$( set.mm - Version of 16-Jan-2010
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
    Metamath source file for logic, set theory, numbers, and Hilbert space
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

                           ~~ PUBLIC DOMAIN ~~

This file is placed in the public domain per the Creative Commons Public Domain
Dedication:  http://creativecommons.org/licenses/publicdomain/ .  The public
domain release applies worldwide.  In case this is not legally possible, the
right is granted to use the work for any purpose, without any conditions,
unless such conditions are required by law.

Norman Megill - http://us.metamath.org/email.html

Contributor list:

DA David Abernethy      DH David Harvey           RM Rodolfo Medina
SA Stefan Allan         J2 Jeff Hoffman           MO Mel L. O'Cat
JA Juha Arpiainen       SJ Szymon Jaroszewicz     JO Jason Orendorff
GB Gregory Bush         GL Gerard Lang            JP Josh Purinton
PC Paul Chapman         RL Raph Levien            SR Steve Rodriguez
SF Scott Fenton         FL Frederic Line          AS Alan Sare
JH Jeffrey Hankins      R2 Roy F. Longton         ES Eric Schmidt
AH Anthony Hart         JM Jeff Madsen

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Contents of this header
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

1. Recent label changes
2. Finding shorter proofs
3. Bibliography
4. Quick "How To"
5. Metamath syntax summary
6. Other notes

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          1. Recent label changes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

This is part of an ongoing project to improve naming consistency.  If you are
using an older version of set.mm as the base for your project, you should
review the following changes before updating to this version.  If you want to
create an automated script, you can make can make global substitutions into
your database by processing the ones *without* "Notes" in *reverse* order,
starting backwards from the date of the set.mm version you used.  When doing
global substitutions, match a space or beginning-of-line before the label and a
space or end-of-line after the label.  The ones *with* "Notes" must be
processed manually.

If you have suggestions for better names, let me know.

IMPORTANT:  Except for general-purpose utility theorems, I often do not
include label changes of theorems first added in the past year, because the
current work in progress is subject to frequent changes.  If you are using
theorems from a new section being developed, let me know.  Currently I do not
include label changes in the Hilbert space or mathbox sections.

Date      Old       New         Notes

16-Jan-11 grothinf  grothomex
13-Jan-11 hbequid   hbequid2
10-Dec-10 nexnoti   nexr
31-Oct-10 reu3xxx   reu6
31-Oct-10 reu6      reu3
31-Oct-10 reu3      reu3xxx
30-Oct-10 eusn      euabsn
26-Oct-10 raaan     raaanv
18-Oct-10 ---       ---         changed math symbol from "C=" to "C_"
 3-Oct-10 ---       ---         added variables E, e, I, i, V
 3-Oct-10 ---       ---         changed math symbol from "P~" to "~P"
 3-Oct-10 ---       ---         changed math symbol from "H~" to "~H"
 3-Oct-10 ---       ---         changed math symbol from "(_" to "C="
 3-Oct-10 ---       ---         changed math symbol from "(." to "C."
 3-Oct-10 ---       ---         changed math symbol from "C." to "_C"
 3-Oct-10 ---       ---         changed math symbol from "E" to "_E"
 3-Oct-10 ---       ---         changed math symbol from "e" to "_e"
 3-Oct-10 ---       ---         changed math symbol from "I" to "_I"
 3-Oct-10 ---       ---         changed math symbol from "i" to "_i"
 3-Oct-10 ---       ---         changed math symbol from "V" to "_V"
24-Jul-09 sandbox   mathbox
12-Jun-09 mulge0    [--same--]  rearranged antecedent
12-Jun-09 mulgt0    [--same--]  rearranged antecedent
12-May-09 ---       ---         changed math symbol from "ZZ_>" to "ZZ>="
 2-May-09 snsspr    snsspr1
 2-May-09 axpow     zfpow
 2-May-09 axac      zfac
 2-May-09 axun      zfun
27-Apr-09 pm4.22    bitr
24-Apr-09 axinf     zfinf
24-Apr-09 zfinf     zfinf2
 2-Apr-09 infmssuzle [--same--] changed -. S = (/) to S =/= (/)
23-Mar-09 eqfnfvf   ---         obsolete; use eqfnfvf2 instead
23-Mar-09 ffnoprval ffnoprv
23-Mar-09 eqfnoprval eqfnoprv
23-Mar-09 fnoprval  fnoprv
23-Mar-09 foprval   foprv
23-Mar-09 oprvalres oprvres
23-Mar-09 oprssoprval oprssoprv
23-Mar-09 fnrnoprval fnrnoprv
23-Mar-09 fooprval  fooprv
23-Mar-09 fnoprvalrn fnoprvrn
23-Mar-09 oprvalelrn oprvelrn
23-Mar-09 oprvalconst2 oprvconst2
23-Mar-09 oprvalex  oprvex
23-Mar-09 symgoprval symgoprv
23-Mar-09 fnoprvalrn2 fnoprvrn2
22-Mar-09 icoshf    icoshft
 8-Mar-09 nnont     nnon
 7-Mar-09 eluzsubii eluzsubi
 7-Mar-09 eluzaddii eluzaddi
 7-Mar-09 divexp    expdiv
 7-Mar-09 recexp    exprec
 7-Mar-09 ---       ---         changed math symbol from "ZZ>" to "ZZ_>"
27-Feb-09 lediv23   [--same--]  rearranged antecedent
27-Feb-09 ltdiv23   [--same--]  rearranged antecedent
 3-Jan-09 muln0     mulne0
 3-Jan-09 vne0      vn0
 3-Jan-09 n0        neq0
 3-Jan-09 ne0       n0
 3-Jan-09 ssne0     ssn0
 3-Jan-09 onne0     onn0
 3-Jan-09 dmsnne0   dmsnn0
 3-Jan-09 rnsnne0   rnsnn0
 3-Jan-09 1ne0      1n0
 3-Jan-09 metne0    metn0
 3-Jan-09 blne0     bln0
 2-Jan-08 flrecl    reflcl
30-Dec-08 letrdi    letrd
30-Dec-08 lelttrdi  lelttrd
30-Dec-08 ltletrdi  ltletrd
30-Dec-08 lttrdi    lttrd
29-Dec-08 hbnegi    hbneg
29-Dec-08 hbnegdi   hbnegd
29-Dec-08 hbsumi    hbsum
29-Dec-08 hbsum1i   hbsum1
28-Dec-08 negnei    negne0i
28-Dec-08 negne0i   negne0bi
28-Dec-08 lemul2    [--same--]  rearranged antecedent
28-Dec-08 lemul1    [--same--]  rearranged antecedent
28-Dec-08 ltmul2    [--same--]  rearranged antecedent
28-Dec-08 ltmul1    [--same--]  rearranged antecedent
28-Dec-08 ecdmn0    [--same--]  changed -. ... = to =/=
27-Dec-08 divdiv24  [--same--]  rearranged antecedent
27-Dec-08 divdiv13  [--same--]  rearranged antecedent
27-Dec-08 divadddiv [--same--]  rearranged antecedent
27-Dec-08 divdivdiv [--same--]  rearranged antecedent
27-Dec-08 recndi    recnd
27-Dec-08 divdivmul divdiv1
27-Dec-08 divdiv23  [--same--]  rearranged antecedent
27-Dec-08 dmsnsn0   ---         obsolete; use the more general dmsn0el
25-Dec-08 div12     [--same--]  rearranged antecedent
25-Dec-08 div13     [--same--]  rearranged antecedent
25-Dec-08 div23     [--same--]  rearranged antecedent
25-Dec-08 expm1     expm1t
25-Dec-08 divmuldiv [--same--]  rearranged antecedent
25-Dec-08 recexp    [--same--]  rearranged antecedent
25-Dec-08 expne0i   [--same--]  rearranged antecedent
25-Dec-08 expsub    [--same--]  rearranged antecedent
25-Dec-08 divexp    [--same--]  rearranged antecedent
21-Dec-08 imaun2    imaundir
21-Dec-08 imaun     imaundi
19-Dec-08 sbhyp     ---         obsolete; use sbhypf
19-Dec-08 opelcog   opelco2g
18-Dec-08 fsumspl   fsumsplit
18-Dec-08 fsum0spl  fsum0split
18-Dec-08 fsumshf   fsumshft
18-Dec-08 fsumcons  fsumconst
18-Dec-08 dmco2     dmco
17-Dec-08 ---       ---         the math token "Base" was changed to "BaseSet"
17-Dec-08 ssxpr     ---         obsolete; use ssxpb
17-Dec-08 nicodraw  ---         obsolete; use nic-ax
17-Dec-08 nicodmpraw ---        obsolete; use nic-mp
17-Dec-08 3exbi     3exbii
17-Dec-08 relssdr   relssdmrn
16-Dec-08 dfoprab4  dfoprab5s
16-Dec-08 dfoprab5  dfoprab4s
16-Dec-08 dffxxx    dff2
16-Dec-08 dff4      dff3
16-Dec-08 dff3      dff4
16-Dec-08 dff4      dffxxx
16-Dec-08 dffunmo   dffun6
16-Dec-08 dffun6    dffun7
16-Dec-08 dffun7    dffun8
16-Dec-08 dffun8    dffun9
16-Dec-08 dffunmof  dffun6f
16-Dec-08 fnopabfv  dffn5
16-Dec-08 fnforn    dffn4
16-Dec-08 fnfrn     dffn3
16-Dec-08 fnf       dffn2
16-Dec-08 f1fvf     dff13f
16-Dec-08 f1fv      dff13
16-Dec-08 f11       dff12
16-Dec-08 f1ofv     dff1o6
16-Dec-08 f1o5      dff1o5
16-Dec-08 f1o4      dff1o4
16-Dec-08 f1o3      dff1o3
16-Dec-08 f1o2      dff1o2
15-Dec-08 pm4.2d    biidd
15-Dec-08 pm4.2     biid
15-Dec-08 pm4.1     con34b
15-Dec-08 bi2.15    con1b
15-Dec-08 bi2.03    con2b
15-Dec-08 a3d       con4d
15-Dec-08 a3i       con4i
13-Dec-08 2climnni  2climnn
13-Dec-08 2climnn0i 2climnn0
12-Dec-08 reeftlclti reeftlcl
12-Dec-08 eftlclti  eftlcl
12-Dec-08 eftlexti  eftlex
12-Dec-08 fnsmnti   arisumi
12-Dec-08 nn0le2msqti nn0le2msqi
12-Dec-08 reccnvi   reccnv
12-Dec-08 expcnvi   expcnv
11-Dec-08 isummulc1i isummulc1
11-Dec-08 iserzgt0i iserzgt0
11-Dec-08 isumreclti isumrecl
11-Dec-08 isumclti  isumcl
11-Dec-08 isumnn0nni isumnn0nn
11-Dec-08 isum1pi   isum1p
11-Dec-08 isumnuli  isumnul
11-Dec-08 isumclim5ti isumclim5
11-Dec-08 isumclim4ti isumclim4
11-Dec-08 isumclim3ti isumclim3
11-Dec-08 isumclim2ti isumclim2
11-Dec-08 isumclim2tfi isumclim2f
11-Dec-08 isum1climi isum1clim
11-Dec-08 isumclimti isumclim
11-Dec-08 isumval2ti isumval2
11-Dec-08 isumvalti isumval
11-Dec-08 cvgcmp3ceti cvgcmp3ce
11-Dec-08 iserzcmp0i iserzcmp0
11-Dec-08 iserzcmpi iserzcmp
11-Dec-08 climsqueeze2i climsqueeze2
11-Dec-08 climsqueezei climsqueeze
11-Dec-08 climcmpc1i climcmpc1
11-Dec-08 climcmpi  climcmp
11-Dec-08 iserzmulc1i iserzmulc1
11-Dec-08 iserzexti iserzex
11-Dec-08 clim2serzti clim2serz
11-Dec-08 climsubc2i climsubc2
11-Dec-08 climsubi  climsub
11-Dec-08 climmulc2i climmulc2
11-Dec-08 climmuli  climmul
11-Dec-08 climaddc2i climaddc2
11-Dec-08 climaddc1i climaddc1
11-Dec-08 climaddi  climadd
11-Dec-08 climge0i  climge0
11-Dec-08 climrecli climrecl
11-Dec-08 climreui  climreu
11-Dec-08 climeui   climeu
11-Dec-08 climuniii climunii
11-Dec-08 climunii  climuni
11-Dec-08 clm4ati   clm4a
11-Dec-08 serzmulc1i serzmulc1
11-Dec-08 serzspliti serzsplit
11-Dec-08 serzcmp0i serzcmp0
11-Dec-08 serzcmpi  serzcmp
11-Dec-08 serz1pi   serz1p
11-Dec-08 serzreclti serzrecl
11-Dec-08 serzcl2ti serzcl2
11-Dec-08 ser1clti  ser1cl
11-Dec-08 ser0clti  ser0cl
11-Dec-08 serzclti  serzcl
11-Dec-08 fsum4i    fsum4
11-Dec-08 fsum3i    fsum3
11-Dec-08 fsum2i    fsum2
11-Dec-08 fsum0spli fsum0spl
11-Dec-08 fsumspli  fsumspl
11-Dec-08 serzfsumi serzfsum
11-Dec-08 fsumserz2i fsumserz2
11-Dec-08 fsumserzi fsumserz
11-Dec-08 cvg1ii    cvg1i
11-Dec-08 cvg1i     cvg1
11-Dec-08 seqzres2i seqzres2
11-Dec-08 seqzresi  seqzres
11-Dec-08 seqzresvali seqzresval
11-Dec-08 seqzcli   seqzcl
11-Dec-08 seqzrni   seqzrn
11-Dec-08 seqzrn2i  seqzrn2
11-Dec-08 seqzeqi   seqzeq
11-Dec-08 seqzfveqi seqzfveq
11-Dec-08 seqzval2ti seqzval2
11-Dec-08 seq01i    seq01
11-Dec-08 seq0p1i   seq0p1
11-Dec-08 seq00i    seq00
11-Dec-08 seqzm1i   seqzm1
11-Dec-08 seqzp1i   seqzp1
11-Dec-08 seqz1i    seqz1
11-Dec-08 seq0fni   seq0fn
11-Dec-08 seq1seq0i seq1seq0
11-Dec-08 seq1seq0ti seq1seq01
11-Dec-08 seq1seq02ti seq1seq02
11-Dec-08 seq0seqzi seq0seqz
11-Dec-08 seq1seqzi seq1seqz
11-Dec-08 seqzvalti seqzval
11-Dec-08 seqzfni   seqzfn
11-Dec-08 seqzfval2i seqzfval2
11-Dec-08 seqzfvali seqzfval
11-Dec-08 seq0valti seq0valt
11-Dec-08 seq0fvali seq0fval
11-Dec-08 seq1shftidi seq1shftid
11-Dec-08 shftidti  shftidt
11-Dec-08 shftcan1ti shftcan1
11-Dec-08 shftcan2ti shftcan2
11-Dec-08 shftfi    shftf
11-Dec-08 shftval5ti shftval5
11-Dec-08 shftval4ti shftval4
11-Dec-08 shftval3ti shftval3
11-Dec-08 shftval2ti shftval2
11-Dec-08 shftvalti shftval
11-Dec-08 shftresvalti shftresval
11-Dec-08 shftresi  shftres
11-Dec-08 shftfni   shftfn
11-Dec-08 shftfvali shftfval
11-Dec-08 seq1resi  seq1res
11-Dec-08 seq1cl2i  seq1cl2
11-Dec-08 seq1cli   seq1cl
11-Dec-08 seq1f2i   seq1f2
11-Dec-08 seq1fi    seq1f
11-Dec-08 seq1rni   seq1rn
11-Dec-08 seq1rn2i  seq1rn2
11-Dec-08 seq1fni   seq1fn
11-Dec-08 seq1m1i   seq1m1
11-Dec-08 seq1p1i   seq1p1
11-Dec-08 seq11i    seq11
11-Dec-08 seq1val2i seq1val2
11-Dec-08 seq1vali  seq1val
11-Dec-08 seq1rvali seq1rval
11-Dec-08 uznegi    uzneg
 9-Dec-08 nvelv     vprc
 9-Dec-08 inelv     iprc
 9-Dec-08 fipr      fiprc
 9-Dec-08 ecqs      [--same--]  eliminated redundant hypothesis A e. _V
18-Nov-08 ---       ---         See mmnotes.txt entry of 18-Nov-2008
18-Nov-08 cdavalt   cdaval
18-Nov-08 cdaval    cdavali
18-Nov-08 unbnnt    unbnn3
18-Nov-08 frsuct    frsuc
18-Nov-08 fr0t      fr0g
18-Nov-08 rdg0t     rdg0g
18-Nov-08 ssonunit  ssonuni
18-Nov-08 ssonuni   ssonunii
18-Nov-08 eqtr3t    eqtr3
18-Nov-08 eqtr2t    eqtr2
18-Nov-08 eqtrt     eqtr
18-Nov-08 3eqtr4r   3eqtr4ri
18-Nov-08 3eqtr3r   3eqtr3ri
18-Nov-08 3eqtr2r   3eqtr2ri
18-Nov-08 3eqtr4r   3eqtr4ri
18-Nov-08 3eqtr3r   3eqtr3ri
18-Nov-08 3bitr3r   3bitr3ri
18-Nov-08 3bitr4r   3bitr4ri
18-Nov-08 3bitr2r   3bitr2ri
18-Nov-08 biimpr    biimpri
18-Nov-08 biimp     biimpi
18-Nov-08 impbi     impbii
18-Nov-08 ---       ---         See mmnotes.txt entry of 17-Nov-2008
17-Nov-08 ---       ---         Remember that substitutions are
17-Nov-08 ---       ---         made in _reverse_ order.
17-Nov-08 efi4pt    efi4p
17-Nov-08 resin4pt  resin4p
17-Nov-08 recos4pt  recos4p
17-Nov-08 ef4pt     ef4p
17-Nov-08 addclt    addcl
17-Nov-08 readdclt  readdcl
17-Nov-08 mulclt    mulcl
17-Nov-08 remulclt  remulcl
17-Nov-08 addcomt   addcom
17-Nov-08 mulcomt   mulcom
17-Nov-08 addasst   addass
17-Nov-08 mulasst   mulass
17-Nov-08 adddit    adddi
17-Nov-08 addid1t   addid1
17-Nov-08 mulid1t   mulid1
17-Nov-08 recnt     recn
17-Nov-08 adddirt   adddir
17-Nov-08 addid2t   addid2
17-Nov-08 add12t    add12
17-Nov-08 add23t    add23
17-Nov-08 add4t     add4
17-Nov-08 add42t    add42
17-Nov-08 cnegext   cnegex
17-Nov-08 cnegextlem1 cnegexlem1
17-Nov-08 cnegextlem2 cnegexlem2
17-Nov-08 cnegextlem3 cnegexlem3
17-Nov-08 addcant   addcan
17-Nov-08 addcan2t  addcan2
17-Nov-08 subvalt   subval
17-Nov-08 subclt    subcl
17-Nov-08 negclt    negcl
17-Nov-08 subaddt   subadd
17-Nov-08 subsub23t subsub23
17-Nov-08 pncan3t   pncan3
17-Nov-08 negidt    negid
17-Nov-08 negsubt   negsub
17-Nov-08 addsubasst addsubass
17-Nov-08 addsubt   addsub
17-Nov-08 subadd23t subadd23
17-Nov-08 addsub12t addsub12
17-Nov-08 2addsubt  2addsub
17-Nov-08 negnegt   negneg
17-Nov-08 subnegt   subneg
17-Nov-08 subidt    subid
17-Nov-08 subid1t   subid1
17-Nov-08 pncant    pncan
17-Nov-08 pncan2t   pncan2
17-Nov-08 npcant    npcan
17-Nov-08 npncant   npncan
17-Nov-08 nppcant   nppcan
17-Nov-08 subcan2t  subcan2
17-Nov-08 subeq0t   subeq0
17-Nov-08 neg11t    neg11
17-Nov-08 negcon1t  negcon1
17-Nov-08 negcon2t  negcon2
17-Nov-08 subcant   subcan
17-Nov-08 mulid2t   mulid2
17-Nov-08 mul12t    mul12
17-Nov-08 mul23t    mul23
17-Nov-08 mul4t     mul4
17-Nov-08 muladdt   muladd
17-Nov-08 muladd11t muladd11
17-Nov-08 subdit    subdi
17-Nov-08 subdirt   subdir
17-Nov-08 renegclt  renegcl
17-Nov-08 resubclt  resubcl
17-Nov-08 mul01t    mul01
17-Nov-08 mul02t    mul02
17-Nov-08 mulneg1t  mulneg1
17-Nov-08 mulneg2t  mulneg2
17-Nov-08 mulneg12t mulneg12
17-Nov-08 mul2negt  mul2neg
17-Nov-08 negdit    negdi
17-Nov-08 negdi2t   negdi2
17-Nov-08 negsubdit negsubdi
17-Nov-08 negsubdi2t negsubdi2
17-Nov-08 neg2subt  neg2sub
17-Nov-08 submul2t  submul2
17-Nov-08 subsub2t  subsub2
17-Nov-08 subsubt   subsub
17-Nov-08 subsub3t  subsub3
17-Nov-08 subsub4t  subsub4
17-Nov-08 sub23t    sub23
17-Nov-08 nnncant   nnncan
17-Nov-08 nnncan1t  nnncan1
17-Nov-08 nnncan2t  nnncan2
17-Nov-08 nncant    nncan
17-Nov-08 nppcan2t  nppcan2
17-Nov-08 mulm1t    mulm1
17-Nov-08 addsub4t  addsub4
17-Nov-08 subadd4t  subadd4
17-Nov-08 sub4t     sub4
17-Nov-08 mulsubt   mulsub
17-Nov-08 pnpcant   pnpcan
17-Nov-08 pnpcan2t  pnpcan2
17-Nov-08 pnncant   pnncan
17-Nov-08 ppncant   ppncan
17-Nov-08 ltxrt     ltxr
17-Nov-08 rexrt     rexr
17-Nov-08 ltxrltt   ltxrlt
17-Nov-08 xrlenltt  xrlenlt
17-Nov-08 xrltnlet  xrltnle
17-Nov-08 lttrt     lttr
17-Nov-08 mulgt0t   mulgt0
17-Nov-08 lenltt    lenlt
17-Nov-08 ltnlet    ltnle
17-Nov-08 lttri2t   lttri2
17-Nov-08 lttri3t   lttri3
17-Nov-08 lttri4t   lttri4
17-Nov-08 ltnet     ltne
17-Nov-08 letri3t   letri3
17-Nov-08 leloet    leloe
17-Nov-08 eqleltt   eqlelt
17-Nov-08 ltlet     ltle
17-Nov-08 leltnet   leltne
17-Nov-08 ltlent    ltlen
17-Nov-08 lelttrt   lelttr
17-Nov-08 ltletrt   ltletr
17-Nov-08 letrt     letr
17-Nov-08 ltnrt     ltnr
17-Nov-08 leidt     leid
17-Nov-08 ltnsymt   ltnsym
17-Nov-08 ltnsym2t  ltnsym2
17-Nov-08 renepnft  renepnf
17-Nov-08 renemnft  renemnf
17-Nov-08 xrltnrt   xrltnr
17-Nov-08 ltpnft    ltpnf
17-Nov-08 mnfltt    mnflt
17-Nov-08 mnfltxrt  mnfltxr
17-Nov-08 pnfnltt   pnfnlt
17-Nov-08 nltmnft   nltmnf
17-Nov-08 pnfget    pnfge
17-Nov-08 mnflet    mnfle
17-Nov-08 xrltnsymt xrltnsym
17-Nov-08 xrltnsym2t xrltnsym2
17-Nov-08 xrlttrit  xrlttri
17-Nov-08 xrlttrt   xrlttr
17-Nov-08 xrlttri2t xrlttri2
17-Nov-08 xrlttri3t xrlttri3
17-Nov-08 xrleloet  xrleloe
17-Nov-08 xrleltnet xrleltne
17-Nov-08 xrltlet   xrltle
17-Nov-08 xrleidt   xrleid
17-Nov-08 xrletrit  xrletri
17-Nov-08 xrlelttrt xrlelttr
17-Nov-08 xrltletrt xrltletr
17-Nov-08 xrletrt   xrletr
17-Nov-08 xrltnet   xrltne
17-Nov-08 nltpnftt  nltpnft
17-Nov-08 ngtmnftt  ngtmnft
17-Nov-08 xrrebndt  xrrebnd
17-Nov-08 xrret     xrre
17-Nov-08 xrre2t    xrre2
17-Nov-08 eqlet     eqle
17-Nov-08 msqgt0t   msqgt0
17-Nov-08 msqge0t   msqge0
17-Nov-08 gt0ne0t   gt0ne0
17-Nov-08 ne0gt0t   ne0gt0
17-Nov-08 letrit    letric
17-Nov-08 lelttrit  lelttric
17-Nov-08 ltadd1t   ltadd1
17-Nov-08 ltadd2t   ltadd2
17-Nov-08 leadd1t   leadd1
17-Nov-08 leadd2t   leadd2
17-Nov-08 ltsubaddt ltsubadd
17-Nov-08 ltsubadd2t ltsubadd2
17-Nov-08 lesubaddt lesubadd
17-Nov-08 lesubadd2t lesubadd2
17-Nov-08 ltaddsubt ltaddsub
17-Nov-08 ltaddsub2t ltaddsub2
17-Nov-08 leaddsubt leaddsub
17-Nov-08 leaddsub2t leaddsub2
17-Nov-08 sublet    suble
17-Nov-08 lesubt    lesub
17-Nov-08 ltsub23t  ltsub23
17-Nov-08 ltsub13t  ltsub13
17-Nov-08 lt2addt   lt2add
17-Nov-08 le2addt   le2add
17-Nov-08 ltleaddt  ltleadd
17-Nov-08 leltaddt  leltadd
17-Nov-08 addgt0t   addgt0
17-Nov-08 addgegt0t addgegt0
17-Nov-08 addgtge0t addgtge0
17-Nov-08 addge0t   addge0
17-Nov-08 ltaddpost ltaddpos
17-Nov-08 ltaddpos2t ltaddpos2
17-Nov-08 ltsubpost ltsubpos
17-Nov-08 posdift   posdif
17-Nov-08 ltnegt    ltneg
17-Nov-08 ltnegcon1t ltnegcon1
17-Nov-08 lenegt    leneg
17-Nov-08 lenegcon1t lenegcon1
17-Nov-08 lenegcon2t lenegcon2
17-Nov-08 lesub1t   lesub1
17-Nov-08 lesub2t   lesub2
17-Nov-08 ltsub1t   ltsub1
17-Nov-08 ltsub2t   ltsub2
17-Nov-08 lt0neg1t  lt0neg1
17-Nov-08 lt0neg2t  lt0neg2
17-Nov-08 le0neg1t  le0neg1
17-Nov-08 le0neg2t  le0neg2
17-Nov-08 addge01t  addge01
17-Nov-08 addge02t  addge02
17-Nov-08 subge0t   subge0
17-Nov-08 suble0t   suble0
17-Nov-08 subge02t  subge02
17-Nov-08 lesub0t   lesub0
17-Nov-08 mulge0t   mulge0
17-Nov-08 recext    recex
17-Nov-08 mulcant   mulcan
17-Nov-08 mulcan2t  mulcan2
17-Nov-08 mul0ort   mul0or
17-Nov-08 muln0bt   muln0b
17-Nov-08 muln0t    muln0
17-Nov-08 muleqaddt muleqadd
17-Nov-08 divmult   divmul
17-Nov-08 divmul2t  divmul2
17-Nov-08 divmul3t  divmul3
17-Nov-08 divclt    divcl
17-Nov-08 recclt    reccl
17-Nov-08 divcan1t  divcan1
17-Nov-08 divcan2t  divcan2
17-Nov-08 divne0bt  divne0b
17-Nov-08 divne0t   divne0
17-Nov-08 recne0t   recne0
17-Nov-08 recidt    recid
17-Nov-08 recid2t   recid2
17-Nov-08 divrect   divrec
17-Nov-08 divrec2t  divrec2
17-Nov-08 divasst   divass
17-Nov-08 div23t    div23
17-Nov-08 div13t    div13
17-Nov-08 div12t    div12
17-Nov-08 divdirt   divdir
17-Nov-08 divcan3t  divcan3
17-Nov-08 divcan4t  divcan4
17-Nov-08 div11t    div11
17-Nov-08 dividt    divid
17-Nov-08 div0t     div0
17-Nov-08 diveq0t   diveq0
17-Nov-08 div1t     div1
17-Nov-08 divnegt   divneg
17-Nov-08 divsubdirt divsubdir
17-Nov-08 recrect   recrec
17-Nov-08 rec11rt   rec11r
17-Nov-08 divmuldivt divmuldiv
17-Nov-08 divcan5t  divcan5
17-Nov-08 divmul13t divmul13
17-Nov-08 divmul24t divmul24
17-Nov-08 divadddivt divadddiv
17-Nov-08 divdivdivt divdivdiv
17-Nov-08 recdivt   recdiv
17-Nov-08 divcan6t  divcan6
17-Nov-08 divdiv23t divdiv23
17-Nov-08 divdivmult divdivmul
17-Nov-08 recdiv2t  recdiv2
17-Nov-08 conjmult  conjmul
17-Nov-08 redivclt  redivcl
17-Nov-08 rerecclt  rereccl
17-Nov-08 eqnegt    eqneg
17-Nov-08 negeq0t   negeq0
17-Nov-08 ltp1t     ltp1
17-Nov-08 lep1t     lep1
17-Nov-08 ltm1t     ltm1
17-Nov-08 letrp1t   letrp1
17-Nov-08 p1let     p1le
17-Nov-08 prodgt0t  prodgt0
17-Nov-08 prodgt02t prodgt02
17-Nov-08 prodge0t  prodge0
17-Nov-08 prodge02t prodge02
17-Nov-08 ltmul1t   ltmul1
17-Nov-08 ltmul2t   ltmul2
17-Nov-08 lemul1t   lemul1
17-Nov-08 lemul2t   lemul2
17-Nov-08 lemul1it  lemul1a
17-Nov-08 lemul2it  lemul2a
17-Nov-08 ltmul12it ltmul12a
17-Nov-08 lemul12ait lemul12b
17-Nov-08 lemul12it lemul12a
17-Nov-08 mulgt1t   mulgt1
17-Nov-08 ltmulgt11t ltmulgt11
17-Nov-08 ltmulgt12t ltmulgt12
17-Nov-08 lemulge11t lemulge11
17-Nov-08 ltdiv1t   ltdiv1
17-Nov-08 lediv1t   lediv1
17-Nov-08 gt0divt   gt0div
17-Nov-08 ge0divt   ge0div
17-Nov-08 divgt0t   divgt0
17-Nov-08 divge0t   divge0
17-Nov-08 recgt0t   recgt0
17-Nov-08 ltmuldivt ltmuldiv
17-Nov-08 ltmuldiv2t ltmuldiv2
17-Nov-08 ltdivmult ltdivmul
17-Nov-08 ledivmult ledivmul
17-Nov-08 ltdivmul2t ltdivmul2
17-Nov-08 lt2mul2divt lt2mul2div
17-Nov-08 ledivmul2t ledivmul2
17-Nov-08 lemuldivt lemuldiv
17-Nov-08 lemuldiv2t lemuldiv2
17-Nov-08 ltrect    ltrec
17-Nov-08 lerect    lerec
17-Nov-08 lt2msqt   lt2msq
17-Nov-08 ltdiv2t   ltdiv2
17-Nov-08 ltrec1t   ltrec1
17-Nov-08 lerec2t   lerec2
17-Nov-08 ledivdivt ledivdiv
17-Nov-08 lediv2t   lediv2
17-Nov-08 ltdiv23t  ltdiv23
17-Nov-08 lediv23t  lediv23
17-Nov-08 lediv12it lediv12a
17-Nov-08 lediv2it  lediv2a
17-Nov-08 reclt1t   reclt1
17-Nov-08 recgt1t   recgt1
17-Nov-08 recgt1it  recgt1i
17-Nov-08 recrecltt recreclt
17-Nov-08 le2msqt   le2msq
17-Nov-08 ledivp1t  ledivp1
17-Nov-08 xrmaxltt  xrmaxlt
17-Nov-08 xrltmint  xrltmin
17-Nov-08 maxlet    maxle
17-Nov-08 lemint    lemin
17-Nov-08 maxltt    maxlt
17-Nov-08 ltmint    ltmin
17-Nov-08 nnret     nnre
17-Nov-08 nncnt     nncn
17-Nov-08 nnaddclt  nnaddcl
17-Nov-08 nnmulclt  nnmulcl
17-Nov-08 nn2get    nn2ge
17-Nov-08 nnge1t    nnge1
17-Nov-08 nngt1ne1t nngt1ne1
17-Nov-08 nnle1eq1t nnle1eq1
17-Nov-08 nngt0t    nngt0
17-Nov-08 nnne0t    nnne0
17-Nov-08 nnrecret  nnrecre
17-Nov-08 nnrecgt0t nnrecgt0
17-Nov-08 nnleltp1t nnleltp1
17-Nov-08 nnltp1let nnltp1le
17-Nov-08 nnsubt    nnsub
17-Nov-08 nnaddm1clt nnaddm1cl
17-Nov-08 nndivt    nndiv
17-Nov-08 nndivtrt  nndivtr
17-Nov-08 2timest   2times
17-Nov-08 times2t   times2
17-Nov-08 halfclt   halfcl
17-Nov-08 rehalfclt rehalfcl
17-Nov-08 half0t    half0
17-Nov-08 halfpost  halfpos
17-Nov-08 halfpos2t halfpos2
17-Nov-08 halfnneg2t halfnneg2
17-Nov-08 2halvest  2halves
17-Nov-08 halfaddsubt halfaddsub
17-Nov-08 lt2halvest lt2halves
17-Nov-08 avglet    avgle
17-Nov-08 rpret     rpre
17-Nov-08 rpcnt     rpcn
17-Nov-08 rpgt0t    rpgt0
17-Nov-08 rpge0t    rpge0
17-Nov-08 rpregt0t  rpregt0
17-Nov-08 rpne0t    rpne0
17-Nov-08 rprene0t  rprene0
17-Nov-08 rpcnne0t  rpcnne0
17-Nov-08 rpaddclt  rpaddcl
17-Nov-08 rpmulclt  rpmulcl
17-Nov-08 rpdivclt  rpdivcl
17-Nov-08 rerpdivclt rerpdivcl
17-Nov-08 rpnegt    rpneg
17-Nov-08 nnreclt   nnrecl
17-Nov-08 nnnn0t    nnnn0
17-Nov-08 nn0ret    nn0re
17-Nov-08 nn0cnt    nn0cn
17-Nov-08 nn0ge0t   nn0ge0
17-Nov-08 nn0le0eq0t nn0le0eq0
17-Nov-08 nn0addclt nn0addcl
17-Nov-08 nn0mulclt nn0mulcl
17-Nov-08 nnnn0addclt nnnn0addcl
17-Nov-08 nn0nnaddclt nn0nnaddcl
17-Nov-08 nn0ltp1let nn0ltp1le
17-Nov-08 nn0leltp1t nn0leltp1
17-Nov-08 nn0ltlem1t nn0ltlem1
17-Nov-08 nn0addge1t nn0addge1
17-Nov-08 nn0addge2t nn0addge2
17-Nov-08 zret      zre
17-Nov-08 zcnt      zcn
17-Nov-08 nnzt      nnz
17-Nov-08 nn0zt     nn0z
17-Nov-08 znnnlt1t  znnnlt1
17-Nov-08 nn0subt   nn0sub
17-Nov-08 nn0sub2t  nn0sub2
17-Nov-08 znegclt   znegcl
17-Nov-08 zaddclt   zaddcl
17-Nov-08 zsubclt   zsubcl
17-Nov-08 zrevaddclt zrevaddcl
17-Nov-08 nn0p1nnt  nn0p1nn
17-Nov-08 nnm1nn0t  nnm1nn0
17-Nov-08 znnsubt   znnsub
17-Nov-08 znn0subt  znn0sub
17-Nov-08 znn0sub2t znn0sub2
17-Nov-08 zmulclt   zmulcl
17-Nov-08 zltp1let  zltp1le
17-Nov-08 zleltp1t  zleltp1
17-Nov-08 zlem1ltt  zlem1lt
17-Nov-08 zltlem1t  zltlem1
17-Nov-08 nn0lem1ltt nn0lem1lt
17-Nov-08 nnlem1ltt nnlem1lt
17-Nov-08 nnltlem1t nnltlem1
17-Nov-08 zdivt     zdiv
17-Nov-08 zdivaddt  zdivadd
17-Nov-08 zdivmult  zdivmul
17-Nov-08 z2get     z2ge
17-Nov-08 zextlet   zextle
17-Nov-08 zextltt   zextlt
17-Nov-08 recnzt    recnz
17-Nov-08 btwnnzt   btwnnz
17-Nov-08 gtndivt   gtndiv
17-Nov-08 primet    prime
17-Nov-08 nneot     nneo
17-Nov-08 zeot      zeo
17-Nov-08 qret      qre
17-Nov-08 zqt       zq
17-Nov-08 nnqt      nnq
17-Nov-08 qcnt      qcn
17-Nov-08 qaddclt   qaddcl
17-Nov-08 qnegclt   qnegcl
17-Nov-08 qmulclt   qmulcl
17-Nov-08 qsubclt   qsubcl
17-Nov-08 qrecclt   qreccl
17-Nov-08 qdivclt   qdivcl
17-Nov-08 qrevaddclt qrevaddcl
17-Nov-08 nnrecqt   nnrecq
17-Nov-08 irraddt   irradd
17-Nov-08 irrmult   irrmul
17-Nov-08 flvalt    flval
17-Nov-08 flclt     flcl
17-Nov-08 flreclt   flrecl
17-Nov-08 flleltt   fllelt
17-Nov-08 fllet     flle
17-Nov-08 flltp1t   flltp1
17-Nov-08 fraclt1t  fraclt1
17-Nov-08 fracge0t  fracge0
17-Nov-08 flget     flge
17-Nov-08 flltt     fllt
17-Nov-08 flidt     flid
17-Nov-08 flidmt    flidm
17-Nov-08 flidzt    flidz
17-Nov-08 flwordit  flwordi
17-Nov-08 flval2t   flval2
17-Nov-08 flval3t   flval3
17-Nov-08 flbit     flbi
17-Nov-08 flbi2t    flbi2
17-Nov-08 flge0nn0t flge0nn0
17-Nov-08 flge1nnt  flge1nn
17-Nov-08 fladdzt   fladdz
17-Nov-08 btwnzge0t btwnzge0
17-Nov-08 flhalft   flhalf
17-Nov-08 ceiclt    ceicl
17-Nov-08 ceiget    ceige
17-Nov-08 ceim1lt   ceim1l
17-Nov-08 ceilet    ceile
17-Nov-08 fldivt    fldiv
17-Nov-08 fldiv2t   fldiv2
17-Nov-08 modvalt   modval
17-Nov-08 modclt    modcl
17-Nov-08 modge0t   modge0
17-Nov-08 modltt    modlt
17-Nov-08 modfract  modfrac
17-Nov-08 flmodt    flmod
17-Nov-08 modcyct   modcyc
17-Nov-08 modcyc2t  modcyc2
17-Nov-08 modadd1t  modadd1
17-Nov-08 modmul1t  modmul1
17-Nov-08 moddit    moddi
17-Nov-08 modirrt   modirr
17-Nov-08 ioovalt   iooval
17-Nov-08 iooval2t  iooval2
17-Nov-08 ioo0t     ioo0
17-Nov-08 ioon0t    ioon0
17-Nov-08 iooint    iooin
17-Nov-08 iocvalt   iocval
17-Nov-08 icovalt   icoval
17-Nov-08 iccvalt   iccval
17-Nov-08 elioo1t   elioo1
17-Nov-08 elioo2t   elioo2
17-Nov-08 elioc1t   elioc1
17-Nov-08 elico1t   elico1
17-Nov-08 elicc1t   elicc1
17-Nov-08 elioo5t   elioo5
17-Nov-08 eliooret  elioore
17-Nov-08 eliooxrt  eliooxr
17-Nov-08 eliooordt eliooord
17-Nov-08 elioc2t   elioc2
17-Nov-08 elico2t   elico2
17-Nov-08 elicc2t   elicc2
17-Nov-08 iooshft   iooshf
17-Nov-08 iccssret  iccssre
17-Nov-08 lbicc2t   lbicc2
17-Nov-08 ubicc2t   ubicc2
17-Nov-08 ioonegt   iooneg
17-Nov-08 iccnegt   iccneg
17-Nov-08 icoshft   icoshf
17-Nov-08 ioojoint  ioojoin
17-Nov-08 uzvalt    uzval
17-Nov-08 eluz1t    eluz1
17-Nov-08 eluz2t    eluz2
17-Nov-08 eluzt     eluz
17-Nov-08 uzidt     uzid
17-Nov-08 uznegit   uznegi
17-Nov-08 uz11t     uz11
17-Nov-08 eluzp1m1t eluzp1m1
17-Nov-08 eluzp1lt  eluzp1l
17-Nov-08 eluzp1p1t eluzp1p1
17-Nov-08 uzaddclt  uzaddcl
17-Nov-08 fzvalt    fzval
17-Nov-08 elfz1t    elfz1
17-Nov-08 elfzt     elfz
17-Nov-08 elfz2t    elfz2
17-Nov-08 elfz5t    elfz5
17-Nov-08 elfz4t    elfz4
17-Nov-08 eluzfzt   eluzfz
17-Nov-08 elfzuz3t  elfzuz3
17-Nov-08 elfzuz2t  elfzuz2
17-Nov-08 eluzfz1t  eluzfz1
17-Nov-08 elfzuzt   elfzuz
17-Nov-08 eluzfz2t  eluzfz2
17-Nov-08 elfz3t    elfz3
17-Nov-08 elfz1eqt  elfz1eq
17-Nov-08 fznt      fzn
17-Nov-08 elfznnt   elfznn
17-Nov-08 elfz2nn0t elfz2nn0
17-Nov-08 elfznn0t  elfznn0
17-Nov-08 elfz3nn0t elfz3nn0
17-Nov-08 fznn0subt fznn0sub
17-Nov-08 fznn0sub2t fznn0sub2
17-Nov-08 fzaddelt  fzaddel
17-Nov-08 fzsubelt  fzsubel
17-Nov-08 fzoptht   fzopth
17-Nov-08 fzss1t    fzss1
17-Nov-08 fzss2t    fzss2
17-Nov-08 fzssuzt   fzssuz
17-Nov-08 fzssp1t   fzssp1
17-Nov-08 fzp1sst   fzp1ss
17-Nov-08 fzelp1t   fzelp1
17-Nov-08 fzrevt    fzrev
17-Nov-08 fzrev2t   fzrev2
17-Nov-08 fzrev2it  fzrev2i
17-Nov-08 fzrev3t   fzrev3
17-Nov-08 fzrev3it  fzrev3i
17-Nov-08 fznn0t    fznn0
17-Nov-08 fz1sbct   fz1sbc
17-Nov-08 fzneuzt   fzneuz
17-Nov-08 fzrevralt fzrevral
17-Nov-08 fzrevral2t fzrevral2
17-Nov-08 fzrevral3t fzrevral3
17-Nov-08 fzshftralt fzshftral
17-Nov-08 ser1ft    ser1f
17-Nov-08 limsupvalt limsupval
17-Nov-08 limsupclt limsupcl
17-Nov-08 expvalt   expval
17-Nov-08 exp0t     exp0
17-Nov-08 expnnvalt expnnval
17-Nov-08 exp1t     exp1
17-Nov-08 expp1t    expp1
17-Nov-08 nnexpclt  nnexpcl
17-Nov-08 nn0expclt nn0expcl
17-Nov-08 zexpclt   zexpcl
17-Nov-08 qexpclt   qexpcl
17-Nov-08 reexpclt  reexpcl
17-Nov-08 expclt    expcl
17-Nov-08 rpexpclt  rpexpcl
17-Nov-08 expm1t    expm1
17-Nov-08 1expt     1exp
17-Nov-08 expeq0t   expeq0
17-Nov-08 expne0t   expne0
17-Nov-08 expne0it  expne0i
17-Nov-08 expgt0t   expgt0
17-Nov-08 0expt     0exp
17-Nov-08 expge0t   expge0
17-Nov-08 expgt1t   expgt1
17-Nov-08 expge1t   expge1
17-Nov-08 mulexpt   mulexp
17-Nov-08 recexpt   recexp
17-Nov-08 expaddt   expadd
17-Nov-08 expmult   expmul
17-Nov-08 expsubt   expsub
17-Nov-08 divexpt   divexp
17-Nov-08 expordit  expordi
17-Nov-08 expcant   expcan
17-Nov-08 expordt   expord
17-Nov-08 expwordit expwordi
17-Nov-08 expord2t  expord2
17-Nov-08 expword2it expword2i
17-Nov-08 expmwordit expmwordi
17-Nov-08 exple1t   exple1
17-Nov-08 expubndt  expubnd
17-Nov-08 sqvalt    sqval
17-Nov-08 sqnegt    sqneg
17-Nov-08 sqclt     sqcl
17-Nov-08 sqmult    sqmul
17-Nov-08 sqeq0t    sqeq0
17-Nov-08 sqne0t    sqne0
17-Nov-08 resqclt   resqcl
17-Nov-08 sqgt0t    sqgt0
17-Nov-08 sq11t     sq11
17-Nov-08 lt2sqt    lt2sq
17-Nov-08 le2sqt    le2sq
17-Nov-08 le2sqit   le2sq2
17-Nov-08 sqge0t    sqge0
17-Nov-08 sqlecant  sqlecan
17-Nov-08 subsqt    subsq
17-Nov-08 subsq2t   subsq2
17-Nov-08 sqeqort   sqeqor
17-Nov-08 binom2t   binom2
17-Nov-08 sq01t     sq01
17-Nov-08 expnbndt  expnbnd
17-Nov-08 expnlbndt expnlbnd
17-Nov-08 expnlbnd2t expnlbnd2
17-Nov-08 nn0opth2t nn0opth2
17-Nov-08 sqrclt    sqrcl
17-Nov-08 sqrgt0t   sqrgt0
17-Nov-08 sqrge0t   sqrge0
17-Nov-08 sqrlet    sqrle
17-Nov-08 sqr00t    sqr00
17-Nov-08 rpsqrclt  rpsqrcl
17-Nov-08 sqrsqt    sqrsq
17-Nov-08 sqsqrt    sqsqr
17-Nov-08 crut      cru
17-Nov-08 revalt    reval
17-Nov-08 imvalt    imval
17-Nov-08 reclt     recl
17-Nov-08 imclt     imcl
17-Nov-08 replimt   replim
17-Nov-08 absvalt   absval
17-Nov-08 cjvalt    cjval
17-Nov-08 cjclt     cjcl
17-Nov-08 crret     crre
17-Nov-08 crimt     crim
17-Nov-08 imret     imre
17-Nov-08 reim0t    reim0
17-Nov-08 reim0bt   reim0b
17-Nov-08 rerebt    rereb
17-Nov-08 mulret    mulre
17-Nov-08 reret     rere
17-Nov-08 cjrebt    cjreb
17-Nov-08 cjmulrclt cjmulrcl
17-Nov-08 cjmulvalt cjmulval
17-Nov-08 cjmulge0t cjmulge0
17-Nov-08 renegt    reneg
17-Nov-08 readdt    readd
17-Nov-08 resubt    resub
17-Nov-08 imnegt    imneg
17-Nov-08 imaddt    imadd
17-Nov-08 imsubt    imsub
17-Nov-08 cjret     cjre
17-Nov-08 cjcjt     cjcj
17-Nov-08 cjaddt    cjadd
17-Nov-08 cjmult    cjmul
17-Nov-08 cjnegt    cjneg
17-Nov-08 addcjt    addcj
17-Nov-08 cjsubt    cjsub
17-Nov-08 cjexpt    cjexp
17-Nov-08 recjt     recj
17-Nov-08 imcjt     imcj
17-Nov-08 cjreimt   cjreim
17-Nov-08 cjreim2t  cjreim2
17-Nov-08 cj11t     cj11
17-Nov-08 cjne0t    cjne0
17-Nov-08 absnegt   absneg
17-Nov-08 absclt    abscl
17-Nov-08 abscjt    abscj
17-Nov-08 absvalsqt absvalsq
17-Nov-08 absvalsq2t absvalsq2
17-Nov-08 sqabsaddt sqabsadd
17-Nov-08 sqabssubt sqabssub
17-Nov-08 absval2t  absval2
17-Nov-08 abs00t    abs00
17-Nov-08 absge0t   absge0
17-Nov-08 absrpclt  absrpcl
17-Nov-08 absreimsqt absreimsq
17-Nov-08 absreimt  absreim
17-Nov-08 absmult   absmul
17-Nov-08 absdivt   absdiv
17-Nov-08 absidt    absid
17-Nov-08 absnidt   absnid
17-Nov-08 leabst    leabs
17-Nov-08 absort    absor
17-Nov-08 absret    absre
17-Nov-08 absresqt  absresq
17-Nov-08 absexpt   absexp
17-Nov-08 absrelet  absrele
17-Nov-08 absimlet  absimle
17-Nov-08 nn0absclt nn0abscl
17-Nov-08 absltt    abslt
17-Nov-08 abslet    absle
17-Nov-08 abssubne0t abssubne0
17-Nov-08 absdifltt absdiflt
17-Nov-08 absdiflet absdifle
17-Nov-08 lenegsqt  lenegsq
17-Nov-08 releabst  releabs
17-Nov-08 cjdivt    cjdiv
17-Nov-08 absidmt   absidm
17-Nov-08 absgt0t   absgt0
17-Nov-08 abssubt   abssub
17-Nov-08 abssubge0t abssubge0
17-Nov-08 abssuble0t abssuble0
17-Nov-08 absmaxt   absmax
17-Nov-08 abstrit   abstri
17-Nov-08 abs3dift  abs3dif
17-Nov-08 abs2dift  abs2dif
17-Nov-08 abs2difabst abs2difabs
17-Nov-08 recant    recan
17-Nov-08 abs3lemt  abs3lem
17-Nov-08 facnnt    facnn
17-Nov-08 facp1t    facp1
17-Nov-08 facnn2t   facnn2
17-Nov-08 facclt    faccl
17-Nov-08 facne0t   facne0
17-Nov-08 facdivt   facdiv
17-Nov-08 facndivt  facndiv
17-Nov-08 facwordit facwordi
17-Nov-08 facavgt   facavg
17-Nov-08 bcvalt    bcval
17-Nov-08 bcval2t   bcval2
17-Nov-08 bcval3t   bcval3
17-Nov-08 bcval4t   bcval4
17-Nov-08 bccmplt   bccmpl
17-Nov-08 bcn0t     bcn0
17-Nov-08 bcnnt     bcnn
17-Nov-08 bcnp11t   bcnp11
17-Nov-08 bcnp1nt   bcnp1n
17-Nov-08 bcpasc2t  bcpasc2
17-Nov-08 bcpasct   bcpasc
17-Nov-08 bccl2t    bccl2
17-Nov-08 bcclt     bccl
17-Nov-08 permnnt   permnn
17-Nov-08 fsumclt   fsumcl
17-Nov-08 fsum0clt  fsum0cl
17-Nov-08 fsumreclt fsumrecl
17-Nov-08 fsumsplit fsumspli
17-Nov-08 fsum0split fsum0spli
17-Nov-08 fsumshft  fsumshf
17-Nov-08 fsumconst fsumcons
17-Nov-08 clmi2at   clmi2a
17-Nov-08 caucvg3t  caucvg3
17-Nov-08 eftclt    eftcl
17-Nov-08 efvalt    efval
17-Nov-08 efclt     efcl
17-Nov-08 reefclt   reefcl
17-Nov-08 efcjt     efcj
17-Nov-08 efaddt    efadd
17-Nov-08 efcant    efcan
17-Nov-08 efne0t    efne0
17-Nov-08 efsubt    efsub
17-Nov-08 efexpt    efexp
17-Nov-08 efnn0valt efnn0val
17-Nov-08 reeftclt  reeftcl
17-Nov-08 eftlubclt eftlubcl
17-Nov-08 efgt0t    efgt0
17-Nov-08 reef11t   reef11
17-Nov-08 eflegeot  eflegeo
17-Nov-08 efm1legeot efm1legeo
17-Nov-08 sinvalt   sinval
17-Nov-08 cosvalt   cosval
17-Nov-08 sinclt    sincl
17-Nov-08 cosclt    coscl
17-Nov-08 resinvalt resinval
17-Nov-08 recosvalt recosval
17-Nov-08 resinclt  resincl
17-Nov-08 recosclt  recoscl
17-Nov-08 sinnegt   sinneg
17-Nov-08 cosnegt   cosneg
17-Nov-08 efivalt   efival
17-Nov-08 efmivalt  efmival
17-Nov-08 efeult    efeul
17-Nov-08 sinaddt   sinadd
17-Nov-08 cosaddt   cosadd
17-Nov-08 sinsubt   sinsub
17-Nov-08 cossubt   cossub
17-Nov-08 addsint   addsin
17-Nov-08 subsint   subsin
17-Nov-08 addcost   addcos
17-Nov-08 subcost   subcos
17-Nov-08 sincossqt sincossq
17-Nov-08 sin2tt    sin2t
17-Nov-08 cos2tt    cos2t
17-Nov-08 cos2tsint cos2tsin
17-Nov-08 sinbndt   sinbnd
17-Nov-08 cosbndt   cosbnd
17-Nov-08 absefit   absefi
17-Nov-08 abseft    absef
17-Nov-08 absefibt  absefib
17-Nov-08 cosh111t  cosh111
17-Nov-08 logclt    logcl
17-Nov-08 relogclt  relogcl
17-Nov-08 eflogt    eflog
17-Nov-08 reeflogt  reeflog
17-Nov-08 logeft    logef
17-Nov-08 relogeft  relogef
17-Nov-08 relogmult relogmul
17-Nov-08 relogdivt relogdiv
17-Nov-08 explogt   explog
17-Nov-08 reexplogt reexplog
17-Nov-08 relogexpt relogexp
17-Nov-08 logltbt   logltb
17-Nov-08 1p1times  1p1timesi
17-Nov-08 2climnn   2climnni
17-Nov-08 2climnn0  2climnn0i
17-Nov-08 2shft     2shfti
17-Nov-08 2times    2timesi
17-Nov-08 abs00     abs00i
17-Nov-08 abs1m     abs1mi
17-Nov-08 abs3dif   abs3difi
17-Nov-08 abscj     abscji
17-Nov-08 abscl     abscli
17-Nov-08 absdivz   absdivzi
17-Nov-08 absef01tlub absef01tlubi
17-Nov-08 absefm1le absefm1lei
17-Nov-08 absge0    absge0i
17-Nov-08 absgt0    absgt0i
17-Nov-08 absid     absidi
17-Nov-08 absle     abslei
17-Nov-08 abslt     abslti
17-Nov-08 absmul    absmuli
17-Nov-08 absneg    absnegi
17-Nov-08 absnid    absnidi
17-Nov-08 absor     absori
17-Nov-08 abspef01tlub abspef01tlubi
17-Nov-08 absre     absrei
17-Nov-08 abssub    abssubi
17-Nov-08 abstri    abstrii
17-Nov-08 absval2   absval2i
17-Nov-08 absvalsq  absvalsqi
17-Nov-08 absvalsq2 absvalsq2i
17-Nov-08 add12     add12i
17-Nov-08 add20     add20i
17-Nov-08 add23     add23i
17-Nov-08 add4      add4i
17-Nov-08 add42     add42i
17-Nov-08 addass    addassi
17-Nov-08 addcan    addcani
17-Nov-08 addcan2   addcan2i
17-Nov-08 addcj     addcji
17-Nov-08 addcl     addcli
17-Nov-08 addcom    addcomi
17-Nov-08 adddi     adddii
17-Nov-08 adddir    adddiri
17-Nov-08 addge0    addge0i
17-Nov-08 addgegt0  addgegt0i
17-Nov-08 addgt0    addgt0i
17-Nov-08 addgt0i   addgt0ii
17-Nov-08 addid1    addid1i
17-Nov-08 addid2    addid2i
17-Nov-08 addsub    addsubi
17-Nov-08 addsub4   addsub4i
17-Nov-08 addsubass addsubassi
17-Nov-08 bcpasc    bcpasci
17-Nov-08 bcpasc2   bcpasc2i
17-Nov-08 binom     binomi
17-Nov-08 binom1p   binom1pi
17-Nov-08 binom2    binom2i
17-Nov-08 binom2a   binom2ai
17-Nov-08 cau2      cau2i
17-Nov-08 cau3      cau3i
17-Nov-08 cau3i     cau3ii
17-Nov-08 cau3ir    cau3iri
17-Nov-08 cau4i     cau4ii
17-Nov-08 cau5      cau5i
17-Nov-08 cau5i     cau5ii
17-Nov-08 caubnd    caubndi
17-Nov-08 caucvg    caucvgi
17-Nov-08 caucvg2   caucvg2i
17-Nov-08 caucvg3   caucvg3i
17-Nov-08 caucvg3a  caucvg3ai
17-Nov-08 cauim     cauimi
17-Nov-08 caure     caurei
17-Nov-08 cbvsum    cbvsumi
17-Nov-08 cjadd     cjaddi
17-Nov-08 cjcj      cjcji
17-Nov-08 cjcl      cjcli
17-Nov-08 cjdiv     cjdivi
17-Nov-08 cjmul     cjmuli
17-Nov-08 cjmulge0  cjmulge0i
17-Nov-08 cjmulrcl  cjmulrcli
17-Nov-08 cjmulval  cjmulvali
17-Nov-08 cjneg     cjnegi
17-Nov-08 cjreb     cjrebi
17-Nov-08 clim2serz clim2serzi
17-Nov-08 clim2serzt clim2serzti
17-Nov-08 climabs   climabsi
17-Nov-08 climabs0  climabs0i
17-Nov-08 climadd   climaddi
17-Nov-08 climaddc  climaddci
17-Nov-08 climaddc1 climaddc1i
17-Nov-08 climaddc2 climaddc2i
17-Nov-08 climcau   climcaui
17-Nov-08 climcj    climcji
17-Nov-08 climcmp   climcmpi
17-Nov-08 climcmpc1 climcmpc1i
17-Nov-08 climconst climconsti
17-Nov-08 climeu    climeui
17-Nov-08 climfnrcl climfnrcli
17-Nov-08 climge0   climge0i
17-Nov-08 climim    climimi
17-Nov-08 climmul   climmuli
17-Nov-08 climmulc  climmulci
17-Nov-08 climmulc2 climmulc2i
17-Nov-08 climre    climrei
17-Nov-08 climrecl  climrecli
17-Nov-08 climres   climresi
17-Nov-08 climreu   climreui
17-Nov-08 climserzle climserzlei
17-Nov-08 climshft  climshfti
17-Nov-08 climshft2 climshft2i
17-Nov-08 climsqueeze climsqueezei
17-Nov-08 climsqueeze2 climsqueeze2i
17-Nov-08 climsub   climsubi
17-Nov-08 climsubc2 climsubc2i
17-Nov-08 climsup   climsupi
17-Nov-08 climub    climubi
17-Nov-08 climubi   climubii
17-Nov-08 climuni   climunii
17-Nov-08 climunii  climuniii
17-Nov-08 climuz0   climuz0i
17-Nov-08 clm0      clm0i
17-Nov-08 clm0i     clm0ii
17-Nov-08 clm0nns   clm0nnsi
17-Nov-08 clm1      clm1i
17-Nov-08 clm2      clm2i
17-Nov-08 clm3      clm3i
17-Nov-08 clm4      clm4i
17-Nov-08 clm4at    clm4ati
17-Nov-08 clm4f     clm4fi
17-Nov-08 clm4le    clm4lei
17-Nov-08 clmi1     clmi1i
17-Nov-08 clmi2     clmi2i
17-Nov-08 clmi2rp   clmi2rpi
17-Nov-08 clmnns    clmnnsi
17-Nov-08 cnegex    cnegexi
17-Nov-08 cosadd    cosaddi
17-Nov-08 crim      crimi
17-Nov-08 crmul     crmuli
17-Nov-08 crne0     crne0i
17-Nov-08 crre      crrei
17-Nov-08 crrecz    crreczi
17-Nov-08 cru       crui
17-Nov-08 cvg1      cvg1i
17-Nov-08 cvg1i     cvg1ii
17-Nov-08 cvg2      cvg2i
17-Nov-08 cvg3      cvg3i
17-Nov-08 cvganuz   cvganuzi
17-Nov-08 cvgcmp    cvgcmpi
17-Nov-08 cvgcmp2   cvgcmp2i
17-Nov-08 cvgcmp2c  cvgcmp2ci
17-Nov-08 cvgcmp3c  cvgcmp3ci
17-Nov-08 cvgcmp3ce cvgcmp3cei
17-Nov-08 cvgcmp3cet cvgcmp3ceti
17-Nov-08 cvgcmpub  cvgcmpubi
17-Nov-08 cvgrat    cvgrati
17-Nov-08 dfef2     dfef2i
17-Nov-08 dfuz      dfuzi
17-Nov-08 div0      div0i
17-Nov-08 div1      div1i
17-Nov-08 div11     div11i
17-Nov-08 div23     div23i
17-Nov-08 divadddiv divadddivi
17-Nov-08 divass    divassi
17-Nov-08 divassz   divasszi
17-Nov-08 divcan1   divcan1i
17-Nov-08 divcan1z  divcan1zi
17-Nov-08 divcan2   divcan2i
17-Nov-08 divcan2z  divcan2zi
17-Nov-08 divcan3   divcan3i
17-Nov-08 divcan3z  divcan3zi
17-Nov-08 divcan4   divcan4i
17-Nov-08 divcan4z  divcan4zi
17-Nov-08 divcl     divcli
17-Nov-08 divclz    divclzi
17-Nov-08 divdir    divdiri
17-Nov-08 divdirz   divdirzi
17-Nov-08 divdiv23  divdiv23i
17-Nov-08 divdiv23z divdiv23zi
17-Nov-08 divdivdiv divdivdivi
17-Nov-08 divge0    divge0i
17-Nov-08 divgt0    divgt0i
17-Nov-08 divgt0i   divgt0ii
17-Nov-08 divgt0i2  divgt0i2i
17-Nov-08 divid     dividi
17-Nov-08 divmul    divmuli
17-Nov-08 divmul13  divmul13i
17-Nov-08 divmuldiv divmuldivi
17-Nov-08 divmulz   divmulzi
17-Nov-08 divne0    divne0i
17-Nov-08 divrec    divreci
17-Nov-08 divrecz   divreczi
17-Nov-08 divval    divvali
17-Nov-08 dsupivth  dsupivthi
17-Nov-08 ef01tlub  ef01tlubi
17-Nov-08 ef1tlub   ef1tlubi
17-Nov-08 ef4p      ef4pi
17-Nov-08 efadd     efaddi
17-Nov-08 efcj      efcji
17-Nov-08 effsumle  effsumlei
17-Nov-08 efge1     efge1i
17-Nov-08 efge1p    efge1pi
17-Nov-08 efgt0     efgt0i
17-Nov-08 efgt1     efgt1i
17-Nov-08 eflegeo   eflegeoi
17-Nov-08 eflt      eflti
17-Nov-08 efltb     efltbi
17-Nov-08 efm1legeo efm1legeoi
17-Nov-08 efm1lim   efm1limi
17-Nov-08 efsep     efsepi
17-Nov-08 eft0val   eft0vali
17-Nov-08 eftabs    eftabsi
17-Nov-08 eftlclt   eftlclti
17-Nov-08 eftlext   eftlexti
17-Nov-08 elcncf1d  elcncf1di
17-Nov-08 elcncf1i  elcncf1ii
17-Nov-08 elfzel2   elfzel2i
17-Nov-08 elrpi     elrpii
17-Nov-08 eluz1     eluz1i
17-Nov-08 eluzaddi  eluzaddii
17-Nov-08 eluzsubi  eluzsubii
17-Nov-08 eqle      eqlei
17-Nov-08 eqneg     eqnegi
17-Nov-08 expcnv    expcnvi
17-Nov-08 fnsmnt    fnsmnti
17-Nov-08 fseqsupub fseqsupubi
17-Nov-08 fsum1     fsum1i
17-Nov-08 fsum1f    fsum1fi
17-Nov-08 fsum2     fsum2i
17-Nov-08 fsum3     fsum3i
17-Nov-08 fsum4     fsum4i
17-Nov-08 fsump1    fsump1i
17-Nov-08 fsump1f   fsump1fi
17-Nov-08 fsumser0f fsumser0fi
17-Nov-08 fsumser1f fsumser1fi
17-Nov-08 fsumserz  fsumserzi
17-Nov-08 fsumserz2 fsumserz2i
17-Nov-08 fsumserzf fsumserzfi
17-Nov-08 fzelp1    fzelp1i
17-Nov-08 geoser    geoseri
17-Nov-08 geosum    geosumi
17-Nov-08 gt0ne0    gt0ne0i
17-Nov-08 gt0ne0i   gt0ne0ii
17-Nov-08 halfpos   halfposi
17-Nov-08 hbneg     hbnegi
17-Nov-08 hbnegd    hbnegdi
17-Nov-08 hbsum     hbsumi
17-Nov-08 hbsum1    hbsum1i
17-Nov-08 icoshftf1oi icoshftf1oii
17-Nov-08 imadd     imaddi
17-Nov-08 imcj      imcji
17-Nov-08 imcl      imcli
17-Nov-08 immul     immuli
17-Nov-08 imneg     imnegi
17-Nov-08 infcvg    infcvgi
17-Nov-08 infcvgaux1 infcvgaux1i
17-Nov-08 infcvgaux2 infcvgaux2i
17-Nov-08 ipcn      ipcni
17-Nov-08 iserzabs  iserzabsi
17-Nov-08 iserzcmp  iserzcmpi
17-Nov-08 iserzcmp0 iserzcmp0i
17-Nov-08 iserzex   iserzexi
17-Nov-08 iserzext  iserzexti
17-Nov-08 iserzgt0  iserzgt0i
17-Nov-08 iserzmulc1 iserzmulc1i
17-Nov-08 iserzshft iserzshfti
17-Nov-08 iserzshft2 iserzshft2i
17-Nov-08 isum0split isum0spliti
17-Nov-08 isum1clim isum1climi
17-Nov-08 isum1p    isum1pi
17-Nov-08 isumclim2t isumclim2ti
17-Nov-08 isumclim2tf isumclim2tfi
17-Nov-08 isumclim3t isumclim3ti
17-Nov-08 isumclim4t isumclim4ti
17-Nov-08 isumclim5t isumclim5ti
17-Nov-08 isumclimt isumclimti
17-Nov-08 isumclimtf isumclimtfi
17-Nov-08 isumclt   isumclti
17-Nov-08 isumcmpi  isumcmpii
17-Nov-08 isummulc1 isummulc1i
17-Nov-08 isummulc1ALT isummulc1iALT
17-Nov-08 isummulc1a isummulc1ai
17-Nov-08 isumnn0nn isumnn0nni
17-Nov-08 isumnn0nna isumnn0nnai
17-Nov-08 isumnul   isumnuli
17-Nov-08 isumreclt isumreclti
17-Nov-08 isumshft  isumshfti
17-Nov-08 isumshft2 isumshft2i
17-Nov-08 isumsplit isumspliti
17-Nov-08 isumval2t isumval2ti
17-Nov-08 isumvalt  isumvalti
17-Nov-08 isumvaltf isumvaltfi
17-Nov-08 isupivth  isupivthi
17-Nov-08 le2add    le2addi
17-Nov-08 le2msq    le2msqi
17-Nov-08 le2sq     le2sqi
17-Nov-08 le2tri3   le2tri3i
17-Nov-08 leabs     leabsi
17-Nov-08 leadd1    leadd1i
17-Nov-08 leadd2    leadd2i
17-Nov-08 lecase    lecasei
17-Nov-08 ledivp1   ledivp1i
17-Nov-08 leid      leidi
17-Nov-08 leloe     leloei
17-Nov-08 lelttr    lelttri
17-Nov-08 lelttrd   lelttrdi
17-Nov-08 lemul1    lemul1i
17-Nov-08 lemul2    lemul2i
17-Nov-08 leneg     lenegi
17-Nov-08 lenegcon1 lenegcon1i
17-Nov-08 lenlt     lenlti
17-Nov-08 lerec     lereci
17-Nov-08 lesub0    lesub0i
17-Nov-08 lesubadd  lesubaddi
17-Nov-08 lesubadd2 lesubadd2i
17-Nov-08 letr      letri
17-Nov-08 letrd     letrdi
17-Nov-08 letri     letrii
17-Nov-08 letri3    letri3i
17-Nov-08 lt2add    lt2addi
17-Nov-08 lt2msq    lt2msqi
17-Nov-08 lt2sq     lt2sqi
17-Nov-08 ltadd1    ltadd1i
17-Nov-08 ltadd2    ltadd2i
17-Nov-08 ltaddpos  ltaddposi
17-Nov-08 ltaddsub  ltaddsubi
17-Nov-08 ltdiv1    ltdiv1i
17-Nov-08 ltdiv1i   ltdiv1ii
17-Nov-08 ltdiv23   ltdiv23i
17-Nov-08 ltdiv23i  ltdiv23ii
17-Nov-08 ltdivp1   ltdivp1i
17-Nov-08 ltle      ltlei
17-Nov-08 ltlei     ltleii
17-Nov-08 ltlen     ltleni
17-Nov-08 ltletr    ltletri
17-Nov-08 ltletrd   ltletrdi
17-Nov-08 ltmul1    ltmul1i
17-Nov-08 ltmul1i   ltmul1ii
17-Nov-08 ltmul2    ltmul2i
17-Nov-08 ltmuldiv  ltmuldivi
17-Nov-08 ltne      ltnei
17-Nov-08 ltneg     ltnegi
17-Nov-08 ltnegcon1 ltnegcon1i
17-Nov-08 ltnegcon2 ltnegcon2i
17-Nov-08 ltnle     ltnlei
17-Nov-08 ltnr      ltnri
17-Nov-08 ltnsym    ltnsymi
17-Nov-08 ltp1      ltp1i
17-Nov-08 ltrec     ltreci
17-Nov-08 ltreci    ltrecii
17-Nov-08 ltsubadd  ltsubaddi
17-Nov-08 ltsubadd2 ltsubadd2i
17-Nov-08 lttr      lttri
17-Nov-08 lttrd     lttrdi
17-Nov-08 lttri2    lttri2i
17-Nov-08 lttri3    lttri3i
17-Nov-08 msq0      msq0i
17-Nov-08 msq11     msq11i
17-Nov-08 msqge0    msqge0i
17-Nov-08 msqgt0    msqgt0i
17-Nov-08 mul01     mul01i
17-Nov-08 mul02     mul02i
17-Nov-08 mul0or    mul0ori
17-Nov-08 mul12     mul12i
17-Nov-08 mul23     mul23i
17-Nov-08 mul2neg   mul2negi
17-Nov-08 mul4      mul4i
17-Nov-08 muladd    muladdi
17-Nov-08 mulass    mulassi
17-Nov-08 mulcan    mulcani
17-Nov-08 mulcant2  mulcant2i
17-Nov-08 mulcl     mulcli
17-Nov-08 mulcom    mulcomi
17-Nov-08 mulge0    mulge0i
17-Nov-08 mulgt0    mulgt0i
17-Nov-08 mulgt0i   mulgt0ii
17-Nov-08 mulid1    mulid1i
17-Nov-08 mulid2    mulid2i
17-Nov-08 mulm1     mulm1i
17-Nov-08 muln0     muln0i
17-Nov-08 mulneg1   mulneg1i
17-Nov-08 mulneg2   mulneg2i
17-Nov-08 neg11     neg11i
17-Nov-08 negcl     negcli
17-Nov-08 negcon1   negcon1i
17-Nov-08 negcon2   negcon2i
17-Nov-08 negdi     negdii
17-Nov-08 negeu     negeui
17-Nov-08 negfcncf  negfcncfi
17-Nov-08 negid     negidi
17-Nov-08 negn0     negn0i
17-Nov-08 negne0    negne0i
17-Nov-08 negneg    negnegi
17-Nov-08 negreb    negrebi
17-Nov-08 negsub    negsubi
17-Nov-08 negsubdi  negsubdii
17-Nov-08 negsubdi2 negsubdi2i
17-Nov-08 nn0addcl  nn0addcli
17-Nov-08 nn0addge1 nn0addge1i
17-Nov-08 nn0addge2 nn0addge2i
17-Nov-08 nn0cn     nn0cni
17-Nov-08 nn0ge0    nn0ge0i
17-Nov-08 nn0le2msqt nn0le2msqti
17-Nov-08 nn0le2x   nn0le2xi
17-Nov-08 nn0lele2x nn0lele2xi
17-Nov-08 nn0mulcl  nn0mulcli
17-Nov-08 nn0opth   nn0opthi
17-Nov-08 nn0opth2  nn0opth2i
17-Nov-08 nn0re     nn0rei
17-Nov-08 nncn      nncni
17-Nov-08 nneo      nneoi
17-Nov-08 nnesq     nnesqi
17-Nov-08 nngt0     nngt0i
17-Nov-08 nnlesq    nnlesqi
17-Nov-08 nnne0     nnne0i
17-Nov-08 nnnn0     nnnn0i
17-Nov-08 nnre      nnrei
17-Nov-08 nnsqcl    nnsqcli
17-Nov-08 nnsub     nnsubi
17-Nov-08 om2uz0    om2uz0i
17-Nov-08 om2uzf1o  om2uzf1oi
17-Nov-08 om2uziso  om2uzisoi
17-Nov-08 om2uzlt   om2uzlti
17-Nov-08 om2uzlt2  om2uzlt2i
17-Nov-08 om2uzran  om2uzrani
17-Nov-08 om2uzsuc  om2uzsuci
17-Nov-08 om2uzuz   om2uzuzi
17-Nov-08 peano2zd  peano2zdi
17-Nov-08 peano5nn  peano5nni
17-Nov-08 peano5uz  peano5uzi
17-Nov-08 peano5uzt peano5uzti
17-Nov-08 pm2.61ltle pm2.61ltlei
17-Nov-08 pncan3    pncan3i
17-Nov-08 pnncan    pnncani
17-Nov-08 posdif    posdifi
17-Nov-08 posex     posexi
17-Nov-08 prodge0   prodge0i
17-Nov-08 prodgt0   prodgt0i
17-Nov-08 readd     readdi
17-Nov-08 readdcl   readdcli
17-Nov-08 rec11     rec11i
17-Nov-08 rec11i    rec11ii
17-Nov-08 reccl     reccli
17-Nov-08 recclz    recclzi
17-Nov-08 reccnv    reccnvi
17-Nov-08 receu     receui
17-Nov-08 recex     recexi
17-Nov-08 recgt0    recgt0i
17-Nov-08 recgt0i   recgt0ii
17-Nov-08 recid     recidi
17-Nov-08 recidz    recidzi
17-Nov-08 recj      recji
17-Nov-08 recl      recli
17-Nov-08 recn      recni
17-Nov-08 recnd     recndi
17-Nov-08 recne0z   recne0zi
17-Nov-08 recrec    recreci
17-Nov-08 recvalz   recvalzi
17-Nov-08 redivcl   redivcli
17-Nov-08 redivclz  redivclzi
17-Nov-08 reef11    reef11i
17-Nov-08 reefcl    reefcli
17-Nov-08 reeftlclt reeftlclti
17-Nov-08 reim0b    reim0bi
17-Nov-08 releabs   releabsi
17-Nov-08 remul     remuli
17-Nov-08 remulcl   remulcli
17-Nov-08 reneg     renegi
17-Nov-08 renegcl   renegcli
17-Nov-08 replim    replimi
17-Nov-08 rereb     rerebi
17-Nov-08 rereccl   rereccli
17-Nov-08 rerecclz  rerecclzi
17-Nov-08 resqcl    resqcli
17-Nov-08 resubcl   resubcli
17-Nov-08 reuunineg reuuninegi
17-Nov-08 seq00     seq00i
17-Nov-08 seq01     seq01i
17-Nov-08 seq0fn    seq0fni
17-Nov-08 seq0fval  seq0fvali
17-Nov-08 seq0p1    seq0p1i
17-Nov-08 seq0seqz  seq0seqzi
17-Nov-08 seq0valt  seq0valti
17-Nov-08 seq11     seq11i
17-Nov-08 seq1bnd   seq1bndi
17-Nov-08 seq1cl    seq1cli
17-Nov-08 seq1cl2   seq1cl2i
17-Nov-08 seq1f     seq1fi
17-Nov-08 seq1f2    seq1f2i
17-Nov-08 seq1fn    seq1fni
17-Nov-08 seq1m1    seq1m1i
17-Nov-08 seq1p1    seq1p1i
17-Nov-08 seq1res   seq1resi
17-Nov-08 seq1rn    seq1rni
17-Nov-08 seq1rn2   seq1rn2i
17-Nov-08 seq1rval  seq1rvali
17-Nov-08 seq1seq0  seq1seq0i
17-Nov-08 seq1seq02t seq1seq02ti
17-Nov-08 seq1seq0t seq1seq0ti
17-Nov-08 seq1seqz  seq1seqzi
17-Nov-08 seq1shftid seq1shftidi
17-Nov-08 seq1ub    seq1ubi
17-Nov-08 seq1val   seq1vali
17-Nov-08 seq1val2  seq1val2i
17-Nov-08 seqz1     seqz1i
17-Nov-08 seqzcl    seqzcli
17-Nov-08 seqzeq    seqzeqi
17-Nov-08 seqzfn    seqzfni
17-Nov-08 seqzfval  seqzfvali
17-Nov-08 seqzfval2 seqzfval2i
17-Nov-08 seqzfveq  seqzfveqi
17-Nov-08 seqzm1    seqzm1i
17-Nov-08 seqzp1    seqzp1i
17-Nov-08 seqzres   seqzresi
17-Nov-08 seqzres2  seqzres2i
17-Nov-08 seqzresval seqzresvali
17-Nov-08 seqzrn    seqzrni
17-Nov-08 seqzrn2   seqzrn2i
17-Nov-08 seqzval2t seqzval2ti
17-Nov-08 seqzvalt  seqzvalti
17-Nov-08 ser00     ser00i
17-Nov-08 ser0cj    ser0cji
17-Nov-08 ser0cl1   ser0cl1i
17-Nov-08 ser0clt   ser0clti
17-Nov-08 ser0f     ser0fi
17-Nov-08 ser0mulc  ser0mulci
17-Nov-08 ser0p1    ser0p1i
17-Nov-08 ser11     ser11i
17-Nov-08 ser1absdif ser1absdifi
17-Nov-08 ser1add   ser1addi
17-Nov-08 ser1add2  ser1add2i
17-Nov-08 ser1cl1   ser1cl1i
17-Nov-08 ser1cl2   ser1cl2i
17-Nov-08 ser1clt   ser1clti
17-Nov-08 ser1cmp   ser1cmpi
17-Nov-08 ser1cmp0  ser1cmp0i
17-Nov-08 ser1cmp2  ser1cmp2i
17-Nov-08 ser1const ser1consti
17-Nov-08 ser1f     ser1fi
17-Nov-08 ser1f0    ser1f0i
17-Nov-08 ser1f2    ser1f2i
17-Nov-08 ser1mono  ser1monoi
17-Nov-08 ser1mulc  ser1mulci
17-Nov-08 ser1p1    ser1p1i
17-Nov-08 ser1recl  ser1recli
17-Nov-08 ser1ref   ser1refi
17-Nov-08 ser1ser0  ser1ser0i
17-Nov-08 serz1p    serz1pi
17-Nov-08 serzcj    serzcji
17-Nov-08 serzcl1   serzcl1i
17-Nov-08 serzcl2t  serzcl2ti
17-Nov-08 serzclt   serzclti
17-Nov-08 serzcmp   serzcmpi
17-Nov-08 serzcmp0  serzcmp0i
17-Nov-08 serzf0    serzf0i
17-Nov-08 serzfsum  serzfsumi
17-Nov-08 serzim    serzimi
17-Nov-08 serzmulc  serzmulci
17-Nov-08 serzmulc1 serzmulc1i
17-Nov-08 serzre    serzrei
17-Nov-08 serzreclt serzreclti
17-Nov-08 serzref   serzrefi
17-Nov-08 serzsplit serzspliti
17-Nov-08 shftcan1t shftcan1ti
17-Nov-08 shftcan2t shftcan2ti
17-Nov-08 shftf     shftfi
17-Nov-08 shftfn    shftfni
17-Nov-08 shftfval  shftfvali
17-Nov-08 shftidt   shftidti
17-Nov-08 shftres   shftresi
17-Nov-08 shftresvalt shftresvalti
17-Nov-08 shftval2t shftval2ti
17-Nov-08 shftval3t shftval3ti
17-Nov-08 shftval4t shftval4ti
17-Nov-08 shftval5t shftval5ti
17-Nov-08 shftvalt  shftvalti
17-Nov-08 sinadd    sinaddi
17-Nov-08 sq11      sq11i
17-Nov-08 sqabsadd  sqabsaddi
17-Nov-08 sqabssub  sqabssubi
17-Nov-08 sqcl      sqcli
17-Nov-08 sqdiv     sqdivi
17-Nov-08 sqeq0     sqeq0i
17-Nov-08 sqeqor    sqeqori
17-Nov-08 sqge0     sqge0i
17-Nov-08 sqgt0     sqgt0i
17-Nov-08 sqmul     sqmuli
17-Nov-08 sqr11     sqr11i
17-Nov-08 sqrcl     sqrcli
17-Nov-08 sqreci    sqrecii
17-Nov-08 sqrge0    sqrge0i
17-Nov-08 sqrgt0    sqrgt0i
17-Nov-08 sqrgt0i   sqrgt0ii
17-Nov-08 sqrle     sqrlei
17-Nov-08 sqrlt     sqrlti
17-Nov-08 sqrmsq    sqrmsqi
17-Nov-08 sqrmsq2   sqrmsq2i
17-Nov-08 sqrmul    sqrmuli
17-Nov-08 sqrmuli   sqrmulii
17-Nov-08 sqrsq     sqrsqi
17-Nov-08 sqrth     sqrthi
17-Nov-08 sqsqr     sqsqri
17-Nov-08 sqval     sqvali
17-Nov-08 subadd    subaddi
17-Nov-08 subadd2   subadd2i
17-Nov-08 subaddri  subaddrii
17-Nov-08 subcan    subcani
17-Nov-08 subcan2   subcan2i
17-Nov-08 subcl     subcli
17-Nov-08 subdi     subdii
17-Nov-08 subdir    subdiri
17-Nov-08 subeq0    subeq0i
17-Nov-08 subge0    subge0i
17-Nov-08 subid     subidi
17-Nov-08 subid1    subid1i
17-Nov-08 subneg    subnegi
17-Nov-08 subsq     subsqi
17-Nov-08 subsq0    subsq0i
17-Nov-08 subsub23  subsub23i
17-Nov-08 sumsqne0  sumsqne0i
17-Nov-08 sup3i     sup3ii
17-Nov-08 suprcli   suprclii
17-Nov-08 suprleubi suprleubii
17-Nov-08 suprlubi  suprlubii
17-Nov-08 suprnubi  suprnubii
17-Nov-08 suprubi   suprubii
17-Nov-08 times2    times2i
17-Nov-08 uzinfm    uzinfmi
17-Nov-08 uzrdgfnuz uzrdgfnuzi
17-Nov-08 uzrdgini  uzrdginii
17-Nov-08 uzrdginip1 uzrdginip1i
17-Nov-08 uzrdgsuc  uzrdgsuci
17-Nov-08 uzrdgval  uzrdgvali
17-Nov-08 zre       zrei
17-Nov-08 abs3lem   abs3lemi
17-Nov-08 abs2difabs abs2difabsi
17-Nov-08 abs2dif   abs2difi
17-Nov-08 2basgent  2basgen
17-Nov-08 basgent   basgen
17-Nov-08 basgen2t  basgen2
17-Nov-08 tgss3t    tgss3
17-Nov-08 tgss2t    tgss2
17-Nov-08 tgsst     tgss
17-Nov-08 tgtop11t  tgtop11
17-Nov-08 bastopt   bastop
17-Nov-08 bastop    bastop1
17-Nov-08 tgidmt    tgidm
17-Nov-08 eltop3t   eltop3
17-Nov-08 eltop2t   eltop2
17-Nov-08 eltopt    eltop
17-Nov-08 tgtopt    tgtop
17-Nov-08 topbast   topbas
17-Nov-08 eltg3t    eltg3
17-Nov-08 tgval3t   tgval3
17-Nov-08 tgclt     tgcl
17-Nov-08 unitgt    unitg
17-Nov-08 bastgt    bastg
17-Nov-08 tg2t      tg2
17-Nov-08 tg1t      tg1
17-Nov-08 eltg2t    eltg2
17-Nov-08 eltgt     eltg
17-Nov-08 tgval2t   tgval2
17-Nov-08 tgvalt    tgval
17-Nov-08 basis2t   basis2
17-Nov-08 basis1t   basis1
17-Nov-08 0opnt     0opn
17-Nov-08 inopnt    inopn
17-Nov-08 iunopnt   iunopn
17-Nov-08 uniopnt   uniopn
17-Nov-08 uniopn    uniopn2
17-Nov-08 entrt     entr
17-Nov-08 entr4     entr4i
17-Nov-08 entr3     entr3i
17-Nov-08 entr2     entr2i
17-Nov-08 entr      entri
17-Nov-08 entri     entric
17-Nov-08 rdglimt   rdglim
17-Nov-08 onelpsst  onelpss
17-Nov-08 rdgsuct   rdgsuc
17-Nov-08 on0eqelt  on0eqel
17-Nov-08 onelsst   onelss
17-Nov-08 onsst     onss
17-Nov-08 rdglim    rdglimi
17-Nov-08 rdgsuc    rdgsuci
17-Nov-08 nnon      nnoni
17-Nov-08 onsucss   onsucssi
17-Nov-08 onun      onun2i
17-Nov-08 onssel    onsseli
17-Nov-08 onuninsuc onuninsuci
17-Nov-08 onuniorsuc onuniorsuci
17-Nov-08 onunisuc  onunisuci
17-Nov-08 onsuc     onsuci
17-Nov-08 onelun    oneluni
17-Nov-08 onelin    onelini
17-Nov-08 onssneli2 onssnel2i
17-Nov-08 onelss    onelssi
17-Nov-08 onss      onssi
17-Nov-08 onel      oneli
17-Nov-08 onirr     onirri
17-Nov-08 ontrc     ontrci
17-Nov-08 onord     onordi
17-Nov-08 ---       ---         The *tr* inferences were changed to *tr*i,
17-Nov-08 ---       ---         for consistency with *tr*d
17-Nov-08 bitr      bitri
17-Nov-08 bitr2     bitr2i
17-Nov-08 bitr3     bitr3i
17-Nov-08 bitr4     bitr4i
17-Nov-08 3bitr     3bitri
17-Nov-08 3bitrr    3bitrri
17-Nov-08 3bitr2    3bitr2i
17-Nov-08 3bitr3    3bitr3i
17-Nov-08 3bitr4    3bitr4i
17-Nov-08 3imtr3    3imtr3i
17-Nov-08 3imtr4    3imtr4i
17-Nov-08 eqtr      eqtri
17-Nov-08 eqtr2     eqtr2i
17-Nov-08 eqtr3     eqtr3i
17-Nov-08 eqtr4     eqtr4i
17-Nov-08 3eqtr     3eqtri
17-Nov-08 3eqtrr    3eqtrri
17-Nov-08 3eqtr2    3eqtr2i
17-Nov-08 3eqtr3    3eqtr3i
17-Nov-08 3eqtr4    3eqtr4i
17-Nov-08 eq2tr     eq2tri
17-Nov-08 eqeltr    eqeltri
17-Nov-08 eqeltrr   eqeltrri
17-Nov-08 eleqtr    eleqtri
17-Nov-08 eleqtrr   eleqtrri
17-Nov-08 eqsstr    eqsstri
17-Nov-08 eqsstr3   eqsstr3i
17-Nov-08 sseqtr    sseqtri
17-Nov-08 sseqtr4   sseqtr4i
17-Nov-08 3sstr3    3sstr3i
17-Nov-08 3sstr4    3sstr4i
17-Nov-08 eqbrtr    eqbrtri
17-Nov-08 eqbrtrr   eqbrtrri
17-Nov-08 breqtr    breqtri
17-Nov-08 breqtrr   breqtrri
17-Nov-08 3brtr3    3brtr3i
17-Nov-08 3brtr4    3brtr4i
16-Nov-08 opabsb    opelopabsb
14-Nov-08 zfext2    axext3
14-Nov-08 axext     axext2
14-Nov-08 nega      notnot2
14-Nov-08 negai     notnotri
14-Nov-08 negb      notnot1
14-Nov-08 negbi     notnoti
14-Nov-08 negbii    notbii
14-Nov-08 negbid    notbid
14-Nov-08 pm4.13    notnot
14-Nov-08 pm4.11    notbi
11-Nov-08 divmul3t  [--same--]  rearranged antecedent; renamed variables
11-Nov-08 divmul2t  [--same--]  rearranged antecedent; renamed variables
11-Nov-08 divmult   [--same--]  rearranged antecedent; renamed variables
11-Nov-08 elqsi     [--same--]  changed E. x ( x e. A /\ ...  to E. x e. A ...
11-Nov-08 elqs      [--same--]  changed E. x ( x e. A /\ ...  to E. x e. A ...
 8-Nov-08 indistop  [--same--]  eliminated hypothesis A e. _V
 8-Nov-08 pri2      prid2
 8-Nov-08 pri1      prid1
 7-Nov-08 qdivclt   [--same--]  antecedent changed to use triple conjunction
 6-Nov-08 rcfpfil   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem6 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem5 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem4 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem3 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem2 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem1 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fisub     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 filint2   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 efilcp    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fgsb      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fipfil2   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 sppfi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fiv       [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 df-fi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 emfin     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 ficli     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fiiu      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 abfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fine      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 infi1     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 spfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fctop     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 subbas2   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 subbas    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 istps5    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 istps4    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 istop2g   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 isfinite  [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 pwfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 pwfilem   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 iunfi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fofi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fodomfib  [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fodomfi   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 abfii5    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 abfii4    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 isfinite1 [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 domfi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 unifi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 abfii1    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 abfii2    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 abfii3    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
10-Sep-08 isfinite2 [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 9-Sep-08 finsucdom [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 7-Sep-08 ominf     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Sep-08 onfin     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Sep-08 pssinf    {--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Sep-08 divsubdirt [--same--] changed hyp. order
 3-Sep-08 php3      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 2-Sep-08 fiint     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 1-Sep-08 prfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
30-Aug-08 unfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
29-Aug-08 snfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
29-Aug-08 ssnnfi    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
29-Aug-08 ssfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
24-Aug-08 mulcant   [--same--]  changed antecendent order; swapped var. names
24-Aug-08 mulcan2t  [--same--]  changed antecendent order; swapped var. names
24-Aug-08 mulcant2  [--same--]  changed hyp. order; swapped var. names
24-Aug-08 mulcan    [--same--]  changed hyp. order; swapped var. names
23-Aug-08 divcan4t  [--same--]  changed antecendent order; swapped var. names
23-Aug-08 divcan4z  [--same--]  changed hyp. order; swapped var. names
23-Aug-08 divcan3t  [--same--]  changed antecendent order; swapped var. names
23-Aug-08 divcan3z  [--same--]  changed hyp. order; swapped var. names
22-Aug-08 ssnn      ssnnfi
22-Aug-08 divcan4   [--same--]  changed hyp. order; swapped var. names
22-Aug-08 divcan3   [--same--]  changed hyp. order; swapped var. names
21-Aug-08 pm4.2i    biidd
21-Aug-08 divcan2t  [--same--]  changed antecendent order; swapped var. names
21-Aug-08 divcan2z  [--same--]  changed hyp. order; swapped var. names
20-Aug-08 divdirt   [--same--]  changed hyp. order
18-Aug-08 divcan2   [--same--]  changed hyp. order; swapped var. names
18-Aug-08 divcan1t  [--same--]  changed antecendent order; swapped var. names
18-Aug-08 divcan1z  [--same--]  changed hyp. order; swapped var. names
18-Aug-08 divcan1   [--same--]  changed hyp. order; swapped var. names
17-Aug-08 ltmuldiv2t [--same--] changed antecedent grouping
17-Aug-08 ltdivmult [--same--]  changed antecedent grouping
17-Aug-08 ledivmult [--same--]  changed antecedent grouping
17-Aug-08 ltdivmul2t [--same--] changed antecedent grouping
17-Aug-08 ledivmul2t [--same--] changed antecedent grouping
17-Aug-08 lemuldivt [--same--]  changed antecedent grouping
17-Aug-08 lemuldiv2t [--same--] changed antecedent grouping
16-Aug-08 ltmuldivt [--same--]  changed antecedent grouping
15-Aug-08 bii       dfbi1
15-Aug-08 biigb     dfbi1gb
15-Aug-08 bi        dfbi2
15-Aug-08 dfbi      dfbi3
14-Aug-08 lediv1t   [--same--]  changed antecedent grouping
14-Aug-08 ltdiv1t   [--same--]  changed antecedent grouping
10-Jul-08 expne0t   [--same--]  swapped biconditional
10-Jul-08 sq0t      sqeq0t
10-Jul-08 sq00      sqeq0
 7-Jul-08 syl3dan3  syld3an3
 7-Jul-08 syl3dan2  syld3an2
31-May-08 isnvi     [--same--]  eliminated hypotheses G e. V, S e. _V
31-May-08 isnvg     ---         obsolete; use isnv
31-May-08 isvcg     ---         obsolete; use isvc
31-May-08 ideq      [--same--]  eliminated hypothesis A e. _V
31-May-08 ideqg     [--same--]  eliminated first antecedent A e. C
28-May-08 opelxpex  ---         obsolete; use opelxp1
22-May-08 ax9a      ax9
22-May-08 ax9       ax9o
21-May-08 ax6-2     ax6
21-May-08 ax6-3     ax6o
21-May-08 ax-6      ax-6o
21-May-08 ax-5      ax-5o
17-May-08 ax-10     ax-10o
16-May-08 er2       dfer2
16-May-08 er2       dfer2
16-May-08 sb7       dfsb7
13-May-08 cla4e2v   cla42ev
13-May-08 cla4e2gv  cla42egv
12-May-08 a4w1      a4eiv
12-May-08 a4w       a4imev
12-May-08 a4c1      a4imed
12-May-08 a4c       a4ime
12-May-08 a4b1      a4v
12-May-08 a4b       a4imv
12-May-08 a4at      a4imt
12-May-08 a4a       a4im
11-May-08 sbea4     a4sbe
11-May-08 sbia4     a4sbim
11-May-08 sbba4     a4sbbi
 6-May-08 inf4      axinf2
 6-May-08 minfnre   mnfnre
27-Apr-08 sb6y      sb6f
27-Apr-08 sb5y      sb5f
17-Apr-08 sbn2      ---         obsolete; use sbn
17-Apr-08 sbn1      ---         obsolete; use sbn
 9-Apr-08 isvci     [--same--]  weakened hyp from G : ... to dom G = ...
 9-Apr-08 isabli    [--same--]  weakened hyp from G : ... to dom G = ...
 2-Apr-08 19.2      [--same--]  generalized to use 2 set variables
30-Mar-08 grprn     [--same--]  weakened hyp from G : ... to dom G = ...
11-Mar-08 absefimt  absefit
11-Mar-08 axcnre    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cnegexlem2 [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cnegext   [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 recextlem1 [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 recextlem2 [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 recext    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crulem    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cru       [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crut      [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crne0     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crmul     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crrecz    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 creur     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 creui     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 rimul     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 df-re     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 df-im     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 revalt    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 imvalt    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 replimt   [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 df-cj     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cjvalt    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 replim    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crret     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crimt     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crre      [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crim      [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 efit4pt   efi4pt      changed 'x. i' to 'i x.'
10-Mar-08 fabex     [--same--]  added 3rd hypothesis
 6-Mar-08 pm2.36    [--same--]  corrected to match Principia Mathematica
 6-Mar-08 pm2.37    [--same--]  corrected to match Principia Mathematica
 6-Mar-08 pm2.38    [--same--]  corrected to match Principia Mathematica
 2-Mar-08 csbiet    csbiegft
 2-Mar-08 csbie2g   csbie2t
 2-Mar-08 vsbcint   sbhyp
 2-Mar-08 cbvsbcv   cbvralsv
 1-Mar-08 sbcrex    sbcrexg
 1-Mar-08 sbcral    sbcralg
 1-Mar-08 19.23g    19.23t
 1-Mar-08 19.21g    19.21t
 1-Mar-08 minusex   negex
 1-Mar-08 negext    cnegext
 1-Mar-08 negex     cnegex
29-Feb-08 hbneq     hbne
29-Feb-08 hbne      hbn
29-Feb-08 csbiet    csbiegft
29-Feb-08 sbciet    sbciegft
29-Feb-08 elabt     elabgt
29-Feb-08 vtoclefg  vtoclegft
23-Feb-08 sqdif0    subsq0
23-Feb-08 binom2a   ---         obsolete; use subsq
12-Feb-08 cnhl      [--same--]  added hypothesis to assign vector space to var
 9-Feb-08 oneirr    onirr
 9-Feb-08 ordeirr   ordirr
 9-Feb-08 eirr      elirr
 9-Feb-08 eirrv     elirrv
29-Jan-08 oibabs    [--same--]  swapped sides of biconditional
24-Jan-08 cos2t     ---         obsolete; use cos2tt
20-Jan-08 ffvrni    ffvelrni
20-Jan-08 ffvrn     ffvelrn
20-Jan-08 fnfvrn    fnfvelrn
20-Jan-08 fvrn      fvelrn
20-Jan-08 fvelrn    fvelrnb
18-Jan-08 arch      [--same--]  changed x to n, changing $f hypothesis order
18-Jan-08 cos1lem4  8th4div3
18-Jan-08 eftlex    ---         obsolete; use eftlext
18-Jan-08 sin2t     ---         obsolete; use sin2tt
15-Jan-08 explt1t   expord2t
15-Jan-08 eft0vallem eft0val
15-Jan-08 effsumlelem ---       obsolete; use reeftclt
15-Jan-08 eftvallem eftval
15-Jan-08 efpartex  eftlex
15-Jan-08 efcltlem4 efseq0ex
15-Jan-08 efcltlem2a ef0lem
15-Jan-08 dfef2lem  dfef2
15-Jan-08 efcltlem3 efseq1ex
15-Jan-08 eftcltlem eftclt
15-Jan-08 eftabslem eftabs
12-Jan-08 rgen2xxx  rgen2a
12-Jan-08 rgen2a    rgen2
12-Jan-08 rgen2     rgen2xxx
12-Jan-08 cnbn      [--same--]  added hypothesis to assign vector space to var
12-Jan-08 cnph      [--same--]  added hypothesis to assign vector space to var
12-Jan-08 cnims     [--same--]  reorganized hypotheses and conclusion
14-Jan-08 rgen3     [--same--]  generalized for 3 different class variables
12-Jan-08 cnnv      [--same--]  added hypothesis to assign vector space to var
10-Jan-08 zneo      [--same--]  changed -. ... = to =/=
 3-Jan-08 ax7-467   ax467to7
 3-Jan-08 ax6-467   ax467to6
 3-Jan-08 ax4-467   ax467to4
 3-Jan-08 ax6-67    ax67to6
 3-Jan-08 ax7-67    ax67to7
 3-Jan-08 ax4-46    ax46to4
 3-Jan-08 ax5-46    ax46to5
29-Dec-07 eftvallem [--same--]  added hypothesis
22-Dec-07 zfnuleu   [--same--]  added $e hypothesis to remove ax-nul dependency
 8-Dec-07 supxrre2  [--same--]  changed -. ... = to =/=
23-Nov-07 sub4      addsub4
23-Nov-07 sub4t     addsub4t
17-Nov-07 climres   [--same--]  generalized antecedent from A e. CC to A e. B
12-Nov-07 climle    climcmp
11-Nov-07 eqneqi    necon3bii
11-Nov-07 eqneqd    necon3bid
10-Nov-07 ser0cj    [--same--]  weakened hypotheses
 9-Nov-07 ser1cj    ---         obsolete; derive from serzcj (as in ser0cj)
 9-Nov-07 ser0re    ---         obsolete; derive from serzre (as in ser0cj)
 9-Nov-07 ser1re    ---         obsolete; derive from serzre (as in ser0cj)
 8-Nov-07 mp3dan    mp3dan23
23-Oct-07 pm3.27bd  pm3.27bi
23-Oct-07 pm3.26bd  pm3.26bi
16-Oct-07 expbndt   expubndt
16-Oct-07 expge1t   [--same--]  strengthened from N e. NN to N e. NN0
12-Oct-07 kmlem15   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem14   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem13   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem10   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem9    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem7    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem5    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem4    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem3    [--same--]  changed -. ... = to =/=
 5-Oct-07 1open     topopn
 5-Oct-07 1clsd     topcld
 3-Oct-07 intss3    ntrss3
 2-Oct-07 isopen3   isopn3
 2-Oct-07 isopen2   isopn2
 2-Oct-07 cmclsopen cmclsopn
 2-Oct-07 snclsd    sncld
 2-Oct-07 clsdlp    cldlp
 2-Oct-07 isclsd3   iscld3
 2-Oct-07 cmntrclsd cmntrcld
 2-Oct-07 clsclsd   clscld
 2-Oct-07 clsdcls   cldcls
 2-Oct-07 unclsd    uncld
 2-Oct-07 intclsd   intcld
 2-Oct-07 iinclsd   iincld
 2-Oct-07 0clsd     0cld
 2-Oct-07 openclsd  opncld
 2-Oct-07 clsdopen  cldopn
 2-Oct-07 clsdss    cldss
 2-Oct-07 isclsd2   iscld2
 2-Oct-07 isclsd    iscld
 2-Oct-07 clsdval   cldval
 2-Oct-07 df-clsd   df-cld
 2-Oct-07 isopn2    isopn4
28-Sep-07 ---       ---         changed math symbol from "floor" to "|_"
26-Sep-07 ser0cl    ser0cl1
26-Sep-07 ser1cl    ser1cl1
25-Sep-07 ser1re2   ser1re
25-Sep-07 ser1re    ser1ref
23-Sep-07 df-fac    [--same--]  swapped arguments of union
23-Sep-07 seqzrnx   seqzrn
23-Sep-07 seqzrn    seqzrn2
23-Sep-07 seqzrn2   seqzrnx
23-Sep-07 seq1rnx   seq1rn
23-Sep-07 seq1rn    seq1rn2
23-Sep-07 seq1rn2   seq1rnx
17-Sep-07 pm2.21nd  pm2.24d
17-Sep-07 pm2.21ni  pm2.24i
16-Sep-07 dvelimf2  dvelimfALT
 8-Sep-07 lemul2it  [--same--]  rearranged antecedent
 8-Sep-07 lemul1it  [--same--]  rearranged antecedent
 7-Sep-07 0vval     0vfval
 4-Sep-07 ---       ---         Many changes after df-ms, described in the
                                  4-Sep-2007 entry of
                                  us.metamath.org/mpegif/mmnotes.txt
 4-Sep-07 elssab    ---         obsolete; use elssabg
 4-Sep-07 nvc       nvvc
 4-Sep-07 ---       ---         changed math symbol from "Met" to "MetSp"
 4-Sep-07 ---       ---         changed math symbol from "CMet" to "CMetSp"
25-Aug-07 fopabco   fopabcos
21-Aug-07 xrltnet   [--same--]  changed -. A = B to B =/= A; triple conjunction
21-Aug-07 lttri2    [--same--]  changed -. A = B to A =/= B
21-Aug-07 lttri2t   [--same--]  changed -. A = B to A =/= B
15-Aug-07 sbccsbg   sbccsb2g
11-Aug-07 recdivt   [--same--]  rearranged antecedent
 9-Aug-07 funopabex2g opabex2g
 9-Aug-07 funopabex2 opabex2
 9-Aug-07 funopabex opabex
 9-Aug-07 cnco      [--same--]  swapped 2nd & 3rd args in 1st triple conj
 6-Aug-07 ---       ---         changed "ncv" to "nv" in the labels of:
                                  cncv df-ncv ncvss ncvrel ncvop ncvvop
                                  isncvg isncvi ncvi ncvv ncvgcl
                                  ncvscl ncvf ncvcl ncvcli ncvdm ncvs
                                  ncvm1 ncvdif ncvpi ncvz0 ncvz ncvtri
                                  ncvabs ncvge0 cnncv cnncv0 elimncvu
                                  ncvnd phncv bnncv hlncv hilncv
 4-Aug-07 subval    ---         obsolete; use subvalt
31-Jul-07 divge0t   [--same--]  rearranged antecedent
31-Jul-07 divgt0t   [--same--]  rearranged antecedent
31-Jul-07 ltne      [--same--]  changed -. A = B to B =/= A
31-Jul-07 ltnet     [--same--]  changed -. A = B to B =/= A; triple conjunction
31-Jul-07 ltlen     [--same--]  changed -. A = B to B =/= A
31-Jul-07 ltlent    [--same--]  changed -. A = B to B =/= A
22-Jul-07 xrleltnet [--same--]  changed -. A = B to B =/= A
20-Jul-07 nngt1ne1t [--same--]  changed -. A = 1 to A =/= 1
18-Jul-07 leltnet   [--same--]  changed -. A = B to B =/= A
15-Ju1-07 zornx     zorn
15-Ju1-07 zorn      zorn2
15-Ju1-07 zorn2     zornx
18-Jun-07 caucvglem2 [--same--]  changed -. S = (/) to S =/= (/)
17-Jun-07 seq1ublem [--same--]  changed -. ... = (/) to =/= (/)
17-Jun-07 suppr     supexpr
17-Jun-07 ruclem33  [--same--]  changed -. ... = (/) to =/= (/)
16-Jun-07 ltrec1t   [--same--]  rearranged antecedent
15-Jun-07 lerec2t   [--same--]  rearranged antecedent
 3-Jun-07 nordeq    [--same--]  changed -. A = B to A =/= B
 3-Jun-07 xpsndisj  [--same--]  changed -. A = B to A =/= B
 2-Jun-07 peano3    [--same--]  changed -. A = (/) to A =/= (/)
 2-Jun-07 disjsn2   [--same--]  changed -. A = B to A =/= B
 2-Jun-07 fun2ssres [--same--]  antecedent changed to use triple conjunction
 2-Jun-07 onelpsst  [--same--]  changed -. A = B to A =/= B
 1-Jun-07 ordelssne [--same--]  changed -. A = B to A =/= B
 1-Jun-07 suprleubi [--same--]  changed -. A = (/) to A =/= (/)
31-May-07 suprnubi  [--same--]  changed -. A = (/) to A =/= (/)
30-Mar-07 onssmin   [--same--]  changed -. A = (/) to A =/= (/)
29-May-07 suprlub   [--same--]  changed -. A = (/) to A =/= (/)
29-May-07 funssfv   [--same--]  antecedent changed to use triple conjunction
29-May-07 limuni3   [--same--]  changed -. A = (/) to A =/= (/)
29-May-07 ordge1n0  [--same--]  changed -. A = (/) to A =/= (/)
28-May-07 onmindif2 [--same--]  changed -. A = (/) to A =/= (/)
28-May-07 suprleub  [--same--]  changed -. A = (/) to A =/= (/)
28-May-07 tz7.7     [--same--]  changed -. B = A to B =/= A
27-May-07 nnullss   [--same--]  changed -. ... = (/) to =/= (/)
27-May-07 supxrre2  [--same--]  changed -. A = (/) to A =/= (/)
27-May-07 fodomfib  [--same--]  changed -. A = (/) to A =/= (/)
26-May-07 supxrre1  [--same--]  changed -. A = (/) to A =/= (/)
24-May-07 supxrgtmnf [--same--]  changed -. A = (/) to A =/= (/)
23-May-07 ltmsqt    ---         obsolete; use msqgt0t
23-May-07 msqgt0    [--same--]  changed -. A = (/) to A =/= (/)
22-May-07 supxrbnd  [--same--]  changed -. A = (/) to A =/= (/)
21-May-07 suprnub   [--same--]  changed -. A = (/) to A =/= (/)
21-May-07 19.3r     ---         obsolete; use 19.3
21-May-07 19.9rv    ---         obsolete; use 19.9v
20-May-07 19.9r     ---         obsolete; use 19.9
17-May-07 iunn0     [--same--]  changed -. ... = (/) to =/= (/)
17-May-07 iinon     [--same--]  changed -. A = (/) to A =/= (/)
17-May-07 map0      [--same--]  changed -. B = (/) to B =/= (/)
16-May-07 infmrcl   [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprub    [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprcli   [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprubi   [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprlubi  [--same--]  changed -. A = (/) to A =/= (/)
14-May-07 sup3i     [--same--]  changed -. A = (/) to A =/= (/)
13-May-07 kmlemxx   kmlem8      changed -. ... = (/) to =/= (/)
13-May-07 kmlem8    kmlem9
13-May-07 kmlem9    kmlem10
13-May-07 kmlem10   kmlem11
13-May-07 kmlem11   kmlem12     changed -. ... = to =/=
13-May-07 kmlem12   kmlem13     changed -. ... = to =/=
13-May-07 kmlem13   kmlemxx
13-May-07 supxrre   [--same--]  changed -. A = (/) to A =/= (/)
13-May-07 infmsup   [--same--]  changed -. A = (/) to A =/= (/)
13-May-07 suprcl    [--same--]  changed -. A = (/) to A =/= (/)
12-May-07 kmlem1    [--same--]  changed -. ... = to =/=
12-May-07 kmlem3    [--same--]  changed -. ... = to =/=
12-May-07 kmlem6    [--same--]  changed -. ... = to =/=
12-May-07 kmlem7    [--same--]  changed -. ... = to =/=
11-May-07 infm3     [--same--]  changed -. A = (/) to A =/= (/)
11-May-07 sup3      [--same--]  changed -. A = (/) to A =/= (/)
10-May-07 oneqmin   [--same--]  changed -. B = (/) to B =/= (/)
10-May-07 infmssuzcl [--same--]  changed -. S = (/) to S =/= (/)
 5-May-07 xpexr2    [--same--]  changed -. ... = (/) to =/= (/)
 5-May-07 tz7.49c   [--same--]  changed -. ... = to =/=
 4-May-07 tz7.49    [--same--]  changed -. ... = to =/=
 4-May-07 funimass2 [--same--]  conjoined antecedents in hypothesis
 3-May-07 ac4c      [--same--]  changed -. x = (/) to x =/= (/)
30-Apr-07 aceq6b    [--same--]  changed -. z = (/) to z =/= (/)
30-Apr-07 disjpss   [--same--]  changed -. B = (/) to B =/= (/)
30-Apr-07 infxpidmlem10 [--same--]  changed -. g = (/) to g =/= (/)
30-Apr-07 1ne0      [--same--]  changed -. 1o = (/) to 1o =/= (/)
30-Apr-07 ac5b      [--same--]  changed -. x = (/) to x =/= (/)
30-Apr-07 aceq6a    [--same--]  changed -. z = (/) to z =/= (/)
30-Apr-07 on0eln0   [--same--]  changed -. A = (/) to A =/= (/)
28-Apr-07 tz7.2     [--same--]  changed -. B = A to B =/= A; triple conjunction
25-Apr-07 ac5       [--same--]  changed -. x = (/) to x =/= (/)
23-Apr-07 ac4       [--same--]  changed -. z = (/) to z =/= (/)
22-Apr-07 ac8       [--same--]  changed -. ... = to =/=
22-Apr-07 uzwo2     [--same--]  changed -. S = (/) to S =/= (/)
21-Apr-07 aceq5     [--same--]  changed -. ... = to =/=
21-Apr-07 epfrc     [--same--]  -. B = (/) to B =/= (/); triple conjunction
20-Apr-07 dfepfr    [--same--]  changed -. x = (/) to x =/= (/)
19-Apr-07 xpnz      [--same--]  changed -. ... = (/) to =/= (/)
18-Apr-07 ltexprlem1 [--same--]  changed -. C = (/) to C =/= (/)
17-Apr-07 uzwo      [--same--]  changed -. S = (/) to S =/= (/)
17-Apr-07 aceq4     [--same--]  changed -. z = (/) to z =/= (/)
17-Apr-07 prn0      [--same--]  changed -. A = (/) to A =/= (/)
15-Apr-07 elni      [--same--]  changed -. A = (/) to A =/= (/)
14-Apr-07 aceq3lem  [--same--]  changed -. z = (/) to z =/= (/)
14-Apr-07 aceq3     [--same--]  changed -. z = (/) to z =/= (/)
13-Apr-07 tpnz      [--same--]  changed -. ... = (/) to =/= (/)
13-Apr-07 0nep0     [--same--]  changed -. (/) = { (/) } to (/) =/= { (/) }
12-Apr-07 1cn       ax1cn
12-Apr-07 ax1re     1re
11-Apr-07 zfreg     [--same--]  changed -. A = (/) to A =/= (/)
11-Apr-07 zfreg2    [--same--]  changed -. A = (/) to A =/= (/)
11-Apr-07 inf1      [--same--]  changed -. x = (/) to x =/= (/)
11-Apr-07 inf2      [--same--]  changed -. x = (/) to x =/= (/)
11-Apr-07 zorn2lem6  [--same--]  changed -. H = (/) to H =/= (/)
11-Apr-07 zorn2lem5  [--same--]  changed -. H = (/) to H =/= (/)
11-Apr-07 zorn2lem3  [--same--]  changed -. D = (/) to D =/= (/)
11-Apr-07 zorn2lem2  [--same--]  changed -. D = (/) to D =/= (/)
11-Apr-07 zorn2lem1  [--same--]  changed -. D = (/) to D =/= (/)
11-Apr-07 inf3lem2  [--same--]  changed -. ... = to =/=
11-Apr-07 inf3lem3  [--same--]  changed -. ... = to =/=
11-Apr-07 inf3lem4  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3lem5  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3lem6  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3lem7  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3      [--same--]  changed -. -. x = (/) to x =/= (/)
10-Apr-07 htalem    [--same--]  changed -. A = (/) to A =/= (/)
 9-Apr-07 ac3       [--same--]  changed -. z = (/) to z =/= (/)
 9-Apr-07 rnxp      [--same--]  changed -. A = (/) to A =/= (/)
 7-Apr-07 aceq2     [--same--]  changed -. z = (/) to z =/= (/)
 6-Apr-07 tz6.12i   [--same--]  changed -. B = (/) to B =/= (/)
 6-Apr-07 scott0s   [--same--]  changed -. .. = (/) to =/= { (/) }
 6-Apr-07 dmxp      [--same--]  changed -. A = (/) to A =/= (/)
 6-Apr-07 nnsuc     [--same--]  changed -. A = (/) to A =/= (/)
 5-Apr-07 onne0     [--same--]  changed -. On = (/) to On =/= (/)
 5-Apr-07 ord0eln0  [--same--]  changed -. A = (/) to A =/= (/)
 5-Apr-07 wereu     [--same--]  -. B = (/) to B =/= (/); triple conjunction
 3-Apr-07 aceq5lem5 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 aceq5lem4 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 aceq5lem3 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 aceq5lem2 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 pssdifn0  [--same--]  changed -. ... = to =/=
 3-Apr-07 fri       [--same--]  changed -. ... = (/) to ... =/= (/)
 2-Apr-07 cplem1    [--same--]  changed -. ... = (/) to =/= (/)
 2-Apr-07 cplem2    [--same--]  changed -. ... = (/) to =/= (/)
 2-Apr-07 0pss      [--same--]  changed -. A = (/) to A =/= (/)
 2-Apr-07 inelcm    [--same--]  changed -. ... = (/) to =/= (/)
 2-Apr-07 snnz      [--same--]  changed -. A = (/) to A =/= (/)
 2-Apr-07 inf0      [--same--]  changed conclusion to match ax-inf exactly
 2-Apr-07 n0f       ---         obsolete; use ne0f
26-Mar-07 df-lim    [--same--]  changed -. A = (/) to A =/= (/)
26-Mar-07 pwen      [--same--]  eliminated redundant hypotheses
26-Mar-07 ssundif   undif
23-Mar-07 fo2       dffo2
23-Mar-07 fofv      dffo3
22-Mar-07 fnbr      [--same--]  eliminated redundant hypotheses
22-Mar-07 fnop      [--same--]  eliminated redundant hypotheses
21-Mar-07 kardex    [--same--]  eliminated redundant hypothesis
21-Mar-07 qsid      [--same--]  eliminated redundant hypothesis
21-Mar-07 0nelqs    [--same--]  eliminated redundant hypothesis
21-Mar-07 brecop2   [--same--]  eliminated redundant hypothesis
21-Mar-07 ecelqsdm  [--same--]  eliminated redundant hypothesis
18-Mar-07 map0b     [--same--]  changed -. A = (/) to A =/= (/)
17-Mar-07 oninton   [--same--]  changed -. A = (/) to A =/= (/)
17-Mar-07 wefrc     [--same--]  -. B = (/) to B =/= (/); triple conjunction
17-Mar-07 onint     [--same--]  changed -. A = (/) to A =/= (/)
17-Mar-07 tz7.5     [--same--]  -. B = (/) to B =/= (/); triple conjunction
17-Mar-07 fiint     [--same--]  changed -. x = (/) to x =/= (/)
16-Mar-07 ishlg     [--same--]  changed hypothesis from X = dom N to X = ran G
16-Mar-07 unitopt   ---         obsolete; use topopn
16-Mar-07 peano3nn0 nn0p1nnt
15-Mar-07 intex     [--same--]  changed -. A = (/) to A =/= (/)
 4-Mar-07 opthreg   [--same--]  added converse:  ->  to  <->
15-Feb-07 qbtwnre   [--same--]  antecedent changed to use triple conjunction
13-Feb-07 rcla42ev  [--same--]  antecedent changed to use triple conjunction
10-Feb-07 fodomb    [--same--]  changed -. A = (/) to A =/= (/)
 7-Feb-07 rabbidv   [--same--]  conjoined antecedents in hypothesis
 5-Feb-07 equidALT  equid1
 5-Feb-07 ax-11     ax-11o
 2-Feb-07 ax11a     ax11v
 1-Feb-07 frc       [--same--]  -. = (/) to =/= (/); conjoined antecedents
31-Jan-07 itimesi   ixi
31-Jan-07 isqm1     i2
30-Jan-07 dffr2     [--same--]  changed -. ... = (/) to ... =/= (/)
30-Jan-07 df-fr     [--same--]  changed -. ... = (/) to ... =/= (/)
30-Jan-07 f1oeng    [--same--]  conjoined antecedents
29-Jan-07 2sumeq2d  ---         obsolete; use 2sumeq2dv
29-Jan-07 sumeq12d  ---         obsolete; use sumeq12dv
29-Jan-07 sumeq12rd ---         obsolete; use sumeq12rdv
29-Jan-07 eval      [--same--]  ( 1 ^ k ) changed to 1
22-Jan-07 ax11el    [--same--]  generalized with less restrictive variables
18-Jan-07 climcvgc1 ---         obsolete; use clmi1
18-Jan-07 climcvg1  ---         obsolete; use clmi2
18-Jan-07 clim1     ---         obsolete; use clm2
18-Jan-07 clim1a    ---         obsolete; use clm3
18-Jan-07 clim2a    ---         obsolete; use clm2
18-Jan-07 clim2     ---         obsolete; use clm4
18-Jan-07 climcvg2  ---         obsolete; use clmi2
18-Jan-07 climcvg2z ---         obsolete; use clmi2
18-Jan-07 climcvgc2z ---        obsolete; use clmi1
18-Jan-07 climcvg2zb ---        obsolete; use clmi2
18-Jan-07 clim2az   ---         obsolete; use clm3
18-Jan-07 clim3az   ---         obsolete; use clm3
18-Jan-07 clim3a    ---         obsolete; use clm3
18-Jan-07 clim3     ---         obsolete; use clm4
18-Jan-07 clim3b    ---         obsolete; use clm2
18-Jan-07 climcvg3  ---         obsolete; use clmi2
18-Jan-07 climcvg3z ---         obsolete; use clmi2
18-Jan-07 clim4a    ---         obsolete; use clm3
18-Jan-07 clim4     ---         obsolete; use clm4
18-Jan-07 climcvg4  ---         obsolete; use clmi2
18-Jan-07 climcvgc4z ---        obsolete; use clmi1
18-Jan-07 climcvg4z ---         obsolete; use clmi2
18-Jan-07 clim0cvg4z ---        obsolete; use clm0i
18-Jan-07 climcvgc5z ---        obsolete; use clmi1
18-Jan-07 climcvg5z ---         obsolete; use clmi2
18-Jan-07 clim0cvg5z ---        obsolete; use clm0i
18-Jan-07 climnn0   ---         obsolete; use clm4
18-Jan-07 climnn    ---         obsolete; use clm4
18-Jan-07 clim0nn   ---         obsolete; use clm0
18-Jan-07 climcvgnn ---         obsolete; use clmi2
18-Jan-07 climcvgnn0 ---        obsolete; use clmi2
18-Jan-07 clim0cvgnn0 ---       obsolete; use clm0i
18-Jan-07 climcvg2nn0 ---       obsolete; use clmi2
18-Jan-07 clim0cvg2nn0 ---      obsolete; use clm0i
18-Jan-07 climnn0le ---         obsolete; use clm4le
18-Jan-07 clim0nn0le ---        obsolete; use clm4le and clm0
16-Jan-07 abn0      [--same--]  changed -. ... = (/) to ... =/= (/)
16-Jan-07 rabn0     [--same--]  changed -. ... = (/) to ... =/= (/)
16-Jan-07 nsuceq0   [--same--]  changed -. ... = (/) to ... =/= (/)
16-Jan-07 iin0      [--same--]  changed -. A = (/) to A =/= (/)
16-Jan-07 fint      [--same--]  changed -. B = (/) to B =/= (/)
14-Jan-07 clim3z    clm4at
12-Jan-07 climconst [--same--]  made M e. ZZ a hypothesis instead of antecedent
11-Jan-07 climres2  ---         obsolete; use climres
 4-Jan-07 iunconst  [--same--]  changed -. A = (/) to A =/= (/)
21-Dec-06 intssuni2 [--same--]  changed -. A = (/) to A =/= (/)
21-Dec-06 intssuni  [--same--]  changed -. A = (/) to A =/= (/)
21-Dec-06 prer2     preqr2
20-Dec-06 ccms      cnms
20-Dec-06 ccims     cnims
20-Dec-06 ccmsval   cnimsval
18-Dec-06 cvgannn   ---         obsolete; use cvganuz
18-Dec-06 cvgannn0  ---         obsolete; use cvganuz
14-Dec-06 cleqreli  eqrelriv
14-Dec-06 cleqrel   eqrel
12-Dec-06 rnco      rncoss
12-Dec-06 dmco      dmcoss
 5-Dec-06 r19.2z    [--same--]  -. A = (/) to A =/= (/); conjoined antecendents
24-Nov-06 infn0     [--same--]  changed -. A = (/) to A =/= (/)
24-Nov-06 0sdom     [--same--]  changed -. A = (/) to A =/= (/)
24-Nov-06 0sdomg    [--same--]  changed -. A = (/) to A =/= (/)
24-Nov-06 infxpabs  [--same--]  -. B = (/) to B =/= (/); use w3a for antec.
24-Nov-06 xpdom3    [--same--]  changed antecedent from -. B = (/) to B =/= (/)
14-Nov-06 zfnul     axnul
14-Nov-06 zfaus     axsep
28-Oct-06 inv       inv1
25-Oct-06 orcana    ---         obsolete; use pm5.6
10-Oct-06 oprec     [--same--]  changed order of $f hypotheses
10-Oct-06 ecoprdi   [--same--]  changed order of $f hypotheses
10-Oct-06 ecoprass  [--same--]  changed order of $f hypotheses
 9-Oct-06 unisseq   ---         obsolete; use unimax
 8-Oct-06 notzfaus  [--same--]  more meaningful first hypothesis
 8-Oct-06 intmin    [--same--]  swapped arguments of = sign
 8-Oct-06 intmin2   [--same--]  swapped arguments of = sign
 5-Oct-06 expcant   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 expsubt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 divexpt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 expwordit [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 explt1t   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 recexpt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 expordt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 iineq2dv  [--same--]  conjoined antecedents in hypothesis
 5-Oct-06 iuneq2dv  [--same--]  conjoined antecedents in hypothesis
 5-Oct-06 r19.9rzv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.45zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.27zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.36zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 iindif2   [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.28zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.3rzv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 2-Oct-06 phplem5   phplem4
 2-Oct-06 phplem4   phplem3
 2-Oct-06 phplem3   phplem2
 2-Oct-06 phplem2   phplem1
 2-Oct-06 phplem1   ---         obsolete; use difsnid
29-Sep-06 uniord    orduni
29-Sep-06 onunit    ssonuni
29-Sep-06 onuni     ssonunii
29-Sep-06 ac6s2     ac6s3
29-Sep-06 ac6c      ---         obsolete; use ac6s5
21-Sep-06 rankuni   rankuni2
20-Sep-06 npnz      [--same--]  strengthened by adding converse
20-Sep-06 onsucuni2 [--same--]  swapped arguments of = sign
19-Sep-06 nlimsuc   ---         obsolete; use nlimsucg
19-Sep-06 limuni2   limuni3
15-Sep-06 ranklon   rankval4
13-Sep-06 cbvop     rexxp
11-Sep-06 zfaus     zfauscl
10-Sep-06 fex       [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 f1dmex    [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 fnex      [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 ssexg     [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 funimaexg [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 resfunexg [--same--]  antecedent changed to use conjunction & swapped
 9-Sep-06 funex     [--same--]  antecedent changed to use conjunction & swapped
 8-Sep-06 cls       clsp
29-Aug-06 elab3g    elab3
26-Aug-06 unop      uniop
26-Aug-06 unpr      unipr
26-Aug-06 unictb    [--same--]  removed irrelevant hypothesis
16-Aug-06 ssrab     ssrab2
16-Aug-06 rabss     rabss2
16-Aug-06 ssab      ssab2
13-Aug-06 fvco3     [--same--]  antecedent changed to use triple conjunction
13-Aug-06 fvco2     [--same--]  antecedent changed to use triple conjunction
 6-Jun-06 sq0       sq00
 1-Jun-06 infpn     infpn2
27-May-06 ---       ---         exp was changed to ex to prevent matching
27-May-06 ---       ---           math token 'exp'.
27-May-06 exp       ex
26-May-06 f1ocnvfvb [--same--]  antecedent changed to use triple conjunction
22-Apr-06 fvco      [--same--]  antecedent changed to use triple conjunction
10-Apr-06 plus1let  p1let
10-Apr-06 leplus1t  lep1t
10-Apr-06 ltplus1   ltp1
10-Apr-06 ltplus1t  ltp1t
29-Mar-06 xpdom2    [--same--]  eliminated the A e. _V hypothesis
29-Mar-06 xpdom1    [--same--]  eliminated the A e. _V hypothesis
28-Mar-06 sspr      [--same--]  eliminated both $e hypotheses
26-Mar-06 fnfvop    fnopfvb
26-Mar-06 fnfvbr    fnbrfvb
26-Mar-06 eqri      eqriv
26-Mar-06 eqrd      eqrdv
26-Mar-06 nn0z      nn0zrab
26-Mar-06 nnz       nnzrab
24-Mar-06 fodomb    [--same--]  eliminated the B e. _V hypothesis
24-Mar-06 eldmg     eldm2g
22-Mar-06 prprc     prprc1
22-Mar-06 sqrsqet   sqrsqt
22-Mar-06 sqrsqe    sqrsq
22-Mar-06 sqrsq     sqrmsq2
21-Mar-06 nn0le2sqet nn0le2msqt
21-Mar-06 le2sqet   le2sqt
21-Mar-06 le2sqt    le2msqt
21-Mar-06 lt2sqet   lt2sqt
21-Mar-06 lt2sqt    lt2msqt
21-Mar-06 le2sqe    le2sq
21-Mar-06 le2sq     le2msq
21-Mar-06 lt2sqe    lt2sq
21-Mar-06 lt2sq     lt2msq
21-Mar-06 ltsqt     ltmsqt
13-Mar-06 sq11t     [--same--]  rearranged antecedent
11-Mar-06 sqrecl    resqcl
11-Mar-06 sqreclt   resqclt
11-Mar-06 ---       ---         'sq' is normal square (A ^ 2)
11-Mar-06 sqe0      sqeq0
11-Mar-06 sqe11     sq11
11-Mar-06 sqegt0    sqgt0
11-Mar-06 sqege0    sqge0
11-Mar-06 sqe11t    sq11t
11-Mar-06 sqege0t   sqge0t
11-Mar-06 ---       ---         'msq' is square represented by mult. (A x. A)
11-Mar-06 sqeq0      msq0
11-Mar-06 sqgt0     msqgt0
11-Mar-06 sqge0     msqge0
11-Mar-06 sq11      msq11
11-Mar-06 sqznn     msqznn
11-Mar-06 sqrsqid   sqrmsq
11-Mar-06 sqeq0      msq0
24-Feb-06 lerect    [--same--]  rearranged antecedent
24-Feb-06 ltrect    [--same--]  rearranged antecedent
24-Feb-06 lt2sqet   [--same--]  rearranged antecedent
24-Feb-06 le2sqet   [--same--]  rearranged antecedent
24-Feb-06 lt2sqt    [--same--]  rearranged antecedent
24-Feb-06 le2sqt    [--same--]  rearranged antecedent
20-Feb-06 funfvopi  funopfv
20-Feb-06 funopfv   funfvop
20-Feb-06 funfvop   funopfvb
 9-Feb-06 divneq0bt divne0bt
 9-Feb-06 divneq0   divne0
 9-Feb-06 recneq0z  recne0z
 9-Feb-06 pm2.61an2 pm2.61dan
 9-Feb-06 pm2.61an1 pm2.61ian
28-Jan-06 cleqfvf   eqfnfvf
26-Jan-06 fri       [--same--]  changed to closed theorem instead of inference
17-Jan-06 relin     relin1
17-Jan-06 ssrelqqq  relss
17-Jan-06 relss     ssrel
17-Jan-06 ssrel     ssrelqqq
16-Jan-06 elrnqqq   elrn2
16-Jan-06 elrn2     elrn
16-Jan-06 elrn      elrnqqq
12-Jan-06 df-ef     [--same--]  revised to use new df-sum
 9-Jan-06 rabeqbi2i rabeq2i
 9-Jan-06 abeqbi2   abeq2
 9-Jan-06 abeqbi1   abeq1
 9-Jan-06 abeqbi2i  abeq2i
 9-Jan-06 abeqbi1i  abeq1i
 9-Jan-06 abeqbi2d  abeq2d
 9-Jan-06 abbieq2i  abbi2i
 9-Jan-06 abbieqi   abbii
 9-Jan-06 abbieqd   abbid
 9-Jan-06 abbieqdv  abbidv
 9-Jan-06 abbieq2dv abbi2dv
 9-Jan-06 abbieq1dv abbi1dv
 9-Jan-06 rabbieqi  rabbii
 9-Jan-06 rabbieqdv rabbidv
 9-Jan-06 rabbieqsdv rabbisdv
 9-Jan-06 rabbieqrdv rabbirdv
 9-Jan-06 opabbieqd opabbid
 9-Jan-06 opabbieqdv opabbidv
 9-Jan-06 oprabbieqd oprabbid
 9-Jan-06 oprabbieqdv oprabbidv
 9-Jan-06 oprabbieqi oprabbii
 9-Jan-06 abeqbi2   abeq2
 9-Jan-06 abeqbi2i  abeq2i
 9-Jan-06 abeqbi1   abeq1
 9-Jan-06 abeqbi2d  abeq2d
 9-Jan-06 abeqbi1i  abeq1i
 9-Jan-06 rabeqbi2i rabeq2i
 9-Jan-06 oprabbieqi oprabbii
 7-Jan-06 divgt0lem divgt0i2
 5-Jan-06 lep1t  letrp1t
 4-Jan-06 nnegdift  ---         obsolete; use subge0t (swapped biconditional)
 2-Jan-06 opabbii.2 opabbii
 1-Jan-06 negdi2    negsubdi
 1-Jan-06 negdi2t   negsubdit
 1-Jan-06 negdi3    negsubdi2t
 1-Jan-06 negdi3t   negsubdi2t
17-Dec-05 msca      ---         obsolete; now embedded inside equs4 proof
16-Dec-05 1expt     [--same--]  antecedent extended from NN to NN0
16-Dec-05 nnexpclt  [--same--]  antecedent extended from NN to NN0
16-Dec-05 nn0expclt [--same--]  antecedent extended from NN to NN0
16-Dec-05 zexpclt   [--same--]  antecedent extended from NN to NN0
16-Dec-05 qexpclt   [--same--]  antecedent extended from NN to NN0
16-Dec-05 reexpclt  [--same--]  antecedent extended from NN to NN0
16-Dec-05 expclt    [--same--]  antecedent extended from NN to NN0
16-Dec-05 expcllem  [--same--]  antecedent extended from NN to NN0; + 3rd hyp.
16-Dec-05 expp1t    [--same--]  antecedent extended from NN to NN0
16-Dec-05 expvalt   expnnvalt
13-Dec-05 sbcco     sbccog
 1-Dec-05 subneg2t  subnegt
 1-Dec-05 subnegt   ---         obsolete; use negsubt (swapped equality)
 1-Dec-05 subneg    ---         obsolete; use negsub (swapped equality)
 1-Dec-05 reueq     reueq1
 1-Dec-05 rexeq     rexeq1
 1-Dec-05 raleq     raleq1
 1-Dec-05 reueqf    reueq1f
 1-Dec-05 rexeqf    rexeq1f
 1-Dec-05 raleqf    raleq1f
 1-Dec-05 ad2antxx  ad2antrr
 1-Dec-05 ad2antrr  ad2antll
 1-Dec-05 ad2antll  ad2antxx
29-Nov-05 sbcel2    sbcel2gv
29-Nov-05 sbcel1    sbcel1gv
28-Nov-05 sbcn      sbcng
28-Nov-05 sbcim     sbcimg
28-Nov-05 sbcbi     sbcbidig
28-Nov-05 sbcor     sbcorg
28-Nov-05 sbcan     sbcang
28-Nov-05 sbcal     sbcalg
28-Nov-05 sbcex     sbcexg
28-Nov-05 sbceq1    sbceq1a
21-Nov-05 2o        2on
21-Nov-05 1o        1on
19-Nov-05 zfrep3    axrep5
19-Nov-05 zfrep2    axrep4
19-Nov-05 axrep     axrep2
18-Nov-05 hbsbcg    hbsbc1g
18-Nov-05 hbsbc     hbsbc1
18-Nov-05 hbsbcv    hbsbc1v
18-Nov-05 ---       ---         More changes to the bixx series below -
18-Nov-05 ---       ---         changed to xxbix to be analogous to the xxeqx
18-Nov-05 ---       ---         series e.g. uneq12d.  Also, the bi(r)abxx were
18-Nov-05 ---       ---         changed to (r)abbieqxx: "bi" in hyp. and
18-Nov-05 ---       ---         "eq" in conclusion.
18-Nov-05 bial      albii
18-Nov-05 bi2al     2albii
18-Nov-05 biex      exbii
18-Nov-05 bi2ex     2exbii
18-Nov-05 bi3ex     3exbi
18-Nov-05 biald     albid
18-Nov-05 biexd     exbid
18-Nov-05 bisb      sbbii
18-Nov-05 bisbd     sbbid
18-Nov-05 bialdv    albidv
18-Nov-05 biexdv    exbidv
18-Nov-05 bi2aldv   2albidv
18-Nov-05 bi2exdv   2exbidv
18-Nov-05 bi3exdv   3exbidv
18-Nov-05 bi4exdv   4exbidv
18-Nov-05 bieud     eubid
18-Nov-05 bieudv    eubidv
18-Nov-05 bieu      eubii
18-Nov-05 bimod     mobid
18-Nov-05 bimo      mobii
18-Nov-05 biralda   ralbida
18-Nov-05 birexda   rexbida
18-Nov-05 biraldva  ralbidva
18-Nov-05 birexdva  rexbidva
18-Nov-05 birald    ralbid
18-Nov-05 birexd    rexbid
18-Nov-05 biraldv   ralbidv
18-Nov-05 birexdv   rexbidv
18-Nov-05 biraldv2  ralbidv2
18-Nov-05 birexdv2  rexbidv2
18-Nov-05 biral     ralbii
18-Nov-05 birex     rexbii
18-Nov-05 bi2ral    2ralbii
18-Nov-05 bi2rex    2rexbii
18-Nov-05 biral2    ralbii2
18-Nov-05 birex2    rexbii2
18-Nov-05 birala    ralbiia
18-Nov-05 birexa    rexbiia
18-Nov-05 bi2rexa   2rexbiia
18-Nov-05 bi2ralda  2ralbida
18-Nov-05 bi2raldva 2ralbidva
18-Nov-05 bi2rexdva 2rexbidva
18-Nov-05 bireudva  reubidva
18-Nov-05 bireudv   reubidv
18-Nov-05 bireua    reubiia
18-Nov-05 bireu     reubii
18-Nov-05 bisbcdv   sbcbidv
18-Nov-05 bisbc     sbcbii
18-Nov-05 eqrabi    rabeqbi2i
18-Nov-05 eqab      abeqbi2
18-Nov-05 eqabr     abeqbi1
18-Nov-05 eqabi     abeqbi2i
18-Nov-05 eqabri    abeqbi1i
18-Nov-05 eqabd     abeqbi2d
18-Nov-05 biabri    abbieq2i
18-Nov-05 biabi     abbieqi
18-Nov-05 biabd     abbieqd
18-Nov-05 biabdv    abbieqdv
18-Nov-05 biabrdv   abbieq2dv
18-Nov-05 biabldv   abbieq1dv
18-Nov-05 birabi    rabbieqi
18-Nov-05 birabdv   rabbieqdv
18-Nov-05 birabsdv  rabbieqsdv
18-Nov-05 birabrdv  rabbieqrdv
18-Nov-05 biopabd   opabbieqd
18-Nov-05 biopabdv  opabbieqdv
18-Nov-05 bioprabd  oprabbieqd
18-Nov-05 bioprabdv oprabbieqdv
18-Nov-05 bioprabi  oprabbieqi
18-Nov-05 bicon1i   con1bii
18-Nov-05 bicon2i   con2bii
18-Nov-05 bicon4i   con4bii
18-Nov-05 bicon4d   con4bid
18-Nov-05 bicon2    con2bi
18-Nov-05 bicon2d   con2bid
18-Nov-05 bicon1d   con1bid
18-Nov-05 bisyl7    syl7ib
18-Nov-05 bisyl8    syl8ib
11-Nov-05 sbcbidv   [--same--]  swapped antecedents
21-Oct-05 ciin      [--same--]  "|^|" changed to "|^|_"
21-Oct-05 cuin      [--same--]  "U." changed to "U_"
21-Oct-05 ---SYMBOL CHANGE----  Changed "|^|" to "|^|_" in thm's using ciin
21-Oct-05 ---SYMBOL CHANGE----  Changed "U." to "U_" in thm's using ciun
20-Oct-05 rax5      ra5
20-Oct-05 rax4      ---         obsolete; use ra4sbc
20-Oct-05 reuuni2f  [--same--]  weakened its hypotheses
19-Oct-05 reuss     [--same--]  antecedent changed to use triple conjunction
10-Oct-05 uzwo      [--same--]  changed to use ZZ>= notation
10-Oct-05 uzwo2     [--same--]  changed to use ZZ>= notation
 1-Oct-05 nnncant   nnncan1t
13-Sep-05 leltnet   [--same--]  antecedent changed to use triple conjunction
10-Sep-05 ifel      ifcl
 6-Sep-05 dmopab2   dmopab3
 5-Sep-05 peano2uz  peano2uz2
 1-Sep-05 cleqfv    eqfnfv
 1-Sep-05 df-seq    df-seq1
 1-Sep-05 cseqz     cseq1
 1-Sep-05 serft     ser1ft
 1-Sep-05 serf      ser1f
 1-Sep-05 sercl     ser1cl
 1-Sep-05 serrecl   ser1recl
 1-Sep-05 serre     ser1re
 1-Sep-05 sercl2    ser1cl2
 1-Sep-05 serf2     ser1f2
 1-Sep-05 ser12     ser11
 1-Sep-05 sersuc2   ser1p1
 1-Sep-05 sermono   ser1mono
 1-Sep-05 seradd2   ser1add2
 1-Sep-05 seradd    ser1add
 1-Sep-05 serdir    ser1dir
 1-Sep-05 serabsdiflem ser1absdiflem
 1-Sep-05 serabsdif ser1absdif
 1-Sep-05 serre2    ser1re2
 1-Sep-05 sercj     ser1cj
 1-Sep-05 serconst  ser1const
 1-Sep-05 sertrunclem ser1trunclem
 1-Sep-05 sercmp    ser1cmp
 1-Sep-05 sercmp0   ser1cmp0
 1-Sep-05 sercmp2lem ser1cmp2lem
 1-Sep-05 sercmp2   ser1cmp2
 1-Sep-05 seqlem1   seq1lem1
 1-Sep-05 seqlem2   seq1lem2
 1-Sep-05 seqrval   seq1rval
 1-Sep-05 seqval    seq1val
 1-Sep-05 seqfnlem  seq1fnlem
 1-Sep-05 seqval2   seq1val2
 1-Sep-05 seq1lem   seq11lem
 1-Sep-05 seqsuclem seq1suclem
 1-Sep-05 seqp1     seq1p1
 1-Sep-05 seqm1     seq1m1
 1-Sep-05 seqfn     seq1fn
 1-Sep-05 seqrn     seq1rn2
 1-Sep-05 seqrn2    seq1rn
 1-Sep-05 seqcl     seq1cl
 1-Sep-05 seqres    seq1res
 1-Sep-05 seqbnd    seq1bnd
 1-Sep-05 sequblem  seq1ublem
 1-Sep-05 sequb     seq1ub
 1-Sep-05 seqhcau   seq1hcau
 1-Sep-05 ---SYMBOL CHANGE----  Changed math symbol 'seq' to 'seq1'
 1-Sep-05 seq1      seq11       Warning: change _before_ symbol change above
17-Aug-05 df-clim   [--same--]  The old df-clim, df-shft, and df-seq0, and
17-Aug-05 df-shft   [--same--]      all derived theorems, have been scrapped
17-Aug-05 df-seq0   [--same--]      or rederived from the new definitions.
30-Jul-05 ---       ---         syl* changes below were sugg'ed by Scott Fenton
30-Jul-05 syl34d    imim12d
30-Jul-05 syl4d     imim1d
30-Jul-05 syl3d     imim2d
30-Jul-05 syl34     imim112i
30-Jul-05 syl4      imim1i
30-Jul-05 syl3      imim2i
30-Jul-05 syl2      imim1
30-Jul-05 syl1      imim2
27-Jul-05 uzind     [--same--]  weaker basis hyp.; different mand. hyp. order
13-Jul-05 mp3an11   mp3anl1
13-Jul-05 mp3an12   mp3anl2
13-Jul-05 mp3an13   mp3anl3
13-Jul-05 syl3an11  syl3anl1
13-Jul-05 syl3an12  syl3anl2
13-Jul-05 syl3an13  syl3anl3
13-Jul-05 mpan11    mpanl1
13-Jul-05 mpan12    mpanl2
13-Jul-05 mpan21    mpanr1
13-Jul-05 mpan22    mpanr2
13-Jul-05 sylan11   sylanl1
13-Jul-05 sylan12   sylanl2
13-Jul-05 sylan21   sylanr1
13-Jul-05 sylan22   sylanr2
13-Jul-05 mpan121   mpanlr1
13-Jul-05 ecased    ---         obsolete; use ecase23d (diff. hyp. order)
11-Jul-05 lelt      lenlt
11-Jul-05 leltt     lenltt
11-Jul-05 lenltt    eqleltt
10-Jul-05 bcpasc    bcpasc2
10-Jul-05 bcvalt    bcval2t
 9-Jul-05 sermconst ---         obsolete; use ser1mulc
 9-Jul-05 seqsuc    seq1p1
 3-Jul-05 peano5c   ---         obsolete; use peano5nn (restr. qntfr.)
 3-Jul-05 df-n      [--same--]  shortened with restricted quantifier
 2-Jul-05 mulge0t   [--same--]  conjoined antecedents
 2-Jul-05 prodgt02t [--same--]  swapped A e. RR and B e. RR
27-Jun-05 syl3an    [--same--]  changed order of hypotheses
25-Jun-05 ecoprcom  [--same--]  changed order of $f hypotheses
21-Jun-05 nn0ltlem1 nn0ltlem1t
21-Jun-05 subsub    subsub23
17-Jun-05 ecoprdist ---         obsolete; use ecoprdi
16-Jun-05 binom     binom2
12-Jun-05 oel       orabs
30-May-05 ltdiv23t  [--same--]  conjoined antecedents
30-May-05 ledivt    lediv1t
23-May-05 rcla42v   [--same--]  swapped antecedents
23-May-05 rcla4v    [--same--]  swapped antecedents
23-May-05 rcla4     [--same--]  swapped antecedents
10-May-05 mpbiranr  mpbiran2
 8-May-05 funfv2    [--same--]  changed to A F y instead of <. A , y >. e. F
 8-May-05 imasn     ---         obsolete; use relimasn (A R y instead of o.p.)
 3-May-05 nndiv     nndivt
 2-May-05 subaddeq  pncan3
 2-May-05 subaddeqt pncan3t
 1-May-05 divne0bt  [--same--]  changed antecedent to triple conjunction
 1-May-05 divcan2t  [--same--]  changed antecedent to triple conjunction
 1-May-05 divcan1t  [--same--]  changed antecedent to triple conjunction
30-Apr-05 divnegt   [--same--]  changed antecedent to triple conjunction
30-Apr-05 divrect   [--same--]  changed antecedent to triple conjunction
30-Apr-05 divcan3t  [--same--]  changed antecedent to triple conjunction
30-Apr-05 divcan4t  [--same--]  changed antecedent to triple conjunction
29-Apr-05 crut      [--same--]  generalized -> to <->
29-Apr-05 cru       [--same--]  generalized -> to <->
29-Apr-05 isqm1     itimesi
29-Apr-05 crmult    crmul       changed hypotheses from real to complex
29-Apr-05 redivclt  [--same--]  changed antecedent to triple conjunction
29-Apr-05 divclt    [--same--]  changed antecedent to triple conjunction
28-Apr-05 ine0      [--same--]  changed -. and = to =/=
27-Apr-05 ltdivt    ltdiv1t
27-Apr-05 ltdiv     ltdiv1
27-Apr-05 ltdivi    ltdiv1i
24-Apr-05 prodgt0   [--same--]  strengthened 0 < A to 0 <_ A
24-Apr-05 prodgt0i  prodgt0lem
 7-Apr-05 equs2     ---         obsolete; use equs5
 7-Apr-05 equs1     ---         obsolete; use equs4
 6-Apr-05 absltt    [--same--]  swapped & contraposed conjunct with -u
 6-Apr-05 absle     [--same--]  swapped & contraposed conjunct with -u
 6-Apr-05 abslt     [--same--]  swapped & contraposed conjunct with -u
26-Mar-05 abscj     [--same--]  swapped arguments of = sign
18-Mar-05 reim0     reim0b
18-Mar-05 rere      rereb
18-Mar-05 cjre      cjreb
18-Mar-05 negre     negreb
11-Mar-05 frsuc     frsuc
10-Mar-05 nn0addge2 [--same--]  Generalized 1st hyp from NN0 to RR
10-Mar-05 nn0addge1 [--same--]  Generalized 1st hyp from NN0 to RR
 5-Mar-05 chv       chvarv
 5-Mar-05 chv2      chvar
 4-Mar-05 divdistr  divdir
 4-Mar-05 divdistrz divdirz
 4-Mar-05 divge0t   [--same--]  conjoined the two left-most antecedents
 4-Mar-05 divgt0t   [--same--]  conjoined the two left-most antecedents
 4-Mar-05 absgt0t   [--same--]  changed  -. A = 0  to  A =/= 0
 4-Mar-05 absgt0    [--same--]  changed  -. A = 0  to  A =/= 0
24-Feb-05 absidt    [--same--]  conjoined the two left-most antecedents
27-Feb-05 del34     ---         obsolete; use dral1 instead
27-Feb-05 del35     ---         obsolete; use dral1 instead
27-Feb-05 del34b    dral1
27-Feb-05 del36     ---         obsolete; use dral2 instead
27-Feb-05 del40     ---         obsolete; use drex1 instead
27-Feb-05 del41     ---         obsolete; use drex1 instead
27-Feb-05 del42     ---         obsolete; use drex2 instead
27-Feb-05 del43     ---         obsolete; use drsb1 instead
27-Feb-05 del43b    drsb1
27-Feb-05 del44     ---         obsolete; use drsb2 instead
27-Feb-05 del45     ---         obsolete; use drsb2 instead
27-Feb-05 ddelimf2  dvelimf2
27-Feb-05 ddelimf   dvelimf
27-Feb-05 ddelimdf  dvelimdf
27-Feb-05 ddelim    dvelim
27-Feb-05 ddeeq1    dveeq1
27-Feb-05 ddeeq2    dveeq2
27-Feb-05 ddeel1    dveel1
27-Feb-05 ddeel2    dveel2
24-Feb-05 bi3ord    3orbi123d
24-Feb-05 im3ord    3orim123d
24-Feb-05 bi3or     3orbi123i
24-Feb-05 bi3an     3anbi123i
24-Feb-05 bi3and    3anbi123d
24-Feb-05 im3an     3anim123i
24-Feb-05 divdistrt divdirt
24-Feb-05 ltdiv1t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 lediv1t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltmuldivt [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltdivmult [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltmuldiv2t [--same--]  conjoined the two left-most antecedents
24-Feb-05 gt0ne0t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltrect    [--same--]  conjoined the two left-most antecedents
24-Feb-05 recgt0t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 lerect    [--same--]  conjoined the two left-most antecedents
21-Feb-05 nn0ge0i   nn0ge0
21-Feb-05 rdgzer    rdg0
21-Feb-05 rdgzert   rdg0g
21-Feb-05 frzer     fr0g
21-Feb-05 mulzer1   mul01
21-Feb-05 mulzer2   mul02
21-Feb-05 mulzer1t  mul01t
21-Feb-05 mulzer2t  mul02t
21-Feb-05 divzer    div0
19-Feb-05 ax0re     0re
13-Feb-05 cardcard  cardidm
13-Feb-05 exp2t     sqvalt
13-Feb-05 uzind2    ---         Obsolete; use uzind3
 5-Feb-05 ---       ---         We will adopt "equ" (vs. old "eq") for
 5-Feb-05 ---       ---         set variable equality and "eq" (vs. old
 5-Feb-05 ---       ---         "cleq") for class equality.  (Remember it
 5-Feb-05 ---       ---         is important to do these in REVERSE order
 5-Feb-05 ---       ---         below!)
 5-Feb-05 cleqri    eqri
 5-Feb-05 cleqrd    eqrd
 5-Feb-05 cleqid    eqid
 5-Feb-05 cleqcom   eqcom
 5-Feb-05 cleqcomi  eqcomi
 5-Feb-05 cleqcomd  eqcomd
 5-Feb-05 cleq1     eqeq1
 5-Feb-05 cleq2     eqeq2
 5-Feb-05 cleq1i    eqeq1i
 5-Feb-05 cleq2i    eqeq2i
 5-Feb-05 cleq1d    eqeq1d
 5-Feb-05 cleq2d    eqeq2d
 5-Feb-05 cleq12    eqeq12
 5-Feb-05 cleq12i   eqeq12i
 5-Feb-05 cleq12d   eqeq12d
 5-Feb-05 cleqan12d eqeqan12d
 5-Feb-05 cleqan12rd eqeqan12rd
 5-Feb-05 cleqtr    eqtr
 5-Feb-05 cleq2tr   eq2tri
 5-Feb-05 cleqab    abeqbi2
 5-Feb-05 cleqabi   abeqbi2i
 5-Feb-05 cleqabr   abeqbi1
 5-Feb-05 cleqabd   abeqbi2d
 5-Feb-05 cleqabri  abeqbi1i
 5-Feb-05 cleq2ab   eq2ab
 5-Feb-05 cleqrabi  rabeqbi2i
 5-Feb-05 clneq     nelneq
 5-Feb-05 clneq2    nelneq2
 5-Feb-05 sbeq2     equsb2
 5-Feb-05 sbeq1     equsb1
 5-Feb-05 eqvin.l2  ---           obsolete; use equvin instead
 5-Feb-05 eqvin     equvin
 5-Feb-05 eqvin.l1  equvini
 5-Feb-05 eqsal     equsal
 5-Feb-05 eqsex     equsex
 5-Feb-05 eqs5      equs5
 5-Feb-05 eqs4      equs4
 5-Feb-05 eqs3      equs3
 5-Feb-05 eqs2      equs2
 5-Feb-05 eqs1      equs1
 5-Feb-05 eq6s      hbnaes
 5-Feb-05 eq6       hbnae
 5-Feb-05 eq5s      hbaes
 5-Feb-05 eq5       hbae
 5-Feb-05 eq4ds     nalequcoms
 5-Feb-05 eq4s      alequcoms
 5-Feb-05 eq4       ax-10
 5-Feb-05 a14b      elequ2
 5-Feb-05 a13b      elequ1
 5-Feb-05 eqt2b     equequ2
 5-Feb-05 a8b       equequ1
 5-Feb-05 eqt       equtr
 5-Feb-05 eqt2      equtrr
 5-Feb-05 eqan      equtr2
 5-Feb-05 eqcom     equcomi
 5-Feb-05 eqcomb    equcom
 5-Feb-05 eqcoms    equcoms
 5-Feb-05 eqid      equid
 3-Feb-05 sb5f1     sb6rf
21-Jan-05 mulcanxx  mulcant2
21-Jan-05 mulcant2  mulcant
21-Jan-05 mulcant   mulcanxx
10-Jan-05 add41r3   add42
10-Jan-05 caopr41r3 caopr42
10-Jan-05 an41r3s   an42s
10-Jan-05 an41r3    an42
 8-Jan-05 ---       ---         The imxx series was changed analogously
 8-Jan-05 ---       ---         to the bixx series change.
 8-Jan-05 im2an     anim12i
 8-Jan-05 imran     anim1i
 8-Jan-05 imlan     anim2i
 8-Jan-05 im2or     orim12i
 8-Jan-05 imror     orim1i
 8-Jan-05 imlor     orim2i
 8-Jan-05 im2and    anim12d
 8-Jan-05 imrand    anim1d
 8-Jan-05 imland    anim2d
 8-Jan-05 im2ord    orim12d
 8-Jan-05 imrord    orim1d
 8-Jan-05 imlord    orim2d
 8-Jan-05 ---       ---         The bixx series was changed to be analogous
 8-Jan-05 ---       ---         to the xxeqx series e.g. uneq12d.
 8-Jan-05 ---       ---         (Suggested by Raph Levien.)
 8-Jan-05 bi2and    anbi12d
 8-Jan-05 birand    anbi1d
 8-Jan-05 biland    anbi2d
 8-Jan-05 bi2imd    imbi12d
 8-Jan-05 birimd    imbi1d
 8-Jan-05 bilimd    imbi2d
 8-Jan-05 bi2ord    orbi12d
 8-Jan-05 birord    orbi1d
 8-Jan-05 bilord    orbi2d
 8-Jan-05 bi2bid    bibi12d
 8-Jan-05 birbid    bibi1d
 8-Jan-05 bilbid    bibi2d
 8-Jan-05 binegd    negbid
 8-Jan-05 bi2an     anbi12i
 8-Jan-05 biran     anbi1i
 8-Jan-05 bilan     anbi2i
 8-Jan-05 bi2im     imbi12i
 8-Jan-05 birim     imbi1i
 8-Jan-05 bilim     imbi2i
 8-Jan-05 bi2or     orbi12i
 8-Jan-05 biror     orbi1i
 8-Jan-05 bilor     orbi2i
 8-Jan-05 bi2bi     bibi12i
 8-Jan-05 birbi     bibi1i
 8-Jan-05 bilbi     bibi2i
 8-Jan-05 bineg     negbii
 3-Jan-05 pm5.41    imdi
 1-Jan-05 iundif    iundif2
 1-Jan-05 iindif    iindif2
 1-Jan-05 iunin     iunin2
 1-Jan-05 iinin     iinin2
 1-Jan-05 sylan13br sylancbr
 1-Jan-05 sylan13b  sylancb
 1-Jan-05 sylan13   sylanc
 1-Jan-05 syl13     sylc
26-Dec-04 0ne1o     ---         obsolete; use 1ne0
19-Dec-04 sbequ6    [--same--]  swapped biconditional order
19-Dec-04 sbequ5    [--same--]  swapped biconditional order
15-Dec-04 syl2and   syl2ani
15-Dec-04 sylan2d   sylan2i
15-Dec-04 syland    sylani
12-Dec-04 nnordex   nnaordex
12-Dec-04 nnwordex  nnawordex
12-Dec-04 mpand     mpdan
12-Dec-04 ontr      ontr1
 6-Dec-04 on0eqel   on0eqelt
30-Nov-04 exp2      sqvalt
30-Nov-04 1exp      1expt
30-Nov-04 0exp      0expt
30-Nov-04 exp1      exp1t
30-Nov-04 expp1     expp1t
18-Nov-04 divrclz   redivclz
18-Nov-04 divrclt   redivclt
18-Nov-04 subrclt   resubclt
18-Nov-04 negrclt   renegclt
18-Nov-04 mulrclt   remulclt
18-Nov-04 divrcl    redivcl
18-Nov-04 subrcl    resubcl
18-Nov-04 negrcl    renegcl
18-Nov-04 mulrcl    remulcl
18-Nov-04 addrcl    readdcl
18-Nov-04 ltdivmul  ---         obsolete; use ltmuldiv instead
18-Nov-04 ltdivmult ---         obsolete; use ltmuldivt instead (note: there
                                is a new ltdivmult that is unrelated)
18-Nov-04 distr2t   adddirt
18-Nov-04 distr2    adddir
18-Nov-04 distr     adddi
18-Nov-04 subdistr  subdir
17-Nov-04 nnrect    nnrecgt0t
17-Nov-04 posdif    [--same--]  swapped biconditional and variable order
15-Nov-04 negdistt3 negdi3t
15-Nov-04 negdistt2 negdi2t
15-Nov-04 negdistt  negdit
15-Nov-04 negdist3  negdi3
15-Nov-04 negdist2  negdi2
11-Nov-04 reuunis   reuuni2
11-Nov-04 reuuni    reuuni1
 9-Nov-04 zlelt1    zleltp1t
 9-Nov-04 zltle1    zltp1let
 7-Sep-04 arch      [--same--]  removed quantifier, changed set var. to class
 2-Nov-04 dfom2     dfom3
 2-Nov-04 dfom3     dfom4
29-Oct-04 df-ded    df-if
29-Oct-04 dedeq1    ifeq1
29-Oct-04 dedeq2    ifeq2
29-Oct-04 dedeq12   ifeq12
29-Oct-04 dedbi     ifbi
29-Oct-04 dedlem1   iftrue
29-Oct-04 dedlem2   iffalse
29-Oct-04 dedex     ifex
29-Oct-04 cded      cif
29-Oct-04 ---SYMBOL CHANGE----  Changed math symbol 'ded' to 'if'
28-Oct-04 cmulc     cmul
20-Oct-04 oprabex   oprabex2
14-Oct-04 nn0lelt1  nn0leltp1t
14-Oct-04 nn0ltle1  nn0ltp1let
14-Oct-04 nnlelt1   nnleltp1t
14-Oct-04 nnltle1   nnltp1let
14-Oct-04 rnoel3    rabn0
14-Oct-04 noel3     abn0
14-Oct-04 noel2     n0i
14-Oct-04 peano2c   peano2nn
12-Oct-04 supeu     supeui
12-Oct-04 supcl     supcli
12-Oct-04 supub     supubi
12-Oct-04 suplub    suplubi
12-Oct-04 supnub    supnubi
12-Oct-04 suprcl    suprcli
12-Oct-04 suprub    suprubi
12-Oct-04 pm4.12    con2bi
12-Oct-04 bicon4    con4bii
12-Oct-04 con2bi    con2bii
12-Oct-04 bicon1    con1bii
12-Oct-04 pm2.11    exmid
11-Oct-04 sbf1      ---         obsolete; use sbf instead
11-Oct-04 ceqsexg   ceqex
 9-Oct-04 fvco2     fvco3
 8-Oct-04 indif0    difdisj
 8-Oct-04 biopab    opabbii.2
 8-Oct-04 bioprab   oprabbieqi
 7-Oct-04 ssii      sselii
 6-Oct-04 op2nd     op2ndb
 6-Oct-04 op1st     op1stb
 3-Oct-04 ind       nnind
 3-Oct-04 sylan5    sylan2
 3-Oct-04 sylan5b   sylan2b
 3-Oct-04 sylan5br  sylan2br
 3-Oct-04 sylan5d   sylan2i
 3-Oct-04 zind      ---         obsolete; use uzind
30-Sep-04 fvop      funfvop
30-Sep-04 funfvop   funopfv
30-Sep-04 pm4.21    bicom
30-Sep-04 bicom     bicomi
30-Sep-04 entr      entri
30-Sep-04 sstr2qqq  sstr
30-Sep-04 sstr      sstr2
30-Sep-04 sstr2     sstr2qqq
29-Sep-04 xp0qqq    xp0r
29-Sep-04 xp0r      xp0
29-Sep-04 xp0       xp0qqq
28-Sep-04 xpdom     xpdom2      changed variable names
28-Sep-04 xpdom2    xpdom3
26-Sep-04 xpindi    inxp
26-Sep-04 xpun1     xpundi
26-Sep-04 xpun2     xpundir
25-Sep-04 entr      entrt
23-Sep-04 ssfnres   ---         obsolete; use fnssres instead
23-Sep-04 resun     resundi
21-Sep-04 f11       [--same--]  changed o.p. membership to binary relation
21-Sep-04 unisuc    [--same--]  swapped arguments of = sign
21-Sep-04 onunisuc  [--same--]  swapped arguments of = sign
21-Sep-04 undif3    ---         obsolete; use undif
21-Sep-04 ssequn2   [--same--]  swapped arguments of = sign
21-Sep-04 sseqin2   [--same--]  swapped arguments of = sign
21-Sep-04 onelun    [--same--]  swapped arguments of = sign
21-Sep-04 dfss4     [--same--]  swapped arguments of = sign
21-Sep-04 ordunisuc ordunisssuc
21-Sep-04 ssfun     funss
15-Sep-04 19.6      alex
15-Sep-04 alex      alexeq
15-Sep-04 19.11     excom
15-Sep-04 19.11a    excomim
15-Sep-04 19.5      alcom
15-Sep-04 19.7      alnex
15-Sep-04 19.14     exnal
15-Sep-04 alnex     alinexa
15-Sep-04 exnal     exanali
15-Sep-04 dmsn      dmsnop
15-Sep-04 rnsn      rnsnop
13-Sep-04 ppnull    pwpw0
13-Sep-04 pwnull    pw0
13-Sep-04 zfnull2   zfnul
13-Sep-04 nullpss   0pss
13-Sep-04 nullss    0ss
13-Sep-04 nulleq    eq0
13-Sep-04 nnull     n0
13-Sep-04 nnullf    n0f
13-Sep-04 xpdisj    xpsndisj
13-Sep-04 subdist   subdi
13-Sep-04 negdist   negdi
13-Sep-04 nndist    nndi
13-Sep-04 xpindist  inxp
11-Sep-04 ssd       sseld
11-Sep-04 ssi       sseli
11-Sep-04 vtoclab   elab2
11-Sep-04 vtoclabg  elab2g
11-Sep-04 elab2g    elab3g
 6-Sep-04 comm      com12
 4-Sep-04 opabval   fvopab3
 4-Sep-04 opabvalig fvopab3ig
 4-Sep-04 opabval2g fvopab4g
 4-Sep-04 opabval2  fvopab4
 3-Sep-04 undif2    difun2
 1-Sep-04 dedlem2   [--same--]  swapped arguments of = sign
 1-Sep-04 dedlem1   [--same--]  swapped arguments of = sign
31-Aug-04 pm2.16d   con3d
31-Aug-04 pm2.03d   con2d
31-Aug-04 pm2.15d   con1d
31-Aug-04 pm2.16    con3
31-Aug-04 pm2.03    con2
31-Aug-04 pm2.15    con1
31-Aug-04 con3      con3i
31-Aug-04 con2      con2i
31-Aug-04 con1      con1i
29-Aug-04 oprabelrn elrnoprab
27-Aug-04 ssequn1   [--same--]  swapped arguments of = sign
27-Aug-04 df-ss     dfss
27-Aug-04 imdistanb ---         obsolete; use imdistan
27-Aug-04 imdistan  [--same--]  now includes converse
17-Aug-04 difun2    [--same--]  swapped arguments of = sign
17-Aug-04 undif1    [--same--]  swapped arguments of = sign and union
17-Aug-04 difin     [--same--]  swapped arguments of = sign
17-Aug-04 unindistr undir
17-Aug-04 unindist  undi
17-Aug-04 inundistr indir
17-Aug-04 inundist  indi
17-Aug-04 indist    inindi
16-Aug-04 ss2un     unss12      order of variables changed
15-Aug-04 funmo,dffunmof,dffunmo
                    [--same--]  ordered pair membership -> binary relation
15-Aug-04 dfrel2    [--same--]  swapped arguments of = sign
12-Aug-04 unxp      xpundir
11-Aug-04 elima2    elima3
11-Aug-04 reluni    [--same--]  restricted quantifier and added converse
 9-Aug-04 imun      imaun
 3-Aug-04 1id       om1
 3-Aug-04 oalim     [--same--]  conjoined antecedents; now uses indexed union
 3-Aug-04 divdiv23  divdiv23z
 3-Aug-04 divdiv23i divdiv23
 2-Aug-04 divrec,divrecz [--same--] swapped A and B
 2-Aug-04 zq        zqt
 2-Aug-04 qre       qret
 1-Aug-04 mulcant  [--same--]  swapped conjunct in antecedent
 1-Aug-04 axrecex,axrrecex,divclt,divcan1t,divcan2t,recidt,divdistrt,divrclt
                    [--same--]  conjoined the two left-most antecedents
 1-Aug-04 peano1c   1nn
 1-Aug-04 1nn       1onn
28-Jul-04 sbco0     sbid2
28-Jul-04 sbid2     sbid2v
26-Jul-04 cardonval oncardval
15-Jun-04 ssin      [--same--]  swapped biconditional order
15-Jun-04 unss      [--same--]  swapped biconditional order
11-Jun-04 dfun2     df-un
11-Jun-04 df-un     dfun2
11-Jun-04 dfin2     df-in
11-Jun-04 df-in     dfin2
 3-Jun-04 ssintss   intss
 3-Jun-04 intss     intss1
30-May-04 r1clos    r1pwcl      now uses antecedent instead of hypothesis
30-May-04 r1powt    r1pw
28-May-04 sqvalt    ---         obsolete; use exp2
28-May-04 expntwo   exp2
28-May-04 expnone   ---         obsolete; use expp1t
28-May-04 expnsuc   ---         obsolete; use expp1t
28-May-04 expnzer   ---         obsolete; use exp0t
26-May-04 ontrt     ---         obsolete; use onelon instead
26-May-04 ddelim*   [--same--]  (*=wildcard) changed order of hypotheses
21-May-04 fvcnvb    f1ocnvfvb
21-May-04 fvcnv     f1ocnvfv
21-May-04 sbcb      sbcbidig    now uses antecedent instead of hypothesis
21-May-04 sbci      sbcimg
21-May-04 sbb       sbbi
21-May-04 sbo       sbor
21-May-04 sbi       sbim
21-May-04 sbim      sbimi
21-May-04 sba       sban
21-May-04 fvelrn    [--same--]  changed to restricted quantifier
 8-Feb-04 zfpowb    pwexb
 8-Feb-04 zfpowcl   pwex
 8-Feb-04 zfnull    0ex
 8-Feb-04 limelon   [--same--]  changed first -> to /\ in antecedent


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           2. Finding shorter proofs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

I like shorter proofs, and any shorter proof I accept will be acknowledged.

Usually I will automatically accept shorter proofs that (1) shorten the set.mm
file (with compressed proofs), (2) reduce the size of the HTML file generated
with SHOW STATEMENT xx / HTML, (3) use only existing, unmodified theorems in
the database (the order of theorems may be changed though), (4) use no
additional axioms, and (5) involve none of the special cases listed below.

Usually I will also automatically accept a _new_ theorem that is used to
shorten multiple proofs, if the total size of set.mm (including the comment of
the new theorem) decreases as a result.

In borderline cases, I may choose to look primarily at the number of compressed
proof steps with less weight on the length of the label section (since the
names are in principal arbitrary).  If two proofs have the same number of
compressed proof steps, I will typically give preference to the one with the
smaller number of different labels, or if these are the same, the proof with
the fewest number of characters that the proofs happen to have by chance when
label lengths are included.

The remainder of this section lists theorems that purposely do not have
shortest proofs for various reasons.  It is primarily a reminder to myself and
normally you don't have to worry about it.  In the list, theorem names are
surrounded by whitespace to facilitate future label changes.

The proofs of id1 , snex , sbth , ordon , ltso and several other theorems (in
particular ones avoiding ax-reg and ax-ac ) could be made shorter but are
longer to illustrate specific points or to avoid specific axioms.

The following proofs should not be MINIMIZE_WITH'ed in the Proof Assistant,
since they are for illustrative purposes, have proofs that avoid certain
axioms, or involve areas I want to rework in the future.

   " id1 " using anything
   " dfbi1gb " using anything
   " con3th " using " con3 "
   " merlem1 " through " ax3 " using anything
   " ax4-* " using " ax-4 "
   " ax6-* " using " ax-6o "
   " ax7-* " using " ax-7 "
   " hbequid2 " using " equid "
   " dvelimf " using " dvelimfALT "
   anything using " om0x " (i.e. don't use om0x - use om0 instead)
   " dtruALT " , " dtru " , " ax16 " using anything
   " pwpw0 " using " pwsn "
   " omex " using " inf3 "
   " pjpji " using " pjpj0i "
   " pjomli " using " omlsi "
   " pjococi " using " omlsii "
   " pjococi " using " ococi "
   " pjpjth " using " pjth "
   " pjpjthi " using " pjthi "

In set theory, don't use equequ1 , equequ2 , elequ1 , elequ2 - use the set
theory versions eqeq1 , eqeq2 , eleq1 , eleq2 instead.

Don't use ax17eq or ax17el - use ax-17 instead.

Don't use elirr if efrirr , ordirr , or onirr can be used (to avoid the Axiom
of Regularity when it is not needed).

Always use weq, wel, wsb instead of wceq, wcel, wsbc in predicate calculus.
The opposite applies to set theory.  If e.g. weq is accidentally used in set
theory, "minimize_with wceq / allow_growth" in the Proof Assistant will replace
it with wceq.

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             3. Bibliography
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Bibliographical references are made by bracketing an identifer in a theorem's
comment, such as [RussellWhitehead].  These refer to HTML tags on the following
web pages:

  Logic and set theory - see http://us.metamath.org/mpegif/mmset.html#bib
  Hilbert space - see http://us.metamath.org/mpegif/mmhil.html#ref


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                           4. Quick "How To"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

How to use this file under Windows 95/98/NT/2K/XP/Vista:

1. Download the program metamath.exe per the instructions on the
   Metamath home page (http://us.metamath.org) and put it in the same
   directory as this file (set.mm).
2. In Windows Explorer, double-click on metamath.exe.
3. Type "read set.mm" and press Enter.
4. Type "help" for a list of help topics, and "help demo" for some
   command examples.


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      5. Metamath syntax summary
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

The HELP LANGUAGE command in the Metamath program will give you a quick
overview of Metamath.  Syntax summary:

          $c ... $. - Constant declaration
          $v ... $. - Variable declaration
          $d ... $. - Disjoint (distinct) variable restriction
  <label> $f ... $. - "Floating" hypothesis (i.e. variable type declaration)
  <label> $e ... $. - "Essential" hypothesis (i.e. a logical assumption for a
                      theorem or axiom)
  <label> $a ... $. - Axiom or definition or syntax construction
  <label> $p ... $= ... $. - Theorem and its proof
          ${ ... $} - Block for defining the scope of the above statements
                      (except $a, $p which are forever active)
$)        $( ... $)
$(                  - Comments (may not be nested); see HELP LANGUAGE
                      for markup features
          $[ ... $] - Include a file

The above two-character sequences beginning with "$" are the only primitives
built into the Metamath language.  The only "logic" Metamath uses in its proof
verification algorithm is the substitution of expressions for variables while
checking for distinct variable violations.  Everything else, including the
axioms for logic, is defined in this database file.

Here is some more detail about the syntax.  There are two kinds of user-defined
syntax elements, called math symbols (or just symbols) and labels.  A symbol
may contain any non-whitespace printable character except "$".  A label may
contain only alphanumeric characters and the characters "."  (period), "-"
(hyphen), and "_" (underscore).  Tokens and labels are case-sensitive.  All
labels (except in proofs) must be distinct.  A label may not have the same name
as a token (to simplify the coding of certain parsers and translators).

  $c <symbollist> $.
      <symbollist> is a (whitespace-separated) list of distinct symbols that
      haven't been used before.
  $v <symbollist> $.
      <symbollist> is a list of distinct symbols that haven't been used yet
      in the current scope (see ${ ... $} below).
  $d <symbollist> $.
      <symbollist> is a (whitespace-separated) list of distinct symbols
      previously declared with $v in current scope.  It means that
      substitutions into these symbols may not have variables in common.
  <label> $f <symbollist> $.
      <symbollist> is a list of 2 symbols, the first of which must be
      previously declared with $c in the current scope.
  <label> $e <symbollist> $.
      <symbollist> is a list of 2 or more symbols, the first of which must be
      previously declared with $c in the current scope.
  <label> $a <symbollist> $.
      <symbollist> is a list of 2 or more symbols, the first of which must be
      previously declared with $c in the current scope.
  <label> $p <symbollist> $= <proof> $.
      <symbollist> is a list of 2 or more symbols, the first of which must be
      previously declared with $c in the current scope.  <proof> is either a
      whitespace-delimited sequence of previous labels (created by
      SAVE PROOF <label> /NORMAL) or a compressed proof (created by
      SAVE PROOF <label> /COMPRESSED).  After using SAVE PROOF, use
      WRITE SOURCE to save the database file to disk.
  ${ ... $}
      Block for scoping the above statements (except $a, $p which are forever
      active).  Currently, $c may not occur inside of a block.
$)
  $( <any text> $)
$(    Comment.  Note: <any text> may not contain adjacent "$" and ")"
      characters.
  $[ <filename> $]
      Insert contents of <filename> at this point.  If <filename> is current
      file or has been already been inserted, it will not be inserted again.

Inside of comments, it is recommended that labels be preceded with a tilde (~)
and math symbol tokens be enclosed in grave accents (` `).  This way the LaTeX
and HTML rendition of comments will be accurate, and (future) tools to globally
change labels and math symbols will also change them in comments.  Note that ``
inside of grave accents is interpreted as a single ` .  A special comment
containing $ t defines LaTeX and HTML symbols.  See HELP LANGUAGE and
HELP HTML for other markup features in comments.

The proofs in this file are in "compressed" format for storage efficiency.  The
Metamath program reads the compressed format directly.  This format is
described in an Appendix of the Metamath book.  It is not intended to be read
by humans.  For viewing proofs you should use the various SHOW PROOF commands
described in the Metamath book (or the on-line HELP).

The Metamath program does not normally affect any content of this file (set.mm)
other than proofs, i.e. tokens between "$=" and "$.".  All other content is
user-created.  Proofs are created or modified with the PROVE command.


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          6. Other notes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

1. It is recommended that you be familiar with chapters 2 and 4 of the
'Metamath' book to understand the Metamath language.  Chapters 2, 3 and 5
explain how to use the program.  Chapter 3 gives you an informal overview of
what this source file is all about.  Appendix A shows you the standard
mathematical symbols corresponding to some of the ASCII tokens in this file.

The ASCII tokens may seem cryptic at first, even if you are familiar with set
theory, but a review of the definition summary in Chapter 3 should quickly
enable you to see the correspondence to standard mathematical notation.  To
easily find the definition of a token, search for the first occurrences of the
token surrounded by spaces.  Some odd-looking ones include "-." for "not", and
"=(" for "is a subset of."  (HELP TEX tells you how to obtain a LaTeX output to
see the real mathematical symbols.)  Let me know if you have better suggestions
for naming ASCII tokens.

2. Logic and set theory provide a foundation for all of mathematics.  To learn
about them, you should study one or more of the references listed below.  The
textbooks provide a motivation for what we are doing, whereas Metamath lets you
see in detail all hidden and implicit steps.  Most standard theorems are
accompanied by citations.  Some closely followed texts include the following:

  Axioms of propositional calculus - [Margaris].
  Axioms of predicate calculus - [Megill] (System S3' in the article
      referenced).
  Theorems of propositional calculus - [WhiteheadRussell].
  Theorems of pure predicate calculus - [Margaris].
  Theorems of equality and substitution - [Monk2], [Tarski], [Megill].
  Axioms of set theory - [BellMachover].
  Development of set theory - [TakeutiZaring].  (The first part of [Quine]
      has a good explanation of the powerful device of "virtual" or
      class abstractions, which is essential to our development.)
  Construction of real and complex numbers - [Gleason]
  Theorems about real numbers - [Apostol]

3. Convention:  All $a statements starting with "|-" have labels starting with
"ax-" (axioms) or "df-" (definitions).  "ax-" corresponds to what is
traditionally called an axiom.  "df-" introduces new symbols or a new
relationship among symbols that can be eliminated; they always extend the
definition of a wff or class.  Metamath blindly treats $a statements as new
facts but does not try to justify them; their justification is the job of
mathematicians and philosophers.  Generally our philosophy is to make
definitions easy to eliminate using simple symbol substitutions.

4. Our method of definition, the axioms for predicate calculus, and the
development of substitution are somewhat different from those found in standard
texts.  The axioms were designed for direct derivation of standard results
without excessive use of metatheorems.  (See Theorem 9.7 of [Megill] for a
rigorous justification.)  Typically we are minimalist when introducing new
definitions; they are introduced only when a clear advantage becomes apparent
for reducing the number of symbols, shortening proofs, etc.  We generally avoid
the introduction of gratuitous definitions because each one requires associated
theorems and additional elimination steps in proofs.

5. Where possible, the notation attempts to conform to modern conventions, with
variations due to our choice of the axiom system or to make proofs shorter.
Listed below are some important conventions and how they correspond to textbook
language.  The notation is usually explained in more detail when first
introduced.

  Typically, Greek letters (ph = phi, ps = psi, ch = chi, etc.) are used for
      propositional (wff) variables; x,y,z,... for individual (i.e. set)
      variables; and A,B,C,... for class variables.
  "|-", meaning "It is provable that," is the first token of all assertions
      and hypotheses that aren't syntax constructions.  This is a standard
      convention in logic.  For us, it also prevents any ambiguity with
      statements that are syntax constructions, such as "wff -. ph".
  "$e |- ( ph -> A. x ph ) $." should be read "Assume variable x is
      (effectively) not free in wff phi."  Literally, this says "Assume it is
      provable that phi implies for all x phi."
  "|- ( -. A. x x = y -> ..." should be read "If x and y are distinct
      variables, then..."  This antecedent provides us with a technical
      device (called a "distinctor" in [Megill]) to avoid the need for the
      $d statement early in our development of predicate calculus, permitting
      unrestricted substitituions as conceptually simple as those in
      propositional calculus.  However, the $d eventually becomes a
      requirement, and after that this device is rarely used.
  "[ y / x ] ph" should be read "the wff that results when y is properly
      substituted for x in ph."
  "$d x y $." should be read "Assume x and y are distinct variables."
  "$d x ph $." should be read "Assume x does not occur in phi $."  Sometimes
      a theorem is proved with "$e |- ( ph -> A. x ph ) $." in place of
      "$d x ph $." when a more general result is desired; ~ ax-17 can be used
      to derive the $d version.  For an example of how to get from the $d
      version back to the $e version, see the proof of ~ euf from ~ df-eu .
  "$d x A $." should be read "Assume x is not a variable occurring in class A."
  "$d x A $.  $d x ps $.  $e |- ( x = A -> ( ph <-> ps ) ) $." is an idiom
      often used instead of explicit substitution, meaning "Assume psi results
      from the substitution of A for x in phi."
  "$e |- A e. _V $." should be read "Assume class A is a set (i.e. exists)."
      This is a convenient convention used by [Quine].
  "$d x y $.  $e |- y e. A -> A. x y e. A $." should be read "Assume x is
      (effectively) not a free variable in class A."
  "`' R" should be read "converse of (relation) R" and is the same as the more
      standard notation R^{-1}.
  "( f ` x )" should be read "the value of function f at x" and is the same as
      the more familiar f(x).
  The Deduction Theorem of standard logic is never used.  Instead, in set
      theory, we use other tricks to make a $e hypothesis become an antecedent.
      See the comment for theorem ~ dedth below.

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Pre-logic
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $( Declare the primitive constant symbols for propositional calculus. $)
  $c ( $.  $( Left parenthesis $)
  $c ) $.  $( Right parenthesis $)
  $c -> $. $( Right arrow (read:  "implies") $)
  $c -. $. $( Right handle (read:  "not") $)
  $c wff $. $( Well-formed formula symbol (read:  "the following symbol
               sequence is a wff") $)
  $c |- $. $( Turnstile (read:  "the following symbol sequence is provable" or
              'a proof exists for") $)

  $( Introduce some variable names we will use to represent well-formed
     formulas (wff's). $)
  $v ph $. $( Greek phi $)
  $v ps $.  $( Greek psi $)
  $v ch $.  $( Greek chi $)
  $v th $.  $( Greek theta $)
  $v ta $.  $( Greek tau $)

  $( Specify some variables that we will use to represent wff's.
     The fact that a variable represents a wff is relevant only to a theorem
     referring to that variable, so we may use $f hypotheses.  The symbol
     ` wff ` specifies that the variable that follows it represents a wff. $)
  $( Let variable ` ph ` be a wff. $)
  wph $f wff ph $.
  $( Let variable ` ps ` be a wff. $)
  wps $f wff ps $.
  $( Let variable ` ch ` be a wff. $)
  wch $f wff ch $.
  $( Let variable ` th ` be a wff. $)
  wth $f wff th $.
  $( Let variable ` ta ` be a wff. $)
  wta $f wff ta $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Propositional calculus
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Recursively define primitive wffs for propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( If ` ph ` is a wff, so is ` -. ph ` or "not ` ph ` ."  Part of the
     recursive definition of a wff (well-formed formula).  In classical logic
     (which is our logic), a wff is interpreted as either true or false.
     So if ` ph ` is true, then ` -. ph ` is false; if ` ph ` is false, then
     ` -. ph ` is true.  Traditionally, Greek letters are used to represent
     wffs, and we follow this convention.  In propositional calculus, we define
     only wffs built up from other wffs, i.e. there is no starting or "atomic"
     wff.  Later, in predicate calculus, we will extend the basic wff
     definition by including atomic wffs ( ~ weq and ~ wel ). $)
  wn $a wff -. ph $.

  $( If ` ph ` and ` ps ` are wff's, so is ` ( ph -> ps ) ` or " ` ph ` implies
     ` ps ` ."  Part of the recursive definition of a wff.  The resulting wff
     is (interpreted as) false when ` ph ` is true and ` ps ` is false; it is
     true otherwise.  (Think of the truth table for an OR gate with input
     ` ph ` connected through an inverter.)  The left-hand wff is called the
     antecedent, and the right-hand wff is called the consequent.  In the case
     of ` ( ph -> ( ps -> ch ) ) ` , the middle ` ps ` may be informally called
     either an antecedent or part of the consequent depending on context. $)
  wi $a wff ( ph -> ps ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The axioms of propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $(
     Postulate the three axioms of classical propositional calculus.
  $)

  $( Axiom _Simp_.  Axiom A1 of [Margaris] p. 49.  One of the 3 axioms of
     propositional calculus.  The 3 axioms are also given as Definition 2.1
     of [Hamilton] p. 28.  This axiom is called _Simp_ or "the principle of
     simplification" in _Principia Mathematica_ (Theorem *2.02 of
     [WhiteheadRussell] p. 100) because "it enables us to pass from the joint
     assertion of ` ph ` and ` ps ` to the assertion of ` ph ` simply."

     _General remarks_:  Propositional calculus (axioms ~ ax-1 through ~ ax-3
     and rule ~ ax-mp ) can be thought of as asserting formulas that are
     universally "true" when their variables are replaced by any combination
     of "true" and "false."  Propositional calculus was first formalized by
     Frege in 1879, using as his axioms (in addition to rule ~ ax-mp ) the
     wffs ~ ax-1 , ~ ax-2 , ~ pm2.04 , ~ con3 , ~ notnot2 , and ~ notnot1 .
     Around 1930, Lukasiewicz simplified the system by eliminating the third
     (which follows from the first two, as you can see by looking at the proof
     of ~ pm2.04 ) and replacing the last three with our ~ ax-3 .  (Thanks to
     Ted Ulrich for this information.)

     The theorems of propositional calculus are also called _tautologies_.
     Tautologies can be proved very simply using truth tables, based on the
     true/false interpretation of propositional calculus.  To do this, we
     assign all possible combinations of true and false to the wff variables
     and verify that the result (using the rules described in ~ wi and ~ wn )
     always evaluates to true.  This is called the _semantic_ approach.  Our
     approach is called the _syntactic_ approach, in which everything is
     derived from axioms.  A metatheorem called the Completeness Theorem for
     Propositional Calculus shows that the two approaches are equivalent and
     even provides an algorithm for automatically generating syntactic proofs
     from a truth table.  Those proofs, however, tend to be long, and the
     much shorter proofs that we show here were found manually.  Truth tables
     grow exponentially with the number of variables, but it is unknown if the
     same is true of proofs - an answer to this would resolve the P=NP
     conjecture in complexity theory. $)
  ax-1 $a |- ( ph -> ( ps -> ph ) ) $.
  $( [ ?] $) $( [ ?] $)

  $( Axiom _Frege_.  Axiom A2 of [Margaris] p. 49.  One of the 3 axioms of
     propositional calculus.  It "distributes" an antecedent over two
     consequents.  This axiom was part of Frege's original system and is known
     as _Frege_ in the literature.  It is also proved as Theorem *2.77 of
     [WhiteheadRussell] p. 108.  The other direction of this axiom also
     turns out to be true, as demonstrated by ~ pm5.41 . $)
  ax-2 $a |- ( ( ph -> ( ps -> ch ) ) -> ( ( ph -> ps ) -> ( ph -> ch ) ) ) $.

  $( Axiom _Transp_.  Axiom A3 of [Margaris] p. 49.  One of the 3 axioms of
     propositional calculus.  It swaps or "transposes" the order of the
     consequents when negation is removed.  An informal example is that the
     statement "if there are no clouds in the sky, it is not raining" implies
     the statement "if it is raining, there are clouds in the sky."  This
     axiom is called _Transp_ or "the principle of transposition" in
     _Principia Mathematica_ (Theorem *2.17 of [WhiteheadRussell] p. 103).
     We will also use the term "contraposition" for this principle, although
     the reader is advised that in the field of philosophical logic,
     "contraposition" has a different technical meaning. $)
  ax-3 $a |- ( ( -. ph -> -. ps ) -> ( ps -> ph ) ) $.

  $(
     Postulate the modus ponens rule of inference.
  $)

  ${
    $( Minor premise for modus ponens. $)
    min $e |- ph $.
    $( Major premise for modus ponens. $)
    maj $e |- ( ph -> ps ) $.
    $( Rule of Modus Ponens.  The postulated inference rule of propositional
       calculus.  See e.g. Rule 1 of [Hamilton] p. 73.  The rule says, "if
       ` ph ` is true, and ` ph ` implies ` ps ` , then ` ps ` must also be
       true."  This rule is sometimes called "detachment," since it detaches
       the minor premise from the major premise.

       Note:  In some web page displays such as the Statement List, the symbols
       "&" and "=>" informally indicate the relationship between the hypotheses
       and the assertion (conclusion), abbreviating the English words "and" and
       "implies."  They are not part of the formal language. $)
    ax-mp $a |- ps $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical implication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$( The results in this section make use of the first 2 axioms only.  In
   an implication, the wff before the arrow is called the "antecedent"
   and the wff after the arrow is called the "consequent." $)

$( We will use the following descriptive terms very loosely:  A "theorem"
   usually has no $e hypotheses.  An "inference" has one or more $e hypotheses.
   A "deduction" is an inference in which the hypotheses and the result
   share the same antecedent. $)

  ${
    $( Premise for ~ a1i . $)
    a1i.1 $e |- ph $.
    $( Inference derived from axiom ~ ax-1 .  See ~ a1d for an explanation of
       our informal use of the terms "inference" and "deduction."  See also
       the comment in ~ syld . $)
    a1i $p |- ( ps -> ph ) $=
      wph wps wph wi a1i.1 wph wps ax-1 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    a1i12.1 $e |- ch $.
    $( Add two antecedents to a wff.  (Contributed by Jeff Hankins,
       4-Aug-2009.) $)
    a1i12 $p |- ( ph -> ( ps -> ch ) ) $=
      wps wch wi wph wch wps a1i12.1 a1i a1i $.
      $( [18-Apr-2010] $) $( [4-Aug-2009] $)
  $}

  ${
    $( Premise for ~ a2i . $)
    a2i.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference derived from axiom ~ ax-2 . $)
    a2i $p |- ( ( ph -> ps ) -> ( ph -> ch ) ) $=
      wph wps wch wi wi wph wps wi wph wch wi wi a2i.1 wph wps wch ax-2 ax-mp
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    $( First of 2 premises for ~ syl . $)
    syl.1 $e |- ( ph -> ps ) $.
    $( Second of 2 premises for ~ syl . $)
    syl.2 $e |- ( ps -> ch ) $.
    $( An inference version of the transitive laws for implication ~ imim2 and
       ~ imim1 , which Russell and Whitehead call "the principle of the
       syllogism...because...the syllogism in Barbara is derived from them"
       (quote after Theorem *2.06 of [WhiteheadRussell] p. 101).  Some authors
       call this law a "hypothetical syllogism."

       (A bit of trivia:  this is the most commonly referenced assertion in our
       database.  In second place is ~ ax-mp , followed by ~ visset , ~ bitri ,
       ~ imp , and ~ ex .  The Metamath program command 'show usage' shows the
       number of references.) $)
    syl $p |- ( ph -> ch ) $=
      wph wps wi wph wch wi syl.1 wph wps wch wps wch wi wph syl.2 a1i a2i
      ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    $( Premise for ~ com12 .  See ~ pm2.04 for the theorem form. $)
    com12.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference that swaps (commutes) antecedents in an implication. $)
    com12 $p |- ( ps -> ( ph -> ch ) ) $=
      wps wph wps wi wph wch wi wps wph ax-1 wph wps wch com12.1 a2i syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    a1d.1 $e |- ( ph -> ps ) $.
    $( Deduction introducing an embedded antecedent.  (The proof was revised by
       Stefan Allan, 20-Mar-2006.)

       _Naming convention_:  We often call a theorem a "deduction" and suffix
       its label with "d" whenever the hypotheses and conclusion are each
       prefixed with the same antecedent.  This allows us to use the theorem in
       places where (in traditional textbook formalizations) the standard
       Deduction Theorem would be used; here ` ph ` would be replaced with a
       conjunction ( ~ df-an ) of the hypotheses of the would-be deduction.  By
       contrast, we tend to call the simpler version with no common antecedent
       an "inference" and suffix its label with "i"; compare theorem ~ a1i .
       Finally, a "theorem" would be the form with no hypotheses; in this case
       the "theorem" form would be the original axiom ~ ax-1 .  We usually show
       the theorem form without a suffix on its label (e.g. ~ pm2.43 vs.
       ~ pm2.43i vs. ~ pm2.43d ).  When an inference is converted to a theorem
       by eliminating an "is a set" hypothesis, we sometimes suffix the theorem
       form with "g" (for "more general") as in ~ uniex vs. ~ uniexg . $)
    a1d $p |- ( ph -> ( ch -> ps ) ) $=
      wph wps wch wps wi a1d.1 wps wch ax-1 syl $.
      $( [20-Mar-2006] $) $( [5-Aug-1993] $)
  $}

  ${
    a2d.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Deduction distributing an embedded antecedent. $)
    a2d $p |- ( ph -> ( ( ps -> ch ) -> ( ps -> th ) ) ) $=
      wph wps wch wth wi wi wps wch wi wps wth wi wi a2d.1 wps wch wth ax-2 syl
      $.
      $( [23-Jun-1994] $)
  $}

  $( A closed form of syllogism (see ~ syl ).  Theorem *2.05 of
     [WhiteheadRussell] p. 100. $)
  imim2 $p |- ( ( ph -> ps ) -> ( ( ch -> ph ) -> ( ch -> ps ) ) ) $=
    wph wps wi wch wph wps wph wps wi wch ax-1 a2d $.
    $( [5-Aug-1993] $)

  $( A closed form of syllogism (see ~ syl ).  Theorem *2.06 of
     [WhiteheadRussell] p. 100. $)
  imim1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    wps wch wi wph wps wi wph wch wi wps wch wph imim2 com12 $.
    $( [5-Aug-1993] $)

  ${
    imim1i.1 $e |- ( ph -> ps ) $.
    $( Inference adding common consequents in an implication, thereby
       interchanging the original antecedent and consequent. $)
    imim1i $p |- ( ( ps -> ch ) -> ( ph -> ch ) ) $=
      wph wps wi wps wch wi wph wch wi wi imim1i.1 wph wps wch imim1 ax-mp $.
      $( [5-Aug-1993] $)

    $( Inference adding common antecedents in an implication. $)
    imim2i $p |- ( ( ch -> ph ) -> ( ch -> ps ) ) $=
      wch wph wps wph wps wi wch imim1i.1 a1i a2i $.
      $( [5-Aug-1993] $)
  $}

  ${
    imim12i.1 $e |- ( ph -> ps ) $.
    imim12i.2 $e |- ( ch -> th ) $.
    $( Inference joining two implications. $)
    imim12i $p |- ( ( ps -> ch ) -> ( ph -> th ) ) $=
      wps wch wi wps wth wi wph wth wi wch wth wps imim12i.2 imim2i wph wps wth
      imim12i.1 imim1i syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    imim3i.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference adding three nested antecedents. $)
    imim3i $p |- ( ( th -> ph ) -> ( ( th -> ps ) -> ( th -> ch ) ) ) $=
      wth wph wi wth wps wch wph wps wch wi wth imim3i.1 imim2i a2d $.
      $( [19-Dec-2006] $) $( [19-Dec-2006] $)
  $}

  ${
    3syl.1 $e |- ( ph -> ps ) $.
    3syl.2 $e |- ( ps -> ch ) $.
    3syl.3 $e |- ( ch -> th ) $.
    $( Inference chaining two syllogisms. $)
    3syl $p |- ( ph -> th ) $=
      wph wch wth wph wps wch 3syl.1 3syl.2 syl 3syl.3 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl5.2 $e |- ( th -> ps ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the second antecedent of the first premise. $)
    syl5 $p |- ( ph -> ( th -> ch ) ) $=
      wph wps wch wi wth wch wi syl5.1 wth wps wch syl5.2 imim1i syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6.2 $e |- ( ch -> th ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the consequent of the first premise. $)
    syl6 $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wi wps wth wi syl6.1 wch wth wps syl6.2 imim2i syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl7.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl7.2 $e |- ( ta -> ch ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the third antecedent of the first premise. $)
    syl7 $p |- ( ph -> ( ps -> ( ta -> th ) ) ) $=
      wph wps wch wth wi wta wth wi syl7.1 wta wch wth syl7.2 imim1i syl6 $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl8.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl8.2 $e |- ( th -> ta ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the consequent of the first premise. $)
    syl8 $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      wph wps wch wth wi wch wta wi syl8.1 wth wta wch syl8.2 imim2i syl6 $.
      $( [1-Aug-1994] $)
  $}

  ${
    imim2d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding nested antecedents. $)
    imim2d $p |- ( ph -> ( ( th -> ps ) -> ( th -> ch ) ) ) $=
      wph wth wps wch wph wps wch wi wth imim2d.1 a1d a2d $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpd.1 $e |- ( ph -> ps ) $.
    mpd.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A modus ponens deduction. $)
    mpd $p |- ( ph -> ch ) $=
      wph wps wi wph wch wi mpd.1 wph wps wch mpd.2 a2i ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    syld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syld.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( Syllogism deduction.  (The proof was shortened by O'Cat, 19-Feb-2008.)

       Notice that ~ syld can be obtained from ~ syl by replacing each
       hypothesis and conclusion ` ta ` by ` ( ph -> ta ) ` .  In general, this
       process will always yield a new propositional calculus theorem because
       of something called the Deduction Theorem for propositional calculus. $)
    syld $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wi wps wth wi syld.1 wph wch wth wps syld.2 imim2d mpd $.
      $( [19-Feb-2008] $) $( [5-Aug-1993] $)
  $}

  ${
    3syld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3syld.2 $e |- ( ph -> ( ch -> th ) ) $.
    3syld.3 $e |- ( ph -> ( th -> ta ) ) $.
    $( Triple syllogism deduction.  (Contributed by Jeff Hankins,
       4-Aug-2009.) $)
    3syld $p |- ( ph -> ( ps -> ta ) ) $=
      wph wps wth wta wph wps wch wth 3syld.1 3syld.2 syld 3syld.3 syld $.
      $( [24-Sep-2010] $) $( [4-Aug-2009] $)
  $}

  ${
    imim1d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding nested consequents. $)
    imim1d $p |- ( ph -> ( ( ch -> th ) -> ( ps -> th ) ) ) $=
      wph wps wch wi wch wth wi wps wth wi wi imim1d.1 wps wch wth imim1 syl $.
      $( [3-Apr-1994] $)
  $}

  ${
    imim12d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    imim12d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( Deduction combining antecedents and consequents. $)
    imim12d $p |- ( ph -> ( ( ch -> th ) -> ( ps -> ta ) ) ) $=
      wph wch wth wi wps wth wi wps wta wi wph wps wch wth imim12d.1 imim1d wph
      wth wta wps imim12d.2 imim2d syld $.
      $( [7-Aug-1994] $)
  $}

  $( Swap antecedents.  Theorem *2.04 of [WhiteheadRussell] p. 100. $)
  pm2.04 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ps -> ( ph -> ch ) ) ) $=
    wph wps wch wi wi wph wps wi wph wch wi wps wph wps wch ax-2 wps wph ax-1
    syl5 $.
    $( [5-Aug-1993] $)

  $( Theorem *2.83 of [WhiteheadRussell] p. 108. $)
  pm2.83 $p |-  ( ( ph -> ( ps -> ch ) ) -> ( ( ph -> ( ch -> th ) ) ->
                ( ph -> ( ps -> th ) ) ) ) $=
    wps wch wi wch wth wi wps wth wi wph wps wch wth imim1 imim3i $.
    $( [13-Jan-2005] $) $( [3-Jan-2005] $)

  ${
    com3.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Commutation of antecedents.  Swap 2nd and 3rd. $)
    com23 $p |- ( ph -> ( ch -> ( ps -> th ) ) ) $=
      wph wps wch wth wi wi wch wps wth wi wi com3.1 wps wch wth pm2.04 syl $.
      $( [5-Aug-1993] $)

    $( Commutation of antecedents.  Swap 1st and 3rd. $)
    com13 $p |- ( ch -> ( ps -> ( ph -> th ) ) ) $=
      wps wch wph wth wi wps wph wch wth wph wps wch wth wi com3.1 com12 com23
      com12 $.
      $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Rotate left. $)
    com3l $p |- ( ps -> ( ch -> ( ph -> th ) ) ) $=
      wph wch wps wth wph wps wch wth com3.1 com23 com13 $.
      $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Rotate right. $)
    com3r $p |- ( ch -> ( ph -> ( ps -> th ) ) ) $=
      wps wch wph wth wph wps wch wth com3.1 com3l com3l $.
      $( [25-Apr-1994] $)
  $}

  ${
    com4.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $.
    $( Commutation of antecedents.  Swap 3rd and 4th. $)
    com34 $p |- ( ph -> ( ps -> ( th -> ( ch -> ta ) ) ) ) $=
      wph wps wch wth wta wi wi wth wch wta wi wi com4.1 wch wth wta pm2.04
      syl6 $.
      $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Swap 2nd and 4th. $)
    com24 $p |- ( ph -> ( th -> ( ch -> ( ps -> ta ) ) ) ) $=
      wph wth wps wch wta wph wps wth wch wta wi wph wps wch wth wta com4.1
      com34 com23 com34 $.
      $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Swap 1st and 4th. $)
    com14 $p |- ( th -> ( ps -> ( ch -> ( ph -> ta ) ) ) ) $=
      wth wps wph wch wta wph wps wth wch wta wi wph wps wch wth wta com4.1
      com34 com13 com34 $.
      $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Rotate left.  (The proof was shortened by
       O'Cat, 15-Aug-2004.) $)
    com4l $p |- ( ps -> ( ch -> ( th -> ( ph -> ta ) ) ) ) $=
      wth wps wch wph wta wi wph wps wch wth wta com4.1 com14 com3l $.
      $( [15-Aug-2004] $) $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Rotate twice. $)
    com4t $p |- ( ch -> ( th -> ( ph -> ( ps -> ta ) ) ) ) $=
      wps wch wth wph wta wph wps wch wth wta com4.1 com4l com4l $.
      $( [25-Apr-1994] $)

    $( Commutation of antecedents.  Rotate right. $)
    com4r $p |- ( th -> ( ph -> ( ps -> ( ch -> ta ) ) ) ) $=
      wch wth wph wps wta wph wps wch wth wta com4.1 com4t com4l $.
      $( [25-Apr-1994] $)
  $}

  ${
    $v et $.
    com5.et $f wff et $.
    com5.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( Commutation of antecedents.  Swap 4th and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com45 $p |- ( ph -> ( ps -> ( ch -> ( ta -> ( th -> et ) ) ) ) ) $=
      wph wps wch wth wta com5.et wi wi wta wth com5.et wi wi com5.1 wth wta
      com5.et pm2.04 syl8 $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)

    $( Commutation of antecedents.  Swap 3rd and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com35 $p |- ( ph -> ( ps -> ( ta -> ( th -> ( ch -> et ) ) ) ) ) $=
      wph wps wth wta wch com5.et wi wph wps wth wch wta com5.et wph wps wch
      wth wta com5.et wi com5.1 com34 com45 com34 $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)

    $( Commutation of antecedents.  Swap 2nd and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com25 $p |- ( ph -> ( ta -> ( ch -> ( th -> ( ps -> et ) ) ) ) ) $=
      wph wth wch wta wps com5.et wi wph wth wch wps wta com5.et wph wps wch
      wth wta com5.et wi com5.1 com24 com45 com24 $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)

    $( Commutation of antecedents.  Swap 1st and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com15 $p |- ( ta -> ( ps -> ( ch -> ( th -> ( ph -> et ) ) ) ) ) $=
      wth wps wch wta wph com5.et wi wth wps wch wph wta com5.et wph wps wch
      wth wta com5.et wi com5.1 com14 com45 com14 $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)

    $( Commutation of antecedents.  Rotate left.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com5l $p |- ( ps -> ( ch -> ( th -> ( ta -> ( ph -> et ) ) ) ) ) $=
      wph wch wth wta wps com5.et wph wps wth wta wch com5.et wph wps wch wta
      wth com5.et wph wps wch wth wta com5.et com5.1 com45 com35 com25 com15 $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)

    $( Commutation of antecedents.  Rotate left twice.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com52l $p |- ( ch -> ( th -> ( ta -> ( ph -> ( ps -> et ) ) ) ) ) $=
      wps wch wth wta wph com5.et wph wps wch wth wta com5.et com5.1 com5l
      com5l $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)

    $( Commutation of antecedents.  Rotate right twice.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com52r $p |- ( th -> ( ta -> ( ph -> ( ps -> ( ch -> et ) ) ) ) ) $=
      wch wth wta wph wps com5.et wph wps wch wth wta com5.et com5.1 com52l
      com5l $.
      $( [18-Apr-2010] $) $( [28-Jun-2009] $)
  $}

  ${
    a1dd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction introducing a nested embedded antecedent.  (The proof was
       shortened by O'Cat, 15-Jan-2008.) $)
    a1dd $p |- ( ph -> ( ps -> ( th -> ch ) ) ) $=
      wph wps wch wth wch wi a1dd.1 wch wth ax-1 syl6 $.
      $( [15-Jan-2008] $) $( [17-Dec-2004] $)
  $}

  ${
    mp2.1 $e |- ph $.
    mp2.2 $e |- ps $.
    mp2.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A double modus ponens inference. $)
    mp2 $p |- ch $=
      wps wch mp2.2 wph wps wch wi mp2.1 mp2.3 ax-mp ax-mp $.
      $( [5-Apr-1994] $)
  $}

  ${
    mpi.1 $e |- ps $.
    mpi.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A nested modus ponens inference.  (The proof was shortened by Stefan
       Allan, 20-Mar-2006.) $)
    mpi $p |- ( ph -> ch ) $=
      wph wps wch wps wph mpi.1 a1i mpi.2 mpd $.
      $( [20-Mar-2006] $) $( [5-Aug-1993] $)
  $}

  ${
    mpii.1 $e |- ch $.
    mpii.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A doubly nested modus ponens inference. $)
    mpii $p |- ( ph -> ( ps -> th ) ) $=
      wph wch wps wth wi mpii.1 wph wps wch wth mpii.2 com23 mpi $.
      $( [31-Dec-1993] $)
  $}

  ${
    mpdd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    mpdd.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A nested modus ponens deduction. $)
    mpdd $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wi wps wth wi mpdd.1 wph wps wch wth mpdd.2 a2d mpd $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  ${
    mpid.1 $e |- ( ph -> ch ) $.
    mpid.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A nested modus ponens deduction. $)
    mpid $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth wph wch wps mpid.1 a1d mpid.2 mpdd $.
      $( [16-Dec-2004] $) $( [14-Dec-2004] $)
  $}

  ${
    mpdi.1 $e |- ( ps -> ch ) $.
    mpdi.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A nested modus ponens deduction.  (The proof was shortened by O'Cat,
       15-Jan-2008.) $)
    mpdi $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth wps wch wi wph mpdi.1 a1i mpdi.2 mpdd $.
      $( [15-Jan-2008] $) $( [16-Apr-2005] $)
  $}

  ${
    mpcom.1 $e |- ( ps -> ph ) $.
    mpcom.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Modus ponens inference with commutation of antecedents. $)
    mpcom $p |- ( ps -> ch ) $=
      wps wph wch mpcom.1 wph wps wch mpcom.2 com12 mpd $.
      $( [17-Mar-1996] $)
  $}

  ${
    syldd.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syldd.2 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    $( Nested syllogism deduction. $)
    syldd $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      wph wps wch wth wi wch wta wi syldd.1 wph wps wth wta wi wch wth wi wch
      wta wi wi syldd.2 wth wta wch imim2 syl6 mpdd $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  ${
    sylcom.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylcom.2 $e |- ( ps -> ( ch -> th ) ) $.
    $( Syllogism inference with commutation of antecedents.  (The proof was
       shortened by O'Cat, 2-Feb-2006 and shortened further by Stefan Allan,
       23-Feb-2006.) $)
    sylcom $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wi wps wth wi sylcom.1 wps wch wth sylcom.2 a2i syl $.
      $( [24-Feb-2006] $) $( [29-Aug-2004] $)
  $}

  ${
    syl5com.2 $e |- ( ph -> ( ps -> ch ) ) $.
    syl5com.1 $e |- ( th -> ps ) $.
    $( Syllogism inference with commuted antecedents. $)
    syl5com $p |- ( th -> ( ph -> ch ) ) $=
      wth wph wps wch wth wps wph syl5com.1 a1d syl5com.2 sylcom $.
      $( [25-May-2005] $) $( [24-May-2005] $)
  $}

  ${
    syl6com.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6com.2 $e |- ( ch -> th ) $.
    $( Syllogism inference with commuted antecedents. $)
    syl6com $p |- ( ps -> ( ph -> th ) ) $=
      wph wps wth wph wps wch wth syl6com.1 syl6com.2 syl6 com12 $.
      $( [26-May-2005] $) $( [25-May-2005] $)
  $}

  ${
    syli.1 $e |- ( ps -> ( ph -> ch ) ) $.
    syli.2 $e |- ( ch -> ( ph -> th ) ) $.
    $( Syllogism inference with common nested antecedent. $)
    syli $p |- ( ps -> ( ph -> th ) ) $=
      wps wph wch wth syli.1 wch wph wth syli.2 com12 sylcom $.
      $( [5-Nov-2004] $) $( [4-Nov-2004] $)
  $}

  ${
    syl5d.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl5d.2 $e |- ( ph -> ( ta -> ch ) ) $.
    $( A nested syllogism deduction.  (The proof was shortened by Josh
       Purinton, 29-Dec-2000 and shortened further by O'Cat, 2-Feb-2006.) $)
    syl5d $p |- ( ph -> ( ps -> ( ta -> th ) ) ) $=
      wph wps wta wch wth wph wta wch wi wps syl5d.2 a1d syl5d.1 syldd $.
      $( [3-Feb-2006] $) $( [5-Aug-1993] $)
  $}

  ${
    syl6d.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl6d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( A nested syllogism deduction.  (The proof was shortened by Josh
       Purinton, 29-Dec-2000 and shortened further by O'Cat, 2-Feb-2006.) $)
    syl6d $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      wph wps wch wth wta syl6d.1 wph wth wta wi wps syl6d.2 a1d syldd $.
      $( [3-Feb-2006] $) $( [5-Aug-1993] $)
  $}

  ${
    syl9.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl9.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( A nested syllogism inference with different antecedents.  (The proof
       was shortened by Josh Purinton, 29-Dec-2000.) $)
    syl9 $p |- ( ph -> ( th -> ( ps -> ta ) ) ) $=
      wph wth wch wta wps wth wch wta wi wi wph syl9.2 a1i syl9.1 syl5d $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl9r.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl9r.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( A nested syllogism inference with different antecedents. $)
    syl9r $p |- ( th -> ( ph -> ( ps -> ta ) ) ) $=
      wph wth wps wta wi wph wps wch wth wta syl9r.1 syl9r.2 syl9 com12 $.
      $( [5-Aug-1993] $)
  $}

  $( Principle of identity.  Theorem *2.08 of [WhiteheadRussell] p. 101.
     For another version of the proof directly from axioms, see ~ id1 .
     (The proof was shortened by Stefan Allan, 20-Mar-2006.) $)
  id $p |- ( ph -> ph ) $=
    wph wph wph wi wph wph wph ax-1 wph wph wph wi ax-1 mpd $.
    $( [20-Mar-2006] $) $( [20-Mar-2006] $)

  $( Principle of identity.  Theorem *2.08 of [WhiteheadRussell] p. 101.  This
     version is proved directly from the axioms for demonstration purposes.
     This proof is a popular example in the literature and is identical,
     step for step, to the proofs of Theorem 1 of [Margaris] p. 51,
     Example 2.7(a) of [Hamilton] p. 31, Lemma 10.3 of [BellMachover] p. 36,
     and Lemma 1.8 of [Mendelson] p. 36.  It is also
     "Our first proof" in Hirst and Hirst's _A Primer for Logic and Proof_
     p. 16 (PDF p. 22) at
     ~ http://www.mathsci.appstate.edu/~~jlh/primer/hirst.pdf .
     For a shorter version of the proof that takes advantage of previously
     proved theorems, see ~ id . $)
  id1 $p |- ( ph -> ph ) $=
    wph wph wph wi wi wph wph wi wph wph ax-1 wph wph wph wi wph wi wi wph wph
    wph wi wi wph wph wi wi wph wph wph wi ax-1 wph wph wph wi wph ax-2 ax-mp
    ax-mp $.
    $( [5-Aug-1993] $)

  $( Principle of identity with antecedent. $)
  idd $p |- ( ph -> ( ps -> ps ) ) $=
    wps wps wi wph wps id a1i $.
    $( [26-Nov-1995] $)

  $( This theorem, called "Assertion," can be thought of as closed form of
     modus ponens ~ ax-mp .  Theorem *2.27 of [WhiteheadRussell] p. 104. $)
  pm2.27 $p |- ( ph -> ( ( ph -> ps ) -> ps ) ) $=
    wph wps wi wph wps wph wps wi id com12 $.
    $( [5-Aug-1993] $)

  $( Absorption of redundant antecedent.  Also called the "Contraction" or
     "Hilbert" axiom.  Theorem *2.43 of [WhiteheadRussell] p. 106.  (The proof
     was shortened by O'Cat, 15-Aug-2004.) $)
  pm2.43 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    wph wph wps wi wps wph wps pm2.27 a2i $.
    $( [15-Aug-2004] $) $( [5-Aug-1993] $)

  ${
    pm2.43i.1 $e |- ( ph -> ( ph -> ps ) ) $.
    $( Inference absorbing redundant antecedent.  (The proof was shortened by
       O'Cat, 28-Nov-2008.) $)
    pm2.43i $p |- ( ph -> ps ) $=
      wph wph wps wph id pm2.43i.1 mpd $.
      $( [29-Nov-2008] $) $( [5-Aug-1993] $)
  $}

  ${
    pm2.43d.1 $e |- ( ph -> ( ps -> ( ps -> ch ) ) ) $.
    $( Deduction absorbing redundant antecedent.  (The proof was shortened by
       O'Cat, 28-Nov-2008.) $)
    pm2.43d $p |- ( ph -> ( ps -> ch ) ) $=
      wph wps wps wch wps id pm2.43d.1 mpdi $.
      $( [29-Nov-2008] $) $( [18-Aug-1993] $)
  $}

  ${
    pm2.43a.1 $e |- ( ps -> ( ph -> ( ps -> ch ) ) ) $.
    $( Inference absorbing redundant antecedent.  (The proof was shortened by
       O'Cat, 28-Nov-2008.) $)
    pm2.43a $p |- ( ps -> ( ph -> ch ) ) $=
      wps wph wps wch wps id pm2.43a.1 mpid $.
      $( [29-Nov-2008] $) $( [7-Nov-1995] $)

    $( Inference absorbing redundant antecedent. $)
    pm2.43b $p |- ( ph -> ( ps -> ch ) ) $=
      wps wph wch wph wps wch pm2.43a.1 pm2.43a com12 $.
      $( [31-Oct-1995] $)
  $}

  ${
    sylc.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylc.2 $e |- ( th -> ph ) $.
    sylc.3 $e |- ( th -> ps ) $.
    $( A syllogism inference combined with contraction. $)
    sylc $p |- ( th -> ch ) $=
      wth wps wch sylc.3 wth wph wps wch wi sylc.2 sylc.1 syl mpd $.
      $( [4-May-1994] $)
  $}

  $( Converse of axiom ~ ax-2 .  Theorem *2.86 of [WhiteheadRussell] p. 108. $)
  pm2.86 $p |- ( ( ( ph -> ps ) -> ( ph -> ch ) ) ->
               ( ph -> ( ps -> ch ) ) ) $=
    wph wps wi wph wch wi wi wps wph wch wps wph wps wi wph wch wi wps wph ax-1
    imim1i com23 $.
    $( [25-Apr-1994] $)

  ${
    pm2.86i.1 $e |- ( ( ph -> ps ) -> ( ph -> ch ) ) $.
    $( Inference based on ~ pm2.86 . $)
    pm2.86i $p |- ( ph -> ( ps -> ch ) ) $=
      wph wps wi wph wch wi wi wph wps wch wi wi pm2.86i.1 wph wps wch pm2.86
      ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    pm2.86d.1 $e |- ( ph -> ( ( ps -> ch ) -> ( ps -> th ) ) ) $.
    $( Deduction based on ~ pm2.86 . $)
    pm2.86d $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      wph wps wch wi wps wth wi wi wps wch wth wi wi pm2.86d.1 wps wch wth
      pm2.86 syl $.
      $( [29-Jun-1995] $)
  $}

  $( The Linearity Axiom of the infinite-valued sentential logic (L-infinity)
     of Lukasiewicz.  (Contributed by O'Cat, 12-Aug-2004.) $)
  loolin $p |- ( ( ( ph -> ps ) -> ( ps -> ph ) ) -> ( ps -> ph ) ) $=
    wph wps wi wps wph wi wi wps wph wps wph wps wi wps wph wi wps wph ax-1
    imim1i pm2.43d $.
    $( [14-Aug-2004] $) $( [12-Aug-2004] $)

  $( An alternate for the Linearity Axiom of the infinite-valued sentential
     logic (L-infinity) of Lukasiewicz, due to Barbara Wozniakowska, _Reports
     on Mathematical Logic_ 10, 129-137 (1978).  (Contributed by O'Cat,
     8-Aug-2004.) $)
  loowoz $p |- ( ( ( ph -> ps ) -> ( ph -> ch ) ) ->
                 ( ( ps -> ph ) -> ( ps -> ch ) ) ) $=
    wph wps wi wph wch wi wi wps wph wch wps wph wps wi wph wch wi wps wph ax-1
    imim1i a2d $.
    $( [9-Aug-2004] $) $( [8-Aug-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical negation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$( This section makes our first use of the third axiom of propositonal
   calculus. $)

  ${
    con4i.1 $e |- ( -. ph -> -. ps ) $.
    $( Inference rule derived from axiom ~ ax-3 . $)
    con4i $p |- ( ps -> ph ) $=
      wph wn wps wn wi wps wph wi con4i.1 wph wps ax-3 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    con4d.1 $e |- ( ph -> ( -. ps -> -. ch ) ) $.
    $( Deduction derived from axiom ~ ax-3 . $)
    con4d $p |- ( ph -> ( ch -> ps ) ) $=
      wph wps wn wch wn wi wch wps wi con4d.1 wps wch ax-3 syl $.
      $( [26-Mar-1995] $)
  $}

  $( From a wff and its negation, anything is true.  Theorem *2.21 of
     [WhiteheadRussell] p. 104.  Also called the Duns Scotus law. $)
  pm2.21 $p |- ( -. ph -> ( ph -> ps ) ) $=
    wph wn wps wph wph wn wps wn ax-1 con4d $.
    $( [5-Aug-1993] $)

  ${
    pm2.21i.1 $e |- -. ph $.
    $( A contradiction implies anything.  Inference from ~ pm2.21 . $)
    pm2.21i $p |- ( ph -> ps ) $=
      wps wph wph wn wps wn pm2.21i.1 a1i con4i $.
      $( [16-Sep-1993] $)
  $}

  ${
    pm2.21d.1 $e |- ( ph -> -. ps ) $.
    $( A contradiction implies anything.  Deduction from ~ pm2.21 . $)
    pm2.21d $p |- ( ph -> ( ps -> ch ) ) $=
      wph wch wps wph wps wn wch wn pm2.21d.1 a1d con4d $.
      $( [10-Feb-1996] $)
  $}

  $( Theorem *2.24 of [WhiteheadRussell] p. 104. $)
  pm2.24 $p |-  ( ph -> ( -. ph -> ps ) ) $=
    wph wn wph wps wph wps pm2.21 com12 $.
    $( [6-Jan-2005] $) $( [3-Jan-2005] $)

  ${
    pm2.24ii.1 $e |- ph $.
    pm2.24ii.2 $e |- -. ph $.
    $( A contradiction implies anything.  Inference from ~ pm2.24 . $)
    pm2.24ii $p |- ps $=
      wph wps pm2.24ii.1 wph wps pm2.24ii.2 pm2.21i ax-mp $.
      $( [27-Feb-2008] $) $( [27-Feb-2008] $)
  $}

  $( Proof by contradiction.  Theorem *2.18 of [WhiteheadRussell] p. 103.
     Also called the Law of Clavius. $)
  pm2.18 $p |- ( ( -. ph -> ph ) -> ph ) $=
    wph wn wph wi wph wph wn wph wi wph wph wn wph wi wph wn wph wph wn wph wi
    wn wph wph wn wph wi wn pm2.21 a2i con4d pm2.43i $.
    $( [5-Aug-1993] $)

  $( Peirce's axiom.  This odd-looking theorem is the "difference" between
     an intuitionistic system of propositional calculus and a classical system
     and is not accepted by intuitionists.  When Peirce's axiom is added to an
     intuitionistic system, the system becomes equivalent to our classical
     system ~ ax-1 through ~ ax-3 .  A curious fact about this
     theorem is that it requires ~ ax-3 for its proof even though the
     result has no negation connectives in it. $)
  peirce $p |- ( ( ( ph -> ps ) -> ph ) -> ph ) $=
    wph wps wi wph wi wph wn wph wi wph wph wn wph wps wi wph wph wps pm2.21
    imim1i wph pm2.18 syl $.
    $( [5-Aug-1993] $)

  $( The Inversion Axiom of the infinite-valued sentential logic (L-infinity)
     of Lukasiewicz.  Using ~ dfor2 , we can see that this essentially
     expresses "disjunction commutes."  Theorem *2.69 of [WhiteheadRussell]
     p. 108. $)
  looinv $p |- ( ( ( ph -> ps ) -> ps ) -> ( ( ps -> ph ) -> ph ) ) $=
    wph wps wi wps wi wps wph wi wph wps wi wph wi wph wph wps wi wps wph imim1
    wph wps peirce syl6 $.
    $( [20-Aug-2004] $) $( [12-Aug-2004] $)

  $( Converse of double negation.  Theorem *2.14 of [WhiteheadRussell] p. 102.
     (The proof was shortened by David Harvey, 5-Sep-1999.  An even shorter
     proof found by Josh Purinton, 29-Dec-2000.) $)
  notnot2 $p |- ( -. -. ph -> ph ) $=
    wph wn wn wph wn wph wi wph wph wn wph pm2.21 wph pm2.18 syl $.
    $( [5-Aug-1993] $)

  ${
    negai.1 $e |- -. -. ph $.
    $( Inference from double negation. $)
    notnotri $p |- ph $=
      wph wn wn wph negai.1 wph notnot2 ax-mp $.
      $( [27-Feb-2008] $) $( [27-Feb-2008] $)
  $}

  $( Converse of double negation.  Theorem *2.12 of [WhiteheadRussell]
     p. 101. $)
  notnot1 $p |- ( ph -> -. -. ph ) $=
    wph wn wn wph wph wn notnot2 con4i $.
    $( [5-Aug-1993] $)

  ${
    negbi.1 $e |- ph $.
    $( Infer double negation. $)
    notnoti $p |- -. -. ph $=
      wph wph wn wn negbi.1 wph notnot1 ax-mp $.
      $( [27-Feb-2008] $) $( [27-Feb-2008] $)
  $}

  $( Reductio ad absurdum.  Theorem *2.01 of [WhiteheadRussell] p. 100.  (The
     proof was shortened by O'Cat, 21-Nov-2008. $)
  pm2.01 $p |- ( ( ph -> -. ph ) -> -. ph ) $=
    wph wn wph wi wph wi wph wph wn wi wph wn wi wph pm2.18 wph wn wph looinv
    ax-mp $.
    $( [21-Nov-2008] $) $( [18-Aug-1993] $)

  ${
    pm2.01d.1 $e |- ( ph -> ( ps -> -. ps ) ) $.
    $( Deduction based on reductio ad absurdum. $)
    pm2.01d $p |- ( ph -> -. ps ) $=
      wph wps wps wn wi wps wn pm2.01d.1 wps pm2.01 syl $.
      $( [18-Aug-1993] $)
  $}

  $( Contraposition.  Theorem *2.03 of [WhiteheadRussell] p. 100. $)
  con2 $p |- ( ( ph -> -. ps ) -> ( ps -> -. ph ) ) $=
    wph wps wn wi wph wn wps wph wn wn wph wps wn wph notnot2 imim1i con4d $.
    $( [5-Aug-1993] $)

  ${
    con2d.1 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( A contraposition deduction. $)
    con2d $p |- ( ph -> ( ch -> -. ps ) ) $=
      wph wps wch wn wi wch wps wn wi con2d.1 wps wch con2 syl $.
      $( [19-Aug-1993] $)
  $}

  $( Contraposition.  Theorem *2.15 of [WhiteheadRussell] p. 102. $)
  con1 $p |- ( ( -. ph -> ps ) -> ( -. ps -> ph ) ) $=
    wph wn wps wi wph wps wn wps wps wn wn wph wn wps notnot1 imim2i con4d $.
    $( [5-Aug-1993] $)

  ${
    con1d.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( A contraposition deduction. $)
    con1d $p |- ( ph -> ( -. ch -> ps ) ) $=
      wph wps wn wch wi wch wn wps wi con1d.1 wps wch con1 syl $.
      $( [5-Aug-1993] $)
  $}

  $( Contraposition.  Theorem *2.16 of [WhiteheadRussell] p. 103. $)
  con3 $p |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) $=
    wph wps wi wph wps wn wps wps wn wn wph wps notnot1 imim2i con2d $.
    $( [5-Aug-1993] $)

  ${
    con3d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A contraposition deduction. $)
    con3d $p |- ( ph -> ( -. ch -> -. ps ) ) $=
      wph wps wch wi wch wn wps wn wi con3d.1 wps wch con3 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    con1.a $e |- ( -. ph -> ps ) $.
    $( A contraposition inference.  (The proof was shortened by O'Cat,
       28-Nov-2008.) $)
    con1i $p |- ( -. ps -> ph ) $=
      wph wn wps wi wps wn wph wi con1.a wph wps con1 ax-mp $.
      $( [29-Nov-2008] $) $( [5-Aug-1993] $)
  $}

  ${
    con2.a $e |- ( ph -> -. ps ) $.
    $( A contraposition inference.  (The proof was shortened by O'Cat,
       28-Nov-2008.) $)
    con2i $p |- ( ps -> -. ph ) $=
      wph wps wn wi wps wph wn wi con2.a wph wps con2 ax-mp $.
      $( [29-Nov-2008] $) $( [5-Aug-1993] $)
  $}

  ${
    con3.a $e |- ( ph -> ps ) $.
    $( A contraposition inference. $)
    con3i $p |- ( -. ps -> -. ph ) $=
      wph wn wps wph wn wn wph wps wph notnot2 con3.a syl con1i $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem *2.5 of [WhiteheadRussell] p. 107. $)
  pm2.5 $p |-  ( -. ( ph -> ps ) -> ( -. ph -> ps ) ) $=
    wph wps wi wn wph wn wps wph wn wph wps wi wph wps pm2.21 con3i pm2.21d $.
    $( [27-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.51 of [WhiteheadRussell] p. 107. $)
  pm2.51 $p |-  ( -. ( ph -> ps ) -> ( ph -> -. ps ) ) $=
    wph wps wi wn wps wn wph wps wph wps wi wps wph ax-1 con3i a1d $.
    $( [27-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.52 of [WhiteheadRussell] p. 107. $)
  pm2.52 $p |-  ( -. ( ph -> ps ) -> ( -. ph -> -. ps ) ) $=
    wph wps wi wn wps wn wph wn wps wph wps wi wps wph ax-1 con3i a1d $.
    $( [27-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.521 of [WhiteheadRussell] p. 107. $)
  pm2.521 $p |-  ( -. ( ph -> ps ) -> ( ps -> ph ) ) $=
    wph wps wi wn wph wps wph wps pm2.52 con4d $.
    $( [6-Feb-2005] $) $( [3-Jan-2005] $)

  ${
    pm2.24i.1 $e |- ph $.
    $( Inference version of ~ pm2.24 . $)
    pm2.24i $p |- ( -. ph -> ps ) $=
      wps wph wph wps wn pm2.24i.1 a1i con1i $.
      $( [20-Aug-2001] $)
  $}

  ${
    pm2.24d.1 $e |- ( ph -> ps ) $.
    $( Deduction version of ~ pm2.21 . $)
    pm2.24d $p |- ( ph -> ( -. ps -> ch ) ) $=
      wph wch wps wph wps wch wn pm2.24d.1 a1d con1d $.
      $( [31-Jan-2006] $) $( [30-Jan-2006] $)
  $}

  ${
    mto.1 $e |- -. ps $.
    mto.2 $e |- ( ph -> ps ) $.
    $( The rule of modus tollens. $)
    mto $p |- -. ph $=
      wps wn wph wn mto.1 wph wps mto.2 con3i ax-mp $.
      $( [19-Aug-1993] $)
  $}

  ${
    mtoi.1 $e |- -. ch $.
    mtoi.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Modus tollens inference. $)
    mtoi $p |- ( ph -> -. ps ) $=
      wph wch wn wps wn mtoi.1 wph wps wch mtoi.2 con3d mpi $.
      $( [5-Jul-1994] $)
  $}

  ${
    mtod.1 $e |- ( ph -> -. ch ) $.
    mtod.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Modus tollens deduction. $)
    mtod $p |- ( ph -> -. ps ) $=
      wph wch wn wps wn mtod.1 wph wps wch mtod.2 con3d mpd $.
      $( [3-Apr-1994] $)
  $}

  ${
    mt2.1 $e |- ps $.
    mt2.2 $e |- ( ph -> -. ps ) $.
    $( A rule similar to modus tollens. $)
    mt2 $p |- -. ph $=
      wps wph wn mt2.1 wph wps mt2.2 con2i ax-mp $.
      $( [19-Aug-1993] $)
  $}

  ${
    mt2i.1 $e |- ch $.
    mt2i.2 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( Modus tollens inference. $)
    mt2i $p |- ( ph -> -. ps ) $=
      wph wch wps wn mt2i.1 wph wps wch mt2i.2 con2d mpi $.
      $( [26-Mar-1995] $)
  $}

  ${
    mt2d.1 $e |- ( ph -> ch ) $.
    mt2d.2 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( Modus tollens deduction. $)
    mt2d $p |- ( ph -> -. ps ) $=
      wph wch wps wn mt2d.1 wph wps wch mt2d.2 con2d mpd $.
      $( [4-Jul-1994] $)
  $}

  ${
    mt3.1 $e |- -. ps $.
    mt3.2 $e |- ( -. ph -> ps ) $.
    $( A rule similar to modus tollens. $)
    mt3 $p |- ph $=
      wps wn wph mt3.1 wph wps mt3.2 con1i ax-mp $.
      $( [18-May-1994] $)
  $}

  ${
    mt3i.1 $e |- -. ch $.
    mt3i.2 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Modus tollens inference. $)
    mt3i $p |- ( ph -> ps ) $=
      wph wch wn wps mt3i.1 wph wps wch mt3i.2 con1d mpi $.
      $( [26-Mar-1995] $)
  $}

  ${
    mt3d.1 $e |- ( ph -> -. ch ) $.
    mt3d.2 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Modus tollens deduction. $)
    mt3d $p |- ( ph -> ps ) $=
      wph wch wn wps mt3d.1 wph wps wch mt3d.2 con1d mpd $.
      $( [26-Mar-1995] $)
  $}

  ${
    mt4d.1 $e |- ( ph -> ps ) $.
    mt4d.2 $e |- ( ph -> ( -. ch -> -. ps ) ) $.
    $( Modus tollens deduction. $)
    mt4d $p |- ( ph -> ch ) $=
      wph wps wch mt4d.1 wph wch wps mt4d.2 con4d mpd $.
      $( [18-Jun-2006] $) $( [9-Jun-2006] $)
  $}

  ${
    nsyl.1 $e |- ( ph -> -. ps ) $.
    nsyl.2 $e |- ( ch -> ps ) $.
    $( A negated syllogism inference. $)
    nsyl $p |- ( ph -> -. ch ) $=
      wph wps wn wch wn nsyl.1 wch wps nsyl.2 con3i syl $.
      $( [31-Dec-1993] $)
  $}

  ${
    nsyld.1 $e |- ( ph -> ( ps -> -. ch ) ) $.
    nsyld.2 $e |- ( ph -> ( ta -> ch ) ) $.
    $( A negated syllogism deduction. $)
    nsyld $p |- ( ph -> ( ps -> -. ta ) ) $=
      wph wps wch wn wta wn nsyld.1 wph wta wch nsyld.2 con3d syld $.
      $( [10-Apr-2005] $) $( [9-Apr-2005] $)
  $}

  ${
    nsyl2.1 $e |- ( ph -> -. ps ) $.
    nsyl2.2 $e |- ( -. ch -> ps ) $.
    $( A negated syllogism inference. $)
    nsyl2 $p |- ( ph -> ch ) $=
      wph wps wn wch nsyl2.1 wch wps nsyl2.2 con1i syl $.
      $( [26-Jun-1994] $)
  $}

  ${
    nsyl3.1 $e |- ( ph -> -. ps ) $.
    nsyl3.2 $e |- ( ch -> ps ) $.
    $( A negated syllogism inference. $)
    nsyl3 $p |- ( ch -> -. ph ) $=
      wch wps wph wn nsyl3.2 wph wps nsyl3.1 con2i syl $.
      $( [1-Dec-1995] $)
  $}

  ${
    nsyl4.1 $e |- ( ph -> ps ) $.
    nsyl4.2 $e |- ( -. ph -> ch ) $.
    $( A negated syllogism inference. $)
    nsyl4 $p |- ( -. ch -> ps ) $=
      wch wn wph wps wph wch nsyl4.2 con1i nsyl4.1 syl $.
      $( [15-Feb-1996] $)
  $}

  ${
    nsyli.1 $e |- ( ph -> ( ps -> ch ) ) $.
    nsyli.2 $e |- ( th -> -. ch ) $.
    $( A negated syllogism inference. $)
    nsyli $p |- ( ph -> ( th -> -. ps ) ) $=
      wph wch wn wps wn wth wph wps wch nsyli.1 con3d nsyli.2 syl5 $.
      $( [3-May-1994] $)
  $}

  $( Theorem *3.2 of [WhiteheadRussell] p. 111, expressed with primitive
     connectives.  (The proof was shortened by Josh Purinton, 29-Dec-2000.) $)
  pm3.2im $p |- ( ph -> ( ps -> -. ( ph -> -. ps ) ) ) $=
    wph wph wps wn wi wps wph wps wn pm2.27 con2d $.
    $( [5-Aug-1993] $)

  $( Theorem 8 of [Margaris] p. 60.  (The proof was shortened by Josh Purinton,
     29-Dec-2000.) $)
  mth8 $p |- ( ph -> ( -. ps -> -. ( ph -> ps ) ) ) $=
    wph wph wps wi wps wph wps pm2.27 con3d $.
    $( [5-Aug-1993] $)

  $( Theorem *2.61 of [WhiteheadRussell] p. 107.  Useful for eliminating an
     antecedent. $)
  pm2.61 $p |- ( ( ph -> ps ) -> ( ( -. ph -> ps ) -> ps ) ) $=
    wph wn wps wi wph wps wi wps wn wps wi wps wph wn wps wi wps wn wph wps wph
    wps con1 imim1d wps pm2.18 syl6com $.
    $( [6-Mar-2008] $) $( [5-Aug-1993] $)

  ${
    pm2.61i.1 $e |- ( ph -> ps ) $.
    pm2.61i.2 $e |- ( -. ph -> ps ) $.
    $( Inference eliminating an antecedent. $)
    pm2.61i $p |- ps $=
      wph wps wi wph wn wps wi wps pm2.61i.1 pm2.61i.2 wph wps pm2.61 mp2 $.
      $( [5-Apr-1994] $)
  $}

  ${
    pm2.61d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.61d.2 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Deduction eliminating an antecedent. $)
    pm2.61d $p |- ( ph -> ch ) $=
      wps wph wch wi wph wps wch pm2.61d.1 com12 wph wps wn wch pm2.61d.2 com12
      pm2.61i $.
      $( [27-Apr-1994] $)
  $}

  ${
    pm2.61d1.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.61d1.2 $e |- ( -. ps -> ch ) $.
    $( Inference eliminating an antecedent. $)
    pm2.61d1 $p |- ( ph -> ch ) $=
      wph wps wch pm2.61d1.1 wps wn wch wi wph pm2.61d1.2 a1i pm2.61d $.
      $( [20-Jul-2005] $) $( [15-Jul-2005] $)
  $}

  ${
    pm2.61d2.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    pm2.61d2.2 $e |- ( ps -> ch ) $.
    $( Inference eliminating an antecedent. $)
    pm2.61d2 $p |- ( ph -> ch ) $=
      wph wps wch wps wch wi wph pm2.61d2.2 a1i pm2.61d2.1 pm2.61d $.
      $( [18-Aug-1993] $)
  $}

  ${
    pm2.61ii.1 $e |- ( -. ph -> ( -. ps -> ch ) ) $.
    pm2.61ii.2 $e |- ( ph -> ch ) $.
    pm2.61ii.3 $e |- ( ps -> ch ) $.
    $( Inference eliminating two antecedents.  (The proof was shortened by Josh
       Purinton,  29-Dec-2000.) $)
    pm2.61ii $p |- ch $=
      wph wch pm2.61ii.2 wph wn wps wch pm2.61ii.1 pm2.61ii.3 pm2.61d2 pm2.61i
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    pm2.61nii.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.61nii.2 $e |- ( -. ph -> ch ) $.
    pm2.61nii.3 $e |- ( -. ps -> ch ) $.
    $( Inference eliminating two antecedents. $)
    pm2.61nii $p |- ch $=
      wps wch wps wph wch wph wps wch pm2.61nii.1 com12 pm2.61nii.2 pm2.61d1
      pm2.61nii.3 pm2.61i $.
      $( [5-Aug-1993] $)
  $}

  ${
    pm2.61iii.1 $e |- ( -. ph -> ( -. ps -> ( -. ch -> th ) ) ) $.
    pm2.61iii.2 $e |- ( ph -> th ) $.
    pm2.61iii.3 $e |- ( ps -> th ) $.
    pm2.61iii.4 $e |- ( ch -> th ) $.
    $( Inference eliminating three antecedents. $)
    pm2.61iii $p |- th $=
      wps wch wth wph wps wn wch wn wth wi wi wph wch wn wth wi wps wn wph wth
      wch wn pm2.61iii.2 a1d a1d pm2.61iii.1 pm2.61i pm2.61iii.3 pm2.61iii.4
      pm2.61ii $.
      $( [2-Jan-2002] $)
  $}

  $( Theorem *2.6 of [WhiteheadRussell] p. 107. $)
  pm2.6 $p |-  ( ( -. ph -> ps ) -> ( ( ph -> ps ) -> ps ) ) $=
    wph wps wi wph wn wps wi wps wph wps pm2.61 com12 $.
    $( [1-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.65 of [WhiteheadRussell] p. 107.  Proof by contradiction. $)
  pm2.65 $p |- ( ( ph -> ps ) -> ( ( ph -> -. ps ) -> -. ph ) ) $=
    wph wps wi wph wph wps wn wi wph wps wph wps wn wi wn wph wps pm3.2im a2i
    con2d $.
    $( [5-Aug-1993] $)

  ${
    pm2.65i.1 $e |- ( ph -> ps ) $.
    pm2.65i.2 $e |- ( ph -> -. ps ) $.
    $( Inference rule for proof by contradiction. $)
    pm2.65i $p |- -. ph $=
      wph wps wi wph wps wn wi wph wn pm2.65i.1 pm2.65i.2 wph wps pm2.65 mp2 $.
      $( [18-May-1994] $)
  $}

  ${
    pm2.65d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.65d.2 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( Deduction rule for proof by contradiction. $)
    pm2.65d $p |- ( ph -> -. ps ) $=
      wps wch wi wps wch wn wi wps wn wph wps wch pm2.65 pm2.65d.1 pm2.65d.2
      sylc $.
      $( [26-Jun-1994] $)
  $}

  ${
    ja.1 $e |- ( -. ph -> ch ) $.
    ja.2 $e |- ( ps -> ch ) $.
    $( Inference joining the antecedents of two premises.  (The proof was
       shortened by O'Cat, 19-Feb-2008.) $)
    ja $p |- ( ( ph -> ps ) -> ch ) $=
      wph wps wi wph wch wps wch wph ja.2 imim2i ja.1 pm2.61d1 $.
      $( [19-Feb-2008] $) $( [5-Aug-1993] $)
  $}

  ${
    jc.1 $e |- ( ph -> ps ) $.
    jc.2 $e |- ( ph -> ch ) $.
    $( Inference joining the consequents of two premises. $)
    jc $p |- ( ph -> -. ( ps -> -. ch ) ) $=
      wps wch wps wch wn wi wn wph wps wch pm3.2im jc.1 jc.2 sylc $.
      $( [5-Aug-1993] $)
  $}

  $( Simplification.  Similar to Theorem *3.26 (Simp) of [WhiteheadRussell]
     p. 112. $)
  pm3.26im $p |- ( -. ( ph -> -. ps ) -> ph ) $=
    wph wph wps wn wi wph wps wn pm2.21 con1i $.
    $( [5-Aug-1993] $)

  $( Simplification.  Similar to Theorem *3.27 (Simp) of [WhiteheadRussell]
     p. 112. $)
  pm3.27im $p |- ( -. ( ph -> -. ps ) -> ps ) $=
    wps wph wps wn wi wps wn wph ax-1 con1i $.
    $( [5-Aug-1993] $)

  $( Importation theorem expressed with primitive connectives. $)
  impt $p |- ( ( ph -> ( ps -> ch ) ) -> ( -. ( ph -> -. ps ) -> ch ) ) $=
    wph wps wch wi wi wch wph wps wn wi wph wps wch wi wi wph wch wn wps wn wps
    wch wi wch wn wps wn wi wph wps wch con3 imim2i com23 con1d $.
    $( [25-Apr-1994] $)

  $( Exportation theorem expressed with primitive connectives. $)
  expt $p |- ( ( -. ( ph -> -. ps ) -> ch ) -> ( ph -> ( ps -> ch ) ) ) $=
    wph wph wps wn wi wn wch wi wps wch wi wph wps wph wps wn wi wn wch wph wps
    pm3.2im imim1d com12 $.
    $( [5-Aug-1993] $)

  ${
    impi.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( An importation inference. $)
    impi $p |- ( -. ( ph -> -. ps ) -> ch ) $=
      wph wps wch wi wi wph wps wn wi wn wch wi impi.1 wph wps wch impt ax-mp
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    expi.1 $e |- ( -. ( ph -> -. ps ) -> ch ) $.
    $( An exportation inference.  (The proof was shortened by O'Cat,
       28-Nov-2008.) $)
    expi $p |- ( ph -> ( ps -> ch ) ) $=
      wph wps wph wps wn wi wn wch wph wps pm3.2im expi.1 syl6 $.
      $( [29-Nov-2008] $) $( [5-Aug-1993] $)
  $}

  $( Theorem used to justify definition of biconditional ~ def-bi .  (The proof
     was shortened by Josh Purinton, 29-Dec-2000.) $)
  bijust $p |- -. ( ( ph -> ph ) -> -. ( ph -> ph ) ) $=
    wph wph wi wph wph wi wn wi wph wph wi wph id wph wph wi pm2.01 mt2 $.
    $( [11-May-1999] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical equivalence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the biconditional connective. $)
  $c <-> $. $( Double arrow (read:  'if and only if' or
               'is logically equivalent to') $)

  $( Extend our wff definition to include the biconditional connective. $)
  wb $a wff ( ph <-> ps ) $.

  $( This is our first definition, which introduces and defines the
     biconditional connective ` <-> ` .  We define a wff of the form
     ` ( ph <-> ps ) ` as an abbreviation for
     ` -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ` .

     Unlike most traditional developments, we have chosen not to have a
     separate symbol such as "Df." to mean "is defined as."  Instead, we will
     later use the biconditional connective for this purpose ( ~ df-or is its
     first use), as it allows us to use logic to manipulate definitions
     directly.  This greatly simplifies many proofs since it eliminates the
     need for a separate mechanism for introducing and eliminating
     definitions.  Of course, we cannot use this mechanism to define the
     biconditional itself, since it hasn't been introduced yet.  Instead, we
     use a more general form of definition, described as follows.

     In its most general form, a definition is simply an assertion that
     introduces a new symbol (or a new combination of existing symbols, as in
     ~ df-3an ) that is eliminable and does not strengthen the existing
     language.  The latter requirement means that the set of provable
     statements not containing the new symbol (or new combination) should
     remain exactly the same after the definition is introduced.  Our
     definition of the biconditional may look unusual compared to most
     definitions, but it strictly satisfies these requirements.

     The justification for our definition is that if we mechanically replace
     the first wff above (the definiendum i.e. the thing being defined) with
     the second (the definiens i.e. the defining expression) in the
     definition, the definition becomes a substitution instance of previously
     proved theorem ~ bijust .  It is impossible to use ~ def-bi to prove any
     statement expressed in the original language that can't be proved from
     the original axioms.  For if it were, we could replace it with instances
     of ~ bijust throughout the proof, thus obtaining a proof from the
     original axioms (contradiction).

     Note that from Metamath's point of view, a definition is just another
     axiom - i.e. an assertion we claim to be true - but from our high level
     point of view, we are are not strengthening the language.  To indicate
     this fact, we prefix definition labels with "df-" instead of "ax-".
     (This prefixing is an informal convention that means nothing to the
     Metamath proof verifier; it is just for human readability.)

     See ~ dfbi1 , ~ dfbi2 , and ~ dfbi3 for theorems suggesting typical
     textbook definitions of ` <-> ` , showing that our definition has the
     properties we expect.  Theorem ~ dfbi shows this definition rewritten
     in an abbreviated form after conjunction is introduced, for easier
     understanding. $)
  def-bi $a |- -. ( ( ( ph <-> ps ) -> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) )
        -> -. ( -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) -> ( ph <-> ps ) ) ) $.

  $( Property of the biconditional connective. $)
  bi1 $p |- ( ( ph <-> ps ) -> ( ph -> ps ) ) $=
    wph wps wb wph wps wi wps wph wi wn wi wn wph wps wi wph wps wb wph wps wi
    wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi
    wn wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps def-bi wph wps wb
    wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb
    wi pm3.26im ax-mp wph wps wi wps wph wi pm3.26im syl $.
    $( [11-May-1999] $)

  $( Property of the biconditional connective. $)
  bi2 $p |- ( ( ph <-> ps ) -> ( ps -> ph ) ) $=
    wph wps wb wph wps wi wps wph wi wn wi wn wps wph wi wph wps wb wph wps wi
    wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi
    wn wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps def-bi wph wps wb
    wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb
    wi pm3.26im ax-mp wph wps wi wps wph wi pm3.27im syl $.
    $( [11-May-1999] $)

  $( Property of the biconditional connective. $)
  bi3 $p |- ( ( ph -> ps ) -> ( ( ps -> ph ) -> ( ph <-> ps ) ) ) $=
    wph wps wi wps wph wi wph wps wb wph wps wb wph wps wi wps wph wi wn wi wn
    wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wi wps wph
    wi wn wi wn wph wps wb wi wph wps def-bi wph wps wb wph wps wi wps wph wi wn
    wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi pm3.27im ax-mp expi
    $.
    $( [11-May-1999] $)

  ${
    biimp.1 $e |- ( ph <-> ps ) $.
    $( Infer an implication from a logical equivalence. $)
    biimpi $p |- ( ph -> ps ) $=
      wph wps wb wph wps wi biimp.1 wph wps bi1 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    biimpr.1 $e |- ( ph <-> ps ) $.
    $( Infer a converse implication from a logical equivalence. $)
    biimpri $p |- ( ps -> ph ) $=
      wph wps wb wps wph wi biimpr.1 wph wps bi2 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    biimpd.1 $e |- ( ph -> ( ps <-> ch ) ) $.

    $( Deduce an implication from a logical equivalence. $)
    biimpd $p |- ( ph -> ( ps -> ch ) ) $=
      wph wps wch wb wps wch wi biimpd.1 wps wch bi1 syl $.
      $( [5-Aug-1993] $)

   $( Deduce a converse implication from a logical equivalence. $)
    biimprd $p |- ( ph -> ( ch -> ps ) ) $=
      wph wps wch wb wch wps wi biimpd.1 wps wch bi2 syl $.
      $( [5-Aug-1993] $)

   $( Deduce a commuted implication from a logical equivalence. $)
    biimpcd $p |- ( ps -> ( ph -> ch ) ) $=
      wph wps wch wph wps wch biimpd.1 biimpd com12 $.
      $( [3-May-1994] $)

   $( Deduce a converse commuted implication from a logical equivalence. $)
    biimprcd $p |- ( ch -> ( ph -> ps ) ) $=
      wph wch wps wph wps wch biimpd.1 biimprd com12 $.
      $( [3-May-1994] $)
  $}

  ${
    impbi.1 $e |- ( ph -> ps ) $.
    impbi.2 $e |- ( ps -> ph ) $.
    $( Infer an equivalence from an implication and its converse. $)
    impbii $p |- ( ph <-> ps ) $=
      wph wps wi wps wph wi wph wps wb impbi.1 impbi.2 wph wps bi3 mp2 $.
      $( [5-Aug-1993] $)
  $}

  $( Relate the biconditional connective to primitive connectives.  See
     ~ dfbi1gb for an unusual version proved directly from axioms. $)
  dfbi1 $p |- ( ( ph <-> ps ) <-> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ) $=
    wph wps wb wph wps wi wps wph wi wn wi wn wph wps wb wph wps wi wps wph wi
    wph wps bi1 wph wps bi2 jc wph wps wi wps wph wi wph wps wb wph wps bi3
    impi impbii $.
    $( [5-Aug-1993] $)

  $( This proof of ~ dfbi1 , discovered by Gregory Bush on 8-Mar-2004, has
     several curious properties.  First, it has only 17 steps directly
     from the axioms and ~ def-bi , compared to over 800 steps were the proof
     of ~ dfbi1 expanded into axioms.  Second, step 2 demands only the property
     of "true"; any axiom (or theorem) could be used.  It might be thought,
     therefore, that it is in some sense redundant, but in fact no proof
     is shorter than this (measured by number of steps).  Third, it illustrates
     how intermediate steps can "blow up" in size even in short proofs.
     Fourth, the compressed proof is only 182 bytes (or 17 bytes in D-proof
     notation), but the generated web page is over 200kB with intermediate
     steps that are essentially incomprehensible to humans (other than Gregory
     Bush).  If there were an obfuscated code contest for proofs, this would be
     a contender. $)
  dfbi1gb $p |- ( ( ph <-> ps ) <-> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ) $=
    wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn
    wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wph wps
    def-bi wch wth wch wi wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph
    wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps
    wph wi wn wi wn wb wi wch wth ax-1 wph wps wb wph wps wi wps wph wi wn wi
    wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph
    wps wi wps wph wi wn wi wn wb wi wn wch wth wch wi wi wn wi wch wth wch wi
    wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi
    wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi
    wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi
    wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi
    wn wph wps wb wph wps wi wps wph wi wn wi wn wb wph wps wb wph wps wi wps
    wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wi
    wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn
    wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn
    wi wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn
    wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb
    wi wn wch wth wch wi wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wi
    wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi
    wps wph wi wn wi wn wb wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb
    wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn
    wph wps wb wi wn wi wn wi ax-1 wph wps wb wph wps wi wps wph wi wn wi wn wi
    wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi
    wps wph wi wn wi wn wb wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb
    wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn
    wph wps wb wi wn wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph
    wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps
    wph wi wn wi wn wb wi wn wi wch wth wch wi wi wn wi wi wph wps wb wph wps
    wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn
    wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn wph wps wb wph wps
    wi wps wph wi wn wi wn wb wph wps wb wph wps wi wps wph wi wn wi wn wi wph
    wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wi wph wps wb wph wps wi
    wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi
    wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn wi wi wph wps wb wph
    wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi
    wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn wch wth wch wi
    wi wn wi wi wph wps wb wph wps wi wps wph wi wn wi wn wb wph wps wb wph wps
    wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn
    wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi
    wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn
    wb wi wn wi wch wth wch wi wi wn wi wph wps wb wph wps wi wps wph wi wn wi
    wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph
    wps wi wps wph wi wn wi wn wb wi wn wph wps wb wph wps wi wps wph wi wn wi
    wn wb wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn
    wi wn wph wps wb wi wn wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn
    wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps
    wi wps wph wi wn wi wn wb wi wn wi wch wth wch wi wi wn wi wi wch wth wch
    wi wi wn wn wph wps wb wph wps wi wps wph wi wn wi wn wb wph wps wb wph wps
    wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn
    wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi
    wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn
    wb wi wn wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wb wph wps wb
    wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb
    wi wn wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps
    wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn
    wi wn wb wi wn wi wch wth wch wi wi wn wi wph wps wb wph wps wi wps wph wi
    wn wi wn wb wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph
    wi wn wi wn wph wps wb wi wn wi wn wi wph wps wb wph wps wi wps wph wi wn
    wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb
    wph wps wi wps wph wi wn wi wn wb wi wn wi wn wch wth wch wi wi wn wn wph
    wps wb wph wps wi wps wph wi wn wi wn wb wph wps wb wph wps wi wps wph wi
    wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wi wph
    wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph
    wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn wi wn
    wi wph wps wb wph wps wi wps wph wi wn wi wn def-bi wph wps wb wph wps wi
    wps wph wi wn wi wn wb wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps
    wi wps wph wi wn wi wn wph wps wb wi wn wi wn wi wph wps wb wph wps wi wps
    wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn
    wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn wi wn wch wth wch wi wi
    wn wn ax-1 ax-mp wch wth wch wi wi wn wph wps wb wph wps wi wps wph wi wn
    wi wn wb wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi
    wn wi wn wph wps wb wi wn wi wn wi wph wps wb wph wps wi wps wph wi wn wi
    wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph
    wps wi wps wph wi wn wi wn wb wi wn wi ax-3 ax-mp wph wps wb wph wps wi wps
    wph wi wn wi wn wb wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi
    wps wph wi wn wi wn wph wps wb wi wn wi wn wi wph wps wb wph wps wi wps wph
    wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn wph
    wps wb wph wps wi wps wph wi wn wi wn wb wi wn wi wch wth wch wi wi wn wi
    wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn
    wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wi wn
    ax-1 ax-mp wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph
    wi wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi
    wn wb wi wn wph wps wb wph wps wi wps wph wi wn wi wn wb wph wps wb wph wps
    wi wps wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn
    wi wn wi wph wps wb wph wps wi wps wph wi wn wi wn wi wph wps wi wps wph wi
    wn wi wn wph wps wb wi wn wi wn wph wps wb wph wps wi wps wph wi wn wi wn
    wb wi wn wi wch wth wch wi wi wn ax-2 ax-mp ax-mp wph wps wb wph wps wi wps
    wph wi wn wi wn wi wph wps wi wps wph wi wn wi wn wph wps wb wi wn wi wn
    wph wps wb wph wps wi wps wph wi wn wi wn wb wi wch wth wch wi wi ax-3
    ax-mp ax-mp ax-mp $.
    $( [10-Mar-2004] $) $( [10-Mar-2004] $)

  $( Logical equivalence of commuted antecedents.  Part of Theorem *4.87 of
     [WhiteheadRussell] p. 122. $)
  bi2.04 $p |- ( ( ph -> ( ps -> ch ) ) <-> ( ps -> ( ph -> ch ) ) ) $=
    wph wps wch wi wi wps wph wch wi wi wph wps wch pm2.04 wps wph wch pm2.04
    impbii $.
    $( [5-Aug-1993] $)

  $( Double negation.  Theorem *4.13 of [WhiteheadRussell] p. 117. $)
  notnot $p |- ( ph <-> -. -. ph ) $=
    wph wph wn wn wph notnot1 wph notnot2 impbii $.
    $( [5-Aug-1993] $)

  $( Theorem *4.8 of [WhiteheadRussell] p. 122. $)
  pm4.8 $p |-  ( ( ph -> -. ph ) <-> -. ph ) $=
    wph wph wn wi wph wn wph pm2.01 wph wn wph ax-1 impbii $.
    $( [5-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.81 of [WhiteheadRussell] p. 122. $)
  pm4.81 $p |-  ( ( -. ph -> ph ) <-> ph ) $=
    wph wn wph wi wph wph pm2.18 wph wph pm2.24 impbii $.
    $( [10-Feb-2005] $) $( [3-Jan-2005] $)

  $( Contraposition.  Bidirectional version of ~ con1 . $)
  con1b $p |- ( ( -. ph -> ps ) <-> ( -. ps -> ph ) ) $=
    wph wn wps wi wps wn wph wi wph wps con1 wps wph con1 impbii $.
    $( [5-Aug-1993] $)

  $( Contraposition.  Bidirectional version of ~ con2 . $)
  con2b $p |- ( ( ph -> -. ps ) <-> ( ps -> -. ph ) ) $=
    wph wps wn wi wps wph wn wi wph wps con2 wps wph con2 impbii $.
    $( [5-Aug-1993] $)

  $( Contraposition.  Theorem *4.1 of [WhiteheadRussell] p. 116. $)
  con34b $p |- ( ( ph -> ps ) <-> ( -. ps -> -. ph ) ) $=
    wph wps wi wps wn wph wn wi wph wps con3 wps wph ax-3 impbii $.
    $( [5-Aug-1993] $)

  $( Antecedent absorption implication.  Theorem *5.4 of
     [WhiteheadRussell] p. 125. $)
  pm5.4 $p |- ( ( ph -> ( ph -> ps ) ) <-> ( ph -> ps ) ) $=
    wph wph wps wi wi wph wps wi wph wps pm2.43 wph wps wi wph ax-1 impbii $.
    $( [5-Aug-1993] $)

  $( Distributive law for implication.  Compare Theorem *5.41 of
     [WhiteheadRussell] p. 125. $)
  imdi $p |- ( ( ph -> ( ps -> ch ) ) <->
               ( ( ph -> ps ) -> ( ph -> ch ) ) ) $=
    wph wps wch wi wi wph wps wi wph wch wi wi wph wps wch ax-2 wph wps wch
    pm2.86 impbii $.
    $( [5-Aug-1993] $)

  $( Theorem *5.41 of [WhiteheadRussell] p. 125. $)
  pm5.41 $p |-  ( ( ( ph -> ps ) -> ( ph -> ch ) ) <->
                ( ph -> ( ps -> ch ) ) ) $=
    wph wps wi wph wch wi wi wph wps wch wi wi wph wps wch pm2.86 wph wps wch
    ax-2 impbii $.
    $( [10-Feb-2005] $) $( [3-Jan-2005] $)

  $( Principle of identity for logical equivalence.  Theorem *4.2 of
     [WhiteheadRussell] p. 117. $)
  biid $p |- ( ph <-> ph ) $=
    wph wph wph id wph id impbii $.
    $( [5-Aug-1993] $)

  $( Principle of identity with antecedent. $)
  biidd $p |- ( ph -> ( ps <-> ps ) ) $=
    wps wps wb wph wps biid a1i $.
    $( [25-Nov-1995] $)

  ${
    bicomi.1 $e |- ( ph <-> ps ) $.
    $( Inference from commutative law for logical equivalence. $)
    bicomi $p |- ( ps <-> ph ) $=
      wps wph wph wps bicomi.1 biimpri wph wps bicomi.1 biimpi impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    bitri.1 $e |- ( ph <-> ps ) $.
    bitri.2 $e |- ( ps <-> ch ) $.
    $( An inference from transitive law for logical equivalence. $)
    bitri $p |- ( ph <-> ch ) $=
      wph wch wph wps wch wph wps bitri.1 biimpi wps wch bitri.2 biimpi syl wch
      wps wph wps wch bitri.2 biimpri wph wps bitri.1 biimpri syl impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    bitr2i.1 $e |- ( ph <-> ps ) $.
    bitr2i.2 $e |- ( ps <-> ch ) $.
    $( An inference from transitive law for logical equivalence. $)
    bitr2i $p |- ( ch <-> ph ) $=
      wph wch wph wps wch bitr2i.1 bitr2i.2 bitri bicomi $.
      $( [5-Aug-1993] $)
  $}

  ${
    bitr3i.1 $e |- ( ps <-> ph ) $.
    bitr3i.2 $e |- ( ps <-> ch ) $.
    $( An inference from transitive law for logical equivalence. $)
    bitr3i $p |- ( ph <-> ch ) $=
      wph wps wch wps wph bitr3i.1 bicomi bitr3i.2 bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    bitr4i.1 $e |- ( ph <-> ps ) $.
    bitr4i.2 $e |- ( ch <-> ps ) $.
    $( An inference from transitive law for logical equivalence. $)
    bitr4i $p |- ( ph <-> ch ) $=
      wph wps wch bitr4i.1 wch wps bitr4i.2 bicomi bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    3bitri.1 $e |- ( ph <-> ps ) $.
    3bitri.2 $e |- ( ps <-> ch ) $.
    3bitri.3 $e |- ( ch <-> th ) $.
    $( A chained inference from transitive law for logical equivalence. $)
    3bitri $p |- ( ph <-> th ) $=
      wph wps wth 3bitri.1 wps wch wth 3bitri.2 3bitri.3 bitri bitri $.
      $( [5-Aug-1993] $)

    $( A chained inference from transitive law for logical equivalence. $)
    3bitrri $p |- ( th <-> ph ) $=
      wth wch wph 3bitri.3 wph wps wch 3bitri.1 3bitri.2 bitr2i bitr3i $.
      $( [10-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3bitr2i.1 $e |- ( ph <-> ps ) $.
    3bitr2i.2 $e |- ( ch <-> ps ) $.
    3bitr2i.3 $e |- ( ch <-> th ) $.
    $( A chained inference from transitive law for logical equivalence. $)
    3bitr2i $p |- ( ph <-> th ) $=
      wph wch wth wph wps wch 3bitr2i.1 3bitr2i.2 bitr4i 3bitr2i.3 bitri $.
      $( [10-Aug-2006] $) $( [4-Aug-2006] $)

    $( A chained inference from transitive law for logical equivalence. $)
    3bitr2ri $p |- ( th <-> ph ) $=
      wph wch wth wph wps wch 3bitr2i.1 3bitr2i.2 bitr4i 3bitr2i.3 bitr2i $.
      $( [10-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3bitr3i.1 $e |- ( ph <-> ps ) $.
    3bitr3i.2 $e |- ( ph <-> ch ) $.
    3bitr3i.3 $e |- ( ps <-> th ) $.
    $( A chained inference from transitive law for logical equivalence. $)
    3bitr3i $p |- ( ch <-> th ) $=
      wch wps wth wch wph wps 3bitr3i.2 3bitr3i.1 bitr3i 3bitr3i.3 bitri $.
      $( [19-Aug-1993] $)

    $( A chained inference from transitive law for logical equivalence. $)
    3bitr3ri $p |- ( th <-> ch ) $=
      wth wps wch 3bitr3i.3 wps wph wch 3bitr3i.1 3bitr3i.2 bitr3i bitr3i $.
      $( [5-Aug-1993] $)
  $}

  ${
    3bitr4i.1 $e |- ( ph <-> ps ) $.
    3bitr4i.2 $e |- ( ch <-> ph ) $.
    3bitr4i.3 $e |- ( th <-> ps ) $.
    $( A chained inference from transitive law for logical equivalence.  This
       inference is frequently used to apply a definition to both sides of a
       logical equivalence. $)
    3bitr4i $p |- ( ch <-> th ) $=
      wch wph wth 3bitr4i.2 wph wps wth 3bitr4i.1 3bitr4i.3 bitr4i bitri $.
      $( [5-Aug-1993] $)

    $( A chained inference from transitive law for logical equivalence. $)
    3bitr4ri $p |- ( th <-> ch ) $=
      wch wph wth 3bitr4i.2 wph wps wth 3bitr4i.1 3bitr4i.3 bitr4i bitr2i $.
      $( [2-Sep-1995] $)
  $}

  $( The next three rules are useful for building up wff's around a
     definition, in order to make use of the definition. $)

  ${
    bi.a $e |- ( ph <-> ps ) $.

    $( Introduce an antecedent to both sides of a logical equivalence. $)
    imbi2i $p |- ( ( ch -> ph ) <-> ( ch -> ps ) ) $=
      wch wph wi wch wps wi wph wps wch wph wps bi.a biimpi imim2i wps wph wch
      wph wps bi.a biimpri imim2i impbii $.
      $( [5-Aug-1993] $)

    $( Introduce a consequent to both sides of a logical equivalence. $)
    imbi1i $p |- ( ( ph -> ch ) <-> ( ps -> ch ) ) $=
      wph wch wi wps wch wi wps wph wch wph wps bi.a biimpri imim1i wph wps wch
      wph wps bi.a biimpi imim1i impbii $.
      $( [5-Aug-1993] $)

    $( Negate both sides of a logical equivalence. $)
    notbii $p |- ( -. ph <-> -. ps ) $=
      wph wn wps wn wps wph wph wps bi.a biimpri con3i wph wps wph wps bi.a
      biimpi con3i impbii $.
      $( [5-Aug-1993] $)

  $}

  ${
    imbi12i.1 $e |- ( ph <-> ps ) $.
    imbi12i.2 $e |- ( ch <-> th ) $.
    $( Join two logical equivalences to form equivalence of implications. $)
    imbi12i $p |- ( ( ph -> ch ) <-> ( ps -> th ) ) $=
      wph wch wi wph wth wi wps wth wi wch wth wph imbi12i.2 imbi2i wph wps wth
      imbi12i.1 imbi1i bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpbi.min $e |- ph $.
    mpbi.maj $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus ponens. $)
    mpbi $p |- ps $=
      wph wps mpbi.min wph wps mpbi.maj biimpi ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpbir.min $e |- ps $.
    mpbir.maj $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus ponens. $)
    mpbir $p |- ph $=
      wps wph mpbir.min wph wps mpbir.maj biimpri ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    mtbi.1 $e |- -. ph $.
    mtbi.2 $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus tollens. $)
    mtbi $p |- -. ps $=
      wph wn wps wn mtbi.1 wph wps mtbi.2 notbii mpbi $.
      $( [15-Nov-1994] $)
  $}

  ${
    mtbir.1 $e |- -. ps $.
    mtbir.2 $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus tollens. $)
    mtbir $p |- -. ph $=
      wph wn wps wn mtbir.1 wph wps mtbir.2 notbii mpbir $.
      $( [15-Nov-1994] $)
  $}

  ${
    mpbii.min $e |- ps $.
    mpbii.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a nested biconditional, related to modus ponens. $)
    mpbii $p |- ( ph -> ch ) $=
      wph wps wch mpbii.min wph wps wch mpbii.maj biimpd mpi $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpbiri.min $e |- ch $.
    mpbiri.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a nested biconditional, related to modus ponens. $)
    mpbiri $p |- ( ph -> ps ) $=
      wph wch wps mpbiri.min wph wps wch mpbiri.maj biimprd mpi $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpbid.min $e |- ( ph -> ps ) $.
    mpbid.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, related to modus ponens. $)
    mpbid $p |- ( ph -> ch ) $=
      wph wps wch mpbid.min wph wps wch mpbid.maj biimpd mpd $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpbird.min $e |- ( ph -> ch ) $.
    mpbird.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, related to modus ponens. $)
    mpbird $p |- ( ph -> ps ) $=
      wph wch wps mpbird.min wph wps wch mpbird.maj biimprd mpd $.
      $( [5-Aug-1993] $)
  $}

  ${
    a1bi.1 $e |- ph $.
    $( Inference rule introducing a theorem as an antecedent. $)
    a1bi $p |- ( ps <-> ( ph -> ps ) ) $=
      wps wph wps wi wps wph ax-1 wph wph wps wi wps wi a1bi.1 wph wps pm2.27
      ax-mp impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    sylib.1 $e |- ( ph -> ps ) $.
    sylib.2 $e |- ( ps <-> ch ) $.
    $( A mixed syllogism inference from an implication and a biconditional. $)
    sylib $p |- ( ph -> ch ) $=
      wph wps wch sylib.1 wps wch sylib.2 biimpi syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    sylbi.1 $e |- ( ph <-> ps ) $.
    sylbi.2 $e |- ( ps -> ch ) $.
    $( A mixed syllogism inference from a biconditional and an implication.
       Useful for substituting an antecedent with a definition. $)
    sylbi $p |- ( ph -> ch ) $=
      wph wps wch wph wps sylbi.1 biimpi sylbi.2 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    sylibr.1 $e |- ( ph -> ps ) $.
    sylibr.2 $e |- ( ch <-> ps ) $.
    $( A mixed syllogism inference from an implication and a biconditional.
       Useful for substituting a consequent with a definition. $)
    sylibr $p |- ( ph -> ch ) $=
      wph wps wch sylibr.1 wch wps sylibr.2 biimpri syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    sylbir.1 $e |- ( ps <-> ph ) $.
    sylbir.2 $e |- ( ps -> ch ) $.
    $( A mixed syllogism inference from a biconditional and an implication. $)
    sylbir $p |- ( ph -> ch ) $=
      wph wps wch wps wph sylbir.1 biimpri sylbir.2 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    sylibd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylibd.2 $e |- ( ph -> ( ch <-> th ) ) $.
    $( A syllogism deduction. $)
    sylibd $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth sylibd.1 wph wch wth sylibd.2 biimpd syld $.
      $( [3-Aug-1994] $)
  $}

  ${
    sylbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    sylbid.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( A syllogism deduction. $)
    sylbid $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth wph wps wch sylbid.1 biimpd sylbid.2 syld $.
      $( [3-Aug-1994] $)
  $}

  ${
    sylibrd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylibrd.2 $e |- ( ph -> ( th <-> ch ) ) $.
    $( A syllogism deduction. $)
    sylibrd $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth sylibrd.1 wph wth wch sylibrd.2 biimprd syld $.
      $( [3-Aug-1994] $)
  $}

  ${
    sylbird.1 $e |- ( ph -> ( ch <-> ps ) ) $.
    sylbird.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( A syllogism deduction. $)
    sylbird $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth wph wch wps sylbird.1 biimprd sylbird.2 syld $.
      $( [3-Aug-1994] $)
  $}

  ${
    syl5ib.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl5ib.2 $e |- ( th <-> ps ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional.  Useful for substituting an embedded antecedent with a
       definition. $)
    syl5ib $p |- ( ph -> ( th -> ch ) ) $=
      wph wps wch wth syl5ib.1 wth wps syl5ib.2 biimpi syl5 $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5ibr.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl5ibr.2 $e |- ( ps <-> th ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional. $)
    syl5ibr $p |- ( ph -> ( th -> ch ) ) $=
      wph wps wch wth syl5ibr.1 wps wth syl5ibr.2 biimpri syl5 $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5bi.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl5bi.2 $e |- ( th -> ps ) $.
    $( A mixed syllogism inference. $)
    syl5bi $p |- ( ph -> ( th -> ch ) ) $=
      wph wps wch wth wph wps wch syl5bi.1 biimpd syl5bi.2 syl5 $.
      $( [5-Aug-1993] $)

    $( A mixed syllogism inference. $)
    syl5cbi $p |- ( th -> ( ph -> ch ) ) $=
      wph wth wch wph wps wch wth syl5bi.1 syl5bi.2 syl5bi com12 $.
      $( [22-Jun-2007] $) $( [19-Jun-2007] $)
  $}

  ${
    syl5bir.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl5bir.2 $e |- ( th -> ch ) $.
    $( A mixed syllogism inference. $)
    syl5bir $p |- ( ph -> ( th -> ps ) ) $=
      wph wch wps wth wph wps wch syl5bir.1 biimprd syl5bir.2 syl5 $.
      $( [3-Apr-1994] $)

    $( A mixed syllogism inference. $)
    syl5cbir $p |- ( th -> ( ph -> ps ) ) $=
      wph wth wps wph wps wch wth syl5bir.1 syl5bir.2 syl5bir com12 $.
      $( [20-Jun-2007] $) $( [20-Jun-2007] $)
  $}

  ${
    syl6ib.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6ib.2 $e |- ( ch <-> th ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional. $)
    syl6ib $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth syl6ib.1 wch wth syl6ib.2 biimpi syl6 $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6ibr.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6ibr.2 $e |- ( th <-> ch ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional.  Useful for substituting an embedded consequent with a
       definition. $)
    syl6ibr $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth syl6ibr.1 wth wch syl6ibr.2 biimpri syl6 $.
      $( [5-Aug-1993] $)
  $}


  ${
    syl6bi.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6bi.2 $e |- ( ch -> th ) $.
    $( A mixed syllogism inference. $)
    syl6bi $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth wph wps wch syl6bi.1 biimpd syl6bi.2 syl6 $.
      $( [2-Jan-1994] $)
  $}

  ${
    syl6bir.1 $e |- ( ph -> ( ch <-> ps ) ) $.
    syl6bir.2 $e |- ( ch -> th ) $.
    $( A mixed syllogism inference. $)
    syl6bir $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth wph wch wps syl6bir.1 biimprd syl6bir.2 syl6 $.
      $( [18-May-1994] $)
  $}

  ${
    syl7ib.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl7ib.2 $e |- ( ta <-> ch ) $.
    $( A mixed syllogism inference from a doubly nested implication and a
       biconditional. $)
    syl7ib $p |- ( ph -> ( ps -> ( ta -> th ) ) ) $=
      wph wps wch wth wta syl7ib.1 wta wch syl7ib.2 biimpi syl7 $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl8ib.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl8ib.2 $e |- ( th <-> ta ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the consequent of the first premise. $)
    syl8ib $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      wph wps wch wth wta syl8ib.1 wth wta syl8ib.2 biimpi syl8 $.
      $( [1-Aug-1994] $)
  $}

  ${
    3imtr3.1 $e |- ( ph -> ps ) $.
    3imtr3.2 $e |- ( ph <-> ch ) $.
    3imtr3.3 $e |- ( ps <-> th ) $.
    $( A mixed syllogism inference, useful for removing a definition from both
       sides of an implication. $)
    3imtr3i $p |- ( ch -> th ) $=
      wch wps wth wch wph wps 3imtr3.2 3imtr3.1 sylbir 3imtr3.3 sylib $.
      $( [10-Aug-1994] $)
  $}

  ${
    3imtr4.1 $e |- ( ph -> ps ) $.
    3imtr4.2 $e |- ( ch <-> ph ) $.
    3imtr4.3 $e |- ( th <-> ps ) $.
    $( A mixed syllogism inference, useful for applying a definition to both
       sides of an implication. $)
    3imtr4i $p |- ( ch -> th ) $=
      wch wps wth wch wph wps 3imtr4.2 3imtr4.1 sylbi 3imtr4.3 sylibr $.
      $( [5-Aug-1993] $)
  $}

  ${
    con1bii.1 $e |- ( -. ph <-> ps ) $.
    $( A contraposition inference. $)
    con1bii $p |- ( -. ps <-> ph ) $=
      wps wn wph wph wps wph wn wps con1bii.1 biimpi con1i wps wph wph wn wps
      con1bii.1 biimpri con2i impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    con2bii.1 $e |- ( ph <-> -. ps ) $.
    $( A contraposition inference. $)
    con2bii $p |- ( ps <-> -. ph ) $=
      wph wn wps wps wph wph wps wn con2bii.1 bicomi con1bii bicomi $.
      $( [5-Aug-1993] $)
  $}

  $( For ~ bicon3 :  See ~ notbii . $)

  $( For ~ con4bii :  Later. $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical disjunction and conjunction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare connectives for disjunction ('or') and conjunction ('and'). $)
  $c \/ $. $( Vee (read:  'or') $)
  $c /\ $. $( Wedge (read:  'and') $)

  $( Extend wff definition to include disjunction ('or'). $)
  wo $a wff ( ph \/ ps ) $.
  $( Extend wff definition to include conjunction ('and'). $)
  wa $a wff ( ph /\ ps ) $.

  $( Define disjunction (logical 'or').  This is our first use of the
     biconditional connective in a definition; we use it in place of the
     traditional "<=def=>", which means the same thing, except that we can
     manipulate the biconditional connective directly in proofs rather than
     having to rely on an informal definition substitution rule.  Note that
     if we mechanically substitute ` ( -. ph -> ps ) ` for ` ( ph \/ ps ) ` ,
     we end up with an instance of previously proved theorem ~ biid .  This
     is the justification for the definition, along with the fact that it
     introduces a new symbol ` \/ ` .  Definition of [Margaris] p. 49. $)
  df-or $a |- ( ( ph \/ ps ) <-> ( -. ph -> ps ) ) $.

  $( Define conjunction (logical 'and').  Definition of [Margaris] p. 49. $)
  df-an $a |- ( ( ph /\ ps ) <-> -. ( ph -> -. ps ) ) $.

  $( Theorem *4.64 of [WhiteheadRussell] p. 120. $)
  pm4.64 $p |-  ( ( -. ph -> ps ) <-> ( ph \/ ps ) ) $=
    wph wps wo wph wn wps wi wph wps df-or bicomi $.
    $( [1-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.54 of [WhiteheadRussell] p. 107. $)
  pm2.54 $p |-  ( ( -. ph -> ps ) -> ( ph \/ ps ) ) $=
    wph wps wo wph wn wps wi wph wps df-or biimpri $.
    $( [10-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.63 of [WhiteheadRussell] p. 120. $)
  pm4.63 $p |-  ( -. ( ph -> -. ps ) <-> ( ph /\ ps ) ) $=
    wph wps wa wph wps wn wi wn wph wps df-an bicomi $.
    $( [19-Feb-2005] $) $( [3-Jan-2005] $)

  $( Logical 'or' expressed in terms of implication only.  Theorem *5.25 of
     [WhiteheadRussell] p. 124. $)
  dfor2 $p |- ( ( ph \/ ps ) <-> ( ( ph -> ps ) -> ps ) ) $=
    wph wps wo wph wn wps wi wph wps wi wps wi wph wps df-or wph wn wps wi wph
    wps wi wps wi wph wps pm2.6 wph wn wph wps wi wps wph wps pm2.21 imim1i
    impbii bitri $.
    $( [20-Aug-2004] $) $( [12-Aug-2004] $)

  ${
    ori.1 $e |- ( ph \/ ps ) $.
    $( Infer implication from disjunction. $)
    ori $p |- ( -. ph -> ps ) $=
      wph wps wo wph wn wps wi ori.1 wph wps df-or mpbi $.
      $( [11-Jun-1994] $)
  $}

  ${
    orri.1 $e |- ( -. ph -> ps ) $.
    $( Infer implication from disjunction. $)
    orri $p |- ( ph \/ ps ) $=
      wph wps wo wph wn wps wi orri.1 wph wps df-or mpbir $.
      $( [11-Jun-1994] $)
  $}

  ${
    ord.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    $( Deduce implication from disjunction. $)
    ord $p |- ( ph -> ( -. ps -> ch ) ) $=
      wph wps wch wo wps wn wch wi ord.1 wps wch df-or sylib $.
      $( [18-May-1994] $)
  $}

  ${
    orrd.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Deduce implication from disjunction. $)
    orrd $p |- ( ph -> ( ps \/ ch ) ) $=
      wph wps wn wch wi wps wch wo orrd.1 wps wch df-or sylibr $.
      $( [27-Nov-1995] $)
  $}

  $( Implication in terms of disjunction.  Theorem *4.6 of
     [WhiteheadRussell] p. 120. $)
  imor $p |- ( ( ph -> ps ) <-> ( -. ph \/ ps ) ) $=
    wph wps wi wph wn wn wps wi wph wn wps wo wph wph wn wn wps wph notnot
    imbi1i wph wn wps df-or bitr4i $.
    $( [5-Aug-1993] $)

  $( Theorem *4.62 of [WhiteheadRussell] p. 120. $)
  pm4.62 $p |-  ( ( ph -> -. ps ) <-> ( -. ph \/ -. ps ) ) $=
    wph wps wn imor $.
    $( [24-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.66 of [WhiteheadRussell] p. 120. $)
  pm4.66 $p |-  ( ( -. ph -> -. ps ) <-> ( ph \/ -. ps ) ) $=
    wph wps wn pm4.64 $.
    $( [1-Feb-2005] $) $( [3-Jan-2005] $)

  $( Express implication in terms of conjunction.  Theorem 3.4(27) of [Stoll]
     p. 176. $)
  iman $p |- ( ( ph -> ps ) <-> -. ( ph /\ -. ps ) ) $=
    wph wps wi wph wps wn wn wi wph wps wn wa wn wps wps wn wn wph wps notnot
    imbi2i wph wps wn wa wph wps wn wn wi wph wps wn df-an con2bii bitri $.
    $( [5-Aug-1993] $)

  $( Express conjunction in terms of implication. $)
  annim $p |- ( ( ph /\ -. ps ) <-> -. ( ph -> ps ) ) $=
    wph wps wi wph wps wn wa wph wps iman con2bii $.
    $( [2-Aug-1994] $)

  $( Theorem *4.61 of [WhiteheadRussell] p. 120. $)
  pm4.61 $p |-  ( -. ( ph -> ps ) <-> ( ph /\ -. ps ) ) $=
    wph wps wn wa wph wps wi wn wph wps annim bicomi $.
    $( [24-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.65 of [WhiteheadRussell] p. 120. $)
  pm4.65 $p |-  ( -. ( -. ph -> ps ) <-> ( -. ph /\ -. ps ) ) $=
    wph wn wps pm4.61 $.
    $( [24-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.67 of [WhiteheadRussell] p. 120. $)
  pm4.67 $p |-  ( -. ( -. ph -> -. ps ) <-> ( -. ph /\ ps ) ) $=
    wph wn wps pm4.63 $.
    $( [27-Feb-2005] $) $( [3-Jan-2005] $)

  $( Express implication in terms of conjunction. $)
  imnan $p |- ( ( ph -> -. ps ) <-> -. ( ph /\ ps ) ) $=
    wph wps wa wph wps wn wi wph wps df-an con2bii $.
    $( [9-Apr-1994] $)

  $( Idempotent law for disjunction.  Theorem *4.25 of [WhiteheadRussell]
     p. 117. $)
  oridm $p |- ( ( ph \/ ph ) <-> ph ) $=
    wph wph wo wph wn wph wi wph wph wph df-or wph wph wn wph wi wph wph pm2.24
    wph pm2.18 impbii bitr4i $.
    $( [5-Aug-1993] $)

  $( Theorem *4.25 of [WhiteheadRussell] p. 117. $)
  pm4.25 $p |-  ( ph <-> ( ph \/ ph ) ) $=
    wph wph wo wph wph oridm bicomi $.
    $( [27-Feb-2005] $) $( [3-Jan-2005] $)

  $( Axiom *1.2 (Taut) of [WhiteheadRussell] p. 96. $)
  pm1.2 $p |-  ( ( ph \/ ph ) -> ph ) $=
    wph wph wo wph wph oridm biimpi $.
    $( [27-Feb-2005] $) $( [3-Jan-2005] $)

  $( Commutative law for disjunction.  Theorem *4.31 of [WhiteheadRussell]
     p. 118. $)
  orcom $p |- ( ( ph \/ ps ) <-> ( ps \/ ph ) ) $=
    wph wn wps wi wps wn wph wi wph wps wo wps wph wo wph wps con1b wph wps
    df-or wps wph df-or 3bitr4i $.
    $( [5-Aug-1993] $)

  $( Axiom *1.4 of [WhiteheadRussell] p. 96. $)
  pm1.4 $p |-  ( ( ph \/ ps ) -> ( ps \/ ph ) ) $=
    wph wps wo wps wph wo wph wps orcom biimpi $.
    $( [27-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.62 of [WhiteheadRussell] p. 107. $)
  pm2.62 $p |-  ( ( ph \/ ps ) -> ( ( ph -> ps ) -> ps ) ) $=
    wph wps wo wph wps wi wps wi wph wps dfor2 biimpi $.
    $( [6-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.621 of [WhiteheadRussell] p. 107. $)
  pm2.621 $p |-  ( ( ph -> ps ) -> ( ( ph \/ ps ) -> ps ) ) $=
    wph wps wo wph wps wi wps wph wps pm2.62 com12 $.
    $( [6-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.68 of [WhiteheadRussell] p. 108. $)
  pm2.68 $p |-  ( ( ( ph -> ps ) -> ps ) -> ( ph \/ ps ) ) $=
    wph wps wo wph wps wi wps wi wph wps dfor2 biimpri $.
    $( [27-Feb-2005] $) $( [3-Jan-2005] $)

  $( Elimination of disjunction by denial of a disjunct.  Theorem *2.55 of
     [WhiteheadRussell] p. 107. $)
  orel1 $p |- ( -. ph -> ( ( ph \/ ps ) -> ps ) ) $=
    wph wps wo wph wn wps wph wps wo wph wn wps wi wph wps df-or biimpi com12
    $.
    $( [12-Aug-1994] $)

  $( Elimination of disjunction by denial of a disjunct.  Theorem *2.56 of
     [WhiteheadRussell] p. 107. $)
  orel2 $p |- ( -. ph -> ( ( ps \/ ph ) -> ps ) ) $=
    wph wn wph wps wo wps wps wph wo wph wps orel1 wps wph orcom syl5ib $.
    $( [12-Aug-1994] $)

  $( Theorem *2.25 of [WhiteheadRussell] p. 104. $)
  pm2.25 $p |-  ( ph \/ ( ( ph \/ ps ) -> ps ) ) $=
    wph wph wps wo wps wi wph wps orel1 orri $.
    $( [1-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.53 of [WhiteheadRussell] p. 107. $)
  pm2.53 $p |-  ( ( ph \/ ps ) -> ( -. ph -> ps ) ) $=
    wph wn wph wps wo wps wph wps orel1 com12 $.
    $( [1-Mar-2005] $) $( [3-Jan-2005] $)

  ${
    orbi2i.1 $e |- ( ph <-> ps ) $.

    $( Inference adding a left disjunct to both sides of a logical
       equivalence. $)
    orbi2i $p |- ( ( ch \/ ph ) <-> ( ch \/ ps ) ) $=
      wch wn wph wi wch wn wps wi wch wph wo wch wps wo wph wps wch wn orbi2i.1
      imbi2i wch wph df-or wch wps df-or 3bitr4i $.
      $( [5-Aug-1993] $)

    $( Inference adding a right disjunct to both sides of a logical
       equivalence. $)
    orbi1i $p |- ( ( ph \/ ch ) <-> ( ps \/ ch ) ) $=
      wph wch wo wch wph wo wch wps wo wps wch wo wph wch orcom wph wps wch
      orbi2i.1 orbi2i wch wps orcom 3bitri $.
      $( [5-Aug-1993] $)

  $}

  ${
    orbi12i.1 $e |- ( ph <-> ps ) $.
    orbi12i.2 $e |- ( ch <-> th ) $.
    $( Infer the disjunction of two equivalences. $)
    orbi12i $p |- ( ( ph \/ ch ) <-> ( ps \/ th ) ) $=
      wph wch wo wph wth wo wps wth wo wch wth wph orbi12i.2 orbi2i wph wps wth
      orbi12i.1 orbi1i bitri $.
      $( [5-Aug-1993] $)
  $}

  $( A rearrangement of disjuncts. $)
  or12 $p |- ( ( ph \/ ( ps \/ ch ) ) <-> ( ps \/ ( ph \/ ch ) ) ) $=
    wph wn wps wch wo wi wps wn wph wch wo wi wph wps wch wo wo wps wph wch wo
    wo wps wn wph wn wch wi wi wph wn wps wn wch wi wi wps wn wph wch wo wi wph
    wn wps wch wo wi wps wn wph wn wch bi2.04 wph wch wo wph wn wch wi wps wn
    wph wch df-or imbi2i wps wch wo wps wn wch wi wph wn wps wch df-or imbi2i
    3bitr4ri wph wps wch wo df-or wps wph wch wo df-or 3bitr4i $.
    $( [5-Aug-1993] $)

  $( Axiom *1.5 (Assoc) of [WhiteheadRussell] p. 96. $)
  pm1.5 $p |-  ( ( ph \/ ( ps \/ ch ) ) -> ( ps \/ ( ph \/ ch ) ) ) $=
    wph wps wch wo wo wps wph wch wo wo wph wps wch or12 biimpi $.
    $( [1-Mar-2005] $) $( [3-Jan-2005] $)

  $( Associative law for disjunction.  Theorem *4.33 of [WhiteheadRussell]
     p. 118. $)
  orass $p |- ( ( ( ph \/ ps ) \/ ch ) <-> ( ph \/ ( ps \/ ch ) ) ) $=
    wch wph wps wo wo wph wch wps wo wo wph wps wo wch wo wph wps wch wo wo wch
    wph wps or12 wph wps wo wch orcom wps wch wo wch wps wo wph wps wch orcom
    orbi2i 3bitr4i $.
    $( [5-Aug-1993] $)

  $( Theorem *2.31 of [WhiteheadRussell] p. 104. $)
  pm2.31 $p |-  ( ( ph \/ ( ps \/ ch ) ) -> ( ( ph \/ ps ) \/ ch ) ) $=
    wph wps wo wch wo wph wps wch wo wo wph wps wch orass biimpri $.
    $( [2-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.32 of [WhiteheadRussell] p. 105. $)
  pm2.32 $p |-  ( ( ( ph \/ ps ) \/ ch ) -> ( ph \/ ( ps \/ ch ) ) ) $=
    wph wps wo wch wo wph wps wch wo wo wph wps wch orass biimpi $.
    $( [6-Mar-2005] $) $( [3-Jan-2005] $)

  $( A rearrangement of disjuncts. $)
  or23 $p |- ( ( ( ph \/ ps ) \/ ch ) <-> ( ( ph \/ ch ) \/ ps ) ) $=
    wph wps wch wo wo wph wch wps wo wo wph wps wo wch wo wph wch wo wps wo wps
    wch wo wch wps wo wph wps wch orcom orbi2i wph wps wch orass wph wch wps
    orass 3bitr4i $.
    $( [18-Oct-1995] $)

  $( Rearrangement of 4 disjuncts. $)
  or4 $p |- ( ( ( ph \/ ps ) \/ ( ch \/ th ) ) <->
                ( ( ph \/ ch ) \/ ( ps \/ th ) ) ) $=
    wph wps wch wth wo wo wo wph wch wps wth wo wo wo wph wps wo wch wth wo wo
    wph wch wo wps wth wo wo wps wch wth wo wo wch wps wth wo wo wph wps wch
    wth or12 orbi2i wph wps wch wth wo orass wph wch wps wth wo orass 3bitr4i
    $.
    $( [12-Aug-1994] $)

  $( Rearrangement of 4 disjuncts. $)
  or42 $p |- ( ( ( ph \/ ps ) \/ ( ch \/ th ) ) <->
                 ( ( ph \/ ch ) \/ ( th \/ ps ) ) ) $=
    wph wps wo wch wth wo wo wph wch wo wps wth wo wo wph wch wo wth wps wo wo
    wph wps wch wth or4 wps wth wo wth wps wo wph wch wo wps wth orcom orbi2i
    bitri $.
    $( [11-Jan-2005] $) $( [10-Jan-2005] $)

  $( Distribution of disjunction over disjunction. $)
  orordi $p |- ( ( ph \/ ( ps \/ ch ) ) <->
               ( ( ph \/ ps ) \/ ( ph \/ ch ) ) ) $=
    wph wps wch wo wo wph wph wo wps wch wo wo wph wps wo wph wch wo wo wph wph
    wo wph wps wch wo wph oridm orbi1i wph wph wps wch or4 bitr3i $.
    $( [25-Feb-1995] $)

  $( Distribution of disjunction over disjunction. $)
  orordir $p |- ( ( ( ph \/ ps ) \/ ch ) <->
               ( ( ph \/ ch ) \/ ( ps \/ ch ) ) ) $=
    wph wps wo wch wo wph wps wo wch wch wo wo wph wch wo wps wch wo wo wch wch
    wo wch wph wps wo wch oridm orbi2i wph wps wch wch or4 bitr3i $.
    $( [25-Feb-1995] $)

  $( Introduction of a disjunct.  Axiom *1.3 of [WhiteheadRussell] p. 96. $)
  olc $p |- ( ph -> ( ps \/ ph ) ) $=
    wph wps wph wph wps wn ax-1 orrd $.
    $( [30-Aug-1993] $)

  $( Introduction of a disjunct.  Theorem *2.2 of [WhiteheadRussell] p. 104. $)
  orc $p |- ( ph -> ( ph \/ ps ) ) $=
    wph wph wps wph wps pm2.24 orrd $.
    $( [30-Aug-1993] $)

  ${
    orci.1 $e |- ph $.
    $( Deduction introducing a disjunct. $)
    orci $p |- ( ph \/ ps ) $=
      wph wph wps wo orci.1 wph wps orc ax-mp $.
      $( [20-Jan-2008] $) $( [19-Jan-2008] $)

    $( Deduction introducing a disjunct. $)
    olci $p |- ( ps \/ ph ) $=
      wph wps wph wo orci.1 wph wps olc ax-mp $.
      $( [20-Jan-2008] $) $( [19-Jan-2008] $)
  $}

  ${
    orcd.1 $e |- ( ph -> ps ) $.
    $( Deduction introducing a disjunct. $)
    orcd $p |- ( ph -> ( ps \/ ch ) ) $=
      wph wps wps wch wo orcd.1 wps wch orc syl $.
      $( [19-Feb-2008] $) $( [20-Sep-2007] $)

    $( Deduction introducing a disjunct. $)
    olcd $p |- ( ph -> ( ch \/ ps ) ) $=
      wph wps wch wps wo orcd.1 wps wch olc syl $.
      $( [11-Apr-2008] $) $( [11-Apr-2008] $)
  $}

  ${
    orcs.1 $e |- ( ( ph \/ ps ) -> ch ) $.
    $( Deduction eliminating disjunct. $)
    orcs $p |- ( ph -> ch ) $=
      wph wph wps wo wch wph wps orc orcs.1 syl $.
      $( [21-Jun-1994] $)
  $}

  ${
    olcs.1 $e |- ( ( ph \/ ps ) -> ch ) $.
    $( Deduction eliminating disjunct. $)
    olcs $p |- ( ps -> ch ) $=
      wps wph wps wo wch wps wph olc olcs.1 syl $.
      $( [21-Jun-1994] $)
  $}

  $( Theorem *2.07 of [WhiteheadRussell] p. 101. $)
  pm2.07 $p |-  ( ph -> ( ph \/ ph ) ) $=
    wph wph olc $.
    $( [6-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.45 of [WhiteheadRussell] p. 106. $)
  pm2.45 $p |-  ( -. ( ph \/ ps ) -> -. ph ) $=
    wph wph wps wo wph wps orc con3i $.
    $( [8-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.46 of [WhiteheadRussell] p. 106. $)
  pm2.46 $p |-  ( -. ( ph \/ ps ) -> -. ps ) $=
    wps wph wps wo wps wph olc con3i $.
    $( [8-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.47 of [WhiteheadRussell] p. 107. $)
  pm2.47 $p |-  ( -. ( ph \/ ps ) -> ( -. ph \/ ps ) ) $=
    wph wps wo wn wph wn wps wph wps pm2.45 orcd $.
    $( [6-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.48 of [WhiteheadRussell] p. 107. $)
  pm2.48 $p |-  ( -. ( ph \/ ps ) -> ( ph \/ -. ps ) ) $=
    wph wps wo wn wps wn wph wph wps pm2.46 olcd $.
    $( [9-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.49 of [WhiteheadRussell] p. 107. $)
  pm2.49 $p |-  ( -. ( ph \/ ps ) -> ( -. ph \/ -. ps ) ) $=
    wph wps wo wn wps wn wph wn wph wps pm2.46 olcd $.
    $( [7-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.67 of [WhiteheadRussell] p. 107. $)
  pm2.67 $p |-  ( ( ( ph \/ ps ) -> ps ) -> ( ph -> ps ) ) $=
    wph wph wps wo wps wph wps orc imim1i $.
    $( [6-Jan-2005] $) $( [3-Jan-2005] $)

  $( Join antecedents with conjunction.  Theorem *3.2 of [WhiteheadRussell]
     p. 111. $)
  pm3.2 $p |- ( ph -> ( ps -> ( ph /\ ps ) ) ) $=
    wph wps wph wps wa wph wps wa wph wps wn wi wn wph wps df-an biimpri expi
    $.
    $( [5-Aug-1993] $)

  $( Join antecedents with conjunction.  Theorem *3.21 of
     [WhiteheadRussell] p. 111. $)
  pm3.21 $p |- ( ph -> ( ps -> ( ps /\ ph ) ) ) $=
    wps wph wps wph wa wps wph pm3.2 com12 $.
    $( [5-Aug-1993] $)

  ${
    pm3.2i.1 $e |- ph $.
    pm3.2i.2 $e |- ps $.
    $( Infer conjunction of premises. $)
    pm3.2i $p |- ( ph /\ ps ) $=
      wph wps wph wps wa pm3.2i.1 pm3.2i.2 wph wps pm3.2 mp2 $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem *3.37 (Transp) of [WhiteheadRussell] p. 112. $)
  pm3.37 $p |-  ( ( ( ph /\ ps ) -> ch ) -> ( ( ph /\ -. ch ) -> -. ps ) ) $=
    wph wps wa wch wi wps wph wch wn wa wph wps wa wch wi wps wph wch wi wph
    wch wn wa wn wps wph wps wa wch wi wph wch wi wps wph wph wps wa wch wps
    wph pm3.21 imim1d com12 wph wch iman syl6ib con2d $.
    $( [7-Mar-2005] $) $( [3-Jan-2005] $)

  $( Nested conjunction of antecedents. $)
  pm3.43i $p |- ( ( ph -> ps ) ->
                ( ( ph -> ch ) -> ( ph -> ( ps /\ ch ) ) ) ) $=
    wps wch wps wch wa wph wps wch pm3.2 imim3i $.
    $( [5-Aug-1993] $)

  ${
    jca.1 $e |- ( ph -> ps ) $.
    jca.2 $e |- ( ph -> ch ) $.
    $( Deduce conjunction of the consequents of two implications ("join
       consequents with 'and'"). $)
    jca $p |- ( ph -> ( ps /\ ch ) ) $=
      wph wps wch wn wi wn wps wch wa wph wps wch jca.1 jca.2 jc wps wch df-an
      sylibr $.
      $( [5-Aug-1993] $)
  $}

  ${
    jca31.1 $e |- ( ph -> ps ) $.
    jca31.2 $e |- ( ph -> ch ) $.
    jca31.3 $e |- ( ph -> th ) $.
    $( Join three consequents.  (Contributed by Jeff Hankins, 1-Aug-2009.) $)
    jca31 $p |- ( ph -> ( ( ps /\ ch ) /\ th ) ) $=
      wph wps wch wa wth wph wps wch jca31.1 jca31.2 jca jca31.3 jca $.
      $( [18-Apr-2010] $) $( [1-Aug-2009] $)

    $( Join three consequents.  (Contributed by FL, 1-Aug-2009.) $)
    jca32 $p |- ( ph -> ( ps /\ ( ch /\ th ) ) ) $=
      wph wps wch wth wa jca31.1 wph wch wth jca31.2 jca31.3 jca jca $.
      $( [18-Apr-2010] $) $( [1-Aug-2009] $)
  $}

  ${
    jcai.1 $e |- ( ph -> ps ) $.
    jcai.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction replacing implication with conjunction. $)
    jcai $p |- ( ph -> ( ps /\ ch ) ) $=
      wph wps wch jcai.1 wph wps wch jcai.1 jcai.2 mpd jca $.
      $( [5-Aug-1993] $)
  $}

  ${
    jctl.1 $e |- ps $.
    $( Inference conjoining a theorem to the left of a consequent. $)
    jctl $p |- ( ph -> ( ps /\ ph ) ) $=
      wph wps wph wps wph jctl.1 a1i wph id jca $.
      $( [31-Dec-1993] $)
  $}

  ${
    jctr.1 $e |- ps $.
    $( Inference conjoining a theorem to the right of a consequent. $)
    jctr $p |- ( ph -> ( ph /\ ps ) ) $=
      wph wph wps wph id wps wph jctr.1 a1i jca $.
      $( [18-Aug-1993] $)
  $}

  ${
    jctil.1 $e |- ( ph -> ps ) $.
    jctil.2 $e |- ch $.
    $( Inference conjoining a theorem to left of consequent in an
       implication. $)
    jctil $p |- ( ph -> ( ch /\ ps ) ) $=
      wph wch wps wch wph jctil.2 a1i jctil.1 jca $.
      $( [31-Dec-1993] $)
  $}

  ${
    jctir.1 $e |- ( ph -> ps ) $.
    jctir.2 $e |- ch $.
    $( Inference conjoining a theorem to right of consequent in an
       implication. $)
    jctir $p |- ( ph -> ( ps /\ ch ) ) $=
      wph wps wch jctir.1 wch wph jctir.2 a1i jca $.
      $( [31-Dec-1993] $)
  $}

  $( Conjoin antecedent to left of consequent. $)
  ancl $p |- ( ( ph -> ps ) -> ( ph -> ( ph /\ ps ) ) ) $=
    wph wps wph wps wa wph wps pm3.2 a2i $.
    $( [15-Aug-1994] $)

  $( Conjoin antecedent to right of consequent. $)
  ancr $p |- ( ( ph -> ps ) -> ( ph -> ( ps /\ ph ) ) ) $=
    wph wps wps wph wa wph wps pm3.21 a2i $.
    $( [15-Aug-1994] $)

  ${
    ancli.1 $e |- ( ph -> ps ) $.
    $( Deduction conjoining antecedent to left of consequent. $)
    ancli $p |- ( ph -> ( ph /\ ps ) ) $=
      wph wph wps wph id ancli.1 jca $.
      $( [12-Aug-1993] $)
  $}

  ${
    ancri.1 $e |- ( ph -> ps ) $.
    $( Deduction conjoining antecedent to right of consequent. $)
    ancri $p |- ( ph -> ( ps /\ ph ) ) $=
      wph wps wph ancri.1 wph id jca $.
      $( [15-Aug-1994] $)
  $}

  ${
    ancld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to left of consequent in nested
       implication. $)
    ancld $p |- ( ph -> ( ps -> ( ps /\ ch ) ) ) $=
      wph wps wch wi wps wps wch wa wi ancld.1 wps wch ancl syl $.
      $( [15-Aug-1994] $)
  $}

  ${
    ancrd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to right of consequent in nested
       implication. $)
    ancrd $p |- ( ph -> ( ps -> ( ch /\ ps ) ) ) $=
      wph wps wch wi wps wch wps wa wi ancrd.1 wps wch ancr syl $.
      $( [15-Aug-1994] $)
  $}

  $( Conjoin antecedent to left of consequent in nested implication. $)
  anc2l $p |- ( ( ph -> ( ps -> ch ) ) -> ( ph -> ( ps -> ( ph /\ ch ) ) ) ) $=
    wph wps wch wi wps wph wch wa wi wph wch wph wch wa wps wph wch pm3.2
    imim2d a2i $.
    $( [10-Aug-1994] $)

  $( Conjoin antecedent to right of consequent in nested implication. $)
  anc2r $p |- ( ( ph -> ( ps -> ch ) ) -> ( ph -> ( ps -> ( ch /\ ph ) ) ) ) $=
    wph wps wch wi wps wch wph wa wi wph wch wch wph wa wps wph wch pm3.21
    imim2d a2i $.
    $( [15-Aug-1994] $)

  ${
    anc2li.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to left of consequent in nested
       implication. $)
    anc2li $p |- ( ph -> ( ps -> ( ph /\ ch ) ) ) $=
      wph wps wch wi wi wph wps wph wch wa wi wi anc2li.1 wph wps wch anc2l
      ax-mp $.
      $( [10-Aug-1994] $)
  $}

  ${
    anc2ri.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to right of consequent in nested
       implication. $)
    anc2ri $p |- ( ph -> ( ps -> ( ch /\ ph ) ) ) $=
      wph wps wch wi wi wph wps wch wph wa wi wi anc2ri.1 wph wps wch anc2r
      ax-mp $.
      $( [15-Aug-1994] $)
  $}

  $( Conjunction in terms of disjunction (DeMorgan's law).  Theorem *4.5 of
     [WhiteheadRussell] p. 120. $)
  anor $p |- ( ( ph /\ ps ) <-> -. ( -. ph \/ -. ps ) ) $=
    wph wps wa wph wps wn wi wn wph wn wps wn wo wn wph wps df-an wph wps wn wi
    wph wn wps wn wo wph wps pm4.62 notbii bitri $.
    $( [5-Aug-1993] $)

  $( Negated conjunction in terms of disjunction (DeMorgan's law).  Theorem
     *4.51 of [WhiteheadRussell] p. 120. $)
  ianor $p |- ( -. ( ph /\ ps ) <-> ( -. ph \/ -. ps ) ) $=
    wph wps wa wn wph wn wps wn wo wn wn wph wn wps wn wo wph wps wa wph wn wps
    wn wo wn wph wps anor notbii wph wn wps wn wo notnot bitr4i $.
    $( [5-Aug-1993] $)

  $( Negated disjunction in terms of conjunction (DeMorgan's law).  Compare
     Theorem *4.56 of [WhiteheadRussell] p. 120. $)
  ioran $p |- ( -. ( ph \/ ps ) <-> ( -. ph /\ -. ps ) ) $=
    wph wps wo wn wph wn wn wps wn wn wo wn wph wn wps wn wa wph wps wo wph wn
    wn wps wn wn wo wph wph wn wn wps wps wn wn wph notnot wps notnot orbi12i
    notbii wph wn wps wn anor bitr4i $.
    $( [5-Aug-1993] $)

  $( Theorem *4.52 of [WhiteheadRussell] p. 120. $)
  pm4.52 $p |-  ( ( ph /\ -. ps ) <-> -. ( -. ph \/ ps ) ) $=
    wph wps wn wa wph wn wps wn wn wo wn wph wn wps wo wn wph wps wn anor wph
    wn wps wo wph wn wps wn wn wo wps wps wn wn wph wn wps notnot orbi2i notbii
    bitr4i $.
    $( [11-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.53 of [WhiteheadRussell] p. 120. $)
  pm4.53 $p |-  ( -. ( ph /\ -. ps ) <-> ( -. ph \/ ps ) ) $=
    wph wn wps wo wph wps wn wa wn wph wps wn wa wph wn wps wo wph wps pm4.52
    con2bii bicomi $.
    $( [11-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.54 of [WhiteheadRussell] p. 120. $)
  pm4.54 $p |-  ( ( -. ph /\ ps ) <-> -. ( ph \/ -. ps ) ) $=
    wph wn wps wa wph wn wn wps wn wo wn wph wps wn wo wn wph wn wps anor wph
    wps wn wo wph wn wn wps wn wo wph wph wn wn wps wn wph notnot orbi1i notbii
    bitr4i $.
    $( [11-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.55 of [WhiteheadRussell] p. 120. $)
  pm4.55 $p |-  ( -. ( -. ph /\ ps ) <-> ( ph \/ -. ps ) ) $=
    wph wps wn wo wph wn wps wa wn wph wn wps wa wph wps wn wo wph wps pm4.54
    con2bii bicomi $.
    $( [11-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.56 of [WhiteheadRussell] p. 120. $)
  pm4.56 $p |-  ( ( -. ph /\ -. ps ) <-> -. ( ph \/ ps ) ) $=
    wph wps wo wn wph wn wps wn wa wph wps ioran bicomi $.
    $( [11-Mar-2005] $) $( [3-Jan-2005] $)

  $( Disjunction in terms of conjunction (DeMorgan's law).  Compare Theorem
     *4.57 of [WhiteheadRussell] p. 120. $)
  oran $p |- ( ( ph \/ ps ) <-> -. ( -. ph /\ -. ps ) ) $=
    wph wps wo wph wps wo wn wn wph wn wps wn wa wn wph wps wo notnot wph wps
    wo wn wph wn wps wn wa wph wps ioran notbii bitri $.
    $( [5-Aug-1993] $)

  $( Theorem *4.57 of [WhiteheadRussell] p. 120. $)
  pm4.57 $p |-  ( -. ( -. ph /\ -. ps ) <-> ( ph \/ ps ) ) $=
    wph wps wo wph wn wps wn wa wn wph wps oran bicomi $.
    $( [11-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.1 of [WhiteheadRussell] p. 111. $)
  pm3.1 $p |-  ( ( ph /\ ps ) -> -. ( -. ph \/ -. ps ) ) $=
    wph wps wa wph wn wps wn wo wn wph wps anor biimpi $.
    $( [21-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.11 of [WhiteheadRussell] p. 111. $)
  pm3.11 $p |-  ( -. ( -. ph \/ -. ps ) -> ( ph /\ ps ) ) $=
    wph wps wa wph wn wps wn wo wn wph wps anor biimpri $.
    $( [25-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.12 of [WhiteheadRussell] p. 111. $)
  pm3.12 $p |-  ( ( -. ph \/ -. ps ) \/ ( ph /\ ps ) ) $=
    wph wn wps wn wo wph wps wa wph wps pm3.11 orri $.
    $( [25-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.13 of [WhiteheadRussell] p. 111. $)
  pm3.13 $p |-  ( -. ( ph /\ ps ) -> ( -. ph \/ -. ps ) ) $=
    wph wn wps wn wo wph wps wa wph wps pm3.11 con1i $.
    $( [25-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.14 of [WhiteheadRussell] p. 111. $)
  pm3.14 $p |-  ( ( -. ph \/ -. ps ) -> -. ( ph /\ ps ) ) $=
    wph wps wa wph wn wps wn wo wph wps pm3.1 con2i $.
    $( [25-Mar-2005] $) $( [3-Jan-2005] $)

  $( Elimination of a conjunct.  Theorem *3.26 (Simp) of [WhiteheadRussell]
     p. 112. $)
  pm3.26 $p |- ( ( ph /\ ps ) -> ph ) $=
    wph wps wa wph wps wn wi wn wph wph wps df-an wph wps pm3.26im sylbi $.
    $( [5-Aug-1993] $)

  ${
    pm3.26i.1 $e |- ( ph /\ ps ) $.
    $( Inference eliminating a conjunct. $)
    pm3.26i $p |- ph $=
      wph wps wa wph pm3.26i.1 wph wps pm3.26 ax-mp $.
      $( [15-Jun-1994] $)
  $}

  ${
    pm3.26d.1 $e |- ( ph -> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct. $)
    pm3.26d $p |- ( ph -> ps ) $=
      wph wps wch wa wps pm3.26d.1 wps wch pm3.26 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    pm3.26bi.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct. $)
    pm3.26bi $p |- ( ph -> ps ) $=
      wph wps wch wph wps wch wa pm3.26bi.1 biimpi pm3.26d $.
      $( [27-May-1998] $)
  $}

  $( Elimination of a conjunct.  Theorem *3.27 (Simp) of [WhiteheadRussell]
     p. 112. $)
  pm3.27 $p |- ( ( ph /\ ps ) -> ps ) $=
    wph wps wa wph wps wn wi wn wps wph wps df-an wph wps pm3.27im sylbi $.
    $( [5-Aug-1993] $)

  ${
    pm3.27i.1 $e |- ( ph /\ ps ) $.
    $( Inference eliminating a conjunct. $)
    pm3.27i $p |- ps $=
      wph wps wa wps pm3.27i.1 wph wps pm3.27 ax-mp $.
      $( [15-Jun-1994] $)
  $}

  ${
    pm3.27d.1 $e |- ( ph -> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct. $)
    pm3.27d $p |- ( ph -> ch ) $=
      wph wps wch wa wch pm3.27d.1 wps wch pm3.27 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    pm3.27bi.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct. $)
    pm3.27bi $p |- ( ph -> ch ) $=
      wph wps wch wph wps wch wa pm3.27bi.1 biimpi pm3.27d $.
      $( [27-May-1998] $)
  $}

  $( Theorem *3.41 of [WhiteheadRussell] p. 113. $)
  pm3.41 $p |-  ( ( ph -> ch ) -> ( ( ph /\ ps ) -> ch ) ) $=
    wph wps wa wph wch wph wps pm3.26 imim1i $.
    $( [21-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.42 of [WhiteheadRussell] p. 113. $)
  pm3.42 $p |-  ( ( ps -> ch ) -> ( ( ph /\ ps ) -> ch ) ) $=
    wph wps wa wps wch wph wps pm3.27 imim1i $.
    $( [27-Mar-2005] $) $( [3-Jan-2005] $)

  $( Conjoin antecedent to left of consequent.  Theorem *4.7 of
     [WhiteheadRussell] p. 120. $)
  anclb $p |- ( ( ph -> ps ) <-> ( ph -> ( ph /\ ps ) ) ) $=
    wph wps wi wph wph wps wa wi wph wps ancl wph wps wa wps wph wph wps pm3.27
    imim2i impbii $.
    $( [25-Jul-1999] $)

  $( Conjoin antecedent to right of consequent. $)
  ancrb $p |- ( ( ph -> ps ) <-> ( ph -> ( ps /\ ph ) ) ) $=
    wph wps wi wph wps wph wa wi wph wps ancr wps wph wa wps wph wps wph pm3.26
    imim2i impbii $.
    $( [25-Jul-1999] $)

  $( Conjunction implies implication.  Theorem *3.4 of [WhiteheadRussell]
     p. 113. $)
  pm3.4 $p |- ( ( ph /\ ps ) -> ( ph -> ps ) ) $=
    wph wps wa wps wph wph wps pm3.27 a1d $.
    $( [31-Jul-1995] $)

  $( Conjunction with implication.  Compare Theorem *4.45 of
     [WhiteheadRussell] p. 119. $)
  pm4.45im $p |- ( ph <-> ( ph /\ ( ps -> ph ) ) ) $=
    wph wph wps wph wi wa wph wps wph wi wph wps ax-1 ancli wph wps wph wi
    pm3.26 impbii $.
    $( [17-May-1998] $)

  ${
    anim12i.1 $e |- ( ph -> ps ) $.
    anim12i.2 $e |- ( ch -> th ) $.
    $( Conjoin antecedents and consequents of two premises. $)
    anim12i $p |- ( ( ph /\ ch ) -> ( ps /\ th ) ) $=
      wph wch wa wps wth wph wch wa wph wps wph wch pm3.26 anim12i.1 syl wph
      wch wa wch wth wph wch pm3.27 anim12i.2 syl jca $.
      $( [5-Aug-1993] $)
  $}

  ${
    anim1i.1 $e |- ( ph -> ps ) $.
    $( Introduce conjunct to both sides of an implication. $)
    anim1i $p |- ( ( ph /\ ch ) -> ( ps /\ ch ) ) $=
      wph wps wch wch anim1i.1 wch id anim12i $.
      $( [5-Aug-1993] $)

    $( Introduce conjunct to both sides of an implication. $)
    anim2i $p |- ( ( ch /\ ph ) -> ( ch /\ ps ) ) $=
      wch wch wph wps wch id anim1i.1 anim12i $.
      $( [5-Aug-1993] $)
  $}

  ${
    orim12i.1 $e |- ( ph -> ps ) $.
    orim12i.2 $e |- ( ch -> th ) $.
    $( Disjoin antecedents and consequents of two premises. $)
    orim12i $p |- ( ( ph \/ ch ) -> ( ps \/ th ) ) $=
      wph wn wch wn wa wn wps wn wth wn wa wn wph wch wo wps wth wo wps wn wth
      wn wa wph wn wch wn wa wps wn wph wn wth wn wch wn wph wps orim12i.1
      con3i wch wth orim12i.2 con3i anim12i con3i wph wch oran wps wth oran
      3imtr4i $.
      $( [6-Jun-1994] $)
  $}

  ${
    orim1i.1 $e |- ( ph -> ps ) $.
    $( Introduce disjunct to both sides of an implication. $)
    orim1i $p |- ( ( ph \/ ch ) -> ( ps \/ ch ) ) $=
      wph wps wch wch orim1i.1 wch id orim12i $.
      $( [6-Jun-1994] $)

    $( Introduce disjunct to both sides of an implication. $)
    orim2i $p |- ( ( ch \/ ph ) -> ( ch \/ ps ) ) $=
      wch wch wph wps wch id orim1i.1 orim12i $.
      $( [6-Jun-1994] $)
  $}

  $( Theorem *2.3 of [WhiteheadRussell] p. 104. $)
  pm2.3 $p |-  ( ( ph \/ ( ps \/ ch ) ) -> ( ph \/ ( ch \/ ps ) ) ) $=
    wps wch wo wch wps wo wph wps wch pm1.4 orim2i $.
    $( [2-Apr-2005] $) $( [3-Jan-2005] $)

  $( Disjunction of antecedents.  Compare Theorem *3.44 of
     [WhiteheadRussell] p. 113. $)
  jao $p |- ( ( ph -> ps ) -> ( ( ch -> ps ) -> ( ( ph \/ ch ) -> ps ) ) ) $=
    wph wps wi wps wn wph wn wi wch wps wi wph wch wo wps wi wi wph wps con3
    wps wn wph wn wi wps wn wch wn wi wph wch wo wps wi wch wps wi wps wn wph
    wn wi wps wn wch wn wi wph wn wch wn wa wn wps wph wch wo wps wn wph wn wi
    wps wn wch wn wi wps wn wph wn wch wn wa wi wph wn wch wn wa wn wps wi wps
    wn wph wn wch wn pm3.43i wps wph wn wch wn wa con1 syl6 wph wch oran syl7ib
    wch wps con3 syl5 syl $.
    $( [5-Apr-1994] $)

  ${
    jaoi.1 $e |- ( ph -> ps ) $.
    jaoi.2 $e |- ( ch -> ps ) $.
    $( Inference disjoining the antecedents of two implications. $)
    jaoi $p |- ( ( ph \/ ch ) -> ps ) $=
      wph wps wi wch wps wi wph wch wo wps wi jaoi.1 jaoi.2 wph wps wch jao mp2
      $.
      $( [5-Apr-1994] $)
  $}

  $( Theorem *2.41 of [WhiteheadRussell] p. 106. $)
  pm2.41 $p |-  ( ( ps \/ ( ph \/ ps ) ) -> ( ph \/ ps ) ) $=
    wps wph wps wo wph wps wo wps wph olc wph wps wo id jaoi $.
    $( [2-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.42 of [WhiteheadRussell] p. 106. $)
  pm2.42 $p |-  ( ( -. ph \/ ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    wph wn wph wps wi wph wps wi wph wps pm2.21 wph wps wi id jaoi $.
    $( [2-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.4 of [WhiteheadRussell] p. 106. $)
  pm2.4 $p |-  ( ( ph \/ ( ph \/ ps ) ) -> ( ph \/ ps ) ) $=
    wph wph wps wo wph wps wo wph wps orc wph wps wo id jaoi $.
    $( [2-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.44 of [WhiteheadRussell] p. 119. $)
  pm4.44 $p |-  ( ph <-> ( ph \/ ( ph /\ ps ) ) ) $=
    wph wph wph wps wa wo wph wph wps wa orc wph wph wph wps wa wph id wph wps
    pm3.26 jaoi impbii $.
    $( [2-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.63 of [WhiteheadRussell] p. 125. $)
  pm5.63 $p |-  ( ( ph \/ ps ) <-> ( ph \/ ( -. ph /\ ps ) ) ) $=
    wph wps wo wph wph wn wps wa wo wph wps wo wph wph wn wps wa wph wps wo wph
    wn wps wph wps pm2.53 ancld orrd wph wph wn wps wa wo wph wps wph wph wn
    wps wi wph wn wps wa wph wps pm2.24 wph wn wps pm3.4 jaoi orrd impbii $.
    $( [2-Apr-2005] $) $( [3-Jan-2005] $)

  $( Import-export theorem.  Part of Theorem *4.87 of [WhiteheadRussell]
     p. 122. $)
  impexp $p |- ( ( ( ph /\ ps ) -> ch ) <-> ( ph -> ( ps -> ch ) ) ) $=
    wph wps wa wch wi wph wps wn wi wn wch wi wph wps wch wi wi wph wps wa wph
    wps wn wi wn wch wph wps df-an imbi1i wph wps wn wi wn wch wi wph wps wch
    wi wi wph wps wch expt wph wps wch impt impbii bitri $.
    $( [5-Aug-1993] $)

  $( Theorem *3.3 (Exp) of [WhiteheadRussell] p. 112. $)
  pm3.3 $p |-  ( ( ( ph /\ ps ) -> ch ) -> ( ph -> ( ps -> ch ) ) ) $=
    wph wps wa wch wi wph wps wch wi wi wph wps wch impexp biimpi $.
    $( [10-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.31 (Imp) of [WhiteheadRussell] p. 112. $)
  pm3.31 $p |-  ( ( ph -> ( ps -> ch ) ) -> ( ( ph /\ ps ) -> ch ) ) $=
    wph wps wa wch wi wph wps wch wi wi wph wps wch impexp biimpri $.
    $( [14-Apr-2005] $) $( [3-Jan-2005] $)

  ${
    imp.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Importation inference.  (The proof was shortened by Eric Schmidt,
       22-Dec-2006.) $)
    imp $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wch wi wph wps wch wi wi imp.1 wph wps wch impexp mpbir $.
      $( [22-Dec-2006] $) $( [5-Aug-1993] $)

    $( Importation inference with commuted antecedents. $)
    impcom $p |- ( ( ps /\ ph ) -> ch ) $=
      wps wph wch wph wps wch imp.1 com12 imp $.
      $( [26-May-2005] $) $( [25-May-2005] $)
  $}

  $( Theorem *4.14 of [WhiteheadRussell] p. 117. $)
  pm4.14 $p |-  ( ( ( ph /\ ps ) -> ch ) <-> ( ( ph /\ -. ch ) -> -. ps ) ) $=
    wph wps wa wch wi wps wph wch wi wi wps wph wch wn wa wn wi wph wch wn wa
    wps wn wi wph wps wa wch wi wph wps wch wi wi wps wph wch wi wi wph wps wch
    impexp wph wps wch bi2.04 bitri wph wch wi wph wch wn wa wn wps wph wch
    iman imbi2i wps wph wch wn wa con2b 3bitri $.
    $( [11-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.15 of [WhiteheadRussell] p. 117. $)
  pm4.15 $p |-  ( ( ( ph /\ ps ) -> -. ch ) <-> ( ( ps /\ ch ) -> -. ph ) ) $=
    wph wps wa wch wn wi wph wps wch wn wi wi wph wps wch wa wn wi wps wch wa
    wph wn wi wph wps wch wn impexp wps wch wn wi wps wch wa wn wph wps wch
    imnan imbi2i wph wps wch wa con2b 3bitri $.
    $( [11-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.78 of [WhiteheadRussell] p. 121. $)
  pm4.78 $p |-  ( ( ( ph -> ps ) \/ ( ph -> ch ) ) <->
                ( ph -> ( ps \/ ch ) ) ) $=
    wph wps wi wn wph wch wi wi wph wps wn wch wi wi wph wps wi wph wch wi wo
    wph wps wch wo wi wph wps wn wa wph wch wi wi wph wps wn wph wch wi wi wi
    wph wps wi wn wph wch wi wi wph wps wn wch wi wi wph wps wn wph wch wi
    impexp wph wps wn wa wph wps wi wn wph wch wi wph wps annim imbi1i wph wps
    wn wph wch wi wi wi wph wph wps wn wch wi wi wi wph wps wn wch wi wi wps wn
    wph wch wi wi wph wps wn wch wi wi wph wps wn wph wch bi2.04 imbi2i wph wps
    wn wch wi pm5.4 bitri 3bitr3i wph wps wi wph wch wi df-or wps wch wo wps wn
    wch wi wph wps wch df-or imbi2i 3bitr4i $.
    $( [10-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.79 of [WhiteheadRussell] p. 121. $)
  pm4.79 $p |-  ( ( ( ps -> ph ) \/ ( ch -> ph ) ) <->
                ( ( ps /\ ch ) -> ph ) ) $=
    wph wn wps wn wi wph wn wch wn wi wo wph wn wps wch wa wn wi wps wph wi wch
    wph wi wo wps wch wa wph wi wph wn wps wn wi wph wn wch wn wi wo wph wn wps
    wn wch wn wo wi wph wn wps wch wa wn wi wph wn wps wn wch wn pm4.78 wps wch
    wa wn wps wn wch wn wo wph wn wps wch ianor imbi2i bitr4i wps wph wi wph wn
    wps wn wi wch wph wi wph wn wch wn wi wps wph con34b wch wph con34b orbi12i
    wps wch wa wph con34b 3bitr4i $.
    $( [14-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.87 of [WhiteheadRussell] p. 122.  (The proof was shortened by
     Eric Schmidt, 26-Oct-2006.) $)
  pm4.87 $p |-  ( ( ( ( ( ph /\ ps ) -> ch ) <-> ( ph -> ( ps -> ch ) ) ) /\
                ( ( ph -> ( ps -> ch ) ) <-> ( ps -> ( ph -> ch ) ) ) ) /\
                ( ( ps -> ( ph -> ch ) ) <-> ( ( ps /\ ph ) -> ch ) ) ) $=
    wph wps wa wch wi wph wps wch wi wi wb wph wps wch wi wi wps wph wch wi wi
    wb wa wps wph wch wi wi wps wph wa wch wi wb wph wps wa wch wi wph wps wch
    wi wi wb wph wps wch wi wi wps wph wch wi wi wb wph wps wch impexp wph wps
    wch bi2.04 pm3.2i wps wph wa wch wi wps wph wch wi wi wps wph wch impexp
    bicomi pm3.2i $.
    $( [27-Oct-2006] $) $( [3-Jan-2005] $)

  $( Theorem *3.33 (Syll) of [WhiteheadRussell] p. 112. $)
  pm3.33 $p |-  ( ( ( ph -> ps ) /\ ( ps -> ch ) ) -> ( ph -> ch ) ) $=
    wph wps wi wps wch wi wph wch wi wph wps wch imim1 imp $.
    $( [16-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.34 (Syll) of [WhiteheadRussell] p. 112. $)
  pm3.34 $p |-  ( ( ( ps -> ch ) /\ ( ph -> ps ) ) -> ( ph -> ch ) ) $=
    wps wch wi wph wps wi wph wch wi wps wch wph imim2 imp $.
    $( [16-Apr-2005] $) $( [3-Jan-2005] $)

  $( Conjunctive detachment.  Theorem *3.35 of [WhiteheadRussell] p. 112. $)
  pm3.35 $p |- ( ( ph /\ ( ph -> ps ) ) -> ps ) $=
    wph wph wps wi wps wph wps pm2.27 imp $.
    $( [14-Dec-2002] $)

  $( Theorem *5.31 of [WhiteheadRussell] p. 125. $)
  pm5.31 $p |-  ( ( ch /\ ( ph -> ps ) ) -> ( ph -> ( ps /\ ch ) ) ) $=
    wch wph wps wi wph wps wch wa wi wch wps wps wch wa wph wch wps pm3.21
    imim2d imp $.
    $( [19-Apr-2005] $) $( [3-Jan-2005] $)

  ${
    imp3.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.

    $( Importation deduction. $)
    imp3a $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      wph wps wch wth wi wi wps wch wa wth wi imp3.1 wps wch wth impexp sylibr
      $.
      $( [31-Mar-1994] $)

    $( An importation inference. $)
    imp31 $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      wph wps wa wch wth wph wps wch wth wi imp3.1 imp imp $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp32 $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      wph wps wch wa wth wph wps wch wth imp3.1 imp3a imp $.
      $( [26-Apr-1994] $)

  $}

  ${
    imp4.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $.

    $( An importation inference. $)
    imp4a $p |- ( ph -> ( ps -> ( ( ch /\ th ) -> ta ) ) ) $=
      wph wps wch wth wta wi wi wch wth wa wta wi imp4.1 wch wth wta impexp
      syl6ibr $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp4b $p |- ( ( ph /\ ps ) -> ( ( ch /\ th ) -> ta ) ) $=
      wph wps wch wth wa wta wi wph wps wch wth wta imp4.1 imp4a imp $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp4c $p |- ( ph -> ( ( ( ps /\ ch ) /\ th ) -> ta ) ) $=
      wph wps wch wa wth wta wph wps wch wth wta wi imp4.1 imp3a imp3a $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp4d $p |- ( ph -> ( ( ps /\ ( ch /\ th ) ) -> ta ) ) $=
      wph wps wch wth wa wta wph wps wch wth wta imp4.1 imp4a imp3a $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp41 $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      wph wps wa wch wth wta wph wps wch wth wta wi wi imp4.1 imp imp31 $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp42 $p |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ta ) $=
      wph wps wch wa wa wth wta wph wps wch wth wta wi imp4.1 imp32 imp $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp43 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $=
      wph wps wa wch wth wa wta wph wps wch wth wta imp4.1 imp4b imp $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp44 $p |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ta ) $=
      wph wps wch wa wth wa wta wph wps wch wth wta imp4.1 imp4c imp $.
      $( [26-Apr-1994] $)

    $( An importation inference. $)
    imp45 $p |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> ta ) $=
      wph wps wch wth wa wa wta wph wps wch wth wta imp4.1 imp4d imp $.
      $( [26-Apr-1994] $)

  $}

  ${
    exp.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Exportation inference.  (This theorem used to be labeled "exp" but was
       changed to "ex" so as not to conflict with the math token "exp", per
       the June 2006 Metamath spec change.)  (The proof was shortened by Eric
       Schmidt, 22-Dec-2006.) $)
    ex $p |- ( ph -> ( ps -> ch ) ) $=
      wph wps wa wch wi wph wps wch wi wi exp.1 wph wps wch impexp mpbi $.
      $( [22-Dec-2006] $) $( [5-Aug-1993] $)

    $( Exportation inference with commuted antecedents. $)
    expcom $p |- ( ps -> ( ph -> ch ) ) $=
      wph wps wch wph wps wch exp.1 ex com12 $.
      $( [26-May-2005] $) $( [25-May-2005] $)
  $}

  ${
    expimpd.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Exportation followed by a deduction version of importation. $)
    expimpd $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      wph wps wch wth wph wps wch wth wi expimpd.1 ex imp3a $.
      $( [8-Sep-2008] $) $( [6-Sep-2008] $)
  $}

  ${
    exp3a.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Exportation deduction. $)
    exp3a $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      wph wps wch wa wth wi wps wch wth wi wi exp3a.1 wps wch wth impexp sylib
      $.
      $( [20-Aug-1993] $)

    $( A deduction version of exportation, followed by importation. $)
    expdimp $p |- ( ( ph /\ ps ) -> ( ch -> th ) ) $=
      wph wps wch wth wi wph wps wch wth exp3a.1 exp3a imp $.
      $( [7-Sep-2008] $) $( [6-Sep-2008] $)
  $}

  ${
    exp31.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An exportation inference. $)
    exp31 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      wph wps wch wth wi wph wps wa wch wth exp31.1 ex ex $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp32.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An exportation inference. $)
    exp32 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      wph wps wch wth wph wps wch wa wth exp32.1 ex exp3a $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp4a.1 $e |- ( ph -> ( ps -> ( ( ch /\ th ) -> ta ) ) ) $.
    $( An exportation inference. $)
    exp4a $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wa wta wi wch wth wta wi wi exp4a.1 wch wth wta impexp
      syl6ib $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp4b.1 $e |- ( ( ph /\ ps ) -> ( ( ch /\ th ) -> ta ) ) $.
    $( An exportation inference. $)
    exp4b $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wi wi wph wps wa wch wth wta exp4b.1 exp3a ex $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp4c.1 $e |- ( ph -> ( ( ( ps /\ ch ) /\ th ) -> ta ) ) $.
    $( An exportation inference. $)
    exp4c $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wi wph wps wch wa wth wta exp4c.1 exp3a exp3a $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp4d.1 $e |- ( ph -> ( ( ps /\ ( ch /\ th ) ) -> ta ) ) $.
    $( An exportation inference. $)
    exp4d $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wph wps wch wth wa wta exp4d.1 exp3a exp4a $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp41.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $.
    $( An exportation inference. $)
    exp41 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wi wph wps wa wch wa wth wta exp41.1 ex exp31 $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp42.1 $e |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ta ) $.
    $( An exportation inference. $)
    exp42 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wi wph wps wch wa wth wta exp42.1 exp31 exp3a $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp43.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( An exportation inference. $)
    exp43 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wph wps wa wch wth wa wta exp43.1 ex exp4b $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp44.1 $e |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ta ) $.
    $( An exportation inference. $)
    exp44 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wi wph wps wch wa wth wta exp44.1 exp32 exp3a $.
      $( [26-Apr-1994] $)
  $}

  ${
    exp45.1 $e |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> ta ) $.
    $( An exportation inference. $)
    exp45 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wph wps wch wth wa wta exp45.1 exp32 exp4a $.
      $( [26-Apr-1994] $)
  $}

  ${
    impac.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Importation with conjunction in consequent. $)
    impac $p |- ( ( ph /\ ps ) -> ( ch /\ ps ) ) $=
      wph wps wch wps wa wph wps wch impac.1 ancrd imp $.
      $( [9-Aug-1994] $)
  $}

  ${
    adantl.1 $e |- ( ph -> ps ) $.
    $( Inference adding a conjunct to the left of an antecedent. $)
    adantl $p |- ( ( ch /\ ph ) -> ps ) $=
      wch wph wps wph wps wi wch adantl.1 a1i imp $.
      $( [30-Aug-1993] $)
  $}

  ${
    adantr.1 $e |- ( ph -> ps ) $.
    $( Inference adding a conjunct to the right of an antecedent. $)
    adantr $p |- ( ( ph /\ ch ) -> ps ) $=
      wph wch wps wph wps wch adantr.1 a1d imp $.
      $( [30-Aug-1993] $)
  $}

  ${
    adantld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding a conjunct to the left of an antecedent. $)
    adantld $p |- ( ph -> ( ( th /\ ps ) -> ch ) ) $=
      wph wth wps wch wph wps wch wi wth adantld.1 a1d imp3a $.
      $( [4-May-1994] $)
  $}

  ${
    adantrd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding a conjunct to the right of an antecedent. $)
    adantrd $p |- ( ph -> ( ( ps /\ th ) -> ch ) ) $=
      wph wps wch wps wth wa adantrd.1 wps wth pm3.26 syl5 $.
      $( [4-May-1994] $)
  $}

  ${
    adant2.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding a conjunct to antecedent. $)
    adantll $p |- ( ( ( th /\ ph ) /\ ps ) -> ch ) $=
      wth wph wa wps wch wph wps wch wi wth wph wps wch adant2.1 ex adantl imp
      $.
      $( [4-May-1994] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantlr $p |- ( ( ( ph /\ th ) /\ ps ) -> ch ) $=
      wph wth wa wps wch wph wps wch wi wth wph wps wch adant2.1 ex adantr imp
      $.
      $( [4-May-1994] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantrl $p |- ( ( ph /\ ( th /\ ps ) ) -> ch ) $=
      wph wth wps wa wch wph wps wch wth wph wps wch adant2.1 ex adantld imp $.
      $( [4-May-1994] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantrr $p |- ( ( ph /\ ( ps /\ th ) ) -> ch ) $=
      wph wps wth wa wch wph wps wch wth wph wps wch adant2.1 ex adantrd imp $.
      $( [4-May-1994] $)
  $}

  ${
    adantl2.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Deduction adding a conjunct to antecedent. $)
    adantlll $p |- ( ( ( ( ta /\ ph ) /\ ps ) /\ ch ) -> th ) $=
      wta wph wps wch wth wph wps wch wth wi wi wi wta wph wps wch wth
      adantl2.1 exp31 a1i imp41 $.
      $( [31-Dec-2004] $) $( [26-Dec-2004] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantllr $p |- ( ( ( ( ph /\ ta ) /\ ps ) /\ ch ) -> th ) $=
      wph wta wps wch wth wph wps wch wth wi wi wta wph wps wch wth adantl2.1
      exp31 a1d imp41 $.
      $( [23-Apr-2005] $) $( [26-Dec-2004] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantlrl $p |- ( ( ( ph /\ ( ta /\ ps ) ) /\ ch ) -> th ) $=
      wph wta wps wch wth wph wps wch wth wi wi wta wph wps wch wth adantl2.1
      exp31 a1d imp42 $.
      $( [31-Dec-2004] $) $( [26-Dec-2004] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantlrr $p |- ( ( ( ph /\ ( ps /\ ta ) ) /\ ch ) -> th ) $=
      wph wps wta wch wth wph wps wch wth wi wta wph wps wch wth adantl2.1
      exp31 a1dd imp42 $.
      $( [5-Jan-2005] $) $( [26-Dec-2004] $)
  $}

  ${
    adantr2.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Deduction adding a conjunct to antecedent. $)
    adantrll $p |- ( ( ph /\ ( ( ta /\ ps ) /\ ch ) ) -> th ) $=
      wph wta wps wch wth wph wps wch wth wi wi wta wph wps wch wth adantr2.1
      exp32 a1d imp44 $.
      $( [31-Dec-2004] $) $( [26-Dec-2004] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantrlr $p |- ( ( ph /\ ( ( ps /\ ta ) /\ ch ) ) -> th ) $=
      wph wps wta wch wth wph wps wch wth wi wta wph wps wch wth adantr2.1
      exp32 a1dd imp44 $.
      $( [31-Dec-2004] $) $( [26-Dec-2004] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantrrl $p |- ( ( ph /\ ( ps /\ ( ta /\ ch ) ) ) -> th ) $=
      wph wps wta wch wth wph wps wch wth wi wta wph wps wch wth adantr2.1
      exp32 a1dd imp45 $.
      $( [31-Dec-2004] $) $( [26-Dec-2004] $)

    $( Deduction adding a conjunct to antecedent. $)
    adantrrr $p |- ( ( ph /\ ( ps /\ ( ch /\ ta ) ) ) -> th ) $=
      wph wps wch wta wth wph wps wch wta wth wi wph wps wch wa wa wth wta
      adantr2.1 a1d exp32 imp45 $.
      $( [31-Dec-2004] $) $( [26-Dec-2004] $)
  $}

  ${
    ad2ant.1 $e |- ( ph -> ps ) $.
    $( Deduction adding conjuncts to antecedent. $)
    ad2antrr $p |- ( ( ( ph /\ ch ) /\ th ) -> ps ) $=
      wph wch wa wps wth wph wps wch ad2ant.1 adantr adantr $.
      $( [19-Oct-1999] $)

    $( Deduction adding conjuncts to antecedent. $)
    ad2antlr $p |- ( ( ( ch /\ ph ) /\ th ) -> ps ) $=
      wch wph wa wps wth wph wps wch ad2ant.1 adantl adantr $.
      $( [19-Oct-1999] $)

    $( Deduction adding conjuncts to antecedent. $)
    ad2antrl $p |- ( ( ch /\ ( ph /\ th ) ) -> ps ) $=
      wph wth wa wps wch wph wps wth ad2ant.1 adantr adantl $.
      $( [19-Oct-1999] $)

    $( Deduction adding conjuncts to antecedent. $)
    ad2antll $p |- ( ( ch /\ ( th /\ ph ) ) -> ps ) $=
      wth wph wa wps wch wph wps wth ad2ant.1 adantl adantl $.
      $( [19-Oct-1999] $)
  $}

  ${
    ad2ant2.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding two conjuncts to antecedent. $)
    ad2ant2l $p |- ( ( ( th /\ ph ) /\ ( ta /\ ps ) ) -> ch ) $=
      wph wta wps wa wch wth wph wps wch wta ad2ant2.1 adantrl adantll $.
      $( [9-Jan-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding two conjuncts to antecedent. $)
    ad2ant2r $p |- ( ( ( ph /\ th ) /\ ( ps /\ ta ) ) -> ch ) $=
      wph wps wta wa wch wth wph wps wch wta ad2ant2.1 adantrr adantlr $.
      $( [9-Jan-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding two conjuncts to antecedent. $)
    ad2ant2lr $p |- ( ( ( th /\ ph ) /\ ( ps /\ ta ) ) -> ch ) $=
      wph wps wta wa wch wth wph wps wch wta ad2ant2.1 adantrr adantll $.
      $( [23-Nov-2007] $) $( [23-Nov-2007] $)

    $( Deduction adding two conjuncts to antecedent. $)
    ad2ant2rl $p |- ( ( ( ph /\ th ) /\ ( ta /\ ps ) ) -> ch ) $=
      wph wta wps wa wch wth wph wps wch wta ad2ant2.1 adantrl adantlr $.
      $( [24-Nov-2007] $) $( [24-Nov-2007] $)
  $}

  $( Simplification of a conjunction. $)
  simpll $p |- ( ( ( ph /\ ps ) /\ ch ) -> ph ) $=
    wph wph wps wch wph id ad2antrr $.
    $( [19-Mar-2007] $) $( [18-Mar-2007] $)

  $( Simplification of a conjunction. $)
  simplr $p |- ( ( ( ph /\ ps ) /\ ch ) -> ps ) $=
    wps wps wph wch wps id ad2antlr $.
    $( [20-Mar-2007] $) $( [20-Mar-2007] $)

  $( Simplification of a conjunction. $)
  simprl $p |- ( ( ph /\ ( ps /\ ch ) ) -> ps ) $=
    wps wps wph wch wps id ad2antrl $.
    $( [21-Mar-2007] $) $( [21-Mar-2007] $)

  $( Simplification of a conjunction. $)
  simprr $p |- ( ( ph /\ ( ps /\ ch ) ) -> ch ) $=
    wch wch wph wps wch id ad2antll $.
    $( [21-Mar-2007] $) $( [21-Mar-2007] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simplll $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ph ) $=
    wph wps wa wph wch wth wph wps pm3.26 ad2antrr $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simpllr $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ps ) $=
    wph wps wa wps wch wth wph wps pm3.27 ad2antrr $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simplrl $p |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ps ) $=
    wps wch wa wps wph wth wps wch pm3.26 ad2antlr $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simplrr $p |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ch ) $=
    wps wch wa wch wph wth wps wch pm3.27 ad2antlr $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprll $p |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ps ) $=
    wps wch wa wps wph wth wps wch pm3.26 ad2antrl $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprlr $p |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ch ) $=
    wps wch wa wch wph wth wps wch pm3.27 ad2antrl $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprrl $p |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> ch ) $=
    wch wth wa wch wph wps wch wth pm3.26 ad2antll $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprrr $p |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> th ) $=
    wch wth wa wth wph wps wch wth pm3.27 ad2antll $.
    $( [18-Apr-2010] $) $( [28-Jul-2009] $)

  ${
    biimpa.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Inference from a logical equivalence. $)
    biimpa $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wch biimpa.1 biimpd imp $.
      $( [3-May-1994] $)

    $( Inference from a logical equivalence. $)
    biimpar $p |- ( ( ph /\ ch ) -> ps ) $=
      wph wch wps wph wps wch biimpa.1 biimprd imp $.
      $( [3-May-1994] $)

    $( Inference from a logical equivalence. $)
    biimpac $p |- ( ( ps /\ ph ) -> ch ) $=
      wps wph wch wph wps wch biimpa.1 biimpcd imp $.
      $( [3-May-1994] $)

    $( Inference from a logical equivalence. $)
    biimparc $p |- ( ( ch /\ ph ) -> ps ) $=
      wch wph wps wph wps wch biimpa.1 biimprcd imp $.
      $( [3-May-1994] $)
  $}

  ${
    pm3.26bda.1 $e |- ( ph -> ( ps <-> ( ch /\ th ) ) ) $.
    $( Deduction eliminating a conjunct. $)
    pm3.26bda $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wch wth wph wps wch wth wa pm3.26bda.1 biimpa pm3.26d $.
      $( [23-Oct-2007] $) $( [22-Oct-2007] $)

    $( Deduction eliminating a conjunct. $)
    pm3.27bda $p |- ( ( ph /\ ps ) -> th ) $=
      wph wps wa wch wth wph wps wch wth wa pm3.26bda.1 biimpa pm3.27d $.
      $( [25-Oct-2007] $) $( [22-Oct-2007] $)
  $}

  $( Disjunction of antecedents.  Compare Theorem *4.77 of
     [WhiteheadRussell] p. 121. $)
  jaob $p |- ( ( ( ph \/ ch ) -> ps ) <-> ( ( ph -> ps ) /\ ( ch -> ps ) ) ) $=
    wph wch wo wps wi wph wps wi wch wps wi wa wph wch wo wps wi wph wps wi wch
    wps wi wph wph wch wo wps wph wch orc imim1i wch wph wch wo wps wch wph olc
    imim1i jca wph wps wi wch wps wi wph wch wo wps wi wph wps wch jao imp
    impbii $.
    $( [30-May-1994] $)

  $( Theorem *4.77 of [WhiteheadRussell] p. 121. $)
  pm4.77 $p |-  ( ( ( ps -> ph ) /\ ( ch -> ph ) ) <->
                ( ( ps \/ ch ) -> ph ) ) $=
    wps wch wo wph wi wps wph wi wch wph wi wa wps wph wch jaob bicomi $.
    $( [10-Apr-2005] $) $( [3-Jan-2005] $)

  ${
    jaod.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jaod.2 $e |- ( ph -> ( th -> ch ) ) $.
    $( Deduction disjoining the antecedents of two implications. $)
    jaod $p |- ( ph -> ( ( ps \/ th ) -> ch ) ) $=
      wps wch wi wth wch wi wps wth wo wch wi wph wps wch wth jao jaod.1 jaod.2
      sylc $.
      $( [18-Aug-1994] $)
  $}

  ${
    jaoian.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    jaoian.2 $e |- ( ( th /\ ps ) -> ch ) $.
    $( Inference disjoining the antecedents of two implications. $)
    jaoian $p |- ( ( ( ph \/ th ) /\ ps ) -> ch ) $=
      wph wth wo wps wch wph wps wch wi wth wph wps wch jaoian.1 ex wth wps wch
      jaoian.2 ex jaoi imp $.
      $( [26-Oct-2005] $) $( [23-Oct-2005] $)
  $}

  ${
    jaodan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    jaodan.2 $e |- ( ( ph /\ th ) -> ch ) $.
    $( Deduction disjoining the antecedents of two implications. $)
    jaodan $p |- ( ( ph /\ ( ps \/ th ) ) -> ch ) $=
      wph wps wth wo wch wph wps wch wth wph wps wch jaodan.1 ex wph wth wch
      jaodan.2 ex jaod imp $.
      $( [24-Oct-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    jaao.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jaao.2 $e |- ( th -> ( ta -> ch ) ) $.
    $( Inference conjoining and disjoining the antecedents of two
       implications. $)
    jaao $p |- ( ( ph /\ th ) -> ( ( ps \/ ta ) -> ch ) ) $=
      wph wth wa wps wch wta wph wps wch wi wth jaao.1 adantr wth wta wch wi
      wph jaao.2 adantl jaod $.
      $( [30-Sep-1999] $)

    $( Inference disjoining and conjoining the antecedents of two
       implications.  (Contributed by Stefan Allan, 1-Nov-2008.) $)
    jaoa $p |-  ( ( ph \/ th ) -> ( ( ps /\ ta ) -> ch ) ) $=
      wph wps wta wa wch wi wth wph wps wch wta jaao.1 adantrd wth wta wch wps
      jaao.2 adantld jaoi $.
      $( [2-Nov-2008] $) $( [1-Nov-2008] $)
  $}

  $( Theorem *2.63 of [WhiteheadRussell] p. 107. $)
  pm2.63 $p |-  ( ( ph \/ ps ) -> ( ( -. ph \/ ps ) -> ps ) ) $=
    wph wps wo wph wn wps wps wph wps pm2.53 wph wps wo wps idd jaod $.
    $( [19-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.64 of [WhiteheadRussell] p. 107. $)
  pm2.64 $p |-  ( ( ph \/ ps ) -> ( ( ph \/ -. ps ) -> ph ) ) $=
    wph wps wn wo wph wps wo wph wph wph wps wo wph wi wps wn wph wph wps wo
    ax-1 wps wph orel2 jaoi com12 $.
    $( [19-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *3.44 of [WhiteheadRussell] p. 113. $)
  pm3.44 $p |-  ( ( ( ps -> ph ) /\ ( ch -> ph ) ) ->
                ( ( ps \/ ch ) -> ph ) ) $=
    wps wch wo wph wi wps wph wi wch wph wi wa wps wph wch jaob biimpri $.
    $( [24-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.43 of [WhiteheadRussell] p. 119. $)
  pm4.43 $p |-  ( ph <-> ( ( ph \/ ps ) /\ ( ph \/ -. ps ) ) ) $=
    wph wph wps wo wph wps wn wo wa wph wph wps wo wph wps wn wo wph wps orc
    wph wps wn orc jca wph wps wo wph wps wn wo wph wph wps pm2.64 imp impbii
    $.
    $( [25-Apr-2005] $) $( [3-Jan-2005] $)

  $( Idempotent law for conjunction. $)
  anidm $p |- ( ( ph /\ ph ) <-> ph ) $=
    wph wph wa wph wph wph pm3.26 wph wph wph wa wph wph pm3.2 pm2.43i impbii
    $.
    $( [5-Aug-1993] $)

  $( Theorem *4.24 of [WhiteheadRussell] p. 117. $)
  pm4.24 $p |-  ( ph <-> ( ph /\ ph ) ) $=
    wph wph wa wph wph anidm bicomi $.
    $( [17-Jan-2005] $) $( [3-Jan-2005] $)

  ${
    anidms.1 $e |- ( ( ph /\ ph ) -> ps ) $.
    $( Inference from idempotent law for conjunction. $)
    anidms $p |- ( ph -> ps ) $=
      wph wps wph wph wps anidms.1 ex pm2.43i $.
      $( [15-Jun-1994] $)
  $}

  $( Conjunction idempotence with antecedent. (Contributed by Roy F.
     Longton, 8-Aug-2005.) $)
  anidmdbi $p |- ( ( ph -> ( ps /\ ps ) ) <-> ( ph -> ps ) ) $=
    wps wps wa wps wph wps anidm imbi2i $.
    $( [31-Oct-2007] $) $( [8-Aug-2005] $)

  $( Commutative law for conjunction.  Theorem *4.3 of [WhiteheadRussell]
     p. 118. $)
  ancom $p |- ( ( ph /\ ps ) <-> ( ps /\ ph ) ) $=
    wph wps wa wps wph wa wph wps wa wps wph wph wps pm3.27 wph wps pm3.26 jca
    wps wph wa wph wps wps wph pm3.27 wps wph pm3.26 jca impbii $.
    $( [25-Jun-1998] $)

  ${
    ancomd.1 $e |- ( ph -> ( ps /\ ch ) ) $.
    $( Commutation of conjuncts in consequent.  (Contributed by Jeff Hankins,
       14-Aug-2009.)  $)
    ancomd $p |- ( ph -> ( ch /\ ps ) ) $=
      wph wps wch wa wch wps wa ancomd.1 wps wch ancom sylib $.
      $( [18-Apr-2010] $) $( [14-Aug-2009] $)
  $}

  ${
    ancoms.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Inference commuting conjunction in antecedent.  _Notational convention_:
       We sometimes suffix with "s" the label of an inference that manipulates
       an antecedent, leaving the consequent unchanged.  The "s" means that the
       inference eliminates the need for a syllogism ( ~ syl ) -type inference
       in a proof. $)
    ancoms $p |- ( ( ps /\ ph ) -> ch ) $=
      wps wph wa wph wps wa wch wps wph ancom ancoms.1 sylbi $.
      $( [21-Apr-1994] $)
  $}

  ${
    ancomsd.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Deduction commuting conjunction in antecedent. $)
    ancomsd $p |- ( ph -> ( ( ch /\ ps ) -> th ) ) $=
      wph wps wch wa wth wch wps wa ancomsd.1 wch wps ancom syl5ib $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  $( Theorem *3.22 of [WhiteheadRussell] p. 111. $)
  pm3.22 $p |-  ( ( ph /\ ps ) -> ( ps /\ ph ) ) $=
    wph wps wa wps wph wa wph wps ancom biimpi $.
    $( [17-Jan-2005] $) $( [3-Jan-2005] $)

  $( Associative law for conjunction.  Theorem *4.32 of [WhiteheadRussell]
     p. 118. $)
  anass $p |- ( ( ( ph /\ ps ) /\ ch ) <-> ( ph /\ ( ps /\ ch ) ) ) $=
    wph wps wa wch wn wi wn wph wps wch wa wn wi wn wph wps wa wch wa wph wps
    wch wa wa wph wps wa wch wn wi wph wps wch wa wn wi wph wps wa wch wn wi
    wph wps wch wn wi wi wph wps wch wa wn wi wph wps wch wn impexp wps wch wn
    wi wps wch wa wn wph wps wch imnan imbi2i bitri notbii wph wps wa wch df-an
    wph wps wch wa df-an 3bitr4i $.
    $( [5-Aug-1993] $)

  ${
    anasss.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Associative law for conjunction applied to antecedent (eliminates
       syllogism). $)
    anasss $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      wph wps wch wth wph wps wch wth anasss.1 exp31 imp32 $.
      $( [15-Nov-2002] $)
  $}

  ${
    anassrs.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Associative law for conjunction applied to antecedent (eliminates
       syllogism). $)
    anassrs $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth anassrs.1 exp32 imp31 $.
      $( [15-Nov-2002] $)
  $}

  $( Distribution of implication with conjunction. $)
  imdistan $p |- ( ( ph -> ( ps -> ch ) ) <->
                 ( ( ph /\ ps ) -> ( ph /\ ch ) ) ) $=
    wph wps wch wi wi wph wps wa wph wch wa wi wph wps wch wi wi wph wps wph
    wch wa wph wps wch anc2l imp3a wph wps wa wph wch wa wi wph wps wch wph wch
    wa wch wph wps wa wph wch pm3.27 imim2i exp3a impbii $.
    $( [31-May-1999] $)

  ${
    imdistani.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Distribution of implication with conjunction. $)
    imdistani $p |- ( ( ph /\ ps ) -> ( ph /\ ch ) ) $=
      wph wps wph wch wa wph wps wch imdistani.1 anc2li imp $.
      $( [1-Aug-1994] $)
  $}

  ${
    imdistanri.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Distribution of implication with conjunction. $)
    imdistanri $p |- ( ( ps /\ ph ) -> ( ch /\ ph ) ) $=
      wps wph wch wph wps wch imdistanri.1 com12 impac $.
      $( [8-Jan-2002] $)
  $}

  ${
    imdistand.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Distribution of implication with conjunction (deduction rule). $)
    imdistand $p |- ( ph -> ( ( ps /\ ch ) -> ( ps /\ th ) ) ) $=
      wph wps wch wth wi wi wps wch wa wps wth wa wi imdistand.1 wps wch wth
      imdistan sylib $.
      $( [28-Aug-2004] $) $( [27-Aug-2004] $)
  $}

  $( Theorem *5.3 of [WhiteheadRussell] p. 125. $)
  pm5.3 $p |-  ( ( ( ph /\ ps ) -> ch ) <->
               ( ( ph /\ ps ) -> ( ph /\ ch ) ) ) $=
    wph wps wa wch wi wph wps wa wph wch wa wi wph wps wa wch wi wph wps wch
    wph wps wch pm3.3 imdistand wph wch wa wch wph wps wa wph wch pm3.27 imim2i
    impbii $.
    $( [27-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.61 of [WhiteheadRussell] p. 125. $)
  pm5.61 $p |-  ( ( ( ph \/ ps ) /\ -. ps ) <-> ( ph /\ -. ps ) ) $=
    wph wps wo wps wn wa wph wps wn wa wps wn wph wps wo wph wps wph orel2
    imdistanri wph wph wps wo wps wn wph wps orc anim1i impbii $.
    $( [10-Apr-2005] $) $( [3-Jan-2005] $)

  ${
    sylan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    ${
      sylan.2 $e |- ( th -> ph ) $.
      $( A syllogism inference. $)
      sylan $p |- ( ( th /\ ps ) -> ch ) $=
        wth wps wch wth wph wps wch wi sylan.2 wph wps wch sylan.1 ex syl imp
        $.
        $( [21-Apr-1994] $)
    $}

    ${
      sylanb.2 $e |- ( th <-> ph ) $.
      $( A syllogism inference. $)
      sylanb $p |- ( ( th /\ ps ) -> ch ) $=
        wph wps wch wth sylan.1 wth wph sylanb.2 biimpi sylan $.
        $( [18-May-1994] $)
    $}

    ${
      sylanbr.2 $e |- ( ph <-> th ) $.
      $( A syllogism inference. $)
      sylanbr $p |- ( ( th /\ ps ) -> ch ) $=
        wph wps wch wth sylan.1 wph wth sylanbr.2 biimpri sylan $.
        $( [18-May-1994] $)
    $}

    ${
      sylan2.2 $e |- ( th -> ps ) $.
      $( A syllogism inference. $)
      sylan2 $p |- ( ( ph /\ th ) -> ch ) $=
        wph wth wch wph wps wch wth wph wps wch sylan.1 ex sylan2.2 syl5 imp $.
        $( [21-Apr-1994] $)
    $}

    ${
      sylan2b.2 $e |- ( th <-> ps ) $.
      $( A syllogism inference. $)
      sylan2b $p |- ( ( ph /\ th ) -> ch ) $=
        wph wps wch wth sylan.1 wth wps sylan2b.2 biimpi sylan2 $.
        $( [21-Apr-1994] $)
    $}

    ${
      sylan2br.2 $e |- ( ps <-> th ) $.
      $( A syllogism inference. $)
      sylan2br $p |- ( ( ph /\ th ) -> ch ) $=
        wph wps wch wth sylan.1 wps wth sylan2br.2 biimpri sylan2 $.
        $( [21-Apr-1994] $)
    $}

    ${
      syl2an.2 $e |- ( th -> ph ) $.
      syl2an.3 $e |- ( ta -> ps ) $.
      $( A double syllogism inference. $)
      syl2an $p |- ( ( th /\ ta ) -> ch ) $=
        wth wps wch wta wph wps wch wth sylan.1 syl2an.2 sylan syl2an.3 sylan2
        $.
        $( [31-Jan-1997] $)
    $}

    ${
      syl2anb.2 $e |- ( th <-> ph ) $.
      syl2anb.3 $e |- ( ta <-> ps ) $.
      $( A double syllogism inference. $)
      syl2anb $p |- ( ( th /\ ta ) -> ch ) $=
        wth wps wch wta wph wps wch wth sylan.1 syl2anb.2 sylanb syl2anb.3
        sylan2b $.
        $( [29-Jul-1999] $)
    $}

    ${
      syl2anbr.2 $e |- ( ph <-> th ) $.
      syl2anbr.3 $e |- ( ps <-> ta ) $.
      $( A double syllogism inference. $)
      syl2anbr $p |- ( ( th /\ ta ) -> ch ) $=
        wth wps wch wta wph wps wch wth sylan.1 syl2anbr.2 sylanbr syl2anbr.3
        sylan2br $.
        $( [29-Jul-1999] $)
    $}
  $}

  ${
    syland.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    syland.2 $e |- ( ph -> ( ta -> ps ) ) $.
    $( A syllogism deduction. $)
    syland $p |- ( ph -> ( ( ta /\ ch ) -> th ) ) $=
      wph wta wch wth wph wta wps wch wth wi syland.2 wph wps wch wth syland.1
      exp3a syld imp3a $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)
  $}

  ${
    sylan2d.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    sylan2d.2 $e |- ( ph -> ( ta -> ch ) ) $.
    $( A syllogism deduction. $)
    sylan2d $p |- ( ph -> ( ( ps /\ ta ) -> th ) ) $=
      wph wta wps wth wph wch wps wth wta wph wps wch wth sylan2d.1 ancomsd
      sylan2d.2 syland ancomsd $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)
  $}

  ${
    $v et $. $( Greek eta $)
    syl2and.wet $f wff et $.
    syl2and.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    syl2and.2 $e |- ( ph -> ( ta -> ps ) ) $.
    syl2and.3 $e |- ( ph -> ( et -> ch ) ) $.
    $( A syllogism deduction. $)
    syl2and $p |- ( ph -> ( ( ta /\ et ) -> th ) ) $=
      wph wps syl2and.wet wth wta wph wps wch wth syl2and.wet syl2and.1
      syl2and.3 sylan2d syl2and.2 syland $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)
  $}

  ${
    sylanl1.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    sylanl1.2 $e |- ( ta -> ph ) $.
    $( A syllogism inference. $)
    sylanl1 $p |- ( ( ( ta /\ ps ) /\ ch ) -> th ) $=
      wph wps wa wch wth wta wps wa sylanl1.1 wta wph wps sylanl1.2 anim1i
      sylan $.
      $( [30-Apr-2005] $) $( [10-Mar-2005] $)
  $}

  ${
    sylanl2.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    sylanl2.2 $e |- ( ta -> ps ) $.
    $( A syllogism inference. $)
    sylanl2 $p |- ( ( ( ph /\ ta ) /\ ch ) -> th ) $=
      wph wps wa wch wth wph wta wa sylanl2.1 wta wps wph sylanl2.2 anim2i
      sylan $.
      $( [2-Jan-2005] $) $( [1-Jan-2005] $)
  $}

  ${
    sylanr1.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    sylanr1.2 $e |- ( ta -> ps ) $.
    $( A syllogism inference. $)
    sylanr1 $p |- ( ( ph /\ ( ta /\ ch ) ) -> th ) $=
      wph wps wch wa wth wta wch wa sylanr1.1 wta wps wch sylanr1.2 anim1i
      sylan2 $.
      $( [15-May-2005] $) $( [9-Apr-2005] $)
  $}

  ${
    sylanr2.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    sylanr2.2 $e |- ( ta -> ch ) $.
    $( A syllogism inference. $)
    sylanr2 $p |- ( ( ph /\ ( ps /\ ta ) ) -> th ) $=
      wph wps wch wa wth wps wta wa sylanr2.1 wta wch wps sylanr2.2 anim2i
      sylan2 $.
      $( [1-May-2005] $) $( [9-Apr-2005] $)
  $}

  ${
    sylani.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    sylani.2 $e |- ( ta -> ps ) $.
    $( A syllogism inference. $)
    sylani $p |- ( ph -> ( ( ta /\ ch ) -> th ) ) $=
      wph wps wch wth wta sylani.1 wta wps wi wph sylani.2 a1i syland $.
      $( [2-May-1996] $)
  $}

  ${
    sylan2i.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    sylan2i.2 $e |- ( ta -> ch ) $.
    $( A syllogism inference. $)
    sylan2i $p |- ( ph -> ( ( ps /\ ta ) -> th ) ) $=
      wph wps wch wth wta sylan2i.1 wta wch wi wph sylan2i.2 a1i sylan2d $.
      $( [1-Aug-1994] $)
  $}

  ${
    $v et $. $( Greek eta $)
    syl2ani.wet $f wff et $.
    syl2ani.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    syl2ani.2 $e |- ( ta -> ps ) $.
    syl2ani.3 $e |- ( et -> ch ) $.
    $( A syllogism inference. $)
    syl2ani $p |- ( ph -> ( ( ta /\ et ) -> th ) ) $=
      wph wps syl2ani.wet wth wta wph wps wch wth syl2ani.wet syl2ani.1
      syl2ani.3 sylan2i syl2ani.2 sylani $.
      $( [3-Aug-1999] $)
  $}

  ${
    syldan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    syldan.2 $e |- ( ( ph /\ ch ) -> th ) $.
    $( A syllogism deduction with conjoined antecents. $)
    syldan $p |- ( ( ph /\ ps ) -> th ) $=
      wph wps wth wph wps wch wth wph wps wch syldan.1 ex wph wch wth syldan.2
      ex syld imp $.
      $( [26-Feb-2005] $) $( [24-Feb-2005] $)
  $}

  ${
    sylan9.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylan9.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents. $)
    sylan9 $p |- ( ( ph /\ th ) -> ( ps -> ta ) ) $=
      wph wth wa wps wch wta wph wps wch wi wth sylan9.1 adantr wth wch wta wi
      wph sylan9.2 adantl syld $.
      $( [5-Aug-1993] $)
  $}

  ${
    sylan9r.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylan9r.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents. $)
    sylan9r $p |- ( ( th /\ ph ) -> ( ps -> ta ) ) $=
      wth wph wps wta wi wph wps wch wth wta sylan9r.1 sylan9r.2 syl9r imp $.
      $( [5-Aug-1993] $)
  $}

  ${
    mpan9.1 $e |- ( ph -> ps ) $.
    mpan9.2 $e |- ( ch -> ( ps -> th ) ) $.
    $( Modus ponens conjoining dissimilar antecedents. $)
    mpan9 $p |- ( ( ph /\ ch ) -> th ) $=
      wph wch wa wps wth wph wps wch mpan9.1 adantr wch wps wth wi wph mpan9.2
      adantl mpd $.
      $( [1-Feb-2008] $) $( [1-Feb-2008] $)
  $}

  ${
    sylanc.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylanc.2 $e |- ( th -> ph ) $.
    sylanc.3 $e |- ( th -> ps ) $.
    $( A syllogism inference combined with contraction. $)
    sylanc $p |- ( th -> ch ) $=
      wph wps wch wth wph wps wch sylanc.1 ex sylanc.2 sylanc.3 sylc $.
      $( [3-Oct-1999] $)
  $}

  ${
    sylancl.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylancl.2 $e |- ( th -> ph ) $.
    sylancl.3 $e |- ps $.
    $( Syllogism inference.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    sylancl $p |- ( th -> ch ) $=
      wph wps wch wth sylancl.1 sylancl.2 wps wth sylancl.3 a1i sylanc $.
      $( [18-Apr-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    sylancr.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylancr.2 $e |- ph $.
    sylancr.3 $e |- ( th -> ps ) $.
    $( Syllogism inference.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    sylancr $p |- ( th -> ch ) $=
      wph wps wch wth sylancr.1 wph wth sylancr.2 a1i sylancr.3 sylanc $.
      $( [2-Sep-2009] $)
  $}

  ${
    sylanbrc.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    sylanbrc.2 $e |- ( th -> ps ) $.
    sylanbrc.3 $e |- ( th -> ch ) $.
    $( Syllogism inference. (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    sylanbrc $p |- ( th -> ph ) $=
      wth wps wch wa wph wth wps wch sylanbrc.2 sylanbrc.3 jca sylanbrc.1
      sylibr $.
      $( [11-Oct-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $v et $. $( Greek eta $)
    syl2anc.wet $f wff et $.
    syl2anc.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    syl2anc.2 $e |- ( et -> ph ) $.
    syl2anc.3 $e |- ( et -> ps ) $.
    syl2anc.4 $e |- ( et -> ch ) $.
    syl2anc.5 $e |- ( et -> th ) $.
    $( A syllogism inference combined with contraction. $)
    syl2anc $p |- ( et -> ta ) $=
      wph wps wa wch wth wa wta syl2anc.wet syl2anc.1 syl2anc.wet wph wps
      syl2anc.2 syl2anc.3 jca syl2anc.wet wch wth syl2anc.4 syl2anc.5 jca
      sylanc $.
      $( [18-Jun-2007] $) $( [16-Jun-2007] $)
  $}

  ${
    sylancb.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylancb.2 $e |- ( th <-> ph ) $.
    sylancb.3 $e |- ( th <-> ps ) $.
    $( A syllogism inference combined with contraction. $)
    sylancb $p |- ( th -> ch ) $=
      wth wch wph wps wch wth wth sylancb.1 sylancb.2 sylancb.3 syl2anb anidms
      $.
      $( [9-Sep-2004] $) $( [3-Sep-2004] $)
  $}

  ${
    sylancbr.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylancbr.2 $e |- ( ph <-> th ) $.
    sylancbr.3 $e |- ( ps <-> th ) $.
    $( A syllogism inference combined with contraction. $)
    sylancbr $p |- ( th -> ch ) $=
      wth wch wph wps wch wth wth sylancbr.1 sylancbr.2 sylancbr.3 syl2anbr
      anidms $.
      $( [14-Sep-2004] $) $( [3-Sep-2004] $)
  $}

  ${
    sylancom.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylancom.2 $e |- ( ( ch /\ ps ) -> th ) $.
    $( Syllogism inference with commutation of antecents. $)
    sylancom $p |- ( ( ph /\ ps ) -> th ) $=
      wch wps wth wph wps wa sylancom.2 sylancom.1 wph wps pm3.27 sylanc $.
      $( [2-Jul-2008] $) $( [2-Jul-2008] $)
  $}

  ${
    sylan31c.1 $e |- ( ta -> ph ) $.
    sylan31c.2 $e |- ( ta -> ps ) $.
    sylan31c.3 $e |- ( ta -> ch ) $.
    ${
      sylan31c.4 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
      $( A syllogism inference combined with contraction.  (Contributed by Jeff
         Hankins, 19-Aug-2009.) $)
      sylan31c $p |- ( ta -> th ) $=
        wta wph wps wa wch wa wth wta wph wps wch sylan31c.1 sylan31c.2
        sylan31c.3 jca31 sylan31c.4 syl $.
        $( [1-Dec-2010] $) $( [1-Aug-2009] $)
    $}

    ${
      sylan32c.4 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
      $( A syllogism inference combined with contraction.  (Contributed by Jeff
         Hankins,  19-Aug-2009.) $)
      sylan32c $p |- ( ta -> th ) $=
        wta wph wps wch wa wa wth wta wph wps wch sylan31c.1 sylan31c.2
        sylan31c.3 jca32 sylan32c.4 syl $.
        $( [1-Dec-2010] $) $( [1-Aug-2009] $)
    $}
  $}

  ${
    pm2.61ian.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    pm2.61ian.2 $e |- ( ( -. ph /\ ps ) -> ch ) $.
    $( Elimination of an antecedent. $)
    pm2.61ian $p |- ( ps -> ch ) $=
      wph wps wch wi wph wps wch pm2.61ian.1 ex wph wn wps wch pm2.61ian.2 ex
      pm2.61i $.
      $( [3-Jan-2005] $) $( [1-Jan-2005] $)
  $}

  ${
    pm2.61dan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    pm2.61dan.2 $e |- ( ( ph /\ -. ps ) -> ch ) $.
    $( Elimination of an antecedent. $)
    pm2.61dan $p |- ( ph -> ch ) $=
      wph wps wch wph wps wch pm2.61dan.1 ex wph wps wn wch pm2.61dan.2 ex
      pm2.61d $.
      $( [3-Jan-2005] $) $( [1-Jan-2005] $)
  $}

  ${
    condan.1 $e |- ( ( ph /\ -. ps ) -> ch ) $.
    condan.2 $e |- ( ( ph /\ -. ps ) -> -. ch ) $.
    $( Proof by contradiction. $)
    condan $p |- ( ph -> ps ) $=
      wph wps wn wn wps wph wps wn wch wph wps wn wch condan.1 ex wph wps wn
      wch wn condan.2 ex pm2.65d wps notnot2 syl $.
      $( [21-Feb-2006] $) $( [9-Feb-2006] $)
  $}

  $( Introduce one conjunct as an antecedent to the another. $)
  abai $p |- ( ( ph /\ ps ) <-> ( ph /\ ( ph -> ps ) ) ) $=
    wph wps wa wph wph wps wi wa wph wps wa wph wph wps wi wph wps pm3.26 wph
    wps pm3.4 jca wph wph wps wi wa wph wps wph wph wps wi pm3.26 wph wps
    pm3.35 jca impbii $.
    $( [12-Aug-1993] $)

  ${
    bi.aa $e |- ( ph <-> ps ) $.

    $( Introduce a left conjunct to both sides of a logical equivalence. $)
    anbi2i $p |- ( ( ch /\ ph ) <-> ( ch /\ ps ) ) $=
      wch wph wa wch wps wa wph wps wch wph wps bi.aa biimpi anim2i wps wph wch
      wph wps bi.aa biimpri anim2i impbii $.
      $( [5-Aug-1993] $)

    $( Introduce a right conjunct to both sides of a logical equivalence. $)
    anbi1i $p |- ( ( ph /\ ch ) <-> ( ps /\ ch ) ) $=
      wph wch wa wch wph wa wch wps wa wps wch wa wph wch ancom wph wps wch
      bi.aa anbi2i wch wps ancom 3bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    anbi12.1 $e |- ( ph <-> ps ) $.
    anbi12.2 $e |- ( ch <-> th ) $.
    $( Conjoin both sides of two equivalences. $)
    anbi12i $p |- ( ( ph /\ ch ) <-> ( ps /\ th ) ) $=
      wph wch wa wps wch wa wps wth wa wph wps wch anbi12.1 anbi1i wch wth wps
      anbi12.2 anbi2i bitri $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem *5.53 of [WhiteheadRussell] p. 125. $)
  pm5.53 $p |-  ( ( ( ( ph \/ ps ) \/ ch ) -> th ) <->
                ( ( ( ph -> th ) /\ ( ps -> th ) ) /\ ( ch -> th ) ) ) $=
    wph wps wo wch wo wth wi wph wps wo wth wi wch wth wi wa wph wth wi wps wth
    wi wa wch wth wi wa wph wps wo wth wch jaob wph wps wo wth wi wph wth wi
    wps wth wi wa wch wth wi wph wth wps jaob anbi1i bitri $.
    $( [28-Apr-2005] $) $( [3-Jan-2005] $)

  $( A rearrangement of conjuncts. $)
  an12 $p |- ( ( ph /\ ( ps /\ ch ) ) <-> ( ps /\ ( ph /\ ch ) ) ) $=
    wph wps wa wch wa wps wph wa wch wa wph wps wch wa wa wps wph wch wa wa wph
    wps wa wps wph wa wch wph wps ancom anbi1i wph wps wch anass wps wph wch
    anass 3bitr3i $.
    $( [12-Mar-1995] $)

  $( A rearrangement of conjuncts. $)
  an23 $p |- ( ( ( ph /\ ps ) /\ ch ) <-> ( ( ph /\ ch ) /\ ps ) ) $=
    wph wps wch wa wa wph wch wps wa wa wph wps wa wch wa wph wch wa wps wa wps
    wch wa wch wps wa wph wps wch ancom anbi2i wph wps wch anass wph wch wps
    anass 3bitr4i $.
    $( [12-Mar-1995] $)

  ${
    an1s.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Deduction rearranging conjuncts. $)
    an1s $p |- ( ( ps /\ ( ph /\ ch ) ) -> th ) $=
      wps wph wch wa wa wph wps wch wa wa wth wps wph wch an12 an1s.1 sylbi $.
      $( [13-Mar-1996] $)

    $( Inference commuting a nested conjunction in antecedent. $)
    ancom2s $p |- ( ( ph /\ ( ch /\ ps ) ) -> th ) $=
      wph wch wps wth wph wps wch wth wph wps wch wth an1s.1 exp32 com23 imp32
      $.
      $( [25-May-2006] $) $( [24-May-2006] $)

    $( Deduction rearranging conjuncts. $)
    ancom13s $p |- ( ( ch /\ ( ps /\ ph ) ) -> th ) $=
      wch wps wph wth wph wps wch wth wph wps wch wth an1s.1 exp32 com13 imp32
      $.
      $( [31-May-2006] $) $( [31-May-2006] $)
  $}

  ${
    an1rs.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Deduction rearranging conjuncts. $)
    an1rs $p |- ( ( ( ph /\ ch ) /\ ps ) -> th ) $=
      wph wch wa wps wa wph wps wa wch wa wth wph wch wps an23 an1rs.1 sylbi $.
      $( [13-Mar-1996] $)

    $( Inference commuting a nested conjunction in antecedent. $)
    ancom1s $p |- ( ( ( ps /\ ph ) /\ ch ) -> th ) $=
      wps wph wch wth wph wps wch wth wi wph wps wch wth an1rs.1 exp31 com12
      imp31 $.
      $( [25-May-2006] $) $( [24-May-2006] $)

    $( Deduction rearranging conjuncts. $)
    ancom31s $p |- ( ( ( ch /\ ps ) /\ ph ) -> th ) $=
      wch wps wph wth wph wps wch wth wph wps wch wth an1rs.1 exp31 com13 imp31
      $.
      $( [2-Jun-2006] $) $( [31-May-2006] $)
  $}

  $( Absorption into embedded conjunct. $)
  anabs1 $p |- ( ( ( ph /\ ps ) /\ ph ) <-> ( ph /\ ps ) ) $=
    wph wps wa wph wa wph wps wa wph wps wa wph pm3.26 wph wps wa wph wph wps
    pm3.26 ancli impbii $.
    $( [4-Sep-1995] $)

  $( Absorption into embedded conjunct. $)
  anabs5 $p |- ( ( ph /\ ( ph /\ ps ) ) <-> ( ph /\ ps ) ) $=
    wph wph wps wa wa wph wps wa wph wa wph wps wa wph wps wa wph ancom wph wps
    anabs1 bitr3i $.
    $( [20-Jul-1996] $)

  $( Absorption into embedded conjunct. $)
  anabs7 $p |- ( ( ps /\ ( ph /\ ps ) ) <-> ( ph /\ ps ) ) $=
    wps wph wps wa wa wph wps wa wps wph wps wa pm3.27 wph wps wa wps wph wps
    pm3.27 ancri impbii $.
    $( [20-Jul-1996] $)

  ${
    anabsi5.1 $e |- ( ph -> ( ( ph /\ ps ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction. $)
    anabsi5 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wch wph wph wps wa wch wi wps anabsi5.1 adantr pm2.43i $.
      $( [11-Jun-1995] $)
  $}

  ${
    anabsi6.1 $e |- ( ph -> ( ( ps /\ ph ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction. $)
    anabsi6 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wph wch anabsi6.1 ancomsd anabsi5 $.
      $( [14-Aug-2000] $)
  $}

  ${
    anabsi7.1 $e |- ( ps -> ( ( ph /\ ps ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction. $)
    anabsi7 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wch wps wph wps wch anabsi7.1 exp3a pm2.43b imp $.
      $( [20-Jul-1996] $)
  $}

  ${
    anabsi8.1 $e |- ( ps -> ( ( ps /\ ph ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction. $)
    anabsi8 $p |- ( ( ph /\ ps ) -> ch ) $=
      wps wph wch wps wph wch anabsi8.1 anabsi5 ancoms $.
      $( [26-Sep-1999] $)
  $}

  ${
    anabss1.1 $e |- ( ( ( ph /\ ps ) /\ ph ) -> ch ) $.
    $( Absorption of antecedent into conjunction. $)
    anabss1 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wch wph wps wa wph wch wps anabss1.1 adantrr anidms $.
      $( [20-Jul-1996] $)
  $}

  ${
    anabss3.1 $e |- ( ( ( ph /\ ps ) /\ ps ) -> ch ) $.
    $( Absorption of antecedent into conjunction. $)
    anabss3 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wch wph wps wa wps wch wph anabss3.1 adantrl anidms $.
      $( [20-Jul-1996] $)
  $}

  ${
    anabss4.1 $e |- ( ( ( ps /\ ph ) /\ ps ) -> ch ) $.
    $( Absorption of antecedent into conjunction. $)
    anabss4 $p |- ( ( ph /\ ps ) -> ch ) $=
      wps wph wch wps wph wch anabss4.1 anabss1 ancoms $.
      $( [20-Jul-1996] $)
  $}

  ${
    anabss5.1 $e |- ( ( ph /\ ( ph /\ ps ) ) -> ch ) $.
    $( Absorption of antecedent into conjunction. $)
    anabss5 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wch wph wph wps wa wch wps anabss5.1 adantlr anidms $.
      $( [10-May-1994] $)
  $}

  ${
    anabss7.1 $e |- ( ( ps /\ ( ph /\ ps ) ) -> ch ) $.
    $( Absorption of antecedent into conjunction. $)
    anabss7 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wps wph wps wa wch anabss7.1 ex anabsi7 $.
      $( [20-Jul-1996] $)
  $}

  ${
    anabsan.1 $e |- ( ( ( ph /\ ph ) /\ ps ) -> ch ) $.
    $( Absorption of antecedent with conjunction. $)
    anabsan $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wph wps wch anabsan.1 an1rs anabss1 $.
      $( [24-Mar-1996] $)
  $}

  ${
    anabsan2.1 $e |- ( ( ph /\ ( ps /\ ps ) ) -> ch ) $.
    $( Absorption of antecedent with conjunction. $)
    anabsan2 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wps wch anabsan2.1 anassrs anabss3 $.
      $( [10-May-2004] $) $( [10-May-2004] $)
  $}

  $( Rearrangement of 4 conjuncts. $)
  an4 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
              ( ( ph /\ ch ) /\ ( ps /\ th ) ) ) $=
    wph wps wch wth wa wa wa wph wch wps wth wa wa wa wph wps wa wch wth wa wa
    wph wch wa wps wth wa wa wps wch wth wa wa wch wps wth wa wa wph wps wch
    wth an12 anbi2i wph wps wch wth wa anass wph wch wps wth wa anass 3bitr4i
    $.
    $( [10-Jul-1994] $)

  $( Rearrangement of 4 conjuncts. $)
  an42 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
                 ( ( ph /\ ch ) /\ ( th /\ ps ) ) ) $=
    wph wps wa wch wth wa wa wph wch wa wps wth wa wa wph wch wa wth wps wa wa
    wph wps wch wth an4 wps wth wa wth wps wa wph wch wa wps wth ancom anbi2i
    bitri $.
    $( [7-Feb-1996] $)

  ${
    an4s.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( Inference rearranging 4 conjuncts in antecedent. $)
    an4s $p |- ( ( ( ph /\ ch ) /\ ( ps /\ th ) ) -> ta ) $=
      wph wch wa wps wth wa wa wph wps wa wch wth wa wa wta wph wch wps wth an4
      an4s.1 sylbi $.
      $( [10-Aug-1995] $)
  $}

  ${
    an41r3s.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( Inference rearranging 4 conjuncts in antecedent. $)
    an42s $p |- ( ( ( ph /\ ch ) /\ ( th /\ ps ) ) -> ta ) $=
      wph wch wa wth wps wa wa wph wps wa wch wth wa wa wta wph wps wch wth
      an42 an41r3s.1 sylbir $.
      $( [10-Aug-1995] $)
  $}

  $( Distribution of conjunction over conjunction. $)
  anandi $p |- ( ( ph /\ ( ps /\ ch ) ) <->
               ( ( ph /\ ps ) /\ ( ph /\ ch ) ) ) $=
    wph wps wch wa wa wph wph wa wps wch wa wa wph wps wa wph wch wa wa wph wph
    wa wph wps wch wa wph anidm anbi1i wph wph wps wch an4 bitr3i $.
    $( [14-Aug-1995] $)

  $( Distribution of conjunction over conjunction. $)
  anandir $p |- ( ( ( ph /\ ps ) /\ ch ) <->
               ( ( ph /\ ch ) /\ ( ps /\ ch ) ) ) $=
    wph wps wa wch wa wph wps wa wch wch wa wa wph wch wa wps wch wa wa wch wch
    wa wch wph wps wa wch anidm anbi2i wph wps wch wch an4 bitr3i $.
    $( [24-Aug-1995] $)

  ${
    anandis.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) ) -> ta ) $.
    $( Inference that undistributes conjunction in the antecedent. $)
    anandis $p |- ( ( ph /\ ( ps /\ ch ) ) -> ta ) $=
      wph wps wch wa wta wph wps wph wch wta anandis.1 an4s anabsan $.
      $( [7-Jun-2004] $) $( [7-Jun-2004] $)
  $}

  ${
    anandirs.1 $e |- ( ( ( ph /\ ch ) /\ ( ps /\ ch ) ) -> ta ) $.
    $( Inference that undistributes conjunction in the antecedent. $)
    anandirs $p |- ( ( ( ph /\ ps ) /\ ch ) -> ta ) $=
      wph wps wa wch wta wph wch wps wch wta anandirs.1 an4s anabsan2 $.
      $( [8-Jun-2004] $) $( [7-Jun-2004] $)
  $}

  $( A theorem similar to the standard definition of the biconditional.
     Definition of [Margaris] p. 49. $)
  dfbi2 $p |- ( ( ph <-> ps ) <-> ( ( ph -> ps ) /\ ( ps -> ph ) ) ) $=
    wph wps wb wph wps wi wps wph wi wn wi wn wph wps wi wps wph wi wa wph wps
    dfbi1 wph wps wi wps wph wi df-an bitr4i $.
    $( [5-Aug-1993] $)

  $( Definition ~ def-bi rewritten in an abbreviated form to help intuitive
     understanding of that definition.  Note that it is a conjunction of
     two implications; one which asserts properties that follow from the
     biconditional and one which asserts properties that imply the
     biconditional. $)
  dfbi $p |- ( ( ( ph <-> ps ) -> ( ( ph -> ps ) /\ ( ps -> ph ) ) )
        /\ ( ( ( ph -> ps ) /\ ( ps -> ph ) ) -> ( ph <-> ps ) ) ) $=
    wph wps wb wph wps wi wps wph wi wa wi wph wps wi wps wph wi wa wph wps wb
    wi wph wps wb wph wps wi wps wph wi wa wph wps dfbi2 biimpi wph wps wb wph
    wps wi wps wph wi wa wph wps dfbi2 biimpri pm3.2i $.
    $( [16-Aug-2008] $) $( [15-Aug-2008] $)

  ${
    impbid.1 $e |- ( ph -> ( ps -> ch ) ) $.
    impbid.2 $e |- ( ph -> ( ch -> ps ) ) $.
    $( Deduce an equivalence from two implications. $)
    impbid $p |- ( ph -> ( ps <-> ch ) ) $=
      wps wch wb wps wch wi wch wps wi wph wps wch dfbi2 impbid.1 impbid.2
      sylanbrc $.
      $( [5-Aug-1993] $)
  $}

  ${
    impbid1.1 $e |- ( ph -> ( ps -> ch ) ) $.
    impbid1.2 $e |- ( ch -> ps ) $.
    $( Infer an equivalence from two implications. $)
    impbid1 $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wch impbid1.1 wch wps wi wph impbid1.2 a1i impbid $.
      $( [7-Mar-2007] $) $( [6-Mar-2007] $)
  $}

  ${
    impbid2.1 $e |- ( ps -> ch ) $.
    impbid2.2 $e |- ( ph -> ( ch -> ps ) ) $.
    $( Infer an equivalence from two implications. $)
    impbid2 $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wch wps wch wi wph impbid2.1 a1i impbid2.2 impbid $.
      $( [7-Mar-2007] $) $( [6-Mar-2007] $)
  $}

  ${
    impbida.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    impbida.2 $e |- ( ( ph /\ ch ) -> ps ) $.
    $( Deduce an equivalence from two implications. $)
    impbida $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wch wph wps wch impbida.1 ex wph wch wps impbida.2 ex impbid $.
      $( [20-Feb-2007] $) $( [17-Feb-2007] $)
  $}

  $( Commutative law for equivalence.  Theorem *4.21 of [WhiteheadRussell]
     p. 117. $)
  bicom $p |- ( ( ph <-> ps ) <-> ( ps <-> ph ) ) $=
    wph wps wi wps wph wi wa wps wph wi wph wps wi wa wph wps wb wps wph wb wph
    wps wi wps wph wi ancom wph wps dfbi2 wps wph dfbi2 3bitr4i $.
    $( [5-Aug-1993] $)

  ${
    bicomd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Commute two sides of a biconditional in a deduction. $)
    bicomd $p |- ( ph -> ( ch <-> ps ) ) $=
      wph wps wch wb wch wps wb bicomd.1 wps wch bicom sylib $.
      $( [5-Aug-1993] $)
  $}

  $( Contraposition.  Theorem *4.11 of [WhiteheadRussell] p. 117. $)
  notbi $p |- ( ( ph <-> ps ) <-> ( -. ph <-> -. ps ) ) $=
    wph wps wb wps wn wph wn wb wph wn wps wn wb wph wps wi wps wph wi wa wps
    wn wph wn wi wph wn wps wn wi wa wph wps wb wps wn wph wn wb wph wps wi wps
    wn wph wn wi wps wph wi wph wn wps wn wi wph wps con34b wps wph con34b
    anbi12i wph wps dfbi2 wps wn wph wn dfbi2 3bitr4i wps wn wph wn bicom bitri
    $.
    $( [21-May-1994] $)

  ${
    con4bii.1 $e |- ( -. ph <-> -. ps ) $.
    $( A contraposition inference. $)
    con4bii $p |- ( ph <-> ps ) $=
      wph wps wb wph wn wps wn wb con4bii.1 wph wps notbi mpbir $.
      $( [21-May-1994] $)
  $}

  ${
    con4bid.1 $e |- ( ph -> ( -. ps <-> -. ch ) ) $.
    $( A contraposition deduction. $)
    con4bid $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wn wch wn wb wps wch wb con4bid.1 wps wch notbi sylibr $.
      $( [21-May-1994] $)
  $}

  $( Contraposition.  Theorem *4.12 of [WhiteheadRussell] p. 117. $)
  con2bi $p |- ( ( ph <-> -. ps ) <-> ( ps <-> -. ph ) ) $=
    wph wps wn wi wps wn wph wi wa wps wph wn wi wph wn wps wi wa wph wps wn wb
    wps wph wn wb wph wps wn wi wps wph wn wi wps wn wph wi wph wn wps wi wph
    wps con2b wps wph con1b anbi12i wph wps wn dfbi2 wps wph wn dfbi2 3bitr4i
    $.
    $( [15-Apr-1995] $)

  ${
    con2bid.1 $e |- ( ph -> ( ps <-> -. ch ) ) $.
    $( A contraposition deduction. $)
    con2bid $p |- ( ph -> ( ch <-> -. ps ) ) $=
      wph wps wch wn wb wch wps wn wb con2bid.1 wch wps con2bi sylibr $.
      $( [15-Apr-1995] $)
  $}

  ${
    con1bid.1 $e |- ( ph -> ( -. ps <-> ch ) ) $.
    $( A contraposition deduction. $)
    con1bid $p |- ( ph -> ( -. ch <-> ps ) ) $=
      wph wps wch wn wph wch wps wph wps wn wch con1bid.1 bicomd con2bid bicomd
      $.
      $( [9-Oct-1999] $)
  $}

  ${
    bitrd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitrd.2 $e |- ( ph -> ( ch <-> th ) ) $.
    $( Deduction form of ~ bitri . $)
    bitrd $p |- ( ph -> ( ps <-> th ) ) $=
      wph wps wth wph wps wch wth wph wps wch bitrd.1 biimpd bitrd.2 sylibd wph
      wth wch wps wph wch wth bitrd.2 biimprd bitrd.1 sylibrd impbid $.
      $( [5-Aug-1993] $)
  $}

  ${
    bitr2d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitr2d.2 $e |- ( ph -> ( ch <-> th ) ) $.
    $( Deduction form of ~ bitr2i . $)
    bitr2d $p |- ( ph -> ( th <-> ps ) ) $=
      wph wps wth wph wps wch wth bitr2d.1 bitr2d.2 bitrd bicomd $.
      $( [11-Jun-2004] $) $( [9-Jun-2004] $)
  $}

  ${
    bitr3d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitr3d.2 $e |- ( ph -> ( ps <-> th ) ) $.
    $( Deduction form of ~ bitr3i . $)
    bitr3d $p |- ( ph -> ( ch <-> th ) ) $=
      wph wch wps wth wph wps wch bitr3d.1 bicomd bitr3d.2 bitrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    bitr4d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitr4d.2 $e |- ( ph -> ( th <-> ch ) ) $.
    $( Deduction form of ~ bitr4i . $)
    bitr4d $p |- ( ph -> ( ps <-> th ) ) $=
      wph wps wch wth bitr4d.1 wph wth wch bitr4d.2 bicomd bitrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5bb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl5bb.2 $e |- ( th <-> ps ) $.
    $( A syllogism inference from two biconditionals. $)
    syl5bb $p |- ( ph -> ( th <-> ch ) ) $=
      wph wth wps wch wth wps wb wph syl5bb.2 a1i syl5bb.1 bitrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5rbb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl5rbb.2 $e |- ( th <-> ps ) $.
    $( A syllogism inference from two biconditionals. $)
    syl5rbb $p |- ( ph -> ( ch <-> th ) ) $=
      wph wth wch wph wps wch wth syl5rbb.1 syl5rbb.2 syl5bb bicomd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5bbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl5bbr.2 $e |- ( ps <-> th ) $.
    $( A syllogism inference from two biconditionals. $)
    syl5bbr $p |- ( ph -> ( th <-> ch ) ) $=
      wph wps wch wth syl5bbr.1 wps wth syl5bbr.2 bicomi syl5bb $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5rbbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl5rbbr.2 $e |- ( ps <-> th ) $.
    $( A syllogism inference from two biconditionals. $)
    syl5rbbr $p |- ( ph -> ( ch <-> th ) ) $=
      wph wps wch wth syl5rbbr.1 wps wth syl5rbbr.2 bicomi syl5rbb $.
      $( [25-Nov-1994] $)
  $}

  ${
    syl6bb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6bb.2 $e |- ( ch <-> th ) $.
    $( A syllogism inference from two biconditionals. $)
    syl6bb $p |- ( ph -> ( ps <-> th ) ) $=
      wph wps wch wth syl6bb.1 wch wth wb wph syl6bb.2 a1i bitrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6rbb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6rbb.2 $e |- ( ch <-> th ) $.
    $( A syllogism inference from two biconditionals. $)
    syl6rbb $p |- ( ph -> ( th <-> ps ) ) $=
      wph wps wth wph wps wch wth syl6rbb.1 syl6rbb.2 syl6bb bicomd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6bbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6bbr.2 $e |- ( th <-> ch ) $.
    $( A syllogism inference from two biconditionals. $)
    syl6bbr $p |- ( ph -> ( ps <-> th ) ) $=
      wph wps wch wth syl6bbr.1 wth wch syl6bbr.2 bicomi syl6bb $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6rbbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6rbbr.2 $e |- ( th <-> ch ) $.
    $( A syllogism inference from two biconditionals. $)
    syl6rbbr $p |- ( ph -> ( th <-> ps ) ) $=
      wph wps wch wth syl6rbbr.1 wth wch syl6rbbr.2 bicomi syl6rbb $.
      $( [25-Nov-1994] $)
  $}

  ${
    sylan9bb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    sylan9bb.2 $e |- ( th -> ( ch <-> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents. $)
    sylan9bb $p |- ( ( ph /\ th ) -> ( ps <-> ta ) ) $=
      wph wth wa wps wch wta wph wps wch wb wth sylan9bb.1 adantr wth wch wta
      wb wph sylan9bb.2 adantl bitrd $.
      $( [4-Mar-1995] $)
  $}

  ${
    sylan9bbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    sylan9bbr.2 $e |- ( th -> ( ch <-> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents. $)
    sylan9bbr $p |- ( ( th /\ ph ) -> ( ps <-> ta ) ) $=
      wph wth wps wta wb wph wps wch wth wta sylan9bbr.1 sylan9bbr.2 sylan9bb
      ancoms $.
      $( [4-Mar-1995] $)
  $}

  ${
    3imtr3d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr3d.2 $e |- ( ph -> ( ps <-> th ) ) $.
    3imtr3d.3 $e |- ( ph -> ( ch <-> ta ) ) $.
    $( More general version of ~ 3imtr3i .  Useful for converting
       conditional definitions in a formula. $)
    3imtr3d $p |- ( ph -> ( th -> ta ) ) $=
      wph wth wps wta 3imtr3d.2 wph wps wch wta 3imtr3d.1 3imtr3d.3 sylibd
      sylbird $.
      $( [8-Apr-1996] $)
  $}

  ${
    3imtr4d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr4d.2 $e |- ( ph -> ( th <-> ps ) ) $.
    3imtr4d.3 $e |- ( ph -> ( ta <-> ch ) ) $.
    $( More general version of ~ 3imtr4i .  Useful for converting
       conditional definitions in a formula. $)
    3imtr4d $p |- ( ph -> ( th -> ta ) ) $=
      wph wth wps wta 3imtr4d.2 wph wps wch wta 3imtr4d.1 3imtr4d.3 sylibrd
      sylbid $.
      $( [26-Oct-1995] $)
  $}

  ${
    3bitrd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitrd.2 $e |- ( ph -> ( ch <-> th ) ) $.
    3bitrd.3 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction from transitivity of biconditional. $)
    3bitrd $p |- ( ph -> ( ps <-> ta ) ) $=
      wph wps wth wta wph wps wch wth 3bitrd.1 3bitrd.2 bitrd 3bitrd.3 bitrd $.
      $( [13-Aug-1999] $)

    $( Deduction from transitivity of biconditional. $)
    3bitrrd $p |- ( ph -> ( ta <-> ps ) ) $=
      wph wth wta wps 3bitrd.3 wph wps wch wth 3bitrd.1 3bitrd.2 bitr2d bitr3d
      $.
      $( [11-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3bitr2d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr2d.2 $e |- ( ph -> ( th <-> ch ) ) $.
    3bitr2d.3 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction from transitivity of biconditional. $)
    3bitr2d $p |- ( ph -> ( ps <-> ta ) ) $=
      wph wps wth wta wph wps wch wth 3bitr2d.1 3bitr2d.2 bitr4d 3bitr2d.3
      bitrd $.
      $( [11-Aug-2006] $) $( [4-Aug-2006] $)

    $( Deduction from transitivity of biconditional. $)
    3bitr2rd $p |- ( ph -> ( ta <-> ps ) ) $=
      wph wps wth wta wph wps wch wth 3bitr2d.1 3bitr2d.2 bitr4d 3bitr2d.3
      bitr2d $.
      $( [11-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3bitr3d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr3d.2 $e |- ( ph -> ( ps <-> th ) ) $.
    3bitr3d.3 $e |- ( ph -> ( ch <-> ta ) ) $.
    $( Deduction from transitivity of biconditional.  Useful for converting
       conditional definitions in a formula. $)
    3bitr3d $p |- ( ph -> ( th <-> ta ) ) $=
      wph wth wch wta wph wps wth wch 3bitr3d.2 3bitr3d.1 bitr3d 3bitr3d.3
      bitrd $.
      $( [24-Apr-1996] $)

    $( Deduction from transitivity of biconditional. $)
    3bitr3rd $p |- ( ph -> ( ta <-> th ) ) $=
      wph wch wta wth 3bitr3d.3 wph wps wch wth 3bitr3d.1 3bitr3d.2 bitr3d
      bitr3d $.
      $( [11-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3bitr4d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr4d.2 $e |- ( ph -> ( th <-> ps ) ) $.
    3bitr4d.3 $e |- ( ph -> ( ta <-> ch ) ) $.
    $( Deduction from transitivity of biconditional.  Useful for converting
       conditional definitions in a formula. $)
    3bitr4d $p |- ( ph -> ( th <-> ta ) ) $=
      wph wth wps wta 3bitr4d.2 wph wps wch wta 3bitr4d.1 3bitr4d.3 bitr4d
      bitrd $.
      $( [18-Oct-1995] $)

    $( Deduction from transitivity of biconditional. $)
    3bitr4rd $p |- ( ph -> ( ta <-> th ) ) $=
      wph wta wps wth wph wta wch wps 3bitr4d.3 3bitr4d.1 bitr4d 3bitr4d.2
      bitr4d $.
      $( [11-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3imtr3g.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr3g.2 $e |- ( ps <-> th ) $.
    3imtr3g.3 $e |- ( ch <-> ta ) $.
    $( More general version of ~ 3imtr3i .  Useful for converting
       definitions in a formula. $)
    3imtr3g $p |- ( ph -> ( th -> ta ) ) $=
      wph wth wta wph wps wa wch wph wth wa wta wph wps wch 3imtr3g.1 imp wps
      wth wph 3imtr3g.2 anbi2i 3imtr3g.3 3imtr3i ex $.
      $( [20-May-1996] $)
  $}

  ${
    3imtr4g.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr4g.2 $e |- ( th <-> ps ) $.
    3imtr4g.3 $e |- ( ta <-> ch ) $.
    $( More general version of ~ 3imtr4i .  Useful for converting
       definitions in a formula. $)
    3imtr4g $p |- ( ph -> ( th -> ta ) ) $=
      wph wps wch wth wta 3imtr4g.1 wth wps 3imtr4g.2 bicomi wta wch 3imtr4g.3
      bicomi 3imtr3g $.
      $( [20-May-1996] $)
  $}

  ${
    3bitr3g.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr3g.2 $e |- ( ps <-> th ) $.
    3bitr3g.3 $e |- ( ch <-> ta ) $.
    $( More general version of ~ 3bitr3i .  Useful for converting
       definitions in a formula. $)
    3bitr3g $p |- ( ph -> ( th <-> ta ) ) $=
      wph wth wch wta wph wps wch wth 3bitr3g.1 3bitr3g.2 syl5bbr 3bitr3g.3
      syl6bb $.
      $( [4-Jun-1995] $)
  $}

  ${
    3bitr4g.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr4g.2 $e |- ( th <-> ps ) $.
    3bitr4g.3 $e |- ( ta <-> ch ) $.
    $( More general version of ~ 3bitr4i .  Useful for converting
       definitions in a formula. $)
    3bitr4g $p |- ( ph -> ( th <-> ta ) ) $=
      wph wth wch wta wph wps wch wth 3bitr4g.1 3bitr4g.2 syl5bb 3bitr4g.3
      syl6bbr $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem *3.47 of [WhiteheadRussell] p. 113.  It was proved by Leibniz, and
     it evidently pleased him enough to call it 'praeclarum theorema' (splendid
     theorem). $)
  prth $p |- ( ( ( ph -> ps ) /\ ( ch -> th ) ) ->
               ( ( ph /\ ch ) -> ( ps /\ th ) ) ) $=
    wph wps wi wch wth wi wph wch wps wth wa wph wps wi wph wch wth wi wch wps
    wth wa wi wps wch wth wi wch wps wth wa wi wi wph wps wth wps wth wa wch
    wps wth pm3.2 imim2d imim2i com23 imp4b $.
    $( [12-Aug-1993] $)

  $( Theorem *3.48 of [WhiteheadRussell] p. 114. $)
  pm3.48 $p |- ( ( ( ph -> ps ) /\ ( ch -> th ) ) ->
               ( ( ph \/ ch ) -> ( ps \/ th ) ) ) $=
    wph wps wi wch wth wi wa wph wn wch wi wps wn wth wi wph wch wo wps wth wo
    wph wps wi wch wth wi wa wps wn wph wn wch wth wph wps wi wch wth wi wa wph
    wps wph wps wi wch wth wi pm3.26 con3d wph wps wi wch wth wi pm3.27 imim12d
    wph wch df-or wps wth df-or 3imtr4g $.
    $( [28-Jan-1997] $)

  ${
    anim12d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    anim12d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( Conjoin antecedents and consequents in a deduction. $)
    anim12d $p |- ( ph -> ( ( ps /\ th ) -> ( ch /\ ta ) ) ) $=
      wps wch wi wth wta wi wps wth wa wch wta wa wi wph wps wch wth wta prth
      anim12d.1 anim12d.2 sylanc $.
      $( [3-Apr-1994] $)
  $}

  ${
    anim12ii.1 $e |- ( ph -> ( ps -> ch ) ) $.
    anim12ii.2 $e |- ( th -> ( ps -> ta ) ) $.
    $( Conjoin antecedents and consequents in a deduction. $)
    anim12ii $p |- ( ( ph /\ th ) -> ( ps -> ( ch /\ ta ) ) ) $=
      wps wph wth wa wch wta wa wps wph wch wth wta wph wps wch anim12ii.1
      com12 wth wps wta anim12ii.2 com12 anim12d com12 $.
      $( [12-Nov-2007] $) $( [11-Nov-2007] $)
  $}

  ${
    anim1d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Add a conjunct to right of antecedent and consequent in a deduction. $)
    anim1d $p |- ( ph -> ( ( ps /\ th ) -> ( ch /\ th ) ) ) $=
      wph wps wch wth wth anim1d.1 wph wth idd anim12d $.
      $( [3-Apr-1994] $)

    $( Add a conjunct to left of antecedent and consequent in a deduction. $)
    anim2d $p |- ( ph -> ( ( th /\ ps ) -> ( th /\ ch ) ) ) $=
      wph wth wth wps wch wph wth idd anim1d.1 anim12d $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem *3.45 (Fact) of [WhiteheadRussell] p. 113. $)
  pm3.45 $p |-  ( ( ph -> ps ) -> ( ( ph /\ ch ) -> ( ps /\ ch ) ) ) $=
    wph wps wi wph wps wch wph wps wi id anim1d $.
    $( [17-Jan-2005] $) $( [3-Jan-2005] $)

  ${
    $v et $. $( Greek eta $)
    im2an9.wet $f wff et $.
    im2an9.1 $e |- ( ph -> ( ps -> ch ) ) $.
    im2an9.2 $e |- ( th -> ( ta -> et ) ) $.

    $( Deduction joining nested implications to form implication of
       conjunctions. $)
    im2anan9 $p |- ( ( ph /\ th ) -> ( ( ps /\ ta ) -> ( ch /\ et ) ) ) $=
      wph wth wa wps wch wta im2an9.wet wph wps wch wi wth im2an9.1 adantr wth
      wta im2an9.wet wi wph im2an9.2 adantl anim12d $.
      $( [29-Feb-1996] $)

    $( Deduction joining nested implications to form implication of
       conjunctions. $)
    im2anan9r $p |- ( ( th /\ ph ) -> ( ( ps /\ ta ) -> ( ch /\ et ) ) ) $=
      wth wph wa wps wch wta im2an9.wet wph wps wch wi wth im2an9.1 adantl wth
      wta im2an9.wet wi wph im2an9.2 adantr anim12d $.
      $( [29-Feb-1996] $)

  $}

  ${
    orim12d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    orim12d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( Disjoin antecedents and consequents in a deduction. $)
    orim12d $p |- ( ph -> ( ( ps \/ th ) -> ( ch \/ ta ) ) ) $=
      wps wch wi wth wta wi wps wth wo wch wta wo wi wph wps wch wth wta pm3.48
      orim12d.1 orim12d.2 sylanc $.
      $( [10-May-1994] $)
  $}

  ${
    orim1d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Disjoin antecedents and consequents in a deduction. $)
    orim1d $p |- ( ph -> ( ( ps \/ th ) -> ( ch \/ th ) ) ) $=
      wph wps wch wth wth orim1d.1 wph wth idd orim12d $.
      $( [23-Apr-1995] $)

    $( Disjoin antecedents and consequents in a deduction. $)
    orim2d $p |- ( ph -> ( ( th \/ ps ) -> ( th \/ ch ) ) ) $=
      wph wth wth wps wch wph wth idd orim1d.1 orim12d $.
      $( [23-Apr-1995] $)
  $}

  $( Axiom *1.6 (Sum) of [WhiteheadRussell] p. 97. $)
  orim2 $p |-  ( ( ps -> ch ) -> ( ( ph \/ ps ) -> ( ph \/ ch ) ) ) $=
    wps wch wi wps wch wph wps wch wi id orim2d $.
    $( [16-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.38 of [WhiteheadRussell] p. 105. $)
  pm2.38 $p |-  ( ( ps -> ch ) -> ( ( ps \/ ph ) -> ( ch \/ ph ) ) ) $=
    wps wch wi wps wch wph wps wch wi id orim1d $.
    $( [6-Mar-2008] $) $( [6-Mar-2008] $)

  $( Theorem *2.36 of [WhiteheadRussell] p. 105. $)
  pm2.36 $p |-  ( ( ps -> ch ) -> ( ( ph \/ ps ) -> ( ch \/ ph ) ) ) $=
    wps wch wi wps wph wo wch wph wo wph wps wo wph wps wch pm2.38 wph wps
    pm1.4 syl5 $.
    $( [6-Mar-2008] $) $( [6-Mar-2008] $)

  $( Theorem *2.37 of [WhiteheadRussell] p. 105. $)
  pm2.37 $p |-  ( ( ps -> ch ) -> ( ( ps \/ ph ) -> ( ph \/ ch ) ) ) $=
    wps wch wi wps wph wo wch wph wo wph wch wo wph wps wch pm2.38 wch wph
    pm1.4 syl6 $.
    $( [6-Mar-2008] $) $( [6-Mar-2008] $)

  $( Theorem *2.73 of [WhiteheadRussell] p. 108. $)
  pm2.73 $p |-  ( ( ph -> ps ) -> ( ( ( ph \/ ps ) \/ ch ) ->
                ( ps \/ ch ) ) ) $=
    wph wps wi wph wps wo wps wch wph wps pm2.621 orim1d $.
    $( [29-Apr-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.74 of [WhiteheadRussell] p. 108. $)
  pm2.74 $p |-  ( ( ps -> ph ) -> ( ( ( ph \/ ps ) \/ ch ) ->
                ( ph \/ ch ) ) ) $=
    wps wph wph wps wo wch wo wph wch wo wi wps wn wph wps wo wph wch wps wph
    orel2 orim1d wph wph wch wo wph wps wo wch wo wph wch orc a1d ja $.
    $( [9-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.75 of [WhiteheadRussell] p. 108. $)
  pm2.75 $p |-  ( ( ph \/ ps ) ->
                ( ( ph \/ ( ps -> ch ) ) -> ( ph \/ ch ) ) ) $=
    wph wph wps wch wi wo wph wch wo wi wps wph wph wch wo wph wps wch wi wo
    wph wch orc a1d wps wps wch wi wch wph wps wch pm2.27 orim2d jaoi $.
    $( [14-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.76 of [WhiteheadRussell] p. 108. $)
  pm2.76 $p |-  ( ( ph \/ ( ps -> ch ) ) ->
                ( ( ph \/ ps ) -> ( ph \/ ch ) ) ) $=
    wph wps wo wph wps wch wi wo wph wch wo wph wps wch pm2.75 com12 $.
    $( [16-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.8 of [WhiteheadRussell] p. 108. $)
  pm2.8 $p |-  ( ( ps \/ ch ) -> ( ( -. ch \/ th ) -> ( ps \/ th ) ) ) $=
    wps wch wn wth wo wps wth wo wi wch wps wps wth wo wch wn wth wo wps wth
    orc a1d wch wch wn wps wth wch wps pm2.24 orim1d jaoi $.
    $( [16-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.81 of [WhiteheadRussell] p. 108. $)
  pm2.81 $p |-  ( ( ps -> ( ch -> th ) ) -> ( ( ph \/ ps ) ->
                ( ( ph \/ ch ) -> ( ph \/ th ) ) ) ) $=
    wps wch wth wi wi wph wps wo wph wch wth wi wo wph wch wo wph wth wo wi wph
    wps wch wth wi orim2 wph wch wth pm2.76 syl6 $.
    $( [17-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.82 of [WhiteheadRussell] p. 108. $)
  pm2.82 $p |-  ( ( ( ph \/ ps ) \/ ch ) -> ( ( ( ph \/ -. ch ) \/ th ) ->
                ( ( ph \/ ps ) \/ th ) ) ) $=
    wph wps wo wch wo wph wch wn wo wph wps wo wth wph wps wo wph wch wn wo wph
    wps wo wi wch wph wps wo wph wch wn wo ax-1 wch wch wn wps wph wch wps
    pm2.24 orim2d jaoi orim1d $.
    $( [18-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.85 of [WhiteheadRussell] p. 108. $)
  pm2.85 $p |-  ( ( ( ph \/ ps ) -> ( ph \/ ch ) ) ->
                ( ph \/ ( ps -> ch ) ) ) $=
    wph wps wo wph wch wo wi wph wps wn wo wph wch wo wo wph wps wch wi wo wph
    wps wo wph wch wo wi wph wps wo wn wph wch wo wo wph wps wn wo wph wch wo
    wo wph wps wo wph wch wo imor wph wps wo wn wph wps wn wo wph wch wo wph
    wps pm2.48 orim1i sylbi wph wps wch wi wo wph wps wn wch wo wo wph wps wn
    wo wph wch wo wo wps wch wi wps wn wch wo wph wps wch imor orbi2i wph wps
    wn wch orordi bitr2i sylib $.
    $( [9-Jan-2005] $) $( [3-Jan-2005] $)

  ${
    pm3.2ni.1 $e |- -. ph $.
    pm3.2ni.2 $e |- -. ps $.
    $( Infer negated disjunction of negated premises. $)
    pm3.2ni $p |- -. ( ph \/ ps ) $=
      wph wps wo wn wph wn wps wn wa wph wn wps wn pm3.2ni.1 pm3.2ni.2 pm3.2i
      wph wps ioran mpbir $.
      $( [4-Apr-1995] $)
  $}

  $( Absorption of redundant internal disjunct.  Compare Theorem *4.45
     of [WhiteheadRussell] p. 119. $)
  orabs $p |- ( ph <-> ( ( ph \/ ps ) /\ ph ) ) $=
    wph wph wps wo wph wa wph wph wps wo wph wps orc ancri wph wps wo wph
    pm3.27 impbii $.
    $( [5-Aug-1993] $)

  $( Absorb a disjunct into a conjunct.  (Contributed by Roy F. Longton
     23-Jun-2005.) $)
  oranabs $p |- ( ( ( ph \/ -. ps ) /\ ps ) <-> ( ph /\ ps ) ) $=
    wph wps wn wo wps wn wn wa wph wps wn wn wa wph wps wn wo wps wa wph wps wa
    wph wps wn pm5.61 wps wps wn wn wph wps wn wo wps notnot anbi2i wps wps wn
    wn wph wps notnot anbi2i 3bitr4i $.
    $( [12-Apr-2008] $) $( [23-Jun-2005] $)

  $( Distribution of implication over biconditional.  Theorem *5.74 of
     [WhiteheadRussell] p. 126. $)
  pm5.74 $p |- ( ( ph -> ( ps <-> ch ) ) <->
               ( ( ph -> ps ) <-> ( ph -> ch ) ) ) $=
    wph wps wch wb wi wph wps wi wph wch wi wb wph wps wch wb wi wph wps wi wph
    wch wi wps wch wb wps wch wph wps wch bi1 imim3i wps wch wb wch wps wph wps
    wch bi2 imim3i impbid wph wps wi wph wch wi wb wph wph wa wps wch wi wch
    wps wi wa wph wps wch wb wph wps wi wph wch wi wb wph wps wch wi wph wch
    wps wi wph wps wi wph wch wi wb wph wps wch wph wps wi wph wch wi bi1
    pm2.86d wph wps wi wph wch wi wb wph wch wps wph wps wi wph wch wi bi2
    pm2.86d anim12d wph pm4.24 wps wch dfbi2 3imtr4g impbii $.
    $( [1-Aug-1994] $)

  ${
    pm5.74i.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Distribution of implication over biconditional (inference rule). $)
    pm5.74i $p |- ( ( ph -> ps ) <-> ( ph -> ch ) ) $=
      wph wps wch wb wi wph wps wi wph wch wi wb pm5.74i.1 wph wps wch pm5.74
      mpbi $.
      $( [1-Aug-1994] $)
  $}

  ${
    pm5.74d.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Distribution of implication over biconditional (deduction rule). $)
    pm5.74d $p |- ( ph -> ( ( ps -> ch ) <-> ( ps -> th ) ) ) $=
      wph wps wch wth wb wi wps wch wi wps wth wi wb pm5.74d.1 wps wch wth
      pm5.74 sylib $.
      $( [21-Mar-1996] $)
  $}

  ${
    pm5.74da.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Distribution of implication over biconditional (deduction rule). $)
    pm5.74da $p |- ( ph -> ( ( ps -> ch ) <-> ( ps -> th ) ) ) $=
      wph wps wch wth wph wps wch wth wb pm5.74da.1 ex pm5.74d $.
      $( [5-May-2007] $) $( [4-May-2007] $)
  $}

  ${
    pm5.74ri.1 $e |- ( ( ph -> ps ) <-> ( ph -> ch ) ) $.
    $( Distribution of implication over biconditional (reverse inference
       rule). $)
    pm5.74ri $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wch wb wi wph wps wi wph wch wi wb pm5.74ri.1 wph wps wch pm5.74
      mpbir $.
      $( [1-Aug-1994] $)
  $}

  ${
    pm5.74rd.1 $e |- ( ph -> ( ( ps -> ch ) <-> ( ps -> th ) ) ) $.
    $( Distribution of implication over biconditional (deduction rule). $)
    pm5.74rd $p |- ( ph -> ( ps -> ( ch <-> th ) ) ) $=
      wph wps wch wi wps wth wi wb wps wch wth wb wi pm5.74rd.1 wps wch wth
      pm5.74 sylibr $.
      $( [19-Mar-1997] $)
  $}

  ${
    mpbidi.min $e |- ( th -> ( ph -> ps ) ) $.
    mpbidi.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, related to modus ponens. $)
    mpbidi $p |- ( th -> ( ph -> ch ) ) $=
      wth wph wps wi wph wch wi mpbidi.min wph wps wch mpbidi.maj pm5.74i sylib
      $.
      $( [9-Aug-1994] $)
  $}

  $( Implication in terms of implication and biconditional. $)
  ibib $p |- ( ( ph -> ps ) <-> ( ph -> ( ph <-> ps ) ) ) $=
    wph wps wph wps wb wph wps wph wps wb wph wps wph wps wb wph wps wa wph wps
    wph wps pm3.4 wph wps wa wph wps wph wps pm3.26 a1d impbid ex wph wps wb
    wph wps wph wps bi1 com12 impbid pm5.74i $.
    $( [31-Mar-1994] $)

  $( Implication in terms of implication and biconditional. $)
  ibibr $p |- ( ( ph -> ps ) <-> ( ph -> ( ps <-> ph ) ) ) $=
    wph wps wi wph wph wps wb wi wph wps wph wb wi wph wps ibib wph wps wb wps
    wph wb wph wph wps bicom imbi2i bitri $.
    $( [6-Jun-2005] $) $( [29-Apr-2005] $)

  ${
    ibi.1 $e |- ( ph -> ( ph <-> ps ) ) $.
    $( Inference that converts a biconditional implied by one of its arguments,
       into an implication. $)
    ibi $p |- ( ph -> ps ) $=
      wph wps wph wph wps ibi.1 biimpd pm2.43i $.
      $( [17-Oct-2003] $) $( [17-Oct-2003] $)
  $}

  ${
    ibir.1 $e |- ( ph -> ( ps <-> ph ) ) $.
    $( Inference that converts a biconditional implied by one of its arguments,
       into an implication. $)
    ibir $p |- ( ph -> ps ) $=
      wph wps wph wps wph ibir.1 bicomd ibi $.
      $( [28-Jul-2004] $) $( [22-Jul-2004] $)
  $}

  ${
    ibd.1 $e |- ( ph -> ( ps -> ( ps <-> ch ) ) ) $.
    $( Deduction that converts a biconditional implied by one of its arguments,
       into an implication. $)
    ibd $p |- ( ph -> ( ps -> ch ) ) $=
      wph wps wps wch wb wi wps wch wi ibd.1 wps wch ibib sylibr $.
      $( [27-Jun-2004] $) $( [26-Jun-2004] $)
  $}

  $( Theorem *5.501 of [WhiteheadRussell] p. 125. $)
  pm5.501 $p |-  ( ph -> ( ps <-> ( ph <-> ps ) ) ) $=
    wph wps wph wps wb wph wps ibib pm5.74ri $.
    $( [1-Feb-2005] $) $( [3-Jan-2005] $)

  $( Distributive law for disjunction.  Theorem *4.41 of [WhiteheadRussell]
     p. 119. $)
  ordi $p |- ( ( ph \/ ( ps /\ ch ) ) <-> ( ( ph \/ ps ) /\ ( ph \/ ch ) ) ) $=
    wph wps wch wa wo wph wps wo wph wch wo wa wph wps wch wa wo wph wps wo wph
    wch wo wps wch wa wps wph wps wch pm3.26 orim2i wps wch wa wch wph wps wch
    pm3.27 orim2i jca wph wps wo wph wch wo wph wps wch wa wo wph wps wo wph wn
    wps wi wph wch wo wph wps wch wa wo wi wph wps df-or wph wn wps wi wph wn
    wch wi wph wn wps wch wa wi wph wch wo wph wps wch wa wo wph wn wps wch
    pm3.43i wph wch df-or wph wps wch wa df-or 3imtr4g sylbi imp impbii $.
    $( [5-Aug-1993] $)

  $( Distributive law for disjunction. $)
  ordir $p |- ( ( ( ph /\ ps ) \/ ch ) <->
              ( ( ph \/ ch ) /\ ( ps \/ ch ) ) ) $=
    wch wph wps wa wo wch wph wo wch wps wo wa wph wps wa wch wo wph wch wo wps
    wch wo wa wch wph wps ordi wph wps wa wch orcom wph wch wo wch wph wo wps
    wch wo wch wps wo wph wch orcom wps wch orcom anbi12i 3bitr4i $.
    $( [12-Aug-1994] $)

  $( Distributive law for implication over conjunction.  Compare Theorem
     *4.76 of [WhiteheadRussell] p. 121. $)
  jcab $p |- ( ( ph -> ( ps /\ ch ) ) <->
                 ( ( ph -> ps ) /\ ( ph -> ch ) ) ) $=
    wph wn wps wch wa wo wph wn wps wo wph wn wch wo wa wph wps wch wa wi wph
    wps wi wph wch wi wa wph wn wps wch ordi wph wps wch wa imor wph wps wi wph
    wn wps wo wph wch wi wph wn wch wo wph wps imor wph wch imor anbi12i
    3bitr4i $.
    $( [3-Apr-1994] $)

  $( Theorem *4.76 of [WhiteheadRussell] p. 121. $)
  pm4.76 $p |-  ( ( ( ph -> ps ) /\ ( ph -> ch ) ) <->
                ( ph -> ( ps /\ ch ) ) ) $=
    wph wps wch wa wi wph wps wi wph wch wi wa wph wps wch jcab bicomi $.
    $( [22-May-2005] $) $( [3-Jan-2005] $)

  ${
    jcad.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jcad.2 $e |- ( ph -> ( ps -> th ) ) $.
    $( Deduction conjoining the consequents of two implications. $)
    jcad $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      wph wps wch wth wa wph wps wa wch wth wph wps wch jcad.1 imp wph wps wth
      jcad.2 imp jca ex $.
      $( [5-Aug-1993] $)
  $}

  ${
    jctild.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jctild.2 $e |- ( ph -> th ) $.
    $( Deduction conjoining a theorem to left of consequent in an
       implication. $)
    jctild $p |- ( ph -> ( ps -> ( th /\ ch ) ) ) $=
      wph wps wth wch wph wth wps jctild.2 a1d jctild.1 jcad $.
      $( [22-Apr-2005] $) $( [21-Apr-2005] $)
  $}

  ${
    jctird.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jctird.2 $e |- ( ph -> th ) $.
    $( Deduction conjoining a theorem to right of consequent in an
       implication. $)
    jctird $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      wph wps wch wth jctird.1 wph wth wps jctird.2 a1d jcad $.
      $( [22-Apr-2005] $) $( [21-Apr-2005] $)
  $}

  $( Theorem *3.43 (Comp) of [WhiteheadRussell] p. 113. $)
  pm3.43 $p |-  ( ( ( ph -> ps ) /\ ( ph -> ch ) ) ->
                ( ph -> ( ps /\ ch ) ) ) $=
    wph wps wch wa wi wph wps wi wph wch wi wa wph wps wch jcab biimpri $.
    $( [27-May-2005] $) $( [3-Jan-2005] $)

  $( Distributive law for conjunction.  Theorem *4.4 of [WhiteheadRussell]
     p. 118. $)
  andi $p |- ( ( ph /\ ( ps \/ ch ) ) <-> ( ( ph /\ ps ) \/ ( ph /\ ch ) ) ) $=
    wph wn wps wch wo wn wo wn wph wps wa wn wph wch wa wn wa wn wph wps wch wo
    wa wph wps wa wph wch wa wo wph wn wps wch wo wn wo wph wps wa wn wph wch
    wa wn wa wph wn wps wn wch wn wa wo wph wn wps wn wo wph wn wch wn wo wa
    wph wn wps wch wo wn wo wph wps wa wn wph wch wa wn wa wph wn wps wn wch wn
    ordi wps wch wo wn wps wn wch wn wa wph wn wps wch ioran orbi2i wph wps wa
    wn wph wn wps wn wo wph wch wa wn wph wn wch wn wo wph wps ianor wph wch
    ianor anbi12i 3bitr4i notbii wph wps wch wo anor wph wps wa wph wch wa oran
    3bitr4i $.
    $( [5-Aug-1993] $)

  $( Distributive law for conjunction. $)
  andir $p |- ( ( ( ph \/ ps ) /\ ch ) <->
              ( ( ph /\ ch ) \/ ( ps /\ ch ) ) ) $=
    wch wph wps wo wa wch wph wa wch wps wa wo wph wps wo wch wa wph wch wa wps
    wch wa wo wch wph wps andi wph wps wo wch ancom wph wch wa wch wph wa wps
    wch wa wch wps wa wph wch ancom wps wch ancom orbi12i 3bitr4i $.
    $( [12-Aug-1994] $)

  $( Double distributive law for disjunction. $)
  orddi $p |- ( ( ( ph /\ ps ) \/ ( ch /\ th ) ) <->
              ( ( ( ph \/ ch ) /\ ( ph \/ th ) ) /\
              ( ( ps \/ ch ) /\ ( ps \/ th ) ) ) ) $=
    wph wps wa wch wth wa wo wph wch wth wa wo wps wch wth wa wo wa wph wch wo
    wph wth wo wa wps wch wo wps wth wo wa wa wph wps wch wth wa ordir wph wch
    wth wa wo wph wch wo wph wth wo wa wps wch wth wa wo wps wch wo wps wth wo
    wa wph wch wth ordi wps wch wth ordi anbi12i bitri $.
    $( [12-Aug-1994] $)

  $( Double distributive law for conjunction. $)
  anddi $p |- ( ( ( ph \/ ps ) /\ ( ch \/ th ) ) <->
              ( ( ( ph /\ ch ) \/ ( ph /\ th ) ) \/
              ( ( ps /\ ch ) \/ ( ps /\ th ) ) ) ) $=
    wph wps wo wch wth wo wa wph wch wth wo wa wps wch wth wo wa wo wph wch wa
    wph wth wa wo wps wch wa wps wth wa wo wo wph wps wch wth wo andir wph wch
    wth wo wa wph wch wa wph wth wa wo wps wch wth wo wa wps wch wa wps wth wa
    wo wph wch wth andi wps wch wth andi orbi12i bitri $.
    $( [12-Aug-1994] $)

  $( Prove formula-building rules for the biconditional connective. $)

  ${
    bibi.a $e |- ( ph <-> ps ) $.

    $( Inference adding a biconditional to the left in an equivalence. $)
    bibi2i $p |- ( ( ch <-> ph ) <-> ( ch <-> ps ) ) $=
      wch wph wb wch wph wi wph wch wi wa wch wph wi wps wch wi wa wch wps wb
      wch wph dfbi2 wph wch wi wps wch wi wch wph wi wph wps wch bibi.a imbi1i
      anbi2i wch wph wi wps wch wi wa wch wps wi wps wch wi wa wch wps wb wch
      wph wi wch wps wi wps wch wi wph wps wch bibi.a imbi2i anbi1i wch wps
      dfbi2 bitr4i 3bitri $.
      $( [5-Aug-1993] $)

    $( Inference adding a biconditional to the right in an equivalence. $)
    bibi1i $p |- ( ( ph <-> ch ) <-> ( ps <-> ch ) ) $=
      wph wch wb wch wph wb wch wps wb wps wch wb wph wch bicom wph wps wch
      bibi.a bibi2i wch wps bicom 3bitri $.
      $( [5-Aug-1993] $)

    ${
      bibi12.2 $e |- ( ch <-> th ) $.
      $( The equivalence of two equivalences. $)
      bibi12i $p |- ( ( ph <-> ch ) <-> ( ps <-> th ) ) $=
        wph wch wb wph wth wb wps wth wb wch wth wph bibi12.2 bibi2i wph wps
        wth bibi.a bibi1i bitri $.
        $( [5-Aug-1993] $)
    $}
  $}

  ${
    bid.1 $e |- ( ph -> ( ps <-> ch ) ) $.

    $( Deduction negating both sides of a logical equivalence. $)
    notbid $p |- ( ph -> ( -. ps <-> -. ch ) ) $=
      wph wps wch wb wps wn wch wn wb bid.1 wps wch notbi sylib $.
      $( [21-May-1994] $)

    $( Deduction adding an antecedent to both sides of a logical
       equivalence. $)
    imbi2d $p |- ( ph -> ( ( th -> ps ) <-> ( th -> ch ) ) ) $=
      wph wth wps wch wph wps wch wb wth bid.1 a1d pm5.74d $.
      $( [5-Aug-1993] $)

    $( Deduction adding a consequent to both sides of a logical equivalence. $)
    imbi1d $p |- ( ph -> ( ( ps -> th ) <-> ( ch -> th ) ) ) $=
      wph wth wn wps wn wi wth wn wch wn wi wps wth wi wch wth wi wph wps wn
      wch wn wth wn wph wps wch bid.1 notbid imbi2d wps wth con34b wch wth
      con34b 3bitr4g $.
      $( [5-Aug-1993] $)

    $( Deduction adding a left disjunct to both sides of a logical
       equivalence. $)
    orbi2d $p |- ( ph -> ( ( th \/ ps ) <-> ( th \/ ch ) ) ) $=
      wph wth wn wps wi wth wn wch wi wth wps wo wth wch wo wph wps wch wth wn
      bid.1 imbi2d wth wps df-or wth wch df-or 3bitr4g $.
      $( [5-Aug-1993] $)

    $( Deduction adding a right disjunct to both sides of a logical
       equivalence. $)
    orbi1d $p |- ( ph -> ( ( ps \/ th ) <-> ( ch \/ th ) ) ) $=
      wph wth wps wo wth wch wo wps wth wo wch wth wo wph wps wch wth bid.1
      orbi2d wps wth orcom wch wth orcom 3bitr4g $.
      $( [5-Aug-1993] $)

    $( Deduction adding a left conjunct to both sides of a logical
       equivalence. $)
    anbi2d $p |- ( ph -> ( ( th /\ ps ) <-> ( th /\ ch ) ) ) $=
      wph wth wps wa wth wch wa wph wps wch wth wph wps wch bid.1 biimpd anim2d
      wph wch wps wth wph wps wch bid.1 biimprd anim2d impbid $.
      $( [5-Aug-1993] $)

    $( Deduction adding a right conjunct to both sides of a logical
       equivalence. $)
    anbi1d $p |- ( ph -> ( ( ps /\ th ) <-> ( ch /\ th ) ) ) $=
      wph wth wps wa wth wch wa wps wth wa wch wth wa wph wps wch wth bid.1
      anbi2d wps wth ancom wch wth ancom 3bitr4g $.
      $( [5-Aug-1993] $)

    $( Deduction adding a biconditional to the left in an equivalence. $)
    bibi2d $p |- ( ph -> ( ( th <-> ps ) <-> ( th <-> ch ) ) ) $=
      wph wth wps wi wps wth wi wa wth wch wi wch wth wi wa wth wps wb wth wch
      wb wph wth wps wi wps wth wi wa wth wch wi wps wth wi wa wth wch wi wch
      wth wi wa wph wth wps wi wth wch wi wps wth wi wph wps wch wth bid.1
      imbi2d anbi1d wph wps wth wi wch wth wi wth wch wi wph wps wch wth bid.1
      imbi1d anbi2d bitrd wth wps dfbi2 wth wch dfbi2 3bitr4g $.
      $( [5-Aug-1993] $)

    $( Deduction adding a biconditional to the right in an equivalence. $)
    bibi1d $p |- ( ph -> ( ( ps <-> th ) <-> ( ch <-> th ) ) ) $=
      wph wth wps wb wth wch wb wps wth wb wch wth wb wph wps wch wth bid.1
      bibi2d wps wth bicom wch wth bicom 3bitr4g $.
      $( [5-Aug-1993] $)

  $}

  $( Theorem *4.37 of [WhiteheadRussell] p. 118. $)
  orbi1 $p |-  ( ( ph <-> ps ) -> ( ( ph \/ ch ) <-> ( ps \/ ch ) ) ) $=
    wph wps wb wph wps wch wph wps wb id orbi1d $.
    $( [12-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.36 of [WhiteheadRussell] p. 118. $)
  anbi1 $p |-  ( ( ph <-> ps ) -> ( ( ph /\ ch ) <-> ( ps /\ ch ) ) ) $=
    wph wps wb wph wps wch wph wps wb id anbi1d $.
    $( [15-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.22 of [WhiteheadRussell] p. 117. $)
  bitr $p |-  ( ( ( ph <-> ps ) /\ ( ps <-> ch ) ) -> ( ph <-> ch ) ) $=
    wph wps wb wph wch wb wps wch wb wph wps wb wph wps wch wph wps wb id
    bibi1d biimpar $.
    $( [30-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.84 of [WhiteheadRussell] p. 122. $)
  imbi1 $p |-  ( ( ph <-> ps ) -> ( ( ph -> ch ) <-> ( ps -> ch ) ) ) $=
    wph wps wb wph wps wch wph wps wb id imbi1d $.
    $( [9-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.85 of [WhiteheadRussell] p. 122. $)
  imbi2 $p |-  ( ( ph <-> ps ) -> ( ( ch -> ph ) <-> ( ch -> ps ) ) ) $=
    wph wps wb wch wph wps wph wps wb wch ax-1 pm5.74d $.
    $( [9-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.86 of [WhiteheadRussell] p. 122. $)
  bibi1 $p |-  ( ( ph <-> ps ) -> ( ( ph <-> ch ) <-> ( ps <-> ch ) ) ) $=
    wph wps wb wph wps wch wph wps wb id bibi1d $.
    $( [15-Jun-2005] $) $( [3-Jan-2005] $)

  ${
    bi12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bi12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction joining two equivalences to form equivalence of
       implications. $)
    imbi12d $p |- ( ph -> ( ( ps -> th ) <-> ( ch -> ta ) ) ) $=
      wph wps wth wi wch wth wi wch wta wi wph wps wch wth bi12d.1 imbi1d wph
      wth wta wch bi12d.2 imbi2d bitrd $.
      $( [5-Aug-1993] $)

    $( Deduction joining two equivalences to form equivalence of
       disjunctions. $)
    orbi12d $p |- ( ph -> ( ( ps \/ th ) <-> ( ch \/ ta ) ) ) $=
      wph wps wth wo wch wth wo wch wta wo wph wps wch wth bi12d.1 orbi1d wph
      wth wta wch bi12d.2 orbi2d bitrd $.
      $( [5-Aug-1993] $)

    $( Deduction joining two equivalences to form equivalence of
       conjunctions. $)
    anbi12d $p |- ( ph -> ( ( ps /\ th ) <-> ( ch /\ ta ) ) ) $=
      wph wps wth wa wch wth wa wch wta wa wph wps wch wth bi12d.1 anbi1d wph
      wth wta wch bi12d.2 anbi2d bitrd $.
      $( [5-Aug-1993] $)

    $( Deduction joining two equivalences to form equivalence of
       biconditionals. $)
    bibi12d $p |- ( ph -> ( ( ps <-> th ) <-> ( ch <-> ta ) ) ) $=
      wph wps wth wb wch wth wb wch wta wb wph wps wch wth bi12d.1 bibi1d wph
      wth wta wch bi12d.2 bibi2d bitrd $.
      $( [5-Aug-1993] $)

  $}

  $( Theorem *4.39 of [WhiteheadRussell] p. 118. $)
  pm4.39 $p |-  ( ( ( ph <-> ch ) /\ ( ps <-> th ) ) ->
                ( ( ph \/ ps ) <-> ( ch \/ th ) ) ) $=
    wph wch wb wps wth wb wa wph wch wps wth wph wch wb wps wth wb pm3.26 wph
    wch wb wps wth wb pm3.27 orbi12d $.
    $( [30-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.38 of [WhiteheadRussell] p. 118. $)
  pm4.38 $p |-  ( ( ( ph <-> ch ) /\ ( ps <-> th ) ) ->
                ( ( ph /\ ps ) <-> ( ch /\ th ) ) ) $=
    wph wch wb wps wth wb wa wph wch wps wth wph wch wb wps wth wb pm3.26 wph
    wch wb wps wth wb pm3.27 anbi12d $.
    $( [30-May-2005] $) $( [3-Jan-2005] $)

  ${
    $v et $. $( Greek eta $)
    bi2an9.wet $f wff et $.
    bi2an9.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bi2an9.2 $e |- ( th -> ( ta <-> et ) ) $.

    $( Deduction joining two equivalences to form equivalence of
       conjunctions. $)
    bi2anan9 $p |- ( ( ph /\ th ) -> ( ( ps /\ ta ) <-> ( ch /\ et ) ) ) $=
      wph wps wta wa wch wta wa wth wch bi2an9.wet wa wph wps wch wta bi2an9.1
      anbi1d wth wta bi2an9.wet wch bi2an9.2 anbi2d sylan9bb $.
      $( [31-Jul-1995] $)

    $( Deduction joining two equivalences to form equivalence of
       conjunctions. $)
    bi2anan9r $p |- ( ( th /\ ph ) -> ( ( ps /\ ta ) <-> ( ch /\ et ) ) ) $=
      wph wth wps wta wa wch bi2an9.wet wa wb wph wps wch wth wta bi2an9.wet
      bi2an9.1 bi2an9.2 bi2anan9 ancoms $.
      $( [19-Feb-1996] $)

    $( Deduction joining two biconditionals with different antecedents. $)
    bi2bian9 $p |- ( ( ph /\ th ) -> ( ( ps <-> ta ) <-> ( ch <-> et ) ) ) $=
      wph wth wa wps wch wta bi2an9.wet wph wps wch wb wth bi2an9.1 adantr wth
      wta bi2an9.wet wb wph bi2an9.2 adantl bibi12d $.
      $( [14-May-2004] $) $( [12-May-2004] $)
  $}

  $( Implication in terms of biconditional and conjunction.  Theorem *4.71 of
     [WhiteheadRussell] p. 120. $)
  pm4.71 $p |- ( ( ph -> ps ) <-> ( ph <-> ( ph /\ ps ) ) ) $=
    wph wps wi wph wph wps wa wb wph wps wi wph wph wps wa wph wps ancl wph wps
    pm3.26 impbid1 wph wph wps wa wb wph wph wps wa wps wph wph wps wa bi1 wph
    wps pm3.27 syl6 impbii $.
    $( [5-Aug-1993] $)

  $( Implication in terms of biconditional and conjunction.  Theorem *4.71 of
     [WhiteheadRussell] p. 120 (with conjunct reversed). $)
  pm4.71r $p |- ( ( ph -> ps ) <-> ( ph <-> ( ps /\ ph ) ) ) $=
    wph wps wi wph wph wps wa wb wph wps wph wa wb wph wps pm4.71 wph wps wa
    wps wph wa wph wph wps ancom bibi2i bitri $.
    $( [25-Jul-1999] $)

  ${
    pm4.71i.1 $e |- ( ph -> ps ) $.
    $( Inference converting an implication to a biconditional with conjunction.
       Inference from Theorem *4.71 of [WhiteheadRussell] p. 120. $)
    pm4.71i $p |- ( ph <-> ( ph /\ ps ) ) $=
      wph wps wi wph wph wps wa wb pm4.71i.1 wph wps pm4.71 mpbi $.
      $( [6-Jan-2004] $) $( [4-Jan-2004] $)
  $}

  ${
    pm4.71ri.1 $e |- ( ph -> ps ) $.
    $( Inference converting an implication to a biconditional with conjunction.
       Inference from Theorem *4.71 of [WhiteheadRussell] p. 120 (with
       conjunct reversed). $)
    pm4.71ri $p |- ( ph <-> ( ps /\ ph ) ) $=
      wph wps wi wph wps wph wa wb pm4.71ri.1 wph wps pm4.71r mpbi $.
      $( [1-Dec-2003] $) $( [1-Dec-2003] $)
  $}

  ${
    pm4.71rd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction converting an implication to a biconditional with conjunction.
       Deduction from Theorem *4.71 of [WhiteheadRussell] p. 120. $)
    pm4.71rd $p |- ( ph -> ( ps <-> ( ch /\ ps ) ) ) $=
      wph wps wch wi wps wch wps wa wb pm4.71rd.1 wps wch pm4.71r sylib $.
      $( [12-Feb-2005] $) $( [10-Feb-2005] $)
  $}

  $( Theorem *4.45 of [WhiteheadRussell] p. 119. $)
  pm4.45 $p |-  ( ph <-> ( ph /\ ( ph \/ ps ) ) ) $=
    wph wph wps wo wph wps orc pm4.71i $.
    $( [30-May-2005] $) $( [3-Jan-2005] $)

  $( Implication in terms of biconditional and disjunction.  Theorem *4.72 of
     [WhiteheadRussell] p. 121. $)
  pm4.72 $p |- ( ( ph -> ps ) <-> ( ps <-> ( ph \/ ps ) ) ) $=
    wph wps wi wps wph wps wo wb wph wps wi wps wph wps wo wps wph olc wph wps
    pm2.621 impbid2 wps wph wps wo wb wph wps wo wps wi wph wps wi wps wph wps
    wo bi2 wph wps pm2.67 syl impbii $.
    $( [30-Aug-1993] $)

  $( Introduction of antecedent as conjunct.  Theorem *4.73 of
     [WhiteheadRussell] p. 121. $)
  iba $p |- ( ph -> ( ps <-> ( ps /\ ph ) ) ) $=
    wph wps wps wph wa wph wps ancrb pm5.74ri $.
    $( [30-Mar-1994] $)

  $( Introduction of antecedent as conjunct. $)
  ibar $p |- ( ph -> ( ps <-> ( ph /\ ps ) ) ) $=
    wph wps wph wps wa wph wps anclb pm5.74ri $.
    $( [5-Dec-1995] $)

  $( Distribution of implication over biconditional.  Theorem *5.32 of
     [WhiteheadRussell] p. 125. $)
  pm5.32 $p |- ( ( ph -> ( ps <-> ch ) ) <->
               ( ( ph /\ ps ) <-> ( ph /\ ch ) ) ) $=
    wph wps wch wb wi wph wps wn wi wn wph wch wn wi wn wb wph wps wa wph wch
    wa wb wph wps wch wb wi wph wps wn wch wn wb wi wph wps wn wi wph wch wn wi
    wb wph wps wn wi wn wph wch wn wi wn wb wps wch wb wps wn wch wn wb wph wps
    wch notbi imbi2i wph wps wn wch wn pm5.74 wph wps wn wi wph wch wn wi notbi
    3bitri wph wps wa wph wps wn wi wn wph wch wa wph wch wn wi wn wph wps
    df-an wph wch df-an bibi12i bitr4i $.
    $( [1-Aug-1994] $)

  ${
    pm5.32i.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Distribution of implication over biconditional (inference rule). $)
    pm5.32i $p |- ( ( ph /\ ps ) <-> ( ph /\ ch ) ) $=
      wph wps wch wb wi wph wps wa wph wch wa wb pm5.32i.1 wph wps wch pm5.32
      mpbi $.
      $( [1-Aug-1994] $)

    $( Distribution of implication over biconditional (inference rule). $)
    pm5.32ri $p |- ( ( ps /\ ph ) <-> ( ch /\ ph ) ) $=
      wph wps wa wph wch wa wps wph wa wch wph wa wph wps wch pm5.32i.1 pm5.32i
      wps wph ancom wch wph ancom 3bitr4i $.
      $( [12-Mar-1995] $)
  $}

  ${
    pm5.32d.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Distribution of implication over biconditional (deduction rule). $)
    pm5.32d $p |- ( ph -> ( ( ps /\ ch ) <-> ( ps /\ th ) ) ) $=
      wph wps wch wth wb wi wps wch wa wps wth wa wb pm5.32d.1 wps wch wth
      pm5.32 sylib $.
      $( [29-Oct-1996] $)

    $( Distribution of implication over biconditional (deduction rule). $)
    pm5.32rd $p |- ( ph -> ( ( ch /\ ps ) <-> ( th /\ ps ) ) ) $=
      wph wps wch wa wps wth wa wch wps wa wth wps wa wph wps wch wth pm5.32d.1
      pm5.32d wch wps ancom wth wps ancom 3bitr4g $.
      $( [1-Jan-2005] $) $( [25-Dec-2004] $)
  $}

  ${
    pm5.32da.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Distribution of implication over biconditional (deduction rule). $)
    pm5.32da $p |- ( ph -> ( ( ps /\ ch ) <-> ( ps /\ th ) ) ) $=
      wph wps wch wth wph wps wch wth wb pm5.32da.1 ex pm5.32d $.
      $( [10-Dec-2006] $) $( [9-Dec-2006] $)
  $}

  $( Theorem *5.33 of [WhiteheadRussell] p. 125. $)
  pm5.33 $p |-  ( ( ph /\ ( ps -> ch ) ) <->
                ( ph /\ ( ( ph /\ ps ) -> ch ) ) ) $=
    wph wps wch wi wph wps wa wch wi wph wps wph wps wa wch wph wps ibar imbi1d
    pm5.32i $.
    $( [31-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.36 of [WhiteheadRussell] p. 125. $)
  pm5.36 $p |-  ( ( ph /\ ( ph <-> ps ) ) <-> ( ps /\ ( ph <-> ps ) ) ) $=
    wph wps wb wph wps wph wps wb id pm5.32ri $.
    $( [31-May-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.42 of [WhiteheadRussell] p. 125. $)
  pm5.42 $p |-  ( ( ph -> ( ps -> ch ) ) <->
                ( ph -> ( ps -> ( ph /\ ch ) ) ) ) $=
    wph wps wch wi wps wph wch wa wi wph wch wph wch wa wps wph wch ibar imbi2d
    pm5.74i $.
    $( [3-Jun-2005] $) $( [3-Jan-2005] $)

  ${
    bianabs.1 $e |- ( ph -> ( ps <-> ( ph /\ ch ) ) ) $.
    $( Absorb a hypothesis into the second member of a biconditional.
       (Contributed by FL, 15-Feb-2007.) $)
    bianabs $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wph wch wa wch bianabs.1 wph wch ibar bitr4d $.
      $( [22-May-2008] $) $( [15-Feb-2007] $)
  $}

  $( Absorption of disjunction into equivalence. $)
  oibabs $p |- ( ( ( ph \/ ps ) -> ( ph <-> ps ) ) <-> ( ph <-> ps ) ) $=
    wph wps wo wph wps wb wi wph wps wb wph wps wo wph wps wb wi wph wps wph
    wps wo wph wps wb wi wph wps wph wph wps wo wph wps wb wph wps orc imim1i
    ibd wph wps wo wph wps wb wi wps wph wps wb wi wps wph wi wps wph wps wo
    wph wps wb wps wph olc imim1i wps wph ibibr sylibr impbid wph wps wb wph
    wps wo ax-1 impbii $.
    $( [29-Jan-2008] $)  $( [6-Aug-1995] $)

  $( Law of excluded middle, also called the principle of _tertium non datur_.
     Theorem *2.11 of [WhiteheadRussell] p. 101.  It says that something is
     either true or not true; there are no in-between values of truth.  This is
     an essential distinction of our classical logic and is not a theorem of
     intuitionistic logic. $)
  exmid $p |- ( ph \/ -. ph ) $=
    wph wph wn wph wn id orri $.
    $( [5-Aug-1993] $)

  $( Theorem *2.1 of [WhiteheadRussell] p. 101. $)
  pm2.1 $p |-  ( -. ph \/ ph ) $=
    wph wn wph wph notnot2 orri $.
    $( [7-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *2.13 of [WhiteheadRussell] p. 101. $)
  pm2.13 $p |-  ( ph \/ -. -. -. ph ) $=
    wph wph wn wn wn wph wn notnot1 orri $.
    $( [4-Jun-2005] $) $( [3-Jan-2005] $)

  $( Law of noncontradiction.  Theorem *3.24 of [WhiteheadRussell] p. 111
     (who call it the "law of contradiction"). $)
  pm3.24 $p |- -. ( ph /\ -. ph ) $=
    wph wph wn wa wn wph wn wph wn wn wo wph wn exmid wph wph wn ianor mpbir $.
    $( [16-Sep-1993] $)

  $( Theorem *2.26 of [WhiteheadRussell] p. 104. $)
  pm2.26 $p |-  ( -. ph \/ ( ( ph -> ps ) -> ps ) ) $=
    wph wn wph wps wi wps wi wph wps wi wph wn wn wps wph wn wn wph wps wph
    notnot2 imim1i com12 orri $.
    $( [5-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.18 of [WhiteheadRussell] p. 124.  This theorem says that
     logical equivalence is the same as negated "exclusive-or." $)
  pm5.18 $p |- ( ( ph <-> ps ) <-> -. ( ph <-> -. ps ) ) $=
    wph wps wb wps wph wb wph wps wn wb wn wph wps bicom wph wps wn wb wps wph
    wb wph wps wn wb wps wn wph wb wps wph wb wn wph wps wn bicom wps wn wph wb
    wps wph wb wn wps wn wph wb wps wph wi wph wps wi wa wn wps wph wb wn wps
    wn wph wb wps wph wi wph wps wi wn wi wps wph wi wph wps wi wa wn wps wph
    wi wps wn wph wb wph wps wi wn wps wph wi wps wn wph wb wph wps wn wa wph
    wps wi wn wps wph wi wps wn wph wi wph wps wn wi wa wph wps wn wa wps wn
    wph wb wps wph wi wps wn wph wi wph wph wps wn wi wps wn wps wph pm2.61 wps
    wph wi wps wph wn wi wps wn wph wps wn wi wps wph pm2.65 wph wps con2 syl5
    anim12d wps wn wph dfbi2 syl5ib wph wps annim syl6ib com12 wps wph wi wph
    wps wi imnan sylib wps wph wb wps wph wi wph wps wi wa wps wph dfbi2 notbii
    sylibr wps wph wb wn wps wph wi wph wps wi wa wn wps wn wph wb wps wph wb
    wps wph wi wph wps wi wa wps wph dfbi2 notbii wps wph wi wn wph wps wi wn
    wo wps wn wph wi wph wps wn wi wa wps wph wi wph wps wi wa wn wps wn wph wb
    wps wph wi wn wps wn wph wi wph wps wn wi wa wph wps wi wn wps wph wi wn
    wps wn wph wi wph wps wn wi wps wph pm2.5 wps wph wi wn wps wph wn wa wph
    wps wn wi wps wph annim wph wn wph wps wn wi wps wph wps wn pm2.21 adantl
    sylbir jca wph wps wi wn wps wn wph wi wph wps wn wi wph wps wi wn wph wps
    wn wa wps wn wph wi wph wps annim wph wps wn wph wi wps wn wph wps wn ax-1
    adantr sylbir wph wps pm2.51 jca jaoi wps wph wi wph wps wi ianor wps wn
    wph dfbi2 3imtr4i sylbi impbii bitri con2bii bitri $.
    $( [28-Jun-2002] $)

  $( Move negation outside of biconditional.  Compare Theorem *5.18 of
     [WhiteheadRussell] p. 124. $)
  nbbn $p |- ( ( -. ph <-> ps ) <-> -. ( ph <-> ps ) ) $=
    wph wn wps wb wps wph wn wb wph wps wb wn wph wn wps bicom wph wps wb wps
    wph wn wb wph wps wb wps wph wb wps wph wn wb wn wph wps bicom wps wph
    pm5.18 bitri con2bii bitri $.
    $( [27-Jun-2002] $)

  $( Theorem *5.11 of [WhiteheadRussell] p. 123. $)
  pm5.11 $p |-  ( ( ph -> ps ) \/ ( -. ph -> ps ) ) $=
    wph wps wi wph wn wps wi wph wps pm2.5 orri $.
    $( [17-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.12 of [WhiteheadRussell] p. 123. $)
  pm5.12 $p |-  ( ( ph -> ps ) \/ ( ph -> -. ps ) ) $=
    wph wps wi wph wps wn wi wph wps pm2.51 orri $.
    $( [17-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.13 of [WhiteheadRussell] p. 123. $)
  pm5.13 $p |-  ( ( ph -> ps ) \/ ( ps -> ph ) ) $=
    wph wps wi wps wph wi wph wps pm2.521 orri $.
    $( [7-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.14 of [WhiteheadRussell] p. 123. $)
  pm5.14 $p |-  ( ( ph -> ps ) \/ ( ps -> ch ) ) $=
    wph wps wi wps wch wi wph wps wi wn wps wch wps wph wps wi wps wph ax-1
    con3i pm2.21d orri $.
    $( [17-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.15 of [WhiteheadRussell] p. 124. $)
  pm5.15 $p |-  ( ( ph <-> ps ) \/ ( ph <-> -. ps ) ) $=
    wph wps wb wph wps wn wb wph wps wn wb wph wps wb wph wps wb wph wps wn wb
    wn wph wps pm5.18 biimpri con1i orri $.
    $( [1-Feb-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.16 of [WhiteheadRussell] p. 124. $)
  pm5.16 $p |-  -. ( ( ph <-> ps ) /\ ( ph <-> -. ps ) ) $=
    wph wps wb wph wps wn wb wa wn wph wps wb wn wph wps wn wb wn wo wph wps wb
    wph wps wn wb wn wi wph wps wb wn wph wps wn wb wn wo wph wps wb wph wps wn
    wb wn wph wps pm5.18 biimpi wph wps wb wph wps wn wb pm4.62 mpbi wph wps wb
    wph wps wn wb ianor mpbir $.
    $( [17-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.17 of [WhiteheadRussell] p. 124. $)
  pm5.17 $p |-  ( ( ( ph \/ ps ) /\ -. ( ph /\ ps ) ) <-> ( ph <-> -. ps ) ) $=
    wph wps wo wph wps wa wn wa wps wn wph wi wph wps wn wi wa wps wn wph wb
    wph wps wn wb wph wps wo wps wn wph wi wph wps wa wn wph wps wn wi wph wps
    wo wps wph wo wps wn wph wi wph wps orcom wps wph df-or bitri wph wps wn wi
    wph wps wa wn wph wps imnan bicomi anbi12i wps wn wph dfbi2 wps wn wph
    bicom 3bitr2i $.
    $( [22-Mar-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.19 of [WhiteheadRussell] p. 124. $)
  pm5.19 $p |-  -. ( ph <-> -. ph ) $=
    wph wph wb wph wph wn wb wn wph biid wph wph pm5.18 mpbi $.
    $( [1-Feb-2005] $) $( [3-Jan-2005] $)

  $( An alternate definition of the biconditional.  Theorem *5.23 of
     [WhiteheadRussell] p. 124. $)
  dfbi3 $p |- ( ( ph <-> ps ) <-> ( ( ph /\ ps ) \/ ( -. ph /\ -. ps ) ) ) $=
    wph wps wb wph wps wn wb wn wph wps wa wph wn wps wn wa wo wph wps pm5.18
    wph wps wa wph wn wps wn wa wo wph wps wn wb wph wps wn wi wps wn wph wi wa
    wph wps wa wn wph wn wps wn wa wn wa wph wps wn wb wph wps wa wph wn wps wn
    wa wo wn wph wps wn wi wph wps wa wn wps wn wph wi wph wn wps wn wa wn wph
    wps imnan wps wn wph wi wph wn wps wi wph wn wps wn wa wn wps wph con1b wph
    wn wps iman bitri anbi12i wph wps wn dfbi2 wph wps wa wph wn wps wn wa
    ioran 3bitr4ri con1bii bitri $.
    $( [27-Jun-2002] $)

  $( Two ways to express "exclusive or."  Theorem *5.22 of [WhiteheadRussell]
     p. 124. $)
  xor $p |-  ( -. ( ph <-> ps ) <->
                ( ( ph /\ -. ps ) \/ ( ps /\ -. ph ) ) ) $=
    wph wn wps wb wph wn wps wa wph wn wn wps wn wa wo wph wps wb wn wph wps wn
    wa wps wph wn wa wo wph wn wps dfbi3 wph wps nbbn wph wn wps wa wph wn wn
    wps wn wa wo wps wph wn wa wph wps wn wa wo wph wps wn wa wps wph wn wa wo
    wps wph wn wa wph wn wps wa wph wps wn wa wph wn wn wps wn wa wps wph wn
    ancom wph wph wn wn wps wn wph notnot anbi1i orbi12i wps wph wn wa wph wps
    wn wa orcom bitr3i 3bitr3i $.
    $( [11-Jan-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.24 of [WhiteheadRussell] p. 124. $)
  pm5.24 $p |-  ( -. ( ( ph /\ ps ) \/ ( -. ph /\ -. ps ) ) <->
                ( ( ph /\ -. ps ) \/ ( ps /\ -. ph ) ) ) $=
    wph wps wa wph wn wps wn wa wo wn wph wps wb wn wph wps wn wa wps wph wn wa
    wo wph wps wb wph wps wa wph wn wps wn wa wo wph wps dfbi3 notbii wph wps
    xor bitr3i $.
    $( [11-Feb-2005] $) $( [3-Jan-2005] $)

  $( Two ways to express "exclusive or." $)
  xor2 $p |-  ( -. ( ph <-> ps ) <-> ( ( ph \/ ps ) /\ -. ( ph /\ ps ) ) ) $=
    wph wps wb wn wph wps wn wa wps wph wn wa wo wph wps wo wph wps wa wn wa
    wph wps xor wph wps wa wph wn wps wn wa wo wn wph wps wa wn wph wn wps wn
    wa wn wa wph wps wn wa wps wph wn wa wo wph wps wo wph wps wa wn wa wph wps
    wa wph wn wps wn wa ioran wph wps pm5.24 wph wps wa wn wph wn wps wn wa wn
    wa wph wps wa wn wph wps wo wa wph wps wo wph wps wa wn wa wph wps wo wph
    wn wps wn wa wn wph wps wa wn wph wps oran anbi2i wph wps wa wn wph wps wo
    ancom bitr3i 3bitr3i bitri $.
    $( [11-Feb-2005] $) $( [3-Jan-2005] $)

  $( Two ways to express "exclusive or." $)
  xor3 $p |-  ( -. ( ph <-> ps ) <-> ( ph <-> -. ps ) ) $=
    wph wps wn wb wph wps wb wn wph wps wb wph wps wn wb wph wps pm5.18 con2bii
    bicomi $.
    $( [4-Jan-2006] $) $( [1-Jan-2006] $)

  $( Conjunction distributes over exclusive-or, using ` -. ( ph <-> ps ) `
     to express exclusive-or.  This is one way to interpret the distributive
     law of multiplication over addition in modulo 2 arithmetic. $)
  xordi $p |- ( ( ph /\ -. ( ps <-> ch ) ) <->
                -. ( ( ph /\ ps ) <-> ( ph /\ ch ) ) ) $=
    wph wps wch wb wn wa wph wps wch wb wi wn wph wps wa wph wch wa wb wn wph
    wps wch wb annim wph wps wch wb wi wph wps wa wph wch wa wb wph wps wch
    pm5.32 notbii bitri $.
    $( [3-Oct-2008] $) $( [3-Oct-2008] $)

  $( Theorem *5.55 of [WhiteheadRussell] p. 125. $)
  pm5.55 $p |-  ( ( ( ph \/ ps ) <-> ph ) \/ ( ( ph \/ ps ) <-> ps ) ) $=
    wps wph wi wph wps wi wo wph wps wo wph wb wph wps wo wps wb wo wps wph
    pm5.13 wps wph wi wph wps wo wph wb wph wps wi wph wps wo wps wb wps wph wi
    wph wps wph wo wb wph wph wps wo wb wph wps wo wph wb wps wph pm4.72 wps
    wph wo wph wps wo wph wps wph orcom bibi2i wph wph wps wo bicom 3bitri wph
    wps wi wps wph wps wo wb wph wps wo wps wb wph wps pm4.72 wps wph wps wo
    bicom bitri orbi12i mpbi $.
    $( [7-Jun-2005] $) $( [3-Jan-2005] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Miscellaneous theorems of propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Two propositions are equivalent if they are both true.  Theorem *5.1 of
     [WhiteheadRussell] p. 123. $)
  pm5.1 $p |- ( ( ph /\ ps ) -> ( ph <-> ps ) ) $=
    wph wps wph wps wb wph wps pm5.501 biimpa $.
    $( [21-May-1994] $)

  $( Two propositions are equivalent if they are both false.  Theorem *5.21 of
     [WhiteheadRussell] p. 124. $)
  pm5.21 $p |- ( ( -. ph /\ -. ps ) -> ( ph <-> ps ) ) $=
    wph wn wps wn wa wph wps wph wn wps wn pm5.1 con4bid $.
    $( [21-May-1994] $)


  ${
    pm5.21ni.1 $e |- ( ph -> ps ) $.
    pm5.21ni.2 $e |- ( ch -> ps ) $.
    $( Two propositions implying a false one are equivalent. $)
    pm5.21ni $p |- ( -. ps -> ( ph <-> ch ) ) $=
      wph wn wch wn wph wch wb wps wn wph wch pm5.21 wph wps pm5.21ni.1 con3i
      wch wps pm5.21ni.2 con3i sylanc $.
      $( [16-Feb-1996] $)

    ${
      pm5.21nii.3 $e |- ( ps -> ( ph <-> ch ) ) $.
      $( Eliminate an antecedent implied by each side of a biconditional. $)
      pm5.21nii $p |- ( ph <-> ch ) $=
        wps wph wch wb pm5.21nii.3 wph wps wch pm5.21ni.1 pm5.21ni.2 pm5.21ni
        pm2.61i $.
        $( [21-May-1999] $)
    $}
  $}

  ${
    pm5.21nd.1 $e |- ( ( ph /\ ps ) -> th ) $.
    pm5.21nd.2 $e |- ( ( ph /\ ch ) -> th ) $.
    pm5.21nd.3 $e |- ( th -> ( ps <-> ch ) ) $.
    $( Eliminate an antecedent implied by each side of a biconditional. $)
    pm5.21nd $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wth wps wch wb wph wth wn wps wn wch wn wa wps wch wb wph wth wn wps
      wn wch wn wph wps wth wph wps wth pm5.21nd.1 ex con3d wph wch wth wph wch
      wth pm5.21nd.2 ex con3d jcad wps wch pm5.21 syl6 pm5.21nd.3 pm2.61d2 $.
      $( [23-Nov-2005] $) $( [20-Nov-2005] $)
  $}

  $( Transfer negation via an equivalence. $)
  bibif $p |- ( -. ps -> ( ( ph <-> ps ) <-> -. ph ) ) $=
    wps wn wph wps wb wph wn wph wps wb wps wn wph wn wph wps wb wph wps wph
    wps bi1 con3d com12 wph wn wps wn wph wps wb wph wps pm5.21 expcom impbid
    $.
    $( [7-Nov-2007] $) $( [3-Oct-2007] $)

  $( Theorem *5.35 of [WhiteheadRussell] p. 125. $)
  pm5.35 $p |-  ( ( ( ph -> ps ) /\ ( ph -> ch ) ) ->
                ( ph -> ( ps <-> ch ) ) ) $=
    wph wps wi wph wch wi wa wph wps wch wph wps wi wph wch wi pm5.1 pm5.74rd
    $.
    $( [28-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.54 of [WhiteheadRussell] p. 125. $)
  pm5.54 $p |-  ( ( ( ph /\ ps ) <-> ph ) \/ ( ( ph /\ ps ) <-> ps ) ) $=
    wph wps wa wph wb wph wps wa wps wb wph wps wa wph wps wa wph wb wps wph
    wps wph wps wa wph wb wph wps wa wph pm5.1 anabss1 wps wph wph wps wa wps
    wph iba bicomd pm5.21ni orri $.
    $( [28-Jun-2005] $) $( [3-Jan-2005] $)

  $( Elimination of antecedents in an implication. (The proof was shortened by
     Juha Arpiainen, 19-Jan-2006.) $)
  elimant $p |- ( ( ( ph -> ps ) /\ ( ( ps -> ch ) -> ( ph -> th ) ) ) ->
                ( ph -> ( ch -> th ) ) ) $=
    wph wps wi wps wch wi wph wth wi wi wa wch wph wth wph wps wi wps wch wi
    wph wth wi wi wa wps wch wi wph wth wi wch wph wps wi wps wch wi wph wth wi
    wi pm3.27 wch wps ax-1 syl5 com23 $.
    $( [21-Jan-2006] $) $( [13-Oct-1999] $)

  ${
    baib.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Move conjunction outside of biconditional. $)
    baib $p |- ( ps -> ( ph <-> ch ) ) $=
      wps wch wps wch wa wph wps wch ibar baib.1 syl6rbbr $.
      $( [13-May-1999] $)
  $}

  ${
    baibr.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Move conjunction outside of biconditional. $)
    baibr $p |- ( ps -> ( ch <-> ph ) ) $=
      wps wph wch wph wps wch baibr.1 baib bicomd $.
      $( [11-Jul-1994] $)
  $}

  $( Theorem *5.44 of [WhiteheadRussell] p. 125. $)
  pm5.44 $p |-  ( ( ph -> ps ) -> ( ( ph -> ch ) <->
                ( ph -> ( ps /\ ch ) ) ) ) $=
    wph wps wch wa wi wph wps wi wph wch wi wph wps wch jcab baibr $.
    $( [28-Jun-2005] $) $( [3-Jan-2005] $)

  $( Conjunction in antecedent versus disjunction in consequent.  Theorem *5.6
     of [WhiteheadRussell] p. 125. $)
  pm5.6 $p |-  ( ( ( ph /\ -. ps ) -> ch ) <-> ( ph -> ( ps \/ ch ) ) ) $=
    wph wps wn wa wch wi wph wps wn wch wi wi wph wps wch wo wi wph wps wn wch
    impexp wps wch wo wps wn wch wi wph wps wch df-or imbi2i bitr4i $.
    $( [22-Mar-2005] $) $( [8-Jun-1994] $)

  $( Theorem to move a conjunct in and out of a negation. $)
  nan $p |- ( ( ph -> -. ( ps /\ ch ) ) <-> ( ( ph /\ ps ) -> -. ch ) ) $=
    wph wps wa wch wn wi wph wps wch wn wi wi wph wps wch wa wn wi wph wps wch
    wn impexp wps wch wn wi wps wch wa wn wph wps wch imnan imbi2i bitr2i $.
    $( [9-Nov-2003] $) $( [9-Nov-2003] $)

  ${
    orcanai.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    $( Change disjunction in consequent to conjunction in antecedent. $)
    orcanai $p |- ( ( ph /\ -. ps ) -> ch ) $=
      wph wps wn wch wph wps wch orcanai.1 ord imp $.
      $( [8-Jun-1994] $)
  $}


  ${
    intnan.1 $e |- -. ph $.
    $( Introduction of conjunct inside of a contradiction. $)
    intnan $p |- -. ( ps /\ ph ) $=
      wps wph wa wph intnan.1 wps wph pm3.27 mto $.
      $( [16-Sep-1993] $)

    $( Introduction of conjunct inside of a contradiction. $)
    intnanr $p |- -. ( ph /\ ps ) $=
      wph wps wa wph intnan.1 wph wps pm3.26 mto $.
      $( [3-Apr-1995] $)
  $}

  ${
    intnand.1 $e |- ( ph -> -. ps ) $.
    $( Introduction of conjunct inside of a contradiction. $)
    intnand $p |- ( ph -> -. ( ch /\ ps ) ) $=
      wph wps wch wps wa intnand.1 wch wps pm3.27 nsyl $.
      $( [12-Jul-2005] $) $( [10-Jul-2005] $)

    $( Introduction of conjunct inside of a contradiction. $)
    intnanrd $p |- ( ph -> -. ( ps /\ ch ) ) $=
      wph wps wps wch wa intnand.1 wps wch pm3.26 nsyl $.
      $( [12-Jul-2005] $) $( [10-Jul-2005] $)
  $}

  ${
    mpan.1 $e |- ph $.
    mpan.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens. $)
    mpan $p |- ( ps -> ch ) $=
      wph wps wch wi mpan.1 wph wps wch mpan.2 ex ax-mp $.
      $( [30-Aug-1993] $)
  $}

  ${
    mpan2.1 $e |- ps $.
    mpan2.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens. $)
    mpan2 $p |- ( ph -> ch ) $=
      wph wps wch mpan2.1 wph wps wch mpan2.2 ex mpi $.
      $( [16-Sep-1993] $)
  $}

  ${
    mp2an.1 $e |- ph $.
    mp2an.2 $e |- ps $.
    mp2an.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens. $)
    mp2an $p |- ch $=
      wps wch mp2an.2 wph wps wch mp2an.1 mp2an.3 mpan ax-mp $.
      $( [13-Apr-1995] $)
  $}

  ${
    mpani.1 $e |- ps $.
    mpani.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( An inference based on modus ponens. $)
    mpani $p |- ( ph -> ( ch -> th ) ) $=
      wph wps wch wth wi mpani.1 wph wps wch wth mpani.2 exp3a mpi $.
      $( [10-Apr-1994] $)
  $}

  ${
    mpan2i.1 $e |- ch $.
    mpan2i.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( An inference based on modus ponens. $)
    mpan2i $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth mpan2i.1 wph wps wch wth mpan2i.2 exp3a mpii $.
      $( [10-Apr-1994] $)
  $}

  ${
    mp2ani.1 $e |- ps $.
    mp2ani.2 $e |- ch $.
    mp2ani.3 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( An inference based on modus ponens. $)
    mp2ani $p |- ( ph -> th ) $=
      wph wch wth mp2ani.2 wph wps wch wth mp2ani.1 mp2ani.3 mpani mpi $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  ${
    mpand.1 $e |- ( ph -> ps ) $.
    mpand.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( A deduction based on modus ponens. $)
    mpand $p |- ( ph -> ( ch -> th ) ) $=
      wph wps wch wth wi mpand.1 wph wps wch wth mpand.2 exp3a mpd $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  ${
    mpan2d.1 $e |- ( ph -> ch ) $.
    mpan2d.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( A deduction based on modus ponens. $)
    mpan2d $p |- ( ph -> ( ps -> th ) ) $=
      wph wps wch wth mpan2d.1 wph wps wch wth mpan2d.2 exp3a mpid $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  ${
    mp2and.1 $e |- ( ph -> ps ) $.
    mp2and.2 $e |- ( ph -> ch ) $.
    mp2and.3 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( A deduction based on modus ponens. $)
    mp2and $p |- ( ph -> th ) $=
      wph wch wth mp2and.2 wph wps wch wth mp2and.1 mp2and.3 mpand mpd $.
      $( [13-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  ${
    mpdan.1 $e |- ( ph -> ps ) $.
    mpdan.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens. $)
    mpdan $p |- ( ph -> ch ) $=
      wph wps wch mpdan.1 wph wps wch mpdan.2 ex mpd $.
      $( [23-May-1999] $)
  $}

  ${
    mpancom.1 $e |- ( ps -> ph ) $.
    mpancom.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens with commutation of antecedents. $)
    mpancom $p |- ( ps -> ch ) $=
      wps wph wch mpancom.1 wph wps wch mpancom.2 ancoms mpdan $.
      $( [13-Mar-2004] $) $( [28-Oct-2003] $)
  $}

  ${
    mpanl1.1 $e |- ph $.
    mpanl1.2 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpanl1 $p |- ( ( ps /\ ch ) -> th ) $=
      wps wch wth wph wps wch wth wi mpanl1.1 wph wps wa wch wth mpanl1.2 ex
      mpan imp $.
      $( [16-Aug-1994] $)
  $}

  ${
    mpanl2.1 $e |- ps $.
    mpanl2.2 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpanl2 $p |- ( ( ph /\ ch ) -> th ) $=
      wph wch wth wph wps wch wth wi mpanl2.1 wph wps wa wch wth mpanl2.2 ex
      mpan2 imp $.
      $( [16-Aug-1994] $)
  $}

  ${
    mpanl12.1 $e |- ph $.
    mpanl12.2 $e |- ps $.
    mpanl12.3 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpanl12 $p |- ( ch -> th ) $=
      wps wch wth mpanl12.2 wph wps wch wth mpanl12.1 mpanl12.3 mpanl1 mpan $.
      $( [15-Jul-2005] $) $( [13-Jul-2005] $)
  $}

  ${
    mpanr1.1 $e |- ps $.
    mpanr1.2 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpanr1 $p |- ( ( ph /\ ch ) -> th ) $=
      wph wch wth wph wps wch wth mpanr1.1 wph wps wch wa wth mpanr1.2 ex mpani
      imp $.
      $( [3-May-1994] $)
  $}

  ${
    mpanr2.1 $e |- ch $.
    mpanr2.2 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpanr2 $p |- ( ( ph /\ ps ) -> th ) $=
      wph wps wth wph wps wch wth mpanr2.1 wph wps wch wa wth mpanr2.2 ex
      mpan2i imp $.
      $( [3-May-1994] $)
  $}

  ${
    mpanr12.1 $e |- ps $.
    mpanr12.2 $e |- ch $.
    mpanr12.3 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpanr12 $p |- ( ph -> th ) $=
      wph wch wth mpanr12.2 wph wps wch wth mpanr12.1 mpanr12.3 mpanr1 mpan2 $.
      $( [26-Jul-2009] $) $( [24-Jul-2009] $)
  $}

  ${
    mpanlr1.1 $e |- ps $.
    mpanlr1.2 $e |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mpanlr1 $p |- ( ( ( ph /\ ch ) /\ th ) -> ta ) $=
      wph wch wa wth wta wph wps wch wth wta wi mpanlr1.1 wph wps wch wa wa wth
      wta mpanlr1.2 ex mpanr1 imp $.
      $( [7-Jan-2005] $) $( [30-Dec-2004] $)
  $}

  $( Modus-tollens-like theorem. $)
  mtt $p |- ( -. ph -> ( -. ps <-> ( ps -> ph ) ) ) $=
    wph wn wps wn wps wph wi wps wph pm2.21 wps wph wi wph wn wps wn wps wph
    con3 com12 impbid2 $.
    $( [7-Apr-2001] $)

  ${
    mt2bi.1 $e |- ph $.
    $( A false consequent falsifies an antecedent. $)
    mt2bi $p |- ( -. ps <-> ( ps -> -. ph ) ) $=
      wps wn wps wph wn wi wps wph wn pm2.21 wps wph wn wi wph wps wn mt2bi.1
      wps wph con2 mpi impbii $.
      $( [19-Aug-1993] $)
  $}

  ${
    mtbid.min $e |- ( ph -> -. ps ) $.
    mtbid.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, similar to modus tollens. $)
    mtbid $p |- ( ph -> -. ch ) $=
      wph wch wps mtbid.min wph wps wch mtbid.maj biimprd mtod $.
      $( [26-Nov-1995] $)
  $}

  ${
    mtbird.min $e |- ( ph -> -. ch ) $.
    mtbird.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, similar to modus tollens. $)
    mtbird $p |- ( ph -> -. ps ) $=
      wph wps wch mtbird.min wph wps wch mtbird.maj biimpd mtod $.
      $( [10-May-1994] $)
  $}

  ${
    mtbii.min $e |- -. ps $.
    mtbii.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a biconditional, similar to modus tollens. $)
    mtbii $p |- ( ph -> -. ch ) $=
      wph wch wps mtbii.min wph wps wch mtbii.maj biimprd mtoi $.
      $( [27-Nov-1995] $)
  $}

  ${
    mtbiri.min $e |- -. ch $.
    mtbiri.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a biconditional, similar to modus tollens. $)
    mtbiri $p |- ( ph -> -. ps ) $=
      wph wps wch mtbiri.min wph wps wch mtbiri.maj biimpd mtoi $.
      $( [24-Aug-1995] $)
  $}

  ${
    2th.1 $e |- ph $.
    2th.2 $e |- ps $.
    $( Two truths are equivalent. $)
    2th $p |- ( ph <-> ps ) $=
      wph wps wps wph 2th.2 a1i wph wps 2th.1 a1i impbii $.
      $( [18-Aug-1993] $)
  $}

  ${
    2false.1 $e |- -. ph $.
    2false.2 $e |- -. ps $.
    $( Two falsehoods are equivalent. $)
    2false $p |- ( ph <-> ps ) $=
      wph wn wps wn wph wps wb 2false.1 2false.2 wph wps pm5.21 mp2an $.
      $( [5-Apr-2005] $) $( [4-Apr-2005] $)
  $}

  ${
    tbt.1 $e |- ph $.
    $( A wff is equivalent to its equivalence with truth. (The proof was
       shortened by Juha Arpiainen, 19-Jan-2006.) $)
    tbt $p |- ( ps <-> ( ps <-> ph ) ) $=
      wps wph wps wb wps wph wb wph wps wph wps wb wb tbt.1 wph wps pm5.501
      ax-mp wph wps bicom bitri $.
      $( [21-Jan-2006] $) $( [18-Aug-1993] $)
  $}

  $( The negation of a wff is equivalent to the wff's equivalence to
     falsehood.  (Contributed by Juha Arpiainen, 19-Jan-2006.) $)
  nbn2 $p |- ( -. ph -> ( -. ps <-> ( ph <-> ps ) ) ) $=
    wph wn wps wn wph wps wb wph wn wps wn wph wps wb wph wps pm5.21 ex wph wps
    wb wph wn wps wn wph wps wb wph wn wps wn wb wph wps notbi biimpi biimpcd
    impbid $.
    $( [21-Jan-2006] $) $( [19-Jan-2006] $)

  ${
    nbn.1 $e |- -. ph $.
    $( The negation of a wff is equivalent to the wff's equivalence to
       falsehood. $)
    nbn $p |- ( -. ps <-> ( ps <-> ph ) ) $=
      wps wn wph wps wb wps wph wb wph wn wps wn wph wps wb wb nbn.1 wph wps
      nbn2 ax-mp wph wps bicom bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    nbn3.1 $e |- ph $.
    $( Transfer falsehood via equivalence. $)
    nbn3 $p |- ( -. ps <-> ( ps <-> -. ph ) ) $=
      wph wn wps wph nbn3.1 notnoti nbn $.
      $( [12-Sep-2006] $) $( [11-Sep-2006] $)
  $}

  ${
    biantru.1 $e |- ph $.
    $( A wff is equivalent to its conjunction with truth. $)
    biantru $p |- ( ps <-> ( ps /\ ph ) ) $=
      wph wps wps wph wa wb biantru.1 wph wps iba ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    biantrur.1 $e |- ph $.
    $( A wff is equivalent to its conjunction with truth. $)
    biantrur $p |- ( ps <-> ( ph /\ ps ) ) $=
      wph wps wph wps wa wb biantrur.1 wph wps ibar ax-mp $.
      $( [3-Aug-1994] $)
  $}

  ${
    biantrud.1 $e |- ( ph -> ps ) $.
    $( A wff is equivalent to its conjunction with truth. $)
    biantrud $p |- ( ph -> ( ch <-> ( ch /\ ps ) ) ) $=
      wph wch wch wps wa wch wph wch wps wa wph wps wch biantrud.1 anim2i
      expcom wch wps pm3.26 impbid1 $.
      $( [2-Aug-1994] $)

    $( A wff is equivalent to its conjunction with truth. $)
    biantrurd $p |- ( ph -> ( ch <-> ( ps /\ ch ) ) ) $=
      wph wch wch wps wa wps wch wa wph wps wch biantrud.1 biantrud wch wps
      ancom syl6bb $.
      $( [1-May-1995] $)
  $}

  ${
    mpbiran.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    ${
      mpbiran.2 $e |- ps $.
      $( Detach truth from conjunction in biconditional. $)
      mpbiran $p |- ( ph <-> ch ) $=
        wph wps wch wa wch mpbiran.1 wps wch mpbiran.2 biantrur bitr4i $.
        $( [27-Feb-1996] $)
    $}

    ${
      mpbiran2.2 $e |- ch $.
      $( Detach truth from conjunction in biconditional. $)
      mpbiran2 $p |- ( ph <-> ps ) $=
        wph wps wch wa wps mpbiran.1 wch wps mpbiran2.2 biantru bitr4i $.
        $( [22-Feb-1996] $)
    $}

    ${
      mpbir2an.2 $e |- ps $.
      mpbir2an.3 $e |- ch $.
      $( Detach a conjunction of truths in a biconditional. $)
      mpbir2an $p |- ph $=
        wph wch mpbir2an.3 wph wps wch mpbiran.1 mpbir2an.2 mpbiran mpbir $.
        $( [12-May-2005] $) $( [10-May-2005] $)
    $}
  $}

  $( A wff is equivalent to itself with true antecedent. $)
  biimt $p |- ( ph -> ( ps <-> ( ph -> ps ) ) ) $=
    wph wps wph wps wi wps wph ax-1 wph wps pm2.27 impbid2 $.
    $( [28-Jan-1996] $)

  $( Theorem *5.5 of [WhiteheadRussell] p. 125. $)
  pm5.5 $p |-  ( ph -> ( ( ph -> ps ) <-> ps ) ) $=
    wph wps wph wps wi wph wps biimt bicomd $.
    $( [28-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *5.62 of [WhiteheadRussell] p. 125.  (Contributed by Roy F.
     Longton, 21-Jun-2005.) $)
  pm5.62 $p |-  ( ( ( ph /\ ps ) \/ -. ps ) <-> ( ph \/ -. ps ) ) $=
    wph wps wa wps wn wo wph wps wn wo wps wps wn wo wph wps wps wn ordir wps
    exmid mpbiran2 $.
    $( [22-Jun-2005] $) $( [21-Jun-2005] $)

  $( A wff is disjoined with truth is true. $)
  biort $p |- ( ph -> ( ph <-> ( ph \/ ps ) ) ) $=
    wph wph wph wps wo wph wps orc wph wph wps wo ax-1 impbid2 $.
    $( [23-May-1999] $)

  $( A wff is equivalent to its disjunction with falsehood.  Theorem *4.74 of
     [WhiteheadRussell] p. 121. $)
  biorf $p |- ( -. ph -> ( ps <-> ( ph \/ ps ) ) ) $=
    wph wn wps wph wn wps wi wph wps wo wph wn wps biimt wph wps df-or syl6bbr
    $.
    $( [23-Mar-1995] $)

  ${
    biorfi.1 $e |- -. ph $.
    $( A wff is equivalent to its disjunction with falsehood. $)
    biorfi $p |- ( ps <-> ( ps \/ ph ) ) $=
      wps wph wps wo wps wph wo wph wn wps wph wps wo wb biorfi.1 wph wps biorf
      ax-mp wph wps orcom bitri $.
      $( [23-Mar-1995] $)
  $}

  ${
    bianfi.1 $e |- -. ph $.
    $( A wff conjoined with falsehood is false. $)
    bianfi $p |- ( ph <-> ( ps /\ ph ) ) $=
      wph wps wph wa wph wps wph wa bianfi.1 pm2.21i wps wph pm3.27 impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    bianfd.1 $e |- ( ph -> -. ps ) $.
    $( A wff conjoined with falsehood is false. $)
    bianfd $p |- ( ph -> ( ps <-> ( ps /\ ch ) ) ) $=
      wph wps wps wch wa wph wps wps wch wa bianfd.1 pm2.21d wps wch pm3.26
      impbid1 $.
      $( [27-Mar-1995] $)
  $}

  $( Theorem *4.82 of [WhiteheadRussell] p. 122. $)
  pm4.82 $p |-  ( ( ( ph -> ps ) /\ ( ph -> -. ps ) ) <-> -. ph ) $=
    wph wps wi wph wps wn wi wa wph wn wph wps wi wph wps wn wi wph wn wph wps
    pm2.65 imp wph wn wph wps wi wph wps wn wi wph wps pm2.21 wph wps wn pm2.21
    jca impbii $.
    $( [28-Jun-2005] $) $( [3-Jan-2005] $)

  $( Theorem *4.83 of [WhiteheadRussell] p. 122. $)
  pm4.83 $p |-  ( ( ( ph -> ps ) /\ ( -. ph -> ps ) ) <-> ps ) $=
    wps wph wph wn wo wps wi wph wps wi wph wn wps wi wa wph wph wn wo wps wph
    exmid a1bi wph wps wph wn jaob bitr2i $.
    $( [28-Jun-2005] $) $( [3-Jan-2005] $)

  $( Negation inferred from embedded conjunct. $)
  pclem6 $p |- ( ( ph <-> ( ps /\ -. ph ) ) -> -. ps ) $=
    wph wps wph wn wa wb wph wn wps wn wph wps wph wn wa wb wph wph wps wph wn
    wa wb wph wps wph wn wa wph wn wph wps wph wn wa bi1 wps wph wn pm3.27 syl6
    pm2.01d wph wn wph wps wph wn wa wb wps wph wi wps wn wph wps wph wn wa wb
    wps wph wn wph wph wps wph wn wa wb wps wph wn wph wph wps wph wn wa bi2
    exp3a com23 wps wph con3 syli mpd $.
    $( [20-Aug-1993] $)

  $( A transitive law of equivalence.  Compare Theorem *4.22 of
     [WhiteheadRussell] p. 117. $)
  biantr $p |- ( ( ( ph <-> ps ) /\ ( ch <-> ps ) ) -> ( ph <-> ch ) ) $=
    wch wps wb wph wch wb wph wps wb wch wps wb wch wps wph wch wps wb id
    bibi2d biimparc $.
    $( [18-Aug-1993] $)


  $( Disjunction distributes over the biconditional.  An axiom of system DS in
     Vladimir Lifschitz, "On calculational proofs" (1998),
     ~ http://citeseer.ist.psu.edu/lifschitz98calculational.html . $)
  orbidi $p |-  ( ( ph \/ ( ps <-> ch ) ) <->
                ( ( ph \/ ps ) <-> ( ph \/ ch ) ) ) $=
    wph wps wch wb wo wph wps wo wph wch wo wb wph wph wps wo wph wch wo wb wps
    wch wb wph wph wps wo wph wch wo wph wph wch wo wph wps wo wph wch orc a1d
    wph wph wps wo wph wch wo wph wps orc a1d impbid wps wch wb wps wch wph wps
    wch wb id orbi2d jaoi wph wps wo wph wch wo wi wph wch wo wph wps wo wi wa
    wph wps wch wi wo wph wch wps wi wo wa wph wps wo wph wch wo wb wph wps wch
    wb wo wph wps wo wph wch wo wi wph wps wch wi wo wph wch wo wph wps wo wi
    wph wch wps wi wo wph wps wch pm2.85 wph wch wps pm2.85 anim12i wph wps wo
    wph wch wo dfbi2 wph wps wch wb wo wph wps wch wi wch wps wi wa wo wph wps
    wch wi wo wph wch wps wi wo wa wps wch wb wps wch wi wch wps wi wa wph wps
    wch dfbi2 orbi2i wph wps wch wi wch wps wi ordi bitri 3imtr4i impbii $.
    $( [9-Jan-2005] $) $( [8-Jan-2005] $)

  $( Associative law for the biconditional.  An axiom of system DS in Vladimir
     Lifschitz, "On calculational proofs" (1998),
     ~ http://citeseer.ist.psu.edu/lifschitz98calculational.html .
     Interestingly, this law was not included in _Principia Mathematica_ but
     was apparently first noted by Jan Lukasiewicz circa 1923.  (The proof was
     shortened by Juha Arpiainen, 19-Jan-2006.) $)
  biass $p |- ( ( ( ph <-> ps ) <-> ch ) <-> ( ph <-> ( ps <-> ch ) ) ) $=
    wph wph wps wb wch wb wph wps wch wb wb wb wph wps wch wb wph wps wb wch wb
    wph wps wch wb wb wph wps wph wps wb wch wph wps pm5.501 bibi1d wph wps wch
    wb pm5.501 bitr3d wph wn wps wn wch wb wps wch wb wn wph wps wb wch wb wph
    wps wch wb wb wps wn wch wb wps wch wb wn wb wph wn wps wch nbbn a1i wph wn
    wps wn wph wps wb wch wph wps nbn2 bibi1d wph wps wch wb nbn2 3bitr3d
    pm2.61i $.
    $( [21-Jan-2006] $) $( [8-Jan-2005] $)

  $( Lukasiewicz's shortest axiom for equivalential calculus.  Storrs McCall,
     ed., _Polish Logic 1920-1939_ (Oxford, 1967), p. 96. $)
  biluk $p |- ( ( ph <-> ps ) <-> ( ( ch <-> ps ) <-> ( ph <-> ch ) ) ) $=
    wph wps wb wch wps wph wch wb wb wb wch wps wb wph wch wb wb wph wps wb wch
    wb wps wph wch wb wb wb wph wps wb wch wps wph wch wb wb wb wb wph wps wb
    wch wb wps wph wb wch wb wps wph wch wb wb wph wps wb wps wph wb wch wph
    wps bicom bibi1i wps wph wch biass bitri wph wps wb wch wps wph wch wb wb
    biass mpbi wch wps wph wch wb biass bitr4i $.
    $( [11-Jan-2005] $) $( [10-Jan-2005] $)

  $( Disjunction distributes over the biconditional.  Theorem *5.7 of
     [WhiteheadRussell] p. 125.  This theorem is similar to ~ orbidi .
     (Contributed by Roy F. Longton, 21-Jun-2005.) $)
  pm5.7 $p |-  ( ( ( ph \/ ch ) <-> ( ps \/ ch ) ) <->
               ( ch \/ ( ph <-> ps ) ) ) $=
    wch wph wps wb wo wch wph wo wch wps wo wb wph wch wo wps wch wo wb wch wph
    wps orbidi wch wph wo wph wch wo wch wps wo wps wch wo wch wph orcom wch
    wps orcom bibi12i bitr2i $.
    $( [22-Jun-2005] $) $( [21-Jun-2005] $)

  $( Dijkstra-Scholten's Golden Rule for calculational proofs. $)
  bigolden $p |- ( ( ( ph /\ ps ) <-> ph ) <-> ( ps <-> ( ph \/ ps ) ) ) $=
    wph wps wi wph wph wps wa wb wps wph wps wo wb wph wps wa wph wb wph wps
    pm4.71 wph wps pm4.72 wph wph wps wa bicom 3bitr3ri $.
    $( [12-Jan-2005] $) $( [10-Jan-2005] $)

  $( Theorem *5.71 of [WhiteheadRussell] p. 125.  (Contributed by Roy F.
     Longton, 23-Jun-2005.) $)
  pm5.71 $p |-  ( ( ps -> -. ch ) -> ( ( ( ph \/ ps ) /\ ch ) <->
                ( ph /\ ch ) ) ) $=
    wps wch wn wph wps wo wch wa wph wch wa wb wps wn wph wps wo wph wch wps wn
    wph wps wo wph wps wph orel2 wph wps orc impbid1 anbi1d wch wn wch wph wps
    wo wph wch wph wps wo wph wb pm2.21 pm5.32rd ja $.
    $( [24-Jun-2005] $) $( [23-Jun-2005] $)

  $( Theorem *5.75 of [WhiteheadRussell] p. 126. $)
  pm5.75 $p |-  ( ( ( ch -> -. ps ) /\ ( ph <-> ( ps \/ ch ) ) ) ->
                ( ( ph /\ -. ps ) <-> ch ) ) $=
    wch wps wn wi wph wps wch wo wb wa wph wps wn wa wch wph wps wch wo wb wph
    wps wn wa wch wi wch wps wn wi wph wps wch wo wb wph wps wch wo wi wph wps
    wn wa wch wi wph wps wch wo bi1 wph wps wch pm5.6 sylibr adantl wch wps wn
    wi wph wps wch wo wb wa wch wph wps wn wph wps wch wo wb wch wps wn wi wch
    wph wi wph wps wch wo wb wch wps wn wph wph wps wch wo wb wch wps wn wph
    wph wps wch wo wb wch wps wph wo wi wch wps wn wa wph wi wph wps wch wo wb
    wps wch wo wph wi wch wps wph wo wi wph wps wch wo bi2 wch wps wch wo wph
    wps wph wo wch wps olc wph wps olc imim12i syl wch wps wph pm5.6 sylibr
    exp3a a2d impcom wch wps wn wi wph wps wch wo wb pm3.26 jcad impbid $.
    $( [22-Mar-2005] $) $( [3-Jan-2005] $)

  $( Removal of conjunct from one side of an equivalence. $)
  bimsc1 $p |- ( ( ( ph -> ps ) /\ ( ch <-> ( ps /\ ph ) ) )
               -> ( ch <-> ph ) ) $=
    wch wps wph wa wb wch wps wph wa wph wps wi wph wch wps wph wa wb id wph
    wps wi wph wps wph wa wph wps wi wph wps wph wa wb wph wps pm4.71r biimpi
    bicomd sylan9bbr $.
    $( [5-Aug-1993] $)

  ${
    ecase2d.1 $e |- ( ph -> ps ) $.
    ecase2d.2 $e |- ( ph -> -. ( ps /\ ch ) ) $.
    ecase2d.3 $e |- ( ph -> -. ( ps /\ th ) ) $.
    ecase2d.4 $e |- ( ph -> ( ta \/ ( ch \/ th ) ) ) $.
    $( Deduction for elimination by cases. $)
    ecase2d $p |- ( ph -> ta ) $=
      wph wch wth wo wn wta wch wth wo wn wch wn wth wn wph wch wth ioran wph
      wps wch wn ecase2d.1 wph wps wch wa wn wps wch wn wi ecase2d.2 wps wch
      imnan sylibr mpd wph wps wth wn ecase2d.1 wph wps wth wa wn wps wth wn wi
      ecase2d.3 wps wth imnan sylibr mpd sylanbrc wph wch wth wo wta wph wta
      wch wth wo wo wch wth wo wta wo ecase2d.4 wta wch wth wo orcom sylib ord
      mpd $.
      $( [21-Apr-1994] $)
  $}

  ${
    ecase3.1 $e |- ( ph -> ch ) $.
    ecase3.2 $e |- ( ps -> ch ) $.
    ecase3.3 $e |- ( -. ( ph \/ ps ) -> ch ) $.
    $( Inference for elimination by cases. $)
    ecase3 $p |- ch $=
      wph wps wch wph wn wps wn wch wph wn wps wn wa wph wps wo wn wch wph wps
      ioran ecase3.3 sylbir ex ecase3.1 ecase3.2 pm2.61ii $.
      $( [23-Mar-1995] $)
  $}

  ${
    ecase.1 $e |- ( -. ph -> ch ) $.
    ecase.2 $e |- ( -. ps -> ch ) $.
    ecase.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Inference for elimination by cases. $)
    ecase $p |- ch $=
      wph wps wch wph wps wch ecase.3 ex ecase.1 ecase.2 pm2.61nii $.
      $( [22-Jul-2005] $) $( [13-Jul-2005] $)
  $}

  ${
    ecase3d.1 $e |- ( ph -> ( ps -> th ) ) $.
    ecase3d.2 $e |- ( ph -> ( ch -> th ) ) $.
    ecase3d.3 $e |- ( ph -> ( -. ( ps \/ ch ) -> th ) ) $.
    $( Deduction for elimination by cases. $)
    ecase3d $p |- ( ph -> th ) $=
      wps wch wph wth wi wph wps wth ecase3d.1 com12 wph wch wth ecase3d.2
      com12 wph wps wch wo wn wth ecase3d.3 com12 ecase3 $.
      $( [2-May-1996] $)
  $}

  ${
    ccase.1 $e |- ( ( ph /\ ps ) -> ta ) $.
    ccase.2 $e |- ( ( ch /\ ps ) -> ta ) $.
    ccase.3 $e |- ( ( ph /\ th ) -> ta ) $.
    ccase.4 $e |- ( ( ch /\ th ) -> ta ) $.
    $( Inference for combining cases. $)
    ccase $p |- ( ( ( ph \/ ch ) /\ ( ps \/ th ) ) -> ta ) $=
      wph wch wo wps wth wo wa wph wps wa wch wps wa wo wph wth wa wch wth wa
      wo wo wta wph wch wo wps wth wo wa wph wps wa wph wth wa wo wch wps wa
      wch wth wa wo wo wph wps wa wch wps wa wo wph wth wa wch wth wa wo wo wph
      wch wps wth anddi wph wps wa wph wth wa wch wps wa wch wth wa or4 bitri
      wph wps wa wch wps wa wo wta wph wth wa wch wth wa wo wph wps wa wta wch
      wps wa ccase.1 ccase.2 jaoi wph wth wa wta wch wth wa ccase.3 ccase.4
      jaoi jaoi sylbi $.
      $( [29-Jul-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    ccasedwet $f wff et $.
    ccased.1 $e |- ( ph -> ( ( ps /\ ch ) -> et ) ) $.
    ccased.2 $e |- ( ph -> ( ( th /\ ch ) -> et ) ) $.
    ccased.3 $e |- ( ph -> ( ( ps /\ ta ) -> et ) ) $.
    ccased.4 $e |- ( ph -> ( ( th /\ ta ) -> et ) ) $.
    $( Deduction for combining cases. $)
    ccased $p |- ( ph -> ( ( ( ps \/ th ) /\ ( ch \/ ta ) ) -> et ) ) $=
      wph wps wch wa wth wch wa wo wps wta wa wth wta wa wo wo ccasedwet wps
      wth wo wch wta wo wa wph wps wch wa wth wch wa wo ccasedwet wps wta wa
      wth wta wa wo wph wps wch wa ccasedwet wth wch wa ccased.1 ccased.2 jaod
      wph wps wta wa ccasedwet wth wta wa ccased.3 ccased.4 jaod jaod wps wth
      wo wch wta wo wa wps wch wa wps wta wa wo wth wch wa wth wta wa wo wo wps
      wch wa wth wch wa wo wps wta wa wth wta wa wo wo wps wth wch wta anddi
      wps wch wa wps wta wa wth wch wa wth wta wa or4 bitri syl5ib $.
      $( [10-May-2004] $) $( [9-May-2004] $)
  $}

  ${
    ccase2.1 $e |- ( ( ph /\ ps ) -> ta ) $.
    ccase2.2 $e |- ( ch -> ta ) $.
    ccase2.3 $e |- ( th -> ta ) $.
    $( Inference for combining cases. $)
    ccase2 $p |- ( ( ( ph \/ ch ) /\ ( ps \/ th ) ) -> ta ) $=
      wph wps wch wth wta ccase2.1 wch wta wps ccase2.2 adantr wth wta wph
      ccase2.3 adantl wth wta wch ccase2.3 adantl ccase $.
      $( [29-Jul-1999] $)
  $}

  ${
    4cases.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    4cases.2 $e |- ( ( ph /\ -. ps ) -> ch ) $.
    4cases.3 $e |- ( ( -. ph /\ ps ) -> ch ) $.
    4cases.4 $e |- ( ( -. ph /\ -. ps ) -> ch ) $.
    $( Inference eliminating two antecedents from the four possible cases that
       result from their true/false combinations. $)
    4cases $p |- ch $=
      wps wch wph wps wch 4cases.1 4cases.3 pm2.61ian wph wps wn wch 4cases.2
      4cases.4 pm2.61ian pm2.61i $.
      $( [25-Oct-2003] $) $( [25-Oct-2003] $)
  $}

  ${
    niabn.1 $e |- ph $.
    $( Miscellaneous inference relating falsehoods. $)
    niabn $p |- ( -. ps -> ( ( ch /\ ps ) <-> -. ph ) ) $=
      wch wps wa wps wph wn wch wps pm3.27 wph wps niabn.1 pm2.24i pm5.21ni $.
      $( [31-Mar-1994] $)
  $}

  $( Lemma for an alternate version of weak deduction theorem. $)
  dedlem0a $p |- ( ph -> ( ps <-> ( ( ch -> ph ) -> ( ps /\ ph ) ) ) ) $=
    wph wps wch wph wi wps wi wch wph wi wps wph wa wi wph wps wch wph wi wps
    wi wps wch wph wi ax-1 wch wph wi wps wi wph wps wph wch wph wi wps wph wch
    ax-1 imim1i com12 impbid2 wph wps wps wph wa wch wph wi wph wps iba imbi2d
    bitrd $.
    $( [2-Apr-1994] $)

  $( Lemma for an alternate version of weak deduction theorem. $)
  dedlem0b $p |- ( -. ph -> ( ps <-> ( ( ps -> ph ) -> ( ch /\ ph ) ) ) ) $=
    wph wn wps wps wph wi wch wph wa wi wph wn wps wph wi wps wch wph wa wph wn
    wph wch wph wa wps wph wch wph wa pm2.21 imim2d com23 wps wph wi wch wph wa
    wi wph wn wps wps wph wi wch wph wa wi wps wph wps wn wps wph wi wch wph wa
    wph wps wph pm2.21 wch wph pm3.27 imim12i con1d com12 impbid $.
    $( [2-Apr-1994] $)

  $( Lemma for weak deduction theorem. $)
  dedlema $p |- ( ph -> ( ps <-> ( ( ps /\ ph ) \/ ( ch /\ -. ph ) ) ) ) $=
    wph wps wps wch wph wn wa wo wps wph wa wch wph wn wa wo wph wps wps wch
    wph wn wa wo wps wch wph wn wa orc wph wps wps wch wph wn wa wph wps idd
    wph wph wn wps wch wph wps pm2.24 adantld jaod impbid2 wph wps wps wph wa
    wch wph wn wa wph wps iba orbi1d bitrd $.
    $( [26-Jun-2002] $)

  $( Lemma for weak deduction theorem. $)
  dedlemb $p |- ( -. ph -> ( ch <-> ( ( ps /\ ph ) \/ ( ch /\ -. ph ) ) ) ) $=
    wph wn wch wps wph wa wch wph wn wa wo wch wph wn wps wph wa wch wph wn wa
    wo wch wph wn wa wps wph wa olc expcom wph wn wps wph wa wch wch wph wn wa
    wph wn wps wph wch wph wn wph wps wch wph wps wch wi pm2.21 com23 imp3a wch
    wph wn wa wch wi wph wn wch wph wn pm3.26 a1i jaod impbid $.
    $( [15-May-1999] $)

  ${
    elimh.1 $e |- ( ( ph <-> ( ( ph /\ ch ) \/ ( ps /\ -. ch ) ) )
                     -> ( ch <-> ta ) ) $.
    elimh.2 $e |- ( ( ps <-> ( ( ph /\ ch ) \/ ( ps /\ -. ch ) ) )
                     -> ( th <-> ta ) ) $.
    elimh.3 $e |- th $.
    $( Hypothesis builder for weak deduction theorem.  For more information,
       see the Deduction Theorem link on the Metamath Proof Explorer home
       page. $)
    elimh $p |- ta $=
      wch wta wch wta wch wph wph wch wa wps wch wn wa wo wb wch wta wb wch wph
      wps dedlema elimh.1 syl ibi wch wn wth wta elimh.3 wch wn wps wph wch wa
      wps wch wn wa wo wb wth wta wb wch wph wps dedlemb elimh.2 syl mpbii
      pm2.61i $.
      $( [26-Jun-2002] $)
  $}

  ${
    dedt.1 $e |- ( ( ph <-> ( ( ph /\ ch ) \/ ( ps /\ -. ch ) ) )
                     -> ( th <-> ta ) ) $.
    dedt.2 $e |- ta $.
    $( The weak deduction theorem.  For more information, see the Deduction
       Theorem link on the Metamath Proof Explorer home page. $)
    dedt $p |- ( ch -> th ) $=
      wch wph wph wch wa wps wch wn wa wo wb wth wch wph wps dedlema wph wph
      wch wa wps wch wn wa wo wb wth wta dedt.2 dedt.1 mpbiri syl $.
      $( [26-Jun-2002] $)
  $}

  $( Contraposition.  Theorem *2.16 of [WhiteheadRussell] p. 103.  This version
     of ~ con3 demonstrates the use of the weak deduction theorem to derive
     it from ~ con3i . $)
  con3th $p |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) $=
    wps wph wph wps wi wps wn wph wn wi wps wph wps wi wa wph wph wps wi wn wa
    wo wn wph wn wi wps wps wph wps wi wa wph wph wps wi wn wa wo wb wps wn wps
    wph wps wi wa wph wph wps wi wn wa wo wn wph wn wps wps wph wps wi wa wph
    wph wps wi wn wa wo wb wps wps wph wps wi wa wph wph wps wi wn wa wo wps
    wps wph wps wi wa wph wph wps wi wn wa wo wb id notbid imbi1d wph wps wph
    wps wi wa wph wph wps wi wn wa wo wps wph wph wps wi wph wph wi wph wps wph
    wps wi wa wph wph wps wi wn wa wo wi wps wps wph wps wi wa wph wph wps wi
    wn wa wo wb wps wps wph wps wi wa wph wph wps wi wn wa wo wph wps wps wph
    wps wi wa wph wph wps wi wn wa wo wb id imbi2d wph wps wph wps wi wa wph
    wph wps wi wn wa wo wb wph wps wph wps wi wa wph wph wps wi wn wa wo wph
    wph wps wph wps wi wa wph wph wps wi wn wa wo wb id imbi2d wph id elimh
    con3i dedt $.
    $( [27-Jun-2002] $)

  $( The consensus theorem.  This theorem and its dual (with ` \/ ` and ` /\ `
     interchanged) are commonly used in computer logic design to eliminate
     redundant terms from Boolean expressions.  Specifically, we prove that the
     term ` ( ps /\ ch ) ` on the left-hand side is redundant. $)
  consensus $p |- ( ( ( ( ph /\ ps ) \/ ( -. ph /\ ch ) ) \/ ( ps /\ ch ) ) <->
                      ( ( ph /\ ps ) \/ ( -. ph /\ ch ) ) ) $=
    wph wps wa wph wn wch wa wo wps wch wa wo wph wps wa wph wn wch wa wo wph
    wps wa wph wn wch wa wo wph wps wa wph wn wch wa wo wps wch wa wph wps wa
    wph wn wch wa wo id wps wch wa wps wph wa wch wph wn wa wo wph wps wa wph
    wn wch wa wo wph wps wch wa wps wph wa wch wph wn wa wo wi wph wps wps wph
    wa wch wph wn wa wo wch wph wps wps wph wa wch wph wn wa wo wph wps wch
    dedlema biimpd adantrd wph wn wch wps wph wa wch wph wn wa wo wps wph wn
    wch wps wph wa wch wph wn wa wo wph wps wch dedlemb biimpd adantld pm2.61i
    wps wph wa wph wps wa wch wph wn wa wph wn wch wa wps wph ancom wch wph wn
    ancom orbi12i sylib jaoi wph wps wa wph wn wch wa wo wps wch wa orc impbii
    $.
    $( [16-May-2003] $)

  $( Theorem *4.42 of [WhiteheadRussell] p. 119.  (Contributed by Roy F.
     Longton, 21-Jun-2005.) $)
  pm4.42 $p |-  ( ph <-> ( ( ph /\ ps ) \/ ( ph /\ -. ps ) ) ) $=
    wps wph wph wps wa wph wps wn wa wo wb wps wph wph dedlema wps wph wph
    dedlemb pm2.61i $.
    $( [21-Jun-2005] $) $( [21-Jun-2005] $)

  ${
    ninba.1 $e |- ph $.
    $( Miscellaneous inference relating falsehoods. $)
    ninba $p |- ( -. ps -> ( -. ph <-> ( ch /\ ps ) ) ) $=
      wps wn wch wps wa wph wn wph wps wch ninba.1 niabn bicomd $.
      $( [31-Mar-1994] $)
  $}

  ${
    $v et $. $( Greek eta $)
    wet $f wff et $.
    prlem1.1 $e |- ( ph -> ( et <-> ch ) ) $.
    prlem1.2 $e |- ( ps -> -. th ) $.
    $( A specialized lemma for set theory (to derive the Axiom of Pairing). $)
    prlem1 $p |- ( ph -> ( ps ->
                  ( ( ( ps /\ ch ) \/ ( th /\ ta ) ) -> et ) ) ) $=
      wps wch wa wth wta wa wo wph wps wet wps wch wa wph wps wet wi wi wth wta
      wa wps wch wa wph wet wps wch wph wet wi wps wph wet wch prlem1.1
      biimprcd adantl a1dd wth wta wa wps wet wi wph wth wps wet wi wta wth wth
      wn wet wps wth wet pm2.24 prlem1.2 syl5 adantr a1d jaoi com3l $.
      $( [18-Oct-1995] $)
  $}

  $( A specialized lemma for set theory (to derive the Axiom of Pairing). $)
  prlem2 $p |- ( ( ( ph /\ ps ) \/ ( ch /\ th ) ) <->
               ( ( ph \/ ch ) /\ ( ( ph /\ ps ) \/ ( ch /\ th ) ) ) ) $=
    wph wps wa wch wth wa wo wph wch wo wph wps wa wa wph wch wo wch wth wa wa
    wo wph wch wo wph wps wa wch wth wa wo wa wph wps wa wph wch wo wph wps wa
    wa wch wth wa wph wch wo wch wth wa wa wph wps wa wph wch wo wph wa wps wa
    wph wch wo wph wps wa wa wph wph wch wo wph wa wps wph wch orabs anbi1i wph
    wch wo wph wps anass bitri wch wth wa wph wch wo wch wa wth wa wph wch wo
    wch wth wa wa wch wph wch wo wch wa wth wch wch wph wo wch wa wph wch wo
    wch wa wch wph orabs wch wph wo wph wch wo wch wch wph orcom anbi1i bitri
    anbi1i wph wch wo wch wth anass bitri orbi12i wph wch wo wph wps wa wch wth
    wa andi bitr4i $.
    $( [5-Aug-1993] $)

  ${
    oplem1.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    oplem1.2 $e |- ( ph -> ( th \/ ta ) ) $.
    oplem1.3 $e |- ( ps <-> th ) $.
    oplem1.4 $e |- ( ch -> ( th <-> ta ) ) $.
    $( A specialized lemma for set theory (ordered pair theorem). $)
    oplem1 $p |- ( ph -> ps ) $=
      wph wps wn wps wi wps wph wps wn wch wta wa wps wph wps wn wch wta wph
      wps wch oplem1.1 ord wph wth wn wta wps wn wph wth wta oplem1.2 ord wps
      wth oplem1.3 notbii syl5ib jcad wch wps wta wch wth wta wps oplem1.4
      oplem1.3 syl5bb biimpar syl6 wps pm2.18 syl $.
      $( [18-Oct-1995] $)
  $}

  $( Lemma used in construction of real numbers. $)
  rnlem $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
  ( ( ( ph /\ ch ) /\ ( ps /\ th ) ) /\ ( ( ph /\ th ) /\ ( ps /\ ch ) ) ) ) $=
    wph wps wa wch wth wa wa wph wch wth wa wa wps wch wth wa wa wa wph wch wa
    wph wth wa wa wps wch wa wps wth wa wa wa wph wch wa wps wth wa wa wph wth
    wa wps wch wa wa wa wph wps wch wth wa anandir wph wch wth wa wa wph wch wa
    wph wth wa wa wps wch wth wa wa wps wch wa wps wth wa wa wph wch wth anandi
    wps wch wth anandi anbi12i wph wch wa wph wth wa wa wps wch wa wps wth wa
    wa wa wph wch wa wph wth wa wa wps wth wa wps wch wa wa wa wph wch wa wps
    wth wa wa wph wth wa wps wch wa wa wa wps wch wa wps wth wa wa wps wth wa
    wps wch wa wa wph wch wa wph wth wa wa wps wch wa wps wth wa ancom anbi2i
    wph wch wa wph wth wa wps wth wa wps wch wa an4 bitri 3bitri $.
    $( [4-Sep-1995] $)

  $( A single axiom for Boolean algebra known as DN_1.  See
     ~ http://www-unix.mcs.anl.gov/~~mccune/papers/basax/v12.pdf .
     (Contributed by Jeffrey Hankins, 3-Jul-2009.) $)
  dn1 $p |- ( -. ( -. ( -. ( ph \/ ps ) \/ ch ) \/
            -. ( ph \/ -. ( -. ch \/ -. ( ch \/ th ) ) ) ) <-> ch ) $=
    wph wps wo wn wch wo wn wph wch wn wch wth wo wn wo wn wo wn wo wn wph wps
    wo wn wch wo wph wch wn wch wth wo wn wo wn wo wa wch wph wps wo wn wch wo
    wph wch wn wch wth wo wn wo wn wo anor wph wps wo wn wch wo wph wch wn wch
    wth wo wn wo wn wo wa wch wph wps wo wn wch wo wph wch wn wch wth wo wn wo
    wn wo wch wph wps wo wn wph wch wn wch wth wo wn wo wn wo wch wi wch wph
    wps wo wn wph wn wps wn wa wph wch wn wch wth wo wn wo wn wo wch wi wph wps
    ioran wph wn wps wn wph wch wn wch wth wo wn wo wn wo wch wi wph wch wn wch
    wth wo wn wo wn wo wps wn wph wn wch wph wps wn wph wn wch wi wi wch wn wch
    wth wo wn wo wn wph wph wn wps wn wch wph wps wn wch wi pm2.24 com23 wch wn
    wch wth wo wn wo wn wch wch wth wo wa wps wn wph wn wch wi wi wch wch wth
    wo anor wch wps wn wph wn wch wi wi wch wth wo wch wph wn wch wi wps wn wch
    wph wn ax-1 a1d adantr sylbir jaoi com13 imp sylbi wch wph wch wn wch wth
    wo wn wo wn wo ax-1 jaoi imp wch wph wps wo wn wch wo wph wch wn wch wth wo
    wn wo wn wo wch wph wps wo wn olc wch wph wch wn wch wth wo wn wo wn wch
    wch wn wch wth wo wn wo wph wch wch wn wph wch wth wo wn wch wph pm2.24 wch
    wch wn wth wn wa wph wch wth wo wn wch wch wn wth wn wph wch wth wn wph wi
    pm2.24 imp3a wch wth ioran syl5ib jaod con3d orrd jca impbii bitr3i $.
    $( [8-Jul-2009] $) $( [22-Jun-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Abbreviated conjunction and disjunction of three wff's
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend wff definition to include 3-way disjunction ('or'). $)
  w3o $a wff ( ph \/ ps \/ ch ) $.
  $( Extend wff definition to include 3-way conjunction ('and'). $)
  w3a $a wff ( ph /\ ps /\ ch ) $.

  $( These abbreviations help eliminate parentheses to aid readability. $)

  $( Define disjunction ('or') of 3 wff's.  Definition *2.33 of
     [WhiteheadRussell] p. 105.  This abbreviation reduces the number of
     parentheses and emphasizes that the order of bracketing is not
     important by virtue of the associative law ~ orass . $)
  df-3or $a |- ( ( ph \/ ps \/ ch ) <-> ( ( ph \/ ps ) \/ ch ) ) $.

  $( Define conjunction ('and') of 3 wff.s.  Definition *4.34 of
     [WhiteheadRussell] p. 118.  This abbreviation reduces the number of
     parentheses and emphasizes that the order of bracketing is not
     important by virtue of the associative law ~ anass . $)
  df-3an $a |- ( ( ph /\ ps /\ ch ) <-> ( ( ph /\ ps ) /\ ch ) ) $.

  $( Associative law for triple disjunction. $)
  3orass $p |- ( ( ph \/ ps \/ ch ) <-> ( ph \/ ( ps \/ ch ) ) ) $=
    wph wps wch w3o wph wps wo wch wo wph wps wch wo wo wph wps wch df-3or wph
    wps wch orass bitri $.
    $( [8-Apr-1994] $)

  $( Associative law for triple conjunction. $)
  3anass $p |- ( ( ph /\ ps /\ ch ) <-> ( ph /\ ( ps /\ ch ) ) ) $=
    wph wps wch w3a wph wps wa wch wa wph wps wch wa wa wph wps wch df-3an wph
    wps wch anass bitri $.
    $( [8-Apr-1994] $)

  $( Rotation law for triple conjunction. $)
  3anrot $p |- ( ( ph /\ ps /\ ch ) <-> ( ps /\ ch /\ ph ) ) $=
    wph wps wch wa wa wps wch wa wph wa wph wps wch w3a wps wch wph w3a wph wps
    wch wa ancom wph wps wch 3anass wps wch wph df-3an 3bitr4i $.
    $( [8-Apr-1994] $)

  $( Rotation law for triple disjunction. $)
  3orrot $p |- ( ( ph \/ ps \/ ch ) <-> ( ps \/ ch \/ ph ) ) $=
    wph wps wch wo wo wps wch wo wph wo wph wps wch w3o wps wch wph w3o wph wps
    wch wo orcom wph wps wch 3orass wps wch wph df-3or 3bitr4i $.
    $( [4-Apr-1995] $)

  $( Commutation law for triple conjunction. $)
  3ancoma $p |- ( ( ph /\ ps /\ ch ) <-> ( ps /\ ph /\ ch ) ) $=
    wph wps wa wch wa wps wph wa wch wa wph wps wch w3a wps wph wch w3a wph wps
    wa wps wph wa wch wph wps ancom anbi1i wph wps wch df-3an wps wph wch
    df-3an 3bitr4i $.
    $( [21-Apr-1994] $)

  $( Commutation law for triple conjunction. $)
  3ancomb $p |- ( ( ph /\ ps /\ ch ) <-> ( ph /\ ch /\ ps ) ) $=
    wph wps wch w3a wps wph wch w3a wph wch wps w3a wph wps wch 3ancoma wps wph
    wch 3anrot bitri $.
    $( [21-Apr-1994] $)

  $( Reversal law for triple conjunction. $)
  3anrev $p |- ( ( ph /\ ps /\ ch ) <-> ( ch /\ ps /\ ph ) ) $=
    wph wps wch w3a wps wph wch w3a wch wps wph w3a wph wps wch 3ancoma wch wps
    wph 3anrot bitr4i $.
    $( [21-Apr-1994] $)

  $( Simplification of triple conjunction. $)
  3simpa $p |- ( ( ph /\ ps /\ ch ) -> ( ph /\ ps ) ) $=
    wph wps wch w3a wph wps wa wch wph wps wch df-3an pm3.26bi $.
    $( [21-Apr-1994] $)

  $( Simplification of triple conjunction. $)
  3simpb $p |- ( ( ph /\ ps /\ ch ) -> ( ph /\ ch ) ) $=
    wph wps wch w3a wph wch wps w3a wph wch wa wph wps wch 3ancomb wph wch wps
    3simpa sylbi $.
    $( [21-Apr-1994] $)

  $( Simplification of triple conjunction. $)
  3simpc $p |- ( ( ph /\ ps /\ ch ) -> ( ps /\ ch ) ) $=
    wph wps wch w3a wps wch wph w3a wps wch wa wph wps wch 3anrot wps wch wph
    3simpa sylbi $.
    $( [21-Apr-1994] $)

  $( Simplification of triple conjunction. $)
  3simp1 $p |- ( ( ph /\ ps /\ ch ) -> ph ) $=
    wph wps wch w3a wph wps wph wps wch 3simpa pm3.26d $.
    $( [21-Apr-1994] $)

  $( Simplification of triple conjunction. $)
  3simp2 $p |- ( ( ph /\ ps /\ ch ) -> ps ) $=
    wph wps wch w3a wph wps wph wps wch 3simpa pm3.27d $.
    $( [21-Apr-1994] $)

  $( Simplification of triple conjunction. $)
  3simp3 $p |- ( ( ph /\ ps /\ ch ) -> ch ) $=
    wph wps wch w3a wps wch wph wps wch 3simpc pm3.27d $.
    $( [21-Apr-1994] $)

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  3simpl1 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ph ) $=
    wph wps wch w3a wph wth wph wps wch 3simp1 adantr $.
    $( [18-Apr-2010] $) $( [17-Nov-2009] $)

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  3simpl2 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ps ) $=
    wph wps wch w3a wps wth wph wps wch 3simp2 adantr $.
    $( [18-Apr-2010] $) $( [17-Nov-2009] $)

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  3simpl3 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ch ) $=
    wph wps wch w3a wch wth wph wps wch 3simp3 adantr $.
    $( [18-Apr-2010] $) $( [17-Nov-2009] $)

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  3simpr1 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ps ) $=
    wps wch wth w3a wps wph wps wch wth 3simp1 adantl $.
    $( [18-Apr-2010] $) $( [17-Nov-2009] $)

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  3simpr2 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ch ) $=
    wps wch wth w3a wch wph wps wch wth 3simp2 adantl $.
    $( [18-Apr-2010] $) $( [17-Nov-2009] $)

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  3simpr3 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> th ) $=
    wps wch wth w3a wth wph wps wch wth 3simp3 adantl $.
    $( [18-Apr-2010] $) $( [17-Nov-2009] $)

  ${
    3simp1i.1 $e |- ( ph /\ ps /\ ch ) $.
    $( Infer a conjunct from a triple conjunction. $)
    3simp1i $p |- ph $=
      wph wps wch w3a wph 3simp1i.1 wph wps wch 3simp1 ax-mp $.
      $( [21-Apr-2005] $) $( [19-Apr-2005] $)

    $( Infer a conjunct from a triple conjunction. $)
    3simp2i $p |- ps $=
      wph wps wch w3a wps 3simp1i.1 wph wps wch 3simp2 ax-mp $.
      $( [21-Apr-2005] $) $( [19-Apr-2005] $)

    $( Infer a conjunct from a triple conjunction. $)
    3simp3i $p |- ch $=
      wph wps wch w3a wch 3simp1i.1 wph wps wch 3simp3 ax-mp $.
      $( [21-Apr-2005] $) $( [19-Apr-2005] $)
  $}

  ${
    3simp1d.1 $e |- ( ph -> ( ps /\ ch /\ th ) ) $.
    $( Deduce a conjunct from a triple conjunction. $)
    3simp1d $p |- ( ph -> ps ) $=
      wph wps wch wth w3a wps 3simp1d.1 wps wch wth 3simp1 syl $.
      $( [6-Sep-2005] $) $( [4-Sep-2005] $)

    $( Deduce a conjunct from a triple conjunction. $)
    3simp2d $p |- ( ph -> ch ) $=
      wph wps wch wth w3a wch 3simp1d.1 wps wch wth 3simp2 syl $.
      $( [6-Sep-2005] $) $( [4-Sep-2005] $)

    $( Deduce a conjunct from a triple conjunction. $)
    3simp3d $p |- ( ph -> th ) $=
      wph wps wch wth w3a wth 3simp1d.1 wps wch wth 3simp3 syl $.
      $( [7-Sep-2005] $) $( [4-Sep-2005] $)
  $}

  ${
    3adant.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding a conjunct to antecedent. $)
    3adant1 $p |- ( ( th /\ ph /\ ps ) -> ch ) $=
      wth wph wps w3a wph wps wa wch wth wph wps 3simpc 3adant.1 syl $.
      $( [16-Jul-1995] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant2 $p |- ( ( ph /\ th /\ ps ) -> ch ) $=
      wph wth wps w3a wph wps wa wch wph wth wps 3simpb 3adant.1 syl $.
      $( [16-Jul-1995] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant3 $p |- ( ( ph /\ ps /\ th ) -> ch ) $=
      wph wps wth w3a wph wps wa wch wph wps wth 3simpa 3adant.1 syl $.
      $( [16-Jul-1995] $)
  $}

  ${
    3ad2ant.1 $e |- ( ph -> ch ) $.
    $( Deduction adding conjuncts to an antecedent. $)
    3ad2ant1 $p |- ( ( ph /\ ps /\ th ) -> ch ) $=
      wph wth wch wps wph wch wth 3ad2ant.1 adantr 3adant2 $.
      $( [23-Apr-2005] $) $( [21-Apr-2005] $)

    $( Deduction adding conjuncts to an antecedent. $)
    3ad2ant2 $p |- ( ( ps /\ ph /\ th ) -> ch ) $=
      wph wth wch wps wph wch wth 3ad2ant.1 adantr 3adant1 $.
      $( [23-Apr-2005] $) $( [21-Apr-2005] $)

    $( Deduction adding conjuncts to an antecedent. $)
    3ad2ant3 $p |- ( ( ps /\ th /\ ph ) -> ch ) $=
      wth wph wch wps wph wch wth 3ad2ant.1 adantl 3adant1 $.
      $( [23-Apr-2005] $) $( [21-Apr-2005] $)
  $}

  ${
    3adantl.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Deduction adding a conjunct to antecedent. $)
    3adantl1 $p |- ( ( ( ta /\ ph /\ ps ) /\ ch ) -> th ) $=
      wta wph wps w3a wch wth wph wps wch wth wi wta wph wps wa wch wth
      3adantl.1 ex 3adant1 imp $.
      $( [26-Feb-2005] $) $( [24-Feb-2005] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adantl2 $p |- ( ( ( ph /\ ta /\ ps ) /\ ch ) -> th ) $=
      wph wta wps w3a wch wth wph wps wch wth wi wta wph wps wa wch wth
      3adantl.1 ex 3adant2 imp $.
      $( [25-Feb-2005] $) $( [24-Feb-2005] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adantl3 $p |- ( ( ( ph /\ ps /\ ta ) /\ ch ) -> th ) $=
      wph wps wta w3a wch wth wph wps wch wth wi wta wph wps wa wch wth
      3adantl.1 ex 3adant3 imp $.
      $( [28-Apr-2005] $) $( [24-Feb-2005] $)
  $}

  ${
    3adantr.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Deduction adding a conjunct to antecedent. $)
    3adantr1 $p |- ( ( ph /\ ( ta /\ ps /\ ch ) ) -> th ) $=
      wta wps wch w3a wph wth wps wch wph wth wta wph wps wch wa wth 3adantr.1
      ancoms 3adantl1 ancoms $.
      $( [27-Jun-2005] $) $( [27-Apr-2005] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adantr2 $p |- ( ( ph /\ ( ps /\ ta /\ ch ) ) -> th ) $=
      wps wta wch w3a wph wth wps wch wph wth wta wph wps wch wa wth 3adantr.1
      ancoms 3adantl2 ancoms $.
      $( [28-Apr-2005] $) $( [27-Apr-2005] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adantr3 $p |- ( ( ph /\ ( ps /\ ch /\ ta ) ) -> th ) $=
      wps wch wta w3a wph wth wps wch wph wth wta wph wps wch wa wth 3adantr.1
      ancoms 3adantl3 ancoms $.
      $( [28-Apr-2005] $) $( [27-Apr-2005] $)
  $}

  ${
    3ad2antl.1 $e |- ( ( ph /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent. $)
    3ad2antl1 $p |- ( ( ( ph /\ ps /\ ta ) /\ ch ) -> th ) $=
      wph wta wch wth wps wph wch wth wta 3ad2antl.1 adantlr 3adantl2 $.
      $( [4-Aug-2007] $) $( [4-Aug-2007] $)

    $( Deduction adding conjuncts to antecedent. $)
    3ad2antl2 $p |- ( ( ( ps /\ ph /\ ta ) /\ ch ) -> th ) $=
      wph wta wch wth wps wph wch wth wta 3ad2antl.1 adantlr 3adantl1 $.
      $( [4-Aug-2007] $) $( [4-Aug-2007] $)

    $( Deduction adding conjuncts to antecedent. $)
    3ad2antl3 $p |- ( ( ( ps /\ ta /\ ph ) /\ ch ) -> th ) $=
      wta wph wch wth wps wph wch wth wta 3ad2antl.1 adantll 3adantl1 $.
      $( [4-Aug-2007] $) $( [4-Aug-2007] $)

    $( Deduction adding a conjuncts to antecedent. $)
    3ad2antr1 $p |- ( ( ph /\ ( ch /\ ps /\ ta ) ) -> th ) $=
      wph wch wps wth wta wph wch wth wps 3ad2antl.1 adantrr 3adantr3 $.
      $( [25-Dec-2007] $) $( [25-Dec-2007] $)

    $( Deduction adding a conjuncts to antecedent. $)
    3ad2antr2 $p |- ( ( ph /\ ( ps /\ ch /\ ta ) ) -> th ) $=
      wph wps wch wth wta wph wch wth wps 3ad2antl.1 adantrl 3adantr3 $.
      $( [27-Dec-2007] $) $( [27-Dec-2007] $)

    $( Deduction adding a conjuncts to antecedent. $)
    3ad2antr3 $p |- ( ( ph /\ ( ps /\ ta /\ ch ) ) -> th ) $=
      wph wta wch wth wps wph wch wth wta 3ad2antl.1 adantrl 3adantr1 $.
      $( [30-Dec-2007] $) $( [30-Dec-2007] $)
  $}

  $( Introduction in triple disjunction. $)
  3mix1 $p |- ( ph -> ( ph \/ ps \/ ch ) ) $=
    wph wph wps wch wo wo wph wps wch w3o wph wps wch wo orc wph wps wch 3orass
    sylibr $.
    $( [4-Apr-1995] $)

  $( Introduction in triple disjunction. $)
  3mix2 $p |- ( ph -> ( ps \/ ph \/ ch ) ) $=
    wph wph wch wps w3o wps wph wch w3o wph wch wps 3mix1 wps wph wch 3orrot
    sylibr $.
    $( [4-Apr-1995] $)

  $( Introduction in triple disjunction. $)
  3mix3 $p |- ( ph -> ( ps \/ ch \/ ph ) ) $=
    wph wph wps wch w3o wps wch wph w3o wph wps wch 3mix1 wph wps wch 3orrot
    sylib $.
    $( [4-Apr-1995] $)

  ${
    3pm3.2i.1 $e |- ph $.
    3pm3.2i.2 $e |- ps $.
    3pm3.2i.3 $e |- ch $.
    $( Infer conjunction of premises. $)
    3pm3.2i $p |- ( ph /\ ps /\ ch ) $=
      wph wps wch w3a wph wps wa wch wph wps wch df-3an wph wps 3pm3.2i.1
      3pm3.2i.2 pm3.2i 3pm3.2i.3 mpbir2an $.
      $( [10-Feb-1995] $)
  $}

  ${
    3jca.1 $e |- ( ph -> ps ) $.
    3jca.2 $e |- ( ph -> ch ) $.
    3jca.3 $e |- ( ph -> th ) $.
    $( Join consequents with conjunction. $)
    3jca $p |- ( ph -> ( ps /\ ch /\ th ) ) $=
      wph wps wch wa wth wa wps wch wth w3a wph wps wch wth 3jca.1 3jca.2
      3jca.3 jca31 wps wch wth df-3an sylibr $.
      $( [9-Apr-1994] $)
  $}

  ${
    3jcad.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3jcad.2 $e |- ( ph -> ( ps -> th ) ) $.
    3jcad.3 $e |- ( ph -> ( ps -> ta ) ) $.
    $( Deduction conjoining the consequents of three implications. $)
    3jcad $p |- ( ph -> ( ps -> ( ch /\ th /\ ta ) ) ) $=
      wph wps wch wth wta w3a wph wps wa wch wth wta wph wps wch 3jcad.1 imp
      wph wps wth 3jcad.2 imp wph wps wta 3jcad.3 imp 3jca ex $.
      $( [3-Oct-2005] $) $( [25-Sep-2005] $)
  $}

  ${
    $v et $. $( Greek eta $)
    i3wet $f wff et $.
    3anim123i.1 $e |- ( ph -> ps ) $.
    3anim123i.2 $e |- ( ch -> th ) $.
    3anim123i.3 $e |- ( ta -> et ) $.
    $( Join antecedents and consequents with conjunction. $)
    3anim123i $p |- ( ( ph /\ ch /\ ta ) -> ( ps /\ th /\ et ) ) $=
      wph wch wa wta wa wps wth wa i3wet wa wph wch wta w3a wps wth i3wet w3a
      wph wch wa wps wth wa wta i3wet wph wps wch wth 3anim123i.1 3anim123i.2
      anim12i 3anim123i.3 anim12i wph wch wta df-3an wps wth i3wet df-3an
      3imtr4i $.
      $( [8-Apr-1994] $)
  $}

  ${
    $v et $. $( Greek eta $)
    b3wet $f wff et $.
    bi3.1 $e |- ( ph <-> ps ) $.
    bi3.2 $e |- ( ch <-> th ) $.
    bi3.3 $e |- ( ta <-> et ) $.
    $( Join 3 biconditionals with conjunction. $)
    3anbi123i $p |- ( ( ph /\ ch /\ ta ) <-> ( ps /\ th /\ et ) ) $=
      wph wch wa wta wa wps wth wa b3wet wa wph wch wta w3a wps wth b3wet w3a
      wph wch wa wps wth wa wta b3wet wph wps wch wth bi3.1 bi3.2 anbi12i bi3.3
      anbi12i wph wch wta df-3an wps wth b3wet df-3an 3bitr4i $.
      $( [21-Apr-1994] $)

    $( Join 3 biconditionals with disjunction. $)
    3orbi123i $p |- ( ( ph \/ ch \/ ta ) <-> ( ps \/ th \/ et ) ) $=
      wph wch wo wta wo wps wth wo b3wet wo wph wch wta w3o wps wth b3wet w3o
      wph wch wo wps wth wo wta b3wet wph wps wch wth bi3.1 bi3.2 orbi12i bi3.3
      orbi12i wph wch wta df-3or wps wth b3wet df-3or 3bitr4i $.
      $( [17-May-1994] $)
  $}

  ${
    3anbi1i.1 $e |- ( ph <-> ps ) $.
    $( Inference adding two conjuncts to each side of a biconditional. $)
    3anbi1i $p |- ( ( ph /\ ch /\ th ) <-> ( ps /\ ch /\ th ) ) $=
      wph wps wch wch wth wth 3anbi1i.1 wch biid wth biid 3anbi123i $.
      $( [8-Sep-2006] $) $( [8-Sep-2006] $)

    $( Inference adding two conjuncts to each side of a biconditional. $)
    3anbi2i $p |- ( ( ch /\ ph /\ th ) <-> ( ch /\ ps /\ th ) ) $=
      wch wch wph wps wth wth wch biid 3anbi1i.1 wth biid 3anbi123i $.
      $( [5-Oct-2006] $) $( [8-Sep-2006] $)

    $( Inference adding two conjuncts to each side of a biconditional. $)
    3anbi3i $p |- ( ( ch /\ th /\ ph ) <-> ( ch /\ th /\ ps ) ) $=
      wch wch wth wth wph wps wch biid wth biid 3anbi1i.1 3anbi123i $.
      $( [18-Oct-2006] $) $( [8-Sep-2006] $)
  $}

  ${
    3imp.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Importation inference. $)
    3imp $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch w3a wph wps wa wch wa wth wph wps wch df-3an wph wps wch wth
      3imp.1 imp31 sylbi $.
      $( [8-Apr-1994] $)
  $}

  ${
    3impa.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Importation from double to triple conjunction. $)
    3impa $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth 3impa.1 exp31 3imp $.
      $( [20-Aug-1995] $)
  $}

  ${
    3impb.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Importation from double to triple conjunction. $)
    3impb $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth 3impb.1 exp32 3imp $.
      $( [20-Aug-1995] $)
  $}

  ${
    3impia.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Importation to triple conjunction. $)
    3impia $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth wi 3impia.1 ex 3imp $.
      $( [13-Jun-2006] $) $( [13-Jun-2006] $)
  $}

  ${
    3impib.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Importation to triple conjunction. $)
    3impib $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth 3impib.1 exp3a 3imp $.
      $( [15-Jun-2006] $) $( [13-Jun-2006] $)
  $}

  ${
    3exp.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Exportation inference. $)
    3exp $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      wph wps wch wth wph wps wa wch wa wph wps wch w3a wth wph wps wch df-3an
      3exp.1 sylbir exp31 $.
      $( [30-May-1994] $)

    $( Exportation from triple to double conjunction. $)
    3expa $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth 3exp.1 3exp imp31 $.
      $( [20-Aug-1995] $)

    $( Exportation from triple to double conjunction. $)
    3expb $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      wph wps wch wth wph wps wch wth 3exp.1 3exp imp32 $.
      $( [20-Aug-1995] $)

    $( Exportation from triple conjunction. $)
    3expia $p |- ( ( ph /\ ps ) -> ( ch -> th ) ) $=
      wph wps wch wth wi wph wps wch wth 3exp.1 3exp imp $.
      $( [19-May-2007] $) $( [19-May-2007] $)

    $( Exportation from triple conjunction. $)
    3expib $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      wph wps wch wth wph wps wch wth 3exp.1 3exp imp3a $.
      $( [20-May-2007] $) $( [19-May-2007] $)

    $( Commutation in antecedent.  Swap 1st and 3rd. $)
    3com12 $p |- ( ( ps /\ ph /\ ch ) -> th ) $=
      wps wph wch wth wph wps wch wth wi wph wps wch wth 3exp.1 3exp com12 3imp
      $.
      $( [28-Jan-1996] $)

    $( Commutation in antecedent.  Swap 1st and 3rd. $)
    3com13 $p |- ( ( ch /\ ps /\ ph ) -> th ) $=
      wch wps wph w3a wph wps wch w3a wth wch wps wph 3anrev 3exp.1 sylbi $.
      $( [28-Jan-1996] $)

    $( Commutation in antecedent.  Swap 2nd and 3rd. $)
    3com23 $p |- ( ( ph /\ ch /\ ps ) -> th ) $=
      wph wch wps wth wph wps wch wth wph wps wch wth 3exp.1 3exp com23 3imp $.
      $( [28-Jan-1996] $)

    $( Commutation in antecedent.  Rotate left. $)
    3coml $p |- ( ( ps /\ ch /\ ph ) -> th ) $=
      wph wch wps wth wph wps wch wth 3exp.1 3com23 3com13 $.
      $( [28-Jan-1996] $)

    $( Commutation in antecedent.  Rotate right. $)
    3comr $p |- ( ( ch /\ ph /\ ps ) -> th ) $=
      wps wch wph wth wph wps wch wth 3exp.1 3coml 3coml $.
      $( [28-Jan-1996] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant3r1 $p |- ( ( ph /\ ( ta /\ ps /\ ch ) ) -> th ) $=
      wph wps wch wth wta wph wps wch wth 3exp.1 3expb 3adantr1 $.
      $( [16-Feb-2008] $) $( [16-Feb-2008] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant3r2 $p |- ( ( ph /\ ( ps /\ ta /\ ch ) ) -> th ) $=
      wph wps wch wth wta wph wps wch wth 3exp.1 3expb 3adantr2 $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant3r3 $p |- ( ( ph /\ ( ps /\ ch /\ ta ) ) -> th ) $=
      wph wps wch wth wta wph wps wch wth 3exp.1 3expb 3adantr3 $.
      $( [18-Feb-2008] $) $( [18-Feb-2008] $)
  $}

  ${
    3an1rs.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( Swap conjuncts. $)
    3an1rs $p |- ( ( ( ph /\ ps /\ th ) /\ ch ) -> ta ) $=
      wph wps wth w3a wch wta wph wps wth wch wta wi wph wps wch wth wta wph
      wps wch wth wta wi wph wps wch w3a wth wta 3an1rs.1 ex 3exp com34 3imp
      imp $.
      $( [3-Apr-2008] $) $( [16-Dec-2007] $)
  $}

  ${
    3imp1.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $.
    $( Importation to left triple conjunction. $)
    3imp1 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $=
      wph wps wch w3a wth wta wph wps wch wth wta wi 3imp1.1 3imp imp $.
      $( [26-Feb-2005] $) $( [24-Feb-2005] $)

    $( Importation deduction for triple conjunction. $)
    3impd $p |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $=
      wps wch wth w3a wph wta wps wch wth wph wta wi wph wps wch wth wta
      3imp1.1 com4l 3imp com12 $.
      $( [28-Oct-2006] $) $( [26-Oct-2006] $)

    $( Importation to right triple conjunction. $)
    3imp2 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $=
      wph wps wch wth w3a wta wph wps wch wth wta 3imp1.1 3impd imp $.
      $( [28-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  ${
    3exp1.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( Exportation from left triple conjunction. $)
    3exp1 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wi wph wps wch w3a wth wta 3exp1.1 ex 3exp $.
      $( [26-Feb-2005] $) $( [24-Feb-2005] $)
  $}

  ${
    3expd.1 $e |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $.
    $( Exportation deduction for triple conjunction. $)
    3expd $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wps wch wth wph wta wps wch wth wph wta wi wph wps wch wth w3a wta
      3expd.1 com12 3exp com4r $.
      $( [27-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  ${
    3exp2.1 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( Exportation from right triple conjunction. $)
    3exp2 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wth wta wph wps wch wth w3a wta 3exp2.1 ex 3expd $.
      $( [28-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  ${
    3adant1l.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding a conjunct to antecedent. $)
    3adant1l $p |- ( ( ( ta /\ ph ) /\ ps /\ ch ) -> th ) $=
      wta wph wa wps wch wth wph wps wch wa wth wta wph wps wch wth 3adant1l.1
      3expb adantll 3impb $.
      $( [12-Jan-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant1r $p |- ( ( ( ph /\ ta ) /\ ps /\ ch ) -> th ) $=
      wph wta wa wps wch wth wph wps wch wa wth wta wph wps wch wth 3adant1l.1
      3expb adantlr 3impb $.
      $( [17-Jan-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant2l $p |- ( ( ph /\ ( ta /\ ps ) /\ ch ) -> th ) $=
      wta wps wa wph wch wth wps wph wch wth wta wph wps wch wth 3adant1l.1
      3com12 3adant1l 3com12 $.
      $( [22-Feb-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant2r $p |- ( ( ph /\ ( ps /\ ta ) /\ ch ) -> th ) $=
      wps wta wa wph wch wth wps wph wch wth wta wph wps wch wth 3adant1l.1
      3com12 3adant1r 3com12 $.
      $( [23-Jan-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant3l $p |- ( ( ph /\ ps /\ ( ta /\ ch ) ) -> th ) $=
      wta wch wa wps wph wth wch wps wph wth wta wph wps wch wth 3adant1l.1
      3com13 3adant1l 3com13 $.
      $( [5-Feb-2006] $) $( [8-Jan-2006] $)

    $( Deduction adding a conjunct to antecedent. $)
    3adant3r $p |- ( ( ph /\ ps /\ ( ch /\ ta ) ) -> th ) $=
      wch wta wa wps wph wth wch wps wph wth wta wph wps wch wth 3adant1l.1
      3com13 3adant1r 3com13 $.
      $( [27-Jan-2006] $) $( [8-Jan-2006] $)
  $}

  ${
    syl3anc.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    syl3anc.2 $e |- ( ta -> ph ) $.
    syl3anc.3 $e |- ( ta -> ps ) $.
    syl3anc.4 $e |- ( ta -> ch ) $.
    $( A syllogism inference combined with contraction. $)
    syl3anc $p |- ( ta -> th ) $=
      wta wph wps wch w3a wth wta wph wps wch syl3anc.2 syl3anc.3 syl3anc.4
      3jca syl3anc.1 syl $.
      $( [2-Jan-2005] $) $( [1-Jan-2005] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    syl3an.we $f wff et $.
    syl3an.wz $f wff ze $.
    syl3an.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    ${
      syl3an1.2 $e |- ( ta -> ph ) $.
      $( A syllogism inference. $)
      syl3an1 $p |- ( ( ta /\ ps /\ ch ) -> th ) $=
        wta wps wch wth wph wps wch wa wth wta wph wps wch wth syl3an.1 3expb
        syl3an1.2 sylan 3impb $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an2.2 $e |- ( ta -> ps ) $.
      $( A syllogism inference. $)
      syl3an2 $p |- ( ( ph /\ ta /\ ch ) -> th ) $=
        wph wta wch wth wph wps wch wth wi wta wph wps wch wth syl3an.1 3exp
        syl3an2.2 syl5 3imp $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an3.2 $e |- ( ta -> ch ) $.
      $( A syllogism inference. $)
      syl3an3 $p |- ( ( ph /\ ps /\ ta ) -> th ) $=
        wph wps wta wth wph wps wch wth wta wph wps wch wth syl3an.1 3exp
        syl3an3.2 syl7 3imp $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an1b.2 $e |- ( ta <-> ph ) $.
      $( A syllogism inference. $)
      syl3an1b $p |- ( ( ta /\ ps /\ ch ) -> th ) $=
        wph wps wch wth wta syl3an.1 wta wph syl3an1b.2 biimpi syl3an1 $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an2b.2 $e |- ( ta <-> ps ) $.
      $( A syllogism inference. $)
      syl3an2b $p |- ( ( ph /\ ta /\ ch ) -> th ) $=
        wph wps wch wth wta syl3an.1 wta wps syl3an2b.2 biimpi syl3an2 $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an3b.2 $e |- ( ta <-> ch ) $.
      $( A syllogism inference. $)
      syl3an3b $p |- ( ( ph /\ ps /\ ta ) -> th ) $=
        wph wps wch wth wta syl3an.1 wta wch syl3an3b.2 biimpi syl3an3 $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an1br.2 $e |- ( ph <-> ta ) $.
      $( A syllogism inference. $)
      syl3an1br $p |- ( ( ta /\ ps /\ ch ) -> th ) $=
        wph wps wch wth wta syl3an.1 wph wta syl3an1br.2 biimpri syl3an1 $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an2br.2 $e |- ( ps <-> ta ) $.
      $( A syllogism inference. $)
      syl3an2br $p |- ( ( ph /\ ta /\ ch ) -> th ) $=
        wph wps wch wth wta syl3an.1 wps wta syl3an2br.2 biimpri syl3an2 $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an3br.2 $e |- ( ch <-> ta ) $.
      $( A syllogism inference. $)
      syl3an3br $p |- ( ( ph /\ ps /\ ta ) -> th ) $=
        wph wps wch wth wta syl3an.1 wch wta syl3an3br.2 biimpri syl3an3 $.
        $( [22-Aug-1995] $)
    $}

    ${
      syl3an.2 $e |- ( ta -> ph ) $.
      syl3an.3 $e |- ( et -> ps ) $.
      syl3an.4 $e |- ( ze -> ch ) $.
      $( A triple syllogism inference. $)
      syl3an $p |- ( ( ta /\ et /\ ze ) -> th ) $=
        wta syl3an.we syl3an.wz w3a wph wps wch w3a wth wta wph syl3an.we wps
        syl3an.wz wch syl3an.2 syl3an.3 syl3an.4 3anim123i syl3an.1 syl $.
        $( [14-May-2004] $) $( [13-May-2004] $)
    $}

    ${
      syl3anb.2 $e |- ( ta <-> ph ) $.
      syl3anb.3 $e |- ( et <-> ps ) $.
      syl3anb.4 $e |- ( ze <-> ch ) $.
      $( A triple syllogism inference. $)
      syl3anb $p |- ( ( ta /\ et /\ ze ) -> th ) $=
        wta syl3an.we syl3an.wz w3a wph wps wch w3a wth wta wph syl3an.we wps
        syl3an.wz wch syl3anb.2 syl3anb.3 syl3anb.4 3anbi123i syl3an.1 sylbi $.
        $( [20-Oct-2005] $) $( [15-Oct-2005] $)
    $}

    ${
      syld3an3.2 $e |- ( ( ph /\ ps /\ ta ) -> ch ) $.
      $( A syllogism inference. $)
      syld3an3 $p |- ( ( ph /\ ps /\ ta ) -> th ) $=
        wph wps wch wth wph wps wta w3a syl3an.1 wph wps wta 3simp1 wph wps wta
        3simp2 syld3an3.2 syl3anc $.
        $( [23-May-2007] $) $( [20-May-2007] $)
    $}

    ${
      syld3an1.2 $e |- ( ( ta /\ ps /\ ch ) -> ph ) $.
      $( A syllogism inference. $)
      syld3an1 $p |- ( ( ta /\ ps /\ ch ) -> th ) $=
        wch wps wta wth wch wps wph wth wta wph wps wch wth syl3an.1 3com13 wta
        wps wch wph syld3an1.2 3com13 syld3an3 3com13 $.
        $( [14-Jul-2008] $) $( [7-Jul-2008] $)
    $}

    ${
      syld3an2.2 $e |- ( ( ph /\ ta /\ ch ) -> ps ) $.
      $( A syllogism inference. $)
      syld3an2 $p |- ( ( ph /\ ta /\ ch ) -> th ) $=
        wph wch wta wth wph wch wps wth wta wph wps wch wth syl3an.1 3com23 wph
        wta wch wps syld3an2.2 3com23 syld3an3 3com23 $.
        $( [24-May-2007] $) $( [20-May-2007] $)
    $}
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    $v si $. $( Greek sigma $)
    syl3anl1.we $f wff et $.
    syl3anl1.wz $f wff ze $.
    syl3anl1.ws $f wff si $.
    syl3anl1.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    ${
      syl3anl1.2 $e |- ( et -> ph ) $.
      $( A syllogism inference. $)
      syl3anl1 $p |- ( ( ( et /\ ps /\ ch ) /\ th ) -> ta ) $=
        syl3anl1.we wps wch w3a wth wta wph wps wch wth wta wi syl3anl1.we wph
        wps wch w3a wth wta syl3anl1.1 ex syl3anl1.2 syl3an1 imp $.
        $( [28-Apr-2005] $) $( [24-Feb-2005] $)
    $}

    ${
      syl3anl2.2 $e |- ( et -> ps ) $.
      $( A syllogism inference. $)
      syl3anl2 $p |- ( ( ( ph /\ et /\ ch ) /\ th ) -> ta ) $=
        wph syl3anl1.we wch w3a wth wta wph wps wch wth wta wi syl3anl1.we wph
        wps wch w3a wth wta syl3anl1.1 ex syl3anl2.2 syl3an2 imp $.
        $( [26-Feb-2005] $) $( [24-Feb-2005] $)
    $}

    ${
      syl3anl3.2 $e |- ( et -> ch ) $.
      $( A syllogism inference. $)
      syl3anl3 $p |- ( ( ( ph /\ ps /\ et ) /\ th ) -> ta ) $=
        wph wps syl3anl1.we w3a wth wta wph wps wch wth wta wi syl3anl1.we wph
        wps wch w3a wth wta syl3anl1.1 ex syl3anl3.2 syl3an3 imp $.
        $( [27-Jun-2005] $) $( [24-Feb-2005] $)
    $}

    ${
      syl3anl.2 $e |- ( et -> ph ) $.
      syl3anl.3 $e |- ( ze -> ps ) $.
      syl3anl.4 $e |- ( si -> ch ) $.
      $( A triple syllogism inference. $)
      syl3anl $p |- ( ( ( et /\ ze /\ si ) /\ th ) -> ta ) $=
        wph wps wch w3a wth wta syl3anl1.we syl3anl1.wz syl3anl1.ws w3a
        syl3anl1.1 syl3anl1.we wph syl3anl1.wz wps syl3anl1.ws wch syl3anl.2
        syl3anl.3 syl3anl.4 3anim123i sylan $.
        $( [24-Dec-2006] $) $( [24-Dec-2006] $)
    $}
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    $v si $. $( Greek sigma $)
    syl3anr1.we $f wff et $.
    syl3anr1.1 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    ${
      syl3anr1.2 $e |- ( et -> ps ) $.
      $( A syllogism inference. $)
      syl3anr1 $p |- ( ( ph /\ ( et /\ ch /\ th ) ) -> ta ) $=
        syl3anr1.we wch wth w3a wph wta wps wch wth wph wta syl3anr1.we wph wps
        wch wth w3a wta syl3anr1.1 ancoms syl3anr1.2 syl3anl1 ancoms $.
        $( [16-Aug-2007] $) $( [31-Jul-2007] $)
    $}

    ${
      syl3anr2.2 $e |- ( et -> ch ) $.
      $( A syllogism inference. $)
      syl3anr2 $p |- ( ( ph /\ ( ps /\ et /\ th ) ) -> ta ) $=
        wps syl3anr1.we wth w3a wph wta wps wch wth wph wta syl3anr1.we wph wps
        wch wth w3a wta syl3anr1.1 ancoms syl3anr2.2 syl3anl2 ancoms $.
        $( [6-Aug-2007] $) $( [1-Aug-2007] $)
    $}

    ${
      syl3anr3.2 $e |- ( et -> th ) $.
      $( A syllogism inference. $)
      syl3anr3 $p |- ( ( ph /\ ( ps /\ ch /\ et ) ) -> ta ) $=
        wps wch syl3anr1.we w3a wph wta wps wch wth wph wta syl3anr1.we wph wps
        wch wth w3a wta syl3anr1.1 ancoms syl3anr3.2 syl3anl3 ancoms $.
        $( [23-Aug-2007] $) $( [23-Aug-2007] $)
    $}
  $}

  ${
    3impdi.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) ) -> th ) $.
    $( Importation inference (undistribute conjunction). $)
    3impdi $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wth 3impdi.1 anandis 3impb $.
      $( [14-Aug-1995] $)
  $}

  ${
    3impdir.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ ps ) ) -> th ) $.
    $( Importation inference (undistribute conjunction). $)
    3impdir $p |- ( ( ph /\ ch /\ ps ) -> th ) $=
      wph wch wps wth wph wch wps wth 3impdir.1 anandirs 3impa $.
      $( [20-Aug-1995] $)
  $}

  ${
    3anidm12.1 $e |- ( ( ph /\ ph /\ ps ) -> ch ) $.
    $( Inference from idempotent law for conjunction. $)
    3anidm12 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wch wi wph wph wps wch 3anidm12.1 3exp pm2.43i imp $.
      $( [7-Mar-2008] $) $( [7-Mar-2008] $)
  $}

  ${
    3anidm13.1 $e |- ( ( ph /\ ps /\ ph ) -> ch ) $.
    $( Inference from idempotent law for conjunction. $)
    3anidm13 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wph wch 3anidm13.1 3com23 3anidm12 $.
      $( [10-Mar-2008] $) $( [7-Mar-2008] $)
  $}

  ${
    3anidm23.1 $e |- ( ( ph /\ ps /\ ps ) -> ch ) $.
    $( Inference from idempotent law for conjunction. $)
    3anidm23 $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wch wph wps wps wch 3anidm23.1 3exp pm2.43d imp $.
      $( [1-Feb-2007] $) $( [1-Feb-2007] $)
  $}

  ${
    3ori.1 $e |- ( ph \/ ps \/ ch ) $.
    $( Infer implication from triple disjunction. $)
    3ori $p |- ( ( -. ph /\ -. ps ) -> ch ) $=
      wph wn wps wn wa wph wps wo wn wch wph wps ioran wph wps wo wch wph wps
      wch w3o wph wps wo wch wo 3ori.1 wph wps wch df-3or mpbi ori sylbir $.
      $( [28-Sep-2006] $) $( [26-Sep-2006] $)
  $}

  $( Disjunction of 3 antecedents. $)
  3jao $p |- ( ( ( ph -> ps ) /\ ( ch -> ps ) /\ ( th -> ps ) ) ->
              ( ( ph \/ ch \/ th ) -> ps ) ) $=
    wph wps wi wch wps wi wth wps wi w3a wph wch wo wth wo wps wph wch wth w3o
    wph wps wi wch wps wi wth wps wi wph wch wo wth wo wps wi wph wps wi wch
    wps wi wph wch wo wps wi wth wps wi wph wch wo wth wo wps wi wi wph wps wch
    jao wph wch wo wps wth jao syl6 3imp wph wch wth df-3or syl5ib $.
    $( [8-Apr-1994] $)

  ${
    3jaoi.1 $e |- ( ph -> ps ) $.
    3jaoi.2 $e |- ( ch -> ps ) $.
    3jaoi.3 $e |- ( th -> ps ) $.
    $( Disjunction of 3 antecedents (inference). $)
    3jaoi $p |- ( ( ph \/ ch \/ th ) -> ps ) $=
      wph wps wi wch wps wi wth wps wi w3a wph wch wth w3o wps wi wph wps wi
      wch wps wi wth wps wi 3jaoi.1 3jaoi.2 3jaoi.3 3pm3.2i wph wps wch wth
      3jao ax-mp $.
      $( [12-Sep-1995] $)
  $}

  ${
    3jaod.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3jaod.2 $e |- ( ph -> ( th -> ch ) ) $.
    3jaod.3 $e |- ( ph -> ( ta -> ch ) ) $.
    $( Disjunction of 3 antecedents (deduction). $)
    3jaod $p |- ( ph -> ( ( ps \/ th \/ ta ) -> ch ) ) $=
      wps wch wi wth wch wi wta wch wi wps wth wta w3o wch wi wph wps wch wth
      wta 3jao 3jaod.1 3jaod.2 3jaod.3 syl3anc $.
      $( [16-Oct-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    3jaoian.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    3jaoian.2 $e |- ( ( th /\ ps ) -> ch ) $.
    3jaoian.3 $e |- ( ( ta /\ ps ) -> ch ) $.
    $( Disjunction of 3 antecedents (inference). $)
    3jaoian $p |- ( ( ( ph \/ th \/ ta ) /\ ps ) -> ch ) $=
      wph wth wta w3o wps wch wph wps wch wi wth wta wph wps wch 3jaoian.1 ex
      wth wps wch 3jaoian.2 ex wta wps wch 3jaoian.3 ex 3jaoi imp $.
      $( [17-Oct-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    3jaodan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    3jaodan.2 $e |- ( ( ph /\ th ) -> ch ) $.
    3jaodan.3 $e |- ( ( ph /\ ta ) -> ch ) $.
    $( Disjunction of 3 antecedents (deduction). $)
    3jaodan $p |- ( ( ph /\ ( ps \/ th \/ ta ) ) -> ch ) $=
      wph wps wth wta w3o wch wph wps wch wth wta wph wps wch 3jaodan.1 ex wph
      wth wch 3jaodan.2 ex wph wta wch 3jaodan.3 ex 3jaod imp $.
      $( [21-Oct-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    syl3an9b.we $f wff et $.
    syl3an9b.wz $f wff ze $.
    syl3an9b.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl3an9b.2 $e |- ( th -> ( ch <-> ta ) ) $.
    syl3an9b.3 $e |- ( et -> ( ta <-> ze ) ) $.
    $( Nested syllogism inference conjoining 3 dissimilar antecedents. $)
    syl3an9b $p |- ( ( ph /\ th /\ et ) -> ( ps <-> ze ) ) $=
      wph wth syl3an9b.we wps syl3an9b.wz wb wph wth wa wps wta syl3an9b.we
      syl3an9b.wz wph wps wch wth wta syl3an9b.1 syl3an9b.2 sylan9bb syl3an9b.3
      sylan9bb 3impa $.
      $( [1-May-1995] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    bi3d.we $f wff et $.
    bi3d.wz $f wff ze $.
    bi3d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bi3d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    bi3d.3 $e |- ( ph -> ( et <-> ze ) ) $.
    $( Deduction joining 3 equivalences to form equivalence of disjunctions. $)
    3orbi123d $p |- ( ph -> ( ( ps \/ th \/ et ) <-> ( ch \/ ta \/ ze ) ) ) $=
      wph wps wth wo bi3d.we wo wch wta wo bi3d.wz wo wps wth bi3d.we w3o wch
      wta bi3d.wz w3o wph wps wth wo wch wta wo bi3d.we bi3d.wz wph wps wch wth
      wta bi3d.1 bi3d.2 orbi12d bi3d.3 orbi12d wps wth bi3d.we df-3or wch wta
      bi3d.wz df-3or 3bitr4g $.
      $( [20-Apr-1994] $)

    $( Deduction joining 3 equivalences to form equivalence of conjunctions. $)
    3anbi123d $p |- ( ph -> ( ( ps /\ th /\ et ) <-> ( ch /\ ta /\ ze ) ) ) $=
      wph wps wth wa bi3d.we wa wch wta wa bi3d.wz wa wps wth bi3d.we w3a wch
      wta bi3d.wz w3a wph wps wth wa wch wta wa bi3d.we bi3d.wz wph wps wch wth
      wta bi3d.1 bi3d.2 anbi12d bi3d.3 anbi12d wps wth bi3d.we df-3an wch wta
      bi3d.wz df-3an 3bitr4g $.
      $( [22-Apr-1994] $)
  $}

  ${
    $v et $. $( Greek eta $)
    3anbi12d.we $f wff et $.
    3anbi12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3anbi12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction conjoining and adding a conjunct to equivalences. $)
    3anbi12d $p |- ( ph -> ( ( ps /\ th /\ et ) <-> ( ch /\ ta /\ et ) ) ) $=
      wph wps wch wth wta 3anbi12d.we 3anbi12d.we 3anbi12d.1 3anbi12d.2 wph
      3anbi12d.we biidd 3anbi123d $.
      $( [8-Sep-2006] $) $( [8-Sep-2006] $)

    $( Deduction conjoining and adding a conjunct to equivalences. $)
    3anbi13d $p |- ( ph -> ( ( ps /\ et /\ th ) <-> ( ch /\ et /\ ta ) ) ) $=
      wph wps wch 3anbi12d.we 3anbi12d.we wth wta 3anbi12d.1 wph 3anbi12d.we
      biidd 3anbi12d.2 3anbi123d $.
      $( [9-Sep-2006] $) $( [8-Sep-2006] $)

    $( Deduction conjoining and adding a conjunct to equivalences. $)
    3anbi23d $p |- ( ph -> ( ( et /\ ps /\ th ) <-> ( et /\ ch /\ ta ) ) ) $=
      wph 3anbi12d.we 3anbi12d.we wps wch wth wta wph 3anbi12d.we biidd
      3anbi12d.1 3anbi12d.2 3anbi123d $.
      $( [10-Sep-2006] $) $( [8-Sep-2006] $)
  $}

  ${
    3anbi1d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction adding conjuncts to an equivalence. $)
    3anbi1d $p |- ( ph -> ( ( ps /\ th /\ ta ) <-> ( ch /\ th /\ ta ) ) ) $=
      wph wps wch wth wth wta 3anbi1d.1 wph wth biidd 3anbi12d $.
      $( [9-Sep-2006] $) $( [8-Sep-2006] $)

    $( Deduction adding conjuncts to an equivalence. $)
    3anbi2d $p |- ( ph -> ( ( th /\ ps /\ ta ) <-> ( th /\ ch /\ ta ) ) ) $=
      wph wth wth wps wch wta wph wth biidd 3anbi1d.1 3anbi12d $.
      $( [2-Nov-2006] $) $( [8-Sep-2006] $)

    $( Deduction adding conjuncts to an equivalence. $)
    3anbi3d $p |- ( ph -> ( ( th /\ ta /\ ps ) <-> ( th /\ ta /\ ch ) ) ) $=
      wph wth wth wps wch wta wph wth biidd 3anbi1d.1 3anbi13d $.
      $( [11-Sep-2006] $) $( [8-Sep-2006] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    3anim123d.we $f wff et $.
    3anim123d.wz $f wff ze $.
    3anim123d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3anim123d.2 $e |- ( ph -> ( th -> ta ) ) $.
    3anim123d.3 $e |- ( ph -> ( et -> ze ) ) $.
    $( Deduction joining 3 implications to form implication of conjunctions. $)
    3anim123d $p |- ( ph -> ( ( ps /\ th /\ et ) -> ( ch /\ ta /\ ze ) ) ) $=
      wph wps wth wa 3anim123d.we wa wch wta wa 3anim123d.wz wa wps wth
      3anim123d.we w3a wch wta 3anim123d.wz w3a wph wps wth wa wch wta wa
      3anim123d.we 3anim123d.wz wph wps wch wth wta 3anim123d.1 3anim123d.2
      anim12d 3anim123d.3 anim12d wps wth 3anim123d.we df-3an wch wta
      3anim123d.wz df-3an 3imtr4g $.
      $( [30-Jun-2005] $) $( [24-Feb-2005] $)

    $( Deduction joining 3 implications to form implication of disjunctions. $)
    3orim123d $p |- ( ph -> ( ( ps \/ th \/ et ) -> ( ch \/ ta \/ ze ) ) ) $=
      wph wps wth wo 3anim123d.we wo wch wta wo 3anim123d.wz wo wps wth
      3anim123d.we w3o wch wta 3anim123d.wz w3o wph wps wth wo wch wta wo
      3anim123d.we 3anim123d.wz wph wps wch wth wta 3anim123d.1 3anim123d.2
      orim12d 3anim123d.3 orim12d wps wth 3anim123d.we df-3or wch wta
      3anim123d.wz df-3or 3imtr4g $.
      $( [4-Apr-1997] $)
  $}

  ${
    $v et $. $( Greek eta $)
    an6wet $f wff et $.
    $( Rearrangement of 6 conjuncts. $)
    an6 $p |- ( ( ( ph /\ ps /\ ch ) /\ ( th /\ ta /\ et ) ) <->
              ( ( ph /\ th ) /\ ( ps /\ ta ) /\ ( ch /\ et ) ) ) $=
      wph wps wch w3a wth wta an6wet w3a wa wph wth wa wps wta wa wa wch an6wet
      wa wa wph wth wa wps wta wa wch an6wet wa w3a wph wps wch w3a wth wta
      an6wet w3a wa wph wps wa wch wa wth wta wa an6wet wa wa wph wps wa wth
      wta wa wa wch an6wet wa wa wph wth wa wps wta wa wa wch an6wet wa wa wph
      wps wch w3a wph wps wa wch wa wth wta an6wet w3a wth wta wa an6wet wa wph
      wps wch df-3an wth wta an6wet df-3an anbi12i wph wps wa wch wth wta wa
      an6wet an4 wph wps wa wth wta wa wa wph wth wa wps wta wa wa wch an6wet
      wa wph wps wth wta an4 anbi1i 3bitri wph wth wa wps wta wa wch an6wet wa
      df-3an bitr4i $.
      $( [13-Mar-1995] $)
  $}

  ${
    mp3an1.1 $e |- ph $.
    mp3an1.2 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an1 $p |- ( ( ps /\ ch ) -> th ) $=
      wph wps wch wa wth mp3an1.1 wph wps wch wth mp3an1.2 3expb mpan $.
      $( [21-Nov-1994] $)
  $}

  ${
    mp3an2.1 $e |- ps $.
    mp3an2.2 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an2 $p |- ( ( ph /\ ch ) -> th ) $=
      wph wps wch wth mp3an2.1 wph wps wch wth mp3an2.2 3expa mpanl2 $.
      $( [21-Nov-1994] $)
  $}

  ${
    mp3an3.1 $e |- ch $.
    mp3an3.2 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an3 $p |- ( ( ph /\ ps ) -> th ) $=
      wph wps wa wch wth mp3an3.1 wph wps wch wth mp3an3.2 3expa mpan2 $.
      $( [21-Nov-1994] $)
  $}

  ${
    mp3an12.1 $e |- ph $.
    mp3an12.2 $e |- ps $.
    mp3an12.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an12 $p |- ( ch -> th ) $=
      wps wch wth mp3an12.2 wph wps wch wth mp3an12.1 mp3an12.3 mp3an1 mpan $.
      $( [15-Jul-2005] $) $( [13-Jul-2005] $)
  $}

  ${
    mp3an13.1 $e |- ph $.
    mp3an13.2 $e |- ch $.
    mp3an13.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an13 $p |- ( ps -> th ) $=
      wph wps wth mp3an13.1 wph wps wch wth mp3an13.2 mp3an13.3 mp3an3 mpan $.
      $( [16-Jul-2005] $) $( [14-Jul-2005] $)
  $}

  ${
    mp3an23.1 $e |- ps $.
    mp3an23.2 $e |- ch $.
    mp3an23.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an23 $p |- ( ph -> th ) $=
      wph wps wth mp3an23.1 wph wps wch wth mp3an23.2 mp3an23.3 mp3an3 mpan2 $.
      $( [16-Jul-2005] $) $( [14-Jul-2005] $)
  $}

  ${
    mp3an1i.1 $e |- ps $.
    mp3an1i.2 $e |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $.
    $( An inference based on modus ponens. $)
    mp3an1i $p |- ( ph -> ( ( ch /\ th ) -> ta ) ) $=
      wch wth wa wph wta wps wch wth wph wta wi mp3an1i.1 wph wps wch wth w3a
      wta mp3an1i.2 com12 mp3an1 com12 $.
      $( [9-Jul-2005] $) $( [5-Jul-2005] $)
  $}

  ${
    mp3anl1.1 $e |- ph $.
    mp3anl1.2 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mp3anl1 $p |- ( ( ( ps /\ ch ) /\ th ) -> ta ) $=
      wps wch wa wth wta wph wps wch wth wta wi mp3anl1.1 wph wps wch w3a wth
      wta mp3anl1.2 ex mp3an1 imp $.
      $( [25-Feb-2005] $) $( [24-Feb-2005] $)
  $}

  ${
    mp3anl2.1 $e |- ps $.
    mp3anl2.2 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mp3anl2 $p |- ( ( ( ph /\ ch ) /\ th ) -> ta ) $=
      wph wch wa wth wta wph wps wch wth wta wi mp3anl2.1 wph wps wch w3a wth
      wta mp3anl2.2 ex mp3an2 imp $.
      $( [26-Feb-2005] $) $( [24-Feb-2005] $)
  $}

  ${
    mp3anl3.1 $e |- ch $.
    mp3anl3.2 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mp3anl3 $p |- ( ( ( ph /\ ps ) /\ th ) -> ta ) $=
      wph wps wa wth wta wph wps wch wth wta wi mp3anl3.1 wph wps wch w3a wth
      wta mp3anl3.2 ex mp3an3 imp $.
      $( [25-Feb-2005] $) $( [24-Feb-2005] $)
  $}

  ${
    mp3anr1.1 $e |- ps $.
    mp3anr1.2 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mp3anr1 $p |- ( ( ph /\ ( ch /\ th ) ) -> ta ) $=
      wch wth wa wph wta wps wch wth wph wta mp3anr1.1 wph wps wch wth w3a wta
      mp3anr1.2 ancoms mp3anl1 ancoms $.
      $( [6-Nov-2006] $) $( [4-Nov-2006] $)
  $}

  ${
    mp3anr2.1 $e |- ch $.
    mp3anr2.2 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mp3anr2 $p |- ( ( ph /\ ( ps /\ th ) ) -> ta ) $=
      wps wth wa wph wta wps wch wth wph wta mp3anr2.1 wph wps wch wth w3a wta
      mp3anr2.2 ancoms mp3anl2 ancoms $.
      $( [25-Nov-2006] $) $( [24-Nov-2006] $)
  $}

  ${
    mp3anr3.1 $e |- th $.
    mp3anr3.2 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens. $)
    mp3anr3 $p |- ( ( ph /\ ( ps /\ ch ) ) -> ta ) $=
      wps wch wa wph wta wps wch wth wph wta mp3anr3.1 wph wps wch wth w3a wta
      mp3anr3.2 ancoms mp3anl3 ancoms $.
      $( [19-Oct-2007] $) $( [19-Oct-2007] $)
  $}

  ${
    mp3an.1 $e |- ph $.
    mp3an.2 $e |- ps $.
    mp3an.3 $e |- ch $.
    mp3an.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mp3an $p |- th $=
      wps wch wth mp3an.2 mp3an.3 wph wps wch wth mp3an.1 mp3an.4 mp3an1 mp2an
      $.
      $( [14-May-1999] $)
  $}

  ${
    mpd3an3.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    mpd3an3.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpd3an3 $p |- ( ( ph /\ ps ) -> th ) $=
      wph wps wa wch wth mpd3an3.2 wph wps wch wth mpd3an3.3 3expa mpdan $.
      $( [12-Nov-2007] $) $( [8-Nov-2007] $)
  $}

  ${
    mpd3an23.1 $e |- ( ph -> ps ) $.
    mpd3an23.2 $e |- ( ph -> ch ) $.
    mpd3an23.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens. $)
    mpd3an23 $p |- ( ph -> th ) $=
      wph wps wch wth wph mpd3an23.3 wph id mpd3an23.1 mpd3an23.2 syl3anc $.
      $( [5-Dec-2006] $) $( [4-Dec-2006] $)
  $}

  ${
    biimp3a.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Infer implication from a logical equivalence.  Similar to ~ biimpa . $)
    biimp3a $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wa wch wth biimp3a.1 biimpa 3impa $.
      $( [6-Sep-2005] $) $( [4-Sep-2005] $)

    $( Infer implication from a logical equivalence.  Similar to ~ biimpar . $)
    biimp3ar $p |- ( ( ph /\ ps /\ th ) -> ch ) $=
      wph wps wth wch wph wps wa wch wth biimp3a.1 biimpar 3impa $.
      $( [9-Jan-2009] $) $( [2-Jan-2009] $)
  $}

  ${
    3anandis.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) /\ ( ph /\ th ) )
                      -> ta ) $.
    $( Inference that undistributes a triple conjunction in the antecedent. $)
    3anandis $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $=
      wph wps wa wph wch wa wph wth wa wta wph wps wch wth w3a wa 3anandis.1
      wps wch wth w3a wps wph wps wch wth 3simp1 anim2i wps wch wth w3a wch wph
      wps wch wth 3simp2 anim2i wps wch wth w3a wth wph wps wch wth 3simp3
      anim2i syl3anc $.
      $( [21-Apr-2007] $) $( [18-Apr-2007] $)
  $}

  ${
    3anandirs.1 $e |- ( ( ( ph /\ th ) /\ ( ps /\ th ) /\ ( ch /\ th ) )
                      -> ta ) $.
    $( Inference that undistributes a triple conjunction in the antecedent. $)
    3anandirs $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $=
      wph wth wa wps wth wa wch wth wa wta wph wps wch w3a wth wa 3anandirs.1
      wph wps wch w3a wph wth wph wps wch 3simp1 anim1i wph wps wch w3a wps wth
      wph wps wch 3simp2 anim1i wph wps wch w3a wch wth wph wps wch 3simp3
      anim1i syl3anc $.
      $( [18-Apr-2007] $) $( [25-Jul-2006] $)
  $}

  ${
    ecase23d.1 $e |- ( ph -> -. ch ) $.
    ecase23d.2 $e |- ( ph -> -. th ) $.
    ecase23d.3 $e |- ( ph -> ( ps \/ ch \/ th ) ) $.
    $( Deduction for elimination by cases. $)
    ecase23d $p |- ( ph -> ps ) $=
      wph wps wch wth wo wch wth wo wn wch wn wth wn wph wch wth ioran
      ecase23d.1 ecase23d.2 sylanbrc wph wps wch wth wo wph wps wch wth w3o wps
      wch wth wo wo ecase23d.3 wps wch wth 3orass sylib ord mt3d $.
      $( [15-Jul-2005] $) $( [22-Apr-1994] $)
  $}

  ${
    3ecase.1 $e |- ( -. ph -> th ) $.
    3ecase.2 $e |- ( -. ps -> th ) $.
    3ecase.3 $e |- ( -. ch -> th ) $.
    3ecase.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Inference for elimination by cases. $)
    3ecase $p |- th $=
      wps wch wth wph wps wch wth wi wi wph wps wch wth 3ecase.4 3exp wph wn
      wch wth wi wps wph wn wth wch 3ecase.1 a1d a1d pm2.61i 3ecase.2 3ecase.3
      pm2.61nii $.
      $( [19-Jul-2005] $) $( [13-Jul-2005] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
      Other axiomatizations of classical propositional calculus
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Derive the Lukasiewicz axioms from Meredith's sole axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Carew Meredith's sole axiom for propositional calculus.  This amazing
     formula is thought to be the shortest possible single axiom for
     propositional calculus with inference rule ~ ax-mp , where negation and
     implication are primitive.  Here we prove Meredith's axiom from ~ ax-1 ,
     ~ ax-2 , and ~ ax-3 .  Then from it we derive the Lukasiewicz axioms
     ~ luk-1 , ~ luk-2 , and ~ luk-3 .  Using these we finally re-derive our
     axioms as ~ ax1 , ~ ax2 , and ~ ax3 , thus proving the equivalence of
     all three systems.  C. A. Meredith, "Single Axioms for the Systems
     (C,N), (C,O) and (A,N) of the Two-Valued Propositional Calculus," _The
     Journal of Computing Systems_ vol. 1 (1953), pp. 155-164.  Meredith
     claimed to be close to a proof that this axiom is the shortest possible,
     but the proof was apparently never completed.

     An obscure Irish lecturer, Meredith (1904-1976) became enamored with
     logic somewhat late in life after attending talks by Lukasiewicz and
     produced many remarkable results such as this axiom.  From his obituary:
     "He did logic whenever time and opportunity presented themselves, and he
     did it on whatever materials came to hand:  in a pub, his favored pint
     of porter within reach, he would use the inside of cigarette packs to
     write proofs for logical colleagues." $)
  meredith $p |- ( ( ( ( ( ph -> ps ) -> ( -. ch -> -. th ) ) -> ch ) ->
       ta ) -> ( ( ta -> ph ) -> ( th -> ph ) ) ) $=
    wph wps wi wch wn wth wn wi wi wch wi wta wi wta wn wch wn wch wn wph wn
    wth wn wi wi wn wi wn wi wta wph wi wth wph wi wi wph wps wi wch wn wth wn
    wi wi wch wi wta wi wch wn wch wn wph wn wth wn wi wi wn wi wta wch wn wch
    wn wph wn wth wn wi wi wn wi wph wps wi wch wn wth wn wi wi wch wi wta wch
    wn wch wn wph wn wth wn wi wi wn wi wch wn wph wn wth wn wi wi wch wph wps
    wi wch wn wth wn wi wi wch wch wn wph wn wth wn wi wi ax-3 wph wps wi wch
    wn wth wn wi wi wph wn wch wn wth wn wph wn wph wps wi wch wn wth wn wi wph
    wps pm2.21 imim1i com23 syl5 imim1i con3d wta wn wch wn wch wn wph wn wth
    wn wi wi wn wi wn wi wta wph wi wph wn wth wn wi wth wph wi wta wn wch wn
    wch wn wph wn wth wn wi wi wn wi wn wi wph wn wta wn wi wph wn wth wn wi
    wta wph wi wta wn wch wn wch wn wph wn wth wn wi wi wn wi wn wi wph wn wta
    wn wth wn wph wn wta wn wch wn wch wn wph wn wth wn wi wi wn wi wn wi wta
    wn wth wn wi wph wn wch wn wch wn wph wn wth wn wi wi wn wi wn wth wn wta
    wn wch wn wch wn wph wn wth wn wi wi wn wi wn wph wn wth wn wch wn wch wn
    wph wn wth wn wi wi wph wn wth wn wi wch wn wph wn wth wn wi pm2.27 impi
    com12 imim2d com12 a2d wta wph con3 syl5 wph wth ax-3 syl6 syl $.
    $( [14-Dec-2002] $)

  $( Step 3 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (The step numbers refer to Meredith's original paper.) $)
  merlem1 $p |- ( ( ( ch -> ( -. ph -> ps ) ) -> ta ) -> ( ph -> ta ) ) $=
    wta wph wn wi wph wn wps wi wn wph wn wi wi wph wn wps wi wi wch wph wn wps
    wi wi wi wch wph wn wps wi wi wta wi wph wta wi wi wph wn wps wi wta wn wch
    wn wi wn wph wn wps wi wn wn wi wi wta wn wch wn wi wi wta wi wta wph wn wi
    wph wn wps wi wn wph wn wi wi wi wta wph wn wi wph wn wps wi wn wph wn wi
    wi wph wn wps wi wi wch wph wn wps wi wi wi wph wn wps wta wn wch wn wi wph
    wn wps wi wn wta meredith wph wn wps wi wta wn wch wn wi wn wph wn wps wi
    wn wn wi wta wch wta wph wn wi wph wn wps wi wn wph wn wi wi meredith ax-mp
    wta wph wn wph wn wps wi wph wch wph wn wps wi wi meredith ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 4 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem2 $p |- ( ( ( ph -> ph ) -> ch ) -> ( th -> ch ) ) $=
    wch wch wi wph wn wth wn wi wi wph wi wph wph wi wi wph wph wi wch wi wth
    wch wi wi wph wth wn wch wch wi wph merlem1 wch wch wph wth wph wph wi
    meredith ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 7 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem3 $p |- ( ( ( ps -> ch ) -> ph ) -> ( ch -> ph ) ) $=
    wph wph wi wch wn wch wn wi wi wch wi wps wch wi wi wps wch wi wph wi wch
    wph wi wi wch wph wi wps wn wps wn wi wi wps wi wph wph wi wch wn wch wn wi
    wi wi wph wph wi wch wn wch wn wi wi wch wi wps wch wi wi wch wn wch wn wi
    wch wn wch wn wi wi wph wph wi wch wn wch wn wi wi wi wch wph wi wps wn wps
    wn wi wi wps wi wph wph wi wch wn wch wn wi wi wi wch wn wch wn wch wn wi
    wph wph wi merlem2 wch wn wch wn wi wph wph wi wch wn wch wn wi wi wch wph
    wi wps wn wps wn wi wi wps wi merlem2 ax-mp wch wph wps wps wph wph wi wch
    wn wch wn wi wi meredith ax-mp wph wph wch wch wps wch wi meredith ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 8 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem4 $p |- ( ta -> ( ( ta -> ph ) -> ( th -> ph ) ) ) $=
    wph wph wi wth wn wth wn wi wi wth wi wta wi wta wph wi wth wph wi wi wi
    wta wta wph wi wth wph wi wi wi wph wph wth wth wta meredith wta wph wi wth
    wph wi wi wph wph wi wth wn wth wn wi wi wth wi wta merlem3 ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 11 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem5 $p |- ( ( ph -> ps ) -> ( -. -. ph -> ps ) ) $=
    wps wps wi wps wn wps wn wi wi wps wi wps wi wps wps wi wps wps wi wi wi
    wph wps wi wph wn wn wps wi wi wps wps wps wps wps meredith wps wps wi wps
    wn wph wn wn wn wi wi wps wi wph wi wph wps wi wph wn wn wps wi wi wi wps
    wps wi wps wn wps wn wi wi wps wi wps wi wps wps wi wps wps wi wi wi wph
    wps wi wph wn wn wps wi wi wi wps wps wps wph wn wn wph meredith wph wps wi
    wph wn wn wps wi wi wps wps wi wps wn wps wn wi wi wps wi wps wi wps wps wi
    wps wps wi wi wi wn wi wph wn wps wps wi wps wn wps wn wi wi wps wi wps wi
    wps wps wi wps wps wi wi wi wn wi wi wph wi wps wps wi wps wn wph wn wn wn
    wi wi wps wi wph wi wi wps wps wi wps wn wph wn wn wn wi wi wps wi wph wi
    wph wps wi wph wn wn wps wi wi wi wps wps wi wps wn wps wn wi wi wps wi wps
    wi wps wps wi wps wps wi wi wi wph wps wi wph wn wn wps wi wi wi wi wph wps
    wi wph wn wn wps wi wi wps wps wi wps wn wps wn wi wi wps wi wps wi wps wps
    wi wps wps wi wi wi wn wi wph wn wps wps wi wps wn wps wn wi wi wps wi wps
    wi wps wps wi wps wps wi wi wi wn wi wi wph wps wi wph wn wn wps wi wi wps
    wps wi wps wn wps wn wi wi wps wi wps wi wps wps wi wps wps wi wi wi wn wi
    wph wn wps wps wi wps wn wps wn wi wi wps wi wps wi wps wps wi wps wps wi
    wi wi wn wi wi wph wi wps wps wi wps wn wph wn wn wn wi wi wps wi wph wi wi
    wph wn wps wph wps wi wps wps wi wps wn wps wn wi wi wps wi wps wi wps wps
    wi wps wps wi wi wi wn merlem1 wph wps wps wi wps wn wph wn wn wn wi wi wps
    wi wph wps wi wph wn wn wps wi wi wps wps wi wps wn wps wn wi wi wps wi wps
    wi wps wps wi wps wps wi wi wi wn wi wph wn wps wps wi wps wn wps wn wi wi
    wps wi wps wi wps wps wi wps wps wi wi wi wn wi wi merlem4 ax-mp wph wps wi
    wph wn wn wps wi wi wps wps wi wps wn wps wn wi wi wps wi wps wi wps wps wi
    wps wps wi wi wi wn wph wps wps wi wps wn wps wn wi wi wps wi wps wi wps
    wps wi wps wps wi wi wi wps wps wi wps wn wph wn wn wn wi wi wps wi wph wi
    meredith ax-mp ax-mp ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 12 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem6 $p |- ( ch -> ( ( ( ps -> ch ) -> ph ) -> ( th -> ph ) ) ) $=
    wps wch wi wps wch wi wph wi wth wph wi wi wi wch wps wch wi wph wi wth wph
    wi wi wi wph wth wps wch wi merlem4 wps wch wi wph wi wth wph wi wi wps wch
    merlem3 ax-mp $.
    $( [14-Dec-2002] $)

  $( Between steps 14 and 15 of Meredith's proof of Lukasiewicz axioms from his
     sole axiom. $)
  merlem7 $p |- ( ph -> ( ( ( ps -> ch ) -> th ) -> ( ( ( ch -> ta ) ->
                  ( -. th -> -. ps ) ) -> th ) ) ) $=
    wps wch wi wps wch wi wth wi wch wta wi wth wn wps wn wi wi wth wi wi wi
    wph wps wch wi wth wi wch wta wi wth wn wps wn wi wi wth wi wi wi wth wch
    wta wi wth wn wps wn wi wi wps wch wi merlem4 wps wch wi wth wi wch wta wi
    wth wn wps wn wi wi wth wi wi wph wn wi wch wn wph wn wi wi wch wi wps wch
    wi wi wps wch wi wps wch wi wth wi wch wta wi wth wn wps wn wi wi wth wi wi
    wi wph wps wch wi wth wi wch wta wi wth wn wps wn wi wi wth wi wi wi wi wch
    wta wi wth wn wps wn wi wi wth wi wps wch wi wth wi wch wta wi wth wn wps
    wn wi wi wth wi wi wph wn wi wch wn wph wn wi wi wi wps wch wi wth wi wch
    wta wi wth wn wps wn wi wi wth wi wi wph wn wi wch wn wph wn wi wi wch wi
    wps wch wi wi wph wn wps wch wi wth wi wch wta wi wth wn wps wn wi wi wth
    wi wch wn merlem6 wch wta wth wps wps wch wi wth wi wch wta wi wth wn wps
    wn wi wi wth wi wi wph wn wi wch wn wph wn wi wi meredith ax-mp wps wch wi
    wth wi wch wta wi wth wn wps wn wi wi wth wi wi wph wn wch wph wps wch wi
    meredith ax-mp ax-mp $.
    $( [22-Dec-2002] $)

  $( Step 15 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem8 $p |- ( ( ( ps -> ch ) -> th ) -> ( ( ( ch -> ta ) ->
                  ( -. th -> -. ps ) ) -> th ) ) $=
    wph wph wi wph wn wph wn wi wi wph wi wph wi wph wph wi wph wph wi wi wi
    wps wch wi wth wi wch wta wi wth wn wps wn wi wi wth wi wi wph wph wph wph
    wph meredith wph wph wi wph wn wph wn wi wi wph wi wph wi wph wph wi wph
    wph wi wi wi wps wch wth wta merlem7 ax-mp $.
    $( [22-Dec-2002] $)

  ${
    $v et $. $( Greek eta $)
    meredith.we $f wff et $.
    $( Step 18 of Meredith's proof of Lukasiewicz axioms from his sole
       axiom. $)
    merlem9 $p |- ( ( ( ph -> ps ) -> ( ch -> ( th -> ( ps -> ta ) ) ) ) ->
                    ( et -> ( ch -> ( th -> ( ps -> ta ) ) ) ) ) $=
      wch wth wps wta wi wi wi meredith.we wn wi wps wn meredith.we wn wi wi
      wps wi wph wps wi wi wph wps wi wch wth wps wta wi wi wi wi meredith.we
      wch wth wps wta wi wi wi wi wi wps wta wi wch wth wps wta wi wi wi
      meredith.we wn wi wps wn meredith.we wn wi wi wn wth wn wi wn wph wn wi
      wi wch wth wps wta wi wi wi meredith.we wn wi wps wn meredith.we wn wi wi
      wn wth wn wi wi wch wth wps wta wi wi wi meredith.we wn wi wps wn
      meredith.we wn wi wi wi wch wth wps wta wi wi wi meredith.we wn wi wps wn
      meredith.we wn wi wi wps wi wph wps wi wi wth wps wta wi wi wch wth wps
      wta wi wi wi meredith.we wn wi wps wn meredith.we wn wi wi wi wps wta wi
      wch wth wps wta wi wi wi meredith.we wn wi wps wn meredith.we wn wi wi wn
      wth wn wi wn wph wn wi wi wch wth wps wta wi wi wi meredith.we wn wi wps
      wn meredith.we wn wi wi wn wth wn wi wi wch wth wps wta wi wi wi
      meredith.we wn wi wps wn meredith.we wn wi wi wi meredith.we wn wch wth
      wps wta wi wi wps wn merlem6 wth wps wta wi wch wth wps wta wi wi wi
      meredith.we wn wi wps wn meredith.we wn wi wi wch wth wps wta wi wi wi
      meredith.we wn wi wps wn meredith.we wn wi wi wn wth wn wi wn wph wn wi
      merlem8 ax-mp wps wta wch wth wps wta wi wi wi meredith.we wn wi wps wn
      meredith.we wn wi wi wn wth wn wi wph wch wth wps wta wi wi wi
      meredith.we wn wi wps wn meredith.we wn wi wi meredith ax-mp wch wth wps
      wta wi wi wi meredith.we wn wps meredith.we wph wps wi meredith ax-mp $.
      $( [22-Dec-2002] $)
  $}

  $( Step 19 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem10 $p |- ( ( ph -> ( ph -> ps ) ) -> ( th -> ( ph -> ps ) ) ) $=
    wph wph wi wph wn wph wn wi wi wph wi wph wi wph wph wi wph wph wi wi wi
    wph wph wps wi wi wth wph wps wi wi wi wph wph wph wph wph meredith wph wps
    wi wph wi wph wn wth wn wi wi wph wi wph wi wph wph wps wi wi wth wph wps
    wi wi wi wi wph wph wi wph wn wph wn wi wi wph wi wph wi wph wph wi wph wph
    wi wi wi wph wph wps wi wi wth wph wps wi wi wi wi wph wps wi wph wph wth
    wph meredith wph wps wi wph wi wph wn wth wn wi wi wph wi wph wph wph wps
    wi wi wth wps wph wph wi wph wn wph wn wi wi wph wi wph wi wph wph wi wph
    wph wi wi wi merlem9 ax-mp ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 20 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem11 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    wph wph wi wph wn wph wn wi wi wph wi wph wi wph wph wi wph wph wi wi wi
    wph wph wps wi wi wph wps wi wi wph wph wph wph wph meredith wph wph wps wi
    wi wph wph wps wi wi wph wps wi wi wi wph wph wi wph wn wph wn wi wi wph wi
    wph wi wph wph wi wph wph wi wi wi wph wph wps wi wi wph wps wi wi wi wph
    wps wph wph wps wi wi merlem10 wph wph wps wi wi wph wps wi wph wph wi wph
    wn wph wn wi wi wph wi wph wi wph wph wi wph wph wi wi wi merlem10 ax-mp
    ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 28 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem12 $p |- ( ( ( th -> ( -. -. ch -> ch ) ) -> ph ) -> ph ) $=
    wth wch wn wn wch wi wi wph wi wth wch wn wn wch wi wi wph wi wph wi wi wth
    wch wn wn wch wi wi wph wi wph wi wth wch wn wn wch wi wi wth wch wn wn wch
    wi wi wph wi wth wch wn wn wch wi wi wph wi wph wi wi wch wch wi wch wn wn
    wch wi wi wth wch wn wn wch wi wi wch wch merlem5 wch wch wn wn wch wi wth
    merlem2 ax-mp wph wth wch wn wn wch wi wi wph wi wth wch wn wn wch wi wi
    merlem4 ax-mp wth wch wn wn wch wi wi wph wi wph merlem11 ax-mp $.
    $( [14-Dec-2002] $)

  $( Step 35 of Meredith's proof of Lukasiewicz axioms from his sole axiom. $)
  merlem13 $p |- ( ( ph -> ps ) ->
              ( ( ( th -> ( -. -. ch -> ch ) ) -> -. -. ph ) -> ps ) ) $=
    wps wps wi wph wn wth wch wn wn wch wi wi wph wn wn wi wn wi wi wph wi wph
    wi wph wps wi wth wch wn wn wch wi wi wph wn wn wi wps wi wi wps wps wi wph
    wn wth wch wn wn wch wi wi wph wn wn wi wn wi wi wph wi wps wps wi wph wn
    wth wch wn wn wch wi wi wph wn wn wi wn wi wi wph wi wph wi wi wps wps wi
    wph wn wth wch wn wn wch wi wi wph wn wn wi wn wi wi wph wi wph wi wph wn
    wth wch wn wn wch wi wi wph wn wn wi wn wi wps wps wi wph wn wth wch wn wn
    wch wi wi wph wn wn wi wn wi wi wph wi wps wps wi wph wn wth wch wn wn wch
    wi wi wph wn wn wi wn wi wi wph wi wph wi wi wth wch wn wn wch wi wi wth
    wch wn wn wch wi wi wph wn wn wi wn wi wth wch wn wn wch wi wi wph wn wn wi
    wn wi wph wn wth wch wn wn wch wi wi wph wn wn wi wn wi wth wch wn wn wch
    wi wi wph wn wn wi wn wch wth merlem12 wth wch wn wn wch wi wi wph wn wn wi
    wn wps wi wth wch wn wn wch wi wi wph wn wn wi wn wn wph wn wn wi wi wth
    wch wn wn wch wi wi wph wn wn wi wn wi wth wch wn wn wch wi wi wth wch wn
    wn wch wi wi wph wn wn wi wn wi wi wth wch wn wn wch wi wi wth wch wn wn
    wch wi wi wph wn wn wi wn wi wth wch wn wn wch wi wi wph wn wn wi wn wi wph
    wn wth wch wn wn wch wi wi wph wn wn wi wn wi wi wth wch wn wn wch wi wi
    wph wn wn wi wn wn wph wn wn wi wth wch wn wn wch wi wi wph wn wn wi wn wps
    wi wth wch wn wn wch wi wi wph wn wn wi wn wn wph wn wn wi wi wth wch wn wn
    wch wi wi wph wn wn wi wn wi wth wch wn wn wch wi wi wth wch wn wn wch wi
    wi wph wn wn wi wn wi wi wth wch wn wn wch wi wi wph wn wn wi wph wn wn wi
    wth wch wn wn wch wi wi wph wn wn wi wn wn wph wn wn wi wph wn wn wch wth
    merlem12 wth wch wn wn wch wi wi wph wn wn wi wph wn wn merlem5 ax-mp wth
    wch wn wn wch wi wi wph wn wn wi wn wth wch wn wn wch wi wi wph wn wn wi wn
    wps wi wth wch wn wn wch wi wi wph wn wn wi wn wn wph wn wn wi wth wch wn
    wn wch wi wi merlem6 ax-mp wth wch wn wn wch wi wi wph wn wn wi wn wps wth
    wch wn wn wch wi wi wph wn wn wi wn wph wn wth wch wn wn wch wi wi wth wch
    wn wn wch wi wi wph wn wn wi wn wi meredith ax-mp ax-mp wph wps wps wi wph
    wn wth wch wn wn wch wi wi wph wn wn wi wn wi wps wps wi wph wn wth wch wn
    wn wch wi wi wph wn wn wi wn wi wi wph wi merlem6 ax-mp wps wps wi wph wn
    wth wch wn wn wch wi wi wph wn wn wi wn wi wi wph wi wph merlem11 ax-mp wps
    wps wph wth wch wn wn wch wi wi wph wn wn wi wph meredith ax-mp $.
    $( [14-Dec-2002] $)

  $( 1 of 3 axioms for propositional calculus due to Lukasiewicz, derived from
     Meredith's sole axiom. $)
  luk-1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    wch wch wi wph wn wn wn wph wn wi wi wph wn wn wi wps wi wps wch wi wph wch
    wi wi wi wph wps wi wps wch wi wph wch wi wi wi wch wch wph wn wn wph wps
    meredith wps wch wi wph wch wi wi wph wi wph wps wi wn wn wn wph wps wi wn
    wi wi wph wps wi wn wn wi wch wch wi wph wn wn wn wph wn wi wi wph wn wn wi
    wps wi wi wch wch wi wph wn wn wn wph wn wi wi wph wn wn wi wps wi wps wch
    wi wph wch wi wi wi wph wps wi wps wch wi wph wch wi wi wi wi wph wps wi
    wch wch wi wph wn wn wn wph wn wi wi wph wn wn wi wps wi wi wps wch wi wph
    wch wi wi wph wi wph wps wi wn wn wn wph wps wi wn wi wi wph wps wi wn wn
    wi wch wch wi wph wn wn wn wph wn wi wi wph wn wn wi wps wi wi wph wps wph
    wn wch wch wi merlem13 wph wps wi wch wch wi wph wn wn wn wph wn wi wi wph
    wn wn wi wps wi wph wps wi wn wps wch wi wph wch wi wi wph wi merlem13
    ax-mp wps wch wi wph wch wi wi wph wph wps wi wn wn wph wps wi wch wch wi
    wph wn wn wn wph wn wi wi wph wn wn wi wps wi meredith ax-mp ax-mp $.
    $( [14-Dec-2002] $)

  $( 2 of 3 axioms for propositional calculus due to Lukasiewicz, derived from
     Meredith's sole axiom. $)
  luk-2 $p |- ( ( -. ph -> ph ) -> ph ) $=
    wph wn wph wi wph wn wph wi wph wi wi wph wn wph wi wph wi wph wph wn wph
    wi wn wi wph wn wn wph wn wph wi wn wi wi wph wn wi wph wn wi wph wn wph wi
    wph wn wph wi wph wi wi wph wph wn wph wi wn wi wph wn wn wph wn wph wi wn
    wi wi wph wn wi wph wph wn wph wi wn wi wph wn wn wph wn wph wi wn wi wi
    wph wn wi wph wn wi wi wph wph wn wph wi wn wi wph wn wn wph wn wph wi wn
    wi wi wph wn wi wph wn wi wph wph wn wph wi wn wi wph wn wn wph wn wph wi
    wn wi wi wph wph wn wph wi wn wi wph wn wn wph wn wph wi wn wi wi wph wn wi
    wph wph wn wph wi wn wi wph wn wn wph wn wph wi wn wi wi wph wn wi wph wn
    wi wi wph wph wn wph wi wn merlem5 wph wn wph wph wn wph wi wn wi wph wn wn
    wph wn wph wi wn wi wi wph wn wi wph wph wn wph wi wn wi wph wn wn wph wn
    wph wi wn wi wi merlem4 ax-mp wph wph wn wph wi wn wi wph wn wn wph wn wph
    wi wn wi wi wph wn wi wph wn merlem11 ax-mp wph wph wn wph wi wn wph wn wph
    wn wph wi wph wn meredith ax-mp wph wn wph wi wph merlem11 ax-mp $.
    $( [14-Dec-2002] $)

  $( 3 of 3 axioms for propositional calculus due to Lukasiewicz, derived from
     Meredith's sole axiom. $)
  luk-3 $p |- ( ph -> ( -. ph -> ps ) ) $=
    wph wn wph wn wps wi wi wph wn wps wi wi wph wph wn wps wi wi wph wn wps
    merlem11 wph wps wph wn wph wn wps wi merlem1 ax-mp $.
    $( [14-Dec-2002] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Derive the standard axioms from the Lukasiewicz axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    luklem1.1 $e |- ( ph -> ps ) $.
    luklem1.2 $e |- ( ps -> ch ) $.
    $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
    luklem1 $p |- ( ph -> ch ) $=
      wps wch wi wph wch wi luklem1.2 wph wps wi wps wch wi wph wch wi wi
      luklem1.1 wph wps wch luk-1 ax-mp ax-mp $.
      $( [23-Dec-2002] $)
  $}

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem2 $p |- ( ( ph -> -. ps ) ->
                ( ( ( ph -> ch ) -> th ) -> ( ps -> th ) ) ) $=
    wph wps wn wi wps wph wch wi wi wph wch wi wth wi wps wth wi wi wph wps wn
    wi wps wn wch wi wph wch wi wi wps wph wch wi wi wph wps wn wch luk-1 wps
    wps wn wch wi wi wps wn wch wi wph wch wi wi wps wph wch wi wi wi wps wch
    luk-3 wps wps wn wch wi wph wch wi luk-1 ax-mp luklem1 wps wph wch wi wth
    luk-1 luklem1 $.
    $( [22-Dec-2002] $)

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem3 $p |- ( ph -> ( ( ( -. ph -> ps ) -> ch ) -> ( th -> ch ) ) ) $=
    wph wph wn wth wn wi wph wn wps wi wch wi wth wch wi wi wph wth wn luk-3
    wph wn wth wps wch luklem2 luklem1 $.
    $( [22-Dec-2002] $)

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem4 $p |- ( ( ( ( -. ph -> ph ) -> ph ) -> ps ) -> ps ) $=
    wph wn wph wi wph wi wps wi wps wn wps wi wps wps wn wph wn wph wi wph wi
    wi wph wn wph wi wph wi wps wi wps wn wps wi wi wph wn wph wi wph wi wn wph
    wn wph wi wph wi wi wph wn wph wi wph wi wi wps wn wph wn wph wi wph wi wi
    wph wn wph wi wph wi luk-2 wph wn wph wi wph wi wn wph wn wph wi wph wi wi
    wph wn wph wi wph wi wi wps wn wph wn wph wi wph wi wph luk-2 a1i12 ax-mp
    wps wn wph wn wph wi wph wi wps luk-1 ax-mp wps luk-2 luklem1 $.
    $( [22-Dec-2002] $)

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem5 $p |- ( ph -> ( ps -> ph ) ) $=
    wph wph wn wph wi wph wi wps wph wi wi wps wph wi wph wph wph wps luklem3
    wph wps wph wi luklem4 luklem1 $.
    $( [22-Dec-2002] $)

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem6 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    wph wph wps wi wi wph wps wi wps wi wph wps wi wi wph wps wi wph wph wps wi
    wps luk-1 wph wps wi wn wph wps wi wi wph wps wi wi wph wps wi wps wi wph
    wps wi wi wph wps wi wi wi wph wps wi wps wi wph wps wi wi wph wps wi wi
    wph wps wi wps wi wph wps wi wi wph wps wi wn wph wps wi wi wi wph wps wi
    wn wph wps wi wi wph wps wi wi wph wps wi wps wi wph wps wi wi wph wps wi
    wi wi wph wps wi wn wph wps wi wps wi wi wph wps wi wps wi wph wps wi wi
    wph wps wi wn wph wps wi wi wi wph wps wi wn wps wn wph wps wi wn wi wph
    wps wi wps wi wph wps wi wn wps wn luklem5 wps wn wph wps wi wn wi wps wn
    wps wi wps wi wph wps wi wps wi wi wph wps wi wps wi wps wn wph wps wi wps
    wps luklem2 wps wph wps wi wps wi luklem4 luklem1 luklem1 wph wps wi wn wph
    wps wi wps wi wph wps wi luk-1 ax-mp wph wps wi wps wi wph wps wi wi wph
    wps wi wn wph wps wi wi wph wps wi luk-1 ax-mp wph wps wi wph wps wi wps wi
    wph wps wi wi wph wps wi wi luklem4 ax-mp luklem1 $.
    $( [22-Dec-2002] $)

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem7 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ps -> ( ph -> ch ) ) ) $=
    wph wps wch wi wi wps wch wi wch wi wph wch wi wi wps wph wch wi wi wph wps
    wch wi wch luk-1 wps wps wch wi wch wi wi wps wch wi wch wi wph wch wi wi
    wps wph wch wi wi wi wps wps wch wi wps wch wi wch wi wi wps wch wi wch wi
    wps wps wch wi wps wi wps wch wi wps wch wi wch wi wi wps wps wch wi
    luklem5 wps wch wi wps wch luk-1 luklem1 wps wch wi wch luklem6 luklem1 wps
    wps wch wi wch wi wph wch wi luk-1 ax-mp luklem1 $.
    $( [22-Dec-2002] $)

  $( Used to rederive standard propositional axioms from Lukasiewicz'. $)
  luklem8 $p |- ( ( ph -> ps ) -> ( ( ch -> ph ) -> ( ch -> ps ) ) ) $=
    wch wph wi wph wps wi wch wps wi wi wi wph wps wi wch wph wi wch wps wi wi
    wi wch wph wps luk-1 wch wph wi wph wps wi wch wps wi luklem7 ax-mp $.
    $( [22-Dec-2002] $)

  $( Standard propositional axiom derived from Lukasiewicz axioms. $)
  ax1 $p |- ( ph -> ( ps -> ph ) ) $=
    wph wps luklem5 $.
    $( [22-Dec-2002] $)

  $( Standard propositional axiom derived from Lukasiewicz axioms. $)
  ax2 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( ph -> ps ) -> ( ph -> ch ) ) ) $=
    wph wps wch wi wi wps wph wch wi wi wph wps wi wph wch wi wi wph wps wch
    luklem7 wps wph wch wi wi wph wps wi wph wph wch wi wi wi wph wps wi wph
    wch wi wi wps wph wch wi wph luklem8 wph wph wch wi wi wph wch wi wi wph
    wps wi wph wph wch wi wi wi wph wps wi wph wch wi wi wi wph wch luklem6 wph
    wph wch wi wi wph wch wi wph wps wi luklem8 ax-mp luklem1 luklem1 $.
    $( [22-Dec-2002] $)

  $( Standard propositional axiom derived from Lukasiewicz axioms. $)
  ax3 $p |- ( ( -. ph -> -. ps ) -> ( ps -> ph ) ) $=
    wph wn wps wn wi wph wn wph wi wph wi wps wph wi wi wps wph wi wph wn wps
    wph wph luklem2 wph wps wph wi luklem4 luklem1 $.
    $( [22-Dec-2002] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical 'nand' (Sheffer stroke)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c -/\ $. $( 'nand' ) $)
  $( Extend wff definition to include 'nand'. $)
  wnand $a wff ( ph -/\ ps ) $.

  $( Define  incompatibility ('not-and' or 'nand').  This is also called the
     Sheffer stroke, represented by a vertical bar, but we use a different
     symbol to avoid ambiguity with other uses of the vertical bar. $)
  df-nand $a |- ( ( ph -/\ ps ) <-> -. ( ph /\ ps ) ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Derive Nicod's axiom from the standard axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for handling nested 'nand's. $)
  nic-justlem $p |- ( ( ph -/\ ( ch -/\ ps ) ) <-> ( ph -> ( ch /\ ps ) ) ) $=
    wph wch wps wnand wa wn wph wch wps wa wn wa wn wph wch wps wnand wnand wph
    wch wps wa wi wph wch wps wnand wa wph wch wps wa wn wa wch wps wnand wch
    wps wa wn wph wch wps df-nand anbi2i notbii wph wch wps wnand df-nand wph
    wch wps wa iman 3bitr4i $.
    $( [11-Dec-2008] $) $( [19-Nov-2007] $)

  $( Show equivalence between implication and the Nicod version.  To derive
     ~ nic-dfim , apply ~ nic-justbi . $)
  nic-justim $p |- ( ( ph -> ps ) <-> ( ph -/\ ( ps -/\ ps ) ) ) $=
    wph wps wps wnand wnand wph wps wps wa wi wph wps wi wph wps wps
    nic-justlem wph wps anidmdbi bitr2i $.
    $( [17-Dec-2008] $) $( [19-Nov-2007] $)

  $( Show equivalence between negation and the Nicod version.  To derive
     ~ nic-dfneg , apply ~ nic-justbi . $)
  nic-justneg $p |- ( -. ps <-> ( ps -/\ ps ) ) $=
    wps wps wnand wps wps wa wn wps wn wps wps df-nand wps wps wa wps wps anidm
    notbii bitr2i $.
    $( [16-Dec-2008] $) $( [19-Nov-2007] $)

  $( Show equivalence between the bidirectional and the Nicod version.
     (Contributed by Jeff Hoffman, 19-Nov-2007.) $)
  nic-justbi $p |- ( ( ph <-> ps ) <->
          ( ( ph -/\ ps ) -/\ ( ( ph -/\ ph ) -/\ ( ps -/\ ps ) ) ) ) $=
    wph wps wa wn wph wn wps wn wa wn wa wn wph wps wa wph wn wps wn wa wo wph
    wps wnand wph wph wnand wps wps wnand wnand wnand wph wps wb wph wps wa wph
    wn wps wn wa pm4.57 wph wps wnand wph wph wnand wps wps wnand wnand wnand
    wph wps wnand wph wph wnand wps wps wnand wnand wa wn wph wps wa wn wph wn
    wps wn wa wn wa wn wph wps wnand wph wph wnand wps wps wnand wnand df-nand
    wph wps wnand wph wph wnand wps wps wnand wnand wa wph wps wa wn wph wn wps
    wn wa wn wa wph wps wnand wph wps wa wn wph wph wnand wps wps wnand wnand
    wph wn wps wn wa wn wph wps df-nand wph wph wnand wps wps wnand wnand wph
    wph wnand wps wps wnand wa wn wph wn wps wn wa wn wph wph wnand wps wps
    wnand df-nand wph wn wps wn wa wph wph wnand wps wps wnand wa wph wn wph
    wph wnand wps wn wps wps wnand wph nic-justneg wps nic-justneg anbi12i
    notbii bitr4i anbi12i notbii bitri wph wps dfbi3 3bitr4ri $.
    $( [11-Dec-2008] $) $( [19-Nov-2007] $)

$( [exclude from the Table of Contents by breaking whitespace after "$","("]
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Prove Nicod's axiom and implication and negation definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define implication in terms of 'nand'.  Analogous to
     ` ( ( ph -/\ ( ps -/\ ps ) ) <-> ( ph -> ps ) ) ` .  In a pure
     (standalone) treatment of Nicod's axiom, this theorem would be changed
     to a definition ($a statement). $)
  nic-dfim $p |- ( ( ( ph -/\ ( ps -/\ ps ) ) -/\ ( ph -> ps ) ) -/\
                   ( ( ( ph -/\ ( ps -/\ ps ) ) -/\ ( ph -/\ ( ps -/\ ps ) ) )
                          -/\
                     ( ( ph -> ps ) -/\ ( ph -> ps ) ) ) ) $=
    wph wps wps wnand wnand wph wps wi wb wph wps wps wnand wnand wph wps wi
    wnand wph wps wps wnand wnand wph wps wps wnand wnand wnand wph wps wi wph
    wps wi wnand wnand wnand wph wps wi wph wps wps wnand wnand wph wps
    nic-justim bicomi wph wps wps wnand wnand wph wps wi nic-justbi mpbi $.
    $( [11-Dec-2008] $) $( [11-Dec-2008] $)

  $( Define negation in terms of 'nand'.  Analogous to
     ` ( ( ph -/\ ph ) <-> -. ph ) ` .  In a pure (standalone) treatment of
     Nicod's axiom, this theorem would be changed to a definition ($a
     statement). $)
  nic-dfneg $p |- ( ( ( ph -/\ ph ) -/\ -. ph ) -/\
                    ( ( ( ph -/\ ph ) -/\ ( ph -/\ ph ) ) -/\
                      ( -. ph -/\ -. ph ) ) ) $=
    wph wph wnand wph wn wb wph wph wnand wph wn wnand wph wph wnand wph wph
    wnand wnand wph wn wph wn wnand wnand wnand wph wn wph wph wnand wph
    nic-justneg bicomi wph wph wnand wph wn nic-justbi mpbi $.
    $( [11-Dec-2008] $) $( [11-Dec-2008] $)

  ${
    $( Minor premise. $)
    nic-jmin $e |- ph $.
    $( Major premise. $)
    nic-jmaj $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    $( Derive Nicod's rule of modus ponens using 'nand', from the standard
       one.  Although the major and minor premise together also imply ` ch ` ,
       this form is necessary for useful derivations from ~ nic-ax .  In a
       pure (standalone) treatment of Nicod's axiom, this theorem would be
       changed to an axiom ($a statement).  (Contributed by Jeff Hoffman,
       19-Nov-2007.) $)
    nic-mp $p |- ps $=
      wph wps nic-jmin wph wch wps wph wch wps wnand wnand wph wch wps wa wi
      nic-jmaj wph wps wch nic-justlem mpbi pm3.27d ax-mp $.
      $( [11-Dec-2008] $) $( [19-Nov-2007] $)

    $( A direct proof of ~ nic-mp . $)
    nic-mpALT $p |- ps $=
      wph wps nic-jmin wph wch wps wph wch wps wa wi wph wch wps wa wn wa wn
      wph wch wps wnand wnand wph wch wps wa wn wa wn nic-jmaj wph wch wps
      wnand wnand wph wch wps wnand wa wn wph wch wps wa wn wa wn wph wch wps
      wnand df-nand wph wch wps wnand wa wph wch wps wa wn wa wch wps wnand wch
      wps wa wn wph wch wps df-nand anbi2i notbii bitri mpbi wph wch wps wa
      iman mpbir pm3.27d ax-mp $.
      $( [13-Jan-2009] $) $( [30-Dec-2008] $)
  $}

  $( Nicod's axiom derived from the standard ones.  See _Intro. to Math. Phil._
     by B. Russell, p. 152.  Like ~ meredith , the usual axioms can be derived
     from this and vice versa.  Unlike ~ meredith , Nicod uses a different
     connective ('nand'), so another form of modus ponens must be used in
     proofs, e.g. ` { ` ~ nic-ax , ~ nic-mp  ` } ` is equivalent to
     ` { ` ~ luk-1 , ~ luk-2 , ~ luk-3 , ~ ax-mp ` } ` .  In a pure
     (standalone) treatment of Nicod's axiom, this theorem would be changed
     to an axiom ($a statement).  (Contributed by Jeff Hoffman,
     19-Nov-2007.) $)
  nic-ax $p |- ( ( ph -/\ ( ch -/\ ps ) ) -/\
                   ( ( ta -/\ ( ta -/\ ta ) ) -/\
                     ( ( th -/\ ch ) -/\
                       ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    wph wch wps wnand wnand wta wta wta wnand wnand wth wch wnand wph wth wnand
    wph wth wnand wnand wnand wnand wnand wph wch wps wnand wnand wta wta wta
    wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand wa wi wph
    wch wps wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand
    wta wta wta wnand wnand wph wch wps wnand wnand wph wch wps wa wi wph wch
    wi wth wch wnand wph wth wnand wph wth wnand wnand wnand wph wch wps wnand
    wnand wph wch wps wa wi wph wps wch nic-justlem biimpi wch wps wa wch wph
    wch wps pm3.26 imim2i wph wch wi wth wch wnand wph wth wnand wi wth wch
    wnand wph wth wnand wph wth wnand wnand wnand wph wch wi wth wch wn wi wph
    wth wnand wth wch wnand wph wch wi wth wch wn wi wth wph wn wi wph wth
    wnand wph wch wi wch wn wph wn wth wph wch con3 imim2d wph wth wn wi wph
    wth wa wn wth wph wn wi wph wth wnand wph wth imnan wth wph con2b wph wth
    df-nand 3bitr4ri syl6ibr wth wch wn wi wth wch wa wn wth wch wnand wth wch
    imnan wth wch df-nand bitr4i syl5ibr wth wch wnand wph wth wnand nic-justim
    sylib 3syl wta wta wta wnand wnand wta wta wta wa wi wta wta wta wa wta
    pm4.24 biimpi wta wta wta nic-justlem mpbir jctil wph wch wps wnand wnand
    wth wch wnand wph wth wnand wph wth wnand wnand wnand wta wta wta wnand
    wnand nic-justlem mpbir $.
    $( [11-Dec-2008] $) $( [19-Nov-2007] $)

  $( A direct proof of ~ nic-ax . $)
  nic-axALT $p |- ( ( ph -/\ ( ch -/\ ps ) ) -/\ ( ( ta -/\ ( ta -/\ ta ) )
          -/\ ( ( th -/\ ch ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    wph wch wps wnand wnand wta wta wta wnand wnand wth wch wnand wph wth wnand
    wph wth wnand wnand wnand wnand wnand wph wch wps wnand wnand wta wta wta
    wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand wnand wa
    wn wph wch wps wnand wnand wta wta wta wnand wnand wth wch wnand wph wth
    wnand wph wth wnand wnand wnand wnand wa wn wph wch wps wa wi wta wta wta
    wa wi wth wch wn wi wth wph wn wi wi wa wi wph wch wps wa wi wth wch wn wi
    wth wph wn wi wi wta wta wta wa wi wph wch wps wa wi wph wch wi wth wch wn
    wi wth wph wn wi wi wch wps wa wch wph wch wps pm3.26 imim2i wph wch wi wch
    wn wph wn wth wph wch con3 imim2d syl wta wta wa wta wta anidm biimpri
    jctil wph wch wps wnand wnand wta wta wta wnand wnand wth wch wnand wph wth
    wnand wph wth wnand wnand wnand wnand wa wn wph wch wps wa wi wta wta wta
    wa wi wth wch wn wi wth wph wn wi wi wa wn wa wn wph wch wps wa wi wta wta
    wta wa wi wth wch wn wi wth wph wn wi wi wa wi wph wch wps wnand wnand wta
    wta wta wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand
    wnand wa wph wch wps wa wi wta wta wta wa wi wth wch wn wi wth wph wn wi wi
    wa wn wa wph wch wps wnand wnand wph wch wps wa wi wta wta wta wnand wnand
    wth wch wnand wph wth wnand wph wth wnand wnand wnand wnand wta wta wta wa
    wi wth wch wn wi wth wph wn wi wi wa wn wph wch wps wnand wa wn wph wch wps
    wa wn wa wn wph wch wps wnand wnand wph wch wps wa wi wph wch wps wnand wa
    wph wch wps wa wn wa wch wps wnand wch wps wa wn wph wch wps df-nand anbi2i
    notbii wph wch wps wnand df-nand wph wch wps wa iman 3bitr4i wta wta wta
    wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand wnand wta
    wta wta wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand
    wa wn wta wta wta wa wi wth wch wn wi wth wph wn wi wi wa wn wta wta wta
    wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand df-nand
    wta wta wta wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand
    wnand wa wta wta wta wa wi wth wch wn wi wth wph wn wi wi wa wta wta wta
    wnand wnand wta wta wta wa wi wth wch wnand wph wth wnand wph wth wnand
    wnand wnand wth wch wn wi wth wph wn wi wi wta wta wta wnand wa wn wta wta
    wta wa wn wa wn wta wta wta wnand wnand wta wta wta wa wi wta wta wta wnand
    wa wta wta wta wa wn wa wta wta wnand wta wta wa wn wta wta wta df-nand
    anbi2i notbii wta wta wta wnand df-nand wta wta wta wa iman 3bitr4i wth wch
    wnand wph wth wnand wph wth wnand wnand wa wn wth wch wn wi wth wph wn wi
    wn wa wn wth wch wnand wph wth wnand wph wth wnand wnand wnand wth wch wn
    wi wth wph wn wi wi wth wch wnand wph wth wnand wph wth wnand wnand wa wth
    wch wn wi wth wph wn wi wn wa wth wch wnand wth wch wn wi wph wth wnand wph
    wth wnand wnand wth wph wn wi wn wth wch wnand wth wch wa wn wth wch wn wi
    wth wch df-nand wth wch imnan bitr4i wph wth wnand wph wth wnand wnand wph
    wth wnand wph wth wnand wa wn wth wph wn wi wn wph wth wnand wph wth wnand
    df-nand wph wth wnand wph wth wnand wa wth wph wn wi wph wth wnand wph wth
    wnand wa wph wth wnand wph wth wa wn wth wph wn wi wph wth wnand anidm wph
    wth df-nand wph wth wa wn wph wth wn wi wth wph wn wi wph wth imnan wph wth
    con2b bitr3i 3bitri notbii bitri anbi12i notbii wth wch wnand wph wth wnand
    wph wth wnand wnand df-nand wth wch wn wi wth wph wn wi iman 3bitr4i
    anbi12i notbii bitri anbi12i notbii wph wch wps wa wi wta wta wta wa wi wth
    wch wn wi wth wph wn wi wi wa iman bitr4i mpbir wph wch wps wnand wnand wta
    wta wta wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand wnand
    wnand df-nand mpbir $.
    $( [25-Dec-2008] $) $( [11-Dec-2008] $)



$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Derive the Lukasiewicz axioms from Nicod's axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Minor premise. $)
    nic-imp.1 $e |- ( ph -/\ ( ch -/\ ps ) ) $.
     $( Inference for ~ nic-mp using ~ nic-ax as major premise.  (Contributed
        by Jeff Hoffman, 17-Nov-2007.)  $)
    nic-imp $p |- ( ( th -/\ ch ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) $=
      wph wch wps wnand wnand wth wch wnand wph wth wnand wph wth wnand wnand
      wnand wta wta wta wnand wnand nic-imp.1 wph wps wch wth wta nic-ax nic-mp
      $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  $( Lemma for ~ nic-id . $)
  nic-idlem1 $p |- ( ( th -/\ ( ta -/\ ( ta -/\ ta ) ) ) -/\
                 ( ( ( ph -/\ ( ch -/\ ps ) ) -/\ th ) -/\
                   ( ( ph -/\ ( ch -/\ ps ) ) -/\ th ) ) ) $=
    wph wch wps wnand wnand wph wch wnand wph wph wnand wph wph wnand wnand
    wnand wta wta wta wnand wnand wth wph wps wch wph wta nic-ax nic-imp $.
    $( [11-Dec-2008] $) $( [17-Nov-2007] $)

  ${
    $v et $. $( Greek eta $)
    nic-idlem2.we $f wff et $.
    nic-idlem2.1 $e |- ( et -/\ ( ( ph -/\ ( ch -/\ ps ) ) -/\ th ) ) $.
     $( Lemma for ~ nic-id .  Inference used by ~ nic-id . $)
    nic-idlem2 $p |- ( ( th -/\ ( ta -/\ ( ta -/\ ta ) ) ) -/\ et ) $=
      nic-idlem2.we wph wch wps wnand wnand wth wnand wnand wth wta wta wta
      wnand wnand wnand nic-idlem2.we wnand wth wta wta wta wnand wnand wnand
      nic-idlem2.we wnand nic-idlem2.1 wth wta wta wta wnand wnand wnand wph
      wch wps wnand wnand wth wnand wph wch wps wnand wnand wth wnand
      nic-idlem2.we wph wch wps wnand wnand wph wch wnand wph wph wnand wph wph
      wnand wnand wnand wta wta wta wnand wnand wth wph wps wch wph wta nic-ax
      nic-imp nic-imp nic-mp $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  $( Theorem ~ id expressed with ` -/\ ` .  (Contributed by Jeff Hoffman,
     17-Nov-2007.) $)
  nic-id $p |- ( ta -/\ ( ta -/\ ta ) ) $=
    wph wps wnand wps wph wnand wps wph wnand wnand wnand wch wch wch wnand
    wnand wnand wps wps wps wnand wnand wnand wta wta wta wnand wnand wch wch
    wch wnand wnand wth wth wth wph wps wnand wps wph wnand wps wph wnand wnand
    wnand wch wps wps wps wnand wnand wps wps wps wph wth nic-ax nic-idlem2 wph
    wps wnand wps wph wnand wps wph wnand wnand wnand wch wch wnand wch wph wps
    wnand wps wph wnand wps wph wnand wnand wnand wch wch wch wnand wnand wnand
    wps wch wch wch wnand wnand wta wta wta wnand wnand wnand wph wps wnand wps
    wph wnand wps wph wnand wch wch wch wnand wnand wta nic-idlem1 nic-idlem2
    nic-mp $.
    $( [11-Dec-2008] $) $( [17-Nov-2007] $)

  $( ` -/\ ` is symmetric.  (Contributed by Jeff Hoffman, 17-Nov-2007.)  $)
  nic-swap $p |- ( ( th -/\ ph ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) $=
    wph wph wph wnand wnand wth wph wnand wph wth wnand wph wth wnand wnand
    wnand wta wta wta wnand wnand wph nic-id wph wph wph wth wta nic-ax nic-mp
    $.
    $( [11-Dec-2008] $) $( [17-Nov-2007] $)

  ${
    nic-isw1.1 $e |- ( th -/\ ph ) $.
    $( Inference version of ~ nic-swap .  (Contributed by Jeff Hoffman,
       17-Nov-2007.) $)
    nic-isw1 $p |- ( ph -/\ th ) $=
      wth wph wnand wph wth wnand wph wth wnand nic-isw1.1 wph wth nic-swap
      nic-mp $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  ${
    nic-isw2.1 $e |- ( ps -/\ ( th -/\ ph ) ) $.
    $( Inference for swapping nested terms.  (Contributed by Jeff Hoffman,
       17-Nov-2007.) $)
    nic-isw2 $p |- ( ps -/\ ( ph -/\ th ) ) $=
      wps wph wth wnand wps wth wph wnand wnand wph wth wnand wps wnand wph wth
      wnand wps wnand nic-isw2.1 wph wth wnand wth wph wnand wth wph wnand wps
      wth wph nic-swap nic-imp nic-mp nic-isw1 $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  ${
    nic-iimp1.1 $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    nic-iimp1.2 $e |- ( th -/\ ch ) $.
    $( Inference version of ~ nic-imp using right-handed term.  (Contributed
       by Jeff Hoffman, 17-Nov-2007.) $)
    nic-iimp1 $p |- ( th -/\ ph ) $=
      wth wph wth wch wnand wph wth wnand wph wth wnand nic-iimp1.2 wph wps wch
      wth nic-iimp1.1 nic-imp nic-mp nic-isw1 $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  ${
    nic-iimp2.1 $e |- ( ( ph -/\ ps ) -/\ ( ch -/\ ch ) ) $.
    nic-iimp2.2 $e |- ( th -/\ ph ) $.
    $( Inference version of ~ nic-imp using left-handed term.  (Contributed
       by Jeff Hoffman, 17-Nov-2007.) $)
    nic-iimp2 $p |- ( th -/\ ( ch -/\ ch ) ) $=
      wch wch wnand wps wph wth wch wch wnand wph wps wnand nic-iimp2.1
      nic-isw1 nic-iimp2.2 nic-iimp1 $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  ${
    nic-idel.1 $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    $( Inference to remove the trailing term.  (Contributed by Jeff Hoffman,
       17-Nov-2007.) $)
    nic-idel $p |- ( ph -/\ ( ch -/\ ch ) ) $=
      wch wch wnand wch wnand wph wch wch wnand wnand wph wch wch wnand wnand
      wch wch wnand wch wch nic-id nic-isw1 wph wps wch wch wch wnand
      nic-idel.1 nic-imp nic-mp $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  ${
    nic-ich.1 $e |- ( ph -/\ ( ps -/\ ps ) ) $.
    nic-ich.2 $e |- ( ps -/\ ( ch -/\ ch ) ) $.
    $( Chained inference.  (Contributed by Jeff Hoffman, 17-Nov-2007.) $)
    nic-ich $p |- ( ph -/\ ( ch -/\ ch ) ) $=
      wch wch wnand wps wnand wph wch wch wnand wnand wph wch wch wnand wnand
      wch wch wnand wps nic-ich.2 nic-isw1 wph wps wps wch wch wnand nic-ich.1
      nic-imp nic-mp $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

  ${
    nic-idbl.1 $e |- ( ph -/\ ( ps -/\ ps ) ) $.
    $( Double the terms.  Since doubling is the same as negation,
       this can be viewed as a contraposition Inference.  (Contributed
       by Jeff Hoffman, 17-Nov-2007.) $)
    nic-idbl $p |- ( ( ps -/\ ps ) -/\ ( ( ph -/\ ph ) -/\ ( ph -/\ ph ) ) ) $=
      wps wps wnand wph wps wnand wph wph wnand wph wps wps wps nic-idbl.1
      nic-imp wph wps wps wph nic-idbl.1 nic-imp nic-ich $.
      $( [11-Dec-2008] $) $( [17-Nov-2007] $)
  $}

$( (not in Table of Contents)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Biconditional justification from Nicod's axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( For nic-* definitions, the biconditional connective is not used.  Instead,
     definitions are made based on this form.  ~ nic-bi1 and ~ nic-bi2 are
     used to convert the definitions into usable theorems about one side of the
     implication.  (Contributed by Jeff Hoffman, 18-Nov-2007.)  $)
  nic-bijust $p |- ( ( ta -/\ ta ) -/\ ( ( ta -/\ ta ) -/\ ( ta -/\ ta ) ) ) $=
    wta wta wnand nic-id $.
    $( [11-Dec-2008] $) $( [18-Nov-2007] $)

  ${
    $( 'Biconditional' premise.  (Contributed by Jeff Hoffman, 18-Nov-2007.) $)
    nic-bi1.1 $e |- ( ( ph -/\ ps ) -/\ ( ( ph -/\ ph )
         -/\ ( ps -/\ ps ) ) ) $.
    $( Inference to extract one side of an implication from a definition $)
    nic-bi1 $p |- ( ph -/\ ( ps -/\ ps ) ) $=
      wph wph wps wps wph wph wph wps wnand wps wps wnand wph wph wnand wph
      nic-bi1.1 wph nic-id nic-iimp1 nic-isw2 nic-idel $.
      $( [11-Dec-2008] $) $( [18-Nov-2007] $)
  $}

  ${
    $( 'Biconditional' premise.  (Contributed by Jeff Hoffman, 18-Nov-2007.) $)
    nic-bi2.1 $e |- ( ( ph -/\ ps ) -/\ ( ( ph -/\ ph )
         -/\ ( ps -/\ ps ) ) ) $.
    $( Inference to extract the other side of an implication from a
        'biconditional' definition. $)
    nic-bi2 $p |- ( ps -/\ ( ph -/\ ph ) ) $=
      wps wps wph wph wps wnand wph wph wnand wps wps wnand wps wps wps wnand
      wph wps wnand wph wph wnand nic-bi2.1 nic-isw2 wps nic-id nic-iimp1
      nic-idel $.
      $( [11-Dec-2008] $) $( [18-Nov-2007] $)
  $}

$( (not in Table of Contents)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Prove the Lukasiewicz axioms from Nicod's axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Minor premise. $)
    nic-smin $e |- ph $.
    $( Major premise. $)
    nic-smaj $e |- ( ph -> ps ) $.
    $( Derive the standard modus ponens from ~ nic-mp .  (Contributed by Jeff
       Hoffman, 18-Nov-2007.) $)
    nic-stdmp $p |- ps $=
      wph wps wps nic-smin wph wps wi wph wps wps wnand wnand wph wps wps wnand
      wnand nic-smaj wph wps wps wnand wnand wph wps wi wph wps nic-dfim
      nic-bi2 nic-mp nic-mp $.
      $( [11-Dec-2008] $) $( [18-Nov-2007] $)
  $}

  $( Proof of ~ luk-1 from ~ nic-ax and ~ nic-mp (and definitions
     ~ nic-dfim and ~ nic-dfneg ).  Note that the standard axioms ~ ax-1 ,
     ~ ax-2 , and ~ ax-3 are proved from the Lukasiewicz axioms by theorems
     ~ ax1 , ~ ax2 , and ~ ax3 .  (Contributed by Jeff Hoffman,
     18-Nov-2007.) $)
  nic-luk1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    wph wps wi wps wch wi wph wch wi wi wps wch wi wph wch wi wi wnand wnand
    wph wps wi wps wch wi wph wch wi wi wi wph wps wi wps wch wi wph wch wi wi
    wi wph wps wi wph wps wps wnand wnand wps wch wi wph wch wi wi wph wps wps
    wnand wnand wph wps wi wph wps nic-dfim nic-bi2 wph wps wps wnand wnand wps
    wch wi wph wch wi wph wch wi wnand wnand wps wch wi wph wch wi wi wph wps
    wps wnand wnand wch wch wnand wps wnand wph wch wch wnand wnand wph wch wch
    wnand wnand wnand wnand wps wch wi wph wch wi wph wch wi wnand wnand wph
    wps wps wnand wnand wta wta wta wnand wnand wch wch wnand wps wnand wph wch
    wch wnand wnand wph wch wch wnand wnand wnand wnand wch wch wnand wps wnand
    wph wch wch wnand wnand wph wch wch wnand wnand wnand wnand wph wps wps
    wnand wnand wta wta wta wnand wnand wph wps wps wch wch wnand wta nic-ax
    nic-isw2 nic-idel wch wch wnand wps wnand wph wch wch wnand wnand wph wch
    wch wnand wnand wnand wnand wph wch wi wph wch wi wnand wch wch wnand wps
    wnand wnand wps wch wi wph wch wi wph wch wi wnand wnand wph wch wi wph wch
    wi wnand wph wch wch wnand wnand wph wch wch wnand wnand wnand wph wch wch
    wnand wnand wph wch wch wnand wnand wnand wch wch wnand wps wnand wph wch
    wch wnand wnand wph wch wi wph wch wch wnand wnand wph wch wi wph wch
    nic-dfim nic-bi1 nic-idbl nic-imp wps wch wi wch wch wnand wps wnand wch
    wch wnand wps wnand wph wch wi wph wch wi wnand wps wch wi wps wch wch
    wnand wnand wch wch wnand wps wnand wps wch wch wnand wnand wps wch wi wps
    wch nic-dfim nic-bi2 wch wch wnand wps nic-swap nic-ich nic-imp nic-ich
    nic-ich wps wch wi wph wch wi wph wch wi wnand wnand wps wch wi wph wch wi
    wi wps wch wi wph wch wi nic-dfim nic-bi1 nic-ich nic-ich wph wps wi wps
    wch wi wph wch wi wi wps wch wi wph wch wi wi wnand wnand wph wps wi wps
    wch wi wph wch wi wi wi wph wps wi wps wch wi wph wch wi wi nic-dfim
    nic-bi1 nic-mp $.
    $( [11-Dec-2008] $) $( [18-Nov-2007] $)

  $( Proof of ~ luk-2 from ~ nic-ax and ~ nic-mp .  (Contributed by Jeff
     Hoffman, 18-Nov-2007.) $)
  nic-luk2 $p |- ( ( -. ph ->  ph ) -> ph ) $=
    wph wn wph wi wph wph wnand wnand wph wn wph wi wph wi wph wn wph wi wph wi
    wph wn wph wi wph wph wnand wph wn wph wi wph wn wph wph wnand wnand wph wn
    wph wph wnand wnand wph wph wnand wph wn wph wph wnand wnand wph wn wph wi
    wph wn wph nic-dfim nic-bi2 wph wn wph wph wnand wph wph wnand wph wph
    wnand wph wn wnand wph wn wph wn wnand wph wph wnand wph wph wnand wnand
    wph wph wnand wph nic-dfneg wph wph wnand nic-id nic-iimp1 nic-isw2
    nic-iimp1 nic-isw1 wph wn wph wi wph wph wnand wnand wph wn wph wi wph wi
    wph wn wph wi wph nic-dfim nic-bi1 nic-mp $.
    $( [11-Dec-2008] $) $( [18-Nov-2007] $)

  $( Proof of ~ luk-3 from ~ nic-ax and ~ nic-mp .  (Contributed by Jeff
     Hoffman, 18-Nov-2007.) $)
  nic-luk3 $p |- ( ph -> ( -. ph -> ps ) ) $=
    wph wph wn wps wi wph wn wps wi wnand wnand wph wph wn wps wi wi wph wph wn
    wps wi wi wph wn wps wps wnand wph wn wps wi wph wph wn wps wps wnand wnand
    wph wn wps wi wph wn wps nic-dfim nic-bi1 wph wn wph wph wnand wph wph
    wnand wph wph wph wnand wph wn wph nic-dfneg nic-bi2 wph nic-id nic-iimp1
    nic-iimp2 wph wph wn wps wi wph wn wps wi wnand wnand wph wph wn wps wi wi
    wph wph wn wps wi nic-dfim nic-bi1 nic-mp $.
    $( [11-Dec-2008] $) $( [18-Nov-2007] $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Predicate calculus axiomatization
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The axioms of predicate calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols needed for pure predicate calculus. $)
  $c A. $. $( "inverted A" universal quantifier (read:  "for all") $)
  $c set $. $( Individual variable type (read:  "the following is an
             individual (set) variable" $)

  $( Declare some names for individual variables. $)
  $v x $.
  $v y $.
  $v z $.
  $v w $.
  $v v $.
  $v u $.
  $( Let ` x ` be an individual variable. $)
  vx $f set x $.
  $( Let ` y ` be an individual variable. $)
  vy $f set y $.
  $( Let ` z ` be an individual variable. $)
  vz $f set z $.
  $( Let ` w ` be an individual variable. $)
  vw $f set w $.
  $( Let ` v ` be an individual variable. $)
  vv $f set v $.
  $( Let ` u ` be an individual variable. $)
  vu $f set u $.

  $( Extend wff definition to include the universal quantifier ('for all').
     ` A. x ph ` is read " ` ph ` (phi) is true for all ` x ` ."  Typically,
     in its final application ` ph ` would be replaced with a wff containing
     a (free) occurrence of the variable ` x ` , for example ` x = y ` .
     In a universe with a finite number of objects, "for all" is equivalent
     to a big conjunction (AND) with one wff for each possible case of
     ` x ` .  When the universe is infinite (as with set theory), such a
     propositional-calculus equivalent is not possible because an infinitely
     long formula has no meaning, but conceptually the idea is the same. $)
  wal $a wff A. x ph $.

  $( Declare the equality predicate symbol. $)
  $c = $.  $( Equal sign (read:  'is equal to') $)

  $( --- Start of patch to prevent connective overloading $)
  $c class $.
  $( This syntax construction states that a variable ` x ` , which has been
     declared to be a set variable by $f statement vx, is also a class
     expression.  This can be justified informally as follows.  We know that
     the class builder ` { y | y e. x } ` is a class by ~ cab .  Since (when
     ` y ` is distinct from ` x ` ) we have ` x = { y | y e. x } ` by
     ~ cvjust , we can argue that that the syntax " ` class x ` " can be
     viewed as an abbreviation for " ` class { y | y e. x } ` ".  See the
     discussion under the definition of class in [Jech] p. 4 showing that
     "Every set can be considered to be a class."

     While it is tempting and perhaps occasionally useful to view ~ cv as a
     "type conversion" from a set variable to a class variable, keep in mind
     that ~ cv is intrinsically no different from any other class-building
     syntax such as ~ cab , ~ cun , or ~ c0 .

     (The description above applies to set theory, not predicate calculus.
     The purpose of introducing ` class x ` here, and not in set theory where
     it belongs, is to allow us to express i.e.  "prove" the ~ weq of
     predicate calculus from the ~ wceq of set theory, so that we don't
     "overload" the ` = ` connective with two syntax definitions.  This is
     done to prevent ambiguity that would complicate some Metamath
     parsers.)  $)
  cv $a class x $.

  ${
    $v A $.
    $v B $.
    wceq.cA $f class A $.
    wceq.cB $f class B $.
    $( Extend wff definition to include class equality.

       (The purpose of introducing ` wff A = B ` here, and not in set theory
       where it belongs, is to allow us to express i.e. "prove" the ~ weq of
       predicate calculus in terms of the ~ wceq of set theory, so that we
       don't "overload" the ` = ` connective with two syntax definitions.
       This is done to prevent ambiguity that would complicate some Metamath
       parsers.  For example, some parsers - although not the Metamath
       program - stumble on the fact that the ` = ` in ` x = y ` could be the
       ` = ` of either ~ weq or ~ wceq , although mathematically it makes no
       difference.  The class variables ` A ` and ` B ` are introduced
       temporarily for the purpose of this definition but otherwise not used
       in predicate calculus.  See ~ df-cleq for more information on the set
       theory usage of ~ wceq .) $)
    wceq $a wff A = B $.
  $}

  $( Extend wff definition to include atomic formulas using the equality
     predicate.

     (Instead of introducing ~ weq as an axiomatic statement, as was done
     in an older version of this database, we introduce it by "proving" a
     special case of set theory's more general ~ wceq .  This lets us avoid
     overloading the ` = ` connective, thus preventing ambiguity that would
     complicate certain Metamath parsers.  However, logically ~ weq is
     considered to be a primitive syntax, even though here it is artificially
     "derived" from ~ wceq .  Note: To see the proof steps of this syntax
     proof, type "show proof weq /all" in the Metamath program.) $)
  weq $p wff x = y $=
    vx cv vy cv wceq $.
    $( [24-Jan-2006] $)
  $( --- End of patch to prevent connective overloading $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include atomic formulas using the equality
     predicate.

     After we introduce ~ cv and ~ wceq in set theory, this syntax construction
     becomes redundant, since it can be derived with the proof
     "vx cv vy cv wceq". @)
  weq @a wff x = y @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Declare the membership predicate symbol. $)
  $c e. $. $( Stylized epsilon $)

  $( --- Start of patch to prevent connective overloading $)
  ${
    $v A $.
    $v B $.
    wcel.cA $f class A $.
    wcel.cB $f class B $.
    $( Extend wff definition to include the membership connective between
       classes.

       (The purpose of introducing ` wff A e. B ` here is to allow us to
       express i.e. "prove" the ~ wel of predicate calculus in terms of the
       ~ wceq of set theory, so that we don't "overload" the ` e. ` connective
       with two syntax definitions.  This is done to prevent ambiguity that
       would complicate some Metamath parsers.  The class variables ` A ` and
       ` B ` are introduced temporarily for the purpose of this definition but
       otherwise not used in predicate calculus.  See ~ df-clab for more
       information on the set theory usage of ~ wcel .) $)
    wcel $a wff A e. B $.
  $}

  $( Extend wff definition to include atomic formulas with the epsilon
     (membership) predicate.  This is read " ` x ` is an element of ` y ` ,"
     " ` x ` is a member of ` y ` ," " ` x ` belongs to ` y ` ," or " ` y `
     contains ` x ` ."  Note:  The phrase " ` y ` includes ` x ` " means
     " ` x ` is a subset of ` y ` ;" to use it also for ` x e. y ` , as some
     authors occasionally do, is poor form and causes confusion, according to
     George Boolos (1992 lecture at MIT).

     This syntactical construction introduces a binary non-logical predicate
     symbol ` e. ` (epsilon) into our predicate calculus.  We will eventually
     use it for the membership predicate of set theory, but that is
     irrelevant at this point:  the predicate calculus axioms for ` e. `
     apply to any arbitrary binary predicate symbol.  "Non-logical" means
     that the predicate is presumed to have additional properties beyond the
     realm of predicate calculus, although these additional properties are
     not specified by predicate calculus itself but rather by the axioms of a
     theory (in our case set theory) added to predicate calculus.  "Binary"
     means that the predicate has two arguments.

     (Instead of introducing ~ wel as an axiomatic statement, as was done
     in an older version of this database, we introduce it by "proving" a
     special case of set theory's more general ~ wcel .  This lets us avoid
     overloading the ` e. ` connective, thus preventing ambiguity that would
     complicate certain Metamath parsers.  However, logically ~ wel is
     considered to be a primitive syntax, even though here it is artificially
     "derived" from ~ wcel .  Note: To see the proof steps of this syntax
     proof, type "show proof wel /all" in the Metamath program.) $)
  wel $p wff x e. y $=
    vx cv vy cv wcel $.
    $( [24-Jan-2006] $)
  $( --- End of patch to prevent connective overloading $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include atomic formulas with the epsilon
     (membership) predicate.  This is read " ` x ` is an element of ` y ` ,"
     " ` x ` is a member of ` y ` ," " ` x ` belongs to ` y ` ," or " ` y `
     contains ` x ` ."  Note:  The phrase " ` y ` includes ` x ` " means
     " ` x ` is a subset of ` y ` "; to use it also for ` x e. y ` (as some
     authors occasionally do) is poor form and causes confusion.

     After we introduce ~ cv and ~ wcel in set theory, this syntax construction
     becomes redundant, since it can be derived with the proof
     "vx cv vy cv wcel". @)
  wel @a wff x e. y @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Axiom of Quantified Implication.  Axiom C4 of [Monk2] p. 105. $)
  ax-5 $a |- ( A. x ( ph -> ps ) -> ( A. x ph -> A. x ps ) ) $.

  $( Axiom of Quantified Negation.  Axiom C5-2 of [Monk2] p. 113. $)
  ax-6 $a |- ( -. A. x ph -> A. x -. A. x ph ) $.

  $( Axiom of Quantifier Commutation.  This axiom says universal quantifiers
     can be swapped.  One of the 4 axioms of pure predicate calculus.  Axiom
     scheme C6' in [Megill] p. 448 (p. 16 of the preprint).  Also appears as
     Lemma 12 of [Monk2] p. 109 and Axiom C5-3 of [Monk2] p. 113.  An
     alternate axiomatization could use ~ ax467 in place of ~ ax-4 , ~ ax-6o ,
     and ~ ax-7 . $)
  ax-7 $a |- ( A. x A. y ph -> A. y A. x ph ) $.

  ${
    ax-g.1 $e |- ph $.
    $( Rule of Generalization.  The postulated inference rule of pure predicate
       calculus.  See e.g. Rule 2 of [Hamilton] p. 74.  This rule says that if
       something is unconditionally true, then it is true for all values of a
       variable.  For example, if we have proved ` x = x ` , we can conclude
       ` A. x x = x ` or even ` A. y x = x ` .  Theorem ~ a4i shows we can go
      the other way also:  in other words we can add or remove universal
      quantifiers from the beginning of any theorem as required. $)
    ax-gen $a |- A. x ph $.
  $}

  $( Axiom of Equality.  One of the equality and substitution axioms of
     predicate calculus with equality.  This is similar to, but not quite, a
     transitive law for equality (proved later as ~ equtr ).  Axiom scheme C8'
     in [Megill] p. 448  (p. 16 of the preprint).  Also appears as Axiom C7 of
     [Monk2] p. 105.

     Axioms ~ ax-8 through ~ ax-16 are the axioms having to do with
     equality, substitution, and logical properties of our binary predicate
     ` e. ` (which later in set theory will mean "is a member of").  Note
     that all axioms except ~ ax-16 and ~ ax-17 are still valid even when
     ` x ` , ` y ` , and ` z ` are replaced with the same variable because they
     do not have any distinct variable (Metamath's $d) restrictions.  Distinct
     variable restrictions are required for ~ ax-16 and ~ ax-17 only. $)
  ax-8 $a |- ( x = y -> ( x = z -> y = z ) ) $.

  $( Axiom of Existence.  One of the equality and substitution axioms of
     predicate calculus with equality.  One thing this axiom tells us is that
     at least one thing exists (although ~ ax-4 and possibly others also tell
     us that, i.e. they are not valid in the empty domain of a "free logic.")
     In this form (not requiring that ` x ` and ` y ` be distinct) it was
     used in an axiom system of Tarski (see Axiom B7' in footnote 1 of
     [KalishMontague] p. 81.)  It is equivalent to axiom scheme C10' in
     [Megill] p. 448 (p. 16 of the preprint); the equivalence is established
     by ~ ax9o and ~ ax9 . A more convenient form of this axiom is ~ a9e ,
     which has additional remarks.

     Raph Levien proved the independence of this axiom from the others on
     12-Apr-2005.  See item 16 at
     ~ http://us.metamath.org/award2003.html . $)
  ax-9 $a |- -. A. x -. x = y $.

  $( Axiom of Quantifier Substitution.  One of the equality and substitution
     axioms of predicate calculus with equality.  Appears as Lemma L12 in
     [Megill] p. 445 (p. 12 of the preprint).

     The original version of this axiom was ~ ax-10o ("o" for "old") and was
     replaced with this shorter ~ ax-10 in May 2008.  The old axiom is proved
     from this one as theorem ~ ax10o .  Conversely, this axiom is proved from
     ~ ax-10o as theorem ~ ax10 . $)
  ax-10 $a |- ( A. x x = y -> A. y y = x ) $.

  $( Axiom of Variable Substitution.  One of the 5 equality axioms of predicate
     calculus.  The final consequent ` A. x ( x = y -> ph ) ` is a way of
     expressing " ` y ` substituted for ` x ` in wff ` ph ` " (cf. ~ sb6 ).
     It is based on Lemma 16 of [Tarski] p. 70 and Axiom C8 of [Monk2] p. 105,
     from which it can be proved by cases.

     The original version of this axiom was ~ ax-11o ("o" for "old") and was
     replaced with this shorter ~ ax-11 in Jan. 2007.  The old axiom is proved
     from this one as theorem ~ ax11o .  Conversely, this axiom is proved from
     ~ ax-11o as theorem ~ ax11 .

     Juha Arpiainen proved the independence of this axiom (in the form of the
     older axiom ~ ax-11o ) from the others on 19-Jan-2006.  See item 9a at
     ~ http://us.metamath.org/award2003.html .

     Interestingly, if the wff expression substituted for ` ph ` contains no
     wff variables, the resulting statement _can_ be proved without invoking
     this axiom.  This means that even though this axiom is _metalogically_
     independent from the others, it is not _logically_ independent.
     Specifically, we can prove any wff-variable-free instance of axiom
     ~ ax-11o (from which the ~ ax-11 instance follows by theorem ~ ax11 .)
     The proof is by induction on formula length, using ~ ax11eq and ~ ax11el
     for the basis steps and ~ ax11indn , ~ ax11indi , and ~ ax11inda for the
     induction steps.

     See also ~ ax11v and ~ ax11v2 for other equivalents of this axiom that
     (unlike this axiom) have distinct variable restrictions. $)
  ax-11 $a |- ( x = y -> ( A. y ph -> A. x ( x = y -> ph ) ) ) $.

  $( Axiom of Quantifier Introduction.  One of the equality and substitution
     axioms of predicate calculus with equality.  Informally, it says that
     whenever ` z ` is distinct from ` x ` and ` y ` , and ` x = y ` is true,
     then ` x = y ` quantified with ` z ` is also true.  In other words, ` z `
     is irrelevant to the truth of ` x = y ` .  Axiom scheme C9' in [Megill]
     p. 448  (p. 16 of the preprint).  It apparently does not otherwise appear
     in the literature but is easily proved from textbook predicate calculus
     by cases.

     An open problem is whether this axiom is redundant.  Note that the
     analogous axiom for the membership connective, ~ ax-15 , has been shown
     to be redundant.  It is also unknown whether this axiom can be replaced
     by a shorter formula.  However, it can be derived from two slightly
     shorter formulas, as shown by ~ a12study . $)
  ax-12 $a |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x = y -> A. z x = y ) ) ) $.

  $( Axiom of Equality.  One of the equality and substitution axioms for a
     non-logical predicate in our predicate calculus with equality.  It
     substitutes equal variables into the left-hand side of the ` e. ` binary
     predicate.  Axiom scheme C12' in [Megill] p. 448  (p. 16 of the preprint).
     It is a special case of Axiom B8 (p. 75) of system S2 of [Tarski] p. 77.
     "Non-logical" means that the predicate is not a primitive of predicate
     calculus proper but instead is an extension to it.  "Binary" means that
     the predicate has two arguments.  In a system of predicate calculus with
     equality, like ours, equality is not usually considered to be a
     non-logical predicate.  In systems of predicate calculus without equality,
     it typically would be. $)
  ax-13 $a |- ( x = y -> ( x e. z -> y e. z ) ) $.

  $( Axiom of Equality.  One of the equality and substitution axioms for a
     non-logical predicate in our predicate calculus with equality.  It
     substitutes equal variables into the right-hand side of the ` e. ` binary
     predicate.  Axiom scheme C13' in [Megill] p. 448  (p. 16 of the preprint).
     It is a special case of Axiom B8 (p. 75) of system S2 of [Tarski]
     p. 77. $)
  ax-14 $a |- ( x = y -> ( z e. x -> z e. y ) ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Some theorems that use neither ax-17 nor ax-4
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A more general version of ~ hbequid2 using ~ ax-5 , ~ ax-8 , ~ ax-12 , and
     ~ ax-gen . $)
  hbequid $p |- ( x = x -> A. y x = x ) $=
    vy cv vx cv wceq vy wal vy cv vx cv wceq vy wal vx cv vx cv wceq vx cv vx
    cv wceq vy wal wi vx vx vy ax-12 vy cv vx cv wceq vy wal vx cv vx cv wceq
    vy wal vx cv vx cv wceq vy cv vx cv wceq vx cv vx cv wceq wi vy wal vy cv
    vx cv wceq vy wal vx cv vx cv wceq vy wal wi vy cv vx cv wceq vx cv vx cv
    wceq wi vy vy cv vx cv wceq vx cv vx cv wceq vy vx vx ax-8 pm2.43i ax-gen
    vy cv vx cv wceq vx cv vx cv wceq vy ax-5 ax-mp a1d vy cv vx cv wceq vy wal
    vx cv vx cv wceq vy wal vx cv vx cv wceq vy cv vx cv wceq vx cv vx cv wceq
    wi vy wal vy cv vx cv wceq vy wal vx cv vx cv wceq vy wal wi vy cv vx cv
    wceq vx cv vx cv wceq wi vy vy cv vx cv wceq vx cv vx cv wceq vy vx vx ax-8
    pm2.43i ax-gen vy cv vx cv wceq vx cv vx cv wceq vy ax-5 ax-mp a1d pm2.61ii
    $.
    $( [13-Jan-2011] $) $( [13-Jan-2011] $)

  $( ~ equid with existential quantifier without using ~ ax-4 or ~ ax-17 . $)
  equidqe $p |- -. A. y -. x = x $=
    vx vx weq wn vy wal vy vx weq wn vy wal vy vx ax-9 vx vx weq wn vy vx weq
    wn wi vy wal vx vx weq wn vy wal vy vx weq wn vy wal wi vx vx weq wn vy vx
    weq wn wi vy vy vx weq vx vx weq vy vx weq vx vx weq vy vx vx ax-8 pm2.43i
    con3i ax-gen vx vx weq wn vy vx weq wn vy ax-5 ax-mp mto $.
    $( [13-Jan-2011] $) $( [13-Jan-2011] $)

  $( ~ equid with universal quantifier without using ~ ax-4 or ~ ax-17 . $)
  equidq $p |- A. y x = x $=
    vx vx weq vy wal vx vx weq wn vy wal vx vy equidqe vx vx weq vy wal wn vx
    vx weq vy wal wn vy wal vx vx weq wn vy wal vx vx weq vy ax-6 vx vx weq vy
    wal wn vx vx weq wn wi vy wal vx vx weq vy wal wn vy wal vx vx weq wn vy
    wal wi vx vx weq vy wal wn vx vx weq wn wi vy vx vx weq vx vx weq vy wal vx
    vy hbequid con3i ax-gen vx vx weq vy wal wn vx vx weq wn vy ax-5 ax-mp syl
    mt3 $.
    $( [13-Jan-2011] $) $( [13-Jan-2011] $)

  $( A special case of ~ ax-4 without using ~ ax-4 or ~ ax-17 . $)
  ax4sp1 $p |- ( A. y -. x = x -> -. x = x ) $=
    vx vx weq wn vy wal vx vx weq wn vx vy equidqe pm2.21i $.
    $( [13-Jan-2011] $) $( [13-Jan-2011] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Axiom ax-17 - first use of the $d distinct variable statement
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d x ph $.
    $( Axiom to quantify a variable over a formula in which it does not occur.
       Axiom C5 in [Megill] p. 444 (p. 11 of the preprint).  Also appears as
       Axiom B6 (p. 75) of system S2 of [Tarski] p. 77 and Axiom C5-1 of
       [Monk2] p. 113.

       This axiom is _logically_ redundant in the (logically complete)
       predicate calculus axiom system consisting of ~ ax-gen , ~ ax-4 through
       ~ ax-9 , ~ ax-10o , and ~ ax-12 through ~ ax-16 :  in that system, we
       can derive any instance of ~ ax-17 not containing wff variables by
       induction on formula length, using ~ ax17eq and ~ ax17el for the basis
       together ~ hbn , ~ hbal , and ~ hbim .  However, if we omit this axiom,
       our development would be quite inconvenient since we could work only
       with specific instances of wffs containing no wff variables - this axiom
       introduces the concept of a set variable not occurring in a wff (as
       opposed to just two set variables being distinct). $)
    ax-17 $a |- ( ph -> A. x ph ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Derive ax-4, ax-5o, and ax-6o
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.  $d y ph $.
    $( Theorem showing that ~ ax-4 can be derived from ~ ax-5 , ~ ax-gen ,
       ~ ax-8 , ~ ax-9 , ~ ax-11 , and ~ ax-17 and is therefore redundant in a
       system including the latter axioms.  Lemma 21 of [Monk2] p. 114.

       This theorem should not be referenced in any proof.  Instead, we will
       use ~ ax-4 below so that explicit uses of ~ ax-4 can be more easily
       identified.  In particular, this will more cleanly separate out the
       theorems of "pure" predicate calculus that don't involve equality or
       distinct variables.  A beginner may wish to accept ~ ax-4 a priori, so
       that the proof of this theorem ( ~ ax4 ), which involves equality as
       well as the distinct variable requirements of ~ ax-17 , can be put off
       until those axioms are studied.

       Note:  All predicate calculus axioms introduced from this point forward
       are redundant.  Immediately before their introduction, we prove them
       from earlier axioms to demonstrate their redundancy.  Specifically,
       redundant axioms ~ ax-4 , ~ ax-5o , ~ ax-6o , ~ ax-9o , ~ ax-10o ,
       ~ ax-11o , ~ ax-15 , and ~ ax-16 are proved by theorems ~ ax4 , ~ ax5o ,
       ~ ax6o , ~ ax9o , ~ ax10o , ~ ax11o , ~ ax15 , and ~ ax16 .  We never
       reference those theorems directly - instead, we use the axiom version
       that immediately follows it - in order to better isolate the uses of
       the redundant axioms for easier study of subsystems containing them. $)
    ax4 $p |- ( A. x ph -> ph ) $=
      wph vx wal wph wi vy vx weq wn vy wal vy vx ax-9 wph vx wal wph wi wn wph
      vx wal wph wi wn vy wal vy vx weq wn vy wal wph vx wal wph wi wn vy ax-17
      wph vx wal wph wi wn vy vx weq wn wi vy wal wph vx wal wph wi wn vy wal
      vy vx weq wn vy wal wi wph vx wal wph wi wn vy vx weq wn wi vy vy vx weq
      wph vx wal wph wi vy vx weq wph wph vx wal vy vx weq wph wn wph vx wal vx
      vy weq wn vx wal wi wph vx wal wn vy vx weq wph wn wph vx vy weq wn wi vx
      wal wph vx wal vx vy weq wn vx wal wi vy vx weq wph wn vx vy weq wph wn
      wi vx wal wph vx vy weq wn wi vx wal vy vx weq wph wn vy wal vx vy weq
      wph wn wi vx wal wph wn vy vx weq vx vy weq wph wn vy wal vx vy weq wph
      wn wi vx wal wi vy vx weq vy vy weq vx vy weq vy vy weq vx vy weq wn vx
      wal vx vy ax-9 vy vy weq wn vy vy weq wn vx wal vx vy weq wn vx wal vy vy
      weq wn vx ax-17 vy vy weq wn vx vy weq wn wi vx wal vy vy weq wn vx wal
      vx vy weq wn vx wal wi vy vy weq wn vx vy weq wn wi vx vx vy weq vy vy
      weq vx vy weq vy vy weq vx vy vy ax-8 pm2.43i con3i ax-gen vy vy weq wn
      vx vy weq wn vx ax-5 ax-mp syl mt3 vy vx vy ax-8 mpi wph wn vx vy ax-11
      syl wph wn vy ax-17 syl5 vx vy weq wph wn wi wph vx vy weq wn wi wi vx
      wal vx vy weq wph wn wi vx wal wph vx vy weq wn wi vx wal wi vx vy weq
      wph wn wi wph vx vy weq wn wi wi vx vx vy weq wph con2 ax-gen vx vy weq
      wph wn wi wph vx vy weq wn wi vx ax-5 ax-mp syl6 wph vx vy weq wn vx ax-5
      syl6 wph vx wal vx vy weq wn vx wal wi vx vy weq wn vx wal wn wph vx wal
      wn vx vy ax-9 wph vx wal vx vy weq wn vx wal con3 mpi syl6 con4d con3i
      ax-gen wph vx wal wph wi wn vy vx weq wn vy ax-5 ax-mp syl mt3 $.
      $( [21-May-2008] $) $( [21-May-2008] $)
  $}

  $( Axiom of Specialization.  A quantified wff implies the wff without a
     quantifier (i.e. an instance, or special case, of the generalized wff).
     In other words if something is true for all ` x ` , it is true for any
     specific ` x ` (that would typically occur as a free variable in the wff
     substituted for ` ph ` ). (A free variable is one that does not occur in
     the scope of a quantifier:  ` x ` and ` y ` are both free in ` x = y ` ,
     but only ` x ` is free in ` A. y x = y ` .)  This is one of the axioms
     of what we call "pure" predicate calculus ( ~ ax-4 through ~ ax-7 plus
     rule ~ ax-gen ).  Axiom scheme C5' in [Megill] p. 448 (p. 16 of the
     preprint).  Also appears as Axiom B5 of [Tarski] p. 67 (under his system
     S2, defined in the last paragraph on p. 77).

     Note that the converse of this axiom does not hold in general, but a
     weaker inference form of the converse holds and is expressed as rule
     ~ ax-gen . Conditional forms of the converse are given by ~ ax-12 ,
     ~ ax-15 , ~ ax-16 , and ~ ax-17 .

     Unlike the more general textbook Axiom of Specialization, we cannot
     choose a variable different from ` x ` for the special case.  For use,
     that requires the assistance of equality axioms, and we deal with it
     later after we introduce the definition of proper substitution - see
     ~ stdpc4 .

     An nice alternate axiomatization uses ~ ax467 and ~ ax-5o in place
     of ~ ax-4 , ~ ax-5 , ~ ax-6 , and ~ ax-7 .

     This axiom is redundant in the presence of certain other axioms, as shown
     by theorem ~ ax4 .  (We replaced the older ~ ax-5o and ~ ax-6o with newer
     versions ~ ax-5 and ~ ax-6 in order to prove this redundancy.) $)
  ax-4 $a |- ( A. x ph -> ph ) $.

  $( Show that the original axiom ~ ax-5o can be derived from ~ ax-5 and
     others.  See ~ ax5 for the rederivation of ~ ax-5 from ~ ax-5o .

     Part of the proof is based on the proof of Lemma 22 of [Monk2] p. 114.

     This theorem should not be referenced in any proof.  Instead, use ~ ax-5o
     below so that uses of ~ ax-5o can be more easily identified. $)
  ax5o $p |- ( A. x ( A. x ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    wph vx wal wps wi vx wal wph vx wal vx wal wps vx wal wph vx wal wph vx wal
    wps vx ax-5 wph vx wal wph vx wal wn vx wal wn wph vx wal wn vx wal wn vx
    wal wph vx wal vx wal wph vx wal wn vx wal wph vx wal wph vx wal wn vx ax-4
    con2i wph vx wal wn vx ax-6 wph vx wal wn vx wal wn wph vx wal wi vx wal
    wph vx wal wn vx wal wn vx wal wph vx wal vx wal wi wph vx wal wn vx wal wn
    wph vx wal wi vx wph vx wal wph vx wal wn vx wal wph vx ax-6 con1i ax-gen
    wph vx wal wn vx wal wn wph vx wal vx ax-5 ax-mp 3syl syl5 $.
    $( [22-May-2008] $) $( [21-May-2008] $)

  $( Axiom of Quantified Implication.  This axiom moves a quantifier from
     outside to inside an implication, quantifying ` ps ` .  Notice that
     ` x ` must not be a free variable in the antecedent of the quantified
     implication, and we express this by binding ` ph ` to "protect" the
     axiom from a ` ph ` containing a free ` x ` .  One of the 4 axioms of
     "pure" predicate calculus.  Axiom scheme C4' in [Megill] p. 448 (p. 16 of
     the preprint).  It is a special case of Lemma 5 of [Monk2] p. 108 and
     Axiom 5 of [Mendelson] p. 69.

     This axiom is redundant, as shown by theorem ~ ax5o . $)
  ax-5o $a |- ( A. x ( A. x ph -> ps ) -> ( A. x ph -> A. x ps ) ) $.

  $( Rederivation of axiom ~ ax-5 from the orginal version, ~ ax-5o .
     See ~ ax5o for the derivation of ~ ax-5o from ~ ax-5 .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-5
     above so that uses of ~ ax-5 can be more easily identified.

     Note:  This is the same as theorem ~ 19.20 below.  It is proved separately
     here so that it won't be dependent on the axioms used for ~ 19.20 (which
     may change in the future). $)
  ax5 $p |- ( A. x ( ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    wph wps wi vx wal wph vx wal wps wi vx wal wph vx wal wps vx wal wi wph wps
    wi vx wal wph vx wal wps wi wi vx wal wph wps wi vx wal wph vx wal wps wi
    vx wal wi wph wps wi vx wal wph vx wal wps wi wi vx wph wps wi vx wal wph
    wps wph vx wal wph wps wi vx ax-4 wph vx ax-4 syl5 ax-gen wph wps wi wph vx
    wal wps wi vx ax-5o ax-mp wph wps vx ax-5o syl $.
    $( [5-Dec-2010] $) $( [23-May-2008] $)

  $( Show that the original axiom ~ ax-6o can be derived from ~ ax-6 and
     others.  See ~ ax6 for the rederivation of ~ ax-6 from ~ ax-6o .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-6o
     below so that uses of ~ ax-6o can be more easily identified. $)
  ax6o $p |- ( -. A. x -. A. x ph -> ph ) $=
    wph vx wal wph wph vx wal wn vx wal wph vx ax-4 wph vx ax-6 nsyl4 $.
    $( [22-May-2008] $) $( [21-May-2008] $)

  $( Axiom of Quantified Negation.  This axiom is used to manipulate negated
     quantifiers.  One of the 4 axioms of pure predicate calculus.  Equivalent
     to axiom scheme C7' in [Megill] p. 448 (p. 16 of the preprint).  An
     alternate axiomatization could use ~ ax467 in place of ~ ax-4 , ~ ax-6o ,
     and ~ ax-7 .

     This axiom is redundant, as shown by theorem ~ ax6o . $)
  ax-6o $a |- ( -. A. x -. A. x ph -> ph ) $.

  $( Rederivation of axiom ~ ax-6 from the orginal version, ~ ax-6o .
     See ~ ax6o for the derivation of ~ ax-6o from ~ ax-6 .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-6
     above so that uses of ~ ax-6 can be more easily identified. $)
  ax6 $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
    wph vx wal vx wal wn vx wal wph vx wal wn vx wal wph vx wal wph vx wal vx
    wal wn vx wal wph vx wal wn wi vx wal wph vx wal vx wal wn vx wal wph vx
    wal wn vx wal wi wph vx wal vx wal wn vx wal wph vx wal wn wi vx wph vx wal
    vx wal wn vx wal wph vx wal vx wal wph vx wal wph vx wal vx wal wn vx ax-4
    wph vx wal wph vx wal wi vx wal wph vx wal wph vx wal vx wal wi wph vx wal
    wph vx wal wi vx wph vx wal id ax-gen wph wph vx wal vx ax-5o ax-mp nsyl
    ax-gen wph vx wal vx wal wn wph vx wal wn vx ax-5o ax-mp wph vx wal vx
    ax-6o nsyl4 $.
    $( [23-May-2008] $) $( [23-May-2008] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Predicate calculus without distinct variables
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    "Pure" predicate calculus ax-4, ax-5o, ax-6o, ax-gen
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( Declare the existential quantifier symbol. $)
  $c E. $.   $( Backwards E (read:  "there exists") $)

  $( Extend wff definition to include the existential quantifier ("there
     exists"). $)
  wex $a wff E. x ph $.

  $( Define existential quantification.  ` E. x ph ` means "there exists at
     least one set ` x ` such that ` ph ` is true."  Definition of [Margaris]
     p. 49. $)
  df-ex $a |- ( E. x ph <-> -. A. x -. ph ) $.

  ${
    a4i.1 $e |- A. x ph $.
    $( Inference rule reversing generalization. $)
    a4i $p |- ph $=
      wph vx wal wph a4i.1 wph vx ax-4 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    gen2.1 $e |- ph $.
    $( Generalization applied twice. $)
    gen2 $p |- A. x A. y ph $=
      wph vy wal vx wph vy gen2.1 ax-gen ax-gen $.
      $( [30-Apr-1998] $)
  $}

  ${
    a4s.1 $e |- ( ph -> ps ) $.
    $( Generalization of antecedent. $)
    a4s $p |- ( A. x ph -> ps ) $=
      wph vx wal wph wps wph vx ax-4 a4s.1 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    a4sd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction generalizing antecedent. $)
    a4sd $p |- ( ph -> ( A. x ps -> ch ) ) $=
      wph wps wch wps vx wal a4sd.1 wps vx ax-4 syl5 $.
      $( [17-Aug-1994] $)
  $}

  ${
    mpg.1 $e |- ( A. x ph -> ps ) $.
    mpg.2 $e |- ph $.
    $( Modus ponens combined with generalization. $)
    mpg $p |- ps $=
      wph vx wal wps wph vx mpg.2 ax-gen mpg.1 ax-mp $.
      $( [24-May-1994] $)
  $}

  ${
    mpgbi.1 $e |- ( A. x ph <-> ps ) $.
    mpgbi.2 $e |- ph $.
    $( Modus ponens on biconditional combined with generalization.  (The proof
       was shortened by Stefan Allan, 28-Oct-2008.) $)
    mpgbi $p |- ps $=
      wph vx wal wps wph vx mpgbi.2 ax-gen mpgbi.1 mpbi $.
      $( [31-Oct-2008] $) $( [24-May-1994] $)
  $}

  ${
    mpgbir.1 $e |- ( ph <-> A. x ps ) $.
    mpgbir.2 $e |- ps $.
    $( Modus ponens on biconditional combined with generalization.  (The proof
       was shortened by Stefan Allan, 28-Oct-2008.) $)
    mpgbir $p |- ph $=
      wph wps vx wal wps vx mpgbir.2 ax-gen mpgbir.1 mpbir $.
      $( [31-Oct-2008] $) $( [24-May-1994] $)
  $}

  ${
    a5i.1 $e |- ( A. x ph -> ps ) $.
    $( Inference from ~ ax-5o . $)
    a5i $p |- ( A. x ph -> A. x ps ) $=
      wph vx wal wps wi wph vx wal wps vx wal wi vx wph wps vx ax-5o a5i.1 mpg
      $.
      $( [5-Aug-1993] $)
  $}

  $( Abbreviated version of ~ ax-6o . $)
  a6e $p |- ( E. x A. x ph -> ph ) $=
    wph vx wal vx wex wph vx wal wn vx wal wn wph wph vx wal vx df-ex wph vx
    ax-6o sylbi $.
    $( [5-Aug-1993] $)

  ${
    a7s.1 $e |- ( A. x A. y ph -> ps ) $.
    $( Swap quantifiers in an antecedent. $)
    a7s $p |- ( A. y A. x ph -> ps ) $=
      wph vx wal vy wal wph vy wal vx wal wps wph vy vx ax-7 a7s.1 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.20i.1 $e |- ( ph -> ps ) $.
    $( Inference quantifying both antecedent and consequent. $)
    19.20i $p |- ( A. x ph -> A. x ps ) $=
      wph wps vx wph wps vx 19.20i.1 a4s a5i $.
      $( [5-Aug-1993] $)

    $( Inference doubly quantifying both antecedent and consequent. $)
    19.20i2 $p |- ( A. x A. y ph -> A. x A. y ps ) $=
      wph vy wal wps vy wal vx wph wps vy 19.20i.1 19.20i 19.20i $.
      $( [5-Feb-2005] $) $( [3-Feb-2005] $)
  $}

  $( Theorem 19.20 of [Margaris] p. 90.  (The proof was shortened by O'Cat,
     30-Mar-2008.) $)
  19.20 $p |- ( A. x ( ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    wph wps wi vx wal wph vx wal wps wi vx wal wph vx wal wps vx wal wi wph wps
    wi wph vx wal wps wi vx wph wps wi wph wps vx wph wps wi id a4sd 19.20i wph
    wps vx ax-5o syl $.
    $( [30-Mar-2008] $) $( [5-Aug-1993] $)

  ${
    19.20ii.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference quantifying antecedent, nested antecedent, and consequent. $)
    19.20ii $p |- ( A. x ph -> ( A. x ps -> A. x ch ) ) $=
      wph vx wal wps wch wi vx wal wps vx wal wch vx wal wi wph wps wch wi vx
      19.20ii.1 19.20i wps wch vx 19.20 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.20d.1 $e |- ( ph -> A. x ph ) $.
    19.20d.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.20 of [Margaris] p. 90. $)
    19.20d $p |- ( ph -> ( A. x ps -> A. x ch ) ) $=
      wph wph vx wal wps vx wal wch vx wal wi 19.20d.1 wph wps wch vx 19.20d.2
      19.20ii syl $.
      $( [4-Jan-2002] $)
  $}

  $( Theorem 19.15 of [Margaris] p. 90. $)
  19.15 $p |- ( A. x ( ph <-> ps ) -> ( A. x ph <-> A. x ps ) ) $=
    wph wps wb vx wal wph vx wal wps vx wal wph wps wb wph wps vx wph wps bi1
    19.20ii wph wps wb wps wph vx wph wps bi2 19.20ii impbid $.
    $( [5-Aug-1993] $)

  ${
    19.21ai.1 $e |- ( ph -> A. x ph ) $.
    19.21ai.2 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90. $)
    19.21ai $p |- ( ph -> A. x ps ) $=
      wph wph vx wal wps vx wal 19.21ai.1 wph wps vx 19.21ai.2 19.20i syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    albii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding universal quantifier to both sides of an
       equivalence. $)
    albii $p |- ( A. x ph <-> A. x ps ) $=
      wph wps wb wph vx wal wps vx wal wb vx wph wps vx 19.15 albii.1 mpg $.
      $( [7-Aug-1994] $)

    $( Inference adding 2 universal quantifiers to both sides of an
       equivalence. $)
    2albii $p |- ( A. x A. y ph <-> A. x A. y ps ) $=
      wph vy wal wps vy wal vx wph wps vy albii.1 albii albii $.
      $( [9-Mar-1997] $)
  $}

  ${
    hbth.1 $e |- ph $.
    $( No variable is (effectively) free in a theorem.

       This and later "hypothesis-building" lemmas, with labels starting
       "hb...", allow us to construct proofs of formulas of the form
       ` |- ( ph -> A. x ph ) ` from smaller formulas of this form.  These are
       useful for constructing hypotheses that state
       " ` x ` is (effectively) not free in ` ph ` ." $)
    hbth $p |- ( ph -> A. x ph ) $=
      wph vx wal wph wph vx hbth.1 ax-gen a1i $.
      $( [5-Aug-1993] $)
  $}

  $( Closed theorem version of bound-variable hypothesis builder ~ hbn . $)
  hbnt $p |- ( A. x ( ph -> A. x ph ) -> ( -. ph -> A. x -. ph ) ) $=
    wph wph vx wal wi vx wal wph vx wal wn vx wal wph wn vx wal wph wn wph wph
    vx wal wi wph vx wal wn wph wn vx wph wph vx wal con3 19.20ii wph vx wal wn
    vx wal wph wph vx ax-6o con1i syl5 $.
    $( [5-Aug-1993] $)

  $( ` x ` is not free in ` A. x ph ` .  Example in Appendix in [Megill]
     p. 450 (p. 19 of the preprint).  Also Lemma 22 of [Monk2] p. 114. $)
  hba1 $p |- ( A. x ph -> A. x A. x ph ) $=
    wph wph vx wal vx wph vx wal id a5i $.
    $( [5-Aug-1993] $)

  ${
    hb.1 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` -. ph ` . $)
    hbn $p |- ( -. ph -> A. x -. ph ) $=
      wph wph vx wal wi wph wn wph wn vx wal wi vx wph vx hbnt hb.1 mpg $.
      $( [5-Aug-1993] $)

    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` . $)
    hbal $p |- ( A. y ph -> A. x A. y ph ) $=
      wph vy wal wph vx wal vy wal wph vy wal vx wal wph wph vx wal vy hb.1
      19.20i wph vy vx ax-7 syl $.
      $( [5-Aug-1993] $)

    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` . $)
    hbex $p |- ( E. y ph -> A. x E. y ph ) $=
      wph wn vy wal wn wph wn vy wal wn vx wal wph vy wex wph vy wex vx wal wph
      wn vy wal vx wph wn vx vy wph vx hb.1 hbn hbal hbn wph vy df-ex wph vy
      wex wph wn vy wal wn vx wph vy df-ex albii 3imtr4i $.
      $( [5-Aug-1993] $)

    ${
      hb.2 $e |- ( ps -> A. x ps ) $.
      $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
         ` ( ph -> ps ) ` .  (The proof was shortened by O'Cat, 3-Mar-2008.) $)
      hbim $p |- ( ( ph -> ps ) -> A. x ( ph -> ps ) ) $=
        wph wps wph wps wi vx wal wph wn wph wps wi vx wph vx hb.1 hbn wph wps
        pm2.21 19.21ai wps wph wps wi vx hb.2 wps wph ax-1 19.21ai ja $.
        $( [4-Mar-2008] $)  $( [5-Aug-1993] $)

      $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
         ` ( ph \/ ps ) ` . $)
      hbor $p |- ( ( ph \/ ps ) -> A. x ( ph \/ ps ) ) $=
        wph wn wps wi wph wn wps wi vx wal wph wps wo wph wps wo vx wal wph wn
        wps vx wph vx hb.1 hbn hb.2 hbim wph wps df-or wph wps wo wph wn wps wi
        vx wph wps df-or albii 3imtr4i $.
        $( [5-Aug-1993] $)

      $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
         ` ( ph /\ ps ) ` . $)
      hban $p |- ( ( ph /\ ps ) -> A. x ( ph /\ ps ) ) $=
        wph wps wn wi wn wph wps wn wi wn vx wal wph wps wa wph wps wa vx wal
        wph wps wn wi vx wph wps wn vx hb.1 wps vx hb.2 hbn hbim hbn wph wps
        df-an wph wps wa wph wps wn wi wn vx wph wps df-an albii 3imtr4i $.
        $( [5-Aug-1993] $)

      $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
         ` ( ph <-> ps ) ` . $)
      hbbi $p |- ( ( ph <-> ps ) -> A. x ( ph <-> ps ) ) $=
        wph wps wi wps wph wi wa wph wps wi wps wph wi wa vx wal wph wps wb wph
        wps wb vx wal wph wps wi wps wph wi vx wph wps vx hb.1 hb.2 hbim wps
        wph vx hb.2 hb.1 hbim hban wph wps dfbi2 wph wps wb wph wps wi wps wph
        wi wa vx wph wps dfbi2 albii 3imtr4i $.
        $( [5-Aug-1993] $)

      ${
        hb.3 $e |- ( ch -> A. x ch ) $.
        $( If ` x ` is not free in ` ph ` , ` ps ` , and ` ch ` , it is not
           free in ` ( ph \/ ps \/ ch ) ` . $)
        hb3or $p |- ( ( ph \/ ps \/ ch ) -> A. x ( ph \/ ps \/ ch ) ) $=
          wph wps wo wch wo wph wps wo wch wo vx wal wph wps wch w3o wph wps
          wch w3o vx wal wph wps wo wch vx wph wps vx hb.1 hb.2 hbor hb.3 hbor
          wph wps wch df-3or wph wps wch w3o wph wps wo wch wo vx wph wps wch
          df-3or albii 3imtr4i $.
          $( [14-Sep-2003] $)

        $( If ` x ` is not free in ` ph ` , ` ps ` , and ` ch ` , it is not
           free in ` ( ph /\ ps /\ ch ) ` . $)
        hb3an $p |- ( ( ph /\ ps /\ ch ) -> A. x ( ph /\ ps /\ ch ) ) $=
          wph wps wa wch wa wph wps wa wch wa vx wal wph wps wch w3a wph wps
          wch w3a vx wal wph wps wa wch vx wph wps vx hb.1 hb.2 hban hb.3 hban
          wph wps wch df-3an wph wps wch w3a wph wps wa wch wa vx wph wps wch
          df-3an albii 3imtr4i $.
          $( [14-Sep-2003] $)
      $}
    $}
  $}

  $( Lemma 24 of [Monk2] p. 114. $)
  hba2 $p |- ( A. y A. x ph -> A. x A. y A. x ph ) $=
    wph vx wal vx vy wph vx hba1 hbal $.
    $( [30-May-2008] $) $( [29-May-2008] $)

  $( Lemma 23 of [Monk2] p. 114. $)
  hbia1 $p |- ( ( A. x ph -> A. x ps ) -> A. x ( A. x ph -> A. x ps ) ) $=
    wph vx wal wps vx wal vx wph vx hba1 wps vx hba1 hbim $.
    $( [12-Jun-2008] $) $( [29-May-2008] $)

  $( ` x ` is not free in ` -. A. x ph ` . $)
  hbn1 $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
    wph vx wal vx wph vx hba1 hbn $.
    $( [5-Aug-1993] $)

  $( ` x ` is not free in ` E. x ph ` . $)
  hbe1 $p |- ( E. x ph -> A. x E. x ph ) $=
    wph wn vx wal wn wph wn vx wal wn vx wal wph vx wex wph vx wex vx wal wph
    wn vx hbn1 wph vx df-ex wph vx wex wph wn vx wal wn vx wph vx df-ex albii
    3imtr4i $.
    $( [5-Aug-1993] $)

  $( Proof of a single axiom that can replace ~ ax-4 and ~ ax-6o .  See
     ~ ax46to4 and ~ ax46to6 for the re-derivation of those axioms.
     (Contributed by Scott Fenton, 12-Sep-2005.) $)
  ax46 $p |- ( ( A. x -. A. x ph -> A. x ph ) -> ph ) $=
    wph vx wal wn vx wal wph vx wal wph wph vx ax-6o wph vx ax-4 ja $.
    $( [19-Sep-2005] $) $( [12-Sep-2005] $)

  $( Re-derivation of ~ ax-4 from ~ ax46 .  Only propositional calculus is
     used for the re-derivation.  (Contributed by Scott Fenton,
     12-Sep-2005.) $)
  ax46to4 $p |- ( A. x ph -> ph ) $=
    wph vx wal wph vx wal wn vx wal wph vx wal wi wph wph vx wal wph vx wal wn
    vx wal ax-1 wph vx ax46 syl $.
    $( [13-Sep-2005] $) $( [12-Sep-2005] $)

  $( Re-derivation of ~ ax-6o from ~ ax46 .  Only propositional calculus is
     used for the re-derivation.  (Contributed by Scott Fenton,
     12-Sep-2005.) $)
  ax46to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    wph vx wal wn vx wal wn wph vx wal wn vx wal wph vx wal wi wph wph vx wal
    wn vx wal wph vx wal pm2.21 wph vx ax46 syl $.
    $( [13-Sep-2005] $) $( [12-Sep-2005] $)

  $( Proof of a single axiom that can replace both ~ ax-6o and ~ ax-7 .  See
     ~ ax67to6 and ~ ax67to7 for the re-derivation of those axioms. $)
  ax67 $p |- ( -. A. x -. A. y A. x ph -> A. y ph ) $=
    wph vx wal vy wal wn vx wal wn wph vy wal vx wal wn vx wal wn wph vy wal
    wph vy wal vx wal wn vx wal wph vx wal vy wal wn vx wal wph vy wal vx wal
    wn wph vx wal vy wal wn vx wph vx wal vy wal wph vy wal vx wal wph vy vx
    ax-7 con3i 19.20i con3i wph vy wal vx ax-6o syl $.
    $( [18-Nov-2006] $) $( [18-Nov-2006] $)

  $( Re-derivation of ~ ax-6o from ~ ax67 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation. $)
  ax67to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    wph vx wal wn vx wal wn wph vx wal vx wal wn vx wal wn wph vx wal wph wph
    vx wal vx wal wn vx wal wph vx wal wn vx wal wph vx wal vx wal wn wph vx
    wal wn vx wph vx wal wph vx wal vx wal wph vx hba1 con3i 19.20i con3i wph
    vx vx ax67 wph vx ax-4 3syl $.
    $( [19-Nov-2006] $) $( [18-Nov-2006] $)

  $( Re-derivation of ~ ax-7 from ~ ax67 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation. $)
  ax67to7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
    wph vy wal vx wal wph vy wal vx wal wn vy wal wn vy wal wph vx wal vy wal
    wph vy wal vx wal wn vy wal wn vy wal wph vy wal vx wal wph vy wal vx wal
    wn vy ax67to6 con4i wph vy wal vx wal wn vy wal wn wph vx wal vy wph vy vx
    ax67 19.20i syl $.
    $( [19-Nov-2006] $) $( [18-Nov-2006] $)

  $( Proof of a single axiom that can replace ~ ax-4 , ~ ax-6o , and ~ ax-7
     in a subsystem that includes these axioms plus ~ ax-5o and ~ ax-gen (and
     propositional calculus).  See ~ ax467to4 , ~ ax467to6 , and ~ ax467to7
     for the re-derivation of those axioms.  This theorem extends the idea in
     Scott Fenton's ~ ax46 . $)
  ax467 $p |- ( ( A. x A. y -. A. x A. y ph -> A. x ph ) -> ph ) $=
    wph vy wal vx wal wn vy wal vx wal wph vx wal wph wph vy wal wph wph vy wal
    vx wal wn vy wal vx wal wph vy ax-4 wph vy wal wn wph vy wal wn vy wal wph
    vy wal vx wal wn vx wal vy wal wph vy wal vx wal wn vy wal vx wal wph vy
    hbn1 wph vy wal wn wph vy wal vx wal wn vx wal vy wph vy wal vx wal wn vx
    wal wph vy wal wph vy wal vx ax-6o con1i 19.20i wph vy wal vx wal wn vy vx
    ax-7 3syl nsyl4 wph vx ax-4 ja $.
    $( [19-Nov-2006] $) $( [18-Nov-2006] $)

  $( Re-derivation of ~ ax-4 from ~ ax467 .  Only propositional calculus is
     used by the re-derivation. $)
  ax467to4 $p |- ( A. x ph -> ph ) $=
    wph vx wal wph vx wal vx wal wn vx wal vx wal wph vx wal wi wph wph vx wal
    wph vx wal vx wal wn vx wal vx wal ax-1 wph vx vx ax467 syl $.
    $( [19-Nov-2006] $) $( [19-Nov-2006] $)

  $( Re-derivation of ~ ax-6o from ~ ax467 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation.  The use of ~ 19.20i (which uses ~ ax-4 )
     is allowed since we have already proved ~ ax467to4 . $)
  ax467to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    wph vx wal wn vx wal wn wph vx wal vx wal wn vx wal vx wal wn wph vx wal vx
    wal wn vx wal vx wal wph vx wal wi wph wph vx wal vx wal wn vx wal vx wal
    wph vx wal wn vx wal wph vx wal vx wal wn vx wal vx wal wph vx wal vx wal
    wn vx wal wph vx wal wn vx wal wph vx wal vx wal wn vx wal vx ax467to4 wph
    vx wal vx wal wn wph vx wal wn vx wph vx wal wph vx wal vx wal wph vx hba1
    con3i 19.20i syl con3i wph vx wal vx wal wn vx wal vx wal wph vx wal pm2.21
    wph vx vx ax467 3syl $.
    $( [19-Nov-2006] $) $( [19-Nov-2006] $)

  $( Re-derivation of ~ ax-7 from ~ ax467 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation.  The use of ~ 19.20i (which uses ~ ax-4 )
     is allowed since we have already proved ~ ax467to4 . $)
  ax467to7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
    wph vy wal vx wal wph vy wal vx wal wn vy wal wn vy wal wph vx wal vy wal
    wph vy wal vx wal wn vy wal wn vy wal wph vy wal vx wal wph vy wal vx wal
    wn vy ax467to6 con4i wph vy wal vx wal wn vy wal wn wph vx wal vy wph vy
    wal vx wal wn vy wal vx wal wn vx wal wph vx wal wph vy wal vx wal wn vy
    wal wph vy wal vx wal wn vy wal vx wal wn wph vx wph vy wal vx wal wn vy
    wal vx wal wn wph vy wal vx wal wn vy wal vx wal wph vx wal wi wph wph vy
    wal vx wal wn vy wal vx wal wph vx wal pm2.21 wph vx vy ax467 syl 19.20i
    wph vy wal vx wal wn vy wal vx ax467to6 nsyl4 19.20i syl $.
    $( [19-Nov-2006] $) $( [19-Nov-2006] $)

  $( The analog in our "pure" predicate calculus of axiom 5 of modal logic
     S5. $)
  modal-5 $p |- ( -. A. x -. ph -> A. x -. A. x -. ph ) $=
    wph wn vx hbn1 $.
    $( [8-Oct-2005] $) $( [5-Oct-2005] $)

  $( The analog in our "pure" predicate calculus of the Brouwer axiom (B) of
     modal logic S5. $)
  modal-b $p |- ( ph -> A. x -. A. x -. ph ) $=
    wph wn vx wal wn vx wal wph wph wn vx ax-6o con4i $.
    $( [6-Oct-2005] $) $( [5-Oct-2005] $)

  $( If a wff is true, it is true for at least one instance.  Special case of
     Theorem 19.8 of [Margaris] p. 89. $)
  19.8a $p |- ( ph -> E. x ph ) $=
    wph wph wn vx wal wn wph vx wex wph wn vx wal wph wph wn vx ax-4 con2i wph
    vx df-ex sylibr $.
    $( [5-Aug-1993] $)

  $( Theorem 19.2 of [Margaris] p. 89, generalized to use two set variables.
     (Contributed by O'Cat, 31-Mar-2008.) $)
  19.2 $p |- ( A. x ph -> E. y ph ) $=
    wph wph vy wex vx wph vy 19.8a a4s $.
    $( [31-Mar-2008] $)

  ${
    19.3.1 $e |- ( ph -> A. x ph ) $.
    $( A wff may be quantified with a variable not free in it.  Theorem 19.3 of
       [Margaris] p. 89. $)
    19.3 $p |- ( A. x ph <-> ph ) $=
      wph vx wal wph wph vx ax-4 19.3.1 impbii $.
      $( [21-May-2007] $) $( [5-Aug-1993] $)
  $}

  $( Theorem 19.5 of [Margaris] p. 89. $)
  alcom $p |- ( A. x A. y ph <-> A. y A. x ph ) $=
    wph vy wal vx wal wph vx wal vy wal wph vx vy ax-7 wph vy vx ax-7 impbii $.
    $( [5-Aug-1993] $)

  $( Theorem 19.7 of [Margaris] p. 89. $)
  alnex $p |- ( A. x -. ph <-> -. E. x ph ) $=
    wph vx wex wph wn vx wal wph vx df-ex con2bii $.
    $( [5-Aug-1993] $)

  $( Theorem 19.6 of [Margaris] p. 89. $)
  alex $p |- ( A. x ph <-> -. E. x -. ph ) $=
    wph vx wal wph wn wn vx wal wph wn vx wex wn wph wph wn wn vx wph notnot
    albii wph wn vx alnex bitri $.
    $( [5-Aug-1993] $)

  $( A closed version of one direction of ~ 19.9 . $)
  19.9t $p |- ( A. x ( ph -> A. x ph ) -> ( E. x ph -> ph ) ) $=
    wph wph vx wal wi vx wal wph wn vx wal wn wph wph vx wex wph wph vx wal wi
    vx wal wph wph wn vx wal wph vx hbnt con1d wph vx df-ex syl5ib $.
    $( [5-Aug-1993] $)

  ${
    19.9.1 $e |- ( ph -> A. x ph ) $.
    $( A wff may be existentially quantified with a variable not free in it.
       Theorem 19.9 of [Margaris] p. 89.  (Contributed by FL, 24-Mar-2007.) $)
    19.9 $p |- ( E. x ph <-> ph ) $=
      wph vx wex wph wph wph vx wal wi wph vx wex wph wi vx wph vx 19.9t 19.9.1
      mpg wph vx 19.8a impbii $.
      $( [20-May-2007] $) $( [24-Mar-2007] $)
  $}

  ${
    19.9d.1 $e |- ( ps -> A. x ps ) $.
    19.9d.2 $e |- ( ps -> ( ph -> A. x ph ) ) $.
    $( A deduction version of one direction of ~ 19.9 . $)
    19.9d $p |- ( ps -> ( E. x ph -> ph ) ) $=
      wps wps vx wal wph wph vx wal wi vx wal wph vx wex wph wi 19.9d.1 wps wph
      wph vx wal wi vx 19.9d.2 19.20i wph vx 19.9t 3syl $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem 19.14 of [Margaris] p. 90. $)
  exnal $p |- ( E. x -. ph <-> -. A. x ph ) $=
    wph vx wal wph wn vx wex wph vx alex con2bii $.
    $( [5-Aug-1993] $)

  $( Theorem 19.22 of [Margaris] p. 90. $)
  19.22 $p |- ( A. x ( ph -> ps ) -> ( E. x ph -> E. x ps ) ) $=
    wph wps wi vx wal wph wn vx wal wn wps wn vx wal wn wph vx wex wps vx wex
    wph wps wi vx wal wps wn vx wal wph wn vx wal wph wps wi wps wn wph wn vx
    wph wps con3 19.20ii con3d wph vx df-ex wps vx df-ex 3imtr4g $.
    $( [5-Aug-1993] $)

  ${
    19.22i.1 $e |- ( ph -> ps ) $.
    $( Inference adding existential quantifier to antecedent and consequent. $)
    19.22i $p |- ( E. x ph -> E. x ps ) $=
      wph wps wi wph vx wex wps vx wex wi vx wph wps vx 19.22 19.22i.1 mpg $.
      $( [5-Aug-1993] $)

    $( Inference adding 2 existential quantifiers to antecedent and
       consequent. $)
    19.22i2 $p |- ( E. x E. y ph -> E. x E. y ps ) $=
      wph vy wex wps vy wex vx wph wps vy 19.22i.1 19.22i 19.22i $.
      $( [5-Feb-2005] $) $( [3-Feb-2005] $)
  $}

  $( A transformation of quantifiers and logical connectives. $)
  alinexa $p |- ( A. x ( ph -> -. ps ) <-> -. E. x ( ph /\ ps ) ) $=
    wph wps wn wi vx wal wph wps wa wn vx wal wph wps wa vx wex wn wph wps wn
    wi wph wps wa wn vx wph wps imnan albii wph wps wa vx alnex bitri $.
    $( [19-Aug-1993] $)

  $( A transformation of quantifiers and logical connectives. $)
  exanali $p |- ( E. x ( ph /\ -. ps ) <-> -. A. x ( ph -> ps ) ) $=
    wph wps wi vx wal wph wps wn wa vx wex wph wps wi vx wal wph wps wn wa wn
    vx wal wph wps wn wa vx wex wn wph wps wi wph wps wn wa wn vx wph wps iman
    albii wph wps wn wa vx alnex bitri con2bii $.
    $( [25-Mar-1996] $)

  $( A relationship between two quantifiers and negation. $)
  alexn $p |- ( A. x E. y -. ph <-> -. E. x A. y ph ) $=
    wph wn vy wex vx wal wph vy wal wn vx wal wph vy wal vx wex wn wph wn vy
    wex wph vy wal wn vx wph vy exnal albii wph vy wal vx alnex bitri $.
    $( [18-Aug-1993] $)

  $( One direction of Theorem 19.11 of [Margaris] p. 89. $)
  excomim $p |- ( E. x E. y ph -> E. y E. x ph ) $=
    wph vy wex vx wex wph vx wex vy wex vx wex wph vx wex vy wex wph wph vx wex
    vx vy wph vx 19.8a 19.22i2 wph vx wex vy wex vx wph vx wex vx vy wph vx
    hbe1 hbex 19.9 sylib $.
    $( [5-Aug-1993] $)

  $( Theorem 19.11 of [Margaris] p. 89. $)
  excom $p |- ( E. x E. y ph <-> E. y E. x ph ) $=
    wph vy wex vx wex wph vx wex vy wex wph vx vy excomim wph vy vx excomim
    impbii $.
    $( [5-Aug-1993] $)

  $( Theorem 19.12 of [Margaris] p. 89.  Assuming the converse is a mistake
     sometimes made by beginners!  But sometimes the converse does hold,
     as in ~ 19.12vv and ~ r19.12sn . $)
  19.12 $p |- ( E. x A. y ph -> A. y E. x ph ) $=
    wph vy wal vx wex wph vx wex vy wph vy wal vy vx wph vy hba1 hbex wph vy
    wal wph vx wph vy ax-4 19.22i 19.21ai $.
    $( [5-Aug-1993] $)

  ${
    19.16.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.16 of [Margaris] p. 90. $)
    19.16 $p |- ( A. x ( ph <-> ps ) -> ( ph <-> A. x ps ) ) $=
      wph wps wb vx wal wph vx wal wps vx wal wph wph wps vx 19.15 wph vx
      19.16.1 19.3 syl5bbr $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.17.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.17 of [Margaris] p. 90. $)
    19.17 $p |- ( A. x ( ph <-> ps ) -> ( A. x ph <-> ps ) ) $=
      wph wps wb vx wal wph vx wal wps vx wal wps wph wps vx 19.15 wps vx
      19.17.1 19.3 syl6bb $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem 19.18 of [Margaris] p. 90. $)
  19.18 $p |- ( A. x ( ph <-> ps ) -> ( E. x ph <-> E. x ps ) ) $=
    wph wps wb vx wal wph vx wex wps vx wex wph wps wb vx wal wph wps wi vx wal
    wph vx wex wps vx wex wi wph wps wb wph wps wi vx wph wps bi1 19.20i wph
    wps vx 19.22 syl wph wps wb vx wal wps wph wi vx wal wps vx wex wph vx wex
    wi wph wps wb wps wph wi vx wph wps bi2 19.20i wps wph vx 19.22 syl impbid
    $.
    $( [5-Aug-1993] $)

  ${
    exbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding existential quantifier to both sides of an
       equivalence. $)
    exbii $p |- ( E. x ph <-> E. x ps ) $=
      wph wps wb wph vx wex wps vx wex wb vx wph wps vx 19.18 exbii.1 mpg $.
      $( [24-May-1994] $)
  $}

  ${
    2exbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding 2 existential quantifiers to both sides of an
       equivalence. $)
    2exbii $p |- ( E. x E. y ph <-> E. x E. y ps ) $=
      wph vy wex wps vy wex vx wph wps vy 2exbii.1 exbii exbii $.
      $( [16-Mar-1995] $)
  $}

  ${
    3exbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding 3 existential quantifiers to both sides of an
       equivalence. $)
    3exbii $p |- ( E. x E. y E. z ph <-> E. x E. y E. z ps ) $=
      wph vz wex wps vz wex vx vy wph wps vz 3exbii.1 exbii 2exbii $.
      $( [2-May-1995] $)
  $}

  $( Commutation of conjunction inside an existential quantifier. $)
  exancom $p |- ( E. x ( ph /\ ps ) <-> E. x ( ps /\ ph ) ) $=
    wph wps wa wps wph wa vx wph wps ancom exbii $.
    $( [18-Aug-1993] $)

  ${
    19.19.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.19 of [Margaris] p. 90. $)
    19.19 $p |- ( A. x ( ph <-> ps ) -> ( ph <-> E. x ps ) ) $=
      wph wps wb vx wal wph vx wex wps vx wex wph wph wps vx 19.18 wph vx
      19.19.1 19.9 syl5bbr $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.21.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.21 of [Margaris] p. 90.  The hypothesis can be thought of as
       " ` x ` is not free in ` ph ` ." $)
    19.21 $p |- ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) $=
      wph wps wi vx wal wph wps vx wal wi wph wps wi vx wal wph vx wal wps vx
      wal wph wph wps vx 19.20 19.21.1 syl5 wph wps vx wal wi wph wps wi vx wph
      wps vx wal vx 19.21.1 wps vx hba1 hbim wps vx wal wps wph wps vx ax-4
      imim2i 19.21ai impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.21-2.1 $e |- ( ph -> A. x ph ) $.
    19.21-2.2 $e |- ( ph -> A. y ph ) $.
    $( Theorem 19.21 of [Margaris] p. 90 but with 2 quantifiers. $)
    19.21-2 $p |- ( A. x A. y ( ph -> ps ) <-> ( ph -> A. x A. y ps ) ) $=
      wph wps wi vy wal vx wal wph wps vy wal wi vx wal wph wps vy wal vx wal
      wi wph wps wi vy wal wph wps vy wal wi vx wph wps vy 19.21-2.2 19.21
      albii wph wps vy wal vx 19.21-2.1 19.21 bitri $.
      $( [11-Feb-2005] $) $( [4-Feb-2005] $)
  $}

  ${
    stdpc5.1 $e |- ( ph -> A. x ph ) $.
    $( An axiom scheme of standard predicate calculus that emulates Axiom 5 of
       [Mendelson] p. 69.  The hypothesis ` ( ph -> A. x ph ) ` can be thought
       of as emulating " ` x ` is not free in ` ph ` ."  With this convention,
       the meaning of "not free" is less restrictive than the usual textbook
       definition; for example ` x ` would not (for us) be free in ` x = x ` by
       ~ hbequid2 .  This theorem scheme can be proved as a metatheorem of
       Mendelson's axiom system, even though it is slightly stronger than his
       Axiom 5. $)
    stdpc5 $p |- ( A. x ( ph -> ps ) -> ( ph -> A. x ps ) ) $=
      wph wps wi vx wal wph wps vx wal wi wph wps vx stdpc5.1 19.21 biimpi $.
      $( [22-Sep-1993] $)
  $}

  ${
    19.21ad.1 $e |- ( ph -> A. x ph ) $.
    19.21ad.2 $e |- ( ps -> A. x ps ) $.
    19.21ad.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.21 of [Margaris] p. 90. $)
    19.21ad $p |- ( ph -> ( ps -> A. x ch ) ) $=
      wph wps wch vx wal wph wps wa wch vx wph wps vx 19.21ad.1 19.21ad.2 hban
      wph wps wch 19.21ad.3 imp 19.21ai ex $.
      $( [10-Feb-1997] $)
  $}

  ${
    19.21bi.1 $e |- ( ph -> A. x ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90. $)
    19.21bi $p |- ( ph -> ps ) $=
      wph wps vx wal wps 19.21bi.1 wps vx ax-4 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.21bbi.1 $e |- ( ph -> A. x A. y ps ) $.
    $( Inference removing double quantifier. $)
    19.21bbi $p |- ( ph -> ps ) $=
      wph wps vy wph wps vy wal vx 19.21bbi.1 19.21bi 19.21bi $.
      $( [20-Apr-1994] $)
  $}

  ${
    19.22d.1 $e |- ( ph -> A. x ph ) $.
    19.22d.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90. $)
    19.22d $p |- ( ph -> ( E. x ps -> E. x ch ) ) $=
      wph wps wch wi vx wal wps vx wex wch vx wex wi wph wps wch wi vx 19.22d.1
      19.22d.2 19.21ai wps wch vx 19.22 syl $.
      $( [20-May-1996] $)
  $}

  ${
    19.23.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.23 of [Margaris] p. 90. $)
    19.23 $p |- ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) $=
      wph wps wi vx wal wph vx wex wps wi wph wps wi vx wal wph vx wex wps vx
      wex wps wph wps vx 19.22 wps vx 19.23.1 19.9 syl6ib wph vx wex wps wi wph
      wps wi vx wph vx wex wps vx wph vx hbe1 19.23.1 hbim wph wph vx wex wps
      wph vx 19.8a imim1i 19.21ai impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.23ai.1 $e |- ( ps -> A. x ps ) $.
    19.23ai.2 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90. $)
    19.23ai $p |- ( E. x ph -> ps ) $=
      wph vx wex wps vx wex wps wph wps vx 19.23ai.2 19.22i wps vx 19.23ai.1
      19.9 sylib $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.23bi.1 $e |- ( E. x ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90. $)
    19.23bi $p |- ( ph -> ps ) $=
      wph wph vx wex wps wph vx 19.8a 19.23bi.1 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.23ad.1 $e |- ( ph -> A. x ph ) $.
    19.23ad.2 $e |- ( ch -> A. x ch ) $.
    19.23ad.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90. $)
    19.23ad $p |- ( ph -> ( E. x ps -> ch ) ) $=
      wph wps wch wi vx wal wps vx wex wch wi wph wps wch wi vx 19.23ad.1
      19.23ad.3 19.21ai wps wch vx 19.23ad.2 19.23 sylib $.
      $( [28-Jan-1997] $)
  $}

  $( Theorem 19.26 of [Margaris] p. 90.  Also Theorem *10.22 of
     [WhiteheadRussell] p. 119. $)
  19.26 $p |- ( A. x ( ph /\ ps ) <-> ( A. x ph /\ A. x ps ) ) $=
    wph wps wa vx wal wph vx wal wps vx wal wa wph wps wa vx wal wph vx wal wps
    vx wal wph wps wa wph vx wph wps pm3.26 19.20i wph wps wa wps vx wph wps
    pm3.27 19.20i jca wph vx wal wps vx wal wph wps wa vx wal wph wps wph wps
    wa vx wph wps pm3.2 19.20ii imp impbii $.
    $( [5-Aug-1993] $)

  $( Theorem 19.26 of [Margaris] p. 90 with two quantifiers. $)
  19.26-2 $p |- ( A. x A. y ( ph /\ ps ) <->
                ( A. x A. y ph /\ A. x A. y ps ) ) $=
    wph wps wa vy wal vx wal wph vy wal wps vy wal wa vx wal wph vy wal vx wal
    wps vy wal vx wal wa wph wps wa vy wal wph vy wal wps vy wal wa vx wph wps
    vy 19.26 albii wph vy wal wps vy wal vx 19.26 bitri $.
    $( [27-Apr-2005] $) $( [3-Feb-2005] $)

  ${
    19.27.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.27 of [Margaris] p. 90. $)
    19.27 $p |- ( A. x ( ph /\ ps ) <-> ( A. x ph /\ ps ) ) $=
      wph wps wa vx wal wph vx wal wps vx wal wa wph vx wal wps wa wph wps vx
      19.26 wps vx wal wps wph vx wal wps vx 19.27.1 19.3 anbi2i bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.28.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.28 of [Margaris] p. 90. $)
    19.28 $p |- ( A. x ( ph /\ ps ) <-> ( ph /\ A. x ps ) ) $=
      wph wps wa vx wal wph vx wal wps vx wal wa wph wps vx wal wa wph wps vx
      19.26 wph vx wal wph wps vx wal wph vx 19.28.1 19.3 anbi1i bitri $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem 19.29 of [Margaris] p. 90. $)
  19.29 $p |- ( ( A. x ph /\ E. x ps ) -> E. x ( ph /\ ps ) ) $=
    wph vx wal wps vx wex wa wph wps wn wi wn vx wex wph wps wa vx wex wph vx
    wal wps vx wex wn wi wn wph wps wn wi vx wal wn wph vx wal wps vx wex wa
    wph wps wn wi wn vx wex wph wps wn wi vx wal wph vx wal wps vx wex wn wi
    wph wps wn wi vx wal wph vx wal wps wn vx wal wps vx wex wn wph wps wn vx
    19.20 wps vx alnex syl6ib con3i wph vx wal wps vx wex df-an wph wps wn wi
    vx exnal 3imtr4i wph wps wa wph wps wn wi wn vx wph wps df-an exbii sylibr
    $.
    $( [5-Aug-1993] $)

  $( Variation of Theorem 19.29 of [Margaris] p. 90. $)
  19.29r $p |- ( ( E. x ph /\ A. x ps ) -> E. x ( ph /\ ps ) ) $=
    wps vx wal wph vx wex wa wps wph wa vx wex wph vx wex wps vx wal wa wph wps
    wa vx wex wps wph vx 19.29 wph vx wex wps vx wal ancom wph wps vx exancom
    3imtr4i $.
    $( [18-Aug-1993] $)

  $( Variation of Theorem 19.29 of [Margaris] p. 90 with double
     quantification. $)
  19.29r2 $p |- ( ( E. x E. y ph /\ A. x A. y ps ) ->
             E. x E. y ( ph /\ ps ) ) $=
    wph vy wex vx wex wps vy wal vx wal wa wph vy wex wps vy wal wa vx wex wph
    wps wa vy wex vx wex wph vy wex wps vy wal vx 19.29r wph vy wex wps vy wal
    wa wph wps wa vy wex vx wph wps vy 19.29r 19.22i syl $.
    $( [11-Feb-2005] $) $( [3-Feb-2005] $)

  $( Variation of Theorem 19.29 of [Margaris] p. 90 with mixed
     quantification. $)
  19.29x $p |- ( ( E. x A. y ph /\ A. x E. y ps ) ->
             E. x E. y ( ph /\ ps ) ) $=
    wph vy wal vx wex wps vy wex vx wal wa wph vy wal wps vy wex wa vx wex wph
    wps wa vy wex vx wex wph vy wal wps vy wex vx 19.29r wph vy wal wps vy wex
    wa wph wps wa vy wex vx wph wps vy 19.29 19.22i syl $.
    $( [25-Mar-2005] $) $( [11-Feb-2005] $)

  $( Theorem 19.35 of [Margaris] p. 90.  This theorem is useful for moving
     an implication (in the form of the right-hand side) into the scope of a
     single existential quantifier. $)
  19.35 $p |- ( E. x ( ph -> ps ) <-> ( A. x ph -> E. x ps ) ) $=
    wph vx wal wps wn vx wal wn wi wph wps wi wn vx wal wn wph vx wal wps vx
    wex wi wph wps wi vx wex wph wps wi wn vx wal wph vx wal wps wn vx wal wn
    wi wph wps wn wa vx wal wph vx wal wps wn vx wal wa wph wps wi wn vx wal
    wph vx wal wps wn vx wal wn wi wn wph wps wn vx 19.26 wph wps wn wa wph wps
    wi wn vx wph wps annim albii wph vx wal wps wn vx wal df-an 3bitr3i con2bii
    wps vx wex wps wn vx wal wn wph vx wal wps vx df-ex imbi2i wph wps wi vx
    df-ex 3bitr4ri $.
    $( [5-Aug-1993] $)

  ${
    19.35i.1 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.35 of [Margaris] p. 90. $)
    19.35i $p |- ( A. x ph -> E. x ps ) $=
      wph wps wi vx wex wph vx wal wps vx wex wi 19.35i.1 wph wps vx 19.35 mpbi
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.35ri.1 $e |- ( A. x ph -> E. x ps ) $.
    $( Inference from Theorem 19.35 of [Margaris] p. 90. $)
    19.35ri $p |- E. x ( ph -> ps ) $=
      wph wps wi vx wex wph vx wal wps vx wex wi 19.35ri.1 wph wps vx 19.35
      mpbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.36.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.36 of [Margaris] p. 90. $)
    19.36 $p |- ( E. x ( ph -> ps ) <-> ( A. x ph -> ps ) ) $=
      wph wps wi vx wex wph vx wal wps vx wex wi wph vx wal wps wi wph wps vx
      19.35 wps vx wex wps wph vx wal wps vx 19.36.1 19.9 imbi2i bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.36i.1 $e |- ( ps -> A. x ps ) $.
    19.36i.2 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.36 of [Margaris] p. 90. $)
    19.36i $p |- ( A. x ph -> ps ) $=
      wph wps wi vx wex wph vx wal wps wi 19.36i.2 wph wps vx 19.36i.1 19.36
      mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.37.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.37 of [Margaris] p. 90. $)
    19.37 $p |- ( E. x ( ph -> ps ) <-> ( ph -> E. x ps ) ) $=
      wph wps wi vx wex wph vx wal wps vx wex wi wph wps vx wex wi wph wps vx
      19.35 wph vx wal wph wps vx wex wph vx 19.37.1 19.3 imbi1i bitri $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem 19.38 of [Margaris] p. 90. $)
  19.38 $p |- ( ( E. x ph -> A. x ps ) -> A. x ( ph -> ps ) ) $=
    wph vx wex wps vx wal wi wph wps wi vx wph vx wex wps vx wal vx wph vx hbe1
    wps vx hba1 hbim wph wph vx wex wps vx wal wps wph vx 19.8a wps vx ax-4
    imim12i 19.21ai $.
    $( [5-Aug-1993] $)

  $( Theorem 19.39 of [Margaris] p. 90. $)
  19.39 $p |- ( ( E. x ph -> E. x ps ) -> E. x ( ph -> ps ) ) $=
    wph vx wex wps vx wex wi wph vx wal wps vx wex wi wph wps wi vx wex wph vx
    wal wph vx wex wps vx wex wph vx vx 19.2 imim1i wph wps vx 19.35 sylibr $.
    $( [5-Aug-1993] $)

  $( Theorem 19.24 of [Margaris] p. 90. $)
  19.24 $p |- ( ( A. x ph -> A. x ps ) -> E. x ( ph -> ps ) ) $=
    wph vx wal wps vx wal wi wph vx wal wps vx wex wi wph wps wi vx wex wps vx
    wal wps vx wex wph vx wal wps vx vx 19.2 imim2i wph wps vx 19.35 sylibr $.
    $( [5-Aug-1993] $)

  $( Theorem 19.25 of [Margaris] p. 90. $)
  19.25 $p |- ( A. y E. x ( ph -> ps ) ->
              ( E. y A. x ph -> E. y E. x ps ) ) $=
    wph wps wi vx wex vy wal wph vx wal wps vx wex wi vy wal wph vx wal vy wex
    wps vx wex vy wex wi wph wps wi vx wex wph vx wal wps vx wex wi vy wph wps
    wi vx wex wph vx wal wps vx wex wi wph wps vx 19.35 biimpi 19.20i wph vx
    wal wps vx wex vy 19.22 syl $.
    $( [5-Aug-1993] $)

  $( Theorem 19.30 of [Margaris] p. 90. $)
  19.30 $p |- ( A. x ( ph \/ ps ) -> ( A. x ph \/ E. x ps ) ) $=
    wps wn wph wi vx wal wps wn vx wal wph vx wal wi wph wps wo vx wal wph vx
    wal wps vx wex wo wps wn wph vx 19.20 wph wps wo wps wn wph wi vx wph wps
    wo wps wph wo wps wn wph wi wph wps orcom wps wph df-or bitri albii wph vx
    wal wps wn vx wal wn wo wps wn vx wal wn wph vx wal wo wph vx wal wps vx
    wex wo wps wn vx wal wph vx wal wi wph vx wal wps wn vx wal wn orcom wps vx
    wex wps wn vx wal wn wph vx wal wps vx df-ex orbi2i wps wn vx wal wph vx
    wal imor 3bitr4i 3imtr4i $.
    $( [5-Aug-1993] $)

  ${
    19.32.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.32 of [Margaris] p. 90. $)
    19.32 $p |- ( A. x ( ph \/ ps ) <-> ( ph \/ A. x ps ) ) $=
      wph wn wps wi vx wal wph wn wps vx wal wi wph wps wo vx wal wph wps vx
      wal wo wph wn wps vx wph vx 19.32.1 hbn 19.21 wph wps wo wph wn wps wi vx
      wph wps df-or albii wph wps vx wal df-or 3bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.31.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.31 of [Margaris] p. 90. $)
    19.31 $p |- ( A. x ( ph \/ ps ) <-> ( A. x ph \/ ps ) ) $=
      wps wph wo vx wal wps wph vx wal wo wph wps wo vx wal wph vx wal wps wo
      wps wph vx 19.31.1 19.32 wph wps wo wps wph wo vx wph wps orcom albii wph
      vx wal wps orcom 3bitr4i $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem 19.43 of [Margaris] p. 90. $)
  19.43 $p |- ( E. x ( ph \/ ps ) <-> ( E. x ph \/ E. x ps ) ) $=
    wph wps wo wn vx wal wn wph vx wex wn wps vx wex wn wa wn wph wps wo vx wex
    wph vx wex wps vx wex wo wph wps wo wn vx wal wph vx wex wn wps vx wex wn
    wa wph wps wo wn vx wal wph wn wps wn wa vx wal wph wn vx wal wps wn vx wal
    wa wph vx wex wn wps vx wex wn wa wph wps wo wn wph wn wps wn wa vx wph wps
    ioran albii wph wn wps wn vx 19.26 wph wn vx wal wph vx wex wn wps wn vx
    wal wps vx wex wn wph vx alnex wps vx alnex anbi12i 3bitri notbii wph wps
    wo vx df-ex wph vx wex wps vx wex oran 3bitr4i $.
    $( [5-Aug-1993] $)

  ${
    19.44.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.44 of [Margaris] p. 90. $)
    19.44 $p |- ( E. x ( ph \/ ps ) <-> ( E. x ph \/ ps ) ) $=
      wph wps wo vx wex wph vx wex wps vx wex wo wph vx wex wps wo wph wps vx
      19.43 wps vx wex wps wph vx wex wps vx 19.44.1 19.9 orbi2i bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.45.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.45 of [Margaris] p. 90. $)
    19.45 $p |- ( E. x ( ph \/ ps ) <-> ( ph \/ E. x ps ) ) $=
      wph wps wo vx wex wph vx wex wps vx wex wo wph wps vx wex wo wph wps vx
      19.43 wph vx wex wph wps vx wex wph vx 19.45.1 19.9 orbi1i bitri $.
      $( [5-Aug-1993] $)
  $}

  $( Theorem 19.33 of [Margaris] p. 90. $)
  19.33 $p |- ( ( A. x ph \/ A. x ps ) -> A. x ( ph \/ ps ) ) $=
    wph vx wal wph wps wo vx wal wps vx wal wph wph wps wo vx wph wps orc
    19.20i wps wph wps wo vx wps wph olc 19.20i jaoi $.
    $( [5-Aug-1993] $)

  $( The antecedent provides a condition implying the converse of ~ 19.33 .
     Compare Theorem 19.33 of [Margaris] p. 90. $)
  19.33b $p |- ( -. ( E. x ph /\ E. x ps ) ->
               (  A. x ( ph \/ ps ) <-> ( A. x ph \/ A. x ps ) ) ) $=
    wph vx wex wps vx wex wa wn wph wps wo vx wal wph vx wal wps vx wal wo wph
    vx wex wps vx wex wa wn wph wn vx wal wps wn vx wal wo wph wps wo vx wal
    wph vx wal wps vx wal wo wi wph vx wex wps vx wex wa wn wph vx wex wn wps
    vx wex wn wo wph wn vx wal wps wn vx wal wo wph vx wex wps vx wex ianor wph
    wn vx wal wph vx wex wn wps wn vx wal wps vx wex wn wph vx alnex wps vx
    alnex orbi12i bitr4i wph wn vx wal wph wps wo vx wal wph vx wal wps vx wal
    wo wi wps wn vx wal wph wn vx wal wph wps wo vx wal wps vx wal wph vx wal
    wps vx wal wo wph wn vx wal wps wph wps wo wb vx wal wps vx wal wph wps wo
    vx wal wb wph wn wps wph wps wo wb vx wph wps biorf 19.20i wps wph wps wo
    vx 19.15 syl wps vx wal wph vx wal olc syl6bir wps wn vx wal wph wps wo vx
    wal wph vx wal wph vx wal wps vx wal wo wps wn vx wal wph wph wps wo wb vx
    wal wph vx wal wph wps wo vx wal wb wps wn wph wph wps wo wb vx wps wn wph
    wps wph wo wph wps wo wps wph biorf wps wph orcom syl6bb 19.20i wph wph wps
    wo vx 19.15 syl wph vx wal wps vx wal orc syl6bir jaoi sylbi wph wps vx
    19.33 impbid1 $.
    $( [2-Apr-2004] $) $( [27-Mar-2004] $)

  $( Theorem 19.34 of [Margaris] p. 90. $)
  19.34 $p |- ( ( A. x ph \/ E. x ps ) -> E. x ( ph \/ ps ) ) $=
    wph vx wal wps vx wex wo wph vx wex wps vx wex wo wph wps wo vx wex wph vx
    wal wph vx wex wps vx wex wph vx vx 19.2 orim1i wph wps vx 19.43 sylibr $.
    $( [5-Aug-1993] $)

  $( Theorem 19.40 of [Margaris] p. 90. $)
  19.40 $p |- ( E. x ( ph /\ ps ) -> ( E. x ph /\ E. x ps ) ) $=
    wph wps wa vx wex wph vx wex wps vx wex wph wps wa wph vx wph wps pm3.26
    19.22i wph wps wa wps vx wph wps pm3.27 19.22i jca $.
    $( [5-Aug-1993] $)

  ${
    19.41.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.41 of [Margaris] p. 90. $)
    19.41 $p |- ( E. x ( ph /\ ps ) <-> ( E. x ph /\ ps ) ) $=
      wph wps wa vx wex wph wps wa wn vx wal wn wph vx wex wps wa wph wps wa vx
      df-ex wph wps wa wn vx wal wph vx wex wps wa wph wn wps wn wo vx wal wph
      wn vx wal wps wn wo wph wps wa wn vx wal wph vx wex wps wa wn wph wn wps
      wn vx wps vx 19.41.1 hbn 19.31 wph wps wa wn wph wn wps wn wo vx wph wps
      ianor albii wph vx wex wps wa wn wph vx wex wn wps wn wo wph wn vx wal
      wps wn wo wph vx wex wps ianor wph wn vx wal wph vx wex wn wps wn wph vx
      alnex orbi1i bitr4i 3bitr4i con2bii bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    19.42.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.42 of [Margaris] p. 90. $)
    19.42 $p |- ( E. x ( ph /\ ps ) <-> ( ph /\ E. x ps ) ) $=
      wps wph wa vx wex wps vx wex wph wa wph wps wa vx wex wph wps vx wex wa
      wps wph vx 19.42.1 19.41 wph wps vx exancom wph wps vx wex ancom 3bitr4i
      $.
      $( [18-Aug-1993] $)
  $}

  $( Rotate 4 universal quantifiers twice. $)
  alrot4 $p |- ( A. x A. y A. z A. w ph <-> A. z A. w A. x A. y ph ) $=
    wph vw wal vz wal vy wal vx wal wph vy wal vw wal vz wal vx wal wph vy wal
    vw wal vx wal vz wal wph vy wal vx wal vw wal vz wal wph vw wal vz wal vy
    wal wph vy wal vw wal vz wal vx wph vw wal vz wal vy wal wph vw wal vy wal
    vz wal wph vy wal vw wal vz wal wph vw wal vy vz alcom wph vw wal vy wal
    wph vy wal vw wal vz wph vy vw alcom albii bitri albii wph vy wal vw wal vx
    vz alcom wph vy wal vw wal vx wal wph vy wal vx wal vw wal vz wph vy wal vx
    vw alcom albii 3bitri $.
    $( [7-Feb-2005] $) $( [2-Feb-2005] $)

  $( Swap 1st and 3rd existential quantifiers. $)
  excom13 $p |- ( E. x E. y E. z ph <-> E. z E. y E. x ph ) $=
    wph vz wex vy wex vx wex wph vz wex vx wex vy wex wph vx wex vz wex vy wex
    wph vx wex vy wex vz wex wph vz wex vx vy excom wph vz wex vx wex wph vx
    wex vz wex vy wph vx vz excom exbii wph vx wex vy vz excom 3bitri $.
    $( [9-Mar-1995] $)

  $( Rotate existential quantifiers. $)
  exrot3 $p |- ( E. x E. y E. z ph <-> E. y E. z E. x ph ) $=
    wph vz wex vy wex vx wex wph vx wex vy wex vz wex wph vx wex vz wex vy wex
    wph vx vy vz excom13 wph vx wex vz vy excom bitri $.
    $( [17-Mar-1995] $)

  $( Rotate existential quantifiers twice. $)
  exrot4 $p |- ( E. x E. y E. z E. w ph <-> E. z E. w E. x E. y ph ) $=
    wph vw wex vz wex vy wex vx wex wph vy wex vz wex vw wex vx wex wph vy wex
    vx wex vw wex vz wex wph vw wex vz wex vy wex wph vy wex vz wex vw wex vx
    wph vy vz vw excom13 exbii wph vy wex vx vw vz excom13 bitri $.
    $( [9-Mar-1995] $)

  ${
    nexr.1 $e |- -. E. x ph $.
    $( Inference from ~ 19.8a .  (Contributed by Jeff Hankins, 26-Jul-2009.) $)
    nexr $p |- -. ph $=
      wph wph vx wex nexr.1 wph vx 19.8a mto $.
      $( [22-Sep-2009] $) $( [26-Jul-2009] $)
  $}

  ${
    nex.1 $e |- -. ph $.
    $( Generalization rule for negated wff. $)
    nex $p |- -. E. x ph $=
      wph wn wph vx wex wn vx wph vx alnex nex.1 mpgbi $.
      $( [18-May-1994] $)
  $}

  ${
    nexd.1 $e |- ( ph -> A. x ph ) $.
    nexd.2 $e |- ( ph -> -. ps ) $.
    $( Deduction for generalization rule for negated wff. $)
    nexd $p |- ( ph -> -. E. x ps ) $=
      wph wps wn vx wal wps vx wex wn wph wps wn vx nexd.1 nexd.2 19.21ai wps
      vx alnex sylib $.
      $( [2-Jan-2002] $)
  $}

  ${
    hbim1.1 $e |- ( ph -> A. x ph ) $.
    hbim1.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( A closed form of ~ hbim . $)
    hbim1 $p |- ( ( ph -> ps ) -> A. x ( ph -> ps ) ) $=
      wph wps wi wph wps vx wal wi wph wps wi vx wal wph wps wps vx wal hbim1.2
      a2i wph wps vx hbim1.1 19.21 sylibr $.
      $( [5-Aug-1993] $)
  $}

  ${
    albid.1 $e |- ( ph -> A. x ph ) $.
    albid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for universal quantifier (deduction rule). $)
    albid $p |- ( ph -> ( A. x ps <-> A. x ch ) ) $=
      wph wps wch wb vx wal wps vx wal wch vx wal wb wph wps wch wb vx albid.1
      albid.2 19.21ai wps wch vx 19.15 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    exbid.1 $e |- ( ph -> A. x ph ) $.
    exbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for existential quantifier (deduction rule). $)
    exbid $p |- ( ph -> ( E. x ps <-> E. x ch ) ) $=
      wph wps wch wb vx wal wps vx wex wch vx wex wb wph wps wch wb vx exbid.1
      exbid.2 19.21ai wps wch vx 19.18 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    exan.1 $e |- ( E. x ph /\ ps ) $.
    $( Place a conjunct in the scope of an existential quantifier. $)
    exan $p |- E. x ( ph /\ ps ) $=
      wps wph wa vx wex wph wps wa vx wex wps vx wal wph vx wex wa wps wph wa
      vx wex wps wph vx wex wa wps vx wal wph vx wex wa vx wps wph vx wex vx
      wph vx hbe1 19.27 wph vx wex wps wa wps wph vx wex wa exan.1 wph vx wex
      wps ancom mpbi mpgbi wps wph vx 19.29 ax-mp wps wph vx exancom mpbi $.
      $( [18-Aug-1993] $)
  $}

  $( Split a biconditional and distribute quantifier. $)
  albi $p |- ( A. x ( ph <-> ps ) <->
             ( A. x ( ph -> ps ) /\ A. x ( ps -> ph ) ) ) $=
    wph wps wb vx wal wph wps wi wps wph wi wa vx wal wph wps wi vx wal wps wph
    wi vx wal wa wph wps wb wph wps wi wps wph wi wa vx wph wps dfbi2 albii wph
    wps wi wps wph wi vx 19.26 bitri $.
    $( [18-Aug-1993] $)

  $( Split a biconditional and distribute 2 quantifiers. $)
  2albi $p |- ( A. x A. y ( ph <-> ps ) <->
             ( A. x A. y ( ph -> ps ) /\ A. x A. y ( ps -> ph ) ) ) $=
    wph wps wb vy wal vx wal wph wps wi vy wal wps wph wi vy wal wa vx wal wph
    wps wi vy wal vx wal wps wph wi vy wal vx wal wa wph wps wb vy wal wph wps
    wi vy wal wps wph wi vy wal wa vx wph wps vy albi albii wph wps wi vy wal
    wps wph wi vy wal vx 19.26 bitri $.
    $( [5-Feb-2005] $) $( [3-Feb-2005] $)

  ${
    hbnd.1 $e |- ( ph -> A. x ph ) $.
    hbnd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbn . $)
    hbnd $p |- ( ph -> ( -. ps -> A. x -. ps ) ) $=
      wph wps wps vx wal wi vx wal wps wn wps wn vx wal wi wph wps wps vx wal
      wi vx hbnd.1 hbnd.2 19.21ai wps vx hbnt syl $.
      $( [3-Jan-2002] $)
  $}

  ${
    hbimd.1 $e |- ( ph -> A. x ph ) $.
    hbimd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    hbimd.3 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbim . $)
    hbimd $p |- ( ph -> ( ( ps -> ch ) -> A. x ( ps -> ch ) ) ) $=
      wps wch wi wph wps wch wi vx wal wps wch wph wps wch wi vx wal wi wph wps
      wn wps wn vx wal wps wch wi vx wal wph wps vx hbimd.1 hbimd.2 hbnd wps wn
      wps wch wi vx wps wch pm2.21 19.20i syl6com wph wch wch vx wal wps wch wi
      vx wal hbimd.3 wch wps wch wi vx wch wps ax-1 19.20i syl6com ja com12 $.
      $( [1-Jan-2002] $)
  $}

  ${
    hband.1 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    hband.2 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hban . $)
    hband $p |- ( ph -> ( ( ps /\ ch ) -> A. x ( ps /\ ch ) ) ) $=
      wph wps wch wa wps vx wal wch vx wal wa wps wch wa vx wal wph wps wps vx
      wal wch wch vx wal hband.1 hband.2 anim12d wps wch vx 19.26 syl6ibr $.
      $( [2-Jan-2002] $)
  $}

  ${
    hbbid.1 $e |- ( ph -> A. x ph ) $.
    hbbid.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    hbbid.3 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbbi . $)
    hbbid $p |- ( ph -> ( ( ps <-> ch ) -> A. x ( ps <-> ch ) ) ) $=
      wph wps wch wi wch wps wi wa wps wch wi vx wal wch wps wi vx wal wa wps
      wch wb wps wch wb vx wal wph wps wch wi wps wch wi vx wal wch wps wi wch
      wps wi vx wal wph wps wch vx hbbid.1 hbbid.2 hbbid.3 hbimd wph wch wps vx
      hbbid.1 hbbid.3 hbbid.2 hbimd anim12d wps wch dfbi2 wps wch vx albi
      3imtr4g $.
      $( [1-Jan-2002] $)
  $}

  ${
    hbald.1 $e |- ( ph -> A. y ph ) $.
    hbald.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbal . $)
    hbald $p |- ( ph -> ( A. y ps -> A. x A. y ps ) ) $=
      wph wps vy wal wps vx wal vy wal wps vy wal vx wal wph wps wps vx wal vy
      hbald.1 hbald.2 19.20d wps vy vx ax-7 syl6 $.
      $( [2-Jan-2002] $)
  $}

  ${
    hbexd.1 $e |- ( ph -> A. y ph ) $.
    hbexd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbex . $)
    hbexd $p |- ( ph -> ( E. y ps -> A. x E. y ps ) ) $=
      wph wps vy wex wps vx wal vy wex wps vy wex vx wal wph wps wps vx wal vy
      hbexd.1 hbexd.2 19.22d wps vy vx 19.12 syl6 $.
      $( [2-Jan-2002] $)
  $}

  $( Closed form of Theorem 19.21 of [Margaris] p. 90. $)
  19.21t $p |- ( A. x ( ph -> A. x ph ) ->
               ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) ) $=
    wph wph vx wal wi vx wal wph wps wi vx wal wph wps vx wal wi wph wph vx wal
    wi wph wps wi vx wal wph wps vx wal wi wi vx wph wps wi vx wal wph wph vx
    wal wi wph wps vx wal wi wph wps wi vx wal wph vx wal wps vx wal wph wph
    wps vx 19.20 imim2d com12 a4s wph wph vx wal wi vx wal wph wps vx wal wi
    wph wps vx wal wi vx wal wph wps wi vx wal wph wph vx wal wi vx wal wph wps
    vx wal vx wph wph vx wal wi vx hba1 wph wph vx wal wi vx ax-4 wps vx wal
    wps vx wal vx wal wi wph wph vx wal wi vx wal wps vx hba1 a1i hbimd wph wps
    vx wal wi wph wps wi vx wps vx wal wps wph wps vx ax-4 imim2i 19.20i syl6
    impbid $.
    $( [27-May-1997] $)

  $( Closed form of Theorem 19.23 of [Margaris] p. 90. $)
  19.23t $p |- ( A. x ( ps -> A. x ps ) ->
               ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) ) $=
    wps wps vx wal wi vx wal wph wps vx wal wi vx wal wph wps wi vx wal wph vx
    wex wps wi wps wps vx wal wi vx wal wph wps vx wal wi wph wps wi vx wps wps
    vx wal wi vx hba1 wps wps vx wal wi vx wal wps vx wal wps wph wps wps vx
    wal wi vx wal wps vx wal wps wps vx ax-4 wps wps vx wal wi vx ax-4 impbid2
    imbi2d albid wps wps vx wal wi vx wal wph vx wex wps vx wal wi wph vx wex
    wps wi wph wps vx wal wi vx wal wps wps vx wal wi vx wal wps vx wal wps wph
    vx wex wps wps vx wal wi vx wal wps vx wal wps wps vx ax-4 wps wps vx wal
    wi vx ax-4 impbid2 imbi2d wph wps vx wal vx wps vx hba1 19.23 syl5bb bitr3d
    $.
    $( [8-Nov-2005] $) $( [7-Nov-2005] $)

  $( Introduce a conjunct in the scope of an existential quantifier. $)
  exintr $p |- ( A. x ( ph -> ps ) -> ( E. x ph -> E. x ( ph /\ ps ) ) ) $=
    wph wps wi vx wal wph wph wps wa vx wph wps wi vx hba1 wph wps wi wph wph
    wps wa wi vx wph wps ancl a4s 19.22d $.
    $( [11-Aug-1993] $)

  $( Add/remove a conjunct in the scope of an existential quantifier.
     (Contributed by Raph Levien, 3-Jul-2006.) $)
  exintrbi $p |- ( A. x ( ph -> ps ) -> ( E. x ph <-> E. x ( ph /\ ps ) ) ) $=
    wph wps wi vx wal wph wph wps wa wb vx wal wph vx wex wph wps wa vx wex wb
    wph wps wi wph wph wps wa wb vx wph wps pm4.71 albii wph wph wps wa vx
    19.18 sylbi $.
    $( [6-Jul-2006] $) $( [3-Jul-2006] $)

  ${
    aaan.1 $e |- ( ph -> A. y ph ) $.
    aaan.2 $e |- ( ps -> A. x ps ) $.
    $( Rearrange universal quantifiers. $)
    aaan $p |- ( A. x A. y ( ph /\ ps ) <-> ( A. x ph /\ A. y ps ) ) $=
      wph wps wa vy wal vx wal wph wps vy wal wa vx wal wph vx wal wps vy wal
      wa wph wps wa vy wal wph wps vy wal wa vx wph wps vy aaan.1 19.28 albii
      wph wps vy wal vx wps vx vy aaan.2 hbal 19.27 bitri $.
      $( [12-Aug-1993] $)
  $}

  ${
    eeor.1 $e |- ( ph -> A. y ph ) $.
    eeor.2 $e |- ( ps -> A. x ps ) $.
    $( Rearrange existential quantifiers. $)
    eeor $p |- ( E. x E. y ( ph \/ ps ) <-> ( E. x ph \/ E. y ps ) ) $=
      wph wps wo vy wex vx wex wph wps vy wex wo vx wex wph vx wex wps vy wex
      wo wph wps wo vy wex wph wps vy wex wo vx wph wps vy eeor.1 19.45 exbii
      wph wps vy wex vx wps vx vy eeor.2 hbex 19.44 bitri $.
      $( [8-Aug-1994] $)
  $}

  $( Quantified "excluded middle."  Exercise 9.2a of Boolos, p. 111,
     _Computability and Logic_. $)
  qexmid $p |- E. x ( ph -> A. x ph ) $=
    wph wph vx wal vx wph vx wal vx 19.8a 19.35ri $.
    $( [10-Dec-2000] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Equality
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Show that the original axiom ~ ax-9o can be derived from ~ ax-9 and
     others.  See ~ ax9 for the rederivation of ~ ax-9 from ~ ax-9o .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-9o
     below so that uses of ~ ax-9o can be more easily identified. $)
  ax9o $p |- ( A. x ( x = y -> A. x ph ) -> ph ) $=
    vx vy weq wph vx wal wi vx wal wph vx wal vx wex wph vx vy weq wph vx wal
    wi vx wal vx vy weq vx wex wph vx wal vx wex vx vy weq vx wex vx vy weq wn
    vx wal wn vx vy ax-9 vx vy weq vx df-ex mpbir vx vy weq wph vx wal vx 19.22
    mpi wph vx a6e syl $.
    $( [5-Aug-1993] $)

  $( A variant of ~ ax-9 .  Axiom scheme C10' in [Megill] p. 448 (p. 16 of the
     preprint).

     This axiom is redundant, as shown by theorem ~ ax9o . $)
  ax-9o $a |- ( A. x ( x = y -> A. x ph ) -> ph ) $.

  $( Rederivation of axiom ~ ax-9 from the orginal version, ~ ax-9o .
     See ~ ax9o for the derivation of ~ ax-9o from ~ ax-9 .  Lemma L18 in
     [Megill] p. 446 (p. 14 of the preprint).

     This theorem should not be referenced in any proof.  Instead, use ~ ax-9
     above so that uses of ~ ax-9 can be more easily identified. $)
  ax9 $p |- -. A. x -. x = y $=
    vx vy weq vx vy weq wn vx wal wn vx wal wi vx vy weq wn vx wal wn vx vx vy
    weq wn vx wal wn vx vy ax-9o vx vy weq vx modal-b mpg $.
    $( [5-Aug-1993] $)

  $( At least one individual exists.  This is not a theorem of free logic,
     which is sound in empty domains.  For such a logic, we would add this
     theorem as an axiom of set theory (Axiom 0 of [Kunen] p. 10).
     In the system consisting of ~ ax-5 through ~ ax-14 and ~ ax-17 , all
     axioms other than ~ ax-9 are believed to be theorems of free logic,
     although the system without ~ ax-9 is probably not complete in free
     logic. $)
  a9e $p |- E. x x = y $=
    vx vy weq vx wex vx vy weq wn vx wal wn vx vy ax-9 vx vy weq vx df-ex mpbir
    $.
    $( [5-Aug-1993] $)

  $( Identity law for equality (reflexivity).  Lemma 6 of [Tarski] p. 68.
     This is often an axiom of equality in textbook systems, but we don't need
     it as an axiom since it can be proved from our other axioms (although
     the proof, as you can see below, is not as obvious as you might think).
     This proof uses only axioms without distinct variable conditions and thus
     requires no dummy variables.  A simpler proof, similar to Tarki's, is
     possible if we make use of ~ ax-17 ; see the proof of ~ equid1 .  See
     ~ equidALT for an alternate proof. $)
  equid $p |- x = x $=
    vx vx weq vx wal wn vx wal vx vx weq vx vx weq vx wal wn vx wal vx vx weq
    vx vx weq vx wal wi vx wal vx vx weq vx vx weq vx wal wn vx vx weq vx vx
    weq vx wal wi vx vx vx weq vx wal wn vx vx weq vx vx weq vx wal wi vx vx vx
    ax-12 pm2.43i 19.20i vx vx weq vx vx ax-9o syl vx vx weq vx ax-6o pm2.61i
    $.
    $( [5-Aug-1993] $)

  $( Identity law for equality (reflexivity).  Lemma 6 of [Tarski] p. 68.
     Alternate proof of ~ equid directly from equality axioms ~ ax-9 and
     ~ ax-12 . $)
  equidALT $p |- x = x $=
    vx vx weq vx vx vx weq vx wal vx vx weq wn vx wal vx vx ax-9 vx vx weq vx
    wal wn vx vx weq wn vx vx vx weq vx hbn1 vx vx weq vx wal wn vx vx weq wn
    vx vx weq vx wal wn vx vx weq vx vx weq vx wal vx vx weq vx wal wn vx vx
    weq vx vx weq vx wal wi vx vx vx ax-12 pm2.43i con3d pm2.43i 19.21ai mt3
    a4i $.
    $( [1-Dec-2008] $) $( [30-Nov-2008] $)

  $( One of the two equality axioms of standard predicate calculus, called
     reflexivity of equality.  (The other one is ~ stdpc7 .)  Axiom 6 of
     [Mendelson] p. 95.  Mendelson doesn't say why he prepended the redundant
     quantifier, but it was probably to be compatible with free logic (which is
     valid in the empty domain). $)
  stdpc6 $p |- A. x x = x $=
    vx vx weq vx vx equid ax-gen $.
    $( [16-Feb-2005] $) $( [16-Feb-2005] $)

  $( Commutative law for equality.  Lemma 7 of [Tarski] p. 69. $)
  equcomi $p |- ( x = y -> y = x ) $=
    vx vy weq vx vx weq vy vx weq vx equid vx vy vx ax-8 mpi $.
    $( [5-Aug-1993] $)

  $( Commutative law for equality. $)
  equcom $p |- ( x = y <-> y = x ) $=
    vx vy weq vy vx weq vx vy equcomi vy vx equcomi impbii $.
    $( [20-Aug-1993] $)

  ${
    equcoms.1 $e |- ( x = y -> ph ) $.
    $( An inference commuting equality in antecedent.  Used to eliminate the
       need for a syllogism. $)
    equcoms $p |- ( y = x -> ph ) $=
      vy vx weq vx vy weq wph vy vx equcomi equcoms.1 syl $.
      $( [5-Aug-1993] $)
  $}

  $( A transitive law for equality. $)
  equtr $p |- ( x = y -> ( y = z -> x = z ) ) $=
    vy vz weq vx vz weq wi vy vx vy vx vz ax-8 equcoms $.
    $( [23-Aug-1993] $)

  $( A transitive law for equality.  Lemma L17 in [Megill] p. 446
     (p. 14 of the preprint). $)
  equtrr $p |- ( x = y -> ( z = x -> z = y ) ) $=
    vz vx weq vx vy weq vz vy weq vz vx vy equtr com12 $.
    $( [23-Aug-1993] $)

  $( A transitive law for equality. $)
  equtr2 $p |- ( ( x = z /\ y = z ) -> x = y ) $=
    vx vz weq vy vz weq vx vy weq vx vz weq vz vy weq vx vy weq vy vz weq vx vz
    vy equtr vy vz equcomi syl5 imp $.
    $( [12-Aug-1993] $)

  $( An equivalence law for equality. $)
  equequ1 $p |- ( x = y -> ( x = z <-> y = z ) ) $=
    vx vy weq vx vz weq vy vz weq vx vy vz ax-8 vx vy vz equtr impbid $.
    $( [5-Aug-1993] $)

  $( An equivalence law for equality. $)
  equequ2 $p |- ( x = y -> ( z = x <-> z = y ) ) $=
    vx vy weq vz vx weq vz vy weq vx vy vz equtrr vz vy weq vz vx weq wi vy vx
    vy vx vz equtrr equcoms impbid $.
    $( [5-Aug-1993] $)

  $( An identity law for the non-logical predicate. $)
  elequ1 $p |- ( x = y -> ( x e. z <-> y e. z ) ) $=
    vx vy weq vx vz wel vy vz wel vx vy vz ax-13 vy vz wel vx vz wel wi vy vx
    vy vx vz ax-13 equcoms impbid $.
    $( [5-Aug-1993] $)

  $( An identity law for the non-logical predicate. $)
  elequ2 $p |- ( x = y -> ( z e. x <-> z e. y ) ) $=
    vx vy weq vz vx wel vz vy wel vx vy vz ax-14 vz vy wel vz vx wel wi vy vx
    vy vx vz ax-14 equcoms impbid $.
    $( [5-Aug-1993] $)

  ${
    ax11i.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    ax11i.2 $e |- ( ps -> A. x ps ) $.
    $( Inference that has ~ ax-11 (without ` A. y ` ) as its conclusion and
       doesn't require ~ ax-10 , ~ ax-11 , or ~ ax-12 for its proof.  The
       hypotheses may be eliminable without one or more of these axioms in
       special cases.  Proof similar to Lemma 16 of [Tarski] p. 70. $)
    ax11i $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      vx vy weq wph wps vx vy weq wph wi vx wal ax11i.1 wps vx vy weq wph wi vx
      ax11i.2 vx vy weq wph wps ax11i.1 biimprcd 19.21ai syl6bi $.
      $( [27-May-2008] $) $( [20-May-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Axioms ax-10 and ax-11
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Show that ~ ax-10o can be derived from ~ ax-10 .  An open problem is
     whether this theorem can be derived from ~ ax-10 and the others when
     ~ ax-11 is replaced with ~ ax-11o .  See theorem ~ ax10 for the
     rederivation of ~ ax-10 from ~ ax10o .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-10o
     below so that uses of ~ ax-10o can be more easily identified. $)
  ax10o $p |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $=
    vx vy weq vx wal wph vx wal vy vx weq wph wi vy wal wph vy wal vx vy weq
    wph vx wal vy vx weq wph wi vy wal wi vx wph vx wal vy vx weq wph wi vy wal
    wi vy vx wph vy vx ax-11 equcoms a4s vx vy weq vx wal vy vx weq vy wal vy
    vx weq wph wi vy wal wph vy wal wi vx vy ax-10 vy vx weq vy vx weq wph wi
    wph vy vy vx weq wph pm2.27 19.20ii syl syld $.
    $( [17-May-2008] $) $( [16-May-2008] $)

  $( Axiom ~ ax-10o ("o" for "old") was the original version of ~ ax-10 ,
     before it was discovered (in May 2008) that the shorter ~ ax-10 could
     replace it.  It appears as Axiom scheme C11' in [Megill] p. 448 (p. 16
     of the preprint).

     This axiom is redundant, as shown by theorem ~ ax10o . $)
  ax-10o $a |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $.

  $( Rederivation of ~ ax-10 from original version ~ ax-10o .  See theorem
     ~ ax10o for the derivation of ~ ax-10o from ~ ax-10 .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-10
     above so that uses of ~ ax-10 can be more easily identified. $)
  ax10 $p |- ( A. x x = y -> A. y y = x ) $=
    vx vy weq vx wal vx vy weq vy wal vy vx weq vy wal vx vy weq vx wal vx vy
    weq vy wal vx vy weq vx vy ax-10o pm2.43i vx vy weq vy vx weq vy vx vy
    equcomi 19.20i syl $.
    $( [17-May-2008] $) $( [16-May-2008] $)

  $( Commutation law for identical variable specifiers.  The antecedent and
     consequent are true when ` x ` and ` y ` are substituted with the same
     variable.  Lemma L12 in [Megill] p. 445 (p. 12 of the preprint). $)
  alequcom $p |- ( A. x x = y -> A. y y = x ) $=
    vx vy ax-10 $.
    $( [5-Aug-1993] $)

  ${
    alequcoms.1 $e |- ( A. x x = y -> ph ) $.
    $( A commutation rule for identical variable specifiers. $)
    alequcoms $p |- ( A. y y = x -> ph ) $=
      vy vx weq vy wal vx vy weq vx wal wph vy vx alequcom alequcoms.1 syl $.
      $( [5-Aug-1993] $)
  $}

  ${
    nalequcoms.1 $e |- ( -. A. x x = y -> ph ) $.
    $( A commutation rule for distinct variable specifiers. $)
    nalequcoms $p |- ( -. A. y y = x -> ph ) $=
      wph vy vx weq vy wal vx vy weq vx wal vy vx weq vy wal wph vx vy alequcom
      nalequcoms.1 nsyl4 con1i $.
      $( [2-Jan-2002] $)
  $}

  $( All variables are effectively bound in an identical variable specifier. $)
  hbae $p |- ( A. x x = y -> A. z A. x x = y ) $=
    vx vy weq vx wal vx vy weq vz wal vx wal vx vy weq vx wal vz wal vx vy weq
    vx vy weq vz wal vx vz vx weq vz wal vz vy weq vz wal vx vy weq vx wal vx
    vy weq vz wal wi vz vx weq vz wal wn vz vy weq vz wal wn vx vy weq vx vy
    weq vz wal vx vy weq vx wal vx vy vz ax-12 vx vy weq vx ax-4 syl7 vx vy weq
    vx wal vx vy weq vz wal wi vx vz vx vy weq vx vz ax-10o alequcoms vx vy weq
    vx wal vx vy weq vz wal wi vy vz vy vz weq vy wal vx vy weq vy wal vx vy
    weq vz wal vx vy weq vx wal vx vy weq vy vz ax-10o vx vy weq vx wal vx vy
    weq vy wal vx vy weq vx vy ax-10o pm2.43i syl5 alequcoms pm2.61ii a5i vx vy
    weq vx vz ax-7 syl $.
    $( [5-Aug-1993] $)

  ${
    hbalequs.1 $e |- ( A. z A. x x = y -> ph ) $.
    $( Rule that applies ~ hbae to antecedent. $)
    hbaes $p |- ( A. x x = y -> ph ) $=
      vx vy weq vx wal vx vy weq vx wal vz wal wph vx vy vz hbae hbalequs.1 syl
      $.
      $( [5-Aug-1993] $)
  $}

  $( All variables are effectively bound in a distinct variable specifier.
     Lemma L19 in [Megill] p. 446 (p. 14 of the preprint). $)
  hbnae $p |- ( -. A. x x = y -> A. z -. A. x x = y ) $=
    vx vy weq vx wal vz vx vy vz hbae hbn $.
    $( [5-Aug-1993] $)

  ${
    hbnalequs.1 $e |- ( A. z -. A. x x = y -> ph ) $.
    $( Rule that applies ~ hbnae to antecedent. $)
    hbnaes $p |- ( -. A. x x = y -> ph ) $=
      vx vy weq vx wal wn vx vy weq vx wal wn vz wal wph vx vy vz hbnae
      hbnalequs.1 syl $.
      $( [5-Aug-1993] $)
  $}

  $( Lemma used in proofs of substitution properties. $)
  equs3 $p |- ( E. x ( x = y /\ ph ) <-> -. A. x ( x = y -> -. ph ) ) $=
    vx vy weq wph wn wi vx wal vx vy weq wph wa vx wex vx vy weq wph vx alinexa
    con2bii $.
    $( [5-Aug-1993] $)

  $( Lemma used in proofs of substitution properties. $)
  equs4 $p |- ( A. x ( x = y -> ph ) -> E. x ( x = y /\ ph ) ) $=
    vx vy weq wph wi vx wal vx vy weq wph wn wi vx wal wn vx vy weq wph wa vx
    wex vx vy weq wph wi vx wal vx vy weq vx vy weq wph wn wi vx wal wn vx wal
    wi vx wal vx vy weq wph wn wi vx wal wn vx vy weq wph wi vx vy weq vx vy
    weq wph wn wi vx wal wn vx wal wi vx vx vy weq wph wi vx wal vx vy weq vx
    vy weq wph wn wi vx wal wn vx vy weq wph wn wi vx wal wn vx wal vx vy weq
    wph wi vx wal vx vy weq vx vy weq wph wn wi vx wal wn vx vy weq wph wi vx
    wal vx vy weq wa vx vy weq wph wn wi vx vy weq wph wn wi vx wal vx vy weq
    wph wi vx wal vx vy weq wa vx vy weq wph vx vy weq wph wi vx wal vx vy weq
    pm3.27 vx vy weq wph wi vx wal vx vy weq wph vx vy weq wph wi vx ax-4 imp
    jc vx vy weq wph wn wi vx ax-4 nsyl ex vx vy weq wph wn wi vx hbn1 syl6 a5i
    vx vy weq wph wn wi vx wal wn vx vy ax-9o syl wph vx vy equs3 sylibr $.
    $( [5-Aug-1993] $)

  ${
    equsal.1 $e |- ( ps -> A. x ps ) $.
    equsal.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution. $)
    equsal $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      vx vy weq wph wi vx wal vx vy weq wps vx wal wi vx wal wps vx vy weq wph
      wi vx vy weq wps vx wal wi vx vx vy weq wph wps vx wal vx vy weq wph wps
      wps vx wal equsal.2 wps vx equsal.1 19.3 syl6bbr pm5.74i albii wps vx vy
      weq wps vx wal wi vx wal wps wps vx wal vx vy weq wps vx wal wi vx wal
      equsal.1 wps vx vy weq wps vx wal wi vx wps vx wal vx vy weq ax-1 a5i syl
      wps vx vy ax-9o impbii bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    equsex.1 $e |- ( ps -> A. x ps ) $.
    equsex.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution. $)
    equsex $p |- ( E. x ( x = y /\ ph ) <-> ps ) $=
      vx vy weq wph wn wi wn vx wex vx vy weq wph wn wi vx wal wn vx vy weq wph
      wa vx wex wps vx vy weq wph wn wi vx exnal vx vy weq wph wa vx vy weq wph
      wn wi wn vx vx vy weq wph df-an exbii vx vy weq wph wn wi vx wal wps wph
      wn wps wn vx vy wps vx equsex.1 hbn vx vy weq wph wps equsex.2 notbid
      equsal con2bii 3bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    dvelimfALT.1 $e |- ( ph -> A. x ph ) $.
    dvelimfALT.2 $e |- ( ps -> A. z ps ) $.
    dvelimfALT.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Proof of ~ dvelimf without using ~ ax-11 .  See ~ dvelimALT for a proof
       (of the distinct variable version ~ dvelim ) that doesn't require
        ~ ax-10 . $)
    dvelimfALT $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      vx vy weq vx wal wn vz vy weq wph wi vz wal vz vy weq wph wi vz wal vx
      wal wps wps vx wal vx vz weq vx wal vx vy weq vx wal wn vz vy weq wph wi
      vz wal vz vy weq wph wi vz wal vx wal wi wi vx vz weq vx wal vz vy weq
      wph wi vz wal vz vy weq wph wi vz wal vx wal wi vx vy weq vx wal wn vx vz
      weq vx wal vz vy weq wph wi vz wal vz wal vz vy weq wph wi vz wal vx wal
      vz vy weq wph wi vz wal vz vy weq wph wi vz wal vz wal vz vy weq wph wi
      vz wal vx wal wi vz vx vz vy weq wph wi vz wal vz vx ax-10o alequcoms vz
      vy weq wph wi vz hba1 syl5 a1d vx vz weq vx wal wn vx vy weq vx wal wn vz
      vy weq wph wi vz wal vz vy weq wph wi vz wal vx wal wi vx vz weq vx wal
      wn vx vy weq vx wal wn wa vz vy weq wph wi vx vz vx vz weq vx wal wn vx
      vy weq vx wal wn vz vx vz vz hbnae vx vy vz hbnae hban vx vz weq vx wal
      wn vx vy weq vx wal wn wa vz vy weq wph vx vx vz weq vx wal wn vx vy weq
      vx wal wn vx vx vz vx hbnae vx vy vx hbnae hban vx vz weq vx wal wn vx vy
      weq vx wal wn vz vy weq vz vy weq vx wal wi vz vy vx ax-12 imp wph wph vx
      wal wi vx vz weq vx wal wn vx vy weq vx wal wn wa dvelimfALT.1 a1i hbimd
      hbald ex pm2.61i wph wps vz vy dvelimfALT.2 dvelimfALT.3 equsal vz vy weq
      wph wi vz wal wps vx wph wps vz vy dvelimfALT.2 dvelimfALT.3 equsal albii
      3imtr3g $.
      $( [12-Nov-2002] $)
  $}

  ${
    dral1.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint). $)
    dral1 $p |- ( A. x x = y -> ( A. x ph <-> A. y ps ) ) $=
      vx vy weq vx wal wph vx wal wps vy wal vx vy weq vx wal wph vx wal wps vx
      wal wps vy wal vx vy weq vx wal wph wps vx vx vy vx hbae vx vy weq vx wal
      wph wps dral1.1 biimpd 19.20d wps vx vy ax-10o syld vx vy weq vx wal wps
      vy wal wph vy wal wph vx wal vx vy weq vx wal wps wph vy vx vy vy hbae vx
      vy weq vx wal wph wps dral1.1 biimprd 19.20d wph vy wal wph vx wal wi vy
      vx wph vy vx ax-10o alequcoms syld impbid $.
      $( [24-Nov-1994] $)
  $}

  ${
    dral2.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint). $)
    dral2 $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
      vx vy weq vx wal wph wps vz vx vy vz hbae dral2.1 albid $.
      $( [21-Mar-2005] $) $( [27-Feb-2005] $)
  $}

  ${
    drex1.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint). $)
    drex1 $p |- ( A. x x = y -> ( E. x ph <-> E. y ps ) ) $=
      vx vy weq vx wal wph wn vx wal wn wps wn vy wal wn wph vx wex wps vy wex
      vx vy weq vx wal wph wn vx wal wps wn vy wal wph wn wps wn vx vy vx vy
      weq vx wal wph wps drex1.1 notbid dral1 notbid wph vx df-ex wps vy df-ex
      3bitr4g $.
      $( [5-Apr-2005] $) $( [27-Feb-2005] $)
  $}

  ${
    drex2.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint). $)
    drex2 $p |- ( A. x x = y -> ( E. z ph <-> E. z ps ) ) $=
      vx vy weq vx wal wph wps vz vx vy vz hbae drex2.1 exbid $.
      $( [16-May-2005] $) $( [27-Feb-2005] $)
  $}

  $( Closed theorem form of ~ a4im . $)
  a4imt $p |- ( A. x ( ( ps -> A. x ps ) /\ ( x = y -> ( ph -> ps ) ) ) ->
              ( A. x ph -> ps ) ) $=
    wps wps vx wal wi vx vy weq wph wps wi wi wa vx wal wph vx wal vx vy weq
    wps vx wal wi vx wal wps wps wps vx wal wi vx vy weq wph wps wi wi wa wph
    vx vy weq wps vx wal wi vx wps wps vx wal wi vx vy weq wph wps wi wi wa vx
    vy weq wph wps vx wal wps wps vx wal wi vx vy weq wph wps wi wi vx vy weq
    wph wps vx wal wi wi wps wps vx wal wi wph wps wi wph wps vx wal wi vx vy
    weq wps wps vx wal wph imim2 imim2d imp com23 19.20ii wps vx vy ax-9o syl6
    $.
    $( [16-Jan-2008] $) $( [15-Jan-2008] $)

  ${
    a4im.1 $e |- ( ps -> A. x ps ) $.
    a4im.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization, using implicit substitition.  Compare Lemma 14 of
       [Tarski] p. 70.  The ~ a4im series of theorems requires that only one
       direction of the substitution hypothesis hold. $)
    a4im $p |- ( A. x ph -> ps ) $=
      wph vx wal vx vy weq wps vx wal wi vx wal wps wph vx vy weq wps vx wal wi
      vx vx vy weq wph wps wps vx wal a4im.2 a4im.1 syl6com 19.20i wps vx vy
      ax-9o syl $.
      $( [8-May-2008] $) $( [5-Aug-1993] $)
  $}

  ${
    a4ime.1 $e |- ( ph -> A. x ph ) $.
    a4ime.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Existential introduction, using implicit substitition.  Compare Lemma 14
       of [Tarski] p. 70. $)
    a4ime $p |- ( ph -> E. x ps ) $=
      wph wps wn vx wal wn wps vx wex wps wn vx wal wph wps wn wph wn vx vy wph
      vx a4ime.1 hbn vx vy weq wph wps a4ime.2 con3d a4im con2i wps vx df-ex
      sylibr $.
      $( [7-Aug-1994] $)
  $}

  ${
    a4imed.1 $e |- ( ch -> A. x ch ) $.
    a4imed.2 $e |- ( ch -> ( ph -> A. x ph ) ) $.
    a4imed.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Deduction version of ~ a4ime . $)
    a4imed $p |- ( ch -> ( ph -> E. x ps ) ) $=
      wch wph wps vx wex wch wph wa wps vx vy wch wph wa vx wal wch vx wal wph
      vx wal wch wph wa wch wph vx 19.26 wch wch vx wal wph a4imed.1 adantr wch
      wph wph vx wal a4imed.2 imp sylanbrc vx vy weq wph wps wch a4imed.3
      adantld a4ime ex $.
      $( [5-Aug-1993] $)
  $}

  ${
    cbv1.1 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv1.2 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv1.3 $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbv1 $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      wph vy wal vx wal wps vx wal wps vx wal vy wal wch vy wal wph vy wal vx
      wal wps vx wal wps vy wal vx wal wps vx wal vy wal wph vy wal wps wps vy
      wal vx wph wps wps vy wal wi vy cbv1.1 a4s 19.20ii wps vx vy ax-7 syl6
      wph wps vx wal vy wal wch vy wal wi vy vx wph vx wal wps vx wal wch vy
      wph vx wal wps vx wal vx vy weq wch vx wal wi vx wal wch wph wps vx vy
      weq wch vx wal wi vx wph wps vx vy weq wch wch vx wal wph vx vy weq wps
      wch cbv1.3 com23 cbv1.2 syl6d 19.20ii wch vx vy ax-9o syl6 19.20ii a7s
      syld $.
      $( [5-Aug-1993] $)
  $}


  ${
    cbv2.1 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv2.2 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv2.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbv2 $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      wph vy wal vx wal wps vx wal wch vy wal wph wps wch vx vy cbv2.1 cbv2.2
      wph vx vy weq wps wch wb wps wch wi cbv2.3 wps wch bi1 syl6 cbv1 wph wch
      vy wal wps vx wal wi vy vx wph wch wps vy vx cbv2.2 cbv2.1 wph vx vy weq
      wch wps wi vy vx weq wph vx vy weq wps wch wb wch wps wi cbv2.3 wps wch
      bi2 syl6 vy vx equcomi syl5 cbv1 a7s impbid $.
      $( [5-Aug-1993] $)
  $}

  ${
    cbv3.1 $e |- ( ph -> A. y ph ) $.
    cbv3.2 $e |- ( ps -> A. x ps ) $.
    cbv3.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbv3 $p |- ( A. x ph -> A. y ps ) $=
      wph wph wi vy wal wph vx wal wps vy wal wi vx wph wph wi wph wps vx vy
      wph wph vy wal wph cbv3.1 imim2i wps wps vx wal wi wph wph wi cbv3.2 a1i
      vx vy weq wph wps wi wi wph wph wi cbv3.3 a1i cbv1 wph wph wi vy wph id
      ax-gen mpg $.
      $( [5-Aug-1993] $)
  $}


  ${
    cbval.1 $e |- ( ph -> A. y ph ) $.
    cbval.2 $e |- ( ps -> A. x ps ) $.
    cbval.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbval $p |- ( A. x ph <-> A. y ps ) $=
      wph wph wi vy wal wph vx wal wps vy wal wb vx wph wph wi wph wps vx vy
      wph wph vy wal wph cbval.1 imim2i wps wps vx wal wi wph wph wi cbval.2
      a1i vx vy weq wph wps wb wi wph wph wi cbval.3 a1i cbv2 wph wph wi vy wph
      id ax-gen mpg $.
      $( [5-Aug-1993] $)
  $}

  ${
    cbvex.1 $e |- ( ph -> A. y ph ) $.
    cbvex.2 $e |- ( ps -> A. x ps ) $.
    cbvex.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbvex $p |- ( E. x ph <-> E. y ps ) $=
      wph wn vx wal wn wps wn vy wal wn wph vx wex wps vy wex wph wn vx wal wps
      wn vy wal wph wn wps wn vx vy wph vy cbvex.1 hbn wps vx cbvex.2 hbn vx vy
      weq wph wps cbvex.3 notbid cbval notbii wph vx df-ex wps vy df-ex 3bitr4i
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    chv2.1 $e |- ( ps -> A. x ps ) $.
    chv2.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    chv2.3 $e |- ph $.
    $( Implicit substitution of ` y ` for ` x ` into a theorem.  (Contributed
       by Raph Levien, 9-Jul-2003.) $)
    chvar $p |- ps $=
      wph wps vx wph wps vx vy chv2.1 vx vy weq wph wps chv2.2 biimpd a4im
      chv2.3 mpg $.
      $( [29-Jul-2003] $) $( [9-Jul-2003] $)
  $}

  $( A variable introduction law for equality.  Lemma 15 of [Monk2] p. 109,
     however we do not require ` z ` to be distinct from ` x ` and ` y `
     (making the proof longer). $)
  equvini $p |- ( x = y -> E. z ( x = z /\ z = y ) ) $=
    vz vx weq vz wal vz vy weq vz wal wo vx vy weq vx vz weq vz vy weq wa vz
    wex wi vz vx weq vz wal vz vy weq vz wal wo vx vz weq vz vy weq wa vz wex
    vx vy weq vz vx weq vz wal vx vz weq vz vy weq wa vz wex vz vy weq vz wal
    vz vx weq vz wal vz vz weq vz vy weq wa vz wex vx vz weq vz vy weq wa vz
    wex vz vy weq vz wex vz vz weq vz vy weq wa vz wex vz vy a9e vz vy weq vz
    vz weq vz vy weq wa vz vz vy weq vz vz weq vz equid jctl 19.22i ax-mp vz vx
    weq vz wal vz vz weq vz vy weq wa vx vz weq vz vy weq wa vz vz vx vz hbae
    vz vx weq vz wal vz vz weq vx vz weq vz vy weq vz vx weq vz vz weq vx vz
    weq wi vz vz vx vz ax-8 a4s anim1d 19.22d mpi vz vy weq vz wal vx vz weq vz
    vz weq wa vz wex vx vz weq vz vy weq wa vz wex vz vx weq vz wex vx vz weq
    vz vz weq wa vz wex vz vx a9e vz vx weq vx vz weq vz vz weq wa vz vz vx weq
    vx vz weq vz vz weq vz vx equcomi vz equid jctir 19.22i ax-mp vz vy weq vz
    wal vx vz weq vz vz weq wa vx vz weq vz vy weq wa vz vz vy vz hbae vz vy
    weq vz wal vz vz weq vz vy weq vx vz weq vz vy weq vz vz weq vz vy weq wi
    vz vz vy vz equtrr a4s anim2d 19.22d mpi jaoi a1d vz vx weq vz wal vz vy
    weq vz wal wo wn vz vx weq vz wal wn vz vy weq vz wal wn wa vx vy weq vx vz
    weq vz vy weq wa vz wex wi vz vx weq vz wal vz vy weq vz wal ioran vx vy
    weq vx vz weq vz vy weq wa vz vx weq vz wal wn vz vy weq vz wal wn wa vz vx
    vz vx weq vz wal wn vz vy weq vz wal wn vz vz vx vz hbnae vz vy vz hbnae
    hban vz vx weq vz wal wn vz vy weq vz wal wn vx vy weq vx vy weq vz wal wi
    vx vy vz ax-12 imp vx vy weq vx vz weq vz vy weq wa wi vx vz vx vz weq vx
    vy weq vz vy weq vx vz vy ax-8 anc2li equcoms a4imed sylbi pm2.61i $.
    $( [5-Aug-1993] $)

  $( Bound-variable hypothesis builder for ` x = x ` .  This theorem tells us
     that ` x ` is effectively not free in ` x = x ` , even though it is
     technically free according to the traditional definition of free variable.
     (The proof shows that this can be proved without ~ ax-9 , even though the
     theorem ~ equid cannot be.  A shorter proof that uses ~ ax-9 is obtainable
     from ~ equid and ~ hbth .)  See ~ hbequid for a more general version. $)
  hbequid2 $p |- ( x = x -> A. x x = x ) $=
    vx vx weq vx wal vx vx weq vx wal vx vx weq vx vx weq vx wal wi vx vx vx
    ax-12 vx vx weq vx wal vx vx weq ax-1 vx vx weq vx wal vx vx weq ax-1
    pm2.61ii $.
    $( [3-Aug-2008] $) $( [27-Dec-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Substitution (without distinct variables)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c [ $. $( Left bracket $)
  $c / $. $( Division. $)
  $c ] $.  $( Right bracket $)

  $( --- Start of patch to prevent connective overloading $)
  ${
    $v A $.
    wsbc.cA $f class A $.
    $( Extend wff notation to include the proper substitution of a class for a
       set.  Read this notation as "the proper substitution of class ` A ` for
       set variable ` x ` in wff ` ph ` ."

       (The purpose of introducing ` wff [ A / x ] ph ` here is to allow us to
       express i.e. "prove" the ~ wsb of predicate calculus in terms of the
       ~ wsbc of set theory, so that we don't "overload" its connectives with
       two syntax definitions.  This is done to prevent ambiguity that would
       complicate some Metamath parsers.  The class variable ` A ` is
       introduced temporarily for the purpose of this definition but otherwise
       not used in predicate calculus.  See ~ df-sbc for more information on
       the set theory usage of ~ wsbc .) $)
    wsbc $a wff [ A / x ] ph $.
  $}

  $( Extend wff definition to include proper substitution (read "the wff that
     results when ` y ` is properly substituted for ` x ` in wff ` ph ` ").

     (Instead of introducing ~ wsb as an axiomatic statement, as was done
     in an older version of this database, we introduce it by "proving" a
     special case of set theory's more general ~ wsbc .  This lets us avoid
     overloading its connectives, thus preventing ambiguity that would
     complicate some Metamath parsers.  Note: To see the proof steps of
     this syntax proof, type "show proof wsb /all" in the Metamath
     program.) $)
  wsb $p wff [ y / x ] ph $=
    wph vx vy cv wsbc $.
    $( [24-Jan-2006] $)
  $( --- End of patch to prevent connective overloading $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include proper substitution (read "the wff that
     results when ` y ` is properly substituted for ` x ` in wff ` ph ` ").

     After we introduce ~ cv and ~ wsbc in set theory, this syntax construction
     becomes redundant, since it can be derived with the proof
     "wph vx vy cv wsbc". @)
  wsb @a wff [ y / x ] ph @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Define proper substitution.  Remark 9.1 in [Megill] p. 447 (p. 15 of the
     preprint).  For our notation, we use ` [ y / x ] ph ` to mean "the wff
     that results when ` y ` is properly substituted for ` x ` in the wff
     ` ph ` ."  We can also use ` [ y / x ] ph ` in place of the "free for"
     side condition used in traditional predicate calculus; see, for example,
     ~ stdpc4 .

     Our notation was introduced in Haskell B. Curry's _Foundations of
     Mathematical Logic_ (1977), p. 316 and is frequently used in textbooks
     of lambda calculus and combinatory logic.  This notation improves the
     common but ambiguous notation, " ` ph ( y ) ` is the wff that results
     when ` y ` is properly substituted for ` x ` in ` ph ( x ) ` ."  For
     example, if the original ` ph ( x ) ` is ` x = y ` , then ` ph ( y ) `
     is ` y = y ` , from which we obtain that ` ph ( x ) ` is ` x = x ` .  So
     what exactly does ` ph ( x ) ` mean?  Curry's notation solves this
     problem.

     In most books, proper substitution has a somewhat complicated recursive
     definition with multiple cases based on the occurrences of free and
     bound variables in the wff.  Instead, we use a remarkable little formula
     that is exactly equivalent and gives us a single direct definition.  We
     later prove that our definition has the properties we expect of proper
     substitution (see theorems ~ sbequ , ~ sbcom2 and ~ sbid2v ).

     Note that our definition is valid even when ` x ` and ` y ` are replaced
     with the same variable, as ~ sbid shows.  We achieve this by having ` x `
     free in the first conjunct and bound in the second.  We can also achieve
     this by using a dummy variable, as the alternate definition ~ dfsb7 shows
     (which some logicians may prefer because it doesn't mix free and bound
     variables).  Another version that mixes free and bound variables is
     ~ dfsb3 .  When ` x ` and ` y ` are distinct, we can express proper
     substitution with the simpler expressions of ~ sb5 and ~ sb6 .

     There are no restrictions on any of the variables, including what
     variables may occur in wff ` ph ` . $)
  df-sb $a |- ( [ y / x ] ph <->
              ( ( x = y -> ph ) /\ E. x ( x = y /\ ph ) ) ) $.

  ${
    sbimi.1 $e |- ( ph -> ps ) $.
    $( Infer substitution into antecedent and consequent of an implication. $)
    sbimi $p |- ( [ y / x ] ph -> [ y / x ] ps ) $=
      vx vy weq wph wi vx vy weq wph wa vx wex wa vx vy weq wps wi vx vy weq
      wps wa vx wex wa wph vx vy wsb wps vx vy wsb vx vy weq wph wi vx vy weq
      wps wi vx vy weq wph wa vx wex vx vy weq wps wa vx wex wph wps vx vy weq
      sbimi.1 imim2i vx vy weq wph wa vx vy weq wps wa vx wph wps vx vy weq
      sbimi.1 anim2i 19.22i anim12i wph vx vy df-sb wps vx vy df-sb 3imtr4i $.
      $( [25-Jun-1998] $)
  $}

  ${
    sbbii.1 $e |- ( ph <-> ps ) $.
    $( Infer substitution into both sides of a logical equivalence. $)
    sbbii $p |- ( [ y / x ] ph <-> [ y / x ] ps ) $=
      wph vx vy wsb wps vx vy wsb wph wps vx vy wph wps sbbii.1 biimpi sbimi
      wps wph vx vy wph wps sbbii.1 biimpri sbimi impbii $.
      $( [5-Aug-1993] $)
  $}

  $( Formula-building lemma for use with the Distinctor Reduction Theorem.
     Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint). $)
  drsb1 $p |- ( A. x x = y -> ( [ z / x ] ph <-> [ z / y ] ph ) ) $=
    vx vy weq vx wal vx vz weq wph wi vx vz weq wph wa vx wex wa vy vz weq wph
    wi vy vz weq wph wa vy wex wa wph vx vz wsb wph vy vz wsb vx vy weq vx wal
    vx vz weq wph wi vy vz weq wph wi vx vz weq wph wa vx wex vy vz weq wph wa
    vy wex vx vy weq vx wal vx vz weq vy vz weq wph vx vy weq vx vz weq vy vz
    weq wb vx vx vy vz equequ1 a4s imbi1d vx vz weq wph wa vy vz weq wph wa vx
    vy vx vy weq vx wal vx vz weq vy vz weq wph vx vy weq vx vz weq vy vz weq
    wb vx vx vy vz equequ1 a4s anbi1d drex1 anbi12d wph vx vz df-sb wph vy vz
    df-sb 3bitr4g $.
    $( [5-Aug-1993] $)

  $( One direction of a simplified definition of substitution. $)
  sb1 $p |- ( [ y / x ] ph -> E. x ( x = y /\ ph ) ) $=
    wph vx vy wsb vx vy weq wph wi vx vy weq wph wa vx wex wph vx vy df-sb
    pm3.27bi $.
    $( [5-Aug-1993] $)

  $( One direction of a simplified definition of substitution. $)
  sb2 $p |- ( A. x ( x = y -> ph ) -> [ y / x ] ph ) $=
    wph vx vy wsb vx vy weq wph wi vx vy weq wph wa vx wex vx vy weq wph wi vx
    wal wph vx vy df-sb vx vy weq wph wi vx ax-4 wph vx vy equs4 sylanbrc $.
    $( [5-Aug-1993] $)

  $( An equality theorem for substitution. $)
  sbequ1 $p |- ( x = y -> ( ph -> [ y / x ] ph ) ) $=
    vx vy weq wph wph vx vy wsb wph vx vy wsb vx vy weq wph wi vx vy weq wph wa
    vx wex vx vy weq wph wa wph vx vy df-sb vx vy weq wph pm3.4 vx vy weq wph
    wa vx 19.8a sylanbrc ex $.
    $( [5-Aug-1993] $)

  $( An equality theorem for substitution. $)
  sbequ2 $p |- ( x = y -> ( [ y / x ] ph -> ph ) ) $=
    vx vy weq vx vy weq wph wi vx vy weq wph wa vx wex wa wph wph vx vy wsb vx
    vy weq wph wi vx vy weq wph wa vx wex wa vx vy weq wph vx vy weq wph wi vx
    vy weq wph wa vx wex pm3.26 com12 wph vx vy df-sb syl5ib $.
    $( [5-Aug-1993] $)

  $( One of the two equality axioms of standard predicate calculus, called
     substitutivity of equality.  (The other one is ~ stdpc6 .)  Translated
     to traditional notation, it can be read:
     " ` x = y -> ( ph ( x , x ) -> ph ( x , y ) ) ` , provided that ` y ` is
     free for ` x ` in ` ph ( x , y ) ` ."  Axiom 7 of [Mendelson] p. 95. $)
  stdpc7 $p |- ( x = y -> ( [ x / y ] ph -> ph ) ) $=
    wph vy vx wsb wph wi vy vx wph vy vx sbequ2 equcoms $.
    $( [15-Feb-2005] $) $( [15-Feb-2005] $)

  $( An equality theorem for substitution. $)
  sbequ12 $p |- ( x = y -> ( ph <-> [ y / x ] ph ) ) $=
    vx vy weq wph wph vx vy wsb wph vx vy sbequ1 wph vx vy sbequ2 impbid $.
    $( [5-Aug-1993] $)

  $( An equality theorem for substitution. $)
  sbequ12r $p |- ( x = y -> ( [ x / y ] ph <-> ph ) ) $=
    vy vx weq wph wph vy vx wsb wb vx vy weq wph vy vx wsb wph wb wph vy vx
    sbequ12 vx vy equcom wph vy vx wsb wph bicom 3imtr4i $.
    $( [7-Oct-2004] $) $( [6-Oct-2004] $)

  $( An equality theorem for substitution. $)
  sbequ12a $p |- ( x = y -> ( [ y / x ] ph <-> [ x / y ] ph ) ) $=
    vx vy weq wph wph vx vy wsb wph vy vx wsb wph vx vy sbequ12 wph wph vy vx
    wsb wb vy vx wph vy vx sbequ12 equcoms bitr3d $.
    $( [5-Aug-1993] $)

  $( An identity theorem for substitution.  Remark 9.1 in [Megill] p. 447
     (p. 15 of the preprint). $)
  sbid $p |- ( [ x / x ] ph <-> ph ) $=
    wph wph vx vx wsb vx vx weq wph wph vx vx wsb wb vx equid wph vx vx sbequ12
    ax-mp bicomi $.
    $( [5-Aug-1993] $)

  $( The specialization axiom of standard predicate calculus.  It states that
     if a statement ` ph ` holds for all ` x ` , then it also holds for the
     specific case of ` y ` (properly) substituted for ` x ` .  Translated to
     traditional notation, it can be read:  " ` A. x ph ( x ) -> ph ( y ) ` ,
     provided that ` y ` is free for ` x ` in ` ph ( x ) ` ."  Axiom 4 of
     [Mendelson] p. 69.  See also ~ a4sbc and ~ ra4sbc . $)
  stdpc4 $p |- ( A. x ph -> [ y / x ] ph ) $=
    wph vx wal vx vy weq wph wi vx wal wph vx vy wsb wph vx vy weq wph wi vx
    wph vx vy weq ax-1 19.20i wph vx vy sb2 syl $.
    $( [5-Aug-1993] $)

  ${
    sbf.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution for a variable not free in a wff does not affect it. $)
    sbf $p |- ( [ y / x ] ph <-> ph ) $=
      wph vx vy wsb wph wph vx vy wsb vx vy weq vx wex wph wph vx vy wsb vx vy
      weq wph wa vx wex vx vy weq vx wex wph wa wph vx vy sb1 vx vy weq wph vx
      sbf.1 19.41 sylib pm3.27d wph wph vx wal wph vx vy wsb sbf.1 wph vx vy
      stdpc4 syl impbii $.
      $( [17-Oct-2004] $) $( [5-Aug-1993] $)
  $}

  $( Substitution has no effect on a bound variable. $)
  sbf2 $p |- ( [ y / x ] A. x ph <-> A. x ph ) $=
    wph vx wal vx vy wph vx hba1 sbf $.
    $( [2-Jul-2005] $) $( [1-Jul-2005] $)

  ${
    sb6x.1 $e |- ( ph -> A. x ph ) $.
    $( Equivalence involving substitution for a variable not free. $)
    sb6x $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      wph vx vy wsb vx vy weq wph wi vx wal wph vx vy wsb wph vx vy weq wph wi
      vx wal wph vx vy sb6x.1 sbf wph vx vy weq wph wi vx sb6x.1 wph vx vy weq
      ax-1 19.21ai sylbi wph vx vy sb2 impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    hbs1f.1 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` . $)
    hbs1f $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      wph vx vy wsb wph wph vx wal wph vx vy wsb vx wal wph vx vy wsb vx vy weq
      vx wex wph wph vx vy wsb vx vy weq wph wa vx wex vx vy weq vx wex wph wa
      wph vx vy sb1 vx vy weq wph vx hbs1f.1 19.41 sylib pm3.27d hbs1f.1 wph
      wph vx vy wsb vx wph vx vy stdpc4 a5i 3syl $.
      $( [5-Aug-1993] $)
  $}

  $( Substitution does not change an identical variable specifier. $)
  sbequ5 $p |- ( [ w / z ] A. x x = y <-> A. x x = y ) $=
    vx vy weq vx wal vz vw vx vy vz hbae sbf $.
    $( [21-Dec-2004] $) $( [5-Aug-1993] $)

  $( Substitution does not change a distinctor. $)
  sbequ6 $p |- ( [ w / z ] -. A. x x = y <-> -. A. x x = y ) $=
    vx vy weq vx wal wn vz vw vx vy vz hbnae sbf $.
    $( [14-May-2005] $) $( [5-Aug-1993] $)

  ${
    sbt.1 $e |- ph $.
    $( A substitution into a theorem remains true.  (See ~ chvar and ~ chvarv
       for versions, using implicit substitition. $)
    sbt $p |- [ y / x ] ph $=
      vx vy weq wph wi wph vx vy wsb vx wph vx vy sb2 wph vx vy weq sbt.1 a1i
      mpg $.
      $( [21-Jan-2004] $) $( [21-Jan-2004] $)
  $}

  $( Substitution applied to an atomic wff. $)
  equsb1 $p |- [ y / x ] x = y $=
    vx vy weq vx vy weq wi vx vy weq vx vy wsb vx vx vy weq vx vy sb2 vx vy weq
    id mpg $.
    $( [5-Aug-1993] $)

  $( Substitution applied to an atomic wff. $)
  equsb2 $p |- [ y / x ] y = x $=
    vx vy weq vy vx weq wi vy vx weq vx vy wsb vx vy vx weq vx vy sb2 vx vy
    equcomi mpg $.
    $( [5-Aug-1993] $)

  ${
    sbied.1 $e |- ( ph -> A. x ph ) $.
    sbied.2 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    sbied.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Conversion of implicit substitution to explicit substitution (deduction
       version of ~ sbie ). $)
    sbied $p |- ( ph -> ( [ y / x ] ps <-> ch ) ) $=
      wph wps vx vy wsb wch wph wph vx wal wps vx vy wsb wch wi sbied.1 wph vx
      wal wps vx vy wsb wch vx wex wch wph vx wal vx vy weq wps wa vx wex wch
      vx wex wps vx vy wsb wph vx wal vx vy weq wps wa wch wi vx wal vx vy weq
      wps wa vx wex wch vx wex wi wph vx vy weq wps wa wch wi vx wph vx vy weq
      wps wch wph vx vy weq wps wch wb wps wch wi sbied.3 wps wch bi1 syl6
      imp3a 19.20i vx vy weq wps wa wch vx 19.22 syl wps vx vy sb1 syl5 wph vx
      wal wch vx wex wch vx wal wch wph vx wal wch wch vx wal wi vx wal wch vx
      wex wch vx wal wi wph wch wch vx wal wi vx sbied.2 19.20i wch wch vx wal
      vx wch vx hba1 19.23 sylib wch vx ax-4 syl6 syld syl wph wph vx wal wch
      wps vx vy wsb wi sbied.1 wph vx wal wch wch vx wal wps vx vy wsb wph wch
      wch vx wal wi vx sbied.2 a4s wph vx wal wch vx wal vx vy weq wps wi vx
      wal wps vx vy wsb wph wch vx vy weq wps wi vx wph vx vy weq wch wps wph
      vx vy weq wps wch wb wch wps wi sbied.3 wps wch bi2 syl6 com23 19.20ii
      wps vx vy sb2 syl6 syld syl impbid $.
      $( [30-Jun-1994] $)
  $}

  ${
    sbie.1 $e |- ( ps -> A. x ps ) $.
    sbie.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit substitution. $)
    sbie $p |- ( [ y / x ] ph <-> ps ) $=
      wph wph wi wph vx vy wsb wps wb wph id wph wph wi wph wps vx vy wph wph
      wi vx wph id hbth wps wps vx wal wi wph wph wi sbie.1 a1i vx vy weq wph
      wps wb wi wph wph wi sbie.2 a1i sbied ax-mp $.
      $( [30-Jun-1994] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Theorems using axiom ax-11
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A property related to substitution that unlike ~ equs5 doesn't require a
     distinctor antecedent. $)
  equs5a $p |- ( E. x ( x = y /\ A. y ph ) -> A. x ( x = y -> ph ) ) $=
    vx vy weq wph vy wal wa vx vy weq wph wi vx wal vx vx vy weq wph wi vx hba1
    vx vy weq wph vy wal vx vy weq wph wi vx wal wph vx vy ax-11 imp 19.23ai $.
    $( [4-Feb-2007] $) $( [2-Feb-2007] $)

  $( A property related to substitution that unlike ~ equs5 doesn't require a
     distinctor antecedent. $)
  equs5e $p |- ( E. x ( x = y /\ ph ) -> A. x ( x = y -> E. y ph ) ) $=
    vx vy weq wph wa vx wex vx vy weq wph wn wi vx wal wn vx vy weq wph vy wex
    wi vx wal wph vx vy equs3 vx vy weq wph wn wi vx wal wn vx vy weq wph vy
    wex wi vx vx vy weq wph wn wi vx hbn1 vx vy weq wph wn wi vx wal wn vx vy
    weq wph wn vy wal wn wph vy wex vx vy weq vx vy weq wph wn wi vx wal wn wph
    wn vy wal wn vx vy weq wph wn vy wal vx vy weq wph wn wi vx wal wph wn vx
    vy ax-11 con3d com12 wph vy df-ex syl6ibr 19.21ai sylbi $.
    $( [11-Feb-2007] $) $( [2-Feb-2007] $)

  $( A version of ~ sb4 that doesn't require a distinctor antecedent. $)
  sb4a $p |- ( [ y / x ] A. y ph -> A. x ( x = y -> ph ) ) $=
    wph vy wal vx vy wsb vx vy weq wph vy wal wa vx wex vx vy weq wph wi vx wal
    wph vy wal vx vy sb1 wph vx vy equs5a syl $.
    $( [4-Feb-2007] $) $( [2-Feb-2007] $)

  ${
    equs45f.1 $e |- ( ph -> A. y ph ) $.
    $( Two ways of expressing substitution when ` y ` is not free in
        ` ph ` . $)
    equs45f $p |- ( E. x ( x = y /\ ph ) <-> A. x ( x = y -> ph ) ) $=
      vx vy weq wph wa vx wex vx vy weq wph wi vx wal vx vy weq wph wa vx wex
      vx vy weq wph vy wal wa vx wex vx vy weq wph wi vx wal vx vy weq wph wa
      vx vy weq wph vy wal wa vx wph wph vy wal vx vy weq equs45f.1 anim2i
      19.22i wph vx vy equs5a syl wph vx vy equs4 impbii $.
      $( [25-Apr-2008] $) $( [25-Apr-2008] $)

    $( Equivalence for substitution when ` y ` is not free in ` ph ` . $)
    sb6f $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      wph vx vy wsb vx vy weq wph wi vx wal wph vx vy wsb wph vy wal vx vy wsb
      vx vy weq wph wi vx wal wph wph vy wal vx vy equs45f.1 sbimi wph vx vy
      sb4a syl wph vx vy sb2 impbii $.
      $( [30-Apr-2008] $)  $( [5-Aug-1993] $)

    $( Equivalence for substitution when ` y ` is not free in ` ph ` . $)
    sb5f $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      wph vx vy wsb vx vy weq wph wi vx wal vx vy weq wph wa vx wex wph vx vy
      equs45f.1 sb6f wph vx vy equs45f.1 equs45f bitr4i $.
      $( [18-May-2008] $)  $( [5-Aug-1993] $)
  $}

  $( One direction of a simplified definition of substitution that unlike ~ sb4
     doesn't require a distinctor antecedent. $)
  sb4e $p |- ( [ y / x ] ph -> A. x ( x = y -> E. y ph ) ) $=
    wph vx vy wsb vx vy weq wph wa vx wex vx vy weq wph vy wex wi vx wal wph vx
    vy sb1 wph vx vy equs5e syl $.
    $( [23-Feb-2007] $) $( [2-Feb-2007] $)

  $( Special case of a bound-variable hypothesis builder for substitution. $)
  hbsb2a $p |- ( [ y / x ] A. y ph -> A. x [ y / x ] ph ) $=
    wph vy wal vx vy wsb vx vy weq wph wi vx wal wph vx vy wsb vx wal wph vx vy
    sb4a vx vy weq wph wi wph vx vy wsb vx wph vx vy sb2 a5i syl $.
    $( [5-Feb-2007] $) $( [2-Feb-2007] $)

  $( Special case of a bound-variable hypothesis builder for substitution. $)
  hbsb2e $p |- ( [ y / x ] ph -> A. x [ y / x ] E. y ph ) $=
    wph vx vy wsb vx vy weq wph vy wex wi vx wal wph vy wex vx vy wsb vx wal
    wph vx vy sb4e vx vy weq wph vy wex wi wph vy wex vx vy wsb vx wph vy wex
    vx vy sb2 a5i syl $.
    $( [17-Mar-2007] $) $( [2-Feb-2007] $)

  ${
    hbsb3.1 $e |- ( ph -> A. y ph ) $.
    $( If ` y ` is not free in ` ph ` , ` x ` is not free in
       ` [ y / x ] ph ` . $)
    hbsb3 $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      wph vx vy wsb wph vy wal vx vy wsb wph vx vy wsb vx wal wph wph vy wal vx
      vy hbsb3.1 sbimi wph vx vy hbsb2a syl $.
      $( [5-Aug-1993] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                  Predicate calculus with distinct variables
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            The axiom of quantifier introduction ax-17
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x ps $.
    a4imv.1 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( A version of ~ a4im with a distinct variable requirement instead of a
       bound variable hypothesis. $)
    a4imv $p |- ( A. x ph -> ps ) $=
      wph wps vx vy wps vx ax-17 a4imv.1 a4im $.
      $( [5-Aug-1993] $)
  $}

  ${
    $v f $.
    $( Define a temporary individual variable. $)
    aev.vf $f set f $.
    $d f u v $.  $d f u x y $.  $d u w $.
    $( A "distinctor elimination" lemma with no restrictions on variables in
       the consequent, proved without using ~ ax-16 .  The proof is unusual in
       that it involves linking 17 implications, which might provide an
       interesting challenge for an automated theorem prover. $)
    aev $p |- ( A. x x = y -> A. z w = v ) $=
      vx vy weq vx wal vw vv weq vz vx vy vz hbae vx vy weq vx wal vw vv weq vw
      vx vy weq vx wal vx vy weq vx wal vx wal vx vu weq vx wal vw vv weq vw
      wal vx vy vx hbae vx vy weq vx wal vx vu weq vx vx vy weq vx wal vy vx
      weq vy wal vu vx weq vx vu weq vx vy alequcom vy vx weq vu vx weq vy vu
      vy vu vx ax-8 a4imv vu vx equcomi 3syl 19.20i vx vu weq vx wal vu vx weq
      vu wal vu aev.vf weq vu wal vw vv weq vw wal vx vu alequcom vu vx weq vu
      aev.vf weq vu vu vx weq vu wal vx vu weq vx wal aev.vf vu weq vu aev.vf
      weq vu vx alequcom vx vu weq aev.vf vu weq vx aev.vf vx aev.vf vu ax-8
      a4imv aev.vf vu equcomi 3syl a5i vu aev.vf weq vu wal vu aev.vf weq vu
      wal vu wal vu vv weq vu wal vw vv weq vw wal vu aev.vf vu hbae vu aev.vf
      weq vu wal vu vv weq vu vu aev.vf weq vu wal aev.vf vu weq aev.vf wal vv
      vu weq vu vv weq vu aev.vf alequcom aev.vf vu weq vv vu weq aev.vf vv
      aev.vf vv vu ax-8 a4imv vv vu equcomi 3syl 19.20i vu vv weq vu wal vv vu
      weq vv wal vv vw weq vv wal vw vv weq vw wal vu vv alequcom vv vu weq vv
      vw weq vv vv vu weq vv wal vu vv weq vu wal vw vv weq vv vw weq vv vu
      alequcom vu vv weq vw vv weq vu vw vu vw vv ax-8 a4imv vw vv equcomi 3syl
      a5i vv vw alequcom 3syl 3syl 3syl 3syl 19.21bi 19.21ai $.
      $( [8-Nov-2006] $) $( [8-Nov-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Derive the axiom of distinct variables ax-16
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.  $d z ph $.
    $( Theorem showing that ~ ax-16 is redundant if ~ ax-17 is included in the
       axiom system.  The important part of the proof is provided by ~ aev .

       See ~ ax16ALT for an alternate proof that does not require ~ ax-10 or
       ~ ax-12 .

       This theorem should not be referenced in any proof.  Instead, use
       ~ ax-16 below so that theorems needing ~ ax-16 can be more easily
       identified. $)
    ax16 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      vx vy weq vx wal vx vz weq vz wal wph wph vx wal wi vx vy vz vx vz aev
      wph vx vz weq vz wal wph vx vz wsb vz wal wph vx wal wph vx vz weq wph vx
      vz wsb vz wph vz ax-17 vx vz weq wph wph vx vz wsb wph vx vz sbequ12
      biimpcd 19.20d wph vx vz wsb wph vz vx wph vx vz wph vz ax-17 hbsb3 wph
      vz ax-17 wph vz vx stdpc7 cbv3 syl6com syl $.
      $( [8-Nov-2006] $) $( [8-Nov-2006] $)
  $}

  ${
    $d x y $.
    $( Axiom of Distinct Variables.  The only axiom of predicate calculus
       requiring that variables be distinct (if we consider ~ ax-17 to be a
       metatheorem and not an axiom).  Axiom scheme C16' in [Megill]
       p. 448 (p. 16 of the preprint).  It apparently does not otherwise
       appear in the literature but is easily proved from textbook predicate
       calculus by cases.  It is a somewhat bizarre axiom since the antecedent
       is always false in set theory (see ~ dtru ), but nonetheless it is
       technically necessary as you can see from its uses.

       This axiom is redundant if we include ~ ax-17 ; see theorem ~ ax16 .
       Alternately, ~ ax-17 becomes logically redundant in the presence of this
       axiom, but without ~ ax-17 we lose the more powerful metalogic that
       results from being able to express the concept of a set variable not
       occurring in a wff (as opposed to just two set variables being
       distinct).  We retain ~ ax-16 here to provide logical completeness for
       systems with the simpler metalogic that results from omitting ~ ax-17 ,
       which might be easier to study for some theoretical purposes. $)
    ax-16 $a |- ( A. x x = y -> ( ph -> A. x ph ) ) $.
  $}

  ${
    $d x z $.  $d y z $.
    $( Theorem to add distinct quantifier to atomic formula.  (This theorem
       demonstrates the induction basis for ~ ax-17 considered as a
       metatheorem.  Do not use it for later proofs - use ~ ax-17 instead, to
       avoid reference to the redundant axiom ~ ax-16 .) $)
    ax17eq $p |- ( x = y -> A. z x = y ) $=
      vz vx weq vz wal vz vy weq vz wal vx vy weq vx vy weq vz wal wi vx vy vz
      ax-12 vx vy weq vz vx ax-16 vx vy weq vz vy ax-16 pm2.61ii $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct. $)
    dveeq2 $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      vz vw weq vz vy weq vx vy vw vz vw weq vx ax-17 vz vy weq vw ax-17 vw vy
      vz equequ2 dvelimfALT $.
      $( [2-Jan-2002] $)

    $( Version of ~ dveeq2 using ~ ax-16 instead of ~ ax-17 . $)
    dveeq2ALT $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      vz vw weq vz vy weq vx vy vw vz vw vx ax17eq vz vy vw ax17eq vw vy vz
      equequ2 dvelimfALT $.
      $( [19-Jun-2008] $) $( [29-Apr-2008] $)
  $}

  ${
    $d x ch $.  $d x ph $.
    19.23adv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90. $)
    19.23adv $p |- ( ph -> ( E. x ps -> ch ) ) $=
      wph wps wch vx wph vx ax-17 wch vx ax-17 19.23adv.1 19.23ad $.
      $( [27-Apr-1994] $)
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11v2.1 $e |- ( x = z -> ( ph -> A. x ( x = z -> ph ) ) ) $.
    $( Recovery of ~ ax11o from ~ ax11v without using ~ ax-11 .  The
       hypothesis is even weaker than ~ ax11v , with ` z ` both distinct from
       ` x ` _and_ not occurring in ` ph ` .  Thus the hypothesis provides an
       alternate axiom that can be used in place of ~ ax11o . $)
    ax11v2 $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      vx vy weq vx wal wn vz vy weq vz wex vx vy weq wph vx vy weq wph wi vx
      wal wi wi vz vy a9e vx vy weq vx wal wn vz vy weq vx vy weq wph vx vy weq
      wph wi vx wal wi wi vz vx vy weq vx wal wn vz vy weq vx vy weq wph vx vy
      weq wph wi vx wal wi wi vx vy weq vx wal wn vz vy weq wa vx vz weq wph vx
      vz weq wph wi vx wal wi wi vx vy weq wph vx vy weq wph wi vx wal wi wi
      ax11v2.1 vx vy weq vx wal wn vz vy weq wa vx vz weq vx vy weq wph vx vz
      weq wph wi vx wal wi wph vx vy weq wph wi vx wal wi vz vy weq vx vz weq
      vx vy weq wb vx vy weq vx wal wn vz vy vx equequ2 adantl vx vy weq vx wal
      wn vz vy weq wa vx vz weq wph wi vx wal vx vy weq wph wi vx wal wph vx vy
      weq vx wal wn vz vy weq wa vz vy weq vx wal vx vz weq wph wi vx wal vx vy
      weq wph wi vx wal wb vx vy weq vx wal wn vz vy weq vz vy weq vx wal vx vy
      vz dveeq2 imp vz vy weq vx wal vx vz weq wph wi vx vy weq wph wi vx vz vy
      weq vx hba1 vz vy weq vx vz weq wph wi vx vy weq wph wi wb vx vz vy weq
      vx vz weq vx vy weq wph vz vy vx equequ2 imbi1d a4s albid syl imbi2d
      imbi12d mpbii ex 19.23adv mpi $.
      $( [2-Feb-2007] $) $( [2-Feb-2007] $)
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11a2.1 $e |- ( x = z -> ( A. z ph -> A. x ( x = z -> ph ) ) ) $.
    $( Derive ~ ax-11o from a hypothesis in the form of ~ ax-11 .  The
       hypothesis is even weaker than ~ ax-11 , with ` z ` both distinct from
       ` x ` and not occurring in ` ph ` .  Thus the hypothesis provides an
       alternate axiom that can be used in place of ~ ax11o .  As theorem
       ~ ax11 shows, the distinct variable conditions are optional.  An
       open problem is whether ~ ax11o can be derived from ~ ax-11 without
       relying on ~ ax-17 . $)
    ax11a2 $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      wph vx vy vz vx vz weq wph vz wal vx vz weq wph wi vx wal wph ax11a2.1
      wph vz ax-17 syl5 ax11v2 $.
      $( [2-Feb-2007] $) $( [2-Feb-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Derive the original axiom of variable substitution ax-11o
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( Derivation of set.mm's original ~ ax-11o from the shorter ~ ax-11 that
       has replaced it.

       An open problem is whether this theorem can be proved without relying on
       ~ ax-16 or ~ ax-17 .

       Another open problem is whether this theorem can be proved without
       relying on ~ ax-12 (see note in ~ a12study ).

       Theorem ~ ax11 shows the reverse derivation of ~ ax-11 from
       ~ ax-11o .

       This theorem should not be referenced in any proof.  Instead, use
       ~ ax-11o below so that theorems needing ~ ax-11o can be more easily
       identified. $)
    ax11o $p |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      wph vx vy vz wph vx vz ax-11 ax11a2 $.
      $( [5-Feb-2007] $) $( [3-Feb-2007] $)
  $}

  $( Axiom ~ ax-11o ("o" for "old") was the original version of ~ ax-11 ,
     before it was discovered (in Jan. 2007) that the shorter ~ ax-11 could
     replace it.  It appears as Axiom scheme C15' in [Megill] p. 448 (p. 16
     of the preprint).  It is based on Lemma 16 of [Tarski] p. 70 and Axiom
     C8 of [Monk2] p. 105, from which it can be proved by cases.  To
     understand this theorem more easily, think of
     " ` -. A. x x = y -> ` ..." as informally meaning "if ` x ` and ` y `
     are distinct variables then..."  The antecedent becomes false if the
     same variable is substituted for ` x ` and ` y ` , ensuring the theorem
     is sound whenever this is the case.  In some later theorems, we call an
     antecedent of the form ` -. A. x x = y ` a "distinctor."

     This axiom is redundant, as shown by theorem ~ ax11o . $)
  ax-11o $a |- ( -. A. x x = y ->
             ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.

  $( Rederivation of axiom ~ ax-11 from the orginal version, ~ ax-11o .
     See theorem ~ ax11o for the derivation of ~ ax-11o from ~ ax-11 .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-11
     above so that uses of ~ ax-11 can be more easily identified. $)
  ax11 $p |- ( x = y -> ( A. y ph -> A. x ( x = y -> ph ) ) ) $=
    vx vy weq vx wal vx vy weq wph vy wal vx vy weq wph wi vx wal wi wi vx vy
    weq vx wal wph vy wal vx vy weq wph wi vx wal wi vx vy weq vx vy weq vx wal
    wph vy wal wph vx wal vx vy weq wph wi vx wal wph wph vx vy vx vy weq vx
    wal wph biidd dral1 wph vx vy weq wph wi vx wph vx vy weq ax-1 19.20i
    syl6bir a1d vx vy weq vx wal wn vx vy weq wph vx vy weq wph wi vx wal wph
    vy wal wph vx vy ax-11o wph vy ax-4 syl7 pm2.61i $.
    $( [22-Jan-2007] $) $( [22-Jan-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Theorems without distinct variables that use axiom ax-11o
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A bidirectional version of ~ ax-11o . $)
  ax11b $p |- ( ( -. A. x x = y /\ x = y ) ->
              ( ph <-> A. x ( x = y -> ph ) ) ) $=
    vx vy weq vx wal wn vx vy weq wa wph vx vy weq wph wi vx wal vx vy weq vx
    wal wn vx vy weq wph vx vy weq wph wi vx wal wi wph vx vy ax-11o imp vx vy
    weq vx vy weq wph wi vx wal wph wi vx vy weq vx wal wn vx vy weq wph wi vx
    wal vx vy weq wph vx vy weq wph wi vx ax-4 com12 adantl impbid $.
    $( [7-Jul-2006] $) $( [30-Jun-2006] $)

  $( Lemma used in proofs of substitution properties. $)
  equs5 $p |- ( -. A. x x = y ->
             ( E. x ( x = y /\ ph ) -> A. x ( x = y -> ph ) ) ) $=
    vx vy weq vx wal wn vx vy weq wph wa vx vy weq wph wi vx wal vx vx vy vx
    hbnae vx vy weq wph wi vx hba1 vx vy weq vx wal wn vx vy weq wph vx vy weq
    wph wi vx wal wph vx vy ax-11o imp3a 19.23ad $.
    $( [5-Aug-1993] $)

  $( One direction of a simplified definition of substitution when variables
     are distinct. $)
  sb3 $p |- ( -. A. x x = y -> ( E. x ( x = y /\ ph ) -> [ y / x ] ph ) ) $=
    vx vy weq vx wal wn vx vy weq wph wa vx wex vx vy weq wph wi vx wal wph vx
    vy wsb wph vx vy equs5 wph vx vy sb2 syl6 $.
    $( [5-Aug-1993] $)

  $( One direction of a simplified definition of substitution when variables
     are distinct. $)
  sb4 $p |- ( -. A. x x = y -> ( [ y / x ] ph -> A. x ( x = y -> ph ) ) ) $=
    vx vy weq vx wal wn vx vy weq wph wa vx wex vx vy weq wph wi vx wal wph vx
    vy wsb wph vx vy equs5 wph vx vy sb1 syl5 $.
    $( [5-Aug-1993] $)

  $( Simplified definition of substitution when variables are distinct. $)
  sb4b $p |- ( -. A. x x = y -> ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) ) $=
    vx vy weq vx wal wn wph vx vy wsb vx vy weq wph wi vx wal wph vx vy sb4 wph
    vx vy sb2 impbid1 $.
    $( [27-May-1997] $)

  $( An alternate definition of proper substitution that, like ~ df-sb , mixes
     free and bound variables to avoid distinct variable requirements. $)
  dfsb2 $p |- ( [ y / x ] ph <->
              ( ( x = y /\ ph ) \/ A. x ( x = y -> ph ) ) ) $=
    wph vx vy wsb vx vy weq wph wa vx vy weq wph wi vx wal wo vx vy weq vx wal
    wph vx vy wsb vx vy weq wph wa vx vy weq wph wi vx wal wo wi vx vy weq vx
    wal wph vx vy wsb vx vy weq wph wa vx vy weq wph wa vx vy weq wph wi vx wal
    wo vx vy weq vx wal wph vx vy wsb wph vx vy weq vx vy weq wph vx vy wsb wph
    wi vx wph vx vy sbequ2 a4s vx vy weq vx ax-4 jctild vx vy weq wph wa vx vy
    weq wph wi vx wal orc syl6 vx vy weq vx wal wn wph vx vy wsb vx vy weq wph
    wi vx wal vx vy weq wph wa vx vy weq wph wi vx wal wo wph vx vy sb4 vx vy
    weq wph wi vx wal vx vy weq wph wa olc syl6 pm2.61i vx vy weq wph wa wph vx
    vy wsb vx vy weq wph wi vx wal vx vy weq wph wph vx vy wsb wph vx vy sbequ1
    imp wph vx vy sb2 jaoi impbii $.
    $( [18-Feb-2005] $) $( [17-Feb-2005] $)

  $( An alternate definition of proper substitution ~ df-sb that uses only
     primitive connectives (no defined terms) on the right-hand side. $)
  dfsb3 $p |- ( [ y / x ] ph <->
              ( ( x = y -> -. ph ) -> A. x ( x = y -> ph ) ) ) $=
    vx vy weq wph wa vx vy weq wph wi vx wal wo vx vy weq wph wa wn vx vy weq
    wph wi vx wal wi wph vx vy wsb vx vy weq wph wn wi vx vy weq wph wi vx wal
    wi vx vy weq wph wa vx vy weq wph wi vx wal df-or wph vx vy dfsb2 vx vy weq
    wph wn wi vx vy weq wph wa wn vx vy weq wph wi vx wal vx vy weq wph imnan
    imbi1i 3bitr4i $.
    $( [18-Mar-2007] $) $( [6-Mar-2007] $)

  $( Bound-variable hypothesis builder for substitution. $)
  hbsb2 $p |- ( -. A. x x = y -> ( [ y / x ] ph -> A. x [ y / x ] ph ) ) $=
    vx vy weq vx wal wn wph vx vy wsb vx vy weq wph wi vx wal wph vx vy wsb vx
    wal wph vx vy sb4 vx vy weq wph wi wph vx vy wsb vx wph vx vy sb2 a5i syl6
    $.
    $( [5-Aug-1993] $)

  $( An equality theorem for substitution. $)
  sbequi $p |- ( x = y -> ( [ x / z ] ph -> [ y / z ] ph ) ) $=
    vz vx weq vz wal vz vy weq vz wal vx vy weq wph vz vx wsb wph vz vy wsb wi
    wi vz vx weq vz wal wn vx vy weq vz vy weq vz wal wn wph vz vx wsb wph vz
    vy wsb wi vz vx weq vz wal wn vx vy weq vz vy weq vz wal wn wph vz vx wsb
    wph vz vy wsb wi wi vz vx weq vz wal wn vx vy weq wa wph vz vx wsb wph vz
    vy wsb vz wex vz vy weq vz wal wn wph vz vy wsb vz vx weq vz wal wn wph vz
    vx wsb wph vz vx wsb vz wal vx vy weq wph vz vy wsb vz wex wph vz vx hbsb2
    vx vy weq wph vz vx wsb wph vz vy wsb wi vz wex wph vz vx wsb vz wal wph vz
    vy wsb vz wex wi vx vy weq vx vz weq vz vy weq wa vz wex wph vz vx wsb wph
    vz vy wsb wi vz wex vx vy vz equvini vx vz weq vz vy weq wa wph vz vx wsb
    wph vz vy wsb wi vz vx vz weq wph vz vx wsb wph vz vy weq wph vz vy wsb wph
    vx vz stdpc7 wph vz vy sbequ1 sylan9 19.22i syl wph vz vx wsb wph vz vy wsb
    vz 19.35 sylib sylan9 wph vz vy wsb vz vy weq vz wal wn vz vz vy vz hbnae
    wph vz vy hbsb2 19.9d syl9 ex com23 vz vx weq vz wal vx vy weq wph vz vx
    wsb wph vz vy wsb wi vz vx weq vz wal vx vy weq wa wph vz vx wsb wph wph vz
    vy wsb vz vx weq vz wal wph vz vx wsb wph wi vx vy weq vz vx weq wph vz vx
    wsb wph wi vz wph vz vx sbequ2 a4s adantr vx vy weq wph wph vx vy wsb vz vx
    weq vz wal wph vz vy wsb wph vx vy sbequ1 wph vx vy wsb wph vz vy wsb wi vx
    vz vx vz weq vx wal wph vx vy wsb wph vz vy wsb wph vx vz vy drsb1 biimpd
    alequcoms sylan9r syld ex vz vy weq vz wal vx vy weq wph vz vx wsb wph vz
    vy wsb wi vz vy weq vz wal vx vy weq wa wph vz vx wsb wph wph vz vy wsb vz
    vy weq vz wal wph vz vx wsb wph vy vx wsb vx vy weq wph vz vy weq vz wal
    wph vz vx wsb wph vy vx wsb wph vz vy vx drsb1 biimpd wph vx vy stdpc7
    sylan9 vz vy weq vz wal wph wph vz vy wsb wi vx vy weq vz vy weq wph wph vz
    vy wsb wi vz wph vz vy sbequ1 a4s adantr syld ex pm2.61ii $.
    $( [5-Aug-1993] $)

  $( An equality theorem for substitution.  Used in proof of Theorem 9.7
     in [Megill] p. 449 (p. 16 of the preprint). $)
  sbequ $p |- ( x = y -> ( [ x / z ] ph <-> [ y / z ] ph ) ) $=
    vx vy weq wph vz vx wsb wph vz vy wsb wph vx vy vz sbequi wph vz vy wsb wph
    vz vx wsb wi vy vx wph vy vx vz sbequi equcoms impbid $.
    $( [5-Aug-1993] $)

  $( Formula-building lemma for use with the Distinctor Reduction Theorem.
     Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint). $)
  drsb2 $p |- ( A. x x = y -> ( [ x / z ] ph <-> [ y / z ] ph ) ) $=
    vx cv vy cv wceq wph vz vx cv wsbc wph vz vy cv wsbc wb vx wph vx vy vz
    sbequ a4s $.
    $( [5-Apr-2005] $) $( [27-Feb-2005] $)

  $( Negation inside and outside of substitution are equivalent. $)
  sbn $p |- ( [ y / x ] -. ph <-> -. [ y / x ] ph ) $=
    wph wn vx vy wsb wph vx vy wsb wn vx vy weq vx wal wph wn vx vy wsb wph vx
    vy wsb wn wi vx vy weq wph wn vx vy wsb wph vx vy wsb wn wi vx vx vy weq
    wph wn vx vy wsb wph wph vx vy wsb wph wn vx vy sbequ2 wph vx vy sbequ2
    nsyld a4s vx vy weq vx wal wn wph wn vx vy wsb vx vy weq wph wn wi vx wal
    wph vx vy wsb wn wph wn vx vy sb4 wph vx vy wsb vx vy weq wph wn wi vx wal
    wph vx vy wsb vx vy weq wph wa vx wex vx vy weq wph wn wi vx wal wn wph vx
    vy sb1 wph vx vy equs3 sylib con2i syl6 pm2.61i wph wn vx vy wsb vx vy weq
    wph wn wi vx vy weq wph wn wa vx wex wph vx vy wsb wn wph wn vx vy df-sb vx
    vy weq wph vx vy wsb wn wph wn vx vy weq wph wph vx vy wsb wph vx vy sbequ1
    con3d com12 wph vx vy wsb wn vx vy weq wph wn wn wi vx wal wn vx vy weq wph
    wn wa vx wex vx vy weq wph wn wn wi vx wal wph vx vy wsb vx vy weq wph wn
    wn wi vx wal wph wn wn vx vy wsb wph vx vy wsb wph wn wn vx vy sb2 wph wph
    wn wn vx vy wph notnot sbbii sylibr con3i wph wn vx vy equs3 sylibr
    sylanbrc impbii $.
    $( [5-Aug-1993] $)

  $( Removal of implication from substitution. $)
  sbi1 $p |- ( [ y / x ] ( ph -> ps ) -> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    vx vy weq vx wal wph wps wi vx vy wsb wph vx vy wsb wps vx vy wsb wi wi vx
    vy weq wph wps wi vx vy wsb wph vx vy wsb wps vx vy wsb wi wi vx vx vy weq
    wph wps wi vx vy wsb wph vx vy wsb wps wps vx vy wsb vx vy weq wph wps wi
    vx vy wsb wph wps wph vx vy wsb wph wps wi vx vy sbequ2 wph vx vy sbequ2
    syl5d wps vx vy sbequ1 syl6d a4s vx vy weq vx wal wn wph wps wi vx vy wsb
    vx vy weq wph wi vx wal wps vx vy wsb wph vx vy wsb vx vy weq vx wal wn wph
    wps wi vx vy wsb vx vy weq wph wps wi wi vx wal vx vy weq wph wi vx wal wps
    vx vy wsb wi wph wps wi vx vy sb4 vx vy weq wph wps wi wi vx wal vx vy weq
    wph wi vx wal vx vy weq wps wi vx wal wps vx vy wsb vx vy weq wph wps wi wi
    vx vy weq wph wi vx vy weq wps wi vx vx vy weq wph wps ax-2 19.20ii wps vx
    vy sb2 syl6 syl6 wph vx vy sb4 syl5d pm2.61i $.
    $( [5-Aug-1993] $)

  $( Introduction of implication into substitution. $)
  sbi2 $p |- ( ( [ y / x ] ph -> [ y / x ] ps ) -> [ y / x ] ( ph -> ps ) ) $=
    wph vx vy wsb wps vx vy wsb wph wps wi vx vy wsb wph vx vy wsb wn wph wn vx
    vy wsb wph wps wi vx vy wsb wph vx vy sbn wph wn wph wps wi vx vy wph wps
    pm2.21 sbimi sylbir wps wph wps wi vx vy wps wph ax-1 sbimi ja $.
    $( [5-Aug-1993] $)

  $( Implication inside and outside of substitution are equivalent. $)
  sbim $p |- ( [ y / x ] ( ph -> ps ) <-> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    wph wps wi vx vy wsb wph vx vy wsb wps vx vy wsb wi wph wps vx vy sbi1 wph
    wps vx vy sbi2 impbii $.
    $( [5-Aug-1993] $)

  $( Logical OR inside and outside of substitution are equivalent. $)
  sbor $p |- ( [ y / x ] ( ph \/ ps ) <-> ( [ y / x ] ph \/ [ y / x ] ps ) ) $=
    wph wn wps wi vx vy wsb wph vx vy wsb wn wps vx vy wsb wi wph wps wo vx vy
    wsb wph vx vy wsb wps vx vy wsb wo wph wn wps wi vx vy wsb wph wn vx vy wsb
    wps vx vy wsb wi wph vx vy wsb wn wps vx vy wsb wi wph wn wps vx vy sbim
    wph wn vx vy wsb wph vx vy wsb wn wps vx vy wsb wph vx vy sbn imbi1i bitri
    wph wps wo wph wn wps wi vx vy wph wps df-or sbbii wph vx vy wsb wps vx vy
    wsb df-or 3bitr4i $.
    $( [29-Sep-2002] $)

  ${
    sb19.21.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution with a variable not free in antecedent affects only the
       consequent. $)
    sb19.21 $p |- ( [ y / x ] ( ph -> ps ) <-> ( ph -> [ y / x ] ps ) ) $=
      wph wps wi vx vy wsb wph vx vy wsb wps vx vy wsb wi wph wps vx vy wsb wi
      wph wps vx vy sbim wph vx vy wsb wph wps vx vy wsb wph vx vy sb19.21.1
      sbf imbi1i bitri $.
      $( [5-Aug-1993] $)
  $}

  $( Conjunction inside and outside of a substitution are equivalent. $)
  sban $p |- ( [ y / x ] ( ph /\ ps ) <-> ( [ y / x ] ph /\ [ y / x ] ps ) ) $=
    wph wps wn wi wn vx vy wsb wph vx vy wsb wps vx vy wsb wn wi wn wph wps wa
    vx vy wsb wph vx vy wsb wps vx vy wsb wa wph wps wn wi wn vx vy wsb wph wps
    wn wi vx vy wsb wn wph vx vy wsb wps vx vy wsb wn wi wn wph wps wn wi vx vy
    sbn wph wps wn wi vx vy wsb wph vx vy wsb wps vx vy wsb wn wi wph wps wn wi
    vx vy wsb wph vx vy wsb wps wn vx vy wsb wi wph vx vy wsb wps vx vy wsb wn
    wi wph wps wn vx vy sbim wps wn vx vy wsb wps vx vy wsb wn wph vx vy wsb
    wps vx vy sbn imbi2i bitri notbii bitri wph wps wa wph wps wn wi wn vx vy
    wph wps df-an sbbii wph vx vy wsb wps vx vy wsb df-an 3bitr4i $.
    $( [5-Aug-1993] $)

  $( Conjunction inside and outside of a substitution are equivalent. $)
  sb3an $p |- ( [ y / x ] ( ph /\ ps /\ ch ) <->
              ( [ y / x ] ph /\ [ y / x ] ps /\ [ y / x ] ch ) ) $=
    wph wps wch w3a vx vy wsb wph wps wa wch wa vx vy wsb wph wps wa vx vy wsb
    wch vx vy wsb wa wph vx vy wsb wps vx vy wsb wch vx vy wsb w3a wph wps wch
    w3a wph wps wa wch wa vx vy wph wps wch df-3an sbbii wph wps wa wch vx vy
    sban wph wps wa vx vy wsb wch vx vy wsb wa wph vx vy wsb wps vx vy wsb wa
    wch vx vy wsb wa wph vx vy wsb wps vx vy wsb wch vx vy wsb w3a wph wps wa
    vx vy wsb wph vx vy wsb wps vx vy wsb wa wch vx vy wsb wph wps vx vy sban
    anbi1i wph vx vy wsb wps vx vy wsb wch vx vy wsb df-3an bitr4i 3bitri $.
    $( [16-Dec-2006] $) $( [14-Dec-2006] $)

  $( Equivalence inside and outside of a substitution are equivalent. $)
  sbbi $p |- ( [ y / x ] ( ph <-> ps )
     <-> ( [ y / x ] ph <-> [ y / x ] ps ) ) $=
    wph wps wb vx vy wsb wph wps wi wps wph wi wa vx vy wsb wph vx vy wsb wps
    vx vy wsb wb wph wps wb wph wps wi wps wph wi wa vx vy wph wps dfbi2 sbbii
    wph wps wi vx vy wsb wps wph wi vx vy wsb wa wph vx vy wsb wps vx vy wsb wi
    wps vx vy wsb wph vx vy wsb wi wa wph wps wi wps wph wi wa vx vy wsb wph vx
    vy wsb wps vx vy wsb wb wph wps wi vx vy wsb wph vx vy wsb wps vx vy wsb wi
    wps wph wi vx vy wsb wps vx vy wsb wph vx vy wsb wi wph wps vx vy sbim wps
    wph vx vy sbim anbi12i wph wps wi wps wph wi vx vy sban wph vx vy wsb wps
    vx vy wsb dfbi2 3bitr4i bitri $.
    $( [5-Aug-1993] $)

  ${
    sblbis.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce left biconditional inside of a substitution. $)
    sblbis $p |- ( [ y / x ] ( ch <-> ph ) <-> ( [ y / x ] ch <-> ps ) ) $=
      wch wph wb vx vy wsb wch vx vy wsb wph vx vy wsb wb wch vx vy wsb wps wb
      wch wph vx vy sbbi wph vx vy wsb wps wch vx vy wsb sblbis.1 bibi2i bitri
      $.
      $( [19-Aug-1993] $)
  $}

  ${
    sbrbis.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce right biconditional inside of a substitution. $)
    sbrbis $p |- ( [ y / x ] ( ph <-> ch ) <-> ( ps <-> [ y / x ] ch ) ) $=
      wph wch wb vx vy wsb wph vx vy wsb wch vx vy wsb wb wps wch vx vy wsb wb
      wph wch vx vy sbbi wph vx vy wsb wps wch vx vy wsb sbrbis.1 bibi1i bitri
      $.
      $( [18-Aug-1993] $)
  $}

  ${
    sbrbif.1 $e |- ( ch -> A. x ch ) $.
    sbrbif.2 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce right biconditional inside of a substitution. $)
    sbrbif $p |- ( [ y / x ] ( ph <-> ch ) <-> ( ps <-> ch ) ) $=
      wph wch wb vx vy wsb wps wch vx vy wsb wb wps wch wb wph wps wch vx vy
      sbrbif.2 sbrbis wch vx vy wsb wch wps wch vx vy sbrbif.1 sbf bibi2i bitri
      $.
      $( [18-Aug-1993] $)
  $}

  $( A specialization theorem. $)
  a4sbe $p |- ( [ y / x ] ph -> E. x ph ) $=
    wph vx vy wsb wph wn vx wal wn wph vx wex wph wn vx wal wph vx vy wsb wph
    wn vx wal wph wn vx vy wsb wph vx vy wsb wn wph wn vx vy stdpc4 wph vx vy
    sbn sylib con2i wph vx df-ex sylibr $.
    $( [5-Aug-1993] $)

  $( Specialization of implication. $)
  a4sbim $p |- ( A. x ( ph -> ps ) -> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    wph wps wi vx wal wph wps wi vx vy wsb wph vx vy wsb wps vx vy wsb wi wph
    wps wi vx vy stdpc4 wph wps vx vy sbim sylib $.
    $( [5-Aug-1993] $)

  $( Specialization of biconditional. $)
  a4sbbi $p |- ( A. x ( ph <-> ps ) -> ( [ y / x ] ph <-> [ y / x ] ps ) ) $=
    wph wps wb vx wal wph wps wb vx vy wsb wph vx vy wsb wps vx vy wsb wb wph
    wps wb vx vy stdpc4 wph wps vx vy sbbi sylib $.
    $( [5-Aug-1993] $)

  ${
    sbbid.1 $e |- ( ph -> A. x ph ) $.
    sbbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction substituting both sides of a biconditional. $)
    sbbid $p |- ( ph -> ( [ y / x ] ps <-> [ y / x ] ch ) ) $=
      wph wps wch wb vx wal wps vx vy wsb wch vx vy wsb wb wph wps wch wb vx
      sbbid.1 sbbid.2 19.21ai wps wch vx vy a4sbbi syl $.
      $( [5-Aug-1993] $)
  $}

  $( Elimination of equality from antecedent after substitution. $)
  sbequ8 $p |- ( [ y / x ] ph <-> [ y / x ] ( x = y -> ph ) ) $=
    wph vx vy wsb vx vy weq vx vy wsb wph vx vy wsb wi vx vy weq wph wi vx vy
    wsb vx vy weq vx vy wsb wph vx vy wsb vx vy equsb1 a1bi vx vy weq wph vx vy
    sbim bitr4i $.
    $( [5-Aug-1993] $)

  $( Substitution has no effect on a non-free variable. $)
  sbf3t $p |- ( A. x ( ph -> A. x ph ) -> ( [ y / x ] ph <-> ph ) ) $=
    wph wph vx wal wi vx wal wph vx vy wsb wph wph wph vx wal wi vx wal wph vx
    vy wsb wph vx wal vx vy wsb wph wph wph vx wal vx vy a4sbim wph vx wal vx
    vy wsb wph vx wal wph wph vx vy sbf2 wph vx ax-4 sylbi syl6 wph wph vx wal
    wi wph wph vx vy wsb wi vx wph vx wal wph vx vy wsb wph wph vx vy stdpc4
    imim2i a4s impbid $.
    $( [4-Jun-2009] $) $( [30-May-2009] $)

  ${
    hbsb4.1 $e |- ( ph -> A. z ph ) $.
    $( A variable not free remains so after substitution with a distinct
       variable. $)
    hbsb4 $p |- ( -. A. z z = y -> ( [ y / x ] ph -> A. z [ y / x ] ph ) ) $=
      vz vx weq vz wal vz vy weq vz wal wn wph vx vy wsb wph vx vy wsb vz wal
      wi wi vz vx weq vz wal vz vy weq vz wal wn vx vy weq vx wal wn wph vx vy
      wsb wph vx vy wsb vz wal wi vz vx weq vz wal vz vy weq vz wal vx vy weq
      vx wal vz vy weq vx vy weq vz vx vz vx weq vz vy weq vx vy weq wb vz vz
      vx vy equequ1 a4s dral1 notbid vx vy weq vx wal wn wph vx vy wsb wph vx
      vy wsb vx wal vz vx weq vz wal wph vx vy wsb vz wal wph vx vy hbsb2 wph
      vx vy wsb vx wal wph vx vy wsb vz wal wi vx vz wph vx vy wsb vx vz ax-10o
      alequcoms syl9r sylbid vz vx weq vz wal wn vz vy weq vz wal wn wph vx vy
      wsb wph vx vy wsb vz wal wi vx vy weq vx wal vz vx weq vz wal wn vz vy
      weq vz wal wn wa wph vx vy wsb wph vx vy wsb vz wal wi wi vx vy weq vx
      wal wph vx vy wsb wph vx vy wsb vz wal wi vz vx weq vz wal wn vz vy weq
      vz wal wn wa vx vy weq vx wal vx vy weq vx wal vz wal vx vy weq vz wal
      wph vx vy wsb wph vx vy wsb vz wal wi vx vy vz hbae vx vy weq vx wal vx
      vy weq vz vx vy weq vx ax-4 19.20i vx vy weq vz wal wph vx vy wsb wph wph
      vx vy wsb vz wal vx vy weq wph vx vy wsb wph wi vz wph vx vy sbequ2 a4s
      vx vy weq vz wal wph vz wal wph vx vy wsb vz wal wph vx vy weq wph wph vx
      vy wsb vz wph vx vy sbequ1 19.20ii hbsb4.1 syl5 syld 3syl a1d vx vy weq
      vx wal wn wph vx vy wsb vx vy weq wph wi vx wal vz vx weq vz wal wn vz vy
      weq vz wal wn wa wph vx vy wsb vz wal wph vx vy sb4 vz vx weq vz wal wn
      vz vy weq vz wal wn wa vx vy weq wph wi vx wal vx vy weq wph wi vz wal vx
      wal wph vx vy wsb vz wal vz vx weq vz wal wn vz vy weq vz wal wn wa vx vy
      weq wph wi vx vy weq wph wi vz wal vx vz vx weq vz wal wn vz vy weq vz
      wal wn vx vz vx vx hbnae vz vy vx hbnae hban vz vx weq vz wal wn vz vy
      weq vz wal wn wa vx vy weq wph vz vz vx weq vz wal wn vz vy weq vz wal wn
      vz vz vx vz hbnae vz vy vz hbnae hban vz vx weq vz wal wn vz vy weq vz
      wal wn vx vy weq vx vy weq vz wal wi vx vy vz ax-12 imp wph wph vz wal wi
      vz vx weq vz wal wn vz vy weq vz wal wn wa hbsb4.1 a1i hbimd 19.20d vx vy
      weq wph wi wph vx vy wsb vz wal vz vx vx vy weq wph wi vx wal wph vx vy
      wsb vz wph vx vy sb2 19.20i a7s syl6 syl9 pm2.61i ex pm2.61i $.
      $( [5-Aug-1993] $)
  $}

  $( A variable not free remains so after substitution with a distinct
     variable (closed form of ~ hbsb4 ). $)
  hbsb4t $p |- ( A. x A. z ( ph -> A. z ph ) ->
               ( -. A. z z = y -> ( [ y / x ] ph -> A. z [ y / x ] ph ) ) ) $=
    wph wph vz wal wi vz wal vx wal wph vx vy wsb wph vx vy wsb vz wal wi wph
    vz wal vx vy wsb wph vz wal vx vy wsb vz wal wi vz vy weq vz wal wn wph wph
    vz wal wi vz wal vx wal wph wph vz wal wb vz wal vx wal wph vx vy wsb wph
    vx vy wsb vz wal wi wph vz wal vx vy wsb wph vz wal vx vy wsb vz wal wi wb
    wph wph vz wal wi wph wph vz wal wb vx vz wph wph vz wal wi wph wph vz wal
    wi wph vz wal wph wi wa wph wph vz wal wb wph vz wal wph wi wph wph vz wal
    wi wph vz ax-4 biantru wph wph vz wal dfbi2 bitr4i 2albii wph wph vz wal wb
    wph vx vy wsb wph vx vy wsb vz wal wi wph vz wal vx vy wsb wph vz wal vx vy
    wsb vz wal wi wb vz vx wph wph vz wal wb vx wal vz wal wph vx vy wsb wph vz
    wal vx vy wsb wph vx vy wsb vz wal wph vz wal vx vy wsb vz wal wph wph vz
    wal wb vx wal wph vx vy wsb wph vz wal vx vy wsb wb vz wph wph vz wal vx vy
    a4sbbi a4s wph wph vz wal wb vx wal vz wal wph vx vy wsb wph vz wal vx vy
    wsb vz wph wph vz wal wb vx wal vz hba1 wph wph vz wal wb vx wal wph vx vy
    wsb wph vz wal vx vy wsb wb vz wph wph vz wal vx vy a4sbbi a4s albid
    imbi12d a7s sylbi wph vz wal vx vy vz wph vz hba1 hbsb4 syl5bir $.
    $( [14-Apr-2004] $) $( [7-Apr-2004] $)

  ${
    dvelimf.1 $e |- ( ph -> A. x ph ) $.
    dvelimf.2 $e |- ( ps -> A. z ps ) $.
    dvelimf.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelim without any variable restrictions. $)
    dvelimf $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      vx vy weq vx wal wn wph vz vy wsb wph vz vy wsb vx wal wps wps vx wal wph
      vz vy vx dvelimf.1 hbsb4 wph wps vz vy dvelimf.2 dvelimf.3 sbie wph vz vy
      wsb wps vx wph wps vz vy dvelimf.2 dvelimf.3 sbie albii 3imtr3g $.
      $( [1-Oct-2002] $)
  $}

  ${
    dvelimdf.1 $e |- ( ph -> A. x ph ) $.
    dvelimdf.2 $e |- ( ph -> A. z ph ) $.
    dvelimdf.3 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    dvelimdf.4 $e |- ( ph -> ( ch -> A. z ch ) ) $.
    dvelimdf.5 $e |- ( ph -> ( z = y -> ( ps <-> ch ) ) ) $.
    $( Deduction form of ~ dvelimf .  This version may be useful if we want to
       avoid ~ ax-17 and use ~ ax-16 instead. $)
    dvelimdf $p |- ( ph -> ( -. A. x x = y -> ( ch -> A. x ch ) ) ) $=
      wph vx vy weq vx wal wn wch wch vx wal wi wph vx vy weq vx wal wn wa wps
      vz vy wsb wps vz vy wsb vx wal wch wch vx wal wph vx vy weq vx wal wn wps
      vz vy wsb wps vz vy wsb vx wal wi wph wph vx wal vz wal wps wps vx wal wi
      vx wal vz wal vx vy weq vx wal wn wps vz vy wsb wps vz vy wsb vx wal wi
      wi wph wph vx wal vz dvelimdf.2 dvelimdf.1 19.21ai wph wps wps vx wal wi
      vz vx dvelimdf.3 19.20i2 wps vz vy vx hbsb4t 3syl imp wph wps vz vy wsb
      wch wb vx vy weq vx wal wn wph wps wch vz vy dvelimdf.2 dvelimdf.4
      dvelimdf.5 sbied adantr wph wps vz vy wsb vx wal wch vx wal wb vx vy weq
      vx wal wn wph wps vz vy wsb wch vx dvelimdf.1 wph wps wch vz vy
      dvelimdf.2 dvelimdf.4 dvelimdf.5 sbied albid adantr 3imtr3d ex $.
      $( [15-Apr-2004] $) $( [7-Apr-2004] $)
  $}

  $( A composition law for substitution. $)
  sbco $p |- ( [ y / x ] [ x / y ] ph <-> [ y / x ] ph ) $=
    wph vy vx wsb wph wb vx vy wsb wph vy vx wsb vx vy wsb wph vx vy wsb wb vy
    vx weq vx vy wsb wph vy vx wsb wph wb vx vy wsb vx vy equsb2 vy vx weq wph
    vy vx wsb wph wb vx vy vy vx weq wph wph vy vx wsb wph vy vx sbequ12 bicomd
    sbimi ax-mp wph vy vx wsb wph vx vy sbbi mpbi $.
    $( [5-Aug-1993] $)

  ${
    sbid2.1 $e |- ( ph -> A. x ph ) $.
    $( An identity law for substitution. $)
    sbid2 $p |- ( [ y / x ] [ x / y ] ph <-> ph ) $=
      wph vy vx wsb vx vy wsb wph vx vy wsb wph wph vx vy sbco wph vx vy
      sbid2.1 sbf bitri $.
      $( [5-Aug-1993] $)
  $}

  $( An idempotent law for substitution. $)
  sbidm $p |- ( [ y / x ] [ y / x ] ph <-> [ y / x ] ph ) $=
    vx vy weq vx wal wph vx vy wsb vx vy wsb wph vx vy wsb wb vx vy weq wph vx
    vy wsb vx vy wsb wph vx vy wsb wb vx vx vy weq wph vx vy wsb wph vx vy wsb
    vx vy wsb wph vx vy wsb vx vy sbequ12 bicomd a4s vx vy weq vx wal wn wph vx
    vy wsb wph vx vy wsb vx vy vx vy vx hbnae wph vx vy hbsb2 vx vy weq wph vx
    vy wsb wph vx vy wsb wb wi vx vy weq vx wal wn vx vy weq wph vx vy wsb
    biidd a1i sbied pm2.61i $.
    $( [30-Jun-1994] $)

  ${
    sbco2.1 $e |- ( ph -> A. z ph ) $.
    $( A composition law for substitution. $)
    sbco2 $p |- ( [ y / z ] [ z / x ] ph <-> [ y / x ] ph ) $=
      vx vy weq vx wal wph vx vz wsb vz vy wsb wph vx vy wsb wb vx vy weq wph
      vx vz wsb vz vy wsb wph vx vy wsb wb vx vx vy weq wph wph vx vz wsb vz vy
      wsb wph vx vy wsb vx vy weq wph vx vz wsb vz vx wsb wph vx vz wsb vz vy
      wsb wph wph vx vz wsb vx vy vz sbequ wph vz vx sbco2.1 sbid2 syl5bbr wph
      vx vy sbequ12 bitr3d a4s vx vy weq vx wal wn wph vx vy wsb wph vx vz wsb
      vz vy wsb vx vy weq vx wal wn wph wph vx vz wsb vz vy wsb vx vy vx vy vx
      hbnae wph vx vz wsb vz vy vx wph vx vz sbco2.1 hbsb3 hbsb4 vx vy weq wph
      wph vx vz wsb vz vy wsb wb wi vx vy weq vx wal wn vx vy weq wph vx vz wsb
      vz vx wsb wph vx vz wsb vz vy wsb wph wph vx vz wsb vx vy vz sbequ wph vz
      vx sbco2.1 sbid2 syl5bbr a1i sbied bicomd pm2.61i $.
      $( [30-Jun-1994] $)
  $}

  ${
    sbco2d.1 $e |- ( ph -> A. x ph ) $.
    sbco2d.2 $e |- ( ph -> A. z ph ) $.
    sbco2d.3 $e |- ( ph -> ( ps -> A. z ps ) ) $.
    $( A composition law for substitution. $)
    sbco2d $p |- ( ph -> ( [ y / z ] [ z / x ] ps <-> [ y / x ] ps ) ) $=
      wph wps vx vz wsb vz vy wsb wps vx vy wsb wph wps wi vx vz wsb vz vy wsb
      wph wps wi vx vy wsb wph wps vx vz wsb vz vy wsb wi wph wps vx vy wsb wi
      wph wps wi vx vy vz wph wps vz sbco2d.2 sbco2d.3 hbim1 sbco2 wph wps wi
      vx vz wsb vz vy wsb wph wps vx vz wsb wi vz vy wsb wph wps vx vz wsb vz
      vy wsb wi wph wps wi vx vz wsb wph wps vx vz wsb wi vz vy wph wps vx vz
      sbco2d.1 sb19.21 sbbii wph wps vx vz wsb vz vy sbco2d.2 sb19.21 bitri wph
      wps vx vy sbco2d.1 sb19.21 3bitr3i pm5.74ri $.
      $( [5-Aug-1993] $)
  $}

  $( A composition law for substitution. $)
  sbco3 $p |- ( [ z / y ] [ y / x ] ph <-> [ z / x ] [ x / y ] ph ) $=
    vx vy weq vx wal wph vx vy wsb vy vz wsb wph vy vx wsb vx vz wsb wb vx vy
    weq vx wal wph vx vy wsb vx vz wsb wph vx vy wsb vy vz wsb wph vy vx wsb vx
    vz wsb wph vx vy wsb vx vy vz drsb1 vx vy weq vx wal wph vx vy wsb wph vy
    vx wsb wb vx wal wph vx vy wsb vx vz wsb wph vy vx wsb vx vz wsb wb vx vy
    weq wph vx vy wsb wph vy vx wsb wb vx wph vx vy sbequ12a 19.20i wph vx vy
    wsb wph vy vx wsb vx vz a4sbbi syl bitr3d vx vy weq vx wal wn wph vx vy wsb
    vy vx wsb vx vz wsb wph vx vy wsb vy vz wsb wph vy vx wsb vx vz wsb vx vy
    weq vx wal wn wph vx vy wsb vy vz vx vx vy vy hbnae vx vy vx hbnae wph vx
    vy hbsb2 sbco2d wph vx vy wsb vy vx wsb wph vy vx wsb vx vz wph vy vx sbco
    sbbii syl5rbbr pm2.61i $.
    $( [5-Aug-1993] $)

  $( A commutativity law for substitution. $)
  sbcom $p |- ( [ y / z ] [ y / x ] ph <-> [ y / x ] [ y / z ] ph ) $=
    vx vy weq vx wal vz vy weq vz wal wph vx vy wsb vz vy wsb wph vz vy wsb vx
    vy wsb wb vx vy weq vx wal wn vz vy weq vz wal wn wph vx vy wsb vz vy wsb
    wph vz vy wsb vx vy wsb wb vx vz weq vx wal vx vy weq vx wal wn vz vy weq
    vz wal wn wa wph vx vy wsb vz vy wsb wph vz vy wsb vx vy wsb wb vx vz weq
    vx wal wph vx vy wsb vz vy wsb wph vz vy wsb vx vy wsb wb vx vy weq vx wal
    wn vz vy weq vz wal wn wa vx vz weq vx wal wph vx vy wsb vx vy wsb wph vx
    vy wsb vz vy wsb wph vz vy wsb vx vy wsb wph vx vy wsb vx vz vy drsb1 vx vz
    weq vx wal wph vx vy wsb wph vz vy wsb vx vy vx vz vx hbae wph vx vz vy
    drsb1 sbbid bitr3d adantr vx vz weq vx wal wn vx vy weq vx wal wn vz vy weq
    vz wal wn wa wa vz vy weq vx vy weq wph wi vx wal wi vz wal vx vy weq vz vy
    weq wph wi vz wal wi vx wal wph vx vy wsb vz vy wsb wph vz vy wsb vx vy wsb
    vx vz weq vx wal wn vx vy weq vx wal wn vz vy weq vz wal wn wa wa vz vy weq
    vx vy weq wph wi wi vx wal vz wal vz vy weq vx vy weq wph wi vx wal wi vz
    wal vx vy weq vz vy weq wph wi vz wal wi vx wal vx vz weq vx wal wn vx vy
    weq vx wal wn vz vy weq vx vy weq wph wi wi vx wal vz wal vz vy weq vx vy
    weq wph wi vx wal wi vz wal wb vz vy weq vz wal wn vx vz weq vx wal wn vx
    vy weq vx wal wn wa vz vy weq vx vy weq wph wi wi vx wal vz vy weq vx vy
    weq wph wi vx wal wi vz vx vz weq vx wal wn vx vy weq vx wal wn vz vx vz vz
    hbnae vx vy vz hbnae hban vx vz weq vx wal wn vx vy weq vx wal wn wa vx vz
    weq vx wal wn vx vy weq vx wal wn wa vx wal vz vy weq vz vy weq vx wal wi
    vx wal vz vy weq vx vy weq wph wi wi vx wal vz vy weq vx vy weq wph wi vx
    wal wi wb vx vz weq vx wal wn vx vy weq vx wal wn vx vx vz vx hbnae vx vy
    vx hbnae hban vx vz weq vx wal wn vx vy weq vx wal wn wa vz vy weq vz vy
    weq vx wal wi vx vx vz weq vx wal wn vx vy weq vx wal wn vz vy weq vz vy
    weq vx wal wi vz vy vx ax-12 imp 19.20i vz vy weq vx vy weq wph wi vx
    19.21t 3syl albid adantrr vx vz weq vx wal wn vz vy weq vz wal wn vz vy weq
    vx vy weq wph wi wi vx wal vz wal vx vy weq vz vy weq wph wi vz wal wi vx
    wal wb vx vy weq vx wal wn vx vz weq vx wal wn vz vy weq vz wal wn wa vz vy
    weq vx vy weq wph wi wi vz wal vx wal vx vy weq vz vy weq wph wi vz wal wi
    vx wal vz vy weq vx vy weq wph wi wi vx wal vz wal vx vz weq vx wal wn vz
    vy weq vz wal wn wa vz vy weq vx vy weq wph wi wi vz wal vx vy weq vz vy
    weq wph wi vz wal wi vx vx vz weq vx wal wn vz vy weq vz wal wn vx vx vz vx
    hbnae vz vy vx hbnae hban vx vz weq vx wal wn vz vy weq vz wal wn wa vx vy
    weq vz vy weq wph wi wi vz wal vx vy weq vz vy weq wph wi vz wal wi vz vy
    weq vx vy weq wph wi wi vz wal vx vz weq vx wal wn vz vy weq vz wal wn wa
    vx vz weq vx wal wn vz vy weq vz wal wn wa vz wal vx vy weq vx vy weq vz
    wal wi vz wal vx vy weq vz vy weq wph wi wi vz wal vx vy weq vz vy weq wph
    wi vz wal wi wb vx vz weq vx wal wn vz vy weq vz wal wn vz vx vz vz hbnae
    vz vy vz hbnae hban vx vz weq vx wal wn vz vy weq vz wal wn wa vx vy weq vx
    vy weq vz wal wi vz vx vz weq vx wal wn vz vy weq vz wal wn vx vy weq vx vy
    weq vz wal wi vz vy weq vz wal wn vx vy weq vx vy weq vz wal wi wi vz vx vx
    vy vz ax-12 nalequcoms imp 19.20i vx vy weq vz vy weq wph wi vz 19.21t 3syl
    vz vy weq vx vy weq wph wi wi vx vy weq vz vy weq wph wi wi vz vz vy weq vx
    vy weq wph bi2.04 albii syl5bb albid vz vy weq vx vy weq wph wi wi vz vx
    alcom syl5bb adantrl bitr3d vx vy weq vx wal wn vz vy weq vz wal wn wa wph
    vx vy wsb vz vy wsb vz vy weq vx vy weq wph wi vx wal wi vz wal wb vx vz
    weq vx wal wn vz vy weq vz wal wn wph vx vy wsb vz vy wsb vz vy weq wph vx
    vy wsb wi vz wal vx vy weq vx wal wn vz vy weq vx vy weq wph wi vx wal wi
    vz wal wph vx vy wsb vz vy sb4b vx vy weq vx wal wn vz vy weq wph vx vy wsb
    wi vz vy weq vx vy weq wph wi vx wal wi vz vx vy vz hbnae vx vy weq vx wal
    wn wph vx vy wsb vx vy weq wph wi vx wal vz vy weq wph vx vy sb4b imbi2d
    albid sylan9bbr adantl vx vy weq vx wal wn vz vy weq vz wal wn wa wph vz vy
    wsb vx vy wsb vx vy weq vz vy weq wph wi vz wal wi vx wal wb vx vz weq vx
    wal wn vx vy weq vx wal wn wph vz vy wsb vx vy wsb vx vy weq wph vz vy wsb
    wi vx wal vz vy weq vz wal wn vx vy weq vz vy weq wph wi vz wal wi vx wal
    wph vz vy wsb vx vy sb4b vz vy weq vz wal wn vx vy weq wph vz vy wsb wi vx
    vy weq vz vy weq wph wi vz wal wi vx vz vy vx hbnae vz vy weq vz wal wn wph
    vz vy wsb vz vy weq wph wi vz wal vx vy weq wph vz vy sb4b imbi2d albid
    sylan9bb adantl 3bitr4d pm2.61ian ex vx vy weq vx wal wph vz vy wsb wph vx
    vy wsb vz vy wsb wph vz vy wsb vx vy wsb vx vy weq vx wal wph wph vx vy wsb
    vz vy vx vy vz hbae vx vy weq wph wph vx vy wsb wb vx wph vx vy sbequ12 a4s
    sbbid vx vy weq wph vz vy wsb wph vz vy wsb vx vy wsb wb vx wph vz vy wsb
    vx vy sbequ12 a4s bitr3d vz vy weq vz wal wph vx vy wsb wph vx vy wsb vz vy
    wsb wph vz vy wsb vx vy wsb vz vy weq wph vx vy wsb wph vx vy wsb vz vy wsb
    wb vz wph vx vy wsb vz vy sbequ12 a4s vz vy weq vz wal wph wph vz vy wsb vx
    vy vz vy vx hbae vz vy weq wph wph vz vy wsb wb vz wph vz vy sbequ12 a4s
    sbbid bitr3d pm2.61ii $.
    $( [27-May-1997] $)

  ${
    sb5rf.1 $e |- ( ph -> A. y ph ) $.
    $( Reversed substitution. $)
    sb5rf $p |- ( ph <-> E. y ( y = x /\ [ y / x ] ph ) ) $=
      wph vy vx weq wph vx vy wsb wa vy wex wph wph vx vy wsb vy vx wsb vy vx
      weq wph vx vy wsb wa vy wex wph vy vx sb5rf.1 sbid2 wph vx vy wsb vy vx
      sb1 sylbir vy vx weq wph vx vy wsb wa wph vy sb5rf.1 vy vx weq wph vx vy
      wsb wph wph vy vx sbequ12r biimpa 19.23ai impbii $.
      $( [22-Mar-2005] $) $( [3-Feb-2005] $)

    $( Reversed substitution. $)
    sb6rf $p |- ( ph <-> A. y ( y = x -> [ y / x ] ph ) ) $=
      wph vy vx weq wph vx vy wsb wi vy wal wph vy vx weq wph vx vy wsb wi vy
      sb5rf.1 vy vx weq wph wph vx vy wsb wph wph vx vy wsb wi vx vy wph vx vy
      sbequ1 equcoms com12 19.21ai vy vx weq wph vx vy wsb wi vy wal wph vy vx
      wsb wph vy vx weq wph vx vy wsb wi vy wal wph vx vy wsb vy vx wsb wph vy
      vx wsb wph vx vy wsb vy vx sb2 wph vy vx sbco sylib wph vy vx sb5rf.1 sbf
      sylib impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    sb8.1 $e |- ( ph -> A. y ph ) $.
    $( Substitution of variable in universal quantifier. $)
    sb8 $p |- ( A. x ph <-> A. y [ y / x ] ph ) $=
      wph vx wal wph vx vy wsb vy wal wph vx wal wph vx vy wsb vy wph vy vx
      sb8.1 hbal wph vx vy stdpc4 19.21ai wph vx vy wsb vy wal wph vx wph vx vy
      wsb vx vy wph vx vy sb8.1 hbsb3 hbal wph vx vy wsb vy wal wph vx vy wsb
      vy vx wsb wph wph vx vy wsb vy vx stdpc4 wph vy vx sb8.1 sbid2 sylib
      19.21ai impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    sb8e.1 $e |- ( ph -> A. y ph ) $.
    $( Substitution of variable in existential quantifier. $)
    sb8e $p |- ( E. x ph <-> E. y [ y / x ] ph ) $=
      wph wn vx wal wn wph vx vy wsb wn vy wal wn wph vx wex wph vx vy wsb vy
      wex wph wn vx wal wph vx vy wsb wn vy wal wph wn vx wal wph wn vx vy wsb
      vy wal wph vx vy wsb wn vy wal wph wn vx vy wph vy sb8e.1 hbn sb8 wph wn
      vx vy wsb wph vx vy wsb wn vy wph vx vy sbn albii bitri notbii wph vx
      df-ex wph vx vy wsb vy df-ex 3bitr4i $.
      $( [12-Aug-1993] $)
  $}

  $( Commutation of quantification and substitution variables. $)
  sb9i $p |- ( A. x [ x / y ] ph -> A. y [ y / x ] ph ) $=
    vy vx weq vy wal wph vy vx wsb vx wal wph vx vy wsb vy wal wi vy vx weq vy
    wal wph vx vy wsb vy wal wph vy vx wsb vx wal wph vx vy wsb wph vy vx wsb
    vy vx vy vx weq vy wal wph vy vy wsb wph vx vy wsb wph vy vx wsb wph vy vx
    vy drsb1 wph vy vx vy drsb2 bitr3d dral1 biimprd vy vx weq vy wal wn wph vy
    vx wsb vx wal wph vy vx wsb vy wal vx wal wph vx vy wsb vy wal wph vy vx
    wsb vx wal wph vy vx wsb vy wal vx wal wi vy vx vx vy vx weq vy wal wn wph
    vy vx wsb wph vy vx wsb vy wal vx wph vy vx hbsb2 19.20ii hbnaes wph vy vx
    wsb wph vx vy wsb vy wal vy vx wph vy vx wsb vx wal wph vx vy wsb vy wph vy
    vx wsb vx wal wph vy vx wsb vx vy wsb wph vx vy wsb wph vy vx wsb vx vy
    stdpc4 wph vx vy sbco sylib 19.20i a7s syl6 pm2.61i $.
    $( [5-Aug-1993] $)

  $( Commutation of quantification and substitution variables. $)
  sb9 $p |- ( A. x [ x / y ] ph <-> A. y [ y / x ] ph ) $=
    wph vy vx wsb vx wal wph vx vy wsb vy wal wph vx vy sb9i wph vy vx sb9i
    impbii $.
    $( [5-Aug-1993] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Predicate calculus with distinct variables (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( This is a version of ~ ax-11o when the variables are distinct.  Axiom
       (C8) of [Monk2] p. 105.  See theorem ~ ax11v2 for the rederivation of
       ~ ax-11o from this theorem. $)
    ax11v $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      vx vy weq vx wal vx vy weq wph vx vy weq wph wi vx wal wi wi vx vy weq vx
      wal wph vx vy weq wph wi vx wal wi vx vy weq vx vy weq vx wal vx vy weq
      wph wi vx vy weq wph wi vx wal wph vx vy weq wph wi vx vy ax-16 wph vx vy
      weq ax-1 syl5 a1d wph vx vy ax-11o pm2.61i $.
      $( [5-Aug-1993] $)

    $( Two equivalent ways of expressing the proper substitution of ` y ` for
       ` x ` in ` ph ` , when ` x ` and ` y ` are distinct.  Theorem 6.2 of
       [Quine] p. 40.  The proof does not involve ~ df-sb . $)
    sb56 $p |- ( E. x ( x = y /\ ph ) <->  A. x ( x = y -> ph ) ) $=
      wph vx vy weq wph wi vx wal vx vy vx vy weq wph wi vx hba1 vx vy weq wph
      vx vy weq wph wi vx wal wph vx vy ax11v vx vy weq wph wi vx wal vx vy weq
      wph vx vy weq wph wi vx ax-4 com12 impbid equsex $.
      $( [14-Apr-2008] $) $( [14-Apr-2008] $)

    $( Equivalence for substitution.  Compare Theorem 6.2 of [Quine] p. 40.
       Also proved as Lemmas 16 and 17 of [Tarski] p. 70. $)
    sb6 $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      vx vy weq wph wi vx vy weq wph wa vx wex wa vx vy weq wph wi vx vy weq
      wph wi vx wal wa wph vx vy wsb vx vy weq wph wi vx wal vx vy weq wph wa
      vx wex vx vy weq wph wi vx wal vx vy weq wph wi wph vx vy sb56 anbi2i wph
      vx vy df-sb vx vy weq wph wi vx wal vx vy weq wph wi vx vy weq wph wi vx
      ax-4 pm4.71ri 3bitr4i $.
      $( [14-Apr-2008] $) $( [18-Aug-1993] $)

    $( Equivalence for substitution.  Similar to Theorem 6.1 of [Quine]
       p. 40. $)
    sb5 $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      wph vx vy wsb vx vy weq wph wi vx wal vx vy weq wph wa vx wex wph vx vy
      sb6 wph vx vy sb56 bitr4i $.
      $( [14-Apr-2008] $) $( [18-Aug-1993] $)

    $( Identity law for equality (reflexivity).  Lemma 6 of [Tarski] p. 68.
       This proof is similar to Tarski's and makes use of a dummy variable
       ` y ` .  See ~ equid for a proof that avoids dummy variables (but is
       less intuitive). $)
    equid1 $p |- x = x $=
      vy vx weq vy wex vx vx weq vy vx a9e vy vx weq vx vx weq vy vx vx weq vy
      ax-17 vy vx weq vx vx weq vy vx vx ax-8 pm2.43i 19.23ai ax-mp $.
      $( [5-Apr-2005] $) $( [1-Apr-2005] $)
  $}

  ${
    $d x y z $.  $d z ph $.
    ax16i.1 $e |- ( x = z -> ( ph <-> ps ) ) $.
    ax16i.2 $e |- ( ps -> A. x ps ) $.
    $( Inference with ~ ax-16 as its conclusion, that doesn't require ~ ax-10 ,
       ~ ax-11 , or ~ ax-12 for its proof.  The hypotheses may be eliminable
       without one or more of these axioms in special cases. $)
    ax16i $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      vx vy weq vx wal vx vz weq vz wal wph wph vx wal wi vx vy weq vx wal vz
      vy weq vz wal vx vz weq vz wal vx vy weq vz vy weq vx vz vx vy weq vz
      ax-17 vz vy weq vx ax-17 vx vz vy ax-8 cbv3 vz vy weq vz wal vz vx weq vz
      wal vx vz weq vz wal vx vy weq vz vy weq vz wal vz vx weq vz wal vz vy
      weq vx vy weq vz vx vz vx vy ax-8 a4imv vx vy weq vz vy weq vz vx weq vz
      vx vy weq vz ax-17 vz vy weq vy vx weq vz vx weq vx vy weq vz vy weq vy
      vz weq vy vx weq vz vx weq wi vz vy weq vz vz weq vy vz weq vz equid1 vz
      vy vz ax-8 mpi vy vz vx ax-8 syl vx vy weq vx vx weq vy vx weq vx equid1
      vx vy vx ax-8 mpi syl5com 19.20d mpcom vz vx weq vx vz weq vz vz vx weq
      vz vz weq vx vz weq vz equid1 vz vx vz ax-8 mpi 19.20i syl syl wph vx vz
      weq vz wal wps vz wal wph vx wal wph vx vz weq wps vz wph vz ax-17 vx vz
      weq wph wps ax16i.1 biimpcd 19.20d wps wph vz vx ax16i.2 wph vz ax-17 vz
      vx weq vx vz weq wps wph wi vz vx weq vz vz weq vx vz weq vz equid1 vz vx
      vz ax-8 mpi vx vz weq wph wps ax16i.1 biimprd syl cbv3 syl6com syl $.
      $( [2-Jun-2008] $) $( [20-May-2008] $)
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Version of ~ ax16 that doesn't require ~ ax-10 or ~ ax-12 for its
       proof. $)
    ax16ALT $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      wph wph vx vz wsb vx vy vz wph vx vz sbequ12 wph vx vz wph vz ax-17 hbsb3
      ax16i $.
      $( [7-Jun-2008] $) $( [17-May-2008] $)
  $}

  ${
    $d x ps $.
    a4v.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Specialization, using implicit substitition. $)
    a4v $p |- ( A. x ph -> ps ) $=
      wph wps vx vy vx vy weq wph wps a4v.1 biimpd a4imv $.
      $( [30-Aug-1993] $)
  $}

  ${
    $d x ph $.
    a4imev.1 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Distinct-variable version of ~ a4ime . $)
    a4imev $p |- ( ph -> E. x ps ) $=
      wph wps vx vy wph vx ax-17 a4imev.1 a4ime $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ps $.
    a4eiv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    a4eiv.2 $e |- ps $.
    $( Inference from existential specialization, using implicit
       substitition. $)
    a4eiv $p |- E. x ph $=
      wps wph vx wex a4eiv.2 wps wph vx vy vx vy weq wph wps a4eiv.1 biimprd
      a4imev ax-mp $.
      $( [19-Aug-1993] $)
  $}

  ${
    $d x z $.  $d y z $.
    $( A variable introduction law for equality.  Lemma 15 of [Monk2]
       p. 109. $)
    equvin $p |- ( x = y <-> E. z ( x = z /\ z = y ) ) $=
      vx vy weq vx vz weq vz vy weq wa vz wex vx vy vz equvini vx vz weq vz vy
      weq wa vx vy weq vz vx vy weq vz ax-17 vx vz weq vz vy weq vx vy weq vx
      vz vy equtr imp 19.23ai impbii $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.
    $( A generalization of axiom ~ ax-16 . $)
    a16g $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      vz vx weq vz wal vx vy weq vx wal wph wph vz wal wi vx vy weq vx wal vz
      vx weq vz vx vy vz hbae vx vy weq vx wal vx vz weq vz vx weq vx vy weq vx
      wal vx vz weq vx vz weq wn vx wal vx vz ax-9 vx vz weq wn vx vy ax-16
      mt3i vx vz equcomi syl 19.21ai vx vy weq vx wal wph wph vx wal vz vx weq
      vz wal wph vz wal wph vx vy ax-16 vz vx weq vz wal wph vz wal wph vx wal
      wph wph vz vx vz vx weq vz wal wph biidd dral1 biimprd syl9r mpcom $.
      $( [5-Aug-1993] $)

    $( A generalization of axiom ~ ax-16 . $)
    a16gb $p |- ( A. x x = y -> ( ph <-> A. z ph ) ) $=
      vx vy weq vx wal wph wph vz wal wph vx vy vz a16g wph vz ax-4 impbid1 $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph $.
    albidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for universal quantifier (deduction rule). $)
    albidv $p |- ( ph -> ( A. x ps <-> A. x ch ) ) $=
      wph wps wch vx wph vx ax-17 albidv.1 albid $.
      $( [5-Aug-1993] $)

    $( Formula-building rule for existential quantifier (deduction rule). $)
    exbidv $p |- ( ph -> ( E. x ps <-> E. x ch ) ) $=
      wph wps wch vx wph vx ax-17 albidv.1 exbid $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph $.  $d y ph $.
    2albidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for 2 existential quantifiers (deduction rule). $)
    2albidv $p |- ( ph -> ( A. x A. y ps <-> A. x A. y ch ) ) $=
      wph wps vy wal wch vy wal vx wph wps wch vy 2albidv.1 albidv albidv $.
      $( [4-Mar-1997] $)

    $( Formula-building rule for 2 existential quantifiers (deduction rule). $)
    2exbidv $p |- ( ph -> ( E. x E. y ps <-> E. x E. y ch ) ) $=
      wph wps vy wex wch vy wex vx wph wps wch vy 2albidv.1 exbidv exbidv $.
      $( [1-May-1995] $)
  $}

  ${
    $d x ph $.  $d y ph $.  $d z ph $.
    3exbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for 3 existential quantifiers (deduction rule). $)
    3exbidv $p |- ( ph -> ( E. x E. y E. z ps <-> E. x E. y E. z ch ) ) $=
      wph wps vz wex wch vz wex vx vy wph wps wch vz 3exbidv.1 exbidv 2exbidv
      $.
      $( [1-May-1995] $)
  $}

  ${
    $d x ph $.  $d y ph $.  $d z ph $.  $d w ph $.
    4exbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for 4 existential quantifiers (deduction rule). $)
    4exbidv $p |- ( ph ->
                     ( E. x E. y E. z E. w ps <-> E. x E. y E. z E. w ch ) ) $=
      wph wps vw wex vz wex wch vw wex vz wex vx vy wph wps wch vz vw 4exbidv.1
      2exbidv 2exbidv $.
      $( [3-Aug-1995] $)
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.9 of [Margaris] p. 89. $)
    19.9v $p |- ( E. x ph <-> ph ) $=
      wph vx wph vx ax-17 19.9 $.
      $( [21-May-2007] $) $( [28-May-1995] $)
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.21 of [Margaris] p. 90.  _Notational
       convention_:  We sometimes suffix with "v" the label of a theorem
       eliminating a hypothesis such as ` ( ph -> A. x ph ) ` in ~ 19.21
       via the use of distinct variable conditions combined with ~ ax-17 .
       Conversely, we sometimes suffix with "f" the label of a theorem
       introducing such a hypothesis to eliminate the need for the
       distinct variable condition; e.g. ~ euf derived from ~ df-eu .
       The "f" stands for "not free in" which is less restrictive than
       "does not occur in." $)
    19.21v $p |- ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) $=
      wph wps vx wph vx ax-17 19.21 $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph $.
    19.21aiv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90. $)
    19.21aiv $p |- ( ph -> A. x ps ) $=
      wph wps vx wph vx ax-17 19.21aiv.1 19.21ai $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph $.  $d y ph $.
    19.21aivv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90. $)
    19.21aivv $p |- ( ph -> A. x A. y ps ) $=
      wph wps vy wal vx wph wps vy 19.21aivv.1 19.21aiv 19.21aiv $.
      $( [31-Jul-1995] $)
  $}

  ${
    $d x ph $.  $d x ps $.
    19.21adv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.21 of [Margaris] p. 90. $)
    19.21adv $p |- ( ph -> ( ps -> A. x ch ) ) $=
      wph wps wch vx wph vx ax-17 wps vx ax-17 19.21adv.1 19.21ad $.
      $( [10-Feb-1997] $)
  $}

  ${
    $d x ph $.
    19.20dv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.20 of [Margaris] p. 90. $)
    19.20dv $p |- ( ph -> ( A. x ps -> A. x ch ) ) $=
      wph wps wch vx wph vx ax-17 19.20dv.1 19.20d $.
      $( [3-Apr-1994] $)

    $( Deduction from Theorem 19.22 of [Margaris] p. 90. $)
    19.22dv $p |- ( ph -> ( E. x ps -> E. x ch ) ) $=
      wph wps wch vx wph vx ax-17 19.20dv.1 19.22d $.
      $( [27-Apr-1994] $)
  $}

  ${
    $d x ph $.  $d y ph $.
    19.20dvv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90. $)
    19.20dvv $p |- ( ph -> ( A. x A. y ps -> A. x A. y ch ) ) $=
      wph wps vy wal wch vy wal vx wph wps wch vy 19.20dvv.1 19.20dv 19.20dv $.
      $( [8-May-2004] $) $( [27-Apr-2004] $)

    $( Deduction from Theorem 19.22 of [Margaris] p. 90. $)
    19.22dvv $p |- ( ph -> ( E. x E. y ps -> E. x E. y ch ) ) $=
      wph wps vy wex wch vy wex vx wph wps wch vy 19.20dvv.1 19.22dv 19.22dv $.
      $( [3-Aug-1995] $)
  $}

  ${
    $d x ps $.
    $( Special case of Theorem 19.23 of [Margaris] p. 90. $)
    19.23v $p |- ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) $=
      wph wps vx wps vx ax-17 19.23 $.
      $( [28-Jun-1998] $)
  $}

  ${
    $d x ps $.  $d y ps $.
    $( Theorem 19.23 of [Margaris] p. 90 extended to two variables. $)
    19.23vv $p |- ( A. x A. y ( ph -> ps ) <-> ( E. x E. y ph -> ps ) ) $=
      wph wps wi vy wal vx wal wph vy wex wps wi vx wal wph vy wex vx wex wps
      wi wph wps wi vy wal wph vy wex wps wi vx wph wps vy 19.23v albii wph vy
      wex wps vx 19.23v bitri $.
      $( [23-Aug-2004] $) $( [10-Aug-2004] $)
  $}

  ${
    $d x ps $.
    19.23aiv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90. $)
    19.23aiv $p |- ( E. x ph -> ps ) $=
      wph wps vx wps vx ax-17 19.23aiv.1 19.23ai $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ps $.  $d y ps $.
    19.23aivv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90. $)
    19.23aivv $p |- ( E. x E. y ph -> ps ) $=
      wph vy wex wps vx wph wps vy 19.23aivv.1 19.23aiv 19.23aiv $.
      $( [1-Aug-1995] $)
  $}

  ${
    $d x ch $.  $d x ph $.  $d y ch $.  $d y ph $.
    19.23advv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90. $)
    19.23advv $p |- ( ph -> ( E. x E. y ps -> ch ) ) $=
      wph wps vy wex wch vx wph wps wch vy 19.23advv.1 19.23adv 19.23adv $.
      $( [31-Jul-1995] $)
  $}

  ${
    $d x ps $.
    $( Theorem 19.27 of [Margaris] p. 90. $)
    19.27v $p |- ( A. x ( ph /\ ps ) <-> ( A. x ph /\ ps ) ) $=
      wph wps vx wps vx ax-17 19.27 $.
      $( [4-Jun-2004] $) $( [3-Jun-2004] $)
  $}

  ${
    $d x ph $.
    $( Theorem 19.28 of [Margaris] p. 90. $)
    19.28v $p |- ( A. x ( ph /\ ps ) <-> ( ph /\ A. x ps ) ) $=
      wph wps vx wph vx ax-17 19.28 $.
      $( [25-Mar-2004] $) $( [25-Mar-2004] $)
  $}

  ${
    $d x ps $.
    $( Special case of Theorem 19.36 of [Margaris] p. 90. $)
    19.36v $p |- ( E. x ( ph -> ps ) <-> ( A. x ph -> ps ) ) $=
      wph wps vx wps vx ax-17 19.36 $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x ps $.
    19.36aiv.1 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.36 of [Margaris] p. 90. $)
    19.36aiv $p |- ( A. x ph -> ps ) $=
      wph wps vx wps vx ax-17 19.36aiv.1 19.36i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d x ps $.  $d y ph $.
    $( Special case of ~ 19.12 where its converse holds. $)
    19.12vv $p |- ( E. x A. y ( ph -> ps ) <-> A. y E. x ( ph -> ps ) ) $=
      wph wps wi vy wal vx wex wph wps vy wal wi vx wex wph vx wal wps vy wal
      wi wph wps wi vx wex vy wal wph wps wi vy wal wph wps vy wal wi vx wph
      wps vy 19.21v exbii wph wps vy wal vx 19.36v wph wps wi vx wex vy wal wph
      vx wal wps wi vy wal wph vx wal wps vy wal wi wph wps wi vx wex wph vx
      wal wps wi vy wph wps vx 19.36v albii wph vx wal wps vy 19.21v bitr2i
      3bitri $.
      $( [18-Jul-2001] $)
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.37 of [Margaris] p. 90. $)
    19.37v $p |- ( E. x ( ph -> ps ) <-> ( ph -> E. x ps ) ) $=
      wph wps vx wph vx ax-17 19.37 $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph $.
    19.37aiv.1 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.37 of [Margaris] p. 90. $)
    19.37aiv $p |- ( ph -> E. x ps ) $=
      wph wps wi vx wex wph wps vx wex wi 19.37aiv.1 wph wps vx 19.37v mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ps $.
    $( Special case of Theorem 19.41 of [Margaris] p. 90. $)
    19.41v $p |- ( E. x ( ph /\ ps ) <-> ( E. x ph /\ ps ) ) $=
      wph wps vx wps vx ax-17 19.41 $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ps $.  $d y ps $.
    $( Theorem 19.41 of [Margaris] p. 90 with 2 quantifiers. $)
    19.41vv $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x E. y ph /\ ps ) ) $=
      wph wps wa vy wex vx wex wph vy wex wps wa vx wex wph vy wex vx wex wps
      wa wph wps wa vy wex wph vy wex wps wa vx wph wps vy 19.41v exbii wph vy
      wex wps vx 19.41v bitri $.
      $( [30-Apr-1995] $)
  $}

  ${
    $d x ps $.  $d y ps $.  $d z ps $.
    $( Theorem 19.41 of [Margaris] p. 90 with 3 quantifiers. $)
    19.41vvv $p |- ( E. x E. y E. z ( ph /\ ps ) <->
                     ( E. x E. y E. z ph /\ ps ) ) $=
      wph wps wa vz wex vy wex vx wex wph vz wex vy wex wps wa vx wex wph vz
      wex vy wex vx wex wps wa wph wps wa vz wex vy wex wph vz wex vy wex wps
      wa vx wph wps vy vz 19.41vv exbii wph vz wex vy wex wps vx 19.41v bitri
      $.
      $( [30-Apr-1995] $)
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.42 of [Margaris] p. 90. $)
    19.42v $p |- ( E. x ( ph /\ ps ) <-> ( ph /\ E. x ps ) ) $=
      wph wps vx wph vx ax-17 19.42 $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d y ph $.
    $( Distribution of existential quantifiers. $)
    exdistr $p |- ( E. x E. y ( ph /\ ps ) <-> E. x ( ph /\ E. y ps ) ) $=
      wph wps wa vy wex wph wps vy wex wa vx wph wps vy 19.42v exbii $.
      $( [9-Mar-1995] $)
  $}

  ${
    $d x ph $.  $d y ph $.
    $( Theorem 19.42 of [Margaris] p. 90 with 2 quantifiers. $)
    19.42vv $p |- ( E. x E. y ( ph /\ ps ) <-> ( ph /\ E. x E. y ps ) ) $=
      wph wps wa vy wex vx wex wph wps vy wex wa vx wex wph wps vy wex vx wex
      wa wph wps vx vy exdistr wph wps vy wex vx 19.42v bitri $.
      $( [16-Mar-1995] $)
  $}

  ${
    $d y ph $.  $d z ph $.
    $( Distribution of existential quantifiers. $)
    exdistr2 $p |- ( E. x E. y E. z ( ph /\ ps ) <->
                   E. x ( ph /\ E. y E. z ps ) ) $=
      wph wps wa vz wex vy wex wph wps vz wex vy wex wa vx wph wps vy vz
      19.42vv exbii $.
      $( [17-Mar-1995] $)
  $}

  ${
    $d y ph $.  $d z ph $.  $d z ps $.
    $( Distribution of existential quantifiers. $)
    3exdistr $p |- ( E. x E. y E. z ( ph /\ ps /\ ch ) <->
                E. x ( ph /\ E. y ( ps /\ E. z ch ) ) ) $=
      wph wps wch w3a vz wex vy wex wph wps wch vz wex wa vy wex wa vx wph wps
      wch w3a vz wex vy wex wph wps wch vz wex wa wa vy wex wph wps wch vz wex
      wa vy wex wa wph wps wch w3a vz wex wph wps wch vz wex wa wa vy wph wps
      wch w3a vz wex wph wps wch wa wa vz wex wph wps wch wa vz wex wa wph wps
      wch vz wex wa wa wph wps wch w3a wph wps wch wa wa vz wph wps wch 3anass
      exbii wph wps wch wa vz 19.42v wps wch wa vz wex wps wch vz wex wa wph
      wps wch vz 19.42v anbi2i 3bitri exbii wph wps wch vz wex wa vy 19.42v
      bitri exbii $.
      $( [9-Mar-1995] $)
  $}

  ${
    $d y ph $.  $d z ph $.  $d w ph $.  $d z ps $.  $d w ps $.  $d w ch $.
    $( Distribution of existential quantifiers. $)
    4exdistr $p |- ( E. x E. y E. z E. w ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
                E. x ( ph /\ E. y ( ps /\ E. z ( ch /\ E. w th ) ) ) ) $=
      wph wps wa wch wth wa wa vw wex vz wex vy wex wph wps wch wth vw wex wa
      vz wex wa vy wex wa vx wph wps wa wch wth wa wa vw wex vz wex vy wex wph
      wps wch wth vw wex wa vz wex wa wa vy wex wph wps wch wth vw wex wa vz
      wex wa vy wex wa wph wps wa wch wth wa wa vw wex vz wex wph wps wch wth
      vw wex wa vz wex wa wa vy wph wps wa wch wth wa wa vw wex vz wex wph wps
      wch wth vw wex wa wa wa vz wex wph wps wch wth vw wex wa wa vz wex wa wph
      wps wch wth vw wex wa vz wex wa wa wph wps wa wch wth wa wa vw wex wph
      wps wch wth vw wex wa wa wa vz wph wps wa wch wth wa wa vw wex wph wps
      wch wth wa wa wa vw wex wph wps wch wth vw wex wa wa wa wph wps wa wch
      wth wa wa wph wps wch wth wa wa wa vw wph wps wch wth wa anass exbii wph
      wps wch wth wa wa wa vw wex wph wps wch wth wa wa vw wex wa wph wps wch
      wth wa vw wex wa wa wph wps wch wth vw wex wa wa wa wph wps wch wth wa wa
      vw 19.42v wps wch wth wa wa vw wex wps wch wth wa vw wex wa wph wps wch
      wth wa vw 19.42v anbi2i wps wch wth wa vw wex wa wps wch wth vw wex wa wa
      wph wch wth wa vw wex wch wth vw wex wa wps wch wth vw 19.42v anbi2i
      anbi2i 3bitri bitri exbii wph wps wch wth vw wex wa wa vz 19.42v wps wch
      wth vw wex wa wa vz wex wps wch wth vw wex wa vz wex wa wph wps wch wth
      vw wex wa vz 19.42v anbi2i 3bitri exbii wph wps wch wth vw wex wa vz wex
      wa vy 19.42v bitri exbii $.
      $( [9-Mar-1995] $)
  $}

  ${
    $d y ph $.  $d x ps $.
    cbvalv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbvalv $p |- ( A. x ph <-> A. y ps ) $=
      wph wps vx vy wph vy ax-17 wps vx ax-17 cbvalv.1 cbval $.
      $( [5-Aug-1993] $)

    $( Rule used to change bound variables, using implicit substitition. $)
    cbvexv $p |- ( E. x ph <-> E. y ps ) $=
      wph wps vx vy wph vy ax-17 wps vx ax-17 cbvalv.1 cbvex $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d y x $.  $d y z $.  $d w x $.  $d w z $.
    cbval2.1 $e |- ( ph -> A. z ph ) $.
    cbval2.2 $e |- ( ph -> A. w ph ) $.
    cbval2.3 $e |- ( ps -> A. x ps ) $.
    cbval2.4 $e |- ( ps -> A. y ps ) $.
    cbval2.5 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbval2 $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      wph vy wal wps vw wal vx vz wph vz vy cbval2.1 hbal wps vx vw cbval2.3
      hbal vx vz weq wph vy wal wps vw wal wb wi vx vz weq wph vy wal wa vx vz
      weq wps vw wal wa wb vx vz weq wph wa vy wal vx vz weq wps wa vw wal vx
      vz weq wph vy wal wa vx vz weq wps vw wal wa vx vz weq wph wa vx vz weq
      wps wa vy vw vx vz weq wph vw vx vz weq vw ax-17 cbval2.2 hban vx vz weq
      wps vy vx vz weq vy ax-17 cbval2.4 hban vy vw weq vx vz weq wph wps vx vz
      weq vy vw weq wph wps wb cbval2.5 expcom pm5.32d cbval vx vz weq wph vy
      vx vz weq vy ax-17 19.28 vx vz weq wps vw vx vz weq vw ax-17 19.28
      3bitr3i vx vz weq wph vy wal wps vw wal pm5.32 mpbir cbval $.
      $( [22-Dec-2003] $) $( [22-Dec-2003] $)

    $( Rule used to change bound variables, using implicit substitition. $)
    cbvex2 $p |- ( E. x E. y ph <-> E. z E. w ps ) $=
      wph vy wex wps vw wex vx vz wph vz vy cbval2.1 hbex wps vx vw cbval2.3
      hbex vx vz weq wph vy wex wps vw wex wb wi vx vz weq wph vy wex wa vx vz
      weq wps vw wex wa wb vx vz weq wph wa vy wex vx vz weq wps wa vw wex vx
      vz weq wph vy wex wa vx vz weq wps vw wex wa vx vz weq wph wa vx vz weq
      wps wa vy vw vx vz weq wph vw vx vz weq vw ax-17 cbval2.2 hban vx vz weq
      wps vy vx vz weq vy ax-17 cbval2.4 hban vy vw weq vx vz weq wph wps vx vz
      weq vy vw weq wph wps wb cbval2.5 expcom pm5.32d cbvex vx vz weq wph vy
      vx vz weq vy ax-17 19.42 vx vz weq wps vw vx vz weq vw ax-17 19.42
      3bitr3i vx vz weq wph vy wex wps vw wex pm5.32 mpbir cbvex $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d z w ph $.  $d x y ps $.  $d x w $.  $d z y $.
    cbval2v.1 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbval2v $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      wph wps vx vy vz vw wph vz ax-17 wph vw ax-17 wps vx ax-17 wps vy ax-17
      cbval2v.1 cbval2 $.
      $( [2-Mar-2005] $) $( [4-Feb-2005] $)

    $( Rule used to change bound variables, using implicit substitition. $)
    cbvex2v $p |- ( E. x E. y ph <-> E. z E. w ps ) $=
      wph wps vx vy vz vw wph vz ax-17 wph vw ax-17 wps vx ax-17 wps vy ax-17
      cbval2v.1 cbvex2 $.
      $( [26-Jul-1995] $)
  $}

  ${
    $d x ph $.  $d x ch $.
    cbvald.1 $e |- ( ph -> A. y ph ) $.
    cbvald.2 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbvald.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Deduction used to change bound variables, using implicit substitition,
       particularly useful in conjunction with ~ dvelim . $)
    cbvald $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      wph wps vx wal wch vy wal wph wps wi vx wal wph wch wi vy wal wph wps vx
      wal wi wph wch vy wal wi wph wps wi wph wch wi vx vy wph wps vy cbvald.1
      cbvald.2 hbim1 wph wch wi vx ax-17 vx vy weq wph wps wch wph vx vy weq
      wps wch wb cbvald.3 com12 pm5.74d cbval wph wps vx 19.21v wph wch vy
      cbvald.1 19.21 3bitr3i pm5.74ri $.
      $( [2-Jan-2002] $)

    $( Deduction used to change bound variables, using implicit substitition,
       particularly useful in conjunction with ~ dvelim . $)
    cbvexd $p |- ( ph -> ( E. x ps <-> E. y ch ) ) $=
      wph wps wn vx wal wn wch wn vy wal wn wps vx wex wch vy wex wph wps wn vx
      wal wch wn vy wal wph wps wn wch wn vx vy cbvald.1 wph wps vy cbvald.1
      cbvald.2 hbnd wph vx vy weq wps wch wb wps wn wch wn wb cbvald.3 wps wch
      notbi syl6ib cbvald notbid wps vx df-ex wch vy df-ex 3bitr4g $.
      $( [2-Jan-2002] $)
  $}

  ${
    $v f $.
    $v g $.
    $( Define temporary individual variables. $)
    cbvex4v.vf $f set f $.
    cbvex4v.vg $f set g $.
    $d w z ch $.  $d u v ph $.  $d x y ps $.  $d f g ps $.  $d f w $.
    $d g z $.  $d u v w x y z $.
    cbvex4v.1 $e |- ( ( x = v /\ y = u ) -> ( ph <-> ps ) ) $.
    cbvex4v.2 $e |- ( ( z = f /\ w = g ) -> ( ps <-> ch ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbvex4v $p |- ( E. x E. y E. z E. w ph <-> E. v E. u E. f E. g ch ) $=
      wph vw wex vz wex vy wex vx wex wps vw wex vz wex vu wex vv wex wch
      cbvex4v.vg wex cbvex4v.vf wex vu wex vv wex wph vw wex vz wex wps vw wex
      vz wex vx vy vv vu vx vv weq vy vu weq wa wph wps vz vw cbvex4v.1 2exbidv
      cbvex2v wps vw wex vz wex wch cbvex4v.vg wex cbvex4v.vf wex vv vu wps wch
      vz vw cbvex4v.vf cbvex4v.vg cbvex4v.2 cbvex2v 2exbii bitri $.
      $( [26-Jul-1995] $)
  $}

  ${
    eean.1 $e |- ( ph -> A. y ph ) $.
    eean.2 $e |- ( ps -> A. x ps ) $.
    $( Rearrange existential quantifiers. $)
    eean $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x ph /\ E. y ps ) ) $=
      wph wps wa vy wex vx wex wph wps vy wex wa vx wex wph vx wex wps vy wex
      wa wph wps wa vy wex wph wps vy wex wa vx wph wps vy eean.1 19.42 exbii
      wph wps vy wex vx wps vx vy eean.2 hbex 19.41 bitri $.
      $( [1-Nov-2010] $) $( [27-Oct-2010] $)
  $}

  ${
    $d y ph $.  $d x ps $.
    $( Rearrange existential quantifiers. $)
    eeanv $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x ph /\ E. y ps ) ) $=
      wph wps vx vy wph vy ax-17 wps vx ax-17 eean $.
      $( [26-Jul-1995] $)
  $}

  ${
    $d y ph $.  $d z ph $.  $d x z ps $.  $d x y ch $.
    $( Rearrange existential quantifiers. $)
    eeeanv $p |- ( E. x E. y E. z ( ph /\ ps /\ ch ) <->
                 ( E. x ph /\ E. y ps /\ E. z ch ) ) $=
      wph wps wch wa wa vz wex vy wex vx wex wph vx wex wps vy wex wch vz wex
      wa wa wph wps wch w3a vz wex vy wex vx wex wph vx wex wps vy wex wch vz
      wex w3a wph wps wch wa wa vz wex vy wex vx wex wph wps vy wex wch vz wex
      wa wa vx wex wph vx wex wps vy wex wch vz wex wa wa wph wps wch wa wa vz
      wex vy wex wph wps vy wex wch vz wex wa wa vx wph wps wch wa wa vz wex vy
      wex wph wps wch wa vz wex vy wex wa wph wps vy wex wch vz wex wa wa wph
      wps wch wa vy vz 19.42vv wps wch wa vz wex vy wex wps vy wex wch vz wex
      wa wph wps wch vy vz eeanv anbi2i bitri exbii wph wps vy wex wch vz wex
      wa vx 19.41v bitri wph wps wch w3a wph wps wch wa wa vx vy vz wph wps wch
      3anass 3exbii wph vx wex wps vy wex wch vz wex 3anass 3bitr4i $.
      $( [26-Jul-1995] $)
  $}

  ${
    $d z ph $.  $d w ph $.  $d x ps $.  $d y ps $.  $d y z $.  $d w x $.
    $( Rearrange existential quantifiers. $)
    ee4anv $p |- ( E. x E. y E. z E. w ( ph /\ ps ) <->
                  ( E. x E. y ph /\ E. z E. w ps ) ) $=
      wph wps wa vw wex vz wex vy wex vx wex wph wps wa vw wex vy wex vz wex vx
      wex wph vy wex wps vw wex wa vz wex vx wex wph vy wex vx wex wps vw wex
      vz wex wa wph wps wa vw wex vz wex vy wex wph wps wa vw wex vy wex vz wex
      vx wph wps wa vw wex vy vz excom exbii wph wps wa vw wex vy wex wph vy
      wex wps vw wex wa vx vz wph wps vy vw eeanv 2exbii wph vy wex wps vw wex
      vx vz eeanv 3bitri $.
      $( [31-Jul-1995] $)
  $}

  ${
    $d x ph $.
    nexdv.1 $e |- ( ph -> -. ps ) $.
    $( Deduction for generalization rule for negated wff. $)
    nexdv $p |- ( ph -> -. E. x ps ) $=
      wph wps vx wph vx ax-17 nexdv.1 nexd $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ps $.
    chv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    chv.2 $e |- ph $.
    $( Implicit substitution of ` y ` for ` x ` into a theorem. $)
    chvarv $p |- ps $=
      wph wps vx wph wps vx vy chv.1 a4v chv.2 mpg $.
      $( [20-Apr-1994] $)
  $}

  ${
    $d x z $.  $d y z $.
    $( When the class variables in definition ~ df-clel are replaced with set
       variables, this theorem of predicate calculus is the result.  This
       theorem provides part of the justification for the consistency of that
       definition, which "overloads" the set variables in ~ wel with the class
       variables in ~ wcel . $)
    cleljust $p |- ( x e. y <-> E. z ( z = x /\ z e. y ) ) $=
      vz vx weq vz vy wel wa vz wex vx vy wel vz vy wel vx vy wel vz vx vx vy
      wel vz ax-17 vz vx vy elequ1 equsex bicomi $.
      $( [28-Jan-2004] $) $( [28-Jan-2004] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        More substitution theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$( The theorems in this section make use of the $d statement. $)

  ${
    $d y ph $.
    $( Two ways of expressing " ` x ` is not free in ` ph ` ". $)
    sbhb $p |- ( ( ph -> A. x ph ) <-> A. y ( ph -> [ y / x ] ph ) ) $=
      wph wph vx wal wi wph wph vx vy wsb vy wal wi wph wph vx vy wsb wi vy wal
      wph vx wal wph vx vy wsb vy wal wph wph vx vy wph vy ax-17 sb8 imbi2i wph
      wph vx vy wsb vy 19.21v bitr4i $.
      $( [30-May-2009] $) $( [29-May-2009] $)
  $}

  ${
    $d y z $.  $d x y $.
    $( Lemma for ~ equsb3 . $)
    equsb3lem $p |- ( [ x / y ] y = z <-> x = z ) $=
      vy vz weq vy vx wsb vx vz weq vy vx wsb vx vz weq vx vz weq vy vz weq wb
      vy vx wsb vx vz weq vy vx wsb vy vz weq vy vx wsb wb vx vy weq vy vx wsb
      vx vz weq vy vz weq wb vy vx wsb vy vx equsb2 vx vy weq vx vz weq vy vz
      weq wb vy vx vx vy vz equequ1 sbimi ax-mp vx vz weq vy vz weq vy vx sbbi
      mpbi vx vz weq vy vx vx vz weq vy ax-17 sbf bitr3i $.
      $( [4-Dec-2005] $) $( [4-Dec-2005] $)
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic wff.  (Contributed by Raph Levien and
       FL, 4-Dec-2005.) $)
    equsb3 $p |- ( [ x / y ] y = z <-> x = z ) $=
      vy vz weq vy vw wsb vw vx wsb vw vz weq vw vx wsb vy vz weq vy vx wsb vx
      vz weq vy vz weq vy vw wsb vw vz weq vw vx vw vy vz equsb3lem sbbii vy vz
      weq vy vx vw vy vz weq vw ax-17 sbco2 vx vw vz equsb3lem 3bitr3i $.
      $( [4-Dec-2005] $) $( [4-Dec-2005] $)
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic membership wff. $)
    elsb3 $p |- ( [ x / y ] y e. z <-> x e. z ) $=
      vy vz wel vy vw wsb vw vx wsb vw vz wel vw vx wsb vy vz wel vy vx wsb vx
      vz wel vy vz wel vy vw wsb vw vz wel vw vx vy vz wel vy vw wsb vw vz wel
      vy vw wsb vw vz wel vw vz wel vy vz wel wb vy vw wsb vw vz wel vy vw wsb
      vy vz wel vy vw wsb wb vw vy weq vy vw wsb vw vz wel vy vz wel wb vy vw
      wsb vy vw equsb2 vw vy weq vw vz wel vy vz wel wb vy vw vw vy vz elequ1
      sbimi ax-mp vw vz wel vy vz wel vy vw sbbi mpbi vw vz wel vy vw vw vz wel
      vy ax-17 sbf bitr3i sbbii vy vz wel vy vx vw vy vz wel vw ax-17 sbco2 vw
      vz wel vw vx wsb vx vz wel vw vx wsb vx vz wel vx vz wel vw vz wel wb vw
      vx wsb vx vz wel vw vx wsb vw vz wel vw vx wsb wb vx vw weq vw vx wsb vx
      vz wel vw vz wel wb vw vx wsb vw vx equsb2 vx vw weq vx vz wel vw vz wel
      wb vw vx vx vw vz elequ1 sbimi ax-mp vx vz wel vw vz wel vw vx sbbi mpbi
      vx vz wel vw vx vx vz wel vw ax-17 sbf bitr3i 3bitr3i $.
      $( [7-Nov-2006] $) $( [7-Nov-2006] $)
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic membership wff.  (Contributed by
       Rodolfo Medina, 3-Apr-2010.) $)
    elsb4 $p |- ( [ x / y ] z e. y <-> z e. x ) $=
      vz vy wel vy vw wsb vw vx wsb vz vw wel vw vx wsb vz vy wel vy vx wsb vz
      vx wel vz vy wel vy vw wsb vz vw wel vw vx vz vy wel vy vw wsb vz vw wel
      vy vw wsb vz vw wel vz vw wel vz vy wel wb vy vw wsb vz vw wel vy vw wsb
      vz vy wel vy vw wsb wb vw vy weq vy vw wsb vz vw wel vz vy wel wb vy vw
      wsb vy vw equsb2 vw vy weq vz vw wel vz vy wel wb vy vw vw vy vz elequ2
      sbimi ax-mp vz vw wel vz vy wel vy vw sbbi mpbi vz vw wel vy vw vz vw wel
      vy ax-17 sbf bitr3i sbbii vz vy wel vy vx vw vz vy wel vw ax-17 sbco2 vz
      vw wel vw vx wsb vz vx wel vw vx wsb vz vx wel vz vx wel vz vw wel wb vw
      vx wsb vz vx wel vw vx wsb vz vw wel vw vx wsb wb vx vw weq vw vx wsb vz
      vx wel vz vw wel wb vw vx wsb vw vx equsb2 vx vw weq vz vx wel vz vw wel
      wb vw vx vx vw vz elequ2 sbimi ax-mp vz vx wel vz vw wel vw vx sbbi mpbi
      vz vx wel vw vx vz vx wel vw ax-17 sbf bitr3i 3bitr3i $.
      $( [15-Apr-2010] $) $( [3-Apr-2010] $)
  $}

  ${
    $d x y $.
    $( ` x ` is not free in ` [ y / x ] ph ` when ` x ` and ` y ` are
       distinct. $)
    hbs1 $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      vx vy weq vx wal wph vx vy wsb wph vx vy wsb vx wal wi wph vx vy wsb vx
      vy ax-16 wph vx vy hbsb2 pm2.61i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d y z $.
    hbsb.1 $e |- ( ph -> A. z ph ) $.
    $( If ` z ` is not free in ` ph ` , it is not free in ` [ y / x ] ph `
       when ` y ` and ` z ` are distinct. $)
    hbsb $p |- ( [ y / x ] ph -> A. z [ y / x ] ph ) $=
      vz vy weq vz wal wph vx vy wsb wph vx vy wsb vz wal wi wph vx vy wsb vz
      vy ax-16 wph vx vy vz hbsb.1 hbsb4 pm2.61i $.
      $( [12-Aug-1993] $)
  $}

  ${
    $d x z $.  $d x w $.  $d y z $.
    $( Commutativity law for substitution.  Used in proof of Theorem 9.7 of
       [Megill] p. 449 (p. 16 of the preprint). $)
    sbcom2 $p |- ( [ w / z ] [ y / x ] ph <-> [ y / x ] [ w / z ] ph ) $=
      vx vy weq vx wal vz vw weq vz wal wph vx vy wsb vz vw wsb wph vz vw wsb
      vx vy wsb wb vx vy weq vx wal wn vz vw weq vz wal wn wph vx vy wsb vz vw
      wsb wph vz vw wsb vx vy wsb wb vx vy weq vx wal wn vz vw weq vz wal wn wa
      vz vw weq vx vy weq wph wi vx wal wi vz wal vx vy weq vz vw weq wph wi vz
      wal wi vx wal wph vx vy wsb vz vw wsb wph vz vw wsb vx vy wsb vz vw weq
      vx vy weq wph wi vx wal wi vz wal vx vy weq vz vw weq wph wi vz wal wi vx
      wal wb vx vy weq vx wal wn vz vw weq vz wal wn wa vx vy weq vz vw weq wph
      wi wi vx wal vz wal vx vy weq vz vw weq wph wi wi vz wal vx wal vz vw weq
      vx vy weq wph wi vx wal wi vz wal vx vy weq vz vw weq wph wi vz wal wi vx
      wal vx vy weq vz vw weq wph wi wi vz vx alcom vx vy weq vz vw weq wph wi
      wi vx wal vz vw weq vx vy weq wph wi vx wal wi vz vx vy weq vz vw weq wph
      wi wi vx wal vz vw weq vx vy weq wph wi wi vx wal vz vw weq vx vy weq wph
      wi vx wal wi vx vy weq vz vw weq wph wi wi vz vw weq vx vy weq wph wi wi
      vx vx vy weq vz vw weq wph bi2.04 albii vz vw weq vx vy weq wph wi vx
      19.21v bitri albii vx vy weq vz vw weq wph wi wi vz wal vx vy weq vz vw
      weq wph wi vz wal wi vx vx vy weq vz vw weq wph wi vz 19.21v albii
      3bitr3i a1i vz vw weq vz wal wn wph vx vy wsb vz vw wsb vz vw weq wph vx
      vy wsb wi vz wal vx vy weq vx wal wn vz vw weq vx vy weq wph wi vx wal wi
      vz wal wph vx vy wsb vz vw sb4b vx vy weq vx wal wn vz vw weq wph vx vy
      wsb wi vz vw weq vx vy weq wph wi vx wal wi vz vx vy weq vx wal wn wph vx
      vy wsb vx vy weq wph wi vx wal vz vw weq wph vx vy sb4b imbi2d albidv
      sylan9bbr vx vy weq vx wal wn wph vz vw wsb vx vy wsb vx vy weq wph vz vw
      wsb wi vx wal vz vw weq vz wal wn vx vy weq vz vw weq wph wi vz wal wi vx
      wal wph vz vw wsb vx vy sb4b vz vw weq vz wal wn vx vy weq wph vz vw wsb
      wi vx vy weq vz vw weq wph wi vz wal wi vx vz vw weq vz wal wn wph vz vw
      wsb vz vw weq wph wi vz wal vx vy weq wph vz vw sb4b imbi2d albidv
      sylan9bb 3bitr4d ex vx vy weq vx wal wph vz vw wsb wph vx vy wsb vz vw
      wsb wph vz vw wsb vx vy wsb vx vy weq vx wal wph wph vx vy wsb vz vw vx
      vy vz hbae vx vy weq wph wph vx vy wsb wb vx wph vx vy sbequ12 a4s sbbid
      vx vy weq wph vz vw wsb wph vz vw wsb vx vy wsb wb vx wph vz vw wsb vx vy
      sbequ12 a4s bitr3d vz vw weq vz wal wph vx vy wsb wph vx vy wsb vz vw wsb
      wph vz vw wsb vx vy wsb vz vw weq wph vx vy wsb wph vx vy wsb vz vw wsb
      wb vz wph vx vy wsb vz vw sbequ12 a4s vz vw weq vz wal wph wph vz vw wsb
      vx vy vz vw vx hbae vz vw weq wph wph vz vw wsb wb vz wph vz vw sbequ12
      a4s sbbid bitr3d pm2.61ii $.
      $( [27-May-1997] $)
  $}

  ${
    $d x y z $.  $d w y $.
    $( Equivalence for double substitution. $)
    2sb5 $p |- ( [ z / x ] [ w / y ] ph <->
               E. x E. y ( ( x = z /\ y = w ) /\ ph ) ) $=
      wph vy vw wsb vx vz wsb vx vz weq wph vy vw wsb wa vx wex vx vz weq vy vw
      weq wa wph wa vy wex vx wex wph vy vw wsb vx vz sb5 vx vz weq wph vy vw
      wsb wa vx vz weq vy vw weq wa wph wa vy wex vx vx vz weq vy vw weq wph wa
      wa vy wex vx vz weq vy vw weq wph wa vy wex wa vx vz weq vy vw weq wa wph
      wa vy wex vx vz weq wph vy vw wsb wa vx vz weq vy vw weq wph wa vy 19.42v
      vx vz weq vy vw weq wa wph wa vx vz weq vy vw weq wph wa wa vy vx vz weq
      vy vw weq wph anass exbii wph vy vw wsb vy vw weq wph wa vy wex vx vz weq
      wph vy vw sb5 anbi2i 3bitr4ri exbii bitri $.
      $( [25-Mar-2005] $) $( [3-Feb-2005] $)

    $( Equivalence for double substitution. $)
    2sb6 $p |- ( [ z / x ] [ w / y ] ph <->
               A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      wph vy vw wsb vx vz wsb vx vz weq wph vy vw wsb wi vx wal vx vz weq vy vw
      weq wa wph wi vy wal vx wal wph vy vw wsb vx vz sb6 vx vz weq wph vy vw
      wsb wi vx vz weq vy vw weq wa wph wi vy wal vx vx vz weq vy vw weq wph wi
      wi vy wal vx vz weq vy vw weq wph wi vy wal wi vx vz weq vy vw weq wa wph
      wi vy wal vx vz weq wph vy vw wsb wi vx vz weq vy vw weq wph wi vy 19.21v
      vx vz weq vy vw weq wa wph wi vx vz weq vy vw weq wph wi wi vy vx vz weq
      vy vw weq wph impexp albii wph vy vw wsb vy vw weq wph wi vy wal vx vz
      weq wph vy vw sb6 imbi2i 3bitr4ri albii bitri $.
      $( [12-Feb-2005] $) $( [3-Feb-2005] $)
  $}

  ${
    $d x y $.
    $( Equivalence for substitution. $)
    sb6a $p |- ( [ y / x ] ph <-> A. x ( x = y -> [ x / y ] ph ) ) $=
      wph vx vy wsb vx vy weq wph wi vx wal vx vy weq wph vy vx wsb wi vx wal
      wph vx vy sb6 vx vy weq wph wi vx vy weq wph vy vx wsb wi vx vx vy weq
      wph wph vy vx wsb wph wph vy vx wsb wb vy vx wph vy vx sbequ12 equcoms
      pm5.74i albii bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d x w $.  $d y z $.  $d z w $.
    2sb5rf.1 $e |- ( ph -> A. z ph ) $.
    2sb5rf.2 $e |- ( ph -> A. w ph ) $.
    $( Reversed double substitution. $)
    2sb5rf $p |- ( ph <->
                E. z E. w ( ( z = x /\ w = y ) /\ [ z / x ] [ w / y ] ph ) ) $=
      wph vz vx weq wph vx vz wsb wa vz wex vz vx weq vw vy weq wa wph vy vw
      wsb vx vz wsb wa vw wex vz wex wph vx vz 2sb5rf.1 sb5rf vz vx weq wph vx
      vz wsb wa vz vx weq vw vy weq wa wph vy vw wsb vx vz wsb wa vw wex vz vz
      vx weq vw vy weq wph vx vz wsb vy vw wsb wa wa vw wex vz vx weq vw vy weq
      wph vx vz wsb vy vw wsb wa vw wex wa vz vx weq vw vy weq wa wph vy vw wsb
      vx vz wsb wa vw wex vz vx weq wph vx vz wsb wa vz vx weq vw vy weq wph vx
      vz wsb vy vw wsb wa vw 19.42v vz vx weq vw vy weq wa wph vy vw wsb vx vz
      wsb wa vz vx weq vw vy weq wph vx vz wsb vy vw wsb wa wa vw vz vx weq vw
      vy weq wa wph vy vw wsb vx vz wsb wa vz vx weq vw vy weq wa wph vx vz wsb
      vy vw wsb wa vz vx weq vw vy weq wph vx vz wsb vy vw wsb wa wa wph vy vw
      wsb vx vz wsb wph vx vz wsb vy vw wsb vz vx weq vw vy weq wa wph vy vw vx
      vz sbcom2 anbi2i vz vx weq vw vy weq wph vx vz wsb vy vw wsb anass bitri
      exbii wph vx vz wsb vw vy weq wph vx vz wsb vy vw wsb wa vw wex vz vx weq
      wph vx vz wsb vy vw wph vx vz vw 2sb5rf.2 hbsb sb5rf anbi2i 3bitr4ri
      exbii bitri $.
      $( [16-May-2005] $) $( [3-Feb-2005] $)

    $( Reversed double substitution. $)
    2sb6rf $p |- ( ph <->
                A. z A. w ( ( z = x /\ w = y ) -> [ z / x ] [ w / y ] ph ) ) $=
      wph vz vx weq wph vx vz wsb wi vz wal vz vx weq vw vy weq wa wph vy vw
      wsb vx vz wsb wi vw wal vz wal wph vx vz 2sb5rf.1 sb6rf vz vx weq wph vx
      vz wsb wi vz vx weq vw vy weq wa wph vy vw wsb vx vz wsb wi vw wal vz vz
      vx weq vw vy weq wph vx vz wsb vy vw wsb wi wi vw wal vz vx weq vw vy weq
      wph vx vz wsb vy vw wsb wi vw wal wi vz vx weq vw vy weq wa wph vy vw wsb
      vx vz wsb wi vw wal vz vx weq wph vx vz wsb wi vz vx weq vw vy weq wph vx
      vz wsb vy vw wsb wi vw 19.21v vz vx weq vw vy weq wa wph vy vw wsb vx vz
      wsb wi vz vx weq vw vy weq wph vx vz wsb vy vw wsb wi wi vw vz vx weq vw
      vy weq wa wph vy vw wsb vx vz wsb wi vz vx weq vw vy weq wa wph vx vz wsb
      vy vw wsb wi vz vx weq vw vy weq wph vx vz wsb vy vw wsb wi wi wph vy vw
      wsb vx vz wsb wph vx vz wsb vy vw wsb vz vx weq vw vy weq wa wph vy vw vx
      vz sbcom2 imbi2i vz vx weq vw vy weq wph vx vz wsb vy vw wsb impexp bitri
      albii wph vx vz wsb vw vy weq wph vx vz wsb vy vw wsb wi vw wal vz vx weq
      wph vx vz wsb vy vw wph vx vz vw 2sb5rf.2 hbsb sb6rf imbi2i 3bitr4ri
      albii bitri $.
      $( [6-Jun-2005] $) $( [3-Feb-2005] $)
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( An alternate definition of proper substitution ~ df-sb .  By
       introducing a dummy variable ` z ` in the definiens, we are able to
       eliminate any distinct variable restrictions among the variables
       ` x ` , ` y ` , and ` ph ` of the definiendum.  No distinct variable
       conflicts arise because ` z ` effectively insulates ` x ` from ` y ` .
       To achieve this, we use a chain of two substitutions in the form of
       ~ sb5 , first ` z ` for ` x ` then ` y ` for ` z ` .  Compare Definition
       2.1'' of [Quine] p. 17, which is obtained from this theorem by applying
       ~ df-clab .  Theorem ~ sb7f provides a version where ` ph ` and ` z `
       don't have to be distinct. $)
    dfsb7 $p |- ( [ y / x ] ph <-> E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      wph vx vz wsb vz vy wsb vx vz weq wph wa vx wex vz vy wsb wph vx vy wsb
      vz vy weq vx vz weq wph wa vx wex wa vz wex wph vx vz wsb vx vz weq wph
      wa vx wex vz vy wph vx vz sb5 sbbii wph vx vy vz wph vz ax-17 sbco2 vx vz
      weq wph wa vx wex vz vy sb5 3bitr3i $.
      $( [29-Jan-2004] $) $( [28-Jan-2004] $)
  $}

  ${
    $d w x z $.  $d w y z $.  $d w ph $.
    sb7f.1 $e |- ( ph -> A. z ph ) $.
    $( This version of ~ dfsb7 does not require that ` ph ` and ` z ` be
       distinct.  This permits it to be used as a definition for substitution
       in a formalization that omits the logically redundant axiom ~ ax-17
       i.e. that doesn't have the concept of a variable not occurring in a
       wff.  ( ~ df-sb is also suitable, but its mixing of free and bound
       variables is distasteful to some logicians.) $)
    sb7f $p |- ( [ y / x ] ph <->
               E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      wph vx vy wsb vw vy weq vx vw weq wph wa vx wex wa vw wex vz vy weq vx vz
      weq wph wa vx wex wa vz wex wph vx vy vw dfsb7 vw vy weq vx vw weq wph wa
      vx wex wa vz vy weq vx vz weq wph wa vx wex wa vw vz vw vy weq vx vw weq
      wph wa vx wex vz vw vy weq vz ax-17 vx vw weq wph wa vz vx vx vw weq wph
      vz vx vw weq vz ax-17 sb7f.1 hban hbex hban vz vy weq vx vz weq wph wa vx
      wex wa vw ax-17 vw vz weq vw vy weq vz vy weq vx vw weq wph wa vx wex vx
      vz weq wph wa vx wex vw vz vy equequ1 vw vz weq vx vw weq wph wa vx vz
      weq wph wa vx vw vz weq vx vw weq vx vz weq wph vw vz vx equequ2 anbi1d
      exbidv anbi12d cbvex bitri $.
      $( [4-Aug-2006] $) $( [26-Jul-2006] $)
  $}

  ${
    $d x y $.
    sb10f.1 $e |- ( ph -> A. x ph ) $.
    $( Hao Wang's identity axiom P6 in Irving Copi, _Symbolic Logic_ (5th ed.,
       1979), p. 328.  In traditional predicate calculus, this is a sole
       axiom for identity from which the usual ones can be derived. $)
    sb10f $p |- ( [ y / z ] ph <-> E. x ( x = y /\ [ x / z ] ph ) ) $=
      vx vy weq wph vz vx wsb wa vx wex wph vz vy wsb wph vz vx wsb wph vz vy
      wsb vx vy wph vz vy vx sb10f.1 hbsb wph vx vy vz sbequ equsex bicomi $.
      $( [9-May-2005] $) $( [9-May-2005] $)
  $}

  ${
    $d x ph $.
    $( An identity law for substitution.  Used in proof of Theorem 9.7 of
       [Megill] p. 449 (p. 16 of the preprint). $)
    sbid2v $p |- ( [ y / x ] [ x / y ] ph <-> ph ) $=
      wph vx vy wph vx ax-17 sbid2 $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d x ph $.
    $( Elimination of substitution. $)
    sbelx $p |- ( ph <-> E. x ( x = y /\ [ x / y ] ph ) ) $=
      wph wph vy vx wsb vx vy wsb vx vy weq wph vy vx wsb wa vx wex wph vx vy
      sbid2v wph vy vx wsb vx vy sb5 bitr3i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $( Note:  A more general case could also be proved with
       "$d x z $.  $d y w $.  $d x ph $.  $d y ph $.", but with more
       difficulty. $)
    $d x y z $.  $d w y $.  $d x y ph $.
    $( Elimination of double substitution. $)
    sbel2x $p |- ( ph <-> E. x E. y ( ( x = z /\ y = w ) /\
                     [ y / w ] [ x / z ] ph ) ) $=
      wph vx vz weq vy vw weq wph vz vx wsb vw vy wsb wa wa vy wex vx wex vx vz
      weq vy vw weq wa wph vz vx wsb vw vy wsb wa vy wex vx wex vx vz weq wph
      vz vx wsb wa vx wex vx vz weq vy vw weq wph vz vx wsb vw vy wsb wa vy wex
      wa vx wex wph vx vz weq vy vw weq wph vz vx wsb vw vy wsb wa wa vy wex vx
      wex vx vz weq wph vz vx wsb wa vx vz weq vy vw weq wph vz vx wsb vw vy
      wsb wa vy wex wa vx wph vz vx wsb vy vw weq wph vz vx wsb vw vy wsb wa vy
      wex vx vz weq wph vz vx wsb vy vw sbelx anbi2i exbii wph vx vz sbelx vx
      vz weq vy vw weq wph vz vx wsb vw vy wsb wa vx vy exdistr 3bitr4i vx vz
      weq vy vw weq wa wph vz vx wsb vw vy wsb wa vx vz weq vy vw weq wph vz vx
      wsb vw vy wsb wa wa vx vy vx vz weq vy vw weq wph vz vx wsb vw vy wsb
      anass 2exbii bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.
    $( A theorem used in elimination of disjoint variable restriction on ` x `
       and ` y ` by replacing it with a distinctor ` -. A. x x = z ` . $)
    sbal1 $p |- ( -. A. x x = z ->
             ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) ) $=
      vy vz weq vy wal vx vz weq vx wal wn wph vx wal vy vz wsb wph vy vz wsb
      vx wal wb wi vy vz weq vy wal wph vx wal vy vz wsb wph vy vz wsb vx wal
      wb vx vz weq vx wal wn vy vz weq vy wal wph vx wal wph vx wal vy vz wsb
      wph vy vz wsb vx wal vy vz weq wph vx wal wph vx wal vy vz wsb wb vy wph
      vx wal vy vz sbequ12 a4s wph wph vy vz wsb vy vz vx vy vz weq wph wph vy
      vz wsb wb vy wph vy vz sbequ12 a4s dral2 bitr3d a1d vy vz weq vy wal wn
      vx vz weq vx wal wn wph vx wal vy vz wsb wph vy vz wsb vx wal wb vy vz
      weq vy wal wn vx vz weq vx wal wn wa wph vx wal vy vz wsb wph vy vz wsb
      vx wal vx vz weq vx wal wn wph vx wal vy vz wsb wph vy vz wsb vx wal wi
      vy vz weq vy wal wn vx vz weq vx wal wn wph vx wal vy vz wsb wph vx wal
      vy vz wsb vx wal wph vy vz wsb vx wal wph vx wal vy vz vx wph vx hba1
      hbsb4 wph vx wal vy vz wsb wph vy vz wsb vx wph vx wal wph vy vz wph vx
      ax-4 sbimi 19.20i syl6 adantl vy vz weq vy wal wn wph vy vz wsb vx wal vy
      vz weq wph wi vx wal vy wal vx vz weq vx wal wn wph vx wal vy vz wsb vy
      vz weq vy wal wn wph vy vz wsb vx wal vy vz weq wph wi vy wal vx wal vy
      vz weq wph wi vx wal vy wal wph vy vz wsb vx wal vy vz weq wph wi vy wal
      vx wal wi vy vz vx vy vz weq vy wal wn wph vy vz wsb vy vz weq wph wi vy
      wal vx wph vy vz sb4 19.20ii hbnaes vy vz weq wph wi vx vy ax-7 syl6 vy
      vz weq wph wi vx wal vy wal wph vx wal vy vz wsb wi vx vz vy vx vz weq vx
      wal wn vy wal vy vz weq wph wi vx wal vy wal vy vz weq wph vx wal wi vy
      wal wph vx wal vy vz wsb vx vz weq vx wal wn vy vz weq wph wi vx wal vy
      vz weq wph vx wal wi vy vx vz weq vx wal wn vy vz weq vy vz weq vx wal vy
      vz weq wph wi vx wal wph vx wal vx vy weq vx wal vx vz weq vx wal wn vy
      vz weq vy vz weq vx wal wi wi vx vy weq vx wal vy vz weq vy vz weq vx wal
      wi vx vz weq vx wal wn vy vz weq vx vy ax-16 a1d vy vz vx ax-12 pm2.61i
      vy vz weq wph vx 19.20 syl9 19.20ii wph vx wal vy vz sb2 syl6 hbnaes
      sylan9 impbid ex pm2.61i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d x z $.
    $( Move universal quantifier in and out of substitution. $)
    sbal $p |- ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) $=
      vx vz weq vx wal wph vx wal vy vz wsb wph vy vz wsb vx wal wb vx vz weq
      vx wal wph vy vz wsb wph vx wal vy vz wsb wph vy vz wsb vx wal vx vz weq
      vx wal vy vz wsb wph wph vx wal wb vy vz wsb vx vz weq vx wal wph vy vz
      wsb wph vx wal vy vz wsb wb vx vz weq vx wal wph wph vx wal wb vy vz wph
      vx vz vx a16gb sbimi vx vz vy vz sbequ5 wph wph vx wal vy vz sbbi 3imtr3i
      wph vy vz wsb vx vz vx a16gb bitr3d wph vx vy vz sbal1 pm2.61i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d x z $.
    $( Move existential quantifier in and out of substitution. $)
    sbex $p |- ( [ z / y ] E. x ph <-> E. x [ z / y ] ph ) $=
      wph wn vx wal wn vy vz wsb wph vy vz wsb wn vx wal wn wph vx wex vy vz
      wsb wph vy vz wsb vx wex wph wn vx wal wn vy vz wsb wph wn vx wal vy vz
      wsb wn wph vy vz wsb wn vx wal wn wph wn vx wal vy vz sbn wph wn vx wal
      vy vz wsb wph vy vz wsb wn vx wal wph wn vx wal vy vz wsb wph wn vy vz
      wsb vx wal wph vy vz wsb wn vx wal wph wn vx vy vz sbal wph wn vy vz wsb
      wph vy vz wsb wn vx wph vy vz sbn albii bitri notbii bitri wph vx wex wph
      wn vx wal wn vy vz wph vx df-ex sbbii wph vy vz wsb vx df-ex 3bitr4i $.
      $( [27-Sep-2003] $)
  $}

  ${
    $d x z $.  $d y z $.
    sbalv.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Quantify with new variable inside substitution. $)
    sbalv $p |- ( [ y / x ] A. z ph <-> A. z ps ) $=
      wph vz wal vx vy wsb wph vx vy wsb vz wal wps vz wal wph vz vx vy sbal
      wph vx vy wsb wps vz sbalv.1 albii bitri $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( An equivalent expression for existence. $)
    exsb $p |- ( E. x ph <-> E. y A. x ( x = y -> ph ) ) $=
      wph vx wex wph vx vy wsb vy wex vx vy weq wph wi vx wal vy wex wph vx vy
      wph vy ax-17 sb8e wph vx vy wsb vx vy weq wph wi vx wal vy wph vx vy sb6
      exbii bitri $.
      $( [12-Feb-2005] $) $( [2-Feb-2005] $)
  $}

  ${
    $d x y z $.  $d y w $.  $d z w ph $.
    $( An equivalent expression for double existence. $)
    2exsb $p |- ( E. x E. y ph <->
                  E. z E. w A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      wph vy wex vx wex vy vw weq wph wi vy wal vx wex vw wex vx vz weq vy vw
      weq wa wph wi vy wal vx wal vz wex vw wex vx vz weq vy vw weq wa wph wi
      vy wal vx wal vw wex vz wex wph vy wex vx wex vy vw weq wph wi vy wal vw
      wex vx wex vy vw weq wph wi vy wal vx wex vw wex wph vy wex vy vw weq wph
      wi vy wal vw wex vx wph vy vw exsb exbii vy vw weq wph wi vy wal vx vw
      excom bitri vy vw weq wph wi vy wal vx wex vx vz weq vy vw weq wa wph wi
      vy wal vx wal vz wex vw vy vw weq wph wi vy wal vx wex vx vz weq vy vw
      weq wph wi vy wal wi vx wal vz wex vx vz weq vy vw weq wa wph wi vy wal
      vx wal vz wex vy vw weq wph wi vy wal vx vz exsb vx vz weq vy vw weq wph
      wi vy wal wi vx wal vx vz weq vy vw weq wa wph wi vy wal vx wal vz vx vz
      weq vy vw weq wph wi vy wal wi vx vz weq vy vw weq wa wph wi vy wal vx vx
      vz weq vy vw weq wa wph wi vy wal vx vz weq vy vw weq wph wi wi vy wal vx
      vz weq vy vw weq wph wi vy wal wi vx vz weq vy vw weq wa wph wi vx vz weq
      vy vw weq wph wi wi vy vx vz weq vy vw weq wph impexp albii vx vz weq vy
      vw weq wph wi vy 19.21v bitr2i albii exbii bitri exbii vx vz weq vy vw
      weq wa wph wi vy wal vx wal vw vz excom 3bitri $.
      $( [12-Feb-2005] $) $( [2-Feb-2005] $)
  $}

  ${
    $d z ps $.
    dvelim.1 $e |- ( ph -> A. x ph ) $.
    dvelim.2 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( This theorem can be used to eliminate a distinct variable restriction on
       ` x ` and ` z ` and replace it with the "distinctor" ` -. A. x x = y `
       as an antecedent.  ` ph ` normally has ` z ` free and can be read
       ` ph ( z ) ` , and ` ps ` substitutes ` y ` for ` z ` and can be read
       ` ph ( y ) ` .  We don't require that ` x ` and ` y ` be distinct: if
       they aren't, the distinctor will become false (in multiple-element
       domains of discourse) and "protect" the consequent.

       To obtain a closed-theorem form of this inference, prefix the hypotheses
       with ` A. x A. z ` , conjoin them, and apply ~ dvelimdf .

       Other variants of this theorem are ~ dvelimf (with no distinct variable
       restrictions),  ~ dvelimfALT (that avoids ~ ax-11 ), and ~ dvelimALT
       (that avoids ~ ax-10 ). $)
    dvelim $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      wph wps vx vy vz dvelim.1 wps vz ax-17 dvelim.2 dvelimf $.
      $( [23-Nov-1994] $)
  $}

  ${
    $d z ps $.  $d x z $.  $d y z $.
    dvelimALT.1 $e |- ( ph -> A. x ph ) $.
    dvelimALT.2 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelim that doesn't use ~ ax-10 .  (See ~ dvelimfALT for a
       version that doesn't use ~ ax-11 .) $)
    dvelimALT $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      vx vy weq vx wal wn vz vy weq wph wi vz wal vz vy weq wph wi vz wal vx
      wal wps wps vx wal vx vy weq vx wal wn vz vy weq wph wi vx vz vx vy weq
      vx wal wn vz ax-17 vx vz weq vx wal vx vy weq vx wal wn vz vy weq wph wi
      vz vy weq wph wi vx wal wi wi vx vz weq vx wal vz vy weq wph wi vz vy weq
      wph wi vx wal wi vx vy weq vx wal wn vx vz weq vx wal vz vy weq wph vx vx
      vz weq vx hba1 vz vy weq vx vz ax16ALT wph wph vx wal wi vx vz weq vx wal
      dvelimALT.1 a1i hbimd a1d vx vz weq vx wal wn vx vy weq vx wal wn vz vy
      weq wph wi vz vy weq wph wi vx wal wi vx vz weq vx wal wn vx vy weq vx
      wal wn wa vz vy weq wph vx vx vz weq vx wal wn vx vy weq vx wal wn vx vx
      vz weq vx wal vx vx vz weq vx hba1 hbn vx vy weq vx wal vx vx vy weq vx
      hba1 hbn hban vx vz weq vx wal wn vx vy weq vx wal wn vz vy weq vz vy weq
      vx wal wi vz vy vx ax-12 imp wph wph vx wal wi vx vz weq vx wal wn vx vy
      weq vx wal wn wa dvelimALT.1 a1i hbimd ex pm2.61i hbald wph wps vz vy wps
      vz ax-17 dvelimALT.2 equsal vz vy weq wph wi vz wal wps vx wph wps vz vy
      wps vz ax-17 dvelimALT.2 equsal albii 3imtr3g $.
      $( [15-Jun-2008] $) $( [17-May-2008] $)
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct. $)
    dveeq1 $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      vw vz weq vy vz weq vx vy vw vw vz weq vx ax-17 vy vz weq vw ax-17 vw vy
      vz equequ1 dvelimfALT $.
      $( [2-Jan-2002] $)

    $( Version of ~ dveeq1 using ~ ax-16 instead of ~ ax-17 . $)
    dveeq1ALT $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      vw vz weq vy vz weq vx vy vw vw vz vx ax17eq vy vz vw ax17eq vw vy vz
      equequ1 dvelimfALT $.
      $( [20-Jun-2008] $) $( [29-Apr-2008] $)
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct. $)
    dveel1 $p |- ( -. A. x x = y -> ( y e. z -> A. x y e. z ) ) $=
      vw vz wel vy vz wel vx vy vw vw vz wel vx ax-17 vy vz wel vw ax-17 vw vy
      vz elequ1 dvelimfALT $.
      $( [2-Jan-2002] $)
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct. $)
    dveel2 $p |- ( -. A. x x = y -> ( z e. y -> A. x z e. y ) ) $=
      vz vw wel vz vy wel vx vy vw vz vw wel vx ax-17 vz vy wel vw ax-17 vw vy
      vz elequ2 dvelimfALT $.
      $( [2-Jan-2002] $)
  $}

  ${
    $d z y $.  $d z x $.
    $( Move quantifier in and out of substitution. $)
    sbal2 $p |- ( -. A. x x = y ->
             ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) ) $=
      vx vy weq vx wal wn vy vz weq wph vx wal wi vy wal vy vz weq wph wi vy
      wal vx wal wph vx wal vy vz wsb wph vy vz wsb vx wal vx vy weq vx wal wn
      vy vz weq wph wi vx wal vy wal vy vz weq wph vx wal wi vy wal vy vz weq
      wph wi vy wal vx wal vx vy weq vx wal wn vy vz weq wph wi vx wal vy vz
      weq wph vx wal wi vy vx vy vy hbnae vx vy weq vx wal wn vy vz weq vy vz
      weq vx wal wi vx wal vy vz weq wph wi vx wal vy vz weq wph vx wal wi wb
      vy vz weq vy vz weq vx wal wi vx wal vx vy vx vx vy weq vx wal wn vy vz
      weq vy vz weq vx wal wi vx vx vy vz dveeq1 19.20i hbnaes vy vz weq wph vx
      19.21t syl albid vy vz weq wph wi vy vx alcom syl5rbbr wph vx wal vy vz
      sb6 wph vy vz wsb vy vz weq wph wi vy wal vx wph vy vz sb6 albii 3bitr4g
      $.
      $( [2-Jan-2002] $)
  $}

  ${
    $d w y $.  $d w z $.  $d w x $.  $( ` w ` is dummy. $)
    $( Axiom ~ ax-15 is redundant if we assume ~ ax-17 .  Remark 9.6 in
       [Megill] p. 448 (p. 16 of the preprint), regarding axiom scheme C14'.

       Note that ` w ` is a dummy variable introduced in the proof.  On the
       web page, it is implicitly assumed to be distinct from all other
       variables.  (This is made explicit in the database file set.mm).  Its
       purpose is to satisfy the distinct variable requirements of ~ dveel2 and
       ~ ax-17 .  By the end of the proof it has vanished, and the final
       theorem has no distinct variable requirements.

       This theorem should not be referenced in any proof.  Instead, use
       ~ ax-15 below so that theorems needing ~ ax-15 can be more easily
       identified. $)
    ax15 $p |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x e. y -> A. z x e. y ) ) ) $=
      vz vx weq vz wal wn vz vy weq vz wal wn vx vy wel vx vy wel vz wal vz vx
      weq vz wal wn vz vy weq vz wal wn vx vy wel wi vz vy weq vz wal wn vx vy
      wel wi vz wal vz vy weq vz wal wn vx vy wel vz wal wi vz vy weq vz wal wn
      vw vy wel wi vz vy weq vz wal wn vx vy wel wi vz vx vw vz vy weq vz wal
      wn vw vy wel vz vz vy weq vz hbn1 vz vy vw dveel2 hbim1 vz vy weq vz wal
      wn vx vy wel wi vw ax-17 vw vx weq vw vy wel vx vy wel vz vy weq vz wal
      wn vw vx vy elequ1 imbi2d dvelimfALT vz vy weq vz wal wn vx vy wel vz vz
      vy weq vz hbn1 19.21 syl6ib pm2.86d $.
      $( [29-Jun-1995] $)
  $}

  $( Axiom of Quantifier Introduction.  One of the equality and substitution
     axioms for a non-logical predicate in our predicate calculus with
     equality.  Axiom scheme C14' in [Megill] p. 448 (p. 16 of the preprint).
     It is redundant if we include ~ ax-17 ; see theorem ~ ax15 .  Alternately,
     ~ ax-17 becomes unnecessary in principle with this axiom, but we lose the
     more powerful metalogic afforded by ~ ax-17 .  We retain ~ ax-15 here to
     provide completeness for systems with the simpler metalogic that results
     from omitting ~ ax-17 , which might be easier to study for some
     theoretical purposes. $)
  ax-15 $a |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x e. y -> A. z x e. y ) ) ) $.

  ${
    $d x z $.  $d y z $.
    $( Theorem to add distinct quantifier to atomic formula.  This theorem
       demonstrates the induction basis for ~ ax-17 considered as a
       metatheorem.) $)
    ax17el $p |- ( x e. y -> A. z x e. y ) $=
      vz vx weq vz wal vz vy weq vz wal vx vy wel vx vy wel vz wal wi vx vy vz
      ax-15 vx vy wel vz vx ax-16 vx vy wel vz vy ax-16 pm2.61ii $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d w z x $.  $d w y $.
    $( Version of ~ dveel2 using ~ ax-16 instead of ~ ax-17 . $)
    dveel2ALT $p |- ( -. A. x x = y -> ( z e. y -> A. x z e. y ) ) $=
      vz vw wel vz vy wel vx vy vw vz vw vx ax17el vz vy vw ax17el vw vy vz
      elequ2 dvelimfALT $.
      $( [10-May-2008] $) $( [10-May-2008] $)
  $}

  ${
    $d x u v $.  $d y u v $.  $d z u v $.  $d w u v $.
    $( Basis step for constructing a substitution instance of ~ ax-11o without
       using ~ ax-11o .  Atomic formula for equality predicate. $)
    ax11eq $p |- ( -. A. x x = y ->
               ( x = y -> ( z = w -> A. x ( x = y -> z = w ) ) ) ) $=
      vx vz weq vx wal vx vw weq vx wal vx vy weq vx wal wn vx vy weq vz vw weq
      vx vy weq vz vw weq wi vx wal wi wi wi vx vz weq vx wal vx vw weq vx wal
      wa vx vz weq vx vw weq wa vx wal vx vy weq vx wal wn vx vy weq vz vw weq
      vx vy weq vz vw weq wi vx wal wi wi wi vx vz weq vx vw weq vx 19.26 vx vz
      weq vx vw weq wa vx wal vx vy weq vx wal wn vx vy weq vz vw weq vx vy weq
      vz vw weq wi vx wal wi vx vz weq vx vw weq wa vx wal vx vy weq vx wal wn
      vx vy weq wa wa vx vx weq vx vy weq vx vx weq wi vx wal wi vz vw weq vx
      vy weq vz vw weq wi vx wal wi vx vy weq vx vx weq wi vx wal vx vx weq vx
      vy weq vx vx weq wi vx vx vx weq vx vy weq vx equid a1i ax-gen a1i vx vz
      weq vx vw weq wa vx wal vx vx weq vx vy weq vx vx weq wi vx wal wi vz vw
      weq vx vy weq vz vw weq wi vx wal wi wb vx vy weq vx wal wn vx vy weq wa
      vx vz weq vx vw weq wa vx wal vx vx weq vz vw weq vx vy weq vx vx weq wi
      vx wal vx vy weq vz vw weq wi vx wal vx vz weq vx vw weq wa vx vx weq vz
      vw weq wb vx vx vz weq vx vx weq vz vx weq vx vw weq vz vw weq vx vz vx
      equequ1 vx vw vz equequ2 sylan9bb a4s vx vz weq vx vw weq wa vx wal vx vy
      weq vx vx weq wi vx vy weq vz vw weq wi vx vx vz weq vx vw weq wa vx hba1
      vx vz weq vx vw weq wa vx wal vx vx weq vz vw weq vx vy weq vx vz weq vx
      vw weq wa vx vx weq vz vw weq wb vx vx vz weq vx vx weq vz vx weq vx vw
      weq vz vw weq vx vz vx equequ1 vx vw vz equequ2 sylan9bb a4s imbi2d albid
      imbi12d adantr mpbii exp32 sylbir vx vz weq vx wal vx vw weq vx wal wn wa
      vx vy weq vx wal wn vx vy weq vz vw weq vx vy weq vz vw weq wi vx wal wi
      vx vz weq vx wal vx vw weq vx wal wn wa vx vy weq vx wal wn vx vy weq wa
      wa vx vw weq vx vy weq vx vw weq wi vx wal wi vz vw weq vx vy weq vz vw
      weq wi vx wal wi vx vw weq vx wal wn vx vy weq vx wal wn vx vy weq wa vx
      vw weq vx vy weq vx vw weq wi vx wal wi vx vz weq vx wal vx vw weq vx wal
      wn vx vy weq vx wal wn vx vy weq wa wa vx vw weq vy vw weq vx vy weq vx
      vw weq wi vx wal vx vy weq vx vw weq vy vw weq wb vx vw weq vx wal wn vx
      vy weq vx wal wn vx vy vw equequ1 ad2antll vx vw weq vx wal wn vx vy weq
      vx wal wn vx vy weq wa wa vy vw weq vy vw weq vx wal vx vy weq vx vw weq
      wi vx wal vx vw weq vx wal wn vx vy weq vx wal wn vy vw weq vy vw weq vx
      wal wi vx vy weq vx vy weq vx wal wn vx vw weq vx wal wn vy vw weq vy vw
      weq vx wal wi vy vw vx ax-12 impcom adantrr vy vw weq vx vy weq vx vw weq
      wi vx vy vw vx equtrr 19.20i syl6 sylbid adantll vx vz weq vx wal vx vw
      weq vx vy weq vx vw weq wi vx wal wi vz vw weq vx vy weq vz vw weq wi vx
      wal wi wb vx vw weq vx wal wn vx vy weq vx wal wn vx vy weq wa vx vz weq
      vx wal vx vw weq vz vw weq vx vy weq vx vw weq wi vx wal vx vy weq vz vw
      weq wi vx wal vx vz weq vx vw weq vz vw weq wb vx vx vz vw equequ1 a4s vx
      vy weq vx vw weq wi vx vy weq vz vw weq wi vx vz vx vx vz weq vx wal vx
      vw weq vz vw weq vx vy weq vx vz weq vx vw weq vz vw weq wb vx vx vz vw
      equequ1 a4s imbi2d dral2 imbi12d ad2antrr mpbid exp32 vx vz weq vx wal wn
      vx vw weq vx wal wa vx vy weq vx wal wn vx vy weq vz vw weq vx vy weq vz
      vw weq wi vx wal wi vx vz weq vx wal wn vx vw weq vx wal wa vx vy weq vx
      wal wn vx vy weq wa wa vz vx weq vx vy weq vz vx weq wi vx wal wi vz vw
      weq vx vy weq vz vw weq wi vx wal wi vx vz weq vx wal wn vx vy weq vx wal
      wn vx vy weq wa vz vx weq vx vy weq vz vx weq wi vx wal wi vx vw weq vx
      wal vx vz weq vx wal wn vx vy weq vx wal wn vx vy weq wa wa vz vx weq vz
      vy weq vx vy weq vz vx weq wi vx wal vx vy weq vz vx weq vz vy weq wb vx
      vz weq vx wal wn vx vy weq vx wal wn vx vy vz equequ2 ad2antll vx vz weq
      vx wal wn vx vy weq vx wal wn vx vy weq wa wa vz vy weq vz vy weq vx wal
      vx vy weq vz vx weq wi vx wal vx vz weq vx wal wn vx vy weq vx wal wn vz
      vy weq vz vy weq vx wal wi vx vy weq vx vz weq vx wal wn vx vy weq vx wal
      wn vz vy weq vz vy weq vx wal wi vz vy vx ax-12 imp adantrr vz vy weq vx
      vy weq vz vx weq wi vx vx vy weq vz vx weq vz vy weq vx vy vz equequ2
      biimprcd 19.20i syl6 sylbid adantlr vx vw weq vx wal vz vx weq vx vy weq
      vz vx weq wi vx wal wi vz vw weq vx vy weq vz vw weq wi vx wal wi wb vx
      vz weq vx wal wn vx vy weq vx wal wn vx vy weq wa vx vw weq vx wal vz vx
      weq vz vw weq vx vy weq vz vx weq wi vx wal vx vy weq vz vw weq wi vx wal
      vx vw weq vz vx weq vz vw weq wb vx vx vw vz equequ2 a4s vx vy weq vz vx
      weq wi vx vy weq vz vw weq wi vx vw vx vx vw weq vx wal vz vx weq vz vw
      weq vx vy weq vx vw weq vz vx weq vz vw weq wb vx vx vw vz equequ2 a4s
      imbi2d dral2 imbi12d ad2antlr mpbid exp32 vx vz weq vx wal wn vx vw weq
      vx wal wn wa vx vy weq vz vw weq vx vy weq vz vw weq wi vx wal wi wi vx
      vy weq vx wal wn vx vz weq vx wal wn vx vw weq vx wal wn wa vz vw weq vx
      vy weq vz vw weq wi vx wal wi vx vy weq vx vz weq vx wal wn vx vw weq vx
      wal wn wa vu vw weq vu wex vz vw weq vx vy weq vz vw weq wi vx wal wi vu
      vw a9e vx vz weq vx wal wn vx vw weq vx wal wn wa vu vw weq vz vw weq vx
      vy weq vz vw weq wi vx wal wi vu vx vz weq vx wal wn vx vw weq vx wal wn
      wa vv vz weq vv wex vu vw weq vz vw weq vx vy weq vz vw weq wi vx wal wi
      wi vv vz a9e vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu vw
      weq vz vw weq vx vy weq vz vw weq wi vx wal wi wi vv vx vz weq vx wal wn
      vx vw weq vx wal wn wa vv vz weq vu vw weq vz vw weq vx vy weq vz vw weq
      wi vx wal wi vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu vw
      weq wa wa vv vu weq vx vy weq vv vu weq wi vx wal wi vz vw weq vx vy weq
      vz vw weq wi vx wal wi vv vu weq vx vy weq vv vu weq wi vx vv vu weq vx
      vy weq ax-1 19.21aiv vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq
      vu vw weq wa wa vv vu weq vz vw weq vx vy weq vv vu weq wi vx wal vx vy
      weq vz vw weq wi vx wal vv vz weq vu vw weq wa vv vu weq vz vw weq wb vx
      vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vv vu weq vz vu weq vu
      vw weq vz vw weq vv vz vu equequ1 vu vw vz equequ2 sylan9bb adantl vx vz
      weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu vw weq wa wa vv vz weq
      vu vw weq wa vx wal vx vy weq vv vu weq wi vx wal vx vy weq vz vw weq wi
      vx wal wb vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu vw weq
      wa wa vv vz weq vx wal vu vw weq vx wal wa vv vz weq vu vw weq wa vx wal
      vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu vw weq wa vv vz
      weq vx wal vu vw weq vx wal wa vx vz weq vx wal wn vv vz weq vv vz weq vx
      wal vx vw weq vx wal wn vu vw weq vu vw weq vx wal vx vz vv dveeq2 vx vw
      vu dveeq2 im2anan9 imp vv vz weq vu vw weq vx 19.26 sylibr vv vz weq vu
      vw weq wa vx wal vx vy weq vv vu weq wi vx vy weq vz vw weq wi vx vv vz
      weq vu vw weq wa vx hba1 vv vz weq vu vw weq wa vx wal vv vu weq vz vw
      weq vx vy weq vv vz weq vu vw weq wa vv vu weq vz vw weq wb vx vv vz weq
      vv vu weq vz vu weq vu vw weq vz vw weq vv vz vu equequ1 vu vw vz equequ2
      sylan9bb a4s imbi2d albid syl imbi12d mpbii exp32 19.23adv mpi 19.23adv
      mpi a1d a1d 4cases $.
      $( [22-Jan-2007] $) $( [22-Jan-2007] $)
  $}

  ${
    $d x u v $.  $d y u v $.  $d z u v $.  $d w u v $.
    $( Basis step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Atomic formula for membership predicate. $)
    ax11el $p |- ( -. A. x x = y ->
               ( x = y -> ( z e. w -> A. x ( x = y -> z e. w ) ) ) ) $=
      vx vz weq vx wal vx vw weq vx wal vx vy weq vx wal wn vx vy weq vz vw wel
      vx vy weq vz vw wel wi vx wal wi wi wi vx vz weq vx wal vx vw weq vx wal
      wa vx vz weq vx vw weq wa vx wal vx vy weq vx wal wn vx vy weq vz vw wel
      vx vy weq vz vw wel wi vx wal wi wi wi vx vz weq vx vw weq vx 19.26 vx vz
      weq vx vw weq wa vx wal vx vy weq vx wal wn vx vy weq vz vw wel vx vy weq
      vz vw wel wi vx wal wi vx vz weq vx vw weq wa vx wal vx vy weq vx wal wn
      vx vy weq wa wa vx vx wel vx vy weq vx vx wel wi vx wal wi vz vw wel vx
      vy weq vz vw wel wi vx wal wi vx vy weq vx wal wn vx vy weq wa vx vx wel
      vx vy weq vx vx wel wi vx wal wi vx vz weq vx vw weq wa vx wal vx vy weq
      vx wal wn vx vy weq wa vx vx wel vy vy wel vx vy weq vx vx wel wi vx wal
      vx vy weq vx vx wel vy vy wel wb vx vy weq vx wal wn vx vy weq vx vx wel
      vy vx wel vy vy wel vx vy vx elequ1 vx vy vy elequ2 bitrd adantl vx vy
      weq vx wal wn vy vy wel vx vy weq vx vx wel wi vx wal wi vx vy weq vx vy
      weq vx wal wn vy vy wel vy vy wel vx wal vx vy weq vx vx wel wi vx wal vv
      vv wel vy vy wel vx vy vv vv vv wel vx ax-17 vy vy wel vv ax-17 vv vy weq
      vv vv wel vy vv wel vy vy wel vv vy vv elequ1 vv vy vy elequ2 bitrd
      dvelimfALT vy vy wel vx vy weq vx vx wel wi vx vx vy weq vx vx wel vy vy
      wel vx vy weq vx vx wel vy vx wel vy vy wel vx vy vx elequ1 vx vy vy
      elequ2 bitrd biimprcd 19.20i syl6 adantr sylbid adantl vx vz weq vx vw
      weq wa vx wal vx vx wel vx vy weq vx vx wel wi vx wal wi vz vw wel vx vy
      weq vz vw wel wi vx wal wi wb vx vy weq vx wal wn vx vy weq wa vx vz weq
      vx vw weq wa vx wal vx vx wel vz vw wel vx vy weq vx vx wel wi vx wal vx
      vy weq vz vw wel wi vx wal vx vz weq vx vw weq wa vx vx wel vz vw wel wb
      vx vx vz weq vx vx wel vz vx wel vx vw weq vz vw wel vx vz vx elequ1 vx
      vw vz elequ2 sylan9bb a4s vx vz weq vx vw weq wa vx wal vx vy weq vx vx
      wel wi vx vy weq vz vw wel wi vx vx vz weq vx vw weq wa vx hba1 vx vz weq
      vx vw weq wa vx wal vx vx wel vz vw wel vx vy weq vx vz weq vx vw weq wa
      vx vx wel vz vw wel wb vx vx vz weq vx vx wel vz vx wel vx vw weq vz vw
      wel vx vz vx elequ1 vx vw vz elequ2 sylan9bb a4s imbi2d albid imbi12d
      adantr mpbid exp32 sylbir vx vz weq vx wal vx vw weq vx wal wn wa vx vy
      weq vx wal wn vx vy weq vz vw wel vx vy weq vz vw wel wi vx wal wi vx vz
      weq vx wal vx vw weq vx wal wn wa vx vy weq vx wal wn vx vy weq wa wa vx
      vw wel vx vy weq vx vw wel wi vx wal wi vz vw wel vx vy weq vz vw wel wi
      vx wal wi vx vw weq vx wal wn vx vy weq vx wal wn vx vy weq wa vx vw wel
      vx vy weq vx vw wel wi vx wal wi vx vz weq vx wal vx vw weq vx wal wn vx
      vy weq vx wal wn vx vy weq wa wa vx vw wel vy vw wel vx vy weq vx vw wel
      wi vx wal vx vy weq vx vw wel vy vw wel wb vx vw weq vx wal wn vx vy weq
      vx wal wn vx vy vw elequ1 ad2antll vx vw weq vx wal wn vx vy weq vx wal
      wn vx vy weq wa wa vy vw wel vy vw wel vx wal vx vy weq vx vw wel wi vx
      wal vx vw weq vx wal wn vx vy weq vx wal wn vy vw wel vy vw wel vx wal wi
      vx vy weq vx vy weq vx wal wn vx vw weq vx wal wn vy vw wel vy vw wel vx
      wal wi vy vw vx ax-15 impcom adantrr vy vw wel vx vy weq vx vw wel wi vx
      vx vy weq vx vw wel vy vw wel vx vy vw elequ1 biimprcd 19.20i syl6 sylbid
      adantll vx vz weq vx wal vx vw wel vx vy weq vx vw wel wi vx wal wi vz vw
      wel vx vy weq vz vw wel wi vx wal wi wb vx vw weq vx wal wn vx vy weq vx
      wal wn vx vy weq wa vx vz weq vx wal vx vw wel vz vw wel vx vy weq vx vw
      wel wi vx wal vx vy weq vz vw wel wi vx wal vx vz weq vx vw wel vz vw wel
      wb vx vx vz vw elequ1 a4s vx vy weq vx vw wel wi vx vy weq vz vw wel wi
      vx vz vx vx vz weq vx wal vx vw wel vz vw wel vx vy weq vx vz weq vx vw
      wel vz vw wel wb vx vx vz vw elequ1 a4s imbi2d dral2 imbi12d ad2antrr
      mpbid exp32 vx vz weq vx wal wn vx vw weq vx wal wa vx vy weq vx wal wn
      vx vy weq vz vw wel vx vy weq vz vw wel wi vx wal wi vx vz weq vx wal wn
      vx vw weq vx wal wa vx vy weq vx wal wn vx vy weq wa wa vz vx wel vx vy
      weq vz vx wel wi vx wal wi vz vw wel vx vy weq vz vw wel wi vx wal wi vx
      vz weq vx wal wn vx vy weq vx wal wn vx vy weq wa vz vx wel vx vy weq vz
      vx wel wi vx wal wi vx vw weq vx wal vx vz weq vx wal wn vx vy weq vx wal
      wn vx vy weq wa wa vz vx wel vz vy wel vx vy weq vz vx wel wi vx wal vx
      vy weq vz vx wel vz vy wel wb vx vz weq vx wal wn vx vy weq vx wal wn vx
      vy vz elequ2 ad2antll vx vz weq vx wal wn vx vy weq vx wal wn vx vy weq
      wa wa vz vy wel vz vy wel vx wal vx vy weq vz vx wel wi vx wal vx vz weq
      vx wal wn vx vy weq vx wal wn vz vy wel vz vy wel vx wal wi vx vy weq vx
      vz weq vx wal wn vx vy weq vx wal wn vz vy wel vz vy wel vx wal wi vz vy
      vx ax-15 imp adantrr vz vy wel vx vy weq vz vx wel wi vx vx vy weq vz vx
      wel vz vy wel vx vy vz elequ2 biimprcd 19.20i syl6 sylbid adantlr vx vw
      weq vx wal vz vx wel vx vy weq vz vx wel wi vx wal wi vz vw wel vx vy weq
      vz vw wel wi vx wal wi wb vx vz weq vx wal wn vx vy weq vx wal wn vx vy
      weq wa vx vw weq vx wal vz vx wel vz vw wel vx vy weq vz vx wel wi vx wal
      vx vy weq vz vw wel wi vx wal vx vw weq vz vx wel vz vw wel wb vx vx vw
      vz elequ2 a4s vx vy weq vz vx wel wi vx vy weq vz vw wel wi vx vw vx vx
      vw weq vx wal vz vx wel vz vw wel vx vy weq vx vw weq vz vx wel vz vw wel
      wb vx vx vw vz elequ2 a4s imbi2d dral2 imbi12d ad2antlr mpbid exp32 vx vz
      weq vx wal wn vx vw weq vx wal wn wa vx vy weq vz vw wel vx vy weq vz vw
      wel wi vx wal wi wi vx vy weq vx wal wn vx vz weq vx wal wn vx vw weq vx
      wal wn wa vz vw wel vx vy weq vz vw wel wi vx wal wi vx vy weq vx vz weq
      vx wal wn vx vw weq vx wal wn wa vu vw weq vu wex vz vw wel vx vy weq vz
      vw wel wi vx wal wi vu vw a9e vx vz weq vx wal wn vx vw weq vx wal wn wa
      vu vw weq vz vw wel vx vy weq vz vw wel wi vx wal wi vu vx vz weq vx wal
      wn vx vw weq vx wal wn wa vv vz weq vv wex vu vw weq vz vw wel vx vy weq
      vz vw wel wi vx wal wi wi vv vz a9e vx vz weq vx wal wn vx vw weq vx wal
      wn wa vv vz weq vu vw weq vz vw wel vx vy weq vz vw wel wi vx wal wi wi
      vv vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu vw weq vz vw
      wel vx vy weq vz vw wel wi vx wal wi vx vz weq vx wal wn vx vw weq vx wal
      wn wa vv vz weq vu vw weq wa wa vv vu wel vx vy weq vv vu wel wi vx wal
      wi vz vw wel vx vy weq vz vw wel wi vx wal wi vv vu wel vx vy weq vv vu
      wel wi vx vv vu wel vx vy weq ax-1 19.21aiv vx vz weq vx wal wn vx vw weq
      vx wal wn wa vv vz weq vu vw weq wa wa vv vu wel vz vw wel vx vy weq vv
      vu wel wi vx wal vx vy weq vz vw wel wi vx wal vv vz weq vu vw weq wa vv
      vu wel vz vw wel wb vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq
      vv vu wel vz vu wel vu vw weq vz vw wel vv vz vu elequ1 vu vw vz elequ2
      sylan9bb adantl vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz weq vu
      vw weq wa wa vv vz weq vu vw weq wa vx wal vx vy weq vv vu wel wi vx wal
      vx vy weq vz vw wel wi vx wal wb vx vz weq vx wal wn vx vw weq vx wal wn
      wa vv vz weq vu vw weq wa wa vv vz weq vx wal vu vw weq vx wal wa vv vz
      weq vu vw weq wa vx wal vx vz weq vx wal wn vx vw weq vx wal wn wa vv vz
      weq vu vw weq wa vv vz weq vx wal vu vw weq vx wal wa vx vz weq vx wal wn
      vv vz weq vv vz weq vx wal vx vw weq vx wal wn vu vw weq vu vw weq vx wal
      vx vz vv dveeq2 vx vw vu dveeq2 im2anan9 imp vv vz weq vu vw weq vx 19.26
      sylibr vv vz weq vu vw weq wa vx wal vx vy weq vv vu wel wi vx vy weq vz
      vw wel wi vx vv vz weq vu vw weq wa vx hba1 vv vz weq vu vw weq wa vx wal
      vv vu wel vz vw wel vx vy weq vv vz weq vu vw weq wa vv vu wel vz vw wel
      wb vx vv vz weq vv vu wel vz vu wel vu vw weq vz vw wel vv vz vu elequ1
      vu vw vz elequ2 sylan9bb a4s imbi2d albid syl imbi12d mpbii exp32
      19.23adv mpi 19.23adv mpi a1d a1d 4cases $.
      $( [22-Jan-2007] $) $( [22-Jan-2007] $)
  $}

  ${
    ax11f.1 $e |- ( ph -> A. x ph ) $.
    $( Basis step for constructing a substitution instance of ~ ax-11o without
       using ~ ax-11o .  We can start with any formula ` ph ` in which ` x ` is
       not free. $)
    ax11f $p |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      vx vy weq vx wal wn vx vy weq wph vx vy weq wph wi vx wal wi wph vx vy
      weq wph wi vx ax11f.1 wph vx vy weq ax-1 19.21ai a1i12 $.
      $( [22-Jan-2007] $) $( [21-Jan-2007] $)
  $}

  ${
    ax11indn.1 $e |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.
    $( Induction step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Negation case. $)
    ax11indn $p |- ( -. A. x x = y ->
               ( x = y -> ( -. ph -> A. x ( x = y -> -. ph ) ) ) ) $=
      vx vy weq vx wal wn vx vy weq wph wn vx vy weq wph wn wi vx wal vx vy weq
      vx wal wn vx vy weq wph wn wa vx wex vx vy weq wph wn wi vx wal vx vy weq
      wph wn wa vx vy weq vx wal wn vx vy weq wph wi vx wal wn vx vy weq wph wn
      wi vx wal vx vy weq wph wn wa vx wex vx vy weq vx wal wn vx vy weq wph wi
      vx wal wn vx vy weq wph wn wi vx vx vy weq vx hbn1 vx vy weq wph wi vx
      hbn1 vx vy weq vx wal wn vx vy weq vx vy weq wph wi vx wal wn wph wn vx
      vy weq vx wal wn vx vy weq wph vx vy weq wph wi vx wal wi vx vy weq wph
      wi vx wal wn wph wn wi ax11indn.1 wph vx vy weq wph wi vx wal con3 syl6
      com23 19.21ad vx vy weq wph vx exanali syl5ib vx vy weq wph wn wa vx
      19.8a syl5 exp3a $.
      $( [21-Jan-2007] $) $( [21-Jan-2007] $)

    ${
      ax11indi.2 $e |- ( -. A. x x = y ->
                 ( x = y -> ( ps -> A. x ( x = y -> ps ) ) ) ) $.
      $( Induction step for constructing a substitution instance of ~ ax-11o
         without using ~ ax-11o .  Implication case. $)
      ax11indi $p |- ( -. A. x x = y ->
           ( x = y -> ( ( ph -> ps ) -> A. x ( x = y -> ( ph -> ps ) ) ) ) ) $=
        vx vy weq vx wal wn vx vy weq wph wps wi vx vy weq wph wps wi wi vx wal
        wi vx vy weq vx wal wn vx vy weq wa wph wn wps wo vx vy weq wph wps wi
        wi vx wal wph wps wi vx vy weq vx wal wn vx vy weq wa wph wn vx vy weq
        wph wps wi wi vx wal wps vx vy weq vx wal wn vx vy weq wa wph wn vx vy
        weq wph wn wi vx wal vx vy weq wph wps wi wi vx wal vx vy weq vx wal wn
        vx vy weq wph wn vx vy weq wph wn wi vx wal wi wph vx vy ax11indn.1
        ax11indn imp vx vy weq wph wn wi vx vy weq wph wps wi wi vx wph wn wph
        wps wi vx vy weq wph wps pm2.21 imim2i 19.20i syl6 vx vy weq vx wal wn
        vx vy weq wa wps vx vy weq wps wi vx wal vx vy weq wph wps wi wi vx wal
        vx vy weq vx wal wn vx vy weq wps vx vy weq wps wi vx wal wi ax11indi.2
        imp vx vy weq wps wi vx vy weq wph wps wi wi vx wps wph wps wi vx vy
        weq wps wph ax-1 imim2i 19.20i syl6 jaod wph wps imor syl5ib ex $.
        $( [22-Jan-2007] $) $( [21-Jan-2007] $)
    $}
  $}

  ${
    ax11indalem.1 $e |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.
    $( Lemma for ~ ax11inda2 and ~ ax11inda . $)
    ax11indalem $p |- ( -. A. y y = z  -> ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) ) $=
      vx vz weq vx wal vy vz weq vy wal wn vx vy weq vx wal wn vx vy weq wph vz
      wal vx vy weq wph vz wal wi vx wal wi wi wi vx vz weq vx wal vx vy weq vx
      wal wn vx vy weq wph vz wal vx vy weq wph vz wal wi vx wal wi wi wi vy vz
      weq vy wal wn vx vz weq vx wal vx vy weq wph vz wal vx vy weq wph vz wal
      wi vx wal wi wi vx vy weq vx wal wn vx vz weq vx wal wph vz wal vx vy weq
      wph vz wal wi vx wal wi vx vy weq wph vz wal vx vy weq wph vz wal wi vx
      wal wi vz vx vz vx weq vz wal wph vx wal vx vy weq wph vx wal wi vx wal
      wph vz wal vx vy weq wph vz wal wi vx wal wph vx wal vx vy weq wph vx wal
      wi vx wal wi vz vx weq vz wal wph vx vy weq wph vx wal wi vx wph vx wal
      vx vy weq ax-1 a5i a1i wph wph vz vx vz vx weq vz wal wph biidd dral1 vx
      vy weq wph vz wal wi vx vy weq wph vx wal wi vz vx vx vz vx weq vz wal
      wph vz wal wph vx wal vx vy weq wph wph vz vx vz vx weq vz wal wph biidd
      dral1 imbi2d dral2 3imtr4d alequcoms a1d a1d adantr vx vz weq vx wal wn
      vy vz weq vy wal wn wa vx vy weq vx wal wn vx vy weq wph vz wal vx vy weq
      wph vz wal wi vx wal wi vx vz weq vx wal wn vy vz weq vy wal wn wa vx vy
      weq vx wal wn wa vx vy weq wa wph vz wal vx vy weq wph wi vx wal vz wal
      vx vy weq wph vz wal wi vx wal vx vy weq vx wal wn vx vy weq vz wal wph
      vz wal vx vy weq wph wi vx wal vz wal wi vx vz weq vx wal wn vy vz weq vy
      wal wn wa vx vy weq vx wal wn wa vx vy weq wa vx vy weq vx wal wn vx vy
      weq vz wal wa wph vx vy weq wph wi vx wal vz vx vy weq vx wal wn vx vy
      weq vz wal vz vx vy vz hbnae vx vy weq vz hba1 hban vx vy weq vx wal wn
      vx vy weq wph vx vy weq wph wi vx wal wi vx vy weq vz wal vx vy weq vx
      wal wn vx vy weq wph vx vy weq wph wi vx wal wi ax11indalem.1 imp vx vy
      weq vz ax-4 sylan2 19.20d vx vz weq vx wal wn vy vz weq vy wal wn wa vx
      vy weq vx wal wn vx vy weq simplr vx vz weq vx wal wn vy vz weq vy wal wn
      wa vx vy weq vx vy weq vz wal vx vy weq vx wal wn vx vz weq vx wal wn vy
      vz weq vy wal wn wa vx vy weq vx vy weq vz wal vz vx weq vz wal wn vz vy
      weq vz wal wn vx vy weq vx vy weq vz wal wi vx vz weq vx wal wn vy vz weq
      vy wal wn vz vx weq vz wal wn vz vy weq vz wal wn vx vy weq vx vy weq vz
      wal wi vx vy vz ax-12 imp vz vx weq vz wal vx vz weq vx wal vz vx
      alequcom con3i vz vy weq vz wal vy vz weq vy wal vz vy alequcom con3i
      syl2an imp adantlr sylanc vx vz weq vx wal wn vy vz weq vy wal wn wa vx
      vy weq wph wi vx wal vz wal vx vy weq wph vz wal wi vx wal wi vx vy weq
      vx wal wn vx vy weq vx vz weq vx wal wn vy vz weq vy wal wn wa vx vy weq
      wph wi vz wal vx wal vx vy weq wph vz wal wi vx wal vx vy weq wph wi vx
      wal vz wal vx vz weq vx wal wn vy vz weq vy wal wn wa vx vy weq wph wi vz
      wal vx vy weq wph vz wal wi vx vx vz weq vx wal wn vy vz weq vy wal wn vx
      vx vz vx hbnae vy vz vx hbnae hban vx vz weq vx wal wn vy vz weq vy wal
      wn wa vx vy weq vx vy weq vz wal wi vz wal vx vy weq wph wi vz wal vx vy
      weq wph vz wal wi wb vx vz weq vx wal wn vy vz weq vy wal wn wa vx vy weq
      vx vy weq vz wal wi vz vx vz weq vx wal wn vy vz weq vy wal wn vz vx vz
      vz hbnae vy vz vz hbnae hban vz vx weq vz wal wn vz vy weq vz wal wn vx
      vy weq vx vy weq vz wal wi vx vz weq vx wal wn vy vz weq vy wal wn vz vx
      weq vz wal wn vz vy weq vz wal wn vx vy weq vx vy weq vz wal wi vx vy vz
      ax-12 imp vz vx weq vz wal vx vz weq vx wal vz vx alequcom con3i vz vy
      weq vz wal vy vz weq vy wal vz vy alequcom con3i syl2an 19.21ai vx vy weq
      wph vz 19.21t syl albid vx vy weq wph wi vz vx ax-7 syl5bi ad2antrr syld
      exp31 pm2.61ian $.
      $( [14-Mar-2007] $) $( [24-Jan-2007] $)
  $}

  ${
    $d z y $.
    ax11inda2.1 $e |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.
    $( A proof of ~ ax11inda2 that is slightly more direct. $)
    ax11inda2ALT $p |- ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) $=
      vx vz weq vx wal vx vy weq vx wal wn vx vy weq wph vz wal vx vy weq wph
      vz wal wi vx wal wi wi wi vx vz weq vx wal vx vy weq wph vz wal vx vy weq
      wph vz wal wi vx wal wi wi vx vy weq vx wal wn vx vz weq vx wal wph vz
      wal vx vy weq wph vz wal wi vx wal wi vx vy weq wph vz wal vx vy weq wph
      vz wal wi vx wal wi vz vx vz vx weq vz wal wph vx wal vx vy weq wph vx
      wal wi vx wal wph vz wal vx vy weq wph vz wal wi vx wal wph vx wal vx vy
      weq wph vx wal wi vx wal wi vz vx weq vz wal wph vx vy weq wph vx wal wi
      vx wph vx wal vx vy weq ax-1 a5i a1i wph wph vz vx vz vx weq vz wal wph
      biidd dral1 vx vy weq wph vz wal wi vx vy weq wph vx wal wi vz vx vx vz
      vx weq vz wal wph vz wal wph vx wal vx vy weq wph wph vz vx vz vx weq vz
      wal wph biidd dral1 imbi2d dral2 3imtr4d alequcoms a1d a1d vx vz weq vx
      wal wn vx vy weq vx wal wn vx vy weq wph vz wal vx vy weq wph vz wal wi
      vx wal wi vx vz weq vx wal wn vx vy weq vx wal wn wa vx vy weq wa wph vz
      wal vx vy weq wph wi vx wal vz wal vx vy weq wph vz wal wi vx wal vx vy
      weq vx wal wn vx vy weq vz wal wph vz wal vx vy weq wph wi vx wal vz wal
      wi vx vz weq vx wal wn vx vy weq vx wal wn wa vx vy weq wa vx vy weq vx
      wal wn vx vy weq vz wal wa wph vx vy weq wph wi vx wal vz vx vy weq vx
      wal wn vx vy weq vz wal vz vx vy vz hbnae vx vy weq vz hba1 hban vx vy
      weq vx wal wn vx vy weq wph vx vy weq wph wi vx wal wi vx vy weq vz wal
      vx vy weq vx wal wn vx vy weq wph vx vy weq wph wi vx wal wi ax11inda2.1
      imp vx vy weq vz ax-4 sylan2 19.20d vx vz weq vx wal wn vx vy weq vx wal
      wn vx vy weq simplr vx vz weq vx wal wn vx vy weq vx vy weq vz wal vx vy
      weq vx wal wn vx vz weq vx wal wn vx vy weq vx vy weq vz wal vx vy weq vx
      vy weq vz wal wi vz vx vz vx vy dveeq1 nalequcoms imp adantlr sylanc vx
      vz weq vx wal wn vx vy weq wph wi vx wal vz wal vx vy weq wph vz wal wi
      vx wal wi vx vy weq vx wal wn vx vy weq vx vz weq vx wal wn vx vy weq wph
      wi vz wal vx wal vx vy weq wph vz wal wi vx wal vx vy weq wph wi vx wal
      vz wal vx vz weq vx wal wn vx vy weq wph wi vz wal vx vy weq wph vz wal
      wi vx vx vz vx hbnae vx vz weq vx wal wn vx vy weq vx vy weq vz wal wi vz
      wal vx vy weq wph wi vz wal vx vy weq wph vz wal wi wb vx vz weq vx wal
      wn vx vy weq vx vy weq vz wal wi vz vx vz vz hbnae vx vy weq vx vy weq vz
      wal wi vz vx vz vx vy dveeq1 nalequcoms 19.21ai vx vy weq wph vz 19.21t
      syl albid vx vy weq wph wi vz vx ax-7 syl5bi ad2antrr syld exp31 pm2.61i
      $.
      $( [4-May-2007] $) $( [4-May-2007] $)

    $( Induction step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Quantification case.  When ` z ` and ` y ` are
       distinct, this theorem avoids the dummy variables needed by the more
       general ~ ax11inda . $)
    ax11inda2 $p |- ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) $=
      vy vz weq vy wal vx vy weq vx wal wn vx vy weq wph vz wal vx vy weq wph
      vz wal wi vx wal wi wi wi vy vz weq vy wal vx vy weq wph vz wal vx vy weq
      wph vz wal wi vx wal wi wi vx vy weq vx wal wn vy vz weq vy wal wph vz
      wal vx vy weq wph vz wal wi vx wal wi vx vy weq vy vz weq vy wal vx vy
      weq wph vz wal wi vx vy weq wph vz wal wi vx wal wph vz wal vx vy weq wph
      vz wal wi vy vz vx a16g wph vz wal vx vy weq ax-1 syl5 a1d a1d wph vx vy
      vz ax11inda2.1 ax11indalem pm2.61i $.
      $( [14-Mar-2007] $) $( [24-Jan-2007] $)
  $}

  ${
    $d w ph $.  $d w x $.  $d w y $.  $d w z $.
    ax11inda.1 $e |- ( -. A. x x = w ->
               ( x = w -> ( ph -> A. x ( x = w -> ph ) ) ) ) $.
    $( Induction step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Quantification case.  (When ` z ` and ` y `
       are distinct, ~ ax11inda2 may be used instead to avoid the dummy
       variable ` w ` in the proof.) $)
    ax11inda $p |- ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) $=
      vx vy weq vx wal wn vx vy weq wph vz wal vx vy weq wph vz wal wi vx wal
      wi wi vx vy weq vx wal wn vw vy weq vw wex vx vy weq vx wal wn vx vy weq
      wph vz wal vx vy weq wph vz wal wi vx wal wi wi wi vw vy a9e vx vy weq vx
      wal wn vw vy weq vx vy weq vx wal wn vx vy weq wph vz wal vx vy weq wph
      vz wal wi vx wal wi wi wi vw vx vy weq vx wal wn vw vy weq vx vy weq vx
      wal wn vx vy weq wph vz wal vx vy weq wph vz wal wi vx wal wi wi wi vx vy
      weq vx wal wn vw vy weq wa vx vw weq vx wal wn vx vw weq wph vz wal vx vw
      weq wph vz wal wi vx wal wi wi wi vx vy weq vx wal wn vx vy weq wph vz
      wal vx vy weq wph vz wal wi vx wal wi wi wi wph vx vw vz ax11inda.1
      ax11inda2 vx vy weq vx wal wn vw vy weq wa vx vw weq vx wal wn vx vy weq
      vx wal wn vx vw weq wph vz wal vx vw weq wph vz wal wi vx wal wi wi vx vy
      weq wph vz wal vx vy weq wph vz wal wi vx wal wi wi vx vy weq vx wal wn
      vw vy weq wa vw vy weq vx wal vx vw weq vx wal wn vx vy weq vx wal wn wb
      vx vy weq vx wal wn vw vy weq vw vy weq vx wal vx vy vw dveeq2 imp vw vy
      weq vx wal vx vw weq vx wal vx vy weq vx wal vw vy weq vx wal vx vw weq
      vx vy weq vx vw vy weq vx hba1 vw vy weq vx vw weq vx vy weq wb vx vw vy
      vx equequ2 a4s albid notbid syl vx vy weq vx wal wn vw vy weq wa vx vw
      weq vx vy weq wph vz wal vx vw weq wph vz wal wi vx wal wi wph vz wal vx
      vy weq wph vz wal wi vx wal wi vw vy weq vx vw weq vx vy weq wb vx vy weq
      vx wal wn vw vy vx equequ2 adantl vx vy weq vx wal wn vw vy weq wa vx vw
      weq wph vz wal wi vx wal vx vy weq wph vz wal wi vx wal wph vz wal vx vy
      weq vx wal wn vw vy weq wa vw vy weq vx wal vx vw weq wph vz wal wi vx
      wal vx vy weq wph vz wal wi vx wal wb vx vy weq vx wal wn vw vy weq vw vy
      weq vx wal vx vy vw dveeq2 imp vw vy weq vx wal vx vw weq wph vz wal wi
      vx vy weq wph vz wal wi vx vw vy weq vx hba1 vw vy weq vx wal vx vw weq
      vx vy weq wph vz wal vw vy weq vx vw weq vx vy weq wb vx vw vy vx equequ2
      a4s imbi1d albid syl imbi2d imbi12d imbi12d mpbii ex 19.23adv mpi pm2.43i
      $.
      $( [14-Mar-2007] $) $( [24-Jan-2007] $)
  $}

  $( Part of a study related to ~ ax-12 .  The consequent introduces a new
     variable ` z ` .  There are no distinct variable restrictions. $)
  a12stdy1 $p |- ( A. x x = y -> E. x y = z ) $=
    vx vy weq vx wal vy vz weq vy wex vy vz weq vx wex vy vz a9e vx vy weq vx
    wal vy vz weq wn vy wal wn vy vz weq wn vx wal wn vy vz weq vy wex vy vz
    weq vx wex vx vy weq vx wal vy vz weq wn vx wal vy vz weq wn vy wal vy vz
    weq wn vx vy ax-10o con3d vy vz weq vy df-ex vy vz weq vx df-ex 3imtr4g mpi
    $.
    $( [9-Apr-2008] $) $( [14-Jan-2008] $)

  $( Part of a study related to ~ ax-12 .  The consequent is quantified with
     a different variable.  There are no distinct variable restrictions. $)
  a12stdy2 $p |- ( A. z ( z = x /\ x = y ) -> A. y y = x ) $=
    vz vx weq vx vy weq wa vz wal vz vx weq vz wal vx vy weq vz wal wa vy vx
    weq vy wal vz vx weq vx vy weq vz 19.26 vz vx weq vz wal vx vy weq vz wal
    vy vx weq vy wal vz vx weq vz wal vx vy weq vz wal vx vy weq vx wal vy vx
    weq vy wal vx vy weq vz vx ax-10o vx vy alequcom syl6 imp sylbi $.
    $( [9-Apr-2008] $) $( [14-Jan-2008] $)

  $( Part of a study related to ~ ax-12 .  The consequent introduces two new
     variables.  There are no distinct variable restrictions. $)
  a12stdy3 $p |- ( A. z ( z = x /\ x = y ) -> A. v E. y x = w ) $=
    vz vx weq vx vy weq wa vz wal vy vx weq vy wal vy vx weq vy wal vv wal vx
    vw weq vy wex vv wal vx vy vz a12stdy2 vy vx vv hbae vy vx weq vy wal vx vw
    weq vy wex vv vy vx vw a12stdy1 19.20i 3syl $.
    $( [9-Apr-2008] $) $( [14-Jan-2008] $)

  $( Part of a study related to ~ ax-12 .  The second antecedent of ~ ax-12
     is replaced.  There are no distinct variable restrictions. $)
  a12stdy4 $p |- ( -. A. z z = x -> ( A. y z = x ->
           ( x = y -> A. z x = y ) ) ) $=
    vz vx weq vz wal wn vz vy weq vz wal vz vx weq vy wal vx vy weq vx vy weq
    vz wal wi wi vz vx weq vz wal wn vz vy weq vz wal vz vx weq vy wal vx vy
    weq vx vy weq vz wal wi wi vz vx weq vz wal wn vz vy weq vz wal wa vz vx
    weq vy wal vx vy weq vx vy weq vz wal wi vz vy weq vz wal vz vx weq vz wal
    wn vz vx weq vy wal wn vz vy weq vz wal vz vx weq vy wal vz vx weq vz wal
    vz vx weq vy wal vz vx weq vz wal wi vy vz vz vx weq vy vz ax-10o alequcoms
    con3d impcom pm2.21d ex vz vx weq vz wal wn vz vy weq vz wal wn vx vy weq
    vx vy weq vz wal wi vz vx weq vy wal vx vy vz ax-12 a1dd pm2.61d $.
    $( [9-Apr-2008] $) $( [14-Jan-2008] $)

  $( Proof of first hypothesis of ~ a12study . $)
  a12lem1 $p |- ( -. A. z z = y ->
                  ( A. z ( z = x -> z = y ) -> x = y ) ) $=
    vz vx weq vz wal vz vy weq vz wal wn vz vx weq vz vy weq wi vz wal vx vy
    weq wi wi vz vx weq vz wal vz vx weq vz vy weq wi vz wal vx vy weq wi vz vy
    weq vz wal wn vz vx weq vz wal vz vx weq vz vy weq wi vz wal vx vx weq vx
    vy weq wi vz wal vx vy weq vz vx weq vz vy weq wi vx vx weq vx vy weq wi vz
    vx vz vz vx weq vz vx weq vz vy weq wi vx vx weq vx vy weq wi wb vz vz vx
    weq vz vx weq vx vx weq vz vy weq vx vy weq vz vx vx equequ1 vz vx vy
    equequ1 imbi12d a4s dral2 vx vx weq vx vy weq wi vx vy weq vz vx vy weq vx
    vx weq vx vy weq wi vx vx weq vx vy weq vx equid a1bi biimpri a4s syl6bi
    a1d vz vx weq vz wal wn vz vy weq vz wal wn vz vx weq vz vy weq wi vz wal
    vx vy weq wi vz vx weq vz wal wn vz vy weq vz wal wn wa vz vx weq vz vy weq
    wi vz wal vx vx weq vx vy weq vx equid vx vx weq vx vy weq wi vx vx weq vx
    vy weq wi vz wal wi vz wal vz vx weq vz vx weq vz vy weq wi vx vx weq vx vy
    weq wi wi wi vz wal vz vx weq vz vy weq wi vz wal vx vx weq vx vy weq wi wi
    vz vx weq vz wal wn vz vy weq vz wal wn wa vx vx weq vx vy weq wi vx vx weq
    vx vy weq wi vz wal wi vz wal vz vx weq vz vx weq vz vy weq wi vx vx weq vx
    vy weq wi wi wi vz wal wa vx vx weq vx vy weq wi vx vx weq vx vy weq wi vz
    wal wi vz vx weq vz vx weq vz vy weq wi vx vx weq vx vy weq wi wi wi wa vz
    wal vz vx weq vz vy weq wi vz wal vx vx weq vx vy weq wi wi vx vx weq vx vy
    weq wi vx vx weq vx vy weq wi vz wal wi vz vx weq vz vx weq vz vy weq wi vx
    vx weq vx vy weq wi wi wi vz 19.26 vz vx weq vz vy weq wi vx vx weq vx vy
    weq wi vz vx a4imt sylbir vz vx weq vz wal wn vz vy weq vz wal wn wa vx vx
    weq vx vy weq wi vx vx weq vx vy weq wi vz wal wi vz vz vx weq vz wal wn vz
    vy weq vz wal wn vz vz vx weq vz hbn1 vz vy weq vz hbn1 hban vz vx weq vz
    wal wn vz vy weq vz wal wn wa vx vx weq vx vy weq vz vz vx weq vz wal wn vz
    vy weq vz wal wn vz vz vx weq vz hbn1 vz vy weq vz hbn1 hban vx vx weq vx
    vx weq vz wal wi vz vx weq vz wal wn vz vy weq vz wal wn wa vx vx weq vz vx
    equid hbth a1i vz vx weq vz wal wn vz vy weq vz wal wn vx vy weq vx vy weq
    vz wal wi vx vy vz ax-12 imp hbimd 19.21ai vz vx weq vz vx weq vz vy weq wi
    vx vx weq vx vy weq wi wi wi vz vz vx weq vx vx weq vz vx weq vz vy weq vx
    vy weq vz vx vx equtr vz vx vy ax-8 imim12d ax-gen sylancl mpii ex pm2.61i
    $.
    $( [16-Jan-2008] $) $( [15-Jan-2008] $)

  $( Proof of second hypothesis of ~ a12study . $)
  a12lem2 $p |- ( A. z ( z = x -> -. z = y ) -> -. x = y ) $=
    vz vx weq vz vy weq wn wi vz wal vx vz weq vz vy weq wa vz wex wn vx vy weq
    wn vz vx weq vz vy weq wn wi vz wal vx vz weq vz vy weq wa wn vz wal vx vz
    weq vz vy weq wa vz wex wn vz vx weq vz vy weq wn wi vx vz weq vz vy weq wa
    wn vz vz vx weq vz vy weq wn wi vx vz weq vz vy weq wn wi vx vz weq vz vy
    weq wa wn vz vx weq vx vz weq vz vy weq wn vz vx equcom imbi1i vx vz weq vz
    vy weq imnan bitri albii vx vz weq vz vy weq wa vz alnex bitri vx vy weq vx
    vz weq vz vy weq wa vz wex vx vy vz equvini con3i sylbi $.
    $( [16-Jan-2008] $) $( [15-Jan-2008] $)

  ${
    a12study.1 $e |- ( -. A. z z = y ->
                    ( A. z ( z = x -> z = y ) -> x = y ) ) $.
    a12study.2 $e |- ( A. z ( z = x -> -. z = y ) -> -. x = y ) $.
    $( Rederivation of axiom ~ ax-12 from two shorter formulas, without using
       ~ ax-12 .  See ~ a12lem1 and ~ a12lem2 for the proofs of the hypotheses
       (using ~ ax-12 ).  This is the only known breakdown of ~ ax-12 into
       shorter formulas.  See ~ a12studyALT for an alternate proof.  Note that
       the proof depends on ~ ax-11o , whose proof ~ ax11o depends on ~ ax-12 ,
       meaning that we would have to replace ~ ax-11 with ~ ax-11o in an
       axiomatization that uses the hypotheses in place of ~ ax-12 .  Whether
       this can be avoided is an open problem. $)
    a12study $p |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x = y -> A. z x = y ) ) ) $=
      vz vx weq vz wal wn vz vy weq vz wal wn vx vz weq vz vy weq wa vz wex vx
      vy weq vz wal vx vy weq vz vx weq vz wal wn vz vy weq vz wal wn vx vz weq
      vz vy weq wa vz wex vx vy weq vz wal wi vz vx weq vz wal wn vz vy weq vz
      wal wn wa vx vz weq vz vy weq wa vx vy weq vz wal vz vz vx weq vz wal wn
      vz vy weq vz wal wn vz vz vx weq vz hbn1 vz vy weq vz hbn1 hban vx vy weq
      vz hba1 vz vx weq vz wal wn vx vz weq vz vy weq wa vz vx weq vz vy weq wi
      vz wal vz vy weq vz wal wn vx vy weq vz wal vz vx weq vz wal wn vx vz weq
      vz vy weq vz vx weq vz vy weq wi vz wal vz vx weq vz wal wn vz vx weq vz
      vy weq vz vx weq vz vy weq wi vz wal wi vx vz weq vz vy weq vz vx ax-11o
      vx vz weq vx vx weq vz vx weq vx equid1 vx vz vx ax-8 mpi syl5 imp3a vz
      vy weq vz wal wn vz vx weq vz vy weq wi vz wal vx vy weq vz vz vy weq vz
      hbn1 vz vx weq vz vy weq wi vz hba1 a12study.1 19.21ad sylan9 19.23ad ex
      vx vy weq vx vz weq vz vy weq wa wn vz wal wn vx vz weq vz vy weq wa vz
      wex vx vz weq vz vy weq wa wn vz wal vx vy weq vx vz weq vz vy weq wa wn
      vz wal vz vx weq vz vy weq wn wi vz wal vx vy weq wn vx vz weq vz vy weq
      wa wn vz vx weq vz vy weq wn wi vz vx vz weq vz vy weq wa wn vx vz weq vz
      vy weq wn wi vz vx weq vz vy weq wn wi vx vz weq vz vy weq imnan vz vx
      weq vx vz weq vz vy weq wn vz vx weq vz vz weq vx vz weq vz equid1 vz vx
      vz ax-8 mpi imim1i sylbir 19.20i a12study.2 syl con2i vx vz weq vz vy weq
      wa vz df-ex sylibr syl7 $.
      $( [16-Jan-2008] $) $( [15-Jan-2008] $)

    $( Alternate proof of ~ a12study , also without using ~ ax-12 . $)
    a12studyALT $p |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x = y -> A. z x = y ) ) ) $=
      vz vx weq vz wal wn vz vy weq vz wal wn vx vy weq vx vy weq vz wal wi vz
      vx weq vz wal wn vz vy weq vz wal wn wa vx vy weq wn wn vx vy weq wn wn
      vz wal vx vy weq vx vy weq vz wal vz vx weq vz wal wn vz vy weq vz wal wn
      wa vx vy weq wn vz vz vx weq vz wal wn vz vy weq vz wal wn vz vz vx weq
      vz hbn1 vz vy weq vz hbn1 hban vz vy weq vz wal wn vx vy weq wn vz vx weq
      vz vy weq wi vz wal wn vz vx weq vz wal wn vx vy weq wn vz wal vz vy weq
      vz wal wn vz vx weq vz vy weq wi vz wal vx vy weq a12study.1 con3d vz vx
      weq vz wal wn vz vx weq vz vy weq wi wn vz wex vx vy weq wn vz wal vz vx
      weq vz vy weq wi vz wal wn vz vx weq vz wal wn vz vx weq vz vy weq wi wn
      vx vy weq wn vz wal vz vz vx weq vz hbn1 vx vy weq wn vz hba1 vz vx weq
      vz wal wn vz vx weq vz vy weq wn wa vx vy weq wn vz wal vz vx weq vz vy
      weq wi wn vz vx weq vz wal wn vz vx weq vz vy weq wn vx vy weq wn vz wal
      vz vx weq vz wal wn vz vx weq vz vy weq wn vz vx weq vz vy weq wn wi vz
      wal vx vy weq wn vz wal vz vy weq vz vx vz vy weq vz vx ax-11o ax11indn
      vz vx weq vz vy weq wn wi vx vy weq wn vz a12study.2 a5i syl8 imp3a vz vx
      weq vz vy weq annim syl5ibr 19.23ad vz vx weq vz vy weq wi vz exnal
      syl5ibr sylan9r hbnd vx vy weq notnot vx vy weq vx vy weq wn wn vz vx vy
      weq notnot albii 3imtr4g ex $.
      $( [17-Jan-2008] $) $( [17-Jan-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Existential uniqueness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols needed for uniqueness notation. $)
  $c E! $.  $( Backwards E exclamation point. $)
  $c E* $.  $( Backwards E superscript *. $)

  $( Extend wff definition to include existential uniqueness ("there exists a
     unique ` x ` such that ` ph ` "). $)
  weu $a wff E! x ph $.

  $( Extend wff definition to include uniqueness ("there exists at most one
     ` x ` such that ` ph ` "). $)
  wmo $a wff E* x ph $.

  ${
    $d w x y $.  $d x z $.  $d y ph $.  $d w z ph $.
    $( A soundness justification theorem for ~ df-eu , showing that the
       definition is equivalent to itself with its dummy variable renamed.
       Note that ` y ` and ` z ` needn't be distinct variables.  While this
       isn't strictly necessary for soundness, the proof provides an example of
       how it can be achieved through the use of ~ dvelim . $)
    eujust $p |- ( E. y A. x ( ph <-> x = y )
        <-> E. z A. x ( ph <-> x = z ) ) $=
      vy vz weq vy wal wph vx vy weq wb vx wal vy wex wph vx vz weq wb vx wal
      vz wex wb wph vx vy weq wb vx wal wph vx vz weq wb vx wal vy vz vy vz weq
      wph vx vy weq wb vx wal wph vx vz weq wb vx wal wb vy vy vz weq wph vx vy
      weq wb wph vx vz weq wb vx vy vz weq vx vy weq vx vz weq wph vy vz vx
      equequ2 bibi2d albidv a4s drex1 vy vz weq vy wal wn wph vx vy weq wb vx
      wal wn vy wal wn wph vx vz weq wb vx wal wn vz wal wn wph vx vy weq wb vx
      wal vy wex wph vx vz weq wb vx wal vz wex vy vz weq vy wal wn wph vx vy
      weq wb vx wal wn vy wal wph vx vz weq wb vx wal wn vz wal vy vz weq vy
      wal wn vy vz weq vy wal wn vz wal vy wal wph vx vy weq wb vx wal wn vy
      wal wph vx vz weq wb vx wal wn vz wal wb vy vz weq vy wal wn vy vz weq vy
      wal wn vz wal vy vy vz vy hbnae vy vz vz hbnae 19.21ai vy vz weq vy wal
      wn wph vx vy weq wb vx wal wn wph vx vz weq wb vx wal wn vy vz wph vx vy
      weq wb vx wal wn wph vx vy weq wb vx wal wn vz wal wi vz vy wph vx vw weq
      wb vx wal wn wph vx vy weq wb vx wal wn vz vy vw wph vx vw weq wb vx wal
      wn vz ax-17 vw vy weq wph vx vw weq wb vx wal wph vx vy weq wb vx wal vw
      vy weq wph vx vw weq wb wph vx vy weq wb vx vw vy weq vx vw weq vx vy weq
      wph vw vy vx equequ2 bibi2d albidv notbid dvelim nalequcoms wph vx vw weq
      wb vx wal wn wph vx vz weq wb vx wal wn vy vz vw wph vx vw weq wb vx wal
      wn vy ax-17 vw vz weq wph vx vw weq wb vx wal wph vx vz weq wb vx wal vw
      vz weq wph vx vw weq wb wph vx vz weq wb vx vw vz weq vx vw weq vx vz weq
      wph vw vz vx equequ2 bibi2d albidv notbid dvelim vy vz weq wph vx vy weq
      wb vx wal wn wph vx vz weq wb vx wal wn wb wi vy vz weq vy wal wn vy vz
      weq wph vx vy weq wb vx wal wph vx vz weq wb vx wal vy vz weq wph vx vy
      weq wb wph vx vz weq wb vx vy vz weq vx vy weq vx vz weq wph vy vz vx
      equequ2 bibi2d albidv notbid a1i cbv2 syl notbid wph vx vy weq wb vx wal
      vy df-ex wph vx vz weq wb vx wal vz df-ex 3bitr4g pm2.61i $.
      $( [11-Mar-2010] $) $( [11-Mar-2010] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( Define existential uniqueness, i.e. "there exists exactly one ` x `
       such that ` ph ` ."  Definition 10.1 of [BellMachover] p. 97; also
       Definition *14.02 of [WhiteheadRussell] p. 175.  Other possible
       definitions are given by ~ eu1 , ~ eu2 , ~ eu3 , and ~ eu5 (which in
       some cases we show with a hypothesis ` ph -> A. y ph ` in place of a
       distinct variable condition on ` y ` and ` ph ` ).  Double uniqueness is
       tricky:  ` E! x E! y ph ` does not mean "exactly one ` x ` and one
       ` y ` " (see ~ 2eu4 ). $)
    df-eu $a |- ( E! x ph <-> E. y A. x ( ph <-> x = y ) ) $.
  $}

  $( Define "there exists at most one ` x ` such that ` ph ` ."  Here we
     define it in terms of existential uniqueness.  Notation of [BellMachover]
     p. 460, whose definition we show as ~ mo3 .  For other possible
     definitions see ~ mo2 and ~ mo4 . $)
  df-mo $a |- ( E* x ph <-> ( E. x ph -> E! x ph ) ) $.

  ${
    $d x y z $.  $d ph z $.
    euf.1 $e |- ( ph -> A. y ph ) $.
    $( A version of the existential uniqueness definition with a hypothesis
       instead of a distinct variable condition. $)
    euf $p |- ( E! x ph <-> E. y A. x ( ph <-> x = y ) ) $=
      wph vx weu wph vx vz weq wb vx wal vz wex wph vx vy weq wb vx wal vy wex
      wph vx vz df-eu wph vx vz weq wb vx wal wph vx vy weq wb vx wal vz vy wph
      vx vz weq wb vy vx wph vx vz weq vy euf.1 vx vz weq vy ax-17 hbbi hbal
      wph vx vy weq wb vx wal vz ax-17 vz vy weq wph vx vz weq wb wph vx vy weq
      wb vx vz vy weq vx vz weq vx vy weq wph vz vy vx equequ2 bibi2d albidv
      cbvex bitri $.
      $( [12-Aug-1993] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d y ps $.  $d y ch $.
    eubid.1 $e |- ( ph -> A. x ph ) $.
    eubid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for uniqueness quantifier (deduction rule). $)
    eubid $p |- ( ph -> ( E! x ps <-> E! x ch ) ) $=
      wph wps vx vy weq wb vx wal vy wex wch vx vy weq wb vx wal vy wex wps vx
      weu wch vx weu wph wps vx vy weq wb vx wal wch vx vy weq wb vx wal vy wph
      wps vx vy weq wb wch vx vy weq wb vx eubid.1 wph wps wch vx vy weq
      eubid.2 bibi1d albid exbidv wps vx vy df-eu wch vx vy df-eu 3bitr4g $.
      $( [9-Jul-1994] $)
  $}

  ${
    $d x ph $.
    eubidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for uniqueness quantifier (deduction rule). $)
    eubidv $p |- ( ph -> ( E! x ps <-> E! x ch ) ) $=
      wph wps wch vx wph vx ax-17 eubidv.1 eubid $.
      $( [9-Jul-1994] $)
  $}

  ${
    eubii.1 $e |- ( ph <-> ps ) $.
    $( Introduce uniqueness quantifier to both sides of an equivalence. $)
    eubii $p |- ( E! x ph <-> E! x ps ) $=
      vx vx weq wph vx weu wps vx weu wb vx equid vx vx weq wph wps vx vx
      hbequid2 wph wps wb vx vx weq eubii.1 a1i eubid ax-mp $.
      $( [9-Jul-1994] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( Bound-variable hypothesis builder for uniqueness. $)
    hbeu1 $p |- ( E! x ph -> A. x E! x ph ) $=
      wph vx vy weq wb vx wal vy wex wph vx vy weq wb vx wal vy wex vx wal wph
      vx weu wph vx weu vx wal wph vx vy weq wb vx wal vx vy wph vx vy weq wb
      vx hba1 hbex wph vx vy df-eu wph vx weu wph vx vy weq wb vx wal vy wex vx
      wph vx vy df-eu albii 3imtr4i $.
      $( [9-Jul-1994] $)
  $}

  ${
    $d y z $.  $d x z $.  $d z ph $.
    hbeu.1 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for "at most one."  Note that ` x `
       and ` y ` needn't be distinct (this makes the proof more difficult). $)
    hbeu $p |- ( E! y ph -> A. x E! y ph ) $=
      wph vy vz weq wb vy wal vz wex wph vy vz weq wb vy wal vz wex vx wal wph
      vy weu wph vy weu vx wal wph vy vz weq wb vy wal vx vz vx vy weq vx wal
      wph vy vz weq wb vy wal wph vy vz weq wb vy wal vx wal wi vx vy weq vx
      wal wph vy vz weq wb vy wal vy wal wph vy vz weq wb vy wal vx wal wph vy
      vz weq wb vy wal wph vy vz weq wb vy wal vy wal wph vy vz weq wb vy wal
      vx wal wi vy vx wph vy vz weq wb vy wal vy vx ax-10o alequcoms wph vy vz
      weq wb vy hba1 syl5 vx vy weq vx wal wn wph vy vz weq wb vx vy vx vy vy
      hbnae vx vy weq vx wal wn wph vy vz weq vx vx vy vx hbnae wph wph vx wal
      wi vx vy weq vx wal wn hbeu.1 a1i vx vy vz dveeq1 hbbid hbald pm2.61i
      hbex wph vy vz df-eu wph vy weu wph vy vz weq wb vy wal vz wex vx wph vy
      vz df-eu albii 3imtr4i $.
      $( [8-Mar-1995] $)
  $}

  ${
    $d x y z $.  $d ph z $.
    sb8eu.1 $e |- ( ph -> A. y ph ) $.
    $( Variable substitution in uniqueness quantifier.  (This theorem can also
       be proved without requiring that ` x ` and ` y ` be distinct, but
       the proof would be longer.) $)
    sb8eu $p |- ( E! x ph <-> E! y [ y / x ] ph ) $=
      wph vx vz weq wb vx wal vz wex wph vx vy wsb vy vz weq wb vy wal vz wex
      wph vx weu wph vx vy wsb vy weu wph vx vz weq wb vx wal wph vx vy wsb vy
      vz weq wb vy wal vz wph vx vz weq wb vx wal wph vx vz weq wb vx vy wsb vy
      wal wph vx vy wsb vy vz weq wb vy wal wph vx vz weq wb vx vy wph vx vz
      weq vy sb8eu.1 vx vz weq vy ax-17 hbbi sb8 wph vx vz weq wb vx vy wsb wph
      vx vy wsb vy vz weq wb vy vx vz weq vy vz weq wph vx vy vx vz weq vy vz
      weq vx vy vy vz weq vx ax-17 vx vy vz equequ1 sbie sblbis albii bitri
      exbii wph vx vz df-eu wph vx vy wsb vy vz df-eu 3bitr4i $.
      $( [7-Aug-1994] $)
  $}

  ${
    $d x y $.
    cbveu.1 $e |- ( ph -> A. y ph ) $.
    cbveu.2 $e |- ( ps -> A. x ps ) $.
    cbveu.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbveu $p |- ( E! x ph <-> E! y ps ) $=
      wph vx weu wph vx vy wsb vy weu wps vy weu wph vx vy cbveu.1 sb8eu wph vx
      vy wsb wps vy wph wps vx vy cbveu.2 cbveu.3 sbie eubii bitri $.
      $( [25-Nov-1994] $)
  $}

  ${
    $d x y $.
    eu1.1 $e |- ( ph -> A. y ph ) $.
    $( An alternate way to express uniqueness used by some authors.
       Exercise 2(b) of [Margaris] p. 110. $)
    eu1 $p |- ( E! x ph <->
                E. x ( ph /\ A. y ( [ y / x ] ph -> x = y ) ) ) $=
      wph vx vy wsb vy weu wph vx vy wsb vy vx weq wb vy wal vx wex wph vx weu
      wph wph vx vy wsb vx vy weq wi vy wal wa vx wex wph vx vy wsb vy vx wph
      vx vy hbs1 euf wph vx vy eu1.1 sb8eu wph wph vx vy wsb vx vy weq wi vy
      wal wa wph vx vy wsb vy vx weq wb vy wal vx wph vx vy wsb vx vy weq wi vy
      wal wph wa wph vx vy wsb vy vx weq wi vy wal vy vx weq wph vx vy wsb wi
      vy wal wa wph wph vx vy wsb vx vy weq wi vy wal wa wph vx vy wsb vy vx
      weq wb vy wal wph vx vy wsb vx vy weq wi vy wal wph vx vy wsb vy vx weq
      wi vy wal wph vy vx weq wph vx vy wsb wi vy wal wph vx vy wsb vx vy weq
      wi wph vx vy wsb vy vx weq wi vy vx vy weq vy vx weq wph vx vy wsb vx vy
      equcom imbi2i albii wph vx vy eu1.1 sb6rf anbi12i wph wph vx vy wsb vx vy
      weq wi vy wal ancom wph vx vy wsb vy vx weq vy albi 3bitr4i exbii 3bitr4i
      $.
      $( [20-Aug-1993] $)
  $}

  ${
    $d x y z $.  $d ph z $.
    mo.1 $e |- ( ph -> A. y ph ) $.
    $( Equivalent definitions of "there exists at most one." $)
    mo $p |- ( E. y A. x ( ph -> x = y ) <->
               A. x A. y ( ( ph /\ [ y / x ] ph ) -> x = y ) ) $=
      wph vx vy weq wi vx wal vy wex wph wph vx vy wsb wa vx vy weq wi vy wal
      vx wal wph vx vy weq wi vx wal vy wex wph vx vz weq wi vx wal vz wex wph
      wph vx vy wsb wa vx vy weq wi vy wal vx wal wph vx vz weq wi vx wal wph
      vx vy weq wi vx wal vz vy wph vx vz weq wi vy vx wph vx vz weq vy mo.1 vx
      vz weq vy ax-17 hbim hbal wph vx vy weq wi vx wal vz ax-17 vz vy weq wph
      vx vz weq wi wph vx vy weq wi vx vz vy weq vx vz weq vx vy weq wph vz vy
      vx equequ2 imbi2d albidv cbvex wph vx vz weq wi vx wal wph wph vx vy wsb
      wa vx vy weq wi vy wal vx wal vz wph vx vz weq wi vx wal wph vx vz weq wi
      wph vx vy wsb vy vz weq wi wa vy wal vx wal wph wph vx vy wsb wa vx vy
      weq wi vy wal vx wal wph vx vz weq wi vx wal wph vx vz weq wi vx wal wph
      vx vy wsb vy vz weq wi vy wal wa wph vx vz weq wi wph vx vy wsb vy vz weq
      wi wa vy wal vx wal wph vx vz weq wi vx wal wph vx vy wsb vy vz weq wi vy
      wal wph vx vz weq wi wph vx vy wsb vy vz weq wi vx vy wph vx vz weq vy
      mo.1 vx vz weq vy ax-17 hbim wph vx vy wsb vy vz weq vx wph vx vy hbs1 vy
      vz weq vx ax-17 hbim vx vy weq wph vx vy wsb wph vx vz weq vy vz weq wph
      vx vy sbequ2 vx vy vz ax-8 imim12d cbv3 ancli wph vx vz weq wi wph vx vy
      wsb vy vz weq wi vx vy wph vx vz weq vy mo.1 vx vz weq vy ax-17 hbim wph
      vx vy wsb vy vz weq vx wph vx vy hbs1 vy vz weq vx ax-17 hbim aaan sylibr
      wph vx vz weq wi wph vx vy wsb vy vz weq wi wa wph wph vx vy wsb wa vx vy
      weq wi vx vy wph vx vz weq wi wph vx vy wsb vy vz weq wi wa wph wph vx vy
      wsb wa vx vz weq vy vz weq wa vx vy weq wph vx vz weq wph vx vy wsb vy vz
      weq prth vx vy vz equtr2 syl6 19.20i2 syl 19.23aiv sylbir wph vx vy wsb
      vy wex wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wph vx vy weq wi
      vx wal vy wex wi wph vx vy wsb vy wex wph vx vy wsb wph vx vy weq wi wi
      vy wal vx wal wph vx vy weq wi vx wal vy wex wph wph vx vy wsb wa vx vy
      weq wi vy wal vx wal wph vx vy wsb wph vx vy weq wi wi vy wal vx wal wph
      vx vy wsb vx wal vy wex wph vx vy weq wi vx wal vy wex wph vx vy wsb vy
      wex wph vx vy wsb wph vx vy weq wi wi vy wal vx wal wph vx vy wsb vx wal
      wph vx vy weq wi vx wal wi vy wal wph vx vy wsb vx wal vy wex wph vx vy
      weq wi vx wal vy wex wi wph vx vy wsb wph vx vy weq wi wi wph vx vy wsb
      vx wal wph vx vy weq wi vx wal wi vy wal vy vx wph vx vy wsb wph vx vy
      weq wi wi vx wal wph vx vy wsb vx wal wph vx vy weq wi vx wal wi vy wph
      vx vy wsb wph vx vy weq wi vx 19.20 19.20i a7s wph vx vy wsb vx wal wph
      vx vy weq wi vx wal vy 19.22 syl wph vx vy wsb wph vx vy wsb vx wal vy
      wph vx vy mo.1 hbsb3 19.22i syl5com wph wph vx vy wsb wa vx vy weq wi wph
      vx vy wsb wph vx vy weq wi wi vx vy wph wph vx vy wsb wa vx vy weq wi wph
      wph vx vy wsb vx vy weq wi wi wph vx vy wsb wph vx vy weq wi wi wph wph
      vx vy wsb vx vy weq impexp wph wph vx vy wsb vx vy weq bi2.04 bitri
      2albii syl5ib wph vx vy wsb vy wex wn wph vx vy weq wi vx wal vy wex wph
      wph vx vy wsb wa vx vy weq wi vy wal vx wal wph vx vy wsb vy wex wn wph
      vx vy wsb wn vy wal wph vx vy weq wi vx wal vy wex wph vx vy wsb vy alnex
      wph vx vy wsb wn vy wal wph wn vx wal wph vx vy weq wi vx wal wph vx vy
      weq wi vx wal vy wex wph vx vy wsb wn wph wn vy vx wph vx vy wsb vx wph
      vx vy mo.1 hbsb3 hbn wph vy mo.1 hbn vy vx weq wph wph vx vy wsb wph wph
      vx vy wsb wi vx vy wph vx vy sbequ1 equcoms con3d cbv3 wph wn wph vx vy
      weq wi vx wph vx vy weq pm2.21 19.20i wph vx vy weq wi vx wal vy 19.8a
      3syl sylbir a1d pm2.61i impbii $.
      $( [7-Aug-1994] $)
  $}

  ${
    $d x y $.  $d ph y $.
    $( Existential uniqueness implies existence. $)
    euex $p |- ( E! x ph -> E. x ph ) $=
      wph vx weu wph vx wex wph vx vy wsb vx vy weq wi vy wal vx wex wph vx weu
      wph wph vx vy wsb vx vy weq wi vy wal wa vx wex wph vx wex wph vx vy wsb
      vx vy weq wi vy wal vx wex wa wph vx vy wph vy ax-17 eu1 wph wph vx vy
      wsb vx vy weq wi vy wal vx 19.40 sylbi pm3.26d $.
      $( [15-Sep-1993] $)
  $}

  ${
    $d x y $.
    eumo0.1 $e |- ( ph -> A. y ph ) $.
    $( Existential uniqueness implies "at most one." $)
    eumo0 $p |- ( E! x ph -> E. y A. x ( ph -> x = y ) ) $=
      wph vx weu wph vx vy weq wb vx wal vy wex wph vx vy weq wi vx wal vy wex
      wph vx vy eumo0.1 euf wph vx vy weq wb vx wal wph vx vy weq wi vx wal vy
      wph vx vy weq wb wph vx vy weq wi vx wph vx vy weq bi1 19.20i 19.22i
      sylbi $.
      $( [8-Jul-1994] $)
  $}

  ${
    $d x y $.
    eu2.1 $e |- ( ph -> A. y ph ) $.
    $( An alternate way of defining existential uniqueness.  Definition 6.10 of
       [TakeutiZaring] p. 26. $)
    eu2 $p |- ( E! x ph <->
    ( E. x ph /\ A. x A. y ( ( ph /\ [ y / x ] ph ) -> x = y ) ) ) $=
      wph vx weu wph vx wex wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wa
      wph vx weu wph vx wex wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wph
      vx euex wph vx weu wph vx vy weq wi vx wal vy wex wph wph vx vy wsb wa vx
      vy weq wi vy wal vx wal wph vx vy eu2.1 eumo0 wph vx vy eu2.1 mo sylib
      jca wph vx wex wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wa wph wph
      vx vy wsb vx vy weq wi vy wal wa vx wex wph vx weu wph vx wex wph wph vx
      vy wsb wa vx vy weq wi vy wal vx wal wa wph wph wph vx vy wsb wa vx vy
      weq wi vy wal wa vx wex wph wph vx vy wsb vx vy weq wi vy wal wa vx wex
      wph wph wph vx vy wsb wa vx vy weq wi vy wal vx 19.29r wph wph wph vx vy
      wsb wa vx vy weq wi vy wal wa wph wph vx vy wsb vx vy weq wi vy wal wa vx
      wph wph wph vx vy wsb wa vx vy weq wi vy wal wa wph wph wph vx vy wsb vx
      vy weq wi vy wal wi wa wph wph vx vy wsb vx vy weq wi vy wal wa wph wph
      vx vy wsb wa vx vy weq wi vy wal wph wph vx vy wsb vx vy weq wi vy wal wi
      wph wph wph vx vy wsb wa vx vy weq wi vy wal wph wph vx vy wsb vx vy weq
      wi wi vy wal wph wph vx vy wsb vx vy weq wi vy wal wi wph wph vx vy wsb
      wa vx vy weq wi wph wph vx vy wsb vx vy weq wi wi vy wph wph vx vy wsb vx
      vy weq impexp albii wph wph vx vy wsb vx vy weq wi vy eu2.1 19.21 bitri
      anbi2i wph wph vx vy wsb vx vy weq wi vy wal abai bitr4i exbii sylib wph
      vx vy eu2.1 eu1 sylibr impbii $.
      $( [8-Jul-1994] $)
  $}

  ${
    $d x y $.
    eu3.1 $e |- ( ph -> A. y ph ) $.
    $( An alternate way to express existential uniqueness. $)
    eu3 $p |- ( E! x ph <->
                ( E. x ph /\ E. y A. x ( ph -> x = y ) ) ) $=
      wph vx weu wph vx wex wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wa
      wph vx wex wph vx vy weq wi vx wal vy wex wa wph vx vy eu3.1 eu2 wph vx
      vy weq wi vx wal vy wex wph wph vx vy wsb wa vx vy weq wi vy wal vx wal
      wph vx wex wph vx vy eu3.1 mo anbi2i bitr4i $.
      $( [8-Jul-1994] $)
  $}

  ${
    euor.1 $e |- ( ph -> A. x ph ) $.
    $( Introduce a disjunct into a uniqueness quantifier. $)
    euor $p |- ( ( -. ph /\ E! x ps ) -> E! x ( ph \/ ps ) ) $=
      wph wn wps vx weu wph wps wo vx weu wph wn wps wph wps wo vx wph vx
      euor.1 hbn wph wps biorf eubid biimpa $.
      $( [22-Oct-2005] $) $( [21-Oct-2005] $)
  $}

  ${
    $d x ph $.
    $( Introduce a disjunct into a uniqueness quantifier. $)
    euorv $p |- ( ( -. ph /\ E! x ps ) -> E! x ( ph \/ ps ) ) $=
      wph wps vx wph vx ax-17 euor $.
      $( [23-Mar-1995] $)
  $}

  ${
    $d x y $.
    mo2.1 $e |- ( ph -> A. y ph ) $.
    $( Alternate definition of "at most one." $)
    mo2 $p |- ( E* x ph <-> E. y A. x ( ph -> x = y ) ) $=
      wph vx wmo wph vx wex wph vx weu wi wph vx vy weq wi vx wal vy wex wph vx
      df-mo wph vx wex wph vx weu wi wph vx vy weq wi vx wal vy wex wph vx wex
      wph vx weu wph vx vy weq wi vx wal vy wex wph vx wex wn wph wn vx wal wph
      vx vy weq wi vx wal vy wex wph vx alnex wph wn vx wal wph vx vy weq wi vx
      wal wph vx vy weq wi vx wal vy wex wph wn wph vx vy weq wi vx wph vx vy
      weq pm2.21 19.20i wph vx vy weq wi vx wal vy 19.8a syl sylbir wph vx vy
      mo2.1 eumo0 ja wph vx wex wph vx vy weq wi vx wal vy wex wph vx weu wph
      vx weu wph vx wex wph vx vy weq wi vx wal vy wex wa wph vx vy mo2.1 eu3
      biimpri expcom impbii bitri $.
      $( [8-Mar-1995] $)
  $}

  ${
    $d x y $.
    mo3.1 $e |- ( ph -> A. y ph ) $.
    $( Alternate definition of "at most one."  Definition of [BellMachover]
       p. 460, except that definition has the side condition that ` y ` not
       occur in ` ph ` in place of our hypothesis. $)
    mo3 $p |- ( E* x ph <->
               A. x A. y ( ( ph /\ [ y / x ] ph ) -> x = y ) ) $=
      wph vx wmo wph vx vy weq wi vx wal vy wex wph wph vx vy wsb wa vx vy weq
      wi vy wal vx wal wph vx vy mo3.1 mo2 wph vx vy mo3.1 mo bitri $.
      $( [8-Mar-1995] $)
  $}

  ${
    $d x y $.  $d y ph $.
    mo4f.1 $e |- ( ps -> A. x ps ) $.
    mo4f.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( "At most one" expressed using implicit substitution. $)
    mo4f $p |- ( E* x ph <-> A. x A. y ( ( ph /\ ps ) -> x = y ) ) $=
      wph vx wmo wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wph wps wa vx
      vy weq wi vy wal vx wal wph vx vy wph vy ax-17 mo3 wph wph vx vy wsb wa
      vx vy weq wi wph wps wa vx vy weq wi vx vy wph wph vx vy wsb wa wph wps
      wa vx vy weq wph vx vy wsb wps wph wph wps vx vy mo4f.1 mo4f.2 sbie
      anbi2i imbi1i 2albii bitri $.
      $( [12-Apr-2004] $) $( [10-Apr-2004] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    mo4.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( "At most one" expressed using implicit substitution. $)
    mo4 $p |- ( E* x ph <-> A. x A. y ( ( ph /\ ps ) -> x = y ) ) $=
      wph wps vx vy wps vx ax-17 mo4.1 mo4f $.
      $( [26-Jul-1995] $)
  $}

  ${
    mobid.1 $e |- ( ph -> A. x ph ) $.
    mobid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for "at most one" quantifier (deduction rule). $)
    mobid $p |- ( ph -> ( E* x ps <-> E* x ch ) ) $=
      wph wps vx wex wps vx weu wi wch vx wex wch vx weu wi wps vx wmo wch vx
      wmo wph wps vx wex wch vx wex wps vx weu wch vx weu wph wps wch vx
      mobid.1 mobid.2 exbid wph wps wch vx mobid.1 mobid.2 eubid imbi12d wps vx
      df-mo wch vx df-mo 3bitr4g $.
      $( [8-Mar-1995] $)
  $}

  ${
    mobii.1 $e |- ( ps <-> ch ) $.
    $( Formula-building rule for "at most one" quantifier (inference rule). $)
    mobii $p |- ( E* x ps <-> E* x ch ) $=
      vx vx weq wps vx wmo wch vx wmo wb vx equid vx vx weq wps wch vx vx
      hbequid2 wps wch wb vx vx weq mobii.1 a1i mobid ax-mp $.
      $( [9-Mar-1995] $)
  $}

  $( Bound-variable hypothesis builder for "at most one." $)
  hbmo1 $p |- ( E* x ph -> A. x E* x ph ) $=
    wph vx wex wph vx weu wi wph vx wex wph vx weu wi vx wal wph vx wmo wph vx
    wmo vx wal wph vx wex wph vx weu vx wph vx hbe1 wph vx hbeu1 hbim wph vx
    df-mo wph vx wmo wph vx wex wph vx weu wi vx wph vx df-mo albii 3imtr4i $.
    $( [8-Mar-1995] $)

  ${
    hbmo.1 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for "at most one." $)
    hbmo $p |- ( E* y ph -> A. x E* y ph ) $=
      wph vy wex wph vy weu wi wph vy wex wph vy weu wi vx wal wph vy wmo wph
      vy wmo vx wal wph vy wex wph vy weu vx wph vx vy hbmo.1 hbex wph vx vy
      hbmo.1 hbeu hbim wph vy df-mo wph vy wmo wph vy wex wph vy weu wi vx wph
      vy df-mo albii 3imtr4i $.
      $( [9-Mar-1995] $)
  $}

  ${
    $d x y $.
    cbvmo.1 $e |- ( ph -> A. y ph ) $.
    cbvmo.2 $e |- ( ps -> A. x ps ) $.
    cbvmo.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbvmo $p |- ( E* x ph <-> E* y ps ) $=
      wph vx wex wph vx weu wi wps vy wex wps vy weu wi wph vx wmo wps vy wmo
      wph vx wex wps vy wex wph vx weu wps vy weu wph wps vx vy cbvmo.1 cbvmo.2
      cbvmo.3 cbvex wph wps vx vy cbvmo.1 cbvmo.2 cbvmo.3 cbveu imbi12i wph vx
      df-mo wps vy df-mo 3bitr4i $.
      $( [9-Mar-1995] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( Uniqueness in terms of "at most one." $)
    eu5 $p |- ( E! x ph <-> ( E. x ph /\ E* x ph ) ) $=
      wph vx weu wph vx wex wph vx vy weq wi vx wal vy wex wa wph vx wex wph vx
      wmo wa wph vx vy wph vy ax-17 eu3 wph vx wmo wph vx vy weq wi vx wal vy
      wex wph vx wex wph vx vy wph vy ax-17 mo2 anbi2i bitr4i $.
      $( [23-Mar-1995] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    eu4.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Uniqueness using implicit substitution. $)
    eu4 $p |- ( E! x ph <-> ( E. x ph /\
             A. x A. y ( ( ph /\ ps ) -> x = y ) ) ) $=
      wph vx weu wph vx wex wph vx wmo wa wph vx wex wph wps wa vx vy weq wi vy
      wal vx wal wa wph vx eu5 wph vx wmo wph wps wa vx vy weq wi vy wal vx wal
      wph vx wex wph wps vx vy eu4.1 mo4 anbi2i bitri $.
      $( [26-Jul-1995] $)
  $}

  $( Existential uniqueness implies "at most one." $)
  eumo $p |- ( E! x ph -> E* x ph ) $=
    wph vx weu wph vx wex wph vx wmo wph vx eu5 pm3.27bi $.
    $( [23-Mar-1995] $)

  ${
    eumoi.1 $e |- E! x ph $.
    $( "At most one" inferred from existential uniqueness. $)
    eumoi $p |- E* x ph $=
      wph vx weu wph vx wmo eumoi.1 wph vx eumo ax-mp $.
      $( [5-Apr-1995] $)
  $}

  $( Existence in terms of "at most one" and uniqueness. $)
  exmoeu $p |- ( E. x ph <-> ( E* x ph -> E! x ph ) ) $=
    wph vx wex wph vx wmo wph vx weu wi wph vx wmo wph vx wex wph vx weu wph vx
    wmo wph vx wex wph vx weu wi wph vx df-mo biimpi com12 wph vx wmo wph vx
    weu wi wph vx wex wph vx weu wi wph vx wex wi wph vx wex wph vx wex wph vx
    weu wi wph vx wmo wph vx weu wph vx wex wph vx wmo wph vx wex wph vx weu wi
    wph vx df-mo biimpri wph vx euex imim12i wph vx wex wph vx weu peirce syl
    impbii $.
    $( [17-Apr-2004] $) $( [5-Apr-2004] $)

  $( Existence implies "at most one" is equivalent to uniqueness. $)
  exmoeu2 $p |- ( E. x ph -> ( E* x ph <-> E! x ph ) ) $=
    wph vx weu wph vx wex wph vx wmo wph vx eu5 baibr $.
    $( [18-Apr-2004] $) $( [5-Apr-2004] $)

  $( Absorption of existence condition by "at most one." $)
  moabs $p |- ( E* x ph <-> ( E. x ph -> E* x ph ) ) $=
    wph vx wex wph vx wex wph vx weu wi wi wph vx wex wph vx weu wi wph vx wex
    wph vx wmo wi wph vx wmo wph vx wex wph vx weu pm5.4 wph vx wmo wph vx wex
    wph vx weu wi wph vx wex wph vx df-mo imbi2i wph vx df-mo 3bitr4ri $.
    $( [4-Nov-2002] $)

  $( Something exists or at most one exists. $)
  exmo $p |- ( E. x ph \/ E* x ph ) $=
    wph vx wex wph vx wmo wph vx wex wn wph vx wex wph vx weu wi wph vx wmo wph
    vx wex wph vx weu pm2.21 wph vx df-mo sylibr orri $.
    $( [8-Mar-1995] $)

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    $( "At most one" is preserved through implication (notice wff reversal). $)
    immo $p |- ( A. x ( ph -> ps ) -> ( E* x ps -> E* x ph ) ) $=
      wph wps wi vx wal wps vx vy weq wi vx wal vy wex wph vx vy weq wi vx wal
      vy wex wps vx wmo wph vx wmo wph wps wi vx wal wps vx vy weq wi vx wal
      wph vx vy weq wi vx wal vy wph wps wi wps vx vy weq wi wph vx vy weq wi
      vx wph wps vx vy weq imim1 19.20ii 19.22dv wps vx vy wps vy ax-17 mo2 wph
      vx vy wph vy ax-17 mo2 3imtr4g $.
      $( [22-Apr-1995] $)
  $}

  ${
    immoi.1 $e |- ( ph -> ps ) $.
    $( "At most one" is preserved through implication (notice wff reversal). $)
    immoi $p |- ( E* x ps -> E* x ph ) $=
      wph wps wi wps vx wmo wph vx wmo wi vx wph wps vx immo immoi.1 mpg $.
      $( [16-Feb-2006] $) $( [15-Feb-2006] $)
  $}

  ${
    $d x y $.  $d x y ph $.  $d y ps $.
    $( Move antecedent outside of "at most one." $)
    moimv $p |- ( E* x ( ph -> ps ) -> ( ph -> E* x ps ) ) $=
      wph wph wps wi vx wmo wps vx wmo wph wph wps wi vx vy weq wi vx wal vy
      wex wps vx vy weq wi vx wal vy wex wph wps wi vx wmo wps vx wmo wph wph
      wps wi vx vy weq wi vx wal wps vx vy weq wi vx wal vy wph wph wps wi vx
      vy weq wi wps vx vy weq wi vx wph wps wph wps wi vx vy weq wps wph wps wi
      wi wph wps wph ax-1 a1i imim1d 19.20dv 19.22dv wph wps wi vx vy wph wps
      wi vy ax-17 mo2 wps vx vy wps vy ax-17 mo2 3imtr4g com12 $.
      $( [28-Jul-1995] $)
  $}

  $( Uniqueness implies "at most one" through implication. $)
  euimmo $p |- ( A. x ( ph -> ps ) -> ( E! x ps -> E* x ph ) ) $=
    wph wps wi vx wal wps vx wmo wph vx wmo wps vx weu wph wps vx immo wps vx
    eumo syl5 $.
    $( [22-Apr-1995] $)

  $( Add existential uniqueness quantifiers to an implication.  Note the
     reversed implication in the antecedent. $)
  euim $p |- ( ( E. x ph /\ A. x ( ph -> ps ) ) -> ( E! x ps -> E! x ph ) ) $=
    wph vx wex wph wps wi vx wal wa wps vx weu wph vx wmo wph vx weu wph wps wi
    vx wal wps vx weu wph vx wmo wi wph vx wex wph wps vx euimmo adantl wph vx
    wex wph vx wmo wph vx weu wb wph wps wi vx wal wph vx exmoeu2 adantr sylibd
    $.
    $( [20-Oct-2005] $) $( [19-Oct-2005] $)

  $( "At most one" is still the case when a conjunct is added. $)
  moan $p |- ( E* x ph -> E* x ( ps /\ ph ) ) $=
    wps wph wa wph vx wps wph pm3.27 immoi $.
    $( [22-Apr-1995] $)

  ${
    moani.1 $e |- E* x ph $.
    $( "At most one" is still true when a conjunct is added. $)
    moani $p |- E* x ( ps /\ ph ) $=
      wph vx wmo wps wph wa vx wmo moani.1 wph wps vx moan ax-mp $.
      $( [9-Mar-1995] $)
  $}

  $( "At most one" is still the case when a disjunct is removed. $)
  moor $p |- ( E* x ( ph \/ ps ) -> E* x ph ) $=
    wph wph wps wo vx wph wps orc immoi $.
    $( [19-Apr-2004] $) $( [5-Apr-2004] $)

  $( "At most one" imports disjunction to conjunction. $)
  mooran1 $p |- ( ( E* x ph \/ E* x ps ) -> E* x ( ph /\ ps ) ) $=
    wph vx wmo wph wps wa vx wmo wps vx wmo wph vx wmo wps wph wa vx wmo wph
    wps wa vx wmo wph wps vx moan wps wph wa wph wps wa vx wps wph ancom mobii
    sylib wps wph vx moan jaoi $.
    $( [20-Apr-2004] $) $( [5-Apr-2004] $)

  $( "At most one" exports disjunction to conjunction. $)
  mooran2 $p |- ( E* x ( ph \/ ps ) -> ( E* x ph /\ E* x ps ) ) $=
    wph wps wo vx wmo wph vx wmo wps vx wmo wph wps vx moor wph wps wo vx wmo
    wps wph wo vx wmo wps vx wmo wph wps wo wps wph wo vx wph wps orcom mobii
    wps wph vx moor sylbi jca $.
    $( [21-Apr-2004] $) $( [5-Apr-2004] $)

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    moanim.1 $e |- ( ph -> A. x ph ) $.
    $( Introduction of a conjunct into "at most one" quantifier. $)
    moanim $p |- ( E* x ( ph /\ ps ) <-> ( ph -> E* x ps ) ) $=
      wph wps wa vx vy weq wi vx wal vy wex wph wps vx vy weq wi vx wal wi vy
      wex wph wps wa vx wmo wph wps vx wmo wi wph wps wa vx vy weq wi vx wal
      wph wps vx vy weq wi vx wal wi vy wph wps wa vx vy weq wi vx wal wph wps
      vx vy weq wi wi vx wal wph wps vx vy weq wi vx wal wi wph wps wa vx vy
      weq wi wph wps vx vy weq wi wi vx wph wps vx vy weq impexp albii wph wps
      vx vy weq wi vx moanim.1 19.21 bitri exbii wph wps wa vx vy wph wps wa vy
      ax-17 mo2 wph wps vx wmo wi wph wps vx vy weq wi vx wal vy wex wi wph wps
      vx vy weq wi vx wal wi vy wex wps vx wmo wps vx vy weq wi vx wal vy wex
      wph wps vx vy wps vy ax-17 mo2 imbi2i wph wps vx vy weq wi vx wal vy
      19.37v bitr4i 3bitr4i $.
      $( [3-Dec-2001] $)

    $( Introduction of a conjunct into uniqueness quantifier. $)
    euan $p |- ( E! x ( ph /\ ps ) <-> ( ph /\ E! x ps ) ) $=
      wph wps wa vx wex wph wa wph wps wa vx wmo wa wph wph wa wps vx wex wps
      vx wmo wa wa wph wps wa vx weu wph wps vx weu wa wph wps wa vx wex wph
      wph wps wa vx wmo wa wa wph wps vx wex wa wph wps vx wmo wa wa wph wps wa
      vx wex wph wa wph wps wa vx wmo wa wph wph wa wps vx wex wps vx wmo wa wa
      wph wps wa vx wex wph wps vx wex wa wph wph wps wa vx wmo wa wph wps vx
      wmo wa wph wps vx moanim.1 19.42 wph wph wps wa vx wmo wa wph wph wps vx
      wmo wi wa wph wps vx wmo wa wph wps wa vx wmo wph wps vx wmo wi wph wph
      wps vx moanim.1 moanim anbi2i wph wps vx wmo abai bitr4i anbi12i wph wps
      wa vx wex wph wph wps wa vx wmo anass wph wph wps vx wex wps vx wmo an4
      3bitr4i wph wps wa vx weu wph wps wa vx wex wph wps wa vx wmo wa wph wps
      wa vx wex wph wa wph wps wa vx wmo wa wph wps wa vx eu5 wph wps wa vx wex
      wph wps wa vx wex wph wa wph wps wa vx wmo wph wps wa vx wex wph wps wa
      wph wa vx wex wph wps wa vx wex wph wa wph wps wa wph wa wph wps wa vx
      wph wps anabs1 exbii wph wps wa wph vx moanim.1 19.41 bitr3i anbi1i bitri
      wph wph wph wa wps vx weu wps vx wex wps vx wmo wa wph pm4.24 wps vx eu5
      anbi12i 3bitr4i $.
      $( [20-Feb-2005] $) $( [19-Feb-2005] $)
  $}

  ${
    $d x y ph $.  $d y ps $.
    $( Introduction of a conjunct into "at most one" quantifier. $)
    moanimv $p |- ( E* x ( ph /\ ps ) <-> ( ph -> E* x ps ) ) $=
      wph wps vx wph vx ax-17 moanim $.
      $( [23-Mar-1995] $)
  $}

  $( Nested "at most one" and uniqueness quantifiers. $)
  moaneu $p |- E* x ( ph /\ E! x ph ) $=
    wph wph vx weu wa vx wmo wph vx weu wph wa vx wmo wph vx weu wph wa vx wmo
    wph vx weu wph vx wmo wi wph vx eumo wph vx weu wph vx wph vx hbeu1 moanim
    mpbir wph wph vx weu wa wph vx weu wph wa vx wph wph vx weu ancom mobii
    mpbir $.
    $( [1-Mar-2006] $) $( [25-Jan-2006] $)

  $( Nested "at most one" quantifiers. $)
  moanmo $p |- E* x ( ph /\ E* x ph ) $=
    wph wph vx wmo wa vx wmo wph vx wmo wph wa vx wmo wph vx wmo wph wa vx wmo
    wph vx wmo wph vx wmo wi wph vx wmo id wph vx wmo wph vx wph vx hbmo1
    moanim mpbir wph wph vx wmo wa wph vx wmo wph wa vx wph wph vx wmo ancom
    mobii mpbir $.
    $( [26-Jan-2006] $) $( [25-Jan-2006] $)

  ${
    $d x ph $.
    $( Introduction of a conjunct into uniqueness quantifier. $)
    euanv $p |- ( E! x ( ph /\ ps ) <-> ( ph /\ E! x ps ) ) $=
      wph wps vx wph vx ax-17 euan $.
      $( [23-Mar-1995] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    $( "At most one" picks a variable value, eliminating an existential
       quantifier. $)
    mopick $p |- ( ( E* x ph /\ E. x ( ph /\ ps ) ) -> ( ph -> ps ) ) $=
      wph wps wa vx wex wph vx wmo wph wps wi wph wps wa vx wex wph vx vy wsb
      wps vx vy wsb wa vy wex wph vx wmo wph wps wi wi wph wps wa wph vx vy wsb
      wps vx vy wsb wa vx vy wph wps wa vy ax-17 wph vx vy wsb wps vx vy wsb vx
      wph vx vy hbs1 wps vx vy hbs1 hban vx vy weq wph wph vx vy wsb wps wps vx
      vy wsb wph vx vy sbequ12 wps vx vy sbequ12 anbi12d cbvex wph vx vy wsb
      wps vx vy wsb wa wph vx wmo wph wps wi wi vy wph vx vy wsb wps vx vy wsb
      wa wph wph vx vy wsb wa vx vy weq wi wph wps wi wph vx wmo wph vx vy wsb
      wps vx vy wsb wph wph vx vy wsb wa vx vy weq wi wph wps wi wi wph wph vx
      vy wsb wa vx vy weq wi wph wph vx vy wsb wps vx vy wsb wps wph wph vx vy
      wsb wa vx vy weq wi wph wph vx vy wsb wps vx vy wsb wps wi vx vy weq wps
      vx vy wsb wps wi wph wph vx vy wsb wa wps vx vy sbequ2 imim2i exp3a com4t
      imp wph vx wmo wph wph vx vy wsb wa vx vy weq wi vy wal vx wal wph wph vx
      vy wsb wa vx vy weq wi wph vx vy wph vy ax-17 mo3 wph wph vx vy wsb wa vx
      vy weq wi vy wal wph wph vx vy wsb wa vx vy weq wi vx wph wph vx vy wsb
      wa vx vy weq wi vy ax-4 a4s sylbi syl5 19.23aiv sylbi impcom $.
      $( [27-Jan-1997] $)
  $}

  $( Existential uniqueness "picks" a variable value for which another wff is
     true.  If there is only one thing ` x ` such that ` ph ` is true, and
     there is also an ` x ` (actually the same one) such that ` ph ` and ` ps `
     are both true, then ` ph ` implies ` ps ` regardless of ` x ` .  This
     theorem, which apparently does not appear explicitly in the literature,
     can be quite useful because it lets us eliminate existential quantifiers
     in a hypothesis. $)
  eupick $p |- ( ( E! x ph /\ E. x ( ph /\ ps ) ) -> ( ph -> ps ) ) $=
    wph vx wmo wph wps wa vx wex wph wps wi wph vx weu wph wps vx mopick wph vx
    eumo sylan $.
    $( [10-Jul-1994] $)

  $( Version of ~ eupick with closed formulas. $)
  eupicka $p |- ( ( E! x ph /\ E. x ( ph /\ ps ) ) -> A. x ( ph -> ps ) ) $=
    wph vx weu wph wps wa vx wex wa wph wps wi vx wph vx weu wph wps wa vx wex
    vx wph vx hbeu1 wph wps wa vx hbe1 hban wph wps vx eupick 19.21ai $.
    $( [24-Sep-2008] $) $( [6-Sep-2008] $)

  $( Existential uniqueness "pick" showing wff equivalence. $)
  eupickb $p |- ( ( E! x ph /\ E! x ps /\ E. x ( ph /\ ps ) ) ->
               ( ph <-> ps ) ) $=
    wph vx weu wps vx weu wph wps wa vx wex w3a wph wps wph vx weu wph wps wa
    vx wex wph wps wi wps vx weu wph wps vx eupick 3adant2 wph vx weu wps vx
    weu wph wps wa vx wex w3a wps vx weu wph wps wa vx wex wa wps vx weu wps
    wph wa vx wex wa wps wph wi wph vx weu wps vx weu wph wps wa vx wex 3simpc
    wph wps wa vx wex wps wph wa vx wex wps vx weu wph wps wa wps wph wa vx wph
    wps pm3.22 19.22i anim2i wps wph vx eupick 3syl impbid $.
    $( [25-Nov-1994] $)

  $( "At most one" can show the existence of a common value.  In this case we
     can infer existence of conjunction from a conjunction of existence, and
     it is one way to achieve the converse of ~ 19.40 . $)
  mopick2 $p |- ( ( E* x ph /\ E. x ( ph /\ ps ) /\ E. x ( ph /\ ch ) ) ->
                E. x ( ph /\ ps /\ ch ) ) $=
    wph vx wmo wph wps wa vx wex wph wch wa vx wex w3a wph vx wex wph wps wch
    w3a vx wex wph wps wa vx wex wph vx wmo wph vx wex wph wch wa vx wex wph
    wps wa wph vx wph wps pm3.26 19.22i 3ad2ant2 wph vx wmo wph wps wa vx wex
    wph wch wa vx wex w3a wph wph wps wch w3a vx wph vx wmo wph wps wa vx wex
    wph wch wa vx wex vx wph vx hbmo1 wph wps wa vx hbe1 wph wch wa vx hbe1
    hb3an wph vx wmo wph wps wa vx wex wph wch wa vx wex w3a wph wph wps wch wa
    wa wph wps wch w3a wph vx wmo wph wps wa vx wex wph wch wa vx wex w3a wph
    wps wch wa wph vx wmo wph wps wa vx wex wa wph vx wmo wph wch wa vx wex wa
    wa wph wps wi wph wch wi wa wph vx wmo wph wps wa vx wex wph wch wa vx wex
    w3a wph wps wch wa wi wph vx wmo wph wps wa vx wex wa wph wps wi wph vx wmo
    wph wch wa vx wex wa wph wch wi wph wps vx mopick wph wch vx mopick anim12i
    wph vx wmo wph wps wa vx wex wph wch wa vx wex w3a wph vx wmo wph wps wa vx
    wex wph wch wa vx wex wa wa wph vx wmo wph wps wa vx wex wa wph vx wmo wph
    wch wa vx wex wa wa wph vx wmo wph wps wa vx wex wph wch wa vx wex 3anass
    wph vx wmo wph wps wa vx wex wph wch wa vx wex anandi bitri wph wps wch
    jcab 3imtr4i ancld wph wps wch 3anass syl6ibr 19.22d mpd $.
    $( [22-Apr-2004] $) $( [5-Apr-2004] $)

  $( Introduce or eliminate a disjunct in a uniqueness quantifier. $)
  euor2 $p |- ( -. E. x ph -> ( E! x ( ph \/ ps ) <-> E! x ps ) ) $=
    wph vx wex wn wph wps wo vx weu wps vx weu wph vx wex wn wph wps wo vx weu
    wps vx wex wps vx wmo wa wps vx weu wph vx wex wn wph wps wo vx weu wps vx
    wex wps vx wmo wph wps wo vx weu wph vx wex wn wps vx wex wph wps wo vx weu
    wph vx wex wps vx wex wph wps wo vx weu wph wps wo vx wex wph vx wex wps vx
    wex wo wph wps wo vx euex wph wps vx 19.43 sylib ord com12 wph wps wo vx
    weu wps vx wmo wi wph vx wex wn wph wps wo vx weu wph wps wo vx wmo wps vx
    wmo wph wps wo vx eumo wph wps wo vx wmo wps wph wo vx wmo wps vx wmo wph
    wps wo wps wph wo vx wph wps orcom mobii wps wph vx moor sylbi syl a1i jcad
    wps vx eu5 syl6ibr wph vx wex wn wps vx weu wph wps wo vx weu wph vx wex wn
    wps vx weu wa wph vx wex wps wo vx weu wph wps wo vx weu wph vx wex wps vx
    wph vx hbe1 euor wps vx weu wph vx wex wps wo vx weu wph wps wo vx weu wi
    wph vx wex wn wps vx weu wps vx wex wph wps wo vx wex wph vx wex wps wo vx
    weu wph wps wo vx weu wi wps vx euex wps wph wps wo vx wps wph olc 19.22i
    wph wps wo vx wex wph wps wo wph vx wex wps wo wi vx wal wph vx wex wps wo
    vx weu wph wps wo vx weu wi wph wps wo wph vx wex wps wo wi vx wph wph vx
    wex wps wph vx 19.8a orim1i ax-gen wph wps wo wph vx wex wps wo vx euim
    mpan2 3syl adantl mpd ex impbid $.
    $( [25-Oct-2005] $) $( [21-Oct-2005] $)

  ${
    moexex.1 $e |- ( ph -> A. y ph ) $.
    $( "At most one" double quantification. $)
    moexex $p |- ( ( E* x ph /\ A. x E* y ps ) -> E* y E. x ( ph /\ ps ) ) $=
      wph vx wmo wps vy wmo vx wal wph wps wa vx wex vy wmo wph vx wex wph vx
      wmo wps vy wmo vx wal wph wps wa vx wex vy wmo wi wi wph wph vx wmo wps
      vy wmo vx wal wph wps wa vx wex vy wmo wi wi vx wph vx wmo wps vy wmo vx
      wal wph wps wa vx wex vy wmo wi vx wph vx hbmo1 wps vy wmo vx wal wph wps
      wa vx wex vy wmo vx wps vy wmo vx hba1 wph wps wa vx wex vx vy wph wps wa
      vx hbe1 hbmo hbim hbim wph wph vx wmo wph wps wa vx wex wps wi vy wal wps
      vy wmo vx wal wph wps wa vx wex vy wmo wi wph wph vx wmo wph wps wa vx
      wex wps wi vy moexex.1 wph vy vx moexex.1 hbmo wph vx wmo wph wps wa vx
      wex wph wps wph vx wmo wph wps wa vx wex wph wps wi wph wps vx mopick ex
      com3r 19.21ad wph wps wa vx wex wps wi vy wal wps vy wmo wph wps wa vx
      wex vy wmo vx wph wps wa vx wex wps vy immo a4sd syl6 19.23ai wph vx wex
      wn wps vy wmo vx wal wph wps wa vx wex vy wmo wi wph vx wmo wph vx wex wn
      wph wps wa vx wex vy wmo wps vy wmo vx wal wph vx wex wn wph wps wa vx
      wex vy wex wn wph wps wa vx wex vy wmo wph wps wa vx wex vy wex wph vx
      wex wph wps wa vx wex wph vx wex vy wph vy vx moexex.1 hbex wph wps wa
      wph vx wph wps pm3.26 19.22i 19.23ai con3i wph wps wa vx wex vy wex wph
      wps wa vx wex vy wmo wph wps wa vx wex vy exmo ori syl a1d a1d pm2.61i
      imp $.
      $( [3-Dec-2001] $)
  $}

  ${
    $d y ph $.
    $( "At most one" double quantification. $)
    moexexv $p |- ( ( E* x ph /\ A. x E* y ps ) -> E* y E. x ( ph /\ ps ) ) $=
      wph wps vx vy wph vy ax-17 moexex $.
      $( [26-Jan-1997] $)
  $}

  $( Double quantification with "at most one." $)
  2moex $p |- ( E* x E. y ph -> A. y E* x ph ) $=
    wph vy wex vx wmo wph vx wmo vy wph vy wex vy vx wph vy hbe1 hbmo wph wph
    vy wex vx wph vy 19.8a immoi 19.21ai $.
    $( [3-Dec-2001] $)

  $( Double quantification with existential uniqueness. $)
  2euex $p |- ( E! x E. y ph -> E. y E! x ph ) $=
    wph vy wex vx weu wph vy wex vx wex wph vy wex vx wmo wa wph vx weu vy wex
    wph vy wex vx eu5 wph vy wex vx wex wph vy wex vx wmo wa wph vx wex wph vy
    wex vx wmo wa vy wex wph vx weu vy wex wph vx wex vy wex wph vy wex vx wmo
    wph vx wex wph vy wex vx wmo wa vy wex wph vy wex vx wex wph vx wex wph vy
    wex vx wmo wa vy wex wph vx wex vy wex wph vy wex vx wmo wa wph vx wex wph
    vy wex vx wmo vy wph vy wex vy vx wph vy hbe1 hbmo 19.41 biimpri wph vx vy
    excom sylanb wph vx wex wph vy wex vx wmo wa wph vx weu vy wph vx wex wph
    vy wex vx wmo wa wph vx wex wph vx wmo wa wph vx weu wph vy wex vx wmo wph
    vx wmo wph vx wex wph vy wex vx wmo wph vx wmo vy wph vx vy 2moex 19.21bi
    anim2i wph vx eu5 sylibr 19.22i syl sylbi $.
    $( [3-Dec-2001] $)

  $( Double quantification with existential uniqueness and "at most one." $)
  2eumo $p |- ( E! x E* y ph -> E* x E! y ph ) $=
    wph vy weu wph vy wmo wi wph vy wmo vx weu wph vy weu vx wmo wi vx wph vy
    weu wph vy wmo vx euimmo wph vy eumo mpg $.
    $( [3-Dec-2001] $)

  $( Double existential uniqueness. $)
  2eu2ex $p |- ( E! x E! y ph -> E. x E. y ph ) $=
    wph vy weu vx weu wph vy weu vx wex wph vy wex vx wex wph vy weu vx euex
    wph vy weu wph vy wex vx wph vy euex 19.22i syl $.
    $( [3-Dec-2001] $)

  $( A condition allowing swap of "at most one" and existential quantifiers. $)
  2moswap $p |- ( A. x E* y ph -> ( E* x E. y ph -> E* y E. x ph ) ) $=
    wph vy wmo vx wal wph vy wex vx wmo wph vy wex wph wa vx wex vy wmo wph vx
    wex vy wmo wph vy wex vx wmo wph vy wmo vx wal wph vy wex wph wa vx wex vy
    wmo wph vy wex wph vx vy wph vy hbe1 moexex expcom wph vx wex wph vy wex
    wph wa vx wex vy wph wph vy wex wph wa vx wph wph vy wex wph vy 19.8a
    pm4.71ri exbii mobii syl6ibr $.
    $( [11-Apr-2004] $) $( [10-Apr-2004] $)

  $( A condition allowing swap of uniqueness and existential quantifiers. $)
  2euswap $p |- ( A. x E* y ph -> ( E! x E. y ph -> E! y E. x ph ) ) $=
    wph vy wmo vx wal wph vy wex vx wex wph vy wex vx wmo wa wph vx wex vy wex
    wph vx wex vy wmo wa wph vy wex vx weu wph vx wex vy weu wph vy wmo vx wal
    wph vy wex vx wex wph vx wex vy wex wph vy wex vx wmo wph vx wex vy wmo wph
    vy wex vx wex wph vx wex vy wex wi wph vy wmo vx wal wph vx vy excomim a1i
    wph vx vy 2moswap anim12d wph vy wex vx eu5 wph vx wex vy eu5 3imtr4g $.
    $( [13-Apr-2004] $) $( [10-Apr-2004] $)

  $( Double existential uniqueness implies double uniqueness quantification. $)
  2exeu $p |- ( ( E! x E. y ph /\ E! y E. x ph ) -> E! x E! y ph ) $=
    wph vy wex vx wex wph vy wex vx wmo wa wph vx wex vy wex wph vx wex vy wmo
    wa wa wph vy wex wph vy wmo wa vx wex wph vy wex wph vy wmo wa vx wmo wa
    wph vy wex vx weu wph vx wex vy weu wa wph vy weu vx weu wph vx wex vy wex
    wph vx wex vy wmo wa wph vy wex vx wex wph vy wex vx wmo wa wph vy wex wph
    vy wmo wa vx wex wph vy wex wph vy wmo wa vx wmo wa wph vx wex vy wex wph
    vx wex vy wmo wa wph vy wex wph vy wmo wa vx wex wph vy wex vx wex wph vy
    wex vx wmo wa wph vy wex wph vy wmo wa vx wmo wph vy wex vx wex wph vx wex
    vy wmo wph vy wex wph vy wmo wa vx wex wph vx wex vy wex wph vy wex vx wex
    wph vx wex vy wmo wa wph vy wex wph vx wex vy wmo wa vx wex wph vy wex wph
    vy wmo wa vx wex wph vy wex wph vx wex vy wmo vx wph vx wex vx vy wph vx
    hbe1 hbmo 19.41 wph vy wex wph vx wex vy wmo wa wph vy wex wph vy wmo wa vx
    wph vx wex vy wmo wph vy wmo wph vy wex wph wph vx wex vy wph vx 19.8a
    immoi anim2i 19.22i sylbir wph vy vx excom sylanb wph vy wex vx wmo wph vy
    wex wph vy wmo wa vx wmo wph vy wex vx wex wph vy wex wph vy wmo wa wph vy
    wex vx wph vy wex wph vy wmo pm3.26 immoi adantl anim12i ancoms wph vy wex
    vx weu wph vy wex vx wex wph vy wex vx wmo wa wph vx wex vy weu wph vx wex
    vy wex wph vx wex vy wmo wa wph vy wex vx eu5 wph vx wex vy eu5 anbi12i wph
    vy weu vx weu wph vy weu vx wex wph vy weu vx wmo wa wph vy wex wph vy wmo
    wa vx wex wph vy wex wph vy wmo wa vx wmo wa wph vy weu vx eu5 wph vy weu
    vx wex wph vy wex wph vy wmo wa vx wex wph vy weu vx wmo wph vy wex wph vy
    wmo wa vx wmo wph vy weu wph vy wex wph vy wmo wa vx wph vy eu5 exbii wph
    vy weu wph vy wex wph vy wmo wa vx wph vy eu5 mobii anbi12i bitri 3imtr4i
    $.
    $( [3-Dec-2001] $)

  ${
    $d x y z w v u $.  $d z w v u ph $.
    $( Two equivalent expressions for double "at most one." $)
    2mo $p |- ( E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) <->
              A. x A. y A. z A. w ( ( ph /\ [ z / x ] [ w / y ] ph ) ->
                   ( x = z /\ y = w ) ) ) $=
      wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wph wph vy vw
      wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw wal vz wal vy wal vx wal
      wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wph vx vv weq
      vy vu weq wa wi vy wal vx wal vu wex vv wex wph wph vy vw wsb vx vz wsb
      wa vx vz weq vy vw weq wa wi vw wal vz wal vy wal vx wal wph vx vv weq vy
      vu weq wa wi vy wal vx wal wph vx vz weq vy vw weq wa wi vy wal vx wal vv
      vu vz vw vv vz weq vu vw weq wa wph vx vv weq vy vu weq wa wi wph vx vz
      weq vy vw weq wa wi vx vy vv vz weq vu vw weq wa vx vv weq vy vu weq wa
      vx vz weq vy vw weq wa wph vv vz weq vx vv weq vx vz weq vu vw weq vy vu
      weq vy vw weq vv vz vx equequ2 vu vw vy equequ2 bi2anan9 imbi2d 2albidv
      cbvex2v wph vx vv weq vy vu weq wa wi vy wal vx wal wph wph vy vw wsb vx
      vz wsb wa vx vz weq vy vw weq wa wi vw wal vz wal vy wal vx wal vv vu wph
      vx vv weq vy vu weq wa wi vy wal vx wal wph vx vv weq vy vu weq wa wi wph
      vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi wa vw wal vz wal vy wal vx
      wal wph wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw wal vz
      wal vy wal vx wal wph vx vv weq vy vu weq wa wi vy wal vx wal wph vx vv
      weq vy vu weq wa wi vy wal vx wal wph vy vw wsb vx vz wsb vz vv weq vw vu
      weq wa wi vw wal vz wal wa wph vx vv weq vy vu weq wa wi wph vy vw wsb vx
      vz wsb vz vv weq vw vu weq wa wi wa vw wal vz wal vy wal vx wal wph vx vv
      weq vy vu weq wa wi vy wal vx wal wph vy vw wsb vx vz wsb vz vv weq vw vu
      weq wa wi vw wal vz wal wph vx vv weq vy vu weq wa wi vy wal vx wal wph
      vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi vw wal vz wal wph vx vv weq
      vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi vx vy
      vz vw wph vx vv weq vy vu weq wa wi vz ax-17 wph vx vv weq vy vu weq wa
      wi vw ax-17 wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa vx wph vy vw
      wsb vx vz hbs1 vz vv weq vw vu weq wa vx ax-17 hbim wph vy vw wsb vx vz
      wsb vz vv weq vw vu weq wa vy wph vy vw wsb vx vz vy wph vy vw hbs1 hbsb
      vz vv weq vw vu weq wa vy ax-17 hbim vx vz weq vy vw weq wa wph wph vy vw
      wsb vx vz wsb vx vv weq vy vu weq wa vz vv weq vw vu weq wa vy vw weq wph
      wph vy vw wsb vx vz weq wph vy vw wsb vx vz wsb wph vy vw sbequ12 wph vy
      vw wsb vx vz sbequ12 sylan9bbr vx vz weq vx vv weq vz vv weq vy vw weq vy
      vu weq vw vu weq vx vz vv equequ1 vy vw vu equequ1 bi2anan9 imbi12d
      cbval2 biimpi ancli wph vx vv weq vy vu weq wa wi wph vy vw wsb vx vz wsb
      vz vv weq vw vu weq wa wi wa vw wal vz wal vy wal vx wal wph vx vv weq vy
      vu weq wa wi vy wal wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi vw
      wal wa vz wal vx wal wph vx vv weq vy vu weq wa wi vy wal vx wal wph vy
      vw wsb vx vz wsb vz vv weq vw vu weq wa wi vw wal vz wal wa wph vx vv weq
      vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi wa vw
      wal vz wal vy wal wph vx vv weq vy vu weq wa wi vy wal wph vy vw wsb vx
      vz wsb vz vv weq vw vu weq wa wi vw wal wa vz wal vx wph vx vv weq vy vu
      weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi wa vw wal vz
      wal vy wal wph vx vv weq vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv
      weq vw vu weq wa wi wa vw wal vy wal vz wal wph vx vv weq vy vu weq wa wi
      vy wal wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi vw wal wa vz wal
      wph vx vv weq vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw vu weq
      wa wi wa vw wal vy vz alcom wph vx vv weq vy vu weq wa wi wph vy vw wsb
      vx vz wsb vz vv weq vw vu weq wa wi wa vw wal vy wal wph vx vv weq vy vu
      weq wa wi vy wal wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi vw wal
      wa vz wph vx vv weq vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw
      vu weq wa wi vy vw wph vx vv weq vy vu weq wa wi vw ax-17 wph vy vw wsb
      vx vz wsb vz vv weq vw vu weq wa vy wph vy vw wsb vx vz vy wph vy vw hbs1
      hbsb vz vv weq vw vu weq wa vy ax-17 hbim aaan albii bitri albii wph vx
      vv weq vy vu weq wa wi vy wal wph vy vw wsb vx vz wsb vz vv weq vw vu weq
      wa wi vw wal vx vz wph vx vv weq vy vu weq wa wi vy wal vz ax-17 wph vy
      vw wsb vx vz wsb vz vv weq vw vu weq wa wi vx vw wph vy vw wsb vx vz wsb
      vz vv weq vw vu weq wa vx wph vy vw wsb vx vz hbs1 vz vv weq vw vu weq wa
      vx ax-17 hbim hbal aaan bitri sylibr wph vx vv weq vy vu weq wa wi wph vy
      vw wsb vx vz wsb vz vv weq vw vu weq wa wi wa vw wal vz wal wph wph vy vw
      wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw wal vz wal vx vy wph vx vv
      weq vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi wa
      wph wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi vz vw wph vx vv
      weq vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi wa
      wph wph vy vw wsb vx vz wsb wa vx vv weq vy vu weq wa vz vv weq vw vu weq
      wa wa vx vz weq vy vw weq wa wph vx vv weq vy vu weq wa wph vy vw wsb vx
      vz wsb vz vv weq vw vu weq wa prth vx vv weq vz vv weq vy vu weq vw vu
      weq vx vz weq vy vw weq wa vx vv weq vz vv weq wa vx vz weq vy vu weq vw
      vu weq wa vy vw weq vx vz vv equtr2 vy vw vu equtr2 anim12i an4s syl6
      19.20i2 19.20i2 syl 19.23aivv sylbir wph vy vw wsb vx vz wsb vw wex vz
      wex wph wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw wal vz
      wal vy wal vx wal wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz
      wex wi wph vy vw wsb vx vz wsb vw wex vz wex wph vy vw wsb vx vz wsb wph
      vx vz weq vy vw weq wa wi wi vw wal vz wal vy wal vx wal wph vx vz weq vy
      vw weq wa wi vy wal vx wal vw wex vz wex wph wph vy vw wsb vx vz wsb wa
      vx vz weq vy vw weq wa wi vw wal vz wal vy wal vx wal wph vy vw wsb vx vz
      wsb wph vx vz weq vy vw weq wa wi wi vw wal vz wal vy wal vx wal wph vy
      vw wsb vx vz wsb vy wal vx wal vw wex vz wex wph vx vz weq vy vw weq wa
      wi vy wal vx wal vw wex vz wex wph vy vw wsb vx vz wsb vw wex vz wex wph
      vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi wi vw wal vz wal vy wal
      vx wal wph vy vw wsb vx vz wsb vy wal vx wal wph vx vz weq vy vw weq wa
      wi vy wal vx wal wi vw wal vz wal wph vy vw wsb vx vz wsb vy wal vx wal
      vw wex wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex wi vz wal wph
      vy vw wsb vx vz wsb vy wal vx wal vw wex vz wex wph vx vz weq vy vw weq
      wa wi vy wal vx wal vw wex vz wex wi wph vy vw wsb vx vz wsb wph vx vz
      weq vy vw weq wa wi wi vw wal vz wal vy wal vx wal wph vy vw wsb vx vz
      wsb wph vx vz weq vy vw weq wa wi wi vy wal vx wal vw wal vz wal wph vy
      vw wsb vx vz wsb vy wal vx wal wph vx vz weq vy vw weq wa wi vy wal vx
      wal wi vw wal vz wal wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa
      wi wi vx vy vz vw alrot4 wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq
      wa wi wi vy wal vx wal wph vy vw wsb vx vz wsb vy wal vx wal wph vx vz
      weq vy vw weq wa wi vy wal vx wal wi vz vw wph vy vw wsb vx vz wsb wph vx
      vz weq vy vw weq wa wi wi vy wal wph vy vw wsb vx vz wsb vy wal wph vx vz
      weq vy vw weq wa wi vy wal vx wph vy vw wsb vx vz wsb wph vx vz weq vy vw
      weq wa wi vy 19.20 19.20ii 19.20i2 sylbi wph vy vw wsb vx vz wsb vy wal
      vx wal wph vx vz weq vy vw weq wa wi vy wal vx wal wi vw wal wph vy vw
      wsb vx vz wsb vy wal vx wal vw wex wph vx vz weq vy vw weq wa wi vy wal
      vx wal vw wex wi vz wph vy vw wsb vx vz wsb vy wal vx wal wph vx vz weq
      vy vw weq wa wi vy wal vx wal vw 19.22 19.20i wph vy vw wsb vx vz wsb vy
      wal vx wal vw wex wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz
      19.22 3syl wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vy wal vx wal
      vz vw wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vy wal vx wph vy vw
      wsb vx vz hbs1 wph vy vw wsb vx vz vy wph vy vw hbs1 hbsb 19.21ai 19.22i2
      syl5com wph wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw wal
      vz wal wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi wi vw wal vz
      wal vx vy wph wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi wph vy
      vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi wi vz vw wph wph vy vw wsb
      vx vz wsb wa vx vz weq vy vw weq wa wi wph wph vy vw wsb vx vz wsb vx vz
      weq vy vw weq wa wi wi wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa
      wi wi wph wph vy vw wsb vx vz wsb vx vz weq vy vw weq wa impexp wph wph
      vy vw wsb vx vz wsb vx vz weq vy vw weq wa bi2.04 bitri 2albii 2albii
      syl5ib wph vy vw wsb vx vz wsb vw wex vz wex wn wph vx vz weq vy vw weq
      wa wi vy wal vx wal vw wex vz wex wph wph vy vw wsb vx vz wsb wa vx vz
      weq vy vw weq wa wi vw wal vz wal vy wal vx wal wph vy vw wsb vx vz wsb
      vw wex vz wex wn wph vy vw wsb vx vz wsb wn vw wal vz wal wph vx vz weq
      vy vw weq wa wi vy wal vx wal vw wex vz wex wph vy vw wsb vx vz wsb wn vw
      wal vz wal wph vy vw wsb vx vz wsb vw wex wn vz wal wph vy vw wsb vx vz
      wsb vw wex vz wex wn wph vy vw wsb vx vz wsb wn vw wal wph vy vw wsb vx
      vz wsb vw wex wn vz wph vy vw wsb vx vz wsb vw alnex albii wph vy vw wsb
      vx vz wsb vw wex vz alnex bitri wph vy vw wsb vx vz wsb wn vw wal vz wal
      wph wn vy wal vx wal wph vx vz weq vy vw weq wa wi vy wal vx wal wph vx
      vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wph wn vy wal vx wal
      wph vy vw wsb vx vz wsb wn vw wal vz wal wph wn wph vy vw wsb vx vz wsb
      wn vx vy vz vw wph wn vz ax-17 wph wn vw ax-17 wph vy vw wsb vx vz wsb vx
      wph vy vw wsb vx vz hbs1 hbn wph vy vw wsb vx vz wsb vy wph vy vw wsb vx
      vz vy wph vy vw hbs1 hbsb hbn vx vz weq vy vw weq wa wph wph vy vw wsb vx
      vz wsb vy vw weq wph wph vy vw wsb vx vz weq wph vy vw wsb vx vz wsb wph
      vy vw sbequ12 wph vy vw wsb vx vz sbequ12 sylan9bbr notbid cbval2 biimpri
      wph wn wph vx vz weq vy vw weq wa wi vx vy wph vx vz weq vy vw weq wa
      pm2.21 19.20i2 wph vx vz weq vy vw weq wa wi vy wal vx wal wph vx vz weq
      vy vw weq wa wi vy wal vx wal vw wex vz wex vw wph vx vz weq vy vw weq wa
      wi vy wal vx wal vw wex vz 19.8a 19.23bi 3syl sylbir a1d pm2.61i impbii
      $.
      $( [7-Feb-2005] $) $( [2-Feb-2005] $)
  $}

  ${
    $d z w ph $.  $d x y ps $.  $d x y z w $.
    2mos.1 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Double "exists at most one", using implicit substitition. $)
    2mos $p  |- ( E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) <->
             A. x A. y A. z A. w ( ( ph /\ ps ) -> ( x = z /\ y = w ) ) ) $=
      wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wph wph vy vw
      wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw wal vz wal vy wal vx wal
      wph wps wa vx vz weq vy vw weq wa wi vw wal vz wal vy wal vx wal wph vx
      vy vz vw 2mo wph wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi vw
      wal vz wal wph wps wa vx vz weq vy vw weq wa wi vw wal vz wal vx vy wph
      wph vy vw wsb vx vz wsb wa vx vz weq vy vw weq wa wi wph wps wa vx vz weq
      vy vw weq wa wi vz vw wph wph vy vw wsb vx vz wsb wa wph wps wa vx vz weq
      vy vw weq wa wph vy vw wsb vx vz wsb wps wph wph vy vw wsb wps vx vz wps
      vx ax-17 vx vz weq wph vy vw wsb wps vx vz weq wph vy vw wsb wi vx vz weq
      wph wi vy vw wsb vx vz weq wps wi vx vz weq wph vy vw vx vz weq vy ax-17
      sb19.21 vx vz weq wph wi vx vz weq wps wi vy vw vx vz weq wps wi vy ax-17
      vy vw weq vx vz weq wph wps vx vz weq vy vw weq wph wps wb 2mos.1 expcom
      pm5.74d sbie bitr3i pm5.74ri sbie anbi2i imbi1i 2albii 2albii bitri $.
      $( [17-May-2005] $) $( [10-Feb-2005] $)
  $}

  $( Double existential uniqueness.  This theorem shows a condition under
     which a "naive" definition matches the correct one. $)
  2eu1 $p |- ( A. x E* y ph ->
        ( E! x E! y ph <-> ( E! x E. y ph /\ E! y E. x ph ) ) ) $=
    wph vy wmo vx wal wph vy weu vx weu wph vy wex vx weu wph vx wex vy weu wa
    wph vy weu vx weu wph vy wmo vx wal wph vy wex vx weu wph vx wex vy weu wa
    wph vy weu vx weu wph vy wmo vx wal wph vy wex vx wex wph vx wex vy wex wa
    wph vy wex vx wmo wph vx wex vy wmo wa wa wph vy wex vx weu wph vx wex vy
    weu wa wph vy weu vx weu wph vy wmo vx wal wph vy wex vx wmo wph vx wex vy
    wmo wa wph vy wex vx wex wph vx wex vy wex wa wph vy weu vx weu wph vy wex
    wph vy wmo wa vx wmo wph vy wmo vx wal wph vy wex vx wmo wph vx wex vy wmo
    wa wi wph vy weu vx weu wph vy wex wph vy wmo wa vx wex wph vy wex wph vy
    wmo wa vx wmo wph vy weu vx weu wph vy weu vx wex wph vy weu vx wmo wa wph
    vy wex wph vy wmo wa vx wex wph vy wex wph vy wmo wa vx wmo wa wph vy weu
    vx eu5 wph vy weu vx wex wph vy wex wph vy wmo wa vx wex wph vy weu vx wmo
    wph vy wex wph vy wmo wa vx wmo wph vy weu wph vy wex wph vy wmo wa vx wph
    vy eu5 exbii wph vy weu wph vy wex wph vy wmo wa vx wph vy eu5 mobii
    anbi12i bitri pm3.27bi wph vy wex wph vy wmo wa vx wmo wph vy wmo vx wal
    wph vy wex vx wmo wph vy wmo vx wal wa wph vy wex vx wmo wph vx wex vy wmo
    wa wph vy wex wph vy wmo wa vx wmo wph vy wmo vx wal wph vy wex vx wmo wph
    vy wex wph vy wmo wa vx wmo wph vy wmo vx wal wph vy wex wa vx wmo wph vy
    wmo vx wal wph vy wex vx wmo wi wph vy wmo vx wal wph vy wex wa wph vy wex
    wph vy wmo wa vx wph vy wex wph vy wmo vx wal wph vy wex wph vy wmo wa wph
    vy wmo vx wal wph vy wmo wph vy wex wph vy wmo vx ax-4 anim2i ancoms immoi
    wph vy wmo vx wal wph vy wex vx wph vy wmo vx hba1 moanim sylib ancrd wph
    vy wex vx wmo wph vy wmo vx wal wph vx wex vy wmo wph vy wmo vx wal wph vy
    wex vx wmo wph vx wex vy wmo wph vx vy 2moswap com12 imdistani syl6 syl wph
    vy weu vx weu wph vy wex vx wex wph vx wex vy wex wph vx vy 2eu2ex wph vy
    weu vx weu wph vy wex vx wex wph vx wex vy wex wph vx vy 2eu2ex wph vx vy
    excom sylib jca jctild wph vy wex vx weu wph vx wex vy weu wa wph vy wex vx
    wex wph vy wex vx wmo wa wph vx wex vy wex wph vx wex vy wmo wa wa wph vy
    wex vx wex wph vx wex vy wex wa wph vy wex vx wmo wph vx wex vy wmo wa wa
    wph vy wex vx weu wph vy wex vx wex wph vy wex vx wmo wa wph vx wex vy weu
    wph vx wex vy wex wph vx wex vy wmo wa wph vy wex vx eu5 wph vx wex vy eu5
    anbi12i wph vy wex vx wex wph vy wex vx wmo wph vx wex vy wex wph vx wex vy
    wmo an4 bitri syl6ibr com12 wph vx vy 2exeu impbid1 $.
    $( [3-Dec-2001] $)

  $( Double existential uniqueness. $)
  2eu2 $p |- ( E! y E. x ph -> ( E! x E! y ph <-> E! x E. y ph ) ) $=
    wph vx wex vy weu wph vy weu vx weu wph vy wex vx weu wph vx wex vy weu wph
    vx wex vy wmo wph vy wmo vx wal wph vy weu vx weu wph vy wex vx weu wi wph
    vx wex vy eumo wph vy vx 2moex wph vy wmo vx wal wph vy weu vx weu wph vy
    wex vx weu wph vx wex vy weu wa wph vy wex vx weu wph vx vy 2eu1 wph vy wex
    vx weu wph vx wex vy weu pm3.26 syl6bi 3syl wph vy wex vx weu wph vx wex vy
    weu wph vy weu vx weu wph vx vy 2exeu expcom impbid $.
    $( [3-Dec-2001] $)


  $( Double existential uniqueness. $)
  2eu3 $p |- ( A. x A. y ( E* x ph \/ E* y ph ) ->
 ( ( E! x E! y ph /\ E! y E! x ph ) <-> ( E! x E. y ph /\ E! y E. x ph ) ) ) $=
    wph vx wmo wph vy wmo wo vy wal vx wal wph vx wmo vy wal wph vy wmo vx wal
    wo wph vy weu vx weu wph vx weu vy weu wa wph vy wex vx weu wph vx wex vy
    weu wa wb wph vx wmo wph vy wmo wo vy wal vx wal wph vx wmo vy wal wph vy
    wmo wo vx wal wph vx wmo vy wal wph vy wmo vx wal wo wph vx wmo wph vy wmo
    wo vy wal wph vx wmo vy wal wph vy wmo wo vx wph vx wmo wph vy wmo vy wph
    vy hbmo1 19.31 albii wph vx wmo vy wal wph vy wmo vx wph vx wmo vx vy wph
    vx hbmo1 hbal 19.32 bitri wph vx wmo vy wal wph vy wmo vx wal wo wph vy weu
    vx weu wph vx weu vy weu wa wph vy wex vx weu wph vx wex vy weu wa wph vx
    wmo vy wal wph vy weu vx weu wph vx weu vy weu wa wph vy wex vx weu wph vx
    wex vy weu wa wi wph vy wmo vx wal wph vx wmo vy wal wph vx weu vy weu wph
    vy wex vx weu wph vx wex vy weu wa wph vy weu vx weu wph vx wmo vy wal wph
    vx weu vy weu wph vx wex vy weu wph vy wex vx weu wa wph vy wex vx weu wph
    vx wex vy weu wa wph vx wmo vy wal wph vx weu vy weu wph vx wex vy weu wph
    vy wex vx weu wa wph vy vx 2eu1 biimpd wph vx wex vy weu wph vy wex vx weu
    ancom syl6ib adantld wph vy wmo vx wal wph vy weu vx weu wph vy wex vx weu
    wph vx wex vy weu wa wph vx weu vy weu wph vy wmo vx wal wph vy weu vx weu
    wph vy wex vx weu wph vx wex vy weu wa wph vx vy 2eu1 biimpd adantrd jaoi
    wph vy wex vx weu wph vx wex vy weu wa wph vy weu vx weu wph vx weu vy weu
    wph vx vy 2exeu wph vx wex vy weu wph vy wex vx weu wph vx weu vy weu wph
    vy vx 2exeu ancoms jca impbid1 sylbi $.
    $( [3-Dec-2001] $)

  ${
    $d x y z w $.  $d z w ph $.
    $( This theorem provides us with a definition of double existential
       uniqueness ("exactly one ` x ` and exactly one ` y ` ").  Naively one
       might think (incorrectly) that it could be defined by
       ` E! x E! y ph ` .  See ~ 2eu1 for a condition under which the naive
       definition holds and ~ 2exeu for a one-way implication.  See ~ 2eu5 and
       ~ 2eu8 for alternate definitions. $)
    2eu4 $p |- ( ( E! x E. y ph /\ E! y E. x ph ) <->
      ( E. x E. y ph /\ E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) ) ) $=
      wph vy wex vx weu wph vx wex vy weu wa wph vy wex vx wex wph vy wex vx vz
      weq wi vx wal vz wex wa wph vx wex vy wex wph vx wex vy vw weq wi vy wal
      vw wex wa wa wph vy wex vx wex wph vx wex vy wex wa wph vy wex vx vz weq
      wi vx wal vz wex wph vx wex vy vw weq wi vy wal vw wex wa wa wph vy wex
      vx wex wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wa wph
      vy wex vx weu wph vy wex vx wex wph vy wex vx vz weq wi vx wal vz wex wa
      wph vx wex vy weu wph vx wex vy wex wph vx wex vy vw weq wi vy wal vw wex
      wa wph vy wex vx vz wph vy wex vz ax-17 eu3 wph vx wex vy vw wph vx wex
      vw ax-17 eu3 anbi12i wph vy wex vx wex wph vy wex vx vz weq wi vx wal vz
      wex wph vx wex vy wex wph vx wex vy vw weq wi vy wal vw wex an4 wph vy
      wex vx wex wph vx wex vy wex wa wph vy wex vx wex wph vy wex vx vz weq wi
      vx wal vz wex wph vx wex vy vw weq wi vy wal vw wex wa wph vx vz weq vy
      vw weq wa wi vy wal vx wal vw wex vz wex wph vy wex vx wex wph vx wex vy
      wex wa wph vy wex vx wex wph vy wex vx wex wa wph vy wex vx wex wph vx
      wex vy wex wph vy wex vx wex wph vy wex vx wex wph vy vx excom anbi2i wph
      vy wex vx wex anidm bitri wph vx vz weq vy vw weq wa wi vy wal vx wal vw
      wex vz wex wph vy wex vx vz weq wi vx wal wph vx wex vy vw weq wi vy wal
      wa vw wex vz wex wph vy wex vx vz weq wi vx wal vz wex wph vx wex vy vw
      weq wi vy wal vw wex wa wph vx vz weq vy vw weq wa wi vy wal vx wal wph
      vy wex vx vz weq wi vx wal wph vx wex vy vw weq wi vy wal wa vz vw wph vx
      vz weq vy vw weq wa wi vy wal vx wal wph vx vz weq wi vy wal wph vy vw
      weq wi vx wal wa vy wal vx wal wph vy wex vx vz weq wi wph vx wex vy vw
      weq wi wa vy wal vx wal wph vy wex vx vz weq wi vx wal wph vx wex vy vw
      weq wi vy wal wa wph vx vz weq vy vw weq wa wi vy wal vx wal wph vx vz
      weq wi vy wal wph vy vw weq wi vy wal vx wal wa vx wal wph vx vz weq wi
      vy wal wph vy vw weq wi vx wal wa vy wal vx wal wph vx vz weq wi vy wal
      vx wal wph vy vw weq wi vy wal vx wal vx wal wa wph vx vz weq wi vy wal
      vx wal wph vy vw weq wi vy wal vx wal wa wph vx vz weq wi vy wal wph vy
      vw weq wi vy wal vx wal wa vx wal wph vx vz weq vy vw weq wa wi vy wal vx
      wal wph vy vw weq wi vy wal vx wal vx wal wph vy vw weq wi vy wal vx wal
      wph vx vz weq wi vy wal vx wal wph vy vw weq wi vy wal vx wal vx wph vy
      vw weq wi vy wal vx hba1 19.3 anbi2i wph vx vz weq wi vy wal wph vy vw
      weq wi vy wal vx wal vx 19.26 wph vx vz weq vy vw weq wa wi vy wal vx wal
      wph vx vz weq wi vy wal wph vy vw weq wi vy wal wa vx wal wph vx vz weq
      wi vy wal vx wal wph vy vw weq wi vy wal vx wal wa wph vx vz weq vy vw
      weq wa wi vy wal wph vx vz weq wi vy wal wph vy vw weq wi vy wal wa vx
      wph vx vz weq vy vw weq wa wi vy wal wph vx vz weq wi wph vy vw weq wi wa
      vy wal wph vx vz weq wi vy wal wph vy vw weq wi vy wal wa wph vx vz weq
      vy vw weq wa wi wph vx vz weq wi wph vy vw weq wi wa vy wph vx vz weq vy
      vw weq jcab albii wph vx vz weq wi wph vy vw weq wi vy 19.26 bitri albii
      wph vx vz weq wi vy wal wph vy vw weq wi vy wal vx 19.26 bitri 3bitr4ri
      wph vx vz weq wi vy wal wph vy vw weq wi vx wal wa vy wal wph vx vz weq
      wi vy wal wph vy vw weq wi vy wal vx wal wa vx wph vx vz weq wi vy wal
      wph vy vw weq wi vx wal wa vy wal wph vx vz weq wi vy wal vy wal wph vy
      vw weq wi vx wal vy wal wa wph vx vz weq wi vy wal wph vy vw weq wi vy
      wal vx wal wa wph vx vz weq wi vy wal wph vy vw weq wi vx wal vy 19.26
      wph vx vz weq wi vy wal vy wal wph vx vz weq wi vy wal wph vy vw weq wi
      vx wal vy wal wph vy vw weq wi vy wal vx wal wph vx vz weq wi vy wal vy
      wph vx vz weq wi vy hba1 19.3 wph vy vw weq wi vy vx alcom anbi12i bitri
      albii bitr4i wph vx vz weq wi vy wal wph vy vw weq wi vx wal wa wph vy
      wex vx vz weq wi wph vx wex vy vw weq wi wa vx vy wph vx vz weq wi vy wal
      wph vy wex vx vz weq wi wph vy vw weq wi vx wal wph vx wex vy vw weq wi
      wph vx vz weq vy 19.23v wph vy vw weq vx 19.23v anbi12i 2albii wph vy wex
      vx vz weq wi wph vx wex vy vw weq wi vx vy wph vy wex vx vz weq vy wph vy
      hbe1 vx vz weq vy ax-17 hbim wph vx wex vy vw weq vx wph vx hbe1 vy vw
      weq vx ax-17 hbim aaan 3bitri 2exbii wph vy wex vx vz weq wi vx wal wph
      vx wex vy vw weq wi vy wal vz vw eeanv bitr2i anbi12i 3bitri $.
      $( [3-Dec-2001] $)

    $( An alternate definition of double existential uniqueness (see ~ 2eu4 ).
       A mistake sometimes made in the literature is to use ` E! x E! y ` to
       mean "exactly one ` x ` and exactly one ` y ` ."  (For example, see
       Proposition 7.53 of [TakeutiZaring] p. 53.)  It turns out that this is
       actually a weaker assertion, as can be seen by expanding out the formal
       definitions.  This theorem shows that the erroneous definition can be
       repaired by conjoining ` A. x E* y ph ` as an additional condition.  The
       correct definition apparently has never been published.  ( ` E* ` means
       "exists at most one.") $)
    2eu5 $p |- ( ( E! x E! y ph /\ A. x E* y ph ) <->
      ( E. x E. y ph /\ E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) ) ) $=
      wph vy weu vx weu wph vy wmo vx wal wa wph vy wex vx weu wph vx wex vy
      weu wa wph vy wmo vx wal wa wph vy wex vx weu wph vx wex vy weu wa wph vy
      wex vx wex wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wa
      wph vy wmo vx wal wph vy weu vx weu wph vy wex vx weu wph vx wex vy weu
      wa wph vx vy 2eu1 pm5.32ri wph vy wex vx weu wph vx wex vy weu wa wph vy
      wmo vx wal wph vy wex vx weu wph vx wex vy weu wa wph vx wex vy wmo wph
      vy wmo vx wal wph vx wex vy weu wph vx wex vy wmo wph vy wex vx weu wph
      vx wex vy eumo adantl wph vy vx 2moex syl pm4.71i wph vx vy vz vw 2eu4
      3bitr2i $.
      $( [26-Oct-2003] $) $( [26-Oct-2003] $)
  $}

  ${
    $d x y z w v u $.  $d z w v u ph $.
    $( Two equivalent expressions for double existential uniqueness. $)
    2eu6 $p  |- ( ( E! x E. y ph /\ E! y E. x ph ) <->
               E. z E. w A. x A. y ( ph <-> ( x = z /\ y = w ) ) ) $=
      wph vy wex vx weu wph vx wex vy weu wa wph vy wex vx wex wph vx vz weq vy
      vw weq wa wi vy wal vx wal vw wex vz wex wa wph vx vz weq vy vw weq wa wb
      vy wal vx wal vw wex vz wex wph vx vy vz vw 2eu4 wph vy wex vx wex wph vx
      vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wa wph vx vz weq vy vw
      weq wa wb vy wal vx wal vw wex vz wex wph vy vw wsb vx vz wsb vw wex vz
      wex wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb
      wa vz vv weq vw vu weq wa wi vu wal vv wal vw wal vz wal wa wph vy vw wsb
      vx vz wsb wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv
      wsb wa vz vv weq vw vu weq wa wi vu wal vv wal wa vw wex vz wex wph vy
      wex vx wex wph vx vz weq vy vw weq wa wi vy wal vx wal vw wex vz wex wa
      wph vx vz weq vy vw weq wa wb vy wal vx wal vw wex vz wex wph vy vw wsb
      vx vz wsb wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv
      wsb wa vz vv weq vw vu weq wa wi vu wal vv wal vz vw 19.29r2 wph vy wex
      vx wex wph vy vw wsb vx vz wsb vw wex vz wex wph vx vz weq vy vw weq wa
      wi vy wal vx wal vw wex vz wex wph vy vw wsb vx vz wsb wph vy vw wsb vx
      vz wsb vw vu wsb vz vv wsb wa vz vv weq vw vu weq wa wi vu wal vv wal vw
      wal vz wal wph wph vy vw wsb vx vz wsb vx vy vz vw wph vz ax-17 wph vw
      ax-17 wph vy vw wsb vx vz hbs1 wph vy vw wsb vx vz vy wph vy vw hbs1 hbsb
      vy vw weq wph wph vy vw wsb vx vz weq wph vy vw wsb vx vz wsb wph vy vw
      sbequ12 wph vy vw wsb vx vz sbequ12 sylan9bbr cbvex2 wph vx vz weq vy vw
      weq wa wi vy wal vx wal vw wex vz wex wph vx vv weq vy vu weq wa wi vy
      wal vx wal vu wex vv wex wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa
      wi vw wal vz wal vu wex vv wex wph vy vw wsb vx vz wsb wph vy vw wsb vx
      vz wsb vw vu wsb vz vv wsb wa vz vv weq vw vu weq wa wi vu wal vv wal vw
      wal vz wal wph vx vz weq vy vw weq wa wi vy wal vx wal wph vx vv weq vy
      vu weq wa wi vy wal vx wal vz vw vv vu vz vv weq vw vu weq wa wph vx vz
      weq vy vw weq wa wi wph vx vv weq vy vu weq wa wi vx vy vz vv weq vw vu
      weq wa vx vz weq vy vw weq wa vx vv weq vy vu weq wa wph vz vv weq vx vz
      weq vx vv weq vw vu weq vy vw weq vy vu weq vz vv vx equequ2 vw vu vy
      equequ2 bi2anan9 imbi2d 2albidv cbvex2v wph vx vv weq vy vu weq wa wi vy
      wal vx wal wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa wi vw wal vz
      wal vv vu wph vx vv weq vy vu weq wa wi wph vy vw wsb vx vz wsb vz vv weq
      vw vu weq wa wi vx vy vz vw wph vx vv weq vy vu weq wa wi vz ax-17 wph vx
      vv weq vy vu weq wa wi vw ax-17 wph vy vw wsb vx vz wsb vz vv weq vw vu
      weq wa vx wph vy vw wsb vx vz hbs1 vz vv weq vw vu weq wa vx ax-17 hbim
      wph vy vw wsb vx vz wsb vz vv weq vw vu weq wa vy wph vy vw wsb vx vz vy
      wph vy vw hbs1 hbsb vz vv weq vw vu weq wa vy ax-17 hbim vx vz weq vy vw
      weq wa wph wph vy vw wsb vx vz wsb vx vv weq vy vu weq wa vz vv weq vw vu
      weq wa vy vw weq wph wph vy vw wsb vx vz weq wph vy vw wsb vx vz wsb wph
      vy vw sbequ12 wph vy vw wsb vx vz sbequ12 sylan9bbr vx vz weq vx vv weq
      vz vv weq vy vw weq vy vu weq vw vu weq vx vz vv equequ1 vy vw vu equequ1
      bi2anan9 imbi12d cbval2 2exbii wph vy vw wsb vx vz wsb vz vw vv vu 2mo
      3bitri anbi12i wph vx vz weq vy vw weq wa wb vy wal vx wal vw wex vz wex
      vx vz weq vy vw weq wa wph wi vy wal vx wal wph vx vz weq vy vw weq wa wi
      vy wal vx wal wa vw wex vz wex wph vy vw wsb vx vz wsb wph vy vw wsb vx
      vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb wa vz vv weq vw vu weq
      wa wi vu wal vv wal wa vw wex vz wex wph vx vz weq vy vw weq wa wb vy wal
      vx wal vx vz weq vy vw weq wa wph wi vy wal vx wal wph vx vz weq vy vw
      weq wa wi vy wal vx wal wa vz vw wph vx vz weq vy vw weq wa wb vy wal vx
      wal wph vx vz weq vy vw weq wa wi vy wal vx wal vx vz weq vy vw weq wa
      wph wi vy wal vx wal wa vx vz weq vy vw weq wa wph wi vy wal vx wal wph
      vx vz weq vy vw weq wa wi vy wal vx wal wa wph vx vz weq vy vw weq wa vx
      vy 2albi wph vx vz weq vy vw weq wa wi vy wal vx wal vx vz weq vy vw weq
      wa wph wi vy wal vx wal ancom bitri 2exbii wph vy vw wsb vx vz wsb wph vy
      vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb wa vz vv weq
      vw vu weq wa wi vu wal vv wal wa vx vz weq vy vw weq wa wph wi vy wal vx
      wal wph vx vz weq vy vw weq wa wi vy wal vx wal wa vz vw wph vy vw wsb vx
      vz wsb wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv
      wsb wa vz vv weq vw vu weq wa wi vu wal vv wal wa wph vy vw wsb vx vz wsb
      wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi vy wal vx wal wi wa
      wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi vy wal vx wal wa vx
      vz weq vy vw weq wa wph wi vy wal vx wal wph vx vz weq vy vw weq wa wi vy
      wal vx wal wa wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb
      vz vv wsb wa vz vv weq vw vu weq wa wi vu wal vv wal wph vy vw wsb vx vz
      wsb wph vx vz weq vy vw weq wa wi vy wal vx wal wi wph vy vw wsb vx vz
      wsb wph vy vw wsb vx vz wsb wph wa vz vx weq vw vy weq wa wi vy wal vx
      wal wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi wi vy wal vx
      wal wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb
      wa vz vv weq vw vu weq wa wi vu wal vv wal wph vy vw wsb vx vz wsb wph vx
      vz weq vy vw weq wa wi vy wal vx wal wi wph vy vw wsb vx vz wsb wph wa vz
      vx weq vw vy weq wa wi wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa
      wi wi vx vy wph vy vw wsb vx vz wsb wph wa vz vx weq vw vy weq wa wi wph
      vy vw wsb vx vz wsb wph wa vx vz weq vy vw weq wa wi wph vy vw wsb vx vz
      wsb wph vx vz weq vy vw weq wa wi wi vz vx weq vw vy weq wa vx vz weq vy
      vw weq wa wph vy vw wsb vx vz wsb wph wa vz vx weq vx vz weq vw vy weq vy
      vw weq vz vx equcom vw vy equcom anbi12i imbi2i wph vy vw wsb vx vz wsb
      wph vx vz weq vy vw weq wa impexp bitri 2albii wph vy vw wsb vx vz wsb
      wph wa vz vx weq vw vy weq wa wi wph vy vw wsb vx vz wsb wph vy vw wsb vx
      vz wsb vw vu wsb vz vv wsb wa vz vv weq vw vu weq wa wi vx vy vv vu wph
      vy vw wsb vx vz wsb wph wa vz vx weq vw vy weq wa wi vv ax-17 wph vy vw
      wsb vx vz wsb wph wa vz vx weq vw vy weq wa wi vu ax-17 wph vy vw wsb vx
      vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb wa vz vv weq vw vu weq
      wa vx wph vy vw wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb
      vx wph vy vw wsb vx vz hbs1 wph vy vw wsb vx vz wsb vw vu wsb vz vv vx
      wph vy vw wsb vx vz wsb vw vu vx wph vy vw wsb vx vz hbs1 hbsb hbsb hban
      vz vv weq vw vu weq wa vx ax-17 hbim wph vy vw wsb vx vz wsb wph vy vw
      wsb vx vz wsb vw vu wsb vz vv wsb wa vz vv weq vw vu weq wa vy wph vy vw
      wsb vx vz wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb vy wph vy vw
      wsb vx vz vy wph vy vw hbs1 hbsb wph vy vw wsb vx vz wsb vw vu wsb vz vv
      vy wph vy vw wsb vx vz wsb vw vu vy wph vy vw wsb vx vz vy wph vy vw hbs1
      hbsb hbsb hbsb hban vz vv weq vw vu weq wa vy ax-17 hbim vx vv weq vy vu
      weq wa wph vy vw wsb vx vz wsb wph wa wph vy vw wsb vx vz wsb wph vy vw
      wsb vx vz wsb vw vu wsb vz vv wsb wa vz vx weq vw vy weq wa vz vv weq vw
      vu weq wa vx vv weq vy vu weq wa wph wph vy vw wsb vx vz wsb vw vu wsb vz
      vv wsb wph vy vw wsb vx vz wsb vx vv weq vy vu weq wa wph wph vy vu wsb
      vx vv wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv wsb vy vu weq wph wph
      vy vu wsb vx vv weq wph vy vu wsb vx vv wsb wph vy vu sbequ12 wph vy vu
      wsb vx vv sbequ12 sylan9bbr wph vy vw wsb vw vu wsb vx vz wsb vz vv wsb
      wph vy vw wsb vw vu wsb vx vv wsb wph vy vw wsb vx vz wsb vw vu wsb vz vv
      wsb wph vy vu wsb vx vv wsb wph vy vw wsb vw vu wsb vx vv vz wph vy vw
      wsb vw vu wsb vz ax-17 sbco2 wph vy vw wsb vw vu wsb vx vz wsb wph vy vw
      wsb vx vz wsb vw vu wsb vz vv wph vy vw wsb vw vu vx vz sbcom2 sbbii wph
      vy vw wsb vw vu wsb wph vy vu wsb vx vv wph vy vu vw wph vw ax-17 sbco2
      sbbii 3bitr3ri syl6bb anbi2d vx vv weq vz vx weq vz vv weq vy vu weq vw
      vy weq vw vu weq vx vv vz equequ2 vy vu vw equequ2 bi2anan9 imbi12d
      cbval2 wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi vx vy wph vy
      vw wsb vx vz hbs1 wph vy vw wsb vx vz vy wph vy vw hbs1 hbsb 19.21-2
      3bitr3i anbi2i wph vy vw wsb vx vz wsb wph vx vz weq vy vw weq wa wi vy
      wal vx wal abai wph vy vw wsb vx vz wsb vx vz weq vy vw weq wa wph wi vy
      wal vx wal wph vx vz weq vy vw weq wa wi vy wal vx wal wph vx vy vz vw
      2sb6 anbi1i 3bitr2i 2exbii bitr4i 3imtr4i wph vx vz weq vy vw weq wa wb
      vy wal vx wal vw wex vz wex wph vy wex vx wex wph vx vz weq vy vw weq wa
      wi vy wal vx wal vw wex vz wex wph vx vz weq vy vw weq wa wb vy wal vx
      wal vw wex vz wex vx vz weq vy vw weq wa wph wi vy wal vx wal vw wex vz
      wex wph vy wex vx wex wph vx vz weq vy vw weq wa wb vy wal vx wal vx vz
      weq vy vw weq wa wph wi vy wal vx wal vz vw wph vx vz weq vy vw weq wa wb
      vx vz weq vy vw weq wa wph wi vx vy wph vx vz weq vy vw weq wa bi2
      19.20i2 19.22i2 wph vx vy vz vw 2exsb sylibr wph vx vz weq vy vw weq wa
      wb vy wal vx wal wph vx vz weq vy vw weq wa wi vy wal vx wal vz vw wph vx
      vz weq vy vw weq wa wb wph vx vz weq vy vw weq wa wi vx vy wph vx vz weq
      vy vw weq wa bi1 19.20i2 19.22i2 jca impbii bitri $.
      $( [13-Feb-2005] $) $( [2-Feb-2005] $)
  $}

  $( Two equivalent expressions for double existential uniqueness. $)
  2eu7 $p  |- ( ( E! x E. y ph /\ E! y E. x ph ) <->
             E! x E! y ( E. x ph /\ E. y ph ) ) $=
    wph vx wex vy weu wph vy wex wa vx weu wph vx wex vy weu wph vy wex vx weu
    wa wph vx wex wph vy wex wa vy weu vx weu wph vy wex vx weu wph vx wex vy
    weu wa wph vx wex vy weu wph vy wex vx wph vx wex vx vy wph vx hbe1 hbeu
    euan wph vx wex wph vy wex wa vy weu wph vx wex vy weu wph vy wex wa vx wph
    vx wex wph vy wex wa vy weu wph vy wex wph vx wex wa vy weu wph vy wex wph
    vx wex vy weu wa wph vx wex vy weu wph vy wex wa wph vx wex wph vy wex wa
    wph vy wex wph vx wex wa vy wph vx wex wph vy wex ancom eubii wph vy wex
    wph vx wex vy wph vy hbe1 euan wph vy wex wph vx wex vy weu ancom 3bitri
    eubii wph vy wex vx weu wph vx wex vy weu ancom 3bitr4ri $.
    $( [21-Feb-2005] $) $( [19-Feb-2005] $)

  $( Two equivalent expressions for double existential uniqueness.
     Curiously, we can put ` E! ` on either of the internal conjuncts but not
     both.  We can also commute ` E! x E! y ` using ~ 2eu7 . $)
  2eu8 $p  |- ( E! x E! y ( E. x ph /\ E. y ph ) <->
                E! x E! y ( E! x ph /\ E. y ph ) ) $=
    wph vy wex vx weu wph vx weu vy weu wa wph vy wex vx weu wph vx wex vy weu
    wa wph vx weu wph vy wex wa vy weu vx weu wph vx wex wph vy wex wa vy weu
    vx weu wph vy wex vx weu wph vx weu vy weu wph vx wex vy weu wph vy vx 2eu2
    pm5.32i wph vx weu vy weu wph vy wex wa vx weu wph vx weu vy weu wph vy wex
    vx weu wa wph vx weu wph vy wex wa vy weu vx weu wph vy wex vx weu wph vx
    weu vy weu wa wph vx weu vy weu wph vy wex vx wph vx weu vx vy wph vx hbeu1
    hbeu euan wph vx weu wph vy wex wa vy weu wph vx weu vy weu wph vy wex wa
    vx wph vx weu wph vy wex wa vy weu wph vy wex wph vx weu wa vy weu wph vy
    wex wph vx weu vy weu wa wph vx weu vy weu wph vy wex wa wph vx weu wph vy
    wex wa wph vy wex wph vx weu wa vy wph vx weu wph vy wex ancom eubii wph vy
    wex wph vx weu vy wph vy hbe1 euan wph vy wex wph vx weu vy weu ancom
    3bitri eubii wph vy wex vx weu wph vx weu vy weu ancom 3bitr4ri wph vx vy
    2eu7 3bitr3ri $.
    $( [24-Apr-2005] $) $( [20-Feb-2005] $)

  ${
    $d x y z $.
    $( Equality has existential uniqueness.  Special case of ~ eueq1 proved
       using only predicate calculus.  (Contributed by Stefan Allan,
       4-Dec-2008.) $)
    euequ1 $p |- E! x x = y $=
      vx vy weq vx weu vx vy weq vx wex vx vy weq vz vy weq wa vx vz weq wi vz
      wal vx wal wa vx vy weq vx wex vx vy weq vz vy weq wa vx vz weq wi vz wal
      vx wal vx vy a9e vx vy weq vz vy weq wa vx vz weq wi vx vz vx vz vy
      equtr2 gen2 pm3.2i vx vy weq vz vy weq vx vz vx vz vy equequ1 eu4 mpbir
      $.
      $( [11-Dec-2008] $) $( [4-Dec-2008] $)
  $}

  ${
    $d x y $.
    $( Two ways to express "only one thing exists."  The left-hand side
       requires only one variable to express this.  Both sides are false in
       set theory; see theorem ~ dtru . $)
    exists1 $p |- ( E! x x = x <-> A. x x = y ) $=
      vx vx weq vx weu vx vx weq vx vy weq wb vx wal vy wex vx vy weq vx wal vy
      wex vx vy weq vx wal vx vx weq vx vy df-eu vx vy weq vx wal vx vx weq vx
      vy weq wb vx wal vy vx vy weq vx vx weq vx vy weq wb vx vx vy weq vx vy
      weq vx vx weq wb vx vx weq vx vy weq wb vx vx weq vx vy weq vx equid tbt
      vx vy weq vx vx weq bicom bitri albii exbii vx vy weq vx wal vy vx vy vy
      hbae 19.9 3bitr2i $.
      $( [6-Apr-2004] $) $( [5-Apr-2004] $)

    $( A condition implying that at least two things exist. $)
    exists2 $p |- ( ( E. x ph /\ E. x -. ph ) -> -. E! x x = x ) $=
      vx vx weq vx weu wph vx wex wph wn vx wex wa vx vx weq vx weu vx vy weq
      vx wal wph vx wex wph wn vx wex wa wn vx vy exists1 vx vy weq vx wal wph
      vx wex wph wn vx wex wa wph wph wn wa wph pm3.24 vx vy weq vx wal wph vx
      wex wph wph wn vx wex wph wn vx vy weq vx wal wph wph vx wal wi vx wal
      wph vx wex wph wi vx vy weq wph wph vx wal wi vx wph vx vy ax-16 a5i wph
      vx 19.9t syl vx vy weq vx wal wph wn wph wn vx wal wi vx wal wph wn vx
      wex wph wn wi vx vy weq wph wn wph wn vx wal wi vx wph wn vx vy ax-16 a5i
      wph wn vx 19.9t syl anim12d mtoi sylbi con2i $.
      $( [9-May-2004] $) $( [10-Apr-2004] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                    Zermelo-Fraenkel Set Theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - start with the Axiom of Extensionality
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$( Logic is a prerequisite. $)
$( $[ logic.mm $] $) $( Use this if logic is separated out of set.mm. $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Introduce the Axiom of Extensionality
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $v t $.
  $( Let ` t ` be an individual variable. $)
  vt $f set t $.

$(
$)

  ${
    $d x y z $.
    $( Axiom of Extensionality.  An axiom of Zermelo-Fraenkel set theory.  It
       states that two sets are identical if they contain the same elements.
       Axiom Ext of [BellMachover] p. 461.

       Set theory can also be formulated with a _single_ primitive predicate
       ` e. ` on top of traditional predicate calculus _without_ equality.  In
       that case the Axiom of Extensionality becomes
       ` ( A. w ( w e. x <-> w e. y ) -> ( x e. z -> y e. z ) ) ` , and
       equality ` x = y ` is _defined_ as ` A. w ( w e. x <-> w e. y ) ` .  All
       of the usual axioms of equality then become theorems of set theory.
       See, for example, Axiom 1 of [TakeutiZaring] p. 8.

       To use the above "equality-free" version of Extensionality with
       Metamath's logical axioms, we would rewrite ~ ax-8 through ~ ax-16 with
       equality expanded according to the above definition.  Some of those
       axioms could be proved from set theory and would be redundant.  Not all
       of them are redundant, since our axioms of predicate calculus make
       essential use of equality for the proper substitution that is a
       primitive notion in traditional predicate calculus.  A study of such an
       axiomatization would be an interesting project for someone exploring the
       foundations of logic.

       _General remarks_:  Our set theory axioms are presented using defined
       connectives ( ` <-> ` , ` E. ` , etc.) for convenience.  However, it is
       implicitly understood that the actual axioms use only the primitive
       connectives ` -> ` , ` -. ` , ` A. ` , ` = ` , and ` e. ` .  It is
       straightforward to establish the equivalence between the actual axioms
       and the ones we display, and we will not do so.

       It is important to understand that strictly speaking, all of our set
       theory axioms are really schemes that represent an infinite number of
       actual axioms.  This is inherent in the design of Metamath
       ("metavariable math"), which manipulates only metavariables.  For
       example, the metavariable ` x ` in ~ ax-ext can represent any actual
       variable _v1_, _v2_, _v3_,... .  Distinct variable restrictions ($d)
       prevent us from substituting say _v1_ for both ` x ` and ` z ` .  This
       is in contrast to typical textbook presentations that present actual
       axioms (except for Replacement ~ ax-rep , which involves a wff
       metavariable).  In practice, though, the theorems and proofs are
       essentially the same.  The $d restrictions make each of the the infinite
       axioms generated by the ~ ax-ext scheme exactly logically equivalent to
       each other and in particular to the actual axiom of the textbook
       version. $)
    ax-ext $a |- ( A. z ( z e. x <-> z e. y ) -> x = y ) $.

    $( The Axiom of Extensionality ( ~ ax-ext ) restated so that it postulates
       the existence of a set ` z ` given two arbitrary sets ` x ` and ` y ` .
       This way to express it follows the general idea of the other ZFC axioms,
       which is to postulate the existence of sets given other sets. $)
    axext2 $p |- E. z ( ( z e. x <-> z e. y ) -> x = y ) $=
      vz cv vx cv wcel vz cv vy cv wcel wb vx cv vy cv wceq wi vz wex vz cv vx
      cv wcel vz cv vy cv wcel wb vz wal vx cv vy cv wceq wi vx vy vz ax-ext vz
      cv vx cv wcel vz cv vy cv wcel wb vx cv vy cv wceq vz 19.36v mpbir $.
      $( [28-Sep-2003] $)
  $}

  ${
    $d z x w $.  $d z y w $.
    $( A generalization of the Axiom of Extensionality in which ` x ` and
       ` y ` need not be distinct. $)
    axext3 $p |- ( A. z ( z e. x <-> z e. y ) -> x = y ) $=
      vw cv vx cv wceq vw wex vz cv vx cv wcel vz cv vy cv wcel wb vz wal vx cv
      vy cv wceq wi vw vx a9e vw cv vx cv wceq vz cv vx cv wcel vz cv vy cv
      wcel wb vz wal vx cv vy cv wceq wi vw vw cv vx cv wceq vz cv vw cv wcel
      vz cv vy cv wcel wb vz wal vw cv vy cv wceq wi vz cv vx cv wcel vz cv vy
      cv wcel wb vz wal vx cv vy cv wceq wi vw vy vz ax-ext vw cv vx cv wceq vz
      cv vw cv wcel vz cv vy cv wcel wb vz wal vz cv vx cv wcel vz cv vy cv
      wcel wb vz wal vw cv vy cv wceq vx cv vy cv wceq vw cv vx cv wceq vz cv
      vw cv wcel vz cv vy cv wcel wb vz cv vx cv wcel vz cv vy cv wcel wb vz vw
      cv vx cv wceq vz cv vw cv wcel vz cv vx cv wcel vz cv vy cv wcel vw vx vz
      elequ2 bibi1d albidv vw vx vy equequ1 imbi12d mpbii 19.23aiv ax-mp $.
      $( [15-Sep-1993] $)

    $( A bidirectional version of Extensionality.  Although this theorem
       "looks" like it is just a definition of equality, it requires the Axiom
       of Extensionality for its proof under our axiomatization.  See the
       comments for ~ ax-ext and ~ df-cleq . $)
    axext4 $p |- ( x = y <-> A. z ( z e. x <-> z e. y ) ) $=
      vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb vz wal vx cv vy cv
      wceq vz cv vx cv wcel vz cv vy cv wcel wb vz vx vy vz elequ2 19.21aiv vx
      vy vz axext3 impbii $.
      $( [14-Nov-2008] $) $( [14-Nov-2008] $)
  $}

  ${
    $d x y z $.  $d ph z $.
    bm1.1.1 $e |- ( ph -> A. x ph ) $.
    $( Any set defined by a property is the only set defined by that property.
       Theorem 1.1 of [BellMachover] p. 462. $)
    bm1.1 $p |- ( E. x A. y ( y e. x <-> ph ) ->
                  E! x A. y ( y e. x <-> ph ) ) $=
      vy cv vx cv wcel wph wb vy wal vx wex vy cv vx cv wcel wph wb vy wal vx
      wex vy cv vx cv wcel wph wb vy wal vy cv vx cv wcel wph wb vy wal vx vz
      cv wsbc wa vx cv vz cv wceq wi vz wal vx wal wa vy cv vx cv wcel wph wb
      vy wal vx weu vy cv vx cv wcel wph wb vy wal vx wex vy cv vx cv wcel wph
      wb vy wal vy cv vx cv wcel wph wb vy wal vx vz cv wsbc wa vx cv vz cv
      wceq wi vz wal vx wal vy cv vx cv wcel wph wb vy wal vy cv vx cv wcel wph
      wb vy wal vx vz cv wsbc wa vx cv vz cv wceq wi vx vz vy cv vx cv wcel wph
      wb vy wal vy cv vz cv wcel wph wb vy wal vx cv vz cv wceq vy cv vx cv
      wcel wph wb vy wal vx vz cv wsbc vy cv vx cv wcel wph wb vy wal vy cv vz
      cv wcel wph wb vy wal wa vy cv vx cv wcel wph wb vy cv vz cv wcel wph wb
      wa vy wal vx cv vz cv wceq vy cv vx cv wcel wph wb vy cv vz cv wcel wph
      wb vy 19.26 vy cv vx cv wcel wph wb vy cv vz cv wcel wph wb wa vy wal vy
      cv vx cv wcel vy cv vz cv wcel wb vy wal vx cv vz cv wceq vy cv vx cv
      wcel wph wb vy cv vz cv wcel wph wb wa vy cv vx cv wcel vy cv vz cv wcel
      wb vy vy cv vx cv wcel wph vy cv vz cv wcel biantr 19.20i vx vz vy ax-ext
      syl sylbir vy cv vx cv wcel wph wb vy wal vy cv vz cv wcel wph wb vy wal
      vx vz vy cv vz cv wcel wph wb vx vy vy cv vz cv wcel wph vx vy cv vz cv
      wcel vx ax-17 bm1.1.1 hbbi hbal vx cv vz cv wceq vy cv vx cv wcel wph wb
      vy cv vz cv wcel wph wb vy vx cv vz cv wceq vy cv vx cv wcel vy cv vz cv
      wcel wph vx vz vy elequ2 bibi1d albidv sbie sylan2b gen2 jctr vy cv vx cv
      wcel wph wb vy wal vx vz vy cv vx cv wcel wph wb vy wal vz ax-17 eu2
      sylibr $.
      $( [30-Jun-1994] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Class abstractions (a.k.a. class builders)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constants use in class definition. $)
  $c { $. $( Left brace $)
  $c | $.  $( Vertical bar $)
  $c } $. $( Right brace $)
  $( --- Start of old code before overloading prevention patch. $)
  $(
  @c class @. @( Class variable type @)
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Declare variable symbols that will be used to represent classes.  Note
     that later on ` R ` , ` S ` , ` F ` and ` G ` denote relations and
     functions, but these letters serve as mnemonics only and in fact behave
     no differently from the variables ` A ` through ` D ` . $)
  $v A $.
  $v B $.
  $v C $.
  $v D $.
  $v P $.
  $v Q $.
  $v R $.
  $v S $.
  $v T $.
  $v U $.

  $( Introduce the class builder or class abstraction notation ("the class of
     sets ` x ` such that ` ph ` is true").  Our class variables ` A ` ,
     ` B ` , etc. range over class builders (implicitly in the case of defined
     class terms such as ~ df-nul ).  Note that a set variable can be
     expressed as a class builder per theorem ~ cvjust , justifying the
     assignment of set variables to class variables via the use of ~ cv . $)
  cab $a class { x | ph } $.

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( A set variable is a class expression.  The syntax " ` class x ` " can be
     viewed as an abbreviation for " ` class { y | y e. x } ` " (a special case
     of ~ cab ), where ` y ` is distinct from ` x ` .  See the discussion under
     the definition of class in [Jech] p. 4.  Note that ` { y | y e. x } = x `
     by ~ cvjust . @)
  cv @a class x @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Let ` A ` be a class variable. $)
  cA $f class A $.
  $( Let ` B ` be a class variable. $)
  cB $f class B $.
  $( Let ` C ` be a class variable. $)
  cC $f class C $.
  $( Let ` D ` be a class variable. $)
  cD $f class D $.
  $( Let ` P ` be a class variable. $)
  cP $f class P $.
  $( Let ` Q ` be a class variable. $)
  cQ $f class Q $.
  $( Let ` R ` be a class variable. $)
  cR $f class R $.
  $( Let ` S ` be a class variable. $)
  cS $f class S $.
  $( Let ` T ` be a class variable. $)
  cT $f class T $.
  $( Let ` U ` be a class variable. $)
  cU $f class U $.

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include class equality. @)
  wceq @a wff A = B @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include the membership connective between
     classes. @)
  wcel @a wff A e. B @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Define class abstraction notation (so-called by Quine), also called a
     "class builder" in the literature.  ` x ` and ` y ` need not be distinct.
     Definition 2.1 of [Quine] p. 16.  Typically, ` ph ` will have ` y ` as a
     free variable, and " ` { y | ph } ` " is read "the class of all sets ` y `
     such that ` ph ( y ) ` is true."  We do not define ` { y | ph } ` in
     isolation but only as part of an expression that extends or "overloads"
     the ` e. ` relationship.

     This is our first use of the ` e. ` symbol to connect classes instead of
     sets.  The syntax definition ~ wcel , which extends or "overloads" the
     ~ wel definition connecting set variables, requires that both sides of `
     e. ` be a class.  In ~ df-cleq and ~ df-clel , we introduce a new kind of
     variable (class variable) that can substituted with expressions such as
     ` { y | ph } ` .  In the present definition, the ` x ` on the left-hand
     side is a set variable.  Syntax definition ~ cv allows us to substitute
     a set variable ` x ` for a class variable:  all sets are classes by
     ~ cvjust (but not necessarily vice-versa).  For a full description of
     how classes are introduced and how to recover the primitive language,
     see the discussion in Quine (and under ~ abeq2 for a quick overview).

     Because class variables can be substituted with compound expressions
     and set variables cannot, it is often useful to convert a theorem
     containing a free set variable to a more general version with a class
     variable.  This is done with theorems such as ~ vtoclg which is used, for
     example, to convert ~ elirrv to ~ elirr . $)
  df-clab $a |- ( x e. { y | ph } <-> [ x / y ] ph ) $.

  $( Simplification of class abstraction notation when the free and bound
     variables are identical. $)
  abid $p |- ( x e. { x | ph } <-> ph ) $=
    vx cv wph vx cab wcel wph vx vx cv wsbc wph wph vx vx df-clab wph vx sbid
    bitri $.
    $( [5-Aug-1993] $)

  ${
    $d x y $.
    $( Bound-variable hypothesis builder for a class abstraction. $)
    hbab1 $p |- ( y e. { x | ph } -> A. x y e. { x | ph } ) $=
      wph vx vy cv wsbc wph vx vy cv wsbc vx wal vy cv wph vx cab wcel vy cv
      wph vx cab wcel vx wal wph vx vy hbs1 wph vy vx df-clab vy cv wph vx cab
      wcel wph vx vy cv wsbc vx wph vy vx df-clab albii 3imtr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x z $.
    hbab.1 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for a class abstraction. $)
    hbab $p |- ( z e. { y | ph } -> A. x z e. { y | ph } ) $=
      wph vy vz cv wsbc wph vy vz cv wsbc vx wal vz cv wph vy cab wcel vz cv
      wph vy cab wcel vx wal vx cv vz cv wceq vx wal wph vy vz cv wsbc wph vy
      vz cv wsbc vx wal wi wph vy vz cv wsbc vx vz ax-16 wph vy vz vx hbab.1
      hbsb4 pm2.61i wph vz vy df-clab vz cv wph vy cab wcel wph vy vz cv wsbc
      vx wph vz vy df-clab albii 3imtr4i $.
      $( [1-Mar-1995] $)
  $}

  ${
    $d x z $.
    hbabd.1 $e |- ( ph -> A. x A. y ph ) $.
    hbabd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbab . $)
    hbabd $p |- ( ph -> ( z e. { y | ps } -> A. x z e. { y | ps } ) ) $=
      wph wps vy vz cv wsbc wps vy vz cv wsbc vx wal vz cv wps vy cab wcel vz
      cv wps vy cab wcel vx wal wph vx cv vz cv wceq vx wal wps vy vz cv wsbc
      wps vy vz cv wsbc vx wal wi wph wph vx wal vy wal wps wps vx wal wi vx
      wal vy wal vx cv vz cv wceq vx wal wn wps vy vz cv wsbc wps vy vz cv wsbc
      vx wal wi wi wph wph vy wal vx wal wph vx wal vy wal hbabd.1 wph vx vy
      ax-7 syl wph wps wps vx wal wi vy vx hbabd.2 19.20i2 wps vy vz vx hbsb4t
      3syl wps vy vz cv wsbc vx vz ax-16 pm2.61d2 wps vz vy df-clab vz cv wps
      vy cab wcel wps vy vz cv wsbc vx wps vz vy df-clab albii 3imtr4g $.
      $( [16-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x y z $.
    df-cleq.1 $e |- ( A. x ( x e. y <-> x e. z ) -> y = z ) $.
    $( Define the equality connective between classes.  Definition 2.7 of
       [Quine] p. 18.  Also Definition 4.5 of [TakeutiZaring] p. 13; Chapter 4
       provides its justification and methods for eliminating it.  Note that
       its elimination will not necessarily result in a single wff in the
       original language but possibly a "scheme" of wffs.

       This is an example of a somewhat "risky" definition, meaning that it has
       a more complex than usual soundness justification (outside of Metamath),
       because it "overloads" or reuses the existing equality symbol rather
       than introducing a new symbol.  This allows us to make statements that
       may not hold for the original symbol.  For example, it permits us to
       deduce ` y = z <-> A. x ( x e. y <-> x e. z ) ` , which is not a theorem
       of logic but rather presupposes the Axiom of Extensionality (see
       theorem ~ axext4 ).  We therefore include this axiom as a hypothesis,
       so that the use of Extensionality is properly indicated.

       We could avoid this complication by introducing a new symbol, say =_2,
       in place of ` = ` .  This would also have the advantage of making
       elimination of the definition straightforward, so that we could
       eliminate Extensionality as a hypothesis.  We would then also have the
       advantage of being able to identify in various proofs exactly where
       Extensionality truly comes into play rather than just being an artifact
       of a definition..  One of our theorems would then be ` x ` =_2
       ` y <-> x = y ` by invoking Extensionality.

       However, to conform to literature usage, we retain this overloaded
       definition.  This also makes some proofs shorter and probably easier to
       read, without the constant switching between two kinds of equality.

       See also comments under ~ df-clab , ~ df-clel , and ~ abeq2 . $)
    df-cleq $a |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $.
  $}

 ${
    $d x A $.  $d x B $.  $d x y z $.
    $( The same as ~ df-cleq with the hypothesis removed using the Axiom
       of Extensionality ~ ax-ext . $)
    dfcleq $p |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $=
      vx vy vz cA cB vy vz vx ax-ext df-cleq $.
      $( [15-Sep-1993] $)
  $}

  ${
    $d x y z $.
    $( Every set is a class.  Proposition 4.9 of [TakeutiZaring] p. 13.  This
       theorem shows that a set variable can be expressed as a class
       abstraction.  This provides a motivation for the class syntax
       construction ~ cv , which allows us to substitute a set variable for a
       class variable.  See also ~ cab and ~ df-clab .  Note that this is not a
       rigorous justification, because ~ cv is used as part of the proof of
       this theorem, but a careful argument can be made outside of the
       formalism of Metamath, for example as is done in Chapter 4 of Takeuti
       and Zaring.  See also the discussion under the definition of class in
       [Jech] p. 4 showing that "Every set can be considered to be a class." $)
    cvjust $p |- x = { y | y e. x } $=
      vx cv vy cv vx cv wcel vy cab wceq vz cv vx cv wcel vz cv vy cv vx cv
      wcel vy cab wcel wb vz vz vx cv vy cv vx cv wcel vy cab dfcleq vz cv vy
      cv vx cv wcel vy cab wcel vy cv vx cv wcel vy vz cv wsbc vz cv vx cv wcel
      vy cv vx cv wcel vz vy df-clab vz vy vx elsb3 bitr2i mpgbir $.
      $( [7-Nov-2006] $) $( [7-Nov-2006] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Define the membership connective between classes.  Theorem 6.3 of
       [Quine] p. 41, or Proposition 4.6 of [TakeutiZaring] p. 13, which we
       adopt as a definition.  See these references for its metalogical
       justification.  Note that like ~ df-cleq it extends or "overloads" the
       use of the existing membership symbol, but unlike ~ df-cleq it does not
       strengthen the set of valid wffs of logic when the class variables are
       replaced with set variables (see ~ cleljust ), so we don't include any
       set theory axiom as a hypothesis.  See also comments about the syntax
       under ~ df-clab . $)
    df-clel $a |- ( A e. B <-> E. x ( x = A /\ x e. B ) ) $.
  $}

  ${
    $d x A $.  $d x B $.
    eqriv.1 $e |- ( x e. A <-> x e. B ) $.
    $( Infer equality of classes from equivalence of membership. $)
    eqriv $p |- A = B $=
      cA cB wceq vx cv cA wcel vx cv cB wcel wb vx vx cA cB dfcleq eqriv.1
      mpgbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    eqrdv.1 $e |- ( ph -> ( x e. A <-> x e. B ) ) $.
    $( Deduce equality of classes from equivalence of membership. $)
    eqrdv $p |- ( ph -> A = B ) $=
      wph vx cv cA wcel vx cv cB wcel wb vx wal cA cB wceq wph vx cv cA wcel vx
      cv cB wcel wb vx eqrdv.1 19.21aiv vx cA cB dfcleq sylibr $.
      $( [17-Mar-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    eqrdav.1 $e |- ( ( ph /\ x e. A ) -> x e. C ) $.
    eqrdav.2 $e |- ( ( ph /\ x e. B ) -> x e. C ) $.
    eqrdav.3 $e |- ( ( ph /\ x e. C ) -> ( x e. A <-> x e. B ) ) $.
    $( MAY BE REVISED - delete this if it is unused / not useful $)
    $( Deduce equality of classes from an equivalence of membership that
       depends on the membership variable. $)
    eqrdav $p |- ( ph -> A = B ) $=
      wph vx cA cB wph vx cv cA wcel vx cv cB wcel wph vx cv cA wcel wa vx cv
      cC wcel vx cv cB wcel eqrdav.1 wph vx cv cA wcel vx cv cC wcel vx cv cB
      wcel wi wph vx cv cC wcel vx cv cA wcel vx cv cB wcel wph vx cv cC wcel
      vx cv cA wcel vx cv cB wcel wi wph vx cv cC wcel wa vx cv cA wcel vx cv
      cB wcel eqrdav.3 biimpd ex com23 imp mpd wph vx cv cB wcel wa vx cv cC
      wcel vx cv cA wcel eqrdav.2 wph vx cv cB wcel vx cv cC wcel vx cv cA wcel
      wi wph vx cv cC wcel vx cv cB wcel vx cv cA wcel wph vx cv cC wcel vx cv
      cB wcel vx cv cA wcel wi wph vx cv cC wcel wa vx cv cA wcel vx cv cB wcel
      eqrdav.3 biimprd ex com23 imp mpd impbida eqrdv $.
      $( [10-Nov-2008] $) $( [7-Nov-2008] $)
  $}

  ${
    $d x A $.
    $( Law of identity (reflexivity of class equality).  Theorem 6.4 of
       [Quine] p. 41.

       This law is thought to have originated with Aristotle (_Metaphysics_,
       Book VII, Part 17).  (Thanks to Stefan Allan for this
       information.)  $)
    eqid $p |- A = A $=
      vx cA cA vx cv cA wcel biid eqriv $.
      $( [5-Aug-1993] $) $( [5-Aug-1993] $)
  $}

  $( Class identity law with antecedent. $)
  eqidd $p |- ( ph -> A = A ) $=
    cA cA wceq wph cA eqid a1i $.
    $( [21-Aug-2008] $) $( [21-Aug-2008] $)

  ${
    $d x A $.  $d x B $.
    $( Commutative law for class equality.  Theorem 6.5 of [Quine] p. 41. $)
    eqcom $p |- ( A = B <-> B = A ) $=
      vx cv cA wcel vx cv cB wcel wb vx wal vx cv cB wcel vx cv cA wcel wb vx
      wal cA cB wceq cB cA wceq vx cv cA wcel vx cv cB wcel wb vx cv cB wcel vx
      cv cA wcel wb vx vx cv cA wcel vx cv cB wcel bicom albii vx cA cB dfcleq
      vx cB cA dfcleq 3bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqcoms.1 $e |- ( A = B -> ph ) $.
    $( Inference applying commutative law for class equality to an
       antecedent. $)
    eqcoms $p |- ( B = A -> ph ) $=
      cB cA wceq cA cB wceq wph cB cA eqcom eqcoms.1 sylbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqcomi.1 $e |- A = B $.
    $( Inference from commutative law for class equality. $)
    eqcomi $p |- B = A $=
      cA cB wceq cB cA wceq eqcomi.1 cA cB eqcom mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqcomd.1 $e |- ( ph -> A = B ) $.
    $( Deduction from commutative law for class equality. $)
    eqcomd $p |- ( ph -> B = A ) $=
      wph cA cB wceq cB cA wceq eqcomd.1 cA cB eqcom sylib $.
      $( [15-Aug-1994] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality implies equivalence of equalities. $)
    eqeq1 $p |- ( A = B -> ( A = C <-> B = C ) ) $=
      cA cB wceq vx cv cA wcel vx cv cC wcel wb vx wal vx cv cB wcel vx cv cC
      wcel wb vx wal cA cC wceq cB cC wceq cA cB wceq vx cv cA wcel vx cv cC
      wcel wb vx cv cB wcel vx cv cC wcel wb vx cA cB wceq vx cv cA wcel vx cv
      cB wcel vx cv cC wcel cA cB wceq vx cv cA wcel vx cv cB wcel wb vx cA cB
      wceq vx cv cA wcel vx cv cB wcel wb vx wal vx cA cB dfcleq biimpi 19.21bi
      bibi1d albidv vx cA cC dfcleq vx cB cC dfcleq 3bitr4g $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeq1i.1 $e |- A = B $.
    $( Inference from equality to equivalence of equalities. $)
    eqeq1i $p |- ( A = C <-> B = C ) $=
      cA cB wceq cA cC wceq cB cC wceq wb eqeq1i.1 cA cB cC eqeq1 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction from equality to equivalence of equalities. $)
    eqeq1d $p |- ( ph -> ( A = C <-> B = C ) ) $=
      wph cA cB wceq cA cC wceq cB cC wceq wb eqeq1d.1 cA cB cC eqeq1 syl $.
      $( [27-Dec-1993] $)
  $}

  $( Equality implies equivalence of equalities. $)
  eqeq2 $p |- ( A = B -> ( C = A <-> C = B ) ) $=
    cA cB wceq cA cC wceq cB cC wceq cC cA wceq cC cB wceq cA cB cC eqeq1 cC cA
    eqcom cC cB eqcom 3bitr4g $.
    $( [5-Aug-1993] $)

  ${
    eqeq2i.1 $e |- A = B $.
    $( Inference from equality to equivalence of equalities. $)
    eqeq2i $p |- ( C = A <-> C = B ) $=
      cA cB wceq cC cA wceq cC cB wceq wb eqeq2i.1 cA cB cC eqeq2 ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeq2d.1 $e |- ( ph -> A = B ) $.
    $( Deduction from equality to equivalence of equalities. $)
    eqeq2d $p |- ( ph -> ( C = A <-> C = B ) ) $=
      wph cA cB wceq cC cA wceq cC cB wceq wb eqeq2d.1 cA cB cC eqeq2 syl $.
      $( [27-Dec-1993] $)
  $}

  $( Equality relationship among 4 classes. $)
  eqeq12 $p |- ( ( A = B /\ C = D ) -> ( A = C <-> B = D ) ) $=
    cA cB wceq cA cC wceq cB cC wceq cC cD wceq cB cD wceq cA cB cC eqeq1 cC cD
    cB eqeq2 sylan9bb $.
    $( [3-Aug-1994] $)

  ${
    eqeq12i.1 $e |- A = B $.
    eqeq12i.2 $e |- C = D $.
    $( A useful inference for substituting definitions into an equality. $)
    eqeq12i $p |- ( A = C <-> B = D ) $=
      cA cC wceq cB cC wceq cB cD wceq cA cB cC eqeq12i.1 eqeq1i cC cD cB
      eqeq12i.2 eqeq2i bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeq12d.1 $e |- ( ph -> A = B ) $.
    eqeq12d.2 $e |- ( ph -> C = D ) $.
    $( A useful inference for substituting definitions into an equality. $)
    eqeq12d $p |- ( ph -> ( A = C <-> B = D ) ) $=
      wph cA cC wceq cB cC wceq cB cD wceq wph cA cB cC eqeq12d.1 eqeq1d wph cC
      cD cB eqeq12d.2 eqeq2d bitrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeqan12d.1 $e |- ( ph -> A = B ) $.
    eqeqan12d.2 $e |- ( ps -> C = D ) $.
    $( A useful inference for substituting definitions into an equality. $)
    eqeqan12d $p |- ( ( ph /\ ps ) -> ( A = C <-> B = D ) ) $=
      wph wps wa cA cB cC cD wph cA cB wceq wps eqeqan12d.1 adantr wps cC cD
      wceq wph eqeqan12d.2 adantl eqeq12d $.
      $( [9-Aug-1994] $)
  $}

  ${
    eqeqan12rd.1 $e |- ( ph -> A = B ) $.
    eqeqan12rd.2 $e |- ( ps -> C = D ) $.
    $( A useful inference for substituting definitions into an equality. $)
    eqeqan12rd $p |- ( ( ps /\ ph ) -> ( A = C <-> B = D ) ) $=
      wph wps cA cC wceq cB cD wceq wb wph wps cA cB cC cD eqeqan12rd.1
      eqeqan12rd.2 eqeqan12d ancoms $.
      $( [9-Aug-1994] $)
  $}

  $( Transitive law for class equality.  Proposition 4.7(3) of [TakeutiZaring]
     p. 13. $)
  eqtr $p |- ( ( A = B /\ B = C ) -> A = C ) $=
    cA cB wceq cA cC wceq cB cC wceq cA cB cC eqeq1 biimpar $.
    $( [25-Jan-2004] $) $( [25-Jan-2004] $)

  $( A transitive law for class equality. $)
  eqtr2 $p |- ( ( A = B /\ A = C ) -> B = C ) $=
    cB cA wceq cA cC wceq cB cC wceq cA cB wceq cB cA cC eqtr cA cB eqcom
    sylanb $.
    $( [21-May-2005] $) $( [20-May-2005] $)

  $( A transitive law for class equality. $)
  eqtr3 $p |- ( ( A = C /\ B = C ) -> A = B ) $=
    cA cC wceq cC cB wceq cA cB wceq cB cC wceq cA cC cB eqtr cB cC eqcom
    sylan2b $.
    $( [21-May-2005] $) $( [20-May-2005] $)

  ${
    eqtri.1 $e |- A = B $.
    eqtri.2 $e |- B = C $.
    $( An equality transitivity inference. $)
    eqtri $p |- A = C $=
      cA cB wceq cA cC wceq eqtri.1 cB cC cA eqtri.2 eqeq2i mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqtr2i.1 $e |- A = B $.
    eqtr2i.2 $e |- B = C $.
    $( An equality transitivity inference. $)
    eqtr2i $p |- C = A $=
      cA cC cA cB cC eqtr2i.1 eqtr2i.2 eqtri eqcomi $.
      $( [21-Feb-1995] $)
  $}

  ${
    eqtr3i.1 $e |- A = B $.
    eqtr3i.2 $e |- A = C $.
    $( An equality transitivity inference. $)
    eqtr3i $p |- B = C $=
      cB cA cC cA cB eqtr3i.1 eqcomi eqtr3i.2 eqtri $.
      $( [6-May-1994] $)
  $}

  ${
    eqtr4i.1 $e |- A = B $.
    eqtr4i.2 $e |- C = B $.
    $( An equality transitivity inference. $)
    eqtr4i $p |- A = C $=
      cA cB cC eqtr4i.1 cC cB eqtr4i.2 eqcomi eqtri $.
      $( [5-Aug-1993] $)
  $}

  ${
    3eqtri.1 $e |- A = B $.
    3eqtri.2 $e |- B = C $.
    3eqtri.3 $e |- C = D $.
    $( An inference from three chained equalities. $)
    3eqtri $p |- A = D $=
      cA cB cD 3eqtri.1 cB cC cD 3eqtri.2 3eqtri.3 eqtri eqtri $.
      $( [29-Aug-1993] $)

    $( An inference from three chained equalities. $)
    3eqtrri $p |- D = A $=
      cC cD cA 3eqtri.3 cA cB cC 3eqtri.1 3eqtri.2 eqtr2i eqtr3i $.
      $( [4-Aug-2006] $) $( [3-Aug-2006] $)
  $}

  ${
    3eqtr2i.1 $e |- A = B $.
    3eqtr2i.2 $e |- C = B $.
    3eqtr2i.3 $e |- C = D $.
    $( An inference from three chained equalities. $)
    3eqtr2i $p |- A = D $=
      cA cC cD cA cB cC 3eqtr2i.1 3eqtr2i.2 eqtr4i 3eqtr2i.3 eqtri $.
      $( [4-Aug-2006] $) $( [3-Aug-2006] $)

    $( An inference from three chained equalities. $)
    3eqtr2ri $p |- D = A $=
      cA cB cC cD 3eqtr2i.1 cC cB 3eqtr2i.2 eqcomi 3eqtr2i.3 3eqtrri $.
      $( [4-Aug-2006] $) $( [3-Aug-2006] $)
  $}

  ${
    3eqtr3i.1 $e |- A = B $.
    3eqtr3i.2 $e |- A = C $.
    3eqtr3i.3 $e |- B = D $.
    $( An inference from three chained equalities. $)
    3eqtr3i $p |- C = D $=
      cA cC cD 3eqtr3i.2 cA cB cD 3eqtr3i.1 3eqtr3i.3 eqtri eqtr3i $.
      $( [6-May-1994] $)

    $( An inference from three chained equalities. $)
    3eqtr3ri $p |- D = C $=
      cB cD cC 3eqtr3i.3 cA cB cC 3eqtr3i.1 3eqtr3i.2 eqtr3i eqtr3i $.
      $( [16-Aug-2004] $) $( [15-Aug-2004] $)
  $}

  ${
    3eqtr4i.1 $e |- A = B $.
    3eqtr4i.2 $e |- C = A $.
    3eqtr4i.3 $e |- D = B $.
    $( An inference from three chained equalities. $)
    3eqtr4i $p |- C = D $=
      cC cA cD 3eqtr4i.2 cA cB cD 3eqtr4i.1 3eqtr4i.3 eqtr4i eqtri $.
      $( [5-Aug-1993] $)

    $( An inference from three chained equalities. $)
    3eqtr4ri $p |- D = C $=
      cC cA cD 3eqtr4i.2 cA cB cD 3eqtr4i.1 3eqtr4i.3 eqtr4i eqtr2i $.
      $( [2-Sep-1995] $)
  $}

  ${
    eqtrd.1 $e |- ( ph -> A = B ) $.
    eqtrd.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction. $)
    eqtrd $p |- ( ph -> A = C ) $=
      wph cA cB wceq cA cC wceq eqtrd.1 wph cB cC cA eqtrd.2 eqeq2d mpbid $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqtr2d.1 $e |- ( ph -> A = B ) $.
    eqtr2d.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction. $)
    eqtr2d $p |- ( ph -> C = A ) $=
      wph cA cC wph cA cB cC eqtr2d.1 eqtr2d.2 eqtrd eqcomd $.
      $( [18-Oct-1999] $)
  $}

  ${
    eqtr3d.1 $e |- ( ph -> A = B ) $.
    eqtr3d.2 $e |- ( ph -> A = C ) $.
    $( An equality transitivity equality deduction. $)
    eqtr3d $p |- ( ph -> B = C ) $=
      wph cB cA cC wph cA cB eqtr3d.1 eqcomd eqtr3d.2 eqtrd $.
      $( [18-Jul-1995] $)
  $}

  ${
    eqtr4d.1 $e |- ( ph -> A = B ) $.
    eqtr4d.2 $e |- ( ph -> C = B ) $.
    $( An equality transitivity equality deduction. $)
    eqtr4d $p |- ( ph -> A = C ) $=
      wph cA cB cC eqtr4d.1 wph cC cB eqtr4d.2 eqcomd eqtrd $.
      $( [18-Jul-1995] $)
  $}

  ${
    3eqtrd.1 $e |- ( ph -> A = B ) $.
    3eqtrd.2 $e |- ( ph -> B = C ) $.
    3eqtrd.3 $e |- ( ph -> C = D ) $.
    $( A deduction from three chained equalities. $)
    3eqtrd $p |- ( ph -> A = D ) $=
      wph cA cB cD 3eqtrd.1 wph cB cC cD 3eqtrd.2 3eqtrd.3 eqtrd eqtrd $.
      $( [29-Oct-1995] $)

    $( A deduction from three chained equalities. $)
    3eqtrrd $p |- ( ph -> D = A ) $=
      wph cC cD cA 3eqtrd.3 wph cA cB cC 3eqtrd.1 3eqtrd.2 eqtr2d eqtr3d $.
      $( [8-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3eqtr2d.1 $e |- ( ph -> A = B ) $.
    3eqtr2d.2 $e |- ( ph -> C = B ) $.
    3eqtr2d.3 $e |- ( ph -> C = D ) $.
    $( A deduction from three chained equalities. $)
    3eqtr2d $p |- ( ph -> A = D ) $=
      wph cA cC cD wph cA cB cC 3eqtr2d.1 3eqtr2d.2 eqtr4d 3eqtr2d.3 eqtrd $.
      $( [8-Aug-2006] $) $( [4-Aug-2006] $)

    $( A deduction from three chained equalities. $)
    3eqtr2rd $p |- ( ph -> D = A ) $=
      wph cA cC cD wph cA cB cC 3eqtr2d.1 3eqtr2d.2 eqtr4d 3eqtr2d.3 eqtr2d $.
      $( [8-Aug-2006] $) $( [4-Aug-2006] $)
  $}

  ${
    3eqtr3d.1 $e |- ( ph -> A = B ) $.
    3eqtr3d.2 $e |- ( ph -> A = C ) $.
    3eqtr3d.3 $e |- ( ph -> B = D ) $.
    $( A deduction from three chained equalities. $)
    3eqtr3d $p |- ( ph -> C = D ) $=
      wph cA cC cD 3eqtr3d.2 wph cA cB cD 3eqtr3d.1 3eqtr3d.3 eqtrd eqtr3d $.
      $( [4-Aug-1995] $)

    $( A deduction from three chained equalities. $)
    3eqtr3rd $p |- ( ph -> D = C ) $=
      wph cB cD cC 3eqtr3d.3 wph cA cB cC 3eqtr3d.1 3eqtr3d.2 eqtr3d eqtr3d $.
      $( [15-Jan-2006] $) $( [14-Jan-2006] $)
  $}

  ${
    3eqtr4d.1 $e |- ( ph -> A = B ) $.
    3eqtr4d.2 $e |- ( ph -> C = A ) $.
    3eqtr4d.3 $e |- ( ph -> D = B ) $.
    $( A deduction from three chained equalities. $)
    3eqtr4d $p |- ( ph -> C = D ) $=
      wph cC cA cD 3eqtr4d.2 wph cA cB cD 3eqtr4d.1 3eqtr4d.3 eqtr4d eqtrd $.
      $( [4-Aug-1995] $)

    $( A deduction from three chained equalities. $)
    3eqtr4rd $p |- ( ph -> D = C ) $=
      wph cD cA cC wph cD cB cA 3eqtr4d.3 3eqtr4d.1 eqtr4d 3eqtr4d.2 eqtr4d $.
      $( [21-Sep-1995] $)
  $}

  ${
    syl5eq.1 $e |- ( ph -> A = B ) $.
    syl5eq.2 $e |- C = A $.
    $( An equality transitivity deduction. $)
    syl5eq $p |- ( ph -> C = B ) $=
      wph cC cA cB cC cA wceq wph syl5eq.2 a1i syl5eq.1 eqtrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5req.1 $e |- ( ph -> A = B ) $.
    syl5req.2 $e |- C = A $.
    $( An equality transitivity deduction. $)
    syl5req $p |- ( ph -> B = C ) $=
      wph cC cB wph cA cB cC syl5req.1 syl5req.2 syl5eq eqcomd $.
      $( [29-Mar-1998] $)
  $}

  ${
    syl5eqr.1 $e |- ( ph -> A = B ) $.
    syl5eqr.2 $e |- A = C $.
    $( An equality transitivity deduction. $)
    syl5eqr $p |- ( ph -> C = B ) $=
      wph cA cB cC syl5eqr.1 cA cC syl5eqr.2 eqcomi syl5eq $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl5reqr.1 $e |- ( ph -> A = B ) $.
    syl5reqr.2 $e |- A = C $.
    $( An equality transitivity deduction. $)
    syl5reqr $p |- ( ph -> B = C ) $=
      wph cA cB cC syl5reqr.1 cA cC syl5reqr.2 eqcomi syl5req $.
      $( [29-Mar-1998] $)
  $}

  ${
    syl6eq.1 $e |- ( ph -> A = B ) $.
    syl6eq.2 $e |- B = C $.
    $( An equality transitivity deduction. $)
    syl6eq $p |- ( ph -> A = C ) $=
      wph cA cB cC syl6eq.1 cB cC wceq wph syl6eq.2 a1i eqtrd $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6req.1 $e |- ( ph -> A = B ) $.
    syl6req.2 $e |- B = C $.
    $( An equality transitivity deduction. $)
    syl6req $p |- ( ph -> C = A ) $=
      wph cA cC wph cA cB cC syl6req.1 syl6req.2 syl6eq eqcomd $.
      $( [29-Mar-1998] $)
  $}

  ${
    syl6eqr.1 $e |- ( ph -> A = B ) $.
    syl6eqr.2 $e |- C = B $.
    $( An equality transitivity deduction. $)
    syl6eqr $p |- ( ph -> A = C ) $=
      wph cA cB cC syl6eqr.1 cC cB syl6eqr.2 eqcomi syl6eq $.
      $( [5-Aug-1993] $)
  $}

  ${
    syl6reqr.1 $e |- ( ph -> A = B ) $.
    syl6reqr.2 $e |- C = B $.
    $( An equality transitivity deduction. $)
    syl6reqr $p |- ( ph -> C = A ) $=
      wph cA cB cC syl6reqr.1 cC cB syl6reqr.2 eqcomi syl6req $.
      $( [29-Mar-1998] $)
  $}

  ${
    sylan9eq.1 $e |- ( ph -> A = B ) $.
    sylan9eq.2 $e |- ( ps -> B = C ) $.
    $( An equality transitivity deduction. $)
    sylan9eq $p |- ( ( ph /\ ps ) -> A = C ) $=
      wph wps wa cA cB cC wph cA cB wceq wps sylan9eq.1 adantr wps cB cC wceq
      wph sylan9eq.2 adantl eqtrd $.
      $( [8-May-1994] $)
  $}

  ${
    sylan9req.1 $e |- ( ph -> B = A ) $.
    sylan9req.2 $e |- ( ps -> B = C ) $.
    $( An equality transitivity deduction. $)
    sylan9req $p |- ( ( ph /\ ps ) -> A = C ) $=
      wph wps cA cB cC wph cB cA sylan9req.1 eqcomd sylan9req.2 sylan9eq $.
      $( [29-Jun-2007] $) $( [23-Jun-2007] $)
  $}

  ${
    sylan9eqr.1 $e |- ( ph -> A = B ) $.
    sylan9eqr.2 $e |- ( ps -> B = C ) $.
    $( An equality transitivity deduction. $)
    sylan9eqr $p |- ( ( ps /\ ph ) -> A = C ) $=
      wph wps cA cC wceq wph wps cA cB cC sylan9eqr.1 sylan9eqr.2 sylan9eq
      ancoms $.
      $( [8-May-1994] $)
  $}

  ${
    3eqtr3g.1 $e |- ( ph -> A = B ) $.
    3eqtr3g.2 $e |- A = C $.
    3eqtr3g.3 $e |- B = D $.
    $( A chained equality inference, useful for converting from definitions. $)
    3eqtr3g $p |- ( ph -> C = D ) $=
      wph cC cB cD wph cA cB cC 3eqtr3g.1 3eqtr3g.2 syl5eqr 3eqtr3g.3 syl6eq $.
      $( [15-Nov-1994] $)
  $}

  ${
    3eqtr4g.1 $e |- ( ph -> A = B ) $.
    3eqtr4g.2 $e |- C = A $.
    3eqtr4g.3 $e |- D = B $.
    $( A chained equality inference, useful for converting to definitions. $)
    3eqtr4g $p |- ( ph -> C = D ) $=
      wph cC cB cD wph cA cB cC 3eqtr4g.1 3eqtr4g.2 syl5eq 3eqtr4g.3 syl6eqr $.
      $( [5-Aug-1993] $)
  $}

  ${
    3eqtr4a.1 $e |- A = B $.
    3eqtr4a.2 $e |- ( ph -> C = A ) $.
    3eqtr4a.3 $e |- ( ph -> D = B ) $.
    $( A chained equality inference, useful for converting to definitions. $)
    3eqtr4a $p |- ( ph -> C = D ) $=
      wph cA cB cC cD cA cB wceq wph 3eqtr4a.1 a1i 3eqtr4a.2 3eqtr4a.3 3eqtr4d
      $.
      $( [2-Feb-2007] $) $( [2-Feb-2007] $)
  $}

  ${
    $v F $.
    $v G $.
    eq2tr.F $f class F $.
    eq2tr.G $f class G $.
    eq2tr.1 $e |- ( A = C -> D = F ) $.
    eq2tr.2 $e |- ( B = D -> C = G ) $.
    $( A compound transitive inference for class equality. $)
    eq2tri $p |- ( ( A = C /\ B = F ) <-> ( B = D /\ A = G ) ) $=
      cA cC wceq cB cD wceq wa cB cD wceq cA cC wceq wa cA cC wceq cB eq2tr.F
      wceq wa cB cD wceq cA eq2tr.G wceq wa cA cC wceq cB cD wceq ancom cA cC
      wceq cB cD wceq cB eq2tr.F wceq cA cC wceq cD eq2tr.F cB eq2tr.1 eqeq2d
      pm5.32i cB cD wceq cA cC wceq cA eq2tr.G wceq cB cD wceq cC eq2tr.G cA
      eq2tr.2 eqeq2d pm5.32i 3bitr3i $.
      $( [26-Jan-2004] $) $( [22-Jan-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality implies equivalence of membership. $)
    eleq1 $p |- ( A = B -> ( A e. C <-> B e. C ) ) $=
      cA cB wceq vx cv cA wceq vx cv cC wcel wa vx wex vx cv cB wceq vx cv cC
      wcel wa vx wex cA cC wcel cB cC wcel cA cB wceq vx cv cA wceq vx cv cC
      wcel wa vx cv cB wceq vx cv cC wcel wa vx cA cB wceq vx cv cA wceq vx cv
      cB wceq vx cv cC wcel cA cB vx cv eqeq2 anbi1d exbidv vx cA cC df-clel vx
      cB cC df-clel 3bitr4g $.
      $( [5-Aug-1993] $)

    $( Equality implies equivalence of membership. $)
    eleq2 $p |- ( A = B -> ( C e. A <-> C e. B ) ) $=
      cA cB wceq vx cv cC wceq vx cv cA wcel wa vx wex vx cv cC wceq vx cv cB
      wcel wa vx wex cC cA wcel cC cB wcel cA cB wceq vx cv cC wceq vx cv cA
      wcel wa vx cv cC wceq vx cv cB wcel wa vx cA cB wceq vx cv cA wcel vx cv
      cB wcel vx cv cC wceq cA cB wceq vx cv cA wcel vx cv cB wcel wb vx cA cB
      wceq vx cv cA wcel vx cv cB wcel wb vx wal vx cA cB dfcleq biimpi 19.21bi
      anbi2d exbidv vx cC cA df-clel vx cC cB df-clel 3bitr4g $.
      $( [5-Aug-1993] $)
  $}

  $( Equality implies equivalence of membership. $)
  eleq12 $p |- ( ( A = B /\ C = D ) -> ( A e. C <-> B e. D ) ) $=
    cA cB wceq cA cC wcel cB cC wcel cC cD wceq cB cD wcel cA cB cC eleq1 cC cD
    cB eleq2 sylan9bb $.
    $( [31-May-1999] $)

  ${
    eleq1i.1 $e |- A = B $.
    $( Inference from equality to equivalence of membership. $)
    eleq1i $p |- ( A e. C <-> B e. C ) $=
      cA cB wceq cA cC wcel cB cC wcel wb eleq1i.1 cA cB cC eleq1 ax-mp $.
      $( [5-Aug-1993] $)

    $( Inference from equality to equivalence of membership. $)
    eleq2i $p |- ( C e. A <-> C e. B ) $=
      cA cB wceq cC cA wcel cC cB wcel wb eleq1i.1 cA cB cC eleq2 ax-mp $.
      $( [5-Aug-1993] $)

    ${
      eleq12i.2 $e |- C = D $.
      $( Inference from equality to equivalence of membership. $)
      eleq12i $p |- ( A e. C <-> B e. D ) $=
        cA cC wcel cA cD wcel cB cD wcel cC cD cA eleq12i.2 eleq2i cA cB cD
        eleq1i.1 eleq1i bitri $.
        $( [31-May-1994] $)
    $}
  $}

  ${
    eleq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction from equality to equivalence of membership. $)
    eleq1d $p |- ( ph -> ( A e. C <-> B e. C ) ) $=
      wph cA cB wceq cA cC wcel cB cC wcel wb eleq1d.1 cA cB cC eleq1 syl $.
      $( [5-Aug-1993] $)

    $( Deduction from equality to equivalence of membership. $)
    eleq2d $p |- ( ph -> ( C e. A <-> C e. B ) ) $=
      wph cA cB wceq cC cA wcel cC cB wcel wb eleq1d.1 cA cB cC eleq2 syl $.
      $( [27-Dec-1993] $)

    ${
      eleq12d.2 $e |- ( ph -> C = D ) $.
      $( Deduction from equality to equivalence of membership. $)
      eleq12d $p |- ( ph -> ( A e. C <-> B e. D ) ) $=
        wph cA cC wcel cA cD wcel cB cD wcel wph cC cD cA eleq12d.2 eleq2d wph
        cA cB cD eleq1d.1 eleq1d bitrd $.
        $( [31-May-1994] $)
    $}
  $}

  $( A transitive-type law relating membership and equality. $)
  eleq1a $p |- ( A e. B -> ( C = A -> C e. B ) ) $=
    cC cA wceq cC cB wcel cA cB wcel cC cA cB eleq1 biimprcd $.
    $( [9-Apr-1994] $)

  ${
    eqeltr.1 $e |- A = B $.
    eqeltr.2 $e |- B e. C $.
    $( Substitution of equal classes into membership relation. $)
    eqeltri $p |- A e. C $=
      cA cC wcel cB cC wcel eqeltr.2 cA cB cC eqeltr.1 eleq1i mpbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeltrr.1 $e |- A = B $.
    eqeltrr.2 $e |- A e. C $.
    $( Substitution of equal classes into membership relation. $)
    eqeltrri $p |- B e. C $=
      cB cA cC cA cB eqeltrr.1 eqcomi eqeltrr.2 eqeltri $.
      $( [5-Aug-1993] $)
  $}

  ${
    eleqtr.1 $e |- A e. B $.
    eleqtr.2 $e |- B = C $.
    $( Substitution of equal classes into membership relation. $)
    eleqtri $p |- A e. C $=
      cA cB wcel cA cC wcel eleqtr.1 cB cC cA eleqtr.2 eleq2i mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    eleqtrr.1 $e |- A e. B $.
    eleqtrr.2 $e |- C = B $.
    $( Substitution of equal classes into membership relation. $)
    eleqtrri $p |- A e. C $=
      cA cB cC eleqtrr.1 cC cB eleqtrr.2 eqcomi eleqtri $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqeltrd.1 $e |- ( ph -> A = B ) $.
    eqeltrd.2 $e |- ( ph -> B e. C ) $.
    $( Substitution of equal classes into membership relation, deduction form.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    eqeltrd $p |- ( ph -> A e. C ) $=
      wph cA cC wcel cB cC wcel eqeltrd.2 wph cA cB cC eqeltrd.1 eleq1d mpbird
      $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  ${
    eqeltrrd.1 $e |- ( ph -> A = B ) $.
    eqeltrrd.2 $e |- ( ph -> A e. C ) $.
    $( Deduction that substitutes equal classes into membership. $)
    eqeltrrd $p |- ( ph -> B e. C ) $=
      wph cB cA cC wph cA cB eqeltrrd.1 eqcomd eqeltrrd.2 eqeltrd $.
      $( [15-Dec-2004] $) $( [14-Dec-2004] $)
  $}

  ${
    eleqtrd.1 $e |- ( ph -> A e. B ) $.
    eleqtrd.2 $e |- ( ph -> B = C ) $.
    $( Deduction that substitutes equal classes into membership. $)
    eleqtrd $p |- ( ph -> A e. C ) $=
      wph cA cB wcel cA cC wcel eleqtrd.1 wph cB cC cA eleqtrd.2 eleq2d mpbid
      $.
      $( [15-Dec-2004] $) $( [14-Dec-2004] $)
  $}

  ${
    eleqtrrd.1 $e |- ( ph -> A e. B ) $.
    eleqtrrd.2 $e |- ( ph -> C = B ) $.
    $( Deduction that substitutes equal classes into membership. $)
    eleqtrrd $p |- ( ph -> A e. C ) $=
      wph cA cB cC eleqtrrd.1 wph cC cB eleqtrrd.2 eqcomd eleqtrd $.
      $( [15-Dec-2004] $) $( [14-Dec-2004] $)
  $}

  ${
    syl5eqel.1 $e |- ( ph -> A e. B ) $.
    syl5eqel.2 $e |- C = A $.
    $( A membership and equality inference. $)
    syl5eqel $p |- ( ph -> C e. B ) $=
      wph cC cA cB cC cA wceq wph syl5eqel.2 a1i syl5eqel.1 eqeltrd $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl5eqelr.1 $e |- ( ph -> A e. B ) $.
    syl5eqelr.2 $e |- A = C $.
    $( A membership and equality inference. $)
    syl5eqelr $p |- ( ph -> C e. B ) $=
      wph cA cB cC syl5eqelr.1 cA cC syl5eqelr.2 eqcomi syl5eqel $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl5eleq.1 $e |- ( ph -> A = B ) $.
    syl5eleq.2 $e |- C e. A $.
    $( A membership and equality inference. $)
    syl5eleq $p |- ( ph -> C e. B ) $=
      wph cC cA cB cC cA wcel wph syl5eleq.2 a1i syl5eleq.1 eleqtrd $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl5eleqr.1 $e |- ( ph -> B = A ) $.
    syl5eleqr.2 $e |- C e. A $.
    $( A membership and equality inference. $)
    syl5eleqr $p |- ( ph -> C e. B ) $=
      wph cA cB cC wph cB cA syl5eleqr.1 eqcomd syl5eleqr.2 syl5eleq $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl6eqel.1 $e |- ( ph -> A = B ) $.
    syl6eqel.2 $e |- B e. C $.
    $( A membership and equality inference. $)
    syl6eqel $p |- ( ph -> A e. C ) $=
      wph cA cB cC syl6eqel.1 cB cC wcel wph syl6eqel.2 a1i eqeltrd $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl6eqelr.1 $e |- ( ph -> B = A ) $.
    syl6eqelr.2 $e |- B e. C $.
    $( A membership and equality inference. $)
    syl6eqelr $p |- ( ph -> A e. C ) $=
      wph cA cB cC wph cB cA syl6eqelr.1 eqcomd syl6eqelr.2 syl6eqel $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl6eleq.1 $e |- ( ph -> A e. B ) $.
    syl6eleq.2 $e |- B = C $.
    $( A membership and equality inference. $)
    syl6eleq $p |- ( ph -> A e. C ) $=
      wph cA cB cC syl6eleq.1 cB cC wceq wph syl6eleq.2 a1i eleqtrd $.
      $( [6-Jan-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl6eleqr.1 $e |- ( ph -> A e. B ) $.
    syl6eleqr.2 $e |- C = B $.
    $( A membership and equality inference. $)
    syl6eleqr $p |- ( ph -> A e. C ) $=
      wph cA cB cC syl6eleqr.1 cC cB syl6eleqr.2 eqcomi syl6eleq $.
      $( [26-Apr-2005] $) $( [24-Apr-2005] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    cleqf.1 $e |- ( y e. A -> A. x y e. A ) $.
    cleqf.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Establish equality between classes, using bound-variable hypotheses
       instead of distinct variable conditions. $)
    cleqf $p |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $=
      cA cB wceq vy cv cA wcel vy cv cB wcel wb vy wal vx cv cA wcel vx cv cB
      wcel wb vx wal vy cA cB dfcleq vx cv cA wcel vx cv cB wcel wb vy cv cA
      wcel vy cv cB wcel wb vx vy vx cv cA wcel vx cv cB wcel wb vy ax-17 vy cv
      cA wcel vy cv cB wcel vx cleqf.1 cleqf.2 hbbi vx cv vy cv wceq vx cv cA
      wcel vy cv cA wcel vx cv cB wcel vy cv cB wcel vx cv vy cv cA eleq1 vx cv
      vy cv cB eleq1 bibi12d cbval bitr4i $.
      $( [5-Aug-1993] $)
  $}

  $( A way of showing two classes are not equal. $)
  nelneq $p |- ( ( A e. C /\ -. B e. C ) -> -. A = B ) $=
    cA cC wcel cB cC wcel wn cA cB wceq wn cA cC wcel cA cB wceq cB cC wcel cA
    cB wceq cA cC wcel cB cC wcel cA cB cC eleq1 biimpcd con3d imp $.
    $( [1-Apr-1997] $)

  $( A way of showing two classes are not equal. $)
  nelneq2 $p |- ( ( A e. B /\ -. A e. C ) -> -. B = C ) $=
    cA cB wcel cA cC wcel wn cB cC wceq wn cA cB wcel cB cC wceq cA cC wcel cB
    cC wceq cA cB wcel cA cC wcel cB cC cA eleq2 biimpcd con3d imp $.
    $( [12-Jan-2002] $)

  ${
    hbxfr.1 $e |- A = B $.
    hbxfr.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( A utility lemma to transfer a bound-variable hypothesis builder into
       a definition. $)
    hbxfr $p |- ( y e. A -> A. x y e. A ) $=
      vy cv cB wcel vy cv cB wcel vx wal vy cv cA wcel vy cv cA wcel vx wal
      hbxfr.2 cA cB vy cv hbxfr.1 eleq2i vy cv cA wcel vy cv cB wcel vx cA cB
      vy cv hbxfr.1 eleq2i albii 3imtr4i $.
      $( [22-Aug-2007] $) $( [21-Aug-2007] $)
  $}

  ${
    $d y A $.  $d x y z $.
    hblem.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Lemma for ~ hbeq and ~ hbel . $)
    hblem $p |- ( z e. A -> A. x z e. A ) $=
      vy cv cA wcel vy cv cA wcel vx wal wi vz cv cA wcel vz cv cA wcel vx wal
      wi vy vz vy cv vz cv wceq vy cv cA wcel vz cv cA wcel vy cv cA wcel vx
      wal vz cv cA wcel vx wal vy cv vz cv cA eleq1 vy cv vz cv wceq vy cv cA
      wcel vz cv cA wcel vx vy cv vz cv cA eleq1 albidv imbi12d hblem.1 chvarv
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d y A w $.  $d z B w $.  $d x y w $.  $d x z w $.
    hbeq.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbeq.2 $e |- ( z e. B -> A. x z e. B ) $.
    $( If ` x ` is effectively bound in ` A ` and ` B ` , it is effectively
       bound in ` A = B ` . $)
    hbeq $p |- ( A = B -> A. x A = B ) $=
      vw cv cA wcel vw cv cB wcel wb vw wal vw cv cA wcel vw cv cB wcel wb vw
      wal vx wal cA cB wceq cA cB wceq vx wal vw cv cA wcel vw cv cB wcel wb vx
      vw vw cv cA wcel vw cv cB wcel vx vx vy vw cA hbeq.1 hblem vx vz vw cB
      hbeq.2 hblem hbbi hbal vw cA cB dfcleq cA cB wceq vw cv cA wcel vw cv cB
      wcel wb vw wal vx vw cA cB dfcleq albii 3imtr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d y A w $.  $d z B w $.  $d x y w $.  $d x z w $.
    hbel.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbel.2 $e |- ( z e. B -> A. x z e. B ) $.
    $( If ` x ` is effectively bound in ` A ` and ` B ` , it is effectively
       bound in ` A e. B ` . $)
    hbel $p |- ( A e. B -> A. x A e. B ) $=
      vw cv cA wceq vw cv cB wcel wa vw wex vw cv cA wceq vw cv cB wcel wa vw
      wex vx wal cA cB wcel cA cB wcel vx wal vw cv cA wceq vw cv cB wcel wa vx
      vw vw cv cA wceq vw cv cB wcel vx vx vy vy vw cv cA vy cv vw cv wcel vx
      ax-17 hbel.1 hbeq vx vz vw cB hbel.2 hblem hban hbex vw cA cB df-clel cA
      cB wcel vw cv cA wceq vw cv cB wcel wa vw wex vx vw cA cB df-clel albii
      3imtr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y z $.  $d y z A $.
    hbeleq.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( If ` x ` is effectively bound in ` y e. A ` , then it is effectively
       bound in ` y = A ` . $)
    hbeleq $p |- ( y = A -> A. x y = A ) $=
      vx vz vz vy cv cA vz cv vy cv wcel vx ax-17 vx vy vy vz cv cA vy cv vz cv
      wcel vx ax-17 hbeleq.1 hbel hbeq $.
      $( [25-Feb-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Equality of a class variable and a class abstraction (also called a
       class builder).  Theorem 5.1 of [Quine] p. 34.  This theorem shows the
       relationship between expressions with class abstractions and expressions
       with class variables.  Note that ~ eq2ab and its relatives are among
       those useful for converting theorems with class variables to equivalent
       theorems with wff variables, by first substituting a class abstraction
       for each class variable.

       Class variables can always be eliminated from a theorem to result in an
       equivalent theorem with wff variables, and vice-versa.  The idea is
       roughly as follows.  To convert a theorem with a wff variable ` ph `
       (that has a free variable ` x ` ) to a theorem with a class variable
       ` A ` , we substitute ` x e. A ` for ` ph ` throughout and simplify,
       where ` A ` is a new class variable not already in the wff.  An
       example is the conversion of ~ zfauscl to ~ inex1 (look at the instance
       of ~ zfauscl that occurs in the proof of ~ inex1 ).  Conversely, to
       convert a theorem with a class variable ` A ` to one with ` ph ` , we
       substitute ` { x | ph } ` for ` A ` throughout and simplify, where ` x `
       and ` ph ` are new set and wff variables not already in the wff.  An
       example is ~ cp , which derives a formula containing wff variables from
       substitution instances of the class variables in its equivalent
       formulation ~ cplem2 . $)
    abeq2 $p |- ( A = { x | ph } <-> A. x ( x e. A <-> ph ) ) $=
      cA wph vx cab wceq vx cv cA wcel vx cv wph vx cab wcel wb vx wal vx cv cA
      wcel wph wb vx wal vx vy cA wph vx cab vy cv cA wcel vx ax-17 wph vx vy
      hbab1 cleqf vx cv cA wcel vx cv wph vx cab wcel wb vx cv cA wcel wph wb
      vx vx cv wph vx cab wcel wph vx cv cA wcel wph vx abid bibi2i albii bitri
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Equality of a class variable and a class abstraction. $)
    abeq1 $p |- ( { x | ph } = A <-> A. x ( ph <-> x e. A ) ) $=
      cA wph vx cab wceq vx cv cA wcel wph wb vx wal wph vx cab cA wceq wph vx
      cv cA wcel wb vx wal wph vx cA abeq2 wph vx cab cA eqcom wph vx cv cA
      wcel wb vx cv cA wcel wph wb vx wph vx cv cA wcel bicom albii 3bitr4i $.
      $( [20-Aug-1993] $)
  $}

  ${
    abeqi.1 $e |- A = { x | ph } $.
    $( Equality of a class variable and a class abstraction (inference
       rule). $)
    abeq2i $p |- ( x e. A <-> ph ) $=
      vx cv cA wcel vx cv wph vx cab wcel wph cA wph vx cab vx cv abeqi.1
      eleq2i wph vx abid bitri $.
      $( [3-Apr-1996] $)
  $}

  ${
    abeqri.1 $e |- { x | ph } = A $.
    $( Equality of a class variable and a class abstraction (inference
       rule). $)
    abeq1i $p |- ( ph <-> x e. A ) $=
      wph vx cv wph vx cab wcel vx cv cA wcel wph vx abid wph vx cab cA vx cv
      abeqri.1 eleq2i bitr3i $.
      $( [31-Jul-1994] $)
  $}

  ${
    abeqd.1 $e |- ( ph -> A = { x | ps } ) $.
    $( Equality of a class variable and a class abstraction (deduction). $)
    abeq2d $p |- ( ph -> ( x e. A <-> ps ) ) $=
      wph vx cv cA wcel vx cv wps vx cab wcel wps wph cA wps vx cab vx cv
      abeqd.1 eleq2d wps vx abid syl6bb $.
      $( [16-Nov-1995] $)
  $}

  ${
    $d ph y $.  $d ps y $.  $d x y $.
    $( Equality of two class abstractions means their wff's are equivalent. $)
    eq2ab $p |- ( { x | ph } = { x | ps } <-> A. x ( ph <-> ps ) ) $=
      wph vx cab wps vx cab wceq vx cv wph vx cab wcel vx cv wps vx cab wcel wb
      vx wal wph wps wb vx wal vx vy wph vx cab wps vx cab wph vx vy hbab1 wps
      vx vy hbab1 cleqf vx cv wph vx cab wcel vx cv wps vx cab wcel wb wph wps
      wb vx vx cv wph vx cab wcel wph vx cv wps vx cab wcel wps wph vx abid wps
      vx abid bibi12i albii bitri $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.
    abbiri.1 $e |- ( x e. A <-> ph ) $.
    $( Equality of a class variable and a class abstraction (inference
       rule). $)
    abbi2i $p |- A = { x | ph } $=
      cA wph vx cab wceq vx cv cA wcel wph wb vx wph vx cA abeq2 abbiri.1
      mpgbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    abbii.1 $e |- ( ph <-> ps ) $.
    $( Equivalent wff's yield equal class abstractions (inference rule). $)
    abbii $p |- { x | ph } = { x | ps } $=
      wph vx cab wps vx cab wceq wph wps wb vx wph wps vx eq2ab abbii.1 mpgbir
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d ph y $.  $d ps y $.  $d ch y $.  $( ` y ` is a dummy var. $)
    abbid.1 $e |- ( ph -> A. x ph ) $.
    abbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal class abstractions (deduction rule). $)
    abbid $p |- ( ph -> { x | ps } = { x | ch } ) $=
      wph wps wch wb vx wal wps vx cab wch vx cab wceq wph wps wch wb vx
      abbid.1 abbid.2 19.21ai wps wch vx eq2ab sylibr $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph $.
    abbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal class abstractions (deduction rule). $)
    abbidv $p |- ( ph -> { x | ps } = { x | ch } ) $=
      wph wps wch vx wph vx ax-17 abbidv.1 abbid $.
      $( [10-Aug-1993] $)
  $}

  ${
    $d x y A $.  $d ph x y $.  $d ps y $.  $( ` y ` is a dummy var. $)
    abbirdv.1 $e |- ( ph -> ( x e. A <-> ps ) ) $.
    $( Deduction from a wff to a class abstraction. $)
    abbi2dv $p |- ( ph -> A = { x | ps } ) $=
      wph vx cv cA wcel wps wb vx wal cA wps vx cab wceq wph vx cv cA wcel wps
      wb vx abbirdv.1 19.21aiv wps vx cA abeq2 sylibr $.
      $( [9-Jul-1994] $)
  $}

  ${
    $d x y A $.  $d ph x y $.  $d ps y $.  $( ` y ` is a dummy var. $)
    abbildv.1 $e |- ( ph -> ( ps <-> x e. A ) ) $.
    $( Deduction from a wff to a class abstraction. $)
    abbi1dv $p |- ( ph -> { x | ps } = A ) $=
      wph wps vx cv cA wcel wb vx wal wps vx cab cA wceq wph wps vx cv cA wcel
      wb vx abbildv.1 19.21aiv wps vx cA abeq1 sylibr $.
      $( [9-Jul-1994] $)
  $}

  ${
    $d x A $.
    $( A simplification of class abstraction.  Theorem 5.2 of [Quine] p. 35. $)
    abid2 $p |- { x | x e. A } = A $=
      cA vx cv cA wcel vx cab vx cv cA wcel vx cA vx cv cA wcel biid abbi2i
      eqcomi $.
      $( [26-Dec-1993] $)
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Membership of a class variable in a class abstraction. $)
    clelab $p |- ( A e. { x | ph } <-> E. x ( x = A /\ ph ) ) $=
      vy cv cA wceq vy cv wph vx cab wcel wa vy wex vy cv cA wceq wph vx vy cv
      wsbc wa vy wex cA wph vx cab wcel vx cv cA wceq wph wa vx wex vy cv cA
      wceq vy cv wph vx cab wcel wa vy cv cA wceq wph vx vy cv wsbc wa vy vy cv
      wph vx cab wcel wph vx vy cv wsbc vy cv cA wceq wph vy vx df-clab anbi2i
      exbii vy cA wph vx cab df-clel vx cv cA wceq wph wa vy cv cA wceq wph vx
      vy cv wsbc wa vx vy vx cv cA wceq wph wa vy ax-17 vy cv cA wceq wph vx vy
      cv wsbc vx vy cv cA wceq vx ax-17 wph vx vy hbs1 hban vx cv vy cv wceq vx
      cv cA wceq vy cv cA wceq wph wph vx vy cv wsbc vx cv vy cv cA eqeq1 wph
      vx vy sbequ12 anbi12d cbvex 3bitr4i $.
      $( [23-Dec-1993] $)
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( Membership of a class abstraction in another class $)
    clabel $p |- ( { x | ph } e. A <->
                 E. y ( y e. A /\ A. x ( x e. y <-> ph ) ) ) $=
      wph vx cab cA wcel vy cv wph vx cab wceq vy cv cA wcel wa vy wex vy cv cA
      wcel vx cv vy cv wcel wph wb vx wal wa vy wex vy wph vx cab cA df-clel vy
      cv wph vx cab wceq vy cv cA wcel wa vy cv cA wcel vx cv vy cv wcel wph wb
      vx wal wa vy vy cv wph vx cab wceq vy cv cA wcel wa vx cv vy cv wcel wph
      wb vx wal vy cv cA wcel wa vy cv cA wcel vx cv vy cv wcel wph wb vx wal
      wa vy cv wph vx cab wceq vx cv vy cv wcel wph wb vx wal vy cv cA wcel wph
      vx vy cv abeq2 anbi1i vx cv vy cv wcel wph wb vx wal vy cv cA wcel ancom
      bitri exbii bitri $.
      $( [18-Jan-2006] $) $( [17-Jan-2006] $)
  $}

  ${
    $d x y $.  $d y A $.
    $( Lemma for ~ eqsb3 . $)
    eqsb3lem $p |- ( [ x / y ] y = A <-> x = A ) $=
      vy cv cA wceq vy vx cv wsbc vx cv cA wceq vy vx cv wsbc vx cv cA wceq vx
      cv cA wceq vy cv cA wceq wb vy vx cv wsbc vx cv cA wceq vy vx cv wsbc vy
      cv cA wceq vy vx cv wsbc wb vx cv vy cv wceq vy vx cv wsbc vx cv cA wceq
      vy cv cA wceq wb vy vx cv wsbc vy vx equsb2 vx cv vy cv wceq vx cv cA
      wceq vy cv cA wceq wb vy vx vx cv vy cv cA eqeq1 sbimi ax-mp vx cv cA
      wceq vy cv cA wceq vy vx sbbi mpbi vx cv cA wceq vy vx vx cv cA wceq vy
      ax-17 sbf bitr3i $.
      $( [19-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d y A $.  $d w y $.  $d w A $.  $d x w $.
    $( Substitution applied to an atomic wff (class version of ~ equsb3 ).
       (Contributed by Rodolfo Medina, 28-Apr-2010.) $)
    eqsb3 $p |- ( [ x / y ] y = A <-> x = A ) $=
      vy cv cA wceq vy vw cv wsbc vw vx cv wsbc vw cv cA wceq vw vx cv wsbc vy
      cv cA wceq vy vx cv wsbc vx cv cA wceq vy cv cA wceq vy vw cv wsbc vw cv
      cA wceq vw vx vw vy cA eqsb3lem sbbii vy cv cA wceq vy vx vw vy cv cA
      wceq vw ax-17 sbco2 vx vw cA eqsb3lem 3bitr3i $.
      $( [19-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d y A $.  $d w y $.  $d w A $.  $d w x $.
    $( Substitution applied to an atomic wff (class version of ~ elsb3 ).
       (Contributed by Rodolfo Medina, 28-Apr-2010.) $)
    clelsb3 $p |- ( [ x / y ] y e. A <-> x e. A ) $=
      vy cv cA wcel vy vw cv wsbc vw vx cv wsbc vw cv cA wcel vw vx cv wsbc vy
      cv cA wcel vy vx cv wsbc vx cv cA wcel vy cv cA wcel vy vw cv wsbc vw cv
      cA wcel vw vx vy cv cA wcel vy vw cv wsbc vw cv cA wcel vy vw cv wsbc vw
      cv cA wcel vw cv cA wcel vy cv cA wcel wb vy vw cv wsbc vw cv cA wcel vy
      vw cv wsbc vy cv cA wcel vy vw cv wsbc wb vw cv vy cv wceq vy vw cv wsbc
      vw cv cA wcel vy cv cA wcel wb vy vw cv wsbc vy vw equsb2 vw cv vy cv
      wceq vw cv cA wcel vy cv cA wcel wb vy vw vw cv vy cv cA eleq1 sbimi
      ax-mp vw cv cA wcel vy cv cA wcel vy vw sbbi mpbi vw cv cA wcel vy vw vw
      cv cA wcel vy ax-17 sbf bitr3i sbbii vy cv cA wcel vy vx vw vy cv cA wcel
      vw ax-17 sbco2 vw cv cA wcel vw vx cv wsbc vx cv cA wcel vw vx cv wsbc vx
      cv cA wcel vx cv cA wcel vw cv cA wcel wb vw vx cv wsbc vx cv cA wcel vw
      vx cv wsbc vw cv cA wcel vw vx cv wsbc wb vx cv vw cv wceq vw vx cv wsbc
      vx cv cA wcel vw cv cA wcel wb vw vx cv wsbc vw vx equsb2 vx cv vw cv
      wceq vx cv cA wcel vw cv cA wcel wb vw vx vx cv vw cv cA eleq1 sbimi
      ax-mp vx cv cA wcel vw cv cA wcel vw vx sbbi mpbi vx cv cA wcel vw vx vx
      cv cA wcel vw ax-17 sbf bitr3i 3bitr3i $.
      $( [19-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d z A $.  $d z x $.  $d z y $.
    $( The right-hand side of the second equality is a way of representing
       proper substitution of ` y ` for ` x ` into a class variable. $)
    sbab $p |- ( x = y -> A = { z | [ y / x ] z e. A } ) $=
      vx cv vy cv wceq vz cv cA wcel vx vy cv wsbc vz cA vz cv cA wcel vx vy
      sbequ12 abbi2dv $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d w v A $.  $d x w $.  $d x z v u $.  $d y z v u $.  $d v ph $.
    sbabel.1 $e |- ( w e. A -> A. x w e. A ) $.
    $( Theorem to move a substitution in and out of a class abstraction. $)
    sbabel $p |- ( [ y / x ] { z | ph } e. A <-> { z | [ y / x ] ph } e. A ) $=
      vv cv wph vz cab wceq vv cv cA wcel wa vv wex vx vy cv wsbc vv cv wph vx
      vy cv wsbc vz cab wceq vv cv cA wcel wa vv wex wph vz cab cA wcel vx vy
      cv wsbc wph vx vy cv wsbc vz cab cA wcel vv cv wph vz cab wceq vv cv cA
      wcel wa vv wex vx vy cv wsbc vv cv wph vz cab wceq vv cv cA wcel wa vx vy
      cv wsbc vv wex vv cv wph vx vy cv wsbc vz cab wceq vv cv cA wcel wa vv
      wex vv cv wph vz cab wceq vv cv cA wcel wa vv vx vy sbex vv cv wph vz cab
      wceq vv cv cA wcel wa vx vy cv wsbc vv cv wph vx vy cv wsbc vz cab wceq
      vv cv cA wcel wa vv vv cv wph vz cab wceq vv cv cA wcel wa vx vy cv wsbc
      vv cv wph vz cab wceq vx vy cv wsbc vv cv cA wcel vx vy cv wsbc wa vv cv
      wph vx vy cv wsbc vz cab wceq vv cv cA wcel wa vv cv wph vz cab wceq vv
      cv cA wcel vx vy sban vv cv wph vz cab wceq vx vy cv wsbc vv cv wph vx vy
      cv wsbc vz cab wceq vv cv cA wcel vx vy cv wsbc vv cv cA wcel vz cv vv cv
      wcel wph wb vz wal vx vy cv wsbc vz cv vv cv wcel wph vx vy cv wsbc wb vz
      wal vv cv wph vz cab wceq vx vy cv wsbc vv cv wph vx vy cv wsbc vz cab
      wceq vz cv vv cv wcel wph wb vz wal vx vy cv wsbc vz cv vv cv wcel wph wb
      vx vy cv wsbc vz wal vz cv vv cv wcel wph vx vy cv wsbc wb vz wal vz cv
      vv cv wcel wph wb vz vx vy sbal vz cv vv cv wcel wph wb vx vy cv wsbc vz
      cv vv cv wcel wph vx vy cv wsbc wb vz vz cv vv cv wcel vz cv vv cv wcel
      wph vx vy vz cv vv cv wcel vx vy vz cv vv cv wcel vx ax-17 sbf sbrbis
      albii bitri vv cv wph vz cab wceq vz cv vv cv wcel wph wb vz wal vx vy
      wph vz vv cv abeq2 sbbii wph vx vy cv wsbc vz vv cv abeq2 3bitr4i vv cv
      cA wcel vx vy vx vw vw vv cv cA vw cv vv cv wcel vx ax-17 sbabel.1 hbel
      sbf anbi12i bitri exbii bitri wph vz cab cA wcel vv cv wph vz cab wceq vv
      cv cA wcel wa vv wex vx vy vv wph vz cab cA df-clel sbbii vv wph vx vy cv
      wsbc vz cab cA df-clel 3bitr4i $.
      $( [27-Sep-2003] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Negated equality and membership
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new connectives. $)
  $c =/= $. $( Not equal to (equal sign with slash through it). $)
  $c e/ $. $( Not an element of (epsilon with slash through it). $)

  $( Extend wff notation to include inequality. $)
  wne $a wff A =/= B $.

  $( Extend wff notation to include negated membership. $)
  wnel $a wff A e/ B $.

  $( Define inequality. $)
  df-ne $a |- ( A =/= B <-> -. A = B ) $.

  $( Define negated membership. $)
  df-nel $a |- ( A e/ B <-> -. A e. B ) $.

  $( Negation of inequality. $)
  nne $p |- ( -. A =/= B <-> A = B ) $=
    cA cB wceq cA cB wne wn cA cB wne cA cB wceq cA cB df-ne con2bii bicomi $.
    $( [20-Jun-2006] $) $( [9-Jun-2006] $)

  $( Equality theorem for inequality. $)
  neeq1 $p |- ( A = B -> ( A =/= C <-> B =/= C ) ) $=
    cA cB wceq cA cC wceq wn cB cC wceq wn cA cC wne cB cC wne cA cB wceq cA cC
    wceq cB cC wceq cA cB cC eqeq1 notbid cA cC df-ne cB cC df-ne 3bitr4g $.
    $( [19-Nov-1994] $)

  $( Equality theorem for inequality. $)
  neeq2 $p |- ( A = B -> ( C =/= A <-> C =/= B ) ) $=
    cA cB wceq cC cA wceq wn cC cB wceq wn cC cA wne cC cB wne cA cB wceq cC cA
    wceq cC cB wceq cA cB cC eqeq2 notbid cC cA df-ne cC cB df-ne 3bitr4g $.
    $( [19-Nov-1994] $)

  ${
    neeq1i.1 $e |- A = B $.
    $( Inference for inequality. $)
    neeq1i $p |- ( A =/= C <-> B =/= C ) $=
      cA cB wceq cA cC wne cB cC wne wb neeq1i.1 cA cB cC neeq1 ax-mp $.
      $( [3-May-2005] $) $( [29-Apr-2005] $)

    $( Inference for inequality. $)
    neeq2i $p |- ( C =/= A <-> C =/= B ) $=
      cA cB wceq cC cA wne cC cB wne wb neeq1i.1 cA cB cC neeq2 ax-mp $.
      $( [17-May-2005] $) $( [29-Apr-2005] $)
  $}

  ${
    neeq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction for inequality. $)
    neeq1d $p |- ( ph -> ( A =/= C <-> B =/= C ) ) $=
      wph cA cB wceq cA cC wne cB cC wne wb neeq1d.1 cA cB cC neeq1 syl $.
      $( [25-Oct-1999] $)

    $( Deduction for inequality. $)
    neeq2d $p |- ( ph -> ( C =/= A <-> C =/= B ) ) $=
      wph cA cB wceq cC cA wne cC cB wne wb neeq1d.1 cA cB cC neeq2 syl $.
      $( [25-Oct-1999] $)
  $}

  ${
    necon3abii.1 $e |- ( A = B <-> ph ) $.
    $( Deduction from equality to inequality. $)
    necon3abii $p |- ( A =/= B <-> -. ph ) $=
      cA cB wne cA cB wceq wn wph wn cA cB df-ne cA cB wceq wph necon3abii.1
      notbii bitri $.
      $( [11-Nov-2007] $) $( [9-Nov-2007] $)
  $}

  ${
    necon3bbii.1 $e |- ( ph <-> A = B ) $.
    $( Deduction from equality to inequality. $)
    necon3bbii $p |- ( -. ph <-> A =/= B ) $=
      cA cB wne wph wn wph cA cB wph cA cB wceq necon3bbii.1 bicomi necon3abii
      bicomi $.
      $( [17-Apr-2007] $) $( [13-Apr-2007] $)
  $}

  ${
    necon3bii.1 $e |- ( A = B <-> C = D ) $.
    $( Inference from equality to inequality. $)
    necon3bii $p |- ( A =/= B <-> C =/= D ) $=
      cA cB wne cC cD wceq wn cC cD wne cC cD wceq cA cB necon3bii.1 necon3abii
      cC cD df-ne bitr4i $.
      $( [25-Feb-2005] $) $( [23-Feb-2005] $)
  $}

  ${
    necon3abid.1 $e |- ( ph -> ( A = B <-> ps ) ) $.
    $( Deduction from equality to inequality. $)
    necon3abid $p |- ( ph -> ( A =/= B <-> -. ps ) ) $=
      wph cA cB wceq wn wps wn cA cB wne wph cA cB wceq wps necon3abid.1 notbid
      cA cB df-ne syl5bb $.
      $( [24-Mar-2007] $) $( [21-Mar-2007] $)
  $}

  ${
    necon3bbid.1 $e |- ( ph -> ( ps <-> A = B ) ) $.
    $( Deduction from equality to inequality. $)
    necon3bbid $p |- ( ph -> ( -. ps <-> A =/= B ) ) $=
      wph cA cB wne wps wn wph wps cA cB wph wps cA cB wceq necon3bbid.1 bicomd
      necon3abid bicomd $.
      $( [4-Jun-2007] $) $( [2-Jun-2007] $)
  $}

  ${
    necon3bid.1 $e |- ( ph -> ( A = B <-> C = D ) ) $.
    $( Deduction from equality to inequality. $)
    necon3bid $p |- ( ph -> ( A =/= B <-> C =/= D ) ) $=
      wph cA cB wne cC cD wceq wn cC cD wne wph cC cD wceq cA cB necon3bid.1
      necon3abid cC cD df-ne syl6bbr $.
      $( [25-Feb-2005] $) $( [23-Feb-2005] $)
  $}

  ${
    necon3ad.1 $e |- ( ph -> ( ps -> A = B ) ) $.
    $( Contrapositive law deduction for inequality. $)
    necon3ad $p |- ( ph -> ( A =/= B -> -. ps ) ) $=
      wph cA cB wceq wn wps wn cA cB wne wph wps cA cB wceq necon3ad.1 con3d cA
      cB df-ne syl5ib $.
      $( [2-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    necon3bd.1 $e |- ( ph -> ( A = B -> ps ) ) $.
    $( Contrapositive law deduction for inequality. $)
    necon3bd $p |- ( ph -> ( -. ps -> A =/= B ) ) $=
      wph wps wn cA cB wceq wn cA cB wne wph cA cB wceq wps necon3bd.1 con3d cA
      cB df-ne syl6ibr $.
      $( [3-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    necon3d.1 $e |- ( ph -> ( A = B -> C = D ) ) $.
    $( Contrapositive law deduction for inequality. $)
    necon3d $p |- ( ph -> ( C =/= D -> A =/= B ) ) $=
      wph cC cD wne cA cB wceq wn cA cB wne wph cA cB wceq cC cD necon3d.1
      necon3ad cA cB df-ne syl6ibr $.
      $( [23-Jun-2006] $) $( [10-Jun-2006] $)
  $}

  ${
    necon3i.1 $e |- ( A = B -> C = D ) $.
    $( Contrapositive inference for inequality. $)
    necon3i $p |- ( C =/= D -> A =/= B ) $=
      cA cB wceq cC cD wceq wi cC cD wne cA cB wne wi necon3i.1 cA cB wceq cC
      cD wceq wi cA cB cC cD cA cB wceq cC cD wceq wi id necon3d ax-mp $.
      $( [15-Oct-2006] $) $( [9-Aug-2006] $)
  $}

  ${
    necon3ai.1 $e |- ( ph -> A = B ) $.
    $( Contrapositive inference for inequality. $)
    necon3ai $p |- ( A =/= B -> -. ph ) $=
      cA cB wne cA cB wceq wn wph wn cA cB df-ne wph cA cB wceq necon3ai.1
      con3i sylbi $.
      $( [23-May-2007] $) $( [23-May-2007] $)
  $}

  ${
    necon3bi.1 $e |- ( A = B -> ph ) $.
    $( Contrapositive inference for inequality. $)
    necon3bi $p |- ( -. ph -> A =/= B ) $=
      wph wn cA cB wceq wn cA cB wne cA cB wceq wph necon3bi.1 con3i cA cB
      df-ne sylibr $.
      $( [5-Jun-2007] $) $( [1-Jun-2007] $)
  $}

  ${
    necon1ai.1 $e |- ( -. ph -> A = B ) $.
    $( Contrapositive inference for inequality. $)
    necon1ai $p |- ( A =/= B -> ph ) $=
      cA cB wne cA cB wceq wn wph cA cB df-ne wph cA cB wceq necon1ai.1 con1i
      sylbi $.
      $( [15-Feb-2007] $) $( [12-Feb-2007] $)
  $}

  ${
    necon1bi.1 $e |- ( A =/= B -> ph ) $.
    $( Contrapositive inference for inequality. $)
    necon1bi $p |- ( -. ph -> A = B ) $=
      cA cB wceq wph cA cB wceq wn cA cB wne wph cA cB df-ne necon1bi.1 sylbir
      con1i $.
      $( [23-Mar-2007] $) $( [18-Mar-2007] $)
  $}

  ${
    necon1i.1 $e |- ( A =/= B -> C = D ) $.
    $( Contrapositive inference for inequality. $)
    necon1i $p |- ( C =/= D -> A = B ) $=
      cA cB wceq cC cD cA cB wceq wn cA cB wne cC cD wceq cA cB df-ne necon1i.1
      sylbir necon1ai $.
      $( [19-Mar-2007] $) $( [18-Mar-2007] $)
  $}

  ${
    necon2ai.1 $e |- ( A = B -> -. ph ) $.
    $( Contrapositive inference for inequality. $)
    necon2ai $p |- ( ph -> A =/= B ) $=
      wph cA cB wceq wn cA cB wne cA cB wceq wph necon2ai.1 con2i cA cB df-ne
      sylibr $.
      $( [19-Jan-2007] $) $( [16-Jan-2007] $)
  $}

  ${
    necon2bi.1 $e |- ( ph -> A =/= B ) $.
    $( Contrapositive inference for inequality. $)
    necon2bi $p |- ( A = B -> -. ph ) $=
      wph cA cB wceq wph cA cB wne cA cB wceq wn necon2bi.1 cA cB df-ne sylib
      con2i $.
      $( [2-Apr-2007] $) $( [1-Apr-2007] $)
  $}

  ${
    necon2i.1 $e |- ( A = B -> C =/= D ) $.
    $( Contrapositive inference for inequality. $)
    necon2i $p |- ( C = D -> A =/= B ) $=
      cC cD wceq cA cB cA cB wceq cC cD wne cC cD wceq wn necon2i.1 cC cD df-ne
      sylib necon2ai $.
      $( [25-Apr-2007] $) $( [18-Mar-2007] $)
  $}

  ${
    necon2ad.1 $e |- ( ph -> ( A = B -> -. ps ) ) $.
    $( Contrapositive inference for inequality. $)
    necon2ad $p |- ( ph -> ( ps -> A =/= B ) ) $=
      wph wps cA cB wceq wn cA cB wne wph cA cB wceq wps necon2ad.1 con2d cA cB
      df-ne syl6ibr $.
      $( [26-Apr-2007] $) $( [19-Apr-2007] $)
  $}

  ${
    necon2bd.1 $e |- ( ph -> ( ps -> A =/= B ) ) $.
    $( Contrapositive inference for inequality. $)
    necon2bd $p |- ( ph -> ( A = B -> -. ps ) ) $=
      wph wps cA cB wceq wph wps cA cB wne cA cB wceq wn necon2bd.1 cA cB df-ne
      syl6ib con2d $.
      $( [14-Apr-2007] $) $( [13-Apr-2007] $)
  $}

  ${
    necon2d.1 $e |- ( ph -> ( A = B -> C =/= D ) ) $.
    $( Contrapositive inference for inequality. $)
    necon2d $p |- ( ph -> ( C = D -> A =/= B ) ) $=
      wph cC cD wceq cA cB wph cA cB wceq cC cD wne cC cD wceq wn necon2d.1 cC
      cD df-ne syl6ib necon2ad $.
      $( [18-Jan-2009] $) $( [28-Dec-2008] $)
  $}

  ${
    necon1abii.1 $e |- ( -. ph <-> A = B ) $.
    $( Contrapositive inference for inequality. $)
    necon1abii $p |- ( A =/= B <-> ph ) $=
      cA cB wne cA cB wceq wn wph cA cB df-ne wph cA cB wceq necon1abii.1
      con1bii bitri $.
      $( [2-Jun-2007] $) $( [17-Mar-2007] $)
  $}

  ${
    necon1bbii.1 $e |- ( A =/= B <-> ph ) $.
    $( Contrapositive inference for inequality. $)
    necon1bbii $p |- ( -. ph <-> A = B ) $=
      cA cB wceq wph cA cB wceq wn cA cB wne wph cA cB df-ne necon1bbii.1
      bitr3i con1bii $.
      $( [20-Mar-2007] $) $( [17-Mar-2007] $)
  $}

  ${
    necon1abid.1 $e |- ( ph -> ( -. ps <-> A = B ) ) $.
    $( Contrapositive deduction for inequality. $)
    necon1abid $p |- ( ph -> ( A =/= B <-> ps ) ) $=
      wph cA cB wceq wn wps cA cB wne wph wps cA cB wceq necon1abid.1 con1bid
      cA cB df-ne syl5bb $.
      $( [22-Aug-2007] $) $( [21-Aug-2007] $)
  $}

  ${
    necon1bbid.1 $e |-  ( ph -> ( A =/= B <-> ps ) ) $.
    $( Contrapositive inference for inequality. $)
    necon1bbid $p |-  ( ph -> ( -. ps <-> A = B ) ) $=
      wph cA cB wceq wps wph cA cB wne wps cA cB wceq wn necon1bbid.1 cA cB
      df-ne syl5bbr con1bid $.
      $( [15-Apr-2008] $) $( [31-Jan-2008] $)
  $}

  ${
    necon2abii.1 $e |- ( A = B <-> -. ph ) $.
    $( Contrapositive inference for inequality. $)
    necon2abii $p |- ( ph <-> A =/= B ) $=
      cA cB wne wph wph cA cB cA cB wceq wph wn necon2abii.1 bicomi necon1abii
      bicomi $.
      $( [2-Mar-2007] $) $( [2-Mar-2007] $)
  $}

  ${
    necon2bbii.1 $e |- ( ph <-> A =/= B ) $.
    $( Contrapositive inference for inequality. $)
    necon2bbii $p |- ( A = B <-> -. ph ) $=
      wph wn cA cB wceq wph cA cB wph cA cB wne necon2bbii.1 bicomi necon1bbii
      bicomi $.
      $( [19-Apr-2007] $) $( [13-Apr-2007] $)
  $}

  ${
    necon2abid.1 $e |- ( ph -> ( A = B <-> -. ps ) ) $.
    $( Contrapositive deduction for inequality. $)
    necon2abid $p |- ( ph -> ( ps <-> A =/= B ) ) $=
      wph wps cA cB wceq wn cA cB wne wph cA cB wceq wps necon2abid.1 con2bid
      cA cB df-ne syl6bbr $.
      $( [18-Jul-2007] $) $( [18-Jul-2007] $)
  $}

  ${
    necon2bbid.1 $e |- ( ph -> ( ps <-> A =/= B ) ) $.
    $( Contrapositive deduction for inequality. $)
    necon2bbid $p |- ( ph -> ( A = B <-> -. ps ) ) $=
      wph wps cA cB wceq wph wps cA cB wne cA cB wceq wn necon2bbid.1 cA cB
      df-ne syl6bb con2bid $.
      $( [17-Apr-2007] $) $( [13-Apr-2007] $)
  $}

  ${
    necon4ai.1 $e |- ( A =/= B -> -. ph ) $.
    $( Contrapositive inference for inequality. $)
    necon4ai $p |- ( ph -> A = B ) $=
      cA cB wceq wph cA cB wceq wn cA cB wne wph wn cA cB df-ne necon4ai.1
      sylbir con4i $.
      $( [20-Jan-2007] $) $( [16-Jan-2007] $)
  $}

  ${
    necon4i.1 $e |- ( A =/= B -> C =/= D ) $.
    $( Contrapositive inference for inequality. $)
    necon4i $p |- ( C = D -> A = B ) $=
      cC cD wceq cA cB cA cB wne cC cD wne cC cD wceq wn necon4i.1 cC cD df-ne
      sylib necon4ai $.
      $( [25-Mar-2007] $) $( [17-Mar-2007] $)
  $}

  ${
    necon4ad.1 $e |- ( ph -> ( A =/= B -> -. ps ) ) $.
    $( Contrapositive inference for inequality. $)
    necon4ad $p |- ( ph -> ( ps -> A = B ) ) $=
      wph cA cB wceq wps wph cA cB wne wps wn cA cB wceq wn necon4ad.1 cA cB
      df-ne syl5ibr con4d $.
      $( [15-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    necon4bd.1 $e |- ( ph -> ( -. ps -> A =/= B ) ) $.
    $( Contrapositive inference for inequality. $)
    necon4bd $p |- ( ph -> ( A = B -> ps ) ) $=
      wph wps cA cB wceq wph wps wn cA cB wne cA cB wceq wn necon4bd.1 cA cB
      df-ne syl6ib con4d $.
      $( [3-Jun-2007] $) $( [1-Jun-2007] $)
  $}

  ${
    necon4d.1 $e |- ( ph -> ( A =/= B -> C =/= D ) ) $.
    $( Contrapositive inference for inequality. $)
    necon4d $p |- ( ph -> ( C = D -> A = B ) ) $=
      wph cC cD wceq cA cB wph cA cB wne cC cD wne cC cD wceq wn necon4d.1 cC
      cD df-ne syl6ib necon4ad $.
      $( [15-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    necon4abid.1 $e |- ( ph -> ( A =/= B <-> -. ps ) ) $.
    $( Contrapositive law deduction for inequality. $)
    necon4abid $p |- ( ph -> ( A = B <-> ps ) ) $=
      wph cA cB wceq wps wph cA cB wne wps wn cA cB wceq wn necon4abid.1 cA cB
      df-ne syl5bbr con4bid $.
      $( [12-Feb-2008] $) $( [11-Jan-2008] $)
  $}

  ${
    necon4bid.1 $e |- ( ph -> ( A =/= B <-> C =/= D ) ) $.
    $( Contrapositive law deduction for inequality. $)
    necon4bid $p |- ( ph -> ( A = B <-> C = D ) ) $=
      wph cC cD wceq cA cB wne wn cA cB wceq wph cA cB wne cC cD necon4bid.1
      necon2bbid cA cB nne syl6rbb $.
      $( [29-Jun-2007] $) $( [29-Jun-2007] $)
  $}

  ${
    necon1ad.1 $e |- ( ph -> ( -. ps -> A = B ) ) $.
    $( Contrapositive deduction for inequality. $)
    necon1ad $p |- ( ph -> ( A =/= B -> ps ) ) $=
      wph cA cB wceq wn wps cA cB wne wph wps cA cB wceq necon1ad.1 con1d cA cB
      df-ne syl5ib $.
      $( [17-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    necon1bd.1 $e |- ( ph -> ( A =/= B -> ps ) ) $.
    $( Contrapositive deduction for inequality. $)
    necon1bd $p |- ( ph -> ( -. ps -> A = B ) ) $=
      wph cA cB wceq wps wph cA cB wne wps cA cB wceq wn necon1bd.1 cA cB df-ne
      syl5ibr con1d $.
      $( [25-Mar-2007] $) $( [21-Mar-2007] $)
  $}

  ${
    necon1d.1 $e |- ( ph -> ( A =/= B -> C = D ) ) $.
    $( Contrapositive law deduction for inequality. $)
    necon1d $p |- ( ph -> ( C =/= D -> A = B ) ) $=
      wph cA cB wceq cC cD wph cA cB wne cC cD wceq cA cB wceq wn necon1d.1 cA
      cB df-ne syl5ibr necon1ad $.
      $( [29-Dec-2008] $) $( [28-Dec-2008] $)
  $}

  $( Contraposition law for inequality. $)
  nebi $p |- ( ( A = B <-> C = D ) <-> ( A =/= B <-> C =/= D ) ) $=
    cA cB wceq cC cD wceq wb cA cB wne cC cD wne wb cA cB wceq cC cD wceq wb cA
    cB cC cD cA cB wceq cC cD wceq wb id necon3bid cA cB wne cC cD wne wb cA cB
    cC cD cA cB wne cC cD wne wb id necon4bid impbii $.
    $( [13-Jan-2009] $) $( [28-Dec-2008] $)

  ${
    pm2.61ne.1 $e |- ( A = B -> ( ps <-> ch ) ) $.
    pm2.61ne.2 $e |- ( ( ph /\ A =/= B ) -> ps ) $.
    pm2.61ne.3 $e |- ( ph -> ch ) $.
    $( Deduction eliminating an inequality in an antecedent. $)
    pm2.61ne $p |- ( ph -> ps ) $=
      wph cA cB wceq wps cA cB wceq wph wps cA cB wceq wps wch wph pm2.61ne.1
      pm2.61ne.3 syl5bir impcom wph cA cB wne wps cA cB wceq wn pm2.61ne.2 cA
      cB df-ne sylan2br pm2.61dan $.
      $( [1-Jun-2006] $) $( [24-May-2006] $)
  $}

  ${
    pm2.61ine.1 $e |- ( A = B -> ph ) $.
    pm2.61ine.2 $e |- ( A =/= B -> ph ) $.
    $( Inference eliminating an inequality in an antecedent. $)
    pm2.61ine $p |- ph $=
      cA cB wceq wph pm2.61ine.1 cA cB wceq wn cA cB wne wph cA cB df-ne
      pm2.61ine.2 sylbir pm2.61i $.
      $( [16-Jan-2007] $) $( [16-Jan-2007] $)
  $}

  ${
    pm2.61dne.1 $e |- ( ph -> ( A = B -> ps ) ) $.
    pm2.61dne.2 $e |- ( ph -> ( A =/= B -> ps ) ) $.
    $( Deduction eliminating an inequality in an antecedent. $)
    pm2.61dne $p |- ( ph -> ps ) $=
      wph cA cB wceq wps pm2.61dne.1 wph cA cB wne wps cA cB wceq wn
      pm2.61dne.2 cA cB df-ne syl5ibr pm2.61d $.
      $( [1-Jun-2007] $) $( [1-Jun-2007] $)
  $}

  $( Commutation of inequality. $)
  necom $p |- ( A =/= B <-> B =/= A ) $=
    cA cB cB cA cA cB eqcom necon3bii $.
    $( [14-May-1999] $)

  ${
    necomd.1 $e |- ( ph -> A =/= B ) $.
    $( Deduction from commutative law for inequality. $)
    necomd $p |- ( ph -> B =/= A ) $=
      wph cA cB wne cB cA wne necomd.1 cA cB necom sylib $.
      $( [13-Feb-2008] $) $( [12-Feb-2008] $)
  $}

  $( Logical OR with an equality. $)
  neor $p |- ( ( A = B \/ ps ) <-> ( A =/= B -> ps ) ) $=
    cA cB wceq wps wo cA cB wceq wn wps wi cA cB wne wps wi cA cB wceq wps
    df-or cA cB wne cA cB wceq wn wps cA cB df-ne imbi1i bitr4i $.
    $( [30-Apr-2007] $) $( [29-Apr-2007] $)

  $( A DeMorgan's law for inequality. $)
  neanior $p |- ( ( A =/= B /\ C =/= D ) <-> -. ( A = B \/ C = D ) ) $=
    cA cB wne cC cD wne wa cA cB wceq wn cC cD wceq wn wa cA cB wceq cC cD wceq
    wo wn cA cB wne cA cB wceq wn cC cD wne cC cD wceq wn cA cB df-ne cC cD
    df-ne anbi12i cA cB wceq cC cD wceq pm4.56 bitri $.
    $( [20-May-2007] $) $( [18-May-2007] $)

  $( A DeMorgan's law for inequality. $)
  neorian $p |- ( ( A =/= B \/ C =/= D ) <-> -. ( A = B /\ C = D ) ) $=
    cA cB wne cC cD wne wo cA cB wceq wn cC cD wceq wn wo cA cB wceq cC cD wceq
    wa wn cA cB wne cA cB wceq wn cC cD wne cC cD wceq wn cA cB df-ne cC cD
    df-ne orbi12i cA cB wceq cC cD wceq ianor bitr4i $.
    $( [20-May-2007] $) $( [18-May-2007] $)

  ${
    nemtbir.1 $e |- A =/= B $.
    nemtbir.2 $e |- ( ph <-> A = B ) $.
    $( An inference from an inequality, related to modus tollens. $)
    nemtbir $p |- -. ph $=
      wph cA cB wceq cA cB wne cA cB wceq wn nemtbir.1 cA cB df-ne mpbi
      nemtbir.2 mtbir $.
      $( [13-Apr-2007] $) $( [13-Apr-2007] $)
  $}

  $( Equality theorem for negated membership. $)
  neleq1 $p |- ( A = B -> ( A e/ C <-> B e/ C ) ) $=
    cA cB wceq cA cC wcel wn cB cC wcel wn cA cC wnel cB cC wnel cA cB wceq cA
    cC wcel cB cC wcel cA cB cC eleq1 notbid cA cC df-nel cB cC df-nel 3bitr4g
    $.
    $( [20-Nov-1994] $)

  $( Equality theorem for negated membership. $)
  neleq2 $p |- ( A = B -> ( C e/ A <-> C e/ B ) ) $=
    cA cB wceq cC cA wcel wn cC cB wcel wn cC cA wnel cC cB wnel cA cB wceq cC
    cA wcel cC cB wcel cA cB cC eleq2 notbid cC cA df-nel cC cB df-nel 3bitr4g
    $.
    $( [20-Nov-1994] $)

  ${
    $d y A $.  $d y B $.  $d x y $.
    hbne.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbne.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for inequality. $)
    hbne $p |- ( A =/= B -> A. x A =/= B ) $=
      cA cB wceq wn cA cB wceq wn vx wal cA cB wne cA cB wne vx wal cA cB wceq
      vx vx vy vy cA cB hbne.1 hbne.2 hbeq hbn cA cB df-ne cA cB wne cA cB wceq
      wn vx cA cB df-ne albii 3imtr4i $.
      $( [4-Apr-2008] $) $( [10-Nov-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Restricted quantification
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend wff notation to include restricted universal quantification. $)
  wral $a wff A. x e. A ph $.

  $( Extend wff notation to include restricted existential quantification. $)
  wrex $a wff E. x e. A ph $.

  $( Extend wff notation to include restricted existential uniqueness. $)
  wreu $a wff E! x e. A ph $.

  $( Extend class notation to include the restricted class abstraction
     (class builder). $)
  crab $a class { x e. A | ph } $.

  $( Define restricted universal quantification.  Special case of Definition
     4.15(3) of [TakeutiZaring] p. 22. $)
  df-ral $a |- ( A. x e. A ph <-> A. x ( x e. A -> ph ) ) $.

  $( Define restricted existential quantification.  Special case of Definition
     4.15(4) of [TakeutiZaring] p. 22. $)
  df-rex $a |- ( E. x e. A ph <-> E. x ( x e. A /\ ph ) ) $.

  $( Define restricted existential uniqueness. $)
  df-reu $a |- ( E! x e. A ph <-> E! x ( x e. A /\ ph ) ) $.

  $( Define a restricted class abstraction (class builder), which is the class
     of all ` x ` in ` A ` such that ` ph ` is true.  Definition of
     [TakeutiZaring] p. 20. $)
  df-rab $a |- { x e. A | ph } = { x | ( x e. A /\ ph ) } $.

  $( Relationship between restricted universal and existential quantifiers. $)
  ralnex $p |- ( A. x e. A -. ph <-> -. E. x e. A ph ) $=
    vx cv cA wcel wph wn wi vx wal vx cv cA wcel wph wa vx wex wn wph wn vx cA
    wral wph vx cA wrex wn vx cv cA wcel wph vx alinexa wph wn vx cA df-ral wph
    vx cA wrex vx cv cA wcel wph wa vx wex wph vx cA df-rex notbii 3bitr4i $.
    $( [21-Jan-1997] $)

  $( Relationship between restricted universal and existential quantifiers. $)
  rexnal $p |- ( E. x e. A -. ph <-> -. A. x e. A ph ) $=
    vx cv cA wcel wph wn wa vx wex vx cv cA wcel wph wi vx wal wn wph wn vx cA
    wrex wph vx cA wral wn vx cv cA wcel wph vx exanali wph wn vx cA df-rex wph
    vx cA wral vx cv cA wcel wph wi vx wal wph vx cA df-ral notbii 3bitr4i $.
    $( [21-Jan-1997] $)

  $( Relationship between restricted universal and existential quantifiers. $)
  dfral2 $p |- ( A. x e. A ph <-> -. E. x e. A -. ph ) $=
    wph wn vx cA wrex wph vx cA wral wph vx cA rexnal con2bii $.
    $( [21-Jan-1997] $)

  $( Relationship between restricted universal and existential quantifiers. $)
  dfrex2 $p |- ( E. x e. A ph <-> -. A. x e. A -. ph ) $=
    wph wn vx cA wral wph vx cA wrex wph vx cA ralnex con2bii $.
    $( [21-Jan-1997] $)

  ${
    ralbida.1 $e |- ( ph -> A. x ph ) $.
    ralbida.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule). $)
    ralbida $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      wph vx cv cA wcel wps wi vx wal vx cv cA wcel wch wi vx wal wps vx cA
      wral wch vx cA wral wph vx cv cA wcel wps wi vx cv cA wcel wch wi vx
      ralbida.1 wph vx cv cA wcel wps wch ralbida.2 pm5.74da albid wps vx cA
      df-ral wch vx cA df-ral 3bitr4g $.
      $( [3-Nov-2003] $) $( [6-Oct-2003] $)

    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    rexbida $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      wph vx cv cA wcel wps wa vx wex vx cv cA wcel wch wa vx wex wps vx cA
      wrex wch vx cA wrex wph vx cv cA wcel wps wa vx cv cA wcel wch wa vx
      ralbida.1 wph vx cv cA wcel wps wch ralbida.2 pm5.32da exbid wps vx cA
      df-rex wch vx cA df-rex 3bitr4g $.
      $( [3-Nov-2003] $) $( [6-Oct-2003] $)
  $}

  ${
    $d x ph $.
    ralbidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule). $)
    ralbidva $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 ralbidva.1 ralbida $.
      $( [4-Mar-1997] $)

    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    rexbidva $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 ralbidva.1 rexbida $.
      $( [9-Mar-1997] $)
  $}

  ${
    ralbid.1 $e |- ( ph -> A. x ph ) $.
    ralbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.

    $( Formula-building rule for restricted universal quantifier (deduction
       rule). $)
    ralbid $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      wph wps wch vx cA ralbid.1 wph wps wch wb vx cv cA wcel ralbid.2 adantr
      ralbida $.
      $( [27-Jun-1998] $)

    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    rexbid $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      wph wps wch vx cA ralbid.1 wph wps wch wb vx cv cA wcel ralbid.2 adantr
      rexbida $.
      $( [27-Jun-1998] $)
  $}

  ${
    $d x ph $.
    ralbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.

    $( Formula-building rule for restricted universal quantifier (deduction
       rule). $)
    ralbidv $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 ralbidv.1 ralbid $.
      $( [20-Nov-1994] $)

    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    rexbidv $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 ralbidv.1 rexbid $.
      $( [20-Nov-1994] $)
  $}

  ${
    $d x ph $.
    ralbidv2.1 $e |- ( ph -> ( ( x e. A -> ps ) <-> ( x e. B -> ch ) ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule). $)
    ralbidv2 $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ch ) ) $=
      wph vx cv cA wcel wps wi vx wal vx cv cB wcel wch wi vx wal wps vx cA
      wral wch vx cB wral wph vx cv cA wcel wps wi vx cv cB wcel wch wi vx
      ralbidv2.1 albidv wps vx cA df-ral wch vx cB df-ral 3bitr4g $.
      $( [6-Apr-1997] $)
  $}

  ${
    $d x ph $.
    rexbidv2.1 $e |- ( ph -> ( ( x e. A /\ ps ) <-> ( x e. B /\ ch ) ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    rexbidv2 $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ch ) ) $=
      wph vx cv cA wcel wps wa vx wex vx cv cB wcel wch wa vx wex wps vx cA
      wrex wch vx cB wrex wph vx cv cA wcel wps wa vx cv cB wcel wch wa vx
      rexbidv2.1 exbidv wps vx cA df-rex wch vx cB df-rex 3bitr4g $.
      $( [22-May-1999] $)
  $}

  ${
    ralbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding restricted universal quantifier to both sides of an
       equivalence. $)
    ralbii $p |- ( A. x e. A ph <-> A. x e. A ps ) $=
      wph wph wb wph vx cA wral wps vx cA wral wb wph biid wph wph wb wph wps
      vx cA wph wph wb vx wph biid hbth wph wps wb wph wph wb ralbii.1 a1i
      ralbid ax-mp $.
      $( [23-Nov-1994] $)

    $( Inference adding restricted existential quantifier to both sides of an
       equivalence. $)
    rexbii $p |- ( E. x e. A ph <-> E. x e. A ps ) $=
      wph wph wb wph vx cA wrex wps vx cA wrex wb wph biid wph wph wb wph wps
      vx cA wph wph wb vx wph biid hbth wph wps wb wph wph wb ralbii.1 a1i
      rexbid ax-mp $.
      $( [23-Nov-1994] $)

    $( Inference adding 2 restricted universal quantifiers to both sides of
       an equivalence. $)
    2ralbii $p |- ( A. x e. A A. y e. B ph <-> A. x e. A A. y e. B ps ) $=
      wph vy cB wral wps vy cB wral vx cA wph wps vy cB ralbii.1 ralbii ralbii
      $.
      $( [2-Aug-2004] $) $( [1-Aug-2004] $)

    $( Inference adding 2 restricted existential quantifiers to both sides of
       an equivalence. $)
    2rexbii $p |- ( E. x e. A E. y e. B ph <-> E. x e. A E. y e. B ps ) $=
      wph vy cB wrex wps vy cB wrex vx cA wph wps vy cB ralbii.1 rexbii rexbii
      $.
      $( [11-Nov-1995] $)
  $}

  ${
    ralbii2.1 $e |- ( ( x e. A -> ph ) <-> ( x e. B -> ps ) ) $.
    $( Inference adding different restricted universal quantifiers to each
       side of an equivalence. $)
    ralbii2 $p |- ( A. x e. A ph <-> A. x e. B ps ) $=
      vx cv cA wcel wph wi vx wal vx cv cB wcel wps wi vx wal wph vx cA wral
      wps vx cB wral vx cv cA wcel wph wi vx cv cB wcel wps wi vx ralbii2.1
      albii wph vx cA df-ral wps vx cB df-ral 3bitr4i $.
      $( [29-Aug-2005] $) $( [15-Aug-2005] $)
  $}

  ${
    rexbii2.1 $e |- ( ( x e. A /\ ph ) <-> ( x e. B /\ ps ) ) $.
    $( Inference adding different restricted existential quantifiers to each
       side of an equivalence. $)
    rexbii2 $p |- ( E. x e. A ph <-> E. x e. B ps ) $=
      vx cv cA wcel wph wa vx wex vx cv cB wcel wps wa vx wex wph vx cA wrex
      wps vx cB wrex vx cv cA wcel wph wa vx cv cB wcel wps wa vx rexbii2.1
      exbii wph vx cA df-rex wps vx cB df-rex 3bitr4i $.
      $( [16-Feb-2004] $) $( [4-Feb-2004] $)
  $}

  ${
    ralbiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Inference adding restricted universal quantifier to both sides of an
       equivalence. $)
    ralbiia $p |- ( A. x e. A ph <-> A. x e. A ps ) $=
      wph wps vx cA cA vx cv cA wcel wph wps ralbiia.1 pm5.74i ralbii2 $.
      $( [26-Nov-2000] $)

    $( Inference adding restricted existential quantifier to both sides of an
       equivalence. $)
    rexbiia $p |- ( E. x e. A ph <-> E. x e. A ps ) $=
      wph wps vx cA cA vx cv cA wcel wph wps ralbiia.1 pm5.32i rexbii2 $.
      $( [26-Oct-1999] $)
  $}

  ${
    $d x y $.  $d y A $.
    2rexbiia.1 $e |- ( ( x e. A /\ y e. B ) -> ( ph <-> ps ) ) $.
    $( Inference adding 2 restricted existential quantifiers to both sides of
       an equivalence. $)
    2rexbiia $p |- ( E. x e. A E. y e. B ph <-> E. x e. A E. y e. B ps ) $=
      wph vy cB wrex wps vy cB wrex vx cA vx cv cA wcel wph wps vy cB
      2rexbiia.1 rexbidva rexbiia $.
      $( [2-Aug-2004] $) $( [1-Aug-2004] $)
  $}

  ${
    $d x y $.  $d y A $.
    $( Double restricted universal quantification. $)
    r2al $p |- ( A. x e. A A. y e. B ph <->
               A. x A. y ( ( x e. A /\ y e. B ) -> ph ) ) $=
      wph vy cB wral vx cA wral vx cv cA wcel wph vy cB wral wi vx wal vx cv cA
      wcel vy cv cB wcel wa wph wi vy wal vx wal wph vy cB wral vx cA df-ral vx
      cv cA wcel vy cv cB wcel wa wph wi vy wal vx cv cA wcel wph vy cB wral wi
      vx vx cv cA wcel vy cv cB wcel wph wi wi vy wal vx cv cA wcel vy cv cB
      wcel wph wi vy wal wi vx cv cA wcel vy cv cB wcel wa wph wi vy wal vx cv
      cA wcel wph vy cB wral wi vx cv cA wcel vy cv cB wcel wph wi vy 19.21v vx
      cv cA wcel vy cv cB wcel wa wph wi vx cv cA wcel vy cv cB wcel wph wi wi
      vy vx cv cA wcel vy cv cB wcel wph impexp albii wph vy cB wral vy cv cB
      wcel wph wi vy wal vx cv cA wcel wph vy cB df-ral imbi2i 3bitr4i albii
      bitr4i $.
      $( [19-Nov-1995] $)
  $}

  ${
    $d x y $.  $d y A $.
    2ralbida.1 $e |- ( ph -> A. x ph ) $.
    2ralbida.2 $e |- ( ph -> A. y ph ) $.
    2ralbida.3 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule). $)
    2ralbida $p |- ( ph ->
                     ( A. x e. A A. y e. B ps <-> A. x e. A A. y e. B ch ) ) $=
      wph wps vy cB wral wch vy cB wral vx cA 2ralbida.1 wph vx cv cA wcel wa
      wps wch vy cB wph vx cv cA wcel vy 2ralbida.2 vx cv cA wcel vy ax-17 hban
      wph vx cv cA wcel vy cv cB wcel wps wch wb 2ralbida.3 anassrs ralbida
      ralbida $.
      $( [24-Feb-2004] $) $( [24-Feb-2004] $)
  $}

  ${
    $d x y ph $.  $d y A $.
    2ralbidva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifiers (deduction
       rule). $)
    2ralbidva $p |- ( ph ->
                     ( A. x e. A A. y e. B ps <-> A. x e. A A. y e. B ch ) ) $=
      wph wps wch vx vy cA cB wph vx ax-17 wph vy ax-17 2ralbidva.1 2ralbida $.
      $( [4-Mar-1997] $)

    $( Formula-building rule for restricted existential quantifiers (deduction
       rule). $)
    2rexbidva $p |- ( ph ->
                    ( E. x e. A E. y e. B ps <-> E. x e. A E. y e. B ch ) ) $=
      wph wps vy cB wrex wch vy cB wrex vx cA wph vx cv cA wcel wa wps wch vy
      cB wph vx cv cA wcel vy cv cB wcel wps wch wb 2ralbidva.1 anassrs
      rexbidva rexbidva $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)
  $}

  ${
    $d x ph $.  $d y ph $.
    2ralbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifiers (deduction
       rule).  (Distinct variable restriction on ` x ` and ` y ` removed by
       Szymon Jaroszewicz, 16-Mar-2006.) $)
    2ralbidv $p |- ( ph ->
                     ( A. x e. A A. y e. B ps <-> A. x e. A A. y e. B ch ) ) $=
      wph wps vy cB wral wch vy cB wral vx cA wph wps wch vy cB 2ralbidv.1
      ralbidv ralbidv $.
      $( [16-Mar-2007] $) $( [28-Jan-2006] $)

    $( Formula-building rule for restricted existential quantifiers (deduction
       rule). $)
    2rexbidv $p |- ( ph ->
                    ( E. x e. A E. y e. B ps <-> E. x e. A E. y e. B ch ) ) $=
      wph wps vy cB wrex wch vy cB wrex vx cA wph wps wch vy cB 2ralbidv.1
      rexbidv rexbidv $.
      $( [29-Jan-2006] $) $( [28-Jan-2006] $)

    $( Formula-building rule for restricted quantifiers (deduction rule). $)
    rexralbidv $p |- ( ph ->
                    ( E. x e. A A. y e. B ps <-> E. x e. A A. y e. B ch ) ) $=
      wph wps vy cB wral wch vy cB wral vx cA wph wps wch vy cB 2ralbidv.1
      ralbidv rexbidv $.
      $( [29-Jan-2006] $) $( [28-Jan-2006] $)
  $}

  $( A transformation of restricted quantifiers and logical connectives. $)
  ralinexa $p |- ( A. x e. A ( ph -> -. ps ) <-> -. E. x e. A ( ph /\ ps ) ) $=
    wph wps wn wi vx cA wral wph wps wa wn vx cA wral wph wps wa vx cA wrex wn
    wph wps wn wi wph wps wa wn vx cA wph wps imnan ralbii wph wps wa vx cA
    ralnex bitri $.
    $( [8-Sep-2005] $) $( [4-Sep-2005] $)

  $( A transformation of restricted quantifiers and logical connectives. $)
  rexanali $p |- ( E. x e. A ( ph /\ -. ps ) <-> -. A. x e. A ( ph -> ps ) ) $=
    wph wps wn wa vx cA wrex wph wps wi wn vx cA wrex wph wps wi vx cA wral wn
    wph wps wn wa wph wps wi wn vx cA wph wps annim rexbii wph wps wi vx cA
    rexnal bitri $.
    $( [27-Sep-2005] $) $( [4-Sep-2005] $)

  ${
    $d x A $.  $d x B $.
    $( Two ways to say " ` A ` belongs to ` B ` ." $)
    risset $p |- ( A e. B <-> E. x e. B x = A ) $=
      vx cv cB wcel vx cv cA wceq wa vx wex vx cv cA wceq vx cv cB wcel wa vx
      wex vx cv cA wceq vx cB wrex cA cB wcel vx cv cB wcel vx cv cA wceq vx
      exancom vx cv cA wceq vx cB df-rex vx cA cB df-clel 3bitr4ri $.
      $( [22-Nov-1994] $)
  $}

  ${
    hbral.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbral.2 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for restricted quantification.
       (Distinct variable restriction on ` x ` and ` y ` was removed by
       David Abernethy, 13-Dec-2009.) $)
    hbral $p |- ( A. y e. A ph -> A. x A. y e. A ph ) $=
      vy cv cA wcel wph wi vy wal vy cv cA wcel wph wi vy wal vx wal wph vy cA
      wral wph vy cA wral vx wal vy cv cA wcel wph wi vx vy vy cv cA wcel wph
      vx hbral.1 hbral.2 hbim hbal wph vy cA df-ral wph vy cA wral vy cv cA
      wcel wph wi vy wal vx wph vy cA df-ral albii 3imtr4i $.
      $( [13-Dec-2009] $) $( [1-Sep-1999] $)
  $}

  $( ` x ` is not free in ` A. x e. A ph ` . $)
  hbra1 $p |- ( A. x e. A ph -> A. x A. x e. A ph ) $=
    vx cv cA wcel wph wi vx wal vx cv cA wcel wph wi vx wal vx wal wph vx cA
    wral wph vx cA wral vx wal vx cv cA wcel wph wi vx hba1 wph vx cA df-ral
    wph vx cA wral vx cv cA wcel wph wi vx wal vx wph vx cA df-ral albii
    3imtr4i $.
    $( [18-Oct-1996] $)

  ${
    hbrex.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbrex.2 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for restricted quantification.
       (Distinct variable restriction on ` x ` and ` y ` was removed by
       David Abernethy, 13-Dec-2009.) $)
    hbrex $p |- ( E. y e. A ph -> A. x E. y e. A ph ) $=
      vy cv cA wcel wph wa vy wex vy cv cA wcel wph wa vy wex vx wal wph vy cA
      wrex wph vy cA wrex vx wal vy cv cA wcel wph wa vx vy vy cv cA wcel wph
      vx hbrex.1 hbrex.2 hban hbex wph vy cA df-rex wph vy cA wrex vy cv cA
      wcel wph wa vy wex vx wph vy cA df-rex albii 3imtr4i $.
      $( [13-Dec-2009] $) $( [1-Sep-1999] $)
  $}

  $( ` x ` is not free in ` E. x e. A ph ` . $)
  hbre1 $p |- ( E. x e. A ph -> A. x E. x e. A ph ) $=
    vx cv cA wcel wph wa vx wex vx cv cA wcel wph wa vx wex vx wal wph vx cA
    wrex wph vx cA wrex vx wal vx cv cA wcel wph wa vx hbe1 wph vx cA df-rex
    wph vx cA wrex vx cv cA wcel wph wa vx wex vx wph vx cA df-rex albii
    3imtr4i $.
    $( [19-Mar-1997] $)

  ${
    $d x y z $.  $d y z A $.  $d z B $.
    $( Triple restricted universal quantification. $)
    r3al $p |- ( A. x e. A A. y e. B A. z e. C ph <->
               A. x A. y A. z ( ( x e. A /\ y e. B /\ z e. C ) -> ph ) ) $=
      vy cv cB wcel vz cv cC wcel wa wph wi vz wal vy wal vx cA wral vx cv cA
      wcel vy cv cB wcel vz cv cC wcel wa wph wi vz wal vy wal wi vx wal wph vz
      cC wral vy cB wral vx cA wral vx cv cA wcel vy cv cB wcel vz cv cC wcel
      w3a wph wi vz wal vy wal vx wal vy cv cB wcel vz cv cC wcel wa wph wi vz
      wal vy wal vx cA df-ral wph vz cC wral vy cB wral vy cv cB wcel vz cv cC
      wcel wa wph wi vz wal vy wal vx cA wph vy vz cB cC r2al ralbii vx cv cA
      wcel vy cv cB wcel vz cv cC wcel w3a wph wi vz wal vy wal vx cv cA wcel
      vy cv cB wcel vz cv cC wcel wa wph wi vz wal vy wal wi vx vx cv cA wcel
      vy cv cB wcel vz cv cC wcel w3a wph wi vz wal vy wal vx cv cA wcel vy cv
      cB wcel vz cv cC wcel wa wph wi vz wal wi vy wal vx cv cA wcel vy cv cB
      wcel vz cv cC wcel wa wph wi vz wal vy wal wi vx cv cA wcel vy cv cB wcel
      vz cv cC wcel w3a wph wi vz wal vx cv cA wcel vy cv cB wcel vz cv cC wcel
      wa wph wi vz wal wi vy vx cv cA wcel vy cv cB wcel vz cv cC wcel w3a wph
      wi vz wal vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wph wi wi vz wal
      vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wph wi vz wal wi vx cv cA
      wcel vy cv cB wcel vz cv cC wcel w3a wph wi vx cv cA wcel vy cv cB wcel
      vz cv cC wcel wa wph wi wi vz vx cv cA wcel vy cv cB wcel vz cv cC wcel
      w3a wph wi vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa wph wi vx cv
      cA wcel vy cv cB wcel vz cv cC wcel wa wph wi wi vx cv cA wcel vy cv cB
      wcel vz cv cC wcel w3a vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa
      wph vx cv cA wcel vy cv cB wcel vz cv cC wcel 3anass imbi1i vx cv cA wcel
      vy cv cB wcel vz cv cC wcel wa wph impexp bitri albii vx cv cA wcel vy cv
      cB wcel vz cv cC wcel wa wph wi vz 19.21v bitri albii vx cv cA wcel vy cv
      cB wcel vz cv cC wcel wa wph wi vz wal vy 19.21v bitri albii 3bitr4i $.
      $( [19-Nov-1995] $)
  $}

  ${
    $d x y $.  $d y A $.
    $( Double restricted existential quantification. $)
    r2ex $p |- ( E. x e. A E. y e. B ph <->
               E. x E. y ( ( x e. A /\ y e. B ) /\ ph ) ) $=
      wph vy cB wrex vx cA wrex vx cv cA wcel wph vy cB wrex wa vx wex vx cv cA
      wcel vy cv cB wcel wa wph wa vy wex vx wex wph vy cB wrex vx cA df-rex vx
      cv cA wcel vy cv cB wcel wa wph wa vy wex vx cv cA wcel wph vy cB wrex wa
      vx vx cv cA wcel vy cv cB wcel wph wa wa vy wex vx cv cA wcel vy cv cB
      wcel wph wa vy wex wa vx cv cA wcel vy cv cB wcel wa wph wa vy wex vx cv
      cA wcel wph vy cB wrex wa vx cv cA wcel vy cv cB wcel wph wa vy 19.42v vx
      cv cA wcel vy cv cB wcel wa wph wa vx cv cA wcel vy cv cB wcel wph wa wa
      vy vx cv cA wcel vy cv cB wcel wph anass exbii wph vy cB wrex vy cv cB
      wcel wph wa vy wex vx cv cA wcel wph vy cB df-rex anbi2i 3bitr4i exbii
      bitr4i $.
      $( [11-Nov-1995] $)
  $}

  $( Universal quantification implies restricted quantification. $)
  alral $p |- ( A. x ph -> A. x e. A ph ) $=
    wph vx wal vx cv cA wcel wph wi vx wal wph vx cA wral wph vx cv cA wcel wph
    wi vx wph vx cv cA wcel ax-1 19.20i wph vx cA df-ral sylibr $.
    $( [13-Nov-2006] $) $( [20-Oct-2006] $)

  $( Restricted existence implies existence. $)
  rexex $p |- ( E. x e. A ph -> E. x ph ) $=
    wph vx cA wrex vx cv cA wcel wph wa vx wex wph vx wex wph vx cA df-rex vx
    cv cA wcel wph wa wph vx vx cv cA wcel wph pm3.27 19.22i sylbi $.
    $( [11-Nov-1995] $)

  $( Restricted specialization. $)
  ra4 $p |- ( A. x e. A ph -> ( x e. A -> ph ) ) $=
    wph vx cA wral vx cv cA wcel wph wi vx wal vx cv cA wcel wph wi wph vx cA
    df-ral vx cv cA wcel wph wi vx ax-4 sylbi $.
    $( [17-Oct-1996] $)

  $( Restricted specialization. $)
  ra4e $p |- ( ( x e. A /\ ph ) -> E. x e. A ph ) $=
    vx cv cA wcel wph wa vx cv cA wcel wph wa vx wex wph vx cA wrex vx cv cA
    wcel wph wa vx 19.8a wph vx cA df-rex sylibr $.
    $( [12-Oct-1999] $)

  $( Restricted specialization. $)
  ra42 $p |- ( A. x e. A A. y e. B ph -> ( ( x e. A /\ y e. B ) -> ph ) ) $=
    wph vy cB wral vx cA wral vx cv cA wcel vy cv cB wcel wph wph vy cB wral vx
    cA wral vx cv cA wcel wph vy cB wral vy cv cB wcel wph wi wph vy cB wral vx
    cA ra4 wph vy cB ra4 syl6 imp3a $.
    $( [11-Feb-1997] $)

  ${
    rspec.1 $e |- A. x e. A ph $.
    $( Specialization rule for restricted quantification. $)
    rspec $p |- ( x e. A -> ph ) $=
      wph vx cA wral vx cv cA wcel wph wi rspec.1 wph vx cA ra4 ax-mp $.
      $( [19-Nov-1994] $)
  $}

  ${
    rgen.1 $e |- ( x e. A -> ph ) $.
    $( Generalization rule for restricted quantification. $)
    rgen $p |- A. x e. A ph $=
      wph vx cA wral vx cv cA wcel wph wi vx wph vx cA df-ral rgen.1 mpgbir $.
      $( [19-Nov-1994] $)
  $}

  ${
    $d y z A $.  $d x z $.
    rgen2a.1 $e |- ( ( x e. A /\ y e. A ) -> ph ) $.
    $( Generalization rule for restricted quantification.  Note that ` x `
       and ` y ` needn't be distinct. $)
    rgen2a $p |- A. x e. A A. y e. A ph $=
      wph vy cA wral vx cA vx cv cA wcel vy cv cA wcel wph wi vy wal wph vy cA
      wral vy cv vx cv wceq vy wal vx cv cA wcel vy cv cA wcel wph wi vy wal wi
      vy cv vx cv wceq vy wal vy cv cA wcel vy cv cA wcel wph wi wi vy wal vy
      cv cA wcel wph wi vy wal vx cv cA wcel vy cv cA wcel wph wi vy wal wi vy
      cv vx cv wceq vy wal vy cv cA wcel vy cv cA wcel wph wi wi vy wal vx cv
      cA wcel vy cv cA wcel wph wi wi vy wal vx cv cA wcel vy cv cA wcel wph wi
      wi vy vx cv cA wcel vy cv cA wcel wph rgen2a.1 ex ax-gen vy cv cA wcel vy
      cv cA wcel wph wi wi vx cv cA wcel vy cv cA wcel wph wi wi vy vx vy vy cv
      vx cv wceq vy wal vy cv cA wcel vx cv cA wcel vy cv cA wcel wph wi vy cv
      vx cv wceq vy cv cA wcel vx cv cA wcel wb vy vy cv vx cv cA eleq1 a4s
      imbi1d dral2 mpbiri vy cv cA wcel vy cv cA wcel wph wi wi vy cv cA wcel
      wph wi vy vy cv cA wcel wph pm2.43 19.20i vy cv cA wcel wph wi vy wal vx
      cv cA wcel ax-1 3syl vy cv vx cv wceq vy wal wn vx cv cA wcel vx cv cA
      wcel vy wal vy cv cA wcel wph wi vy wal vz cv cA wcel vx cv cA wcel vy vx
      vz vz cv cA wcel vy ax-17 vz cv vx cv cA eleq1 dvelim vx cv cA wcel vy cv
      cA wcel wph wi vy vx cv cA wcel vy cv cA wcel wph rgen2a.1 ex 19.20i syl6
      pm2.61i wph vy cA df-ral sylibr rgen $.
      $( [23-Nov-1994] $)
  $}

  ${
    mprg.1 $e |- ( A. x e. A ph -> ps ) $.
    mprg.2 $e |- ( x e. A -> ph ) $.
    $( Modus ponens combined with restricted generalization. $)
    mprg $p |- ps $=
      wph vx cA wral wps wph vx cA mprg.2 rgen mprg.1 ax-mp $.
      $( [11-Aug-2004] $) $( [10-Aug-2004] $)
  $}

  ${
    mprgbir.1 $e |- ( ph <-> A. x e. A ps ) $.
    mprgbir.2 $e |- ( x e. A -> ps ) $.
    $( Modus ponens on biconditional combined with restricted
       generalization. $)
    mprgbir $p |- ph $=
      wph wps vx cA wral wps vx cA mprgbir.2 rgen mprgbir.1 mpbir $.
      $( [22-Mar-2004] $) $( [21-Mar-2004] $)
  $}

  $( Distribution of restricted quantification over implication. $)
  r19.20 $p |- ( A. x e. A ( ph -> ps ) ->
               ( A. x e. A ph -> A. x e. A ps ) ) $=
    wph wps wi vx cA wral vx cv cA wcel wph wi vx wal vx cv cA wcel wps wi vx
    wal wph vx cA wral wps vx cA wral wph wps wi vx cA wral vx cv cA wcel wph
    wps wi wi vx wal vx cv cA wcel wph wi vx wal vx cv cA wcel wps wi vx wal wi
    wph wps wi vx cA df-ral vx cv cA wcel wph wps wi wi vx cv cA wcel wph wi vx
    cv cA wcel wps wi vx vx cv cA wcel wph wps ax-2 19.20ii sylbi wph vx cA
    df-ral wps vx cA df-ral 3imtr4g $.
    $( [9-Feb-1997] $)

  ${
    r19.20i2.1 $e |- ( ( x e. A -> ph ) -> ( x e. B -> ps ) ) $.
    $( Inference quantifying both antecedent and consequent. $)
    r19.20i2 $p |- ( A. x e. A ph -> A. x e. B ps ) $=
      vx cv cA wcel wph wi vx wal vx cv cB wcel wps wi vx wal wph vx cA wral
      wps vx cB wral vx cv cA wcel wph wi vx cv cB wcel wps wi vx r19.20i2.1
      19.20i wph vx cA df-ral wps vx cB df-ral 3imtr4i $.
      $( [4-Mar-2004] $) $( [22-Feb-2004] $)
  $}

  ${
    r19.20i.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference quantifying both antecedent and consequent. $)
    r19.20i $p |- ( A. x e. A ph -> A. x e. A ps ) $=
      wph wps vx cA cA vx cv cA wcel wph wps r19.20i.1 a2i r19.20i2 $.
      $( [19-Jul-1996] $)
  $}

  ${
    r19.20ia.1 $e |- ( ( x e. A /\ ph ) -> ps ) $.
    $( Inference quantifying both antecedent and consequent. $)
    r19.20ia $p |- ( A. x e. A ph -> A. x e. A ps ) $=
      wph wps vx cA vx cv cA wcel wph wps r19.20ia.1 ex r19.20i $.
      $( [5-Aug-2007] $) $( [4-Aug-2007] $)
  $}

  ${
    r19.20si.1 $e |- ( ph -> ps ) $.
    $( Inference quantifying both antecedent and consequent, with strong
       hypothesis. $)
    r19.20si $p |- ( A. x e. A ph -> A. x e. A ps ) $=
      wph wps vx cA wph wps wi vx cv cA wcel r19.20si.1 a1i r19.20i $.
      $( [4-Mar-1997] $)
  $}

  ${
    r19.20sii.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference quantifying antecedent, nested antecedent, and consequent,
       with a strong hypothesis. $)
    r19.20sii $p |- ( A. x e. A ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      wph vx cA wral wps wch wi vx cA wral wps vx cA wral wch vx cA wral wi wph
      wps wch wi vx cA r19.20sii.1 r19.20si wps wch vx cA r19.20 syl $.
      $( [22-Dec-2006] $) $( [19-Dec-2006] $)
  $}

  ${
    r19.20da.1 $e |- ( ph -> A. x ph ) $.
    r19.20da.2 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.20 of [Margaris] p. 90. $)
    r19.20da $p |- ( ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      wph vx cv cA wcel wps wi vx wal vx cv cA wcel wch wi vx wal wps vx cA
      wral wch vx cA wral wph vx cv cA wcel wps wi vx cv cA wcel wch wi vx
      r19.20da.1 wph vx cv cA wcel wps wch wph vx cv cA wcel wps wch wi
      r19.20da.2 ex a2d 19.20d wps vx cA df-ral wch vx cA df-ral 3imtr4g $.
      $( [22-Sep-2003] $)
  $}

  ${
    $d x ph $.
    r19.20dva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.20 of [Margaris] p. 90. $)
    r19.20dva $p |- ( ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 r19.20dva.1 r19.20da $.
      $( [22-May-1999] $)
  $}

  ${
    $d x ph $.
    r19.20sdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.20 of [Margaris] p. 90. $)
    r19.20sdv $p |- ( ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      wph wps wch vx cA wph wps wch wi vx cv cA wcel r19.20sdv.1 adantr
      r19.20dva $.
      $( [8-Oct-2003] $) $( [8-Oct-2003] $)
  $}

  ${
    $d x ph $.
    r19.20dv2.1 $e |- ( ph -> ( ( x e. A -> ps ) -> ( x e. B -> ch ) ) ) $.
    $( Inference quantifying both antecedent and consequent. $)
    r19.20dv2 $p |- ( ph -> ( A. x e. A ps -> A. x e. B ch ) ) $=
      wph vx cv cA wcel wps wi vx wal vx cv cB wcel wch wi vx wal wps vx cA
      wral wch vx cB wral wph vx cv cA wcel wps wi vx cv cB wcel wch wi vx
      r19.20dv2.1 19.20dv wps vx cA df-ral wch vx cB df-ral 3imtr4g $.
      $( [1-Mar-2005] $) $( [1-Feb-2005] $)
  $}

  ${
    r19.21ai.1 $e |- ( ph -> A. x ph ) $.
    r19.21ai.2 $e |- ( ph -> ( x e. A -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21ai $p |- ( ph -> A. x e. A ps ) $=
      wph vx cv cA wcel wps wi vx wal wps vx cA wral wph vx cv cA wcel wps wi
      vx r19.21ai.1 r19.21ai.2 19.21ai wps vx cA df-ral sylibr $.
      $( [10-Oct-1999] $)
  $}

  ${
    $d x ph $.
    r19.21aiv.1 $e |- ( ph -> ( x e. A -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21aiv $p |- ( ph -> A. x e. A ps ) $=
      wph wps vx cA wph vx ax-17 r19.21aiv.1 r19.21ai $.
      $( [22-Nov-1994] $)
  $}

  ${
    $d x ph $.
    r19.21aiva.1 $e |- ( ( ph /\ x e. A ) -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21aiva $p |- ( ph -> A. x e. A ps ) $=
      wph wps vx cA wph vx cv cA wcel wps r19.21aiva.1 ex r19.21aiv $.
      $( [3-Jan-2006] $) $( [2-Jan-2006] $)
  $}

  ${
    $( Theorem 19.21 of [Margaris] p. 90 with restricted quantifiers (closed
       theorem version). $)
    r19.21t $p |- ( A. x ( ph -> A. x ph ) ->
             ( A. x e. A ( ph -> ps ) <-> ( ph -> A. x e. A ps ) ) ) $=
      wph wph vx wal wi vx wal vx cv cA wcel wph wps wi wi vx wal wph vx cv cA
      wcel wps wi vx wal wi wph wps wi vx cA wral wph wps vx cA wral wi wph wph
      vx wal wi vx wal wph vx cv cA wcel wps wi wi vx wal wph vx cv cA wcel wps
      wi vx wal wi vx cv cA wcel wph wps wi wi vx wal wph vx cv cA wcel wps wi
      vx 19.21t vx cv cA wcel wph wps wi wi wph vx cv cA wcel wps wi wi vx vx
      cv cA wcel wph wps bi2.04 albii syl5bb wph wps wi vx cA df-ral wps vx cA
      wral vx cv cA wcel wps wi vx wal wph wps vx cA df-ral imbi2i 3bitr4g $.
      $( [1-Mar-2008] $) $( [1-Mar-2008] $)
  $}

  ${
    $d x ph $.
    $( Theorem 19.21 of [Margaris] p. 90 with restricted quantifiers. $)
    r19.21v $p |- ( A. x e. A ( ph -> ps ) <-> ( ph -> A. x e. A ps ) ) $=
      wph wph vx wal wi vx wal wph wps wi vx cA wral wph wps vx cA wral wi wb
      wph wph vx wal wi vx wph vx ax-17 ax-gen wph wps vx cA r19.21t ax-mp $.
      $( [15-Oct-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    r19.21ad.1 $e |- ( ph -> A. x ph ) $.
    r19.21ad.2 $e |- ( ps -> A. x ps ) $.
    r19.21ad.3 $e |- ( ph -> ( ps -> ( x e. A -> ch ) ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21ad $p |- ( ph -> ( ps -> A. x e. A ch ) ) $=
      wph wps vx cv cA wcel wch wi vx wal wch vx cA wral wph wps vx cv cA wcel
      wch wi vx r19.21ad.1 r19.21ad.2 r19.21ad.3 19.21ad wch vx cA df-ral
      syl6ibr $.
      $( [16-Feb-2004] $) $( [16-Feb-2004] $)
  $}

  ${
    $d x ph $.  $d x ps $.
    r19.21adv.1 $e |- ( ph -> ( ps -> ( x e. A -> ch ) ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21adv $p |- ( ph -> ( ps -> A. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 wps vx ax-17 r19.21adv.1 r19.21ad $.
      $( [27-May-1998] $)
  $}

  ${
    $d x ph $.  $d x ps $.
    r19.21adva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21adva $p |- ( ph -> ( ps -> A. x e. A ch ) ) $=
      wph wps wch vx cA wph vx cv cA wcel wps wch wph vx cv cA wcel wps wch wi
      r19.21adva.1 ex com23 r19.21adv $.
      $( [3-Feb-2008] $) $( [2-Feb-2008] $)
  $}

  ${
    $d x y ph $.  $d y A $.
    r19.21aivv.1 $e |- ( ph -> ( ( x e. A /\ y e. B ) -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.) $)
    r19.21aivv $p |- ( ph -> A. x e. A A. y e. B ps ) $=
      wph wps vy cB wral vx cA wph vx cv cA wcel wps vy cB wph vx cv cA wcel vy
      cv cB wcel wps r19.21aivv.1 exp3a r19.21adv r19.21aiv $.
      $( [26-Jul-2004] $) $( [24-Jul-2004] $)
  $}

  ${
    $d x y ph $.  $d x y ps $.  $d y A $.
    r19.21advv.1 $e |- ( ph -> ( ps -> ( ( x e. A /\ y e. B ) -> ch ) ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.) $)
    r19.21advv $p |- ( ph -> ( ps -> A. x e. A A. y e. B ch ) ) $=
      wph wps wch vy cB wral vx cA wral wph wps wa wch vx vy cA cB wph wps vx
      cv cA wcel vy cv cB wcel wa wch wi r19.21advv.1 imp r19.21aivv ex $.
      $( [10-Jun-2005] $) $( [1-Jun-2005] $)
  $}

  ${
    $d x y ph $.  $d x y ps $.  $d y A $.
    r19.21advva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.) $)
    r19.21advva $p |- ( ph -> ( ps -> A. x e. A A. y e. B ch ) ) $=
      wph wps wch vx vy cA cB wph vx cv cA wcel vy cv cB wcel wa wps wch wph vx
      cv cA wcel vy cv cB wcel wa wps wch wi r19.21advva.1 ex com23 r19.21advv
      $.
      $( [8-Feb-2008] $) $( [2-Feb-2008] $)
  $}

  ${
    $d x y $.  $d y A $.
    rgen2.1 $e |- ( ( x e. A /\ y e. B ) -> ph ) $.
    $( Generalization rule for restricted quantification. $)
    rgen2 $p |- A. x e. A A. y e. B ph $=
      wph vy cB wral vx cA vx cv cA wcel wph vy cB rgen2.1 r19.21aiva rgen $.
      $( [30-May-1999] $)
  $}

  ${
    $d y z A $.  $d z B $.  $d x y z $.
    rgen3.1 $e |- ( ( x e. A /\ y e. B /\ z e. C ) -> ph ) $.
    $( Generalization rule for restricted quantification. $)
    rgen3 $p |- A. x e. A A. y e. B A. z e. C ph $=
      wph vz cC wral vx vy cA cB vx cv cA wcel vy cv cB wcel wa wph vz cC vx cv
      cA wcel vy cv cB wcel vz cv cC wcel wph rgen3.1 3expa r19.21aiva rgen2 $.
      $( [14-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    r19.21bi.1 $e |- ( ph -> A. x e. A ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21bi $p |- ( ( ph /\ x e. A ) -> ps ) $=
      wph vx cv cA wcel wps wph vx cv cA wcel wps wi vx wph wps vx cA wral vx
      cv cA wcel wps wi vx wal r19.21bi.1 wps vx cA df-ral sylib 19.21bi imp $.
      $( [20-Nov-1994] $)
  $}

  ${
    rspec2.1 $e |- A. x e. A A. y e. B ph $.
    $( Specialization rule for restricted quantification. $)
    rspec2 $p |- ( ( x e. A /\ y e. B ) -> ph ) $=
      vx cv cA wcel wph vy cB wph vy cB wral vx cA rspec2.1 rspec r19.21bi $.
      $( [20-Nov-1994] $)
  $}

  ${
    rspec3.1 $e |- A. x e. A A. y e. B A. z e. C ph $.
    $( Specialization rule for restricted quantification. $)
    rspec3 $p |- ( ( x e. A /\ y e. B /\ z e. C ) -> ph ) $=
      vx cv cA wcel vy cv cB wcel vz cv cC wcel wph vx cv cA wcel vy cv cB wcel
      wa wph vz cC wph vz cC wral vx vy cA cB rspec3.1 rspec2 r19.21bi 3impa $.
      $( [20-Nov-1994] $)
  $}

  ${
    r19.21be.1 $e |- ( ph -> A. x e. A ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.21be $p |- A. x e. A ( ph -> ps ) $=
      wph wps wi vx cA wph vx cv cA wcel wps wph wps vx cA r19.21be.1 r19.21bi
      expcom rgen $.
      $( [21-Nov-1994] $)
  $}

  ${
    nrex.1 $e |- ( x e. A -> -. ps ) $.
    $( Inference adding restricted existential quantifier to negated wff. $)
    nrex $p |- -. E. x e. A ps $=
      wps wn vx cA wral wps vx cA wrex wn wps wn vx cA nrex.1 rgen wps vx cA
      ralnex mpbi $.
      $( [21-Feb-2004] $) $( [16-Oct-2003] $)
  $}

  ${
    $d x ph $.
    nrexdv.1 $e |- ( ( ph /\ x e. A ) -> -. ps ) $.
    $( Deduction adding restricted existential quantifier to negated wff. $)
    nrexdv $p |- ( ph -> -. E. x e. A ps ) $=
      wph wps wn vx cA wral wps vx cA wrex wn wph wps wn vx cA nrexdv.1
      r19.21aiva wps vx cA ralnex sylib $.
      $( [9-Nov-2003] $) $( [16-Oct-2003] $)
  $}

  $( Theorem 19.22 of [Margaris] p. 90.  (Restricted quantifier version.) $)
  r19.22 $p |- ( A. x e. A ( ph -> ps ) ->
               ( E. x e. A ph -> E. x e. A ps ) ) $=
    vx cv cA wcel wph wps wi wi vx wal vx cv cA wcel wph wa vx wex vx cv cA
    wcel wps wa vx wex wi wph wps wi vx cA wral wph vx cA wrex wps vx cA wrex
    wi vx cv cA wcel wph wps wi wi vx wal vx cv cA wcel wph wa vx cv cA wcel
    wps wa wi vx wal vx cv cA wcel wph wa vx wex vx cv cA wcel wps wa vx wex wi
    vx cv cA wcel wph wps wi wi vx cv cA wcel wph wa vx cv cA wcel wps wa wi vx
    vx cv cA wcel wph wps imdistan albii vx cv cA wcel wph wa vx cv cA wcel wps
    wa vx 19.22 sylbi wph wps wi vx cA df-ral wph vx cA wrex vx cv cA wcel wph
    wa vx wex wps vx cA wrex vx cv cA wcel wps wa vx wex wph vx cA df-rex wps
    vx cA df-rex imbi12i 3imtr4i $.
    $( [22-Nov-1994] $)

  ${
    r19.22i.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference quantifying both antecedent and consequent. $)
    r19.22i $p |- ( E. x e. A ph -> E. x e. A ps ) $=
      wph wps wi wph vx cA wrex wps vx cA wrex wi vx cA wph wps vx cA r19.22
      r19.22i.1 mprg $.
      $( [10-Feb-1997] $)
  $}

  ${
    r19.22i2.1 $e |- ( ( x e. A /\ ph ) -> ( x e. B /\ ps ) ) $.
    $( Inference quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90. $)
    r19.22i2 $p |- ( E. x e. A ph -> E. x e. B ps ) $=
      vx cv cA wcel wph wa vx wex vx cv cB wcel wps wa vx wex wph vx cA wrex
      wps vx cB wrex vx cv cA wcel wph wa vx cv cB wcel wps wa vx r19.22i2.1
      19.22i wph vx cA df-rex wps vx cB df-rex 3imtr4i $.
      $( [12-Nov-2004] $) $( [8-Nov-2004] $)
  $}

  ${
    r19.22si.1 $e |- ( ph -> ps ) $.
    $( Inference quantifying both antecedent and consequent. $)
    r19.22si $p |- ( E. x e. A ph -> E. x e. A ps ) $=
      wph wps vx cA wph wps wi vx cv cA wcel r19.22si.1 a1i r19.22i $.
      $( [18-Oct-1996] $)
  $}

  ${
    r19.22d.1 $e |- ( ph -> A. x ph ) $.
    r19.22d.2 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.22d $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      wph wps wch wi vx cA wral wps vx cA wrex wch vx cA wrex wi wph wps wch wi
      vx cA r19.22d.1 r19.22d.2 r19.21ai wps wch vx cA r19.22 syl $.
      $( [31-Aug-1999] $)
  $}

  ${
    $d x ph $.
    r19.22dv2.1 $e |- ( ph -> ( ( x e. A /\ ps ) -> ( x e. B /\ ch ) ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90. $)
    r19.22dv2 $p |- ( ph -> ( E. x e. A ps -> E. x e. B ch ) ) $=
      wph vx cv cA wcel wps wa vx wex vx cv cB wcel wch wa vx wex wps vx cA
      wrex wch vx cB wrex wph vx cv cA wcel wps wa vx cv cB wcel wch wa vx
      r19.22dv2.1 19.22dv wps vx cA df-rex wch vx cB df-rex 3imtr4g $.
      $( [22-Feb-2004] $) $( [17-Sep-2003] $)
  $}

  ${
    $d x ph $.
    r19.22dv.1 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90. $)
    r19.22dv $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      wph wps wch vx cA wph vx ax-17 r19.22dv.1 r19.22d $.
      $( [14-Nov-2002] $)
  $}

  ${
    $d x ph $.
    r19.22sdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Restricted
       quantifier version with strong hypothesis.) $)
    r19.22sdv $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      wph wps wch vx cA wph wps wch wi vx cv cA wcel r19.22sdv.1 a1d r19.22dv
      $.
      $( [24-Jun-1998] $)
  $}

  ${
    $d x ph $.
    r19.22dva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90. $)
    r19.22dva $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      wph wps wch vx cA wph vx cv cA wcel wps wch wi r19.22dva.1 ex r19.22dv $.
      $( [22-May-1999] $)
  $}

  ${
    $d x y $.  $d y A $.  $d x B $.
    $( Theorem 19.12 of [Margaris] p. 89 with restricted quantifiers. $)
    r19.12 $p |- ( E. x e. A A. y e. B ph -> A. y e. B E. x e. A ph ) $=
      wph vy cB wral vx cA wrex wph vy cB wral vx cA wrex vy cB wral wph vx cA
      wrex vy cB wral wph vy cB wral vx cA wrex wph vy cB wral vx cA wrex vy cB
      wph vy cB wral vy vx cA vx cv cA wcel vy ax-17 wph vy cB hbra1 hbrex wph
      vy cB wral vx cA wrex vy cv cB wcel ax-1 r19.21ai wph vy cB wral vx cA
      wrex wph vx cA wrex vy cB vy cv cB wcel wph vy cB wral wph vx cA vy cv cB
      wcel wph vy cB wral wph wi vx cv cA wcel wph vy cB wral vy cv cB wcel wph
      wph vy cB ra4 com12 a1d r19.22dv r19.20i syl $.
      $( [15-Oct-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    r19.23.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.23 of [Margaris] p. 90 with restricted quantifiers. $)
    r19.23 $p |- ( A. x e. A ( ph -> ps ) <-> ( E. x e. A ph -> ps ) ) $=
      vx cv cA wcel wph wa wps wi vx wal vx cv cA wcel wph wps wi wi vx wal wph
      vx cA wrex wps wi wph wps wi vx cA wral vx cv cA wcel wph wa wps wi vx cv
      cA wcel wph wps wi wi vx vx cv cA wcel wph wps impexp albii wph vx cA
      wrex wps wi vx cv cA wcel wph wa vx wex wps wi vx cv cA wcel wph wa wps
      wi vx wal wph vx cA wrex vx cv cA wcel wph wa vx wex wps wph vx cA df-rex
      imbi1i vx cv cA wcel wph wa wps vx r19.23.1 19.23 bitr4i wph wps wi vx cA
      df-ral 3bitr4ri $.
      $( [23-Oct-2010] $) $( [22-Oct-2010] $)
  $}

  ${
    $d x ps $.
    $( Theorem 19.23 of [Margaris] p. 90 with restricted quantifiers. $)
    r19.23v $p |- ( A. x e. A ( ph -> ps ) <-> ( E. x e. A ph -> ps ) ) $=
      wph wps vx cA wps vx ax-17 r19.23 $.
      $( [31-Aug-1999] $)
  $}

  ${
    r19.23ai.1 $e |- ( ps -> A. x ps ) $.
    r19.23ai.2 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.23ai $p |- ( E. x e. A ph -> ps ) $=
      wph vx cA wrex vx cv cA wcel wph wa vx wex wps wph vx cA df-rex vx cv cA
      wcel wph wa wps vx r19.23ai.1 vx cv cA wcel wph wps r19.23ai.2 imp
      19.23ai sylbi $.
      $( [30-Nov-2003] $) $( [30-Nov-2003] $)
  $}

  ${
    $d x ps $.
    r19.23aiv.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.23aiv $p |- ( E. x e. A ph -> ps ) $=
      wph wps vx cA wps vx ax-17 r19.23aiv.1 r19.23ai $.
      $( [20-Nov-1994] $)
  $}

  ${
    $d x ps $.
    r19.23aiva.1 $e |- ( ( x e. A /\ ph ) -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version). $)
    r19.23aiva $p |- ( E. x e. A ph -> ps ) $=
      wph wps vx cA vx cv cA wcel wph wps r19.23aiva.1 ex r19.23aiv $.
      $( [20-Dec-2006] $) $( [18-Dec-2006] $)
  $}

  ${
    r19.23ad.1 $e |- ( ph -> A. x ph ) $.
    r19.23ad.2 $e |- ( ch -> A. x ch ) $.
    r19.23ad.3 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version). $)
    r19.23ad $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      wph vx cv cA wcel wps wa vx wex wch wps vx cA wrex wph vx cv cA wcel wps
      wa wch vx r19.23ad.1 r19.23ad.2 wph vx cv cA wcel wps wch r19.23ad.3
      imp3a 19.23ad wps vx cA df-rex syl5ib $.
      $( [27-May-1998] $)
  $}

  ${
    $d x ph $.  $d x ch $.
    r19.23adv.1 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (The proof was shortened by Eric Schmidt, 22-Dec-2006.) $)
    r19.23adv $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      wph wps wch vx cA wph vx ax-17 wch vx ax-17 r19.23adv.1 r19.23ad $.
      $( [22-Dec-2006] $) $( [14-Nov-2002] $)
  $}

  ${
    $d x ph $.  $d x ch $.
    r19.23adva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version). $)
    r19.23adva $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      wph wps wch vx cA wph vx cv cA wcel wps wch wi r19.23adva.1 ex r19.23adv
      $.
      $( [21-Jan-2007] $) $( [20-Jan-2007] $)
  $}

  ${
    $d x y ps $.  $d y A $.
    r19.23aivv.1 $e |- ( ( x e. A /\ y e. B ) -> ( ph -> ps ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version). $)
    r19.23aivv $p |- ( E. x e. A E. y e. B ph -> ps ) $=
      wph vy cB wrex wps vx cA vx cv cA wcel wph wps vy cB r19.23aivv.1
      r19.23adva r19.23aiv $.
      $( [17-Feb-2004] $) $( [17-Feb-2004] $)
  $}

  ${
    $d x y ph $.  $d x y ch $.  $d y A $.
    r19.23advv.1 $e |- ( ph -> ( ( x e. A /\ y e. B ) -> ( ps -> ch ) ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Restricted
       quantifier version.) $)
    r19.23advv $p |- ( ph -> ( E. x e. A E. y e. B ps -> ch ) ) $=
      wph wps vy cB wrex wch vx cA wph vx cv cA wcel wa wps wch vy cB wph vx cv
      cA wcel vy cv cB wcel wps wch wi r19.23advv.1 expdimp r19.23adv
      r19.23adva $.
      $( [5-Aug-2004] $) $( [22-Jul-2004] $)
  $}

  $( Theorem 19.26 of [Margaris] p. 90 with restricted quantifiers. $)
  r19.26 $p |- ( A. x e. A ( ph /\ ps ) <->
               ( A. x e. A ph /\ A. x e. A ps ) ) $=
    vx cv cA wcel wph wps wa wi vx wal vx cv cA wcel wph wi vx wal vx cv cA
    wcel wps wi vx wal wa wph wps wa vx cA wral wph vx cA wral wps vx cA wral
    wa vx cv cA wcel wph wps wa wi vx wal vx cv cA wcel wph wi vx cv cA wcel
    wps wi wa vx wal vx cv cA wcel wph wi vx wal vx cv cA wcel wps wi vx wal wa
    vx cv cA wcel wph wps wa wi vx cv cA wcel wph wi vx cv cA wcel wps wi wa vx
    vx cv cA wcel wph wps jcab albii vx cv cA wcel wph wi vx cv cA wcel wps wi
    vx 19.26 bitri wph wps wa vx cA df-ral wph vx cA wral vx cv cA wcel wph wi
    vx wal wps vx cA wral vx cv cA wcel wps wi vx wal wph vx cA df-ral wps vx
    cA df-ral anbi12i 3bitr4i $.
    $( [28-Jan-1997] $)

  $( Theorem 19.26 of [Margaris] p. 90 with 2 restricted quantifiers. $)
  r19.26-2 $p |- ( A. x e. A A. y e. B ( ph /\ ps ) <->
               ( A. x e. A A. y e. B ph /\ A. x e. A A. y e. B ps ) ) $=
    wph wps wa vy cB wral vx cA wral wph vy cB wral wps vy cB wral wa vx cA
    wral wph vy cB wral vx cA wral wps vy cB wral vx cA wral wa wph wps wa vy
    cB wral wph vy cB wral wps vy cB wral wa vx cA wph wps vy cB r19.26 ralbii
    wph vy cB wral wps vy cB wral vx cA r19.26 bitri $.
    $( [25-Aug-2004] $) $( [10-Aug-2004] $)

  $( Theorem 19.26 of [Margaris] p. 90 with mixed quantifiers. $)
  r19.26m $p |- ( A. x ( ( x e. A -> ph ) /\ ( x e. B -> ps ) ) <->
               ( A. x e. A ph /\ A. x e. B ps ) ) $=
    vx cv cA wcel wph wi vx cv cB wcel wps wi wa vx wal vx cv cA wcel wph wi vx
    wal vx cv cB wcel wps wi vx wal wa wph vx cA wral wps vx cB wral wa vx cv
    cA wcel wph wi vx cv cB wcel wps wi vx 19.26 wph vx cA wral vx cv cA wcel
    wph wi vx wal wps vx cB wral vx cv cB wcel wps wi vx wal wph vx cA df-ral
    wps vx cB df-ral anbi12i bitr4i $.
    $( [22-Feb-2004] $) $( [22-Feb-2004] $)

  $( Distribute a restricted universal quantifier over a biconditional.
     Theorem 19.15 of [Margaris] p. 90 with restricted quantification. $)
  r19.15 $p |- ( A. x e. A ( ph <-> ps ) ->
               ( A. x e. A ph <-> A. x e. A ps ) ) $=
    wph wps wb vx cA wral wph wps vx cA wph wps wb vx cA hbra1 wph wps wb vx cA
    wral vx cv cA wcel wph wps wb wph wps wb vx cA ra4 imp ralbida $.
    $( [6-Oct-2003] $) $( [6-Oct-2003] $)

  ${
    $d x ps $.
    $( Restricted version of one direction of Theorem 19.27 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.) $)
    r19.27av $p |- ( ( A. x e. A ph /\ ps ) -> A. x e. A ( ph /\ ps ) ) $=
      vx cv cA wcel wph wi wps wa vx wal vx cv cA wcel wph wps wa wi vx wal wph
      vx cA wral wps wa wph wps wa vx cA wral vx cv cA wcel wph wi wps wa vx cv
      cA wcel wph wps wa wi vx vx cv cA wcel vx cv cA wcel wph wi wps wa wph
      wps wa vx cv cA wcel vx cv cA wcel wph wi wph wps vx cv cA wcel wph
      pm2.27 anim1d com12 19.20i wph vx cA wral wps wa vx cv cA wcel wph wi vx
      wal wps wa vx cv cA wcel wph wi wps wa vx wal wph vx cA wral vx cv cA
      wcel wph wi vx wal wps wph vx cA df-ral anbi1i vx cv cA wcel wph wi wps
      vx 19.27v bitr4i wph wps wa vx cA df-ral 3imtr4i $.
      $( [4-Jun-2004] $) $( [3-Jun-2004] $)
  $}

  ${
    $d x ph $.
    $( Restricted version of one direction of Theorem 19.28 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.) $)
    r19.28av $p |- ( ( ph /\ A. x e. A ps ) -> A. x e. A ( ph /\ ps ) ) $=
      wps vx cA wral wph wa wps wph wa vx cA wral wph wps vx cA wral wa wph wps
      wa vx cA wral wps wph vx cA r19.27av wph wps vx cA wral ancom wph wps wa
      wps wph wa vx cA wph wps ancom ralbii 3imtr4i $.
      $( [2-Apr-2004] $) $( [2-Apr-2004] $)
  $}

  $( Theorem 19.29 of [Margaris] p. 90 with restricted quantifiers. $)
  r19.29 $p |- ( ( A. x e. A ph /\ E. x e. A ps ) ->
               E. x e. A ( ph /\ ps ) ) $=
    vx cv cA wcel wph wi vx wal vx cv cA wcel wps wa vx wex wa vx cv cA wcel
    wph wps wa wa vx wex wph vx cA wral wps vx cA wrex wa wph wps wa vx cA wrex
    vx cv cA wcel wph wi vx wal vx cv cA wcel wps wa vx wex wa vx cv cA wcel
    wph wi vx cv cA wcel wps wa wa vx wex vx cv cA wcel wph wps wa wa vx wex vx
    cv cA wcel wph wi vx cv cA wcel wps wa vx 19.29 vx cv cA wcel wph wps wa wa
    vx cv cA wcel wph wi vx cv cA wcel wps wa wa vx vx cv cA wcel wph wps wa wa
    vx cv cA wcel wph wa vx cv cA wcel wps wa wa vx cv cA wcel vx cv cA wcel
    wph wi wps wa wa vx cv cA wcel wph wi vx cv cA wcel wps wa wa vx cv cA wcel
    wph wps anandi vx cv cA wcel wph wa vx cv cA wcel wps wa wa vx cv cA wcel
    vx cv cA wcel wph wi wa vx cv cA wcel wps wa wa vx cv cA wcel vx cv cA wcel
    wph wi wps wa wa vx cv cA wcel wph wa vx cv cA wcel vx cv cA wcel wph wi wa
    vx cv cA wcel wps wa vx cv cA wcel wph abai anbi1i vx cv cA wcel vx cv cA
    wcel wph wi wps anandi bitr4i vx cv cA wcel vx cv cA wcel wph wi wps an12
    3bitri exbii sylibr wph vx cA wral vx cv cA wcel wph wi vx wal wps vx cA
    wrex vx cv cA wcel wps wa vx wex wph vx cA df-ral wps vx cA df-rex anbi12i
    wph wps wa vx cA df-rex 3imtr4i $.
    $( [31-Aug-1999] $)

  $( Variation of Theorem 19.29 of [Margaris] p. 90 with restricted
     quantifiers. $)
  r19.29r $p |- ( ( E. x e. A ph /\ A. x e. A ps ) ->
                E. x e. A ( ph /\ ps ) ) $=
    wps vx cA wral wph vx cA wrex wa wps wph wa vx cA wrex wph vx cA wrex wps
    vx cA wral wa wph wps wa vx cA wrex wps wph vx cA r19.29 wph vx cA wrex wps
    vx cA wral ancom wph wps wa wps wph wa vx cA wph wps ancom rexbii 3imtr4i
    $.
    $( [31-Aug-1999] $)

  ${
    $d x ph $.
    $( Theorem 19.32 of [Margaris] p. 90 with restricted quantifiers. $)
    r19.32v $p |- ( A. x e. A ( ph \/ ps ) <-> ( ph \/ A. x e. A ps ) ) $=
      wph wn wps wi vx cA wral wph wn wps vx cA wral wi wph wps wo vx cA wral
      wph wps vx cA wral wo wph wn wps vx cA r19.21v wph wps wo wph wn wps wi
      vx cA wph wps df-or ralbii wph wps vx cA wral df-or 3bitr4i $.
      $( [25-Nov-2003] $) $( [25-Nov-2003] $)
  $}

  $( Restricted quantifier version of Theorem 19.35 of [Margaris] p. 90. $)
  r19.35 $p |- ( E. x e. A ( ph -> ps ) <->
               ( A. x e. A ph -> E. x e. A ps ) ) $=
    wph vx cA wral wps wn vx cA wral wn wi wph wps wi wn vx cA wral wn wph vx
    cA wral wps vx cA wrex wi wph wps wi vx cA wrex wph wps wi wn vx cA wral
    wph vx cA wral wps wn vx cA wral wn wi wph wps wn wa vx cA wral wph vx cA
    wral wps wn vx cA wral wa wph wps wi wn vx cA wral wph vx cA wral wps wn vx
    cA wral wn wi wn wph wps wn vx cA r19.26 wph wps wn wa wph wps wi wn vx cA
    wph wps annim ralbii wph vx cA wral wps wn vx cA wral df-an 3bitr3i con2bii
    wps vx cA wrex wps wn vx cA wral wn wph vx cA wral wps vx cA dfrex2 imbi2i
    wph wps wi vx cA dfrex2 3bitr4ri $.
    $( [20-Sep-2003] $)

  ${
    $d x ps $.
    $( One direction of a restricted quantifier version of Theorem 19.36 of
       [Margaris] p. 90.  The other direction doesn't hold when ` A ` is
       empty. $)
    r19.36av $p |- ( E. x e. A ( ph -> ps ) -> ( A. x e. A ph -> ps ) ) $=
      wph wps wi vx cA wrex wph vx cA wral wps vx cA wrex wi wph vx cA wral wps
      wi wph wps vx cA r19.35 wps vx cA wrex wps wph vx cA wral wps wps vx cA
      vx cv cA wcel wps idd r19.23aiv imim2i sylbi $.
      $( [24-Oct-2003] $) $( [22-Oct-2003] $)
  $}

  ${
    $d x ph $.
    $( Restricted version of one direction of Theorem 19.37 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.) $)
    r19.37av $p |- ( E. x e. A ( ph -> ps ) -> ( ph -> E. x e. A ps ) ) $=
      wph wps wi vx cA wrex wph vx cA wral wps vx cA wrex wi wph wps vx cA wrex
      wi wph wps vx cA r19.35 wph wph vx cA wral wps vx cA wrex wph wph vx cA
      wph vx cv cA wcel ax-1 r19.21aiv imim1i sylbi $.
      $( [2-Apr-2004] $) $( [2-Apr-2004] $)
  $}

  $( Restricted quantifier version of Theorem 19.40 of [Margaris] p. 90. $)
  r19.40 $p |- ( E. x e. A ( ph /\ ps ) ->
               ( E. x e. A ph /\ E. x e. A ps ) ) $=
    wph wps wa vx cA wrex wph vx cA wrex wps vx cA wrex wph wps wa wph vx cA
    wph wps pm3.26 r19.22si wph wps wa wps vx cA wph wps pm3.27 r19.22si jca $.
    $( [2-Apr-2004] $) $( [2-Apr-2004] $)

  ${
    r19.41.1 $e |- ( ps -> A. x ps ) $.
    $( Restricted quantifier version of Theorem 19.41 of [Margaris] p. 90. $)
    r19.41 $p |- ( E. x e. A ( ph /\ ps ) <-> ( E. x e. A ph /\ ps ) ) $=
      vx cv cA wcel wph wps wa wa vx wex vx cv cA wcel wph wa vx wex wps wa wph
      wps wa vx cA wrex wph vx cA wrex wps wa vx cv cA wcel wph wps wa wa vx
      wex vx cv cA wcel wph wa wps wa vx wex vx cv cA wcel wph wa vx wex wps wa
      vx cv cA wcel wph wa wps wa vx cv cA wcel wph wps wa wa vx vx cv cA wcel
      wph wps anass exbii vx cv cA wcel wph wa wps vx r19.41.1 19.41 bitr3i wph
      wps wa vx cA df-rex wph vx cA wrex vx cv cA wcel wph wa vx wex wps wph vx
      cA df-rex anbi1i 3bitr4i $.
      $( [7-Nov-2010] $) $( [1-Nov-2010] $)
  $}

  ${
    $d x ps $.
    $( Restricted quantifier version of Theorem 19.41 of [Margaris] p. 90. $)
    r19.41v $p |- ( E. x e. A ( ph /\ ps ) <-> ( E. x e. A ph /\ ps ) ) $=
      wph wps vx cA wps vx ax-17 r19.41 $.
      $( [17-Dec-2003] $) $( [17-Dec-2003] $)
  $}

  ${
    $d x ph $.
    $( Restricted version of Theorem 19.42 of [Margaris] p. 90. $)
    r19.42v $p |- ( E. x e. A ( ph /\ ps ) <-> ( ph /\ E. x e. A ps ) ) $=
      wps wph wa vx cA wrex wps vx cA wrex wph wa wph wps wa vx cA wrex wph wps
      vx cA wrex wa wps wph vx cA r19.41v wph wps wa wps wph wa vx cA wph wps
      ancom rexbii wph wps vx cA wrex ancom 3bitr4i $.
      $( [27-May-1998] $)
  $}

  $( Restricted version of Theorem 19.43 of [Margaris] p. 90. $)
  r19.43 $p |- ( E. x e. A ( ph \/ ps ) <->
               ( E. x e. A ph \/ E. x e. A ps ) ) $=
    vx cv cA wcel wph wps wo wa vx wex vx cv cA wcel wph wa vx wex vx cv cA
    wcel wps wa vx wex wo wph wps wo vx cA wrex wph vx cA wrex wps vx cA wrex
    wo vx cv cA wcel wph wps wo wa vx wex vx cv cA wcel wph wa vx cv cA wcel
    wps wa wo vx wex vx cv cA wcel wph wa vx wex vx cv cA wcel wps wa vx wex wo
    vx cv cA wcel wph wps wo wa vx cv cA wcel wph wa vx cv cA wcel wps wa wo vx
    vx cv cA wcel wph wps andi exbii vx cv cA wcel wph wa vx cv cA wcel wps wa
    vx 19.43 bitri wph wps wo vx cA df-rex wph vx cA wrex vx cv cA wcel wph wa
    vx wex wps vx cA wrex vx cv cA wcel wps wa vx wex wph vx cA df-rex wps vx
    cA df-rex orbi12i 3bitr4i $.
    $( [27-May-1998] $)

  ${
    $d x ps $.
    $( One direction of a restricted quantifier version of Theorem 19.44 of
       [Margaris] p. 90.  The other direction doesn't hold when ` A ` is
       empty. $)
    r19.44av $p |- ( E. x e. A ( ph \/ ps ) -> ( E. x e. A ph \/ ps ) ) $=
      wph wps wo vx cA wrex wph vx cA wrex wps vx cA wrex wo wph vx cA wrex wps
      wo wph wps vx cA r19.43 wps vx cA wrex wps wph vx cA wrex wps wps vx cA
      vx cv cA wcel wps idd r19.23aiv orim2i sylbi $.
      $( [3-Apr-2004] $) $( [2-Apr-2004] $)
  $}

  ${
    $d x ph $.
    $( Restricted version of one direction of Theorem 19.45 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.) $)
    r19.45av $p |- ( E. x e. A ( ph \/ ps ) -> ( ph \/ E. x e. A ps ) ) $=
      wph wps wo vx cA wrex wph vx cA wrex wps vx cA wrex wo wph wps vx cA wrex
      wo wph wps vx cA r19.43 wph vx cA wrex wph wps vx cA wrex wph wph vx cA
      vx cv cA wcel wph idd r19.23aiv orim1i sylbi $.
      $( [3-Apr-2004] $) $( [2-Apr-2004] $)
  $}

  ${
    hbreu.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbreu.2 $e |- ( ph -> A. x ph ) $.
  $}

  $( ` x ` is not free in ` E! x e. A ph ` . $)
  hbreu1 $p |- ( E! x e. A ph -> A. x E! x e. A ph ) $=
    vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx weu vx wal wph vx cA
    wreu wph vx cA wreu vx wal vx cv cA wcel wph wa vx hbeu1 wph vx cA df-reu
    wph vx cA wreu vx cv cA wcel wph wa vx weu vx wph vx cA df-reu albii
    3imtr4i $.
    $( [19-Mar-1997] $)

  $( An "identity" law of concretion for restricted abstraction.  Special case
     of Definition 2.1 of [Quine] p. 16. $)
  rabid $p |- ( x e. { x e. A | ph } <-> ( x e. A /\ ph ) ) $=
    vx cv cA wcel wph wa vx wph vx cA crab wph vx cA df-rab abeq2i $.
    $( [3-Feb-2004] $) $( [9-Oct-2003] $)

  ${
    $d x A $.
    $( An "identity" law for restricted class abstraction. $)
    rabid2 $p |- ( A = { x e. A | ph } <-> A. x e. A ph ) $=
      vx cv cA wcel wph wi vx wal cA vx cv cA wcel wph wa vx cab wceq wph vx cA
      wral cA wph vx cA crab wceq vx cv cA wcel wph wi vx wal vx cv cA wcel vx
      cv cA wcel wph wa wb vx wal cA vx cv cA wcel wph wa vx cab wceq vx cv cA
      wcel wph wi vx cv cA wcel vx cv cA wcel wph wa wb vx vx cv cA wcel wph
      pm4.71 albii vx cv cA wcel wph wa vx cA abeq2 bitr4i wph vx cA df-ral wph
      vx cA crab vx cv cA wcel wph wa vx cab cA wph vx cA df-rab eqeq2i
      3bitr4ri $.
      $( [10-Jan-2004] $) $( [9-Oct-2003] $)
  $}

  $( Swap with a membership relation in a restricted class abstraction. $)
  rabswap $p |- { x e. A | x e. B } = { x e. B | x e. A } $=
    vx cv cA wcel vx cv cB wcel wa vx cab vx cv cB wcel vx cv cA wcel wa vx cab
    vx cv cB wcel vx cA crab vx cv cA wcel vx cB crab vx cv cA wcel vx cv cB
    wcel wa vx cv cB wcel vx cv cA wcel wa vx vx cv cA wcel vx cv cB wcel ancom
    abbii vx cv cB wcel vx cA df-rab vx cv cA wcel vx cB df-rab 3eqtr4i $.
    $( [5-Jul-2005] $) $( [4-Jul-2005] $)

  ${
    $d x y $.
    $( The abstraction variable in a restricted class abstraction isn't
       free. $)
    hbrab1 $p |- ( y e. { x e. A | ph } -> A. x y e. { x e. A | ph } ) $=
      vx vy wph vx cA crab vx cv cA wcel wph wa vx cab wph vx cA df-rab vx cv
      cA wcel wph wa vx vy hbab1 hbxfr $.
      $( [19-Mar-1997] $)
  $}

  ${
    $d x y z $.  $d z A $.
    hbrab.1 $e |- ( ph -> A. x ph ) $.
    hbrab.2 $e |- ( z e. A -> A. x z e. A ) $.
    $( A variable not free in a wff remains so in a restricted class
       abstraction. $)
    hbrab $p |- ( z e. { y e. A | ph } -> A. x z e. { y e. A | ph } ) $=
      vx vz wph vy cA crab vy cv cA wcel wph wa vy cab wph vy cA df-rab vy cv
      cA wcel wph wa vx vy vz vy cv cA wcel wph vx vx vz vz vy cv cA vz cv vy
      cv wcel vx ax-17 hbrab.2 hbel hbrab.1 hban hbab hbxfr $.
      $( [15-Oct-2003] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y $.  $d x B $.  $d y A $.
    $( Commutation of restricted quantifiers. $)
    ralcom $p |- ( A. x e. A A. y e. B ph <-> A. y e. B A. x e. A ph ) $=
      vx cv cA wcel vy cv cB wcel wa wph wi vy wal vx wal vy cv cB wcel vx cv
      cA wcel wa wph wi vx wal vy wal wph vy cB wral vx cA wral wph vx cA wral
      vy cB wral vx cv cA wcel vy cv cB wcel wa wph wi vy wal vx wal vy cv cB
      wcel vx cv cA wcel wa wph wi vy wal vx wal vy cv cB wcel vx cv cA wcel wa
      wph wi vx wal vy wal vx cv cA wcel vy cv cB wcel wa wph wi vy cv cB wcel
      vx cv cA wcel wa wph wi vx vy vx cv cA wcel vy cv cB wcel wa vy cv cB
      wcel vx cv cA wcel wa wph vx cv cA wcel vy cv cB wcel ancom imbi1i 2albii
      vy cv cB wcel vx cv cA wcel wa wph wi vx vy alcom bitri wph vx vy cA cB
      r2al wph vy vx cB cA r2al 3bitr4i $.
      $( [13-Oct-1999] $)
  $}

  ${
    $d x y $.  $d x B $.  $d y A $.
    $( Commutation of restricted quantifiers. $)
    rexcom $p |- ( E. x e. A E. y e. B ph <-> E. y e. B E. x e. A ph ) $=
      vx cv cA wcel vy cv cB wcel wa wph wa vy wex vx wex vy cv cB wcel vx cv
      cA wcel wa wph wa vx wex vy wex wph vy cB wrex vx cA wrex wph vx cA wrex
      vy cB wrex vx cv cA wcel vy cv cB wcel wa wph wa vy wex vx wex vy cv cB
      wcel vx cv cA wcel wa wph wa vy wex vx wex vy cv cB wcel vx cv cA wcel wa
      wph wa vx wex vy wex vx cv cA wcel vy cv cB wcel wa wph wa vy cv cB wcel
      vx cv cA wcel wa wph wa vx vy vx cv cA wcel vy cv cB wcel wa vy cv cB
      wcel vx cv cA wcel wa wph vx cv cA wcel vy cv cB wcel ancom anbi1i 2exbii
      vy cv cB wcel vx cv cA wcel wa wph wa vx vy excom bitri wph vx vy cA cB
      r2ex wph vy vx cB cA r2ex 3bitr4i $.
      $( [19-Nov-1995] $)
  $}

  ${
    $d y z A $.  $d x z A $.
    $( Commutation of restricted quantifiers.  Note that ` x ` and ` y `
       needn't be distinct (this makes the proof longer but illustrates
       the use of ~ dvelim ). $)
    ralcom2 $p |- ( A. x e. A A. y e. A ph -> A. y e. A A. x e. A ph ) $=
      vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx wal vy cv cA wcel vx cv
      cA wcel wph wi vx wal wi vy wal wph vy cA wral vx cA wral wph vx cA wral
      vy cA wral vx cv vy cv wceq vx wal vx cv cA wcel vy cv cA wcel wph wi vy
      wal wi vx wal vy cv cA wcel vx cv cA wcel wph wi vx wal wi vy wal wi vx
      cv vy cv wceq vx wal vx cv cA wcel vx cv cA wcel wph wi vx wal wi vx wal
      vx cv cA wcel vx cv cA wcel wph wi vx wal wi vx wal wi vx cv cA wcel vy
      cv cA wcel wph wi vy wal wi vx wal vy cv cA wcel vx cv cA wcel wph wi vx
      wal wi vy wal wi vx cv cA wcel vx cv cA wcel wph wi vx wal wi vx wal id
      vx cv vy cv wceq vx wal vx cv cA wcel vx cv cA wcel wph wi vx wal wi vx
      wal vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx wal vx cv cA wcel vx
      cv cA wcel wph wi vx wal wi vx wal vy cv cA wcel vx cv cA wcel wph wi vx
      wal wi vy wal vx cv cA wcel vx cv cA wcel wph wi vx wal wi vx cv cA wcel
      vy cv cA wcel wph wi vy wal wi vx vy vx vx cv vy cv wceq vx wal vx cv cA
      wcel wph wi vx wal vy cv cA wcel wph wi vy wal vx cv cA wcel vx cv cA
      wcel wph wi vy cv cA wcel wph wi vx vy vx cv vy cv wceq vx wal vx cv cA
      wcel vy cv cA wcel wph vx cv vy cv wceq vx cv cA wcel vy cv cA wcel wb vx
      vx cv vy cv cA eleq1 a4s imbi1d dral1 imbi2d dral2 vx cv cA wcel vx cv cA
      wcel wph wi vx wal wi vy cv cA wcel vx cv cA wcel wph wi vx wal wi vx vy
      vx cv vy cv wceq vx wal vx cv cA wcel vy cv cA wcel vx cv cA wcel wph wi
      vx wal vx cv vy cv wceq vx cv cA wcel vy cv cA wcel wb vx vx cv vy cv cA
      eleq1 a4s imbi1d dral1 imbi12d mpbii vx cv cA wcel vy cv cA wcel wph wi
      vy wal wi vx wal vy cv cA wcel vx cv cA wcel wph wi vx wal wi vy wal wi
      vx vy vy vx cv vy cv wceq vx wal wn vy wal vx cv cA wcel vy cv cA wcel
      wph wi vy wal wi vx wal vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx
      wal vy wal vy cv cA wcel vx cv cA wcel wph wi vx wal wi vy wal vx cv vy
      cv wceq vx wal wn vy wal vx cv cA wcel vy cv cA wcel wph wi vy wal wi vy
      vx vx cv vy cv wceq vx wal wn vx vy vx vy vx hbnae hbal vx cv vy cv wceq
      vx wal wn vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx cv cA wcel vy
      cv cA wcel wph wi vy wal wi vy wal wi vy vx cv vy cv wceq vx wal wn vx cv
      cA wcel vy cv cA wcel wph wi vy wal vy vx vy vy hbnae vx cv cA wcel vx cv
      cA wcel vy wal wi vy vx vz cv cA wcel vx cv cA wcel vy vx vz vz cv cA
      wcel vy ax-17 vz cv vx cv cA eleq1 dvelim nalequcoms vy cv cA wcel wph wi
      vy wal vy cv cA wcel wph wi vy wal vy wal wi vx cv vy cv wceq vx wal wn
      vy cv cA wcel wph wi vy hba1 a1i hbimd a4s hbald vx cv vy cv wceq vx wal
      wn vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx wal vy cv cA wcel vx
      cv cA wcel wph wi vx wal wi vy vx cv vy cv wceq vx wal wn vy cv cA wcel
      vy cv cA wcel vx wal vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx wal
      vx cv cA wcel wph wi vx wal vz cv cA wcel vy cv cA wcel vx vy vz vz cv cA
      wcel vx ax-17 vz cv vy cv cA eleq1 dvelim vx cv cA wcel vy cv cA wcel wph
      wi vy wal wi vy cv cA wcel vx cv cA wcel wph wi vx vx cv cA wcel vy cv cA
      wcel wph wi vy wal wi vx cv cA wcel vy cv cA wcel wph vy cv cA wcel wph
      wi vy wal vy cv cA wcel wph wi vx cv cA wcel vy cv cA wcel wph wi vy ax-4
      imim2i com23 19.20ii syl9 19.20ii syld hbnaes pm2.61i wph vy cA wral vx
      cA wral vx cv cA wcel wph vy cA wral wi vx wal vx cv cA wcel vy cv cA
      wcel wph wi vy wal wi vx wal wph vy cA wral vx cA df-ral vx cv cA wcel
      wph vy cA wral wi vx cv cA wcel vy cv cA wcel wph wi vy wal wi vx wph vy
      cA wral vy cv cA wcel wph wi vy wal vx cv cA wcel wph vy cA df-ral imbi2i
      albii bitri wph vx cA wral vy cA wral vy cv cA wcel wph vx cA wral wi vy
      wal vy cv cA wcel vx cv cA wcel wph wi vx wal wi vy wal wph vx cA wral vy
      cA df-ral vy cv cA wcel wph vx cA wral wi vy cv cA wcel vx cv cA wcel wph
      wi vx wal wi vy wph vx cA wral vx cv cA wcel wph wi vx wal vy cv cA wcel
      wph vx cA df-ral imbi2i albii bitri 3imtr4i $.
      $( [24-Nov-1994] $)
  $}

  ${
    $( A commutative law for restricted quantifiers that swaps the domain
       of the restriction. $)
    ralcom3 $p |- ( A. x e. A ( x e. B -> ph ) <->
                    A. x e. B ( x e. A -> ph ) ) $=
      vx cv cB wcel wph wi vx cA wral vx cv cA wcel wph wi vx cB wral vx cv cB
      wcel wph wi vx cv cA wcel wph wi vx cA cB vx cv cA wcel vx cv cB wcel wph
      pm2.04 r19.20i2 vx cv cA wcel wph wi vx cv cB wcel wph wi vx cB cA vx cv
      cB wcel vx cv cA wcel wph pm2.04 r19.20i2 impbii $.
      $( [22-Feb-2004] $) $( [22-Feb-2004] $)
  $}

  ${
    $d y A $.  $d x B $.  $d x y $.
    reean.1 $e |- ( ph -> A. y ph ) $.
    reean.2 $e |- ( ps -> A. x ps ) $.
    $( Rearrange existential quantifiers. $)
    reean $p |- ( E. x e. A E. y e. B ( ph /\ ps ) <->
                 ( E. x e. A ph /\ E. y e. B ps ) ) $=
      vx cv cA wcel vy cv cB wcel wph wps wa wa vy wex wa vx wex vx cv cA wcel
      wph wa vx wex vy cv cB wcel wps wa vy wex wa wph wps wa vy cB wrex vx cA
      wrex wph vx cA wrex wps vy cB wrex wa vx cv cA wcel vy cv cB wcel wph wps
      wa wa wa vy wex vx wex vx cv cA wcel wph wa vy cv cB wcel wps wa wa vy
      wex vx wex vx cv cA wcel vy cv cB wcel wph wps wa wa vy wex wa vx wex vx
      cv cA wcel wph wa vx wex vy cv cB wcel wps wa vy wex wa vx cv cA wcel vy
      cv cB wcel wph wps wa wa wa vx cv cA wcel wph wa vy cv cB wcel wps wa wa
      vx vy vx cv cA wcel vy cv cB wcel wph wps wa wa wa vx cv cA wcel vy cv cB
      wcel wa wph wps wa wa vx cv cA wcel wph wa vy cv cB wcel wps wa wa vx cv
      cA wcel vy cv cB wcel wph wps wa anass vx cv cA wcel vy cv cB wcel wph
      wps an4 bitr3i 2exbii vx cv cA wcel vy cv cB wcel wph wps wa wa wa vy wex
      vx cv cA wcel vy cv cB wcel wph wps wa wa vy wex wa vx vx cv cA wcel vy
      cv cB wcel wph wps wa wa vy vx cv cA wcel vy ax-17 19.42 exbii vx cv cA
      wcel wph wa vy cv cB wcel wps wa vx vy vx cv cA wcel wph vy vx cv cA wcel
      vy ax-17 reean.1 hban vy cv cB wcel wps vx vy cv cB wcel vx ax-17 reean.2
      hban eean 3bitr3i wph wps wa vy cB wrex vx cA wrex vy cv cB wcel wph wps
      wa wa vy wex vx cA wrex vx cv cA wcel vy cv cB wcel wph wps wa wa vy wex
      wa vx wex wph wps wa vy cB wrex vy cv cB wcel wph wps wa wa vy wex vx cA
      wph wps wa vy cB df-rex rexbii vy cv cB wcel wph wps wa wa vy wex vx cA
      df-rex bitri wph vx cA wrex vx cv cA wcel wph wa vx wex wps vy cB wrex vy
      cv cB wcel wps wa vy wex wph vx cA df-rex wps vy cB df-rex anbi12i
      3bitr4i $.
      $( [7-Nov-2010] $) $( [27-Oct-2010] $)
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y $.  $d y A $.  $d x B $.
    $( Rearrange existential quantifiers. $)
    reeanv $p |- ( E. x e. A E. y e. B ( ph /\ ps ) <->
                 ( E. x e. A ph /\ E. y e. B ps ) ) $=
      wph wps vx vy cA cB wph vy ax-17 wps vx ax-17 reean $.
      $( [9-May-1999] $)
  $}

  ${
    $d x ph $.
    reubidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    reubidva $p |- ( ph -> ( E! x e. A ps <-> E! x e. A ch ) ) $=
      wph vx cv cA wcel wps wa vx weu vx cv cA wcel wch wa vx weu wps vx cA
      wreu wch vx cA wreu wph vx cv cA wcel wps wa vx cv cA wcel wch wa vx wph
      vx cv cA wcel wps wch reubidva.1 pm5.32da eubidv wps vx cA df-reu wch vx
      cA df-reu 3bitr4g $.
      $( [15-Nov-2004] $) $( [13-Nov-2004] $)
  $}

  ${
    $d x ph $.
    reubidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule). $)
    reubidv $p |- ( ph -> ( E! x e. A ps <-> E! x e. A ch ) ) $=
      wph wps wch vx cA wph wps wch wb vx cv cA wcel reubidv.1 adantr reubidva
      $.
      $( [17-Oct-1996] $)
  $}

  ${
    reubiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Formula-building rule for restricted existential quantifier (inference
       rule). $)
    reubiia $p |- ( E! x e. A ph <-> E! x e. A ps ) $=
      vx cv cA wcel wph wa vx weu vx cv cA wcel wps wa vx weu wph vx cA wreu
      wps vx cA wreu vx cv cA wcel wph wa vx cv cA wcel wps wa vx vx cv cA wcel
      wph wps reubiia.1 pm5.32i eubii wph vx cA df-reu wps vx cA df-reu 3bitr4i
      $.
      $( [15-Nov-2004] $) $( [14-Nov-2004] $)
  $}

  ${
    reubii.1 $e |- ( ph <-> ps ) $.
    $( Formula-building rule for restricted existential quantifier (inference
       rule). $)
    reubii $p |- ( E! x e. A ph <-> E! x e. A ps ) $=
      wph wps vx cA wph wps wb vx cv cA wcel reubii.1 a1i reubiia $.
      $( [22-Oct-1999] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    raleq1f.1 $e |- ( y e. A -> A. x y e. A ) $.
    raleq1f.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Equality theorem for restricted universal quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions. $)
    raleq1f $p |- ( A = B -> ( A. x e. A ph <-> A. x e. B ph ) ) $=
      cA cB wceq vx cv cA wcel wph wi vx wal vx cv cB wcel wph wi vx wal wph vx
      cA wral wph vx cB wral cA cB wceq vx cv cA wcel wph wi vx cv cB wcel wph
      wi vx vx vy vy cA cB raleq1f.1 raleq1f.2 hbeq cA cB wceq vx cv cA wcel vx
      cv cB wcel wph cA cB vx cv eleq2 imbi1d albid wph vx cA df-ral wph vx cB
      df-ral 3bitr4g $.
      $( [8-Mar-2004] $) $( [7-Mar-2004] $)

    $( Equality theorem for restricted existential quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions. $)
    rexeq1f $p |- ( A = B -> ( E. x e. A ph <-> E. x e. B ph ) ) $=
      cA cB wceq vx cv cA wcel wph wa vx wex vx cv cB wcel wph wa vx wex wph vx
      cA wrex wph vx cB wrex cA cB wceq vx cv cA wcel wph wa vx cv cB wcel wph
      wa vx vx vy vy cA cB raleq1f.1 raleq1f.2 hbeq cA cB wceq vx cv cA wcel vx
      cv cB wcel wph cA cB vx cv eleq2 anbi1d exbid wph vx cA df-rex wph vx cB
      df-rex 3bitr4g $.
      $( [9-Oct-2003] $) $( [9-Oct-2003] $)

    $( Equality theorem for restricted uniqueness quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions. $)
    reueq1f $p |- ( A = B -> ( E! x e. A ph <-> E! x e. B ph ) ) $=
      cA cB wceq vx cv cA wcel wph wa vx weu vx cv cB wcel wph wa vx weu wph vx
      cA wreu wph vx cB wreu cA cB wceq vx cv cA wcel wph wa vx cv cB wcel wph
      wa vx vx vy vy cA cB raleq1f.1 raleq1f.2 hbeq cA cB wceq vx cv cA wcel vx
      cv cB wcel wph cA cB vx cv eleq2 anbi1d eubid wph vx cA df-reu wph vx cB
      df-reu 3bitr4g $.
      $( [11-May-2004] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for restricted universal quantifier. $)
    raleq1 $p |- ( A = B -> ( A. x e. A ph <-> A. x e. B ph ) ) $=
      wph vx vy cA cB vy cv cA wcel vx ax-17 vy cv cB wcel vx ax-17 raleq1f $.
      $( [16-Nov-1995] $)

    $( Equality theorem for restricted existential quantifier. $)
    rexeq1 $p |- ( A = B -> ( E. x e. A ph <-> E. x e. B ph ) ) $=
      wph vx vy cA cB vy cv cA wcel vx ax-17 vy cv cB wcel vx ax-17 rexeq1f $.
      $( [29-Oct-1995] $)

    $( Equality theorem for restricted uniqueness quantifier. $)
    reueq1 $p |- ( A = B -> ( E! x e. A ph <-> E! x e. B ph ) ) $=
      wph vx vy cA cB vy cv cA wcel vx ax-17 vy cv cB wcel vx ax-17 reueq1f $.
      $( [11-May-2004] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    raleq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for restricted universal quantifier. $)
    raleq1d $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ps ) ) $=
      wph cA cB wceq wps vx cA wral wps vx cB wral wb raleq1d.1 wps vx cA cB
      raleq1 syl $.
      $( [15-Nov-2005] $) $( [13-Nov-2005] $)

    $( Equality deduction for restricted existential quantifier. $)
    rexeq1d $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ps ) ) $=
      wph cA cB wceq wps vx cA wrex wps vx cB wrex wb raleq1d.1 wps vx cA cB
      rexeq1 syl $.
      $( [14-Jan-2007] $) $( [14-Jan-2007] $)
  $}

  ${
    $d x A $.  $d x B $.
    raleqd.1 $e |- ( A = B -> ( ph <-> ps ) ) $.
    $( Equality deduction for restricted universal quantifier. $)
    raleqd $p |- ( A = B -> ( A. x e. A ph <-> A. x e. B ps ) ) $=
      cA cB wceq wph vx cA wral wph vx cB wral wps vx cB wral wph vx cA cB
      raleq1 cA cB wceq wph wps vx cB raleqd.1 ralbidv bitrd $.
      $( [16-Nov-1995] $)

    $( Equality deduction for restricted existential quantifier. $)
    rexeqd $p |- ( A = B -> ( E. x e. A ph <-> E. x e. B ps ) ) $=
      cA cB wceq wph vx cA wrex wph vx cB wrex wps vx cB wrex wph vx cA cB
      rexeq1 cA cB wceq wph wps vx cB raleqd.1 rexbidv bitrd $.
      $( [18-Mar-1997] $)

    $( Equality deduction for restricted uniqueness quantifier. $)
    reueqd $p |- ( A = B -> ( E! x e. A ph <-> E! x e. B ps ) ) $=
      cA cB wceq wph vx cA wreu wph vx cB wreu wps vx cB wreu wph vx cA cB
      reueq1 cA cB wceq wph wps vx cB raleqd.1 reubidv bitrd $.
      $( [11-May-2004] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    raleq12d.1 $e |- ( ph -> A = B ) $.
    raleq12d.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality deduction for restricted universal quantifier. $)
    raleq12d $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ch ) ) $=
      wph wps vx cA wral wps vx cB wral wch vx cB wral wph wps vx cA cB
      raleq12d.1 raleq1d wph wps wch vx cB raleq12d.2 ralbidv bitrd $.
      $( [8-Nov-2007] $) $( [6-Nov-2007] $)

    $( Equality deduction for restricted universal quantifier. $)
    rexeq12d $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ch ) ) $=
      wph wps vx cA wrex wps vx cB wrex wch vx cB wrex wph wps vx cA cB
      raleq12d.1 rexeq1d wph wps wch vx cB raleq12d.2 rexbidv bitrd $.
      $( [12-Nov-2007] $) $( [6-Nov-2007] $)
  $}

  ${
    $d z A $.  $d x y z $.
    cbvralf.1 $e |- ( z e. A -> A. x z e. A ) $.
    cbvralf.2 $e |- ( z e. A -> A. y z e. A ) $.
    cbvralf.3 $e |- ( ph -> A. y ph ) $.
    cbvralf.4 $e |- ( ps -> A. x ps ) $.
    cbvralf.5 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbvralf $p |- ( A. x e. A ph <-> A. y e. A ps ) $=
      vx cv cA wcel wph wi vx wal vy cv cA wcel wps wi vy wal wph vx cA wral
      wps vy cA wral vx cv cA wcel wph wi vy cv cA wcel wps wi vx vy vx cv cA
      wcel wph vy vy vz vz vx cv cA vz cv vx cv wcel vy ax-17 cbvralf.2 hbel
      cbvralf.3 hbim vy cv cA wcel wps vx vx vz vz vy cv cA vz cv vy cv wcel vx
      ax-17 cbvralf.1 hbel cbvralf.4 hbim vx cv vy cv wceq vx cv cA wcel vy cv
      cA wcel wph wps vx cv vy cv cA eleq1 cbvralf.5 imbi12d cbval wph vx cA
      df-ral wps vy cA df-ral 3bitr4i $.
      $( [8-Mar-2004] $) $( [7-Mar-2004] $)

    $( Rule used to change bound variables, using implicit substitition.
       (Contributed by FL, 27-Apr-2008.) $)
    cbvrexf $p |- ( E. x e. A ph <-> E. y e. A ps ) $=
      vx cv cA wcel wph wa vx wex vy cv cA wcel wps wa vy wex wph vx cA wrex
      wps vy cA wrex vx cv cA wcel wph wa vy cv cA wcel wps wa vx vy vx cv cA
      wcel wph vy vy vz vz vx cv cA vz cv vx cv wcel vy ax-17 cbvralf.2 hbel
      cbvralf.3 hban vy cv cA wcel wps vx vx vz vz vy cv cA vz cv vy cv wcel vx
      ax-17 cbvralf.1 hbel cbvralf.4 hban vx cv vy cv wceq vx cv cA wcel vy cv
      cA wcel wph wps vx cv vy cv cA eleq1 cbvralf.5 anbi12d cbvex wph vx cA
      df-rex wps vy cA df-rex 3bitr4i $.
      $( [22-Aug-2008] $) $( [27-Apr-2008] $)
  $}

  ${
    $d x y z A $.
    cbvral.1 $e |- ( ph -> A. y ph ) $.
    cbvral.2 $e |- ( ps -> A. x ps ) $.
    cbvral.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitition. $)
    cbvral $p |- ( A. x e. A ph <-> A. y e. A ps ) $=
      wph wps vx vy vz cA vz cv cA wcel vx ax-17 vz cv cA wcel vy ax-17
      cbvral.1 cbvral.2 cbvral.3 cbvralf $.
      $( [31-Jul-2003] $)

    $( Rule used to change bound variables, using implicit substitition. $)
    cbvrex $p |- ( E. x e. A ph <-> E. y e. A ps ) $=
      vx cv cA wcel wph wa vx wex vy cv cA wcel wps wa vy wex wph vx cA wrex
      wps vy cA wrex vx cv cA wcel wph wa vy cv cA wcel wps wa vx vy vx cv cA
      wcel wph vy vx cv cA wcel vy ax-17 cbvral.1 hban vy cv cA wcel wps vx vy
      cv cA wcel vx ax-17 cbvral.2 hban vx cv vy cv wceq vx cv cA wcel vy cv cA
      wcel wph wps vx cv vy cv cA eleq1 cbvral.3 anbi12d cbvex wph vx cA df-rex
      wps vy cA df-rex 3bitr4i $.
      $( [31-Jul-2003] $)
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y A $.
    cbvralv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change the bound variable of a restricted universal quantifier using
       implicit substitution. $)
    cbvralv $p |- ( A. x e. A ph <-> A. y e. A ps ) $=
      wph wps vx vy cA wph vy ax-17 wps vx ax-17 cbvralv.1 cbvral $.
      $( [28-Jan-1997] $)

    $( Change the bound variable of a restricted existential quantifier using
       implicit substitution. $)
    cbvrexv $p |- ( E. x e. A ph <-> E. y e. A ps ) $=
      wph wps vx vy cA wph vy ax-17 wps vx ax-17 cbvralv.1 cbvrex $.
      $( [2-Jun-1998] $)

    $( Change the bound variable of a restricted uniqueness quantifier using
       implicit substitution. $)
    cbvreuv $p |- ( E! x e. A ph <-> E! y e. A ps ) $=
      vx cv cA wcel wph wa vx weu vy cv cA wcel wps wa vy weu wph vx cA wreu
      wps vy cA wreu vx cv cA wcel wph wa vy cv cA wcel wps wa vx vy vx cv cA
      wcel wph wa vy ax-17 vy cv cA wcel wps wa vx ax-17 vx cv vy cv wceq vx cv
      cA wcel vy cv cA wcel wph wps vx cv vy cv cA eleq1 cbvralv.1 anbi12d
      cbveu wph vx cA df-reu wps vy cA df-reu 3bitr4i $.
      $( [19-Apr-2004] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x z A $.  $d x y z B $.  $d y w B $.  $d z ph $.  $d y ps $.
    $d x ch $.  $d w ch $.
    cbvral2v.1 $e |- ( x = z -> ( ph <-> ch ) ) $.
    cbvral2v.2 $e |- ( y = w -> ( ch <-> ps ) ) $.
    $( Change bound variables of double restricted universal quantification,
       using implicit substitution. $)
    cbvral2v $p |- ( A. x e. A A. y e. B ph <-> A. z e. A A. w e. B ps ) $=
      wph vy cB wral vx cA wral wch vy cB wral vz cA wral wps vw cB wral vz cA
      wral wph vy cB wral wch vy cB wral vx vz cA vx cv vz cv wceq wph wch vy
      cB cbvral2v.1 ralbidv cbvralv wch vy cB wral wps vw cB wral vz cA wch wps
      vy vw cB cbvral2v.2 cbvralv ralbii bitri $.
      $( [26-Aug-2004] $) $( [10-Aug-2004] $)
  $}

  ${
    $d w ph $.  $d z ps $.  $d x ch $.  $d v ch $.  $d y u th $.
    $d x w A $.  $d x y w B $.  $d v B $.  $d x y z w C $.
    $d v z y C $.  $d u z C $.
    cbvral3v.1 $e |- ( x = w -> ( ph <-> ch ) ) $.
    cbvral3v.2 $e |- ( y = v -> ( ch <-> th ) ) $.
    cbvral3v.3 $e |- ( z = u -> ( th <-> ps ) ) $.
    $( Change bound variables of triple restricted universal quantification,
       using implicit substitution. $)
    cbvral3v $p |- ( A. x e. A A. y e. B A. z e. C ph <->
                     A. w e. A A. v e. B A. u e. C ps ) $=
      wph vz cC wral vy cB wral vx cA wral wch vz cC wral vy cB wral vw cA wral
      wps vu cC wral vv cB wral vw cA wral wph vz cC wral vy cB wral wch vz cC
      wral vy cB wral vx vw cA vx cv vw cv wceq wph wch vy vz cB cC cbvral3v.1
      2ralbidv cbvralv wch vz cC wral vy cB wral wps vu cC wral vv cB wral vw
      cA wch wps wth vy vz vv vu cB cC cbvral3v.2 cbvral3v.3 cbvral2v ralbii
      bitri $.
      $( [22-May-2005] $) $( [10-May-2005] $)
  $}

  ${
    rabbii.1 $e |- ( x e. A -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (inference
       rule). $)
    rabbii $p |- { x e. A | ps } = { x e. A | ch } $=
      vx cv cA wcel wps wa vx cab vx cv cA wcel wch wa vx cab wps vx cA crab
      wch vx cA crab vx cv cA wcel wps wa vx cv cA wcel wch wa vx vx cv cA wcel
      wps wch rabbii.1 pm5.32i abbii wps vx cA df-rab wch vx cA df-rab 3eqtr4i
      $.
      $( [22-May-1999] $)
  $}

  ${
    $d x ph $.
    rabbidv.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (deduction
       rule). $)
    rabbidv $p |- ( ph -> { x e. A | ps } = { x e. A | ch } ) $=
      wph vx cv cA wcel wps wa vx cab vx cv cA wcel wch wa vx cab wps vx cA
      crab wch vx cA crab wph vx cv cA wcel wps wa vx cv cA wcel wch wa vx wph
      vx cv cA wcel wps wch rabbidv.1 pm5.32da abbidv wps vx cA df-rab wch vx
      cA df-rab 3eqtr4g $.
      $( [7-Feb-2007] $) $( [28-Nov-2003] $)
  $}

  ${
    $d x ph $.
    rabbisdv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (deduction
       rule). $)
    rabbisdv $p |- ( ph -> { x e. A | ps } = { x e. A | ch } ) $=
      wph wps wch vx cA wph wps wch wb vx cv cA wcel rabbisdv.1 adantr rabbidv
      $.
      $( [10-Feb-1995] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    rabeqf.1 $e |- ( y e. A -> A. x y e. A ) $.
    rabeqf.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Equality theorem for restricted class abstractions, with bound-variable
       hypotheses instead of distinct variable restrictions. $)
    rabeqf $p |- ( A = B -> { x e. A | ph } = { x e. B | ph } ) $=
      cA cB wceq vx cv cA wcel wph wa vx cab vx cv cB wcel wph wa vx cab wph vx
      cA crab wph vx cB crab cA cB wceq vx cv cA wcel wph wa vx cv cB wcel wph
      wa vx vx vy vy cA cB rabeqf.1 rabeqf.2 hbeq cA cB wceq vx cv cA wcel vx
      cv cB wcel wph cA cB vx cv eleq2 anbi1d abbid wph vx cA df-rab wph vx cB
      df-rab 3eqtr4g $.
      $( [8-Mar-2004] $) $( [7-Mar-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for restricted class abstractions. $)
    rabeq $p |- ( A = B -> { x e. A | ph } = { x e. B | ph } ) $=
      wph vx vy cA cB vy cv cA wcel vx ax-17 vy cv cB wcel vx ax-17 rabeqf $.
      $( [16-Oct-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    rabeqi.1 $e |- A = { x e. B | ph } $.
    $( Inference rule from equality of a class variable and a restricted
       class abstraction. $)
    rabeq2i $p |- ( x e. A <-> ( x e. B /\ ph ) ) $=
      vx cv cA wcel vx cv wph vx cB crab wcel vx cv cB wcel wph wa cA wph vx cB
      crab vx cv rabeqi.1 eleq2i wph vx cB rabid bitri $.
      $( [16-Feb-2004] $) $( [16-Feb-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The universal class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the symbol for the universal class. $)
  $c _V $. $( Letter V (for the universal class) $)

  $( Extend class notation to include the universal class symbol. $)
  cvv $a class _V $.

  ${
    $d z x $.  $d z y $.
    $( Soundness justification theorem for ~ df-v .  (Contributed by Rodolfo
       Medina, 27-Apr-2010.) $)
    vjust $p  |- { x | x = x } = { y | y = y } $=
      vz vx cv vx cv wceq vx cab vy cv vy cv wceq vy cab vx cv vx cv wceq vx vz
      cv wsbc vy cv vy cv wceq vy vz cv wsbc vz cv vx cv vx cv wceq vx cab wcel
      vz cv vy cv vy cv wceq vy cab wcel vx cv vx cv wceq vx vz cv wsbc vy cv
      vy cv wceq vy vz cv wsbc vx cv vx cv wceq vx vz vx equid sbt vy cv vy cv
      wceq vy vz vy equid sbt 2th vx cv vx cv wceq vz vx df-clab vy cv vy cv
      wceq vz vy df-clab 3bitr4i eqriv $.
      $( [19-May-2010] $) $( [27-Apr-2010] $)
  $}

  $( Define the universal class.  Definition 5.20 of [TakeutiZaring] p. 21. $)
  df-v $a |- _V = { x | x = x } $.

  $( All set variables are sets (see ~ isset ).  Theorem 6.8 of [Quine]
     p. 43. $)
  visset $p |- x e. _V $=
    vx cv cvv wcel vx cv vx cv wceq vx cv eqid vx cv vx cv wceq vx cvv vx df-v
    abeq2i mpbir $.
    $( [5-Aug-1993] $)

  ${
    $d x A $.
    $( Two ways to say " ` A ` is a set":  A class ` A ` is a member of the
       universal class ` _V ` (see ~ df-v ) if and only if the class ` A `
       exists (i.e. there exists some set ` x ` equal to class ` A ` ).
       Theorem 6.9 of [Quine] p. 43.  _Notational convention_:  We will use the
       notational device " ` A e. _V ` " to mean " ` A ` is a set" very
       frequently, for example in ~ uniex .  Note the when ` A ` is not a set,
       it is called a proper class.  In some theorems, such as ~ uniexg , in
       order to shorten certain proofs we use the more general antecedent
       ` A e. B ` instead of ` A e. _V ` to mean " ` A ` is a set."

       Note that a constant is considered distinct from all variables.
       This is why ` _V ` is not included in the distinct variable list,
       even though ~ df-clel requires that the expression substituted for
       ` B ` not contain ` x ` .  (Also, the Metamath spec does not allow
       constants in the distinct variable list.) $)
    isset $p |- ( A e. _V <-> E. x x = A ) $=
      cA cvv wcel vx cv cA wceq vx cv cvv wcel wa vx wex vx cv cA wceq vx wex
      vx cA cvv df-clel vx cv cA wceq vx cv cA wceq vx cv cvv wcel wa vx vx cv
      cvv wcel vx cv cA wceq vx visset biantru exbii bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.
    isseti.1 $e |- A e. _V $.
    $( A way to say " ` A ` is a set" (inference rule). $)
    isseti $p |- E. x x = A $=
      cA cvv wcel vx cv cA wceq vx wex isseti.1 vx cA isset mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.
    issetri.1 $e |- E. x x = A $.
    $( A way to say " ` A ` is a set" (inference rule). $)
    issetri $p |- A e. _V $=
      cA cvv wcel vx cv cA wceq vx wex issetri.1 vx cA isset mpbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class is a member of another class, it is a set.  Theorem 6.12
       of [Quine] p. 44. $)
    elisset $p |- ( A e. B -> A e. _V ) $=
      cA cB wcel vx cv cA wceq vx wex cA cvv wcel cA cB wcel vx cv cA wceq vx
      wex vx cv cB wcel vx wex cA cB wcel vx cv cA wceq vx cv cB wcel wa vx wex
      vx cv cA wceq vx wex vx cv cB wcel vx wex wa vx cA cB df-clel vx cv cA
      wceq vx cv cB wcel vx 19.40 sylbi pm3.26d vx cA isset sylibr $.
      $( [5-Aug-1993] $)
  $}

  ${
    elisseti.1 $e |- A e. B $.
    $( If a class is a member of another class, it is a set. $)
    elisseti $p |- A e. _V $=
      cA cB wcel cA cvv wcel elisseti.1 cA cB elisset ax-mp $.
      $( [11-Jun-1994] $)
  $}

  ${
    $d x A $.
    $( An element of a class exists. $)
    elex $p |- ( A e. B -> E. x x = A ) $=
      cA cB wcel cA cvv wcel vx cv cA wceq vx wex cA cB elisset vx cA isset
      sylib $.
      $( [1-May-1995] $)
  $}

  $( A universal quantifier restricted to the universe is unrestricted. $)
  ralv $p |- ( A. x e. _V ph <-> A. x ph ) $=
    wph vx cvv wral vx cv cvv wcel wph wi vx wal wph vx wal wph vx cvv df-ral
    wph vx cv cvv wcel wph wi vx vx cv cvv wcel wph vx visset a1bi albii bitr4i
    $.
    $( [31-Mar-2004] $) $( [26-Mar-2004] $)

  $( An existential quantifier restricted to the universe is unrestricted. $)
  rexv $p |- ( E. x e. _V ph <-> E. x ph ) $=
    wph vx cvv wrex vx cv cvv wcel wph wa vx wex wph vx wex wph vx cvv df-rex
    wph vx cv cvv wcel wph wa vx vx cv cvv wcel wph vx visset biantrur exbii
    bitr4i $.
    $( [4-Apr-2004] $)


  $( A class abstraction restricted to the universe is unrestricted. $)
  rabab $p |- { x e. _V | ph } = { x | ph } $=
    wph vx cvv crab vx cv cvv wcel wph wa vx cab wph vx cab wph vx cvv df-rab
    vx cv cvv wcel wph wa wph vx vx cv cvv wcel wph wa wph vx cv cvv wcel wph
    pm3.27 wph vx cv cvv wcel vx visset jctl impbii abbii eqtri $.
    $( [1-Jan-2005] $) $( [27-Dec-2004] $)

  ${
    $d x y $.  $d y A $.
    $( Commutation of restricted and unrestricted universal quantifiers. $)
    ralcom4 $p |- ( A. x e. A A. y ph <-> A. y A. x e. A ph ) $=
      wph vx cA wral vy cvv wral wph vy cvv wral vx cA wral wph vx cA wral vy
      wal wph vy wal vx cA wral wph vy vx cvv cA ralcom wph vx cA wral vy ralv
      wph vy cvv wral wph vy wal vx cA wph vy ralv ralbii 3bitr3ri $.
      $( [31-Mar-2004] $) $( [26-Mar-2004] $)

    $( Commutation of restricted and unrestricted existential quantifiers. $)
    rexcom4 $p |- ( E. x e. A E. y ph <-> E. y E. x e. A ph ) $=
      wph vx cA wrex vy cvv wrex wph vy cvv wrex vx cA wrex wph vx cA wrex vy
      wex wph vy wex vx cA wrex wph vy vx cvv cA rexcom wph vx cA wrex vy rexv
      wph vy cvv wrex wph vy wex vx cA wph vy rexv rexbii 3bitr3ri $.
      $( [13-Apr-2004] $) $( [12-Apr-2004] $)
  $}

  ${
    $d x A $.
    ceqsalg.1 $e |- ( ps -> A. x ps ) $.
    ceqsalg.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis. $)
    ceqsalg $p |- ( A e. B -> ( A. x ( x = A -> ph ) <-> ps ) ) $=
      cA cB wcel vx cv cA wceq wph wi vx wal wps vx cv cA wceq wph wi vx wal vx
      cv cA wceq vx wex wps cA cB wcel vx cv cA wceq wph wi vx wal vx cv cA
      wceq wps wi vx wal vx cv cA wceq vx wex wps wi vx cv cA wceq wph wi vx cv
      cA wceq wps wi vx vx cv cA wceq wph wps vx cv cA wceq wph wps ceqsalg.2
      biimpd a2i 19.20i vx cv cA wceq wps vx ceqsalg.1 19.23 sylib vx cA cB
      elex syl5com wps vx cv cA wceq wph wi vx ceqsalg.1 vx cv cA wceq wph wps
      ceqsalg.2 biimprcd 19.21ai impbid1 $.
      $( [29-Oct-2003] $) $( [29-Oct-2003] $)
  $}

  ${
    $d x A $.
    ceqsal.1 $e |- ( ps -> A. x ps ) $.
    ceqsal.2 $e |- A e. _V $.
    ceqsal.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis. $)
    ceqsal $p |- ( A. x ( x = A -> ph ) <-> ps ) $=
      cA cvv wcel vx cv cA wceq wph wi vx wal wps wb ceqsal.2 wph wps vx cA cvv
      ceqsal.1 ceqsal.3 ceqsalg ax-mp $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x ps $.
    ceqsalv.1 $e |- A e. _V $.
    ceqsalv.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis. $)
    ceqsalv $p |- ( A. x ( x = A -> ph ) <-> ps ) $=
      wph wps vx cA wps vx ax-17 ceqsalv.1 ceqsalv.2 ceqsal $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x ps $.
    gencl.1 $e |- ( th <-> E. x ( ch /\ A = B ) ) $.
    gencl.2 $e |- ( A = B -> ( ph <-> ps ) ) $.
    gencl.3 $e |- ( ch -> ph ) $.
    $( Implicit substitution for class with embedded variable. $)
    gencl $p |- ( th -> ps ) $=
      wth wch cA cB wceq wa vx wex wps gencl.1 wch cA cB wceq wa wps vx cA cB
      wceq wch wps cA cB wceq wph wps wch gencl.2 gencl.3 syl5bi impcom
      19.23aiv sylbi $.
      $( [17-May-1996] $)
  $}

  ${
    $d x y $.  $d x R $.  $d x ps $.  $d y C $.  $d y S $.  $d y ch $.
    2gencl.1 $e |- ( C e. S <-> E. x ( x e. R /\ A = C ) ) $.
    2gencl.2 $e |- ( D e. S <-> E. y ( y e. R /\ B = D ) ) $.
    2gencl.3 $e |- ( A = C -> ( ph <-> ps ) ) $.
    2gencl.4 $e |- ( B = D -> ( ps <-> ch ) ) $.
    2gencl.5 $e |- ( ( x e. R /\ y e. R ) -> ph ) $.
    $( Implicit substitution for class with embedded variable. $)
    2gencl $p |- ( ( C e. S /\ D e. S ) -> ch ) $=
      cD cS wcel cC cS wcel wch cC cS wcel wps wi cC cS wcel wch wi vy cv cR
      wcel cD cS wcel vy cB cD 2gencl.2 cB cD wceq wps wch cC cS wcel 2gencl.4
      imbi2d cC cS wcel vy cv cR wcel wps vy cv cR wcel wph wi vy cv cR wcel
      wps wi vx cv cR wcel cC cS wcel vx cA cC 2gencl.1 cA cC wceq wph wps vy
      cv cR wcel 2gencl.3 imbi2d vx cv cR wcel vy cv cR wcel wph 2gencl.5 ex
      gencl com12 gencl impcom $.
      $( [17-May-1996] $)
  $}

  ${
    $v F $.
    $v G $.
    3gencl.F $f class F $.
    3gencl.G $f class G $.
    $d x y z $.  $d y z D $.  $d z F $.  $d x y R $.  $d y z S $.
    $d x ps $.  $d y ch $.  $d z th $.
    3gencl.1 $e |- ( D e. S <-> E. x ( x e. R /\ A = D ) ) $.
    3gencl.2 $e |- ( F e. S <-> E. y ( y e. R /\ B = F ) ) $.
    3gencl.3 $e |- ( G e. S <-> E. z ( z e. R /\ C = G ) ) $.
    3gencl.4 $e |- ( A = D -> ( ph <-> ps ) ) $.
    3gencl.5 $e |- ( B = F -> ( ps <-> ch ) ) $.
    3gencl.6 $e |- ( C = G -> ( ch <-> th ) ) $.
    3gencl.7 $e |- ( ( x e. R /\ y e. R /\ z e. R ) -> ph ) $.
    $( Implicit substitution for class with embedded variable. $)
    3gencl $p |- ( ( D e. S /\ F e. S /\ G e. S ) -> th ) $=
      cD cS wcel 3gencl.F cS wcel 3gencl.G cS wcel wth 3gencl.G cS wcel cD cS
      wcel 3gencl.F cS wcel wa wth cD cS wcel 3gencl.F cS wcel wa wch wi cD cS
      wcel 3gencl.F cS wcel wa wth wi vz cv cR wcel 3gencl.G cS wcel vz cC
      3gencl.G 3gencl.3 cC 3gencl.G wceq wch wth cD cS wcel 3gencl.F cS wcel wa
      3gencl.6 imbi2d cD cS wcel 3gencl.F cS wcel wa vz cv cR wcel wch vz cv cR
      wcel wph wi vz cv cR wcel wps wi vz cv cR wcel wch wi vx vy cA cB cD
      3gencl.F cR cS 3gencl.1 3gencl.2 cA cD wceq wph wps vz cv cR wcel
      3gencl.4 imbi2d cB 3gencl.F wceq wps wch vz cv cR wcel 3gencl.5 imbi2d vx
      cv cR wcel vy cv cR wcel vz cv cR wcel wph 3gencl.7 3expia 2gencl com12
      gencl com12 3impia $.
      $( [17-May-1996] $)
  $}

  ${
    $d x A $.  $d x ps $.
    cgsexg.1 $e |- ( x = A -> ch ) $.
    cgsexg.2 $e |- ( ch -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for general classes. $)
    cgsexg $p |- ( A e. B ->
                     ( E. x ( ch /\ ph ) <-> ps ) ) $=
      cA cB wcel wch wph wa vx wex wps wch wph wa wps vx wch wph wps cgsexg.2
      biimpa 19.23aiv wps wch vx wex wch wph wa vx wex cA cB wcel wps wch wch
      wph wa vx wps wch wph wch wph wps cgsexg.2 biimprcd ancld 19.22dv cA cB
      wcel vx cv cA wceq vx wex wch vx wex vx cA cB elex vx cv cA wceq wch vx
      cgsexg.1 19.22i syl syl5com impbid2 $.
      $( [21-Apr-2008] $) $( [26-Aug-2007] $)
  $}

  ${
    $d x y ps $.  $d x y A $.  $d x y B $.
    cgsex2g.1 $e |- ( ( x = A /\ y = B ) -> ch ) $.
    cgsex2g.2 $e |- ( ch -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for general classes. $)
    cgsex2g $p |- ( ( A e. C /\ B e. D ) ->
                     ( E. x E. y ( ch /\ ph ) <-> ps ) ) $=
      cA cC wcel cB cD wcel wa wch wph wa vy wex vx wex wps wch wph wa wps vx
      vy wch wph wps cgsex2g.2 biimpa 19.23aivv wps wch vy wex vx wex wch wph
      wa vy wex vx wex cA cC wcel cB cD wcel wa wps wch wch wph wa vx vy wps
      wch wph wch wph wps cgsex2g.2 biimprcd ancld 19.22dvv cA cC wcel cB cD
      wcel wa vx cv cA wceq vy cv cB wceq wa vy wex vx wex wch vy wex vx wex cA
      cC wcel cB cD wcel wa vx cv cA wceq vx wex vy cv cB wceq vy wex wa vx cv
      cA wceq vy cv cB wceq wa vy wex vx wex cA cC wcel vx cv cA wceq vx wex cB
      cD wcel vy cv cB wceq vy wex vx cA cC elex vy cB cD elex anim12i vx cv cA
      wceq vy cv cB wceq vx vy eeanv sylibr vx cv cA wceq vy cv cB wceq wa wch
      vx vy cgsex2g.1 19.22i2 syl syl5com impbid2 $.
      $( [26-Jul-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x y z w ps $.
    cgsex4g.1 $e |- ( ( ( x = A /\ y = B ) /\ ( z = C /\ w = D ) ) -> ch ) $.
    cgsex4g.2 $e |- ( ch -> ( ph <-> ps ) ) $.
    $( An implicit substitution inference for 4 general classes. $)
    cgsex4g $p |- ( ( ( A e. R /\ B e. S ) /\ ( C e. R /\ D e. S ) ) ->
                    ( E. x E. y E. z E. w ( ch /\ ph ) <-> ps ) ) $=
      cA cR wcel cB cS wcel wa cC cR wcel cD cS wcel wa wa wch wph wa vw wex vz
      wex vy wex vx wex wps wch wph wa vw wex vz wex wps vx vy wch wph wa wps
      vz vw wch wph wps cgsex4g.2 biimpa 19.23aivv 19.23aivv wps wch vw wex vz
      wex vy wex vx wex wch wph wa vw wex vz wex vy wex vx wex cA cR wcel cB cS
      wcel wa cC cR wcel cD cS wcel wa wa wps wch vw wex vz wex wch wph wa vw
      wex vz wex vx vy wps wch wch wph wa vz vw wps wch wph wch wph wps
      cgsex4g.2 biimprcd ancld 19.22dvv 19.22dvv cA cR wcel cB cS wcel wa cC cR
      wcel cD cS wcel wa wa vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv
      cD wceq wa wa vw wex vz wex vy wex vx wex wch vw wex vz wex vy wex vx wex
      cA cR wcel cB cS wcel wa cC cR wcel cD cS wcel wa wa vx cv cA wceq vy cv
      cB wceq wa vy wex vx wex vz cv cC wceq vw cv cD wceq wa vw wex vz wex wa
      vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv cD wceq wa wa vw wex
      vz wex vy wex vx wex cA cR wcel cB cS wcel wa vx cv cA wceq vy cv cB wceq
      wa vy wex vx wex cC cR wcel cD cS wcel wa vz cv cC wceq vw cv cD wceq wa
      vw wex vz wex cA cR wcel cB cS wcel wa vx cv cA wceq vx wex vy cv cB wceq
      vy wex wa vx cv cA wceq vy cv cB wceq wa vy wex vx wex cA cR wcel vx cv
      cA wceq vx wex cB cS wcel vy cv cB wceq vy wex vx cA cR elex vy cB cS
      elex anim12i vx cv cA wceq vy cv cB wceq vx vy eeanv sylibr cC cR wcel cD
      cS wcel wa vz cv cC wceq vz wex vw cv cD wceq vw wex wa vz cv cC wceq vw
      cv cD wceq wa vw wex vz wex cC cR wcel vz cv cC wceq vz wex cD cS wcel vw
      cv cD wceq vw wex vz cC cR elex vw cD cS elex anim12i vz cv cC wceq vw cv
      cD wceq vz vw eeanv sylibr anim12i vx cv cA wceq vy cv cB wceq wa vz cv
      cC wceq vw cv cD wceq wa vx vy vz vw ee4anv sylibr vx cv cA wceq vy cv cB
      wceq wa vz cv cC wceq vw cv cD wceq wa wa vw wex vz wex wch vw wex vz wex
      vx vy vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv cD wceq wa wa
      wch vz vw cgsex4g.1 19.22i2 19.22i2 syl syl5com impbid2 $.
      $( [5-Aug-1995] $)
  $}

  ${
    $d x A $.
    ceqsex.1 $e |- ( ps -> A. x ps ) $.
    ceqsex.2 $e |- A e. _V $.
    ceqsex.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of an existential quantifier, using implicit
       substitution. $)
    ceqsex $p |- ( E. x ( x = A /\ ph ) <-> ps ) $=
      vx cv cA wceq wph wa vx wex wps vx cv cA wceq wph wa wps vx ceqsex.1 vx
      cv cA wceq wph wps ceqsex.3 biimpa 19.23ai wps vx cv cA wceq vx wex vx cv
      cA wceq wph wa vx wex vx cA ceqsex.2 isseti wps vx cv cA wceq wph wi vx
      wal vx cv cA wceq vx wex vx cv cA wceq wph wa vx wex wi wps vx cv cA wceq
      wph wi vx ceqsex.1 vx cv cA wceq wph wps ceqsex.3 biimprcd 19.21ai vx cv
      cA wceq wph vx exintr syl mpi impbii $.
      $( [2-Mar-1995] $)
  $}

  ${
    $d x A $.  $d x ps $.
    ceqsexv.1 $e |- A e. _V $.
    ceqsexv.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of an existential quantifier, using implicit
       substitution. $)
    ceqsexv $p |- ( E. x ( x = A /\ ph ) <-> ps ) $=
      wph wps vx cA wps vx ax-17 ceqsexv.1 ceqsexv.2 ceqsex $.
      $( [2-Mar-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    ceqsex2.1 $e |- ( ps -> A. x ps ) $.
    ceqsex2.2 $e |- ( ch -> A. y ch ) $.
    ceqsex2.3 $e |- A e. _V $.
    ceqsex2.4 $e |- B e. _V $.
    ceqsex2.5 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex2.6 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Elimination of two existential quantifiers, using implicit substitution.
       (Contributed by Scott Fenton, 7-Jun-2006.) $)
    ceqsex2 $p |- ( E. x E. y ( ( x = A /\ y = B ) /\ ph ) <-> ch ) $=
      vx cv cA wceq vy cv cB wceq wa wph wa vy wex vx wex vx cv cA wceq vy cv
      cB wceq wph wa vy wex wa vx wex vy cv cB wceq wps wa vy wex wch vx cv cA
      wceq vy cv cB wceq wa wph wa vy wex vx cv cA wceq vy cv cB wceq wph wa vy
      wex wa vx vx cv cA wceq vy cv cB wceq wa wph wa vy wex vx cv cA wceq vy
      cv cB wceq wph wa wa vy wex vx cv cA wceq vy cv cB wceq wph wa vy wex wa
      vx cv cA wceq vy cv cB wceq wa wph wa vx cv cA wceq vy cv cB wceq wph wa
      wa vy vx cv cA wceq vy cv cB wceq wph anass exbii vx cv cA wceq vy cv cB
      wceq wph wa vy 19.42v bitri exbii vy cv cB wceq wph wa vy wex vy cv cB
      wceq wps wa vy wex vx cA vy cv cB wceq wps wa vx vy vy cv cB wceq wps vx
      vy cv cB wceq vx ax-17 ceqsex2.1 hban hbex ceqsex2.3 vx cv cA wceq vy cv
      cB wceq wph wa vy cv cB wceq wps wa vy vx cv cA wceq wph wps vy cv cB
      wceq ceqsex2.5 anbi2d exbidv ceqsex wps wch vy cB ceqsex2.2 ceqsex2.4
      ceqsex2.6 ceqsex 3bitri $.
      $( [10-Jun-2006] $) $( [7-Jun-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ch $.  $d x ps $.
    ceqsex2v.1 $e |- A e. _V $.
    ceqsex2v.2 $e |- B e. _V $.
    ceqsex2v.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex2v.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Elimination of two existential quantifiers, using implicit substitution.
       (Contributed by Scott Fenton, 7-Jun-2006.) $)
    ceqsex2v $p |- ( E. x E. y ( ( x = A /\ y = B ) /\ ph ) <-> ch ) $=
      wph wps wch vx vy cA cB wps vx ax-17 wch vy ax-17 ceqsex2v.1 ceqsex2v.2
      ceqsex2v.3 ceqsex2v.4 ceqsex2 $.
      $( [10-Jun-2006] $) $( [7-Jun-2006] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x th $.  $d y ch $.  $d y A $.
    gencbvex.1 $e |- A e. _V $.
    gencbvex.2 $e |- ( A = y -> ( ph <-> ps ) ) $.
    gencbvex.3 $e |- ( A = y -> ( ch <-> th ) ) $.
    gencbvex.4 $e |- ( th <-> E. x ( ch /\ A = y ) ) $.
    $( Change of bound variable using implicit substitution. $)
    gencbvex $p |- ( E. x ( ch /\ ph ) <-> E. y ( th /\ ps ) ) $=
      vy cv cA wceq wth wps wa wa vy wex vx wex vy cv cA wceq wth wps wa wa vx
      wex vy wex wch wph wa vx wex wth wps wa vy wex vy cv cA wceq wth wps wa
      wa vx vy excom vy cv cA wceq wth wps wa wa vy wex wch wph wa vx wth wps
      wa wch wph wa vy cA gencbvex.1 wth wps wa wch wph wa wb cA vy cv cA vy cv
      wceq wch wph wa wth wps wa cA vy cv wceq wch wth wph wps gencbvex.3
      gencbvex.2 anbi12d bicomd eqcoms ceqsexv exbii vy cv cA wceq wth wps wa
      wa vx wex wth wps wa vy vy cv cA wceq vx wex wth wa wps wa vy cv cA wceq
      vx wex wth wps wa wa wth wps wa vy cv cA wceq wth wps wa wa vx wex vy cv
      cA wceq vx wex wth wps anass wth vy cv cA wceq vx wex wth wa wps wth wch
      cA vy cv wceq wa vx wex vy cv cA wceq wth wa vx wex vy cv cA wceq vx wex
      wth wa gencbvex.4 wch cA vy cv wceq wa vy cv cA wceq wth wa vx cA vy cv
      wceq wch wa cA vy cv wceq wth wa wch cA vy cv wceq wa vy cv cA wceq wth
      wa cA vy cv wceq wch wth gencbvex.3 pm5.32i cA vy cv wceq wch ancom cA vy
      cv wceq vy cv cA wceq wth cA vy cv eqcom anbi1i 3bitr3i exbii vy cv cA
      wceq wth vx 19.41v 3bitri anbi1i vy cv cA wceq wth wps wa vx 19.41v
      3bitr4ri exbii 3bitr3i $.
      $( [17-May-1996] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x th $.  $d y ch $.  $d y A $.
    gencbvex2.1 $e |- A e. _V $.
    gencbvex2.2 $e |- ( A = y -> ( ph <-> ps ) ) $.
    gencbvex2.3 $e |- ( A = y -> ( ch <-> th ) ) $.
    gencbvex2.4 $e |- ( th -> E. x ( ch /\ A = y ) ) $.
    $( Restatement of ~ gencbvex with weaker hypotheses.  (Contributed by
       Jeffrey Hankins, 6-Dec-2006.) $)
    gencbvex2 $p |- ( E. x ( ch /\ ph ) <-> E. y ( th /\ ps ) ) $=
      wph wps wch wth vx vy cA gencbvex2.1 gencbvex2.2 gencbvex2.3 wth wch cA
      vy cv wceq wa vx wex gencbvex2.4 wch cA vy cv wceq wa wth vx cA vy cv
      wceq wch wth gencbvex2.3 biimpac 19.23aiv impbii gencbvex $.
      $( [7-Dec-2006] $) $( [6-Dec-2006] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x th $.  $d y ch $.  $d y A $.
    gencbval.1 $e |- A e. _V $.
    gencbval.2 $e |- ( A = y -> ( ph <-> ps ) ) $.
    gencbval.3 $e |- ( A = y -> ( ch <-> th ) ) $.
    gencbval.4 $e |- ( th <-> E. x ( ch /\ A = y ) ) $.
    $( Change of bound variable using implicit substitution. $)
    gencbval $p |- ( A. x ( ch -> ph ) <-> A. y ( th -> ps ) ) $=
      wch wph wi vx wal wth wps wi vy wal wch wph wn wa vx wex wth wps wn wa vy
      wex wch wph wi vx wal wn wth wps wi vy wal wn wph wn wps wn wch wth vx vy
      cA gencbval.1 cA vy cv wceq wph wps gencbval.2 notbid gencbval.3
      gencbval.4 gencbvex wch wph vx exanali wth wps vy exanali 3bitr3i con4bii
      $.
      $( [17-May-1996] $)
  $}

  ${
    $d x A $.
    vtoclf.1 $e |- ( ps -> A. x ps ) $.
    vtoclf.2 $e |- A e. _V $.
    vtoclf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclf.4 $e |- ph $.
    $( Implicit substitution of a class for a set variable.  This is a
       generalization of ~ chvar . $)
    vtoclf $p |- ps $=
      wph wps vx wph wps vx vtoclf.1 vx cv cA wceq vx wex wph wps wi vx wex vx
      cA vtoclf.2 isseti vx cv cA wceq wph wps wi vx vx cv cA wceq wph wps
      vtoclf.3 biimpd 19.22i ax-mp 19.36i vtoclf.4 mpg $.
      $( [30-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x ps $.
    vtocl.1 $e |- A e. _V $.
    vtocl.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl.3 $e |- ph $.
    $( Implicit substitution of a class for a set variable. $)
    vtocl $p |- ps $=
      wph wps vx cA wps vx ax-17 vtocl.1 vtocl.2 vtocl.3 vtoclf $.
      $( [30-Aug-1993] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    vtocl2.1 $e |- A e. _V $.
    vtocl2.2 $e |- B e. _V $.
    vtocl2.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    vtocl2.4 $e |- ph $.
    $( Implicit substitution of classes for set variables. $)
    vtocl2 $p |- ps $=
      wph vy wal wps vx wph wps wi vy wex vx wex wph vy wal vx wal wps wi vx cv
      cA wceq vx wex vy cv cB wceq vy wex wph wps wi vy wex vx wex vx cA
      vtocl2.1 isseti vy cB vtocl2.2 isseti vx cv cA wceq vx wex vy cv cB wceq
      vy wex wa vx cv cA wceq vy cv cB wceq wa vy wex vx wex wph wps wi vy wex
      vx wex vx cv cA wceq vy cv cB wceq vx vy eeanv vx cv cA wceq vy cv cB
      wceq wa wph wps wi vx vy vx cv cA wceq vy cv cB wceq wa wph wps vtocl2.3
      biimpd 19.22i2 sylbir mp2an wph wps wi vy wex vx wex wph vy wal wps wi vx
      wex wph vy wal vx wal wps wi wph wps wi vy wex wph vy wal wps wi vx wph
      wps vy 19.36v exbii wph vy wal wps vx 19.36v bitri mpbi wph vy vtocl2.4
      ax-gen mpg $.
      $( [26-Jul-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z ps $.
    vtocl3.1 $e |- A e. _V $.
    vtocl3.2 $e |- B e. _V $.
    vtocl3.3 $e |- C e. _V $.
    vtocl3.4 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    vtocl3.5 $e |- ph $.
    $( Implicit substitution of classes for set variables. $)
    vtocl3 $p |- ps $=
      wph vz wal vy wal wps vx wph wps wi vz wex vy wex vx wex wph vz wal vy
      wal vx wal wps wi vx cv cA wceq vx wex vy cv cB wceq vy wex vz cv cC wceq
      vz wex wph wps wi vz wex vy wex vx wex vx cA vtocl3.1 isseti vy cB
      vtocl3.2 isseti vz cC vtocl3.3 isseti vx cv cA wceq vx wex vy cv cB wceq
      vy wex vz cv cC wceq vz wex w3a vx cv cA wceq vy cv cB wceq vz cv cC wceq
      w3a vz wex vy wex vx wex wph wps wi vz wex vy wex vx wex vx cv cA wceq vy
      cv cB wceq vz cv cC wceq vx vy vz eeeanv vx cv cA wceq vy cv cB wceq vz
      cv cC wceq w3a vz wex wph wps wi vz wex vx vy vx cv cA wceq vy cv cB wceq
      vz cv cC wceq w3a wph wps wi vz vx cv cA wceq vy cv cB wceq vz cv cC wceq
      w3a wph wps vtocl3.4 biimpd 19.22i 19.22i2 sylbir mp3an wph wps wi vz wex
      vy wex vx wex wph vz wal vy wal wps wi vx wex wph vz wal vy wal vx wal
      wps wi wph wps wi vz wex vy wex wph vz wal vy wal wps wi vx wph wps wi vz
      wex vy wex wph vz wal wps wi vy wex wph vz wal vy wal wps wi wph wps wi
      vz wex wph vz wal wps wi vy wph wps vz 19.36v exbii wph vz wal wps vy
      19.36v bitri exbii wph vz wal vy wal wps vx 19.36v bitri mpbi wph vy vz
      vtocl3.5 gen2 mpg $.
      $( [3-Jun-1995] $)
  $}

  ${
    $d x A $.  $d x ch $.  $d x th $.
    vtoclb.1 $e |- A e. _V $.
    vtoclb.2 $e |- ( x = A -> ( ph <-> ch ) ) $.
    vtoclb.3 $e |- ( x = A -> ( ps <-> th ) ) $.
    vtoclb.4 $e |- ( ph <-> ps ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclb $p |- ( ch <-> th ) $=
      wph wps wb wch wth wb vx cA vtoclb.1 vx cv cA wceq wph wch wps wth
      vtoclb.2 vtoclb.3 bibi12d vtoclb.4 vtocl $.
      $( [23-Dec-1993] $)
  $}

  ${
    $d y A $.  $d x y $.
    vtoclgf.1 $e |- ( y e. A -> A. x y e. A ) $.
    vtoclgf.2 $e |- ( ps -> A. x ps ) $.
    vtoclgf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclgf.4 $e |- ph $.
    $( Implicit substitution of a class for a set variable, with bound-variable
       hypotheses in place of distinct variable restrictions. $)
    vtoclgf $p |- ( A e. B -> ps ) $=
      cA cB wcel cA cvv wcel wps cA cB elisset cA cvv wcel vx cv cA wceq vx wex
      wps cA cvv wcel vy cv cA wceq vy wex vx cv cA wceq vx wex vy cA isset vy
      cv cA wceq vx cv cA wceq vy vx vx vy cA vtoclgf.1 hbeleq vx cv cA wceq vy
      ax-17 vy cv vx cv cA eqeq1 cbvex bitri vx cv cA wceq wps vx vtoclgf.2 vx
      cv cA wceq wph wps vtoclgf.4 vtoclgf.3 mpbii 19.23ai sylbi syl $.
      $( [21-Sep-2003] $)
  $}

  ${
    $d x y A $.  $d x ps $.
    vtoclg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclg.2 $e |- ph $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclg $p |- ( A e. B -> ps ) $=
      wph wps vx vy cA cB vy cv cA wcel vx ax-17 wps vx ax-17 vtoclg.1 vtoclg.2
      vtoclgf $.
      $( [17-Apr-1995] $)
  $}

  ${
    $d x A $.  $d x ch $.  $d x th $.
    vtoclbg.1 $e |- ( x = A -> ( ph <-> ch ) ) $.
    vtoclbg.2 $e |- ( x = A -> ( ps <-> th ) ) $.
    vtoclbg.3 $e |- ( ph <-> ps ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclbg $p |- ( A e. B -> ( ch <-> th ) ) $=
      wph wps wb wch wth wb vx cA cB vx cv cA wceq wph wch wps wth vtoclbg.1
      vtoclbg.2 bibi12d vtoclbg.3 vtoclg $.
      $( [29-Apr-1994] $)
  $}

  ${
    $d x A $.  $d y z A $.  $d y z B $.  $d z x $.
    vtocl2gf.1 $e |- ( ps -> A. x ps ) $.
    vtocl2gf.2 $e |- ( ch -> A. y ch ) $.
    vtocl2gf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2gf.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2gf.5 $e |- ph $.
    $( Implicit substitution of a class for a set variable. $)
    vtocl2gf $p |- ( ( A e. C /\ B e. D ) -> ch ) $=
      cA cvv wcel cB cD wcel wch cA cC wcel cB cD wcel cA cvv wcel wch cA cvv
      wcel wps wi cA cvv wcel wch wi vy vz cB cD vz cv cB wcel vy ax-17 cA cvv
      wcel wch vy cA cvv wcel vy ax-17 vtocl2gf.2 hbim vy cv cB wceq wps wch cA
      cvv wcel vtocl2gf.4 imbi2d wph wps vx vz cA cvv vz cv cA wcel vx ax-17
      vtocl2gf.1 vtocl2gf.3 vtocl2gf.5 vtoclgf vtoclgf impcom cA cC elisset
      sylan $.
      $( [25-Apr-1995] $)
  $}

  ${
    $d x A $.  $d y A $.  $d y B $.  $d x ps $.  $d y ch $.
    vtocl2g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2g.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2g.3 $e |- ph $.
    $( Implicit substitution of 2 classes for 2 set variables. $)
    vtocl2g $p |- ( ( A e. C /\ B e. D ) -> ch ) $=
      wph wps wch vx vy cA cB cC cD wps vx ax-17 wch vy ax-17 vtocl2g.1
      vtocl2g.2 vtocl2g.3 vtocl2gf $.
      $( [25-Apr-1995] $)
  $}

  ${
    $d y A $.  $d x y $.  $d x y B $.
    vtoclgaf.1 $e |- ( y e. A -> A. x y e. A ) $.
    vtoclgaf.2 $e |- ( ps -> A. x ps ) $.
    vtoclgaf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclgaf.4 $e |- ( x e. B -> ph ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclgaf $p |- ( A e. B -> ps ) $=
      cA cB wcel wps vx cv cB wcel wph wi cA cB wcel wps wi vx vy cA cB
      vtoclgaf.1 cA cB wcel wps vx vx vy vy cA cB vtoclgaf.1 vy cv cB wcel vx
      ax-17 hbel vtoclgaf.2 hbim vx cv cA wceq vx cv cB wcel cA cB wcel wph wps
      vx cv cA cB eleq1 vtoclgaf.3 imbi12d vtoclgaf.4 vtoclgf pm2.43i $.
      $( [18-Feb-2006] $) $( [17-Feb-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x ps $.
    vtoclga.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclga.2 $e |- ( x e. B -> ph ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclga $p |- ( A e. B -> ps ) $=
      wph wps vx vy cA cB vy cv cA wcel vx ax-17 wps vx ax-17 vtoclga.1
      vtoclga.2 vtoclgaf $.
      $( [20-Aug-1995] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x ps $.  $d y ch $.
    vtocl2ga.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2ga.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2ga.3 $e |- ( ( x e. C /\ y e. D ) -> ph ) $.
    $( Implicit substitution of 2 classes for 2 set variables. $)
    vtocl2ga $p |- ( ( A e. C /\ B e. D ) -> ch ) $=
      cB cD wcel cA cC wcel wch cA cC wcel wps wi cA cC wcel wch wi vy cB cD vy
      cv cB wceq wps wch cA cC wcel vtocl2ga.2 imbi2d cA cC wcel vy cv cD wcel
      wps vy cv cD wcel wph wi vy cv cD wcel wps wi vx cA cC vx cv cA wceq wph
      wps vy cv cD wcel vtocl2ga.1 imbi2d vx cv cC wcel vy cv cD wcel wph
      vtocl2ga.3 ex vtoclga com12 vtoclga impcom $.
      $( [20-Aug-1995] $)
  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.  $d x y z D $.
    $d x y z R $.  $d x y z S $.
    $d x ps $.  $d y ch $.  $d z th $.
    vtocl3ga.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl3ga.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl3ga.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    vtocl3ga.4 $e |- ( ( x e. D /\ y e. R /\ z e. S ) -> ph ) $.
    $( Implicit substitution of 3 classes for 3 set variables. $)
    vtocl3ga $p |- ( ( A e. D /\ B e. R /\ C e. S ) -> th ) $=
      cA cD wcel cB cR wcel cC cS wcel wth cB cR wcel cC cS wcel cA cD wcel wth
      cB cR wcel cC cS wcel cA cD wcel wth wi cA cD wcel wps wi cA cD wcel wch
      wi cA cD wcel wth wi vy vz cB cC cR cS vy cv cB wceq wps wch cA cD wcel
      vtocl3ga.2 imbi2d vz cv cC wceq wch wth cA cD wcel vtocl3ga.3 imbi2d cA
      cD wcel vy cv cR wcel vz cv cS wcel wa wps vy cv cR wcel vz cv cS wcel wa
      wph wi vy cv cR wcel vz cv cS wcel wa wps wi vx cA cD vx cv cA wceq wph
      wps vy cv cR wcel vz cv cS wcel wa vtocl3ga.1 imbi2d vx cv cD wcel vy cv
      cR wcel vz cv cS wcel wph vtocl3ga.4 3expib vtoclga com12 vtocl2ga ex
      com3r 3imp $.
      $( [20-Aug-1995] $)
  $}

  ${
    $d x A $.  $d x ph $.
    vtocleg.1 $e |- ( x = A -> ph ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtocleg $p |- ( A e. B -> ph ) $=
      cA cB wcel vx cv cA wceq vx wex wph vx cA cB elex vx cv cA wceq wph vx
      vtocleg.1 19.23aiv syl $.
      $( [10-Jan-2004] $) $( [10-Jan-2004] $)
  $}

  ${
    $d x A $.
    $( Implicit substitution of a class for a set variable.  (Closed theorem
       version of ~ vtoclef .) $)
    vtoclegft $p |- ( ( A e. B /\ A. x ( ph -> A. x ph ) /\
                   A. x ( x = A -> ph ) ) -> ph ) $=
      cA cB wcel wph wph vx wal wi vx wal vx cv cA wceq wph wi vx wal wph cA cB
      wcel wph wph vx wal wi vx wal wa vx cv cA wceq wph wi vx wal vx cv cA
      wceq vx wex wph wi wph wph wph vx wal wi vx wal vx cv cA wceq wph wi vx
      wal vx cv cA wceq vx wex wph wi wb cA cB wcel vx cv cA wceq wph vx 19.23t
      adantl cA cB wcel vx cv cA wceq vx wex wph wi wph wi wph wph vx wal wi vx
      wal cA cB wcel vx cv cA wceq vx wex vx cv cA wceq vx wex wph wi wph wi vx
      cA cB elex vx cv cA wceq vx wex wph pm2.27 syl adantr sylbid 3impia $.
      $( [9-Nov-2005] $) $( [7-Nov-2005] $)
  $}

  ${
    $d x A $.
    vtoclef.1 $e |- ( ph -> A. x ph ) $.
    vtoclef.2 $e |- A e. _V $.
    vtoclef.3 $e |- ( x = A -> ph ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclef $p |- ph $=
      vx cv cA wceq vx wex wph vx cA vtoclef.2 isseti vx cv cA wceq wph vx
      vtoclef.1 vtoclef.3 19.23ai ax-mp $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x ph $.
    vtocle.1 $e |- A e. _V $.
    vtocle.2 $e |- ( x = A -> ph ) $.
    $( Implicit substitution of a class for a set variable. $)
    vtocle $p |- ph $=
      cA cvv wcel wph vtocle.1 wph vx cA cvv vtocle.2 vtocleg ax-mp $.
      $( [9-Sep-1993] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    vtoclri.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclri.2 $e |- A. x e. B ph $.
    $( Implicit substitution of a class for a set variable. $)
    vtoclri $p |- ( A e. B -> ps ) $=
      wph wps vx cA cB vtoclri.1 wph vx cB vtoclri.2 rspec vtoclga $.
      $( [21-Nov-1994] $)
  $}

  ${
    $d x y $.  $d y A $.
    cla4gf.1 $e |- ( y e. A -> A. x y e. A ) $.
    cla4gf.2 $e |- ( ps -> A. x ps ) $.
    cla4gf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Rule of specialization, using implicit substitition.  Compare
       Theorem 7.3 of [Quine] p. 44. $)
    cla4gf $p |- ( A e. B -> ( A. x ph -> ps ) ) $=
      cA cB wcel cA cvv wcel wph vx wal wps wi cA cB elisset cA cvv wcel wph
      wps wi vx wex wph vx wal wps wi cA cvv wcel vx cv cA wceq vx wex wph wps
      wi vx wex cA cvv wcel vy cv cA wceq vy wex vx cv cA wceq vx wex vy cA
      isset vy cv cA wceq vx cv cA wceq vy vx vx vy cA cla4gf.1 hbeleq vx cv cA
      wceq vy ax-17 vy cv vx cv cA eqeq1 cbvex bitri vx cv cA wceq wph wps wi
      vx vx cv cA wceq wph wps cla4gf.3 biimpd 19.22i sylbi wph wps vx cla4gf.2
      19.36 sylib syl $.
      $( [2-Feb-1997] $)

    $( Existential specialization, using implicit substitition. $)
    cla4egf $p |- ( A e. B -> ( ps -> E. x ph ) ) $=
      cA cB wcel wps wph wn vx wal wn wph vx wex cA cB wcel wph wn vx wal wps
      wph wn wps wn vx vy cA cB cla4gf.1 wps vx cla4gf.2 hbn vx cv cA wceq wph
      wps cla4gf.3 notbid cla4gf con2d wph vx df-ex syl6ibr $.
      $( [2-Feb-1997] $)
  $}

  ${
    $d x ps $.  $d x y A $.
    cla4gv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Rule of specialization, using implicit substitition.  Compare
       Theorem 7.3 of [Quine] p. 44. $)
    cla4gv $p |- ( A e. B -> ( A. x ph -> ps ) ) $=
      wph wps vx vy cA cB vy cv cA wcel vx ax-17 wps vx ax-17 cla4gv.1 cla4gf
      $.
      $( [22-Jun-1994] $)

    $( Existential specialization, using implicit substitition. $)
    cla4egv $p |- ( A e. B -> ( ps -> E. x ph ) ) $=
      wph wps vx vy cA cB vy cv cA wcel vx ax-17 wps vx ax-17 cla4gv.1 cla4egf
      $.
      $( [14-Aug-1994] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    cla42egv.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Existential specialization with 2 quantifiers, using implicit
       substitution. $)
    cla42egv $p |- ( ( A e. C /\ B e. D ) -> ( ps -> E. x E. y ph ) ) $=
      wps vx cv cA wceq vy cv cB wceq wa vy wex vx wex wph vy wex vx wex cA cC
      wcel cB cD wcel wa wps vx cv cA wceq vy cv cB wceq wa wph vx vy vx cv cA
      wceq vy cv cB wceq wa wph wps cla42egv.1 biimprcd 19.22dvv cA cC wcel cB
      cD wcel wa vx cv cA wceq vx wex vy cv cB wceq vy wex wa vx cv cA wceq vy
      cv cB wceq wa vy wex vx wex cA cC wcel vx cv cA wceq vx wex cB cD wcel vy
      cv cB wceq vy wex vx cA cC elex vy cB cD elex anim12i vx cv cA wceq vy cv
      cB wceq vx vy eeanv sylibr syl5com $.
      $( [3-Aug-1995] $)

    $( Specialization with 2 quantifiers, using implicit substitution. $)
    cla42gv $p |- ( ( A e. C /\ B e. D ) -> ( A. x A. y ph -> ps ) ) $=
      cA cC wcel cB cD wcel wa wps wph vy wal vx wal cA cC wcel cB cD wcel wa
      wps wn wph wn vy wex vx wex wph vy wal vx wal wn wph wn wps wn vx vy cA
      cB cC cD vx cv cA wceq vy cv cB wceq wa wph wps cla42egv.1 notbid
      cla42egv wph wn vy wex vx wex wph vy wal wn vx wex wph vy wal vx wal wn
      wph wn vy wex wph vy wal wn vx wph vy exnal exbii wph vy wal vx exnal
      bitr2i syl6ibr con4d $.
      $( [13-May-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z ps $.
    cla43egv.1 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    $( Existential specialization with 3 quantifiers, using implicit
       substitution. $)
    cla43egv $p |- ( ( A e. R /\ B e. S /\ C e. T ) ->
               ( ps -> E. x E. y E. z ph ) ) $=
      wps vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a vz wex vy wex vx wex
      wph vz wex vy wex vx wex cA cR wcel cB cS wcel cC cT wcel w3a wps vx cv
      cA wceq vy cv cB wceq vz cv cC wceq w3a vz wex wph vz wex vx vy wps vx cv
      cA wceq vy cv cB wceq vz cv cC wceq w3a wph vz vx cv cA wceq vy cv cB
      wceq vz cv cC wceq w3a wph wps cla43egv.1 biimprcd 19.22dv 19.22dvv cA cR
      wcel cB cS wcel cC cT wcel w3a vx cv cA wceq vx wex vy cv cB wceq vy wex
      vz cv cC wceq vz wex w3a vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a vz
      wex vy wex vx wex cA cR wcel vx cv cA wceq vx wex cB cS wcel vy cv cB
      wceq vy wex cC cT wcel vz cv cC wceq vz wex vx cA cR elex vy cB cS elex
      vz cC cT elex 3anim123i vx cv cA wceq vy cv cB wceq vz cv cC wceq vx vy
      vz eeeanv sylibr syl5com $.
      $( [12-May-2008] $) $( [12-May-2008] $)

    $( Specialization with 3 quantifiers, using implicit substitution. $)
    cla43gv $p |- ( ( A e. R /\ B e. S /\ C e. T ) ->
               ( A. x A. y A. z ph -> ps ) ) $=
      cA cR wcel cB cS wcel cC cT wcel w3a wps wph vz wal vy wal vx wal cA cR
      wcel cB cS wcel cC cT wcel w3a wps wn wph wn vz wex vy wex vx wex wph vz
      wal vy wal vx wal wn wph wn wps wn vx vy vz cA cB cC cR cS cT vx cv cA
      wceq vy cv cB wceq vz cv cC wceq w3a wph wps cla43egv.1 notbid cla43egv
      wph wn vz wex vy wex vx wex wph vz wal vy wal wn vx wex wph vz wal vy wal
      vx wal wn wph wn vz wex vy wex wph vz wal vy wal wn vx wph wn vz wex vy
      wex wph vz wal wn vy wex wph vz wal vy wal wn wph wn vz wex wph vz wal wn
      vy wph vz exnal exbii wph vz wal vy exnal bitri exbii wph vz wal vy wal
      vx exnal bitr2i syl6ibr con4d $.
      $( [15-May-2008] $) $( [12-May-2008] $)
  $}

  ${
    $d x A $.  $d x ps $.
    cla4v.1 $e |- A e. _V $.
    cla4v.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Rule of specialization, using implicit substitition. $)
    cla4v $p |- ( A. x ph -> ps ) $=
      cA cvv wcel wph vx wal wps wi cla4v.1 wph wps vx cA cvv cla4v.2 cla4gv
      ax-mp $.
      $( [22-Jun-1994] $)

    $( Existential specialization, using implicit substitition.  (The proof was
       shortened by Eric Schmidt, 22-Dec-2006.) $)
    cla4ev $p |- ( ps -> E. x ph ) $=
      cA cvv wcel wps wph vx wex wi cla4v.1 wph wps vx cA cvv cla4v.2 cla4egv
      ax-mp $.
      $( [22-Dec-2006] $) $( [31-Dec-1993] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    cla4e2v.1 $e |- A e. _V $.
    cla4e2v.2 $e |- B e. _V $.
    cla4e2v.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Existential specialization, using implicit substitition. $)
    cla42ev $p |- ( ps -> E. x E. y ph ) $=
      cA cvv wcel cB cvv wcel wps wph vy wex vx wex wi cla4e2v.1 cla4e2v.2 wph
      wps vx vy cA cB cvv cvv cla4e2v.3 cla42egv mp2an $.
      $( [3-Aug-1995] $)
  $}

  ${
    $d x y A $.  $d x B $.
    rcla4.1 $e |- ( ps -> A. x ps ) $.
    rcla4.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Restricted specialization, using implicit substitition. $)
    rcla4 $p |- ( A e. B -> ( A. x e. B ph -> ps ) ) $=
      wph vx cB wral cA cB wcel wps wph vx cB wral vx cv cB wcel wph wi vx wal
      cA cB wcel wps wi wph vx cB df-ral vx cv cB wcel wph wi vx wal cA cB wcel
      wps vx cv cB wcel wph wi cA cB wcel wps wi vx vy cA cB vy cv cA wcel vx
      ax-17 cA cB wcel wps vx cA cB wcel vx ax-17 rcla4.1 hbim vx cv cA wceq vx
      cv cB wcel cA cB wcel wph wps vx cv cA cB eleq1 rcla4.2 imbi12d cla4gf
      pm2.43b sylbi com12 $.
      $( [24-May-2005] $) $( [19-Apr-2005] $)

    $( Restricted existential specialization, using implicit substitition. $)
    rcla4e $p |- ( ( A e. B /\ ps ) -> E. x e. B ph ) $=
      cA cB wcel wps wa vx cv cB wcel wph wa vx wex wph vx cB wrex cA cB wcel
      wps vx cv cB wcel wph wa vx wex vx cv cB wcel wph wa cA cB wcel wps wa vx
      vy cA cB vy cv cA wcel vx ax-17 cA cB wcel wps vx cA cB wcel vx ax-17
      rcla4.1 hban vx cv cA wceq vx cv cB wcel cA cB wcel wph wps vx cv cA cB
      eleq1 rcla4.2 anbi12d cla4egf anabsi5 wph vx cB df-rex sylibr $.
      $( [26-May-1998] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    rcla4v.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Restricted specialization, using implicit substitition. $)
    rcla4v $p |- ( A e. B -> ( A. x e. B ph -> ps ) ) $=
      wph wps vx cA cB wps vx ax-17 rcla4v.1 rcla4 $.
      $( [24-May-2005] $) $( [26-May-1998] $)

    $( Restricted specialization, using implicit substitition. $)
    rcla4cv $p |- ( A. x e. B ph -> ( A e. B -> ps ) ) $=
      cA cB wcel wph vx cB wral wps wph wps vx cA cB rcla4v.1 rcla4v com12 $.
      $( [4-Feb-2006] $) $( [2-Feb-2006] $)

    $( Restricted specialization, using implicit substitition. $)
    rcla4va $p |- ( ( A e. B /\ A. x e. B ph ) -> ps ) $=
      cA cB wcel wph vx cB wral wps wph wps vx cA cB rcla4v.1 rcla4v imp $.
      $( [15-Sep-2005] $) $( [13-Sep-2005] $)

    $( Restricted specialization, using implicit substitition. $)
    rcla4cva $p |- ( ( A. x e. B ph /\ A e. B ) -> ps ) $=
      cA cB wcel wph vx cB wral wps wph wps vx cA cB rcla4v.1 rcla4va ancoms $.
      $( [27-Jul-2006] $) $( [26-Jul-2006] $)

    $( Restricted existential specialization, using implicit substitition. $)
    rcla4ev $p |- ( ( A e. B /\ ps ) -> E. x e. B ph ) $=
      wph wps vx cA cB wps vx ax-17 rcla4v.1 rcla4e $.
      $( [26-May-1998] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.  $d x ch $.
    rcla4dv.1 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Restricted specialization, using implicit substitition. $)
    rcla4dv $p |- ( ( ph /\ A e. B ) -> ( A. x e. B ps -> ch ) ) $=
      cA cB wcel wph wps vx cB wral wch wi cA cB wcel wph wps vx cB wral wch cA
      cB wcel wph wps wi vx cB wral wph wch wi wph wps vx cB wral wi wph wps wi
      wph wch wi vx cA cB vx cv cA wceq wph wps wch wph vx cv cA wceq wps wch
      wb rcla4dv.1 expcom pm5.74d rcla4v wph wps vx cB r19.21v syl5ibr pm2.86d
      impcom $.
      $( [18-Feb-2007] $) $( [17-Feb-2007] $)

    $( Restricted existential specialization, using implicit substitition.
       (Contributed by FL, 17-Apr-2007.) $)
    rcla4edv $p |- ( ( ph /\ A e. B ) -> ( ch -> E. x e. B ps ) ) $=
      cA cB wcel wph wch wps vx cB wrex wi cA cB wcel wph wch wps vx cB wrex cA
      cB wcel wph wch wi wph wps vx cB wrex wi cA cB wcel wph wch wi wa wph wps
      wi vx cB wrex wph wps vx cB wrex wi wph wps wi wph wch wi vx cA cB vx cv
      cA wceq wph wps wch wph vx cv cA wceq wps wch wb rcla4dv.1 expcom pm5.74d
      rcla4ev wph wps vx cB r19.37av syl ex pm2.86d impcom $.
      $( [10-May-2008] $) $( [17-Apr-2007] $)
  $}

  ${
    $d x y A $.  $d x C $.  $d x D $.  $d y B $.  $d y D $.  $d x ch $.
    $d y ps $.
    rcla42v.1 $e |- ( x = A -> ( ph <-> ch ) ) $.
    rcla42v.2 $e |- ( y = B -> ( ch <-> ps ) ) $.
    $( 2-variable restricted specialization, using implicit substitition. $)
    rcla42v $p |- ( ( A e. C /\ B e. D ) -> ( A. x e. C A. y e. D ph ->
                  ps ) ) $=
      cA cC wcel wph vy cD wral vx cC wral wch vy cD wral cB cD wcel wps wph vy
      cD wral wch vy cD wral vx cA cC vx cv cA wceq wph wch vy cD rcla42v.1
      ralbidv rcla4v wch wps vy cB cD rcla42v.2 rcla4v sylan9 $.
      $( [24-May-2005] $) $( [13-Sep-1999] $)

    $( 2-variable restricted existential specialization, using implicit
       substitution. $)
    rcla42ev $p |- ( ( A e. C /\ B e. D /\ ps ) -> E. x e. C E. y e. D ph ) $=
      cA cC wcel cB cD wcel wps w3a cA cC wcel wch vy cD wrex wa wph vy cD wrex
      vx cC wrex cA cC wcel cB cD wcel wps cA cC wcel wch vy cD wrex wa cB cD
      wcel wps wa wch vy cD wrex cA cC wcel wch wps vy cB cD rcla42v.2 rcla4ev
      anim2i 3impb wph vy cD wrex wch vy cD wrex vx cA cC vx cv cA wceq wph wch
      vy cD rcla42v.1 rexbidv rcla4ev syl $.
      $( [13-Feb-2007] $) $( [16-Oct-1999] $)
  $}

  ${
    $d z ps $.  $d x ch $.  $d y th $.  $d x y z A $.  $d y z B $.  $d z C $.
    $d x R $.  $d x y S $.  $d x y z T $.
    rcla43v.1 $e |- ( x = A -> ( ph <-> ch ) ) $.
    rcla43v.2 $e |- ( y = B -> ( ch <-> th ) ) $.
    rcla43v.3 $e |- ( z = C -> ( th <-> ps ) ) $.
    $( 3-variable restricted specialization, using implicit substitition. $)
    rcla43v $p |- ( ( A e. R /\ B e. S /\ C e. T ) ->
                  ( A. x e. R A. y e. S A. z e. T ph -> ps ) ) $=
      cA cR wcel cB cS wcel cC cT wcel wph vz cT wral vy cS wral vx cR wral wps
      wi cA cR wcel cB cS wcel wa wph vz cT wral vy cS wral vx cR wral wth vz
      cT wral cC cT wcel wps wph vz cT wral wth vz cT wral wch vz cT wral vx vy
      cA cB cR cS vx cv cA wceq wph wch vz cT rcla43v.1 ralbidv vy cv cB wceq
      wch wth vz cT rcla43v.2 ralbidv rcla42v wth wps vz cC cT rcla43v.3 rcla4v
      sylan9 3impa $.
      $( [1-Jun-2005] $) $( [10-May-2005] $)
  $}

  ${
    $d x A y z $.  $d x B y z $.
    eqvinc.1 $e |- A e. _V $.
    $( A variable introduction law for class equality. $)
    eqvinc $p |- ( A = B <-> E. x ( x = A /\ x = B ) ) $=
      cA cB wceq cB cvv wcel vx cv cA wceq vx cv cB wceq wa vx wex cA cB wceq
      cA cvv wcel cB cvv wcel eqvinc.1 cA cB cvv eleq1 mpbii vx cv cA wceq vx
      cv cB wceq wa cB cvv wcel vx vx cv cB wceq cB cvv wcel vx cv cA wceq vx
      cv cB wceq vx cv cvv wcel cB cvv wcel vx visset vx cv cB cvv eleq1 mpbii
      adantl 19.23aiv cA vz cv wceq vx cv cA wceq vx cv vz cv wceq wa vx wex cA
      cB wceq vx cv cA wceq vx cv cB wceq wa vx wex vz cB cvv vz cv cB cA eqeq2
      vz cv cB wceq vx cv cA wceq vx cv vz cv wceq wa vx cv cA wceq vx cv cB
      wceq wa vx vz cv cB wceq vx cv vz cv wceq vx cv cB wceq vx cv cA wceq vz
      cv cB vx cv eqeq2 anbi2d exbidv vy cv vz cv wceq vy cv vx cv wceq vx cv
      vz cv wceq wa vx wex cA vz cv wceq vx cv cA wceq vx cv vz cv wceq wa vx
      wex vy cA eqvinc.1 vy cv cA vz cv eqeq1 vy cv cA wceq vy cv vx cv wceq vx
      cv vz cv wceq wa vx cv cA wceq vx cv vz cv wceq wa vx vy cv cA wceq vy cv
      vx cv wceq vx cv cA wceq vx cv vz cv wceq vy cv cA wceq vy cv vx cv wceq
      cA vx cv wceq vx cv cA wceq vy cv cA vx cv eqeq1 cA vx cv eqcom syl6bb
      anbi1d exbidv vy vz vx equvin vtoclb vtoclbg pm5.21nii $.
      $( [14-Apr-1995] $)
  $}

  ${
    $d A y $.  $d B y $.  $d x y $.
    eqvincf.1 $e |- ( y e. A -> A. x y e. A ) $.
    eqvincf.2 $e |- ( y e. B -> A. x y e. B ) $.
    eqvincf.3 $e |- A e. _V $.
    $( A variable introduction law for class equality, using bound-variable
       hypotheses instead of distinct variable conditions. $)
    eqvincf $p |- ( A = B <-> E. x ( x = A /\ x = B ) ) $=
      cA cB wceq vy cv cA wceq vy cv cB wceq wa vy wex vx cv cA wceq vx cv cB
      wceq wa vx wex vy cA cB eqvincf.3 eqvinc vy cv cA wceq vy cv cB wceq wa
      vx cv cA wceq vx cv cB wceq wa vy vx vy cv cA wceq vy cv cB wceq vx vx vy
      cA eqvincf.1 hbeleq vx vy cB eqvincf.2 hbeleq hban vx cv cA wceq vx cv cB
      wceq wa vy ax-17 vy cv vx cv wceq vy cv cA wceq vx cv cA wceq vy cv cB
      wceq vx cv cB wceq vy cv vx cv cA eqeq1 vy cv vx cv cB eqeq1 anbi12d
      cbvex bitri $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d x A y $.  $d ph y $.
    alexeq.1 $e |- A e. _V $.
    $( Two ways to express substitution of ` A ` for ` x ` in ` ph ` . $)
    alexeq $p |- ( A. x ( x = A -> ph ) <-> E. x ( x = A /\ ph ) ) $=
      vx cv cA wceq wph wa vx wex vx cv cA wceq wph wi vx wal vx cv vy cv wceq
      wph wa vx wex vx cv vy cv wceq wph wi vx wal vx cv cA wceq wph wa vx wex
      vx cv cA wceq wph wi vx wal vy cA alexeq.1 vy cv cA wceq vx cv vy cv wceq
      wph wa vx cv cA wceq wph wa vx vy cv cA wceq vx cv vy cv wceq vx cv cA
      wceq wph vy cv cA vx cv eqeq2 anbi1d exbidv vy cv cA wceq vx cv vy cv
      wceq wph wi vx cv cA wceq wph wi vx vy cv cA wceq vx cv vy cv wceq vx cv
      cA wceq wph vy cv cA vx cv eqeq2 imbi1d albidv wph vx vy sb56 vtoclb
      bicomi $.
      $( [2-Mar-1995] $)
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Equality implies equivalence with substitution. $)
    ceqex $p |- ( x = A -> ( ph <-> E. x ( x = A /\ ph ) ) ) $=
      cA cvv wcel vx cv cA wceq wph vx cv cA wceq wph wa vx wex wb vx cv cA
      wceq vx cv cA wceq vx wex cA cvv wcel vx cv cA wceq vx 19.8a vx cA isset
      sylibr vx cv vy cv wceq wph vx cv vy cv wceq wph wa vx wex wb wi vx cv cA
      wceq wph vx cv cA wceq wph wa vx wex wb wi vy cA cvv vy cv cA wceq vx cv
      vy cv wceq vx cv cA wceq wph vx cv vy cv wceq wph wa vx wex wb wph vx cv
      cA wceq wph wa vx wex wb vy cv cA vx cv eqeq2 vy cv cA wceq vx cv vy cv
      wceq wph wa vx wex vx cv cA wceq wph wa vx wex wph vy cv cA wceq vx cv vy
      cv wceq wph wa vx cv cA wceq wph wa vx vy cv cA wceq vx cv vy cv wceq vx
      cv cA wceq wph vy cv cA vx cv eqeq2 anbi1d exbidv bibi2d imbi12d vx cv vy
      cv wceq wph vx cv vy cv wceq wph wa vx wex vx cv vy cv wceq wph vx cv vy
      cv wceq wph wa vx wex vx cv vy cv wceq wph wa vx 19.8a ex vx cv vy cv
      wceq vx cv vy cv wceq wph wi vx wal wph vx cv vy cv wceq wph wa vx wex vx
      cv vy cv wceq wph wi vx wal vx cv vy cv wceq wph vx cv vy cv wceq wph wi
      vx ax-4 com12 wph vx vy cv vy visset alexeq syl5ibr impbid vtoclg mpcom
      $.
      $( [2-Mar-1995] $)
  $}

  ${
    $d x y A $.
    ceqsexg.1 $e |- ( ps -> A. x ps ) $.
    ceqsexg.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis. $)
    ceqsexg $p |- ( A e. B -> ( E. x ( x = A /\ ph ) <-> ps ) ) $=
      wph wph wb vx cv cA wceq wph wa vx wex wps wb vx vy cA cB vy cv cA wcel
      vx ax-17 vx cv cA wceq wph wa vx wex wps vx vx cv cA wceq wph wa vx hbe1
      ceqsexg.1 hbbi vx cv cA wceq wph vx cv cA wceq wph wa vx wex wph wps wph
      vx cA ceqex ceqsexg.2 bibi12d wph biid vtoclgf $.
      $( [13-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    $d x y A $.  $d x ps $.
    ceqsexgv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of an existential quantifier, using implicit
       substitution. $)
    ceqsexgv $p |- ( A e. B -> ( E. x ( x = A /\ ph ) <-> ps ) ) $=
      wph wps vx cA cB wps vx ax-17 ceqsexgv.1 ceqsexg $.
      $( [29-Dec-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    ceqsrexv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of a restricted existential quantifier, using implicit
       substitution. $)
    ceqsrexv $p |- ( A e. B -> ( E. x e. B ( x = A /\ ph ) <-> ps ) ) $=
      cA cB wcel vx cv cA wceq vx cv cB wcel wph wa wa vx wex wps vx cv cA wceq
      wph wa vx cB wrex cA cB wcel vx cv cA wceq vx cv cB wcel wph wa wa vx wex
      wps vx cv cB wcel wph wa cA cB wcel wps wa vx cA cB vx cv cA wceq vx cv
      cB wcel cA cB wcel wph wps vx cv cA cB eleq1 ceqsrexv.1 anbi12d ceqsexgv
      bianabs vx cv cA wceq wph wa vx cB wrex vx cv cB wcel vx cv cA wceq wph
      wa wa vx wex vx cv cA wceq vx cv cB wcel wph wa wa vx wex vx cv cA wceq
      wph wa vx cB df-rex vx cv cA wceq vx cv cB wcel wph wa wa vx cv cB wcel
      vx cv cA wceq wph wa wa vx vx cv cA wceq vx cv cB wcel wph an12 exbii
      bitr4i syl5bb $.
      $( [13-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.  $d x y D $.  $d x ps $.  $d y ch $.
    ceqsrex2v.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsrex2v.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Elimination of a restricted existential quantifier, using implicit
       substitution. $)
    ceqsrex2v $p |- ( ( A e. C /\ B e. D ) ->
      ( E. x e. C E. y e. D ( ( x = A /\ y = B ) /\ ph ) <-> ch ) ) $=
      cA cC wcel vx cv cA wceq vy cv cB wceq wa wph wa vy cD wrex vx cC wrex vy
      cv cB wceq wps wa vy cD wrex cB cD wcel wch cA cC wcel vx cv cA wceq vy
      cv cB wceq wph wa vy cD wrex wa vx cC wrex vy cv cB wceq wps wa vy cD
      wrex vx cv cA wceq vy cv cB wceq wa wph wa vy cD wrex vx cC wrex vy cv cB
      wceq wph wa vy cD wrex vy cv cB wceq wps wa vy cD wrex vx cA cC vx cv cA
      wceq vy cv cB wceq wph wa vy cv cB wceq wps wa vy cD vx cv cA wceq wph
      wps vy cv cB wceq ceqsrex2v.1 anbi2d rexbidv ceqsrexv vx cv cA wceq vy cv
      cB wceq wa wph wa vy cD wrex vx cv cA wceq vy cv cB wceq wph wa vy cD
      wrex wa vx cC vx cv cA wceq vy cv cB wceq wa wph wa vy cD wrex vx cv cA
      wceq vy cv cB wceq wph wa wa vy cD wrex vx cv cA wceq vy cv cB wceq wph
      wa vy cD wrex wa vx cv cA wceq vy cv cB wceq wa wph wa vx cv cA wceq vy
      cv cB wceq wph wa wa vy cD vx cv cA wceq vy cv cB wceq wph anass rexbii
      vx cv cA wceq vy cv cB wceq wph wa vy cD r19.42v bitri rexbii syl5bb wps
      wch vy cB cD ceqsrex2v.2 ceqsrexv sylan9bb $.
      $( [1-Nov-2005] $) $( [29-Oct-2005] $)
  $}

  ${
    $d x A $.  $d x B $.
    clel2.1 $e |- A e. _V $.
    $( An alternate definition of class membership when the class is a set. $)
    clel2 $p |- ( A e. B <-> A. x ( x = A -> x e. B ) ) $=
      vx cv cA wceq vx cv cB wcel wi vx wal cA cB wcel vx cv cB wcel cA cB wcel
      vx cA clel2.1 vx cv cA cB eleq1 ceqsalv bicomi $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( An alternate definition of class membership when the class is a set. $)
    clel3g $p |- ( B e. C -> ( A e. B <-> E. x ( x = B /\ A e. x ) ) ) $=
      cB cC wcel vx cv cB wceq cA vx cv wcel wa vx wex cA cB wcel cA vx cv wcel
      cA cB wcel vx cB cC vx cv cB cA eleq2 ceqsexgv bicomd $.
      $( [15-Aug-2005] $) $( [13-Aug-2005] $)
  $}

  ${
    $d x A $.  $d x B $.
    clel3.1 $e |- B e. _V $.
    $( An alternate definition of class membership when the class is a set. $)
    clel3 $p |- ( A e. B <-> E. x ( x = B /\ A e. x ) ) $=
      cB cvv wcel cA cB wcel vx cv cB wceq cA vx cv wcel wa vx wex wb clel3.1
      vx cA cB cvv clel3g ax-mp $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    clel4.1 $e |- B e. _V $.
    $( An alternate definition of class membership when the class is a set. $)
    clel4 $p |- ( A e. B <-> A. x ( x = B -> A e. x ) ) $=
      vx cv cB wceq cA vx cv wcel wi vx wal cA cB wcel cA vx cv wcel cA cB wcel
      vx cB clel4.1 vx cv cB cA eleq2 ceqsalv bicomi $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x y A $.  $d y ph $.  $d x ps $.
    $( Membership in a class abstraction, using implicit substitition.  (Closed
       theorem version of ~ elabg .) $)
    elabgt $p |- ( ( A e. B /\ A. x ( x = A -> ( ph <-> ps ) ) ) ->
                 ( A e. { x | ph } <-> ps ) ) $=
      cA cB wcel vx cv cA wceq cA wph vx cab wcel wps wb wi vx wal cA wph vx
      cab wcel wps wb vx cv cA wceq wph wps wb wi vx wal cA cB wcel cA wph vx
      cab wcel wps wb cA wph vx cab wcel wps wb vx wal wi vx wal vx cv cA wceq
      cA wph vx cab wcel wps wb wi vx wal cA wph vx cab wcel wps wb cA wph vx
      cab wcel wps wb cA wph vx cab wcel wps wb vx wal wi vx cA wph vx cab wcel
      wps vx vx vy vy cA wph vx cab vy cv cA wcel vx ax-17 wph vx vy hbab1 hbel
      wps vx ax-17 hbbi ax-gen cA wph vx cab wcel wps wb vx cA cB vtoclegft
      mp3an2 vx cv cA wceq wph wps wb wi vx cv cA wceq cA wph vx cab wcel wps
      wb wi vx vx cv cA wceq wph wps wb cA wph vx cab wcel wps wb vx cv cA wceq
      cA wph vx cab wcel wps wb wph wps wb vx cv cA wceq cA wph vx cab wcel wph
      wps vx cv cA wceq vx cv wph vx cab wcel cA wph vx cab wcel wph vx cv cA
      wph vx cab eleq1 wph vx abid syl5rbbr bibi1d biimprd a2i 19.20i sylan2 $.
      $( [10-Nov-2005] $) $( [7-Nov-2005] $)
  $}

  ${
    $d ps y $.  $d x A y $.  $d y ph $.
    elabf.1 $e |- ( ps -> A. x ps ) $.
    elabf.2 $e |- A e. _V $.
    elabf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitition. $)
    elabf $p |- ( A e. { x | ph } <-> ps ) $=
      cA wph vx cab wcel wps wb vx cA cA wph vx cab wcel wps vx vx vy vy cA wph
      vx cab vy cv cA wcel vx ax-17 wph vx vy hbab1 hbel elabf.1 hbbi elabf.2
      vx cv cA wceq wph cA wph vx cab wcel wps vx cv cA wceq vx cv wph vx cab
      wcel cA wph vx cab wcel wph vx cv cA wph vx cab eleq1 wph vx abid syl5bbr
      elabf.3 bitr3d vtoclef $.
      $( [1-Aug-1994] $)
  $}

  ${
    $d x ps $.  $d x A $.
    elab.1 $e |- A e. _V $.
    elab.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitition.  Compare
       Theorem 6.13 of [Quine] p. 44. $)
    elab $p |- ( A e. { x | ph } <-> ps ) $=
      wph wps vx cA wps vx ax-17 elab.1 elab.2 elabf $.
      $( [1-Aug-1994] $)
  $}

  ${
    $d y A $.  $d z ph $.  $d x y z $.
    elabgf.1 $e |- ( y e. A -> A. x y e. A ) $.
    elabgf.2 $e |- ( ps -> A. x ps ) $.
    elabgf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitition.  Compare
       Theorem 6.13 of [Quine] p. 44.  This version has bound-variable
       hypotheses in place of distinct variable restrictions. $)
    elabgf $p |- ( A e. B -> ( A e. { x | ph } <-> ps ) ) $=
      vx cv wph vx cab wcel wph wb cA wph vx cab wcel wps wb vx vy cA cB
      elabgf.1 cA wph vx cab wcel wps vx vx vy vz cA wph vx cab elabgf.1 wph vx
      vz hbab1 hbel elabgf.2 hbbi vx cv cA wceq vx cv wph vx cab wcel cA wph vx
      cab wcel wph wps vx cv cA wph vx cab eleq1 elabgf.3 bibi12d wph vx abid
      vtoclgf $.
      $( [21-Sep-2003] $)
  $}

  ${
    $d x ps $.  $d x y A $.
    elabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitition.  Compare
       Theorem 6.13 of [Quine] p. 44. $)
    elabg $p |- ( A e. B -> ( A e. { x | ph } <-> ps ) ) $=
      wph wps vx vy cA cB vy cv cA wcel vx ax-17 wps vx ax-17 elabg.1 elabgf $.
      $( [14-Apr-1995] $)
  $}

  ${
    $d x ps $.  $d x A $.
    elab2g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elab2g.2 $e |- B = { x | ph } $.
    $( Membership in a class abstraction, using implicit substitution. $)
    elab2g $p |- ( A e. C -> ( A e. B <-> ps ) ) $=
      cA cC wcel cA wph vx cab wcel wps cA cB wcel wph wps vx cA cC elab2g.1
      elabg cB wph vx cab cA elab2g.2 eleq2i syl5bb $.
      $( [12-Sep-2004] $) $( [13-Sep-1995] $)
  $}

  ${
    $d x ps $.  $d x A $.
    elab2.1 $e |- A e. _V $.
    elab2.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elab2.3 $e |- B = { x | ph } $.
    $( Membership in a class abstraction, using implicit substitution. $)
    elab2 $p |- ( A e. B <-> ps ) $=
      cA cvv wcel cA cB wcel wps wb elab2.1 wph wps vx cA cB cvv elab2.2
      elab2.3 elab2g ax-mp $.
      $( [12-Sep-2004] $) $( [13-Sep-1995] $)
  $}

  ${
    $d x ps $.  $d x A $.
    elab3g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, with a weaker antecedent than
       ~ elabg . $)
    elab3g $p |- ( ( ps -> A e. B ) -> ( A e. { x | ph } <-> ps ) ) $=
      wps cA cB wcel wi cA wph vx cab wcel wps cA wph vx cab wcel wps wph wps
      vx cA wph vx cab elab3g.1 elabg ibi wps cA cB wcel wi wps cA wph vx cab
      wcel wps wb wi wps cA wph vx cab wcel wi cA cB wcel cA wph vx cab wcel
      wps wb wps wph wps vx cA cB elab3g.1 elabg imim2i wps cA wph vx cab wcel
      ibibr sylibr impbid2 $.
      $( [30-Aug-2006] $) $( [29-Aug-2006] $)
  $}

  ${
    $d x ps $.  $d x A $.
    elab3.1 $e |- ( ps -> A e. _V ) $.
    elab3.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction using implicit substitution. $)
    elab3 $p |- ( A e. { x | ph } <-> ps ) $=
      wps cA cvv wcel wi cA wph vx cab wcel wps wb elab3.1 wph wps vx cA cvv
      elab3.2 elab3g ax-mp $.
      $( [10-Nov-2000] $)
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    elrabf.1 $e |- ( y e. A -> A. x y e. A ) $.
    elrabf.2 $e |- ( y e. B -> A. x y e. B ) $.
    elrabf.3 $e |- ( ps -> A. x ps ) $.
    elrabf.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a restricted class abstraction, using implicit
       substitution.  This version has bound-variable hypotheses in place of
       distinct variable restrictions. $)
    elrabf $p |- ( A e. { x e. B | ph } <-> ( A e. B /\ ps ) ) $=
      cA wph vx cB crab wcel cA cvv wcel cA cB wcel wps wa cA wph vx cB crab
      elisset cA cB wcel cA cvv wcel wps cA cB elisset adantr cA cvv wcel cA vx
      cv cB wcel wph wa vx cab wcel cA cB wcel wps wa cA wph vx cB crab wcel vx
      cv cB wcel wph wa cA cB wcel wps wa vx vy cA cvv elrabf.1 cA cB wcel wps
      vx vx vy vy cA cB elrabf.1 elrabf.2 hbel elrabf.3 hban vx cv cA wceq vx
      cv cB wcel cA cB wcel wph wps vx cv cA cB eleq1 elrabf.4 anbi12d elabgf
      wph vx cB crab vx cv cB wcel wph wa vx cab cA wph vx cB df-rab eleq2i
      syl5bb pm5.21nii $.
      $( [21-Sep-2003] $)
  $}

  ${
    $d x ps $.  $d x y A $.  $d x y B $.
    elrab.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a restricted class abstraction, using implicit
       substitution. $)
    elrab $p |- ( A e. { x e. B | ph } <-> ( A e. B /\ ps ) ) $=
      wph wps vx vy cA cB vy cv cA wcel vx ax-17 vy cv cB wcel vx ax-17 wps vx
      ax-17 elrab.1 elrabf $.
      $( [21-May-1999] $)

    $( Membership in a restricted class abstraction, using implicit
       substitution. $)
    elrab3 $p |- ( A e. B -> ( A e. { x e. B | ph } <-> ps ) ) $=
      cA wph vx cB crab wcel cA cB wcel wps wph wps vx cA cB elrab.1 elrab baib
      $.
      $( [6-Oct-2006] $) $( [5-Oct-2006] $)
  $}

  ${
    $d x ps $.  $d x y A $.  $d x y B $.
    elrab2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elrab2.2 $e |- C = { x e. B | ph } $.
    $( Membership in a class abstraction, using implicit substitution. $)
    elrab2 $p |- ( A e. C <-> ( A e. B /\ ps ) ) $=
      cA cC wcel cA wph vx cB crab wcel cA cB wcel wps wa cC wph vx cB crab cA
      elrab2.2 eleq2i wph wps vx cA cB elrab2.1 elrab bitri $.
      $( [3-Nov-2006] $) $( [2-Nov-2006] $)
  $}

  ${
    $d x y z $.  $d z ph $.  $d z ps $.
    cbvab.1 $e |- ( ph -> A. y ph ) $.
    cbvab.2 $e |- ( ps -> A. x ps ) $.
    cbvab.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution. $)
    cbvab $p |- { x | ph } = { y | ps } $=
      wph vx cab wps vy cab wceq vy cv wph vx cab wcel vy cv wps vy cab wcel wb
      vy vy vz wph vx cab wps vy cab wph vy vx vz cbvab.1 hbab wps vy vz hbab1
      cleqf vy cv wph vx cab wcel wps vy cv wps vy cab wcel wph wps vx vy cv
      cbvab.2 vy visset cbvab.3 elabf wps vy abid bitr4i mpgbir $.
      $( [8-Mar-1995] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    cbvabv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution. $)
    cbvabv $p |- { x | ph } = { y | ps } $=
      wph wps vx vy wph vy ax-17 wps vx ax-17 cbvabv.1 cbvab $.
      $( [26-May-1999] $)
  $}

  ${
    $d x y z $.  $d z A $.
    cbvrab.1 $e |- ( z e. A -> A. x z e. A ) $.
    cbvrab.2 $e |- ( z e. A -> A. y z e. A ) $.
    cbvrab.3 $e |- ( ph -> A. y ph ) $.
    cbvrab.4 $e |- ( ps -> A. x ps ) $.
    cbvrab.5 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule to change the bound variable in a restricted class abstraction,
       using implicit substitution.  This version has bound-variable hypotheses
       in place of distinct variable conditions. $)
    cbvrab $p |- { x e. A | ph } = { y e. A | ps } $=
      vx cv cA wcel wph wa vx cab vy cv cA wcel wps wa vy cab wph vx cA crab
      wps vy cA crab vx cv cA wcel wph wa vy cv cA wcel wps wa vx vy vx cv cA
      wcel wph vy vy vz vz vx cv cA vz cv vx cv wcel vy ax-17 cbvrab.2 hbel
      cbvrab.3 hban vy cv cA wcel wps vx vx vz vz vy cv cA vz cv vy cv wcel vx
      ax-17 cbvrab.1 hbel cbvrab.4 hban vx cv vy cv wceq vx cv cA wcel vy cv cA
      wcel wph wps vx cv vy cv cA eleq1 cbvrab.5 anbi12d cbvab wph vx cA df-rab
      wps vy cA df-rab 3eqtr4i $.
      $( [26-Sep-2003] $)
  $}

  ${
    $d x y z A $.  $d y ph $.  $d x ps $.
    cbvrabv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule to change the bound variable in a restricted class abstraction,
       using implicit substitution. $)
    cbvrabv $p |- { x e. A | ph } = { y e. A | ps } $=
      wph wps vx vy vz cA vz cv cA wcel vx ax-17 vz cv cA wcel vy ax-17 wph vy
      ax-17 wps vx ax-17 cbvrabv.1 cbvrab $.
      $( [26-May-1999] $)
  $}

  ${
    $d y z A $.  $d x y z $.
    $( Identity used to create closed-form versions of bound-variable
       hypothesis builders for class expressions. $)
    abidhb $p |- ( A. y ( y e. A -> A. x y e. A ) ->
                 { z | A. x z e. A } = A ) $=
      vy cv cA wcel vy cv cA wcel vx wal wi vy wal vy cv cA wcel vx wal vy cab
      vy cv cA wcel vy cab vz cv cA wcel vx wal vz cab cA vy cv cA wcel vy cv
      cA wcel vx wal wi vy wal vy cv cA wcel vx wal vy cv cA wcel vy vy cv cA
      wcel vy cv cA wcel vx wal wi vy hba1 vy cv cA wcel vy cv cA wcel vx wal
      wi vy wal vy cv cA wcel vx wal vy cv cA wcel vy cv cA wcel vx ax-4 vy cv
      cA wcel vy cv cA wcel vx wal wi vy ax-4 impbid2 abbid vy cv cA wcel vx
      wal vz cv cA wcel vx wal vy vz vy cv vz cv wceq vy cv cA wcel vz cv cA
      wcel vx vy cv vz cv cA eleq1 albidv cbvabv vy cA abid2 3eqtr3g $.
      $( [17-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y ph $.  $d x y z $.
    hbeqd.1 $e |- ( ph -> A. x ph ) $.
    hbeqd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    hbeqd.3 $e |- ( ph -> ( y e. B -> A. x y e. B ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbeq . $)
    hbeqd $p |- ( ph -> ( A = B -> A. x A = B ) ) $=
      wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab wceq vz cv cA
      wcel vx wal vz cab vz cv cB wcel vx wal vz cab wceq vx wal cA cB wceq cA
      cB wceq vx wal vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab
      wceq vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab wceq vx wal
      wi wph vx vy vy vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab
      vz cv cA wcel vx wal vx vz vy vz cv cA wcel vx hba1 hbab vz cv cB wcel vx
      wal vx vz vy vz cv cB wcel vx hba1 hbab hbeq a1i wph vz cv cA wcel vx wal
      vz cab cA vz cv cB wcel vx wal vz cab cB wph vy cv cA wcel vy cv cA wcel
      vx wal wi vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy
      cv cA wcel vx wal wi vy hbeqd.2 19.21aiv vx vy vz cA abidhb syl wph vy cv
      cB wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB
      wceq wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbeqd.3 19.21aiv vx vy
      vz cB abidhb syl eqeq12d wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx
      wal vz cab wceq cA cB wceq vx hbeqd.1 wph vz cv cA wcel vx wal vz cab cA
      vz cv cB wcel vx wal vz cab cB wph vy cv cA wcel vy cv cA wcel vx wal wi
      vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA
      wcel vx wal wi vy hbeqd.2 19.21aiv vx vy vz cA abidhb syl wph vy cv cB
      wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB wceq
      wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbeqd.3 19.21aiv vx vy vz cB
      abidhb syl eqeq12d albid 3imtr3d $.
      $( [9-Dec-2005] $) $( [6-Dec-2005] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y ph $.  $d x y z $.
    hbeld.1 $e |- ( ph -> A. x ph ) $.
    hbeld.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    hbeld.3 $e |- ( ph -> ( y e. B -> A. x y e. B ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbel . $)
    hbeld $p |- ( ph -> ( A e. B -> A. x A e. B ) ) $=
      wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab wcel vz cv cA
      wcel vx wal vz cab vz cv cB wcel vx wal vz cab wcel vx wal cA cB wcel cA
      cB wcel vx wal vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab
      wcel vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab wcel vx wal
      wi wph vx vy vy vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab
      vz cv cA wcel vx wal vx vz vy vz cv cA wcel vx hba1 hbab vz cv cB wcel vx
      wal vx vz vy vz cv cB wcel vx hba1 hbab hbel a1i wph vz cv cA wcel vx wal
      vz cab cA vz cv cB wcel vx wal vz cab cB wph vy cv cA wcel vy cv cA wcel
      vx wal wi vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy
      cv cA wcel vx wal wi vy hbeld.2 19.21aiv vx vy vz cA abidhb syl wph vy cv
      cB wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB
      wceq wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbeld.3 19.21aiv vx vy
      vz cB abidhb syl eleq12d wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx
      wal vz cab wcel cA cB wcel vx hbeld.1 wph vz cv cA wcel vx wal vz cab cA
      vz cv cB wcel vx wal vz cab cB wph vy cv cA wcel vy cv cA wcel vx wal wi
      vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA
      wcel vx wal wi vy hbeld.2 19.21aiv vx vy vz cA abidhb syl wph vy cv cB
      wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB wceq
      wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbeld.3 19.21aiv vx vy vz cB
      abidhb syl eleq12d albid 3imtr3d $.
      $( [19-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d x y z $.
    dedhb.1 $e |- ( A = { z | A. x z e. A } -> ( ph <-> ps ) ) $.
    dedhb.2 $e |- ps $.
    $( A deduction theorem for converting the inference
       ` |- ( y e. A -> A. x y e. A ) ` => ` |- ph ` into a closed theorem.
       Use ~ hba1 and ~ hbab to eliminate the hypothesis of the substitution
       instance ` ps ` of the inference.  For converting the inference form
       into a deduction form, ~ abidhb is useful. $)
    dedhb $p |- ( A. y ( y e. A -> A. x y e. A ) -> ph ) $=
      vy cv cA wcel vy cv cA wcel vx wal wi vy wal wph wps dedhb.2 vy cv cA
      wcel vy cv cA wcel vx wal wi vy wal cA vz cv cA wcel vx wal vz cab wceq
      wph wps wb vy cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx
      wal vz cab cA vx vy vz cA abidhb eqcomd dedhb.1 syl mpbiri $.
      $( [8-Dec-2006] $) $( [8-Dec-2006] $)
  $}

  ${
    $d x y A $.
    $( Equality has existential uniqueness. $)
    eueq $p |- ( A e. _V <-> E! x x = A ) $=
      vx cv cA wceq vx wex vx cv cA wceq vx wex vx cv cA wceq vy cv cA wceq wa
      vx cv vy cv wceq wi vy wal vx wal wa cA cvv wcel vx cv cA wceq vx weu vx
      cv cA wceq vy cv cA wceq wa vx cv vy cv wceq wi vy wal vx wal vx cv cA
      wceq vx wex vx cv cA wceq vy cv cA wceq wa vx cv vy cv wceq wi vx vy vx
      cv vy cv cA eqtr3 gen2 biantru vx cA isset vx cv cA wceq vy cv cA wceq vx
      vy vx cv vy cv cA eqeq1 eu4 3bitr4i $.
      $( [25-Nov-1994] $)
  $}

  ${
    $d x A $.
    eueq1.1 $e |- A e. _V $.
    $( Equality has existential uniqueness. $)
    eueq1 $p |- E! x x = A $=
      cA cvv wcel vx cv cA wceq vx weu eueq1.1 vx cA eueq mpbi $.
      $( [5-Apr-1995] $)
  $}

  ${
    $d x ph $.  $d x A $.  $d x B $.
    eueq2.1 $e |- A e. _V $.
    eueq2.2 $e |- B e. _V $.
    $( Equality has existential uniqueness (split into 2 cases). $)
    eueq2 $p |- E! x ( ( ph /\ x = A ) \/ ( -. ph /\ x = B ) ) $=
      wph wph vx cv cA wceq wa wph wn vx cv cB wceq wa wo vx weu wph wph wn wph
      vx cv cA wceq wa wo vx weu wph vx cv cA wceq wa wph wn vx cv cB wceq wa
      wo vx weu wph wn wn wph vx cv cA wceq wa vx weu wph wn wph vx cv cA wceq
      wa wo vx weu wph wph wn wph vx cv cA wceq wa vx euorv wph notnot1 wph vx
      cv cA wceq vx weu wph vx cv cA wceq wa vx weu vx cA eueq2.1 eueq1 wph vx
      cv cA wceq wa vx weu wph vx cv cA wceq vx weu wa wph vx cv cA wceq vx
      euanv biimpri mpan2 sylanc wph wph wn wph vx cv cA wceq wa wo wph vx cv
      cA wceq wa wph wn vx cv cB wceq wa wo vx wph wph vx cv cA wceq wa wph wn
      wo wph vx cv cA wceq wa wph wn vx cv cB wceq wa wo wph wn wph vx cv cA
      wceq wa wo wph wph wn wph wn vx cv cB wceq wa wph vx cv cA wceq wa wph
      wph wn vx cv cB wceq wph notnot1 bianfd orbi2d wph wn wph vx cv cA wceq
      wa orcom syl5bb eubidv mpbid wph wn wph wph wn vx cv cB wceq wa wo vx weu
      wph vx cv cA wceq wa wph wn vx cv cB wceq wa wo vx weu wph wn wph wn vx
      cv cB wceq wa vx weu wph wph wn vx cv cB wceq wa wo vx weu wph wn vx cv
      cB wceq vx weu wph wn vx cv cB wceq wa vx weu vx cB eueq2.2 eueq1 wph wn
      vx cv cB wceq wa vx weu wph wn vx cv cB wceq vx weu wa wph wn vx cv cB
      wceq vx euanv biimpri mpan2 wph wph wn vx cv cB wceq wa vx euorv mpdan
      wph wn wph wph wn vx cv cB wceq wa wo wph vx cv cA wceq wa wph wn vx cv
      cB wceq wa wo vx wph wn wph wph vx cv cA wceq wa wph wn vx cv cB wceq wa
      wph wn wph vx cv cA wceq wph wn id bianfd orbi1d eubidv mpbid pm2.61i $.
      $( [5-Apr-1995] $)
  $}

  ${
    $d x ph $.  $d x ps $.  $d x A $.  $d x B $.  $d x C $.
    eueq3.1 $e |- A e. _V $.
    eueq3.2 $e |- B e. _V $.
    eueq3.3 $e |- C e. _V $.
    eueq3.4 $e |- -. ( ph /\ ps ) $.
    $( Equality has existential uniqueness (split into 3 cases). $)
    eueq3 $p |- E! x ( ( ph /\ x = A ) \/ ( -. ( ph \/ ps ) /\ x = B )
                \/ ( ps /\ x = C ) ) $=
      wph wps wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC
      wceq wa w3o vx weu wph wph wps wo wn wps wo wph vx cv cA wceq wa wo vx
      weu wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq
      wa w3o vx weu wph wps wo wn wps wo wn wph vx cv cA wceq wa vx weu wph wps
      wo wn wps wo wph vx cv cA wceq wa wo vx weu wph wph wps wo wn wps wo wph
      vx cv cA wceq wa vx euorv wph wps wo wn wps wo wph wph wps wo wn wph wn
      wps wph wps pm2.45 wph wps wph wps wn wi wph wps wa wn eueq3.4 wph wps
      imnan mpbir con2i jaoi con2i wph vx cv cA wceq vx weu wph vx cv cA wceq
      wa vx weu vx cA eueq3.1 eueq1 wph vx cv cA wceq wa vx weu wph vx cv cA
      wceq vx weu wa wph vx cv cA wceq vx euanv biimpri mpan2 sylanc wph wph
      wps wo wn wps wo wph vx cv cA wceq wa wo wph vx cv cA wceq wa wph wps wo
      wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx wph wph vx cv cA wceq wa
      wph wps wo wn wps wo wo wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq
      wa wps vx cv cC wceq wa wo wo wph wps wo wn wps wo wph vx cv cA wceq wa
      wo wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq
      wa w3o wph wph wps wo wn wps wo wph wps wo wn vx cv cB wceq wa wps vx cv
      cC wceq wa wo wph vx cv cA wceq wa wph wph wps wo wn wph wps wo wn vx cv
      cB wceq wa wps wps vx cv cC wceq wa wph wph wps wo wn vx cv cB wceq wph
      wps wph wps wo wn wn wph wps wo notnot1 orcs bianfd wph wps vx cv cC wceq
      wph wps wn wi wph wps wa wn eueq3.4 wph wps imnan mpbir bianfd orbi12d
      orbi2d wph wps wo wn wps wo wph vx cv cA wceq wa orcom wph vx cv cA wceq
      wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa 3orass 3bitr4g
      eubidv mpbid wps wph wph wps wo wn wo wps vx cv cC wceq wa wo vx weu wph
      vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o
      vx weu wph wph wps wo wn wo wn wps vx cv cC wceq wa vx weu wph wph wps wo
      wn wo wps vx cv cC wceq wa wo vx weu wps wph wph wps wo wn wo wps vx cv
      cC wceq wa vx euorv wph wph wps wo wn wo wps wph wps wn wph wps wo wn wph
      wps wn wi wph wps wa wn eueq3.4 wph wps imnan mpbir wph wps pm2.46 jaoi
      con2i wps vx cv cC wceq vx weu wps vx cv cC wceq wa vx weu vx cC eueq3.3
      eueq1 wps vx cv cC wceq wa vx weu wps vx cv cC wceq vx weu wa wps vx cv
      cC wceq vx euanv biimpri mpan2 sylanc wps wph wph wps wo wn wo wps vx cv
      cC wceq wa wo wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx
      cv cC wceq wa w3o vx wps wph wph wps wo wn wo wps vx cv cC wceq wa wo wph
      vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wo wps vx cv cC wceq wa
      wo wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq
      wa w3o wps wph wph wps wo wn wo wph vx cv cA wceq wa wph wps wo wn vx cv
      cB wceq wa wo wps vx cv cC wceq wa wps wph wph vx cv cA wceq wa wph wps
      wo wn wph wps wo wn vx cv cB wceq wa wps wph vx cv cA wceq wph wps wph
      wps wn wi wph wps wa wn eueq3.4 wph wps imnan mpbir con2i bianfd wps wph
      wps wo wn vx cv cB wceq wph wps wph wps wo wn wn wph wps wo notnot1 olcs
      bianfd orbi12d orbi1d wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa
      wps vx cv cC wceq wa df-3or syl6bbr eubidv mpbid wph wps wo wn wph wps wo
      wph wps wo wn vx cv cB wceq wa wo vx weu wph vx cv cA wceq wa wph wps wo
      wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx weu wph wps wo wn wph wps
      wo wn vx cv cB wceq wa vx weu wph wps wo wph wps wo wn vx cv cB wceq wa
      wo vx weu wph wps wo wn vx cv cB wceq vx weu wph wps wo wn vx cv cB wceq
      wa vx weu vx cB eueq3.2 eueq1 wph wps wo wn vx cv cB wceq wa vx weu wph
      wps wo wn vx cv cB wceq vx weu wa wph wps wo wn vx cv cB wceq vx euanv
      biimpri mpan2 wph wps wo wph wps wo wn vx cv cB wceq wa vx euorv mpdan
      wph wps wo wn wph wps wo wph wps wo wn vx cv cB wceq wa wo wph vx cv cA
      wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx wph
      wps wo wn wph wps wph wps wo wn vx cv cB wceq wa wo wo wph vx cv cA wceq
      wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa wo wo wph wps wo
      wph wps wo wn vx cv cB wceq wa wo wph vx cv cA wceq wa wph wps wo wn vx
      cv cB wceq wa wps vx cv cC wceq wa w3o wph wps wo wn wph wph vx cv cA
      wceq wa wps wph wps wo wn vx cv cB wceq wa wo wph wps wo wn vx cv cB wceq
      wa wps vx cv cC wceq wa wo wph wps wo wn wph vx cv cA wceq wph wps pm2.45
      bianfd wph wps wo wn wps wph wps wo wn vx cv cB wceq wa wo wps vx cv cC
      wceq wa wph wps wo wn vx cv cB wceq wa wo wph wps wo wn vx cv cB wceq wa
      wps vx cv cC wceq wa wo wph wps wo wn wps wps vx cv cC wceq wa wph wps wo
      wn vx cv cB wceq wa wph wps wo wn wps vx cv cC wceq wph wps pm2.46 bianfd
      orbi1d wps vx cv cC wceq wa wph wps wo wn vx cv cB wceq wa orcom syl6bb
      orbi12d wph wps wph wps wo wn vx cv cB wceq wa orass wph vx cv cA wceq wa
      wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa 3orass 3bitr4g eubidv
      mpbid ecase3 $.
      $( [5-Apr-1995] $)
  $}

  ${
    $d x A $.
    $( There is at most one set equal to a class. $)
    moeq $p |- E* x x = A $=
      vx cv cA wceq vx wmo vx cv cA wceq vx wex vx cv cA wceq vx weu wi vx cv
      cA wceq vx wex vx cv cA wceq vx weu vx cv cA wceq vx wex cA cvv wcel vx
      cv cA wceq vx weu vx cA isset vx cA eueq bitr3i biimpi vx cv cA wceq vx
      df-mo mpbir $.
      $( [8-Mar-1995] $)
  $}

  ${
    $d x y ph $.  $d x y ps $.  $d x y A $.  $d x y B $.  $d x y C $.

    moeq3.1 $e |- B e. _V $.
    moeq3.2 $e |- C e. _V $.
    moeq3.3 $e |- -. ( ph /\ ps ) $.
    $( "At most one" property of equality (split into 3 cases).  (The
       first 2 hypotheses could be eliminated with longer proof.) $)
    moeq3 $p |- E* x ( ( ph /\ x = A ) \/ ( -. ( ph \/ ps ) /\ x = B )
                \/ ( ps /\ x = C ) ) $=
      cA cvv wcel wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv
      cC wceq wa w3o vx wmo cA cvv wcel wph vx cv cA wceq wa wph wps wo wn vx
      cv cB wceq wa wps vx cv cC wceq wa w3o vx weu wph vx cv cA wceq wa wph
      wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx wmo wph vx cv vy
      cv wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx weu
      wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa
      w3o vx weu vy cA cvv vy cv cA wceq wph vx cv vy cv wceq wa wph wps wo wn
      vx cv cB wceq wa wps vx cv cC wceq wa w3o wph vx cv cA wceq wa wph wps wo
      wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx vy cv cA wceq wph vx cv
      vy cv wceq wa wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wph wps
      wo wn vx cv cB wceq wa wps vx cv cC wceq wa wps vx cv cC wceq wa vy cv cA
      wceq vx cv vy cv wceq vx cv cA wceq wph vy cv cA vx cv eqeq2 anbi2d vy cv
      cA wceq wph wps wo wn vx cv cB wceq wa biidd vy cv cA wceq wps vx cv cC
      wceq wa biidd 3orbi123d eubidv wph wps vx vy cv cB cC vy visset moeq3.1
      moeq3.2 moeq3.3 eueq3 vtoclg wph vx cv cA wceq wa wph wps wo wn vx cv cB
      wceq wa wps vx cv cC wceq wa w3o vx eumo syl cA cvv wcel wn wph vx cv vy
      cv wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx weu
      wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa
      w3o vx wmo wph wps vx vy cv cB cC vy visset moeq3.1 moeq3.2 moeq3.3 eueq3
      cA cvv wcel wn wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx
      cv cC wceq wa w3o wph vx cv vy cv wceq wa wph wps wo wn vx cv cB wceq wa
      wps vx cv cC wceq wa w3o wi vx wal wph vx cv vy cv wceq wa wph wps wo wn
      vx cv cB wceq wa wps vx cv cC wceq wa w3o vx weu wph vx cv cA wceq wa wph
      wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o vx wmo wi cA cvv wcel
      wn wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq
      wa w3o wph vx cv vy cv wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv
      cC wceq wa w3o wi vx cA cvv wcel wn wph vx cv cA wceq wa wph wps wo wn vx
      cv cB wceq wa wps vx cv cC wceq wa wo wo wph vx cv vy cv wceq wa wph wps
      wo wn vx cv cB wceq wa wps vx cv cC wceq wa wo wo wph vx cv cA wceq wa
      wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o wph vx cv vy cv
      wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa w3o cA cvv
      wcel wn wph vx cv cA wceq wa wph vx cv vy cv wceq wa wph wps wo wn vx cv
      cB wceq wa wps vx cv cC wceq wa wo cA cvv wcel wn vx cv cA wceq vx cv vy
      cv wceq wph cA cvv wcel wn cA cvv wcel vx cv vy cv wceq vx cv cA wceq cA
      cvv wcel vx cv vy cv wceq pm2.21 vx cv cA wceq vx cv cvv wcel cA cvv wcel
      vx visset vx cv cA cvv eleq1 mpbii syl5 anim2d orim1d wph vx cv cA wceq
      wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa 3orass wph vx cv
      vy cv wceq wa wph wps wo wn vx cv cB wceq wa wps vx cv cC wceq wa 3orass
      3imtr4g 19.21aiv wph vx cv cA wceq wa wph wps wo wn vx cv cB wceq wa wps
      vx cv cC wceq wa w3o wph vx cv vy cv wceq wa wph wps wo wn vx cv cB wceq
      wa wps vx cv cC wceq wa w3o vx euimmo syl mpi pm2.61i $.
      $( [23-Apr-1995] $)
  $}

  ${
    $d x y A $.
    mosub.1 $e |- E* x ph $.
    $( "At most one" remains true after substitution. $)
    mosub $p |- E* x E. y ( y = A /\ ph ) $=
      vy cv cA wceq vy wmo wph vx wmo vy wal vy cv cA wceq wph wa vy wex vx wmo
      vy cA moeq wph vx wmo vy mosub.1 ax-gen vy cv cA wceq wph vy vx moexexv
      mp2an $.
      $( [9-Mar-1995] $)
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Theorem for inferring "at most one." $)
    mo2icl $p |- ( A. x ( ph -> x = A ) -> E* x ph ) $=
      cA cvv wcel wph vx cv cA wceq wi vx wal wph vx wmo wi wph vx cv vy cv
      wceq wi vx wal wph vx wmo wi wph vx cv cA wceq wi vx wal wph vx wmo wi vy
      cA cvv vy cv cA wceq wph vx cv vy cv wceq wi vx wal wph vx cv cA wceq wi
      vx wal wph vx wmo vy cv cA wceq wph vx cv vy cv wceq wi wph vx cv cA wceq
      wi vx vy cv cA wceq vx cv vy cv wceq vx cv cA wceq wph vy cv cA vx cv
      eqeq2 imbi2d albidv imbi1d wph vx cv vy cv wceq wi vx wal wph vx cv vy cv
      wceq wi vx wal vy wex wph vx wmo wph vx cv vy cv wceq wi vx wal vy 19.8a
      wph vx vy wph vy ax-17 mo2 sylibr vtoclg cA cvv wcel wn wph vx cv cA wceq
      wi vx wal wph wn vx wal wph vx wmo cA cvv wcel wn wph vx cv cA wceq wi
      wph wn vx wph vx cv cA wceq wi cA cvv wcel wn wph wn wph vx cv cA wceq wi
      wph cA cvv wcel vx cv cA wceq cA cvv wcel wph vx cv cA wceq vx cv cvv
      wcel cA cvv wcel vx visset vx cv cA cvv eleq1 mpbii imim2i con3d com12
      19.20dv wph wn vx wal wph vx wex wn wph vx wmo wph vx alnex wph vx wex
      wph vx wmo wph vx exmo ori sylbi syl6 pm2.61i $.
      $( [17-Oct-1996] $)
  $}

  ${
    $d x y A $.  $d y ph $.  $d x y ps $.
    moi2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Consequence of "at most one." $)
    moi2 $p |- ( ( ( A e. B /\ E* x ph ) /\ ( ph /\ ps ) ) -> x = A ) $=
      cA cB wcel wph vx wmo wph wps wa vx cv cA wceq cA cB wcel wph wph vx vy
      cv wsbc wa vx cv vy cv wceq wi vy wal vx wal wph wps wa vx cv cA wceq wi
      wph vx wmo cA cB wcel wph wph vx vy cv wsbc wa vx cv vy cv wceq wi vy wal
      wph wps wa vx cv cA wceq wi vx wph wph vx vy cv wsbc wa vx cv vy cv wceq
      wi wph wps wa vx cv cA wceq wi vy cA cB vy cv cA wceq wph wph vx vy cv
      wsbc wa wph wps wa vx cv vy cv wceq vx cv cA wceq vy cv cA wceq wph vx vy
      cv wsbc wps wph vy cv cA wceq vx cv vy cv wceq vx cv cA wceq wa vx wex
      wph vx vy cv wsbc wps wb vx vy cv cA vy visset eqvinc vx cv vy cv wceq vx
      cv cA wceq wa wph vx vy cv wsbc wps wb vx wph vx vy cv wsbc wps vx wph vx
      vy hbs1 wps vx ax-17 hbbi vx cv vy cv wceq wph vx vy cv wsbc wph vx cv cA
      wceq wps vx cv vy cv wceq wph wph vx vy cv wsbc wph vx vy sbequ12 bicomd
      moi2.1 sylan9bb 19.23ai sylbi anbi2d vy cv cA vx cv eqeq2 imbi12d cla4gv
      a4sd wph wph vx vy cv wsbc vx vy wph vx vy hbs1 wph vx vy sbequ12 mo4f
      syl5ib imp31 $.
      $( [29-Jun-2008] $) $( [29-Jun-2008] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ch $.  $d y ph $.  $d x y ps $.
    moi.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    moi.2 $e |- ( x = B -> ( ph <-> ch ) ) $.
    $( MAY BE REVISED - is there a way to shorten w/ moi2? $)
    $( Equality implied by "at most one." $)
    moi $p |- ( ( ( A e. C /\ B e. D ) /\ E* x ph /\ ( ps /\ ch ) ) ->
              A = B ) $=
      cA cC wcel cB cD wcel wa wph vx wmo wps wch wa cA cB wceq cA cC wcel cB
      cD wcel wa wph wph vx vy cv wsbc wa vx cv vy cv wceq wi vy wal vx wal wps
      wch wa cA cB wceq wi wph vx wmo cA cC wcel wph wph vx vy cv wsbc wa vx cv
      vy cv wceq wi vy wal vx wal wps wph vx vy cv wsbc wa cA vy cv wceq wi vy
      wal cB cD wcel wps wch wa cA cB wceq wi wph wph vx vy cv wsbc wa vx cv vy
      cv wceq wi vy wal wps wph vx vy cv wsbc wa cA vy cv wceq wi vy wal vx vy
      cA cC vy cv cA wcel vx ax-17 wps wph vx vy cv wsbc wa cA vy cv wceq wi vx
      vy wps wph vx vy cv wsbc wa cA vy cv wceq vx wps wph vx vy cv wsbc vx wps
      vx ax-17 wph vx vy hbs1 hban cA vy cv wceq vx ax-17 hbim hbal vx cv cA
      wceq wph wph vx vy cv wsbc wa vx cv vy cv wceq wi wps wph vx vy cv wsbc
      wa cA vy cv wceq wi vy vx cv cA wceq wph wph vx vy cv wsbc wa wps wph vx
      vy cv wsbc wa vx cv vy cv wceq cA vy cv wceq vx cv cA wceq wph wps wph vx
      vy cv wsbc moi.1 anbi1d vx cv cA vy cv eqeq1 imbi12d albidv cla4gf wps
      wph vx vy cv wsbc wa cA vy cv wceq wi wps wch wa cA cB wceq wi vy cB cD
      vy cv cB wceq wps wph vx vy cv wsbc wa wps wch wa cA vy cv wceq cA cB
      wceq vy cv cB wceq wph vx vy cv wsbc wch wps vy cv cB wceq vx cv vy cv
      wceq vx cv cB wceq wa vx wex wph vx vy cv wsbc wch wb vx vy cv cB vy
      visset eqvinc vx cv vy cv wceq vx cv cB wceq wa wph vx vy cv wsbc wch wb
      vx wph vx vy cv wsbc wch vx wph vx vy hbs1 wch vx ax-17 hbbi vx cv vy cv
      wceq wph vx vy cv wsbc wph vx cv cB wceq wch vx cv vy cv wceq wph wph vx
      vy cv wsbc wph vx vy sbequ12 bicomd moi.2 sylan9bb 19.23ai sylbi anbi2d
      vy cv cB cA eqeq2 imbi12d cla4gv sylan9 wph wph vx vy cv wsbc vx vy wph
      vx vy hbs1 wph vx vy sbequ12 mo4f syl5ib 3imp $.
      $( [20-Feb-2006] $) $( [18-Feb-2006] $)
  $}

  ${
    $d x ph $.  $d x A $.
    euxfr2.1 $e |- A e. _V $.
    euxfr2.2 $e |- E* y x = A $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    euxfr2 $p |- ( E! x E. y ( x = A /\ ph ) <-> E! y ph ) $=
      vx cv cA wceq wph wa vy wex vx weu vx cv cA wceq wph wa vx wex vy weu wph
      vy weu vx cv cA wceq wph wa vy wex vx weu vx cv cA wceq wph wa vx wex vy
      weu vx cv cA wceq wph wa vy wmo vx cv cA wceq wph wa vy wex vx weu vx cv
      cA wceq wph wa vx wex vy weu wi vx vx cv cA wceq wph wa vx vy 2euswap wph
      vx cv cA wceq wa vy wmo vx cv cA wceq wph wa vy wmo vx cv cA wceq wph vy
      euxfr2.2 moani wph vx cv cA wceq wa vx cv cA wceq wph wa vy wph vx cv cA
      wceq ancom mobii mpbi mpg vx cv cA wceq wph wa vx wmo vx cv cA wceq wph
      wa vx wex vy weu vx cv cA wceq wph wa vy wex vx weu wi vy vx cv cA wceq
      wph wa vy vx 2euswap wph vx cv cA wceq wa vx wmo vx cv cA wceq wph wa vx
      wmo vx cv cA wceq wph vx vx cA moeq moani wph vx cv cA wceq wa vx cv cA
      wceq wph wa vx wph vx cv cA wceq ancom mobii mpbi mpg impbii vx cv cA
      wceq wph wa vx wex wph vy wph wph vx cA euxfr2.1 vx cv cA wceq wph biidd
      ceqsexv eubii bitri $.
      $( [15-Nov-2004] $) $( [14-Nov-2004] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x A $.
    euxfr.1 $e |- A e. _V $.
    euxfr.2 $e |- E! y x = A $.
    euxfr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    euxfr $p |- ( E! x ph <-> E! y ps ) $=
      wph vx weu vx cv cA wceq wps wa vy wex vx weu wps vy weu wph vx cv cA
      wceq wps wa vy wex vx wph vx cv cA wceq vy wex wph wa vx cv cA wceq wph
      wa vy wex vx cv cA wceq wps wa vy wex vx cv cA wceq vy wex wph vx cv cA
      wceq vy weu vx cv cA wceq vy wex euxfr.2 vx cv cA wceq vy euex ax-mp
      biantrur vx cv cA wceq wph vy 19.41v vx cv cA wceq wph wa vx cv cA wceq
      wps wa vy vx cv cA wceq wph wps euxfr.3 pm5.32i exbii 3bitr2i eubii wps
      vx vy cA euxfr.1 vx cv cA wceq vy euxfr.2 eumoi euxfr2 bitri $.
      $( [19-Nov-2004] $) $( [14-Nov-2004] $)
  $}

  ${
    $d y z w ph $.  $d x z ps $.  $d y z w A $.  $d x z B $.  $d x y w $.
    euind.0 $e |- B e. _V $.
    euind.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    euind.2 $e |- ( x = y -> A = B ) $.
    $( Existential uniqueness via an indirect equality. $)
    euind $p |- ( ( A. x A. y ( ( ph /\ ps ) -> A = B ) /\ E. x ph )
                 -> E! z A. x ( ph -> z = A ) ) $=
      wph vz cv cA wceq wi vx wal vz weu wph vz cv cA wceq wi vx wal vz wex wph
      vz cv cA wceq wi vx wal wph vw cv cA wceq wi vx wal wa vz vw weq wi vw
      wal vz wal wph wps wa cA cB wceq wi vy wal vx wal wph vx wex wa wph vz cv
      cA wceq wi vx wal wph vw cv cA wceq wi vx wal vz vw vz vw weq wph vz cv
      cA wceq wi wph vw cv cA wceq wi vx vz vw weq vz cv cA wceq vw cv cA wceq
      wph vz cv vw cv cA eqeq1 imbi2d albidv eu4 wph wps wa cA cB wceq wi vy
      wal vx wal wph vx wex wph vz cv cA wceq wi vx wal vz wex wph wps wa cA cB
      wceq wi vy wal vx wal vz cv cB wceq wps wa vy wex vz wex wph vz cv cA
      wceq wi vx wal vz wex wph vx wex wph wps wa cA cB wceq wi vy wal vx wal
      vz cv cB wceq wps wa vy wex wph vz cv cA wceq wi vx wal vz wph wps wa cA
      cB wceq wi vy wal vx wal vz cv cB wceq wps wa wph vz cv cA wceq wi wi vy
      wal vx wal vz cv cB wceq wps wa vy wex wph vz cv cA wceq wi vx wal wi wph
      wps wa cA cB wceq wi vz cv cB wceq wps wa wph vz cv cA wceq wi wi vx vy
      wph wps wa cA cB wceq wi wph wps wa vz cv cA wceq vz cv cB wceq wb wi vz
      cv cB wceq wps wa wph vz cv cA wceq wi wi cA cB wceq vz cv cA wceq vz cv
      cB wceq wb wph wps wa cA cB vz cv eqeq2 imim2i wph wps wa vz cv cA wceq
      vz cv cB wceq wb wi wph wps wa vz cv cB wceq vz cv cA wceq wi wi vz cv cB
      wceq wps wa wph vz cv cA wceq wi wi vz cv cA wceq vz cv cB wceq wb vz cv
      cB wceq vz cv cA wceq wi wph wps wa vz cv cA wceq vz cv cB wceq bi2
      imim2i wph wps wa vz cv cB wceq wa vz cv cA wceq wi vz cv cB wceq wps wa
      wph wa vz cv cA wceq wi wph wps wa vz cv cB wceq vz cv cA wceq wi wi vz
      cv cB wceq wps wa wph vz cv cA wceq wi wi wph wps wa vz cv cB wceq wa vz
      cv cB wceq wps wa wph wa vz cv cA wceq wph wps wa vz cv cB wceq wa wph vz
      cv cB wceq wa wps wa vz cv cB wceq wph wa wps wa vz cv cB wceq wps wa wph
      wa wph wps vz cv cB wceq an23 wph vz cv cB wceq wa vz cv cB wceq wph wa
      wps wph vz cv cB wceq ancom anbi1i vz cv cB wceq wph wps an23 3bitri
      imbi1i wph wps wa vz cv cB wceq vz cv cA wceq impexp vz cv cB wceq wps wa
      wph vz cv cA wceq impexp 3bitr3i sylib syl 19.20i2 vz cv cB wceq wps wa
      wph vz cv cA wceq wi wi vy wal vx wal vz cv cB wceq wps wa vy wex wph vz
      cv cA wceq wi wi vx wal vz cv cB wceq wps wa vy wex wph vz cv cA wceq wi
      vx wal wi vz cv cB wceq wps wa wph vz cv cA wceq wi wi vy wal vz cv cB
      wceq wps wa vy wex wph vz cv cA wceq wi wi vx vz cv cB wceq wps wa wph vz
      cv cA wceq wi vy 19.23v albii vz cv cB wceq wps wa vy wex wph vz cv cA
      wceq wi vx 19.21v bitri sylib 19.22dv wph vx wex wps vy wex vz cv cB wceq
      vz wex wps wa vy wex vz cv cB wceq wps wa vy wex vz wex wph wps vx vy
      euind.1 cbvexv wps vz cv cB wceq vz wex wps wa vy vz cv cB wceq vz wex
      wps vz cB euind.0 isseti biantrur exbii vz cv cB wceq vz wex wps wa vy
      wex vz cv cB wceq wps wa vz wex vy wex vz cv cB wceq wps wa vy wex vz wex
      vz cv cB wceq wps wa vz wex vz cv cB wceq vz wex wps wa vy vz cv cB wceq
      wps vz 19.41v exbii vz cv cB wceq wps wa vy vz excom bitr3i 3bitri syl5ib
      imp wph vx wex wph vz cv cA wceq wi vx wal wph vw cv cA wceq wi vx wal wa
      vz vw weq wi vw wal vz wal wph wps wa cA cB wceq wi vy wal vx wal wph vx
      wex wph vz cv cA wceq wi vx wal wph vw cv cA wceq wi vx wal wa vz vw weq
      wi vz vw wph vx wex wph vz vw weq wi vx wal vz vw weq wph vz cv cA wceq
      wi vx wal wph vw cv cA wceq wi vx wal wa wph vz vw weq wi vx wal wph vx
      wex vz vw weq wph vz vw weq wi vx wal wph vx wex vz vw weq wi wph vz vw
      weq vx 19.23v biimpi com12 wph vz cv cA wceq wi vx wal wph vw cv cA wceq
      wi vx wal wa wph vz cv cA wceq wi wph vw cv cA wceq wi wa vx wal wph vz
      vw weq wi vx wal wph vz cv cA wceq wi wph vw cv cA wceq wi vx 19.26 wph
      vz cv cA wceq wi wph vw cv cA wceq wi wa wph vz vw weq wi vx wph vz cv cA
      wceq wi wph vw cv cA wceq wi wa wph wph wa vz cv cA wceq vw cv cA wceq wa
      wi wph vz vw weq wi wph vz cv cA wceq wph vw cv cA wceq prth wph wph wph
      wa vz cv cA wceq vw cv cA wceq wa vz vw weq wph wph wph wa wph pm4.24
      biimpi vz cv vw cv cA eqtr3 imim12i syl 19.20i sylbir syl5 19.21aivv
      adantl sylanbrc $.
      $( [11-Oct-2010] $) $( [11-Oct-2010] $)
  $}

  $( Restricted unique existence implies restricted existence. $)
  reurex $p |- ( E! x e. A ph -> E. x e. A ph ) $=
    vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx wex wph vx cA wreu wph
    vx cA wrex vx cv cA wcel wph wa vx euex wph vx cA df-reu wph vx cA df-rex
    3imtr4i $.
    $( [19-Aug-1999] $)

  $( Restricted uniqueness in terms of "at most one." $)
  reu5 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\ E* x ( x e. A /\ ph ) ) ) $=
    vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx wex vx cv cA wcel wph
    wa vx wmo wa wph vx cA wreu wph vx cA wrex vx cv cA wcel wph wa vx wmo wa
    vx cv cA wcel wph wa vx eu5 wph vx cA df-reu wph vx cA wrex vx cv cA wcel
    wph wa vx wex vx cv cA wcel wph wa vx wmo wph vx cA df-rex anbi1i 3bitr4i
    $.
    $( [23-May-1999] $)

  ${
    $d x y A $.  $d y ph $.
    $( A way to express restricted uniqueness. $)
    reu2 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\
               A. x e. A A. y e. A ( ( ph /\ [ y / x ] ph ) -> x = y ) ) ) $=
      vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx wex vx cv cA wcel wph
      wa vx cv cA wcel wph wa vx vy cv wsbc wa vx cv vy cv wceq wi vy wal vx
      wal wa wph vx cA wreu wph vx cA wrex wph wph vx vy cv wsbc wa vx cv vy cv
      wceq wi vy cA wral vx cA wral wa vx cv cA wcel wph wa vx vy vx cv cA wcel
      wph wa vy ax-17 eu2 wph vx cA df-reu wph vx cA wrex vx cv cA wcel wph wa
      vx wex wph wph vx vy cv wsbc wa vx cv vy cv wceq wi vy cA wral vx cA wral
      vx cv cA wcel wph wa vx cv cA wcel wph wa vx vy cv wsbc wa vx cv vy cv
      wceq wi vy wal vx wal wph vx cA df-rex wph wph vx vy cv wsbc wa vx cv vy
      cv wceq wi vy cA wral vx cA wral vx cv cA wcel wph wph vx vy cv wsbc wa
      vx cv vy cv wceq wi vy cA wral wi vx wal vx cv cA wcel wph wa vx cv cA
      wcel wph wa vx vy cv wsbc wa vx cv vy cv wceq wi vy wal vx wal wph wph vx
      vy cv wsbc wa vx cv vy cv wceq wi vy cA wral vx cA df-ral vx cv cA wcel
      wph wa vx cv cA wcel wph wa vx vy cv wsbc wa vx cv vy cv wceq wi vy wal
      vx cv cA wcel wph wph vx vy cv wsbc wa vx cv vy cv wceq wi vy cA wral wi
      vx vx cv cA wcel vy cv cA wcel wph wph vx vy cv wsbc wa vx cv vy cv wceq
      wi wi wi vy wal vx cv cA wcel vy cv cA wcel wph wph vx vy cv wsbc wa vx
      cv vy cv wceq wi wi vy wal wi vx cv cA wcel wph wa vx cv cA wcel wph wa
      vx vy cv wsbc wa vx cv vy cv wceq wi vy wal vx cv cA wcel wph wph vx vy
      cv wsbc wa vx cv vy cv wceq wi vy cA wral wi vx cv cA wcel vy cv cA wcel
      wph wph vx vy cv wsbc wa vx cv vy cv wceq wi wi vy 19.21v vx cv cA wcel
      wph wa vx cv cA wcel wph wa vx vy cv wsbc wa vx cv vy cv wceq wi vx cv cA
      wcel vy cv cA wcel wph wph vx vy cv wsbc wa vx cv vy cv wceq wi wi wi vy
      vx cv cA wcel wph wa vx cv cA wcel wph wa vx vy cv wsbc wa vx cv vy cv
      wceq wi vx cv cA wcel vy cv cA wcel wa wph wph vx vy cv wsbc wa wa vx cv
      vy cv wceq wi vx cv cA wcel vy cv cA wcel wa wph wph vx vy cv wsbc wa vx
      cv vy cv wceq wi wi vx cv cA wcel vy cv cA wcel wph wph vx vy cv wsbc wa
      vx cv vy cv wceq wi wi wi vx cv cA wcel wph wa vx cv cA wcel wph wa vx vy
      cv wsbc wa vx cv cA wcel vy cv cA wcel wa wph wph vx vy cv wsbc wa wa vx
      cv vy cv wceq vx cv cA wcel wph wa vx cv cA wcel wph wa vx vy cv wsbc wa
      vx cv cA wcel wph wa vy cv cA wcel wph vx vy cv wsbc wa wa vx cv cA wcel
      vy cv cA wcel wa wph wph vx vy cv wsbc wa wa vx cv cA wcel wph wa vx vy
      cv wsbc vy cv cA wcel wph vx vy cv wsbc wa vx cv cA wcel wph wa vx cv cA
      wcel wph wa vy cv cA wcel wph vx vy cv wsbc wa vx vy vy cv cA wcel wph vx
      vy cv wsbc vx vy cv cA wcel vx ax-17 wph vx vy hbs1 hban vx cv vy cv wceq
      vx cv cA wcel vy cv cA wcel wph wph vx vy cv wsbc vx cv vy cv cA eleq1
      wph vx vy sbequ12 anbi12d sbie anbi2i vx cv cA wcel wph vy cv cA wcel wph
      vx vy cv wsbc an4 bitri imbi1i vx cv cA wcel vy cv cA wcel wa wph wph vx
      vy cv wsbc wa vx cv vy cv wceq impexp vx cv cA wcel vy cv cA wcel wph wph
      vx vy cv wsbc wa vx cv vy cv wceq wi impexp 3bitri albii wph wph vx vy cv
      wsbc wa vx cv vy cv wceq wi vy cA wral vy cv cA wcel wph wph vx vy cv
      wsbc wa vx cv vy cv wceq wi wi vy wal vx cv cA wcel wph wph vx vy cv wsbc
      wa vx cv vy cv wceq wi vy cA df-ral imbi2i 3bitr4i albii bitr4i anbi12i
      3bitr4i $.
      $( [22-Nov-1994] $)

    $( A way to express restricted uniqueness. $)
    reu6  $p |- ( E! x e. A ph <-> E. y e. A A. x e. A ( ph <-> x = y ) ) $=
      wph vx cA wreu vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx cv vy
      cv wceq wb vx wal vy wex wph vx cv vy cv wceq wb vx cA wral vy cA wrex
      wph vx cA df-reu vx cv cA wcel wph wa vx vy df-eu vx cv cA wcel wph wa vx
      cv vy cv wceq wb vx wal vy wex vy cv cA wcel wph vx cv vy cv wceq wb vx
      cA wral wa vy wex wph vx cv vy cv wceq wb vx cA wral vy cA wrex vx cv cA
      wcel wph wa vx cv vy cv wceq wb vx wal vy cv cA wcel wph vx cv vy cv wceq
      wb vx cA wral wa vy vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb
      wi wa vx wal vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb wi vx
      wal wa vx cv cA wcel wph wa vx cv vy cv wceq wb vx wal vy cv cA wcel wph
      vx cv vy cv wceq wb vx cA wral wa vy cv cA wcel vx cv cA wcel wph vx cv
      vy cv wceq wb wi vx 19.28v vx cv cA wcel wph wa vx cv vy cv wceq wb vx
      wal vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb wi wa vx wal vx
      cv cA wcel wph wa vx cv vy cv wceq wb vy cv cA wcel vx cv cA wcel wph vx
      cv vy cv wceq wb wi wa vx vx cv cA wcel wph wa vx cv vy cv wceq wb vx wal
      vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb wi vx cv cA wcel wph
      wa vx cv vy cv wceq wb vy cv cA wcel vx vy vx cv vy cv wceq vx cv cA wcel
      wph wa vx cv vy cv wceq wb vy cv cA wcel wph vx vy cv wsbc wa vy cv vy cv
      wceq wb vy cv cA wcel vx cv vy cv wceq vx cv cA wcel wph wa vy cv cA wcel
      wph vx vy cv wsbc wa vx cv vy cv wceq vy cv vy cv wceq vx cv vy cv wceq
      vx cv cA wcel vy cv cA wcel wph wph vx vy cv wsbc vx cv vy cv cA eleq1
      wph vx vy sbequ12 anbi12d vx cv vy cv vy cv eqeq1 bibi12d vy cv cA wcel
      wph vx vy cv wsbc wa vy cv vy cv wceq wb vy cv cA wcel wph vx vy cv wsbc
      wa vy cv cA wcel vy cv vy cv wceq vy cv cA wcel wph vx vy cv wsbc wa vy
      cv eqid tbt vy cv cA wcel wph vx vy cv wsbc pm3.26 sylbir syl6bi a4imv vx
      cv cA wcel wph wa vx cv vy cv wceq wb vx cv cA wcel wph vx cv vy cv wceq
      wb wi vx vx cv cA wcel wph wa vx cv vy cv wceq wb vx cv cA wcel wph vx cv
      vy cv wceq wb vx cv cA wcel wph wa vx cv vy cv wceq wb vx cv cA wcel wa
      wph vx cv vy cv wceq vx cv cA wcel wph wa vx cv vy cv wceq wb vx cv cA
      wcel wph vx cv vy cv wceq vx cv cA wcel wph wa vx cv vy cv wceq bi1
      expdimp vx cv cA wcel wph wa vx cv vy cv wceq wb vx cv vy cv wceq wph wi
      vx cv cA wcel vx cv cA wcel wph wa vx cv vy cv wceq wb vx cv vy cv wceq
      vx cv cA wcel wph wa wph vx cv cA wcel wph wa vx cv vy cv wceq bi2 vx cv
      cA wcel wph pm3.27 syl6 adantr impbid ex a4s jca a5i vy cv cA wcel vx cv
      cA wcel wph vx cv vy cv wceq wb wi wa vx cv cA wcel wph wa vx cv vy cv
      wceq wb vx vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb wi wa vx
      cv cA wcel wph wa vx cv vy cv wceq vx cv cA wcel wph vx cv vy cv wceq wb
      wi vx cv cA wcel wph wa vx cv vy cv wceq wi vy cv cA wcel vx cv cA wcel
      wph vx cv vy cv wceq wb wi vx cv cA wcel wph vx cv vy cv wceq wph vx cv
      vy cv wceq wb wph vx cv vy cv wceq wi vx cv cA wcel wph vx cv vy cv wceq
      bi1 imim2i imp3a adantl vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq
      wb wi wa vx cv vy cv wceq vx cv cA wcel wph wa vy cv cA wcel vx cv cA
      wcel wph vx cv vy cv wceq wb wi wa vx cv vy cv wceq wa vx cv cA wcel wph
      vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb wi wa vx cv vy cv
      wceq vx cv cA wcel vy cv cA wcel vx cv vy cv wceq vx cv cA wcel wi vx cv
      cA wcel wph vx cv vy cv wceq wb wi vy cv cA vx cv eleq1a adantr imp vx cv
      cA wcel wph vx cv vy cv wceq wb wi vx cv vy cv wceq vx cv cA wcel wph wi
      vy cv cA wcel vx cv cA wcel wph vx cv vy cv wceq wb wi vx cv vy cv wceq
      vx cv cA wcel wph wi vx cv cA wcel wph vx cv vy cv wceq wb wi vx cv cA
      wcel vx cv vy cv wceq wph wph vx cv vy cv wceq wb vx cv vy cv wceq wph wi
      vx cv cA wcel wph vx cv vy cv wceq bi2 imim2i com23 imp adantll jcai ex
      impbid 19.20i impbii wph vx cv vy cv wceq wb vx cA wral vx cv cA wcel wph
      vx cv vy cv wceq wb wi vx wal vy cv cA wcel wph vx cv vy cv wceq wb vx cA
      df-ral anbi2i 3bitr4i exbii wph vx cv vy cv wceq wb vx cA wral vy cA
      df-rex bitr4i 3bitri $.
      $( [21-Oct-2006] $) $( [20-Oct-2006] $)

    $( A way to express restricted uniqueness. $)
    reu3 $p |- ( E! x e. A ph <->
               ( E. x e. A ph /\ E. y e. A A. x e. A ( ph -> x = y ) ) ) $=
      wph vx cA wreu wph vx cA wrex wph vx cv vy cv wceq wi vx cA wral vy cA
      wrex wa wph vx cA wreu wph vx cA wrex wph vx cv vy cv wceq wi vx cA wral
      vy cA wrex wph vx cA reurex wph vx cA wreu wph vx cv vy cv wceq wb vx cA
      wral vy cA wrex wph vx cv vy cv wceq wi vx cA wral vy cA wrex wph vx vy
      cA reu6 wph vx cv vy cv wceq wb vx cA wral wph vx cv vy cv wceq wi vx cA
      wral vy cA wph vx cv vy cv wceq wb wph vx cv vy cv wceq wi vx cA wph vx
      cv vy cv wceq bi1 r19.20si r19.22si sylbi jca wph vx cA wrex wph vx cv vy
      cv wceq wi vx cA wral vy cA wrex wa wph vx cA wrex wph vx cv vy cv wceq
      wi vx cA wral vy wex wa wph vx cA wreu wph vx cv vy cv wceq wi vx cA wral
      vy cA wrex wph vx cv vy cv wceq wi vx cA wral vy wex wph vx cA wrex wph
      vx cv vy cv wceq wi vx cA wral vy cA rexex anim2i vx cv cA wcel wph wa vx
      weu vx cv cA wcel wph wa vx wex vx cv cA wcel wph wa vx cv vy cv wceq wi
      vx wal vy wex wa wph vx cA wreu wph vx cA wrex wph vx cv vy cv wceq wi vx
      cA wral vy wex wa vx cv cA wcel wph wa vx vy vx cv cA wcel wph wa vy
      ax-17 eu3 wph vx cA df-reu wph vx cA wrex vx cv cA wcel wph wa vx wex wph
      vx cv vy cv wceq wi vx cA wral vy wex vx cv cA wcel wph wa vx cv vy cv
      wceq wi vx wal vy wex wph vx cA df-rex wph vx cv vy cv wceq wi vx cA wral
      vx cv cA wcel wph wa vx cv vy cv wceq wi vx wal vy wph vx cv vy cv wceq
      wi vx cA wral vx cv cA wcel wph vx cv vy cv wceq wi wi vx wal vx cv cA
      wcel wph wa vx cv vy cv wceq wi vx wal wph vx cv vy cv wceq wi vx cA
      df-ral vx cv cA wcel wph wa vx cv vy cv wceq wi vx cv cA wcel wph vx cv
      vy cv wceq wi wi vx vx cv cA wcel wph vx cv vy cv wceq impexp albii
      bitr4i exbii anbi12i 3bitr4i sylibr impbii $.
      $( [1-Nov-2006] $) $( [24-Oct-2006] $)
  $}

  ${
    $d x y z A $.  $d y z ph $.  $d x z ps $.
    rmo4.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Restricted "at most one" using implicit substitution. $)
    rmo4 $p |- ( E* x ( x e. A /\ ph ) <->
               A. x e. A A. y e. A ( ( ph /\ ps ) -> x = y ) ) $=
      vx cv cA wcel wph wa vy cv cA wcel wps wa wa vx cv vy cv wceq wi vy wal
      vx wal vx cv cA wcel wph wps wa vx cv vy cv wceq wi vy cA wral wi vx wal
      vx cv cA wcel wph wa vx wmo wph wps wa vx cv vy cv wceq wi vy cA wral vx
      cA wral vx cv cA wcel wph wa vy cv cA wcel wps wa wa vx cv vy cv wceq wi
      vy wal vx cv cA wcel wph wps wa vx cv vy cv wceq wi vy cA wral wi vx vx
      cv cA wcel wph wa vy cv cA wcel wps wa wa vx cv vy cv wceq wi vy wal vy
      cv cA wcel vx cv cA wcel wph wps wa vx cv vy cv wceq wi wi wi vy wal vx
      cv cA wcel wph wps wa vx cv vy cv wceq wi wi vy cA wral vx cv cA wcel wph
      wps wa vx cv vy cv wceq wi vy cA wral wi vx cv cA wcel wph wa vy cv cA
      wcel wps wa wa vx cv vy cv wceq wi vy cv cA wcel vx cv cA wcel wph wps wa
      vx cv vy cv wceq wi wi wi vy vx cv cA wcel wph wa vy cv cA wcel wps wa wa
      vx cv vy cv wceq wi vy cv cA wcel vx cv cA wcel wa wph wps wa wa vx cv vy
      cv wceq wi vy cv cA wcel vx cv cA wcel wa wph wps wa vx cv vy cv wceq wi
      wi vy cv cA wcel vx cv cA wcel wph wps wa vx cv vy cv wceq wi wi wi vx cv
      cA wcel wph wa vy cv cA wcel wps wa wa vy cv cA wcel vx cv cA wcel wa wph
      wps wa wa vx cv vy cv wceq vx cv cA wcel wph wa vy cv cA wcel wps wa wa
      vx cv cA wcel vy cv cA wcel wa wph wps wa wa vy cv cA wcel vx cv cA wcel
      wa wph wps wa wa vx cv cA wcel wph vy cv cA wcel wps an4 vx cv cA wcel vy
      cv cA wcel wa vy cv cA wcel vx cv cA wcel wa wph wps wa vx cv cA wcel vy
      cv cA wcel ancom anbi1i bitri imbi1i vy cv cA wcel vx cv cA wcel wa wph
      wps wa vx cv vy cv wceq impexp vy cv cA wcel vx cv cA wcel wph wps wa vx
      cv vy cv wceq wi impexp 3bitri albii vx cv cA wcel wph wps wa vx cv vy cv
      wceq wi wi vy cA df-ral vx cv cA wcel wph wps wa vx cv vy cv wceq wi vy
      cA r19.21v 3bitr2i albii vx cv cA wcel wph wa vy cv cA wcel wps wa vx vy
      vx cv vy cv wceq vx cv cA wcel vy cv cA wcel wph wps vx cv vy cv cA eleq1
      rmo4.1 anbi12d mo4 wph wps wa vx cv vy cv wceq wi vy cA wral vx cA df-ral
      3bitr4i $.
      $( [24-Oct-2006] $) $( [24-Oct-2006] $)

    $( Restricted uniqueness using implicit substitution. $)
    reu4 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\
             A. x e. A A. y e. A ( ( ph /\ ps ) -> x = y ) ) ) $=
      wph vx cA wreu wph vx cA wrex vx cv cA wcel wph wa vx wmo wa wph vx cA
      wrex wph wps wa vx cv vy cv wceq wi vy cA wral vx cA wral wa wph vx cA
      reu5 vx cv cA wcel wph wa vx wmo wph wps wa vx cv vy cv wceq wi vy cA
      wral vx cA wral wph vx cA wrex wph wps vx vy cA rmo4.1 rmo4 anbi2i bitri
      $.
      $( [23-Nov-1994] $)

    $( Restricted uniqueness using implicit substitution. $)
    reu7 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\
             E. x e. A A. y e. A ( ps -> x = y ) ) ) $=
      wph vx cA wreu wph vx cA wrex wph vx cv vz cv wceq wi vx cA wral vz cA
      wrex wa wph vx cA wrex wps vx cv vy cv wceq wi vy cA wral vx cA wrex wa
      wph vx vz cA reu3 wph vx cv vz cv wceq wi vx cA wral vz cA wrex wps vx cv
      vy cv wceq wi vy cA wral vx cA wrex wph vx cA wrex wph vx cv vz cv wceq
      wi vx cA wral vz cA wrex wps vz cv vy cv wceq wi vy cA wral vz cA wrex
      wps vx cv vy cv wceq wi vy cA wral vx cA wrex wph vx cv vz cv wceq wi vx
      cA wral wps vz cv vy cv wceq wi vy cA wral vz cA wph vx cv vz cv wceq wi
      wps vz cv vy cv wceq wi vx vy cA vx cv vy cv wceq wph wps vx cv vz cv
      wceq vz cv vy cv wceq rmo4.1 vx cv vy cv wceq vx cv vz cv wceq vy cv vz
      cv wceq vz cv vy cv wceq vx cv vy cv vz cv eqeq1 vy cv vz cv eqcom syl6bb
      imbi12d cbvralv rexbii wps vz cv vy cv wceq wi vy cA wral wps vx cv vy cv
      wceq wi vy cA wral vz vx cA vz cv vx cv wceq wps vz cv vy cv wceq wi wps
      vx cv vy cv wceq wi vy cA vz cv vx cv wceq vz cv vy cv wceq vx cv vy cv
      wceq wps vz cv vx cv vy cv eqeq1 imbi2d ralbidv cbvrexv bitri anbi2i
      bitri $.
      $( [12-Nov-2006] $) $( [24-Oct-2006] $)

    $( Restricted uniqueness using implicit substitution. $)
    reu8 $p |- ( E! x e. A ph <-> E. x e. A ( ph /\
                A. y e. A ( ps -> x = y ) ) ) $=
      wph vx cA wreu wps vy cA wreu wps vy cv vx cv wceq wb vy cA wral vx cA
      wrex wph wps vx cv vy cv wceq wi vy cA wral wa vx cA wrex wph wps vx vy
      cA rmo4.1 cbvreuv wps vy vx cA reu6 wps vy cv vx cv wceq wb vy cA wral
      wph wps vx cv vy cv wceq wi vy cA wral wa vx cA vx cv cA wcel wps vy cv
      vx cv wceq wi vy cv vx cv wceq wps wi wa vy cA wral wph wps vx cv vy cv
      wceq wi vy cA wral wa wps vy cv vx cv wceq wb vy cA wral vx cv cA wcel
      wph wps vx cv vy cv wceq wi vy cA wral wa wps vy cv vx cv wceq wi vy cA
      wral vy cv vx cv wceq wps wi vy cA wral wa wps vy cv vx cv wceq wi vy cv
      vx cv wceq wps wi wa vy cA wral vx cv cA wcel wps vx cv vy cv wceq wi vy
      cA wral wph wa wps vy cv vx cv wceq wi vy cA wral vy cv vx cv wceq wps wi
      vy cA wral wa wph wps vx cv vy cv wceq wi vy cA wral wa vx cv cA wcel wps
      vx cv vy cv wceq wi vy cA wral wps vy cv vx cv wceq wi vy cA wral wph vy
      cv vx cv wceq wps wi vy cA wral wps vx cv vy cv wceq wi vy cA wral wps vy
      cv vx cv wceq wi vy cA wral wb vx cv cA wcel wps vx cv vy cv wceq wi wps
      vy cv vx cv wceq wi vy cA vx cv vy cv wceq vy cv vx cv wceq wps vx cv vy
      cv eqcom imbi2i ralbii a1i vx cv cA wcel wph vx cv cA wcel wph wi vy cv
      vx cv wceq wps wi vy cA wral vx cv cA wcel wph biimt vy cv vx cv wceq wps
      wi vy cA wral vy cv cA wcel vy cv vx cv wceq wps wi wi vy wal vy cv vx cv
      wceq vy cv cA wcel wps wi wi vy wal vx cv cA wcel wph wi vy cv vx cv wceq
      wps wi vy cA df-ral vy cv cA wcel vy cv vx cv wceq wps wi wi vy cv vx cv
      wceq vy cv cA wcel wps wi wi vy vy cv cA wcel vy cv vx cv wceq wps bi2.04
      albii vy cv cA wcel wps wi vx cv cA wcel wph wi vy vx cv vx visset vy cv
      cA wcel wps wi vx cv cA wcel wph wi wb vx cv vy cv vx cv vy cv wceq vx cv
      cA wcel wph wi vy cv cA wcel wps wi vx cv vy cv wceq vx cv cA wcel vy cv
      cA wcel wph wps vx cv vy cv cA eleq1 rmo4.1 imbi12d bicomd eqcoms ceqsalv
      3bitrri syl6bb anbi12d wph wps vx cv vy cv wceq wi vy cA wral ancom
      syl5bb wps vy cv vx cv wceq wi vy cv vx cv wceq wps wi vy cA r19.26
      syl6rbbr wps vy cv vx cv wceq wb wps vy cv vx cv wceq wi vy cv vx cv wceq
      wps wi wa vy cA wps vy cv vx cv wceq dfbi2 ralbii syl5bb rexbiia 3bitri
      $.
      $( [25-Oct-2006] $) $( [24-Oct-2006] $)
  $}

  ${
    $d x y A $.
    $( A condition allowing swap of uniqueness and existential quantifiers. $)
    2reuswap $p |- ( A. x e. A E* y ( y e. A /\ ph ) ->
                   ( E! x e. A E. y e. A ph -> E! y e. A E. x e. A ph ) ) $=
      vy cv cA wcel wph wa vy wmo vx cA wral vx cv cA wcel vy cv cA wcel wph wa
      wa vy wmo vx wal wph vy cA wrex vx cA wreu wph vx cA wrex vy cA wreu wi
      vy cv cA wcel wph wa vy wmo vx cA wral vx cv cA wcel vy cv cA wcel wph wa
      vy wmo wi vx wal vx cv cA wcel vy cv cA wcel wph wa wa vy wmo vx wal vy
      cv cA wcel wph wa vy wmo vx cA df-ral vx cv cA wcel vy cv cA wcel wph wa
      wa vy wmo vx cv cA wcel vy cv cA wcel wph wa vy wmo wi vx vx cv cA wcel
      vy cv cA wcel wph wa vy moanimv albii bitr4i vx cv cA wcel vy cv cA wcel
      wph wa wa vy wmo vx wal vx cv cA wcel vy cv cA wcel wph wa wa vy wex vx
      weu vx cv cA wcel vy cv cA wcel wph wa wa vx wex vy weu wph vy cA wrex vx
      cA wreu wph vx cA wrex vy cA wreu vx cv cA wcel vy cv cA wcel wph wa wa
      vx vy 2euswap wph vy cA wrex vx cA wreu vx cv cA wcel wph vy cA wrex wa
      vx weu vx cv cA wcel vy cv cA wcel wph wa wa vy wex vx weu wph vy cA wrex
      vx cA df-reu vx cv cA wcel wph vy cA wrex wa vx cv cA wcel vy cv cA wcel
      wph wa wa vy wex vx vx cv cA wcel wph wa vy cA wrex vy cv cA wcel vx cv
      cA wcel wph wa wa vy wex vx cv cA wcel wph vy cA wrex wa vx cv cA wcel vy
      cv cA wcel wph wa wa vy wex vx cv cA wcel wph wa vy cA df-rex vx cv cA
      wcel wph vy cA r19.42v vy cv cA wcel vx cv cA wcel wph wa wa vx cv cA
      wcel vy cv cA wcel wph wa wa vy vy cv cA wcel vx cv cA wcel wph an12
      exbii 3bitr3i eubii bitri wph vx cA wrex vy cA wreu vy cv cA wcel wph vx
      cA wrex wa vy weu vx cv cA wcel vy cv cA wcel wph wa wa vx wex vy weu wph
      vx cA wrex vy cA df-reu vy cv cA wcel wph vx cA wrex wa vx cv cA wcel vy
      cv cA wcel wph wa wa vx wex vy vy cv cA wcel wph vx cA wrex wa vy cv cA
      wcel wph wa vx cA wrex vx cv cA wcel vy cv cA wcel wph wa wa vx wex vy cv
      cA wcel wph vx cA r19.42v vy cv cA wcel wph wa vx cA df-rex bitr3i eubii
      bitri 3imtr4g sylbi $.
      $( [16-Nov-2004] $) $( [14-Nov-2004] $)
  $}

  ${
    $d w y z A $.  $d x z B $.  $d w x y z C $.  $d w y z ph $.  $d x z ps $.
    reuind.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    reuind.2 $e |- ( x = y -> A = B ) $.
    $( Existential uniqueness via an indirect equality. $)
    reuind $p |- ( ( A. x A. y ( ( ( A e. C /\ ph ) /\ ( B e. C /\ ps ) )
         -> A = B ) /\ E. x ( A e. C /\ ph ) )
                 -> E! z e. C A. x ( ( A e. C /\ ph ) -> z = A ) ) $=
      cA cC wcel wph wa vz cv cA wceq wi vx wal vz cC wreu cA cC wcel wph wa vz
      cv cA wceq wi vx wal vz cC wrex cA cC wcel wph wa vz cv cA wceq wi vx wal
      cA cC wcel wph wa vw cv cA wceq wi vx wal wa vz cv vw cv wceq wi vw cC
      wral vz cC wral cA cC wcel wph wa cB cC wcel wps wa wa cA cB wceq wi vy
      wal vx wal cA cC wcel wph wa vx wex wa cA cC wcel wph wa vz cv cA wceq wi
      vx wal cA cC wcel wph wa vw cv cA wceq wi vx wal vz vw cC vz cv vw cv
      wceq cA cC wcel wph wa vz cv cA wceq wi cA cC wcel wph wa vw cv cA wceq
      wi vx vz cv vw cv wceq vz cv cA wceq vw cv cA wceq cA cC wcel wph wa vz
      cv vw cv cA eqeq1 imbi2d albidv reu4 cA cC wcel wph wa cB cC wcel wps wa
      wa cA cB wceq wi vy wal vx wal cA cC wcel wph wa vx wex cA cC wcel wph wa
      vz cv cA wceq wi vx wal vz cC wrex cA cC wcel wph wa cB cC wcel wps wa wa
      cA cB wceq wi vy wal vx wal vz cv cB wceq wps wa vy wex vz cC wrex cA cC
      wcel wph wa vz cv cA wceq wi vx wal vz cC wrex cA cC wcel wph wa vx wex
      cA cC wcel wph wa cB cC wcel wps wa wa cA cB wceq wi vy wal vx wal vz cv
      cB wceq wps wa vy wex cA cC wcel wph wa vz cv cA wceq wi vx wal vz cC cA
      cC wcel wph wa cB cC wcel wps wa wa cA cB wceq wi vy wal vx wal vz cv cC
      wcel vz cv cB wceq wps wa vy wex cA cC wcel wph wa vz cv cA wceq wi vx
      wal cA cC wcel wph wa cB cC wcel wps wa wa cA cB wceq wi vy wal vx wal vz
      cv cB wceq cB cC wcel wps wa wa cA cC wcel wph wa vz cv cA wceq wi wi vy
      wal vx wal vz cv cC wcel vz cv cB wceq wps wa vy wex wa cA cC wcel wph wa
      vz cv cA wceq wi vx wal wi cA cC wcel wph wa cB cC wcel wps wa wa cA cB
      wceq wi vz cv cB wceq cB cC wcel wps wa wa cA cC wcel wph wa vz cv cA
      wceq wi wi vx vy cA cC wcel wph wa cB cC wcel wps wa wa cA cB wceq wi cA
      cC wcel wph wa cB cC wcel wps wa wa vz cv cA wceq vz cv cB wceq wb wi vz
      cv cB wceq cB cC wcel wps wa wa cA cC wcel wph wa vz cv cA wceq wi wi cA
      cB wceq vz cv cA wceq vz cv cB wceq wb cA cC wcel wph wa cB cC wcel wps
      wa wa cA cB vz cv eqeq2 imim2i cA cC wcel wph wa cB cC wcel wps wa wa vz
      cv cA wceq vz cv cB wceq wb wi cA cC wcel wph wa cB cC wcel wps wa wa vz
      cv cB wceq vz cv cA wceq wi wi vz cv cB wceq cB cC wcel wps wa wa cA cC
      wcel wph wa vz cv cA wceq wi wi vz cv cA wceq vz cv cB wceq wb vz cv cB
      wceq vz cv cA wceq wi cA cC wcel wph wa cB cC wcel wps wa wa vz cv cA
      wceq vz cv cB wceq bi2 imim2i cA cC wcel wph wa cB cC wcel wps wa wa vz
      cv cB wceq wa vz cv cA wceq wi vz cv cB wceq cB cC wcel wps wa wa cA cC
      wcel wph wa wa vz cv cA wceq wi cA cC wcel wph wa cB cC wcel wps wa wa vz
      cv cB wceq vz cv cA wceq wi wi vz cv cB wceq cB cC wcel wps wa wa cA cC
      wcel wph wa vz cv cA wceq wi wi cA cC wcel wph wa cB cC wcel wps wa wa vz
      cv cB wceq wa vz cv cB wceq cB cC wcel wps wa wa cA cC wcel wph wa wa vz
      cv cA wceq cA cC wcel wph wa cB cC wcel wps wa wa vz cv cB wceq wa cA cC
      wcel wph wa vz cv cB wceq wa cB cC wcel wps wa wa vz cv cB wceq cA cC
      wcel wph wa wa cB cC wcel wps wa wa vz cv cB wceq cB cC wcel wps wa wa cA
      cC wcel wph wa wa cA cC wcel wph wa cB cC wcel wps wa vz cv cB wceq an23
      cA cC wcel wph wa vz cv cB wceq wa vz cv cB wceq cA cC wcel wph wa wa cB
      cC wcel wps wa cA cC wcel wph wa vz cv cB wceq ancom anbi1i vz cv cB wceq
      cA cC wcel wph wa cB cC wcel wps wa an23 3bitri imbi1i cA cC wcel wph wa
      cB cC wcel wps wa wa vz cv cB wceq vz cv cA wceq impexp vz cv cB wceq cB
      cC wcel wps wa wa cA cC wcel wph wa vz cv cA wceq impexp 3bitr3i sylib
      syl 19.20i2 vz cv cB wceq cB cC wcel wps wa wa cA cC wcel wph wa vz cv cA
      wceq wi wi vy wal vx wal vz cv cC wcel vz cv cB wceq wps wa vy wex wa cA
      cC wcel wph wa vz cv cA wceq wi wi vx wal vz cv cC wcel vz cv cB wceq wps
      wa vy wex wa cA cC wcel wph wa vz cv cA wceq wi vx wal wi vz cv cB wceq
      cB cC wcel wps wa wa cA cC wcel wph wa vz cv cA wceq wi wi vy wal vz cv
      cC wcel vz cv cB wceq wps wa vy wex wa cA cC wcel wph wa vz cv cA wceq wi
      wi vx vz cv cB wceq cB cC wcel wps wa wa cA cC wcel wph wa vz cv cA wceq
      wi wi vy wal vz cv cB wceq cB cC wcel wps wa wa vy wex cA cC wcel wph wa
      vz cv cA wceq wi wi vz cv cC wcel vz cv cB wceq wps wa vy wex wa cA cC
      wcel wph wa vz cv cA wceq wi wi vz cv cB wceq cB cC wcel wps wa wa cA cC
      wcel wph wa vz cv cA wceq wi vy 19.23v vz cv cB wceq cB cC wcel wps wa wa
      vy wex vz cv cC wcel vz cv cB wceq wps wa vy wex wa cA cC wcel wph wa vz
      cv cA wceq wi vz cv cB wceq cB cC wcel wps wa wa vy wex vz cv cC wcel vz
      cv cB wceq wps wa wa vy wex vz cv cC wcel vz cv cB wceq wps wa vy wex wa
      vz cv cB wceq cB cC wcel wps wa wa vz cv cC wcel vz cv cB wceq wps wa wa
      vy vz cv cB wceq cB cC wcel wps wa wa cB cC wcel vz cv cB wceq wps wa wa
      vz cv cC wcel vz cv cB wceq wps wa wa vz cv cB wceq cB cC wcel wps an12
      vz cv cB wceq wps wa vz cv cC wcel cB cC wcel vz cv cB wceq vz cv cC wcel
      cB cC wcel wb wps vz cv cB cC eleq1 adantr pm5.32ri bitr4i exbii vz cv cC
      wcel vz cv cB wceq wps wa vy 19.42v bitri imbi1i bitri albii vz cv cC
      wcel vz cv cB wceq wps wa vy wex wa cA cC wcel wph wa vz cv cA wceq wi vx
      19.21v bitri sylib exp3a r19.22dv cA cC wcel wph wa vx wex cB cC wcel wps
      wa vy wex vz cv cB wceq vz cC wrex wps wa vy wex vz cv cB wceq wps wa vy
      wex vz cC wrex cA cC wcel wph wa cB cC wcel wps wa vx vy vx cv vy cv wceq
      cA cC wcel cB cC wcel wph wps vx cv vy cv wceq cA cB cC reuind.2 eleq1d
      reuind.1 anbi12d cbvexv cB cC wcel wps wa vz cv cB wceq vz cC wrex wps wa
      vy cB cC wcel vz cv cB wceq vz cC wrex wps vz cB cC risset anbi1i exbii
      vz cv cB wceq wps wa vy wex vz cC wrex vz cv cB wceq wps wa vz cC wrex vy
      wex vz cv cB wceq vz cC wrex wps wa vy wex vz cv cB wceq wps wa vz vy cC
      rexcom4 vz cv cB wceq wps wa vz cC wrex vz cv cB wceq vz cC wrex wps wa
      vy vz cv cB wceq wps vz cC r19.41v exbii bitr2i 3bitri syl5ib imp cA cC
      wcel wph wa vx wex cA cC wcel wph wa vz cv cA wceq wi vx wal cA cC wcel
      wph wa vw cv cA wceq wi vx wal wa vz cv vw cv wceq wi vw cC wral vz cC
      wral cA cC wcel wph wa cB cC wcel wps wa wa cA cB wceq wi vy wal vx wal
      cA cC wcel wph wa vx wex cA cC wcel wph wa vz cv cA wceq wi vx wal cA cC
      wcel wph wa vw cv cA wceq wi vx wal wa vz cv vw cv wceq wi vz vw cC cC cA
      cC wcel wph wa vx wex cA cC wcel wph wa vz cv cA wceq wi vx wal cA cC
      wcel wph wa vw cv cA wceq wi vx wal wa vz cv vw cv wceq wi vz cv cC wcel
      vw cv cC wcel wa cA cC wcel wph wa vx wex cA cC wcel wph wa vz cv vw cv
      wceq wi vx wal vz cv vw cv wceq cA cC wcel wph wa vz cv cA wceq wi vx wal
      cA cC wcel wph wa vw cv cA wceq wi vx wal wa cA cC wcel wph wa vz cv vw
      cv wceq wi vx wal cA cC wcel wph wa vx wex vz cv vw cv wceq cA cC wcel
      wph wa vz cv vw cv wceq wi vx wal cA cC wcel wph wa vx wex vz cv vw cv
      wceq wi cA cC wcel wph wa vz cv vw cv wceq vx 19.23v biimpi com12 cA cC
      wcel wph wa vz cv cA wceq wi vx wal cA cC wcel wph wa vw cv cA wceq wi vx
      wal wa cA cC wcel wph wa vz cv cA wceq wi cA cC wcel wph wa vw cv cA wceq
      wi wa vx wal cA cC wcel wph wa vz cv vw cv wceq wi vx wal cA cC wcel wph
      wa vz cv cA wceq wi cA cC wcel wph wa vw cv cA wceq wi vx 19.26 cA cC
      wcel wph wa vz cv cA wceq wi cA cC wcel wph wa vw cv cA wceq wi wa cA cC
      wcel wph wa vz cv vw cv wceq wi vx cA cC wcel wph wa vz cv cA wceq wi cA
      cC wcel wph wa vw cv cA wceq wi wa cA cC wcel wph wa cA cC wcel wph wa wa
      vz cv cA wceq vw cv cA wceq wa wi cA cC wcel wph wa vz cv vw cv wceq wi
      cA cC wcel wph wa vz cv cA wceq cA cC wcel wph wa vw cv cA wceq prth cA
      cC wcel wph wa cA cC wcel wph wa cA cC wcel wph wa wa vz cv cA wceq vw cv
      cA wceq wa vz cv vw cv wceq cA cC wcel wph wa cA cC wcel wph wa cA cC
      wcel wph wa wa cA cC wcel wph wa pm4.24 biimpi vz cv vw cv cA eqtr3
      imim12i syl 19.20i sylbir syl5 a1d r19.21aivv adantl sylanbrc $.
      $( [16-Oct-2010] $) $( [16-Oct-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Russell's Paradox
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Russell's Paradox.  Proposition 4.14 of [TakeutiZaring] p. 14.  Frege's
       Axiom of (unrestricted) Comprehension, expressed in our notation as
       ` A e. _V ` , asserted that any collection of sets ` A ` is a set i.e.
       belongs to the universe ` _V ` of all sets.  In particular, by
       substituting ` { x | x e/ x } ` (the "Russell class") for ` A ` , it
       asserted ` { x | x e/ x } e. _V ` , meaning that the "collection of all
       sets which are not members of themselves" is a set.  However, here we
       prove ` { x | x e/ x } e/ _V ` . This contradiction was discovered by
       Russell in 1901 (published in 1903), invalidating Comprehension and
       leading to the collapse of Frege's system.

       In 1908 Zermelo rectified this fatal flaw by replacing Comprehension
       with a weaker Subset (or Separation) Axiom ~ ssex asserting that ` A `
       is a set only when it is smaller than some other set ` B ` . However,
       Zermelo was then faced with a "chicken and egg" problem of how to show
       ` B ` is a set, leading him to introduce the set-building axioms of Null
       Set ~ 0ex , Pairing ~ prex , Union ~ uniex , Power Set ~ pwex , and
       Infinity ~ omex to give him some starting sets to work with (all of
       which, before Russell's Paradox, were immediate consequences of Frege's
       Comprehension).  In 1922 Fraenkel strengthened the Subset Axiom with our
       present Replacement Axiom ~ funimaex (whose modern formalization is due
       to Skolem, also in 1922).  Thus in a very real sense Russell's Paradox
       spawned the invention of ZF set theory and completely revised the
       foundations of mathematics!

       Another mainstream formalization of set theory, devised by von
       Neumann, Bernays, and Goedel, uses class variables rather than set
       variables as its primitives.  The axiom system NBG in [Mendelson]
       p. 225 is suitable for a Metamath encoding.  NBG is a conservative
       extension of ZF in that it proves exactly the same theorems as ZF that
       are expressible in the language of ZF.  An advantage of NBG is that it
       is finitely axiomatizable - the Axiom of Replacement can be broken down
       into a finite set of formulas that eliminate its wff metavariable.
       Finite axiomatizability is required by some proof languages (although
       not by Metamath).  There is a stronger version of NBG called
       Morse-Kelley (axiom system MK in [Mendelson] p. 287).

       Russell himself continued in a different direction, avoiding the paradox
       with his "theory of types."  Quine extended Russell's ideas to formulate
       the very strong New Foundations set theory (axiom system NF of [Quine]
       p. 331).  In NF, the collection of all sets is a set, contradicting ZF
       and NBG set theories, and it has other bizarre consequences:  when sets
       become too huge (beyond the size of those used in standard mathematics),
       the Axiom of Choice ~ ac4 and Cantor's Theorem ~ canth are provably
       false!  (See ~ ncanth for some intuition behind the latter.)
       Nonetheless, NF has not been shown to be inconsistent and has its
       advocates - who's to say which set theory is "right"?  NF is finitely
       axiomatizable and can be encoded in Metamath using the axioms from
       T. Hailperin, "A set of axioms for logic," _J. Symb. Logic_ 9:1-19
       (1944).

       Under our ZF set theory, every set is a member of the Russell class by
       ~ elirrv (derived from the Axiom of Regularity), so for us the Russell
       class equals the universe ` _V ` (theorem ~ ruv ).  See ~ ruALT for an
       alternate proof of ~ ru derived from that fact. $)
    ru $p |- { x | x e/ x } e/ _V $=
      vx cv vx cv wnel vx cab cvv wnel vx cv vx cv wnel vx cab cvv wcel wn vx
      cv vx cv wnel vx cab cvv wcel vy cv vx cv vx cv wnel vx cab wceq vy wex
      vy cv vx cv vx cv wnel vx cab wceq vy vy cv vx cv vx cv wnel vx cab wceq
      vx cv vy cv wcel vx cv vx cv wnel wb vx wal vx cv vy cv wcel vx cv vx cv
      wnel wb vx wal vy cv vy cv wcel vy cv vy cv wcel wn wb vy cv vy cv wcel
      pm5.19 vx cv vy cv wcel vx cv vx cv wnel wb vy cv vy cv wcel vy cv vy cv
      wcel wn wb vx vy vx cv vy cv wceq vx cv vy cv wcel vy cv vy cv wcel vx cv
      vx cv wnel vy cv vy cv wcel wn vx cv vy cv vy cv eleq1 vx cv vy cv wceq
      vx cv vx cv wcel wn vy cv vy cv wcel wn vx cv vx cv wnel vx cv vy cv wceq
      vx cv vx cv wcel vy cv vy cv wcel vx cv vy cv wceq vx cv vy cv vx cv vy
      cv vx cv vy cv wceq id vx cv vy cv wceq id eleq12d notbid vx cv vx cv
      df-nel syl5bb bibi12d a4v mto vx cv vx cv wnel vx vy cv abeq2 mtbir nex
      vy vx cv vx cv wnel vx cab isset mtbir vx cv vx cv wnel vx cab cvv df-nel
      mpbir $.
      $( [4-Oct-2008] $) $( [7-Aug-1994] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Proper substitution of classes for sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.  $d x y $.
    sbhypf.1 $e |- ( ps -> A. x ps ) $.
    sbhypf.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Introduce an explicit substitution into an implicit substitution
       hypothesis.  See also ~ csbhypf .  (Contributed by Raph Levien,
       10-Apr-2004.) $)
    sbhypf $p |- ( y = A -> ( [ y / x ] ph <-> ps ) ) $=
      vy cv cA wceq vx cv vy cv wceq vx cv cA wceq wa vx wex wph vx vy cv wsbc
      wps wb vx cv cA wceq vy cv cA wceq vx vy cv vy visset vx cv vy cv cA
      eqeq1 ceqsexv vx cv vy cv wceq vx cv cA wceq wa wph vx vy cv wsbc wps wb
      vx wph vx vy cv wsbc wps vx wph vx vy hbs1 sbhypf.1 hbbi vx cv vy cv wceq
      wph vx vy cv wsbc wph vx cv cA wceq wps vx cv vy cv wceq wph wph vx vy cv
      wsbc wph vx vy sbequ12 bicomd sbhypf.2 sylan9bb 19.23ai sylbir $.
      $( [5-Mar-2008] $) $( 2-Mar-2008] $)
  $}

  ${
    $d x y z $.  $d y z ph $.  $d x z ps $.
    sbralie.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Implicit to explicit substitution that swaps variables in a quantified
       expression. $)
    sbralie $p |- ( [ x / y ] A. x e. y ph <-> A. y e. x ps ) $=
      wph vx vy cv wral vy vx cv wsbc wph vx vz cv wsbc vz vx cv wral wph vx vz
      cv wsbc vz vy cv wsbc vy vx cv wral wps vy vx cv wral wph vx vy cv wral
      vy vx cv wsbc wph vx vz cv wsbc vz vy cv wral vy vx cv wsbc wph vx vz cv
      wsbc vz vx cv wral wph vx vy cv wral wph vx vz cv wsbc vz vy cv wral vy
      vx wph wph vx vz cv wsbc vx vz vy cv wph vz ax-17 wph vx vz hbs1 wph vx
      vz sbequ12 cbvral sbbii wph vx vz cv wsbc vz vy cv wral wph vx vz cv wsbc
      vz vx cv wral vy vx wph vx vz cv wsbc vz vx cv wral vy ax-17 wph vx vz cv
      wsbc vz vy cv vx cv raleq1 sbie bitri wph vx vz cv wsbc wph vx vz cv wsbc
      vz vy cv wsbc vz vy vx cv wph vx vz cv wsbc vy ax-17 wph vx vz cv wsbc vz
      vy hbs1 wph vx vz cv wsbc vz vy sbequ12 cbvral wph vx vz cv wsbc vz vy cv
      wsbc wps vy vx cv wph vx vz cv wsbc vz vy cv wsbc wph vx vy cv wsbc wps
      wph vx vy vz wph vz ax-17 sbco2 wph wps vx vy wps vx ax-17 sbralie.1 sbie
      bitri ralbii 3bitri $.
      $( [6-Sep-2004] $) $( [5-Sep-2004] $)
  $}

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff notation to include the proper substitution of a class for a
     set.  This definition "overloads" the previously defined variable
     substitution ~ wsb (where the first argument is a set variable rather
     than a class variable).  We take care to ensure that this new definition
     is a conservative extension.  Read this notation as "the proper
     substitution of class ` A ` for set variable ` x ` in wff ` ph ` ." @)
  wsbc @a wff [ A / x ] ph @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Define the proper substitution of a class for a set.  This definition
     applies to proper classes but is not meaningful in that case (and does not
     produce the same results as Definition 6.6 of [Quine] p. 42).  This
     definition is somewhat arbitrary in how it behaves with proper classes -
     e.g., we could have used ~ sbc6 , which yields a different result for
     proper classes.  In order to allow for a possible alternate but
     conflicting definition in the future, we will not commit to any specific
     proper class behavior.  Instead, we will use this definition _only_ to
     prove ~ dfsbcq , which will in turn serve as the starting point for all
     theorems based on the definition.  Note: this definition extends or
     "overloads" ~ df-sb which (via ~ df-clab ) becomes a special case of it,
     so a careful metalogical soundness justification, outside of Metamath,
     is needed for complete rigor; alternately, we could treat this definition
     as a new axiom.

     The related definition ~ df-csb defines proper substitution into a class
     variable (as opposed to a wff variable). $)
  df-sbc $a |- ( [ A / x ] ph <-> A e. { x | ph } ) $.

  $( This theorem, which is similar to Theorem 6.7 of [Quine] p. 42, provides
     us with a weak definition of the proper substitution of a class for a set,
     which we will use in place of ~ df-sbc above.  We will derive all our
     results from starting from here instead of ~ df-sbc . As a consequence, we
     can derive ~ elabs , which is a weaker version of ~ df-sbc that leaves
     substitution undefined when ` A ` is a proper class.  We thus leave
     unspecified the "official" behavior for proper classes, which could be as
     in the ~ sbc5 assertion (always false) or as in ~ sbc6 (always true), or
     some more meaningful possibility in the future, that some clever person
     may discover, that is closer to Quine's definition.  (Quine's definition
     has neither behavior for proper classes, and by using ~ dfsbcq as the
     definition, we leave it unspecified so as not to conflict.  Quine's
     definition is based on the formula's structure rather than its logical
     properties and apparently cannot be expressed directly in our formal
     system.)

     While in principle we could have made this theorem the official
     definition, we use ~ df-sbc because it is more obviously eliminable and
     thus easier to justify metalogically.  But to avoid conflict with Quine,
     we never use ~ df-sbc except indirectly via this theorem. $)
  dfsbcq $p |- ( A = B -> ( [ A / x ] ph <-> [ B / x ] ph ) ) $=
    cA cB wceq cA wph vx cab wcel cB wph vx cab wcel wph vx cA wsbc wph vx cB
    wsbc cA cB wph vx cab eleq1 wph vx cA df-sbc wph vx cB df-sbc 3bitr4g $.
    $( [14-Apr-1995] $)

  $( Equality theorem for class substitution. $)
  sbceq1a $p |- ( x = A -> ( ph <-> [ A / x ] ph ) ) $=
    vx cv cA wceq wph vx vx cv wsbc wph vx cA wsbc wph wph vx vx cv cA dfsbcq
    wph vx sbid syl5bbr $.
    $( [26-Sep-2003] $)

  ${
    $d ph y $.  $d A y $.  $d x y $.
    $( Specialization:  if a formula is true for all sets, it is true for
       any class which is a set.  Similar to Theorem 6.11 of [Quine] p. 44.
       See also ~ stdpc4 and ~ ra4sbc . $)
    a4sbc $p |- ( A e. B -> ( A. x ph -> [ A / x ] ph ) ) $=
      wph vx wal wph vx cA wsbc wi vy cA cB vy cv cA wceq wph vx vy cv wsbc wph
      vx cA wsbc wph vx wal wph vx vy cv cA dfsbcq wph vx vy stdpc4 syl5bi
      vtocleg $.
      $( [17-Jan-2004] $) $( [16-Jan-2004] $)
  $}

  ${
    sbcth.1 $e |- ph $.
    $( A substitution into a theorem remains true (when ` A ` is a set). $)
    sbcth $p |- ( A e. B -> [ A / x ] ph ) $=
      cA cB wcel wph vx wal wph vx cA wsbc wph vx sbcth.1 ax-gen wph vx cA cB
      a4sbc mpi $.
      $( [7-Nov-2005] $) $( [5-Nov-2005] $)
  $}

  ${
    $d x ph $.
    sbcthdv.1 $e |- ( ph -> ps ) $.
    $( Deduction version of ~ sbcth . $)
    sbcthdv $p |- ( ( ph /\ A e. B ) -> [ A / x ] ps ) $=
      wph cA cB wcel wa wps vx wal wps vx cA wsbc wph wps vx wal cA cB wcel wph
      wps vx sbcthdv.1 19.21aiv adantr cA cB wcel wps vx wal wps vx cA wsbc wi
      wph wps vx cA cB a4sbc adantl mpd $.
      $( [2-Dec-2005] $) $( [30-Nov-2005] $)
  $}

  ${
    $d x y z $.  $d y A z $.  $d ph z $.
    hbsbc1g.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for class substitution.  (The
       antecedent ensures that ` A ` is a set, which is necessary if we
       restrict ourselves to using only the "weak" class substitution
       definition ~ dfsbcq .) $)
    hbsbc1g $p |- ( A e. B -> ( [ A / x ] ph -> A. x [ A / x ] ph ) ) $=
      wph vx cA wsbc wph vx cA wsbc vx wal wi vz cA cB vz cv cA wceq wph vx cA
      wsbc wph vx vz cv wsbc wph vx cA wsbc vx wal wph vx vz cv cA dfsbcq vz cv
      cA wceq wph vx vz cv wsbc vx wal wph vx cA wsbc vx wal wph vx vz cv wsbc
      vz cv cA wceq wph vx vz cv wsbc wph vx cA wsbc vx vx vy vy vz cv cA vy cv
      vz cv wcel vx ax-17 hbsbc1g.1 hbeq wph vx vz cv cA dfsbcq albid wph vx vz
      hbs1 syl5bi sylbird vtocleg $.
      $( [13-Oct-2004] $) $( [11-Oct-2004] $)

    ${
      $d x y B $.
      $( Bound-variable hypothesis builder for class substitution.  (The
         antecedent ensures that ` A ` is a set, which is necessary if we
         restrict ourselves to using only the "weak" class substitution
         definition ~ dfsbcq .) $)
      hbsbc1 $p |- ( ( A e. B -> [ A / x ] ph ) ->
                        A. x ( A e. B -> [ A / x ] ph ) ) $=
        cA cB wcel wph vx cA wsbc vx vx vy vy cA cB hbsbc1g.1 vy cv cB wcel vx
        ax-17 hbel wph vx vy cA cB hbsbc1g.1 hbsbc1g hbim1 $.
        $( [23-Aug-1993] $)
    $}
  $}

  ${
    $d x A y $.
    hbsbcv.1 $e |- A e. _V $.
    $( Bound-variable hypothesis builder for class substitution. $)
    hbsbc1v $p |- ( [ A / x ] ph -> A. x [ A / x ] ph ) $=
      cA cvv wcel wph vx cA wsbc wi cA cvv wcel wph vx cA wsbc wi vx wal wph vx
      cA wsbc wph vx cA wsbc vx wal wph vx vy cA cvv vy cv cA wcel vx ax-17
      hbsbc1 cA cvv wcel wph vx cA wsbc hbsbcv.1 a1bi wph vx cA wsbc cA cvv
      wcel wph vx cA wsbc wi vx cA cvv wcel wph vx cA wsbc hbsbcv.1 a1bi albii
      3imtr4i $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d w z A $.  $d w y $.  $d z w x $.  $d w ph $.
    hbsbcg.1 $e |- ( z e. A -> A. x z e. A ) $.
    hbsbcg.2 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for class substitution.  (The proof
       was shortened by Eric Schmidt, 17-Jan-2007.) $)
    hbsbcg $p |- ( A e. B -> ( [ A / y ] ph -> A. x [ A / y ] ph ) ) $=
      wph vy vw cv wsbc wph vy vw cv wsbc vx wal wi wph vy cA wsbc wph vy cA
      wsbc vx wal wi vw cA cB vw cv cA wceq wph vy vw cv wsbc wph vy cA wsbc
      wph vy vw cv wsbc vx wal wph vy cA wsbc vx wal wph vy vw cv cA dfsbcq vw
      cv cA wceq wph vy vw cv wsbc wph vy cA wsbc vx vx vz vz vw cv cA vz cv vw
      cv wcel vx ax-17 hbsbcg.1 hbeq wph vy vw cv cA dfsbcq albid imbi12d wph
      vy vw vx hbsbcg.2 hbsb vtoclg $.
      $( [18-Jan-2007] $) $( [17-Nov-2005] $)
  $}

  ${
    $d x z $.  $d z A $.  $d y z ph $.
    $( A composition law for class substitution. $)
    sbccog $p |- ( A e. B -> ( [ A / y ] [ y / x ] ph <-> [ A / x ] ph ) ) $=
      wph vx vy cv wsbc vy vz cv wsbc wph vx vz cv wsbc wph vx vy cv wsbc vy cA
      wsbc wph vx cA wsbc vz cA cB wph vx vy cv wsbc vy vz cv cA dfsbcq wph vx
      vz cv cA dfsbcq wph vx vz vy wph vy ax-17 sbco2 vtoclbg $.
      $( [11-Jan-2004] $) $( [26-Sep-2003] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d A y $.
    sbcco2.1 $e |- ( x = y -> A = B ) $.
    $( A composition law for class substitution.  Importantly, ` x ` may occur
       free in the class expression substituted for ` A ` . $)
    sbcco2 $p |- ( [ x / y ] [ B / x ] ph <-> [ A / x ] ph ) $=
      wph vx cB wsbc wph vx cA wsbc vy vx wph vx cA wsbc vy ax-17 vy cv vx cv
      wceq cB cA wceq wph vx cB wsbc wph vx cA wsbc wb vx cv vy cv wceq cA cB
      wceq vy cv vx cv wceq cB cA wceq sbcco2.1 vy cv vx cv eqcom cB cA eqcom
      3imtr4i wph vx cB cA dfsbcq syl sbie $.
      $( [6-Sep-2004] $) $( [5-Sep-2004] $)
  $}

  ${
    $d x y A $.
    $( An equivalence for class substitution. $)
    sbc5g $p |- ( A e. B -> ( [ A / x ] ph <-> E. x ( x = A /\ ph ) ) ) $=
      cA cvv wcel cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wa vx wex wb cA
      cB wcel cA cvv wcel cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wa vx
      wex cA cvv wcel vx cv cA wceq wph wa vx wex vx cv cA wceq cA cvv wcel wph
      wi wa vx wex cA cvv wcel vx cv cA wceq wph wa vx wex wi cA cvv wcel wph
      vx cA wsbc wi cA cvv wcel vx cv cA wceq wph wa vx cv cA wceq cA cvv wcel
      wph wi wa vx cA cvv wcel wph cA cvv wcel wph wi vx cv cA wceq cA cvv wcel
      wph biimt anbi2d exbidv cA cvv wcel vx cv cA wceq wph wa vx wex biimt cA
      cvv wcel wph wi cA cvv wcel wph vx cA wsbc wi vx cA cvv wph vx vy cA cvv
      vy cv cA wcel vx ax-17 hbsbc1 vx cv cA wceq wph wph vx cA wsbc cA cvv
      wcel wph vx cA sbceq1a imbi2d ceqsexg 3bitr3rd pm5.74rd cA cB elisset cA
      cB elisset sylc $.
      $( [13-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    $d x y A $.
    $( An equivalence for class substitution. $)
    sbc6g $p |- ( A e. B -> ( [ A / x ] ph <-> A. x ( x = A -> ph ) ) ) $=
      cA cvv wcel cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wi vx wal wb cA
      cB wcel cA cvv wcel cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wi vx
      wal cA cvv wcel vx cv cA wceq wph wi vx wal vx cv cA wceq cA cvv wcel wph
      wi wi vx wal cA cvv wcel vx cv cA wceq wph wi vx wal wi cA cvv wcel wph
      vx cA wsbc wi cA cvv wcel vx cv cA wceq wph wi vx cv cA wceq cA cvv wcel
      wph wi wi vx cA cvv wcel wph cA cvv wcel wph wi vx cv cA wceq cA cvv wcel
      wph biimt imbi2d albidv cA cvv wcel vx cv cA wceq wph wi vx wal biimt cA
      cvv wcel wph wi cA cvv wcel wph vx cA wsbc wi vx cA cvv wph vx vy cA cvv
      vy cv cA wcel vx ax-17 hbsbc1 vx cv cA wceq wph wph vx cA wsbc cA cvv
      wcel wph vx cA sbceq1a imbi2d ceqsalg 3bitr3rd pm5.74rd cA cB elisset cA
      cB elisset sylc $.
      $( [26-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    $d x A $.
    sbc5.1 $e |- A e. _V $.
    $( An equivalence for class substitution. $)
    sbc5 $p |- ( [ A / x ] ph <-> E. x ( x = A /\ ph ) ) $=
      cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wa vx wex wb sbc5.1 wph vx
      cA cvv sbc5g ax-mp $.
      $( [23-Aug-1993] $)
  $}

  ${
    $d x A $.
    sbc6.1 $e |- A e. _V $.
    $( An equivalence for class substitution.  (The proof was shortened by Eric
       Schmidt, 17-Jan-2007.) $)
    sbc6 $p |- ( [ A / x ] ph <-> A. x ( x = A -> ph ) ) $=
      cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wi vx wal wb sbc6.1 wph vx
      cA cvv sbc6g ax-mp $.
      $( [18-Jan-2007] $) $( [23-Aug-1993] $)
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( An equivalence for class substitution in the spirit of ~df-clab .
       Note that ` x ` and ` A ` don't have to be distinct. $)
    sbc7g $p |- ( A e. B -> ( [ A / x ] ph
                     <-> E. y ( y = A /\ [ y / x ] ph ) ) ) $=
      cA cB wcel wph vx vy wsb vy cA wsbc wph vx cA wsbc vy cv cA wceq wph vx
      vy wsb wa vy wex wph vx vy cA cB sbccog wph vx vy wsb vy cA cB sbc5g
      bitr3d $.
      $( [18-Nov-2008] $) $( [18-Nov-2008] $)

    $( This is the closest we can get to ~ df-sbc if we start from ~ dfsbcq
       (see its comments). $)
    sbc8g $p |- ( A e. B -> ( [ A / x ] ph <-> A e. { x | ph } ) ) $=
      cA cB wcel wph vx cA wsbc vy cv cA wceq wph vx vy cv wsbc wa vy wex cA
      wph vx cab wcel wph vx vy cA cB sbc7g cA cB wcel vy cv cA wceq vy cv wph
      vx cab wcel wa vy wex vy cv cA wceq wph vx vy cv wsbc wa vy wex cA wph vx
      cab wcel vy cv cA wceq vy cv wph vx cab wcel wa vy wex vy cv cA wceq wph
      vx vy cv wsbc wa vy wex wb cA cB wcel vy cv cA wceq vy cv wph vx cab wcel
      wa vy cv cA wceq wph vx vy cv wsbc wa vy vy cv wph vx cab wcel wph vx vy
      cv wsbc vy cv cA wceq wph vy vx df-clab anbi2i exbii a1i vy cA wph vx cab
      df-clel syl5rbb bitrd $.
      $( [18-Nov-2008] $) $( [18-Nov-2008] $)
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y A $.
    cbvsbcv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change the bound variable of a class substitution using
       implicit substitution. $)
    cbvsbcv $p |- ( A e. B -> ( [ A / x ] ph <-> [ A / y ] ps ) ) $=
      cA cB wcel vx cv cA wceq wph wa vx wex vy cv cA wceq wps wa vy wex wph vx
      cA wsbc wps vy cA wsbc vx cv cA wceq wph wa vx wex vy cv cA wceq wps wa
      vy wex wb cA cB wcel vx cv cA wceq wph wa vy cv cA wceq wps wa vx vy vx
      cv vy cv wceq vx cv cA wceq vy cv cA wceq wph wps vx cv vy cv cA eqeq1
      cbvsbcv.1 anbi12d cbvexv a1i wph vx cA cB sbc5g wps vy cA cB sbc5g
      3bitr4d $.
      $( [30-Sep-2008] $) $( [30-Sep-2008] $)
  $}

  ${
    $d x A $.
    $( The disjunction of two equivalences for class substitution does not
       require a class existence hypothesis.  This theorem tells us that there
       are only 2 possibilities for defining ` [ A / x ] ph ` behavior at
       proper classes (given a specific ` A ` ), which is interesting since
       ~ dfsbcq (from which it is derived) does not say anything obvious about
       that. $)
    sbc2or $p |- ( ( [ A / x ] ph <-> E. x ( x = A /\ ph ) ) \/
                  ( [ A / x ] ph <-> A. x ( x = A -> ph ) ) ) $=
      cA cvv wcel wph vx cA wsbc vx cv cA wceq wph wa vx wex wb wph vx cA wsbc
      vx cv cA wceq wph wi vx wal wb wo cA cvv wcel wph vx cA wsbc vx cv cA
      wceq wph wa vx wex wb wph vx cA wsbc vx cv cA wceq wph wi vx wal wb wph
      vx cA cvv sbc5g orcd cA cvv wcel wn wph vx cA wsbc vx cv cA wceq wph wa
      vx wex wb wph vx cA wsbc vx cv cA wceq wph wa vx wex wn wb wo wph vx cA
      wsbc vx cv cA wceq wph wa vx wex wb wph vx cA wsbc vx cv cA wceq wph wi
      vx wal wb wo wph vx cA wsbc vx cv cA wceq wph wa vx wex pm5.15 cA cvv
      wcel wn wph vx cA wsbc vx cv cA wceq wph wa vx wex wn wb wph vx cA wsbc
      vx cv cA wceq wph wi vx wal wb wph vx cA wsbc vx cv cA wceq wph wa vx wex
      wb cA cvv wcel wn vx cv cA wceq wph wa vx wex wn vx cv cA wceq wph wi vx
      wal wph vx cA wsbc vx cv cA wceq wph wa vx wex wn vx cv cA wceq wph wi vx
      wal vx cv cA wceq wph wa vx wex wn vx cv cA wceq wph wi vx wal wb cA cvv
      wcel wn vx cv cA wceq wph wa vx wex wn vx cv cA wceq wph wi vx wal pm5.1
      cA cvv wcel wn vx cv cA wceq wph wa vx vx cv cA wceq wph wa cA cvv wcel
      vx cv cA wceq cA cvv wcel wph vx cv cA wceq vx cv cvv wcel cA cvv wcel vx
      visset vx cv cA cvv eleq1 mpbii adantr con3i nexdv cA cvv wcel wn vx cv
      cA wceq wph wi vx cA cvv wcel wn vx cv cA wceq wph vx cv cA wceq cA cvv
      wcel vx cv cA wceq vx cv cvv wcel cA cvv wcel vx visset vx cv cA cvv
      eleq1 mpbii con3i pm2.21d 19.21aiv sylanc bibi2d orbi2d mpbii pm2.61i $.
      $( [26-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    $d x y A $.  $d y ps $.
    $( Conversion of implicit substitution to explicit class substitution,
       using a bound-variable hypothesis instead of distinct variables.
       (Closed theorem version of ~ sbciegf .) $)
    sbciegft $p |- ( ( A e. B /\ A. x ( ps -> A. x ps ) /\
              A. x ( x = A -> ( ph <-> ps ) ) ) -> ( [ A / x ] ph <-> ps ) ) $=
      cA cB wcel wps wps vx wal wi vx wal vx cv cA wceq wph wps wb wi vx wal
      w3a wph vx cA wsbc wps cA cB wcel wps wps vx wal wi vx wal vx cv cA wceq
      wph wps wb wi vx wal w3a wph vx cA wsbc vx cv cA wceq wph wa vx wex wps
      cA cB wcel wps wps vx wal wi vx wal wph vx cA wsbc vx cv cA wceq wph wa
      vx wex wb vx cv cA wceq wph wps wb wi vx wal wph vx cA cB sbc5g 3ad2ant1
      wps wps vx wal wi vx wal vx cv cA wceq wph wps wb wi vx wal vx cv cA wceq
      wph wa vx wex wps wi cA cB wcel wps wps vx wal wi vx wal vx cv cA wceq
      wph wa wps wi vx wal vx cv cA wceq wph wa vx wex wps wi vx cv cA wceq wph
      wps wb wi vx wal wps wps vx wal wi vx wal vx cv cA wceq wph wa wps wi vx
      wal vx cv cA wceq wph wa vx wex wps wi vx cv cA wceq wph wa wps vx 19.23t
      biimpa vx cv cA wceq wph wps wb wi vx cv cA wceq wph wa wps wi vx vx cv
      cA wceq wph wps wb wi vx cv cA wceq wph wps wph wps wb wph wps wi vx cv
      cA wceq wph wps bi1 imim2i imp3a 19.20i sylan2 3adant1 sylbid cA cB wcel
      wps wps vx wal wi vx wal vx cv cA wceq wph wps wb wi vx wal w3a wps vx cv
      cA wceq wph wi vx wal wph vx cA wsbc wps wps vx wal wi vx wal vx cv cA
      wceq wph wps wb wi vx wal wps vx cv cA wceq wph wi vx wal wi cA cB wcel
      wps wps vx wal wi vx wal wps vx cv cA wceq wph wi wi vx wal wps vx cv cA
      wceq wph wi vx wal wi vx cv cA wceq wph wps wb wi vx wal wps wps vx wal
      wi vx wal wps vx cv cA wceq wph wi wi vx wal wps vx cv cA wceq wph wi vx
      wal wi wps vx cv cA wceq wph wi vx 19.21t biimpa vx cv cA wceq wph wps wb
      wi wps vx cv cA wceq wph wi wi vx vx cv cA wceq wph wps wb wi vx cv cA
      wceq wps wph wph wps wb wps wph wi vx cv cA wceq wph wps bi2 imim2i com23
      19.20i sylan2 3adant1 cA cB wcel wps wps vx wal wi vx wal wph vx cA wsbc
      vx cv cA wceq wph wi vx wal wb vx cv cA wceq wph wps wb wi vx wal wph vx
      cA cB sbc6g 3ad2ant1 sylibrd impbid $.
      $( [11-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x A $.  $d x B $.
    sbciegf.1 $e |- ( A e. B -> ( ps -> A. x ps ) ) $.
    sbciegf.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution. $)
    sbciegf $p |- ( A e. B -> ( [ A / x ] ph <-> ps ) ) $=
      cA cB wcel wps wps vx wal wi vx wal wph vx cA wsbc wps wb cA cB wcel wps
      wps vx wal wi vx sbciegf.1 19.21aiv cA cB wcel wps wps vx wal wi vx wal
      vx cv cA wceq wph wps wb wi vx wal wph vx cA wsbc wps wb vx cv cA wceq
      wph wps wb wi vx sbciegf.2 ax-gen cA cB wcel wps wps vx wal wi vx wal vx
      cv cA wceq wph wps wb wi vx wal wph vx cA wsbc wps wb wph wps vx cA cB
      sbciegft 3exp mpii mpd $.
      $( [14-Dec-2005] $) $( [14-Dec-2005] $)
  $}

  ${
    $d x A $.  $d x ps $.
    sbcieg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution. $)
    sbcieg $p |- ( A e. B -> ( [ A / x ] ph <-> ps ) ) $=
      cA cB wcel cA cvv wcel wph vx cA wsbc wps wb cA cB elisset wph wps vx cA
      cvv wps wps vx wal wi cA cvv wcel wps vx ax-17 a1i sbcieg.1 sbciegf syl
      $.
      $( [11-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x A $.  $d x ps $.
    sbcie.1 $e |- A e. _V $.
    sbcie.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution. $)
    sbcie $p |- ( [ A / x ] ph <-> ps ) $=
      cA cvv wcel wph vx cA wsbc wps wb sbcie.1 wph wps vx cA cvv sbcie.2
      sbcieg ax-mp $.
      $( [6-Sep-2004] $) $( [4-Sep-2004] $)
  $}

  ${
    $d z w A $.  $d y z w B $.  $d z ph $.  $d x y z w $.
    elrabsf.1 $e |- ( y e. B -> A. x y e. B ) $.
    $( Membership in a restricted class abstraction, expressed with explicit
       class substitution. (The variation ~ elrabf has implicit
       substitution).  The hypothesis specifies that ` x ` must not be a free
       variable in ` B ` . $)
    elrabsf $p |- ( A e. { x e. B | ph } <-> ( A e. B /\ [ A / x ] ph ) ) $=
      cA wph vx cB crab wcel cA wph vx vz cv wsbc vz cB crab wcel cA cB wcel
      wph vx vz cv wsbc vz cA wsbc wa cA cB wcel wph vx cA wsbc wa wph vx cB
      crab wph vx vz cv wsbc vz cB crab cA wph wph vx vz cv wsbc vx vz vy cB
      elrabsf.1 vy cv cB wcel vz ax-17 wph vz ax-17 wph vx vz hbs1 wph vx vz
      sbequ12 cbvrab eleq2i cA wph vx vz cv wsbc vz cB crab wcel cA cB wcel cA
      cvv wcel wph vx vz cv wsbc vz cA wsbc wi wa cA cB wcel wph vx vz cv wsbc
      vz cA wsbc wa wph vx vz cv wsbc cA cvv wcel wph vx vz cv wsbc vz cA wsbc
      wi vz vw cA cB vw cv cA wcel vz ax-17 vw cv cB wcel vz ax-17 wph vx vz cv
      wsbc vz vw cA cvv vw cv cA wcel vz ax-17 hbsbc1 vz cv cA wceq wph vx vz
      cv wsbc wph vx vz cv wsbc vz cA wsbc cA cvv wcel wph vx vz cv wsbc vz cA
      wsbc wi wph vx vz cv wsbc vz cA sbceq1a vz cv cA wceq cA cvv wcel wph vx
      vz cv wsbc vz cA wsbc cA cvv wcel wph vx vz cv wsbc vz cA wsbc wi wb vz
      cv cA wceq vz cv cA wceq vz wex cA cvv wcel vz cv cA wceq vz 19.8a vz cA
      isset sylibr cA cvv wcel wph vx vz cv wsbc vz cA wsbc biimt syl bitrd
      elrabf cA cB wcel wph vx vz cv wsbc vz cA wsbc cA cvv wcel wph vx vz cv
      wsbc vz cA wsbc wi cA cB wcel cA cvv wcel wph vx vz cv wsbc vz cA wsbc cA
      cvv wcel wph vx vz cv wsbc vz cA wsbc wi wb cA cB elisset cA cvv wcel wph
      vx vz cv wsbc vz cA wsbc biimt syl pm5.32i bitr4i cA cB wcel wph vx vz cv
      wsbc vz cA wsbc wph vx cA wsbc wph vx vz cA cB sbccog pm5.32i 3bitri $.
      $( [30-Sep-2003] $)
  $}

  ${
    $d x y $.
    $( Membership in a class abstraction, expressed in terms of class
       substitution.  Theorem 6.13 of [Quine] p. 44. $)
    elabs2 $p |- ( A e. { x | ph } <-> ( A e. _V /\ [ A / x ] ph ) ) $=
      cA wph vx cab wcel cA wph vx cvv crab wcel cA cvv wcel wph vx cA wsbc wa
      wph vx cvv crab wph vx cab cA wph vx rabab eleq2i wph vx vy cA cvv vy cv
      cvv wcel vx ax-17 elrabsf bitr3i $.
      $( [9-Mar-2004] $) $( [7-Mar-2004] $)
  $}

  $( Membership in a class abstraction, expressed in terms of class
     substitution.  Conveniently, this theorem has no distinct variable
     restrictions.  Except for the antecedent, this theorem is "almost" like
     ~ df-sbc but was proved using only ~ dfsbcq as its starting point
     (making no other reference to ~ df-sbc ).  We prefer not to make direct
     reference to ~ df-sbc (i.e. commit to it) since its behavior at proper
     classes is at odds with Quine, whereas ~ dfsbcq is not.  (Quine's class
     substitution cannot be expressed in closed form.)  This theorem serves
     as a weaker Quine-compatible substitute for ~ df-sbc . $)
  elabsg $p |- ( A e. B -> ( A e. { x | ph } <-> [ A / x ] ph ) ) $=
    cA cB wcel cA cvv wcel cA wph vx cab wcel wph vx cA wsbc wb cA cB elisset
    cA wph vx cab wcel cA cvv wcel wph vx cA wsbc wph vx cA elabs2 baib syl $.
    $( [6-Nov-2005] $) $( [4-Nov-2005] $)

  ${
    elabs.1 $e |- A e. _V $.
    $( Membership in a class abstraction, expressed in terms of class
       substitution. $)
    elabs $p |- ( A e. { x | ph } <-> [ A / x ] ph ) $=
      cA wph vx cab wcel cA cvv wcel wph vx cA wsbc wph vx cA elabs2 elabs.1
      mpbiran $.
      $( [9-Mar-2004] $) $( [7-Mar-2004] $)
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Change bound variable by using a substitution. $)
    cbvralsv $p |- ( A. x e. A ph <-> A. y e. A [ y / x ] ph ) $=
      wph wph vx vy cv wsbc vx vy cA wph vy ax-17 wph vx vy hbs1 wph vx vy
      sbequ12 cbvral $.
      $( [25-Nov-2005] $) $( [20-Nov-2005] $)
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Change bound variable by using a substitution. $)
    cbvrexsv $p |- ( E. x e. A ph <-> E. y e. A [ y / x ] ph ) $=
      wph wph vx vy cv wsbc vx vy cA wph vy ax-17 wph vx vy hbs1 wph vx vy
      sbequ12 cbvrex $.
      $( [5-Mar-2008] $) $( [2-Mar-2008] $)
  $}

  ${
    $d x y $.  $d y A $.  $d y ph $.  $d y ps $.
    $( Move negation in and out of class substitution. $)
    sbcng $p |- ( A e. B -> ( [ A / x ] -. ph <-> -. [ A / x ] ph ) ) $=
      wph wn vx vy cv wsbc wph vx vy cv wsbc wn wph wn vx cA wsbc wph vx cA
      wsbc wn vy cA cB wph wn vx vy cv cA dfsbcq vy cv cA wceq wph vx vy cv
      wsbc wph vx cA wsbc wph vx vy cv cA dfsbcq notbid wph vx vy sbn vtoclbg
      $.
      $( [3-Feb-2004] $) $( [16-Jan-2004] $)

    $( Distribution of class substitution over implication. $)
    sbcimg $p |- ( A e. B ->
           ( [ A / x ] ( ph -> ps ) <-> ( [ A / x ] ph -> [ A / x ] ps ) ) ) $=
      wph wps wi vx vy cv wsbc wph vx vy cv wsbc wps vx vy cv wsbc wi wph wps
      wi vx cA wsbc wph vx cA wsbc wps vx cA wsbc wi vy cA cB wph wps wi vx vy
      cv cA dfsbcq vy cv cA wceq wph vx vy cv wsbc wph vx cA wsbc wps vx vy cv
      wsbc wps vx cA wsbc wph vx vy cv cA dfsbcq wps vx vy cv cA dfsbcq imbi12d
      wph wps vx vy sbim vtoclbg $.
      $( [16-Jan-2004] $) $( [16-Jan-2004] $)

    $( Distribution of class substitution over conjunction. $)
    sbcang $p |- ( A e. B ->
           ( [ A / x ] ( ph /\ ps ) <-> ( [ A / x ] ph /\ [ A / x ] ps ) ) ) $=
      wph wps wa vx vy cv wsbc wph vx vy cv wsbc wps vx vy cv wsbc wa wph wps
      wa vx cA wsbc wph vx cA wsbc wps vx cA wsbc wa vy cA cB wph wps wa vx vy
      cv cA dfsbcq vy cv cA wceq wph vx vy cv wsbc wph vx cA wsbc wps vx vy cv
      wsbc wps vx cA wsbc wph vx vy cv cA dfsbcq wps vx vy cv cA dfsbcq anbi12d
      wph wps vx vy sban vtoclbg $.
      $( [22-May-2004] $) $( [21-May-2004] $)

    $( Distribution of class substitution over disjunction. $)
    sbcorg $p |- ( A e. B ->
           ( [ A / x ] ( ph \/ ps ) <-> ( [ A / x ] ph \/ [ A / x ] ps ) ) ) $=
      wph wps wo vx vy cv wsbc wph vx vy cv wsbc wps vx vy cv wsbc wo wph wps
      wo vx cA wsbc wph vx cA wsbc wps vx cA wsbc wo vy cA cB wph wps wo vx vy
      cv cA dfsbcq vy cv cA wceq wph vx vy cv wsbc wph vx cA wsbc wps vx vy cv
      wsbc wps vx cA wsbc wph vx vy cv cA dfsbcq wps vx vy cv cA dfsbcq orbi12d
      wph wps vx vy sbor vtoclbg $.
      $( [22-May-2004] $) $( [21-May-2004] $)

    $( Distribution of class substitution over biconditional.  (Contributed
       by Raph Levien, 10-Apr-2004.) $)
    sbcbidig $p |- ( A e. B ->
         ( [ A / x ] ( ph <-> ps ) <-> ( [ A / x ] ph <-> [ A / x ] ps ) ) ) $=
      wph wps wb vx vy cv wsbc wph vx vy cv wsbc wps vx vy cv wsbc wb wph wps
      wb vx cA wsbc wph vx cA wsbc wps vx cA wsbc wb vy cA cB wph wps wb vx vy
      cv cA dfsbcq vy cv cA wceq wph vx vy cv wsbc wph vx cA wsbc wps vx vy cv
      wsbc wps vx cA wsbc wph vx vy cv cA dfsbcq wps vx vy cv cA dfsbcq bibi12d
      wph wps vx vy sbbi vtoclbg $.
      $( [22-May-2004] $) $( [19-Apr-2004] $)
  $}

  ${
    $d x z A $.  $d x y z $.  $d z ph $.
    $( Move universal quantifier in and out of class substitution. $)
    sbcalg $p |- ( A e. B -> ( [ A / y ] A. x ph <-> A. x [ A / y ] ph ) ) $=
      wph vx wal vy vz cv wsbc wph vy vz cv wsbc vx wal wph vx wal vy cA wsbc
      wph vy cA wsbc vx wal vz cA cB wph vx wal vy vz cv cA dfsbcq vz cv cA
      wceq wph vy vz cv wsbc wph vy cA wsbc vx wph vy vz cv cA dfsbcq albidv
      wph vx vy vz sbal vtoclbg $.
      $( [4-Feb-2004] $) $( [16-Jan-2004] $)

    $( Move existential quantifier in and out of class substitution. $)
    sbcexg $p |- ( A e. B -> ( [ A / y ] E. x ph <-> E. x [ A / y ] ph ) ) $=
      wph vx wex vy vz cv wsbc wph vy vz cv wsbc vx wex wph vx wex vy cA wsbc
      wph vy cA wsbc vx wex vz cA cB wph vx wex vy vz cv cA dfsbcq vz cv cA
      wceq wph vy vz cv wsbc wph vy cA wsbc vx wph vy vz cv cA dfsbcq exbidv
      wph vx vy vz sbex vtoclbg $.
      $( [22-May-2004] $) $( [21-May-2004] $)
  $}

  ${
    sbcbid.1 $e |- ( ph -> A. x ph ) $.
    sbcbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building deduction rule for class substitution. $)
    sbcbid $p |- ( ( ph /\ A e. B ) -> ( [ A / x ] ps <-> [ A / x ] ch ) ) $=
      cA cB wcel wph wps vx cA wsbc wch vx cA wsbc wb cA cB wcel wph wps wch wb
      vx cA wsbc wps vx cA wsbc wch vx cA wsbc wb cA cB wcel wps wch wb vx wal
      wps wch wb vx cA wsbc wph wps wch wb vx cA cB a4sbc wph wps wch wb vx
      sbcbid.1 sbcbid.2 19.21ai syl5 wps wch vx cA cB sbcbidig sylibd impcom $.
      $( [26-Feb-2005] $) $( [23-Nov-2005] $)
  $}

  ${
    $d x ph $.
    sbcbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building deduction rule for class substitution.  (The proof
       was shortened by Eric Schmidt, 17-Jan-2007.) $)
    sbcbidv $p |- ( ( ph /\ A e. B ) -> ( [ A / x ] ps <-> [ A / x ] ch ) ) $=
      wph wps wch vx cA cB wph vx ax-17 sbcbidv.1 sbcbid $.
      $( [18-Jan-2007] $) $( [11-Oct-2004] $)
  $}

  ${
    sbcbii.1 $e |- ( ph <-> ps ) $.
    $( Formula-building inference rule for class substitution. $)
    sbcbii $p |- ( A e. B -> ( [ A / x ] ph <-> [ A / x ] ps ) ) $=
      cvv cvv wceq cA cB wcel wph vx cA wsbc wps vx cA wsbc wb cvv eqid cvv cvv
      wceq wph wps vx cA cB wph wps wb cvv cvv wceq sbcbii.1 a1i sbcbidv mpan
      $.
      $( [11-Nov-2005] $) $( [11-Nov-2005] $)
  $}

  $( Distribution of class substitution over triple conjunction. $)
  sbc3ang $p |- ( A e. B -> ( [ A / x ] ( ph /\ ps /\ ch ) <->
                ( [ A / x ] ph /\ [ A / x ] ps /\ [ A / x ] ch ) ) ) $=
    cA cB wcel wph wps wch w3a vx cA wsbc wph wps wa wch wa vx cA wsbc wph wps
    wa vx cA wsbc wch vx cA wsbc wa wph vx cA wsbc wps vx cA wsbc wch vx cA
    wsbc w3a wph wps wch w3a wph wps wa wch wa vx cA cB wph wps wch df-3an
    sbcbii wph wps wa wch vx cA cB sbcang cA cB wcel wph wps wa vx cA wsbc wch
    vx cA wsbc wa wph vx cA wsbc wps vx cA wsbc wa wch vx cA wsbc wa wph vx cA
    wsbc wps vx cA wsbc wch vx cA wsbc w3a cA cB wcel wph wps wa vx cA wsbc wph
    vx cA wsbc wps vx cA wsbc wa wch vx cA wsbc wph wps vx cA cB sbcang anbi1d
    wph vx cA wsbc wps vx cA wsbc wch vx cA wsbc df-3an syl6bbr 3bitrd $.
    $( [30-Dec-2006] $) $( [14-Dec-2006] $)

  ${
    $d y z A $.  $d x y B $.
    $( Class substitution into a membership relation. $)
    sbcel1gv $p |- ( A e. C -> ( [ A / x ] x e. B <-> A e. B ) ) $=
      cA cC wcel vx cv cB wcel vx vy cv wsbc vy cA wsbc vy cv cB wcel vy cA
      wsbc vx cv cB wcel vx cA wsbc cA cB wcel vx cv cB wcel vx vy cv wsbc vy
      cv cB wcel vy cA cC vx cv cB wcel vy cv cB wcel vx vy vy cv cB wcel vx
      ax-17 vx cv vy cv cB eleq1 sbie sbcbii vx cv cB wcel vx vy cA cC sbccog
      cA cC wcel cA cvv wcel vy cv cB wcel vy cA wsbc cA cB wcel wb cA cC
      elisset vy cv cA wceq vy wex cA cvv wcel vy cv cB wcel vy cA wsbc cA cB
      wcel wb vy cA cvv elex vy cv cA wceq vy wex cA cvv wcel vy cv cB wcel vy
      cA wsbc cA cB wcel vy cv cA wceq cA cvv wcel vy cv cB wcel vy cA wsbc wi
      cA cvv wcel cA cB wcel wi wb vy cA cvv wcel vy cv cB wcel vy cA wsbc wi
      cA cvv wcel cA cB wcel wi vy vy cv cB wcel vy vz cA cvv vz cv cA wcel vy
      ax-17 hbsbc1 cA cvv wcel cA cB wcel wi vy ax-17 hbbi vy cv cA wceq vy cv
      cB wcel vy cA wsbc cA cB wcel cA cvv wcel vy cv cA wceq vy cv cB wcel vy
      cv cB wcel vy cA wsbc cA cB wcel vy cv cB wcel vy cA sbceq1a vy cv cA cB
      eleq1 bitr3d imbi2d 19.23ai pm5.74rd mpcom syl 3bitr3d $.
      $( [17-Nov-2006] $) $( [17-Nov-2006] $)
  $}

  ${
    $d y z B $.  $d x y A $.
    $( Class substitution into a membership relation. $)
    sbcel2gv $p |- ( B e. C -> ( [ B / x ] A e. x <-> A e. B ) ) $=
      cB cC wcel cA vx cv wcel vx vy cv wsbc vy cB wsbc cA vy cv wcel vy cB
      wsbc cA vx cv wcel vx cB wsbc cA cB wcel cA vx cv wcel vx vy cv wsbc cA
      vy cv wcel vy cB cC cA vx cv wcel cA vy cv wcel vx vy cA vy cv wcel vx
      ax-17 vx cv vy cv cA eleq2 sbie sbcbii cA vx cv wcel vx vy cB cC sbccog
      cB cC wcel cB cvv wcel cA vy cv wcel vy cB wsbc cA cB wcel wb cB cC
      elisset vy cv cB wceq vy wex cB cvv wcel cA vy cv wcel vy cB wsbc cA cB
      wcel wb vy cB cvv elex vy cv cB wceq vy wex cB cvv wcel cA vy cv wcel vy
      cB wsbc cA cB wcel vy cv cB wceq cB cvv wcel cA vy cv wcel vy cB wsbc wi
      cB cvv wcel cA cB wcel wi wb vy cB cvv wcel cA vy cv wcel vy cB wsbc wi
      cB cvv wcel cA cB wcel wi vy cA vy cv wcel vy vz cB cvv vz cv cB wcel vy
      ax-17 hbsbc1 cB cvv wcel cA cB wcel wi vy ax-17 hbbi vy cv cB wceq cA vy
      cv wcel vy cB wsbc cA cB wcel cB cvv wcel vy cv cB wceq cA vy cv wcel cA
      vy cv wcel vy cB wsbc cA cB wcel cA vy cv wcel vy cB sbceq1a vy cv cB cA
      eleq2 bitr3d imbi2d 19.23ai pm5.74rd mpcom syl 3bitr3d $.
      $( [26-Nov-2006] $) $( [17-Nov-2006] $)
  $}

  ${
    $d x B $.
    sbcth2.1 $e |- ( x e. B -> ph ) $.
    $( A substitution into a theorem. $)
    sbcth2 $p |- ( A e. B -> [ A / x ] ph ) $=
      cA cB wcel wph vx cA wsbc cA cB wcel vx cv cB wcel wph wi vx cA wsbc cA
      cB wcel wph vx cA wsbc wi vx cv cB wcel wph wi vx cA cB sbcth2.1 sbcth cA
      cB wcel vx cv cB wcel wph wi vx cA wsbc vx cv cB wcel vx cA wsbc wph vx
      cA wsbc wi cA cB wcel wph vx cA wsbc wi vx cv cB wcel wph vx cA cB sbcimg
      cA cB wcel vx cv cB wcel vx cA wsbc cA cB wcel wph vx cA wsbc vx cA cB cB
      sbcel1gv imbi1d bitrd mpbid pm2.43i $.
      $( [19-Mar-2008] $) $( [1-Mar-2008] $)
  $}

  ${
    $d y z A $.  $d y ph $.  $d x y z $.
    hbsbc1gd.1 $e |- ( ph -> A. x ph ) $.
    hbsbc1gd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    $( Deduction version of ~ hbsbc1g . $)
    hbsbc1gd $p |- ( ( ph /\ A e. B ) ->
                   ( [ A / x ] ps -> A. x [ A / x ] ps ) ) $=
      wph cA cvv wcel wps vx cA wsbc wps vx cA wsbc vx wal wi cA cB wcel wph cA
      cvv wcel wa wps vx vz cv cA wcel vx wal vz cab wsbc wps vx vz cv cA wcel
      vx wal vz cab wsbc vx wal wps vx cA wsbc wps vx cA wsbc vx wal wph cA cvv
      wcel wa vz cv cA wcel vx wal vz cab cvv wcel wps vx vz cv cA wcel vx wal
      vz cab wsbc wps vx vz cv cA wcel vx wal vz cab wsbc vx wal wi wph vz cv
      cA wcel vx wal vz cab cvv wcel cA cvv wcel wph vz cv cA wcel vx wal vz
      cab cA cvv wph vy cv cA wcel vx wal vy cab vy cv cA wcel vy cab vz cv cA
      wcel vx wal vz cab cA wph vy cv cA wcel vx wal vy cv cA wcel vy wph vy cv
      cA wcel vx wal vy cv cA wcel vy cv cA wcel vx ax-4 hbsbc1gd.2 impbid2
      abbidv vy cv cA wcel vx wal vz cv cA wcel vx wal vy vz vy cv vz cv wceq
      vy cv cA wcel vz cv cA wcel vx vy cv vz cv cA eleq1 albidv cbvabv vy cA
      abid2 3eqtr3g eleq1d biimpar wps vx vy vz cv cA wcel vx wal vz cab cvv vz
      cv cA wcel vx wal vx vz vy vz cv cA wcel vx hba1 hbab hbsbc1g syl wph wps
      vx vz cv cA wcel vx wal vz cab wsbc wps vx cA wsbc wb cA cvv wcel wph vy
      cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz cab cA
      wceq wps vx vz cv cA wcel vx wal vz cab wsbc wps vx cA wsbc wb wph vy cv
      cA wcel vy cv cA wcel vx wal wi vy hbsbc1gd.2 19.21aiv vx vy vz cA abidhb
      wps vx vz cv cA wcel vx wal vz cab cA dfsbcq 3syl adantr wph cA cvv wcel
      wa wps vx vz cv cA wcel vx wal vz cab wsbc wps vx cA wsbc vx wph cA cvv
      wcel wph cA cvv wcel wa vx wal wph wph cA cvv wcel vx wph wph vx wal wph
      hbsbc1gd.1 a1d wph vx vy cA cvv hbsbc1gd.1 hbsbc1gd.2 vy cv cvv wcel vy
      cv cvv wcel vx wal wi wph vy cv cvv wcel vx ax-17 a1i hbeld hband anabsi5
      wph wps vx vz cv cA wcel vx wal vz cab wsbc wps vx cA wsbc wb cA cvv wcel
      wph vy cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz
      cab cA wceq wps vx vz cv cA wcel vx wal vz cab wsbc wps vx cA wsbc wb wph
      vy cv cA wcel vy cv cA wcel vx wal wi vy hbsbc1gd.2 19.21aiv vx vy vz cA
      abidhb wps vx vz cv cA wcel vx wal vz cab cA dfsbcq 3syl adantr albid
      3imtr3d cA cB elisset sylan2 $.
      $( [23-May-2006] $) $( [23-May-2006] $)
  $}

  ${
    $d w z A $.  $d z ph $.  $d w x z $.
    hbsbcgd.1 $e |- ( ph -> A. x ph ) $.
    hbsbcgd.2 $e |- ( ph -> A. y ph ) $.
    hbsbcgd.3 $e |- ( ph -> ( z e. A -> A. x z e. A ) ) $.
    hbsbcgd.4 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction version of ~ hbsbcg . $)
    hbsbcgd $p |- ( ( ph /\ A e. C ) ->
                 ( [ A / y ] ps -> A. x [ A / y ] ps ) ) $=
      wph cA cvv wcel wps vy cA wsbc wps vy cA wsbc vx wal wi cA cC wcel wph cA
      cvv wcel wa wps vx wal vy vw cv cA wcel vx wal vw cab wsbc wps vx wal vy
      vw cv cA wcel vx wal vw cab wsbc vx wal wps vy cA wsbc wps vy cA wsbc vx
      wal wph cA cvv wcel wa vw cv cA wcel vx wal vw cab cvv wcel wps vx wal vy
      vw cv cA wcel vx wal vw cab wsbc wps vx wal vy vw cv cA wcel vx wal vw
      cab wsbc vx wal wi wph vw cv cA wcel vx wal vw cab cvv wcel cA cvv wcel
      wph vw cv cA wcel vx wal vw cab cA cvv wph vz cv cA wcel vx wal vz cab vz
      cv cA wcel vz cab vw cv cA wcel vx wal vw cab cA wph vz cv cA wcel vx wal
      vz cv cA wcel vz wph vz cv cA wcel vx wal vz cv cA wcel vz cv cA wcel vx
      ax-4 hbsbcgd.3 impbid2 abbidv vz cv cA wcel vx wal vw cv cA wcel vx wal
      vz vw vz cv vw cv wceq vz cv cA wcel vw cv cA wcel vx vz cv vw cv cA
      eleq1 albidv cbvabv vz cA abid2 3eqtr3g eleq1d biimpar wps vx wal vx vy
      vz vw cv cA wcel vx wal vw cab cvv vw cv cA wcel vx wal vx vw vz vw cv cA
      wcel vx hba1 hbab wps vx hba1 hbsbcg syl wph cA cvv wcel wa wps vx wal vy
      vw cv cA wcel vx wal vw cab wsbc wps vx wal vy cA wsbc wps vy cA wsbc wph
      wps vx wal vy vw cv cA wcel vx wal vw cab wsbc wps vx wal vy cA wsbc wb
      cA cvv wcel wph vz cv cA wcel vz cv cA wcel vx wal wi vz wal vw cv cA
      wcel vx wal vw cab cA wceq wps vx wal vy vw cv cA wcel vx wal vw cab wsbc
      wps vx wal vy cA wsbc wb wph vz cv cA wcel vz cv cA wcel vx wal wi vz
      hbsbcgd.3 19.21aiv vx vz vw cA abidhb wps vx wal vy vw cv cA wcel vx wal
      vw cab cA dfsbcq 3syl adantr wph wps vx wal wps vy cA cvv hbsbcgd.2 wph
      wps vx wal wps wps vx ax-4 hbsbcgd.4 impbid2 sbcbid bitrd wph cA cvv wcel
      wa wps vx wal vy vw cv cA wcel vx wal vw cab wsbc wps vy cA wsbc vx wph
      cA cvv wcel wph cA cvv wcel wa vx wal wph wph cA cvv wcel vx wph wph vx
      wal wph hbsbcgd.1 a1d wph vx vz cA cvv hbsbcgd.1 hbsbcgd.3 vz cv cvv wcel
      vz cv cvv wcel vx wal wi wph vz cv cvv wcel vx ax-17 a1i hbeld hband
      anabsi5 wph cA cvv wcel wa wps vx wal vy vw cv cA wcel vx wal vw cab wsbc
      wps vx wal vy cA wsbc wps vy cA wsbc wph wps vx wal vy vw cv cA wcel vx
      wal vw cab wsbc wps vx wal vy cA wsbc wb cA cvv wcel wph vz cv cA wcel vz
      cv cA wcel vx wal wi vz wal vw cv cA wcel vx wal vw cab cA wceq wps vx
      wal vy vw cv cA wcel vx wal vw cab wsbc wps vx wal vy cA wsbc wb wph vz
      cv cA wcel vz cv cA wcel vx wal wi vz hbsbcgd.3 19.21aiv vx vz vw cA
      abidhb wps vx wal vy vw cv cA wcel vx wal vw cab cA dfsbcq 3syl adantr
      wph wps vx wal wps vy cA cvv hbsbcgd.2 wph wps vx wal wps wps vx ax-4
      hbsbcgd.4 impbid2 sbcbid bitrd albid 3imtr3d cA cC elisset sylan2 $.
      $( [26-Nov-2005] $) $( [23-Nov-2005] $)
  $}

  ${
    $d x ph $.
    sbc19.20dv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Substitution analog of Theorem 19.20 of [Margaris] p. 90. $)
    sbc19.20dv $p |- ( ( ph /\ A e. B ) ->
                     ( [ A / x ] ps -> [ A / x ] ch ) ) $=
      cA cB wcel wph wps vx cA wsbc wch vx cA wsbc wi cA cB wcel wph wps wch wi
      vx cA wsbc wps vx cA wsbc wch vx cA wsbc wi cA cB wcel wps wch wi vx wal
      wps wch wi vx cA wsbc wph wps wch wi vx cA cB a4sbc wph wps wch wi vx
      sbc19.20dv.1 19.21aiv syl5 wps wch vx cA cB sbcimg sylibd impcom $.
      $( [18-Nov-2005] $) $( [11-Nov-2005] $)
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    sbcgf.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution for a variable not free in a wff does not affect it. $)
    sbcgf $p |- ( A e. B -> ( [ A / x ] ph <-> ph ) ) $=
      cA cB wcel wph vx vy cv wsbc vy cA wsbc wph vx cA wsbc wph wph vx vy cA
      cB sbccog cA cB wcel wph vx vy cv wsbc vy cA wsbc wph vy cA wsbc vy cv cA
      wceq wph wa vy wex wph wph vx vy cv wsbc wph vy cA cB wph vx vy sbcgf.1
      sbf sbcbii wph vy cA cB sbc5g cA cB wcel wph vy cv cA wceq vy wex wph wa
      vy cv cA wceq wph wa vy wex cA cB wcel vy cv cA wceq vy wex wph vy cA cB
      elex biantrurd vy cv cA wceq wph vy 19.41v syl6rbbr 3bitrd bitr3d $.
      $( [17-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    sbc19.21g.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution for a variable not free in antecedent affects only the
       consequent. $)
    sbc19.21g $p |- ( A e. B ->
                    ( [ A / x ] ( ph -> ps ) <-> ( ph -> [ A / x ] ps ) ) ) $=
      cA cB wcel wph wps wi vx cA wsbc wph vx cA wsbc wps vx cA wsbc wi wph wps
      vx cA wsbc wi wph wps vx cA cB sbcimg cA cB wcel wph vx cA wsbc wph wps
      vx cA wsbc wph vx cA cB sbc19.21g.1 sbcgf imbi1d bitrd $.
      $( [17-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ps $.
    sbc2ie.1 $e |- A e. _V $.
    sbc2ie.2 $e |- B e. _V $.
    sbc2ie.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution. $)
    sbc2ie $p |- ( [ A / x ] [ B / y ] ph <-> ps ) $=
      wph vy cB wsbc wps vx cA sbc2ie.1 vx cv cA wceq wph vy cB wsbc wps vx cv
      cA wceq wph wi vy cB wsbc vx cv cA wceq vy cB wsbc wph vy cB wsbc wi vx
      cv cA wceq wps wi vx cv cA wceq wph vy cB wsbc wi cB cvv wcel vx cv cA
      wceq wph wi vy cB wsbc vx cv cA wceq vy cB wsbc wph vy cB wsbc wi wb
      sbc2ie.2 vx cv cA wceq wph vy cB cvv sbcimg ax-mp vx cv cA wceq wph wi vx
      cv cA wceq wps wi vy cB sbc2ie.2 vy cv cB wceq vx cv cA wceq wph wps vx
      cv cA wceq vy cv cB wceq wph wps wb sbc2ie.3 expcom pm5.74d sbcie vx cv
      cA wceq vy cB wsbc vx cv cA wceq wph vy cB wsbc cB cvv wcel vx cv cA wceq
      vy cB wsbc vx cv cA wceq wb sbc2ie.2 vx cv cA wceq vy cB cvv vx cv cA
      wceq vy ax-17 sbcgf ax-mp imbi1i 3bitr3ri pm5.74ri sbcie $.
      $( [23-Dec-2008] $) $( [16-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ph $.  $d x y ch $.
    sbc2iedv.1 $e |- A e. _V $.
    sbc2iedv.2 $e |- B e. _V $.
    sbc2iedv.3 $e |- ( ph -> ( ( x = A /\ y = B ) -> ( ps <-> ch ) ) ) $.
    $( Conversion of implicit substitution to explicit class substitution. $)
    sbc2iedv $p |- ( ph -> ( [ A / x ] [ B / y ] ps <-> ch ) ) $=
      wph wps vy cB wsbc vx cA wsbc wch wph wps wi vy cB wsbc vx cA wsbc wph
      wps vy cB wsbc wi vx cA wsbc wph wch wi wph wps vy cB wsbc vx cA wsbc wi
      cA cvv wcel wph wps wi vy cB wsbc vx cA wsbc wph wps vy cB wsbc wi vx cA
      wsbc wb sbc2iedv.1 wph wps wi vy cB wsbc wph wps vy cB wsbc wi vx cA cvv
      cB cvv wcel wph wps wi vy cB wsbc wph wps vy cB wsbc wi wb sbc2iedv.2 wph
      wps vy cB cvv wph vy ax-17 sbc19.21g ax-mp sbcbii ax-mp wph wps wi wph
      wch wi vx vy cA cB sbc2iedv.1 sbc2iedv.2 vx cv cA wceq vy cv cB wceq wa
      wph wps wch wph vx cv cA wceq vy cv cB wceq wa wps wch wb sbc2iedv.3
      impcom pm5.74da sbc2ie cA cvv wcel wph wps vy cB wsbc wi vx cA wsbc wph
      wps vy cB wsbc vx cA wsbc wi wb sbc2iedv.1 wph wps vy cB wsbc vx cA cvv
      wph vx ax-17 sbc19.21g ax-mp 3bitr3ri pm5.74ri $.
      $( [27-Dec-2008] $) $( [16-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    $( Lemma for ~ sbccomg . $)
    sbccomglem $p |- ( ( A e. C /\ B e. D ) ->
                 ( [ A / x ] [ B / y ] ph <-> [ B / y ] [ A / x ] ph ) ) $=
      cA cC wcel cB cD wcel wa wph vy cB wsbc vx cA wsbc vy cv cB wceq wph wa
      vy wex vx cA wsbc vx cv cA wceq vy cv cB wceq wph wa vy wex wa vx wex wph
      vx cA wsbc vy cB wsbc cB cD wcel cA cC wcel wph vy cB wsbc vx cA wsbc vy
      cv cB wceq wph wa vy wex vx cA wsbc wb cB cD wcel wph vy cB wsbc vy cv cB
      wceq wph wa vy wex vx cA cC wph vy cB cD sbc5g sbcbidv ancoms cA cC wcel
      vy cv cB wceq wph wa vy wex vx cA wsbc vx cv cA wceq vy cv cB wceq wph wa
      vy wex wa vx wex wb cB cD wcel vy cv cB wceq wph wa vy wex vx cA cC sbc5g
      adantr cA cC wcel cB cD wcel wa vy cv cB wceq vx cv cA wceq wph wa vx wex
      wa vy wex wph vx cA wsbc vy cB wsbc vx cv cA wceq vy cv cB wceq wph wa vy
      wex wa vx wex cA cC wcel cB cD wcel wa wph vx cA wsbc vy cB wsbc vx cv cA
      wceq wph wa vx wex vy cB wsbc vy cv cB wceq vx cv cA wceq wph wa vx wex
      wa vy wex cA cC wcel wph vx cA wsbc vx cv cA wceq wph wa vx wex vy cB cD
      wph vx cA cC sbc5g sbcbidv cB cD wcel vx cv cA wceq wph wa vx wex vy cB
      wsbc vy cv cB wceq vx cv cA wceq wph wa vx wex wa vy wex wb cA cC wcel vx
      cv cA wceq wph wa vx wex vy cB cD sbc5g adantl bitr2d vx cv cA wceq vy cv
      cB wceq wph wa wa vy wex vx wex vx cv cA wceq vy cv cB wceq wph wa wa vx
      wex vy wex vx cv cA wceq vy cv cB wceq wph wa vy wex wa vx wex vy cv cB
      wceq vx cv cA wceq wph wa vx wex wa vy wex vx cv cA wceq vy cv cB wceq
      wph wa wa vx vy excom vx cv cA wceq vy cv cB wceq wph wa vx vy exdistr vx
      cv cA wceq vy cv cB wceq wph wa wa vx wex vy cv cB wceq vx cv cA wceq wph
      wa vx wex wa vy vx cv cA wceq vy cv cB wceq wph wa wa vx wex vy cv cB
      wceq vx cv cA wceq wph wa wa vx wex vy cv cB wceq vx cv cA wceq wph wa vx
      wex wa vx cv cA wceq vy cv cB wceq wph wa wa vy cv cB wceq vx cv cA wceq
      wph wa wa vx vx cv cA wceq vy cv cB wceq wph an12 exbii vy cv cB wceq vx
      cv cA wceq wph wa vx 19.42v bitri exbii 3bitr3i syl5bb 3bitrd $.
      $( [18-Nov-2005] $) $( [14-Nov-2005] $)
  $}

  ${
    $d w y z A $.  $d w x z B $.  $d w z ph $.  $d x y $.
    $( Commutative law for double class substitution.  (The proof was shortened
       by Eric Schmidt, 17-Jan-2007.) $)
    sbccomg $p |- ( ( A e. C /\ B e. D ) ->
                 ( [ A / x ] [ B / y ] ph <-> [ B / y ] [ A / x ] ph ) ) $=
      cA cvv wcel cB cvv wcel wph vy cB wsbc vx cA wsbc wph vx cA wsbc vy cB
      wsbc wb cA cC wcel cB cD wcel cA cvv wcel cB cvv wcel wa wph vy vw cv
      wsbc vw cB wsbc vx vz cv wsbc vz cA wsbc wph vy vw cv wsbc vw cB wsbc vx
      cA wsbc wph vx cA wsbc vy cB wsbc wph vy cB wsbc vx cA wsbc cA cvv wcel
      wph vy vw cv wsbc vw cB wsbc vx vz cv wsbc vz cA wsbc wph vy vw cv wsbc
      vw cB wsbc vx cA wsbc wb cB cvv wcel wph vy vw cv wsbc vw cB wsbc vx vz
      cA cvv sbccog adantr cA cvv wcel cB cvv wcel wa wph vy vw cv wsbc vw cB
      wsbc vx vz cv wsbc vz cA wsbc wph vx vz cv wsbc vz cA wsbc vy vw cv wsbc
      vw cB wsbc wph vx vz cv wsbc vz cA wsbc vy cB wsbc wph vx cA wsbc vy cB
      wsbc cA cvv wcel cB cvv wcel wa wph vy vw cv wsbc vw cB wsbc vx vz cv
      wsbc vz cA wsbc wph vx vz cv wsbc vy vw cv wsbc vw cB wsbc vz cA wsbc wph
      vx vz cv wsbc vy vw cv wsbc vz cA wsbc vw cB wsbc wph vx vz cv wsbc vz cA
      wsbc vy vw cv wsbc vw cB wsbc cB cvv wcel cA cvv wcel wph vy vw cv wsbc
      vw cB wsbc vx vz cv wsbc vz cA wsbc wph vx vz cv wsbc vy vw cv wsbc vw cB
      wsbc vz cA wsbc wb cB cvv wcel wph vy vw cv wsbc vw cB wsbc vx vz cv wsbc
      wph vx vz cv wsbc vy vw cv wsbc vw cB wsbc vz cA cvv cB cvv wcel wph vy
      vw cv wsbc vx vz cv wsbc vw cB wsbc wph vy vw cv wsbc vw cB wsbc vx vz cv
      wsbc wph vx vz cv wsbc vy vw cv wsbc vw cB wsbc cB cvv wcel vz cv cvv
      wcel wph vy vw cv wsbc vx vz cv wsbc vw cB wsbc wph vy vw cv wsbc vw cB
      wsbc vx vz cv wsbc wb vz visset wph vy vw cv wsbc vw vx cB vz cv cvv cvv
      sbccomglem mpan2 wph vy vw cv wsbc vx vz cv wsbc wph vx vz cv wsbc vy vw
      cv wsbc vw cB cvv vz cv cvv wcel vw cv cvv wcel wph vy vw cv wsbc vx vz
      cv wsbc wph vx vz cv wsbc vy vw cv wsbc wb vz visset vw visset wph vx vy
      vz cv vw cv cvv cvv sbccomglem mp2an sbcbii bitr3d sbcbidv ancoms wph vx
      vz cv wsbc vy vw cv wsbc vz vw cA cB cvv cvv sbccomglem cA cvv wcel wph
      vx vz cv wsbc vy vw cv wsbc vz cA wsbc wph vx vz cv wsbc vz cA wsbc vy vw
      cv wsbc vw cB cvv cA cvv wcel vw cv cvv wcel wph vx vz cv wsbc vy vw cv
      wsbc vz cA wsbc wph vx vz cv wsbc vz cA wsbc vy vw cv wsbc wb vw visset
      wph vx vz cv wsbc vz vy cA vw cv cvv cvv sbccomglem mpan2 sbcbidv 3bitrd
      cB cvv wcel wph vx vz cv wsbc vz cA wsbc vy vw cv wsbc vw cB wsbc wph vx
      vz cv wsbc vz cA wsbc vy cB wsbc wb cA cvv wcel wph vx vz cv wsbc vz cA
      wsbc vy vw cB cvv sbccog adantl cA cvv wcel wph vx vz cv wsbc vz cA wsbc
      wph vx cA wsbc vy cB cvv wph vx vz cA cvv sbccog sbcbidv 3bitrd cB cvv
      wcel cA cvv wcel wph vy vw cv wsbc vw cB wsbc vx cA wsbc wph vy cB wsbc
      vx cA wsbc wb cB cvv wcel wph vy vw cv wsbc vw cB wsbc wph vy cB wsbc vx
      cA cvv wph vy vw cB cvv sbccog sbcbidv ancoms 3bitr3rd cA cC elisset cB
      cD elisset syl2an $.
      $( [18-Jan-2007] $) $( [15-Nov-2005] $)
  $}

  ${
    $d v w z A $.  $d w x B $.   $d v w C $.   $d w ph $.  $d x y $.
    $d v w y z $.
    $( Interchange class substitution and restricted quantifier.  (Unnecessary
       distinct variable restrictions were removed by David Abernethy,
       22-Feb-2010.) $)
    sbcralt $p |- ( A. y ( A e. C /\ A. z ( z e. A -> A. y z e. A ) ) ->
                 ( [ A / x ] A. y e. B ph <-> A. y e. B [ A / x ] ph ) ) $=
      cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal wph vy
      cB wral vx vw cv wsbc vw cA wsbc wph vx vw cv wsbc vw cA wsbc vy cB wral
      wph vy cB wral vx cA wsbc wph vx cA wsbc vy cB wral cA cC wcel vz cv cA
      wcel vz cv cA wcel vy wal wi vz wal wa vy wal wph vx vw cv wsbc vy cB
      wral vw cA wsbc vw cv cA wceq wph vx vw cv wsbc wi vw wal vy cB wral wph
      vy cB wral vx vw cv wsbc vw cA wsbc wph vx vw cv wsbc vw cA wsbc vy cB
      wral cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal
      wph vx vw cv wsbc vy cB wral vw cA wsbc vw cv cA wceq wph vx vw cv wsbc
      vy cB wral wi vw wal vw cv cA wceq wph vx vw cv wsbc wi vw wal vy cB wral
      cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa wph vx vw cv
      wsbc vy cB wral vw cA wsbc vw cv cA wceq wph vx vw cv wsbc vy cB wral wi
      vw wal wb vy cA cC wcel wph vx vw cv wsbc vy cB wral vw cA wsbc vw cv cA
      wceq wph vx vw cv wsbc vy cB wral wi vw wal wb vz cv cA wcel vz cv cA
      wcel vy wal wi vz wal wph vx vw cv wsbc vy cB wral vw cA cC sbc6g adantr
      a4s cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal vw
      cv cA wceq wph vx vw cv wsbc wi vy cB wral vw wal vw cv cA wceq wph vx vw
      cv wsbc vy cB wral wi vw wal vw cv cA wceq wph vx vw cv wsbc wi vw wal vy
      cB wral cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal
      vw cv cA wceq wph vx vw cv wsbc wi vy cB wral vw cv cA wceq wph vx vw cv
      wsbc vy cB wral wi vw cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz
      wal wa vy wal vw cv cA wceq vw cv cA wceq vy wal wi vy wal vw cv cA wceq
      wph vx vw cv wsbc wi vy cB wral vw cv cA wceq wph vx vw cv wsbc vy cB
      wral wi wb cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vw
      cv cA wceq vw cv cA wceq vy wal wi vy cA cC wcel vz cv cA wcel vz cv cA
      wcel vy wal wi vz wal wa vy wal vy vv vw cv cA cA cC wcel vz cv cA wcel
      vz cv cA wcel vy wal wi vz wal wa vy hba1 vv cv vw cv wcel vv cv vw cv
      wcel vy wal wi cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa
      vy wal vv cv vw cv wcel vy ax-17 a1i cA cC wcel vz cv cA wcel vz cv cA
      wcel vy wal wi vz wal wa vv cv cA wcel vv cv cA wcel vy wal wi vy vz cv
      cA wcel vz cv cA wcel vy wal wi vz wal vv cv cA wcel vv cv cA wcel vy wal
      wi cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vv cv cA wcel vv cv
      cA wcel vy wal wi vz vv vz cv vv cv wceq vz cv cA wcel vv cv cA wcel vz
      cv cA wcel vy wal vv cv cA wcel vy wal vz cv vv cv cA eleq1 vz cv vv cv
      wceq vz cv cA wcel vv cv cA wcel vy vz cv vv cv cA eleq1 albidv imbi12d
      a4v adantl a4s hbeqd a5i vw cv cA wceq wph vx vw cv wsbc vy cB r19.21t
      syl albidv vw cv cA wceq wph vx vw cv wsbc wi vy vw cB ralcom4 syl5rbb
      bitrd cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa wph vy
      cB wral vx vw cv wsbc vw cA wsbc wph vx vw cv wsbc vy cB wral vw cA wsbc
      wb vy cA cC wcel wph vy cB wral vx vw cv wsbc vw cA wsbc wph vx vw cv
      wsbc vy cB wral vw cA wsbc wb vz cv cA wcel vz cv cA wcel vy wal wi vz
      wal wph vy cB wral vx vw cv wsbc wph vx vw cv wsbc vy cB wral vw cA cC vw
      cv cvv wcel wph vy cB wral vx vw cv wsbc wph vx vw cv wsbc vy cB wral wb
      vw visset vw cv cvv wcel wph vy cB wral vx vw cv wsbc vx cv vw cv wceq
      wph wi vx wal vy cB wral wph vx vw cv wsbc vy cB wral vw cv cvv wcel wph
      vy cB wral vx vw cv wsbc vx cv vw cv wceq wph vy cB wral wi vx wal vx cv
      vw cv wceq wph wi vx wal vy cB wral wph vy cB wral vx vw cv cvv sbc6g vx
      cv vw cv wceq wph wi vx wal vy cB wral vx cv vw cv wceq wph wi vy cB wral
      vx wal vx cv vw cv wceq wph vy cB wral wi vx wal vx cv vw cv wceq wph wi
      vy vx cB ralcom4 vx cv vw cv wceq wph wi vy cB wral vx cv vw cv wceq wph
      vy cB wral wi vx vx cv vw cv wceq wph vy cB r19.21v albii bitr2i syl6bb
      vw cv cvv wcel wph vx vw cv wsbc vx cv vw cv wceq wph wi vx wal vy cB wph
      vx vw cv cvv sbc6g ralbidv bitr4d ax-mp sbcbii adantr a4s cA cC wcel vz
      cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal wph vx vw cv wsbc vw
      cA wsbc vw cv cA wceq wph vx vw cv wsbc wi vw wal vy cB cA cC wcel vz cv
      cA wcel vz cv cA wcel vy wal wi vz wal wa vy hba1 cA cC wcel vz cv cA
      wcel vz cv cA wcel vy wal wi vz wal wa wph vx vw cv wsbc vw cA wsbc vw cv
      cA wceq wph vx vw cv wsbc wi vw wal wb vy cA cC wcel wph vx vw cv wsbc vw
      cA wsbc vw cv cA wceq wph vx vw cv wsbc wi vw wal wb vz cv cA wcel vz cv
      cA wcel vy wal wi vz wal wph vx vw cv wsbc vw cA cC sbc6g adantr a4s
      ralbid 3bitr4d cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa
      wph vy cB wral vx vw cv wsbc vw cA wsbc wph vy cB wral vx cA wsbc wb vy
      cA cC wcel wph vy cB wral vx vw cv wsbc vw cA wsbc wph vy cB wral vx cA
      wsbc wb vz cv cA wcel vz cv cA wcel vy wal wi vz wal wph vy cB wral vx vw
      cA cC sbccog adantr a4s cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi
      vz wal wa vy wal wph vx vw cv wsbc vw cA wsbc wph vx cA wsbc vy cB cA cC
      wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy hba1 cA cC wcel
      vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa wph vx vw cv wsbc vw cA
      wsbc wph vx cA wsbc wb vy cA cC wcel wph vx vw cv wsbc vw cA wsbc wph vx
      cA wsbc wb vz cv cA wcel vz cv cA wcel vy wal wi vz wal wph vx vw cA cC
      sbccog adantr a4s ralbid 3bitr3d $.
      $( [22-Feb-2010] $) $( [1-Mar-2008] $)

    $( Interchange class substitution and restricted existential quantifier.
       (Unnecessary distinct variable restrictions were removed by David
       Abernethy, 22-Feb-2010.) $)
    sbcrext $p |- ( A. y ( A e. C /\ A. z ( z e. A -> A. y z e. A ) ) ->
                 ( [ A / x ] E. y e. B ph <-> E. y e. B [ A / x ] ph ) ) $=
      cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal wph vy
      cB wrex vx cA wsbc wph vx cA wsbc wn vy cB wral wn wph vx cA wsbc vy cB
      wrex cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal
      wph vy cB wrex vx cA wsbc wph wn vy cB wral vx cA wsbc wn wph vx cA wsbc
      wn vy cB wral wn cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal
      wa wph vy cB wrex vx cA wsbc wph wn vy cB wral vx cA wsbc wn wb vy cA cC
      wcel wph vy cB wrex vx cA wsbc wph wn vy cB wral vx cA wsbc wn wb vz cv
      cA wcel vz cv cA wcel vy wal wi vz wal cA cC wcel wph vy cB wrex vx cA
      wsbc wph wn vy cB wral wn vx cA wsbc wph wn vy cB wral vx cA wsbc wn wph
      vy cB wrex wph wn vy cB wral wn vx cA cC wph vy cB dfrex2 sbcbii wph wn
      vy cB wral vx cA cC sbcng bitrd adantr a4s cA cC wcel vz cv cA wcel vz cv
      cA wcel vy wal wi vz wal wa vy wal wph wn vy cB wral vx cA wsbc wph vx cA
      wsbc wn vy cB wral cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz
      wal wa vy wal wph wn vy cB wral vx cA wsbc wph wn vx cA wsbc vy cB wral
      wph vx cA wsbc wn vy cB wral wph wn vx vy vz cA cB cC sbcralt cA cC wcel
      vz cv cA wcel vz cv cA wcel vy wal wi vz wal wa vy wal wph wn vx cA wsbc
      wph vx cA wsbc wn vy cB cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi
      vz wal wa vy hba1 cA cC wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal
      wa wph wn vx cA wsbc wph vx cA wsbc wn wb vy cA cC wcel wph wn vx cA wsbc
      wph vx cA wsbc wn wb vz cv cA wcel vz cv cA wcel vy wal wi vz wal wph vx
      cA cC sbcng adantr a4s ralbid bitrd notbid bitrd wph vx cA wsbc vy cB
      dfrex2 syl6bbr $.
      $( [22-Feb-2010] $) $( [1-Mar-2008] $)
  $}

  $( MAY BE REVISED - may be deleted $)
  ${
    $d w z A $.  $d x w B $.  $d w z C $.  $d w ph $.  $d x y z w $.
    sbcralgf.1 $e |- ( A. y A e. C -> ( z e. A -> A. y z e. A ) ) $.
    $( Interchange class substitution and restricted quantifier. $)
    sbcralgf $p |- ( A. y A e. C ->
                 ( [ A / x ] A. y e. B ph <-> A. y e. B [ A / x ] ph ) ) $=
      cA cC wcel vy wal wph vy cB wral vx vw cv wsbc vw cA wsbc wph vx vw cv
      wsbc vw cA wsbc vy cB wral wph vy cB wral vx cA wsbc wph vx cA wsbc vy cB
      wral cA cC wcel vy wal wph vx vw cv wsbc vy cB wral vw cA wsbc vw cv cA
      wceq wph vx vw cv wsbc wi vw wal vy cB wral wph vy cB wral vx vw cv wsbc
      vw cA wsbc wph vx vw cv wsbc vw cA wsbc vy cB wral cA cC wcel vy wal wph
      vx vw cv wsbc vy cB wral vw cA wsbc vw cv cA wceq wph vx vw cv wsbc vy cB
      wral wi vw wal vw cv cA wceq wph vx vw cv wsbc wi vw wal vy cB wral cA cC
      wcel wph vx vw cv wsbc vy cB wral vw cA wsbc vw cv cA wceq wph vx vw cv
      wsbc vy cB wral wi vw wal wb vy wph vx vw cv wsbc vy cB wral vw cA cC
      sbc6g a4s cA cC wcel vy wal vw cv cA wceq wph vx vw cv wsbc wi vy cB wral
      vw wal vw cv cA wceq wph vx vw cv wsbc vy cB wral wi vw wal vw cv cA wceq
      wph vx vw cv wsbc wi vw wal vy cB wral cA cC wcel vy wal vw cv cA wceq
      wph vx vw cv wsbc wi vy cB wral vw cv cA wceq wph vx vw cv wsbc vy cB
      wral wi vw cA cC wcel vy wal vw cv cA wceq vw cv cA wceq vy wal wi vy wal
      vw cv cA wceq wph vx vw cv wsbc wi vy cB wral vw cv cA wceq wph vx vw cv
      wsbc vy cB wral wi wb cA cC wcel vw cv cA wceq vw cv cA wceq vy wal wi vy
      cA cC wcel vy wal vy vz vw cv cA cA cC wcel vy hba1 vz cv vw cv wcel vz
      cv vw cv wcel vy wal wi cA cC wcel vy wal vz cv vw cv wcel vy ax-17 a1i
      sbcralgf.1 hbeqd a5i vw cv cA wceq wph vx vw cv wsbc vy cB r19.21t syl
      albidv vw cv cA wceq wph vx vw cv wsbc wi vy vw cB ralcom4 syl5rbb bitrd
      cA cC wcel wph vy cB wral vx vw cv wsbc vw cA wsbc wph vx vw cv wsbc vy
      cB wral vw cA wsbc wb vy wph vy cB wral vx vw cv wsbc wph vx vw cv wsbc
      vy cB wral vw cA cC vw cv cvv wcel wph vy cB wral vx vw cv wsbc wph vx vw
      cv wsbc vy cB wral wb vw visset vw cv cvv wcel wph vy cB wral vx vw cv
      wsbc vx cv vw cv wceq wph wi vx wal vy cB wral wph vx vw cv wsbc vy cB
      wral vw cv cvv wcel wph vy cB wral vx vw cv wsbc vx cv vw cv wceq wph vy
      cB wral wi vx wal vx cv vw cv wceq wph wi vx wal vy cB wral wph vy cB
      wral vx vw cv cvv sbc6g vx cv vw cv wceq wph wi vx wal vy cB wral vx cv
      vw cv wceq wph wi vy cB wral vx wal vx cv vw cv wceq wph vy cB wral wi vx
      wal vx cv vw cv wceq wph wi vy vx cB ralcom4 vx cv vw cv wceq wph wi vy
      cB wral vx cv vw cv wceq wph vy cB wral wi vx vx cv vw cv wceq wph vy cB
      r19.21v albii bitr2i syl6bb vw cv cvv wcel wph vx vw cv wsbc vx cv vw cv
      wceq wph wi vx wal vy cB wph vx vw cv cvv sbc6g ralbidv bitr4d ax-mp
      sbcbii a4s cA cC wcel vy wal wph vx vw cv wsbc vw cA wsbc vw cv cA wceq
      wph vx vw cv wsbc wi vw wal vy cB cA cC wcel vy hba1 cA cC wcel wph vx vw
      cv wsbc vw cA wsbc vw cv cA wceq wph vx vw cv wsbc wi vw wal wb vy wph vx
      vw cv wsbc vw cA cC sbc6g a4s ralbid 3bitr4d cA cC wcel wph vy cB wral vx
      vw cv wsbc vw cA wsbc wph vy cB wral vx cA wsbc wb vy wph vy cB wral vx
      vw cA cC sbccog a4s cA cC wcel vy wal wph vx vw cv wsbc vw cA wsbc wph vx
      cA wsbc vy cB cA cC wcel vy hba1 cA cC wcel wph vx vw cv wsbc vw cA wsbc
      wph vx cA wsbc wb vy wph vx vw cA cC sbccog a4s ralbid 3bitr3d $.
      $( [5-Mar-2008] $) $( [1-Mar-2008] $)

    $( Interchange class substitution and restricted existential
       quantifier. $)
    sbcrexgf $p |- ( A. y A e. C ->
                 ( [ A / x ] E. y e. B ph <-> E. y e. B [ A / x ] ph ) ) $=
      cA cC wcel vy wal wph vy cB wrex vx cA wsbc wph vx cA wsbc wn vy cB wral
      wn wph vx cA wsbc vy cB wrex cA cC wcel vy wal wph vy cB wrex vx cA wsbc
      wph wn vy cB wral vx cA wsbc wn wph vx cA wsbc wn vy cB wral wn cA cC
      wcel wph vy cB wrex vx cA wsbc wph wn vy cB wral vx cA wsbc wn wb vy cA
      cC wcel wph vy cB wrex vx cA wsbc wph wn vy cB wral wn vx cA wsbc wph wn
      vy cB wral vx cA wsbc wn wph vy cB wrex wph wn vy cB wral wn vx cA cC wph
      vy cB dfrex2 sbcbii wph wn vy cB wral vx cA cC sbcng bitrd a4s cA cC wcel
      vy wal wph wn vy cB wral vx cA wsbc wph vx cA wsbc wn vy cB wral cA cC
      wcel vy wal wph wn vy cB wral vx cA wsbc wph wn vx cA wsbc vy cB wral wph
      vx cA wsbc wn vy cB wral wph wn vx vy vz cA cB cC sbcralgf.1 sbcralgf cA
      cC wcel vy wal wph wn vx cA wsbc wph vx cA wsbc wn vy cB cA cC wcel vy
      hba1 cA cC wcel wph wn vx cA wsbc wph vx cA wsbc wn wb vy wph vx cA cC
      sbcng a4s ralbid bitrd notbid bitrd wph vx cA wsbc vy cB dfrex2 syl6bbr
      $.
      $( [13-Apr-2008] $) $( [1-Mar-2008] $)
  $}

  ${
    $d y z A $.  $d x B $.  $d x y z $.
    $( Interchange class substitution and restricted quantifier. $)
    sbcralg $p |- ( A e. C ->
                 ( [ A / x ] A. y e. B ph <-> A. y e. B [ A / x ] ph ) ) $=
      cA cvv wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wph vy cB wral
      vx cA wsbc wph vx cA wsbc vy cB wral wb cA cC wcel cA cvv wcel vz cv cA
      wcel vz cv cA wcel vy wal wi vz wal wa cA cvv wcel vz cv cA wcel vz cv cA
      wcel vy wal wi vz wal wa vy wal wph vy cB wral vx cA wsbc wph vx cA wsbc
      vy cB wral wb cA cvv wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal vy
      cA cvv wcel vy ax-17 vz cv cA wcel vz cv cA wcel vy wal wi vz wal vy vz
      cv cA wcel vz cv cA wcel vy wal wi vz vz cv cA wcel vy ax-17 ax-gen hbth
      hban wph vx vy vz cA cB cvv sbcralt syl cA cC elisset vz cv cA wcel vz cv
      cA wcel vy wal wi vz vz cv cA wcel vy ax-17 ax-gen sylancl $.
      $( [22-Feb-2010] $) $( [15-Nov-2005] $)

    $( Interchange class substitution and restricted existential
       quantifier. $)
    sbcrexg $p |- ( A e. C ->
                 ( [ A / x ] E. y e. B ph <-> E. y e. B [ A / x ] ph ) ) $=
      cA cvv wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal wph vy cB wrex
      vx cA wsbc wph vx cA wsbc vy cB wrex wb cA cC wcel cA cvv wcel vz cv cA
      wcel vz cv cA wcel vy wal wi vz wal wa cA cvv wcel vz cv cA wcel vz cv cA
      wcel vy wal wi vz wal wa vy wal wph vy cB wrex vx cA wsbc wph vx cA wsbc
      vy cB wrex wb cA cvv wcel vz cv cA wcel vz cv cA wcel vy wal wi vz wal vy
      cA cvv wcel vy ax-17 vz cv cA wcel vz cv cA wcel vy wal wi vz wal vy vz
      cv cA wcel vz cv cA wcel vy wal wi vz vz cv cA wcel vy ax-17 ax-gen hbth
      hban wph vx vy vz cA cB cvv sbcrext syl cA cC elisset vz cv cA wcel vz cv
      cA wcel vy wal wi vz vz cv cA wcel vy ax-17 ax-gen sylancl $.
      $( [22-Feb-2010] $) $( [15-Nov-2005] $)
  $}

  ${
    $d y w A $.  $d w z B $.  $d w ph $.  $d x y $.  $d w x z $.
    sbcabel.1 $e |- ( z e. B -> A. x z e. B ) $.
    $( Interchange class substitution and class abstraction. $)
    sbcabel $p |- ( A e. C -> ( [ A / x ] { y | ph } e. B <->
                  { y | [ A / x ] ph } e. B ) ) $=
      cA cC wcel cA cvv wcel wph vy cab cB wcel vx cA wsbc wph vx cA wsbc vy
      cab cB wcel wb cA cC elisset cA cvv wcel wph vy cab cB wcel vx cA wsbc vw
      cv wph vx cA wsbc vy cab wceq vw cv cB wcel wa vw wex wph vx cA wsbc vy
      cab cB wcel cA cvv wcel wph vy cab cB wcel vx cA wsbc vw cv wph vy cab
      wceq vw cv cB wcel wa vw wex vx cA wsbc vw cv wph vy cab wceq vw cv cB
      wcel wa vx cA wsbc vw wex vw cv wph vx cA wsbc vy cab wceq vw cv cB wcel
      wa vw wex wph vy cab cB wcel vw cv wph vy cab wceq vw cv cB wcel wa vw
      wex vx cA cvv vw wph vy cab cB df-clel sbcbii vw cv wph vy cab wceq vw cv
      cB wcel wa vw vx cA cvv sbcexg cA cvv wcel vw cv wph vy cab wceq vw cv cB
      wcel wa vx cA wsbc vw cv wph vx cA wsbc vy cab wceq vw cv cB wcel wa vw
      cA cvv wcel vw cv wph vy cab wceq vw cv cB wcel wa vx cA wsbc vw cv wph
      vy cab wceq vx cA wsbc vw cv cB wcel vx cA wsbc wa vw cv wph vx cA wsbc
      vy cab wceq vw cv cB wcel wa vw cv wph vy cab wceq vw cv cB wcel vx cA
      cvv sbcang cA cvv wcel vw cv wph vy cab wceq vx cA wsbc vw cv wph vx cA
      wsbc vy cab wceq vw cv cB wcel vx cA wsbc vw cv cB wcel cA cvv wcel vw cv
      wph vy cab wceq vx cA wsbc vy cv vw cv wcel wph vx cA wsbc wb vy wal vw
      cv wph vx cA wsbc vy cab wceq cA cvv wcel vw cv wph vy cab wceq vx cA
      wsbc vy cv vw cv wcel wph wb vy wal vx cA wsbc vy cv vw cv wcel wph wb vx
      cA wsbc vy wal vy cv vw cv wcel wph vx cA wsbc wb vy wal vw cv wph vy cab
      wceq vy cv vw cv wcel wph wb vy wal vx cA cvv wph vy vw cv abeq2 sbcbii
      vy cv vw cv wcel wph wb vy vx cA cvv sbcalg cA cvv wcel vy cv vw cv wcel
      wph wb vx cA wsbc vy cv vw cv wcel wph vx cA wsbc wb vy cA cvv wcel vy cv
      vw cv wcel wph wb vx cA wsbc vy cv vw cv wcel vx cA wsbc wph vx cA wsbc
      wb vy cv vw cv wcel wph vx cA wsbc wb vy cv vw cv wcel wph vx cA cvv
      sbcbidig cA cvv wcel vy cv vw cv wcel vx cA wsbc vy cv vw cv wcel wph vx
      cA wsbc vy cv vw cv wcel vx cA cvv vy cv vw cv wcel vx ax-17 sbcgf bibi1d
      bitrd albidv 3bitrd wph vx cA wsbc vy vw cv abeq2 syl6bbr vw cv cB wcel
      vx cA cvv vx vz vz vw cv cB vz cv vw cv wcel vx ax-17 sbcabel.1 hbel
      sbcgf anbi12d bitrd exbidv 3bitrd vw wph vx cA wsbc vy cab cB df-clel
      syl6bbr syl $.
      $( [9-Nov-2005] $) $( [5-Nov-2005] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d y ph $.
    $( Restricted quantifier version of Axiom 4 of [Mendelson] p. 69.  This
       provides an axiom for a predicate calculus for a restricted domain.
       This theorem generalizes the unrestricted ~ stdpc4 and ~ a4sbc .  See
       also ~ ra4sbca and ~ ra4csbela . $)
    ra4sbc $p |- ( A e. B -> ( A. x e. B ph -> [ A / x ] ph ) ) $=
      wph vx cB wral cA cB wcel wph vx cA wsbc wph vx cB wral cA cB wcel wph vx
      cA wsbc wi wi vy cA cB vy cv cA wceq vx cv cB wcel wph wi vx vy cv wsbc
      cA cB wcel wph vx cA wsbc wi wph vx cB wral vy cv cA wceq vx cv cB wcel
      wph wi vx vy cv wsbc vx cv cB wcel wph wi vx cA wsbc cA cB wcel wph vx cA
      wsbc wi vx cv cB wcel wph wi vx vy cv cA dfsbcq vx cv cB wcel wph wi vx
      cA wsbc cA cB wcel wph vx cA wsbc cA cB wcel vx cv cB wcel wph wi vx cA
      wsbc cA cB wcel wph vx cA wsbc wi cA cB wcel vx cv cB wcel wph wi vx cA
      wsbc vx cv cB wcel vx cA wsbc wph vx cA wsbc wi cA cB wcel wph vx cA wsbc
      wi vx cv cB wcel wph vx cA cB sbcimg cA cB wcel vx cv cB wcel vx cA wsbc
      cA cB wcel wph vx cA wsbc vx cA cB cB sbcel1gv imbi1d bitrd biimpd
      pm2.43b syl6bi wph vx cB wral vx cv cB wcel wph wi vx wal vx cv cB wcel
      wph wi vx vy cv wsbc wph vx cB df-ral vx cv cB wcel wph wi vx vy stdpc4
      sylbi syl5 vtocleg pm2.43a $.
      $( [17-Nov-2006] $) $( [17-Nov-2006] $)

    $( Restricted quantifier version of Axiom 4 of [Mendelson] p. 69. $)
    ra4sbca $p |- ( ( A e. B /\ A. x e. B ph ) -> [ A / x ] ph ) $=
      cA cB wcel wph vx cB wral wph vx cA wsbc wph vx cA cB ra4sbc imp $.
      $( [18-Nov-2006] $) $( [14-Dec-2005] $)

    $( Existence form of ~ ra4sbca . $)
    ra4esbca $p |- ( ( A e. B /\ [ A / x ] ph ) -> E. x e. B ph ) $=
      cA cB wcel wph vx cA wsbc wph vx cB wrex cA cB wcel wph vx cB wrex wph vx
      cA wsbc cA cB wcel wph wn vx cB wral wph vx cA wsbc wn wph vx cB wrex wn
      cA cB wcel wph wn vx cB wral wph wn vx cA wsbc wph vx cA wsbc wn wph wn
      vx cA cB ra4sbc wph vx cA cB sbcng sylibd wph vx cB ralnex syl5ibr con4d
      imp $.
      $( [22-Mar-2008] $) $( [29-Feb-2008] $)
  $}

  ${
    ra5.1 $e |- ( ph -> A. x ph ) $.
    $( Restricted quantifier version of Axiom 5 of [Mendelson] p. 69.  This
       is an axiom of a predicate calculus for a restricted domain.
       Compare the unrestricted ~ stdpc5 . $)
    ra5 $p |- ( A. x e. A ( ph -> ps ) -> ( ph -> A. x e. A ps ) ) $=
      wph wps wi vx cA wral wph vx cv cA wcel wps wi vx wal wps vx cA wral wph
      wps wi vx cA wral wph vx cv cA wcel wps wi wi vx wal wph vx cv cA wcel
      wps wi vx wal wi wph wps wi vx cA wral vx cv cA wcel wph wps wi wi vx wal
      wph vx cv cA wcel wps wi wi vx wal wph wps wi vx cA df-ral vx cv cA wcel
      wph wps wi wi wph vx cv cA wcel wps wi wi vx vx cv cA wcel wph wps bi2.04
      albii bitri wph vx cv cA wcel wps wi vx ra5.1 stdpc5 sylbi wps vx cA
      df-ral syl6ibr $.
      $( [17-Jan-2004] $) $( [16-Jan-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Proper substitution of classes for sets into classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c [_ $.  $( Underlined left bracket $)
  $c ]_ $.  $( Underlined right bracket $)

  $( Extend class notation to include the proper substitution of a class for a
     set into another class. $)
  csb $a class [_ A / x ]_ B $.

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( Define the proper substitution of a class for a set into another class.
       The underlined brackets distinguish it from the substitution into a wff,
       ~ wsbc , to prevent ambiguity.  Theorem ~ sbcel1g shows an example of
       how ambiguity could arise if we didn't use distinguished brackets.
       Theorem ~ sbccsbg recreates substitution into a wff from this
       definition. $)
    df-csb $a |- [_ A / x ]_ B = { y | [ A / x ] y e. B } $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Analog of ~ dfsbcq for proper substitution into a class. $)
    csbeq1 $p |- ( A = B -> [_ A / x ]_ C = [_ B / x ]_ C ) $=
      cA cB wceq vy cv cC wcel vx cA wsbc vy cab vy cv cC wcel vx cB wsbc vy
      cab vx cA cC csb vx cB cC csb cA cB wceq vy cv cC wcel vx cA wsbc vy cv
      cC wcel vx cB wsbc vy vy cv cC wcel vx cA cB dfsbcq abbidv vx vy cA cC
      df-csb vx vy cB cC df-csb 3eqtr4g $.
      $( [14-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x z C $.  $d z D $.
    cbvcsbv.1 $e |- ( x = y -> B = C ) $.
    $( Change the bound variable of a proper substitution into a class using
       implicit substitution. $)
    cbvcsbv $p |- ( A e. D -> [_ A / x ]_ B = [_ A / y ]_ C ) $=
      cA cD wcel vz cv cB wcel vx cA wsbc vz cab vz cv cC wcel vy cA wsbc vz
      cab vx cA cB csb vy cA cC csb cA cD wcel vz cv cB wcel vx cA wsbc vz cv
      cC wcel vy cA wsbc vz vz cv cB wcel vz cv cC wcel vx vy cA cD vx cv vy cv
      wceq cB cC vz cv cbvcsbv.1 eleq2d cbvsbcv abbidv vx vz cA cB df-csb vy vz
      cA cC df-csb 3eqtr4g $.
      $( [6-Oct-2008] $) $( [30-Sep-2008] $)
  $}

  ${
    csbeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for proper substitution into a class. $)
    csbeq1d $p |- ( ph -> [_ A / x ]_ C = [_ B / x ]_ C ) $=
      wph cA cB wceq vx cA cC csb vx cB cC csb wceq csbeq1d.1 vx cA cB cC
      csbeq1 syl $.
      $( [4-Dec-2005] $) $( [3-Dec-2005] $)
  $}

  ${
    $d x y $.  $d y A $.
    $( Analog of ~ sbid for proper substitution into a class. $)
    csbid $p |- [_ x / x ]_ A = A $=
      vx vx cv cA csb vy cv cA wcel vx vx cv wsbc vy cab vy cv cA wcel vy cab
      cA vx vy vx cv cA df-csb vy cv cA wcel vx vx cv wsbc vy cv cA wcel vy vy
      cv cA wcel vx sbid abbii vy cA abid2 3eqtri $.
      $( [5-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Equality theorem for proper substitution into a class. $)
    csbeq1a $p |- ( x = A -> B = [_ A / x ]_ B ) $=
      vx cv cA wceq vx vx cv cB csb vx cA cB csb cB vx vx cv cA cB csbeq1 vx cB
      csbid syl5eqr $.
      $( [23-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d z A $.  $d y z B $.  $d z C $.  $d x z $.
    $( Composition law for chained substitutions into a class. $)
    csbcog $p |- ( A e. C -> [_ A / y ]_ [_ y / x ]_ B = [_ A / x ]_ B ) $=
      cA cC wcel vz cv vx vy cv cB csb wcel vy cA wsbc vz cab vz cv cB wcel vx
      cA wsbc vz cab vy cA vx vy cv cB csb csb vx cA cB csb cA cC wcel vz cv vx
      vy cv cB csb wcel vy cA wsbc vz cv cB wcel vx cA wsbc vz cA cC wcel vz cv
      vx vy cv cB csb wcel vy cA wsbc vz cv cB wcel vx vy cv wsbc vy cA wsbc vz
      cv cB wcel vx cA wsbc vz cv vx vy cv cB csb wcel vz cv cB wcel vx vy cv
      wsbc vy cA cC vz cv cB wcel vx vy cv wsbc vz vx vy cv cB csb vx vz vy cv
      cB df-csb abeq2i sbcbii vz cv cB wcel vx vy cA cC sbccog bitrd abbidv vy
      vz cA vx vy cv cB csb df-csb vx vz cA cB df-csb 3eqtr4g $.
      $( [15-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( The existence of proper substitution into a class. $)
    csbexg $p |- ( ( A e. C /\ A. x B e. D ) -> [_ A / x ]_ B e. _V ) $=
      cA cC wcel cB cD wcel vx wal wa vy cv cB wcel vx cA wsbc vy cab cvv vx cA
      cB csb cA cC wcel cB cD wcel vx wal wa vy cv cB wcel vy cab cvv wcel vx
      cA wsbc vy cv cB wcel vx cA wsbc vy cab cvv wcel cA cC wcel cB cD wcel vx
      wal vy cv cB wcel vy cab cvv wcel vx cA wsbc cA cC wcel vy cv cB wcel vy
      cab cvv wcel vx wal vy cv cB wcel vy cab cvv wcel vx cA wsbc cB cD wcel
      vx wal vy cv cB wcel vy cab cvv wcel vx cA cC a4sbc cB cD wcel vy cv cB
      wcel vy cab cvv wcel vx cB cD wcel cB cvv vy cv cB wcel vy cab cB cD
      elisset vy cB abid2 syl5eqel 19.20i syl5 imp cA cC wcel vy cv cB wcel vy
      cab cvv wcel vx cA wsbc vy cv cB wcel vx cA wsbc vy cab cvv wcel wb cB cD
      wcel vx wal vy cv cB wcel vx vy vy cA cvv cC vy cv cvv wcel vx ax-17
      sbcabel adantr mpbid vx vy cA cB df-csb syl5eqel $.
      $( [28-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    csbex.1 $e |- A e. _V $.
    csbex.2 $e |- B e. _V $.
    $( The existence of proper substitution into a class. $)
    csbex $p |- [_ A / x ]_ B e. _V $=
      cA cvv wcel cB cvv wcel vx wal vx cA cB csb cvv wcel csbex.1 cB cvv wcel
      vx csbex.2 ax-gen vx cA cB cvv cvv csbexg mp2an $.
      $( [8-Aug-2007] $) $( [7-Aug-2007] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d x y $.
    csbconstgf.1 $e |- ( y e. B -> A. x y e. B ) $.
    $( Substitution doesn't affect a constant ` B ` (in which ` x ` is not
       free). $)
    csbconstgf $p |- ( A e. C -> [_ A / x ]_ B = B ) $=
      cA cC wcel vy cv cB wcel vx cA wsbc vy cab cB vx cA cB csb cA cC wcel vy
      cv cB wcel vx cA wsbc vy cab vy cv cB wcel vy cab cB cA cC wcel vy cv cB
      wcel vx cA wsbc vy cv cB wcel vy vy cv cB wcel vx cA cC csbconstgf.1
      sbcgf abbidv vy cB abid2 syl6eq vx vy cA cB df-csb syl5eq $.
      $( [16-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x y z $.  $d y z A $.  $d y z B $.  $d y z C $.
    $( Distribute proper substitution through a membership relation. $)
    sbcel12g $p |- ( A e. D -> ( [ A / x ] B e. C <->
                   [_ A / x ]_ B e. [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC wcel vx cA wsbc vy cv cB wcel vx cA wsbc vy cab vy cv cC
      wcel vx cA wsbc vy cab wcel vx cA cB csb vx cA cC csb wcel cA cD wcel cA
      cvv wcel cB cC wcel vx cA wsbc vy cv cB wcel vx cA wsbc vy cab vy cv cC
      wcel vx cA wsbc vy cab wcel wb cA cD elisset cA cvv wcel cB cC wcel vx cA
      wsbc vz cv vy cv cB wcel vx cA wsbc vy cab wceq vz cv vy cv cC wcel vx cA
      wsbc vy cab wcel wa vz wex vy cv cB wcel vx cA wsbc vy cab vy cv cC wcel
      vx cA wsbc vy cab wcel cA cvv wcel vz cv cB wceq vz cv cC wcel wa vz wex
      vx cA wsbc vz cv cB wceq vz cv cC wcel wa vx cA wsbc vz wex cB cC wcel vx
      cA wsbc vz cv vy cv cB wcel vx cA wsbc vy cab wceq vz cv vy cv cC wcel vx
      cA wsbc vy cab wcel wa vz wex vz cv cB wceq vz cv cC wcel wa vz vx cA cvv
      sbcexg cB cC wcel vz cv cB wceq vz cv cC wcel wa vz wex vx cA cvv vz cB
      cC df-clel sbcbii cA cvv wcel vz cv vy cv cB wcel vx cA wsbc vy cab wceq
      vz cv vy cv cC wcel vx cA wsbc vy cab wcel wa vz cv cB wceq vz cv cC wcel
      wa vx cA wsbc vz cA cvv wcel vz cv vy cv cB wcel vx cA wsbc vy cab wceq
      vz cv vy cv cC wcel vx cA wsbc vy cab wcel wa vz cv cB wceq vx cA wsbc vz
      cv cC wcel vx cA wsbc wa vz cv cB wceq vz cv cC wcel wa vx cA wsbc cA cvv
      wcel vz cv vy cv cB wcel vx cA wsbc vy cab wceq vz cv cB wceq vx cA wsbc
      vz cv vy cv cC wcel vx cA wsbc vy cab wcel vz cv cC wcel vx cA wsbc cA
      cvv wcel vz cv cB wceq vx cA wsbc vy cv vz cv wcel vy cv cB wcel vx cA
      wsbc wb vy wal vz cv vy cv cB wcel vx cA wsbc vy cab wceq cA cvv wcel vz
      cv cB wceq vx cA wsbc vy cv vz cv wcel vy cv cB wcel wb vy wal vx cA wsbc
      vy cv vz cv wcel vy cv cB wcel wb vx cA wsbc vy wal vy cv vz cv wcel vy
      cv cB wcel vx cA wsbc wb vy wal vz cv cB wceq vy cv vz cv wcel vy cv cB
      wcel wb vy wal vx cA cvv vy vz cv cB dfcleq sbcbii vy cv vz cv wcel vy cv
      cB wcel wb vy vx cA cvv sbcalg cA cvv wcel vy cv vz cv wcel vy cv cB wcel
      wb vx cA wsbc vy cv vz cv wcel vy cv cB wcel vx cA wsbc wb vy cA cvv wcel
      vy cv vz cv wcel vy cv cB wcel wb vx cA wsbc vy cv vz cv wcel vx cA wsbc
      vy cv cB wcel vx cA wsbc wb vy cv vz cv wcel vy cv cB wcel vx cA wsbc wb
      vy cv vz cv wcel vy cv cB wcel vx cA cvv sbcbidig cA cvv wcel vy cv vz cv
      wcel vx cA wsbc vy cv vz cv wcel vy cv cB wcel vx cA wsbc vy cv vz cv
      wcel vx cA cvv vy cv vz cv wcel vx ax-17 sbcgf bibi1d bitrd albidv 3bitrd
      vy cv cB wcel vx cA wsbc vy vz cv abeq2 syl6rbbr vz cv cvv wcel vy cv vz
      cv wceq vy cv cC wcel vx cA wsbc vz cv cC wcel vx cA wsbc wb wi vy wal vz
      cv vy cv cC wcel vx cA wsbc vy cab wcel vz cv cC wcel vx cA wsbc wb cA
      cvv wcel vy cv cC wcel vx cA wsbc vz cv cC wcel vx cA wsbc vy vz cv cvv
      elabgt vz visset cA cvv wcel vy cv vz cv wceq vy cv cC wcel vx cA wsbc vz
      cv cC wcel vx cA wsbc wb wi vy vy cv vz cv wceq cA cvv wcel vy cv cC wcel
      vx cA wsbc vz cv cC wcel vx cA wsbc wb vy cv vz cv wceq vy cv cC wcel vz
      cv cC wcel vx cA cvv vy cv vz cv cC eleq1 sbcbidv expcom 19.21aiv sylancr
      anbi12d vz cv cB wceq vz cv cC wcel vx cA cvv sbcang bitr4d exbidv
      3bitr4d vz vy cv cB wcel vx cA wsbc vy cab vy cv cC wcel vx cA wsbc vy
      cab df-clel syl6bbr syl vx cA cB csb vy cv cB wcel vx cA wsbc vy cab vx
      cA cC csb vy cv cC wcel vx cA wsbc vy cab vx vy cA cB df-csb vx vy cA cC
      df-csb eleq12i syl6bbr $.
      $( [24-Nov-2005] $) $( [10-Nov-2005] $)

    $( Distribute proper substitution through an equality relation. $)
    sbceqdig $p |- ( A e. D -> ( [ A / x ] B = C <->
                   [_ A / x ]_ B = [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC wceq vx cA wsbc vy cv cB wcel vx cA wsbc vy cab vy cv cC
      wcel vx cA wsbc vy cab wceq vx cA cB csb vx cA cC csb wceq cA cD wcel cA
      cvv wcel cB cC wceq vx cA wsbc vy cv cB wcel vx cA wsbc vy cab vy cv cC
      wcel vx cA wsbc vy cab wceq wb cA cD elisset cA cvv wcel cB cC wceq vx cA
      wsbc vz cv vy cv cB wcel vx cA wsbc vy cab wcel vz cv vy cv cC wcel vx cA
      wsbc vy cab wcel wb vz wal vy cv cB wcel vx cA wsbc vy cab vy cv cC wcel
      vx cA wsbc vy cab wceq cA cvv wcel vz cv cB wcel vz cv cC wcel wb vz wal
      vx cA wsbc vz cv cB wcel vz cv cC wcel wb vx cA wsbc vz wal cB cC wceq vx
      cA wsbc vz cv vy cv cB wcel vx cA wsbc vy cab wcel vz cv vy cv cC wcel vx
      cA wsbc vy cab wcel wb vz wal vz cv cB wcel vz cv cC wcel wb vz vx cA cvv
      sbcalg cB cC wceq vz cv cB wcel vz cv cC wcel wb vz wal vx cA cvv vz cB
      cC dfcleq sbcbii cA cvv wcel vz cv vy cv cB wcel vx cA wsbc vy cab wcel
      vz cv vy cv cC wcel vx cA wsbc vy cab wcel wb vz cv cB wcel vz cv cC wcel
      wb vx cA wsbc vz cA cvv wcel vz cv vy cv cB wcel vx cA wsbc vy cab wcel
      vz cv vy cv cC wcel vx cA wsbc vy cab wcel wb vz cv cB wcel vx cA wsbc vz
      cv cC wcel vx cA wsbc wb vz cv cB wcel vz cv cC wcel wb vx cA wsbc cA cvv
      wcel vz cv vy cv cB wcel vx cA wsbc vy cab wcel vz cv cB wcel vx cA wsbc
      vz cv vy cv cC wcel vx cA wsbc vy cab wcel vz cv cC wcel vx cA wsbc vz cv
      cvv wcel vy cv vz cv wceq vy cv cB wcel vx cA wsbc vz cv cB wcel vx cA
      wsbc wb wi vy wal vz cv vy cv cB wcel vx cA wsbc vy cab wcel vz cv cB
      wcel vx cA wsbc wb cA cvv wcel vy cv cB wcel vx cA wsbc vz cv cB wcel vx
      cA wsbc vy vz cv cvv elabgt vz visset cA cvv wcel vy cv vz cv wceq vy cv
      cB wcel vx cA wsbc vz cv cB wcel vx cA wsbc wb wi vy vy cv vz cv wceq cA
      cvv wcel vy cv cB wcel vx cA wsbc vz cv cB wcel vx cA wsbc wb vy cv vz cv
      wceq vy cv cB wcel vz cv cB wcel vx cA cvv vy cv vz cv cB eleq1 sbcbidv
      expcom 19.21aiv sylancr vz cv cvv wcel vy cv vz cv wceq vy cv cC wcel vx
      cA wsbc vz cv cC wcel vx cA wsbc wb wi vy wal vz cv vy cv cC wcel vx cA
      wsbc vy cab wcel vz cv cC wcel vx cA wsbc wb cA cvv wcel vy cv cC wcel vx
      cA wsbc vz cv cC wcel vx cA wsbc vy vz cv cvv elabgt vz visset cA cvv
      wcel vy cv vz cv wceq vy cv cC wcel vx cA wsbc vz cv cC wcel vx cA wsbc
      wb wi vy vy cv vz cv wceq cA cvv wcel vy cv cC wcel vx cA wsbc vz cv cC
      wcel vx cA wsbc wb vy cv vz cv wceq vy cv cC wcel vz cv cC wcel vx cA cvv
      vy cv vz cv cC eleq1 sbcbidv expcom 19.21aiv sylancr bibi12d vz cv cB
      wcel vz cv cC wcel vx cA cvv sbcbidig bitr4d albidv 3bitr4d vz vy cv cB
      wcel vx cA wsbc vy cab vy cv cC wcel vx cA wsbc vy cab dfcleq syl6bbr syl
      vx cA cB csb vy cv cB wcel vx cA wsbc vy cab vx cA cC csb vy cv cC wcel
      vx cA wsbc vy cab vx vy cA cB df-csb vx vy cA cC df-csb eqeq12i syl6bbr
      $.
      $( [28-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d y A $.  $d x y C $.  $d y D $.
    $( Move proper substitution in and out of a membership relation.
       Note that the scope of ` [ A / x ] ` is the wff ` B e. C ` , whereas
       the scope of ` [_ A / x ]_ ` is the class ` B ` . $)
    sbcel1g $p |- ( A e. D -> ( [ A / x ] B e. C <->
                    [_ A / x ]_ B e. C ) ) $=
      cA cD wcel cB cC wcel vx cA wsbc vx cA cB csb vx cA cC csb wcel vx cA cB
      csb cC wcel vx cA cB cC cD sbcel12g cA cD wcel vx cA cC csb cC vx cA cB
      csb vx vy cA cC cD vy cv cC wcel vx ax-17 csbconstgf eleq2d bitrd $.
      $( [29-Nov-2005] $) $( [10-Nov-2005] $)

    $( Move proper substitution to first argument of an equality. $)
    sbceq1dig $p |- ( A e. D -> ( [ A / x ] B = C <->
                    [_ A / x ]_ B = C ) ) $=
      cA cD wcel cB cC wceq vx cA wsbc vx cA cB csb vx cA cC csb wceq vx cA cB
      csb cC wceq vx cA cB cC cD sbceqdig cA cD wcel vx cA cC csb cC vx cA cB
      csb vx vy cA cC cD vy cv cC wcel vx ax-17 csbconstgf eqeq2d bitrd $.
      $( [5-Dec-2005] $) $( [30-Nov-2005] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d y D $.
    $( Move proper substitution in and out of a membership relation. $)
    sbcel2g $p |- ( A e. D -> ( [ A / x ] B e. C <->
                    B e. [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC wcel vx cA wsbc vx cA cB csb vx cA cC csb wcel cB vx cA
      cC csb wcel vx cA cB cC cD sbcel12g cA cD wcel vx cA cB csb cB vx cA cC
      csb vx vy cA cB cD vy cv cB wcel vx ax-17 csbconstgf eleq1d bitrd $.
      $( [28-Nov-2005] $) $( [14-Nov-2005] $)

    $( Move proper substitution to second argument of an equality. $)
    sbceq2dig $p |- ( A e. D -> ( [ A / x ] B = C <->
                    B = [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC wceq vx cA wsbc vx cA cB csb vx cA cC csb wceq cB vx cA
      cC csb wceq vx cA cB cC cD sbceqdig cA cD wcel vx cA cB csb cB vx cA cC
      csb vx vy cA cB cD vy cv cB wcel vx ax-17 csbconstgf eqeq1d bitrd $.
      $( [11-Dec-2005] $) $( [30-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d x z B $.  $d z C $.  $d x y $.
    $( Commutative law for double substitution into a class. $)
    csbcomg $p |- ( ( A e. R /\ B e. S ) ->
                 [_ A / x ]_ [_ B / y ]_ C = [_ B / y ]_ [_ A / x ]_ C ) $=
      cA cvv wcel cB cvv wcel vx cA vy cB cC csb csb vy cB vx cA cC csb csb
      wceq cA cR wcel cB cS wcel cA cvv wcel cB cvv wcel wa vz vx cA vy cB cC
      csb csb vy cB vx cA cC csb csb cA cvv wcel cB cvv wcel wa vz cv vy cB cC
      csb wcel vx cA wsbc vz cv vx cA cC csb wcel vy cB wsbc vz cv vx cA vy cB
      cC csb csb wcel vz cv vy cB vx cA cC csb csb wcel cA cvv wcel cB cvv wcel
      wa vz cv cC wcel vy cB wsbc vx cA wsbc vz cv cC wcel vx cA wsbc vy cB
      wsbc vz cv vy cB cC csb wcel vx cA wsbc vz cv vx cA cC csb wcel vy cB
      wsbc vz cv cC wcel vx vy cA cB cvv cvv sbccomg cB cvv wcel cA cvv wcel vz
      cv cC wcel vy cB wsbc vx cA wsbc vz cv vy cB cC csb wcel vx cA wsbc wb cB
      cvv wcel vz cv cC wcel vy cB wsbc vz cv vy cB cC csb wcel vx cA cvv vy cB
      vz cv cC cvv sbcel2g sbcbidv ancoms cA cvv wcel vz cv cC wcel vx cA wsbc
      vz cv vx cA cC csb wcel vy cB cvv vx cA vz cv cC cvv sbcel2g sbcbidv
      3bitr3d cA cvv wcel vz cv vy cB cC csb wcel vx cA wsbc vz cv vx cA vy cB
      cC csb csb wcel wb cB cvv wcel vx cA vz cv vy cB cC csb cvv sbcel2g
      adantr cB cvv wcel vz cv vx cA cC csb wcel vy cB wsbc vz cv vy cB vx cA
      cC csb csb wcel wb cA cvv wcel vy cB vz cv vx cA cC csb cvv sbcel2g
      adantl 3bitr3d eqrdv cA cR elisset cB cS elisset syl2an $.
      $( [28-Nov-2005] $) $( [14-Nov-2005] $)
  $}

  ${
    csbeq2d.1 $e |- ( ph -> A. x ph ) $.
    csbeq2d.2 $e |- ( ph -> B = C ) $.
    $( Formula-building deduction rule for class substitution. $)
    csbeq2d $p |- ( ( ph /\ A e. D ) -> [_ A / x ]_ B = [_ A / x ]_ C ) $=
      cA cD wcel wph vx cA cB csb vx cA cC csb wceq cA cD wcel wph cB cC wceq
      vx cA wsbc vx cA cB csb vx cA cC csb wceq cA cD wcel cB cC wceq vx wal cB
      cC wceq vx cA wsbc wph cB cC wceq vx cA cD a4sbc wph cB cC wceq vx
      csbeq2d.1 csbeq2d.2 19.21ai syl5 vx cA cB cC cD sbceqdig sylibd impcom $.
      $( [29-Nov-2005] $) $( [22-Nov-2005] $)
  $}

  ${
    $d x ph $.
    csbeq2dv.1 $e |- ( ph -> B = C ) $.
    $( Formula-building deduction rule for class substitution. $)
    csbeq2dv $p |- ( ( ph /\ A e. D ) -> [_ A / x ]_ B = [_ A / x ]_ C ) $=
      wph vx cA cB cC cD wph vx ax-17 csbeq2dv.1 csbeq2d $.
      $( [30-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    csbeq2i.1 $e |- B = C $.
    $( Formula-building inference rule for class substitution. $)
    csbeq2i $p |- ( A e. D -> [_ A / x ]_ B = [_ A / x ]_ C ) $=
      cA cD wcel cB cC wceq vx cA wsbc vx cA cB csb vx cA cC csb wceq cB cC
      wceq vx cA cD csbeq2i.1 sbcth vx cA cB cC cD sbceqdig mpbid $.
      $( [1-Dec-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d x y z $.
    $( The proper substitution of a class for set variable results in the class
       (if the class exists). $)
    csbvarg $p |- ( A e. B -> [_ A / x ]_ x = A ) $=
      cA cB wcel cA cvv wcel vx cA vx cv csb cA wceq cA cB elisset cA cvv wcel
      vy cA vx vy cv vx cv csb csb vy cA vy cv csb vx cA vx cv csb cA vy cA vx
      vy cv vx cv csb vy cv cvv vy cv cvv wcel vx vy cv vx cv csb vy cv wceq vy
      visset vy cv cvv wcel vz cv vx cv wcel vx vy cv wsbc vz cab vy cv vx vy
      cv vx cv csb vy cv cvv wcel vz cv vx cv wcel vx vy cv wsbc vz vy cv vx vz
      cv vy cv cvv sbcel2gv abbi1dv vx vz vy cv vx cv df-csb syl5eq ax-mp
      csbeq2i vx vy cA vx cv cvv csbcog cA cvv wcel vz cv vy cv wcel vy cA wsbc
      vz cab cA vy cA vy cv csb cA cvv wcel vz cv vy cv wcel vy cA wsbc vz cA
      vy vz cv cA cvv sbcel2gv abbi1dv vy vz cA vy cv df-csb syl5eq 3eqtr3d syl
      $.
      $( [1-Dec-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x y $.
    $( Substitution into a wff expressed in terms of substitution into a
       class. $)
    sbccsbg $p |- ( A e. B ->
                 ( [ A / x ] ph <-> y e. [_ A / x ]_ { y | ph } ) ) $=
      cA cB wcel vy cv wph vy cab wcel vx cA wsbc wph vx cA wsbc vy cv vx cA
      wph vy cab csb wcel vy cv wph vy cab wcel wph vx cA cB wph vy abid sbcbii
      vx cA vy cv wph vy cab cB sbcel2g bitr3d $.
      $( [15-Aug-2007] $) $( [15-Aug-2007] $)
  $}

  $( Substitution into a wff expressed in using substitution into a class. $)
  sbccsb2g $p |- ( A e. B ->
               ( [ A / x ] ph <-> A e. [_ A / x ]_ { x | ph } ) ) $=
    cA cB wcel vx cv wph vx cab wcel vx cA wsbc vx cA vx cv csb vx cA wph vx
    cab csb wcel wph vx cA wsbc cA vx cA wph vx cab csb wcel vx cA vx cv wph vx
    cab cB sbcel12g vx cv wph vx cab wcel wph vx cA cB wph vx abid sbcbii cA cB
    wcel vx cA vx cv csb cA vx cA wph vx cab csb vx cA cB csbvarg eleq1d
    3bitr3d $.
    $( [1-Dec-2005] $) $( [27-Nov-2005] $)

  ${
    $d y z A $.  $d z B $.  $d x y z $.
    hbcsb1g.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for substitution into a class. $)
    hbcsb1g $p |- ( A e. C ->
                 ( y e. [_ A / x ]_ B -> A. x y e. [_ A / x ]_ B ) ) $=
      cA cC wcel cA cvv wcel vy cv vx cA cB csb wcel vy cv vx cA cB csb wcel vx
      wal wi cA cC elisset cA cvv wcel vy cv vz cv cB wcel vx cA wsbc vz cab
      wcel vy cv vz cv cB wcel vx cA wsbc vz cab wcel vx wal vy cv vx cA cB csb
      wcel vy cv vx cA cB csb wcel vx wal cA cvv wcel vz cv cB wcel vx cA wsbc
      vx vz vy cA cvv wcel cA cvv wcel vz wal vx vx vy vy cA cvv hbcsb1g.1 vy
      cv cvv wcel vx ax-17 hbel cA cvv wcel vz ax-17 19.21ai vz cv cB wcel vx
      vy cA cvv hbcsb1g.1 hbsbc1g hbabd vx cA cB csb vz cv cB wcel vx cA wsbc
      vz cab vy cv vx vz cA cB df-csb eleq2i vy cv vx cA cB csb wcel vy cv vz
      cv cB wcel vx cA wsbc vz cab wcel vx vx cA cB csb vz cv cB wcel vx cA
      wsbc vz cab vy cv vx vz cA cB df-csb eleq2i albii 3imtr4g syl $.
      $( [29-Nov-2005] $) $( [11-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d z B $.  $d x y z $.
    hbcsb1.1 $e |- A e. _V $.
    hbcsb1.2 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for substitution into a class. $)
    hbcsb1 $p |- ( y e. [_ A / x ]_ B -> A. x y e. [_ A / x ]_ B ) $=
      cA cvv wcel vy cv vx cA cB csb wcel vy cv vx cA cB csb wcel vx wal wi
      hbcsb1.1 vx vy cA cB cvv hbcsb1.2 hbcsb1g ax-mp $.
      $( [17-Aug-2006] $) $( [17-Aug-2006] $)
  $}

  ${
    $d w z A $.  $d w z B $.  $d w x z $.  $d w y $.
    hbcsbg.1 $e |- ( z e. A -> A. x z e. A ) $.
    hbcsbg.2 $e |- ( z e. B -> A. x z e. B ) $.
    $( Bound-variable hypothesis builder for substitution into a class. $)
    hbcsbg $p |- ( A e. C ->
                 ( z e. [_ A / y ]_ B -> A. x z e. [_ A / y ]_ B ) ) $=
      cA cC wcel cA cvv wcel vz cv vy cA cB csb wcel vz cv vy cA cB csb wcel vx
      wal wi cA cC elisset cA cvv wcel vz cv vw cv cB wcel vy cA wsbc vw cab
      wcel vz cv vw cv cB wcel vy cA wsbc vw cab wcel vx wal vz cv vy cA cB csb
      wcel vz cv vy cA cB csb wcel vx wal cA cvv wcel vw cv cB wcel vy cA wsbc
      vx vw vz cA cvv wcel cA cvv wcel vw wal vx vx vz vz cA cvv hbcsbg.1 vz cv
      cvv wcel vx ax-17 hbel cA cvv wcel vw ax-17 19.21ai vw cv cB wcel vx vy
      vz cA cvv hbcsbg.1 vx vz vz vw cv cB vz cv vw cv wcel vx ax-17 hbcsbg.2
      hbel hbsbcg hbabd vy cA cB csb vw cv cB wcel vy cA wsbc vw cab vz cv vy
      vw cA cB df-csb eleq2i vz cv vy cA cB csb wcel vz cv vw cv cB wcel vy cA
      wsbc vw cab wcel vx vy cA cB csb vw cv cB wcel vy cA wsbc vw cab vz cv vy
      vw cA cB df-csb eleq2i albii 3imtr4g syl $.
      $( [7-Dec-2005] $) $( [20-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d z B $.  $d y z ph $.  $d x y z $.
    hbcsb1gd.1 $e |- ( ph -> A. x ph ) $.
    hbcsb1gd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    $( Deduction version of ~ hbcsb1g . $)
    hbcsb1gd $p |- ( ( ph /\ A e. C ) ->
                 ( y e. [_ A / x ]_ B -> A. x y e. [_ A / x ]_ B ) ) $=
      wph cA cvv wcel vy cv vx cA cB csb wcel vy cv vx cA cB csb wcel vx wal wi
      cA cC wcel wph cA cvv wcel wa vx vz vy cv vx cA cB csb wph cA cvv wcel
      wph cA cvv wcel wa vx wal wph wph cA cvv wcel vx wph wph vx wal wph
      hbcsb1gd.1 a1d wph vx vy cA cvv hbcsb1gd.1 hbcsb1gd.2 vy cv cvv wcel vy
      cv cvv wcel vx wal wi wph vy cv cvv wcel vx ax-17 a1i hbeld hband anabsi5
      vz cv vy cv wcel vz cv vy cv wcel vx wal wi wph cA cvv wcel wa vz cv vy
      cv wcel vx ax-17 a1i wph cA cvv wcel wa vz cv cB wcel vx cA wsbc vz cv cB
      wcel vx cA wsbc vx wal vz cv vx cA cB csb wcel vz cv vx cA cB csb wcel vx
      wal wph vz cv cB wcel vx vy cA cvv hbcsb1gd.1 hbcsb1gd.2 hbsbc1gd cA cvv
      wcel vz cv cB wcel vx cA wsbc vz cv vx cA cB csb wcel wb wph vx cA vz cv
      cB cvv sbcel2g adantl wph cA cvv wcel wa vz cv cB wcel vx cA wsbc vz cv
      vx cA cB csb wcel vx wph cA cvv wcel wph cA cvv wcel wa vx wal wph wph cA
      cvv wcel vx wph wph vx wal wph hbcsb1gd.1 a1d wph vx vy cA cvv hbcsb1gd.1
      hbcsb1gd.2 vy cv cvv wcel vy cv cvv wcel vx wal wi wph vy cv cvv wcel vx
      ax-17 a1i hbeld hband anabsi5 cA cvv wcel vz cv cB wcel vx cA wsbc vz cv
      vx cA cB csb wcel wb wph vx cA vz cv cB cvv sbcel2g adantl albid 3imtr3d
      hbeld cA cC elisset sylan2 $.
      $( [24-May-2006] $) $( [23-May-2006] $)
  $}

  ${
    $d w z A $.  $d w z B $.  $d w z ph $.  $d w x z $.  $d w y $.
    hbcsbgd.1 $e |- ( ph -> A. x ph ) $.
    hbcsbgd.2 $e |- ( ph -> A. y ph ) $.
    hbcsbgd.3 $e |- ( ph -> ( z e. A -> A. x z e. A ) ) $.
    hbcsbgd.4 $e |- ( ph -> ( z e. B -> A. x z e. B ) ) $.
    $( Deduction version of ~ hbcsbg . $)
    hbcsbgd $p |- ( ( ph /\ A e. C ) ->
                 ( z e. [_ A / y ]_ B -> A. x z e. [_ A / y ]_ B ) ) $=
      wph cA cvv wcel vz cv vy cA cB csb wcel vz cv vy cA cB csb wcel vx wal wi
      cA cC wcel wph cA cvv wcel wa vx vw vz cv vy cA cB csb wph cA cvv wcel
      wph cA cvv wcel wa vx wal wph wph cA cvv wcel vx wph wph vx wal wph
      hbcsbgd.1 a1d wph vx vz cA cvv hbcsbgd.1 hbcsbgd.3 vz cv cvv wcel vz cv
      cvv wcel vx wal wi wph vz cv cvv wcel vx ax-17 a1i hbeld hband anabsi5 vw
      cv vz cv wcel vw cv vz cv wcel vx wal wi wph cA cvv wcel wa vw cv vz cv
      wcel vx ax-17 a1i wph cA cvv wcel wa vw cv cB wcel vy cA wsbc vw cv cB
      wcel vy cA wsbc vx wal vw cv vy cA cB csb wcel vw cv vy cA cB csb wcel vx
      wal wph vw cv cB wcel vx vy vz cA cvv hbcsbgd.1 hbcsbgd.2 hbcsbgd.3 wph
      vx vz vw cv cB hbcsbgd.1 vz cv vw cv wcel vz cv vw cv wcel vx wal wi wph
      vz cv vw cv wcel vx ax-17 a1i hbcsbgd.4 hbeld hbsbcgd cA cvv wcel vw cv
      cB wcel vy cA wsbc vw cv vy cA cB csb wcel wb wph vy cA vw cv cB cvv
      sbcel2g adantl wph cA cvv wcel wa vw cv cB wcel vy cA wsbc vw cv vy cA cB
      csb wcel vx wph cA cvv wcel wph cA cvv wcel wa vx wal wph wph cA cvv wcel
      vx wph wph vx wal wph hbcsbgd.1 a1d wph vx vz cA cvv hbcsbgd.1 hbcsbgd.3
      vz cv cvv wcel vz cv cvv wcel vx wal wi wph vz cv cvv wcel vx ax-17 a1i
      hbeld hband anabsi5 cA cvv wcel vw cv cB wcel vy cA wsbc vw cv vy cA cB
      csb wcel wb wph vy cA vw cv cB cvv sbcel2g adantl albid 3imtr3d hbeld cA
      cC elisset sylan2 $.
      $( [30-Nov-2005] $) $( [21-Nov-2005] $)
  $}

  ${
    $d z A $.  $d w B $.  $d z C $.  $d w x y z $.
    csbhypf.1 $e |- ( z e. A -> A. x z e. A ) $.
    csbhypf.2 $e |- ( z e. C -> A. x z e. C ) $.
    csbhypf.3 $e |- ( x = A -> B = C ) $.
    $( Introduce an explicit substitution into an implicit substitution
       hypothesis.  See ~ sbhypf for class substitution version. $)
    csbhypf $p |- ( y = A -> [_ y / x ]_ B = C ) $=
      vy cv cA wceq vx cv vy cv wceq vx cv cA wceq wa vx wex vx vy cv cB csb cC
      wceq vx vz vy cv cA vz cv vy cv wcel vx ax-17 csbhypf.1 vy visset eqvincf
      vx cv vy cv wceq vx cv cA wceq wa vx vy cv cB csb cC wceq vx vx vw vz vx
      vy cv cB csb cC vx vw vy cv cB vy visset vw cv vy cv wcel vx ax-17 hbcsb1
      csbhypf.2 hbeq vx cv vy cv wceq vx cv cA wceq vx vy cv cB csb cB cC vx vy
      cv cB csbeq1a csbhypf.3 sylan9req 19.23ai sylbi $.
      $( [19-Dec-2008] $) $( [19-Dec-2008] $)
  $}

  ${
    $d x z A $.  $d z B $.  $d y z C $.  $d z D $.  $d x y z $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Closed theorem version of ~ csbiegf .) $)
    csbiegft $p |- ( ( A e. D /\ A. x A. y ( y e. C -> A. x y e. C ) /\
                 A. x ( x = A -> B = C ) ) -> [_ A / x ]_ B = C ) $=
      cA cD wcel vy cv cC wcel vy cv cC wcel vx wal wi vy wal vx wal vx cv cA
      wceq cB cC wceq wi vx wal w3a vz cv cB wcel vx cA wsbc vz cab cC vx cA cB
      csb cA cD wcel vy cv cC wcel vy cv cC wcel vx wal wi vy wal vx wal vx cv
      cA wceq cB cC wceq wi vx wal w3a vz cv cB wcel vx cA wsbc vz cC cA cD
      wcel vz cv cC wcel vz cv cC wcel vx wal wi vx wal vx cv cA wceq vz cv cB
      wcel vz cv cC wcel wb wi vx wal vz cv cB wcel vx cA wsbc vz cv cC wcel wb
      cA cD wcel vy cv cC wcel vy cv cC wcel vx wal wi vy wal vx wal vx cv cA
      wceq cB cC wceq wi vx wal vz cv cB wcel vz cv cC wcel vx cA cD sbciegft
      cA cD wcel id vy cv cC wcel vy cv cC wcel vx wal wi vy wal vz cv cC wcel
      vz cv cC wcel vx wal wi vx vy cv cC wcel vy cv cC wcel vx wal wi vz cv cC
      wcel vz cv cC wcel vx wal wi vy vz cv vz visset vy cv vz cv wceq vy cv cC
      wcel vz cv cC wcel vy cv cC wcel vx wal vz cv cC wcel vx wal vy cv vz cv
      cC eleq1 vy cv vz cv wceq vy cv cC wcel vz cv cC wcel vx vy cv vz cv cC
      eleq1 albidv imbi12d cla4v 19.20i vx cv cA wceq cB cC wceq wi vx cv cA
      wceq vz cv cB wcel vz cv cC wcel wb wi vx cB cC wceq vz cv cB wcel vz cv
      cC wcel wb vx cv cA wceq cB cC vz cv eleq2 imim2i 19.20i syl3an abbi1dv
      vx vz cA cB df-csb syl5eq $.
      $( [28-Nov-2005] $) $( [11-Nov-2005] $)
  $}

  ${
    $d x z A $.  $d z B $.  $d y C $.  $d x y $.
    csbieb.1 $e |- A e. _V $.
    csbieb.2 $e |- ( y e. C -> A. x y e. C ) $.
    $( Bidirectional conversion between an implicit class substitution
       hypothesis ` x = A -> B = C ` and its explicit substitution
       equivalent. $)
    csbieb $p |- ( A. x ( x = A -> B = C ) <-> [_ A / x ]_ B = C ) $=
      cB cC wceq vx cA cB csb cC wceq vx cA vx vz vy vx cA cB csb cC vx vz cA
      cB csbieb.1 vz cv cA wcel vx ax-17 hbcsb1 csbieb.2 hbeq csbieb.1 vx cv cA
      wceq cB vx cA cB csb cC vx cA cB csbeq1a eqeq1d ceqsal $.
      $( [3-Mar-2008] $) $( [2-Mar-2008] $)
  $}

  ${
    $d x y A $.  $d y C $.  $d x y D $.
    csbiegf.1 $e |- ( A e. D -> ( y e. C -> A. x y e. C ) ) $.
    csbiegf.2 $e |- ( x = A -> B = C ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class. $)
    csbiegf $p |- ( A e. D -> [_ A / x ]_ B = C ) $=
      cA cD wcel vy cv cC wcel vy cv cC wcel vx wal wi vy wal vx wal vx cv cA
      wceq cB cC wceq wi vx wal wa vx cA cB csb cC wceq cA cD wcel vy cv cC
      wcel vy cv cC wcel vx wal wi vy wal vx wal vx cv cA wceq cB cC wceq wi vx
      wal cA cD wcel vy cv cC wcel vy cv cC wcel vx wal wi vx vy csbiegf.1
      19.21aivv vx cv cA wceq cB cC wceq wi vx csbiegf.2 ax-gen jctir cA cD
      wcel vy cv cC wcel vy cv cC wcel vx wal wi vy wal vx wal vx cv cA wceq cB
      cC wceq wi vx wal vx cA cB csb cC wceq vx vy cA cB cC cD csbiegft 3expb
      mpdan $.
      $( [12-Dec-2005] $) $( [11-Nov-2005] $)
  $}

  ${
    $d x A $.  $d y C $.  $d x y $.
    csbief.1 $e |- A e. _V $.
    csbief.2 $e |- ( y e. C -> A. x y e. C ) $.
    csbief.3 $e |- ( x = A -> B = C ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class. $)
    csbief $p |- [_ A / x ]_ B = C $=
      vx cv cA wceq cB cC wceq wi vx wal vx cA cB csb cC wceq vx cv cA wceq cB
      cC wceq wi vx csbief.3 ax-gen vx vy cA cB cC csbief.1 csbief.2 csbieb
      mpbi $.
      $( [16-Dec-2005] $) $( [26-Nov-2005] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.  $d x y z D $.
    csbie2g.1 $e |- A e. _V $.
    csbie2g.2 $e |- B e. _V $.
    $( Conversion of implicit substitution to explicit substitution into a
       class (closed form of ~ csbie2 ). $)
    csbie2t $p |- ( A. x A. y ( ( x = A /\ y = B ) -> C = D ) ->
                  [_ A / x ]_ [_ B / y ]_ C = D ) $=
      vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vy wal vx wal vx cv cA wceq
      vx wex vy cv cB wceq vy wex vx cA vy cB cC csb csb cD wceq vx cA
      csbie2g.1 isseti vy cB csbie2g.2 isseti vx cv cA wceq vy cv cB wceq wa cC
      cD wceq wi vy wal vx wal vx cv cA wceq vy cv cB wceq wa vy wex vx wex vx
      cA vy cB cC csb csb cD wceq vx cv cA wceq vx wex vy cv cB wceq vy wex wa
      vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vy wal vx wal vx cv cA wceq
      vy cv cB wceq wa vy wex vx cA vy cB cC csb csb cD wceq vx vx cv cA wceq
      vy cv cB wceq wa cC cD wceq wi vy wal vx hba1 vx vz vz vx cA vy cB cC csb
      csb cD vx vz cA vy cB cC csb csbie2g.1 vz cv cA wcel vx ax-17 hbcsb1 vz
      cv cD wcel vx ax-17 hbeq vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vy
      wal vx cv cA wceq vy cv cB wceq wa vy wex vx cA vy cB cC csb csb cD wceq
      wi vx vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vy wal vx cv cA wceq
      vy cv cB wceq wa vx cA vy cB cC csb csb cD wceq vy vx cv cA wceq vy cv cB
      wceq wa cC cD wceq wi vy hba1 vy vz vz vx cA vy cB cC csb csb cD cA cvv
      wcel vz cv vx cA vy cB cC csb csb wcel vz cv vx cA vy cB cC csb csb wcel
      vy wal wi csbie2g.1 vy vx vz cA vy cB cC csb cvv vz cv cA wcel vy ax-17
      vy vz cB cC csbie2g.2 vz cv cB wcel vy ax-17 hbcsb1 hbcsbg ax-mp vz cv cD
      wcel vy ax-17 hbeq vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vx cv cA
      wceq vy cv cB wceq wa vx cA vy cB cC csb csb cD wceq wi vy vx cv cA wceq
      vy cv cB wceq wa cC cD wceq wi vx cv cA wceq vy cv cB wceq wa cC vx cA vy
      cB cC csb csb wceq cC cD wceq wa vx cA vy cB cC csb csb cD wceq vx cv cA
      wceq vy cv cB wceq wa cC vx cA vy cB cC csb csb wceq wi vx cv cA wceq vy
      cv cB wceq wa cC cD wceq wi vx cv cA wceq vy cv cB wceq wa cC vx cA vy cB
      cC csb csb wceq cC cD wceq wa wi vy cv cB wceq vx cv cA wceq cC vy cB cC
      csb vx cA vy cB cC csb csb vy cB cC csbeq1a vx cA vy cB cC csb csbeq1a
      sylan9eqr vx cv cA wceq vy cv cB wceq wa cC vx cA vy cB cC csb csb wceq
      cC cD wceq pm3.43 mpan cC vx cA vy cB cC csb csb cD eqtr2 syl6 a4s
      19.23ad a4s 19.23ad vx cv cA wceq vy cv cB wceq vx vy eeanv syl5ibr
      mp2ani $.
      $( [9-Sep-2007] $) $( [3-Sep-2007] $)

    ${
      csbie2.3 $e |- ( ( x = A /\ y = B ) -> C = D ) $.
      $( Conversion of implicit substitution to explicit substitution into a
         class. $)
      csbie2 $p |- [_ A / x ]_ [_ B / y ]_ C = D $=
        vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vy wal vx wal vx cA vy cB
        cC csb csb cD wceq vx cv cA wceq vy cv cB wceq wa cC cD wceq wi vx vy
        csbie2.3 gen2 vx vy cA cB cC cD csbie2g.1 csbie2g.2 csbie2t ax-mp $.
        $( [9-Sep-2007] $) $( [27-Aug-2007] $)
    $}
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x z C $.  $d x y z R $.  $d y z S $.
    $( Lemma for ~ csbnestg . $)
    csbnestglem $p |- ( ( A e. R /\ A. x B e. S ) ->
                  [_ A / x ]_ [_ B / y ]_ C = [_ [_ A / x ]_ B / y ]_ C ) $=
      cA cR wcel vz cv vy vx cA cB csb cC csb wcel vz cv vy vx cA cB csb cC csb
      wcel vx wal wi vz wal vx wal vx cv cA wceq vy cB cC csb vy vx cA cB csb
      cC csb wceq wi vx wal vx cA vy cB cC csb csb vy vx cA cB csb cC csb wceq
      cA cR wcel cB cS wcel vx wal wa vx vz cA vy cB cC csb vy vx cA cB csb cC
      csb cR csbiegft cA cR wcel cB cS wcel vx wal pm3.26 cA cR wcel cB cS wcel
      vx wal wa vz cv vy vx cA cB csb cC csb wcel vz cv vy vx cA cB csb cC csb
      wcel vx wal wi vz wal vx cA cR wcel cB cS wcel vx wal vx cA cR wcel vx
      ax-17 cB cS wcel vx hba1 hban cA cR wcel cB cS wcel vx wal wa vz cv vy vx
      cA cB csb cC csb wcel vz cv vy vx cA cB csb cC csb wcel vx wal wi vz cA
      cR wcel cB cS wcel vx wal wa vx cA cB csb cvv wcel vz cv vy vx cA cB csb
      cC csb wcel vz cv vy vx cA cB csb cC csb wcel vx wal wi vx cA cB cR cS
      csbexg cA cR wcel cB cS wcel vx wal wa vx vy vz vx cA cB csb cC cvv cA cR
      wcel cB cS wcel vx wal vx cA cR wcel vx ax-17 cB cS wcel vx hba1 hban cA
      cR wcel cB cS wcel vx wal vy cA cR wcel vy ax-17 cB cS wcel vx wal vy
      ax-17 hban cA cR wcel vz cv vx cA cB csb wcel vz cv vx cA cB csb wcel vx
      wal wi cB cS wcel vx wal vx vz cA cB cR vz cv cA wcel vx ax-17 hbcsb1g
      adantr vz cv cC wcel vz cv cC wcel vx wal wi cA cR wcel cB cS wcel vx wal
      wa vz cv cC wcel vx ax-17 a1i hbcsbgd mpdan 19.21aiv 19.21ai vx cv cA
      wceq vy cB cC csb vy vx cA cB csb cC csb wceq wi vx wal cA cR wcel cB cS
      wcel vx wal wa vx cv cA wceq vy cB cC csb vy vx cA cB csb cC csb wceq wi
      vx vx cv cA wceq vy cB vx cA cB csb cC vx cA cB csbeq1a csbeq1d ax-gen
      a1i syl3anc $.
      $( [30-Nov-2005] $) $( [23-Nov-2005] $)
  $}

  ${
    $d w z A $.  $d w z B $.  $d w x z C $.  $d w x y $.
    $( Nest the composition of two substitutions. $)
    csbnestg $p |- ( ( A e. R /\ A. x B e. S ) ->
                  [_ A / x ]_ [_ B / y ]_ C = [_ [_ A / x ]_ B / y ]_ C ) $=
      cA cvv wcel cB cvv wcel vx wal vx cA vy cB cC csb csb vy vx cA cB csb cC
      csb wceq cA cR wcel cB cS wcel vx wal cA cvv wcel cB cvv wcel vx wal wa
      vx cA vz cB vy vz cv cC csb csb csb vz vx cA cB csb vy vz cv cC csb csb
      vx cA vy cB cC csb csb vy vx cA cB csb cC csb cA cvv wcel cB cvv wcel vx
      wal wa vw cA vx vw cv vz cB vy vz cv cC csb csb csb csb vx cA vz cB vy vz
      cv cC csb csb csb vz vx cA cB csb vy vz cv cC csb csb cA cvv wcel vw cA
      vx vw cv vz cB vy vz cv cC csb csb csb csb vx cA vz cB vy vz cv cC csb
      csb csb wceq cB cvv wcel vx wal vx vw cA vz cB vy vz cv cC csb csb cvv
      csbcog adantr cA cvv wcel cB cvv wcel vx wal wa vw cA vx vw cv vz cB vy
      vz cv cC csb csb csb csb vw cA vz vx vw cv cB csb vy vz cv cC csb csb csb
      vz vw cA vx vw cv cB csb csb vy vz cv cC csb csb vz vx cA cB csb vy vz cv
      cC csb csb cB cvv wcel vx wal cA cvv wcel vw cA vx vw cv vz cB vy vz cv
      cC csb csb csb csb vw cA vz vx vw cv cB csb vy vz cv cC csb csb csb wceq
      cB cvv wcel vx wal vw cA vx vw cv vz cB vy vz cv cC csb csb csb vz vx vw
      cv cB csb vy vz cv cC csb csb cvv vw cv cvv wcel cB cvv wcel vx wal vx vw
      cv vz cB vy vz cv cC csb csb csb vz vx vw cv cB csb vy vz cv cC csb csb
      wceq vw visset vx vz vw cv cB vy vz cv cC csb cvv cvv csbnestglem mpan
      csbeq2dv ancoms cA cvv wcel vx vw cv cB csb cvv wcel vw wal vw cA vz vx
      vw cv cB csb vy vz cv cC csb csb csb vz vw cA vx vw cv cB csb csb vy vz
      cv cC csb csb wceq cB cvv wcel vx wal vw vz cA vx vw cv cB csb vy vz cv
      cC csb cvv cvv csbnestglem cB cvv wcel vx wal vx vw cv cB csb cvv wcel vw
      vw cv cvv wcel cB cvv wcel vx wal vx vw cv cB csb cvv wcel vw visset vx
      vw cv cB cvv cvv csbexg mpan 19.21aiv sylan2 cA cvv wcel vz vw cA vx vw
      cv cB csb csb vy vz cv cC csb csb vz vx cA cB csb vy vz cv cC csb csb
      wceq cB cvv wcel vx wal cA cvv wcel vz vw cA vx vw cv cB csb csb vx cA cB
      csb vy vz cv cC csb vx vw cA cB cvv csbcog csbeq1d adantr 3eqtrd eqtr3d
      cB cvv wcel vx wal cA cvv wcel vx cA vz cB vy vz cv cC csb csb csb vx cA
      vy cB cC csb csb wceq cB cvv wcel vx wal vx cA vz cB vy vz cv cC csb csb
      vy cB cC csb cvv cB cvv wcel vx hba1 cB cvv wcel vz cB vy vz cv cC csb
      csb vy cB cC csb wceq vx vy vz cB cC cvv csbcog a4s csbeq2d ancoms cA cvv
      wcel cB cvv wcel vx wal wa vx cA cB csb cvv wcel vz vx cA cB csb vy vz cv
      cC csb csb vy vx cA cB csb cC csb wceq vx cA cB cvv cvv csbexg vy vz vx
      cA cB csb cC cvv csbcog syl 3eqtr3d cA cR elisset cB cS wcel cB cvv wcel
      vx cB cS elisset 19.20i syl2an $.
      $( [30-Nov-2005] $) $( [23-Nov-2005] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d y C $.  $d y S $.
    $( Nest the composition of two substitutions. $)
    csbnest1g $p |- ( ( A e. R /\ A. x B e. S ) ->
                  [_ A / x ]_ [_ B / x ]_ C = [_ [_ A / x ]_ B / x ]_ C ) $=
      cA cvv wcel cB cS wcel vx wal vx cA vx cB cC csb csb vx vx cA cB csb cC
      csb wceq cA cR wcel cA cvv wcel vy cv vx vx cA cB csb cC csb wcel vy cv
      vx vx cA cB csb cC csb wcel vx wal wi vy wal vx wal vx cv cA wceq vx cB
      cC csb vx vx cA cB csb cC csb wceq wi vx wal vx cA vx cB cC csb csb vx vx
      cA cB csb cC csb wceq cA cvv wcel cB cS wcel vx wal wa vx vy cA vx cB cC
      csb vx vx cA cB csb cC csb cvv csbiegft cA cvv wcel cB cS wcel vx wal
      pm3.26 cA cvv wcel cB cS wcel vx wal wa vy cv vx vx cA cB csb cC csb wcel
      vy cv vx vx cA cB csb cC csb wcel vx wal wi vy wal vx cA cvv wcel cB cS
      wcel vx wal vx cA cvv wcel vx ax-17 cB cS wcel vx hba1 hban cA cvv wcel
      cB cS wcel vx wal wa vy cv vx vx cA cB csb cC csb wcel vy cv vx vx cA cB
      csb cC csb wcel vx wal wi vy cA cvv wcel cB cS wcel vx wal vx cA cB csb
      cvv wcel vy cv vx vx cA cB csb cC csb wcel vy cv vx vx cA cB csb cC csb
      wcel vx wal wi vx cA cB cvv cS csbexg cA cvv wcel vx vy vx cA cB csb cC
      cvv cA cvv wcel vx ax-17 vx vy cA cB cvv vy cv cA wcel vx ax-17 hbcsb1g
      hbcsb1gd syldan 19.21aiv 19.21ai vx cv cA wceq vx cB cC csb vx vx cA cB
      csb cC csb wceq wi vx wal cA cvv wcel cB cS wcel vx wal wa vx cv cA wceq
      vx cB cC csb vx vx cA cB csb cC csb wceq wi vx vx cv cA wceq vx cB vx cA
      cB csb cC vx cA cB csbeq1a csbeq1d ax-gen a1i syl3anc cA cR elisset sylan
      $.
      $( [25-May-2006] $) $( [23-May-2006] $)
  $}

  ${
    $d x ph $.  $d x y $.
    $( Nest the composition of two substitutions. $)
    sbcnestg $p |- ( ( A e. R /\ A. x B e. S ) ->
                ( [ A / x ] [ B / y ] ph <-> [ [_ A / x ]_ B / y ] ph ) ) $=
      cA cR wcel cB cvv wcel vx wal wph vy cB wsbc vx cA wsbc wph vy vx cA cB
      csb wsbc wb cB cS wcel vx wal cA cR wcel cB cvv wcel vx wal wa wph vy cB
      wsbc vx cA wsbc cB vy cB wph vy cab csb wcel vx cA wsbc vx cA cB csb vx
      cA vy cB wph vy cab csb csb wcel wph vy vx cA cB csb wsbc cB cvv wcel vx
      wal cA cR wcel wph vy cB wsbc vx cA wsbc cB vy cB wph vy cab csb wcel vx
      cA wsbc wb cB cvv wcel vx wal wph vy cB wsbc cB vy cB wph vy cab csb wcel
      vx cA cR cB cvv wcel vx hba1 cB cvv wcel wph vy cB wsbc cB vy cB wph vy
      cab csb wcel wb vx wph vy cB cvv sbccsb2g a4s sbcbid ancoms cA cR wcel cB
      vy cB wph vy cab csb wcel vx cA wsbc vx cA cB csb vx cA vy cB wph vy cab
      csb csb wcel wb cB cvv wcel vx wal vx cA cB vy cB wph vy cab csb cR
      sbcel12g adantr cA cR wcel cB cvv wcel vx wal wa vx cA cB csb vx cA vy cB
      wph vy cab csb csb wcel vx cA cB csb vy vx cA cB csb wph vy cab csb wcel
      wph vy vx cA cB csb wsbc cA cR wcel cB cvv wcel vx wal wa vx cA vy cB wph
      vy cab csb csb vy vx cA cB csb wph vy cab csb vx cA cB csb vx vy cA cB
      wph vy cab cR cvv csbnestg eleq2d cA cR wcel cB cvv wcel vx wal wa vx cA
      cB csb cvv wcel wph vy vx cA cB csb wsbc vx cA cB csb vy vx cA cB csb wph
      vy cab csb wcel wb vx cA cB cR cvv csbexg wph vy vx cA cB csb cvv
      sbccsb2g syl bitr4d 3bitrd cB cS wcel cB cvv wcel vx cB cS elisset 19.20i
      sylan2 $.
      $( [5-Dec-2005] $) $( [27-Nov-2005] $)
  $}

  ${
    $d x y A $.
    $( Idempotent law for class substitutions. $)
    csbidmg $p |- ( A e. C -> [_ A / x ]_ [_ A / x ]_ B = [_ A / x ]_ B ) $=
      cA cC wcel cA cvv wcel vx cA vx cA cB csb csb vx cA cB csb wceq cA cC
      elisset cA cvv wcel vx cA vx cA cB csb csb vx vx cA cA csb cB csb vx cA
      cB csb cA cvv wcel cA cvv wcel vx wal vx cA vx cA cB csb csb vx vx cA cA
      csb cB csb wceq cA cvv wcel vx ax-17 vx cA cA cB cvv cvv csbnest1g mpdan
      cA cvv wcel vx vx cA cA csb cA cB vx vy cA cA cvv vy cv cA wcel vx ax-17
      csbconstgf csbeq1d eqtrd syl $.
      $( [7-Mar-2008] $) $( [1-Mar-2008] $)
  $}

  ${
    $d x A $.  $d x C $.  $d x z D $.  $d x y $.
    csbco3g.1 $e |- ( x = A -> B = D ) $.
    $( Composition of two class substitutions. $)
    csbco3g $p |- ( ( A e. R /\ A. x B e. S ) ->
                 [_ A / x ]_ [_ B / y ]_ C = [_ D / y ]_ C ) $=
      cA cR wcel cB cS wcel vx wal wa vx cA vy cB cC csb csb vy vx cA cB csb cC
      csb vy cD cC csb vx vy cA cB cC cR cS csbnestg cA cR wcel vy vx cA cB csb
      cC csb vy cD cC csb wceq cB cS wcel vx wal cA cR wcel vy vx cA cB csb cD
      cC cA cR wcel vz cv cD wcel vz cv cD wcel vx wal wi vz wal vx wal vx cv
      cA wceq cB cD wceq wi vx wal vx cA cB csb cD wceq vz cv cD wcel vz cv cD
      wcel vx wal wi vx vz vz cv cD wcel vx ax-17 gen2 vx cv cA wceq cB cD wceq
      wi vx csbco3g.1 ax-gen vx vz cA cB cD cR csbiegft mp3an23 csbeq1d adantr
      eqtrd $.
      $( [1-Dec-2005] $) $( [27-Nov-2005] $)
  $}

  ${
    $d x A $.  $d x ph $.  $d x z C $.  $d x y $.
    sbcco3g.1 $e |- ( x = A -> B = C ) $.
    $( Composition of two substitutions. $)
    sbcco3g $p |- ( ( A e. R /\ A. x B e. S ) ->
                ( [ A / x ] [ B / y ] ph <-> [ C / y ] ph ) ) $=
      cA cR wcel cB cS wcel vx wal wa wph vy cB wsbc vx cA wsbc wph vy vx cA cB
      csb wsbc wph vy cC wsbc wph vx vy cA cB cR cS sbcnestg cA cR wcel wph vy
      vx cA cB csb wsbc wph vy cC wsbc wb cB cS wcel vx wal cA cR wcel vx cA cB
      csb cC wceq wph vy vx cA cB csb wsbc wph vy cC wsbc wb cA cR wcel vz cv
      cC wcel vz cv cC wcel vx wal wi vz wal vx wal vx cv cA wceq cB cC wceq wi
      vx wal vx cA cB csb cC wceq vz cv cC wcel vz cv cC wcel vx wal wi vx vz
      vz cv cC wcel vx ax-17 gen2 vx cv cA wceq cB cC wceq wi vx sbcco3g.1
      ax-gen vx vz cA cB cC cR csbiegft mp3an23 wph vy vx cA cB csb cC dfsbcq
      syl adantr bitrd $.
      $( [6-Dec-2005] $) $( [27-Nov-2005] $)
  $}

  ${
    $d x B $.  $d x D $.
    $( Special case related to ~ ra4sbc .  (The proof was shortened by Eric
       Schmidt, 17-Jan-2007.) $)
    ra4csbela $p |- ( ( A e. B /\ A. x e. B C e. D ) -> [_ A / x ]_ C e. D ) $=
      cA cB wcel cC cD wcel vx cB wral vx cA cC csb cD wcel cA cB wcel cC cD
      wcel vx cB wral cC cD wcel vx cA wsbc vx cA cC csb cD wcel cC cD wcel vx
      cA cB ra4sbc vx cA cC cD cB sbcel1g sylibd imp $.
      $( [18-Jan-2007] $) $( [10-Dec-2005] $)
  $}

  ${
    $d y z A $.  $d z ph $.  $d x y z $.
    $( Move substitution into a class abstraction. $)
    csbabg $p |- ( A e. B ->
                 [_ A / x ]_ { y | ph } = { y | [ A / x ] ph } ) $=
      cA cB wcel cA cvv wcel vx cA wph vy cab csb wph vx cA wsbc vy cab wceq cA
      cB elisset cA cvv wcel wph vx cA wsbc vy cab vz cv wph vy cab wcel vx cA
      wsbc vz cab vx cA wph vy cab csb cA cvv wcel wph vx cA wsbc vy vz cv wsbc
      vz cab vz cv wph vy cab wcel vx cA wsbc vz cab wph vx cA wsbc vy cab cA
      cvv wcel wph vx cA wsbc vy vz cv wsbc vz cv wph vy cab wcel vx cA wsbc vz
      cA cvv wcel wph vx cA wsbc vy vz cv wsbc wph vy vz cv wsbc vx cA wsbc vz
      cv wph vy cab wcel vx cA wsbc vz cv cvv wcel cA cvv wcel wph vx cA wsbc
      vy vz cv wsbc wph vy vz cv wsbc vx cA wsbc wb vz visset wph vy vx vz cv
      cA cvv cvv sbccomg mpan vz cv wph vy cab wcel wph vy vz cv wsbc vx cA cvv
      wph vz vy df-clab sbcbii bitr4d abbidv wph vx cA wsbc wph vx cA wsbc vy
      vz cv wsbc vy vz wph vx cA wsbc vz ax-17 wph vx cA wsbc vy vz hbs1 wph vx
      cA wsbc vy vz sbequ12 cbvab syl5eq vx vz cA wph vy cab df-csb syl6reqr
      syl $.
      $( [17-Dec-2005] $) $( [13-Dec-2005] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Define basic set operations and relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols. $)
  $c \ $. $( Backslash (difference) $)
  $c u. $. $( Cup (union) $)
  $c i^i $. $( Cap (intersection) $)
  $c C_ $. $( Subclass or subset symbol $)
  $c C. $. $( Proper subclass or subset symbol $)

  $( Extend class notation to include class difference (read:
     " ` A ` minus ` B ` "). $)
  cdif $a class ( A \ B ) $.

  $( Extend class notation to include union of two classes (read:  " ` A `
     union ` B ` "). $)
  cun $a class ( A u. B ) $.

  $( Extend class notation to include the intersection of two classes (read:
     " ` A ` intersect ` B ` "). $)
  cin $a class ( A i^i B ) $.

  $( Extend wff notation to include the subclass relation.  This is read
     " ` A ` is a subclass of ` B `" or " ` B ` includes ` A ` ."  When ` A `
     exists as a set, it is also read " ` A ` is a subset of ` B ` ." $)
  wss $a wff A C_ B $.

  $( Extend wff notation with proper subclass relation. $)
  wpss $a wff A C. B $.

  ${
    $d x A $.  $d x B $.  $d y A $.  $d y B $.  $d z x $.  $d z y $.  $d z A $.
    $d z B $.
    $( Soundness justification theorem for ~ df-dif .  (Contributed by Rodolfo
       Medina, 27-Apr-2010.) $)
    difjust $p |- { x | ( x e. A /\ -. x e. B ) }
                  = { y | ( y e. A /\ -. y e. B ) } $=
      vz vx cv cA wcel vx cv cB wcel wn wa vx cab vy cv cA wcel vy cv cB wcel
      wn wa vy cab vz cv vx cv cA wcel vx cv cB wcel wn wa vx cab wcel vz cv cA
      wcel vz cv cB wcel wn wa vz cv vy cv cA wcel vy cv cB wcel wn wa vy cab
      wcel vz cv vx cv cA wcel vx cv cB wcel wn wa vx cab wcel vx cv cA wcel vx
      cv cB wcel wn wa vx vz cv wsbc vx cv cA wcel vx vz cv wsbc vx cv cB wcel
      wn vx vz cv wsbc wa vz cv cA wcel vz cv cB wcel wn wa vx cv cA wcel vx cv
      cB wcel wn wa vz vx df-clab vx cv cA wcel vx cv cB wcel wn vx vz sban vx
      cv cA wcel vx vz cv wsbc vz cv cA wcel vx cv cB wcel wn vx vz cv wsbc vz
      cv cB wcel wn vz vx cA clelsb3 vx cv cB wcel wn vx vz cv wsbc vx cv cB
      wcel vx vz cv wsbc wn vz cv cB wcel wn vx cv cB wcel vx vz sbn vx cv cB
      wcel vx vz cv wsbc vz cv cB wcel vz vx cB clelsb3 notbii bitri anbi12i
      3bitri vz cv vy cv cA wcel vy cv cB wcel wn wa vy cab wcel vy cv cA wcel
      vy cv cB wcel wn wa vy vz cv wsbc vy cv cA wcel vy vz cv wsbc vy cv cB
      wcel wn vy vz cv wsbc wa vz cv cA wcel vz cv cB wcel wn wa vy cv cA wcel
      vy cv cB wcel wn wa vz vy df-clab vy cv cA wcel vy cv cB wcel wn vy vz
      sban vy cv cA wcel vy vz cv wsbc vz cv cA wcel vy cv cB wcel wn vy vz cv
      wsbc vz cv cB wcel wn vz vy cA clelsb3 vy cv cB wcel wn vy vz cv wsbc vy
      cv cB wcel vy vz cv wsbc wn vz cv cB wcel wn vy cv cB wcel vy vz sbn vy
      cv cB wcel vy vz cv wsbc vz cv cB wcel vz vy cB clelsb3 notbii bitri
      anbi12i 3bitri bitr4i eqriv $.
      $( [19-May-2010] $) $( [27-Apr-2010] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Define class difference, also called relative complement.  Definition
       5.12 of [TakeutiZaring] p. 20.  Several notations are used in the
       literature; we chose the ` \ ` convention used in Definition 5.3 of
       [Eisenberg] p. 67 instead of the more common minus sign to reserve the
       latter for later use in, e.g., arithmetic.  We will use the terminology
       " ` A ` excludes ` B ` " to mean ` A \ B ` .  We will use " ` B ` is
       removed from ` A ` " to mean ` A \ { B } ` i.e. the removal of an
       element or equivalently the exclusion of a singleton. $)
    df-dif $a |- ( A \ B ) = { x | ( x e. A /\ -. x e. B ) } $.
  $}

  ${
    $d x A $.  $d x B $.  $d y A $.  $d y B $.  $d z x $.  $d z y $.  $d z A $.
    $d z B $.
    $( Soundness justification theorem for ~ df-un .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.) $)
    unjust $p |- { x | ( x e. A \/ x e. B ) } = { y | ( y e. A \/ y e. B ) } $=
      vz vx cv cA wcel vx cv cB wcel wo vx cab vy cv cA wcel vy cv cB wcel wo
      vy cab vz cv vx cv cA wcel vx cv cB wcel wo vx cab wcel vz cv cA wcel vz
      cv cB wcel wo vz cv vy cv cA wcel vy cv cB wcel wo vy cab wcel vz cv vx
      cv cA wcel vx cv cB wcel wo vx cab wcel vx cv cA wcel vx cv cB wcel wo vx
      vz cv wsbc vx cv cA wcel vx vz cv wsbc vx cv cB wcel vx vz cv wsbc wo vz
      cv cA wcel vz cv cB wcel wo vx cv cA wcel vx cv cB wcel wo vz vx df-clab
      vx cv cA wcel vx cv cB wcel vx vz sbor vx cv cA wcel vx vz cv wsbc vz cv
      cA wcel vx cv cB wcel vx vz cv wsbc vz cv cB wcel vz vx cA clelsb3 vz vx
      cB clelsb3 orbi12i 3bitri vz cv vy cv cA wcel vy cv cB wcel wo vy cab
      wcel vy cv cA wcel vy cv cB wcel wo vy vz cv wsbc vy cv cA wcel vy vz cv
      wsbc vy cv cB wcel vy vz cv wsbc wo vz cv cA wcel vz cv cB wcel wo vy cv
      cA wcel vy cv cB wcel wo vz vy df-clab vy cv cA wcel vy cv cB wcel vy vz
      sbor vy cv cA wcel vy vz cv wsbc vz cv cA wcel vy cv cB wcel vy vz cv
      wsbc vz cv cB wcel vz vy cA clelsb3 vz vy cB clelsb3 orbi12i 3bitri
      bitr4i eqriv $.
      $( [19-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Define the union of two classes.  Definition 5.6 of [TakeutiZaring]
       p. 16.  For an alternate definition in terms of class difference,
       requiring no dummy variables, see ~ dfun2 .  For union defined in terms
       of intersection, see ~ dfun3 . $)
    df-un $a |- ( A u. B ) = { x | ( x e. A \/ x e. B ) } $.
  $}

  ${
    $d x A $.  $d x B $.  $d y A $.  $d y B $.  $d z x $.  $d z y $.
    $d z A $.  $d z B $.
    $( Soundness justification theorem for ~ df-in .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.) $)
     injust $p |- { x | ( x e. A /\ x e. B ) }
                  = { y | ( y e. A /\ y e. B ) } $=
       vz vx cv cA wcel vx cv cB wcel wa vx cab vy cv cA wcel vy cv cB wcel wa
       vy cab vz cv vx cv cA wcel vx cv cB wcel wa vx cab wcel vz cv cA wcel vz
       cv cB wcel wa vz cv vy cv cA wcel vy cv cB wcel wa vy cab wcel vz cv vx
       cv cA wcel vx cv cB wcel wa vx cab wcel vx cv cA wcel vx cv cB wcel wa
       vx vz cv wsbc vx cv cA wcel vx vz cv wsbc vx cv cB wcel vx vz cv wsbc wa
       vz cv cA wcel vz cv cB wcel wa vx cv cA wcel vx cv cB wcel wa vz vx
       df-clab vx cv cA wcel vx cv cB wcel vx vz sban vx cv cA wcel vx vz cv
       wsbc vz cv cA wcel vx cv cB wcel vx vz cv wsbc vz cv cB wcel vz vx cA
       clelsb3 vz vx cB clelsb3 anbi12i 3bitri vz cv vy cv cA wcel vy cv cB
       wcel wa vy cab wcel vy cv cA wcel vy cv cB wcel wa vy vz cv wsbc vy cv
       cA wcel vy vz cv wsbc vy cv cB wcel vy vz cv wsbc wa vz cv cA wcel vz cv
       cB wcel wa vy cv cA wcel vy cv cB wcel wa vz vy df-clab vy cv cA wcel vy
       cv cB wcel vy vz sban vy cv cA wcel vy vz cv wsbc vz cv cA wcel vy cv cB
       wcel vy vz cv wsbc vz cv cB wcel vz vy cA clelsb3 vz vy cB clelsb3
       anbi12i 3bitri bitr4i eqriv $.
       $( [19-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Define the intersection of two classes.  Definition 5.6 of
       [TakeutiZaring] p. 16.  For alternate definitions in terms of class
       difference, requiring no dummy variables, see ~ dfin2 and ~ dfin4 .  For
       intersection defined in terms of union, see ~ dfin3 . $)
    df-in $a |- ( A i^i B ) = { x | ( x e. A /\ x e. B ) } $.

    $( Alternate definition for the intersection of two classes. $)
    dfin5 $p |- ( A i^i B ) = { x e. A | x e. B } $=
      cA cB cin vx cv cA wcel vx cv cB wcel wa vx cab vx cv cB wcel vx cA crab
      vx cA cB df-in vx cv cB wcel vx cA df-rab eqtr4i $.
      $( [11-Jul-2005] $) $( [6-Jul-2005] $)
  $}

  $( Define the subclass relationship.  Exercise 9 of [TakeutiZaring] p. 18.
     For a more traditional definition, but requiring a dummy variable, see
     ~ dfss2 .  Other possible definitions are given by ~ dfss3 , ~ dfss4 ,
     ~ sspss , ~ ssequn1 , ~ ssequn2 , ~ sseqin2 , and ~ ssdif0 . $)
  df-ss $a |- ( A C_ B <-> ( A i^i B ) = A ) $.

  $( A frequently-used variant of subclass definition ~ df-ss . $)
  dfss $p |- ( A C_ B <-> A = ( A i^i B ) ) $=
    cA cB wss cA cB cin cA wceq cA cA cB cin wceq cA cB df-ss cA cB cin cA
    eqcom bitri $.
    $( [3-Sep-2004] $)

  $( Define proper subclass relationship between two classes.  Definition 5.9
     of [TakeutiZaring] p. 17.  Other possible definitions are given by
     ~ dfpss2 and ~ dfpss3 . $)
  df-pss $a |- ( A C. B <-> ( A C_ B /\ A =/= B ) ) $.

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of class difference. $)
    dfdif2 $p |- ( A \ B ) = { x e. A | -. x e. B } $=
      cA cB cdif vx cv cA wcel vx cv cB wcel wn wa vx cab vx cv cB wcel wn vx
      cA crab vx cA cB df-dif vx cv cB wcel wn vx cA df-rab eqtr4i $.
      $( [26-Mar-2004] $) $( [25-Mar-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Expansion of membership in a class difference. $)
    eldif $p |- ( A e. ( B \ C ) <-> ( A e. B /\ -. A e. C ) ) $=
      cA cB cC cdif wcel cA cvv wcel cA cB wcel cA cC wcel wn wa cA cB cC cdif
      elisset cA cB wcel cA cvv wcel cA cC wcel wn cA cB elisset adantr vx cv
      cB wcel vx cv cC wcel wn wa cA cB wcel cA cC wcel wn wa vx cA cB cC cdif
      cvv vx cv cA wceq vx cv cB wcel cA cB wcel vx cv cC wcel wn cA cC wcel wn
      vx cv cA cB eleq1 vx cv cA wceq vx cv cC wcel cA cC wcel vx cv cA cC
      eleq1 notbid anbi12d vx cB cC df-dif elab2g pm5.21nii $.
      $( [29-Apr-1994] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Subclasses and subsets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of the subclass relationship between two classes.
       Definition 5.9 of [TakeutiZaring] p. 17. $)
    dfss2 $p |- ( A C_ B <-> A. x ( x e. A -> x e. B ) ) $=
      cA cB wss vx cv cA wcel vx cv cA wcel vx cv cB wcel wa wb vx wal vx cv cA
      wcel vx cv cB wcel wi vx wal cA cB wss cA cA cB cin wceq cA vx cv cA wcel
      vx cv cB wcel wa vx cab wceq vx cv cA wcel vx cv cA wcel vx cv cB wcel wa
      wb vx wal cA cB dfss cA cB cin vx cv cA wcel vx cv cB wcel wa vx cab cA
      vx cA cB df-in eqeq2i vx cv cA wcel vx cv cB wcel wa vx cA abeq2 3bitri
      vx cv cA wcel vx cv cB wcel wi vx cv cA wcel vx cv cA wcel vx cv cB wcel
      wa wb vx vx cv cA wcel vx cv cB wcel pm4.71 albii bitr4i $.
      $( [8-Jan-2002] $)

    $( Alternate definition of subclass relationship. $)
    dfss3 $p |- ( A C_ B <-> A. x e. A x e. B ) $=
      cA cB wss vx cv cA wcel vx cv cB wcel wi vx wal vx cv cB wcel vx cA wral
      vx cA cB dfss2 vx cv cB wcel vx cA df-ral bitr4i $.
      $( [14-Oct-1999] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    dfss2f.1 $e |- ( y e. A -> A. x y e. A ) $.
    dfss2f.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Equivalence for subclass relation, using bound-variable hypotheses
       instead of distinct variable conditions. $)
    dfss2f $p |- ( A C_ B <-> A. x ( x e. A -> x e. B ) ) $=
      cA cB wss vy cv cA wcel vy cv cB wcel wi vy wal vx cv cA wcel vx cv cB
      wcel wi vx wal vy cA cB dfss2 vx cv cA wcel vx cv cB wcel wi vy cv cA
      wcel vy cv cB wcel wi vx vy vx cv cA wcel vx cv cB wcel wi vy ax-17 vy cv
      cA wcel vy cv cB wcel vx dfss2f.1 dfss2f.2 hbim vx cv vy cv wceq vx cv cA
      wcel vy cv cA wcel vx cv cB wcel vy cv cB wcel vx cv vy cv cA eleq1 vx cv
      vy cv cB eleq1 imbi12d cbval bitr4i $.
      $( [3-Jul-1994] $)

    $( Equivalence for subclass relation, using bound-variable hypotheses
       instead of distinct variable conditions. $)
    dfss3f $p |- ( A C_ B <-> A. x e. A x e. B ) $=
      cA cB wss vx cv cA wcel vx cv cB wcel wi vx wal vx cv cB wcel vx cA wral
      vx vy cA cB dfss2f.1 dfss2f.2 dfss2f vx cv cB wcel vx cA df-ral bitr4i $.
      $( [21-Mar-2004] $) $( [20-Mar-2004] $)

    $( If ` x ` is not free in ` A ` and ` B ` , it is not free in
       ` A C_ B ` . $)
    hbss $p |- ( A C_ B -> A. x A C_ B ) $=
      vx cv cA wcel vx cv cB wcel wi vx wal vx cv cA wcel vx cv cB wcel wi vx
      wal vx wal cA cB wss cA cB wss vx wal vx cv cA wcel vx cv cB wcel wi vx
      hba1 vx vy cA cB dfss2f.1 dfss2f.2 dfss2f cA cB wss vx cv cA wcel vx cv
      cB wcel wi vx wal vx vx vy cA cB dfss2f.1 dfss2f.2 dfss2f albii 3imtr4i
      $.
      $( [27-Dec-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Membership relationships follow from a subclass relationship. $)
    ssel $p |- ( A C_ B -> ( C e. A -> C e. B ) ) $=
      cA cB wss vx cv cC wceq vx cv cA wcel wa vx wex vx cv cC wceq vx cv cB
      wcel wa vx wex cC cA wcel cC cB wcel cA cB wss vx cv cC wceq vx cv cA
      wcel wa vx cv cC wceq vx cv cB wcel wa vx cA cB wss vx cv cA wcel vx cv
      cB wcel vx cv cC wceq cA cB wss vx cv cA wcel vx cv cB wcel wi vx cA cB
      wss vx cv cA wcel vx cv cB wcel wi vx wal vx cA cB dfss2 biimpi 19.21bi
      anim2d 19.22dv vx cC cA df-clel vx cC cB df-clel 3imtr4g $.
      $( [5-Aug-1993] $)
  $}

  $( Membership relationships follow from a subclass relationship. $)
  ssel2 $p |- ( ( A C_ B /\ C e. A ) -> C e. B ) $=
    cA cB wss cC cA wcel cC cB wcel cA cB cC ssel imp $.
    $( [8-Jun-2004] $) $( [7-Jun-2004] $)

  ${
    sseli.1 $e |- A C_ B $.
    $( Membership inference from subclass relationship. $)
    sseli $p |- ( C e. A -> C e. B ) $=
      cA cB wss cC cA wcel cC cB wcel wi sseli.1 cA cB cC ssel ax-mp $.
      $( [5-Aug-1993] $)
    ${
      sselii.2 $e |- C e. A $.
      $( Membership inference from subclass relationship. $)
      sselii $p |- C e. B $=
        cC cA wcel cC cB wcel sselii.2 cA cB cC sseli.1 sseli ax-mp $.
        $( [31-May-1999] $)
    $}
  $}

  ${
    sseld.1 $e |- ( ph -> A C_ B ) $.
    $( Membership deduction from subclass relationship. $)
    sseld $p |- ( ph -> ( C e. A -> C e. B ) ) $=
      wph cA cB wss cC cA wcel cC cB wcel wi sseld.1 cA cB cC ssel syl $.
      $( [15-Nov-1995] $)
    ${
      sseldd.2 $e |- ( ph -> C e. A ) $.
      $( Membership inference from subclass relationship. $)
      sseldd $p |- ( ph -> C e. B ) $=
        wph cC cA wcel cC cB wcel sseldd.2 wph cA cB cC sseld.1 sseld mpd $.
        $( [15-Dec-2004] $) $( [14-Dec-2004] $)
    $}
  $}

  ${
    $d x A $.  $d x B $.
    ssriv.1 $e |- ( x e. A -> x e. B ) $.
    $( Inference rule based on subclass definition. $)
    ssriv $p |- A C_ B $=
      cA cB wss vx cv cA wcel vx cv cB wcel wi vx vx cA cB dfss2 ssriv.1 mpgbir
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    ssrdv.1 $e |- ( ph -> ( x e. A -> x e. B ) ) $.
    $( Deduction rule based on subclass definition. $)
    ssrdv $p |- ( ph -> A C_ B ) $=
      wph vx cv cA wcel vx cv cB wcel wi vx wal cA cB wss wph vx cv cA wcel vx
      cv cB wcel wi vx ssrdv.1 19.21aiv vx cA cB dfss2 sylibr $.
      $( [15-Nov-1995] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Transitivity of subclasses.  Exercise 5 of [TakeutiZaring] p. 17. $)
    sstr2 $p |- ( A C_ B -> ( B C_ C -> A C_ C ) ) $=
      cA cB wss vx cv cA wcel vx cv cB wcel wi vx wal cB cC wss cA cC wss wi vx
      cA cB dfss2 vx cv cA wcel vx cv cB wcel wi vx wal vx cv cB wcel vx cv cC
      wcel wi vx wal vx cv cA wcel vx cv cC wcel wi vx wal cB cC wss cA cC wss
      vx cv cA wcel vx cv cB wcel wi vx cv cB wcel vx cv cC wcel wi vx cv cA
      wcel vx cv cC wcel wi vx vx cv cA wcel vx cv cB wcel vx cv cC wcel imim1
      19.20ii vx cB cC dfss2 vx cA cC dfss2 3imtr4g sylbi $.
      $( [5-Aug-1993] $)
  $}

  $( Transitivity of subclasses.  Theorem 6 of [Suppes] p. 23. $)
  sstr $p |- ( ( A C_ B /\ B C_ C ) -> A C_ C ) $=
    cA cB wss cB cC wss cA cC wss cA cB cC sstr2 imp $.
    $( [5-Sep-2003] $)

  ${
    sstri.1 $e |- A C_ B $.
    sstri.2 $e |- B C_ C $.
    $( Subclass transitivity inference. $)
    sstri $p |- A C_ C $=
      cA cB wss cB cC wss cA cC wss sstri.1 sstri.2 cA cB cC sstr2 mp2 $.
      $( [5-May-2000] $)
  $}

  ${
    sstrd.1 $e |- ( ph -> A C_ B ) $.
    sstrd.2 $e |- ( ph -> B C_ C ) $.
    $( Subclass transitivity deduction. $)
    sstrd $p |- ( ph -> A C_ C ) $=
      cA cB wss cB cC wss cA cC wss wph cA cB cC sstr sstrd.1 sstrd.2 sylanc $.
      $( [4-Jun-2004] $) $( [2-Jun-2004] $)
  $}

  ${
    sylan9ss.1 $e |- ( ph -> A C_ B ) $.
    sylan9ss.2 $e |- ( ps -> B C_ C ) $.
    $( A subclass transitivity deduction. $)
    sylan9ss $p |- ( ( ph /\ ps ) -> A C_ C ) $=
      wph wps wa cA cB cC wph cA cB wss wps sylan9ss.1 adantr wps cB cC wss wph
      sylan9ss.2 adantl sstrd $.
      $( [28-Sep-2004] $) $( [27-Sep-2004] $)
  $}

  ${
    sylan9ssr.1 $e |- ( ph -> A C_ B ) $.
    sylan9ssr.2 $e |- ( ps -> B C_ C ) $.
    $( A subclass transitivity deduction. $)
    sylan9ssr $p |- ( ( ps /\ ph ) -> A C_ C ) $=
      wph wps cA cC wss wph wps cA cB cC sylan9ssr.1 sylan9ssr.2 sylan9ss
      ancoms $.
      $( [28-Oct-2004] $) $( [27-Sep-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The subclass relationship is antisymmetric.  Compare Theorem 4 of
       [Suppes] p. 22. $)
    eqss $p |- ( A = B <-> ( A C_ B /\ B C_ A ) ) $=
      vx cv cA wcel vx cv cB wcel wb vx wal vx cv cA wcel vx cv cB wcel wi vx
      wal vx cv cB wcel vx cv cA wcel wi vx wal wa cA cB wceq cA cB wss cB cA
      wss wa vx cv cA wcel vx cv cB wcel vx albi vx cA cB dfcleq cA cB wss vx
      cv cA wcel vx cv cB wcel wi vx wal cB cA wss vx cv cB wcel vx cv cA wcel
      wi vx wal vx cA cB dfss2 vx cB cA dfss2 anbi12i 3bitr4i $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqssi.1 $e |- A C_ B $.
    eqssi.2 $e |- B C_ A $.
    $( Infer equality from two subclass relationships.  Compare Theorem 4 of
       [Suppes] p. 22. $)
    eqssi $p |- A = B $=
      cA cB wceq cA cB wss cB cA wss cA cB eqss eqssi.1 eqssi.2 mpbir2an $.
      $( [9-Sep-1993] $)
  $}

  ${
    eqssd.1 $e |- ( ph -> A C_ B ) $.
    eqssd.2 $e |- ( ph -> B C_ A ) $.
    $( Equality deduction from two subclass relationships.  Compare Theorem 4
       of [Suppes] p. 22. $)
    eqssd $p |- ( ph -> A = B ) $=
      cA cB wceq cA cB wss cB cA wss wph cA cB eqss eqssd.1 eqssd.2 sylanbrc $.
      $( [28-Jun-2004] $) $( [27-Jun-2004] $)
  $}

  $( Any class is a subclass of itself.  Exercise 10 of [TakeutiZaring]
     p. 18. $)
  ssid $p |- A C_ A $=
    cA cA wss cA cA wss cA cA wceq cA cA wss cA cA wss wa cA eqid cA cA eqss
    mpbi pm3.26i $.
    $( [5-Aug-1993] $)

  ${
    $d A x $.
    $( Any class is a subclass of the universal class. $)
    ssv $p |- A C_ _V $=
      vx cA cvv vx cv cA elisset ssriv $.
      $( [31-Oct-1995] $)
  $}

  $( Equality theorem for subclasses. $)
  sseq1 $p |- ( A = B -> ( A C_ C <-> B C_ C ) ) $=
    cA cC wss cB cC wss wb cB cA cB cA wss cA cB wss wa cA cC wss cB cC wss wi
    cB cC wss cA cC wss wi wa cB cA wceq cA cC wss cB cC wss wb cB cA wss cA cC
    wss cB cC wss wi cA cB wss cB cC wss cA cC wss wi cB cA cC sstr2 cA cB cC
    sstr2 anim12i cB cA eqss cA cC wss cB cC wss dfbi2 3imtr4i eqcoms $.
    $( [5-Aug-1993] $)

  $( Equality theorem for the subclass relationship. $)
  sseq2 $p |- ( A = B -> ( C C_ A <-> C C_ B ) ) $=
    cA cB wss cB cA wss wa cC cA wss cC cB wss wi cC cB wss cC cA wss wi wa cA
    cB wceq cC cA wss cC cB wss wb cA cB wss cC cA wss cC cB wss wi cB cA wss
    cC cB wss cC cA wss wi cC cA wss cA cB wss cC cB wss cC cA cB sstr2 com12
    cC cB wss cB cA wss cC cA wss cC cB cA sstr2 com12 anim12i cA cB eqss cC cA
    wss cC cB wss dfbi2 3imtr4i $.
    $( [25-Jun-1998] $)

  $( Equality theorem for the subclass relationship. $)
  sseq12 $p |- ( ( A = B /\ C = D ) -> ( A C_ C <-> B C_ D ) ) $=
    cA cB wceq cA cC wss cB cC wss cC cD wceq cB cD wss cA cB cC sseq1 cC cD cB
    sseq2 sylan9bb $.
    $( [31-May-1999] $)

  ${
    sseq1i.1 $e |- A = B $.
    $( An equality inference for the subclass relationship. $)
    sseq1i $p |- ( A C_ C <-> B C_ C ) $=
      cA cB wceq cA cC wss cB cC wss wb sseq1i.1 cA cB cC sseq1 ax-mp $.
      $( [18-Aug-1993] $)

    $( An equality inference for the subclass relationship. $)
    sseq2i $p |- ( C C_ A <-> C C_ B ) $=
      cA cB wceq cC cA wss cC cB wss wb sseq1i.1 cA cB cC sseq2 ax-mp $.
      $( [30-Aug-1993] $)

    ${
      sseq12i.2 $e |- C = D $.
      $( An equality inference for the subclass relationship.  (The proof was
         shortened by Eric Schmidt, 26-Jan-2007.) $)
      sseq12i $p |- ( A C_ C <-> B C_ D ) $=
        cA cB wceq cC cD wceq cA cC wss cB cD wss wb sseq1i.1 sseq12i.2 cA cB
        cC cD sseq12 mp2an $.
        $( [27-Jan-2007] $) $( [31-May-1999] $)
    $}
  $}

  ${
    sseq1d.1 $e |- ( ph -> A = B ) $.
    $( An equality deduction for the subclass relationship. $)
    sseq1d $p |- ( ph -> ( A C_ C <-> B C_ C ) ) $=
      wph cA cB wceq cA cC wss cB cC wss wb sseq1d.1 cA cB cC sseq1 syl $.
      $( [14-Aug-1994] $)

    $( An equality deduction for the subclass relationship. $)
    sseq2d $p |- ( ph -> ( C C_ A <-> C C_ B ) ) $=
      wph cA cB wceq cC cA wss cC cB wss wb sseq1d.1 cA cB cC sseq2 syl $.
      $( [14-Aug-1994] $)

    ${
      sseq12d.2 $e |- ( ph -> C = D ) $.
      $( An equality deduction for the subclass relationship. $)
      sseq12d $p |- ( ph -> ( A C_ C <-> B C_ D ) ) $=
        wph cA cC wss cB cC wss cB cD wss wph cA cB cC sseq1d.1 sseq1d wph cC
        cD cB sseq12d.2 sseq2d bitrd $.
        $( [31-May-1999] $)
    $}
  $}

  ${
    eqsstr.1 $e |- A = B $.
    eqsstr.2 $e |- B C_ C $.
    $( Substitution of equality into a subclass relationship. $)
    eqsstri $p |- A C_ C $=
      cA cC wss cB cC wss eqsstr.2 cA cB cC eqsstr.1 sseq1i mpbir $.
      $( [16-Jul-1995] $)
  $}

  ${
    eqsstr3.1 $e |- B = A $.
    eqsstr3.2 $e |- B C_ C $.
    $( Substitution of equality into a subclass relationship. $)
    eqsstr3i $p |- A C_ C $=
      cA cB cC cB cA eqsstr3.1 eqcomi eqsstr3.2 eqsstri $.
      $( [19-Oct-1999] $)
  $}

  ${
    sseqtr.1 $e |- A C_ B $.
    sseqtr.2 $e |- B = C $.
    $( Substitution of equality into a subclass relationship. $)
    sseqtri $p |- A C_ C $=
      cA cB wss cA cC wss sseqtr.1 cB cC cA sseqtr.2 sseq2i mpbi $.
      $( [28-Jul-1995] $)
  $}

  ${
    sseqtr4.1 $e |- A C_ B $.
    sseqtr4.2 $e |- C = B $.
    $( Substitution of equality into a subclass relationship. $)
    sseqtr4i $p |- A C_ C $=
      cA cB cC sseqtr4.1 cC cB sseqtr4.2 eqcomi sseqtri $.
      $( [4-Apr-1995] $)
  $}

  ${
    eqsstrd.1 $e |- ( ph -> A = B ) $.
    eqsstrd.2 $e |- ( ph -> B C_ C ) $.
    $( Substitution of equality into a subclass relationship. $)
    eqsstrd $p |- ( ph -> A C_ C ) $=
      wph cA cC wss cB cC wss eqsstrd.2 wph cA cB cC eqsstrd.1 sseq1d mpbird $.
      $( [27-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    eqsstr3d.1 $e |- ( ph -> B = A ) $.
    eqsstr3d.2 $e |- ( ph -> B C_ C ) $.
    $( Substitution of equality into a subclass relationship. $)
    eqsstr3d $p |- ( ph -> A C_ C ) $=
      wph cA cB cC wph cB cA eqsstr3d.1 eqcomd eqsstr3d.2 eqsstrd $.
      $( [27-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    sseqtrd.1 $e |- ( ph -> A C_ B ) $.
    sseqtrd.2 $e |- ( ph -> B = C ) $.
    $( Substitution of equality into a subclass relationship. $)
    sseqtrd $p |- ( ph -> A C_ C ) $=
      wph cA cB wss cA cC wss sseqtrd.1 wph cB cC cA sseqtrd.2 sseq2d mpbid $.
      $( [27-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    sseqtr4d.1 $e |- ( ph -> A C_ B ) $.
    sseqtr4d.2 $e |- ( ph -> C = B ) $.
    $( Substitution of equality into a subclass relationship. $)
    sseqtr4d $p |- ( ph -> A C_ C ) $=
      wph cA cB cC sseqtr4d.1 wph cC cB sseqtr4d.2 eqcomd sseqtrd $.
      $( [27-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    3sstr3.1 $e |- A C_ B $.
    3sstr3.2 $e |- A = C $.
    3sstr3.3 $e |- B = D $.
    $( Substitution of equality in both sides of a subclass relationship.
       (The proof was shortened by Eric Schmidt, 26-Jan-2007.) $)
    3sstr3i $p |- C C_ D $=
      cA cB wss cC cD wss 3sstr3.1 cA cC cB cD 3sstr3.2 3sstr3.3 sseq12i mpbi
      $.
      $( [27-Jan-2007] $) $( [13-Jan-1996] $)
  $}

  ${
    3sstr4.1 $e |- A C_ B $.
    3sstr4.2 $e |- C = A $.
    3sstr4.3 $e |- D = B $.
    $( Substitution of equality in both sides of a subclass relationship.
       (The proof was shortened by Eric Schmidt, 26-Jan-2007.) $)
    3sstr4i $p |- C C_ D $=
      cC cD wss cA cB wss 3sstr4.1 cC cA cD cB 3sstr4.2 3sstr4.3 sseq12i mpbir
      $.
      $( [27-Jan-2007] $) $( [13-Jan-1996] $)
  $}

  ${
    3sstr3g.1 $e |- ( ph -> A C_ B ) $.
    3sstr3g.2 $e |- A = C $.
    3sstr3g.3 $e |- B = D $.
    $( Substitution of equality into both sides of a subclass relationship. $)
    3sstr3g $p |- ( ph -> C C_ D ) $=
      wph cA cB wss cC cD wss 3sstr3g.1 cA cC cB cD 3sstr3g.2 3sstr3g.3 sseq12i
      sylib $.
      $( [1-Oct-2000] $)
  $}

  ${
    3sstr4g.1 $e |- ( ph -> A C_ B ) $.
    3sstr4g.2 $e |- C = A $.
    3sstr4g.3 $e |- D = B $.
    $( Substitution of equality into both sides of a subclass relationship.
       (The proof was shortened by Eric Schmidt, 26-Jan-2007.) $)
    3sstr4g $p |- ( ph -> C C_ D ) $=
      wph cA cB wss cC cD wss 3sstr4g.1 cC cA cD cB 3sstr4g.2 3sstr4g.3 sseq12i
      sylibr $.
      $( [27-Jan-2007] $) $( [16-Aug-1994] $)
  $}

  ${
    3sstr3d.1 $e |- ( ph -> A C_ B ) $.
    3sstr3d.2 $e |- ( ph -> A = C ) $.
    3sstr3d.3 $e |- ( ph -> B = D ) $.
    $( Substitution of equality into both sides of a subclass relationship. $)
    3sstr3d $p |- ( ph -> C C_ D ) $=
      wph cA cB wss cC cD wss 3sstr3d.1 wph cA cC cB cD 3sstr3d.2 3sstr3d.3
      sseq12d mpbid $.
      $( [1-Oct-2000] $)
  $}

  ${
    3sstr4d.1 $e |- ( ph -> A C_ B ) $.
    3sstr4d.2 $e |- ( ph -> C = A ) $.
    3sstr4d.3 $e |- ( ph -> D = B ) $.
    $( Substitution of equality into both sides of a subclass relationship.
       (The proof was shortened by Eric Schmidt, 26-Jan-2007.) $)
    3sstr4d $p |- ( ph -> C C_ D ) $=
      wph cC cD wss cA cB wss 3sstr4d.1 wph cC cA cD cB 3sstr4d.2 3sstr4d.3
      sseq12d mpbird $.
      $( [27-Jan-2007] $) $( [30-Nov-1995] $)
  $}

  ${
    syl5ss.1 $e |- ( ph -> A C_ B ) $.
    syl5ss.2 $e |- C = A $.
    $( A chained subclass and equality deduction. $)
    syl5ss $p |- ( ph -> C C_ B ) $=
      wph cA cB wss cC cB wss syl5ss.1 cC cA cB syl5ss.2 sseq1i sylibr $.
      $( [26-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    syl5ssr.1 $e |- ( ph -> A C_ B ) $.
    syl5ssr.2 $e |- A = C $.
    $( A chained subclass and equality deduction. $)
    syl5ssr $p |- ( ph -> C C_ B ) $=
      wph cA cB cC syl5ssr.1 cA cC syl5ssr.2 eqcomi syl5ss $.
      $( [26-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    syl6ss.1 $e |- ( ph -> A C_ B ) $.
    syl6ss.2 $e |- B = C $.
    $( A chained subclass and equality deduction. $)
    syl6ss $p |- ( ph -> A C_ C ) $=
      wph cA cB wss cA cC wss syl6ss.1 cB cC cA syl6ss.2 sseq2i sylib $.
      $( [26-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  ${
    syl6ssr.1 $e |- ( ph -> A C_ B ) $.
    syl6ssr.2 $e |- C = B $.
    $( A chained subclass and equality deduction. $)
    syl6ssr $p |- ( ph -> A C_ C ) $=
      wph cA cB cC syl6ssr.1 cC cB syl6ssr.2 eqcomi syl6ss $.
      $( [26-Apr-2004] $) $( [25-Apr-2004] $)
  $}

  $( Equality implies the subclass relation. $)
  eqimss $p |- ( A = B -> A C_ B ) $=
    cA cB wceq cA cA wss cA cB wss cA ssid cA cB cA sseq2 mpbii $.
    $( [5-Aug-1993] $)

  $( Equality implies the subclass relation. $)
  eqimss2 $p |- ( B = A -> A C_ B ) $=
    cA cB wss cA cB cA cB eqimss eqcoms $.
    $( [23-Nov-2003] $) $( [23-Nov-2003] $)

  ${
    eqimssi.1 $e |- A = B $.
    $( Infer subclass relationship from equality. $)
    eqimssi $p |- A C_ B $=
      cA cA cB cA ssid eqimssi.1 sseqtri $.
      $( [6-Jan-2007] $) $( [6-Jan-2007] $)

    $( Infer subclass relationship from equality. $)
    eqimss2i $p |- B C_ A $=
      cB cB cA cB ssid eqimssi.1 sseqtr4i $.
      $( [7-Jan-2007] $) $( [7-Jan-2007] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Negation of subclass relationship.  Exercise 13 of [TakeutiZaring]
       p. 18. $)
    nss $p |- ( -. A C_ B <-> E. x ( x e. A /\ -. x e. B ) ) $=
      vx cv cA wcel vx cv cB wcel wi wn vx wex vx cv cA wcel vx cv cB wcel wi
      vx wal wn vx cv cA wcel vx cv cB wcel wn wa vx wex cA cB wss wn vx cv cA
      wcel vx cv cB wcel wi vx exnal vx cv cA wcel vx cv cB wcel wn wa vx cv cA
      wcel vx cv cB wcel wi wn vx vx cv cA wcel vx cv cB wcel annim exbii cA cB
      wss vx cv cA wcel vx cv cB wcel wi vx wal vx cA cB dfss2 notbii 3bitr4ri
      $.
      $( [25-Feb-1996] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Quantification restricted to a subclass. $)
    ssralv $p |- ( A C_ B -> ( A. x e. B ph -> A. x e. A ph ) ) $=
      cA cB wss wph wph vx cB cA cA cB wss vx cv cA wcel vx cv cB wcel wph cA
      cB vx cv ssel imim1d r19.20dv2 $.
      $( [12-Mar-2006] $) $( [11-Mar-2006] $)

    $( Existential quantification restricted to a subclass. $)
    ssrexv $p |- ( A C_ B -> ( E. x e. A ph -> E. x e. B ph ) ) $=
      cA cB wss wph wph vx cA cB cA cB wss vx cv cA wcel vx cv cB wcel wph cA
      cB vx cv ssel anim1d r19.22dv2 $.
      $( [13-Jan-2007] $) $( [11-Jan-2007] $)
  $}

  ${
    $d ph y $.  $d ps y $.  $d x y $.
    $( Class abstractions in a subclass relationship. $)
    ss2ab $p |- ( { x | ph } C_ { x | ps } <-> A. x ( ph -> ps ) ) $=
      wph vx cab wps vx cab wss vx cv wph vx cab wcel vx cv wps vx cab wcel wi
      vx wal wph wps wi vx wal vx vy wph vx cab wps vx cab wph vx vy hbab1 wps
      vx vy hbab1 dfss2f vx cv wph vx cab wcel vx cv wps vx cab wcel wi wph wps
      wi vx vx cv wph vx cab wcel wph vx cv wps vx cab wcel wps wph vx abid wps
      vx abid imbi12i albii bitri $.
      $( [3-Jul-1994] $)
  $}

  ${
    $d x A $.
    $( Class abstraction in a subclass relationship. $)
    abss $p |- ( { x | ph } C_ A <-> A. x ( ph -> x e. A ) ) $=
      wph vx cab cA wss wph vx cab vx cv cA wcel vx cab wss wph vx cv cA wcel
      wi vx wal vx cv cA wcel vx cab cA wph vx cab vx cA abid2 sseq2i wph vx cv
      cA wcel vx ss2ab bitr3i $.
      $( [17-Aug-2006] $) $( [16-Aug-2006] $)

    $( Subclass of a class abstraction. $)
    ssab $p |- ( A C_ { x | ph } <-> A. x ( x e. A -> ph ) ) $=
      cA wph vx cab wss vx cv cA wcel vx cab wph vx cab wss vx cv cA wcel wph
      wi vx wal vx cv cA wcel vx cab cA wph vx cab vx cA abid2 sseq1i vx cv cA
      wcel wph vx ss2ab bitr3i $.
      $( [6-Sep-2006] $) $( [16-Aug-2006] $)

    $( The relation for a subclass of a class abstraction is equivalent to
       restricted quantification. $)
    ssabral $p |- ( A C_ { x | ph } <-> A. x e. A ph ) $=
      cA wph vx cab wss vx cv cA wcel wph wi vx wal wph vx cA wral wph vx cA
      ssab wph vx cA df-ral bitr4i $.
      $( [16-Sep-2006] $) $( [6-Sep-2006] $)
  $}

  ${
    ss2abi.1 $e |- ( ph -> ps ) $.
    $( Inference of abstraction subclass from implication. $)
    ss2abi $p |- { x | ph } C_ { x | ps } $=
      wph vx cab wps vx cab wss wph wps wi vx wph wps vx ss2ab ss2abi.1 mpgbir
      $.
      $( [31-Mar-1995] $)
  $}

  ${
    $d x ph $.  $d x A $.
    abssdv.1 $e |- ( ph -> ( ps -> x e. A ) ) $.
    $( Deduction of abstraction subclass from implication. $)
    abssdv $p |- ( ph -> { x | ps } C_ A ) $=
      wph wps vx cv cA wcel wi vx wal wps vx cab cA wss wph wps vx cv cA wcel
      wi vx abssdv.1 19.21aiv wps vx cA abss sylibr $.
      $( [25-Feb-2006] $) $( [20-Jan-2006] $)
  $}

  ${
    $d x A $.
    abssi.1 $e |- ( ph -> x e. A ) $.
    $( Inference of abstraction subclass from implication. $)
    abssi $p |- { x | ph } C_ A $=
      wph vx cab vx cv cA wcel vx cab cA wph vx cv cA wcel vx abssi.1 ss2abi vx
      cA abid2 sseqtri $.
      $( [22-Jan-2006] $) $( [20-Jan-2006] $)
  $}

  $( Restricted abstraction classes in a subclass relationship. $)
  ss2rab $p |- ( { x e. A | ph } C_ { x e. A | ps } <->
               A. x e. A ( ph -> ps ) ) $=
    wph vx cA crab wps vx cA crab wss vx cv cA wcel wph wa vx cab vx cv cA wcel
    wps wa vx cab wss vx cv cA wcel wph wa vx cv cA wcel wps wa wi vx wal wph
    wps wi vx cA wral wph vx cA crab vx cv cA wcel wph wa vx cab wps vx cA crab
    vx cv cA wcel wps wa vx cab wph vx cA df-rab wps vx cA df-rab sseq12i vx cv
    cA wcel wph wa vx cv cA wcel wps wa vx ss2ab wph wps wi vx cA wral vx cv cA
    wcel wph wps wi wi vx wal vx cv cA wcel wph wa vx cv cA wcel wps wa wi vx
    wal wph wps wi vx cA df-ral vx cv cA wcel wph wps wi wi vx cv cA wcel wph
    wa vx cv cA wcel wps wa wi vx vx cv cA wcel wph wps imdistan albii bitr2i
    3bitri $.
    $( [30-May-1999] $)

  ${
    $d x B $.
    $( Restricted class abstraction in a subclass relationship. $)
    rabss $p |- ( { x e. A | ph } C_ B <-> A. x e. A ( ph -> x e. B ) ) $=
      wph vx cA crab cB wss vx cv cA wcel wph wa vx cab cB wss vx cv cA wcel
      wph wa vx cv cB wcel wi vx wal wph vx cv cB wcel wi vx cA wral wph vx cA
      crab vx cv cA wcel wph wa vx cab cB wph vx cA df-rab sseq1i vx cv cA wcel
      wph wa vx cB abss vx cv cA wcel wph wa vx cv cB wcel wi vx wal vx cv cA
      wcel wph vx cv cB wcel wi wi vx wal wph vx cv cB wcel wi vx cA wral vx cv
      cA wcel wph wa vx cv cB wcel wi vx cv cA wcel wph vx cv cB wcel wi wi vx
      vx cv cA wcel wph vx cv cB wcel impexp albii wph vx cv cB wcel wi vx cA
      df-ral bitr4i 3bitri $.
      $( [18-Sep-2006] $) $( [16-Aug-2006] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass of a restricted class abstraction. $)
    ssrab $p |- ( B C_ { x e. A | ph } <-> ( B C_ A /\ A. x e. B ph ) ) $=
      cB wph vx cA crab wss cB vx cv cA wcel wph wa vx cab wss vx cv cB wcel vx
      cv cA wcel wph wa wi vx wal cB cA wss wph vx cB wral wa wph vx cA crab vx
      cv cA wcel wph wa vx cab cB wph vx cA df-rab sseq2i vx cv cA wcel wph wa
      vx cB ssab cB cA wss wph vx cB wral wa vx cv cA wcel vx cB wral wph vx cB
      wral wa vx cv cA wcel wph wa vx cB wral vx cv cB wcel vx cv cA wcel wph
      wa wi vx wal cB cA wss vx cv cA wcel vx cB wral wph vx cB wral vx cB cA
      dfss3 anbi1i vx cv cA wcel wph vx cB r19.26 vx cv cA wcel wph wa vx cB
      df-ral 3bitr2ri 3bitri $.
      $( [8-Sep-2006] $) $( [16-Aug-2006] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    ssrabdv.1 $e |- ( ph -> B C_ A ) $.
    ssrabdv.2 $e |- ( ( ph /\ x e. B ) -> ps ) $.
    $( Subclass of a restricted class abstraction (deduction rule). $)
    ssrabdv $p |- ( ph -> B C_ { x e. A | ps } ) $=
      cB wps vx cA crab wss cB cA wss wps vx cB wral wph wps vx cA cB ssrab
      ssrabdv.1 wph wps vx cB ssrabdv.2 r19.21aiva sylanbrc $.
      $( [13-Sep-2006] $) $( [31-Aug-2006] $)
  $}

  ${
    $d x ph $.
    ss2rabdv.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction of restricted abstraction subclass from implication. $)
    ss2rabdv $p |- ( ph -> { x e. A | ps } C_ { x e. A | ch } ) $=
      wph wps wch wi vx cA wral wps vx cA crab wch vx cA crab wss wph wps wch
      wi vx cA ss2rabdv.1 r19.21aiva wps wch vx cA ss2rab sylibr $.
      $( [31-May-2006] $) $( [30-May-2006] $)
  $}

  ${
    ss2rabi.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference of restricted abstraction subclass from implication. $)
    ss2rabi $p |- { x e. A | ph } C_ { x e. A | ps } $=
      wph vx cA crab wps vx cA crab wss wph wps wi vx cA wph wps vx cA ss2rab
      ss2rabi.1 mprgbir $.
      $( [14-Oct-1999] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass law for restricted abstraction. $)
    rabss2 $p |- ( A C_ B -> { x e. A | ph } C_ { x e. B | ph } ) $=
      vx cv cA wcel vx cv cB wcel wi vx wal vx cv cA wcel wph wa vx cab vx cv
      cB wcel wph wa vx cab wss cA cB wss wph vx cA crab wph vx cB crab wss vx
      cv cA wcel vx cv cB wcel wi vx wal vx cv cA wcel wph wa vx cv cB wcel wph
      wa wi vx wal vx cv cA wcel wph wa vx cab vx cv cB wcel wph wa vx cab wss
      vx cv cA wcel vx cv cB wcel wi vx cv cA wcel wph wa vx cv cB wcel wph wa
      wi vx vx cv cA wcel vx cv cB wcel wph pm3.45 19.20i vx cv cA wcel wph wa
      vx cv cB wcel wph wa vx ss2ab sylibr vx cA cB dfss2 wph vx cA crab vx cv
      cA wcel wph wa vx cab wph vx cB crab vx cv cB wcel wph wa vx cab wph vx
      cA df-rab wph vx cB df-rab sseq12i 3imtr4i $.
      $( [16-Jan-2005] $) $( [18-Dec-2004] $)

    $( Subclass relation for the restriction of a class abstraction. $)
    ssab2 $p |- { x | ( x e. A /\ ph ) } C_ A $=
      vx cv cA wcel wph wa vx cA vx cv cA wcel wph pm3.26 abssi $.
      $( [31-Mar-1995] $)

    $( Subclass relation for a restricted class. $)
    ssrab2 $p |- { x e. A | ph } C_ A $=
      wph vx cA crab vx cv cA wcel wph wa vx cab cA wph vx cA df-rab wph vx cA
      ssab2 eqsstri $.
      $( [19-Mar-1997] $)
  $}

  ${
    $d w y z A $.  $d w y z B $.  $d w x z C $.  $d w D $.  $d x y $.
    $( A subset relationship useful for converting union to indexed union using
       ~ dfiun2 or ~ dfiun2g and intersection to indexed intersection using
       ~ dfiin2 . $)
    uniiunlem $p |- ( A. x e. A B e. D ->
                     ( A. x e. A B e. C <-> { y | E. x e. A y = B } C_ C ) ) $=
      cB cD wcel vx cA wral cB cC wcel vx cA wral vz cv cB wceq vx cA wrex vz
      cv cC wcel wi vz wal vy cv cB wceq vx cA wrex vy cab cC wss cB cD wcel vx
      cA wral cB cC wcel vx cA wral vz cv cB wceq vx cA wrex vz cv cC wcel wi
      vz wal cB cC wcel vx cA wral vz cv cB wceq vx cA wrex vz cv cC wcel wi vz
      cB cC wcel vx cA wral vz cv cB wceq vz cv cC wcel vx cA cB cC wcel vx cA
      hbra1 vz cv cC wcel vx ax-17 cB cC wcel vx cA wral vx cv cA wcel cB cC
      wcel vz cv cB wceq vz cv cC wcel wi cB cC wcel vx cA ra4 cB cC vz cv
      eleq1a syl6 r19.23ad 19.21aiv vz cv cB wceq vx cA wrex vz cv cC wcel wi
      vz wal cB cD wcel vx cA wral cB cC wcel vx cA wral vz cv cB wceq vx cA
      wrex vz cv cC wcel wi vz wal cB cD wcel cB cC wcel vx cA vz cv cB wceq vx
      cA wrex vz cv cC wcel wi vx vz vz cv cB wceq vx cA wrex vz cv cC wcel vx
      vz cv cB wceq vx cA hbre1 vz cv cC wcel vx ax-17 hbim hbal cB cD wcel vz
      cv cB wceq vx cA wrex vz cv cC wcel wi vz wal vx cv cA wcel wa cB cC wcel
      cB cD wcel vz cv cB wceq vx cA wrex vz cv cC wcel wi vz wal vx cv cA wcel
      cB cC wcel vx vw cv cB csb cB wceq vw wex cB cD wcel vz cv cB wceq vx cA
      wrex vz cv cC wcel wi vz wal vx cv cA wcel cB cC wcel wi wi wi vx vw cv
      cB csb cB wceq cB cB wceq vw vx vw cv vx cv wceq vx vw cv cB csb cB cB vw
      cv vx cv wceq cB vx vw cv cB csb cB vx vw cv cB csb wceq vx cv vw cv vx
      vw cv cB csbeq1a eqcoms eqcomd eqeq1d cB eqid a4eiv vx vw cv cB csb cB
      wceq cB cD wcel vz cv cB wceq vx cA wrex vz cv cC wcel wi vz wal vx cv cA
      wcel cB cC wcel wi wi wi vw vx vw cv cB csb cB wceq vx vw cv cB csb cD
      wcel vz cv cB wceq vx cA wrex vz cv cC wcel wi vz wal vx cv cA wcel vx vw
      cv cB csb cC wcel wi wi cB cD wcel vz cv cB wceq vx cA wrex vz cv cC wcel
      wi vz wal vx cv cA wcel cB cC wcel wi wi vx vw cv cB csb cD wcel vz cv cB
      wceq vx cA wrex vz cv cC wcel wi vz wal vx cv cA wcel vx vw cv cB csb cB
      wceq vx vw cv cB csb cC wcel vx vw cv cB csb cD wcel vz cv cB wceq vx cA
      wrex vz cv cC wcel wi vz wal vx cv cA wcel vx vw cv cB csb cB wceq vx vw
      cv cB csb cC wcel vx vw cv cB csb cD wcel vz cv cB wceq vx cA wrex vz cv
      cC wcel wi vz wal vx vw cv cB csb cB wceq vx cA wrex vx vw cv cB csb cC
      wcel vx cv cA wcel vx vw cv cB csb cB wceq wa vz cv cB wceq vx cA wrex vz
      cv cC wcel wi vx vw cv cB csb cB wceq vx cA wrex vx vw cv cB csb cC wcel
      wi vz vx vw cv cB csb cD vz cv vx vw cv cB csb wceq vz cv cB wceq vx cA
      wrex vx vw cv cB csb cB wceq vx cA wrex vz cv cC wcel vx vw cv cB csb cC
      wcel vz cv vx vw cv cB csb wceq vz cv cB wceq vx vw cv cB csb cB wceq vx
      cA vx vz vx vw cv cB csb vx vz vw cv cB vw visset vz cv vw cv wcel vx
      ax-17 hbcsb1 hbeleq vz cv vx vw cv cB csb cB eqeq1 rexbid vz cv vx vw cv
      cB csb cC eleq1 imbi12d cla4gv vx vw cv cB csb cB wceq vx cA ra4e syl7
      exp4a com4r vx vw cv cB csb cB cD eleq1 vx vw cv cB csb cB wceq vx cv cA
      wcel vx vw cv cB csb cC wcel wi vx cv cA wcel cB cC wcel wi vz cv cB wceq
      vx cA wrex vz cv cC wcel wi vz wal vx vw cv cB csb cB wceq vx vw cv cB
      csb cC wcel cB cC wcel vx cv cA wcel vx vw cv cB csb cB cC eleq1 imbi2d
      imbi2d 3imtr3d 19.23aiv ax-mp imp3a com12 r19.20da com12 impbid2 vz cv cB
      wceq vx cA wrex vz cv cC wcel wi vz wal vz cv cB wceq vx cA wrex vz cab
      cC wss vy cv cB wceq vx cA wrex vy cab cC wss vz cv cB wceq vx cA wrex vz
      cC abss vz cv cB wceq vx cA wrex vz cab vy cv cB wceq vx cA wrex vy cab
      cC vz cv cB wceq vx cA wrex vy cv cB wceq vx cA wrex vz vy vz cv vy cv
      wceq vz cv cB wceq vy cv cB wceq vx cA vz cv vy cv cB eqeq1 rexbidv
      cbvabv sseq1i bitr3i syl6bb $.
      $( [6-Oct-2006] $) $( [5-Oct-2006] $)
  $}

  $( Alternate definition of proper subclass. $)
  dfpss2 $p |- ( A C. B <-> ( A C_ B /\ -. A = B ) ) $=
    cA cB wpss cA cB wss cA cB wne wa cA cB wss cA cB wceq wn wa cA cB df-pss
    cA cB wne cA cB wceq wn cA cB wss cA cB df-ne anbi2i bitri $.
    $( [7-Feb-1996] $)

  $( Alternate definition of proper subclass. $)
  dfpss3 $p |- ( A C. B <-> ( A C_ B /\ -. B C_ A ) ) $=
    cA cB wss cA cB wceq wn wa cA cB wss cA cB wss cB cA wss wa wn wa cA cB
    wpss cA cB wss cB cA wss wn wa cA cB wceq wn cA cB wss cB cA wss wa wn cA
    cB wss cA cB wceq cA cB wss cB cA wss wa cA cB eqss notbii anbi2i cA cB
    dfpss2 cA cB wss cB cA wss wn wa cA cB wss cA cB wss cB cA wss wa wn wa cA
    cB wss cB cA wss wi cA cB wss cA cB wss cB cA wss wa wi cA cB wss cB cA wss
    wn wa wn cA cB wss cA cB wss cB cA wss wa wn wa wn cA cB wss cB cA wss
    anclb cA cB wss cB cA wss iman cA cB wss cA cB wss cB cA wss wa iman
    3bitr3i con4bii 3bitr4i $.
    $( [7-Feb-1996] $)

  $( Equality theorem for proper subclass. $)
  psseq1 $p |- ( A = B -> ( A C. C <-> B C. C ) ) $=
    cA cB wceq cA cC wss cA cC wne wa cB cC wss cB cC wne wa cA cC wpss cB cC
    wpss cA cB wceq cA cC wss cB cC wss cA cC wne cB cC wne cA cB cC sseq1 cA
    cB cC neeq1 anbi12d cA cC df-pss cB cC df-pss 3bitr4g $.
    $( [7-Feb-1996] $)

  $( Equality theorem for proper subclass. $)
  psseq2 $p |- ( A = B -> ( C C. A <-> C C. B ) ) $=
    cA cB wceq cC cA wss cC cA wne wa cC cB wss cC cB wne wa cC cA wpss cC cB
    wpss cA cB wceq cC cA wss cC cB wss cC cA wne cC cB wne cA cB cC sseq2 cA
    cB cC neeq2 anbi12d cC cA df-pss cC cB df-pss 3bitr4g $.
    $( [7-Feb-1996] $)

  ${
    psseq1i.1 $e |- A = B $.
    $( An equality inference for the proper subclass relationship. $)
    psseq1i $p |- ( A C. C <-> B C. C ) $=
      cA cB wceq cA cC wpss cB cC wpss wb psseq1i.1 cA cB cC psseq1 ax-mp $.
      $( [13-Jun-2004] $) $( [9-Jun-2004] $)

    $( An equality inference for the proper subclass relationship. $)
    psseq2i $p |- ( C C. A <-> C C. B ) $=
      cA cB wceq cC cA wpss cC cB wpss wb psseq1i.1 cA cB cC psseq2 ax-mp $.
      $( [11-Jun-2004] $) $( [9-Jun-2004] $)

    ${
      psseq12i.2 $e |- C = D $.
      $( An equality inference for the proper subclass relationship. $)
      psseq12i $p |- ( A C. C <-> B C. D ) $=
        cA cC wpss cB cC wpss cB cD wpss cA cB cC psseq1i.1 psseq1i cC cD cB
        psseq12i.2 psseq2i bitri $.
        $( [15-Jun-2004] $) $( [9-Jun-2004] $)
    $}
  $}

  ${
    psseq1d.1 $e |- ( ph -> A = B ) $.
    $( An equality deduction for the proper subclass relationship. $)
    psseq1d $p |- ( ph -> ( A C. C <-> B C. C ) ) $=
      wph cA cB wceq cA cC wpss cB cC wpss wb psseq1d.1 cA cB cC psseq1 syl $.
      $( [15-Jun-2004] $) $( [9-Jun-2004] $)

    $( An equality deduction for the proper subclass relationship. $)
    psseq2d $p |- ( ph -> ( C C. A <-> C C. B ) ) $=
      wph cA cB wceq cC cA wpss cC cB wpss wb psseq1d.1 cA cB cC psseq2 syl $.
      $( [11-Jun-2004] $) $( [9-Jun-2004] $)

    ${
      psseq12d.2 $e |- ( ph -> C = D ) $.
      $( An equality deduction for the proper subclass relationship. $)
      psseq12d $p |- ( ph -> ( A C. C <-> B C. D ) ) $=
        wph cA cC wpss cB cC wpss cB cD wpss wph cA cB cC psseq1d.1 psseq1d wph
        cC cD cB psseq12d.2 psseq2d bitrd $.
        $( [15-Jun-2004] $) $( [9-Jun-2004] $)
    $}
  $}

  $( A proper subclass is a subclass.  Theorem 10 of [Suppes] p. 23. $)
  pssss $p |- ( A C. B -> A C_ B ) $=
    cA cB wpss cA cB wss cA cB wne cA cB df-pss pm3.26bi $.
    $( [7-Feb-1996] $)

  ${
    pssssd.1 $e |- ( ph -> A C. B ) $.
    $( Deduce subclass from proper subclass. $)
    pssssd $p |- ( ph -> A C_ B ) $=
      wph cA cB wpss cA cB wss pssssd.1 cA cB pssss syl $.
      $( [29-Feb-1996] $)
  $}

  $( Subclass in terms of proper subclass. $)
  sspss $p |- ( A C_ B <-> ( A C. B \/ A = B ) ) $=
    cA cB wss cA cB wpss cA cB wceq wo cA cB wss cA cB wpss cA cB wceq cA cB
    wss cA cB wceq cA cB wpss cA cB wss cA cB wceq wn cA cB wpss cA cB wpss cA
    cB wss cA cB wceq wn wa cA cB dfpss2 biimpri ex con1d orrd cA cB wpss cA cB
    wss cA cB wceq cA cB pssss cA cB eqimss jaoi impbii $.
    $( [25-Feb-1996] $)

  $( Proper subclass is irreflexive.  Theorem 7 of [Suppes] p. 23. $)
  pssirr $p |- -. A C. A $=
    cA cA wpss cA cA wss cA cA wss wn wa cA cA wss pm3.24 cA cA dfpss3 mtbir $.
    $( [7-Feb-1996] $)

  $( Proper subclass has no 2-cycle loops.  Compare Theorem 8 of [Suppes]
     p. 23. $)
  pssn2lp $p |- -. ( A C. B /\ B C. A ) $=
    cA cB wpss cB cA wpss wa cA cB wss cB cA wss wa cA cB wss cB cA wss wa wn
    wa cA cB wss cB cA wss wa pm3.24 cA cB wpss cB cA wpss wa cA cB wss cB cA
    wss wa cA cB wss wn cB cA wss wn wa wa cA cB wss cB cA wss wa cA cB wss cB
    cA wss wa wn wa cA cB wpss cB cA wpss wa cA cB wss cB cA wss wn wa cB cA
    wss cA cB wss wn wa wa cA cB wss cB cA wss wa cA cB wss wn cB cA wss wn wa
    wa cA cB wpss cA cB wss cB cA wss wn wa cB cA wpss cB cA wss cA cB wss wn
    wa cA cB dfpss3 cB cA dfpss3 anbi12i cA cB wss cB cA wss wn cB cA wss cA cB
    wss wn an42 bitri cA cB wss wn cB cA wss wn wa cA cB wss cB cA wss wa wn cA
    cB wss cB cA wss wa cA cB wss wn cB cA wss wn wa cA cB wss wn cB cA wss wn
    wo cA cB wss cB cA wss wa wn cA cB wss wn cA cB wss wn cB cA wss wn wo cB
    cA wss wn cA cB wss wn cB cA wss wn orc adantr cA cB wss cB cA wss ianor
    sylibr anim2i sylbi mto $.
    $( [7-Feb-1996] $)

  $( Two ways of stating trichotomy with respect to inclusion. $)
  sspsstri $p |- ( ( A C_ B \/ B C_ A ) <-> ( A C. B \/ A = B \/ B C. A ) ) $=
    cA cB wss cB cA wss wo cA cB wpss cA cB wceq wo cB cA wpss cA cB wceq wo wo
    cA cB wpss cB cA wpss wo cA cB wceq wo cA cB wpss cA cB wceq cB cA wpss w3o
    cA cB wss cA cB wpss cA cB wceq wo cB cA wss cB cA wpss cA cB wceq wo cA cB
    sspss cB cA wss cB cA wpss cB cA wceq wo cB cA wpss cA cB wceq wo cB cA
    sspss cB cA wceq cA cB wceq cB cA wpss cB cA eqcom orbi2i bitri orbi12i cA
    cB wpss cB cA wpss cA cB wceq orordir cA cB wpss cB cA wpss wo cA cB wceq
    wo cA cB wpss cA cB wceq wo cB cA wpss wo cA cB wpss cA cB wceq cB cA wpss
    w3o cA cB wpss cB cA wpss cA cB wceq or23 cA cB wpss cA cB wceq cB cA wpss
    df-3or bitr4i 3bitr2i $.
    $( [13-Aug-2004] $) $( [12-Aug-2004] $)

  $( Partial trichotomy law for subclasses. $)
  ssnpss $p |- ( A C_ B -> -. B C. A ) $=
    cA cB wss cA cB wpss cA cB wceq wo cB cA wpss wn cA cB sspss cA cB wpss cB
    cA wpss wn cA cB wceq cA cB wpss cB cA wpss wn wi cA cB wpss cB cA wpss wa
    wn cA cB pssn2lp cA cB wpss cB cA wpss imnan mpbir cA cB wceq cA cA wpss cB
    cA wpss cA pssirr cA cB cA psseq1 mtbii jaoi sylbi $.
    $( [16-May-1996] $)

  $( Transitive law for proper subclass.  Theorem 9 of [Suppes] p. 23. $)
  psstr $p |- ( ( A C. B /\ B C. C ) -> A C. C ) $=
    cA cC wpss cA cC wss cA cC wceq wn cA cB wpss cB cC wpss wa cA cC dfpss2 cA
    cB wpss cB cC wpss cA cB cC cA cB pssss cB cC pssss sylan9ss cA cC wceq cA
    cB wpss cB cC wpss wa cA cC wceq cA cB wpss cB cC wpss wa cC cB wpss cB cC
    wpss wa cC cB pssn2lp cA cC wceq cA cB wpss cC cB wpss cB cC wpss cA cC cB
    psseq1 anbi1d mtbiri con2i sylanbrc $.
    $( [7-Feb-1996] $)

  $( Transitive law for subclass and proper subclass. $)
  sspsstr $p |- ( ( A C_ B /\ B C. C ) -> A C. C ) $=
    cA cB wpss cA cB wceq wo cB cC wpss cA cC wpss cA cB wss cA cB wpss cA cB
    wceq wo cB cC wpss cA cC wpss cA cB wpss cB cC wpss cA cC wpss wi cA cB
    wceq cA cB wpss cB cC wpss cA cC wpss cA cB cC psstr ex cA cB wceq cA cC
    wpss cB cC wpss cA cB cC psseq1 biimprd jaoi imp cA cB sspss sylanb $.
    $( [3-Apr-1996] $)


  $( Transitive law for subclass and proper subclass. $)
  psssstr $p |- ( ( A C. B /\ B C_ C ) -> A C. C ) $=
    cA cB wpss cB cC wpss cB cC wceq wo cA cC wpss cB cC wss cA cB wpss cB cC
    wpss cB cC wceq wo cA cC wpss cA cB wpss cB cC wpss cA cC wpss cB cC wceq
    cA cB wpss cB cC wpss cA cC wpss cA cB cC psstr ex cB cC wceq cA cB wpss cA
    cC wpss cB cC cA psseq2 biimpcd jaod imp cB cC sspss sylan2b $.
    $( [3-Apr-1996] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The difference, union, and intersection of two classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality theorem for class difference. $)
    difeq1 $p |- ( A = B -> ( A \ C ) = ( B \ C ) ) $=
      cA cB wceq vx cv cA wcel vx cv cC wcel wn wa vx cab vx cv cB wcel vx cv
      cC wcel wn wa vx cab cA cC cdif cB cC cdif cA cB wceq vx cv cA wcel vx cv
      cC wcel wn wa vx cv cB wcel vx cv cC wcel wn wa vx cA cB wceq vx cv cA
      wcel vx cv cB wcel vx cv cC wcel wn cA cB vx cv eleq2 anbi1d abbidv vx cA
      cC df-dif vx cB cC df-dif 3eqtr4g $.
      $( [10-Feb-1997] $)

    $( Equality theorem for class difference. $)
    difeq2 $p |- ( A = B -> ( C \ A ) = ( C \ B ) ) $=
      cA cB wceq vx cv cC wcel vx cv cA wcel wn wa vx cab vx cv cC wcel vx cv
      cB wcel wn wa vx cab cC cA cdif cC cB cdif cA cB wceq vx cv cC wcel vx cv
      cA wcel wn wa vx cv cC wcel vx cv cB wcel wn wa vx cA cB wceq vx cv cA
      wcel wn vx cv cB wcel wn vx cv cC wcel cA cB wceq vx cv cA wcel vx cv cB
      wcel cA cB vx cv eleq2 notbid anbi2d abbidv vx cC cA df-dif vx cC cB
      df-dif 3eqtr4g $.
      $( [10-Feb-1997] $)
  $}

  ${
    difeq1i.1 $e |- A = B $.
    $( Inference adding difference to the right in a class equality. $)
    difeq1i $p |- ( A \ C ) = ( B \ C ) $=
      cA cB wceq cA cC cdif cB cC cdif wceq difeq1i.1 cA cB cC difeq1 ax-mp $.
      $( [15-Nov-2002] $)

    $( Inference adding difference to the left in a class equality. $)
    difeq2i $p |- ( C \ A ) = ( C \ B ) $=
      cA cB wceq cC cA cdif cC cB cdif wceq difeq1i.1 cA cB cC difeq2 ax-mp $.
      $( [15-Nov-2002] $)

    ${
      difeq12i.2 $e |- C = D $.
      $( Equality inference for class difference. $)
      difeq12i $p |- ( A \ C ) = ( B \ D ) $=
        cA cC cdif cB cC cdif cB cD cdif cA cB cC difeq1i.1 difeq1i cC cD cB
        difeq12i.2 difeq2i eqtri $.
        $( [11-Sep-2004] $) $( [29-Aug-2004] $)
    $}
  $}

  ${
    difeq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction adding difference to the right in a class equality. $)
    difeq1d $p |- ( ph -> ( A \ C ) = ( B \ C ) ) $=
      wph cA cB wceq cA cC cdif cB cC cdif wceq difeq1d.1 cA cB cC difeq1 syl
      $.
      $( [15-Nov-2002] $)

    $( Deduction adding difference to the left in a class equality. $)
    difeq2d $p |- ( ph -> ( C \ A ) = ( C \ B ) ) $=
      wph cA cB wceq cC cA cdif cC cB cdif wceq difeq1d.1 cA cB cC difeq2 syl
      $.
      $( [15-Nov-2002] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    difeqri.1 $e |- ( ( x e. A /\ -. x e. B ) <-> x e. C ) $.
    $( Inference from membership to difference. $)
    difeqri $p |- ( A \ B ) = C $=
      cA cB cdif vx cv cA wcel vx cv cB wcel wn wa vx cab cC vx cA cB df-dif vx
      cv cA wcel vx cv cB wcel wn wa vx cC vx cv cA wcel vx cv cB wcel wn wa vx
      cv cC wcel difeqri.1 bicomi abbi2i eqtr4i $.
      $( [17-May-1998] $)
  $}

  ${
    hbdif.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbdif.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for class difference.  (Distinct
       variable restrictions were removed by David Abernethy, 2-Apr-2010.) $)
    hbdif $p |- ( y e. ( A \ B ) -> A. x y e. ( A \ B ) ) $=
      vy cv cA wcel vy cv cB wcel wn wa vy cv cA wcel vy cv cB wcel wn wa vx
      wal vy cv cA cB cdif wcel vy cv cA cB cdif wcel vx wal vy cv cA wcel vy
      cv cB wcel wn vx hbdif.1 vy cv cB wcel vx hbdif.2 hbn hban vy cv cA cB
      eldif vy cv cA cB cdif wcel vy cv cA wcel vy cv cB wcel wn wa vx vy cv cA
      cB eldif albii 3imtr4i $.
      $( [15-Apr-2010] $) $( [3-Dec-2003] $)
  $}

  $( Implication of membership in a class difference. $)
  eldifi $p |- ( A e. ( B \ C ) -> A e. B ) $=
    cA cB cC cdif wcel cA cB wcel cA cC wcel wn cA cB cC eldif pm3.26bi $.
    $( [29-Apr-1994] $)

  $( Implication of membership in a class difference. $)
  eldifn $p |- ( A e. ( B \ C ) -> -. A e. C ) $=
    cA cB cC cdif wcel cA cB wcel cA cC wcel wn cA cB cC eldif pm3.27bi $.
    $( [3-May-1994] $)

  $( A set does not belong to a class excluding it. $)
  elndif $p |- ( A e. B -> -. A e. ( C \ B ) ) $=
    cA cC cB cdif wcel cA cB wcel cA cC cB eldifn con2i $.
    $( [27-Jun-1994] $)

  $( Implication of membership in a class difference. $)
  neldif $p |- ( ( A e. B /\ -. A e. ( B \ C ) ) -> A e. C ) $=
    cA cB wcel cA cB cC cdif wcel wn cA cC wcel cA cB wcel cA cC wcel cA cB cC
    cdif wcel cA cB wcel cA cC wcel wn cA cB cC cdif wcel cA cB cC cdif wcel cA
    cB wcel cA cC wcel wn wa cA cB cC eldif biimpri ex con1d imp $.
    $( [28-Jun-1994] $)

  ${
    $d x A $.  $d x B $.
    $( Double class difference.  Exercise 11 of [TakeutiZaring] p. 22. $)
    difdif $p |- ( A \ ( B \ A ) ) = A $=
      vx cA cB cA cdif cA vx cv cA wcel vx cv cB cA cdif wcel wn wa vx cv cA
      wcel vx cv cB wcel vx cv cA wcel wi wa vx cv cA wcel vx cv cB cA cdif
      wcel wn vx cv cB wcel vx cv cA wcel wi vx cv cA wcel vx cv cB cA cdif
      wcel wn vx cv cB wcel vx cv cA wcel wn wa wn vx cv cB wcel vx cv cA wcel
      wi vx cv cB cA cdif wcel vx cv cB wcel vx cv cA wcel wn wa vx cv cB cA
      eldif notbii vx cv cB wcel vx cv cA wcel iman bitr4i anbi2i vx cv cA wcel
      vx cv cB wcel pm4.45im bitr4i difeqri $.
      $( [17-May-1998] $)

    $( Subclass relationship for class difference.  Exercise 14 of
       [TakeutiZaring] p. 22. $)
    difss $p |- ( A \ B ) C_ A $=
      vx cA cB cdif cA vx cv cA cB eldifi ssriv $.
      $( [29-Apr-1994] $)
  $}

  $( Preservation of a subclass relationship by class difference. $)
  ssdifss $p |- ( A C_ B -> ( A \ C ) C_ B ) $=
    cA cC cdif cA wss cA cB wss cA cC cdif cB wss cA cC difss cA cC cdif cA cB
    sstr mpan $.
    $( [26-Feb-2007] $) $( [15-Feb-2007] $)

  ${
    $d x A $.
    $( Double complement under universal class.  Exercise 4.10(s) of
       [Mendelson] p. 231. $)
    ddif $p |- ( _V \ ( _V \ A ) ) = A $=
      vx cvv cvv cA cdif cA vx cv cA wcel vx cv cvv cA cdif wcel wn vx cv cvv
      wcel vx cv cvv cA cdif wcel wn wa vx cv cvv cA cdif wcel vx cv cA wcel vx
      cv cvv cA cdif wcel vx cv cvv wcel vx cv cA wcel wn vx cv cvv cA eldif vx
      visset mpbiran con2bii vx cv cvv wcel vx cv cvv cA cdif wcel wn vx visset
      biantrur bitr2i difeqri $.
      $( [8-Jan-2002] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Contraposition law for subsets. $)
    ssconb $p |- ( ( A C_ C /\ B C_ C ) ->
                  ( A C_ ( C \ B ) <-> B C_ ( C \ A ) ) ) $=
      cA cC wss cB cC wss wa vx cv cA wcel vx cv cC cB cdif wcel wi vx wal vx
      cv cB wcel vx cv cC cA cdif wcel wi vx wal cA cC cB cdif wss cB cC cA
      cdif wss cA cC wss cB cC wss wa vx cv cA wcel vx cv cC cB cdif wcel wi vx
      cv cB wcel vx cv cC cA cdif wcel wi vx cA cC wss cB cC wss wa vx cv cA
      wcel vx cv cC wcel vx cv cB wcel wn wa wi vx cv cB wcel vx cv cC wcel vx
      cv cA wcel wn wa wi vx cv cA wcel vx cv cC cB cdif wcel wi vx cv cB wcel
      vx cv cC cA cdif wcel wi cA cC wss cB cC wss wa vx cv cA wcel vx cv cC
      wcel wi vx cv cA wcel vx cv cB wcel wn wi wa vx cv cB wcel vx cv cC wcel
      wi vx cv cB wcel vx cv cA wcel wn wi wa vx cv cA wcel vx cv cC wcel vx cv
      cB wcel wn wa wi vx cv cB wcel vx cv cC wcel vx cv cA wcel wn wa wi cA cC
      wss cB cC wss wa vx cv cA wcel vx cv cC wcel wi vx cv cB wcel vx cv cC
      wcel wi vx cv cA wcel vx cv cB wcel wn wi vx cv cB wcel vx cv cA wcel wn
      wi vx cv cA wcel vx cv cC wcel wi vx cv cB wcel vx cv cC wcel wi vx cv cA
      wcel vx cv cC wcel wi vx cv cB wcel vx cv cC wcel wi wb cA cC wss cB cC
      wss vx cv cA wcel vx cv cC wcel wi vx cv cB wcel vx cv cC wcel wi pm5.1
      cA cC vx cv ssel cB cC vx cv ssel syl2an vx cv cA wcel vx cv cB wcel wn
      wi vx cv cB wcel vx cv cA wcel wn wi wb cA cC wss cB cC wss wa vx cv cA
      wcel vx cv cB wcel con2b a1i anbi12d vx cv cA wcel vx cv cC wcel vx cv cB
      wcel wn jcab vx cv cB wcel vx cv cC wcel vx cv cA wcel wn jcab 3bitr4g vx
      cv cC cB cdif wcel vx cv cC wcel vx cv cB wcel wn wa vx cv cA wcel vx cv
      cC cB eldif imbi2i vx cv cC cA cdif wcel vx cv cC wcel vx cv cA wcel wn
      wa vx cv cB wcel vx cv cC cA eldif imbi2i 3bitr4g albidv vx cA cC cB cdif
      dfss2 vx cB cC cA cdif dfss2 3bitr4g $.
      $( [22-Mar-1998] $)

    $( Contraposition law for subsets.  Exercise 15 of [TakeutiZaring]
       p. 22. $)
    sscon $p |- ( A C_ B -> ( C \ B ) C_ ( C \ A ) ) $=
      cA cB wss vx cC cB cdif cC cA cdif cA cB wss vx cv cC wcel vx cv cB wcel
      wn wa vx cv cC wcel vx cv cA wcel wn wa vx cv cC cB cdif wcel vx cv cC cA
      cdif wcel cA cB wss vx cv cB wcel wn vx cv cA wcel wn vx cv cC wcel cA cB
      wss vx cv cA wcel vx cv cB wcel cA cB vx cv ssel con3d anim2d vx cv cC cB
      eldif vx cv cC cA eldif 3imtr4g ssrdv $.
      $( [22-Mar-1998] $)

    $( Difference law for subsets. $)
    ssdif $p |- ( A C_ B -> ( A \ C ) C_ ( B \ C ) ) $=
      cA cB wss vx cA cC cdif cB cC cdif cA cB wss vx cv cA wcel vx cv cC wcel
      wn wa vx cv cB wcel vx cv cC wcel wn wa vx cv cA cC cdif wcel vx cv cB cC
      cdif wcel cA cB wss vx cv cA wcel vx cv cB wcel vx cv cC wcel wn cA cB vx
      cv ssel anim1d vx cv cA cC eldif vx cv cB cC eldif 3imtr4g ssrdv $.
      $( [28-May-1998] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Expansion of membership in class union.  Theorem 12 of [Suppes]
       p. 25. $)
    elun $p |- ( A e. ( B u. C ) <-> ( A e. B \/ A e. C ) ) $=
      cA cB cC cun wcel cA cvv wcel cA cB wcel cA cC wcel wo cA cB cC cun
      elisset cA cB wcel cA cvv wcel cA cC wcel cA cB elisset cA cC elisset
      jaoi vx cv cB wcel vx cv cC wcel wo cA cB wcel cA cC wcel wo vx cA cB cC
      cun cvv vx cv cA wceq vx cv cB wcel cA cB wcel vx cv cC wcel cA cC wcel
      vx cv cA cB eleq1 vx cv cA cC eleq1 orbi12d vx cB cC df-un elab2g
      pm5.21nii $.
      $( [7-Aug-1994] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    uneqri.1 $e |- ( ( x e. A \/ x e. B ) <-> x e. C ) $.
    $( Inference from membership to union. $)
    uneqri $p |- ( A u. B ) = C $=
      vx cA cB cun cC vx cv cA cB cun wcel vx cv cA wcel vx cv cB wcel wo vx cv
      cC wcel vx cv cA cB elun uneqri.1 bitri eqriv $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.
    $( Idempotent law for union of classes.  Theorem 23 of [Suppes] p. 27. $)
    unidm $p |- ( A u. A ) = A $=
      vx cA cA cA vx cv cA wcel oridm uneqri $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Commutative law for union of classes.  Exercise 6 of [TakeutiZaring]
       p. 17. $)
    uncom $p |- ( A u. B ) = ( B u. A ) $=
      vx cA cB cun cB cA cun vx cv cA wcel vx cv cB wcel wo vx cv cB wcel vx cv
      cA wcel wo vx cv cA cB cun wcel vx cv cB cA cun wcel vx cv cA wcel vx cv
      cB wcel orcom vx cv cA cB elun vx cv cB cA elun 3bitr4i eqriv $.
      $( [25-Jun-1998] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality theorem for union of two classes. $)
    uneq1 $p |- ( A = B -> ( A u. C ) = ( B u. C ) ) $=
      cA cB wceq vx cA cC cun cB cC cun cA cB wceq vx cv cA wcel vx cv cC wcel
      wo vx cv cB wcel vx cv cC wcel wo vx cv cA cC cun wcel vx cv cB cC cun
      wcel cA cB wceq vx cv cA wcel vx cv cB wcel vx cv cC wcel cA cB vx cv
      eleq2 orbi1d vx cv cA cC elun vx cv cB cC elun 3bitr4g eqrdv $.
      $( [5-Aug-1993] $)
  $}

  $( Equality theorem for the union of two classes. $)
  uneq2 $p |- ( A = B -> ( C u. A ) = ( C u. B ) ) $=
    cA cB wceq cA cC cun cB cC cun cC cA cun cC cB cun cA cB cC uneq1 cC cA
    uncom cC cB uncom 3eqtr4g $.
    $( [5-Aug-1993] $)

  $( Equality theorem for union of two classes. $)
  uneq12 $p |- ( ( A = B /\ C = D ) -> ( A u. C ) = ( B u. D ) ) $=
    cA cB wceq cC cD wceq cA cC cun cB cC cun cB cD cun cA cB cC uneq1 cC cD cB
    uneq2 sylan9eq $.
    $( [29-Mar-1998] $)

  ${
    uneq1i.1 $e |- A = B $.
    $( Inference adding union to the right in a class equality. $)
    uneq1i $p |- ( A u. C ) = ( B u. C ) $=
      cA cB wceq cA cC cun cB cC cun wceq uneq1i.1 cA cB cC uneq1 ax-mp $.
      $( [30-Aug-1993] $)

    $( Inference adding union to the left in a class equality. $)
    uneq2i $p |- ( C u. A ) = ( C u. B ) $=
      cA cB wceq cC cA cun cC cB cun wceq uneq1i.1 cA cB cC uneq2 ax-mp $.
      $( [30-Aug-1993] $)

    ${
      uneq12i.2 $e |- C = D $.
      $( Equality inference for union of two classes.  (The proof was
         shortened by Eric Schmidt, 26-Jan-2007.) $)
      uneq12i $p |- ( A u. C ) = ( B u. D ) $=
        cA cB wceq cC cD wceq cA cC cun cB cD cun wceq uneq1i.1 uneq12i.2 cA cB
        cC cD uneq12 mp2an $.
        $( [27-Jan-2007] $) $( [12-Aug-2004] $)
    $}
  $}

  ${
    uneq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction adding union to the right in a class equality. $)
    uneq1d $p |- ( ph -> ( A u. C ) = ( B u. C ) ) $=
      wph cA cB wceq cA cC cun cB cC cun wceq uneq1d.1 cA cB cC uneq1 syl $.
      $( [29-Mar-1998] $)

    $( Deduction adding union to the left in a class equality. $)
    uneq2d $p |- ( ph -> ( C u. A ) = ( C u. B ) ) $=
      wph cA cB wceq cC cA cun cC cB cun wceq uneq1d.1 cA cB cC uneq2 syl $.
      $( [29-Mar-1998] $)

    ${
      uneq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for union of two classes. $)
      uneq12d $p |- ( ph -> ( A u. C ) = ( B u. D ) ) $=
        wph cA cC cun cB cC cun cB cD cun wph cA cB cC uneq1d.1 uneq1d wph cC
        cD cB uneq12d.2 uneq2d eqtrd $.
        $( [30-Sep-2004] $) $( [29-Sep-2004] $)
    $}
  $}

  ${
    hbun.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbun.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for the union of classes. $)
    hbun $p |- ( y e. ( A u. B ) -> A. x y e. ( A u. B ) ) $=
      vy cv cA wcel vy cv cB wcel wo vy cv cA wcel vy cv cB wcel wo vx wal vy
      cv cA cB cun wcel vy cv cA cB cun wcel vx wal vy cv cA wcel vy cv cB wcel
      vx hbun.1 hbun.2 hbor vy cv cA cB elun vy cv cA cB cun wcel vy cv cA wcel
      vy cv cB wcel wo vx vy cv cA cB elun albii 3imtr4i $.
      $( [15-Sep-2003] $)
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Associative law for union of classes.  Exercise 8 of [TakeutiZaring]
       p. 17. $)
    unass $p |- ( ( A u. B ) u. C ) = ( A u. ( B u. C ) ) $=
      vx cA cB cun cC cA cB cC cun cun vx cv cA cB cun wcel vx cv cC wcel wo vx
      cv cA wcel vx cv cB cC cun wcel wo vx cv cA cB cC cun cun wcel vx cv cA
      wcel vx cv cB wcel wo vx cv cC wcel wo vx cv cA wcel vx cv cB wcel vx cv
      cC wcel wo wo vx cv cA cB cun wcel vx cv cC wcel wo vx cv cA wcel vx cv
      cB cC cun wcel wo vx cv cA wcel vx cv cB wcel vx cv cC wcel orass vx cv
      cA cB cun wcel vx cv cA wcel vx cv cB wcel wo vx cv cC wcel vx cv cA cB
      elun orbi1i vx cv cB cC cun wcel vx cv cB wcel vx cv cC wcel wo vx cv cA
      wcel vx cv cB cC elun orbi2i 3bitr4i vx cv cA cB cC cun elun bitr4i
      uneqri $.
      $( [3-May-1994] $)
  $}

  $( A rearrangement of union. $)
  un12 $p |- ( A u. ( B u. C ) ) = ( B u. ( A u. C ) ) $=
    cA cB cun cC cun cB cA cun cC cun cA cB cC cun cun cB cA cC cun cun cA cB
    cun cB cA cun cC cA cB uncom uneq1i cA cB cC unass cB cA cC unass 3eqtr3i
    $.
    $( [26-Aug-2004] $) $( [12-Aug-2004] $)

  $( A rearrangement of union. $)
  un23 $p |- ( ( A u. B ) u. C ) = ( ( A u. C ) u. B ) $=
    cA cB cC cun cun cA cC cB cun cun cA cB cun cC cun cA cC cun cB cun cB cC
    cun cC cB cun cA cB cC uncom uneq2i cA cB cC unass cA cC cB unass 3eqtr4i
    $.
    $( [29-Aug-2004] $) $( [12-Aug-2004] $)

  $( A rearrangement of the union of 4 classes. $)
  un4 $p |- ( ( A u. B ) u. ( C u. D ) ) =
            ( ( A u. C ) u. ( B u. D ) ) $=
    cA cB cC cD cun cun cun cA cC cB cD cun cun cun cA cB cun cC cD cun cun cA
    cC cun cB cD cun cun cB cC cD cun cun cC cB cD cun cun cA cB cC cD un12
    uneq2i cA cB cC cD cun unass cA cC cB cD cun unass 3eqtr4i $.
    $( [30-Aug-2004] $) $( [12-Aug-2004] $)

  $( Union distributes over itself. $)
  unundi $p |- ( A u. ( B u. C ) ) = ( ( A u. B ) u. ( A u. C ) ) $=
    cA cA cun cB cC cun cun cA cB cC cun cun cA cB cun cA cC cun cun cA cA cun
    cA cB cC cun cA unidm uneq1i cA cA cB cC un4 eqtr3i $.
    $( [15-Sep-2004] $) $( [17-Aug-2004] $)

  $( Union distributes over itself. $)
  unundir $p |- ( ( A u. B ) u. C ) = ( ( A u. C ) u. ( B u. C ) ) $=
    cA cB cun cC cC cun cun cA cB cun cC cun cA cC cun cB cC cun cun cC cC cun
    cC cA cB cun cC unidm uneq2i cA cB cC cC un4 eqtr3i $.
    $( [9-Sep-2004] $) $( [17-Aug-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Subclass relationship for union of classes.  Theorem 25 of [Suppes]
       p. 27. $)
    ssun1 $p |- A C_ ( A u. B ) $=
      vx cA cA cB cun vx cv cA wcel vx cv cA wcel vx cv cB wcel wo vx cv cA cB
      cun wcel vx cv cA wcel vx cv cB wcel orc vx cv cA cB elun sylibr ssriv $.
      $( [5-Aug-1993] $)
  $}

  $( Subclass relationship for union of classes. $)
  ssun2 $p |- A C_ ( B u. A ) $=
    cA cA cB cun cB cA cun cA cB ssun1 cA cB uncom sseqtri $.
    $( [30-Aug-1993] $)

  $( Subclass law for union of classes. $)
  ssun3 $p |- ( A C_ B -> A C_ ( B u. C ) ) $=
    cA cB wss cB cB cC cun wss cA cB cC cun wss cB cC ssun1 cA cB cB cC cun
    sstr2 mpi $.
    $( [5-Aug-1993] $)

  $( Subclass law for union of classes. $)
  ssun4 $p |- ( A C_ B -> A C_ ( C u. B ) ) $=
    cA cB wss cB cC cB cun wss cA cC cB cun wss cB cC ssun2 cA cB cC cB cun
    sstr2 mpi $.
    $( [14-Aug-1994] $)

  $( Membership law for union of classes. $)
  elun1 $p |- ( A e. B -> A e. ( B u. C ) ) $=
    cB cB cC cun cA cB cC ssun1 sseli $.
    $( [5-Aug-1993] $)

  $( Membership law for union of classes. $)
  elun2 $p |- ( A e. B -> A e. ( C u. B ) ) $=
    cB cC cB cun cA cB cC ssun2 sseli $.
    $( [30-Aug-1993] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Subclass law for union of classes. $)
    unss1 $p |- ( A C_ B -> ( A u. C ) C_ ( B u. C ) ) $=
      vx cv cA wcel vx cv cB wcel wi vx wal vx cv cA cC cun wcel vx cv cB cC
      cun wcel wi vx wal cA cB wss cA cC cun cB cC cun wss vx cv cA wcel vx cv
      cB wcel wi vx cv cA cC cun wcel vx cv cB cC cun wcel wi vx vx cv cA wcel
      vx cv cB wcel wi vx cv cA wcel vx cv cC wcel wo vx cv cB wcel vx cv cC
      wcel wo vx cv cA cC cun wcel vx cv cB cC cun wcel vx cv cC wcel vx cv cA
      wcel vx cv cB wcel pm2.38 vx cv cA cC elun vx cv cB cC elun 3imtr4g
      19.20i vx cA cB dfss2 vx cA cC cun cB cC cun dfss2 3imtr4i $.
      $( [14-Oct-1999] $)

    $( A relationship between subclass and union.  Theorem 26 of [Suppes]
       p. 27. $)
    ssequn1 $p |- ( A C_ B <-> ( A u. B ) = B ) $=
      cB cA cB cun wceq cB vx cv cA wcel vx cv cB wcel wo vx cab wceq cA cB cun
      cB wceq cA cB wss cA cB cun vx cv cA wcel vx cv cB wcel wo vx cab cB vx
      cA cB df-un eqeq2i cA cB cun cB eqcom vx cv cA wcel vx cv cB wcel wi vx
      wal vx cv cB wcel vx cv cA wcel vx cv cB wcel wo wb vx wal cA cB wss cB
      vx cv cA wcel vx cv cB wcel wo vx cab wceq vx cv cA wcel vx cv cB wcel wi
      vx cv cB wcel vx cv cA wcel vx cv cB wcel wo wb vx vx cv cA wcel vx cv cB
      wcel pm4.72 albii vx cA cB dfss2 vx cv cA wcel vx cv cB wcel wo vx cB
      abeq2 3bitr4i 3bitr4ri $.
      $( [29-Aug-2004] $) $( [30-Aug-1993] $)
  $}

  $( Subclass law for union of classes.  Exercise 7 of [TakeutiZaring]
     p. 18. $)
  unss2 $p |- ( A C_ B -> ( C u. A ) C_ ( C u. B ) ) $=
    cA cB wss cA cC cun cB cC cun cC cA cun cC cB cun cA cB cC unss1 cC cA
    uncom cC cB uncom 3sstr4g $.
    $( [14-Oct-1999] $)

  $( Subclass law for union of classes. $)
  unss12 $p |- ( ( A C_ B /\ C C_ D ) -> ( A u. C ) C_ ( B u. D ) ) $=
    cA cB wss cC cD wss cA cC cun cB cC cun cB cD cun cA cB cC unss1 cC cD cB
    unss2 sylan9ss $.
    $( [7-Jun-2004] $) $( [2-Jun-2004] $)

  $( A relationship between subclass and union. $)
  ssequn2 $p |- ( A C_ B <-> ( B u. A ) = B ) $=
    cA cB wss cA cB cun cB wceq cB cA cun cB wceq cA cB ssequn1 cA cB cun cB cA
    cun cB cA cB uncom eqeq1i bitri $.
    $( [23-Sep-2004] $) $( [13-Jun-1994] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( The union of two subclasses is a subclass.  Theorem 27 of [Suppes] p. 27
       and its converse. $)
    unss $p |- ( ( A C_ C /\ B C_ C ) <-> ( A u. B ) C_ C ) $=
      vx cv cA cB cun wcel vx cv cC wcel wi vx wal vx cv cA wcel vx cv cC wcel
      wi vx cv cB wcel vx cv cC wcel wi wa vx wal cA cB cun cC wss cA cC wss cB
      cC wss wa vx cv cA cB cun wcel vx cv cC wcel wi vx cv cA wcel vx cv cC
      wcel wi vx cv cB wcel vx cv cC wcel wi wa vx vx cv cA cB cun wcel vx cv
      cC wcel wi vx cv cA wcel vx cv cB wcel wo vx cv cC wcel wi vx cv cA wcel
      vx cv cC wcel wi vx cv cB wcel vx cv cC wcel wi wa vx cv cA cB cun wcel
      vx cv cA wcel vx cv cB wcel wo vx cv cC wcel vx cv cA cB elun imbi1i vx
      cv cA wcel vx cv cC wcel vx cv cB wcel jaob bitri albii vx cA cB cun cC
      dfss2 cA cC wss cB cC wss wa vx cv cA wcel vx cv cC wcel wi vx wal vx cv
      cB wcel vx cv cC wcel wi vx wal wa vx cv cA wcel vx cv cC wcel wi vx cv
      cB wcel vx cv cC wcel wi wa vx wal cA cC wss vx cv cA wcel vx cv cC wcel
      wi vx wal cB cC wss vx cv cB wcel vx cv cC wcel wi vx wal vx cA cC dfss2
      vx cB cC dfss2 anbi12i vx cv cA wcel vx cv cC wcel wi vx cv cB wcel vx cv
      cC wcel wi vx 19.26 bitr4i 3bitr4ri $.
      $( [15-Jun-2004] $) $( [11-Jun-2004] $)
  $}

  ${
    unssi.1 $e |- A C_ C $.
    unssi.2 $e |- B C_ C $.
    $( An inference that the union of two subclasses is a subclass.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    unssi $p |- ( A u. B ) C_ C $=
      cA cC wss cB cC wss wa cA cB cun cC wss cA cC wss cB cC wss unssi.1
      unssi.2 pm3.2i cA cB cC unss mpbi $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  $( A condition that implies inclusion in the union of two classes. $)
  ssun $p |- ( ( A C_ B \/ A C_ C ) -> A C_ ( B u. C ) ) $=
    cA cB wss cA cB cC cun wss cA cC wss cA cB cC ssun3 cA cC cB ssun4 jaoi $.
    $( [23-Nov-2003] $) $( [23-Nov-2003] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Expansion of membership in an intersection of two classes.  Theorem 12
       of [Suppes] p. 25. $)
    elin $p |- ( A e. ( B i^i C ) <-> ( A e. B /\ A e. C ) ) $=
      cA cB cC cin wcel cA cvv wcel cA cB wcel cA cC wcel wa cA cB cC cin
      elisset cA cC wcel cA cvv wcel cA cB wcel cA cC elisset adantl vx cv cB
      wcel vx cv cC wcel wa cA cB wcel cA cC wcel wa vx cA cB cC cin cvv vx cv
      cA wceq vx cv cB wcel cA cB wcel vx cv cC wcel cA cC wcel vx cv cA cB
      eleq1 vx cv cA cC eleq1 anbi12d vx cB cC df-in elab2g pm5.21nii $.
      $( [29-Apr-1994] $)
  $}

  ${
    $d A x $.  $d B x $.
    $( Commutative law for intersection of classes.  Exercise 7 of
       [TakeutiZaring] p. 17. $)
    incom $p |- ( A i^i B ) = ( B i^i A ) $=
      vx cA cB cin cB cA cin vx cv cA wcel vx cv cB wcel wa vx cv cB wcel vx cv
      cA wcel wa vx cv cA cB cin wcel vx cv cB cA cin wcel vx cv cA wcel vx cv
      cB wcel ancom vx cv cA cB elin vx cv cB cA elin 3bitr4i eqriv $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    ineqri.1 $e |- ( ( x e. A /\ x e. B ) <-> x e. C ) $.
    $( Inference from membership to intersection. $)
    ineqri $p |- ( A i^i B ) = C $=
      vx cA cB cin cC vx cv cA cB cin wcel vx cv cA wcel vx cv cB wcel wa vx cv
      cC wcel vx cv cA cB elin ineqri.1 bitri eqriv $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality theorem for intersection of two classes. $)
    ineq1 $p |- ( A = B -> ( A i^i C ) = ( B i^i C ) ) $=
      cA cB wceq vx cA cC cin cB cC cin cA cB wceq vx cv cA wcel vx cv cC wcel
      wa vx cv cB wcel vx cv cC wcel wa vx cv cA cC cin wcel vx cv cB cC cin
      wcel cA cB wceq vx cv cA wcel vx cv cB wcel vx cv cC wcel cA cB vx cv
      eleq2 anbi1d vx cv cA cC elin vx cv cB cC elin 3bitr4g eqrdv $.
      $( [14-Dec-1993] $)
  $}

  $( Equality theorem for intersection of two classes. $)
  ineq2 $p |- ( A = B -> ( C i^i A ) = ( C i^i B ) ) $=
    cA cB wceq cA cC cin cB cC cin cC cA cin cC cB cin cA cB cC ineq1 cC cA
    incom cC cB incom 3eqtr4g $.
    $( [26-Dec-1993] $)

  $( Equality theorem for intersection of two classes. $)
  ineq12 $p |- ( ( A = B /\ C = D ) -> ( A i^i C ) = ( B i^i D ) ) $=
    cA cB wceq cC cD wceq cA cC cin cB cC cin cB cD cin cA cB cC ineq1 cC cD cB
    ineq2 sylan9eq $.
    $( [8-May-1994] $)

  ${
    ineq1i.1 $e |- A = B $.
    $( Equality inference for intersection of two classes. $)
    ineq1i $p |- ( A i^i C ) = ( B i^i C ) $=
      cA cB wceq cA cC cin cB cC cin wceq ineq1i.1 cA cB cC ineq1 ax-mp $.
      $( [26-Dec-1993] $)

    $( Equality inference for intersection of two classes. $)
    ineq2i $p |- ( C i^i A ) = ( C i^i B ) $=
      cA cB wceq cC cA cin cC cB cin wceq ineq1i.1 cA cB cC ineq2 ax-mp $.
      $( [26-Dec-1993] $)

    ${
      ineq12i.2 $e |- C = D $.
      $( Equality inference for intersection of two classes.  (The proof was
         shortened by Eric Schmidt, 26-Jan-2007.) $)
      ineq12i $p |- ( A i^i C ) = ( B i^i D ) $=
        cA cB wceq cC cD wceq cA cC cin cB cD cin wceq ineq1i.1 ineq12i.2 cA cB
        cC cD ineq12 mp2an $.
        $( [27-Jan-2007] $) $( [24-Jun-2004] $)
    $}
  $}

  ${
    ineq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for intersection of two classes. $)
    ineq1d $p |- ( ph -> ( A i^i C ) = ( B i^i C ) ) $=
      wph cA cB wceq cA cC cin cB cC cin wceq ineq1d.1 cA cB cC ineq1 syl $.
      $( [10-Apr-1994] $)

    $( Equality deduction for intersection of two classes. $)
    ineq2d $p |- ( ph -> ( C i^i A ) = ( C i^i B ) ) $=
      wph cA cB wceq cC cA cin cC cB cin wceq ineq1d.1 cA cB cC ineq2 syl $.
      $( [10-Apr-1994] $)

    ${
      ineq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for intersection of two classes. $)
      ineq12d $p |- ( ph -> ( A i^i C ) = ( B i^i D ) ) $=
        wph cA cC cin cB cC cin cB cD cin wph cA cB cC ineq1d.1 ineq1d wph cC
        cD cB ineq12d.2 ineq2d eqtrd $.
        $( [25-Jun-2004] $) $( [24-Jun-2004] $)
    $}

    ${
      ineqan12d.2 $e |- ( ps -> C = D ) $.
      $( Equality deduction for intersection of two classes. $)
      ineqan12d $p |- ( ( ph /\ ps ) -> ( A i^i C ) = ( B i^i D ) ) $=
        cA cB wceq cC cD wceq cA cC cin cB cD cin wceq wph wps cA cB cC cD
        ineq12 ineq1d.1 ineqan12d.2 syl2an $.
        $( [7-Feb-2007] $) $( [7-Feb-2007] $)
    $}
  $}

  ${
    hbin.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbin.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for the intersection of classes.
       (Distinct variable restrictions were removed by David Abernethy,
       6-Apr-2010.) $)
    hbin $p |- ( y e. ( A i^i B ) -> A. x y e. ( A i^i B ) ) $=
      vy cv cA wcel vy cv cB wcel wa vy cv cA wcel vy cv cB wcel wa vx wal vy
      cv cA cB cin wcel vy cv cA cB cin wcel vx wal vy cv cA wcel vy cv cB wcel
      vx hbin.1 hbin.2 hban vy cv cA cB elin vy cv cA cB cin wcel vy cv cA wcel
      vy cv cB wcel wa vx vy cv cA cB elin albii 3imtr4i $.
      $( [15-Apr-2010] $) $( [15-Sep-2003] $)
  $}

  ${
    $d x ph $.  $d x A $.  $d x B $.
    rabbirdv.1 $e |- ( ph -> ( x e. B -> ( x e. A <-> ch ) ) ) $.
    $( Deduction from wff to restricted class abstraction. $)
    rabbirdv $p |- ( ph -> ( B i^i A ) = { x e. B | ch } ) $=
      wph cB cA cin vx cv cB wcel wch wa vx cab wch vx cB crab wph vx cv cB
      wcel wch wa vx cB cA cin wph vx cv cB wcel vx cv cA wcel wa vx cv cB wcel
      wch wa vx cv cB cA cin wcel wph vx cv cB wcel vx cv cA wcel wch
      rabbirdv.1 pm5.32d vx cv cB cA elin syl5bb abbi2dv wch vx cB df-rab
      syl6eqr $.
      $( [16-Sep-2004] $) $( [27-Aug-2004] $)
  $}

  ${
    $d x A $.
    $( Idempotent law for intersection of classes.  Theorem 15 of [Suppes]
       p. 26. $)
    inidm $p |- ( A i^i A ) = A $=
      vx cA cA cA vx cv cA wcel anidm ineqri $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Associative law for intersection of classes.  Exercise 9 of
       [TakeutiZaring] p. 17. $)
    inass $p |- ( ( A i^i B ) i^i C ) = ( A i^i ( B i^i C ) ) $=
      vx cA cB cin cC cA cB cC cin cin vx cv cA wcel vx cv cB wcel wa vx cv cC
      wcel wa vx cv cA wcel vx cv cB cC cin wcel wa vx cv cA cB cin wcel vx cv
      cC wcel wa vx cv cA cB cC cin cin wcel vx cv cA wcel vx cv cB wcel wa vx
      cv cC wcel wa vx cv cA wcel vx cv cB wcel vx cv cC wcel wa wa vx cv cA
      wcel vx cv cB cC cin wcel wa vx cv cA wcel vx cv cB wcel vx cv cC wcel
      anass vx cv cB cC cin wcel vx cv cB wcel vx cv cC wcel wa vx cv cA wcel
      vx cv cB cC elin anbi2i bitr4i vx cv cA cB cin wcel vx cv cA wcel vx cv
      cB wcel wa vx cv cC wcel vx cv cA cB elin anbi1i vx cv cA cB cC cin elin
      3bitr4i ineqri $.
      $( [3-May-1994] $)
  $}

  $( A rearrangement of intersection. $)
  in12 $p |- ( A i^i ( B i^i C ) ) = ( B i^i ( A i^i C ) ) $=
    cA cB cin cC cin cB cA cin cC cin cA cB cC cin cin cB cA cC cin cin cA cB
    cin cB cA cin cC cA cB incom ineq1i cA cB cC inass cB cA cC inass 3eqtr3i
    $.
    $( [21-Apr-2001] $)

  $( A rearrangement of intersection. $)
  in23 $p |- ( ( A i^i B ) i^i C ) = ( ( A i^i C ) i^i B ) $=
    cA cB cC cin cin cA cC cB cin cin cA cB cin cC cin cA cC cin cB cin cB cC
    cin cC cB cin cA cB cC incom ineq2i cA cB cC inass cA cC cB inass 3eqtr4i
    $.
    $( [21-Apr-2001] $)

  $( Rearrangement of intersection of 4 classes. $)
  in4 $p |- ( ( A i^i B ) i^i ( C i^i D ) ) =
            ( ( A i^i C ) i^i ( B i^i D ) ) $=
    cA cB cC cD cin cin cin cA cC cB cD cin cin cin cA cB cin cC cD cin cin cA
    cC cin cB cD cin cin cB cC cD cin cin cC cB cD cin cin cA cB cC cD in12
    ineq2i cA cB cC cD cin inass cA cC cB cD cin inass 3eqtr4i $.
    $( [21-Apr-2001] $)

  $( Intersection distributes over itself. $)
  inindi $p |- ( A i^i ( B i^i C ) ) = ( ( A i^i B ) i^i ( A i^i C ) ) $=
    cA cA cin cB cC cin cin cA cB cC cin cin cA cB cin cA cC cin cin cA cA cin
    cA cB cC cin cA inidm ineq1i cA cA cB cC in4 eqtr3i $.
    $( [6-May-1994] $)

  $( Intersection distributes over itself. $)
  inindir $p |- ( ( A i^i B ) i^i C ) = ( ( A i^i C ) i^i ( B i^i C ) ) $=
    cA cB cin cC cC cin cin cA cB cin cC cin cA cC cin cB cC cin cin cC cC cin
    cC cA cB cin cC inidm ineq2i cA cB cC cC in4 eqtr3i $.
    $( [18-Sep-2004] $) $( [17-Aug-2004] $)

  $( A relationship between subclass and intersection.  Similar to
     Exercise 9 of [TakeutiZaring] p. 18. $)
  sseqin2 $p |- ( A C_ B <-> ( B i^i A ) = A ) $=
    cA cB wss cA cB cin cA wceq cB cA cin cA wceq cA cB df-ss cA cB cin cB cA
    cin cA cA cB incom eqeq1i bitri $.
    $( [23-Sep-2004] $) $( [17-May-1994] $)

  ${
    $d x A $.  $d x B $.
    $( The intersection of two classes is a subset of one of them.  Part of
       Exercise 12 of [TakeutiZaring] p. 18. $)
    inss1 $p |- ( A i^i B ) C_ A $=
      vx cA cB cin cA vx cv cA cB cin wcel vx cv cA wcel vx cv cB wcel vx cv cA
      cB elin pm3.26bi ssriv $.
      $( [27-Apr-1994] $)
  $}

  $( The intersection of two classes is a subset of one of them.  Part of
     Exercise 12 of [TakeutiZaring] p. 18. $)
  inss2 $p |- ( A i^i B ) C_ B $=
    cA cB cin cB cA cin cB cB cA incom cB cA inss1 eqsstr3i $.
    $( [27-Apr-1994] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Subclass of intersection.  Theorem 2.8(vii) of [Monk1] p. 26. $)
    ssin $p |- ( ( A C_ B /\ A C_ C ) <-> A C_ ( B i^i C ) ) $=
      cA cB wss cA cC wss wa cA cB cC cin wss cA cB cin cA wceq cA cC cin cA
      wceq wa cA cB cC cin cin cA wceq cA cB wss cA cC wss wa cA cB cC cin wss
      cA cB cin cA wceq cA cC cin cA wceq wa cA cB cC cin cin cA cA cin cA cA
      cB cin cA wceq cA cC cin cA wceq wa cA cB cin cA cC cin cin cA cA cin cA
      cB cC cin cin cA cB cin cA cA cC cin cA ineq12 cA cB cC inindi syl5eq cA
      inidm syl6eq cA cB wss cA cB cin cA wceq cA cC wss cA cC cin cA wceq cA
      cB df-ss cA cC df-ss anbi12i cA cB cC cin df-ss 3imtr4i cA cB cC cin wss
      cA cB wss cA cC wss cA cB cC cin wss cB cC cin cB wss cA cB wss cB cC
      inss1 cA cB cC cin cB sstr2 mpi cA cB cC cin wss cB cC cin cC wss cA cC
      wss cB cC inss2 cA cB cC cin cC sstr2 mpi jca impbii $.
      $( [16-Jun-2004] $) $( [15-Jun-2004] $)
  $}

  ${
    ssini.1 $e |- A C_ B $.
    ssini.2 $e |- A C_ C $.
    $( An inference showing that the a subclass of two classes is a subclass of
       their intersection. $)
    ssini $p |- A C_ ( B i^i C ) $=
      cA cB wss cA cC wss wa cA cB cC cin wss cA cB wss cA cC wss ssini.1
      ssini.2 pm3.2i cA cB cC ssin mpbi $.
      $( [24-Nov-2003] $) $( [24-Nov-2003] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Add right intersection to subclass relation. $)
    ssrin $p |- ( A C_ B -> ( A i^i C ) C_ ( B i^i C ) ) $=
      vx cv cA wcel vx cv cB wcel wi vx wal vx cv cA cC cin wcel vx cv cB cC
      cin wcel wi vx wal cA cB wss cA cC cin cB cC cin wss vx cv cA wcel vx cv
      cB wcel wi vx cv cA cC cin wcel vx cv cB cC cin wcel wi vx vx cv cA wcel
      vx cv cB wcel wi vx cv cA wcel vx cv cC wcel wa vx cv cB wcel vx cv cC
      wcel wa vx cv cA cC cin wcel vx cv cB cC cin wcel vx cv cA wcel vx cv cB
      wcel vx cv cC wcel pm3.45 vx cv cA cC elin vx cv cB cC elin 3imtr4g
      19.20i vx cA cB dfss2 vx cA cC cin cB cC cin dfss2 3imtr4i $.
      $( [16-Aug-1994] $)

    $( Add left intersection to subclass relation. $)
    sslin $p |- ( A C_ B -> ( C i^i A ) C_ ( C i^i B ) ) $=
      cA cB wss cA cC cin cB cC cin cC cA cin cC cB cin cA cB cC ssrin cC cA
      incom cC cB incom 3sstr4g $.
      $( [19-Oct-1999] $)
  $}

  $( Intersection of subclasses. $)
  ss2in $p |- ( ( A C_ B /\ C C_ D ) -> ( A i^i C ) C_ ( B i^i D ) ) $=
    cA cB wss cC cD wss cA cC cin cB cC cin cB cD cin cA cB cC ssrin cC cD cB
    sslin sylan9ss $.
    $( [5-May-2000] $)

  $( Intersection preserves subclass relationship. $)
  ssinss1 $p |- ( A C_ C -> ( A i^i B ) C_ C ) $=
    cA cB cin cA wss cA cC wss cA cB cin cC wss wi cA cB inss1 cA cB cin cA cC
    sstr2 ax-mp $.
    $( [14-Sep-1999] $)

  $( Absorption law for union. $)
  unabs $p |- ( A u. ( A i^i B ) ) = A $=
    cA cB cin cA wss cA cA cB cin cun cA wceq cA cB inss1 cA cB cin cA ssequn2
    mpbi $.
    $( [19-Apr-2006] $) $( [16-Apr-2006] $)

  $( Absorption law for intersection. $)
  inabs $p |- ( A i^i ( A u. B ) ) = A $=
    cA cA cB cun wss cA cA cB cun cin cA wceq cA cB ssun1 cA cA cB cun df-ss
    mpbi $.
    $( [23-Apr-2006] $) $( [16-Apr-2006] $)

  $( Negation of subclass expressed in terms of intersection and proper
     subclass. $)
  nssinpss $p |- ( -. A C_ B <-> ( A i^i B ) C. A ) $=
    cA cA cB cin wss wn cA cB cin cA wss cA cA cB cin wss wn wa cA cB wss wn cA
    cB cin cA wpss cA cB cin cA wss cA cA cB cin wss wn cA cB inss1 biantrur cA
    cB wss cA cA cB cin wss cA cB wss cA cA wss cA cB wss wa cA cA cB cin wss
    cA cA wss cA cB wss cA ssid biantrur cA cA cB ssin bitri notbii cA cB cin
    cA dfpss3 3bitr4i $.
    $( [1-Jul-2004] $) $( [30-Jun-2004] $)

  $( Negation of subclass expressed in terms of proper subclass and union. $)
  nsspssun $p |- ( -. A C_ B <-> B C. ( A u. B ) ) $=
    cA cB cun cB wss wn cB cA cB cun wss cA cB cun cB wss wn wa cA cB wss wn cB
    cA cB cun wpss cB cA cB cun wss cA cB cun cB wss wn cB cA ssun2 biantrur cA
    cB wss cA cB cun cB wss cA cB wss cA cB wss cB cB wss wa cA cB cun cB wss
    cB cB wss cA cB wss cB ssid biantru cA cB cB unss bitri notbii cB cA cB cun
    dfpss3 3bitr4i $.
    $( [18-Sep-2004] $) $( [15-Sep-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Subclass defined in terms of class difference.  See comments under
       ~ dfun2 . $)
    dfss4 $p |- ( A C_ B <-> ( B \ ( B \ A ) ) = A ) $=
      cA cB wss cB cA cin cA wceq cB cB cA cdif cdif cA wceq cA cB sseqin2 cB
      cA cin cB cB cA cdif cdif cA vx cB cA cin cB cB cA cdif cdif vx cv cB
      wcel vx cv cA wcel wa vx cv cB wcel vx cv cB wcel vx cv cA wcel wn wa wn
      wa vx cv cB cA cin wcel vx cv cB cB cA cdif cdif wcel vx cv cB wcel vx cv
      cA wcel wa vx cv cB wcel vx cv cB wcel vx cv cA wcel wi wa vx cv cB wcel
      vx cv cB wcel vx cv cA wcel wn wa wn wa vx cv cB wcel vx cv cA wcel abai
      vx cv cB wcel vx cv cA wcel wi vx cv cB wcel vx cv cA wcel wn wa wn vx cv
      cB wcel vx cv cB wcel vx cv cA wcel iman anbi2i bitri vx cv cB cA elin vx
      cv cB cB cA cdif cdif wcel vx cv cB wcel vx cv cB cA cdif wcel wn wa vx
      cv cB wcel vx cv cB wcel vx cv cA wcel wn wa wn wa vx cv cB cB cA cdif
      eldif vx cv cB cA cdif wcel wn vx cv cB wcel vx cv cA wcel wn wa wn vx cv
      cB wcel vx cv cB cA cdif wcel vx cv cB wcel vx cv cA wcel wn wa vx cv cB
      cA eldif notbii anbi2i bitri 3bitr4i eqriv eqeq1i bitri $.
      $( [23-Sep-2004] $) $( [22-Mar-1998] $)

    $( An alternate definition of the union of two classes in terms of class
       difference, requiring no dummy variables.  Along with ~ dfin2 and
       ~ dfss4 it shows we can express union, intersection, and subset directly
       in terms of the single "primitive" operation ` \ `  (class
       difference). $)
    dfun2 $p |- ( A u. B ) = ( _V \ ( ( _V \ A ) \ B ) ) $=
      vx cA cB cun cvv cvv cA cdif cB cdif cdif vx cv cA wcel vx cv cB wcel wo
      vx cv cvv cA cdif cB cdif wcel wn vx cv cA cB cun wcel vx cv cvv cvv cA
      cdif cB cdif cdif wcel vx cv cvv cA cdif cB cdif wcel vx cv cA wcel vx cv
      cB wcel wo vx cv cvv cA cdif wcel vx cv cB wcel wn wa vx cv cA wcel wn vx
      cv cB wcel wn wa vx cv cvv cA cdif cB cdif wcel vx cv cA wcel vx cv cB
      wcel wo wn vx cv cvv cA cdif wcel vx cv cA wcel wn vx cv cB wcel wn vx cv
      cvv cA cdif wcel vx cv cvv wcel vx cv cA wcel wn vx cv cvv cA eldif vx
      visset mpbiran anbi1i vx cv cvv cA cdif cB eldif vx cv cA wcel vx cv cB
      wcel ioran 3bitr4i con2bii vx cv cA cB elun vx cv cvv cvv cA cdif cB cdif
      cdif wcel vx cv cvv wcel vx cv cvv cA cdif cB cdif wcel wn vx cv cvv cvv
      cA cdif cB cdif eldif vx visset mpbiran 3bitr4i eqriv $.
      $( [12-Jun-2004] $) $( [10-Jun-2004] $)

    $( An alternate definition of the intersection of two classes in terms of
       class difference, requiring no dummy variables.  See comments under
       ~ dfun2 .  Another version is given by ~ dfin4 . $)
    dfin2 $p |- ( A i^i B ) = ( A \ ( _V \ B ) ) $=
      vx cA cB cin cA cvv cB cdif cdif vx cv cA wcel vx cv cB wcel wa vx cv cA
      wcel vx cv cvv cB cdif wcel wn wa vx cv cA cB cin wcel vx cv cA cvv cB
      cdif cdif wcel vx cv cB wcel vx cv cvv cB cdif wcel wn vx cv cA wcel vx
      cv cvv cB cdif wcel vx cv cB wcel vx cv cvv cB cdif wcel vx cv cvv wcel
      vx cv cB wcel wn vx cv cvv cB eldif vx visset mpbiran con2bii anbi2i vx
      cv cA cB elin vx cv cA cvv cB cdif eldif 3bitr4i eqriv $.
      $( [12-Jun-2004] $) $( [10-Jun-2004] $)

    $( Difference with intersection.  Theorem 33 of [Suppes] p. 29. $)
    difin $p |- ( A \ ( A i^i B ) ) = ( A \ B ) $=
      vx cA cA cB cin cdif cA cB cdif vx cv cA wcel vx cv cB wcel wn wa vx cv
      cA wcel vx cv cA wcel vx cv cB wcel wa wn wa vx cv cA cB cdif wcel vx cv
      cA cA cB cin cdif wcel vx cv cA wcel vx cv cB wcel wn wa vx cv cA wcel vx
      cv cA wcel vx cv cB wcel wn wi wa vx cv cA wcel vx cv cA wcel vx cv cB
      wcel wa wn wa vx cv cA wcel vx cv cB wcel wn abai vx cv cA wcel vx cv cB
      wcel wn wi vx cv cA wcel vx cv cB wcel wa wn vx cv cA wcel vx cv cA wcel
      vx cv cB wcel imnan anbi2i bitri vx cv cA cB eldif vx cv cA cA cB cin
      cdif wcel vx cv cA wcel vx cv cA cB cin wcel wn wa vx cv cA wcel vx cv cA
      wcel vx cv cB wcel wa wn wa vx cv cA cA cB cin eldif vx cv cA cB cin wcel
      wn vx cv cA wcel vx cv cB wcel wa wn vx cv cA wcel vx cv cA cB cin wcel
      vx cv cA wcel vx cv cB wcel wa vx cv cA cB elin notbii anbi2i bitri
      3bitr4ri eqriv $.
      $( [18-Aug-2004] $) $( [31-Mar-1998] $)
  $}

  $( Union defined in terms of intersection (DeMorgan's law).  Definition of
     union in [Mendelson] p. 231. $)
  dfun3 $p |- ( A u. B ) = ( _V \ ( ( _V \ A ) i^i ( _V \ B ) ) ) $=
    cA cB cun cvv cvv cA cdif cB cdif cdif cvv cvv cA cdif cvv cB cdif cin cdif
    cA cB dfun2 cvv cA cdif cB cdif cvv cA cdif cvv cB cdif cin cvv cvv cA cdif
    cvv cB cdif cin cvv cA cdif cvv cvv cB cdif cdif cdif cvv cA cdif cB cdif
    cvv cA cdif cvv cB cdif dfin2 cvv cvv cB cdif cdif cB cvv cA cdif cB ddif
    difeq2i eqtr2i difeq2i eqtri $.
    $( [8-Jan-2002] $)

  $( Intersection defined in terms of union (DeMorgan's law.  Similar to
     Exercise 4.10(n) of [Mendelson] p. 231. $)
  dfin3 $p |- ( A i^i B ) = ( _V \ ( ( _V \ A ) u. ( _V \ B ) ) ) $=
    cvv cvv cA cvv cB cdif cdif cdif cdif cA cvv cB cdif cdif cvv cvv cA cdif
    cvv cB cdif cun cdif cA cB cin cA cvv cB cdif cdif ddif cvv cA cdif cvv cB
    cdif cun cvv cA cvv cB cdif cdif cdif cvv cvv cA cdif cvv cB cdif cun cvv
    cvv cvv cA cdif cdif cvv cB cdif cdif cdif cvv cA cvv cB cdif cdif cdif cvv
    cA cdif cvv cB cdif dfun2 cvv cvv cA cdif cdif cvv cB cdif cdif cA cvv cB
    cdif cdif cvv cvv cvv cA cdif cdif cA cvv cB cdif cA ddif difeq1i difeq2i
    eqtri difeq2i cA cB dfin2 3eqtr4ri $.
    $( [8-Jan-2002] $)

  $( Alternate definition of the intersection of two classes.  Exercise 4.10(q)
     of [Mendelson] p. 231. $)
  dfin4 $p |- ( A i^i B ) = ( A \ ( A \ B ) ) $=
    cA cA cA cB cin cdif cdif cA cB cin cA cA cB cdif cdif cA cB cin cA wss cA
    cA cA cB cin cdif cdif cA cB cin wceq cA cB inss1 cA cB cin cA dfss4 mpbi
    cA cA cB cin cdif cA cB cdif cA cA cB difin difeq2i eqtr3i $.
    $( [25-Nov-2003] $) $( [25-Nov-2003] $)

  $( Intersection with universal complement.  Remark in [Stoll] p. 20. $)
  invdif $p |- ( A i^i ( _V \ B ) ) = ( A \ B ) $=
    cA cvv cB cdif cin cA cvv cvv cB cdif cdif cdif cA cB cdif cA cvv cB cdif
    dfin2 cvv cvv cB cdif cdif cB cA cB ddif difeq2i eqtri $.
    $( [18-Aug-2004] $) $( [17-Aug-2004] $)

  $( Intersection with class difference.  Theorem 34 of [Suppes] p. 29. $)
  indif $p |- ( A i^i ( A \ B ) ) = ( A \ B ) $=
    cA cA cB cdif cin cA cA cA cB cdif cdif cdif cA cA cB cin cdif cA cB cdif
    cA cA cB cdif dfin4 cA cB cin cA cA cB cdif cdif cA cA cB dfin4 difeq2i cA
    cB difin 3eqtr2i $.
    $( [3-Sep-2004] $) $( [17-Aug-2004] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Distributive law for intersection over union.  Exercise 10 of
       [TakeutiZaring] p. 17. $)
    indi $p |- ( A i^i ( B u. C ) ) = ( ( A i^i B ) u. ( A i^i C ) ) $=
      vx cA cB cC cun cin cA cB cin cA cC cin cun vx cv cA wcel vx cv cB cC cun
      wcel wa vx cv cA cB cin wcel vx cv cA cC cin wcel wo vx cv cA cB cC cun
      cin wcel vx cv cA cB cin cA cC cin cun wcel vx cv cA wcel vx cv cB wcel
      vx cv cC wcel wo wa vx cv cA wcel vx cv cB wcel wa vx cv cA wcel vx cv cC
      wcel wa wo vx cv cA wcel vx cv cB cC cun wcel wa vx cv cA cB cin wcel vx
      cv cA cC cin wcel wo vx cv cA wcel vx cv cB wcel vx cv cC wcel andi vx cv
      cB cC cun wcel vx cv cB wcel vx cv cC wcel wo vx cv cA wcel vx cv cB cC
      elun anbi2i vx cv cA cB cin wcel vx cv cA wcel vx cv cB wcel wa vx cv cA
      cC cin wcel vx cv cA wcel vx cv cC wcel wa vx cv cA cB elin vx cv cA cC
      elin orbi12i 3bitr4i vx cv cA cB cC cun elin vx cv cA cB cin cA cC cin
      elun 3bitr4i eqriv $.
      $( [30-Sep-2002] $)

    $( Distributive law for union over intersection.  Exercise 11 of
       [TakeutiZaring] p. 17. $)
    undi $p |- ( A u. ( B i^i C ) ) = ( ( A u. B ) i^i ( A u. C ) ) $=
      vx cA cB cC cin cun cA cB cun cA cC cun cin vx cv cA wcel vx cv cB cC cin
      wcel wo vx cv cA cB cun wcel vx cv cA cC cun wcel wa vx cv cA cB cC cin
      cun wcel vx cv cA cB cun cA cC cun cin wcel vx cv cA wcel vx cv cB wcel
      vx cv cC wcel wa wo vx cv cA wcel vx cv cB wcel wo vx cv cA wcel vx cv cC
      wcel wo wa vx cv cA wcel vx cv cB cC cin wcel wo vx cv cA cB cun wcel vx
      cv cA cC cun wcel wa vx cv cA wcel vx cv cB wcel vx cv cC wcel ordi vx cv
      cB cC cin wcel vx cv cB wcel vx cv cC wcel wa vx cv cA wcel vx cv cB cC
      elin orbi2i vx cv cA cB cun wcel vx cv cA wcel vx cv cB wcel wo vx cv cA
      cC cun wcel vx cv cA wcel vx cv cC wcel wo vx cv cA cB elun vx cv cA cC
      elun anbi12i 3bitr4i vx cv cA cB cC cin elun vx cv cA cB cun cA cC cun
      elin 3bitr4i eqriv $.
      $( [30-Sep-2002] $)
  $}

  $( Distributive law for intersection over union.  Theorem 28 of [Suppes]
     p. 27. $)
  indir $p |- ( ( A u. B ) i^i C ) = ( ( A i^i C ) u. ( B i^i C ) ) $=
    cC cA cB cun cin cC cA cin cC cB cin cun cA cB cun cC cin cA cC cin cB cC
    cin cun cC cA cB indi cA cB cun cC incom cA cC cin cC cA cin cB cC cin cC
    cB cin cA cC incom cB cC incom uneq12i 3eqtr4i $.
    $( [30-Sep-2002] $)

  $( Distributive law for union over intersection.  Theorem 29 of [Suppes]
     p. 27. $)
  undir $p |- ( ( A i^i B ) u. C ) = ( ( A u. C ) i^i ( B u. C ) ) $=
    cC cA cB cin cun cC cA cun cC cB cun cin cA cB cin cC cun cA cC cun cB cC
    cun cin cC cA cB undi cA cB cin cC uncom cA cC cun cC cA cun cB cC cun cC
    cB cun cA cC uncom cB cC uncom ineq12i 3eqtr4i $.
    $( [30-Sep-2002] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Infer equality from equalities of union and intersection.  Exercise 20
       of [Enderton] p. 32 and its converse. $)
    unineq $p |- ( ( ( A u. C ) = ( B u. C ) /\ ( A i^i C ) = ( B i^i C ) )
                 <-> A = B ) $=
      cA cC cun cB cC cun wceq cA cC cin cB cC cin wceq wa cA cB wceq cA cC cun
      cB cC cun wceq cA cC cin cB cC cin wceq wa vx cA cB vx cv cC wcel cA cC
      cun cB cC cun wceq cA cC cin cB cC cin wceq wa vx cv cA wcel vx cv cB
      wcel wb wi vx cv cC wcel cA cC cin cB cC cin wceq vx cv cA wcel vx cv cB
      wcel wb cA cC cun cB cC cun wceq vx cv cC wcel vx cv cA wcel vx cv cB
      wcel wb vx cv cA wcel vx cv cC wcel wa vx cv cB wcel vx cv cC wcel wa wb
      cA cC cin cB cC cin wceq vx cv cC wcel vx cv cA wcel vx cv cA wcel vx cv
      cC wcel wa vx cv cB wcel vx cv cB wcel vx cv cC wcel wa vx cv cC wcel vx
      cv cA wcel iba vx cv cC wcel vx cv cB wcel iba bibi12d cA cC cin cB cC
      cin wceq vx cv cA cC cin wcel vx cv cB cC cin wcel vx cv cA wcel vx cv cC
      wcel wa vx cv cB wcel vx cv cC wcel wa cA cC cin cB cC cin vx cv eleq2 vx
      cv cA cC elin vx cv cB cC elin 3bitr3g syl5bir adantld vx cv cC wcel wn
      cA cC cun cB cC cun wceq vx cv cA wcel vx cv cB wcel wb cA cC cin cB cC
      cin wceq vx cv cC wcel wn vx cv cA wcel vx cv cB wcel wb vx cv cC wcel vx
      cv cA wcel wo vx cv cC wcel vx cv cB wcel wo wb cA cC cun cB cC cun wceq
      vx cv cC wcel wn vx cv cA wcel vx cv cC wcel vx cv cA wcel wo vx cv cB
      wcel vx cv cC wcel vx cv cB wcel wo vx cv cC wcel vx cv cA wcel biorf vx
      cv cC wcel vx cv cB wcel biorf bibi12d cA cC cun cB cC cun wceq vx cv cC
      cA cun wcel vx cv cC cB cun wcel vx cv cC wcel vx cv cA wcel wo vx cv cC
      wcel vx cv cB wcel wo cA cC cun cB cC cun wceq cC cA cun cC cB cun wceq
      vx cv cC cA cun wcel vx cv cC cB cun wcel wb cA cC cun cC cA cun cB cC
      cun cC cB cun cA cC uncom cB cC uncom eqeq12i cC cA cun cC cB cun vx cv
      eleq2 sylbi vx cv cC cA elun vx cv cC cB elun 3bitr3g syl5bir adantrd
      pm2.61i eqrdv cA cB wceq cA cC cun cB cC cun wceq cA cC cin cB cC cin
      wceq cA cB cC uneq1 cA cB cC ineq1 jca impbii $.
      $( [25-Sep-2004] $) $( [10-Aug-2004] $)
  $}

  $( Equality of union and intersection implies equality of their arguments. $)
  uneqin $p |- ( ( A u. B ) = ( A i^i B ) <-> A = B ) $=
    cA cB cun cA cB cin wceq cA cB wceq cA cB cun cA cB cin wceq cA cB cun cA
    cB cin wss cA cB wceq cA cB cun cA cB cin eqimss cA cB cun cA cB cin wss cA
    cB wss cB cA wss wa cA cB wceq cA cB cun cA cB cin wss cA cA cB cin wss cB
    cA cB cin wss wa cA cB wss cB cA wss wa cA cB cA cB cin unss cA cA cB cin
    wss cA cB wss cB cA cB cin wss cB cA wss cA cA cB cin wss cA cA wss cA cB
    wss wa cA cB wss cA cA cB ssin cA cA cB sstr sylbir cB cA cB cin wss cB cA
    wss cB cB wss wa cB cA wss cB cA cB ssin cB cA wss cB cB wss pm3.26 sylbir
    anim12i sylbir cA cB eqss sylibr syl cA cB wceq cA cA cun cA cB cun cA cB
    cin cA cB cA uneq2 cA cB wceq cA cA cB cin cA cA cun cA cB wceq cA cA cin
    cA cB cin cA cA cB cA ineq2 cA inidm syl5eqr cA unidm syl5eq eqtr3d impbii
    $.
    $( [17-Apr-2006] $) $( [16-Apr-2006] $)

  $( Distributive law for class difference.  Theorem 39 of [Suppes] p. 29. $)
  difundi $p |- ( A \ ( B u. C ) ) = ( ( A \ B ) i^i ( A \ C ) ) $=
    cA cB cC cun cdif cA cvv cvv cB cdif cvv cC cdif cin cdif cdif cA cB cdif
    cA cC cdif cin cB cC cun cvv cvv cB cdif cvv cC cdif cin cdif cA cB cC
    dfun3 difeq2i cA cvv cB cdif cvv cC cdif cin cin cA cvv cB cdif cin cA cvv
    cC cdif cin cin cA cvv cvv cB cdif cvv cC cdif cin cdif cdif cA cB cdif cA
    cC cdif cin cA cvv cB cdif cvv cC cdif inindi cA cvv cB cdif cvv cC cdif
    cin dfin2 cA cvv cB cdif cin cA cB cdif cA cvv cC cdif cin cA cC cdif cA cB
    invdif cA cC invdif ineq12i 3eqtr3i eqtri $.
    $( [31-Aug-2004] $) $( [17-Aug-2004] $)

  $( Distributive law for class difference. $)
  difundir $p |- ( ( A u. B ) \ C ) = ( ( A \ C ) u. ( B \ C ) ) $=
    cA cB cun cvv cC cdif cin cA cvv cC cdif cin cB cvv cC cdif cin cun cA cB
    cun cC cdif cA cC cdif cB cC cdif cun cA cB cvv cC cdif indir cA cB cun cC
    invdif cA cvv cC cdif cin cA cC cdif cB cvv cC cdif cin cB cC cdif cA cC
    invdif cB cC invdif uneq12i 3eqtr3i $.
    $( [18-Aug-2004] $) $( [17-Aug-2004] $)

  $( Distributive law for class difference.  Theorem 40 of [Suppes] p. 29. $)
  difindi $p |- ( A \ ( B i^i C ) ) = ( ( A \ B ) u. ( A \ C ) ) $=
    cA cB cC cin cdif cA cvv cvv cB cdif cvv cC cdif cun cdif cdif cA cB cdif
    cA cC cdif cun cB cC cin cvv cvv cB cdif cvv cC cdif cun cdif cA cB cC
    dfin3 difeq2i cA cvv cB cdif cvv cC cdif cun cin cA cvv cB cdif cin cA cvv
    cC cdif cin cun cA cvv cvv cB cdif cvv cC cdif cun cdif cdif cA cB cdif cA
    cC cdif cun cA cvv cB cdif cvv cC cdif indi cA cvv cB cdif cvv cC cdif cun
    dfin2 cA cvv cB cdif cin cA cB cdif cA cvv cC cdif cin cA cC cdif cA cB
    invdif cA cC invdif uneq12i 3eqtr3i eqtri $.
    $( [18-Sep-2004] $) $( [17-Aug-2004] $)

  $( Distributive law for class difference. $)
  difindir $p |- ( ( A i^i B ) \ C ) = ( ( A \ C ) i^i ( B \ C ) ) $=
    cA cB cin cvv cC cdif cin cA cvv cC cdif cin cB cvv cC cdif cin cin cA cB
    cin cC cdif cA cC cdif cB cC cdif cin cA cB cvv cC cdif inindir cA cB cin
    cC invdif cA cvv cC cdif cin cA cC cdif cB cvv cC cdif cin cB cC cdif cA cC
    invdif cB cC invdif ineq12i 3eqtr3i $.
    $( [19-Sep-2004] $) $( [17-Aug-2004] $)

  $( DeMorgan's law for union.  Theorem 5.2(13) of [Stoll] p. 19. $)
  undm $p |- ( _V \ ( A u. B ) ) = ( ( _V \ A ) i^i ( _V \ B ) ) $=
    cvv cA cB difundi $.
    $( [31-Aug-2004] $) $( [18-Aug-2004] $)

  $( DeMorgan's law for intersection.  Theorem 5.2(13') of [Stoll] p. 19. $)
  indm $p |- ( _V \ ( A i^i B ) ) = ( ( _V \ A ) u. ( _V \ B ) ) $=
    cvv cA cB difindi $.
    $( [20-Sep-2004] $) $( [18-Aug-2004] $)

  $( A relationship involving double difference and union. $)
  difun1 $p |- ( A \ ( B u. C ) ) = ( ( A \ B ) \ C ) $=
    cA cvv cB cdif cin cC cdif cA cB cC cun cdif cA cB cdif cC cdif cA cvv cB
    cdif cin cvv cC cdif cin cA cvv cB cdif cvv cC cdif cin cin cA cvv cB cdif
    cin cC cdif cA cB cC cun cdif cA cvv cB cdif cvv cC cdif inass cA cvv cB
    cdif cin cC invdif cA cvv cB cC cun cdif cin cA cvv cB cdif cvv cC cdif cin
    cin cA cB cC cun cdif cvv cB cC cun cdif cvv cB cdif cvv cC cdif cin cA cB
    cC undm ineq2i cA cB cC cun invdif eqtr3i 3eqtr3i cA cvv cB cdif cin cA cB
    cdif cC cA cB invdif difeq1i eqtr3i $.
    $( [4-Sep-2004] $) $( [29-Aug-2004] $)

  $( Swap second and third argument of double difference. $)
  dif23 $p |- ( ( A \ B ) \ C ) = ( ( A \ C ) \ B ) $=
    cA cB cC cun cdif cA cC cB cun cdif cA cB cdif cC cdif cA cC cdif cB cdif
    cB cC cun cC cB cun cA cB cC uncom difeq2i cA cB cC difun1 cA cC cB difun1
    3eqtr3i $.
    $( [27-Aug-2004] $) $( [18-Aug-2004] $)

  $( Two ways to express symmetric difference.  This theorem shows the
     equivalence of the definition of symmetric difference in [Stoll] p. 13
     and the restated definition in Example 4.1 of [Stoll] p. 262. $)
  symdif1 $p |- ( ( A \ B ) u. ( B \ A ) ) = ( ( A u. B ) \ ( A i^i B ) ) $=
    cA cB cun cA cB cin cdif cA cA cB cin cdif cB cA cB cin cdif cun cA cB cdif
    cB cA cdif cun cA cB cA cB cin difundir cA cA cB cin cdif cA cB cdif cB cA
    cB cin cdif cB cA cdif cA cB difin cB cA cB cin cdif cB cB cA cin cdif cB
    cA cdif cA cB cin cB cA cin cB cA cB incom difeq2i cB cA difin eqtri
    uneq12i eqtr2i $.
    $( [2-Sep-2004] $) $( [17-Aug-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Two ways to express symmetric difference. $)
    symdif2 $p |- ( ( A \ B ) u. ( B \ A ) ) =
                  { x | -. ( x e. A <-> x e. B ) } $=
      vx cv cA wcel vx cv cB wcel wb wn vx cA cB cdif cB cA cdif cun vx cv cA
      cB cdif cB cA cdif cun wcel vx cv cA cB cdif wcel vx cv cB cA cdif wcel
      wo vx cv cA wcel wn wn vx cv cB wcel wn wa vx cv cA wcel wn vx cv cB wcel
      wa wo vx cv cA wcel vx cv cB wcel wb wn vx cv cA cB cdif cB cA cdif elun
      vx cv cA cB cdif wcel vx cv cA wcel wn wn vx cv cB wcel wn wa vx cv cB cA
      cdif wcel vx cv cA wcel wn vx cv cB wcel wa vx cv cA cB cdif wcel vx cv
      cA wcel vx cv cB wcel wn wa vx cv cA wcel wn wn vx cv cB wcel wn wa vx cv
      cA cB eldif vx cv cA wcel vx cv cA wcel wn wn vx cv cB wcel wn vx cv cA
      wcel notnot anbi1i bitri vx cv cB cA cdif wcel vx cv cB wcel vx cv cA
      wcel wn wa vx cv cA wcel wn vx cv cB wcel wa vx cv cB cA eldif vx cv cB
      wcel vx cv cA wcel wn ancom bitri orbi12i vx cv cA wcel wn wn vx cv cB
      wcel wn wa vx cv cA wcel wn vx cv cB wcel wa wo vx cv cA wcel wn vx cv cB
      wcel wa vx cv cA wcel wn wn vx cv cB wcel wn wa wo vx cv cA wcel wn vx cv
      cB wcel wb vx cv cA wcel vx cv cB wcel wb wn vx cv cA wcel wn wn vx cv cB
      wcel wn wa vx cv cA wcel wn vx cv cB wcel wa orcom vx cv cA wcel wn vx cv
      cB wcel dfbi3 vx cv cA wcel vx cv cB wcel nbbn 3bitr2i 3bitri abbi2i $.
      $( [21-Sep-2004] $) $( [17-Aug-2004] $)
  $}

  ${
    $d x y $.  $d ph y $.  $d ps y $.
    $( Union of two class abstractions. $)
    unab $p |- ( { x | ph } u. { x | ps } ) = { x | ( ph \/ ps ) } $=
      vy wph vx cab wps vx cab cun wph wps wo vx cab vy cv wph vx cab wcel vy
      cv wps vx cab wcel wo wph wps wo vx vy cv wsbc vy cv wph vx cab wps vx
      cab cun wcel vy cv wph wps wo vx cab wcel vy cv wph vx cab wcel vy cv wps
      vx cab wcel wo wph vx vy cv wsbc wps vx vy cv wsbc wo wph wps wo vx vy cv
      wsbc vy cv wph vx cab wcel wph vx vy cv wsbc vy cv wps vx cab wcel wps vx
      vy cv wsbc wph vy vx df-clab wps vy vx df-clab orbi12i wph wps vx vy sbor
      bitr4i vy cv wph vx cab wps vx cab elun wph wps wo vy vx df-clab 3bitr4i
      eqriv $.
      $( [29-Sep-2002] $)

    $( Intersection of two class abstractions. $)
    inab $p |- ( { x | ph } i^i { x | ps } ) = { x | ( ph /\ ps ) } $=
      vy wph vx cab wps vx cab cin wph wps wa vx cab vy cv wph vx cab wcel vy
      cv wps vx cab wcel wa wph wps wa vx vy cv wsbc vy cv wph vx cab wps vx
      cab cin wcel vy cv wph wps wa vx cab wcel vy cv wph vx cab wcel vy cv wps
      vx cab wcel wa wph vx vy cv wsbc wps vx vy cv wsbc wa wph wps wa vx vy cv
      wsbc vy cv wph vx cab wcel wph vx vy cv wsbc vy cv wps vx cab wcel wps vx
      vy cv wsbc wph vy vx df-clab wps vy vx df-clab anbi12i wph wps vx vy sban
      bitr4i vy cv wph vx cab wps vx cab elin wph wps wa vy vx df-clab 3bitr4i
      eqriv $.
      $( [29-Sep-2002] $)

    $( Difference of two class abstractions. $)
    difab $p |- ( { x | ph } \ { x | ps } ) = { x | ( ph /\ -. ps ) } $=
      wph vx cab cvv wps vx cab cdif cin wph vx cab wps wn vx cab cin wph vx
      cab wps vx cab cdif wph wps wn wa vx cab cvv wps vx cab cdif wps wn vx
      cab wph vx cab vy cvv wps vx cab wps wn vx cab vy cv wps wn vx cab wcel
      vy cv wps vx cab wcel wn vy cv cvv wcel vy cv wps vx cab wcel wn wa wps
      wn vx vy cv wsbc wps vx vy cv wsbc wn vy cv wps wn vx cab wcel vy cv wps
      vx cab wcel wn wps vx vy sbn wps wn vy vx df-clab vy cv wps vx cab wcel
      wps vx vy cv wsbc wps vy vx df-clab notbii 3bitr4i vy cv cvv wcel vy cv
      wps vx cab wcel wn vy visset biantrur bitr2i difeqri ineq2i wph vx cab
      wps vx cab invdif wph wps wn vx inab 3eqtr3i $.
      $( [23-Oct-2004] $) $( [23-Oct-2004] $)
  $}

  $( Union of two restricted class abstractions. $)
  unrab $p |- ( { x e. A | ph } u. { x e. A | ps } ) =
              { x e. A | ( ph \/ ps ) } $=
    vx cv cA wcel wph wa vx cab vx cv cA wcel wps wa vx cab cun vx cv cA wcel
    wph wps wo wa vx cab wph vx cA crab wps vx cA crab cun wph wps wo vx cA
    crab vx cv cA wcel wph wa vx cab vx cv cA wcel wps wa vx cab cun vx cv cA
    wcel wph wa vx cv cA wcel wps wa wo vx cab vx cv cA wcel wph wps wo wa vx
    cab vx cv cA wcel wph wa vx cv cA wcel wps wa vx unab vx cv cA wcel wph wps
    wo wa vx cv cA wcel wph wa vx cv cA wcel wps wa wo vx vx cv cA wcel wph wps
    andi abbii eqtr4i wph vx cA crab vx cv cA wcel wph wa vx cab wps vx cA crab
    vx cv cA wcel wps wa vx cab wph vx cA df-rab wps vx cA df-rab uneq12i wph
    wps wo vx cA df-rab 3eqtr4i $.
    $( [26-Mar-2004] $) $( [25-Mar-2004] $)

  $( Intersection of two restricted class abstractions. $)
  inrab $p |- ( { x e. A | ph } i^i { x e. A | ps } ) =
              { x e. A | ( ph /\ ps ) } $=
    vx cv cA wcel wph wa vx cab vx cv cA wcel wps wa vx cab cin vx cv cA wcel
    wph wps wa wa vx cab wph vx cA crab wps vx cA crab cin wph wps wa vx cA
    crab vx cv cA wcel wph wa vx cab vx cv cA wcel wps wa vx cab cin vx cv cA
    wcel wph wa vx cv cA wcel wps wa wa vx cab vx cv cA wcel wph wps wa wa vx
    cab vx cv cA wcel wph wa vx cv cA wcel wps wa vx inab vx cv cA wcel wph wps
    wa wa vx cv cA wcel wph wa vx cv cA wcel wps wa wa vx vx cv cA wcel wph wps
    anandi abbii eqtr4i wph vx cA crab vx cv cA wcel wph wa vx cab wps vx cA
    crab vx cv cA wcel wps wa vx cab wph vx cA df-rab wps vx cA df-rab ineq12i
    wph wps wa vx cA df-rab 3eqtr4i $.
    $( [5-Sep-2006] $) $( [1-Sep-2006] $)

  ${
    $d x B $.
    $( Intersection with a restricted class abstraction. $)
    inrab2 $p |- ( { x e. A | ph } i^i B ) = { x e. ( A i^i B ) | ph } $=
      vx cv cA wcel wph wa vx cab vx cv cB wcel vx cab cin vx cv cA cB cin wcel
      wph wa vx cab wph vx cA crab cB cin wph vx cA cB cin crab vx cv cA wcel
      wph wa vx cab vx cv cB wcel vx cab cin vx cv cA wcel wph wa vx cv cB wcel
      wa vx cab vx cv cA cB cin wcel wph wa vx cab vx cv cA wcel wph wa vx cv
      cB wcel vx inab vx cv cA cB cin wcel wph wa vx cv cA wcel wph wa vx cv cB
      wcel wa vx vx cv cA cB cin wcel wph wa vx cv cA wcel vx cv cB wcel wa wph
      wa vx cv cA wcel wph wa vx cv cB wcel wa vx cv cA cB cin wcel vx cv cA
      wcel vx cv cB wcel wa wph vx cv cA cB elin anbi1i vx cv cA wcel vx cv cB
      wcel wph an23 bitri abbii eqtr4i wph vx cA crab vx cv cA wcel wph wa vx
      cab cB vx cv cB wcel vx cab wph vx cA df-rab vx cv cB wcel vx cab cB vx
      cB abid2 eqcomi ineq12i wph vx cA cB cin df-rab 3eqtr4i $.
      $( [22-Nov-2007] $) $( [19-Nov-2007] $)
  $}

  $( Difference of two restricted class abstractions. $)
  difrab $p |- ( { x e. A | ph } \ { x e. A | ps } ) =
              { x e. A | ( ph /\ -. ps ) } $=
    vx cv cA wcel wph wa vx cab vx cv cA wcel wps wa vx cab cdif vx cv cA wcel
    wph wps wn wa wa vx cab wph vx cA crab wps vx cA crab cdif wph wps wn wa vx
    cA crab vx cv cA wcel wph wa vx cab vx cv cA wcel wps wa vx cab cdif vx cv
    cA wcel wph wa vx cv cA wcel wps wa wn wa vx cab vx cv cA wcel wph wps wn
    wa wa vx cab vx cv cA wcel wph wa vx cv cA wcel wps wa vx difab vx cv cA
    wcel wph wps wn wa wa vx cv cA wcel wph wa vx cv cA wcel wps wa wn wa vx vx
    cv cA wcel wph wps wn wa wa vx cv cA wcel wph wa wps wn wa vx cv cA wcel
    wph wa vx cv cA wcel wps wa wn wa vx cv cA wcel wph wps wn anass vx cv cA
    wcel wph wa wps wn wa vx cv cA wcel wph wa vx cv cA wcel wps wa wn wa wps
    wn vx cv cA wcel wps wa wn vx cv cA wcel wph wa vx cv cA wcel wps wa wps vx
    cv cA wcel wps pm3.27 con3i anim2i vx cv cA wcel wph wa vx cv cA wcel wps
    wa wn wps wn vx cv cA wcel wph wa wps vx cv cA wcel wps wa vx cv cA wcel
    wps vx cv cA wcel wps wa wi wph vx cv cA wcel wps pm3.2 adantr con3d
    imdistani impbii bitr3i abbii eqtr4i wph vx cA crab vx cv cA wcel wph wa vx
    cab wps vx cA crab vx cv cA wcel wps wa vx cab wph vx cA df-rab wps vx cA
    df-rab difeq12i wph wps wn wa vx cA df-rab 3eqtr4i $.
    $( [23-Oct-2004] $) $( [23-Oct-2004] $)

  ${
    $d x A $.
    $( Alternate definition of restricted class abstraction. $)
    dfrab2 $p |- { x e. A | ph } = ( { x | ph } i^i A ) $=
      wph vx cA crab vx cv cA wcel wph wa vx cab cA wph vx cab cin wph vx cab
      cA cin wph vx cA df-rab vx cv cA wcel vx cab wph vx cab cin vx cv cA wcel
      wph wa vx cab cA wph vx cab cin vx cv cA wcel wph vx inab vx cv cA wcel
      vx cab cA wph vx cab vx cA abid2 ineq1i eqtr3i cA wph vx cab incom 3eqtri
      $.
      $( [20-Sep-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Transfer uniqueness to a smaller subclass. $)
    reuss2 $p |- ( ( ( A C_ B /\ A. x e. A ( ph -> ps ) ) /\
                 ( E. x e. A ph /\ E! x e. B ps ) ) -> E! x e. A ph ) $=
      cA cB wss wph wps wi vx cA wral wa vx cv cA wcel wph wa vx wex vx cv cB
      wcel wps wa vx weu wa wph vx cA wreu wph vx cA wrex wps vx cB wreu wa cA
      cB wss wph wps wi vx cA wral wa vx cv cA wcel wph wa vx wex vx cv cB wcel
      wps wa vx weu wa wa vx cv cA wcel wph wa vx weu wph vx cA wreu cA cB wss
      wph wps wi vx cA wral wa vx cv cA wcel wph wa vx wex vx cv cB wcel wps wa
      vx weu vx cv cA wcel wph wa vx weu cA cB wss wph wps wi vx cA wral wa vx
      cv cB wcel wps wa vx weu vx cv cA wcel wph wa vx wmo vx cv cA wcel wph wa
      vx wex vx cv cA wcel wph wa vx weu cA cB wss wph wps wi vx cA wral wa vx
      cv cA wcel wph wa vx cv cB wcel wps wa wi vx wal vx cv cB wcel wps wa vx
      weu vx cv cA wcel wph wa vx wmo wi cA cB wss vx cv cA wcel wph wps wi wi
      vx wal vx cv cA wcel wph wa vx cv cB wcel wps wa wi vx wal wph wps wi vx
      cA wral cA cB wss vx cv cA wcel wph wps wi wi vx wal vx cv cA wcel wph wa
      vx cv cB wcel wps wa wi vx wal cA cB wss vx cv cA wcel wph wps wi wi vx
      cv cA wcel wph wa vx cv cB wcel wps wa wi vx cA cB wss vx cv cA wcel wph
      wps wi wi vx cv cA wcel wph vx cv cB wcel wps wa cA cB wss vx cv cA wcel
      wph wps wi wph vx cv cB wcel wps wa wi cA cB wss wph wps wi vx cv cA wcel
      wph vx cv cB wcel wps wa wi cA cB wss wph wps wi vx cv cA wcel wph vx cv
      cB wcel wps wa vx cv cA wcel vx cv cB wcel wi wph wps wi vx cv cA wcel
      wph wa vx cv cB wcel wps wa wi cA cB wss vx cv cA wcel vx cv cB wcel wph
      wps prth cA cB vx cv ssel sylan exp4b com23 a2d imp4a 19.20dv imp wph wps
      wi vx cA df-ral sylan2b vx cv cA wcel wph wa vx cv cB wcel wps wa vx
      euimmo syl vx cv cA wcel wph wa vx wex vx cv cA wcel wph wa vx wmo vx cv
      cA wcel wph wa vx weu vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx
      wex vx cv cA wcel wph wa vx wmo wa vx cv cA wcel wph wa vx eu5 biimpri ex
      syl9 imp32 wph vx cA df-reu sylibr wph vx cA wrex vx cv cA wcel wph wa vx
      wex wps vx cB wreu vx cv cB wcel wps wa vx weu wph vx cA df-rex wps vx cB
      df-reu anbi12i sylan2b $.
      $( [26-Oct-2005] $) $( [20-Oct-2005] $)

    $( Transfer uniqueness to a smaller subclass. $)
    reuss $p |- ( ( A C_ B /\ E. x e. A ph /\ E! x e. B ph ) ->
                E! x e. A ph ) $=
      cA cB wss wph vx cA wrex wph vx cB wreu wph vx cA wreu cA cB wss wph wph
      wi vx cA wral wph vx cA wrex wph vx cB wreu wa wph vx cA wreu wph wph wi
      vx cA vx cv cA wcel wph idd rgen wph wph vx cA cB reuss2 mpanl2 3impb $.
      $( [2-Nov-2005] $) $( [21-Aug-1999] $)
$(
      ( wss wrex wreu cv wcel wa wex weu wmo wi wal ssel anim1d 19.21aiv
      euimmo syl eu5 biimpri ex syl9 imp32 df-reu sylibr df-rex anbi12i
      sylan2b 3impb ) CDEZABCFZABDGZABCGZULBHZCIZAJZBKZUPDIZAJZBLZJZUOUMUNJULVC
      JURBLZUOULUSVBVDULVBURBMZUSVDULURVANZBOVBVENULVFBULUQUTACDUPPQRURVABSTUSV
      EVDVDUSVEJURBUAUBUCUDUEABCUFUGUMUSUNVBABCUHABDUFUIUJUK $.
$)

    $( Transfer uniqueness to a smaller class. $)
    reuun1 $p |- ( ( E. x e. A ph /\ E! x e. ( A u. B ) ( ph \/ ps ) )
                 -> E! x e. A ph ) $=
      cA cA cB cun wss wph wph wps wo wi vx cA wral wph vx cA wrex wph wps wo
      vx cA cB cun wreu wa wph vx cA wreu cA cB ssun1 wph wph wps wo wi vx cA
      wph wph wps wo wi vx cv cA wcel wph wps orc a1i rgen wph wph wps wo vx cA
      cA cB cun reuss2 mpanl12 $.
      $( [10-Nov-2005] $) $( [21-Oct-2005] $)

    $( Transfer uniqueness to a smaller or larger class. $)
    reuun2 $p |- ( -. E. x e. B ph ->
             ( E! x e. ( A u. B ) ph <-> E! x e. A ph ) ) $=
      wph vx cB wrex wn vx cv cB wcel wph wa vx cv cA wcel wph wa wo vx weu vx
      cv cA wcel wph wa vx weu wph vx cA cB cun wreu wph vx cA wreu wph vx cB
      wrex wn vx cv cB wcel wph wa vx wex wn vx cv cB wcel wph wa vx cv cA wcel
      wph wa wo vx weu vx cv cA wcel wph wa vx weu wb wph vx cB wrex vx cv cB
      wcel wph wa vx wex wph vx cB df-rex notbii vx cv cB wcel wph wa vx cv cA
      wcel wph wa vx euor2 sylbi wph vx cA cB cun wreu vx cv cA cB cun wcel wph
      wa vx weu vx cv cB wcel wph wa vx cv cA wcel wph wa wo vx weu wph vx cA
      cB cun df-reu vx cv cA cB cun wcel wph wa vx cv cB wcel wph wa vx cv cA
      wcel wph wa wo vx vx cv cA cB cun wcel wph wa vx cv cA wcel vx cv cB wcel
      wo wph wa vx cv cA wcel wph wa vx cv cB wcel wph wa wo vx cv cB wcel wph
      wa vx cv cA wcel wph wa wo vx cv cA cB cun wcel vx cv cA wcel vx cv cB
      wcel wo wph vx cv cA cB elun anbi1i vx cv cA wcel vx cv cB wcel wph andir
      vx cv cA wcel wph wa vx cv cB wcel wph wa orcom 3bitri eubii bitri wph vx
      cA df-reu 3bitr4g $.
      $( [28-Oct-2005] $) $( [21-Oct-2005] $)

    $( Restricted uniqueness "picks" a member of a subclass. $)
    reupick $p |- ( ( ( A C_ B /\ ( E. x e. A ph /\ E! x e. B ph ) ) /\ ph ) ->
                  ( x e. A <-> x e. B ) ) $=
      cA cB wss wph vx cA wrex wph vx cB wreu wa wa wph wa vx cv cA wcel vx cv
      cB wcel cA cB wss vx cv cA wcel vx cv cB wcel wi wph vx cA wrex wph vx cB
      wreu wa wph cA cB vx cv ssel ad2antrr cA cB wss wph vx cA wrex wph vx cB
      wreu wa wa wph vx cv cB wcel vx cv cA wcel wi cA cB wss wph vx cA wrex
      wph vx cB wreu wa wa vx cv cB wcel wph vx cv cA wcel cA cB wss wph vx cA
      wrex wph vx cB wreu wa wa vx cv cB wcel wph vx cv cA wcel cA cB wss vx cv
      cA wcel wph wa vx wex vx cv cB wcel wph wa vx weu wa vx cv cB wcel wph wa
      vx cv cA wcel wi wph vx cA wrex wph vx cB wreu wa cA cB wss vx cv cA wcel
      wph wa vx wex vx cv cB wcel wph wa vx weu vx cv cB wcel wph wa vx cv cA
      wcel wi cA cB wss vx cv cB wcel wph wa vx weu vx cv cA wcel wph wa vx wex
      vx cv cB wcel wph wa vx cv cA wcel wi cA cB wss vx cv cA wcel wph wa vx
      wex vx cv cB wcel wph wa vx cv cA wcel wa vx wex vx cv cB wcel wph wa vx
      weu vx cv cB wcel wph wa vx cv cA wcel wi cA cB wss vx cv cA wcel wph wa
      vx cv cB wcel wph wa vx cv cA wcel wa vx cA cB wss vx cv cA wcel wph wa
      vx cv cB wcel vx cv cA wcel wa wph wa vx cv cB wcel wph wa vx cv cA wcel
      wa cA cB wss vx cv cA wcel vx cv cB wcel vx cv cA wcel wa wph cA cB wss
      vx cv cA wcel vx cv cB wcel cA cB vx cv ssel ancrd anim1d vx cv cB wcel
      vx cv cA wcel wph an23 syl6ib 19.22dv vx cv cB wcel wph wa vx weu vx cv
      cB wcel wph wa vx cv cA wcel wa vx wex vx cv cB wcel wph wa vx cv cA wcel
      wi vx cv cB wcel wph wa vx cv cA wcel vx eupick ex syl9 com23 imp32 wph
      vx cA wrex vx cv cA wcel wph wa vx wex wph vx cB wreu vx cv cB wcel wph
      wa vx weu wph vx cA df-rex wph vx cB df-reu anbi12i sylan2b exp3a com23
      imp impbid $.
      $( [21-Aug-1999] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           The empty set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the symbol for the empty or null set. $)
  $c (/) $. $( null set $)

  $( Extend class notation to include the empty set. $)
  c0 $a class (/) $.

  $( Define the empty set.  Special case of Exercise 4.10(o) of [Mendelson]
     p. 231.  For a more traditional definition, but requiring a dummy
     variable, see ~ dfnul2 . $)
  df-nul $a |- (/) = ( _V \ _V ) $.

  $( Alternate definition of the empty set.  Definition 5.14 of [TakeutiZaring]
     p. 20. $)
  dfnul2 $p |- (/) = { x | -. x = x } $=
    vx cv vx cv wceq wn vx c0 vx cv c0 wcel vx cv cvv cvv cdif wcel vx cv cvv
    wcel vx cv cvv wcel wn wa vx cv vx cv wceq wn c0 cvv cvv cdif vx cv df-nul
    eleq2i vx cv cvv cvv eldif vx cv vx cv wceq vx cv cvv wcel vx cv cvv wcel
    wn wa vx cv vx cv wceq vx cv cvv wcel vx cv cvv wcel wn wa wn vx cv eqid vx
    cv cvv wcel pm3.24 2th con2bii 3bitri abbi2i $.
    $( [26-Dec-1996] $)

  $( Alternate definition of the empty set.. $)
  dfnul3 $p |- (/) = { x e. A | -. x e. A } $=
    vx cv vx cv wceq wn vx cab vx cv cA wcel vx cv cA wcel wn wa vx cab c0 vx
    cv cA wcel wn vx cA crab vx cv vx cv wceq wn vx cv cA wcel vx cv cA wcel wn
    wa vx vx cv cA wcel vx cv cA wcel wn wa vx cv vx cv wceq vx cv cA wcel vx
    cv cA wcel wn wa wn vx cv vx cv wceq vx cv cA wcel pm3.24 vx cv eqid 2th
    con1bii abbii vx dfnul2 vx cv cA wcel wn vx cA df-rab 3eqtr4i $.
    $( [26-Mar-2004] $) $( [25-Mar-2004] $)

  ${
    $d A x $.
    $( The empty set has no elements.  Theorem 6.14 of [Quine] p. 44. $)
    noel $p |- -. A e. (/) $=
      cA cvv wcel cA c0 wcel wn cA c0 wcel wn vx cA cvv vx cv cA wceq vx cv c0
      wcel cA c0 wcel vx cv vx cv wceq vx cv c0 wcel wn vx cv eqid vx cv c0
      wcel vx cv vx cv wceq vx cv vx cv wceq wn vx c0 vx dfnul2 abeq2i con2bii
      mpbi vx cv cA c0 eleq1 mtbii vtocleg cA c0 wcel cA cvv wcel cA c0 elisset
      con3i pm2.61i $.
      $( [5-Aug-1993] $)
  $}

  $( If a set has elements, it is not empty. $)
  n0i $p |- ( B e. A -> -. A = (/) ) $=
    cA c0 wceq cB cA wcel cA c0 wceq cB cA wcel cB c0 wcel cB noel cA c0 cB
    eleq2 mtbiri con2i $.
    $( [31-Dec-1993] $)

  $( If a set has elements, it is not empty. $)
  ne0i $p |- ( B e. A -> A =/= (/) ) $=
    cB cA wcel cA c0 wceq wn cA c0 wne cA cB n0i cA c0 df-ne sylibr $.
    $( [31-Dec-1993] $)

  $( The universal class is not equal to the empty set. $)
  vn0 $p |- _V =/= (/) $=
    vx cv cvv wcel cvv c0 wne vx visset cvv vx cv ne0i ax-mp $.
    $( [11-Sep-2008] $) $( [11-Sep-2008] $)

  ${
    $d x y $.  $d y A $.
    ne0f.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( A nonempty class has at least one element.  Proposition 5.17(1) of
       [TakeutiZaring] p. 20.  This version of ~ n0 requires only that
       ` x ` not be free in, rather than not occur in, ` A ` . $)
    ne0f $p |- ( A =/= (/) <-> E. x x e. A ) $=
      cA c0 wceq wn vx cv cA wcel wn vx wal wn cA c0 wne vx cv cA wcel vx wex
      cA c0 wceq vx cv cA wcel wn vx wal cA c0 wceq vx cv cA wcel vx cv c0 wcel
      wb vx wal vx cv cA wcel wn vx wal vx vy cA c0 ne0f.1 vy cv c0 wcel vx
      ax-17 cleqf vx cv cA wcel wn vx cv cA wcel vx cv c0 wcel wb vx vx cv c0
      wcel vx cv cA wcel vx cv noel nbn albii bitr4i notbii cA c0 df-ne vx cv
      cA wcel vx df-ex 3bitr4i $.
      $( [2-Apr-2007] $) $( [17-Oct-2003] $)
  $}

  ${
    $d x y A $.
    $( A nonempty class has at least one element.  Proposition 5.17(1) of
       [TakeutiZaring] p. 20. $)
    n0 $p |- ( A =/= (/) <-> E. x x e. A ) $=
      vx vy cA vy cv cA wcel vx ax-17 ne0f $.
      $( [30-Sep-2006] $) $( [29-Sep-2006] $)

    $( A nonempty class has at least one element.  Proposition 5.17(1) of
       [TakeutiZaring] p. 20. $)
    neq0 $p |- ( -. A = (/) <-> E. x x e. A ) $=
      cA c0 wceq wn cA c0 wne vx cv cA wcel vx wex cA c0 df-ne vx cA n0 bitr3i
      $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( Nonempty class abstraction. $)
    abn0 $p |- ( { x | ph } =/= (/) <-> E. x ph ) $=
      wph vx cab c0 wne vy cv wph vx cab wcel vy wex vx cv wph vx cab wcel vx
      wex wph vx wex vy wph vx cab n0 vy cv wph vx cab wcel vx cv wph vx cab
      wcel vy vx wph vx vy hbab1 vx cv wph vx cab wcel vy ax-17 vy cv vx cv wph
      vx cab eleq1 cbvex vx cv wph vx cab wcel wph vx wph vx abid exbii 3bitri
      $.
      $( [21-Feb-2007] $) $( [26-Dec-1996] $)
  $}

  $( Vacuous existential quantification is false. $)
  rex0 $p |- -. E. x e. (/) ph $=
    wph vx c0 vx cv c0 wcel wph wn vx cv noel pm2.21i nrex $.
    $( [16-Oct-2003] $) $( [15-Oct-2003] $)

  $( Non-empty restricted class abstraction. $)
  rabn0 $p |- ( { x e. A | ph } =/= (/) <-> E. x e. A ph ) $=
    vx cv cA wcel wph wa vx cab c0 wne vx cv cA wcel wph wa vx wex wph vx cA
    crab c0 wne wph vx cA wrex vx cv cA wcel wph wa vx abn0 wph vx cA crab vx
    cv cA wcel wph wa vx cab c0 wph vx cA df-rab neeq1i wph vx cA df-rex
    3bitr4i $.
    $( [24-Feb-2007] $) $( [29-Aug-1999] $)

  $( Any restricted class abstraction restricted to the empty set is empty. $)
  rab0 $p |- { x e. (/) | ph } = (/) $=
    vx cv c0 wcel wph wa vx wex wn wph vx c0 crab c0 wceq vx cv c0 wcel wph wa
    vx vx cv c0 wcel wph vx cv noel intnanr nex vx cv c0 wcel wph wa vx wex wph
    vx c0 crab c0 wph vx c0 crab c0 wne wph vx c0 wrex vx cv c0 wcel wph wa vx
    wex wph vx c0 rabn0 wph vx c0 df-rex bitri necon1bbii mpbi $.
    $( [16-Oct-2003] $) $( [15-Oct-2003] $)

  ${
    $d x A $.
    $( The empty set has no elements.  Theorem 2 of [Suppes] p. 22. $)
    eq0 $p |- ( A = (/) <-> A. x -. x e. A ) $=
      cA c0 wceq vx cv cA wcel wn vx wal cA c0 wceq wn vx cv cA wcel vx wex vx
      cv cA wcel wn vx wal wn vx cA neq0 vx cv cA wcel vx df-ex bitri con4bii
      $.
      $( [29-Aug-1993] $)

    $( The universe contains every set. $)
    eqv $p |- ( A = _V <-> A. x x e. A ) $=
      cA cvv wceq vx cv cA wcel vx cv cvv wcel wb vx wal vx cv cA wcel vx wal
      vx cA cvv dfcleq vx cv cA wcel vx cv cA wcel vx cv cvv wcel wb vx vx cv
      cvv wcel vx cv cA wcel vx visset tbt albii bitr4i $.
      $( [4-Oct-2006] $) $( [11-Sep-2006] $)
  $}

  ${
    $d x A $.  $d x y $.
    $( Membership of the empty set in another class. $)
    0el $p |- ( (/) e. A <-> E. x e. A A. y -. y e. x ) $=
      c0 cA wcel vx cv c0 wceq vx cA wrex vy cv vx cv wcel wn vy wal vx cA wrex
      vx c0 cA risset vx cv c0 wceq vy cv vx cv wcel wn vy wal vx cA vy vx cv
      eq0 rexbii bitri $.
      $( [30-Jun-2004] $) $( [29-Jun-2004] $)
  $}

  ${
    $d x A $.
    $( The union of a class with the empty set is itself.  Theorem 24 of
       [Suppes] p. 27. $)
    un0 $p |- ( A u. (/) ) = A $=
      vx cA c0 cA vx cv cA wcel vx cv cA wcel vx cv c0 wcel wo vx cv c0 wcel vx
      cv cA wcel vx cv noel biorfi bicomi uneqri $.
      $( [5-Aug-1993] $)

    $( The intersection of a class with the empty set is the empty set.
       Theorem 16 of [Suppes] p. 26. $)
    in0 $p |- ( A i^i (/) ) = (/) $=
      vx cA c0 c0 vx cv c0 wcel vx cv cA wcel vx cv c0 wcel wa vx cv c0 wcel vx
      cv cA wcel vx cv noel bianfi bicomi ineqri $.
      $( [5-Aug-1993] $)
  $}

  $( The intersection of a class with the universal class is itself.  Exercise
     4.10(k) of [Mendelson] p. 231. $)
  inv1 $p |- ( A i^i _V ) = A $=
    cA cvv cin cA cA cvv inss1 cA cA cvv cA ssid cA ssv ssini eqssi $.
    $( [17-May-1998] $)

  $( The union of a class with the universal class is the universal class.
     Exercise 4.10(l) of [Mendelson] p. 231. $)
  unv $p |- ( A u. _V ) = _V $=
    cA cvv cun cvv cA cvv cun ssv cvv cA ssun2 eqssi $.
    $( [17-May-1998] $)

  ${
    $d A x $.
    $( The null set is a subset of any class.  Part of Exercise 1 of
       [TakeutiZaring] p. 22. $)
    0ss $p |- (/) C_ A $=
      vx c0 cA vx cv c0 wcel vx cv cA wcel vx cv noel pm2.21i ssriv $.
      $( [5-Aug-1993] $)
  $}

  $( Any subset of the empty set is empty.  Theorem 5 of [Suppes] p. 23 and its
     converse. $)
  ss0b $p |- ( A C_ (/) <-> A = (/) ) $=
    cA c0 wceq cA c0 wss cA c0 wceq cA c0 wss c0 cA wss cA c0 eqss cA 0ss
    mpbiran2 bicomi $.
    $( [17-Sep-2003] $)

  $( Any subset of the empty set is empty.  Theorem 5 of [Suppes] p. 23. $)
  ss0 $p |- ( A C_ (/) -> A = (/) ) $=
    cA c0 wss cA c0 wceq cA ss0b biimpi $.
    $( [13-Aug-1994] $)

  $( A subclass of an empty class is empty. $)
  sseq0 $p |- ( ( A C_ B /\ B = (/) ) -> A = (/) ) $=
    cA cB wss cB c0 wceq wa cA c0 wss cA c0 wceq cB c0 wceq cA cB wss cA c0 wss
    cB c0 cA sseq2 biimpac cA ss0b sylib $.
    $( [8-Mar-2007] $) $( [7-Mar-2007] $)

  $( A class with a nonempty subclass is nonempty. $)
  ssn0 $p |- ( ( A C_ B /\ A =/= (/) ) -> B =/= (/) ) $=
    cA cB wss cA c0 wne cB c0 wne cA cB wss cB c0 cA c0 cA cB wss cB c0 wceq cA
    c0 wceq cA cB sseq0 ex necon3d imp $.
    $( [27-Feb-2007] $) $( [17-Feb-2007] $)

  $( Two classes are empty iff their union is empty. $)
  un00 $p |- ( ( A = (/) /\ B = (/) ) <-> ( A u. B ) = (/) ) $=
    cA c0 wceq cB c0 wceq wa cA cB cun c0 wceq cA c0 wceq cB c0 wceq wa cA cB
    cun c0 c0 cun c0 cA c0 cB c0 uneq12 c0 un0 syl6eq cA cB cun c0 wceq cA c0
    wceq cB c0 wceq cA cB cun c0 wceq cA c0 wss cA c0 wceq cA cB cun c0 wceq cA
    cA cB cun wss cA c0 wss cA cB ssun1 cA cB cun c0 cA sseq2 mpbii cA ss0b
    sylib cA cB cun c0 wceq cB c0 wss cB c0 wceq cA cB cun c0 wceq cB cA cB cun
    wss cB c0 wss cB cA ssun2 cA cB cun c0 cB sseq2 mpbii cB ss0b sylib jca
    impbii $.
    $( [12-Aug-2004] $) $( [11-Aug-2004] $)

  $( Only the universal class has the universal class as a subclass. $)
  vss $p |- ( _V C_ A <-> A = _V ) $=
    cvv cA wss cA cvv wceq cvv cA wss cA cvv wss cvv cA wss wa cA cvv wceq cvv
    cA wss cA cvv wss cA ssv jctl cA cvv eqss sylibr cvv cA eqimss2 impbii $.
    $( [17-Sep-2003] $)

  $( The null set is a proper subset of any non-empty set. $)
  0pss $p |- ( (/) C. A <-> A =/= (/) ) $=
    c0 cA wpss c0 cA wne cA c0 wne c0 cA wpss c0 cA wss c0 cA wne c0 cA df-pss
    cA 0ss mpbiran c0 cA necom bitri $.
    $( [2-Apr-2007] $) $( [27-Feb-1996] $)

  $( No set is a proper subset of the empty set. $)
  npss0 $p |- -. A C. (/) $=
    cA c0 wpss c0 c0 wceq c0 eqid cA c0 wpss c0 c0 wpss c0 c0 wceq wn cA c0
    wpss c0 c0 wpss cA c0 wpss cA c0 wss cA c0 wceq cA c0 wpss c0 c0 wpss wb cA
    c0 pssss cA ss0 cA c0 c0 psseq1 3syl ibi c0 c0 wpss c0 c0 wne c0 c0 wceq wn
    c0 0pss c0 c0 df-ne bitri sylib mt2 $.
    $( [17-Jun-1998] $)

  $( Any non-universal class is a proper subclass of the universal class. $)
  pssv $p |- ( A C. _V <-> -. A = _V ) $=
    cA cvv wpss cA cvv wss cA cvv wceq wn cA cvv dfpss2 cA ssv mpbiran $.
    $( [17-May-1998] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Two ways of saying that two classes are disjoint (have no members in
       common). $)
    disj $p |- ( ( A i^i B ) = (/) <-> A. x e. A -. x e. B ) $=
      cA cB cin c0 wceq vx cv cA wcel vx cv cB wcel wn wi vx wal vx cv cB wcel
      wn vx cA wral cA cB cin c0 wceq vx cv cA wcel vx cv cB wcel wa vx cab c0
      wceq vx cv cA wcel vx cv cB wcel wa vx cv c0 wcel wb vx wal vx cv cA wcel
      vx cv cB wcel wn wi vx wal cA cB cin vx cv cA wcel vx cv cB wcel wa vx
      cab c0 vx cA cB df-in eqeq1i vx cv cA wcel vx cv cB wcel wa vx c0 abeq1
      vx cv cA wcel vx cv cB wcel wa vx cv c0 wcel wb vx cv cA wcel vx cv cB
      wcel wn wi vx vx cv cA wcel vx cv cB wcel wn wi vx cv cA wcel vx cv cB
      wcel wa wn vx cv cA wcel vx cv cB wcel wa vx cv c0 wcel wb vx cv cA wcel
      vx cv cB wcel imnan vx cv c0 wcel vx cv cA wcel vx cv cB wcel wa vx cv
      noel nbn bitr2i albii 3bitri vx cv cB wcel wn vx cA df-ral bitr4i $.
      $( [17-Feb-2004] $) $( [17-Feb-2004] $)

    $( Two ways of saying that two classes are disjoint (have no members in
       common). $)
    disj1 $p |- ( ( A i^i B ) = (/) <-> A. x ( x e. A -> -. x e. B ) ) $=
      cA cB cin c0 wceq vx cv cB wcel wn vx cA wral vx cv cA wcel vx cv cB wcel
      wn wi vx wal vx cA cB disj vx cv cB wcel wn vx cA df-ral bitri $.
      $( [19-Aug-1993] $)

    $( Two ways of saying that two classes are disjoint, using the complement
       of ` B ` relative to a universe ` C ` . $)
    reldisj $p |- ( A C_ C -> ( ( A i^i B ) = (/) <-> A C_ ( C \ B ) ) ) $=
      cA cC wss vx cv cA wcel vx cv cB wcel wn wi vx wal vx cv cA wcel vx cv cC
      cB cdif wcel wi vx wal cA cB cin c0 wceq cA cC cB cdif wss cA cC wss vx
      cv cA wcel vx cv cB wcel wn wi vx cv cA wcel vx cv cC cB cdif wcel wi vx
      cA cC wss vx cv cA wcel vx cv cB wcel wn wi vx cv cA wcel vx cv cC wcel
      wi vx cv cA wcel vx cv cB wcel wn wi wa vx cv cA wcel vx cv cC cB cdif
      wcel wi cA cC wss vx cv cA wcel vx cv cC wcel wi vx cv cA wcel vx cv cB
      wcel wn wi cA cC vx cv ssel biantrurd vx cv cA wcel vx cv cC wcel wi vx
      cv cA wcel vx cv cB wcel wn wi wa vx cv cA wcel vx cv cC wcel vx cv cB
      wcel wn wa wi vx cv cA wcel vx cv cC cB cdif wcel wi vx cv cA wcel vx cv
      cC wcel vx cv cB wcel wn pm4.76 vx cv cC cB cdif wcel vx cv cC wcel vx cv
      cB wcel wn wa vx cv cA wcel vx cv cC cB eldif imbi2i bitr4i syl6bb albidv
      vx cA cB disj1 vx cA cC cB cdif dfss2 3bitr4g $.
      $( [17-Feb-2007] $) $( [15-Feb-2007] $)

    $( Two ways of saying that two classes are disjoint. $)
    disj3 $p |- ( ( A i^i B ) = (/) <-> A = ( A \ B ) ) $=
      vx cv cA wcel vx cv cB wcel wn wi vx wal vx cv cA wcel vx cv cA cB cdif
      wcel wb vx wal cA cB cin c0 wceq cA cA cB cdif wceq vx cv cA wcel vx cv
      cB wcel wn wi vx cv cA wcel vx cv cA cB cdif wcel wb vx vx cv cA wcel vx
      cv cB wcel wn wi vx cv cA wcel vx cv cA wcel vx cv cB wcel wn wa wb vx cv
      cA wcel vx cv cA cB cdif wcel wb vx cv cA wcel vx cv cB wcel wn pm4.71 vx
      cv cA cB cdif wcel vx cv cA wcel vx cv cB wcel wn wa vx cv cA wcel vx cv
      cA cB eldif bibi2i bitr4i albii vx cA cB disj1 vx cA cA cB cdif dfcleq
      3bitr4i $.
      $( [19-May-1998] $)

    $( Members of disjoint sets are not equal. $)
    disjne $p |- ( ( ( A i^i B ) = (/) /\ C e. A /\ D e. B ) -> C =/= D ) $=
      cA cB cin c0 wceq cC cA wcel cD cB wcel cC cD wne vx cv cB wcel wn vx cA
      wral cC cA wcel cD cB wcel cC cD wne wi cA cB cin c0 wceq cD cB wcel cC
      cB wcel wn cC cD wne vx cv cB wcel wn vx cA wral cC cA wcel wa cD cB wcel
      cC cB wcel wn cC cD wne cD cB wcel cC cB wcel wn wa cD cC cD cB wcel cC
      cB wcel wn wa cD cC wceq wn cD cC wne cD cC cB nelneq cD cC df-ne sylibr
      necomd ex vx cv cB wcel wn cC cB wcel wn vx cC cA vx cv cC wceq vx cv cB
      wcel cC cB wcel vx cv cC cB eleq1 notbid rcla4cva syl5com vx cA cB disj
      sylanb 3impia $.
      $( [30-Mar-2007] $) $( [28-Mar-2007] $)
  $}

  $( Two ways of saying that two classes are disjoint. $)
  disj2 $p |- ( ( A i^i B ) = (/) <-> A C_ ( _V \ B ) ) $=
    cA cvv wss cA cB cin c0 wceq cA cvv cB cdif wss wb cA ssv cA cB cvv reldisj
    ax-mp $.
    $( [17-May-1998] $)

  $( Two ways of saying that two classes are disjoint. $)
  disj4 $p |- ( ( A i^i B ) = (/) <-> -. ( A \ B ) C. A ) $=
    cA cB cin c0 wceq cA cA cB cdif wceq cA cB cdif cA wceq cA cB cdif cA wpss
    wn cA cB disj3 cA cA cB cdif eqcom cA cB cdif cA wpss cA cB cdif cA wceq cA
    cB cdif cA wpss cA cB cdif cA wss cA cB cdif cA wceq wn cA cB cdif cA
    dfpss2 cA cB difss mpbiran con2bii 3bitri $.
    $( [22-Mar-2004] $) $( [21-Mar-2004] $)

  $( Intersection with a subclass of a disjoint class.  (Contributed by FL,
     24-Jan-2007.) $)
  ssdisj $p |- ( ( A C_ B /\ ( B i^i C ) = (/) ) ->  ( A i^i C ) = (/) ) $=
    cA cB wss cB cC cin c0 wceq wa cA cC cin c0 wss cA cC cin c0 wceq cA cB wss
    cB cC cin c0 wceq cA cC cin c0 wss cA cB wss cB cC cin c0 wss cA cC cin c0
    wss cB cC cin c0 wceq cA cB wss cA cC cin cB cC cin wss cB cC cin c0 wss cA
    cC cin c0 wss wi cA cB cC ssrin cA cC cin cB cC cin c0 sstr2 syl cB cC cin
    ss0b syl5ibr imp cA cC cin ss0 syl $.
    $( [25-Jan-2007] $) $( [23-Jan-2007] $)

  $( A class is a proper subset of its union with a disjoint nonempty class. $)
  disjpss $p |- ( ( ( A i^i B ) = (/) /\ B =/= (/) ) -> A C. ( A u. B ) ) $=
    cA cB cin c0 wceq cB c0 wne wa cB cA wss wn cA cA cB cun wpss cA cB cin c0
    wceq cB c0 wne cB cA wss wn cA cB cin c0 wceq cB cA wss cB c0 cA cB cin c0
    wceq cB cA wss cB c0 wss cB c0 wceq cA cB cin c0 wceq cB cA cB cin wss cB
    c0 wss cB cA wss cA cB cin c0 cB sseq2 cB cA wss cB cA wss cB cB wss wa cB
    cA cB cin wss cB cB wss cB cA wss cB ssid biantru cB cA cB ssin bitri
    syl5bb cB ss0 syl6bi necon3ad imp cB cA wss wn cA cB cA cun wpss cA cA cB
    cun wpss cB cA nsspssun cB cA cun cA cB cun cA cB cA uncom psseq2i bitri
    sylib $.
    $( [30-Apr-2007] $) $( [15-Sep-2004] $)

  $( The union of disjoint classes is disjoint. $)
  undisj1 $p |- ( ( ( A i^i C ) = (/) /\ ( B i^i C ) = (/) ) <->
               ( ( A u. B ) i^i C ) = (/) ) $=
    cA cC cin c0 wceq cB cC cin c0 wceq wa cA cC cin cB cC cin cun c0 wceq cA
    cB cun cC cin c0 wceq cA cC cin cB cC cin un00 cA cB cun cC cin cA cC cin
    cB cC cin cun c0 cA cB cC indir eqeq1i bitr4i $.
    $( [26-Oct-2004] $) $( [26-Sep-2004] $)

  $( The union of disjoint classes is disjoint. $)
  undisj2 $p |- ( ( ( A i^i B ) = (/) /\ ( A i^i C ) = (/) ) <->
               ( A i^i ( B u. C ) ) = (/) ) $=
    cA cB cin c0 wceq cA cC cin c0 wceq wa cA cB cin cA cC cin cun c0 wceq cA
    cB cC cun cin c0 wceq cA cB cin cA cC cin un00 cA cB cC cun cin cA cB cin
    cA cC cin cun c0 cA cB cC indi eqeq1i bitr4i $.
    $( [3-Oct-2004] $) $( [13-Sep-2004] $)

  $( Subclass expressed in terms of intersection with difference from the
     universal class. $)
  ssindif0 $p |- ( A C_ B <-> ( A i^i ( _V \ B ) ) = (/) ) $=
    cA cvv cB cdif cin c0 wceq cA cvv cvv cB cdif cdif wss cA cB wss cA cvv cB
    cdif disj2 cvv cvv cB cdif cdif cB cA cB ddif sseq2i bitr2i $.
    $( [17-Sep-2003] $)

  $( The intersection of classes with a common member is nonempty. $)
  inelcm $p |- ( ( A e. B /\ A e. C ) -> ( B i^i C ) =/= (/) ) $=
    cA cB wcel cA cC wcel wa cA cB cC cin wcel cB cC cin c0 wne cA cB cC elin
    cB cC cin cA ne0i sylbir $.
    $( [2-Apr-2007] $) $( [7-Apr-1994] $)

  $( A minimum element of a class has no elements in common with the class. $)
  minel $p |- ( ( A e. B /\ ( C i^i B ) = (/) ) -> -. A e. C ) $=
    cC cB cin c0 wceq cA cB wcel cA cC wcel wn cC cB cin c0 wceq cA cC wcel cA
    cB wcel cC cB cin c0 wceq cA cC wcel cA cB wcel wa wn cA cC wcel cA cB wcel
    wn wi cA cC wcel cA cB wcel wa cC cB cin c0 cA cC cB inelcm necon2bi cA cC
    wcel cA cB wcel imnan sylibr con2d impcom $.
    $( [22-Jun-1994] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Distribute union over difference. $)
    undif4 $p |- ( ( A i^i C ) = (/) ->
                 ( A u. ( B \ C ) ) = ( ( A u. B ) \ C ) ) $=
      vx cv cA wcel vx cv cC wcel wn wi vx wal vx cv cA cB cC cdif cun wcel vx
      cv cA cB cun cC cdif wcel wb vx wal cA cC cin c0 wceq cA cB cC cdif cun
      cA cB cun cC cdif wceq vx cv cA wcel vx cv cC wcel wn wi vx cv cA cB cC
      cdif cun wcel vx cv cA cB cun cC cdif wcel wb vx vx cv cA wcel vx cv cC
      wcel wn wi vx cv cA wcel vx cv cB cC cdif wcel wo vx cv cA cB cun wcel vx
      cv cC wcel wn wa vx cv cA cB cC cdif cun wcel vx cv cA cB cun cC cdif
      wcel vx cv cA wcel vx cv cC wcel wn wi vx cv cA wcel vx cv cB wcel wo vx
      cv cA wcel vx cv cC wcel wn wo wa vx cv cA wcel vx cv cB wcel wo vx cv cC
      wcel wn wa vx cv cA wcel vx cv cB cC cdif wcel wo vx cv cA cB cun wcel vx
      cv cC wcel wn wa vx cv cA wcel vx cv cC wcel wn wi vx cv cA wcel vx cv cC
      wcel wn wo vx cv cC wcel wn vx cv cA wcel vx cv cB wcel wo vx cv cA wcel
      vx cv cC wcel wn wi vx cv cA wcel wn vx cv cC wcel wn wi vx cv cC wcel wn
      vx cv cA wcel vx cv cC wcel wn wo vx cv cA wcel vx cv cC wcel wn wi vx cv
      cA wcel wn vx cv cC wcel wn wi vx cv cC wcel wn vx cv cA wcel vx cv cC
      wcel wn pm2.61 vx cv cC wcel wn vx cv cA wcel wn ax-1 impbid1 vx cv cA
      wcel vx cv cC wcel wn df-or syl5bb anbi2d vx cv cA wcel vx cv cB cC cdif
      wcel wo vx cv cA wcel vx cv cB wcel vx cv cC wcel wn wa wo vx cv cA wcel
      vx cv cB wcel wo vx cv cA wcel vx cv cC wcel wn wo wa vx cv cB cC cdif
      wcel vx cv cB wcel vx cv cC wcel wn wa vx cv cA wcel vx cv cB cC eldif
      orbi2i vx cv cA wcel vx cv cB wcel vx cv cC wcel wn ordi bitri vx cv cA
      cB cun wcel vx cv cA wcel vx cv cB wcel wo vx cv cC wcel wn vx cv cA cB
      elun anbi1i 3bitr4g vx cv cA cB cC cdif elun vx cv cA cB cun cC eldif
      3bitr4g 19.20i vx cA cC disj1 vx cA cB cC cdif cun cA cB cun cC cdif
      dfcleq 3imtr4i $.
      $( [17-May-1998] $)

    $( Subset relation for disjoint classes. $)
    disjssun $p |- ( ( A i^i B ) = (/) -> ( A C_ ( B u. C ) <-> A C_ C ) ) $=
      cA cB cin c0 wceq vx cv cB cC cun wcel vx cA wral vx cv cC wcel vx cA
      wral cA cB cC cun wss cA cC wss cA cB cin c0 wceq vx cv cB cC cun wcel vx
      cv cC wcel vx cA cA cB cin c0 wceq vx cv cA wcel wa vx cv cC wcel vx cv
      cB wcel vx cv cC wcel wo vx cv cB cC cun wcel cA cB cin c0 wceq vx cv cA
      wcel wa vx cv cB wcel wn vx cv cC wcel vx cv cB wcel vx cv cC wcel wo wb
      cA cB cin c0 wceq vx cv cA wcel vx cv cB wcel wn cA cB cin c0 wceq vx cv
      cA wcel vx cv cB wcel wn wi vx wal vx cv cA wcel vx cv cB wcel wn wi vx
      cA cB disj1 vx cv cA wcel vx cv cB wcel wn wi vx ax-4 sylbi imp vx cv cB
      wcel vx cv cC wcel biorf syl vx cv cB cC elun syl6rbbr ralbidva vx cA cB
      cC cun dfss3 vx cA cC dfss3 3bitr4g $.
      $( [9-Nov-2005] $) $( [25-Oct-2005] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass expressed in terms of difference.  Exercise 7 of
       [TakeutiZaring] p. 22. $)
    ssdif0 $p |- ( A C_ B <-> ( A \ B ) = (/) ) $=
      vx cv cA wcel vx cv cB wcel wi vx wal vx cv cA cB cdif wcel wn vx wal cA
      cB wss cA cB cdif c0 wceq vx cv cA wcel vx cv cB wcel wi vx cv cA cB cdif
      wcel wn vx vx cv cA wcel vx cv cB wcel wi vx cv cA wcel vx cv cB wcel wn
      wa wn vx cv cA cB cdif wcel wn vx cv cA wcel vx cv cB wcel iman vx cv cA
      cB cdif wcel vx cv cA wcel vx cv cB wcel wn wa vx cv cA cB eldif notbii
      bitr4i albii vx cA cB dfss2 vx cA cB cdif eq0 3bitr4i $.
      $( [29-Apr-1994] $)
  $}

  $( Universal class equality in terms of empty difference. $)
  vdif0 $p |- ( A = _V <-> ( _V \ A ) = (/) ) $=
    cA cvv wceq cvv cA wss cvv cA cdif c0 wceq cA vss cvv cA ssdif0 bitr3i $.
    $( [17-Sep-2003] $)

  $( A proper subclass has a nonempty difference. $)
  pssdifn0 $p |- ( ( A C_ B /\ A =/= B ) -> ( B \ A ) =/= (/) ) $=
    cA cB wss cA cB wne cB cA cdif c0 wne cA cB wss cB cA cdif c0 cA cB cA cB
    wss cB cA wss cA cB wceq cB cA cdif c0 wceq cA cB wss cB cA wss cA cB wceq
    cA cB wceq cA cB wss cB cA wss wa cA cB eqss biimpri ex cB cA ssdif0
    syl5ibr necon3d imp $.
    $( [3-Apr-2007] $) $( [3-May-1994] $)

  $( A subclass missing a member is a proper subclass. $)
  ssnelpss $p |- ( A C_ B -> ( ( C e. B /\ -. C e. A ) -> A C. B ) ) $=
    cA cB wss cA cB wceq wn cA cB wpss cC cB wcel cC cA wcel wn wa cA cB wpss
    cA cB wss cA cB wceq wn cA cB dfpss2 baibr cC cB wcel cC cA wcel wn wa cB
    cA wceq wn cA cB wceq wn cC cB cA nelneq2 cB cA wceq cA cB wceq cB cA eqcom
    notbii sylib syl5bi $.
    $( [12-Jan-2002] $)

  ${
    $d x A $.  $d x B $.
    $( A proper subclass has a member in one argument that's not in both. $)
    pssnel $p |- ( A C. B -> E. x ( x e. B /\ -. x e. A ) ) $=
      cA cB wpss vx cv cB cA cdif wcel vx wex vx cv cB wcel vx cv cA wcel wn wa
      vx wex cA cB wpss cB cA cdif c0 wne vx cv cB cA cdif wcel vx wex cA cB
      wpss cA cB wss cA cB wne wa cB cA cdif c0 wne cA cB df-pss cA cB pssdifn0
      sylbi vx cB cA cdif n0 sylib vx cv cB cA cdif wcel vx cv cB wcel vx cv cA
      wcel wn wa vx vx cv cB cA eldif exbii sylib $.
      $( [29-Feb-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Difference, intersection, and subclass relationship. $)
    difin0ss $p |- ( ( ( A \ B ) i^i C ) = (/) -> ( C C_ A -> C C_ B ) ) $=
      cA cB cdif cC cin c0 wceq vx cv cC wcel vx cv cA wcel wi vx wal vx cv cC
      wcel vx cv cB wcel wi vx wal cC cA wss cC cB wss cA cB cdif cC cin c0
      wceq vx cv cA cB cdif cC cin wcel wn vx wal vx cv cC wcel vx cv cA wcel
      wi vx wal vx cv cC wcel vx cv cB wcel wi vx wal wi vx cA cB cdif cC cin
      eq0 vx cv cA cB cdif cC cin wcel wn vx cv cC wcel vx cv cA wcel wi vx cv
      cC wcel vx cv cB wcel wi vx vx cv cA cB cdif cC cin wcel wn vx cv cC wcel
      vx cv cA wcel vx cv cB wcel wi wi vx cv cC wcel vx cv cA wcel wi vx cv cC
      wcel vx cv cB wcel wi wi vx cv cC wcel vx cv cA wcel vx cv cB wcel wi wn
      wa wn vx cv cA wcel vx cv cB wcel wn wa vx cv cC wcel wa wn vx cv cC wcel
      vx cv cA wcel vx cv cB wcel wi wi vx cv cA cB cdif cC cin wcel wn vx cv
      cC wcel vx cv cA wcel vx cv cB wcel wi wn wa vx cv cA wcel vx cv cB wcel
      wn wa vx cv cC wcel wa vx cv cC wcel vx cv cA wcel vx cv cB wcel wi wn wa
      vx cv cC wcel vx cv cA wcel vx cv cB wcel wn wa wa vx cv cA wcel vx cv cB
      wcel wn wa vx cv cC wcel wa vx cv cA wcel vx cv cB wcel wn wa vx cv cA
      wcel vx cv cB wcel wi wn vx cv cC wcel vx cv cA wcel vx cv cB wcel annim
      anbi2i vx cv cC wcel vx cv cA wcel vx cv cB wcel wn wa ancom bitr3i
      notbii vx cv cC wcel vx cv cA wcel vx cv cB wcel wi iman vx cv cA cB cdif
      cC cin wcel vx cv cA wcel vx cv cB wcel wn wa vx cv cC wcel wa vx cv cA
      cB cdif cC cin wcel vx cv cA cB cdif wcel vx cv cC wcel wa vx cv cA wcel
      vx cv cB wcel wn wa vx cv cC wcel wa vx cv cA cB cdif cC elin vx cv cA cB
      cdif wcel vx cv cA wcel vx cv cB wcel wn wa vx cv cC wcel vx cv cA cB
      eldif anbi1i bitri notbii 3bitr4i vx cv cC wcel vx cv cA wcel vx cv cB
      wcel ax-2 sylbir 19.20ii sylbi vx cC cA dfss2 vx cC cB dfss2 3imtr4g $.
      $( [30-Apr-1994] $)

    $( Intersection, subclass, and difference relationship. $)
    inssdif0 $p |- ( ( A i^i B ) C_ C <-> ( A i^i ( B \ C ) ) = (/) ) $=
      vx cv cA cB cin wcel vx cv cC wcel wi vx wal vx cv cA cB cC cdif cin wcel
      wn vx wal cA cB cin cC wss cA cB cC cdif cin c0 wceq vx cv cA cB cin wcel
      vx cv cC wcel wi vx cv cA cB cC cdif cin wcel wn vx vx cv cA wcel vx cv
      cB wcel wa vx cv cC wcel wi vx cv cA wcel vx cv cB wcel vx cv cC wcel wn
      wa wa wn vx cv cA cB cin wcel vx cv cC wcel wi vx cv cA cB cC cdif cin
      wcel wn vx cv cA wcel vx cv cB wcel wa vx cv cC wcel wi vx cv cA wcel vx
      cv cB wcel vx cv cC wcel wi wi vx cv cA wcel vx cv cB wcel vx cv cC wcel
      wn wa wn wi vx cv cA wcel vx cv cB wcel vx cv cC wcel wn wa wa wn vx cv
      cA wcel vx cv cB wcel vx cv cC wcel impexp vx cv cB wcel vx cv cC wcel wi
      vx cv cB wcel vx cv cC wcel wn wa wn vx cv cA wcel vx cv cB wcel vx cv cC
      wcel iman imbi2i vx cv cA wcel vx cv cB wcel vx cv cC wcel wn wa imnan
      3bitri vx cv cA cB cin wcel vx cv cA wcel vx cv cB wcel wa vx cv cC wcel
      vx cv cA cB elin imbi1i vx cv cA cB cC cdif cin wcel vx cv cA wcel vx cv
      cB wcel vx cv cC wcel wn wa wa vx cv cA cB cC cdif cin wcel vx cv cA wcel
      vx cv cB cC cdif wcel wa vx cv cA wcel vx cv cB wcel vx cv cC wcel wn wa
      wa vx cv cA cB cC cdif elin vx cv cB cC cdif wcel vx cv cB wcel vx cv cC
      wcel wn wa vx cv cA wcel vx cv cB cC eldif anbi2i bitri notbii 3bitr4i
      albii vx cA cB cin cC dfss2 vx cA cB cC cdif cin eq0 3bitr4i $.
      $( [27-Oct-1996] $)
  $}

  $( The difference between a class and itself is the empty set.  Proposition
     5.15 of [TakeutiZaring] p. 20.  Also Theorem 32 of [Suppes] p. 28. $)
  difid $p |- ( A \ A ) = (/) $=
    cA cA wss cA cA cdif c0 wceq cA ssid cA cA ssdif0 mpbi $.
    $( [13-May-2004] $) $( [22-Apr-2004] $)

  $( The difference between a class and the empty set.  Part of Exercise 4.4 of
     [Stoll] p. 16. $)
  dif0 $p |- ( A \ (/) ) = A $=
    cA cA cA cdif cdif cA c0 cdif cA cA cA cdif c0 cA cA difid difeq2i cA cA
    difdif eqtr3i $.
    $( [18-Aug-2004] $) $( [17-Aug-2004] $)

  $( The difference between the empty set and a class.  Part of Exercise 4.4 of
     [Stoll] p. 16. $)
  0dif $p |- ( (/) \ A ) = (/) $=
    c0 cA cdif c0 wss c0 cA cdif c0 wceq c0 cA difss c0 cA cdif ss0 ax-mp $.
    $( [8-Sep-2004] $) $( [17-Aug-2004] $)

  $( A class and its relative complement are disjoint.  Theorem 38 of [Suppes]
     p. 29. $)
  difdisj $p |- ( A i^i ( B \ A ) ) = (/) $=
    cA cB cin cA wss cA cB cA cdif cin c0 wceq cA cB inss1 cA cB cA inssdif0
    mpbi $.
    $( [24-Mar-1998] $)

  $( The difference of a class from its intersection is empty.  Theorem 37 of
     [Suppes] p. 29. $)
  difin0 $p |- ( ( A i^i B ) \ B ) = (/) $=
    cA cB cin cB cdif cA cB cdif cB cB cdif cin cA cB cdif c0 cin c0 cA cB cB
    difindir cB cB cdif c0 cA cB cdif cB difid ineq2i cA cB cdif in0 3eqtri $.
    $( [29-Oct-2004] $) $( [17-Aug-2004] $)

  $( The union of a class and its complement is the universe.  Theorem 5.1(5)
     of [Stoll] p. 17. $)
  undifv $p |- ( A u. ( _V \ A ) ) = _V $=
    cA cvv cA cdif cun cvv cvv cA cdif cvv cvv cA cdif cdif cin cdif cvv c0
    cdif cvv cA cvv cA cdif dfun3 cvv cA cdif cvv cvv cA cdif cdif cin c0 cvv
    cvv cA cdif cvv difdisj difeq2i cvv dif0 3eqtri $.
    $( [18-Aug-2004] $) $( [17-Aug-2004] $)

  $( Absorption of difference by union.  This decomposes a union into two
     disjoint classes (see ~ difdisj ).  Theorem 35 of [Suppes] p. 29. $)
  undif1 $p |- ( ( A \ B ) u. B ) = ( A u. B ) $=
    cA cvv cB cdif cin cB cun cA cB cdif cB cun cA cB cun cA cvv cB cdif cin cA
    cB cdif cB cA cB invdif uneq1i cA cvv cB cdif cin cB cun cA cB cun cvv cB
    cdif cB cun cin cA cB cun cvv cin cA cB cun cA cvv cB cdif cB undir cvv cB
    cdif cB cun cvv cA cB cun cvv cB cdif cB cun cB cvv cB cdif cun cvv cvv cB
    cdif cB uncom cB undifv eqtri ineq2i cA cB cun inv1 3eqtri eqtr3i $.
    $( [18-Aug-2004] $) $( [19-May-1998] $)

  $( Absorption of difference by union.  This decomposes a union into two
     disjoint classes (see ~ difdisj ).  Part of proof of Corollary 6K of
     [Enderton] p. 144. $)
  undif2 $p |- ( A u. ( B \ A ) ) = ( A u. B ) $=
    cA cB cA cdif cun cB cA cdif cA cun cB cA cun cA cB cun cA cB cA cdif uncom
    cB cA undif1 cB cA uncom 3eqtri $.
    $( [4-Sep-2004] $) $( [19-May-1998] $)

  $( The intersection and class difference of a class with another class unite
     to give the original class. (Contributed by Paul Chapman, 5-Jun-2009.) $)
  inundif $p |- ( ( A i^i B ) u. ( A \ B ) ) = A $=
    cA cB cin cA cB cdif cun cA cA cB cdif cun cB cA cB cdif cun cin cA cA cB
    cun cin cA cA cB cA cB cdif undir cA cA cB cdif cun cA cB cA cB cdif cun cA
    cB cun cA cB cdif cA wss cA cA cB cdif cun cA wceq cA cB difss cA cB cdif
    cA ssequn2 mpbi cB cA cB cdif cun cB cA cun cA cB cun cB cA undif2 cB cA
    uncom eqtri ineq12i cA cB inabs 3eqtri $.
    $( [6-Jun-2009] $) $( [5-Jun-2009] $)

  $( Absorption of union by difference.  Theorem 36 of [Suppes] p. 29. $)
  difun2 $p |- ( ( A u. B ) \ B ) = ( A \ B ) $=
    cA cB cun cB cdif cA cB cdif cB cB cdif cun cA cB cdif c0 cun cA cB cdif cA
    cB cB difundir cB cB cdif c0 cA cB cdif cB difid uneq2i cA cB cdif un0
    3eqtri $.
    $( [18-Aug-2004] $) $( [19-May-1998] $)

  $( Union of complementary parts into whole. $)
  undif $p |- ( A C_ B <-> ( A u. ( B \ A ) ) = B ) $=
    cA cB wss cA cB cun cB wceq cA cB cA cdif cun cB wceq cA cB ssequn1 cA cB
    cA cdif cun cA cB cun cB cA cB undif2 eqeq1i bitr4i $.
    $( [22-Sep-2004] $) $( [22-Mar-1998] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( A condition equivalent to inclusion in the union of two classes. $)
    ssundif $p |- ( A C_ ( B u. C ) <-> ( A \ B ) C_ C ) $=
      vx cv cA wcel vx cv cB cC cun wcel wi vx wal vx cv cA cB cdif wcel vx cv
      cC wcel wi vx wal cA cB cC cun wss cA cB cdif cC wss vx cv cA wcel vx cv
      cB cC cun wcel wi vx cv cA cB cdif wcel vx cv cC wcel wi vx vx cv cA wcel
      vx cv cB wcel wn wa vx cv cC wcel wi vx cv cA wcel vx cv cB wcel vx cv cC
      wcel wo wi vx cv cA cB cdif wcel vx cv cC wcel wi vx cv cA wcel vx cv cB
      cC cun wcel wi vx cv cA wcel vx cv cB wcel vx cv cC wcel pm5.6 vx cv cA
      cB cdif wcel vx cv cA wcel vx cv cB wcel wn wa vx cv cC wcel vx cv cA cB
      eldif imbi1i vx cv cB cC cun wcel vx cv cB wcel vx cv cC wcel wo vx cv cA
      wcel vx cv cB cC elun imbi2i 3bitr4ri albii vx cA cB cC cun dfss2 vx cA
      cB cdif cC dfss2 3bitr4i $.
      $( [29-Mar-2007] $) $( [26-Mar-2007] $)
  $}

  $( Swap the arguments of a class difference. $)
  difcom $p |- ( ( A \ B ) C_ C <-> ( A \ C ) C_ B ) $=
    cA cB cC cun wss cA cC cB cun wss cA cB cdif cC wss cA cC cdif cB wss cB cC
    cun cC cB cun cA cB cC uncom sseq2i cA cB cC ssundif cA cC cB ssundif
    3bitr3i $.
    $( [3-May-2007] $) $( [29-Mar-2007] $)

  $( Distributive law for class difference.  Exercise 4.8 of [Stoll] p. 16. $)
  difdifdir $p |- ( ( A \ B ) \ C ) = ( ( A \ C ) \ ( B \ C ) ) $=
    cA cB cdif cC cdif cA cC cdif cvv cB cdif cC cun cin cA cC cdif cvv cB cC
    cdif cdif cin cA cC cdif cB cC cdif cdif cA cC cdif cvv cB cdif cin c0 cun
    cA cC cdif cvv cB cdif cin cA cC cdif cC cin cun cA cB cdif cC cdif cA cC
    cdif cvv cB cdif cC cun cin c0 cA cC cdif cC cin cA cC cdif cvv cB cdif cin
    cC cA cC cdif cin c0 cA cC cdif cC cin cC cA difdisj cC cA cC cdif incom
    eqtr3i uneq2i cA cC cdif cvv cB cdif cin cA cC cdif cB cdif cA cC cdif cvv
    cB cdif cin c0 cun cA cB cdif cC cdif cA cC cdif cB invdif cA cC cdif cvv
    cB cdif cin un0 cA cB cC dif23 3eqtr4ri cA cC cdif cvv cB cdif cC indi
    3eqtr4i cvv cB cdif cC cun cvv cB cC cdif cdif cA cC cdif cvv cB cvv cC
    cdif cin cdif cvv cB cdif cvv cvv cC cdif cdif cun cvv cB cC cdif cdif cvv
    cB cdif cC cun cB cvv cC cdif indm cB cvv cC cdif cin cB cC cdif cvv cB cC
    invdif difeq2i cvv cvv cC cdif cdif cC cvv cB cdif cC ddif uneq2i 3eqtr3ri
    ineq2i cA cC cdif cB cC cdif invdif 3eqtri $.
    $( [29-Oct-2004] $) $( [18-Aug-2004] $)

  ${
    $d x A $.
    $( Theorem 19.2 of [Margaris] p. 89 with restricted quantifiers (compare
       ~ 19.2 ).  The restricted version is valid only when the domain of
       quantification is not empty. $)
    r19.2z $p |- ( ( A =/= (/) /\ A. x e. A ph ) -> E. x e. A ph ) $=
      wph vx cA wral cA c0 wne wph vx cA wrex wph vx cA wral vx cv cA wcel vx
      wex vx cv cA wcel wph wa vx wex cA c0 wne wph vx cA wrex wph vx cA wral
      vx cv cA wcel wph wi vx wal vx cv cA wcel vx wex vx cv cA wcel wph wa vx
      wex wi wph vx cA df-ral vx cv cA wcel wph vx exintr sylbi vx cA n0 wph vx
      cA df-rex 3imtr4g impcom $.
      $( [9-Dec-2006] $) $( [15-Nov-2003] $)
  $}

  ${
    $d x A $.
    r19.3rz.1 $e |- ( ph -> A. x ph ) $.
  $}

  ${
    $d x A $.  $d x ph $.
    $( Restricted quantification of wff not containing quantified variable. $)
    r19.3rzv $p |- ( A =/= (/) -> ( ph <-> A. x e. A ph ) ) $=
      cA c0 wne wph vx cv cA wcel vx wex wph wi wph vx cA wral cA c0 wne vx cv
      cA wcel vx wex wph vx cv cA wcel vx wex wph wi wb vx cA n0 vx cv cA wcel
      vx wex wph biimt sylbi wph vx cA wral vx cv cA wcel wph wi vx wal vx cv
      cA wcel vx wex wph wi wph vx cA df-ral vx cv cA wcel wph vx 19.23v bitri
      syl6bbr $.
      $( [5-Oct-2006] $) $( [10-Mar-1997] $)

    $( Restricted quantification of wff not containing quantified variable. $)
    r19.9rzv $p |- ( A =/= (/) -> ( ph <-> E. x e. A ph ) ) $=
      cA c0 wne wph wph wn vx cA wral wn wph vx cA wrex cA c0 wne wph wn vx cA
      wral wph cA c0 wne wph wn wph wn vx cA wral wph wn vx cA r19.3rzv bicomd
      con2bid wph vx cA dfrex2 syl6bbr $.
      $( [10-Oct-2006] $) $( [27-May-1998] $)

    $( Restricted quantifier version of Theorem 19.28 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty. $)
    r19.28zv $p |- ( A =/= (/) ->
                   ( A. x e. A ( ph /\ ps ) <-> ( ph /\ A. x e. A ps ) ) ) $=
      cA c0 wne wph wps vx cA wral wa wph vx cA wral wps vx cA wral wa wph wps
      wa vx cA wral cA c0 wne wph wph vx cA wral wps vx cA wral wph vx cA
      r19.3rzv anbi1d wph wps vx cA r19.26 syl6rbbr $.
      $( [5-Oct-2006] $) $( [19-Aug-2004] $)

    $( Restricted quantifier version of Theorem 19.37 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by Paul Chapman, 8-Oct-2007.) $)
    r19.37zv $p |- ( A =/= (/) ->
                   ( E. x e. A ( ph -> ps ) <-> ( ph -> E. x e. A ps ) ) ) $=
      cA c0 wne wph wps vx cA wrex wi wph vx cA wral wps vx cA wrex wi wph wps
      wi vx cA wrex cA c0 wne wph wph vx cA wral wps vx cA wrex wph vx cA
      r19.3rzv imbi1d wph wps vx cA r19.35 syl6rbbr $.
      $( [8-Oct-2007] $) $( [8-Oct-2007] $)

    $( Restricted version of Theorem 19.45 of [Margaris] p. 90. $)
    r19.45zv $p |- ( A =/= (/) ->
                   ( E. x e. A ( ph \/ ps ) <-> ( ph \/ E. x e. A ps ) ) ) $=
      cA c0 wne wph wps vx cA wrex wo wph vx cA wrex wps vx cA wrex wo wph wps
      wo vx cA wrex cA c0 wne wph wph vx cA wrex wps vx cA wrex wph vx cA
      r19.9rzv orbi1d wph wps vx cA r19.43 syl6rbbr $.
      $( [10-Oct-2006] $) $( [27-May-1998] $)
  $}

  ${
    $d x A $.
    r19.27z.1 $e |- ( ps -> A. x ps ) $.
  $}

  ${
    $d x A $.  $d x ps $.
    $( Restricted quantifier version of Theorem 19.27 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty. $)
    r19.27zv $p |- ( A =/= (/) ->
                   ( A. x e. A ( ph /\ ps ) <-> ( A. x e. A ph /\ ps ) ) ) $=
      cA c0 wne wph vx cA wral wps wa wph vx cA wral wps vx cA wral wa wph wps
      wa vx cA wral cA c0 wne wps wps vx cA wral wph vx cA wral wps vx cA
      r19.3rzv anbi2d wph wps vx cA r19.26 syl6rbbr $.
      $( [12-Oct-2006] $) $( [19-Aug-2004] $)

    $( Restricted quantifier version of Theorem 19.36 of [Margaris] p. 90.
       It is valid only when the domain of quantification is not empty. $)
    r19.36zv $p |- ( A =/= (/) ->
                   ( E. x e. A ( ph -> ps ) <-> ( A. x e. A ph -> ps ) ) ) $=
      cA c0 wne wph vx cA wral wps wi wph vx cA wral wps vx cA wrex wi wph wps
      wi vx cA wrex cA c0 wne wps wps vx cA wrex wph vx cA wral wps vx cA
      r19.9rzv imbi2d wph wps vx cA r19.35 syl6rbbr $.
      $( [13-Oct-2006] $) $( [20-Sep-2003] $)
  $}

  ${
    $d x A $.
    $( Vacuous quantification is always true. $)
    rzal $p |- ( A = (/) -> A. x e. A ph ) $=
      cA c0 wceq wph vx cA cA c0 wceq vx cv cA wcel vx cv c0 wcel wph cA c0 vx
      cv eleq2 vx cv c0 wcel wph vx cv noel pm2.21i syl6bi r19.21aiv $.
      $( [11-Mar-1997] $)

    $( Restricted existential quantification implies its restriction is
       nonempty.  (Contributed by Szymon Jaroszewicz, 3-Apr-2007.) $)
    rexn0 $p |- ( E. x e. A ph -> A =/= (/) ) $=
      wph cA c0 wne vx cA vx cv cA wcel cA c0 wne wph cA vx cv ne0i a1d
      r19.23aiv $.
      $( [3-Apr-2007] $) $( [1-Mar-2007] $)

    $( Idempotent law for restricted quantifier. $)
    ralidm $p |- ( A. x e. A A. x e. A ph <-> A. x e. A ph ) $=
      cA c0 wceq wph vx cA wral vx cA wral wph vx cA wral wb wph vx cA wral vx
      cA wral wph vx cA wral wph vx cA wral vx cA wral wph vx cA wral wb cA c0
      wceq wph vx cA wral vx cA wral wph vx cA wral pm5.1 wph vx cA wral vx cA
      rzal wph vx cA rzal sylanc cA c0 wceq wn vx cv cA wcel vx wex wph vx cA
      wral vx cA wral wph vx cA wral wb vx cA neq0 vx cv cA wcel vx wex wph vx
      cA wral vx cv cA wcel vx wex wph vx cA wral wi wph vx cA wral vx cA wral
      vx cv cA wcel vx wex wph vx cA wral biimt wph vx cA wral vx cA wral vx cv
      cA wcel wph vx cA wral wi vx wal vx cv cA wcel vx wex wph vx cA wral wi
      wph vx cA wral vx cA df-ral vx cv cA wcel wph vx cA wral vx wph vx cA
      hbra1 19.23 bitri syl6rbbr sylbi pm2.61i $.
      $( [28-Mar-1997] $)
  $}

  $( Vacuous universal quantification is always true. $)
  ral0 $p |- A. x e. (/) ph $=
    wph vx c0 vx cv c0 wcel wph vx cv noel pm2.21i rgen $.
    $( [27-Oct-2005] $) $( [20-Oct-2005] $)

  ${
    $d x A $.
    ralf0.1 $e |- -. ph $.
    $( The quantification of a falsehood is vacuous when true. $)
    ralf0 $p |- ( A. x e. A ph <-> A = (/) ) $=
      wph vx cA wral cA c0 wceq vx cv cA wcel wph wi vx wal vx cv cA wcel wn vx
      wal wph vx cA wral cA c0 wceq vx cv cA wcel wph wi vx cv cA wcel wn vx vx
      cv cA wcel wph wi wph wn vx cv cA wcel wn ralf0.1 vx cv cA wcel wph con3
      mpi 19.20i wph vx cA df-ral vx cA eq0 3imtr4i wph vx cA rzal impbii $.
      $( [6-Dec-2005] $) $( [26-Nov-2005] $)
  $}

  $( MAY BE REVISED - shorten r19.3zv, r19.27zv, r19.28zv, raaanv w/ non-v $)
  ${
    $d x y A $.
    raaan.1 $e |- ( ph -> A. y ph ) $.
    raaan.2 $e |- ( ps -> A. x ps ) $.
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y A $.
    $( Rearrange restricted quantifiers. $)
    raaanv $p |- ( A. x e. A A. y e. A ( ph /\ ps ) <->
                  ( A. x e. A ph /\ A. y e. A ps ) ) $=
      wph wps wa vy cA wral vx cA wral wph vx cA wral wps vy cA wral wa wb cA
      c0 wph wps wa vy cA wral vx cA wral wph vx cA wral wps vy cA wral wa wph
      wps wa vy cA wral vx cA wral wph vx cA wral wps vy cA wral wa wb cA c0
      wceq wph wps wa vy cA wral vx cA wral wph vx cA wral wps vy cA wral wa
      pm5.1 wph wps wa vy cA wral vx cA rzal cA c0 wceq wph vx cA wral wps vy
      cA wral wph vx cA rzal wps vy cA rzal jca sylanc cA c0 wne wph wps wa vy
      cA wral vx cA wral wph wps vy cA wral wa vx cA wral wph vx cA wral wps vy
      cA wral wa cA c0 wne wph wps wa vy cA wral wph wps vy cA wral wa vx cA
      wph wps vy cA r19.28zv ralbidv wph wps vy cA wral vx cA r19.27zv bitrd
      pm2.61ine $.
      $( [11-Mar-1997] $)
  $}

  ${
    $d x A w $.  $d v x $.  $d v A $.  $d w v $.  $d w y $.
    $( Lemma for ~ sbss . $)
    sbsslem $p |- ( [ y / x ] x C_ A
                  <-> A. w ( ( w e. y /\ w e. A ) <-> w e. y ) ) $=
      vx cv cA wss vx vy cv wsbc vv cv vx cv wcel vv cv cA wcel wa vv cab vx cv
      wceq vx vy cv wsbc vw cv vx cv wcel vw cv cA wcel wa vw cv vx cv wcel wb
      vw wal vx vy cv wsbc vw cv vy cv wcel vw cv cA wcel wa vw cv vy cv wcel
      wb vw wal vx cv cA wss vv cv vx cv wcel vv cv cA wcel wa vv cab vx cv
      wceq vx vy vx cv cA wss vx cv cA cin vx cv wceq vv cv vx cv wcel vv cv cA
      wcel wa vv cab vx cv wceq vx cv cA df-ss vx cv cA cin vv cv vx cv wcel vv
      cv cA wcel wa vv cab vx cv vv vx cv cA df-in eqeq1i bitri sbbii vv cv vx
      cv wcel vv cv cA wcel wa vv cab vx cv wceq vw cv vx cv wcel vw cv cA wcel
      wa vw cv vx cv wcel wb vw wal vx vy vv cv vx cv wcel vv cv cA wcel wa vv
      cab vx cv wceq vw cv vv cv vx cv wcel vv cv cA wcel wa vv cab wcel vw cv
      vx cv wcel wb vw wal vw cv vx cv wcel vw cv cA wcel wa vw cv vx cv wcel
      wb vw wal vw vv cv vx cv wcel vv cv cA wcel wa vv cab vx cv dfcleq vw cv
      vv cv vx cv wcel vv cv cA wcel wa vv cab wcel vw cv vx cv wcel wb vw cv
      vx cv wcel vw cv cA wcel wa vw cv vx cv wcel wb vw vw cv vv cv vx cv wcel
      vv cv cA wcel wa vv cab wcel vw cv vx cv wcel vw cv cA wcel wa vw cv vx
      cv wcel vw cv vv cv vx cv wcel vv cv cA wcel wa vv cab wcel vv cv vx cv
      wcel vv cv cA wcel wa vv vw cv wsbc vv cv vx cv wcel vv vw cv wsbc vv cv
      cA wcel vv vw cv wsbc wa vw cv vx cv wcel vw cv cA wcel wa vv cv vx cv
      wcel vv cv cA wcel wa vw vv df-clab vv cv vx cv wcel vv cv cA wcel vv vw
      sban vv cv vx cv wcel vv vw cv wsbc vw cv vx cv wcel vv cv cA wcel vv vw
      cv wsbc vw cv cA wcel vw vv vx elsb3 vw vv cA clelsb3 anbi12i 3bitri
      bibi1i albii bitri sbbii vw cv vx cv wcel vw cv cA wcel wa vw cv vx cv
      wcel wb vw wal vx vy cv wsbc vw cv vx cv wcel vw cv cA wcel wa vw cv vx
      cv wcel wb vx vy cv wsbc vw wal vw cv vy cv wcel vw cv cA wcel wa vw cv
      vy cv wcel wb vw wal vw cv vx cv wcel vw cv cA wcel wa vw cv vx cv wcel
      wb vw vx vy sbal vw cv vx cv wcel vw cv cA wcel wa vw cv vx cv wcel wb vx
      vy cv wsbc vw cv vy cv wcel vw cv cA wcel wa vw cv vy cv wcel wb vw vw cv
      vx cv wcel vw cv cA wcel wa vw cv vx cv wcel wb vx vy cv wsbc vw cv vx cv
      wcel vw cv cA wcel wa vx vy cv wsbc vw cv vx cv wcel vx vy cv wsbc wb vw
      cv vy cv wcel vw cv cA wcel wa vw cv vy cv wcel wb vw cv vx cv wcel vw cv
      cA wcel wa vw cv vx cv wcel vx vy sbbi vw cv vx cv wcel vw cv cA wcel wa
      vx vy cv wsbc vw cv vy cv wcel vw cv cA wcel wa vw cv vx cv wcel vx vy cv
      wsbc vw cv vy cv wcel vw cv vx cv wcel vw cv cA wcel wa vx vy cv wsbc vw
      cv vx cv wcel vx vy cv wsbc vw cv cA wcel vx vy cv wsbc wa vw cv vy cv
      wcel vw cv cA wcel wa vw cv vx cv wcel vw cv cA wcel vx vy sban vw cv vx
      cv wcel vx vy cv wsbc vw cv vy cv wcel vw cv cA wcel vx vy cv wsbc vw cv
      cA wcel vy vx vw elsb4 vw cv cA wcel vx vy vw cv cA wcel vx ax-17 sbf
      anbi12i bitri vy vx vw elsb4 bibi12i bitri albii bitri 3bitri $.
      $( [12-Jul-2010] $) $( [7-Jul-2010] $)
  $}

  ${
    $d x v A $.  $d v y A $.
    $( Set substitution into the first argument of a subset relation.
       (Contributed by Rodolfo Medina, 7-Jul-2010.) $)
    sbss $p |- ( [ y / x ] x C_ A <-> y C_ A ) $=
      vx cv cA wss vx vy cv wsbc vv cv vy cv wcel vv cv cA wcel wa vv cv vy cv
      wcel wb vv wal vy cv cA wss vy vy cv wsbc vy cv cA wss vx vy vv cA
      sbsslem vy vy vv cA sbsslem vy cv cA wss vy sbid 3bitr2i $.
      $( [12-Jul-2010] $) $( [7-Jul-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           "Weak deduction theorem" for set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( These lemmas are used to convert hypotheses into antecedents,
     when there is at least one class making the hypothesis true. $)

$(
The Weak Deduction Theorem in set theory
----------------------------------------

In a Hilbert system of logic (which consists of a set of axioms, modus
ponens, and the generalization rule), converting a deduction to a proof using
the Deduction Theorem (taught in introductory logic books) involves an
exponential increase of the number of steps as hypotheses are successively
eliminated.  Here is a trick that is not as general as the Deduction Theorem
but requires only a linear increase in the number of steps.

The general problem:  We want to convert a deduction
  P |- Q
into a proof of the theorem
  |- P -> Q
i.e. we want to eliminate the hypothesis P.  Normally this is done using the
Deduction (meta)Theorem, which looks at the microscopic steps of the
deduction and usually doubles or triples the number of these microscopic
steps for each hypothesis that is eliminated.  We will look at a special case
of this problem, without appealing to the Deduction Theorem.

We assume ZF with class notation.  A and B are arbitrary (possibly
proper) classes.  P, Q, R, S and T are wffs.

We define the conditional operator, if(P,A,B), as follows:
  if(P,A,B) =def= { x | (x \in A & P) v (x \in B & ~P) }
(where x does not occur in A, B, or P).

Lemma 1.
  A = if(P,A,B) -> (P <-> R), B = if(P,A,B) -> (S <-> R), S |- R
Proof:  Logic and Axiom of Extensionality.

Lemma 2.
  A = if(P,A,B) -> (Q <-> T), T |- P -> Q
Proof:  Logic and Axiom of Extensionality.

Here's a simple example that illustrates how it works.  Suppose we have
a deduction
  Ord A |- Tr A
which means, "Assume A is an ordinal class.  Then A is a transitive class."
Note that A is a class variable that may be substituted with any class
expression, so this is really a deduction scheme.

We want to convert this to a proof of the theorem (scheme)
  |- Ord A -> Tr A.

The catch is that we must be able to prove "Ord A" for at least one
object A (and this is what makes it weaker than the ordinary Deduction
Theorem).  However it is easy to prove |- Ord 0 (the empty set is
ordinal).  (For a typical textbook "theorem," i.e. deduction, there is
usually at least one object satisfying each hypothesis, otherwise the
theorem would not be very useful.  We can always go back to the standard
Deduction Theorem for those hypotheses where this is not the case.)
Continuing with the example:

Equality axioms (and Extensionality) yield
  |- A = if(Ord A, A, 0) -> (Ord A <-> Ord if(Ord A, A, 0))  (1)
  |- 0 = if(Ord A, A, 0) -> (Ord 0 <-> Ord if(Ord A, A, 0))  (2)
From (1), (2) and |- Ord 0, Lemma 1 yields
  |- Ord if(Ord A, A, 0)                                       (3)
From (3) and substituting if(Ord A, A, 0) for
A in the original deduction,
  |- Tr if(Ord A, A, 0)                                        (4)
Equality axioms (and Extensionality) yield
  |- A = if(Ord A, A, 0) -> (Tr A <-> Tr if(Ord A, A, 0))    (5)
From (4) and (5), Lemma 2 yields
  |- Ord A -> Tr A                                               (Q.E.D.)
$)


  $( Declare new constant symbols. $)
  $c if $.  $( Conditional operator (was "ded" for "deduction class"). $)
  $c , $.  $( Comma (also used for unordered pair notation later) $)

  $( Extend class notation to include the conditional operator.  See ~ df-if
     for a description.  (In older databases this was denoted "ded".) $)
  cif $a class if ( ph , A , B ) $.

  ${
    $d x ph $.  $d x A $.  $d x B $.
    $( Define the conditional operator.  Read ` if ( ph , A , B ) ` as "if
       ` ph ` then ` A ` else ` B ` ." See ~ iftrue and ~ iffalse for its
       values.  In mathematical literature, this operator is rarely defined
       formally but is implicit in informal definitions such as "let f(x)=0 if
       x=0 and 1/x otherwise."  (In older versions of this database, this
       operator was denoted "ded" and called the "deduction class.")

       An important use for us is in conjunction with the weak deduction
       theorem, which converts a hypothesis into an antecedent.  In that role,
       ` A ` is a class variable in the hypothesis and ` B ` is a class
       (usually a constant) that makes the hypothesis true when it is
       substituted for ` A ` .  See ~ dedth for the main part of the weak
       deduction theorem, ~ elimhyp to eliminate a hypothesis, and ~ keephyp to
       keep a hypothesis.  See the Deduction Theorem link on the Metamath Proof
       Explorer Home Page for a description of the weak deduction theorem. $)
    df-if $a |- if ( ph , A , B ) =
                 { x | ( ( x e. A /\ ph ) \/ ( x e. B /\ -. ph ) ) } $.
  $}

  ${
    $d x ph $.  $d x A $.  $d x B $.  $d x C $.
    $( An alternate definition of the conditional operator ~ df-if with one
       fewer connectives (but probably less intuitive to understand). $)
    dfif2 $p |- if ( ph , A , B ) =
                 { x | ( ( x e. B -> ph ) -> ( x e. A /\ ph ) ) } $=
      wph cA cB cif vx cv cA wcel wph wa vx cv cB wcel wph wn wa wo vx cab vx
      cv cB wcel wph wi vx cv cA wcel wph wa wi vx cab wph vx cA cB df-if vx cv
      cA wcel wph wa vx cv cB wcel wph wn wa wo vx cv cB wcel wph wi vx cv cA
      wcel wph wa wi vx vx cv cB wcel wph wn wa vx cv cA wcel wph wa wo vx cv
      cB wcel wph wn wa wn vx cv cA wcel wph wa wi vx cv cA wcel wph wa vx cv
      cB wcel wph wn wa wo vx cv cB wcel wph wi vx cv cA wcel wph wa wi vx cv
      cB wcel wph wn wa vx cv cA wcel wph wa df-or vx cv cA wcel wph wa vx cv
      cB wcel wph wn wa orcom vx cv cB wcel wph wi vx cv cB wcel wph wn wa wn
      vx cv cA wcel wph wa vx cv cB wcel wph iman imbi1i 3bitr4i abbii eqtri $.
      $( [6-Mar-2006] $) $( [30-Jan-2006] $)

    $( Equality theorem for conditional operator. $)
    ifeq1 $p |- ( A = B -> if ( ph , A , C ) = if ( ph , B , C ) ) $=
      cA cB wceq vx cv cA wcel wph wa vx cv cC wcel wph wn wa wo vx cab vx cv
      cB wcel wph wa vx cv cC wcel wph wn wa wo vx cab wph cA cC cif wph cB cC
      cif cA cB wceq vx cv cA wcel wph wa vx cv cC wcel wph wn wa wo vx cv cB
      wcel wph wa vx cv cC wcel wph wn wa wo vx cA cB wceq vx cv cA wcel wph wa
      vx cv cB wcel wph wa vx cv cC wcel wph wn wa cA cB wceq vx cv cA wcel vx
      cv cB wcel wph cA cB vx cv eleq2 anbi1d orbi1d abbidv wph vx cA cC df-if
      wph vx cB cC df-if 3eqtr4g $.
      $( [30-Sep-2004] $) $( [1-Sep-2004] $)

    $( Equality theorem for conditional operator. $)
    ifeq2 $p |- ( A = B -> if ( ph , C , A ) = if ( ph , C , B ) ) $=
      cA cB wceq vx cv cC wcel wph wa vx cv cA wcel wph wn wa wo vx cab vx cv
      cC wcel wph wa vx cv cB wcel wph wn wa wo vx cab wph cC cA cif wph cC cB
      cif cA cB wceq vx cv cC wcel wph wa vx cv cA wcel wph wn wa wo vx cv cC
      wcel wph wa vx cv cB wcel wph wn wa wo vx cA cB wceq vx cv cA wcel wph wn
      wa vx cv cB wcel wph wn wa vx cv cC wcel wph wa cA cB wceq vx cv cA wcel
      vx cv cB wcel wph wn cA cB vx cv eleq2 anbi1d orbi2d abbidv wph vx cC cA
      df-if wph vx cC cB df-if 3eqtr4g $.
      $( [30-Sep-2004] $) $( [1-Sep-2004] $)

    $( Value of the conditional operator when its first argument is true. $)
    iftrue $p |- ( ph -> if ( ph , A , B ) = A ) $=
      wph cA vx cv cA wcel wph wa vx cv cB wcel wph wn wa wo vx cab wph cA cB
      cif wph vx cv cA wcel wph wa vx cv cB wcel wph wn wa wo vx cA wph vx cv
      cA wcel vx cv cB wcel dedlema abbi2dv wph vx cA cB df-if syl6reqr $.
      $( [2-Sep-2004] $) $( [15-May-1999] $)

    $( Value of the conditional operator when its first argument is false. $)
    iffalse $p |- ( -. ph -> if ( ph , A , B ) = B ) $=
      wph wn cB vx cv cA wcel wph wa vx cv cB wcel wph wn wa wo vx cab wph cA
      cB cif wph wn vx cv cA wcel wph wa vx cv cB wcel wph wn wa wo vx cB wph
      vx cv cA wcel vx cv cB wcel dedlemb abbi2dv wph vx cA cB df-if syl6reqr
      $.
      $( [2-Sep-2004] $) $( [14-Aug-1999] $)
  $}

  $( Equality theorem for conditional operators. $)
  ifeq12 $p |- ( ( A = B /\ C = D ) ->
                if ( ph , A , C ) = if ( ph , B , D ) ) $=
    cA cB wceq cC cD wceq wph cA cC cif wph cB cC cif wph cB cD cif wph cA cB
    cC ifeq1 wph cC cD cB ifeq2 sylan9eq $.
    $( [30-Sep-2004] $) $( [1-Sep-2004] $)

  ${
    ifeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for conditional operator. $)
    ifeq1d $p |- ( ph -> if ( ps , A , C ) = if ( ps , B , C ) ) $=
      wph cA cB wceq wps cA cC cif wps cB cC cif wceq ifeq1d.1 wps cA cB cC
      ifeq1 syl $.
      $( [16-Feb-2005] $) $( [16-Feb-2005] $)

    $( Equality deduction for conditional operator. $)
    ifeq2d $p |- ( ph -> if ( ps , C , A ) = if ( ps , C , B ) ) $=
      wph cA cB wceq wps cC cA cif wps cC cB cif wceq ifeq1d.1 wps cA cB cC
      ifeq2 syl $.
      $( [16-Feb-2005] $) $( [16-Feb-2005] $)
  $}

  $( Equivalence theorem for conditional operators.  (Contributed by Raph
     Levien, 15-Jan-2004.) $)
  ifbi $p |- ( ( ph <-> ps ) -> if ( ph , A , B ) = if ( ps , A , B ) ) $=
    wph wps wb wph wps wa wph wn wps wn wa wo wph cA cB cif wps cA cB cif wceq
    wph wps dfbi3 wph wps wa wph cA cB cif wps cA cB cif wceq wph wn wps wn wa
    wph wps wph cA cB cif cA wps cA cB cif wph cA cB iftrue wps wps cA cB cif
    cA wps cA cB iftrue eqcomd sylan9eq wph wn wps wn wph cA cB cif cB wps cA
    cB cif wph cA cB iffalse wps wn wps cA cB cif cB wps cA cB iffalse eqcomd
    sylan9eq jaoi sylbi $.
    $( [18-Jan-2004] $) $( [15-Jan-2004] $)

  ${
    ifbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalence deduction for conditional operators. $)
    ifbid $p |- ( ph -> if ( ps , A , B ) = if ( ch , A , B ) ) $=
      wph wps wch wb wps cA cB cif wch cA cB cif wceq ifbid.1 wps wch cA cB
      ifbi syl $.
      $( [20-Apr-2005] $) $( [18-Apr-2005] $)
  $}

  ${
    $d x y z $.  $d y z A $.  $d y z B $.  $d z ph $.
    hbif.1 $e |- ( ph -> A. x ph ) $.
    hbif.2 $e |- ( y e. A -> A. x y e. A ) $.
    hbif.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for a conditional operator. $)
    hbif $p |- ( y e. if ( ph , A , B ) -> A. x y e. if ( ph , A , B ) ) $=
      vx vy wph cA cB cif vz cv cA wcel wph wa vz cv cB wcel wph wn wa wo vz
      cab wph vz cA cB df-if vz cv cA wcel wph wa vz cv cB wcel wph wn wa wo vx
      vz vy vz cv cA wcel wph wa vz cv cB wcel wph wn wa vx vz cv cA wcel wph
      vx vx vy vy vz cv cA vy cv vz cv wcel vx ax-17 hbif.2 hbel hbif.1 hban vz
      cv cB wcel wph wn vx vx vy vy vz cv cB vy cv vz cv wcel vx ax-17 hbif.3
      hbel wph vx hbif.1 hbn hban hbor hbab hbxfr $.
      $( [16-Feb-2005] $) $( [16-Feb-2005] $)
  $}

  ${
    sbif.1 $e |- ( if ( ph , A , B ) = A -> ( ps <-> ch ) ) $.
    sbif.2 $e |- ( if ( ph , A , B ) = B -> ( ps <-> th ) ) $.
    $( Elimination of a conditional operator contained in a wff ` ps ` . $)
    elimif $p |- ( ps <-> ( ( ph /\ ch ) \/ ( -. ph /\ th ) ) ) $=
      wps wph wph wn wo wps wa wph wps wa wph wn wps wa wo wph wch wa wph wn
      wth wa wo wph wph wn wo wps wph exmid biantrur wph wph wn wps andir wph
      wps wa wph wch wa wph wn wps wa wph wn wth wa wph wps wch wph wph cA cB
      cif cA wceq wps wch wb wph cA cB iftrue sbif.1 syl pm5.32i wph wn wps wth
      wph wn wph cA cB cif cB wceq wps wth wb wph cA cB iffalse sbif.2 syl
      pm5.32i orbi12i 3bitri $.
      $( [15-Feb-2005] $) $( [15-Feb-2005] $)
  $}

  ${
    ifboth.1 $e |- ( A = if ( ph , A , B ) -> ( ps <-> th ) ) $.
    ifboth.2 $e |- ( B = if ( ph , A , B ) -> ( ch <-> th ) ) $.
    $( A wff ` th ` containing a conditional operator is true when both of its
       cases are true. $)
    ifboth $p |- ( ( ps /\ ch ) -> th ) $=
      wph wps wch wa wth wph wps wth wch wph wps wth wph cA wph cA cB cif wceq
      wps wth wb wph wph cA cB cif cA wph cA cB iftrue eqcomd ifboth.1 syl
      biimpa adantrr wph wn wch wth wps wph wn wth wch wph wn cB wph cA cB cif
      wceq wth wch wb wph wn wph cA cB cif cB wph cA cB iffalse eqcomd cB wph
      cA cB cif wceq wch wth ifboth.2 bicomd syl biimpar adantrl pm2.61ian $.
      $( [4-Sep-2006] $) $( [3-Sep-2006] $)
  $}

  $( Identical true and false arguments in the conditional operator. $)
  ifid $p |- if ( ph , A , A ) = A $=
    wph wph cA cA cif cA wceq wph cA cA iftrue wph cA cA iffalse pm2.61i $.
    $( [25-Apr-2005] $) $( [18-Apr-2005] $)

  $( Expansion of an equality with a conditional operator. $)
  eqif $p |- ( A = if ( ph , B , C ) <->
             ( ( ph /\ A = B ) \/ ( -. ph /\ A = C ) ) ) $=
    wph cA wph cB cC cif wceq cA cB wceq cA cC wceq cB cC wph cB cC cif cB cA
    eqeq2 wph cB cC cif cC cA eqeq2 elimif $.
    $( [15-Feb-2005] $) $( [14-Feb-2005] $)

  $( Membership in a conditional operator. $)
  elif $p |- ( A e. if ( ph , B , C ) <->
             ( ( ph /\ A e. B ) \/ ( -. ph /\ A e. C ) ) ) $=
    wph cA wph cB cC cif wcel cA cB wcel cA cC wcel cB cC wph cB cC cif cB cA
    eleq2 wph cB cC cif cC cA eleq2 elimif $.
    $( [9-Mar-2005] $) $( [14-Feb-2005] $)

  $( Membership of a conditional operator. $)
  ifel $p |- ( if ( ph , A , B ) e. C <->
             ( ( ph /\ A e. C ) \/ ( -. ph /\ B e. C ) ) ) $=
    wph wph cA cB cif cC wcel cA cC wcel cB cC wcel cA cB wph cA cB cif cA cC
    eleq1 wph cA cB cif cB cC eleq1 elimif $.
    $( [30-Sep-2005] $) $( [10-Sep-2005] $)

  $( Membership (closure) of a conditional operator. $)
  ifcl $p |- ( ( A e. C /\ B e. C ) -> if ( ph , A , B ) e. C ) $=
    wph cA cC wcel cB cC wcel wph cA cB cif cC wcel cA cB cA wph cA cB cif cC
    eleq1 cB wph cA cB cif cC eleq1 ifboth $.
    $( [12-Apr-2005] $) $( [4-Apr-2005] $)

  $( The possible values of a conditional operator. $)
  ifor $p |- ( if ( ph , A , B ) = A \/ if ( ph , A , B ) = B ) $=
    wph wph cA cB cif cA wceq wa wph wn wph cA cB cif cB wceq wa wo wph cA cB
    cif cA wceq wph cA cB cif cB wceq wo wph cA cB cif wph cA cB cif wceq wph
    wph cA cB cif cA wceq wa wph wn wph cA cB cif cB wceq wa wo wph cA cB cif
    eqid wph wph cA cB cif cA cB eqif mpbi wph wph cA cB cif cA wceq wa wph cA
    cB cif cA wceq wph wn wph cA cB cif cB wceq wa wph cA cB cif cB wceq wph
    wph cA cB cif cA wceq pm3.27 wph wn wph cA cB cif cB wceq pm3.27 orim12i
    ax-mp $.
    $( [17-Jun-2007] $) $( [17-Jun-2007] $)

  $( Negating the first argument swaps the last two arguments of a conditional
     operator. $)
  ifswap $p |- if ( -. ph , A , B ) = if ( ph , B , A ) $=
    wph wph wn cA cB cif wph cB cA cif wceq wph wph wn cA cB cif cB wph cB cA
    cif wph wph wn wn wph wn cA cB cif cB wceq wph notnot1 wph wn cA cB iffalse
    syl wph cB cA iftrue eqtr4d wph wn wph wn cA cB cif cA wph cB cA cif wph wn
    cA cB iftrue wph cB cA iffalse eqtr4d pm2.61i $.
    $( [24-Jun-2007] $) $( [21-Jun-2007] $)

  ${
    $d x A $.  $d x B $.  $d x ph $.
    dedth.1 $e |- ( A = if ( ph , A , B ) -> ( ps <-> ch ) ) $.
    dedth.2 $e |- ch $.
    $( Weak deduction theorem that eliminates a hypothesis ` ph ` , making it
       become an antecedent.  We assume that a proof exists for ` ph ` when
       the class variable ` A ` is replaced with a specific class ` B ` .
       The hypothesis ` ch ` should be assigned to the inference, and the
       inference's hypothesis eliminated with ~ elimhyp .  If the inference
       has other hypotheses with class variable ` A ` , these can be
       kept by assigning ~ keephyp to them.  For more information, see the
       Deduction Theorem ~ http://us.metamath.org/mpegif/mmdeduction.html . $)
    dedth $p |- ( ph -> ps ) $=
      wph wps wch dedth.2 wph cA wph cA cB cif wceq wps wch wb wph wph cA cB
      cif cA wph cA cB iftrue eqcomd dedth.1 syl mpbiri $.
      $( [15-May-1999] $)
  $}

  ${
    dedth2vOLD.1 $e |- ( A = if ( ph , A , C ) -> ( ps <-> ch ) ) $.
    dedth2vOLD.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    dedth2vOLD.3 $e |- th $.
    $( Weak deduction theorem for eliminating a hypothesis with 2 class
       variables.  Note:  if the hypothesis can be separated into two
       hypotheses, each with one class variable, then ~ dedth2h is simpler to
       use.  See also comments in ~ dedth . $)
    dedth2vOLD $p |- ( ph -> ps ) $=
      wph wps wth dedth2vOLD.3 wph wps wch wth wph cA wph cA cC cif wceq wps
      wch wb wph wph cA cC cif cA wph cA cC iftrue eqcomd dedth2vOLD.1 syl wph
      cB wph cB cD cif wceq wch wth wb wph wph cB cD cif cB wph cB cD iftrue
      eqcomd dedth2vOLD.2 syl bitrd mpbiri $.
      $( [13-Aug-1999] $)
  $}

  ${
    dedth3vOLD.1 $e |- ( A = if ( ph , A , D ) -> ( ps <-> ch ) ) $.
    dedth3vOLD.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    dedth3vOLD.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    dedth3vOLD.4 $e |- ta $.
    $( Weak deduction theorem for eliminating a hypothesis with 3 class
       variables.  See comments in ~ dedth2v . $)
    dedth3vOLD $p |- ( ph -> ps ) $=
      wph wps wta dedth3vOLD.4 wph wps wch wth wta wph cA wph cA cD cif wceq
      wps wch wb wph wph cA cD cif cA wph cA cD iftrue eqcomd dedth3vOLD.1 syl
      wph cB wph cB cR cif wceq wch wth wb wph wph cB cR cif cB wph cB cR
      iftrue eqcomd dedth3vOLD.2 syl wph cC wph cC cS cif wceq wth wta wb wph
      wph cC cS cif cC wph cC cS iftrue eqcomd dedth3vOLD.3 syl 3bitrd mpbiri
      $.
      $( [13-Aug-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    dedth4vOLD.we $f wff et $.
    dedth4vOLD.1 $e |- ( A = if ( ph , A , R ) -> ( ps <-> ch ) ) $.
    dedth4vOLD.2 $e |- ( B = if ( ph , B , S ) -> ( ch <-> th ) ) $.
    dedth4vOLD.3 $e |- ( C = if ( ph , C , T ) -> ( th <-> ta ) ) $.
    dedth4vOLD.4 $e |- ( D = if ( ph , D , U ) -> ( ta <-> et ) ) $.
    dedth4vOLD.5 $e |- et $.
    $( Weak deduction theorem for eliminating a hypothesis with 4 class
       variables.  See comments in ~ dedth2v . $)
    dedth4vOLD $p |- ( ph -> ps ) $=
      wph wps dedth4vOLD.we dedth4vOLD.5 wph wps wth wta dedth4vOLD.we wph wps
      wch wth wph cA wph cA cR cif wceq wps wch wb wph wph cA cR cif cA wph cA
      cR iftrue eqcomd dedth4vOLD.1 syl wph cB wph cB cS cif wceq wch wth wb
      wph wph cB cS cif cB wph cB cS iftrue eqcomd dedth4vOLD.2 syl bitrd wph
      cC wph cC cT cif wceq wth wta wb wph wph cC cT cif cC wph cC cT iftrue
      eqcomd dedth4vOLD.3 syl wph cD wph cD cU cif wceq wta dedth4vOLD.we wb
      wph wph cD cU cif cD wph cD cU iftrue eqcomd dedth4vOLD.4 syl 3bitrd
      mpbiri $.
      $( [27-Apr-2007] $) $( [21-Apr-2007] $)
  $}

  ${
    dedth2h.1 $e |- ( A = if ( ph , A , C ) -> ( ch <-> th ) ) $.
    dedth2h.2 $e |- ( B = if ( ps , B , D ) -> ( th <-> ta ) ) $.
    dedth2h.3 $e |- ta $.
    $( Weak deduction theorem eliminating two hypotheses.  This theorem is
       simpler to use than ~ dedth2v but requires that each hypothesis has
       exactly one class variable.  See also comments in ~ dedth . $)
    dedth2h $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wch wph wps wch wi wps wth wi cA cC cA wph cA cC cif wceq wch wth
      wps dedth2h.1 imbi2d wps wth wta cB cD dedth2h.2 dedth2h.3 dedth dedth
      imp $.
      $( [15-May-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    dedth3h.we $f wff et $.
    dedth3h.wz $f wff ze $.
    dedth3h.1 $e |- ( A = if ( ph , A , D ) -> ( th <-> ta ) ) $.
    dedth3h.2 $e |- ( B = if ( ps , B , R ) -> ( ta <-> et ) ) $.
    dedth3h.3 $e |- ( C = if ( ch , C , S ) -> ( et <-> ze ) ) $.
    dedth3h.4 $e |- ze $.
    $( Weak deduction theorem eliminating three hypotheses.  See comments in
       ~ dedth2h . $)
    dedth3h $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      wph wps wch wth wph wps wch wa wth wi wps wch wa wta wi cA cD cA wph cA
      cD cif wceq wth wta wps wch wa dedth3h.1 imbi2d wps wch wta dedth3h.we
      dedth3h.wz cB cC cR cS dedth3h.2 dedth3h.3 dedth3h.4 dedth2h dedth 3impib
      $.
      $( [15-May-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    $v si $. $( Greek sigma $)
    $v rh $. $( Greek rho $)
    $v F $.
    $v G $.
    dedth4h.we $f wff et $.
    dedth4h.wz $f wff ze $.
    dedth4h.ws $f wff si $.
    dedth4h.wr $f wff rh $.
    dedth4h.F $f class F $.
    dedth4h.G $f class G $.
    dedth4h.1 $e |- ( A = if ( ph , A , R ) -> ( ta <-> et ) ) $.
    dedth4h.2 $e |- ( B = if ( ps , B , S ) -> ( et <-> ze ) ) $.
    dedth4h.3 $e |- ( C = if ( ch , C , F ) -> ( ze <-> si ) ) $.
    dedth4h.4 $e |- ( D = if ( th , D , G ) -> ( si <-> rh ) ) $.
    dedth4h.5 $e |- rh $.
    $( Weak deduction theorem eliminating four hypotheses.  See comments in
       ~ dedth2h . $)
    dedth4h $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $=
      wph wps wa wch wth wa wta wph wps wch wth wa wta wi wch wth wa dedth4h.we
      wi wch wth wa dedth4h.wz wi cA cB cR cS cA wph cA cR cif wceq wta
      dedth4h.we wch wth wa dedth4h.1 imbi2d cB wps cB cS cif wceq dedth4h.we
      dedth4h.wz wch wth wa dedth4h.2 imbi2d wch wth dedth4h.wz dedth4h.ws
      dedth4h.wr cC cD dedth4h.F dedth4h.G dedth4h.3 dedth4h.4 dedth4h.5
      dedth2h dedth2h imp $.
      $( [16-May-1999] $)
  $}

  ${
    dedth2v.1 $e |- ( A = if ( ph , A , C ) -> ( ps <-> ch ) ) $.
    dedth2v.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    dedth2v.3 $e |- th $.
    $( Weak deduction theorem for eliminating a hypothesis with 2 class
       variables.  Note:  if the hypothesis can be separated into two
       hypotheses, each with one class variable, then ~ dedth2h is simpler to
       use.  See also comments in ~ dedth .  (The proof was shortened by Eric
       Schmidt, 28-Jul-2009.  Compare ~ dedth2vOLD . ) $)
    dedth2v $p |- ( ph -> ps ) $=
      wph wps wph wph wps wch wth cA cB cC cD dedth2v.1 dedth2v.2 dedth2v.3
      dedth2h anidms $.
      $( [29-Jul-2009] $) $( [13-Aug-1999] $)
  $}

  ${
    dedth3v.1 $e |- ( A = if ( ph , A , D ) -> ( ps <-> ch ) ) $.
    dedth3v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    dedth3v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    dedth3v.4 $e |- ta $.
    $( Weak deduction theorem for eliminating a hypothesis with 3 class
       variables.  See comments in ~ dedth2v .  (The proof was shortened by
       Eric Schmidt, 28-Jul-2009.  Compare ~ dedth3vOLD .) $)
    dedth3v $p |- ( ph -> ps ) $=
      wph wps wph wph wps wph wph wph wps wch cA cB cC cD cR cS wth wta
      dedth3v.1 dedth3v.2 dedth3v.3 dedth3v.4 dedth3h 3anidm12 anidms $.
      $( [29-Jul-2009] $) $( [13-Aug-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    dedth4v.we $f wff et $.
    dedth4v.1 $e |- ( A = if ( ph , A , R ) -> ( ps <-> ch ) ) $.
    dedth4v.2 $e |- ( B = if ( ph , B , S ) -> ( ch <-> th ) ) $.
    dedth4v.3 $e |- ( C = if ( ph , C , T ) -> ( th <-> ta ) ) $.
    dedth4v.4 $e |- ( D = if ( ph , D , U ) -> ( ta <-> et ) ) $.
    dedth4v.5 $e |- et $.
    $( Weak deduction theorem for eliminating a hypothesis with 4 class
       variables.  See comments in ~ dedth2v .  (The proof was shortened by
       Eric Schmidt, 28-Jul-2009.  Compare ~ dedth4vOLD .) $)
    dedth4v $p |- ( ph -> ps ) $=
      wph wps wph wph wa wps wph wph wph wph wps cA cB cC cD cR cS wch wth wta
      dedth4v.we cT cU dedth4v.1 dedth4v.2 dedth4v.3 dedth4v.4 dedth4v.5
      dedth4h anidms anidms $.
      $( [29-Jul-2009] $) $( [21-Apr-2007] $)
  $}

  ${
    elimhyp.1 $e |- ( A = if ( ph , A , B ) -> ( ph <-> ps ) ) $.
    elimhyp.2 $e |- ( B = if ( ph , A , B ) -> ( ch <-> ps ) ) $.
    elimhyp.3 $e |- ch $.
    $( Eliminate a hypothesis containing class variable ` A ` when it is known
       for a specific class ` B ` .  For more information, see comments in
       ~ dedth . $)
    elimhyp $p |- ps $=
      wph wps wph wps wph cA wph cA cB cif wceq wph wps wb wph wph cA cB cif cA
      wph cA cB iftrue eqcomd elimhyp.1 syl ibi wph wn wch wps elimhyp.3 wph wn
      cB wph cA cB cif wceq wch wps wb wph wn wph cA cB cif cB wph cA cB
      iffalse eqcomd elimhyp.2 syl mpbii pm2.61i $.
      $( [15-May-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    elimhyp2v.we $f wff et $.
    elimhyp2v.1 $e |- ( A = if ( ph , A , C ) -> ( ph <-> ch ) ) $.
    elimhyp2v.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    elimhyp2v.3 $e |- ( C = if ( ph , A , C ) -> ( ta <-> et ) ) $.
    elimhyp2v.4 $e |- ( D = if ( ph , B , D ) -> ( et <-> th ) ) $.
    elimhyp2v.5 $e |- ta $.
    $( Eliminate a hypothesis containing 2 class variables. $)
    elimhyp2v $p |- th $=
      wph wth wph wth wph wph wch wth wph cA wph cA cC cif wceq wph wch wb wph
      wph cA cC cif cA wph cA cC iftrue eqcomd elimhyp2v.1 syl wph cB wph cB cD
      cif wceq wch wth wb wph wph cB cD cif cB wph cB cD iftrue eqcomd
      elimhyp2v.2 syl bitrd ibi wph wn wta wth elimhyp2v.5 wph wn wta
      elimhyp2v.we wth wph wn cC wph cA cC cif wceq wta elimhyp2v.we wb wph wn
      wph cA cC cif cC wph cA cC iffalse eqcomd elimhyp2v.3 syl wph wn cD wph
      cB cD cif wceq elimhyp2v.we wth wb wph wn wph cB cD cif cD wph cB cD
      iffalse eqcomd elimhyp2v.4 syl bitrd mpbii pm2.61i $.
      $( [14-Aug-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    $v si $. $( Greek sigma $)
    elimhyp3v.we $f wff et $.
    elimhyp3v.wz $f wff ze $.
    elimhyp3v.ws $f wff si $.
    elimhyp3v.1 $e |- ( A = if ( ph , A , D ) -> ( ph <-> ch ) ) $.
    elimhyp3v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    elimhyp3v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    elimhyp3v.4 $e |- ( D = if ( ph , A , D ) -> ( et <-> ze ) ) $.
    elimhyp3v.5 $e |- ( R = if ( ph , B , R ) -> ( ze <-> si ) ) $.
    elimhyp3v.6 $e |- ( S = if ( ph , C , S ) -> ( si <-> ta ) ) $.
    elimhyp3v.7 $e |- et $.
    $( Eliminate a hypothesis containing 3 class variables. $)
    elimhyp3v $p |- ta $=
      wph wta wph wta wph wph wch wth wta wph cA wph cA cD cif wceq wph wch wb
      wph wph cA cD cif cA wph cA cD iftrue eqcomd elimhyp3v.1 syl wph cB wph
      cB cR cif wceq wch wth wb wph wph cB cR cif cB wph cB cR iftrue eqcomd
      elimhyp3v.2 syl wph cC wph cC cS cif wceq wth wta wb wph wph cC cS cif cC
      wph cC cS iftrue eqcomd elimhyp3v.3 syl 3bitrd ibi wph wn elimhyp3v.we
      wta elimhyp3v.7 wph wn elimhyp3v.we elimhyp3v.wz elimhyp3v.ws wta wph wn
      cD wph cA cD cif wceq elimhyp3v.we elimhyp3v.wz wb wph wn wph cA cD cif
      cD wph cA cD iffalse eqcomd elimhyp3v.4 syl wph wn cR wph cB cR cif wceq
      elimhyp3v.wz elimhyp3v.ws wb wph wn wph cB cR cif cR wph cB cR iffalse
      eqcomd elimhyp3v.5 syl wph wn cS wph cC cS cif wceq elimhyp3v.ws wta wb
      wph wn wph cC cS cif cS wph cC cS iffalse eqcomd elimhyp3v.6 syl 3bitrd
      mpbii pm2.61i $.
      $( [14-Aug-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    $v si $. $( Greek sigma $)
    $v rh $. $( Greek rho $)
    $v F $.
    $v G $.
    elimhyp4v.we $f wff et $.
    elimhyp4v.wz $f wff ze $.
    elimhyp4v.ws $f wff si $.
    elimhyp4v.wr $f wff rh $.
    elimhyp4v.cF $f class F $.
    elimhyp4v.cG $f class G $.
    elimhyp4v.1 $e |- ( A = if ( ph , A , D ) -> ( ph <-> ch ) ) $.
    elimhyp4v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    elimhyp4v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    elimhyp4v.4 $e |- ( F = if ( ph , F , G ) -> ( ta <-> ps ) ) $.

    elimhyp4v.5 $e |- ( D = if ( ph , A , D ) -> ( et <-> ze ) ) $.
    elimhyp4v.6 $e |- ( R = if ( ph , B , R ) -> ( ze <-> si ) ) $.
    elimhyp4v.7 $e |- ( S = if ( ph , C , S ) -> ( si <-> rh ) ) $.
    elimhyp4v.8 $e |- ( G = if ( ph , F , G ) -> ( rh <-> ps ) ) $.
    elimhyp4v.9 $e |- et $.
    $( Eliminate a hypothesis containing 4 class variables (for use with the
       weak deduction theorem ~ dedth ). $)
    elimhyp4v $p |- ps $=
      wph wps wph wps wph wph wth wta wps wph wph wch wth wph cA wph cA cD cif
      wceq wph wch wb wph wph cA cD cif cA wph cA cD iftrue eqcomd elimhyp4v.1
      syl wph cB wph cB cR cif wceq wch wth wb wph wph cB cR cif cB wph cB cR
      iftrue eqcomd elimhyp4v.2 syl bitrd wph cC wph cC cS cif wceq wth wta wb
      wph wph cC cS cif cC wph cC cS iftrue eqcomd elimhyp4v.3 syl wph
      elimhyp4v.cF wph elimhyp4v.cF elimhyp4v.cG cif wceq wta wps wb wph wph
      elimhyp4v.cF elimhyp4v.cG cif elimhyp4v.cF wph elimhyp4v.cF elimhyp4v.cG
      iftrue eqcomd elimhyp4v.4 syl 3bitrd ibi wph wn elimhyp4v.we wps
      elimhyp4v.9 wph wn elimhyp4v.we elimhyp4v.ws elimhyp4v.wr wps wph wn
      elimhyp4v.we elimhyp4v.wz elimhyp4v.ws wph wn cD wph cA cD cif wceq
      elimhyp4v.we elimhyp4v.wz wb wph wn wph cA cD cif cD wph cA cD iffalse
      eqcomd elimhyp4v.5 syl wph wn cR wph cB cR cif wceq elimhyp4v.wz
      elimhyp4v.ws wb wph wn wph cB cR cif cR wph cB cR iffalse eqcomd
      elimhyp4v.6 syl bitrd wph wn cS wph cC cS cif wceq elimhyp4v.ws
      elimhyp4v.wr wb wph wn wph cC cS cif cS wph cC cS iffalse eqcomd
      elimhyp4v.7 syl wph wn elimhyp4v.cG wph elimhyp4v.cF elimhyp4v.cG cif
      wceq elimhyp4v.wr wps wb wph wn wph elimhyp4v.cF elimhyp4v.cG cif
      elimhyp4v.cG wph elimhyp4v.cF elimhyp4v.cG iffalse eqcomd elimhyp4v.8 syl
      3bitrd mpbii pm2.61i $.
      $( [9-May-2005] $) $( [16-Apr-2005] $)
  $}

  ${
    elimel.1 $e |- B e. C $.
    $( Eliminate a membership hypothesis for weak deduction theorem, when
       special case ` B e. C ` is provable. $)
    elimel $p |- if ( A e. C , A , B ) e. C $=
      cA cC wcel cA cC wcel cA cB cif cC wcel cB cC wcel cA cB cA cA cC wcel cA
      cB cif cC eleq1 cB cA cC wcel cA cB cif cC eleq1 elimel.1 elimhyp $.
      $( [15-May-1999] $)
  $}

  ${
    elimdhyp.1 $e |- ( ph -> ps ) $.
    elimdhyp.2 $e |- ( A = if ( ph , A , B ) -> ( ps <-> ch ) ) $.
    elimdhyp.3 $e |- ( B = if ( ph , A , B ) -> ( th <-> ch ) ) $.
    elimdhyp.4 $e |- th $.
    $( Version of ~ elimhyp where the hypothesis is deduced from the final
       antecedent.  See ~ ghomgrplem for an example of its use.  (Contributed
       by Paul Chapman, 25-Mar-2008.) $)
    elimdhyp $p |- ch $=
      wph wch wph wps wch elimdhyp.1 wph cA wph cA cB cif wceq wps wch wb wph
      wph cA cB cif cA wph cA cB iftrue eqcomd elimdhyp.2 syl mpbid wph wn wth
      wch elimdhyp.4 wph wn cB wph cA cB cif wceq wth wch wb wph wn wph cA cB
      cif cB wph cA cB iffalse eqcomd elimdhyp.3 syl mpbii pm2.61i $.
      $( [26-Mar-2008] $) $( [25-Mar-2008] $)
  $}

  ${
    keephyp.1 $e |- ( A = if ( ph , A , B ) -> ( ps <-> th ) ) $.
    keephyp.2 $e |- ( B = if ( ph , A , B ) -> ( ch <-> th ) ) $.
    keephyp.3 $e |- ps $.
    keephyp.4 $e |- ch $.
    $( Transform a hypothesis ` ps ` that we want to keep (but contains the
       same class variable ` A ` used in the eliminated hypothesis) for use
       with the weak deduction theorem. $)
    keephyp $p |- th $=
      wps wch wth keephyp.3 keephyp.4 wph wps wch wth cA cB keephyp.1 keephyp.2
      ifboth mp2an $.
      $( [15-May-1999] $)
  $}

  ${
    $v et $. $( Greek eta $)
    keephyp2v.we $f wff et $.
    keephyp2v.1 $e |- ( A = if ( ph , A , C ) -> ( ps <-> ch ) ) $.
    keephyp2v.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    keephyp2v.3 $e |- ( C = if ( ph , A , C ) -> ( ta <-> et ) ) $.
    keephyp2v.4 $e |- ( D = if ( ph , B , D ) -> ( et <-> th ) ) $.
    keephyp2v.5 $e |- ps $.
    keephyp2v.6 $e |- ta $.
    $( Keep a hypothesis containing 2 class variables (for use with the weak
       deduction theorem ~ dedth ). $)
    keephyp2v $p |- th $=
      wph wth wph wps wth keephyp2v.5 wph wps wch wth wph cA wph cA cC cif wceq
      wps wch wb wph wph cA cC cif cA wph cA cC iftrue eqcomd keephyp2v.1 syl
      wph cB wph cB cD cif wceq wch wth wb wph wph cB cD cif cB wph cB cD
      iftrue eqcomd keephyp2v.2 syl bitrd mpbii wph wn wta wth keephyp2v.6 wph
      wn wta keephyp2v.we wth wph wn cC wph cA cC cif wceq wta keephyp2v.we wb
      wph wn wph cA cC cif cC wph cA cC iffalse eqcomd keephyp2v.3 syl wph wn
      cD wph cB cD cif wceq keephyp2v.we wth wb wph wn wph cB cD cif cD wph cB
      cD iffalse eqcomd keephyp2v.4 syl bitrd mpbii pm2.61i $.
      $( [15-May-2005] $) $( [16-Apr-2005] $)
  $}

  ${
    $v et $. $( Greek eta $)
    $v ze $. $( Greek zeta $)
    $v si $. $( Greek sigma $)
    $v rh $. $( Greek rho $)
    keephyp3v.we $f wff et $.
    keephyp3v.wz $f wff ze $.
    keephyp3v.ws $f wff si $.
    keephyp3v.wr $f wff rh $.
    keephyp3v.1 $e |- ( A = if ( ph , A , D ) -> ( rh <-> ch ) ) $.
    keephyp3v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    keephyp3v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    keephyp3v.4 $e |- ( D = if ( ph , A , D ) -> ( et <-> ze ) ) $.
    keephyp3v.5 $e |- ( R = if ( ph , B , R ) -> ( ze <-> si ) ) $.
    keephyp3v.6 $e |- ( S = if ( ph , C , S ) -> ( si <-> ta ) ) $.
    keephyp3v.7 $e |- rh $.
    keephyp3v.8 $e |- et $.
    $( Keep a hypothesis containing 3 class variables. $)
    keephyp3v $p |- ta $=
      wph wta wph keephyp3v.wr wta keephyp3v.7 wph keephyp3v.wr wch wth wta wph
      cA wph cA cD cif wceq keephyp3v.wr wch wb wph wph cA cD cif cA wph cA cD
      iftrue eqcomd keephyp3v.1 syl wph cB wph cB cR cif wceq wch wth wb wph
      wph cB cR cif cB wph cB cR iftrue eqcomd keephyp3v.2 syl wph cC wph cC cS
      cif wceq wth wta wb wph wph cC cS cif cC wph cC cS iftrue eqcomd
      keephyp3v.3 syl 3bitrd mpbii wph wn keephyp3v.we wta keephyp3v.8 wph wn
      keephyp3v.we keephyp3v.wz keephyp3v.ws wta wph wn cD wph cA cD cif wceq
      keephyp3v.we keephyp3v.wz wb wph wn wph cA cD cif cD wph cA cD iffalse
      eqcomd keephyp3v.4 syl wph wn cR wph cB cR cif wceq keephyp3v.wz
      keephyp3v.ws wb wph wn wph cB cR cif cR wph cB cR iffalse eqcomd
      keephyp3v.5 syl wph wn cS wph cC cS cif wceq keephyp3v.ws wta wb wph wn
      wph cC cS cif cS wph cC cS iffalse eqcomd keephyp3v.6 syl 3bitrd mpbii
      pm2.61i $.
      $( [27-Sep-1999] $)
  $}

  ${
    keepel.1 $e |- A e. C $.
    keepel.2 $e |- B e. C $.
    $( Keep a membership hypothesis for weak deduction theorem, when
       special case ` B e. C ` is provable. $)
    keepel $p |- if ( ph , A , B ) e. C $=
      wph cA cC wcel cB cC wcel wph cA cB cif cC wcel cA cB cA wph cA cB cif cC
      eleq1 cB wph cA cB cif cC eleq1 keepel.1 keepel.2 keephyp $.
      $( [14-Aug-1999] $)
  $}

  ${
    dedex.1 $e |- A e. _V $.
    dedex.2 $e |- B e. _V $.
    $( Conditional operator existence. $)
    ifex $p |- if ( ph , A , B ) e. _V $=
      wph cA cB cvv dedex.1 dedex.2 keepel $.
      $( [30-Sep-2004] $) $( [2-Sep-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Power classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the symbol for power class. $)
  $c ~P $.  $( Calligraphic P $)

  $( Extend class notation to include power class.  (The tilde in the Metamath
     token is meant to suggest the calligraphic font of the P.) $)
  cpw $a class ~P A $.

  ${
    $d x A $.  $d y A $.  $d w x $.  $d w y $.  $d w A $.  $d w z $.  $d z x $.
    $d z y $.  $d z A $.
    $( Soundness justification theorem for ~ df-pw .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.) $)
       pwjust $p |- { x | x C_ A } = { y | y C_ A } $=
         vz vx cv cA wss vx cab vy cv cA wss vy cab vx cv cA wss vx vz cv wsbc
         vw cv vz cv wcel vw cv cA wcel wa vw cv vz cv wcel wb vw wal vz cv vx
         cv cA wss vx cab wcel vz cv vy cv cA wss vy cab wcel vx vz vw cA
         sbsslem vx cv cA wss vz vx df-clab vz cv vy cv cA wss vy cab wcel vy
         cv cA wss vy vz cv wsbc vw cv vz cv wcel vw cv cA wcel wa vw cv vz cv
         wcel wb vw wal vy cv cA wss vz vy df-clab vy vz vw cA sbsslem bitri
         3bitr4i eqriv $.
         $( [12-Jul-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d x A $.
    $( Define power class.  Definition 5.10 of [TakeutiZaring] p. 17,
       but we also let it apply to proper classes, i.e. those that are not
       members of ` _V ` . $)
    df-pw $a |- ~P A = { x | x C_ A } $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Equality theorem for the power class. $)
    pweq $p |- ( A = B -> ~P A = ~P B ) $=
      cA cB wceq vx cv cA wss vx cab vx cv cB wss vx cab cA cpw cB cpw cA cB
      wceq vx cv cA wss vx cv cB wss vx cA cB vx cv sseq2 abbidv vx cA df-pw vx
      cB df-pw 3eqtr4g $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d A x $.  $d B x $.
    ${
      elpw.1 $e |- A e. _V $.
      $( Membership in a power class.  Theorem 86 of [Suppes] p. 47. $)
      elpw $p |- ( A e. ~P B  <-> A C_ B ) $=
        vx cv cB cpw wcel vx cv cB wss cA cB cpw wcel cA cB wss vx cA elpw.1 vx
        cv cA cB cpw eleq1 vx cv cA cB sseq1 vx cv cB wss vx cB cpw vx cB df-pw
        abeq2i vtoclb $.
        $( [31-Dec-1993] $)
    $}

    $( Membership in a power class.  Theorem 86 of [Suppes] p. 47.  See also
       ~ elpw2g . $)
    elpwg $p |- ( A e. C -> ( A e. ~P B  <-> A C_ B ) ) $=
      vx cv cB cpw wcel vx cv cB wss wb cA cB cpw wcel cA cB wss wb vx cA cC vx
      cv cA wceq vx cv cB cpw wcel cA cB cpw wcel vx cv cB wss cA cB wss vx cv
      cA cB cpw eleq1 vx cv cA cB sseq1 bibi12d vx cv cB vx visset elpw vtoclg
      $.
      $( [6-Aug-2000] $)
  $}

  $( Subset relation implied by membership in a power class. $)
  elpwi $p |- ( A e. ~P B -> A C_ B ) $=
    cA cB cpw wcel cA cB wss cA cB cB cpw elpwg ibi $.
    $( [20-Feb-2007] $) $( [17-Feb-2007] $)

  ${
    $d y z A $.  $d x y z $.
    hbpw.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for power class. $)
    hbpw $p |- ( y e. ~P A -> A. x y e. ~P A ) $=
      vy cv cA wss vy cv cA wss vx wal vy cv cA cpw wcel vy cv cA cpw wcel vx
      wal vx vz vy cv cA vz cv vy cv wcel vx ax-17 vx vy vy vz cv cA vy cv vz
      cv wcel vx ax-17 hbpw.1 hbel hbss vy cv cA vy visset elpw vy cv cA cpw
      wcel vy cv cA wss vx vy cv cA vy visset elpw albii 3imtr4i $.
      $( [6-Nov-2003] $) $( [28-Oct-2003] $)
  $}

  ${
    pwid.1 $e |- A e. _V $.
    $( A set is a member of its power class.  Theorem 87 of [Suppes] p. 47. $)
    pwid $p |- A e. ~P A $=
      cA cA cpw wcel cA cA wss cA ssid cA cA pwid.1 elpw mpbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass relationship for power class. $)
    pwss $p |- ( ~P A C_ B <-> A. x ( x C_ A -> x e. B ) ) $=
      cA cpw cB wss vx cv cA cpw wcel vx cv cB wcel wi vx wal vx cv cA wss vx
      cv cB wcel wi vx wal vx cA cpw cB dfss2 vx cv cA cpw wcel vx cv cB wcel
      wi vx cv cA wss vx cv cB wcel wi vx vx cv cA cpw wcel vx cv cA wss vx cv
      cB wcel vx cv cA wss vx cA cpw vx cA df-pw abeq2i imbi1i albii bitri $.
      $( [23-Jun-2009] $) $( [21-Jun-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Unordered and ordered pairs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols needed. $)
  $c <. $.  $( Bracket (the period distinguishes it from 'less than') $)
  $c >. $.  $( Bracket (the period distinguishes it from 'greater than') $)

  $( Extend class notation to include singleton. $)
  csn $a class { A } $.
  $( Extend class notation to include unordered pair. $)
  cpr $a class { A , B } $.
  $( Extend class notation to include ordered pair. $)
  cop $a class <. A , B >. $.

  ${
    $d x A $.  $d y A $.  $d z x $.  $d z y $.  $d z A $.
    $( Soundness justification theorem for ~ df-sn .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.) $)
    snjust $p |- { x | x = A } = { y | y = A } $=
      vz vx cv cA wceq vx cab vy cv cA wceq vy cab vz cv vx cv cA wceq vx cab
      wcel vz cv cA wceq vz cv vy cv cA wceq vy cab wcel vz cv vx cv cA wceq vx
      cab wcel vx cv cA wceq vx vz cv wsbc vz cv cA wceq vx cv cA wceq vz vx
      df-clab vz vx cA eqsb3 bitri vz cv vy cv cA wceq vy cab wcel vy cv cA
      wceq vy vz cv wsbc vz cv cA wceq vy cv cA wceq vz vy df-clab vz vy cA
      eqsb3 bitri bitr4i eqriv $.
      $( [19-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d x A $.
    $( Define the singleton of a class.  Definition 7.1 of [Quine] p. 48.  For
       convenience, it is well-defined for proper classes, i.e., those that
       are not elements of ` _V ` , although it is not very meaningful in this
       case.  For an alternate definition see ~ dfsn2 . $)
    df-sn $a |- { A } = { x | x = A } $.
  $}

  $( Define unordered pair of classes.  Definition 7.1 of [Quine] p. 48.  For
     a more traditional definition, but requiring a dummy variable, see
     ~ dfpr2 . $)
  df-pr $a |- { A , B } = ( { A } u. { B } ) $.

  $( Extend class notation to include unordered triplet. $)
  ctp $a class { A , B , C } $.

  $( Define unordered triple of classes.  Definition of [Enderton] p. 19. $)
  df-tp $a |- { A , B , C } = ( { A , B } u. { C } ) $.

  $( Kuratowski's ordered pair definition.  Definition 9.1 of [Quine] p. 58.
     For proper classes it is not meaningful but is well-defined and we
     allow it for convenience (see ~ opprc1 , ~ opprc1b , ~ opprc2 , and
     ~ opprc3 ). For the justifying theorem (for sets) see ~ opth .  There are
     other ways to define ordered pairs; the basic requirement is that two
     ordered pairs are equal iff their respective members are equal.  In 1914
     Norbert Wiener gave the first successful definition ` <. A , B >. `_2
     ` = { { { A } , (/) } , { { B } } } ` , justified by ~ opthwiener ,
     which was simplified by Kazimierz Kuratowski in 1921 to our present
     definition.  An even simpler definition ` <. A , B >. `_3
     ` = { A , { A , B } } ` is justified by ~ opthreg , but it requires the
     Axiom of Regularity for its justification and is not commonly used.  A
     definition that also works for proper classes is ` <. A , B >. `_4
     ` = ( ( A X. { (/) } ) u. ( B X. { { (/) } } ) ) ` , justified by
     ~ opthprc .  If we restrict our sets to nonnegative integers, an ordered
     pair definition that involves only elementary arithmetic is provided by
     ~ nn0opthi .  Finally, an ordered pair of real numbers can be represented
     by a complex number as shown by ~ crui . $)
  df-op $a |- <. A , B >. = { { A } , { A , B } } $.

  ${
    $d x A $.  $d x B $.
    $( Equality theorem for singletons.  Part of Exercise 4 of [TakeutiZaring]
       p. 15. $)
    sneq $p |- ( A = B -> { A } = { B } ) $=
      cA cB wceq vx cv cA wceq vx cab vx cv cB wceq vx cab cA csn cB csn cA cB
      wceq vx cv cA wceq vx cv cB wceq vx cA cB vx cv eqeq2 abbidv vx cA df-sn
      vx cB df-sn 3eqtr4g $.
      $( [5-Aug-1993] $)
  $}

  ${
    sneqi.1 $e |- A = B $.
    $( Equality inference for singletons. $)
    sneqi $p |- { A } = { B } $=
      cA cB wceq cA csn cB csn wceq sneqi.1 cA cB sneq ax-mp $.
      $( [7-Feb-2004] $) $( [22-Jan-2004] $)
  $}

  ${
    sneqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for singletons. $)
    sneqd $p |- ( ph -> { A } = { B } ) $=
      wph cA cB wceq cA csn cB csn wceq sneqd.1 cA cB sneq syl $.
      $( [7-Feb-2004] $) $( [22-Jan-2004] $)
  $}

  $( Alternate definition of singleton.  Definition 5.1 of [TakeutiZaring]
     p. 15. $)
  dfsn2 $p |- { A } = { A , A } $=
    cA cA cpr cA csn cA csn cun cA csn cA cA df-pr cA csn unidm eqtr2i $.
    $( [24-Apr-1994] $)

  ${
    $d x A $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15. $)
    elsn $p |- ( x e. { A } <-> x = A ) $=
      vx cv cA wceq vx cA csn vx cA df-sn abeq2i $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of unordered pair.  Definition 5.1 of
       [TakeutiZaring] p. 15. $)
    dfpr2 $p |- { A , B } = { x | ( x = A \/ x = B ) } $=
      cA cB cpr cA csn cB csn cun vx cv cA wceq vx cv cB wceq wo vx cab cA cB
      df-pr vx cv cA wceq vx cv cB wceq wo vx cA csn cB csn cun vx cv cA csn cB
      csn cun wcel vx cv cA csn wcel vx cv cB csn wcel wo vx cv cA wceq vx cv
      cB wceq wo vx cv cA csn cB csn elun vx cv cA csn wcel vx cv cA wceq vx cv
      cB csn wcel vx cv cB wceq vx cA elsn vx cB elsn orbi12i bitri abbi2i
      eqtri $.
      $( [24-Apr-1994] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( A member of an unordered pair of classes is one or the other of them.
       Exercise 1 of [TakeutiZaring] p. 15, generalized. $)
    elprg $p |- ( A e. D -> ( A e. { B , C } <-> ( A = B \/ A = C ) ) ) $=
      vx cv cB wceq vx cv cC wceq wo cA cB wceq cA cC wceq wo vx cA cB cC cpr
      cD vx cv cA wceq vx cv cB wceq cA cB wceq vx cv cC wceq cA cC wceq vx cv
      cA cB eqeq1 vx cv cA cC eqeq1 orbi12d vx cB cC dfpr2 elab2g $.
      $( [13-Sep-1995] $)
  $}

  ${
    elpr.1 $e |- A e. _V $.
    $( A member of an unordered pair of classes is one or the other of them.
       Exercise 1 of [TakeutiZaring] p. 15. $)
    elpr $p |- ( A e. { B , C } <-> ( A = B \/ A = C ) ) $=
      cA cvv wcel cA cB cC cpr wcel cA cB wceq cA cC wceq wo wb elpr.1 cA cB cC
      cvv elprg ax-mp $.
      $( [13-Sep-1995] $)
  $}

  ${
    elpr2.1 $e |- B e. _V $.
    elpr2.2 $e |- C e. _V $.
    $( A member of an unordered pair of classes is one or the other of them.
       Exercise 1 of [TakeutiZaring] p. 15. $)
    elpr2 $p |- ( A e. { B , C } <-> ( A = B \/ A = C ) ) $=
      cA cB cC cpr wcel cA cB wceq cA cC wceq wo cA cB cC cpr wcel cA cB wceq
      cA cC wceq wo cA cB cC cB cC cpr elprg ibi cA cB wceq cA cC wceq wo cA cB
      cC cpr wcel cA cB wceq cA cC wceq wo cA cvv wcel cA cB cC cpr wcel cA cB
      wceq cA cC wceq wo wb cA cB wceq cA cvv wcel cA cC wceq cA cB wceq cA cvv
      wcel cB cvv wcel elpr2.1 cA cB cvv eleq1 mpbiri cA cC wceq cA cvv wcel cC
      cvv wcel elpr2.2 cA cC cvv eleq1 mpbiri jaoi cA cB cC cvv elprg syl ibir
      impbii $.
      $( [16-Oct-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    hbpr.1 $e |- ( y e. A -> A. x y e. A ) $.
    hppr.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for unordered pairs. $)
    hbpr $p |- ( y e. { A , B } -> A. x y e. { A , B } ) $=
      vy cv cA wceq vy cv cB wceq wo vy cv cA wceq vy cv cB wceq wo vx wal vy
      cv cA cB cpr wcel vy cv cA cB cpr wcel vx wal vy cv cA wceq vy cv cB wceq
      vx vx vy cA hbpr.1 hbeleq vx vy cB hppr.2 hbeleq hbor vy cv cA cB vy
      visset elpr vy cv cA cB cpr wcel vy cv cA wceq vy cv cB wceq wo vx vy cv
      cA cB vy visset elpr albii 3imtr4i $.
      $( [14-Nov-1995] $)
  $}

  $( Membership of a conditional operator in an unordered pair. $)
  ifpr $p |- ( ( A e. C /\ B e. D ) -> if ( ph , A , B ) e. { A , B } ) $=
    cA cvv wcel cB cvv wcel wph cA cB cif cA cB cpr wcel cA cC wcel cB cD wcel
    cA cvv wcel cB cvv wcel wa wph cA cB cif cvv wcel wph cA cB cif cA cB cpr
    wcel wph cA cB cvv ifcl wph cA cB cif cvv wcel wph cA cB cif cA cB cpr wcel
    wph cA cB cif cA wceq wph cA cB cif cB wceq wo wph cA cB ifor wph cA cB cif
    cA cB cvv elprg mpbiri syl cA cC elisset cB cD elisset syl2an $.
    $( [20-Jun-2007] $) $( [17-Jun-2007] $)

  ${
    $d x A $.  $d x B $.
    ralpr.1 $e |- A e. _V $.
    ralpr.2 $e |- B e. _V $.
    $( Convert a quantification over a pair to a conjunction. $)
    ralpr $p |- ( A. x e. { A , B } ph <->
                ( [ A / x ] ph /\ [ B / x ] ph ) ) $=
      wph vx cA cB cpr wral vx cv cA cB cpr wcel wph wi vx wal vx cv cA wceq
      wph wi vx cv cB wceq wph wi wa vx wal wph vx cA wsbc wph vx cB wsbc wa
      wph vx cA cB cpr df-ral vx cv cA cB cpr wcel wph wi vx cv cA wceq wph wi
      vx cv cB wceq wph wi wa vx vx cv cA cB cpr wcel wph wi vx cv cA wceq vx
      cv cB wceq wo wph wi vx cv cA wceq wph wi vx cv cB wceq wph wi wa vx cv
      cA cB cpr wcel vx cv cA wceq vx cv cB wceq wo wph vx cv cA cB vx visset
      elpr imbi1i vx cv cA wceq wph vx cv cB wceq jaob bitri albii vx cv cA
      wceq wph wi vx cv cB wceq wph wi wa vx wal vx cv cA wceq wph wi vx wal vx
      cv cB wceq wph wi vx wal wa wph vx cA wsbc wph vx cB wsbc wa vx cv cA
      wceq wph wi vx cv cB wceq wph wi vx 19.26 wph vx cA wsbc vx cv cA wceq
      wph wi vx wal wph vx cB wsbc vx cv cB wceq wph wi vx wal wph vx cA
      ralpr.1 sbc6 wph vx cB ralpr.2 sbc6 anbi12i bitr4i 3bitri $.
      $( [3-Jun-2007] $) $( [3-Jun-2007] $)

    $( Convert an existential quantification over a pair to a disjunction. $)
    rexpr $p |- ( E. x e. { A , B } ph <->
                ( [ A / x ] ph \/ [ B / x ] ph ) ) $=
      wph wn vx cA cB cpr wral wn wph vx cA wsbc wn wph vx cB wsbc wn wa wn wph
      vx cA cB cpr wrex wph vx cA wsbc wph vx cB wsbc wo wph wn vx cA cB cpr
      wral wph vx cA wsbc wn wph vx cB wsbc wn wa wph wn vx cA cB cpr wral wph
      wn vx cA wsbc wph wn vx cB wsbc wa wph vx cA wsbc wn wph vx cB wsbc wn wa
      wph wn vx cA cB ralpr.1 ralpr.2 ralpr wph wn vx cA wsbc wph vx cA wsbc wn
      wph wn vx cB wsbc wph vx cB wsbc wn cA cvv wcel wph wn vx cA wsbc wph vx
      cA wsbc wn wb ralpr.1 wph vx cA cvv sbcng ax-mp cB cvv wcel wph wn vx cB
      wsbc wph vx cB wsbc wn wb ralpr.2 wph vx cB cvv sbcng ax-mp anbi12i bitri
      notbii wph vx cA cB cpr dfrex2 wph vx cA wsbc wph vx cB wsbc oran 3bitr4i
      $.
      $( [9-Jun-2007] $) $( [3-Jun-2007] $)
  $}

  ${
    $d x A $.
    ralsn.1 $e |- A e. _V $.
    $( MAY BE REVISED - derive from ralsng? $)
    $( Convert a quantification over a singleton to a substitution. $)
    ralsn $p |- (  A. x e. { A } ph <-> [ A / x ] ph ) $=
      wph vx cA csn wral wph vx cA cA cpr wral wph vx cA wsbc wph vx cA wsbc wa
      wph vx cA wsbc cA csn cA cA cpr wceq wph vx cA csn wral wph vx cA cA cpr
      wral wb cA dfsn2 wph vx cA csn cA cA cpr raleq1 ax-mp wph vx cA cA
      ralsn.1 ralsn.1 ralpr wph vx cA wsbc anidm 3bitri $.
      $( [1-May-2009] $) $( [27-Apr-2009] $)
  $}

  ${
    $d x A $.
    $( Substitution expressed in terms of quantification over a singleton. $)
    ralsng $p |- ( A e. B -> ( A. x e. { A } ph <-> [ A / x ] ph ) ) $=
      cA cB wcel wph vx cA wsbc vx cv cA wceq wph wi vx wal wph vx cA csn wral
      wph vx cA cB sbc6g wph vx cA csn wral vx cv cA csn wcel wph wi vx wal vx
      cv cA wceq wph wi vx wal wph vx cA csn df-ral vx cv cA csn wcel wph wi vx
      cv cA wceq wph wi vx vx cv cA csn wcel vx cv cA wceq wph vx cA elsn
      imbi1i albii bitri syl6rbbr $.
      $( [14-May-2009] $) $( [14-Dec-2005] $)

    $( MAY BE REVISED - make obsolete; use ralsng instead - also,
       shorten posn w/ ralsn or ralsng $)
    $( Substitution expressed in terms of quantification over a singleton. $)
    sbcsng $p |- ( A e. B -> ( [ A / x ] ph <-> A. x e. { A } ph ) ) $=
      cA cB wcel wph vx cA wsbc vx cv cA wceq wph wi vx wal wph vx cA csn wral
      wph vx cA cB sbc6g wph vx cA csn wral vx cv cA csn wcel wph wi vx wal vx
      cv cA wceq wph wi vx wal wph vx cA csn df-ral vx cv cA csn wcel wph wi vx
      cv cA wceq wph wi vx vx cv cA csn wcel vx cv cA wceq wph vx cA elsn
      imbi1i albii bitr2i syl6bb $.
      $( [22-Dec-2005] $) $( [14-Dec-2005] $)
  $}

  $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
     p. 15 (generalized). $)
  elsncg $p |- ( A e. C -> ( A e. { B } <-> A = B ) ) $=
    cA cC wcel cA cB cB cpr wcel cA cB wceq cA cB wceq wo cA cB csn wcel cA cB
    wceq cA cB cB cC elprg cB cB cpr cB csn cA cB csn cB cB cpr cB dfsn2 eqcomi
    eleq2i cA cB wceq oridm 3bitr3g $.
    $( [13-Sep-1995] $)

  ${
    elsnc.1 $e |- A e. _V $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15. $)
    elsnc $p |- ( A e. { B } <-> A = B ) $=
      cA cvv wcel cA cB csn wcel cA cB wceq wb elsnc.1 cA cB cvv elsncg ax-mp
      $.
      $( [13-Sep-1995] $)
  $}

  $( There is only one element in a singleton. $)
  elsni $p |- ( A e. { B } -> A = B ) $=
    cA cB csn wcel cA cB wceq cA cB cB csn elsncg ibi $.
    $( [5-Jun-1994] $)

  $( A set is a member of its singleton.  Part of Theorem 7.6 of [Quine]
     p. 49. $)
  snidg $p |- ( A e. B -> A e. { A } ) $=
    cA cB wcel cA cA csn wcel cA cA wceq cA eqid cA cA cB elsncg mpbiri $.
    $( [28-Oct-2003] $) $( [28-Oct-2003] $)

  $( A class is a set iff it is a member of its singleton. $)
  snidb $p |- ( A e. _V <-> A e. { A } ) $=
    cA cvv wcel cA cA csn wcel cA cvv snidg cA cA csn elisset impbii $.
    $( [7-Apr-2004] $) $( [5-Apr-2004] $)

  ${
    snid.1 $e |- A e. _V $.
    $( A set is a member of its singleton.  Part of Theorem 7.6 of [Quine]
       p. 49. $)
    snid $p |- A e. { A } $=
      cA cvv wcel cA cA csn wcel snid.1 cA snidb mpbi $.
      $( [31-Dec-1993] $)
  $}

  $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
     p. 15.  This variation requires only that ` B ` , rather than
     ` A ` , be a set. $)
  elsnc2g $p |- ( B e. C -> ( A e. { B } <-> A = B ) ) $=
    cB cC wcel cA cB csn wcel cA cB wceq cA cB elsni cA cB wceq cA cB csn wcel
    cB cB csn wcel cB cC wcel cA cB cB csn eleq1 cB cC snidg syl5cbir impbid2
    $.
    $( [28-Oct-2003] $) $( [28-Oct-2003] $)

  ${
    elsnc2.1 $e |- B e. _V $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15.  This variation requires only that ` B ` , rather than
       ` A ` , be a set. $)
    elsnc2 $p |- ( A e. { B } <-> A = B ) $=
      cB cvv wcel cA cB csn wcel cA cB wceq wb elsnc2.1 cA cB cvv elsnc2g ax-mp
      $.
      $( [12-Jun-1994] $)
  $}

  ${
    $d y A $.  $d x y $.
    hbsn.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for singletons. $)
    hbsn $p |- ( y e. { A } -> A. x y e. { A } ) $=
      vx vy cA csn cA cA cpr cA dfsn2 vx vy cA cA hbsn.1 hbsn.1 hbpr hbxfr $.
      $( [14-Nov-1995] $)
  $}

  ${
    eltp.1 $e |- A e. _V $.
    $( A member of an unordered triple of classes is one of them.  Special
       case of Exercise 1 of [TakeutiZaring] p. 17. $)
    eltp $p |- ( A e. { B , C , D } <-> ( A = B \/ A = C \/ A = D ) ) $=
      cA cB cC cD ctp wcel cA cB wceq cA cC wceq wo cA cD wceq wo cA cB wceq cA
      cC wceq cA cD wceq w3o cA cB cC cD ctp wcel cA cB cC cpr cD csn cun wcel
      cA cB cC cpr wcel cA cD csn wcel wo cA cB wceq cA cC wceq wo cA cD wceq
      wo cB cC cD ctp cB cC cpr cD csn cun cA cB cC cD df-tp eleq2i cA cB cC
      cpr cD csn elun cA cB cC cpr wcel cA cB wceq cA cC wceq wo cA cD csn wcel
      cA cD wceq cA cB cC eltp.1 elpr cA cD eltp.1 elsnc orbi12i 3bitri cA cB
      wceq cA cC wceq cA cD wceq df-3or bitr4i $.
      $( [8-Apr-1994] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Alternate definition of unordered triple of classes.  Special case of
       Definition 5.3 of [TakeutiZaring] p. 16. $)
    dftp2 $p |- { A , B , C } = { x | ( x = A \/ x = B \/ x = C ) } $=
      vx cv cA wceq vx cv cB wceq vx cv cC wceq w3o vx cA cB cC ctp vx cv cA cB
      cC vx visset eltp abbi2i $.
      $( [8-Apr-1994] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Intersection with the singleton of a non-member is disjoint. $)
    disjsn $p |- ( ( A i^i { B } ) = (/) <-> -. B e. A ) $=
      cA cB csn cin c0 wceq cB cA wcel wn cA cB csn cin c0 wceq cB cA cB csn
      cin wcel cB cA wcel cA cB csn cin c0 wceq cB cA cB csn cin wcel cB c0
      wcel cB noel cA cB csn cin c0 cB eleq2 mtbiri cB cA wcel cB cA wcel cB cB
      csn wcel wa cB cA cB csn cin wcel cB cA wcel cB cB csn wcel cB cA snidg
      ancli cB cA cB csn elin sylibr nsyl cB cA wcel wn vx cv cA wcel vx cv cB
      csn wcel wn wi vx wal cA cB csn cin c0 wceq cB cA wcel wn vx cv cA wcel
      vx cv cB csn wcel wn wi vx vx cv cA wcel cB cA wcel wn vx cv cB csn wcel
      wn vx cv cA wcel vx cv cB csn wcel cB cA wcel vx cv cA wcel vx cv cB wceq
      cB cA wcel vx cv cB csn wcel vx cv cB wceq vx cv cA wcel cB cA wcel vx cv
      cB cA eleq1 biimpcd vx cB elsn syl5ib con3d com12 19.21aiv vx cA cB csn
      disj1 sylibr impbii $.
      $( [22-May-1998] $)
  $}

  $( Intersection of distinct singletons is disjoint. $)
  disjsn2 $p |- ( A =/= B -> ( { A } i^i { B } ) = (/) ) $=
    cA cB wne cB cA csn wcel wn cA csn cB csn cin c0 wceq cB cA csn wcel cA cB
    cB cA csn wcel cB cA cB cA elsni eqcomd necon3ai cA csn cB disjsn sylibr $.
    $( [2-Jun-2007] $) $( [25-May-1998] $)

  ${
    $d x A $.
    $( The singleton of a proper class (one that doesn't exist) is the empty
       set.  Theorem 7.2 of [Quine] p. 48. $)
    snprc $p |- ( -. A e. _V <-> { A } = (/) ) $=
      cA csn c0 wceq cA cvv wcel vx cv cA csn wcel vx wex vx cv cA wceq vx wex
      cA csn c0 wceq wn cA cvv wcel vx cv cA csn wcel vx cv cA wceq vx vx cA
      elsn exbii vx cA csn neq0 vx cA isset 3bitr4i con1bii $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x y A $.  $d x B $.
    r19.12sn.1 $e |- A e. _V $.
    $( Special case of ~ r19.12 where its converse holds. $)
    r19.12sn $p |- ( E. x e. { A } A. y e. B ph
                <-> A. y e. B E. x e. { A } ph ) $=
      wph vy cB wral vx cA cA cpr wrex wph vx cA wsbc vy cB wral wph vy cB wral
      vx cA csn wrex wph vx cA csn wrex vy cB wral wph vy cB wral vx cA cA cpr
      wrex wph vy cB wral vx cA wsbc wph vy cB wral vx cA wsbc wo wph vy cB
      wral vx cA wsbc wph vx cA wsbc vy cB wral wph vy cB wral vx cA cA
      r19.12sn.1 r19.12sn.1 rexpr wph vy cB wral vx cA wsbc oridm cA cvv wcel
      wph vy cB wral vx cA wsbc wph vx cA wsbc vy cB wral wb r19.12sn.1 wph vx
      vy cA cB cvv sbcralg ax-mp 3bitri cA csn cA cA cpr wceq wph vy cB wral vx
      cA csn wrex wph vy cB wral vx cA cA cpr wrex wb cA dfsn2 wph vy cB wral
      vx cA csn cA cA cpr rexeq1 ax-mp wph vx cA csn wrex wph vx cA wsbc vy cB
      wph vx cA csn wrex wph vx cA cA cpr wrex wph vx cA wsbc wph vx cA wsbc wo
      wph vx cA wsbc cA csn cA cA cpr wceq wph vx cA csn wrex wph vx cA cA cpr
      wrex wb cA dfsn2 wph vx cA csn cA cA cpr rexeq1 ax-mp wph vx cA cA
      r19.12sn.1 r19.12sn.1 rexpr wph vx cA wsbc oridm 3bitri ralbii 3bitr4i $.
      $( [19-May-2008] $) $( [19-May-2008] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Condition where a restricted class abstraction is a singleton. $)
    rabsn $p |- ( B e. A -> { x e. A | x = B } = { B } ) $=
      cB cA wcel vx cv cA wcel vx cv cB wceq wa vx cab vx cv cB wceq vx cab vx
      cv cB wceq vx cA crab cB csn cB cA wcel vx cv cA wcel vx cv cB wceq wa vx
      cv cB wceq vx vx cv cA wcel vx cv cB wceq wa cB cA wcel vx cv cB wceq vx
      cv cB wceq vx cv cA wcel cB cA wcel vx cv cB cA eleq1 pm5.32ri baib
      abbidv vx cv cB wceq vx cA df-rab vx cB df-sn 3eqtr4g $.
      $( [12-Jul-2006] $) $( [28-May-2006] $)
  $}

  ${
    $d x y z $.  $d y ph $.
    $( Another way to express existential uniqueness of a wff:  its class
       abstraction is a singleton. $)
    euabsn $p |- ( E! x ph <-> E. x { x | ph } = { x } ) $=
      wph vx cab vy cv csn wceq vy wex wph vx cv vy cv wceq wb vx wal vy wex
      wph vx cab vx cv csn wceq vx wex wph vx weu wph vx cab vy cv csn wceq wph
      vx cv vy cv wceq wb vx wal vy wph vx cab vy cv csn wceq wph vx cv vy cv
      csn wcel wb vx wal wph vx cv vy cv wceq wb vx wal wph vx vy cv csn abeq1
      wph vx cv vy cv csn wcel wb wph vx cv vy cv wceq wb vx vx cv vy cv csn
      wcel vx cv vy cv wceq wph vx vy cv elsn bibi2i albii bitri exbii wph vx
      cab vx cv csn wceq wph vx cab vy cv csn wceq vx vy wph vx cab vx cv csn
      wceq vy ax-17 vx vy vz wph vx cab vy cv csn wph vx vy hbab1 vz cv vy cv
      csn wcel vx ax-17 hbeq vx cv vy cv wceq vx cv csn vy cv csn wph vx cab vx
      cv vy cv sneq eqeq2d cbvex wph vx vy df-eu 3bitr4ri $.
      $( [22-Feb-2004] $) $( [22-Feb-2004] $)
  $}

  ${
    $d x A $.
    $( Two ways to express " ` A ` is a singleton." $)
    eusn $p |- ( E! x x e. A <-> E. x A = { x } ) $=
      vx cv cA wcel vx weu vx cv cA wcel vx cab vx cv csn wceq vx wex cA vx cv
      csn wceq vx wex vx cv cA wcel vx euabsn vx cv cA wcel vx cab vx cv csn
      wceq cA vx cv csn wceq vx vx cv cA wcel vx cab cA vx cv csn vx cA abid2
      eqeq1i exbii bitri $.
      $( [7-Nov-2010] $) $( [30-Oct-2010] $)
  $}

  $( Commutative law for unordered pairs. $)
  prcom $p |- { A , B } = { B , A } $=
    cA csn cB csn cun cB csn cA csn cun cA cB cpr cB cA cpr cA csn cB csn uncom
    cA cB df-pr cB cA df-pr 3eqtr4i $.
    $( [5-Aug-1993] $)

  $( An equality theorem for unordered pairs. $)
  preq1 $p |- ( A = B -> { A , C } = { B , C } ) $=
    cA cB wceq cA csn cC csn cun cB csn cC csn cun cA cC cpr cB cC cpr cA cB
    wceq cA csn cB csn cC csn cA cB sneq uneq1d cA cC df-pr cB cC df-pr 3eqtr4g
    $.
    $( [29-Mar-1998] $)

  $( An equality theorem for unordered pairs. $)
  preq2 $p |- ( A = B -> { C , A } = { C , B } ) $=
    cA cB wceq cA cC cpr cB cC cpr cC cA cpr cC cB cpr cA cB cC preq1 cC cA
    prcom cC cB prcom 3eqtr4g $.
    $( [5-Aug-1993] $)

  $( An unordered pair contains its first member.  Part of Theorem 7.6 of
     [Quine] p. 49.  (Contributed by Stefan Allan, 8-Nov-2008.) $)
  prid1g $p |- ( A e. C -> A e. { A , B } ) $=
    cA cC wcel cA cA cB cpr wcel cA cA wceq cA cB wceq wo cA cA wceq cA cB wceq
    cA eqid orci cA cA cB cC elprg mpbiri $.
    $( [8-Nov-2008] $) $( [7-Nov-2008] $)

  $( An unordered pair contains its second member.  Part of Theorem 7.6 of
     [Quine] p. 49.  (Contributed by Stefan Allan, 8-Nov-2008.) $)
  prid2g $p |- ( B e. C -> B e. { A , B } ) $=
    cB cC wcel cB cB cA cpr cA cB cpr cB cA cC prid1g cB cA prcom syl6eleq $.
    $( [8-Nov-2008] $) $( [7-Nov-2008] $)

  ${
    pri1.1 $e |- A e. _V $.
    $( An unordered pair contains its first member.  Part of Theorem 7.6 of
       [Quine] p. 49. $)
    prid1 $p |- A e. { A , B } $=
      cA cvv wcel cA cA cB cpr wcel pri1.1 cA cB cvv prid1g ax-mp $.
      $( [5-Aug-1993] $)
  $}

  ${
    pri2.1 $e |- B e. _V $.
    $( An unordered pair contains its second member.  Part of Theorem 7.6 of
       [Quine] p. 49. $)
    prid2 $p |- B e. { A , B } $=
      cB cB cA cpr cA cB cpr cB cA pri2.1 prid1 cB cA prcom eleqtri $.
      $( [5-Aug-1993] $)
  $}

  $( A proper class vanishes in an unordered pair. $)
  prprc1 $p |- ( -. A e. _V -> { A , B } = { B } ) $=
    cA cvv wcel wn cA csn c0 wceq cA cB cpr cB csn wceq cA snprc cA csn c0 wceq
    cA csn cB csn cun c0 cB csn cun cA cB cpr cB csn cA csn c0 cB csn uneq1 cA
    cB df-pr c0 cB csn cun cB csn c0 cun cB csn c0 cB csn uncom cB csn un0
    eqtr2i 3eqtr4g sylbi $.
    $( [5-Aug-1993] $)

  $( A proper class vanishes in an unordered pair. $)
  prprc2 $p |- ( -. B e. _V -> { A , B } = { A } ) $=
    cB cvv wcel wn cB cA cpr cA csn cA cB cpr cB cA prprc1 cA cB prcom syl5eq
    $.
    $( [10-Apr-2006] $) $( [22-Mar-2006] $)

  $( An unordered pair containing two proper classes is the empty set. $)
  prprc $p |- ( ( -. A e. _V /\ -. B e. _V ) -> { A , B } = (/) ) $=
    cA cvv wcel wn cB cvv wcel wn cA cB cpr cB csn c0 cA cB prprc1 cB cvv wcel
    wn cB csn c0 wceq cB snprc biimpi sylan9eq $.
    $( [2-May-2006] $) $( [22-Mar-2006] $)

  ${
    tpi1.1 $e |- A e. _V $.
    $( One of the three elements of an unordered triple. $)
    tpi1 $p |- A e. { A , B , C } $=
      cA cA cB cpr wcel cA cA cB cC ctp wcel cA cB tpi1.1 prid1 cA cA cB cpr
      wcel cA cA cB cpr cC csn cun cA cB cC ctp cA cA cB cpr cC csn elun1 cA cB
      cC df-tp syl6eleqr ax-mp $.
      $( [7-Apr-1994] $)
  $}

  ${
    tpi2.1 $e |- B e. _V $.
    $( One of the three elements of an unordered triple. $)
    tpi2 $p |- B e. { A , B , C } $=
      cB cA cB cpr wcel cB cA cB cC ctp wcel cA cB tpi2.1 prid2 cB cA cB cpr
      wcel cB cA cB cpr cC csn cun cA cB cC ctp cB cA cB cpr cC csn elun1 cA cB
      cC df-tp syl6eleqr ax-mp $.
      $( [7-Apr-1994] $)
  $}

  ${
    tpi3.1 $e |- C e. _V $.
    $( One of the three elements of an unordered triple. $)
    tpi3 $p |- C e. { A , B , C } $=
      cC cC csn wcel cC cA cB cC ctp wcel cC tpi3.1 snid cC cC csn wcel cC cA
      cB cpr cC csn cun cA cB cC ctp cC cC csn cA cB cpr elun2 cA cB cC df-tp
      syl6eleqr ax-mp $.
      $( [7-Apr-1994] $)
  $}

  $( The singleton of a set is not empty. $)
  snnzg $p |- ( A e. B -> { A } =/= (/) ) $=
    cA cB wcel cA cA csn wcel cA csn c0 wne cA cB snidg cA csn cA ne0i syl $.
    $( [14-Dec-2008] $) $( [14-Dec-2008] $)

  ${
    snnz.1 $e |- A e. _V $.
    $( The singleton of a set is not empty. $)
    snnz $p |- { A } =/= (/) $=
      cA cvv wcel cA csn c0 wne snnz.1 cA cvv snnzg ax-mp $.
      $( [2-Apr-2007] $) $( [10-Apr-1994] $)
  $}

  ${
    prnz.1 $e |- A e. _V $.
    $( A pair containing a set is not empty. $)
    prnz $p |- { A , B } =/= (/) $=
      cA cA cB cpr wcel cA cB cpr c0 wne cA cB prnz.1 prid1 cA cB cpr cA ne0i
      ax-mp $.
      $( [17-Jan-2007] $) $( [9-Apr-1994] $)
  $}

  ${
    tpnz.1 $e |- A e. _V $.
    $( A triplet containing a set is not empty. $)
    tpnz $p |- { A , B , C } =/= (/) $=
      cA cA cB cC ctp wcel cA cB cC ctp c0 wne cA cB cC tpnz.1 tpi1 cA cB cC
      ctp cA ne0i ax-mp $.
      $( [13-Apr-2007] $) $( [10-Apr-1994] $)
  $}

  ${
    $d A x $.  $d B x $.
    snss.1 $e |- A e. _V $.
    $( The singleton of an element of a class is a subset of the class.
       Theorem 7.4 of [Quine] p. 49. $)
    snss $p |- ( A e. B <-> { A } C_ B ) $=
      vx cv cA csn wcel vx cv cB wcel wi vx wal vx cv cA wceq vx cv cB wcel wi
      vx wal cA csn cB wss cA cB wcel vx cv cA csn wcel vx cv cB wcel wi vx cv
      cA wceq vx cv cB wcel wi vx vx cv cA csn wcel vx cv cA wceq vx cv cB wcel
      vx cA elsn imbi1i albii vx cA csn cB dfss2 vx cA cB snss.1 clel2 3bitr4ri
      $.
      $( [5-Aug-1993] $)
  $}

  $( Membership in a set with an element removed. $)
  eldifsn $p |- ( A e. ( B \ { C } ) <-> ( A e. B /\ A =/= C ) ) $=
    cA cB cC csn cdif wcel cA cB wcel cA cC csn wcel wn wa cA cB wcel cA cC wne
    wa cA cB cC csn eldif cA cB wcel cA cC csn wcel wn cA cC wne cA cB wcel cA
    cC csn wcel cA cC cA cC cB elsncg necon3bbid pm5.32i bitri $.
    $( [11-Oct-2007] $) $( [10-Oct-2007] $)

  ${
    $d A x $.  $d B x $.
    $( The singleton of an element of a class is a subset of the class.
       Theorem 7.4 of [Quine] p. 49. $)
    snssg $p |- ( A e. C -> ( A e. B <-> { A } C_ B ) ) $=
      vx cv cB wcel vx cv csn cB wss cA cB wcel cA csn cB wss vx cA cC vx cv cA
      cB eleq1 vx cv cA wceq vx cv csn cA csn cB vx cv cA sneq sseq1d vx cv cB
      vx visset snss vtoclbg $.
      $( [22-Jul-2001] $)

    $( An element not in a set can be removed without affecting the set. $)
    difsn $p |- ( -. A e. B -> ( B \ { A } ) = B ) $=
      cA cB wcel wn cB cA csn cdif cB cB cA csn cdif cB wss cA cB wcel wn cB cA
      csn difss a1i cA cB wcel wn vx cB cB cA csn cdif cA cB wcel wn vx cv cB
      wcel vx cv cB wcel vx cv cA wne wa vx cv cB cA csn cdif wcel cA cB wcel
      wn vx cv cB wcel vx cv cA wne vx cv cB wcel cA cB wcel wn vx cv cA wne vx
      cv cB wcel cA cB wcel wn wa vx cv cA wceq wn vx cv cA wne vx cv cA cB
      nelneq vx cv cA df-ne sylibr expcom ancld vx cv cB cA eldifsn syl6ibr
      ssrdv eqssd $.
      $( [16-Mar-2006] $) $( [16-Mar-2006] $)

    $( Removal of a singleton from an unordered pair. $)
    difprsn $p |- ( { A , B } \ { A } ) C_ { B } $=
      vx cA cB cpr cA csn cdif cB csn vx cv cB wceq vx cv cA wceq wn wa vx cv
      cB wceq vx cv cA cB cpr cA csn cdif wcel vx cv cB csn wcel vx cv cB wceq
      vx cv cA wceq wn pm3.26 vx cv cA cB cpr cA csn cdif wcel vx cv cA cB cpr
      wcel vx cv cA wne wa vx cv cB wceq vx cv cA wceq wo vx cv cA wceq wn wa
      vx cv cB wceq vx cv cA wceq wn wa vx cv cA cB cpr cA eldifsn vx cv cA cB
      cpr wcel vx cv cB wceq vx cv cA wceq wo vx cv cA wne vx cv cA wceq wn vx
      cv cA cB cpr wcel vx cv cA wceq vx cv cB wceq wo vx cv cB wceq vx cv cA
      wceq wo vx cv cA cB vx visset elpr vx cv cA wceq vx cv cB wceq orcom
      bitri vx cv cA df-ne anbi12i vx cv cB wceq vx cv cA wceq pm5.61 3bitri vx
      cB elsn 3imtr4i ssriv $.
      $( [16-Mar-2006] $) $( [16-Mar-2006] $)
  $}

  $( The singleton of an element of a class is a subset of the class. $)
  snssi $p |- ( A e. B -> { A } C_ B ) $=
    cA cB wcel cA csn cB wss cA cB cB snssg ibi $.
    $( [6-Jun-1994] $)

  $( If we remove a single element from a class then put it back in, we end up
     with the original class. $)
  difsnid $p |- ( B e. A -> ( ( A \ { B } ) u. { B } ) = A ) $=
    cB cA wcel cB csn cA cB csn cdif cun cA cA cB csn cdif cB csn cun cB cA
    wcel cB csn cA wss cB csn cA cB csn cdif cun cA wceq cB cA snssi cB csn cA
    undif sylib cA cB csn cdif cB csn uncom syl5eq $.
    $( [3-Oct-2006] $) $( [2-Oct-2006] $)

  $( Note that ` x ` is a dummy variable in the proof below. $)
  $( Compute the power set of the empty set.  Theorem 89 of [Suppes] p. 47.
     (The proof was shortened by Eric Schmidt, 4-Apr-2007.) $)
  pw0 $p |- ~P (/) = { (/) } $=
    c0 cpw vx cv c0 wceq vx cab c0 csn vx cv c0 wceq vx c0 cpw vx cv c0 cpw
    wcel vx cv c0 wss vx cv c0 wceq vx cv c0 wss vx c0 cpw vx c0 df-pw abeq2i
    vx cv ss0b bitri abbi2i vx c0 df-sn eqtr4i $.
    $( [4-Apr-2007] $) $( [5-Aug-1993] $)

  ${
    $d x y $.
    $( Compute the power set of the power set of the empty set.  (See ~ pw0
       for the power set of the empty set.)  Theorem 90 of [Suppes] p. 48.
       Although this theorem is a special case of ~ pwsn , we have chosen to
       show a direct elementary proof. $)
    pwpw0 $p |- ~P { (/) } = { (/) , { (/) } } $=
      vx cv c0 csn wss vx cab vx cv c0 wceq vx cv c0 csn wceq wo vx cab c0 csn
      cpw c0 c0 csn cpr vx cv c0 csn wss vx cv c0 wceq vx cv c0 csn wceq wo vx
      vx cv c0 csn wss vx cv c0 wceq vx cv c0 csn wceq wo vx cv c0 csn wss vx
      cv c0 wceq vx cv c0 csn wceq vx cv c0 csn wss vx cv c0 wceq wn vx cv c0
      csn wss c0 csn vx cv wss wa vx cv c0 csn wceq vx cv c0 csn wss vx cv c0
      wceq wn c0 csn vx cv wss vx cv c0 csn wss vy cv vx cv wcel vy cv c0 wceq
      wi vy wal vx cv c0 wceq wn c0 csn vx cv wss wi vx cv c0 csn wss vy cv vx
      cv wcel vy cv c0 csn wcel wi vy wal vy cv vx cv wcel vy cv c0 wceq wi vy
      wal vy vx cv c0 csn dfss2 vy cv vx cv wcel vy cv c0 csn wcel wi vy cv vx
      cv wcel vy cv c0 wceq wi vy vy cv c0 csn wcel vy cv c0 wceq vy cv vx cv
      wcel vy c0 elsn imbi2i albii bitri vy cv vx cv wcel vy cv c0 wceq wi vy
      wal vx cv c0 wceq wn vy cv vx cv wcel vy cv c0 wceq wa vy wex c0 csn vx
      cv wss vy cv vx cv wcel vy cv c0 wceq wi vy wal vy cv vx cv wcel vy wex
      vy cv vx cv wcel vy cv c0 wceq wa vy wex vx cv c0 wceq wn vy cv vx cv
      wcel vy cv c0 wceq vy exintr vy vx cv neq0 syl5ib vy cv vx cv wcel vy cv
      c0 wceq wa vy wex c0 vx cv wcel c0 csn vx cv wss vy cv vx cv wcel vy cv
      c0 wceq wa vy wex vy cv c0 wceq vy cv vx cv wcel wa vy wex c0 vx cv wcel
      vy cv vx cv wcel vy cv c0 wceq vy exancom vy c0 vx cv df-clel bitr4i c0
      vx cv snssi sylbi syl6 sylbi anc2li vx cv c0 csn eqss syl6ibr orrd vx cv
      c0 wceq vx cv c0 csn wss vx cv c0 csn wceq vx cv c0 wceq vx cv c0 csn wss
      c0 c0 csn wss c0 csn 0ss vx cv c0 c0 csn sseq1 mpbiri vx cv c0 csn eqimss
      jaoi impbii abbii vx c0 csn df-pw vx c0 c0 csn dfpr2 3eqtr4i $.
      $( [28-Sep-2006] $) $( [7-Aug-1994] $)
  $}

  $( A singleton is a subset of an unordered pair containing its member. $)
  snsspr1 $p |- { A } C_ { A , B } $=
    cA cvv wcel cA csn cA cB cpr wss cA cvv wcel cA cA cB cpr wcel cA csn cA cB
    cpr wss cA cvv wcel cA cA cB cpr wcel cA cA wceq cA cB wceq wo cA cA wceq
    cA cB wceq cA eqid orci cA cA cB cvv elprg mpbiri cA cA cB cpr snssi syl cA
    cvv wcel wn cA csn c0 cA cB cpr cA cvv wcel wn cA csn c0 wceq cA snprc
    biimpi c0 cA cB cpr wss cA cvv wcel wn cA cB cpr 0ss a1i eqsstrd pm2.61i $.
    $( [29-Aug-2004] $) $( [27-Aug-2004] $)

  $( A singleton is a subset of an unordered pair containing its member. $)
  snsspr2 $p |- { B } C_ { A , B } $=
    cB csn cB cA cpr cA cB cpr cB cA snsspr1 cB cA prcom sseqtri $.
    $( [1-May-2009] $) $( [2-May-2009] $)

  ${
    $d A x $.  $d B x $.  $d C x $.
    prss.1 $e |- A e. _V $.
    prss.2 $e |- B e. _V $.
    $( A pair of elements of a class is a subset of the class.  Theorem 7.5 of
       [Quine] p. 49. $)
    prss $p |- ( ( A e. C /\ B e. C ) <-> { A , B } C_ C ) $=
      cA cC wcel cB cC wcel wa cA cB cpr cC wss cA cC wcel cB cC wcel wa vx cA
      cB cpr cC cA cC wcel cB cC wcel wa vx cv cA wceq vx cv cB wceq wo vx cv
      cC wcel vx cv cA cB cpr wcel cA cC wcel vx cv cA wceq vx cv cC wcel cB cC
      wcel vx cv cB wceq cA cC vx cv eleq1a cB cC vx cv eleq1a jaao vx cv cA cB
      vx visset elpr syl5ib ssrdv cA cB cpr cC wss cA cC wcel cB cC wcel cA cB
      cpr cC wss cA cA cB cpr wcel cA cC wcel cA cB prss.1 prid1 cA cB cpr cC
      cA ssel mpi cA cB cpr cC wss cB cA cB cpr wcel cB cC wcel cA cB prss.2
      prid2 cA cB cpr cC cB ssel mpi jca impbii $.
      $( [30-May-1994] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.
    $( A pair of elements of a class is a subset of the class.  Theorem 7.5 of
       [Quine] p. 49. $)
    prssg $p |- ( ( A e. R /\ B e. S ) ->
                ( ( A e. C /\ B e. C ) <-> { A , B } C_ C ) ) $=
      vx cv cC wcel vy cv cC wcel wa vx cv vy cv cpr cC wss wb cA cC wcel vy cv
      cC wcel wa cA vy cv cpr cC wss wb cA cC wcel cB cC wcel wa cA cB cpr cC
      wss wb vx vy cA cB cR cS vx cv cA wceq vx cv cC wcel vy cv cC wcel wa cA
      cC wcel vy cv cC wcel wa vx cv vy cv cpr cC wss cA vy cv cpr cC wss vx cv
      cA wceq vx cv cC wcel cA cC wcel vy cv cC wcel vx cv cA cC eleq1 anbi1d
      vx cv cA wceq vx cv vy cv cpr cA vy cv cpr cC vx cv cA vy cv preq1 sseq1d
      bibi12d vy cv cB wceq cA cC wcel vy cv cC wcel wa cA cC wcel cB cC wcel
      wa cA vy cv cpr cC wss cA cB cpr cC wss vy cv cB wceq vy cv cC wcel cB cC
      wcel cA cC wcel vy cv cB cC eleq1 anbi2d vy cv cB wceq cA vy cv cpr cA cB
      cpr cC vy cv cB cA preq2 sseq1d bibi12d vx cv vy cv cC vx visset vy
      visset prss vtocl2g $.
      $( [27-Mar-2006] $) $( [22-Mar-2006] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The subsets of a singleton. $)
    sssn $p |- ( A C_ { B } <-> ( A = (/) \/ A = { B } ) ) $=
      cA cB csn wss cA c0 wceq cA cB csn wceq wo cA cB csn wss cA c0 wceq cA cB
      csn wceq cA cB csn wss cA c0 wceq wn cA cB csn wss cB csn cA wss wa cA cB
      csn wceq cA cB csn wss cA c0 wceq wn cB csn cA wss cA cB csn wss cA c0
      wceq wn cB cA wcel cB csn cA wss cA cB csn wss vx cv cA wcel vx wex cB cA
      wcel cA c0 wceq wn cA cB csn wss vx cv cA wcel cB cA wcel vx cA cB csn
      wss vx cv cA wcel cB cA wcel cA cB csn wss vx cv cA wcel vx cv cB wceq vx
      cv cA wcel cB cA wcel wb cA cB csn wss vx cv cA wcel vx cv cB csn wcel vx
      cv cB wceq cA cB csn vx cv ssel vx cv cB elsni syl6 vx cv cB cA eleq1
      syl6 ibd 19.23adv vx cA neq0 syl5ib cB cA snssi syl6 anc2li cA cB csn
      eqss syl6ibr orrd cA c0 wceq cA cB csn wss cA cB csn wceq cA c0 wceq cA
      cB csn wss c0 cB csn wss cB csn 0ss cA c0 cB csn sseq1 mpbiri cA cB csn
      eqimss jaoi impbii $.
      $( [14-May-2004] $) $( [24-Apr-2004] $)

    $( Two ways to express that a nonempty set equals a singleton. $)
    eqsn $p |- ( A =/= (/) -> ( A = { B } <-> A. x e. A x = B ) ) $=
      cA c0 wne cA cB csn wceq cA cB csn wss vx cv cB wceq vx cA wral cA c0 wne
      cA cB csn wceq cA cB csn wss cA cB csn eqimss cA cB csn wss cA c0 wne cA
      cB csn wceq cA cB csn wss cA c0 wceq wn cA cB csn wceq cA c0 wne cA cB
      csn wss cA c0 wceq cA cB csn wceq cA cB csn wss cA c0 wceq cA cB csn wceq
      wo cA cB sssn biimpi ord cA c0 df-ne syl5ib com12 impbid2 cA cB csn wss
      vx cv cB csn wcel vx cA wral vx cv cB wceq vx cA wral vx cA cB csn dfss3
      vx cv cB csn wcel vx cv cB wceq vx cA vx cB elsn ralbii bitri syl6bb $.
      $( [15-Dec-2007] $) $( [15-Dec-2007] $)
  $}

  ${
    $( The subsets of a pair. $)
    sspr $p |- ( A C_ { B , C } <->
     ( ( A = (/) \/ A = { B } ) \/ ( A = { C } \/ A = { B , C } ) ) ) $=
      cA cB cC cpr wss cA c0 wceq cA cB csn wceq wo cA cC csn wceq cA cB cC cpr
      wceq wo wo cA cB cC cpr wss cA c0 wceq cA cB csn wceq wo cA cC csn wceq
      cA cB cC cpr wceq wo cA cB cC cpr wss cA c0 wceq cA cB csn wceq wo wn cA
      cC csn wceq cA cB cC cpr wceq wo cA cB cC cpr wss cA c0 wceq cA cB csn
      wceq wo wn wa cA cC csn wceq cA cB cC cpr wceq cA cB cC cpr wss cA c0
      wceq cA cB csn wceq wo wn wa cA cC csn wceq wn cA cB cC cpr wceq cA cB cC
      cpr wss cA c0 wceq cA cB csn wceq wo wn wa cA cC csn wceq wn wa cA cB cC
      cpr cA cB cC cpr wss cA c0 wceq cA cB csn wceq wo wn cA cC csn wceq wn
      simpll cB cA wcel cC cA wcel cB cC cpr cA wss cA cB cC cpr wss cA c0 wceq
      cA cB csn wceq wo wn wa cA cC csn wceq wn wa cB cA wcel cC cA wcel wa cB
      cC cpr cA wss cB cC cA cA cA prssg ibi cA cB cC cpr wss cA c0 wceq cA cB
      csn wceq wo wn cA cC csn wceq wn cB cA wcel cA cB cC cpr wss cA c0 wceq
      cA cC csn wceq wo wn cB cA wcel cA c0 wceq cA cB csn wceq wo wn cA cC csn
      wceq wn wa cA cB cC cpr wss cA c0 wceq cA cC csn wceq wo wn cB cA wcel cA
      cB cC cpr wss cB cA wcel cA c0 wceq cA cC csn wceq wo cA cB cC cpr wss cB
      cA wcel wn cA cC csn wss cA c0 wceq cA cC csn wceq wo cA cB cC cpr wss cB
      cA wcel wn cA cC csn wss cA cB cC cpr wss cB cA wcel wn wa cA cA cB csn
      cdif cC csn cB cA wcel wn cA cB csn cdif cA wceq cA cB cC cpr wss cB cA
      difsn adantl cA cB cC cpr wss cA cB csn cdif cC csn wss cB cA wcel wn cA
      cB cC cpr wss cA cB csn cdif cB cC cpr cB csn cdif cC csn cA cB cC cpr cB
      csn ssdif cB cC cpr cB csn cdif cC csn wss cA cB cC cpr wss cB cC difprsn
      a1i sstrd adantr eqsstr3d ex cA cC sssn syl6ib con1d imp cA c0 wceq cA cB
      csn wceq wo wn cA cC csn wceq wn wa cA c0 wceq wn cA cC csn wceq wn wa cA
      c0 wceq cA cC csn wceq wo wn cA c0 wceq cA cB csn wceq wo wn cA c0 wceq
      wn cA cC csn wceq wn cA c0 wceq cA cB csn wceq pm2.45 anim1i cA c0 wceq
      cA cC csn wceq ioran sylibr sylan2 anassrs cA cB cC cpr wss cA c0 wceq cA
      cB csn wceq wo wn wa cC cA wcel cA cC csn wceq wn cA cB cC cpr wss cA c0
      wceq cA cB csn wceq wo wn cC cA wcel cA cB cC cpr wss cC cA wcel cA c0
      wceq cA cB csn wceq wo cA cB cC cpr wss cC cA wcel wn cA cB csn wss cA c0
      wceq cA cB csn wceq wo cA cB cC cpr wss cC cA wcel wn cA cB csn wss cA cB
      cC cpr wss cC cA wcel wn wa cA cA cC csn cdif cB csn cC cA wcel wn cA cC
      csn cdif cA wceq cA cB cC cpr wss cC cA difsn adantl cA cB cC cpr wss cC
      cA wcel wn wa cA cC csn cdif cC cB cpr cC csn cdif cB csn cA cB cC cpr
      wss cA cC csn cdif cC cB cpr cC csn cdif wss cC cA wcel wn cA cB cC cpr
      wss cA cC cB cpr wss cA cC csn cdif cC cB cpr cC csn cdif wss cB cC cpr
      cC cB cpr cA cB cC prcom sseq2i cA cC cB cpr cC csn ssdif sylbi adantr cC
      cB cpr cC csn cdif cB csn wss cA cB cC cpr wss cC cA wcel wn wa cC cB
      difprsn a1i sstrd eqsstr3d ex cA cB sssn syl6ib con1d imp adantr sylanc
      eqssd ex orrd ex orrd cA c0 wceq cA cB csn wceq wo cA cB cC cpr wss cA cC
      csn wceq cA cB cC cpr wceq wo cA c0 wceq cA cB cC cpr wss cA cB csn wceq
      cA c0 wceq cA cB cC cpr wss c0 cB cC cpr wss cB cC cpr 0ss cA c0 cB cC
      cpr sseq1 mpbiri cA cB csn wceq cA cB cC cpr wss cB csn cB cC cpr wss cB
      cC snsspr1 cA cB csn cB cC cpr sseq1 mpbiri jaoi cA cC csn wceq cA cB cC
      cpr wss cA cB cC cpr wceq cA cC csn wceq cA cB cC cpr wss cC csn cB cC
      cpr wss cB cC snsspr2 cA cC csn cB cC cpr sseq1 mpbiri cA cB cC cpr
      eqimss jaoi jaoi impbii $.
      $( [28-Mar-2006] $) $( [16-Mar-2006] $)
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.  $d D x $.
    tpss.1 $e |- A e. _V $.
    tpss.2 $e |- B e. _V $.
    tpss.3 $e |- C e. _V $.
    $( A triplet of elements of a class is a subset of the class. $)
    tpss $p |- ( ( A e. D /\ B e. D /\ C e. D ) <-> { A , B , C } C_ D ) $=
      cA cD wcel cB cD wcel cC cD wcel w3a cA cB cC ctp cD wss cA cD wcel cB cD
      wcel cC cD wcel w3a vx cA cB cC ctp cD cA cD wcel cB cD wcel cC cD wcel
      w3a vx cv cA wceq vx cv cB wceq vx cv cC wceq w3o vx cv cD wcel vx cv cA
      cB cC ctp wcel vx cv cA wceq vx cv cD wcel wi vx cv cB wceq vx cv cD wcel
      wi vx cv cC wceq vx cv cD wcel wi vx cv cA wceq vx cv cB wceq vx cv cC
      wceq w3o vx cv cD wcel wi cA cD wcel cB cD wcel cC cD wcel vx cv cA wceq
      vx cv cD wcel vx cv cB wceq vx cv cC wceq 3jao cA cD vx cv eleq1a cB cD
      vx cv eleq1a cC cD vx cv eleq1a syl3an vx cv cA cB cC vx visset eltp
      syl5ib ssrdv cA cB cC ctp cD wss cA cD wcel cB cD wcel cC cD wcel cA cB
      cC ctp cD wss cA cA cB cC ctp wcel cA cD wcel cA cB cC tpss.1 tpi1 cA cB
      cC ctp cD cA ssel mpi cA cB cC ctp cD wss cB cA cB cC ctp wcel cB cD wcel
      cA cB cC tpss.2 tpi2 cA cB cC ctp cD cB ssel mpi cA cB cC ctp cD wss cC
      cA cB cC ctp wcel cC cD wcel cA cB cC tpss.3 tpi3 cA cB cC ctp cD cC ssel
      mpi 3jca impbii $.
      $( [9-Apr-1994] $)
  $}

  ${
    sneqr.1 $e |- A e. _V $.
    $( If the singletons of two sets are equal, the two sets are equal.
       Part of Exercise 4 of [TakeutiZaring] p. 15. $)
    sneqr $p |- ( { A } = { B } -> A = B ) $=
      cA csn cB csn wceq cA cB csn wcel cA cB wceq cA csn cB csn wceq cA cA csn
      wcel cA cB csn wcel cA sneqr.1 snid cA csn cB csn cA eleq2 mpbii cA cB
      sneqr.1 elsnc sylib $.
      $( [27-Aug-1993] $)

    $( If a singleton is a subset of another, their members are equal. $)
    snsssn $p |- ( { A } C_ { B } -> A = B ) $=
      cA csn cB csn wss cA csn c0 wceq cA csn cB csn wceq wo cA cB wceq cA csn
      cB sssn cA csn c0 wceq cA cB wceq cA csn cB csn wceq cA csn c0 wceq cA cB
      wceq cA csn c0 wne cA csn c0 wceq wn cA sneqr.1 snnz cA csn c0 df-ne mpbi
      pm2.21i cA cB sneqr.1 sneqr jaoi sylbi $.
      $( [29-May-2006] $) $( [28-May-2006] $)
  $}

  ${
    $d x A $.
    $( The singleton of a class is a subset of its power class. $)
    snsspw $p |- { A } C_ ~P A $=
      vx cA csn cA cpw vx cv cA wceq vx cv cA wss vx cv cA csn wcel vx cv cA
      cpw wcel vx cv cA eqimss vx cA elsn vx cv cA wss vx cA cpw vx cA df-pw
      abeq2i 3imtr4i ssriv $.
      $( [5-Aug-1993] $)
  $}


  ${
    $d x A $.  $d x B $.  $d x C $.
    prsspw.1 $e |- A e. _V $.
    prsspw.2 $e |- B e. _V $.
    $( An unordered pair belongs to the power class of a class iff each member
       belongs to the class. $)
    prsspw $p |- ( { A , B } C_ ~P C <-> ( A C_ C /\ B C_ C ) ) $=
      cA cB cpr cC cpw wss vx cv cA cB cpr wcel vx cv cC cpw wcel wi vx wal vx
      cv cA wceq vx cv cC wss wi vx cv cB wceq vx cv cC wss wi wa vx wal cA cC
      wss cB cC wss wa vx cA cB cpr cC cpw dfss2 vx cv cA cB cpr wcel vx cv cC
      cpw wcel wi vx cv cA wceq vx cv cC wss wi vx cv cB wceq vx cv cC wss wi
      wa vx vx cv cA cB cpr wcel vx cv cC cpw wcel wi vx cv cA wceq vx cv cB
      wceq wo vx cv cC wss wi vx cv cA wceq vx cv cC wss wi vx cv cB wceq vx cv
      cC wss wi wa vx cv cA cB cpr wcel vx cv cA wceq vx cv cB wceq wo vx cv cC
      cpw wcel vx cv cC wss vx cv cA cB vx visset elpr vx cv cC vx visset elpw
      imbi12i vx cv cA wceq vx cv cC wss vx cv cB wceq jaob bitri albii vx cv
      cA wceq vx cv cC wss wi vx cv cB wceq vx cv cC wss wi wa vx wal vx cv cA
      wceq vx cv cC wss wi vx wal vx cv cB wceq vx cv cC wss wi vx wal wa cA cC
      wss cB cC wss wa vx cv cA wceq vx cv cC wss wi vx cv cB wceq vx cv cC wss
      wi vx 19.26 vx cv cA wceq vx cv cC wss wi vx wal cA cC wss vx cv cB wceq
      vx cv cC wss wi vx wal cB cC wss vx cv cC wss cA cC wss vx cA prsspw.1 vx
      cv cA cC sseq1 ceqsalv vx cv cC wss cB cC wss vx cB prsspw.2 vx cv cB cC
      sseq1 ceqsalv anbi12i bitri 3bitri $.
      $( [10-Dec-2003] $) $( [10-Dec-2003] $)
  $}

  ${
    preqr1.1 $e |- A e. _V $.
    preqr1.2 $e |- B e. _V $.
    $( Reverse equality lemma for unordered pairs.  If two unordered pairs
       have the same second element, the first elements are equal. $)
    preqr1 $p |- ( { A , C } = { B , C } -> A = B ) $=
      cA cC cpr cB cC cpr wceq cA cB wceq cA cC wceq cB cA wceq cB cC wceq cA
      cC cpr cB cC cpr wceq cA cB cC cpr wcel cA cB wceq cA cC wceq wo cA cC
      cpr cB cC cpr wceq cA cA cC cpr wcel cA cB cC cpr wcel cA cC preqr1.1
      prid1 cA cC cpr cB cC cpr cA eleq2 mpbii cA cB cC preqr1.1 elpr sylib cA
      cC cpr cB cC cpr wceq cB cA cC cpr wcel cB cA wceq cB cC wceq wo cA cC
      cpr cB cC cpr wceq cB cA cC cpr wcel cB cB cC cpr wcel cB cC preqr1.2
      prid1 cA cC cpr cB cC cpr cB eleq2 mpbiri cB cA cC preqr1.2 elpr sylib cA
      cB eqcom cA cC cB eqeq2 oplem1 $.
      $( [18-Oct-1995] $)
  $}

  ${
    preqr2.1 $e |- A e. _V $.
    preqr2.2 $e |- B e. _V $.
    $( Reverse equality lemma for unordered pairs.  If two unordered pairs have
       the same first element, the second elements are equal. $)
    preqr2 $p |- ( { C , A } = { C , B } -> A = B ) $=
      cC cA cpr cC cB cpr wceq cA cC cpr cB cC cpr wceq cA cB wceq cC cA cpr cA
      cC cpr cC cB cpr cB cC cpr cC cA prcom cC cB prcom eqeq12i cA cB cC
      preqr2.1 preqr2.2 preqr1 sylbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    preq12b.1 $e |- A e. _V $.
    preq12b.2 $e |- B e. _V $.
    preq12b.3 $e |- C e. _V $.
    preq12b.4 $e |- D e. _V $.
    $( Equality relationship for two unordered pairs. $)
    preq12b $p |- ( { A , B } = { C , D } <->
                   ( ( A = C /\ B = D ) \/ ( A = D /\ B = C ) ) ) $=
      cA cB cpr cC cD cpr wceq cA cC wceq cB cD wceq wa cA cD wceq cB cC wceq
      wa wo cA cB cpr cC cD cpr wceq cA cC wceq cA cD wceq wo cA cC wceq cB cD
      wceq wa cA cD wceq cB cC wceq wa wo cA cB cpr cC cD cpr wceq cA cC cD cpr
      wcel cA cC wceq cA cD wceq wo cA cB cpr cC cD cpr wceq cA cA cB cpr wcel
      cA cC cD cpr wcel cA cB preq12b.1 prid1 cA cB cpr cC cD cpr cA eleq2
      mpbii cA cC cD preq12b.1 elpr sylib cA cB cpr cC cD cpr wceq cA cC wceq
      cA cC wceq cB cD wceq wa cA cD wceq cA cD wceq cB cC wceq wa cA cB cpr cC
      cD cpr wceq cA cC wceq cB cD wceq cA cC wceq cA cB cpr cC cD cpr wceq cB
      cD wceq cA cC wceq cA cB cpr cC cD cpr wceq cC cB cpr cC cD cpr wceq cB
      cD wceq cA cC wceq cA cB cpr cC cB cpr cC cD cpr cA cC cB preq1 eqeq1d cB
      cD cC preq12b.2 preq12b.4 preqr2 syl6bi com12 ancld cA cB cpr cC cD cpr
      wceq cA cD wceq cB cC wceq cA cB cpr cC cD cpr wceq cA cB cpr cD cC cpr
      wceq cA cD wceq cB cC wceq wi cC cD cpr cD cC cpr cA cB cpr cC cD prcom
      eqeq2i cA cD wceq cA cB cpr cD cC cpr wceq cB cC wceq cA cD wceq cA cB
      cpr cD cC cpr wceq cD cB cpr cD cC cpr wceq cB cC wceq cA cD wceq cA cB
      cpr cD cB cpr cD cC cpr cA cD cB preq1 eqeq1d cB cC cD preq12b.2
      preq12b.3 preqr2 syl6bi com12 sylbi ancld orim12d mpd cA cC wceq cB cD
      wceq wa cA cB cpr cC cD cpr wceq cA cD wceq cB cC wceq wa cA cC wceq cB
      cD wceq cA cB cpr cC cB cpr cC cD cpr cA cC cB preq1 cB cD cC preq2
      sylan9eq cA cD wceq cB cC wceq cA cB cpr cB cD cpr cC cD cpr cA cD wceq
      cA cB cpr cD cB cpr cB cD cpr cA cD cB preq1 cD cB prcom syl6eq cB cC cD
      preq1 sylan9eq jaoi impbii $.
      $( [17-Oct-1996] $)

    $( Equality of two unordered pairs. $)
    prel12 $p |- ( -. A = B -> ( { A , B } = { C , D } <->
                   ( A e. { C , D } /\ B e. { C , D } ) ) ) $=
      cA cB wceq wn cA cB cpr cC cD cpr wceq cA cC cD cpr wcel cB cC cD cpr
      wcel wa cA cB cpr cC cD cpr wceq cA cC cD cpr wcel cB cC cD cpr wcel cA
      cB cpr cC cD cpr wceq cA cA cB cpr wcel cA cC cD cpr wcel cA cB preq12b.1
      prid1 cA cB cpr cC cD cpr cA eleq2 mpbii cA cB cpr cC cD cpr wceq cB cA
      cB cpr wcel cB cC cD cpr wcel cA cB preq12b.2 prid2 cA cB cpr cC cD cpr
      cB eleq2 mpbii jca cA cB wceq wn cA cC cD cpr wcel cB cC cD cpr wcel cA
      cB cpr cC cD cpr wceq cA cB wceq wn cA cC wceq cA cD wceq wo cB cC cD cpr
      wcel cA cB cpr cC cD cpr wceq wi cA cC cD cpr wcel cA cB wceq wn cA cC
      wceq cA cD wceq wo cB cC cD cpr wcel cA cB cpr cC cD cpr wceq wi cA cB
      wceq wn cA cC wceq cA cD wceq wo wa cB cD wceq cB cC wceq wo cA cC wceq
      cB cD wceq wa cA cD wceq cB cC wceq wa wo cB cC cD cpr wcel cA cB cpr cC
      cD cpr wceq cA cB wceq wn cA cC wceq cA cD wceq wo wa cB cD wceq cA cC
      wceq cB cD wceq wa cB cC wceq cA cD wceq cB cC wceq wa cA cB wceq wn cA
      cC wceq cA cD wceq wo wa cB cD wceq cA cC wceq cA cB wceq wn cA cC wceq
      cA cD wceq wo cB cD wceq cA cC wceq wi cB cD wceq cA cB wceq wn cA cC
      wceq cA cD wceq wo cA cC wceq cB cD wceq cA cB wceq wn cA cD wceq wn cA
      cC wceq cA cD wceq wo cA cC wceq wi cB cD wceq cA cB wceq cA cD wceq cB
      cD cA eqeq2 notbid cA cD wceq cA cC wceq orel2 syl6bi com3l imp ancrd cA
      cB wceq wn cA cC wceq cA cD wceq wo wa cB cC wceq cA cD wceq cA cB wceq
      wn cA cC wceq cA cD wceq wo cB cC wceq cA cD wceq wi cB cC wceq cA cB
      wceq wn cA cC wceq cA cD wceq wo cA cD wceq cB cC wceq cA cB wceq wn cA
      cC wceq wn cA cC wceq cA cD wceq wo cA cD wceq wi cB cC wceq cA cB wceq
      cA cC wceq cB cC cA eqeq2 notbid cA cC wceq cA cD wceq orel1 syl6bi com3l
      imp ancrd orim12d cB cC cD cpr wcel cB cC wceq cB cD wceq wo cB cD wceq
      cB cC wceq wo cB cC cD preq12b.2 elpr cB cC wceq cB cD wceq orcom bitri
      cA cB cC cD preq12b.1 preq12b.2 preq12b.3 preq12b.4 preq12b 3imtr4g ex cA
      cC cD preq12b.1 elpr syl5ib imp3a impbid2 $.
      $( [17-Oct-1996] $)

    $( A way to represent ordered pairs using unordered pairs with distinct
       members. $)
    opthpr $p |- ( A =/= D ->
                 ( { A , B } = { C , D } <-> ( A = C /\ B = D ) ) ) $=
      cA cD wne cA cC wceq cB cD wceq wa cA cD wceq cB cC wceq wa wo cA cC wceq
      cB cD wceq wa cA cB cpr cC cD cpr wceq cA cD wne cA cC wceq cB cD wceq wa
      cA cD wceq cB cC wceq wa wo cA cC wceq cB cD wceq wa cA cD wne cA cC wceq
      cB cD wceq wa cA cC wceq cB cD wceq wa cA cD wceq cB cC wceq wa cA cD wne
      cA cC wceq cB cD wceq wa idd cA cD wne cA cD wceq cB cC wceq cA cC wceq
      cB cD wceq wa cA cD wne cA cD wceq wn cA cD wceq cB cC wceq cA cC wceq cB
      cD wceq wa wi wi cA cD df-ne cA cD wceq cB cC wceq cA cC wceq cB cD wceq
      wa wi pm2.21 sylbi imp3a jaod cA cC wceq cB cD wceq wa cA cD wceq cB cC
      wceq wa orc impbid1 cA cB cC cD preq12b.1 preq12b.2 preq12b.3 preq12b.4
      preq12b syl5bb $.
      $( [30-Mar-2007] $) $( [27-Mar-2007] $)
  $}

  ${
    preqsn.1 $e |- A e. _V $.
    preqsn.2 $e |- B e. _V $.
    preqsn.3 $e |- C e. _V $.
    $( Equivalence for a pair equal to a singleton. $)
    preqsn $p |- ( { A , B } = { C } <-> ( A = B /\ B = C ) ) $=
      cA cB cpr cC csn wceq cA cB cpr cC cC cpr wceq cA cC wceq cB cC wceq wa
      cA cC wceq cB cC wceq wa wo cA cB wceq cB cC wceq wa cC csn cC cC cpr cA
      cB cpr cC dfsn2 eqeq2i cA cB cC cC preqsn.1 preqsn.2 preqsn.3 preqsn.3
      preq12b cA cC wceq cB cC wceq wa cA cC wceq cB cC wceq wa wo cA cC wceq
      cB cC wceq wa cA cB wceq cB cC wceq wa cA cC wceq cB cC wceq wa oridm cA
      cC wceq cB cC wceq wa cA cB wceq cB cC wceq wa cA cC wceq cB cC wceq wa
      cA cB wceq cB cC wceq cA cB cC eqtr3 cA cC wceq cB cC wceq pm3.27 jca cA
      cB wceq cB cC wceq wa cA cC wceq cB cC wceq cA cB cC eqtr cA cB wceq cB
      cC wceq pm3.27 jca impbii bitri 3bitri $.
      $( [4-Jun-2008] $) $( [3-Jun-2008] $)
  $}

  $( Equality theorem for ordered pairs. $)
  opeq1 $p |- ( A = B -> <. A , C >. = <. B , C >. ) $=
    cA cB wceq cA csn cA cC cpr cpr cB csn cB cC cpr cpr cA cC cop cB cC cop cA
    cB wceq cA csn cA cC cpr cpr cA csn cB cC cpr cpr cB csn cB cC cpr cpr cA
    cB wceq cA cC cpr cB cC cpr wceq cA csn cA cC cpr cpr cA csn cB cC cpr cpr
    wceq cA cB cC preq1 cA cC cpr cB cC cpr cA csn preq2 syl cA cB wceq cA csn
    cB csn wceq cA csn cB cC cpr cpr cB csn cB cC cpr cpr wceq cA cB sneq cA
    csn cB csn cB cC cpr preq1 syl eqtrd cA cC df-op cB cC df-op 3eqtr4g $.
    $( [25-Jun-1998] $)

  $( Equality theorem for ordered pairs. $)
  opeq2 $p |- ( A = B -> <. C , A >. = <. C , B >. ) $=
    cA cB wceq cC csn cC cA cpr cpr cC csn cC cB cpr cpr cC cA cop cC cB cop cA
    cB wceq cC cA cpr cC cB cpr wceq cC csn cC cA cpr cpr cC csn cC cB cpr cpr
    wceq cA cB cC preq2 cC cA cpr cC cB cpr cC csn preq2 syl cC cA df-op cC cB
    df-op 3eqtr4g $.
    $( [25-Jun-1998] $)

  $( Equality theorem for ordered pairs. $)
  opeq12 $p |- ( ( A = C /\ B = D ) -> <. A , B >. = <. C , D >. ) $=
    cA cC wceq cB cD wceq cA cB cop cC cB cop cC cD cop cA cC cB opeq1 cB cD cC
    opeq2 sylan9eq $.
    $( [28-May-1995] $)

  ${
    opeq1i.1 $e |- A = B $.
    $( Equality inference for ordered pairs. $)
    opeq1i $p |- <. A , C >. = <. B , C >. $=
      cA cB wceq cA cC cop cB cC cop wceq opeq1i.1 cA cB cC opeq1 ax-mp $.
      $( [16-Dec-2006] $) $( [16-Dec-2006] $)

    $( Equality inference for ordered pairs. $)
    opeq2i $p |- <. C , A >. = <. C , B >. $=
      cA cB wceq cC cA cop cC cB cop wceq opeq1i.1 cA cB cC opeq2 ax-mp $.
      $( [16-Dec-2006] $) $( [16-Dec-2006] $)

    ${
      opeq12i.2 $e |- C = D $.
      $( Equality inference for ordered pairs.  (The proof was shortened by
         Eric Schmidt, 4-Apr-2007.) $)
      opeq12i $p |- <. A , C >. = <. B , D >. $=
        cA cB wceq cC cD wceq cA cC cop cB cD cop wceq opeq1i.1 opeq12i.2 cA cC
        cB cD opeq12 mp2an $.
        $( [4-Apr-2007] $) $( [16-Dec-2006] $)
    $}
  $}

  ${
    opeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for ordered pairs. $)
    opeq1d $p |- ( ph -> <. A , C >. = <. B , C >. ) $=
      wph cA cB wceq cA cC cop cB cC cop wceq opeq1d.1 cA cB cC opeq1 syl $.
      $( [17-Dec-2006] $) $( [16-Dec-2006] $)

    $( Equality deduction for ordered pairs. $)
    opeq2d $p |- ( ph -> <. C , A >. = <. C , B >. ) $=
      wph cA cB wceq cC cA cop cC cB cop wceq opeq1d.1 cA cB cC opeq2 syl $.
      $( [17-Dec-2006] $) $( [16-Dec-2006] $)

    ${
      opeq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for ordered pairs. $)
      opeq12d $p |- ( ph -> <. A , C >. = <. B , D >. ) $=
        wph cA cC cop cB cC cop cB cD cop wph cA cB cC opeq1d.1 opeq1d wph cC
        cD cB opeq12d.2 opeq2d eqtrd $.
        $( [21-Dec-2006] $) $( [16-Dec-2006] $)
    $}
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    hbop.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbop.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for ordered pairs. $)
    hbop $p |- ( y e. <. A , B >. -> A. x y e. <. A , B >. ) $=
      vx vy cA cB cop cA csn cA cB cpr cpr cA cB df-op vx vy cA csn cA cB cpr
      vx vy cA hbop.1 hbsn vx vy cA cB hbop.1 hbop.2 hbpr hbpr hbxfr $.
      $( [14-Nov-1995] $)
  $}

  ${
    $d y z B $.  $d y z A $.  $d y ph $.  $d x y z $.
    hbopd.1 $e |- ( ph -> A. x ph ) $.
    hbopd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    hbopd.3 $e |- ( ph -> ( y e. B -> A. x y e. B ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbop . $)
    hbopd $p |- ( ph -> ( y e. <. A , B >. -> A. x y e. <. A , B >. ) ) $=
      wph vy cv vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cop
      wcel vy cv vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cop
      wcel vx wal vy cv cA cB cop wcel vy cv cA cB cop wcel vx wal vy cv vz cv
      cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cop wcel vy cv vz cv cA
      wcel vx wal vz cab vz cv cB wcel vx wal vz cab cop wcel vx wal wi wph vx
      vy vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv cA wcel
      vx wal vx vz vy vz cv cA wcel vx hba1 hbab vz cv cB wcel vx wal vx vz vy
      vz cv cB wcel vx hba1 hbab hbop a1i wph vz cv cA wcel vx wal vz cab vz cv
      cB wcel vx wal vz cab cop cA cB cop vy cv wph vz cv cA wcel vx wal vz cab
      vz cv cB wcel vx wal vz cab cop cA vz cv cB wcel vx wal vz cab cop cA cB
      cop wph vz cv cA wcel vx wal vz cab cA vz cv cB wcel vx wal vz cab wph vy
      cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz cab cA
      wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy hbopd.2 19.21aiv vx vy
      vz cA abidhb syl opeq1d wph vz cv cB wcel vx wal vz cab cB cA wph vy cv
      cB wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB
      wceq wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbopd.3 19.21aiv vx vy
      vz cB abidhb syl opeq2d eqtrd eleq2d wph vy cv vz cv cA wcel vx wal vz
      cab vz cv cB wcel vx wal vz cab cop wcel vy cv cA cB cop wcel vx hbopd.1
      wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cop cA cB cop
      vy cv wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cop cA
      vz cv cB wcel vx wal vz cab cop cA cB cop wph vz cv cA wcel vx wal vz cab
      cA vz cv cB wcel vx wal vz cab wph vy cv cA wcel vy cv cA wcel vx wal wi
      vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA
      wcel vx wal wi vy hbopd.2 19.21aiv vx vy vz cA abidhb syl opeq1d wph vz
      cv cB wcel vx wal vz cab cB cA wph vy cv cB wcel vy cv cB wcel vx wal wi
      vy wal vz cv cB wcel vx wal vz cab cB wceq wph vy cv cB wcel vy cv cB
      wcel vx wal wi vy hbopd.3 19.21aiv vx vy vz cB abidhb syl opeq2d eqtrd
      eleq2d albid 3imtr3d $.
      $( [4-Feb-2008] $) $( [4-Feb-2008] $)
  $}

  $( Expansion of an ordered pair when the first member is a proper class.
     See also ~ opprc1b , ~ opprc2 , ~ opprc3 . $)
  opprc1 $p |- ( -. A e. _V -> <. A , B >. = { (/) , { B } } ) $=
    cA cvv wcel wn cA csn cA cB cpr cpr c0 cB csn cpr cA cB cop cA cvv wcel wn
    cA csn cA cB cpr cpr c0 cA cB cpr cpr c0 cB csn cpr cA cvv wcel wn cA csn
    c0 wceq cA csn cA cB cpr cpr c0 cA cB cpr cpr wceq cA snprc cA csn c0 cA cB
    cpr preq1 sylbi cA cvv wcel wn cA cB cpr cB csn wceq c0 cA cB cpr cpr c0 cB
    csn cpr wceq cA cB prprc1 cA cB cpr cB csn c0 preq2 syl eqtrd cA cB df-op
    syl5eq $.
    $( [12-Apr-2004] $) $( [10-Apr-2004] $)

  $( A property of an ordered pair of proper classes (due to our
     particular definition of ordered pair). $)
  opprc2 $p |- ( -. B e. _V -> <. A , B >. = <. A , A >. ) $=
    cB cvv wcel wn cA csn cA cB cpr cpr cA csn cA cA cpr cpr cA cB cop cA cA
    cop cB cvv wcel wn cA cB cpr cA cA cpr wceq cA csn cA cB cpr cpr cA csn cA
    cA cpr cpr wceq cB cvv wcel wn cB cA cpr cA csn cA cB cpr cA cA cpr cB cA
    prprc1 cB cA prcom cA dfsn2 3eqtr3g cA cB cpr cA cA cpr cA csn preq2 syl cA
    cB df-op cA cA df-op 3eqtr4g $.
    $( [15-Nov-1994] $)

  ${
    $d x A $.  $d x B $.
    $( The power set of a singleton. $)
    pwsn $p |- ~P { A } = { (/) , { A } } $=
      vx cv cA csn wss vx cab vx cv c0 wceq vx cv cA csn wceq wo vx cab cA csn
      cpw c0 cA csn cpr vx cv cA csn wss vx cv c0 wceq vx cv cA csn wceq wo vx
      vx cv cA sssn abbii vx cA csn df-pw vx c0 cA csn dfpr2 3eqtr4i $.
      $( [5-Jun-2006] $) $( [5-Jun-2006] $)

    $d x y $.  $d y A $.
    $( MAY BE REVISED - should we keep this? $)
    $( The power set of a singleton (direct proof). $)
    pwsnALT $p |- ~P { A } = { (/) , { A } } $=
      vx cv cA csn wss vx cab vx cv c0 wceq vx cv cA csn wceq wo vx cab cA csn
      cpw c0 cA csn cpr vx cv cA csn wss vx cv c0 wceq vx cv cA csn wceq wo vx
      vx cv cA csn wss vx cv c0 wceq vx cv cA csn wceq wo vx cv cA csn wss vx
      cv c0 wceq vx cv cA csn wceq vx cv cA csn wss vx cv c0 wceq wn vx cv cA
      csn wss cA csn vx cv wss wa vx cv cA csn wceq vx cv cA csn wss vx cv c0
      wceq wn cA csn vx cv wss vx cv cA csn wss vy cv vx cv wcel vy cv cA wceq
      wi vy wal vx cv c0 wceq wn cA csn vx cv wss wi vx cv cA csn wss vy cv vx
      cv wcel vy cv cA csn wcel wi vy wal vy cv vx cv wcel vy cv cA wceq wi vy
      wal vy vx cv cA csn dfss2 vy cv vx cv wcel vy cv cA csn wcel wi vy cv vx
      cv wcel vy cv cA wceq wi vy vy cv cA csn wcel vy cv cA wceq vy cv vx cv
      wcel vy cA elsn imbi2i albii bitri vy cv vx cv wcel vy cv cA wceq wi vy
      wal vx cv c0 wceq wn vy cv vx cv wcel vy cv cA wceq wa vy wex cA csn vx
      cv wss vy cv vx cv wcel vy cv cA wceq wi vy wal vy cv vx cv wcel vy wex
      vy cv vx cv wcel vy cv cA wceq wa vy wex vx cv c0 wceq wn vy cv vx cv
      wcel vy cv cA wceq vy exintr vy vx cv neq0 syl5ib vy cv vx cv wcel vy cv
      cA wceq wa vy wex cA vx cv wcel cA csn vx cv wss cA vx cv wcel vy cv cA
      wceq vy cv vx cv wcel wa vy wex vy cv vx cv wcel vy cv cA wceq wa vy wex
      vy cA vx cv df-clel vy cv cA wceq vy cv vx cv wcel vy exancom bitr2i cA
      vx cv snssi sylbi syl6 sylbi anc2li vx cv cA csn eqss syl6ibr orrd vx cv
      c0 wceq vx cv cA csn wss vx cv cA csn wceq vx cv c0 wceq vx cv cA csn wss
      c0 cA csn wss cA csn 0ss vx cv c0 cA csn sseq1 mpbiri vx cv cA csn eqimss
      jaoi impbii abbii vx cA csn df-pw vx c0 cA csn dfpr2 3eqtr4i $.
      $( [8-Aug-2008] $) $( [5-Jun-2006] $)

    $( The power set of an unordered pair. $)
    pwpr $p |- ~P { A , B } = ( { (/) , { A } } u. { { B } , { A , B } } ) $=
      cA cB cpr cpw vx cv cA cB cpr wss vx cab vx cv c0 cA csn cpr cB csn cA cB
      cpr cpr cun wcel vx cab c0 cA csn cpr cB csn cA cB cpr cpr cun vx cA cB
      cpr df-pw vx cv cA cB cpr wss vx cv c0 cA csn cpr cB csn cA cB cpr cpr
      cun wcel vx vx cv c0 cA csn cpr wcel vx cv cB csn cA cB cpr cpr wcel wo
      vx cv c0 wceq vx cv cA csn wceq wo vx cv cB csn wceq vx cv cA cB cpr wceq
      wo wo vx cv c0 cA csn cpr cB csn cA cB cpr cpr cun wcel vx cv cA cB cpr
      wss vx cv c0 cA csn cpr wcel vx cv c0 wceq vx cv cA csn wceq wo vx cv cB
      csn cA cB cpr cpr wcel vx cv cB csn wceq vx cv cA cB cpr wceq wo vx cv c0
      cA csn vx visset elpr vx cv cB csn cA cB cpr vx visset elpr orbi12i vx cv
      c0 cA csn cpr cB csn cA cB cpr cpr elun vx cv cA cB sspr 3bitr4ri abbii
      vx c0 cA csn cpr cB csn cA cB cpr cpr cun abid2 3eqtri $.
      $( [3-May-2009] $) $( [1-May-2009] $)
  $}

  ${

    $( The power class of the universe is the universe.  Exercise 4.12(d) of
       [Mendelson] p. 235. $)
    pwv $p |- ~P _V = _V $=
      vx cvv cpw cvv vx cv cvv cpw wcel vx cv cvv wcel vx cv cvv cpw wcel vx cv
      cvv wss vx cv ssv vx cv cvv vx visset elpw mpbir vx visset 2th eqriv $.
      $( [14-Sep-2003] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       The union of a class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare class union symbol. $)
  $c U. $. $( Big cup $)

  $( Extend class notation to include the union of a class (read:  'union
     ` A ` ') $)
  cuni $a class U. A $.

  ${
    $d x y A $.
    $( Define the union of a class i.e. the collection of all members of the
       members of the class.  Definition 5.5 of [TakeutiZaring] p. 16. $)
    df-uni $a |- U. A = { x | E. y ( x e. y /\ y e. A ) } $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of class union. $)
    dfuni2 $p |- U. A = { x | E. y e. A  x e. y } $=
      cA cuni vx cv vy cv wcel vy cv cA wcel wa vy wex vx cab vx cv vy cv wcel
      vy cA wrex vx cab vx vy cA df-uni vx cv vy cv wcel vy cv cA wcel wa vy
      wex vx cv vy cv wcel vy cA wrex vx vx cv vy cv wcel vy cv cA wcel wa vy
      wex vy cv cA wcel vx cv vy cv wcel wa vy wex vx cv vy cv wcel vy cA wrex
      vx cv vy cv wcel vy cv cA wcel vy exancom vx cv vy cv wcel vy cA df-rex
      bitr4i abbii eqtri $.
      $( [28-Jun-1998] $)
  $}

  ${
    $d x A y $.  $d x B y $.
    $( Membership in class union. $)
    eluni $p |- ( A e. U. B <-> E. x ( A e. x /\ x e. B ) ) $=
      cA cB cuni wcel cA cvv wcel cA vx cv wcel vx cv cB wcel wa vx wex cA cB
      cuni elisset cA vx cv wcel vx cv cB wcel wa cA cvv wcel vx cA vx cv wcel
      cA cvv wcel vx cv cB wcel cA vx cv elisset adantr 19.23aiv vy cv vx cv
      wcel vx cv cB wcel wa vx wex cA vx cv wcel vx cv cB wcel wa vx wex vy cA
      cB cuni cvv vy cv cA wceq vy cv vx cv wcel vx cv cB wcel wa cA vx cv wcel
      vx cv cB wcel wa vx vy cv cA wceq vy cv vx cv wcel cA vx cv wcel vx cv cB
      wcel vy cv cA vx cv eleq1 anbi1d exbidv vy vx cB df-uni elab2g pm5.21nii
      $.
      $( [22-May-1994] $)

    $( Membership in class union.  Restricted quantifier version. $)
    eluni2 $p |- ( A e. U. B <-> E. x e. B A e. x ) $=
      cA vx cv wcel vx cv cB wcel wa vx wex vx cv cB wcel cA vx cv wcel wa vx
      wex cA cB cuni wcel cA vx cv wcel vx cB wrex cA vx cv wcel vx cv cB wcel
      vx exancom vx cA cB eluni cA vx cv wcel vx cB df-rex 3bitr4i $.
      $( [31-Aug-1999] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Membership in class union. $)
    elunii $p |- ( ( A e. B /\ B e. C ) -> A e. U. C ) $=
      cA cB wcel cB cC wcel wa cA vx cv wcel vx cv cC wcel wa vx wex cA cC cuni
      wcel cA cB wcel cB cC wcel cA vx cv wcel vx cv cC wcel wa vx wex cA vx cv
      wcel vx cv cC wcel wa cA cB wcel cB cC wcel wa vx cB cC vx cv cB wceq cA
      vx cv wcel cA cB wcel vx cv cC wcel cB cC wcel vx cv cB cA eleq2 vx cv cB
      cC eleq1 anbi12d cla4egv anabsi7 vx cA cC eluni sylibr $.
      $( [24-Mar-1995] $)
  $}

  ${
    $d y z A $.  $d x y z $.
    hbuni.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for union. $)
    hbuni $p |- ( y e. U. A -> A. x y e. U. A ) $=
      vy cv vz cv wcel vz cv cA wcel wa vz wex vy cv vz cv wcel vz cv cA wcel
      wa vz wex vx wal vy cv cA cuni wcel vy cv cA cuni wcel vx wal vy cv vz cv
      wcel vz cv cA wcel wa vx vz vy cv vz cv wcel vz cv cA wcel vx vy cv vz cv
      wcel vx ax-17 vx vy vy vz cv cA vy cv vz cv wcel vx ax-17 hbuni.1 hbel
      hban hbex vz vy cv cA eluni vy cv cA cuni wcel vy cv vz cv wcel vz cv cA
      wcel wa vz wex vx vz vy cv cA eluni albii 3imtr4i $.
      $( [30-Dec-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for class union.  Exercise 15 of [TakeutiZaring]
       p. 18. $)
    unieq $p |- ( A = B -> U. A = U. B ) $=
      cA cB wceq vx cv vy cv wcel vy cv cA wcel wa vy wex vx cab vx cv vy cv
      wcel vy cv cB wcel wa vy wex vx cab cA cuni cB cuni cA cB wceq vx cv vy
      cv wcel vy cv cA wcel wa vy wex vx cv vy cv wcel vy cv cB wcel wa vy wex
      vx cA cB wceq vx cv vy cv wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cB
      wcel wa vy cA cB wceq vy cv cA wcel vy cv cB wcel vx cv vy cv wcel cA cB
      vy cv eleq2 anbi2d exbidv abbidv vx vy cA df-uni vx vy cB df-uni 3eqtr4g
      $.
      $( [10-Aug-1993] $)
  $}

  ${
    unieqi.1 $e |- A = B $.
    $( Inference of equality of two class unions. $)
    unieqi $p |- U. A = U. B $=
      cA cB wceq cA cuni cB cuni wceq unieqi.1 cA cB unieq ax-mp $.
      $( [30-Aug-1993] $)
  $}

  ${
    unieqd.1 $e |- ( ph -> A = B ) $.
    $( Deduction of equality of two class unions. $)
    unieqd $p |- ( ph -> U. A = U. B ) $=
      wph cA cB wceq cA cuni cB cuni wceq unieqd.1 cA cB unieq syl $.
      $( [21-Apr-1995] $)
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Membership in union of a class abstraction. $)
    eluniab $p |- ( A e. U. { x | ph } <-> E. x ( A e. x /\ ph ) ) $=
      cA wph vx cab cuni wcel cA vy cv wcel vy cv wph vx cab wcel wa vy wex cA
      vx cv wcel wph wa vx wex vy cA wph vx cab eluni cA vy cv wcel vy cv wph
      vx cab wcel wa cA vx cv wcel wph wa vy vx cA vy cv wcel vy cv wph vx cab
      wcel vx cA vy cv wcel vx ax-17 wph vx vy hbab1 hban cA vx cv wcel wph wa
      vy ax-17 vy cv vx cv wceq cA vy cv wcel vy cv wph vx cab wcel wa cA vx cv
      wcel vx cv wph vx cab wcel wa cA vx cv wcel wph wa vy cv vx cv wceq cA vy
      cv wcel cA vx cv wcel vy cv wph vx cab wcel vx cv wph vx cab wcel vy cv
      vx cv cA eleq2 vy cv vx cv wph vx cab eleq1 anbi12d vx cv wph vx cab wcel
      wph cA vx cv wcel wph vx abid anbi2i syl6bb cbvex bitri $.
      $( [11-Aug-1994] $)

    $( Membership in union of a class abstraction. $)
    elunirab $p |- ( A e. U. { x e. B | ph } <->
                   E. x e. B ( A e. x /\ ph ) ) $=
      cA vx cv cB wcel wph wa vx cab cuni wcel cA vx cv wcel vx cv cB wcel wph
      wa wa vx wex cA wph vx cB crab cuni wcel cA vx cv wcel wph wa vx cB wrex
      vx cv cB wcel wph wa vx cA eluniab wph vx cB crab cuni vx cv cB wcel wph
      wa vx cab cuni cA wph vx cB crab vx cv cB wcel wph wa vx cab wph vx cB
      df-rab unieqi eleq2i cA vx cv wcel wph wa vx cB wrex vx cv cB wcel cA vx
      cv wcel wph wa wa vx wex cA vx cv wcel vx cv cB wcel wph wa wa vx wex cA
      vx cv wcel wph wa vx cB df-rex vx cv cB wcel cA vx cv wcel wph wa wa cA
      vx cv wcel vx cv cB wcel wph wa wa vx vx cv cB wcel cA vx cv wcel wph
      an12 exbii bitri 3bitr4i $.
      $( [7-Oct-2006] $) $( [4-Oct-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    unipr.1 $e |- A e. _V $.
    unipr.2 $e |- B e. _V $.
    $( The union of a pair is the union of its members.  Proposition 5.7 of
       [TakeutiZaring] p. 16. $)
    unipr $p |- U. { A , B } = ( A u. B ) $=
      vx cv cA wcel vx cv cB wcel wo vx cab vx cv vy cv wcel vy cv cA cB cpr
      wcel wa vy wex vx cab cA cB cun cA cB cpr cuni vx cv cA wcel vx cv cB
      wcel wo vx cv vy cv wcel vy cv cA cB cpr wcel wa vy wex vx vx cv vy cv
      wcel vy cv cA wceq wa vx cv vy cv wcel vy cv cB wceq wa wo vy wex vx cv
      vy cv wcel vy cv cA wceq wa vy wex vx cv vy cv wcel vy cv cB wceq wa vy
      wex wo vx cv vy cv wcel vy cv cA cB cpr wcel wa vy wex vx cv cA wcel vx
      cv cB wcel wo vx cv vy cv wcel vy cv cA wceq wa vx cv vy cv wcel vy cv cB
      wceq wa vy 19.43 vx cv vy cv wcel vy cv cA cB cpr wcel wa vx cv vy cv
      wcel vy cv cA wceq wa vx cv vy cv wcel vy cv cB wceq wa wo vy vx cv vy cv
      wcel vy cv cA cB cpr wcel wa vx cv vy cv wcel vy cv cA wceq vy cv cB wceq
      wo wa vx cv vy cv wcel vy cv cA wceq wa vx cv vy cv wcel vy cv cB wceq wa
      wo vy cv cA cB cpr wcel vy cv cA wceq vy cv cB wceq wo vx cv vy cv wcel
      vy cv cA cB vy visset elpr anbi2i vx cv vy cv wcel vy cv cA wceq vy cv cB
      wceq andi bitri exbii vx cv cA wcel vx cv vy cv wcel vy cv cA wceq wa vy
      wex vx cv cB wcel vx cv vy cv wcel vy cv cB wceq wa vy wex vx cv cA wcel
      vy cv cA wceq vx cv vy cv wcel wa vy wex vx cv vy cv wcel vy cv cA wceq
      wa vy wex vy vx cv cA unipr.1 clel3 vy cv cA wceq vx cv vy cv wcel vy
      exancom bitri vx cv cB wcel vy cv cB wceq vx cv vy cv wcel wa vy wex vx
      cv vy cv wcel vy cv cB wceq wa vy wex vy vx cv cB unipr.2 clel3 vy cv cB
      wceq vx cv vy cv wcel vy exancom bitri orbi12i 3bitr4ri abbii vx cA cB
      df-un vx vy cA cB cpr df-uni 3eqtr4ri $.
      $( [23-Aug-1993] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( The union of a pair is the union of its members.  Proposition 5.7 of
       [TakeutiZaring] p. 16. $)
    uniprg $p |- ( ( A e. C /\ B e. D ) -> U. { A , B } = ( A u. B ) ) $=
      vx cv vy cv cpr cuni vx cv vy cv cun wceq cA vy cv cpr cuni cA vy cv cun
      wceq cA cB cpr cuni cA cB cun wceq vx vy cA cB cC cD vx cv cA wceq vx cv
      vy cv cpr cuni cA vy cv cpr cuni vx cv vy cv cun cA vy cv cun vx cv cA
      wceq vx cv vy cv cpr cA vy cv cpr vx cv cA vy cv preq1 unieqd vx cv cA vy
      cv uneq1 eqeq12d vy cv cB wceq cA vy cv cpr cuni cA cB cpr cuni cA vy cv
      cun cA cB cun vy cv cB wceq cA vy cv cpr cA cB cpr vy cv cB cA preq2
      unieqd vy cv cB cA uneq2 eqeq12d vx cv vy cv vx visset vy visset unipr
      vtocl2g $.
      $( [26-Aug-2006] $) $( [25-Aug-2006] $)
  $}

  ${
    unisn.1 $e |- A e. _V $.
    $( A set equals the union of its singleton.  Theorem 8.2 of [Quine]
       p. 53. $)
    unisn $p |- U. { A } = A $=
      cA csn cuni cA cA cpr cuni cA cA cun cA cA csn cA cA cpr cA dfsn2 unieqi
      cA cA unisn.1 unisn.1 unipr cA unidm 3eqtri $.
      $( [30-Aug-1993] $)
  $}

  ${
    $d x A $.
    $( A set equals the union of its singleton.  Theorem 8.2 of [Quine]
       p. 53. $)
    unisng $p |- ( A e. B -> U. { A } = A ) $=
      vx cv csn cuni vx cv wceq cA csn cuni cA wceq vx cA cB vx cv cA wceq vx
      cv csn cuni cA csn cuni vx cv cA vx cv cA wceq vx cv csn cA csn vx cv cA
      sneq unieqd vx cv cA wceq id eqeq12d vx cv vx visset unisn vtoclg $.
      $( [13-Aug-2002] $)
  $}

  ${
    $d y A $.  $d x y $.
    hbeqel.1 $e |- A e. _V $.
    hbeqel.2 $e |- ( y = A -> A. x y = A ) $.
    $( If ` x ` is effectively bound in ` y = A ` , then it is effectively
       bound in ` y e. A ` .  This is the other direction of ~ hbeleq ,
       showing the two conditions are equivalent when ` A ` is a set. $)
    hbeqel $p |- ( y e. A -> A. x y e. A ) $=
      vx vy cA cA csn cuni cA csn cuni cA cA hbeqel.1 unisn eqcomi vx vy cA csn
      vy cv cA wceq vy cv cA wceq vx wal vy cv cA csn wcel vy cv cA csn wcel vx
      wal hbeqel.2 vy cA elsn vy cv cA csn wcel vy cv cA wceq vx vy cA elsn
      albii 3imtr4i hbuni hbxfr $.
      $( [14-Oct-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The class union of the union of two classes.  Theorem 8.3 of
       [Quine] p. 53. $)
    uniun $p |- U. ( A u. B ) = ( U. A u. U. B ) $=
      vx cA cB cun cuni cA cuni cB cuni cun vx cv vy cv wcel vy cv cA cB cun
      wcel wa vy wex vx cv cA cuni wcel vx cv cB cuni wcel wo vx cv cA cB cun
      cuni wcel vx cv cA cuni cB cuni cun wcel vx cv vy cv wcel vy cv cA wcel
      wa vx cv vy cv wcel vy cv cB wcel wa wo vy wex vx cv vy cv wcel vy cv cA
      wcel wa vy wex vx cv vy cv wcel vy cv cB wcel wa vy wex wo vx cv vy cv
      wcel vy cv cA cB cun wcel wa vy wex vx cv cA cuni wcel vx cv cB cuni wcel
      wo vx cv vy cv wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cB wcel wa vy
      19.43 vx cv vy cv wcel vy cv cA cB cun wcel wa vx cv vy cv wcel vy cv cA
      wcel wa vx cv vy cv wcel vy cv cB wcel wa wo vy vx cv vy cv wcel vy cv cA
      cB cun wcel wa vx cv vy cv wcel vy cv cA wcel vy cv cB wcel wo wa vx cv
      vy cv wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cB wcel wa wo vy cv cA
      cB cun wcel vy cv cA wcel vy cv cB wcel wo vx cv vy cv wcel vy cv cA cB
      elun anbi2i vx cv vy cv wcel vy cv cA wcel vy cv cB wcel andi bitri exbii
      vx cv cA cuni wcel vx cv vy cv wcel vy cv cA wcel wa vy wex vx cv cB cuni
      wcel vx cv vy cv wcel vy cv cB wcel wa vy wex vy vx cv cA eluni vy vx cv
      cB eluni orbi12i 3bitr4i vy vx cv cA cB cun eluni vx cv cA cuni cB cuni
      elun 3bitr4i eqriv $.
      $( [20-Aug-1993] $)

    $( The class union of the intersection of two classes.  Exercise 4.12(n)
       of [Mendelson] p. 235.  See ~ uninqs for a condition where equality
       holds. $)
    uniin $p |- U. ( A i^i B ) C_ ( U. A i^i U. B ) $=
      vx cA cB cin cuni cA cuni cB cuni cin vx cv vy cv wcel vy cv cA wcel wa
      vx cv vy cv wcel vy cv cB wcel wa wa vy wex vx cv vy cv wcel vy cv cA
      wcel wa vy wex vx cv vy cv wcel vy cv cB wcel wa vy wex wa vx cv cA cB
      cin cuni wcel vx cv cA cuni cB cuni cin wcel vx cv vy cv wcel vy cv cA
      wcel wa vx cv vy cv wcel vy cv cB wcel wa vy 19.40 vx cv cA cB cin cuni
      wcel vx cv vy cv wcel vy cv cA cB cin wcel wa vy wex vx cv vy cv wcel vy
      cv cA wcel wa vx cv vy cv wcel vy cv cB wcel wa wa vy wex vy vx cv cA cB
      cin eluni vx cv vy cv wcel vy cv cA cB cin wcel wa vx cv vy cv wcel vy cv
      cA wcel wa vx cv vy cv wcel vy cv cB wcel wa wa vy vx cv vy cv wcel vy cv
      cA cB cin wcel wa vx cv vy cv wcel vy cv cA wcel vy cv cB wcel wa wa vx
      cv vy cv wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cB wcel wa wa vy cv
      cA cB cin wcel vy cv cA wcel vy cv cB wcel wa vx cv vy cv wcel vy cv cA
      cB elin anbi2i vx cv vy cv wcel vy cv cA wcel vy cv cB wcel anandi bitri
      exbii bitri vx cv cA cuni cB cuni cin wcel vx cv cA cuni wcel vx cv cB
      cuni wcel wa vx cv vy cv wcel vy cv cA wcel wa vy wex vx cv vy cv wcel vy
      cv cB wcel wa vy wex wa vx cv cA cuni cB cuni elin vx cv cA cuni wcel vx
      cv vy cv wcel vy cv cA wcel wa vy wex vx cv cB cuni wcel vx cv vy cv wcel
      vy cv cB wcel wa vy wex vy vx cv cA eluni vy vx cv cB eluni anbi12i bitri
      3imtr4i ssriv $.
      $( [4-Dec-2003] $) $( [4-Dec-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Subclass relationship for class union.  Theorem 61 of [Suppes] p. 39. $)
    uniss $p |- ( A C_ B -> U. A C_ U. B ) $=
      cA cB wss vx cv vy cv wcel vy cv cA wcel wa vy wex vx cab vx cv vy cv
      wcel vy cv cB wcel wa vy wex vx cab cA cuni cB cuni cA cB wss vx cv vy cv
      wcel vy cv cA wcel wa vy wex vx cv vy cv wcel vy cv cB wcel wa vy wex wi
      vx wal vx cv vy cv wcel vy cv cA wcel wa vy wex vx cab vx cv vy cv wcel
      vy cv cB wcel wa vy wex vx cab wss cA cB wss vx cv vy cv wcel vy cv cA
      wcel wa vy wex vx cv vy cv wcel vy cv cB wcel wa vy wex wi vx cA cB wss
      vx cv vy cv wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cB wcel wa vy cA
      cB wss vy cv cA wcel vy cv cB wcel vx cv vy cv wcel cA cB vy cv ssel
      anim2d 19.22dv 19.21aiv vx cv vy cv wcel vy cv cA wcel wa vy wex vx cv vy
      cv wcel vy cv cB wcel wa vy wex vx ss2ab sylibr vx vy cA df-uni vx vy cB
      df-uni 3sstr4g $.
      $( [22-Mar-1998] $)

    $( Subclass relationship for class union. $)
    ssuni $p |- ( ( A C_ B /\ B e. C ) -> A C_ U. C ) $=
      cB cC wcel cA cB wss cA cC cuni wss cA vx cv wss cA cC cuni wss wi cA cB
      wss cA cC cuni wss wi vx cB cC vx cv cB wceq cA vx cv wss cA cB wss cA cC
      cuni wss vx cv cB cA sseq2 imbi1d vx cv cC wcel vy cv cA wcel vy cv vx cv
      wcel wi vy wal vy cv cA wcel vy cv cC cuni wcel wi vy wal cA vx cv wss cA
      cC cuni wss vx cv cC wcel vy cv cA wcel vy cv vx cv wcel wi vy cv cA wcel
      vy cv cC cuni wcel wi vy vx cv cC wcel vy cv vx cv wcel vy cv cC cuni
      wcel vy cv cA wcel vx cv cC wcel vy cv vx cv wcel vy cv vx cv wcel vx cv
      cC wcel wa vx wex vy cv cC cuni wcel vy cv vx cv wcel vx cv cC wcel vy cv
      vx cv wcel vx cv cC wcel wa vx wex vy cv vx cv wcel vx cv cC wcel wa vx
      19.8a expcom vx vy cv cC eluni syl6ibr imim2d 19.20dv vy cA vx cv dfss2
      vy cA cC cuni dfss2 3imtr4g vtoclga impcom $.
      $( [24-May-1994] $)
  $}

  ${
    $d x y A $.
    $( The union of a set is empty iff the set is included in the singleton of
       the empty set. $)
    uni0b $p |- ( U. A = (/) <-> A C_ { (/) } ) $=
      vx cv c0 csn wcel vx cA wral vx cv c0 wceq vx cA wral cA c0 csn wss cA
      cuni c0 wceq vx cv c0 csn wcel vx cv c0 wceq vx cA vx c0 elsn ralbii vx
      cA c0 csn dfss3 cA cuni c0 wceq vx cv c0 wceq vx cA wral cA cuni c0 wceq
      wn vy cv cA cuni wcel vy wex vx cv c0 wceq wn vx cA wrex vx cv c0 wceq vx
      cA wral wn vy cA cuni neq0 vy cv vx cv wcel vy wex vx cA wrex vy cv vx cv
      wcel vx cA wrex vy wex vx cv c0 wceq wn vx cA wrex vy cv cA cuni wcel vy
      wex vy cv vx cv wcel vx vy cA rexcom4 vx cv c0 wceq wn vy cv vx cv wcel
      vy wex vx cA vy vx cv neq0 rexbii vy cv cA cuni wcel vy cv vx cv wcel vx
      cA wrex vy vx vy cv cA eluni2 exbii 3bitr4ri vx cv c0 wceq vx cA rexnal
      3bitri con4bii 3bitr4ri $.
      $( [13-Sep-2004] $) $( [12-Sep-2004] $)

    $( The union of a set is empty iff all of its members are empty. $)
    uni0c $p |- ( U. A = (/) <-> A. x e. A x = (/) ) $=
      cA cuni c0 wceq cA c0 csn wss vx cv c0 csn wcel vx cA wral vx cv c0 wceq
      vx cA wral cA uni0b vx cA c0 csn dfss3 vx cv c0 csn wcel vx cv c0 wceq vx
      cA vx c0 elsn ralbii 3bitri $.
      $( [15-Nov-2006] $) $( [16-Aug-2006] $)
  $}

  $( The union of the empty set is the empty set.  Theorem 8.7 of [Quine]
     p. 54.  (Reproved without relying on ~ ax-nul by Eric Schmidt,
     4-Apr-2007.) $)
  uni0 $p |- U. (/) = (/) $=
    c0 cuni c0 wceq c0 c0 csn wss c0 csn 0ss c0 uni0b mpbir $.
    $( [4-Apr-2007] $) $( [16-Sep-1993] $)

  $( An element of a class is a subclass of its union.  Theorem 8.6 of [Quine]
     p. 54.  Also the basis for Proposition 7.20 of [TakeutiZaring] p. 40. $)
  elssuni $p |- ( A e. B -> A C_ U. B ) $=
    cA cA wss cA cB wcel cA cB cuni wss cA ssid cA cA cB ssuni mpan $.
    $( [6-Jun-1994] $)

  $( Condition turning a subclass relationship for union into an equality. $)
  unissel $p |- ( ( U. A C_ B /\ B e. A ) -> U. A = B ) $=
    cA cuni cB wss cB cA wcel wa cA cuni cB cA cuni cB wss cB cA wcel pm3.26 cB
    cA wcel cB cA cuni wss cA cuni cB wss cB cA elssuni adantl eqssd $.
    $( [28-Jul-2006] $) $( [18-Jul-2006] $)

  ${
    $d x y A $.  $d x y B $.
    $( Relationship involving membership, subset, and union.  Exercise 5
       of [Enderton] p. 26 and its converse. $)
    unissb $p |- ( U. A C_ B <-> A. x e. A x C_ B ) $=
      cA cuni cB wss vx cv cA wcel vx cv cB wss wi vx wal vx cv cB wss vx cA
      wral cA cuni cB wss vy cv cA cuni wcel vy cv cB wcel wi vy wal vy cv vx
      cv wcel vx cv cA wcel wa vy cv cB wcel wi vx wal vy wal vx cv cA wcel vx
      cv cB wss wi vx wal vy cA cuni cB dfss2 vy cv cA cuni wcel vy cv cB wcel
      wi vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel wi vx wal vy vy cv cA
      cuni wcel vy cv cB wcel wi vy cv vx cv wcel vx cv cA wcel wa vx wex vy cv
      cB wcel wi vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel wi vx wal vy
      cv cA cuni wcel vy cv vx cv wcel vx cv cA wcel wa vx wex vy cv cB wcel vx
      vy cv cA eluni imbi1i vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel vx
      19.23v bitr4i albii vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel wi vx
      wal vy wal vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel wi vy wal vx
      wal vx cv cA wcel vx cv cB wss wi vx wal vy cv vx cv wcel vx cv cA wcel
      wa vy cv cB wcel wi vy vx alcom vy cv vx cv wcel vx cv cA wcel wa vy cv
      cB wcel wi vy wal vx cv cA wcel vx cv cB wss wi vx vx cv cA wcel vy cv vx
      cv wcel vy cv cB wcel wi wi vy wal vx cv cA wcel vy cv vx cv wcel vy cv
      cB wcel wi vy wal wi vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel wi
      vy wal vx cv cA wcel vx cv cB wss wi vx cv cA wcel vy cv vx cv wcel vy cv
      cB wcel wi vy 19.21v vy cv vx cv wcel vx cv cA wcel wa vy cv cB wcel wi
      vx cv cA wcel vy cv vx cv wcel vy cv cB wcel wi wi vy vy cv vx cv wcel vx
      cv cA wcel wa vy cv cB wcel wi vy cv vx cv wcel vx cv cA wcel vy cv cB
      wcel wi wi vx cv cA wcel vy cv vx cv wcel vy cv cB wcel wi wi vy cv vx cv
      wcel vx cv cA wcel vy cv cB wcel impexp vy cv vx cv wcel vx cv cA wcel vy
      cv cB wcel bi2.04 bitri albii vx cv cB wss vy cv vx cv wcel vy cv cB wcel
      wi vy wal vx cv cA wcel vy vx cv cB dfss2 imbi2i 3bitr4i albii bitri
      3bitri vx cv cB wss vx cA df-ral bitr4i $.
      $( [20-Sep-2003] $)
  $}

  ${
    $d x A $.  $d x y B $.
    $( A subclass condition on the members of two classes that implies
       a subclass relation on their unions.  Proposition 8.6 of [TakeutiZaring]
       p. 59.  See ~ iunss2 for a generalization to indexed unions. $)
    uniss2 $p |- ( A. x e. A E. y e. B x C_ y -> U. A C_ U. B ) $=
      vx cv vy cv wss vy cB wrex vx cA wral vx cv cB cuni wss vx cA wral cA
      cuni cB cuni wss vx cv vy cv wss vy cB wrex vx cv cB cuni wss vx cA vx cv
      vy cv wss vx cv cB cuni wss vy cB vx cv vy cv wss vy cv cB wcel vx cv cB
      cuni wss vx cv vy cv cB ssuni expcom r19.23aiv r19.20si vx cA cB cuni
      unissb sylibr $.
      $( [4-Apr-2004] $) $( [22-Mar-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( If the difference ` A \ B ` contains the largest members of ` A ` ,
       then the union of the difference is the union of ` A ` . $)
    unidif $p |- ( A. x e. A E. y e. ( A \ B ) x C_ y ->
               U. ( A \ B ) = U. A ) $=
      vx cv vy cv wss vy cA cB cdif wrex vx cA wral cA cB cdif cuni cA cuni wss
      cA cuni cA cB cdif cuni wss wa cA cB cdif cuni cA cuni wceq vx cv vy cv
      wss vy cA cB cdif wrex vx cA wral cA cuni cA cB cdif cuni wss cA cB cdif
      cuni cA cuni wss vx vy cA cA cB cdif uniss2 cA cB cdif cA wss cA cB cdif
      cuni cA cuni wss cA cB difss cA cB cdif cA uniss ax-mp jctil cA cB cdif
      cuni cA cuni eqss sylibr $.
      $( [18-Apr-2004] $) $( [22-Mar-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Relationship implying union. $)
    ssunieq $p |- ( ( A e. B /\ A. x e. B x C_ A ) -> A = U. B ) $=
      cA cB wcel vx cv cA wss vx cB wral wa cA cB cuni wss cB cuni cA wss wa cA
      cB cuni wceq cA cB wcel cA cB cuni wss vx cv cA wss vx cB wral cB cuni cA
      wss cA cB elssuni cB cuni cA wss vx cv cA wss vx cB wral vx cB cA unissb
      biimpri anim12i cA cB cuni eqss sylibr $.
      $( [10-Nov-1999] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Any member of a class is the largest of those members that it
       includes. $)
    unimax $p |- ( A e. B -> U. { x e. B | x C_ A } = A ) $=
      cA vx cv cA wss vx cB crab wcel vy cv cA wss vy vx cv cA wss vx cB crab
      wral vx cv cA wss vx cB crab cuni cA wceq cA cB wcel cA vx cv cA wss vx
      cB crab wcel vy cv cA wss vy vx cv cA wss vx cB crab wral wa cA vx cv cA
      wss vx cB crab cuni vy cA vx cv cA wss vx cB crab ssunieq eqcomd cA cB
      wcel cA vx cv cA wss vx cB crab wcel cA cA wss cA ssid vx cv cA wss cA cA
      wss vx cA cB vx cv cA cA sseq1 elrab3 mpbiri vy cv cA wss vy vx cv cA wss
      vx cB crab vy cv vx cv cA wss vx cB crab wcel vy cv cB wcel vy cv cA wss
      vx cv cA wss vy cv cA wss vx vy cv cB vx cv vy cv cA sseq1 elrab pm3.27bi
      rgen sylancl $.
      $( [9-Oct-2006] $) $( [13-Aug-2002] $)
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Closure law for "the unique element in ` A ` such that ` ph ` ." $)
    reucl $p |- ( E! x e. A ph -> U. { x e. A | ph } e. A ) $=
      vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx cab cuni cA wcel wph
      vx cA wreu wph vx cA crab cuni cA wcel vx cv cA wcel wph wa vx weu vx cv
      cA wcel wph wa vx cab vx cv csn wceq vx wex vx cv cA wcel wph wa vx cab
      cuni cA wcel vx cv cA wcel wph wa vx euabsn vx cv cA wcel wph wa vx cab
      vx cv csn wceq vx cv cA wcel wph wa vx cab cuni cA wcel vx vx vy vy vx cv
      cA wcel wph wa vx cab cuni cA vx vy vx cv cA wcel wph wa vx cab vx cv cA
      wcel wph wa vx vy hbab1 hbuni vy cv cA wcel vx ax-17 hbel vx cv cA wcel
      wph wa vx cab vx cv csn wceq vx cv vx cv cA wcel wph wa vx cab cuni cA vx
      cv cA wcel wph wa vx cab vx cv csn wceq vx cv cA wcel wph wa vx cab cuni
      vx cv csn cuni vx cv vx cv cA wcel wph wa vx cab vx cv csn unieq vx cv vx
      visset unisn syl6req vx cv cA wcel wph wa vx cab vx cv csn wceq vx cv cA
      wcel wph vx cv cA wcel wph wa vx cab vx cv csn wceq vx cv vx cv cA wcel
      wph wa vx cab wcel vx cv cA wcel wph wa vx cv cA wcel wph wa vx cab vx cv
      csn wceq vx cv vx cv cA wcel wph wa vx cab wcel vx cv vx cv csn wcel vx
      cv vx visset snid vx cv cA wcel wph wa vx cab vx cv csn vx cv eleq2
      mpbiri vx cv cA wcel wph wa vx abid sylib pm3.26d eqeltrrd 19.23ai sylbi
      wph vx cA df-reu wph vx cA crab cuni vx cv cA wcel wph wa vx cab cuni cA
      wph vx cA crab vx cv cA wcel wph wa vx cab wph vx cA df-rab unieqi eleq1i
      3imtr4i $.
      $( [22-Nov-1994] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The intersection of a class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare class intersection symbol. $)
  $c |^| $. $( Big cap $)

  $( Extend class notation to include the intersection of a class (read:
     'intersect ` A ` '). $)
  cint $a class |^| A $.

  ${
    $d x y A $.
    $( Define the intersection of a class.  Definition 7.35 of
       [TakeutiZaring] p. 44. $)
    df-int $a |- |^| A = { x | A. y ( y e. A -> x e. y ) } $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of class intersection. $)
    dfint2 $p |- |^| A = { x | A. y e. A x e. y } $=
      cA cint vy cv cA wcel vx cv vy cv wcel wi vy wal vx cab vx cv vy cv wcel
      vy cA wral vx cab vx vy cA df-int vx cv vy cv wcel vy cA wral vy cv cA
      wcel vx cv vy cv wcel wi vy wal vx vx cv vy cv wcel vy cA df-ral abbii
      eqtr4i $.
      $( [28-Jun-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality law for intersection. $)
    inteq $p |- ( A = B -> |^| A = |^| B ) $=
      cA cB wceq vx cv vy cv wcel vy cA wral vx cab vx cv vy cv wcel vy cB wral
      vx cab cA cint cB cint cA cB wceq vx cv vy cv wcel vy cA wral vx cv vy cv
      wcel vy cB wral vx vx cv vy cv wcel vy cA cB raleq1 abbidv vx vy cA
      dfint2 vx vy cB dfint2 3eqtr4g $.
      $( [13-Sep-1999] $)
  $}

  ${
    inteqi.1 $e |- A = B $.
    $( Equality inference for class intersection. $)
    inteqi $p |- |^| A = |^| B $=
      cA cB wceq cA cint cB cint wceq inteqi.1 cA cB inteq ax-mp $.
      $( [2-Sep-2003] $)
  $}

  ${
    inteqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for class intersection. $)
    inteqd $p |- ( ph -> |^| A = |^| B ) $=
      wph cA cB wceq cA cint cB cint wceq inteqd.1 cA cB inteq syl $.
      $( [2-Sep-2003] $)
  $}

  ${
    $d x A y $.  $d x B y $.
    elint.1 $e |- A e. _V $.
    $( Membership in class intersection. $)
    elint $p |- ( A e. |^| B <-> A. x ( x e. B -> A e. x ) ) $=
      vx cv cB wcel vy cv vx cv wcel wi vx wal vx cv cB wcel cA vx cv wcel wi
      vx wal vy cA cB cint elint.1 vy cv cA wceq vx cv cB wcel vy cv vx cv wcel
      wi vx cv cB wcel cA vx cv wcel wi vx vy cv cA wceq vy cv vx cv wcel cA vx
      cv wcel vx cv cB wcel vy cv cA vx cv eleq1 imbi2d albidv vy vx cB df-int
      elab2 $.
      $( [21-May-1994] $)
  $}

  ${
    $d x A $.  $d x B $.
    elint2.1 $e |- A e. _V $.
    $( Membership in class intersection. $)
    elint2 $p |- ( A e. |^| B <-> A. x e. B A e. x ) $=
      cA cB cint wcel vx cv cB wcel cA vx cv wcel wi vx wal cA vx cv wcel vx cB
      wral vx cA cB elint2.1 elint cA vx cv wcel vx cB df-ral bitr4i $.
      $( [14-Oct-1999] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Membership in class intersection, with the sethood requirement expressed
       as an antecedent. $)
    elintg $p |- ( A e. C -> ( A e. |^| B <-> A. x e. B A e. x ) ) $=
      vy cv cB cint wcel vy cv vx cv wcel vx cB wral wb cA cB cint wcel cA vx
      cv wcel vx cB wral wb vy cA cC vy cv cA wceq vy cv cB cint wcel cA cB
      cint wcel vy cv vx cv wcel vx cB wral cA vx cv wcel vx cB wral vy cv cA
      cB cint eleq1 vy cv cA wceq vy cv vx cv wcel cA vx cv wcel vx cB vy cv cA
      vx cv eleq1 ralbidv bibi12d vx vy cv cB vy visset elint2 vtoclg $.
      $( [21-Nov-2003] $) $( [20-Nov-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Membership in class intersection. $)
    elinti $p |- ( A e. |^| B -> ( C e. B -> A e. C ) ) $=
      cA cB cint wcel vy cv cB wcel cA vy cv wcel wi vy wal cC cB wcel cA cC
      wcel wi vy cv cB wcel vx cv vy cv wcel wi vy wal vy cv cB wcel cA vy cv
      wcel wi vy wal vx cA cB cint vx cv cA wceq vy cv cB wcel vx cv vy cv wcel
      wi vy cv cB wcel cA vy cv wcel wi vy vx cv cA wceq vx cv vy cv wcel cA vy
      cv wcel vy cv cB wcel vx cv cA vy cv eleq1 imbi2d albidv vx cv cB cint
      wcel vy cv cB wcel vx cv vy cv wcel wi vy wal vy vx cv cB vx visset elint
      biimpi vtoclga vy cv cB wcel cA vy cv wcel wi vy wal cC cB wcel cA cC
      wcel vy cv cB wcel cA vy cv wcel wi cC cB wcel cA cC wcel wi vy cC cB vy
      cv cC wceq vy cv cB wcel cC cB wcel cA vy cv wcel cA cC wcel vy cv cC cB
      eleq1 vy cv cC cA eleq2 imbi12d cla4gv pm2.43b syl $.
      $( [14-Oct-1999] $)
  $}

  ${
    $d y z A $.  $d x y z $.
    hbint.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for intersection. $)
    hbint $p |- ( y e. |^| A -> A. x y e. |^| A ) $=
      vz cv cA wcel vy cv vz cv wcel wi vz wal vz cv cA wcel vy cv vz cv wcel
      wi vz wal vx wal vy cv cA cint wcel vy cv cA cint wcel vx wal vz cv cA
      wcel vy cv vz cv wcel wi vx vz vz cv cA wcel vy cv vz cv wcel vx vx vy vy
      vz cv cA vy cv vz cv wcel vx ax-17 hbint.1 hbel vy cv vz cv wcel vx ax-17
      hbim hbal vz vy cv cA vy visset elint vy cv cA cint wcel vz cv cA wcel vy
      cv vz cv wcel wi vz wal vx vz vy cv cA vy visset elint albii 3imtr4i $.
      $( [2-Feb-1997] $)
  $}

  ${
    $d A x y $.  $d ph y $.
    inteqab.1 $e |- A e. _V $.
    $( Membership in the intersection of a class abstraction. $)
    elintab $p |- ( A e. |^| { x | ph } <-> A. x ( ph -> A e. x ) ) $=
      cA wph vx cab cint wcel vy cv wph vx cab wcel cA vy cv wcel wi vy wal wph
      cA vx cv wcel wi vx wal vy cA wph vx cab inteqab.1 elint vy cv wph vx cab
      wcel cA vy cv wcel wi wph cA vx cv wcel wi vy vx vy cv wph vx cab wcel cA
      vy cv wcel vx wph vx vy hbab1 cA vy cv wcel vx ax-17 hbim wph cA vx cv
      wcel wi vy ax-17 vy cv vx cv wceq vy cv wph vx cab wcel wph cA vy cv wcel
      cA vx cv wcel vy cv vx cv wceq vy cv wph vx cab wcel vx cv wph vx cab
      wcel wph vy cv vx cv wph vx cab eleq1 wph vx abid syl6bb vy cv vx cv cA
      eleq2 imbi12d cbval bitri $.
      $( [30-Aug-1993] $)

    $( Membership in the intersection of a class abstraction. $)
    elintrab $p |- ( A e. |^| { x e. B | ph } <->
                 A. x e. B ( ph -> A e. x ) ) $=
      cA vx cv cB wcel wph wa vx cab cint wcel vx cv cB wcel wph cA vx cv wcel
      wi wi vx wal cA wph vx cB crab cint wcel wph cA vx cv wcel wi vx cB wral
      cA vx cv cB wcel wph wa vx cab cint wcel vx cv cB wcel wph wa cA vx cv
      wcel wi vx wal vx cv cB wcel wph cA vx cv wcel wi wi vx wal vx cv cB wcel
      wph wa vx cA inteqab.1 elintab vx cv cB wcel wph wa cA vx cv wcel wi vx
      cv cB wcel wph cA vx cv wcel wi wi vx vx cv cB wcel wph cA vx cv wcel
      impexp albii bitri wph vx cB crab cint vx cv cB wcel wph wa vx cab cint
      cA wph vx cB crab vx cv cB wcel wph wa vx cab wph vx cB df-rab inteqi
      eleq2i wph cA vx cv wcel wi vx cB df-ral 3bitr4i $.
      $( [17-Oct-1999] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d y ph $.
    $( Membership in the intersection of a class abstraction. $)
    elintrabg $p |- ( A e. C -> ( A e. |^| { x e. B | ph } <->
                 A. x e. B ( ph -> A e. x ) ) ) $=
      vy cv wph vx cB crab cint wcel wph vy cv vx cv wcel wi vx cB wral cA wph
      vx cB crab cint wcel wph cA vx cv wcel wi vx cB wral vy cA cC vy cv cA
      wph vx cB crab cint eleq1 vy cv cA wceq wph vy cv vx cv wcel wi wph cA vx
      cv wcel wi vx cB vy cv cA wceq vy cv vx cv wcel cA vx cv wcel wph vy cv
      cA vx cv eleq1 imbi2d ralbidv wph vx vy cv cB vy visset elintrab vtoclbg
      $.
      $( [28-Feb-2007] $) $( [17-Feb-2007] $)

    $( The intersection of the empty set is the universal class.  Exercise 2 of
       [TakeutiZaring] p. 44. $)
    int0 $p |- |^| (/) = _V $=
      vy cv c0 wcel vx cv vy cv wcel wi vy wal vx cab vx cv vx cv wceq vx cab
      c0 cint cvv vy cv c0 wcel vx cv vy cv wcel wi vy wal vx cv vx cv wceq vx
      vy cv c0 wcel vx cv vy cv wcel wi vy wal vx cv vx cv wceq vy cv c0 wcel
      vx cv vy cv wcel wi vy vy cv c0 wcel vx cv vy cv wcel vy cv noel pm2.21i
      ax-gen vx cv eqid 2th abbii vx vy c0 df-int vx df-v 3eqtr4i $.
      $( [18-Aug-1993] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ph $.
    $( An element of a class includes the intersection of the class.  Exercise
       4 of [TakeutiZaring] p. 44 (with correction), generalized to classes. $)
    intss1 $p |- ( A e. B -> |^| B C_ A ) $=
      cA cB wcel vx cB cint cA cA cB wcel vy cv cB wcel vx cv vy cv wcel wi vy
      wal vx cv cA wcel vx cv cB cint wcel vy cv cB wcel vx cv vy cv wcel wi vy
      wal cA cB wcel vx cv cA wcel vy cv cB wcel vx cv vy cv wcel wi cA cB wcel
      vx cv cA wcel wi vy cA cB vy cv cA wceq vy cv cB wcel cA cB wcel vx cv vy
      cv wcel vx cv cA wcel vy cv cA cB eleq1 vy cv cA vx cv eleq2 imbi12d
      cla4gv pm2.43a vy vx cv cB vx visset elint syl5ib ssrdv $.
      $( [18-Nov-1995] $)

    $( Subclass of a class intersection.  Theorem 5.11(viii) of [Monk1] p. 52
       and its converse. $)
    ssint $p |- ( A C_ |^| B <-> A. x e. B A C_ x ) $=
      cA cB cint wss vy cv cB cint wcel vy cA wral vy cv vx cv wcel vx cB wral
      vy cA wral cA vx cv wss vx cB wral vy cA cB cint dfss3 vy cv cB cint wcel
      vy cv vx cv wcel vx cB wral vy cA vx vy cv cB vy visset elint2 ralbii vy
      cv vx cv wcel vx cB wral vy cA wral vy cv vx cv wcel vy cA wral vx cB
      wral cA vx cv wss vx cB wral vy cv vx cv wcel vy vx cA cB ralcom cA vx cv
      wss vy cv vx cv wcel vy cA wral vx cB vy cA vx cv dfss3 ralbii bitr4i
      3bitri $.
      $( [14-Oct-1999] $)

    $( Subclass of the intersection of a class abstraction. $)
    ssintab $p |- ( A C_ |^| { x | ph } <-> A. x ( ph -> A C_ x ) ) $=
      cA wph vx cab cint wss cA vy cv wss vy wph vx cab wral vy cv wph vx cab
      wcel cA vy cv wss wi vy wal wph cA vx cv wss wi vx wal vy cA wph vx cab
      ssint cA vy cv wss vy wph vx cab df-ral vy cv wph vx cab wcel cA vy cv
      wss wi vy wal vx cv wph vx cab wcel cA vx cv wss wi vx wal wph cA vx cv
      wss wi vx wal vy cv wph vx cab wcel cA vy cv wss wi vx cv wph vx cab wcel
      cA vx cv wss wi vy vx vy cv wph vx cab wcel cA vy cv wss vx wph vx vy
      hbab1 cA vy cv wss vx ax-17 hbim vx cv wph vx cab wcel cA vx cv wss wi vy
      ax-17 vy cv vx cv wceq vy cv wph vx cab wcel vx cv wph vx cab wcel cA vy
      cv wss cA vx cv wss vy cv vx cv wph vx cab eleq1 vy cv vx cv cA sseq2
      imbi12d cbval vx cv wph vx cab wcel cA vx cv wss wi wph cA vx cv wss wi
      vx vx cv wph vx cab wcel wph cA vx cv wss wph vx abid imbi1i albii bitri
      3bitri $.
      $( [31-Jul-2006] $) $( [31-Jul-2006] $)

    $( Subclass of a least upper bound. $)
    ssintub $p |- A C_ |^| { x e. B | A C_ x } $=
      cA cA vx cv wss vx cB crab cint wss cA vy cv wss vy cA vx cv wss vx cB
      crab vy cA cA vx cv wss vx cB crab ssint vy cv cA vx cv wss vx cB crab
      wcel vy cv cB wcel cA vy cv wss cA vx cv wss cA vy cv wss vx vy cv cB vx
      cv vy cv cA sseq2 elrab pm3.27bi mprgbir $.
      $( [8-Aug-2000] $)

    $( Subclass of the minimum value of class of supersets. $)
    ssmin $p |- A C_ |^| { x | ( A C_ x /\ ph ) } $=
      cA cA vx cv wss wph wa vx cab cint wss cA vx cv wss wph wa cA vx cv wss
      wi vx cA vx cv wss wph wa vx cA ssintab cA vx cv wss wph pm3.26 mpgbir $.
      $( [10-Aug-2006] $) $( [10-Aug-2006] $)

    $( Any member of a class is the smallest of those members that include
       it. $)
    intmin $p |- ( A e. B -> |^| { x e. B | A C_ x } = A ) $=
      cA cB wcel cA vx cv wss vx cB crab cint cA wss cA cA vx cv wss vx cB crab
      cint wss wa cA vx cv wss vx cB crab cint cA wceq cA cB wcel cA vx cv wss
      vx cB crab cint cA wss cA cA vx cv wss vx cB crab cint wss cA cB wcel vy
      cA vx cv wss vx cB crab cint cA cA cB wcel cA vx cv wss vy cv vx cv wcel
      wi vx cB wral vy cv cA wcel vy cv cA vx cv wss vx cB crab cint wcel cA cB
      wcel cA vx cv wss vy cv vx cv wcel wi vx cB wral cA cA wss vy cv cA wcel
      cA ssid cA vx cv wss vy cv vx cv wcel wi cA cA wss vy cv cA wcel wi vx cA
      cB vx cv cA wceq cA vx cv wss cA cA wss vy cv vx cv wcel vy cv cA wcel vx
      cv cA cA sseq2 vx cv cA vy cv eleq2 imbi12d rcla4v mpii cA vx cv wss vx
      vy cv cB vy visset elintrab syl5ib ssrdv vx cA cB ssintub jctir cA vx cv
      wss vx cB crab cint cA eqss sylibr $.
      $( [8-Oct-2006] $) $( [13-Aug-2002] $)

    $( Intersection of subclasses. $)
    intss $p |- ( A C_ B -> |^| B C_ |^| A ) $=
      vy cv cA wcel vy cv cB wcel wi vy wal vx cv cB cint wcel vx cv cA cint
      wcel wi vx wal cA cB wss cB cint cA cint wss vy cv cA wcel vy cv cB wcel
      wi vy wal vx cv cB cint wcel vx cv cA cint wcel wi vx vy cv cA wcel vy cv
      cB wcel wi vy wal vy cv cB wcel vx cv vy cv wcel wi vy wal vy cv cA wcel
      vx cv vy cv wcel wi vy wal vx cv cB cint wcel vx cv cA cint wcel vy cv cA
      wcel vy cv cB wcel wi vy cv cB wcel vx cv vy cv wcel wi vy cv cA wcel vx
      cv vy cv wcel wi vy vy cv cA wcel vy cv cB wcel vx cv vy cv wcel imim1
      19.20ii vy vx cv cB vx visset elint vy vx cv cA vx visset elint 3imtr4g
      19.21aiv vy cA cB dfss2 vx cB cint cA cint dfss2 3imtr4i $.
      $( [14-Oct-1999] $)

    $( The intersection of a nonempty set is a subclass of its union. $)
    intssuni $p |- ( A =/= (/) -> |^| A C_ U. A ) $=
      cA c0 wne vx cA cint cA cuni cA c0 wne vx cv vy cv wcel vy cA wral vx cv
      vy cv wcel vy cA wrex vx cv cA cint wcel vx cv cA cuni wcel cA c0 wne vx
      cv vy cv wcel vy cA wral vx cv vy cv wcel vy cA wrex vx cv vy cv wcel vy
      cA r19.2z ex vy vx cv cA vx visset elint2 vy vx cv cA eluni2 3imtr4g
      ssrdv $.
      $( [21-Dec-2006] $) $( [29-Jul-2006] $)
  $}

  $( If the union of a class is included in its intersection, the class is
     either the empty set or a singleton ( ~ uniintsn ). $)
  unissint $p |- ( U. A C_ |^| A <-> ( A = (/) \/ U. A = |^| A ) ) $=
    cA cuni cA cint wss cA cuni cA cint wpss cA cuni cA cint wceq wo cA c0 wceq
    cA cuni cA cint wceq wo cA cuni cA cint sspss cA cuni cA cint wpss cA c0
    wceq cA cuni cA cint wceq cA cuni cA cint wpss cA c0 wceq cA cuni cA cint
    wpss cA cuni cA cint wss cA cint cA cuni wss wn wa cA c0 wceq cA cuni cA
    cint dfpss3 cA cint cA cuni wss wn cA c0 wceq cA cuni cA cint wss cA cint
    cA cuni wss cA c0 cA intssuni necon1bi adantl sylbi cA c0 wceq cA cuni cA
    cint wpss c0 cvv wpss c0 cvv wpss c0 cvv wceq wn c0 cvv wne c0 cvv wceq wn
    cvv c0 wne c0 cvv wne vn0 cvv c0 necom mpbi c0 cvv df-ne mpbi c0 pssv mpbir
    cA c0 wceq cA cuni c0 cA cint cvv cA c0 wceq cA cuni c0 cuni c0 cA c0 unieq
    uni0 syl6eq cA c0 wceq cA cint c0 cint cvv cA c0 inteq int0 syl6eq psseq12d
    mpbiri impbii orbi1i bitri $.
    $( [30-Oct-2010] $) $( [30-Oct-2010] $)

  $( Subclass relationship for intersection and union. $)
  intssuni2 $p |- ( ( A C_ B /\ A =/= (/) ) -> |^| A C_ U. B ) $=
    cA c0 wne cA cB wss cA cint cA cuni cB cuni cA intssuni cA cB uniss
    sylan9ssr $.
    $( [31-Dec-2006] $) $( [29-Jul-2006] $)

  ${
    $d x A $.
    intmin2.1 $e |- A e. _V $.
    $( Any set is the smallest of all sets that include it. $)
    intmin2 $p |- |^| { x | A C_ x } = A $=
      cA vx cv wss vx cvv crab cint cA vx cv wss vx cab cint cA cA vx cv wss vx
      cvv crab cA vx cv wss vx cab cA vx cv wss vx rabab inteqi cA cvv wcel cA
      vx cv wss vx cvv crab cint cA wceq intmin2.1 vx cA cvv intmin ax-mp
      eqtr3i $.
      $( [30-Nov-2006] $) $( [20-Sep-2003] $)
  $}

  ${
    $d x A $.  $d x ps $.
    intmin3.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    intmin3.3 $e |- ps $.
    $( Under subset ordering, the intersection of a class abstraction is less
       than or equal to any of its members. $)
    intmin3 $p |- ( A e. B -> |^| { x | ph } C_ A ) $=
      cA cB wcel cA wph vx cab wcel wph vx cab cint cA wss cA cB wcel cA wph vx
      cab wcel wps intmin3.3 wph wps vx cA cB intmin3.2 elabg mpbiri cA wph vx
      cab intss1 syl $.
      $( [6-Jul-2005] $) $( [3-Jul-2005] $)
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Elimination of a conjunct in a class intersection. $)
    intmin4 $p |- ( A C_ |^| { x | ph } ->
                  |^| { x | ( A C_ x /\ ph ) } = |^| { x | ph } ) $=
      cA wph vx cab cint wss vy cA vx cv wss wph wa vx cab cint wph vx cab cint
      cA wph vx cab cint wss cA vx cv wss wph wa vy cv vx cv wcel wi vx wal wph
      vy cv vx cv wcel wi vx wal vy cv cA vx cv wss wph wa vx cab cint wcel vy
      cv wph vx cab cint wcel cA wph vx cab cint wss wph cA vx cv wss wi vx wal
      cA vx cv wss wph wa vy cv vx cv wcel wi vx wal wph vy cv vx cv wcel wi vx
      wal wb wph vx cA ssintab wph cA vx cv wss wi vx wal cA vx cv wss wph wa
      vy cv vx cv wcel wi wph vy cv vx cv wcel wi wb vx wal cA vx cv wss wph wa
      vy cv vx cv wcel wi vx wal wph vy cv vx cv wcel wi vx wal wb wph cA vx cv
      wss wi cA vx cv wss wph wa vy cv vx cv wcel wi wph vy cv vx cv wcel wi wb
      vx wph cA vx cv wss wi cA vx cv wss wph wa wph vy cv vx cv wcel wph cA vx
      cv wss wi cA vx cv wss wph wa wph cA vx cv wss wph pm3.27 wph cA vx cv
      wss ancr impbid2 imbi1d 19.20i cA vx cv wss wph wa vy cv vx cv wcel wi
      wph vy cv vx cv wcel wi vx 19.15 syl sylbi cA vx cv wss wph wa vx vy cv
      vy visset elintab wph vx vy cv vy visset elintab 3bitr4g eqrdv $.
      $( [11-Aug-2006] $) $( [31-Jul-2006] $)
  $}

  ${
    $d x z A $.  $d x z ph $.  $d x y z $.
    intab.1 $e |- A e. _V $.
    intab.2 $e |- { x | E. y ( ph /\ x = A ) } e. _V $.
    $( The intersection of a special case of a class abstraction.  ` y ` may be
       free in ` ph ` and ` A ` , which can be thought of a ` ph ( y ) ` and
       ` A ( y ) ` .  Typically, ~ abrexex2 or ~ abexssex can be used to
       satisfy the second hypothesis. $)
    intab $p |- |^| { x | A. y ( ph -> A e. x ) } =
                { x | E. y ( ph /\ x = A ) } $=
      wph cA vx cv wcel wi vy wal vx cab cint wph vz cv cA wceq wa vy wex vz
      cab wph vx cv cA wceq wa vy wex vx cab wph cA vx cv wcel wi vy wal vx cab
      cint wph vz cv cA wceq wa vy wex vz cab wph vz cv cA wceq wa vy wex vz
      cab wph cA vx cv wcel wi vy wal vx cab wcel wph cA vx cv wcel wi vy wal
      vx cab cint wph vz cv cA wceq wa vy wex vz cab wss wph vz cv cA wceq wa
      vy wex vz cab wph cA vx cv wcel wi vy wal vx cab wcel wph cA vx cv wcel
      wi vy wal vx wph vz cv cA wceq wa vy wex vz cab wsbc wph cA vx cv wcel wi
      vy wal vx wph vz cv cA wceq wa vy wex vz cab wsbc wph cA wph vz cv cA
      wceq wa vy wex vz cab wcel wi vy wph cA vx cv wcel wi vy wal wph cA wph
      vz cv cA wceq wa vy wex vz cab wcel wi vy wal vx wph vz cv cA wceq wa vy
      wex vz cab wph vz cv cA wceq wa vy wex vz cab wph vx cv cA wceq wa vy wex
      vx cab cvv wph vz cv cA wceq wa vy wex wph vx cv cA wceq wa vy wex vz vx
      vz cv vx cv wceq wph vz cv cA wceq wa wph vx cv cA wceq wa vy vz cv vx cv
      wceq vz cv cA wceq vx cv cA wceq wph vz cv vx cv cA eqeq1 anbi2d exbidv
      cbvabv intab.2 eqeltri vx cv wph vz cv cA wceq wa vy wex vz cab wceq wph
      cA vx cv wcel wi wph cA wph vz cv cA wceq wa vy wex vz cab wcel wi vy vy
      vx wph vz cv cA wceq wa vy wex vz cab wph vz cv cA wceq wa vy wex vy vz
      vx wph vz cv cA wceq wa vy hbe1 hbab hbeleq vx cv wph vz cv cA wceq wa vy
      wex vz cab wceq cA vx cv wcel cA wph vz cv cA wceq wa vy wex vz cab wcel
      wph vx cv wph vz cv cA wceq wa vy wex vz cab cA eleq2 imbi2d albid sbcie
      wph wph vz cv cA wceq wa vy wex vz cA wsbc cA wph vz cv cA wceq wa vy wex
      vz cab wcel wph wph vz cv cA wceq wa vz cA wsbc wph vz cv cA wceq wa vy
      wex vz cA wsbc wph wph vz cA wsbc vz cv cA wceq vz cA wsbc wa wph vz cv
      cA wceq wa vz cA wsbc wph wph vz cA wsbc vz cv cA wceq vz cA wsbc wph vz
      cA wsbc wph cA cvv wcel wph vz cA wsbc wph wb intab.1 wph vz cA cvv wph
      vz ax-17 sbcgf ax-mp biimpri vz cv cA wceq vz cA wsbc vz cA vz cv csb cA
      wceq cA cvv wcel vz cA vz cv csb cA wceq intab.1 vz cA cvv csbvarg ax-mp
      cA cvv wcel vz cv cA wceq vz cA wsbc vz cA vz cv csb cA wceq wb intab.1
      vz cA vz cv cA cvv sbceq1dig ax-mp mpbir jctir cA cvv wcel wph vz cv cA
      wceq wa vz cA wsbc wph vz cA wsbc vz cv cA wceq vz cA wsbc wa wb intab.1
      wph vz cv cA wceq vz cA cvv sbcang ax-mp sylibr wph vz cv cA wceq wa wph
      vz cv cA wceq wa vy wex wi vz cA wsbc wph vz cv cA wceq wa vz cA wsbc wph
      vz cv cA wceq wa vy wex vz cA wsbc wi cA cvv wcel wph vz cv cA wceq wa
      wph vz cv cA wceq wa vy wex wi vz wal wph vz cv cA wceq wa wph vz cv cA
      wceq wa vy wex wi vz cA wsbc intab.1 wph vz cv cA wceq wa wph vz cv cA
      wceq wa vy wex wi vz wph vz cv cA wceq wa vy 19.8a ax-gen wph vz cv cA
      wceq wa wph vz cv cA wceq wa vy wex wi vz cA cvv a4sbc mp2 cA cvv wcel
      wph vz cv cA wceq wa wph vz cv cA wceq wa vy wex wi vz cA wsbc wph vz cv
      cA wceq wa vz cA wsbc wph vz cv cA wceq wa vy wex vz cA wsbc wi wb
      intab.1 wph vz cv cA wceq wa wph vz cv cA wceq wa vy wex vz cA cvv sbcimg
      ax-mp mpbi syl wph vz cv cA wceq wa vy wex vz cA intab.1 elabs sylibr
      mpgbir wph cA vx cv wcel wi vy wal vx wph vz cv cA wceq wa vy wex vz cab
      wph vz cv cA wceq wa vy wex vz cab wph vx cv cA wceq wa vy wex vx cab cvv
      wph vz cv cA wceq wa vy wex wph vx cv cA wceq wa vy wex vz vx vz cv vx cv
      wceq wph vz cv cA wceq wa wph vx cv cA wceq wa vy vz cv vx cv wceq vz cv
      cA wceq vx cv cA wceq wph vz cv vx cv cA eqeq1 anbi2d exbidv cbvabv
      intab.2 eqeltri elabs mpbir wph vz cv cA wceq wa vy wex vz cab wph cA vx
      cv wcel wi vy wal vx cab intss1 ax-mp wph vz cv cA wceq wa vy wex vz wph
      cA vx cv wcel wi vy wal vx cab cint wph vz cv cA wceq wa vz cv wph cA vx
      cv wcel wi vy wal vx cab cint wcel vy vy vz wph cA vx cv wcel wi vy wal
      vx cab wph cA vx cv wcel wi vy wal vy vx vz wph cA vx cv wcel wi vy hba1
      hbab hbint wph vz cv cA wceq wa wph cA vx cv wcel wi vy wal vz cv vx cv
      wcel wi vx wal vz cv wph cA vx cv wcel wi vy wal vx cab cint wcel wph vz
      cv cA wceq wa wph cA vx cv wcel wi vy wal vz cv vx cv wcel wi vx wph vz
      cv cA wceq wa wph cA vx cv wcel wi vy wal cA vx cv wcel vz cv vx cv wcel
      wph wph cA vx cv wcel wi vy wal cA vx cv wcel wi vz cv cA wceq wph cA vx
      cv wcel wi vy wal wph cA vx cv wcel wph cA vx cv wcel wi vy ax-4 com12
      adantr vz cv cA wceq vz cv vx cv wcel cA vx cv wcel wb wph vz cv cA vx cv
      eleq1 adantl sylibrd 19.21aiv wph cA vx cv wcel wi vy wal vx vz cv vz
      visset elintab sylibr 19.23ai abssi eqssi wph vz cv cA wceq wa vy wex wph
      vx cv cA wceq wa vy wex vz vx vz cv vx cv wceq wph vz cv cA wceq wa wph
      vx cv cA wceq wa vy vz cv vx cv wceq vz cv cA wceq vx cv cA wceq wph vz
      cv vx cv cA eqeq1 anbi2d exbidv cbvabv eqtri $.
      $( [7-Aug-2006] $) $( [28-Jul-2006] $)
  $}

  $( The intersection of a class containing the empty set is empty. $)
  int0el $p |- ( (/) e. A -> |^| A = (/) ) $=
    c0 cA wcel cA cint c0 c0 cA intss1 c0 cA cint wss c0 cA wcel cA cint 0ss
    a1i eqssd $.
    $( [25-Apr-2004] $) $( [24-Apr-2004] $)

  ${
    $d x y A $.  $d x y B $.
    $( The class intersection of the union of two classes.  Theorem 78 of
       [Suppes] p. 42. $)
    intun $p |- |^| ( A u. B ) = ( |^| A i^i |^| B ) $=
      vx cA cB cun cint cA cint cB cint cin vy cv cA cB cun wcel vx cv vy cv
      wcel wi vy wal vx cv cA cint wcel vx cv cB cint wcel wa vx cv cA cB cun
      cint wcel vx cv cA cint cB cint cin wcel vy cv cA wcel vx cv vy cv wcel
      wi vy cv cB wcel vx cv vy cv wcel wi wa vy wal vy cv cA wcel vx cv vy cv
      wcel wi vy wal vy cv cB wcel vx cv vy cv wcel wi vy wal wa vy cv cA cB
      cun wcel vx cv vy cv wcel wi vy wal vx cv cA cint wcel vx cv cB cint wcel
      wa vy cv cA wcel vx cv vy cv wcel wi vy cv cB wcel vx cv vy cv wcel wi vy
      19.26 vy cv cA cB cun wcel vx cv vy cv wcel wi vy cv cA wcel vx cv vy cv
      wcel wi vy cv cB wcel vx cv vy cv wcel wi wa vy vy cv cA cB cun wcel vx
      cv vy cv wcel wi vy cv cA wcel vy cv cB wcel wo vx cv vy cv wcel wi vy cv
      cA wcel vx cv vy cv wcel wi vy cv cB wcel vx cv vy cv wcel wi wa vy cv cA
      cB cun wcel vy cv cA wcel vy cv cB wcel wo vx cv vy cv wcel vy cv cA cB
      elun imbi1i vy cv cA wcel vx cv vy cv wcel vy cv cB wcel jaob bitri albii
      vx cv cA cint wcel vy cv cA wcel vx cv vy cv wcel wi vy wal vx cv cB cint
      wcel vy cv cB wcel vx cv vy cv wcel wi vy wal vy vx cv cA vx visset elint
      vy vx cv cB vx visset elint anbi12i 3bitr4i vy vx cv cA cB cun vx visset
      elint vx cv cA cint cB cint elin 3bitr4i eqriv $.
      $( [22-Sep-2002] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    intpr.1 $e |- A e. _V $.
    intpr.2 $e |- B e. _V $.
    $( The intersection of a pair is the intersection of its members.  Theorem
       71 of [Suppes] p. 42. $)
    intpr $p |- |^| { A , B } = ( A i^i B ) $=
      vx cA cB cpr cint cA cB cin vy cv cA cB cpr wcel vx cv vy cv wcel wi vy
      wal vx cv cA wcel vx cv cB wcel wa vx cv cA cB cpr cint wcel vx cv cA cB
      cin wcel vy cv cA wceq vx cv vy cv wcel wi vy cv cB wceq vx cv vy cv wcel
      wi wa vy wal vy cv cA wceq vx cv vy cv wcel wi vy wal vy cv cB wceq vx cv
      vy cv wcel wi vy wal wa vy cv cA cB cpr wcel vx cv vy cv wcel wi vy wal
      vx cv cA wcel vx cv cB wcel wa vy cv cA wceq vx cv vy cv wcel wi vy cv cB
      wceq vx cv vy cv wcel wi vy 19.26 vy cv cA cB cpr wcel vx cv vy cv wcel
      wi vy cv cA wceq vx cv vy cv wcel wi vy cv cB wceq vx cv vy cv wcel wi wa
      vy vy cv cA cB cpr wcel vx cv vy cv wcel wi vy cv cA wceq vy cv cB wceq
      wo vx cv vy cv wcel wi vy cv cA wceq vx cv vy cv wcel wi vy cv cB wceq vx
      cv vy cv wcel wi wa vy cv cA cB cpr wcel vy cv cA wceq vy cv cB wceq wo
      vx cv vy cv wcel vy cv cA cB vy visset elpr imbi1i vy cv cA wceq vx cv vy
      cv wcel vy cv cB wceq jaob bitri albii vx cv cA wcel vy cv cA wceq vx cv
      vy cv wcel wi vy wal vx cv cB wcel vy cv cB wceq vx cv vy cv wcel wi vy
      wal vy vx cv cA intpr.1 clel4 vy vx cv cB intpr.2 clel4 anbi12i 3bitr4i
      vy vx cv cA cB cpr vx visset elint vx cv cA cB elin 3bitr4i eqriv $.
      $( [14-Oct-1999] $)
  $}

  ${
    intsn.1 $e |- A e. _V $.
    $( The intersection of a singleton is its member.  Theorem 70 of [Suppes]
       p. 41. $)
    intsn $p |- |^| { A } = A $=
      cA csn cint cA cA cpr cint cA cA cin cA cA csn cA cA cpr cA dfsn2 inteqi
      cA cA intsn.1 intsn.1 intpr cA inidm 3eqtri $.
      $( [29-Sep-2002] $)
  $}

  ${
    $d x y A $.
    $( Two ways to express " ` A ` is a singleton."  See also ~ en1 ,
       ~ card1 , and ~ eusn . $)
    uniintsn $p |- ( U. A = |^| A <-> E. x A = { x } ) $=
      cA cuni cA cint wceq cA vx cv csn wceq vx wex cA cuni cA cint wceq vx cv
      cA wcel vx wex vx cv cA wcel vy cv cA wcel wa vx cv vy cv wceq wi vy wal
      vx wal wa cA vx cv csn wceq vx wex cA cuni cA cint wceq vx cv cA wcel vx
      wex vx cv cA wcel vy cv cA wcel wa vx cv vy cv wceq wi vy wal vx wal cA
      cuni cA cint wceq cA c0 wne vx cv cA wcel vx wex cA cuni cA cint wceq cvv
      c0 wne cA c0 wne vn0 cA cuni cA cint wceq cA c0 cvv c0 cA cuni cA cint
      wceq cA c0 wceq cvv c0 wceq cA cuni cA cint wceq cA c0 wceq wa cA cint
      cvv c0 cA c0 wceq cA cint cvv wceq cA cuni cA cint wceq cA c0 wceq cA
      cint c0 cint cvv cA c0 inteq int0 syl6eq adantl cA cuni cA cint wceq cA
      c0 wceq cA cint c0 wceq cA cuni cA cint wceq cA cuni c0 wceq cA cint c0
      wceq cA c0 wceq cA cuni cA cint c0 eqeq1 cA c0 wceq cA cuni c0 cuni c0 cA
      c0 unieq uni0 syl6eq syl5bi imp eqtr3d ex necon3d mpi vx cA n0 sylib cA
      cuni cA cint wceq vx cv cA wcel vy cv cA wcel wa vx cv vy cv wceq wi vx
      vy cA cuni cA cint wceq vx cv vy cv cpr cA wss vx cv vy cv wceq vx cv cA
      wcel vy cv cA wcel wa cA cuni cA cint wceq vx cv vy cv cpr cA wss vx cv
      vy cv wceq cA cuni cA cint wceq vx cv vy cv cpr cA wss wa vx cv vy cv cun
      vx cv vy cv cin wss vx cv vy cv cin vx cv vy cv cun wss wa vx cv vy cv
      wceq cA cuni cA cint wceq vx cv vy cv cpr cA wss wa vx cv vy cv cun vx cv
      vy cv cin wss vx cv vy cv cin vx cv vy cv cun wss cA cuni cA cint wceq vx
      cv vy cv cpr cA wss wa vx cv vy cv cpr cuni vx cv vy cv cpr cint vx cv vy
      cv cun vx cv vy cv cin cA cuni cA cint wceq vx cv vy cv cpr cA wss wa vx
      cv vy cv cpr cuni cA cint vx cv vy cv cpr cint cA cuni cA cint wceq vx cv
      vy cv cpr cA wss wa vx cv vy cv cpr cuni cA cuni cA cint vx cv vy cv cpr
      cA wss vx cv vy cv cpr cuni cA cuni wss cA cuni cA cint wceq vx cv vy cv
      cpr cA uniss adantl cA cuni cA cint wceq vx cv vy cv cpr cA wss pm3.26
      sseqtrd vx cv vy cv cpr cA wss cA cint vx cv vy cv cpr cint wss cA cuni
      cA cint wceq vx cv vy cv cpr cA intss adantl sstrd vx cv vy cv vx visset
      vy visset unipr vx cv vy cv vx visset vy visset intpr 3sstr3g vx cv vy cv
      cin vx cv vx cv vy cv cun vx cv vy cv inss1 vx cv vy cv ssun1 sstri jctir
      vx cv vy cv cun vx cv vy cv cin wss vx cv vy cv cin vx cv vy cv cun wss
      wa vx cv vy cv cun vx cv vy cv cin wceq vx cv vy cv wceq vx cv vy cv cun
      vx cv vy cv cin eqss vx cv vy cv uneqin bitr3i sylib ex vx cv vy cv cA vx
      visset vy visset prss syl5ib 19.21aivv jca vx cv cA wcel vx weu vx cv cA
      wcel vx cab vx cv csn wceq vx wex vx cv cA wcel vx wex vx cv cA wcel vy
      cv cA wcel wa vx cv vy cv wceq wi vy wal vx wal wa cA vx cv csn wceq vx
      wex vx cv cA wcel vx euabsn vx cv cA wcel vy cv cA wcel vx vy vx cv vy cv
      cA eleq1 eu4 vx cv cA wcel vx cab vx cv csn wceq cA vx cv csn wceq vx vx
      cv cA wcel vx cab cA vx cv csn vx cA abid2 eqeq1i exbii 3bitr3i sylib cA
      vx cv csn wceq cA cuni cA cint wceq vx cA vx cv csn wceq vx cv csn cuni
      vx cv cA cuni cA cint vx cv vx visset unisn cA vx cv csn unieq cA vx cv
      csn wceq cA cint vx cv csn cint vx cv cA vx cv csn inteq vx cv vx visset
      intsn syl6eq 3eqtr4a 19.23aiv impbii $.
      $( [2-Aug-2010] $) $( [2-Aug-2010] $)
  $}

  ${
    intunsn.1 $e |- B e. _V $.
    $( Theorem joining a singleton to an intersection. $)
    intunsn $p |- |^| ( A u. { B } ) = ( |^| A i^i B ) $=
      cA cB csn cun cint cA cint cB csn cint cin cA cint cB cin cA cB csn intun
      cB csn cint cB cA cint cB intunsn.1 intsn ineq2i eqtri $.
      $( [29-Sep-2002] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Indexed union and intersection
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c U_ $. $( Underlined big cup. $)
  $c |^|_ $. $( Underlined big cap. $)

  $( Extend class notation to include indexed union.  Note:  Historically
     (prior to 21-Oct-2005), set.mm used the notation ` U. x e. A B ` , with
     the same union symbol as ~ cuni .  While that syntax was unambiguous, it
     did not allow for LALR parsing of the syntax constructions in set.mm.
     The new syntax uses as distinguished symbol ` U_ ` instead of ` U. ` and
     does allow LALR parsing.  Thanks to Peter Backes for suggesting this
     change. $)
  ciun $a class U_ x e. A B $.

  $( Extend class notation to include indexed intersection.  Note:
     Historically (prior to 21-Oct-2005), set.mm used the notation
     ` |^| x e. A B ` , with the same intersection symbol as ~ cint .
     Although that syntax was unambiguous, it did not allow for LALR parsing
     of the syntax constructions in set.mm.  The new syntax uses a
     distinguished symbol ` |^|_ ` instead of ` |^| ` and does allow LALR
     parsing.  Thanks to Peter Backes for suggesting this change. $)
  ciin $a class |^|_ x e. A B $.

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Define indexed union.  Definition of [Stoll] p. 45.  In normal use,
       ` A ` is independent of ` x ` , and ` B ` depends on ` x ` i.e. can be
       read informally as ` B ( x ) ` .  We call ` x ` the index, ` A ` the
       index set, and ` B ` the indexed set.  In most books, ` x e. A ` is
       written as a subscript or underneath a union symbol ` U. ` .  We use a
       special union symbol ` U_ ` to make it easier to distinguish from plain
       class union.  In many theorems, you will see that ` x ` and ` A ` are in
       the same distinct variable group (meaning ` A ` cannot depend on ` x ` )
       and that ` B ` and ` x ` do not share a distinct variable group (meaning
       that can be thought of as ` B ( x ) ` i.e. can be substituted with a
       class expression containing ` x ` ).  An alternate definition tying
       indexed union to ordinary union is ~ dfiun2 .  Theorem ~ uniiun provides
       a definition of ordinary union in terms of indexed union.  Theorems
       ~ fniunfv and ~ funiunfv are useful when ` B ` is a function. $)
    df-iun $a |- U_ x e. A B = { y | E. x e. A y e. B } $.

    $( Define indexed intersection.  Definition of [Stoll] p. 45.  See the
       remarks for its sibling operation of indexed union ~ df-iun .  An
       alternate definition tying indexed intersection to ordinary intersection
       is ~ dfiin2 .  Theorem ~ intiin provides a definition of ordinary
       intersection in terms of indexed intersection. $)
    df-iin $a |- |^|_ x e. A B = { y | A. x e. A y e. B } $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y C $.
    $( Membership in indexed union. $)
    eliun $p |- ( A e. U_ x e. B C <-> E. x e. B A e. C ) $=
      cA vx cB cC ciun wcel cA cvv wcel cA cC wcel vx cB wrex cA vx cB cC ciun
      elisset cA cC wcel cA cvv wcel vx cB cA cC wcel cA cvv wcel wi vx cv cB
      wcel cA cC elisset a1i r19.23aiv vy cv cC wcel vx cB wrex cA cC wcel vx
      cB wrex vy cA vx cB cC ciun cvv vy cv cA wceq vy cv cC wcel cA cC wcel vx
      cB vy cv cA cC eleq1 rexbidv vx vy cB cC df-iun elab2g pm5.21nii $.
      $( [3-Sep-2003] $)

    $( Membership in indexed intersection. $)
    eliin $p |- ( A e. D -> ( A e. |^|_ x e. B C <-> A. x e. B A e. C ) ) $=
      vy cv cC wcel vx cB wral cA cC wcel vx cB wral vy cA vx cB cC ciin cD vy
      cv cA wceq vy cv cC wcel cA cC wcel vx cB vy cv cA cC eleq1 ralbidv vx vy
      cB cC df-iin elab2g $.
      $( [3-Sep-2003] $)
  $}

  ${
    $d y z A $.  $d x z B $.  $d z C $.  $d x y $.
    $( Commutation of indexed unions. $)
    iuncom $p |- U_ x e. A U_ y e. B C = U_ y e. B U_ x e. A C $=
      vz vx cA vy cB cC ciun ciun vy cB vx cA cC ciun ciun vz cv vy cB cC ciun
      wcel vx cA wrex vz cv vx cA cC ciun wcel vy cB wrex vz cv vx cA vy cB cC
      ciun ciun wcel vz cv vy cB vx cA cC ciun ciun wcel vz cv cC wcel vy cB
      wrex vx cA wrex vz cv cC wcel vx cA wrex vy cB wrex vz cv vy cB cC ciun
      wcel vx cA wrex vz cv vx cA cC ciun wcel vy cB wrex vz cv cC wcel vx vy
      cA cB rexcom vz cv vy cB cC ciun wcel vz cv cC wcel vy cB wrex vx cA vy
      vz cv cB cC eliun rexbii vz cv vx cA cC ciun wcel vz cv cC wcel vx cA
      wrex vy cB vx vz cv cA cC eliun rexbii 3bitr4i vx vz cv cA vy cB cC ciun
      eliun vy vz cv cB vx cA cC ciun eliun 3bitr4i eqriv $.
      $( [27-Dec-2008] $) $( [18-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Indexed union of a constant class, i.e. where ` B ` does not depend
       on ` x ` . $)
    iunconst $p |- ( A =/= (/) -> U_ x e. A B = B ) $=
      cA c0 wne vy vx cA cB ciun cB cA c0 wne vy cv cB wcel vx cv cA wcel vx
      wex vy cv cB wcel wa vy cv vx cA cB ciun wcel cA c0 wne vx cv cA wcel vx
      wex vy cv cB wcel vx cv cA wcel vx wex vy cv cB wcel wa wb vx cA n0 vx cv
      cA wcel vx wex vy cv cB wcel ibar sylbi vy cv vx cA cB ciun wcel vy cv cB
      wcel vx cA wrex vx cv cA wcel vy cv cB wcel wa vx wex vx cv cA wcel vx
      wex vy cv cB wcel wa vx vy cv cA cB eliun vy cv cB wcel vx cA df-rex vx
      cv cA wcel vy cv cB wcel vx 19.41v 3bitri syl6rbbr eqrdv $.
      $( [4-Jan-2007] $) $( [5-Sep-2004] $)
  $}

  ${
    $d x y $.  $d y z A $.  $d x z B $.  $d z C $.
    $( Law combining indexed union with indexed intersection.  Eq.  (14),
       p. 109, in _Set Theory, with an Introduction to Descriptive Set Theory_
       by K. Kuratowski and A. Mostowski (2nd ed., 1976).  (This theorem also
       appears as the last example at ~
       http://en.wikipedia.org/wiki/Union%5F%28set%5Ftheory%29 .) $)
    iuniin $p |- U_ x e. A |^|_ y e. B C C_ |^|_ y e. B U_ x e. A C $=
      vz vx cA vy cB cC ciin ciun vy cB vx cA cC ciun ciin vz cv cC wcel vy cB
      wral vx cA wrex vz cv cC wcel vx cA wrex vy cB wral vz cv vx cA vy cB cC
      ciin ciun wcel vz cv vy cB vx cA cC ciun ciin wcel vz cv cC wcel vx vy cA
      cB r19.12 vz cv vx cA vy cB cC ciin ciun wcel vz cv vy cB cC ciin wcel vx
      cA wrex vz cv cC wcel vy cB wral vx cA wrex vx vz cv cA vy cB cC ciin
      eliun vz cv vy cB cC ciin wcel vz cv cC wcel vy cB wral vx cA vz cv cvv
      wcel vz cv vy cB cC ciin wcel vz cv cC wcel vy cB wral wb vz visset vy vz
      cv cB cC cvv eliin ax-mp rexbii bitri vz cv vy cB vx cA cC ciun ciin wcel
      vz cv vx cA cC ciun wcel vy cB wral vz cv cC wcel vx cA wrex vy cB wral
      vz cv cvv wcel vz cv vy cB vx cA cC ciun ciin wcel vz cv vx cA cC ciun
      wcel vy cB wral wb vz visset vy vz cv cB vx cA cC ciun cvv eliin ax-mp vz
      cv vx cA cC ciun wcel vz cv cC wcel vx cA wrex vy cB vx vz cv cA cC eliun
      ralbii bitri 3imtr4i ssriv $.
      $( [8-Dec-2010] $) $( [17-Aug-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Subclass theorem for indexed union. $)
    iunss1 $p |- ( A C_ B -> U_ x e. A C C_ U_ x e. B C ) $=
      cA cB wss vy cv cC wcel vx cA wrex vy cab vy cv cC wcel vx cB wrex vy cab
      vx cA cC ciun vx cB cC ciun cA cB wss vy cv cC wcel vx cA wrex vy cv cC
      wcel vx cB wrex wi vy wal vy cv cC wcel vx cA wrex vy cab vy cv cC wcel
      vx cB wrex vy cab wss cA cB wss vy cv cC wcel vx cA wrex vy cv cC wcel vx
      cB wrex wi vy cA cB wss vy cv cC wcel vy cv cC wcel vx cA cB cA cB wss vx
      cv cA wcel vx cv cB wcel vy cv cC wcel cA cB vx cv ssel anim1d r19.22dv2
      19.21aiv vy cv cC wcel vx cA wrex vy cv cC wcel vx cB wrex vy ss2ab
      sylibr vx vy cA cC df-iun vx vy cB cC df-iun 3sstr4g $.
      $( [11-Dec-2004] $) $( [10-Dec-2004] $)

    $( Equality theorem for indexed union. $)
    iuneq1 $p |- ( A = B -> U_ x e. A C = U_ x e. B C ) $=
      cA cB wss cB cA wss wa vx cA cC ciun vx cB cC ciun wss vx cB cC ciun vx
      cA cC ciun wss wa cA cB wceq vx cA cC ciun vx cB cC ciun wceq cA cB wss
      vx cA cC ciun vx cB cC ciun wss cB cA wss vx cB cC ciun vx cA cC ciun wss
      vx cA cB cC iunss1 vx cB cA cC iunss1 anim12i cA cB eqss vx cA cC ciun vx
      cB cC ciun eqss 3imtr4i $.
      $( [27-Jun-1998] $)

    $( Equality theorem for restricted existential quantifier. $)
    iineq1 $p |- ( A = B -> |^|_ x e. A C = |^|_ x e. B C ) $=
      cA cB wceq vy cv cC wcel vx cA wral vy cab vy cv cC wcel vx cB wral vy
      cab vx cA cC ciin vx cB cC ciin cA cB wceq vy cv cC wcel vx cA wral vy cv
      cC wcel vx cB wral vy vy cv cC wcel vx cA cB raleq1 abbidv vx vy cA cC
      df-iin vx vy cB cC df-iin 3eqtr4g $.
      $( [27-Jun-1998] $)
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Subclass theorem for indexed union. $)
    ss2iun $p |- ( A. x e. A B C_ C -> U_ x e. A B C_ U_ x e. A C ) $=
      cB cC wss vx cA wral vy vx cA cB ciun vx cA cC ciun cB cC wss vx cA wral
      vy cv cB wcel vx cA wrex vy cv cC wcel vx cA wrex vy cv vx cA cB ciun
      wcel vy cv vx cA cC ciun wcel cB cC wss vx cA wral vy cv cB wcel vy cv cC
      wcel vx cA cB cC wss vx cA hbra1 cB cC wss vx cA wral vx cv cA wcel cB cC
      wss vy cv cB wcel vy cv cC wcel wi cB cC wss vx cA ra4 cB cC vy cv ssel
      syl6 r19.22d vx vy cv cA cB eliun vx vy cv cA cC eliun 3imtr4g ssrdv $.
      $( [30-Nov-2003] $) $( [26-Nov-2003] $)

    $( Equality theorem for indexed union. $)
    iuneq2 $p |- ( A. x e. A B = C -> U_ x e. A B = U_ x e. A C ) $=
      cB cC wss vx cA wral cC cB wss vx cA wral wa vx cA cB ciun vx cA cC ciun
      wss vx cA cC ciun vx cA cB ciun wss wa cB cC wceq vx cA wral vx cA cB
      ciun vx cA cC ciun wceq cB cC wss vx cA wral vx cA cB ciun vx cA cC ciun
      wss cC cB wss vx cA wral vx cA cC ciun vx cA cB ciun wss vx cA cB cC
      ss2iun vx cA cC cB ss2iun anim12i cB cC wceq vx cA wral cB cC wss cC cB
      wss wa vx cA wral cB cC wss vx cA wral cC cB wss vx cA wral wa cB cC wceq
      cB cC wss cC cB wss wa vx cA cB cC eqss ralbii cB cC wss cC cB wss vx cA
      r19.26 bitri vx cA cB ciun vx cA cC ciun eqss 3imtr4i $.
      $( [3-Nov-2003] $) $( [22-Oct-2003] $)

    $( Equality theorem for indexed intersection. $)
    iineq2 $p |- ( A. x e. A B = C -> |^|_ x e. A B = |^|_ x e. A C ) $=
      cB cC wceq vx cA wral vy cv cB wcel vx cA wral vy cab vy cv cC wcel vx cA
      wral vy cab vx cA cB ciin vx cA cC ciin cB cC wceq vx cA wral vy cv cB
      wcel vx cA wral vy cv cC wcel vx cA wral vy cB cC wceq vx cA wral vy cv
      cB wcel vy cv cC wcel vx cA cB cC wceq vx cA hbra1 cB cC wceq vx cA wral
      vx cv cA wcel vy cv cB wcel vy cv cC wcel wb cB cC wceq vx cA wral vx cv
      cA wcel cB cC wceq vy cv cB wcel vy cv cC wcel wb cB cC wceq vx cA ra4 cB
      cC vy cv eleq2 syl6 imp ralbida abbidv vx vy cA cB df-iin vx vy cA cC
      df-iin 3eqtr4g $.
      $( [4-Nov-2003] $) $( [22-Oct-2003] $)
  $}

  ${
    iuneq2i.1 $e |- ( x e. A -> B = C ) $.
    $( Equality inference for indexed union. $)
    iuneq2i $p |- U_ x e. A B = U_ x e. A C $=
      cB cC wceq vx cA cB ciun vx cA cC ciun wceq vx cA vx cA cB cC iuneq2
      iuneq2i.1 mprg $.
      $( [3-Nov-2003] $) $( [22-Oct-2003] $)

    $( Equality inference for indexed intersection. $)
    iineq2i $p |- |^|_ x e. A B = |^|_ x e. A C $=
      cB cC wceq vx cA cB ciin vx cA cC ciin wceq vx cA vx cA cB cC iineq2
      iuneq2i.1 mprg $.
      $( [4-Nov-2003] $) $( [22-Oct-2003] $)
  $}

  ${
    $d x ph $.
    iuneq2dv.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Equality deduction for indexed union. $)
    iuneq2dv $p |- ( ph -> U_ x e. A B = U_ x e. A C ) $=
      wph cB cC wceq vx cA wral vx cA cB ciun vx cA cC ciun wceq wph cB cC wceq
      vx cA iuneq2dv.1 r19.21aiva vx cA cB cC iuneq2 syl $.
      $( [5-Oct-2006] $) $( [3-Aug-2004] $)

    $( Equality deduction for indexed intersection. $)
    iineq2dv $p |- ( ph -> |^|_ x e. A B = |^|_ x e. A C ) $=
      wph cB cC wceq vx cA wral vx cA cB ciin vx cA cC ciin wceq wph cB cC wceq
      vx cA iuneq2dv.1 r19.21aiva vx cA cB cC iineq2 syl $.
      $( [3-Jan-2007] $) $( [3-Aug-2004] $)
  $}

  ${
    $d z A $.  $d z B $.  $d x y z $.
    $( Bound-variable hypothesis builder for indexed union. $)
    hbiu1 $p |- ( y e. U_ x e. A B -> A. x y e. U_ x e. A B ) $=
      vx vy vx cA cB ciun vz cv cB wcel vx cA wrex vz cab vx vz cA cB df-iun vz
      cv cB wcel vx cA wrex vx vz vy vz cv cB wcel vx cA hbre1 hbab hbxfr $.
      $( [14-Oct-2003] $) $( [12-Oct-2003] $)
  $}

  ${
    $d z A $.  $d z B $.  $d x y z $.
    $( Bound-variable hypothesis builder for indexed intersection. $)
    hbii1 $p |- ( y e. |^|_ x e. A B -> A. x y e. |^|_ x e. A B ) $=
      vx vy vx cA cB ciin vz cv cB wcel vx cA wral vz cab vx vz cA cB df-iin vz
      cv cB wcel vx cA wral vx vz vy vz cv cB wcel vx cA hbra1 hbab hbxfr $.
      $( [16-Oct-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    $d y z w A $.  $d y z w B $.  $d w C $.  $d w x y z $.
    $( Alternate definition of indexed union when ` B ` is a set.  Definition
       15(a) of [Suppes] p. 44. $)
    dfiun2g $p |- ( A. x e. A B e. C ->
                  U_ x e. A B = U. { y | E. x e. A y = B } ) $=
      cB cC wcel vx cA wral vw cv cB wcel vx cA wrex vw cab vw cv vz cv wcel vz
      cv vy cv cB wceq vx cA wrex vy cab wcel wa vz wex vw cab vx cA cB ciun vy
      cv cB wceq vx cA wrex vy cab cuni cB cC wcel vx cA wral vw cv cB wcel vx
      cA wrex vw cv vz cv wcel vz cv vy cv cB wceq vx cA wrex vy cab wcel wa vz
      wex vw cB cC wcel vx cA wral vx cv cA wcel vw cv cB wcel wa vx wex vw cv
      vz cv wcel vz cv vy cv cB wceq vx cA wrex vy cab wcel wa vz wex vw cv cB
      wcel vx cA wrex cB cC wcel vx cA wral vx cv cA wcel vw cv cB wcel wa vx
      wex vx cv cA wcel vw cv vz cv wcel vz cv cB wceq wa wa vz wex vx wex vw
      cv vz cv wcel vz cv vy cv cB wceq vx cA wrex vy cab wcel wa vz wex cB cC
      wcel vx cA wral vx cv cA wcel vw cv cB wcel wa vx cv cA wcel vw cv vz cv
      wcel vz cv cB wceq wa wa vz wex vx cB cC wcel vx cA hbra1 cB cC wcel vx
      cA wral vx cv cA wcel vw cv cB wcel wa vx cv cA wcel vw cv vz cv wcel vz
      cv cB wceq wa vz wex wa vx cv cA wcel vw cv vz cv wcel vz cv cB wceq wa
      wa vz wex cB cC wcel vx cA wral vx cv cA wcel vw cv cB wcel vw cv vz cv
      wcel vz cv cB wceq wa vz wex cB cC wcel vx cA wral vx cv cA wcel cB cC
      wcel vw cv cB wcel vw cv vz cv wcel vz cv cB wceq wa vz wex wb cB cC wcel
      vx cA ra4 cB cC wcel vw cv cB wcel vz cv cB wceq vw cv vz cv wcel wa vz
      wex vw cv vz cv wcel vz cv cB wceq wa vz wex vz vw cv cB cC clel3g vz cv
      cB wceq vw cv vz cv wcel vz exancom syl6bb syl6 pm5.32d vx cv cA wcel vw
      cv vz cv wcel vz cv cB wceq wa vz 19.42v syl6bbr exbid vx cv cA wcel vw
      cv vz cv wcel vz cv cB wceq wa wa vz wex vx wex vx cv cA wcel vw cv vz cv
      wcel vz cv cB wceq wa wa vx wex vz wex vw cv vz cv wcel vz cv vy cv cB
      wceq vx cA wrex vy cab wcel wa vz wex vx cv cA wcel vw cv vz cv wcel vz
      cv cB wceq wa wa vx vz excom vx cv cA wcel vw cv vz cv wcel vz cv cB wceq
      wa wa vx wex vw cv vz cv wcel vz cv vy cv cB wceq vx cA wrex vy cab wcel
      wa vz vw cv vz cv wcel vx cv cA wcel vz cv cB wceq wa wa vx wex vw cv vz
      cv wcel vx cv cA wcel vz cv cB wceq wa vx wex wa vx cv cA wcel vw cv vz
      cv wcel vz cv cB wceq wa wa vx wex vw cv vz cv wcel vz cv vy cv cB wceq
      vx cA wrex vy cab wcel wa vw cv vz cv wcel vx cv cA wcel vz cv cB wceq wa
      vx 19.42v vx cv cA wcel vw cv vz cv wcel vz cv cB wceq wa wa vw cv vz cv
      wcel vx cv cA wcel vz cv cB wceq wa wa vx vx cv cA wcel vw cv vz cv wcel
      vz cv cB wceq an12 exbii vz cv vy cv cB wceq vx cA wrex vy cab wcel vx cv
      cA wcel vz cv cB wceq wa vx wex vw cv vz cv wcel vz cv vy cv cB wceq vx
      cA wrex vy cab wcel vz cv cB wceq vx cA wrex vx cv cA wcel vz cv cB wceq
      wa vx wex vy cv cB wceq vx cA wrex vz cv cB wceq vx cA wrex vy vz cv vz
      visset vy cv vz cv wceq vy cv cB wceq vz cv cB wceq vx cA vy cv vz cv cB
      eqeq1 rexbidv elab vz cv cB wceq vx cA df-rex bitri anbi2i 3bitr4i exbii
      bitri syl6bb vw cv cB wcel vx cA df-rex syl5bb abbidv vx vw cA cB df-iun
      vw vz vy cv cB wceq vx cA wrex vy cab df-uni 3eqtr4g $.
      $( [25-Mar-2006] $) $( [23-Mar-2006] $)
  $}

  ${
    $d x y z w A $.  $d y z w B $.
    dfiun2.1 $e |- B e. _V $.
    $( Alternate definition of indexed union when ` B ` is a set.  Definition
       15(a) of [Suppes] p. 44. $)
    dfiun2 $p |- U_ x e. A B = U. { y | E. x e. A y = B } $=
      cB cvv wcel vx cA cB ciun vy cv cB wceq vx cA wrex vy cab cuni wceq vx cA
      vx vy cA cB cvv dfiun2g cB cvv wcel vx cv cA wcel dfiun2.1 a1i mprg $.
      $( [27-Jun-1998] $)
  $}

  ${
    $d y z w A $.  $d y z w B $.  $d w x y z $.
    dfiin2.1 $e |- B e. _V $.
    $( Alternate definition of indexed intersection when ` B ` is a set.
       Definition 15(b) of [Suppes] p. 44. $)
    dfiin2 $p |- |^|_ x e. A B = |^| { y | E. x e. A y = B } $=
      vw cv cB wcel vx cA wral vw cab vz cv vy cv cB wceq vx cA wrex vy cab
      wcel vw cv vz cv wcel wi vz wal vw cab vx cA cB ciin vy cv cB wceq vx cA
      wrex vy cab cint vw cv cB wcel vx cA wral vz cv vy cv cB wceq vx cA wrex
      vy cab wcel vw cv vz cv wcel wi vz wal vw vw cv cB wcel vx cA wral vx cv
      cA wcel vw cv cB wcel wi vx wal vx cv cA wcel vz cv cB wceq vw cv vz cv
      wcel wi wi vx wal vz wal vz cv vy cv cB wceq vx cA wrex vy cab wcel vw cv
      vz cv wcel wi vz wal vw cv cB wcel vx cA df-ral vx cv cA wcel vw cv cB
      wcel wi vx wal vx cv cA wcel vz cv cB wceq vw cv vz cv wcel wi wi vz wal
      vx wal vx cv cA wcel vz cv cB wceq vw cv vz cv wcel wi wi vx wal vz wal
      vx cv cA wcel vw cv cB wcel wi vx cv cA wcel vz cv cB wceq vw cv vz cv
      wcel wi wi vz wal vx vx cv cA wcel vw cv cB wcel wi vx cv cA wcel vz cv
      cB wceq vw cv vz cv wcel wi vz wal wi vx cv cA wcel vz cv cB wceq vw cv
      vz cv wcel wi wi vz wal vw cv cB wcel vz cv cB wceq vw cv vz cv wcel wi
      vz wal vx cv cA wcel vz vw cv cB dfiin2.1 clel4 imbi2i vx cv cA wcel vz
      cv cB wceq vw cv vz cv wcel wi vz 19.21v bitr4i albii vx cv cA wcel vz cv
      cB wceq vw cv vz cv wcel wi wi vx vz alcom bitri vx cv cA wcel vz cv cB
      wceq vw cv vz cv wcel wi wi vx wal vz cv vy cv cB wceq vx cA wrex vy cab
      wcel vw cv vz cv wcel wi vz vz cv vy cv cB wceq vx cA wrex vy cab wcel vw
      cv vz cv wcel wi vx cv cA wcel vz cv cB wceq wa vx wex vw cv vz cv wcel
      wi vx cv cA wcel vz cv cB wceq wa vw cv vz cv wcel wi vx wal vx cv cA
      wcel vz cv cB wceq vw cv vz cv wcel wi wi vx wal vz cv vy cv cB wceq vx
      cA wrex vy cab wcel vx cv cA wcel vz cv cB wceq wa vx wex vw cv vz cv
      wcel vz cv vy cv cB wceq vx cA wrex vy cab wcel vz cv cB wceq vx cA wrex
      vx cv cA wcel vz cv cB wceq wa vx wex vy cv cB wceq vx cA wrex vz cv cB
      wceq vx cA wrex vy vz cv vz visset vy cv vz cv wceq vy cv cB wceq vz cv
      cB wceq vx cA vy cv vz cv cB eqeq1 rexbidv elab vz cv cB wceq vx cA
      df-rex bitri imbi1i vx cv cA wcel vz cv cB wceq wa vw cv vz cv wcel vx
      19.23v vx cv cA wcel vz cv cB wceq wa vw cv vz cv wcel wi vx cv cA wcel
      vz cv cB wceq vw cv vz cv wcel wi wi vx vx cv cA wcel vz cv cB wceq vw cv
      vz cv wcel impexp albii 3bitr2ri albii 3bitri abbii vx vw cA cB df-iin vw
      vz vy cv cB wceq vx cA wrex vy cab df-int 3eqtr4i $.
      $( [28-Jun-1998] $)
  $}

  ${
    $d x y z A $.  $d z B $.  $d z C $.
    cbviun.1 $e |- ( z e. B -> A. y z e. B ) $.
    cbviun.2 $e |- ( z e. C -> A. x z e. C ) $.
    cbviun.3 $e |- ( x = y -> B = C ) $.
    $( Rule used to change the bound variables in an indexed union, with the
       substitution specified implicitly by the hypothesis. $)
    cbviun $p |- U_ x e. A B = U_ y e. A C $=
      vz cv cB wcel vx cA wrex vz cab vz cv cC wcel vy cA wrex vz cab vx cA cB
      ciun vy cA cC ciun vz cv cB wcel vx cA wrex vz cv cC wcel vy cA wrex vz
      vz cv cB wcel vz cv cC wcel vx vy cA cbviun.1 cbviun.2 vx cv vy cv wceq
      cB cC vz cv cbviun.3 eleq2d cbvrex abbii vx vz cA cB df-iun vy vz cA cC
      df-iun 3eqtr4i $.
      $( [27-Mar-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x z C $.
    cbviunv.1 $e |- ( x = y -> B = C ) $.
    $( Rule used to change the bound variables in an indexed union, with the
       substitution specified implicitly by the hypothesis. $)
    cbviunv $p |- U_ x e. A B = U_ y e. A C $=
      vx vy vz cA cB cC vz cv cB wcel vy ax-17 vz cv cC wcel vx ax-17 cbviunv.1
      cbviun $.
      $( [15-Sep-2003] $)
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset theorem for an indexed union. $)
    iunss $p |- ( U_ x e. A B C_ C <-> A. x e. A B C_ C ) $=
      cB cC wss vx cA wral vx cv cA wcel vy cv cB wcel wa vy cv cC wcel wi vy
      wal vx wal vx cA cB ciun cC wss cB cC wss vx cA wral vy cv cB wcel vy cv
      cC wcel wi vy wal vx cA wral vx cv cA wcel vy cv cB wcel vy cv cC wcel wi
      vy wal wi vx wal vx cv cA wcel vy cv cB wcel wa vy cv cC wcel wi vy wal
      vx wal cB cC wss vy cv cB wcel vy cv cC wcel wi vy wal vx cA vy cB cC
      dfss2 ralbii vy cv cB wcel vy cv cC wcel wi vy wal vx cA df-ral vx cv cA
      wcel vy cv cB wcel vy cv cC wcel wi vy wal wi vx cv cA wcel vy cv cB wcel
      wa vy cv cC wcel wi vy wal vx vx cv cA wcel vy cv cB wcel wa vy cv cC
      wcel wi vy wal vx cv cA wcel vy cv cB wcel vy cv cC wcel wi wi vy wal vx
      cv cA wcel vy cv cB wcel vy cv cC wcel wi vy wal wi vx cv cA wcel vy cv
      cB wcel wa vy cv cC wcel wi vx cv cA wcel vy cv cB wcel vy cv cC wcel wi
      wi vy vx cv cA wcel vy cv cB wcel vy cv cC wcel impexp albii vx cv cA
      wcel vy cv cB wcel vy cv cC wcel wi vy 19.21v bitr2i albii 3bitri vx cv
      cA wcel vy cv cB wcel wa vy cv cC wcel wi vx wal vy wal vy cv vx cA cB
      ciun wcel vy cv cC wcel wi vy wal vx cv cA wcel vy cv cB wcel wa vy cv cC
      wcel wi vy wal vx wal vx cA cB ciun cC wss vx cv cA wcel vy cv cB wcel wa
      vy cv cC wcel wi vx wal vy cv vx cA cB ciun wcel vy cv cC wcel wi vy vx
      cv cA wcel vy cv cB wcel wa vy cv cC wcel wi vx wal vx cv cA wcel vy cv
      cB wcel wa vx wex vy cv cC wcel wi vy cv vx cA cB ciun wcel vy cv cC wcel
      wi vx cv cA wcel vy cv cB wcel wa vy cv cC wcel vx 19.23v vy cv vx cA cB
      ciun wcel vx cv cA wcel vy cv cB wcel wa vx wex vy cv cC wcel vy cv vx cA
      cB ciun wcel vy cv cB wcel vx cA wrex vx cv cA wcel vy cv cB wcel wa vx
      wex vx vy cv cA cB eliun vy cv cB wcel vx cA df-rex bitri imbi1i bitr4i
      albii vx cv cA wcel vy cv cB wcel wa vy cv cC wcel wi vx vy alcom vy vx
      cA cB ciun cC dfss2 3bitr4i bitr2i $.
      $( [13-Sep-2003] $)
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset implication for an indexed union. $)
    ssiun $p |- ( E. x e. A C C_ B ->  C C_ U_ x e. A B ) $=
      cC cB wss vx cA wrex vx cv cA wcel cC cB wss wa vx wex cC vx cA cB ciun
      wss cC cB wss vx cA df-rex vx cv cA wcel cC cB wss wa vx wex vy cv cC
      wcel vx cv cA wcel vy cv cB wcel wa wi vx wex vy wal cC vx cA cB ciun wss
      vx cv cA wcel cC cB wss wa vx wex vy cv cC wcel vx cv cA wcel vy cv cB
      wcel wa wi vx wex vy vx cv cA wcel cC cB wss wa vy cv cC wcel vx cv cA
      wcel vy cv cB wcel wa wi vx vx cv cA wcel vy cv cC wcel vy cv cB wcel wi
      vy cv cC wcel vx cv cA wcel vy cv cB wcel wa wi cC cB wss vx cv cA wcel
      vy cv cC wcel vy cv cB wcel wi vy cv cC wcel vx cv cA wcel vy cv cB wcel
      wa wi vx cv cA wcel vy cv cC wcel vy cv cC wcel vy cv cB wcel wi vx cv cA
      wcel vy cv cB wcel wa vx cv cA wcel vy cv cC wcel vy cv cC wcel vy cv cB
      wcel wi vx cv cA wcel vy cv cB wcel wa vy cv cC wcel vy cv cC wcel vy cv
      cB wcel wi wa vy cv cB wcel vx cv cA wcel vy cv cC wcel vy cv cB wcel
      pm3.35 anim2i exp32 com23 imp cC cB vy cv ssel sylan2 19.22i 19.21aiv vy
      cv cC wcel vx cv cA wcel vy cv cB wcel wa vx wex wi vy wal vy cv cC wcel
      vy cv vx cA cB ciun wcel wi vy wal vy cv cC wcel vx cv cA wcel vy cv cB
      wcel wa wi vx wex vy wal cC vx cA cB ciun wss vy cv cC wcel vx cv cA wcel
      vy cv cB wcel wa vx wex wi vy cv cC wcel vy cv vx cA cB ciun wcel wi vy
      vx cv cA wcel vy cv cB wcel wa vx wex vy cv vx cA cB ciun wcel vy cv cC
      wcel vy cv vx cA cB ciun wcel vy cv cB wcel vx cA wrex vx cv cA wcel vy
      cv cB wcel wa vx wex vx vy cv cA cB eliun vy cv cB wcel vx cA df-rex
      bitr2i imbi2i albii vy cv cC wcel vx cv cA wcel vy cv cB wcel wa wi vx
      wex vy cv cC wcel vx cv cA wcel vy cv cB wcel wa vx wex wi vy vy cv cC
      wcel vx cv cA wcel vy cv cB wcel wa vx 19.37v albii vy cC vx cA cB ciun
      dfss2 3bitr4i sylib sylbi $.
      $( [3-Sep-2003] $)
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( Identity law for subset of an indexed union. $)
    ssiun2 $p |- ( x e. A ->  B C_ U_ x e. A B ) $=
      vx cv cA wcel vy cB vx cA cB ciun vx cv cA wcel vy cv cB wcel vy cv vx cA
      cB ciun wcel vx cv cA wcel vy cv cB wcel wa vy cv cB wcel vx cA wrex vy
      cv vx cA cB ciun wcel vy cv cB wcel vx cA ra4e vx vy cv cA cB eliun
      sylibr ex ssrdv $.
      $( [14-Oct-2003] $) $( [12-Oct-2003] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.
    ssiun2s.1 $e |- ( x = C -> B = D ) $.
    $( Subset relationship for an indexed union. $)
    ssiun2s $p |- ( C e. A ->  D C_ U_ x e. A B ) $=
      cC cA wcel cD vx cA cB ciun wss vx cv cA wcel cB vx cA cB ciun wss wi cC
      cA wcel cD vx cA cB ciun wss wi vx vy cC cA vy cv cC wcel vx ax-17 cC cA
      wcel cD vx cA cB ciun wss vx cC cA wcel vx ax-17 vx vy cD vx cA cB ciun
      vy cv cD wcel vx ax-17 vx vy cA cB hbiu1 hbss hbim vx cv cC wceq vx cv cA
      wcel cC cA wcel cB vx cA cB ciun wss cD vx cA cB ciun wss vx cv cC cA
      eleq1 vx cv cC wceq cB cD vx cA cB ciun ssiun2s.1 sseq1d imbi12d vx cA cB
      ssiun2 vtoclgf pm2.43i $.
      $( [2-Nov-2003] $) $( [26-Oct-2003] $)
  $}

  ${
    $d x y $.  $d x B $.  $d y C $.  $d x D $.
    $( A subclass condition on the members of two indexed classes ` C ( x ) `
       and ` D ( y ) ` that implies a subclass relation on their indexed
       unions.  Generalization of Proposition 8.6 of [TakeutiZaring] p. 59.
       Compare ~ uniss2 . $)
    iunss2 $p |- ( A. x e. A E. y e. B C C_ D ->
                 U_ x e. A C C_ U_ y e. B D ) $=
      cC cD wss vy cB wrex vx cA wral cC vy cB cD ciun wss vx cA wral vx cA cC
      ciun vy cB cD ciun wss cC cD wss vy cB wrex cC vy cB cD ciun wss vx cA vy
      cB cD cC ssiun r19.20si vx cA cC vy cB cD ciun iunss sylibr $.
      $( [30-Dec-2004] $) $( [9-Dec-2004] $)
  $}

  ${
    $d y z A $.  $d x y z B $.  $d z ph $.
    $( The indexed union of a restricted class abstraction. $)
    iunrab $p |- U_ x e. A { y e. B | ph } = { y e. B | E. x e. A ph } $=
      wph vy vz cv wsbc vx cA wrex vz cB crab vz cv cB wcel wph vy vz cv wsbc
      vx cA wrex wa vz cab wph vx cA wrex vy cB crab vx cA wph vy cB crab ciun
      wph vy vz cv wsbc vx cA wrex vz cB df-rab wph vx cA wrex wph vy vz cv
      wsbc vx cA wrex vy vz vx cB vx cv cB wcel vy ax-17 vx cv cB wcel vz ax-17
      wph vx cA wrex vz ax-17 wph vy vz cv wsbc vy vx cA vx cv cA wcel vy ax-17
      wph vy vz hbs1 hbrex vy cv vz cv wceq wph wph vy vz cv wsbc vx cA wph vy
      vz sbequ12 rexbidv cbvrab vz cv cB wcel wph vy vz cv wsbc vx cA wrex wa
      vz vx cA wph vy cB crab ciun vz cv vx cA wph vy cB crab ciun wcel vz cv
      wph vy cB crab wcel vx cA wrex vz cv cB wcel wph vy vz cv wsbc wa vx cA
      wrex vz cv cB wcel wph vy vz cv wsbc vx cA wrex wa vx vz cv cA wph vy cB
      crab eliun vz cv wph vy cB crab wcel vz cv cB wcel wph vy vz cv wsbc wa
      vx cA wph vy vx vz cv cB vx cv cB wcel vy ax-17 elrabsf rexbii vz cv cB
      wcel wph vy vz cv wsbc vx cA r19.42v 3bitri abbi2i 3eqtr4ri $.
      $( [24-Jan-2004] $) $( [3-Jan-2004] $)
  $}

  ${
    $d y A $.  $d x y $.
    $( The indexed union of a class abstraction. $)
    iunab $p |- U_ x e. A { y | ph } = { y | E. x e. A ph } $=
      vx cA wph vy cvv crab ciun wph vx cA wrex vy cvv crab vx cA wph vy cab
      ciun wph vx cA wrex vy cab wph vx vy cA cvv iunrab vx cA wph vy cvv crab
      wph vy cab wph vy cvv crab wph vy cab wceq vx cv cA wcel wph vy rabab a1i
      iuneq2i wph vx cA wrex vy rabab 3eqtr3i $.
      $( [2-Jan-2005] $) $( [27-Dec-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    iunxdif2.1 $e |- ( x = y -> C = D ) $.
    $( Indexed union with a class difference as its index. $)
    iunxdif2 $p |- ( A. x e. A E. y e. ( A \ B ) C C_ D ->
                 U_ y e. ( A \ B ) D = U_ x e. A C ) $=
      cC cD wss vy cA cB cdif wrex vx cA wral vy cA cB cdif cD ciun vx cA cC
      ciun wss vx cA cC ciun vy cA cB cdif cD ciun wss wa vy cA cB cdif cD ciun
      vx cA cC ciun wceq cC cD wss vy cA cB cdif wrex vx cA wral vx cA cC ciun
      vy cA cB cdif cD ciun wss vy cA cB cdif cD ciun vx cA cC ciun wss vx vy
      cA cA cB cdif cC cD iunss2 vy cA cB cdif cD ciun vy cA cD ciun vx cA cC
      ciun cA cB cdif cA wss vy cA cB cdif cD ciun vy cA cD ciun wss cA cB
      difss vy cA cB cdif cA cD iunss1 ax-mp vx vy cA cC cD iunxdif2.1 cbviunv
      sseqtr4i jctil vy cA cB cdif cD ciun vx cA cC ciun eqss sylibr $.
      $( [24-Feb-2005] $) $( [10-Dec-2004] $)
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset theorem for an indexed intersection. $)
    ssiin $p |- ( C C_ |^|_ x e. A B <-> A. x e. A C C_ B ) $=
      vy cv cC wcel vy cv vx cA cB ciin wcel wi vy wal vx cv cA wcel vy cv cC
      wcel vy cv cB wcel wi wi vx wal vy wal cC vx cA cB ciin wss cC cB wss vx
      cA wral vy cv cC wcel vy cv vx cA cB ciin wcel wi vx cv cA wcel vy cv cC
      wcel vy cv cB wcel wi wi vx wal vy vy cv cC wcel vy cv vx cA cB ciin wcel
      wi vy cv cC wcel vy cv cB wcel vx cA wral wi vy cv cC wcel vy cv cB wcel
      wi vx cA wral vx cv cA wcel vy cv cC wcel vy cv cB wcel wi wi vx wal vy
      cv vx cA cB ciin wcel vy cv cB wcel vx cA wral vy cv cC wcel vy cv cvv
      wcel vy cv vx cA cB ciin wcel vy cv cB wcel vx cA wral wb vy visset vx vy
      cv cA cB cvv eliin ax-mp imbi2i vy cv cC wcel vy cv cB wcel vx cA r19.21v
      vy cv cC wcel vy cv cB wcel wi vx cA df-ral 3bitr2i albii vy cC vx cA cB
      ciin dfss2 cC cB wss vx cA wral vy cv cC wcel vy cv cB wcel wi vy wal vx
      cA wral vx cv cA wcel vy cv cC wcel vy cv cB wcel wi vy wal wi vx wal vx
      cv cA wcel vy cv cC wcel vy cv cB wcel wi wi vx wal vy wal cC cB wss vy
      cv cC wcel vy cv cB wcel wi vy wal vx cA vy cC cB dfss2 ralbii vy cv cC
      wcel vy cv cB wcel wi vy wal vx cA df-ral vx cv cA wcel vy cv cC wcel vy
      cv cB wcel wi vy wal wi vx wal vx cv cA wcel vy cv cC wcel vy cv cB wcel
      wi wi vy wal vx wal vx cv cA wcel vy cv cC wcel vy cv cB wcel wi wi vx
      wal vy wal vx cv cA wcel vy cv cC wcel vy cv cB wcel wi wi vy wal vx cv
      cA wcel vy cv cC wcel vy cv cB wcel wi vy wal wi vx vx cv cA wcel vy cv
      cC wcel vy cv cB wcel wi vy 19.21v albii vx cv cA wcel vy cv cC wcel vy
      cv cB wcel wi wi vx vy alcom bitr3i 3bitri 3bitr4i $.
      $( [20-Oct-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset implication for an indexed intersection. $)
    iinss $p |- ( E. x e. A B C_ C ->  |^|_ x e. A B C_ C ) $=
      vy cv cB wcel vy cv cC wcel wi vy wal vx cA wrex vy cv vx cA cB ciin wcel
      vy cv cC wcel wi vy wal cB cC wss vx cA wrex vx cA cB ciin cC wss vy cv
      cB wcel vy cv cC wcel wi vy wal vx cA wrex vy cv cB wcel vy cv cC wcel wi
      vx cA wrex vy wal vy cv vx cA cB ciin wcel vy cv cC wcel wi vy wal vx cv
      cA wcel vy cv cB wcel vy cv cC wcel wi wa vy wal vx wex vx cv cA wcel vy
      cv cB wcel vy cv cC wcel wi wa vx wex vy wal vy cv cB wcel vy cv cC wcel
      wi vy wal vx cA wrex vy cv cB wcel vy cv cC wcel wi vx cA wrex vy wal vx
      cv cA wcel vy cv cB wcel vy cv cC wcel wi wa vx vy 19.12 vy cv cB wcel vy
      cv cC wcel wi vy wal vx cA wrex vx cv cA wcel vy cv cB wcel vy cv cC wcel
      wi vy wal wa vx wex vx cv cA wcel vy cv cB wcel vy cv cC wcel wi wa vy
      wal vx wex vy cv cB wcel vy cv cC wcel wi vy wal vx cA df-rex vx cv cA
      wcel vy cv cB wcel vy cv cC wcel wi wa vy wal vx cv cA wcel vy cv cB wcel
      vy cv cC wcel wi vy wal wa vx vx cv cA wcel vy cv cB wcel vy cv cC wcel
      wi vy 19.28v exbii bitr4i vy cv cB wcel vy cv cC wcel wi vx cA wrex vx cv
      cA wcel vy cv cB wcel vy cv cC wcel wi wa vx wex vy vy cv cB wcel vy cv
      cC wcel wi vx cA df-rex albii 3imtr4i vy cv cB wcel vy cv cC wcel wi vx
      cA wrex vy cv vx cA cB ciin wcel vy cv cC wcel wi vy vy cv cB wcel vy cv
      cC wcel wi vx cA wrex vy cv cB wcel vx cA wral vy cv cC wcel vy cv vx cA
      cB ciin wcel vy cv cB wcel vy cv cC wcel vx cA r19.36av vy cv cvv wcel vy
      cv vx cA cB ciin wcel vy cv cB wcel vx cA wral wb vy visset vx vy cv cA
      cB cvv eliin ax-mp syl5ib 19.20i syl cB cC wss vy cv cB wcel vy cv cC
      wcel wi vy wal vx cA vy cB cC dfss2 rexbii vy vx cA cB ciin cC dfss2
      3imtr4i $.
      $( [22-Oct-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    $d x y A $.
    $( Class union in terms of indexed union.  Definition of [Stoll] p. 43. $)
    uniiun $p |- U. A = U_ x e. A x $=
      cA cuni vy cv vx cv wcel vx cA wrex vy cab vx cA vx cv ciun vy vx cA
      dfuni2 vx vy cA vx cv df-iun eqtr4i $.
      $( [28-Jun-1998] $)

    $( Class intersection in terms of indexed intersection.  Definition of
       [Stoll] p. 44. $)
    intiin $p |- |^| A = |^|_ x e. A x $=
      cA cint vy cv vx cv wcel vx cA wral vy cab vx cA vx cv ciin vy vx cA
      dfint2 vx vy cA vx cv df-iin eqtr4i $.
      $( [28-Jun-1998] $)

    $( An indexed union of singletons recovers the index set. $)
    iunid $p |- U_ x e. A { x } = A $=
      vx cA vx cv csn ciun vx cA vx cv vy cv wceq vy cab ciun vx cv vy cv wceq
      vx cA wrex vy cab cA vx cA vx cv csn vx cv vy cv wceq vy cab vx cv csn vx
      cv vy cv wceq vy cab wceq vx cv cA wcel vx cv csn vy cv vx cv wceq vy cab
      vx cv vy cv wceq vy cab vy vx cv df-sn vy cv vx cv wceq vx cv vy cv wceq
      vy vy vx equcom abbii eqtri a1i iuneq2i vx cv vy cv wceq vx vy cA iunab
      vy cv cA wcel vy cab vx cv vy cv wceq vx cA wrex vy cab cA vy cv cA wcel
      vx cv vy cv wceq vx cA wrex vy vx vy cv cA risset abbii vy cA abid2
      eqtr3i 3eqtri $.
      $( [18-Dec-2008] $) $( [6-Sep-2005] $)
  $}

  ${
    $d x y $.  $d y A $.
    $( An indexed union of the empty set is empty. $)
    iun0 $p |- U_ x e. A (/) = (/) $=
      vy vx cA c0 ciun c0 vy cv vx cA c0 ciun wcel vy cv c0 wcel vx cA wrex vy
      cv c0 wcel vx vy cv cA c0 eliun vy cv c0 wcel vx cA wrex vy cv c0 wcel vy
      cv c0 wcel vx cA vy cv c0 wcel wn vx cv cA wcel vy cv noel a1i nrex vy cv
      noel 2false bitri eqriv $.
      $( [27-Mar-2003] $) $( [26-Mar-2003] $)

    $( An empty indexed union is empty. $)
    0iun $p |- U_ x e. (/) A = (/) $=
      vy vx c0 cA ciun c0 vy cv vx c0 cA ciun wcel vy cv cA wcel vx c0 wrex vy
      cv c0 wcel vx vy cv c0 cA eliun vy cv cA wcel vx c0 wrex vy cv c0 wcel vy
      cv cA wcel vx rex0 vy cv noel 2false bitri eqriv $.
      $( [21-Feb-2005] $) $( [4-Dec-2004] $)

    $( An empty indexed intersection is the universal class. $)
    0iin $p |- |^|_ x e. (/) A = _V $=
      vx c0 cA ciin vy cv cA wcel vx c0 wral vy cab cvv vx vy c0 cA df-iin vy
      cv cA wcel vx c0 wral vy cvv vy cv cvv wcel vy cv cA wcel vx c0 wral vy
      visset vy cv cA wcel vx ral0 2th abbi2i eqtr4i $.
      $( [22-Nov-2005] $) $( [20-Oct-2005] $)

    $( Indexed intersection with a universal index class.  When ` A ` doesn't
       depend on ` x ` , this evaluates to ` A ` by ~ 19.3 and ~ abid2 .
       When ` A = x ` , this evaluates to ` (/) ` by ~ intiin and ~ intv . $)
    viin $p |- |^|_ x e. _V A = { y | A. x y e. A } $=
      vx cvv cA ciin vy cv cA wcel vx cvv wral vy cab vy cv cA wcel vx wal vy
      cab vx vy cvv cA df-iin vy cv cA wcel vx cvv wral vy cv cA wcel vx wal vy
      vy cv cA wcel vx ralv abbii eqtri $.
      $( [11-Sep-2008] $) $( [11-Sep-2008] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( There is a non-empty class in an indexed collection ` B ( x ) ` iff the
       indexed union of them is non-empty. $)
    iunn0 $p |- ( E. x e. A B =/= (/) <-> U_ x e. A B =/= (/) ) $=
      cB c0 wne vx cA wrex vy cv cB wcel vy wex vx cA wrex vx cv cA wcel vy cv
      cB wcel vy wex wa vx wex vx cA cB ciun c0 wne cB c0 wne vy cv cB wcel vy
      wex vx cA vy cB n0 rexbii vy cv cB wcel vy wex vx cA df-rex vx cv cA wcel
      vy cv cB wcel vy wex wa vx wex vy cv vx cA cB ciun wcel vy wex vx cA cB
      ciun c0 wne vx cv cA wcel vy cv cB wcel wa vy wex vx wex vx cv cA wcel vy
      cv cB wcel wa vx wex vy wex vx cv cA wcel vy cv cB wcel vy wex wa vx wex
      vy cv vx cA cB ciun wcel vy wex vx cv cA wcel vy cv cB wcel wa vx vy
      excom vx cv cA wcel vy cv cB wcel vx vy exdistr vx cv cA wcel vy cv cB
      wcel wa vx wex vy cv vx cA cB ciun wcel vy vy cv vx cA cB ciun wcel vy cv
      cB wcel vx cA wrex vx cv cA wcel vy cv cB wcel wa vx wex vx vy cv cA cB
      eliun vy cv cB wcel vx cA df-rex bitr2i exbii 3bitr3i vy vx cA cB ciun n0
      bitr4i 3bitri $.
      $( [17-May-2007] $) $( [15-Oct-2003] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d y C $.
    $( Indexed union of intersection.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ uniiun to recover
       Enderton's theorem. $)
    iunin2 $p |- U_ x e. A ( B i^i C ) = ( B i^i U_ x e. A C ) $=
      vy vx cA cB cC cin ciun cB vx cA cC ciun cin vy cv cB cC cin wcel vx cA
      wrex vy cv cB wcel vy cv vx cA cC ciun wcel wa vy cv vx cA cB cC cin ciun
      wcel vy cv cB vx cA cC ciun cin wcel vy cv cB wcel vy cv cC wcel wa vx cA
      wrex vy cv cB wcel vy cv cC wcel vx cA wrex wa vy cv cB cC cin wcel vx cA
      wrex vy cv cB wcel vy cv vx cA cC ciun wcel wa vy cv cB wcel vy cv cC
      wcel vx cA r19.42v vy cv cB cC cin wcel vy cv cB wcel vy cv cC wcel wa vx
      cA vy cv cB cC elin rexbii vy cv vx cA cC ciun wcel vy cv cC wcel vx cA
      wrex vy cv cB wcel vx vy cv cA cC eliun anbi2i 3bitr4i vx vy cv cA cB cC
      cin eliun vy cv cB vx cA cC ciun elin 3bitr4i eqriv $.
      $( [30-Mar-2004] $) $( [26-Mar-2004] $)

    $( Indexed intersection of union.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ intiin to recover
       Enderton's theorem. $)
    iinun2 $p |- |^|_ x e. A ( B u. C ) = ( B u. |^|_ x e. A C ) $=
      vy vx cA cB cC cun ciin cB vx cA cC ciin cun vy cv cB cC cun wcel vx cA
      wral vy cv cB wcel vy cv vx cA cC ciin wcel wo vy cv vx cA cB cC cun ciin
      wcel vy cv cB vx cA cC ciin cun wcel vy cv cB wcel vy cv cC wcel wo vx cA
      wral vy cv cB wcel vy cv cC wcel vx cA wral wo vy cv cB cC cun wcel vx cA
      wral vy cv cB wcel vy cv vx cA cC ciin wcel wo vy cv cB wcel vy cv cC
      wcel vx cA r19.32v vy cv cB cC cun wcel vy cv cB wcel vy cv cC wcel wo vx
      cA vy cv cB cC elun ralbii vy cv vx cA cC ciin wcel vy cv cC wcel vx cA
      wral vy cv cB wcel vy cv cvv wcel vy cv vx cA cC ciin wcel vy cv cC wcel
      vx cA wral wb vy visset vx vy cv cA cC cvv eliin ax-mp orbi2i 3bitr4i vy
      cv cvv wcel vy cv vx cA cB cC cun ciin wcel vy cv cB cC cun wcel vx cA
      wral wb vy visset vx vy cv cA cB cC cun cvv eliin ax-mp vy cv cB vx cA cC
      ciin elun 3bitr4i eqriv $.
      $( [3-Sep-2004] $) $( [19-Aug-2004] $)

    $( Indexed union of class difference.  Generalization of half of theorem
       "De Morgan's laws" in [Enderton] p. 31.  Use ~ intiin to recover
       Enderton's theorem. $)
    iundif2 $p |- U_ x e. A ( B \ C ) = ( B \ |^|_ x e. A C ) $=
      vy vx cA cB cC cdif ciun cB vx cA cC ciin cdif vy cv cB cC cdif wcel vx
      cA wrex vy cv cB wcel vy cv vx cA cC ciin wcel wn wa vy cv vx cA cB cC
      cdif ciun wcel vy cv cB vx cA cC ciin cdif wcel vy cv cB wcel vy cv cC
      wcel wn wa vx cA wrex vy cv cB wcel vy cv cC wcel wn vx cA wrex wa vy cv
      cB cC cdif wcel vx cA wrex vy cv cB wcel vy cv vx cA cC ciin wcel wn wa
      vy cv cB wcel vy cv cC wcel wn vx cA r19.42v vy cv cB cC cdif wcel vy cv
      cB wcel vy cv cC wcel wn wa vx cA vy cv cB cC eldif rexbii vy cv vx cA cC
      ciin wcel wn vy cv cC wcel wn vx cA wrex vy cv cB wcel vy cv vx cA cC
      ciin wcel wn vy cv cC wcel vx cA wral wn vy cv cC wcel wn vx cA wrex vy
      cv vx cA cC ciin wcel vy cv cC wcel vx cA wral vy cv cvv wcel vy cv vx cA
      cC ciin wcel vy cv cC wcel vx cA wral wb vy visset vx vy cv cA cC cvv
      eliin ax-mp notbii vy cv cC wcel vx cA rexnal bitr4i anbi2i 3bitr4i vx vy
      cv cA cB cC cdif eliun vy cv cB vx cA cC ciin eldif 3bitr4i eqriv $.
      $( [30-Oct-2004] $) $( [19-Aug-2004] $)
  $}

  ${
    $d x B $.  $d y C $.  $d x D $.  $d x y $.
    $( Rearrange indexed unions over intersection. $)
    2iunin $p |- U_ x e. A U_ y e. B ( C i^i D )
        = ( U_ x e. A C i^i U_ y e. B D ) $=
      vx cA vy cB cC cD cin ciun ciun vx cA cC vy cB cD ciun cin ciun vy cB cD
      ciun vx cA cC ciun cin vx cA cC ciun vy cB cD ciun cin vx cA vy cB cC cD
      cin ciun cC vy cB cD ciun cin vy cB cC cD cin ciun cC vy cB cD ciun cin
      wceq vx cv cA wcel vy cB cC cD iunin2 a1i iuneq2i vx cA cC vy cB cD ciun
      cin ciun vx cA vy cB cD ciun cC cin ciun vy cB cD ciun vx cA cC ciun cin
      vx cA cC vy cB cD ciun cin vy cB cD ciun cC cin cC vy cB cD ciun cin vy
      cB cD ciun cC cin wceq vx cv cA wcel cC vy cB cD ciun incom a1i iuneq2i
      vx cA vy cB cD ciun cC iunin2 eqtri vy cB cD ciun vx cA cC ciun incom
      3eqtri $.
      $( [19-Jan-2009] $) $( [18-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Indexed intersection of class difference.  Generalization of half of
       theorem "De Morgan's laws" in [Enderton] p. 31.  Use ~ uniiun to recover
       Enderton's theorem. $)
    iindif2 $p |- ( A =/= (/) ->
                 |^|_ x e. A ( B \ C ) = ( B \ U_ x e. A C ) ) $=
      cA c0 wne vy vx cA cB cC cdif ciin cB vx cA cC ciun cdif cA c0 wne vy cv
      cB cC cdif wcel vx cA wral vy cv cB wcel vy cv vx cA cC ciun wcel wn wa
      vy cv vx cA cB cC cdif ciin wcel vy cv cB vx cA cC ciun cdif wcel cA c0
      wne vy cv cB wcel vy cv cC wcel wn wa vx cA wral vy cv cB wcel vy cv cC
      wcel wn vx cA wral wa vy cv cB cC cdif wcel vx cA wral vy cv cB wcel vy
      cv vx cA cC ciun wcel wn wa vy cv cB wcel vy cv cC wcel wn vx cA r19.28zv
      vy cv cB cC cdif wcel vy cv cB wcel vy cv cC wcel wn wa vx cA vy cv cB cC
      eldif ralbii vy cv vx cA cC ciun wcel wn vy cv cC wcel wn vx cA wral vy
      cv cB wcel vy cv vx cA cC ciun wcel wn vy cv cC wcel vx cA wrex wn vy cv
      cC wcel wn vx cA wral vy cv vx cA cC ciun wcel vy cv cC wcel vx cA wrex
      vx vy cv cA cC eliun notbii vy cv cC wcel vx cA ralnex bitr4i anbi2i
      3bitr4g vy cv cvv wcel vy cv vx cA cB cC cdif ciin wcel vy cv cB cC cdif
      wcel vx cA wral wb vy visset vx vy cv cA cB cC cdif cvv eliin ax-mp vy cv
      cB vx cA cC ciun eldif 3bitr4g eqrdv $.
      $( [13-Oct-2006] $) $( [5-Oct-2006] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.
    iunxsn.1 $e |- A e. _V $.
    iunxsn.2 $e |- ( x = A -> B = C ) $.
    $( A singleton index picks out an instance of an indexed union's
       argument. $)
    iunxsn $p |- U_ x e. { A } B = C $=
      vy vx cA csn cB ciun cC vy cv vx cA csn cB ciun wcel vy cv cB wcel vx cA
      csn wrex vx cv cA csn wcel vy cv cB wcel wa vx wex vy cv cC wcel vx vy cv
      cA csn cB eliun vy cv cB wcel vx cA csn df-rex vx cv cA csn wcel vy cv cB
      wcel wa vx wex vx cv cA wceq vy cv cB wcel wa vx wex vy cv cC wcel vx cv
      cA csn wcel vy cv cB wcel wa vx cv cA wceq vy cv cB wcel wa vx vx cv cA
      csn wcel vx cv cA wceq vy cv cB wcel vx cA elsn anbi1i exbii vy cv cB
      wcel vy cv cC wcel vx cA iunxsn.1 vx cv cA wceq cB cC vy cv iunxsn.2
      eleq2d ceqsexv bitri 3bitri eqriv $.
      $( [27-Mar-2004] $) $( [26-Mar-2004] $)
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Separate a union in an indexed union. $)
    iunun $p |- U_ x e. A ( B u. C ) = ( U_ x e. A B u. U_ x e. A C ) $=
      vy cv cB cC cun wcel vx cA wrex vy cab vy cv cB wcel vx cA wrex vy cab vy
      cv cC wcel vx cA wrex vy cab cun vx cA cB cC cun ciun vx cA cB ciun vx cA
      cC ciun cun vy cv cB cC cun wcel vx cA wrex vy cab vy cv cB wcel vx cA
      wrex vy cv cC wcel vx cA wrex wo vy cab vy cv cB wcel vx cA wrex vy cab
      vy cv cC wcel vx cA wrex vy cab cun vy cv cB cC cun wcel vx cA wrex vy cv
      cB wcel vx cA wrex vy cv cC wcel vx cA wrex wo vy vy cv cB cC cun wcel vx
      cA wrex vy cv cB wcel vy cv cC wcel wo vx cA wrex vy cv cB wcel vx cA
      wrex vy cv cC wcel vx cA wrex wo vy cv cB cC cun wcel vy cv cB wcel vy cv
      cC wcel wo vx cA vy cv cB cC elun rexbii vy cv cB wcel vy cv cC wcel vx
      cA r19.43 bitri abbii vy cv cB wcel vx cA wrex vy cv cC wcel vx cA wrex
      vy unab eqtr4i vx vy cA cB cC cun df-iun vx cA cB ciun vy cv cB wcel vx
      cA wrex vy cab vx cA cC ciun vy cv cC wcel vx cA wrex vy cab vx vy cA cB
      df-iun vx vy cA cC df-iun uneq12i 3eqtr4i $.
      $( [16-Jan-2005] $) $( [27-Dec-2004] $)

    $( Separate a union in the index of an indexed union. $)
    iunxun $p |- U_ x e. ( A u. B ) C = ( U_ x e. A C u. U_ x e. B C ) $=
      vy vx cA cB cun cC ciun vx cA cC ciun vx cB cC ciun cun vy cv cC wcel vx
      cA cB cun wrex vy cv vx cA cC ciun wcel vy cv vx cB cC ciun wcel wo vy cv
      vx cA cB cun cC ciun wcel vy cv vx cA cC ciun vx cB cC ciun cun wcel vy
      cv cC wcel vx cA cB cun wrex vx cv cA cB cun wcel vy cv cC wcel wa vx wex
      vx cv cA wcel vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa wo vx wex
      vy cv vx cA cC ciun wcel vy cv vx cB cC ciun wcel wo vy cv cC wcel vx cA
      cB cun df-rex vx cv cA cB cun wcel vy cv cC wcel wa vx cv cA wcel vy cv
      cC wcel wa vx cv cB wcel vy cv cC wcel wa wo vx vx cv cA cB cun wcel vy
      cv cC wcel wa vx cv cA wcel vx cv cB wcel wo vy cv cC wcel wa vx cv cA
      wcel vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa wo vx cv cA cB cun
      wcel vx cv cA wcel vx cv cB wcel wo vy cv cC wcel vx cv cA cB elun anbi1i
      vx cv cA wcel vx cv cB wcel vy cv cC wcel andir bitri exbii vx cv cA wcel
      vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa wo vx wex vx cv cA wcel
      vy cv cC wcel wa vx wex vx cv cB wcel vy cv cC wcel wa vx wex wo vy cv vx
      cA cC ciun wcel vy cv vx cB cC ciun wcel wo vx cv cA wcel vy cv cC wcel
      wa vx cv cB wcel vy cv cC wcel wa vx 19.43 vy cv vx cA cC ciun wcel vx cv
      cA wcel vy cv cC wcel wa vx wex vy cv vx cB cC ciun wcel vx cv cB wcel vy
      cv cC wcel wa vx wex vy cv vx cA cC ciun wcel vy cv cC wcel vx cA wrex vx
      cv cA wcel vy cv cC wcel wa vx wex vx vy cv cA cC eliun vy cv cC wcel vx
      cA df-rex bitri vy cv vx cB cC ciun wcel vy cv cC wcel vx cB wrex vx cv
      cB wcel vy cv cC wcel wa vx wex vx vy cv cB cC eliun vy cv cC wcel vx cB
      df-rex bitri orbi12i bitr4i 3bitri vx vy cv cA cB cun cC eliun vy cv vx
      cA cC ciun vx cB cC ciun elun 3bitr4i eqriv $.
      $( [30-Mar-2004] $) $( [26-Mar-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A relationship involving union and indexed intersection.  Exercise 23 of
       [Enderton] p. 33. $)
    iinuni $p |- ( A u. |^| B ) = |^|_ x e. B ( A u. x ) $=
      vy cA cB cint cun vx cB cA vx cv cun ciin vy cv cA wcel vy cv cB cint
      wcel wo vy cv cA vx cv cun wcel vx cB wral vy cv cA cB cint cun wcel vy
      cv vx cB cA vx cv cun ciin wcel vy cv cA wcel vy cv vx cv wcel wo vx cB
      wral vy cv cA wcel vy cv vx cv wcel vx cB wral wo vy cv cA vx cv cun wcel
      vx cB wral vy cv cA wcel vy cv cB cint wcel wo vy cv cA wcel vy cv vx cv
      wcel vx cB r19.32v vy cv cA vx cv cun wcel vy cv cA wcel vy cv vx cv wcel
      wo vx cB vy cv cA vx cv elun ralbii vy cv cB cint wcel vy cv vx cv wcel
      vx cB wral vy cv cA wcel vx vy cv cB vy visset elint2 orbi2i 3bitr4ri vy
      cv cA cB cint elun vy cv cvv wcel vy cv vx cB cA vx cv cun ciin wcel vy
      cv cA vx cv cun wcel vx cB wral wb vy visset vx vy cv cB cA vx cv cun cvv
      eliin ax-mp 3bitr4i eqriv $.
      $( [27-Nov-2003] $) $( [25-Nov-2003] $)

    $( A relationship involving union and indexed union.  Exercise 25 of
      [Enderton] p. 33. $)
    iununi $p |- ( ( B = (/) -> A = (/) ) <->
                ( A u. U. B ) = U_ x e. B ( A u. x ) ) $=
      cB c0 wceq cA c0 wceq wi cA cB cuni cun vx cB cA vx cv cun ciun wceq cB
      c0 wceq cA c0 wceq wi vy cA cB cuni cun vx cB cA vx cv cun ciun cB c0
      wceq cA c0 wceq wi vy cv cA wcel vy cv vx cv wcel vx cB wrex wo vy cv cA
      vx cv cun wcel vx cB wrex vy cv cA cB cuni cun wcel vy cv vx cB cA vx cv
      cun ciun wcel cB c0 wceq cA c0 wceq wi vy cv cA wcel vy cv vx cv wcel vx
      cB wrex wo vy cv cA wcel vy cv vx cv wcel wo vx cB wrex vy cv cA vx cv
      cun wcel vx cB wrex cB c0 wceq cA c0 wceq wi cB c0 wceq wn cA c0 wceq wo
      vy cv cA wcel vy cv vx cv wcel vx cB wrex wo vy cv cA wcel vy cv vx cv
      wcel wo vx cB wrex wb cB c0 wceq cA c0 wceq imor cB c0 wceq wn cA c0 wceq
      wo vy cv cA wcel vy cv vx cv wcel wo vx cB wrex vy cv cA wcel vy cv vx cv
      wcel vx cB wrex wo cB c0 wceq wn vy cv cA wcel vy cv vx cv wcel wo vx cB
      wrex vy cv cA wcel vy cv vx cv wcel vx cB wrex wo wb cA c0 wceq cB c0
      wceq wn cB c0 wne vy cv cA wcel vy cv vx cv wcel wo vx cB wrex vy cv cA
      wcel vy cv vx cv wcel vx cB wrex wo wb cB c0 df-ne vy cv cA wcel vy cv vx
      cv wcel vx cB r19.45zv sylbir cA c0 wceq vy cv cA wcel wn vy cv cA wcel
      vy cv vx cv wcel wo vx cB wrex vy cv cA wcel vy cv vx cv wcel vx cB wrex
      wo wb vy cv cA wcel cA c0 wceq cA vy cv n0i con2i vy cv cA wcel wn vy cv
      vx cv wcel vx cB wrex vy cv cA wcel vy cv vx cv wcel wo vx cB wrex vy cv
      cA wcel vy cv vx cv wcel vx cB wrex wo vy cv cA wcel wn vy cv vx cv wcel
      vy cv cA wcel vy cv vx cv wcel wo vx cB vy cv cA wcel vy cv vx cv wcel
      biorf rexbidv vy cv cA wcel vy cv vx cv wcel vx cB wrex biorf bitr3d syl
      jaoi bicomd sylbi vy cv cA vx cv cun wcel vy cv cA wcel vy cv vx cv wcel
      wo vx cB vy cv cA vx cv elun rexbii syl6bbr vy cv cA cB cuni cun wcel vy
      cv cA wcel vy cv cB cuni wcel wo vy cv cA wcel vy cv vx cv wcel vx cB
      wrex wo vy cv cA cB cuni elun vy cv cB cuni wcel vy cv vx cv wcel vx cB
      wrex vy cv cA wcel vx vy cv cB eluni2 orbi2i bitri vx vy cv cB cA vx cv
      cun eliun 3bitr4g eqrdv cA cB cuni cun vx cB cA vx cv cun ciun wceq cA c0
      wceq cB c0 wceq cA cB cuni cun vx cB cA vx cv cun ciun wceq vy cv cA wcel
      vy wex vx cv cB wcel vx wex cA c0 wceq wn cB c0 wceq wn cA cB cuni cun vx
      cB cA vx cv cun ciun wceq vy cv cA wcel vx cv cB wcel vx wex vy cA cB
      cuni cun vx cB cA vx cv cun ciun wceq vy cv cA wcel vx cv cB wcel wi vx
      wex vy cv cA wcel vx cv cB wcel vx wex wi cA cB cuni cun vx cB cA vx cv
      cun ciun wceq vy cv cA wcel vy cv vx cv wcel vx cv cB wcel wa wo vx wex
      vx cv cB wcel vy cv cA vx cv cun wcel wa vx wex wi vy cv cA wcel vy cv vx
      cv wcel vx cv cB wcel wa wo vx cv cB wcel vy cv cA vx cv cun wcel wa wi
      vx wex vy cv cA wcel vx cv cB wcel wi vx wex cA cB cuni cun vx cB cA vx
      cv cun ciun wceq vy cv cA wcel vy cv vx cv wcel vx cv cB wcel wa wo vx
      wex vx cv cB wcel vy cv cA vx cv cun wcel wa vx wex cA cB cuni cun vx cB
      cA vx cv cun ciun wceq vy cv cA cB cuni cun wcel vy cv vx cB cA vx cv cun
      ciun wcel vy cv cA wcel vy cv vx cv wcel vx cv cB wcel wa wo vx wex vx cv
      cB wcel vy cv cA vx cv cun wcel wa vx wex cA cB cuni cun vx cB cA vx cv
      cun ciun vy cv eleq2 vy cv cA wcel vy cv cB cuni wcel wo vy cv cA wcel vy
      cv vx cv wcel vx cv cB wcel wa vx wex wo vy cv cA cB cuni cun wcel vy cv
      cA wcel vy cv vx cv wcel vx cv cB wcel wa wo vx wex vy cv cB cuni wcel vy
      cv vx cv wcel vx cv cB wcel wa vx wex vy cv cA wcel vx vy cv cB eluni
      orbi2i vy cv cA cB cuni elun vy cv cA wcel vy cv vx cv wcel vx cv cB wcel
      wa vx vy cv cA wcel vx ax-17 19.45 3bitr4i vy cv vx cB cA vx cv cun ciun
      wcel vy cv cA vx cv cun wcel vx cB wrex vx cv cB wcel vy cv cA vx cv cun
      wcel wa vx wex vx vy cv cB cA vx cv cun eliun vy cv cA vx cv cun wcel vx
      cB df-rex bitri 3bitr3g biimpd vy cv cA wcel vy cv vx cv wcel vx cv cB
      wcel wa wo vx cv cB wcel vy cv cA vx cv cun wcel wa vx 19.39 vy cv cA
      wcel vy cv vx cv wcel vx cv cB wcel wa wo vx cv cB wcel vy cv cA vx cv
      cun wcel wa wi vy cv cA wcel vx cv cB wcel wi vx vy cv cA wcel vy cv cA
      wcel vy cv vx cv wcel vx cv cB wcel wa wo vx cv cB wcel vy cv cA vx cv
      cun wcel wa vx cv cB wcel vy cv cA wcel vy cv vx cv wcel vx cv cB wcel wa
      orc vx cv cB wcel vy cv cA vx cv cun wcel pm3.26 imim12i 19.22i 3syl vy
      cv cA wcel vx cv cB wcel vx 19.37v sylib 19.23adv vy cA neq0 vx cB neq0
      3imtr4g con4d impbii $.
      $( [28-Nov-2003] $) $( [25-Nov-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass relationship for power class and union. $)
    sspwuni $p |- ( A C_ ~P B <-> U. A C_ B ) $=
      vx cv cB cpw wcel vx cA wral vx cv cB wss vx cA wral cA cB cpw wss cA
      cuni cB wss vx cv cB cpw wcel vx cv cB wss vx cA vx cv cB vx visset elpw
      ralbii vx cA cB cpw dfss3 vx cA cB unissb 3bitr4i $.
      $( [5-May-2009] $) $( [18-Jul-2006] $)

    $( Two ways to express a collection of subclasses. $)
    pwssb $p |- ( A C_ ~P B <-> A. x e. A x C_ B ) $=
      cA cB cpw wss cA cuni cB wss vx cv cB wss vx cA wral cA cB sspwuni vx cA
      cB unissb bitri $.
      $( [9-Jan-2007] $) $( [19-Jul-2006] $)
  $}

  $( Relationship for power class and union. $)
  elpwuni $p |- ( B e. A -> ( A C_ ~P B <-> U. A = B ) ) $=
    cB cA wcel cA cuni cB wss cA cuni cB wceq cA cB cpw wss cB cA wcel cA cuni
    cB wss cA cuni cB wceq cA cuni cB wss cB cA wcel cA cuni cB wceq cA cB
    unissel expcom cA cuni cB eqimss impbid1 cA cB sspwuni syl5bb $.
    $( [13-May-2007] $) $( [18-Jul-2006] $)

  ${
    $d x y A $.
    $( The power class of an intersection in terms of indexed intersection.
       Exercise 24(a) of [Enderton] p. 33. $)
    iinpw $p |- ~P |^| A = |^|_ x e. A ~P x $=
      vy cA cint cpw vx cA vx cv cpw ciin vy cv cA cint wss vy cv vx cv cpw
      wcel vx cA wral vy cv cA cint cpw wcel vy cv vx cA vx cv cpw ciin wcel vy
      cv cA cint wss vy cv vx cv wss vx cA wral vy cv vx cv cpw wcel vx cA wral
      vx vy cv cA ssint vy cv vx cv cpw wcel vy cv vx cv wss vx cA vy cv vx cv
      vy visset elpw ralbii bitr4i vy cv cA cint vy visset elpw vy cv cvv wcel
      vy cv vx cA vx cv cpw ciin wcel vy cv vx cv cpw wcel vx cA wral wb vy
      visset vx vy cv cA vx cv cpw cvv eliin ax-mp 3bitr4i eqriv $.
      $( [29-Nov-2003] $) $( [29-Nov-2003] $)

    $( Inclusion of an indexed union of a power class in the power class of
       the union of its index.  Part of Exercise 24(b) of [Enderton] p. 33. $)
    iunpwss $p |- U_ x e. A ~P x C_ ~P U. A $=
      vy vx cA vx cv cpw ciun cA cuni cpw vy cv vx cv wss vx cA wrex vy cv vx
      cA vx cv ciun wss vy cv vx cA vx cv cpw ciun wcel vy cv cA cuni cpw wcel
      vx cA vx cv vy cv ssiun vy cv vx cA vx cv cpw ciun wcel vy cv vx cv cpw
      wcel vx cA wrex vy cv vx cv wss vx cA wrex vx vy cv cA vx cv cpw eliun vy
      cv vx cv cpw wcel vy cv vx cv wss vx cA vy cv vx cv vy visset elpw rexbii
      bitri vy cv cA cuni cpw wcel vy cv cA cuni wss vy cv vx cA vx cv ciun wss
      vy cv cA cuni vy visset elpw cA cuni vx cA vx cv ciun vy cv vx cA uniiun
      sseq2i bitri 3imtr4i ssriv $.
      $( [25-Nov-2003] $) $( [25-Nov-2003] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Binary relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend wff notation to include the general binary relation predicate.
     Note that the syntax is simply three class symbols in a row.  Since
     binary relations are the only possible wff expressions consisting of three
     class expressions in a row, the syntax is unambiguous.  (For an example of
     how syntax could become ambiguous if we are not careful, see the comment
     in ~ cneg .) $)
  wbr $a wff A R B $.

  $( Define a general binary relation.  Note that the syntax is simply three
     class symbols in a row.  Definition 6.18 of [TakeutiZaring]
     p. 29 generalized to arbitrary classes.  Class ` R ` normally denotes a
     relation such as " ` < ` " that compares two classes ` A ` and ` B ` ,
     which might be numbers such as ` 1 ` and ` 2 ` .  This definition is
     well-defined, although not very meaningful, when classes ` A ` and/or
     ` B ` are proper classes (i.e. are not sets).  On the other hand, we
     often find uses for this definition when ` R ` is a proper class. $)
  df-br $a |- ( A R B <-> <. A , B >. e. R ) $.

  $( Equality theorem for binary relations. $)
  breq $p |- ( R = S -> ( A R B <-> A S B ) ) $=
    cR cS wceq cA cB cop cR wcel cA cB cop cS wcel cA cB cR wbr cA cB cS wbr cR
    cS cA cB cop eleq2 cA cB cR df-br cA cB cS df-br 3bitr4g $.
    $( [4-Jun-1995] $)

  $( Equality theorem for a binary relation. $)
  breq1 $p |- ( A = B -> ( A R C <-> B R C ) ) $=
    cA cB wceq cA cC cop cR wcel cB cC cop cR wcel cA cC cR wbr cB cC cR wbr cA
    cB wceq cA cC cop cB cC cop cR cA cB cC opeq1 eleq1d cA cC cR df-br cB cC
    cR df-br 3bitr4g $.
    $( [31-Dec-1993] $)

  $( Equality theorem for a binary relation. $)
  breq2 $p |- ( A = B -> ( C R A <-> C R B ) ) $=
    cA cB wceq cC cA cop cR wcel cC cB cop cR wcel cC cA cR wbr cC cB cR wbr cA
    cB wceq cC cA cop cC cB cop cR cA cB cC opeq2 eleq1d cC cA cR df-br cC cB
    cR df-br 3bitr4g $.
    $( [31-Dec-1993] $)

  $( Equality theorem for a binary relation. $)
  breq12 $p |- ( ( A = B /\ C = D ) -> ( A R C <-> B R D ) ) $=
    cA cB wceq cA cC cR wbr cB cC cR wbr cC cD wceq cB cD cR wbr cA cB cC cR
    breq1 cC cD cB cR breq2 sylan9bb $.
    $( [8-Feb-1996] $)

  ${
    breqi.1 $e |- R = S $.
    $( Equality inference for binary relations. $)
    breqi $p |- ( A R B <-> A S B ) $=
      cR cS wceq cA cB cR wbr cA cB cS wbr wb breqi.1 cA cB cR cS breq ax-mp $.
      $( [20-Feb-2005] $) $( [19-Feb-2005] $)
  $}

  ${
    breq1i.1 $e |- A = B $.
    $( Equality inference for a binary relation. $)
    breq1i $p |- ( A R C <-> B R C ) $=
      cA cB wceq cA cC cR wbr cB cC cR wbr wb breq1i.1 cA cB cC cR breq1 ax-mp
      $.
      $( [8-Feb-1996] $)

    $( Equality inference for a binary relation. $)
    breq2i $p |- ( C R A <-> C R B ) $=
      cA cB wceq cC cA cR wbr cC cB cR wbr wb breq1i.1 cA cB cC cR breq2 ax-mp
      $.
      $( [8-Feb-1996] $)

    ${
      breq12i.2 $e |- C = D $.
      $( Equality inference for a binary relation.  (The proof was shortened by
         Eric Schmidt, 4-Apr-2007.) $)
      breq12i $p |- ( A R C <-> B R D ) $=
        cA cB wceq cC cD wceq cA cC cR wbr cB cD cR wbr wb breq1i.1 breq12i.2
        cA cB cC cD cR breq12 mp2an $.
        $( [4-Apr-2007] $) $( [8-Feb-1996] $)
    $}
  $}

  ${
    breq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for a binary relation. $)
    breq1d $p |- ( ph -> ( A R C <-> B R C ) ) $=
      wph cA cB wceq cA cC cR wbr cB cC cR wbr wb breq1d.1 cA cB cC cR breq1
      syl $.
      $( [8-Feb-1996] $)

    $( Equality deduction for a binary relation. $)
    breq2d $p |- ( ph -> ( C R A <-> C R B ) ) $=
      wph cA cB wceq cC cA cR wbr cC cB cR wbr wb breq1d.1 cA cB cC cR breq2
      syl $.
      $( [8-Feb-1996] $)

    ${
      breq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for a binary relation. $)
      breq12d $p |- ( ph -> ( A R C <-> B R D ) ) $=
        wph cA cC cR wbr cB cC cR wbr cB cD cR wbr wph cA cB cC cR breq1d.1
        breq1d wph cC cD cB cR breq12d.2 breq2d bitrd $.
        $( [8-Feb-1996] $)
    $}

    ${
      breqan12i.2 $e |- ( ps -> C = D ) $.
      $( Equality deduction for a binary relation. $)
      breqan12d $p |- ( ( ph /\ ps ) -> ( A R C <-> B R D ) ) $=
        cA cB wceq cC cD wceq cA cC cR wbr cB cD cR wbr wb wph wps cA cB cC cD
        cR breq12 breq1d.1 breqan12i.2 syl2an $.
        $( [8-Feb-1996] $)

      $( Equality deduction for a binary relation. $)
      breqan12rd $p |- ( ( ps /\ ph ) -> ( A R C <-> B R D ) ) $=
        wph wps cA cC cR wbr cB cD cR wbr wb wph wps cA cB cC cD cR breq1d.1
        breqan12i.2 breqan12d ancoms $.
        $( [8-Feb-1996] $)
    $}
  $}

  ${
    eqbrtr.1 $e |- A = B $.
    eqbrtr.2 $e |- B R C $.
    $( Substitution of equal classes into a binary relation. $)
    eqbrtri $p |- A R C $=
      cA cC cR wbr cB cC cR wbr eqbrtr.2 cA cB cC cR eqbrtr.1 breq1i mpbir $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqbrtrd.1 $e |- ( ph -> A = B ) $.
    eqbrtrd.2 $e |- ( ph -> B R C ) $.
    $( Substitution of equal classes into a binary relation. $)
    eqbrtrd $p |- ( ph -> A R C ) $=
      wph cA cC cR wbr cB cC cR wbr eqbrtrd.2 wph cA cB cC cR eqbrtrd.1 breq1d
      mpbird $.
      $( [8-Oct-1999] $)
  $}

  ${
    eqbrtrr.1 $e |- A = B $.
    eqbrtrr.2 $e |- A R C $.
    $( Substitution of equal classes into a binary relation. $)
    eqbrtrri $p |- B R C $=
      cB cA cC cR cA cB eqbrtrr.1 eqcomi eqbrtrr.2 eqbrtri $.
      $( [5-Aug-1993] $)
  $}

  ${
    eqbrtrrd.1 $e |- ( ph -> A = B ) $.
    eqbrtrrd.2 $e |- ( ph -> A R C ) $.
    $( Substitution of equal classes into a binary relation. $)
    eqbrtrrd $p |- ( ph -> B R C ) $=
      wph cB cA cC cR wph cA cB eqbrtrrd.1 eqcomd eqbrtrrd.2 eqbrtrd $.
      $( [24-Oct-1999] $)
  $}

  ${
    breqtr.1 $e |- A R B $.
    breqtr.2 $e |- B = C $.
    $( Substitution of equal classes into a binary relation. $)
    breqtri $p |- A R C $=
      cA cB cR wbr cA cC cR wbr breqtr.1 cB cC cA cR breqtr.2 breq2i mpbi $.
      $( [5-Aug-1993] $)
  $}

  ${
    breqtrd.1 $e |- ( ph -> A R B ) $.
    breqtrd.2 $e |- ( ph -> B = C ) $.
    $( Substitution of equal classes into a binary relation. $)
    breqtrd $p |- ( ph -> A R C ) $=
      wph cA cB cR wbr cA cC cR wbr breqtrd.1 wph cB cC cA cR breqtrd.2 breq2d
      mpbid $.
      $( [24-Oct-1999] $)
  $}

  ${
    breqtrr.1 $e |- A R B $.
    breqtrr.2 $e |- C = B $.
    $( Substitution of equal classes into a binary relation. $)
    breqtrri $p |- A R C $=
      cA cB cC cR breqtrr.1 cC cB breqtrr.2 eqcomi breqtri $.
      $( [5-Aug-1993] $)
  $}

  ${
    breqtrrd.1 $e |- ( ph -> A R B ) $.
    breqtrrd.2 $e |- ( ph -> C = B ) $.
    $( Substitution of equal classes into a binary relation. $)
    breqtrrd $p |- ( ph -> A R C ) $=
      wph cA cB cC cR breqtrrd.1 wph cC cB breqtrrd.2 eqcomd breqtrd $.
      $( [24-Oct-1999] $)
  $}

  ${
    3brtr3.1 $e |- A R B $.
    3brtr3.2 $e |- A = C $.
    3brtr3.3 $e |- B = D $.
    $( Substitution of equality into both sides of a binary relation. $)
    3brtr3i $p |- C R D $=
      cC cB cD cR cA cC cB cR 3brtr3.2 3brtr3.1 eqbrtrri 3brtr3.3 breqtri $.
      $( [11-Aug-1999] $)
  $}

  ${
    3brtr4.1 $e |- A R B $.
    3brtr4.2 $e |- C = A $.
    3brtr4.3 $e |- D = B $.
    $( Substitution of equality into both sides of a binary relation. $)
    3brtr4i $p |- C R D $=
      cC cB cD cR cC cA cB cR 3brtr4.2 3brtr4.1 eqbrtri 3brtr4.3 breqtrri $.
      $( [11-Aug-1999] $)
  $}

  ${
    3brtr3d.1 $e |- ( ph -> A R B ) $.
    3brtr3d.2 $e |- ( ph -> A = C ) $.
    3brtr3d.3 $e |- ( ph -> B = D ) $.
    $( Substitution of equality into both sides of a binary relation. $)
    3brtr3d $p |- ( ph -> C R D ) $=
      wph cA cB cR wbr cC cD cR wbr 3brtr3d.1 wph cA cC cB cD cR 3brtr3d.2
      3brtr3d.3 breq12d mpbid $.
      $( [18-Oct-1999] $)
  $}

  ${
    3brtr4d.1 $e |- ( ph -> A R B ) $.
    3brtr4d.2 $e |- ( ph -> C = A ) $.
    3brtr4d.3 $e |- ( ph -> D = B ) $.
    $( Substitution of equality into both sides of a binary relation. $)
    3brtr4d $p |- ( ph -> C R D ) $=
      wph cC cD cR wbr cA cB cR wbr 3brtr4d.1 wph cC cA cD cB cR 3brtr4d.2
      3brtr4d.3 breq12d mpbird $.
      $( [8-Mar-2005] $) $( [21-Feb-2005] $)
  $}

  ${
    3brtr3g.1 $e |- ( ph -> A R B ) $.
    3brtr3g.2 $e |- A = C $.
    3brtr3g.3 $e |- B = D $.
    $( Substitution of equality into both sides of a binary relation. $)
    3brtr3g $p |- ( ph -> C R D ) $=
      wph cA cB cR wbr cC cD cR wbr 3brtr3g.1 cA cC cB cD cR 3brtr3g.2
      3brtr3g.3 breq12i sylib $.
      $( [16-Jan-1997] $)
  $}

  ${
    3brtr4g.1 $e |- ( ph -> A R B ) $.
    3brtr4g.2 $e |- C = A $.
    3brtr4g.3 $e |- D = B $.
    $( Substitution of equality into both sides of a binary relation. $)
    3brtr4g $p |- ( ph -> C R D ) $=
      wph cA cB cR wbr cC cD cR wbr 3brtr4g.1 cC cA cD cB cR 3brtr4g.2
      3brtr4g.3 breq12i sylibr $.
      $( [16-Jan-1997] $)
  $}

  ${
    syl5eqbr.1 $e |- ( ph -> A R B ) $.
    syl5eqbr.2 $e |- C = A $.
    $( A chained equality inference for a binary relation. $)
    syl5eqbr $p |- ( ph -> C R B ) $=
      wph cA cB cC cB cR syl5eqbr.1 syl5eqbr.2 cB eqid 3brtr4g $.
      $( [11-Oct-1999] $)
  $}

  ${
    syl5eqbrr.1 $e |- ( ph -> A R B ) $.
    syl5eqbrr.2 $e |- A = C $.
    $( A chained equality inference for a binary relation. $)
    syl5eqbrr $p |- ( ph -> C R B ) $=
      wph cA cB cC cB cR syl5eqbrr.1 syl5eqbrr.2 cB eqid 3brtr3g $.
      $( [23-Oct-2004] $) $( [17-Sep-2004] $)
  $}

  ${
    syl5breq.1 $e |- ( ph -> A = B ) $.
    syl5breq.2 $e |- C R A $.
    $( A chained equality inference for a binary relation. $)
    syl5breq $p |- ( ph -> C R B ) $=
      wph cC cA cB cR cC cA cR wbr wph syl5breq.2 a1i syl5breq.1 breqtrd $.
      $( [11-Oct-1999] $)
  $}

  ${
    syl5breqr.1 $e |- ( ph -> B = A ) $.
    syl5breqr.2 $e |- C R A $.
    $( A chained equality inference for a binary relation. $)
    syl5breqr $p |- ( ph -> C R B ) $=
      wph cA cB cC cR wph cB cA syl5breqr.1 eqcomd syl5breqr.2 syl5breq $.
      $( [26-Apr-2005] $) $( [24-Apr-2005] $)
  $}

  ${
    syl6eqbr.1 $e |- ( ph -> A = B ) $.
    syl6eqbr.2 $e |- B R C $.
    $( A chained equality inference for a binary relation. $)
    syl6eqbr $p |- ( ph -> A R C ) $=
      wph cA cC cR wbr cB cC cR wbr syl6eqbr.2 wph cA cB cC cR syl6eqbr.1
      breq1d mpbiri $.
      $( [12-Oct-1999] $)
  $}

  ${
    syl6eqbrr.1 $e |- ( ph -> B = A ) $.
    syl6eqbrr.2 $e |- B R C $.
    $( A chained equality inference for a binary relation. $)
    syl6eqbrr $p |- ( ph -> A R C ) $=
      wph cA cB cC cR wph cB cA syl6eqbrr.1 eqcomd syl6eqbrr.2 syl6eqbr $.
      $( [7-Mar-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    syl6breq.1 $e |- ( ph -> A R B ) $.
    syl6breq.2 $e |- B = C $.
    $( A chained equality inference for a binary relation. $)
    syl6breq $p |- ( ph -> A R C ) $=
      wph cA cB cA cC cR syl6breq.1 cA eqid syl6breq.2 3brtr3g $.
      $( [11-Oct-1999] $)
  $}

  ${
    syl6breqr.1 $e |- ( ph -> A R B ) $.
    syl6breqr.2 $e |- C = B $.
    $( A chained equality inference for a binary relation. $)
    syl6breqr $p |- ( ph -> A R C ) $=
      wph cA cB cC cR syl6breqr.1 cC cB syl6breqr.2 eqcomi syl6breq $.
      $( [26-Apr-2005] $) $( [24-Apr-2005] $)
  $}


  ${
    ssbrd.1 $e |- ( ph -> A C_ B ) $.
    $( Deduction from a subclass relationship of binary relations. $)
    ssbrd $p |- ( ph -> ( C A D -> C B D ) ) $=
      wph cC cD cop cA wcel cC cD cop cB wcel cC cD cA wbr cC cD cB wbr wph cA
      cB cC cD cop ssbrd.1 sseld cC cD cA df-br cC cD cB df-br 3imtr4g $.
      $( [14-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    ssbri.1 $e |- A C_ B $.
    $( Inference from a subclass relationship of binary relations. $)
    ssbri $p |- ( C A D -> C B D ) $=
      cA cA wceq cC cD cA wbr cC cD cB wbr wi cA eqid cA cA wceq cA cB cC cD cA
      cB wss cA cA wceq ssbri.1 a1i ssbrd ax-mp $.
      $( [28-Mar-2007] $) $( [28-Mar-2007] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y R $.  $d x y $.
    hbbr.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbbr.2 $e |- ( y e. R -> A. x y e. R ) $.
    hbbr.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for binary relation. $)
    hbbr $p |- ( A R B -> A. x A R B ) $=
      cA cB cop cR wcel cA cB cop cR wcel vx wal cA cB cR wbr cA cB cR wbr vx
      wal vx vy vy cA cB cop cR vx vy cA cB hbbr.1 hbbr.3 hbop hbbr.2 hbel cA
      cB cR df-br cA cB cR wbr cA cB cop cR wcel vx cA cB cR df-br albii
      3imtr4i $.
      $( [1-Sep-1999] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z R $.  $d x y z $.  $d y ph $.
    hbbrd.1 $e |- ( ph -> A. x ph ) $.
    hbbrd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    hbbrd.3 $e |- ( ph -> ( y e. R -> A. x y e. R ) ) $.
    hbbrd.4 $e |- ( ph -> ( y e. B -> A. x y e. B ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbbr . $)
    hbbrd $p |- ( ph -> ( A R B -> A. x A R B ) ) $=
      wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv cR wcel
      vx wal vz cab wbr vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab
      vz cv cR wcel vx wal vz cab wbr vx wal cA cB cR wbr cA cB cR wbr vx wal
      vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv cR wcel vx
      wal vz cab wbr vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz
      cv cR wcel vx wal vz cab wbr vx wal wi wph vx vy vz cv cA wcel vx wal vz
      cab vz cv cB wcel vx wal vz cab vz cv cR wcel vx wal vz cab vz cv cA wcel
      vx wal vx vz vy vz cv cA wcel vx hba1 hbab vz cv cR wcel vx wal vx vz vy
      vz cv cR wcel vx hba1 hbab vz cv cB wcel vx wal vx vz vy vz cv cB wcel vx
      hba1 hbab hbbr a1i wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal
      vz cab vz cv cR wcel vx wal vz cab wbr cA cB vz cv cR wcel vx wal vz cab
      wbr cA cB cR wbr wph vz cv cA wcel vx wal vz cab cA vz cv cB wcel vx wal
      vz cab cB vz cv cR wcel vx wal vz cab wph vy cv cA wcel vy cv cA wcel vx
      wal wi vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv
      cA wcel vx wal wi vy hbbrd.2 19.21aiv vx vy vz cA abidhb syl wph vy cv cB
      wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB wceq
      wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbbrd.4 19.21aiv vx vy vz cB
      abidhb syl breq12d wph vz cv cR wcel vx wal vz cab cR wceq cA cB vz cv cR
      wcel vx wal vz cab wbr cA cB cR wbr wb wph vy cv cR wcel vy cv cR wcel vx
      wal wi vy wal vz cv cR wcel vx wal vz cab cR wceq wph vy cv cR wcel vy cv
      cR wcel vx wal wi vy hbbrd.3 19.21aiv vx vy vz cR abidhb syl cA cB vz cv
      cR wcel vx wal vz cab cR breq syl bitrd wph vz cv cA wcel vx wal vz cab
      vz cv cB wcel vx wal vz cab vz cv cR wcel vx wal vz cab wbr cA cB cR wbr
      vx hbbrd.1 wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz
      cv cR wcel vx wal vz cab wbr cA cB vz cv cR wcel vx wal vz cab wbr cA cB
      cR wbr wph vz cv cA wcel vx wal vz cab cA vz cv cB wcel vx wal vz cab cB
      vz cv cR wcel vx wal vz cab wph vy cv cA wcel vy cv cA wcel vx wal wi vy
      wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA wcel
      vx wal wi vy hbbrd.2 19.21aiv vx vy vz cA abidhb syl wph vy cv cB wcel vy
      cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB wceq wph vy cv
      cB wcel vy cv cB wcel vx wal wi vy hbbrd.4 19.21aiv vx vy vz cB abidhb
      syl breq12d wph vz cv cR wcel vx wal vz cab cR wceq cA cB vz cv cR wcel
      vx wal vz cab wbr cA cB cR wbr wb wph vy cv cR wcel vy cv cR wcel vx wal
      wi vy wal vz cv cR wcel vx wal vz cab cR wceq wph vy cv cR wcel vy cv cR
      wcel vx wal wi vy hbbrd.3 19.21aiv vx vy vz cR abidhb syl cA cB vz cv cR
      wcel vx wal vz cab cR breq syl bitrd albid 3imtr3d $.
      $( [22-Dec-2005] $) $( [13-Dec-2005] $)
  $}

  ${
    $d x z $.  $d y z $.  $d R z $.
    $( Relationship between a binary relation and a class abstraction. $)
    brab1 $p |- ( x R y <-> x e. { z | z R y } ) $=
      vx cv vz cv vy cv cR wbr vz cab wcel vx cv vy cv cR wbr vz cv vy cv cR
      wbr vx cv vy cv cR wbr vz vx cv vx visset vz cv vx cv vy cv cR breq1 elab
      bicomi $.
      $( [7-Apr-1994] $)
  $}

  $( A property of proper class as the second argument of a binary relation. $)
  brprc $p |- ( -. B e. _V -> ( A R B <-> A R A ) ) $=
    cB cvv wcel wn cA cB cop cR wcel cA cA cop cR wcel cA cB cR wbr cA cA cR
    wbr cB cvv wcel wn cA cB cop cA cA cop cR cA cB opprc2 eleq1d cA cB cR
    df-br cA cA cR df-br 3bitr4g $.
    $( [14-Jun-1998] $)

  $( The union of two binary relations. $)
  brun $p |- ( A ( R u. S ) B <-> ( A R B \/ A S B ) ) $=
    cA cB cop cR cS cun wcel cA cB cop cR wcel cA cB cop cS wcel wo cA cB cR cS
    cun wbr cA cB cR wbr cA cB cS wbr wo cA cB cop cR cS elun cA cB cR cS cun
    df-br cA cB cR wbr cA cB cop cR wcel cA cB cS wbr cA cB cop cS wcel cA cB
    cR df-br cA cB cS df-br orbi12i 3bitr4i $.
    $( [31-Dec-2008] $) $( [21-Dec-2008] $)

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y z D $.  $d y z R $.
    $d x y z $.
    $( Move substitution in and out of a binary relation. $)
    sbcbrg $p |- ( A e. D -> ( [ A / x ] B R C <->
           [_ A / x ]_ B [_ A / x ]_ R  [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC cR wbr vx vy cv wsbc vy cA wsbc vy cA vx vy cv cB csb
      csb vy cA vx vy cv cC csb csb vy cA vx vy cv cR csb csb wbr cB cC cR wbr
      vx cA wsbc vx cA cB csb vx cA cC csb vx cA cR csb wbr cB cC cR wbr vx vy
      cv wsbc vy cA vx vy cv cB csb csb vy cA vx vy cv cC csb csb vy cA vx vy
      cv cR csb csb wbr vy cA cD cA cD wcel vy vz vy cA vx vy cv cB csb csb vy
      cA vx vy cv cC csb csb vy cA vx vy cv cR csb csb cA cD wcel vy ax-17 vy
      vz cA vx vy cv cB csb cD vz cv cA wcel vy ax-17 hbcsb1g vy vz cA vx vy cv
      cR csb cD vz cv cA wcel vy ax-17 hbcsb1g vy vz cA vx vy cv cC csb cD vz
      cv cA wcel vy ax-17 hbcsb1g hbbrd vy cv cA wceq cB cC cR wbr vx vy cv
      wsbc vx vy cv cB csb vx vy cv cC csb vx vy cv cR csb wbr vy cA vx vy cv
      cB csb csb vy cA vx vy cv cC csb csb vx vy cv cR csb wbr vy cA vx vy cv
      cB csb csb vy cA vx vy cv cC csb csb vy cA vx vy cv cR csb csb wbr cB cC
      cR wbr vx vy cv wsbc vx vy cv cB csb vx vy cv cC csb vx vy cv cR csb wbr
      wb vy cv cA wceq vx cv vy cv wceq vx wex cB cC cR wbr vx vy cv wsbc vx vy
      cv cB csb vx vy cv cC csb vx vy cv cR csb wbr wb vx vy a9e vx cv vy cv
      wceq cB cC cR wbr vx vy cv wsbc vx vy cv cB csb vx vy cv cC csb vx vy cv
      cR csb wbr wb vx cB cC cR wbr vx vy cv wsbc vx vy cv cB csb vx vy cv cC
      csb vx vy cv cR csb wbr vx vy cv cvv wcel cB cC cR wbr vx vy cv wsbc cB
      cC cR wbr vx vy cv wsbc vx wal wi vy visset cB cC cR wbr vx vz vy cv cvv
      vz cv vy cv wcel vx ax-17 hbsbc1g ax-mp vx vz vx vy cv cB csb vx vy cv cC
      csb vx vy cv cR csb vx vz vy cv cB vy visset vz cv vy cv wcel vx ax-17
      hbcsb1 vx vz vy cv cR vy visset vz cv vy cv wcel vx ax-17 hbcsb1 vx vz vy
      cv cC vy visset vz cv vy cv wcel vx ax-17 hbcsb1 hbbr hbbi vx cv vy cv
      wceq cB cC cR wbr vx vy cv cB csb vx vy cv cC csb cR wbr cB cC cR wbr vx
      vy cv wsbc vx vy cv cB csb vx vy cv cC csb vx vy cv cR csb wbr vx cv vy
      cv wceq cB vx vy cv cB csb cC vx vy cv cC csb cR vx vy cv cB csbeq1a vx
      vy cv cC csbeq1a breq12d cB cC cR wbr vx vy cv sbceq1a vx cv vy cv wceq
      cR vx vy cv cR csb wceq vx vy cv cB csb vx vy cv cC csb cR wbr vx vy cv
      cB csb vx vy cv cC csb vx vy cv cR csb wbr wb vx vy cv cR csbeq1a vx vy
      cv cB csb vx vy cv cC csb cR vx vy cv cR csb breq syl 3bitr3d 19.23ai
      ax-mp a1i vy cv cA wceq vx vy cv cB csb vy cA vx vy cv cB csb csb vx vy
      cv cC csb vy cA vx vy cv cC csb csb vx vy cv cR csb vy cA vx vy cv cB csb
      csbeq1a vy cA vx vy cv cC csb csbeq1a breq12d vy cv cA wceq vx vy cv cR
      csb vy cA vx vy cv cR csb csb wceq vy cA vx vy cv cB csb csb vy cA vx vy
      cv cC csb csb vx vy cv cR csb wbr vy cA vx vy cv cB csb csb vy cA vx vy
      cv cC csb csb vy cA vx vy cv cR csb csb wbr wb vy cA vx vy cv cR csb
      csbeq1a vy cA vx vy cv cB csb csb vy cA vx vy cv cC csb csb vx vy cv cR
      csb vy cA vx vy cv cR csb csb breq syl 3bitrd sbciegf cB cC cR wbr vx vy
      cA cD sbccog cA cD wcel vy cA vx vy cv cB csb csb vy cA vx vy cv cC csb
      csb vy cA vx vy cv cR csb csb wbr vx cA cB csb vx cA cC csb vy cA vx vy
      cv cR csb csb wbr vx cA cB csb vx cA cC csb vx cA cR csb wbr cA cD wcel
      vy cA vx vy cv cB csb csb vx cA cB csb vy cA vx vy cv cC csb csb vx cA cC
      csb vy cA vx vy cv cR csb csb vx vy cA cB cD csbcog vx vy cA cC cD csbcog
      breq12d cA cD wcel vy cA vx vy cv cR csb csb vx cA cR csb wceq vx cA cB
      csb vx cA cC csb vy cA vx vy cv cR csb csb wbr vx cA cB csb vx cA cC csb
      vx cA cR csb wbr wb vx vy cA cR cD csbcog vx cA cB csb vx cA cC csb vy cA
      vx vy cv cR csb csb vx cA cR csb breq syl bitrd 3bitr3d $.
      $( [22-Dec-2005] $) $( [13-Dec-2005] $)
  $}

  ${
    $d y A $.  $d y C $.  $d y D $.  $d x y R $.
    $( Move substitution in and out of a binary relation. $)
    sbcbr12g $p |- ( A e. D ->
                 ( [ A / x ] B R C <-> [_ A / x ]_ B R [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC cR wbr vx cA wsbc vx cA cB csb vx cA cC csb vx cA cR csb
      wbr vx cA cB csb vx cA cC csb cR wbr vx cA cB cC cD cR sbcbrg cA cD wcel
      vx cA cR csb cR wceq vx cA cB csb vx cA cC csb vx cA cR csb wbr vx cA cB
      csb vx cA cC csb cR wbr wb vx vy cA cR cD vy cv cR wcel vx ax-17
      csbconstgf vx cA cB csb vx cA cC csb vx cA cR csb cR breq syl bitrd $.
      $( [30-Dec-2005] $) $( [13-Dec-2005] $)
  $}

  ${
    $d y A $.  $d x y C $.  $d y D $.  $d x y R $.
    $( Move substitution in and out of a binary relation. $)
    sbcbr1g $p |- ( A e. D ->
                  ( [ A / x ] B R C <-> [_ A / x ]_ B R C ) ) $=
      cA cD wcel cB cC cR wbr vx cA wsbc vx cA cB csb vx cA cC csb cR wbr vx cA
      cB csb cC cR wbr vx cA cB cC cD cR sbcbr12g cA cD wcel vx cA cC csb cC vx
      cA cB csb cR vx vy cA cC cD vy cv cC wcel vx ax-17 csbconstgf breq2d
      bitrd $.
      $( [1-Jan-2006] $) $( [13-Dec-2005] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d y D $.  $d x y R $.
    $( Move substitution in and out of a binary relation. $)
    sbcbr2g $p |- ( A e. D ->
                  ( [ A / x ] B R C <-> B R [_ A / x ]_ C ) ) $=
      cA cD wcel cB cC cR wbr vx cA wsbc vx cA cB csb vx cA cC csb cR wbr cB vx
      cA cC csb cR wbr vx cA cB cC cD cR sbcbr12g cA cD wcel vx cA cB csb cB vx
      cA cC csb cR vx vy cA cB cD vy cv cB wcel vx ax-17 csbconstgf breq1d
      bitrd $.
      $( [21-Feb-2006] $) $( [13-Dec-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ordered-pair class abstractions (class builders)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend class notation to include ordered-pair class abstraction (class
     builder). $)
  copab $a class { <. x , y >. | ph } $.

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( Define the class abstraction of a collection of ordered pairs.
       Definition 3.3 of [Monk1] p. 34.  Usually ` x ` and ` y ` are distinct,
       although the definition doesn't strictly require it (see ~ dfid2 for a
       case where they are not distinct).  The brace notation is called "class
       abstraction" by Quine; it is also (more commonly) called a "class
       builder" in the literature.  An alternate definition using no
       existential quantifiers is shown by ~ dfopab2 . $)
    df-opab $a |- { <. x , y >. | ph } =
                  { z | E. x E. y ( z = <. x , y >. /\ ph ) } $.
  $}

  ${
    $d x z R $.  $d y z R $.
    $( The collection of ordered pairs in a class is a subclass of it. $)
    opabss $p |- { <. x , y >. | x R y } C_ R $=
      vx cv vy cv cR wbr vx vy copab vz cv cR wcel vz cab cR vx cv vy cv cR wbr
      vx vy copab vz cv vx cv vy cv cop wceq vx cv vy cv cR wbr wa vy wex vx
      wex vz cab vz cv cR wcel vz cab vx cv vy cv cR wbr vx vy vz df-opab vz cv
      vx cv vy cv cop wceq vx cv vy cv cR wbr wa vy wex vx wex vz cv cR wcel vz
      vz cv vx cv vy cv cop wceq vx cv vy cv cR wbr wa vz cv cR wcel vx vy vz
      cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv cR wcel vx cv vy cv
      cR wbr vz cv vx cv vy cv cop wceq vz cv cR wcel vx cv vy cv cop cR wcel
      vz cv vx cv vy cv cop cR eleq1 biimpar vx cv vy cv cR df-br sylan2b
      19.23aivv ss2abi eqsstri vz cR abid2 sseqtri $.
      $( [27-Dec-1996] $)
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.  $d z ps $.  $d z ch $.
    opabbid.1 $e |- ( ph -> A. x ph ) $.
    opabbid.2 $e |- ( ph -> A. y ph ) $.
    opabbid.3 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal ordered-pair class abstractions (deduction
       rule). $)
    opabbid $p |- ( ph -> { <. x , y >. | ps } = { <. x , y >. | ch } ) $=
      wph vz cv vx cv vy cv cop wceq wps wa vy wex vx wex vz cab vz cv vx cv vy
      cv cop wceq wch wa vy wex vx wex vz cab wps vx vy copab wch vx vy copab
      wph vz cv vx cv vy cv cop wceq wps wa vy wex vx wex vz cv vx cv vy cv cop
      wceq wch wa vy wex vx wex vz wph vz ax-17 wph vz cv vx cv vy cv cop wceq
      wps wa vy wex vz cv vx cv vy cv cop wceq wch wa vy wex vx opabbid.1 wph
      vz cv vx cv vy cv cop wceq wps wa vz cv vx cv vy cv cop wceq wch wa vy
      opabbid.2 wph wps wch vz cv vx cv vy cv cop wceq opabbid.3 anbi2d exbid
      exbid abbid wps vx vy vz df-opab wch vx vy vz df-opab 3eqtr4g $.
      $( [24-Feb-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x ph $.  $d y z ph $.  $d z ps $.  $d z ch $.
    opabbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal ordered-pair class abstractions (deduction
       rule). $)
    opabbidv $p |- ( ph -> { <. x , y >. | ps } = { <. x , y >. | ch } ) $=
      wph wps wch vx vy wph vx ax-17 wph vy ax-17 opabbidv.1 opabbid $.
      $( [15-May-1995] $)
  $}

  ${
    $d x y z $.  $d z ph $.  $d z ps $.
    opabbii.1 $e |- ( ph <-> ps ) $.
    $( Equivalent wff's yield equal class abstractions. $)
    opabbii $p |- { <. x , y >. | ph } = { <. x , y >. | ps } $=
      vz cv vz cv wceq wph vx vy copab wps vx vy copab wceq vz cv eqid vz cv vz
      cv wceq wph wps vx vy wph wps wb vz cv vz cv wceq opabbii.1 a1i opabbidv
      ax-mp $.
      $( [15-May-1995] $)
  $}

  ${
    $d x y z w v $.  $d v ph $.  $d v ps $.
    cbvopab.1 $e |- ( ph -> A. z ph ) $.
    cbvopab.2 $e |- ( ph -> A. w ph ) $.
    cbvopab.3 $e |- ( ps -> A. x ps ) $.
    cbvopab.4 $e |- ( ps -> A. y ps ) $.
    cbvopab.5 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables in an ordered-pair class
       abstraction, using implicit substitution. $)
    cbvopab $p |- { <. x , y >. | ph } = { <. z , w >. | ps } $=
      vv cv vx cv vy cv cop wceq wph wa vy wex vx wex vv cab vv cv vz cv vw cv
      cop wceq wps wa vw wex vz wex vv cab wph vx vy copab wps vz vw copab vv
      cv vx cv vy cv cop wceq wph wa vy wex vx wex vv cv vz cv vw cv cop wceq
      wps wa vw wex vz wex vv vv cv vx cv vy cv cop wceq wph wa vv cv vz cv vw
      cv cop wceq wps wa vx vy vz vw vv cv vx cv vy cv cop wceq wph vz vv cv vx
      cv vy cv cop wceq vz ax-17 cbvopab.1 hban vv cv vx cv vy cv cop wceq wph
      vw vv cv vx cv vy cv cop wceq vw ax-17 cbvopab.2 hban vv cv vz cv vw cv
      cop wceq wps vx vv cv vz cv vw cv cop wceq vx ax-17 cbvopab.3 hban vv cv
      vz cv vw cv cop wceq wps vy vv cv vz cv vw cv cop wceq vy ax-17 cbvopab.4
      hban vx cv vz cv wceq vy cv vw cv wceq wa vv cv vx cv vy cv cop wceq vv
      cv vz cv vw cv cop wceq wph wps vx cv vz cv wceq vy cv vw cv wceq wa vx
      cv vy cv cop vz cv vw cv cop vv cv vx cv vy cv vz cv vw cv opeq12 eqeq2d
      cbvopab.5 anbi12d cbvex2 abbii wph vx vy vv df-opab wps vz vw vv df-opab
      3eqtr4i $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d x y z w $.  $d z w v ph $.  $d x y v ps $.
    cbvopabv.1 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables in an ordered-pair class
       abstraction, using implicit substitution. $)
    cbvopabv $p |- { <. x , y >. | ph } = { <. z , w >. | ps } $=
      wph wps vx vy vz vw wph vz ax-17 wph vw ax-17 wps vx ax-17 wps vy ax-17
      cbvopabv.1 cbvopab $.
      $( [15-Oct-1996] $)
  $}

  ${
    $d x y z w $.  $d w ph $.  $d w ps $.
    cbvopab1.1 $e |- ( ph -> A. z ph ) $.
    cbvopab1.2 $e |- ( ps -> A. x ps ) $.
    cbvopab1.3 $e |- ( x = z -> ( ph <-> ps ) ) $.
    $( Change first bound variable in an ordered-pair class abstraction,
       using explicit substitution. $)
    cbvopab1 $p |- { <. x , y >. | ph } = { <. z , y >. | ps } $=
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cab vw cv vz cv vy cv
      cop wceq wps wa vy wex vz wex vw cab wph vx vy copab wps vz vy copab vw
      cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cv vz cv vy cv cop wceq
      wps wa vy wex vz wex vw vw cv vx cv vy cv cop wceq wph wa vy wex vw cv vz
      cv vy cv cop wceq wps wa vy wex vx vz vw cv vx cv vy cv cop wceq wph wa
      vz vy vw cv vx cv vy cv cop wceq wph vz vw cv vx cv vy cv cop wceq vz
      ax-17 cbvopab1.1 hban hbex vw cv vz cv vy cv cop wceq wps wa vx vy vw cv
      vz cv vy cv cop wceq wps vx vw cv vz cv vy cv cop wceq vx ax-17
      cbvopab1.2 hban hbex vx cv vz cv wceq vw cv vx cv vy cv cop wceq wph wa
      vw cv vz cv vy cv cop wceq wps wa vy vx cv vz cv wceq vw cv vx cv vy cv
      cop wceq vw cv vz cv vy cv cop wceq wph wps vx cv vz cv wceq vx cv vy cv
      cop vz cv vy cv cop vw cv vx cv vz cv vy cv opeq1 eqeq2d cbvopab1.3
      anbi12d exbidv cbvex abbii wph vx vy vw df-opab wps vz vy vw df-opab
      3eqtr4i $.
      $( [17-Oct-2004] $) $( [6-Oct-2004] $)
  $}

  ${
    $d x y z w $.  $d z w ph $.
    $( Change first bound variable in an ordered-pair class abstraction,
       using explicit substitution. $)
    cbvopab1s $p |- { <. x , y >. | ph } = { <. z , y >. | [ z / x ] ph } $=
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cab vw cv vz cv vy cv
      cop wceq wph vx vz cv wsbc wa vy wex vz wex vw cab wph vx vy copab wph vx
      vz cv wsbc vz vy copab vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw
      cv vz cv vy cv cop wceq wph vx vz cv wsbc wa vy wex vz wex vw vw cv vx cv
      vy cv cop wceq wph wa vy wex vw cv vz cv vy cv cop wceq wph vx vz cv wsbc
      wa vy wex vx vz vw cv vx cv vy cv cop wceq wph wa vy wex vz ax-17 vw cv
      vz cv vy cv cop wceq wph vx vz cv wsbc wa vx vy vw cv vz cv vy cv cop
      wceq wph vx vz cv wsbc vx vw cv vz cv vy cv cop wceq vx ax-17 wph vx vz
      hbs1 hban hbex vx cv vz cv wceq vw cv vx cv vy cv cop wceq wph wa vw cv
      vz cv vy cv cop wceq wph vx vz cv wsbc wa vy vx cv vz cv wceq vw cv vx cv
      vy cv cop wceq vw cv vz cv vy cv cop wceq wph wph vx vz cv wsbc vx cv vz
      cv wceq vx cv vy cv cop vz cv vy cv cop vw cv vx cv vz cv vy cv opeq1
      eqeq2d wph vx vz sbequ12 anbi12d exbidv cbvex abbii wph vx vy vw df-opab
      wph vx vz cv wsbc vz vy vw df-opab 3eqtr4i $.
      $( [5-Nov-2004] $) $( [31-Jul-2003] $)
  $}

  ${
    $d x y z $.  $d z ph $.  $d x ps $.
    cbvopab1v.1 $e |- ( x = z -> ( ph <-> ps ) ) $.
    $( Rule used to change the first bound variable in an ordered pair
       abstraction, using implicit substitution.  (The proof was shortened by
       Eric Schmidt, 4-Apr-2007.) $)
    cbvopab1v $p |- { <. x , y >. | ph } = { <. z , y >. | ps } $=
      wph wps vx vy vz wph vz ax-17 wps vx ax-17 cbvopab1v.1 cbvopab1 $.
      $( [4-Apr-2007] $) $( [31-Jul-2003] $)
  $}

  ${
    $d x y z w $.  $d z w ph $.  $d y w ps $.
    cbvopab2v.1 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Rule used to change the second bound variable in an ordered pair
       abstraction, using implicit substitution. $)
    cbvopab2v $p |- { <. x , y >. | ph } = { <. x , z >. | ps } $=
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cab vw cv vx cv vz cv
      cop wceq wps wa vz wex vx wex vw cab wph vx vy copab wps vx vz copab vw
      cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cv vx cv vz cv cop wceq
      wps wa vz wex vx wex vw vw cv vx cv vy cv cop wceq wph wa vy wex vw cv vx
      cv vz cv cop wceq wps wa vz wex vx vw cv vx cv vy cv cop wceq wph wa vw
      cv vx cv vz cv cop wceq wps wa vy vz vy cv vz cv wceq vw cv vx cv vy cv
      cop wceq vw cv vx cv vz cv cop wceq wph wps vy cv vz cv wceq vx cv vy cv
      cop vx cv vz cv cop vw cv vy cv vz cv vx cv opeq2 eqeq2d cbvopab2v.1
      anbi12d cbvexv exbii abbii wph vx vy vw df-opab wps vx vz vw df-opab
      3eqtr4i $.
      $( [2-Sep-1999] $)
  $}

  ${
    $d w y z A $.  $d w ph $.  $d w x y z $.
    $( Move substitution into a class abstraction. $)
    csbopabg $p |- ( A e. B -> [_ A / x ]_ { <. y , z >. | ph } =
               { <. y , z >. | [ A / x ] ph } ) $=
      cA cB wcel cA cvv wcel vx cA wph vy vz copab csb wph vx cA wsbc vy vz
      copab wceq cA cB elisset cA cvv wcel vx cA wph vy vz copab csb vx cA vw
      cv vy cv vz cv cop wceq wph wa vz wex vy wex vw cab csb vw cv vy cv vz cv
      cop wceq wph vx cA wsbc wa vz wex vy wex vw cab wph vx cA wsbc vy vz
      copab vx cA wph vy vz copab vw cv vy cv vz cv cop wceq wph wa vz wex vy
      wex vw cab cvv wph vy vz vw df-opab csbeq2i cA cvv wcel vx cA vw cv vy cv
      vz cv cop wceq wph wa vz wex vy wex vw cab csb vw cv vy cv vz cv cop wceq
      wph wa vz wex vy wex vx cA wsbc vw cab vw cv vy cv vz cv cop wceq wph vx
      cA wsbc wa vz wex vy wex vw cab vw cv vy cv vz cv cop wceq wph wa vz wex
      vy wex vx vw cA cvv csbabg cA cvv wcel vw cv vy cv vz cv cop wceq wph wa
      vz wex vy wex vx cA wsbc vw cv vy cv vz cv cop wceq wph vx cA wsbc wa vz
      wex vy wex vw cA cvv wcel vw cv vy cv vz cv cop wceq wph wa vz wex vy wex
      vx cA wsbc vw cv vy cv vz cv cop wceq wph wa vz wex vx cA wsbc vy wex vw
      cv vy cv vz cv cop wceq wph vx cA wsbc wa vz wex vy wex vw cv vy cv vz cv
      cop wceq wph wa vz wex vy vx cA cvv sbcexg cA cvv wcel vw cv vy cv vz cv
      cop wceq wph wa vz wex vx cA wsbc vw cv vy cv vz cv cop wceq wph vx cA
      wsbc wa vz wex vy cA cvv wcel vw cv vy cv vz cv cop wceq wph wa vz wex vx
      cA wsbc vw cv vy cv vz cv cop wceq wph wa vx cA wsbc vz wex vw cv vy cv
      vz cv cop wceq wph vx cA wsbc wa vz wex vw cv vy cv vz cv cop wceq wph wa
      vz vx cA cvv sbcexg cA cvv wcel vw cv vy cv vz cv cop wceq wph wa vx cA
      wsbc vw cv vy cv vz cv cop wceq wph vx cA wsbc wa vz cA cvv wcel vw cv vy
      cv vz cv cop wceq wph wa vx cA wsbc vw cv vy cv vz cv cop wceq vx cA wsbc
      wph vx cA wsbc wa vw cv vy cv vz cv cop wceq wph vx cA wsbc wa vw cv vy
      cv vz cv cop wceq wph vx cA cvv sbcang cA cvv wcel vw cv vy cv vz cv cop
      wceq vx cA wsbc vw cv vy cv vz cv cop wceq wph vx cA wsbc vw cv vy cv vz
      cv cop wceq vx cA cvv vw cv vy cv vz cv cop wceq vx ax-17 sbcgf anbi1d
      bitrd exbidv bitrd exbidv bitrd abbidv eqtrd vw cv vy cv vz cv cop wceq
      wph vx cA wsbc wa vz wex vy wex vw cab wph vx cA wsbc vy vz copab wceq cA
      cvv wcel wph vx cA wsbc vy vz copab vw cv vy cv vz cv cop wceq wph vx cA
      wsbc wa vz wex vy wex vw cab wph vx cA wsbc vy vz vw df-opab eqcomi a1i
      3eqtrd syl $.
      $( [12-Aug-2007] $) $( [6-Aug-2007] $)
  $}

  ${
    $d x z $.  $d y z $.  $d ph z $.  $d ps z $.
    $( Union of two ordered pair class abstractions. $)
    unopab $p |- ( { <. x , y >. | ph } u. { <. x , y >. | ps } ) =
               { <. x , y >. | ( ph \/ ps ) } $=
      vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vz cv vx cv vy cv
      cop wceq wps wa vy wex vx wex vz cab cun vz cv vx cv vy cv cop wceq wph
      wps wo wa vy wex vx wex vz cab wph vx vy copab wps vx vy copab cun wph
      wps wo vx vy copab vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab
      vz cv vx cv vy cv cop wceq wps wa vy wex vx wex vz cab cun vz cv vx cv vy
      cv cop wceq wph wa vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex
      vx wex wo vz cab vz cv vx cv vy cv cop wceq wph wps wo wa vy wex vx wex
      vz cab vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cv vx cv vy cv
      cop wceq wps wa vy wex vx wex vz unab vz cv vx cv vy cv cop wceq wph wa
      vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wex wo vz cv vx
      cv vy cv cop wceq wph wps wo wa vy wex vx wex vz vz cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wex
      wo vz cv vx cv vy cv cop wceq wph wa vy wex vz cv vx cv vy cv cop wceq
      wps wa vy wex wo vx wex vz cv vx cv vy cv cop wceq wph wps wo wa vy wex
      vx wex vz cv vx cv vy cv cop wceq wph wa vy wex vz cv vx cv vy cv cop
      wceq wps wa vy wex vx 19.43 vz cv vx cv vy cv cop wceq wph wa vy wex vz
      cv vx cv vy cv cop wceq wps wa vy wex wo vz cv vx cv vy cv cop wceq wph
      wps wo wa vy wex vx vz cv vx cv vy cv cop wceq wph wps wo wa vy wex vz cv
      vx cv vy cv cop wceq wph wa vz cv vx cv vy cv cop wceq wps wa wo vy wex
      vz cv vx cv vy cv cop wceq wph wa vy wex vz cv vx cv vy cv cop wceq wps
      wa vy wex wo vz cv vx cv vy cv cop wceq wph wps wo wa vz cv vx cv vy cv
      cop wceq wph wa vz cv vx cv vy cv cop wceq wps wa wo vy vz cv vx cv vy cv
      cop wceq wph wps andi exbii vz cv vx cv vy cv cop wceq wph wa vz cv vx cv
      vy cv cop wceq wps wa vy 19.43 bitr2i exbii bitr3i abbii eqtri wph vx vy
      copab vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab wps vx vy
      copab vz cv vx cv vy cv cop wceq wps wa vy wex vx wex vz cab wph vx vy vz
      df-opab wps vx vy vz df-opab uneq12i wph wps wo vx vy vz df-opab 3eqtr4i
      $.
      $( [30-Sep-2002] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Transitive classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare a new symbol. $)
  $c Tr $. $( Transitive predicate (read:  "the following class is
              transitive") $)

  $( Extend wff notation to include transitive classes.  Notation from
     [TakeutiZaring] p. 35. $)
  wtr $a wff Tr A $.

  $( Define the transitive class predicate.  Not to be confused with a
     transitive relation (see ~ cotr ). Definition of [Enderton] p. 71
     extended to arbitrary classes.  For alternate definitions, see ~ dftr2
     (which is suggestive of the word "transitive"), ~ dftr3 , ~ dftr4 ,
     ~ dftr5 , and (when ` A ` is a set) ~ unisuc . The term "complete" is
     used instead of "transitive" in Definition 3 of [Suppes] p. 130.  $)
  df-tr $a |- ( Tr A <-> U. A C_ A ) $.

  ${
    $d x y A $.
    $( An alternate way of defining a transitive class.  Exercise 7 of
       [TakeutiZaring] p. 40. $)
    dftr2 $p |- ( Tr A <-> A. x A. y ( ( x e. y /\ y e. A ) -> x e. A ) ) $=
      cA cuni cA wss vx cv cA cuni wcel vx cv cA wcel wi vx wal cA wtr vx cv vy
      cv wcel vy cv cA wcel wa vx cv cA wcel wi vy wal vx wal vx cA cuni cA
      dfss2 cA df-tr vx cv vy cv wcel vy cv cA wcel wa vx cv cA wcel wi vy wal
      vx cv cA cuni wcel vx cv cA wcel wi vx vx cv vy cv wcel vy cv cA wcel wa
      vx cv cA wcel wi vy wal vx cv vy cv wcel vy cv cA wcel wa vy wex vx cv cA
      wcel wi vx cv cA cuni wcel vx cv cA wcel wi vx cv vy cv wcel vy cv cA
      wcel wa vx cv cA wcel vy 19.23v vx cv cA cuni wcel vx cv vy cv wcel vy cv
      cA wcel wa vy wex vx cv cA wcel vy vx cv cA eluni imbi1i bitr4i albii
      3bitr4i $.
      $( [24-Apr-1994] $)

    $( An alternate way of defining a transitive class. $)
    dftr5 $p |- ( Tr A <-> A. x e. A A. y e. x y e. A ) $=
      cA wtr vy cv vx cv wcel vx cv cA wcel wa vy cv cA wcel wi vx wal vy wal
      vy cv vx cv wcel vx cv cA wcel wa vy cv cA wcel wi vy wal vx wal vy cv cA
      wcel vy vx cv wral vx cA wral vy vx cA dftr2 vy cv vx cv wcel vx cv cA
      wcel wa vy cv cA wcel wi vy vx alcom vy cv vx cv wcel vx cv cA wcel wa vy
      cv cA wcel wi vy wal vx wal vx cv cA wcel vy cv cA wcel vy vx cv wral wi
      vx wal vy cv cA wcel vy vx cv wral vx cA wral vy cv vx cv wcel vx cv cA
      wcel wa vy cv cA wcel wi vy wal vx cv cA wcel vy cv cA wcel vy vx cv wral
      wi vx vy cv vx cv wcel vx cv cA wcel wa vy cv cA wcel wi vy wal vy cv vx
      cv wcel vx cv cA wcel vy cv cA wcel wi wi vy wal vx cv cA wcel vy cv cA
      wcel wi vy vx cv wral vx cv cA wcel vy cv cA wcel vy vx cv wral wi vy cv
      vx cv wcel vx cv cA wcel wa vy cv cA wcel wi vy cv vx cv wcel vx cv cA
      wcel vy cv cA wcel wi wi vy vy cv vx cv wcel vx cv cA wcel vy cv cA wcel
      impexp albii vx cv cA wcel vy cv cA wcel wi vy vx cv df-ral vx cv cA wcel
      vy cv cA wcel vy vx cv r19.21v 3bitr2i albii vy cv cA wcel vy vx cv wral
      vx cA df-ral bitr4i 3bitri $.
      $( [21-Mar-2004] $) $( [20-Mar-2004] $)

    $( An alternate way of defining a transitive class.  Definition 7.1 of
       [TakeutiZaring] p. 35. $)
    dftr3 $p |- ( Tr A <-> A. x e. A x C_ A ) $=
      cA wtr vy cv cA wcel vy vx cv wral vx cA wral vx cv cA wss vx cA wral vx
      vy cA dftr5 vx cv cA wss vy cv cA wcel vy vx cv wral vx cA vy vx cv cA
      dfss3 ralbii bitr4i $.
      $( [29-Aug-1993] $)
  $}

  $( An alternate way of defining a transitive class.  Definition of
     [Enderton] p. 71. $)
  dftr4 $p |- ( Tr A <-> A C_ ~P A ) $=
    cA wtr cA cuni cA wss cA cA cpw wss cA df-tr cA cA sspwuni bitr4i $.
    $( [8-May-2009] $) $( [29-Aug-1993] $)

  $( Equality theorem for the transitive class predicate. $)
  treq $p |- ( A = B -> ( Tr A <-> Tr B ) ) $=
    cA cB wceq cA cuni cA wss cB cuni cB wss cA wtr cB wtr cA cB wceq cA cuni
    cA wss cB cuni cA wss cB cuni cB wss cA cB wceq cA cuni cB cuni cA cA cB
    unieq sseq1d cA cB cB cuni sseq2 bitrd cA df-tr cB df-tr 3bitr4g $.
    $( [17-Sep-1993] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( In a transitive class, the membership relation is transitive. $)
    trel $p |- ( Tr A -> ( ( B e. C /\ C e. A ) -> B e. A ) ) $=
      cA wtr cB cC wcel cC cA wcel cB cA wcel cA wtr cB cC wcel cC cA wcel cB
      cA wcel wi cA wtr vx cv cC wcel cC cA wcel vx cv cA wcel wi wi wi cA wtr
      cB cC wcel cC cA wcel cB cA wcel wi wi wi vx cB cC vx cv cB wceq vx cv cC
      wcel cC cA wcel vx cv cA wcel wi wi cB cC wcel cC cA wcel cB cA wcel wi
      wi cA wtr vx cv cB wceq vx cv cC wcel cB cC wcel cC cA wcel vx cv cA wcel
      wi cC cA wcel cB cA wcel wi vx cv cB cC eleq1 vx cv cB wceq vx cv cA wcel
      cB cA wcel cC cA wcel vx cv cB cA eleq1 imbi2d imbi12d imbi2d cA wtr vx
      cv cC wcel cC cA wcel cC cA wcel vx cv cA wcel wi wi cC cA wcel vx cv cA
      wcel wi cC cA wcel cA wtr vx cv cC wcel cC cA wcel vx cv cA wcel cA wtr
      vx cv vy cv wcel vy cv cA wcel vx cv cA wcel wi wi wi cA wtr vx cv cC
      wcel cC cA wcel vx cv cA wcel wi wi wi vy cC cA vy cv cC wceq vx cv vy cv
      wcel vy cv cA wcel vx cv cA wcel wi wi vx cv cC wcel cC cA wcel vx cv cA
      wcel wi wi cA wtr vy cv cC wceq vx cv vy cv wcel vx cv cC wcel vy cv cA
      wcel vx cv cA wcel wi cC cA wcel vx cv cA wcel wi vy cv cC vx cv eleq2 vy
      cv cC wceq vy cv cA wcel cC cA wcel vx cv cA wcel vy cv cC cA eleq1
      imbi1d imbi12d imbi2d cA wtr vx cv vy cv wcel vy cv cA wcel vx cv cA wcel
      cA wtr vx cv vy cv wcel vy cv cA wcel wa vx cv cA wcel wi vx vy cA wtr vx
      cv vy cv wcel vy cv cA wcel wa vx cv cA wcel wi vy wal vx wal vx vy cA
      dftr2 biimpi 19.21bbi exp3a vtoclg com4l cC cA wcel vx cv cA wcel pm2.43
      syl6 vtoclg pm2.43b imp3a $.
      $( [19-Apr-1994] $)
  $}

  $( In a transitive class, the membership relation is transitive. $)
  trel3 $p |- ( Tr A -> ( ( B e. C /\ C e. D /\ D e. A ) -> B e. A ) ) $=
    cA wtr cB cC wcel cC cD wcel cD cA wcel w3a cB cC wcel cC cA wcel wa cB cA
    wcel cA wtr cB cC wcel cC cD wcel cD cA wcel wa wa cB cC wcel cC cA wcel wa
    cB cC wcel cC cD wcel cD cA wcel w3a cA wtr cC cD wcel cD cA wcel wa cC cA
    wcel cB cC wcel cA cC cD trel anim2d cB cC wcel cC cD wcel cD cA wcel
    3anass syl5ib cA cB cC trel syld $.
    $( [19-Apr-1994] $)

  ${
    $d x A $.  $d x B $.
    $( An element of a transitive class is a subset of the class. $)
    trss $p |- ( Tr A -> ( B e. A -> B C_ A ) ) $=
      cA wtr cB cA wcel cB cA wss cA wtr vx cv cA wcel vx cv cA wss wi wi cA
      wtr cB cA wcel cB cA wss wi wi vx cB cA vx cv cB wceq vx cv cA wcel vx cv
      cA wss wi cB cA wcel cB cA wss wi cA wtr vx cv cB wceq vx cv cA wcel cB
      cA wcel vx cv cA wss cB cA wss vx cv cB cA eleq1 vx cv cB cA sseq1
      imbi12d imbi2d cA wtr vx cv cA wss vx cA wral vx cv cA wcel vx cv cA wss
      wi vx cA dftr3 vx cv cA wss vx cA ra4 sylbi vtoclg pm2.43b $.
      $( [7-Aug-1994] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The intersection of transitive classes is transitive. $)
    trin $p |- ( ( Tr A /\ Tr B ) -> Tr ( A i^i B ) ) $=
      cA wtr cB wtr wa vx cv cA cB cin wss vx cA cB cin wral cA cB cin wtr cA
      wtr cB wtr wa vx cv cA cB cin wss vx cA cB cin cA wtr cB wtr wa vx cv cA
      cB cin wcel vx cv cA wss vx cv cB wss wa vx cv cA cB cin wss cA wtr cB
      wtr wa vx cv cA wcel vx cv cB wcel wa vx cv cA wss vx cv cB wss wa vx cv
      cA cB cin wcel cA wtr vx cv cA wcel vx cv cA wss cB wtr vx cv cB wcel vx
      cv cB wss cA vx cv trss cB vx cv trss im2anan9 vx cv cA cB elin syl5ib vx
      cv cA cB ssin syl6ib r19.21aiv vx cA cB cin dftr3 sylibr $.
      $( [9-May-1994] $)
  $}

  $( The empty set is transitive. $)
  tr0 $p |- Tr (/) $=
    c0 wtr c0 c0 cpw wss c0 cpw 0ss c0 dftr4 mpbir $.
    $( [16-Sep-1993] $)

  $( The universe is transitive. $)
  trv $p |- Tr _V $=
    cvv wtr cvv cuni cvv wss cvv cuni ssv cvv df-tr mpbir $.
    $( [14-Sep-2003] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Replacement
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Introduce the Axiom of Replacement
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.
    $( Axiom of Replacement.  An axiom scheme of Zermelo-Fraenkel set theory.
       Axiom 5 of [TakeutiZaring] p. 19.  It tells us that that the image of
       any set under a function is also a set (see the variant ~ funimaex ).
       Although ` ph ` may be any wff whatsoever, this axiom is useful (i.e.
       its antecedent is satisfied) when we are given some function and ` ph `
       encodes the predicate "the value of the function at ` w ` is ` z ` ".
       Thus ` ph ` will ordinarily have free variables ` w ` and ` z ` - think
       of it informally as ` ph ( w , z ) ` .  We prefix ` ph ` with the
       quantifier ` A. y ` in order to "protect" the axiom from any ` ph `
       containing ` y ` , thus allowing us to eliminate any restrictions on
       ` ph ` .  This makes the axiom usable in a formalization that omits the
       logically redundant axiom ~ ax-17 .  Another common variant is derived
       as ~ axrep5 , where you can find some further remarks.  A slightly more
       compact version is shown as ~ axrep2 .  A quite different variant is
       ~ zfrep6 , which if used in place of ~ ax-rep would also require that
       the Separation Scheme ~ axsep be stated as a separate axiom.

       There is very a strong generalization of Replacement that doesn't demand
       function-like behavior of ` ph ` .  Two versions of this generalization
       are called the Collection Principle ~ cp and the Boundedness Axiom
        ~ bnd .

       Many developments of set theory distinguish the uses of Replacement from
       uses the weaker axioms of Separation ~ axsep , Null Set ~ axnul , and
       Pairing ~ axpr , all of which we derive from Replacement.  In order to
       make it easier to identify the uses of those redundant axioms, we
       restate them as axioms ~ ax-sep , ~ ax-nul , and ~ ax-pr below the
       theorems that prove them. $)
    ax-rep $a |- ( A. w E. y A. z ( A. y ph -> z = y ) ->
                     E. y A. z ( z e. y <-> E. w ( w e. x /\ A. y ph ) ) ) $.
  $}

  ${
    $d w y ph $.  $d w x y z $.
    $( The version of the Axiom of Replacement used in the Metamath Solitaire
       applet ~ http://us.metamath.org/mmsolitaire/mms.html .
       Equivalence is shown via the path ~ ax-rep ` -> ` ~ axrep1 ` -> `
       ~ axrep2 ` -> ` ~ axrepnd ` -> ` ~ zfcndrep = ~ ax-rep . $)
    axrep1 $p |- E. x ( E. y A. z ( ph -> z = y ) ->
                 A. z ( z e. x <-> E. x ( x e. y /\ ph ) ) ) $=
      wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv wcel
      wph vy wal wa vx wex wb vz wal wi vx wex wph vz cv vy cv wceq wi vz wal
      vy wex vz cv vx cv wcel vx cv vy cv wcel wph wa vx wex wb vz wal wi vx
      wex wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv
      wcel wph vy wal wa vx wex wb vz wal vx wph vz cv vy cv wceq wi vz wal vy
      wex vx wal vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz
      wal vx wex wi wph vz cv vy cv wceq wi vz wal vy wex vx wal vz cv vx cv
      wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal vx wex wi vw vy vw
      cv vy cv wceq vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb
      vz wal vx wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb
      vz wal vx wex wph vz cv vy cv wceq wi vz wal vy wex vx wal vw cv vy cv
      wceq vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal vz
      cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal vx vw cv vy
      cv wceq vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz cv
      vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz vw cv vy cv wceq
      vx cv vw cv wcel wph vy wal wa vx wex vx cv vy cv wcel wph vy wal wa vx
      wex vz cv vx cv wcel vw cv vy cv wceq vx cv vw cv wcel wph vy wal wa vx
      cv vy cv wcel wph vy wal wa vx vw cv vy cv wceq vx cv vw cv wcel vx cv vy
      cv wcel wph vy wal vw vy vx elequ2 anbi1d exbidv bibi2d albidv exbidv
      imbi2d wph vz cv vy cv wceq wi vz wal vy wex vx wal vz cv vy cv wcel vx
      cv vw cv wcel wph vy wal wa vx wex wb vz wal vy wex vz cv vx cv wcel vx
      cv vw cv wcel wph vy wal wa vx wex wb vz wal vx wex wph vz cv vy cv wceq
      wi vz wal vy wex vx wal wph vy wal vz cv vy cv wceq wi vz wal vy wex vx
      wal vz cv vy cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal vy
      wex wph vz cv vy cv wceq wi vz wal vy wex wph vy wal vz cv vy cv wceq wi
      vz wal vy wex vx wph vz cv vy cv wceq wi vz wal wph vy wal vz cv vy cv
      wceq wi vz wal vy wph vz cv vy cv wceq wi wph vy wal vz cv vy cv wceq wi
      vz wph vy wal wph vz cv vy cv wceq wph vy ax-4 imim1i 19.20i 19.22i
      19.20i wph vw vy vz vx ax-rep syl vz cv vy cv wcel vx cv vw cv wcel wph
      vy wal wa vx wex wb vz wal vz cv vx cv wcel vx cv vw cv wcel wph vy wal
      wa vx wex wb vz wal vy vx vz cv vy cv wcel vx cv vw cv wcel wph vy wal wa
      vx wex wb vx vz vz cv vy cv wcel vx cv vw cv wcel wph vy wal wa vx wex vx
      vz cv vy cv wcel vx ax-17 vx cv vw cv wcel wph vy wal wa vx hbe1 hbbi
      hbal vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vy vz vz
      cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex vy vz cv vx cv wcel
      vy ax-17 vx cv vw cv wcel wph vy wal wa vy vx vx cv vw cv wcel wph vy wal
      vy vx cv vw cv wcel vy ax-17 wph vy hba1 hban hbex hbbi hbal vy cv vx cv
      wceq vz cv vy cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz cv vx
      cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz vy cv vx cv wceq vz
      cv vy cv wcel vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex vy
      vx vz elequ2 bibi1d albidv cbvex sylib chvarv 19.35ri wph vz cv vy cv
      wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx
      wex wb vz wal wi wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel
      vx cv vy cv wcel wph wa vx wex wb vz wal wi vx vz cv vx cv wcel vx cv vy
      cv wcel wph vy wal wa vx wex wb vz wal vz cv vx cv wcel vx cv vy cv wcel
      wph wa vx wex wb vz wal wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv
      wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz cv vx cv wcel vx cv vy
      cv wcel wph wa vx wex wb vz vx cv vy cv wcel wph vy wal wa vx wex vx cv
      vy cv wcel wph wa vx wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa
      vx cv vy cv wcel wph wa vx wph vy wal wph vx cv vy cv wcel wph vy wph vy
      ax-17 19.3 anbi2i exbii bibi2i albii imbi2i exbii mpbi $.
      $( [21-Nov-2005] $) $( [19-Nov-2005] $)
  $}

  ${
    $d w ph $.  $d w x y z $.
    $( Axiom of Replacement expressed with the fewest number of different
       variables and without any restrictions on ` ph ` . $)
    axrep2 $p |- E. x ( E. y A. z ( ph -> z = y ) ->
                        A. z ( z e. x <-> E. x ( x e. y /\ A. y ph ) ) ) $=
      wph vy wal vz cv vw cv wceq wi vz wal vw wex vz cv vx cv wcel vx cv vy cv
      wcel wph vy wal wa vx wex wb vz wal wi vx wex wph vz cv vy cv wceq wi vz
      wal vy wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz
      wal wi vx wex wph vy wal vz cv vw cv wceq wi vz wal vw wex vz cv vx cv
      wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal wi vx wex wph vy wal
      vz cv vw cv wceq wi vz wal vw wex vz cv vx cv wcel vx cv vy cv wcel wph
      vy wal wa vx wex wb vz wal wi vx wex vw vy wph vy wal vz cv vw cv wceq wi
      vz wal vw wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb
      vz wal wi vw vx wph vy wal vz cv vw cv wceq wi vz wal vw wex vz cv vx cv
      wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal vw wph vy wal vz cv
      vw cv wceq wi vz wal vw hbe1 vz cv vx cv wcel vx cv vy cv wcel wph vy wal
      wa vx wex wb vz wal vw ax-17 hbim hbex vw cv vy cv wceq wph vy wal vz cv
      vw cv wceq wi vz wal vw wex vz cv vx cv wcel vx cv vw cv wcel wph vy wal
      wa vx wex wb vz wal wi wph vy wal vz cv vw cv wceq wi vz wal vw wex vz cv
      vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi vx vw cv vy
      cv wceq vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal
      vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wph vy
      wal vz cv vw cv wceq wi vz wal vw wex vw cv vy cv wceq vz cv vx cv wcel
      vx cv vw cv wcel wph vy wal wa vx wex wb vz cv vx cv wcel vx cv vy cv
      wcel wph vy wal wa vx wex wb vz vw cv vy cv wceq vx cv vw cv wcel wph vy
      wal wa vx wex vx cv vy cv wcel wph vy wal wa vx wex vz cv vx cv wcel vw
      cv vy cv wceq vx cv vw cv wcel wph vy wal wa vx cv vy cv wcel wph vy wal
      wa vx vw cv vy cv wceq vx cv vw cv wcel vx cv vy cv wcel wph vy wal vw vy
      vx elequ2 anbi1d exbidv bibi2d albidv imbi2d exbidv wph vy wal vx vw vz
      axrep1 chvar wph vy wal vz cv vw cv wceq wi vz wal vw wex vz cv vx cv
      wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi wph vz cv vy cv
      wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx
      wex wb vz wal wi vx wph vz cv vy cv wceq wi vz wal vy wex wph vy wal vz
      cv vw cv wceq wi vz wal vw wex vz cv vx cv wcel vx cv vy cv wcel wph vy
      wal wa vx wex wb vz wal wph vz cv vy cv wceq wi vz wal vy wex wph vy wal
      vz cv vy cv wceq wi vz wal vy wex wph vy wal vz cv vw cv wceq wi vz wal
      vw wex wph vz cv vy cv wceq wi vz wal wph vy wal vz cv vy cv wceq wi vz
      wal vy wph vz cv vy cv wceq wi wph vy wal vz cv vy cv wceq wi vz wph vy
      wal wph vz cv vy cv wceq wph vy ax-4 imim1i 19.20i 19.22i wph vy wal vz
      cv vy cv wceq wi vz wal wph vy wal vz cv vw cv wceq wi vz wal vy vw wph
      vy wal vz cv vy cv wceq wi vz wal vw ax-17 wph vy wal vz cv vw cv wceq wi
      vy vz wph vy wal vz cv vw cv wceq vy wph vy hba1 vz cv vw cv wceq vy
      ax-17 hbim hbal vy cv vw cv wceq wph vy wal vz cv vy cv wceq wi wph vy
      wal vz cv vw cv wceq wi vz vy cv vw cv wceq vz cv vy cv wceq vz cv vw cv
      wceq wph vy wal vy vw vz equequ2 imbi2d albidv cbvex sylib imim1i 19.22i
      ax-mp $.
      $( [15-Aug-2003] $)
  $}

  ${
    $d w x y z $.
    $( Axiom of Replacement slightly strengthened from ~ axrep2 ; ` w ` may
       occur free in ` ph ` . $)
    axrep3 $p |- E. x ( E. y A. z ( ph -> z = y ) ->
                 A. z ( z e. x <-> E. x ( x e. w /\ A. y ph ) ) ) $=
      wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv wcel
      wph vy wal wa vx wex wb vz wal wi vx wex wph vz cv vy cv wceq wi vz wal
      vy wex vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal
      wi vx wex vy vw wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx
      cv vw cv wcel wph vy wal wa vx wex wb vz wal wi vy vx wph vz cv vy cv
      wceq wi vz wal vy wex vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx
      wex wb vz wal vy wph vz cv vy cv wceq wi vz wal vy hbe1 vz cv vx cv wcel
      vx cv vw cv wcel wph vy wal wa vx wex wb vy vz vz cv vx cv wcel vx cv vw
      cv wcel wph vy wal wa vx wex vy vz cv vx cv wcel vy ax-17 vx cv vw cv
      wcel wph vy wal wa vy vx vx cv vw cv wcel wph vy wal vy vx cv vw cv wcel
      vy ax-17 wph vy hba1 hban hbex hbbi hbal hbim hbex vy cv vw cv wceq wph
      vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv wcel wph
      vy wal wa vx wex wb vz wal wi wph vz cv vy cv wceq wi vz wal vy wex vz cv
      vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal wi vx vy cv vw
      cv wceq vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal
      vz cv vx cv wcel vx cv vw cv wcel wph vy wal wa vx wex wb vz wal wph vz
      cv vy cv wceq wi vz wal vy wex vy cv vw cv wceq vz cv vx cv wcel vx cv vy
      cv wcel wph vy wal wa vx wex wb vz cv vx cv wcel vx cv vw cv wcel wph vy
      wal wa vx wex wb vz vy cv vw cv wceq vx cv vy cv wcel wph vy wal wa vx
      wex vx cv vw cv wcel wph vy wal wa vx wex vz cv vx cv wcel vy cv vw cv
      wceq vx cv vy cv wcel wph vy wal wa vx cv vw cv wcel wph vy wal wa vx vy
      cv vw cv wceq vx cv vy cv wcel vx cv vw cv wcel wph vy wal vy vw vx
      elequ2 anbi1d exbidv bibi2d albidv imbi2d exbidv wph vx vy vz axrep2
      chvar $.
      $( [2-Jan-1997] $)
  $}

  ${
    $d x y z w $.
    axrep4.1 $e |- ( ph -> A. z ph ) $.
    $( A more traditional version of the Axiom of Replacement. $)
    axrep4 $p |- ( A. x E. z A. y ( ph -> y = z ) ->
                E. z A. y ( y e. z <-> E. x ( x e. w /\ ph ) ) ) $=
      wph vy cv vz cv wceq wi vy wal vz wex vx wal vy cv vx cv wcel vx cv vw cv
      wcel wph vz wal wa vx wex wb vy wal vx wex vy cv vz cv wcel vx cv vw cv
      wcel wph wa vx wex wb vy wal vz wex wph vy cv vz cv wceq wi vy wal vz wex
      vy cv vx cv wcel vx cv vw cv wcel wph vz wal wa vx wex wb vy wal vx wph
      vx vz vy vw axrep3 19.35i vy cv vx cv wcel vx cv vw cv wcel wph vz wal wa
      vx wex wb vy wal vy cv vz cv wcel vx cv vw cv wcel wph wa vx wex wb vy
      wal vx vz vy cv vx cv wcel vx cv vw cv wcel wph vz wal wa vx wex wb vz vy
      vy cv vx cv wcel vx cv vw cv wcel wph vz wal wa vx wex vz vy cv vx cv
      wcel vz ax-17 vx cv vw cv wcel wph vz wal wa vz vx vx cv vw cv wcel wph
      vz wal vz vx cv vw cv wcel vz ax-17 wph vz hba1 hban hbex hbbi hbal vy cv
      vz cv wcel vx cv vw cv wcel wph wa vx wex wb vx vy vy cv vz cv wcel vx cv
      vw cv wcel wph wa vx wex vx vy cv vz cv wcel vx ax-17 vx cv vw cv wcel
      wph wa vx hbe1 hbbi hbal vx cv vz cv wceq vy cv vx cv wcel vx cv vw cv
      wcel wph vz wal wa vx wex wb vy cv vz cv wcel vx cv vw cv wcel wph wa vx
      wex wb vy vx cv vz cv wceq vy ax-17 vx cv vz cv wceq vy cv vx cv wcel vy
      cv vz cv wcel vx cv vw cv wcel wph vz wal wa vx wex vx cv vw cv wcel wph
      wa vx wex vx vz vy elequ2 vx cv vw cv wcel wph vz wal wa vx wex vx cv vw
      cv wcel wph wa vx wex wb vx cv vz cv wceq vx cv vw cv wcel wph vz wal wa
      vx cv vw cv wcel wph wa vx wph vz wal wph vx cv vw cv wcel wph vz
      axrep4.1 19.3 anbi2i exbii a1i bibi12d albid cbvex sylib $.
      $( [14-Aug-1994] $)
  $}

  ${
    $d x y z w $.
    axrep5.1 $e |- ( ph -> A. z ph ) $.
    $( Axiom of Replacement (similar to Axiom Rep of [BellMachover] p. 463).
       The antecedent tells us ` ph ` is analogous to a "function" from ` x `
       to ` y ` (although it is not really a function since it is a wff and not
       a class).  In the consequent we postulate the existence of a set ` z `
       that corresponds to the "image" of ` ph ` restricted to some other set
       ` w ` .  The hypothesis says ` z ` must not be free in ` ph ` . $)
    axrep5 $p |- ( A. x ( x e. w -> E. z A. y ( ph -> y = z ) ) ->
                E. z A. y ( y e. z <-> E. x ( x e. w /\ ph ) ) ) $=
      vx cv vw cv wcel wph vy cv vz cv wceq wi vy wal vz wex wi vx wal vy cv vz
      cv wcel vx cv vw cv wcel vx cv vw cv wcel wph wa wa vx wex wb vy wal vz
      wex vy cv vz cv wcel vx cv vw cv wcel wph wa vx wex wb vy wal vz wex vx
      cv vw cv wcel wph vy cv vz cv wceq wi vy wal vz wex wi vx wal vx cv vw cv
      wcel wph wa vy cv vz cv wceq wi vy wal vz wex vx wal vy cv vz cv wcel vx
      cv vw cv wcel vx cv vw cv wcel wph wa wa vx wex wb vy wal vz wex vx cv vw
      cv wcel wph vy cv vz cv wceq wi vy wal vz wex wi vx cv vw cv wcel wph wa
      vy cv vz cv wceq wi vy wal vz wex vx vx cv vw cv wcel wph vy cv vz cv
      wceq wi vy wal vz wex wi vx cv vw cv wcel wph vy cv vz cv wceq wi vy wal
      wi vz wex vx cv vw cv wcel wph wa vy cv vz cv wceq wi vy wal vz wex vx cv
      vw cv wcel wph vy cv vz cv wceq wi vy wal vz 19.37v vx cv vw cv wcel wph
      vy cv vz cv wceq wi vy wal wi vx cv vw cv wcel wph wa vy cv vz cv wceq wi
      vy wal vz vx cv vw cv wcel wph wa vy cv vz cv wceq wi vy wal vx cv vw cv
      wcel wph vy cv vz cv wceq wi wi vy wal vx cv vw cv wcel wph vy cv vz cv
      wceq wi vy wal wi vx cv vw cv wcel wph wa vy cv vz cv wceq wi vx cv vw cv
      wcel wph vy cv vz cv wceq wi wi vy vx cv vw cv wcel wph vy cv vz cv wceq
      impexp albii vx cv vw cv wcel wph vy cv vz cv wceq wi vy 19.21v bitr2i
      exbii bitr3i albii vx cv vw cv wcel wph wa vx vy vz vw vx cv vw cv wcel
      wph vz vx cv vw cv wcel vz ax-17 axrep5.1 hban axrep4 sylbi vy cv vz cv
      wcel vx cv vw cv wcel vx cv vw cv wcel wph wa wa vx wex wb vy wal vy cv
      vz cv wcel vx cv vw cv wcel wph wa vx wex wb vy wal vz vy cv vz cv wcel
      vx cv vw cv wcel vx cv vw cv wcel wph wa wa vx wex wb vy cv vz cv wcel vx
      cv vw cv wcel wph wa vx wex wb vy vx cv vw cv wcel vx cv vw cv wcel wph
      wa wa vx wex vx cv vw cv wcel wph wa vx wex vy cv vz cv wcel vx cv vw cv
      wcel vx cv vw cv wcel wph wa wa vx cv vw cv wcel wph wa vx vx cv vw cv
      wcel wph anabs5 exbii bibi2i albii exbii sylib $.
      $( [26-Nov-1995] $)
  $}

  ${
    $d y z A v $.  $d z ph v $.  $d A w v $.  $d x y z v $.  $d x w v $.

    zfrepclf.1 $e |- ( w e. A -> A. x w e. A ) $.
    zfrepclf.2 $e |- A e. _V $.
    zfrepclf.3 $e |- ( x e. A -> E. z A. y ( ph -> y = z ) ) $.
    $( An inference rule based on the Axiom of Replacement.
       Typically, ` ph ` defines a function from ` x ` to ` y ` . $)
    zfrepclf $p |- E. z A. y ( y e. z <-> E. x ( x e. A /\ ph ) ) $=
      vy cv vz cv wcel vx cv cA wcel wph wa vx wex wb vy wal vz wex vv cA
      zfrepclf.2 vv cv cA wceq vy cv vz cv wcel vx cv vv cv wcel wph wa vx wex
      wb vy wal vz wex vy cv vz cv wcel vx cv cA wcel wph wa vx wex wb vy wal
      vz wex vv cv cA wceq vx cv vv cv wcel wph vy cv vz cv wceq wi vy wal vz
      wex wi vx wal vy cv vz cv wcel vx cv vv cv wcel wph wa vx wex wb vy wal
      vz wex vv cv cA wceq vx cv vv cv wcel wph vy cv vz cv wceq wi vy wal vz
      wex wi vx vx vw vw vv cv cA vw cv vv cv wcel vx ax-17 zfrepclf.1 hbeq vv
      cv cA wceq vx cv vv cv wcel vx cv cA wcel wph vy cv vz cv wceq wi vy wal
      vz wex vv cv cA vx cv eleq2 zfrepclf.3 syl6bi 19.21ai wph vx vy vz vv wph
      vz ax-17 axrep5 syl vv cv cA wceq vy cv vz cv wcel vx cv vv cv wcel wph
      wa vx wex wb vy wal vy cv vz cv wcel vx cv cA wcel wph wa vx wex wb vy
      wal vz vv cv cA wceq vy cv vz cv wcel vx cv vv cv wcel wph wa vx wex wb
      vy cv vz cv wcel vx cv cA wcel wph wa vx wex wb vy vv cv cA wceq vx cv vv
      cv wcel wph wa vx wex vx cv cA wcel wph wa vx wex vy cv vz cv wcel vv cv
      cA wceq vx cv vv cv wcel wph wa vx cv cA wcel wph wa vx vx vw vw vv cv cA
      vw cv vv cv wcel vx ax-17 zfrepclf.1 hbeq vv cv cA wceq vx cv vv cv wcel
      vx cv cA wcel wph vv cv cA vx cv eleq2 anbi1d exbid bibi2d albidv exbidv
      mpbid vtocle $.
      $( [26-Nov-1995] $)
  $}

  ${
    $d x y z A $.  $d z ph $.
    zfrep3cl.1 $e |- A e. _V $.
    zfrep3cl.2 $e |- ( x e. A -> E. z A. y ( ph -> y = z ) ) $.
    $( An inference rule based on the Axiom of Replacement.
       Typically, ` ph ` defines a function from ` x ` to ` y ` . $)
    zfrep3cl $p |- E. z A. y ( y e. z <-> E. x ( x e. A /\ ph ) ) $=
      wph vx vy vz vy cA vy cv cA wcel vx ax-17 zfrep3cl.1 zfrep3cl.2 zfrepclf
      $.
      $( [26-Nov-1995] $)
  $}

  ${
    $d ph y z $.  $d ps z $.  $d x y z $.
    zfrep4.1 $e |- { x | ph } e. _V $.
    zfrep4.2 $e |- ( ph -> E. z A. y ( ps -> y = z ) ) $.
    $( A version of Replacement using class abstractions. $)
    zfrep4 $p |- { y | E. x ( ph /\ ps ) } e. _V $=
      vx cv wph vx cab wcel wps wa vx wex vy cab wph wps wa vx wex vy cab cvv
      vx cv wph vx cab wcel wps wa vx wex wph wps wa vx wex vy vx cv wph vx cab
      wcel wps wa wph wps wa vx vx cv wph vx cab wcel wph wps wph vx abid
      anbi1i exbii abbii vz vx cv wph vx cab wcel wps wa vx wex vy cab vz cv vx
      cv wph vx cab wcel wps wa vx wex vy cab wceq vz wex vy cv vz cv wcel vx
      cv wph vx cab wcel wps wa vx wex wb vy wal vz wex wps vx vy vz vy wph vx
      cab wph vx vy hbab1 zfrep4.1 vx cv wph vx cab wcel wph wps vy cv vz cv
      wceq wi vy wal vz wex wph vx abid zfrep4.2 sylbi zfrepclf vz cv vx cv wph
      vx cab wcel wps wa vx wex vy cab wceq vy cv vz cv wcel vx cv wph vx cab
      wcel wps wa vx wex wb vy wal vz vx cv wph vx cab wcel wps wa vx wex vy vz
      cv abeq2 exbii mpbir issetri eqeltrri $.
      $( [26-Nov-1995] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Derive the Axiom of Separation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.  $d y z ph w $.
    $( Separation Scheme, which is an axiom scheme of Zermelo's original
       theory.  Scheme Sep of [BellMachover] p. 463.  As we show here, it is
       redundant if we assume Replacement in the form of ~ ax-rep .  Some
       textbooks present Separation as a separate axiom scheme in order to show
       that much of set theory can be derived without the stronger Replacement.
       The Separation Scheme is a weak form of Frege's Axiom of Comprehension,
       conditioning it (with ` x e. z ` ) so that it asserts the existence of a
       collection only if it is smaller than some other collection ` z ` that
       already exists.  This prevents Russell's paradox ~ ru .  In some texts,
       this scheme is called "Aussonderung" or the Subset Axiom.

       The variable ` x ` can appear free in the wff ` ph ` , which in
       textbooks is often written ` ph ( x ) ` .  To specify this in the
       Metamath language, we _omit_ the distinct variable requirement ($d) that
       ` x ` not appear in ` ph ` .

       For a version using a class variable, see ~ zfauscl , which requires
       the Axiom of Extensionality as well as Replacement for its derivation.

       If we omit the requirement that ` y ` not occur in ` ph ` , we can
       derive a contradiction, as ~ notzfaus shows (contradicting ~ zfauscl ).
       However, as ~ axsep2 shows, we can eliminate the restriction that ` z `
       not occur in ` ph ` .

       Note:  the distinct variable restriction  that ` z ` not occur in
       ` ph ` is actually redundant in this particular proof, but we keep
       it since its purpose is to demonstrate the derivation of the exact
       ~ ax-sep from ~ ax-rep .

       This theorem should not be referenced by any proof.  Instead, use
       ~ ax-sep below so that the uses of the Axiom of Separation can be more
       easily identified. $)
    axsep $p |- E. y A. x ( x e. y <-> ( x e. z /\ ph ) ) $=
      vx cv vy cv wcel vw cv vz cv wcel vw cv vx cv wceq wph wa wa vw wex wb vx
      wal vy wex vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx wal vy wex vw
      cv vz cv wcel vw cv vx cv wceq wph wa vx cv vy cv wceq wi vx wal vy wex
      wi vx cv vy cv wcel vw cv vz cv wcel vw cv vx cv wceq wph wa wa vw wex wb
      vx wal vy wex vw vw cv vx cv wceq wph wa vw vx vy vz vw cv vx cv wceq wph
      wa vy ax-17 axrep5 vw cv vx cv wceq wph wa vx cv vy cv wceq wi vx wal vy
      wex vw cv vz cv wcel vy cv vw cv wceq vy wex vw cv vx cv wceq wph wa vx
      cv vy cv wceq wi vx wal vy wex vy vw a9e vy cv vw cv wceq vw cv vx cv
      wceq wph wa vx cv vy cv wceq wi vx wal vy vy cv vw cv wceq vw cv vx cv
      wceq wph wa vx cv vy cv wceq wi vx vy cv vw cv wceq vw cv vx cv wceq vx
      cv vy cv wceq wph vy cv vw cv wceq vw cv vx cv wceq vy cv vx cv wceq vx
      cv vy cv wceq vy vw vx equtr vy vx equcomi syl6 adantrd 19.21aiv 19.22i
      ax-mp a1i mpg vx cv vy cv wcel vw cv vz cv wcel vw cv vx cv wceq wph wa
      wa vw wex wb vx wal vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx wal vy
      vx cv vy cv wcel vw cv vz cv wcel vw cv vx cv wceq wph wa wa vw wex wb vx
      cv vy cv wcel vx cv vz cv wcel wph wa wb vx vw cv vz cv wcel vw cv vx cv
      wceq wph wa wa vw wex vx cv vz cv wcel wph wa vx cv vy cv wcel vw cv vz
      cv wcel vw cv vx cv wceq wph wa wa vw wex vw cv vx cv wceq vw cv vz cv
      wcel wph wa wa vw wex vx cv vz cv wcel wph wa vw cv vx cv wceq vw cv vz
      cv wcel wph wa wa vw cv vz cv wcel vw cv vx cv wceq wph wa wa vw vw cv vx
      cv wceq vw cv vz cv wcel wph an12 exbii vw cv vz cv wcel wph wa vx cv vz
      cv wcel wph wa vw vx vx cv vz cv wcel wph wa vw ax-17 vw cv vx cv wceq vw
      cv vz cv wcel vx cv vz cv wcel wph vw vx vz elequ1 anbi1d equsex bitr3i
      bibi2i albii exbii mpbi $.
      $( [12-Sep-2006] $) $( [11-Sep-2006] $)

    $( The Axiom of Separation of ZF set theory.  It was derived as ~ axsep
       above and is therefore redundant, but we state it as a separate axiom
       here so that its uses can be identified more easily. $)
    ax-sep $a |- E. y A. x ( x e. y <-> ( x e. z /\ ph ) ) $.
  $}

  ${
    $d x y z w $.  $d y ph w $.  $d z w $.
    $( A less restrictive version of the Separation Scheme ~ axsep , where
       variables ` x ` and ` z ` can both appear free in the wff ` ph ` , which
       can therefore be thought of as ` ph ( x , z ) ` .  This version was
       derived from the more restrictive ~ ax-sep with no additional set
       theory axioms. $)
    axsep2 $p |- E. y A. x ( x e. y <-> ( x e. z /\ ph ) ) $=
      vw cv vz cv wceq vw wex vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx
      wal vy wex vw vz a9e vw cv vz cv wceq vx cv vy cv wcel vx cv vz cv wcel
      wph wa wb vx wal vy wex vw vw cv vz cv wceq vx cv vy cv wcel vx cv vz cv
      wcel wph wa wb vx wal vy wex vx cv vy cv wcel vx cv vw cv wcel vx cv vz
      cv wcel wph wa wa wb vx wal vy wex vx cv vz cv wcel wph wa vx vy vw
      ax-sep vw cv vz cv wceq vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx
      wal vx cv vy cv wcel vx cv vw cv wcel vx cv vz cv wcel wph wa wa wb vx
      wal vy vw cv vz cv wceq vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx cv
      vy cv wcel vx cv vw cv wcel vx cv vz cv wcel wph wa wa wb vx vw cv vz cv
      wceq vx cv vz cv wcel wph wa vx cv vw cv wcel vx cv vz cv wcel wph wa wa
      vx cv vy cv wcel vw cv vz cv wceq vx cv vz cv wcel wph wa vx cv vw cv
      wcel vx cv vz cv wcel wa wph wa vx cv vw cv wcel vx cv vz cv wcel wph wa
      wa vw cv vz cv wceq vx cv vz cv wcel vx cv vw cv wcel vx cv vz cv wcel wa
      wph vw cv vz cv wceq vx cv vz cv wcel vx cv vw cv wcel vw cv vz cv wceq
      vx cv vw cv wcel vx cv vz cv wcel vw vz vx elequ2 biimprd pm4.71rd anbi1d
      vx cv vw cv wcel vx cv vz cv wcel wph anass syl6bb bibi2d albidv exbidv
      mpbiri 19.23aiv ax-mp $.
      $( [11-Dec-2006] $) $( [10-Dec-2006] $)
  $}

  ${
    $d x y A z $.  $d y ph z $.
    zfauscl.1 $e |- A e. _V $.
    $( Separation Scheme using a class variable.  To derive this from
       ~ ax-sep , we invoke the Axiom of Extensionality (indirectly via
       ~ vtocl ), which is needed for the justification of class variable
       notation.

       If we omit the requirement that ` y ` not occur in ` ph ` , we can
       derive a contradiction, as ~ notzfaus shows. $)
    zfauscl $p |- E. y A. x ( x e. y <-> ( x e. A /\ ph ) ) $=
      vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx wal vy wex vx cv vy cv
      wcel vx cv cA wcel wph wa wb vx wal vy wex vz cA zfauscl.1 vz cv cA wceq
      vx cv vy cv wcel vx cv vz cv wcel wph wa wb vx wal vx cv vy cv wcel vx cv
      cA wcel wph wa wb vx wal vy vz cv cA wceq vx cv vy cv wcel vx cv vz cv
      wcel wph wa wb vx cv vy cv wcel vx cv cA wcel wph wa wb vx vz cv cA wceq
      vx cv vz cv wcel wph wa vx cv cA wcel wph wa vx cv vy cv wcel vz cv cA
      wceq vx cv vz cv wcel vx cv cA wcel wph vz cv cA vx cv eleq2 anbi1d
      bibi2d albidv exbidv wph vx vy vz ax-sep vtocl $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x ph z $.  $d x y z $.
    bm1.3ii.1 $e |- E. x A. y ( ph -> y e. x ) $.
    $( Convert implication to equivalence using Aussonderung.  Similar to
       Theorem 1.3ii of [BellMachover] p. 463. $)
    bm1.3ii $p |- E. x A. y ( y e. x <-> ph ) $=
      wph vy cv vz cv wcel wi vy wal vy cv vx cv wcel vy cv vz cv wcel wph wa
      wb vy wal vx wex wa vz wex vy cv vx cv wcel wph wb vy wal vx wex wph vy
      cv vz cv wcel wi vy wal vy cv vx cv wcel vy cv vz cv wcel wph wa wb vy
      wal vx wex vz wph vy cv vz cv wcel wi vy wal vz wex vy cv vx cv wcel vy
      cv vz cv wcel wph wa wb vy wal vx wex wph vy cv vx cv wcel wi vy wal vx
      wex wph vy cv vz cv wcel wi vy wal vz wex bm1.3ii.1 wph vy cv vx cv wcel
      wi vy wal wph vy cv vz cv wcel wi vy wal vx vz vx cv vz cv wceq wph vy cv
      vx cv wcel wi wph vy cv vz cv wcel wi vy vx cv vz cv wceq vy cv vx cv
      wcel vy cv vz cv wcel wph vx vz vy elequ2 imbi2d albidv cbvexv mpbi wph
      vy vx vz ax-sep pm3.2i exan wph vy cv vz cv wcel wi vy wal vy cv vx cv
      wcel vy cv vz cv wcel wph wa wb vy wal vx wex wa vy cv vx cv wcel wph wb
      vy wal vx wex vz wph vy cv vz cv wcel wi vy wal vy cv vx cv wcel vy cv vz
      cv wcel wph wa wb vy wal vx wex wa wph vy cv vz cv wcel wi vy wal vy cv
      vx cv wcel vy cv vz cv wcel wph wa wb vy wal wa vx wex vy cv vx cv wcel
      wph wb vy wal vx wex wph vy cv vz cv wcel wi vy wal vy cv vx cv wcel vy
      cv vz cv wcel wph wa wb vy wal vx 19.42v wph vy cv vz cv wcel wi vy wal
      vy cv vx cv wcel vy cv vz cv wcel wph wa wb vy wal wa vy cv vx cv wcel
      wph wb vy wal vx wph vy cv vz cv wcel wi vy wal vy cv vx cv wcel vy cv vz
      cv wcel wph wa wb vy wal wa wph vy cv vz cv wcel wi vy cv vx cv wcel vy
      cv vz cv wcel wph wa wb wa vy wal vy cv vx cv wcel wph wb vy wal wph vy
      cv vz cv wcel wi vy cv vx cv wcel vy cv vz cv wcel wph wa wb vy 19.26 wph
      vy cv vz cv wcel wi vy cv vx cv wcel vy cv vz cv wcel wph wa wb wa vy cv
      vx cv wcel wph wb vy wph vy cv vz cv wcel vy cv vx cv wcel bimsc1 19.20i
      sylbir 19.22i sylbir 19.23aiv ax-mp $.
      $( [5-Aug-1993] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Derive the Null Set Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    zfnuleu.1 $e |- E. x A. y -. y e. x $.
    $( Show the uniqueness of the empty set (using the Axiom of
       Extensionality via ~ bm1.1 to strengthen ~ axnul ). $)
    zfnuleu $p |- E! x A. y -. y e. x $=
      vy cv vx cv wcel wn vy wal vx weu vy cv vx cv wcel vy cv vy cv wceq wn wb
      vy wal vx weu vy cv vx cv wcel vy cv vy cv wceq wn wb vy wal vx wex vy cv
      vx cv wcel vy cv vy cv wceq wn wb vy wal vx weu vy cv vx cv wcel wn vy
      wal vx wex vy cv vx cv wcel vy cv vy cv wceq wn wb vy wal vx wex
      zfnuleu.1 vy cv vx cv wcel wn vy wal vy cv vx cv wcel vy cv vy cv wceq wn
      wb vy wal vx vy cv vx cv wcel wn vy cv vx cv wcel vy cv vy cv wceq wn wb
      vy vy cv vy cv wceq vy cv vx cv wcel vy equid nbn3 albii exbii mpbi vy cv
      vy cv wceq wn vx vy vy cv vy cv wceq wn vx ax-17 bm1.1 ax-mp vy cv vx cv
      wcel wn vy wal vy cv vx cv wcel vy cv vy cv wceq wn wb vy wal vx vy cv vx
      cv wcel wn vy cv vx cv wcel vy cv vy cv wceq wn wb vy vy cv vy cv wceq vy
      cv vx cv wcel vy equid nbn3 albii eubii mpbir $.
      $( [22-Dec-2007] $) $( [22-Dec-2007] $)
  $}

  ${
    $d x y z w $.
    $( Prove ~ axnul directly from ~ ax-rep without using any equality axioms
       ( ~ ax-9 thru ~ ax-16 ).  The wff ` x = x ` substituted for ` ph ` in
       the ~ ax-rep instance is arbitrary.  Here, we don't need to know if
       ` x = x ` is true or false, only that it's not both.  (Contributed by
       Jeff Hoffman, 4-Feb-2008.)  $)
    axnul2 $p |- E. x A. y -. y e. x $=
      vx cv vx cv wceq vx cv vx cv wceq wn wb vx wal vy cv vx cv wceq wi vy wal
      vx wex vy cv vx cv wcel wn vy wal vx wex vw vx cv vx cv wceq vx cv vx cv
      wceq wn wb vx wal vy cv vx cv wceq wi vy wal vx wex vw wal vy cv vx cv
      wcel vw cv vz cv wcel vx cv vx cv wceq vx cv vx cv wceq wn wb vx wal wa
      vw wex wb vy wal vx wex vy cv vx cv wcel wn vy wal vx wex vx cv vx cv
      wceq vx cv vx cv wceq wn wb vz vx vy vw ax-rep vy cv vx cv wcel wn vy wal
      vy cv vx cv wcel vw cv vz cv wcel vx cv vx cv wceq vx cv vx cv wceq wn wb
      vx wal wa vw wex wb vy wal vx vy cv vx cv wcel wn vy cv vx cv wcel vw cv
      vz cv wcel vx cv vx cv wceq vx cv vx cv wceq wn wb vx wal wa vw wex wb vy
      vw cv vz cv wcel vx cv vx cv wceq vx cv vx cv wceq wn wb vx wal wa vw wex
      vy cv vx cv wcel vw cv vz cv wcel vx cv vx cv wceq vx cv vx cv wceq wn wb
      vx wal wa vw vx cv vx cv wceq vx cv vx cv wceq wn wb vx wal vw cv vz cv
      wcel vx cv vx cv wceq vx cv vx cv wceq wn wb vx wal vx cv vx cv wceq vx
      cv vx cv wceq wn wb vx cv vx cv wceq pm5.19 vx cv vx cv wceq vx cv vx cv
      wceq wn wb vx ax-4 mto intnan nex nbn albii exbii sylibr vx cv vx cv wceq
      vx cv vx cv wceq wn wb vx wal vy cv vx cv wceq wi vx cv vx cv wceq vx cv
      vx cv wceq wn wb vx wal vy cv vx cv wceq wi vy wal vx wex vy vx cv vx cv
      wceq vx cv vx cv wceq wn wb vx wal vy cv vx cv wceq wi vy wal vx 19.8a vx
      cv vx cv wceq vx cv vx cv wceq wn wb vx wal vy cv vx cv wceq vx cv vx cv
      wceq vx cv vx cv wceq wn wb vx wal vx cv vx cv wceq vx cv vx cv wceq wn
      wb vx cv vx cv wceq pm5.19 vx cv vx cv wceq vx cv vx cv wceq wn wb vx
      ax-4 mto pm2.21i mpg mpg $.
      $( [5-Feb-2008] $) $( [4-Feb-2008] $)

    $( The Null Set Axiom of ZF set theory:  there exists a set with no
       elements.  Axiom of Empty Set of [Enderton] p. 18.  In some textbooks,
       this is presented as a separate axiom; here we show it can be derived
       from Separation ~ ax-sep .  This version of the Null Set Axiom tells
       us that at least one empty set exists, but does not tells us that it
       is unique - we need the Axiom of Extensionality to do that (see
       ~ zfnuleu ).

       This proof, suggested by Jeff Hoffman (3-Feb-2008), does not require the
       set existence axiom ~ ax-9 , unlike some empty set existence proofs
       (such as the remark in [Kunen] p. 11).  However, it uses ~ ax-4 , which
       also presupposes the existence of at least one set, i.e it does not hold
       in a "free logic" valid in empty domains.  Theorem ~ ax4 , which shows
       the redundancy of ~ ax-4 , depends on ~ ax-9 for its proof.  See
       ~ axnul2 for a similar proof directly from ~ ax-rep .

       This theorem should not be referenced by any proof.  Instead, use
       ~ ax-nul below so that the uses of the Null Set Axiom can be more easily
       identified. $)
    axnul $p |- E. x A. y -. y e. x $=
      vy cv vx cv wcel vy cv vz cv wcel vy cv vy cv wcel vy cv vy cv wcel wn wa
      wa wb vy wal vx wex vy cv vx cv wcel wn vy wal vx wex vy cv vy cv wcel vy
      cv vy cv wcel wn wa vy vx vz ax-sep vy cv vx cv wcel vy cv vz cv wcel vy
      cv vy cv wcel vy cv vy cv wcel wn wa wa wb vy wal vy cv vx cv wcel wn vy
      wal vx vy cv vx cv wcel vy cv vz cv wcel vy cv vy cv wcel vy cv vy cv
      wcel wn wa wa wb vy cv vx cv wcel wn vy vy cv vx cv wcel vy cv vz cv wcel
      vy cv vy cv wcel vy cv vy cv wcel wn wa wa wb vy cv vx cv wcel vy cv vz
      cv wcel vy cv vy cv wcel vy cv vy cv wcel wn wa wa vy cv vy cv wcel vy cv
      vy cv wcel wn wa vy cv vz cv wcel vy cv vy cv wcel pm3.24 intnan vy cv vx
      cv wcel vy cv vz cv wcel vy cv vy cv wcel vy cv vy cv wcel wn wa wa wb id
      mtbiri 19.20i 19.22i ax-mp $.
      $( [4-Feb-2008] $) $( [7-Aug-2003] $)

    $( The Null Set Axiom of ZF set theory.  It was derived as ~ axnul above
       and is therefore redundant, but we state it as a separate axiom here so
       that its uses can be identified more easily. $)
    ax-nul $a |- E. x A. y -. y e. x $.

    $( The Null Set Axiom of ZF set theory:  the empty set exists.  Corollary
       5.16 of [TakeutiZaring] p. 20.  For the unabbreviated version, see
       ~ ax-nul . $)
    0ex $p |- (/) e. _V $=
      c0 cvv wcel vx cv c0 wceq vx weu vx cv c0 wceq vx weu vy cv vx cv wcel wn
      vy wal vx weu vx vy vx vy ax-nul zfnuleu vx cv c0 wceq vy cv vx cv wcel
      wn vy wal vx vy vx cv eq0 eubii mpbir vx c0 eueq mpbir $.
      $( [5-Aug-1993] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Theorems requiring subset and intersection existence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( No set contains all sets.  Theorem 41 of [Suppes] p. 30. $)
    nalset $p |- -. E. x A. y y e. x $=
      vy cv vx cv wcel wn vy wex vy cv vx cv wcel vy wal vx wex wn vx vy cv vx
      cv wcel vx vy alexn vz cv vy cv wcel vz cv vx cv wcel vz cv vz cv wcel wn
      wa wb vz wal vy wex vy cv vx cv wcel wn vy wex vz cv vz cv wcel wn vz vy
      vx cv vx visset zfauscl vz cv vy cv wcel vz cv vx cv wcel vz cv vz cv
      wcel wn wa wb vz wal vy cv vx cv wcel wn vy vz cv vy cv wcel vz cv vx cv
      wcel vz cv vz cv wcel wn wa wb vz wal vy cv vy cv wcel vy cv vx cv wcel
      vy cv vy cv wcel wn wa wb vy cv vx cv wcel wn vz cv vy cv wcel vz cv vx
      cv wcel vz cv vz cv wcel wn wa wb vy cv vy cv wcel vy cv vx cv wcel vy cv
      vy cv wcel wn wa wb vz vy vz cv vy cv wceq vz cv vy cv wcel vy cv vy cv
      wcel vz cv vx cv wcel vz cv vz cv wcel wn wa vy cv vx cv wcel vy cv vy cv
      wcel wn wa vz vy vy elequ1 vz cv vy cv wceq vz cv vx cv wcel vy cv vx cv
      wcel vz cv vz cv wcel wn vy cv vy cv wcel wn vz vy vx elequ1 vz cv vy cv
      wceq vz cv vz cv wcel vy cv vy cv wcel vz cv vy cv wceq vz cv vz cv wcel
      vy cv vz cv wcel vy cv vy cv wcel vz vy vz elequ1 vz vy vy elequ2 bitrd
      notbid anbi12d bibi12d a4v vy cv vy cv wcel vy cv vx cv wcel pclem6 syl
      19.22i ax-mp mpgbi $.
      $( [23-Aug-1993] $)
  $}

  ${
    $d x y $.
    $( The universal class is not a member of itself (and thus is not a set).
       Proposition 5.21 of [TakeutiZaring] p. 21; our proof, however, does
       not depend on the Axiom of Regularity. $)
    vprc $p |- -. _V e. _V $=
      cvv cvv wcel vx cv cvv wceq vx wex vy cv vx cv wcel vy wal vx wex vx cv
      cvv wceq vx wex vx vy nalset vy cv vx cv wcel vy wal vx cv cvv wceq vx vy
      cv vx cv wcel vy wal vy cv vx cv wcel vy cv cvv wcel wb vy wal vx cv cvv
      wceq vy cv vx cv wcel vy cv vx cv wcel vy cv cvv wcel wb vy vy cv cvv
      wcel vy cv vx cv wcel vy visset tbt albii vy vx cv cvv dfcleq bitr4i
      exbii mtbi vx cvv isset mtbir $.
      $( [23-Aug-1993] $)
  $}

  $( The universal class doesn't belong to any class.  (Contributed by FL,
     31-Dec-2006.) $)
  nvel $p |- -. _V e. A $=
    cvv cA wcel cvv cvv wcel vprc cvv cA elisset mto $.
    $( [1-Jan-2007] $) $( [29-Dec-2006] $)

  $( The universal class does not exist. $)
  vnex $p |- -. E. x x = _V $=
    cvv cvv wcel vx cv cvv wceq vx wex vprc vx cvv isset mtbi $.
    $( [13-Jul-2005] $) $( [4-Jul-2005] $)

  ${
    $d A x y $.  $d B x y $.
    inex1.1 $e |- A e. _V $.
    $( Separation Scheme (Aussonderung) using class notation.  Compare
       Exercise 4 of [TakeutiZaring] p. 22. $)
    inex1 $p |- ( A i^i B ) e. _V $=
      vx cA cB cin vx cv cA cB cin wceq vx wex vy cv vx cv wcel vy cv cA wcel
      vy cv cB wcel wa wb vy wal vx wex vy cv cB wcel vy vx cA inex1.1 zfauscl
      vx cv cA cB cin wceq vy cv vx cv wcel vy cv cA wcel vy cv cB wcel wa wb
      vy wal vx vx cv cA cB cin wceq vy cv vx cv wcel vy cv cA cB cin wcel wb
      vy wal vy cv vx cv wcel vy cv cA wcel vy cv cB wcel wa wb vy wal vy vx cv
      cA cB cin dfcleq vy cv vx cv wcel vy cv cA cB cin wcel wb vy cv vx cv
      wcel vy cv cA wcel vy cv cB wcel wa wb vy vy cv cA cB cin wcel vy cv cA
      wcel vy cv cB wcel wa vy cv vx cv wcel vy cv cA cB elin bibi2i albii
      bitri exbii mpbir issetri $.
      $( [5-Aug-1993] $)
  $}

  ${
    inex2.1 $e |- A e. _V $.
    $( Separation Scheme (Aussonderung) using class notation. $)
    inex2 $p |- ( B i^i A ) e. _V $=
      cB cA cin cA cB cin cvv cB cA incom cA cB inex2.1 inex1 eqeltri $.
      $( [27-Apr-1994] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Closed-form, generalized Separation Scheme. $)
    inex1g $p |- ( A e. C -> ( A i^i B ) e. _V ) $=
      vx cv cB cin cvv wcel cA cB cin cvv wcel vx cA cC vx cv cA wceq vx cv cB
      cin cA cB cin cvv vx cv cA cB ineq1 eleq1d vx cv cB vx visset inex1
      vtoclg $.
      $( [7-Apr-1995] $)
  $}

  ${
    ssex.1 $e |- B e. _V $.
    $( The subset of a set is also a set.  Exercise 3 of [TakeutiZaring]
       p. 22.  This is one way to express the Axiom of Separation ~ ax-sep
       (a.k.a. Subset Axiom). $)
    ssex $p |- ( A C_ B -> A e. _V ) $=
      cA cB wss cA cB cin cA wceq cA cvv wcel cA cB df-ss cA cB cin cA wceq cA
      cB cin cvv wcel cA cvv wcel cB cA ssex.1 inex2 cA cB cin cA cvv eleq1
      mpbii sylbi $.
      $( [27-Apr-1994] $)
  $}

  ${
    ssexi.1 $e |- B e. _V $.
    ssexi.2 $e |- A C_ B $.
    $( The subset of a set is also a set. $)
    ssexi $p |- A e. _V $=
      cA cB wss cA cvv wcel ssexi.2 cA cB ssexi.1 ssex ax-mp $.
      $( [9-Sep-1993] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The subset of a set is also a set.  Exercise 3 of [TakeutiZaring]
       p. 22 (generalized). $)
    ssexg $p |- ( ( A C_ B /\ B e. C ) -> A e. _V ) $=
      cB cC wcel cA cB wss cA cvv wcel cA vx cv wss cA cvv wcel wi cA cB wss cA
      cvv wcel wi vx cB cC vx cv cB wceq cA vx cv wss cA cB wss cA cvv wcel vx
      cv cB cA sseq2 imbi1d cA vx cv vx visset ssex vtoclg impcom $.
      $( [11-Sep-2006] $) $( [14-Aug-1994] $)
  $}

  $( Existence of a difference. $)
  difexg $p |- ( A e. C -> ( A \ B ) e. _V ) $=
    cA cB cdif cA wss cA cC wcel cA cB cdif cvv wcel cA cB difss cA cB cdif cA
    cC ssexg mpan $.
    $( [26-May-1998] $)

  ${
    $d x y A $.  $d y ph $.
    zfausab.1 $e |- A e. _V $.
    $( Separation Scheme in terms of a class abstraction. $)
    zfausab $p |- { x | ( x e. A /\ ph ) } e. _V $=
      vx cv cA wcel wph wa vx cab cA zfausab.1 wph vx cA ssab2 ssexi $.
      $( [8-Jun-1994] $)
  $}

  ${
    $d x A $.
    $( Separation Scheme in terms of a restricted class abstraction. $)
    rabexg $p |- ( A e. B -> { x e. A | ph } e. _V ) $=
      wph vx cA crab cA wss cA cB wcel wph vx cA crab cvv wcel wph vx cA ssrab2
      wph vx cA crab cA cB ssexg mpan $.
      $( [23-Oct-1999] $)
  $}

  ${
    $d x A $.
    rabex.1 $e |- A e. _V $.
    $( Separation Scheme in terms of a restricted class abstraction. $)
    rabex $p |- { x e. A | ph } e. _V $=
      cA cvv wcel wph vx cA crab cvv wcel rabex.1 wph vx cA cvv rabexg ax-mp $.
      $( [19-Jul-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    elssabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction involving a subset.  Unlike ~ elabg ,
       ` A ` does not have to be a set. $)
    elssabg $p |- ( B e. C ->
                  ( A e. { x | ( x C_ B /\ ph ) } <-> ( A C_ B /\ ps ) ) ) $=
      cB cC wcel cA cB wss wps wa cA cvv wcel wi cA vx cv cB wss wph wa vx cab
      wcel cA cB wss wps wa wb cB cC wcel cA cB wss cA cvv wcel wps cA cB wss
      cB cC wcel cA cvv wcel cA cB cC ssexg expcom adantrd vx cv cB wss wph wa
      cA cB wss wps wa vx cA cvv vx cv cA wceq vx cv cB wss cA cB wss wph wps
      vx cv cA cB sseq1 elssabg.1 anbi12d elab3g syl $.
      $( [29-Aug-2007] $) $( [29-Aug-2006] $)
  $}

  $( Membership in a power class.  Theorem 86 of [Suppes] p. 47. $)
  elpw2g $p |- ( B e. C -> ( A e. ~P B  <-> A C_ B ) ) $=
    cB cC wcel cA cB cpw wcel cA cB wss cA cB elpwi cA cB wss cB cC wcel cA cB
    cpw wcel cA cB wss cB cC wcel cA cvv wcel cA cB cpw wcel cA cB cC ssexg cA
    cvv wcel cA cB cpw wcel cA cB wss cA cB cvv elpwg biimparc syldan expcom
    impbid2 $.
    $( [7-Aug-2000] $)

  ${
    elpw2.1 $e |- B e. _V $.
    $( Membership in a power class.  Theorem 86 of [Suppes] p. 47. $)
    elpw2 $p |- ( A e. ~P B  <-> A C_ B ) $=
      cB cvv wcel cA cB cpw wcel cA cB wss wb elpw2.1 cA cB cvv elpw2g ax-mp $.
      $( [12-Oct-2007] $) $( [11-Oct-2007] $)
  $}

  ${
    $d x A $.
    $( The intersection of a non-empty class exists.  Exercise 5 of
       [TakeutiZaring] p. 44 and its converse. $)
    intex $p |- ( A =/= (/) <-> |^| A e. _V ) $=
      cA c0 wne cA cint cvv wcel cA c0 wne vx cv cA wcel vx wex cA cint cvv
      wcel vx cA n0 vx cv cA wcel cA cint cvv wcel vx vx cv cA wcel cA cint vx
      cv wss cA cint cvv wcel vx cv cA intss1 cA cint vx cv vx visset ssex syl
      19.23aiv sylbi cA cint cvv wcel cA c0 cA c0 wceq cA cint cvv wcel cvv cvv
      wcel vprc cA c0 wceq cA cint cvv cvv cA c0 wceq cA cint c0 cint cvv cA c0
      inteq int0 syl6eq eleq1d mtbiri necon2ai impbii $.
      $( [15-Mar-2007] $) $( [13-Aug-2002] $)
  $}

  $( If a class intersection is not a set, it must be the universe. $)
  intnex $p |- ( -. |^| A e. _V <-> |^| A = _V ) $=
    cA cint cvv wcel wn cA cint cvv wceq cA cint cvv wcel wn cA c0 wceq cA cint
    cvv wceq cA cint cvv wcel cA c0 cA intex necon1bbii cA c0 wceq cA cint c0
    cint cvv cA c0 inteq int0 syl6eq sylbi cA cint cvv wceq cA cint cvv wcel
    cvv cvv wcel vprc cA cint cvv cvv eleq1 mtbiri impbii $.
    $( [4-Jul-2005] $) $( [3-Jul-2005] $)

  ${
    $d x y $.  $d ph y $.
    $( The intersection of a non-empty class abstraction exists. $)
    intexab $p |- ( E. x ph <-> |^| { x | ph } e. _V ) $=
      wph vx wex wph vx cab c0 wne wph vx cab cint cvv wcel wph vx abn0 wph vx
      cab intex bitr3i $.
      $( [3-Nov-2003] $) $( [21-Oct-2003] $)
  $}

  $( The intersection of a non-empty restricted class abstraction exists. $)
  intexrab $p |- ( E. x e. A ph <-> |^| { x e. A | ph } e. _V ) $=
    vx cv cA wcel wph wa vx wex vx cv cA wcel wph wa vx cab cint cvv wcel wph
    vx cA wrex wph vx cA crab cint cvv wcel vx cv cA wcel wph wa vx intexab wph
    vx cA df-rex wph vx cA crab cint vx cv cA wcel wph wa vx cab cint cvv wph
    vx cA crab vx cv cA wcel wph wa vx cab wph vx cA df-rab inteqi eleq1i
    3bitr4i $.
    $( [3-Nov-2003] $) $( [21-Oct-2003] $)

  ${
    $d x y $.  $d x A $.  $d y ph $.  $d x ps $.  $d x ch $.
    intabs.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    intabs.2 $e |- ( x = |^| { y | ps } -> ( ph <-> ch ) ) $.
    intabs.3 $e |- ( |^| { y | ps } C_ A /\ ch ) $.
    $( Absorption of a redundant conjunct in the intersection of a class
       abstraction. $)
    intabs $p |- |^| { x | ( x C_ A /\ ph ) } = |^| { x | ph } $=
      vx cv cA wss wph wa vx cab cint wph vx cab cint vx cv cA wss wph wa vx
      cab cint wps vy cab cint wph vx cab cint wps vy cab cint cvv wcel vx cv
      cA wss wph wa vx cab cint wps vy cab cint wss vx cv cA wss wph wa wps vy
      cab cint cA wss wch wa vx wps vy cab cint cvv vx cv wps vy cab cint wceq
      vx cv cA wss wps vy cab cint cA wss wph wch vx cv wps vy cab cint cA
      sseq1 intabs.2 anbi12d intabs.3 intmin3 wps vy cab cint cvv wcel wn wps
      vy cab cint cvv wceq vx cv cA wss wph wa vx cab cint wps vy cab cint wss
      wps vy cab intnex wps vy cab cint cvv wceq vx cv cA wss wph wa vx cab
      cint wps vy cab cint wss vx cv cA wss wph wa vx cab cint cvv wss vx cv cA
      wss wph wa vx cab cint ssv wps vy cab cint cvv vx cv cA wss wph wa vx cab
      cint sseq2 mpbiri sylbi pm2.61i wph vx cab wps vy cab wph wps vx vy
      intabs.1 cbvabv inteqi sseqtr4i vx cv cA wss wph wa vx cab wph vx cab wss
      wph vx cab cint vx cv cA wss wph wa vx cab cint wss vx cv cA wss wph wa
      wph vx vx cv cA wss wph pm3.27 ss2abi vx cv cA wss wph wa vx cab wph vx
      cab intss ax-mp eqssi $.
      $( [8-Jul-2005] $) $( [3-Jul-2005] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Theorems requiring empty set existence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( Construct, from any class ` A ` , a set equal to it when the class
       exists and equal to the empty set when the class is proper.  This
       theorem shows that the constructed set always exists. $)
    class2set $p |- { x e. A | A e. _V } e. _V $=
      cA cvv wcel cA cvv wcel vx cA crab cvv wcel cA cvv wcel vx cA cvv rabexg
      cA cvv wcel wn cA cvv wcel vx cA crab c0 cvv cA cvv wcel wn cA cvv wcel
      vx cA wrex wn cA cvv wcel vx cA crab c0 wceq cA cvv wcel wn cA cvv wcel
      vx cA cA cvv wcel wn vx cv cA wcel pm3.26 nrexdv cA cvv wcel vx cA wrex
      cA cvv wcel vx cA crab c0 cA cvv wcel vx cA rabn0 necon1bbii sylib 0ex
      syl6eqel pm2.61i $.
      $( [15-Nov-2003] $) $( [16-Oct-2003] $)

    $( Equality theorem based on ~ class2set .  (The proof was shortened by
       Raph Levien, 30-Jun-2006.) $)
    class2seteq $p |- ( A e. B -> { x e. A | A e. _V } = A ) $=
      cA cB wcel cA cvv wcel cA cvv wcel vx cA crab cA wceq cA cB elisset cA
      cvv wcel cA cA cvv wcel vx cA crab cA cvv wcel cA cvv wcel vx cA wral cA
      cA cvv wcel vx cA crab wceq cA cvv wcel cA cvv wcel vx cA cA cvv wcel vx
      cv cA wcel ax-1 r19.21aiv cA cvv wcel vx cA rabid2 sylibr eqcomd syl $.
      $( [1-Jul-2006] $) $( [13-Dec-2005] $)
  $}

  $( Every power class contains the empty set. $)
  0elpw $p |- (/) e. ~P A $=
    c0 cA cpw wcel c0 cA wss cA 0ss c0 cA 0ex elpw mpbir $.
    $( [25-Oct-2007] $) $( [25-Oct-2007] $)

  $( The empty set and its power set are not equal. $)
  0nep0 $p |- (/) =/= { (/) } $=
    c0 csn c0 wne c0 c0 csn wne c0 0ex snnz c0 csn c0 necom mpbi $.
    $( [13-Apr-2007] $) $( [23-Dec-1993] $)

  $( Something cannot be equal to both the null set and the power set of
     the null set. $)
  0inp0 $p |- ( A = (/) -> -. A = { (/) } ) $=
    cA c0 wceq cA c0 csn wne cA c0 csn wceq wn cA c0 wceq cA c0 csn wne c0 c0
    csn wne 0nep0 cA c0 c0 csn neeq1 mpbiri cA c0 csn df-ne sylib $.
    $( [30-Sep-2003] $)

  $( The removal of the empty set from a class does not affect its union. $)
  unidif0 $p |- U. ( A \ { (/) } ) = U. A $=
    cA c0 csn cdif cuni c0 cA cuni cun cA cuni c0 cun cA cuni cA c0 csn cdif
    cuni c0 csn cA cun cuni c0 csn cuni cA cuni cun c0 cA cuni cun cA c0 csn
    cdif c0 csn cun cuni cA c0 csn cdif cuni c0 csn cuni cun c0 csn cA cun cuni
    cA c0 csn cdif cuni cA c0 csn cdif c0 csn uniun c0 csn cA cun cA c0 csn
    cdif c0 csn cun cA c0 csn cdif c0 csn cun cA c0 csn cun c0 csn cA cun cA c0
    csn undif1 cA c0 csn uncom eqtr2i unieqi cA c0 csn cdif cuni c0 csn cuni
    cun cA c0 csn cdif cuni c0 cun cA c0 csn cdif cuni c0 csn cuni c0 cA c0 csn
    cdif cuni c0 0ex unisn uneq2i cA c0 csn cdif cuni un0 eqtr2i 3eqtr4ri c0
    csn cA uniun c0 csn cuni c0 cA cuni c0 0ex unisn uneq1i 3eqtri c0 cA cuni
    uncom cA cuni un0 3eqtri $.
    $( [23-Mar-2004] $) $( [22-Mar-2004] $)

  ${
    $d x y A $.  $d y B $.
    $( An indexed intersection of the empty set, with a non-empty index set,
       is empty. $)
    iin0 $p |- ( A =/= (/) <-> |^|_ x e. A (/) = (/) ) $=
      cA c0 wne vx cA c0 ciin c0 wceq cA c0 wne c0 vy cv c0 wcel vx cA wral vy
      cab vx cA c0 ciin cA c0 wne vy cv c0 wcel vx cA wral vy c0 vy cv c0 wcel
      vx cA r19.3rzv abbi2dv vx vy cA c0 df-iin syl6reqr vx cA c0 ciin c0 wceq
      cA c0 cA c0 wceq vx cA c0 ciin c0 wceq vx c0 c0 ciin c0 wceq vx c0 c0
      ciin c0 wceq cvv c0 wceq c0 cvv wcel cvv c0 wceq wn 0ex cvv c0 n0i ax-mp
      vx c0 c0 ciin cvv c0 vx c0 0iin eqeq1i mtbir cA c0 wceq vx cA c0 ciin vx
      c0 c0 ciin c0 vx cA c0 c0 iineq1 eqeq1d mtbiri necon2ai impbii $.
      $( [28-Dec-2005] $) $( [20-Oct-2005] $)
  $}

  ${
    $d x A $.
    notzfaus.1 $e |- A = { (/) } $.
    notzfaus.2 $e |- ( ph <-> -. x e. y ) $.
    $( In the Separation Scheme ~ zfauscl , we require that ` y ` not occur
       in ` ph ` (which can be generalized to "not be free in").  Here we
       show that a contradiction can result if we omit this requirement. $)
    notzfaus $p |- -. E. y A. x ( x e. y <-> ( x e. A /\ ph ) ) $=
      vx cv vy cv wcel vx cv cA wcel wph wa wb vx wal vy vx cv vy cv wcel vx cv
      cA wcel wph wa wb wn vx wex vx cv vy cv wcel vx cv cA wcel wph wa wb vx
      wal wn vx cv cA wcel vx wex vx cv vy cv wcel vx cv cA wcel wph wa wb wn
      vx wex cA c0 wne vx cv cA wcel vx wex cA c0 wne c0 csn c0 wne c0 0ex snnz
      cA c0 csn c0 notzfaus.1 neeq1i mpbir vx cA n0 mpbi vx cv cA wcel vx cv vy
      cv wcel vx cv cA wcel wph wa wb wn vx vx cv cA wcel vx cv vy cv wcel vx
      cv cA wcel wph wa wn wb vx cv vy cv wcel vx cv cA wcel wph wa wb wn vx cv
      cA wcel vx cv vy cv wcel vx cv cA wcel vx cv vy cv wcel wi vx cv cA wcel
      wph wa wn vx cv cA wcel vx cv vy cv wcel biimt vx cv cA wcel vx cv vy cv
      wcel wi vx cv cA wcel vx cv vy cv wcel wn wa wn vx cv cA wcel wph wa wn
      vx cv cA wcel vx cv vy cv wcel iman vx cv cA wcel wph wa vx cv cA wcel vx
      cv vy cv wcel wn wa wph vx cv vy cv wcel wn vx cv cA wcel notzfaus.2
      anbi2i notbii bitr4i syl6bb vx cv vy cv wcel vx cv cA wcel wph wa xor3
      sylibr 19.22i ax-mp vx cv vy cv wcel vx cv cA wcel wph wa wb vx exnal
      mpbi nex $.
      $( [8-Oct-2006] $) $( [8-Feb-2006] $)
  $}

  $( The intersection of the universal class is empty. $)
  intv $p |- |^| _V = (/) $=
    c0 cvv wcel cvv cint c0 wceq 0ex cvv int0el ax-mp $.
    $( [11-Sep-2008] $) $( [11-Sep-2008] $)

  ${
    $d x y z A $.
    axpweq.1 $e |- A e. _V $.
    $( Two equivalent ways to express the Power Set Axiom.  Note that ~ ax-pow
       is not used by the proof. $)
    axpweq $p |- ( ~P A e. _V
                <-> E. x A. y ( A. z ( z e. y -> z e. A ) -> y e. x ) ) $=
      cA cpw cvv wcel cA cpw vx cv cpw wcel vx wex vz cv vy cv wcel vz cv cA
      wcel wi vz wal vy cv vx cv wcel wi vy wal vx wex cA cpw cvv wcel cA cpw
      vx cv cpw wcel vx wex cA cpw cvv wcel cA cpw cA cpw cpw wcel cA cpw vx cv
      cpw wcel vx wex cA cpw cvv wcel cA cpw cA cpw cpw wcel cA cpw cA cpw wss
      cA cpw ssid cA cpw cA cpw cvv elpwg mpbiri cA cpw vx cv cpw wcel cA cpw
      cA cpw cpw wcel vx cA cpw cvv vx cv cA cpw wceq vx cv cpw cA cpw cpw cA
      cpw vx cv cA cpw pweq eleq2d cla4egv mpd cA cpw vx cv cpw wcel cA cpw cvv
      wcel vx cA cpw vx cv cpw elisset 19.23aiv impbii cA cpw vx cv cpw wcel vz
      cv vy cv wcel vz cv cA wcel wi vz wal vy cv vx cv wcel wi vy wal vx cA
      cpw vx cv cpw wcel cA cpw vx cv wss vy cv cA wss vy cv vx cv wcel wi vy
      wal vz cv vy cv wcel vz cv cA wcel wi vz wal vy cv vx cv wcel wi vy wal
      cA cpw vx cv vx visset elpw2 vy cA vx cv pwss vy cv cA wss vy cv vx cv
      wcel wi vz cv vy cv wcel vz cv cA wcel wi vz wal vy cv vx cv wcel wi vy
      vy cv cA wss vz cv vy cv wcel vz cv cA wcel wi vz wal vy cv vx cv wcel vz
      vy cv cA dfss2 imbi1i albii 3bitri exbii bitri $.
      $( [25-Jun-2009] $) $( [22-Jun-2009] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Power Sets
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Introduce the Axiom of Power Sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.
    $( Axiom of Power Sets.  An axiom of Zermelo-Fraenkel set theory.  It
       states that a set ` y ` exists that includes the power set of a given
       set ` x ` i.e. the collection of all subsets of ` x ` .  The variant
       ~ axpow2 states that the power set itself exists.  A version using
       class notation is ~ pwex . $)
    ax-pow $a |- E. y A. z ( A. w ( w e. z -> w e. x ) -> z e. y ) $.

    $( Axiom of Power Sets expressed with fewest number of different
       variables. $)
    zfpow $p |- E. x A. y ( A. x ( x e. y -> x e. z ) -> y e. x ) $=
      vw cv vy cv wcel vw cv vz cv wcel wi vw wal vy cv vx cv wcel wi vy wal vx
      wex vx cv vy cv wcel vx cv vz cv wcel wi vx wal vy cv vx cv wcel wi vy
      wal vx wex vz vx vy vw ax-pow vw cv vy cv wcel vw cv vz cv wcel wi vw wal
      vy cv vx cv wcel wi vy wal vx cv vy cv wcel vx cv vz cv wcel wi vx wal vy
      cv vx cv wcel wi vy wal vx vw cv vy cv wcel vw cv vz cv wcel wi vw wal vy
      cv vx cv wcel wi vx cv vy cv wcel vx cv vz cv wcel wi vx wal vy cv vx cv
      wcel wi vy vw cv vy cv wcel vw cv vz cv wcel wi vw wal vx cv vy cv wcel
      vx cv vz cv wcel wi vx wal vy cv vx cv wcel vw cv vy cv wcel vw cv vz cv
      wcel wi vx cv vy cv wcel vx cv vz cv wcel wi vw vx vw cv vx cv wceq vw cv
      vy cv wcel vx cv vy cv wcel vw cv vz cv wcel vx cv vz cv wcel vw vx vy
      elequ1 vw vx vz elequ1 imbi12d cbvalv imbi1i albii exbii mpbi $.
      $( [14-Aug-2003] $)

    $( A variant of the Axiom of Power Sets ~ ax-pow using subset notation.
       Problem in {BellMachover] p. 466. $)
    axpow2 $p |- E. y A. z ( z C_ x -> z e. y ) $=
      vz cv vx cv wss vz cv vy cv wcel wi vz wal vy wex vw cv vz cv wcel vw cv
      vx cv wcel wi vw wal vz cv vy cv wcel wi vz wal vy wex vx vy vz vw ax-pow
      vz cv vx cv wss vz cv vy cv wcel wi vz wal vw cv vz cv wcel vw cv vx cv
      wcel wi vw wal vz cv vy cv wcel wi vz wal vy vz cv vx cv wss vz cv vy cv
      wcel wi vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy cv wcel wi
      vz vz cv vx cv wss vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy
      cv wcel vw vz cv vx cv dfss2 imbi1i albii exbii mpbir $.
      $( [6-Jun-2006] $) $( [4-Jun-2006] $)

    $( A variant of the Axiom of Power Sets ~ ax-pow .  For any set ` x ` ,
       there exists a set ` y ` whose members are exactly the subsets
       of ` x ` i.e. the power set of ` x ` .  Axiom Pow of [BellMachover]
       p. 466. $)
    axpow3 $p |- E. y A. z ( z C_ x <-> z e. y ) $=
      vz cv vx cv wss vz cv vy cv wcel wb vz wal vy wex vz cv vy cv wcel vz cv
      vx cv wss wb vz wal vy wex vz cv vx cv wss vy vz vx vy vz axpow2 bm1.3ii
      vz cv vx cv wss vz cv vy cv wcel wb vz wal vz cv vy cv wcel vz cv vx cv
      wss wb vz wal vy vz cv vx cv wss vz cv vy cv wcel wb vz cv vy cv wcel vz
      cv vx cv wss wb vz vz cv vx cv wss vz cv vy cv wcel bicom albii exbii
      mpbir $.
      $( [26-Jun-2009] $) $( [4-Jun-2006] $)
  $}

  ${
    $d w x y z $.
    $( Every set is an element of some other set.  See ~ elALT for a shorter
       proof using more axioms. $)
    el $p |- E. y x e. y $=
      vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy cv wcel wi vz wal vy
      wex vx cv vy cv wcel vy wex vx vy vz vw ax-pow vw cv vz cv wcel vw cv vx
      cv wcel wi vw wal vz cv vy cv wcel wi vz wal vx cv vy cv wcel vy vw cv vz
      cv wcel vw cv vx cv wcel wi vw wal vz cv vy cv wcel wi vz wal vw cv vx cv
      wcel vw cv vx cv wcel wi vw wal vx cv vy cv wcel vw cv vx cv wcel vw cv
      vx cv wcel wi vw vw cv vx cv wcel id ax-gen vw cv vz cv wcel vw cv vx cv
      wcel wi vw wal vz cv vy cv wcel wi vw cv vx cv wcel vw cv vx cv wcel wi
      vw wal vx cv vy cv wcel wi vz vx vz cv vx cv wceq vw cv vz cv wcel vw cv
      vx cv wcel wi vw wal vw cv vx cv wcel vw cv vx cv wcel wi vw wal vz cv vy
      cv wcel vx cv vy cv wcel vz cv vx cv wceq vw cv vz cv wcel vw cv vx cv
      wcel wi vw cv vx cv wcel vw cv vx cv wcel wi vw vz cv vx cv wceq vw cv vz
      cv wcel vw cv vx cv wcel vw cv vx cv wcel vz vx vw elequ2 imbi1d albidv
      vz vx vy elequ1 imbi12d a4v mpi 19.22i ax-mp $.
      $( [22-Jun-2009] $) $( [4-Jan-2002] $)
  $}

  ${
    $d A x y z $.
    zfpowcl.1 $e |- A e. _V $.
    $( Power set axiom expressed in class notation.  Axiom 4 of [TakeutiZaring]
       p. 17. $)
    pwex $p |- ~P A e. _V $=
      vz cv cpw cvv wcel cA cpw cvv wcel vz cA zfpowcl.1 vz cv cA wceq vz cv
      cpw cA cpw cvv vz cv cA pweq eleq1d vx vz cv cpw vx cv vz cv cpw wceq vx
      wex vy cv vx cv wcel vy cv vz cv wss wb vy wal vx wex vy cv vz cv wss vx
      vy vy cv vz cv wss vy cv vx cv wcel wi vy wal vx wex vx cv vy cv wcel vx
      cv vz cv wcel wi vx wal vy cv vx cv wcel wi vy wal vx wex vx vy vz zfpow
      vy cv vz cv wss vy cv vx cv wcel wi vy wal vx cv vy cv wcel vx cv vz cv
      wcel wi vx wal vy cv vx cv wcel wi vy wal vx vy cv vz cv wss vy cv vx cv
      wcel wi vx cv vy cv wcel vx cv vz cv wcel wi vx wal vy cv vx cv wcel wi
      vy vy cv vz cv wss vx cv vy cv wcel vx cv vz cv wcel wi vx wal vy cv vx
      cv wcel vx vy cv vz cv dfss2 imbi1i albii exbii mpbir bm1.3ii vx cv vz cv
      cpw wceq vy cv vx cv wcel vy cv vz cv wss wb vy wal vx vx cv vz cv cpw
      wceq vx cv vy cv vz cv wss vy cab wceq vy cv vx cv wcel vy cv vz cv wss
      wb vy wal vz cv cpw vy cv vz cv wss vy cab vx cv vy vz cv df-pw eqeq2i vy
      cv vz cv wss vy vx cv abeq2 bitri exbii mpbir issetri vtocl $.
      $( [5-Aug-1993] $)
  $}

  ${
    $d x A $.
    $( Power set axiom expressed in class notation, with the sethood
       requirement as an antecedent.  Axiom 4 of [TakeutiZaring] p. 17. $)
    pwexg $p |- ( A e. B -> ~P A e. _V ) $=
      vx cv cpw cvv wcel cA cpw cvv wcel vx cA cB vx cv cA wceq vx cv cpw cA
      cpw cvv vx cv cA pweq eleq1d vx cv vx visset pwex vtoclg $.
      $( [30-Oct-2003] $) $( [30-Oct-2003] $)

    $( Existence of a class of subsets. $)
    abssexg $p |- ( A e. B -> { x | ( x C_ A /\ ph ) } e. _V ) $=
      cA cB wcel wph vx cA cpw crab cvv vx cv cA wss wph wa vx cab cA cB wcel
      cA cpw cvv wcel wph vx cA cpw crab cvv wcel cA cB pwexg wph vx cA cpw cvv
      rabexg syl wph vx cA cpw crab vx cv cA cpw wcel wph wa vx cab vx cv cA
      wss wph wa vx cab wph vx cA cpw df-rab vx cv cA cpw wcel wph wa vx cv cA
      wss wph wa vx vx cv cA cpw wcel vx cv cA wss wph vx cv cA vx visset elpw
      anbi1i abbii eqtr2i syl5eqel $.
      $( [15-Jul-2006] $) $( [15-Jul-2006] $)
  $}

  ${
    $d x y A $.
    $( A singleton is a set.  Theorem 7.13 of [Quine] p. 51, but proved using
       only Extensionality, Power Set, and Separation.  Unlike the proof of
       ~ zfpair , Replacement is not needed. $)
    snex $p |- { A } e. _V $=
      cA cvv wcel cA csn cvv wcel vx cv csn cvv wcel cA csn cvv wcel vx cA cvv
      vx cv cA wceq vx cv csn cA csn cvv vx cv cA sneq eleq1d vx cv csn vx cv
      cpw vx cv vx visset pwex vx cv snsspw ssexi vtoclg cA cvv wcel wn cA csn
      c0 wceq cA csn cvv wcel cA snprc cA csn c0 wceq cA csn cvv wcel c0 cvv
      wcel c0 cvv wcel vx cv c0 wceq vx weu vx cv c0 wceq vx weu vy cv vx cv
      wcel wn vy wal vx weu vx vy vx vy axnul zfnuleu vx cv c0 wceq vy cv vx cv
      wcel wn vy wal vx vy vx cv eq0 eubii mpbir vx c0 eueq mpbir cA csn c0 cvv
      eleq1 mpbiri sylbi pm2.61i $.
      $( [7-Aug-1994] $)
  $}

  ${
    $d x y $.
    $( Every set is an element of some other set.  This has a shorter proof
       than ~ el but uses more axioms. $)
    elALT $p |- E. y x e. y $=
      vx cv vx cv csn wcel vx cv vy cv wcel vy wex vx cv vx visset snid vx cv
      vy cv wcel vx cv vx cv csn wcel vy vx cv csn vx cv snex vy cv vx cv csn
      vx cv eleq2 cla4ev ax-mp $.
      $( [4-Jan-2002] $)
  $}

  $( The power set of the empty set (the ordinal 1) is a set. $)
  p0ex $p |- { (/) } e. _V $=
    c0 snex $.
    $( [23-Dec-1993] $)

  $( The power set of the power set of the empty set (the ordinal 2) is a
     set. $)
  pp0ex $p |- { (/) , { (/) } } e. _V $=
    c0 csn cpw c0 c0 csn cpr cvv pwpw0 c0 csn p0ex pwex eqeltrri $.
    $( [5-Aug-1993] $)

  $( The ordinal number 3 is a set, proved without the Axiom of Union
     ~ ax-un . $)
  ord3ex $p |- { (/) , { (/) } , { (/) , { (/) } } } e. _V $=
    c0 c0 csn c0 c0 csn cpr ctp c0 c0 csn cpr c0 c0 csn cpr csn cun cvv c0 c0
    csn c0 c0 csn cpr df-tp c0 c0 csn cpr c0 c0 csn cpr csn cun c0 c0 csn cpr
    c0 csn csn c0 c0 csn cpr cpr cun c0 c0 csn cpr cpw c0 c0 csn cpr c0 csn csn
    c0 c0 csn cpr cpr cun cvv c0 c0 csn pwpr c0 c0 csn cpr pp0ex pwex eqeltrri
    c0 c0 csn cpr csn c0 csn csn c0 c0 csn cpr cpr wss c0 c0 csn cpr c0 c0 csn
    cpr csn cun c0 c0 csn cpr c0 csn csn c0 c0 csn cpr cpr cun wss c0 csn csn
    c0 c0 csn cpr snsspr2 c0 c0 csn cpr csn c0 csn csn c0 c0 csn cpr cpr c0 c0
    csn cpr unss2 ax-mp ssexi eqeltri $.
    $( [4-May-2009] $) $( [2-May-2009] $)

  ${
    $d w x y z $.
    $( At least two sets exist (or in terms of first-order logic, the universe
       of discourse has two or more objects).  Note that we may not substitute
       the same variable for both ` x ` and ` y ` (as indicated by the distinct
       variable requirement), for otherwise we would contradict ~ stdpc6 .
       Assuming that ZF set theory is consistent, we cannot prove this theorem
       unless we specify that ` x ` and ` y ` be distinct.  Specifically,
       theorem ~ cla4ev requires that ` x ` must not occur in the subexpression
       ` -. y = { (/) } ` in step 4 nor in the subexpression ` -. y = (/) ` in
       step 9.  The proof verifier will require that ` x ` and ` y ` be in a
       distinct variable group to ensure this.  You can check this by deleting
       the $d statement in set.mm and rerunning the verifier, which will print
       a detailed explanation of the distinct variable violation.

       This theorem is proved directly from set theory axioms (no set theory
       definitions) and does not use ~ ax-16 , ~ ax-ext , or ~ ax-sep .  See
       ~ dtruALT for a shorter proof using these axioms. $)
    dtru $p |- -. A. x x = y $=
      vx cv vy cv wceq wn vx wex vx cv vy cv wceq vx wal wn vw cv vz cv wceq wn
      vz wex vw wex vx cv vy cv wceq wn vx wex vx cv vw cv wcel vx cv vz cv
      wcel wn wa vz wex vw wex vw cv vz cv wceq wn vz wex vw wex vx cv vw cv
      wcel vx cv vz cv wcel wn wa vz wex vw wex vx cv vw cv wcel vw wex vx cv
      vz cv wcel wn vz wex vx cv vw cv wcel vx cv vz cv wcel wn vw vz eeanv vy
      cv vz cv wcel vy cv vx cv wcel wi vy wal vz cv vw cv wcel wi vz wal vw
      wex vx cv vw cv wcel vw wex vx vw vz vy ax-pow vy cv vz cv wcel vy cv vx
      cv wcel wi vy wal vz cv vw cv wcel wi vz wal vx cv vw cv wcel vw vy cv vz
      cv wcel vy cv vx cv wcel wi vy wal vz cv vw cv wcel wi vz wal vy cv vx cv
      wcel vy cv vx cv wcel wi vy wal vx cv vw cv wcel vy cv vx cv wcel vy cv
      vx cv wcel wi vy vy cv vx cv wcel id ax-gen vy cv vz cv wcel vy cv vx cv
      wcel wi vy wal vz cv vw cv wcel wi vy cv vx cv wcel vy cv vx cv wcel wi
      vy wal vx cv vw cv wcel wi vz vx vz cv vx cv wceq vy cv vz cv wcel vy cv
      vx cv wcel wi vy wal vy cv vx cv wcel vy cv vx cv wcel wi vy wal vz cv vw
      cv wcel vx cv vw cv wcel vz cv vx cv wceq vy cv vz cv wcel vy cv vx cv
      wcel wi vy cv vx cv wcel vy cv vx cv wcel wi vy vz cv vx cv wceq vy cv vz
      cv wcel vy cv vx cv wcel vy cv vx cv wcel vz vx vy elequ2 imbi1d albidv
      vz vx vw elequ1 imbi12d a4v mpi 19.22i ax-mp vx cv vz cv wcel wn vx wal
      vz wex vx cv vz cv wcel wn vz wex vz vx ax-nul vx cv vz cv wcel wn vx wal
      vx cv vz cv wcel wn vz vx cv vz cv wcel wn vx ax-4 19.22i ax-mp mpbir2an
      vx cv vw cv wcel vx cv vz cv wcel wn wa vw cv vz cv wceq wn vw vz vx cv
      vw cv wcel vx cv vz cv wcel wn vw cv vz cv wceq wn vx cv vw cv wcel vw cv
      vz cv wceq vx cv vz cv wcel vw cv vz cv wceq vx cv vw cv wcel vx cv vz cv
      wcel vw vz vx ax-14 com12 con3d imp 19.22i2 ax-mp vw cv vz cv wceq wn vx
      cv vy cv wceq wn vx wex vw vz vz cv vy cv wceq vw cv vz cv wceq wn vx cv
      vy cv wceq wn vx wex wi vz cv vy cv wceq vw cv vz cv wceq wn vw cv vy cv
      wceq wn vx cv vy cv wceq wn vx wex vz cv vy cv wceq vw cv vz cv wceq vw
      cv vy cv wceq vz vy vw equequ2 notbid vw cv vy cv wceq wn vx cv vy cv
      wceq wn vx vw vx cv vw cv wceq vx cv vy cv wceq vw cv vy cv wceq vx vw vy
      ax-8 con3d a4imev syl6bi vz cv vy cv wceq wn vx cv vy cv wceq wn vx wex
      vw cv vz cv wceq wn vz cv vy cv wceq wn vx cv vy cv wceq wn vx vz vx cv
      vz cv wceq vx cv vy cv wceq vz cv vy cv wceq vx vz vy ax-8 con3d a4imev
      a1d pm2.61i 19.23aivv ax-mp vx cv vy cv wceq vx exnal mpbi $.
      $( [8-Nov-2006] $) $( [7-Nov-2006] $)
  $}

  ${
    $d x y $.
    $( This theorem shows that axiom ~ ax-16 is redundant in the presence of
       theorem ~ dtru , which states simply that at least two things exist.
       This justifies the remark at
       ~ http://us.metamath.org/mpegif/mmzfcnd.html#twoness (which links
       to this theorem). $)
    ax16b $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      vx cv vy cv wceq vx wal wph wph vx wal wi vx vy dtru pm2.21i $.
      $( [8-Nov-2006] $) $( [7-Nov-2006] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( Existential uniqueness implies there is a value for which the wff
       argument is false. $)
    eunex $p |- ( E! x ph -> E. x -. ph ) $=
      wph vx wex wph vx cv vy cv wceq wi vx wal vy wex wa wph vx wal wn wph vx
      weu wph wn vx wex wph vx cv vy cv wceq wi vx wal vy wex wph vx wal wn wph
      vx wex wph vx cv vy cv wceq wi vx wal wph vx wal wn vy wph vx cv vy cv
      wceq wi vx wal wph vx wal vx cv vy cv wceq vx wal vx vy dtru wph vx cv vy
      cv wceq vx 19.20 mtoi 19.23aiv adantl wph vx vy wph vy ax-17 eu3 wph vx
      exnal 3imtr4i $.
      $( [29-Oct-2010] $) $( [24-Oct-2010] $)
  $}

  ${
    snelpw.1 $e |- A e. _V $.
    $( A singleton of a set belongs to the power class of a class containing
       the set. $)
    snelpw $p |- ( A e. B <-> { A } e. ~P B ) $=
      cA cB wcel cA csn cB wss cA csn cB cpw wcel cA cB snelpw.1 snss cA csn cB
      cA snex elpw bitr4i $.
      $( [1-Apr-1998] $)
  $}

  ${
    $d x y z $.
    $( A theorem similar to extensionality, requiring the existence of a
       singleton.  Exercise 8 of [TakeutiZaring] p. 16. $)
    rext $p |- ( A. z ( x e. z -> y e. z ) -> x = y ) $=
      vx cv vz cv wcel vy cv vz cv wcel wi vz wal vy cv vx cv csn wcel vx cv vy
      cv wceq vx cv vz cv wcel vy cv vz cv wcel wi vz wal vx cv vx cv csn wcel
      vy cv vx cv csn wcel vx cv vx visset snid vx cv vz cv wcel vy cv vz cv
      wcel wi vx cv vx cv csn wcel vy cv vx cv csn wcel wi vz vx cv csn vx cv
      snex vz cv vx cv csn wceq vx cv vz cv wcel vx cv vx cv csn wcel vy cv vz
      cv wcel vy cv vx cv csn wcel vz cv vx cv csn vx cv eleq2 vz cv vx cv csn
      vy cv eleq2 imbi12d cla4v mpi vy cv vx cv csn wcel vy cv vx cv wceq vx cv
      vy cv wceq vy vx cv elsn vy vx equcomi sylbi syl $.
      $( [10-Aug-1993] $)
  $}

  ${
    $d A x $.  $d B x $.
    $( Classes are subclasses if and only if their power classes are
       subclasses.  Exercise 18 of [TakeutiZaring] p. 18. $)
    sspwb $p |- ( A C_ B <-> ~P A C_ ~P B ) $=
      cA cB wss cA cpw cB cpw wss cA cB wss vx cA cpw cB cpw cA cB wss vx cv cA
      wss vx cv cB wss vx cv cA cpw wcel vx cv cB cpw wcel vx cv cA wss cA cB
      wss vx cv cB wss vx cv cA cB sstr2 com12 vx cv cA vx visset elpw vx cv cB
      vx visset elpw 3imtr4g ssrdv cA cpw cB cpw wss vx cA cB cA cpw cB cpw wss
      vx cv csn cA cpw wcel vx cv csn cB cpw wcel vx cv cA wcel vx cv cB wcel
      cA cpw cB cpw vx cv csn ssel vx cv csn cA cpw wcel vx cv csn cA wss vx cv
      cA wcel vx cv csn cA vx cv snex elpw vx cv cA vx visset snss bitr4i vx cv
      csn cB cpw wcel vx cv csn cB wss vx cv cB wcel vx cv csn cB vx cv snex
      elpw vx cv cB vx visset snss bitr4i 3imtr3g ssrdv impbii $.
      $( [13-Oct-1996] $)
  $}

  ${
    $d A x y $.
    $( A class equals the union of its power class.  Exercise 6(a) of
       [Enderton] p. 38.  (The proof was shortened by Alan Sare,
       28-Dec-2008.) $)
    unipw $p |- U. ~P A = A $=
      vx cA cpw cuni cA vx cv cA cpw cuni wcel vx cv cA wcel vx cv cA cpw cuni
      wcel vx cv vy cv wcel vy cv cA cpw wcel wa vy wex vx cv cA wcel vy vx cv
      cA cpw eluni vx cv vy cv wcel vy cv cA cpw wcel wa vx cv cA wcel vy vy cv
      cA cpw wcel vx cv vy cv wcel vx cv cA wcel vy cv cA cpw wcel vy cv cA wss
      vx cv vy cv wcel vx cv cA wcel wi vy cv cA vy visset elpw vy cv cA vx cv
      ssel sylbi impcom 19.23aiv sylbi vx cv vx cv csn wcel vx cv csn cA cpw
      wcel vx cv cA cpw cuni wcel vx cv cA wcel vx cv vx cv csn cA cpw elunii
      vx cv vx visset snid vx cv cA wcel vx cv csn cA cpw wcel vx cv cA vx
      visset snelpw biimpi sylancr impbii eqriv $.
      $( [29-Dec-2008] $) $( [14-Oct-1996] $)
  $}

  ${
    $d A x $.
    $( A class is a subclass of the power class of its union.  Exercise 6(b)
       of [Enderton] p. 38. $)
    pwuni $p |- A C_ ~P U. A $=
      vx cA cA cuni cpw vx cv cA wcel vx cv cA cuni wss vx cv cA cuni cpw wcel
      vx cv cA elssuni vx cv cA cuni vx visset elpw sylibr ssriv $.
      $( [14-Oct-1996] $)
  $}

  $( Membership of a power class.  Exercise 10 of [Enderton] p. 26. $)
  pwel $p |- ( A e. B -> ~P A e. ~P ~P U. B ) $=
    cA cB wcel cA cpw cB cuni cpw cpw wcel cA cpw cB cuni cpw wss cA cB wcel cA
    cB cuni wss cA cpw cB cuni cpw wss cA cB elssuni cA cB cuni sspwb sylib cA
    cB wcel cA cpw cvv wcel cA cpw cB cuni cpw cpw wcel cA cpw cB cuni cpw wss
    wb cA cB pwexg cA cpw cB cuni cpw cvv elpwg syl mpbird $.
    $( [13-Jan-2007] $) $( [13-Jan-2007] $)

  ${
    $d A x $.  $d B x $.
    $( An extensionality-like principle defining subclass in terms of
       subsets. $)
    ssextss $p |- ( A C_ B <-> A. x ( x C_ A -> x C_ B ) ) $=
      cA cB wss cA cpw cB cpw wss vx cv cA cpw wcel vx cv cB cpw wcel wi vx wal
      vx cv cA wss vx cv cB wss wi vx wal cA cB sspwb vx cA cpw cB cpw dfss2 vx
      cv cA cpw wcel vx cv cB cpw wcel wi vx cv cA wss vx cv cB wss wi vx vx cv
      cA cpw wcel vx cv cA wss vx cv cB cpw wcel vx cv cB wss vx cv cA vx
      visset elpw vx cv cB vx visset elpw imbi12i albii 3bitri $.
      $( [1-Jul-2004] $) $( [30-Jun-2004] $)

    $( An extensionality-like principle that uses the subset instead of the
       membership relation:  two classes are equal iff they have the same
       subsets. $)
    ssext $p |- ( A = B <-> A. x ( x C_ A <-> x C_ B ) ) $=
      cA cB wss cB cA wss wa vx cv cA wss vx cv cB wss wi vx wal vx cv cB wss
      vx cv cA wss wi vx wal wa cA cB wceq vx cv cA wss vx cv cB wss wb vx wal
      cA cB wss vx cv cA wss vx cv cB wss wi vx wal cB cA wss vx cv cB wss vx
      cv cA wss wi vx wal vx cA cB ssextss vx cB cA ssextss anbi12i cA cB eqss
      vx cv cA wss vx cv cB wss vx albi 3bitr4i $.
      $( [1-Jul-2004] $) $( [30-Jun-2004] $)

    $( Negation of subclass relationship.  Compare ~ nss . $)
    nssss $p |- ( -. A C_ B <-> E. x ( x C_ A /\ -. x C_ B ) ) $=
      vx cv cA wss vx cv cB wss wi wn vx wex vx cv cA wss vx cv cB wss wi vx
      wal wn vx cv cA wss vx cv cB wss wn wa vx wex cA cB wss wn vx cv cA wss
      vx cv cB wss wi vx exnal vx cv cA wss vx cv cB wss wn wa vx cv cA wss vx
      cv cB wss wi wn vx vx cv cA wss vx cv cB wss annim exbii cA cB wss vx cv
      cA wss vx cv cB wss wi vx wal vx cA cB ssextss notbii 3bitr4ri $.
      $( [2-Jul-2004] $) $( [30-Jun-2004] $)
  $}

  $( Classes are equal if and only if their power classes are equal.  Exercise
     19 of [TakeutiZaring] p. 18. $)
  pweqb $p |- ( A = B <-> ~P A = ~P B ) $=
    cA cB wss cB cA wss wa cA cpw cB cpw wss cB cpw cA cpw wss wa cA cB wceq cA
    cpw cB cpw wceq cA cB wss cA cpw cB cpw wss cB cA wss cB cpw cA cpw wss cA
    cB sspwb cB cA sspwb anbi12i cA cB eqss cA cpw cB cpw eqss 3bitr4i $.
    $( [13-Oct-1996] $)

  ${
    $d x A $.
    intid.1 $e |- A e. _V $.
    $( The intersection of all sets to which a set belongs is the singleton
       of that set. $)
    intid $p |- |^| { x | A e. x } = { A } $=
      cA vx cv wcel vx cab cint cA csn cA csn cvv wcel cA vx cv wcel vx cab
      cint cA csn wss cA snex cA vx cv wcel cA cA csn wcel vx cA csn cvv vx cv
      cA csn cA eleq2 cA intid.1 snid intmin3 ax-mp cA cA vx cv wcel vx cab
      cint wcel cA csn cA vx cv wcel vx cab cint wss cA cA vx cv wcel vx cab
      cint wcel cA vx cv wcel cA vx cv wcel wi vx cA vx cv wcel vx cA intid.1
      elintab cA vx cv wcel id mpgbir cA cA vx cv wcel vx cab cint snssi ax-mp
      eqssi $.
      $( [5-Jun-2009] $) $( [5-Jun-2009] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( "At most one" existence implies a class abstraction exists. $)
    moabex $p |- ( E* x ph -> { x | ph } e. _V ) $=
      wph vx wmo wph vx cv vy cv wceq wi vx wal vy wex wph vx cab cvv wcel wph
      vx vy wph vy ax-17 mo2 wph vx cv vy cv wceq wi vx wal wph vx cab cvv wcel
      vy wph vx cv vy cv wceq wi vx wal wph vx cab vx cv vy cv wceq wph wa vx
      cab cvv wph vx cv vy cv wceq wi vx wal wph vx cv vy cv wceq wph wa vx wph
      vx cv vy cv wceq wi vx hba1 wph vx cv vy cv wceq wi vx wal wph wph vx cv
      vy cv wceq wa vx cv vy cv wceq wph wa wph vx cv vy cv wceq wi wph wph vx
      cv vy cv wceq wa wb vx wph vx cv vy cv wceq wi wph wph vx cv vy cv wceq
      wa wb wph vx cv vy cv wceq pm4.71 biimpi a4s wph vx cv vy cv wceq ancom
      syl6bb abbid vx cv vy cv wceq wph wa vx cab vx cv vy cv wceq vx cab vy cv
      csn vx cv vy cv wceq vx cab cvv vx vy cv df-sn vy cv snex eqeltrri vx cv
      vy cv wceq wph wa vx cv vy cv wceq vx vx cv vy cv wceq wph pm3.26 ss2abi
      ssexi syl6eqel 19.23aiv sylbi $.
      $( [30-Dec-1996] $)
  $}

  $( The abstraction of a wff with existential uniqueness exists. $)
  euabex $p |- ( E! x ph -> { x | ph } e. _V ) $=
    wph vx weu wph vx wmo wph vx cab cvv wcel wph vx eumo wph vx moabex syl $.
    $( [25-Nov-1994] $)

  ${
    $d x y A $.
    $( A non-empty class (even if proper) has a non-empty subset. $)
    nnullss $p |- ( A =/= (/) -> E. x ( x C_ A /\ x =/= (/) ) ) $=
      cA c0 wne vy cv cA wcel vy wex vx cv cA wss vx cv c0 wne wa vx wex vy cA
      n0 vy cv cA wcel vx cv cA wss vx cv c0 wne wa vx wex vy vy cv cA wcel vy
      cv csn cA wss vx cv cA wss vx cv c0 wne wa vx wex vy cv cA vy visset snss
      vy cv csn cA wss vy cv csn c0 wne vx cv cA wss vx cv c0 wne wa vx wex vy
      cv vy visset snnz vx cv cA wss vx cv c0 wne wa vy cv csn cA wss vy cv csn
      c0 wne wa vx vy cv csn vy cv snex vx cv vy cv csn wceq vx cv cA wss vy cv
      csn cA wss vx cv c0 wne vy cv csn c0 wne vx cv vy cv csn cA sseq1 vx cv
      vy cv csn c0 neeq1 anbi12d cla4ev mpan2 sylbi 19.23aiv sylbi $.
      $( [27-May-2007] $) $( [23-Aug-2003] $)
  $}

  ${
    $d x y z A $.  $d y z ph $.
    $( Restricted existence in a class (even if proper) implies restricted
       existence in a subset. $)
    exss $p |- ( E. x e. A ph -> E. y ( y C_ A /\ E. x e. y ph ) ) $=
      wph vx cA wrex vz cv vx cv cA wcel wph wa vx cab wcel vz wex vy cv cA wss
      wph vx vy cv wrex wa vy wex wph vx cA crab c0 wne vx cv cA wcel wph wa vx
      cab c0 wne wph vx cA wrex vz cv vx cv cA wcel wph wa vx cab wcel vz wex
      wph vx cA crab vx cv cA wcel wph wa vx cab c0 wph vx cA df-rab neeq1i wph
      vx cA rabn0 vz vx cv cA wcel wph wa vx cab n0 3bitr3i vz cv vx cv cA wcel
      wph wa vx cab wcel vy cv cA wss wph vx vy cv wrex wa vy wex vz vz cv csn
      cA wss wph vx vz cv csn wrex vy cv cA wss wph vx vy cv wrex wa vy wex vz
      cv vx cv cA wcel wph wa vx cab wcel vy cv cA wss wph vx vy cv wrex wa vz
      cv csn cA wss wph vx vz cv csn wrex wa vy vz cv csn vz cv snex vy cv vz
      cv csn wceq vy cv cA wss vz cv csn cA wss wph vx vy cv wrex wph vx vz cv
      csn wrex vy cv vz cv csn cA sseq1 wph vx vy cv vz cv csn rexeq1 anbi12d
      cla4ev vz cv vx cv cA wcel wph wa vx cab wcel vz cv csn vx cv cA wcel wph
      wa vx cab wss vz cv csn cA wss vz cv vx cv cA wcel wph wa vx cab vz
      visset snss vz cv csn vx cv cA wcel wph wa vx cab wss vx cv cA wcel wph
      wa vx cab cA wss vz cv csn cA wss wph vx cA ssab2 vz cv csn vx cv cA wcel
      wph wa vx cab cA sstr2 mpi sylbi vz cv vx cv cA wcel wph wa vx cab wcel
      wph vx vz cv csn crab c0 wne wph vx vz cv csn wrex vz cv vx cv cA wcel
      wph wa vx cab wcel vz cv wph vx vz cv csn crab wcel wph vx vz cv csn crab
      c0 wne vx cv cA wcel vx vz cv wsbc wph vx vz cv wsbc wa vx cv vz cv csn
      wcel vx vz cv wsbc wph vx vz cv wsbc wa vz cv vx cv cA wcel wph wa vx cab
      wcel vz cv wph vx vz cv csn crab wcel vx cv cA wcel vx vz cv wsbc wph vx
      vz cv wsbc wa wph vx vz cv wsbc vx cv vz cv csn wcel vx vz cv wsbc vx cv
      cA wcel vx vz cv wsbc wph vx vz cv wsbc pm3.27 vx cv vz cv csn wcel vx vz
      cv wsbc vx cv vz cv wceq vx vz cv wsbc vx vz equsb1 vx cv vz cv csn wcel
      vx cv vz cv wceq vx vz vx vz cv elsn sbbii mpbir jctil vz cv vx cv cA
      wcel wph wa vx cab wcel vx cv cA wcel wph wa vx vz cv wsbc vx cv cA wcel
      vx vz cv wsbc wph vx vz cv wsbc wa vx cv cA wcel wph wa vz vx df-clab vx
      cv cA wcel wph vx vz sban bitri vz cv wph vx vz cv csn crab wcel vz cv vx
      cv vz cv csn wcel wph wa vx cab wcel vx cv vz cv csn wcel wph wa vx vz cv
      wsbc vx cv vz cv csn wcel vx vz cv wsbc wph vx vz cv wsbc wa wph vx vz cv
      csn crab vx cv vz cv csn wcel wph wa vx cab vz cv wph vx vz cv csn df-rab
      eleq2i vx cv vz cv csn wcel wph wa vz vx df-clab vx cv vz cv csn wcel wph
      vx vz sban 3bitri 3imtr4i wph vx vz cv csn crab vz cv ne0i syl wph vx vz
      cv csn rabn0 sylib sylanc 19.23aiv sylbi $.
      $( [23-Aug-2003] $)
  $}

  ${
    $d x y $.
    $( A version of ~ dtru ("two things exist") with a shorter proof using
       more axioms. $)
    dtruALT $p |- -. A. x x = y $=
      vy cv vx cv wceq wn vx wex vx cv vy cv wceq vx wal wn vy cv c0 wceq vy cv
      vx cv wceq wn vx wex vy cv c0 wceq vy cv c0 csn wceq wn vy cv vx cv wceq
      wn vx wex vy cv 0inp0 vy cv vx cv wceq wn vy cv c0 csn wceq wn vx c0 csn
      p0ex vx cv c0 csn wceq vy cv vx cv wceq vy cv c0 csn wceq vx cv c0 csn vy
      cv eqeq2 notbid cla4ev syl vy cv vx cv wceq wn vy cv c0 wceq wn vx c0 0ex
      vx cv c0 wceq vy cv vx cv wceq vy cv c0 wceq vx cv c0 vy cv eqeq2 notbid
      cla4ev pm2.61i vy cv vx cv wceq wn vx wex vy cv vx cv wceq vx wal wn vx
      cv vy cv wceq vx wal wn vy cv vx cv wceq vx exnal vy cv vx cv wceq vx wal
      vx cv vy cv wceq vx wal vy cv vx cv wceq vx cv vy cv wceq vx vy cv vx cv
      eqcom albii notbii bitri mpbi $.
      $( [15-Jul-1994] $)
  $}

  ${
    $d x y $.
    dtrucor.1 $e |- x = y $.
    $( Corollary of ~ dtru .  This example illustrates the danger of blindly
       trusting the standard Deduction Theorem without accounting for free
       variables: the theorem form of this deduction is not valid, as
       shown by ~ dtrucor2 . $)
    dtrucor $p |- x =/= y $=
      vx cv vy cv wceq vx cv vy cv wne vx vx cv vy cv wceq vx wal vx cv vy cv
      wne vx vy dtru pm2.21i dtrucor.1 mpg $.
      $( [27-Jun-2002] $)
  $}

  ${
    dtrucor2.1 $e |- ( x = y -> x =/= y ) $.
    $( The theorem form of the deduction ~ dtrucor leads to a
       contradiction, as mentioned in the "Wrong!" example at
       ~ http://us.metamath.org/mpegif/mmdeduction.html#bad . $)
    dtrucor2 $p |- ( ph /\ -. ph ) $=
      vx cv vy cv wceq vx wex wph wph wn wa vx vy a9e vx cv vy cv wceq vx vx cv
      vy cv wceq vx cv vy cv wceq wn wi vx cv vy cv wceq wn vx cv vy cv wceq vx
      cv vy cv dtrucor2.1 necon2bi vx cv vy cv wceq pm2.01 ax-mp nex pm2.24ii
      $.
      $( [20-Oct-2007] $) $( [20-Oct-2007] $)
  $}


  ${
    $d x y $.
    $( Demonstration of a theorem that requires ` x ` and ` y ` to be
       distinct, but no others.  Compare ~ dvdemo2 . $)
    dvdemo1 $p |- E. x ( x = y -> z e. x ) $=
      vx cv vy cv wceq wn vx wex vx cv vy cv wceq vz cv vx cv wcel wi vx wex vx
      cv vy cv wceq wn vx wex vx cv vy cv wceq vx wal wn vx vy dtru vx cv vy cv
      wceq vx exnal mpbir vx cv vy cv wceq wn vx cv vy cv wceq vz cv vx cv wcel
      wi vx vx cv vy cv wceq vz cv vx cv wcel pm2.21 19.22i ax-mp $.
      $( [1-Dec-2006] $) $( [1-Dec-2006] $)
  $}

  ${
    $d x z $.
    $( Demonstration of a theorem that requires ` x ` and ` z ` to be
       distinct, but no others.  Compare ~ dvdemo1 . $)
    dvdemo2 $p |- E. x ( x = y -> z e. x ) $=
      vz cv vx cv wcel vx wex vx cv vy cv wceq vz cv vx cv wcel wi vx wex vz vx
      el vz cv vx cv wcel vx cv vy cv wceq vz cv vx cv wcel wi vx vz cv vx cv
      wcel vx cv vy cv wceq ax-1 19.22i ax-mp $.
      $( [1-Dec-2006] $) $( [1-Dec-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Derive the Axiom of Pairing
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x z w v $.  $d y z w v $.
    $( The Axiom of Pairing of Zermelo-Fraenkel set theory.  Axiom 2 of
       [TakeutiZaring] p. 15.  In some textbooks this is stated as a separate
       axiom; here we show it is redundant since it can be derived from the
       other axioms.

       This theorem should not be referenced by any proof other than ~ axpr .
       Instead, use ~ zfpair2 below so that the uses of the Axiom of Pairing
       can be more easily identified. $)
    zfpair $p |- { x , y } e. _V $=
      vx cv vy cv cpr vw cv vx cv wceq vw cv vy cv wceq wo vw cab cvv vw vx cv
      vy cv dfpr2 vw cv vx cv wceq vw cv vy cv wceq wo vw cab vz cv c0 wceq vz
      cv c0 csn wceq wo vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn wceq vw
      cv vy cv wceq wa wo wa vz wex vw cab cvv vw cv vx cv wceq vw cv vy cv
      wceq wo vz cv c0 wceq vz cv c0 csn wceq wo vz cv c0 wceq vw cv vx cv wceq
      wa vz cv c0 csn wceq vw cv vy cv wceq wa wo wa vz wex vw vz cv c0 wceq vw
      cv vx cv wceq wa vz cv c0 csn wceq vw cv vy cv wceq wa wo vz wex vz cv c0
      wceq vw cv vx cv wceq wa vz wex vz cv c0 csn wceq vw cv vy cv wceq wa vz
      wex wo vz cv c0 wceq vz cv c0 csn wceq wo vz cv c0 wceq vw cv vx cv wceq
      wa vz cv c0 csn wceq vw cv vy cv wceq wa wo wa vz wex vw cv vx cv wceq vw
      cv vy cv wceq wo vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn wceq vw
      cv vy cv wceq wa vz 19.43 vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn
      wceq vw cv vy cv wceq wa wo vz cv c0 wceq vz cv c0 csn wceq wo vz cv c0
      wceq vw cv vx cv wceq wa vz cv c0 csn wceq vw cv vy cv wceq wa wo wa vz
      vz cv c0 wceq vw cv vx cv wceq vz cv c0 csn wceq vw cv vy cv wceq prlem2
      exbii vz cv c0 wceq vw cv vx cv wceq wa vz wex vw cv vx cv wceq vz cv c0
      csn wceq vw cv vy cv wceq wa vz wex vw cv vy cv wceq vz cv c0 wceq vw cv
      vx cv wceq wa vz wex vz cv c0 wceq vz wex vw cv vx cv wceq vz cv c0 wceq
      vw cv vx cv wceq vz 19.41v vz c0 0ex isseti mpbiran vz cv c0 csn wceq vw
      cv vy cv wceq wa vz wex vz cv c0 csn wceq vz wex vw cv vy cv wceq vz cv
      c0 csn wceq vw cv vy cv wceq vz 19.41v vz c0 csn p0ex isseti mpbiran
      orbi12i 3bitr3ri abbii vz cv c0 wceq vz cv c0 csn wceq wo vz cv c0 wceq
      vw cv vx cv wceq wa vz cv c0 csn wceq vw cv vy cv wceq wa wo vz vw vv c0
      c0 csn cpr vz cv c0 wceq vz cv c0 csn wceq wo vz cab cvv vz c0 c0 csn
      dfpr2 pp0ex eqeltrri vz cv c0 wceq vz cv c0 wceq vw cv vx cv wceq wa vz
      cv c0 csn wceq vw cv vy cv wceq wa wo vw cv vv cv wceq wi vw wal vv wex
      vz cv c0 csn wceq vz cv c0 wceq vz cv c0 wceq vw cv vx cv wceq wa vz cv
      c0 csn wceq vw cv vy cv wceq wa wo vw cv vv cv wceq wi vw wal vv vx vv cv
      vx cv wceq vz cv c0 wceq vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn
      wceq vw cv vy cv wceq wa wo vw cv vv cv wceq wi vw vv cv vx cv wceq vz cv
      c0 wceq vw cv vx cv wceq vz cv c0 csn wceq vw cv vy cv wceq vw cv vv cv
      wceq vv vx vw equequ2 vz cv 0inp0 prlem1 19.21adv a4imev vz cv c0 csn
      wceq vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn wceq vw cv vy cv wceq
      wa wo vw cv vv cv wceq wi vw wal vv vy vv cv vy cv wceq vz cv c0 csn wceq
      vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn wceq vw cv vy cv wceq wa
      wo vw cv vv cv wceq wi vw vv cv vy cv wceq vz cv c0 csn wceq vz cv c0 csn
      wceq vw cv vy cv wceq wa vz cv c0 wceq vw cv vx cv wceq wa wo vw cv vv cv
      wceq vz cv c0 wceq vw cv vx cv wceq wa vz cv c0 csn wceq vw cv vy cv wceq
      wa wo vv cv vy cv wceq vz cv c0 csn wceq vw cv vy cv wceq vz cv c0 wceq
      vw cv vx cv wceq vw cv vv cv wceq vv vy vw equequ2 vz cv c0 wceq vz cv c0
      csn wceq vz cv 0inp0 con2i prlem1 vz cv c0 wceq vw cv vx cv wceq wa vz cv
      c0 csn wceq vw cv vy cv wceq wa orcom syl7ib 19.21adv a4imev jaoi zfrep4
      eqeltri eqeltri $.
      $( [18-Oct-1995] $)

    $( Unabbreviated version of the Axiom of Pairing of ZF set theory, derived
       as a theorem from the other axioms.

       This theorem should not be referenced by any proof.  Instead, use
       ~ ax-pr below so that the uses of the Axiom of Pairing can be more
       easily identified. $)
    axpr $p |- E. z A. w ( ( w = x \/ w = y ) -> w e. z ) $=
      vz cv vx cv vy cv cpr wceq vz wex vw cv vx cv wceq vw cv vy cv wceq wo vw
      cv vz cv wcel wi vw wal vz wex vz vx cv vy cv cpr vx vy zfpair isseti vz
      cv vx cv vy cv cpr wceq vw cv vx cv wceq vw cv vy cv wceq wo vw cv vz cv
      wcel wi vw wal vz vz cv vx cv vy cv cpr wceq vw cv vz cv wcel vw cv vx cv
      vy cv cpr wcel wb vw wal vw cv vx cv wceq vw cv vy cv wceq wo vw cv vz cv
      wcel wi vw wal vw vz cv vx cv vy cv cpr dfcleq vw cv vz cv wcel vw cv vx
      cv vy cv cpr wcel wb vw cv vx cv wceq vw cv vy cv wceq wo vw cv vz cv
      wcel wi vw vw cv vz cv wcel vw cv vx cv vy cv cpr wcel wb vw cv vz cv
      wcel vw cv vx cv wceq vw cv vy cv wceq wo wb vw cv vx cv wceq vw cv vy cv
      wceq wo vw cv vz cv wcel wi vw cv vx cv vy cv cpr wcel vw cv vx cv wceq
      vw cv vy cv wceq wo vw cv vz cv wcel vw cv vx cv vy cv vw visset elpr
      bibi2i vw cv vz cv wcel vw cv vx cv wceq vw cv vy cv wceq wo bi2 sylbi
      19.20i sylbi 19.22i ax-mp $.
      $( [14-Nov-2006] $) $( [14-Nov-2006] $)

    $( The Axiom of Pairing of ZF set theory.  It was derived as theorem ~ axpr
       above and is therefore redundant, but we state it as a separate axiom
       here so that its uses can be identified more easily. $)
    ax-pr $a |- E. z A. w ( ( w = x \/ w = y ) -> w e. z ) $.

    $( Derive the abbreviated version of the Axiom of Pairing from ~ ax-pr .
       See ~ zfpair for its derivation from the other axioms. $)
    zfpair2 $p |- { x , y } e. _V $=
      vz vx cv vy cv cpr vz cv vx cv vy cv cpr wceq vz wex vw cv vz cv wcel vw
      cv vx cv wceq vw cv vy cv wceq wo wb vw wal vz wex vw cv vx cv wceq vw cv
      vy cv wceq wo vz vw vx vy vz vw ax-pr bm1.3ii vz cv vx cv vy cv cpr wceq
      vw cv vz cv wcel vw cv vx cv wceq vw cv vy cv wceq wo wb vw wal vz vz cv
      vx cv vy cv cpr wceq vw cv vz cv wcel vw cv vx cv vy cv cpr wcel wb vw
      wal vw cv vz cv wcel vw cv vx cv wceq vw cv vy cv wceq wo wb vw wal vw vz
      cv vx cv vy cv cpr dfcleq vw cv vz cv wcel vw cv vx cv vy cv cpr wcel wb
      vw cv vz cv wcel vw cv vx cv wceq vw cv vy cv wceq wo wb vw vw cv vx cv
      vy cv cpr wcel vw cv vx cv wceq vw cv vy cv wceq wo vw cv vz cv wcel vw
      cv vx cv vy cv vw visset elpr bibi2i albii bitri exbii mpbir issetri $.
      $( [15-Nov-2006] $) $( [14-Nov-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The Axiom of Pairing using class variables.  Theorem 7.13 of [Quine]
       p. 51.  By virtue of its definition, an unordered pair remains a set
       (even though no longer a pair) even when its components are proper
       classes (see ~ prprc ), so we can dispense with hypotheses requiring
       them to be sets. $)
    prex $p |- { A , B } e. _V $=
      cA cvv wcel cB cvv wcel cA cB cpr cvv wcel cB cvv wcel cA cB cpr cvv wcel
      wi vx cA cvv vx cv cA wceq vx cv cB cpr cvv wcel cA cB cpr cvv wcel cB
      cvv wcel vx cv cA wceq vx cv cB cpr cA cB cpr cvv vx cv cA cB preq1
      eleq1d vx cv vy cv cpr cvv wcel vx cv cB cpr cvv wcel vy cB cvv vy cv cB
      wceq vx cv vy cv cpr vx cv cB cpr cvv vy cv cB vx cv preq2 eleq1d vx vy
      zfpair2 vtoclg syl5bi vtocleg cA cvv wcel wn cA cB cpr cB csn cvv cA cB
      prprc1 cB snex syl6eqel cB cvv wcel wn cA cB cpr cA csn cvv cA cB prprc2
      cA snex syl6eqel pm2.61nii $.
      $( [5-Aug-1993] $)
  $}

  $( An ordered pair of classes is a set.  Exercise 7 of [TakeutiZaring]
     p. 16. $)
  opex $p |- <. A , B >. e. _V $=
    cA cB cop cA csn cA cB cpr cpr cvv cA cB df-op cA csn cA cB cpr prex
    eqeltri $.
    $( [18-Aug-1993] $)

  ${
    elop.1 $e |- A e. _V $.
    $( An ordered pair has two elements.  Exercise 3 of [TakeutiZaring]
       p. 15. $)
    elop $p |- ( A e. <. B , C >. <-> ( A = { B } \/ A = { B , C } ) ) $=
      cA cB cC cop wcel cA cB csn cB cC cpr cpr wcel cA cB csn wceq cA cB cC
      cpr wceq wo cB cC cop cB csn cB cC cpr cpr cA cB cC df-op eleq2i cA cB
      csn cB cC cpr elop.1 elpr bitri $.
      $( [5-Aug-1993] $)
  $}

  $( One of the two elements in an ordered pair. $)
  opi1 $p |- { A } e. <. A , B >. $=
    cA csn cA csn cA cB cpr cpr cA cB cop cA csn cA cB cpr cA snex prid1 cA cB
    df-op eleqtrri $.
    $( [5-Aug-1993] $)

  $( One of the two elements of an ordered pair. $)
  opi2 $p |- { A , B } e. <. A , B >. $=
    cA cB cpr cA csn cA cB cpr cpr cA cB cop cA csn cA cB cpr cA cB prex prid2
    cA cB df-op eleqtrri $.
    $( [5-Aug-1993] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Ordered pair theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    opth1.1 $e |- A e. _V $.
    $( Equality of the first members of equal ordered pairs, which holds
       whether or not the second members are sets. $)
    opth1 $p |- ( <. A , B >. = <. C , D >. -> A = C ) $=
      cA cB cop cC cD cop wceq cA cC csn wcel cA cC wceq cA cB cop cC cD cop
      wceq cC csn cA csn wceq cC csn cA cB cpr wceq wo cA cC csn wcel cA cB cop
      cC cD cop wceq cC csn cA cB cop wcel cC csn cA csn wceq cC csn cA cB cpr
      wceq wo cA cB cop cC cD cop wceq cC csn cA cB cop wcel cC csn cC cD cop
      wcel cC cD opi1 cA cB cop cC cD cop cC csn eleq2 mpbiri cC csn cA cB cC
      snex elop sylib cC csn cA csn wceq cA cC csn wcel cC csn cA cB cpr wceq
      cC csn cA csn wceq cA cC csn wcel cA cA csn wcel cA opth1.1 snid cC csn
      cA csn cA eleq2 mpbiri cC csn cA cB cpr wceq cA cC csn wcel cA cA cB cpr
      wcel cA cB opth1.1 prid1 cC csn cA cB cpr cA eleq2 mpbiri jaoi syl cA cC
      opth1.1 elsnc sylib $.
      $( [29-May-2008] $) $( [28-May-2008] $)
  $}

  ${
    opth.1 $e |- A e. _V $.
    opth.2 $e |- B e. _V $.
    opth.3 $e |- D e. _V $.
    $( The ordered pair theorem.  If two ordered pairs are equal, their first
       elements are equal and their second elements are equal.  Exercise
       6 of [TakeutiZaring] p. 16.  Note that ` C ` is not required to be
       a set due to a peculiarity of our specific ordered pair definition. $)
    opth $p |- ( <. A , B >. = <. C , D >. <-> ( A = C /\ B = D ) ) $=
      cA cB cop cC cD cop wceq cA cC wceq cB cD wceq wa cA cB cop cC cD cop
      wceq cA cC wceq cB cD wceq cA cB cC cD opth.1 opth1 cA cB cop cC cD cop
      wceq cA cC wceq cC cD cop cC cB cop wceq cB cD wceq cA cB cop cC cD cop
      wceq cA cB cop cC cB cop wceq cC cD cop cC cB cop wceq cA cC wceq cA cB
      cop cC cD cop cC cB cop eqeq1 cA cC cB opeq1 syl5bi cC cD cop cC cB cop
      wceq cC cD cpr cC cB cpr wceq cB cD wceq cC cD cop cC cB cop wceq cC csn
      cC cD cpr cpr cC csn cC cB cpr cpr wceq cC cD cpr cC cB cpr wceq cC cD
      cop cC csn cC cD cpr cpr cC cB cop cC csn cC cB cpr cpr cC cD df-op cC cB
      df-op eqeq12i cC cD cpr cC cB cpr cC csn cC cD prex cC cB prex preqr2
      sylbi cC cD cpr cC cB cpr wceq cD cB cD cB cC opth.3 opth.2 preqr2 eqcomd
      syl syl6 jcai cA cB cC cD opeq12 impbii $.
      $( [28-May-1995] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    opthg.1 $e |- A e. _V $.
    opthg.2 $e |- B e. _V $.
    $( Ordered pair theorem. $)
    opthg $p |- ( D e. R -> ( <. A , B >. = <. C , D >. <->
               ( A = C /\ B = D ) ) ) $=
      cA cB cop cC vx cv cop wceq cA cC wceq cB vx cv wceq wa cA cB cop cC cD
      cop wceq cA cC wceq cB cD wceq wa vx cD cR vx cv cD wceq cC vx cv cop cC
      cD cop cA cB cop vx cv cD cC opeq2 eqeq2d vx cv cD wceq cB vx cv wceq cB
      cD wceq cA cC wceq vx cv cD cB eqeq2 anbi2d cA cB cC vx cv opthg.1
      opthg.2 vx visset opth vtoclbg $.
      $( [30-Apr-1995] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x y T $.
    $( Ordered pair theorem.  ` C ` is not required to be a set under our
       specific ordered pair definition. $)
    opthgg $p |- ( ( A e. R /\ B e. S /\ D e. T ) ->
                 ( <. A , B >. = <. C , D >. <-> ( A = C /\ B = D ) ) ) $=
      cA cR wcel cB cS wcel cD cT wcel cA cB cop cC cD cop wceq cA cC wceq cB
      cD wceq wa wb cD cT wcel vx cv vy cv cop cC cD cop wceq vx cv cC wceq vy
      cv cD wceq wa wb wi cD cT wcel cA vy cv cop cC cD cop wceq cA cC wceq vy
      cv cD wceq wa wb wi cD cT wcel cA cB cop cC cD cop wceq cA cC wceq cB cD
      wceq wa wb wi vx vy cA cB cR cS vx cv cA wceq vx cv vy cv cop cC cD cop
      wceq vx cv cC wceq vy cv cD wceq wa wb cA vy cv cop cC cD cop wceq cA cC
      wceq vy cv cD wceq wa wb cD cT wcel vx cv cA wceq vx cv vy cv cop cC cD
      cop wceq cA vy cv cop cC cD cop wceq vx cv cC wceq vy cv cD wceq wa cA cC
      wceq vy cv cD wceq wa vx cv cA wceq vx cv vy cv cop cA vy cv cop cC cD
      cop vx cv cA vy cv opeq1 eqeq1d vx cv cA wceq vx cv cC wceq cA cC wceq vy
      cv cD wceq vx cv cA cC eqeq1 anbi1d bibi12d imbi2d vy cv cB wceq cA vy cv
      cop cC cD cop wceq cA cC wceq vy cv cD wceq wa wb cA cB cop cC cD cop
      wceq cA cC wceq cB cD wceq wa wb cD cT wcel vy cv cB wceq cA vy cv cop cC
      cD cop wceq cA cB cop cC cD cop wceq cA cC wceq vy cv cD wceq wa cA cC
      wceq cB cD wceq wa vy cv cB wceq cA vy cv cop cA cB cop cC cD cop vy cv
      cB cA opeq2 eqeq1d vy cv cB wceq vy cv cD wceq cB cD wceq cA cC wceq vy
      cv cB cD eqeq1 anbi2d bibi12d imbi2d vx cv vy cv cC cD cT vx visset vy
      visset opthg vtocl2g 3impia $.
      $( [15-Oct-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    $v F $.
    $v G $.
    otthg.cF $f class F $.
    otthg.cG $f class G $.
    otthg.1 $e |- A e. _V $.
    otthg.2 $e |- B e. _V $.
    otthg.3 $e |- R e. _V $.
    $( Ordered triple theorem. $)
    otthg $p |- ( ( D e. F /\ S e. G ) ->
                ( <. <. A , B >. , R >. = <. <. C , D >. , S >. <->
                ( A = C /\ B = D /\ R = S ) ) ) $=
      cD otthg.cF wcel cS otthg.cG wcel wa cA cB cop cR cop cC cD cop cS cop
      wceq cA cC wceq cB cD wceq wa cR cS wceq wa cA cC wceq cB cD wceq cR cS
      wceq w3a cS otthg.cG wcel cA cB cop cR cop cC cD cop cS cop wceq cA cB
      cop cC cD cop wceq cR cS wceq wa cD otthg.cF wcel cA cC wceq cB cD wceq
      wa cR cS wceq wa cA cB cop cR cC cD cop cS otthg.cG cA cB opex otthg.3
      opthg cD otthg.cF wcel cA cB cop cC cD cop wceq cA cC wceq cB cD wceq wa
      cR cS wceq cA cB cC cD otthg.cF otthg.1 otthg.2 opthg anbi1d sylan9bbr cA
      cC wceq cB cD wceq cR cS wceq df-3an syl6bbr $.
      $( [1-May-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    eqvinop.1 $e |- B e. _V $.
    eqvinop.2 $e |- C e. _V $.
    $( A variable introduction law for ordered pairs.  Analogue of Lemma 15
       of [Monk2] p. 109. $)
    eqvinop $p |- ( A = <. B , C >. <-> E. x E. y ( A = <. x , y >. /\
                  <. x , y >. = <. B , C >. ) ) $=
      cA vx cv vy cv cop wceq vx cv vy cv cop cB cC cop wceq wa vy wex vx wex
      vx cv cB wceq cA vx cv cC cop wceq wa vx wex cA cB cC cop wceq cA vx cv
      vy cv cop wceq vx cv vy cv cop cB cC cop wceq wa vy wex vx cv cB wceq cA
      vx cv cC cop wceq wa vx cA vx cv vy cv cop wceq vx cv vy cv cop cB cC cop
      wceq wa vy wex vx cv cB wceq vy cv cC wceq cA vx cv vy cv cop wceq wa wa
      vy wex vx cv cB wceq vy cv cC wceq cA vx cv vy cv cop wceq wa vy wex wa
      vx cv cB wceq cA vx cv cC cop wceq wa cA vx cv vy cv cop wceq vx cv vy cv
      cop cB cC cop wceq wa vx cv cB wceq vy cv cC wceq cA vx cv vy cv cop wceq
      wa wa vy cA vx cv vy cv cop wceq vx cv vy cv cop cB cC cop wceq wa cA vx
      cv vy cv cop wceq vx cv cB wceq vy cv cC wceq wa wa vx cv cB wceq vy cv
      cC wceq wa cA vx cv vy cv cop wceq wa vx cv cB wceq vy cv cC wceq cA vx
      cv vy cv cop wceq wa wa vx cv vy cv cop cB cC cop wceq vx cv cB wceq vy
      cv cC wceq wa cA vx cv vy cv cop wceq vx cv vy cv cB cC vx visset vy
      visset eqvinop.2 opth anbi2i cA vx cv vy cv cop wceq vx cv cB wceq vy cv
      cC wceq wa ancom vx cv cB wceq vy cv cC wceq cA vx cv vy cv cop wceq
      anass 3bitri exbii vx cv cB wceq vy cv cC wceq cA vx cv vy cv cop wceq wa
      vy 19.42v vy cv cC wceq cA vx cv vy cv cop wceq wa vy wex cA vx cv cC cop
      wceq vx cv cB wceq cA vx cv vy cv cop wceq cA vx cv cC cop wceq vy cC
      eqvinop.2 vy cv cC wceq vx cv vy cv cop vx cv cC cop cA vy cv cC vx cv
      opeq2 eqeq2d ceqsexv anbi2i 3bitri exbii cA vx cv cC cop wceq cA cB cC
      cop wceq vx cB eqvinop.1 vx cv cB wceq vx cv cC cop cB cC cop cA vx cv cB
      cC opeq1 eqeq2d ceqsexv bitr2i $.
      $( [28-May-1995] $)
  $}

  ${
    $d x y z w A $.  $d z w ph $.
    $( Substitution of class ` A ` for ordered pair ` <. x , y >. ` . $)
    copsexg $p |- ( A = <. x , y >. ->
                  ( ph <-> E. x E. y ( A = <. x , y >. /\ ph ) ) ) $=
      cA vx cv vy cv cop wceq wph cA vx cv vy cv cop wceq wph wa vy wex vx wex
      wb cA vx cv vy cv cop wceq cA vz cv vw cv cop wceq vz cv vw cv cop vx cv
      vy cv cop wceq wa vw wex vz wex cA vx cv vy cv cop wceq wph cA vx cv vy
      cv cop wceq wph wa vy wex vx wex wb wi vz vw cA vx cv vy cv vx visset vy
      visset eqvinop cA vz cv vw cv cop wceq vz cv vw cv cop vx cv vy cv cop
      wceq wa cA vx cv vy cv cop wceq wph cA vx cv vy cv cop wceq wph wa vy wex
      vx wex wb wi vz vw cA vz cv vw cv cop wceq cA vx cv vy cv cop wceq wph cA
      vx cv vy cv cop wceq wph wa vy wex vx wex wb wi vz cv vw cv cop vx cv vy
      cv cop wceq cA vz cv vw cv cop wceq cA vx cv vy cv cop wceq wph cA vx cv
      vy cv cop wceq wph wa vy wex vx wex wb wi vz cv vw cv cop vx cv vy cv cop
      wceq wph vz cv vw cv cop vx cv vy cv cop wceq wph wa vy wex vx wex wb wi
      vz cv vw cv cop vx cv vy cv cop wceq wph vx cv vz cv wceq vy cv vw cv
      wceq wph wa vy wex wa vx wex vz cv vw cv cop vx cv vy cv cop wceq wph wa
      vy wex vx wex vz cv vw cv cop vx cv vy cv cop wceq vx cv vz cv wceq vy cv
      vw cv wceq wa wph vx cv vz cv wceq vy cv vw cv wceq wph wa vy wex wa vx
      wex wb vz cv vw cv cop vx cv vy cv cop wceq vx cv vy cv cop vz cv vw cv
      cop wceq vx cv vz cv wceq vy cv vw cv wceq wa vz cv vw cv cop vx cv vy cv
      cop eqcom vx cv vy cv vz cv vw cv vx visset vy visset vw visset opth
      bitri vy cv vw cv wceq wph vy cv vw cv wceq wph wa vy wex vx cv vz cv
      wceq vx cv vz cv wceq vy cv vw cv wceq wph wa vy wex wa vx wex wph vy vw
      cv ceqex vy cv vw cv wceq wph wa vy wex vx vz cv ceqex sylan9bbr sylbi vz
      cv vw cv cop vx cv vy cv cop wceq wph wa vy wex vx cv vz cv wceq vy cv vw
      cv wceq wph wa vy wex wa vx vz cv vw cv cop vx cv vy cv cop wceq wph wa
      vy wex vx cv vz cv wceq vy cv vw cv wceq wph wa wa vy wex vx cv vz cv
      wceq vy cv vw cv wceq wph wa vy wex wa vz cv vw cv cop vx cv vy cv cop
      wceq wph wa vx cv vz cv wceq vy cv vw cv wceq wph wa wa vy vz cv vw cv
      cop vx cv vy cv cop wceq wph wa vx cv vz cv wceq vy cv vw cv wceq wa wph
      wa vx cv vz cv wceq vy cv vw cv wceq wph wa wa vz cv vw cv cop vx cv vy
      cv cop wceq vx cv vz cv wceq vy cv vw cv wceq wa wph vz cv vw cv cop vx
      cv vy cv cop wceq vx cv vy cv cop vz cv vw cv cop wceq vx cv vz cv wceq
      vy cv vw cv wceq wa vz cv vw cv cop vx cv vy cv cop eqcom vx cv vy cv vz
      cv vw cv vx visset vy visset vw visset opth bitri anbi1i vx cv vz cv wceq
      vy cv vw cv wceq wph anass bitri exbii vx cv vz cv wceq vy cv vw cv wceq
      wph wa vy 19.42v bitri exbii syl6bbr cA vz cv vw cv cop wceq cA vx cv vy
      cv cop wceq vz cv vw cv cop vx cv vy cv cop wceq wph cA vx cv vy cv cop
      wceq wph wa vy wex vx wex wb wph vz cv vw cv cop vx cv vy cv cop wceq wph
      wa vy wex vx wex wb cA vz cv vw cv cop vx cv vy cv cop eqeq1 cA vz cv vw
      cv cop wceq cA vx cv vy cv cop wceq wph wa vy wex vx wex vz cv vw cv cop
      vx cv vy cv cop wceq wph wa vy wex vx wex wph cA vz cv vw cv cop wceq cA
      vx cv vy cv cop wceq wph wa vz cv vw cv cop vx cv vy cv cop wceq wph wa
      vx vy cA vz cv vw cv cop wceq cA vx cv vy cv cop wceq vz cv vw cv cop vx
      cv vy cv cop wceq wph cA vz cv vw cv cop vx cv vy cv cop eqeq1 anbi1d
      2exbidv bibi2d imbi12d mpbiri adantr 19.23aivv sylbi pm2.43i $.
      $( [27-Dec-1996] $)
  $}

  ${
    $d x y ps $.  $d x y A $.  $d x y B $.
    copsex2g.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for ordered pairs. $)
    copsex2g $p |- ( ( A e. C /\ B e. D ) ->
                  ( E. x E. y ( <. A , B >. = <. x , y >. /\ ph ) <-> ps ) ) $=
      vx cv cA wceq vx wex vy cv cB wceq vy wex cA cB cop vx cv vy cv cop wceq
      wph wa vy wex vx wex wps wb cA cC wcel cB cD wcel vx cv cA wceq vx wex vy
      cv cB wceq vy wex wa vx cv cA wceq vy cv cB wceq wa vy wex vx wex cA cB
      cop vx cv vy cv cop wceq wph wa vy wex vx wex wps wb vx cv cA wceq vy cv
      cB wceq vx vy eeanv vx cv cA wceq vy cv cB wceq wa vy wex cA cB cop vx cv
      vy cv cop wceq wph wa vy wex vx wex wps wb vx cA cB cop vx cv vy cv cop
      wceq wph wa vy wex vx wex wps vx cA cB cop vx cv vy cv cop wceq wph wa vy
      wex vx hbe1 wps vx ax-17 hbbi vx cv cA wceq vy cv cB wceq wa cA cB cop vx
      cv vy cv cop wceq wph wa vy wex vx wex wps wb vy cA cB cop vx cv vy cv
      cop wceq wph wa vy wex vx wex wps vy cA cB cop vx cv vy cv cop wceq wph
      wa vy wex vy vx cA cB cop vx cv vy cv cop wceq wph wa vy hbe1 hbex wps vy
      ax-17 hbbi vx cv cA wceq vy cv cB wceq wa wph cA cB cop vx cv vy cv cop
      wceq wph wa vy wex vx wex wps vx cv cA wceq vy cv cB wceq wa vx cv vy cv
      cop cA cB cop wceq wph cA cB cop vx cv vy cv cop wceq wph wa vy wex vx
      wex wb vx cv vy cv cA cB opeq12 wph cA cB cop vx cv vy cv cop wceq wph wa
      vy wex vx wex wb cA cB cop vx cv vy cv cop wph vx vy cA cB cop copsexg
      eqcoms syl copsex2g.1 bitr3d 19.23ai 19.23ai sylbir vx cA cC elex vy cB
      cD elex syl2an $.
      $( [28-May-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x y z w ps $.  $d x y z w R $.  $d x y z w S $.
    copsex4g.1 $e |- ( ( ( x = A /\ y = B ) /\ ( z = C /\ w = D ) ) ->
                     ( ph <-> ps ) ) $.
    $( An implicit substitution inference for 2 ordered pairs. $)
    copsex4g $p |- ( ( ( A e. R /\ B e. S ) /\ ( C e. R /\ D e. S ) ) ->
                      ( E. x E. y E. z E. w ( ( <. A , B >. = <. x , y >. /\
                      <. C , D >. = <. z , w >. ) /\ ph ) <-> ps ) ) $=
      cA cR wcel cB cS wcel wa cC cR wcel cD cS wcel wa wa cA cB cop vx cv vy
      cv cop wceq cC cD cop vz cv vw cv cop wceq wa wph wa vw wex vz wex vy wex
      vx wex vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv cD wceq wa wa
      wph wa vw wex vz wex vy wex vx wex wps cA cR wcel cB cS wcel wa cC cR
      wcel cD cS wcel wa wa cA cB cop vx cv vy cv cop wceq cC cD cop vz cv vw
      cv cop wceq wa wph wa vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv
      cD wceq wa wa wph wa vx vy vz vw cA cR wcel cB cS wcel wa cC cR wcel cD
      cS wcel wa wa cA cB cop vx cv vy cv cop wceq cC cD cop vz cv vw cv cop
      wceq wa vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv cD wceq wa wa
      wph cA cR wcel cB cS wcel wa cA cB cop vx cv vy cv cop wceq vx cv cA wceq
      vy cv cB wceq wa cC cR wcel cD cS wcel wa cC cD cop vz cv vw cv cop wceq
      vz cv cC wceq vw cv cD wceq wa cB cS wcel cA cB cop vx cv vy cv cop wceq
      vx cv cA wceq vy cv cB wceq wa wb cA cR wcel cB cS wcel vx cv vy cv cop
      cA cB cop wceq vx cv cA wceq vy cv cB wceq wa cA cB cop vx cv vy cv cop
      wceq vx cv vy cv cA cB cS vx visset vy visset opthg cA cB cop vx cv vy cv
      cop eqcom syl5bb adantl cD cS wcel cC cD cop vz cv vw cv cop wceq vz cv
      cC wceq vw cv cD wceq wa wb cC cR wcel cD cS wcel vz cv vw cv cop cC cD
      cop wceq vz cv cC wceq vw cv cD wceq wa cC cD cop vz cv vw cv cop wceq vz
      cv vw cv cC cD cS vz visset vw visset opthg cC cD cop vz cv vw cv cop
      eqcom syl5bb adantl bi2anan9 anbi1d 4exbidv wph wps vx cv cA wceq vy cv
      cB wceq wa vz cv cC wceq vw cv cD wceq wa wa vx vy vz vw cA cB cC cD cR
      cS vx cv cA wceq vy cv cB wceq wa vz cv cC wceq vw cv cD wceq wa wa id
      copsex4g.1 cgsex4g bitrd $.
      $( [5-Aug-1995] $)
  $}

  $( An ordered pair is not empty. $)
  opnz $p |- -. <. A , B >. = (/) $=
    cA csn cA cB cop wcel cA cB cop c0 wceq wn cA cB opi1 cA cB cop cA csn n0i
    ax-mp $.
    $( [24-Jan-2004] $) $( [24-Jan-2004] $)

  ${
    $d x A $.  $d x B $.
    $( A property of an ordered pair of proper classes (due to our
       particular definition of ordered pair). $)
    opprc1b $p |- ( -. A e. _V <-> (/) e. <. A , B >. ) $=
      cA cvv wcel wn c0 cA cB cop wcel cA cvv wcel wn c0 cB csn cpr cA cB cop
      c0 cA cB opprc1 c0 cB csn 0ex prid1 syl5eleqr cA cvv wcel c0 cA cB cop
      wcel c0 vx cv cB cop wcel wn c0 cA cB cop wcel wn vx cA cvv vx cv cA wceq
      c0 vx cv cB cop wcel c0 cA cB cop wcel vx cv cA wceq vx cv cB cop cA cB
      cop c0 vx cv cA cB opeq1 eleq2d notbid c0 vx cv cB cop wcel c0 vx cv csn
      wceq c0 vx cv cB cpr wceq wo c0 vx cv csn wceq c0 vx cv cB cpr wceq vx cv
      csn c0 wceq c0 vx cv csn wceq vx cv csn c0 wne vx cv csn c0 wceq wn vx cv
      vx visset snnz vx cv csn c0 df-ne mpbi vx cv csn c0 eqcom mtbi vx cv cB
      cpr c0 wceq c0 vx cv cB cpr wceq vx cv cB cpr c0 wne vx cv cB cpr c0 wceq
      wn vx cv cB vx visset prnz vx cv cB cpr c0 df-ne mpbi vx cv cB cpr c0
      eqcom mtbi pm3.2ni c0 vx cv cB 0ex elop mtbir vtoclg con2i impbii $.
      $( [15-Nov-1994] $)
  $}

  $( A property of an ordered pair of proper classes (due to our
     particular definition of ordered pair). $)
  opprc3 $p |- ( ( -. A e. _V /\ -. B e. _V ) <-> <. A , B >. = { (/) } ) $=
    cA cvv wcel wn cB cvv wcel wn wa cA cB cop c0 csn wceq cA cvv wcel wn cB
    cvv wcel wn wa cA cB cop c0 c0 cpr c0 csn cB cvv wcel wn cA cvv wcel wn cA
    cB cop cA cA cop c0 c0 cpr cA cB opprc2 cA cvv wcel wn cA cA cop c0 cA csn
    cpr c0 c0 cpr cA cA opprc1 cA cvv wcel wn cA csn c0 wceq c0 cA csn cpr c0
    c0 cpr wceq cA snprc cA csn c0 c0 preq2 sylbi eqtrd sylan9eqr c0 dfsn2
    syl6eqr cA cvv wcel wn cA cB cop c0 csn wceq cA cvv wcel wn cB cvv wcel wn
    wa cA cB cop c0 csn wceq c0 cA cB cop wcel cA cvv wcel wn cA cB cop c0 csn
    wceq c0 cA cB cop wcel c0 c0 csn wcel c0 0ex snid cA cB cop c0 csn c0 eleq2
    mpbiri cA cB opprc1b sylibr cA cvv wcel wn cA cB cop c0 csn wceq cB cvv
    wcel wn cA cvv wcel wn cA cB cop c0 csn wceq c0 cB csn cpr c0 csn wceq cB
    cvv wcel wn cA cvv wcel wn cA cB cop c0 cB csn cpr c0 csn cA cB opprc1
    eqeq1d c0 cB csn cpr c0 c0 cpr wceq cB csn c0 wceq c0 cB csn cpr c0 csn
    wceq cB cvv wcel wn cB csn c0 c0 cB snex 0ex preqr2 c0 csn c0 c0 cpr c0 cB
    csn cpr c0 dfsn2 eqeq2i cB snprc 3imtr4i syl6bi anc2li mpcom impbii $.
    $( [17-May-1998] $)

  $( Equivalence of existence implied by equality of ordered pairs. $)
  opeqex $p |- ( <. A , B >. = <. C , D >. -> ( A e. _V <-> C e. _V ) ) $=
    cA cB cop cC cD cop wceq cA cvv wcel cC cvv wcel cA cB cop cC cD cop wceq
    c0 cA cB cop wcel c0 cC cD cop wcel cA cvv wcel wn cC cvv wcel wn cA cB cop
    cC cD cop c0 eleq2 cA cB opprc1b cC cD opprc1b 3bitr4g con4bid $.
    $( [13-Jun-2008] $) $( [28-May-2008] $)

  $( Equivalence of existence implied by equality of ordered triples. $)
  oteqex $p |- ( <. <. A , B >. , C >. = <. <. R , S >. , T >. ->
           ( A e. _V <-> R e. _V ) ) $=
    cA cB cop cC cop cR cS cop cT cop wceq cA cB cop cR cS cop wceq cA cvv wcel
    cR cvv wcel wb cA cB cop cC cR cS cop cT cA cB opex opth1 cA cB cR cS
    opeqex syl $.
    $( [26-Jun-2008] $) $( [28-May-2008] $)

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    opth2.1 $e |- B e. _V $.
    opth2.2 $e |- D e. _V $.
    $( Equality of the second members of equal ordered pairs.  Because of our
       particular ordered pair definition, equality holds whether or not
       the first members are sets. $)
    opth2 $p |- ( <. A , B >. = <. C , D >. -> B = D ) $=
      cA cvv wcel cA cB cop cC cD cop wceq cB cD wceq wi vx cv cB cop cC cD cop
      wceq cB cD wceq wi cA cB cop cC cD cop wceq cB cD wceq wi vx cA cvv vx cv
      cA wceq vx cv cB cop cC cD cop wceq cA cB cop cC cD cop wceq cB cD wceq
      vx cv cA wceq vx cv cB cop cA cB cop cC cD cop vx cv cA cB opeq1 eqeq1d
      imbi1d vx cv cB cop cC cD cop wceq vx cv cC wceq cB cD wceq vx cv cB cC
      cD vx visset opth2.1 opth2.2 opth pm3.27bi vtoclg cA cvv wcel wn cC cvv
      wcel cA cB cop cC cD cop wceq cB cD wceq wi cA cvv wcel wn cC cvv wcel wa
      cA cB cop cC cD cop wceq cB cD wceq c0 cA cB cop wcel c0 cC cD cop wcel
      wn cA cB cop cC cD cop wceq wn cA cvv wcel wn cC cvv wcel c0 cA cB cop cC
      cD cop nelneq2 cA cB opprc1b c0 cC cD cop wcel wn cC cvv wcel cC cvv wcel
      c0 cC cD cop wcel cC cD opprc1b con1bii bicomi syl2anb pm2.21d cA cvv
      wcel wn cC cvv wcel wn wa cA cB cop cC cD cop wceq c0 cB csn cpr c0 cD
      csn cpr wceq cB cD wceq cA cvv wcel wn cC cvv wcel wn cA cB cop c0 cB csn
      cpr cC cD cop c0 cD csn cpr cA cB opprc1 cC cD opprc1 eqeqan12d c0 cB csn
      cpr c0 cD csn cpr wceq cB csn cD csn wceq cB cD wceq cB csn cD csn c0 cB
      snex cD snex preqr2 cB cD opth2.1 sneqr syl syl6bi pm2.61dan pm2.61i $.
      $( [12-Apr-2004] $) $( [10-Apr-2004] $)
  $}

  ${
    opcom.1 $e |- A e. _V $.
    $( An ordered pair commutes iff its members are equal. $)
    opcom $p |- ( <. A , B >. = <. B , A >. <-> A = B ) $=
      cA cB cop cB cA cop wceq cB cvv wcel cA cB wceq cA cB cop cB cA cop wceq
      cA cvv wcel cB cvv wcel opcom.1 cA cB cB cA opeqex mpbii cA cB wceq cA
      cvv wcel cB cvv wcel opcom.1 cA cB cvv eleq1 mpbii cB cvv wcel cA cB cop
      cB cA cop wceq cA cB wceq cB cA wceq wa cA cB wceq cA cvv wcel cB cvv
      wcel cA cvv wcel cA cB cop cB cA cop wceq cA cB wceq cB cA wceq wa wb
      opcom.1 opcom.1 cA cB cB cA cvv cvv cvv opthgg mp3an13 cA cB wceq cB cA
      wceq wa cA cB wceq cA cB wceq wa cA cB wceq cB cA wceq cA cB wceq cA cB
      wceq cB cA eqcom anbi2i cA cB wceq anidm bitri syl6bb pm5.21nii $.
      $( [28-May-2009] $) $( [28-May-2009] $)
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( "At most one" property of an ordered pair.  The proof is a little tricky
       because we do not place any restrictions on class ` B ` . $)
    moop2 $p |- E* x A = <. B , x >. $=
      cA cB vx cv cop wceq vx wmo cA cB vx cv cop wceq cA vx vy cv cB csb vy cv
      cop wceq wa vx cv vy cv wceq wi vy wal vx wal cA cB vx cv cop wceq cA vx
      vy cv cB csb vy cv cop wceq wa vx cv vy cv wceq wi vx vy cA cB vx cv cop
      wceq cA vx vy cv cB csb vy cv cop wceq wa cB vx cv cop vx vy cv cB csb vy
      cv cop wceq vx cv vy cv wceq cA cB vx cv cop vx vy cv cB csb vy cv cop
      eqtr2 cB vx cv vx vy cv cB csb vy cv vx visset vy visset opth2 syl gen2
      cA cB vx cv cop wceq cA vx vy cv cB csb vy cv cop wceq vx vy vx vz vz cA
      vx vy cv cB csb vy cv cop vz cv cA wcel vx ax-17 vx vz vx vy cv cB csb vy
      cv vx vz vy cv cB vy visset vz cv vy cv wcel vx ax-17 hbcsb1 vz cv vy cv
      wcel vx ax-17 hbop hbeq vx cv vy cv wceq cB vx cv cop vx vy cv cB csb vy
      cv cop cA vx cv vy cv wceq cB vx cv cop vx vy cv cB csb vx cv cop vx vy
      cv cB csb vy cv cop vx cv vy cv wceq cB vx vy cv cB csb vx cv vx vy cv cB
      csbeq1a opeq1d vx cv vy cv vx vy cv cB csb opeq2 eqtrd eqeq2d mo4f mpbir
      $.
      $( [19-Dec-2008] $) $( [11-Apr-2004] $)
  $}

  ${
    opeqsn.1 $e |- A e. _V $.
    opeqsn.2 $e |- B e. _V $.
    opeqsn.3 $e |- C e. _V $.
    $( Equivalence for an ordered pair equal to a singleton. $)
    opeqsn $p |- ( <. A , B >. = { C } <-> ( A = B /\ C = { A } ) ) $=
      cA cB cop cC csn wceq cA csn cA cB cpr cpr cC csn wceq cA csn cA cB cpr
      wceq cA cB cpr cC wceq wa cA cB wceq cC cA csn wceq wa cA cB cop cA csn
      cA cB cpr cpr cC csn cA cB df-op eqeq1i cA csn cA cB cpr cC cA snex cA cB
      prex opeqsn.3 preqsn cA csn cA cB cpr wceq cA cB cpr cC wceq wa cA cB
      wceq cA cB cpr cC wceq wa cA cB wceq cC cA csn wceq wa cA csn cA cB cpr
      wceq cA cB wceq cA cB cpr cC wceq cA csn cA cB cpr wceq cA cB cpr cA csn
      wceq cA cB wceq cB cA wceq wa cA cB wceq cA csn cA cB cpr eqcom cA cB cA
      opeqsn.1 opeqsn.2 opeqsn.1 preqsn cA cB wceq cB cA wceq wa cA cB wceq cA
      cB wceq wa cA cB wceq cB cA wceq cA cB wceq cA cB wceq cB cA eqcom anbi2i
      cA cB wceq anidm bitri 3bitri anbi1i cA cB wceq cA cB cpr cC wceq cC cA
      csn wceq cA cB wceq cA cB cpr cC wceq cA csn cC wceq cC cA csn wceq cA cB
      wceq cA cB cpr cA csn cC cA cB wceq cA cA cpr cA cB cpr cA csn cA cB cA
      preq2 cA dfsn2 syl5req eqeq1d cA csn cC eqcom syl6bb pm5.32i bitri 3bitri
      $.
      $( [5-Jun-2008] $) $( [3-Jun-2008] $)
  $}

  ${
    opeqpr.3 $e |- C e. _V $.
    opeqpr.4 $e |- D e. _V $.
    $( Equivalence for an ordered pair equal to an unordered pair. $)
    opeqpr $p |- ( <. A , B >. = { C , D }
  <-> ( ( C = { A } /\ D = { A , B } ) \/ ( C = { A , B } /\ D = { A } ) ) ) $=
      cA cB cop cC cD cpr wceq cC cD cpr cA cB cop wceq cC cD cpr cA csn cA cB
      cpr cpr wceq cC cA csn wceq cD cA cB cpr wceq wa cC cA cB cpr wceq cD cA
      csn wceq wa wo cA cB cop cC cD cpr eqcom cA cB cop cA csn cA cB cpr cpr
      cC cD cpr cA cB df-op eqeq2i cC cD cA csn cA cB cpr opeqpr.3 opeqpr.4 cA
      snex cA cB prex preq12b 3bitri $.
      $( [6-Jun-2008] $) $( [3-Jun-2008] $)
  $}

  ${
    $d x y z A $.
    $( "At most one" remains true inside ordered pair quantification. $)
    mosubopt $p |- ( A. y A. z E* x ph ->
                 E* x E. y E. z ( A = <. y , z >. /\ ph ) ) $=
      wph vx wmo vz wal vy wal cA vy cv vz cv cop wceq vz wex vy wex cA vy cv
      vz cv cop wceq wph wa vz wex vy wex vx wmo wph vx wmo vz wal vy wal cA vy
      cv vz cv cop wceq vz wex cA vy cv vz cv cop wceq wph wa vz wex vy wex vx
      wmo vy wph vx wmo vz wal vy hba1 cA vy cv vz cv cop wceq wph wa vz wex vy
      wex vy vx cA vy cv vz cv cop wceq wph wa vz wex vy hbe1 hbmo wph vx wmo
      vz wal cA vy cv vz cv cop wceq vz wex cA vy cv vz cv cop wceq wph wa vz
      wex vy wex vx wmo wi vy wph vx wmo vz wal cA vy cv vz cv cop wceq cA vy
      cv vz cv cop wceq wph wa vz wex vy wex vx wmo vz wph vx wmo vz hba1 cA vy
      cv vz cv cop wceq wph wa vz wex vy wex vz vx cA vy cv vz cv cop wceq wph
      wa vz wex vz vy cA vy cv vz cv cop wceq wph wa vz hbe1 hbex hbmo wph vx
      wmo cA vy cv vz cv cop wceq cA vy cv vz cv cop wceq wph wa vz wex vy wex
      vx wmo wi vz cA vy cv vz cv cop wceq wph vx wmo cA vy cv vz cv cop wceq
      wph wa vz wex vy wex vx wmo cA vy cv vz cv cop wceq wph cA vy cv vz cv
      cop wceq wph wa vz wex vy wex vx cA vy cv vz cv cop wceq vx ax-17 wph vy
      vz cA copsexg mobid biimpcd a4s 19.23ad a4s 19.23ad cA vy cv vz cv cop
      wceq vz wex vy wex wn cA vy cv vz cv cop wceq wph wa vz wex vy wex vx wex
      wn cA vy cv vz cv cop wceq wph wa vz wex vy wex vx wmo cA vy cv vz cv cop
      wceq wph wa vz wex vy wex vx wex cA vy cv vz cv cop wceq vz wex vy wex cA
      vy cv vz cv cop wceq wph wa vz wex vy wex cA vy cv vz cv cop wceq vz wex
      vy wex vx cA vy cv vz cv cop wceq wph wa cA vy cv vz cv cop wceq vy vz cA
      vy cv vz cv cop wceq wph pm3.26 19.22i2 19.23aiv con3i cA vy cv vz cv cop
      wceq wph wa vz wex vy wex vx wex cA vy cv vz cv cop wceq wph wa vz wex vy
      wex vx wmo cA vy cv vz cv cop wceq wph wa vz wex vy wex vx exmo ori syl
      pm2.61d1 $.
      $( [28-Aug-2007] $) $( [28-Aug-2007] $)
  $}

  ${
    $d x y z A $.
    mosubop.1 $e |- E* x ph $.
    $( "At most one" remains true inside ordered pair quantification. $)
    mosubop $p |- E* x E. y E. z ( A = <. y , z >. /\ ph ) $=
      wph vx wmo vz wal vy wal cA vy cv vz cv cop wceq wph wa vz wex vy wex vx
      wmo wph vx wmo vy vz mosubop.1 gen2 wph vx vy vz cA mosubopt ax-mp $.
      $( [28-May-1995] $)
  $}

  ${
    $d x ph $.  $d x A $.  $d x y $.
    $( Transfer existential uniqueness to second member of an ordered pair. $)
    euop2 $p |- ( E! x E. y ( x = <. A , y >. /\ ph ) <-> E! y ph ) $=
      wph vx vy cA vy cv cop cA vy cv opex vy vx cv cA moop2 euxfr2 $.
      $( [14-Apr-2004] $) $( [10-Apr-2004] $)
  $}

  ${
    opthw.1 $e |- A e. _V $.
    opthw.2 $e |- B e. _V $.
    $( Justification theorem for the ordered pair definition in Norbert Wiener,
       "A simplification of the logic of relations," _Proc. of the Cambridge
       Philos. Soc_., 1914, vol. 17, pp.387-390.  It is also shown as a
       definition in [Enderton] p. 36 and as Exercise 4.8(b) of [Mendelson]
       p. 230.  It is meaningful only for classes that exist as sets (i.e.
       are not proper classes).  See ~ df-op for other ordered pair
       definitions. $)
    opthwiener $p |- ( { { { A } , (/) } , { { B } } } =
                    { { { C } , (/) } , { { D } } } <-> ( A = C /\ B = D ) ) $=
      cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr wceq cA cC wceq
      cB cD wceq wa cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr
      wceq cA cC wceq cB cD wceq cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD
      csn csn cpr wceq cA csn cC csn wceq cA cC wceq cA csn c0 cpr cB csn csn
      cpr cC csn c0 cpr cD csn csn cpr wceq cA csn c0 cpr cC csn c0 cpr wceq cA
      csn cC csn wceq cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr
      wceq cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cB csn csn cpr wceq cA
      csn c0 cpr cC csn c0 cpr wceq cA csn c0 cpr cB csn csn cpr cC csn c0 cpr
      cD csn csn cpr wceq cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn
      cpr cC csn c0 cpr cB csn csn cpr cA csn c0 cpr cB csn csn cpr cC csn c0
      cpr cD csn csn cpr wceq id cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD
      csn csn cpr wceq cB csn csn cD csn csn wceq cC csn c0 cpr cB csn csn cpr
      cC csn c0 cpr cD csn csn cpr wceq cA csn c0 cpr cB csn csn cpr cC csn c0
      cpr cD csn csn cpr wceq cB csn csn cC csn c0 cpr wceq cB csn csn cD csn
      csn wceq wo cB csn csn cD csn csn wceq cA csn c0 cpr cB csn csn cpr cC
      csn c0 cpr cD csn csn cpr wceq cB csn csn cC csn c0 cpr cD csn csn cpr
      wcel cB csn csn cC csn c0 cpr wceq cB csn csn cD csn csn wceq wo cA csn
      c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr wceq cB csn csn cA csn
      c0 cpr cB csn csn cpr wcel cB csn csn cC csn c0 cpr cD csn csn cpr wcel
      cA csn c0 cpr cB csn csn cB csn snex prid2 cA csn c0 cpr cB csn csn cpr
      cC csn c0 cpr cD csn csn cpr cB csn csn eleq2 mpbii cB csn csn cC csn c0
      cpr cD csn csn cB csn snex elpr sylib cB csn csn cC csn c0 cpr wceq wn cB
      csn csn cD csn csn wceq cB csn csn cC csn c0 cpr wceq cB csn csn cD csn
      csn wceq wo wb cC csn c0 cpr cB csn csn wceq cB csn csn cC csn c0 cpr
      wceq c0 cC csn c0 cpr wcel c0 cB csn csn wcel wn cC csn c0 cpr cB csn csn
      wceq wn cC csn c0 0ex prid2 c0 cB csn csn wcel cB csn c0 cB opthw.2 snnz
      c0 cB csn csn wcel c0 cB csn wceq cB csn c0 wceq c0 cB csn 0ex elsnc c0
      cB csn eqcom bitri nemtbir c0 cC csn c0 cpr cB csn csn nelneq2 mp2an cC
      csn c0 cpr cB csn csn eqcom mtbi cB csn csn cC csn c0 cpr wceq cB csn csn
      cD csn csn wceq biorf ax-mp sylibr cB csn csn cD csn csn cC csn c0 cpr
      preq2 syl eqtr4d cA csn c0 cpr cC csn c0 cpr cB csn csn cA csn c0 prex cC
      csn c0 prex preqr1 syl cA csn cC csn c0 cA snex cC snex preqr1 syl cA cC
      opthw.1 sneqr syl cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn
      cpr wceq cB csn csn cD csn csn wceq cB csn cD csn wceq cB cD wceq cA csn
      c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr wceq cB csn csn cC csn
      c0 cpr wceq cB csn csn cD csn csn wceq wo cB csn csn cD csn csn wceq cA
      csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr wceq cB csn csn cC
      csn c0 cpr cD csn csn cpr wcel cB csn csn cC csn c0 cpr wceq cB csn csn
      cD csn csn wceq wo cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn
      cpr wceq cB csn csn cA csn c0 cpr cB csn csn cpr wcel cB csn csn cC csn
      c0 cpr cD csn csn cpr wcel cA csn c0 cpr cB csn csn cB csn snex prid2 cA
      csn c0 cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr cB csn csn eleq2
      mpbii cB csn csn cC csn c0 cpr cD csn csn cB csn snex elpr sylib cB csn
      csn cC csn c0 cpr wceq wn cB csn csn cD csn csn wceq cB csn csn cC csn c0
      cpr wceq cB csn csn cD csn csn wceq wo wb cC csn c0 cpr cB csn csn wceq
      cB csn csn cC csn c0 cpr wceq c0 cC csn c0 cpr wcel c0 cB csn csn wcel wn
      cC csn c0 cpr cB csn csn wceq wn cC csn c0 0ex prid2 c0 cB csn csn wcel
      cB csn c0 cB opthw.2 snnz c0 cB csn csn wcel c0 cB csn wceq cB csn c0
      wceq c0 cB csn 0ex elsnc c0 cB csn eqcom bitri nemtbir c0 cC csn c0 cpr
      cB csn csn nelneq2 mp2an cC csn c0 cpr cB csn csn eqcom mtbi cB csn csn
      cC csn c0 cpr wceq cB csn csn cD csn csn wceq biorf ax-mp sylibr cB csn
      cD csn cB snex sneqr cB cD opthw.2 sneqr 3syl jca cA cC wceq cB cD wceq
      cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cB csn csn cpr cC csn c0 cpr
      cD csn csn cpr cA cC wceq cA csn cC csn wceq cA csn c0 cpr cC csn c0 cpr
      wceq cA csn c0 cpr cB csn csn cpr cC csn c0 cpr cB csn csn cpr wceq cA cC
      sneq cA csn cC csn c0 preq1 cA csn c0 cpr cC csn c0 cpr cB csn csn preq1
      3syl cB cD wceq cB csn cD csn wceq cB csn csn cD csn csn wceq cC csn c0
      cpr cB csn csn cpr cC csn c0 cpr cD csn csn cpr wceq cB cD sneq cB csn cD
      csn sneq cB csn csn cD csn csn cC csn c0 cpr preq2 3syl sylan9eq impbii
      $.
      $( [28-Sep-2003] $)
  $}

  $( The union of an ordered pair.  Theorem 65 of [Suppes] p. 39. $)
  uniop $p |- U. <. A , B >. = { A , B } $=
    cA cB cop cuni cA csn cA cB cpr cpr cuni cA csn cA cB cpr cun cA cB cpr cA
    cB cop cA csn cA cB cpr cpr cA cB df-op unieqi cA csn cA cB cpr cA snex cA
    cB prex unipr cA csn cA cB cpr wss cA csn cA cB cpr cun cA cB cpr wceq cA
    cB snsspr1 cA csn cA cB cpr ssequn1 mpbi 3eqtri $.
    $( [27-Aug-2004] $) $( [17-Aug-2004] $)

  $( Ordered pair membership is inherited by class union. $)
  uniopel $p |- ( <. A , B >. e. C -> U. <. A , B >. e. U. C ) $=
    cA cB cop cC wcel cA cB cop cuni cA cB cop wcel cA cB cop cuni cC cuni wcel
    cA cB cop cuni cA cB cpr cA cB cop cA cB uniop cA cB opi2 eqeltri cA cB cop
    cC wcel cA cB cop cC cuni cA cB cop cuni cA cB cop cC elssuni sseld mpi $.
    $( [13-May-2008] $) $( [13-May-2008] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ordered-pair class abstractions (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v $.  $d ph z w v $.
    $( The law of concretion.  Special case of Theorem 9.5 of [Quine] p. 61. $)
    opabid $p |- ( <. x , y >. e. { <. x , y >. | ph } <-> ph ) $=
      vx cv vy cv cop vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab
      wcel vz cv vx cv vy cv cop wceq vz cv vx cv vy cv cop wceq wph wa vy wex
      vx wex wa vz wex vx cv vy cv cop wph vx vy copab wcel wph vz cv vx cv vy
      cv cop wceq wph wa vy wex vx wex vz vx cv vy cv cop clelab wph vx vy
      copab vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vx cv vy cv
      cop wph vx vy vz df-opab eleq2i wph vz cv vx cv vy cv cop wceq vz cv vw
      cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vv wex vw wex wa vz
      wex vz cv vx cv vy cv cop wceq vz cv vx cv vy cv cop wceq wph wa vy wex
      vx wex wa vz wex vw cv vx cv wceq vv cv vy cv wceq wa wph vx vw cv wsbc
      vy vv cv wsbc wa vv wex vw wex vz cv vx cv vy cv cop wceq vz cv vw cv vv
      cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa wa vz wex vv wex vw wex
      wph vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv
      wsbc vy vv cv wsbc wa vv wex vw wex wa vz wex vw cv vx cv wceq vv cv vy
      cv wceq wa wph vx vw cv wsbc vy vv cv wsbc wa vz cv vx cv vy cv cop wceq
      vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa wa vz wex
      vw vv vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop wceq wa wph vx vw
      cv wsbc vy vv cv wsbc wa vz wex vz cv vx cv vy cv cop wceq vz cv vw cv vv
      cv cop wceq wa vz wex wph vx vw cv wsbc vy vv cv wsbc wa vz cv vx cv vy
      cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa
      wa vz wex vw cv vx cv wceq vv cv vy cv wceq wa wph vx vw cv wsbc vy vv cv
      wsbc wa vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop wceq wa wph vx
      vw cv wsbc vy vv cv wsbc vz 19.41v vz cv vx cv vy cv cop wceq vz cv vw cv
      vv cv cop wceq wa wph vx vw cv wsbc vy vv cv wsbc wa vz cv vx cv vy cv
      cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa wa
      vz vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv
      wsbc vy vv cv wsbc anass exbii vz cv vx cv vy cv cop wceq vz cv vw cv vv
      cv cop wceq wa vz wex vw cv vx cv wceq vv cv vy cv wceq wa wph vx vw cv
      wsbc vy vv cv wsbc vx cv vy cv cop vw cv vv cv cop wceq vw cv vv cv cop
      vx cv vy cv cop wceq vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop
      wceq wa vz wex vw cv vx cv wceq vv cv vy cv wceq wa vx cv vy cv cop vw cv
      vv cv cop eqcom vz vx cv vy cv cop vw cv vv cv cop vx cv vy cv opex
      eqvinc vw cv vv cv vx cv vy cv vw visset vv visset vy visset opth 3bitr3i
      anbi1i 3bitr3ri 2exbii wph vw vv vx vy sbel2x vz cv vx cv vy cv cop wceq
      vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa wa vv wex
      vw wex vz wex vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop wceq wph
      vx vw cv wsbc vy vv cv wsbc wa wa vv wex vz wex vw wex vz cv vx cv vy cv
      cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vv
      wex vw wex wa vz wex vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop
      wceq wph vx vw cv wsbc vy vv cv wsbc wa wa vz wex vv wex vw wex vz cv vx
      cv vy cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv
      wsbc wa wa vv wex vz vw excom vz cv vx cv vy cv cop wceq vz cv vw cv vv
      cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vz vw vv exdistr2 vz cv vx
      cv vy cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv
      wsbc wa wa vv wex vz wex vz cv vx cv vy cv cop wceq vz cv vw cv vv cv cop
      wceq wph vx vw cv wsbc vy vv cv wsbc wa wa vz wex vv wex vw vz cv vx cv
      vy cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc
      wa wa vz vv excom exbii 3bitr3i 3bitr4i vz cv vx cv vy cv cop wceq vz cv
      vx cv vy cv cop wceq wph wa vy wex vx wex wa vz cv vx cv vy cv cop wceq
      vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vv wex vw
      wex wa vz vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cv vw cv vv
      cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vv wex vw wex vz cv vx cv
      vy cv cop wceq vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cv vw
      cv vy cv cop wceq wph vx vw cv wsbc wa vy wex vw wex vz cv vw cv vv cv
      cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vv wex vw wex vz cv vx cv vy
      cv cop wceq wph wa vy wex vz cv vw cv vy cv cop wceq wph vx vw cv wsbc wa
      vy wex vx vw vz cv vx cv vy cv cop wceq wph wa vy wex vw ax-17 vz cv vw
      cv vy cv cop wceq wph vx vw cv wsbc wa vx vy vz cv vw cv vy cv cop wceq
      wph vx vw cv wsbc vx vz cv vw cv vy cv cop wceq vx ax-17 wph vx vw hbs1
      hban hbex vx cv vw cv wceq vz cv vx cv vy cv cop wceq wph wa vz cv vw cv
      vy cv cop wceq wph vx vw cv wsbc wa vy vx cv vw cv wceq vz cv vx cv vy cv
      cop wceq vz cv vw cv vy cv cop wceq wph wph vx vw cv wsbc vx cv vw cv
      wceq vx cv vy cv cop vw cv vy cv cop vz cv vx cv vw cv vy cv opeq1 eqeq2d
      wph vx vw sbequ12 anbi12d exbidv cbvex vz cv vw cv vy cv cop wceq wph vx
      vw cv wsbc wa vy wex vz cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv
      cv wsbc wa vv wex vw vz cv vw cv vy cv cop wceq wph vx vw cv wsbc wa vz
      cv vw cv vv cv cop wceq wph vx vw cv wsbc vy vv cv wsbc wa vy vv vz cv vw
      cv vy cv cop wceq wph vx vw cv wsbc wa vv ax-17 vz cv vw cv vv cv cop
      wceq wph vx vw cv wsbc vy vv cv wsbc vy vz cv vw cv vv cv cop wceq vy
      ax-17 wph vx vw cv wsbc vy vv hbs1 hban vy cv vv cv wceq vz cv vw cv vy
      cv cop wceq vz cv vw cv vv cv cop wceq wph vx vw cv wsbc wph vx vw cv
      wsbc vy vv cv wsbc vy cv vv cv wceq vw cv vy cv cop vw cv vv cv cop vz cv
      vy cv vv cv vw cv opeq2 eqeq2d wph vx vw cv wsbc vy vv sbequ12 anbi12d
      cbvex exbii bitri anbi2i exbii bitr4i 3bitr4i $.
      $( [14-Apr-1995] $)
  $}

  ${
    $d x z A $.  $d y z A $.  $d z ph $.
    $( Membership in a class abstraction of pairs. $)
    elopab $p |- ( A e. { <. x , y >. | ph } <->
                 E. x E. y ( A = <. x , y >. /\ ph ) ) $=
      cA wph vx vy copab wcel cA cvv wcel cA vx cv vy cv cop wceq wph wa vy wex
      vx wex cA wph vx vy copab elisset cA vx cv vy cv cop wceq wph wa cA cvv
      wcel vx vy cA vx cv vy cv cop wceq cA cvv wcel wph cA vx cv vy cv cop
      wceq cA cvv wcel vx cv vy cv cop cvv wcel vx cv vy cv opex cA vx cv vy cv
      cop cvv eleq1 mpbiri adantr 19.23aivv vz cv wph vx vy copab wcel vz cv vx
      cv vy cv cop wceq wph wa vy wex vx wex cA wph vx vy copab wcel cA vx cv
      vy cv cop wceq wph wa vy wex vx wex vz cA cvv vz cv cA wph vx vy copab
      eleq1 vz cv cA wceq vz cv vx cv vy cv cop wceq wph wa cA vx cv vy cv cop
      wceq wph wa vx vy vz cv cA wceq vz cv vx cv vy cv cop wceq cA vx cv vy cv
      cop wceq wph vz cv cA vx cv vy cv cop eqeq1 anbi1d 2exbidv vz cv vx cv vy
      cv cop wceq wph wa vy wex vx wex vz wph vx vy copab wph vx vy vz df-opab
      abeq2i vtoclbg pm5.21nii $.
      $( [24-Mar-1998] $)
  $}

  ${
    $d x z w $.  $d y z w $.
    hbopab.1 $e |- ( ph -> A. z ph ) $.
    $( Bound-variable hypothesis builder for class abstraction. $)
    hbopab $p |- ( w e. { <. x , y >. | ph } ->
                 A. z w e. { <. x , y >. | ph } ) $=
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vz wal vw cv wph vx vy copab wcel vw cv wph vx
      vy copab wcel vz wal vw cv vx cv vy cv cop wceq wph wa vy wex vz vx vw cv
      vx cv vy cv cop wceq wph wa vz vy vw cv vx cv vy cv cop wceq wph vz vw cv
      vx cv vy cv cop wceq vz ax-17 hbopab.1 hban hbex hbex wph vx vy vw cv
      elopab vw cv wph vx vy copab wcel vw cv vx cv vy cv cop wceq wph wa vy
      wex vx wex vz wph vx vy vw cv elopab albii 3imtr4i $.
      $( [1-Sep-1999] $)
  $}

  ${
    $d x w $.  $d y w $.  $d x z $.  $d w ph $.
    $( The first abstraction variable in an ordered-pair class abstraction
       (class builder) is effectively not free. $)
    hbopab1 $p |- ( z e. { <. x , y >. | ph } ->
                 A. x z e. { <. x , y >. | ph } ) $=
      vx vz wph vx vy copab vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw
      cab wph vx vy vw df-opab vw cv vx cv vy cv cop wceq wph wa vy wex vx wex
      vx vw vz vw cv vx cv vy cv cop wceq wph wa vy wex vx hbe1 hbab hbxfr $.
      $( [16-May-1995] $)
  $}

  ${
    $d x w $.  $d y w $.  $d y z $.  $d w ph $.
    $( The second abstraction variable in an ordered-pair class abstraction
       (class builder) is effectively not free. $)
    hbopab2 $p |- ( z e. { <. x , y >. | ph } ->
                 A. y z e. { <. x , y >. | ph } ) $=
      vy vz wph vx vy copab vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw
      cab wph vx vy vw df-opab vw cv vx cv vy cv cop wceq wph wa vy wex vx wex
      vy vw vz vw cv vx cv vy cv cop wceq wph wa vy wex vy vx vw cv vx cv vy cv
      cop wceq wph wa vy hbe1 hbex hbab hbxfr $.
      $( [16-May-1995] $)
  $}


  ${
    $d x y z v $.  $d x y w v $.  $d v ph $.
    $( The law of concretion in terms of substitutions. $)
    opelopabsb $p |- ( <. z , w >. e. { <. x , y >. | ph }
                 <-> [ w / y ] [ z / x ] ph ) $=
      vy cv vw cv wceq vy wex vz cv vw cv cop wph vx vy copab wcel wph vx vz cv
      wsbc vy vw cv wsbc wb vy vw a9e vy cv vw cv wceq vz cv vw cv cop wph vx
      vy copab wcel wph vx vz cv wsbc vy vw cv wsbc wb vy vz cv vw cv cop wph
      vx vy copab wcel wph vx vz cv wsbc vy vw cv wsbc vy vy vv vv vz cv vw cv
      cop wph vx vy copab vv cv vz cv vw cv cop wcel vy ax-17 wph vx vy vv
      hbopab2 hbel wph vx vz cv wsbc vy vw hbs1 hbbi vx cv vz cv wceq vx wex vy
      cv vw cv wceq vz cv vw cv cop wph vx vy copab wcel wph vx vz cv wsbc vy
      vw cv wsbc wb wi vx vz a9e vx cv vz cv wceq vy cv vw cv wceq vz cv vw cv
      cop wph vx vy copab wcel wph vx vz cv wsbc vy vw cv wsbc wb wi vx vy cv
      vw cv wceq vz cv vw cv cop wph vx vy copab wcel wph vx vz cv wsbc vy vw
      cv wsbc wb vx vy cv vw cv wceq vx ax-17 vz cv vw cv cop wph vx vy copab
      wcel wph vx vz cv wsbc vy vw cv wsbc vx vx vv vv vz cv vw cv cop wph vx
      vy copab vv cv vz cv vw cv cop wcel vx ax-17 wph vx vy vv hbopab1 hbel
      wph vx vz cv wsbc vy vw vx wph vx vz hbs1 hbsb hbbi hbim vx cv vz cv wceq
      vy cv vw cv wceq vz cv vw cv cop wph vx vy copab wcel wph vx vz cv wsbc
      vy vw cv wsbc wb vx cv vz cv wceq vy cv vw cv wceq wa wph vz cv vw cv cop
      wph vx vy copab wcel wph vx vz cv wsbc vy vw cv wsbc vx cv vz cv wceq vy
      cv vw cv wceq wa vx cv vy cv cop wph vx vy copab wcel vz cv vw cv cop wph
      vx vy copab wcel wph vx cv vz cv wceq vy cv vw cv wceq wa vx cv vy cv cop
      vz cv vw cv cop wph vx vy copab vx cv vy cv vz cv vw cv opeq12 eleq1d wph
      vx vy opabid syl5bbr vx cv vz cv wceq wph wph vx vz cv wsbc vy cv vw cv
      wceq wph vx vz cv wsbc vy vw cv wsbc wph vx vz sbequ12 wph vx vz cv wsbc
      vy vw sbequ12 sylan9bb bitr3d ex 19.23ai ax-mp 19.23ai ax-mp $.
      $( [30-Sep-2002] $)

    ${
      brabsb.1 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion in terms of substitutions. $)
      brabsb $p |- ( z R w <-> [ w / y ] [ z / x ] ph ) $=
        vz cv vw cv cR wbr vz cv vw cv wph vx vy copab wbr vz cv vw cv cop wph
        vx vy copab wcel wph vx vz cv wsbc vy vw cv wsbc vz cv vw cv cR wph vx
        vy copab brabsb.1 breqi vz cv vw cv wph vx vy copab df-br wph vx vy vz
        vw opelopabsb 3bitri $.
        $( [17-Mar-2008] $) $( [17-Mar-2008] $)
    $}
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y ch $.  $d z ph $.
    opelopabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopabg.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61. $)
    opelopabg $p |- ( ( A e. C /\ B e. D ) ->
                    ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) ) $=
      cA cC wcel cB cD wcel wa cA cB cop vx cv vy cv cop wceq wph wa vy wex vx
      wex wch cA cB cop wph vx vy copab wcel wph wch vx vy cA cB cC cD vx cv cA
      wceq wph wps vy cv cB wceq wch opelopabg.1 opelopabg.2 sylan9bb copsex2g
      wph vx vy cA cB cop elopab syl5bb $.
      $( [15-Mar-2007] $) $( [28-May-1995] $)

    ${
      brabg.5 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion for a binary relation. $)
      brabg $p |- ( ( A e. C /\ B e. D ) -> ( A R B <-> ch ) ) $=
        cA cC wcel cB cD wcel wa cA cB cop wph vx vy copab wcel wch cA cB cR
        wbr wph wps wch vx vy cA cB cC cD opelopabg.1 opelopabg.2 opelopabg cA
        cB cR wbr cA cB cop cR wcel cA cB cop wph vx vy copab wcel cA cB cR
        df-br cR wph vx vy copab cA cB cop brabg.5 eleq2i bitri syl5bb $.
        $( [16-Aug-1999] $)
    $}
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y ch $.
    opelopab2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopab2.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Ordered pair membership in an ordered pair class abstraction. $)
    opelopab2 $p |- ( ( A e. C /\ B e. D ) -> ( <. A , B >. e.
                 { <. x , y >. | ( ( x e. C /\ y e. D ) /\ ph ) } <-> ch ) ) $=
      cA cC wcel cB cD wcel wa cA cB cop vx cv cC wcel vy cv cD wcel wa wph wa
      vx vy copab wcel cA cC wcel cB cD wcel wa wch wa wch vx cv cC wcel vy cv
      cD wcel wa wph wa cA cC wcel vy cv cD wcel wa wps wa cA cC wcel cB cD
      wcel wa wch wa vx vy cA cB cC cD vx cv cA wceq vx cv cC wcel vy cv cD
      wcel wa cA cC wcel vy cv cD wcel wa wph wps vx cv cA wceq vx cv cC wcel
      cA cC wcel vy cv cD wcel vx cv cA cC eleq1 anbi1d opelopab2.1 anbi12d vy
      cv cB wceq cA cC wcel vy cv cD wcel wa cA cC wcel cB cD wcel wa wps wch
      vy cv cB wceq vy cv cD wcel cB cD wcel cA cC wcel vy cv cB cD eleq1
      anbi2d opelopab2.2 anbi12d opelopabg cA cC wcel cB cD wcel wa cA cC wcel
      cB cD wcel wa wch wa wch cA cC wcel cB cD wcel wa wch pm3.27 cA cC wcel
      cB cD wcel wa wch pm3.2 impbid2 bitrd $.
      $( [31-Jan-2008] $) $( [14-Oct-2007] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ch $.
    opelopab.1 $e |- A e. _V $.
    opelopab.2 $e |- B e. _V $.
    opelopab.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopab.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61. $)
    opelopab $p |- ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) $=
      cA cvv wcel cB cvv wcel cA cB cop wph vx vy copab wcel wch wb opelopab.1
      opelopab.2 wph wps wch vx vy cA cB cvv cvv opelopab.3 opelopab.4
      opelopabg mp2an $.
      $( [16-May-1995] $)

    ${
      brab.5 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion for a binary relation. $)
      brab $p |- ( A R B <-> ch ) $=
        cA cvv wcel cB cvv wcel cA cB cR wbr wch wb opelopab.1 opelopab.2 wph
        wps wch vx vy cA cB cvv cvv cR opelopab.3 opelopab.4 brab.5 brabg mp2an
        $.
        $( [16-Aug-1999] $)
    $}
  $}

  ${
    $d w x y z A $.  $d w y z B $.  $d w z ch $.  $d w z ph $.
    opelopabf.x $e |- ( ps -> A. x ps ) $.
    opelopabf.y $e |- ( ch -> A. y ch ) $.
    opelopabf.1 $e |- A e. _V $.
    opelopabf.2 $e |- B e. _V $.
    opelopabf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopabf.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  This version of
       ~ opelopab uses bound-variable hypotheses in place of distinct variable
       conditions." $)
    opelopabf $p |- ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) $=
      cA cB cop wph vx vy copab wcel cA cB cop wph vx vz cv wsbc vy vw cv wsbc
      vz vw copab wcel wch wph vx vy copab wph vx vz cv wsbc vy vw cv wsbc vz
      vw copab cA cB cop wph wph vx vz cv wsbc vy vw cv wsbc vx vy vz vw wph vz
      ax-17 wph vw ax-17 wph vx vz cv wsbc vy vw vx wph vx vz hbs1 hbsb wph vx
      vz cv wsbc vy vw hbs1 vx cv vz cv wceq wph wph vx vz cv wsbc vy cv vw cv
      wceq wph vx vz cv wsbc vy vw cv wsbc wph vx vz sbequ12 wph vx vz cv wsbc
      vy vw sbequ12 sylan9bb cbvopab eleq2i wph vx vz cv wsbc vy vw cv wsbc wps
      vy vw cv wsbc wch vz vw cA cB opelopabf.1 opelopabf.2 vz cv cA wceq wph
      vx vz cv wsbc wps vy vw vz cv cA wceq vy ax-17 wph wps vx vz cA
      opelopabf.x opelopabf.3 sbhypf sbbid wps wch vy vw cB opelopabf.y
      opelopabf.4 sbhypf opelopab bitri $.
      $( [8-Jan-2009] $) $( [19-Dec-2008] $)
  $}

  ${
    $d ph z $.  $d ps z $.  $d x y z $.
    $( Equivalence of ordered pair abstraction subclass and implication. $)
    ssopab2 $p |- ( { <. x , y >. | ph } C_ { <. x , y >. | ps } <->
               A. x A. y ( ph -> ps ) ) $=
      wph vx vy copab wps vx vy copab wss wph wps wi vy wal vx wal wph vx vy
      copab wps vx vy copab wss wph wps wi vy wal vx vx vz wph vx vy copab wps
      vx vy copab wph vx vy vz hbopab1 wps vx vy vz hbopab1 hbss wph vx vy
      copab wps vx vy copab wss wph wps wi vy vy vz wph vx vy copab wps vx vy
      copab wph vx vy vz hbopab2 wps vx vy vz hbopab2 hbss vz cv vx cv vy cv
      cop wceq vz wex wph vx vy copab wps vx vy copab wss wph wps wi wi vz vx
      cv vy cv cop vx cv vy cv opex isseti vz cv vx cv vy cv cop wceq wph vx vy
      copab wps vx vy copab wss wph wps wi wi vz vz cv vx cv vy cv cop wceq vz
      cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vz cv vx cv vy cv cop
      wceq wps wa vy wex vx wex vz cab wss wph wps wi wph vx vy copab wps vx vy
      copab wss vz cv vx cv vy cv cop wceq wph wps wi vz cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wex
      wi vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vz cv vx cv vy
      cv cop wceq wps wa vy wex vx wex vz cab wss vz cv vx cv vy cv cop wceq
      wph vz cv vx cv vy cv cop wceq wph wa vy wex vx wex wps vz cv vx cv vy cv
      cop wceq wps wa vy wex vx wex wph vx vy vz cv copsexg wps vx vy vz cv
      copsexg imbi12d vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vz
      cv vx cv vy cv cop wceq wps wa vy wex vx wex vz cab wss vz cv vx cv vy cv
      cop wceq wph wa vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx
      wex wi vz wal vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cv vx cv
      vy cv cop wceq wps wa vy wex vx wex wi vz cv vx cv vy cv cop wceq wph wa
      vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wex vz ss2ab vz
      cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cv vx cv vy cv cop wceq
      wps wa vy wex vx wex wi vz ax-4 sylbi syl5bir wph vx vy copab vz cv vx cv
      vy cv cop wceq wph wa vy wex vx wex vz cab wps vx vy copab vz cv vx cv vy
      cv cop wceq wps wa vy wex vx wex vz cab wph vx vy vz df-opab wps vx vy vz
      df-opab sseq12i syl5ib 19.23aiv ax-mp 19.21ai 19.21ai wph wps wi vy wal
      vx wal vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vz cv vx cv
      vy cv cop wceq wps wa vy wex vx wex vz cab wph vx vy copab wps vx vy
      copab wph wps wi vy wal vx wal vz cv vx cv vy cv cop wceq wph wa vy wex
      vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wex wi vz wal vz cv vx
      cv vy cv cop wceq wph wa vy wex vx wex vz cab vz cv vx cv vy cv cop wceq
      wps wa vy wex vx wex vz cab wss wph wps wi vy wal vx wal vz cv vx cv vy
      cv cop wceq wph wa vy wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex
      vx wex wi vz wph wps wi vy wal vx wal vz cv vx cv vy cv cop wceq wph wa
      vy wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wph wps wi vy wal vx
      hba1 wph wps wi vy wal vz cv vx cv vy cv cop wceq wph wa vy wex vz cv vx
      cv vy cv cop wceq wps wa vy wex wi vx wph wps wi vy wal vz cv vx cv vy cv
      cop wceq wph wa vz cv vx cv vy cv cop wceq wps wa vy wph wps wi vy hba1
      wph wps wi vy wal wph wps vz cv vx cv vy cv cop wceq wph wps wi vy ax-4
      anim2d 19.22d a4s 19.22d 19.21aiv vz cv vx cv vy cv cop wceq wph wa vy
      wex vx wex vz cv vx cv vy cv cop wceq wps wa vy wex vx wex vz ss2ab
      sylibr wph vx vy vz df-opab wps vx vy vz df-opab 3sstr4g impbii $.
      $( [27-Dec-1996] $)
  $}

  ${
    $d ph z $.  $d ps z $.  $d x y z $.
    ssopab2i.1 $e |- ( ph -> ps ) $.
    $( Inference of ordered pair abstraction subclass from implication. $)
    ssopab2i $p |- { <. x , y >. | ph } C_ { <. x , y >. | ps } $=
      wph vx vy copab wps vx vy copab wss wph wps wi vy wal vx wph wps vx vy
      ssopab2 wph wps wi vy ssopab2i.1 ax-gen mpgbir $.
      $( [5-Apr-1995] $)
  $}

  ${
    $d z ph $.  $d z x $.  $d z y $.
    $( Non-empty ordered pair class abstraction. $)
    opabn0 $p |- ( { <. x , y >. | ph } =/= (/) <-> E. x E. y ph ) $=
      wph vx vy copab c0 wne vz cv wph vx vy copab wcel vz wex vz cv vx cv vy
      cv cop wceq wph wa vy wex vx wex vz wex wph vy wex vx wex vz wph vx vy
      copab n0 vz cv wph vx vy copab wcel vz cv vx cv vy cv cop wceq wph wa vy
      wex vx wex vz wph vx vy vz cv elopab exbii vz cv vx cv vy cv cop wceq wph
      wa vy wex vx wex vz wex vz cv vx cv vy cv cop wceq wph wa vz wex vy wex
      vx wex wph vy wex vx wex vz cv vx cv vy cv cop wceq wph wa vz vx vy
      exrot3 vz cv vx cv vy cv cop wceq wph wa vz wex wph vx vy vz cv vx cv vy
      cv cop wceq wph wa vz wex vz cv vx cv vy cv cop wceq vz wex wph vz cv vx
      cv vy cv cop wceq wph vz 19.41v vz vx cv vy cv cop vx cv vy cv opex
      isseti mpbiran 2exbii bitri 3bitri $.
      $( [10-Nov-2007] $) $( [10-Oct-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Power class of union and intersection
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.  $d B x y $.
    $( The power class of the intersection of two classes is the intersection
       of their power classes.  Exercise 4.12(j) of [Mendelson] p. 235. $)
    pwin $p |- ~P ( A i^i B ) = ( ~P A i^i ~P B ) $=
      cA cpw cB cpw cin cA cB cin cpw vx cA cpw cB cpw cA cB cin cpw vx cv cA
      wss vx cv cB wss wa vx cv cA cB cin wss vx cv cA cpw wcel vx cv cB cpw
      wcel wa vx cv cA cB cin cpw wcel vx cv cA cB ssin vx cv cA cpw wcel vx cv
      cA wss vx cv cB cpw wcel vx cv cB wss vx cv cA vx visset elpw vx cv cB vx
      visset elpw anbi12i vx cv cA cB cin vx visset elpw 3bitr4i ineqri eqcomi
      $.
      $( [23-Nov-2003] $) $( [23-Nov-2003] $)

    $( The power class of the union of two classes includes the union of their
       power classes.  Exercise 4.12(k) of [Mendelson] p. 235. $)
    pwunss $p |- ( ~P A u. ~P B ) C_ ~P ( A u. B ) $=
      vx cA cpw cB cpw cun cA cB cun cpw vx cv cA wss vx cv cB wss wo vx cv cA
      cB cun wss vx cv cA cpw cB cpw cun wcel vx cv cA cB cun cpw wcel vx cv cA
      cB ssun vx cv cA cpw cB cpw cun wcel vx cv cA cpw wcel vx cv cB cpw wcel
      wo vx cv cA wss vx cv cB wss wo vx cv cA cpw cB cpw elun vx cv cA cpw
      wcel vx cv cA wss vx cv cB cpw wcel vx cv cB wss vx cv cA vx visset elpw
      vx cv cB vx visset elpw orbi12i bitri vx cv cA cB cun vx visset elpw
      3imtr4i ssriv $.
      $( [23-Nov-2003] $) $( [23-Nov-2003] $)

    $( The power class of the union of two classes is a subset of the union of
       their power classes, iff one class is a subclass of the other.  Exercise
       4.12(l) of [Mendelson] p. 235. $)
    pwssun $p |- ( ( A C_ B \/ B C_ A ) <->
               ~P ( A u. B ) C_ ( ~P A u. ~P B ) ) $=
      cA cB wss cB cA wss wo cA cB cun cpw cA cpw cB cpw cun wss cA cB wss cB
      cA wss wo cA cB cun cpw cA cpw wss cA cB cun cpw cB cpw wss wo cA cB cun
      cpw cA cpw cB cpw cun wss cA cB wss cB cA wss wo cB cA wss cA cB wss wo
      cA cB cun cpw cA cpw wss cA cB cun cpw cB cpw wss wo cA cB wss cB cA wss
      orcom cB cA wss cA cB cun cpw cA cpw wss cA cB wss cA cB cun cpw cB cpw
      wss cB cA wss cA cB cun cA wceq cA cB cun cpw cA cpw wss cB cA ssequn2 cA
      cB cun cA wceq cA cB cun cpw cA cpw wceq cA cB cun cpw cA cpw wss cA cB
      cun cA pweq cA cB cun cpw cA cpw eqimss syl sylbi cA cB wss cA cB cun cB
      wceq cA cB cun cpw cB cpw wss cA cB ssequn1 cA cB cun cB wceq cA cB cun
      cpw cB cpw wceq cA cB cun cpw cB cpw wss cA cB cun cB pweq cA cB cun cpw
      cB cpw eqimss syl sylbi orim12i sylbi cA cB cun cpw cA cpw cB cpw ssun
      syl cA cB cun cpw cA cpw cB cpw cun wss cA cB wss cB cA wss cA cB cun cpw
      cA cpw cB cpw cun wss cA cB wss wn cB cA wss cA cB cun cpw cA cpw cB cpw
      cun wss cA cB wss wn wa vy cB cA cA cB cun cpw cA cpw cB cpw cun wss cA
      cB wss wn vy cv cB wcel vy cv cA wcel wi cA cB cun cpw cA cpw cB cpw cun
      wss vy cv cB wcel cA cB wss wn vy cv cA wcel cA cB cun cpw cA cpw cB cpw
      cun wss vy cv cB wcel vy cv cA wcel wn cA cB wss wi cA cB wss wn vy cv cA
      wcel wi cA cB cun cpw cA cpw cB cpw cun wss vy cv cB wcel vy cv cA wcel
      wn cA cB wss cA cB cun cpw cA cpw cB cpw cun wss vy cv cB wcel wa vy cv
      cA wcel wn wa vx cA cB cA cB cun cpw cA cpw cB cpw cun wss vy cv cB wcel
      wa vy cv cA wcel wn vx cv cA wcel vx cv cB wcel wi cA cB cun cpw cA cpw
      cB cpw cun wss vy cv cB wcel wa vx cv cA wcel vy cv cA wcel wn vx cv cB
      wcel cA cB cun cpw cA cpw cB cpw cun wss vy cv cB wcel wa vx cv cA wcel
      vy cv cA wcel wn vx cv cB wcel wi cA cB cun cpw cA cpw cB cpw cun wss vy
      cv cB wcel wa vx cv cA wcel wa vy cv cA wcel vx cv cB wcel cA cB cun cpw
      cA cpw cB cpw cun wss vy cv cB wcel wa vx cv cA wcel wa vx cv vy cv cpr
      cA cpw wcel vx cv vy cv cpr cB cpw wcel wo vy cv cA wcel vx cv cB wcel wo
      cA cB cun cpw cA cpw cB cpw cun wss vy cv cB wcel wa vx cv cA wcel wa vx
      cv vy cv cpr cA cpw cB cpw cun wcel vx cv vy cv cpr cA cpw wcel vx cv vy
      cv cpr cB cpw wcel wo cA cB cun cpw cA cpw cB cpw cun wss vy cv cB wcel
      vx cv cA wcel vx cv vy cv cpr cA cpw cB cpw cun wcel cA cB cun cpw cA cpw
      cB cpw cun wss vx cv cA wcel vy cv cB wcel vx cv vy cv cpr cA cpw cB cpw
      cun wcel cA cB cun cpw cA cpw cB cpw cun wss vx cv cA wcel vy cv cB wcel
      vx cv vy cv cpr cA cpw cB cpw cun wcel cA cB cun cpw cA cpw cB cpw cun
      wss vx cv vy cv cpr cA cB cun cpw wcel vx cv vy cv cpr cA cpw cB cpw cun
      wcel vx cv cA wcel vy cv cB wcel wa cA cB cun cpw cA cpw cB cpw cun vx cv
      vy cv cpr ssel vx cv cA wcel vy cv cB wcel wa vx cv csn vy cv csn cun cA
      cB cun wss vx cv vy cv cpr cA cB cun cpw wcel vx cv csn cA wss vy cv csn
      cB wss vx cv csn vy cv csn cun cA cB cun wss vx cv cA wcel vy cv cB wcel
      vx cv csn cA vy cv csn cB unss12 vx cv cA vx visset snss vy cv cB vy
      visset snss syl2anb vx cv vy cv cpr cA cB cun cpw wcel vx cv vy cv cpr cA
      cB cun wss vx cv csn vy cv csn cun cA cB cun wss vx cv vy cv cpr cA cB
      cun vx vy zfpair2 elpw vx cv vy cv cpr vx cv csn vy cv csn cun cA cB cun
      vx cv vy cv df-pr sseq1i bitr2i sylib syl5 exp3a com23 imp31 vx cv vy cv
      cpr cA cpw cB cpw elun sylib vx cv vy cv cpr cA cpw wcel vy cv cA wcel vx
      cv vy cv cpr cB cpw wcel vx cv cB wcel vx cv vy cv cpr cA cpw wcel vx cv
      cA wcel vy cv cA wcel vx cv vy cv cpr cA cpw wcel vx cv vy cv cpr cA wss
      vx cv cA wcel vy cv cA wcel wa vx cv vy cv cpr cA vx vy zfpair2 elpw vx
      cv vy cv cA vx visset vy visset prss bitr4i pm3.27bi vx cv vy cv cpr cB
      cpw wcel vx cv cB wcel vy cv cB wcel vx cv vy cv cpr cB cpw wcel vx cv vy
      cv cpr cB wss vx cv cB wcel vy cv cB wcel wa vx cv vy cv cpr cB vx vy
      zfpair2 elpw vx cv vy cv cB vx visset vy visset prss bitr4i pm3.26bi
      orim12i syl ord ex com23 imp ssrdv exp31 vy cv cA wcel cA cB wss con1b
      syl6ib com23 imp ssrdv ex orrd impbii $.
      $( [23-Nov-2003] $) $( [23-Nov-2003] $)

    $( Break up the power class of a union into a union of smaller classes. $)
    pwundif $p |- ~P ( A u. B ) =
                  ( ( ~P ( A u. B ) \ ~P A ) u. ~P A ) $=
      vx cA cB cun cpw cA cB cun cpw cA cpw cdif cA cpw cun vx cv cA cB cun cpw
      wcel vx cv cA cB cun wss vx cv cA cB cun cpw cA cpw cdif cA cpw cun wcel
      vx cv cA cB cun vx visset elpw vx cv cA cB cun cpw cA cpw cdif cA cpw cun
      wcel vx cv cA cB cun cpw cA cpw cdif wcel vx cv cA cpw wcel wo vx cv cA
      cB cun wss vx cv cA wss wn wa vx cv cA wss wo vx cv cA cB cun wss vx cv
      cA cB cun cpw cA cpw cdif cA cpw elun vx cv cA cB cun cpw cA cpw cdif
      wcel vx cv cA cB cun wss vx cv cA wss wn wa vx cv cA cpw wcel vx cv cA
      wss vx cv cA cB cun cpw cA cpw cdif wcel vx cv cA cB cun cpw wcel vx cv
      cA cpw wcel wn wa vx cv cA cB cun wss vx cv cA wss wn wa vx cv cA cB cun
      cpw cA cpw eldif vx cv cA cB cun cpw wcel vx cv cA cB cun wss vx cv cA
      cpw wcel wn vx cv cA wss wn vx cv cA cB cun vx visset elpw vx cv cA cpw
      wcel vx cv cA wss vx cv cA vx visset elpw notbii anbi12i bitri vx cv cA
      vx visset elpw orbi12i vx cv cA cB cun wss vx cv cA wss wn wa vx cv cA
      wss wo vx cv cA cB cun wss vx cv cA wss wo vx cv cA wss wn vx cv cA wss
      wo wa vx cv cA cB cun wss vx cv cA wss wo vx cv cA cB cun wss vx cv cA cB
      cun wss vx cv cA wss wn vx cv cA wss ordir vx cv cA wss wn vx cv cA wss
      wo vx cv cA cB cun wss vx cv cA wss wo vx cv cA wss pm2.1 biantru vx cv
      cA cB cun wss vx cv cA wss wo vx cv cA cB cun wss vx cv cA cB cun wss vx
      cv cA cB cun wss vx cv cA wss vx cv cA cB cun wss id vx cv cA cB ssun3
      jaoi vx cv cA cB cun wss vx cv cA wss orc impbii 3bitr2i 3bitrri bitri
      eqriv $.
      $( [28-Mar-2007] $) $( [25-Mar-2007] $)
  $}

  $( The power class of the union of two classes equals the union of their
     power classes, iff one class is a subclass of the other.  Part of
     Exercise 7(b) of [Enderton] p. 28. $)
  pwun $p |- ( ( A C_ B \/ B C_ A ) <->
             ~P ( A u. B ) = ( ~P A u. ~P B ) ) $=
    cA cB cun cpw cA cpw cB cpw cun wss cA cB cun cpw cA cpw cB cpw cun wss cA
    cpw cB cpw cun cA cB cun cpw wss wa cA cB wss cB cA wss wo cA cB cun cpw cA
    cpw cB cpw cun wceq cA cpw cB cpw cun cA cB cun cpw wss cA cB cun cpw cA
    cpw cB cpw cun wss cA cB pwunss biantru cA cB pwssun cA cB cun cpw cA cpw
    cB cpw cun eqss 3bitr4i $.
    $( [23-Nov-2003] $) $( [23-Nov-2003] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Epsilon and identity relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols. $)
  $c _E $. $( Letter E (for epsilon relation) $)
  $c _I $.  $( Letter I (for identity relation) $)

  $( Extend class notation to include the epsilon relation. $)
  cep $a class _E $.

  $( Extend the definition of a class to include identity relation. $)
  cid $a class _I $.

  ${
    $d x y $.
    $( Define the epsilon relation.  Similar to Definition 6.22 of
       [TakeutiZaring] p. 30. $)
    df-eprel $a |- _E = { <. x , y >. | x e. y } $.
  $}

  ${
    $d x y A $.  $d x y B $.
    epelc.1 $e |- A e. _V $.
    epelc.2 $e |- B e. _V $.
    $( The epsilon relation and the membership relation are the same. $)
    epelc $p |- ( A _E B <-> A e. B ) $=
      vx cv vy cv wcel cA vy cv wcel cA cB wcel vx vy cA cB cep epelc.1 epelc.2
      vx cv cA vy cv eleq1 vy cv cB cA eleq2 vx vy df-eprel brab $.
      $( [13-Aug-1995] $)
  $}

  ${
    $( The epsilon relation and the membership relation are the same. $)
    epel $p |- ( x _E y <-> x e. y ) $=
      vx cv vy cv vx visset vy visset epelc $.
      $( [13-Aug-1995] $)
  $}

  ${
    $d x y $.
    $( Define the identity relation.  Definition 9.15 of [Quine] p. 64. $)
    df-id $a |- _I = { <. x , y >. | x = y } $.
  $}

  ${
    $d v w z x $.  $d v w z y $.
    $( A stronger version of ~ df-id that doesn't require ` x ` and ` y ` to be
       distinct.  Ordinarily, we wouldn't use this as a definition, since
       non-distinct dummy variables would make soundness verification more
       difficult (as the proof here shows).  The proof can be instructive in
       showing how distinct variable requirements may be eliminated, a task
       that is not necessarily obvious. $)
    dfid3 $p |- _I = { <. x , y >. | x = y } $=
      cid vw cv vx cv vy cv cop wceq vx cv vy cv wceq wa vy wex vx wex vw cab
      vx cv vy cv wceq vx vy copab cid vx cv vz cv wceq vx vz copab vw cv vx cv
      vz cv cop wceq vx cv vz cv wceq wa vz wex vx wex vw cab vw cv vx cv vy cv
      cop wceq vx cv vy cv wceq wa vy wex vx wex vw cab vx vz df-id vx cv vz cv
      wceq vx vz vw df-opab vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa vz
      wex vx wex vw cv vx cv vy cv cop wceq vx cv vy cv wceq wa vy wex vx wex
      vw vx cv vy cv wceq vx wal vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa
      vz wex vx wex vw cv vx cv vy cv cop wceq vx cv vy cv wceq wa vy wex vx
      wex wb vx cv vy cv wceq vx wal vw cv vx cv vx cv cop wceq vx cv vx cv
      wceq wa vx wex vx wex vw cv vx cv vy cv cop wceq vx cv vy cv wceq wa vy
      wex vx wex vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa vz wex vx wex
      vw cv vx cv vx cv cop wceq vx cv vx cv wceq wa vx wex vw cv vx cv vy cv
      cop wceq vx cv vy cv wceq wa vy wex vx vy vx vw cv vx cv vx cv cop wceq
      vx cv vx cv wceq wa vw cv vx cv vy cv cop wceq vx cv vy cv wceq wa vx vy
      vx cv vy cv wceq vw cv vx cv vx cv cop wceq vx cv vx cv wceq wa vw cv vx
      cv vy cv cop wceq vx cv vy cv wceq wa wb vx vx cv vy cv wceq vw cv vx cv
      vx cv cop wceq vw cv vx cv vy cv cop wceq vx cv vx cv wceq vx cv vy cv
      wceq vx cv vy cv wceq vx cv vx cv cop vx cv vy cv cop vw cv vx cv vy cv
      vx cv opeq2 eqeq2d vx vy vx equequ2 anbi12d a4s drex1 drex2 vw cv vx cv
      vz cv cop wceq vx cv vz cv wceq wa vz wex vx wex vw cv vx cv vx cv cop
      wceq vx cv vx cv wceq wa vx wex vw cv vx cv vx cv cop wceq vx cv vx cv
      wceq wa vx wex vx wex vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa vz
      wex vw cv vx cv vx cv cop wceq vx cv vx cv wceq wa vx vw cv vx cv vz cv
      cop wceq vx cv vz cv wceq wa vz wex vz cv vx cv wceq vw cv vx cv vz cv
      cop wceq wa vz wex vw cv vx cv vx cv cop wceq vw cv vx cv vx cv cop wceq
      vx cv vx cv wceq wa vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa vz cv
      vx cv wceq vw cv vx cv vz cv cop wceq wa vz vw cv vx cv vz cv cop wceq vx
      cv vz cv wceq wa vx cv vz cv wceq vw cv vx cv vz cv cop wceq wa vz cv vx
      cv wceq vw cv vx cv vz cv cop wceq wa vw cv vx cv vz cv cop wceq vx cv vz
      cv wceq ancom vx cv vz cv wceq vz cv vx cv wceq vw cv vx cv vz cv cop
      wceq vx vz equcom anbi1i bitri exbii vw cv vx cv vz cv cop wceq vw cv vx
      cv vx cv cop wceq vz vx cv vx visset vz cv vx cv wceq vx cv vz cv cop vx
      cv vx cv cop vw cv vz cv vx cv vx cv opeq2 eqeq2d ceqsexv vx cv vx cv
      wceq vw cv vx cv vx cv cop wceq vx equid biantru 3bitri exbii vw cv vx cv
      vx cv cop wceq vx cv vx cv wceq wa vx wex vx vw cv vx cv vx cv cop wceq
      vx cv vx cv wceq wa vx hbe1 19.9 bitr4i syl5bb vx cv vy cv wceq vx wal wn
      vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa vz wex vw cv vx cv vy cv
      cop wceq vx cv vy cv wceq wa vy wex vx vx vy vx hbnae vx cv vy cv wceq vx
      wal wn vw cv vx cv vz cv cop wceq vx cv vz cv wceq wa vw cv vx cv vy cv
      cop wceq vx cv vy cv wceq wa vz vy vx vy vy hbnae vx cv vy cv wceq vx wal
      wn vw cv vx cv vz cv cop wceq vx cv vz cv wceq vy vx cv vy cv wceq vx wal
      wn vy vv vw cv vx cv vz cv cop vx vy vy hbnae vv cv vw cv wcel vv cv vw
      cv wcel vy wal wi vx cv vy cv wceq vx wal wn vv cv vw cv wcel vy ax-17
      a1i vx cv vy cv wceq vx wal wn vy vv vx cv vz cv vx vy vy hbnae vv cv vx
      cv wcel vv cv vx cv wcel vy wal wi vy vx vy vx vv dveel2 nalequcoms vv cv
      vz cv wcel vv cv vz cv wcel vy wal wi vx cv vy cv wceq vx wal wn vv cv vz
      cv wcel vy ax-17 a1i hbopd hbeqd vx cv vz cv wceq vx cv vz cv wceq vy wal
      wi vy vx vy vx vz dveeq1 nalequcoms hband vz cv vy cv wceq vw cv vx cv vz
      cv cop wceq vx cv vz cv wceq wa vw cv vx cv vy cv cop wceq vx cv vy cv
      wceq wa wb wi vx cv vy cv wceq vx wal wn vz cv vy cv wceq vw cv vx cv vz
      cv cop wceq vw cv vx cv vy cv cop wceq vx cv vz cv wceq vx cv vy cv wceq
      vz cv vy cv wceq vx cv vz cv cop vx cv vy cv cop vw cv vz cv vy cv vx cv
      opeq2 eqeq2d vz vy vx equequ2 anbi12d a1i cbvexd exbid pm2.61i abbii
      3eqtri vx cv vy cv wceq vx vy vw df-opab eqtr4i $.
      $( [5-Feb-2008] $) $( [5-Feb-2008] $)
  $}

  $( Alternate definition of the identity relation. $)
  dfid2 $p |- _I = { <. x , x >. | x = x } $=
    vx vx dfid3 $.
    $( [15-Mar-2007] $) $( [15-Mar-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Partial and complete ordering
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
We have not yet defined relations ( ~ df-rel ), but here but introduce a
few related notions we will use to develop ordinals.  The class variable
` R ` is no different from other class variables, but it reminds us that
normally it represents what we will later call a "relation."
$)

  $( Declare new constant symbols. $)
  $c Po $.  $( Partial ordering predicate symbol (read: 'partial ordering'). $)
  $c Or $.  $( Strict complete ordering predicate symbol (read: 'orders'). $)

  $( Extend wff notation to include the strict partial ordering predicate.
     Read:  '` R ` is a partial order on ` A ` .' $)
  wpo $a wff R Po A $.

  $( Extend wff notation to include the strict complete ordering predicate.
     Read:  '` R ` orders ` A ` .' $)
  wor $a wff R Or A $.

  ${
    $d x y z R $.  $d x y z A $.
    $( Define the strict partial order predicate.  Definition of [Enderton]
       p. 168. $)
    df-po $a |- ( R Po A <-> A. x e. A A. y e. A A. z e. A
                ( -. x R x /\ ( ( x R y /\ y R z ) -> x R z ) ) ) $.
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    $( Subset theorem for the partial ordering predicate. $)
    poss $p |- ( A C_ B -> ( R Po B -> R Po A ) ) $=
      cA cB wss vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi wa vz cB wral vy cB wral vx cB wral vx cv vx cv cR
      wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa
      vz cA wral vy cA wral vx cA wral cB cR wpo cA cR wpo cA cB wss vx cv cB
      wcel vy cv cB wcel vz cv cB wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR
      wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy wal vx
      wal vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz
      wal vy wal vx wal vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi wa vz cB wral vy cB wral vx cB wral vx cv vx
      cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi wa vz cA wral vy cA wral vx cA wral cA cB wss vx cv cB wcel vy cv cB
      wcel vz cv cB wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy wal vx cv cA wcel vy
      cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy wal vx cA cB wss
      vx cv cB wcel vy cv cB wcel vz cv cB wcel w3a vx cv vx cv cR wbr wn vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vx
      cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy cA
      cB wss vx cv cB wcel vy cv cB wcel vz cv cB wcel w3a vx cv vx cv cR wbr
      wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi
      vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz cA cB
      wss vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv cB wcel vy cv cB
      wcel vz cv cB wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa cA cB wss vx cv cA wcel vx cv cB
      wcel vy cv cA wcel vy cv cB wcel vz cv cA wcel vz cv cB wcel cA cB vx cv
      ssel cA cB vy cv ssel cA cB vz cv ssel 3anim123d imim1d 19.20dv 19.20dv
      19.20dv vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi wa vx vy vz cB cB cB r3al vx cv vx cv cR wbr wn vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx vy vz cA
      cA cA r3al 3imtr4g vx vy vz cB cR df-po vx vy vz cA cR df-po 3imtr4g $.
      $( [27-Mar-1997] $)
  $}

  ${
    $d x y z R $.  $d x y z S $.  $d x y z A $.
    $( Equality theorem for partial ordering predicate. $)
    poeq1 $p |- ( R = S -> ( R Po A <-> S Po A ) ) $=
      cR cS wceq vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi wa vz cA wral vy cA wral vx cA wral vx cv vx cv cS
      wbr wn vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi wa
      vz cA wral vy cA wral vx cA wral cA cR wpo cA cS wpo cR cS wceq vx cv vx
      cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi wa vz cA wral vx cv vx cv cS wbr wn vx cv vy cv cS wbr vy cv vz cv cS
      wbr wa vx cv vz cv cS wbr wi wa vz cA wral vx vy cA cA cR cS wceq vx cv
      vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi wa vx cv vx cv cS wbr wn vx cv vy cv cS wbr vy cv vz cv cS wbr wa
      vx cv vz cv cS wbr wi wa vz cA cR cS wceq vx cv vx cv cR wbr wn vx cv vx
      cv cS wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi cR cS
      wceq vx cv vx cv cR wbr vx cv vx cv cS wbr vx cv vx cv cR cS breq notbid
      cR cS wceq vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vy cv cS wbr vy
      cv vz cv cS wbr wa vx cv vz cv cR wbr vx cv vz cv cS wbr cR cS wceq vx cv
      vy cv cR wbr vx cv vy cv cS wbr vy cv vz cv cR wbr vy cv vz cv cS wbr vx
      cv vy cv cR cS breq vy cv vz cv cR cS breq anbi12d vx cv vz cv cR cS breq
      imbi12d anbi12d ralbidv 2ralbidv vx vy vz cA cR df-po vx vy vz cA cS
      df-po 3bitr4g $.
      $( [27-Mar-1997] $)
  $}

  $( Equality theorem for partial ordering predicate. $)
  poeq2 $p |- ( A = B -> ( R Po A <-> R Po B ) ) $=
    cA cB wceq cB cR wpo cA cR wpo cA cB wss cB cA wss wa cB cR wpo cA cR wpo
    wi cA cR wpo cB cR wpo wi wa cA cB wceq cB cR wpo cA cR wpo wb cA cB wss cB
    cR wpo cA cR wpo wi cB cA wss cA cR wpo cB cR wpo wi cA cB cR poss cB cA cR
    poss anim12i cA cB eqss cB cR wpo cA cR wpo dfbi2 3imtr4i bicomd $.
    $( [27-Mar-1997] $)

  ${
    $d x y z R $.  $d x y z A $.
    $d x y z B $.  $d x y z C $.  $d x y z D $.
    $( Properties of partial order relation in class notation. $)
    pocl $p |- ( R Po A -> ( ( B e. A /\ C e. A /\ D e. A ) ->
               ( -. B R B /\ ( ( B R C /\ C R D ) -> B R D ) ) ) ) $=
      cB cA wcel cC cA wcel cD cA wcel w3a cA cR wpo cB cB cR wbr wn cB cC cR
      wbr cC cD cR wbr wa cB cD cR wbr wi wa cA cR wpo vx cv vx cv cR wbr wn vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi cA cR
      wpo cB cB cR wbr wn cB vy cv cR wbr vy cv vz cv cR wbr wa cB vz cv cR wbr
      wi wa wi cA cR wpo cB cB cR wbr wn cB cC cR wbr cC vz cv cR wbr wa cB vz
      cv cR wbr wi wa wi cA cR wpo cB cB cR wbr wn cB cC cR wbr cC cD cR wbr wa
      cB cD cR wbr wi wa wi vx vy vz cB cC cD cA cA cA vx cv cB wceq vx cv vx
      cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi wa cB cB cR wbr wn cB vy cv cR wbr vy cv vz cv cR wbr wa cB vz cv cR
      wbr wi wa cA cR wpo vx cv cB wceq vx cv vx cv cR wbr wn cB cB cR wbr wn
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi cB vy cv
      cR wbr vy cv vz cv cR wbr wa cB vz cv cR wbr wi vx cv cB wceq vx cv vx cv
      cR wbr cB cB cR wbr vx cv cB wceq vx cv cB vx cv cB cR vx cv cB wceq id
      vx cv cB wceq id breq12d notbid vx cv cB wceq vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa cB vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr cB
      vz cv cR wbr vx cv cB wceq vx cv vy cv cR wbr cB vy cv cR wbr vy cv vz cv
      cR wbr vx cv cB vy cv cR breq1 anbi1d vx cv cB vz cv cR breq1 imbi12d
      anbi12d imbi2d vy cv cC wceq cB cB cR wbr wn cB vy cv cR wbr vy cv vz cv
      cR wbr wa cB vz cv cR wbr wi wa cB cB cR wbr wn cB cC cR wbr cC vz cv cR
      wbr wa cB vz cv cR wbr wi wa cA cR wpo vy cv cC wceq cB vy cv cR wbr vy
      cv vz cv cR wbr wa cB vz cv cR wbr wi cB cC cR wbr cC vz cv cR wbr wa cB
      vz cv cR wbr wi cB cB cR wbr wn vy cv cC wceq cB vy cv cR wbr vy cv vz cv
      cR wbr wa cB cC cR wbr cC vz cv cR wbr wa cB vz cv cR wbr vy cv cC wceq
      cB vy cv cR wbr cB cC cR wbr vy cv vz cv cR wbr cC vz cv cR wbr vy cv cC
      cB cR breq2 vy cv cC vz cv cR breq1 anbi12d imbi1d anbi2d imbi2d vz cv cD
      wceq cB cB cR wbr wn cB cC cR wbr cC vz cv cR wbr wa cB vz cv cR wbr wi
      wa cB cB cR wbr wn cB cC cR wbr cC cD cR wbr wa cB cD cR wbr wi wa cA cR
      wpo vz cv cD wceq cB cC cR wbr cC vz cv cR wbr wa cB vz cv cR wbr wi cB
      cC cR wbr cC cD cR wbr wa cB cD cR wbr wi cB cB cR wbr wn vz cv cD wceq
      cB cC cR wbr cC vz cv cR wbr wa cB cC cR wbr cC cD cR wbr wa cB vz cv cR
      wbr cB cD cR wbr vz cv cD wceq cC vz cv cR wbr cC cD cR wbr cB cC cR wbr
      vz cv cD cC cR breq2 anbi2d vz cv cD cB cR breq2 imbi12d anbi2d imbi2d cA
      cR wpo vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr
      wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa cA
      cR wpo vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr
      wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi
      vz cA cR wpo vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR
      wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa
      wi vz wal vx vy cA cR wpo vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a
      vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz
      cv cR wbr wi wa wi vz wal vy wal vx wal cA cR wpo vx cv vx cv cR wbr wn
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz cA
      wral vy cA wral vx cA wral vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a
      vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz
      cv cR wbr wi wa wi vz wal vy wal vx wal vx vy vz cA cR df-po vx cv vx cv
      cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      wa vx vy vz cA cA cA r3al bitri biimpi 19.21bbi 19.21bi com12 vtocl3ga
      com12 $.
      $( [27-Mar-1997] $)
  $}

  $( A partial order relation is irreflexive. $)
  poirr $p |- ( ( R Po A /\ B e. A ) -> -. B R B ) $=
    cA cR wpo cB cA wcel cB cA wcel cB cA wcel w3a cB cB cR wbr wn cB cA wcel
    cA cR wpo cB cA wcel cB cA wcel cB cA wcel w3a wa cB cB cR wbr wn cB cB cR
    wbr cB cB cR wbr wa cB cB cR wbr wi cA cR wpo cB cA wcel cB cA wcel cB cA
    wcel w3a cB cB cR wbr wn cB cB cR wbr cB cB cR wbr wa cB cB cR wbr wi wa cA
    cB cB cB cR pocl imp pm3.26d cB cA wcel cB cA wcel cB cA wcel w3a cB cA
    wcel cB cA wcel wa cB cA wcel wa cB cA wcel cB cA wcel wa cB cA wcel cB cA
    wcel cB cA wcel cB cA wcel df-3an cB cA wcel cB cA wcel anabs1 cB cA wcel
    anidm 3bitrri sylan2b $.
    $( [27-Mar-1997] $)

  $( A partial order relation is a transitive relation. $)
  potr $p |- ( ( R Po A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             ( ( B R C /\ C R D ) -> B R D ) ) $=
    cA cR wpo cB cA wcel cC cA wcel cD cA wcel w3a wa cB cB cR wbr wn cB cC cR
    wbr cC cD cR wbr wa cB cD cR wbr wi cA cR wpo cB cA wcel cC cA wcel cD cA
    wcel w3a cB cB cR wbr wn cB cC cR wbr cC cD cR wbr wa cB cD cR wbr wi wa cA
    cB cC cD cR pocl imp pm3.27d $.
    $( [27-Mar-1997] $)

  $( A partial order relation has no 2-cycle loops. $)
  po2nr $p |- ( ( R Po A /\ ( B e. A /\ C e. A ) ) ->
              -. ( B R C /\ C R B ) ) $=
    cA cR wpo cB cA wcel cC cA wcel wa wa cB cC cR wbr cC cB cR wbr wa cB cB cR
    wbr cA cR wpo cB cA wcel cB cB cR wbr wn cC cA wcel cA cB cR poirr adantrr
    cA cR wpo cB cA wcel cC cA wcel cB cC cR wbr cC cB cR wbr wa cB cB cR wbr
    wi cA cR wpo cB cA wcel cC cA wcel cB cC cR wbr cC cB cR wbr wa cB cB cR
    wbr wi wi cA cR wpo cB cA wcel cC cA wcel cB cA wcel cB cC cR wbr cC cB cR
    wbr wa cB cB cR wbr wi cA cR wpo cB cA wcel cC cA wcel cB cA wcel cB cC cR
    wbr cC cB cR wbr wa cB cB cR wbr wi cA cB cC cB cR potr 3exp2 com34 pm2.43d
    imp32 mtod $.
    $( [27-Mar-1997] $)

  $( A partial order relation has no 3-cycle loops. $)
  po3nr $p |- ( ( R Po A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             -. ( B R C /\ C R D /\ D R B ) ) $=
    cA cR wpo cB cA wcel cC cA wcel cD cA wcel w3a wa cB cC cR wbr cC cD cR wbr
    cD cB cR wbr w3a cB cD cR wbr cD cB cR wbr wa cA cR wpo cB cA wcel cD cA
    wcel cB cD cR wbr cD cB cR wbr wa wn cC cA wcel cA cB cD cR po2nr 3adantr2
    cA cR wpo cB cA wcel cC cA wcel cD cA wcel w3a wa cB cC cR wbr cC cD cR wbr
    wa cD cB cR wbr wa cB cD cR wbr cD cB cR wbr wa cB cC cR wbr cC cD cR wbr
    cD cB cR wbr w3a cA cR wpo cB cA wcel cC cA wcel cD cA wcel w3a wa cB cC cR
    wbr cC cD cR wbr wa cB cD cR wbr cD cB cR wbr cA cB cC cD cR potr anim1d cB
    cC cR wbr cC cD cR wbr cD cB cR wbr df-3an syl5ib mtod $.
    $( [27-Mar-1997] $)

  ${
    $d x y z R $.
    $( Any relation is a partial ordering of the empty set. $)
    po0 $p |- R Po (/) $=
      c0 cR wpo vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi wa vz c0 wral vy c0 wral vx c0 vx vy vz c0 cR df-po
      vx cv c0 wcel vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vx cv vz cv cR wbr wi wa vz c0 wral vy c0 wral vx cv noel pm2.21i
      mprgbir $.
      $( [28-Mar-1997] $)
  $}

  ${
    $d w y z R $.  $d w x y z $.
    $( MAY BE REVISED - use A instead of x $)
    $( Partial ordering of a singleton. $)
    posn $p |- ( R Po { x } <-> -. <. x , x >. e. R ) $=
      vx cv csn cR wpo vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR
      wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv csn wral vy vx
      cv csn wral vx cv vx cv cR wbr wn vx cv vx cv cop cR wcel wn vy vz vw vx
      cv csn cR df-po vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR
      wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv csn wral vy vx
      cv wsbc vy cv vy cv cR wbr wn vy cv vx cv cR wbr vx cv vx cv cR wbr wa vy
      cv vx cv cR wbr wi wa vy vx cv wsbc vy cv vy cv cR wbr wn vy cv vz cv cR
      wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz
      vx cv csn wral vy vx cv csn wral vx cv vx cv cR wbr wn vy cv vy cv cR wbr
      wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw
      vx cv csn wral vz vx cv csn wral vy cv vy cv cR wbr wn vy cv vx cv cR wbr
      vx cv vx cv cR wbr wa vy cv vx cv cR wbr wi wa vy vx vy cv vy cv cR wbr
      wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw
      vx cv csn wral vz vx cv csn wral vy cv vy cv cR wbr wn vy cv vz cv cR wbr
      vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv
      wsbc vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vx cv cR wbr wa vy cv
      vx cv cR wbr wi wa vz vx cv wsbc vy cv vy cv cR wbr wn vy cv vx cv cR wbr
      vx cv vx cv cR wbr wa vy cv vx cv cR wbr wi wa vx cv cvv wcel vy cv vy cv
      cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi
      wa vw vx cv csn wral vz vx cv csn wral vy cv vy cv cR wbr wn vy cv vz cv
      cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral
      vz vx cv wsbc wb vx visset vx cv cvv wcel vy cv vy cv cR wbr wn vy cv vz
      cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn
      wral vz vx cv wsbc vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv
      cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv csn wral vy
      cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv
      cR wbr wi wa vw vx cv csn wral vz vx cv cvv sbcsng bicomd ax-mp vy cv vy
      cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr
      wi wa vw vx cv csn wral vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vx
      cv cR wbr wa vy cv vx cv cR wbr wi wa vz vx vy cv vy cv cR wbr wn vy cv
      vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn
      wral vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv
      vw cv cR wbr wi wa vw vx cv wsbc vy cv vy cv cR wbr wn vy cv vz cv cR wbr
      vz cv vx cv cR wbr wa vy cv vx cv cR wbr wi wa vx cv cvv wcel vy cv vy cv
      cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi
      wa vw vx cv csn wral vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv
      cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv wsbc wb vx visset vx cv cvv
      wcel vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv
      vw cv cR wbr wi wa vw vx cv wsbc vy cv vy cv cR wbr wn vy cv vz cv cR wbr
      vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vy cv vy
      cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr
      wi wa vw vx cv cvv sbcsng bicomd ax-mp vy cv vy cv cR wbr wn vy cv vz cv
      cR wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vy cv vy cv cR wbr
      wn vy cv vz cv cR wbr vz cv vx cv cR wbr wa vy cv vx cv cR wbr wi wa vw
      vx vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vx cv cR wbr wa vy cv
      vx cv cR wbr wi wa vw ax-17 vw cv vx cv wceq vy cv vz cv cR wbr vz cv vw
      cv cR wbr wa vy cv vw cv cR wbr wi vy cv vz cv cR wbr vz cv vx cv cR wbr
      wa vy cv vx cv cR wbr wi vy cv vy cv cR wbr wn vw cv vx cv wceq vy cv vz
      cv cR wbr vz cv vw cv cR wbr wa vy cv vz cv cR wbr vz cv vx cv cR wbr wa
      vy cv vw cv cR wbr vy cv vx cv cR wbr vw cv vx cv wceq vz cv vw cv cR wbr
      vz cv vx cv cR wbr vy cv vz cv cR wbr vw cv vx cv vz cv cR breq2 anbi2d
      vw cv vx cv vy cv cR breq2 imbi12d anbi2d sbie bitri sbbii vy cv vy cv cR
      wbr wn vy cv vz cv cR wbr vz cv vx cv cR wbr wa vy cv vx cv cR wbr wi wa
      vy cv vy cv cR wbr wn vy cv vx cv cR wbr vx cv vx cv cR wbr wa vy cv vx
      cv cR wbr wi wa vz vx vy cv vy cv cR wbr wn vy cv vx cv cR wbr vx cv vx
      cv cR wbr wa vy cv vx cv cR wbr wi wa vz ax-17 vz cv vx cv wceq vy cv vz
      cv cR wbr vz cv vx cv cR wbr wa vy cv vx cv cR wbr wi vy cv vx cv cR wbr
      vx cv vx cv cR wbr wa vy cv vx cv cR wbr wi vy cv vy cv cR wbr wn vz cv
      vx cv wceq vy cv vz cv cR wbr vz cv vx cv cR wbr wa vy cv vx cv cR wbr vx
      cv vx cv cR wbr wa vy cv vx cv cR wbr vz cv vx cv wceq vy cv vz cv cR wbr
      vy cv vx cv cR wbr vz cv vx cv cR wbr vx cv vx cv cR wbr vz cv vx cv vy
      cv cR breq2 vz cv vx cv vx cv cR breq1 anbi12d imbi1d anbi2d sbie 3bitri
      sbbii vx cv cvv wcel vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv
      cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv csn wral vy
      vx cv csn wral vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv vw cv cR
      wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv csn wral vy vx
      cv wsbc wb vx visset vx cv cvv wcel vy cv vy cv cR wbr wn vy cv vz cv cR
      wbr vz cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz
      vx cv csn wral vy vx cv wsbc vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz
      cv vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv
      csn wral vy vx cv csn wral vy cv vy cv cR wbr wn vy cv vz cv cR wbr vz cv
      vw cv cR wbr wa vy cv vw cv cR wbr wi wa vw vx cv csn wral vz vx cv csn
      wral vy vx cv cvv sbcsng bicomd ax-mp vx cv vx cv cR wbr wn vx cv vx cv
      cR wbr wn vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx cv cR wbr wi
      wa vy cv vy cv cR wbr wn vy cv vx cv cR wbr vx cv vx cv cR wbr wa vy cv
      vx cv cR wbr wi wa vy vx cv wsbc vx cv vx cv cR wbr vx cv vx cv cR wbr wa
      vx cv vx cv cR wbr wi vx cv vx cv cR wbr wn vx cv vx cv cR wbr vx cv vx
      cv cR wbr pm3.26 biantru vy cv vy cv cR wbr wn vy cv vx cv cR wbr vx cv
      vx cv cR wbr wa vy cv vx cv cR wbr wi wa vx cv vx cv cR wbr wn vx cv vx
      cv cR wbr vx cv vx cv cR wbr wa vx cv vx cv cR wbr wi wa vy vx vx cv vx
      cv cR wbr wn vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx cv cR wbr
      wi wa vy ax-17 vy cv vx cv wceq vy cv vy cv cR wbr wn vx cv vx cv cR wbr
      wn vy cv vx cv cR wbr vx cv vx cv cR wbr wa vy cv vx cv cR wbr wi vx cv
      vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx cv cR wbr wi vy cv vx cv wceq
      vy cv vy cv cR wbr vx cv vx cv cR wbr vy cv vx cv wceq vy cv vy cv cR wbr
      vx cv vy cv cR wbr vx cv vx cv cR wbr vy cv vx cv vy cv cR breq1 vy cv vx
      cv vx cv cR breq2 bitrd notbid vy cv vx cv wceq vy cv vx cv cR wbr vx cv
      vx cv cR wbr wa vx cv vx cv cR wbr vx cv vx cv cR wbr wa vy cv vx cv cR
      wbr vx cv vx cv cR wbr vy cv vx cv wceq vy cv vx cv cR wbr vx cv vx cv cR
      wbr vx cv vx cv cR wbr vy cv vx cv vx cv cR breq1 anbi1d vy cv vx cv vx
      cv cR breq1 imbi12d anbi12d sbie bitr4i 3bitr4ri vx cv vx cv cR wbr vx cv
      vx cv cop cR wcel vx cv vx cv cR df-br notbii 3bitr2i $.
      $( [15-May-2009] $) $( [27-Apr-2009] $)
  $}

  ${
    $d x y R $.  $d x y A $.
    $( Define the strict complete (linear) order predicate. $)
    df-so $a |- ( R Or A <-> ( R Po A /\ A. x e. A A. y e. A
                ( x R y \/ x = y \/ y R x ) ) ) $.
  $}

  ${
    $d x y R $.  $d x y A $.
    $( A strict linear order is a strict partial order. $)
    sopo $p |- ( R Or A -> R Po A ) $=
      cA cR wor cA cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR
      wbr w3o vy cA wral vx cA wral vx vy cA cR df-so pm3.26bi $.
      $( [28-Mar-1997] $)
  $}

  ${
    $d x y R $.  $d x y A $.  $d x y B $.
    $( Subset theorem for the strict ordering predicate. $)
    soss $p |- ( A C_ B -> ( R Or B -> R Or A ) ) $=
      cA cB wss cB cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR
      wbr w3o vy cB wral vx cB wral wa cA cR wpo vx cv vy cv cR wbr vx cv vy cv
      wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral wa cB cR wor cA cR wor
      cA cB wss cB cR wpo cA cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv
      vx cv cR wbr w3o vy cB wral vx cB wral vx cv vy cv cR wbr vx cv vy cv
      wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral cA cB cR poss cA cB wss
      vx cv cB wcel vy cv cB wcel wa vx cv vy cv cR wbr vx cv vy cv wceq vy cv
      vx cv cR wbr w3o wi vy wal vx wal vx cv cA wcel vy cv cA wcel wa vx cv vy
      cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o wi vy wal vx wal vx cv
      vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cB wral vx cB
      wral vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA
      wral vx cA wral cA cB wss vx cv cB wcel vy cv cB wcel wa vx cv vy cv cR
      wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o wi vy wal vx cv cA wcel vy cv
      cA wcel wa vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o wi
      vy wal vx cA cB wss vx cv cB wcel vy cv cB wcel wa vx cv vy cv cR wbr vx
      cv vy cv wceq vy cv vx cv cR wbr w3o wi vx cv cA wcel vy cv cA wcel wa vx
      cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o wi vy cA cB wss
      vx cv cA wcel vy cv cA wcel wa vx cv cB wcel vy cv cB wcel wa vx cv vy cv
      cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o cA cB wss vx cv cA wcel vx
      cv cB wcel vy cv cA wcel vy cv cB wcel cA cB vx cv ssel cA cB vy cv ssel
      anim12d imim1d 19.20dv 19.20dv vx cv vy cv cR wbr vx cv vy cv wceq vy cv
      vx cv cR wbr w3o vx vy cB cB r2al vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o vx vy cA cA r2al 3imtr4g anim12d vx vy cB cR df-so vx
      vy cA cR df-so 3imtr4g $.
      $( [16-Mar-1997] $)
  $}

  ${
    $d x y R $.  $d x y S $.  $d x y A $.
    $( Equality theorem for the strict ordering predicate. $)
    soeq1 $p |- ( R = S -> ( R Or A <-> S Or A ) ) $=
      cR cS wceq cA cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR
      wbr w3o vy cA wral vx cA wral wa cA cS wpo vx cv vy cv cS wbr vx cv vy cv
      wceq vy cv vx cv cS wbr w3o vy cA wral vx cA wral wa cA cR wor cA cS wor
      cR cS wceq cA cR wpo cA cS wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv
      vx cv cR wbr w3o vy cA wral vx cA wral vx cv vy cv cS wbr vx cv vy cv
      wceq vy cv vx cv cS wbr w3o vy cA wral vx cA wral cA cR cS poeq1 cR cS
      wceq vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vx cv vy
      cv cS wbr vx cv vy cv wceq vy cv vx cv cS wbr w3o vx vy cA cA cR cS wceq
      vx cv vy cv cR wbr vx cv vy cv cS wbr vx cv vy cv wceq vx cv vy cv wceq
      vy cv vx cv cR wbr vy cv vx cv cS wbr vx cv vy cv cR cS breq cR cS wceq
      vx cv vy cv wceq biidd vy cv vx cv cR cS breq 3orbi123d 2ralbidv anbi12d
      vx vy cA cR df-so vx vy cA cS df-so 3bitr4g $.
      $( [16-Mar-1997] $)
  $}

  $( Equality theorem for the strict ordering predicate. $)
  soeq2 $p |- ( A = B -> ( R Or A <-> R Or B ) ) $=
    cA cB wceq cB cR wor cA cR wor cA cB wss cB cA wss wa cB cR wor cA cR wor
    wi cA cR wor cB cR wor wi wa cA cB wceq cB cR wor cA cR wor wb cA cB wss cB
    cR wor cA cR wor wi cB cA wss cA cR wor cB cR wor wi cA cB cR soss cB cA cR
    soss anim12i cA cB eqss cB cR wor cA cR wor dfbi2 3imtr4i bicomd $.
    $( [16-Mar-1997] $)

  $( A strict order relation is irreflexive. $)
  sonr $p |- ( ( R Or A /\ B e. A ) -> -. B R B ) $=
    cA cR wpo cB cA wcel cB cB cR wbr wn cA cR wor cA cB cR poirr cA cR sopo
    sylan $.
    $( [24-Nov-1995] $)

  $( A strict order relation is a transitive relation. $)
  sotr $p |- ( ( R Or A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             ( ( B R C /\ C R D ) -> B R D ) ) $=
    cA cR wpo cB cA wcel cC cA wcel cD cA wcel w3a cB cC cR wbr cC cD cR wbr wa
    cB cD cR wbr wi cA cR wor cA cB cC cD cR potr cA cR sopo sylan $.
    $( [21-Jan-1996] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y R $.

    $( A strict order relation is linear (satisfies trichotomy). $)
    solin $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B R C \/ B = C \/ C R B ) ) $=
      cB cA wcel cC cA wcel wa cA cR wor cB cC cR wbr cB cC wceq cC cB cR wbr
      w3o cA cR wor vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o
      wi cA cR wor cB vy cv cR wbr cB vy cv wceq vy cv cB cR wbr w3o wi cA cR
      wor cB cC cR wbr cB cC wceq cC cB cR wbr w3o wi vx vy cB cC cA cA vx cv
      cB wceq vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o cB vy
      cv cR wbr cB vy cv wceq vy cv cB cR wbr w3o cA cR wor vx cv cB wceq vx cv
      vy cv cR wbr cB vy cv cR wbr vx cv vy cv wceq cB vy cv wceq vy cv vx cv
      cR wbr vy cv cB cR wbr vx cv cB vy cv cR breq1 vx cv cB vy cv eqeq1 vx cv
      cB vy cv cR breq2 3orbi123d imbi2d vy cv cC wceq cB vy cv cR wbr cB vy cv
      wceq vy cv cB cR wbr w3o cB cC cR wbr cB cC wceq cC cB cR wbr w3o cA cR
      wor vy cv cC wceq cB vy cv cR wbr cB cC cR wbr cB vy cv wceq cB cC wceq
      vy cv cB cR wbr cC cB cR wbr vy cv cC cB cR breq2 vy cv cC cB eqeq2 vy cv
      cC cB cR breq1 3orbi123d imbi2d cA cR wor vx cv cA wcel vy cv cA wcel wa
      vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o cA cR wor cA
      cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA
      wral vx cA wral wa vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx
      cv vy cv wceq vy cv vx cv cR wbr w3o wi vx vy cA cR df-so vx cv vy cv cR
      wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral vx cv
      cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
      cR wbr w3o wi cA cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
      cR wbr w3o vx vy cA cA ra42 adantl sylbi com12 vtocl2ga impcom $.
      $( [21-Jan-1996] $)
  $}

  $( A strict order relation has no 2-cycle loops. $)
  so2nr $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              -. ( B R C /\ C R B ) ) $=
    cA cR wpo cB cA wcel cC cA wcel wa cB cC cR wbr cC cB cR wbr wa wn cA cR
    wor cA cB cC cR po2nr cA cR sopo sylan $.
    $( [21-Jan-1996] $)

  $( A strict order relation has no 3-cycle loops. $)
  so3nr $p |- ( ( R Or A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             -. ( B R C /\ C R D /\ D R B ) ) $=
    cA cR wpo cB cA wcel cC cA wcel cD cA wcel w3a cB cC cR wbr cC cD cR wbr cD
    cB cR wbr w3a wn cA cR wor cA cB cC cD cR po3nr cA cR sopo sylan $.
    $( [21-Jan-1996] $)

  $( A strict order relation satisfies strict trichotomy. $)
  sotric $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B R C <-> -. ( B = C \/ C R B ) ) ) $=
    cA cR wor cB cA wcel cC cA wcel wa wa cB cC wceq cC cB cR wbr wo cB cC cR
    wbr cA cR wor cB cA wcel cC cA wcel wa wa cB cC wceq cC cB cR wbr wo cB cC
    cR wbr wn cA cR wor cB cA wcel cC cA wcel wa wa cB cC wceq cB cC cR wbr wn
    cC cB cR wbr cA cR wor cB cA wcel cB cC wceq cB cC cR wbr wn wi cC cA wcel
    cB cC wceq cB cB cR wbr wn cB cC cR wbr wn cA cR wor cB cA wcel wa cB cC
    wceq cB cB cR wbr cB cC cR wbr cB cC cB cR breq2 notbid cA cB cR sonr
    syl5cbi adantrr cA cR wor cB cA wcel cC cA wcel wa wa cB cC cR wbr cC cB cR
    wbr cA cR wor cB cA wcel cC cA wcel wa wa cB cC cR wbr cC cB cR wbr wa wn
    cB cC cR wbr cC cB cR wbr wn wi cA cB cC cR so2nr cB cC cR wbr cC cB cR wbr
    imnan sylibr con2d jaod cA cR wor cB cA wcel cC cA wcel wa wa cB cC cR wbr
    cB cC wceq cC cB cR wbr w3o cB cC cR wbr wn cB cC wceq cC cB cR wbr wo wi
    cA cB cC cR solin cB cC cR wbr cB cC wceq cC cB cR wbr w3o cB cC cR wbr cB
    cC wceq cC cB cR wbr wo wo cB cC cR wbr wn cB cC wceq cC cB cR wbr wo wi cB
    cC cR wbr cB cC wceq cC cB cR wbr 3orass cB cC cR wbr cB cC wceq cC cB cR
    wbr wo df-or bitri sylib impbid con2bid $.
    $( [19-Feb-1996] $)

  $( Trichotomy law for strict order relation. $)
  sotrieq $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B = C <-> -. ( B R C \/ C R B ) ) ) $=
    cA cR wor cB cA wcel cC cA wcel wa wa cB cC wceq cB cC cR wbr wn cC cB cR
    wbr wn wa cB cC cR wbr cC cB cR wbr wo wn cA cR wor cB cA wcel cC cA wcel
    wa wa cB cC wceq cB cC cR wbr wn cC cB cR wbr wn wa cA cR wor cB cA wcel cC
    cA wcel cB cC wceq cB cC cR wbr wn cC cB cR wbr wn wa wi cB cC wceq cA cR
    wor cB cA wcel wa cA cR wor cC cA wcel wa wa cB cC cR wbr wn cC cB cR wbr
    wn wa cB cC wceq cA cR wor cB cA wcel wa cB cC cR wbr wn cA cR wor cC cA
    wcel wa cC cB cR wbr wn cB cC wceq cB cB cR wbr wn cB cC cR wbr wn cA cR
    wor cB cA wcel wa cB cC wceq cB cB cR wbr cB cC cR wbr cB cC cB cR breq2
    notbid cA cB cR sonr syl5bi cB cC wceq cC cB cR wbr wn cC cC cR wbr wn cA
    cR wor cC cA wcel wa cB cC wceq cC cB cR wbr cC cC cR wbr cB cC cC cR breq2
    notbid cA cC cR sonr syl5bir anim12d com12 anandis cA cR wor cB cA wcel cC
    cA wcel wa wa cB cC cR wbr wn cC cB cR wbr wn cB cC wceq cA cR wor cB cA
    wcel cC cA wcel wa wa cB cC cR wbr wn wa cB cC wceq cC cB cR wbr cA cR wor
    cB cA wcel cC cA wcel wa wa cB cC cR wbr wn wa cB cC wceq cC cB cR wbr cA
    cR wor cB cA wcel cC cA wcel wa wa cB cC wceq cC cB cR wbr wo cB cC cR wbr
    wn cA cR wor cB cA wcel cC cA wcel wa wa cB cC cR wbr cB cC wceq cC cB cR
    wbr wo cA cB cC cR sotric con2bid biimpar ord con1d expimpd impbid cB cC cR
    wbr cC cB cR wbr ioran syl6bbr $.
    $( [9-Apr-1996] $)

  $( Trichotomy law for strict order relation. $)
  sotrieq2 $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B = C <-> ( -. B R C /\ -. C R B ) ) ) $=
    cA cR wor cB cA wcel cC cA wcel wa wa cB cC wceq cB cC cR wbr cC cB cR wbr
    wo wn cB cC cR wbr wn cC cB cR wbr wn wa cA cB cC cR sotrieq cB cC cR wbr
    cC cB cR wbr ioran syl6bb $.
    $( [5-May-1999] $)

  ${
    $d x y z R $.  $d x y z A $.
    itlso.1 $e |- ( x e. A -> -. x R x ) $.
    itlso.2 $e |- ( ( x e. A /\ y e. A /\ z e. A ) ->
                  ( ( x R y /\ y R z ) -> x R z ) ) $.
    itlso.3 $e |- ( ( x e. A /\ y e. A ) -> ( x R y \/ x = y \/ y R x ) ) $.
    $( A irreflexive, transitive, linear relation is a strict ordering. $)
    itlso $p |- R Or A $=
      cA cR wor cA cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR
      wbr w3o vy cA wral vx cA wral vx vy cA cR df-so cA cR wpo vx cv vx cv cR
      wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa
      vz cA wral vy cA wral vx cA wral vx cv vx cv cR wbr wn vx cv vy cv cR wbr
      vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx vy vz cA cA cA vx cv cA
      wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR
      wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vx cv cA wcel vy cv cA
      wcel vx cv vx cv cR wbr wn vz cv cA wcel itlso.1 3ad2ant1 itlso.2 jca
      rgen3 vx vy vz cA cR df-po mpbir vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o vx vy cA itlso.3 rgen2a mpbir2an $.
      $( [21-Jan-1996] $)
  $}

  ${
    $d x y z R $.  $d x y z A $.
    so.1 $e |- ( ( x e. A /\ y e. A /\ z e. A ) ->
                  ( ( x R y <-> -. ( x = y \/ y R x ) ) /\
                 ( ( x R y /\ y R z ) -> x R z ) ) ) $.
    $( Deduce strict ordering from its properties. $)
    so $p |- R Or A $=
      vx vy vz cA cR vx cv cA wcel vx cv vx cv cR wbr wn vx cv cA wcel vx cv cA
      wcel wa vx cv vx cv wceq vx cv vx cv cR wbr wo vx cv vx cv cR wbr wn vx
      cv vx cv wceq vx cv vx cv cR wbr vx cv eqid orci vx cv cA wcel vy cv cA
      wcel wa vx cv vy cv wceq vy cv vx cv cR wbr wo vx cv vy cv cR wbr wn wb
      wi vx cv cA wcel vx cv cA wcel wa vx cv vx cv wceq vx cv vx cv cR wbr wo
      vx cv vx cv cR wbr wn wb wi vy vx vy cv vx cv wceq vx cv cA wcel vy cv cA
      wcel wa vx cv cA wcel vx cv cA wcel wa vx cv vy cv wceq vy cv vx cv cR
      wbr wo vx cv vy cv cR wbr wn wb vx cv vx cv wceq vx cv vx cv cR wbr wo vx
      cv vx cv cR wbr wn wb vy cv vx cv wceq vy cv cA wcel vx cv cA wcel vx cv
      cA wcel vy cv vx cv cA eleq1 anbi2d vy cv vx cv wceq vx cv vy cv wceq vy
      cv vx cv cR wbr wo vx cv vx cv wceq vx cv vx cv cR wbr wo vx cv vy cv cR
      wbr wn vx cv vx cv cR wbr wn vy cv vx cv wceq vx cv vy cv wceq vx cv vx
      cv wceq vy cv vx cv cR wbr vx cv vx cv cR wbr vy cv vx cv vx cv eqeq2 vy
      cv vx cv vx cv cR breq1 orbi12d vy cv vx cv wceq vx cv vy cv cR wbr vx cv
      vx cv cR wbr vy cv vx cv vx cv cR breq2 notbid bibi12d imbi12d vx cv cA
      wcel vy cv cA wcel wa vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR
      wbr wo vx cv cA wcel vy cv cA wcel vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr wo wn wb vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx
      cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wn wb wi vx cv cA
      wcel vy cv cA wcel vy cv cA wcel w3a vx cv vy cv cR wbr vx cv vy cv wceq
      vy cv vx cv cR wbr wo wn wb wi vz vy vz cv vy cv wceq vx cv cA wcel vy cv
      cA wcel vz cv cA wcel w3a vx cv cA wcel vy cv cA wcel vy cv cA wcel w3a
      vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wn wb vz cv vy
      cv wceq vz cv cA wcel vy cv cA wcel vx cv cA wcel vy cv cA wcel vz cv vy
      cv cA eleq1 3anbi3d imbi1d vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a
      vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wn wb vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi so.1 pm3.26d chvarv
      3anidm23 con2bid chvarv mpbii anidms vx cv cA wcel vy cv cA wcel vz cv cA
      wcel w3a vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wn wb
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi so.1
      pm3.27d vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr wn vx cv vy cv
      wceq vy cv vx cv cR wbr wo wi vx cv vy cv cR wbr vx cv vy cv wceq vy cv
      vx cv cR wbr w3o vx cv cA wcel vy cv cA wcel wa vx cv vy cv wceq vy cv vx
      cv cR wbr wo vx cv vy cv cR wbr wn vx cv cA wcel vy cv cA wcel wa vx cv
      vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo vx cv cA wcel vy cv
      cA wcel vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wn wb
      vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vy cv cR wbr vx cv vy
      cv wceq vy cv vx cv cR wbr wo wn wb wi vx cv cA wcel vy cv cA wcel vy cv
      cA wcel w3a vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wn
      wb wi vz vy vz cv vy cv wceq vx cv cA wcel vy cv cA wcel vz cv cA wcel
      w3a vx cv cA wcel vy cv cA wcel vy cv cA wcel w3a vx cv vy cv cR wbr vx
      cv vy cv wceq vy cv vx cv cR wbr wo wn wb vz cv vy cv wceq vz cv cA wcel
      vy cv cA wcel vx cv cA wcel vy cv cA wcel vz cv vy cv cA eleq1 3anbi3d
      imbi1d vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vy cv cR wbr
      vx cv vy cv wceq vy cv vx cv cR wbr wo wn wb vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi so.1 pm3.26d chvarv 3anidm23 con2bid
      biimprd vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vx cv
      vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr wo wo vx cv vy cv cR wbr
      wn vx cv vy cv wceq vy cv vx cv cR wbr wo wi vx cv vy cv cR wbr vx cv vy
      cv wceq vy cv vx cv cR wbr 3orass vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr wo df-or bitri sylibr itlso $.
      $( [29-Jan-1996] $)
  $}

  ${
    $d x y R $.
    $( Any relation is a strict ordering of the empty set. $)
    so0 $p |- R Or (/) $=
      c0 cR wor vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy
      c0 wral vx c0 c0 cR wor c0 cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o vy c0 wral vx c0 wral vx vy c0 cR df-so cR po0
      mpbiran vx cv c0 wcel vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR
      wbr w3o vy c0 wral vx cv noel pm2.21i mprgbir $.
      $( [16-Mar-1997] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Founded and well-ordering relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols. $)
  $c Fr $. $( Founded predicate symbol (read: 'founded'). $)
  $c We $. $( Well-ordering predicate symbol (read: 'well orders') $)

  $( Extend wff notation to include the founded predicate.  Read:  '` R ` is a
     founded relation on ` A ` .' $)
  wfr $a wff R Fr A $.

  $( Extend wff notation to include the well-ordering predicate.  Read:  '`R `
     well-orders ` A ` .' $)
  wwe $a wff R We A $.

  ${
    $d x y z R $.  $d x y z A $.
    $( Define the founded relation predicate.  For alternate definitions, see
       ~ dffr2 and ~ dffr3 . $)
    df-fr $a |- ( R Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                E. y e. x A. z e. x -. z R y ) ) $.
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    $( Property of founded relation (one direction of definition). $)
    fri $p |- ( ( ( B e. C /\ R Fr A ) /\ ( B C_ A /\ B =/= (/) ) ) ->
                E. x e. B A. y e. B -. y R x ) $=
      cB cC wcel cA cR wfr cB cA wss cB c0 wne wa vy cv vx cv cR wbr wn vy cB
      wral vx cB wrex cB cC wcel vz cv cA wss vz cv c0 wne wa vy cv vx cv cR
      wbr wn vy vz cv wral vx vz cv wrex wi vz wal cB cA wss cB c0 wne wa vy cv
      vx cv cR wbr wn vy cB wral vx cB wrex wi cA cR wfr vz cv cA wss vz cv c0
      wne wa vy cv vx cv cR wbr wn vy vz cv wral vx vz cv wrex wi cB cA wss cB
      c0 wne wa vy cv vx cv cR wbr wn vy cB wral vx cB wrex wi vz cB cC vz cv
      cB wceq vz cv cA wss vz cv c0 wne wa cB cA wss cB c0 wne wa vy cv vx cv
      cR wbr wn vy vz cv wral vx vz cv wrex vy cv vx cv cR wbr wn vy cB wral vx
      cB wrex vz cv cB wceq vz cv cA wss cB cA wss vz cv c0 wne cB c0 wne vz cv
      cB cA sseq1 vz cv cB c0 neeq1 anbi12d vy cv vx cv cR wbr wn vy vz cv wral
      vy cv vx cv cR wbr wn vy cB wral vx vz cv cB vy cv vx cv cR wbr wn vy vz
      cv cB raleq1 rexeqd imbi12d cla4gv vz vx vy cA cR df-fr syl5ib imp31 $.
      $( [3-Apr-2007] $) $( [18-Mar-1997] $)
  $}

  ${
    $d x y w v R $.  $d y z w v R $.  $d x w v A $.
    $( Alternate definition of founded relation.  Similar to Definition 6.21 of
       [TakeutiZaring] p. 30. $)
    dffr2 $p |- ( R Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                E. y e. x ( x i^i { z | z R y } ) = (/) ) ) $=
      cA cR wfr vx cv cA wss vx cv c0 wne wa vv cv vw cv cR wbr wn vv vx cv
      wral vw vx cv wrex wi vx wal vx cv cA wss vx cv c0 wne wa vx cv vz cv vy
      cv cR wbr vz cab cin c0 wceq vy vx cv wrex wi vx wal vx vw vv cA cR df-fr
      vx cv cA wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr vz cab cin c0 wceq
      vy vx cv wrex wi vx cv cA wss vx cv c0 wne wa vv cv vw cv cR wbr wn vv vx
      cv wral vw vx cv wrex wi vx vx cv vz cv vy cv cR wbr vz cab cin c0 wceq
      vy vx cv wrex vv cv vw cv cR wbr wn vv vx cv wral vw vx cv wrex vx cv cA
      wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr vz cab cin c0 wceq vy vx cv
      wrex vv cv vy cv cR wbr wn vv vx cv wral vy vx cv wrex vv cv vw cv cR wbr
      wn vv vx cv wral vw vx cv wrex vx cv vz cv vy cv cR wbr vz cab cin c0
      wceq vv cv vy cv cR wbr wn vv vx cv wral vy vx cv vx cv vz cv vy cv cR
      wbr vz cab cin c0 wceq vv cv vz cv vy cv cR wbr vz cab wcel wn vv vx cv
      wral vv cv vy cv cR wbr wn vv vx cv wral vv vx cv vz cv vy cv cR wbr vz
      cab disj vv cv vz cv vy cv cR wbr vz cab wcel wn vv cv vy cv cR wbr wn vv
      vx cv vv cv vz cv vy cv cR wbr vz cab wcel vv cv vy cv cR wbr vz cv vy cv
      cR wbr vv cv vy cv cR wbr vz vv cv vv visset vz cv vv cv vy cv cR breq1
      elab notbii ralbii bitri rexbii vv cv vy cv cR wbr wn vv vx cv wral vv cv
      vw cv cR wbr wn vv vx cv wral vy vw vx cv vy cv vw cv wceq vv cv vy cv cR
      wbr wn vv cv vw cv cR wbr wn vv vx cv vy cv vw cv wceq vv cv vy cv cR wbr
      vv cv vw cv cR wbr vy cv vw cv vv cv cR breq2 notbid ralbidv cbvrexv
      bitri imbi2i albii bitr4i $.
      $( [1-Feb-2007] $) $( [17-Feb-2004] $)
  $}

  ${
    $d x y z R $.  $d z A $.  $d x z B $.
    frc.1 $e |- B e. _V $.
    $( Property of founded relation (one direction of definition using class
       variables). $)
    frc $p |- ( ( R Fr A /\ B C_ A /\ B =/= (/) ) ->
                E. x e. B ( B i^i { y | y R x } ) = (/) ) $=
      cA cR wfr cB cA wss cB c0 wne cB vy cv vx cv cR wbr vy cab cin c0 wceq vx
      cB wrex cA cR wfr vz cv cA wss vz cv c0 wne wa vz cv vy cv vx cv cR wbr
      vy cab cin c0 wceq vx vz cv wrex wi vz wal cB cA wss cB c0 wne wa cB vy
      cv vx cv cR wbr vy cab cin c0 wceq vx cB wrex wi vz vx vy cA cR dffr2 vz
      cv cA wss vz cv c0 wne wa vz cv vy cv vx cv cR wbr vy cab cin c0 wceq vx
      vz cv wrex wi cB cA wss cB c0 wne wa cB vy cv vx cv cR wbr vy cab cin c0
      wceq vx cB wrex wi vz cB frc.1 vz cv cB wceq vz cv cA wss vz cv c0 wne wa
      cB cA wss cB c0 wne wa vz cv vy cv vx cv cR wbr vy cab cin c0 wceq vx vz
      cv wrex cB vy cv vx cv cR wbr vy cab cin c0 wceq vx cB wrex vz cv cB wceq
      vz cv cA wss cB cA wss vz cv c0 wne cB c0 wne vz cv cB cA sseq1 vz cv cB
      c0 neeq1 anbi12d vz cv vy cv vx cv cR wbr vy cab cin c0 wceq cB vy cv vx
      cv cR wbr vy cab cin c0 wceq vx vz cv cB vz cv cB wceq vz cv vy cv vx cv
      cR wbr vy cab cin cB vy cv vx cv cR wbr vy cab cin c0 vz cv cB vy cv vx
      cv cR wbr vy cab ineq1 eqeq1d rexeqd imbi12d cla4v sylbi 3impib $.
      $( [1-Feb-2007] $) $( [17-Feb-2004] $)
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    $( Subset theorem for the founded predicate.  Exercise 1 of
       [TakeutiZaring] p. 31. $)
    frss $p |- ( A C_ B -> ( R Fr B -> R Fr A ) ) $=
      cA cB wss vx cv cB wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr vz cab
      cin c0 wceq vy vx cv wrex wi vx wal vx cv cA wss vx cv c0 wne wa vx cv vz
      cv vy cv cR wbr vz cab cin c0 wceq vy vx cv wrex wi vx wal cB cR wfr cA
      cR wfr cA cB wss vx cv cB wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr vz
      cab cin c0 wceq vy vx cv wrex wi vx cv cA wss vx cv c0 wne wa vx cv vz cv
      vy cv cR wbr vz cab cin c0 wceq vy vx cv wrex wi vx cA cB wss vx cv cA
      wss vx cv c0 wne wa vx cv cB wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr
      vz cab cin c0 wceq vy vx cv wrex cA cB wss vx cv cA wss vx cv cB wss vx
      cv c0 wne vx cv cA wss cA cB wss vx cv cB wss vx cv cA cB sstr2 com12
      anim1d imim1d 19.20dv vx vy vz cB cR dffr2 vx vy vz cA cR dffr2 3imtr4g
      $.
      $( [3-Apr-1994] $)
  $}

  ${
    $d x y z R $.  $d x y z S $.  $d x y z A $.
    $( Equality theorem for the founded predicate. $)
    freq1 $p |- ( R = S -> ( R Fr A <-> S Fr A ) ) $=
      cR cS wceq vx cv cA wss vx cv c0 wne wa vz cv vy cv cR wbr wn vz vx cv
      wral vy vx cv wrex wi vx wal vx cv cA wss vx cv c0 wne wa vz cv vy cv cS
      wbr wn vz vx cv wral vy vx cv wrex wi vx wal cA cR wfr cA cS wfr cR cS
      wceq vx cv cA wss vx cv c0 wne wa vz cv vy cv cR wbr wn vz vx cv wral vy
      vx cv wrex wi vx cv cA wss vx cv c0 wne wa vz cv vy cv cS wbr wn vz vx cv
      wral vy vx cv wrex wi vx cR cS wceq vz cv vy cv cR wbr wn vz vx cv wral
      vy vx cv wrex vz cv vy cv cS wbr wn vz vx cv wral vy vx cv wrex vx cv cA
      wss vx cv c0 wne wa cR cS wceq vz cv vy cv cR wbr wn vz cv vy cv cS wbr
      wn vy vz vx cv vx cv cR cS wceq vz cv vy cv cR wbr vz cv vy cv cS wbr vz
      cv vy cv cR cS breq notbid rexralbidv imbi2d albidv vx vy vz cA cR df-fr
      vx vy vz cA cS df-fr 3bitr4g $.
      $( [9-Mar-1997] $)
  $}

  $( Equality theorem for the founded predicate. $)
  freq2 $p |- ( A = B -> ( R Fr A <-> R Fr B ) ) $=
    cA cB wceq cB cR wfr cA cR wfr cA cB wss cB cA wss wa cB cR wfr cA cR wfr
    wi cA cR wfr cB cR wfr wi wa cA cB wceq cB cR wfr cA cR wfr wb cA cB wss cB
    cR wfr cA cR wfr wi cB cA wss cA cR wfr cB cR wfr wi cA cB cR frss cB cA cR
    frss anim12i cA cB eqss cB cR wfr cA cR wfr dfbi2 3imtr4i bicomd $.
    $( [3-Apr-1994] $)

  ${
    $d y z R $.  $d x y z $.  $d y z A $.
    $( A founded relation is irreflexive.  Special case of Proposition 6.23 of
       [TakeutiZaring] p. 30. $)
    frirr $p |- ( ( R Fr A /\ x e. A ) -> -. x R x ) $=
      cA cR wfr vx cv cA wcel vx cv vx cv cR wbr wn cA cR wfr vx cv cA wcel vx
      cv csn vz cv vy cv cR wbr vz cab cin c0 wceq vy vx cv csn wrex vx cv vx
      cv cR wbr wn cA cR wfr vx cv cA wcel vx cv csn c0 wne vx cv csn vz cv vy
      cv cR wbr vz cab cin c0 wceq vy vx cv csn wrex vx cv vx visset snnz cA cR
      wfr vx cv csn cA wss vx cv csn c0 wne vx cv csn vz cv vy cv cR wbr vz cab
      cin c0 wceq vy vx cv csn wrex wi vx cv cA wcel cA cR wfr vx cv csn cA wss
      vx cv csn c0 wne vx cv csn vz cv vy cv cR wbr vz cab cin c0 wceq vy vx cv
      csn wrex vy vz cA vx cv csn cR vx cv snex frc 3exp vx cv cA vx visset
      snss syl5ib mpii vx cv csn vz cv vy cv cR wbr vz cab cin c0 wceq vx cv vx
      cv cR wbr wn vy vx cv csn vy cv vx cv csn wcel vy cv vx cv wceq vx cv csn
      vz cv vy cv cR wbr vz cab cin c0 wceq vx cv vx cv cR wbr wn wi vy vx cv
      elsn vy cv vx cv wceq vx cv csn vz cv vy cv cR wbr vz cab cin c0 wceq vx
      cv csn vz cv vx cv cR wbr vz cab cin c0 wceq vx cv vx cv cR wbr wn vy cv
      vx cv wceq vx cv csn vz cv vy cv cR wbr vz cab cin vx cv csn vz cv vx cv
      cR wbr vz cab cin c0 vy cv vx cv wceq vz cv vy cv cR wbr vz cab vz cv vx
      cv cR wbr vz cab vx cv csn vy cv vx cv wceq vz cv vy cv cR wbr vz cv vx
      cv cR wbr vz vy cv vx cv vz cv cR breq2 abbidv ineq2d eqeq1d vx cv vx cv
      cR wbr vx cv csn vz cv vx cv cR wbr vz cab cin c0 wceq vx cv vx cv cR wbr
      vx cv vx cv csn vz cv vx cv cR wbr vz cab cin wcel vx cv csn vz cv vx cv
      cR wbr vz cab cin c0 wceq wn vx cv vx cv cR wbr vx cv vx cv csn wcel vx
      cv vz cv vx cv cR wbr vz cab wcel wa vx cv vx cv csn vz cv vx cv cR wbr
      vz cab cin wcel vx cv vx cv cR wbr vx cv vz cv vx cv cR wbr vz cab wcel
      vx cv vx cv csn wcel vx cv vz cv vx cv cR wbr vz cab wcel vx cv vx cv cR
      wbr vz cv vx cv cR wbr vx cv vx cv cR wbr vz vx cv vx visset vz cv vx cv
      vx cv cR breq1 elab biimpri vx cv vx visset snid jctil vx cv vx cv csn vz
      cv vx cv cR wbr vz cab elin sylibr vx cv csn vz cv vx cv cR wbr vz cab
      cin vx cv n0i syl con2i syl6bi sylbi r19.23aiv syl6 imp $.
      $( [2-Jan-1994] $)
  $}

  ${
    $d z w R $.  $d z w x $.  $d z w y $.  $d z w A $.
    $( A founded relation has no 2-cycle loops.  Special case of Proposition
       6.23 of [TakeutiZaring] p. 30. $)
    fr2nr $p |- ( ( R Fr A /\ ( x e. A /\ y e. A ) ) ->
                -. ( x R y /\ y R x ) ) $=
      cA cR wfr vy cv cA wcel vx cv cA wcel vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa wn cA cR wfr vy cv vx cv cpr cA wss vx cv vy cv cR wbr vy cv vx cv
      cR wbr wa wn vy cv cA wcel vx cv cA wcel wa cA cR wfr vy cv vx cv cpr cA
      wss wa vy cv vx cv cpr vz cv vw cv cR wbr vz cab cin c0 wceq vw vy cv vx
      cv cpr wrex vx cv vy cv cR wbr vy cv vx cv cR wbr wa wn cA cR wfr vy cv
      vx cv cpr cA wss vy cv vx cv cpr c0 wne vy cv vx cv cpr vz cv vw cv cR
      wbr vz cab cin c0 wceq vw vy cv vx cv cpr wrex vy cv vx cv vy visset prnz
      vw vz cA vy cv vx cv cpr cR vy vx zfpair2 frc mp3an3 vy cv vx cv cpr vz
      cv vw cv cR wbr vz cab cin c0 wceq vx cv vy cv cR wbr vy cv vx cv cR wbr
      wa wn vw vy cv vx cv cpr vw cv vy cv vx cv cpr wcel vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa vy cv vx cv cpr vz cv vw cv cR wbr vz cab cin c0 vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vw cv vy cv vx cv cpr wcel vy cv vx cv
      cpr vz cv vw cv cR wbr vz cab cin c0 wne vx cv vy cv cR wbr vy cv vx cv
      cR wbr wa vw cv vy cv wceq vw cv vx cv wceq wo vy cv vx cv cpr vz cv vw
      cv cR wbr vz cab cin c0 wne vw cv vy cv vx cv cpr wcel vx cv vy cv cR wbr
      vw cv vy cv wceq vy cv vx cv cpr vz cv vw cv cR wbr vz cab cin c0 wne vy
      cv vx cv cR wbr vw cv vx cv wceq vw cv vy cv wceq vy cv vx cv cpr vz cv
      vw cv cR wbr vz cab cin c0 wne vy cv vx cv cpr vz cv vy cv cR wbr vz cab
      cin c0 wne vx cv vy cv cR wbr vw cv vy cv wceq vy cv vx cv cpr vz cv vw
      cv cR wbr vz cab cin vy cv vx cv cpr vz cv vy cv cR wbr vz cab cin c0 vw
      cv vy cv wceq vz cv vw cv cR wbr vz cab vz cv vy cv cR wbr vz cab vy cv
      vx cv cpr vw cv vy cv wceq vz cv vw cv cR wbr vz cv vy cv cR wbr vz vw cv
      vy cv vz cv cR breq2 abbidv ineq2d neeq1d vx cv vy cv cR wbr vx cv vz cv
      vy cv cR wbr vz cab wcel vy cv vx cv cpr vz cv vy cv cR wbr vz cab cin c0
      wne vx vy vz cR brab1 vx cv vy cv vx cv cpr wcel vx cv vz cv vy cv cR wbr
      vz cab wcel vy cv vx cv cpr vz cv vy cv cR wbr vz cab cin c0 wne vy cv vx
      cv vx visset prid2 vx cv vy cv vx cv cpr vz cv vy cv cR wbr vz cab inelcm
      mpan sylbi syl5cbir vw cv vx cv wceq vy cv vx cv cpr vz cv vw cv cR wbr
      vz cab cin c0 wne vy cv vx cv cpr vz cv vx cv cR wbr vz cab cin c0 wne vy
      cv vx cv cR wbr vw cv vx cv wceq vy cv vx cv cpr vz cv vw cv cR wbr vz
      cab cin vy cv vx cv cpr vz cv vx cv cR wbr vz cab cin c0 vw cv vx cv wceq
      vz cv vw cv cR wbr vz cab vz cv vx cv cR wbr vz cab vy cv vx cv cpr vw cv
      vx cv wceq vz cv vw cv cR wbr vz cv vx cv cR wbr vz vw cv vx cv vz cv cR
      breq2 abbidv ineq2d neeq1d vy cv vx cv cR wbr vy cv vz cv vx cv cR wbr vz
      cab wcel vy cv vx cv cpr vz cv vx cv cR wbr vz cab cin c0 wne vy vx vz cR
      brab1 vy cv vy cv vx cv cpr wcel vy cv vz cv vx cv cR wbr vz cab wcel vy
      cv vx cv cpr vz cv vx cv cR wbr vz cab cin c0 wne vy cv vx cv vy visset
      prid1 vy cv vy cv vx cv cpr vz cv vx cv cR wbr vz cab inelcm mpan sylbi
      syl5cbir jaao vw cv vy cv vx cv vw visset elpr syl5ib com12 necon2bd
      r19.23aiv syl vy cv vx cv cA vy visset vx visset prss sylan2b ancom2s $.
      $( [30-May-1994] $)
  $}

  ${
    $d x y z R $.
    $( Any relation is founded on the empty set. $)
    fr0 $p |- R Fr (/) $=
      c0 cR wfr vx cv c0 wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr vz cab
      cin c0 wceq vy vx cv wrex wi vx vx vy vz c0 cR dffr2 vx cv c0 wss vx cv
      c0 wne wa vx cv vz cv vy cv cR wbr vz cab cin c0 wceq vy vx cv wrex vx cv
      c0 wss vx cv c0 wne wn wi vx cv c0 wss vx cv c0 wne wa wn vx cv c0 wss vx
      cv c0 wceq vx cv c0 wne wn vx cv ss0 vx cv c0 nne sylibr vx cv c0 wss vx
      cv c0 wne imnan mpbi pm2.21i mpgbir $.
      $( [17-Sep-1993] $)
  $}

  ${
    $d x A $.
    $( Irreflexivitiy of the epsilon relation:  a class founded by epsilon is
       not a member of itself. $)
    efrirr $p |- ( _E Fr A  -> -. A e. A ) $=
      cA cep wfr cA cA wcel cA cA wcel cA cep wfr cA cA wcel wn vx cv cep wfr
      vx cv vx cv wcel wn wi cA cep wfr cA cA wcel wn wi vx cA cA vx cv cA wceq
      vx cv cep wfr cA cep wfr vx cv vx cv wcel wn cA cA wcel wn vx cv cA cep
      freq2 vx cv cA wceq vx cv vx cv wcel cA cA wcel vx cv cA wceq vx cv vx cv
      wcel cA vx cv wcel cA cA wcel vx cv cA vx cv eleq1 vx cv cA cA eleq2
      bitrd notbid imbi12d vx cv cep wfr vx cv vx cv wcel vx cv cep wfr vx cv
      vx cv wcel vx cv vx cv cep wbr wn vx cv vx cv wcel wn vx cv cep wfr vx cv
      vx cv wcel vx cv vx cv cep wbr wn vx vx cv cep frirr ex vx cv vx cv cep
      wbr vx cv vx cv wcel vx vx epel notbii syl6ib pm2.01d vtoclg com12
      pm2.01d $.
      $( [18-Apr-1994] $)
  $}

  $( A set founded by epsilon contains no 2-cycle loops. $)
  efrn2lp $p |- ( ( _E Fr A /\ ( x e. A /\ y e. A ) ) ->
                -. ( x e. y /\ y e. x ) ) $=
    cA cep wfr vx cv cA wcel vy cv cA wcel wa wa vx cv vy cv cep wbr vy cv vx
    cv cep wbr wa wn vx cv vy cv wcel vy cv vx cv wcel wa wn vx vy cA cep fr2nr
    vx cv vy cv cep wbr vy cv vx cv cep wbr wa vx cv vy cv wcel vy cv vx cv
    wcel wa vx cv vy cv cep wbr vx cv vy cv wcel vy cv vx cv cep wbr vy cv vx
    cv wcel vx vy epel vy vx epel anbi12i notbii sylib $.
    $( [19-Apr-1994] $)

  $( Similar to Theorem 7.2 of [TakeutiZaring] p. 35, of  except that the
     Axiom of Regularity is not required due to antecedent ` _E Fr A ` . $)
  tz7.2 $p |- ( ( Tr A /\ _E Fr A /\ B e. A ) -> ( B C_ A /\ B =/= A ) ) $=
    cA wtr cA cep wfr cB cA wcel cB cA wss cB cA wne wa cA wtr cB cA wcel cB cA
    wss cA cep wfr cB cA wne cA cB trss cA cep wfr cB cA wcel cB cA cB cA wceq
    cB cA wcel wn cA cA wcel wn cA cep wfr cB cA wceq cB cA wcel cA cA wcel cB
    cA cA eleq1 notbid cA efrirr syl5cbir necon2ad anim12ii 3impia $.
    $( [28-Apr-2007] $) $( [4-May-1994] $)

  ${
    $d x y z $.  $d x z A $.
    $( An alternate way of saying that the epsilon relation is founded. $)
    dfepfr $p |- ( _E Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                  E. y e. x ( x i^i y ) = (/) ) ) $=
      cA cep wfr vx cv cA wss vx cv c0 wne wa vx cv vz cv vy cv cep wbr vz cab
      cin c0 wceq vy vx cv wrex wi vx wal vx cv cA wss vx cv c0 wne wa vx cv vy
      cv cin c0 wceq vy vx cv wrex wi vx wal vx vy vz cA cep dffr2 vx cv cA wss
      vx cv c0 wne wa vx cv vz cv vy cv cep wbr vz cab cin c0 wceq vy vx cv
      wrex wi vx cv cA wss vx cv c0 wne wa vx cv vy cv cin c0 wceq vy vx cv
      wrex wi vx vx cv vz cv vy cv cep wbr vz cab cin c0 wceq vy vx cv wrex vx
      cv vy cv cin c0 wceq vy vx cv wrex vx cv cA wss vx cv c0 wne wa vx cv vz
      cv vy cv cep wbr vz cab cin c0 wceq vx cv vy cv cin c0 wceq vy vx cv vx
      cv vz cv vy cv cep wbr vz cab cin vx cv vy cv cin c0 vz cv vy cv cep wbr
      vz cab vy cv vx cv vz cv vy cv cep wbr vz cab vz cv vy cv wcel vz cab vy
      cv vz cv vy cv cep wbr vz cv vy cv wcel vz vz vy epel abbii vz vy cv
      abid2 eqtri ineq2i eqeq1i rexbii imbi2i albii bitri $.
      $( [20-Apr-2007] $) $( [17-Feb-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    epfrc.1 $e |- B e. _V $.
    $( A subset of an epsilon-founded class has a minimal element. $)
    epfrc $p |- ( ( _E Fr A /\ B C_ A /\ B =/= (/) ) ->
                  E. x e. B ( B i^i x ) = (/) ) $=
      cA cep wfr cB cA wss cB c0 wne w3a cB vy cv vx cv cep wbr vy cab cin c0
      wceq vx cB wrex cB vx cv cin c0 wceq vx cB wrex vx vy cA cB cep epfrc.1
      frc cB vx cv cin c0 wceq cB vy cv vx cv cep wbr vy cab cin c0 wceq vx cB
      cB vx cv cin cB vy cv vx cv cep wbr vy cab cin c0 vx cv vy cv vx cv cep
      wbr vy cab cB vy cv vx cv cep wbr vy cab vy cv vx cv wcel vy cab vx cv vy
      cv vx cv cep wbr vy cv vx cv wcel vy vy vx epel abbii vy vx cv abid2
      eqtr2i ineq2i eqeq1i rexbii sylibr $.
      $( [21-Apr-2007] $) $( [17-Feb-2004] $)
  $}

  $( Define the well-ordering predicate.  For an alternate definition, see
     ~ dfwe2 . $)
  df-we $a |- ( R We A <-> ( R Fr A /\ R Or A ) ) $.

  $( Subset theorem for the well-ordering predicate.  Exercise 4 of
     [TakeutiZaring] p. 31. $)
  wess $p |- ( A C_ B -> ( R We B -> R We A ) ) $=
    cA cB wss cB cR wfr cB cR wor wa cA cR wfr cA cR wor wa cB cR wwe cA cR wwe
    cA cB wss cB cR wfr cA cR wfr cB cR wor cA cR wor cA cB cR frss cA cB cR
    soss anim12d cB cR df-we cA cR df-we 3imtr4g $.
    $( [19-Apr-1994] $)

  $( Equality theorem for the well-ordering predicate. $)
  weeq1 $p |- ( R = S -> ( R We A <-> S We A ) ) $=
    cR cS wceq cA cR wfr cA cR wor wa cA cS wfr cA cS wor wa cA cR wwe cA cS
    wwe cR cS wceq cA cR wfr cA cS wfr cA cR wor cA cS wor cA cR cS freq1 cA cR
    cS soeq1 anbi12d cA cR df-we cA cS df-we 3bitr4g $.
    $( [9-Mar-1997] $)

  $( Equality theorem for the well-ordering predicate. $)
  weeq2 $p |- ( A = B -> ( R We A <-> R We B ) ) $=
    cA cB wceq cA cR wfr cA cR wor wa cB cR wfr cB cR wor wa cA cR wwe cB cR
    wwe cA cB wceq cA cR wfr cB cR wfr cA cR wor cB cR wor cA cB cR freq2 cA cB
    cR soeq2 anbi12d cA cR df-we cB cR df-we 3bitr4g $.
    $( [3-Apr-1994] $)

  $( A well-ordering is founded. $)
  wefr $p |- ( R We A -> R Fr A ) $=
    cA cR wwe cA cR wfr cA cR wor cA cR df-we pm3.26bi $.
    $( [22-Apr-1994] $)

  $( A well-ordering is a strict ordering. $)
  weso $p |- ( R We A -> R Or A ) $=
    cA cR wwe cA cR wfr cA cR wor cA cR df-we pm3.27bi $.
    $( [16-Mar-1997] $)

  $( The elements of an epsilon well-ordering are comparable. $)
  wecmpep $p |- ( ( _E We A /\ ( x e. A /\ y e. A ) ) ->
                 ( x e. y \/ x = y \/ y e. x ) ) $=
    cA cep wor vx cv cA wcel vy cv cA wcel wa vx cv vy cv wcel vx cv vy cv wceq
    vy cv vx cv wcel w3o cA cep wwe cA cep wor vx cv cA wcel vy cv cA wcel wa
    wa vx cv vy cv cep wbr vx cv vy cv wceq vy cv vx cv cep wbr w3o vx cv vy cv
    wcel vx cv vy cv wceq vy cv vx cv wcel w3o cA vx cv vy cv cep solin vx cv
    vy cv cep wbr vx cv vy cv wcel vx cv vy cv wceq vx cv vy cv wceq vy cv vx
    cv cep wbr vy cv vx cv wcel vx vy epel vx cv vy cv wceq biid vy vx epel
    3orbi123i sylib cA cep weso sylan $.
    $( [17-May-1994] $)

  $( An epsilon well-ordering is a transitive relation. $)
  wetrep $p |- ( ( _E We A /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
             ( ( x e. y /\ y e. z ) -> x e. z ) ) $=
    cA cep wwe vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a wa vx cv vy cv cep
    wbr vy cv vz cv cep wbr wa vx cv vz cv cep wbr vx cv vy cv wcel vy cv vz cv
    wcel wa vx cv vz cv wcel cA cep wor vx cv cA wcel vy cv cA wcel vz cv cA
    wcel w3a vx cv vy cv cep wbr vy cv vz cv cep wbr wa vx cv vz cv cep wbr wi
    cA cep wwe cA vx cv vy cv vz cv cep sotr cA cep weso sylan vx cv vy cv cep
    wbr vx cv vy cv wcel vy cv vz cv cep wbr vy cv vz cv wcel vx vy epel vy vz
    epel anbi12i vx vz epel 3imtr3g $.
    $( [22-Apr-1994] $)

  ${
    $d x y z R $.  $d y z A $.  $d x y z B $.
    $( A non-empty (possibly proper) subclass of a class well-ordered by ` _E `
       has a minimal element.  Special case of Proposition 6.26 of
       [TakeutiZaring] p. 31. $)
    wefrc $p |- ( ( _E We A /\ B C_ A /\ B =/= (/) ) ->
               E. x e. B ( B i^i x ) = (/) ) $=
      cA cep wwe cB cA wss cB c0 wne cB vx cv cin c0 wceq vx cB wrex cB cA wss
      cA cep wwe cB cep wwe cB c0 wne cB vx cv cin c0 wceq vx cB wrex wi cB cA
      cep wess cB cep wwe vy cv cB wcel vy wex cB vx cv cin c0 wceq vx cB wrex
      cB c0 wne cB cep wwe vy cv cB wcel cB vx cv cin c0 wceq vx cB wrex vy cB
      cep wwe vy cv cB wcel cB vx cv cin c0 wceq vx cB wrex cB cep wwe vy cv cB
      wcel wa cB vx cv cin c0 wceq vx cB wrex cB vy cv cin c0 vy cv cB wcel cB
      vy cv cin c0 wceq cB vx cv cin c0 wceq vx cB wrex wi cB cep wwe vy cv cB
      wcel cB vy cv cin c0 wceq cB vx cv cin c0 wceq vx cB wrex cB vx cv cin c0
      wceq cB vy cv cin c0 wceq vx vy cv cB vx cv vy cv wceq cB vx cv cin cB vy
      cv cin c0 vx cv vy cv cB ineq2 eqeq1d rcla4ev ex adantl cB cep wwe vy cv
      cB wcel wa cB vy cv cin c0 wne vx cv vy cv wcel cB vy cv cin vx cv cin c0
      wceq wa vx cB wrex cB vx cv cin c0 wceq vx cB wrex cB cep wwe cB vy cv
      cin c0 wne vx cv vy cv wcel cB vy cv cin vx cv cin c0 wceq wa vx cB wrex
      wi vy cv cB wcel cB cep wwe cB vy cv cin c0 wne cB vy cv cin vx cv cin c0
      wceq vx cB vy cv cin wrex vx cv vy cv wcel cB vy cv cin vx cv cin c0 wceq
      wa vx cB wrex cB cep wwe cB vy cv cin cB wss cB vy cv cin c0 wne cB vy cv
      cin vx cv cin c0 wceq vx cB vy cv cin wrex wi cB vy cv inss1 cB cep wwe
      cB vy cv cin cB wss cB vy cv cin c0 wne cB vy cv cin vx cv cin c0 wceq vx
      cB vy cv cin wrex cB cep wfr cB vy cv cin cB wss cB vy cv cin c0 wne cB
      vy cv cin vx cv cin c0 wceq vx cB vy cv cin wrex cB cep wwe vx cB cB vy
      cv cin vy cv cB vy visset inex2 epfrc cB cep wefr syl3an1 3exp mpi cB vy
      cv cin vx cv cin c0 wceq vx cv vy cv wcel cB vy cv cin vx cv cin c0 wceq
      wa vx cB vy cv cin cB vx cv cB vy cv cin wcel cB vy cv cin vx cv cin c0
      wceq wa vx cv cB wcel vx cv vy cv wcel wa cB vy cv cin vx cv cin c0 wceq
      wa vx cv cB wcel vx cv vy cv wcel cB vy cv cin vx cv cin c0 wceq wa wa vx
      cv cB vy cv cin wcel vx cv cB wcel vx cv vy cv wcel wa cB vy cv cin vx cv
      cin c0 wceq vx cv cB vy cv elin anbi1i vx cv cB wcel vx cv vy cv wcel cB
      vy cv cin vx cv cin c0 wceq anass bitri rexbii2 syl6ib adantr cB cep wwe
      vy cv cB wcel wa vx cv vy cv wcel cB vy cv cin vx cv cin c0 wceq wa cB vx
      cv cin c0 wceq vx cB cB cep wwe vy cv cB wcel wa vx cv cB wcel vx cv vy
      cv wcel cB vy cv cin vx cv cin c0 wceq cB vx cv cin c0 wceq cB cep wwe vy
      cv cB wcel wa vx cv cB wcel vx cv vy cv wcel cB vy cv cin vx cv cin c0
      wceq cB vx cv cin c0 wceq wi cB cep wwe vy cv cB wcel wa vx cv cB wcel vx
      cv vy cv wcel wa cB vx cv cin vy cv wss cB vy cv cin vx cv cin c0 wceq cB
      vx cv cin c0 wceq wi cB cep wwe vy cv cB wcel wa vx cv cB wcel vx cv vy
      cv wcel wa vz cv vy cv wcel vz cB vx cv cin wral cB vx cv cin vy cv wss
      cB cep wwe vy cv cB wcel wa vx cv cB wcel vx cv vy cv wcel wa vz cv vy cv
      wcel vz cB vx cv cin cB cep wwe vy cv cB wcel wa vz cv cB vx cv cin wcel
      vx cv cB wcel vx cv vy cv wcel wa vz cv vy cv wcel cB cep wwe vy cv cB
      wcel wa vz cv cB vx cv cin wcel vx cv cB wcel vx cv vy cv wcel vz cv vy
      cv wcel cB cep wwe vy cv cB wcel wa vz cv cB wcel vz cv vx cv wcel wa vx
      cv cB wcel vx cv vy cv wcel vz cv vy cv wcel wi wi vz cv cB vx cv cin
      wcel cB cep wwe vy cv cB wcel wa vz cv cB wcel vz cv vx cv wcel vx cv cB
      wcel vx cv vy cv wcel vz cv vy cv wcel wi wi cB cep wwe vy cv cB wcel wa
      vz cv cB wcel vx cv cB wcel vz cv vx cv wcel vx cv vy cv wcel vz cv vy cv
      wcel wi cB cep wwe vy cv cB wcel vz cv cB wcel vx cv cB wcel vz cv vx cv
      wcel vx cv vy cv wcel vz cv vy cv wcel wi wi wi wi cB cep wwe vy cv cB
      wcel vz cv cB wcel vx cv cB wcel vz cv vx cv wcel vx cv vy cv wcel vz cv
      vy cv wcel wi wi cB cep wwe vz cv cB wcel vx cv cB wcel vy cv cB wcel w3a
      vz cv vx cv wcel vx cv vy cv wcel vz cv vy cv wcel wi wi vy cv cB wcel vz
      cv cB wcel wa vx cv cB wcel wa cB cep wwe vz cv cB wcel vx cv cB wcel vy
      cv cB wcel w3a wa vz cv vx cv wcel vx cv vy cv wcel vz cv vy cv wcel vz
      vx vy cB wetrep exp3a vy cv cB wcel vz cv cB wcel wa vx cv cB wcel wa vy
      cv cB wcel vz cv cB wcel vx cv cB wcel w3a vz cv cB wcel vx cv cB wcel vy
      cv cB wcel w3a vy cv cB wcel vz cv cB wcel vx cv cB wcel df-3an vy cv cB
      wcel vz cv cB wcel vx cv cB wcel 3anrot bitr3i sylan2b exp44 imp com34
      imp3a vz cv cB vx cv elin syl5ib imp4a com23 r19.21adv vz cB vx cv cin vy
      cv dfss3 syl6ibr cB vx cv cin vy cv wss cB vx cv cin c0 wceq cB vy cv cin
      vx cv cin c0 wceq cB vx cv cin vy cv wss cB vx cv cin cB vy cv cin vx cv
      cin c0 cB vx cv cin vy cv wss cB vx cv cin cB vy cv cin vx cv cin wceq cB
      vx cv cin vy cv wss cB vx cv cin cB vx cv cin vy cv cin wceq cB vx cv cin
      cB vy cv cin vx cv cin wceq cB vx cv cin vy cv dfss cB vx cv cin vy cv
      cin cB vy cv cin vx cv cin cB vx cv cin cB vx cv vy cv in23 eqeq2i bitri
      biimpi eqeq1d biimprd syl6 exp3a imp4a r19.22dv syld pm2.61dne ex
      19.23adv vy cB n0 syl5ib syl6com 3imp $.
      $( [18-Mar-2007] $) $( [17-Feb-2004] $)
  $}

  $( Any relation is a well-ordering of the empty set. $)
  we0 $p |- R We (/) $=
    c0 cR wwe c0 cR wfr c0 cR wor c0 cR df-we cR fr0 cR so0 mpbir2an $.
    $( [16-Mar-1997] $)

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    wereu.1 $e |- B e. _V $.
    $( A subset of a well-ordered set has a unique minimal element. $)
    wereu $p |- ( ( R We A /\ B C_ A /\ B =/= (/) ) ->
                E! x e. B A. y e. B -. y R x ) $=
      vy cv vx cv cR wbr wn vy cB wral vx cB wreu vy cv vx cv cR wbr wn vy cB
      wral vx cB wrex vy cv vx cv cR wbr wn vy cB wral vy cv vz cv cR wbr wn vy
      cB wral wa vx cv vz cv wceq wi vz cB wral vx cB wral cA cR wwe cB cA wss
      cB c0 wne w3a vy cv vx cv cR wbr wn vy cB wral vy cv vz cv cR wbr wn vy
      cB wral vx vz cB vx cv vz cv wceq vy cv vx cv cR wbr wn vy cv vz cv cR
      wbr wn vy cB vx cv vz cv wceq vy cv vx cv cR wbr vy cv vz cv cR wbr vx cv
      vz cv vy cv cR breq2 notbid ralbidv reu4 cA cR wfr cB cA wss cB c0 wne vy
      cv vx cv cR wbr wn vy cB wral vx cB wrex cA cR wwe cA cR wfr cB cA wss cB
      c0 wne vy cv vx cv cR wbr wn vy cB wral vx cB wrex cB cvv wcel cA cR wfr
      cB cA wss cB c0 wne wa vy cv vx cv cR wbr wn vy cB wral vx cB wrex
      wereu.1 vx vy cA cB cvv cR fri mpanl1 3impb cA cR wefr syl3an1 cA cR wwe
      cB cA wss cB c0 wne w3a vy cv vx cv cR wbr wn vy cB wral vy cv vz cv cR
      wbr wn vy cB wral wa vx cv vz cv wceq wi vx vz cB cB cA cR wwe cB cA wss
      vx cv cB wcel vz cv cB wcel wa vy cv vx cv cR wbr wn vy cB wral vy cv vz
      cv cR wbr wn vy cB wral wa vx cv vz cv wceq wi wi cB c0 wne cA cR wwe cB
      cA wss wa vx cv cB wcel vz cv cB wcel wa vy cv vx cv cR wbr wn vy cB wral
      vy cv vz cv cR wbr wn vy cB wral wa vx cv vz cv wceq wi cA cR wwe cB cA
      wss wa vx cv cB wcel vz cv cB wcel wa vx cv cB wcel vz cv cB wcel wa vy
      cv vx cv cR wbr wn vy cB wral vy cv vz cv cR wbr wn vy cB wral wa vx cv
      vz cv wceq cA cR wwe cB cA wss wa vx cv cB wcel vz cv cB wcel wa wa vx cv
      vz cv cR wbr wn vz cv vx cv cR wbr wn wa vx cv vz cv wceq vx cv cB wcel
      vz cv cB wcel wa vy cv vx cv cR wbr wn vy cB wral vy cv vz cv cR wbr wn
      vy cB wral wa wa cB cR wwe vx cv cB wcel vz cv cB wcel wa vx cv vz cv cR
      wbr wn vz cv vx cv cR wbr wn wa vx cv vz cv wceq wi cA cR wwe cB cA wss
      wa cB cR wwe vx cv cB wcel vz cv cB wcel wa wa vx cv vz cv cR wbr vz cv
      vx cv cR wbr wo wn vx cv vz cv wceq vx cv vz cv cR wbr wn vz cv vx cv cR
      wbr wn wa cB cR wwe vx cv cB wcel vz cv cB wcel wa wa vx cv vz cv cR wbr
      vx cv vz cv wceq vz cv vx cv cR wbr w3o vx cv vz cv cR wbr vz cv vx cv cR
      wbr wo wn vx cv vz cv wceq wi cB cR wor vx cv cB wcel vz cv cB wcel wa vx
      cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o cB cR wwe cB vx
      cv vz cv cR solin cB cR weso sylan vx cv vz cv cR wbr vx cv vz cv wceq vz
      cv vx cv cR wbr w3o vx cv vz cv cR wbr vx cv vz cv wceq wo vz cv vx cv cR
      wbr wo vx cv vz cv cR wbr vz cv vx cv cR wbr wo vx cv vz cv wceq wo vx cv
      vz cv cR wbr vz cv vx cv cR wbr wo wn vx cv vz cv wceq wi vx cv vz cv cR
      wbr vx cv vz cv wceq vz cv vx cv cR wbr df-3or vx cv vz cv cR wbr vx cv
      vz cv wceq vz cv vx cv cR wbr or23 vx cv vz cv cR wbr vz cv vx cv cR wbr
      wo vx cv vz cv wceq df-or 3bitri sylib vx cv vz cv cR wbr vz cv vx cv cR
      wbr ioran syl5ibr cB cA wss cA cR wwe cB cR wwe cB cA cR wess impcom
      sylan vx cv cB wcel vz cv cB wcel wa vy cv vx cv cR wbr wn vy cB wral vy
      cv vz cv cR wbr wn vy cB wral wa vx cv vz cv cR wbr wn vz cv vx cv cR wbr
      wn wa vx cv cB wcel vz cv cB wcel wa vy cv vz cv cR wbr wn vy cB wral vy
      cv vx cv cR wbr wn vy cB wral vx cv vz cv cR wbr wn vz cv vx cv cR wbr wn
      wa vx cv cB wcel vy cv vz cv cR wbr wn vy cB wral vx cv vz cv cR wbr wn
      vz cv cB wcel vy cv vx cv cR wbr wn vy cB wral vz cv vx cv cR wbr wn vy
      cv vz cv cR wbr wn vx cv vz cv cR wbr wn vy vx cv cB vy cv vx cv wceq vy
      cv vz cv cR wbr vx cv vz cv cR wbr vy cv vx cv vz cv cR breq1 notbid
      rcla4v vy cv vx cv cR wbr wn vz cv vx cv cR wbr wn vy vz cv cB vy cv vz
      cv wceq vy cv vx cv cR wbr vz cv vx cv cR wbr vy cv vz cv vx cv cR breq1
      notbid rcla4v im2anan9 ancomsd imp syl5 exp4b pm2.43d 3adant3 r19.21aivv
      sylanbrc $.
      $( [5-Apr-2007] $) $( [18-Mar-1997] $)

    $( The unique minimal element of a subset of a well-ordered set. $)
    wereucl $p |- ( ( R We A /\ B C_ A /\ B =/= (/) ) ->
                U. { x e. B | A. y e. B -. y R x } e. B ) $=
      cA cR wwe cB cA wss cB c0 wne w3a vy cv vx cv cR wbr wn vy cB wral vx cB
      wreu vy cv vx cv cR wbr wn vy cB wral vx cB crab cuni cB wcel vx vy cA cB
      cR wereu.1 wereu vy cv vx cv cR wbr wn vy cB wral vx cB reucl syl $.
      $( [23-Sep-2007] $) $( [23-Sep-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordinals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c Ord $. $( Ordinal predicate $)
  $c On $. $( The class of ordinal numbers $)
  $c Lim $. $( Limit ordinal predicate $)
  $c suc $. $( Successor function (read:  'successor of') $)

  $( Extend the definition of a wff to include the ordinal predicate. $)
  word $a wff Ord A $.

  $( Extend the definition of a class to include the class of all ordinal
     numbers.  (The 0 in the name prevents creating a file called con.html,
     which causes problems in Windows.) $)
  con0 $a class On $.

  $( Extend the definition of a wff to include the limit ordinal predicate. $)
  wlim $a wff Lim A $.

  $( Extend class notation to include the successor function. $)
  csuc $a class suc A $.

  $( Define the ordinal predicate, which is true for a class that is transitive
     and is well-ordered by the epsilon relation.  Variant of definition of
     [BellMachover] p. 468. $)
  df-ord $a |- ( Ord A <-> ( Tr A /\ _E We A ) ) $.

  $( Define the class of all ordinal numbers.  Definition 7.11 of
     [TakeutiZaring] p. 38. $)
  df-on $a |- On = { x | Ord x } $.

  $( Define the limit ordinal predicate, which is true for a non-empty ordinal
     that is not a successor (i.e. that is the union of itself).  Our
     definition combines the definition of Lim of [BellMachover] p. 471 and
     Exercise 1 of [TakeutiZaring] p. 42.  See ~ dflim2 , ~ dflim3 , and
     dflim4 for alternate definitions. $)
  df-lim $a |- ( Lim A <-> ( Ord A /\ A =/= (/) /\ A = U. A ) ) $.

  $( Define the successor of a class.  When applied to an ordinal number, the
     successor means the same thing as "plus 1" (see ~ oa1suc ).  Definition
     7.22 of [TakeutiZaring] p. 41, who use "+ 1" to denote this function.
     Our definition is a generalization to classes.  Although it is not
     conventional to use it with proper classes, it has no affect on a proper
     class ( ~ sucprc ), so that the successor of any ordinal class is still
     an ordinal class ( ~ ordsuc ), simplifying certain proofs.  Some authors
     denote the successor operation with a prime (apostrophe-like) symbol,
     such as Definition 6 of [Suppes] p. 134 and the definition of successor
     in [Mendelson] p. 246 (who uses the symbol "Suc" as a predicate to mean
     "is a successor ordinal").  The definition of successor of [Enderton]
     p. 68 denotes the operation with a plus-sign superscript. $)
  df-suc $a |- suc A = ( A u. { A } ) $.

  $( Equality theorem for the ordinal predicate. $)
  ordeq $p |- ( A = B -> ( Ord A <-> Ord B ) ) $=
    cA cB wceq cA wtr cA cep wwe wa cB wtr cB cep wwe wa cA word cB word cA cB
    wceq cA wtr cB wtr cA cep wwe cB cep wwe cA cB treq cA cB cep weeq2 anbi12d
    cA df-ord cB df-ord 3bitr4g $.
    $( [17-Sep-1993] $)

  ${
    $d x A $.
    $( An ordinal number is an ordinal set. $)
    elong $p |- ( A e. B -> ( A e. On <-> Ord A ) ) $=
      vx cv word cA word vx cA con0 cB vx cv cA ordeq vx df-on elab2g $.
      $( [5-Jun-1994] $)
  $}

  ${
    elon.1 $e |- A e. _V $.
    $( An ordinal number is an ordinal set. $)
    elon $p |- ( A e. On <-> Ord A ) $=
      cA cvv wcel cA con0 wcel cA word wb elon.1 cA cvv elong ax-mp $.
      $( [5-Jun-1994] $)
  $}

  $( An ordinal number has the ordinal property. $)
  eloni $p |- ( A e. On -> Ord A ) $=
    cA con0 wcel cA word cA con0 elong ibi $.
    $( [5-Jun-1994] $)

  $( An ordinal number is an ordinal set. $)
  elon2 $p |- ( A e. On <-> ( Ord A /\ A e. _V ) ) $=
    cA con0 wcel cA word cA cvv wcel wa cA con0 wcel cA word cA cvv wcel cA
    eloni cA con0 elisset jca cA cvv wcel cA con0 wcel cA word cA cvv elong
    biimparc impbii $.
    $( [8-Feb-2004] $) $( [8-Feb-2004] $)

  $( Equality theorem for the limit predicate. $)
  limeq $p |- ( A = B -> ( Lim A <-> Lim B ) ) $=
    cA cB wceq cA word cA c0 wne cA cA cuni wceq w3a cB word cB c0 wne cB cB
    cuni wceq w3a cA wlim cB wlim cA cB wceq cA word cB word cA c0 wne cB c0
    wne cA cA cuni wceq cB cB cuni wceq cA cB ordeq cA cB c0 neeq1 cA cB wceq
    cA cA cuni wceq cA cB cuni wceq cB cB cuni wceq cA cB wceq cA cuni cB cuni
    cA cA cB unieq eqeq2d cA cB cB cuni eqeq1 bitrd 3anbi123d cA df-lim cB
    df-lim 3bitr4g $.
    $( [22-Apr-1994] $)

  $( Epsilon well orders every ordinal.  Proposition 7.4 of [TakeutiZaring]
     p. 36. $)
  ordwe $p |- ( Ord A -> _E We A ) $=
    cA word cA wtr cA cep wwe cA df-ord pm3.27bi $.
    $( [3-Apr-1994] $)

  $( An ordinal class is transitive. $)
  ordtr $p |- ( Ord A -> Tr A ) $=
    cA word cA wtr cA cep wwe cA df-ord pm3.26bi $.
    $( [3-Apr-1994] $)

  $( Epsilon is well-founded on an ordinal class. $)
  ordfr $p |- ( Ord A -> _E Fr A ) $=
    cA word cA cep wwe cA cep wfr cA ordwe cA cep wefr syl $.
    $( [22-Apr-1994] $)

  $( An element of an ordinal class is a subset of it. $)
  ordelss $p |- ( ( Ord A /\ B e. A ) -> B C_ A ) $=
    cA wtr cB cA wcel cB cA wss cA word cA wtr cB cA wcel cB cA wss cA cB trss
    imp cA ordtr sylan $.
    $( [30-May-1994] $)

  $( A transitive subclass of an ordinal class is ordinal. $)
  trssord $p |- ( ( Tr A /\ A C_ B /\ Ord B ) -> Ord A ) $=
    cA wtr cA cB wss cB word wa wa cA wtr cA cep wwe wa cA wtr cA cB wss cB
    word w3a cA word cA cB wss cB word wa cA cep wwe cA wtr cA cB wss cB cep
    wwe cA cep wwe cB word cA cB wss cB cep wwe cA cep wwe cA cB cep wess imp
    cB ordwe sylan2 anim2i cA wtr cA cB wss cB word 3anass cA df-ord 3imtr4i $.
    $( [29-May-1994] $)

  $( Epsilon irreflexivity of ordinals:  no ordinal class is a member of
     itself.  Theorem 2.2(i) of [BellMachover] p. 469, generalized to classes.
     We prove this without invoking the Axiom of Regularity. $)
  ordirr $p |- ( Ord A -> -. A e. A ) $=
    cA word cA cep wfr cA cA wcel wn cA ordfr cA efrirr syl $.
    $( [2-Jan-1994] $)

  $( A member of an ordinal class is not equal to it. $)
  nordeq $p |- ( ( Ord A /\ B e. A ) -> A =/= B ) $=
    cA word cB cA wcel cA cB wne cA word cB cA wcel cA cB cA cB wceq cA cA wcel
    wn cB cA wcel wn cA word cA cB wceq cA cA wcel cB cA wcel cA cB cA eleq1
    notbid cA ordirr syl5cbi necon2ad imp $.
    $( [3-Jun-2007] $) $( [25-May-1998] $)

  $( An ordinal class cannot an element of one of its members.  Variant of
     first part of Theorem 2.2(vii) of [BellMachover] p. 469. $)
  ordn2lp $p |- ( Ord A -> -. ( A e. B /\ B e. A ) ) $=
    cA word cA cB wcel cB cA wcel wa cA cA wcel cA ordirr cA word cA wtr cA cB
    wcel cB cA wcel wa cA cA wcel wi cA ordtr cA cA cB trel syl mtod $.
    $( [3-Apr-1994] $)

  ${
    $d x R $.  $d x A $.  $d x B $.
    $( A subclass (possibly proper) of an ordinal class has a minimal element.
       Proposition 7.5 of [TakeutiZaring] p. 36. $)
    tz7.5 $p |- ( ( Ord A /\ B C_ A /\ B =/= (/) ) ->
               E. x e. B ( B i^i x ) = (/) ) $=
      cA cep wwe cB cA wss cB c0 wne cB vx cv cin c0 wceq vx cB wrex cA word vx
      cA cB wefrc cA ordwe syl3an1 $.
      $( [19-Mar-2007] $) $( [18-Feb-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( An element of an ordinal class is ordinal.  Proposition 7.6 of
       [TakeutiZaring] p. 36. $)
    ordelord $p |- ( ( Ord A /\ B e. A ) -> Ord B ) $=
      cA word cB cA wcel cB word cA word vx cv cA wcel wa vx cv word wi cA word
      cB cA wcel wa cB word wi vx cB cA vx cv cB wceq cA word vx cv cA wcel wa
      cA word cB cA wcel wa vx cv word cB word vx cv cB wceq vx cv cA wcel cB
      cA wcel cA word vx cv cB cA eleq1 anbi2d vx cv cB ordeq imbi12d vx cv
      word vx cv wtr vx cv cep wwe cA word vx cv cA wcel wa vx cv df-ord cA
      word vx cv cA wcel wa vz cv vy cv wcel vy cv vx cv wcel wa vz cv vx cv
      wcel wi vy wal vz wal vx cv wtr cA word vx cv cA wcel wa vz cv vy cv wcel
      vy cv vx cv wcel wa vz cv vx cv wcel wi vz vy cA word vx cv cA wcel wa vz
      cv vy cv wcel vy cv vx cv wcel wa vz cv vx cv wcel cA word vx cv cA wcel
      wa vz cv vy cv wcel vy cv vx cv wcel wa vz cv vy cv wcel vy cv vx cv wcel
      wa vz cv vx cv wcel wi cA word vz cv cA wcel vy cv cA wcel vx cv cA wcel
      w3a vz cv vy cv wcel vy cv vx cv wcel wa vz cv vx cv wcel wi cA word vx
      cv cA wcel wa vz cv vy cv wcel vy cv vx cv wcel wa wa cA cep wwe vz cv cA
      wcel vy cv cA wcel vx cv cA wcel w3a vz cv vy cv wcel vy cv vx cv wcel wa
      vz cv vx cv wcel wi cA word vz vy vx cA wetrep cA ordwe sylan cA word vx
      cv cA wcel vz cv vy cv wcel vy cv vx cv wcel wa simpll cA word vx cv cA
      wcel wa vz cv vy cv wcel vy cv vx cv wcel wa wa vz cv cA wcel vy cv cA
      wcel vx cv cA wcel cA word vx cv cA wcel vz cv vy cv wcel vy cv vx cv
      wcel wa vz cv cA wcel cA word vx cv cA wcel vz cv vy cv wcel vy cv vx cv
      wcel wa vz cv cA wcel cA word vz cv vy cv wcel vy cv vx cv wcel vx cv cA
      wcel w3a vz cv cA wcel vx cv cA wcel vz cv vy cv wcel vy cv vx cv wcel wa
      wa cA word cA wtr vz cv vy cv wcel vy cv vx cv wcel vx cv cA wcel w3a vz
      cv cA wcel wi cA ordtr cA vz cv vy cv vx cv trel3 syl vz cv vy cv wcel vy
      cv vx cv wcel vx cv cA wcel w3a vx cv cA wcel vz cv vy cv wcel vy cv vx
      cv wcel w3a vx cv cA wcel vz cv vy cv wcel vy cv vx cv wcel wa wa vx cv
      cA wcel vz cv vy cv wcel vy cv vx cv wcel 3anrot vx cv cA wcel vz cv vy
      cv wcel vy cv vx cv wcel 3anass bitr3i syl5ibr exp3a imp31 cA word vx cv
      cA wcel wa vy cv vx cv wcel vy cv cA wcel vz cv vy cv wcel cA word vx cv
      cA wcel vy cv vx cv wcel vy cv cA wcel cA word vy cv vx cv wcel vx cv cA
      wcel vy cv cA wcel cA word vy cv vx cv wcel vx cv cA wcel vy cv cA wcel
      cA word cA wtr vy cv vx cv wcel vx cv cA wcel wa vy cv cA wcel wi cA
      ordtr cA vy cv vx cv trel syl exp3a com23 imp31 adantrl cA word vx cv cA
      wcel vz cv vy cv wcel vy cv vx cv wcel wa simplr 3jca sylanc ex pm2.43d
      19.21aivv vz vy vx cv dftr2 sylibr cA word vx cv cA wcel vx cv cep wwe cA
      word vx cv cA wcel vx cv cA wss vx cv cep wwe cA word cA wtr vx cv cA
      wcel vx cv cA wss wi cA ordtr cA vx cv trss syl vx cv cA wss cA cep wwe
      vx cv cep wwe cA word vx cv cA cep wess cA ordwe syl5com syld imp
      sylanbrc vtoclg anabsi7 $.
      $( [23-Apr-1994] $)
  $}

  ${
    $d x y $.
    $( The class of all ordinal numbers is transitive. $)
    tron $p |- Tr On $=
      con0 wtr vx cv con0 wss vx con0 vx con0 dftr3 vx cv con0 wcel vy vx cv
      con0 vx cv con0 wcel vy cv vx cv wcel vy cv word vy cv con0 wcel vx cv
      con0 wcel vy cv vx cv wcel vy cv word vx cv word vy cv vx cv wcel vy cv
      word vx cv con0 wcel vx cv vy cv ordelord vx cv vx visset elon sylanb ex
      vy cv vy visset elon syl6ibr ssrdv mprgbir $.
      $( [9-May-2009] $) $( [4-May-2009] $)
  $}

  $( An element of an ordinal class is an ordinal number. $)
  ordelon $p |- ( ( Ord A /\ B e. A ) -> B e. On ) $=
    cA word cB cA wcel wa cB con0 wcel cB word cA cB ordelord cB cA wcel cB
    con0 wcel cB word wb cA word cB cA elong adantl mpbird $.
    $( [30-Oct-2003] $) $( [26-Oct-2003] $)

  $( An element of an ordinal number is an ordinal number.  Theorem 2.2(iii) of
     [BellMachover] p. 469. $)
  onelon $p |- ( ( A e. On /\ B e. A ) -> B e. On ) $=
    cA word cB cA wcel cB con0 wcel cA con0 wcel cA cB ordelon cA eloni sylan
    $.
    $( [4-Nov-2003] $) $( [26-Oct-2003] $)

  ${
    $d x y A $.  $d x y B $.
    $( Proposition 7.7 of [TakeutiZaring] p. 37. $)
    tz7.7 $p |- ( ( Ord A /\ Tr B ) ->
                ( B e. A <-> ( B C_ A /\ B =/= A ) ) ) $=
      cA word cB wtr wa cB cA wcel cB cA wss cB cA wne wa cA word cB cA wcel cB
      cA wss cB cA wne wa wi cB wtr cA wtr cA cep wfr cB cA wcel cB cA wss cB
      cA wne wa wi cA word cA wtr cA cep wfr cB cA wcel cB cA wss cB cA wne wa
      cA cB tz7.2 3exp cA ordtr cA ordfr sylc adantr cA word cB wtr wa cB cA
      wss cB cA wne cB cA wcel cA word cB wtr wa cB cA wss cB cA wne cB cA wcel
      wi cA word cB wtr wa cB cA wss cB cA wss cB cA wne cB cA wcel cA word cB
      wtr wa cB cA wss cA cB cdif c0 wne cB cA wcel cB cA wss cB cA wne wa cA
      word cB wtr wa cB cA wss cA cB cdif c0 wne cB cA wcel wi wi cA word cB
      wtr wa cA word cB cA wss cA cB cdif c0 wne cB cA wcel wi wi cB wtr cA
      word cB wtr wa cB cA wss cA word cA cB cdif c0 wne cB cA wcel wi cA word
      cB wtr wa cB cA wss cA word cA cB cdif c0 wne cB cA wcel cA word cB wtr
      wa cB cA wss wa cA cB cdif vx cv cin c0 wceq vx cA cB cdif wrex cB cA
      wcel cA word cA cB cdif c0 wne wa cA word cB wtr wa cB cA wss wa cA cB
      cdif vx cv cin c0 wceq cB cA wcel vx cA cB cdif cA word cB wtr wa cB cA
      wss wa vx cv cA cB cdif wcel cA cB cdif vx cv cin c0 wceq cB cA wcel cA
      word cB wtr wa cB cA wss wa vx cv cA cB cdif wcel cA cB cdif vx cv cin c0
      wceq wa wa vx cv cB cA cA word cB wtr wa cB cA wss wa vx cv cA cB cdif
      wcel cA cB cdif vx cv cin c0 wceq wa wa vx cv cB cA word cB wtr wa cB cA
      wss wa vx cv cA cB cdif wcel cA cB cdif vx cv cin c0 wceq vx cv cB wss cA
      word vx cv cA cB cdif wcel cA cB cdif vx cv cin c0 wceq vx cv cB wss wi
      wi cB wtr cB cA wss cA word cA wtr vx cv cA cB cdif wcel cA cB cdif vx cv
      cin c0 wceq vx cv cB wss wi wi cA ordtr cA wtr vx cv cA cB cdif wcel vx
      cv cA wss cA cB cdif vx cv cin c0 wceq vx cv cB wss wi cA wtr vx cv cA
      wcel vx cv cA wss vx cv cA cB cdif wcel cA vx cv trss vx cv cA cB eldifi
      syl5 cA cB cdif vx cv cin c0 wceq vx cv cA wss vx cv cB wss cA cB vx cv
      difin0ss com12 syl6 syl ad2antrr imp32 cA word cB wtr wa cB cA wss wa vx
      cv cA cB cdif wcel cB vx cv wss cA cB cdif vx cv cin c0 wceq cA word cB
      wtr wa cB cA wss wa vx cv cA cB cdif wcel wa vy cB vx cv cA word cB wtr
      wa cB cA wss vx cv cA cB cdif wcel vy cv cB wcel vy cv vx cv wcel wi cA
      word cB wtr wa cB cA wss vy cv cB wcel vx cv cA cB cdif wcel vy cv vx cv
      wcel cA word cB wtr wa cB cA wss vy cv cB wcel vx cv cA cB cdif wcel vy
      cv vx cv wcel cA word cB wtr wa cB cA wss vy cv cB wcel wa vx cv cA cB
      cdif wcel wa wa vy cv vx cv wcel vy cv vx cv wceq vx cv vy cv wcel cB cA
      wss vy cv cB wcel wa vx cv cA cB cdif wcel wa vy cv vx cv wceq wn cA word
      cB wtr wa vy cv cB wcel vx cv cA cB cdif wcel vy cv vx cv wceq wn cB cA
      wss vy cv cB wcel vx cv cA cB cdif wcel vy cv vx cv wceq wn vy cv cB wcel
      vy cv vx cv wceq vx cv cB wcel vx cv cA cB cdif wcel vy cv vx cv wceq vy
      cv cB wcel vx cv cB wcel vy cv vx cv cB eleq1 biimpcd vx cv cA cB eldifn
      nsyli imp adantll adantl cB wtr cB cA wss vy cv cB wcel wa vx cv cA cB
      cdif wcel wa vx cv vy cv wcel wn cA word cB wtr cB cA wss vy cv cB wcel
      wa vx cv cA cB cdif wcel vx cv vy cv wcel wn cB wtr vy cv cB wcel vx cv
      cA cB cdif wcel vx cv vy cv wcel wn wi cB cA wss cB wtr vy cv cB wcel vx
      cv cA cB cdif wcel vx cv vy cv wcel wn wi cB wtr vy cv cB wcel wa vx cv
      vy cv wcel vx cv cB wcel vx cv cA cB cdif wcel cB wtr vy cv cB wcel vx cv
      vy cv wcel vx cv cB wcel wi cB wtr vx cv vy cv wcel vy cv cB wcel vx cv
      cB wcel cB wtr vx cv vy cv wcel vy cv cB wcel vx cv cB wcel cB vx cv vy
      cv trel exp3a com23 imp vx cv cA cB eldifn nsyli ex adantld imp32 adantll
      cA word cB cA wss vy cv cB wcel wa vx cv cA cB cdif wcel wa vy cv vx cv
      wcel vy cv vx cv wceq vx cv vy cv wcel w3o cB wtr cA cep wwe vy cv cA
      wcel vx cv cA wcel wa vy cv vx cv wcel vy cv vx cv wceq vx cv vy cv wcel
      w3o cA word cB cA wss vy cv cB wcel wa vx cv cA cB cdif wcel wa vy vx cA
      wecmpep cA ordwe cB cA wss vy cv cB wcel wa vy cv cA wcel vx cv cA cB
      cdif wcel vx cv cA wcel cB cA vy cv ssel2 vx cv cA cB eldifi anim12i
      syl2an adantlr ecase23d exp44 com34 imp31 ssrdv adantrr eqssd vx cv cA cB
      cdif wcel vx cv cA wcel cA word cB wtr wa cB cA wss wa cA cB cdif vx cv
      cin c0 wceq vx cv cA cB eldifi ad2antrl eqeltrrd exp32 r19.23adv cA word
      cA cB cdif cA wss cA cB cdif c0 wne cA cB cdif vx cv cin c0 wceq vx cA cB
      cdif wrex cA cB difss vx cA cA cB cdif tz7.5 mp3an2 syl5 exp4b com23
      adantrd pm2.43i cB cA pssdifn0 syl7 exp4a pm2.43d imp3a impbid $.
      $( [28-May-2007] $) $( [5-May-1994] $)
  $}

  $( Corollary 7.8 of [TakeutiZaring] p. 37. $)
  ordelssne $p |- ( ( Ord A /\ Ord B ) ->
              ( A e. B <-> ( A C_ B /\ A =/= B ) ) ) $=
    cB word cA word cA cB wcel cA cB wss cA cB wne wa wb cB word cA wtr cA cB
    wcel cA cB wss cA cB wne wa wb cA word cB cA tz7.7 cA ordtr sylan2 ancoms
    $.
    $( [1-Jun-2007] $) $( [25-Nov-1995] $)

  $( Corollary 7.8 of [TakeutiZaring] p. 37. $)
  ordelpss $p |- ( ( Ord A /\ Ord B ) -> ( A e. B <-> A C. B ) ) $=
    cA word cB word wa cA cB wcel cA cB wss cA cB wne wa cA cB wpss cA cB
    ordelssne cA cB df-pss syl6bbr $.
    $( [17-Jun-1998] $)

  $( For ordinal classes, subclass is equivalent to membership or equality. $)
  ordsseleq $p |- ( ( Ord A /\ Ord B ) ->
                  ( A C_ B <-> ( A e. B \/ A = B ) ) ) $=
    cA word cB word wa cA cB wss cA cB wcel cA cB wceq wo cA word cB word wa cA
    cB wss cA cB wcel cA cB wceq wo cA word cB word wa cA cB wss wa cA cB wcel
    cA cB wceq cA word cB word wa cA cB wss wa cA cB wcel cA cB cA word cB word
    wa cA cB wss cA cB wne cA cB wcel cA word cB word wa cA cB wcel cA cB wss
    cA cB wne wa cA cB ordelssne biimprd expdimp necon1bd orrd ex cA word cB
    word wa cA cB wcel cA cB wss wi cA cB wceq cA cB wss wi wa cA cB wcel cA cB
    wceq wo cA cB wss wi cA word cB word wa cA cB wcel cA cB wss wi cA cB wceq
    cA cB wss wi cA word cB word wa cA cB wcel cA cB wss cA cB wne wa cA cB wss
    cA cB ordelssne cA cB wss cA cB wne pm3.26 syl6bi cA cB eqimss jctir cA cB
    wcel cA cB wss cA cB wceq jaob sylibr impbid $.
    $( [25-Nov-1995] $)

  $( The intersection of two ordinal classes is ordinal.  Proposition 7.9 of
     [TakeutiZaring] p. 37. $)
  ordin $p |- ( ( Ord A /\ Ord B ) -> Ord ( A i^i B ) ) $=
    cA word cB word cA cB cin wtr cA cB cin word cA wtr cB wtr cA cB cin wtr cA
    word cB word cA cB trin cA ordtr cB ordtr syl2an cA cB cin wtr cA cB cin cB
    wss cB word cA cB cin word cA cB inss2 cA cB cin cB trssord mp3an2 sylancom
    $.
    $( [9-May-1994] $)

  ${
    $d x y A $.  $d x y B $.
    $( The intersection of two ordinal numbers is an ordinal number. $)
    onin $p |- ( ( A e. On /\ B e. On ) -> ( A i^i B ) e. On ) $=
      cA con0 wcel cB con0 wcel wa cA cB cin con0 wcel cA cB cin word cA word
      cB word cA cB cin word cA con0 wcel cB con0 wcel cA cB ordin cA eloni cB
      eloni syl2an cA con0 wcel cB con0 wcel wa cA con0 wcel cA cB cin cvv wcel
      cA cB cin con0 wcel cA cB cin word wb cA con0 wcel cB con0 wcel pm3.26 cA
      cB con0 inex1g cA cB cin cvv elong 3syl mpbird $.
      $( [7-Apr-1995] $)
  $}

  $( A trichotomy law for ordinals.  Proposition 7.10 of [TakeutiZaring]
     p. 38. $)
  ordtri3or $p |- ( ( Ord A /\ Ord B ) -> ( A e. B \/ A = B \/ B e. A ) ) $=
    cA word cB word wa cA cB wcel cA cB wceq wo cB cA wcel cB cA wceq wo wo cA
    cB wcel cA cB wceq cB cA wcel w3o cA word cB word wa cA cB wss cB cA wss wo
    cA cB wcel cA cB wceq wo cB cA wcel cB cA wceq wo wo cA word cB word wa cA
    cB cin cA wcel wn cB cA cin cB wcel wn wo cA cB wss cB cA wss wo cA word cB
    word wa cA cB cin cA cB cin wcel wn cA cB cin cA wcel wn cB cA cin cB wcel
    wn wo cA word cB word wa cA cB cin word cA cB cin cA cB cin wcel wn cA cB
    ordin cA cB cin ordirr syl cA cB cin cA cB cin wcel wn cA cB cin cA wcel cB
    cA cin cB wcel wa wn cA cB cin cA wcel wn cB cA cin cB wcel wn wo cA cB cin
    cA cB cin wcel cA cB cin cA wcel cB cA cin cB wcel wa cA cB cin cA cB cin
    wcel cA cB cin cA wcel cA cB cin cB wcel wa cA cB cin cA wcel cB cA cin cB
    wcel wa cA cB cin cA cB elin cA cB cin cB wcel cB cA cin cB wcel cA cB cin
    cA wcel cA cB cin cB cA cin cB cA cB incom eleq1i anbi2i bitri notbii cA cB
    cin cA wcel cB cA cin cB wcel ianor bitri sylib cA word cB word wa cA cB
    cin cA wcel wn cA cB wss cB cA cin cB wcel wn cB cA wss cA word cB word wa
    cA cB cin cA wcel wn cA cB cin cA wceq cA cB wss cA word cB word wa cA cB
    cin cA wcel cA cB cin cA wceq cA word cB word cA cB cin cA wcel cA cB cin
    cA wceq wo cA cB cin word cA word cA cB cin cA wcel cA cB cin cA wceq wo cA
    word cB word wa cA cB cin word cA word wa cA cB cin cA wss cA cB cin cA
    wcel cA cB cin cA wceq wo cA cB inss1 cA cB cin cA ordsseleq mpbii cA cB
    ordin sylan anabss1 ord cA cB df-ss syl6ibr cA word cB word wa cB cA cin cB
    wcel wn cB cA cin cB wceq cB cA wss cA word cB word wa cB cA cin cB wcel cB
    cA cin cB wceq cA word cB word cB cA cin cB wcel cB cA cin cB wceq wo cB cA
    cin word cB word cB cA cin cB wcel cB cA cin cB wceq wo cB word cA word wa
    cB cA cin word cB word wa cB cA cin cB wss cB cA cin cB wcel cB cA cin cB
    wceq wo cB cA inss1 cB cA cin cB ordsseleq mpbii cB cA ordin sylan anabss4
    ord cB cA df-ss syl6ibr orim12d mpd cA word cB word wa cA cB wss cA cB wcel
    cA cB wceq wo cB cA wss cB cA wcel cB cA wceq wo cA cB ordsseleq cB word cA
    word cB cA wss cB cA wcel cB cA wceq wo wb cB cA ordsseleq ancoms orbi12d
    mpbid cA cB wcel cA cB wceq cB cA wcel w3o cA cB wcel cB cA wcel wo cA cB
    wceq wo cA cB wcel cA cB wceq wo cB cA wcel cA cB wceq wo wo cA cB wcel cA
    cB wceq wo cB cA wcel cB cA wceq wo wo cA cB wcel cA cB wceq cB cA wcel w3o
    cA cB wcel cA cB wceq wo cB cA wcel wo cA cB wcel cB cA wcel wo cA cB wceq
    wo cA cB wcel cA cB wceq cB cA wcel df-3or cA cB wcel cA cB wceq cB cA wcel
    or23 bitri cA cB wcel cB cA wcel cA cB wceq orordir cB cA wcel cA cB wceq
    wo cB cA wcel cB cA wceq wo cA cB wcel cA cB wceq wo cA cB wceq cB cA wceq
    cB cA wcel cA cB eqcom orbi2i orbi2i 3bitri sylibr $.
    $( [29-Jun-2008] $) $( [10-May-1994] $)

  $( A trichotomy law for ordinals. $)
  ordtri1 $p |- ( ( Ord A /\ Ord B ) -> ( A C_ B <-> -. B e. A ) ) $=
    cA word cB word wa cA cB wss cA cB wcel cA cB wceq wo cB cA wcel wn cA cB
    ordsseleq cA word cB word wa cA cB wcel cA cB wceq wo cB cA wcel wn cA word
    cA cB wcel cB cA wcel wn cB word cA cB wceq cA word cA cB wcel cB cA wcel
    wa wn cA cB wcel cB cA wcel wn wi cA cB ordn2lp cA cB wcel cB cA wcel imnan
    sylibr cA cB wceq cB cA wcel wn cB cB wcel wn cB word cA cB wceq cB cA wcel
    cB cB wcel cA cB cB eleq2 notbid cB ordirr syl5cbir jaao cA word cB word wa
    cA cB wcel cA cB wceq cB cA wcel w3o cB cA wcel wn cA cB wcel cA cB wceq wo
    wi cA cB ordtri3or cA cB wcel cA cB wceq cB cA wcel w3o cA cB wcel cA cB
    wceq wo cB cA wcel wo cB cA wcel cA cB wcel cA cB wceq wo wo cB cA wcel wn
    cA cB wcel cA cB wceq wo wi cA cB wcel cA cB wceq cB cA wcel df-3or cA cB
    wcel cA cB wceq wo cB cA wcel orcom cB cA wcel cA cB wcel cA cB wceq wo
    df-or 3bitri sylib impbid bitrd $.
    $( [25-Mar-1995] $)

  $( A trichotomy law for ordinal numbers. $)
  ontri1 $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B <-> -. B e. A ) ) $=
    cA word cB word cA cB wss cB cA wcel wn wb cA con0 wcel cB con0 wcel cA cB
    ordtri1 cA eloni cB eloni syl2an $.
    $( [14-Nov-2003] $) $( [6-Nov-2003] $)

  $( A trichotomy law for ordinals. $)
  ordtri2 $p |- ( ( Ord A /\ Ord B ) ->
               ( A e. B <-> -. ( A = B \/ B e. A ) ) ) $=
    cA word cB word wa cA cB wceq cB cA wcel wo cA cB wcel cB word cA word cA
    cB wceq cB cA wcel wo cA cB wcel wn wb cB word cA word wa cB cA wss cA cB
    wceq cB cA wcel wo cA cB wcel wn cB word cA word wa cB cA wss cB cA wcel cB
    cA wceq wo cA cB wceq cB cA wcel wo cB cA ordsseleq cB cA wcel cB cA wceq
    wo cB cA wcel cA cB wceq wo cA cB wceq cB cA wcel wo cB cA wceq cA cB wceq
    cB cA wcel cB cA eqcom orbi2i cB cA wcel cA cB wceq orcom bitri syl6bb cB
    cA ordtri1 bitr3d ancoms con2bid $.
    $( [25-Nov-1995] $)

  $( A trichotomy law for ordinals. $)
  ordtri3 $p |- ( ( Ord A /\ Ord B ) ->
               ( A = B <-> -. ( A e. B \/ B e. A ) ) ) $=
    cA word cB word wa cA cB wceq cA cB wcel cB cA wcel wo wn cA cB wceq cA
    word cB word wa cA cB wcel cB cA wcel wo wn cA cB wceq cA word cB word wa
    cA cB wcel wn cB cA wcel wn wa cA cB wcel cB cA wcel wo wn cA cB wceq cA
    word cA cB wcel wn cB word cB cA wcel wn cA cB wceq cA cA wcel wn cA cB
    wcel wn cA word cA cB wceq cA cA wcel cA cB wcel cA cB cA eleq2 notbid cA
    ordirr syl5bi cA cB wceq cB cA wcel wn cB cB wcel wn cB word cA cB wceq cB
    cA wcel cB cB wcel cA cB cB eleq2 notbid cB ordirr syl5bir anim12d cA cB
    wcel cB cA wcel ioran syl6ibr com12 cA word cB word wa cA cB wcel cA cB
    wceq cB cA wcel w3o cA cB wcel cB cA wcel wo wn cA cB wceq wi cA cB
    ordtri3or cA cB wcel cA cB wceq cB cA wcel w3o cA cB wcel cA cB wceq wo cB
    cA wcel wo cA cB wcel cB cA wcel wo cA cB wceq wo cA cB wcel cB cA wcel wo
    wn cA cB wceq wi cA cB wcel cA cB wceq cB cA wcel df-3or cA cB wcel cA cB
    wceq cB cA wcel or23 cA cB wcel cB cA wcel wo cA cB wceq df-or 3bitri sylib
    impbid $.
    $( [18-Oct-1995] $)

  $( A trichotomy law for ordinals. $)
  ordtri4 $p |- ( ( Ord A /\ Ord B ) ->
               ( A = B <-> ( A C_ B /\ -. A e. B ) ) ) $=
    cA word cB word wa cA cB wceq cA cB wcel cB cA wcel wo wn cA cB wss cA cB
    wcel wn wa cA cB ordtri3 cA word cB word wa cA cB wss cA cB wcel wn wa cB
    cA wcel wn cA cB wcel wn wa cA cB wcel cB cA wcel wo wn cA word cB word wa
    cA cB wss cB cA wcel wn cA cB wcel wn cA cB ordtri1 anbi1d cB cA wcel wn cA
    cB wcel wn wa cA cB wcel wn cB cA wcel wn wa cA cB wcel cB cA wcel wo wn cB
    cA wcel wn cA cB wcel wn ancom cA cB wcel cB cA wcel ioran bitr4i syl6bb
    bitr4d $.
    $( [5-Nov-2003] $) $( [1-Nov-2003] $)

  $( An ordinal class and its singleton are disjoint. $)
  orddisj $p |- ( Ord A -> ( A i^i { A } ) = (/) ) $=
    cA word cA cA wcel wn cA cA csn cin c0 wceq cA ordirr cA cA disjsn sylibr
    $.
    $( [19-May-1998] $)

  ${
    $d x y z $.
    $( The ordinal class is founded.  This lemma is needed for ~ ordon in order
       to eliminate the need for the Axiom of Regularity. $)
    onfr $p |- _E Fr On $=
      con0 cep wfr vx cv con0 wss vx cv c0 wne wa vx cv vz cv cin c0 wceq vz vx
      cv wrex wi vx vx vz con0 dfepfr vx cv con0 wss vx cv c0 wne vx cv vz cv
      cin c0 wceq vz vx cv wrex vx cv con0 wss vy cv vx cv wcel vy wex vx cv vz
      cv cin c0 wceq vz vx cv wrex vx cv c0 wne vx cv con0 wss vy cv vx cv wcel
      vx cv vz cv cin c0 wceq vz vx cv wrex vy vx cv con0 wss vy cv vx cv wcel
      vx cv vz cv cin c0 wceq vz vx cv wrex wi wi vx cv vy cv cin c0 vx cv vy
      cv cin c0 wceq vy cv vx cv wcel vx cv vz cv cin c0 wceq vz vx cv wrex wi
      vx cv con0 wss vy cv vx cv wcel vx cv vy cv cin c0 wceq vx cv vz cv cin
      c0 wceq vz vx cv wrex vx cv vz cv cin c0 wceq vx cv vy cv cin c0 wceq vz
      vy cv vx cv vz cv vy cv wceq vx cv vz cv cin vx cv vy cv cin c0 vz cv vy
      cv vx cv ineq2 eqeq1d rcla4ev expcom a1d vx cv con0 wss vy cv vx cv wcel
      vx cv vy cv cin c0 wne vx cv vz cv cin c0 wceq vz vx cv wrex vx cv con0
      wss vy cv vx cv wcel vy cv word vx cv vy cv cin c0 wne vx cv vz cv cin c0
      wceq vz vx cv wrex wi vx cv con0 wss vy cv vx cv wcel vy cv con0 wcel vy
      cv word vx cv con0 vy cv ssel vy cv vy visset elon syl6ib vy cv cep wfr
      vy cv wtr vx cv vy cv cin c0 wne vx cv vz cv cin c0 wceq vz vx cv wrex wi
      vy cv word vy cv cep wfr vx cv vy cv cin c0 wne vx cv vy cv cin vz cv cin
      c0 wceq vz vx cv vy cv cin wrex vy cv wtr vx cv vz cv cin c0 wceq vz vx
      cv wrex vy cv cep wfr vx cv vy cv cin c0 wne vx cv vy cv cin vz cv cin c0
      wceq vz vx cv vy cv cin wrex vy cv cep wfr vx cv vy cv cin vy cv wss vx
      cv vy cv cin c0 wne vx cv vy cv cin vz cv cin c0 wceq vz vx cv vy cv cin
      wrex vx cv vy cv inss2 vz vy cv vx cv vy cv cin vx cv vy cv vx visset
      inex1 epfrc mp3an2 ex vy cv wtr vx cv vy cv cin vz cv cin c0 wceq vx cv
      vz cv cin c0 wceq vz vx cv wrex vz vx cv vy cv cin vy cv wtr vz ax-17 vx
      cv vz cv cin c0 wceq vz vx cv hbre1 vy cv wtr vz cv vx cv vy cv cin wcel
      vx cv vy cv cin vz cv cin c0 wceq vz cv vx cv wcel vx cv vz cv cin c0
      wceq wa vx cv vz cv cin c0 wceq vz vx cv wrex vy cv wtr vx cv vy cv cin
      vz cv cin c0 wceq vz cv vx cv vy cv cin wcel vz cv vx cv wcel vx cv vz cv
      cin c0 wceq wa vy cv wtr vx cv vy cv cin vz cv cin c0 wceq vz cv vx cv vy
      cv cin wcel vz cv vx cv wcel vx cv vz cv cin c0 wceq wa wi vy cv wtr vx
      cv vy cv cin vz cv cin c0 wceq wa vz cv vx cv vy cv cin wcel vz cv vx cv
      wcel vx cv vz cv cin c0 wceq wa vz cv vx cv vy cv cin wcel vy cv wtr vx
      cv vy cv cin vz cv cin c0 wceq wa vz cv vx cv vy cv cin wcel vz cv vx cv
      wcel vx cv vz cv cin c0 wceq wa vz cv vx cv vy cv cin wcel vz cv vx cv
      wcel vy cv wtr vx cv vy cv cin vz cv cin c0 wceq wa vz cv vx cv vy cv cin
      wcel wa vx cv vz cv cin c0 wceq vx cv vy cv cin vx cv vz cv vx cv vy cv
      inss1 sseli vy cv wtr vx cv vy cv cin vz cv cin c0 wceq wa vz cv vx cv vy
      cv cin wcel vx cv vz cv cin c0 wceq vy cv wtr vz cv vx cv vy cv cin wcel
      vz cv vy cv wss vx cv vy cv cin vz cv cin c0 wceq vx cv vz cv cin c0 wceq
      vy cv wtr vz cv vy cv wcel vz cv vy cv wss vz cv vx cv vy cv cin wcel vy
      cv vz cv trss vx cv vy cv cin vy cv vz cv vx cv vy cv inss2 sseli syl5 vz
      cv vy cv wss vx cv vz cv cin c0 wceq vx cv vy cv cin vz cv cin c0 wceq vz
      cv vy cv wss vx cv vz cv cin vx cv vy cv cin vz cv cin c0 vz cv vy cv wss
      vy cv vz cv cin vz cv wceq vx cv vz cv cin vx cv vy cv cin vz cv cin wceq
      vz cv vy cv sseqin2 vy cv vz cv cin vz cv wceq vx cv vy cv vz cv cin cin
      vx cv vz cv cin vx cv vy cv cin vz cv cin vy cv vz cv cin vz cv vx cv
      ineq2 vx cv vy cv vz cv inass syl5req sylbi eqeq1d biimprcd sylan9 imp
      anim12i exp32 pm2.43b ex com23 vx cv vz cv cin c0 wceq vz vx cv ra4e syl8
      r19.23ad sylan9 vy cv ordfr vy cv ordtr sylanc syl6 com3r pm2.61ine
      19.23adv vy vx cv n0 syl5ib imp mpgbir $.
      $( [17-May-1994] $)
  $}

  $( Relationship between membership and proper subset of an ordinal number. $)
  onelpss $p |- ( ( A e. On /\ B e. On ) ->
               ( A e. B <-> ( A C_ B /\ A =/= B ) ) ) $=
    cA word cB word cA cB wcel cA cB wss cA cB wne wa wb cA con0 wcel cB con0
    wcel cA cB ordelssne cA eloni cB eloni syl2an $.
    $( [2-Jun-2007] $) $( [15-Sep-1995] $)

  $( Relationship between subset and membership of an ordinal number. $)
  onsseleq $p |- ( ( A e. On /\ B e. On ) ->
                 ( A C_ B <-> ( A e. B \/ A = B ) ) ) $=
    cA word cB word cA cB wss cA cB wcel cA cB wceq wo wb cA con0 wcel cB con0
    wcel cA cB ordsseleq cA eloni cB eloni syl2an $.
    $( [15-Sep-1995] $)

  $( An element of an ordinal number is a subset of the number. $)
  onelss $p |- ( A e. On -> ( B e. A -> B C_ A ) ) $=
    cA con0 wcel cA word cA wtr cB cA wcel cB cA wss wi cA eloni cA ordtr cA cB
    trss 3syl $.
    $( [5-Jun-1994] $)

  $( Transitive law for ordinal classes. $)
  ordtr1 $p |- ( Ord C -> ( ( A e. B /\ B e. C ) -> A e. C ) ) $=
    cC word cC wtr cA cB wcel cB cC wcel wa cA cC wcel wi cC ordtr cC cA cB
    trel syl $.
    $( [13-Dec-2004] $) $( [12-Dec-2004] $)

  $( Transitive law for ordinal classes. $)
  ordtr2 $p |- ( ( Ord A /\ Ord C ) -> ( ( A C_ B /\ B e. C ) -> A e. C ) ) $=
    cA word cC word wa cA cB wss cB cC wcel cA cC wcel cA word cC word wa cB cC
    wcel cA cB wss cA cC wcel cA word cC word cB cC wcel cA cB wss cA cC wcel
    wi cA word cC word cB cC wcel wa cA cB wss cA cC wcel wi cA word cB word cC
    word cB cC wcel wa cA cB wss cA cC wcel wi wi cC word cB cC wcel wa cA word
    cB word cC word cB cC wcel wa cA cB wss cA cC wcel wi wi cA word cB word wa
    cA cB wss cA cB wcel cA cB wceq wo cC word cB cC wcel wa cA cC wcel cA word
    cB word wa cA cB wss cA cB wcel cA cB wceq wo cA cB ordsseleq biimpd cC
    word cB cC wcel cA cB wcel cA cB wceq wo cA cC wcel wi cC word cA cB wcel
    cA cB wceq wo cB cC wcel cA cC wcel cC word cA cB wcel cB cC wcel cA cC
    wcel wi cA cB wceq cC word cA cB wcel cB cC wcel cA cC wcel cA cB cC ordtr1
    exp3a cA cB wceq cB cC wcel cA cC wcel wi wi cC word cB cC wcel cA cB wceq
    cA cC wcel cB cC cA eleq1a com12 a1i jaod com23 imp syl9 ex cC cB ordelord
    syl5 pm2.43d expdimp com23 imp3a $.
    $( [13-Dec-2004] $) $( [12-Dec-2004] $)

  $( Transitive law for ordinal numbers.  Theorem 7M(b) of [Enderton]
     p. 192. $)
  ontr1 $p |- ( C e. On -> ( ( A e. B /\ B e. C ) -> A e. C ) ) $=
    cC con0 wcel cC word cA cB wcel cB cC wcel wa cA cC wcel wi cC eloni cA cB
    cC ordtr1 syl $.
    $( [11-Aug-1994] $)

  $( Transitive law for ordinal numbers.  Exercise 3 of [TakeutiZaring]
     p. 40. $)
  ontr2 $p |- ( ( A e. On /\ C e. On ) ->
              ( ( A C_ B /\ B e. C ) -> A e. C ) ) $=
    cA word cC word cA cB wss cB cC wcel wa cA cC wcel wi cA con0 wcel cC con0
    wcel cA cB cC ordtr2 cA eloni cC eloni syl2an $.
    $( [6-Nov-2003] $) $( [6-Nov-2003] $)

  ${
    $d x y A $.  $d x y B $.
    $( The union of an ordinal stays the same if a subset equal to one of its
       elements is removed. $)
    ordunidif $p |- ( ( Ord A /\ B e. A ) -> U. ( A \ B ) = U. A ) $=
      cA word cB cA wcel wa vx cv vy cv wss vy cA cB cdif wrex vx cA wral cA cB
      cdif cuni cA cuni wceq cA word cB cA wcel wa vx cv vy cv wss vy cA cB
      cdif wrex vx cA cA word cB cA wcel wa vx cv cA wcel wa vx cv cB wcel vx
      cv vy cv wss vy cA cB cdif wrex cA word cB cA wcel wa vx cv cA wcel wa vx
      cv cB wcel cB cA cB cdif wcel vx cv cB wss wa vx cv vy cv wss vy cA cB
      cdif wrex cA word cB cA wcel wa vx cv cB wcel cB cA cB cdif wcel vx cv cB
      wss wa wi vx cv cA wcel cA word cB cA wcel wa vx cv cB wcel vx cv cB wss
      cB cA cB cdif wcel cA word cB cA wcel wa cB con0 wcel vx cv cB wcel vx cv
      cB wss wi cA cB ordelon cB vx cv onelss syl cA word cB cA wcel wa cB con0
      wcel cB cA cB cdif wcel cA cB ordelon cB cA wcel cB con0 wcel cB cA cB
      cdif wcel wi cA word cB cA wcel cB cB wcel wn cB cA cB cdif wcel cB con0
      wcel cB cA wcel cB cB wcel wn cB cA cB cdif wcel cB cA cB cdif wcel cB cA
      wcel cB cB wcel wn wa cB cA cB eldif biimpri ex cB con0 wcel cB word cB
      cB wcel wn cB eloni cB ordirr syl syl5 adantl mpd jctild adantr vx cv vy
      cv wss vx cv cB wss vy cB cA cB cdif vy cv cB vx cv sseq2 rcla4ev syl6 vx
      cv cA wcel vx cv cB wcel wn vx cv vy cv wss vy cA cB cdif wrex wi cA word
      cB cA wcel wa vx cv cA wcel vx cv cB wcel wn vx cv cA cB cdif wcel vx cv
      vx cv wss wa vx cv vy cv wss vy cA cB cdif wrex vx cv cA wcel vx cv cB
      wcel wn vx cv cA cB cdif wcel vx cv vx cv wss wa vx cv cA wcel vx cv cB
      wcel wn wa vx cv cA cB cdif wcel vx cv vx cv wss vx cv cA cB cdif wcel vx
      cv cA wcel vx cv cB wcel wn wa vx cv cA cB eldif biimpri vx cv ssid jctir
      ex vx cv vy cv wss vx cv vx cv wss vy vx cv cA cB cdif vy cv vx cv vx cv
      sseq2 rcla4ev syl6 adantl pm2.61d r19.21aiva vx vy cA cB unidif syl $.
      $( [11-Dec-2004] $) $( [10-Dec-2004] $)
  $}

  ${
    $d x ps $.  $d x A $.
    onintss.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( If a property is true for an ordinal number, then the minimum ordinal
       number for which it is true is smaller or equal.  Theorem Schema 61 of
       [Suppes] p. 228. $)
    onintss $p |- ( A e. On -> ( ps -> |^| { x e. On | ph } C_ A ) ) $=
      cA con0 wcel wps wph vx con0 crab cint cA wss cA con0 wcel wps wa cA wph
      vx con0 crab wcel wph vx con0 crab cint cA wss wph wps vx cA con0
      onintss.1 elrab cA wph vx con0 crab intss1 sylbir ex $.
      $( [3-Oct-2003] $) $( [3-Oct-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( A way to show that an ordinal number equals the minimum of a collection
       of ordinal numbers: it must be in the collection, and it must not be
       larger than any member of the collection. $)
    oneqmini $p |- ( B C_ On -> ( ( A e. B /\ A. x e. A -. x e. B )
                    -> A = |^| B ) ) $=
      cB con0 wss cA cB wcel vx cv cB wcel wn vx cA wral wa cA cB cint wss cB
      cint cA wss wa cA cB cint wceq cB con0 wss cA cB wcel vx cv cB wcel wn vx
      cA wral wa cA cB cint wss cB cint cA wss cB con0 wss cA cB wcel vx cv cB
      wcel wn vx cA wral cA cB cint wss cB con0 wss cA cB wcel wa cA cB cint
      wss vx cv cB wcel wn vx cA wral cB con0 wss cA cB wcel wa cA vx cv wss vx
      cB wral vx cv cB wcel wn vx cA wral cA cB cint wss cB con0 wss cA cB wcel
      wa cA vx cv wss vx cv cB wcel wn vx cB cA cB con0 wss cA cB wcel wa vx cv
      cB wcel cA vx cv wss wi vx cv cB wcel vx cv cA wcel wn wi vx cv cA wcel
      vx cv cB wcel wn wi cB con0 wss cA cB wcel wa vx cv cB wcel cA vx cv wss
      vx cv cA wcel wn cB con0 wss cA cB wcel vx cv cB wcel cA vx cv wss vx cv
      cA wcel wn wb cB con0 wss cA cB wcel vx cv cB wcel wa cA con0 wcel vx cv
      con0 wcel wa cA vx cv wss vx cv cA wcel wn wb cB con0 wss cA cB wcel cA
      con0 wcel vx cv cB wcel vx cv con0 wcel cB con0 cA ssel cB con0 vx cv
      ssel anim12d cA vx cv ontri1 syl6 expdimp pm5.74d vx cv cB wcel vx cv cA
      wcel con2b syl6bb ralbidv2 vx cA cB ssint syl5bb biimprd expimpd cB con0
      wss cA cB wcel cB cint cA wss vx cv cB wcel wn vx cA wral cA cB wcel cB
      cint cA wss wi cB con0 wss cA cB intss1 a1i adantrd jcad cA cB cint eqss
      syl6ibr $.
      $( [14-Nov-2003] $) $( [14-Nov-2003] $)
  $}

  $( The empty set is an ordinal class. $)
  ord0 $p |- Ord (/) $=
    c0 word c0 wtr c0 cep wwe c0 df-ord tr0 cep we0 mpbir2an $.
    $( [11-May-1994] $)

  $( The empty set is an ordinal number.  Corollary 7N(b) of [Enderton]
     p. 193. $)
  0elon $p |- (/) e. On $=
    c0 con0 wcel c0 word ord0 c0 0ex elon mpbir $.
    $( [17-Sep-1993] $)

  $( A non-empty ordinal contains the empty set. $)
  ord0eln0 $p |- ( Ord A -> ( (/) e. A <-> A =/= (/) ) ) $=
    cA word c0 cA wcel cA c0 wne cA c0 ne0i cA word cA c0 wceq wn c0 cA wcel cA
    c0 wne cA word cA c0 wceq c0 cA wcel cA word c0 word cA c0 wceq c0 cA wcel
    wo ord0 cA word c0 word wa cA c0 wceq c0 cA wcel wo cA c0 wcel wn cA noel
    cA word c0 word wa cA c0 wcel cA c0 wceq c0 cA wcel wo cA c0 ordtri2
    con2bid mpbiri mpan2 ord cA c0 df-ne syl5ib impbid2 $.
    $( [5-Apr-2007] $) $( [25-Nov-1995] $)

  $( An ordinal number  contains zero iff it is nonzero. $)
  on0eln0 $p |- ( A e. On -> ( (/) e. A <-> A =/= (/) ) ) $=
    cA con0 wcel cA word c0 cA wcel cA c0 wne wb cA eloni cA ord0eln0 syl $.
    $( [30-Apr-2007] $) $( [6-Dec-2004] $)

  $( An alternate definition of a limit ordinal. $)
  dflim2 $p |- ( Lim A <-> ( Ord A /\ (/) e. A /\ A = U. A ) ) $=
    cA wlim cA word cA c0 wne cA cA cuni wceq w3a cA word c0 cA wcel cA cA cuni
    wceq w3a cA df-lim cA word c0 cA wcel cA cA cuni wceq wa wa cA word cA c0
    wne cA cA cuni wceq wa wa cA word c0 cA wcel cA cA cuni wceq w3a cA word cA
    c0 wne cA cA cuni wceq w3a cA word c0 cA wcel cA cA cuni wceq wa cA c0 wne
    cA cA cuni wceq wa cA word c0 cA wcel cA c0 wne cA cA cuni wceq cA ord0eln0
    anbi1d pm5.32i cA word c0 cA wcel cA cA cuni wceq 3anass cA word cA c0 wne
    cA cA cuni wceq 3anass 3bitr4i bitr4i $.
    $( [6-Nov-2004] $) $( [4-Nov-2004] $)

  $( The intersection of the class of ordinal numbers is the empty set. $)
  inton $p |- |^| On = (/) $=
    c0 con0 wcel con0 cint c0 wceq 0elon con0 int0el ax-mp $.
    $( [20-Oct-2003] $) $( [20-Oct-2003] $)

  $( The empty set is not a limit ordinal. $)
  nlim0 $p |- -. Lim (/) $=
    c0 c0 wceq c0 wlim wn c0 eqid c0 wlim c0 c0 c0 wlim c0 word c0 c0 wne c0 c0
    cuni wceq w3a c0 c0 wne c0 df-lim c0 word c0 c0 wne c0 c0 cuni wceq 3simp2
    sylbi necon2bi ax-mp $.
    $( [24-Mar-1995] $)

  $( A limit ordinal is ordinal. $)
  limord $p |- ( Lim A -> Ord A ) $=
    cA wlim cA word cA c0 wne cA cA cuni wceq w3a cA word cA df-lim cA word cA
    c0 wne cA cA cuni wceq 3simp1 sylbi $.
    $( [4-May-1995] $)

  $( A limit ordinal is its own supremum (union). $)
  limuni $p |- ( Lim A -> A = U. A ) $=
    cA wlim cA word cA c0 wne cA cA cuni wceq w3a cA cA cuni wceq cA df-lim cA
    word cA c0 wne cA cA cuni wceq 3simp3 sylbi $.
    $( [4-May-1995] $)

  $( The union of a limit ordinal is a limit ordinal. $)
  limuni2 $p |- ( Lim A -> Lim U. A ) $=
    cA wlim cA cuni wlim cA wlim cA cA cuni wceq cA wlim cA cuni wlim wb cA
    limuni cA cA cuni limeq syl ibi $.
    $( [27-Sep-2006] $) $( [19-Sep-2006] $)

  $( A limit ordinal contains the empty set. $)
  0ellim $p |- ( Lim A -> (/) e. A ) $=
    cA wlim c0 cA wcel cA c0 wne cA wlim cA c0 cA c0 wceq cA wlim c0 wlim nlim0
    cA c0 limeq mtbiri necon2ai cA wlim cA word c0 cA wcel cA c0 wne wb cA
    limord cA ord0eln0 syl mpbird $.
    $( [15-May-1994] $)

  $( A limit ordinal class that is also a set is an ordinal number. $)
  limelon $p |- ( ( A e. B /\ Lim A ) -> A e. On ) $=
    cA cB wcel cA wlim cA con0 wcel cA cB wcel cA con0 wcel cA word cA wlim cA
    cB elong cA limord syl5bir imp $.
    $( [27-Apr-2004] $) $( [26-Apr-2004] $)

  $( The class of all ordinal numbers in not empty. $)
  onn0 $p |- On =/= (/) $=
    c0 con0 wcel con0 c0 wne 0elon con0 c0 ne0i ax-mp $.
    $( [5-Apr-2007] $) $( [17-Sep-1995] $)

  $( Equality of successors. $)
  suceq $p |- ( A = B -> suc A = suc B ) $=
    cA cB wceq cA cA csn cun cB cB csn cun cA csuc cB csuc cA cB wceq cA cA csn
    cun cA cB csn cun cB cB csn cun cA cB wceq cA csn cB csn cA cA cB sneq
    uneq2d cA cB cB csn uneq1 eqtrd cA df-suc cB df-suc 3eqtr4g $.
    $( [30-Aug-1993] $)

  $( Membership in a successor.  This one-way implication does not require that
     either ` A ` or ` B ` be sets. $)
  elsuci $p |- ( A e. suc B -> ( A e. B \/ A = B ) ) $=
    cA cB csuc wcel cA cB wcel cA cB csn wcel wo cA cB wcel cA cB wceq wo cA cB
    csuc wcel cA cB cB csn cun wcel cA cB wcel cA cB csn wcel wo cB csuc cB cB
    csn cun cA cB df-suc eleq2i cA cB cB csn elun bitri cA cB csn wcel cA cB
    wceq cA cB wcel cA cB elsni orim2i sylbi $.
    $( [6-Jun-1994] $)

  $( Membership in a successor.  Exercise 5 of [TakeutiZaring] p. 17. $)
  elsucg $p |- ( A e. C -> ( A e. suc B <-> ( A e. B \/ A = B ) ) ) $=
    cA cC wcel cA cB wcel cA cB csn wcel wo cA cB wcel cA cB wceq wo cA cB csuc
    wcel cA cC wcel cA cB csn wcel cA cB wceq cA cB wcel cA cB cC elsncg orbi2d
    cA cB csuc wcel cA cB cB csn cun wcel cA cB wcel cA cB csn wcel wo cB csuc
    cB cB csn cun cA cB df-suc eleq2i cA cB cB csn elun bitri syl5bb $.
    $( [15-Sep-1995] $)

  $( Variant of membership in a successor, requiring that ` B ` rather than
     ` A ` be a set. $)
  elsuc2g $p |- ( B e. C -> ( A e. suc B <-> ( A e. B \/ A = B ) ) ) $=
    cB cC wcel cA cB cB csn cun wcel cA cB wcel cA cB wceq wo cA cB csuc wcel
    cB cC wcel cA cB wcel cA cB csn wcel wo cA cB wcel cA cB wceq wo cA cB cB
    csn cun wcel cB cC wcel cA cB csn wcel cA cB wceq cA cB wcel cA cB cC
    elsnc2g orbi2d cA cB cB csn elun syl5bb cB csuc cB cB csn cun cA cB df-suc
    eleq2i syl5bb $.
    $( [28-Oct-2003] $) $( [28-Oct-2003] $)

  ${
    elsuc.1 $e |- A e. _V $.
    $( Membership in a successor.  Exercise 5 of [TakeutiZaring] p. 17. $)
    elsuc $p |- ( A e. suc B <-> ( A e. B \/ A = B ) ) $=
      cA cvv wcel cA cB csuc wcel cA cB wcel cA cB wceq wo wb elsuc.1 cA cB cvv
      elsucg ax-mp $.
      $( [15-Sep-2003] $) $( [15-Sep-2003] $)

    $( Membership in a successor. $)
    elsuc2 $p |- ( B e. suc A <-> ( B e. A \/ B = A ) ) $=
      cA cvv wcel cB cA csuc wcel cB cA wcel cB cA wceq wo wb elsuc.1 cB cA cvv
      elsuc2g ax-mp $.
      $( [15-Sep-2003] $) $( [15-Sep-2003] $)
  $}

  ${
    $d y A $.  $d x y $.
    hbsuc.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for successor. $)
    hbsuc $p |- ( y e. suc A -> A. x y e. suc A ) $=
      vy cv cA wcel vy cv cA wceq wo vy cv cA wcel vy cv cA wceq wo vx wal vy
      cv cA csuc wcel vy cv cA csuc wcel vx wal vy cv cA wcel vy cv cA wceq vx
      hbsuc.1 vx vy cA hbsuc.1 hbeleq hbor vy cv cA vy visset elsuc vy cv cA
      csuc wcel vy cv cA wcel vy cv cA wceq wo vx vy cv cA vy visset elsuc
      albii 3imtr4i $.
      $( [15-Sep-2003] $) $( [15-Sep-2003] $)
  $}

  $( Membership in a successor. $)
  elelsuc $p |- ( A e. B -> A e. suc B ) $=
    cA cB wcel cA cB csuc wcel cA cB wcel cA cB wceq wo cA cB wcel cA cB wceq
    orc cA cB cB elsucg mpbird $.
    $( [20-Jun-1998] $)

  ${
    $d x y A $.  $d x B $.
    $( Membership of a successor in another class. $)
    sucel $p |- ( suc A e. B <->
                E. x e. B A. y ( y e. x <-> ( y e. A \/ y = A ) ) ) $=
      cA csuc cB wcel vx cv cA csuc wceq vx cB wrex vy cv vx cv wcel vy cv cA
      wcel vy cv cA wceq wo wb vy wal vx cB wrex vx cA csuc cB risset vx cv cA
      csuc wceq vy cv vx cv wcel vy cv cA wcel vy cv cA wceq wo wb vy wal vx cB
      vx cv cA csuc wceq vy cv vx cv wcel vy cv cA csuc wcel wb vy wal vy cv vx
      cv wcel vy cv cA wcel vy cv cA wceq wo wb vy wal vy vx cv cA csuc dfcleq
      vy cv vx cv wcel vy cv cA csuc wcel wb vy cv vx cv wcel vy cv cA wcel vy
      cv cA wceq wo wb vy vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo vy
      cv vx cv wcel vy cv cA vy visset elsuc bibi2i albii bitri rexbii bitri $.
      $( [30-Jun-2004] $) $( [29-Jun-2004] $)
  $}

  $( The successor of the empty set. $)
  suc0 $p |- suc (/) = { (/) } $=
    c0 csuc c0 c0 csn cun c0 csn c0 cun c0 csn c0 df-suc c0 c0 csn uncom c0 csn
    un0 3eqtri $.
    $( [5-Feb-2005] $) $( [1-Feb-2005] $)

  $( A proper class is its own successor. $)
  sucprc $p |- ( -. A e. _V -> suc A = A ) $=
    cA cvv wcel wn cA csuc cA c0 cun cA cA cvv wcel wn cA cA csn cun cA c0 cun
    cA csuc cA cvv wcel wn cA csn c0 wceq cA cA csn cun cA c0 cun wceq cA snprc
    cA csn c0 cA uneq2 sylbi cA df-suc syl5eq cA un0 syl6eq $.
    $( [3-Apr-1995] $)

  ${
    unisuc.1 $e |- A e. _V $.
    $( A transitive class is equal to the union of its successor.  Combines
       Theorem 4E of [Enderton] p. 72 and Exercise 6 of [Enderton] p. 73. $)
    unisuc $p |- ( Tr A <-> U. suc A = A ) $=
      cA cuni cA wss cA cuni cA cun cA wceq cA wtr cA csuc cuni cA wceq cA cuni
      cA ssequn1 cA df-tr cA csuc cuni cA cuni cA cun cA cA csuc cuni cA cA csn
      cun cuni cA cuni cA csn cuni cun cA cuni cA cun cA csuc cA cA csn cun cA
      df-suc unieqi cA cA csn uniun cA csn cuni cA cA cuni cA unisuc.1 unisn
      uneq2i 3eqtri eqeq1i 3bitr4i $.
      $( [22-Sep-2004] $) $( [30-Aug-1993] $)
  $}

  $( A class is included in its own successor.  Part of Proposition 7.23 of
     [TakeutiZaring] p. 41 (generalized to arbitrary classes). $)
  sssucid $p |- A C_ suc A $=
    cA cA cA csn cun cA csuc cA cA csn ssun1 cA df-suc sseqtr4i $.
    $( [31-May-1994] $)

  ${
    sucid.1 $e |- A e. _V $.
    $( A set belongs to its successor. $)
    sucid $p |- A e. suc A $=
      cA cA csn wcel cA cA csuc wcel cA sucid.1 snid cA cA wcel cA cA csn wcel
      cA cA csuc wcel cA cA csuc wcel cA cA wcel cA cA csn wcel wo cA cA csuc
      wcel cA cA cA csn cun wcel cA cA wcel cA cA csn wcel wo cA csuc cA cA csn
      cun cA cA df-suc eleq2i cA cA cA csn elun bitri biimpri olcs ax-mp $.
      $( [22-Jun-1994] $)
  $}

  ${
    $d x A $.
    $( Part of Proposition 7.23 of [TakeutiZaring] p. 41 (generalized). $)
    sucidg $p |- ( A e. B -> A e. suc A ) $=
      vx cv vx cv csuc wcel cA cA csuc wcel vx cA cB vx cv cA wceq vx cv cA vx
      cv csuc cA csuc vx cv cA wceq id vx cv cA suceq eleq12d vx cv vx visset
      sucid vtoclg $.
      $( [25-Mar-1995] $)
  $}

  $( No successor is empty. $)
  nsuceq0 $p |- suc A =/= (/) $=
    cA csuc c0 wne cA csuc c0 wceq wn cA cvv wcel cA csuc c0 wceq wn cA cvv
    wcel cA csuc c0 wceq cA c0 wcel cA noel cA csuc c0 wceq cA cA csuc wcel cA
    c0 wcel cA cvv wcel cA csuc c0 cA eleq2 cA cvv sucidg syl5cbi mtoi cA cvv
    wcel wn cA csuc c0 wceq wn cA cvv wcel wn cA csuc c0 wceq cA cvv wcel cA
    cvv wcel wn cA csuc c0 wceq cA c0 wceq cA cvv wcel cA cvv wcel wn cA csuc
    cA c0 cA sucprc eqeq1d cA c0 wceq cA cvv wcel c0 cvv wcel 0ex cA c0 cvv
    eleq1 mpbiri syl6bi con3d pm2.43i pm2.61i cA csuc c0 df-ne mpbir $.
    $( [16-Jan-2007] $) $( [3-Apr-1995] $)

  ${
    eqelsuc.1 $e |- A e. _V $.
    $( A set belongs to the successor of an equal set. $)
    eqelsuc $p |- ( A = B -> A e. suc B ) $=
      cA cB wceq cA csuc cB csuc cA cA cB suceq cA eqelsuc.1 sucid syl5eleq $.
      $( [18-Aug-1994] $)
  $}

  ${
    $d z y A $.
    $( The successor of a transtive class is transitive.  (Contributed by
       Alan Sare, 11-Apr-2009.) $)
    suctr $p |- ( Tr A -> Tr suc A ) $=
      cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa vz cv cA csuc wcel wi vy
      wal vz wal cA csuc wtr cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa vz
      cv cA csuc wcel wi vz vy cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa vy
      cv cA wcel vy cv cA wceq wo vz cv cA csuc wcel vz cv vy cv wcel vy cv cA
      csuc wcel wa vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo vz cv vy
      cv wcel vy cv cA csuc wcel pm3.27 vy cv cA vy visset elsuc sylib cA wtr
      vz cv vy cv wcel vy cv cA csuc wcel wa vy cv cA wceq vz cv cA csuc wcel
      wi vy cv cA wcel vy cv cA wceq wo vz cv cA csuc wcel wi vz cv vy cv wcel
      vy cv cA csuc wcel wa vy cv cA wceq vz cv cA wcel vz cv cA csuc wcel vy
      cv cA wceq vz cv vy cv wcel vz cv cA wcel vz cv vy cv wcel vy cv cA csuc
      wcel wa vy cv cA vz cv eleq2 vz cv vy cv wcel vy cv cA csuc wcel pm3.26
      syl5cbi vz cv cA elelsuc syl6 cA wtr vz cv vy cv wcel vy cv cA csuc wcel
      wa vy cv cA wcel vz cv cA csuc wcel wi vy cv cA wceq vz cv cA csuc wcel
      wi vy cv cA wcel vy cv cA wceq wo vz cv cA csuc wcel wi wi cA wtr vz cv
      vy cv wcel vy cv cA csuc wcel wa vy cv cA wcel vz cv cA wcel vz cv cA
      csuc wcel cA wtr vz cv vy cv wcel vy cv cA wcel vz cv cA wcel wi vy cv cA
      csuc wcel cA wtr vz cv vy cv wcel vy cv cA wcel vz cv cA wcel cA vz cv vy
      cv trel exp3a adantrd vz cv cA elelsuc syl8 vy cv cA wcel vz cv cA csuc
      wcel vy cv cA wceq jao syl6 mpdi mpdi 19.21aivv vz vy cA csuc dftr2
      sylibr $.
      $( [19-Apr-2009] $) $( [11-Apr-2009] $)
  $}

  $( A set whose successor belongs to a transitive class also belongs. $)
  trsuc $p |- ( ( Tr A /\ suc B e. A ) -> B e. A ) $=
    cA wtr cB csuc cA wcel cB cA wcel cB cvv wcel cA wtr cB csuc cA wcel cB cA
    wcel wi wi cA wtr cB cB csuc wcel cB csuc cA wcel cB cA wcel wi cB cvv wcel
    cA wtr cB cB csuc wcel cB csuc cA wcel cB cA wcel cA cB cB csuc trel exp3a
    cB cvv sucidg syl5com cB cvv wcel wn cB csuc cA wcel cB cA wcel wi cA wtr
    cB cvv wcel wn cB csuc cA wcel cB cA wcel cB cvv wcel wn cB csuc cB cA cB
    sucprc eleq1d biimpd a1d pm2.61i imp $.
    $( [5-Sep-2003] $)

  $( A member of the successor of a transitive class is a subclass of it. $)
  trsucss $p |- ( Tr A -> ( B e. suc A -> B C_ A ) ) $=
    cA wtr cB cA wcel cB cA wceq wo cB cA wss cB cA csuc wcel cA wtr cB cA wcel
    cB cA wss cB cA wceq cA cB trss cB cA wceq cB cA wss wi cA wtr cB cA eqimss
    a1i jaod cB cA elsuci syl5 $.
    $( [4-Oct-2003] $) $( [4-Oct-2003] $)

  $( A subset of an ordinal belongs to its successor. $)
  ordsssuc $p |- ( ( A e. On /\ Ord B ) -> ( A C_ B <-> A e. suc B ) ) $=
    cA con0 wcel cB word wa cA cB wss cA cB wcel cA cB wceq wo cA cB csuc wcel
    cA word cB word cA cB wss cA cB wcel cA cB wceq wo wb cA con0 wcel cA cB
    ordsseleq cA eloni sylan cA con0 wcel cA cB csuc wcel cA cB wcel cA cB wceq
    wo wb cB word cA cB con0 elsucg adantr bitr4d $.
    $( [30-Nov-2003] $) $( [28-Nov-2003] $)

  $( A subset of an ordinal number belongs to its successor. $)
  onsssuc $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B <-> A e. suc B ) ) $=
    cA con0 wcel cB word cA cB wss cA cB csuc wcel wb cB con0 wcel cA cB
    ordsssuc cB eloni sylan2 $.
    $( [15-Sep-1995] $)

  $( An ordinal subset of an ordinal number belongs to its successor. $)
  ordsssuc2 $p |- ( ( Ord A /\ B e. On ) -> ( A C_ B <-> A e. suc B ) ) $=
    cA word cB con0 wcel wa cA cB wss cA cB csuc wcel cA word cB con0 wcel cA
    cB wss cA cB csuc wcel wi cA cB wss cB con0 wcel cA word cA cB csuc wcel cA
    cB wss cB con0 wcel cA word cA cB csuc wcel wi cA cB wss cB con0 wcel wa cA
    word cA con0 wcel cA cB csuc wcel cA cB wss cB con0 wcel wa cA cvv wcel cA
    con0 wcel cA word wb cA cB con0 ssexg cA cvv elong syl cA cB wss cB con0
    wcel cA con0 wcel cA cB csuc wcel wi cA con0 wcel cB con0 wcel cA cB wss cA
    cB csuc wcel cA con0 wcel cB con0 wcel cA cB wss cA cB csuc wcel wi cA con0
    wcel cB con0 wcel wa cA cB wss cA cB csuc wcel cA cB onsssuc biimpd ex
    com13 imp sylbird ex com13 imp cA word cB con0 wcel cA cB csuc wcel cA cB
    wss wi cA cB csuc wcel cA word cB con0 wcel cA cB wss cA cB csuc wcel cA
    word cA con0 wcel cB con0 wcel cA cB wss wi cA cB csuc elong cA con0 wcel
    cB con0 wcel cA cB csuc wcel cA cB wss cA con0 wcel cB con0 wcel cA cB csuc
    wcel cA cB wss wi cA con0 wcel cB con0 wcel wa cA cB wss cA cB csuc wcel cA
    cB onsssuc biimprd ex com3r sylbird com3l imp impbid $.
    $( [4-Feb-2005] $) $( [1-Feb-2005] $)

  ${
    $d x A $.  $d x B $.
    $( When its successor is subtracted from a class of ordinal numbers, an
       ordinal number is less than the minimum of the resulting subclass. $)
    onmindif $p |- ( ( A C_ On /\ B e. On ) -> B e. |^| ( A \ suc B ) ) $=
      cA con0 wss cB con0 wcel wa cB cA cB csuc cdif cint wcel cB vx cv wcel vx
      cA cB csuc cdif wral cA con0 wss cB con0 wcel wa cB vx cv wcel vx cA cB
      csuc cdif cA con0 wss cB con0 wcel wa vx cv cA wcel vx cv cB csuc wcel wn
      wa cB vx cv wcel vx cv cA cB csuc cdif wcel cA con0 wss cB con0 wcel vx
      cv cA wcel vx cv cB csuc wcel wn cB vx cv wcel cA con0 wss vx cv cA wcel
      cB con0 wcel vx cv cB csuc wcel wn cB vx cv wcel wi cA con0 wss vx cv cA
      wcel cB con0 wcel vx cv cB csuc wcel wn cB vx cv wcel wi cA con0 wss vx
      cv cA wcel wa cB con0 wcel wa vx cv cB csuc wcel wn cB vx cv wcel vx cv
      con0 wcel cB con0 wcel vx cv cB csuc wcel wn cB vx cv wcel wb cA con0 wss
      vx cv cA wcel wa vx cv con0 wcel cB con0 wcel wa cB vx cv wcel vx cv cB
      csuc wcel vx cv con0 wcel cB con0 wcel wa vx cv cB wss cB vx cv wcel wn
      vx cv cB csuc wcel vx cv cB ontri1 vx cv cB onsssuc bitr3d con1bid cA
      con0 vx cv ssel2 sylan biimpd exp31 com23 imp4b vx cv cA cB csuc eldif
      syl5ib r19.21aiv cB con0 wcel cB cA cB csuc cdif cint wcel cB vx cv wcel
      vx cA cB csuc cdif wral wb cA con0 wss vx cB cA cB csuc cdif con0 elintg
      adantl mpbird $.
      $( [7-Dec-2003] $) $( [1-Dec-2003] $)
  $}

  $( There is no set between an ordinal class and its successor.  Generalized
     Proposition 7.25 of [TakeutiZaring] p. 41. $)
  ordnbtwn $p |- ( Ord A -> -. ( A e. B /\ B e. suc A ) ) $=
    cA word cA cB wcel cB cA wcel wa cA cA wcel wo cA cB wcel cB cA csuc wcel
    wa cA cB wcel cB cA wcel wa cA cA wcel wo wn cA cB wcel cB cA wcel wa wn cA
    cA wcel wn cA word cA cB wcel cB cA wcel wa cA cA wcel ioran cA cB ordn2lp
    cA ordirr sylanbrc cA cB wcel cB cA csuc wcel wa cA cB wcel cB cA wcel wa
    cA cB wcel cB cA wceq wa wo cA cB wcel cB cA wcel wa cA cA wcel wo cA cB
    wcel cB cA csuc wcel wa cA cB wcel cB cA wcel cB cA wceq wo wa cA cB wcel
    cB cA wcel wa cA cB wcel cB cA wceq wa wo cB cA csuc wcel cB cA wcel cB cA
    wceq wo cA cB wcel cB cA elsuci anim2i cA cB wcel cB cA wcel cB cA wceq
    andi sylib cA cB wcel cB cA wceq wa cA cA wcel cA cB wcel cB cA wcel wa cB
    cA wceq cA cB wcel cA cA wcel cB cA cA eleq2 biimpac orim2i syl nsyl $.
    $( [21-Jun-1998] $)

  $( There is no set between an ordinal number and its successor.  Proposition
     7.25 of [TakeutiZaring] p. 41. $)
  onnbtwn $p |- ( A e. On -> -. ( A e. B /\ B e. suc A ) ) $=
    cA con0 wcel cA word cA cB wcel cB cA csuc wcel wa wn cA eloni cA cB
    ordnbtwn syl $.
    $( [9-Jun-1994] $)

  $( A set whose successor is a subset of another class is a member of that
     class. $)
  sucssel $p |- ( A e. C -> ( suc A C_ B -> A e. B ) ) $=
    cA csuc cB wss cA cA csuc wcel cA cB wcel cA cC wcel cA csuc cB cA ssel cA
    cC sucidg syl5com $.
    $( [16-Sep-1995] $)

  $( Ordinal derived from its successor. $)
  orddif $p |- ( Ord A -> A = ( suc A \ { A } ) ) $=
    cA word cA cA csn cin c0 wceq cA cA csuc cA csn cdif wceq cA orddisj cA cA
    csn cin c0 wceq cA cA cA csn cdif wceq cA cA csuc cA csn cdif wceq cA cA
    csn disj3 cA csuc cA csn cdif cA cA csn cdif cA cA csuc cA csn cdif cA cA
    csn cun cA csn cdif cA cA csn cdif cA csuc cA cA csn cun cA csn cA df-suc
    difeq1i cA cA csn difun2 eqtri eqeq2i bitr4i sylib $.
    $( [20-May-1998] $)

  $( An ordinal class includes its union. $)
  orduniss $p |- ( Ord A -> U. A C_ A ) $=
    cA word cA wtr cA cuni cA wss cA ordtr cA df-tr sylib $.
    $( [13-Sep-2003] $)

  $( A trichotomy law for ordinal classes. $)
  ordtri2or $p |- ( ( Ord A /\ Ord B ) -> ( A e. B \/ B C_ A ) ) $=
    cA word cB word wa cA cB wcel cB cA wss wo cA cB wcel cA cB wceq cB cA wcel
    wo wo cA word cB word wa cA cB wcel cA cB wceq cB cA wcel w3o cA cB wcel cA
    cB wceq cB cA wcel wo wo cA cB ordtri3or cA cB wcel cA cB wceq cB cA wcel
    3orass sylib cA word cB word wa cB cA wss cA cB wceq cB cA wcel wo cA cB
    wcel cA word cB word wa cB cA wss cB cA wcel cB cA wceq wo cA cB wceq cB cA
    wcel wo cB word cA word cB cA wss cB cA wcel cB cA wceq wo wb cB cA
    ordsseleq ancoms cB cA wcel cB cA wceq wo cB cA wceq cB cA wcel wo cA cB
    wceq cB cA wcel wo cB cA wcel cB cA wceq orcom cB cA wceq cA cB wceq cB cA
    wcel cB cA eqcom orbi1i bitri syl6bb orbi2d mpbird $.
    $( [13-Sep-2003] $)

  $( A trichotomy law for ordinal classes. $)
  ordtri2or2 $p |- ( ( Ord A /\ Ord B ) -> ( A C_ B \/ B C_ A ) ) $=
    cA word cB word wa cA cB wcel cB cA wss wo cA cB wss cB cA wss wo cA cB
    ordtri2or cB word cA cB wcel cB cA wss wo cA cB wss cB cA wss wo wi cA word
    cB word cA cB wcel cA cB wss cB cA wss cB word cA cB wcel cA cB wss cB cA
    ordelss ex orim1d adantl mpd $.
    $( [11-Dec-2003] $) $( [2-Nov-2003] $)

  $( Property of a subclass of the maximum (i.e. union) of two ordinals. $)
  ordssun $p |- ( ( Ord B /\ Ord C ) ->
               ( A C_ ( B u. C ) <-> ( A C_ B \/ A C_ C ) ) ) $=
    cB word cC word wa cA cB cC cun wss cA cB wss cA cC wss wo cB word cC word
    wa cB cC wss cC cB wss wo cA cB cC cun wss cA cB wss cA cC wss wo wi cB cC
    ordtri2or2 cB cC wss cA cB cC cun wss cA cB wss cA cC wss wo wi cC cB wss
    cB cC wss cA cB cC cun wss cA cC wss cA cB wss cA cC wss wo cB cC wss cB cC
    cun cC wceq cA cB cC cun wss cA cC wss wb cB cC ssequn1 cB cC cun cC cA
    sseq2 sylbi cA cC wss cA cB wss olc syl6bi cC cB wss cA cB cC cun wss cA cB
    wss cA cB wss cA cC wss wo cC cB wss cB cC cun cB wceq cA cB cC cun wss cA
    cB wss wb cC cB ssequn2 cB cC cun cB cA sseq2 sylbi cA cB wss cA cC wss orc
    syl6bi jaoi syl cA cB cC ssun impbid1 $.
    $( [23-Dec-2003] $) $( [28-Nov-2003] $)

  $( The maximum (i.e. union) of two ordinals is either one or the other.
     Similar to Exercise 14 of [TakeutiZaring] p. 40. $)
  ordequn $p |- ( ( Ord B /\ Ord C ) ->
               ( A = ( B u. C ) -> ( A = B \/ A = C ) ) ) $=
    cB word cC word wa cB cC wss cC cB wss wo cA cB cC cun wceq cA cB wceq cA
    cC wceq wo wi cB cC ordtri2or2 cB cC wss cA cB cC cun wceq cA cB wceq cA cC
    wceq wo wi cC cB wss cB cC wss cA cB cC cun wceq cA cC wceq cA cB wceq cA
    cC wceq wo cB cC wss cB cC cun cC wceq cA cB cC cun wceq cA cC wceq wb cB
    cC ssequn1 cB cC cun cC cA eqeq2 sylbi cA cC wceq cA cB wceq olc syl6bi cC
    cB wss cA cB cC cun wceq cA cB wceq cA cB wceq cA cC wceq wo cC cB wss cB
    cC cun cB wceq cA cB cC cun wceq cA cB wceq wb cC cB ssequn2 cB cC cun cB
    cA eqeq2 sylbi cA cB wceq cA cC wceq orc syl6bi jaoi syl $.
    $( [26-Dec-2003] $) $( [28-Nov-2003] $)

  $( The maximum (i.e. union) of two ordinals is ordinal.  Exercise 12 of
     [TakeutiZaring] p. 40. $)
  ordun $p |- ( ( Ord A /\ Ord B ) -> Ord ( A u. B ) ) $=
    cA word cB word wa cA cB cun cA wceq cA cB cun cB wceq wo cA cB cun word cA
    word cB word wa cA cB cun cA cB cun wceq cA cB cun cA wceq cA cB cun cB
    wceq wo cA cB cun eqid cA cB cun cA cB ordequn mpi cA word cA cB cun cA
    wceq cA cB cun word cB word cA cB cun cB wceq cA cB cun cA wceq cA cB cun
    word cA word cA cB cun cA ordeq biimprcd cA cB cun cB wceq cA cB cun word
    cB word cA cB cun cB ordeq biimprcd jaao mpd $.
    $( [29-Dec-2003] $) $( [28-Nov-2003] $)

  ${
    $d x A $.  $d x B $.
    $( A subclass relationship for union and successor of ordinal classes. $)
    ordunisssuc $p |- ( ( A C_ On /\ Ord B ) ->
                      ( U. A C_ B <-> A C_ suc B ) ) $=
      cA con0 wss cB word wa vx cv cB wss vx cA wral vx cv cB csuc wcel vx cA
      wral cA cuni cB wss cA cB csuc wss cA con0 wss cB word wa vx cv cB wss vx
      cv cB csuc wcel vx cA cA con0 wss vx cv cA wcel cB word vx cv cB wss vx
      cv cB csuc wcel wb vx cv con0 wcel cB word vx cv cB wss vx cv cB csuc
      wcel wb cA con0 wss vx cv cA wcel wa vx cv cB ordsssuc cA con0 vx cv
      ssel2 sylan an1rs ralbidva vx cA cB unissb vx cA cB csuc dfss3 3bitr4g $.
      $( [3-Dec-2003] $) $( [28-Nov-2003] $)
  $}

  $( The successor operation behaves like a one-to-one function.  Compare
     Exercise 16 of [Enderton] p. 194. $)
  suc11 $p |- ( ( A e. On /\ B e. On ) -> ( suc A = suc B <-> A = B ) ) $=
    cA con0 wcel cB con0 wcel wa cA csuc cB csuc wceq cA cB wceq cA con0 wcel
    cB con0 wcel wa cA cB wcel wn cB cA wcel wn wo cA csuc cB csuc wceq cA cB
    wceq wi cA con0 wcel cA cB wcel wn cB cA wcel wn wo cB con0 wcel cA con0
    wcel cA word cA cB wcel wn cB cA wcel wn wo cA eloni cA word cA cB wcel cB
    cA wcel wa wn cA cB wcel wn cB cA wcel wn wo cA cB ordn2lp cA cB wcel cB cA
    wcel ianor sylib syl adantr cA con0 wcel cA cB wcel wn cA csuc cB csuc wceq
    cA cB wceq wi cB con0 wcel cB cA wcel wn cA con0 wcel cA csuc cB csuc wceq
    cA cB csuc wcel cA cB wcel wn cA cB wceq cA con0 wcel cA csuc cB csuc wss
    cA cB csuc wcel cA csuc cB csuc wceq cA cB csuc con0 sucssel cA csuc cB
    csuc eqimss syl5 cA cB csuc wcel cA cB wcel wn cA cB wceq cA cB csuc wcel
    cA cB wcel cA cB wceq cA cB elsuci ord com12 syl9 cB con0 wcel cA csuc cB
    csuc wceq cB cA csuc wcel cB cA wcel wn cA cB wceq cB con0 wcel cB csuc cA
    csuc wss cB cA csuc wcel cA csuc cB csuc wceq cB cA csuc con0 sucssel cB
    csuc cA csuc eqimss2 syl5 cB cA wcel wn cB cA csuc wcel cB cA wceq cA cB
    wceq cB cA csuc wcel cB cA wcel wn cB cA wceq cB cA csuc wcel cB cA wcel cB
    cA wceq cB cA elsuci ord com12 cB cA eqcom syl6ib syl9 jaao mpd cA cB suceq
    impbid1 $.
    $( [3-Sep-2003] $)

  ${
    on.1 $e |- A e. On $.
    $( An ordinal number is an ordinal class. $)
    onordi $p |- Ord A $=
      cA con0 wcel cA word on.1 cA eloni ax-mp $.
      $( [11-Jun-1994] $)

    $( An ordinal number is a transitive class. $)
    ontrci $p |- Tr A $=
      cA word cA wtr cA on.1 onordi cA ordtr ax-mp $.
      $( [11-Jun-1994] $)

    $( An ordinal number is not a member of itself.  Theorem 7M(c) of
       [Enderton] p. 192. $)
    onirri $p |- -. A e. A $=
      cA word cA cA wcel wn cA on.1 onordi cA ordirr ax-mp $.
      $( [11-Jun-1994] $)

    $( A member of an ordinal number is an ordinal number.  Theorem 7M(a) of
       [Enderton] p. 192. $)
    oneli $p |- ( B e. A -> B e. On ) $=
      cA con0 wcel cB cA wcel cB con0 wcel on.1 cA cB onelon mpan $.
      $( [11-Jun-1994] $)

    $( A member of an ordinal number is a subset of it. $)
    onelssi $p |- ( B e. A -> B C_ A ) $=
      cA con0 wcel cB cA wcel cB cA wss wi on.1 cA cB onelss ax-mp $.
      $( [11-Aug-1994] $)

    $( An ordering law for ordinal numbers. $)
    onssneli $p |- ( A C_ B -> -. B e. A ) $=
      cB cA wcel cA cB wss cB cA wcel cA cB wss cB cB wcel cB cA wcel cB con0
      wcel cB word cB cB wcel wn cA cB on.1 oneli cB eloni cB ordirr 3syl cA cB
      wss cB cA wcel cB cB wcel cA cB cB ssel com12 mtod con2i $.
      $( [13-Jun-1994] $)

    $( An ordering law for ordinal numbers. $)
    onssnel2i $p |- ( B C_ A -> -. A e. B ) $=
      cB cA wss cA cB wcel cA cA wcel cA on.1 onirri cB cA cA ssel mtoi $.
      $( [13-Jun-1994] $)

    $( An element of an ordinal number equals the intersection with it. $)
    onelini $p |- ( B e. A -> B = ( B i^i A ) ) $=
      cB cA wcel cB cA wss cB cB cA cin wceq cA cB on.1 onelssi cB cA dfss
      sylib $.
      $( [11-Jun-1994] $)

    $( An ordinal number equals its union with any element. $)
    oneluni $p |- ( B e. A -> ( A u. B ) = A ) $=
      cB cA wcel cB cA wss cA cB cun cA wceq cA cB on.1 onelssi cB cA ssequn2
      sylib $.
      $( [23-Sep-2004] $) $( [13-Jun-1994] $)

    $( An ordinal number is equal to the union of its successor. $)
    onunisuci $p |- U. suc A = A $=
      cA wtr cA csuc cuni cA wceq cA on.1 ontrci cA cA con0 on.1 elisseti
      unisuc mpbi $.
      $( [22-Sep-2004] $) $( [12-Jun-1994] $)

    ${
      on.2 $e |- B e. On $.
      $( Subset is equivalent to membership or equality for ordinal numbers. $)
      onsseli $p |- ( A C_ B <-> ( A e. B \/ A = B ) ) $=
        cA con0 wcel cB con0 wcel cA cB wss cA cB wcel cA cB wceq wo wb on.1
        on.2 cA cB onsseleq mp2an $.
        $( [15-Sep-1995] $)

      $( The union of two ordinal numbers is an ordinal number. $)
      onun2i $p |- ( A u. B ) e. On $=
        cB cA wcel cA cB wss wo cA cB cun con0 wcel cB word cA word cB cA wcel
        cA cB wss wo cB on.2 onordi cA on.1 onordi cB cA ordtri2or mp2an cB cA
        wcel cA cB cun con0 wcel cA cB wss cB cA wcel cA cB cun cA con0 cA cB
        on.1 oneluni on.1 syl6eqel cA cB wss cA cB cun cB wceq cA cB cun con0
        wcel cA cB ssequn1 cA cB cun cB wceq cA cB cun con0 wcel cB con0 wcel
        on.2 cA cB cun cB con0 eleq1 mpbiri sylbi jaoi ax-mp $.
        $( [13-Jun-1994] $)
    $}
  $}

  $( An ordinal equal to its own union is either zero or a limit ordinal. $)
  unizlim $p |- ( Ord A -> ( A = U. A <-> ( A = (/) \/ Lim A ) ) ) $=
    cA word cA cA cuni wceq cA c0 wceq cA wlim wo cA word cA cA cuni wceq cA c0
    wceq cA wlim wo cA word cA cA cuni wceq wa cA c0 wceq cA wlim cA word cA cA
    cuni wceq cA c0 wceq wn cA wlim wi cA word cA c0 wceq wn cA cA cuni wceq cA
    wlim cA word cA c0 wne cA cA cuni wceq cA wlim wi cA c0 wceq wn cA word cA
    c0 wne cA cA cuni wceq cA wlim cA wlim cA word cA c0 wne cA cA cuni wceq
    w3a cA df-lim biimpri 3exp cA c0 df-ne syl5ibr com23 imp orrd ex cA c0 wceq
    cA cA cuni wceq cA wlim cA c0 wceq c0 c0 cuni cA cA cuni c0 cuni c0 uni0
    eqcomi cA c0 wceq id cA c0 unieq 3eqtr4a cA limuni jaoi impbid1 $.
    $( [1-Oct-2003] $) $( [1-Oct-2003] $)

  $( An ordinal number either equals zero or contains zero. $)
  on0eqel $p |- ( A e. On -> ( A = (/) \/ (/) e. A ) ) $=
    cA con0 wcel c0 cA wcel c0 cA wceq wo cA c0 wceq c0 cA wcel wo cA con0 wcel
    c0 cA wss c0 cA wcel c0 cA wceq wo cA 0ss c0 con0 wcel cA con0 wcel c0 cA
    wss c0 cA wcel c0 cA wceq wo wb 0elon c0 cA onsseleq mpan mpbii c0 cA wcel
    c0 cA wceq wo c0 cA wcel cA c0 wceq wo cA c0 wceq c0 cA wcel wo c0 cA wceq
    cA c0 wceq c0 cA wcel c0 cA eqcom orbi2i c0 cA wcel cA c0 wceq orcom bitri
    sylib $.
    $( [2-Jun-2004] $) $( [1-Jun-2004] $)

  $( The singleton of the singleton of the empty set is not an ordinal (nor a
     natural number by ~ omsson ).  It can be used to represent an "undefined"
     value for a partial operation on natural or ordinal numbers.  See also
     ~ onxpdisj . $)
  snsn0non $p |- -. { { (/) } } e. On $=
    c0 csn csn con0 wcel c0 csn c0 csn csn wss c0 csn c0 csn csn wss c0 c0 csn
    csn wcel c0 c0 csn csn wcel c0 csn c0 c0 0ex snnz c0 c0 csn csn wcel c0 c0
    csn wceq c0 csn c0 wceq c0 c0 csn 0ex elsnc c0 c0 csn eqcom bitri nemtbir
    c0 csn c0 csn csn wss c0 c0 csn wcel c0 c0 csn csn wcel c0 0ex snid c0 csn
    c0 csn csn c0 ssel mpi mto c0 csn csn con0 wcel c0 csn c0 csn csn wcel c0
    csn c0 csn csn wss c0 csn p0ex snid c0 csn csn c0 csn onelss mpi mto $.
    $( [21-May-2004] $) $( [21-May-2004] $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Union
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Introduce the Axiom of Union
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z $.
    $( Axiom of Union.  An axiom of Zermelo-Fraenkel set theory.  It states
       that a set ` y ` exists that includes the union of a given set ` x `
       i.e. the collection of all members of the members of ` x ` .  The
       variant ~ axun2 states that the union itself exists.  A version with
       the standard abbreviation for union is ~ uniex2 .  A version using class
       notation is ~ uniex .

       The union of a class ~ df-uni should not be confused with the union of
       two classes ~ df-un .  Their relationship is shown in ~ unipr . $)
    ax-un $a |- E. y A. z ( E. w ( z e. w /\ w e. x ) -> z e. y ) $.

    $( Axiom of Union expressed with fewest number of different variables. $)
    zfun $p |- E. x A. y ( E. x ( y e. x /\ x e. z ) -> y e. x ) $=
      vy cv vw cv wcel vw cv vz cv wcel wa vw wex vy cv vx cv wcel wi vy wal vx
      wex vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy
      wal vx wex vz vx vy vw ax-un vy cv vw cv wcel vw cv vz cv wcel wa vw wex
      vy cv vx cv wcel wi vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy
      cv vx cv wcel wi vy wal vx vy cv vw cv wcel vw cv vz cv wcel wa vw wex vy
      cv vx cv wcel wi vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv
      wcel wi vy vy cv vw cv wcel vw cv vz cv wcel wa vw wex vy cv vx cv wcel
      vx cv vz cv wcel wa vx wex vy cv vx cv wcel vy cv vw cv wcel vw cv vz cv
      wcel wa vy cv vx cv wcel vx cv vz cv wcel wa vw vx vw cv vx cv wceq vy cv
      vw cv wcel vy cv vx cv wcel vw cv vz cv wcel vx cv vz cv wcel vw vx vy
      elequ2 vw vx vz elequ1 anbi12d cbvexv imbi1i albii exbii mpbi $.
      $( [14-Aug-2003] $)

    $( A variant of the Axiom of Union ~ ax-un .  For any set ` x ` , there
       exists a set ` y ` whose members are exactly the members of the members
       of ` x ` i.e. the union of ` x ` .  Axiom Union of [BellMachover]
       p. 466. $)
    axun2 $p |- E. y A. z ( z e. y <-> E. w ( z e. w /\ w e. x ) ) $=
      vz cv vw cv wcel vw cv vx cv wcel wa vw wex vy vz vx vy vz vw ax-un
      bm1.3ii $.
      $( [4-Jun-2006] $) $( [4-Jun-2006] $)

    $( The Axiom of Union using the standard abbreviation for union.  Given
       any set ` x ` , its union ` y ` exists. $)
    uniex2 $p |- E. y y = U. x $=
      vy cv vx cv cuni wceq vy wex vz cv vy cv wcel vz cv vx cv cuni wcel wb vz
      wal vy wex vz cv vx cv cuni wcel vy vz vz cv vx cv cuni wcel vz cv vy cv
      wcel wi vz wal vy wex vz cv vy cv wcel vy cv vx cv wcel wa vy wex vz cv
      vy cv wcel wi vz wal vy wex vy vz vx zfun vz cv vx cv cuni wcel vz cv vy
      cv wcel wi vz wal vz cv vy cv wcel vy cv vx cv wcel wa vy wex vz cv vy cv
      wcel wi vz wal vy vz cv vx cv cuni wcel vz cv vy cv wcel wi vz cv vy cv
      wcel vy cv vx cv wcel wa vy wex vz cv vy cv wcel wi vz vz cv vx cv cuni
      wcel vz cv vy cv wcel vy cv vx cv wcel wa vy wex vz cv vy cv wcel vy vz
      cv vx cv eluni imbi1i albii exbii mpbir bm1.3ii vy cv vx cv cuni wceq vz
      cv vy cv wcel vz cv vx cv cuni wcel wb vz wal vy vz vy cv vx cv cuni
      dfcleq exbii mpbir $.
      $( [4-Jun-2006] $) $( [4-Jun-2006] $)
  $}

  ${
    $d x y A $.
    uniex.1 $e |- A e. _V $.
    $( The Axiom of Union in class notation.  This says that if ` A ` is
       a set i.e. ` A e. _V ` (see ~ isset ), then the union of ` A ` is also a
       set.  Same as Axiom 3 of [TakeutiZaring] p. 16. $)
    uniex $p |- U. A e. _V $=
      vx cv cuni cvv wcel cA cuni cvv wcel vx cA uniex.1 vx cv cA wceq vx cv
      cuni cA cuni cvv vx cv cA unieq eleq1d vy vx cv cuni vx vy uniex2 issetri
      vtocl $.
      $( [11-Aug-1993] $)
  $}

  ${
    $d x A $.
    $( The ZF Axiom of Union in class notation, in the form of a theorem
       instead of an inference.  We use the antecedent ` A e. B ` instead of
       ` A e. _V ` to make the theorem more general and thus shorten some
       proofs; obviously ` _V ` is one possibility for ` B ` . $)
    uniexg $p |- ( A e. B -> U. A e. _V ) $=
      vx cv cuni cvv wcel cA cuni cvv wcel vx cA cB vx cv cA wceq vx cv cuni cA
      cuni cvv vx cv cA unieq eleq1d vx cv vx visset uniex vtoclg $.
      $( [25-Nov-1994] $)
  $}

  ${
    unex.1 $e |- A e. _V $.
    unex.2 $e |- B e. _V $.
    $( The union of two sets is a set.  Corollary 5.8 of [TakeutiZaring]
        p. 16. $)
    unex $p |- ( A u. B ) e. _V $=
      cA cB cpr cuni cA cB cun cvv cA cB unex.1 unex.2 unipr cA cB cpr cA cB
      prex uniex eqeltrri $.
      $( [1-Jul-1994] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Existence of union is equivalent to existence of its components. $)
    unexb $p |- ( ( A e. _V /\ B e. _V ) <-> ( A u. B ) e. _V ) $=
      cA cvv wcel cB cvv wcel wa cA cB cun cvv wcel vx cv vy cv cun cvv wcel cA
      vy cv cun cvv wcel cA cB cun cvv wcel vx vy cA cB cvv cvv vx cv cA wceq
      vx cv vy cv cun cA vy cv cun cvv vx cv cA vy cv uneq1 eleq1d vy cv cB
      wceq cA vy cv cun cA cB cun cvv vy cv cB cA uneq2 eleq1d vx cv vy cv vx
      visset vy visset unex vtocl2g cA cB cun cvv wcel cA cvv wcel cB cvv wcel
      cA cA cB cun wss cA cB cun cvv wcel cA cvv wcel cA cB ssun1 cA cA cB cun
      cvv ssexg mpan cB cA cB cun wss cA cB cun cvv wcel cB cvv wcel cB cA
      ssun2 cB cA cB cun cvv ssexg mpan jca impbii $.
      $( [11-Jun-1998] $)
  $}

  $( A union of two sets is a set.  Corollary 5.8 of [TakeutiZaring] p. 16. $)
  unexg $p |- ( ( A e. C /\ B e. D ) -> ( A u. B ) e. _V ) $=
    cA cvv wcel cB cvv wcel cA cB cun cvv wcel cA cC wcel cB cD wcel cA cvv
    wcel cB cvv wcel wa cA cB cun cvv wcel cA cB unexb biimpi cA cC elisset cB
    cD elisset syl2an $.
    $( [19-Sep-2006] $) $( [18-Sep-2006] $)

  ${
    $( A version of ~ unisn without the ` A e. _V ` hypothesis.  (Contributed
       by Stefan Allan, 14-Mar-2006.) $)
    unisn2 $p |- U. { A } e. { (/) , A } $=
      cA cvv wcel cA csn cuni c0 cA cpr wcel cA cvv wcel cA csn cuni cA c0 cA
      cpr cA cvv unisng cA cvv wcel cA c0 cA cpr wcel cA c0 wceq cA cA wceq wo
      cA cA wceq cA c0 wceq cA eqid olci cA c0 cA cvv elprg mpbiri eqeltrd cA
      cvv wcel wn cA csn cuni c0 cuni c0 cA cpr cA cvv wcel wn cA csn c0 cA cvv
      wcel wn cA csn c0 wceq cA snprc biimpi unieqd c0 cuni c0 c0 cA cpr uni0
      c0 cA 0ex prid1 eqeltri syl6eqel pm2.61i $.
      $( [14-Mar-2006] $) $( [14-Mar-2006] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Union of a singleton in the form of a restricted class abstraction. $)
    unisn3 $p |- ( A e. B -> U. { x e. B | x = A } = A ) $=
      cA cB wcel vx cv cA wceq vx cB crab cuni cA csn cuni cA cA cB wcel vx cv
      cA wceq vx cB crab cA csn vx cB cA rabsn unieqd cA cB unisng eqtrd $.
      $( [3-Jul-2008] $) $( [3-Jul-2008] $)
  $}

  ${
    $d x y z $.
    $( The class of all singletons is a proper class.  (Proof shortened by
       Eric Schmidt, 7-Dec-2008.) $)
    snnex $p |- { x | E. y x = { y } } e/ _V $=
      vx cv vy cv csn wceq vy wex vx cab cvv wnel vx cv vy cv csn wceq vy wex
      vx cab cvv wcel wn vx cv vy cv csn wceq vy wex vx cab cvv wcel vx cv vy
      cv csn wceq vy wex vx cab cuni cvv wcel vx cv vy cv csn wceq vy wex vx
      cab cuni cvv wcel cvv cvv wcel vprc vx cv vy cv csn wceq vy wex vx cab
      cuni cvv cvv vz vx cv vy cv csn wceq vy wex vx cab cuni cvv vz cv vx cv
      vy cv csn wceq vy wex vx cab cuni wcel vz cv cvv wcel vz cv vx cv vy cv
      csn wceq vy wex vx cab cuni wcel vz cv vx cv wcel vx cv vy cv csn wceq vy
      wex wa vx wex vz cv vz cv csn wcel vz cv csn vy cv csn wceq vy wex vz cv
      vx cv wcel vx cv vy cv csn wceq vy wex wa vx wex vz cv vz visset snid vy
      cv vz cv wceq vy wex vz cv csn vy cv csn wceq vy wex vy vz cv vz visset
      isseti vy cv vz cv wceq vz cv csn vy cv csn wceq vy vz cv csn vy cv csn
      wceq vz cv vy cv vz cv vy cv sneq eqcoms 19.22i ax-mp vz cv vx cv wcel vx
      cv vy cv csn wceq vy wex wa vz cv vz cv csn wcel vz cv csn vy cv csn wceq
      vy wex wa vx vz cv csn vz cv snex vx cv vz cv csn wceq vz cv vx cv wcel
      vz cv vz cv csn wcel vx cv vy cv csn wceq vy wex vz cv csn vy cv csn wceq
      vy wex vx cv vz cv csn vz cv eleq2 vx cv vz cv csn wceq vx cv vy cv csn
      wceq vz cv csn vy cv csn wceq vy vx cv vz cv csn vy cv csn eqeq1 exbidv
      anbi12d cla4ev mp2an vx cv vy cv csn wceq vy wex vx vz cv eluniab mpbir
      vz visset 2th eqriv eleq1i mtbir vx cv vy cv csn wceq vy wex vx cab cvv
      uniexg mto vx cv vy cv csn wceq vy wex vx cab cvv df-nel mpbir $.
      $( [9-Dec-2008] $) $( [10-Oct-2008] $)
  $}

  $( If the subtrahend of a class difference exists, then the minuend exists
     iff the difference exists. $)
  difex2 $p |- ( B e. C -> ( A e. _V <-> ( A \ B ) e. _V ) ) $=
    cB cC wcel cA cvv wcel cA cB cdif cvv wcel cA cB cvv difexg cA cB cdif cvv
    wcel cB cC wcel cA cvv wcel cA cB cA cun wss cB cA cun cvv wcel cA cvv wcel
    cA cB cdif cvv wcel cB cC wcel wa cA cB cA cun cvv ssexg cA cB ssun2 cA cB
    cdif cvv wcel cB cC wcel wa cB cA cB cdif cun cvv cB cA cun cA cB cdif cvv
    wcel cB cC wcel wa cB cvv wcel cA cB cdif cvv wcel wa cB cA cB cdif cun cvv
    wcel cB cC wcel cA cB cdif cvv wcel cB cvv wcel cA cB cdif cvv wcel wa cB
    cC wcel cB cvv wcel cA cB cdif cvv wcel cB cC elisset anim1i ancoms cB cA
    cB cdif unexb sylib cB cA undif2 syl5eqelr sylancr expcom impbid2 $.
    $( [12-Nov-2003] $) $( [12-Nov-2003] $)

  $( A triple of classes exists. $)
  tpex $p |- { A , B , C } e. _V $=
    cA cB cC ctp cA cB cpr cC csn cun cvv cA cB cC df-tp cA cB cpr cC csn cA cB
    prex cC snex unex eqeltri $.
    $( [10-Apr-1994] $)

  $( Each member of an ordered pair belongs to the union of the union of a
     class to which the ordered pair belongs.  Lemma 3D of [Enderton] p. 41. $)
  opeluu $p |- ( <. x , y >. e. A ->
               ( x e. U. U. A /\ y e. U. U. A ) ) $=
    vx cv vy cv cop cA wcel vx cv cA cuni cuni wcel vy cv cA cuni cuni wcel vx
    cv vx cv vy cv cpr wcel vx cv vy cv cpr cA cuni wcel vx cv cA cuni cuni
    wcel vx cv vy cv cop cA wcel vx cv vx cv vy cv cpr cA cuni elunii vx cv vy
    cv vx visset prid1 vx cv vy cv cpr vx cv vy cv cop wcel vx cv vy cv cop cA
    wcel vx cv vy cv cpr cA cuni wcel vx cv vy cv opi2 vx cv vy cv cpr vx cv vy
    cv cop cA elunii mpan sylancr vy cv vx cv vy cv cpr wcel vx cv vy cv cpr cA
    cuni wcel vy cv cA cuni cuni wcel vx cv vy cv cop cA wcel vy cv vx cv vy cv
    cpr cA cuni elunii vx cv vy cv vy visset prid2 vx cv vy cv cpr vx cv vy cv
    cop wcel vx cv vy cv cop cA wcel vx cv vy cv cpr cA cuni wcel vx cv vy cv
    opi2 vx cv vy cv cpr vx cv vy cv cop cA elunii mpan sylancr jca $.
    $( [31-Mar-1995] $)

  ${
    $d A x y v z $.  $d A x y u z $.
    $( Expression for double union that moves union into a class builder.
       (Contributed by FL, 28-May-2007.) $)
    uniuni $p |- U. U. A = U. { x | E. y ( x = U. y /\ y e. A ) } $=
      vz cv vu cv wcel vu cv cA cuni wcel wa vu wex vz cab vz cv vv cv wcel vv
      cv vx cv vy cv cuni wceq vy cv cA wcel wa vy wex vx cab wcel wa vv wex vz
      cab cA cuni cuni vx cv vy cv cuni wceq vy cv cA wcel wa vy wex vx cab
      cuni vz cv vu cv wcel vu cv cA cuni wcel wa vu wex vz cv vv cv wcel vv cv
      vx cv vy cv cuni wceq vy cv cA wcel wa vy wex vx cab wcel wa vv wex vz vz
      cv vu cv wcel vu cv cA cuni wcel wa vu wex vz cv vu cv wcel vu cv vy cv
      wcel vy cv cA wcel wa vy wex wa vu wex vy cv cA wcel vz cv vy cv cuni
      wcel wa vy wex vz cv vv cv wcel vv cv vx cv vy cv cuni wceq vy cv cA wcel
      wa vy wex vx cab wcel wa vv wex vz cv vu cv wcel vu cv cA cuni wcel wa vz
      cv vu cv wcel vu cv vy cv wcel vy cv cA wcel wa vy wex wa vu vu cv cA
      cuni wcel vu cv vy cv wcel vy cv cA wcel wa vy wex vz cv vu cv wcel vy vu
      cv cA eluni anbi2i exbii vz cv vu cv wcel vu cv vy cv wcel vy cv cA wcel
      wa vy wex wa vu wex vy cv cA wcel vz cv vu cv wcel vu cv vy cv wcel wa vu
      wex wa vy wex vy cv cA wcel vz cv vy cv cuni wcel wa vy wex vz cv vu cv
      wcel vu cv vy cv wcel vy cv cA wcel wa vy wex wa vu wex vz cv vu cv wcel
      vu cv vy cv wcel vy cv cA wcel wa wa vy wex vu wex vy cv cA wcel vz cv vu
      cv wcel vu cv vy cv wcel wa wa vu wex vy wex vy cv cA wcel vz cv vu cv
      wcel vu cv vy cv wcel wa vu wex wa vy wex vz cv vu cv wcel vu cv vy cv
      wcel vy cv cA wcel wa vy wex wa vz cv vu cv wcel vu cv vy cv wcel vy cv
      cA wcel wa wa vy wex vu vz cv vu cv wcel vu cv vy cv wcel vy cv cA wcel
      wa wa vy wex vz cv vu cv wcel vu cv vy cv wcel vy cv cA wcel wa vy wex wa
      vz cv vu cv wcel vu cv vy cv wcel vy cv cA wcel wa vy 19.42v bicomi exbii
      vz cv vu cv wcel vu cv vy cv wcel vy cv cA wcel wa wa vy wex vu wex vz cv
      vu cv wcel vu cv vy cv wcel vy cv cA wcel wa wa vu wex vy wex vy cv cA
      wcel vz cv vu cv wcel vu cv vy cv wcel wa wa vu wex vy wex vz cv vu cv
      wcel vu cv vy cv wcel vy cv cA wcel wa wa vu vy excom vz cv vu cv wcel vu
      cv vy cv wcel vy cv cA wcel wa wa vy cv cA wcel vz cv vu cv wcel vu cv vy
      cv wcel wa wa vy vu vz cv vu cv wcel vu cv vy cv wcel vy cv cA wcel wa wa
      vz cv vu cv wcel vu cv vy cv wcel wa vy cv cA wcel wa vy cv cA wcel vz cv
      vu cv wcel vu cv vy cv wcel wa wa vz cv vu cv wcel vu cv vy cv wcel vy cv
      cA wcel anass vz cv vu cv wcel vu cv vy cv wcel wa vy cv cA wcel ancom
      bitr3i 2exbii bitri vy cv cA wcel vz cv vu cv wcel vu cv vy cv wcel wa vy
      vu exdistr 3bitri vy cv cA wcel vz cv vu cv wcel vu cv vy cv wcel wa vu
      wex wa vy cv cA wcel vz cv vy cv cuni wcel wa vy vz cv vu cv wcel vu cv
      vy cv wcel wa vu wex vz cv vy cv cuni wcel vy cv cA wcel vz cv vy cv cuni
      wcel vz cv vu cv wcel vu cv vy cv wcel wa vu wex vu vz cv vy cv eluni
      bicomi anbi2i exbii bitri vy cv cA wcel vz cv vy cv cuni wcel wa vy wex
      vz cv vv cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa wa vy wex vv wex
      vz cv vv cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa vy wex wa vv wex
      vz cv vv cv wcel vv cv vx cv vy cv cuni wceq vy cv cA wcel wa vy wex vx
      cab wcel wa vv wex vy cv cA wcel vz cv vy cv cuni wcel wa vy wex vz cv vv
      cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa wa vv wex vy wex vz cv vv
      cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa wa vy wex vv wex vy cv cA
      wcel vz cv vy cv cuni wcel wa vz cv vv cv wcel vv cv vy cv cuni wceq vy
      cv cA wcel wa wa vv wex vy vy cv cA wcel vz cv vy cv cuni wcel wa vy cv
      cA wcel vz cv vv cv wcel vv cv vy cv cuni wceq wa vv wex wa vy cv cA wcel
      vz cv vv cv wcel vv cv vy cv cuni wceq wa wa vv wex vz cv vv cv wcel vv
      cv vy cv cuni wceq vy cv cA wcel wa wa vv wex vz cv vy cv cuni wcel vz cv
      vv cv wcel vv cv vy cv cuni wceq wa vv wex vy cv cA wcel vz cv vy cv cuni
      wcel vv cv vy cv cuni wceq vz cv vv cv wcel wa vv wex vz cv vv cv wcel vv
      cv vy cv cuni wceq wa vv wex vz cv vv cv wcel vz cv vy cv cuni wcel vv vy
      cv cuni vy cv vy visset uniex vv cv vy cv cuni vz cv eleq2 ceqsexv vv cv
      vy cv cuni wceq vz cv vv cv wcel vv exancom bitr3i anbi2i vy cv cA wcel
      vz cv vv cv wcel vv cv vy cv cuni wceq wa vv 19.42v vy cv cA wcel vz cv
      vv cv wcel vv cv vy cv cuni wceq wa wa vz cv vv cv wcel vv cv vy cv cuni
      wceq vy cv cA wcel wa wa vv vy cv cA wcel vz cv vv cv wcel vv cv vy cv
      cuni wceq wa wa vz cv vv cv wcel vv cv vy cv cuni wceq wa vy cv cA wcel
      wa vz cv vv cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa wa vy cv cA
      wcel vz cv vv cv wcel vv cv vy cv cuni wceq wa ancom vz cv vv cv wcel vv
      cv vy cv cuni wceq vy cv cA wcel anass bitri exbii 3bitr2i exbii vz cv vv
      cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa wa vy vv excom bitri vz cv
      vv cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa vv vy exdistr vz cv vv
      cv wcel vv cv vy cv cuni wceq vy cv cA wcel wa vy wex wa vz cv vv cv wcel
      vv cv vx cv vy cv cuni wceq vy cv cA wcel wa vy wex vx cab wcel wa vv vv
      cv vy cv cuni wceq vy cv cA wcel wa vy wex vv cv vx cv vy cv cuni wceq vy
      cv cA wcel wa vy wex vx cab wcel vz cv vv cv wcel vv cv vx cv vy cv cuni
      wceq vy cv cA wcel wa vy wex vx cab wcel vv cv vy cv cuni wceq vy cv cA
      wcel wa vy wex vx cv vy cv cuni wceq vy cv cA wcel wa vy wex vv cv vy cv
      cuni wceq vy cv cA wcel wa vy wex vx vv cv vv visset vx cv vv cv wceq vx
      cv vy cv cuni wceq vy cv cA wcel wa vv cv vy cv cuni wceq vy cv cA wcel
      wa vy vx cv vv cv wceq vx cv vy cv cuni wceq vv cv vy cv cuni wceq vy cv
      cA wcel vx cv vv cv vy cv cuni eqeq1 anbi1d exbidv elab bicomi anbi2i
      exbii 3bitri 3bitri abbii vz vu cA cuni df-uni vz vv vx cv vy cv cuni
      wceq vy cv cA wcel wa vy wex vx cab df-uni 3eqtr4i $.
      $( [5-Feb-2008] $) $( [28-May-2007] $)
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( If ` ph ` is true for exactly one ` x ` , then ` U. { x | ph } ` is a
       way to express "the unique element such that ` ph ` is true."  Some
       books use a special symbol such as iota to denote "the unique element
       such that." $)
    euuni $p |- ( E! x ph -> ( ph <-> U. { x | ph } = x ) ) $=
      wph vx weu wph vx cab cuni vx cv wceq vx weu wph wph vx cab cuni vx cv
      wceq wa vx wex wph wph vx cab cuni vx cv wceq wb wph vx weu wph vx cab
      cuni cvv wcel wph vx cab cuni vx cv wceq vx weu wph vx weu wph vx cab cvv
      wcel wph vx cab cuni cvv wcel wph vx euabex wph vx cab cvv uniexg syl wph
      vx cab cuni cvv wcel vy cv wph vx cab cuni wceq vy weu wph vx cab cuni vy
      cv wceq vy weu wph vx cab cuni vx cv wceq vx weu vy wph vx cab cuni eueq
      vy cv wph vx cab cuni wceq wph vx cab cuni vy cv wceq vy vy cv wph vx cab
      cuni eqcom eubii wph vx cab cuni vy cv wceq wph vx cab cuni vx cv wceq vy
      vx vx vz vz wph vx cab cuni vy cv vx vz wph vx cab wph vx vz hbab1 hbuni
      vz cv vy cv wcel vx ax-17 hbeq wph vx cab cuni vx cv wceq vy ax-17 vy cv
      vx cv wph vx cab cuni eqeq2 cbveu 3bitri sylib wph vx weu wph vx cab vx
      cv csn wceq vx wex wph wph vx cab cuni vx cv wceq wa vx wex wph vx euabsn
      wph vx cab vx cv csn wceq wph wph vx cab cuni vx cv wceq wa vx wph vx cab
      vx cv csn wceq wph wph vx cab cuni vx cv wceq wph vx cab vx cv csn wceq
      vx cv wph vx cab wcel wph wph vx cab vx cv csn wceq vx cv wph vx cab wcel
      vx cv vx cv csn wcel vx cv vx visset snid wph vx cab vx cv csn vx cv
      eleq2 mpbiri wph vx abid sylib wph vx cab vx cv csn wceq wph vx cab cuni
      vx cv csn cuni vx cv wph vx cab vx cv csn unieq vx cv vx visset unisn
      syl6eq jca 19.22i sylbi wph wph vx cab cuni vx cv wceq vx eupickb
      mpd3an23 $.
      $( [22-Feb-2004] $) $( [22-Feb-2004] $)
  $}

  ${
    $d x y $.  $d y ph $.
    $( A way to express "the unique element such that" (restricted
       quantifier version). $)
    reuuni1 $p |- ( ( x e. A /\ E! x e. A ph ) ->
            ( ph <-> U. { x e. A | ph } = x ) ) $=
      vx cv cA wcel vx cv cA wcel wph wa vx weu wph wph vx cA crab cuni vx cv
      wceq wb wph vx cA wreu vx cv cA wcel vx cv cA wcel wph wa vx weu wa wph
      vx cv cA wcel wph wa vx cab cuni vx cv wceq wph vx cA crab cuni vx cv
      wceq vx cv cA wcel vx cv cA wcel wph wa vx weu wa wph vx cv cA wcel wph
      wa vx cab cuni vx cv wceq vx cv cA wcel wph wa vx weu vx cv cA wcel wph
      vx cv cA wcel wph wa vx cab cuni vx cv wceq wi vx cv cA wcel wph wa vx
      weu vx cv cA wcel wph vx cv cA wcel wph wa vx cab cuni vx cv wceq vx cv
      cA wcel wph wa vx weu vx cv cA wcel wph wa vx cv cA wcel wph wa vx cab
      cuni vx cv wceq vx cv cA wcel wph wa vx euuni biimpd exp3a impcom vx cv
      cA wcel wph wa vx weu vx cv cA wcel wph wa vx cab cuni vx cv wceq wph wi
      vx cv cA wcel vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx cab
      cuni vx cv wceq vx cv cA wcel wph wa wph vx cv cA wcel wph wa vx euuni vx
      cv cA wcel wph pm3.27 syl6bir adantl impbid wph vx cA crab cuni vx cv cA
      wcel wph wa vx cab cuni vx cv wph vx cA crab vx cv cA wcel wph wa vx cab
      wph vx cA df-rab unieqi eqeq1i syl6bbr wph vx cA df-reu sylan2b $.
      $( [3-Mar-2004] $) $( [25-Nov-1994] $)
  $}

  ${
    $d y ph $.  $d x y A $.  $d y B $.
    reuuni2f.1 $e |- ( y e. B -> A. x y e. B ) $.
    reuuni2f.2 $e |- ( B e. A -> ( ps -> A. x ps ) ) $.
    reuuni2f.3 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( ` U. { x e. A | ph } ` is an explicit representation of "the unique
       element in ` A ` such that ` ph ` ."  This theorem shows a condition
       that allows us to represent this element with a class expression
       ` B ` .  The second hypothesis is a weakened bound variable condition
       that allows ~ hbsbc1g to be used. $)
    reuuni2f $p |- ( ( B e. A /\ E! x e. A ph ) ->
            ( ps <-> U. { x e. A | ph } = B ) ) $=
      cB cA wcel wph vx cA wreu wps wph vx cA crab cuni cB wceq wb cB cA wcel
      wph vx cA wreu wps wph vx cA crab cuni cB wceq wb wi vx cv cA wcel wph vx
      cA wreu wph wph vx cA crab cuni vx cv wceq wb wi wi cB cA wcel wph vx cA
      wreu wps wph vx cA crab cuni cB wceq wb wi wi vx vy cB cA reuuni2f.1 cB
      cA wcel wph vx cA wreu wps wph vx cA crab cuni cB wceq wb wi vx vx vy vy
      cB cA reuuni2f.1 vy cv cA wcel vx ax-17 hbel cB cA wcel wph vx cA wreu
      wps wph vx cA crab cuni cB wceq wb vx vx vy vy cB cA reuuni2f.1 vy cv cA
      wcel vx ax-17 hbel wph vx cA wreu wph vx cA wreu vx wal wi cB cA wcel wph
      vx cA hbreu1 a1i cB cA wcel wps wph vx cA crab cuni cB wceq vx vx vy vy
      cB cA reuuni2f.1 vy cv cA wcel vx ax-17 hbel reuuni2f.2 wph vx cA crab
      cuni cB wceq wph vx cA crab cuni cB wceq vx wal wi cB cA wcel vx vy vy
      wph vx cA crab cuni cB vx vy wph vx cA crab wph vx vy cA hbrab1 hbuni
      reuuni2f.1 hbeq a1i hbbid hbimd hbim1 vx cv cB wceq vx cv cA wcel cB cA
      wcel wph vx cA wreu wph wph vx cA crab cuni vx cv wceq wb wi wph vx cA
      wreu wps wph vx cA crab cuni cB wceq wb wi vx cv cB cA eleq1 vx cv cB
      wceq wph wph vx cA crab cuni vx cv wceq wb wps wph vx cA crab cuni cB
      wceq wb wph vx cA wreu vx cv cB wceq wph wps wph vx cA crab cuni vx cv
      wceq wph vx cA crab cuni cB wceq reuuni2f.3 vx cv cB wph vx cA crab cuni
      eqeq2 bibi12d imbi2d imbi12d vx cv cA wcel wph vx cA wreu wph wph vx cA
      crab cuni vx cv wceq wb wph vx cA reuuni1 ex vtoclgf pm2.43i imp $.
      $( [27-May-2006] $) $( [19-Oct-2005] $)
  $}

  ${
    $d y ph $.  $d x y A $.  $d x y B $.  $d x ps $.
    reuuni2.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( ` U. { x e. A | ph } ` is an explicit representation of "the unique
       element in ` A ` such that ` ph ` ." $)
    reuuni2 $p |- ( ( B e. A /\ E! x e. A ph ) ->
            ( ps <-> U. { x e. A | ph } = B ) ) $=
      wph wps vx vy cA cB vy cv cB wcel vx ax-17 wps wps vx wal wi cB cA wcel
      wps vx ax-17 a1i reuuni2.1 reuuni2f $.
      $( [27-May-2006] $) $( [28-Mar-1997] $)
  $}

  ${
    $d x y A $.  $d y ph $.  $d x ps $.  $d x ch $.
    reuuni3.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    reuuni3.2 $e |- ( x = U. { y e. A | ps } -> ( ph <-> ch ) ) $.
    $( Derive the property ` ch ` of "the unique element in ` A ` such that
       ` ph ` " when expressed explicitly as ` U. { y e. A | ps } ` . $)
    reuuni3 $p |- ( E! x e. A ph -> ch ) $=
      wps vy cA crab cuni cA wcel wph vx cA wreu wch wph vx cA wreu wph vx cA
      crab cuni cA wps vy cA crab cuni wph vx cA reucl wph vx cA crab wps vy cA
      crab wph wps vx vy cA reuuni3.1 cbvrabv unieqi syl5eqelr wps vy cA crab
      cuni cA wcel wph vx cA wreu wa wch wph vx cA crab cuni wps vy cA crab
      cuni wceq wph vx cA crab wps vy cA crab wph wps vx vy cA reuuni3.1
      cbvrabv unieqi wph wch vx cA wps vy cA crab cuni reuuni3.2 reuuni2 mpbiri
      mpancom $.
      $( [13-Nov-2004] $) $( [11-Nov-2004] $)
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Derive the property of "the unique element in ` A ` such that
       ` ph ` " when expressed explicitly as ` U. { x e. A | ph } ` . $)
    reuuni4 $p |- ( E! x e. A ph -> [ U. { x e. A | ph } / x ] ph ) $=
      wph vx cA wreu wph vx cA crab cuni cA wcel wph vx wph vx cA crab cuni
      wsbc wph vx cA reucl wph vx cA wreu wph vx cA crab cuni cvv wcel wph vx
      wph vx cA crab cuni wsbc wph vx cA crab cuni cA wcel wph vx cA wreu wph
      vx cA wrex wph vx cA crab cuni cvv wcel wph vx wph vx cA crab cuni wsbc
      wi wph vx cA reurex wph vx cA wreu wph wph vx cA crab cuni cvv wcel wph
      vx wph vx cA crab cuni wsbc wi vx cA wph vx cA hbreu1 wph vx vy wph vx cA
      crab cuni cvv vx vy wph vx cA crab wph vx vy cA hbrab1 hbuni hbsbc1 wph
      vx cA crab cuni cvv wcel wph vx cA wreu vx cv cA wcel wph wph vx wph vx
      cA crab cuni wsbc wph vx cA wreu vx cv cA wcel wph wph vx wph vx cA crab
      cuni wsbc wi wi wi wph vx cA crab cuni cvv wcel vx cv cA wcel wph vx cA
      wreu wph wph vx wph vx cA crab cuni wsbc wi vx cv cA wcel wph vx cA wreu
      wa wph wph vx wph vx cA crab cuni wsbc vx cv cA wcel wph vx cA wreu wa
      wph wph vx cA crab cuni vx cv wceq wph wph vx wph vx cA crab cuni wsbc wb
      wph vx cA reuuni1 wph wph vx wph vx cA crab cuni wsbc wb vx cv wph vx cA
      crab cuni wph vx wph vx cA crab cuni sbceq1a eqcoms syl6bi ibd expcom a1i
      com4l r19.23ad mpd wph vx cA crab cuni cA elisset syl5 mpd $.
      $( [23-Nov-2004] $) $( [11-Nov-2004] $)

    $( Membership law for "the unique element in ` A ` such that ` ph ` ." $)
    reucl2 $p |- ( E! x e. A ph -> U. { x e. A | ph } e. { x e. A | ph } ) $=
      wph vx cA crab cuni wph vx cA crab wcel wph vx cA crab cuni cA wcel wph
      vx wph vx cA crab cuni wsbc wph vx cA wreu wph vx vy wph vx cA crab cuni
      cA vy cv cA wcel vx ax-17 elrabsf wph vx cA reucl wph vx cA reuuni4
      sylanbrc $.
      $( [12-Jun-2005] $) $( [11-Jun-2005] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ph $.
    $( Restriction of a unique element to a smaller class. $)
    reuuniss $p |- ( ( A C_ B /\ E. x e. A ph /\ E! x e. B ph ) ->
                U. { x e. A | ph } = U. { x e. B | ph } ) $=
      cA cB wss wph vx cA wrex wph vx cB wreu w3a wph vx cB crab cuni wph vx cA
      crab cuni cA cB wss wph vx cA wrex wph vx cB wreu w3a wph vx wph vx cA
      crab cuni wsbc wph vx cB crab cuni wph vx cA crab cuni wceq cA cB wss wph
      vx cA wrex wph vx cB wreu w3a wph vx cA wreu wph vx wph vx cA crab cuni
      wsbc wph vx cA cB reuss wph vx cA reuuni4 syl wph vx cA crab cuni cB wcel
      wph vx cB wreu wph vx wph vx cA crab cuni wsbc wph vx cB crab cuni wph vx
      cA crab cuni wceq wb cA cB wss wph vx cA wrex wph vx cB wreu w3a wph wph
      vx wph vx cA crab cuni wsbc vx vy cB wph vx cA crab cuni vx vy wph vx cA
      crab wph vx vy cA hbrab1 hbuni wph vx vy wph vx cA crab cuni cB vx vy wph
      vx cA crab wph vx vy cA hbrab1 hbuni hbsbc1g wph vx wph vx cA crab cuni
      sbceq1a reuuni2f cA cB wss wph vx cA wrex wph vx cB wreu w3a wph vx cA
      crab cuni cA wcel wph vx cA crab cuni cB wcel cA cB wss wph vx cA wrex
      wph vx cB wreu w3a wph vx cA wreu wph vx cA crab cuni cA wcel wph vx cA
      cB reuss wph vx cA reucl syl cA cB wss wph vx cA wrex wph vx cA crab cuni
      cA wcel wph vx cA crab cuni cB wcel wi wph vx cB wreu cA cB wph vx cA
      crab cuni ssel 3ad2ant1 mpd cA cB wss wph vx cA wrex wph vx cB wreu
      3simp3 sylanc mpbid eqcomd $.
      $( [21-Nov-2005] $) $( [19-Oct-2005] $)

    $( Restriction of a unique element to a smaller class. $)
    mouniss $p |- ( ( A C_ B /\ E. x e. A ph /\ E* x ( x e. B /\ ph ) ) ->
                U. { x e. A | ph } = U. { x e. B | ph } ) $=
      cA cB wss wph vx cA wrex vx cv cB wcel wph wa vx wmo wph vx cA crab cuni
      wph vx cB crab cuni wceq cA cB wss wph vx cA wrex wa vx cv cB wcel wph wa
      vx wmo wph vx cB wreu wph vx cA crab cuni wph vx cB crab cuni wceq cA cB
      wss wph vx cA wrex wa vx cv cB wcel wph wa vx wmo wa wph vx cB wrex vx cv
      cB wcel wph wa vx wmo wa wph vx cB wreu cA cB wss wph vx cA wrex wa wph
      vx cB wrex vx cv cB wcel wph wa vx wmo cA cB wss wph vx cA wrex wph vx cB
      wrex cA cB wss wph wph vx cA cB cA cB wss vx cv cA wcel vx cv cB wcel wph
      cA cB vx cv ssel anim1d r19.22dv2 imp anim1i wph vx cB reu5 sylibr cA cB
      wss wph vx cA wrex wph vx cB wreu wph vx cA crab cuni wph vx cB crab cuni
      wceq wph vx cA cB reuuniss 3expa syldan 3impa $.
      $( [26-Feb-2006] $) $( [19-Feb-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ph $.  $d y ps $.
    $( Restriction of a unique element to a smaller class. $)
    reuuniss2 $p |- ( ( ( A C_ B /\ A. x e. A ( ph -> ps ) ) /\ ( E. x e. A ph
           /\ E! x e. B ps ) ) -> U. { x e. A | ph } = U. { x e. B | ps } ) $=
      cA cB wss wph wps wi vx cA wral wa wph vx cA wrex wps vx cB wreu wa wa
      wps vx cB crab cuni wph vx cA crab cuni cA cB wss wph wps wi vx cA wral
      wa wph vx cA wrex wps vx cB wreu wa wa wps vx wph vx cA crab cuni wsbc
      wps vx cB crab cuni wph vx cA crab cuni wceq wph vx cA wreu wph wps wi vx
      cA wral wps vx wph vx cA crab cuni wsbc cA cB wss wph wps wi vx cA wral
      wa wph vx cA wrex wps vx cB wreu wa wa wph vx cA wreu wph wps wi vx cA
      wral wph vx wph vx cA crab cuni wsbc wps vx wph vx cA crab cuni wsbc wph
      vx cA reuuni4 wph vx cA wreu wph vx cA crab cuni cA wcel wph wps wi vx cA
      wral wph vx wph vx cA crab cuni wsbc wps vx wph vx cA crab cuni wsbc wi
      wi wph vx cA reucl wph vx cA crab cuni cA wcel wph wps wi vx cA wral wph
      wps wi vx wph vx cA crab cuni wsbc wph vx wph vx cA crab cuni wsbc wps vx
      wph vx cA crab cuni wsbc wi wph wps wi vx wph vx cA crab cuni cA ra4sbc
      wph wps vx wph vx cA crab cuni cA sbcimg sylibd syl mpid wph wps vx cA cB
      reuss2 cA cB wss wph wps wi vx cA wral wph vx cA wrex wps vx cB wreu wa
      simplr sylc wph vx cA crab cuni cB wcel wps vx cB wreu wps vx wph vx cA
      crab cuni wsbc wps vx cB crab cuni wph vx cA crab cuni wceq wb cA cB wss
      wph wps wi vx cA wral wa wph vx cA wrex wps vx cB wreu wa wa wps wps vx
      wph vx cA crab cuni wsbc vx vy cB wph vx cA crab cuni vx vy wph vx cA
      crab wph vx vy cA hbrab1 hbuni wps vx vy wph vx cA crab cuni cB vx vy wph
      vx cA crab wph vx vy cA hbrab1 hbuni hbsbc1g wps vx wph vx cA crab cuni
      sbceq1a reuuni2f cA cB wss wph wps wi vx cA wral wa wph vx cA wrex wps vx
      cB wreu wa wa wph vx cA crab cuni cA wcel wph vx cA crab cuni cB wcel cA
      cB wss wph wps wi vx cA wral wa wph vx cA wrex wps vx cB wreu wa wa wph
      vx cA wreu wph vx cA crab cuni cA wcel wph wps vx cA cB reuss2 wph vx cA
      reucl syl cA cB wss wph vx cA crab cuni cA wcel wph vx cA crab cuni cB
      wcel wi wph wps wi vx cA wral wph vx cA wrex wps vx cB wreu wa cA cB wph
      vx cA crab cuni ssel ad2antrr mpd cA cB wss wph wps wi vx cA wral wa wph
      vx cA wrex wps vx cB wreu simprr sylanc mpbid eqcomd $.
      $( [8-Dec-2005] $) $( [20-Oct-2005] $)
  $}

  ${
    $d y z A $.  $d y z ph $.  $d x y z $.
    $( A way to express restricted existential uniqueness of a wff:  its
       restricted class abstraction is a singleton. $)
    reusn $p |- ( E! x e. A ph <-> E. y { x e. A | ph } = { y } ) $=
      wph vx cA wreu vx cv cA wcel wph wa vx weu vx cv cA wcel wph wa vx cab vx
      cv csn wceq vx wex wph vx cA crab vy cv csn wceq vy wex wph vx cA df-reu
      vx cv cA wcel wph wa vx euabsn vx cv cA wcel wph wa vx cab vx cv csn wceq
      vx wex wph vx cA crab vx cv csn wceq vx wex wph vx cA crab vy cv csn wceq
      vy wex wph vx cA crab vx cv csn wceq vx cv cA wcel wph wa vx cab vx cv
      csn wceq vx wph vx cA crab vx cv cA wcel wph wa vx cab vx cv csn wph vx
      cA df-rab eqeq1i exbii wph vx cA crab vx cv csn wceq wph vx cA crab vy cv
      csn wceq vx vy wph vx cA crab vx cv csn wceq vy ax-17 vx vz vz wph vx cA
      crab vy cv csn wph vx vz cA hbrab1 vz cv vy cv csn wcel vx ax-17 hbeq vx
      cv vy cv wceq vx cv csn vy cv csn wph vx cA crab vx cv vy cv sneq eqeq2d
      cbvex bitr3i 3bitri $.
      $( [30-May-2006] $) $( [30-May-2006] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y ph $.  $d x y $.
    reusni.1 $e |- B e. _V $.
    $( Restricted existential uniqueness determined by a singleton. $)
    reusni $p |- ( { x e. A | ph } = { B } -> E! x e. A ph ) $=
      wph vx cA crab cB csn wceq wph vx cA crab vy cv csn wceq vy wex wph vx cA
      wreu wph vx cA crab vy cv csn wceq wph vx cA crab cB csn wceq vy cB
      reusni.1 vy cv cB wceq vy cv csn cB csn wph vx cA crab vy cv cB sneq
      eqeq2d cla4ev wph vx vy cA reusn sylibr $.
      $( [19-Jun-2006] $) $( [29-May-2006] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    rabsnt.1 $e |- B e. _V $.
    rabsnt.2 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Truth implied by equality of a restricted class abstraction and a
       singleton. $)
    rabsnt $p |- ( { x e. A | ph } = { B } -> ps ) $=
      cB cA wcel wph vx cA wreu wa wph vx cA crab cuni cB wceq wps wph vx cA
      crab cB csn wceq cB cA wcel wph vx cA wreu wa wps wph vx cA crab cuni cB
      wceq wph wps vx cA cB rabsnt.2 reuuni2 biimprd wph vx cA crab cB csn wceq
      cB cA wcel wph vx cA wreu wph vx cA crab cB csn wceq cB csn cA wss cB cA
      wcel wph vx cA crab cB csn wceq wph vx cA crab cA wss cB csn cA wss wph
      vx cA ssrab2 wph vx cA crab cB csn cA sseq1 mpbii cB cA rabsnt.1 snss
      sylibr wph vx cA cB rabsnt.1 reusni jca wph vx cA crab cB csn wceq wph vx
      cA crab cuni cB csn cuni cB wph vx cA crab cB csn unieq cB rabsnt.1 unisn
      syl6eq sylc $.
      $( [7-Dec-2006] $) $( [29-May-2006] $)
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( A restricted class abstraction with a unique member can be expressed as
       a singleton. $)
    reuunisn $p |- ( E! x e. A ph ->
                   { x e. A | ph } = { U. { x e. A | ph } } ) $=
      wph vx cA wreu wph vx cA crab vy cv csn wceq vy wex wph vx cA crab wph vx
      cA crab cuni csn wceq wph vx vy cA reusn wph vx cA crab vy cv csn wceq
      wph vx cA crab wph vx cA crab cuni csn wceq vy wph vx cA crab vy cv csn
      wceq wph vx cA crab cuni csn vy cv csn wceq wph vx cA crab wph vx cA crab
      cuni csn wceq wph vx cA crab vy cv csn wceq wph vx cA crab cuni vy cv wph
      vx cA crab vy cv csn wceq wph vx cA crab cuni vy cv csn cuni vy cv wph vx
      cA crab vy cv csn unieq vy cv vy visset unisn syl6eq sneqd wph vx cA crab
      wph vx cA crab cuni csn vy cv csn eqtr3 mpdan 19.23aiv sylbi $.
      $( [24-Jun-2006] $) $( [30-May-2006] $)
  $}

  ${
    $d x y z $.  $d A y z $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` . $)
    eualeq $p |- ( E! y A. x y = A <-> E. y A. x y = A ) $=
      vy cv cA wceq vx wal vy weu vy cv cA wceq vx wal vy wex vy cv cA wceq vx
      wal vz cv cA wceq vx wal wa vy cv vz cv wceq wi vz wal vy wal vy cv cA
      wceq vx wal vz cv cA wceq vx wal vy vz vy cv vz cv wceq vy cv cA wceq vz
      cv cA wceq vx vy cv vz cv cA eqeq1 albidv eu4 vy cv cA wceq vx wal vz cv
      cA wceq vx wal wa vy cv vz cv wceq wi vy vz vy cv cA wceq vz cv cA wceq
      vy cv vz cv wceq vy cv cA wceq vx wal vz cv cA wceq vx wal vy cv vz cv cA
      eqtr3 vy cv cA wceq vx ax-4 vz cv cA wceq vx ax-4 syl2an gen2 mpbiran2 $.
      $( [19-Oct-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    $d x y z w $.  $d A y z w $.
    $( Even if ` x ` is free in ` A ` , it is effectively bound when
       ` A ( x ) ` is single-valued. $)
    eualeqhb $p |- ( E! y A. x y = A -> ( y = A -> A. x y = A ) ) $=
      vy cv cA wceq vx wal vy weu vy cv cA wceq vx wal vy cvv wreu vy cv cA
      wceq vy cv cA wceq vx wal wi vy cv cA wceq vx wal vy weu vy cv cvv wcel
      vy cv cA wceq vx wal wa vy weu vy cv cA wceq vx wal vy cvv wreu vy cv cA
      wceq vx wal vy cv cvv wcel vy cv cA wceq vx wal wa vy vy cv cvv wcel vy
      cv cA wceq vx wal vy visset biantrur eubii vy cv cA wceq vx wal vy cvv
      df-reu bitr4i vy cv cA wceq vx wal vy cvv wreu vy cv cA wceq vz cv cA
      wceq vx wal vz cvv crab cuni cA wceq vy cv cA wceq vx wal vy cv cA wceq
      vx wal vy cvv wreu vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx vy cv
      cA wceq vx wal vz cv cA wceq vx wal vz cv cA wceq vx wal vz cvv crab cuni
      cA wceq vx wal vy vz cvv vy cv vz cv wceq vy cv cA wceq vz cv cA wceq vx
      vy cv vz cv cA eqeq1 albidv vy cv vz cv cA wceq vx wal vz cvv crab cuni
      wceq vy cv cA wceq vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx vx vw
      vw vy cv vz cv cA wceq vx wal vz cvv crab cuni vw cv vy cv wcel vx ax-17
      vx vw vz cv cA wceq vx wal vz cvv crab vz cv cA wceq vx wal vx vz vw cvv
      vz cv cA wceq vx hba1 vw cv cvv wcel vx ax-17 hbrab hbuni hbeq vy cv vz
      cv cA wceq vx wal vz cvv crab cuni cA eqeq1 albid reuuni3 19.21bi vy cv
      cA wceq vx wal vy cvv wreu vy cv vz cv cA wceq vx wal vz cvv crab cuni
      wceq vy cv cA wceq vx wal vy cv cA wceq vz cv cA wceq vx wal vz cvv crab
      cuni cA wceq wa vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA
      wceq vx wal vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx wal vy cv cA
      wceq vx wal vy cvv wreu vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq
      vy cv cA wceq vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx vx vw vw
      vy cv vz cv cA wceq vx wal vz cvv crab cuni vw cv vy cv wcel vx ax-17 vx
      vw vz cv cA wceq vx wal vz cvv crab vz cv cA wceq vx wal vx vz vw cvv vz
      cv cA wceq vx hba1 vw cv cvv wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv
      cA wceq vx wal vz cvv crab cuni cA eqeq1 albid vy cv cA wceq vx wal vz cv
      cA wceq vx wal vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx wal vy vz
      cvv vy cv vz cv wceq vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1
      albidv vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA wceq vz
      cv cA wceq vx wal vz cvv crab cuni cA wceq vx vx vw vw vy cv vz cv cA
      wceq vx wal vz cvv crab cuni vw cv vy cv wcel vx ax-17 vx vw vz cv cA
      wceq vx wal vz cvv crab vz cv cA wceq vx wal vx vz vw cvv vz cv cA wceq
      vx hba1 vw cv cvv wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv cA wceq vx
      wal vz cvv crab cuni cA eqeq1 albid reuuni3 syl5cbir vy cv vz cv cA wceq
      vx wal vz cvv crab cuni cA eqtr3 syl5 mpan2d sylbi $.
      $( [3-Nov-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    $d x y $.  $d A y $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` . $)
    eualexeq $p |- ( E! y A. x y = A -> E! y E. x y = A ) $=
      vy cv cA wceq vx wal vy weu vy cv cA wceq vx wex vy weu vy cv cA wceq vx
      wal vy weu vy cv cA wceq vx wex vy cv cA wceq vx wal vy vy cv cA wceq vx
      wal vy hbeu1 vy cv cA wceq vx wal vy weu vy cv cA wceq vx wex vy cv cA
      wceq vx wal vy cv cA wceq vx wal vy weu vy cv cA wceq vy cv cA wceq vx
      wal vx vy cv cA wceq vx wal vx vy vy cv cA wceq vx hba1 hbeu vy cv cA
      wceq vx hba1 vx vy cA eualeqhb 19.23ad vy cv cA wceq vx vx 19.2 impbid1
      eubid ibir $.
      $( [3-Nov-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    $d x y z v w $.  $d A y z w v $.
    euexeqOLD.1 $e |- A e. _V $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` . $)
    euexeqOLD $p |- ( E! y E. x y = A <-> E! y A. x y = A ) $=
      vy cv cA wceq vx wex vy weu vy cv cA wceq vx wal vy weu vy cv cA wceq vx
      wex vy weu vy cv cA wceq vx wal vy wex vy cv cA wceq vx wal vy weu vz cv
      cA wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx wal vy cv cA wceq vx wal vy wex vy cv cA wceq vx wex vy
      weu vy cv cA wceq vx wal vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx
      wal vy vz cv cA wceq vx wex vz cvv crab cuni cvv vy cv vz cv cA wceq vx
      wex vz cvv crab cuni wceq vy cv cA wceq vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx vx vv vv vy cv vz cv cA wceq vx wex vz cvv crab cuni vv
      cv vy cv wcel vx ax-17 vx vv vz cv cA wceq vx wex vz cvv crab vz cv cA
      wceq vx wex vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv wcel vx ax-17
      hbrab hbuni hbeq vy cv vz cv cA wceq vx wex vz cvv crab cuni cA eqeq1
      albid cla4egv vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz cvv
      wreu vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex
      vz weu vz cv cvv wcel vz cv cA wceq vx wex wa vz weu vy cv cA wceq vx wex
      vy weu vz cv cA wceq vx wex vz cvv wreu vz cv cA wceq vx wex vz cv cvv
      wcel vz cv cA wceq vx wex wa vz vz cv cvv wcel vz cv cA wceq vx wex vz
      visset biantrur eubii vy cv cA wceq vx wex vz cv cA wceq vx wex vy vz vy
      cv cA wceq vx wex vz ax-17 vz cv cA wceq vx wex vy ax-17 vy cv vz cv wceq
      vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1 exbidv cbveu vz cv cA
      wceq vx wex vz cvv df-reu 3bitr4i vz cv cA wceq vx wex vz cvv reucl sylbi
      vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz cvv crab cuni cA wceq
      vx vy cv cA wceq vx wex vx vy vy cv cA wceq vx hbe1 hbeu vy cv cA wceq vx
      wex vy weu cA cA wceq vz cv cA wceq vx wex vz cvv crab cuni cA wceq cA
      eqid vy cv cA wceq vx wex vy weu vw cv cA wceq vz cv cA wceq vx wex vz
      cvv crab cuni vw cv wceq wi vw wal vx wal vw cv cA wceq vz cv cA wceq vx
      wex vz cvv crab cuni vw cv wceq wi vw wal cA cA wceq vz cv cA wceq vx wex
      vz cvv crab cuni cA wceq wi vy cv cA wceq vx wex vy weu vw cv cA wceq vx
      wex vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vw cv cA
      wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vx wal vy
      cv cA wceq vx wex vy weu vw cv cA wceq vx wex vz cv cA wceq vx wex vz cvv
      crab cuni vw cv wceq wi vw wal vz cv cA wceq vx wex vz cvv crab cuni cA
      wceq vx wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz cvv crab cuni
      vw cv wceq wi vw wal vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz
      cvv crab cuni cvv wcel vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx
      wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz cvv crab cuni vw cv
      wceq wi vw wal vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz cvv
      wreu vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex
      vz weu vz cv cvv wcel vz cv cA wceq vx wex wa vz weu vy cv cA wceq vx wex
      vy weu vz cv cA wceq vx wex vz cvv wreu vz cv cA wceq vx wex vz cv cvv
      wcel vz cv cA wceq vx wex wa vz vz cv cvv wcel vz cv cA wceq vx wex vz
      visset biantrur eubii vy cv cA wceq vx wex vz cv cA wceq vx wex vy vz vy
      cv cA wceq vx wex vz ax-17 vz cv cA wceq vx wex vy ax-17 vy cv vz cv wceq
      vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1 exbidv cbveu vz cv cA
      wceq vx wex vz cvv df-reu 3bitr4i vz cv cA wceq vx wex vz cvv reucl sylbi
      vy cv cA wceq vx wex vy weu vy cv cA wceq vx wex vy wex vy cv cA wceq vx
      wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vw wal vy wal wa vz cv cA
      wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz cvv
      crab cuni vw cv wceq wi vw wal wi vy cv cA wceq vx wex vw cv cA wceq vx
      wex vy vw vy cv vw cv wceq vy cv cA wceq vw cv cA wceq vx vy cv vw cv cA
      eqeq1 exbidv eu4 vy cv cA wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv
      wceq wi vw wal vy wal vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vz
      cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa
      vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal wi vy cv cA
      wceq vx wex vy wex vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vy cv
      cA wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vw wal vy wal
      vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex
      wa vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vy cv cA
      wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vw wal vz cv cA
      wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv
      cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vy vz cv cA wceq vx
      wex vz cvv crab cuni cvv vy cv vz cv cA wceq vx wex vz cvv crab cuni wceq
      vy cv cA wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vz cv cA
      wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv
      cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vy cv vz cv cA wceq vx
      wex vz cvv crab cuni wceq vy cv cA wceq vx wex vw cv cA wceq vx wex wa vz
      cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa
      vy cv vw cv wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq vy cv
      vz cv cA wceq vx wex vz cvv crab cuni wceq vy cv cA wceq vx wex vz cv cA
      wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex vy cv vz
      cv cA wceq vx wex vz cvv crab cuni wceq vy cv cA wceq vz cv cA wceq vx
      wex vz cvv crab cuni cA wceq vx vx vv vv vy cv vz cv cA wceq vx wex vz
      cvv crab cuni vv cv vy cv wcel vx ax-17 vx vv vz cv cA wceq vx wex vz cvv
      crab vz cv cA wceq vx wex vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv
      wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv cA wceq vx wex vz cvv crab
      cuni cA eqeq1 exbid anbi1d vy cv vz cv cA wceq vx wex vz cvv crab cuni vw
      cv eqeq1 imbi12d albidv cla4gv com12 adantl sylbi mpd vy cv cA wceq vx
      wex vy weu vw cv cA wceq vx wex vz cv cA wceq vx wex vz cvv crab cuni vw
      cv wceq wi vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA
      wceq vx wex wa vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vy
      cv cA wceq vx wex vy weu vw cv cA wceq vx wex vz cv cA wceq vx wex vz cvv
      crab cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz
      cvv crab cuni vw cv wceq vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex
      vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex vy cv cA wceq vx wex
      vy weu vy cv cA wceq vx wex vy cvv wreu vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx wex vy cv cA wceq vx wex vy weu vy cv cvv wcel vy cv cA
      wceq vx wex wa vy weu vy cv cA wceq vx wex vy cvv wreu vy cv cA wceq vx
      wex vy cv cvv wcel vy cv cA wceq vx wex wa vy vy cv cvv wcel vy cv cA
      wceq vx wex vy visset biantrur eubii vy cv cA wceq vx wex vy cvv df-reu
      bitr4i vy cv cA wceq vx wex vz cv cA wceq vx wex vz cv cA wceq vx wex vz
      cvv crab cuni cA wceq vx wex vy vz cvv vy cv vz cv wceq vy cv cA wceq vz
      cv cA wceq vx vy cv vz cv cA eqeq1 exbidv vy cv vz cv cA wceq vx wex vz
      cvv crab cuni wceq vy cv cA wceq vz cv cA wceq vx wex vz cvv crab cuni cA
      wceq vx vx vv vv vy cv vz cv cA wceq vx wex vz cvv crab cuni vv cv vy cv
      wcel vx ax-17 vx vv vz cv cA wceq vx wex vz cvv crab vz cv cA wceq vx wex
      vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv wcel vx ax-17 hbrab hbuni
      hbeq vy cv vz cv cA wceq vx wex vz cvv crab cuni cA eqeq1 exbid reuuni3
      sylbi biantrurd imbi1d albidv mpbird vw cv cA wceq vx wex vz cv cA wceq
      vx wex vz cvv crab cuni vw cv wceq wi vw wal vw cv cA wceq vz cv cA wceq
      vx wex vz cvv crab cuni vw cv wceq wi vx wal vw wal vw cv cA wceq vz cv
      cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vx wal vw cv cA wceq
      vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vx wal vw cv cA wceq
      vx wex vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vw cv cA
      wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq vx vx vv vv vz cv
      cA wceq vx wex vz cvv crab cuni vw cv vx vv vz cv cA wceq vx wex vz cvv
      crab vz cv cA wceq vx wex vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv
      wcel vx ax-17 hbrab hbuni vv cv vw cv wcel vx ax-17 hbeq 19.23 albii vw
      cv cA wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vx
      alcom bitr3i sylib vw cv cA wceq vz cv cA wceq vx wex vz cvv crab cuni vw
      cv wceq wi vw wal vx ax-4 vw cv cA wceq vz cv cA wceq vx wex vz cvv crab
      cuni vw cv wceq wi cA cA wceq vz cv cA wceq vx wex vz cvv crab cuni cA
      wceq wi vw cA euexeqOLD.1 vw cv cA wceq vw cv cA wceq cA cA wceq vz cv cA
      wceq vx wex vz cvv crab cuni vw cv wceq vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vw cv cA cA eqeq1 vw cv cA vz cv cA wceq vx wex vz cvv crab
      cuni eqeq2 imbi12d cla4v 3syl mpi 19.21ai sylc vy cv cA wceq vx wal vy
      weu vy cv cA wceq vx wal vy wex vy cv cA wceq vx wal vy weu vy cv cA wceq
      vx wal vy wex vy cv cA wceq vx wal vz cv cA wceq vx wal wa vy cv vz cv
      wceq wi vz wal vy wal vy cv cA wceq vx wal vz cv cA wceq vx wal vy vz vy
      cv vz cv wceq vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1 albidv
      eu4 vy cv cA wceq vx wal vz cv cA wceq vx wal wa vy cv vz cv wceq wi vy
      vz vy cv cA wceq vz cv cA wceq vy cv vz cv wceq vy cv cA wceq vx wal vz
      cv cA wceq vx wal vy cv vz cv cA eqtr3 vy cv cA wceq vx ax-4 vz cv cA
      wceq vx ax-4 syl2an gen2 mpbiran2 bicomi sylib vy cv cA wceq vx wal vy
      weu vy cv cA wceq vx wex vy weu vy cv cA wceq vx wal vy weu vy cv cA wceq
      vx wex vy cv cA wceq vx wal vy vy cv cA wceq vx wal vy hbeu1 vy cv cA
      wceq vx wal vy weu vy cv cA wceq vx wex vy cv cA wceq vx wal vy cv cA
      wceq vx wal vy weu vy cv cA wceq vy cv cA wceq vx wal vx vy cv cA wceq vx
      wal vx vy vy cv cA wceq vx hba1 hbeu vy cv cA wceq vx hba1 vy cv cA wceq
      vx wal vy weu vy cv cA wceq vx wal vy cvv wreu vy cv cA wceq vy cv cA
      wceq vx wal wi vy cv cA wceq vx wal vy weu vy cv cvv wcel vy cv cA wceq
      vx wal wa vy weu vy cv cA wceq vx wal vy cvv wreu vy cv cA wceq vx wal vy
      cv cvv wcel vy cv cA wceq vx wal wa vy vy cv cvv wcel vy cv cA wceq vx
      wal vy visset biantrur eubii vy cv cA wceq vx wal vy cvv df-reu bitr4i vy
      cv cA wceq vx wal vy cvv wreu vy cv cA wceq vz cv cA wceq vx wal vz cvv
      crab cuni cA wceq vy cv cA wceq vx wal vy cv cA wceq vx wal vy cvv wreu
      vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx vy cv cA wceq vx wal vz
      cv cA wceq vx wal vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx wal vy
      vz cvv vy cv vz cv wceq vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA
      eqeq1 albidv vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA
      wceq vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx vx vv vv vy cv vz
      cv cA wceq vx wal vz cvv crab cuni vv cv vy cv wcel vx ax-17 vx vv vz cv
      cA wceq vx wal vz cvv crab vz cv cA wceq vx wal vx vz vv cvv vz cv cA
      wceq vx hba1 vv cv cvv wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv cA wceq
      vx wal vz cvv crab cuni cA eqeq1 albid reuuni3 19.21bi vy cv cA wceq vx
      wal vy cvv wreu vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA
      wceq vx wal vy cv cA wceq vz cv cA wceq vx wal vz cvv crab cuni cA wceq
      wa vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA wceq vx wal
      vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx wal vy cv cA wceq vx wal
      vy cvv wreu vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA
      wceq vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx vx vv vv vy cv vz
      cv cA wceq vx wal vz cvv crab cuni vv cv vy cv wcel vx ax-17 vx vv vz cv
      cA wceq vx wal vz cvv crab vz cv cA wceq vx wal vx vz vv cvv vz cv cA
      wceq vx hba1 vv cv cvv wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv cA wceq
      vx wal vz cvv crab cuni cA eqeq1 albid vy cv cA wceq vx wal vz cv cA wceq
      vx wal vz cv cA wceq vx wal vz cvv crab cuni cA wceq vx wal vy vz cvv vy
      cv vz cv wceq vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1 albidv
      vy cv vz cv cA wceq vx wal vz cvv crab cuni wceq vy cv cA wceq vz cv cA
      wceq vx wal vz cvv crab cuni cA wceq vx vx vv vv vy cv vz cv cA wceq vx
      wal vz cvv crab cuni vv cv vy cv wcel vx ax-17 vx vv vz cv cA wceq vx wal
      vz cvv crab vz cv cA wceq vx wal vx vz vv cvv vz cv cA wceq vx hba1 vv cv
      cvv wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv cA wceq vx wal vz cvv crab
      cuni cA eqeq1 albid reuuni3 syl5cbir vy cv vz cv cA wceq vx wal vz cvv
      crab cuni cA eqtr3 syl5 mpan2d sylbi 19.23ad vy cv cA wceq vx vx 19.2
      impbid1 eubid ibir impbii $.
      $( [15-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y z v w $.  $d A y z w v $.
    euexaleq.1 $e |- A e. _V $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` . $)
    euexaleq $p |- ( E! y E. x y = A <-> E! y A. x y = A ) $=
      vy cv cA wceq vx wex vy weu vy cv cA wceq vx wal vy weu vy cv cA wceq vx
      wex vy weu vy cv cA wceq vx wal vy wex vy cv cA wceq vx wal vy weu vz cv
      cA wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx wal vy cv cA wceq vx wal vy wex vy cv cA wceq vx wex vy
      weu vy cv cA wceq vx wal vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx
      wal vy vz cv cA wceq vx wex vz cvv crab cuni cvv vy cv vz cv cA wceq vx
      wex vz cvv crab cuni wceq vy cv cA wceq vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx vx vv vv vy cv vz cv cA wceq vx wex vz cvv crab cuni vv
      cv vy cv wcel vx ax-17 vx vv vz cv cA wceq vx wex vz cvv crab vz cv cA
      wceq vx wex vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv wcel vx ax-17
      hbrab hbuni hbeq vy cv vz cv cA wceq vx wex vz cvv crab cuni cA eqeq1
      albid cla4egv vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz cvv
      wreu vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex
      vz weu vz cv cvv wcel vz cv cA wceq vx wex wa vz weu vy cv cA wceq vx wex
      vy weu vz cv cA wceq vx wex vz cvv wreu vz cv cA wceq vx wex vz cv cvv
      wcel vz cv cA wceq vx wex wa vz vz cv cvv wcel vz cv cA wceq vx wex vz
      visset biantrur eubii vy cv cA wceq vx wex vz cv cA wceq vx wex vy vz vy
      cv cA wceq vx wex vz ax-17 vz cv cA wceq vx wex vy ax-17 vy cv vz cv wceq
      vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1 exbidv cbveu vz cv cA
      wceq vx wex vz cvv df-reu 3bitr4i vz cv cA wceq vx wex vz cvv reucl sylbi
      vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz cvv crab cuni cA wceq
      vx vy cv cA wceq vx wex vx vy vy cv cA wceq vx hbe1 hbeu vy cv cA wceq vx
      wex vy weu cA cA wceq vz cv cA wceq vx wex vz cvv crab cuni cA wceq cA
      eqid vy cv cA wceq vx wex vy weu vw cv cA wceq vz cv cA wceq vx wex vz
      cvv crab cuni vw cv wceq wi vw wal vx wal vw cv cA wceq vz cv cA wceq vx
      wex vz cvv crab cuni vw cv wceq wi vw wal cA cA wceq vz cv cA wceq vx wex
      vz cvv crab cuni cA wceq wi vy cv cA wceq vx wex vy weu vw cv cA wceq vx
      wex vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vw cv cA
      wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vx wal vy
      cv cA wceq vx wex vy weu vw cv cA wceq vx wex vz cv cA wceq vx wex vz cvv
      crab cuni vw cv wceq wi vw wal vz cv cA wceq vx wex vz cvv crab cuni cA
      wceq vx wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz cvv crab cuni
      vw cv wceq wi vw wal vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz
      cvv crab cuni cvv wcel vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx
      wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz cvv crab cuni vw cv
      wceq wi vw wal vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex vz cvv
      wreu vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex
      vz weu vz cv cvv wcel vz cv cA wceq vx wex wa vz weu vy cv cA wceq vx wex
      vy weu vz cv cA wceq vx wex vz cvv wreu vz cv cA wceq vx wex vz cv cvv
      wcel vz cv cA wceq vx wex wa vz vz cv cvv wcel vz cv cA wceq vx wex vz
      visset biantrur eubii vy cv cA wceq vx wex vz cv cA wceq vx wex vy vz vy
      cv cA wceq vx wex vz ax-17 vz cv cA wceq vx wex vy ax-17 vy cv vz cv wceq
      vy cv cA wceq vz cv cA wceq vx vy cv vz cv cA eqeq1 exbidv cbveu vz cv cA
      wceq vx wex vz cvv df-reu 3bitr4i vz cv cA wceq vx wex vz cvv reucl sylbi
      vy cv cA wceq vx wex vy weu vy cv cA wceq vx wex vy wex vy cv cA wceq vx
      wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vw wal vy wal wa vz cv cA
      wceq vx wex vz cvv crab cuni cvv wcel vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz cvv
      crab cuni vw cv wceq wi vw wal wi vy cv cA wceq vx wex vw cv cA wceq vx
      wex vy vw vy cv vw cv wceq vy cv cA wceq vw cv cA wceq vx vy cv vw cv cA
      eqeq1 exbidv eu4 vy cv cA wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv
      wceq wi vw wal vy wal vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vz
      cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa
      vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal wi vy cv cA
      wceq vx wex vy wex vz cv cA wceq vx wex vz cvv crab cuni cvv wcel vy cv
      cA wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vw wal vy wal
      vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex
      wa vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vy cv cA
      wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vw wal vz cv cA
      wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv
      cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vy vz cv cA wceq vx
      wex vz cvv crab cuni cvv vy cv vz cv cA wceq vx wex vz cvv crab cuni wceq
      vy cv cA wceq vx wex vw cv cA wceq vx wex wa vy cv vw cv wceq wi vz cv cA
      wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv
      cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vy cv vz cv cA wceq vx
      wex vz cvv crab cuni wceq vy cv cA wceq vx wex vw cv cA wceq vx wex wa vz
      cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex wa
      vy cv vw cv wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq vy cv
      vz cv cA wceq vx wex vz cvv crab cuni wceq vy cv cA wceq vx wex vz cv cA
      wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex vy cv vz
      cv cA wceq vx wex vz cvv crab cuni wceq vy cv cA wceq vz cv cA wceq vx
      wex vz cvv crab cuni cA wceq vx vx vv vv vy cv vz cv cA wceq vx wex vz
      cvv crab cuni vv cv vy cv wcel vx ax-17 vx vv vz cv cA wceq vx wex vz cvv
      crab vz cv cA wceq vx wex vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv
      wcel vx ax-17 hbrab hbuni hbeq vy cv vz cv cA wceq vx wex vz cvv crab
      cuni cA eqeq1 exbid anbi1d vy cv vz cv cA wceq vx wex vz cvv crab cuni vw
      cv eqeq1 imbi12d albidv cla4gv com12 adantl sylbi mpd vy cv cA wceq vx
      wex vy weu vw cv cA wceq vx wex vz cv cA wceq vx wex vz cvv crab cuni vw
      cv wceq wi vz cv cA wceq vx wex vz cvv crab cuni cA wceq vx wex vw cv cA
      wceq vx wex wa vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vy
      cv cA wceq vx wex vy weu vw cv cA wceq vx wex vz cv cA wceq vx wex vz cvv
      crab cuni cA wceq vx wex vw cv cA wceq vx wex wa vz cv cA wceq vx wex vz
      cvv crab cuni vw cv wceq vy cv cA wceq vx wex vy weu vz cv cA wceq vx wex
      vz cvv crab cuni cA wceq vx wex vw cv cA wceq vx wex vy cv cA wceq vx wex
      vy weu vy cv cA wceq vx wex vy cvv wreu vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vx wex vy cv cA wceq vx wex vy weu vy cv cvv wcel vy cv cA
      wceq vx wex wa vy weu vy cv cA wceq vx wex vy cvv wreu vy cv cA wceq vx
      wex vy cv cvv wcel vy cv cA wceq vx wex wa vy vy cv cvv wcel vy cv cA
      wceq vx wex vy visset biantrur eubii vy cv cA wceq vx wex vy cvv df-reu
      bitr4i vy cv cA wceq vx wex vz cv cA wceq vx wex vz cv cA wceq vx wex vz
      cvv crab cuni cA wceq vx wex vy vz cvv vy cv vz cv wceq vy cv cA wceq vz
      cv cA wceq vx vy cv vz cv cA eqeq1 exbidv vy cv vz cv cA wceq vx wex vz
      cvv crab cuni wceq vy cv cA wceq vz cv cA wceq vx wex vz cvv crab cuni cA
      wceq vx vx vv vv vy cv vz cv cA wceq vx wex vz cvv crab cuni vv cv vy cv
      wcel vx ax-17 vx vv vz cv cA wceq vx wex vz cvv crab vz cv cA wceq vx wex
      vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv wcel vx ax-17 hbrab hbuni
      hbeq vy cv vz cv cA wceq vx wex vz cvv crab cuni cA eqeq1 exbid reuuni3
      sylbi biantrurd imbi1d albidv mpbird vw cv cA wceq vx wex vz cv cA wceq
      vx wex vz cvv crab cuni vw cv wceq wi vw wal vw cv cA wceq vz cv cA wceq
      vx wex vz cvv crab cuni vw cv wceq wi vx wal vw wal vw cv cA wceq vz cv
      cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw wal vx wal vw cv cA wceq
      vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vx wal vw cv cA wceq
      vx wex vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vw cv cA
      wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq vx vx vv vv vz cv
      cA wceq vx wex vz cvv crab cuni vw cv vx vv vz cv cA wceq vx wex vz cvv
      crab vz cv cA wceq vx wex vx vz vv cvv vz cv cA wceq vx hbe1 vv cv cvv
      wcel vx ax-17 hbrab hbuni vv cv vw cv wcel vx ax-17 hbeq 19.23 albii vw
      cv cA wceq vz cv cA wceq vx wex vz cvv crab cuni vw cv wceq wi vw vx
      alcom bitr3i sylib vw cv cA wceq vz cv cA wceq vx wex vz cvv crab cuni vw
      cv wceq wi vw wal vx ax-4 vw cv cA wceq vz cv cA wceq vx wex vz cvv crab
      cuni vw cv wceq wi cA cA wceq vz cv cA wceq vx wex vz cvv crab cuni cA
      wceq wi vw cA euexaleq.1 vw cv cA wceq vw cv cA wceq cA cA wceq vz cv cA
      wceq vx wex vz cvv crab cuni vw cv wceq vz cv cA wceq vx wex vz cvv crab
      cuni cA wceq vw cv cA cA eqeq1 vw cv cA vz cv cA wceq vx wex vz cvv crab
      cuni eqeq2 imbi12d cla4v 3syl mpi 19.21ai sylc vy cv cA wceq vx wal vy
      weu vy cv cA wceq vx wal vy wex vx vy cA eualeq bicomi sylib vx vy cA
      eualexeq impbii $.
      $( [5-Nov-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y z A $.  $d x z B $.
  $}

  ${
    $d v w x y z A $.  $d v w x z B $.
  $}

  ${
    $d  x y z A $.  $d x z B $.
    eufromeq3.1 $e |- B e. _V $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d x z ph $.
    eufromeq4.1 $e |- C e. _V $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x z C $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.  $d v w x z C $.
  $}

  ${
    $d  x y z A $.  $d x z B $.
    euobj1.1 $e |- B e. _V $.
  $}

  ${
    $d x A $.  $d y ph $.  $d x ps $.  $d x y $.
    alxfr.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    alxfr $p |- ( ( A. y A e. B /\ A. x E. y x = A ) ->
                ( A. x ph <-> A. y ps ) ) $=
      cA cB wcel vy wal vx cv cA wceq vy wex vx wal wa wph vx wal wps vy wal cA
      cB wcel vy wal wph vx wal wps vy wal wi vx cv cA wceq vy wex vx wal cA cB
      wcel vy wal wph vx wal wps vy cA cB wcel vy hba1 wph vx wal vy ax-17 cA
      cB wcel wph vx wal wps wi vy wph wps vx cA cB alxfr.1 cla4gv a4s 19.21ad
      adantr vx cv cA wceq vy wex vx wal wps vy wal wph vx wal wi cA cB wcel vy
      wal vx cv cA wceq vy wex vx wal wps vy wal wph vx vx cv cA wceq vy wex vx
      hba1 wps vy wal vx ax-17 vx cv cA wceq vy wex wps vy wal wph wi vx vx cv
      cA wceq wps vy wal wph wi vy wps vy wal wph vy wps vy hba1 wph vy ax-17
      hbim vx cv cA wceq wph wps wps vy wal alxfr.1 wps vy ax-4 syl5bir 19.23ai
      a4s 19.21ad adantl impbid $.
      $( [11-Jun-2007] $) $( [18-Feb-2007] $)
  $}

  ${
    $d x y ph $.  $d x ch $.  $d y ps $.  $d x A $.  $d x y B $.
    ralxfrd.1 $e |- ( ( ph /\ y e. B ) -> A e. B ) $.
    ralxfrd.2 $e |- ( ( ph /\ x e. B ) -> E. y e. B x = A ) $.
    ralxfrd.3 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    ralxfrd $p |- ( ph -> ( A. x e. B ps <-> A. y e. B ch ) ) $=
      wph wps vx cB wral wch vy cB wral wph wps vx cB wral wch vy cB wph vy cv
      cB wcel wps vx cB wral wch wph vy cv cB wcel cA cB wcel wps vx cB wral
      wch wi wph vy cv cB wcel cA cB wcel ralxfrd.1 ex wph cA cB wcel wps vx cB
      wral wch wi wph wps wch vx cA cB ralxfrd.3 rcla4dv ex syld com23
      r19.21adv wph wch vy cB wral wps vx cB wph wch vy cB wral vx cv cA wceq
      vy cB wrex wps vx cv cB wcel wph wch vy cB wral vx cv cA wceq vy cB wrex
      wps wi wph wch vy cB wral wa vx cv cA wceq wps vy cB wph wch vy cB wral
      vy wph vy ax-17 wch vy cB hbra1 hban wps vy ax-17 wch vy cB wral vy cv cB
      wcel wch wph vx cv cA wceq wps wi wch vy cB ra4 wph vx cv cA wceq wch wps
      wph vx cv cA wceq wch wps wi wph vx cv cA wceq wa wps wch ralxfrd.3
      biimprd ex com23 sylan9r r19.23ad ex wph vx cv cB wcel vx cv cA wceq vy
      cB wrex ralxfrd.2 ex syl5d r19.21adv impbid $.
      $( [18-Feb-2007] $) $( [17-Feb-2007] $)

    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by FL,
       10-Apr-2007.) $)
    rexxfrd $p |- ( ph -> ( E. x e. B ps <-> E. y e. B ch ) ) $=
      wph wps wn vx cB wral wn wch wn vy cB wral wn wps vx cB wrex wch vy cB
      wrex wph wps wn vx cB wral wch wn vy cB wral wph wps wn wch wn vx vy cA
      cB ralxfrd.1 ralxfrd.2 wph vx cv cA wceq wa wps wch ralxfrd.3 notbid
      ralxfrd notbid wps vx cB dfrex2 wch vy cB dfrex2 3bitr4g $.
      $( [23-Oct-2007] $) $( [10-Apr-2007] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x A $.  $d x y B $.
    ralxfr.1 $e |- ( y e. B -> A e. B ) $.
    ralxfr.2 $e |- ( x e. B -> E. y e. B x = A ) $.
    ralxfr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    ralxfr $p |- ( A. x e. B ph <-> A. y e. B ps ) $=
      wph vx cB wral wps vy cB wral wph vx cB wral wps vy cB vy cv cB wcel wph
      vx cB wral wps vy cv cB wcel cA cB wcel wph vx cB wral wps wi ralxfr.1
      wph wps vx cA cB ralxfr.3 rcla4v syl com12 r19.21aiv wps vy cB wral wph
      vx cB wps vy cB wral vx cv cA wceq vy cB wrex wph vx cv cB wcel wps vy cB
      wral vx cv cA wceq wph vy cB wps vy cB hbra1 wph vy ax-17 wps vy cB wral
      vy cv cB wcel wps vx cv cA wceq wph wi wps vy cB ra4 vx cv cA wceq wph
      wps ralxfr.3 biimprcd syl6 r19.23ad ralxfr.2 syl5 r19.21aiv impbii $.
      $( [13-Jun-2005] $) $( [10-Jun-2005] $)

    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    ralxfrALT $p |- ( A. x e. B ph <-> A. y e. B ps ) $=
      cvv cvv wceq wph vx cB wral wps vy cB wral wb cvv eqid cvv cvv wceq wph
      wps vx vy cA cB vy cv cB wcel cA cB wcel cvv cvv wceq ralxfr.1 adantl vx
      cv cB wcel vx cv cA wceq vy cB wrex cvv cvv wceq ralxfr.2 adantl vx cv cA
      wceq wph wps wb cvv cvv wceq ralxfr.3 adantl ralxfrd ax-mp $.
      $( [13-Jun-2005] $) $( [10-Jun-2005] $)

    $( Transfer existence from a variable ` x ` to another variable ` y `
       contained in expression ` A ` . $)
    rexxfr $p |- ( E. x e. B ph <-> E. y e. B ps ) $=
      wph wn vx cB wral wn wps wn vy cB wral wn wph vx cB wrex wps vy cB wrex
      wph wn vx cB wral wps wn vy cB wral wph wn wps wn vx vy cA cB ralxfr.1
      ralxfr.2 vx cv cA wceq wph wps ralxfr.3 notbid ralxfr notbii wph vx cB
      dfrex2 wps vy cB dfrex2 3bitr4i $.
      $( [29-Jun-2005] $) $( [10-Jun-2005] $)
  $}

  ${
    $d x A $.  $d z B $.  $d z C $.  $d x y z D $.  $d y z ph $.  $d x z ps $.
    rabxfr.1 $e |- ( z e. B -> A. y z e. B ) $.
    rabxfr.2 $e |- ( z e. C -> A. y z e. C ) $.
    rabxfr.3 $e |- ( y e. D -> A e. D ) $.
    rabxfr.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    rabxfr.5 $e |- ( y = B -> A = C ) $.
    $( Abstraction class membership after substituting an expression ` A `
       (containing ` y ` ) for ` x ` in the class expression ` ph ` . $)
    rabxfr $p |- ( B e. D ->
                 ( C e. { x e. D | ph } <-> B e. { y e. D | ps } ) ) $=
      cB cD wcel cC wph vx cD crab wcel cB wps vy cD crab wcel wb wi cB cD wcel
      cC wph vx cD crab wcel wa cB cD wcel cB wps vy cD crab wcel wa wb cB cA
      wph vx cD crab wcel vy cD crab wcel cB vy cv wps vy cD crab wcel vy cD
      crab wcel cB cD wcel cC wph vx cD crab wcel wa cB cD wcel cB wps vy cD
      crab wcel wa cA wph vx cD crab wcel vy cD crab vy cv wps vy cD crab wcel
      vy cD crab cB cA wph vx cD crab wcel vy cv wps vy cD crab wcel vy cD vy
      cv cD wcel cA cD wcel wps wa vy cv cD wcel wps wa cA wph vx cD crab wcel
      vy cv wps vy cD crab wcel vy cv cD wcel cA cD wcel vy cv cD wcel wps vy
      cv cD wcel cA cD wcel wi vy cv cD wcel cA cD wcel vy cv cD wcel wb wi
      rabxfr.3 vy cv cD wcel cA cD wcel ibibr mpbi anbi1d wph wps vx cA cD
      rabxfr.4 elrab wps vy cD rabid 3bitr4g rabbii eleq2i cA wph vx cD crab
      wcel cC wph vx cD crab wcel vy vz cB cD rabxfr.1 vz cv cD wcel vy ax-17
      vy vz vz cC wph vx cD crab rabxfr.2 vz cv wph vx cD crab wcel vy ax-17
      hbel vy cv cB wceq cA cC wph vx cD crab rabxfr.5 eleq1d elrabf vy cv wps
      vy cD crab wcel cB wps vy cD crab wcel vy vz cB cD rabxfr.1 vz cv cD wcel
      vy ax-17 vy vz vz cB wps vy cD crab rabxfr.1 wps vy vz cD hbrab1 hbel vy
      cv cB wps vy cD crab eleq1 elrabf 3bitr3i cB cD wcel cC wph vx cD crab
      wcel cB wps vy cD crab wcel pm5.32 mpbir $.
      $( [21-Jun-2005] $) $( [10-Jun-2005] $)
  $}

  ${
    $d x ph $.  $d x A $.  $d x y B $.
    reuxfr2.1 $e |- ( y e. B -> A e. B ) $.
    reuxfr2.2 $e |- ( x e. B -> E* y ( y e. B /\ x = A ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` . $)
    reuxfr2 $p |- ( E! x e. B E. y e. B ( x = A /\ ph ) <-> E! y e. B ph ) $=
      vx cv cA wceq wph wa vy cB wrex vx cB wreu vx cv cA wceq wph wa vx cB
      wrex vy cB wreu wph vy cB wreu vx cv cA wceq wph wa vy cB wrex vx cB wreu
      vx cv cA wceq wph wa vx cB wrex vy cB wreu vy cv cB wcel vx cv cA wceq
      wph wa wa vy wmo vx cv cA wceq wph wa vy cB wrex vx cB wreu vx cv cA wceq
      wph wa vx cB wrex vy cB wreu wi vx cB vx cv cA wceq wph wa vx vy cB
      2reuswap vx cv cB wcel wph vy cv cB wcel vx cv cA wceq wa wa vy wmo vy cv
      cB wcel vx cv cA wceq wph wa wa vy wmo vx cv cB wcel vy cv cB wcel vx cv
      cA wceq wa vy wmo wph vy cv cB wcel vx cv cA wceq wa wa vy wmo reuxfr2.2
      vy cv cB wcel vx cv cA wceq wa wph vy moan syl wph vy cv cB wcel vx cv cA
      wceq wa wa vy cv cB wcel vx cv cA wceq wph wa wa vy wph vy cv cB wcel vx
      cv cA wceq wa wa vy cv cB wcel vx cv cA wceq wa wph wa vy cv cB wcel vx
      cv cA wceq wph wa wa wph vy cv cB wcel vx cv cA wceq wa ancom vy cv cB
      wcel vx cv cA wceq wph anass bitri mobii sylib mprg vx cv cB wcel vx cv
      cA wceq wph wa wa vx wmo vx cv cA wceq wph wa vx cB wrex vy cB wreu vx cv
      cA wceq wph wa vy cB wrex vx cB wreu wi vy cB vx cv cA wceq wph wa vy vx
      cB 2reuswap vx cv cB wcel vx cv cA wceq wph wa wa vx wmo vy cv cB wcel vx
      cv cB wcel wph wa vx cv cA wceq wa vx wmo vx cv cB wcel vx cv cA wceq wph
      wa wa vx wmo vx cv cA wceq vx cv cB wcel wph wa vx vx cA moeq moani vx cv
      cB wcel wph wa vx cv cA wceq wa vx cv cB wcel vx cv cA wceq wph wa wa vx
      vx cv cB wcel wph wa vx cv cA wceq wa vx cv cA wceq vx cv cB wcel wph wa
      wa vx cv cB wcel vx cv cA wceq wph wa wa vx cv cB wcel wph wa vx cv cA
      wceq ancom vx cv cA wceq vx cv cB wcel wph an12 bitri mobii mpbi a1i mprg
      impbii vx cv cA wceq wph wa vx cB wrex wph vy cB vy cv cB wcel cA cB wcel
      vx cv cA wceq wph wa vx cB wrex wph wb reuxfr2.1 wph wph vx cA cB vx cv
      cA wceq wph biidd ceqsrexv syl reubiia bitri $.
      $( [17-Nov-2004] $) $( [14-Nov-2004] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x A $.  $d x y B $.
    reuxfr.1 $e |- ( y e. B -> A e. B ) $.
    reuxfr.2 $e |- ( x e. B -> E! y e. B x = A ) $.
    reuxfr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Use ~ reuhyp to
       eliminate the second hypothesis. $)
    reuxfr $p |- ( E! x e. B ph <-> E! y e. B ps ) $=
      wph vx cB wreu vx cv cA wceq wps wa vy cB wrex vx cB wreu wps vy cB wreu
      wph vx cv cA wceq wps wa vy cB wrex vx cB vx cv cB wcel wph vx cv cA wceq
      vy cB wrex wph wa vx cv cA wceq wps wa vy cB wrex vx cv cB wcel vx cv cA
      wceq vy cB wrex wph vx cv cB wcel vx cv cA wceq vy cB wreu vx cv cA wceq
      vy cB wrex reuxfr.2 vx cv cA wceq vy cB reurex syl biantrurd vx cv cA
      wceq vy cB wrex wph wa vx cv cA wceq wph wa vy cB wrex vx cv cA wceq wps
      wa vy cB wrex vx cv cA wceq wph vy cB r19.41v vx cv cA wceq wph wa vx cv
      cA wceq wps wa vy cB vx cv cA wceq wph wps reuxfr.3 pm5.32i rexbii bitr3i
      syl6bb reubiia wps vx vy cA cB reuxfr.1 vx cv cB wcel vx cv cA wceq vy cB
      wreu vy cv cB wcel vx cv cA wceq wa vy wmo reuxfr.2 vx cv cA wceq vy cB
      wreu vy cv cB wcel vx cv cA wceq wa vy weu vy cv cB wcel vx cv cA wceq wa
      vy wmo vx cv cA wceq vy cB df-reu vy cv cB wcel vx cv cA wceq wa vy eumo
      sylbi syl reuxfr2 bitri $.
      $( [23-Nov-2004] $) $( [14-Nov-2004] $)
  $}

  ${
    $d y B $.  $d y C $.  $d x y $.
    reuhyp.1 $e |- ( x e. C -> B e. C ) $.
    reuhyp.2 $e |- ( ( x e. C /\ y e. C ) -> ( x = A <-> y = B ) ) $.
    $( A theorem useful for eliminating the restricted existential uniqueness
       hypotheses in ~ reuxfr . $)
    reuhyp $p |- ( x e. C -> E! y e. C x = A ) $=
      vx cv cC wcel vy cv cC wcel vx cv cA wceq wa vy weu vx cv cA wceq vy cC
      wreu vx cv cC wcel vy cv cB wceq vy weu vy cv cC wcel vx cv cA wceq wa vy
      weu vx cv cC wcel cB cvv wcel vy cv cB wceq vy weu vx cv cC wcel cB cC
      wcel cB cvv wcel reuhyp.1 cB cC elisset syl vy cB eueq sylib vx cv cC
      wcel vy cv cB wceq vy cv cC wcel vx cv cA wceq wa vy vx cv cC wcel vy cv
      cB wceq vy cv cC wcel vy cv cB wceq wa vy cv cC wcel vx cv cA wceq wa vx
      cv cC wcel vy cv cB wceq vy cv cC wcel vy cv cB wceq vy cv cC wcel cB cC
      wcel vx cv cC wcel vy cv cB cC eleq1 reuhyp.1 syl5cbir pm4.71rd vx cv cC
      wcel vy cv cC wcel vx cv cA wceq vy cv cB wceq reuhyp.2 pm5.32da bitr4d
      eubidv mpbid vx cv cA wceq vy cC df-reu sylibr $.
      $( [23-Nov-2004] $) $( [15-Nov-2004] $)
  $}

  ${
    $d x B $.  $d x z C $.  $d x y z A $.  $d ph y z $.  $d ps x z $.
    reuunixfr.1 $e |- ( z e. C -> A. y z e. C ) $.
    reuunixfr.2 $e |- ( y e. A -> B e. A ) $.
    reuunixfr.3 $e |- ( U. { y e. A | ps } e. A -> C e. A ) $.
    reuunixfr.4 $e |- ( x = B -> ( ph <-> ps ) ) $.
    reuunixfr.5 $e |- ( y = U. { y e. A | ps } -> B = C ) $.
    reuunixfr.6 $e |- ( x e. A -> E! y e. A x = B ) $.
    $( Change the variable ` x ` in the expression for "the unique ` A `
       such that ` ph ` " to another variable ` y ` contained in expression
       ` B ` .  Use ~ reuhyp to eliminate the last hypothesis. $)
    reuunixfr $p |- ( E! x e. A ph -> U. { x e. A | ph } = C ) $=
      wph vx cA wreu vx cv wph vx cA crab wcel vx cA crab cuni cC wph vx cA
      crab cuni wph vx cA wreu cC wph vx cA crab wcel vx cv wph vx cA crab wcel
      vx cA crab cuni cC wceq wph vx cA wreu wps vy cA wreu cC wph vx cA crab
      wcel wph wps vx vy cB cA reuunixfr.2 reuunixfr.6 reuunixfr.4 reuxfr wps
      vy cA wreu cC wph vx cA crab wcel wps vy cA crab cuni wps vy cA crab wcel
      wps vy cA reucl2 wps vy cA wreu wps vy cA crab cuni cA wcel cC wph vx cA
      crab wcel wps vy cA crab cuni wps vy cA crab wcel wb wps vy cA reucl wph
      wps vx vy vz cB wps vy cA crab cuni cC cA vy vz wps vy cA crab wps vy vz
      cA hbrab1 hbuni reuunixfr.1 reuunixfr.2 reuunixfr.4 reuunixfr.5 rabxfr
      syl mpbird sylbi cC cA wcel vx cv wph vx cA crab wcel vx cA wreu cC wph
      vx cA crab wcel vx cv wph vx cA crab wcel vx cA crab cuni cC wceq wb wph
      vx cA wreu vx cv wph vx cA crab wcel cC wph vx cA crab wcel vx vz cA cC
      vz cv cC wcel vx ax-17 cC wph vx cA crab wcel cC wph vx cA crab wcel vx
      wal wi cC cA wcel vx vz vz cC wph vx cA crab vz cv cC wcel vx ax-17 wph
      vx vz cA hbrab1 hbel a1i vx cv cC wph vx cA crab eleq1 reuuni2f wph vx cA
      wreu wps vy cA wreu cC cA wcel wph wps vx vy cB cA reuunixfr.2
      reuunixfr.6 reuunixfr.4 reuxfr wps vy cA wreu wps vy cA crab cuni cA wcel
      cC cA wcel wps vy cA reucl reuunixfr.3 syl sylbi wph vx cA wreu vx cv wph
      vx cA crab wcel vx cA wreu wph vx cv wph vx cA crab wcel vx cA vx cv wph
      vx cA crab wcel vx cv cA wcel wph wph vx cA rabid baibr reubiia biimpi
      sylanc mpbid vx cv wph vx cA crab wcel vx cA crab wph vx cA crab vx cv
      wph vx cA crab wcel wph vx cA vx cv wph vx cA crab wcel vx cv cA wcel wph
      wph vx cA rabid baib rabbii unieqi syl5eqr $.
      $( [25-Jun-2005] $) $( [13-Jun-2005] $)
  $}

  $( The Axiom of Union and its converse.  A class is a set iff its union is a
     set. $)
  uniexb $p |- ( A e. _V <-> U. A e. _V ) $=
    cA cvv wcel cA cuni cvv wcel cA cvv uniexg cA cA cuni cpw wss cA cuni cpw
    cvv wcel cA cvv wcel cA cuni cvv wcel cA cA cuni cpw cvv ssexg cA pwuni cA
    cuni cvv pwexg sylancr impbii $.
    $( [17-Nov-2003] $) $( [11-Nov-2003] $)

  $( The Axiom of Power Sets and its converse.  A class is a set iff its power
     class is a set. $)
  pwexb $p |- ( A e. _V <-> ~P A e. _V ) $=
    cA cpw cvv wcel cA cpw cuni cvv wcel cA cvv wcel cA cpw uniexb cA cpw cuni
    cA cvv cA unipw eleq1i bitr2i $.
    $( [17-Nov-2003] $) $( [11-Nov-2003] $)

  $( The union of the universe is the universe.  Exercise 4.12(c) of
     [Mendelson] p. 235. $)
  univ $p |- U. _V = _V $=
    cvv cpw cuni cvv cuni cvv cvv cpw cvv pwv unieqi cvv unipw eqtr3i $.
    $( [14-Sep-2003] $)

  ${
    eldifpw.1 $e |- C e. _V $.
    $( Membership in a power class difference. $)
    eldifpw $p |- ( ( A e. ~P B /\ -. C C_ B ) ->
                   ( A u. C ) e. ( ~P ( B u. C ) \ ~P B ) ) $=
      cA cB cpw wcel cC cB wss wn wa cA cC cun cB cC cun cpw wcel cA cC cun cB
      cpw wcel wn wa cA cC cun cB cC cun cpw cB cpw cdif wcel cA cB cpw wcel cA
      cC cun cB cC cun cpw wcel cC cB wss wn cA cC cun cB cpw wcel wn cA cB cpw
      wcel cA cB wss cA cC cun cB cC cun cpw wcel cA cB elpwi cA cB cpw wcel cA
      cC cun cB cC cun cpw wcel cA cC cun cB cC cun wss cA cB wss cA cB cpw
      wcel cA cC cun cvv wcel cA cC cun cB cC cun cpw wcel cA cC cun cB cC cun
      wss wb cA cB cpw wcel cC cvv wcel cA cC cun cvv wcel eldifpw.1 cA cC cB
      cpw cvv unexg mpan2 cA cC cun cB cC cun cvv elpwg syl cA cB cC unss1
      syl5bir mpd cA cC cun cB cpw wcel cC cB wss cA cC cun cB cpw wcel cA cC
      cun cB wss cC cB wss cA cC cun cB elpwi cA cC cun cB wss cA cB wss cC cB
      wss wa cC cB wss cA cC cB unss cA cB wss cC cB wss pm3.27 sylbir syl
      con3i anim12i cA cC cun cB cC cun cpw cB cpw eldif sylibr $.
      $( [7-Jun-2007] $) $( [25-Mar-2007] $)

    $( Membership in the power class of a union. $)
    elpwun $p |- ( A e. ~P ( B u. C ) <-> ( A \ C ) e. ~P B ) $=
      cA cB cC cun cpw wcel cA cvv wcel cA cC cdif cB cpw wcel cA cB cC cun cpw
      elisset cA cC cdif cB cpw wcel cA cC cdif cvv wcel cA cvv wcel cA cC cdif
      cB cpw elisset cC cvv wcel cA cvv wcel cA cC cdif cvv wcel wb eldifpw.1
      cA cC cvv difex2 ax-mp sylibr cA cvv wcel cA cB cC cun cpw wcel cA cB cC
      cun wss cA cC cdif cB cpw wcel cA cB cC cun cvv elpwg cA cvv wcel cA cC
      cdif cB cpw wcel cA cC cdif cB wss cA cB cC cun wss cA cvv wcel cA cC
      cdif cvv wcel cA cC cdif cB cpw wcel cA cC cdif cB wss wb cA cC cvv
      difexg cA cC cdif cB cvv elpwg syl cA cB cC cun wss cA cC cB cun wss cA
      cC cdif cB wss cB cC cun cC cB cun cA cB cC uncom sseq2i cA cC cB ssundif
      bitri syl6rbbr bitrd pm5.21nii $.
      $( [29-Mar-2007] $) $( [26-Mar-2007] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Membership in an extension of a power class. $)
    elpwunsn $p |- ( A e. ( ~P ( B u. { C } ) \ ~P B ) -> C e. A ) $=
      cA cB cC csn cun cpw cB cpw cdif wcel cA cB cC csn cun cpw wcel cA cB cpw
      wcel wn wa cC cA wcel cA cB cC csn cun cpw cB cpw eldif cA cB cC csn cun
      cpw wcel cA cB cpw wcel wn vx cv cB wcel wn vx cA wrex cC cA wcel cA cB
      cC csn cun cpw wcel cA cB cpw wcel wn wa vx cv cB wcel vx cA wral wn vx
      cv cB wcel wn vx cA wrex cA cB cC csn cun cpw wcel cA cB cpw wcel wn vx
      cv cB wcel vx cA wral wn cA cB cC csn cun cpw wcel cA cB cpw wcel vx cv
      cB wcel vx cA wral cA cB cC csn cun cpw wcel cA cB cpw wcel cA cB wss vx
      cv cB wcel vx cA wral cA cB cB cC csn cun cpw elpwg vx cA cB dfss3 syl6bb
      notbid biimpa vx cv cB wcel vx cA rexnal sylibr cA cB cC csn cun cpw wcel
      vx cv cB wcel wn vx cA wrex cC cA wcel cA cB cC csn cun cpw wcel vx cv cB
      wcel wn cC cA wcel vx cA cA cB cC csn cun cpw wcel vx cv cA wcel vx cv cB
      wcel wn cC cA wcel wi cA cB cC csn cun cpw wcel vx cv cA wcel vx cv cB
      wcel wn vx cv cA wcel cC cA wcel cA cB cC csn cun cpw wcel vx cv cA wcel
      vx cv cB wcel wn vx cv cA wcel cC cA wcel wi cA cB cC csn cun cpw wcel cA
      cB cC csn cun wss vx cv cA wcel vx cv cB wcel wn wa vx cv cC wceq wi vx
      cv cA wcel vx cv cB wcel wn wa vx cv cA wcel cC cA wcel wi wi cA cB cC
      csn cun elpwi cA cB cC csn cun wss vx cv cA wcel vx cv cB cC csn cun wcel
      wi vx cv cA wcel vx cv cB wcel wn wa vx cv cC wceq wi cA cB cC csn cun vx
      cv ssel vx cv cA wcel vx cv cB cC csn cun wcel wi vx cv cA wcel vx cv cB
      wcel wn vx cv cC wceq vx cv cB cC csn cun wcel vx cv cB wcel wn vx cv cC
      wceq wi vx cv cA wcel vx cv cB cC csn cun wcel vx cv cB wcel vx cv cC csn
      wcel wo vx cv cB wcel wn vx cv cC wceq wi vx cv cB cC csn elun vx cv cB
      wcel vx cv cC csn wcel wo vx cv cB wcel vx cv cC wceq vx cv cC csn wcel
      vx cv cC wceq vx cv cB wcel vx cv cC elsni orim2i ord sylbi imim2i imp3a
      syl vx cv cC wceq vx cv cA wcel cC cA wcel wi vx cv cA wcel vx cv cB wcel
      wn wa vx cv cC wceq vx cv cA wcel cC cA wcel vx cv cC cA eleq1 biimpd
      imim2i 3syl exp3a com4r pm2.43b r19.23adv imp syldan sylbi $.
      $( [29-Mar-2007] $) $( [26-Mar-2007] $)
  $}

  ${
    op1stb.1 $e |- A e. _V $.
    $( Extract the first member of an ordered pair.  Theorem 73 of [Suppes]
       p. 42.  (See ~ op2ndb to extract the second member, ~ op1sta for an
       alternate version, and ~ op1st for the preferred version.) $)
    op1stb $p |- |^| |^| <. A , B >. = A $=
      cA cB cop cint cint cA csn cint cA cA cB cop cint cA csn cA cB cop cint
      cA csn cA cB cpr cpr cint cA csn cA cB cpr cin cA csn cA cB cop cA csn cA
      cB cpr cpr cA cB df-op inteqi cA csn cA cB cpr cA snex cA cB prex intpr
      cA csn cA cB cpr wss cA csn cA cB cpr cin cA csn wceq cA cB snsspr1 cA
      csn cA cB cpr df-ss mpbi 3eqtri inteqi cA op1stb.1 intsn eqtri $.
      $( [25-Nov-2003] $) $( [25-Nov-2003] $)
  $}

  ${
    $d x y A $.
    iunpw.1 $e |- A e. _V $.
    $( An indexed union of a power class in terms of the power class of
       the union of its index.  Part of Exercise 24(b) of [Enderton] p. 33. $)
    iunpw $p |- ( E. x e. A x = U. A <-> ~P U. A = U_ x e. A ~P x ) $=
      vx cv cA cuni wceq vx cA wrex cA cuni cpw vx cA vx cv cpw ciun wceq vx cv
      cA cuni wceq vx cA wrex vy cA cuni cpw vx cA vx cv cpw ciun vx cv cA cuni
      wceq vx cA wrex vy cv cA cuni wss vy cv vx cv wss vx cA wrex vy cv cA
      cuni cpw wcel vy cv vx cA vx cv cpw ciun wcel vx cv cA cuni wceq vx cA
      wrex vy cv cA cuni wss vy cv vx cv wss vx cA wrex vy cv cA cuni wss vx cv
      cA cuni wceq vx cA wrex vy cv vx cv wss vx cA wrex vy cv cA cuni wss vx
      cv cA cuni wceq vy cv vx cv wss vx cA vx cv cA cuni wceq vy cv vx cv wss
      vy cv cA cuni wss vx cv cA cuni vy cv sseq2 biimprcd r19.22sdv com12 vy
      cv vx cv wss vx cA wrex vy cv vx cA vx cv ciun cA cuni vx cA vx cv vy cv
      ssiun vx cA uniiun syl6ssr impbid1 vy cv cA cuni vy visset elpw vy cv vx
      cA vx cv cpw ciun wcel vy cv vx cv cpw wcel vx cA wrex vy cv vx cv wss vx
      cA wrex vx vy cv cA vx cv cpw eliun vy cv vx cv cpw wcel vy cv vx cv wss
      vx cA vy cv vx cv wss vy vx cv cpw vy vx cv df-pw abeq2i rexbii bitri
      3bitr4g eqrdv cA cuni cpw vx cA vx cv cpw ciun wceq cA cuni vx cv cpw
      wcel vx cA wrex vx cv cA cuni wceq vx cA wrex cA cuni cpw vx cA vx cv cpw
      ciun wceq cA cuni vx cA vx cv cpw ciun wcel cA cuni vx cv cpw wcel vx cA
      wrex cA cuni cpw vx cA vx cv cpw ciun wceq cA cuni cA cuni wss cA cuni vx
      cA vx cv cpw ciun wcel cA cuni ssid cA cuni cpw vx cA vx cv cpw ciun wceq
      cA cuni cA cuni cpw wcel cA cuni vx cA vx cv cpw ciun wcel cA cuni cA
      cuni wss cA cuni cpw vx cA vx cv cpw ciun cA cuni eleq2 cA cuni cA cuni
      cA iunpw.1 uniex elpw syl5bbr mpbii vx cA cuni cA vx cv cpw eliun sylib
      cA cuni vx cv cpw wcel vx cv cA cuni wceq vx cA vx cv cA wcel cA cuni vx
      cv cpw wcel vx cv cA cuni wceq vx cv cA wcel cA cuni vx cv cpw wcel wa vx
      cv cA cuni wss cA cuni vx cv wss wa vx cv cA cuni wceq vx cv cA wcel vx
      cv cA cuni wss cA cuni vx cv cpw wcel cA cuni vx cv wss vx cv cA elssuni
      cA cuni vx cv elpwi anim12i vx cv cA cuni eqss sylibr ex r19.22i syl
      impbii $.
      $( [5-Dec-2003] $) $( [29-Nov-2003] $)
  $}

  ${
    $d w v x $.  $d w v y $.  $d w v z $.  $d w v R $.  $d w v A $.
    $( A founded relation has no 3-cycle loops.  Special case of
       Proposition 6.23 of [TakeutiZaring] p. 30. $)
    fr3nr $p |- ( ( R Fr A /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
                -. ( x R y /\ y R z /\ z R x ) ) $=
      cA cR wfr vy cv vz cv vx cv ctp cA wss vx cv vy cv cR wbr vy cv vz cv cR
      wbr vz cv vx cv cR wbr w3a wn vx cv cA wcel vy cv cA wcel vz cv cA wcel
      w3a cA cR wfr vy cv vz cv vx cv ctp cA wss wa vy cv vz cv vx cv ctp vw cv
      vv cv cR wbr vw cab cin c0 wceq vv vy cv vz cv vx cv ctp wrex vx cv vy cv
      cR wbr vy cv vz cv cR wbr vz cv vx cv cR wbr w3a wn cA cR wfr vy cv vz cv
      vx cv ctp cA wss vy cv vz cv vx cv ctp c0 wne vy cv vz cv vx cv ctp vw cv
      vv cv cR wbr vw cab cin c0 wceq vv vy cv vz cv vx cv ctp wrex vy cv vz cv
      vx cv vy visset tpnz vv vw cA vy cv vz cv vx cv ctp cR vy cv vz cv vx cv
      tpex frc mp3an3 vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab cin c0
      wceq vx cv vy cv cR wbr vy cv vz cv cR wbr vz cv vx cv cR wbr w3a wn vv
      vy cv vz cv vx cv ctp vv cv vy cv vz cv vx cv ctp wcel vx cv vy cv cR wbr
      vy cv vz cv cR wbr vz cv vx cv cR wbr w3a vy cv vz cv vx cv ctp vw cv vv
      cv cR wbr vw cab cin c0 vx cv vy cv cR wbr vy cv vz cv cR wbr vz cv vx cv
      cR wbr w3a vv cv vy cv vz cv vx cv ctp wcel vy cv vz cv vx cv ctp vw cv
      vv cv cR wbr vw cab cin c0 wne vx cv vy cv cR wbr vy cv vz cv cR wbr vz
      cv vx cv cR wbr w3a vv cv vy cv wceq vv cv vz cv wceq vv cv vx cv wceq
      w3o vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab cin c0 wne vv cv vy
      cv vz cv vx cv ctp wcel vv cv vy cv wceq vy cv vz cv vx cv ctp vw cv vv
      cv cR wbr vw cab cin c0 wne wi vv cv vz cv wceq vy cv vz cv vx cv ctp vw
      cv vv cv cR wbr vw cab cin c0 wne wi vv cv vx cv wceq vy cv vz cv vx cv
      ctp vw cv vv cv cR wbr vw cab cin c0 wne wi vv cv vy cv wceq vv cv vz cv
      wceq vv cv vx cv wceq w3o vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab
      cin c0 wne wi vx cv vy cv cR wbr vy cv vz cv cR wbr vz cv vx cv cR wbr vv
      cv vy cv wceq vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab cin c0 wne
      vv cv vz cv wceq vv cv vx cv wceq 3jao vv cv vy cv wceq vy cv vz cv vx cv
      ctp vw cv vv cv cR wbr vw cab cin c0 wne vy cv vz cv vx cv ctp vw cv vy
      cv cR wbr vw cab cin c0 wne vx cv vy cv cR wbr vv cv vy cv wceq vy cv vz
      cv vx cv ctp vw cv vv cv cR wbr vw cab cin vy cv vz cv vx cv ctp vw cv vy
      cv cR wbr vw cab cin c0 vv cv vy cv wceq vw cv vv cv cR wbr vw cab vw cv
      vy cv cR wbr vw cab vy cv vz cv vx cv ctp vv cv vy cv wceq vw cv vv cv cR
      wbr vw cv vy cv cR wbr vw vv cv vy cv vw cv cR breq2 abbidv ineq2d neeq1d
      vx cv vy cv cR wbr vx cv vw cv vy cv cR wbr vw cab wcel vy cv vz cv vx cv
      ctp vw cv vy cv cR wbr vw cab cin c0 wne vx vy vw cR brab1 vx cv vy cv vz
      cv vx cv ctp wcel vx cv vw cv vy cv cR wbr vw cab wcel vy cv vz cv vx cv
      ctp vw cv vy cv cR wbr vw cab cin c0 wne vy cv vz cv vx cv vx visset tpi3
      vx cv vy cv vz cv vx cv ctp vw cv vy cv cR wbr vw cab inelcm mpan sylbi
      syl5cbir vv cv vz cv wceq vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab
      cin c0 wne vy cv vz cv vx cv ctp vw cv vz cv cR wbr vw cab cin c0 wne vy
      cv vz cv cR wbr vv cv vz cv wceq vy cv vz cv vx cv ctp vw cv vv cv cR wbr
      vw cab cin vy cv vz cv vx cv ctp vw cv vz cv cR wbr vw cab cin c0 vv cv
      vz cv wceq vw cv vv cv cR wbr vw cab vw cv vz cv cR wbr vw cab vy cv vz
      cv vx cv ctp vv cv vz cv wceq vw cv vv cv cR wbr vw cv vz cv cR wbr vw vv
      cv vz cv vw cv cR breq2 abbidv ineq2d neeq1d vy cv vz cv cR wbr vy cv vw
      cv vz cv cR wbr vw cab wcel vy cv vz cv vx cv ctp vw cv vz cv cR wbr vw
      cab cin c0 wne vy vz vw cR brab1 vy cv vy cv vz cv vx cv ctp wcel vy cv
      vw cv vz cv cR wbr vw cab wcel vy cv vz cv vx cv ctp vw cv vz cv cR wbr
      vw cab cin c0 wne vy cv vz cv vx cv vy visset tpi1 vy cv vy cv vz cv vx
      cv ctp vw cv vz cv cR wbr vw cab inelcm mpan sylbi syl5cbir vv cv vx cv
      wceq vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab cin c0 wne vy cv vz
      cv vx cv ctp vw cv vx cv cR wbr vw cab cin c0 wne vz cv vx cv cR wbr vv
      cv vx cv wceq vy cv vz cv vx cv ctp vw cv vv cv cR wbr vw cab cin vy cv
      vz cv vx cv ctp vw cv vx cv cR wbr vw cab cin c0 vv cv vx cv wceq vw cv
      vv cv cR wbr vw cab vw cv vx cv cR wbr vw cab vy cv vz cv vx cv ctp vv cv
      vx cv wceq vw cv vv cv cR wbr vw cv vx cv cR wbr vw vv cv vx cv vw cv cR
      breq2 abbidv ineq2d neeq1d vz cv vx cv cR wbr vz cv vw cv vx cv cR wbr vw
      cab wcel vy cv vz cv vx cv ctp vw cv vx cv cR wbr vw cab cin c0 wne vz vx
      vw cR brab1 vz cv vy cv vz cv vx cv ctp wcel vz cv vw cv vx cv cR wbr vw
      cab wcel vy cv vz cv vx cv ctp vw cv vx cv cR wbr vw cab cin c0 wne vy cv
      vz cv vx cv vz visset tpi2 vz cv vy cv vz cv vx cv ctp vw cv vx cv cR wbr
      vw cab inelcm mpan sylbi syl5cbir syl3an vv cv vy cv vz cv vx cv vv
      visset eltp syl5ib com12 necon2bd r19.23aiv syl vx cv cA wcel vy cv cA
      wcel vz cv cA wcel w3a vy cv cA wcel vz cv cA wcel vx cv cA wcel w3a vy
      cv vz cv vx cv ctp cA wss vx cv cA wcel vy cv cA wcel vz cv cA wcel
      3anrot vy cv vz cv vx cv cA vy visset vz visset vx visset tpss bitri
      sylan2b $.
      $( [10-Apr-1994] $)
  $}

  $( A set founded by epsilon contains no 3-cycle loops. $)
  epne3 $p |- ( ( _E Fr A /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
                -. ( x e. y /\ y e. z /\ z e. x ) ) $=
    cA cep wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a wa vx cv vy cv cep
    wbr vy cv vz cv cep wbr vz cv vx cv cep wbr w3a wn vx cv vy cv wcel vy cv
    vz cv wcel vz cv vx cv wcel w3a wn vx vy vz cA cep fr3nr vx cv vy cv cep
    wbr vy cv vz cv cep wbr vz cv vx cv cep wbr w3a vx cv vy cv wcel vy cv vz
    cv wcel vz cv vx cv wcel w3a vx cv vy cv cep wbr vx cv vy cv wcel vy cv vz
    cv cep wbr vy cv vz cv wcel vz cv vx cv cep wbr vz cv vx cv wcel vx vy epel
    vy vz epel vz vx epel 3anbi123i notbii sylib $.
    $( [19-Apr-1994] $)

  ${
    $d x y z R $.  $d x y z A $.
    $( Alternate definition of well-ordering.  Definition 6.24(2) of
       [TakeutiZaring] p. 30. $)
    dfwe2 $p |- ( R We A <-> ( R Fr A /\ A. x e. A A. y e. A
                ( x R y \/ x = y \/ y R x ) ) ) $=
      cA cR wwe cA cR wfr cA cR wor wa cA cR wfr vx cv vy cv cR wbr vx cv vy cv
      wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral wa cA cR df-we cA cR
      wfr cA cR wor wa cA cR wfr vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx
      cv cR wbr w3o vy cA wral vx cA wral wa cA cR wor vx cv vy cv cR wbr vx cv
      vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral cA cR wfr cA cR
      wor vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o wi vy wal vx wal vx cv vy cv cR wbr vx cv vy cv wceq
      vy cv vx cv cR wbr w3o vy cA wral vx cA wral cA cR wor vx cv cA wcel vy
      cv cA wcel wa vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o
      wi vx vy cA cR wor vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx
      cv vy cv wceq vy cv vx cv cR wbr w3o cA vx cv vy cv cR solin ex 19.21aivv
      vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vx vy cA cA
      r2al sylibr anim2i cA cR wfr vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx
      cv cR wbr w3o vy cA wral vx cA wral cA cR wor cA cR wfr vx cv vy cv cR
      wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral cA cR
      wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral
      vx cA wral wa cA cR wor cA cR wfr vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o vy cA wral vx cA wral cA cR wpo cA cR wfr vx cv vz cv
      cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o vz cA wral vy cA wral vx
      cA wral vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi wa vz cA wral vy cA wral vx cA wral vx cv vy cv cR wbr
      vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral cA cR wpo
      cA cR wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vz cv cR
      wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o wi vz wal vy wal vx wal vx cv
      cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy wal vx
      wal vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o vz cA wral
      vy cA wral vx cA wral vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa vz cA wral vy cA wral vx cA wral cA
      cR wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vz cv cR wbr
      vx cv vz cv wceq vz cv vx cv cR wbr w3o wi vz wal vy wal vx cv cA wcel vy
      cv cA wcel vz cv cA wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy wal vx cA cR wfr
      vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vz cv cR wbr vx cv vz
      cv wceq vz cv vx cv cR wbr w3o wi vz wal vx cv cA wcel vy cv cA wcel vz
      cv cA wcel w3a vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi wa wi vz wal vy cA cR wfr vx cv cA wcel vy
      cv cA wcel vz cv cA wcel w3a vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx
      cv cR wbr w3o wi vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vx
      cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi wa wi vz cA cR wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv
      vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o vx cv vx cv cR wbr
      wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa cA
      cR wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a vx cv vz cv cR wbr
      vx cv vz cv wceq vz cv vx cv cR wbr w3o vx cv vx cv cR wbr wn vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa wi cA cR wfr vx cv
      cA wcel vy cv cA wcel vz cv cA wcel w3a wa vx cv vz cv cR wbr vx cv vz cv
      wceq vz cv vx cv cR wbr w3o vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi vx cv vx cv cR wbr wn cA cR wfr vx cv cA wcel vy cv cA
      wcel vz cv cA wcel w3a wa vx cv vz cv wceq vz cv vx cv cR wbr wo wn vx cv
      vz cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o cA cR
      wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a wa vx cv vy cv cR wbr
      vy cv vz cv cR wbr wa vx cv vz cv wceq vz cv vx cv cR wbr wo wn vx cv vz
      cv cR wbr cA cR wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a wa vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv wceq wn vz cv vx cv cR
      wbr wn wa vx cv vz cv wceq vz cv vx cv cR wbr wo wn cA cR wfr vx cv cA
      wcel vy cv cA wcel vz cv cA wcel w3a wa vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv wceq wn vz cv vx cv cR wbr wn cA cR wfr vx cv cA wcel
      vy cv cA wcel vz cv cA wcel w3a wa vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vx cv vz cv wceq wa wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv
      vz cv wceq wn wi cA cR wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a
      wa vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv wceq wa cA cR wfr vx cv cA wcel vy cv cA wcel vx
      cv vy cv cR wbr vy cv vx cv cR wbr wa wn vz cv cA wcel vx vy cA cR fr2nr
      3adantr3 vx cv vz cv wceq vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vz cv wceq vy cv vz cv cR wbr vy
      cv vx cv cR wbr vx cv vy cv cR wbr vx cv vz cv wceq vy cv vx cv cR wbr vy
      cv vz cv cR wbr vx cv vz cv vy cv cR breq2 biimprd anim2d impcom nsyl vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv wceq imnan sylibr cA cR
      wfr vx cv cA wcel vy cv cA wcel vz cv cA wcel w3a wa vx cv vy cv cR wbr
      vy cv vz cv cR wbr wa vz cv vx cv cR wbr wa wn vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vz cv vx cv cR wbr wn wi cA cR wfr vx cv cA wcel vy cv cA
      wcel vz cv cA wcel w3a wa vx cv vy cv cR wbr vy cv vz cv cR wbr vz cv vx
      cv cR wbr w3a wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vz cv vx cv cR
      wbr wa wn vx vy vz cA cR fr3nr vx cv vy cv cR wbr vy cv vz cv cR wbr vz
      cv vx cv cR wbr w3a vx cv vy cv cR wbr vy cv vz cv cR wbr wa vz cv vx cv
      cR wbr wa vx cv vy cv cR wbr vy cv vz cv cR wbr vz cv vx cv cR wbr df-3an
      notbii sylib vx cv vy cv cR wbr vy cv vz cv cR wbr wa vz cv vx cv cR wbr
      imnan sylibr jcad vx cv vz cv wceq vz cv vx cv cR wbr ioran syl6ibr
      imim1d vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o vx cv
      vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr wo wo vx cv vz cv wceq
      vz cv vx cv cR wbr wo vx cv vz cv cR wbr wo vx cv vz cv wceq vz cv vx cv
      cR wbr wo wn vx cv vz cv cR wbr wi vx cv vz cv cR wbr vx cv vz cv wceq vz
      cv vx cv cR wbr 3orass vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR
      wbr wo orcom vx cv vz cv wceq vz cv vx cv cR wbr wo vx cv vz cv cR wbr
      df-or 3bitri syl5ib cA cR wfr vy cv cA wcel vx cv cA wcel vx cv vx cv cR
      wbr wn vz cv cA wcel vx cA cR frirr 3ad2antr1 jctild ex a2d 19.20dv
      19.20dv 19.20dv vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr
      w3o vx vy vz cA cA cA r3al vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx vy vz cA cA cA r3al 3imtr4g
      vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx
      cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o vz cA wral vy cA
      wral vx cA vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy
      cA wral vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA
      wral vy cA wral vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr
      w3o vz cA wral vy cA wral vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
      cR wbr w3o vy cA ralidm vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
      cR wbr w3o vy cA wral vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR
      wbr w3o vz cA wral vy cA vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
      cR wbr w3o vx cv vz cv cR wbr vx cv vz cv wceq vz cv vx cv cR wbr w3o vy
      vz cA vy cv vz cv wceq vx cv vy cv cR wbr vx cv vz cv cR wbr vx cv vy cv
      wceq vx cv vz cv wceq vy cv vx cv cR wbr vz cv vx cv cR wbr vy cv vz cv
      vx cv cR breq2 vy cv vz cv vx cv eqeq2 vy cv vz cv vx cv cR breq1
      3orbi123d cbvralv ralbii bitr3i ralbii vx vy vz cA cR df-po 3imtr4g ancrd
      vx vy cA cR df-so syl6ibr imdistani impbii bitri $.
      $( [16-Mar-1997] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordinals (continued)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The class of all ordinal numbers is ordinal.  Proposition 7.12 of
       [TakeutiZaring] p. 38, but without using the Axiom of Regularity. $)
    ordon $p |- Ord On $=
      con0 word con0 wtr con0 cep wwe con0 df-ord tron con0 cep wwe con0 cep
      wfr vx cv vy cv cep wbr vx cv vy cv wceq vy cv vx cv cep wbr w3o vy con0
      wral vx con0 wral vx vy con0 cep dfwe2 onfr vx cv vy cv cep wbr vx cv vy
      cv wceq vy cv vx cv cep wbr w3o vx vy con0 vx cv word vy cv word vx cv vy
      cv cep wbr vx cv vy cv wceq vy cv vx cv cep wbr w3o vx cv con0 wcel vy cv
      con0 wcel vx cv word vy cv word wa vx cv vy cv wcel vx cv vy cv wceq vy
      cv vx cv wcel w3o vx cv vy cv cep wbr vx cv vy cv wceq vy cv vx cv cep
      wbr w3o vx cv vy cv ordtri3or vx cv vy cv cep wbr vx cv vy cv wcel vx cv
      vy cv wceq vx cv vy cv wceq vy cv vx cv cep wbr vy cv vx cv wcel vx vy
      epel vx cv vy cv wceq biid vy vx epel 3orbi123i sylibr vx cv eloni vy cv
      eloni syl2an rgen2a mpbir2an mpbir2an $.
      $( [17-May-1994] $)
  $}

  $( The epsilon relation well-orders the class of ordinal numbers.
     Proposition 4.8(g) of [Mendelson] p. 244. $)
  epweon $p |- _E We On $=
    con0 word con0 cep wwe ordon con0 ordwe ax-mp $.
    $( [1-Nov-2003] $) $( [1-Nov-2003] $)

  $( No set contains all ordinal numbers.  Proposition 7.13 of [TakeutiZaring]
     p. 38, but without using the Axiom of Regularity.  This is also known as
     the Burali-Forti paradox (remark in [Enderton] p. 194).  In 1897, Cesare
     Burali-Forti noticed that since the "set" of all ordinal numbers is an
     ordinal class ( ~ ordon ), it must be both an element of the set of all
     ordinal numbers yet greater than every such element.  ZF set theory
     resolves this paradox by not allowing the class of all ordinal numbers to
     be a set (so instead it is a proper class).  Here we prove the denial of
     its existence. $)
  onprc $p |- -. On e. _V $=
    con0 cvv wcel con0 con0 wcel con0 word con0 con0 wcel wn ordon con0 ordirr
    ax-mp con0 cvv wcel con0 con0 wcel con0 word ordon con0 cvv elong mpbiri
    mto $.
    $( [18-May-1994] $)

  $( A way to express the ordinal property of a class in terms of the class
     of ordinal numbers.  Corollary 7.14 of [TakeutiZaring] p. 38 and its
     converse. $)
  ordeleqon $p |- ( Ord A <-> ( A e. On \/ A = On ) ) $=
    cA word cA con0 wcel cA con0 wceq wo cA word cA con0 wcel cA con0 wceq wo
    con0 cA wcel con0 cA wcel con0 cvv wcel onprc con0 cA elisset mto cA word
    cA con0 wcel cA con0 wceq wo con0 cA wcel cA word cA con0 wcel cA con0 wceq
    con0 cA wcel w3o cA con0 wcel cA con0 wceq wo con0 cA wcel wo cA word con0
    word cA con0 wcel cA con0 wceq con0 cA wcel w3o ordon cA con0 ordtri3or
    mpan2 cA con0 wcel cA con0 wceq con0 cA wcel df-3or sylib ord mt3i cA con0
    wcel cA word cA con0 wceq cA eloni cA con0 wceq cA word con0 word ordon cA
    con0 ordeq mpbiri jaoi impbii $.
    $( [1-Jun-2003] $)

  $( Any ordinal class is a subclass of the class of ordinal numbers.
     Corollary 7.15 of [TakeutiZaring] p. 38. $)
  ordsson $p |- ( Ord A -> A C_ On ) $=
    cA word cA con0 wcel cA con0 wss cA word cA con0 wcel cA con0 wss cA con0
    wne wa cA con0 wss cA word con0 word cA con0 wcel cA con0 wss cA con0 wne
    wa wb ordon cA con0 ordelssne mpan2 cA con0 wss cA con0 wne pm3.26 syl6bi
    cA word cA con0 wcel wn cA con0 wceq cA con0 wss cA word cA con0 wcel cA
    con0 wceq cA word cA con0 wcel cA con0 wceq wo cA ordeleqon biimpi ord cA
    con0 eqimss syl6 pm2.61d $.
    $( [18-May-1994] $)

  $( An ordinal number is a subset of the class of ordinal numbers. $)
  onss $p |- ( A e. On -> A C_ On ) $=
    cA con0 wcel cA word cA con0 wss cA eloni cA ordsson syl $.
    $( [5-Jun-1994] $)

  ${
    $d x y A $.
    $( The union of a class of ordinal numbers is ordinal.  Proposition 7.19 of
       [TakeutiZaring] p. 40. $)
    ssorduni $p |- ( A C_ On -> Ord U. A ) $=
      cA cuni wtr cA cuni con0 wss cA cuni word cA con0 wss cA cuni wtr cA cuni
      con0 wss con0 word cA cuni word ordon cA cuni wtr cA cuni con0 wss con0
      word cA cuni word cA cuni con0 trssord 3exp mpii cA con0 wss vx cv cA
      cuni wss vx cA cuni wral cA cuni wtr cA con0 wss vx cv cA cuni wss vx cA
      cuni cA con0 wss vx cv vy cv wcel vy cA wrex vx cv cA cuni wss vx cv cA
      cuni wcel cA con0 wss vx cv vy cv wcel vx cv cA cuni wss vy cA cA con0
      wss vy cv cA wcel vx cv vy cv wcel vx cv vy cv wss vy cv cA wcel wa vx cv
      cA cuni wss cA con0 wss vy cv cA wcel vx cv vy cv wcel vx cv vy cv wss wi
      wi vy cv cA wcel vx cv vy cv wcel vx cv vy cv wss vy cv cA wcel wa wi wi
      cA con0 wss vy cv cA wcel vy cv con0 wcel vx cv vy cv wcel vx cv vy cv
      wss wi cA con0 vy cv ssel vy cv con0 wcel vy cv word vy cv wtr vx cv vy
      cv wcel vx cv vy cv wss wi vy cv eloni vy cv ordtr vy cv vx cv trss 3syl
      syl6 vy cv cA wcel vx cv vy cv wcel vx cv vy cv wss anc2r syl vx cv vy cv
      cA ssuni syl8 r19.23adv vy vx cv cA eluni2 syl5ib r19.21aiv vx cA cuni
      dftr3 sylibr cA con0 wss vx cA cuni con0 cA con0 wss vx cv vy cv wcel vy
      cA wrex vx cv con0 wcel vx cv cA cuni wcel cA con0 wss vx cv vy cv wcel
      vx cv con0 wcel vy cA cA con0 wss vy cv cA wcel vy cv con0 wcel vx cv vy
      cv wcel vx cv con0 wcel wi cA con0 vy cv ssel vy cv con0 wcel vy cv word
      vx cv vy cv wcel vx cv con0 wcel wi vy cv eloni vy cv word vx cv vy cv
      wcel vx cv word vx cv con0 wcel vy cv word vx cv vy cv wcel vx cv word vy
      cv vx cv ordelord ex vx cv vx visset elon syl6ibr syl syl6 r19.23adv vy
      vx cv cA eluni2 syl5ib ssrdv sylc $.
      $( [30-May-1994] $)
  $}

  $( The union of a set of ordinal numbers is an ordinal number.  Theorem 9 of
     [Suppes] p. 132. $)
  ssonuni $p |- ( A e. B -> ( A C_ On -> U. A e. On ) ) $=
    cA cB wcel cA cuni con0 wcel cA cuni word cA con0 wss cA cB wcel cA cuni
    cvv wcel cA cuni con0 wcel cA cuni word wb cA cB uniexg cA cuni cvv elong
    syl cA ssorduni syl5bir $.
    $( [3-Nov-2003] $) $( [1-Nov-2003] $)

  ${
    ssonuni.1 $e |- A e. _V $.
    $( The union of a set of ordinal numbers is an ordinal number.  Corollary
       7N(d) of [Enderton] p. 193. $)
    ssonunii $p |- ( A C_ On -> U. A e. On ) $=
      cA cvv wcel cA con0 wss cA cuni con0 wcel wi ssonuni.1 cA cvv ssonuni
      ax-mp $.
      $( [20-Sep-2003] $)
  $}

  $( The union of an ordinal number is an ordinal number. $)
  onuni $p |- ( A e. On -> U. A e. On ) $=
    cA con0 wcel cA con0 wss cA cuni con0 wcel cA onss cA con0 ssonuni mpd $.
    $( [1-Oct-2006] $) $( [29-Sep-2006] $)

  $( The union of an ordinal class is ordinal. $)
  orduni $p |- ( Ord A -> Ord U. A ) $=
    cA word cA con0 wss cA cuni word cA ordsson cA ssorduni syl $.
    $( [12-Sep-2003] $)

  ${
    $d x y z A $.
    $( The intersection (infimum) of a non-empty class of ordinal numbers
       belongs to the class.  Compare Exercise 4 of [TakeutiZaring] p. 45. $)
    onint $p |- ( ( A C_ On /\ A =/= (/) ) -> |^| A e. A ) $=
      cA con0 wss cA c0 wne cA cint cA wcel cA con0 wss cA vx cv cin c0 wceq vx
      cA wrex cA cint cA wcel cA con0 wss cA c0 wne wa cA con0 wss cA vx cv cin
      c0 wceq cA cint cA wcel vx cA cA con0 wss vx cv cA wcel cA vx cv cin c0
      wceq cA cint cA wcel wi cA con0 wss vx cv cA wcel cA vx cv cin c0 wceq vx
      cv cA wcel cA cint cA wcel cA con0 wss vx cv cA wcel cA vx cv cin c0 wceq
      vx cv cA wcel cA cint cA wcel wi cA con0 wss vx cv cA wcel cA vx cv cin
      c0 wceq wa wa vx cv cA wcel cA cint cA wcel cA con0 wss vx cv cA wcel cA
      vx cv cin c0 wceq wa wa vx cv cA cint cA cA con0 wss vx cv cA wcel cA vx
      cv cin c0 wceq wa wa vx cv cA cint cA con0 wss vx cv cA wcel cA vx cv cin
      c0 wceq wa wa vy vx cv cA cint cA con0 wss vx cv cA wcel cA vx cv cin c0
      wceq vy cv vx cv wcel vy cv cA cint wcel wi vy cv vx cv wcel cA con0 wss
      vx cv cA wcel cA vx cv cin c0 wceq vy cv cA cint wcel vy cv vx cv wcel cA
      con0 wss vx cv cA wcel cA vx cv cin c0 wceq vy cv cA cint wcel wi vy cv
      vx cv wcel cA con0 wss vx cv con0 wcel wa cA vx cv cin c0 wceq vy cv cA
      cint wcel wi cA con0 wss vx cv cA wcel wa vy cv vx cv wcel cA con0 wss vx
      cv con0 wcel wa wa vz cv vx cv wcel wn vz cA wral vy cv vz cv wcel vz cA
      wral cA vx cv cin c0 wceq vy cv cA cint wcel vy cv vx cv wcel cA con0 wss
      vx cv con0 wcel wa wa vz cv vx cv wcel wn vy cv vz cv wcel vz cA vy cv vx
      cv wcel cA con0 wss vx cv con0 wcel wa vz cv cA wcel vz cv vx cv wcel wn
      vy cv vz cv wcel wi cA con0 wss vx cv con0 wcel wa vz cv cA wcel vz cv vx
      cv wcel wn vy cv vx cv wcel vy cv vz cv wcel cA con0 wss vz cv cA wcel vz
      cv con0 wcel vx cv con0 wcel vz cv vx cv wcel wn vy cv vx cv wcel vy cv
      vz cv wcel wi wi cA con0 vz cv ssel vx cv con0 wcel vz cv con0 wcel vz cv
      vx cv wcel wn vy cv vx cv wcel vy cv vz cv wcel wi wi vx cv con0 wcel vz
      cv con0 wcel wa vz cv vx cv wcel wn vx cv vz cv wss vy cv vx cv wcel vy
      cv vz cv wcel wi vx cv vz cv ontri1 vx cv vz cv vy cv ssel syl6bir ex
      sylan9 com4r imp31 r19.20dva vz cA vx cv disj vz vy cv cA vy visset
      elint2 3imtr4g cA con0 wss vx cv cA wcel vx cv con0 wcel cA con0 vx cv
      ssel imdistani sylan2 exp32 com4l imp32 ssrdv vx cv cA wcel cA cint vx cv
      wss cA con0 wss cA vx cv cin c0 wceq vx cv cA intss1 ad2antrl eqssd
      eleq1d biimpd exp32 com34 pm2.43d r19.23adv con0 word cA con0 wss cA c0
      wne cA vx cv cin c0 wceq vx cA wrex ordon vx con0 cA tz7.5 mp3an1 syl5
      anabsi5 $.
      $( [18-Mar-2007] $) $( [31-Jan-1997] $)
  $}

  $( The intersection of a class of ordinal numbers is zero iff the class
     contains zero. $)
  onint0 $p |- ( A C_ On -> ( |^| A = (/) <-> (/) e. A ) ) $=
    cA con0 wss cA cint c0 wceq c0 cA wcel cA con0 wss cA cint c0 wceq c0 cA
    wcel cA con0 wss cA cint c0 wceq wa cA cint cA wcel c0 cA wcel cA con0 wss
    cA c0 wne cA cint cA wcel cA cint c0 wceq cA onint cA cint c0 wceq cA cint
    cvv wcel cA c0 wne cA cint c0 wceq cA cint cvv wcel c0 cvv wcel 0ex cA cint
    c0 cvv eleq1 mpbiri cA intex sylibr sylan2 cA cint c0 wceq cA cint cA wcel
    c0 cA wcel wb cA con0 wss cA cint c0 cA eleq1 adantl mpbid ex cA int0el
    impbid1 $.
    $( [14-May-2004] $) $( [24-Apr-2004] $)

  ${
    $d x y A $.
    $( A non-empty class of ordinal numbers has a smallest member.  Exercise
       9 of [TakeutiZaring] p. 40. $)
    onssmin $p |- ( ( A C_ On /\ A =/= (/) ) -> E. x e. A A. y e. A x C_ y ) $=
      cA cint cA wcel cA cint vy cv wss vy cA wral vx cv vy cv wss vy cA wral
      vx cA wrex cA con0 wss cA c0 wne wa vx cv vy cv wss vy cA wral cA cint vy
      cv wss vy cA wral vx cA cint cA vx cv cA cint wceq vx cv vy cv wss cA
      cint vy cv wss vy cA vx cv cA cint vy cv sseq1 ralbidv rcla4ev cA onint
      cA cint vy cv wss vy cA vy cv cA intss1 rgen sylancl $.
      $( [30-May-2007] $) $( [3-Oct-2003] $)
  $}

  ${
    $d x y $.  $d y ph $.
    onminsb.1 $e |- ( ps -> A. x ps ) $.
    onminsb.2 $e |- ( x = |^| { x e. On | ph } -> ( ph <-> ps ) ) $.
    $( If a property is true for some ordinal number, it is true for a minimal
       ordinal number.  This version uses implicit substitution.  Theorem
       Schema 62 of [Suppes] p. 228. $)
    onminsb $p |- ( E. x e. On ph -> ps ) $=
      wph vx con0 wrex wph vx con0 crab cint wph vx con0 crab wcel wps wph vx
      con0 wrex wph vx con0 crab c0 wne wph vx con0 crab cint wph vx con0 crab
      wcel wph vx con0 rabn0 wph vx con0 crab con0 wss wph vx con0 crab c0 wne
      wph vx con0 crab cint wph vx con0 crab wcel wph vx con0 ssrab2 wph vx
      con0 crab onint mpan sylbir wph vx con0 crab cint wph vx con0 crab wcel
      wph vx con0 crab cint con0 wcel wps wph wps vx vy wph vx con0 crab cint
      con0 vx vy wph vx con0 crab wph vx vy con0 hbrab1 hbint vy cv con0 wcel
      vx ax-17 onminsb.1 onminsb.2 elrabf pm3.27bi syl $.
      $( [3-Oct-2003] $) $( [3-Oct-2003] $)
  $}

  ${
    $d x y $.
    $( If a property is true for some ordinal number, it is true for a minimal
       ordinal number.  This version uses explicit substitution.  Theorem
       Schema 62 of [Suppes] p. 228. $)
    onminesb $p |- ( E. x e. On ph -> [ |^| { x e. On | ph } / x ] ph ) $=
      wph vx con0 wrex wph vx con0 crab cint wph vx con0 crab wcel wph vx wph
      vx con0 crab cint wsbc wph vx con0 wrex wph vx con0 crab c0 wne wph vx
      con0 crab cint wph vx con0 crab wcel wph vx con0 rabn0 wph vx con0 crab
      con0 wss wph vx con0 crab c0 wne wph vx con0 crab cint wph vx con0 crab
      wcel wph vx con0 ssrab2 wph vx con0 crab onint mpan sylbir wph vx con0
      crab cint wph vx con0 crab wcel wph vx con0 crab cint con0 wcel wph vx
      wph vx con0 crab cint wsbc wph vx vy wph vx con0 crab cint con0 vy cv
      con0 wcel vx ax-17 elrabsf pm3.27bi syl $.
      $( [29-Sep-2003] $)
  $}

  $( The intersection of a non-empty collection of ordinal numbers is an
     ordinal number.  Compare Exercise 6 of [TakeutiZaring] p. 44. $)
  oninton $p |- ( ( A C_ On /\ A =/= (/) ) -> |^| A e. On ) $=
    cA con0 wss cA c0 wne cA cint con0 wcel cA con0 wss cA c0 wne cA cint cA
    wcel cA cint con0 wcel cA con0 wss cA c0 wne cA cint cA wcel cA onint ex cA
    con0 cA cint ssel syld imp $.
    $( [20-Mar-2007] $) $( [29-Jan-1997] $)

  $( The intersection of a class of ordinal numbers exists iff it is an ordinal
     number. $)
  onintrab $p |- ( |^| { x e. On | ph } e. _V <->
                 |^| { x e. On | ph } e. On ) $=
    wph vx con0 crab cint cvv wcel wph vx con0 crab cint con0 wcel wph vx con0
    crab cint cvv wcel wph vx con0 crab c0 wne wph vx con0 crab cint con0 wcel
    wph vx con0 crab intex wph vx con0 crab con0 wss wph vx con0 crab c0 wne
    wph vx con0 crab cint con0 wcel wph vx con0 ssrab2 wph vx con0 crab oninton
    mpan sylbir wph vx con0 crab cint con0 elisset impbii $.
    $( [6-Nov-2003] $) $( [6-Nov-2003] $)

  $( An existence condition equivalent to an intersection's being an ordinal
     number. $)
  onintrab2 $p |- ( E. x e. On ph <-> |^| { x e. On | ph } e. On ) $=
    wph vx con0 wrex wph vx con0 crab cint cvv wcel wph vx con0 crab cint con0
    wcel wph vx con0 intexrab wph vx onintrab bitri $.
    $( [6-Nov-2003] $) $( [6-Nov-2003] $)

  $( No member of a set of ordinal numbers belongs to its minimum. $)
  onnmin $p |- ( ( A C_ On /\ B e. A ) -> -. B e. |^| A ) $=
    cA con0 wss cB cA wcel wa cA cint cB wss cB cA cint wcel wn cB cA wcel cA
    cint cB wss cA con0 wss cB cA intss1 adantl cA cint con0 wcel cB con0 wcel
    cA cint cB wss cB cA cint wcel wn wb cA con0 wss cB cA wcel wa cA cint cB
    ontri1 cA con0 wss cA c0 wne cA cint con0 wcel cB cA wcel cA oninton cA cB
    ne0i sylan2 cA con0 cB ssel2 sylanc mpbid $.
    $( [2-Feb-1997] $)

  ${
    $d x A $.  $d x ps $.
    onnminsb.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( An ordinal number smaller than the minimum of a set of ordinal numbers
       does not have the property determining that set.  ` ps ` is the wff
       resulting from the substitution of ` A ` for ` x ` in wff ` ph ` . $)
    onnminsb $p |- ( A e. On -> ( A e. |^| { x e. On | ph } -> -. ps ) ) $=
      cA con0 wcel wps cA wph vx con0 crab cint wcel cA con0 wcel wps cA wph vx
      con0 crab cint wcel wn cA con0 wcel wps wa cA wph vx con0 crab wcel cA
      wph vx con0 crab cint wcel wn wph wps vx cA con0 onnminsb.1 elrab wph vx
      con0 crab con0 wss cA wph vx con0 crab wcel cA wph vx con0 crab cint wcel
      wn wph vx con0 ssrab2 wph vx con0 crab cA onnmin mpan sylbir ex con2d $.
      $( [9-Nov-2003] $) $( [9-Nov-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( A way to show that an ordinal number equals the minimum of a non-empty
       collection of ordinal numbers: it must be in the collection, and it must
       not be larger than any member of the collection. $)
    oneqmin $p |- ( ( B C_ On /\ B =/= (/) ) -> ( A = |^| B <->
                  ( A e. B /\ A. x e. A -. x e. B ) ) ) $=
      cB con0 wss cB c0 wne wa cA cB cint wceq cA cB wcel vx cv cB wcel wn vx
      cA wral wa cB con0 wss cB c0 wne wa cA cB cint wceq cA cB wcel vx cv cB
      wcel wn vx cA wral cA cB cint wceq cA cB wcel cB cint cB wcel cB con0 wss
      cB c0 wne wa cA cB cint cB eleq1 cB onint syl5cbir cB con0 wss cA cB cint
      wceq vx cv cB wcel wn vx cA wral wi cB c0 wne cB con0 wss cA cB cint wceq
      vx cv cB wcel wn vx cA cA cB cint wceq vx cv cA wcel vx cv cB cint wcel
      cB con0 wss vx cv cB wcel wn cA cB cint wceq vx cv cA wcel vx cv cB cint
      wcel cA cB cint vx cv eleq2 biimpd cB con0 wss vx cv cB wcel vx cv cB
      cint wcel cB con0 wss vx cv cB wcel vx cv cB cint wcel wn cB vx cv onnmin
      ex con2d syl9r r19.21adv adantr jcad cB con0 wss cA cB wcel vx cv cB wcel
      wn vx cA wral wa cA cB cint wceq wi cB c0 wne vx cA cB oneqmini adantr
      impbid $.
      $( [10-May-2007] $) $( [14-Nov-2003] $)
  $}

  ${
    $d x y A $.
    bm2.5ii.1 $e |- A e. _V $.
    $( Problem 2.5(ii) of [BellMachover] p. 471. $)
    bm2.5ii $p |- ( A C_ On -> U. A = |^| { x e. On | A. y e. A y C_ x } ) $=
      cA con0 wss cA cuni con0 wcel cA cuni vy cv vx cv wss vy cA wral vx con0
      crab cint wceq cA bm2.5ii.1 ssonunii cA cuni con0 wcel cA cuni vx cv wss
      vx con0 crab cint cA cuni vy cv vx cv wss vy cA wral vx con0 crab cint vx
      cA cuni con0 intmin cA cuni vx cv wss vx con0 crab vy cv vx cv wss vy cA
      wral vx con0 crab cA cuni vx cv wss vy cv vx cv wss vy cA wral vx con0 cA
      cuni vx cv wss vy cv vx cv wss vy cA wral wb vx cv con0 wcel vy cA vx cv
      unissb a1i rabbii inteqi syl5reqr syl $.
      $( [20-Sep-2003] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    onminex.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( If a wff is true for an ordinal number, there is a smallest ordinal
       number for which it is true. $)
    onminex $p |- ( E. x e. On ph -> E. x e. On ( ph /\ A. y e. x -. ps ) ) $=
      vx cv con0 wcel wph wa vx wex vx cv con0 wcel wph wps wn vy vx cv wral wa
      wa vx wex wph vx con0 wrex wph wps wn vy vx cv wral wa vx con0 wrex vx cv
      con0 wcel wph wa vx cab c0 wne vx cv vx cv con0 wcel wph wa vx cab wcel
      vy cv vx cv wcel wps wn wi vy wal wa vx wex vx cv con0 wcel wph wa vx wex
      vx cv con0 wcel wph wps wn vy vx cv wral wa wa vx wex vx cv con0 wcel wph
      wa vx cab cint vx cv con0 wcel wph wa vx cab wcel vy cv vx cv con0 wcel
      wph wa vx cab cint wcel wps wn wi vy wal vx cv vx cv con0 wcel wph wa vx
      cab wcel vy cv vx cv wcel wps wn wi vy wal wa vx wex vx cv con0 wcel wph
      wa vx cab c0 wne vx cv con0 wcel wph wa vx cab cint vx cv con0 wcel wph
      wa vx cab wcel vy cv vx cv con0 wcel wph wa vx cab cint wcel wps wn wi vy
      wal vx cv vx cv con0 wcel wph wa vx cab wcel vy cv vx cv wcel wps wn wi
      vy wal wa vx wex vx cv vx cv con0 wcel wph wa vx cab wcel vy cv vx cv
      wcel wps wn wi vy wal wa vx cv con0 wcel wph wa vx cab cint vx cv con0
      wcel wph wa vx cab wcel vy cv vx cv con0 wcel wph wa vx cab cint wcel wps
      wn wi vy wal wa vx vy vx cv con0 wcel wph wa vx cab cint vx cv con0 wcel
      wph wa vx cab vx vy vx cv con0 wcel wph wa vx cab vx cv con0 wcel wph wa
      vx vy hbab1 hbint vx cv con0 wcel wph wa vx cab cint vx cv con0 wcel wph
      wa vx cab wcel vy cv vx cv con0 wcel wph wa vx cab cint wcel wps wn wi vy
      wal vx vx vy vy vx cv con0 wcel wph wa vx cab cint vx cv con0 wcel wph wa
      vx cab vx vy vx cv con0 wcel wph wa vx cab vx cv con0 wcel wph wa vx vy
      hbab1 hbint vx cv con0 wcel wph wa vx vy hbab1 hbel vy cv vx cv con0 wcel
      wph wa vx cab cint wcel wps wn wi vx vy vy cv vx cv con0 wcel wph wa vx
      cab cint wcel wps wn vx vx vy vx cv con0 wcel wph wa vx cab vx cv con0
      wcel wph wa vx vy hbab1 hbint wps wn vx ax-17 hbim hbal hban vx cv vx cv
      con0 wcel wph wa vx cab cint wceq vx cv vx cv con0 wcel wph wa vx cab
      wcel vx cv con0 wcel wph wa vx cab cint vx cv con0 wcel wph wa vx cab
      wcel vy cv vx cv wcel wps wn wi vy wal vy cv vx cv con0 wcel wph wa vx
      cab cint wcel wps wn wi vy wal vx cv vx cv con0 wcel wph wa vx cab cint
      vx cv con0 wcel wph wa vx cab eleq1 vx cv vx cv con0 wcel wph wa vx cab
      cint wceq vy cv vx cv wcel wps wn wi vy cv vx cv con0 wcel wph wa vx cab
      cint wcel wps wn wi vy vx cv vx cv con0 wcel wph wa vx cab cint wceq vy
      cv vx cv wcel vy cv vx cv con0 wcel wph wa vx cab cint wcel wps wn vx cv
      vx cv con0 wcel wph wa vx cab cint vy cv eleq2 imbi1d albidv anbi12d
      cla4egf anabsi5 vx cv con0 wcel wph wa vx cab con0 wss vx cv con0 wcel
      wph wa vx cab c0 wne vx cv con0 wcel wph wa vx cab cint vx cv con0 wcel
      wph wa vx cab wcel wph vx con0 ssab2 vx cv con0 wcel wph wa vx cab onint
      mpan vx cv con0 wcel wph wa vx cab c0 wne vy cv vx cv con0 wcel wph wa vx
      cab cint wcel wps wn wi vy vy cv vx cv con0 wcel wph wa vx cab cint wcel
      vx cv con0 wcel wph wa vx cab c0 wne vy cv con0 wcel wps wn vx cv con0
      wcel wph wa vx cab c0 wne vx cv con0 wcel wph wa vx cab cint con0 wcel vy
      cv vx cv con0 wcel wph wa vx cab cint wcel vy cv con0 wcel wi vx cv con0
      wcel wph wa vx cab con0 wss vx cv con0 wcel wph wa vx cab c0 wne vx cv
      con0 wcel wph wa vx cab cint con0 wcel wph vx con0 ssab2 vx cv con0 wcel
      wph wa vx cab oninton mpan vx cv con0 wcel wph wa vx cab cint con0 wcel
      vy cv vx cv con0 wcel wph wa vx cab cint wcel vy cv con0 wcel vx cv con0
      wcel wph wa vx cab cint vy cv onelon ex syl vy cv con0 wcel wps vy cv vx
      cv con0 wcel wph wa vx cab cint wcel vy cv con0 wcel wps vy cv vx cv con0
      wcel wph wa vx cab cint wcel wn vy cv con0 wcel wps wa vy cv vx cv con0
      wcel wph wa vx cab wcel vy cv vx cv con0 wcel wph wa vx cab cint wcel wn
      vx cv con0 wcel wph wa vy cv con0 wcel wps wa vx vy cv vy visset vx cv vy
      cv wceq vx cv con0 wcel vy cv con0 wcel wph wps vx cv vy cv con0 eleq1
      onminex.1 anbi12d elab vx cv con0 wcel wph wa vx cab con0 wss vy cv vx cv
      con0 wcel wph wa vx cab wcel vy cv vx cv con0 wcel wph wa vx cab cint
      wcel wn wph vx con0 ssab2 vx cv con0 wcel wph wa vx cab vy cv onnmin mpan
      sylbir ex con2d syli 19.21aiv sylanc vx cv con0 wcel wph wa vx abn0 vx cv
      vx cv con0 wcel wph wa vx cab wcel vy cv vx cv wcel wps wn wi vy wal wa
      vx cv con0 wcel wph wps wn vy vx cv wral wa wa vx vx cv vx cv con0 wcel
      wph wa vx cab wcel vy cv vx cv wcel wps wn wi vy wal wa vx cv con0 wcel
      wph wa wps wn vy vx cv wral wa vx cv con0 wcel wph wps wn vy vx cv wral
      wa wa vx cv con0 wcel wph wa vx cv vx cv con0 wcel wph wa vx cab wcel wps
      wn vy vx cv wral vy cv vx cv wcel wps wn wi vy wal vx cv vx cv con0 wcel
      wph wa vx cab wcel vx cv con0 wcel wph wa vx cv con0 wcel wph wa vx abid
      bicomi wps wn vy vx cv df-ral anbi12i vx cv con0 wcel wph wps wn vy vx cv
      wral anass bitr3i exbii 3imtr3i wph vx con0 df-rex wph wps wn vy vx cv
      wral wa vx con0 df-rex 3imtr4i $.
      $( [2-Feb-1997] $)
  $}

  $( The class of all ordinal numbers is its own successor. $)
  sucon $p |- suc On = On $=
    con0 cvv wcel wn con0 csuc con0 wceq onprc con0 sucprc ax-mp $.
    $( [12-Sep-2003] $)

  $( A successor exists iff its class argument exists. $)
  sucexb $p |- ( A e. _V <-> suc A e. _V ) $=
    cA cvv wcel cA csn cvv wcel wa cA cA csn cun cvv wcel cA cvv wcel cA csuc
    cvv wcel cA cA csn unexb cA csn cvv wcel cA cvv wcel cA snex biantru cA
    csuc cA cA csn cun cvv cA df-suc eleq1i 3bitr4i $.
    $( [22-Jun-1998] $)

  $( The successor of a set is a set (generalization). $)
  sucexg $p |- ( A e. B -> suc A e. _V ) $=
    cA cB wcel cA cvv wcel cA csuc cvv wcel cA cB elisset cA sucexb sylib $.
    $( [5-Jun-1994] $)

  ${
    sucex.1 $e |- A e. _V $.
    $( The successor of a set is a set. $)
    sucex $p |- suc A e. _V $=
      cA cvv wcel cA csuc cvv wcel sucex.1 cA cvv sucexg ax-mp $.
      $( [30-Aug-1993] $)
  $}

  ${
    $d x A $.
    $( The minimum of a class of ordinal numbers is less than the minimum
       of that class with its minimum removed. $)
    onmindif2 $p |- ( ( A C_ On /\ A =/= (/) ) ->
                   |^| A e. |^| ( A \ { |^| A } ) ) $=
      cA con0 wss cA c0 wne wa cA cint cA cA cint csn cdif cint wcel cA cint vx
      cv wcel vx cA cA cint csn cdif wral cA con0 wss cA c0 wne wa cA cint vx
      cv wcel vx cA cA cint csn cdif cA con0 wss cA c0 wne wa vx cv cA wcel vx
      cv cA cint wne wa cA cint vx cv wcel vx cv cA cA cint csn cdif wcel cA
      con0 wss cA c0 wne wa vx cv cA wcel vx cv cA cint wne cA cint vx cv wcel
      cA con0 wss cA c0 wne wa vx cv cA wcel wa cA cint vx cv wcel vx cv cA
      cint cA con0 wss cA c0 wne wa vx cv cA wcel wa cA cint vx cv wcel wn cA
      cint vx cv wceq vx cv cA cint wceq cA con0 wss cA c0 wne wa vx cv cA wcel
      wa cA cint vx cv wcel cA cint vx cv wceq cA con0 wss cA c0 wne wa vx cv
      cA wcel wa vx cv cA cint wcel wn cA cint vx cv wcel cA cint vx cv wceq wo
      cA con0 wss vx cv cA wcel vx cv cA cint wcel wn cA c0 wne cA vx cv onnmin
      adantlr cA cint con0 wcel vx cv con0 wcel vx cv cA cint wcel wn cA cint
      vx cv wcel cA cint vx cv wceq wo wb cA con0 wss cA c0 wne wa vx cv cA
      wcel wa cA cint con0 wcel vx cv con0 wcel wa cA cint vx cv wss vx cv cA
      cint wcel wn cA cint vx cv wcel cA cint vx cv wceq wo cA cint vx cv
      ontri1 cA cint vx cv onsseleq bitr3d cA con0 wss cA c0 wne wa cA cint
      con0 wcel vx cv cA wcel cA oninton adantr cA con0 wss vx cv cA wcel vx cv
      con0 wcel cA c0 wne cA con0 vx cv ssel2 adantlr sylanc mpbid ord cA cint
      vx cv eqcom syl6ib necon1ad expimpd vx cv cA cA cint eldifsn syl5ib
      r19.21aiv cA c0 wne cA cint cA cA cint csn cdif cint wcel cA cint vx cv
      wcel vx cA cA cint csn cdif wral wb cA con0 wss cA c0 wne cA cint cvv
      wcel cA cint cA cA cint csn cdif cint wcel cA cint vx cv wcel vx cA cA
      cint csn cdif wral wb cA intex vx cA cint cA cA cint csn cdif cvv elintg
      sylbi adantl mpbird $.
      $( [28-May-2007] $) $( [20-Nov-2003] $)
  $}

  ${
    $d x A $.
    $( The successor of an ordinal number is an ordinal number.  Proposition
       7.24 of [TakeutiZaring] p. 41. $)
    suceloni $p |- ( A e. On -> suc A e. On ) $=
      cA con0 wcel cA csuc con0 wcel cA csuc word cA csuc wtr cA csuc con0 wss
      cA csuc word cA con0 wcel cA csuc wtr cA csuc con0 wss con0 word cA csuc
      word ordon cA csuc wtr cA csuc con0 wss con0 word cA csuc word cA csuc
      con0 trssord 3exp mpii cA con0 wcel vx cv cA csuc wss vx cA csuc wral cA
      csuc wtr cA con0 wcel vx cv cA csuc wss vx cA csuc cA con0 wcel vx cv cA
      csuc wcel vx cv cA wss vx cv cA csuc wss cA con0 wcel vx cv cA wcel vx cv
      cA csn wcel wo vx cv cA wss vx cv cA wss wo vx cv cA csuc wcel vx cv cA
      wss cA con0 wcel vx cv cA wcel vx cv cA wss vx cv cA csn wcel vx cv cA
      wss cA vx cv onelss vx cv cA csn wcel vx cv cA wss wi cA con0 wcel vx cv
      cA csn wcel vx cv cA wceq vx cv cA wss vx cA elsn vx cv cA eqimss sylbi
      a1i orim12d vx cv cA csuc wcel vx cv cA cA csn cun wcel vx cv cA wcel vx
      cv cA csn wcel wo cA csuc cA cA csn cun vx cv cA df-suc eleq2i vx cv cA
      cA csn elun bitr2i vx cv cA wss oridm 3imtr3g vx cv cA wss cA cA csuc wss
      vx cv cA csuc wss cA sssucid vx cv cA cA csuc sstr2 mpi syl6 r19.21aiv vx
      cA csuc dftr3 sylibr cA con0 wcel cA cA csn cun con0 cA csuc cA con0 wcel
      cA con0 wss cA csn con0 wss wa cA cA csn cun con0 wss cA con0 wcel cA
      con0 wss cA csn con0 wss cA onss cA con0 snssi jca cA cA csn con0 unss
      sylib cA df-suc syl5ss sylc cA con0 wcel cA csuc cvv wcel cA csuc con0
      wcel cA csuc word wb cA con0 sucexg cA csuc cvv elong syl mpbird $.
      $( [6-Jun-1994] $)
  $}

  $( The successor of an ordinal class is ordinal. $)
  ordsuc $p |- ( Ord A <-> Ord suc A ) $=
    cA cvv wcel cA word cA csuc word wb cA cvv wcel cA word cA csuc word cA cvv
    wcel cA word cA con0 wcel cA csuc word cA cvv elong cA con0 wcel cA csuc
    con0 wcel cA csuc word cA suceloni cA csuc eloni syl syl6bir cA csuc word
    cA cA csuc wcel cA word cA cvv wcel cA csuc word cA cA csuc wcel cA word cA
    csuc cA ordelord ex cA cvv sucidg syl5com impbid cA cvv wcel wn cA cA csuc
    wceq cA word cA csuc word wb cA cvv wcel wn cA csuc cA cA sucprc eqcomd cA
    cA csuc ordeq syl pm2.61i $.
    $( [3-Apr-1995] $)

  ${
    $d x A $.
    $( The collection of ordinals in the power class of an ordinal is its
       successor. $)
    ordpwsuc $p |- ( Ord A -> ( ~P A i^i On ) = suc A ) $=
      cA word vx cA cpw con0 cin cA csuc cA word vx cv con0 wcel vx cv cA wss
      wa vx cv cA csuc wcel vx cv cA cpw con0 cin wcel cA word vx cv con0 wcel
      vx cv cA wss wa vx cv con0 wcel vx cv cA csuc wcel wa vx cv cA csuc wcel
      cA word vx cv con0 wcel vx cv cA wss vx cv cA csuc wcel vx cv con0 wcel
      cA word vx cv cA wss vx cv cA csuc wcel wb vx cv cA ordsssuc expcom
      pm5.32d cA word vx cv con0 wcel vx cv cA csuc wcel wa vx cv cA csuc wcel
      vx cv con0 wcel vx cv cA csuc wcel pm3.27 cA word vx cv cA csuc wcel vx
      cv con0 wcel cA word cA csuc word vx cv cA csuc wcel vx cv con0 wcel wi
      cA ordsuc cA csuc word vx cv cA csuc wcel vx cv con0 wcel cA csuc vx cv
      ordelon ex sylbi ancrd impbid2 bitrd vx cv cA cpw con0 cin wcel vx cv cA
      cpw wcel vx cv con0 wcel wa vx cv cA wss vx cv con0 wcel wa vx cv con0
      wcel vx cv cA wss wa vx cv cA cpw con0 elin vx cv cA cpw wcel vx cv cA
      wss vx cv con0 wcel vx cv cA vx visset elpw anbi1i vx cv cA wss vx cv
      con0 wcel ancom 3bitri syl5bb eqrdv $.
      $( [31-Jan-2005] $) $( [30-Jan-2005] $)

    $( The collection of ordinal numbers in the power set of an ordinal
       number is its successor. $)
    onpwsuc $p |- ( A e. On -> ( ~P A i^i On ) = suc A ) $=
      cA con0 wcel cA word cA cpw con0 cin cA csuc wceq cA eloni cA ordpwsuc
      syl $.
      $( [19-Oct-2004] $) $( [19-Oct-2004] $)
  $}

  $( The successor of an ordinal number is an ordinal number. $)
  sucelon $p |- ( A e. On <-> suc A e. On ) $=
    cA word cA cvv wcel wa cA csuc word cA csuc cvv wcel wa cA con0 wcel cA
    csuc con0 wcel cA word cA csuc word cA cvv wcel cA csuc cvv wcel cA ordsuc
    cA sucexb anbi12i cA elon2 cA csuc elon2 3bitr4i $.
    $( [9-Sep-2003] $)

  $( The successor of an element of an ordinal class is a subset of it. $)
  ordsucss $p |- ( Ord B -> ( A e. B -> suc A C_ B ) ) $=
    cB word cA cB wcel cA csuc cB wss cA cB wcel cB word cA cB wcel cA csuc cB
    wss wi cB word cA cB wcel cB word cA cB wcel cA csuc cB wss wi cA word cB
    word cA cB wcel cA csuc cB wss wi cB word cA cB wcel wa cA word cB word wa
    cA cB wcel cB cA csuc wcel wn cA csuc cB wss cA word cA cB wcel cB cA csuc
    wcel wn wi cB word cA word cA cB wcel cB cA csuc wcel wa wn cA cB wcel cB
    cA csuc wcel wn wi cA cB ordnbtwn cA cB wcel cB cA csuc wcel imnan sylibr
    adantr cA csuc word cB word cA csuc cB wss cB cA csuc wcel wn wb cA word cA
    csuc cB ordtri1 cA ordsuc sylanb sylibrd cB cA ordelord sylan exp31 pm2.43b
    pm2.43b $.
    $( [21-Jun-1998] $)

  $( A set belongs to an ordinal iff its successor is a subset of the
     ordinal.  Exercise 8 of [TakeutiZaring] p. 42 and its converse. $)
  ordelsuc $p |- ( ( A e. C /\ Ord B ) -> ( A e. B <-> suc A C_ B ) ) $=
    cA cC wcel cB word wa cA cB wcel cA csuc cB wss cB word cA cB wcel cA csuc
    cB wss wi cA cC wcel cA cB ordsucss adantl cA cC wcel cA csuc cB wss cA cB
    wcel wi cB word cA cB cC sucssel adantr impbid $.
    $( [29-Nov-2003] $) $( [29-Nov-2003] $)

  ${
    $d x A $.
    $( The successor of an ordinal number is the smallest larger ordinal
       number. $)
    onsucmin $p |- ( A e. On -> suc A = |^| { x e. On | A e. x } ) $=
      cA con0 wcel cA vx cv wcel vx con0 crab cint cA csuc vx cv wss vx con0
      crab cint cA csuc cA con0 wcel cA vx cv wcel vx con0 crab cA csuc vx cv
      wss vx con0 crab cA con0 wcel cA vx cv wcel cA csuc vx cv wss vx con0 cA
      con0 wcel vx cv word cA vx cv wcel cA csuc vx cv wss wb vx cv con0 wcel
      cA vx cv con0 ordelsuc vx cv eloni sylan2 rabbidv inteqd cA con0 wcel cA
      csuc con0 wcel cA csuc vx cv wss vx con0 crab cint cA csuc wceq cA
      sucelon vx cA csuc con0 intmin sylbi eqtr2d $.
      $( [8-Dec-2003] $) $( [28-Nov-2003] $)
  $}

  $( Membership is inherited by successors.  Generalization of Exercise
     9 of [TakeutiZaring] p. 42. $)
  ordsucelsuc $p |- ( Ord B -> ( A e. B <-> suc A e. suc B ) ) $=
    cB word cA cB wcel cA csuc cB csuc wcel cB word cA cB wcel cA csuc cB csuc
    wcel cA cB wcel cB word cA cB wcel cA csuc cB csuc wcel wi cB word cA cB
    wcel cB word cA cB wcel cA csuc cB csuc wcel wi cA word cB word cA cB wcel
    cA csuc cB csuc wcel wi cB word cA cB wcel wa cA word cB word wa cA cB wcel
    cA csuc cB csuc wcel cA cvv wcel cA word cB word wa cA cB wcel cA csuc cB
    csuc wcel wb wi cA cvv wcel cA word cB word wa cA cB wcel cA csuc cB csuc
    wcel wb cA cvv wcel cA word cB word wa wa cA csuc cB wss cA csuc cB wcel cA
    csuc cB wceq wo cA cB wcel cA csuc cB csuc wcel cA word cB word wa cA csuc
    cB wss cA csuc cB wcel cA csuc cB wceq wo wb cA cvv wcel cA csuc word cB
    word cA csuc cB wss cA csuc cB wcel cA csuc cB wceq wo wb cA word cA csuc
    cB ordsseleq cA ordsuc sylanb adantl cA cvv wcel cA word cB word wa wa cA
    cB wcel cA csuc cB wss cB word cA cB wcel cA csuc cB wss wi cA cvv wcel cA
    word cA cB ordsucss ad2antll cA cvv wcel cA csuc cB wss cA cB wcel wi cA
    word cB word wa cA cB cvv sucssel adantr impbid cA cvv wcel cA csuc cB csuc
    wcel cA csuc cB wcel cA csuc cB wceq wo wb cA word cB word wa cA cvv wcel
    cA csuc cvv wcel cA csuc cB csuc wcel cA csuc cB wcel cA csuc cB wceq wo wb
    cA sucexb cA csuc cB cvv elsucg sylbi adantr 3bitr4d ex cA cvv wcel wn cA
    cB wcel cA csuc cB csuc wcel wb cA word cB word wa cA cB wcel cA cvv wcel
    cA csuc cB csuc wcel cA cB elisset cA csuc cB csuc wcel cA csuc cvv wcel cA
    cvv wcel cA csuc cB csuc elisset cA sucexb sylibr pm5.21ni a1d pm2.61i
    biimpd cB cA ordelord sylan exp31 pm2.43a pm2.43d cB word cA csuc cB csuc
    wcel cA cB wcel cA csuc cB csuc wcel cB word cA csuc cB csuc wcel cA cB
    wcel wi cB word cA csuc cB csuc wcel cB word cA csuc cB csuc wcel cA cB
    wcel wi cA word cB word cA csuc cB csuc wcel cA cB wcel wi cB word cA csuc
    cB csuc wcel wa cA word cB word wa cA cB wcel cA csuc cB csuc wcel cA cvv
    wcel cA word cB word wa cA cB wcel cA csuc cB csuc wcel wb wi cA cvv wcel
    cA word cB word wa cA cB wcel cA csuc cB csuc wcel wb cA cvv wcel cA word
    cB word wa wa cA csuc cB wss cA csuc cB wcel cA csuc cB wceq wo cA cB wcel
    cA csuc cB csuc wcel cA word cB word wa cA csuc cB wss cA csuc cB wcel cA
    csuc cB wceq wo wb cA cvv wcel cA csuc word cB word cA csuc cB wss cA csuc
    cB wcel cA csuc cB wceq wo wb cA word cA csuc cB ordsseleq cA ordsuc sylanb
    adantl cA cvv wcel cA word cB word wa wa cA cB wcel cA csuc cB wss cB word
    cA cB wcel cA csuc cB wss wi cA cvv wcel cA word cA cB ordsucss ad2antll cA
    cvv wcel cA csuc cB wss cA cB wcel wi cA word cB word wa cA cB cvv sucssel
    adantr impbid cA cvv wcel cA csuc cB csuc wcel cA csuc cB wcel cA csuc cB
    wceq wo wb cA word cB word wa cA cvv wcel cA csuc cvv wcel cA csuc cB csuc
    wcel cA csuc cB wcel cA csuc cB wceq wo wb cA sucexb cA csuc cB cvv elsucg
    sylbi adantr 3bitr4d ex cA cvv wcel wn cA cB wcel cA csuc cB csuc wcel wb
    cA word cB word wa cA cB wcel cA cvv wcel cA csuc cB csuc wcel cA cB
    elisset cA csuc cB csuc wcel cA csuc cvv wcel cA cvv wcel cA csuc cB csuc
    elisset cA sucexb sylibr pm5.21ni a1d pm2.61i biimprd cB csuc word cA csuc
    cB csuc wcel cA word cB word cB csuc word cA csuc cB csuc wcel wa cA csuc
    word cA word cB csuc cA csuc ordelord cA ordsuc sylibr cB ordsuc sylanb
    sylan exp31 pm2.43a pm2.43d impbid $.
    $( [22-Jun-1998] $)

  $( The subclass relationship between two ordinal classes is inherited by
     their successors. $)
  ordsucsssuc $p |- ( ( Ord A /\ Ord B ) -> ( A C_ B <-> suc A C_ suc B ) ) $=
    cA word cB word wa cB cA wcel wn cB csuc cA csuc wcel wn cA cB wss cA csuc
    cB csuc wss cA word cB cA wcel wn cB csuc cA csuc wcel wn wb cB word cA
    word cB cA wcel cB csuc cA csuc wcel cB cA ordsucelsuc notbid adantr cA cB
    ordtri1 cA csuc word cB csuc word cA csuc cB csuc wss cB csuc cA csuc wcel
    wn wb cA word cB word cA csuc cB csuc ordtri1 cA ordsuc cB ordsuc syl2anb
    3bitr4d $.
    $( [4-Oct-2003] $) $( [4-Oct-2003] $)

  ${
    $d x A $.  $d x B $.
    $( The successor of the maximum (i.e. union) of two ordinals is the
       maximum of their successors. $)
    ordsucun $p |- ( ( Ord A /\ Ord B ) ->
               suc ( A u. B ) = ( suc A u. suc B ) ) $=
      cA word cB word wa vx cA cB cun csuc cA csuc cB csuc cun cA word cB word
      wa vx cv con0 wcel vx cv cA cB cun csuc wcel wa vx cv con0 wcel vx cv cA
      csuc cB csuc cun wcel wa vx cv cA cB cun csuc wcel vx cv cA csuc cB csuc
      cun wcel cA word cB word wa vx cv con0 wcel vx cv cA cB cun csuc wcel vx
      cv cA csuc cB csuc cun wcel vx cv con0 wcel cA word cB word wa vx cv cA
      cB cun csuc wcel vx cv cA csuc cB csuc cun wcel wb vx cv con0 wcel cA
      word cB word wa wa vx cv cA cB cun csuc wcel vx cv cA csuc wcel vx cv cB
      csuc wcel wo vx cv cA csuc cB csuc cun wcel vx cv con0 wcel cA word cB
      word wa wa vx cv cA cB cun wss vx cv cA wss vx cv cB wss wo vx cv cA cB
      cun csuc wcel vx cv cA csuc wcel vx cv cB csuc wcel wo cA word cB word wa
      vx cv cA cB cun wss vx cv cA wss vx cv cB wss wo wb vx cv con0 wcel vx cv
      cA cB ordssun adantl vx cv con0 wcel cA cB cun word vx cv cA cB cun wss
      vx cv cA cB cun csuc wcel wb cA word cB word wa vx cv cA cB cun ordsssuc
      cA cB ordun sylan2 vx cv con0 wcel cA word cB word wa wa vx cv cA wss vx
      cv cA csuc wcel vx cv cB wss vx cv cB csuc wcel vx cv con0 wcel cA word
      vx cv cA wss vx cv cA csuc wcel wb cB word vx cv cA ordsssuc adantrr vx
      cv con0 wcel cB word vx cv cB wss vx cv cB csuc wcel wb cA word vx cv cB
      ordsssuc adantrl orbi12d 3bitr3d vx cv cA csuc cB csuc elun syl6bbr
      expcom pm5.32d cA word cB word wa vx cv cA cB cun csuc wcel vx cv con0
      wcel cA word cB word wa cA cB cun word vx cv cA cB cun csuc wcel vx cv
      con0 wcel wi cA cB ordun cA cB cun word cA cB cun csuc word vx cv cA cB
      cun csuc wcel vx cv con0 wcel wi cA cB cun ordsuc cA cB cun csuc word vx
      cv cA cB cun csuc wcel vx cv con0 wcel cA cB cun csuc vx cv ordelon ex
      sylbi syl pm4.71rd cA word cB word wa vx cv cA csuc cB csuc cun wcel vx
      cv con0 wcel cA csuc word cB csuc word vx cv cA csuc cB csuc cun wcel vx
      cv con0 wcel wi cA word cB word cA csuc word cB csuc word wa cA csuc cB
      csuc cun word vx cv cA csuc cB csuc cun wcel vx cv con0 wcel wi cA csuc
      cB csuc ordun cA csuc cB csuc cun word vx cv cA csuc cB csuc cun wcel vx
      cv con0 wcel cA csuc cB csuc cun vx cv ordelon ex syl cA ordsuc cB ordsuc
      syl2anb pm4.71rd 3bitr4d eqrdv $.
      $( [7-Feb-2004] $) $( [28-Nov-2003] $)
  $}

  $( The maximum of two ordinals belongs to a third if each of them do. $)
  ordunel $p |- ( ( Ord A /\ B e. A /\ C e. A ) -> ( B u. C ) e. A ) $=
    cA word cB cA wcel cC cA wcel w3a cB csuc cA wss cC csuc cA wss wa cB cC
    cun cA wcel cA word cB cA wcel cC cA wcel cB csuc cA wss cC csuc cA wss wa
    cA word cB cA wcel cB csuc cA wss cC cA wcel cC csuc cA wss cB cA ordsucss
    cC cA ordsucss anim12d 3impib cA word cB cA wcel cC cA wcel w3a cB csuc cC
    csuc cun cA wss cB cC cun cA wcel cB csuc cA wss cC csuc cA wss wa cA word
    cB cA wcel cC cA wcel w3a cB csuc cC csuc cun cA wss cB cC cun csuc cA wss
    cB cC cun cA wcel cA word cB cA wcel cC cA wcel w3a cB cC cun csuc cA wss
    cB csuc cC csuc cun cA wss cA word cB cA wcel cC cA wcel w3a cB cC cun csuc
    cB csuc cC csuc cun cA cB word cC word cB cC cun csuc cB csuc cC csuc cun
    wceq cA word cB cA wcel cC cA wcel w3a cB cC ordsucun cA word cB cA wcel cB
    word cC cA wcel cA cB ordelord 3adant3 cA word cC cA wcel cC word cB cA
    wcel cA cC ordelord 3adant2 sylanc sseq1d biimprd cB cC cun cvv wcel cA
    word cB cC cun cA wcel cB cC cun csuc cA wss wb cA word cB cA wcel cC cA
    wcel w3a cB cC cun cA cvv ordelsuc cB cA wcel cC cA wcel cB cC cun cvv wcel
    cA word cB cC cA cA unexg 3adant1 cA word cB cA wcel cC cA wcel 3simp1
    sylanc sylibrd cB csuc cC csuc cA unss syl5ib mpd $.
    $( [19-Sep-2006] $) $( [18-Sep-2006] $)

  $( A class of ordinal numbers is a subclass of the successor of its
     union.  Similar to Proposition 7.26 of [TakeutiZaring] p. 41. $)
  onsucuni $p |- ( A C_ On -> A C_ suc U. A ) $=
    cA con0 wss cA cuni word cA cA cuni csuc wss cA ssorduni cA con0 wss cA
    cuni word wa cA cuni cA cuni wss cA cA cuni csuc wss cA cuni ssid cA cA
    cuni ordunisssuc mpbii mpdan $.
    $( [19-Sep-2003] $)

  $( An ordinal class is a subclass of the successor of its union. $)
  ordsucuni $p |- ( Ord A -> A C_ suc U. A ) $=
    cA word cA con0 wss cA cA cuni csuc wss cA ordsson cA onsucuni syl $.
    $( [12-Sep-2003] $)

  $( An ordinal class is either its union or the successor of its union. $)
  orduniorsuc $p |- ( Ord A -> ( A = U. A \/ A = suc U. A ) ) $=
    cA word cA cA cuni wceq cA cA cuni csuc wceq cA word cA cuni cA wne cA cA
    cuni csuc wss cA cuni csuc cA wss wa cA cA cuni wceq wn cA cA cuni csuc
    wceq cA word cA cuni cA wne cA cuni csuc cA wss cA cA cuni csuc wss cA word
    cA cuni cA wne cA cuni cA wcel cA cuni csuc cA wss cA word cA cuni cA wss
    cA cuni cA wne cA cuni cA wcel cA orduniss cA word cA cuni cA wcel cA cuni
    cA wss cA cuni cA wne wa cA cuni word cA word cA cuni cA wcel cA cuni cA
    wss cA cuni cA wne wa wb cA orduni cA cuni cA ordelssne mpancom biimprd
    mpand cA cuni cA ordsucss syld cA ordsucuni jctild cA cA cuni wceq wn cA cA
    cuni wne cA cuni cA wne cA cA cuni df-ne cA cA cuni necom bitr3i cA cA cuni
    csuc eqss 3imtr4g orrd $.
    $( [13-Sep-2003] $)

  ${
    $d x y A $.
    $( The class of all ordinal numbers is its own union.  Exercise 11 of
       [TakeutiZaring] p. 40. $)
    unon $p |- U. On = On $=
      vx con0 cuni con0 vx cv con0 cuni wcel vx cv con0 wcel vx cv con0 cuni
      wcel vx cv vy cv wcel vy con0 wrex vx cv con0 wcel vy vx cv con0 eluni2
      vx cv vy cv wcel vx cv con0 wcel vy con0 vy cv vx cv onelon r19.23aiva
      sylbi vx cv vx cv csuc wcel vx cv csuc con0 wcel vx cv con0 cuni wcel vx
      cv con0 wcel vx cv vx cv csuc con0 elunii vx cv vx visset sucid vx cv
      suceloni sylancr impbii eqriv $.
      $( [12-Nov-2003] $) $( [12-Nov-2003] $)

    $( An ordinal class is equal to the union of its successor. $)
    ordunisuc $p |- ( Ord A -> U. suc A = A ) $=
      cA word cA con0 wcel cA con0 wceq wo cA csuc cuni cA wceq cA ordeleqon cA
      con0 wcel cA csuc cuni cA wceq cA con0 wceq vx cv csuc cuni vx cv wceq cA
      csuc cuni cA wceq vx cA con0 vx cv cA wceq vx cv csuc cuni cA csuc cuni
      vx cv cA vx cv cA wceq vx cv csuc cA csuc vx cv cA suceq unieqd vx cv cA
      wceq id eqeq12d vx cv con0 wcel vx cv wtr vx cv csuc cuni vx cv wceq vx
      cv con0 wcel vx cv word vx cv wtr vx cv eloni vx cv ordtr syl vx cv vx
      visset unisuc sylib vtoclga cA con0 wceq cA csuc cuni cA cuni cA cA con0
      wceq cA csuc cA cA con0 wceq cA cvv wcel wn cA csuc cA wceq cA con0 wceq
      cA cvv wcel con0 cvv wcel onprc cA con0 cvv eleq1 mtbiri cA sucprc syl
      unieqd cA con0 wceq con0 cuni con0 cA cuni cA unon cA con0 unieq cA con0
      wceq id 3eqtr4a eqtrd jaoi sylbi $.
      $( [24-Dec-2004] $) $( [10-Dec-2004] $)

    $( The union of the ordinal subsets of an ordinal number is that number. $)
    orduniss2 $p |- ( Ord A -> U. { x e. On | x C_ A } = A ) $=
      cA word vx cv cA wss vx con0 crab cuni cA csuc cuni cA cA word vx cv cA
      wss vx con0 crab cA csuc cA word cA cpw con0 cin cA csuc vx cv cA wss vx
      con0 crab cA ordpwsuc vx cv cA wss vx con0 crab vx cv con0 wcel vx cv cA
      wss wa vx cab vx cv cA wss vx cab vx cv con0 wcel vx cab cin cA cpw con0
      cin vx cv cA wss vx con0 df-rab vx cv con0 wcel vx cab vx cv cA wss vx
      cab cin vx cv con0 wcel vx cv cA wss wa vx cab vx cv cA wss vx cab vx cv
      con0 wcel vx cab cin vx cv con0 wcel vx cv cA wss vx inab vx cv con0 wcel
      vx cab vx cv cA wss vx cab incom eqtr3i vx cv cA wss vx cab cA cpw vx cv
      con0 wcel vx cab con0 cA cpw vx cv cA wss vx cab vx cA df-pw eqcomi vx
      con0 abid2 ineq12i 3eqtri syl5eq unieqd cA ordunisuc eqtrd $.
      $( [28-Feb-2005] $) $( [30-Jan-2005] $)
  $}

  $( A successor ordinal is the successor of its union. $)
  onsucuni2 $p |- ( ( A e. On /\ A = suc B ) -> suc U. A = A ) $=
    cA con0 wcel cA cB csuc wceq wa cA cA cuni csuc cA con0 wcel cA cB csuc
    wceq wa cA cA cuni wceq wn cA cA cuni csuc wceq cA con0 wcel cA cB csuc
    wceq wa cB con0 wcel cA cA cuni wceq wn cA cB csuc wceq cA con0 wcel cB
    con0 wcel cA cB csuc wceq cA con0 wcel cB csuc con0 wcel cB con0 wcel cA cB
    csuc con0 eleq1 cB sucelon syl6bbr biimpac cA cB csuc wceq cB con0 wcel cA
    cA cuni wceq wn wi cA con0 wcel cA cB csuc wceq cB con0 wcel cA cA cuni
    wceq wn cA cB csuc wceq cB con0 wcel wa cA cA cuni wceq cB csuc cB csuc
    cuni wceq cB con0 wcel cB csuc cB csuc cuni wceq wn cA cB csuc wceq cB con0
    wcel cB csuc cB csuc cuni wceq cB csuc cB wceq cB con0 wcel cB csuc cB wceq
    cB cB wcel cB con0 wcel cB word cB cB wcel wn cB eloni cB ordirr syl cB
    csuc cB wceq cB cB csuc wcel cB cB wcel cB con0 wcel cB csuc cB cB eleq2 cB
    con0 sucidg syl5cbi mtod cB con0 wcel cB csuc cuni cB cB csuc cB con0 wcel
    cB word cB csuc cuni cB wceq cB eloni cB ordunisuc syl eqeq2d mtbird adantl
    cA cB csuc wceq cA cA cuni wceq cB csuc cB csuc cuni wceq wb cB con0 wcel
    cA cB csuc wceq cA cB csuc cA cuni cB csuc cuni cA cB csuc wceq id cA cB
    csuc unieq eqeq12d adantr mtbird ex adantl mpd cA con0 wcel cA cA cuni wceq
    wn cA cA cuni csuc wceq wi cA cB csuc wceq cA con0 wcel cA word cA cA cuni
    wceq wn cA cA cuni csuc wceq wi cA eloni cA word cA cA cuni wceq cA cA cuni
    csuc wceq cA orduniorsuc ord syl adantr mpd eqcomd $.
    $( [1-Mar-2005] $) $( [10-Dec-2004] $)

  $( The successor of an ordinal class contains the empty set. $)
  0elsuc $p |- ( Ord A -> (/) e. suc A ) $=
    cA word cA csuc word c0 cA csuc wcel cA ordsuc cA csuc word c0 cA csuc wcel
    cA csuc c0 wne cA nsuceq0 cA csuc ord0eln0 mpbiri sylbi $.
    $( [4-Apr-1995] $)

  $( The class of ordinal numbers is a limit ordinal. $)
  limon $p |- Lim On $=
    con0 wlim con0 word con0 c0 wne con0 con0 cuni wceq w3a con0 word con0 c0
    wne con0 con0 cuni wceq ordon onn0 con0 cuni con0 unon eqcomi 3pm3.2i con0
    df-lim mpbir $.
    $( [24-Mar-1995] $)

  ${
    onssi.1 $e |- A e. On $.
    $( An ordinal number is a subset of ` On ` . $)
    onssi $p |- A C_ On $=
      cA con0 wcel cA con0 wss onssi.1 cA onss ax-mp $.
      $( [11-Aug-1994] $)

    $( The successor of an ordinal number is an ordinal number.  Corollary
       7N(c) of [Enderton] p. 193. $)
    onsuci $p |- suc A e. On $=
      cA con0 wcel cA csuc con0 wcel onssi.1 cA suceloni ax-mp $.
      $( [12-Jun-1994] $)

    $( An ordinal number is either its own union (if zero or a limit
       ordinal) or the successor of its union. $)
    onuniorsuci $p |- ( A = U. A \/ A = suc U. A ) $=
      cA word cA cA cuni wceq cA cA cuni csuc wceq wo cA onssi.1 onordi cA
      orduniorsuc ax-mp $.
      $( [13-Jun-1994] $)

    ${
      $d x A $.
      $( A limit ordinal is not a successor ordinal. $)
      onuninsuci $p |- ( A = U. A <-> -. E. x e. On A = suc x ) $=
        cA vx cv csuc wceq vx con0 wrex cA cA cuni wceq cA vx cv csuc wceq vx
        con0 wrex cA cA cuni wceq wn cA vx cv csuc wceq cA cA cuni wceq wn vx
        con0 cA vx cv csuc wceq cA cA cuni wceq wn wi vx cv con0 wcel cA vx cv
        csuc wceq cA cA cuni wceq wn wi cA vx cv csuc wceq cA cA cuni wceq wa
        wn cA vx cv csuc wceq cA cA cuni wceq wa cA cA wcel cA onssi.1 onirri
        cA vx cv csuc wceq cA cA cuni wceq wa cA vx cv cA cA cA cuni wceq cA vx
        cv csuc wceq cA cA cuni vx cv cA cA cuni wceq id cA vx cv csuc wceq cA
        cuni vx cv cuni vx cv cun vx cv cA vx cv csuc wceq cA cuni vx cv vx cv
        csn cun cuni vx cv cuni vx cv cun cA vx cv csuc wceq cA vx cv vx cv csn
        cun wceq cA cuni vx cv vx cv csn cun cuni wceq vx cv csuc vx cv vx cv
        csn cun cA vx cv df-suc eqeq2i cA vx cv vx cv csn cun unieq sylbi vx cv
        vx cv csn cun cuni vx cv cuni vx cv csn cuni cun vx cv cuni vx cv cun
        vx cv vx cv csn uniun vx cv csn cuni vx cv vx cv cuni vx cv vx visset
        unisn uneq2i eqtri syl6eq cA vx cv csuc wceq vx cv cuni vx cv wss vx cv
        cuni vx cv cun vx cv wceq cA vx cv csuc wceq vx cv csuc con0 wcel vx cv
        con0 wcel vx cv cuni vx cv wss cA vx cv csuc wceq cA con0 wcel vx cv
        csuc con0 wcel onssi.1 cA vx cv csuc con0 eleq1 mpbii con0 wtr vx cv
        csuc con0 wcel vx cv con0 wcel tron con0 vx cv trsuc mpan vx cv con0
        wcel vx cv wtr vx cv cuni vx cv wss vx cv con0 wcel vx cv word vx cv
        wtr vx cv eloni vx cv ordtr syl vx cv df-tr sylib 3syl vx cv cuni vx cv
        ssequn1 sylib eqtrd sylan9eqr cA vx cv csuc wceq vx cv cA wcel cA cA
        cuni wceq cA vx cv csuc wceq vx cv cA wcel vx cv vx cv csuc wcel vx cv
        vx visset sucid cA vx cv csuc vx cv eleq2 mpbiri adantr eqeltrd mto cA
        vx cv csuc wceq cA cA cuni wceq imnan mpbir a1i r19.23aiv cA cuni con0
        wcel cA cA cuni csuc wceq cA vx cv csuc wceq vx con0 wrex cA cA cuni
        wceq wn cA vx cv csuc wceq cA cA cuni csuc wceq vx cA cuni con0 vx cv
        cA cuni wceq vx cv csuc cA cuni csuc cA vx cv cA cuni suceq eqeq2d
        rcla4ev cA con0 wcel cA cuni con0 wcel onssi.1 cA onuni ax-mp cA cA
        cuni wceq cA cA cuni csuc wceq cA onssi.1 onuniorsuci ori sylancr
        impbii con2bii $.
        $( [21-Feb-2004] $) $( [18-Feb-2004] $)
    $}

    ${
      onsucssi.2 $e |- B e. On $.
      $( A set belongs to an ordinal number iff its successor is a subset of
         the ordinal number.  Exercise 8 of [TakeutiZaring] p. 42 and its
         converse. $)
      onsucssi $p |- ( A e. B <-> suc A C_ B ) $=
        cA con0 wcel cB word cA cB wcel cA csuc cB wss wb onssi.1 cB onsucssi.2
        onordi cA cB con0 ordelsuc mp2an $.
        $( [16-Sep-1995] $)
    $}
  $}

  $( A successor is not a limit ordinal. $)
  nlimsucg $p |- ( A e. B -> -. Lim suc A ) $=
    cA cB wcel cA word cA csuc wlim wn cA cB wcel cA word cA csuc cA csuc cuni
    wceq cA csuc wlim cA cB wcel cA word cA csuc cA csuc cuni wceq wn cA cB
    wcel cA word wa cA csuc cA csuc cuni wceq cA csuc cA csuc wcel cA word cA
    csuc cA csuc wcel wn cA cB wcel cA word cA csuc word cA csuc cA csuc wcel
    wn cA ordsuc cA csuc ordirr sylbi adantl cA cB wcel cA csuc cuni cA wceq cA
    csuc cA csuc cuni wceq cA csuc cA csuc wcel wi cA word cA csuc cA csuc cuni
    wceq cA csuc cA csuc wcel cA csuc cuni cA csuc wcel cA cB wcel cA csuc cuni
    cA wceq wa cA csuc cA csuc cuni cA csuc eleq1 cA cB wcel cA csuc cuni cA
    wceq wa cA csuc cuni cA cA csuc cA cB wcel cA csuc cuni cA wceq pm3.27 cA
    cB wcel cA cA csuc wcel cA csuc cuni cA wceq cA cB sucidg adantr eqeltrd
    syl5cbir cA ordunisuc sylan2 mtod ex cA csuc wlim cA csuc cA csuc cuni wceq
    wi cA cB wcel cA csuc limuni a1i nsyld cA csuc wlim cA word cA csuc word cA
    csuc c0 wne cA csuc cA csuc cuni wceq w3a cA csuc word cA csuc wlim cA word
    cA csuc word cA csuc c0 wne cA csuc cA csuc cuni wceq 3simp1 cA csuc df-lim
    cA ordsuc 3imtr4i con3i pm2.61d1 $.
    $( [20-Sep-2006] $) $( [25-Mar-1995] $)

  ${
    $d x A $.
    $( An ordinal equal to its union is not a successor. $)
    orduninsuc $p |- ( Ord A -> ( A = U. A <-> -. E. x e. On A = suc x ) ) $=
      cA word cA con0 wcel cA con0 wceq wo cA cA cuni wceq cA vx cv csuc wceq
      vx con0 wrex wn wb cA ordeleqon cA con0 wcel cA cA cuni wceq cA vx cv
      csuc wceq vx con0 wrex wn wb cA con0 wceq cA con0 wcel cA cA cuni wceq cA
      vx cv csuc wceq vx con0 wrex wn wb cA con0 wcel cA c0 cif cA con0 wcel cA
      c0 cif cuni wceq cA con0 wcel cA c0 cif vx cv csuc wceq vx con0 wrex wn
      wb cA c0 cA cA con0 wcel cA c0 cif wceq cA cA cuni wceq cA con0 wcel cA
      c0 cif cA con0 wcel cA c0 cif cuni wceq cA vx cv csuc wceq vx con0 wrex
      wn cA con0 wcel cA c0 cif vx cv csuc wceq vx con0 wrex wn cA cA con0 wcel
      cA c0 cif wceq cA cA con0 wcel cA c0 cif cA cuni cA con0 wcel cA c0 cif
      cuni cA cA con0 wcel cA c0 cif wceq id cA cA con0 wcel cA c0 cif unieq
      eqeq12d cA cA con0 wcel cA c0 cif wceq cA vx cv csuc wceq vx con0 wrex cA
      con0 wcel cA c0 cif vx cv csuc wceq vx con0 wrex cA cA con0 wcel cA c0
      cif wceq cA vx cv csuc wceq cA con0 wcel cA c0 cif vx cv csuc wceq vx
      con0 cA cA con0 wcel cA c0 cif vx cv csuc eqeq1 rexbidv notbid bibi12d vx
      cA con0 wcel cA c0 cif cA c0 con0 0elon elimel onuninsuci dedth cA con0
      wceq cA cA cuni wceq cA vx cv csuc wceq vx con0 wrex wn wb con0 con0 cuni
      wceq con0 vx cv csuc wceq vx con0 wrex wn wb con0 con0 cuni wceq con0 vx
      cv csuc wceq vx con0 wrex wn con0 cuni con0 unon eqcomi con0 vx cv csuc
      wceq vx con0 con0 vx cv csuc wceq wn vx cv con0 wcel con0 vx cv csuc wceq
      con0 cvv wcel onprc con0 vx cv csuc wceq con0 cvv wcel vx cv csuc cvv
      wcel vx cv vx visset sucex con0 vx cv csuc cvv eleq1 mpbiri mto a1i nrex
      2th cA con0 wceq cA cA cuni wceq con0 con0 cuni wceq cA vx cv csuc wceq
      vx con0 wrex wn con0 vx cv csuc wceq vx con0 wrex wn cA con0 wceq cA con0
      cA cuni con0 cuni cA con0 wceq id cA con0 unieq eqeq12d cA con0 wceq cA
      vx cv csuc wceq vx con0 wrex con0 vx cv csuc wceq vx con0 wrex cA con0
      wceq cA vx cv csuc wceq con0 vx cv csuc wceq vx con0 cA con0 vx cv csuc
      eqeq1 rexbidv notbid bibi12d mpbiri jaoi sylbi $.
      $( [21-Feb-2004] $) $( [18-Feb-2004] $)

    $( An ordinal equal to its union contains the successor of each of its
       members. $)
    ordunisuc2 $p |- ( Ord A -> ( A = U. A <-> A. x e. A suc x e. A ) ) $=
      cA word cA cA cuni wceq cA vx cv csuc wceq vx con0 wrex wn vx cv csuc cA
      wcel vx cA wral vx cA orduninsuc cA word cA vx cv csuc wceq wn vx con0
      wral vx cv csuc cA wcel vx cA wral cA vx cv csuc wceq vx con0 wrex wn cA
      word cA vx cv csuc wceq wn vx cv csuc cA wcel vx con0 cA cA word vx cv
      con0 wcel cA vx cv csuc wceq wn wi vx cv con0 wcel vx cv cA wcel vx cv
      csuc cA wcel wi wi vx cv cA wcel vx cv csuc cA wcel wi cA word vx cv con0
      wcel cA vx cv csuc wceq wn vx cv cA wcel vx cv csuc cA wcel wi cA word vx
      cv con0 wcel wa cA vx cv csuc wcel vx cv csuc cA wcel wo cA vx cv csuc
      wceq wn vx cv cA wcel vx cv csuc cA wcel wi cA word vx cv con0 wcel wa cA
      vx cv csuc wceq cA vx cv csuc wcel vx cv csuc cA wcel wo cA word vx cv
      csuc word cA vx cv csuc wceq cA vx cv csuc wcel vx cv csuc cA wcel wo wn
      wb vx cv con0 wcel cA vx cv csuc ordtri3 vx cv con0 wcel vx cv csuc con0
      wcel vx cv csuc word vx cv suceloni vx cv csuc eloni syl sylan2 con2bid
      cA word vx cv con0 wcel wa cA vx cv csuc wcel vx cv csuc cA wcel wo vx cv
      cA wcel vx cv csuc cA wcel wi cA word vx cv con0 wcel wa cA vx cv csuc
      wcel vx cv cA wcel vx cv csuc cA wcel wi vx cv csuc cA wcel vx cv con0
      wcel cA vx cv csuc wcel vx cv cA wcel vx cv csuc cA wcel wi wi cA word vx
      cv con0 wcel cA vx cv csuc wcel vx cv cA wcel wn vx cv cA wcel vx cv csuc
      cA wcel wi vx cv con0 wcel vx cv cA wcel cA vx cv csuc wcel vx cv con0
      wcel vx cv cA wcel cA vx cv csuc wcel wa wn vx cv cA wcel cA vx cv csuc
      wcel wn wi vx cv cA onnbtwn vx cv cA wcel cA vx cv csuc wcel imnan sylibr
      con2d vx cv cA wcel vx cv csuc cA wcel pm2.21 syl6 adantl vx cv csuc cA
      wcel vx cv cA wcel vx cv csuc cA wcel wi wi cA word vx cv con0 wcel wa vx
      cv csuc cA wcel vx cv cA wcel ax-1 a1i jaod cA word vx cv con0 wcel wa vx
      cv cA wcel vx cv csuc cA wcel wi cA vx cv csuc wcel vx cv csuc cA wcel wo
      cA word vx cv con0 wcel wa vx cv cA wcel vx cv csuc cA wcel wi wa cA vx
      cv wss vx cv cA wcel wo cA vx cv csuc wcel vx cv csuc cA wcel wo cA word
      vx cv con0 wcel wa cA vx cv wss vx cv cA wcel wo vx cv cA wcel vx cv csuc
      cA wcel wi cA word vx cv con0 wcel wa vx cv cA wcel cA vx cv wss wo cA vx
      cv wss vx cv cA wcel wo vx cv con0 wcel cA word vx cv cA wcel cA vx cv
      wss wo vx cv word cA word vx cv cA wcel cA vx cv wss wo vx cv con0 wcel
      vx cv cA ordtri2or vx cv eloni sylan ancoms vx cv cA wcel cA vx cv wss
      orcom sylib adantr cA word vx cv con0 wcel wa vx cv cA wcel vx cv csuc cA
      wcel wi wa cA vx cv wss cA vx cv csuc wcel vx cv cA wcel vx cv csuc cA
      wcel cA word vx cv con0 wcel wa cA vx cv wss cA vx cv csuc wcel wi vx cv
      cA wcel vx cv csuc cA wcel wi cA word vx cv con0 wcel wa cA vx cv wss cA
      vx cv csuc wcel cA vx cv ordsssuc2 biimpd adantr cA word vx cv con0 wcel
      wa vx cv cA wcel vx cv csuc cA wcel wi pm3.27 orim12d mpd ex impbid
      bitr3d pm5.74da cA word vx cv con0 wcel vx cv cA wcel wa vx cv csuc cA
      wcel wi vx cv cA wcel vx cv csuc cA wcel wi vx cv con0 wcel vx cv cA wcel
      vx cv csuc cA wcel wi wi cA word vx cv con0 wcel vx cv cA wcel wa vx cv
      cA wcel vx cv csuc cA wcel cA word vx cv con0 wcel vx cv cA wcel wa vx cv
      cA wcel vx cv con0 wcel vx cv cA wcel pm3.27 cA word vx cv cA wcel vx cv
      con0 wcel cA word vx cv cA wcel vx cv con0 wcel cA vx cv ordelon ex ancrd
      impbid2 imbi1d vx cv con0 wcel vx cv cA wcel vx cv csuc cA wcel impexp
      syl5bbr bitrd ralbidv2 cA vx cv csuc wceq vx con0 ralnex syl5bbr bitrd $.
      $( [4-Feb-2005] $) $( [1-Feb-2005] $)

    $( An ordinal is zero, a successor ordinal, or a limit ordinal. $)
    ordzsl $p |- ( Ord A <->
                  ( A = (/) \/ E. x e. On A = suc x \/ Lim A ) ) $=
      cA word cA c0 wceq cA vx cv csuc wceq vx con0 wrex cA wlim w3o cA word cA
      vx cv csuc wceq vx con0 wrex cA c0 wceq cA wlim wo wo cA c0 wceq cA vx cv
      csuc wceq vx con0 wrex cA wlim w3o cA word cA vx cv csuc wceq vx con0
      wrex cA c0 wceq cA wlim wo cA word cA vx cv csuc wceq vx con0 wrex wn cA
      cA cuni wceq cA c0 wceq cA wlim wo cA word cA cA cuni wceq cA vx cv csuc
      wceq vx con0 wrex wn vx cA orduninsuc biimprd cA unizlim sylibd orrd cA
      c0 wceq cA vx cv csuc wceq vx con0 wrex cA wlim w3o cA c0 wceq cA vx cv
      csuc wceq vx con0 wrex cA wlim wo wo cA vx cv csuc wceq vx con0 wrex cA
      c0 wceq cA wlim wo wo cA c0 wceq cA vx cv csuc wceq vx con0 wrex cA wlim
      3orass cA c0 wceq cA vx cv csuc wceq vx con0 wrex cA wlim or12 bitri
      sylibr cA c0 wceq cA word cA vx cv csuc wceq vx con0 wrex cA wlim cA c0
      wceq cA word c0 word ord0 cA c0 ordeq mpbiri cA vx cv csuc wceq cA word
      vx con0 cA vx cv csuc wceq vx cv con0 wcel cA con0 wcel cA word cA vx cv
      csuc wceq cA con0 wcel vx cv csuc con0 wcel vx cv con0 wcel cA vx cv csuc
      con0 eleq1 vx cv suceloni syl5bir cA eloni syl6com r19.23aiv cA limord
      3jaoi impbii $.
      $( [2-Oct-2003] $) $( [1-Oct-2003] $)

    $( An ordinal number is zero, a successor ordinal, or a limit ordinal
       number. $)
    onzsl $p |- ( A e. On <->
               ( A = (/) \/ E. x e. On A = suc x \/ ( A e. _V /\ Lim A ) ) ) $=
      cA con0 wcel cA cvv wcel cA con0 wcel wa cA cvv wcel cA word wa cA c0
      wceq cA vx cv csuc wceq vx con0 wrex cA cvv wcel cA wlim wa w3o cA con0
      wcel cA cvv wcel cA con0 elisset pm4.71ri cA cvv wcel cA con0 wcel cA
      word cA cvv elong pm5.32i cA cvv wcel cA c0 wceq cA vx cv csuc wceq vx
      con0 wrex wo cA wlim wo wa cA c0 wceq cA vx cv csuc wceq vx con0 wrex wo
      cA cvv wcel cA wlim wa wo cA cvv wcel cA word wa cA c0 wceq cA vx cv csuc
      wceq vx con0 wrex cA cvv wcel cA wlim wa w3o cA cvv wcel cA c0 wceq cA vx
      cv csuc wceq vx con0 wrex wo cA wlim wo wa cA cvv wcel cA c0 wceq cA vx
      cv csuc wceq vx con0 wrex wo wa cA cvv wcel cA wlim wa wo cA c0 wceq cA
      vx cv csuc wceq vx con0 wrex wo cA cvv wcel cA wlim wa wo cA cvv wcel cA
      c0 wceq cA vx cv csuc wceq vx con0 wrex wo cA wlim andi cA c0 wceq cA vx
      cv csuc wceq vx con0 wrex wo cA cvv wcel cA c0 wceq cA vx cv csuc wceq vx
      con0 wrex wo wa cA cvv wcel cA wlim wa cA c0 wceq cA vx cv csuc wceq vx
      con0 wrex wo cA cvv wcel cA c0 wceq cA cvv wcel cA vx cv csuc wceq vx
      con0 wrex cA c0 wceq cA cvv wcel c0 cvv wcel 0ex cA c0 cvv eleq1 mpbiri
      cA vx cv csuc wceq cA cvv wcel vx con0 cA vx cv csuc wceq cA cvv wcel wi
      vx cv con0 wcel cA vx cv csuc wceq cA cvv wcel vx cv csuc cvv wcel vx cv
      vx visset sucex cA vx cv csuc cvv eleq1 mpbiri a1i r19.23aiv jaoi
      pm4.71ri orbi1i bitr4i cA word cA c0 wceq cA vx cv csuc wceq vx con0 wrex
      wo cA wlim wo cA cvv wcel cA word cA c0 wceq cA vx cv csuc wceq vx con0
      wrex cA wlim w3o cA c0 wceq cA vx cv csuc wceq vx con0 wrex wo cA wlim wo
      vx cA ordzsl cA c0 wceq cA vx cv csuc wceq vx con0 wrex cA wlim df-3or
      bitri anbi2i cA c0 wceq cA vx cv csuc wceq vx con0 wrex cA cvv wcel cA
      wlim wa df-3or 3bitr4i 3bitri $.
      $( [5-Jan-2004] $) $( [1-Oct-2003] $)

    $( An alternate definition of a limit ordinal, which is any ordinal that
       is neither zero nor a successor. $)
    dflim3 $p |- ( Lim A <->
                 ( Ord A /\ -. ( A = (/) \/ E. x e. On A = suc x ) ) ) $=
      cA wlim cA word cA c0 wceq cA vx cv csuc wceq vx con0 wrex wo wn wa cA
      wlim cA word cA c0 wceq cA vx cv csuc wceq vx con0 wrex wo wn cA limord
      cA c0 wceq cA vx cv csuc wceq vx con0 wrex wo wn cA c0 wceq wn cA vx cv
      csuc wceq vx con0 wrex wn cA wlim cA c0 wceq cA vx cv csuc wceq vx con0
      wrex ioran cA c0 wceq cA wlim cA c0 wceq cA wlim c0 wlim nlim0 cA c0
      limeq mtbiri con2i cA wlim cA cA cuni wceq cA vx cv csuc wceq vx con0
      wrex wn cA limuni cA wlim cA word cA cA cuni wceq cA vx cv csuc wceq vx
      con0 wrex wn wb cA limord vx cA orduninsuc syl mpbid sylanbrc jca cA word
      cA c0 wceq cA vx cv csuc wceq vx con0 wrex wo cA wlim cA word cA c0 wceq
      cA vx cv csuc wceq vx con0 wrex cA wlim w3o cA c0 wceq cA vx cv csuc wceq
      vx con0 wrex wo cA wlim wo cA word cA c0 wceq cA vx cv csuc wceq vx con0
      wrex cA wlim w3o vx cA ordzsl biimpi cA c0 wceq cA vx cv csuc wceq vx
      con0 wrex cA wlim df-3or sylib orcanai impbii $.
      $( [3-Nov-2004] $) $( [1-Nov-2004] $)

    $( An alternate definition of a limit ordinal. $)
    dflim4 $p |- ( Lim A <->
                 ( Ord A /\ (/) e. A /\ A. x e. A suc x e. A ) ) $=
      cA wlim cA word c0 cA wcel cA cA cuni wceq w3a cA word c0 cA wcel vx cv
      csuc cA wcel vx cA wral w3a cA dflim2 cA word c0 cA wcel cA cA cuni wceq
      wa wa cA word c0 cA wcel vx cv csuc cA wcel vx cA wral wa wa cA word c0
      cA wcel cA cA cuni wceq w3a cA word c0 cA wcel vx cv csuc cA wcel vx cA
      wral w3a cA word c0 cA wcel cA cA cuni wceq wa c0 cA wcel vx cv csuc cA
      wcel vx cA wral wa cA word cA cA cuni wceq vx cv csuc cA wcel vx cA wral
      c0 cA wcel vx cA ordunisuc2 anbi2d pm5.32i cA word c0 cA wcel cA cA cuni
      wceq 3anass cA word c0 cA wcel vx cv csuc cA wcel vx cA wral 3anass
      3bitr4i bitri $.
      $( [4-Feb-2005] $) $( [1-Feb-2005] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The successor of a member of a limit ordinal is also a member. $)
    limsuc $p |- ( Lim A -> ( B e. A <-> suc B e. A ) ) $=
      cA wlim cB cA wcel cB csuc cA wcel cA wlim cA word c0 cA wcel vx cv csuc
      cA wcel vx cA wral w3a cB cA wcel cB csuc cA wcel wi vx cA dflim4 vx cv
      csuc cA wcel vx cA wral cA word cB cA wcel cB csuc cA wcel wi c0 cA wcel
      vx cv csuc cA wcel cB csuc cA wcel vx cB cA vx cv cB wceq vx cv csuc cB
      csuc cA vx cv cB suceq eleq1d rcla4cv 3ad2ant3 sylbi cA wlim cA word cA
      wtr cB csuc cA wcel cB cA wcel wi cA limord cA ordtr cA wtr cB csuc cA
      wcel cB cA wcel cA cB trsuc ex 3syl impbid $.
      $( [3-Sep-2003] $)

    $( A class includes a limit ordinal iff the successor of the class includes
       it. $)
    limsssuc $p |- ( Lim A -> ( A C_ B <-> A C_ suc B ) ) $=
      cA wlim cA cB wss cA cB csuc wss cA cB wss cB cB csuc wss cA cB csuc wss
      cB sssucid cA cB cB csuc sstr2 mpi cA wlim cA cB csuc wss cA cB wss cA
      wlim cA cB csuc wss wa vx cA cB cA wlim cA cB csuc wss wa vx cv cA wcel
      vx cv cB wcel cA wlim cA cB csuc wss wa vx cv cA wcel wa vx cv cB wceq wn
      vx cv cB wcel cA wlim cA cB csuc wss vx cv cA wcel vx cv cB wceq wn cA
      wlim vx cv cA wcel cA cB csuc wss vx cv cB wceq wn cA wlim vx cv cA wcel
      cA cB csuc wss vx cv cB wceq wn wi cA wlim vx cv cA wcel wa vx cv cB wceq
      cA cB csuc wss vx cv cA wcel vx cv cB wceq cB cA wcel cA wlim cA cB csuc
      wss wn vx cv cB wceq vx cv cA wcel cB cA wcel vx cv cB cA eleq1 biimpcd
      cA wlim cB cA wcel cA cB csuc wss wn cA wlim cB cA wcel wa cB csuc cA
      wcel cA cB csuc wss wn cA wlim cB cA wcel cB csuc cA wcel cA cB limsuc
      biimpa cA wlim cB cA wcel wa cA cB csuc wss cB csuc cA wcel cA word cB
      csuc word cA cB csuc wss cB csuc cA wcel wn wb cA wlim cB cA wcel wa cA
      cB csuc ordtri1 cA wlim cA word cB cA wcel cA limord adantr cA wlim cB cA
      wcel wa cB word cB csuc word cA word cB cA wcel cB word cA wlim cA cB
      ordelord cA limord sylan cB ordsuc sylib sylanc con2bid mpbid ex sylan9r
      con2d ex com23 imp31 cA cB csuc wss vx cv cA wcel vx cv cB wceq wn vx cv
      cB wcel wi cA wlim cA cB csuc wss vx cv cA wcel wa vx cv cB wcel vx cv cB
      wceq cA cB csuc wss vx cv cA wcel wa vx cv cB wcel vx cv cB wceq cA cB
      csuc wss vx cv cA wcel wa vx cv cB csuc wcel vx cv cB wcel vx cv cB wceq
      wo cA cB csuc vx cv ssel2 vx cv cB vx visset elsuc sylib ord con1d
      adantll mpd ex ssrdv ex impbid2 $.
      $( [6-Nov-2003] $) $( [30-Oct-2003] $)
  $}

  ${
    $d x y $.
    $( Two ways to express the class of non-limit ordinal numbers.  Part of
       Definition 7.27 of [TakeutiZaring] p. 42, who use the symbol K_I for
       this class. $)
    nlimon $p |- { x e. On | ( x = (/) \/ E. y e. On x = suc y ) } =
                   { x e. On | -. Lim x } $=
      vx cv c0 wceq vx cv vy cv csuc wceq vy con0 wrex wo vx cv wlim wn vx con0
      vx cv con0 wcel vx cv word vx cv c0 wceq vx cv vy cv csuc wceq vy con0
      wrex wo vx cv wlim wn wb vx cv eloni vx cv word vx cv wlim vx cv c0 wceq
      vx cv vy cv csuc wceq vy con0 wrex wo vx cv wlim vx cv word vx cv c0 wceq
      vx cv vy cv csuc wceq vy con0 wrex wo wn vy vx cv dflim3 baib con2bid syl
      rabbii $.
      $( [4-Nov-2004] $) $( [1-Nov-2004] $)
  $}

  ${
    $d x y z A $.
    $( The union of a nonempty class of limit ordinals is a limit ordinal. $)
    limuni3 $p |- ( ( A =/= (/) /\ A. x e. A Lim x ) -> Lim U. A ) $=
      cA c0 wne vx cv wlim vx cA wral wa cA cuni word c0 cA cuni wcel vy cv
      csuc cA cuni wcel vy cA cuni wral w3a cA cuni wlim cA c0 wne vx cv wlim
      vx cA wral wa cA cuni word c0 cA cuni wcel vy cv csuc cA cuni wcel vy cA
      cuni wral vx cv wlim vx cA wral cA cuni word cA c0 wne vx cv wlim vx cA
      wral cA con0 wss cA cuni word vx cv wlim vx cA wral vz cA con0 vz cv cA
      wcel vx cv wlim vx cA wral vz cv wlim vz cv con0 wcel vx cv wlim vz cv
      wlim vx vz cv cA vx cv vz cv limeq rcla4v vz cv cvv wcel vz cv wlim vz cv
      con0 wcel vz visset vz cv cvv limelon mpan syl6com ssrdv cA ssorduni syl
      adantl cA c0 wne vx cv wlim vx cA wral c0 cA cuni wcel cA c0 wne vz cv cA
      wcel vz wex vx cv wlim vx cA wral c0 cA cuni wcel wi vz cA n0 vz cv cA
      wcel vx cv wlim vx cA wral c0 cA cuni wcel wi vz vz cv cA wcel vx cv wlim
      vx cA wral vz cv wlim c0 cA cuni wcel vx cv wlim vz cv wlim vx vz cv cA
      vx cv vz cv limeq rcla4v vz cv cA wcel c0 vz cv wcel c0 cA cuni wcel vz
      cv wlim c0 vz cv wcel vz cv cA wcel c0 cA cuni wcel c0 vz cv cA elunii
      expcom vz cv 0ellim syl5 syld 19.23aiv sylbi imp vx cv wlim vx cA wral vy
      cv csuc cA cuni wcel vy cA cuni wral cA c0 wne vx cv wlim vx cA wral vy
      cv csuc cA cuni wcel vy cA cuni vx cv wlim vx cA wral vy cv vz cv wcel vz
      cA wrex vy cv csuc cA cuni wcel vy cv cA cuni wcel vx cv wlim vx cA wral
      vy cv vz cv wcel vy cv csuc cA cuni wcel vz cA vx cv wlim vx cA wral vz
      cv cA wcel vz cv wlim vy cv vz cv wcel vy cv csuc cA cuni wcel wi vx cv
      wlim vz cv wlim vx vz cv cA vx cv vz cv limeq rcla4cv vz cv wlim vy cv vz
      cv wcel vz cv cA wcel vy cv csuc cA cuni wcel vz cv wlim vy cv vz cv wcel
      vz cv cA wcel vy cv csuc cA cuni wcel vz cv wlim vy cv vz cv wcel vz cv
      cA wcel wa vy cv csuc vz cv wcel vz cv cA wcel wa vy cv csuc cA cuni wcel
      vz cv wlim vy cv vz cv wcel vy cv csuc vz cv wcel vz cv cA wcel vz cv vy
      cv limsuc anbi1d vy cv csuc vz cv cA elunii syl6bi exp3a com3r sylcom
      r19.23adv vz vy cv cA eluni2 syl5ib r19.21aiv adantl 3jca vy cA cuni
      dflim4 sylibr $.
      $( [29-May-2007] $) $( [1-Feb-2005] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Transfinite induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( The Principle of Transfinite Induction.  Theorem 7.17 of [TakeutiZaring]
       p. 39.  This principle states that if ` A ` is a class of ordinal
       numbers with the property that every ordinal number included in ` A `
       also belongs to ` A ` , then every ordinal number is in ` A ` .

       See theorem ~ tfindes or ~ tfinds for the version involving basis and
       induction hypotheses. $)
    tfi $p |- ( ( A C_ On /\ A. x e. On ( x C_ A -> x e. A ) ) -> A = On ) $=
      cA con0 wss vx cv cA wss vx cv cA wcel wi vx con0 wral wa cA con0 wss
      con0 cA wss wa cA con0 wceq vx cv cA wss vx cv cA wcel wi vx con0 wral
      con0 cA wss cA con0 wss vx cv cA wss vx cv cA wcel wi vx con0 wral con0
      cA cdif vx cv cin c0 wceq vx con0 cA cdif wrex con0 cA wss vx cv cA wss
      vx cv cA wcel wi vx con0 wral con0 cA cdif vx cv cin c0 wceq wn vx con0
      cA cdif wral con0 cA cdif vx cv cin c0 wceq vx con0 cA cdif wrex wn vx cv
      cA wss vx cv cA wcel wi con0 cA cdif vx cv cin c0 wceq wn vx con0 con0 cA
      cdif vx cv con0 wcel vx cv cA wss vx cv cA wcel wi wi vx cv con0 cA cdif
      wcel con0 cA cdif vx cv cin c0 wceq wn vx cv con0 wcel vx cv cA wss vx cv
      cA wcel wi wi vx cv con0 cA cdif wcel wa con0 cA cdif vx cv cin c0 wceq
      vx cv cA wcel vx cv con0 cA cdif wcel vx cv cA wcel wn vx cv con0 wcel vx
      cv cA wss vx cv cA wcel wi wi vx cv con0 cA eldifn adantl vx cv con0 wcel
      vx cv cA wss vx cv cA wcel wi wi vx cv con0 cA cdif wcel con0 cA cdif vx
      cv cin c0 wceq vx cv cA wcel wi vx cv con0 wcel vx cv cA wss vx cv cA
      wcel wi wi vx cv con0 wcel con0 cA cdif vx cv cin c0 wceq vx cv cA wcel
      wi vx cv con0 cA cdif wcel vx cv con0 wcel vx cv cA wss vx cv cA wcel wi
      con0 cA cdif vx cv cin c0 wceq vx cv cA wcel wi vx cv con0 wcel con0 cA
      cdif vx cv cin c0 wceq vx cv cA wss vx cv cA wcel con0 cA cdif vx cv cin
      c0 wceq vx cv con0 wss vx cv cA wss vx cv con0 wcel con0 cA vx cv
      difin0ss vx cv onss syl5com imim1d a2i vx cv con0 cA eldifi syl5 imp mtod
      ex r19.20i2 con0 cA cdif vx cv cin c0 wceq vx con0 cA cdif ralnex sylib
      con0 cA wss wn con0 cA cdif c0 wne con0 cA cdif vx cv cin c0 wceq vx con0
      cA cdif wrex con0 cA wss con0 cA cdif c0 con0 cA ssdif0 necon3bbii con0
      word con0 cA cdif con0 wss con0 cA cdif c0 wne con0 cA cdif vx cv cin c0
      wceq vx con0 cA cdif wrex ordon con0 cA difss vx con0 con0 cA cdif tz7.5
      mp3an12 sylbi nsyl2 anim2i cA con0 eqss sylibr $.
      $( [29-Feb-2004] $) $( [18-Feb-2004] $)
  $}

  ${
    $d y ph z $.  $d x y z $.
    tfis.1 $e |- ( x e. On -> ( A. y e. x [ y / x ] ph -> ph ) ) $.
    $( Transfinite Induction Schema.  If all ordinal numbers less than a
       given number ` x ` have a property (induction hypothesis), then all
       ordinal numbers have the property (conclusion).  Exercise 25 of
       [Enderton] p. 200. $)
    tfis $p |- ( x e. On -> ph ) $=
      vx cv con0 wcel vx cv con0 wcel wph wph vx con0 con0 wph vx con0 crab
      con0 wph vx con0 crab con0 wss vz cv wph vx con0 crab wss vz cv wph vx
      con0 crab wcel wi vz con0 wral wph vx con0 crab con0 wceq wph vx con0
      ssrab2 vz cv wph vx con0 crab wss vz cv wph vx con0 crab wcel wi vz con0
      vz cv con0 wcel vz cv wph vx con0 crab wss vz cv con0 wcel wph vx vz cv
      wsbc wa vz cv wph vx con0 crab wcel vz cv con0 wcel vz cv wph vx con0
      crab wss wph vx vz cv wsbc vz cv con0 wcel wph vx vy cv wsbc vy vz cv
      wral wph vx vz cv wsbc vz cv wph vx con0 crab wss vx cv con0 wcel wph vx
      vy cv wsbc vy vx cv wral wph wi wi vz cv con0 wcel wph vx vy cv wsbc vy
      vz cv wral wph vx vz cv wsbc wi wi vx vz vz cv con0 wcel wph vx vy cv
      wsbc vy vz cv wral wph vx vz cv wsbc wi vx vz cv con0 wcel vx ax-17 wph
      vx vy cv wsbc vy vz cv wral wph vx vz cv wsbc vx wph vx vy cv wsbc vx vy
      vz cv vy cv vz cv wcel vx ax-17 wph vx vy hbs1 hbral wph vx vz hbs1 hbim
      hbim vx cv vz cv wceq vx cv con0 wcel vz cv con0 wcel wph vx vy cv wsbc
      vy vx cv wral wph wi wph vx vy cv wsbc vy vz cv wral wph vx vz cv wsbc wi
      vx cv vz cv con0 eleq1 vx cv vz cv wceq wph vx vy cv wsbc vy vx cv wral
      wph vx vy cv wsbc vy vz cv wral wph wph vx vz cv wsbc wph vx vy cv wsbc
      vy vx cv vz cv raleq1 wph vx vz sbequ12 imbi12d imbi12d tfis.1 chvar vz
      cv wph vx con0 crab wss vy cv wph vx con0 crab wcel vy vz cv wral wph vx
      vy cv wsbc vy vz cv wral vy vz cv wph vx con0 crab dfss3 vy cv wph vx
      con0 crab wcel wph vx vy cv wsbc vy vz cv vy cv wph vx con0 crab wcel vy
      cv con0 wcel wph vx vy cv wsbc wph vx vz vy cv con0 vz cv con0 wcel vx
      ax-17 elrabsf pm3.27bi r19.20si sylbi syl5 anc2li wph vx vz vz cv con0 vz
      cv con0 wcel vx ax-17 elrabsf syl6ibr rgen vz wph vx con0 crab tfi mp2an
      eqcomi rabeq2i pm3.27bi $.
      $( [1-Mar-2004] $) $( [1-Aug-1994] $)
  $}

  ${
    $d y ph $.  $d x y $.
    tfis2f.1 $e |- ( ps -> A. x ps ) $.
    tfis2f.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    tfis2f.3 $e |- ( x e. On -> ( A. y e. x ps -> ph ) ) $.
    $( Transfinite Induction Schema, using implicit substitition. $)
    tfis2f $p |- ( x e. On -> ph ) $=
      wph vx vy vx cv con0 wcel wps vy vx cv wral wph wph vx vy cv wsbc vy vx
      cv wral tfis2f.3 wph vx vy cv wsbc wps vy vx cv wph wps vx vy tfis2f.1
      tfis2f.2 sbie ralbii syl5ib tfis $.
      $( [1-Mar-2004] $) $( [18-Aug-1994] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x y $.
    tfis2.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    tfis2.2 $e |- ( x e. On -> ( A. y e. x ps -> ph ) ) $.
    $( Transfinite Induction Schema, using implicit substitition. $)
    tfis2 $p |- ( x e. On -> ph ) $=
      wph wps vx vy wps vx ax-17 tfis2.1 tfis2.2 tfis2f $.
      $( [1-Mar-2004] $) $( [18-Aug-1994] $)
  $}

  ${
    $d x ps $.  $d y ph $.  $d x ch $.  $d x A $.  $d x y $.
    tfis3.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    tfis3.2 $e |- ( x = A -> ( ph <-> ch ) ) $.
    tfis3.3 $e |- ( x e. On -> ( A. y e. x ps -> ph ) ) $.
    $( Transfinite Induction Schema, using implicit substitition. $)
    tfis3 $p |- ( A e. On -> ch ) $=
      wph wch vx cA con0 tfis3.2 wph wps vx vy tfis3.1 tfis3.3 tfis2 vtoclga $.
      $( [6-Nov-2003] $) $( [4-Nov-2003] $)
  $}

  ${
    $d x y z $.  $d x A $.  $d x z ch $.  $d x ta $.  $d y z ph $.
    $( Substitutions. $)
    tfinds.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    tfinds.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfinds.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfinds.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfinds.5 $e |- ps $.
    $( Induction hypothesis for successors. $)
    tfinds.6 $e |- ( y e. On -> ( ch -> th ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfinds.7 $e |- ( Lim x -> ( A. y e. x ch -> ph ) ) $.
    $( Principle of Transfinite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the
       substitutions we need.  The last three are the basis, the induction
       hypothesis for successors, and the induction hypothesis for limit
       ordinals.  Theorem Schema 4 of [Suppes] p. 197. $)
    tfinds $p |- ( A e. On -> ta ) $=
      wph wch wta vx vy cA tfinds.2 tfinds.4 vx cv con0 wcel vx cv wlim wch vy
      vx cv wral wph wi vx cv con0 wcel vx cv wlim wn vx cv c0 wceq vx cv vy cv
      csuc wceq vy con0 wrex wo wch vy vx cv wral wph wi vx cv con0 wcel vx cv
      word vx cv wlim wn vx cv c0 wceq vx cv vy cv csuc wceq vy con0 wrex wo wi
      vx cv eloni vx cv word vx cv wlim wn vx cv c0 wceq vx cv vy cv csuc wceq
      vy con0 wrex wo vx cv word vx cv wlim wn wa vx cv c0 wceq vx cv vy cv
      csuc wceq vy con0 wrex vx cv word vx cv wlim wn wa vx cv vy cv csuc wceq
      vy con0 wrex vx cv c0 wceq vx cv word vx cv wlim wn vx cv vy cv csuc wceq
      vy con0 wrex wn vx cv c0 wceq wi vx cv word vx cv wlim wn vx cv vx cv
      cuni wceq vx cv c0 wceq vx cv vy cv csuc wceq vy con0 wrex wn vx cv word
      vx cv vx cv cuni wceq vx cv wlim wn vx cv c0 wceq vx cv word vx cv vx cv
      cuni wceq vx cv wlim wn vx cv c0 wceq wi vx cv word vx cv vx cv cuni wceq
      wa vx cv wlim vx cv c0 vx cv word vx cv vx cv cuni wceq vx cv c0 wne vx
      cv wlim vx cv word vx cv c0 wne vx cv vx cv cuni wceq vx cv wlim vx cv
      wlim vx cv word vx cv c0 wne vx cv vx cv cuni wceq w3a vx cv df-lim
      biimpri 3com23 3expia necon1bd ex com23 vx cv word vx cv vx cv cuni wceq
      vx cv vy cv csuc wceq vy con0 wrex wn vy vx cv orduninsuc biimprd syl5d
      imp con1d orrd ex syl vx cv c0 wceq wch vy vx cv wral wph wi vx cv vy cv
      csuc wceq vy con0 wrex vx cv c0 wceq wph wch vy vx cv wral vx cv c0 wceq
      wph wps tfinds.5 tfinds.1 mpbiri a1d vx cv vy cv csuc wceq wch vy vx cv
      wral wph wi vy con0 wch vy vx cv wral wph vy wch vy vx cv hbra1 wph vy
      ax-17 hbim vy cv con0 wcel vx cv vy cv csuc wceq wch vy vx cv wral wph wi
      vy cv con0 wcel vx cv vy cv csuc wceq wa wch vy vx cv wral wth wph vx cv
      vy cv csuc wceq wch vy vx cv wral wph vx vy cv csuc wral vy cv con0 wcel
      wth vx cv vy cv csuc wceq wch vy vx cv wral wph vx vy cv csuc wral vx cv
      vy cv csuc wceq wph vx vz cv wsbc vz vx cv wral wph vx vz cv wsbc vz vy
      cv csuc wral wch vy vx cv wral wph vx vy cv csuc wral wph vx vz cv wsbc
      vz vx cv vy cv csuc raleq1 wch wph vx vz cv wsbc vy vz vx cv vy cv vz cv
      wceq wph vx vy cv wsbc wph vx vz cv wsbc wch wph vy vz vx sbequ wph wch
      vx vy wch vx ax-17 tfinds.2 sbie syl5bbr cbvralv wph wph vx vz cv wsbc vx
      vz vy cv csuc wph vz ax-17 wph vx vz hbs1 wph vx vz sbequ12 cbvral
      3bitr4g biimpd vy cv con0 wcel wch wth wph vx vy cv csuc wral tfinds.6 vy
      cv vy cv csuc wcel wph vx vy cv csuc wral wch wi vy cv vy visset sucid
      wph wch vx vy cv vy cv csuc tfinds.2 rcla4v ax-mp syl5 sylan9r vx cv vy
      cv csuc wceq wph wth wb vy cv con0 wcel tfinds.3 adantl sylibrd ex
      r19.23ai jaoi syl6 tfinds.7 pm2.61d2 tfis3 $.
      $( [6-Mar-2004] $) $( [16-Apr-1995] $)
  $}

  ${
    $d x A $.  $d x y B $.  $d x ch $.  $d x th $.  $d x ta $.  $d y ph $.
    $( Substitutions. $)
    tfindsg.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    tfindsg.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfindsg.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfindsg.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfindsg.5 $e |- ( B e. On -> ps ) $.
    $( Induction hypothesis for successor ordinals. $)
    tfindsg.6 $e |- ( ( ( y e. On /\ B e. On ) /\ B C_ y ) -> ( ch -> th ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfindsg.7 $e |- ( ( ( Lim x /\ B e. On ) /\ B C_ x ) ->
                   ( A. y e. x ( B C_ y -> ch ) -> ph ) ) $.
    $( Transfinite Induction (inference schema), using implicit substititions.
       The first four hypotheses establish the substitutions we need.  The last
       three are the basis, the induction hypothesis for successors, and the
       induction hypothesis for limit ordinals.  The basis of this version is
       an arbitrary ordinal ` B ` instead of zero.  Remark in
       [TakeutiZaring] p. 57. $)
    tfindsg $p |- ( ( ( A e. On /\ B e. On ) /\ B C_ A ) -> ta ) $=
      cA con0 wcel cB con0 wcel cB cA wss wta cB con0 wcel cB vx cv wss wph wi
      wi cB con0 wcel cB c0 wss wps wi wi cB con0 wcel cB vy cv wss wch wi wi
      cB con0 wcel cB vy cv csuc wss wth wi wi cB con0 wcel cB cA wss wta wi wi
      vx vy cA vx cv c0 wceq cB vx cv wss wph wi cB c0 wss wps wi cB con0 wcel
      cB c0 wceq vx cv c0 wceq cB vx cv wss wph wi cB c0 wss wps wi wb cB c0
      wceq vx cv c0 wceq wa cB vx cv wss cB c0 wss wph wps vx cv c0 wceq cB vx
      cv wss cB c0 wss wb cB c0 wceq vx cv c0 cB sseq2 adantl cB c0 wceq vx cv
      c0 wceq wph wps wb cB c0 wceq vx cv c0 wceq vx cv cB wceq wph wps wb cB
      c0 vx cv eqeq2 tfindsg.1 syl6bir imp imbi12d vx cv c0 wceq cB vx cv wss
      wph wi cB c0 wss wph wi cB c0 wceq wn cB c0 wss wps wi vx cv c0 wceq cB
      vx cv wss cB c0 wss wph vx cv c0 cB sseq2 imbi1d cB c0 wceq wn cB c0 wss
      wph wps cB c0 wceq wn cB c0 wss wph wps wb cB c0 wss cB c0 wceq cB ss0
      con3i pm2.21d pm5.74d sylan9bbr pm2.61ian imbi2d vx cv vy cv wceq cB vx
      cv wss wph wi cB vy cv wss wch wi cB con0 wcel vx cv vy cv wceq cB vx cv
      wss cB vy cv wss wph wch vx cv vy cv cB sseq2 tfindsg.2 imbi12d imbi2d vx
      cv vy cv csuc wceq cB vx cv wss wph wi cB vy cv csuc wss wth wi cB con0
      wcel vx cv vy cv csuc wceq cB vx cv wss cB vy cv csuc wss wph wth vx cv
      vy cv csuc cB sseq2 tfindsg.3 imbi12d imbi2d vx cv cA wceq cB vx cv wss
      wph wi cB cA wss wta wi cB con0 wcel vx cv cA wceq cB vx cv wss cB cA wss
      wph wta vx cv cA cB sseq2 tfindsg.4 imbi12d imbi2d cB con0 wcel wps cB c0
      wss tfindsg.5 a1d vy cv con0 wcel cB con0 wcel cB vy cv wss wch wi cB vy
      cv csuc wss wth wi vy cv con0 wcel cB con0 wcel cB vy cv wss wch wi cB vy
      cv csuc wss wth wi wi vy cv con0 wcel cB con0 wcel wa cB vy cv csuc wss
      cB vy cv csuc wceq wi cB vy cv wss wch wi cB vy cv csuc wss wth wi wi cB
      con0 wcel cB vy cv csuc wss cB vy cv csuc wceq wi cB vy cv wss wch wi cB
      vy cv csuc wss wth wi wi wi vy cv con0 wcel cB vy cv csuc wss cB vy cv
      csuc wceq wi cB vy cv wss wch wi cB vy cv csuc wss cB con0 wcel wth cB vy
      cv csuc wss cB vy cv csuc wceq wi cB vy cv csuc wss cB con0 wcel wth wi
      wi cB vy cv wss wch wi cB vy cv csuc wceq cB con0 wcel wth wi cB vy cv
      csuc wss cB con0 wcel wth wi vy cv csuc cB vy cv csuc cB wceq vx cv vy cv
      csuc wceq vx cv cB wceq wa vx wex cB con0 wcel wth wi vx vy cv csuc cB vy
      cv vy visset sucex eqvinc vx cv vy cv csuc wceq vx cv cB wceq wa cB con0
      wcel wth wi vx vx cv cB wceq cB con0 wcel wph vx cv vy cv csuc wceq wth
      vx cv cB wceq wph wps cB con0 wcel tfindsg.1 tfindsg.5 syl5bir vx cv vy
      cv csuc wceq wph wth tfindsg.3 biimpd sylan9r 19.23aiv sylbi eqcoms
      imim2i a1d com4r adantl vy cv con0 wcel cB con0 wcel wa cB vy cv csuc wss
      cB vy cv csuc wne wa cB vy cv wss wch wi cB vy cv csuc wss wth wi wi cB
      vy cv csuc wss cB vy cv csuc wceq wi wn vy cv con0 wcel cB con0 wcel wa
      cB vy cv csuc wss cB vy cv csuc wne wa cB vy cv wss cB vy cv wss wch wi
      cB vy cv csuc wss wth wi wi cB con0 wcel vy cv con0 wcel cB vy cv wss cB
      vy cv csuc wss cB vy cv csuc wne wa wb cB con0 wcel vy cv con0 wcel wa cB
      vy cv wss cB vy cv csuc wcel cB vy cv csuc wss cB vy cv csuc wne wa cB vy
      cv onsssuc cB con0 wcel vy cv csuc con0 wcel cB vy cv csuc wcel cB vy cv
      csuc wss cB vy cv csuc wne wa wb vy cv con0 wcel cB vy cv csuc onelpss vy
      cv suceloni sylan2 bitrd ancoms vy cv con0 wcel cB con0 wcel wa cB vy cv
      wss wch wi cB vy cv wss cB vy cv csuc wss wth wi vy cv con0 wcel cB con0
      wcel wa cB vy cv wss wch cB vy cv csuc wss wth wi vy cv con0 wcel cB con0
      wcel wa cB vy cv wss wch wth cB vy cv csuc wss wth wi vy cv con0 wcel cB
      con0 wcel wa cB vy cv wss wch wth wi tfindsg.6 ex wth cB vy cv csuc wss
      ax-1 syl8 a2d com23 sylbird cB vy cv csuc wss cB vy cv csuc wne wa cB vy
      cv csuc wss cB vy cv csuc wceq wn wa cB vy cv csuc wss cB vy cv csuc wceq
      wi wn cB vy cv csuc wne cB vy cv csuc wceq wn cB vy cv csuc wss cB vy cv
      csuc df-ne anbi2i cB vy cv csuc wss cB vy cv csuc wceq annim bitri
      syl5ibr pm2.61d ex a2d cB con0 wcel cB vx cv wss vx cv wlim cB con0 wcel
      cB vy cv wss wch wi wi vy vx cv wral wph vx cv wlim cB con0 wcel cB vx cv
      wss cB con0 wcel cB vy cv wss wch wi wi vy vx cv wral wph wi vx cv wlim
      cB con0 wcel cB vx cv wss cB con0 wcel cB vy cv wss wch wi wi vy vx cv
      wral wph wi vx cv wlim cB con0 wcel wa cB vx cv wss wa cB con0 wcel cB vy
      cv wss wch wi wi vy vx cv wral cB vy cv wss wch wi vy vx cv wral wph cB
      con0 wcel cB con0 wcel cB vy cv wss wch wi wi vy vx cv wral cB vy cv wss
      wch wi vy vx cv wral wi vx cv wlim cB vx cv wss cB con0 wcel cB con0 wcel
      cB vy cv wss wch wi wi cB vy cv wss wch wi vy vx cv cB con0 wcel cB vy cv
      wss wch wi pm2.27 r19.20sdv ad2antlr tfindsg.7 syld exp31 com3l com4t
      tfinds imp31 $.
      $( [6-Mar-2004] $) $( [5-Mar-2004] $)
  $}

  ${
    $d x A $.  $d x y B $.
    $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.  $d y ph $.
    $( Substitutions. $)
    tfindsg2.1 $e |- ( x = suc B -> ( ph <-> ps ) ) $.
    tfindsg2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfindsg2.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfindsg2.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfindsg2.5 $e |- ( B e. On -> ps ) $.
    $( Induction hypothesis for successor ordinals. $)
    tfindsg2.6 $e |- ( ( y e. On /\ B e. y ) -> ( ch -> th ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfindsg2.7 $e |- ( ( Lim x /\ B e. x ) ->
                   ( A. y e. x ( B e. y -> ch ) -> ph ) ) $.
    $( Transfinite Induction (inference schema), using implicit substititions.
       The first four hypotheses establish the substitutions we need.  The last
       three are the basis, the induction hypothesis for successors, and the
       induction hypothesis for limit ordinals.  The basis of this version is
       an arbitrary ordinal ` suc B ` instead of zero. $)
    tfindsg2 $p |- ( ( A e. On /\ B e. A ) -> ta ) $=
      cA con0 wcel cB cA wcel wa cB csuc con0 wcel cB csuc cA wss wta cA con0
      wcel cB cA wcel wa cB con0 wcel cB csuc con0 wcel cA cB onelon cB sucelon
      sylib cA con0 wcel cB cA wcel cB csuc cA wss cA con0 wcel cA word cB cA
      wcel cB csuc cA wss wi cA eloni cB cA ordsucss syl imp cA con0 wcel cB
      csuc con0 wcel cB csuc cA wss wa wta wi cB cA wcel cA con0 wcel cB csuc
      con0 wcel cB csuc cA wss wta cA con0 wcel cB csuc con0 wcel cB csuc cA
      wss wta wph wps wch wth wta vx vy cA cB csuc tfindsg2.1 tfindsg2.2
      tfindsg2.3 tfindsg2.4 cB csuc con0 wcel cB con0 wcel wps cB sucelon
      tfindsg2.5 sylbir vy cv con0 wcel cB csuc con0 wcel wa cB csuc vy cv wss
      wch wth wi vy cv con0 wcel cB con0 wcel cB csuc vy cv wss wch wth wi wi
      cB csuc con0 wcel vy cv con0 wcel cB con0 wcel wa cB csuc vy cv wss cB vy
      cv wcel wch wth wi cB con0 wcel vy cv con0 wcel cB vy cv wcel cB csuc vy
      cv wss wb cB con0 wcel vy cv word cB vy cv wcel cB csuc vy cv wss wb vy
      cv con0 wcel cB vy cv con0 ordelsuc vy cv eloni sylan2 ancoms vy cv con0
      wcel cB vy cv wcel wch wth wi wi cB con0 wcel vy cv con0 wcel cB vy cv
      wcel wch wth wi tfindsg2.6 ex adantr sylbird cB sucelon sylan2br imp vx
      cv wlim cB csuc con0 wcel wa cB csuc vx cv wss cB csuc vy cv wss wch wi
      vy vx cv wral wph wi vx cv wlim cB con0 wcel cB csuc vx cv wss cB csuc vy
      cv wss wch wi vy vx cv wral wph wi wi cB csuc con0 wcel vx cv wlim cB
      con0 wcel wa cB vx cv wcel cB vy cv wcel wch wi vy vx cv wral wph wi wi
      cB csuc vx cv wss cB csuc vy cv wss wch wi vy vx cv wral wph wi wi vx cv
      wlim cB vx cv wcel cB vy cv wcel wch wi vy vx cv wral wph wi wi cB con0
      wcel vx cv wlim cB vx cv wcel cB vy cv wcel wch wi vy vx cv wral wph wi
      tfindsg2.7 ex adantr cB con0 wcel vx cv wlim cB vx cv wcel cB vy cv wcel
      wch wi vy vx cv wral wph wi wi cB csuc vx cv wss cB csuc vy cv wss wch wi
      vy vx cv wral wph wi wi wb cB con0 wcel vx cv con0 wcel cB vx cv wcel cB
      vy cv wcel wch wi vy vx cv wral wph wi wi cB csuc vx cv wss cB csuc vy cv
      wss wch wi vy vx cv wral wph wi wi wb vx cv wlim cB con0 wcel vx cv con0
      wcel wa cB vx cv wcel cB csuc vx cv wss cB vy cv wcel wch wi vy vx cv
      wral wph wi cB csuc vy cv wss wch wi vy vx cv wral wph wi cB con0 wcel vx
      cv word cB vx cv wcel cB csuc vx cv wss wb vx cv con0 wcel cB vx cv con0
      ordelsuc vx cv eloni sylan2 cB con0 wcel vx cv con0 wcel wa cB vy cv wcel
      wch wi vy vx cv wral cB csuc vy cv wss wch wi vy vx cv wral wph cB con0
      wcel vx cv con0 wcel wa cB vy cv wcel wch wi cB csuc vy cv wss wch wi vy
      vx cv cB con0 wcel vx cv con0 wcel wa vy cv vx cv wcel wa cB vy cv wcel
      cB csuc vy cv wss wch cB con0 wcel vx cv con0 wcel vy cv vx cv wcel cB vy
      cv wcel cB csuc vy cv wss wb cB con0 wcel vy cv word cB vy cv wcel cB
      csuc vy cv wss wb vx cv con0 wcel vy cv vx cv wcel wa cB vy cv con0
      ordelsuc vx cv con0 wcel vy cv vx cv wcel wa vy cv con0 wcel vy cv word
      vx cv vy cv onelon vy cv eloni syl sylan2 anassrs imbi1d ralbidva imbi1d
      imbi12d vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv cvv
      limelon mpan sylan2 ancoms mpbid cB sucelon sylan2br imp tfindsg exp31
      imp3a adantr mp2and $.
      $( [12-Jan-2005] $) $( [5-Jan-2005] $)
  $}

  ${
    $d x y z $.  $d y z ph $.
    tfindes.1 $e |- [ (/) / x ] ph $.
    tfindes.2 $e |- ( x e. On -> ( ph -> [ suc x / x ] ph ) ) $.
    tfindes.3 $e |- ( Lim y -> ( A. x e. y ph -> [ y / x ] ph ) ) $.
    $( Transfinite Induction with explicit substitution.  The first hypothesis
       is the basis, the second is the induction hypothesis for successors, and
       the third is the induction hypothesis for limit ordinals.   Theorem
       Schema 4 of [Suppes] p. 197. $)
    tfindes $p |- ( x e. On -> ph ) $=
      wph vx vy cv wsbc wph vx c0 wsbc wph vx vz cv wsbc wph vx vz cv csuc wsbc
      wph vy vz vx cv wph vx vy cv c0 dfsbcq wph vy vz vx sbequ wph vx vy cv vz
      cv csuc dfsbcq wph vy vx sbequ12r tfindes.1 vx cv con0 wcel wph wph vx vx
      cv csuc wsbc wi wi vz cv con0 wcel wph vx vz cv wsbc wph vx vz cv csuc
      wsbc wi wi vx vz vz cv con0 wcel wph vx vz cv wsbc wph vx vz cv csuc wsbc
      wi vx vz cv con0 wcel vx ax-17 wph vx vz cv wsbc wph vx vz cv csuc wsbc
      vx wph vx vz hbs1 wph vx vz cv csuc vz cv vz visset sucex hbsbc1v hbim
      hbim vx cv vz cv wceq vx cv con0 wcel vz cv con0 wcel wph wph vx vx cv
      csuc wsbc wi wph vx vz cv wsbc wph vx vz cv csuc wsbc wi vx cv vz cv con0
      eleq1 vx cv vz cv wceq wph wph vx vz cv wsbc wph vx vx cv csuc wsbc wph
      vx vz cv csuc wsbc wph vx vz sbequ12 vx cv vz cv wceq vx cv csuc vz cv
      csuc wceq wph vx vx cv csuc wsbc wph vx vz cv csuc wsbc wb vx cv vz cv
      suceq wph vx vx cv csuc vz cv csuc dfsbcq syl imbi12d imbi12d tfindes.2
      chvar vy cv wlim wph vx vy cv wral wph vx vy cv wsbc wph vx vz cv wsbc vz
      vy cv wral tfindes.3 wph wph vx vz cv wsbc vx vz vy cv wph vz ax-17 wph
      vx vz hbs1 wph vx vz sbequ12 cbvral syl5ibr tfinds $.
      $( [6-Mar-2004] $) $( [5-Mar-2004] $)
  $}

  ${
    $d x y ta $.  $d x ps $.  $d x ch $.  $d x th $.  $d y ph $.
    $( Substitutions. $)
    tfinds2.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    tfinds2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfinds2.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    $( Basis. $)
    tfinds2.4 $e |- ( ta -> ps ) $.
    $( Induction hypothesis for successors. $)
    tfinds2.5 $e |- ( y e. On -> ( ta -> ( ch -> th ) ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfinds2.6 $e |- ( Lim x -> ( ta -> ( A. y e. x ch -> ph ) ) ) $.
    $( Transfinite Induction (inference schema), using implicit substititions.
       The first three hypotheses establish the substitutions we need.  The
       last three are the basis and the induction hypotheses (for successor and
       limit ordinals respectively).  Theorem Schema 4 of [Suppes] p. 197.  The
       wff ` ta ` is an auxiliary antecedent to help shorten proofs using this
       theorem. $)
    tfinds2 $p |- ( x e. On -> ( ta -> ph ) ) $=
      wta wph wi vx vy wta wph wi vx c0 wsbc wta wps wi tfinds2.4 wta wph wi
      wta wps wi vx c0 0ex vx cv c0 wceq wph wps wta tfinds2.1 imbi2d sbcie
      mpbir vx cv con0 wcel wta wch wi vy vx cv wsbc wta wth wi vy vx cv wsbc
      wta wph wi wta wph wi vx vx cv csuc wsbc vy cv con0 wcel vy vx cv wsbc
      wta wch wi wta wth wi wi vy vx cv wsbc vx cv con0 wcel wta wch wi vy vx
      cv wsbc wta wth wi vy vx cv wsbc wi vy cv con0 wcel wta wch wi wta wth wi
      wi vy vx vy cv con0 wcel wta wch wth tfinds2.5 a2d sbimi vx cv cvv wcel
      vy cv con0 wcel vy vx cv wsbc vx cv con0 wcel wb vx visset vy vx cv con0
      cvv sbcel1gv ax-mp wta wch wi wta wth wi vy vx sbim 3imtr3i wta wch wi
      wta wph wi vy vx cv vx visset vy cv vx cv wceq wch wph wta wch wph wb vx
      vy vx cv vy cv wceq wph wch tfinds2.2 bicomd equcoms imbi2d sbcie wta wth
      wi vy vx cv wsbc wta wph wi vx vy cv csuc wsbc vy vx cv wsbc wta wph wi
      vx vx cv csuc wsbc wta wph wi vx vy cv csuc wsbc wta wth wi vy vx wta wph
      wi wta wth wi vx vy cv csuc vy cv vy visset sucex vx cv vy cv csuc wceq
      wph wth wta tfinds2.3 imbi2d sbcie sbbii wta wph wi vx vy vx cv csuc vy
      cv csuc vx cv vy cv suceq sbcco2 bitr3i 3imtr3g vy cv wlim wta wch wi vy
      vx cv wral vx vy cv wsbc wta wph wi vx vy cv wsbc wta wph wi vx vy cv
      wral vx cv wlim vx vy cv wsbc wta wch wi vy vx cv wral wta wph wi wi vx
      vy cv wsbc vy cv wlim wta wch wi vy vx cv wral vx vy cv wsbc wta wph wi
      vx vy cv wsbc wi vx cv wlim wta wch wi vy vx cv wral wta wph wi wi vx vy
      vx cv wlim wta wch vy vx cv wral wi wta wph wi wta wch wi vy vx cv wral
      vx cv wlim wta wch vy vx cv wral wph tfinds2.6 a2d wta wch vy vx cv
      r19.21v syl5ib sbimi vx cv wlim vy cv wlim vx vy vy cv wlim vx ax-17 vx
      cv vy cv limeq sbie wta wch wi vy vx cv wral wta wph wi vx vy sbim
      3imtr3i wta wch wi wta wph wi vy vx vy cv vx cv wceq wch wph wta wch wph
      wb vx vy vx cv vy cv wceq wph wch tfinds2.2 bicomd equcoms imbi2d sbralie
      syl5ibr tfindes $.
      $( [6-Sep-2004] $) $( [4-Sep-2004] $)
  $}

  ${
    $v et $. $( Greek eta $)
    tfinds3.et $f wff et $.
    $d y ph $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d x y et $.
    $( Substitutions. $)
    tfinds3.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    tfinds3.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfinds3.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfinds3.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfinds3.5 $e |- ( et -> ps ) $.
    $( Induction hypothesis for successors. $)
    tfinds3.6 $e |- ( y e. On -> ( et -> ( ch -> th ) ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfinds3.7 $e |- ( Lim x -> ( et -> ( A. y e. x ch -> ph ) ) ) $.
    $( Principle of Transfinite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the
       substitutions we need.  The last three are the basis, the induction
       hypothesis for successors, and the induction hypothesis for limit
       ordinals. $)
    tfinds3 $p |- ( A e. On -> ( et -> ta ) ) $=
      tfinds3.et wph wi tfinds3.et wps wi tfinds3.et wch wi tfinds3.et wth wi
      tfinds3.et wta wi vx vy cA vx cv c0 wceq wph wps tfinds3.et tfinds3.1
      imbi2d vx cv vy cv wceq wph wch tfinds3.et tfinds3.2 imbi2d vx cv vy cv
      csuc wceq wph wth tfinds3.et tfinds3.3 imbi2d vx cv cA wceq wph wta
      tfinds3.et tfinds3.4 imbi2d tfinds3.5 vy cv con0 wcel tfinds3.et wch wth
      tfinds3.6 a2d vx cv wlim tfinds3.et wch vy vx cv wral wi tfinds3.et wph
      wi tfinds3.et wch wi vy vx cv wral vx cv wlim tfinds3.et wch vy vx cv
      wral wph tfinds3.7 a2d tfinds3.et wch vy vx cv r19.21v syl5ib tfinds $.
      $( [7-Jan-2005] $) $( [6-Jan-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The natural numbers (i.e. finite ordinals)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbol. $)
  $c om $. $( Greek letter omega $)

  $( Extend class notation to include the class of natural numbers. $)
  com $a class om $.

  ${
    $d x y $.
    $( Define the class of natural numbers, which are all ordinal numbers that
       are less than every limit ordinal, i.e. all finite ordinals.  Our
       definition is a variant of the Definition of N of [BellMachover] p. 471.
       See ~ dfom2 for an alternate definition.  Later, when we assume the
       Axiom of Infinity, we show ` om ` is a set in ~ omex , and ` om ` can
       then be defined per ~ dfom3 (the smallest inductive set) and ~ dfom4 .

       _Note_:  the natural numbers ` om ` are a subset of the ordinal numbers
       ~ df-on .  They are completely different from the natural numbers ` NN `
       ( ~ df-n ) that are a subset of the complex numbers defined much later
       in our development, although the two sets have analogous properties and
       operations defined on them. $)
    df-om $a |- om = { x | ( Ord x /\ A. y ( Lim y -> x e. y ) ) } $.
  $}

  ${
    $d x z $.  $d y z $.
    $( An alternate definition of the set of natural numbers ` om ` .
       Definition 7.28 of [TakeutiZaring] p. 42, who use the symbol K_I for the
       inner class builder of non-limit ordinal numbers (see ~ nlimon ). $)
    dfom2 $p |- om = { x e. On | suc x C_ { y e. On | -. Lim y } } $=
      vx cv word vz cv wlim vx cv vz cv wcel wi vz wal wa vx cab vx cv con0
      wcel vx cv csuc vy cv wlim wn vy con0 crab wss wa vx cab com vx cv csuc
      vy cv wlim wn vy con0 crab wss vx con0 crab vx cv word vz cv wlim vx cv
      vz cv wcel wi vz wal wa vx cv con0 wcel vx cv csuc vy cv wlim wn vy con0
      crab wss wa vx vx cv word vz cv wlim vx cv vz cv wcel wi vz wal wa vx cv
      con0 wcel vz cv wlim vx cv vz cv wcel wi vz wal wa vx cv con0 wcel vx cv
      csuc vy cv wlim wn vy con0 crab wss wa vx cv con0 wcel vx cv word vz cv
      wlim vx cv vz cv wcel wi vz wal vx cv vx visset elon anbi1i vx cv con0
      wcel vz cv wlim vx cv vz cv wcel wi vz wal vx cv csuc vy cv wlim wn vy
      con0 crab wss vx cv con0 wcel vz cv wlim vx cv vz cv wcel wi vz wal vz cv
      vx cv csuc wcel vz cv vy cv wlim wn vy con0 crab wcel wi vz wal vx cv
      csuc vy cv wlim wn vy con0 crab wss vx cv con0 wcel vz cv wlim vx cv vz
      cv wcel wi vz cv vx cv csuc wcel vz cv vy cv wlim wn vy con0 crab wcel wi
      vz vx cv con0 wcel vz cv wlim vx cv vz cv wcel wi vz cv con0 wcel vz cv
      vx cv csuc wcel vz cv vy cv wlim wn vy con0 crab wcel wi wi vz cv vx cv
      csuc wcel vz cv vy cv wlim wn vy con0 crab wcel wi vx cv con0 wcel vz cv
      con0 wcel vz cv vx cv csuc wcel vz cv vy cv wlim wn vy con0 crab wcel wi
      wi vz cv con0 wcel vx cv vz cv wcel wn vz cv con0 wcel vz cv wlim wn wa
      wi wi vz cv wlim vx cv vz cv wcel wi vx cv con0 wcel vz cv con0 wcel vz
      cv vx cv csuc wcel vz cv vy cv wlim wn vy con0 crab wcel wi vx cv vz cv
      wcel wn vz cv con0 wcel vz cv wlim wn wa wi vx cv con0 wcel vz cv con0
      wcel wa vz cv vx cv csuc wcel vx cv vz cv wcel wn vz cv vy cv wlim wn vy
      con0 crab wcel vz cv con0 wcel vz cv wlim wn wa vz cv con0 wcel vx cv
      con0 wcel vz cv vx cv csuc wcel vx cv vz cv wcel wn wb vz cv con0 wcel vx
      cv con0 wcel wa vz cv vx cv wss vz cv vx cv csuc wcel vx cv vz cv wcel wn
      vz cv vx cv onsssuc vz cv vx cv ontri1 bitr3d ancoms vz cv vy cv wlim wn
      vy con0 crab wcel vz cv con0 wcel vz cv wlim wn wa wb vx cv con0 wcel vz
      cv con0 wcel wa vy cv wlim wn vz cv wlim wn vy vz cv con0 vy cv vz cv
      wceq vy cv wlim vz cv wlim vy cv vz cv limeq notbid elrab a1i imbi12d
      pm5.74da vz cv wlim vx cv vz cv wcel wi vz cv con0 wcel vz cv wlim wa vx
      cv vz cv wcel wi vz cv con0 wcel vz cv wlim vx cv vz cv wcel wi wi vz cv
      con0 wcel vx cv vz cv wcel wn vz cv con0 wcel vz cv wlim wn wa wi wi vz
      cv wlim vz cv con0 wcel vz cv wlim wa vx cv vz cv wcel vz cv wlim vz cv
      con0 wcel vz cv cvv wcel vz cv wlim vz cv con0 wcel vz visset vz cv cvv
      limelon mpan pm4.71ri imbi1i vz cv con0 wcel vz cv wlim vx cv vz cv wcel
      impexp vz cv con0 wcel vz cv wlim vx cv vz cv wcel wi vx cv vz cv wcel wn
      vz cv con0 wcel vz cv wlim wn wa wi vz cv con0 wcel vx cv vz cv wcel wn
      vz cv wlim wn wi vx cv vz cv wcel wn vz cv con0 wcel vz cv wlim wn wa wi
      vz cv wlim vx cv vz cv wcel wi vz cv con0 wcel vz cv wlim wn vz cv con0
      wcel vz cv wlim wn wa vx cv vz cv wcel wn vz cv con0 wcel vz cv wlim wn
      ibar imbi2d vz cv wlim vx cv vz cv wcel con34b syl5bb pm5.74i 3bitri
      syl6rbbr vx cv con0 wcel vz cv con0 wcel vz cv vx cv csuc wcel wa vz cv
      vy cv wlim wn vy con0 crab wcel wi vz cv vx cv csuc wcel vz cv vy cv wlim
      wn vy con0 crab wcel wi vz cv con0 wcel vz cv vx cv csuc wcel vz cv vy cv
      wlim wn vy con0 crab wcel wi wi vx cv con0 wcel vz cv con0 wcel vz cv vx
      cv csuc wcel wa vz cv vx cv csuc wcel vz cv vy cv wlim wn vy con0 crab
      wcel vx cv con0 wcel vz cv con0 wcel vz cv vx cv csuc wcel wa vz cv vx cv
      csuc wcel vz cv con0 wcel vz cv vx cv csuc wcel pm3.27 vx cv con0 wcel vz
      cv vx cv csuc wcel vz cv con0 wcel vx cv con0 wcel vx cv csuc con0 wcel
      vz cv vx cv csuc wcel vz cv con0 wcel wi vx cv suceloni vx cv csuc con0
      wcel vz cv vx cv csuc wcel vz cv con0 wcel vx cv csuc vz cv onelon ex syl
      ancrd impbid2 imbi1d vz cv con0 wcel vz cv vx cv csuc wcel vz cv vy cv
      wlim wn vy con0 crab wcel impexp syl5bbr bitrd albidv vz vx cv csuc vy cv
      wlim wn vy con0 crab dfss2 syl6bbr pm5.32i bitr3i abbii vx vz df-om vx cv
      csuc vy cv wlim wn vy con0 crab wss vx con0 df-rab 3eqtr4i $.
      $( [4-Nov-2004] $) $( [1-Nov-2004] $)
  $}

  ${
    $d A x y $.
    elom.1 $e |- A e. _V $.
    $( Membership in omega.  The hypothesis can be eliminated if we assume the
       Axiom of Infinity; see ~ elom3 . $)
    elom $p |- ( A e. om <-> ( Ord A /\ A. x ( Lim x -> A e. x ) ) ) $=
      vy cv word vx cv wlim vy cv vx cv wcel wi vx wal wa cA word vx cv wlim cA
      vx cv wcel wi vx wal wa vy cA com elom.1 vy cv cA wceq vy cv word cA word
      vx cv wlim vy cv vx cv wcel wi vx wal vx cv wlim cA vx cv wcel wi vx wal
      vy cv cA ordeq vy cv cA wceq vx cv wlim vy cv vx cv wcel wi vx cv wlim cA
      vx cv wcel wi vx vy cv cA wceq vy cv vx cv wcel cA vx cv wcel vx cv wlim
      vy cv cA vx cv eleq1 imbi2d albidv anbi12d vy vx df-om elab2 $.
      $( [15-May-1994] $)
  $}

  ${
    $d A x y $.
    $( Membership in omega.  The antecedent can be eliminated if we assume the
       Axiom of Infinity; see ~ elom3 . $)
    elomg $p |- ( A e. B ->
                ( A e. om <-> ( Ord A /\ A. x ( Lim x -> A e. x ) ) ) ) $=
      vy cv com wcel vy cv word vx cv wlim vy cv vx cv wcel wi vx wal wa cA com
      wcel cA word vx cv wlim cA vx cv wcel wi vx wal wa vy cA cB vy cv cA com
      eleq1 vy cv cA wceq vy cv word cA word vx cv wlim vy cv vx cv wcel wi vx
      wal vx cv wlim cA vx cv wcel wi vx wal vy cv cA ordeq vy cv cA wceq vx cv
      wlim vy cv vx cv wcel wi vx cv wlim cA vx cv wcel wi vx vy cv cA wceq vy
      cv vx cv wcel cA vx cv wcel vx cv wlim vy cv cA vx cv eleq1 imbi2d albidv
      anbi12d vx vy cv vy visset elom vtoclbg $.
      $( [25-Mar-1995] $)
  $}

  ${
    $d x y $.
    $( Omega is a subset of ` On ` . $)
    omsson $p |- om C_ On $=
      vx com con0 vx cv com wcel vx cv word vx cv con0 wcel vx cv com wcel vx
      cv word vy cv wlim vx cv vy cv wcel wi vy wal vy vx cv vx visset elom
      pm3.26bi vx cv vx visset elon sylibr ssriv $.
      $( [13-Jun-1994] $)
  $}

  ${
    $d x y A $.
    $( The class of natural numbers is a subclass of any (infinite) limit
       ordinal.  Exercise 1 of [TakeutiZaring] p. 44.  Remarkably, our proof
       does not require the Axiom of Infinity. $)
    limomss $p |- ( Lim A -> om C_ A ) $=
      cA word cA wlim com cA wss cA limord cA word cA con0 wcel cA con0 wceq wo
      cA wlim com cA wss wi cA ordeleqon cA con0 wcel cA wlim com cA wss wi cA
      con0 wceq cA con0 wcel cA wlim com cA wss cA con0 wcel cA wlim wa vx com
      cA cA con0 wcel cA wlim vx cv com wcel vx cv cA wcel wi cA con0 wcel vx
      cv com wcel cA wlim vx cv cA wcel cA con0 wcel vy cv wlim vx cv vy cv
      wcel wi vy wal cA wlim vx cv cA wcel wi vx cv com wcel vy cv wlim vx cv
      vy cv wcel wi cA wlim vx cv cA wcel wi vy cA con0 vy cv cA wceq vy cv
      wlim cA wlim vx cv vy cv wcel vx cv cA wcel vy cv cA limeq vy cv cA vx cv
      eleq2 imbi12d cla4gv vx cv com wcel vx cv word vy cv wlim vx cv vy cv
      wcel wi vy wal vy vx cv vx visset elom pm3.27bi syl5 com23 imp ssrdv ex
      cA con0 wceq com cA wss cA wlim cA con0 wceq com cA wss com con0 wss
      omsson cA con0 com sseq2 mpbiri a1d jaoi sylbi mpcom $.
      $( [4-Nov-2003] $) $( [30-Oct-2003] $)
  $}

  $( A natural number is an ordinal number. $)
  nnon $p |- ( A e. om -> A e. On ) $=
    com con0 cA omsson sseli $.
    $( [27-Jun-1994] $)

  ${
    nnoni.1 $e |- A e. om $.
    $( A natural number is an ordinal number. $)
    nnoni $p |- A e. On $=
      cA com wcel cA con0 wcel nnoni.1 cA nnon ax-mp $.
      $( [27-Jun-1994] $)
  $}

  $( A natural number is ordinal. $)
  nnord $p |- ( A e. om -> Ord A ) $=
    cA com wcel cA con0 wcel cA word cA nnon cA eloni syl $.
    $( [17-Oct-1995] $)

  ${
    $d x y z $.
    $( Omega is ordinal.  Theorem 7.32 of [TakeutiZaring] p. 43. $)
    ordom $p |- Ord om $=
      com wtr com con0 wss con0 word com word com wtr vy cv vx cv wcel vx cv
      com wcel wa vy cv com wcel wi vx wal vy vy vx com dftr2 vy cv vx cv wcel
      vx cv com wcel wa vy cv com wcel wi vx vy cv com wcel vy cv word vz cv
      wlim vy cv vz cv wcel wi vz wal vy cv vx cv wcel vx cv com wcel wa vz vy
      cv vy visset elom vx cv com wcel vy cv vx cv wcel vy cv word vx cv word
      vy cv vx cv wcel vy cv word vx cv com wcel vx cv vy cv ordelord vx cv
      nnord sylan ancoms vy cv vx cv wcel vx cv com wcel vz cv wlim vy cv vz cv
      wcel wi vz wal vy cv vx cv wcel vz cv wlim vx cv vz cv wcel wi vz wal vz
      cv wlim vy cv vz cv wcel wi vz wal vx cv com wcel vy cv vx cv wcel vz cv
      wlim vx cv vz cv wcel wi vz cv wlim vy cv vz cv wcel wi vz vy cv vx cv
      wcel vz cv wlim vx cv vz cv wcel vy cv vz cv wcel vy cv vx cv wcel vz cv
      wtr vx cv vz cv wcel vy cv vz cv wcel wi vz cv wlim vz cv wtr vy cv vx cv
      wcel vx cv vz cv wcel vy cv vz cv wcel wi vz cv wtr vy cv vx cv wcel vx
      cv vz cv wcel vy cv vz cv wcel vz cv vy cv vx cv trel exp3a com12 vz cv
      wlim vz cv word vz cv wtr vz cv limord vz cv ordtr syl syl5 a2d 19.20dv
      vx cv com wcel vx cv word vz cv wlim vx cv vz cv wcel wi vz wal vz vx cv
      vx visset elom pm3.27bi syl5 imp sylanbrc ax-gen mpgbir omsson ordon com
      con0 trssord mp3an $.
      $( [18-Oct-1995] $)
  $}

  $( A member of a natural number is a natural number. $)
  elnn $p |- ( ( A e. B /\ B e. om ) -> A e. om ) $=
    com wtr cA cB wcel cB com wcel wa cA com wcel wi com word com wtr ordom com
    ordtr ax-mp com cA cB trel ax-mp $.
    $( [21-Jun-1998] $)

  $( The class of natural numbers ` om ` is either an ordinal number (if we
     accept the Axiom of Infinity) or the proper class of all ordinal numbers
     (if we deny the Axiom of Infinity).  Remark in [TakeutiZaring] p. 43. $)
  omon $p |- ( om e. On \/ om = On ) $=
    com word com con0 wcel com con0 wceq wo ordom com ordeleqon mpbi $.
    $( [10-May-1998] $)

  ${
    $d x y A $.
    $( A natural number is not a limit ordinal. $)
    nnlim $p |- ( A e. om -> -. Lim A ) $=
      cA com wcel cA wlim cA cA wcel cA com wcel cA word cA cA wcel wn cA nnord
      cA ordirr syl cA com wcel vx cv wlim cA vx cv wcel wi vx wal cA wlim cA
      cA wcel wi cA com wcel cA word vx cv wlim cA vx cv wcel wi vx wal cA com
      wcel cA word vx cv wlim cA vx cv wcel wi vx wal wa vx cA com elomg ibi
      pm3.27d vx cv wlim cA vx cv wcel wi cA wlim cA cA wcel wi vx cA com vx cv
      cA wceq vx cv wlim cA wlim cA vx cv wcel cA cA wcel vx cv cA limeq vx cv
      cA cA eleq2 imbi12d cla4gv mpd mtod $.
      $( [18-Oct-1995] $)

    $( The class of natural numbers is a subclass of the class of non-limit
       ordinal numbers.  Exercise 4 of [TakeutiZaring] p. 42. $)
    omssnlim $p |- om C_ { x e. On | -. Lim x } $=
      vy com vx cv wlim wn vx con0 crab vy cv vx cv wlim wn vx con0 crab wcel
      vy cv con0 wcel vy cv wlim wn vy cv com wcel vx cv wlim wn vy cv wlim wn
      vx vy cv con0 vx cv vy cv wceq vx cv wlim vy cv wlim vx cv vy cv limeq
      notbid elrab vy cv nnon vy cv nnlim sylanbrc ssriv $.
      $( [14-Nov-2004] $) $( [2-Nov-2004] $)
  $}

  $( Omega is a limit ordinal.  Theorem 2.8 of [BellMachover] p. 473.
     Our proof, however, does not require the Axiom of Infinity. $)
  limom $p |- Lim om $=
    com word com wlim ordom com word com con0 wcel com con0 wceq wo com wlim
    com ordeleqon com con0 wcel com wlim com con0 wceq com con0 wcel com wlim
    com com wcel com word com com wcel wn ordom com ordirr ax-mp com con0 wcel
    com com wcel com word vx cv wlim com vx cv wcel wi vx wal wa com wlim wn vx
    com con0 elomg com wlim wn vx cv wlim com vx cv wcel wi vx wal com word com
    wlim wn vx cv wlim com vx cv wcel wi vx com wlim wn vx cv wlim com vx cv
    wcel vx cv wlim com wlim wn vx cv wlim com vx cv wcel wi vx cv word com
    wlim wn vx cv wlim com vx cv wcel wi vx cv wlim vx cv word com word com
    wlim wn vx cv wlim com vx cv wcel wi ordom vx cv word com word wa com wlim
    wn wa com vx cv wcel vx cv wlim vx cv word com word wa com wlim wn wa com
    vx cv wcel wn vx cv com wss vx cv wlim wn vx cv word com word wa vx cv com
    wss com vx cv wcel wn wb com wlim wn vx cv com ordtri1 adantr vx cv word
    com word wa vx cv com wss vx cv com wcel vx cv com wceq wo com wlim wn vx
    cv wlim wn vx cv word com word wa vx cv com wss vx cv com wcel vx cv com
    wceq wo vx cv com ordsseleq biimpd com wlim wn vx cv com wcel vx cv wlim wn
    vx cv com wceq vx cv com wcel vx cv wlim wn wi com wlim wn vx cv nnlim a1i
    vx cv com wceq com wlim wn vx cv wlim wn vx cv com wceq vx cv wlim com wlim
    vx cv com wceq vx cv wlim com wlim vx cv com limeq biimpd con3d com12 jaod
    sylan9 sylbird con4d mpanl2 vx cv limord sylan ex pm2.43b 19.21aiv ordom
    jctil syl5bir mt3i com con0 wceq com wlim con0 wlim limon com con0 limeq
    mpbiri jaoi sylbi ax-mp $.
    $( [26-Mar-1995] $)

  $( A class belongs to omega iff its successor does. $)
  peano2b $p |- ( A e. om <-> suc A e. om ) $=
    com wlim cA com wcel cA csuc com wcel wb limom com cA limsuc ax-mp $.
    $( [3-Dec-1995] $)

  ${
    $d x y A $.
    $( A non-zero natural number is a successor. $)
    nnsuc $p |- ( ( A e. om /\ A =/= (/) ) -> E. x e. om A = suc x ) $=
      cA com wcel cA c0 wne wa cA vx cv csuc wceq vx con0 wrex cA vx cv csuc
      wceq vx com wrex cA com wcel cA c0 wne wa cA vx cv csuc wceq vx con0 wrex
      cA wlim cA com wcel cA wlim wn cA c0 wne cA nnlim adantr cA word cA c0
      wne cA vx cv csuc wceq vx con0 wrex wn cA wlim wi cA com wcel cA word cA
      c0 wne wa cA vx cv csuc wceq vx con0 wrex wn cA cA cuni wceq cA wlim cA
      word cA cA cuni wceq cA vx cv csuc wceq vx con0 wrex wn wb cA c0 wne vx
      cA orduninsuc adantr cA word cA c0 wne cA cA cuni wceq cA wlim cA wlim cA
      word cA c0 wne cA cA cuni wceq w3a cA df-lim biimpri 3expia sylbird cA
      nnord sylan mt3d cA com wcel cA vx cv csuc wceq vx con0 wrex cA vx cv
      csuc wceq vx com wrex wi cA c0 wne cA com wcel cA vx cv csuc wceq cA vx
      cv csuc wceq vx con0 com cA com wcel cA vx cv csuc wceq vx cv com wcel cA
      vx cv csuc wceq wa vx cv con0 wcel cA com wcel cA vx cv csuc wceq vx cv
      com wcel cA com wcel cA vx cv csuc wceq vx cv csuc com wcel vx cv com
      wcel cA vx cv csuc wceq cA com wcel vx cv csuc com wcel cA vx cv csuc com
      eleq1 biimpcd vx cv peano2b syl6ibr ancrd adantld r19.22dv2 adantr mpd $.
      $( [6-Apr-2007] $) $( [18-Feb-2004] $)
  $}

  ${
    $d x A $.
    $( An ordinal subclass of non-limit ordinals is a class of natural numbers.
       Exercise 7 of [TakeutiZaring] p. 42. $)
    ssnlim $p |- ( ( Ord A /\ A C_ { x e. On | -. Lim x } ) -> A C_ om ) $=
      cA word cA vx cv wlim wn vx con0 crab wss wa cA com wss com cA wcel wn cA
      vx cv wlim wn vx con0 crab wss com cA wcel wn cA word cA vx cv wlim wn vx
      con0 crab wss com cA wcel com wlim limom cA vx cv wlim wn vx con0 crab
      wss com cA wcel com vx cv wlim wn vx con0 crab wcel com wlim wn cA vx cv
      wlim wn vx con0 crab com ssel com vx cv wlim wn vx con0 crab wcel com
      con0 wcel com wlim wn vx cv wlim wn com wlim wn vx com con0 vx cv com
      wceq vx cv wlim com wlim vx cv com limeq notbid elrab pm3.27bi syl6 mt2i
      adantl cA word cA com wss com cA wcel wn wb cA vx cv wlim wn vx con0 crab
      wss cA word com word cA com wss com cA wcel wn wb ordom cA com ordtri1
      mpan2 adantr mpbird $.
      $( [3-Nov-2004] $) $( [2-Nov-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Peano's postulates
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Zero is a natural number.  One of Peano's 5 postulates for arithmetic.
     Proposition 7.30(1) of [TakeutiZaring] p. 42.  Note: Unlike most
     textbooks, our proofs of ~ peano1 through ~ peano5 do not use the Axiom
     of Infinity.  Unlike Takeuti and Zaring, they also do not use the Axiom
     of Regularity. $)
  peano1 $p |- (/) e. om $=
    com wlim c0 com wcel limom com 0ellim ax-mp $.
    $( [15-May-1994] $)

  $( The successor of any natural number is a natural number.  One of Peano's
     5 postulates for arithmetic.  Proposition 7.30(2) of [TakeutiZaring]
     p. 42. $)
  peano2 $p |- ( A e. om -> suc A e. om ) $=
    cA com wcel cA csuc com wcel cA peano2b biimpi $.
    $( [3-Sep-2003] $)

  $( The successor of any natural number is not zero.  One of Peano's 5
     postulates for arithmetic.  Proposition 7.30(3) of [TakeutiZaring]
     p. 42. $)
  peano3 $p |- ( A e. om -> suc A =/= (/) ) $=
    cA csuc c0 wne cA com wcel cA nsuceq0 a1i $.
    $( [2-Jun-2007] $) $( [3-Sep-2003] $)

  $( Two natural numbers are equal iff their successors are equal, i.e. the
     successor function is one-to-one.  One of Peano's 5 postulates for
     arithmetic.  Proposition 7.30(4) of [TakeutiZaring] p. 43. $)
  peano4 $p |- ( ( A e. om /\ B e. om ) -> ( suc A = suc B <-> A = B ) ) $=
    cA con0 wcel cB con0 wcel cA csuc cB csuc wceq cA cB wceq wb cA com wcel cB
    com wcel cA cB suc11 cA nnon cB nnon syl2an $.
    $( [3-Sep-2003] $)

  ${
    $d x y A $.
    $( The induction postulate: any class containing zero and closed under the
       successor operation contains all natural numbers.  One of Peano's 5
       postulates for arithmetic.  Proposition 7.30(5) of [TakeutiZaring]
       p. 43, except our proof does not require the Axiom of Infinity.  The
       more traditional statement of mathematical induction as a theorem
       schema, with a basis and an induction hypothesis, is derived from this
       theorem as theorem ~ findes . $)
    peano5 $p |- ( ( (/) e. A /\
                 A. x e. om ( x e. A -> suc x e. A ) ) -> om C_ A ) $=
      c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral wa com cA cdif
      c0 wceq com cA wss c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com
      wral wa com cA cdif vy cv cin c0 wceq vy com cA cdif wrex wn com cA cdif
      c0 wceq c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral wa com
      cA cdif vy cv cin c0 wceq vy com cA cdif c0 cA wcel vx cv cA wcel vx cv
      csuc cA wcel wi vx com wral wa vy cv com cA cdif wcel wa com cA cdif vy
      cv cin c0 wceq vy cv cA wcel vy cv com cA cdif wcel vy cv cA wcel wn c0
      cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral wa vy cv com cA
      eldifn adantl c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral
      wa vy cv com cA cdif wcel wa com cA cdif vy cv cin c0 wceq vy cv cA wcel
      c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral wa vy cv com
      cA cdif wcel wa com cA cdif vy cv cin c0 wceq wa vy cv vx cv csuc wceq vx
      com wrex vy cv cA wcel c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx
      com wral wa vy cv com cA cdif wcel wa vy cv vx cv csuc wceq vx com wrex
      com cA cdif vy cv cin c0 wceq c0 cA wcel vy cv com cA cdif wcel vy cv vx
      cv csuc wceq vx com wrex vx cv cA wcel vx cv csuc cA wcel wi vx com wral
      vy cv com wcel vy cv c0 wne vy cv vx cv csuc wceq vx com wrex c0 cA wcel
      vy cv com cA cdif wcel wa vx vy cv nnsuc vy cv com cA cdif wcel vy cv com
      wcel c0 cA wcel vy cv com cA eldifi adantl c0 cA wcel vy cv com cA cdif
      wcel vy cv c0 wne vy cv com cA cdif wcel c0 com cA cdif wcel wn vy cv c0
      wne c0 cA wcel vy cv com cA cdif wcel c0 com cA cdif wcel vy cv c0 vy cv
      c0 wceq vy cv com cA cdif wcel c0 com cA cdif wcel vy cv c0 com cA cdif
      eleq1 biimpcd necon3bd c0 cA com elndif syl5com imp sylanc adantlr adantr
      c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral vy cv com cA
      cdif wcel com cA cdif vy cv cin c0 wceq vy cv vx cv csuc wceq vx com wrex
      vy cv cA wcel wi vx cv cA wcel vx cv csuc cA wcel wi vx com wral vy cv
      com cA cdif wcel com cA cdif vy cv cin c0 wceq vy cv vx cv csuc wceq vx
      com wrex vy cv cA wcel wi wi wi wi c0 cA wcel vx cv cA wcel vx cv csuc cA
      wcel wi vx com wral vy cv com cA cdif wcel com cA cdif vy cv cin c0 wceq
      vy cv vx cv csuc wceq vx com wrex vy cv cA wcel wi vx cv cA wcel vx cv
      csuc cA wcel wi vx com wral vy cv com cA cdif wcel com cA cdif vy cv cin
      c0 wceq wa wa vy cv vx cv csuc wceq vy cv cA wcel vx com vx cv cA wcel vx
      cv csuc cA wcel wi vx com wral vy cv com cA cdif wcel com cA cdif vy cv
      cin c0 wceq wa vx vx cv cA wcel vx cv csuc cA wcel wi vx com hbra1 vy cv
      com cA cdif wcel com cA cdif vy cv cin c0 wceq wa vx ax-17 hban vy cv cA
      wcel vx ax-17 vx cv cA wcel vx cv csuc cA wcel wi vx com wral vx cv com
      wcel vx cv cA wcel vx cv csuc cA wcel wi vy cv com cA cdif wcel com cA
      cdif vy cv cin c0 wceq wa vy cv vx cv csuc wceq vy cv cA wcel wi vx cv cA
      wcel vx cv csuc cA wcel wi vx com ra4 vy cv vx cv csuc wceq vx cv cA wcel
      vx cv csuc cA wcel wi vy cv com cA cdif wcel com cA cdif vy cv cin c0
      wceq wa vy cv cA wcel vy cv vx cv csuc wceq vy cv com cA cdif wcel com cA
      cdif vy cv cin c0 wceq wa vx cv cA wcel vx cv csuc cA wcel vy cv cA wcel
      vy cv vx cv csuc wceq vy cv com cA cdif wcel com cA cdif vy cv cin c0
      wceq vx cv cA wcel vy cv vx cv csuc wceq vy cv com wcel com cA cdif vy cv
      cin c0 wceq vx cv cA wcel wi vy cv com cA cdif wcel vy cv vx cv csuc wceq
      vy cv com wcel vx cv vy cv wcel com cA cdif vy cv cin c0 wceq vx cv cA
      wcel wi vy cv vx cv csuc wceq vx cv vy cv wcel vx cv vx cv csuc wcel vx
      cv vx visset sucid vy cv vx cv csuc vx cv eleq2 mpbiri vy cv vx cv csuc
      wceq vy cv com wcel vx cv com wcel vx cv vy cv wcel com cA cdif vy cv cin
      c0 wceq vx cv cA wcel wi wi vy cv vx cv csuc wceq vy cv com wcel vx cv
      csuc com wcel vx cv com wcel vy cv vx cv csuc com eleq1 vx cv peano2b
      syl6bbr vx cv com wcel vx cv vy cv wcel com cA cdif vy cv cin c0 wceq vx
      cv cA wcel vx cv com wcel vx cv com cA cdif wcel wn vx cv cA wcel vx cv
      vy cv wcel com cA cdif vy cv cin c0 wceq wa vx cv com cA neldif vx cv vy
      cv com cA cdif minel sylan2 exp32 syl6bi mpid vy cv com cA eldifi syl5
      imp3a vx cv csuc cA wcel vy cv vx cv csuc wceq vy cv cA wcel vx cv csuc
      cA vy cv eleq1a com12 imim12d com13 sylan9 r19.23ad exp32 a1i imp41 mpd
      ex mtod nrexdv com cA cdif vy cv cin c0 wceq vy com cA cdif wrex com cA
      cdif c0 com word com cA cdif com wss com cA cdif c0 wne com cA cdif vy cv
      cin c0 wceq vy com cA cdif wrex ordom com cA difss vy com com cA cdif
      tz7.5 mp3an12 necon1bi syl com cA ssdif0 sylibr $.
      $( [2-Mar-2004] $) $( [18-Feb-2004] $)
  $}

  ${
    $d x A $.
    $( A natural number is either 0 or a successor. $)
    nn0suc $p |- ( A e. om -> ( A = (/) \/ E. x e. om A = suc x ) ) $=
      cA com wcel cA c0 wceq cA vx cv csuc wceq vx com wrex cA com wcel cA c0
      wceq wn cA vx cv csuc wceq vx com wrex cA com wcel cA c0 wne cA vx cv
      csuc wceq vx com wrex cA c0 wceq wn vx cA nnsuc cA c0 df-ne sylan2br ex
      orrd $.
      $( [27-May-1998] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite induction (for finite ordinals)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    find.1 $e |- ( A C_ om /\ (/) e. A /\ A. x e. A suc x e. A ) $.
    $( The Principle of Finite Induction (mathematical induction).  Corollary
       7.31 of [TakeutiZaring] p. 43.  The simpler hypothesis shown here was
       suggested in an email from "Colin" on 1-Oct-2001.  The hypothesis states
       that ` A ` is a set of natural numbers, zero belongs to ` A ` , and
       given any member of ` A ` the member's successor also belongs to ` A ` .
       The conclusion is that every natural number is in ` A ` . $)
    find $p |- A = om $=
      cA com cA com wss c0 cA wcel vx cv csuc cA wcel vx cA wral find.1 3simp1i
      cA com wss c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral w3a
      com cA wss cA com wss c0 cA wcel vx cv csuc cA wcel vx cA wral w3a cA com
      wss c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral w3a find.1
      cA com wss c0 cA wcel vx cv csuc cA wcel vx cA wral wa wa cA com wss c0
      cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com wral wa wa cA com wss
      c0 cA wcel vx cv csuc cA wcel vx cA wral w3a cA com wss c0 cA wcel vx cv
      cA wcel vx cv csuc cA wcel wi vx com wral w3a c0 cA wcel vx cv csuc cA
      wcel vx cA wral wa c0 cA wcel vx cv cA wcel vx cv csuc cA wcel wi vx com
      wral wa cA com wss vx cv csuc cA wcel vx cA wral vx cv cA wcel vx cv csuc
      cA wcel wi vx com wral c0 cA wcel vx cv csuc cA wcel vx cA wral vx cv com
      wcel vx cv csuc cA wcel wi vx cA wral vx cv cA wcel vx cv csuc cA wcel wi
      vx com wral vx cv csuc cA wcel vx cv com wcel vx cv csuc cA wcel wi vx cA
      vx cv csuc cA wcel vx cv com wcel ax-1 r19.20si vx cv csuc cA wcel vx cA
      com ralcom3 sylib anim2i anim2i cA com wss c0 cA wcel vx cv csuc cA wcel
      vx cA wral 3anass cA com wss c0 cA wcel vx cv cA wcel vx cv csuc cA wcel
      wi vx com wral 3anass 3imtr4i ax-mp c0 cA wcel vx cv cA wcel vx cv csuc
      cA wcel wi vx com wral com cA wss cA com wss vx cA peano5 3adant1 ax-mp
      eqssi $.
      $( [5-Mar-2004] $) $( [22-Feb-2004] $)
  $}

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    finds.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    finds.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    finds.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    finds.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    finds.5 $e |- ps $.
    $( Induction hypothesis. $)
    finds.6 $e |- ( y e. om -> ( ch -> th ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the substitutions we
       need.  The last two are the basis and the induction hypothesis.
       Theorem Schema 22 of [Suppes] p. 136. $)
    finds $p |- ( A e. om -> ta ) $=
      cA com wcel cA wph vx cab wcel wta com wph vx cab cA c0 wph vx cab wcel
      vy cv wph vx cab wcel vy cv csuc wph vx cab wcel wi vy com wral com wph
      vx cab wss c0 wph vx cab wcel wps finds.5 wph wps vx c0 0ex finds.1 elab
      mpbir vy cv wph vx cab wcel vy cv csuc wph vx cab wcel wi vy com vy cv
      com wcel wch wth vy cv wph vx cab wcel vy cv csuc wph vx cab wcel finds.6
      wph wch vx vy cv vy visset finds.2 elab wph wth vx vy cv csuc vy cv vy
      visset sucex finds.3 elab 3imtr4g rgen vy wph vx cab peano5 mp2an sseli
      wph wta vx cA com finds.4 elabg mpbid $.
      $( [14-Apr-1995] $)
  $}

  ${
    $d x A $.  $d x y B $.
    $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.  $d y ph $.
    $( Substitutions. $)
    findsg.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    findsg.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    findsg.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    findsg.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    findsg.5 $e |- ( B e. om -> ps ) $.
    $( Induction hypothesis. $)
    findsg.6 $e |- ( ( ( y e. om /\ B e. om ) /\ B C_ y ) -> ( ch -> th ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the substitutions we
       need.  The last two are the basis and the induction hypothesis.  The
       basis of this version is an arbitrary natural number ` B ` instead of
       zero. $)
    findsg $p |- ( ( ( A e. om /\ B e. om ) /\ B C_ A ) -> ta ) $=
      cA com wcel cB com wcel cB cA wss wta cB com wcel cB vx cv wss wph wi wi
      cB com wcel cB c0 wss wps wi wi cB com wcel cB vy cv wss wch wi wi cB com
      wcel cB vy cv csuc wss wth wi wi cB com wcel cB cA wss wta wi wi vx vy cA
      vx cv c0 wceq cB vx cv wss wph wi cB c0 wss wps wi cB com wcel cB c0 wceq
      vx cv c0 wceq cB vx cv wss wph wi cB c0 wss wps wi wb cB c0 wceq vx cv c0
      wceq wa cB vx cv wss cB c0 wss wph wps vx cv c0 wceq cB vx cv wss cB c0
      wss wb cB c0 wceq vx cv c0 cB sseq2 adantl cB c0 wceq vx cv c0 wceq wph
      wps wb cB c0 wceq vx cv c0 wceq vx cv cB wceq wph wps wb cB c0 vx cv
      eqeq2 findsg.1 syl6bir imp imbi12d vx cv c0 wceq cB vx cv wss wph wi cB
      c0 wss wph wi cB c0 wceq wn cB c0 wss wps wi vx cv c0 wceq cB vx cv wss
      cB c0 wss wph vx cv c0 cB sseq2 imbi1d cB c0 wceq wn cB c0 wss wph wps cB
      c0 wceq wn cB c0 wss wph wps wb cB c0 wss cB c0 wceq cB ss0 con3i pm2.21d
      pm5.74d sylan9bbr pm2.61ian imbi2d vx cv vy cv wceq cB vx cv wss wph wi
      cB vy cv wss wch wi cB com wcel vx cv vy cv wceq cB vx cv wss cB vy cv
      wss wph wch vx cv vy cv cB sseq2 findsg.2 imbi12d imbi2d vx cv vy cv csuc
      wceq cB vx cv wss wph wi cB vy cv csuc wss wth wi cB com wcel vx cv vy cv
      csuc wceq cB vx cv wss cB vy cv csuc wss wph wth vx cv vy cv csuc cB
      sseq2 findsg.3 imbi12d imbi2d vx cv cA wceq cB vx cv wss wph wi cB cA wss
      wta wi cB com wcel vx cv cA wceq cB vx cv wss cB cA wss wph wta vx cv cA
      cB sseq2 findsg.4 imbi12d imbi2d cB com wcel wps cB c0 wss findsg.5 a1d
      vy cv com wcel cB com wcel cB vy cv wss wch wi cB vy cv csuc wss wth wi
      vy cv com wcel cB com wcel cB vy cv wss wch wi cB vy cv csuc wss wth wi
      wi vy cv com wcel cB com wcel wa cB vy cv csuc wss cB vy cv csuc wceq wi
      cB vy cv wss wch wi cB vy cv csuc wss wth wi wi cB com wcel cB vy cv csuc
      wss cB vy cv csuc wceq wi cB vy cv wss wch wi cB vy cv csuc wss wth wi wi
      wi vy cv com wcel cB vy cv csuc wss cB vy cv csuc wceq wi cB vy cv wss
      wch wi cB vy cv csuc wss cB com wcel wth cB vy cv csuc wss cB vy cv csuc
      wceq wi cB vy cv csuc wss cB com wcel wth wi wi cB vy cv wss wch wi cB vy
      cv csuc wceq cB com wcel wth wi cB vy cv csuc wss cB com wcel wth wi vy
      cv csuc cB vy cv csuc cB wceq vx cv vy cv csuc wceq vx cv cB wceq wa vx
      wex cB com wcel wth wi vx vy cv csuc cB vy cv vy visset sucex eqvinc vx
      cv vy cv csuc wceq vx cv cB wceq wa cB com wcel wth wi vx vx cv cB wceq
      cB com wcel wph vx cv vy cv csuc wceq wth vx cv cB wceq wph wps cB com
      wcel findsg.1 findsg.5 syl5bir vx cv vy cv csuc wceq wph wth findsg.3
      biimpd sylan9r 19.23aiv sylbi eqcoms imim2i a1d com4r adantl vy cv com
      wcel cB com wcel wa cB vy cv csuc wss cB vy cv csuc wne wa cB vy cv wss
      wch wi cB vy cv csuc wss wth wi wi cB vy cv csuc wss cB vy cv csuc wceq
      wi wn vy cv com wcel cB com wcel wa cB vy cv csuc wss cB vy cv csuc wne
      wa cB vy cv wss cB vy cv wss wch wi cB vy cv csuc wss wth wi wi cB com
      wcel vy cv com wcel cB vy cv wss cB vy cv csuc wss cB vy cv csuc wne wa
      wb cB con0 wcel vy cv con0 wcel cB vy cv wss cB vy cv csuc wss cB vy cv
      csuc wne wa wb cB com wcel vy cv com wcel cB con0 wcel vy cv con0 wcel wa
      cB vy cv wss cB vy cv csuc wcel cB vy cv csuc wss cB vy cv csuc wne wa cB
      vy cv onsssuc cB con0 wcel vy cv csuc con0 wcel cB vy cv csuc wcel cB vy
      cv csuc wss cB vy cv csuc wne wa wb vy cv con0 wcel cB vy cv csuc onelpss
      vy cv suceloni sylan2 bitrd cB nnon vy cv nnon syl2an ancoms vy cv com
      wcel cB com wcel wa cB vy cv wss wch wi cB vy cv wss cB vy cv csuc wss
      wth wi vy cv com wcel cB com wcel wa cB vy cv wss wch cB vy cv csuc wss
      wth wi vy cv com wcel cB com wcel wa cB vy cv wss wch wth cB vy cv csuc
      wss wth wi vy cv com wcel cB com wcel wa cB vy cv wss wch wth wi findsg.6
      ex wth cB vy cv csuc wss ax-1 syl8 a2d com23 sylbird cB vy cv csuc wss cB
      vy cv csuc wne wa cB vy cv csuc wss cB vy cv csuc wceq wn wa cB vy cv
      csuc wss cB vy cv csuc wceq wi wn cB vy cv csuc wne cB vy cv csuc wceq wn
      cB vy cv csuc wss cB vy cv csuc df-ne anbi2i cB vy cv csuc wss cB vy cv
      csuc wceq annim bitri syl5ibr pm2.61d ex a2d finds imp31 $.
      $( [16-Sep-1995] $)
  $}

  ${
    $d x y ta $.  $d x ps $.  $d x ch $.  $d x th $.  $d y ph $.
    $( Substitutions. $)
    finds2.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    finds2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    finds2.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    $( Basis. $)
    finds2.4 $e |- ( ta -> ps ) $.
    $( Induction hypothesis. $)
    finds2.5 $e |- ( y e. om -> ( ta -> ( ch -> th ) ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first three hypotheses establish the substitutions
       we need.  The last two are the basis and the induction hypothesis.
       Theorem Schema 22 of [Suppes] p. 136. $)
    finds2 $p |- ( x e. om -> ( ta -> ph ) ) $=
      vx cv com wcel vx cv wta wph wi vx cab wcel wta wph wi com wta wph wi vx
      cab vx cv c0 wta wph wi vx cab wcel vy cv wta wph wi vx cab wcel vy cv
      csuc wta wph wi vx cab wcel wi vy com wral com wta wph wi vx cab wss c0
      wta wph wi vx cab wcel wta wps wi finds2.4 wta wph wi wta wps wi vx c0
      0ex vx cv c0 wceq wph wps wta finds2.1 imbi2d elab mpbir vy cv wta wph wi
      vx cab wcel vy cv csuc wta wph wi vx cab wcel wi vy com vy cv com wcel
      wta wch wi wta wth wi vy cv wta wph wi vx cab wcel vy cv csuc wta wph wi
      vx cab wcel vy cv com wcel wta wch wth finds2.5 a2d wta wph wi wta wch wi
      vx vy cv vy visset vx cv vy cv wceq wph wch wta finds2.2 imbi2d elab wta
      wph wi wta wth wi vx vy cv csuc vy cv vy visset sucex vx cv vy cv csuc
      wceq wph wth wta finds2.3 imbi2d elab 3imtr4g rgen vy wta wph wi vx cab
      peano5 mp2an sseli wta wph wi vx abid sylib $.
      $( [29-Nov-2002] $)
  $}

  ${
    $d x y $.  $d x ps $.  $d x ch $.  $d x th $.  $d y ph $.
    $( Substitutions. $)
    finds1.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    finds1.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    finds1.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    $( Basis. $)
    finds1.4 $e |- ps $.
    $( Induction hypothesis. $)
    finds1.5 $e |- ( y e. om -> ( ch -> th ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first three hypotheses establish the substitutions
       we need.  The last two are the basis and the induction hypothesis.
       Theorem Schema 22 of [Suppes] p. 136. $)
    finds1 $p |- ( x e. om -> ph ) $=
      vx cv com wcel c0 c0 wceq wph c0 eqid wph wps wch wth c0 c0 wceq vx vy
      finds1.1 finds1.2 finds1.3 wps c0 c0 wceq finds1.4 a1i vy cv com wcel wch
      wth wi c0 c0 wceq finds1.5 a1d finds2 mpi $.
      $( [23-Mar-2006] $) $( [22-Mar-2006] $)
  $}

  ${
    $d x y z $.  $d y z ph $.
    findes.1 $e |- [ (/) / x ] ph $.
    findes.2 $e |- ( x e. om -> ( ph -> [ suc x / x ] ph ) ) $.
    $( Finite induction with explicit substitution.  The first hypothesis is
       the basis and the second is the induction hypothesis.  Theorem Schema
       22 of [Suppes] p. 136.  See ~ tfindes for the transfinite version.
      (Contributed by Raph Levien, 9-Jul-2003.) $)
    findes $p |- ( x e. om -> ph ) $=
      wph vx vz cv wsbc wph vx c0 wsbc wph vx vy cv wsbc wph vx vy cv csuc wsbc
      wph vz vy vx cv wph vx vz cv c0 dfsbcq wph vz vy vx sbequ wph vx vz cv vy
      cv csuc dfsbcq wph vz vx sbequ12r findes.1 vx cv com wcel wph wph vx vx
      cv csuc wsbc wi wi vy cv com wcel wph vx vy cv wsbc wph vx vy cv csuc
      wsbc wi wi vx vy vy cv com wcel wph vx vy cv wsbc wph vx vy cv csuc wsbc
      wi vx vy cv com wcel vx ax-17 wph vx vy cv wsbc wph vx vy cv csuc wsbc vx
      wph vx vy hbs1 wph vx vy cv csuc vy cv vy visset sucex hbsbc1v hbim hbim
      vx cv vy cv wceq vx cv com wcel vy cv com wcel wph wph vx vx cv csuc wsbc
      wi wph vx vy cv wsbc wph vx vy cv csuc wsbc wi vx cv vy cv com eleq1 vx
      cv vy cv wceq wph wph vx vy cv wsbc wph vx vx cv csuc wsbc wph vx vy cv
      csuc wsbc wph vx vy sbequ12 vx cv vy cv wceq vx cv csuc vy cv csuc wceq
      wph vx vx cv csuc wsbc wph vx vy cv csuc wsbc wb vx cv vy cv suceq wph vx
      vx cv csuc vy cv csuc dfsbcq syl imbi12d imbi12d findes.2 chvar finds $.
      $( [29-Jul-2003] $) $( [9-Jul-2003] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Functions and relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c X. $. $( Times symbol (cross product symbol) (read: 'cross') $)
  $c `' $. $( Small elevated smiley (converse operation) $)
  $c dom $. $( Domain $)
  $c ran $. $( Range $)
  $c |` $. $( Right hook (restriction symbol) $)
  $c " $. $( Left quote (image symbol) $)
  $c o. $. $( Small circle (composition symbol) $)
  $c Rel $. $( Relation predicate $)
  $c Fun $. $( Function predicate $)
  $c Fn $. $( Function connective $)
  $c : $. $( Colon $)
  $c --> $. $( Domain-codomain connective $)
  $c -1-1-> $. $( 'One-to-one' domain-codomain connective $)
  $c -onto-> $. $( 'Onto' domain-codomain connective $)
  $c -1-1-onto-> $. $( 'One-to-one' and 'onto' domain-codomain connective $)
  $c ` $. $( Left apostrophe (function value symbol) $)
  $c Isom $. $( Isomorphism $)
  $( Introduce new variables.  These are no different from our previously
     introduced variables, but their names can serve as mnemonics to remind us,
     for example, that they usually represent functions. $)
  $v e $.
  $v f $.
  $v g $.
  $v h $.
  $v i $.
  $v j $.
  $v k $.
  $v m $.
  $v n $.
  $v o $.
  $v E $.
  $v F $.
  $v G $.
  $v H $.
  $v I $.
  $v J $.
  $v K $.
  $v L $.
  $v M $.
  $v N $.
  $v V $.
  $v W $.
  $v X $.
  $v Y $.
  $v Z $.
  $v O $.
  $v s $.
  $v r $.
  $v q $.
  $v p $.
  $v a $.
  $v b $.
  $v c $.
  $v d $.
  $v l $.


  $( Let ` e ` be an individual variable. $)
  ve $f set e $.
  $( Let ` f ` be an individual variable. $)
  vf $f set f $.
  $( Let ` g ` be an individual variable. $)
  vg $f set g $.
  $( Let ` h ` be an individual variable. $)
  vh $f set h $.
  $( Let ` i ` be an individual variable. $)
  vi $f set i $.
  $( Let ` j ` be an individual variable. $)
  vj $f set j $.
  $( Let ` k ` be an individual variable. $)
  vk $f set k $.
  $( Let ` m ` be an individual variable. $)
  vm $f set m $.
  $( Let ` n ` be an individual variable. $)
  vn $f set n $.
  $( Let ` o ` be an individual variable. $)
  vo $f set o $.
  $( Let ` E ` be a class variable. $)
  cE $f class E $.
  $( Let ` F ` be a class variable. $)
  cF $f class F $.
  $( Let ` G ` be a class variable. $)
  cG $f class G $.
  $( Let ` H ` be a class variable. $)
  cH $f class H $.
  $( Let ` I ` be a class variable. $)
  cI $f class I $.
  $( Let ` J ` be a class variable. $)
  cJ $f class J $.
  $( Let ` K ` be a class variable. $)
  cK $f class K $.
  $( Let ` L ` be a class variable. $)
  cL $f class L $.
  $( Let ` M ` be a class variable. $)
  cM $f class M $.
  $( Let ` N ` be a class variable. $)
  cN $f class N $.
  $( Let ` O ` be a class variable. $)
  cO $f class O $.
  $( Let ` V ` be a class variable. $)
  cV $f class V $.
  $( Let ` W ` be a class variable. $)
  cW $f class W $.
  $( Let ` X ` be a class variable. $)
  cX $f class X $.
  $( Let ` Y ` be a class variable. $)
  cY $f class Y $.
  $( Let ` Z ` be a class variable. $)
  cZ $f class Z $.
  $( Let ` s ` be an individual variable. $)
  vs $f set s $.
  $( Let ` r ` be an individual variable. $)
  vr $f set r $.
  $( Let ` q ` be an individual variable. $)
  vq $f set q $.
  $( Let ` p ` be an individual variable. $)
  vp $f set p $.
  $( Let ` a ` be an individual variable. $)
  va $f set a $.
  $( Let ` b ` be an individual variable. $)
  vb $f set b $.
  $( Let ` c ` be an individual variable. $)
  vc $f set c $.
  $( Let ` d ` be an individual variable. $)
  vd $f set d $.
  $( Let ` l ` be an individual variable. $)
  vl $f set l $.

  $( Extend the definition of a class to include the cross product. $)
  cxp $a class ( A X. B ) $.

  $( Extend the definition of a class to include the converse of a class. $)
  ccnv $a class `' A $.

  $( Extend the definition of a class to include the domain of a class. $)
  cdm $a class dom A $.

  $( Extend the definition of a class to include the range of a class. $)
  crn $a class ran A $.

  $( Extend the definition of a class to include the restriction of a class.
     (Read:  The restriction of ` A ` to ` B ` .) $)
  cres $a class ( A |` B ) $.

  $( Extend the definition of a class to include the image of a class.
     (Read:  The image of ` B ` under ` A ` .) $)
  cima $a class ( A " B ) $.

  $( Extend the definition of a class to include the composition of two
     classes.  (Read:  The composition of ` A ` and ` B ` .) $)
  ccom $a class ( A o. B ) $.

  $( Extend the definition of a wff to include the relation predicate.  (Read:
     ` A ` is a relation.) $)
  wrel $a wff Rel A $.

  $( Extend the definition of a wff to include the function predicate.  (Read:
     ` A ` is a function.) $)
  wfun $a wff Fun A $.

  $( Extend the definition of a wff to include the function predicate with
     a domain.  (Read:  ` A ` is a function on ` B ` .) $)
  wfn $a wff A Fn B $.

  $( Extend the definition of a wff to include the function predicate with
     domain and codomain.  (Read:  ` F ` maps ` A ` into ` B ` .) $)
  wf $a wff F : A --> B $.

  $( Extend the definition of a wff to include one-to-one functions.  (Read:
     ` F ` maps ` A ` one-to-one into ` B ` .)  The notation ("1-1" above the
     arrow) is from Definition 6.15(5) of [TakeutiZaring] p. 27. $)
  wf1 $a wff F : A -1-1-> B $.

  $( Extend the definition of a wff to include onto functions.  (Read:  ` F `
     maps ` A ` onto ` B ` .)  The notation ("onto" below the arrow) is from
     Definition 6.15(4) of [TakeutiZaring] p. 27. $)
  wfo $a wff F : A -onto-> B $.

  $( Extend the definition of a wff to include one-to-one onto functions.
     (Read:  ` F ` maps ` A ` one-to-one onto ` B ` .)  The notation ("1-1"
     above the arrow and "onto" below the arrow) is from Definition 6.15(6) of
     [TakeutiZaring] p. 27. $)
  wf1o $a wff F : A -1-1-onto-> B $.

  $( Extend the definition of a class to include the value of a function.
     (Read:  The value of ` F ` at ` A ` , or " ` F ` of ` A ` ".) $)
  cfv $a class ( F ` A ) $.

  $( Extend the definition of a wff to include the isomorphism property.
     (Read:  ` H ` is an ` R ` , ` S ` isomorphism of ` A ` onto ` B ` .) $)
  wiso $a wff H Isom R , S ( A , B ) $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.
    $( Define the cross product of two classes.  Definition 9.11 of [Quine]
       p. 64. $)
    df-xp $a |- ( A X. B ) = { <. x , y >. | ( x e. A /\ y e. B ) } $.

    $( Define the relation predicate.  Definition 6.4(1) of [TakeutiZaring]
       p. 23.  For alternate definitions, see ~ dfrel2 and ~ dfrel3 . $)
    df-rel $a |- ( Rel A <-> A C_ ( _V X. _V ) ) $.

    $( Define the converse of a class.  Definition 9.12 of [Quine] p. 64.
       We use Quine's breve accent (smile) notation.  Like Quine, we use it as
       a prefix, which eliminates the need for parentheses.  Many authors use
       the postfix superscript "to the minus one."  "Converse" is Quine's
       terminology; some authors call it "inverse," especially when the
       argument is a function. $)
    df-cnv $a |- `' A = { <. x , y >. | y A x } $.

    $( Define the composition of two classes.  Definition 6.6(3) of
       [TakeutiZaring] p. 24.  Note that Definition 7 of [Suppes] p. 63
       reverses ` A ` and ` B ` , uses ` /. ` instead of ` o. ` , and
       calls the operation "relative product." $)
    df-co $a |- ( A o. B ) = { <. x , y >. | E. z ( x B z /\ z A y ) } $.

    $( Define the domain of a class.  Definition 3 of [Suppes] p. 59.  For
       alternate definitions see ~ dfdm2 , ~ dfdm3 , and ~ dfdm4 .  The
       notation " ` dom ` " is used by Enderton; other authors sometimes use
       script D. $)
    df-dm $a |- dom A = { x | E. y x A y } $.

    $( Define the range of a class.  For an alternate definitions, see
       ~ dfrn2 , ~ dfrn3 , and ~ dfrn4 .  The notation " ` ran ` " is used by
       Enderton; other authors sometimes use script R or script W. $)
    df-rn $a |- ran A = dom `' A $.

    $( Define the restriction of a class.  Definition 6.6(1) of [TakeutiZaring]
       p. 24. $)
    df-res $a |- ( A |` B ) = ( A i^i ( B X. _V ) ) $.

    $( Define the image of a class.  Definition 6.6(2) of [TakeutiZaring]
       p. 24.  For an alternate definition, see ~ dfima2 . $)
    df-ima $a |- ( A " B ) = ran ( A |` B ) $.

    $( Define a function.  Definition 10.1 of [Quine] p. 65.  For alternate
       definitions, see ~ dffun2 , ~ dffun3 , ~ dffun4 , ~ dffun5 , ~ dffun6 ,
       ~ dffun7 , ~ dffun8 , and ~ dffun9 . $)
    df-fun $a |- ( Fun A <-> ( Rel A /\ ( A o. `' A ) C_ _I ) ) $.

    $( Define a function with domain.  Definition 6.15(1) of
       [TakeutiZaring] p. 27.  For alternate definitions, see ~ dffn2 ,
       ~ dffn3 , ~ dffn4 , and ~ dffn5 . $)
    df-fn $a |- ( A Fn B <-> ( Fun A /\ dom A = B ) ) $.

    $( Define a function (mapping) with domain and codomain.  Definition
       6.15(3) of [TakeutiZaring] p. 27.  For alternate
       definitions, see ~ dff2 , ~ dff3 , and ~ dff4 . $)
    df-f $a |- ( F : A --> B <-> ( F Fn A /\ ran F C_ B ) ) $.

    $( Define a one-to-one function.  For equivalent definitions see
       ~ dff12 and ~ dff13 .  Compare Definition 6.15(5) of [TakeutiZaring]
       p. 27.  We use their notation ("1-1" above the arrow). $)
    df-f1 $a |- ( F : A -1-1-> B <-> ( F : A --> B /\ Fun `' F ) ) $.

    $( Define an onto function.  Definition 6.15(4) of [TakeutiZaring]
       p. 27.  We use their notation ("onto" under the arrow).  For alternate
       definitions, see ~ dffo2 , ~ dffo3 , ~ dffo4 , and ~ dffo5 . $)
    df-fo $a |- ( F : A -onto-> B <-> ( F Fn A /\ ran F = B ) ) $.

    $( Define a one-to-one onto function.  For equivalent definitions see
       ~ dff1o2 , ~ dff1o3 , ~ dff1o4 , and ~ dff1o5 .  Compare Definition
      6.15(6) of [TakeutiZaring] p. 27.  We use their notation ("1-1" above
      the arrow and "onto" below the arrow). $)
    df-f1o $a |- ( F : A -1-1-onto-> B <->
                ( F : A -1-1-> B /\ F : A -onto-> B ) ) $.

    $( Define the value of a function.  Although based on the idea embodied by
       Definition 10.2 of [Quine] p. 65 (see ~ args ), our definition
       apparently does not appear in the literature; but it is quite
       convenient:  it can be applied to any class and evaluates to the empty
       set when it is not meaningful (as shown by ~ ndmfv and ~ fvprc ).  The
       left apostrophe notation originated with Peano and was adopted in
       Definition *30.01 of [WhiteheadRussell] p. 235, Definition 10.11 of
       [Quine] p. 68, and Definition 6.11 of [TakeutiZaring] p. 26.  It means
       the same thing as the more familiar ` F ( A ) ` notation for a
       function's value at ` A ` , i.e.  " ` F ` of ` A ` ," but without
       context-dependent ambiguity.  An alternate definition is ~ dffv2 .
       For conventional alternate definitions (that fail to evaluate to the
       empty set for proper classes), see ~ fv2 and ~ fv3 .  Restricted
       equivalents that require ` F ` to be a function are shown in ~ funfv
       and ~ funfv2 .  For the familiar definition of function value in terms
       of ordered pair membership, see ~ funopfvb . $)
    df-fv $a |- ( F ` A ) = U. { x | ( F " { A } ) = { x } } $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $( Define the isomorphism predicate.  We read this as " ` H ` is an ` R ` ,
       ` S ` isomorphism of ` A ` onto ` B ` ."  Normally, ` R ` and ` S `
       are ordering relations on ` A ` and ` B ` respectively.  Definition 6.28
       of [TakeutiZaring] p. 32, whose notation is the same as ours except
       that ` R ` and ` S ` are subscripts. $)
    df-iso $a |- ( H Isom R , S ( A , B ) <-> ( H : A -1-1-onto-> B /\
                 A. x e. A A. y e. A ( x R y <-> ( H ` x ) S ( H ` y ) ) ) ) $.

  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Equality theorem for cross product. $)
    xpeq1 $p |- ( A = B -> ( A X. C ) = ( B X. C ) ) $=
      cA cB wceq vx cv cA wcel vy cv cC wcel wa vx vy copab vx cv cB wcel vy cv
      cC wcel wa vx vy copab cA cC cxp cB cC cxp cA cB wceq vx cv cA wcel vy cv
      cC wcel wa vx cv cB wcel vy cv cC wcel wa vx vy cA cB wceq vx cv cA wcel
      vx cv cB wcel vy cv cC wcel cA cB vx cv eleq2 anbi1d opabbidv vx vy cA cC
      df-xp vx vy cB cC df-xp 3eqtr4g $.
      $( [4-Jul-1994] $)

    $( Equality theorem for cross product. $)
    xpeq2 $p |- ( A = B -> ( C X. A ) = ( C X. B ) ) $=
      cA cB wceq vx cv cC wcel vy cv cA wcel wa vx vy copab vx cv cC wcel vy cv
      cB wcel wa vx vy copab cC cA cxp cC cB cxp cA cB wceq vx cv cC wcel vy cv
      cA wcel wa vx cv cC wcel vy cv cB wcel wa vx vy cA cB wceq vy cv cA wcel
      vy cv cB wcel vx cv cC wcel cA cB vy cv eleq2 anbi2d opabbidv vx vy cC cA
      df-xp vx vy cC cB df-xp 3eqtr4g $.
      $( [5-Jul-1994] $)

    $( Membership in a cross product. $)
    elxp $p |- ( A e. ( B X. C ) <-> E. x E. y ( A = <. x , y >. /\
               ( x e. B /\ y e. C ) ) ) $=
      cA cB cC cxp wcel cA vx cv cB wcel vy cv cC wcel wa vx vy copab wcel cA
      vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa vy wex vx wex cB
      cC cxp vx cv cB wcel vy cv cC wcel wa vx vy copab cA vx vy cB cC df-xp
      eleq2i vx cv cB wcel vy cv cC wcel wa vx vy cA elopab bitri $.
      $( [4-Jul-1994] $)

    $( Membership in a cross product. $)
    elxp2 $p |- ( A e. ( B X. C ) <-> E. x e. B E. y e. C A = <. x , y >.  ) $=
      vx cv cB wcel cA vx cv vy cv cop wceq vy cC wrex wa vx wex cA vx cv vy cv
      cop wceq vx cv cB wcel vy cv cC wcel wa wa vy wex vx wex cA vx cv vy cv
      cop wceq vy cC wrex vx cB wrex cA cB cC cxp wcel vx cv cB wcel cA vx cv
      vy cv cop wceq vy cC wrex wa cA vx cv vy cv cop wceq vx cv cB wcel vy cv
      cC wcel wa wa vy wex vx vx cv cB wcel cA vx cv vy cv cop wceq wa vy cC
      wrex vy cv cC wcel vx cv cB wcel cA vx cv vy cv cop wceq wa wa vy wex vx
      cv cB wcel cA vx cv vy cv cop wceq vy cC wrex wa cA vx cv vy cv cop wceq
      vx cv cB wcel vy cv cC wcel wa wa vy wex vx cv cB wcel cA vx cv vy cv cop
      wceq wa vy cC df-rex vx cv cB wcel cA vx cv vy cv cop wceq vy cC r19.42v
      vy cv cC wcel vx cv cB wcel cA vx cv vy cv cop wceq wa wa cA vx cv vy cv
      cop wceq vx cv cB wcel vy cv cC wcel wa wa vy vx cv cB wcel vy cv cC wcel
      wa cA vx cv vy cv cop wceq wa vx cv cB wcel vy cv cC wcel cA vx cv vy cv
      cop wceq wa wa cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa
      vy cv cC wcel vx cv cB wcel cA vx cv vy cv cop wceq wa wa vx cv cB wcel
      vy cv cC wcel cA vx cv vy cv cop wceq anass cA vx cv vy cv cop wceq vx cv
      cB wcel vy cv cC wcel wa ancom vy cv cC wcel vx cv cB wcel cA vx cv vy cv
      cop wceq an12 3bitr4ri exbii 3bitr3i exbii cA vx cv vy cv cop wceq vy cC
      wrex vx cB df-rex vx vy cA cB cC elxp 3bitr4ri $.
      $( [23-Feb-2004] $) $( [23-Feb-2004] $)
  $}

  ${
    xpeq1i.1 $e |- A = B $.
    $( Equality theorem for cross product. $)
    xpeq1i $p |- ( A X. C ) = ( B X. C ) $=
      cA cB wceq cA cC cxp cB cC cxp wceq xpeq1i.1 cA cB cC xpeq1 ax-mp $.
      $( [22-Dec-2008] $) $( [21-Dec-2008] $)

    $( Equality theorem for cross product. $)
    xpeq2i $p |- ( C X. A ) = ( C X. B ) $=
      cA cB wceq cC cA cxp cC cB cxp wceq xpeq1i.1 cA cB cC xpeq2 ax-mp $.
      $( [22-Dec-2008] $) $( [21-Dec-2008] $)
  $}

  ${
    $d y z w A $.  $d y z w B $.  $d x y z w $.
    hbxp.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbxp.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for cross product. $)
    hbxp $p |- ( y e. ( A X. B ) -> A. x y e. ( A X. B ) ) $=
      vy cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vw wex vz
      wex vy cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vw wex
      vz wex vx wal vy cv cA cB cxp wcel vy cv cA cB cxp wcel vx wal vy cv vz
      cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vw wex vx vz vy cv vz
      cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vx vw vy cv vz cv vw
      cv cop wceq vz cv cA wcel vw cv cB wcel wa vx vy cv vz cv vw cv cop wceq
      vx ax-17 vz cv cA wcel vw cv cB wcel vx vx vy vy vz cv cA vy cv vz cv
      wcel vx ax-17 hbxp.1 hbel vx vy vy vw cv cB vy cv vw cv wcel vx ax-17
      hbxp.2 hbel hban hban hbex hbex vz vw vy cv cA cB elxp vy cv cA cB cxp
      wcel vy cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vw wex
      vz wex vx vz vw vy cv cA cB elxp albii 3imtr4i $.
      $( [15-Sep-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    $( The first member of an ordered pair of classes in a cross product
       belongs to first cross product argument. $)
    opelxp1 $p |- ( <. A , B >. e. ( C X. D ) -> A e. C ) $=
      cA cB cop cC cD cxp wcel cA cB cop vx cv vy cv cop wceq vx cv cC wcel vy
      cv cD wcel wa wa vy wex vx wex cA cC wcel vx vy cA cB cop cC cD elxp cA
      cB cop vx cv vy cv cop wceq vx cv cC wcel vy cv cD wcel wa wa cA cC wcel
      vx vy cA cB cop vx cv vy cv cop wceq vx cv cC wcel cA cC wcel vy cv cD
      wcel cA cB cop vx cv vy cv cop wceq vx cv cC wcel cA cC wcel cA cB cop vx
      cv vy cv cop wceq vx cv cA cC vx cv cA wceq vx cv vy cv cop cA cB cop vx
      cv vy cv cA cB vx visset opth1 eqcoms eleq1d biimpa adantrr 19.23aivv
      sylbi $.
      $( [29-May-2008] $) $( [28-May-2008] $)
  $}

  $( The first member of an ordered triple of classes in a cross product
     belongs to first cross product argument. $)
  otelxp1 $p |- ( <. <. A , B >. , C >. e. ( ( R X. S ) X. T )
          -> A e. R ) $=
    cA cB cop cC cop cR cS cxp cT cxp wcel cA cB cop cR cS cxp wcel cA cR wcel
    cA cB cop cC cR cS cxp cT opelxp1 cA cB cR cS opelxp1 syl $.
    $( [30-May-2008] $) $( [28-May-2008] $)

  $( A true binary relation on a relation implies the first argument is a set.
     (This is a property of our ordered pair definition.) $)
  brrelex $p |- ( ( Rel R /\ A R B ) -> A e. _V ) $=
    cR wrel cA cB cR wbr cA cvv wcel cR wrel cR cvv cvv cxp wss cA cB cR wbr cA
    cvv wcel wi cR df-rel cR cvv cvv cxp wss cA cB cR wbr cA cB cop cvv cvv cxp
    wcel cA cvv wcel cR cvv cvv cxp wss cA cB cop cR wcel cA cB cop cvv cvv cxp
    wcel cA cB cR wbr cR cvv cvv cxp cA cB cop ssel cA cB cR df-br syl5ib cA cB
    cvv cvv opelxp1 syl6 sylbi imp $.
    $( [18-May-2004] $) $( [18-May-2004] $)

  ${
    brrelexi.1 $e |- Rel R $.
    $( The first argument of a binary relation exists.  (An artifact of our
       ordered pair definition.) $)
    brrelexi $p |- ( A R B -> A e. _V ) $=
      cR wrel cA cB cR wbr cA cvv wcel brrelexi.1 cA cB cR brrelex mpan $.
      $( [4-Jun-1998] $)
  $}

  ${
    nprrel.1 $e |- Rel R $.
    nprrel.2 $e |- -. A e. _V $.
    $( No proper class is related to anything via any relation.  (Contributed
       by Roy F. Longton, 30-Jul-2005.) $)
    nprrel $p |- -. A R B $=
      cA cB cR wbr cA cvv wcel nprrel.2 cA cB cR nprrel.1 brrelexi mto $.
      $( [31-Jul-2005] $) $( [30-Jul-2005] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Representation of a constant function using ordered pairs. $)
    fconstopab $p |- ( A X. { B } ) = { <. x , y >. | ( x e. A /\ y = B ) } $=
      cA cB csn cxp vx cv cA wcel vy cv cB csn wcel wa vx vy copab vx cv cA
      wcel vy cv cB wceq wa vx vy copab vx vy cA cB csn df-xp vx cv cA wcel vy
      cv cB csn wcel wa vx cv cA wcel vy cv cB wceq wa vx vy vy cv cB csn wcel
      vy cv cB wceq vx cv cA wcel vy cB elsn anbi2i opabbii eqtri $.
      $( [12-Oct-1999] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y z C $.  $d x y z R $.
    vtoclr.1 $e |- Rel R $.
    vtoclr.2 $e |- ( ( x R y /\ y R z ) -> x R z ) $.
    $( Variable to class conversion of transitive relation. $)
    vtoclr $p |- ( C e. D -> ( ( A R B /\ B R C ) -> A R C ) ) $=
      cC cD wcel cC cvv wcel cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi cC cD
      elisset cC cvv wcel cA cB cR wbr cB cC cR wbr wa cA cC cR wbr cA cvv wcel
      cB cvv wcel cC cvv wcel cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi wi
      cA cB cR wbr cB cC cR wbr cC cvv wcel vx cv vy cv cR wbr vy cv cC cR wbr
      wa vx cv cC cR wbr wi wi cC cvv wcel cA vy cv cR wbr vy cv cC cR wbr wa
      cA cC cR wbr wi wi cC cvv wcel cA cB cR wbr cB cC cR wbr wa cA cC cR wbr
      wi wi vx vy cA cB cvv cvv vx cv cA wceq vx cv vy cv cR wbr vy cv cC cR
      wbr wa vx cv cC cR wbr wi cA vy cv cR wbr vy cv cC cR wbr wa cA cC cR wbr
      wi cC cvv wcel vx cv cA wceq vx cv vy cv cR wbr vy cv cC cR wbr wa cA vy
      cv cR wbr vy cv cC cR wbr wa vx cv cC cR wbr cA cC cR wbr vx cv cA wceq
      vx cv vy cv cR wbr cA vy cv cR wbr vy cv cC cR wbr vx cv cA vy cv cR
      breq1 anbi1d vx cv cA cC cR breq1 imbi12d imbi2d vy cv cB wceq cA vy cv
      cR wbr vy cv cC cR wbr wa cA cC cR wbr wi cA cB cR wbr cB cC cR wbr wa cA
      cC cR wbr wi cC cvv wcel vy cv cB wceq cA vy cv cR wbr vy cv cC cR wbr wa
      cA cB cR wbr cB cC cR wbr wa cA cC cR wbr vy cv cB wceq cA vy cv cR wbr
      cA cB cR wbr vy cv cC cR wbr cB cC cR wbr vy cv cB cA cR breq2 vy cv cB
      cC cR breq1 anbi12d imbi1d imbi2d vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vx cv vz cv cR wbr wi vx cv vy cv cR wbr vy cv cC cR wbr wa vx cv cC
      cR wbr wi vz cC cvv vz cv cC wceq vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vx cv vy cv cR wbr vy cv cC cR wbr wa vx cv vz cv cR wbr vx cv cC cR
      wbr vz cv cC wceq vy cv vz cv cR wbr vy cv cC cR wbr vx cv vy cv cR wbr
      vz cv cC vy cv cR breq2 anbi2d vz cv cC vx cv cR breq2 imbi12d vtoclr.2
      vtoclg vtocl2g cA cB cR vtoclr.1 brrelexi cB cC cR vtoclr.1 brrelexi
      syl2an pm2.43b syl $.
      $( [9-Jun-1998] $)

    ${
      vtoclrbr.3 $e |- x R x $.
      $( Variable to class conversion of transitive, reflexive relation. $)
      vtoclrbr $p |- ( ( A R B /\ B R C ) -> A R C ) $=
        cC cvv wcel cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi vx vy vz cA cB
        cC cvv cR vtoclr.1 vtoclr.2 vtoclr cC cvv wcel wn cA cB cR wbr cA cC cR
        wbr cB cC cR wbr cC cvv wcel wn cA cvv wcel cA cC cR wbr cA cB cR wbr
        cC cvv wcel wn cA cC cR wbr cA cA cR wbr cA cvv wcel cA cC cR brprc vx
        cv vx cv cR wbr cA cA cR wbr vx cA cvv vx cv cA wceq vx cv vx cv cR wbr
        cA vx cv cR wbr cA cA cR wbr vx cv cA vx cv cR breq1 vx cv cA cA cR
        breq2 bitrd vtoclrbr.3 vtoclg syl5bir cA cB cR vtoclr.1 brrelexi syl5
        adantrd pm2.61i $.
        $( [9-Jun-1998] $)
    $}

    ${
      $d x B $.
      vtoclibr.3 $e |- -. x R x $.
      $( Variable to class conversion of transitive, irreflexive relation. $)
      vtoclibr $p |- ( ( A R B /\ B R C ) -> A R C ) $=
        cA cB cR wbr cB cC cR wbr cA cC cR wbr cB cC cR wbr cC cvv wcel cA cB
        cR wbr cB cC cR wbr wa cA cC cR wbr wi cC cvv wcel cB cC cR wbr cC cvv
        wcel wn cB cC cR wbr cB cB cR wbr cB cvv wcel cB cB cR wbr wn vx cv vx
        cv cR wbr wn cB cB cR wbr wn vx cB cvv vx cv cB wceq vx cv vx cv cR wbr
        cB cB cR wbr vx cv cB wceq vx cv vx cv cR wbr cB vx cv cR wbr cB cB cR
        wbr vx cv cB vx cv cR breq1 vx cv cB cB cR breq2 bitrd notbid
        vtoclibr.3 vtoclg cB cB cR wbr cB cvv wcel cB cB cR vtoclr.1 brrelexi
        con3i pm2.61i cB cC cR brprc mtbiri con4i vx vy vz cA cB cC cvv cR
        vtoclr.1 vtoclr.2 vtoclr syl anabsi7 $.
        $( [9-Jun-1998] $)
    $}
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    opelxp.1 $e |- B e. _V $.
    $( Ordered pair membership in a cross product. $)
    opelxp $p |- ( <. A , B >. e. ( C X. D ) <-> ( A e. C /\ B e. D ) ) $=
      cA cB cop cC cD cxp wcel cA cC wcel cA cC wcel cB cD wcel wa cA cB cC cD
      opelxp1 cA cC wcel cB cD wcel pm3.26 vz cv cB cop cC cD cxp wcel vz cv cC
      wcel cB cD wcel wa cA cB cop cC cD cxp wcel cA cC wcel cB cD wcel wa vz
      cA cC vz cv cA wceq vz cv cB cop cA cB cop cC cD cxp vz cv cA cB opeq1
      eleq1d vz cv cA wceq vz cv cC wcel cA cC wcel cB cD wcel vz cv cA cC
      eleq1 anbi1d vz cv cB cop vx cv vy cv cop wceq vx cv cC wcel vy cv cD
      wcel wa wa vy wex vx wex vx cv vz cv wceq vx cv cC wcel wa vx wex vy cv
      cB wceq vy cv cD wcel wa vy wex wa vz cv cB cop cC cD cxp wcel vz cv cC
      wcel cB cD wcel wa vz cv cB cop vx cv vy cv cop wceq vx cv cC wcel vy cv
      cD wcel wa wa vy wex vx wex vx cv vz cv wceq vx cv cC wcel wa vy cv cB
      wceq vy cv cD wcel wa vy wex wa vx wex vx cv vz cv wceq vx cv cC wcel wa
      vx wex vy cv cB wceq vy cv cD wcel wa vy wex wa vz cv cB cop vx cv vy cv
      cop wceq vx cv cC wcel vy cv cD wcel wa wa vy wex vx cv vz cv wceq vx cv
      cC wcel wa vy cv cB wceq vy cv cD wcel wa vy wex wa vx vz cv cB cop vx cv
      vy cv cop wceq vx cv cC wcel vy cv cD wcel wa wa vy wex vx cv vz cv wceq
      vx cv cC wcel wa vy cv cB wceq vy cv cD wcel wa wa vy wex vx cv vz cv
      wceq vx cv cC wcel wa vy cv cB wceq vy cv cD wcel wa vy wex wa vz cv cB
      cop vx cv vy cv cop wceq vx cv cC wcel vy cv cD wcel wa wa vx cv vz cv
      wceq vx cv cC wcel wa vy cv cB wceq vy cv cD wcel wa wa vy vz cv cB cop
      vx cv vy cv cop wceq vx cv cC wcel vy cv cD wcel wa wa vx cv vz cv wceq
      vy cv cB wceq wa vx cv cC wcel vy cv cD wcel wa wa vx cv vz cv wceq vx cv
      cC wcel wa vy cv cB wceq vy cv cD wcel wa wa vz cv cB cop vx cv vy cv cop
      wceq vx cv vz cv wceq vy cv cB wceq wa vx cv cC wcel vy cv cD wcel wa vz
      cv cB cop vx cv vy cv cop wceq vx cv vy cv cop vz cv cB cop wceq vx cv vz
      cv wceq vy cv cB wceq wa vz cv cB cop vx cv vy cv cop eqcom vx cv vy cv
      vz cv cB vx visset vy visset opelxp.1 opth bitri anbi1i vx cv vz cv wceq
      vy cv cB wceq vx cv cC wcel vy cv cD wcel an4 bitri exbii vx cv vz cv
      wceq vx cv cC wcel wa vy cv cB wceq vy cv cD wcel wa vy 19.42v bitri
      exbii vx cv vz cv wceq vx cv cC wcel wa vy cv cB wceq vy cv cD wcel wa vy
      wex vx 19.41v bitri vx vy vz cv cB cop cC cD elxp vz cv cC wcel vx cv vz
      cv wceq vx cv cC wcel wa vx wex cB cD wcel vy cv cB wceq vy cv cD wcel wa
      vy wex vx vz cv cC df-clel vy cB cD df-clel anbi12i 3bitr4i vtoclbg
      pm5.21nii $.
      $( [15-Nov-1994] $)

    $( Binary relation on a cross product. $)
    brxp $p |- ( A ( C X. D ) B <-> ( A e. C /\ B e. D ) ) $=
      cA cB cC cD cxp wbr cA cB cop cC cD cxp wcel cA cC wcel cB cD wcel wa cA
      cB cC cD cxp df-br cA cB cC cD opelxp.1 opelxp bitri $.
      $( [14-May-2004] $) $( [22-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    $( Ordered pair membership in a cross product. $)
    opelxpg $p |- ( B e. R ->
                    ( <. A , B >. e. ( C X. D ) <-> ( A e. C /\ B e. D ) ) ) $=
      cA vx cv cop cC cD cxp wcel cA cC wcel vx cv cD wcel wa cA cB cop cC cD
      cxp wcel cA cC wcel cB cD wcel wa vx cB cR vx cv cB wceq cA vx cv cop cA
      cB cop cC cD cxp vx cv cB cA opeq2 eleq1d vx cv cB wceq vx cv cD wcel cB
      cD wcel cA cC wcel vx cv cB cD eleq1 anbi2d cA vx cv cC cD vx visset
      opelxp vtoclbg $.
      $( [28-May-1995] $)
  $}

  $( Ordered pair membership in a cross product (implication). $)
    opelxpi $p |- ( ( A e. C /\ B e. D ) -> <. A , B >. e. ( C X. D ) ) $=
      cA cC wcel cB cD wcel cA cB cop cC cD cxp wcel cB cD wcel cA cB cop cC cD
      cxp wcel cA cC wcel cB cD wcel wa cA cB cC cD cD opelxpg biimprd anabsi7
      $.
      $( [28-May-1995] $)

  ${
    $d x y z A $.  $d x y z B $.  $d y z ph $.  $d x ps $.
    ralxp.1 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Universal quantification restricted to a cross product is equivalent
       to a double restricted quantification.  The hypothesis specifies an
       implicit substitution. $)
    ralxp $p |- ( A. x e. ( A X. B ) ph <-> A. y e. A A. z e. B ps ) $=
      wph vx cA cB cxp wral wps vz cB wral vy cA wral wph vx cA cB cxp wral wps
      vy vz cA cB wph vx cA cB cxp wral vy cv vz cv cop cA cB cxp wcel wps vy
      cv cA wcel vz cv cB wcel wa wph wps vx vy cv vz cv cop cA cB cxp ralxp.1
      rcla4cv vy cv vz cv cA cB vz visset opelxp syl5ibr r19.21aivv wps vz cB
      wral vy cA wral wph vx cA cB cxp wps vz cB wral vy cA wral vx cv cA cB
      cxp wcel wph vx cv cA cB cxp wcel vx cv vy cv vz cv cop wceq vz wex vy
      wex wps vz cB wral vy cA wral vx cv cA cB cxp wcel wph wi wi vx cv cA cB
      cxp wcel vx cv vy cv vz cv cop wceq vy cv cA wcel vz cv cB wcel wa wa vz
      wex vy wex vx cv vy cv vz cv cop wceq vz wex vy wex vy vz vx cv cA cB
      elxp vx cv vy cv vz cv cop wceq vy cv cA wcel vz cv cB wcel wa wa vx cv
      vy cv vz cv cop wceq vy vz vx cv vy cv vz cv cop wceq vy cv cA wcel vz cv
      cB wcel wa pm3.26 19.22i2 sylbi vx cv vy cv vz cv cop wceq vz wex wps vz
      cB wral vy cA wral vx cv cA cB cxp wcel wph wi wi vy wps vz cB wral vy cA
      wral vx cv cA cB cxp wcel wph wi vy wps vz cB wral vy cA hbra1 vx cv cA
      cB cxp wcel wph wi vy ax-17 hbim vx cv vy cv vz cv cop wceq wps vz cB
      wral vy cA wral vx cv cA cB cxp wcel wph wi wi vz wps vz cB wral vy cA
      wral vx cv cA cB cxp wcel wph wi vz wps vz cB wral vz vy cA vy cv cA wcel
      vz ax-17 wps vz cB hbra1 hbral vx cv cA cB cxp wcel wph wi vz ax-17 hbim
      vx cv vy cv vz cv cop wceq vx cv cA cB cxp wcel wph wi vy cv cA wcel vz
      cv cB wcel wa wps wi wps vz cB wral vy cA wral vx cv vy cv vz cv cop wceq
      vx cv cA cB cxp wcel vy cv cA wcel vz cv cB wcel wa wph wps vx cv vy cv
      vz cv cop wceq vx cv cA cB cxp wcel vy cv vz cv cop cA cB cxp wcel vy cv
      cA wcel vz cv cB wcel wa vx cv vy cv vz cv cop cA cB cxp eleq1 vy cv vz
      cv cA cB vz visset opelxp syl6bb ralxp.1 imbi12d wps vy vz cA cB ra42
      syl5bir 19.23ai 19.23ai syl pm2.43b r19.21aiv impbii $.
      $( [4-Mar-2004] $) $( [7-Feb-2004] $)

    $( Existential quantification restricted to a cross product is equivalent
       to a double restricted quantification. $)
    rexxp $p |- ( E. x e. ( A X. B ) ph <-> E. y e. A E. z e. B ps ) $=
      wph wn vx cA cB cxp wral wn wps vz cB wrex wn vy cA wral wn wph vx cA cB
      cxp wrex wps vz cB wrex vy cA wrex wph wn vx cA cB cxp wral wps vz cB
      wrex wn vy cA wral wph wn vx cA cB cxp wral wps wn vz cB wral vy cA wral
      wps vz cB wrex wn vy cA wral wph wn wps wn vx vy vz cA cB vx cv vy cv vz
      cv cop wceq wph wps ralxp.1 notbid ralxp wps wn vz cB wral wps vz cB wrex
      wn vy cA wps vz cB ralnex ralbii bitri notbii wph vx cA cB cxp dfrex2 wps
      vz cB wrex vy cA dfrex2 3bitr4i $.
      $( [14-Sep-2006] $) $( [11-Nov-1995] $)
  $}

  ${
    $d u v w x y A $.  $d u v w x y z B $.  $d u v w ph $.  $d u v w ps $.
    ralxpf.1 $e |- ( ph -> A. y ph ) $.
    ralxpf.2 $e |- ( ph -> A. z ph ) $.
    ralxpf.3 $e |- ( ps -> A. x ps ) $.
    ralxpf.4 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Version of ~ ralxp with bound-variable hypotheses. $)
    ralxpf $p |- ( A. x e. ( A X. B ) ph <-> A. y e. A A. z e. B ps ) $=
      wph vx cA cB cxp wral wph vx vw cv wsbc vw cA cB cxp wral wps vz cB wral
      vy cA wral wph vx vw cA cB cxp cbvralsv wps vy vu cv wsbc vz cB wral vu
      cA wral wps vy vu cv wsbc vz vv cv wsbc vv cB wral vu cA wral wps vz cB
      wral vy cA wral wph vx vw cv wsbc vw cA cB cxp wral wps vy vu cv wsbc vz
      cB wral wps vy vu cv wsbc vz vv cv wsbc vv cB wral vu cA wps vy vu cv
      wsbc vz vv cB cbvralsv ralbii wps vz cB wral wps vy vu cv wsbc vz cB wral
      vy vu cA wps vz cB wral vu ax-17 wps vy vu cv wsbc vy vz cB vz cv cB wcel
      vy ax-17 wps vy vu hbs1 hbral vy cv vu cv wceq wps wps vy vu cv wsbc vz
      cB wps vy vu sbequ12 ralbidv cbvral wph vx vw cv wsbc wps vy vu cv wsbc
      vz vv cv wsbc vw vu vv cA cB vw cv vu cv vv cv cop wceq vw cv vy cv vz cv
      cop wceq vy cv vz cv cop vu cv vv cv cop wceq wa vz wex vy wex wph vx vw
      cv wsbc wps vy vu cv wsbc vz vv cv wsbc wb vy vz vw cv vu cv vv cv vu
      visset vv visset eqvinop vw cv vy cv vz cv cop wceq vy cv vz cv cop vu cv
      vv cv cop wceq wa vz wex wph vx vw cv wsbc wps vy vu cv wsbc vz vv cv
      wsbc wb vy wph vx vw cv wsbc wps vy vu cv wsbc vz vv cv wsbc vy vw cv cvv
      wcel wph vx vw cv wsbc wph vx vw cv wsbc vy wal wi vw visset wph vy vx vx
      vw cv cvv vx cv vw cv wcel vy ax-17 ralxpf.1 hbsbcg ax-mp vv cv cvv wcel
      wps vy vu cv wsbc vz vv cv wsbc wps vy vu cv wsbc vz vv cv wsbc vy wal wi
      vv visset wps vy vu cv wsbc vy vz vx vv cv cvv vx cv vv cv wcel vy ax-17
      wps vy vu hbs1 hbsbcg ax-mp hbbi vw cv vy cv vz cv cop wceq vy cv vz cv
      cop vu cv vv cv cop wceq wa wph vx vw cv wsbc wps vy vu cv wsbc vz vv cv
      wsbc wb vz wph vx vw cv wsbc wps vy vu cv wsbc vz vv cv wsbc vz vw cv cvv
      wcel wph vx vw cv wsbc wph vx vw cv wsbc vz wal wi vw visset wph vz vx vx
      vw cv cvv vx cv vw cv wcel vz ax-17 ralxpf.2 hbsbcg ax-mp wps vy vu cv
      wsbc vz vv hbs1 hbbi vw cv vy cv vz cv cop wceq wph vx vw cv wsbc wps vy
      cv vz cv cop vu cv vv cv cop wceq wps vy vu cv wsbc vz vv cv wsbc wph wps
      vx vw vy cv vz cv cop ralxpf.3 ralxpf.4 sbhypf vy cv vz cv cop vu cv vv
      cv cop wceq vy cv vu cv wceq vz cv vv cv wceq wa wps wps vy vu cv wsbc vz
      vv cv wsbc wb vy cv vz cv vu cv vv cv vy visset vz visset vv visset opth
      vy cv vu cv wceq wps wps vy vu cv wsbc vz cv vv cv wceq wps vy vu cv wsbc
      vz vv cv wsbc wps vy vu sbequ12 wps vy vu cv wsbc vz vv sbequ12 sylan9bb
      sylbi sylan9bb 19.23ai 19.23ai sylbi ralxp 3bitr4ri bitri $.
      $( [20-Dec-2008] $) $( [18-Aug-2006] $)

    $( Version of ~ rexxp with bound-variable hypotheses. $)
    rexxpf $p |- ( E. x e. ( A X. B ) ph <-> E. y e. A E. z e. B ps ) $=
      wph wn vx cA cB cxp wral wn wps vz cB wrex wn vy cA wral wn wph vx cA cB
      cxp wrex wps vz cB wrex vy cA wrex wph wn vx cA cB cxp wral wps vz cB
      wrex wn vy cA wral wph wn vx cA cB cxp wral wps wn vz cB wral vy cA wral
      wps vz cB wrex wn vy cA wral wph wn wps wn vx vy vz cA cB wph vy ralxpf.1
      hbn wph vz ralxpf.2 hbn wps vx ralxpf.3 hbn vx cv vy cv vz cv cop wceq
      wph wps ralxpf.4 notbid ralxpf wps wn vz cB wral wps vz cB wrex wn vy cA
      wps vz cB ralnex ralbii bitri notbii wph vx cA cB cxp dfrex2 wps vz cB
      wrex vy cA dfrex2 3bitr4i $.
      $( [3-Jan-2009] $) $( [19-Dec-2008] $)
  $}

  ${
    $d w x y A $.  $d w x y z B $.  $d w C $.  $d w D $.
    iunxpf.1 $e |- ( w e. C -> A. y w e. C ) $.
    iunxpf.2 $e |- ( w e. C -> A. z w e. C ) $.
    iunxpf.3 $e |- ( w e. D -> A. x w e. D ) $.
    iunxpf.4 $e |- ( x = <. y , z >. -> C = D ) $.
    $( Indexed union on a cross product is equals a double indexed union.
       The hypothesis specifies an implicit substitution. $)
    iunxpf $p |- U_ x e. ( A X. B ) C = U_ y e. A U_ z e. B D $=
      vw vx cA cB cxp cC ciun vy cA vz cB cD ciun ciun vw cv cC wcel vx cA cB
      cxp wrex vw cv cD wcel vz cB wrex vy cA wrex vw cv vx cA cB cxp cC ciun
      wcel vw cv vy cA vz cB cD ciun ciun wcel vw cv cC wcel vw cv cD wcel vx
      vy vz cA cB iunxpf.1 iunxpf.2 iunxpf.3 vx cv vy cv vz cv cop wceq cC cD
      vw cv iunxpf.4 eleq2d rexxpf vx vw cv cA cB cxp cC eliun vw cv vy cA vz
      cB cD ciun ciun wcel vw cv vz cB cD ciun wcel vy cA wrex vw cv cD wcel vz
      cB wrex vy cA wrex vy vw cv cA vz cB cD ciun eliun vw cv vz cB cD ciun
      wcel vw cv cD wcel vz cB wrex vy cA vz vw cv cB cD eliun rexbii bitri
      3bitr4i eqriv $.
      $( [13-Jan-2009] $) $( [19-Dec-2008] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    $( Justification theorem for an ordered pair definition that works for
       any classes, including proper classes.  This is a possible definition
       implied by the footnote in [Jech] p. 78, which says, "The sophisticated
       reader will not object to our use of a pair of classes." $)
    opthprc $p |- ( ( ( A X. { (/) } ) u. ( B X. { { (/) } } ) ) =
                    ( ( C X. { (/) } ) u. ( D X. { { (/) } } ) )
                  <-> ( A = C /\ B = D ) ) $=
      cA c0 csn cxp cB c0 csn csn cxp cun cC c0 csn cxp cD c0 csn csn cxp cun
      wceq cA cC wceq cB cD wceq wa cA c0 csn cxp cB c0 csn csn cxp cun cC c0
      csn cxp cD c0 csn csn cxp cun wceq cA cC wceq cB cD wceq cA c0 csn cxp cB
      c0 csn csn cxp cun cC c0 csn cxp cD c0 csn csn cxp cun wceq vx cA cC cA
      c0 csn cxp cB c0 csn csn cxp cun cC c0 csn cxp cD c0 csn csn cxp cun wceq
      vx cv c0 cop cA c0 csn cxp cB c0 csn csn cxp cun wcel vx cv c0 cop cC c0
      csn cxp cD c0 csn csn cxp cun wcel vx cv cA wcel vx cv cC wcel cA c0 csn
      cxp cB c0 csn csn cxp cun cC c0 csn cxp cD c0 csn csn cxp cun vx cv c0
      cop eleq2 vx cv c0 cop cA c0 csn cxp wcel vx cv c0 cop cB c0 csn csn cxp
      wcel wo vx cv cA wcel c0 c0 csn csn wcel wo vx cv c0 cop cA c0 csn cxp cB
      c0 csn csn cxp cun wcel vx cv cA wcel vx cv c0 cop cA c0 csn cxp wcel vx
      cv cA wcel vx cv c0 cop cB c0 csn csn cxp wcel c0 c0 csn csn wcel vx cv
      c0 cop cA c0 csn cxp wcel vx cv cA wcel c0 c0 csn wcel vx cv c0 cA c0 csn
      0ex opelxp c0 0ex snid mpbiran2 vx cv c0 cop cB c0 csn csn cxp wcel vx cv
      cB wcel c0 c0 csn csn wcel wa c0 c0 csn csn wcel vx cv c0 cB c0 csn csn
      0ex opelxp c0 c0 csn csn wcel vx cv cB wcel c0 c0 csn csn wcel c0 c0 csn
      0nep0 c0 c0 csn 0ex elsnc nemtbir bianfi bitr4i orbi12i vx cv c0 cop cA
      c0 csn cxp cB c0 csn csn cxp elun c0 c0 csn csn wcel vx cv cA wcel c0 c0
      csn csn wcel c0 c0 csn 0nep0 c0 c0 csn 0ex elsnc nemtbir biorfi 3bitr4ri
      vx cv c0 cop cC c0 csn cxp wcel vx cv c0 cop cD c0 csn csn cxp wcel wo vx
      cv cC wcel c0 c0 csn csn wcel wo vx cv c0 cop cC c0 csn cxp cD c0 csn csn
      cxp cun wcel vx cv cC wcel vx cv c0 cop cC c0 csn cxp wcel vx cv cC wcel
      vx cv c0 cop cD c0 csn csn cxp wcel c0 c0 csn csn wcel vx cv c0 cop cC c0
      csn cxp wcel vx cv cC wcel c0 c0 csn wcel vx cv c0 cC c0 csn 0ex opelxp
      c0 0ex snid mpbiran2 vx cv c0 cop cD c0 csn csn cxp wcel vx cv cD wcel c0
      c0 csn csn wcel wa c0 c0 csn csn wcel vx cv c0 cD c0 csn csn 0ex opelxp
      c0 c0 csn csn wcel vx cv cD wcel c0 c0 csn csn wcel c0 c0 csn 0nep0 c0 c0
      csn 0ex elsnc nemtbir bianfi bitr4i orbi12i vx cv c0 cop cC c0 csn cxp cD
      c0 csn csn cxp elun c0 c0 csn csn wcel vx cv cC wcel c0 c0 csn csn wcel
      c0 c0 csn 0nep0 c0 c0 csn 0ex elsnc nemtbir biorfi 3bitr4ri 3bitr4g eqrdv
      cA c0 csn cxp cB c0 csn csn cxp cun cC c0 csn cxp cD c0 csn csn cxp cun
      wceq vx cB cD cA c0 csn cxp cB c0 csn csn cxp cun cC c0 csn cxp cD c0 csn
      csn cxp cun wceq vx cv c0 csn cop cA c0 csn cxp cB c0 csn csn cxp cun
      wcel vx cv c0 csn cop cC c0 csn cxp cD c0 csn csn cxp cun wcel vx cv cB
      wcel vx cv cD wcel cA c0 csn cxp cB c0 csn csn cxp cun cC c0 csn cxp cD
      c0 csn csn cxp cun vx cv c0 csn cop eleq2 vx cv c0 csn cop cA c0 csn cxp
      wcel vx cv c0 csn cop cB c0 csn csn cxp wcel wo c0 csn c0 csn wcel vx cv
      cB wcel wo vx cv c0 csn cop cA c0 csn cxp cB c0 csn csn cxp cun wcel vx
      cv cB wcel vx cv c0 csn cop cA c0 csn cxp wcel c0 csn c0 csn wcel vx cv
      c0 csn cop cB c0 csn csn cxp wcel vx cv cB wcel vx cv c0 csn cop cA c0
      csn cxp wcel vx cv cA wcel c0 csn c0 csn wcel wa c0 csn c0 csn wcel vx cv
      c0 csn cA c0 csn p0ex opelxp c0 csn c0 csn wcel vx cv cA wcel c0 csn c0
      csn wcel c0 c0 csn 0nep0 c0 csn c0 csn wcel c0 csn c0 wceq c0 c0 csn wceq
      c0 csn c0 p0ex elsnc c0 csn c0 eqcom bitri nemtbir bianfi bitr4i vx cv c0
      csn cop cB c0 csn csn cxp wcel vx cv cB wcel c0 csn c0 csn csn wcel vx cv
      c0 csn cB c0 csn csn p0ex opelxp c0 csn p0ex snid mpbiran2 orbi12i vx cv
      c0 csn cop cA c0 csn cxp cB c0 csn csn cxp elun c0 csn c0 csn wcel wn vx
      cv cB wcel c0 csn c0 csn wcel vx cv cB wcel wo wb c0 csn c0 csn wcel c0
      c0 csn 0nep0 c0 csn c0 csn wcel c0 csn c0 wceq c0 c0 csn wceq c0 csn c0
      p0ex elsnc c0 csn c0 eqcom bitri nemtbir c0 csn c0 csn wcel vx cv cB wcel
      biorf ax-mp 3bitr4ri vx cv c0 csn cop cC c0 csn cxp wcel vx cv c0 csn cop
      cD c0 csn csn cxp wcel wo c0 csn c0 csn wcel vx cv cD wcel wo vx cv c0
      csn cop cC c0 csn cxp cD c0 csn csn cxp cun wcel vx cv cD wcel vx cv c0
      csn cop cC c0 csn cxp wcel c0 csn c0 csn wcel vx cv c0 csn cop cD c0 csn
      csn cxp wcel vx cv cD wcel vx cv c0 csn cop cC c0 csn cxp wcel vx cv cC
      wcel c0 csn c0 csn wcel wa c0 csn c0 csn wcel vx cv c0 csn cC c0 csn p0ex
      opelxp c0 csn c0 csn wcel vx cv cC wcel c0 csn c0 csn wcel c0 c0 csn
      0nep0 c0 csn c0 csn wcel c0 csn c0 wceq c0 c0 csn wceq c0 csn c0 p0ex
      elsnc c0 csn c0 eqcom bitri nemtbir bianfi bitr4i vx cv c0 csn cop cD c0
      csn csn cxp wcel vx cv cD wcel c0 csn c0 csn csn wcel vx cv c0 csn cD c0
      csn csn p0ex opelxp c0 csn p0ex snid mpbiran2 orbi12i vx cv c0 csn cop cC
      c0 csn cxp cD c0 csn csn cxp elun c0 csn c0 csn wcel wn vx cv cD wcel c0
      csn c0 csn wcel vx cv cD wcel wo wb c0 csn c0 csn wcel c0 c0 csn 0nep0 c0
      csn c0 csn wcel c0 csn c0 wceq c0 c0 csn wceq c0 csn c0 p0ex elsnc c0 csn
      c0 eqcom bitri nemtbir c0 csn c0 csn wcel vx cv cD wcel biorf ax-mp
      3bitr4ri 3bitr4g eqrdv jca cA c0 csn cxp cC c0 csn cxp wceq cB c0 csn csn
      cxp cD c0 csn csn cxp wceq cA c0 csn cxp cB c0 csn csn cxp cun cC c0 csn
      cxp cD c0 csn csn cxp cun wceq cA cC wceq cB cD wceq cA c0 csn cxp cC c0
      csn cxp cB c0 csn csn cxp cD c0 csn csn cxp uneq12 cA cC c0 csn xpeq1 cB
      cD c0 csn csn xpeq1 syl2an impbii $.
      $( [28-Sep-2003] $)
  $}

  ${
    brelg.1 $e |- R C_ ( C X. D ) $.
    $( Two things in a binary relation belong to the relation's domain. $)
    brelg $p |- ( B e. S -> ( A R B -> ( A e. C /\ B e. D ) ) ) $=
      cB cS wcel cA cB cop cR wcel cA cC wcel cB cD wcel wa cA cB cR wbr cB cS
      wcel cA cB cop cC cD cxp wcel cA cC wcel cB cD wcel wa cA cB cop cR wcel
      cA cB cC cD cS opelxpg cR cC cD cxp cA cB cop brelg.1 sseli syl5bi cA cB
      cR df-br syl5ib $.
      $( [17-May-1996] $)
  $}

  ${
    brel.1 $e |- B e. _V $.
    brel.2 $e |- R C_ ( C X. D ) $.
    $( Membership in superset of binary relation. $)
    brel $p |- ( A R B -> ( A e. C /\ B e. D ) ) $=
      cB cvv wcel cA cB cR wbr cA cC wcel cB cD wcel wa wi brel.1 cA cB cC cD
      cR cvv brel.2 brelg ax-mp $.
      $( [16-Jul-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in a cross product. $)
    elxp3 $p |- ( A e. ( B X. C ) <->
            E. x E. y ( <. x , y >. = A /\ <. x , y >. e. ( B X. C ) ) ) $=
      cA cB cC cxp wcel cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa
      wa vy wex vx wex vx cv vy cv cop cA wceq vx cv vy cv cop cB cC cxp wcel
      wa vy wex vx wex vx vy cA cB cC elxp vx cv vy cv cop cA wceq vx cv vy cv
      cop cB cC cxp wcel wa cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel
      wa wa vx vy vx cv vy cv cop cA wceq cA vx cv vy cv cop wceq vx cv vy cv
      cop cB cC cxp wcel vx cv cB wcel vy cv cC wcel wa vx cv vy cv cop cA
      eqcom vx cv vy cv cB cC vy visset opelxp anbi12i 2exbii bitr4i $.
      $( [5-Mar-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Distributive law for cross product over union.  Theorem 103 of [Suppes]
       p. 52. $)
    xpundi $p |- ( A X. ( B u. C ) ) = ( ( A X. B ) u. ( A X. C ) ) $=
      vx cv cA wcel vy cv cB cC cun wcel wa vx vy copab vx cv cA wcel vy cv cB
      wcel wa vx vy copab vx cv cA wcel vy cv cC wcel wa vx vy copab cun cA cB
      cC cun cxp cA cB cxp cA cC cxp cun vx cv cA wcel vy cv cB cC cun wcel wa
      vx vy copab vx cv cA wcel vy cv cB wcel wa vx cv cA wcel vy cv cC wcel wa
      wo vx vy copab vx cv cA wcel vy cv cB wcel wa vx vy copab vx cv cA wcel
      vy cv cC wcel wa vx vy copab cun vx cv cA wcel vy cv cB cC cun wcel wa vx
      cv cA wcel vy cv cB wcel wa vx cv cA wcel vy cv cC wcel wa wo vx vy vx cv
      cA wcel vy cv cB cC cun wcel wa vx cv cA wcel vy cv cB wcel vy cv cC wcel
      wo wa vx cv cA wcel vy cv cB wcel wa vx cv cA wcel vy cv cC wcel wa wo vy
      cv cB cC cun wcel vy cv cB wcel vy cv cC wcel wo vx cv cA wcel vy cv cB
      cC elun anbi2i vx cv cA wcel vy cv cB wcel vy cv cC wcel andi bitri
      opabbii vx cv cA wcel vy cv cB wcel wa vx cv cA wcel vy cv cC wcel wa vx
      vy unopab eqtr4i vx vy cA cB cC cun df-xp cA cB cxp vx cv cA wcel vy cv
      cB wcel wa vx vy copab cA cC cxp vx cv cA wcel vy cv cC wcel wa vx vy
      copab vx vy cA cB df-xp vx vy cA cC df-xp uneq12i 3eqtr4i $.
      $( [13-Aug-2004] $) $( [12-Aug-2004] $)

    $( Distributive law for cross product over union.  Similar to Theorem 103
       of [Suppes] p. 52. $)
    xpundir $p |- ( ( A u. B ) X. C ) = ( ( A X. C ) u. ( B X. C ) ) $=
      vx cv cA cB cun wcel vy cv cC wcel wa vx vy copab vx cv cA wcel vy cv cC
      wcel wa vx vy copab vx cv cB wcel vy cv cC wcel wa vx vy copab cun cA cB
      cun cC cxp cA cC cxp cB cC cxp cun vx cv cA cB cun wcel vy cv cC wcel wa
      vx vy copab vx cv cA wcel vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa
      wo vx vy copab vx cv cA wcel vy cv cC wcel wa vx vy copab vx cv cB wcel
      vy cv cC wcel wa vx vy copab cun vx cv cA cB cun wcel vy cv cC wcel wa vx
      cv cA wcel vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa wo vx vy vx cv
      cA cB cun wcel vy cv cC wcel wa vx cv cA wcel vx cv cB wcel wo vy cv cC
      wcel wa vx cv cA wcel vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa wo
      vx cv cA cB cun wcel vx cv cA wcel vx cv cB wcel wo vy cv cC wcel vx cv
      cA cB elun anbi1i vx cv cA wcel vx cv cB wcel vy cv cC wcel andir bitri
      opabbii vx cv cA wcel vy cv cC wcel wa vx cv cB wcel vy cv cC wcel wa vx
      vy unopab eqtr4i vx vy cA cB cun cC df-xp cA cC cxp vx cv cA wcel vy cv
      cC wcel wa vx vy copab cB cC cxp vx cv cB wcel vy cv cC wcel wa vx vy
      copab vx vy cA cC df-xp vx vy cB cC df-xp uneq12i 3eqtr4i $.
      $( [30-Sep-2002] $)
  $}

  $( The cross product of two unions. $)
  xpun $p |- ( ( A u. B ) X. ( C u. D ) ) =
            ( ( ( A X. C ) u. ( A X. D ) ) u. ( ( B X. C ) u. ( B X. D ) ) ) $=
    cA cB cun cC cD cun cxp cA cB cun cC cxp cA cB cun cD cxp cun cA cC cxp cB
    cC cxp cun cA cD cxp cB cD cxp cun cun cA cC cxp cA cD cxp cun cB cC cxp cB
    cD cxp cun cun cA cB cun cC cD xpundi cA cB cun cC cxp cA cC cxp cB cC cxp
    cun cA cB cun cD cxp cA cD cxp cB cD cxp cun cA cB cC xpundir cA cB cD
    xpundir uneq12i cA cC cxp cB cC cxp cA cD cxp cB cD cxp un4 3eqtri $.
    $( [8-Sep-2004] $) $( [12-Aug-2004] $)

  ${
    $d w x y z A $.
    $( Membership in universal class of ordered pairs. $)
    elvv $p |- ( A e. ( _V X. _V ) <-> E. x E. y A = <. x , y >. ) $=
      cA cvv cvv cxp wcel cA vx cv vy cv cop wceq vx cv cvv wcel vy cv cvv wcel
      wa wa vy wex vx wex cA vx cv vy cv cop wceq vy wex vx wex vx vy cA cvv
      cvv elxp cA vx cv vy cv cop wceq cA vx cv vy cv cop wceq vx cv cvv wcel
      vy cv cvv wcel wa wa vx vy vx cv cvv wcel vy cv cvv wcel wa cA vx cv vy
      cv cop wceq vx cv cvv wcel vy cv cvv wcel vx visset vy visset pm3.2i
      biantru 2exbii bitr4i $.
      $( [4-Jul-1994] $)

    $( Membership in universal class of ordered triples. $)
    elvvv $p |- ( A e. ( ( _V X. _V ) X. _V )
                 <-> E. x E. y E. z A = <. <. x , y >. , z >. ) $=
      cA cvv cvv cxp cvv cxp wcel cA vw cv vz cv cop wceq vw cv cvv cvv cxp
      wcel vz cv cvv wcel wa wa vz wex vw wex vw cv vx cv vy cv cop wceq cA vw
      cv vz cv cop wceq wa vy wex vx wex vz wex vw wex cA vx cv vy cv cop vz cv
      cop wceq vz wex vy wex vx wex vw vz cA cvv cvv cxp cvv elxp cA vw cv vz
      cv cop wceq vw cv cvv cvv cxp wcel vz cv cvv wcel wa wa vw cv vx cv vy cv
      cop wceq cA vw cv vz cv cop wceq wa vy wex vx wex vw vz cA vw cv vz cv
      cop wceq vw cv cvv cvv cxp wcel vz cv cvv wcel wa wa cA vw cv vz cv cop
      wceq vw cv cvv cvv cxp wcel wa vz cv cvv wcel wa vw cv vx cv vy cv cop
      wceq cA vw cv vz cv cop wceq wa vy wex vx wex cA vw cv vz cv cop wceq vw
      cv cvv cvv cxp wcel vz cv cvv wcel anass cA vw cv vz cv cop wceq vw cv
      cvv cvv cxp wcel wa cA vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq vy
      wex vx wex wa cA vw cv vz cv cop wceq vw cv cvv cvv cxp wcel wa vz cv cvv
      wcel wa vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq wa vy wex vx
      wex vw cv cvv cvv cxp wcel vw cv vx cv vy cv cop wceq vy wex vx wex cA vw
      cv vz cv cop wceq vx vy vw cv elvv anbi2i vz cv cvv wcel cA vw cv vz cv
      cop wceq vw cv cvv cvv cxp wcel wa vz visset biantru vw cv vx cv vy cv
      cop wceq cA vw cv vz cv cop wceq wa vy wex vx wex cA vw cv vz cv cop wceq
      vw cv vx cv vy cv cop wceq wa vy wex vx wex cA vw cv vz cv cop wceq vw cv
      vx cv vy cv cop wceq vy wex vx wex wa vw cv vx cv vy cv cop wceq cA vw cv
      vz cv cop wceq wa cA vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wa
      vx vy vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq ancom 2exbii cA
      vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq vx vy 19.42vv bitr2i
      3bitr3i bitr3i 2exbii vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq
      wa vy wex vx wex vz wex vw wex vw cv vx cv vy cv cop wceq cA vw cv vz cv
      cop wceq wa vz wex vw wex vy wex vx wex cA vx cv vy cv cop vz cv cop wceq
      vz wex vy wex vx wex vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq
      wa vx vy vw vz exrot4 vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq
      wa vz wex vw wex cA vx cv vy cv cop vz cv cop wceq vz wex vx vy vw cv vx
      cv vy cv cop wceq cA vw cv vz cv cop wceq wa vz wex vw wex vw cv vx cv vy
      cv cop wceq cA vw cv vz cv cop wceq wa vw wex vz wex cA vx cv vy cv cop
      vz cv cop wceq vz wex vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq
      wa vw vz excom vw cv vx cv vy cv cop wceq cA vw cv vz cv cop wceq wa vw
      wex cA vx cv vy cv cop vz cv cop wceq vz cA vw cv vz cv cop wceq cA vx cv
      vy cv cop vz cv cop wceq vw vx cv vy cv cop vx cv vy cv opex vw cv vx cv
      vy cv cop wceq vw cv vz cv cop vx cv vy cv cop vz cv cop cA vw cv vx cv
      vy cv cop vz cv opeq1 eqeq2d ceqsexv exbii bitri 2exbii bitr3i 3bitri $.
      $( [25-Dec-2008] $) $( [17-Dec-2008] $)

    $( An ordered pair contains its union. $)
    elvvuni $p |- ( A e. ( _V X. _V ) -> U. A e. A ) $=
      cA cvv cvv cxp wcel cA vx cv vy cv cop wceq vy wex vx wex cA cuni cA wcel
      vx vy cA elvv cA vx cv vy cv cop wceq cA cuni cA wcel vx vy cA vx cv vy
      cv cop wceq cA cuni cA wcel vx cv vy cv cop cuni vx cv vy cv cop wcel vx
      cv vy cv cop cuni vx cv vy cv cpr vx cv vy cv cop vx cv vy cv uniop vx cv
      vy cv opi2 eqeltri cA vx cv vy cv cop wceq cA cuni vx cv vy cv cop cuni
      cA vx cv vy cv cop cA vx cv vy cv cop unieq cA vx cv vy cv cop wceq id
      eleq12d mpbiri 19.23aivv sylbi $.
      $( [16-Sep-2006] $) $( [16-Sep-2006] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( A cross product is included in the ordered pair universe.  Exercise
       3 of [TakeutiZaring] p. 25. $)
    xpss $p |- ( A X. B ) C_ ( _V X. _V ) $=
      vz cA cB cxp cvv cvv cxp vz cv vx cv vy cv cop wceq vx cv cA wcel vy cv
      cB wcel wa wa vy wex vx wex vz cv vx cv vy cv cop wceq vy wex vx wex vz
      cv cA cB cxp wcel vz cv cvv cvv cxp wcel vz cv vx cv vy cv cop wceq vx cv
      cA wcel vy cv cB wcel wa wa vz cv vx cv vy cv cop wceq vx vy vz cv vx cv
      vy cv cop wceq vx cv cA wcel vy cv cB wcel wa pm3.26 19.22i2 vx vy vz cv
      cA cB elxp vx vy vz cv elvv 3imtr4i ssriv $.
      $( [2-Aug-1994] $)
  $}

  $( Intersection of binary relation with cross product. $)
  brinxp2 $p |- ( B e. S -> ( A ( R i^i ( C X. D ) ) B <->
                ( A e. C /\ B e. D /\ A R B ) ) ) $=
    cB cS wcel cA cB cR wbr cA cB cop cC cD cxp wcel wa cA cB cR wbr cA cC wcel
    cB cD wcel wa wa cA cB cR cC cD cxp cin wbr cA cC wcel cB cD wcel cA cB cR
    wbr w3a cB cS wcel cA cB cop cC cD cxp wcel cA cC wcel cB cD wcel wa cA cB
    cR wbr cA cB cC cD cS opelxpg anbi2d cA cB cop cR cC cD cxp cin wcel cA cB
    cop cR wcel cA cB cop cC cD cxp wcel wa cA cB cR cC cD cxp cin wbr cA cB cR
    wbr cA cB cop cC cD cxp wcel wa cA cB cop cR cC cD cxp elin cA cB cR cC cD
    cxp cin df-br cA cB cR wbr cA cB cop cR wcel cA cB cop cC cD cxp wcel cA cB
    cR df-br anbi1i 3bitr4i cA cC wcel cB cD wcel cA cB cR wbr w3a cA cB cR wbr
    cA cC wcel cB cD wcel w3a cA cB cR wbr cA cC wcel cB cD wcel wa wa cA cB cR
    wbr cA cC wcel cB cD wcel 3anrot cA cB cR wbr cA cC wcel cB cD wcel 3anass
    bitr3i 3bitr4g $.
    $( [3-Mar-2007] $) $( [3-Mar-2007] $)

  $( Intersection of binary relation with cross product. $)
  brinxp $p |- ( ( A e. C /\ B e. D ) ->
               ( A R B <-> A ( R i^i ( C X. D ) ) B ) ) $=
    cA cC wcel cB cD wcel wa cA cB cR wbr cA cC wcel cB cD wcel cA cB cR wbr
    w3a cA cB cR cC cD cxp cin wbr cA cC wcel cB cD wcel cA cB cR wbr w3a cA cC
    wcel cB cD wcel wa cA cB cR wbr cA cC wcel cB cD wcel cA cB cR wbr df-3an
    baibr cB cD wcel cA cB cR cC cD cxp cin wbr cA cC wcel cB cD wcel cA cB cR
    wbr w3a wb cA cC wcel cA cB cC cD cR cD brinxp2 adantl bitr4d $.
    $( [9-Mar-1997] $)

  ${
    $d x y z A $.  $d x y z R $.
    $( Intersection of well-ordering with cross product of its field. $)
    weinxp $p |- ( R We A <-> ( R i^i ( A X. A ) ) We A ) $=
      cA cR wfr vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy
      cA wral vx cA wral wa cA cR cA cA cxp cin wfr vx cv vy cv cR cA cA cxp
      cin wbr vx cv vy cv wceq vy cv vx cv cR cA cA cxp cin wbr w3o vy cA wral
      vx cA wral wa cA cR wwe cA cR cA cA cxp cin wwe cA cR wfr cA cR cA cA cxp
      cin wfr vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA
      wral vx cA wral vx cv vy cv cR cA cA cxp cin wbr vx cv vy cv wceq vy cv
      vx cv cR cA cA cxp cin wbr w3o vy cA wral vx cA wral vz cv cA wss vz cv
      c0 wne wa vy cv vx cv cR wbr wn vy vz cv wral vx vz cv wrex wi vz wal vz
      cv cA wss vz cv c0 wne wa vy cv vx cv cR cA cA cxp cin wbr wn vy vz cv
      wral vx vz cv wrex wi vz wal cA cR wfr cA cR cA cA cxp cin wfr vz cv cA
      wss vz cv c0 wne wa vy cv vx cv cR wbr wn vy vz cv wral vx vz cv wrex wi
      vz cv cA wss vz cv c0 wne wa vy cv vx cv cR cA cA cxp cin wbr wn vy vz cv
      wral vx vz cv wrex wi vz vz cv cA wss vz cv c0 wne wa vy cv vx cv cR wbr
      wn vy vz cv wral vx vz cv wrex vy cv vx cv cR cA cA cxp cin wbr wn vy vz
      cv wral vx vz cv wrex vz cv cA wss vy cv vx cv cR wbr wn vy vz cv wral vx
      vz cv wrex vy cv vx cv cR cA cA cxp cin wbr wn vy vz cv wral vx vz cv
      wrex wb vz cv c0 wne vz cv cA wss vy cv vx cv cR wbr wn vy vz cv wral vy
      cv vx cv cR cA cA cxp cin wbr wn vy vz cv wral vx vz cv vz cv cA wss vx
      cv vz cv wcel wa vy cv vx cv cR wbr wn vy cv vx cv cR cA cA cxp cin wbr
      wn vy vz cv vz cv cA wss vx cv vz cv wcel wa vy cv vz cv wcel wa vy cv vx
      cv cR wbr vy cv vx cv cR cA cA cxp cin wbr vz cv cA wss vx cv vz cv wcel
      vy cv vz cv wcel vy cv vx cv cR wbr vy cv vx cv cR cA cA cxp cin wbr wb
      vz cv cA wss vx cv vz cv wcel vy cv vz cv wcel vy cv vx cv cR wbr vy cv
      vx cv cR cA cA cxp cin wbr wb vz cv cA wss vx cv vz cv wcel vy cv vz cv
      wcel wa vx cv cA wcel vy cv cA wcel wa vy cv vx cv cR wbr vy cv vx cv cR
      cA cA cxp cin wbr wb vz cv cA wss vx cv vz cv wcel vx cv cA wcel vy cv vz
      cv wcel vy cv cA wcel vz cv cA vx cv ssel vz cv cA vy cv ssel anim12d vy
      cv cA wcel vx cv cA wcel vy cv vx cv cR wbr vy cv vx cv cR cA cA cxp cin
      wbr wb vy cv vx cv cA cA cR brinxp ancoms syl6 exp3a imp31 notbid
      ralbidva rexbidva adantr pm5.74i albii vz vx vy cA cR df-fr vz vx vy cA
      cR cA cA cxp cin df-fr 3bitr4i vx cv cA wcel vy cv cA wcel wa vx cv vy cv
      cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o wi vy wal vx wal vx cv cA
      wcel vy cv cA wcel wa vx cv vy cv cR cA cA cxp cin wbr vx cv vy cv wceq
      vy cv vx cv cR cA cA cxp cin wbr w3o wi vy wal vx wal vx cv vy cv cR wbr
      vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral vx cv vy cv
      cR cA cA cxp cin wbr vx cv vy cv wceq vy cv vx cv cR cA cA cxp cin wbr
      w3o vy cA wral vx cA wral vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR
      wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o wi vx cv cA wcel vy cv cA
      wcel wa vx cv vy cv cR cA cA cxp cin wbr vx cv vy cv wceq vy cv vx cv cR
      cA cA cxp cin wbr w3o wi vx vy vx cv cA wcel vy cv cA wcel wa vx cv vy cv
      cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vx cv vy cv cR cA cA cxp
      cin wbr vx cv vy cv wceq vy cv vx cv cR cA cA cxp cin wbr w3o vx cv cA
      wcel vy cv cA wcel wa vx cv vy cv cR wbr vx cv vy cv cR cA cA cxp cin wbr
      vx cv vy cv wceq vx cv vy cv wceq vy cv vx cv cR wbr vy cv vx cv cR cA cA
      cxp cin wbr vx cv vy cv cA cA cR brinxp vx cv cA wcel vy cv cA wcel wa vx
      cv vy cv wceq biidd vy cv cA wcel vx cv cA wcel vy cv vx cv cR wbr vy cv
      vx cv cR cA cA cxp cin wbr wb vy cv vx cv cA cA cR brinxp ancoms
      3orbi123d pm5.74i 2albii vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
      cR wbr w3o vx vy cA cA r2al vx cv vy cv cR cA cA cxp cin wbr vx cv vy cv
      wceq vy cv vx cv cR cA cA cxp cin wbr w3o vx vy cA cA r2al 3bitr4i
      anbi12i vx vy cA cR dfwe2 vx vy cA cR cA cA cxp cin dfwe2 3bitr4i $.
      $( [9-Mar-1997] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( An abstraction relation is a subset of a related cross product. $)
    opabssxp $p |- { <. x , y >. | ( ( x e. A /\ y e. B ) /\ ph ) }
                   C_ ( A X. B ) $=
      vx cv cA wcel vy cv cB wcel wa wph wa vx vy copab vx cv cA wcel vy cv cB
      wcel wa vx vy copab cA cB cxp vx cv cA wcel vy cv cB wcel wa wph wa vx cv
      cA wcel vy cv cB wcel wa vx vy vx cv cA wcel vy cv cB wcel wa wph pm3.26
      ssopab2i vx vy cA cB df-xp sseqtr4i $.
      $( [16-Jul-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y ps $.
    optocl.1 $e |- D = ( B X. C ) $.
    optocl.2 $e |- ( <. x , y >. = A -> ( ph <-> ps ) ) $.
    optocl.3 $e |- ( ( x e. B /\ y e. C ) -> ph ) $.
    $( Implicit substitution of class for ordered pair. $)
    optocl $p |- ( A e. D -> ps ) $=
      cA cD wcel cA cB cC cxp wcel wps cD cB cC cxp cA optocl.1 eleq2i cA cB cC
      cxp wcel vx cv vy cv cop cA wceq vx cv vy cv cop cB cC cxp wcel wa vy wex
      vx wex wps vx vy cA cB cC elxp3 vx cv vy cv cop cA wceq vx cv vy cv cop
      cB cC cxp wcel wa wps vx vy vx cv vy cv cop cA wceq vx cv vy cv cop cB cC
      cxp wcel wps vx cv vy cv cop cA wceq wph wps vx cv vy cv cop cB cC cxp
      wcel optocl.2 vx cv vy cv cop cB cC cxp wcel vx cv cB wcel vy cv cC wcel
      wa wph vx cv vy cv cB cC vy visset opelxp optocl.3 sylbi syl5bi imp
      19.23aivv sylbi sylbi $.
      $( [5-Mar-1995] $)
  $}

  ${
    $d x y z w A $.  $d z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x y ps $.  $d z w ch $.  $d z w R $.
    2optocl.1 $e |- R = ( C X. D ) $.
    2optocl.2 $e |- ( <. x , y >. = A -> ( ph <-> ps ) ) $.
    2optocl.3 $e |- ( <. z , w >. = B -> ( ps <-> ch ) ) $.
    2optocl.4 $e |- ( ( ( x e. C /\ y e. D ) /\ ( z e. C /\ w e. D ) ) ->
                   ph ) $.
    $( Implicit substitution of classes for ordered pairs. $)
    2optocl $p |- ( ( A e. R /\ B e. R ) -> ch ) $=
      cB cR wcel cA cR wcel wch cA cR wcel wps wi cA cR wcel wch wi vz vw cB cC
      cD cR 2optocl.1 vz cv vw cv cop cB wceq wps wch cA cR wcel 2optocl.3
      imbi2d cA cR wcel vz cv cC wcel vw cv cD wcel wa wps vz cv cC wcel vw cv
      cD wcel wa wph wi vz cv cC wcel vw cv cD wcel wa wps wi vx vy cA cC cD cR
      2optocl.1 vx cv vy cv cop cA wceq wph wps vz cv cC wcel vw cv cD wcel wa
      2optocl.2 imbi2d vx cv cC wcel vy cv cD wcel wa vz cv cC wcel vw cv cD
      wcel wa wph 2optocl.4 ex optocl com12 optocl impcom $.
      $( [12-Mar-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d z w v u B $.  $d v u C $.
    $d x y z w v u D $.  $d x y z w v u F $.  $d z w v u R $.
    $d x y ps $.  $d z w ch $.  $d v u th $.
    3optocl.1 $e |- R = ( D X. F ) $.
    3optocl.2 $e |- ( <. x , y >. = A -> ( ph <-> ps ) ) $.
    3optocl.3 $e |- ( <. z , w >. = B -> ( ps <-> ch ) ) $.
    3optocl.4 $e |- ( <. v , u >. = C -> ( ch <-> th ) ) $.
    3optocl.5 $e |- ( ( ( x e. D /\ y e. F ) /\ ( z e. D /\ w e. F )
                    /\ ( v e. D /\ u e. F ) ) -> ph ) $.
    $( Implicit substitution of classes for ordered pairs. $)
    3optocl $p |- ( ( A e. R /\ B e. R /\ C e. R ) -> th ) $=
      cA cR wcel cB cR wcel cC cR wcel wth cC cR wcel cA cR wcel cB cR wcel wa
      wth cA cR wcel cB cR wcel wa wch wi cA cR wcel cB cR wcel wa wth wi vv vu
      cC cD cF cR 3optocl.1 vv cv vu cv cop cC wceq wch wth cA cR wcel cB cR
      wcel wa 3optocl.4 imbi2d cA cR wcel cB cR wcel wa vv cv cD wcel vu cv cF
      wcel wa wch vv cv cD wcel vu cv cF wcel wa wph wi vv cv cD wcel vu cv cF
      wcel wa wps wi vv cv cD wcel vu cv cF wcel wa wch wi vx vy vz vw cA cB cD
      cF cR 3optocl.1 vx cv vy cv cop cA wceq wph wps vv cv cD wcel vu cv cF
      wcel wa 3optocl.2 imbi2d vz cv vw cv cop cB wceq wps wch vv cv cD wcel vu
      cv cF wcel wa 3optocl.3 imbi2d vx cv cD wcel vy cv cF wcel wa vz cv cD
      wcel vw cv cF wcel wa vv cv cD wcel vu cv cF wcel wa wph 3optocl.5 3expia
      2optocl com12 optocl impcom 3impa $.
      $( [12-Mar-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.  $d x y z w v u S $.
    $d x y ph $.  $d z w v u ps $.
    opbrop.1 $e |- ( ( ( z = A /\ w = B ) /\ ( v = C /\ u = D ) ) ->
                     ( ph <-> ps ) ) $.
    opbrop.2 $e |- R = { <. x , y >. | ( ( x e. ( S X. S ) /\
                      y e. ( S X. S ) ) /\
                      E. z E. w E. v E. u ( ( x = <. z , w >. /\
                      y = <. v , u >. ) /\ ph ) ) } $.
    $( Ordered pair membership in a relation.  Special case. $)
    opbrop $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) ) ->
                   ( <. A , B >. R <. C , D >. <-> ps ) ) $=
      cA cS wcel cB cS wcel wa cC cS wcel cD cS wcel wa wa cA cB cop cC cD cop
      cR wbr cA cB cop cS cS cxp wcel cC cD cop cS cS cxp wcel wa wps wa wps cA
      cS wcel cB cS wcel wa cC cS wcel cD cS wcel wa wa cA cB cop cS cS cxp
      wcel cC cD cop cS cS cxp wcel wa cA cB cop vz cv vw cv cop wceq cC cD cop
      vv cv vu cv cop wceq wa wph wa vu wex vv wex vw wex vz wex wa cA cB cop
      cS cS cxp wcel cC cD cop cS cS cxp wcel wa wps wa cA cB cop cC cD cop cR
      wbr cA cS wcel cB cS wcel wa cC cS wcel cD cS wcel wa wa cA cB cop vz cv
      vw cv cop wceq cC cD cop vv cv vu cv cop wceq wa wph wa vu wex vv wex vw
      wex vz wex wps cA cB cop cS cS cxp wcel cC cD cop cS cS cxp wcel wa wph
      wps vz vw vv vu cA cB cC cD cS cS opbrop.1 copsex4g anbi2d vx cv cS cS
      cxp wcel vy cv cS cS cxp wcel wa vx cv vz cv vw cv cop wceq vy cv vv cv
      vu cv cop wceq wa wph wa vu wex vv wex vw wex vz wex wa cA cB cop cS cS
      cxp wcel vy cv cS cS cxp wcel wa cA cB cop vz cv vw cv cop wceq vy cv vv
      cv vu cv cop wceq wa wph wa vu wex vv wex vw wex vz wex wa cA cB cop cS
      cS cxp wcel cC cD cop cS cS cxp wcel wa cA cB cop vz cv vw cv cop wceq cC
      cD cop vv cv vu cv cop wceq wa wph wa vu wex vv wex vw wex vz wex wa vx
      vy cA cB cop cC cD cop cR cA cB opex cC cD opex vx cv cA cB cop wceq vx
      cv cS cS cxp wcel vy cv cS cS cxp wcel wa cA cB cop cS cS cxp wcel vy cv
      cS cS cxp wcel wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq
      wa wph wa vu wex vv wex vw wex vz wex cA cB cop vz cv vw cv cop wceq vy
      cv vv cv vu cv cop wceq wa wph wa vu wex vv wex vw wex vz wex vx cv cA cB
      cop wceq vx cv cS cS cxp wcel cA cB cop cS cS cxp wcel vy cv cS cS cxp
      wcel vx cv cA cB cop cS cS cxp eleq1 anbi1d vx cv cA cB cop wceq vx cv vz
      cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa wph wa cA cB cop vz cv vw
      cv cop wceq vy cv vv cv vu cv cop wceq wa wph wa vz vw vv vu vx cv cA cB
      cop wceq vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa cA cB
      cop vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa wph vx cv cA cB
      cop wceq vx cv vz cv vw cv cop wceq cA cB cop vz cv vw cv cop wceq vy cv
      vv cv vu cv cop wceq vx cv cA cB cop vz cv vw cv cop eqeq1 anbi1d anbi1d
      4exbidv anbi12d vy cv cC cD cop wceq cA cB cop cS cS cxp wcel vy cv cS cS
      cxp wcel wa cA cB cop cS cS cxp wcel cC cD cop cS cS cxp wcel wa cA cB
      cop vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa wph wa vu wex vv
      wex vw wex vz wex cA cB cop vz cv vw cv cop wceq cC cD cop vv cv vu cv
      cop wceq wa wph wa vu wex vv wex vw wex vz wex vy cv cC cD cop wceq vy cv
      cS cS cxp wcel cC cD cop cS cS cxp wcel cA cB cop cS cS cxp wcel vy cv cC
      cD cop cS cS cxp eleq1 anbi2d vy cv cC cD cop wceq cA cB cop vz cv vw cv
      cop wceq vy cv vv cv vu cv cop wceq wa wph wa cA cB cop vz cv vw cv cop
      wceq cC cD cop vv cv vu cv cop wceq wa wph wa vz vw vv vu vy cv cC cD cop
      wceq cA cB cop vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa cA cB
      cop vz cv vw cv cop wceq cC cD cop vv cv vu cv cop wceq wa wph vy cv cC
      cD cop wceq vy cv vv cv vu cv cop wceq cC cD cop vv cv vu cv cop wceq cA
      cB cop vz cv vw cv cop wceq vy cv cC cD cop vv cv vu cv cop eqeq1 anbi2d
      anbi1d 4exbidv anbi12d opbrop.2 brab syl5bb cA cS wcel cB cS wcel wa cC
      cS wcel cD cS wcel wa wa cA cB cop cS cS cxp wcel cC cD cop cS cS cxp
      wcel wa wps cA cS wcel cB cS wcel wa cA cB cop cS cS cxp wcel cC cS wcel
      cD cS wcel wa cC cD cop cS cS cxp wcel cA cB cS cS opelxpi cC cD cS cS
      opelxpi anim12i biantrurd bitr4d $.
      $( [5-Aug-1995] $)
  $}

  ${
    $d x y z A $.
    $( The cross product with the empty set is empty.  Part of Theorem 3.13(ii)
       of [Monk1] p. 37. $)
    xp0r $p |- ( (/) X. A ) = (/) $=
      vz c0 cA cxp c0 vz cv c0 cA cxp wcel vz cv vx cv vy cv cop wceq vx cv c0
      wcel vy cv cA wcel wa wa vy wex vx wex vz cv c0 wcel vx vy vz cv c0 cA
      elxp vz cv vx cv vy cv cop wceq vx cv c0 wcel vy cv cA wcel wa wa vy wex
      vx wex vz cv c0 wcel vz cv vx cv vy cv cop wceq vx cv c0 wcel vy cv cA
      wcel wa wa vy wex vx vz cv vx cv vy cv cop wceq vx cv c0 wcel vy cv cA
      wcel wa wa vy vz cv vx cv vy cv cop wceq vx cv c0 wcel vy cv cA wcel wa
      wa vx cv c0 wcel vx cv noel vz cv vx cv vy cv cop wceq vx cv c0 wcel vy
      cv cA wcel simprl mto nex nex vz cv noel 2false bitri eqriv $.
      $( [4-Jul-1994] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( The empty set is not a member of a cross product. $)
    0nelxp $p |- -. (/) e. ( A X. B ) $=
      c0 cA cB cxp wcel c0 vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa
      wa vy wex vx wex c0 vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa
      wa vy wex vx c0 vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa wa vy
      c0 vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa c0 vx cv vy cv cop
      wceq vx cv csn c0 wcel vx cv csn noel c0 vx cv vy cv cop wceq vx cv csn
      c0 wcel vx cv csn vx cv vy cv cop wcel vx cv vy cv opi1 c0 vx cv vy cv
      cop vx cv csn eleq2 mpbiri mto intnanr nex nex vx vy c0 cA cB elxp mtbir
      $.
      $( [2-May-1996] $)

    $( A member of a cross product (ordered pair) doesn't contain the empty
       set. $)
    0nelelxp $p |- ( C e. ( A X. B ) -> -. (/) e. C ) $=
      cC cA cB cxp wcel cC vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa
      wa vy wex vx wex c0 cC wcel wn vx vy cC cA cB elxp cC vx cv vy cv cop
      wceq vx cv cA wcel vy cv cB wcel wa wa c0 cC wcel wn vx vy cC vx cv vy cv
      cop wceq c0 cC wcel wn vx cv cA wcel vy cv cB wcel wa cC vx cv vy cv cop
      wceq c0 cC wcel c0 vx cv vy cv cop wcel vx cv cvv wcel wn c0 vx cv vy cv
      cop wcel vx cv cvv wcel vx visset notnoti vx cv vy cv opprc1b mtbi cC vx
      cv vy cv cop c0 eleq2 mtbiri adantr 19.23aivv sylbi $.
      $( [15-Dec-2008] $) $( [15-Dec-2008] $)
  $}

  ${
    $d x y z $.
    $( Ordinal numbers and ordered pairs are disjoint collections.  This
       theorem can be used if we want to extend a set of ordinal numbers or
       ordered pairs with disjoint elements.  See also ~ snsn0non . $)
    onxpdisj $p |- ( On i^i ( _V X. _V ) ) = (/) $=
      con0 cvv cvv cxp cin c0 wceq vx cv cvv cvv cxp wcel wn vx con0 vx con0
      cvv cvv cxp disj vx cv con0 wcel vx cv c0 wceq c0 vx cv wcel wo vx cv cvv
      cvv cxp wcel wn vx cv on0eqel vx cv c0 wceq vx cv cvv cvv cxp wcel wn c0
      vx cv wcel vx cv c0 wceq vx cv cvv cvv cxp wcel c0 cvv cvv cxp wcel cvv
      cvv 0nelxp vx cv c0 cvv cvv cxp eleq1 mtbiri vx cv cvv cvv cxp wcel c0 vx
      cv wcel vx cv cvv cvv cxp wcel vx cv vy cv vz cv cop wceq vz wex vy wex
      c0 vx cv wcel wn vy vz vx cv elvv vx cv vy cv vz cv cop wceq c0 vx cv
      wcel wn vy vz vx cv vy cv vz cv cop wceq c0 vx cv wcel c0 vy cv vz cv cop
      wcel c0 vy cv vz cv cop wcel wn vy cv cvv wcel vy visset vy cv cvv wcel
      c0 vy cv vz cv cop wcel vy cv vz cv opprc1b con1bii mpbir vx cv vy cv vz
      cv cop c0 eleq2 mtbiri 19.23aivv sylbi con2i jaoi syl mprgbir $.
      $( [2-Jun-2004] $) $( [1-Jun-2004] $)
  $}

  $( The class of ordinal numbers is not equal to the universe. $)
  onnev $p |- On =/= _V $=
    cvv cvv cxp c0 wne con0 cvv wne c0 c0 cop cvv cvv cxp wcel cvv cvv cxp c0
    wne c0 cvv wcel c0 cvv wcel c0 c0 cop cvv cvv cxp wcel 0ex 0ex c0 c0 cvv
    cvv opelxpi mp2an cvv cvv cxp c0 c0 cop ne0i ax-mp con0 cvv cvv cvv cxp c0
    con0 cvv wceq c0 cvv cvv cxp con0 cvv wceq con0 cvv cvv cxp cin cvv cvv cvv
    cxp cin c0 cvv cvv cxp con0 cvv cvv cvv cxp ineq1 onxpdisj cvv cvv cvv cxp
    cin cvv cvv cxp cvv cin cvv cvv cxp cvv cvv cvv cxp incom cvv cvv cxp inv1
    eqtri 3eqtr3g eqcomd necon3i ax-mp $.
    $( [29-Jun-2007] $) $( [16-Jun-2007] $)

  $( Equality theorem for the relation predicate. $)
  releq $p |- ( A = B -> ( Rel A <-> Rel B ) ) $=
    cA cB wceq cA cvv cvv cxp wss cB cvv cvv cxp wss cA wrel cB wrel cA cB cvv
    cvv cxp sseq1 cA df-rel cB df-rel 3bitr4g $.
    $( [1-Aug-1994] $)

  ${
    releqi.1 $e |- A = B $.
    $( Equality inference for the relation predicate. $)
    releqi $p |- ( Rel A <-> Rel B ) $=
      cA cB wceq cA wrel cB wrel wb releqi.1 cA cB releq ax-mp $.
      $( [8-Dec-2006] $) $( [8-Dec-2006] $)
  $}

  ${
    $d y A $.  $d x y $.
    hbrel.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for a relation. $)
    hbrel $p |- ( Rel A -> A. x Rel A ) $=
      cA cvv cvv cxp wss cA cvv cvv cxp wss vx wal cA wrel cA wrel vx wal vx vy
      cA cvv cvv cxp hbrel.1 vy cv cvv cvv cxp wcel vx ax-17 hbss cA df-rel cA
      wrel cA cvv cvv cxp wss vx cA df-rel albii 3imtr4i $.
      $( [31-Jan-2004] $) $( [31-Jan-2004] $)
  $}

  $( Subclass theorem for relation predicate.  Theorem 2 of [Suppes] p. 58. $)
  relss $p |- ( A C_ B -> ( Rel B -> Rel A ) ) $=
    cA cB wss cB cvv cvv cxp wss cA cvv cvv cxp wss cB wrel cA wrel cA cB cvv
    cvv cxp sstr2 cB df-rel cA df-rel 3imtr4g $.
    $( [15-Aug-1994] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( A subclass relationship depends only on a relation's ordered pairs.
       Theorem 3.2(i) of [Monk1] p. 33. $)
    ssrel $p |- ( Rel A -> ( A C_ B <->
                A. x A. y ( <. x , y >. e. A -> <. x , y >. e. B ) ) ) $=
      cA wrel cA cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vy
      wal vx wal cA cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi
      vx vy cA cB vx cv vy cv cop ssel 19.21aivv cA wrel vx cv vy cv cop cA
      wcel vx cv vy cv cop cB wcel wi vy wal vx wal vz cv cA wcel vz cv cB wcel
      wi vz wal cA cB wss cA wrel vx cv vy cv cop cA wcel vx cv vy cv cop cB
      wcel wi vy wal vx wal vz cv cA wcel vz cv cB wcel wi vz cA wrel vx cv vy
      cv cop cA wcel vx cv vy cv cop cB wcel wi vy wal vx wal vz cv cA wcel vz
      cv cA wcel vz cv cB wcel wi wi vz cv cA wcel vz cv cB wcel wi cA wrel vz
      cv cA wcel vz cv vx cv vy cv cop wceq vy wex vx wex vx cv vy cv cop cA
      wcel vx cv vy cv cop cB wcel wi vy wal vx wal vz cv cA wcel vz cv cB wcel
      wi cA wrel vz cv cA wcel vz cv cvv cvv cxp wcel vz cv vx cv vy cv cop
      wceq vy wex vx wex cA wrel cA cvv cvv cxp wss vz cv cA wcel vz cv cvv cvv
      cxp wcel wi cA df-rel cA cvv cvv cxp vz cv ssel sylbi vx vy vz cv elvv
      syl6ib vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vy wal vx wal
      vz cv vx cv vy cv cop wceq vy wex vz cv cA wcel vz cv cB wcel wi wi vx
      wal vz cv vx cv vy cv cop wceq vy wex vx wex vz cv cA wcel vz cv cB wcel
      wi wi vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vy wal vz cv vx
      cv vy cv cop wceq vy wex vz cv cA wcel vz cv cB wcel wi wi vx vx cv vy cv
      cop cA wcel vx cv vy cv cop cB wcel wi vy wal vz cv vx cv vy cv cop wceq
      vz cv cA wcel vz cv cB wcel wi wi vy wal vz cv vx cv vy cv cop wceq vy
      wex vz cv cA wcel vz cv cB wcel wi wi vx cv vy cv cop cA wcel vx cv vy cv
      cop cB wcel wi vz cv vx cv vy cv cop wceq vz cv cA wcel vz cv cB wcel wi
      wi vy vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vz cv vx cv vy
      cv cop wceq vz cv cA wcel vz cv cB wcel vx cv vy cv cop cA wcel vx cv vy
      cv cop cB wcel wi vz cv vx cv vy cv cop wceq vx cv vy cv cop cA wcel wa
      vz cv cB wcel vz cv vx cv vy cv cop wceq vz cv cA wcel wa vx cv vy cv cop
      cA wcel vx cv vy cv cop cB wcel wi vz cv vx cv vy cv cop wceq vx cv vy cv
      cop cA wcel wa vz cv vx cv vy cv cop wceq vx cv vy cv cop cB wcel wa vz
      cv cB wcel vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vx cv vy cv
      cop cA wcel vx cv vy cv cop cB wcel vz cv vx cv vy cv cop wceq vx cv vy
      cv cop cA wcel vx cv vy cv cop cB wcel wi id anim2d vz cv vx cv vy cv cop
      wceq vz cv cB wcel vx cv vy cv cop cB wcel vz cv vx cv vy cv cop cB eleq1
      biimpar syl6 vz cv vx cv vy cv cop wceq vz cv cA wcel vx cv vy cv cop cA
      wcel vz cv vx cv vy cv cop cA eleq1 pm5.32i syl5ib exp3a 19.20i vz cv vx
      cv vy cv cop wceq vz cv cA wcel vz cv cB wcel wi vy 19.23v sylib 19.20i
      vz cv vx cv vy cv cop wceq vy wex vz cv cA wcel vz cv cB wcel wi vx
      19.23v sylib syl9 vz cv cA wcel vz cv cB wcel pm2.43 syl6 19.21adv vz cA
      cB dfss2 syl6ibr impbid2 $.
      $( [2-Aug-1994] $)

    $( Extensionality principle for relations.  Theorem 3.2(ii) of [Monk1]
       p. 33. $)
    eqrel $p |- ( ( Rel A /\ Rel B ) -> ( A = B <->
                A. x A. y ( <. x , y >. e. A <-> <. x , y >. e. B ) ) ) $=
      cA wrel cB wrel wa cA cB wss cB cA wss wa vx cv vy cv cop cA wcel vx cv
      vy cv cop cB wcel wi vy wal vx wal vx cv vy cv cop cB wcel vx cv vy cv
      cop cA wcel wi vy wal vx wal wa cA cB wceq vx cv vy cv cop cA wcel vx cv
      vy cv cop cB wcel wb vy wal vx wal cA wrel cA cB wss vx cv vy cv cop cA
      wcel vx cv vy cv cop cB wcel wi vy wal vx wal cB wrel cB cA wss vx cv vy
      cv cop cB wcel vx cv vy cv cop cA wcel wi vy wal vx wal vx vy cA cB ssrel
      vx vy cB cA ssrel bi2anan9 cA cB eqss vx cv vy cv cop cA wcel vx cv vy cv
      cop cB wcel vx vy 2albi 3bitr4g $.
      $( [2-Aug-1994] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    relssi.1 $e |- Rel A $.
    relssi.2 $e |- ( <. x , y >. e. A -> <. x , y >. e. B ) $.
    $( Inference from subclass principle for relations. $)
    relssi $p |- A C_ B $=
      cA cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vy wal vx cA
      wrel cA cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vy wal
      vx wal wb relssi.1 vx vy cA cB ssrel ax-mp vx cv vy cv cop cA wcel vx cv
      vy cv cop cB wcel wi vy relssi.2 ax-gen mpgbir $.
      $( [31-Mar-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ph $.
    relssdv.1 $e |- ( ph -> Rel A ) $.
    relssdv.2 $e |- ( ph -> ( <. x , y >. e. A -> <. x , y >. e. B ) ) $.
    $( Deduction from subclass principle for relations. $)
    relssdv $p |- ( ph -> A C_ B ) $=
      wph cA cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vy wal
      vx wal wph vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wi vx vy
      relssdv.2 19.21aivv wph cA wrel cA cB wss vx cv vy cv cop cA wcel vx cv
      vy cv cop cB wcel wi vy wal vx wal wb relssdv.1 vx vy cA cB ssrel syl
      mpbird $.
      $( [13-Sep-2004] $) $( [11-Sep-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    eqreli.1 $e |- Rel A $.
    eqreli.2 $e |- Rel B $.
    eqreli.3 $e |- ( <. x , y >. e. A <-> <. x , y >. e. B ) $.
    $( Inference from extensionality principle for relations. $)
    eqrelriv $p |- A = B $=
      cA cB wceq vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wb vy wal vx
      cA wrel cB wrel cA cB wceq vx cv vy cv cop cA wcel vx cv vy cv cop cB
      wcel wb vy wal vx wal wb eqreli.1 eqreli.2 vx vy cA cB eqrel mp2an vx cv
      vy cv cop cA wcel vx cv vy cv cop cB wcel wb vy eqreli.3 ax-gen mpgbir $.
      $( [17-Mar-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    eqbrriv.1 $e |- Rel A $.
    eqbrriv.2 $e |- Rel B $.
    eqbrriv.3 $e |- ( x A y <-> x B y ) $.
    $( Inference from extensionality principle for relations. $)
    eqbrriv $p |- A = B $=
      vx vy cA cB eqbrriv.1 eqbrriv.2 vx cv vy cv cA wbr vx cv vy cv cB wbr vx
      cv vy cv cop cA wcel vx cv vy cv cop cB wcel eqbrriv.3 vx cv vy cv cA
      df-br vx cv vy cv cB df-br 3bitr3i eqrelriv $.
      $( [14-Dec-2006] $) $( [12-Dec-2006] $)
  $}

  ${
    $d w x y z A $.  $d w x y z B $.
    $( A subclass relationship determined by ordered triples.  Use ~ relrelss
       to express the antecedent in terms of the relation predicate. $)
    ssrelrel $p |- ( A C_ ( ( _V X. _V ) X. _V ) -> ( A C_ B <->
                   A. x A. y A. z ( <. <. x , y >. , z >. e. A
                       -> <. <. x , y >. , z >. e. B ) ) ) $=
      cA cvv cvv cxp cvv cxp wss cA cB wss vx cv vy cv cop vz cv cop cA wcel vx
      cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vx wal cA cB wss vx cv vy
      cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vx
      vy cA cB wss vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop
      cB wcel wi vz cA cB vx cv vy cv cop vz cv cop ssel 19.21aiv 19.21aivv cA
      cvv cvv cxp cvv cxp wss vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop
      vz cv cop cB wcel wi vz wal vy wal vx wal vw cv cA wcel vw cv cB wcel wi
      vw wal cA cB wss cA cvv cvv cxp cvv cxp wss vx cv vy cv cop vz cv cop cA
      wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vx wal vw cv cA
      wcel vw cv cB wcel wi vw cA cvv cvv cxp cvv cxp wss vx cv vy cv cop vz cv
      cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vx wal vw
      cv cA wcel vw cv cA wcel vw cv cB wcel wi wi vw cv cA wcel vw cv cB wcel
      wi cA cvv cvv cxp cvv cxp wss vw cv cA wcel vw cv vx cv vy cv cop vz cv
      cop wceq vz wex vy wex vx wex vx cv vy cv cop vz cv cop cA wcel vx cv vy
      cv cop vz cv cop cB wcel wi vz wal vy wal vx wal vw cv cA wcel vw cv cB
      wcel wi cA cvv cvv cxp cvv cxp wss vw cv cA wcel vw cv cvv cvv cxp cvv
      cxp wcel vw cv vx cv vy cv cop vz cv cop wceq vz wex vy wex vx wex cA cvv
      cvv cxp cvv cxp vw cv ssel vx vy vz vw cv elvvv syl6ib vx cv vy cv cop vz
      cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vx wal
      vw cv vx cv vy cv cop vz cv cop wceq vz wex vy wex vw cv cA wcel vw cv cB
      wcel wi wi vx wal vw cv vx cv vy cv cop vz cv cop wceq vz wex vy wex vx
      wex vw cv cA wcel vw cv cB wcel wi wi vx cv vy cv cop vz cv cop cA wcel
      vx cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vw cv vx cv vy cv cop
      vz cv cop wceq vz wex vy wex vw cv cA wcel vw cv cB wcel wi wi vx vx cv
      vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal
      vy wal vw cv vx cv vy cv cop vz cv cop wceq vz wex vw cv cA wcel vw cv cB
      wcel wi wi vy wal vw cv vx cv vy cv cop vz cv cop wceq vz wex vy wex vw
      cv cA wcel vw cv cB wcel wi wi vx cv vy cv cop vz cv cop cA wcel vx cv vy
      cv cop vz cv cop cB wcel wi vz wal vw cv vx cv vy cv cop vz cv cop wceq
      vz wex vw cv cA wcel vw cv cB wcel wi wi vy vx cv vy cv cop vz cv cop cA
      wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vw cv vx cv vy cv cop vz
      cv cop wceq vw cv cA wcel vw cv cB wcel wi wi vz wal vw cv vx cv vy cv
      cop vz cv cop wceq vz wex vw cv cA wcel vw cv cB wcel wi wi vx cv vy cv
      cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vw cv vx cv vy
      cv cop vz cv cop wceq vw cv cA wcel vw cv cB wcel wi wi vz vx cv vy cv
      cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vw cv vx cv vy
      cv cop vz cv cop wceq vw cv cA wcel vw cv cB wcel vx cv vy cv cop vz cv
      cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vw cv vx cv vy cv cop vz
      cv cop wceq vx cv vy cv cop vz cv cop cA wcel wa vw cv cB wcel vw cv vx
      cv vy cv cop vz cv cop wceq vw cv cA wcel wa vx cv vy cv cop vz cv cop cA
      wcel vx cv vy cv cop vz cv cop cB wcel wi vw cv vx cv vy cv cop vz cv cop
      wceq vx cv vy cv cop vz cv cop cA wcel wa vw cv vx cv vy cv cop vz cv cop
      wceq vx cv vy cv cop vz cv cop cB wcel wa vw cv cB wcel vx cv vy cv cop
      vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vx cv vy cv cop vz
      cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel vw cv vx cv vy cv cop vz
      cv cop wceq vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop
      cB wcel wi id anim2d vw cv vx cv vy cv cop vz cv cop wceq vw cv cB wcel
      vx cv vy cv cop vz cv cop cB wcel vw cv vx cv vy cv cop vz cv cop cB
      eleq1 biimpar syl6 vw cv vx cv vy cv cop vz cv cop wceq vw cv cA wcel vx
      cv vy cv cop vz cv cop cA wcel vw cv vx cv vy cv cop vz cv cop cA eleq1
      pm5.32i syl5ib exp3a 19.20i vw cv vx cv vy cv cop vz cv cop wceq vw cv cA
      wcel vw cv cB wcel wi vz 19.23v sylib 19.20i vw cv vx cv vy cv cop vz cv
      cop wceq vz wex vw cv cA wcel vw cv cB wcel wi vy 19.23v sylib 19.20i vw
      cv vx cv vy cv cop vz cv cop wceq vz wex vy wex vw cv cA wcel vw cv cB
      wcel wi vx 19.23v sylib syl9 vw cv cA wcel vw cv cB wcel pm2.43 syl6
      19.21adv vw cA cB dfss2 syl6ibr impbid2 $.
      $( [2-Jan-2009] $) $( [17-Dec-2008] $)

    $( Extensionality principle for ordered triples (used by 2-place
       operations ~ df-oprab ), analogous to ~ eqrel .  Use ~ relrelss to
       express the antecedent in terms of the relation predicate. $)
    eqrelrel $p |- ( ( A u. B ) C_ ( ( _V X. _V ) X. _V ) -> ( A = B <->
                   A. x A. y A. z ( <. <. x , y >. , z >. e. A
                       <-> <. <. x , y >. , z >. e. B ) ) ) $=
      cA cB cun cvv cvv cxp cvv cxp wss cA cvv cvv cxp cvv cxp wss cB cvv cvv
      cxp cvv cxp wss wa cA cB wceq vx cv vy cv cop vz cv cop cA wcel vx cv vy
      cv cop vz cv cop cB wcel wb vz wal vy wal vx wal wb cA cB cvv cvv cxp cvv
      cxp unss cA cvv cvv cxp cvv cxp wss cB cvv cvv cxp cvv cxp wss wa cA cB
      wss cB cA wss wa vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv
      cop cB wcel wi vz wal vy wal vx wal vx cv vy cv cop vz cv cop cB wcel vx
      cv vy cv cop vz cv cop cA wcel wi vz wal vy wal vx wal wa cA cB wceq vx
      cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wb vz
      wal vy wal vx wal cA cvv cvv cxp cvv cxp wss cA cB wss vx cv vy cv cop vz
      cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vx wal
      cB cvv cvv cxp cvv cxp wss cB cA wss vx cv vy cv cop vz cv cop cB wcel vx
      cv vy cv cop vz cv cop cA wcel wi vz wal vy wal vx wal vx vy vz cA cB
      ssrelrel vx vy vz cB cA ssrelrel bi2anan9 cA cB eqss vx cv vy cv cop vz
      cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wb vz wal vy wal vx wal
      vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz
      wal vy wal vx cv vy cv cop vz cv cop cB wcel vx cv vy cv cop vz cv cop cA
      wcel wi vz wal vy wal wa vx wal vx cv vy cv cop vz cv cop cA wcel vx cv
      vy cv cop vz cv cop cB wcel wi vz wal vy wal vx wal vx cv vy cv cop vz cv
      cop cB wcel vx cv vy cv cop vz cv cop cA wcel wi vz wal vy wal vx wal wa
      vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wb vz
      wal vy wal vx cv vy cv cop vz cv cop cA wcel vx cv vy cv cop vz cv cop cB
      wcel wi vz wal vy wal vx cv vy cv cop vz cv cop cB wcel vx cv vy cv cop
      vz cv cop cA wcel wi vz wal vy wal wa vx vx cv vy cv cop vz cv cop cA
      wcel vx cv vy cv cop vz cv cop cB wcel vy vz 2albi albii vx cv vy cv cop
      vz cv cop cA wcel vx cv vy cv cop vz cv cop cB wcel wi vz wal vy wal vx
      cv vy cv cop vz cv cop cB wcel vx cv vy cv cop vz cv cop cA wcel wi vz
      wal vy wal vx 19.26 bitri 3bitr4g sylbir $.
      $( [7-Jan-2009] $) $( [17-Dec-2008] $)
  $}

  ${
    $d x y A $.
    $( A member of a relation is an ordered pair. $)
    elrel $p |- ( ( Rel R /\ A e. R ) -> E. x E. y A = <. x , y >. ) $=
      cR wrel cA cR wcel wa cA cvv cvv cxp wcel cA vx cv vy cv cop wceq vy wex
      vx wex cR wrel cA cR wcel cA cvv cvv cxp wcel cR wrel cR cvv cvv cxp cA
      cR wrel cR cvv cvv cxp wss cR df-rel biimpi sseld imp vx vy cA elvv sylib
      $.
      $( [19-Sep-2006] $) $( [17-Sep-2006] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    relsn.1 $e |- A e. _V $.
    $( A singleton of an ordered pair is a relation. $)
    relsn $p |- Rel { <. A , B >. } $=
      cA cB cop csn wrel cA cB cop csn cvv cvv cxp wss cA cB cop cvv cvv cxp
      wcel cA cB cop csn cvv cvv cxp wss cB cvv wcel cA cB cop cvv cvv cxp wcel
      cA cvv wcel cB cvv wcel cA cB cop cvv cvv cxp wcel relsn.1 cA cB cvv cvv
      opelxpi mpan cB cvv wcel wn cA cB cop cA cA cop cvv cvv cxp cA cB opprc2
      cA cA cop cvv cvv cxp wcel cA cvv wcel cA cvv wcel cA cA cvv cvv relsn.1
      opelxp relsn.1 relsn.1 mpbir2an syl6eqel pm2.61i cA cB cop cvv cvv cxp
      snssi ax-mp cA cB cop csn df-rel mpbir $.
      $( [17-May-1998] $)
  $}

  $( A cross product is a relation.  Theorem 3.13(i) of [Monk1] p. 37. $)
  relxp $p |- Rel ( A X. B ) $=
    cA cB cxp wrel cA cB cxp cvv cvv cxp wss cA cB xpss cA cB cxp df-rel mpbir
    $.
    $( [2-Aug-1994] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    $( Subset theorem for cross product.  Generalization of Theorem 101 of
       [Suppes] p. 52. $)
    ssxp $p |- ( ( A C_ B /\ C C_ D ) -> ( A X. C ) C_ ( B X. D ) ) $=
      cA cB wss cC cD wss wa vx vy cA cC cxp cB cD cxp cA cC cxp wrel cA cB wss
      cC cD wss wa cA cC relxp a1i vx cv cA wcel vx cv cB wcel wi vy cv cC wcel
      vy cv cD wcel wi vx cv vy cv cop cA cC cxp wcel vx cv vy cv cop cB cD cxp
      wcel wi cA cB wss cC cD wss vx cv cA wcel vx cv cB wcel wi vy cv cC wcel
      vy cv cD wcel wi wa vx cv cA wcel vy cv cC wcel wa vx cv cB wcel vy cv cD
      wcel wa vx cv vy cv cop cA cC cxp wcel vx cv vy cv cop cB cD cxp wcel vx
      cv cA wcel vx cv cB wcel vy cv cC wcel vy cv cD wcel prth vx cv vy cv cA
      cC vy visset opelxp vx cv vy cv cB cD vy visset opelxp 3imtr4g cA cB vx
      cv ssel cC cD vy cv ssel syl2an relssdv $.
      $( [26-Aug-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A cross product is included in the power of the power of the union of
       its arguments. $)
    xpsspw $p |- ( A X. B ) C_ ~P ~P ( A u. B ) $=
      vx vy cA cB cxp cA cB cun cpw cpw cA cB relxp vx cv vy cv cop cA cB cxp
      wcel vx cv cA wcel vy cv cB wcel wa vx cv vy cv cop cA cB cun cpw cpw
      wcel vx cv vy cv cA cB vy visset opelxp vx cv cA wcel vy cv cB wcel wa vx
      cv csn cA cB cun cpw wcel vx cv vy cv cpr cA cB cun cpw wcel wa vx cv vy
      cv cop cA cB cun cpw cpw wcel vx cv cA wcel vy cv cB wcel wa vx cv csn cA
      cB cun cpw wcel vx cv vy cv cpr cA cB cun cpw wcel vx cv cA wcel vx cv
      csn cA cB cun cpw wcel vy cv cB wcel vx cv cA wcel vx cv csn cA cB cun
      wss vx cv csn cA cB cun cpw wcel vx cv cA wcel vx cv csn cA wss vx cv csn
      cA cB cun wss vx cv cA snssi vx cv csn cA cB ssun3 syl vx cv csn cA cB
      cun vx cv snex elpw sylibr adantr vx cv cA wcel vy cv cB wcel wa vx cv vy
      cv cpr cA cB cun wss vx cv vy cv cpr cA cB cun cpw wcel vx cv cA wcel vy
      cv cB wcel wa vx cv csn vy cv csn cun cA cB cun vx cv vy cv cpr vx cv cA
      wcel vy cv cB wcel wa vx cv csn cA cB cun wss vy cv csn cA cB cun wss wa
      vx cv csn vy cv csn cun cA cB cun wss vx cv cA wcel vx cv csn cA cB cun
      wss vy cv cB wcel vy cv csn cA cB cun wss vx cv cA wcel vx cv csn cA wss
      vx cv csn cA cB cun wss vx cv cA snssi vx cv csn cA cB ssun3 syl vy cv cB
      wcel vy cv csn cB wss vy cv csn cA cB cun wss vy cv cB snssi vy cv csn cB
      cA ssun4 syl anim12i vx cv csn vy cv csn cA cB cun unss sylib vx cv vy cv
      df-pr syl5ss vx cv vy cv cpr cA cB cun vx vy zfpair2 elpw sylibr jca vx
      cv csn vx cv vy cv cpr cpr cA cB cun cpw cpw wcel vx cv csn vx cv vy cv
      cpr cpr cA cB cun cpw wss vx cv vy cv cop cA cB cun cpw cpw wcel vx cv
      csn cA cB cun cpw wcel vx cv vy cv cpr cA cB cun cpw wcel wa vx cv csn vx
      cv vy cv cpr cpr cA cB cun cpw vx cv csn vx cv vy cv cpr prex elpw vx cv
      vy cv cop vx cv csn vx cv vy cv cpr cpr cA cB cun cpw cpw vx cv vy cv
      df-op eleq1i vx cv csn vx cv vy cv cpr cA cB cun cpw vx cv snex vx vy
      zfpair2 prss 3bitr4ri sylib sylbi relssi $.
      $( [14-Sep-2006] $) $( [13-Sep-2006] $)
  $}

  $( The double class union of a cross product is included in the union of its
     arguments. $)
  unixpss $p |- U. U. ( A X. B ) C_ ( A u. B ) $=
    cA cB cxp cuni cuni cA cB cun cpw cuni cA cB cun cA cB cxp cuni cA cB cun
    cpw wss cA cB cxp cuni cuni cA cB cun cpw cuni wss cA cB cxp cuni cA cB cun
    cpw cpw cuni cA cB cun cpw cA cB cxp cA cB cun cpw cpw wss cA cB cxp cuni
    cA cB cun cpw cpw cuni wss cA cB xpsspw cA cB cxp cA cB cun cpw cpw uniss
    ax-mp cA cB cun cpw unipw sseqtri cA cB cxp cuni cA cB cun cpw uniss ax-mp
    cA cB cun unipw sseqtri $.
    $( [19-Sep-2006] $) $( [16-Sep-2006] $)

  $( The cross product of two sets is a set.  Proposition 6.2 of
     [TakeutiZaring] p. 23. $)
  xpexg $p |- ( ( A e. C /\ B e. D ) -> ( A X. B ) e. _V ) $=
    cA cC wcel cB cD wcel wa cA cB cun cpw cvv wcel cA cB cun cpw cpw cvv wcel
    cA cB cxp cvv wcel cA cC wcel cB cD wcel wa cA cB cun cvv wcel cA cB cun
    cpw cvv wcel cA cB cC cD unexg cA cB cun cvv pwexg syl cA cB cun cpw cvv
    pwexg cA cB cxp cA cB cun cpw cpw wss cA cB cun cpw cpw cvv wcel cA cB cxp
    cvv wcel cA cB xpsspw cA cB cxp cA cB cun cpw cpw cvv ssexg mpan 3syl $.
    $( [14-Aug-1994] $)

  ${
    xpex.1 $e |- A e. _V $.
    xpex.2 $e |- B e. _V $.
    $( The cross product of two sets is a set.  Proposition 6.2 of
       [TakeutiZaring] p. 23. $)
    xpex $p |- ( A X. B ) e. _V $=
      cA cvv wcel cB cvv wcel cA cB cxp cvv wcel xpex.1 xpex.2 cA cB cvv cvv
      xpexg mp2an $.
      $( [14-Aug-1994] $)
  $}

  $( The union of two relations is a relation.  Compare Exercise 5 of
     [TakeutiZaring] p. 25. $)
  relun $p |- ( Rel ( A u. B ) <-> ( Rel A /\ Rel B ) ) $=
    cA cvv cvv cxp wss cB cvv cvv cxp wss wa cA cB cun cvv cvv cxp wss cA wrel
    cB wrel wa cA cB cun wrel cA cB cvv cvv cxp unss cA wrel cA cvv cvv cxp wss
    cB wrel cB cvv cvv cxp wss cA df-rel cB df-rel anbi12i cA cB cun df-rel
    3bitr4ri $.
    $( [12-Aug-1994] $)

  $( The intersection with a relation is a relation. $)
  relin1 $p |- ( Rel A -> Rel ( A i^i B ) ) $=
    cA cB cin cA wss cA wrel cA cB cin wrel wi cA cB inss1 cA cB cin cA relss
    ax-mp $.
    $( [16-Aug-1994] $)

  $( The intersection with a relation is a relation. $)
  relin2 $p |- ( Rel B -> Rel ( A i^i B ) ) $=
    cA cB cin cB wss cB wrel cA cB cin wrel wi cA cB inss2 cA cB cin cB relss
    ax-mp $.
    $( [18-Jan-2006] $) $( [17-Jan-2006] $)

  $( A difference cutting down a relation is a relation. $)
  reldif $p |- ( Rel A -> Rel ( A \ B ) ) $=
    cA cB cdif cA wss cA wrel cA cB cdif wrel wi cA cB difss cA cB cdif cA
    relss ax-mp $.
    $( [31-Mar-1998] $)

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( An indexed union is a relation iff each member of its indexed family is
       a relation. $)
    reliun $p |- ( Rel U_ x e. A B <-> A. x e. A Rel B ) $=
      vx cA cB ciun wrel vy cv cB wcel vx cA wrex vy cab wrel vy cv cB wcel vx
      cA wrex vy cab cvv cvv cxp wss cB wrel vx cA wral vx cA cB ciun vy cv cB
      wcel vx cA wrex vy cab vx vy cA cB df-iun releqi vy cv cB wcel vx cA wrex
      vy cab df-rel vy cv cB wcel vx cA wrex vy cab cvv cvv cxp wss vy cv cB
      wcel vx cA wrex vy cv cvv cvv cxp wcel wi vy wal cB wrel vx cA wral vy cv
      cB wcel vx cA wrex vy cvv cvv cxp abss cB wrel vx cA wral vy cv cB wcel
      vy cv cvv cvv cxp wcel wi vy wal vx cA wral vy cv cB wcel vy cv cvv cvv
      cxp wcel wi vx cA wral vy wal vy cv cB wcel vx cA wrex vy cv cvv cvv cxp
      wcel wi vy wal cB wrel vy cv cB wcel vy cv cvv cvv cxp wcel wi vy wal vx
      cA cB wrel cB cvv cvv cxp wss vy cv cB wcel vy cv cvv cvv cxp wcel wi vy
      wal cB df-rel vy cB cvv cvv cxp dfss2 bitri ralbii vy cv cB wcel vy cv
      cvv cvv cxp wcel wi vx vy cA ralcom4 vy cv cB wcel vy cv cvv cvv cxp wcel
      wi vx cA wral vy cv cB wcel vx cA wrex vy cv cvv cvv cxp wcel wi vy vy cv
      cB wcel vy cv cvv cvv cxp wcel vx cA r19.23v albii 3bitri bitr4i 3bitri
      $.
      $( [19-Dec-2008] $) $( [19-Dec-2008] $)
  $}

  $( The empty set is a relation. $)
  rel0 $p |- Rel (/) $=
    c0 wrel c0 cvv cvv cxp wss cvv cvv cxp 0ss c0 df-rel mpbir $.
    $( [26-Apr-1998] $)

  ${
    $d w x y z A $.   $d x y B $.  $d x y C $.  $d x y D $.
    $d ph z w $.  $d ps z w $.
    $( Union law for relations.  Exercise 6 of [TakeutiZaring] p. 25 and its
       converse. $)
    reluni $p |- ( Rel U. A <-> A. x e. A Rel x ) $=
      cA cuni wrel vx cA vx cv ciun wrel vx cv wrel vx cA wral cA cuni vx cA vx
      cv ciun vx cA uniiun releqi vx cA vx cv reliun bitri $.
      $( [21-Dec-2008] $) $( [13-Aug-2004] $)

    $( A class of ordered pairs is a relation. $)
    relopab $p |- Rel { <. x , y >. | ph } $=
      wph vx vy copab wrel wph vx vy copab cvv cvv cxp wss wph vx vy copab vx
      cv cvv wcel vy cv cvv wcel wa vx vy copab cvv cvv cxp wph vx cv cvv wcel
      vy cv cvv wcel wa vx vy vx cv cvv wcel vy cv cvv wcel wa wph vx cv cvv
      wcel vy cv cvv wcel vx visset vy visset pm3.2i a1i ssopab2i vx vy cvv cvv
      df-xp sseqtr4i wph vx vy copab df-rel mpbir $.
      $( [8-Mar-1995] $)

    $( The identity relation is a relation.  Part of Exercise 4.12(p) of
       [Mendelson] p. 235. $)
    reli $p |- Rel _I $=
      cid wrel vx cv vy cv wceq vx vy copab wrel vx cv vy cv wceq vx vy relopab
      cid vx cv vy cv wceq vx vy copab vx vy df-id releqi mpbir $.
      $( [26-Apr-1998] $)

    $( The membership relation is a relation. $)
    rele $p |- Rel _E $=
      cep wrel vx cv vy cv wcel vx vy copab wrel vx cv vy cv wcel vx vy relopab
      cep vx cv vy cv wcel vx vy copab vx vy df-eprel releqi mpbir $.
      $( [26-Apr-1998] $)

    $( A relation expressed as an ordered pair abstraction. $)
    opabid2 $p |- ( Rel A -> { <. x , y >. | <. x , y >. e. A } = A ) $=
      cA wrel vx cv vy cv cop cA wcel vx vy copab cA wceq vz cv vw cv cop vx cv
      vy cv cop cA wcel vx vy copab wcel vz cv vw cv cop cA wcel wb vw wal vz
      wal vz cv vw cv cop vx cv vy cv cop cA wcel vx vy copab wcel vz cv vw cv
      cop cA wcel wb vz vw vx cv vy cv cop cA wcel vz cv vy cv cop cA wcel vz
      cv vw cv cop cA wcel vx vy vz cv vw cv vz visset vw visset vx cv vz cv
      wceq vx cv vy cv cop vz cv vy cv cop cA vx cv vz cv vy cv opeq1 eleq1d vy
      cv vw cv wceq vz cv vy cv cop vz cv vw cv cop cA vy cv vw cv vz cv opeq2
      eleq1d opelopab gen2 vx cv vy cv cop cA wcel vx vy copab wrel cA wrel vx
      cv vy cv cop cA wcel vx vy copab cA wceq vz cv vw cv cop vx cv vy cv cop
      cA wcel vx vy copab wcel vz cv vw cv cop cA wcel wb vw wal vz wal wb vx
      cv vy cv cop cA wcel vx vy relopab vz vw vx cv vy cv cop cA wcel vx vy
      copab cA eqrel mpan mpbiri $.
      $( [11-Dec-2006] $) $( [11-Dec-2006] $)

    $( Intersection of two ordered pair class abstractions. $)
    inopab $p |- ( { <. x , y >. | ph } i^i { <. x , y >. | ps } ) =
               { <. x , y >. | ( ph /\ ps ) } $=
      vz vw wph vx vy copab wps vx vy copab cin wph wps wa vx vy copab wph vx
      vy copab wrel wph vx vy copab wps vx vy copab cin wrel wph vx vy relopab
      wph vx vy copab wps vx vy copab relin1 ax-mp wph wps wa vx vy relopab vz
      cv vw cv cop wph vx vy copab wcel vz cv vw cv cop wps vx vy copab wcel wa
      wph wps wa vx vz cv wsbc vy vw cv wsbc vz cv vw cv cop wph vx vy copab
      wps vx vy copab cin wcel vz cv vw cv cop wph wps wa vx vy copab wcel wph
      vx vz cv wsbc wps vx vz cv wsbc wa vy vw cv wsbc wph vx vz cv wsbc vy vw
      cv wsbc wps vx vz cv wsbc vy vw cv wsbc wa wph wps wa vx vz cv wsbc vy vw
      cv wsbc vz cv vw cv cop wph vx vy copab wcel vz cv vw cv cop wps vx vy
      copab wcel wa wph vx vz cv wsbc wps vx vz cv wsbc vy vw sban wph wps wa
      vx vz cv wsbc wph vx vz cv wsbc wps vx vz cv wsbc wa vy vw wph wps vx vz
      sban sbbii vz cv vw cv cop wph vx vy copab wcel wph vx vz cv wsbc vy vw
      cv wsbc vz cv vw cv cop wps vx vy copab wcel wps vx vz cv wsbc vy vw cv
      wsbc wph vx vy vz vw opelopabsb wps vx vy vz vw opelopabsb anbi12i
      3bitr4ri vz cv vw cv cop wph vx vy copab wps vx vy copab elin wph wps wa
      vx vy vz vw opelopabsb 3bitr4i eqrelriv $.
      $( [30-Sep-2002] $)

    $( The intersection of two cross products.  Exercise 9 of [TakeutiZaring]
       p. 25. $)
    inxp $p |- ( ( A X. B ) i^i ( C X. D ) ) =
                   ( ( A i^i C ) X. ( B i^i D ) ) $=
      vx vy cA cB cxp cC cD cxp cin cA cC cin cB cD cin cxp cA cB cxp wrel cA
      cB cxp cC cD cxp cin wrel cA cB relxp cA cB cxp cC cD cxp relin1 ax-mp cA
      cC cin cB cD cin relxp vx cv vy cv cop cA cB cxp wcel vx cv vy cv cop cC
      cD cxp wcel wa vx cv cA cC cin wcel vy cv cB cD cin wcel wa vx cv vy cv
      cop cA cB cxp cC cD cxp cin wcel vx cv vy cv cop cA cC cin cB cD cin cxp
      wcel vx cv cA wcel vy cv cB wcel wa vx cv cC wcel vy cv cD wcel wa wa vx
      cv cA wcel vx cv cC wcel wa vy cv cB wcel vy cv cD wcel wa wa vx cv vy cv
      cop cA cB cxp wcel vx cv vy cv cop cC cD cxp wcel wa vx cv cA cC cin wcel
      vy cv cB cD cin wcel wa vx cv cA wcel vy cv cB wcel vx cv cC wcel vy cv
      cD wcel an4 vx cv vy cv cop cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa
      vx cv vy cv cop cC cD cxp wcel vx cv cC wcel vy cv cD wcel wa vx cv vy cv
      cA cB vy visset opelxp vx cv vy cv cC cD vy visset opelxp anbi12i vx cv
      cA cC cin wcel vx cv cA wcel vx cv cC wcel wa vy cv cB cD cin wcel vy cv
      cB wcel vy cv cD wcel wa vx cv cA cC elin vy cv cB cD elin anbi12i
      3bitr4i vx cv vy cv cop cA cB cxp cC cD cxp elin vx cv vy cv cA cC cin cB
      cD cin vy visset opelxp 3bitr4i eqrelriv $.
      $( [3-Aug-1994] $)

    $( Distributive law for cross product over intersection.  Theorem 102 of
      [Suppes] p. 52. $)
    xpindi $p |- ( A X. ( B i^i C ) ) = ( ( A X. B ) i^i ( A X. C ) ) $=
      cA cB cxp cA cC cxp cin cA cA cin cB cC cin cxp cA cB cC cin cxp cA cB cA
      cC inxp cA cA cin cA cB cC cin cA inidm xpeq1i eqtr2i $.
      $( [29-Sep-2004] $) $( [26-Sep-2004] $)

    $( Distributive law for cross product over intersection.  Similar to
       Theorem 102 of [Suppes] p. 52. $)
    xpindir $p |- ( ( A i^i B ) X. C ) = ( ( A X. C ) i^i ( B X. C ) ) $=
      cA cC cxp cB cC cxp cin cA cB cin cC cC cin cxp cA cB cin cC cxp cA cC cB
      cC inxp cC cC cin cC cA cB cin cC inidm xpeq2i eqtr2i $.
      $( [28-Oct-2004] $) $( [26-Sep-2004] $)
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.
    relop.1 $e |- A e. _V $.
    relop.2 $e |- B e. _V $.
    $( A necessary and sufficient condition for a Kuratowski ordered pair to be
       a relation. $)
    relop $p |- ( Rel <. A , B >.
             <-> E. x E. y ( A = { x } /\ B = { x , y } ) ) $=
      cA cB cop wrel cA cB cop cvv cvv cxp wss cA vx cv csn wceq cB vx cv vy cv
      cpr wceq wa vy wex vx wex cA cB cop df-rel cA cB cop cvv cvv cxp wss cA
      vx cv csn wceq cB vx cv vy cv cpr wceq wa vy wex vx wex cA cB cop cvv cvv
      cxp wss vz cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz
      wal vz cv cA cB cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz
      wal wa cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vy wex vx wex cA cB
      cop cvv cvv cxp wss vz cv cA cB cop wcel vz cv cvv cvv cxp wcel wi vz wal
      vz cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz cv cA cB
      cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi wa vz wal vz cv cA
      csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz wal vz cv cA cB
      cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz wal wa vz cA cB
      cop cvv cvv cxp dfss2 vz cv cA cB cop wcel vz cv cvv cvv cxp wcel wi vz
      cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz cv cA cB
      cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi wa vz vz cv cA cB
      cop wcel vz cv cvv cvv cxp wcel wi vz cv cA csn wceq vz cv cA cB cpr wceq
      wo vz cv vx cv vy cv cop wceq vy wex vx wex wi vz cv cA csn wceq vz cv vx
      cv vy cv cop wceq vy wex vx wex wi vz cv cA cB cpr wceq vz cv vx cv vy cv
      cop wceq vy wex vx wex wi wa vz cv cA cB cop wcel vz cv cA csn wceq vz cv
      cA cB cpr wceq wo vz cv cvv cvv cxp wcel vz cv vx cv vy cv cop wceq vy
      wex vx wex vz cv cA cB vz visset elop vx vy vz cv elvv imbi12i vz cv cA
      csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex vz cv cA cB cpr wceq
      jaob bitri albii vz cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex vx
      wex wi vz cv cA cB cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi
      vz 19.26 3bitri cA vw cv csn wceq vw wex cA cB cpr vx cv vy cv cop wceq
      vy wex vx wex cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vy wex vx wex
      vz cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz wal vz
      cv cA cB cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz wal cA
      vw cv csn wceq vw wex cA cB cpr vx cv vy cv cop wceq vy wex vx wex cA vx
      cv csn wceq cB vx cv vy cv cpr wceq wa vy wex vx wex cA vw cv csn wceq cA
      cB cpr vx cv vy cv cop wceq vy wex vx wex cA vx cv csn wceq cB vx cv vy
      cv cpr wceq wa vy wex vx wex wi vw cA vw cv csn wceq cA cB cpr vx cv vy
      cv cop wceq cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vx vy cA vw cv
      csn wceq cA vx cv csn wceq cB vx cv vy cv cpr wceq wa cA vx cv vy cv cpr
      wceq cB vx cv csn wceq wa wo cA vx cv csn wceq cB vx cv vy cv cpr wceq wa
      cA cB cpr vx cv vy cv cop wceq cA vw cv csn wceq cA vx cv csn wceq cB vx
      cv vy cv cpr wceq wa cA vx cv csn wceq cB vx cv vy cv cpr wceq wa cA vx
      cv vy cv cpr wceq cB vx cv csn wceq wa cA vw cv csn wceq cA vx cv csn
      wceq cB vx cv vy cv cpr wceq wa idd cA vw cv csn wceq cA vx cv vy cv cpr
      wceq cB vx cv csn wceq cA vx cv csn wceq cB vx cv vy cv cpr wceq wa cA vx
      cv vy cv cpr wceq cA vw cv csn wceq cB vx cv csn wceq cA vx cv csn wceq
      cB vx cv vy cv cpr wceq wa wi cA vx cv vy cv cpr wceq cA vw cv csn wceq
      wa vx cv vy cv wceq cB vx cv csn wceq cA vx cv csn wceq cB vx cv vy cv
      cpr wceq wa wi cA vx cv vy cv cpr wceq cA vw cv csn wceq wa vx cv vy cv
      cpr vw cv csn wceq vx cv vy cv wceq cA vx cv vy cv cpr vw cv csn eqtr2 vx
      cv vy cv cpr vw cv csn wceq vx cv vy cv wceq vy cv vw cv wceq vx cv vy cv
      vw cv vx visset vy visset vw visset preqsn pm3.26bi syl cA vx cv vy cv
      cpr wceq vx cv vy cv wceq cB vx cv csn wceq cA vx cv csn wceq cB vx cv vy
      cv cpr wceq wa wi wi cA vw cv csn wceq vx cv vy cv wceq cA vx cv vy cv
      cpr wceq cB vx cv csn wceq cA vx cv csn wceq cB vx cv vy cv cpr wceq wa
      wi vx cv vy cv wceq cA vx cv vy cv cpr wceq cB vx cv csn wceq cA vx cv
      csn wceq cB vx cv vy cv cpr wceq wa vx cv vy cv wceq cA vx cv vy cv cpr
      wceq cB vx cv csn wceq wa cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vx
      cv vy cv wceq cA vx cv vy cv cpr wceq cA vx cv csn wceq cB vx cv csn wceq
      cB vx cv vy cv cpr wceq vx cv vy cv wceq vx cv vy cv cpr vx cv csn cA vx
      cv vy cv wceq vx cv vx cv cpr vx cv vy cv cpr vx cv csn vx cv vy cv vx cv
      preq2 vx cv dfsn2 syl5req eqeq2d vx cv vy cv wceq vx cv csn vx cv vy cv
      cpr cB vx cv vy cv wceq vx cv vx cv cpr vx cv vy cv cpr vx cv csn vx cv
      vy cv vx cv preq2 vx cv dfsn2 syl5eq eqeq2d anbi12d biimpd exp3a com12
      adantr mpd expcom imp3a jaod cA cB cpr vx cv vy cv cop wceq vx cv vy cv
      cop cA cB cpr wceq cA vx cv csn wceq cB vx cv vy cv cpr wceq wa cA vx cv
      vy cv cpr wceq cB vx cv csn wceq wa wo cA cB cpr vx cv vy cv cop eqcom vx
      cv vy cv cA cB relop.1 relop.2 opeqpr bitri syl5ib 19.22dvv 19.23aiv imp
      vz cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz wal cA
      csn cA csn wceq vx cv vy cv wceq cA vx cv csn wceq wa vy wex vx wex wi cA
      vw cv csn wceq vw wex vz cv cA csn wceq vz cv vx cv vy cv cop wceq vy wex
      vx wex wi cA csn cA csn wceq vx cv vy cv wceq cA vx cv csn wceq wa vy wex
      vx wex wi vz cA csn cA snex vz cv cA csn wceq vz cv cA csn wceq cA csn cA
      csn wceq vz cv vx cv vy cv cop wceq vy wex vx wex vx cv vy cv wceq cA vx
      cv csn wceq wa vy wex vx wex vz cv cA csn cA csn eqeq1 vz cv cA csn wceq
      vz cv vx cv vy cv cop wceq vx cv vy cv wceq cA vx cv csn wceq wa vx vy vz
      cv cA csn wceq vz cv vx cv vy cv cop wceq cA csn vx cv vy cv cop wceq vx
      cv vy cv wceq cA vx cv csn wceq wa vz cv cA csn vx cv vy cv cop eqeq1 cA
      csn vx cv vy cv cop wceq vx cv vy cv cop cA csn wceq vx cv vy cv wceq cA
      vx cv csn wceq wa cA csn vx cv vy cv cop eqcom vx cv vy cv cA vx visset
      vy visset relop.1 opeqsn bitri syl6bb 2exbidv imbi12d cla4v cA vw cv csn
      wceq vw wex cA vx cv csn wceq vx wex vx cv vy cv wceq cA vx cv csn wceq
      wa vy wex vx wex cA csn cA csn wceq vx cv vy cv wceq cA vx cv csn wceq wa
      vy wex vx wex wi cA vw cv csn wceq cA vx cv csn wceq vw vx vw cv vx cv
      wceq vw cv csn vx cv csn cA vw cv vx cv sneq eqeq2d cbvexv vx cv vy cv
      wceq cA vx cv csn wceq wa vy wex cA vx cv csn wceq vx vx cv vy cv wceq cA
      vx cv csn wceq wa vy wex vx cv vy cv wceq vy wex cA vx cv csn wceq vx cv
      vy cv wceq cA vx cv csn wceq vy 19.41v vy cv vx cv wceq vy wex vx cv vy
      cv wceq vy wex vy vx a9e vy cv vx cv wceq vx cv vy cv wceq vy vy vx
      equcom exbii mpbi mpbiran exbii cA csn cA csn wceq vx cv vy cv wceq cA vx
      cv csn wceq wa vy wex vx wex cA csn eqid a1bi 3bitr2ri sylib vz cv cA cB
      cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi vz wal cA cB cpr cA
      cB cpr wceq cA cB cpr vx cv vy cv cop wceq vy wex vx wex cA cB cpr eqid
      vz cv cA cB cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex wi cA cB
      cpr cA cB cpr wceq cA cB cpr vx cv vy cv cop wceq vy wex vx wex wi vz cA
      cB cpr cA cB prex vz cv cA cB cpr wceq vz cv cA cB cpr wceq cA cB cpr cA
      cB cpr wceq vz cv vx cv vy cv cop wceq vy wex vx wex cA cB cpr vx cv vy
      cv cop wceq vy wex vx wex vz cv cA cB cpr cA cB cpr eqeq1 vz cv cA cB cpr
      wceq vz cv vx cv vy cv cop wceq cA cB cpr vx cv vy cv cop wceq vx vy vz
      cv cA cB cpr vx cv vy cv cop eqeq1 2exbidv imbi12d cla4v mpi syl2an sylbi
      cA vx cv csn wceq cB vx cv vy cv cpr wceq wa cA cB cop cvv cvv cxp wss vx
      vy cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vz cA cB cop cvv cvv cxp
      cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vz cv cA csn wceq vz cv cA
      cB cpr wceq wo vz cv vw cv vv cv cop wceq vv wex vw wex vz cv cA cB cop
      wcel vz cv cvv cvv cxp wcel cA vx cv csn wceq cB vx cv vy cv cpr wceq wa
      vz cv cA csn wceq vz cv cA cB cpr wceq wo vz cv vw cv vv cv cop wceq vv
      wex vw wex cA vx cv csn wceq cB vx cv vy cv cpr wceq wa vz cv cA csn wceq
      vz cv vw cv vv cv cop wceq vv wex vw wex vz cv cA cB cpr wceq cA vx cv
      csn wceq vz cv cA csn wceq vz cv vw cv vv cv cop wceq vv wex vw wex cB vx
      cv vy cv cpr wceq cA vx cv csn wceq vz cv cA csn wceq wa vz cv vx cv vx
      cv cop wceq vz cv vw cv vv cv cop wceq vv wex vw wex cA vx cv csn wceq vz
      cv cA csn wceq wa vz cv cA csn vx cv vx cv cop cA vx cv csn wceq vz cv cA
      csn wceq pm3.27 cA vx cv csn wceq vx cv vx cv cop cA csn wceq vz cv cA
      csn wceq cA vx cv csn wceq vx cv vx cv wceq cA vx cv csn wceq wa vx cv vx
      cv cop cA csn wceq cA vx cv csn wceq vx cv vx cv wceq vx equid jctl vx cv
      vx cv cA vx visset vx visset relop.1 opeqsn sylibr adantr eqtr4d vz cv vw
      cv vv cv cop wceq vz cv vx cv vx cv cop wceq vw vv vx cv vx cv vx visset
      vx visset vw cv vx cv wceq vv cv vx cv wceq wa vw cv vv cv cop vx cv vx
      cv cop vz cv vw cv vv cv vx cv vx cv opeq12 eqeq2d cla42ev syl adantlr cA
      vx cv csn wceq cB vx cv vy cv cpr wceq wa vz cv cA cB cpr wceq wa vz cv
      vx cv vy cv cop wceq vz cv vw cv vv cv cop wceq vv wex vw wex cA vx cv
      csn wceq cB vx cv vy cv cpr wceq wa vz cv cA cB cpr wceq wa vz cv vx cv
      csn vx cv vy cv cpr cpr vx cv vy cv cop cA vx cv csn wceq cB vx cv vy cv
      cpr wceq wa vz cv cA cB cpr wceq vz cv vx cv csn vx cv vy cv cpr cpr wceq
      cA vx cv csn wceq cB vx cv vy cv cpr wceq wa cA cB cpr vx cv csn vx cv vy
      cv cpr cpr vz cv cA vx cv csn wceq cB vx cv vy cv cpr wceq cA cB cpr vx
      cv csn cB cpr vx cv csn vx cv vy cv cpr cpr cA vx cv csn cB preq1 cB vx
      cv vy cv cpr vx cv csn preq2 sylan9eq eqeq2d biimpa vx cv vy cv df-op
      syl6eqr vz cv vw cv vv cv cop wceq vz cv vx cv vy cv cop wceq vw vv vx cv
      vy cv vx visset vy visset vw cv vx cv wceq vv cv vy cv wceq wa vw cv vv
      cv cop vx cv vy cv cop vz cv vw cv vv cv vx cv vy cv opeq12 eqeq2d
      cla42ev syl jaodan ex vz cv cA cB vz visset elop vw vv vz cv elvv 3imtr4g
      ssrdv 19.23aivv impbii bitri $.
      $( [7-Jun-2008] $) $( [3-Jun-2008] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( For sets, the identity relation is the same as equality. $)
    ideqg $p |- ( B e. C -> ( A _I B <-> A = B ) ) $=
      cB cC wcel cA cB cid wbr cA cB wceq cA cvv wcel cB cvv wcel wa cB cC wcel
      cA cB cid wbr wa cA cvv wcel cB cvv wcel cA cB cid wbr cA cvv wcel cB cC
      wcel cA cB cid reli brrelexi adantl cB cC wcel cB cvv wcel cA cB cid wbr
      cB cC elisset adantr jca cB cC wcel cA cB wceq wa cA cvv wcel cB cvv wcel
      cB cC wcel cA cB wceq wa cA cC wcel cA cvv wcel cA cB wceq cA cC wcel cB
      cC wcel cA cB cC eleq1 biimparc cA cC elisset syl cB cC wcel cB cvv wcel
      cA cB wceq cB cC elisset adantr jca vx cv vy cv wceq cA vy cv wceq cA cB
      wceq vx vy cA cB cvv cvv cid vx cv cA vy cv eqeq1 vy cv cB cA eqeq2 vx vy
      df-id brabg pm5.21nd $.
      $( [31-May-2008] $) $( [30-Apr-2004] $)
  $}

  ${
    ideq.1 $e |- B e. _V $.
    $( For sets, the identity relation is the same as equality. $)
    ideq $p |- ( A _I B <-> A = B ) $=
      cB cvv wcel cA cB cid wbr cA cB wceq wb ideq.1 cA cB cvv ideqg ax-mp $.
      $( [1-Jun-2008] $) $( [13-Aug-1995] $)
  $}

  ${
    $d x A $.
    $( A set is identical to itself. $)
    ididg $p |- ( A e. B -> A _I A ) $=
      vx cv vx cv cid wbr cA cA cid wbr vx cA cB vx cv cA wceq vx cv vx cv cid
      wbr cA vx cv cid wbr cA cA cid wbr vx cv cA vx cv cid breq1 vx cv cA cA
      cid breq2 bitrd vx cv vx cv cid wbr vx cv vx cv wceq vx cv eqid vx cv vx
      cv vx visset ideq mpbir vtoclg $.
      $( [28-May-2008] $) $( [28-May-2008] $)
  $}

  $( The second member of an ordered pair of classes in a cross product
     exists when the order pair doesn't belong to ` _I ` . $)
  opelxpex2 $p |- ( <. A , B >. e. ( ( C X. D ) \ _I ) -> B e. _V ) $=
    cA cB cop cC cD cxp cid cdif wcel cA cB cop cC cD cxp wcel cA cB cop cid
    wcel wn wa cB cvv wcel cA cB cop cC cD cxp cid eldif cA cB cop cC cD cxp
    wcel cA cB cop cid wcel wn cB cvv wcel cA cB cop cC cD cxp wcel cB cvv wcel
    cA cB cop cid wcel cA cB cop cC cD cxp wcel cA cB cop cA cA cop wceq cA cB
    cop cid wcel cB cvv wcel wn cA cB cop cC cD cxp wcel cA cC wcel cA cB cop
    cA cA cop wceq cA cB cop cid wcel wi cA cB cC cD opelxp1 cA cB cop cA cA
    cop wceq cA cB cop cid wcel cA cA cop cid wcel cA cC wcel cA cB cop cA cA
    cop cid eleq1 cA cC wcel cA cA cid wbr cA cA cop cid wcel cA cC ididg cA cA
    cid df-br sylib syl5cbir syl cA cB opprc2 syl5 con1d imp sylbi $.
    $( [1-Jul-2008] $) $( [28-May-2008] $)

  $( Two ways of expressing set existence. $)
  issetid $p |- ( A e. _V <-> A _I _V ) $=
    cA cvv wcel cA cvv cid wbr cA cvv wcel cA cA cid wbr cA cvv cid wbr cA cvv
    wcel cA cA cid wbr cA cA wceq cA eqid cA cA cvv ideqg mpbiri cvv cvv wcel
    wn cA cvv cid wbr cA cA cid wbr wb vprc cA cvv cid brprc ax-mp sylibr cA
    cvv cid reli brrelexi impbii $.
    $( [16-Feb-2008] $) $( [16-Feb-2008] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Equality theorem for composition of two classes. $)
    coeq1 $p |- ( A = B -> ( A o. C ) = ( B o. C ) ) $=
      cA cB wceq vx cv vz cv cC wbr vz cv vy cv cA wbr wa vz wex vx vy copab vx
      cv vz cv cC wbr vz cv vy cv cB wbr wa vz wex vx vy copab cA cC ccom cB cC
      ccom cA cB wceq vx cv vz cv cC wbr vz cv vy cv cA wbr wa vz wex vx cv vz
      cv cC wbr vz cv vy cv cB wbr wa vz wex vx vy cA cB wceq vx cv vz cv cC
      wbr vz cv vy cv cA wbr wa vx cv vz cv cC wbr vz cv vy cv cB wbr wa vz cA
      cB wceq vz cv vy cv cA wbr vz cv vy cv cB wbr vx cv vz cv cC wbr vz cv vy
      cv cA cB breq anbi2d exbidv opabbidv vx vy vz cA cC df-co vx vy vz cB cC
      df-co 3eqtr4g $.
      $( [3-Jan-1997] $)

    $( Equality theorem for composition of two classes. $)
    coeq2 $p |- ( A = B -> ( C o. A ) = ( C o. B ) ) $=
      cA cB wceq vx cv vz cv cA wbr vz cv vy cv cC wbr wa vz wex vx vy copab vx
      cv vz cv cB wbr vz cv vy cv cC wbr wa vz wex vx vy copab cC cA ccom cC cB
      ccom cA cB wceq vx cv vz cv cA wbr vz cv vy cv cC wbr wa vz wex vx cv vz
      cv cB wbr vz cv vy cv cC wbr wa vz wex vx vy cA cB wceq vx cv vz cv cA
      wbr vz cv vy cv cC wbr wa vx cv vz cv cB wbr vz cv vy cv cC wbr wa vz cA
      cB wceq vx cv vz cv cA wbr vx cv vz cv cB wbr vz cv vy cv cC wbr vx cv vz
      cv cA cB breq anbi1d exbidv opabbidv vx vy vz cC cA df-co vx vy vz cC cB
      df-co 3eqtr4g $.
      $( [3-Jan-1997] $)
  $}

  ${
    coeq1i.1 $e |- A = B $.
    $( Equality inference for composition of two classes. $)
    coeq1i $p |- ( A o. C ) = ( B o. C ) $=
      cA cB wceq cA cC ccom cB cC ccom wceq coeq1i.1 cA cB cC coeq1 ax-mp $.
      $( [16-Nov-2000] $)

    $( Equality inference for composition of two classes. $)
    coeq2i $p |- ( C o. A ) = ( C o. B ) $=
      cA cB wceq cC cA ccom cC cB ccom wceq coeq1i.1 cA cB cC coeq2 ax-mp $.
      $( [16-Nov-2000] $)
  $}

  ${
    coeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for composition of two classes. $)
    coeq1d $p |- ( ph -> ( A o. C ) = ( B o. C ) ) $=
      wph cA cB wceq cA cC ccom cB cC ccom wceq coeq1d.1 cA cB cC coeq1 syl $.
      $( [16-Nov-2000] $)

    $( Equality deduction for composition of two classes. $)
    coeq2d $p |- ( ph -> ( C o. A ) = ( C o. B ) ) $=
      wph cA cB wceq cC cA ccom cC cB ccom wceq coeq1d.1 cA cB cC coeq2 syl $.
      $( [16-Nov-2000] $)
  $}

  ${
    $d y z w v A $.  $d y z w v B $.  $d x y z w v $.
    hbco.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbco.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for function value. $)
    hbco $p |- ( y e. ( A o. B ) -> A. x y e. ( A o. B ) ) $=
      vx vy cA cB ccom vz cv vv cv cB wbr vv cv vw cv cA wbr wa vv wex vz vw
      copab vz vw vv cA cB df-co vz cv vv cv cB wbr vv cv vw cv cA wbr wa vv
      wex vz vw vx vy vz cv vv cv cB wbr vv cv vw cv cA wbr wa vx vv vz cv vv
      cv cB wbr vv cv vw cv cA wbr vx vx vy vz cv vv cv cB vy cv vz cv wcel vx
      ax-17 hbco.2 vy cv vv cv wcel vx ax-17 hbbr vx vy vv cv vw cv cA vy cv vv
      cv wcel vx ax-17 hbco.1 vy cv vw cv wcel vx ax-17 hbbr hban hbex hbopab
      hbxfr $.
      $( [1-Sep-1999] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    opelco.1 $e |- A e. _V $.
    opelco.2 $e |- B e. _V $.
    $( Ordered pair membership in a composition. $)
    opelco $p |- ( <. A , B >. e. ( C o. D ) <-> E. x ( A D x /\ x C B ) ) $=
      cA cB cop cC cD ccom wcel cA cB cop vy cv vx cv cD wbr vx cv vz cv cC wbr
      wa vx wex vy vz copab wcel cA vx cv cD wbr vx cv cB cC wbr wa vx wex cC
      cD ccom vy cv vx cv cD wbr vx cv vz cv cC wbr wa vx wex vy vz copab cA cB
      cop vy vz vx cC cD df-co eleq2i vy cv vx cv cD wbr vx cv vz cv cC wbr wa
      vx wex cA vx cv cD wbr vx cv vz cv cC wbr wa vx wex cA vx cv cD wbr vx cv
      cB cC wbr wa vx wex vy vz cA cB opelco.1 opelco.2 vy cv cA wceq vy cv vx
      cv cD wbr vx cv vz cv cC wbr wa cA vx cv cD wbr vx cv vz cv cC wbr wa vx
      vy cv cA wceq vy cv vx cv cD wbr cA vx cv cD wbr vx cv vz cv cC wbr vy cv
      cA vx cv cD breq1 anbi1d exbidv vz cv cB wceq cA vx cv cD wbr vx cv vz cv
      cC wbr wa cA vx cv cD wbr vx cv cB cC wbr wa vx vz cv cB wceq vx cv vz cv
      cC wbr vx cv cB cC wbr cA vx cv cD wbr vz cv cB vx cv cC breq2 anbi2d
      exbidv opelopab bitri $.
      $( [27-Dec-1996] $)

    $( Binary relation on a composition. $)
    brco $p |- ( A ( C o. D ) B <-> E. x ( A D x /\ x C B ) ) $=
      cA cB cC cD ccom wbr cA cB cop cC cD ccom wcel cA vx cv cD wbr vx cv cB
      cC wbr wa vx wex cA cB cC cD ccom df-br vx cA cB cC cD opelco.1 opelco.2
      opelco bitri $.
      $( [22-Sep-2004] $) $( [21-Sep-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    $( Ordered pair membership in a composition. $)
    opelco2g $p |- ( ( A e. R /\ B e. S ) -> ( <. A , B >. e. ( C o. D ) <->
                   E. x ( <. A , x >. e. D /\ <. x , B >. e. C ) ) ) $=
      cA cR wcel cB cS wcel wa cA cB cop cC cD ccom wcel cA vx cv cD wbr vx cv
      cB cC wbr wa vx wex cA vx cv cop cD wcel vx cv cB cop cC wcel wa vx wex
      vy cv vz cv cop cC cD ccom wcel vy cv vx cv cD wbr vx cv vz cv cC wbr wa
      vx wex wb cA vz cv cop cC cD ccom wcel cA vx cv cD wbr vx cv vz cv cC wbr
      wa vx wex wb cA cB cop cC cD ccom wcel cA vx cv cD wbr vx cv cB cC wbr wa
      vx wex wb vy vz cA cB cR cS vy cv cA wceq vy cv vz cv cop cC cD ccom wcel
      cA vz cv cop cC cD ccom wcel vy cv vx cv cD wbr vx cv vz cv cC wbr wa vx
      wex cA vx cv cD wbr vx cv vz cv cC wbr wa vx wex vy cv cA wceq vy cv vz
      cv cop cA vz cv cop cC cD ccom vy cv cA vz cv opeq1 eleq1d vy cv cA wceq
      vy cv vx cv cD wbr vx cv vz cv cC wbr wa cA vx cv cD wbr vx cv vz cv cC
      wbr wa vx vy cv cA wceq vy cv vx cv cD wbr cA vx cv cD wbr vx cv vz cv cC
      wbr vy cv cA vx cv cD breq1 anbi1d exbidv bibi12d vz cv cB wceq cA vz cv
      cop cC cD ccom wcel cA cB cop cC cD ccom wcel cA vx cv cD wbr vx cv vz cv
      cC wbr wa vx wex cA vx cv cD wbr vx cv cB cC wbr wa vx wex vz cv cB wceq
      cA vz cv cop cA cB cop cC cD ccom vz cv cB cA opeq2 eleq1d vz cv cB wceq
      cA vx cv cD wbr vx cv vz cv cC wbr wa cA vx cv cD wbr vx cv cB cC wbr wa
      vx vz cv cB wceq vx cv vz cv cC wbr vx cv cB cC wbr cA vx cv cD wbr vz cv
      cB vx cv cC breq2 anbi2d exbidv bibi12d vx vy cv vz cv cC cD vy visset vz
      visset opelco vtocl2g cA vx cv cD wbr vx cv cB cC wbr wa cA vx cv cop cD
      wcel vx cv cB cop cC wcel wa vx cA vx cv cD wbr cA vx cv cop cD wcel vx
      cv cB cC wbr vx cv cB cop cC wcel cA vx cv cD df-br vx cv cB cC df-br
      anbi12i exbii syl6bb $.
      $( [27-Jan-1997] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Subset theorem for converse. $)
    cnvss $p |- ( A C_ B -> `' A C_ `' B ) $=
      cA cB wss vy cv vx cv cA wbr vx vy copab vy cv vx cv cB wbr vx vy copab
      cA ccnv cB ccnv cA cB wss vy cv vx cv cA wbr vy cv vx cv cB wbr wi vy wal
      vx wal vy cv vx cv cA wbr vx vy copab vy cv vx cv cB wbr vx vy copab wss
      cA cB wss vy cv vx cv cA wbr vy cv vx cv cB wbr wi vx vy cA cB wss vy cv
      vx cv cop cA wcel vy cv vx cv cop cB wcel vy cv vx cv cA wbr vy cv vx cv
      cB wbr cA cB vy cv vx cv cop ssel vy cv vx cv cA df-br vy cv vx cv cB
      df-br 3imtr4g 19.21aivv vy cv vx cv cA wbr vy cv vx cv cB wbr vx vy
      ssopab2 sylibr vx vy cA df-cnv vx vy cB df-cnv 3sstr4g $.
      $( [22-Mar-1998] $)
  $}

  $( Equality theorem for converse. $)
  cnveq $p |- ( A = B -> `' A = `' B ) $=
    cA cB wss cB cA wss wa cA ccnv cB ccnv wss cB ccnv cA ccnv wss wa cA cB
    wceq cA ccnv cB ccnv wceq cA cB wss cA ccnv cB ccnv wss cB cA wss cB ccnv
    cA ccnv wss cA cB cnvss cB cA cnvss anim12i cA cB eqss cA ccnv cB ccnv eqss
    3imtr4i $.
    $( [13-Aug-1995] $)

  ${
    cnveqi.1 $e |- A = B $.
    $( Equality theorem for converse. $)
    cnveqi $p |- `' A = `' B $=
      cA cB wceq cA ccnv cB ccnv wceq cnveqi.1 cA cB cnveq ax-mp $.
      $( [24-Dec-2008] $) $( [23-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d x y R $.
    $( Membership in a converse.  Equation 5 of [Suppes] p. 62. $)
    elcnv $p |- ( A e. `' R <-> E. x E. y ( A = <. x , y >. /\ y R x ) ) $=
      cA cR ccnv wcel cA vy cv vx cv cR wbr vx vy copab wcel cA vx cv vy cv cop
      wceq vy cv vx cv cR wbr wa vy wex vx wex cR ccnv vy cv vx cv cR wbr vx vy
      copab cA vx vy cR df-cnv eleq2i vy cv vx cv cR wbr vx vy cA elopab bitri
      $.
      $( [24-Mar-1998] $)

    $( Membership in a converse.  Equation 5 of [Suppes] p. 62. $)
    elcnv2 $p |- ( A e. `' R <->
                 E. x E. y ( A = <. x , y >. /\ <. y , x >. e. R ) ) $=
      cA cR ccnv wcel cA vx cv vy cv cop wceq vy cv vx cv cR wbr wa vy wex vx
      wex cA vx cv vy cv cop wceq vy cv vx cv cop cR wcel wa vy wex vx wex vx
      vy cA cR elcnv cA vx cv vy cv cop wceq vy cv vx cv cR wbr wa cA vx cv vy
      cv cop wceq vy cv vx cv cop cR wcel wa vx vy vy cv vx cv cR wbr vy cv vx
      cv cop cR wcel cA vx cv vy cv cop wceq vy cv vx cv cR df-br anbi2i 2exbii
      bitri $.
      $( [8-Sep-2004] $) $( [11-Aug-2004] $)
  $}

  ${
    $d y z w A $.  $d x y z w $.
    hbcnv.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for converse. $)
    hbcnv $p |- ( y e. `' A -> A. x y e. `' A ) $=
      vy cv vz cv vw cv cop wceq vw cv vz cv cA wbr wa vw wex vz wex vy cv vz
      cv vw cv cop wceq vw cv vz cv cA wbr wa vw wex vz wex vx wal vy cv cA
      ccnv wcel vy cv cA ccnv wcel vx wal vy cv vz cv vw cv cop wceq vw cv vz
      cv cA wbr wa vw wex vx vz vy cv vz cv vw cv cop wceq vw cv vz cv cA wbr
      wa vx vw vy cv vz cv vw cv cop wceq vw cv vz cv cA wbr vx vy cv vz cv vw
      cv cop wceq vx ax-17 vx vy vw cv vz cv cA vy cv vw cv wcel vx ax-17
      hbcnv.1 vy cv vz cv wcel vx ax-17 hbbr hban hbex hbex vz vw vy cv cA
      elcnv vy cv cA ccnv wcel vy cv vz cv vw cv cop wceq vw cv vz cv cA wbr wa
      vw wex vz wex vx vz vw vy cv cA elcnv albii 3imtr4i $.
      $( [31-Jan-2004] $) $( [31-Jan-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( Ordered-pair membership in converse. $)
    opelcnvg $p |- ( ( A e. C /\ B e. D ) ->
                     ( <. A , B >. e. `' R <-> <. B , A >. e. R ) ) $=
      cA cC wcel cB cD wcel wa cA cB cop cR ccnv wcel cB cA cR wbr cB cA cop cR
      wcel cA cC wcel cB cD wcel wa cA cB cop vy cv vx cv cR wbr vx vy copab
      wcel cB cA cR wbr cA cB cop cR ccnv wcel vy cv vx cv cR wbr vy cv cA cR
      wbr cB cA cR wbr vx vy cA cB cC cD vx cv cA vy cv cR breq2 vy cv cB cA cR
      breq1 opelopabg cR ccnv vy cv vx cv cR wbr vx vy copab cA cB cop vx vy cR
      df-cnv eleq2i syl5bb cB cA cR df-br syl6bb $.
      $( [13-May-1999] $)
  $}

  $( The converse of a binary relation swaps arguments.  Theorem 11 of [Suppes]
     p. 61. $)
  brcnvg $p |- ( ( A e. C /\ B e. D ) -> ( A `' R B <-> B R A ) ) $=
    cA cC wcel cB cD wcel wa cA cB cop cR ccnv wcel cB cA cop cR wcel cA cB cR
    ccnv wbr cB cA cR wbr cA cB cC cD cR opelcnvg cA cB cR ccnv df-br cB cA cR
    df-br 3bitr4g $.
    $( [11-Oct-2005] $) $( [10-Oct-2005] $)

  ${
    opelcnv.1 $e |- A e. _V $.
    opelcnv.2 $e |- B e. _V $.
    $( Ordered-pair membership in converse. $)
    opelcnv $p |- ( <. A , B >. e. `' R <-> <. B , A >. e. R ) $=
      cA cvv wcel cB cvv wcel cA cB cop cR ccnv wcel cB cA cop cR wcel wb
      opelcnv.1 opelcnv.2 cA cB cvv cvv cR opelcnvg mp2an $.
      $( [13-Aug-1995] $)

    $( The converse of a binary relation swaps arguments.  Theorem 11 of
       [Suppes] p. 61. $)
    brcnv $p |- ( A `' R B <-> B R A ) $=
      cA cvv wcel cB cvv wcel cA cB cR ccnv wbr cB cA cR wbr wb opelcnv.1
      opelcnv.2 cA cB cvv cvv cR brcnvg mp2an $.
      $( [13-Aug-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( Distributive law of converse over class composition.  Theorem 26 of
       [Suppes] p. 64. $)
    cnvco $p |- `' ( A o. B ) = ( `' B o. `' A ) $=
      vx cv vy cv cA cB ccom wbr vy vx copab vy cv vz cv cA ccnv wbr vz cv vx
      cv cB ccnv wbr wa vz wex vy vx copab cA cB ccom ccnv cB ccnv cA ccnv ccom
      vx cv vy cv cA cB ccom wbr vy cv vz cv cA ccnv wbr vz cv vx cv cB ccnv
      wbr wa vz wex vy vx vx cv vy cv cA cB ccom wbr vx cv vy cv cop cA cB ccom
      wcel vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vy cv vz cv cA ccnv
      wbr vz cv vx cv cB ccnv wbr wa vz wex vx cv vy cv cA cB ccom df-br vz vx
      cv vy cv cA cB vx visset vy visset opelco vx cv vz cv cB wbr vz cv vy cv
      cA wbr wa vy cv vz cv cA ccnv wbr vz cv vx cv cB ccnv wbr wa vz vx cv vz
      cv cB wbr vz cv vy cv cA wbr wa vz cv vy cv cA wbr vx cv vz cv cB wbr wa
      vy cv vz cv cA ccnv wbr vz cv vx cv cB ccnv wbr wa vx cv vz cv cB wbr vz
      cv vy cv cA wbr ancom vy cv vz cv cA ccnv wbr vz cv vy cv cA wbr vz cv vx
      cv cB ccnv wbr vx cv vz cv cB wbr vy cv vz cv cA vy visset vz visset
      brcnv vz cv vx cv cB vz visset vx visset brcnv anbi12i bitr4i exbii
      3bitri opabbii vy vx cA cB ccom df-cnv vy vx vz cB ccnv cA ccnv df-co
      3eqtr4i $.
      $( [19-Mar-1998] $)
  $}

  ${
    $d x y z w A $.
    $( The converse of a class union is the (indexed) union of the converses of
       its members. $)
    cnvuni $p |- `' U. A = U_ x e. A `' x $=
      vy cA cuni ccnv vx cA vx cv ccnv ciun vy cv cA cuni ccnv wcel vy cv vx cv
      ccnv wcel vx cA wrex vy cv vx cA vx cv ccnv ciun wcel vy cv cA cuni ccnv
      wcel vy cv vz cv vw cv cop wceq vw cv vz cv cop cA cuni wcel wa vw wex vz
      wex vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa vx cA wrex
      vw wex vz wex vy cv vx cv ccnv wcel vx cA wrex vz vw vy cv cA cuni elcnv2
      vy cv vz cv vw cv cop wceq vw cv vz cv cop cA cuni wcel wa vy cv vz cv vw
      cv cop wceq vw cv vz cv cop vx cv wcel wa vx cA wrex vz vw vy cv vz cv vw
      cv cop wceq vw cv vz cv cop cA cuni wcel wa vy cv vz cv vw cv cop wceq vw
      cv vz cv cop vx cv wcel vx cA wrex wa vy cv vz cv vw cv cop wceq vw cv vz
      cv cop vx cv wcel wa vx cA wrex vw cv vz cv cop cA cuni wcel vw cv vz cv
      cop vx cv wcel vx cA wrex vy cv vz cv vw cv cop wceq vx vw cv vz cv cop
      cA eluni2 anbi2i vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel vx
      cA r19.42v bitr4i 2exbii vy cv vx cv ccnv wcel vx cA wrex vy cv vz cv vw
      cv cop wceq vw cv vz cv cop vx cv wcel wa vw wex vz wex vx cA wrex vy cv
      vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa vw wex vx cA wrex vz
      wex vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa vx cA wrex
      vw wex vz wex vy cv vx cv ccnv wcel vy cv vz cv vw cv cop wceq vw cv vz
      cv cop vx cv wcel wa vw wex vz wex vx cA vz vw vy cv vx cv elcnv2 rexbii
      vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa vw wex vx vz cA
      rexcom4 vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa vw wex
      vx cA wrex vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa vx cA
      wrex vw wex vz vy cv vz cv vw cv cop wceq vw cv vz cv cop vx cv wcel wa
      vx vw cA rexcom4 exbii 3bitrri 3bitri vx vy cv cA vx cv ccnv eliun bitr4i
      eqriv $.
      $( [14-Sep-2004] $) $( [11-Aug-2004] $)
  $}

  ${
    $d x y A $.
    $( Alternate definition of domain.  Definition 6.5(1) of [TakeutiZaring]
       p. 24. $)
    dfdm3 $p |- dom A = { x | E. y <. x , y >. e. A } $=
      cA cdm vx cv vy cv cA wbr vy wex vx cab vx cv vy cv cop cA wcel vy wex vx
      cab vx vy cA df-dm vx cv vy cv cA wbr vy wex vx cv vy cv cop cA wcel vy
      wex vx vx cv vy cv cA wbr vx cv vy cv cop cA wcel vy vx cv vy cv cA df-br
      exbii abbii eqtri $.
      $( [28-Dec-1996] $)

    $( Alternate definition of range.  Definition 4 of [Suppes] p. 60. $)
    dfrn2 $p |- ran A = { y | E. x x A y } $=
      cA crn cA ccnv cdm vy cv vx cv cA ccnv wbr vx wex vy cab vx cv vy cv cA
      wbr vx wex vy cab cA df-rn vy vx cA ccnv df-dm vy cv vx cv cA ccnv wbr vx
      wex vx cv vy cv cA wbr vx wex vy vy cv vx cv cA ccnv wbr vx cv vy cv cA
      wbr vx vy cv vx cv cA vy visset vx visset brcnv exbii abbii 3eqtri $.
      $( [27-Dec-1996] $)

    $( Alternate definition of range.  Definition 6.5(2) of [TakeutiZaring]
       p. 24. $)
    dfrn3 $p |- ran A = { y | E. x <. x , y >. e. A } $=
      cA crn vx cv vy cv cA wbr vx wex vy cab vx cv vy cv cop cA wcel vx wex vy
      cab vx vy cA dfrn2 vx cv vy cv cA wbr vx wex vx cv vy cv cop cA wcel vx
      wex vy vx cv vy cv cA wbr vx cv vy cv cop cA wcel vx vx cv vy cv cA df-br
      exbii abbii eqtri $.
      $( [28-Dec-1996] $)
  $}

  ${
    $d x y A $.
    $( Alternate definition of domain. $)
    dfdm4 $p |- dom A = ran `' A $=
      vy cv vx cv cA ccnv wbr vy wex vx cab vx cv vy cv cA wbr vy wex vx cab cA
      ccnv crn cA cdm vy cv vx cv cA ccnv wbr vy wex vx cv vy cv cA wbr vy wex
      vx vy cv vx cv cA ccnv wbr vx cv vy cv cA wbr vy vy cv vx cv cA vy visset
      vx visset brcnv exbii abbii vy vx cA ccnv dfrn2 vx vy cA df-dm 3eqtr4ri
      $.
      $( [28-Dec-1996] $)
  $}

  ${
    $d x y z w v $.  $d z w v A $.
    dfdmf.1 $e |- ( z e. A -> A. x z e. A ) $.
    dfdmf.2 $e |- ( z e. A -> A. y z e. A ) $.
    $( Definition of domain, using bound-variable hypotheses instead of
       distinct variable conditions. $)
    dfdmf $p |- dom A = { x | E. y <. x , y >. e. A } $=
      cA cdm vw cv vv cv cop cA wcel vv wex vw cab vw cv vy cv cop cA wcel vy
      wex vw cab vx cv vy cv cop cA wcel vy wex vx cab vw vv cA dfdm3 vw cv vv
      cv cop cA wcel vv wex vw cv vy cv cop cA wcel vy wex vw vw cv vv cv cop
      cA wcel vw cv vy cv cop cA wcel vv vy vy vz vz vw cv vv cv cop cA vz cv
      vw cv vv cv cop wcel vy ax-17 dfdmf.2 hbel vw cv vy cv cop cA wcel vv
      ax-17 vv cv vy cv wceq vw cv vv cv cop vw cv vy cv cop cA vv cv vy cv vw
      cv opeq2 eleq1d cbvex abbii vw cv vy cv cop cA wcel vy wex vx cv vy cv
      cop cA wcel vy wex vw vx vw cv vy cv cop cA wcel vx vy vx vz vz vw cv vy
      cv cop cA vz cv vw cv vy cv cop wcel vx ax-17 dfdmf.1 hbel hbex vx cv vy
      cv cop cA wcel vy wex vw ax-17 vw cv vx cv wceq vw cv vy cv cop cA wcel
      vx cv vy cv cop cA wcel vy vw cv vx cv wceq vw cv vy cv cop vx cv vy cv
      cop cA vw cv vx cv vy cv opeq1 eleq1d exbidv cbvab 3eqtri $.
      $( [8-Mar-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    eldm.1 $e |- A e. _V $.
    $( Membership in a domain.  Theorem 4 of [Suppes] p. 59. $)
    eldm $p |- ( A e. dom B <-> E. y A B y ) $=
      vx cv vy cv cB wbr vy wex cA vy cv cB wbr vy wex vx cA cB cdm eldm.1 vx
      cv cA wceq vx cv vy cv cB wbr cA vy cv cB wbr vy vx cv cA vy cv cB breq1
      exbidv vx vy cB df-dm elab2 $.
      $( [5-Apr-2004] $) $( [2-Apr-2004] $)

    $( Membership in a domain.  Theorem 4 of [Suppes] p. 59. $)
    eldm2 $p |- ( A e. dom B <-> E. y <. A , y >. e. B ) $=
      cA cB cdm wcel cA vy cv cB wbr vy wex cA vy cv cop cB wcel vy wex vy cA
      cB eldm.1 eldm cA vy cv cB wbr cA vy cv cop cB wcel vy cA vy cv cB df-br
      exbii bitri $.
      $( [1-Aug-1994] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Domain membership.  Theorem 4 of [Suppes] p. 59. $)
    eldm2g $p |- ( A e. C -> ( A e. dom B <-> E. y <. A , y >. e. B ) ) $=
      vx cv cB cdm wcel vx cv vy cv cop cB wcel vy wex cA cB cdm wcel cA vy cv
      cop cB wcel vy wex vx cA cC vx cv cA cB cdm eleq1 vx cv cA wceq vx cv vy
      cv cop cB wcel cA vy cv cop cB wcel vy vx cv cA wceq vx cv vy cv cop cA
      vy cv cop cB vx cv cA vy cv opeq1 eleq1d exbidv vy vx cv cB vx visset
      eldm2 vtoclbg $.
      $( [27-Jan-1997] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Subset theorem for domain. $)
    dmss $p |- ( A C_ B -> dom A C_ dom B ) $=
      cA cB wss vx cA cdm cB cdm cA cB wss vx cv vy cv cop cA wcel vy wex vx cv
      vy cv cop cB wcel vy wex vx cv cA cdm wcel vx cv cB cdm wcel cA cB wss vx
      cv vy cv cop cA wcel vx cv vy cv cop cB wcel vy cA cB vx cv vy cv cop
      ssel 19.22dv vy vx cv cA vx visset eldm2 vy vx cv cB vx visset eldm2
      3imtr4g ssrdv $.
      $( [11-Aug-1994] $)
  $}

  $( Equality theorem for domain. $)
  dmeq $p |- ( A = B -> dom A = dom B ) $=
    cA cB wss cB cA wss wa cA cdm cB cdm wss cB cdm cA cdm wss wa cA cB wceq cA
    cdm cB cdm wceq cA cB wss cA cdm cB cdm wss cB cA wss cB cdm cA cdm wss cA
    cB dmss cB cA dmss anim12i cA cB eqss cA cdm cB cdm eqss 3imtr4i $.
    $( [11-Aug-1994] $)

  ${
    dmeqi.1 $e |- A = B $.
    $( Equality inference for domain. $)
    dmeqi $p |- dom A = dom B $=
      cA cB wceq cA cdm cB cdm wceq dmeqi.1 cA cB dmeq ax-mp $.
      $( [5-Mar-2004] $) $( [4-Mar-2004] $)
  $}

  ${
    dmeqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for domain. $)
    dmeqd $p |- ( ph -> dom A = dom B ) $=
      wph cA cB wceq cA cdm cB cdm wceq dmeqd.1 cA cB dmeq syl $.
      $( [5-Mar-2004] $) $( [4-Mar-2004] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.
    opeldm.1 $e |- A e. _V $.
    $( Membership of first of an ordered pair in a domain. $)
    opeldm $p |- ( <. A , B >. e. C -> A e. dom C ) $=
      cB cvv wcel cA cB cop cC wcel cA cC cdm wcel wi cB cvv wcel cA cB cop cC
      wcel cA vy cv cop cC wcel vy wex cA cC cdm wcel cA vy cv cop cC wcel cA
      cB cop cC wcel vy cB cvv vy cv cB wceq cA vy cv cop cA cB cop cC vy cv cB
      cA opeq2 eleq1d cla4egv vy cA cC opeldm.1 eldm2 syl6ibr cB cvv wcel wn cA
      cB cop cC wcel cA cA cop cC wcel cA cC cdm wcel cB cvv wcel wn cA cB cop
      cA cA cop cC cA cB opprc2 eleq1d cA cA cop cC wcel cA vy cv cop cC wcel
      vy wex cA cC cdm wcel cA vy cv cop cC wcel cA cA cop cC wcel vy cA
      opeldm.1 vy cv cA wceq cA vy cv cop cA cA cop cC vy cv cA cA opeq2 eleq1d
      cla4ev vy cA cC opeldm.1 eldm2 sylibr syl6bi pm2.61i $.
      $( [30-Jul-1995] $)
  $}

  ${
    breldm.1 $e |- A e. _V $.
    $( Membership of first of a binary relation in a domain. $)
    breldm $p |- ( A R B  -> A e. dom R ) $=
      cA cB cR wbr cA cB cop cR wcel cA cR cdm wcel cA cB cR df-br cA cB cR
      breldm.1 opeldm sylbi $.
      $( [30-Jul-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x R $.
    $( Membership of first of a binary relation in a domain. $)
    breldmg $p |- ( ( A e. C /\ A R B ) -> A e. dom R ) $=
      cA cC wcel cA cB cR wbr cA cR cdm wcel vx cv cB cR wbr vx cv cR cdm wcel
      wi cA cB cR wbr cA cR cdm wcel wi vx cA cC vx cv cA wceq vx cv cB cR wbr
      cA cB cR wbr vx cv cR cdm wcel cA cR cdm wcel vx cv cA cB cR breq1 vx cv
      cA cR cdm eleq1 imbi12d vx cv cB cR vx visset breldm vtoclg imp $.
      $( [23-Mar-2007] $) $( [21-Mar-2007] $)

    $( The domain of a union is the union of domains.  Exercise 56(a) of
       [Enderton] p. 65. $)
    dmun $p |- dom ( A u. B ) = ( dom A u. dom B ) $=
      vx cA cB cun cdm cA cdm cB cdm cun vx cv vy cv cop cA cB cun wcel vy wex
      vx cv vy cv cop cA wcel vy wex vx cv vy cv cop cB wcel vy wex wo vx cv cA
      cB cun cdm wcel vx cv cA cdm cB cdm cun wcel vx cv vy cv cop cA cB cun
      wcel vy wex vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wo vy wex vx
      cv vy cv cop cA wcel vy wex vx cv vy cv cop cB wcel vy wex wo vx cv vy cv
      cop cA cB cun wcel vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wo vy
      vx cv vy cv cop cA cB elun exbii vx cv vy cv cop cA wcel vx cv vy cv cop
      cB wcel vy 19.43 bitri vy vx cv cA cB cun vx visset eldm2 vx cv cA cdm cB
      cdm cun wcel vx cv cA cdm wcel vx cv cB cdm wcel wo vx cv vy cv cop cA
      wcel vy wex vx cv vy cv cop cB wcel vy wex wo vx cv cA cdm cB cdm elun vx
      cv cA cdm wcel vx cv vy cv cop cA wcel vy wex vx cv cB cdm wcel vx cv vy
      cv cop cB wcel vy wex vy vx cv cA vx visset eldm2 vy vx cv cB vx visset
      eldm2 orbi12i bitri 3bitr4i eqriv $.
      $( [12-Aug-1994] $)

    $( The domain of an intersection belong to the intersection of domains.
       Theorem 6 of [Suppes] p. 60. $)
    dmin $p |- dom ( A i^i B ) C_ ( dom A i^i dom B ) $=
      vx cA cB cin cdm cA cdm cB cdm cin vx cv vy cv cop cA wcel vx cv vy cv
      cop cB wcel wa vy wex vx cv vy cv cop cA wcel vy wex vx cv vy cv cop cB
      wcel vy wex wa vx cv cA cB cin cdm wcel vx cv cA cdm cB cdm cin wcel vx
      cv vy cv cop cA wcel vx cv vy cv cop cB wcel vy 19.40 vx cv cA cB cin cdm
      wcel vx cv vy cv cop cA cB cin wcel vy wex vx cv vy cv cop cA wcel vx cv
      vy cv cop cB wcel wa vy wex vy vx cv cA cB cin vx visset eldm2 vx cv vy
      cv cop cA cB cin wcel vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wa
      vy vx cv vy cv cop cA cB elin exbii bitri vx cv cA cdm cB cdm cin wcel vx
      cv cA cdm wcel vx cv cB cdm wcel wa vx cv vy cv cop cA wcel vy wex vx cv
      vy cv cop cB wcel vy wex wa vx cv cA cdm cB cdm elin vx cv cA cdm wcel vx
      cv vy cv cop cA wcel vy wex vx cv cB cdm wcel vx cv vy cv cop cB wcel vy
      wex vy vx cv cA vx visset eldm2 vy vx cv cB vx visset eldm2 anbi12i bitri
      3imtr4i ssriv $.
      $( [17-Sep-2004] $) $( [15-Sep-2004] $)

  $}

  ${
    $d x y z A $.
    $( The domain of a union.  Part of Exercise 8 of [Enderton] p. 41. $)
    dmuni $p |- dom U. A = U_ x e. A dom x $=
      vy cA cuni cdm vx cA vx cv cdm ciun vy cv vz cv cop cA cuni wcel vz wex
      vy cv vx cv cdm wcel vx cA wrex vy cv cA cuni cdm wcel vy cv vx cA vx cv
      cdm ciun wcel vy cv vz cv cop cA cuni wcel vz wex vx cv cA wcel vy cv vx
      cv cdm wcel wa vx wex vy cv vx cv cdm wcel vx cA wrex vy cv vz cv cop cA
      cuni wcel vz wex vy cv vz cv cop vx cv wcel vx cv cA wcel wa vx wex vz
      wex vy cv vz cv cop vx cv wcel vx cv cA wcel wa vz wex vx wex vx cv cA
      wcel vy cv vx cv cdm wcel wa vx wex vy cv vz cv cop cA cuni wcel vy cv vz
      cv cop vx cv wcel vx cv cA wcel wa vx wex vz vx vy cv vz cv cop cA eluni
      exbii vy cv vz cv cop vx cv wcel vx cv cA wcel wa vz vx excom vy cv vz cv
      cop vx cv wcel vx cv cA wcel wa vz wex vx cv cA wcel vy cv vx cv cdm wcel
      wa vx vy cv vz cv cop vx cv wcel vz wex vx cv cA wcel wa vx cv cA wcel vy
      cv vz cv cop vx cv wcel vz wex wa vy cv vz cv cop vx cv wcel vx cv cA
      wcel wa vz wex vx cv cA wcel vy cv vx cv cdm wcel wa vy cv vz cv cop vx
      cv wcel vz wex vx cv cA wcel ancom vy cv vz cv cop vx cv wcel vx cv cA
      wcel vz 19.41v vy cv vx cv cdm wcel vy cv vz cv cop vx cv wcel vz wex vx
      cv cA wcel vz vy cv vx cv vy visset eldm2 anbi2i 3bitr4i exbii 3bitri vy
      cv vx cv cdm wcel vx cA df-rex bitr4i vz vy cv cA cuni vy visset eldm2 vx
      vy cv cA vx cv cdm eliun 3bitr4i eqriv $.
      $( [13-Mar-2004] $) $( [3-Feb-2004] $)
  $}

  ${
    $d x y z $.  $d z ph $.
    $( The domain of a class of ordered pairs. $)
    dmopab $p |- dom { <. x , y >. | ph } = { x | E. y ph } $=
      wph vx vy copab cdm vx cv vy cv cop wph vx vy copab wcel vy wex vx cab
      wph vy wex vx cab vx vy vz wph vx vy copab wph vx vy vz hbopab1 wph vx vy
      vz hbopab2 dfdmf vx cv vy cv cop wph vx vy copab wcel vy wex wph vy wex
      vx vx cv vy cv cop wph vx vy copab wcel wph vy wph vx vy opabid exbii
      abbii eqtri $.
      $( [16-May-1995] $)
  $}

  ${
    $d x y A $.
    $( Upper bound for the domain of a restricted class of ordered pairs. $)
    dmopabss $p |- dom { <. x , y >. | ( x e. A /\ ph ) } C_ A $=
      vx cv cA wcel wph wa vx vy copab cdm vx cv cA wcel wph wa vy wex vx cab
      cA vx cv cA wcel wph wa vx vy dmopab vx cv cA wcel wph wa vy wex vx cab
      vx cv cA wcel wph vy wex wa vx cab cA vx cv cA wcel wph wa vy wex vx cv
      cA wcel wph vy wex wa vx vx cv cA wcel wph vy 19.42v abbii wph vy wex vx
      cA ssab2 eqsstri eqsstri $.
      $( [1-Feb-2004] $) $( [31-Jan-2004] $)
  $}

  ${
    $d x y A $.
    $( The domain of a restricted class of ordered pairs. $)
    dmopab3 $p |- ( A. x e. A E. y ph <->
               dom { <. x , y >. | ( x e. A /\ ph ) } = A ) $=
      wph vy wex vx cA wral vx cv cA wcel wph vy wex wi vx wal vx cv cA wcel vx
      cv cA wcel wph vy wex wa wb vx wal vx cv cA wcel wph wa vx vy copab cdm
      cA wceq wph vy wex vx cA df-ral vx cv cA wcel wph vy wex wi vx cv cA wcel
      vx cv cA wcel wph vy wex wa wb vx vx cv cA wcel wph vy wex pm4.71 albii
      vx cv cA wcel wph wa vx vy copab cdm cA wceq vx cv cA wcel wph vy wex wa
      vx cab cA wceq cA vx cv cA wcel wph vy wex wa vx cab wceq vx cv cA wcel
      vx cv cA wcel wph vy wex wa wb vx wal vx cv cA wcel wph wa vx vy copab
      cdm vx cv cA wcel wph vy wex wa vx cab cA vx cv cA wcel wph wa vx vy
      copab cdm vx cv cA wcel wph wa vy wex vx cab vx cv cA wcel wph vy wex wa
      vx cab vx cv cA wcel wph wa vx vy dmopab vx cv cA wcel wph wa vy wex vx
      cv cA wcel wph vy wex wa vx vx cv cA wcel wph vy 19.42v abbii eqtri
      eqeq1i cA vx cv cA wcel wph vy wex wa vx cab eqcom vx cv cA wcel wph vy
      wex wa vx cA abeq2 3bitr2ri 3bitri $.
      $( [1-Feb-2004] $) $( [31-Jan-2004] $)
  $}

  ${
    $d x y $.
    $( The domain of the empty set is empty.  Part of Theorem 3.8(v) of [Monk1]
       p. 36. $)
    dm0 $p |- dom (/) = (/) $=
      vx cv vy cv cop c0 wcel vy wex vx cab vx cv vx cv wceq wn vx cab c0 cdm
      c0 vx cv vy cv cop c0 wcel vy wex vx cv vx cv wceq wn vx vx cv vy cv cop
      c0 wcel vy wex vx cv vx cv wceq wn vx cv vy cv cop c0 wcel vy vx cv vy cv
      cop noel nex vx cv vx cv wceq vx cv eqid notnoti 2false abbii vx vy c0
      dfdm3 vx dfnul2 3eqtr4i $.
      $( [4-Jul-1994] $)

    $( The domain of the identity relation is the universe. $)
    dmi $p |- dom _I = _V $=
      vx cv vy cv cid wbr vy wex vx cab vx cv vx cv wceq vx cab cid cdm cvv vx
      cv vy cv cid wbr vy wex vx cv vx cv wceq vx vx cv vy cv cid wbr vy wex vx
      cv vx cv wceq vx cv vy cv cid wbr vy wex vy cv vx cv wceq vy wex vy vx
      a9e vx cv vy cv cid wbr vy cv vx cv wceq vy vx cv vy cv cid wbr vx cv vy
      cv wceq vy cv vx cv wceq vx cv vy cv vy visset ideq vx cv vy cv eqcom
      bitri exbii mpbir vx cv eqid 2th abbii vx vy cid df-dm vx df-v 3eqtr4i $.
      $( [30-Apr-1998] $)

    $( The domain of the universe is the universe. $)
    dmv $p |- dom _V = _V $=
      cvv cdm cvv cvv cdm ssv cvv cid cdm cvv cdm dmi cid cvv wss cid cdm cvv
      cdm wss cid ssv cid cvv dmss ax-mp eqsstr3i eqssi $.
      $( [8-Aug-2003] $)
  $}

  ${
    $d x y A $.
    $( An empty domain implies an empty range. $)
    dm0rn0 $p |- ( dom A = (/) <-> ran A = (/) ) $=
      vx cv vy cv cA wbr vy wex vx cab c0 wceq vx cv vy cv cA wbr vx wex vy cab
      c0 wceq cA cdm c0 wceq cA crn c0 wceq vx cv vy cv cA wbr vy wex vx cv c0
      wcel wb vx wal vx cv vy cv cA wbr vx wex vy cv c0 wcel wb vy wal vx cv vy
      cv cA wbr vy wex vx cab c0 wceq vx cv vy cv cA wbr vx wex vy cab c0 wceq
      vx cv vy cv cA wbr vy wex wn vx wal vx cv vy cv cA wbr vx wex wn vy wal
      vx cv vy cv cA wbr vy wex vx cv c0 wcel wb vx wal vx cv vy cv cA wbr vx
      wex vy cv c0 wcel wb vy wal vx cv vy cv cA wbr vy wex vx wex wn vx cv vy
      cv cA wbr vx wex vy wex wn vx cv vy cv cA wbr vy wex wn vx wal vx cv vy
      cv cA wbr vx wex wn vy wal vx cv vy cv cA wbr vy wex vx wex vx cv vy cv
      cA wbr vx wex vy wex vx cv vy cv cA wbr vx vy excom notbii vx cv vy cv cA
      wbr vy wex vx alnex vx cv vy cv cA wbr vx wex vy alnex 3bitr4i vx cv vy
      cv cA wbr vy wex wn vx cv vy cv cA wbr vy wex vx cv c0 wcel wb vx vx cv
      c0 wcel vx cv vy cv cA wbr vy wex vx cv noel nbn albii vx cv vy cv cA wbr
      vx wex wn vx cv vy cv cA wbr vx wex vy cv c0 wcel wb vy vy cv c0 wcel vx
      cv vy cv cA wbr vx wex vy cv noel nbn albii 3bitr3i vx cv vy cv cA wbr vy
      wex vx c0 abeq1 vx cv vy cv cA wbr vx wex vy c0 abeq1 3bitr4i cA cdm vx
      cv vy cv cA wbr vy wex vx cab c0 vx vy cA df-dm eqeq1i cA crn vx cv vy cv
      cA wbr vx wex vy cab c0 vx vy cA dfrn2 eqeq1i 3bitr4i $.
      $( [21-May-1998] $)

    $( A relation is empty iff its domain is empty. $)
    reldm0 $p |- ( Rel A -> ( A = (/) <-> dom A = (/) ) ) $=
      cA wrel cA c0 wceq vx cv vy cv cop cA wcel vx cv vy cv cop c0 wcel wb vy
      wal vx wal cA cdm c0 wceq cA wrel c0 wrel cA c0 wceq vx cv vy cv cop cA
      wcel vx cv vy cv cop c0 wcel wb vy wal vx wal wb rel0 vx vy cA c0 eqrel
      mpan2 cA cdm c0 wceq vx cv cA cdm wcel wn vx wal vx cv vy cv cop cA wcel
      vx cv vy cv cop c0 wcel wb vy wal vx wal vx cA cdm eq0 vx cv cA cdm wcel
      wn vx cv vy cv cop cA wcel vx cv vy cv cop c0 wcel wb vy wal vx vx cv cA
      cdm wcel wn vx cv vy cv cop cA wcel vy wex wn vx cv vy cv cop cA wcel wn
      vy wal vx cv vy cv cop cA wcel vx cv vy cv cop c0 wcel wb vy wal vx cv cA
      cdm wcel vx cv vy cv cop cA wcel vy wex vy vx cv cA vx visset eldm2
      notbii vx cv vy cv cop cA wcel vy alnex vx cv vy cv cop cA wcel wn vx cv
      vy cv cop cA wcel vx cv vy cv cop c0 wcel wb vy vx cv vy cv cop c0 wcel
      vx cv vy cv cop cA wcel vx cv vy cv cop noel nbn albii 3bitr2i albii
      bitr2i syl6bb $.
      $( [21-Sep-2004] $) $( [15-Sep-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The domain of a cross product.  Part of Theorem 3.13(x) of [Monk1]
       p. 37. $)
    dmxp $p |- ( B =/= (/) -> dom ( A X. B ) = A ) $=
      cB c0 wne vy cv cB wcel vy wex vx cA wral cA cB cxp cdm cA wceq cB c0 wne
      vy cv cB wcel vy wex vx cA cB c0 wne vy cv cB wcel vy wex vx cv cA wcel
      cB c0 wne vy cv cB wcel vy wex vy cB n0 biimpi a1d r19.21aiv vy cv cB
      wcel vy wex vx cA wral vx cv cA wcel vy cv cB wcel wa vx vy copab cdm cA
      wceq cA cB cxp cdm cA wceq vy cv cB wcel vx vy cA dmopab3 cA cB cxp cdm
      vx cv cA wcel vy cv cB wcel wa vx vy copab cdm cA cA cB cxp vx cv cA wcel
      vy cv cB wcel wa vx vy copab vx vy cA cB df-xp dmeqi eqeq1i bitr4i sylib
      $.
      $( [6-Apr-2007] $) $( [28-Jul-1995] $)
  $}

  $( The domain of a square cross product. $)
  dmxpid $p |- dom ( A X. A ) = A $=
    cA cA cxp cdm cA wceq cA c0 cA c0 wceq c0 cdm c0 cA cA cxp cdm cA dm0 cA c0
    wceq cA cA cxp c0 cA c0 wceq cA cA cxp c0 cA cxp c0 cA c0 cA xpeq1 cA xp0r
    syl6eq dmeqd cA c0 wceq id 3eqtr4a cA cA dmxp pm2.61ine $.
    $( [28-Jul-1995] $)

  $( The domain of the intersection of two square cross products.  Unlike
     ~ dmin , equality holds. $)
  dmxpin $p |- dom ( ( A X. A ) i^i ( B X. B ) ) = ( A i^i B ) $=
    cA cA cxp cB cB cxp cin cdm cA cB cin cA cB cin cxp cdm cA cB cin cA cA cxp
    cB cB cxp cin cA cB cin cA cB cin cxp cA cA cB cB inxp dmeqi cA cB cin
    dmxpid eqtri $.
    $( [5-Feb-2008] $) $( [29-Jan-2008] $)

  $( The cross product of a class with itself is one-to-one. $)
  xpid11 $p |- ( ( A X. A ) = ( B X. B ) <-> A = B ) $=
    cA cA cxp cB cB cxp wceq cA cB wceq cA cA cxp cB cB cxp wceq cA cA cxp cdm
    cB cB cxp cdm cA cB cA cA cxp cB cB cxp dmeq cA dmxpid cB dmxpid 3eqtr3g cA
    cB wceq cA cA cxp cB cA cxp cB cB cxp cA cB cA xpeq1 cA cB cB xpeq2 eqtrd
    impbii $.
    $( [5-Nov-2006] $) $( [5-Nov-2006] $)

  $( The domain of the double converse of a class (which doesn't have to be a
     relation as in ~ dfrel2 ). $)
  dmcnvcnv $p |- dom `' `' A = dom A $=
    cA cdm cA ccnv crn cA ccnv ccnv cdm cA dfdm4 cA ccnv df-rn eqtr2i $.
    $( [8-Apr-2007] $) $( [8-Apr-2007] $)

  $( The range of the double converse of a class. $)
  rncnvcnv $p |- ran `' `' A = ran A $=
    cA crn cA ccnv cdm cA ccnv ccnv crn cA df-rn cA ccnv dfdm4 eqtr2i $.
    $( [10-Jul-2007] $) $( [8-Apr-2007] $)

  ${
    $d x y A $.  $d x y B $.
    $( The first member of an ordered pair in a relation belongs to the
       domain of the relation. $)
    elreldm $p |- ( ( Rel A /\ B e. A ) -> |^| |^| B e. dom A ) $=
      cA wrel cB cA wcel cB cint cint cA cdm wcel cB cA wcel cA wrel cB vx cv
      vy cv cop wceq vy wex vx wex cB cint cint cA cdm wcel cA wrel cB cA wcel
      cB cvv cvv cxp wcel cB vx cv vy cv cop wceq vy wex vx wex cA wrel cA cvv
      cvv cxp wss cB cA wcel cB cvv cvv cxp wcel wi cA df-rel cA cvv cvv cxp cB
      ssel sylbi vx vy cB elvv syl6ib cB vx cv vy cv cop wceq cB cA wcel cB
      cint cint cA cdm wcel wi vx vy cB vx cv vy cv cop wceq cB cA wcel vx cv
      cA cdm wcel cB cint cint cA cdm wcel cB vx cv vy cv cop wceq cB cA wcel
      vx cv vy cv cop cA wcel vx cv cA cdm wcel cB vx cv vy cv cop cA eleq1 vx
      cv vy cv cA vx visset opeldm syl6bi cB vx cv vy cv cop wceq cB cint cint
      vx cv cA cdm cB vx cv vy cv cop wceq cB cint cint vx cv vy cv cop cint
      cint vx cv cB vx cv vy cv cop wceq cB cint vx cv vy cv cop cint cB vx cv
      vy cv cop inteq inteqd vx cv vy cv vx visset op1stb syl6eq eleq1d sylibrd
      19.23aivv syli imp $.
      $( [5-Aug-2004] $) $( [28-Jul-2004] $)
  $}

  $( Equality theorem for range. $)
  rneq $p |- ( A = B -> ran A = ran B ) $=
    cA cB wceq cA ccnv cdm cB ccnv cdm cA crn cB crn cA cB wceq cA ccnv cB ccnv
    cA cB cnveq dmeqd cA df-rn cB df-rn 3eqtr4g $.
    $( [29-Dec-1996] $)

  ${
    rneqi.1 $e |- A = B $.
    $( Equality inference for range. $)
    rneqi $p |- ran A = ran B $=
      cA cB wceq cA crn cB crn wceq rneqi.1 cA cB rneq ax-mp $.
      $( [5-Mar-2004] $) $( [4-Mar-2004] $)
  $}

  ${
    rneqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for range. $)
    rneqd $p |- ( ph -> ran A = ran B ) $=
      wph cA cB wceq cA crn cB crn wceq rneqd.1 cA cB rneq syl $.
      $( [5-Mar-2004] $) $( [4-Mar-2004] $)
  $}

  $( Subset theorem for range. $)
  rnss $p |- ( A C_ B -> ran A C_ ran B ) $=
    cA cB wss cA ccnv cdm cB ccnv cdm cA crn cB crn cA cB wss cA ccnv cB ccnv
    wss cA ccnv cdm cB ccnv cdm wss cA cB cnvss cA ccnv cB ccnv dmss syl cA
    df-rn cB df-rn 3sstr4g $.
    $( [22-Mar-1998] $)

  $( The second argument of a binary relation belongs to its range. $)
  brelrng $p |- ( ( A e. F /\ B e. G /\ A C B ) -> B e. ran C ) $=
    cA cF wcel cB cG wcel cA cB cC wbr w3a cB cC ccnv cdm cC crn cA cF wcel cB
    cG wcel cB cA cC ccnv wbr cB cC ccnv cdm wcel cA cB cC wbr cB cG wcel cB cA
    cC ccnv wbr cB cC ccnv cdm wcel cA cF wcel cB cA cG cC ccnv breldmg 3adant1
    cA cF wcel cB cG wcel cB cA cC ccnv wbr cA cB cC wbr cB cG wcel cA cF wcel
    cB cA cC ccnv wbr cA cB cC wbr wb cB cA cG cF cC brcnvg ancoms biimp3ar
    syld3an3 cC df-rn syl6eleqr $.
    $( [29-Jun-2008] $) $( [29-Jun-2008] $)

  ${
    brelrn.1 $e |- A e. _V $.
    brelrn.2 $e |- B e. _V $.
    $( The second argument of a binary relation belongs to its range. $)
    brelrn $p |- ( A C B -> B e. ran C ) $=
      cB cvv wcel cA cB cC wbr cB cC crn wcel brelrn.2 cA cvv wcel cB cvv wcel
      cA cB cC wbr cB cC crn wcel brelrn.1 cA cB cC cvv cvv brelrng mp3an1 mpan
      $.
      $( [29-Jun-2008] $) $( [13-Aug-2004] $)

    $( Membership of second member of an ordered pair in a range. $)
    opelrn $p |- ( <. A , B >. e. C -> B e. ran C ) $=
      cA cB cop cC wcel cA cB cC wbr cB cC crn wcel cA cB cC df-br cA cB cC
      brelrn.1 brelrn.2 brelrn sylbir $.
      $( [23-Feb-1997] $)
  $}

  $( The first argument of a binary relation belongs to its domain. $)
  releldm $p |- ( ( Rel R /\ A R B ) -> A e. dom R ) $=
    cR wrel cA cB cR wbr cA cvv wcel cA cR cdm wcel cA cB cR brrelex cA cB cvv
    cR breldmg sylancom $.
    $( [6-Jul-2008] $) $( [2-Jul-2008] $)

  $( The second argument of a binary relation belongs to its range. $)
  relelrng $p |- ( ( B e. C /\ Rel R /\ A R B ) -> B e. ran R ) $=
    cB cC wcel cA cvv wcel cA cB cR wbr cB cR crn wcel cR wrel cA cvv wcel cB
    cC wcel cA cB cR wbr cB cR crn wcel cA cB cR cvv cC brelrng 3com12 cR wrel
    cA cB cR wbr cA cvv wcel cB cC wcel cA cB cR brrelex 3adant1 syld3an2 $.
    $( [16-Jul-2008] $) $( [2-Jul-2008] $)

  ${
    $d x y z w v $.  $d z w v A $.
    dfrnf.1 $e |- ( z e. A -> A. x z e. A ) $.
    dfrnf.2 $e |- ( z e. A -> A. y z e. A ) $.
    $( Definition of range, using bound-variable hypotheses instead of distinct
       variable conditions. $)
    dfrnf $p |- ran A = { y | E. x <. x , y >. e. A } $=
      cA crn vv cv vw cv cop cA wcel vv wex vw cab vx cv vw cv cop cA wcel vx
      wex vw cab vx cv vy cv cop cA wcel vx wex vy cab vv vw cA dfrn3 vv cv vw
      cv cop cA wcel vv wex vx cv vw cv cop cA wcel vx wex vw vv cv vw cv cop
      cA wcel vx cv vw cv cop cA wcel vv vx vx vz vz vv cv vw cv cop cA vz cv
      vv cv vw cv cop wcel vx ax-17 dfrnf.1 hbel vx cv vw cv cop cA wcel vv
      ax-17 vv cv vx cv wceq vv cv vw cv cop vx cv vw cv cop cA vv cv vx cv vw
      cv opeq1 eleq1d cbvex abbii vx cv vw cv cop cA wcel vx wex vx cv vy cv
      cop cA wcel vx wex vw vy vx cv vw cv cop cA wcel vy vx vy vz vz vx cv vw
      cv cop cA vz cv vx cv vw cv cop wcel vy ax-17 dfrnf.2 hbel hbex vx cv vy
      cv cop cA wcel vx wex vw ax-17 vw cv vy cv wceq vx cv vw cv cop cA wcel
      vx cv vy cv cop cA wcel vx vw cv vy cv wceq vx cv vw cv cop vx cv vy cv
      cop cA vw cv vy cv vx cv opeq2 eleq1d exbidv cbvab 3eqtri $.
      $( [14-Aug-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    elrn.1 $e |- A e. _V $.
    $( Membership in a range. $)
    elrn2 $p |- ( A e. ran B <-> E. x <. x , A >. e. B ) $=
      vx cv vy cv cop cB wcel vx wex vx cv cA cop cB wcel vx wex vy cA cB crn
      elrn.1 vy cv cA wceq vx cv vy cv cop cB wcel vx cv cA cop cB wcel vx vy
      cv cA wceq vx cv vy cv cop vx cv cA cop cB vy cv cA vx cv opeq2 eleq1d
      exbidv vx vy cB dfrn3 elab2 $.
      $( [10-Jul-1994] $)

    $( Membership in a range. $)
    elrn $p |- ( A e. ran B <-> E. x x B A ) $=
      cA cB crn wcel vx cv cA cop cB wcel vx wex vx cv cA cB wbr vx wex vx cA
      cB elrn.1 elrn2 vx cv cA cB wbr vx cv cA cop cB wcel vx vx cv cA cB df-br
      exbii bitr4i $.
      $( [5-Apr-2004] $) $( [2-Apr-2004] $)
  $}

  ${
    $d x y z w $.  $d y z w A $.
    hbrn.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for range. $)
    hbrn $p |- ( y e. ran A -> A. x y e. ran A ) $=
      vz cv vy cv cop cA wcel vz wex vz cv vy cv cop cA wcel vz wex vx wal vy
      cv cA crn wcel vy cv cA crn wcel vx wal vz cv vy cv cop cA wcel vx vz vx
      vw vz vz cv vy cv cop cA vw cv vz cv vy cv cop wcel vx ax-17 vx vy vy vz
      cv cA vy cv vz cv wcel vx ax-17 hbrn.1 hbel hbel hbex vz vy cv cA vy
      visset elrn2 vy cv cA crn wcel vz cv vy cv cop cA wcel vz wex vx vz vy cv
      cA vy visset elrn2 albii 3imtr4i $.
      $( [1-Sep-1999] $)
  $}

  ${
    $d x y z w $.  $d y z w A $.
    hbdm.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for domain. $)
    hbdm $p |- ( y e. dom A -> A. x y e. dom A ) $=
      vx vy cA cdm cA ccnv crn cA dfdm4 vx vy cA ccnv vx vy cA hbdm.1 hbcnv
      hbrn hbxfr $.
      $( [31-Jan-2004] $) $( [30-Jan-2004] $)
  $}

  ${
    $d x y z $.  $d z ph $.
    $( The range of a class of ordered pairs. $)
    rnopab $p |- ran { <. x , y >. | ph } = { y | E. x ph } $=
      wph vx vy copab crn vx cv vy cv cop wph vx vy copab wcel vx wex vy cab
      wph vx wex vy cab vx vy vz wph vx vy copab wph vx vy vz hbopab1 wph vx vy
      vz hbopab2 dfrnf vx cv vy cv cop wph vx vy copab wcel vx wex wph vx wex
      vy vx cv vy cv cop wph vx vy copab wcel wph vx wph vx vy opabid exbii
      abbii eqtri $.
      $( [14-Aug-1995] $)
  $}

  ${
    $d x y $.
    $( The range of a function expressed as a class abstraction. $)
    rnopab2 $p |- ran { <. x , y >. | ( x e. A /\ y = B ) } =
                 { y | E. x e. A y = B } $=
      vx cv cA wcel vy cv cB wceq wa vx vy copab crn vx cv cA wcel vy cv cB
      wceq wa vx wex vy cab vy cv cB wceq vx cA wrex vy cab vx cv cA wcel vy cv
      cB wceq wa vx vy rnopab vy cv cB wceq vx cA wrex vx cv cA wcel vy cv cB
      wceq wa vx wex vy vy cv cB wceq vx cA df-rex abbii eqtr4i $.
      $( [25-Mar-2006] $) $( [23-Mar-2006] $)
  $}

  $( The range of the empty set is empty.  Part of Theorem 3.8(v) of [Monk1]
     p. 36. $)
  rn0 $p |- ran (/) = (/) $=
    c0 cdm c0 wceq c0 crn c0 wceq dm0 c0 dm0rn0 mpbi $.
    $( [4-Jul-1994] $)

  ${
    $d x y A $.
    $( A relation is empty iff its range is empty. $)
    relrn0 $p |- ( Rel A -> ( A = (/) <-> ran A = (/) ) ) $=
      cA wrel cA c0 wceq cA cdm c0 wceq cA crn c0 wceq cA reldm0 cA dm0rn0
      syl6bb $.
      $( [3-Oct-2004] $) $( [15-Sep-2004] $)

    $( The domain and range of a class are included in its double union. $)
    dmrnssfld $p |- ( dom A u. ran A ) C_ U. U. A $=
      cA cdm cA crn cA cuni cuni vx cA cdm cA cuni cuni vx cv cA cdm wcel vx cv
      vy cv cop cA wcel vy wex vx cv cA cuni cuni wcel vy vx cv cA vx visset
      eldm2 vx cv vy cv cop cA wcel vx cv cA cuni cuni wcel vy vx cv vy cv cop
      cA wcel vx cv vx cv vy cv cpr wcel vx cv cA cuni cuni wcel vx cv vy cv vx
      visset prid1 vx cv vy cv cop cA wcel vx cv vy cv cpr cA cuni cuni vx cv
      vx cv vy cv cop cA wcel vx cv vy cv cpr cA cuni wcel vx cv vy cv cpr cA
      cuni cuni wss vx cv vy cv cop cA wcel vx cv vy cv cop cuni cA cuni vx cv
      vy cv cpr vx cv vy cv cA uniopel vx cv vy cv uniop syl5eqelr vx cv vy cv
      cpr cA cuni elssuni syl sseld mpi 19.23aiv sylbi ssriv vy cA crn cA cuni
      cuni vy cv cA crn wcel vx cv vy cv cop cA wcel vx wex vy cv cA cuni cuni
      wcel vx vy cv cA vy visset elrn2 vx cv vy cv cop cA wcel vy cv cA cuni
      cuni wcel vx vx cv vy cv cop cA wcel vy cv vx cv vy cv cpr wcel vy cv cA
      cuni cuni wcel vx cv vy cv vy visset prid2 vx cv vy cv cop cA wcel vx cv
      vy cv cpr cA cuni cuni vy cv vx cv vy cv cop cA wcel vx cv vy cv cpr cA
      cuni wcel vx cv vy cv cpr cA cuni cuni wss vx cv vy cv cop cA wcel vx cv
      vy cv cop cuni cA cuni vx cv vy cv cpr vx cv vy cv cA uniopel vx cv vy cv
      uniop syl5eqelr vx cv vy cv cpr cA cuni elssuni syl sseld mpi 19.23aiv
      sylbi ssriv unssi $.
      $( [14-May-2008] $) $( [13-May-2008] $)
  $}

  $( The domain of a set is a set.  Corollary 6.8(2) of [TakeutiZaring]
     p. 26. $)
  dmexg $p |- ( A e. B -> dom A e. _V ) $=
    cA cB wcel cA cuni cvv wcel cA cuni cuni cvv wcel cA cdm cvv wcel cA cB
    uniexg cA cuni cvv uniexg cA cdm cA cuni cuni wss cA cuni cuni cvv wcel cA
    cdm cvv wcel cA cdm cA cdm cA crn cun cA cuni cuni cA cdm cA crn ssun1 cA
    dmrnssfld sstri cA cdm cA cuni cuni cvv ssexg mpan 3syl $.
    $( [7-Apr-1995] $)

  $( The range of a set is a set.  Corollary 6.8(3) of [TakeutiZaring] p. 26.
     Similar to Lemma 3D of [Enderton] p. 41. $)
  rnexg $p |- ( A e. B -> ran A e. _V ) $=
    cA cB wcel cA cuni cvv wcel cA cuni cuni cvv wcel cA crn cvv wcel cA cB
    uniexg cA cuni cvv uniexg cA crn cA cuni cuni wss cA cuni cuni cvv wcel cA
    crn cvv wcel cA crn cA cdm cA crn cun cA cuni cuni cA crn cA cdm ssun2 cA
    dmrnssfld sstri cA crn cA cuni cuni cvv ssexg mpan 3syl $.
    $( [31-Mar-1995] $)

  ${
    dmex.1 $e |- A e. _V $.
    $( The domain of a set is a set.  Corollary 6.8(2) of [TakeutiZaring]
       p. 26. $)
    dmex $p |- dom A e. _V $=
      cA cvv wcel cA cdm cvv wcel dmex.1 cA cvv dmexg ax-mp $.
      $( [7-Jul-2008] $) $( [7-Jul-2008] $)

    $( The range of a set is a set.  Corollary 6.8(3) of [TakeutiZaring] p. 26.
       Similar to Lemma 3D of [Enderton] p. 41. $)
    rnex $p |- ran A e. _V $=
      cA cvv wcel cA crn cvv wcel dmex.1 cA cvv rnexg ax-mp $.
      $( [23-Jul-2008] $) $( [7-Jul-2008] $)
  $}

  $( The identity function is a proper class.  This means, for example, that
     we cannot use it as a member of the class of continuous functions unless
     it is restricted to a set, as in ~ idcn . $)
  iprc $p |- -. _I e. _V $=
    cid cvv wcel cid cdm cvv wcel cid cdm cvv wcel cvv cvv wcel vprc cid cdm
    cvv cvv dmi eleq1i mtbir cid cvv dmexg mto $.
    $( [1-Jan-2007] $) $( [1-Jan-2007] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( Domain of a composition.  Theorem 21 of [Suppes] p. 63. $)
    dmcoss $p |- dom ( A o. B ) C_ dom B $=
      vx cv vy cv cA cB ccom wbr vy wex vx cab vx cv vz cv cB wbr vz wex vx cab
      cA cB ccom cdm cB cdm vx cv vy cv cA cB ccom wbr vy wex vx cv vz cv cB
      wbr vz wex vx vx cv vy cv cA cB ccom wbr vy wex vx cv vz cv cB wbr vz cv
      vy cv cA wbr wa vy wex vz wex vx cv vz cv cB wbr vz wex vx cv vy cv cA cB
      ccom wbr vy wex vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vy wex vx
      cv vz cv cB wbr vz cv vy cv cA wbr wa vy wex vz wex vx cv vy cv cA cB
      ccom wbr vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vy vx cv vy cv
      cA cB ccom wbr vx cv vy cv cop cA cB ccom wcel vx cv vz cv cB wbr vz cv
      vy cv cA wbr wa vz wex vx cv vy cv cA cB ccom df-br vz vx cv vy cv cA cB
      vx visset vy visset opelco bitri exbii vx cv vz cv cB wbr vz cv vy cv cA
      wbr wa vy vz excom bitri vx cv vz cv cB wbr vz cv vy cv cA wbr wa vy wex
      vx cv vz cv cB wbr vz vx cv vz cv cB wbr vz cv vy cv cA wbr wa vy wex vx
      cv vz cv cB wbr vz cv vy cv cA wbr vy wex vx cv vz cv cB wbr vz cv vy cv
      cA wbr vy 19.42v pm3.26bi 19.22i sylbi ss2abi vx vy cA cB ccom df-dm vx
      vz cB df-dm 3sstr4i $.
      $( [19-Mar-1998] $)
  $}

  $( Range of a composition. $)
  rncoss $p |- ran ( A o. B ) C_ ran A $=
    cB ccnv cA ccnv ccom cdm cA ccnv cdm cA cB ccom crn cA crn cB ccnv cA ccnv
    dmcoss cA cB ccom crn cA cB ccom ccnv cdm cB ccnv cA ccnv ccom cdm cA cB
    ccom df-rn cA cB ccom ccnv cB ccnv cA ccnv ccom cA cB cnvco dmeqi eqtri cA
    df-rn 3sstr4i $.
    $( [19-Mar-1998] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( Domain of a composition. $)
    dmcosseq $p |- ( ran B C_ dom A -> dom ( A o. B ) = dom B ) $=
      vz cv cB crn wcel vz cv cA cdm wcel wi vz wal vx cv cA cB ccom cdm wcel
      vx cv cB cdm wcel wb vx wal cB crn cA cdm wss cA cB ccom cdm cB cdm wceq
      vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr vy wex wi vz wal vx cv vz cv
      cB wbr vz cv vy cv cA wbr vy wex wa vz wex vx cv vz cv cB wbr vz wex wb
      vx wal vz cv cB crn wcel vz cv cA cdm wcel wi vz wal vx cv cA cB ccom cdm
      wcel vx cv cB cdm wcel wb vx wal vx cv vz cv cB wbr vx wex vz cv vy cv cA
      wbr vy wex wi vz wal vx cv vz cv cB wbr vz cv vy cv cA wbr vy wex wa vz
      wex vx cv vz cv cB wbr vz wex wi vx wal vx cv vz cv cB wbr vz wex vx cv
      vz cv cB wbr vz cv vy cv cA wbr vy wex wa vz wex wi vx wal wa vx cv vz cv
      cB wbr vz cv vy cv cA wbr vy wex wa vz wex vx cv vz cv cB wbr vz wex wb
      vx wal vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr vy wex wi vz wal vx
      cv vz cv cB wbr vz wex vx cv vz cv cB wbr vz cv vy cv cA wbr vy wex wa vz
      wex wi vx wal vx cv vz cv cB wbr vz cv vy cv cA wbr vy wex wa vz wex vx
      cv vz cv cB wbr vz wex wi vx wal vx cv vz cv cB wbr vx wex vz cv vy cv cA
      wbr vy wex wi vz wal vx cv vz cv cB wbr vz wex vx cv vz cv cB wbr vz cv
      vy cv cA wbr vy wex wa vz wex wi vx vx cv vz cv cB wbr vx wex vz cv vy cv
      cA wbr vy wex wi vx vz vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr vy
      wex vx vx cv vz cv cB wbr vx hbe1 vz cv vy cv cA wbr vy wex vx ax-17 hbim
      hbal vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr vy wex wi vz wal vx cv
      vz cv cB wbr vx cv vz cv cB wbr vz cv vy cv cA wbr vy wex wa vz vx cv vz
      cv cB wbr vx wex vz cv vy cv cA wbr vy wex wi vz hba1 vx cv vz cv cB wbr
      vx wex vz cv vy cv cA wbr vy wex wi vx cv vz cv cB wbr vx cv vz cv cB wbr
      vz cv vy cv cA wbr vy wex wa wi vz vx cv vz cv cB wbr vx wex vz cv vy cv
      cA wbr vy wex wi vx cv vz cv cB wbr vz cv vy cv cA wbr vy wex vx cv vz cv
      cB wbr vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr vy wex vx cv vz cv cB
      wbr vx 19.8a imim1i ancld a4s 19.22d 19.21ai vx cv vz cv cB wbr vz cv vy
      cv cA wbr vy wex wa vz wex vx cv vz cv cB wbr vz wex wi vx vx cv vz cv cB
      wbr vz cv vy cv cA wbr vy wex wa vx cv vz cv cB wbr vz vx cv vz cv cB wbr
      vz cv vy cv cA wbr vy wex pm3.26 19.22i ax-gen jctil vx cv vz cv cB wbr
      vz cv vy cv cA wbr vy wex wa vz wex vx cv vz cv cB wbr vz wex vx albi
      sylibr vz cv cB crn wcel vz cv cA cdm wcel wi vx cv vz cv cB wbr vx wex
      vz cv vy cv cA wbr vy wex wi vz vz cv cB crn wcel vx cv vz cv cB wbr vx
      wex vz cv cA cdm wcel vz cv vy cv cA wbr vy wex vx vz cv cB vz visset
      elrn vy vz cv cA vz visset eldm imbi12i albii vx cv cA cB ccom cdm wcel
      vx cv cB cdm wcel wb vx cv vz cv cB wbr vz cv vy cv cA wbr vy wex wa vz
      wex vx cv vz cv cB wbr vz wex wb vx vx cv cA cB ccom cdm wcel vx cv vz cv
      cB wbr vz cv vy cv cA wbr vy wex wa vz wex vx cv cB cdm wcel vx cv vz cv
      cB wbr vz wex vx cv cA cB ccom cdm wcel vx cv vy cv cop cA cB ccom wcel
      vy wex vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vy wex vx cv vz cv
      cB wbr vz cv vy cv cA wbr vy wex wa vz wex vy vx cv cA cB ccom vx visset
      eldm2 vx cv vy cv cop cA cB ccom wcel vx cv vz cv cB wbr vz cv vy cv cA
      wbr wa vz wex vy vz vx cv vy cv cA cB vx visset vy visset opelco exbii vx
      cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vy wex vx cv vz cv cB wbr vz
      cv vy cv cA wbr wa vy wex vz wex vx cv vz cv cB wbr vz cv vy cv cA wbr vy
      wex wa vz wex vx cv vz cv cB wbr vz cv vy cv cA wbr wa vy vz excom vx cv
      vz cv cB wbr vz cv vy cv cA wbr wa vy wex vx cv vz cv cB wbr vz cv vy cv
      cA wbr vy wex wa vz vx cv vz cv cB wbr vz cv vy cv cA wbr vy 19.42v exbii
      bitri 3bitri vz vx cv cB vx visset eldm bibi12i albii 3imtr4i vz cB crn
      cA cdm dfss2 vx cA cB ccom cdm cB cdm dfcleq 3imtr4i $.
      $( [28-May-1998] $)

    $( Domain of a composition. $)
    dmcoeq $p |- ( dom A = ran B -> dom ( A o. B ) = dom B ) $=
      cA cdm cB crn wceq cB crn cA cdm wss cA cB ccom cdm cB cdm wceq cB crn cA
      cdm eqimss2 cA cB dmcosseq syl $.
      $( [19-Mar-1998] $)
  $}

  $( Range of a composition. $)
  rncoeq $p |- ( dom A = ran B -> ran ( A o. B ) = ran A ) $=
    cB ccnv cdm cA ccnv crn wceq cB ccnv cA ccnv ccom cdm cA ccnv cdm wceq cA
    cdm cB crn wceq cA cB ccom crn cA crn wceq cB ccnv cA ccnv dmcoeq cA cdm cB
    crn wceq cB crn cA cdm wceq cB ccnv cdm cA ccnv crn wceq cA cdm cB crn
    eqcom cB crn cB ccnv cdm cA cdm cA ccnv crn cB df-rn cA dfdm4 eqeq12i bitri
    cA cB ccom crn cB ccnv cA ccnv ccom cdm cA crn cA ccnv cdm cA cB ccom crn
    cA cB ccom ccnv cdm cB ccnv cA ccnv ccom cdm cA cB ccom df-rn cA cB ccom
    ccnv cB ccnv cA ccnv ccom cA cB cnvco dmeqi eqtri cA df-rn eqeq12i 3imtr4i
    $.
    $( [19-Mar-1998] $)

  $( Equality theorem for restrictions. $)
  reseq1 $p |- ( A = B -> ( A |` C ) = ( B |` C ) ) $=
    cA cB wceq cA cC cvv cxp cin cB cC cvv cxp cin cA cC cres cB cC cres cA cB
    cC cvv cxp ineq1 cA cC df-res cB cC df-res 3eqtr4g $.
    $( [7-Aug-1994] $)

  $( Equality theorem for restrictions. $)
  reseq2 $p |- ( A = B -> ( C |` A ) = ( C |` B ) ) $=
    cA cB wceq cC cA cvv cxp cin cC cB cvv cxp cin cC cA cres cC cB cres cA cB
    wceq cA cvv cxp cB cvv cxp cC cA cB cvv xpeq1 ineq2d cC cA df-res cC cB
    df-res 3eqtr4g $.
    $( [8-Aug-1994] $)

  ${
    $d y A $.  $d y B $.  $d x y $.
    hbres.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbres.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for restriction. $)
    hbres $p |- ( y e. ( A |` B ) -> A. x y e. ( A |` B ) ) $=
      vx vy cA cB cres cA cB cvv cxp cin cA cB df-res vx vy cA cB cvv cxp
      hbres.1 vx vy cB cvv hbres.2 vy cv cvv wcel vx ax-17 hbxp hbin hbxfr $.
      $( [15-Sep-2003] $)
  $}

  $( A restriction to the empty set is empty. $)
  res0 $p |- ( A |` (/) ) = (/) $=
    cA c0 cres cA c0 cvv cxp cin cA c0 cin c0 cA c0 df-res c0 cvv cxp c0 cA cvv
    xp0r ineq2i cA in0 3eqtri $.
    $( [12-Nov-1994] $)

  ${
    opelres.1 $e |- B e. _V $.
    $( Ordered pair membership in a restriction.  Exercise 13 of
       [TakeutiZaring] p. 25. $)
    opelres $p |- ( <. A , B >. e. ( C |` D ) <->
                    ( <. A , B >. e. C /\ A e. D ) ) $=
      cA cB cop cC cD cres wcel cA cB cop cC cD cvv cxp cin wcel cA cB cop cC
      wcel cA cB cop cD cvv cxp wcel wa cA cB cop cC wcel cA cD wcel wa cC cD
      cres cC cD cvv cxp cin cA cB cop cC cD df-res eleq2i cA cB cop cC cD cvv
      cxp elin cA cB cop cD cvv cxp wcel cA cD wcel cA cB cop cC wcel cA cB cop
      cD cvv cxp wcel cA cD wcel cB cvv wcel cA cB cD cvv opelres.1 opelxp
      opelres.1 mpbiran2 anbi2i 3bitri $.
      $( [13-Nov-1995] $)

    $( Binary relation on a restriction. $)
    brres $p |- ( A ( C |` D ) B <-> ( A C B /\ A e. D ) ) $=
      cA cB cop cC cD cres wcel cA cB cop cC wcel cA cD wcel wa cA cB cC cD
      cres wbr cA cB cC wbr cA cD wcel wa cA cB cC cD opelres.1 opelres cA cB
      cC cD cres df-br cA cB cC wbr cA cB cop cC wcel cA cD wcel cA cB cC df-br
      anbi1i 3bitr4i $.
      $( [16-Dec-2006] $) $( [12-Dec-2006] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d y D $.
    $( Ordered pair membership in a restriction.  Exercise 13 of
       [TakeutiZaring] p. 25. $)
    opelresg $p |- ( B e. R -> ( <. A , B >. e. ( C |` D ) <->
                    ( <. A , B >. e. C /\ A e. D ) ) ) $=
      cA vy cv cop cC cD cres wcel cA vy cv cop cC wcel cA cD wcel wa cA cB cop
      cC cD cres wcel cA cB cop cC wcel cA cD wcel wa vy cB cR vy cv cB wceq cA
      vy cv cop cA cB cop cC cD cres vy cv cB cA opeq2 eleq1d vy cv cB wceq cA
      vy cv cop cC wcel cA cB cop cC wcel cA cD wcel vy cv cB wceq cA vy cv cop
      cA cB cop cC vy cv cB cA opeq2 eleq1d anbi1d cA vy cv cC cD vy visset
      opelres vtoclbg $.
      $( [31-Dec-2005] $) $( [14-Oct-2005] $)
  $}

  ${
    opres.1 $e |- B e. _V $.
    $( Ordered pair membership in a restriction when the first member belongs
       to the restricting class. $)
    opres $p |- ( A e. D ->
                    ( <. A , B >. e. ( C |` D ) <-> <. A , B >. e. C ) ) $=
      cA cD wcel cA cB cop cC cD cres wcel cA cB cop cC wcel cA cB cop cC cD
      cres wcel cA cB cop cC wcel cA cD wcel cA cB cC cD opres.1 opelres
      pm3.26bi cA cB cop cC wcel cA cD wcel cA cB cop cC cD cres wcel cA cB cop
      cC cD cres wcel cA cB cop cC wcel cA cD wcel wa cA cB cC cD opres.1
      opelres biimpri expcom impbid2 $.
      $( [2-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( A restricted identity relation is equivalent to equality in its
       domain. $)
    resieq $p |- ( ( B e. A /\ C e. A ) -> ( B ( _I |` A ) C <-> B = C ) ) $=
      cC cA wcel cB cA wcel cB cC cid cA cres wbr cB cC wceq wb cB cA wcel cB
      vx cv cid cA cres wbr cB vx cv wceq wb wi cB cA wcel cB cC cid cA cres
      wbr cB cC wceq wb wi vx cC cA vx cv cC wceq cB vx cv cid cA cres wbr cB
      vx cv wceq wb cB cC cid cA cres wbr cB cC wceq wb cB cA wcel vx cv cC
      wceq cB vx cv cid cA cres wbr cB cC cid cA cres wbr cB vx cv wceq cB cC
      wceq vx cv cC cB cid cA cres breq2 vx cv cC cB eqeq2 bibi12d imbi2d cB cA
      wcel cB vx cv cop cid cA cres wcel cB vx cv cop cid wcel cB vx cv cid cA
      cres wbr cB vx cv wceq cB vx cv cid cA vx visset opres cB vx cv cid cA
      cres df-br cB vx cv wceq cB vx cv cid wbr cB vx cv cop cid wcel cB vx cv
      vx visset ideq cB vx cv cid df-br bitr3i 3bitr4g vtoclg impcom $.
      $( [14-May-2004] $) $( [30-Apr-2004] $)
  $}

  $( The restriction of a restriction. $)
  resres $p |- ( ( A |` B ) |` C ) = ( A |` ( B i^i C ) ) $=
    cA cB cres cC cres cA cB cres cC cvv cxp cin cA cB cvv cxp cin cC cvv cxp
    cin cA cB cC cin cres cA cB cres cC df-res cA cB cres cA cB cvv cxp cin cC
    cvv cxp cA cB df-res ineq1i cA cB cC cin cvv cxp cin cA cB cvv cxp cC cvv
    cxp cin cin cA cB cC cin cres cA cB cvv cxp cin cC cvv cxp cin cB cC cin
    cvv cxp cB cvv cxp cC cvv cxp cin cA cB cC cvv xpindir ineq2i cA cB cC cin
    df-res cA cB cvv cxp cC cvv cxp inass 3eqtr4ri 3eqtri $.
    $( [28-Mar-2008] $) $( [27-Mar-2008] $)

  $( Distributive law for restriction over union.  Theorem 31 of [Suppes]
     p. 65. $)
  resundi $p |- ( A |` ( B u. C ) ) = ( ( A |` B ) u. ( A |` C ) ) $=
    cA cB cC cun cvv cxp cin cA cB cvv cxp cin cA cC cvv cxp cin cun cA cB cC
    cun cres cA cB cres cA cC cres cun cA cB cC cun cvv cxp cin cA cB cvv cxp
    cC cvv cxp cun cin cA cB cvv cxp cin cA cC cvv cxp cin cun cB cC cun cvv
    cxp cB cvv cxp cC cvv cxp cun cA cB cC cvv xpundir ineq2i cA cB cvv cxp cC
    cvv cxp indi eqtri cA cB cC cun df-res cA cB cres cA cB cvv cxp cin cA cC
    cres cA cC cvv cxp cin cA cB df-res cA cC df-res uneq12i 3eqtr4i $.
    $( [30-Sep-2002] $)

  $( Distributive law for restriction over union. $)
  resundir $p |- ( ( A u. B ) |` C ) = ( ( A |` C ) u. ( B |` C ) ) $=
    cA cB cun cC cvv cxp cin cA cC cvv cxp cin cB cC cvv cxp cin cun cA cB cun
    cC cres cA cC cres cB cC cres cun cA cB cC cvv cxp indir cA cB cun cC
    df-res cA cC cres cA cC cvv cxp cin cB cC cres cB cC cvv cxp cin cA cC
    df-res cB cC df-res uneq12i 3eqtr4i $.
    $( [17-Oct-2004] $) $( [23-Sep-2004] $)

  $( Class restriction distributes over intersection.  (Contributed by FL,
     6-Oct-2008.) $)
  resindi $p |- ( A |` ( B i^i C ) ) = ( ( A |` B ) i^i ( A |` C ) ) $=
    cA cB cC cin cvv cxp cin cA cB cvv cxp cin cA cC cvv cxp cin cin cA cB cC
    cin cres cA cB cres cA cC cres cin cA cB cC cin cvv cxp cin cA cB cvv cxp
    cC cvv cxp cin cin cA cB cvv cxp cin cA cC cvv cxp cin cin cB cC cin cvv
    cxp cB cvv cxp cC cvv cxp cin cA cB cC cvv xpindir ineq2i cA cB cvv cxp cC
    cvv cxp inindi eqtri cA cB cC cin df-res cA cB cres cA cB cvv cxp cin cA cC
    cres cA cC cvv cxp cin cA cB df-res cA cC df-res ineq12i 3eqtr4i $.
    $( [28-Jan-2009] $) $( [6-Oct-2008] $)

  $( Class restriction distributes over intersection. $)
  resindir $p |- ( ( A i^i B ) |` C ) = ( ( A |` C ) i^i ( B |` C ) ) $=
    cA cB cin cC cvv cxp cin cA cC cvv cxp cin cB cC cvv cxp cin cin cA cB cin
    cC cres cA cC cres cB cC cres cin cA cB cC cvv cxp inindir cA cB cin cC
    df-res cA cC cres cA cC cvv cxp cin cB cC cres cB cC cvv cxp cin cA cC
    df-res cB cC df-res ineq12i 3eqtr4i $.
    $( [14-Jan-2009] $) $( [18-Dec-2008] $)

  $( Move intersection into class restriction. $)
  inres $p |- ( A i^i ( B |` C ) ) = ( ( A i^i B ) |` C ) $=
    cA cB cin cC cvv cxp cin cA cB cC cvv cxp cin cin cA cB cin cC cres cA cB
    cC cres cin cA cB cC cvv cxp inass cA cB cin cC df-res cB cC cres cB cC cvv
    cxp cin cA cB cC df-res ineq2i 3eqtr4ri $.
    $( [20-Jan-2009] $) $( [18-Dec-2008] $)

  ${
    $d x y A $.  $d x y B $.
    $( The domain of a restriction.  Exercise 14 of [TakeutiZaring]
       p. 25. $)
    dmres $p |- dom ( A |` B ) = ( B i^i dom A ) $=
      cA cdm cB cin cA cB cres cdm cB cA cdm cin vx cA cdm cB cA cB cres cdm vx
      cv vy cv cop cA cB cres wcel vy wex vx cv vy cv cop cA wcel vx cv cB wcel
      wa vy wex vx cv cA cB cres cdm wcel vx cv cA cdm wcel vx cv cB wcel wa vx
      cv vy cv cop cA cB cres wcel vx cv vy cv cop cA wcel vx cv cB wcel wa vy
      vx cv vy cv cA cB vy visset opelres exbii vy vx cv cA cB cres vx visset
      eldm2 vx cv cA cdm wcel vx cv cB wcel wa vx cv vy cv cop cA wcel vy wex
      vx cv cB wcel wa vx cv vy cv cop cA wcel vx cv cB wcel wa vy wex vx cv cA
      cdm wcel vx cv vy cv cop cA wcel vy wex vx cv cB wcel vy vx cv cA vx
      visset eldm2 anbi1i vx cv vy cv cop cA wcel vx cv cB wcel vy 19.41v
      bitr4i 3bitr4ri ineqri cA cdm cB incom eqtr3i $.
      $( [1-Aug-1994] $)
  $}

  $( A domain restricted to a subclass equals the subclass. $)
  ssdmres $p |- ( A C_ dom B <-> dom ( B |` A ) = A ) $=
    cA cB cdm wss cA cB cdm cin cA wceq cB cA cres cdm cA wceq cA cB cdm df-ss
    cB cA cres cdm cA cB cdm cin cA cB cA dmres eqeq1i bitr4i $.
    $( [28-Aug-2004] $) $( [2-Mar-1997] $)

  $( The domain of a restriction to a set exists. $)
  dmresexg $p |- ( B e. C -> dom ( A |` B ) e. _V ) $=
    cB cC wcel cB cA cdm cin cvv cA cB cres cdm cB cA cdm cC inex1g cA cB dmres
    syl5eqel $.
    $( [7-Apr-1995] $)

  $( A class includes its restriction.  Exercise 15 of [TakeutiZaring]
     p. 25. $)
  resss $p |- ( A |` B ) C_ A $=
    cA cB cres cA cB cvv cxp cin cA cA cB df-res cA cB cvv cxp inss1 eqsstri $.
    $( [2-Aug-1994] $)

  $( Commutative law for restriction. $)
  rescom $p |- ( ( A |` B ) |` C ) = ( ( A |` C ) |` B ) $=
    cA cB cC cin cres cA cC cB cin cres cA cB cres cC cres cA cC cres cB cres
    cB cC cin cC cB cin wceq cA cB cC cin cres cA cC cB cin cres wceq cB cC
    incom cB cC cin cC cB cin cA reseq2 ax-mp cA cB cC resres cA cC cB resres
    3eqtr4i $.
    $( [27-Mar-1998] $)

  $( Subclass theorem for restriction. $)
  ssres $p |- ( A C_ B -> ( A |` C ) C_ ( B |` C ) ) $=
    cA cB wss cA cC cvv cxp cin cB cC cvv cxp cin cA cC cres cB cC cres cA cB
    cC cvv cxp ssrin cA cC df-res cB cC df-res 3sstr4g $.
    $( [16-Aug-1994] $)

  $( Subclass theorem for restriction. $)
  ssres2 $p |- ( A C_ B -> ( C |` A ) C_ ( C |` B ) ) $=
    cA cB wss cC cA cvv cxp cin cC cB cvv cxp cin cC cA cres cC cB cres cA cB
    wss cA cvv cxp cB cvv cxp wss cC cA cvv cxp cin cC cB cvv cxp cin wss cA cB
    wss cvv cvv wss cA cvv cxp cB cvv cxp wss cvv ssid cA cB cvv cvv ssxp mpan2
    cA cvv cxp cB cvv cxp cC sslin syl cC cA df-res cC cB df-res 3sstr4g $.
    $( [22-Mar-1998] $)

  $( A restriction is a relation.  Exercise 12 of [TakeutiZaring] p. 25. $)
  relres $p |- Rel ( A |` B ) $=
    cA cB cres wrel cA cB cres cvv cvv cxp wss cA cB cres cA cB cvv cxp cin cvv
    cvv cxp cA cB df-res cA cB cvv cxp cin cB cvv cxp cvv cvv cxp cA cB cvv cxp
    inss2 cB cvv xpss sstri eqsstri cA cB cres df-rel mpbir $.
    $( [2-Aug-1994] $)

  $( Absorption law for restriction.  Exercise 17 of [TakeutiZaring] p. 25. $)
  resabs1 $p |- ( B C_ C -> ( ( A |` C ) |` B ) = ( A |` B ) ) $=
    cB cC wss cA cC cB cin cres cA cB cres cA cC cres cB cres cB cC wss cC cB
    cin cB wceq cA cC cB cin cres cA cB cres wceq cB cC sseqin2 cC cB cin cB cA
    reseq2 sylbi cA cC cB resres syl5eq $.
    $( [9-Aug-1994] $)

  $( Absorption law for restriction. $)
  resabs2 $p |- ( B C_ C -> ( ( A |` B ) |` C ) = ( A |` B ) ) $=
    cB cC wss cA cC cres cB cres cA cB cres cA cB cres cC cres cA cB cC resabs1
    cA cB cC rescom syl5eq $.
    $( [27-Mar-1998] $)

  $( Idempotent law for restriction. $)
  residm $p |- ( ( A |` B ) |` B ) = ( A |` B ) $=
    cB cB wss cA cB cres cB cres cA cB cres wceq cB ssid cA cB cB resabs2 ax-mp
    $.
    $( [27-Mar-1998] $)

  $( A restriction to an image. $)
  resima $p |- ( ( A |` B ) " B ) = ( A " B ) $=
    cA cB cres cB cres crn cA cB cres crn cA cB cres cB cima cA cB cima cA cB
    cres cB cres cA cB cres cA cB residm rneqi cA cB cres cB df-ima cA cB
    df-ima 3eqtr4i $.
    $( [9-Oct-2004] $) $( [29-Sep-2004] $)

  ${
    $d x y A $.  $d x y B $.
    $( Simplification law for restriction. $)
    relssres $p |- ( ( Rel A /\ dom A C_ B ) -> ( A |` B ) = A ) $=
      cA wrel cA cdm cB wss wa cA cB cres cA wss cA cA cB cres wss wa cA cB
      cres cA wceq cA wrel cA cdm cB wss wa cA cA cB cres wss cA cB cres cA wss
      cA wrel cA cdm cB wss wa vx vy cA cA cB cres cA wrel cA cdm cB wss pm3.26
      cA cdm cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cA cB cres wcel wi
      cA wrel cA cdm cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cA wcel vx
      cv cB wcel wa vx cv vy cv cop cA cB cres wcel cA cdm cB wss vx cv vy cv
      cop cA wcel vx cv cB wcel cA cdm cB wss vx cv cA cdm wcel vx cv cB wcel
      vx cv vy cv cop cA wcel cA cdm cB vx cv ssel vx cv vy cv cA vx visset
      opeldm syl5 ancld vx cv vy cv cA cB vy visset opelres syl6ibr adantl
      relssdv cA cB resss jctil cA cB cres cA eqss sylibr $.
      $( [15-Mar-2004] $) $( [16-Aug-1994] $)
  $}

  $( A relation restricted to its domain equals itself. $)
  resdm $p |- ( Rel A -> ( A |` dom A ) = A ) $=
    cA wrel cA cdm cA cdm wss cA cA cdm cres cA wceq cA cdm ssid cA cA cdm
    relssres mpan2 $.
    $( [8-Apr-2007] $) $( [12-Dec-2006] $)

  $( The restriction of a set is a set. $)
  resexg $p |- ( A e. C -> ( A |` B ) e. _V ) $=
    cA cC wcel cA cB cvv cxp cin cvv cA cB cres cA cB cvv cxp cC inex1g cA cB
    df-res syl5eqel $.
    $( [28-Mar-1998] $)

  ${
    $d x y A $.
    $( Restriction of a class abstraction of ordered pairs. $)
    resopab $p |- ( { <. x , y >. | ph } |` A ) =
                  { <. x , y >. | ( x e. A /\ ph ) } $=
      wph vx vy copab cA cres wph vx vy copab cA cvv cxp cin vx cv cA wcel vx
      vy copab wph vx vy copab cin vx cv cA wcel wph wa vx vy copab wph vx vy
      copab cA df-res wph vx vy copab cA cvv cxp cin wph vx vy copab vx cv cA
      wcel vx vy copab cin vx cv cA wcel vx vy copab wph vx vy copab cin cA cvv
      cxp vx cv cA wcel vx vy copab wph vx vy copab cA cvv cxp vx cv cA wcel vy
      cv cvv wcel wa vx vy copab vx cv cA wcel vx vy copab vx vy cA cvv df-xp
      vx cv cA wcel vx cv cA wcel vy cv cvv wcel wa vx vy vy cv cvv wcel vx cv
      cA wcel vy visset biantru opabbii eqtr4i ineq2i wph vx vy copab vx cv cA
      wcel vx vy copab incom eqtri vx cv cA wcel wph vx vy inopab 3eqtri $.
      $( [5-Nov-2002] $)

    $( The existence of a restricted identity function, proved without using
       the Axiom of Replacement (unlike ~ resfunexg ). $)
    resiexg $p |- ( A e. B -> ( _I |` A ) e. _V ) $=
      cid cA cres cA cA cxp wss cA cA cxp cvv wcel cid cA cres cvv wcel cA cB
      wcel cid cA cres cA cA cxp cvv ssexg vx vy cid cA cres cA cA cxp cid cA
      relres vx cv vy cv wceq vx cv cA wcel wa vx cv cA wcel vy cv cA wcel wa
      vx cv vy cv cop cid cA cres wcel vx cv vy cv cop cA cA cxp wcel vx cv vy
      cv wceq vx cv cA wcel wa vx cv cA wcel vy cv cA wcel vx cv vy cv wceq vx
      cv cA wcel pm3.27 vx cv vy cv wceq vx cv cA wcel vy cv cA wcel vx cv vy
      cv cA eleq1 biimpa jca vx cv vy cv cop cid cA cres wcel vx cv vy cv cop
      cid wcel vx cv cA wcel wa vx cv vy cv wceq vx cv cA wcel wa vx cv vy cv
      cid cA vy visset opelres vx cv vy cv cop cid wcel vx cv vy cv wceq vx cv
      cA wcel vx cv vy cv cop cid wcel vx cv vy cv cid wbr vx cv vy cv wceq vx
      cv vy cv cid df-br vx cv vy cv vy visset ideq bitr3i anbi1i bitri vx cv
      vy cv cA cA vy visset opelxp 3imtr4i relssi cA cB wcel cA cA cxp cvv wcel
      cA cA cB cB xpexg anidms sylancr $.
      $( [14-Jan-2007] $) $( [13-Jan-2007] $)

    $( A subclass of the identity function is the identity function restricted
       to its domain. $)
    iss $p |- ( A C_ _I <-> A = ( _I |` dom A ) ) $=
      cA cid wss cA cid cA cdm cres wceq cA cid wss cA cid cA cdm cres wceq vx
      cv vy cv cop cA wcel vx cv vy cv cop cid cA cdm cres wcel wb vy wal vx
      wal cA cid wss vx cv vy cv cop cA wcel vx cv vy cv cop cid cA cdm cres
      wcel wb vx vy cA cid wss vx cv vy cv cop cA wcel vx cv vy cv wceq vx cv
      cA cdm wcel wa vx cv vy cv cop cid cA cdm cres wcel cA cid wss vx cv vy
      cv cop cA wcel vx cv vy cv wceq vx cv vy cv cop cA wcel wa vx cv vy cv
      wceq vx cv cA cdm wcel wa cA cid wss vx cv vy cv cop cA wcel vx cv vy cv
      wceq cA cid wss vx cv vy cv cop cA wcel vx cv vy cv cop cid wcel vx cv vy
      cv wceq cA cid vx cv vy cv cop ssel vx cv vy cv cop cid wcel vx cv vy cv
      cid wbr vx cv vy cv wceq vx cv vy cv cid df-br vx cv vy cv vy visset ideq
      bitr3i syl6ib pm4.71rd cA cid wss vx cv vy cv wceq vx cv cA cdm wcel wa
      vx cv vy cv wceq vx cv vx cv cop cA wcel wa vx cv vy cv wceq vx cv vy cv
      cop cA wcel wa cA cid wss vx cv cA cdm wcel vx cv vx cv cop cA wcel vx cv
      vy cv wceq cA cid wss vx cv vy cv cop cA wcel vy wex vx cv vx cv cop cA
      wcel vx cv cA cdm wcel cA cid wss vx cv vy cv cop cA wcel vy wex vy cv vx
      cv wceq vx cv vy cv cop cA wcel wa vy wex vx cv vx cv cop cA wcel cA cid
      wss vx cv vy cv cop cA wcel vy cv vx cv wceq vx cv vy cv cop cA wcel wa
      vy cA cid wss vx cv vy cv cop cA wcel vx cv vy cv wceq vx cv vy cv cop cA
      wcel wa vy cv vx cv wceq vx cv vy cv cop cA wcel wa cA cid wss vx cv vy
      cv cop cA wcel vx cv vy cv wceq cA cid wss vx cv vy cv cop cA wcel vx cv
      vy cv cop cid wcel vx cv vy cv wceq cA cid vx cv vy cv cop ssel vx cv vy
      cv cop cid wcel vx cv vy cv cid wbr vx cv vy cv wceq vx cv vy cv cid
      df-br vx cv vy cv vy visset ideq bitr3i syl6ib pm4.71rd vx cv vy cv wceq
      vy cv vx cv wceq vx cv vy cv cop cA wcel vx cv vy cv eqcom anbi1i syl6bb
      exbidv vx cv vy cv cop cA wcel vx cv vx cv cop cA wcel vy vx cv vx visset
      vy cv vx cv wceq vx cv vy cv cop vx cv vx cv cop cA vy cv vx cv vx cv
      opeq2 eleq1d ceqsexv syl6bb vy vx cv cA vx visset eldm2 syl5bb anbi2d vx
      cv vy cv wceq vx cv vx cv cop cA wcel vx cv vy cv cop cA wcel vx cv vy cv
      wceq vx cv vx cv cop vx cv vy cv cop cA vx cv vy cv vx cv opeq2 eleq1d
      pm5.32i syl6bb bitr4d vx cv vy cv cop cid cA cdm cres wcel vx cv vy cv
      cop cid wcel vx cv cA cdm wcel wa vx cv vy cv wceq vx cv cA cdm wcel wa
      vx cv vy cv cid cA cdm vy visset opelres vx cv vy cv cop cid wcel vx cv
      vy cv wceq vx cv cA cdm wcel vx cv vy cv cop cid wcel vx cv vy cv cid wbr
      vx cv vy cv wceq vx cv vy cv cid df-br vx cv vy cv vy visset ideq bitr3i
      anbi1i bitr2i syl6bb 19.21aivv cA wrel cid cA cdm cres wrel cA cid cA cdm
      cres wceq vx cv vy cv cop cA wcel vx cv vy cv cop cid cA cdm cres wcel wb
      vy wal vx wal wb cA cid wss vx vy cA cid cA cdm cres eqrel cA cid wss cid
      wrel cA wrel reli cA cid relss mpi cid cA cdm relres sylancl mpbird cA
      cid cA cdm cres wceq cA cid wss cid cA cdm cres cid wss cid cA cdm resss
      cA cid cA cdm cres cid sseq1 mpbiri impbii $.
      $( [16-Dec-2003] $) $( [13-Dec-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Restriction of a class abstraction of ordered pairs. $)
    resopab2 $p |- ( A C_ B -> ( { <. x , y >. | ( x e. B /\ ph ) } |` A ) =
                  { <. x , y >. | ( x e. A /\ ph ) } ) $=
      cA cB wss vx cv cA wcel vx cv cB wcel wph wa wa vx vy copab vx cv cA wcel
      wph wa vx vy copab vx cv cB wcel wph wa vx vy copab cA cres cA cB wss vx
      cv cA wcel vx cv cB wcel wph wa wa vx cv cA wcel wph wa vx vy cA cB wss
      vx cv cA wcel wph wa vx cv cA wcel vx cv cB wcel wa wph wa vx cv cA wcel
      vx cv cB wcel wph wa wa cA cB wss vx cv cA wcel vx cv cA wcel vx cv cB
      wcel wa wph cA cB wss vx cv cA wcel vx cv cB wcel wi vx cv cA wcel vx cv
      cA wcel vx cv cB wcel wa wb cA cB vx cv ssel vx cv cA wcel vx cv cB wcel
      pm4.71 sylib anbi1d vx cv cA wcel vx cv cB wcel wph anass syl6rbb
      opabbidv vx cv cB wcel wph wa vx vy cA resopab syl5eq $.
      $( [24-Aug-2007] $) $( [24-Aug-2007] $)
  $}

  $( The domain of a restricted identity function. $)
  dmresi $p |- dom ( _I |` A ) = A $=
    cA cid cdm wss cid cA cres cdm cA wceq cA cvv cid cdm cA ssv dmi sseqtr4i
    cA cid ssdmres mpbi $.
    $( [30-Aug-2004] $) $( [27-Aug-2004] $)

  $( MAY BE REVISED - delete this and replace w/ dfres3 (in FL's mathbox) $)
  $( Any relation restricted to the universe is itself. $)
  resid $p |- ( Rel A -> ( A |` _V ) = A ) $=
    cA wrel cA cdm cvv wss cA cvv cres cA wceq cA cdm ssv cA cvv relssres mpan2
    $.
    $( [17-Mar-2004] $) $( [16-Mar-2004] $)

  $( Equality theorem for image. $)
  imaeq1 $p |- ( A = B -> ( A " C ) = ( B " C ) ) $=
    cA cB wceq cA cC cres crn cB cC cres crn cA cC cima cB cC cima cA cB wceq
    cA cC cres cB cC cres cA cB cC reseq1 rneqd cA cC df-ima cB cC df-ima
    3eqtr4g $.
    $( [14-Aug-1994] $)

  $( Equality theorem for image. $)
  imaeq2 $p |- ( A = B -> ( C " A ) = ( C " B ) ) $=
    cA cB wceq cC cA cres crn cC cB cres crn cC cA cima cC cB cima cA cB wceq
    cC cA cres cC cB cres cA cB cC reseq2 rneqd cC cA df-ima cC cB df-ima
    3eqtr4g $.
    $( [14-Aug-1994] $)

  ${
    imaeq1i.1 $e |- A = B $.
    $( Equality theorem for image. $)
    imaeq1i $p |- ( A " C ) = ( B " C ) $=
      cA cB wceq cA cC cima cB cC cima wceq imaeq1i.1 cA cB cC imaeq1 ax-mp $.
      $( [22-Dec-2008] $) $( [21-Dec-2008] $)

    $( Equality theorem for image. $)
    imaeq2i $p |- ( C " A ) = ( C " B ) $=
      cA cB wceq cC cA cima cC cB cima wceq imaeq1i.1 cA cB cC imaeq2 ax-mp $.
      $( [22-Dec-2008] $) $( [21-Dec-2008] $)
  $}

  ${
    imaeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for image.  (Contributed by FL, 15-Dec-2006.) $)
    imaeq1d $p |- ( ph -> ( A " C ) = ( B " C ) ) $=
      wph cA cB wceq cA cC cima cB cC cima wceq imaeq1d.1 cA cB cC imaeq1 syl
      $.
      $( [15-Dec-2006] $) $( [12-Dec-2006] $)

    $( Equality theorem for image.  (Contributed by FL, 15-Dec-2006.) $)
    imaeq2d $p |- ( ph -> ( C " A ) = ( C " B ) ) $=
      wph cA cB wceq cC cA cima cC cB cima wceq imaeq1d.1 cA cB cC imaeq2 syl
      $.
      $( [15-Dec-2006] $) $( [12-Dec-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Alternate definition of image.  Compare definition (d) of [Enderton]
       p. 44. $)
    dfima2 $p |- ( A " B ) = { y | E. x e. B x A y } $=
      cA cB cima cA cB cres crn vx cv vy cv cop cA cB cres wcel vx wex vy cab
      vx cv vy cv cA wbr vx cB wrex vy cab cA cB df-ima vx vy cA cB cres dfrn3
      vx cv vy cv cop cA cB cres wcel vx wex vx cv vy cv cA wbr vx cB wrex vy
      vx cv vy cv cop cA cB cres wcel vx wex vx cv cB wcel vx cv vy cv cA wbr
      wa vx wex vx cv vy cv cA wbr vx cB wrex vx cv vy cv cop cA cB cres wcel
      vx cv cB wcel vx cv vy cv cA wbr wa vx vx cv vy cv cop cA cB cres wcel vx
      cv vy cv cop cA cB cvv cxp cin wcel vx cv vy cv cop cA wcel vx cv vy cv
      cop cB cvv cxp wcel wa vx cv cB wcel vx cv vy cv cA wbr wa cA cB cres cA
      cB cvv cxp cin vx cv vy cv cop cA cB df-res eleq2i vx cv vy cv cop cA cB
      cvv cxp elin vx cv cB wcel vx cv vy cv cA wbr wa vx cv vy cv cA wbr vx cv
      cB wcel wa vx cv vy cv cop cA wcel vx cv vy cv cop cB cvv cxp wcel wa vx
      cv cB wcel vx cv vy cv cA wbr ancom vx cv vy cv cA wbr vx cv vy cv cop cA
      wcel vx cv cB wcel vx cv vy cv cop cB cvv cxp wcel vx cv vy cv cA df-br
      vx cv cB wcel vx cv cB wcel vy cv cvv wcel wa vx cv vy cv cop cB cvv cxp
      wcel vy cv cvv wcel vx cv cB wcel vy visset biantru vx cv vy cv cB cvv vy
      visset opelxp bitr4i anbi12i bitr2i 3bitri exbii vx cv vy cv cA wbr vx cB
      df-rex bitr4i abbii 3eqtri $.
      $( [22-Apr-2004] $) $( [19-Apr-2004] $)

    $( Alternate definition of image.  Compare definition (d) of [Enderton]
       p. 44. $)
    dfima3 $p |- ( A " B ) = { y | E. x ( x e. B /\ <. x , y >. e. A ) } $=
      cA cB cima vx cv vy cv cA wbr vx cB wrex vy cab vx cv cB wcel vx cv vy cv
      cop cA wcel wa vx wex vy cab vx vy cA cB dfima2 vx cv vy cv cA wbr vx cB
      wrex vx cv cB wcel vx cv vy cv cop cA wcel wa vx wex vy vx cv vy cv cA
      wbr vx cB wrex vx cv cB wcel vx cv vy cv cA wbr wa vx wex vx cv cB wcel
      vx cv vy cv cop cA wcel wa vx wex vx cv vy cv cA wbr vx cB df-rex vx cv
      cB wcel vx cv vy cv cA wbr wa vx cv cB wcel vx cv vy cv cop cA wcel wa vx
      vx cv vy cv cA wbr vx cv vy cv cop cA wcel vx cv cB wcel vx cv vy cv cA
      df-br anbi2i exbii bitri abbii eqtri $.
      $( [14-Aug-1994] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in an image.  Theorem 34 of [Suppes] p. 65. $)
    elimag $p |- ( A e. D -> ( A e. ( B " C ) <-> E. x e. C x B A ) ) $=
      vx cv vy cv cB wbr vx cC wrex vx cv cA cB wbr vx cC wrex vy cA cB cC cima
      cD vy cv cA wceq vx cv vy cv cB wbr vx cv cA cB wbr vx cC vy cv cA vx cv
      cB breq2 rexbidv vx vy cB cC dfima2 elab2g $.
      $( [17-Feb-2007] $) $( [20-Jan-2007] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    elima.1 $e |- A e. _V $.
    $( Membership in an image.  Theorem 34 of [Suppes] p. 65. $)
    elima $p |- ( A e. ( B " C ) <-> E. x e. C x B A ) $=
      cA cvv wcel cA cB cC cima wcel vx cv cA cB wbr vx cC wrex wb elima.1 vx
      cA cB cC cvv elimag ax-mp $.
      $( [22-Apr-2004] $) $( [19-Apr-2004] $)

    $( Membership in an image.  Theorem 34 of [Suppes] p. 65. $)
    elima2 $p |- ( A e. ( B " C ) <-> E. x ( x e. C /\ x B A ) ) $=
      cA cB cC cima wcel vx cv cA cB wbr vx cC wrex vx cv cC wcel vx cv cA cB
      wbr wa vx wex vx cA cB cC elima.1 elima vx cv cA cB wbr vx cC df-rex
      bitri $.
      $( [12-Aug-2004] $) $( [11-Aug-2004] $)

    $( Membership in an image.  Theorem 34 of [Suppes] p. 65. $)
    elima3 $p |- ( A e. ( B " C ) <-> E. x ( x e. C /\ <. x , A >. e. B ) ) $=
      cA cB cC cima wcel vx cv cC wcel vx cv cA cB wbr wa vx wex vx cv cC wcel
      vx cv cA cop cB wcel wa vx wex vx cA cB cC elima.1 elima2 vx cv cC wcel
      vx cv cA cB wbr wa vx cv cC wcel vx cv cA cop cB wcel wa vx vx cv cA cB
      wbr vx cv cA cop cB wcel vx cv cC wcel vx cv cA cB df-br anbi2i exbii
      bitri $.
      $( [14-Aug-1994] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d x y z w $.
    hbima.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbima.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for image. $)
    hbima $p |- ( y e. ( A " B ) -> A. x y e. ( A " B ) ) $=
      vz cv cB wcel vz cv vy cv cop cA wcel wa vz wex vz cv cB wcel vz cv vy cv
      cop cA wcel wa vz wex vx wal vy cv cA cB cima wcel vy cv cA cB cima wcel
      vx wal vz cv cB wcel vz cv vy cv cop cA wcel wa vx vz vz cv cB wcel vz cv
      vy cv cop cA wcel vx vx vw vy vz cv cB vw cv vz cv wcel vx ax-17 hbima.2
      hbel vx vw vy vz cv vy cv cop cA vx vw vz cv vy cv vw cv vz cv wcel vx
      ax-17 vw cv vy cv wcel vx ax-17 hbop hbima.1 hbel hban hbex vz vy cv cA
      cB vy visset elima3 vy cv cA cB cima wcel vz cv cB wcel vz cv vy cv cop
      cA wcel wa vz wex vx vz vy cv cA cB vy visset elima3 albii 3imtr4i $.
      $( [30-Dec-1996] $)
  $}

  ${
    $d x y z $.  $d B y z $.  $d A y z $.  $d ph y $.
    hbimad.1 $e |- ( ph -> A. x ph ) $.
    hbimad.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    hbimad.3 $e |- ( ph -> ( y e. B -> A. x y e. B ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbima .
       (Contributed by FL, 15-Dec-2006.) $)
    hbimad $p |- ( ph -> ( y e. ( A " B ) -> A. x y e. ( A " B ) ) ) $=
      wph vy cv vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cima
      wcel vy cv vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cima
      wcel vx wal vy cv cA cB cima wcel vy cv cA cB cima wcel vx wal vy cv vz
      cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cima wcel vy cv vz
      cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cima wcel vx wal wi
      wph vx vy vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv
      cA wcel vx wal vx vz vy vz cv cA wcel vx hba1 hbab vz cv cB wcel vx wal
      vx vz vy vz cv cB wcel vx hba1 hbab hbima a1i wph vz cv cA wcel vx wal vz
      cab vz cv cB wcel vx wal vz cab cima cA cB cima vy cv wph vz cv cA wcel
      vx wal vz cab vz cv cB wcel vx wal vz cab cima cA vz cv cB wcel vx wal vz
      cab cima cA cB cima wph vz cv cA wcel vx wal vz cab cA vz cv cB wcel vx
      wal vz cab wph vy cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel
      vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy
      hbimad.2 19.21aiv vx vy vz cA abidhb syl imaeq1d wph vz cv cB wcel vx wal
      vz cab cB cA wph vy cv cB wcel vy cv cB wcel vx wal wi vy wal vz cv cB
      wcel vx wal vz cab cB wceq wph vy cv cB wcel vy cv cB wcel vx wal wi vy
      hbimad.3 19.21aiv vx vy vz cB abidhb syl imaeq2d eqtrd eleq2d wph vy cv
      vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab cima wcel vy cv
      cA cB cima wcel vx hbimad.1 wph vz cv cA wcel vx wal vz cab vz cv cB wcel
      vx wal vz cab cima cA cB cima vy cv wph vz cv cA wcel vx wal vz cab vz cv
      cB wcel vx wal vz cab cima cA vz cv cB wcel vx wal vz cab cima cA cB cima
      wph vz cv cA wcel vx wal vz cab cA vz cv cB wcel vx wal vz cab wph vy cv
      cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz cab cA
      wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy hbimad.2 19.21aiv vx vy
      vz cA abidhb syl imaeq1d wph vz cv cB wcel vx wal vz cab cB cA wph vy cv
      cB wcel vy cv cB wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB
      wceq wph vy cv cB wcel vy cv cB wcel vx wal wi vy hbimad.3 19.21aiv vx vy
      vz cB abidhb syl imaeq2d eqtrd eleq2d albid 3imtr3d $.
      $( [15-Dec-2006] $) $( [14-Dec-2006] $)
  $}

  ${
    $d A y z $.  $d B y z $.  $d C y z $.  $d x y z $.  $d F y z $.
    $( Move class substitution in and out of the image of a function.
       (Contributed by FL, 15-Dec-2006.) $)
    csbima12g $p |- ( A e. C -> [_ A / x ]_ ( F " B ) =
                 ( [_ A / x ]_ F " [_ A / x ]_ B ) ) $=
      cA cC wcel vy cA vx vy cv cF cB cima csb csb vy cA vx vy cv cF csb csb vy
      cA vx vy cv cB csb csb cima vx cA cF cB cima csb vx cA cF csb vx cA cB
      csb cima vy vz cA vx vy cv cF cB cima csb vy cA vx vy cv cF csb csb vy cA
      vx vy cv cB csb csb cima cC cA cC wcel vy vz vy cA vx vy cv cF csb csb vy
      cA vx vy cv cB csb csb cA cC wcel vy ax-17 vy vz cA vx vy cv cF csb cC vz
      cv cA wcel vy ax-17 hbcsb1g vy vz cA vx vy cv cB csb cC vz cv cA wcel vy
      ax-17 hbcsb1g hbimad vy cv cA wceq vx vy cv cF cB cima csb vx vy cv cF
      csb vx vy cv cB csb cima vy cA vx vy cv cF csb csb vx vy cv cB csb cima
      vy cA vx vy cv cF csb csb vy cA vx vy cv cB csb csb cima vx vy cv cF cB
      cima csb vx vy cv cF csb vx vy cv cB csb cima wceq vy cv cA wceq vx cv vy
      cv wceq vx wex vx vy cv cF cB cima csb vx vy cv cF csb vx vy cv cB csb
      cima wceq vx vy a9e vx cv vy cv wceq vx vy cv cF cB cima csb vx vy cv cF
      csb vx vy cv cB csb cima wceq vx vx vz vz vx vy cv cF cB cima csb vx vy
      cv cF csb vx vy cv cB csb cima vx vz vy cv cF cB cima vy visset vz cv vy
      cv wcel vx ax-17 hbcsb1 vx vz vx vy cv cF csb vx vy cv cB csb vx vz vy cv
      cF vy visset vz cv vy cv wcel vx ax-17 hbcsb1 vx vz vy cv cB vy visset vz
      cv vy cv wcel vx ax-17 hbcsb1 hbima hbeq vx cv vy cv wceq cF cB cima vx
      vy cv cF csb cB cima vx vy cv cF cB cima csb vx vy cv cF csb vx vy cv cB
      csb cima vx cv vy cv wceq cF vx vy cv cF csb cB vx vy cv cF csbeq1a
      imaeq1d vx vy cv cF cB cima csbeq1a vx cv vy cv wceq cB vx vy cv cB csb
      vx vy cv cF csb vx vy cv cB csbeq1a imaeq2d 3eqtr3d 19.23ai ax-mp a1i vy
      cv cA wceq vx vy cv cF csb vy cA vx vy cv cF csb csb vx vy cv cB csb vy
      cA vx vy cv cF csb csbeq1a imaeq1d vy cv cA wceq vx vy cv cB csb vy cA vx
      vy cv cB csb csb vy cA vx vy cv cF csb csb vy cA vx vy cv cB csb csbeq1a
      imaeq2d 3eqtrd csbiegf vx vy cA cF cB cima cC csbcog cA cC wcel vy cA vx
      vy cv cF csb csb vy cA vx vy cv cB csb csb cima vx cA cF csb vy cA vx vy
      cv cB csb csb cima vx cA cF csb vx cA cB csb cima cA cC wcel vy cA vx vy
      cv cF csb csb vx cA cF csb vy cA vx vy cv cB csb csb vx vy cA cF cC
      csbcog imaeq1d cA cC wcel vy cA vx vy cv cB csb csb vx cA cB csb vx cA cF
      csb vx vy cA cB cC csbcog imaeq2d eqtrd 3eqtr3d $.
      $( [15-Dec-2006] $) $( [13-Dec-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The image of the domain of a class is the range of the class. $)
    imadmrn $p |- ( A " dom A ) = ran A $=
      vx cv cA cdm wcel vx cv vy cv cop cA wcel wa vx wex vy cab vx cv vy cv
      cop cA wcel vx wex vy cab cA cA cdm cima cA crn vx cv cA cdm wcel vx cv
      vy cv cop cA wcel wa vx wex vx cv vy cv cop cA wcel vx wex vy vx cv cA
      cdm wcel vx cv vy cv cop cA wcel wa vx cv vy cv cop cA wcel vx vx cv vy
      cv cop cA wcel vx cv vy cv cop cA wcel vx cv cA cdm wcel wa vx cv cA cdm
      wcel vx cv vy cv cop cA wcel wa vx cv vy cv cop cA wcel vx cv cA cdm wcel
      vx cv vy cv cA vx visset opeldm pm4.71i vx cv vy cv cop cA wcel vx cv cA
      cdm wcel ancom bitr2i exbii abbii vx vy cA cA cdm dfima3 vx vy cA dfrn3
      3eqtr4i $.
      $( [14-Aug-1994] $)

    $( The image of a class is a subset of its range.  Theorem 3.16(xi) of
       [Monk1] p. 39. $)
    imassrn $p |- ( A " B ) C_ ran A $=
      vx cv cB wcel vx cv vy cv cop cA wcel wa vx wex vy cab vx cv vy cv cop cA
      wcel vx wex vy cab cA cB cima cA crn vx cv cB wcel vx cv vy cv cop cA
      wcel wa vx wex vx cv vy cv cop cA wcel vx wex vy vx cv cB wcel vx cv vy
      cv cop cA wcel wa vx cv vy cv cop cA wcel vx vx cv cB wcel vx cv vy cv
      cop cA wcel pm3.27 19.22i ss2abi vx vy cA cB dfima3 vx vy cA dfrn3
      3sstr4i $.
      $( [31-Mar-1995] $)
  $}

  $( The image of a set is a set.  Theorem 3.17 of [Monk1] p. 39. $)
  imaexg $p |- ( A e. C -> ( A " B ) e. _V ) $=
    cA cB cima cA crn wss cA crn cvv wcel cA cB cima cvv wcel cA cC wcel cA cB
    cima cA crn cvv ssexg cA cB imassrn cA cC rnexg sylancr $.
    $( [24-Jul-1995] $)

  ${
    $d x y A $.
    $( Image under the identity relation.  Theorem 3.16(viii) of [Monk1]
       p. 38. $)
    imai $p |- ( _I " A ) = A $=
      cid cA cima vx cv cA wcel vx cv vy cv cop cid wcel wa vx wex vy cab vy cv
      cA wcel vy cab cA vx vy cid cA dfima3 vx cv cA wcel vx cv vy cv cop cid
      wcel wa vx wex vy cv cA wcel vy vx cv cA wcel vx cv vy cv cop cid wcel wa
      vx wex vx cv vy cv wceq vx cv cA wcel wa vx wex vy cv cA wcel vx cv cA
      wcel vx cv vy cv cop cid wcel wa vx cv vy cv wceq vx cv cA wcel wa vx vx
      cv cA wcel vx cv vy cv cop cid wcel wa vx cv cA wcel vx cv vy cv wceq wa
      vx cv vy cv wceq vx cv cA wcel wa vx cv vy cv cop cid wcel vx cv vy cv
      wceq vx cv cA wcel vx cv vy cv cop cid wcel vx cv vy cv cid wbr vx cv vy
      cv wceq vx cv vy cv cid df-br vx cv vy cv vy visset ideq bitr3i anbi2i vx
      cv cA wcel vx cv vy cv wceq ancom bitri exbii vx cv cA wcel vy cv cA wcel
      vx vy cv vy visset vx cv vy cv cA eleq1 ceqsexv bitri abbii vy cA abid2
      3eqtri $.
      $( [30-Apr-1998] $)
  $}

  $( The range of the restricted identity function. $)
  rnresi $p |- ran ( _I |` A ) = A $=
    cid cA cima cid cA cres crn cA cid cA df-ima cA imai eqtr3i $.
    $( [28-Aug-2004] $) $( [27-Aug-2004] $)

  $( The image of a restriction of the identity function.  (Contributed by
     FL, 31-Dec-2006.) $)
  resiima $p |- ( B C_ A -> ( ( _I |` A ) " B ) = B ) $=
    cB cA wss cid cA cres cB cima cid cA cres cB cres crn cid cB cres crn cB
    cid cA cres cB cima cid cA cres cB cres crn wceq cB cA wss cid cA cres cB
    df-ima a1i cB cA wss cid cA cres cB cres cid cB cres cid cB cA resabs1
    rneqd cid cB cres crn cB wceq cB cA wss cB rnresi a1i 3eqtrd $.
    $( [1-Jan-2007] $) $( [28-Dec-2006] $)

  $( Image of the empty set.  Theorem 3.16(ii) of [Monk1] p. 38. $)
  ima0 $p |- ( A " (/) ) = (/) $=
    cA c0 cima cA c0 cres crn c0 crn c0 cA c0 df-ima cA c0 cres c0 cA res0
    rneqi rn0 3eqtri $.
    $( [20-May-1998] $)

  $( Image under the empty relation.  (Contributed by FL, 11-Jan-2007.) $)
  0ima $p |- ( (/) " A ) = (/) $=
    c0 cA cima c0 c0 cA cima c0 crn c0 c0 cA imassrn rn0 sseqtri c0 cA cima 0ss
    eqssi $.
    $( [12-Jan-2007] $) $( [4-Jan-2007] $)

  $( A class whose image under another is empty is disjoint with the other's
     domain.  (Contributed by FL, 24-Jan-2007.) $)
  imadisj $p |- ( ( A " B ) = (/) <-> ( dom A i^i B ) = (/) ) $=
    cA cB cima c0 wceq cA cB cres crn c0 wceq cA cB cres cdm c0 wceq cA cdm cB
    cin c0 wceq cA cB cima cA cB cres crn c0 cA cB df-ima eqeq1i cA cB cres
    dm0rn0 cA cB cres cdm cA cdm cB cin c0 cA cB cres cdm cB cA cdm cin cA cdm
    cB cin cA cB dmres cB cA cdm incom eqtri eqeq1i 3bitr2i $.
    $( [25-Jan-2007] $) $( [15-Jan-2007] $)

  $( A pre-image under any class is included in the domain of the class.
     (Contributed by FL, 29-Jan-2007.) $)
  cnvimass $p |- ( `' A " B ) C_ dom A $=
    cA ccnv cB cima cA ccnv crn cA cdm cA ccnv cB imassrn cA dfdm4 sseqtr4i $.
    $( [29-Jan-2007] $) $( [29-Jan-2007] $)

  ${
    $d y x A $.  $d y x R $.
    $( The image of a singleton. $)
    imasng $p |- ( A e. B -> ( R " { A } ) = { y | A R y } ) $=
      cA cB wcel cA cvv wcel cR cA csn cima cA vy cv cR wbr vy cab wceq cA cB
      elisset cA cvv wcel vx cv vy cv cR wbr vx cA csn wrex vy cab cA vy cv cR
      wbr vy cab cR cA csn cima cA cvv wcel vx cv vy cv cR wbr vx cA csn wrex
      cA vy cv cR wbr vy cA cvv wcel vx cv cA wceq vx cv vy cv cR wbr wa vx wex
      cA vy cv cR wbr vx cv vy cv cR wbr vx cA csn wrex vx cv vy cv cR wbr cA
      vy cv cR wbr vx cA cvv vx cv cA vy cv cR breq1 ceqsexgv vx cv vy cv cR
      wbr vx cA csn wrex vx cv cA csn wcel vx cv vy cv cR wbr wa vx wex vx cv
      cA wceq vx cv vy cv cR wbr wa vx wex vx cv vy cv cR wbr vx cA csn df-rex
      vx cv cA csn wcel vx cv vy cv cR wbr wa vx cv cA wceq vx cv vy cv cR wbr
      wa vx vx cv cA csn wcel vx cv cA wceq vx cv vy cv cR wbr vx cA elsn
      anbi1i exbii bitri syl5bb abbidv vx vy cR cA csn dfima2 syl5eq syl $.
      $( [10-May-2005] $) $( [8-May-2005] $)

    $( The image of a singleton. $)
    relimasn $p |- ( Rel R -> ( R " { A } ) = { y | A R y } ) $=
      cR wrel cA cvv wcel cR cA csn cima cA vy cv cR wbr vy cab wceq cR wrel cA
      cvv wcel wn cR cA csn cima cA vy cv cR wbr vy cab wceq cR wrel cA cvv
      wcel wn wa cR cA csn cima c0 cA vy cv cR wbr vy cab cA cvv wcel wn cR cA
      csn cima c0 wceq cR wrel cA cvv wcel wn cR cA csn cima cR c0 cima c0 cA
      cvv wcel wn cA csn c0 wceq cR cA csn cima cR c0 cima wceq cA snprc cA csn
      c0 cR imaeq2 sylbi cR ima0 syl6eq adantl cR wrel cA cvv wcel wn wa cA vy
      cv cR wbr vy wex wn cA vy cv cR wbr vy cab c0 wceq cR wrel cA cvv wcel wn
      wa cA vy cv cR wbr vy cR wrel cA cvv wcel wn cA vy cv cR wbr wn cR wrel
      cA vy cv cR wbr cA cvv wcel cR wrel cA vy cv cR wbr cA cvv wcel cA vy cv
      cR brrelex ex con3d imp nexdv cA vy cv cR wbr vy wex cA vy cv cR wbr vy
      cab c0 cA vy cv cR wbr vy abn0 necon1bbii sylib eqtr4d ex vy cA cvv cR
      imasng pm2.61d2 $.
      $( [10-May-2005] $) $( [20-May-1998] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    elimasn.1 $e |- B e. _V $.
    elimasn.2 $e |- C e. _V $.
    $( Membership in an image of a singleton. $)
    elimasn $p |- ( C e. ( A " { B } ) <-> <. B , C >. e. A ) $=
      cC cA cB csn cima wcel vx cv cB csn wcel vx cv cC cop cA wcel wa vx wex
      vx cv cB wceq vx cv cC cop cA wcel wa vx wex cB cC cop cA wcel vx cC cA
      cB csn elimasn.2 elima3 vx cv cB csn wcel vx cv cC cop cA wcel wa vx cv
      cB wceq vx cv cC cop cA wcel wa vx vx cv cB csn wcel vx cv cB wceq vx cv
      cC cop cA wcel vx cB elsn anbi1i exbii vx cv cC cop cA wcel cB cC cop cA
      wcel vx cB elimasn.1 vx cv cB wceq vx cv cC cop cB cC cop cA vx cv cB cC
      opeq1 eleq1d ceqsexv 3bitri $.
      $( [16-Mar-2004] $) $( [15-Mar-2004] $)
  $}

  ${
    $d A y z $.  $d B y z $.  $d C y z $.
    $( Membership in an image of a singleton.  (Contributed by Raph Levien,
       21-Oct-2006.) $)
    elimasng $p |- ( ( B e. R /\ C e. S ) ->
                   ( C e. ( A " { B } ) <-> <. B , C >. e. A ) ) $=
      vz cv cA vy cv csn cima wcel vy cv vz cv cop cA wcel wb vz cv cA cB csn
      cima wcel cB vz cv cop cA wcel wb cC cA cB csn cima wcel cB cC cop cA
      wcel wb vy vz cB cC cR cS vy cv cB wceq vz cv cA vy cv csn cima wcel vz
      cv cA cB csn cima wcel vy cv vz cv cop cA wcel cB vz cv cop cA wcel vy cv
      cB wceq cA vy cv csn cima cA cB csn cima vz cv vy cv cB wceq vy cv csn cB
      csn cA vy cv cB sneq imaeq2d eleq2d vy cv cB wceq vy cv vz cv cop cB vz
      cv cop cA vy cv cB vz cv opeq1 eleq1d bibi12d vz cv cC wceq vz cv cA cB
      csn cima wcel cC cA cB csn cima wcel cB vz cv cop cA wcel cB cC cop cA
      wcel vz cv cC cA cB csn cima eleq1 vz cv cC wceq cB vz cv cop cB cC cop
      cA vz cv cC cB opeq2 eleq1d bibi12d cA vy cv vz cv vy visset vz visset
      elimasn vtocl2g $.
      $( [21-Oct-2006] $) $( [21-Oct-2006] $)
  $}

  $( Membership in an image of a singleton. $)
  elimasni $p |- ( C e. ( A " { B } ) -> B A C ) $=
    cB cvv wcel cC cvv wcel wa cC cA cB csn cima wcel cB cC cA wbr cC cA cB csn
    cima wcel cB cvv wcel cC cvv wcel cB cvv wcel cC cA cB csn cima wcel cB cvv
    wcel wn cC cA cB csn cima wcel cC c0 wcel cC noel cB cvv wcel wn cA cB csn
    cima c0 cC cB cvv wcel wn cA cB csn cima cA c0 cima c0 cB cvv wcel wn cB
    csn c0 cA cB cvv wcel wn cB csn c0 wceq cB snprc biimpi imaeq2d cA ima0
    syl6eq eleq2d mtbiri con4i cC cA cB csn cima elisset jca cB cvv wcel cC cvv
    wcel wa cC cA cB csn cima wcel cB cC cA wbr cB cvv wcel cC cvv wcel wa cC
    cA cB csn cima wcel cB cC cop cA wcel cB cC cA wbr cA cB cC cvv cvv
    elimasng cB cC cA df-br syl6bbr biimpd mpcom $.
    $( [5-Aug-2010] $) $( [5-Aug-2010] $)

  ${
    $d y F $.  $d x y $.
    $( Two ways to express the class of unique-valued arguments of ` F ` ,
       which is the same as the domain of ` F ` whenever ` F ` is a function.
       The left-hand side of the equality is from Definition 10.2 of [Quine]
       p. 65.  Quine uses the notation "arg ` F ` " for this class (for which
       we have no separate notation).  Observe the resemblance to our
       ~ df-fv , which was based on the idea in Quine's definition. $)
    args $p |- { x | E. y ( F " { x } ) = { y } } = { x | E! y x F y } $=
      cF vx cv csn cima vy cv csn wceq vy wex vx cv vy cv cF wbr vy weu vx cF
      vx cv csn cima vy cv csn wceq vy wex vx cv vy cv cF wbr vy cab vy cv csn
      wceq vy wex vx cv vy cv cF wbr vy weu cF vx cv csn cima vy cv csn wceq vx
      cv vy cv cF wbr vy cab vy cv csn wceq vy cF vx cv csn cima vx cv vy cv cF
      wbr vy cab vy cv csn vx cv cvv wcel cF vx cv csn cima vx cv vy cv cF wbr
      vy cab wceq vx visset vy vx cv cvv cF imasng ax-mp eqeq1i exbii vx cv vy
      cv cF wbr vy euabsn bitr4i abbii $.
      $( [11-May-2005] $) $( [8-May-2005] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    eliniseg.1 $e |- C e. _V $.
    $( Membership in an initial segment.  The idiom ` ( ``' A " { B } ) ` ,
       meaning ` { x | x A B } ` , is used to specify an initial segment in
       (for example) Definition 6.21 of [TakeutiZaring] p. 30. $)
    eliniseg $p |- ( B e. D -> ( C e. ( `' A " { B } ) <-> C A B ) ) $=
      cC cA ccnv vx cv csn cima wcel cC vx cv cA wbr wb cC cA ccnv cB csn cima
      wcel cC cB cA wbr wb vx cB cD vx cv cB wceq cC cA ccnv vx cv csn cima
      wcel cC cA ccnv cB csn cima wcel cC vx cv cA wbr cC cB cA wbr vx cv cB
      wceq cA ccnv vx cv csn cima cA ccnv cB csn cima cC vx cv cB wceq vx cv
      csn cB csn cA ccnv vx cv cB sneq imaeq2d eleq2d vx cv cB cC cA breq2
      bibi12d cC cA ccnv vx cv csn cima wcel vx cv cC cop cA ccnv wcel vx cv cC
      cA ccnv wbr cC vx cv cA wbr cA ccnv vx cv cC vx visset eliniseg.1 elimasn
      vx cv cC cA ccnv df-br vx cv cC cA vx visset eliniseg.1 brcnv 3bitr2i
      vtoclg $.
      $( [15-May-2004] $) $( [28-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( An idiom that signifies an initial segment of an ordering, used, for
       example, in Definition 6.21 of [TakeutiZaring] p. 30. $)
    iniseg $p |- ( B e. C -> ( `' A " { B } ) = { x | x A B } ) $=
      cB cC wcel cB cvv wcel cA ccnv cB csn cima vx cv cB cA wbr vx cab wceq cB
      cC elisset cB cvv wcel vx cv cB cA wbr vx cA ccnv cB csn cima cA cB vx cv
      cvv vx visset eliniseg abbi2dv syl $.
      $( [15-May-2004] $) $( [28-Apr-2004] $)
  $}

  ${
    $d x y z R $.  $d x A $.
    $( Alternate definition of founded relation.  Definition 6.21 of
       [TakeutiZaring] p. 30. $)
    dffr3 $p |- ( R Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                E. y e. x ( x i^i ( `' R " { y } ) ) = (/) ) ) $=
      cA cR wfr vx cv cA wss vx cv c0 wne wa vx cv vz cv vy cv cR wbr vz cab
      cin c0 wceq vy vx cv wrex wi vx wal vx cv cA wss vx cv c0 wne wa vx cv cR
      ccnv vy cv csn cima cin c0 wceq vy vx cv wrex wi vx wal vx vy vz cA cR
      dffr2 vx cv cA wss vx cv c0 wne wa vx cv cR ccnv vy cv csn cima cin c0
      wceq vy vx cv wrex wi vx cv cA wss vx cv c0 wne wa vx cv vz cv vy cv cR
      wbr vz cab cin c0 wceq vy vx cv wrex wi vx vx cv cR ccnv vy cv csn cima
      cin c0 wceq vy vx cv wrex vx cv vz cv vy cv cR wbr vz cab cin c0 wceq vy
      vx cv wrex vx cv cA wss vx cv c0 wne wa vx cv cR ccnv vy cv csn cima cin
      c0 wceq vx cv vz cv vy cv cR wbr vz cab cin c0 wceq vy vx cv vx cv cR
      ccnv vy cv csn cima cin vx cv vz cv vy cv cR wbr vz cab cin c0 cR ccnv vy
      cv csn cima vz cv vy cv cR wbr vz cab vx cv vy cv cvv wcel cR ccnv vy cv
      csn cima vz cv vy cv cR wbr vz cab wceq vy visset vz cR vy cv cvv iniseg
      ax-mp ineq2i eqeq1i rexbii imbi2i albii bitr4i $.
      $( [3-Feb-2007] $) $( [23-Apr-2004] $)
  $}

  $( Subset theorem for image. $)
  imass1 $p |- ( A C_ B -> ( A " C ) C_ ( B " C ) ) $=
    cA cB wss cA cC cres crn cB cC cres crn cA cC cima cB cC cima cA cB wss cA
    cC cres cB cC cres wss cA cC cres crn cB cC cres crn wss cA cB cC ssres cA
    cC cres cB cC cres rnss syl cA cC df-ima cB cC df-ima 3sstr4g $.
    $( [17-Mar-2004] $) $( [16-Mar-2004] $)

  $( Subset theorem for image.  Exercise 22(a) of [Enderton] p. 53. $)
  imass2 $p |- ( A C_ B -> ( C " A ) C_ ( C " B ) ) $=
    cA cB wss cC cA cres crn cC cB cres crn cC cA cima cC cB cima cA cB wss cC
    cA cres cC cB cres wss cC cA cres crn cC cB cres crn wss cA cB cC ssres2 cC
    cA cres cC cB cres rnss syl cC cA df-ima cC cB df-ima 3sstr4g $.
    $( [22-Mar-1998] $)

  $( The image of a singleton outside the domain is empty. $)
  ndmima $p |- ( -. A e. dom B -> ( B " { A } ) = (/) ) $=
    cA cB cdm wcel wn cB cA csn cres crn c0 cB cA csn cima cA cB cdm wcel wn cB
    cA csn cres cdm c0 wceq cB cA csn cres crn c0 wceq cA cB cdm wcel wn cB cdm
    cA csn cin c0 cB cA csn cres cdm cB cdm cA csn cin c0 wceq cA cB cdm wcel
    wn cB cdm cA disjsn biimpri cB cA csn cres cdm cA csn cB cdm cin cB cdm cA
    csn cin cB cA csn dmres cA csn cB cdm incom eqtri syl5eq cB cA csn cres
    dm0rn0 sylib cB cA csn df-ima syl5eq $.
    $( [22-May-1998] $)

  ${
    $d x y A $.
    $( A converse is a relation.  Theorem 12 of [Suppes] p. 62. $)
    relcnv $p |- Rel `' A $=
      cA ccnv wrel vy cv vx cv cA wbr vx vy copab wrel vy cv vx cv cA wbr vx vy
      relopab cA ccnv vy cv vx cv cA wbr vx vy copab vx vy cA df-cnv releqi
      mpbir $.
      $( [29-Oct-1996] $)
  $}

  ${
    $d x y z R $.
    $( Two ways of saying a relation is transitive.  Definition of
       transitivity in [Schechter] p. 51. $)
    cotr $p |- ( ( R o. R ) C_ R <->
             A. x A. y A. z ( ( x R y /\ y R z ) -> x R z ) ) $=
      cR cR ccom cR wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi vz wal vy wal vx wal cR cR ccom cR wss vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx cR cR ccom cR wss vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vy wal vz wal
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy
      wal cR cR ccom cR wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz
      cv cR wbr wi vy wal vz vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx
      vz copab cR wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx cv vz
      cv cR wbr wi cR cR ccom cR wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi vy wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy
      wex vx vz copab cR wss vx cv vz cv cop vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vy wex vx vz copab wcel vx cv vz cv cR wbr vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vy wex vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex
      vx vz copab cR wss vx cv vz cv cop vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vy wex vx vz copab wcel vx cv vz cv cop cR wcel vx cv vz cv cR wbr vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx vz copab cR vx cv vz cv
      cop ssel vx cv vz cv cR df-br syl6ibr vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vy wex vx vz opabid syl5ibr cR cR ccom vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vy wex vx vz copab cR vx vz vy cR cR df-co sseq1i vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr vy 19.23v 3imtr4i
      19.21aiv vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      vy vz alcom sylibr 19.21aiv vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi vz wal vy wal vx wal vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vy wex vx vz copab cR cR cR ccom vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vy wex vx vz copab vx cv vz cv cR wbr vx vz copab wss
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx vz copab cR wss vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx vz copab vx cv vz cv cR wbr
      vx vz copab wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx cv vz
      cv cR wbr wi vz wal vx wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv
      vz cv cR wbr wi vz wal vy wal vx wal vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vy wex vx cv vz cv cR wbr vx vz ssopab2 vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vy wex vx cv vz cv cR wbr wi vz wal vx vx cv vy cv cR
      wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vy wal vz wal vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vy wex vx cv vz cv cR wbr wi vz wal vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vy vz alcom vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vy wal vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx cv vz cv cR wbr wi vz vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr vy 19.23v albii
      bitri albii bitr4i vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx vz
      copab vx cv vz cv cR wbr vx vz copab wss vx cv vz cv cR wbr vx vz copab
      cR wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx vz copab cR wss
      vx vz cR opabss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vy wex vx vz
      copab vx cv vz cv cR wbr vx vz copab cR sstr2 mpi sylbir vx vz vy cR cR
      df-co syl5ss impbii $.
      $( [27-Dec-1996] $)
  $}

  ${
    $d x y R $.
    $( Two ways of saying a relation is symmetric.  Similar to definition of
       symmetry in [Schechter] p. 51. $)
    cnvsym $p |- ( `' R C_ R <-> A. x A. y ( x R y -> y R x ) ) $=
      cR ccnv cR wss vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal cR
      ccnv cR wss vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx vy cR ccnv cR wss
      vx cv vy cv cR wbr vy vx copab cR wss vx cv vy cv cR wbr vy cv vx cv cR
      wbr wi cR ccnv vx cv vy cv cR wbr vy vx copab cR vy vx cR df-cnv sseq1i
      vx cv vy cv cR wbr vy vx copab cR wss vy cv vx cv cop vx cv vy cv cR wbr
      vy vx copab wcel vy cv vx cv cR wbr vx cv vy cv cR wbr vx cv vy cv cR wbr
      vy vx copab cR wss vy cv vx cv cop vx cv vy cv cR wbr vy vx copab wcel vy
      cv vx cv cop cR wcel vy cv vx cv cR wbr vx cv vy cv cR wbr vy vx copab cR
      vy cv vx cv cop ssel vy cv vx cv cR df-br syl6ibr vx cv vy cv cR wbr vy
      vx opabid syl5ibr sylbi 19.21aivv vx cv vy cv cR wbr vy cv vx cv cR wbr
      wi vy wal vx wal vx cv vy cv cR wbr vy vx copab cR cR ccnv vx cv vy cv cR
      wbr vy cv vx cv cR wbr wi vy wal vx wal vx cv vy cv cR wbr vy vx copab vy
      cv vx cv cR wbr vy vx copab wss vx cv vy cv cR wbr vy vx copab cR wss vx
      cv vy cv cR wbr vy vx copab vy cv vx cv cR wbr vy vx copab wss vx cv vy
      cv cR wbr vy cv vx cv cR wbr wi vx wal vy wal vx cv vy cv cR wbr vy cv vx
      cv cR wbr wi vy wal vx wal vx cv vy cv cR wbr vy cv vx cv cR wbr vy vx
      ssopab2 vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy vx alcom bitri vx cv
      vy cv cR wbr vy vx copab vy cv vx cv cR wbr vy vx copab wss vy cv vx cv
      cR wbr vy vx copab cR wss vx cv vy cv cR wbr vy vx copab cR wss vy vx cR
      opabss vx cv vy cv cR wbr vy vx copab vy cv vx cv cR wbr vy vx copab cR
      sstr2 mpi sylbir vy vx cR df-cnv syl5ss impbii $.
      $( [28-Dec-1996] $)

    $( Two ways of saying a relation is antisymmetric.  Definition of
       antisymmetry in [Schechter] p. 51. $)
    intasym $p |- ( ( R i^i `' R ) C_ _I <->
                  A. x A. y ( ( x R y /\ y R x ) -> x = y ) ) $=
      cR cR ccnv cin cid wss vx cv vy cv cop cR cR ccnv cin wcel vx cv vy cv
      cop cid wcel wi vy wal vx wal vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx
      cv vy cv wceq wi vy wal vx wal cR cR ccnv cin wrel cR cR ccnv cin cid wss
      vx cv vy cv cop cR cR ccnv cin wcel vx cv vy cv cop cid wcel wi vy wal vx
      wal wb cR cR ccnv cin cR ccnv wss cR ccnv wrel cR cR ccnv cin wrel cR cR
      ccnv inss2 cR relcnv cR cR ccnv cin cR ccnv relss mp2 vx vy cR cR ccnv
      cin cid ssrel ax-mp vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv
      wceq wi vx cv vy cv cop cR cR ccnv cin wcel vx cv vy cv cop cid wcel wi
      vx vy vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv cop cR cR ccnv
      cin wcel vx cv vy cv wceq vx cv vy cv cop cid wcel vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa vx cv vy cv cop cR wcel vx cv vy cv cop cR ccnv wcel
      wa vx cv vy cv cop cR cR ccnv cin wcel vx cv vy cv cR wbr vx cv vy cv cop
      cR wcel vy cv vx cv cR wbr vx cv vy cv cop cR ccnv wcel vx cv vy cv cR
      df-br vy cv vx cv cR wbr vx cv vy cv cR ccnv wbr vx cv vy cv cop cR ccnv
      wcel vx cv vy cv cR vx visset vy visset brcnv vx cv vy cv cR ccnv df-br
      bitr3i anbi12i vx cv vy cv cop cR cR ccnv elin bitr4i vx cv vy cv wceq vx
      cv vy cv cid wbr vx cv vy cv cop cid wcel vx cv vy cv vy visset ideq vx
      cv vy cv cid df-br bitr3i imbi12i 2albii bitr4i $.
      $( [31-Oct-2004] $) $( [9-Sep-2004] $)

    $( Two ways of saying a relation is antisymmetric and reflexive.
       ` U. U. R ` is the field of a relation by ~ relfld . $)
    asymref $p |- ( ( R i^i `' R ) = ( _I |` U. U. R ) <->
       A. x e. U. U. R A. y ( ( x R y /\ y R x ) <-> x = y ) ) $=
      cR cR ccnv cin cid cR cuni cuni cres wceq vx cv vy cv cop cR cR ccnv cin
      wcel vx cv vy cv cop cid cR cuni cuni cres wcel wb vy wal vx wal vx cv cR
      cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq
      wb wi vy wal vx wal vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv
      wceq wb vy wal vx cR cuni cuni wral cR cR ccnv cin wrel cid cR cuni cuni
      cres wrel cR cR ccnv cin cid cR cuni cuni cres wceq vx cv vy cv cop cR cR
      ccnv cin wcel vx cv vy cv cop cid cR cuni cuni cres wcel wb vy wal vx wal
      wb cR cR ccnv cin cR ccnv wss cR ccnv wrel cR cR ccnv cin wrel cR cR ccnv
      inss2 cR relcnv cR cR ccnv cin cR ccnv relss mp2 cid cR cuni cuni relres
      vx vy cR cR ccnv cin cid cR cuni cuni cres eqrel mp2an vx cv vy cv cop cR
      cR ccnv cin wcel vx cv vy cv cop cid cR cuni cuni cres wcel wb vx cv cR
      cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq
      wb wi vx vy vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq vx
      cv cR cuni cuni wcel wa wb vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa wa vx cv cR cuni cuni wcel vx cv vy cv wceq wa wb vx
      cv vy cv cop cR cR ccnv cin wcel vx cv vy cv cop cid cR cuni cuni cres
      wcel wb vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa
      vx cv vy cv wceq wb wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv cR
      cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa wa vx cv vy cv
      wceq vx cv cR cuni cuni wcel wa vx cv cR cuni cuni wcel vx cv vy cv wceq
      wa vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv cR cuni cuni wcel vx cv
      vy cv cR wbr wa vy cv vx cv cR wbr wa vx cv cR cuni cuni wcel vx cv vy cv
      cR wbr vy cv vx cv cR wbr wa wa vx cv vy cv cR wbr vx cv cR cuni cuni
      wcel vx cv vy cv cR wbr wa vy cv vx cv cR wbr vx cv vy cv cR wbr vx cv cR
      cuni cuni wcel vx cv vy cv cR wbr vx cv cR cdm wcel vx cv cR cuni cuni
      wcel vx cv vy cv cR vx visset breldm cR cdm cR cuni cuni vx cv cR cdm cR
      cdm cR crn cun cR cuni cuni cR cdm cR crn ssun1 cR dmrnssfld sstri sseli
      syl pm4.71ri anbi1i vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx
      cv cR wbr anass bitri vx cv vy cv wceq vx cv cR cuni cuni wcel ancom
      bibi12i vx cv vy cv cop cR cR ccnv cin wcel vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv cop cid cR cuni cuni cres wcel vx cv vy cv wceq
      vx cv cR cuni cuni wcel wa vx cv vy cv cop cR cR ccnv cin wcel vx cv vy
      cv cop cR wcel vx cv vy cv cop cR ccnv wcel wa vx cv vy cv cR wbr vy cv
      vx cv cR wbr wa vx cv vy cv cop cR cR ccnv elin vx cv vy cv cR wbr vx cv
      vy cv cop cR wcel vy cv vx cv cR wbr vx cv vy cv cop cR ccnv wcel vx cv
      vy cv cR df-br vy cv vx cv cR wbr vx cv vy cv cR ccnv wbr vx cv vy cv cop
      cR ccnv wcel vx cv vy cv cR vx visset vy visset brcnv vx cv vy cv cR ccnv
      df-br bitr3i anbi12i bitr4i vx cv vy cv cop cid cR cuni cuni cres wcel vx
      cv vy cv cop cid wcel vx cv cR cuni cuni wcel wa vx cv vy cv wceq vx cv
      cR cuni cuni wcel wa vx cv vy cv cid cR cuni cuni vy visset opelres vx cv
      vy cv wceq vx cv vy cv cop cid wcel vx cv cR cuni cuni wcel vx cv vy cv
      wceq vx cv vy cv cid wbr vx cv vy cv cop cid wcel vx cv vy cv vy visset
      ideq vx cv vy cv cid df-br bitr3i anbi1i bitr4i bibi12i vx cv cR cuni
      cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq
      pm5.32 3bitr4i 2albii vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv wceq wb wi vy wal vx wal vx cv cR cuni cuni wcel
      vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal wi vx
      wal vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal
      vx cR cuni cuni wral vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv wceq wb wi vy wal vx cv cR cuni cuni wcel vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal wi vx vx cv
      cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv
      wceq wb vy 19.21v albii vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy
      cv wceq wb vy wal vx cR cuni cuni df-ral bitr4i 3bitri $.
      $( [15-May-2008] $) $( [6-May-2008] $)

    $( Two ways of saying a relation is antisymmetric and reflexive. $)
    asymref2 $p |- ( ( R i^i `' R ) = ( _I |` U. U. R ) <->
   ( A. x e. U. U. R x R x /\ A. x A. y ( ( x R y /\ y R x ) -> x = y ) ) ) $=
      vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal vx cR
      cuni cuni wral vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx wal vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal vx wal wa
      cR cR ccnv cin cid cR cuni cuni cres wceq vx cv vx cv cR wbr vx cR cuni
      cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy
      wal vx wal wa vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq
      wb vy wal vx cR cuni cuni wral vx cv cR cuni cuni wcel vx cv vy cv cR wbr
      vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal wi vx wal vx cv cR cuni
      cuni wcel vx cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa
      vx cv vy cv wceq wi vy wal wa vx wal vx cv cR cuni cuni wcel vx cv vx cv
      cR wbr wi vx wal vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv
      wceq wi vy wal vx wal wa vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv
      vy cv wceq wb vy wal vx cR cuni cuni df-ral vx cv cR cuni cuni wcel vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal wi vx cv cR
      cuni cuni wcel vx cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa vx cv vy cv wceq wi vy wal wa vx vx cv cR cuni cuni wcel vx cv vy
      cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal wi vx cv cR
      cuni cuni wcel vx cv vx cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr
      wa vx cv vy cv wceq wi vy wal wa wi vx cv cR cuni cuni wcel vx cv vx cv
      cR wbr wi vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr
      wa vx cv vy cv wceq wi vy wal wi wa vx cv cR cuni cuni wcel vx cv vx cv
      cR wbr wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy
      wal wa vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy
      wal vx cv vx cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy
      cv wceq wi vy wal wa vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv wceq wb vy wal vx cv vx cv cR wbr vx cv vy cv cR
      wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal wa vx cv vy cv cR
      wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vy wal vx cv vx cv cR wbr
      vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vx cv vx cv cR wbr
      vy vx vy cv vx cv wceq vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy
      cv wceq wb vx cv vx cv cR wbr vx cv vx cv wceq wb vx cv vx cv cR wbr vy
      cv vx cv wceq vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vx cv cR wbr
      vx cv vy cv wceq vx cv vx cv wceq vy cv vx cv wceq vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx cv
      cR wbr vy cv vx cv wceq vx cv vy cv cR wbr vx cv vx cv cR wbr vy cv vx cv
      cR wbr vx cv vx cv cR wbr vy cv vx cv vx cv cR breq2 vy cv vx cv vx cv cR
      breq1 anbi12d vx cv vx cv cR wbr anidm syl6bb vy vx vx equequ2 bibi12d vx
      cv vx cv wceq vx cv vx cv cR wbr vx equid tbt syl6bbr a4v vx cv vy cv cR
      wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wb vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv wceq wi vy vx cv vy cv cR wbr vy cv vx cv cR wbr
      wa vx cv vy cv wceq bi1 19.20i jca vx cv vx cv cR wbr vx cv vy cv cR wbr
      vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal vx cv vy cv cR wbr vy cv
      vx cv cR wbr wa vx cv vy cv wceq wb vy wal vx cv vx cv cR wbr vx cv vy cv
      cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vx cv vy cv cR wbr vy cv
      vx cv cR wbr wa vx cv vy cv wceq wb vy vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa vx cv vy cv wceq wi vx cv vy cv wceq vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq
      wb vx cv vx cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy
      cv wceq bi3 vx cv vx cv cR wbr vx cv vy cv wceq vx cv vy cv cR wbr vy cv
      vx cv cR wbr vx cv vy cv wceq vx cv vx cv cR wbr vx cv vy cv cR wbr vx cv
      vy cv vx cv cR breq2 biimpcd vx cv vy cv wceq vx cv vx cv cR wbr vy cv vx
      cv cR wbr vx cv vy cv vx cv cR breq1 biimpcd jcad syl5com 19.20dv imp
      impbii imbi2i vx cv cR cuni cuni wcel vx cv vx cv cR wbr vx cv vy cv cR
      wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal pm4.76 vx cv cR cuni
      cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy
      wal wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy
      wal vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal vx cv cR cuni cuni wcel vx
      cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi wi vy wal vx cv
      cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv
      wceq wi vy wal wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv
      wceq wi vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wa
      vx cv vy cv wceq wi wi vy vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv
      vy cv wceq wi vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa wa vx cv vy cv wceq wi vx cv cR cuni cuni wcel vx cv vy cv cR wbr
      vy cv vx cv cR wbr wa vx cv vy cv wceq wi wi vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa wa vx cv vy cv wceq vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv
      cR cuni cuni wcel vx cv vy cv cR wbr vx cv cR cuni cuni wcel vy cv vx cv
      cR wbr vx cv vy cv cR wbr vx cv cR cdm wcel vx cv cR cuni cuni wcel vx cv
      vy cv cR vx visset breldm cR cdm cR cuni cuni vx cv cR cdm cR cdm cR crn
      cun cR cuni cuni cR cdm cR crn ssun1 cR dmrnssfld sstri sseli syl adantr
      pm4.71ri imbi1i vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa vx cv vy cv wceq impexp bitri albii vx cv cR cuni cuni wcel vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy 19.21v bitr2i
      anbi2i 3bitr2i albii vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal vx 19.26
      3bitri vx vy cR asymref vx cv vx cv cR wbr vx cR cuni cuni wral vx cv cR
      cuni cuni wcel vx cv vx cv cR wbr wi vx wal vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv wceq wi vy wal vx wal vx cv vx cv cR wbr vx cR
      cuni cuni df-ral anbi1i 3bitr4i $.
      $( [15-May-2008] $) $( [6-May-2008] $)

    $( Two ways of saying a relation is irreflexive.  Definition of
       irreflexivity in [Schechter] p. 51. $)
    intirr $p |- ( ( R i^i _I ) = (/) <-> A. x -. x R x ) $=
      cR cid cin c0 wceq vx cv vy cv cop cR cid cin wcel vx cv vy cv cop c0
      wcel wb vy wal vx wal vx cv vx cv cR wbr wn vx wal cR cid cin wrel c0
      wrel cR cid cin c0 wceq vx cv vy cv cop cR cid cin wcel vx cv vy cv cop
      c0 wcel wb vy wal vx wal wb cR cid cin cid wss cid wrel cR cid cin wrel
      cR cid inss2 reli cR cid cin cid relss mp2 rel0 vx vy cR cid cin c0 eqrel
      mp2an vx cv vy cv cop cR cid cin wcel vx cv vy cv cop c0 wcel wb vy wal
      vx cv vx cv cR wbr wn vx vx cv vx cv cR wbr vx cv vy cv cop cR cid cin
      wcel vx cv vy cv cop c0 wcel wb vy wal vx cv vx cv cR wbr vy cv vx cv
      wceq vx cv vy cv cop cR wcel wa vy wex vx cv vy cv cop cR cid cin wcel vx
      cv vy cv cop c0 wcel wb wn vy wex vx cv vy cv cop cR cid cin wcel vx cv
      vy cv cop c0 wcel wb vy wal wn vx cv vx cv cR wbr vx cv vx cv cop cR wcel
      vy cv vx cv wceq vx cv vy cv cop cR wcel wa vy wex vx cv vx cv cR df-br
      vx cv vy cv cop cR wcel vx cv vx cv cop cR wcel vy vx cv vx visset vy cv
      vx cv wceq vx cv vy cv cop vx cv vx cv cop cR vy cv vx cv vx cv opeq2
      eleq1d ceqsexv bitr4i vy cv vx cv wceq vx cv vy cv cop cR wcel wa vx cv
      vy cv cop cR cid cin wcel vx cv vy cv cop c0 wcel wb wn vy vx cv vy cv
      cop cR cid cin wcel vx cv vy cv cop c0 wcel wb wn vx cv vy cv cop cR cid
      cin wcel vy cv vx cv wceq vx cv vy cv cop cR wcel wa vx cv vy cv cop cR
      cid cin wcel vx cv vy cv cop cR cid cin wcel vx cv vy cv cop c0 wcel wb
      vx cv vy cv cop c0 wcel vx cv vy cv cop cR cid cin wcel vx cv vy cv cop
      noel nbn con1bii vx cv vy cv cop cR wcel vy cv vx cv wceq wa vx cv vy cv
      cop cR wcel vx cv vy cv cop cid wcel wa vy cv vx cv wceq vx cv vy cv cop
      cR wcel wa vx cv vy cv cop cR cid cin wcel vy cv vx cv wceq vx cv vy cv
      cop cid wcel vx cv vy cv cop cR wcel vx cv vy cv cid wbr vx cv vy cv wceq
      vx cv vy cv cop cid wcel vy cv vx cv wceq vx cv vy cv vy visset ideq vx
      cv vy cv cid df-br vx cv vy cv eqcom 3bitr3ri anbi2i vy cv vx cv wceq vx
      cv vy cv cop cR wcel ancom vx cv vy cv cop cR cid elin 3bitr4ri bitr2i
      exbii vx cv vy cv cop cR cid cin wcel vx cv vy cv cop c0 wcel wb vy exnal
      3bitri con2bii albii bitri $.
      $( [2-Nov-2004] $) $( [9-Sep-2004] $)
  $}

  ${
    soi.1 $e |- A e. _V $.
    soi.2 $e |- R Or S $.
    soi.3 $e |- R C_ ( S X. S ) $.
    $( A strict order relation is irreflexive. $)
    soirri $p |- -. A R A $=
      cA cS wcel cA cS wcel wa cA cA cR wbr wn cA cS wcel cA cA cR wbr wn cA cS
      wcel cS cR wor cA cS wcel cA cA cR wbr wn soi.2 cS cA cR sonr mpan adantl
      cA cA cR wbr cA cS wcel cA cS wcel wa cA cA cS cS cR soi.1 soi.3 brel
      con3i pm2.61i $.
      $( [10-Feb-1996] $)

    ${
      sotri.4 $e |- B e. _V $.
      sotri.5 $e |- C e. _V $.
      $( A strict order relation is a transitive relation. $)
      sotri $p |- ( ( A R B /\ B R C ) -> A R C ) $=
        cA cS wcel cB cS wcel cC cS wcel w3a cA cB cR wbr cB cC cR wbr wa cA cC
        cR wbr cA cS wcel cB cS wcel wa cB cS wcel cC cS wcel wa cA cS wcel cB
        cS wcel cC cS wcel w3a cA cB cR wbr cB cC cR wbr cA cS wcel cB cS wcel
        cB cS wcel cC cS wcel cA cS wcel cB cS wcel cC cS wcel w3a cA cS wcel
        cB cS wcel cC cS wcel cA cS wcel cB cS wcel cC cS wcel w3a wi cB cS
        wcel cA cS wcel cB cS wcel cC cS wcel cA cS wcel cB cS wcel cC cS wcel
        w3a cA cS wcel cB cS wcel cC cS wcel w3a id 3exp a1dd imp43 cA cB cS cS
        cR sotri.4 soi.3 brel cB cC cS cS cR sotri.5 soi.3 brel syl2an cS cR
        wor cA cS wcel cB cS wcel cC cS wcel w3a cA cB cR wbr cB cC cR wbr wa
        cA cC cR wbr wi soi.2 cS cA cB cC cR sotr mpan mpcom $.
        $( [10-Feb-1996] $)
    $}

    ${
      son2lpi.4 $e |- B e. _V $.
      $( A strict order relation has no 2-cycle loops. $)
      son2lpi $p |- -. ( A R B /\ B R A ) $=
        cA cB cR wbr cB cA cR wbr wa cA cA cR wbr cA cR cS soi.1 soi.2 soi.3
        soirri cA cB cA cR cS soi.1 soi.2 soi.3 son2lpi.4 soi.1 sotri mto $.
        $( [10-Feb-1996] $)
    $}
  $}

  ${
    $d x y z w $.  $d z w ph $.
    $( The converse of a class abstraction of ordered pairs. $)
    cnvopab $p |- `' { <. x , y >. | ph } = { <. y , x >. | ph } $=
      vw vz wph vx vy copab ccnv wph vy vx copab wph vx vy copab relcnv wph vy
      vx relopab vw cv vz cv cop wph vx vy copab ccnv wcel vz cv vw cv cop wph
      vx vy copab wcel vw cv vz cv cop wph vy vx copab wcel vw cv vz cv wph vx
      vy copab vw visset vz visset opelcnv vx cv vw cv cop wph vx vy copab wcel
      vw cv vx cv cop wph vy vx copab wcel wb vz cv vw cv cop wph vx vy copab
      wcel vw cv vz cv cop wph vy vx copab wcel wb vx vz vz cv vw cv cop wph vx
      vy copab wcel vw cv vz cv cop wph vy vx copab wcel vx vx vy vz vz cv vw
      cv cop wph vx vy copab vy cv vz cv vw cv cop wcel vx ax-17 wph vx vy vz
      hbopab1 hbel vx vy vz vw cv vz cv cop wph vy vx copab vy cv vw cv vz cv
      cop wcel vx ax-17 wph vy vx vz hbopab2 hbel hbbi vx cv vz cv wceq vx cv
      vw cv cop wph vx vy copab wcel vz cv vw cv cop wph vx vy copab wcel vw cv
      vx cv cop wph vy vx copab wcel vw cv vz cv cop wph vy vx copab wcel vx cv
      vz cv wceq vx cv vw cv cop vz cv vw cv cop wph vx vy copab vx cv vz cv vw
      cv opeq1 eleq1d vx cv vz cv wceq vw cv vx cv cop vw cv vz cv cop wph vy
      vx copab vx cv vz cv vw cv opeq2 eleq1d bibi12d vx cv vy cv cop wph vx vy
      copab wcel vy cv vx cv cop wph vy vx copab wcel wb vx cv vw cv cop wph vx
      vy copab wcel vw cv vx cv cop wph vy vx copab wcel wb vy vw vx cv vw cv
      cop wph vx vy copab wcel vw cv vx cv cop wph vy vx copab wcel vy vy vz vz
      vx cv vw cv cop wph vx vy copab vz cv vx cv vw cv cop wcel vy ax-17 wph
      vx vy vz hbopab2 hbel vy vz vz vw cv vx cv cop wph vy vx copab vz cv vw
      cv vx cv cop wcel vy ax-17 wph vy vx vz hbopab1 hbel hbbi vy cv vw cv
      wceq vx cv vy cv cop wph vx vy copab wcel vx cv vw cv cop wph vx vy copab
      wcel vy cv vx cv cop wph vy vx copab wcel vw cv vx cv cop wph vy vx copab
      wcel vy cv vw cv wceq vx cv vy cv cop vx cv vw cv cop wph vx vy copab vy
      cv vw cv vx cv opeq2 eleq1d vy cv vw cv wceq vy cv vx cv cop vw cv vx cv
      cop wph vy vx copab vy cv vw cv vx cv opeq1 eleq1d bibi12d vx cv vy cv
      cop wph vx vy copab wcel wph vy cv vx cv cop wph vy vx copab wcel wph vx
      vy opabid wph vy vx opabid bitr4i chvar chvar bitri eqrelriv $.
      $( [18-Dec-2003] $) $( [11-Dec-2003] $)
  $}

  ${
    $d x y $.
    $( The converse of the empty set. $)
    cnv0 $p |- `' (/) = (/) $=
      vx vy c0 ccnv c0 c0 relcnv rel0 vx cv vy cv cop c0 ccnv wcel vy cv vx cv
      cop c0 wcel vx cv vy cv cop c0 wcel vx cv vy cv c0 vx visset vy visset
      opelcnv vx cv vy cv cop c0 wcel vy cv vx cv cop c0 wcel vx cv vy cv cop
      noel vy cv vx cv cop noel 2false bitr4i eqrelriv $.
      $( [6-Apr-1998] $)

    $( The converse of the identity relation.  Theorem 3.7(ii) of [Monk1]
       p. 36. $)
    cnvi $p |- `' _I = _I $=
      vx vy cid ccnv cid cid relcnv reli vx cv vy cv wceq vy cv vx cv wceq vx
      cv vy cv cop cid wcel vx cv vy cv cop cid ccnv wcel vx cv vy cv eqcom vx
      cv vy cv cop cid wcel vx cv vy cv cid wbr vx cv vy cv wceq vx cv vy cv
      cid df-br vx cv vy cv vy visset ideq bitr3i vx cv vy cv cid ccnv wbr vy
      cv vx cv cid wbr vx cv vy cv cop cid ccnv wcel vy cv vx cv wceq vx cv vy
      cv cid vx visset vy visset brcnv vx cv vy cv cid ccnv df-br vy cv vx cv
      vx visset ideq 3bitr3i 3bitr4ri eqrelriv $.
      $( [26-Apr-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The converse of a union is the union of converses.  Theorem 16 of
       [Suppes] p. 62. $)
    cnvun $p |- `' ( A u. B ) = ( `' A u. `' B ) $=
      vx vy cA cB cun ccnv cA ccnv cB ccnv cun cA cB cun relcnv cA ccnv cB ccnv
      cun wrel cA ccnv wrel cB ccnv wrel cA ccnv cB ccnv relun cA relcnv cB
      relcnv mpbir2an vy cv vx cv cop cA cB cun wcel vx cv vy cv cop cA ccnv
      wcel vx cv vy cv cop cB ccnv wcel wo vx cv vy cv cop cA cB cun ccnv wcel
      vx cv vy cv cop cA ccnv cB ccnv cun wcel vy cv vx cv cop cA cB cun wcel
      vy cv vx cv cop cA wcel vy cv vx cv cop cB wcel wo vx cv vy cv cop cA
      ccnv wcel vx cv vy cv cop cB ccnv wcel wo vy cv vx cv cop cA cB elun vx
      cv vy cv cop cA ccnv wcel vy cv vx cv cop cA wcel vx cv vy cv cop cB ccnv
      wcel vy cv vx cv cop cB wcel vx cv vy cv cA vx visset vy visset opelcnv
      vx cv vy cv cB vx visset vy visset opelcnv orbi12i bitr4i vx cv vy cv cA
      cB cun vx visset vy visset opelcnv vx cv vy cv cop cA ccnv cB ccnv elun
      3bitr4i eqrelriv $.
      $( [25-Mar-1998] $)

    $( Distributive law for converse over intersection.  Theorem 15 of [Suppes]
       p. 62. $)
    cnvin $p |- `' ( A i^i B ) = ( `' A i^i `' B ) $=
      vx vy cA cB cin ccnv cA ccnv cB ccnv cin cA cB cin relcnv cA ccnv wrel cA
      ccnv cB ccnv cin wrel cA relcnv cA ccnv cB ccnv relin1 ax-mp vy cv vx cv
      cop cA cB cin wcel vx cv vy cv cop cA ccnv wcel vx cv vy cv cop cB ccnv
      wcel wa vx cv vy cv cop cA cB cin ccnv wcel vx cv vy cv cop cA ccnv cB
      ccnv cin wcel vy cv vx cv cop cA cB cin wcel vy cv vx cv cop cA wcel vy
      cv vx cv cop cB wcel wa vx cv vy cv cop cA ccnv wcel vx cv vy cv cop cB
      ccnv wcel wa vy cv vx cv cop cA cB elin vx cv vy cv cop cA ccnv wcel vy
      cv vx cv cop cA wcel vx cv vy cv cop cB ccnv wcel vy cv vx cv cop cB wcel
      vx cv vy cv cA vx visset vy visset opelcnv vx cv vy cv cB vx visset vy
      visset opelcnv anbi12i bitr4i vx cv vy cv cA cB cin vx visset vy visset
      opelcnv vx cv vy cv cop cA ccnv cB ccnv elin 3bitr4i eqrelriv $.
      $( [25-Mar-1998] $)
  $}

  $( Distributive law for range over union.  Theorem 8 of [Suppes] p. 60. $)
  rnun $p |- ran ( A u. B ) = ( ran A u. ran B ) $=
    cA cB cun ccnv cdm cA ccnv cdm cB ccnv cdm cun cA cB cun crn cA crn cB crn
    cun cA cB cun ccnv cdm cA ccnv cB ccnv cun cdm cA ccnv cdm cB ccnv cdm cun
    cA cB cun ccnv cA ccnv cB ccnv cun cA cB cnvun dmeqi cA ccnv cB ccnv dmun
    eqtri cA cB cun df-rn cA crn cA ccnv cdm cB crn cB ccnv cdm cA df-rn cB
    df-rn uneq12i 3eqtr4i $.
    $( [24-Mar-1998] $)

  $( The range of an intersection belongs the intersection of ranges.  Theorem
     9 of [Suppes] p. 60. $)
  rnin $p |- ran ( A i^i B ) C_ ( ran A i^i ran B ) $=
    cA cB cin ccnv cdm cA ccnv cdm cB ccnv cdm cin cA cB cin crn cA crn cB crn
    cin cA cB cin ccnv cdm cA ccnv cB ccnv cin cdm cA ccnv cdm cB ccnv cdm cin
    cA cB cin ccnv cA ccnv cB ccnv cin cA cB cnvin dmeqi cA ccnv cB ccnv dmin
    eqsstri cA cB cin df-rn cA crn cA ccnv cdm cB crn cB ccnv cdm cA df-rn cB
    df-rn ineq12i 3sstr4i $.
    $( [3-Oct-2004] $) $( [15-Sep-2004] $)

  ${
    $d x y z A $.
    $( The range of a union.  Part of Exercise 8 of [Enderton] p. 41. $)
    rnuni $p |- ran U. A = U_ x e. A ran x $=
      vz cA cuni crn vx cA vx cv crn ciun vy cv vz cv cop cA cuni wcel vy wex
      vz cv vx cv crn wcel vx cA wrex vz cv cA cuni crn wcel vz cv vx cA vx cv
      crn ciun wcel vy cv vz cv cop cA cuni wcel vy wex vx cv cA wcel vz cv vx
      cv crn wcel wa vx wex vz cv vx cv crn wcel vx cA wrex vy cv vz cv cop cA
      cuni wcel vy wex vy cv vz cv cop vx cv wcel vx cv cA wcel wa vx wex vy
      wex vy cv vz cv cop vx cv wcel vx cv cA wcel wa vy wex vx wex vx cv cA
      wcel vz cv vx cv crn wcel wa vx wex vy cv vz cv cop cA cuni wcel vy cv vz
      cv cop vx cv wcel vx cv cA wcel wa vx wex vy vx vy cv vz cv cop cA eluni
      exbii vy cv vz cv cop vx cv wcel vx cv cA wcel wa vy vx excom vy cv vz cv
      cop vx cv wcel vx cv cA wcel wa vy wex vx cv cA wcel vz cv vx cv crn wcel
      wa vx vy cv vz cv cop vx cv wcel vy wex vx cv cA wcel wa vx cv cA wcel vy
      cv vz cv cop vx cv wcel vy wex wa vy cv vz cv cop vx cv wcel vx cv cA
      wcel wa vy wex vx cv cA wcel vz cv vx cv crn wcel wa vy cv vz cv cop vx
      cv wcel vy wex vx cv cA wcel ancom vy cv vz cv cop vx cv wcel vx cv cA
      wcel vy 19.41v vz cv vx cv crn wcel vy cv vz cv cop vx cv wcel vy wex vx
      cv cA wcel vy vz cv vx cv vz visset elrn2 anbi2i 3bitr4i exbii 3bitri vz
      cv vx cv crn wcel vx cA df-rex bitr4i vy vz cv cA cuni vz visset elrn2 vx
      vz cv cA vx cv crn eliun 3bitr4i eqriv $.
      $( [18-Mar-2004] $) $( [17-Mar-2004] $)
  $}

  $( Distributive law for image over union.  Theorem 35 of [Suppes] p. 65. $)
  imaundi $p |- ( A " ( B u. C ) ) = ( ( A " B ) u. ( A " C ) ) $=
    cA cB cC cun cres crn cA cB cres crn cA cC cres crn cun cA cB cC cun cima
    cA cB cima cA cC cima cun cA cB cC cun cres crn cA cB cres cA cC cres cun
    crn cA cB cres crn cA cC cres crn cun cA cB cC cun cres cA cB cres cA cC
    cres cun cA cB cC resundi rneqi cA cB cres cA cC cres rnun eqtri cA cB cC
    cun df-ima cA cB cima cA cB cres crn cA cC cima cA cC cres crn cA cB df-ima
    cA cC df-ima uneq12i 3eqtr4i $.
    $( [30-Sep-2002] $)

  $( The image of a union. (Contributed by Jeff Hoffman, 17-Feb-2008.) $)
  imaundir $p |- ( ( A u. B ) " C ) = ( ( A " C ) u. ( B " C ) ) $=
    cA cB cun cC cima cA cC cres crn cB cC cres crn cun cA cC cima cB cC cima
    cun cA cB cun cC cima cA cB cun cC cres crn cA cC cres cB cC cres cun crn
    cA cC cres crn cB cC cres crn cun cA cB cun cC df-ima cA cB cun cC cres cA
    cC cres cB cC cres cun cA cB cC resundir rneqi cA cC cres cB cC cres rnun
    3eqtri cA cC cima cA cC cres crn cB cC cima cB cC cres crn cA cC df-ima cB
    cC df-ima uneq12i eqtr4i $.
    $( [19-Feb-2008] $) $( [17-Feb-2008] $)

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( An upper bound for intersection with a domain.  Theorem 40 of [Suppes]
       p. 66, who calls it "somewhat surprising." $)
    dminss $p |- ( dom R i^i A ) C_ ( `' R " ( R " A ) ) $=
      vx cR cdm cA cin cR ccnv cR cA cima cima vx cv vy cv cR wbr vx cv cA wcel
      wa vy wex vy cv cR cA cima wcel vy cv vx cv cR ccnv wbr wa vy wex vx cv
      cR cdm cA cin wcel vx cv cR ccnv cR cA cima cima wcel vx cv vy cv cR wbr
      vx cv cA wcel wa vy cv cR cA cima wcel vy cv vx cv cR ccnv wbr wa vy vx
      cv vy cv cR wbr vx cv cA wcel wa vy cv cR cA cima wcel vy cv vx cv cR
      ccnv wbr vx cv vy cv cR wbr vx cv cA wcel wa vx cv cA wcel vx cv vy cv cR
      wbr wa vx wex vy cv cR cA cima wcel vx cv cA wcel vx cv vy cv cR wbr vx
      cv cA wcel vx cv vy cv cR wbr wa vx wex vx cv cA wcel vx cv vy cv cR wbr
      wa vx 19.8a ancoms vx vy cv cR cA vy visset elima2 sylibr vx cv vy cv cR
      wbr vx cv cA wcel wa vx cv vy cv cR wbr vy cv vx cv cR ccnv wbr vx cv vy
      cv cR wbr vx cv cA wcel pm3.26 vy cv vx cv cR vy visset vx visset brcnv
      sylibr jca 19.22i vx cv cR cdm wcel vx cv cA wcel wa vx cv vy cv cR wbr
      vy wex vx cv cA wcel wa vx cv cR cdm cA cin wcel vx cv vy cv cR wbr vx cv
      cA wcel wa vy wex vx cv cR cdm wcel vx cv vy cv cR wbr vy wex vx cv cA
      wcel vy vx cv cR vx visset eldm anbi1i vx cv cR cdm cA elin vx cv vy cv
      cR wbr vx cv cA wcel vy 19.41v 3bitr4i vy vx cv cR ccnv cR cA cima vx
      visset elima2 3imtr4i ssriv $.
      $( [26-Aug-2004] $) $( [11-Aug-2004] $)

    $( An upper bound for intersection with an image.  Theorem 41 of [Suppes]
       p. 66. $)
    imainss $p |- ( ( R " A ) i^i B ) C_ ( R " ( A i^i ( `' R " B ) ) ) $=
      vy cR cA cima cB cin cR cA cR ccnv cB cima cin cima vx cv cA wcel vx cv
      vy cv cR wbr wa vy cv cB wcel wa vx wex vx cv cA cR ccnv cB cima cin wcel
      vx cv vy cv cR wbr wa vx wex vy cv cR cA cima cB cin wcel vy cv cR cA cR
      ccnv cB cima cin cima wcel vx cv cA wcel vx cv vy cv cR wbr wa vy cv cB
      wcel wa vx cv cA cR ccnv cB cima cin wcel vx cv vy cv cR wbr wa vx vx cv
      cA wcel vx cv vy cv cR wbr wa vy cv cB wcel wa vx cv cA wcel vy cv cB
      wcel vy cv vx cv cR ccnv wbr wa vy wex wa vx cv vy cv cR wbr wa vx cv cA
      cR ccnv cB cima cin wcel vx cv vy cv cR wbr wa vx cv cA wcel vx cv vy cv
      cR wbr vy cv cB wcel vx cv cA wcel vy cv cB wcel vy cv vx cv cR ccnv wbr
      wa vy wex wa vx cv vy cv cR wbr wa vx cv cA wcel vx cv vy cv cR wbr vy cv
      cB wcel wa wa vx cv cA wcel vy cv cB wcel vy cv vx cv cR ccnv wbr wa vy
      wex wa vx cv vy cv cR wbr vx cv vy cv cR wbr vy cv cB wcel wa vy cv cB
      wcel vy cv vx cv cR ccnv wbr wa vy wex vx cv cA wcel vy cv cB wcel vx cv
      vy cv cR wbr vy cv cB wcel vy cv vx cv cR ccnv wbr wa vy wex vy cv cB
      wcel vy cv vx cv cR ccnv wbr vy cv cB wcel vy cv vx cv cR ccnv wbr wa vy
      wex vx cv vy cv cR wbr vy cv cB wcel vy cv vx cv cR ccnv wbr wa vy 19.8a
      vy cv vx cv cR vy visset vx visset brcnv sylan2br ancoms anim2i vx cv cA
      wcel vx cv vy cv cR wbr vy cv cB wcel simprl jca anassrs vx cv cA cR ccnv
      cB cima cin wcel vx cv cA wcel vy cv cB wcel vy cv vx cv cR ccnv wbr wa
      vy wex wa vx cv vy cv cR wbr vx cv cA cR ccnv cB cima cin wcel vx cv cA
      wcel vx cv cR ccnv cB cima wcel wa vx cv cA wcel vy cv cB wcel vy cv vx
      cv cR ccnv wbr wa vy wex wa vx cv cA cR ccnv cB cima elin vx cv cR ccnv
      cB cima wcel vy cv cB wcel vy cv vx cv cR ccnv wbr wa vy wex vx cv cA
      wcel vy vx cv cR ccnv cB vx visset elima2 anbi2i bitri anbi1i sylibr
      19.22i vy cv cR cA cima wcel vy cv cB wcel wa vx cv cA wcel vx cv vy cv
      cR wbr wa vx wex vy cv cB wcel wa vy cv cR cA cima cB cin wcel vx cv cA
      wcel vx cv vy cv cR wbr wa vy cv cB wcel wa vx wex vy cv cR cA cima wcel
      vx cv cA wcel vx cv vy cv cR wbr wa vx wex vy cv cB wcel vx vy cv cR cA
      vy visset elima2 anbi1i vy cv cR cA cima cB elin vx cv cA wcel vx cv vy
      cv cR wbr wa vy cv cB wcel vx 19.41v 3bitr4i vx vy cv cR cA cR ccnv cB
      cima cin vy visset elima2 3imtr4i ssriv $.
      $( [9-Sep-2004] $) $( [11-Aug-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The converse of a cross product.  Exercise 11 of [Suppes] p. 67. $)
    cnvxp $p |- `' ( A X. B ) = ( B X. A ) $=
      vx vy cA cB cxp ccnv cB cA cxp cA cB cxp relcnv cB cA relxp vx cv vy cv
      cop cA cB cxp ccnv wcel vy cv vx cv cop cA cB cxp wcel vx cv vy cv cop cB
      cA cxp wcel vx cv vy cv cA cB cxp vx visset vy visset opelcnv vy cv cA
      wcel vx cv cB wcel wa vx cv cB wcel vy cv cA wcel wa vy cv vx cv cop cA
      cB cxp wcel vx cv vy cv cop cB cA cxp wcel vy cv cA wcel vx cv cB wcel
      ancom vy cv vx cv cA cB vx visset opelxp vx cv vy cv cB cA vy visset
      opelxp 3bitr4i bitri eqrelriv $.
      $( [14-Aug-1999] $)
  $}

  $( The cross product with the empty set is empty.  Part of Theorem 3.13(ii)
     of [Monk1] p. 37. $)
  xp0 $p |- ( A X. (/) ) = (/) $=
    c0 cA cxp ccnv c0 ccnv cA c0 cxp c0 c0 cA cxp c0 cA xp0r cnveqi c0 cA cnvxp
    cnv0 3eqtr3i $.
    $( [17-Apr-2004] $) $( [12-Apr-2004] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( The cross product of nonempty classes is nonempty.  (Variation of a
       theorem contributed by Raph Levien, 30-Jun-2006.) $)
    xpnz $p |- ( ( A =/= (/) /\ B =/= (/) ) <-> ( A X. B ) =/= (/) ) $=
      cA c0 wne cB c0 wne wa cA cB cxp c0 wne cA c0 wne cB c0 wne wa vx cv cA
      wcel vy cv cB wcel wa vy wex vx wex cA cB cxp c0 wne cA c0 wne cB c0 wne
      wa vx cv cA wcel vx wex vy cv cB wcel vy wex wa vx cv cA wcel vy cv cB
      wcel wa vy wex vx wex cA c0 wne vx cv cA wcel vx wex cB c0 wne vy cv cB
      wcel vy wex vx cA n0 vy cB n0 anbi12i vx cv cA wcel vy cv cB wcel vx vy
      eeanv bitr4i vx cv cA wcel vy cv cB wcel wa cA cB cxp c0 wne vx vy vx cv
      cA wcel vy cv cB wcel wa vz cv cA cB cxp wcel vz wex cA cB cxp c0 wne vz
      cv cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa vz vx cv vy cv cop vx cv
      vy cv opex vz cv vx cv vy cv cop wceq vz cv cA cB cxp wcel vx cv vy cv
      cop cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cop
      cA cB cxp eleq1 vx cv vy cv cA cB vy visset opelxp syl6bb cla4ev vz cA cB
      cxp n0 sylibr 19.23aivv sylbi cA cB cxp c0 wne cA c0 wne cB c0 wne cA c0
      cA cB cxp c0 cA c0 wceq cA cB cxp c0 cB cxp c0 cA c0 cB xpeq1 cB xp0r
      syl6eq necon3i cB c0 cA cB cxp c0 cB c0 wceq cA cB cxp cA c0 cxp c0 cB c0
      cA xpeq2 cA xp0 syl6eq necon3i jca impbii $.
      $( [19-Apr-2007] $) $( [30-Jun-2006] $)
  $}

  $( At least one member of an empty cross product is empty. $)
  xpeq0 $p |- ( ( A X. B ) = (/) <-> ( A = (/) \/ B = (/) ) ) $=
    cA cB cxp c0 wceq cA c0 wne cB c0 wne wa wn cA c0 wne wn cB c0 wne wn wo cA
    c0 wceq cB c0 wceq wo cA c0 wne cB c0 wne wa cA cB cxp c0 cA cB xpnz
    necon2bbii cA c0 wne cB c0 wne ianor cA c0 wne wn cA c0 wceq cB c0 wne wn
    cB c0 wceq cA c0 nne cB c0 nne orbi12i 3bitri $.
    $( [21-Sep-2006] $) $( [27-Aug-2006] $)

  $( Cross products with disjoint sets are disjoint. $)
  xpdisj1 $p |- ( ( A i^i B ) = (/) -> ( ( A X. C ) i^i ( B X. D ) ) = (/) ) $=
    cA cB cin c0 wceq cA cB cin cC cD cin cxp c0 cA cC cxp cB cD cxp cin cA cB
    cin c0 wceq cA cB cin cC cD cin cxp c0 cC cD cin cxp c0 cA cB cin c0 cC cD
    cin xpeq1 cC cD cin xp0r syl6eq cA cC cB cD inxp syl5eq $.
    $( [15-Sep-2004] $) $( [13-Sep-2004] $)

  $( Cross products with disjoint sets are disjoint. $)
  xpdisj2 $p |- ( ( A i^i B ) = (/) -> ( ( C X. A ) i^i ( D X. B ) ) = (/) ) $=
    cA cB cin c0 wceq cC cD cin cA cB cin cxp c0 cC cA cxp cD cB cxp cin cA cB
    cin c0 wceq cC cD cin cA cB cin cxp cC cD cin c0 cxp c0 cA cB cin c0 cC cD
    cin xpeq2 cC cD cin xp0 syl6eq cC cA cD cB inxp syl5eq $.
    $( [15-Sep-2004] $) $( [13-Sep-2004] $)

  $( Cross products with two different singletons are disjoint. $)
  xpsndisj $p |- ( B =/= D -> ( ( A X. { B } ) i^i ( C X. { D } ) ) = (/) ) $=
    cB cD wne cB csn cD csn cin c0 wceq cA cB csn cxp cC cD csn cxp cin c0 wceq
    cB cD disjsn2 cB csn cD csn cA cC xpdisj2 syl $.
    $( [3-Jun-2007] $) $( [28-Jul-2004] $)

  $( A double restriction to disjoint classes is the empty set. $)
  resdisj $p |- ( ( A i^i B ) = (/) -> ( ( C |` A ) |` B ) = (/) ) $=
    cA cB cin c0 wceq cC cA cvv cxp cB cvv cxp cin cin c0 cC cA cres cB cres cA
    cB cin c0 wceq cC cA cvv cxp cB cvv cxp cin cin cC c0 cin c0 cA cB cin c0
    wceq cA cvv cxp cB cvv cxp cin c0 cC cA cB cvv cvv xpdisj1 ineq2d cC in0
    syl6eq cC cA cres cB cres cC cA cres cB cvv cxp cin cC cA cvv cxp cin cB
    cvv cxp cin cC cA cvv cxp cB cvv cxp cin cin cC cA cres cB df-res cC cA
    cres cC cA cvv cxp cin cB cvv cxp cC cA df-res ineq1i cC cA cvv cxp cB cvv
    cxp inass 3eqtri syl5eq $.
    $( [17-Oct-2004] $) $( [7-Oct-2004] $)

  $( The range of a cross product.  Part of Theorem 3.13(x) of [Monk1]
     p. 37. $)
  rnxp $p |- ( A =/= (/) -> ran ( A X. B ) = B ) $=
    cA c0 wne cB cA cxp cdm cB cA cB cxp crn cB cA dmxp cA cB cxp crn cA cB cxp
    ccnv cdm cB cA cxp cdm cA cB cxp df-rn cA cB cxp ccnv cB cA cxp cA cB cnvxp
    dmeqi eqtri syl5eq $.
    $( [9-Apr-2007] $) $( [12-Apr-2004] $)

  $( The domain of a cross product is a subclass of the first factor. $)
  dmxpss $p |- dom ( A X. B ) C_ A $=
    cA cB cxp cdm cA wss cB c0 cB c0 wceq cA cB cxp cdm cA wss c0 cA wss cA 0ss
    cB c0 wceq cA cB cxp cdm c0 cA cB c0 wceq cA cB cxp cdm c0 cdm c0 cB c0
    wceq cA cB cxp c0 cB c0 wceq cA cB cxp cA c0 cxp c0 cB c0 cA xpeq2 cA xp0
    syl6eq dmeqd dm0 syl6eq sseq1d mpbiri cB c0 wne cA cB cxp cdm cA wceq cA cB
    cxp cdm cA wss cA cB dmxp cA cB cxp cdm cA eqimss syl pm2.61ine $.
    $( [20-Mar-2007] $) $( [19-Mar-2007] $)

  $( The range of a cross product is a subclass of the second factor. $)
  rnxpss $p |- ran ( A X. B ) C_ B $=
    cA cB cxp crn cB wss cA c0 cA c0 wceq cA cB cxp crn cB wss c0 cB wss cB 0ss
    cA c0 wceq cA cB cxp crn c0 cB cA c0 wceq cA cB cxp crn c0 crn c0 cA c0
    wceq cA cB cxp c0 cA c0 wceq cA cB cxp c0 cB cxp c0 cA c0 cB xpeq1 cB xp0r
    syl6eq rneqd rn0 syl6eq sseq1d mpbiri cA c0 wne cA cB cxp crn cB wceq cA cB
    cxp crn cB wss cA cB rnxp cA cB cxp crn cB eqimss syl pm2.61ine $.
    $( [17-Jan-2006] $) $( [16-Jan-2006] $)

  $( A cross-product subclass relationship is equivalent to the relationship
     for it components. $)
  ssxpb $p |- ( ( A X. B ) =/= (/) -> ( ( A X. B ) C_ ( C X. D ) <->
              ( A C_ C /\ B C_ D ) ) ) $=
    cA cB cxp c0 wne cA cB cxp cC cD cxp wss cA cC wss cB cD wss wa cA cB cxp
    c0 wne cA cB cxp cC cD cxp wss cA cC wss cB cD wss wa cA cB cxp c0 wne cA
    cB cxp cC cD cxp wss wa cA cC wss cB cD wss cA cB cxp c0 wne cA cB cxp cC
    cD cxp wss wa cA cC cD cxp cdm cC cA cB cxp c0 wne cA cB cxp cC cD cxp wss
    wa cA cA cB cxp cdm cC cD cxp cdm cA cB cxp c0 wne cA cB cxp cdm cA wceq cA
    cB cxp cC cD cxp wss cA cB cxp c0 wne cA c0 wne cB c0 wne wa cA cB cxp cdm
    cA wceq cA cB xpnz cB c0 wne cA cB cxp cdm cA wceq cA c0 wne cA cB dmxp
    adantl sylbir adantr cA cB cxp cC cD cxp wss cA cB cxp cdm cC cD cxp cdm
    wss cA cB cxp c0 wne cA cB cxp cC cD cxp dmss adantl eqsstr3d cC cD cxp cdm
    cC wss cA cB cxp c0 wne cA cB cxp cC cD cxp wss wa cC cD dmxpss a1i sstrd
    cA cB cxp c0 wne cA cB cxp cC cD cxp wss wa cB cC cD cxp crn cD cA cB cxp
    c0 wne cA cB cxp cC cD cxp wss wa cB cA cB cxp crn cC cD cxp crn cA cB cxp
    c0 wne cA cB cxp crn cB wceq cA cB cxp cC cD cxp wss cA cB cxp c0 wne cA c0
    wne cB c0 wne wa cA cB cxp crn cB wceq cA cB xpnz cA c0 wne cA cB cxp crn
    cB wceq cB c0 wne cA cB rnxp adantr sylbir adantr cA cB cxp cC cD cxp wss
    cA cB cxp crn cC cD cxp crn wss cA cB cxp c0 wne cA cB cxp cC cD cxp rnss
    adantl eqsstr3d cC cD cxp crn cD wss cA cB cxp c0 wne cA cB cxp cC cD cxp
    wss wa cC cD rnxpss a1i sstrd jca ex cA cC cB cD ssxp impbid1 $.
    $( [18-Dec-2008] $) $( [17-Dec-2008] $)

  $( The cross product of non-empty classes is one-to-one. $)
  xp11 $p |- ( ( A =/= (/) /\ B =/= (/) )
      -> ( ( A X. B ) = ( C X. D ) <-> ( A = C /\ B = D ) ) ) $=
    cA c0 wne cB c0 wne wa cA cB cxp cC cD cxp wceq cA cC wceq cB cD wceq wa cA
    c0 wne cB c0 wne wa cA cB cxp c0 wne cA cB cxp cC cD cxp wceq cA cC wceq cB
    cD wceq wa wi cA cB xpnz cA cB cxp cC cD cxp wceq cA cB cxp c0 wne cA cC
    wceq cB cD wceq wa cA cB cxp cC cD cxp wceq cA cB cxp c0 wne cA cB cxp c0
    wne cC cD cxp c0 wne wa cA cC wceq cB cD wceq wa cA cB cxp cC cD cxp wceq
    cA cB cxp c0 wne cA cB cxp c0 wne wa cA cB cxp c0 wne cC cD cxp c0 wne wa
    cA cB cxp c0 wne cA cB cxp cC cD cxp wceq cA cB cxp c0 wne cC cD cxp c0 wne
    cA cB cxp c0 wne cA cB cxp cC cD cxp c0 neeq1 anbi2d cA cB cxp c0 wne anidm
    syl5bbr cA cB cxp cC cD cxp wceq cA cB cxp c0 wne cC cD cxp c0 wne wa cA cC
    wss cB cD wss wa cC cA wss cD cB wss wa wa cA cC wceq cB cD wceq wa cA cB
    cxp cC cD cxp wceq cA cB cxp c0 wne cA cC wss cB cD wss wa cC cD cxp c0 wne
    cC cA wss cD cB wss wa cA cB cxp c0 wne cA cB cxp cC cD cxp wss cA cC wss
    cB cD wss wa cA cB cxp cC cD cxp wceq cA cB cC cD ssxpb cA cB cxp cC cD cxp
    eqimss syl5cbi cC cD cxp c0 wne cC cD cxp cA cB cxp wss cC cA wss cD cB wss
    wa cA cB cxp cC cD cxp wceq cC cD cA cB ssxpb cC cD cxp cA cB cxp eqimss2
    syl5cbi anim12d cA cC wss cB cD wss wa cC cA wss cD cB wss wa wa cA cC wss
    cC cA wss wa cB cD wss cD cB wss wa wa cA cC wceq cB cD wceq wa cA cC wss
    cB cD wss cC cA wss cD cB wss an4 cA cC wceq cA cC wss cC cA wss wa cB cD
    wceq cB cD wss cD cB wss wa cA cC eqss cB cD eqss anbi12i bitr4i syl6ib
    sylbid com12 sylbi cA cC wceq cB cD wceq cA cB cxp cC cB cxp cC cD cxp cA
    cC cB xpeq1 cB cD cC xpeq2 sylan9eq impbid1 $.
    $( [31-May-2008] $) $( [31-May-2008] $)

  $( The first argument of a cross product is one-to-one. $)
  xp11a $p |- ( A =/= (/) -> ( ( A X. A ) = ( B X. A ) <-> A = B ) ) $=
    cA c0 wne cA cA cxp cB cA cxp wceq cA cB wceq wb cA c0 wne cA c0 wne wa cA
    cA cxp cB cA cxp wceq cA cB wceq cA cA wceq wa cA cB wceq cA cA cB cA xp11
    cA cA wceq cA cB wceq cA eqid biantru syl6bbr anidms $.
    $( [1-Jun-2008] $) $( [31-May-2008] $)

  $( The second argument of a cross product is one-to-one. $)
  xp11b $p |- ( A =/= (/) -> ( ( A X. A ) = ( A X. B ) <-> A = B ) ) $=
    cA c0 wne cA cA cxp cA cB cxp wceq cA cB wceq wb cA c0 wne cA c0 wne wa cA
    cA cxp cA cB cxp wceq cA cA wceq cA cB wceq wa cA cB wceq cA cA cA cB xp11
    cA cA wceq cA cB wceq cA eqid biantrur syl6bbr anidms $.
    $( [12-Jun-2008] $) $( [31-May-2008] $)

  $( If a cross product is a set, one of its components must be a set. $)
  xpexr $p |- ( ( A X. B ) e. C -> ( A e. _V \/ B e. _V ) ) $=
    cA cB cxp cC wcel cA cvv wcel cB cvv wcel cA cB cxp cC wcel cA cvv wcel wn
    cB cvv wcel wi wi cA c0 cA c0 wceq cA cvv wcel wn cB cvv wcel wi cA cB cxp
    cC wcel cA c0 wceq cA cvv wcel cB cvv wcel cA c0 wceq cA cvv wcel c0 cvv
    wcel 0ex cA c0 cvv eleq1 mpbiri pm2.24d a1d cA c0 wne cA cB cxp cC wcel cB
    cvv wcel cA cvv wcel wn cA c0 wne cA cB cxp crn cvv wcel cB cvv wcel cA cB
    cxp cC wcel cA c0 wne cA cB cxp crn cB cvv cA cB rnxp eleq1d cA cB cxp cC
    rnexg syl5bi a1dd pm2.61ine orrd $.
    $( [27-Aug-2006] $) $( [27-Aug-2006] $)

  $( If a nonempty cross product is a set, so are both of its components. $)
  xpexr2 $p |- ( ( ( A X. B ) e. C /\ ( A X. B ) =/= (/) ) ->
               ( A e. _V /\ B e. _V ) ) $=
    cA cB cxp cC wcel cA c0 wne cB c0 wne wa cA cvv wcel cB cvv wcel wa cA cB
    cxp c0 wne cA cB cxp cC wcel cB c0 wne cA c0 wne cA cvv wcel cB cvv wcel wa
    cA cB cxp cC wcel cB c0 wne cA c0 wne cA cvv wcel cB cvv wcel wa cA cB cxp
    cC wcel cB c0 wne wa cA cvv wcel cA cB cxp cC wcel cA c0 wne wa cB cvv wcel
    cA cB cxp cC wcel cB c0 wne wa cA cB cxp cdm cA cvv cB c0 wne cA cB cxp cdm
    cA wceq cA cB cxp cC wcel cA cB dmxp adantl cA cB cxp cC wcel cA cB cxp cdm
    cvv wcel cB c0 wne cA cB cxp cC dmexg adantr eqeltrrd cA cB cxp cC wcel cA
    c0 wne wa cA cB cxp crn cB cvv cA c0 wne cA cB cxp crn cB wceq cA cB cxp cC
    wcel cA cB rnxp adantl cA cB cxp cC wcel cA cB cxp crn cvv wcel cA c0 wne
    cA cB cxp cC rnexg adantr eqeltrrd anim12i anandis ancom2s cA cB xpnz
    sylan2br $.
    $( [5-May-2007] $) $( [27-Aug-2006] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Subset of the range of a restriction. $)
    ssrnres $p |- ( B C_ ran ( C |` A ) <-> ran ( C i^i ( A X. B ) ) = B ) $=
      cC cA cB cxp cin crn cB wceq cC cA cB cxp cin crn cB wss cB cC cA cB cxp
      cin crn wss wa cB cC cA cB cxp cin crn wss cB cC cA cres crn wss cC cA cB
      cxp cin crn cB eqss cC cA cB cxp cin crn cB wss cB cC cA cB cxp cin crn
      wss cC cA cB cxp cin crn cA cB cxp crn cB cC cA cB cxp cin cA cB cxp wss
      cC cA cB cxp cin crn cA cB cxp crn wss cC cA cB cxp inss2 cC cA cB cxp
      cin cA cB cxp rnss ax-mp cA cB rnxpss sstri biantrur cB cC cA cB cxp cin
      crn wss cB cC cA cres crn wss cB cC cA cB cxp cin crn wss cC cA cB cxp
      cin crn cC cA cres crn wss cB cC cA cres crn wss cC cA cB cxp cin cC cA
      cres wss cC cA cB cxp cin crn cC cA cres crn wss cC cA cB cxp cin cC cA
      cvv cxp cin cC cA cres cA cB cxp cA cvv cxp wss cC cA cB cxp cin cC cA
      cvv cxp cin wss cA cA wss cB cvv wss cA cB cxp cA cvv cxp wss cA ssid cB
      ssv cA cA cB cvv ssxp mp2an cA cB cxp cA cvv cxp cC sslin ax-mp cC cA
      df-res sseqtr4i cC cA cB cxp cin cC cA cres rnss ax-mp cB cC cA cB cxp
      cin crn cC cA cres crn sstr mpan2 cB cC cA cres crn wss vy cB cC cA cB
      cxp cin crn cB cC cA cres crn wss vy cv cB wcel vx cv vy cv cop cC cA
      cres wcel vx wex vy cv cB wcel wa vy cv cC cA cB cxp cin crn wcel cB cC
      cA cres crn wss vy cv cB wcel vx cv vy cv cop cC cA cres wcel vx wex cB
      cC cA cres crn wss vy cv cB wcel vy cv cC cA cres crn wcel vx cv vy cv
      cop cC cA cres wcel vx wex cB cC cA cres crn vy cv ssel vx vy cv cC cA
      cres vy visset elrn2 syl6ib ancrd vy cv cC cA cB cxp cin crn wcel vx cv
      vy cv cop cC cA cB cxp cin wcel vx wex vx cv vy cv cop cC cA cres wcel vy
      cv cB wcel wa vx wex vx cv vy cv cop cC cA cres wcel vx wex vy cv cB wcel
      wa vx vy cv cC cA cB cxp cin vy visset elrn2 vx cv vy cv cop cC cA cB cxp
      cin wcel vx cv vy cv cop cC cA cres wcel vy cv cB wcel wa vx vx cv vy cv
      cop cC cA cB cxp cin wcel vx cv vy cv cop cC wcel vx cv vy cv cop cA cB
      cxp wcel wa vx cv vy cv cop cC wcel vx cv cA wcel vy cv cB wcel wa wa vx
      cv vy cv cop cC cA cres wcel vy cv cB wcel wa vx cv vy cv cop cC cA cB
      cxp elin vx cv vy cv cop cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa vx
      cv vy cv cop cC wcel vx cv vy cv cA cB vy visset opelxp anbi2i vx cv vy
      cv cop cC cA cres wcel vy cv cB wcel wa vx cv vy cv cop cC wcel vx cv cA
      wcel wa vy cv cB wcel wa vx cv vy cv cop cC wcel vx cv cA wcel vy cv cB
      wcel wa wa vx cv vy cv cop cC cA cres wcel vx cv vy cv cop cC wcel vx cv
      cA wcel wa vy cv cB wcel vx cv vy cv cC cA vy visset opelres anbi1i vx cv
      vy cv cop cC wcel vx cv cA wcel vy cv cB wcel anass bitr2i 3bitri exbii
      vx cv vy cv cop cC cA cres wcel vy cv cB wcel vx 19.41v 3bitri syl6ibr
      ssrdv impbii 3bitr2ri $.
      $( [18-Jan-2006] $) $( [16-Jan-2006] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.
    $( Range of the intersection with a cross product. $)
    rninxp $p |- ( ran ( C i^i ( A X. B ) ) = B <->
                 A. y e. B E. x e. A x C y ) $=
      cB cC cA cres crn wss vy cv cC cA cres crn wcel vy cB wral cC cA cB cxp
      cin crn cB wceq vx cv vy cv cC wbr vx cA wrex vy cB wral vy cB cC cA cres
      crn dfss3 cA cB cC ssrnres vy cv cC cA cres crn wcel vx cv vy cv cC wbr
      vx cA wrex vy cB vx cv vy cv cop cC cA cres wcel vx wex vx cv cA wcel vx
      cv vy cv cC wbr wa vx wex vy cv cC cA cres crn wcel vx cv vy cv cC wbr vx
      cA wrex vx cv vy cv cop cC cA cres wcel vx cv cA wcel vx cv vy cv cC wbr
      wa vx vx cv vy cv cop cC wcel vx cv cA wcel wa vx cv cA wcel vx cv vy cv
      cop cC wcel wa vx cv vy cv cop cC cA cres wcel vx cv cA wcel vx cv vy cv
      cC wbr wa vx cv vy cv cop cC wcel vx cv cA wcel ancom vx cv vy cv cC cA
      vy visset opelres vx cv vy cv cC wbr vx cv vy cv cop cC wcel vx cv cA
      wcel vx cv vy cv cC df-br anbi2i 3bitr4i exbii vx vy cv cC cA cres vy
      visset elrn2 vx cv vy cv cC wbr vx cA df-rex 3bitr4i ralbii 3bitr3i $.
      $( [18-Jan-2006] $) $( [17-Jan-2006] $)
  $}

  ${
    $d x A $.  $d x y B $.  $d x y C $.
    $( Domain of the intersection with a cross product. $)
    dminxp $p |- ( dom ( C i^i ( A X. B ) ) = A <->
                 A. x e. A E. y e. B x C y ) $=
      cC cA cB cxp cin cdm cA wceq cC ccnv cB cA cxp cin crn cA wceq vy cv vx
      cv cC ccnv wbr vy cB wrex vx cA wral vx cv vy cv cC wbr vy cB wrex vx cA
      wral cC cA cB cxp cin cdm cC ccnv cB cA cxp cin crn cA cC cA cB cxp cin
      cdm cC cA cB cxp cin ccnv crn cC ccnv cB cA cxp cin crn cC cA cB cxp cin
      dfdm4 cC cA cB cxp cin ccnv cC ccnv cB cA cxp cin cC cA cB cxp cin ccnv
      cC ccnv cA cB cxp ccnv cin cC ccnv cB cA cxp cin cC cA cB cxp cnvin cA cB
      cxp ccnv cB cA cxp cC ccnv cA cB cnvxp ineq2i eqtri rneqi eqtri eqeq1i vy
      vx cB cA cC ccnv rninxp vy cv vx cv cC ccnv wbr vy cB wrex vx cv vy cv cC
      wbr vy cB wrex vx cA vy cv vx cv cC ccnv wbr vx cv vy cv cC wbr vy cB vy
      cv vx cv cC vy visset vx visset brcnv rexbii ralbii 3bitri $.
      $( [19-Jan-2006] $) $( [17-Jan-2006] $)
  $}

  ${
    $d x y R $.
    $( Alternate definition of relation.  Exercise 2 of [TakeutiZaring]
       p. 25. $)
    dfrel2 $p |- ( Rel R <-> `' `' R = R ) $=
      cR wrel cR ccnv ccnv cR wceq cR ccnv ccnv wrel cR wrel cR ccnv ccnv cR
      wceq cR ccnv relcnv cR ccnv ccnv wrel cR wrel wa cR ccnv ccnv cR wceq vx
      cv vy cv cop cR ccnv ccnv wcel vx cv vy cv cop cR wcel wb vy wal vx wal
      vx cv vy cv cop cR ccnv ccnv wcel vx cv vy cv cop cR wcel wb vx vy vx cv
      vy cv cop cR ccnv ccnv wcel vy cv vx cv cop cR ccnv wcel vx cv vy cv cop
      cR wcel vx cv vy cv cR ccnv vx visset vy visset opelcnv vy cv vx cv cR vy
      visset vx visset opelcnv bitri gen2 vx vy cR ccnv ccnv cR eqrel mpbiri
      mpan cR ccnv ccnv cR wceq cR ccnv ccnv wrel cR wrel cR ccnv relcnv cR
      ccnv ccnv cR releq mpbii impbii $.
      $( [15-Aug-2004] $) $( [29-Dec-1996] $)
  $}

  $( The double converse of a class strips out all elements that are not
     ordered pairs. $)
  cnvcnv $p |- `' `' A = ( A i^i ( _V X. _V ) ) $=
    cA cvv cvv cxp cin ccnv ccnv cA ccnv cvv cvv cxp ccnv cin ccnv cA cvv cvv
    cxp cin cA ccnv ccnv cA cvv cvv cxp cin ccnv cA ccnv cvv cvv cxp ccnv cin
    cA cvv cvv cxp cnvin cnveqi cA cvv cvv cxp cin wrel cA cvv cvv cxp cin ccnv
    ccnv cA cvv cvv cxp cin wceq cA cvv cvv cxp cin wrel cA cvv cvv cxp cin cvv
    cvv cxp wss cA cvv cvv cxp inss2 cA cvv cvv cxp cin df-rel mpbir cA cvv cvv
    cxp cin dfrel2 mpbi cA ccnv cvv cvv cxp ccnv cin ccnv cA ccnv ccnv cvv cvv
    cxp ccnv ccnv cin cA ccnv ccnv cA ccnv cvv cvv cxp ccnv cnvin cA ccnv ccnv
    cvv cvv cxp ccnv ccnv wss cA ccnv ccnv cA ccnv ccnv cvv cvv cxp ccnv ccnv
    cin wceq cA ccnv ccnv cvv cvv cxp cvv cvv cxp ccnv ccnv cA ccnv ccnv wrel
    cA ccnv ccnv cvv cvv cxp wss cA ccnv relcnv cA ccnv ccnv df-rel mpbi cvv
    cvv cxp wrel cvv cvv cxp ccnv ccnv cvv cvv cxp wceq cvv cvv relxp cvv cvv
    cxp dfrel2 mpbi sseqtr4i cA ccnv ccnv cvv cvv cxp ccnv ccnv dfss mpbi
    eqtr4i 3eqtr3ri $.
    $( [25-Dec-2003] $) $( [8-Dec-2003] $)

  $( The double converse of a class equals its restriction to the universe. $)
  cnvcnv2 $p |- `' `' A = ( A |` _V ) $=
    cA ccnv ccnv cA cvv cvv cxp cin cA cvv cres cA cnvcnv cA cvv df-res eqtr4i
    $.
    $( [14-Dec-2007] $) $( [8-Oct-2007] $)

  $( The double converse of a class is a subclass.  Exercise 2 of
     [TakeutiZaring] p. 25. $)
  cnvcnvss $p |- `' `' A C_ A $=
    cA ccnv ccnv cA cvv cvv cxp cin cA cA cnvcnv cA cvv cvv cxp inss1 eqsstri
    $.
    $( [28-Jul-2004] $) $( [23-Jul-2004] $)

  $( The domain of a singleton is nonzero iff the singleton argument is an
     ordered pair. $)
  dmsnn0 $p |- ( A e. ( _V X. _V ) <-> dom { A } =/= (/) ) $=
    cA cvv cvv cxp wcel cA csn cdm c0 cA csn cdm c0 wceq cA csn cvv cvv cxp cin
    cdm c0 wceq cA cvv cvv cxp wcel wn cA csn cdm cA csn cvv cvv cxp cin cdm c0
    cA csn ccnv ccnv cdm cA csn cdm cA csn cvv cvv cxp cin cdm cA csn dmcnvcnv
    cA csn ccnv ccnv cA csn cvv cvv cxp cin cA csn cnvcnv dmeqi eqtr3i eqeq1i
    cvv cvv cxp cA csn cin c0 wceq cA csn cvv cvv cxp cin c0 wceq cA cvv cvv
    cxp wcel wn cA csn cvv cvv cxp cin cdm c0 wceq cvv cvv cxp cA csn cin cA
    csn cvv cvv cxp cin c0 cvv cvv cxp cA csn incom eqeq1i cvv cvv cxp cA
    disjsn cA csn cvv cvv cxp cin wrel cA csn cvv cvv cxp cin c0 wceq cA csn
    cvv cvv cxp cin cdm c0 wceq wb cvv cvv cxp wrel cA csn cvv cvv cxp cin wrel
    cvv cvv relxp cA csn cvv cvv cxp relin2 ax-mp cA csn cvv cvv cxp cin reldm0
    ax-mp 3bitr3ri bitri necon2abii $.
    $( [15-Dec-2008] $) $( [14-Dec-2008] $)

  $( The range of a singleton is nonzero iff the singleton argument is an
     ordered pair. $)
  rnsnn0 $p |- ( A e. ( _V X. _V ) <-> ran { A } =/= (/) ) $=
    cA cvv cvv cxp wcel cA csn cdm c0 wne cA csn crn c0 wne cA dmsnn0 cA csn
    cdm c0 cA csn crn c0 cA csn dm0rn0 necon3bii bitri $.
    $( [18-Dec-2008] $) $( [14-Dec-2008] $)

  $( The domain of the singleton of the empty set is empty. $)
  dmsn0 $p |- dom { (/) } = (/) $=
    c0 csn cdm c0 wceq c0 cvv cvv cxp wcel wn cvv cvv 0nelxp c0 cvv cvv cxp
    wcel c0 csn cdm c0 c0 dmsnn0 necon2bbii mpbir $.
    $( [17-Dec-2008] $) $( [30-Jan-2004] $)

  $( The domain of a singleton is empty if the singleton's argument contains
     the empty set. $)
  dmsn0el $p |- ( (/) e. A -> dom { A } = (/) ) $=
    c0 cA wcel cA csn cdm c0 cA csn cdm c0 wne cA cvv cvv cxp wcel c0 cA wcel
    wn cA dmsnn0 cvv cvv cA 0nelelxp sylbir necon4ai $.
    $( [15-Dec-2008] $) $( [15-Dec-2008] $)

  ${
    $d x y A $.  $d x y B $.
    $( The domain of a singleton of an ordered pair is the singleton of the
       first member. $)
    dmsnop $p |- dom { <. A , B >. } = { A } $=
      cB cvv wcel cA cB cop csn cdm cA csn wceq cB cvv wcel vx cv vy cv cop cA
      cB cop csn wcel vy wex vx cab vx cv cA wceq vx cab cA cB cop csn cdm cA
      csn cB cvv wcel vx cv vy cv cop cA cB cop csn wcel vy wex vx cv cA wceq
      vx cB cvv wcel vx cv vy cv cop cA cB cop csn wcel vy wex vx cv cA wceq vy
      cv cB wceq vy wex wa vx cv cA wceq cB cvv wcel vx cv vy cv cop cA cB cop
      csn wcel vy wex vx cv cA wceq vy cv cB wceq wa vy wex vx cv cA wceq vy cv
      cB wceq vy wex wa cB cvv wcel vx cv vy cv cop cA cB cop csn wcel vx cv cA
      wceq vy cv cB wceq wa vy cB cvv wcel vx cv vy cv cop cA cB cop wceq vx cv
      cA wceq vy cv cB wceq wa vx cv vy cv cop cA cB cop csn wcel vx cv vy cv
      cA cB cvv vx visset vy visset opthg vx cv vy cv cop cA cB cop vx cv vy cv
      opex elsnc syl5bb exbidv vx cv cA wceq vy cv cB wceq vy 19.42v syl6bb cB
      cvv wcel vy cv cB wceq vy wex vx cv cA wceq vx cv cA wceq vy cv cB wceq
      vy wex wa wb vy cB isset vy cv cB wceq vy wex vx cv cA wceq iba sylbi
      bitr4d abbidv vx vy cA cB cop csn dfdm3 vx cA df-sn 3eqtr4g cB cvv wcel
      wn cA cB cop csn cdm cA cA cop csn cdm cA csn cB cvv wcel wn cA cB cop cA
      cA cop wceq cA cB cop csn cA cA cop csn wceq cA cB cop csn cdm cA cA cop
      csn cdm wceq cA cB opprc2 cA cB cop cA cA cop sneq cA cB cop csn cA cA
      cop csn dmeq 3syl cA cvv wcel cA cA cop csn cdm cA csn wceq cA cvv wcel
      vx cv vy cv cop cA cA cop csn wcel vy wex vx cab vx cv cA wceq vx cab cA
      cA cop csn cdm cA csn cA cvv wcel vx cv vy cv cop cA cA cop csn wcel vy
      wex vx cv cA wceq vx cA cvv wcel vx cv vy cv cop cA cA cop csn wcel vy
      wex vx cv cA wceq vy cv cA wceq vy wex wa vx cv cA wceq cA cvv wcel vx cv
      vy cv cop cA cA cop csn wcel vy wex vx cv cA wceq vy cv cA wceq wa vy wex
      vx cv cA wceq vy cv cA wceq vy wex wa cA cvv wcel vx cv vy cv cop cA cA
      cop csn wcel vx cv cA wceq vy cv cA wceq wa vy cA cvv wcel vx cv vy cv
      cop cA cA cop wceq vx cv cA wceq vy cv cA wceq wa vx cv vy cv cop cA cA
      cop csn wcel vx cv vy cv cA cA cvv vx visset vy visset opthg vx cv vy cv
      cop cA cA cop vx cv vy cv opex elsnc syl5bb exbidv vx cv cA wceq vy cv cA
      wceq vy 19.42v syl6bb cA cvv wcel vy cv cA wceq vy wex vx cv cA wceq vx
      cv cA wceq vy cv cA wceq vy wex wa wb vy cA isset vy cv cA wceq vy wex vx
      cv cA wceq iba sylbi bitr4d abbidv vx vy cA cA cop csn dfdm3 vx cA df-sn
      3eqtr4g cA cvv wcel wn cA cA cop csn cdm c0 cA csn cA cvv wcel wn c0 cA
      cA cop wcel cA cA cop csn cdm c0 wceq cA cA opprc1b cA cA cop dmsn0el
      sylbi cA cvv wcel wn cA csn c0 wceq cA snprc biimpi eqtr4d pm2.61i syl6eq
      pm2.61i $.
      $( [21-Dec-2008] $) $( [30-Jan-2004] $)
  $}

  $( The domain of the singleton of the singleton of a singleton. $)
  dmsnsnsn $p |- dom { { { A } } } = { A } $=
    cA cA cop csn cdm cA csn csn csn cdm cA csn cA cA cop csn cA csn csn csn cA
    cA cop cA csn csn cA csn cA csn cpr cA csn cA cA cpr cpr cA csn csn cA cA
    cop cA csn cA cA cpr wceq cA csn cA csn cpr cA csn cA cA cpr cpr wceq cA
    dfsn2 cA csn cA cA cpr cA csn preq2 ax-mp cA csn dfsn2 cA cA df-op 3eqtr4ri
    sneqi dmeqi cA cA dmsnop eqtr3i $.
    $( [17-Sep-2004] $) $( [15-Sep-2004] $)

  ${
    op1sta.1 $e |- A e. _V $.
    $( Extract the first member of an ordered pair.   (See ~ op2nda to extract
       the second member, ~ op1stb for an alternate version, and ~ op1st for
       the preferred version..)  (Contributed by Raph Levien, 4-Dec-2003.) $)
    op1sta $p |- U. dom { <. A , B >. } = A $=
      cA cB cop csn cdm cuni cA csn cuni cA cA cB cop csn cdm cA csn cA cB
      dmsnop unieqi cA op1sta.1 unisn eqtri $.
      $( [17-Feb-2004] $) $( [4-Dec-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    cnvsn.1 $e |- A e. _V $.
    cnvsn.2 $e |- B e. _V $.
    $( Converse of a singleton of an ordered pair. $)
    cnvsn $p |- `' { <. A , B >. } = { <. B , A >. } $=
      vy vx cA cB cop csn ccnv cB cA cop csn cA cB cop csn relcnv cB cA cnvsn.2
      relsn vy cv cB wceq vx cv cA wceq wa vx cv cA wceq vy cv cB wceq wa vy cv
      vx cv cop cB cA cop csn wcel vy cv vx cv cop cA cB cop csn ccnv wcel vy
      cv cB wceq vx cv cA wceq ancom vy cv vx cv cop cB cA cop csn wcel vy cv
      vx cv cop cB cA cop wceq vy cv cB wceq vx cv cA wceq wa vy cv vx cv cop
      cB cA cop vy cv vx cv opex elsnc vy cv vx cv cB cA vy visset vx visset
      cnvsn.1 opth bitri vy cv vx cv cop cA cB cop csn ccnv wcel vx cv vy cv
      cop cA cB cop csn wcel vx cv vy cv cop cA cB cop wceq vx cv cA wceq vy cv
      cB wceq wa vy cv vx cv cA cB cop csn vy visset vx visset opelcnv vx cv vy
      cv cop cA cB cop vx cv vy cv opex elsnc vx cv vy cv cA cB vx visset vy
      visset cnvsn.2 opth 3bitri 3bitr4ri eqrelriv $.
      $( [11-May-1998] $)

    $( Swap the members of an ordered pair. $)
    opswap $p |- U. `' { <. A , B >. } = <. B , A >. $=
      cA cB cop csn ccnv cuni cB cA cop csn cuni cB cA cop cA cB cop csn ccnv
      cB cA cop csn cA cB cnvsn.1 cnvsn.2 cnvsn unieqi cB cA cop cB cA opex
      unisn eqtri $.
      $( [22-Jan-2009] $) $( [14-Dec-2008] $)

    $( The range of a singleton of an ordered pair is the singleton of the
       second member. $)
    rnsnop $p |- ran { <. A , B >. } = { B } $=
      cA cB cop csn crn cA cB cop csn ccnv cdm cB cA cop csn cdm cB csn cA cB
      cop csn df-rn cA cB cop csn ccnv cB cA cop csn cA cB cnvsn.1 cnvsn.2
      cnvsn dmeqi cB cA dmsnop 3eqtri $.
      $( [27-Jul-2004] $) $( [24-Jul-2004] $)

    $( Extract the second member of an ordered pair.  Theorem 5.12(ii) of
       [Monk1] p. 52.  (See ~ op1stb to extract the first member, ~ op2nda for
       an alternate version, and ~ op2nd for the preferred version.) $)
    op2ndb $p |- |^| |^| |^| `' { <. A , B >. } = B $=
      cA cB cop csn ccnv cint cint cint cB cA cop cint cint cB cA cB cop csn
      ccnv cint cint cB cA cop cint cA cB cop csn ccnv cint cB cA cop cA cB cop
      csn ccnv cint cB cA cop csn cint cB cA cop cA cB cop csn ccnv cB cA cop
      csn cA cB cnvsn.1 cnvsn.2 cnvsn inteqi cB cA cop cB cA opex intsn eqtri
      inteqi inteqi cB cA cnvsn.2 op1stb eqtri $.
      $( [1-Dec-2003] $) $( [25-Nov-2003] $)

    $( Extract the second member of an ordered pair.  (See ~ op1sta to extract
       the first member, ~ op2ndb for an alternate version, and ~ op2nd for the
       preferred version.) $)
    op2nda $p |- U. ran { <. A , B >. } = B $=
      cA cB cop csn crn cuni cB cA cop csn cdm cuni cB cA cB cop csn crn cB cA
      cop csn cdm cA cB cop csn crn cA cB cop csn ccnv cdm cB cA cop csn cdm cA
      cB cop csn df-rn cA cB cop csn ccnv cB cA cop csn cA cB cnvsn.1 cnvsn.2
      cnvsn dmeqi eqtri unieqi cB cA cnvsn.2 op1sta eqtri $.
      $( [17-Feb-2004] $) $( [17-Feb-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in a cross product.  This version requires no quantifiers or
       dummy variables.  See also ~ elxp5 , ~ elxp6 , and ~ elxp7 . $)
    elxp4 $p |- ( A e. ( B X. C ) <-> ( A = <. U. dom { A } , U. ran { A } >.
                 /\ ( U. dom { A } e. B /\ U. ran { A } e. C ) ) ) $=
      cA cB cC cxp wcel cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa
      wa vy wex vx wex vx cv cA csn cdm cuni wceq cA vx cv cA csn crn cuni cop
      wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa wa vx wex cA cA csn cdm
      cuni cA csn crn cuni cop wceq cA csn cdm cuni cB wcel cA csn crn cuni cC
      wcel wa wa vx vy cA cB cC elxp cA vx cv vy cv cop wceq vx cv cB wcel vy
      cv cC wcel wa wa vy wex vx cv cA csn cdm cuni wceq cA vx cv cA csn crn
      cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa wa vx cA vx cv
      vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa vy wex cA vx cv cA csn
      crn cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa vx cv cA
      csn cdm cuni wceq cA vx cv cA csn crn cuni cop wceq wa vx cv cB wcel cA
      csn crn cuni cC wcel wa wa vx cv cA csn cdm cuni wceq cA vx cv cA csn crn
      cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa wa cA vx cv vy
      cv cop wceq vx cv cB wcel vy cv cC wcel wa wa vy wex vy cv cA csn crn
      cuni wceq cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa wa vy
      wex cA vx cv cA csn crn cuni cop wceq vx cv cB wcel cA csn crn cuni cC
      wcel wa wa cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa vy
      cv cA csn crn cuni wceq cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC
      wcel wa wa wa vy cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa
      wa vy cv cA csn crn cuni wceq cA vx cv vy cv cop wceq wa vx cv cB wcel vy
      cv cC wcel wa wa vy cv cA csn crn cuni wceq cA vx cv vy cv cop wceq vx cv
      cB wcel vy cv cC wcel wa wa wa cA vx cv vy cv cop wceq vy cv cA csn crn
      cuni wceq cA vx cv vy cv cop wceq wa vx cv cB wcel vy cv cC wcel wa cA vx
      cv vy cv cop wceq vy cv cA csn crn cuni wceq cA vx cv vy cv cop wceq cA
      csn crn cuni vx cv vy cv cop csn crn cuni vy cv cA vx cv vy cv cop wceq
      cA csn crn vx cv vy cv cop csn crn cA vx cv vy cv cop wceq cA csn vx cv
      vy cv cop csn cA vx cv vy cv cop sneq rneqd unieqd vx cv vy cv vx visset
      vy visset op2nda syl6req pm4.71ri anbi1i vy cv cA csn crn cuni wceq cA vx
      cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa anass bitri exbii cA vx
      cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa cA vx cv cA csn crn
      cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa vy cA csn crn
      cuni cA csn crn cA csn cA snex rnex uniex vy cv cA csn crn cuni wceq cA
      vx cv vy cv cop wceq cA vx cv cA csn crn cuni cop wceq vx cv cB wcel vy
      cv cC wcel wa vx cv cB wcel cA csn crn cuni cC wcel wa vy cv cA csn crn
      cuni wceq vx cv vy cv cop vx cv cA csn crn cuni cop cA vy cv cA csn crn
      cuni vx cv opeq2 eqeq2d vy cv cA csn crn cuni wceq vy cv cC wcel cA csn
      crn cuni cC wcel vx cv cB wcel vy cv cA csn crn cuni cC eleq1 anbi2d
      anbi12d ceqsexv bitri cA vx cv cA csn crn cuni cop wceq vx cv cA csn cdm
      cuni wceq cA vx cv cA csn crn cuni cop wceq wa vx cv cB wcel cA csn crn
      cuni cC wcel wa cA vx cv cA csn crn cuni cop wceq vx cv cA csn cdm cuni
      wceq cA vx cv cA csn crn cuni cop wceq cA csn cdm cuni vx cv cA csn crn
      cuni cop csn cdm cuni vx cv cA vx cv cA csn crn cuni cop wceq cA csn cdm
      vx cv cA csn crn cuni cop csn cdm cA vx cv cA csn crn cuni cop wceq cA
      csn vx cv cA csn crn cuni cop csn cA vx cv cA csn crn cuni cop sneq dmeqd
      unieqd vx cv cA csn crn cuni vx visset op1sta syl6req pm4.71ri anbi1i vx
      cv cA csn cdm cuni wceq cA vx cv cA csn crn cuni cop wceq vx cv cB wcel
      cA csn crn cuni cC wcel wa anass 3bitri exbii cA vx cv cA csn crn cuni
      cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa cA cA csn cdm cuni
      cA csn crn cuni cop wceq cA csn cdm cuni cB wcel cA csn crn cuni cC wcel
      wa wa vx cA csn cdm cuni cA csn cdm cA csn cA snex dmex uniex vx cv cA
      csn cdm cuni wceq cA vx cv cA csn crn cuni cop wceq cA cA csn cdm cuni cA
      csn crn cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa cA csn cdm
      cuni cB wcel cA csn crn cuni cC wcel wa vx cv cA csn cdm cuni wceq vx cv
      cA csn crn cuni cop cA csn cdm cuni cA csn crn cuni cop cA vx cv cA csn
      cdm cuni cA csn crn cuni opeq1 eqeq2d vx cv cA csn cdm cuni wceq vx cv cB
      wcel cA csn cdm cuni cB wcel cA csn crn cuni cC wcel vx cv cA csn cdm
      cuni cB eleq1 anbi1d anbi12d ceqsexv 3bitri $.
      $( [23-Feb-2004] $) $( [17-Feb-2004] $)

    $( Membership in a cross product requiring no quantifiers or dummy
       variables.  Provides a slightly shorter version of ~ elxp4 when
       the double intersection does not create class existence problems
       (caused by ~ int0 ). $)
    elxp5 $p |- ( A e. ( B X. C ) <-> ( A = <. |^| |^| A , U. ran { A } >.
                 /\ ( |^| |^| A e. B /\ U. ran { A } e. C ) ) ) $=
      cA cB cC cxp wcel cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa
      wa vy wex vx wex vx cv cA cint cint wceq cA vx cv cA csn crn cuni cop
      wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa wa vx wex cA cA cint
      cint cA csn crn cuni cop wceq cA cint cint cB wcel cA csn crn cuni cC
      wcel wa wa vx vy cA cB cC elxp cA vx cv vy cv cop wceq vx cv cB wcel vy
      cv cC wcel wa wa vy wex vx cv cA cint cint wceq cA vx cv cA csn crn cuni
      cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa wa vx cA vx cv vy cv
      cop wceq vx cv cB wcel vy cv cC wcel wa wa vy wex cA vx cv cA csn crn
      cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa vx cv cA cint
      cint wceq cA vx cv cA csn crn cuni cop wceq wa vx cv cB wcel cA csn crn
      cuni cC wcel wa wa vx cv cA cint cint wceq cA vx cv cA csn crn cuni cop
      wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa wa cA vx cv vy cv cop
      wceq vx cv cB wcel vy cv cC wcel wa wa vy wex vy cv cA csn crn cuni wceq
      cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa wa vy wex cA vx
      cv cA csn crn cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa
      cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa vy cv cA csn
      crn cuni wceq cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa
      wa vy cA vx cv vy cv cop wceq vx cv cB wcel vy cv cC wcel wa wa vy cv cA
      csn crn cuni wceq cA vx cv vy cv cop wceq wa vx cv cB wcel vy cv cC wcel
      wa wa vy cv cA csn crn cuni wceq cA vx cv vy cv cop wceq vx cv cB wcel vy
      cv cC wcel wa wa wa cA vx cv vy cv cop wceq vy cv cA csn crn cuni wceq cA
      vx cv vy cv cop wceq wa vx cv cB wcel vy cv cC wcel wa cA vx cv vy cv cop
      wceq vy cv cA csn crn cuni wceq cA vx cv vy cv cop wceq cA csn crn cuni
      vx cv vy cv cop csn crn cuni vy cv cA vx cv vy cv cop wceq cA csn crn vx
      cv vy cv cop csn crn cA vx cv vy cv cop wceq cA csn vx cv vy cv cop csn
      cA vx cv vy cv cop sneq rneqd unieqd vx cv vy cv vx visset vy visset
      op2nda syl6req pm4.71ri anbi1i vy cv cA csn crn cuni wceq cA vx cv vy cv
      cop wceq vx cv cB wcel vy cv cC wcel wa anass bitri exbii cA vx cv vy cv
      cop wceq vx cv cB wcel vy cv cC wcel wa wa cA vx cv cA csn crn cuni cop
      wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa vy cA csn crn cuni cA
      csn crn cA csn cA snex rnex uniex vy cv cA csn crn cuni wceq cA vx cv vy
      cv cop wceq cA vx cv cA csn crn cuni cop wceq vx cv cB wcel vy cv cC wcel
      wa vx cv cB wcel cA csn crn cuni cC wcel wa vy cv cA csn crn cuni wceq vx
      cv vy cv cop vx cv cA csn crn cuni cop cA vy cv cA csn crn cuni vx cv
      opeq2 eqeq2d vy cv cA csn crn cuni wceq vy cv cC wcel cA csn crn cuni cC
      wcel vx cv cB wcel vy cv cA csn crn cuni cC eleq1 anbi2d anbi12d ceqsexv
      bitri cA vx cv cA csn crn cuni cop wceq vx cv cA cint cint wceq cA vx cv
      cA csn crn cuni cop wceq wa vx cv cB wcel cA csn crn cuni cC wcel wa cA
      vx cv cA csn crn cuni cop wceq vx cv cA cint cint wceq cA vx cv cA csn
      crn cuni cop wceq cA cint cint vx cv cA csn crn cuni cop cint cint vx cv
      cA vx cv cA csn crn cuni cop wceq cA cint vx cv cA csn crn cuni cop cint
      cA vx cv cA csn crn cuni cop inteq inteqd vx cv cA csn crn cuni vx visset
      op1stb syl6req pm4.71ri anbi1i vx cv cA cint cint wceq cA vx cv cA csn
      crn cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa anass 3bitri
      exbii vx cv cA cint cint wceq cA vx cv cA csn crn cuni cop wceq vx cv cB
      wcel cA csn crn cuni cC wcel wa wa wa vx wex cA cint cint cvv wcel cA cA
      cint cint cA csn crn cuni cop wceq cA cint cint cB wcel cA csn crn cuni
      cC wcel wa wa vx cv cA cint cint wceq cA vx cv cA csn crn cuni cop wceq
      vx cv cB wcel cA csn crn cuni cC wcel wa wa wa cA cint cint cvv wcel vx
      vx cv cA cint cint wceq cA cint cint cvv wcel cA vx cv cA csn crn cuni
      cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa wa vx cv cA cint cint
      wceq vx cv cvv wcel cA cint cint cvv wcel vx visset vx cv cA cint cint
      cvv eleq1 mpbii adantr 19.23aiv cA cint cint cB wcel cA cint cint cvv
      wcel cA cA cint cint cA csn crn cuni cop wceq cA csn crn cuni cC wcel cA
      cint cint cB elisset ad2antrl cA vx cv cA csn crn cuni cop wceq vx cv cB
      wcel cA csn crn cuni cC wcel wa wa cA cA cint cint cA csn crn cuni cop
      wceq cA cint cint cB wcel cA csn crn cuni cC wcel wa wa vx cA cint cint
      cvv vx cv cA cint cint wceq cA vx cv cA csn crn cuni cop wceq cA cA cint
      cint cA csn crn cuni cop wceq vx cv cB wcel cA csn crn cuni cC wcel wa cA
      cint cint cB wcel cA csn crn cuni cC wcel wa vx cv cA cint cint wceq vx
      cv cA csn crn cuni cop cA cint cint cA csn crn cuni cop cA vx cv cA cint
      cint cA csn crn cuni opeq1 eqeq2d vx cv cA cint cint wceq vx cv cB wcel
      cA cint cint cB wcel cA csn crn cuni cC wcel vx cv cA cint cint cB eleq1
      anbi1d anbi12d ceqsexgv pm5.21nii 3bitri $.
      $( [6-Aug-2004] $) $( [1-Aug-2004] $)
  $}

  $( Alternate definition of relation. $)
  dfrel3 $p |- ( Rel R <-> ( R |` _V ) = R ) $=
    cR wrel cR ccnv ccnv cR wceq cR cvv cres cR wceq cR dfrel2 cR ccnv ccnv cR
    cvv cres cR cR cnvcnv2 eqeq1i bitri $.
    $( [15-May-2008] $) $( [14-May-2008] $)

  $( The domain of a universal restriction. $)
  dmresv $p |- dom ( A |` _V ) = dom A $=
    cA cvv cres cdm cvv cA cdm cin cA cdm cvv cin cA cdm cA cvv dmres cvv cA
    cdm incom cA cdm inv1 3eqtri $.
    $( [24-May-2008] $) $( [14-May-2008] $)

  $( The range of a universal restriction. $)
  rnresv $p |- ran ( A |` _V ) = ran A $=
    cA ccnv ccnv crn cA cvv cres crn cA crn cA ccnv ccnv cA cvv cres cA cnvcnv2
    rneqi cA rncnvcnv eqtr3i $.
    $( [16-May-2008] $) $( [14-May-2008] $)

  $( Range defined in terms of image. $)
  dfrn4 $p |- ran A = ( A " _V ) $=
    cA cvv cima cA cvv cres crn cA crn cA cvv df-ima cA rnresv eqtr2i $.
    $( [14-May-2008] $) $( [14-May-2008] $)

  $( The restriction of the double converse of a class. $)
  rescnvcnv $p |- ( `' `' A |` B ) = ( A |` B ) $=
    cA ccnv ccnv cB cvv cxp cin cA cB cvv cxp cin cA ccnv ccnv cB cres cA cB
    cres cA ccnv ccnv cB cvv cxp cin cA cvv cvv cxp cin cB cvv cxp cin cA cvv
    cvv cxp cB cvv cxp cin cin cA cB cvv cxp cin cA ccnv ccnv cA cvv cvv cxp
    cin cB cvv cxp cA cnvcnv ineq1i cA cvv cvv cxp cB cvv cxp inass cvv cvv cxp
    cB cvv cxp cin cB cvv cxp cA cvv cvv cxp cB cvv cxp cin cvv cB cin cvv cvv
    cin cxp cB cvv cvv cin cxp cB cvv cxp cvv cvv cB cvv inxp cvv cB cin cB cvv
    cvv cin cvv cB cin cB cvv cin cB cvv cB incom cB inv1 eqtri xpeq1i cvv cvv
    cin cvv cB cvv inidm xpeq2i 3eqtri ineq2i 3eqtri cA ccnv ccnv cB df-res cA
    cB df-res 3eqtr4i $.
    $( [8-Apr-2007] $) $( [8-Apr-2007] $)

  $( The double converse of the restriction of a class. $)
  cnvcnvres $p |- `' `' ( A |` B ) = ( `' `' A |` B ) $=
    cA cB cres ccnv ccnv cA cB cres cA ccnv ccnv cB cres cA cB cres wrel cA cB
    cres ccnv ccnv cA cB cres wceq cA cB relres cA cB cres dfrel2 mpbi cA cB
    rescnvcnv eqtr4i $.
    $( [13-Jul-2007] $) $( [3-Jun-2007] $)

  $( The image of the double converse of a class. $)
  imacnvcnv $p |- ( `' `' A " B ) = ( A " B ) $=
    cA ccnv ccnv cB cres crn cA cB cres crn cA ccnv ccnv cB cima cA cB cima cA
    ccnv ccnv cB cres cA cB cres cA cB rescnvcnv rneqi cA ccnv ccnv cB df-ima
    cA cB df-ima 3eqtr4i $.
    $( [23-Jul-2007] $) $( [8-Apr-2007] $)

  $( A class restricted to its domain equals its double converse. $)
  resdm2 $p |- ( A |` dom A ) = `' `' A $=
    cA ccnv ccnv cA ccnv ccnv cdm cres cA cA ccnv ccnv cdm cres cA ccnv ccnv cA
    cA cdm cres cA cA ccnv ccnv cdm rescnvcnv cA ccnv ccnv wrel cA ccnv ccnv cA
    ccnv ccnv cdm cres cA ccnv ccnv wceq cA ccnv relcnv cA ccnv ccnv resdm
    ax-mp cA ccnv ccnv cdm cA cdm wceq cA cA ccnv ccnv cdm cres cA cA cdm cres
    wceq cA dmcnvcnv cA ccnv ccnv cdm cA cdm cA reseq2 ax-mp 3eqtr3ri $.
    $( [10-Apr-2007] $) $( [8-Apr-2007] $)

  $( Restriction to the domain of a restriction. $)
  resdmres $p |- ( A |` dom ( A |` B ) ) = ( A |` B ) $=
    cA cA cB cres cdm cres cA ccnv ccnv cB cres cA cB cres cA cB cvv cxp cA cdm
    cvv cxp cin cin cA ccnv ccnv cB cvv cxp cin cA cA cB cres cdm cres cA ccnv
    ccnv cB cres cA cB cvv cxp cA cdm cvv cxp cin cin cB cvv cxp cA cA cdm cvv
    cxp cin cin cB cvv cxp cA ccnv ccnv cin cA ccnv ccnv cB cvv cxp cin cA cB
    cvv cxp cA cdm cvv cxp in12 cA cA cdm cvv cxp cin cA ccnv ccnv cB cvv cxp
    cA cA cdm cres cA cA cdm cvv cxp cin cA ccnv ccnv cA cA cdm df-res cA
    resdm2 eqtr3i ineq2i cB cvv cxp cA ccnv ccnv incom 3eqtri cA cA cB cres cdm
    cres cA cA cB cres cdm cvv cxp cin cA cB cvv cxp cA cdm cvv cxp cin cin cA
    cA cB cres cdm df-res cA cB cres cdm cvv cxp cB cvv cxp cA cdm cvv cxp cin
    cA cA cB cres cdm cvv cxp cB cA cdm cin cvv cxp cB cvv cxp cA cdm cvv cxp
    cin cA cB cres cdm cB cA cdm cin cvv cA cB dmres xpeq1i cB cA cdm cvv
    xpindir eqtri ineq2i eqtri cA ccnv ccnv cB df-res 3eqtr4i cA cB rescnvcnv
    eqtri $.
    $( [11-Apr-2007] $) $( [8-Apr-2007] $)

  $( The image of the domain of a restriction. $)
  imadmres $p |- ( A " dom ( A |` B ) ) = ( A " B ) $=
    cA cA cB cres cdm cres crn cA cB cres crn cA cA cB cres cdm cima cA cB cima
    cA cA cB cres cdm cres cA cB cres cA cB resdmres rneqi cA cA cB cres cdm
    df-ima cA cB df-ima 3eqtr4i $.
    $( [8-Apr-2007] $) $( [8-Apr-2007] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( A composition is a relation.  Exercise 24 of [TakeutiZaring] p. 25. $)
    relco $p |- Rel ( A o. B ) $=
      cA cB ccom wrel vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx vy
      copab wrel vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx vy relopab
      cA cB ccom vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx vy copab vx
      vy vz cA cB df-co releqi mpbir $.
      $( [26-Jan-1997] $)

    $( Alternate definition of a class composition, using only one bound
       variable. $)
    dfco2 $p |- ( A o. B )
                = U_ x e. _V ( ( `' B " { x } ) X. ( A " { x } ) ) $=
      vy vz cA cB ccom vx cvv cB ccnv vx cv csn cima cA vx cv csn cima cxp ciun
      cA cB relco vx cvv cB ccnv vx cv csn cima cA vx cv csn cima cxp ciun wrel
      cB ccnv vx cv csn cima cA vx cv csn cima cxp wrel vx cvv vx cvv cB ccnv
      vx cv csn cima cA vx cv csn cima cxp reliun cB ccnv vx cv csn cima cA vx
      cv csn cima cxp wrel vx cv cvv wcel cB ccnv vx cv csn cima cA vx cv csn
      cima relxp a1i mprgbir vy cv vz cv cop cA cB ccom wcel vy cv vx cv cop cB
      wcel vx cv vz cv cop cA wcel wa vx wex vy cv vz cv cop vx cvv cB ccnv vx
      cv csn cima cA vx cv csn cima cxp ciun wcel vy cv cvv wcel vz cv cvv wcel
      vy cv vz cv cop cA cB ccom wcel vy cv vx cv cop cB wcel vx cv vz cv cop
      cA wcel wa vx wex wb vy visset vz visset vx vy cv vz cv cA cB cvv cvv
      opelco2g mp2an vy cv vz cv cop vx cvv cB ccnv vx cv csn cima cA vx cv csn
      cima cxp ciun wcel vy cv vz cv cop cB ccnv vx cv csn cima cA vx cv csn
      cima cxp wcel vx cvv wrex vy cv vz cv cop cB ccnv vx cv csn cima cA vx cv
      csn cima cxp wcel vx wex vy cv vx cv cop cB wcel vx cv vz cv cop cA wcel
      wa vx wex vx vy cv vz cv cop cvv cB ccnv vx cv csn cima cA vx cv csn cima
      cxp eliun vy cv vz cv cop cB ccnv vx cv csn cima cA vx cv csn cima cxp
      wcel vx rexv vy cv vz cv cop cB ccnv vx cv csn cima cA vx cv csn cima cxp
      wcel vy cv vx cv cop cB wcel vx cv vz cv cop cA wcel wa vx vy cv vz cv
      cop cB ccnv vx cv csn cima cA vx cv csn cima cxp wcel vy cv cB ccnv vx cv
      csn cima wcel vz cv cA vx cv csn cima wcel wa vy cv vx cv cop cB wcel vx
      cv vz cv cop cA wcel wa vy cv vz cv cB ccnv vx cv csn cima cA vx cv csn
      cima vz visset opelxp vy cv cB ccnv vx cv csn cima wcel vy cv vx cv cop
      cB wcel vz cv cA vx cv csn cima wcel vx cv vz cv cop cA wcel vy cv cB
      ccnv vx cv csn cima wcel vx cv vy cv cop cB ccnv wcel vy cv vx cv cop cB
      wcel cB ccnv vx cv vy cv vx visset vy visset elimasn vx cv vy cv cB vx
      visset vy visset opelcnv bitri cA vx cv vz cv vx visset vz visset elimasn
      anbi12i bitri exbii 3bitrri bitri eqrelriv $.
      $( [24-Dec-2008] $) $( [19-Dec-2008] $)

    $( Generalization of ~ dfco2 , where ` C ` can have any value between
       ` dom A i^i ran B ` and ` _V ` . $)
    dfco2a $p |- ( ( dom A i^i ran B ) C_ C -> ( A o. B )
         = U_ x e. C ( ( `' B " { x } ) X. ( A " { x } ) ) ) $=
      cA cdm cB crn cin cC wss cA cB ccom vx cC cB ccnv vx cv csn cima cA vx cv
      csn cima cxp ciun cA cdm cB crn cin cC wss vx cA cdm cB crn cin cB ccnv
      vx cv csn cima cA vx cv csn cima cxp ciun vx cC cB ccnv vx cv csn cima cA
      vx cv csn cima cxp ciun cA cB ccom vx cA cdm cB crn cin cC cB ccnv vx cv
      csn cima cA vx cv csn cima cxp iunss1 cA cB ccom vx cvv cB ccnv vx cv csn
      cima cA vx cv csn cima cxp ciun vx cA cdm cB crn cin cvv cA cdm cB crn
      cin cdif cun cB ccnv vx cv csn cima cA vx cv csn cima cxp ciun vx cA cdm
      cB crn cin cB ccnv vx cv csn cima cA vx cv csn cima cxp ciun vx cA cB
      dfco2 cA cdm cB crn cin cvv cA cdm cB crn cin cdif cun cvv wceq vx cA cdm
      cB crn cin cvv cA cdm cB crn cin cdif cun cB ccnv vx cv csn cima cA vx cv
      csn cima cxp ciun vx cvv cB ccnv vx cv csn cima cA vx cv csn cima cxp
      ciun wceq cA cdm cB crn cin undifv vx cA cdm cB crn cin cvv cA cdm cB crn
      cin cdif cun cvv cB ccnv vx cv csn cima cA vx cv csn cima cxp iuneq1
      ax-mp vx cA cdm cB crn cin cvv cA cdm cB crn cin cdif cun cB ccnv vx cv
      csn cima cA vx cv csn cima cxp ciun vx cA cdm cB crn cin cB ccnv vx cv
      csn cima cA vx cv csn cima cxp ciun vx cvv cA cdm cB crn cin cdif cB ccnv
      vx cv csn cima cA vx cv csn cima cxp ciun cun vx cA cdm cB crn cin cB
      ccnv vx cv csn cima cA vx cv csn cima cxp ciun c0 cun vx cA cdm cB crn
      cin cB ccnv vx cv csn cima cA vx cv csn cima cxp ciun vx cA cdm cB crn
      cin cvv cA cdm cB crn cin cdif cB ccnv vx cv csn cima cA vx cv csn cima
      cxp iunxun vx cvv cA cdm cB crn cin cdif cB ccnv vx cv csn cima cA vx cv
      csn cima cxp ciun c0 vx cA cdm cB crn cin cB ccnv vx cv csn cima cA vx cv
      csn cima cxp ciun vx cvv cA cdm cB crn cin cdif cB ccnv vx cv csn cima cA
      vx cv csn cima cxp ciun vx cvv cA cdm cB crn cin cdif c0 ciun c0 vx cvv
      cA cdm cB crn cin cdif cB ccnv vx cv csn cima cA vx cv csn cima cxp c0 vx
      cv cB crn wcel wn vx cv cA cdm wcel wn wo cB ccnv vx cv csn cima c0 wceq
      cA vx cv csn cima c0 wceq wo vx cv cvv cA cdm cB crn cin cdif wcel cB
      ccnv vx cv csn cima cA vx cv csn cima cxp c0 wceq vx cv cB crn wcel wn cB
      ccnv vx cv csn cima c0 wceq vx cv cA cdm wcel wn cA vx cv csn cima c0
      wceq vx cv cB crn wcel wn vx cv cB ccnv cdm wcel wn cB ccnv vx cv csn
      cima c0 wceq vx cv cB crn wcel vx cv cB ccnv cdm wcel cB crn cB ccnv cdm
      vx cv cB df-rn eleq2i notbii vx cv cB ccnv ndmima sylbi vx cv cA ndmima
      orim12i vx cv cvv cA cdm cB crn cin cdif wcel vx cv cvv wcel vx cv cA cdm
      cB crn cin wcel wn wa vx cv cA cdm cB crn cin wcel wn vx cv cB crn wcel
      wn vx cv cA cdm wcel wn wo vx cv cvv cA cdm cB crn cin eldif vx cv cvv
      wcel vx cv cA cdm cB crn cin wcel wn vx visset biantrur vx cv cA cdm cB
      crn cin wcel wn vx cv cA cdm wcel vx cv cB crn wcel wa wn vx cv cA cdm
      wcel wn vx cv cB crn wcel wn wo vx cv cB crn wcel wn vx cv cA cdm wcel wn
      wo vx cv cA cdm cB crn cin wcel vx cv cA cdm wcel vx cv cB crn wcel wa vx
      cv cA cdm cB crn elin notbii vx cv cA cdm wcel vx cv cB crn wcel ianor vx
      cv cA cdm wcel wn vx cv cB crn wcel wn orcom 3bitri 3bitr2i cB ccnv vx cv
      csn cima cA vx cv csn cima xpeq0 3imtr4i iuneq2i vx cvv cA cdm cB crn cin
      cdif iun0 eqtri uneq2i vx cA cdm cB crn cin cB ccnv vx cv csn cima cA vx
      cv csn cima cxp ciun un0 3eqtri 3eqtr2i syl5ss cA cdm cB crn cin cC wss
      vx cC cB ccnv vx cv csn cima cA vx cv csn cima cxp ciun vx cvv cB ccnv vx
      cv csn cima cA vx cv csn cima cxp ciun cA cB ccom vx cC cB ccnv vx cv csn
      cima cA vx cv csn cima cxp ciun vx cvv cB ccnv vx cv csn cima cA vx cv
      csn cima cxp ciun wss cA cdm cB crn cin cC wss cC cvv wss vx cC cB ccnv
      vx cv csn cima cA vx cv csn cima cxp ciun vx cvv cB ccnv vx cv csn cima
      cA vx cv csn cima cxp ciun wss cC ssv vx cC cvv cB ccnv vx cv csn cima cA
      vx cv csn cima cxp iunss1 ax-mp a1i vx cA cB dfco2 syl6ssr eqssd $.
      $( [6-Jan-2009] $) $( [21-Dec-2008] $)

    $( Class composition distributes over union. $)
    coundi $p |- ( A o. ( B u. C ) ) = ( ( A o. B ) u. ( A o. C ) ) $=
      vx vy cA cB cC cun ccom cA cB ccom cA cC ccom cun cA cB cC cun relco cA
      cB ccom cA cC ccom cun wrel cA cB ccom wrel cA cC ccom wrel cA cB ccom cA
      cC ccom relun cA cB relco cA cC relco mpbir2an vx cv vz cv cB cC cun wbr
      vz cv vy cv cA wbr wa vz wex vx cv vy cv cop cA cB ccom wcel vx cv vy cv
      cop cA cC ccom wcel wo vx cv vy cv cop cA cB cC cun ccom wcel vx cv vy cv
      cop cA cB ccom cA cC ccom cun wcel vx cv vz cv cB wbr vz cv vy cv cA wbr
      wa vx cv vz cv cC wbr vz cv vy cv cA wbr wa wo vz wex vx cv vz cv cB wbr
      vz cv vy cv cA wbr wa vz wex vx cv vz cv cC wbr vz cv vy cv cA wbr wa vz
      wex wo vx cv vz cv cB cC cun wbr vz cv vy cv cA wbr wa vz wex vx cv vy cv
      cop cA cB ccom wcel vx cv vy cv cop cA cC ccom wcel wo vx cv vz cv cB wbr
      vz cv vy cv cA wbr wa vx cv vz cv cC wbr vz cv vy cv cA wbr wa vz 19.43
      vx cv vz cv cB cC cun wbr vz cv vy cv cA wbr wa vx cv vz cv cB wbr vz cv
      vy cv cA wbr wa vx cv vz cv cC wbr vz cv vy cv cA wbr wa wo vz vx cv vz
      cv cB cC cun wbr vz cv vy cv cA wbr wa vx cv vz cv cB wbr vx cv vz cv cC
      wbr wo vz cv vy cv cA wbr wa vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx
      cv vz cv cC wbr vz cv vy cv cA wbr wa wo vx cv vz cv cB cC cun wbr vx cv
      vz cv cB wbr vx cv vz cv cC wbr wo vz cv vy cv cA wbr vx cv vz cv cB cC
      brun anbi1i vx cv vz cv cB wbr vx cv vz cv cC wbr vz cv vy cv cA wbr
      andir bitri exbii vx cv vy cv cop cA cB ccom wcel vx cv vz cv cB wbr vz
      cv vy cv cA wbr wa vz wex vx cv vy cv cop cA cC ccom wcel vx cv vz cv cC
      wbr vz cv vy cv cA wbr wa vz wex vz vx cv vy cv cA cB vx visset vy visset
      opelco vz vx cv vy cv cA cC vx visset vy visset opelco orbi12i 3bitr4i vz
      vx cv vy cv cA cB cC cun vx visset vy visset opelco vx cv vy cv cop cA cB
      ccom cA cC ccom elun 3bitr4i eqrelriv $.
      $( [5-Feb-2009] $) $( [21-Dec-2008] $)

    $( Class composition distributes over union. $)
    coundir $p |- ( ( A u. B ) o. C ) = ( ( A o. C ) u. ( B o. C ) ) $=
      vx vy cA cB cun cC ccom cA cC ccom cB cC ccom cun cA cB cun cC relco cA
      cC ccom cB cC ccom cun wrel cA cC ccom wrel cB cC ccom wrel cA cC ccom cB
      cC ccom relun cA cC relco cB cC relco mpbir2an vx cv vz cv cC wbr vz cv
      vy cv cA cB cun wbr wa vz wex vx cv vz cv cC wbr vz cv vy cv cA wbr wa vx
      cv vz cv cC wbr vz cv vy cv cB wbr wa wo vz wex vx cv vy cv cop cA cB cun
      cC ccom wcel vx cv vy cv cop cA cC ccom cB cC ccom cun wcel vx cv vz cv
      cC wbr vz cv vy cv cA cB cun wbr wa vx cv vz cv cC wbr vz cv vy cv cA wbr
      wa vx cv vz cv cC wbr vz cv vy cv cB wbr wa wo vz vx cv vz cv cC wbr vz
      cv vy cv cA cB cun wbr wa vx cv vz cv cC wbr vz cv vy cv cA wbr vz cv vy
      cv cB wbr wo wa vx cv vz cv cC wbr vz cv vy cv cA wbr wa vx cv vz cv cC
      wbr vz cv vy cv cB wbr wa wo vz cv vy cv cA cB cun wbr vz cv vy cv cA wbr
      vz cv vy cv cB wbr wo vx cv vz cv cC wbr vz cv vy cv cA cB brun anbi2i vx
      cv vz cv cC wbr vz cv vy cv cA wbr vz cv vy cv cB wbr andi bitri exbii vz
      vx cv vy cv cA cB cun cC vx visset vy visset opelco vx cv vy cv cop cA cC
      ccom wcel vx cv vy cv cop cB cC ccom wcel wo vx cv vz cv cC wbr vz cv vy
      cv cA wbr wa vz wex vx cv vz cv cC wbr vz cv vy cv cB wbr wa vz wex wo vx
      cv vy cv cop cA cC ccom cB cC ccom cun wcel vx cv vz cv cC wbr vz cv vy
      cv cA wbr wa vx cv vz cv cC wbr vz cv vy cv cB wbr wa wo vz wex vx cv vy
      cv cop cA cC ccom wcel vx cv vz cv cC wbr vz cv vy cv cA wbr wa vz wex vx
      cv vy cv cop cB cC ccom wcel vx cv vz cv cC wbr vz cv vy cv cB wbr wa vz
      wex vz vx cv vy cv cA cC vx visset vy visset opelco vz vx cv vy cv cB cC
      vx visset vy visset opelco orbi12i vx cv vy cv cop cA cC ccom cB cC ccom
      elun vx cv vz cv cC wbr vz cv vy cv cA wbr wa vx cv vz cv cC wbr vz cv vy
      cv cB wbr wa vz 19.43 3bitr4i 3bitr4i eqrelriv $.
      $( [7-Feb-2009] $) $( [21-Dec-2008] $)

    $( Restricted first member of a class composition. $)
    cores $p |- ( ran B C_ C -> ( ( A |` C ) o. B ) = ( A o. B ) ) $=
      cB crn cC wss vx cv vy cv cop cA cC cres cB ccom wcel vx cv vy cv cop cA
      cB ccom wcel wb vy wal vx wal cA cC cres cB ccom cA cB ccom wceq cB crn
      cC wss vx cv vy cv cop cA cC cres cB ccom wcel vx cv vy cv cop cA cB ccom
      wcel wb vx vy cB crn cC wss vx cv vz cv cB wbr vz cv vy cv cA cC cres wbr
      wa vz wex vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx cv vy cv cop
      cA cC cres cB ccom wcel vx cv vy cv cop cA cB ccom wcel cB crn cC wss vx
      cv vz cv cB wbr vz cv vy cv cA cC cres wbr wa vx cv vz cv cB wbr vz cv vy
      cv cA wbr wa vz cB crn cC wss vx cv vz cv cB wbr vz cv cC wcel wa vz cv
      vy cv cA wbr wa vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx cv vz cv cB
      wbr vz cv vy cv cA cC cres wbr wa cB crn cC wss vx cv vz cv cB wbr vz cv
      cC wcel wa vz cv vy cv cA wbr wa vx cv vz cv cB wbr vz cv vy cv cA wbr wa
      vx cv vz cv cB wbr vz cv cC wcel wa vx cv vz cv cB wbr vz cv vy cv cA wbr
      vx cv vz cv cB wbr vz cv cC wcel pm3.26 anim1i cB crn cC wss vx cv vz cv
      cB wbr vx cv vz cv cB wbr vz cv cC wcel wa vz cv vy cv cA wbr cB crn cC
      wss vx cv vz cv cB wbr vz cv cC wcel cB crn cC wss vz cv cB crn wcel vz
      cv cC wcel vx cv vz cv cB wbr cB crn cC vz cv ssel vx cv vz cv cB vx
      visset vz visset brelrn syl5 ancld anim1d impbid2 vx cv vz cv cB wbr vz
      cv vy cv cA cC cres wbr wa vx cv vz cv cB wbr vz cv cC wcel vz cv vy cv
      cA wbr wa wa vx cv vz cv cB wbr vz cv cC wcel wa vz cv vy cv cA wbr wa vz
      cv vy cv cA cC cres wbr vz cv cC wcel vz cv vy cv cA wbr wa vx cv vz cv
      cB wbr vz cv vy cv cA cC cres wbr vz cv vy cv cA wbr vz cv cC wcel wa vz
      cv cC wcel vz cv vy cv cA wbr wa vz cv vy cv cA cC vy visset brres vz cv
      vy cv cA wbr vz cv cC wcel ancom bitri anbi2i vx cv vz cv cB wbr vz cv cC
      wcel vz cv vy cv cA wbr anass bitr4i syl5bb exbidv vz vx cv vy cv cA cC
      cres cB vx visset vy visset opelco vz vx cv vy cv cA cB vx visset vy
      visset opelco 3bitr4g 19.21aivv cA cC cres cB ccom wrel cA cB ccom wrel
      cA cC cres cB ccom cA cB ccom wceq vx cv vy cv cop cA cC cres cB ccom
      wcel vx cv vy cv cop cA cB ccom wcel wb vy wal vx wal wb cA cC cres cB
      relco cA cB relco vx vy cA cC cres cB ccom cA cB ccom eqrel mp2an sylibr
      $.
      $( [17-Oct-2004] $) $( [12-Oct-2004] $)

    $( Associative law for the restriction of a composition. $)
    resco $p |- ( ( A o. B ) |` C ) = ( A o. ( B |` C ) ) $=
      vx vy cA cB ccom cC cres cA cB cC cres ccom cA cB ccom cC relres cA cB cC
      cres relco vx cv vy cv cA cB ccom wbr vx cv cC wcel wa vx cv vz cv cB cC
      cres wbr vz cv vy cv cA wbr wa vz wex vx cv vy cv cA cB ccom cC cres wbr
      vx cv vy cv cA cB cC cres ccom wbr vx cv vy cv cA cB ccom wbr vx cv cC
      wcel wa vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx cv cC wcel wa
      vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx cv cC wcel wa vz wex vx cv vz
      cv cB cC cres wbr vz cv vy cv cA wbr wa vz wex vx cv vy cv cA cB ccom wbr
      vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx cv cC wcel vz vx cv vy
      cv cA cB vx visset vy visset brco anbi1i vx cv vz cv cB wbr vz cv vy cv
      cA wbr wa vx cv cC wcel vz 19.41v vx cv vz cv cB wbr vz cv vy cv cA wbr
      wa vx cv cC wcel wa vx cv vz cv cB cC cres wbr vz cv vy cv cA wbr wa vz
      vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx cv cC wcel wa vx cv vz cv cB
      wbr vx cv cC wcel wa vz cv vy cv cA wbr wa vx cv vz cv cB cC cres wbr vz
      cv vy cv cA wbr wa vx cv vz cv cB wbr vz cv vy cv cA wbr vx cv cC wcel
      an23 vx cv vz cv cB cC cres wbr vx cv vz cv cB wbr vx cv cC wcel wa vz cv
      vy cv cA wbr vx cv vz cv cB cC vz visset brres anbi1i bitr4i exbii
      3bitr2i vx cv vy cv cA cB ccom cC vy visset brres vz vx cv vy cv cA cB cC
      cres vx visset vy visset brco 3bitr4i eqbrriv $.
      $( [11-May-2007] $) $( [12-Dec-2006] $)

    $( Image of the composition of two classes.  (Contributed by Jason
       Orendorff, 12-Dec-2006.) $)
    imaco $p |- ( ( A o. B ) " C ) = ( A " ( B " C ) ) $=
      vx cA cB ccom cC cima cA cB cC cima cima vy cv vx cv cA wbr vy cB cC cima
      wrex vy cv cB cC cima wcel vy cv vx cv cA wbr wa vy wex vx cv cA cB cC
      cima cima wcel vx cv cA cB ccom cC cima wcel vy cv vx cv cA wbr vy cB cC
      cima df-rex vy vx cv cA cB cC cima vx visset elima vx cv cA cB ccom cC
      cima wcel vz cv vy cv cB wbr vz cC wrex vy cv vx cv cA wbr wa vy wex vy
      cv cB cC cima wcel vy cv vx cv cA wbr wa vy wex vx cv cA cB ccom cC cima
      wcel vz cv vy cv cB wbr vy cv vx cv cA wbr wa vy wex vz cC wrex vz cv vy
      cv cB wbr vy cv vx cv cA wbr wa vz cC wrex vy wex vz cv vy cv cB wbr vz
      cC wrex vy cv vx cv cA wbr wa vy wex vx cv cA cB ccom cC cima wcel vz cv
      vx cv cA cB ccom wbr vz cC wrex vz cv vy cv cB wbr vy cv vx cv cA wbr wa
      vy wex vz cC wrex vz vx cv cA cB ccom cC vx visset elima vz cv vx cv cA
      cB ccom wbr vz cv vy cv cB wbr vy cv vx cv cA wbr wa vy wex vz cC vy vz
      cv vx cv cA cB vz visset vx visset brco rexbii bitri vz cv vy cv cB wbr
      vy cv vx cv cA wbr wa vz vy cC rexcom4 vz cv vy cv cB wbr vy cv vx cv cA
      wbr wa vz cC wrex vz cv vy cv cB wbr vz cC wrex vy cv vx cv cA wbr wa vy
      vz cv vy cv cB wbr vy cv vx cv cA wbr vz cC r19.41v exbii 3bitri vy cv cB
      cC cima wcel vy cv vx cv cA wbr wa vz cv vy cv cB wbr vz cC wrex vy cv vx
      cv cA wbr wa vy vy cv cB cC cima wcel vz cv vy cv cB wbr vz cC wrex vy cv
      vx cv cA wbr vz vy cv cB cC vy visset elima anbi1i exbii bitr4i 3bitr4ri
      eqriv $.
      $( [12-Dec-2006] $) $( [11-Dec-2006] $)

    $( The range of the composition of two classes. $)
    rnco $p |- ran ( A o. B ) = ran ( A |` ran B ) $=
      vy cA cB ccom crn cA cB crn cres crn vx cv vy cv cA cB ccom wbr vx wex vz
      cv vy cv cA cB crn cres wbr vz wex vy cv cA cB ccom crn wcel vy cv cA cB
      crn cres crn wcel vx cv vy cv cA cB ccom wbr vx wex vx cv vz cv cB wbr vz
      cv vy cv cA wbr wa vz wex vx wex vx cv vz cv cB wbr vz cv vy cv cA wbr wa
      vx wex vz wex vz cv vy cv cA cB crn cres wbr vz wex vx cv vy cv cA cB
      ccom wbr vx cv vz cv cB wbr vz cv vy cv cA wbr wa vz wex vx vz vx cv vy
      cv cA cB vx visset vy visset brco exbii vx cv vz cv cB wbr vz cv vy cv cA
      wbr wa vx vz excom vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx wex vz cv
      vy cv cA cB crn cres wbr vz vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx
      wex vz cv vy cv cA wbr vz cv cB crn wcel wa vz cv vy cv cA cB crn cres
      wbr vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr wa vz cv vy cv cA wbr vx
      cv vz cv cB wbr vx wex wa vx cv vz cv cB wbr vz cv vy cv cA wbr wa vx wex
      vz cv vy cv cA wbr vz cv cB crn wcel wa vx cv vz cv cB wbr vx wex vz cv
      vy cv cA wbr ancom vx cv vz cv cB wbr vz cv vy cv cA wbr vx 19.41v vz cv
      cB crn wcel vx cv vz cv cB wbr vx wex vz cv vy cv cA wbr vx vz cv cB vz
      visset elrn anbi2i 3bitr4i vz cv vy cv cA cB crn vy visset brres bitr4i
      exbii 3bitri vx vy cv cA cB ccom vy visset elrn vz vy cv cA cB crn cres
      vy visset elrn 3bitr4i eqriv $.
      $( [31-May-2007] $) $( [12-Dec-2006] $)
  $}

  $( The range of the composition of two classes. $)
  rnco2 $p |- ran ( A o. B ) = ( A " ran B ) $=
    cA cB ccom crn cA cB crn cres crn cA cB crn cima cA cB rnco cA cB crn
    df-ima eqtr4i $.
    $( [27-Mar-2008] $) $( [27-Mar-2008] $)

  $( The domain of a composition.  Exercise 27 of [Enderton] p. 53. $)
  dmco $p |- dom ( A o. B ) = ( `' B " dom A ) $=
    cA cB ccom cdm cA cB ccom ccnv crn cB ccnv cA ccnv ccom crn cB ccnv cA cdm
    cima cA cB ccom dfdm4 cA cB ccom ccnv cB ccnv cA ccnv ccom cA cB cnvco
    rneqi cB ccnv cA ccnv ccom crn cB ccnv cA ccnv crn cima cB ccnv cA cdm cima
    cB ccnv cA ccnv rnco2 cA cdm cA ccnv crn cB ccnv cA dfdm4 imaeq2i eqtr4i
    3eqtri $.
    $( [5-Feb-2004] $) $( [4-Feb-2004] $)

  ${
    $d w x y z A $.  $d w y z B $.  $d w y z C $.
    $( Composition with an indexed union. $)
    coiun $p |- ( A o. U_ x e. C B ) = U_ x e. C ( A o. B ) $=
      vy vz cA vx cC cB ciun ccom vx cC cA cB ccom ciun cA vx cC cB ciun relco
      vx cC cA cB ccom ciun wrel cA cB ccom wrel vx cC vx cC cA cB ccom reliun
      cA cB ccom wrel vx cv cC wcel cA cB relco a1i mprgbir vy cv vw cv vx cC
      cB ciun wbr vw cv vz cv cA wbr wa vw wex vy cv vw cv cB wbr vw cv vz cv
      cA wbr wa vw wex vx cC wrex vy cv vz cv cop cA vx cC cB ciun ccom wcel vy
      cv vz cv cop vx cC cA cB ccom ciun wcel vy cv vw cv vx cC cB ciun wbr vw
      cv vz cv cA wbr wa vw wex vy cv vw cv cB wbr vw cv vz cv cA wbr wa vx cC
      wrex vw wex vy cv vw cv cB wbr vw cv vz cv cA wbr wa vw wex vx cC wrex vy
      cv vw cv vx cC cB ciun wbr vw cv vz cv cA wbr wa vy cv vw cv cB wbr vw cv
      vz cv cA wbr wa vx cC wrex vw vy cv vw cv vx cC cB ciun wbr vw cv vz cv
      cA wbr wa vy cv vw cv cB wbr vx cC wrex vw cv vz cv cA wbr wa vy cv vw cv
      cB wbr vw cv vz cv cA wbr wa vx cC wrex vy cv vw cv vx cC cB ciun wbr vy
      cv vw cv cB wbr vx cC wrex vw cv vz cv cA wbr vy cv vw cv cop vx cC cB
      ciun wcel vy cv vw cv cop cB wcel vx cC wrex vy cv vw cv vx cC cB ciun
      wbr vy cv vw cv cB wbr vx cC wrex vx vy cv vw cv cop cC cB eliun vy cv vw
      cv vx cC cB ciun df-br vy cv vw cv cB wbr vy cv vw cv cop cB wcel vx cC
      vy cv vw cv cB df-br rexbii 3bitr4i anbi1i vy cv vw cv cB wbr vw cv vz cv
      cA wbr vx cC r19.41v bitr4i exbii vy cv vw cv cB wbr vw cv vz cv cA wbr
      wa vx vw cC rexcom4 bitr4i vw vy cv vz cv cA vx cC cB ciun vy visset vz
      visset opelco vy cv vz cv cop vx cC cA cB ccom ciun wcel vy cv vz cv cop
      cA cB ccom wcel vx cC wrex vy cv vw cv cB wbr vw cv vz cv cA wbr wa vw
      wex vx cC wrex vx vy cv vz cv cop cC cA cB ccom eliun vy cv vz cv cop cA
      cB ccom wcel vy cv vw cv cB wbr vw cv vz cv cA wbr wa vw wex vx cC vw vy
      cv vz cv cA cB vy visset vz visset opelco rexbii bitri 3bitr4i eqrelriv
      $.
      $( [3-Jan-2009] $) $( [21-Dec-2008] $)
  $}

  $( A composition is not affected by a double converse of its first
     argument. $)
  cocnvcnv1 $p |- ( `' `' A o. B ) = ( A o. B ) $=
    cA ccnv ccnv cB ccom cA cvv cres cB ccom cA cB ccom cA ccnv ccnv cA cvv
    cres cB cA cnvcnv2 coeq1i cB crn cvv wss cA cvv cres cB ccom cA cB ccom
    wceq cB crn ssv cA cB cvv cores ax-mp eqtri $.
    $( [16-Dec-2007] $) $( [8-Oct-2007] $)

  $( A composition is not affected by a double converse of its second
     argument. $)
  cocnvcnv2 $p |- ( A o. `' `' B ) = ( A o. B ) $=
    cA cB ccnv ccnv ccom cA cB cvv cres ccom cA cB ccom cvv cres cA cB ccom cB
    ccnv ccnv cB cvv cres cA cB cnvcnv2 coeq2i cA cB cvv resco cA cB ccom wrel
    cA cB ccom cvv cres cA cB ccom wceq cA cB relco cA cB ccom dfrel3 mpbi
    3eqtr2i $.
    $( [23-Dec-2007] $) $( [8-Oct-2007] $)

  $( Absorption of a reverse (preimage) restriction of the second member of a
     class composition. $)
  cores2 $p |- ( dom A C_ C -> ( A o. `' ( `' B |` C ) ) = ( A o. B ) ) $=
    cA cdm cC wss cA cB ccnv cC cres ccnv ccom ccnv ccnv cA cB ccom ccnv ccnv
    cA cB ccnv cC cres ccnv ccom cA cB ccom cA cdm cC wss cA cB ccnv cC cres
    ccnv ccom ccnv cA cB ccom ccnv wceq cA cB ccnv cC cres ccnv ccom ccnv ccnv
    cA cB ccom ccnv ccnv wceq cA cdm cC wss cB ccnv cC cres cA ccnv ccom cB
    ccnv cA ccnv ccom cA cB ccnv cC cres ccnv ccom ccnv cA cB ccom ccnv cA cdm
    cC wss cA ccnv crn cC wss cB ccnv cC cres cA ccnv ccom cB ccnv cA ccnv ccom
    wceq cA cdm cA ccnv crn cC cA dfdm4 sseq1i cB ccnv cA ccnv cC cores sylbi
    cA cB ccnv cC cres ccnv ccom ccnv cB ccnv cC cres ccnv ccnv cA ccnv ccom cB
    ccnv cC cres cA ccnv ccom cA cB ccnv cC cres ccnv cnvco cB ccnv cC cres
    ccnv ccnv cB ccnv cC cres cA ccnv cB ccnv cC cres wrel cB ccnv cC cres ccnv
    ccnv cB ccnv cC cres wceq cB ccnv cC relres cB ccnv cC cres dfrel2 mpbi
    coeq1i eqtri cA cB cnvco 3eqtr4g cA cB ccnv cC cres ccnv ccom ccnv cA cB
    ccom ccnv cnveq syl cA cB ccnv cC cres ccnv ccom wrel cA cB ccnv cC cres
    ccnv ccom ccnv ccnv cA cB ccnv cC cres ccnv ccom wceq cA cB ccnv cC cres
    ccnv relco cA cB ccnv cC cres ccnv ccom dfrel2 mpbi cA cB ccom wrel cA cB
    ccom ccnv ccnv cA cB ccom wceq cA cB relco cA cB ccom dfrel2 mpbi 3eqtr3g
    $.
    $( [27-Jun-2007] $) $( [11-Dec-2006] $)

  ${
    $d x y z A $.
    $( Composition with the empty set.  Theorem 20 of [Suppes] p. 63. $)
    co02 $p |- ( A o. (/) ) = (/) $=
      vx vy cA c0 ccom c0 cA c0 relco rel0 vx cv vy cv cop cA c0 ccom wcel vx
      cv vy cv cop c0 wcel vx cv vy cv cop cA c0 ccom wcel vx cv vz cv c0 wbr
      vz cv vy cv cA wbr wa vz wex vx cv vz cv c0 wbr vz cv vy cv cA wbr wa vz
      vx cv vz cv c0 wbr vz cv vy cv cA wbr vx cv vz cv c0 wbr vx cv vz cv cop
      c0 wcel vx cv vz cv cop noel vx cv vz cv c0 df-br mtbir intnanr nex vz vx
      cv vy cv cA c0 vx visset vy visset opelco mtbir vx cv vy cv cop noel
      2false eqrelriv $.
      $( [15-May-2004] $) $( [24-Apr-2004] $)

    $( Composition with the empty set. $)
    co01 $p |- ( (/) o. A ) = (/) $=
      c0 ccnv ccnv c0 cA ccom ccnv ccnv c0 c0 cA ccom c0 ccnv c0 cA ccom ccnv
      c0 cA ccnv c0 ccnv ccom c0 ccnv c0 cA ccom ccnv cA ccnv c0 ccnv ccom cA
      ccnv c0 ccom c0 c0 ccnv c0 cA ccnv cnv0 coeq2i cA ccnv co02 eqtr2i cnv0
      c0 cA cnvco 3eqtr4i cnveqi c0 wrel c0 ccnv ccnv c0 wceq rel0 c0 dfrel2
      mpbi c0 cA ccom wrel c0 cA ccom ccnv ccnv c0 cA ccom wceq c0 cA relco c0
      cA ccom dfrel2 mpbi 3eqtr3ri $.
      $( [15-May-2004] $) $( [24-Apr-2004] $)

    $( Composition with the identity relation.  Part of Theorem 3.7(i) of
       [Monk1] p. 36. $)
    coi1 $p |- ( Rel A -> ( A o. _I ) = A ) $=
      cA cid ccom wrel cA wrel cA cid ccom cA wceq cA cid relco cA cid ccom
      wrel cA wrel wa cA cid ccom cA wceq vx cv vy cv cop cA cid ccom wcel vx
      cv vy cv cop cA wcel wb vy wal vx wal vx cv vy cv cop cA cid ccom wcel vx
      cv vy cv cop cA wcel wb vx vy vx cv vy cv cop cA cid ccom wcel vx cv vy
      cv cA wbr vx cv vy cv cop cA wcel vx cv vy cv cop cA cid ccom wcel vx cv
      vz cv cid wbr vz cv vy cv cA wbr wa vz wex vz cv vx cv wceq vz cv vy cv
      cA wbr wa vz wex vx cv vy cv cA wbr vz vx cv vy cv cA cid vx visset vy
      visset opelco vx cv vz cv cid wbr vz cv vy cv cA wbr wa vz cv vx cv wceq
      vz cv vy cv cA wbr wa vz vx cv vz cv cid wbr vz cv vx cv wceq vz cv vy cv
      cA wbr vx cv vz cv cid wbr vx cv vz cv wceq vz cv vx cv wceq vx cv vz cv
      vz visset ideq vx cv vz cv eqcom bitri anbi1i exbii vz cv vy cv cA wbr vx
      cv vy cv cA wbr vz vx cv vx visset vz cv vx cv vy cv cA breq1 ceqsexv
      3bitri vx cv vy cv cA df-br bitri gen2 vx vy cA cid ccom cA eqrel mpbiri
      mpan $.
      $( [25-Apr-2004] $) $( [22-Apr-2004] $)

    $( Composition with the identity relation.  Part of Theorem 3.7(i) of
       [Monk1] p. 36. $)
    coi2 $p |- ( Rel A -> ( _I o. A ) = A ) $=
      cA wrel cid cA ccom cA ccnv ccnv cA cA wrel cid ccnv cA ccnv ccnv ccom
      cid cA ccom cA ccnv ccnv cA wrel cA ccnv ccnv cA wceq cid ccnv cA ccnv
      ccnv ccom cid cA ccom wceq cA dfrel2 cA ccnv ccnv cA wceq cid ccnv cid
      wceq cid ccnv cA ccnv ccnv ccom cid cA ccom wceq cnvi cA ccnv ccnv cA
      wceq cid ccnv cid wceq cid ccnv cA ccnv ccnv ccom cid ccnv cA ccom cid cA
      ccom cA ccnv ccnv cA cid ccnv coeq2 cid ccnv cid cA coeq1 sylan9eq mpan2
      sylbi cA ccnv cid ccom ccnv cid ccnv cA ccnv ccnv ccom cA ccnv ccnv cA
      ccnv cid cnvco cA ccnv cid ccom cA ccnv cA ccnv wrel cA ccnv cid ccom cA
      ccnv wceq cA relcnv cA ccnv coi1 ax-mp cnveqi eqtr3i syl5reqr cA wrel cA
      ccnv ccnv cA wceq cA dfrel2 biimpi eqtrd $.
      $( [25-Apr-2004] $) $( [22-Apr-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.
    $( Associative law for class composition.  Theorem 27 of [Suppes] p. 64.
       Also Exercise 21 of [Enderton] p. 53.  Interestingly, this law holds for
       any classes whatsoever, not just functions or even relations. $)
    coass $p |- ( ( A o. B ) o. C ) = ( A o. ( B o. C ) ) $=
      vx vy cA cB ccom cC ccom cA cB cC ccom ccom cA cB ccom cC relco cA cB cC
      ccom relco vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy cv cA wbr wa wa
      vw wex vz wex vx cv vz cv cC wbr vz cv vw cv cB wbr wa vw cv vy cv cA wbr
      wa vz wex vw wex vx cv vy cv cop cA cB ccom cC ccom wcel vx cv vy cv cop
      cA cB cC ccom ccom wcel vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy cv
      cA wbr wa wa vw wex vz wex vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy
      cv cA wbr wa wa vz wex vw wex vx cv vz cv cC wbr vz cv vw cv cB wbr wa vw
      cv vy cv cA wbr wa vz wex vw wex vx cv vz cv cC wbr vz cv vw cv cB wbr vw
      cv vy cv cA wbr wa wa vz vw excom vx cv vz cv cC wbr vz cv vw cv cB wbr
      wa vw cv vy cv cA wbr wa vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy
      cv cA wbr wa wa vw vz vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy cv
      cA wbr anass 2exbii bitr4i vx cv vz cv cC wbr vz cv vy cv cA cB ccom wbr
      wa vz wex vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy cv cA wbr wa vw
      wex wa vz wex vx cv vy cv cop cA cB ccom cC ccom wcel vx cv vz cv cC wbr
      vz cv vw cv cB wbr vw cv vy cv cA wbr wa wa vw wex vz wex vx cv vz cv cC
      wbr vz cv vy cv cA cB ccom wbr wa vx cv vz cv cC wbr vz cv vw cv cB wbr
      vw cv vy cv cA wbr wa vw wex wa vz vz cv vy cv cA cB ccom wbr vz cv vw cv
      cB wbr vw cv vy cv cA wbr wa vw wex vx cv vz cv cC wbr vz cv vy cv cA cB
      ccom wbr vz cv vy cv cop cA cB ccom wcel vz cv vw cv cB wbr vw cv vy cv
      cA wbr wa vw wex vz cv vy cv cA cB ccom df-br vw vz cv vy cv cA cB vz
      visset vy visset opelco bitri anbi2i exbii vz vx cv vy cv cA cB ccom cC
      vx visset vy visset opelco vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy
      cv cA wbr wa wa vw wex vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy cv
      cA wbr wa vw wex wa vz vx cv vz cv cC wbr vz cv vw cv cB wbr vw cv vy cv
      cA wbr wa vw 19.42v exbii 3bitr4i vx cv vw cv cB cC ccom wbr vw cv vy cv
      cA wbr wa vw wex vx cv vz cv cC wbr vz cv vw cv cB wbr wa vz wex vw cv vy
      cv cA wbr wa vw wex vx cv vy cv cop cA cB cC ccom ccom wcel vx cv vz cv
      cC wbr vz cv vw cv cB wbr wa vw cv vy cv cA wbr wa vz wex vw wex vx cv vw
      cv cB cC ccom wbr vw cv vy cv cA wbr wa vx cv vz cv cC wbr vz cv vw cv cB
      wbr wa vz wex vw cv vy cv cA wbr wa vw vx cv vw cv cB cC ccom wbr vx cv
      vz cv cC wbr vz cv vw cv cB wbr wa vz wex vw cv vy cv cA wbr vx cv vw cv
      cB cC ccom wbr vx cv vw cv cop cB cC ccom wcel vx cv vz cv cC wbr vz cv
      vw cv cB wbr wa vz wex vx cv vw cv cB cC ccom df-br vz vx cv vw cv cB cC
      vx visset vw visset opelco bitri anbi1i exbii vw vx cv vy cv cA cB cC
      ccom vx visset vy visset opelco vx cv vz cv cC wbr vz cv vw cv cB wbr wa
      vw cv vy cv cA wbr wa vz wex vx cv vz cv cC wbr vz cv vw cv cB wbr wa vz
      wex vw cv vy cv cA wbr wa vw vx cv vz cv cC wbr vz cv vw cv cB wbr wa vw
      cv vy cv cA wbr vz 19.41v exbii 3bitr4i 3bitr4i eqrelriv $.
      $( [27-Jan-1997] $)
  $}

  ${
    $d x y A $.
    $( A relation is included in the cross product of its domain and range.
       Exercise 4.12(t) of [Mendelson] p. 235. $)
    relssdmrn $p |- ( Rel A -> A C_ ( dom A X. ran A ) ) $=
      cA wrel vx vy cA cA cdm cA crn cxp cA wrel id vx cv vy cv cop cA wcel vx
      cv vy cv cop cA cdm cA crn cxp wcel wi cA wrel vx cv vy cv cop cA cdm cA
      crn cxp wcel vx cv vy cv cop cA wcel vy wex vx cv vy cv cop cA wcel vx
      wex vx cv vy cv cop cA wcel vx cv vy cv cop cA cdm cA crn cxp wcel vx cv
      cA cdm wcel vy cv cA crn wcel wa vx cv vy cv cop cA wcel vy wex vx cv vy
      cv cop cA wcel vx wex wa vx cv vy cv cA cdm cA crn vy visset opelxp vx cv
      cA cdm wcel vx cv vy cv cop cA wcel vy wex vy cv cA crn wcel vx cv vy cv
      cop cA wcel vx wex vy vx cv cA vx visset eldm2 vx vy cv cA vy visset
      elrn2 anbi12i bitri vx cv vy cv cop cA wcel vy 19.8a vx cv vy cv cop cA
      wcel vx 19.8a sylanbrc a1i relssdv $.
      $( [3-Aug-1994] $)
  $}

  $( Two ways to describe the structure of a two-place operation. $)
  relrelss $p |- ( ( Rel A /\ Rel dom A ) <-> A C_ ( ( _V X. _V ) X. _V ) ) $=
    cA wrel cA cdm wrel wa cA wrel cA cdm cvv cvv cxp wss wa cA cvv cvv cxp cvv
    cxp wss cA cdm wrel cA cdm cvv cvv cxp wss cA wrel cA cdm df-rel anbi2i cA
    wrel cA cdm cvv cvv cxp wss wa cA cvv cvv cxp cvv cxp wss cA wrel cA cdm
    cvv cvv cxp wss cA cA cdm cA crn cxp cvv cvv cxp cvv cxp cA relssdmrn cA
    cdm cvv cvv cxp wss cA crn cvv wss cA cdm cA crn cxp cvv cvv cxp cvv cxp
    wss cA crn ssv cA cdm cvv cvv cxp cA crn cvv ssxp mpan2 sylan9ss cA cvv cvv
    cxp cvv cxp wss cA wrel cA cdm cvv cvv cxp wss cA cvv cvv cxp cvv cxp wss
    cA cvv cvv cxp wss cA wrel cA cvv cvv cxp cvv cxp wss cvv cvv cxp cvv cxp
    cvv cvv cxp wss cA cvv cvv cxp wss cvv cvv cxp cvv xpss cA cvv cvv cxp cvv
    cxp cvv cvv cxp sstr mpan2 cA df-rel sylibr cA cvv cvv cxp cvv cxp wss cA
    cdm cvv cvv cxp cvv cxp cdm cvv cvv cxp cA cvv cvv cxp cvv cxp dmss cvv c0
    wne cvv cvv cxp cvv cxp cdm cvv cvv cxp wceq vn0 cvv cvv cxp cvv dmxp ax-mp
    syl6ss jca impbii bitri $.
    $( [2-Jan-2009] $) $( [17-Dec-2008] $)

  ${
    $d x y A $.  $d x y R $.
    $( The membership relation for a relation is inherited by class union. $)
    unielrel $p |- ( ( Rel R /\ A e. R ) -> U. A e. U. R ) $=
      cA vx cv vy cv cop wceq vy wex vx wex cA cR wcel cA cuni cR cuni wcel cR
      wrel cA cR wcel wa cA vx cv vy cv cop wceq cA cR wcel cA cuni cR cuni
      wcel wi vx vy cA vx cv vy cv cop wceq vx cv vy cv cop cR wcel vx cv vy cv
      cop cuni cR cuni wcel cA cR wcel cA cuni cR cuni wcel vx cv vy cv cop cR
      wcel vx cv vy cv cop cuni cR cuni wcel wi cA vx cv vy cv cop wceq vx cv
      vy cv cR uniopel a1i cA vx cv vy cv cop cR eleq1 cA vx cv vy cv cop wceq
      cA cuni vx cv vy cv cop cuni cR cuni cA vx cv vy cv cop unieq eleq1d
      3imtr4d 19.23aivv vx vy cA cR elrel cR wrel cA cR wcel pm3.27 sylc $.
      $( [20-Sep-2006] $) $( [17-Sep-2006] $)
  $}

  $( The double union of a relation is its field. $)
  relfld $p |- ( Rel R -> U. U. R = ( dom R u. ran R ) ) $=
    cR wrel cR cuni cuni cR cdm cR crn cun cR wrel cR cuni cuni cR cdm cR crn
    cxp cuni cuni cR cdm cR crn cun cR wrel cR cR cdm cR crn cxp wss cR cuni cR
    cdm cR crn cxp cuni wss cR cuni cuni cR cdm cR crn cxp cuni cuni wss cR
    relssdmrn cR cR cdm cR crn cxp uniss cR cuni cR cdm cR crn cxp cuni uniss
    3syl cR cdm cR crn cxp cuni cuni cR cdm cR crn cun wss cR wrel cR cdm cR
    crn unixpss a1i sstrd cR cdm cR crn cun cR cuni cuni wss cR wrel cR
    dmrnssfld a1i eqssd $.
    $( [22-Sep-2006] $) $( [17-Sep-2006] $)

  $( The double union of the converse of a class is its field. $)
  unidmrn $p |- U. U. `' A = ( dom A u. ran A ) $=
    cA ccnv crn cA ccnv cdm cun cA ccnv cdm cA ccnv crn cun cA cdm cA crn cun
    cA ccnv cuni cuni cA ccnv crn cA ccnv cdm uncom cA cdm cA ccnv crn cA crn
    cA ccnv cdm cA dfdm4 cA df-rn uneq12i cA ccnv wrel cA ccnv cuni cuni cA
    ccnv cdm cA ccnv crn cun wceq cA relcnv cA ccnv relfld ax-mp 3eqtr4ri $.
    $( [13-Jun-2008] $) $( [4-Jun-2008] $)

  $( Alternate definition of domain ~ df-dm that doesn't require dummy
     variables. $)
  dfdm2 $p |- dom A = U. U. ( `' A o. A ) $=
    cA ccnv cA ccom cuni cuni cA ccnv cA ccom cdm cA ccnv cA ccom crn cun cA
    cdm cA cdm cun cA cdm cA ccnv cA ccom ccnv cuni cuni cA ccnv cA ccom cuni
    cuni cA ccnv cA ccom cdm cA ccnv cA ccom crn cun cA ccnv cA ccom ccnv cuni
    cA ccnv cA ccom cuni cA ccnv cA ccom ccnv cA ccnv cA ccom cA ccnv cA ccom
    ccnv cA ccnv cA ccnv ccnv ccom cA ccnv cA ccom cA ccnv cA cnvco cA ccnv cA
    cocnvcnv2 eqtri unieqi unieqi cA ccnv cA ccom unidmrn eqtr3i cA ccnv cA
    ccom cdm cA cdm cA ccnv cA ccom crn cA cdm cA ccnv cdm cA crn wceq cA ccnv
    cA ccom cdm cA cdm wceq cA crn cA ccnv cdm cA df-rn eqcomi cA ccnv cA
    dmcoeq ax-mp cA ccnv cA ccom crn cA ccnv crn cA cdm cA ccnv cdm cA crn wceq
    cA ccnv cA ccom crn cA ccnv crn wceq cA crn cA ccnv cdm cA df-rn eqcomi cA
    ccnv cA rncoeq ax-mp cA dfdm4 eqtr4i uneq12i cA cdm unidm 3eqtrri $.
    $( [3-Aug-2010] $) $( [2-Aug-2010] $)

  $( The double class union of a non-empty cross product is the union of it
     members. $)
  unixp $p |- ( ( A X. B ) =/= (/) -> U. U. ( A X. B ) = ( A u. B ) ) $=
    cA cB cxp c0 wne cA cB cxp cdm cA cB cxp crn cun cA cB cun cA cB cxp cuni
    cuni cB c0 wne cA c0 wne cA cB cxp cdm cA cB cxp crn cun cA cB cun wceq cA
    cB cxp c0 wne cA cB cxp cdm cA wceq cA cB cxp crn cB wceq cA cB cxp cdm cA
    cB cxp crn cun cA cB cun wceq cB c0 wne cA c0 wne cA cB cxp cdm cA cA cB
    cxp crn cB uneq12 cA cB dmxp cA cB rnxp syl2an cB c0 cA cB cxp c0 cB c0
    wceq cA cB cxp cA c0 cxp c0 cB c0 cA xpeq2 cA xp0 syl6eq necon3i cA c0 cA
    cB cxp c0 cA c0 wceq cA cB cxp c0 cB cxp c0 cA c0 cB xpeq1 cB xp0r syl6eq
    necon3i sylanc cA cB cxp wrel cA cB cxp cuni cuni cA cB cxp cdm cA cB cxp
    crn cun wceq cA cB relxp cA cB cxp relfld ax-mp syl5eq $.
    $( [23-Sep-2006] $) $( [17-Sep-2006] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( A cross product is empty iff its union is empty. $)
    unixp0 $p |- ( ( A X. B ) = (/) <-> U. ( A X. B ) = (/) ) $=
      cA cB cxp c0 wceq cA cB cxp cuni c0 wceq cA cB cxp c0 wceq cA cB cxp cuni
      c0 cuni c0 cA cB cxp c0 unieq uni0 syl6eq cA cB cxp c0 wceq cA cB cxp
      cuni c0 wceq cA cB cxp c0 wceq wn vz cv cA cB cxp wcel vz wex cA cB cxp
      cuni c0 wceq wn vz cA cB cxp neq0 vz cv cA cB cxp wcel cA cB cxp cuni c0
      wceq wn vz vz cv cA cB cxp wcel vx cv vy cv cop vz cv wceq vx cv vy cv
      cop cA cB cxp wcel wa vy wex vx wex cA cB cxp cuni c0 wceq wn vx vy vz cv
      cA cB elxp3 vx cv vy cv cop vz cv wceq vx cv vy cv cop cA cB cxp wcel wa
      cA cB cxp cuni c0 wceq wn vx vy vx cv vy cv cop cA cB cxp wcel cA cB cxp
      cuni c0 wceq wn vx cv vy cv cop vz cv wceq vx cv vy cv cop cA cB cxp wcel
      vx cv vy cv cop csn cA cB cxp wss vx cv vy cv cop cA cB cxp cuni wss cA
      cB cxp cuni c0 wceq wn vx cv vy cv cop cA cB cxp snssi vx cv vy cv cop
      csn cA cB cxp wss vx cv vy cv cop csn cuni cA cB cxp cuni vx cv vy cv cop
      vx cv vy cv cop csn cA cB cxp uniss vx cv vy cv cop vx cv vy cv opex
      unisn syl5ssr vx cv vy cv cop cA cB cxp cuni wss cA cB cxp cuni c0 wceq
      vx cv vy cv cop c0 wceq vx cv vy cv opnz cA cB cxp cuni c0 wceq vx cv vy
      cv cop cA cB cxp cuni wss vx cv vy cv cop c0 wss vx cv vy cv cop c0 wceq
      cA cB cxp cuni c0 wceq vx cv vy cv cop cA cB cxp cuni wss vx cv vy cv cop
      c0 wss cA cB cxp cuni c0 vx cv vy cv cop sseq2 biimpd vx cv vy cv cop ss0
      syl6com mtoi 3syl adantl 19.23aivv sylbi 19.23aiv sylbi con4i impbii $.
      $( [28-Sep-2006] $) $( [20-Sep-2006] $)
  $}

  $( The converse of a set is a set.  Corollary 6.8(1) of [TakeutiZaring]
     p. 26. $)
  cnvexg $p |- ( A e. B -> `' A e. _V ) $=
    cA ccnv cA ccnv cdm cA ccnv crn cxp wss cA ccnv cdm cA ccnv crn cxp cvv
    wcel cA ccnv cvv wcel cA cB wcel cA ccnv cA ccnv cdm cA ccnv crn cxp cvv
    ssexg cA ccnv wrel cA ccnv cA ccnv cdm cA ccnv crn cxp wss cA relcnv cA
    ccnv relssdmrn ax-mp cA ccnv cdm cvv wcel cA ccnv crn cvv wcel cA ccnv cdm
    cA ccnv crn cxp cvv wcel cA cB wcel cA ccnv cdm cA ccnv crn cvv cvv xpexg
    cA cB wcel cA crn cvv cA ccnv cdm cA cB rnexg cA df-rn syl5eqelr cA cB wcel
    cA cdm cvv cA ccnv crn cA cB dmexg cA dfdm4 syl5eqelr sylanc sylancr $.
    $( [17-Mar-1998] $)

  ${
    cnvex.1 $e |- A e. _V $.
    $( The converse of a set is a set.  Corollary 6.8(1) of [TakeutiZaring]
       p. 26. $)
    cnvex $p |- `' A e. _V $=
      cA cvv wcel cA ccnv cvv wcel cnvex.1 cA cvv cnvexg ax-mp $.
      $( [20-Dec-2003] $) $( [19-Dec-2003] $)
  $}

  $( A relation is a set iff its converse is a set.  (Contributed by FL,
     3-Mar-2007.) $)
  relcnvexb $p |- ( Rel R -> ( R e. _V <-> `' R e. _V ) ) $=
    cR wrel cR cvv wcel cR ccnv cvv wcel cR cvv cnvexg cR wrel cR ccnv ccnv cR
    wceq cR ccnv cvv wcel cR cvv wcel wi cR dfrel2 cR ccnv ccnv cR wceq cR ccnv
    ccnv cvv wcel cR cvv wcel cR ccnv cvv wcel cR ccnv ccnv cR cvv eleq1 cR
    ccnv cvv cnvexg syl5bi sylbi impbid2 $.
    $( [7-Mar-2007] $) $( [5-Mar-2007] $)

  ${
    $d x y z A $.  $d x y z R $.
    $( The converse of a partial order relation is a partial order relation. $)
    cnvpo $p |- ( R Po A <-> `' R Po A ) $=
      vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz
      cv cR wbr wi wa vz cA wral vy cA wral vx cA wral vz cv vz cv cR ccnv wbr
      wn vz cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv
      wbr wi wa vx cA wral vy cA wral vz cA wral cA cR wpo cA cR ccnv wpo vx cv
      vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi wa vz cA wral vx cA wral vy cA wral vz cv vz cv cR ccnv wbr wn vz
      cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr
      wi wa vx cA wral vz cA wral vy cA wral vx cv vx cv cR wbr wn vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz cA wral vy cA
      wral vx cA wral vz cv vz cv cR ccnv wbr wn vz cv vy cv cR ccnv wbr vy cv
      vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi wa vx cA wral vy cA wral
      vz cA wral vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi wa vz cA wral vx cA wral vz cv vz cv cR ccnv wbr wn
      vz cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv
      wbr wi wa vx cA wral vz cA wral vy cA vx cv vx cv cR wbr wn vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz cA wral vx cA
      wral vx cv vx cv cR wbr wn vx cA wral vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi vz cA wral wa vx cA wral vz cv vz cv cR ccnv
      wbr wn vz cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR
      ccnv wbr wi wa vz cA wral vx cA wral vz cv vz cv cR ccnv wbr wn vz cv vy
      cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi wa
      vx cA wral vz cA wral vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa vz cA wral vx cA wral vx cv vx cv
      cR wbr wn vx cA wral vx cA wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi vz cA wral vx cA wral wa vx cv vx cv cR wbr wn vx
      cA wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz
      cA wral wa vx cA wral vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa vz cA wral vx cA wral vx cv vx cv
      cR wbr wn vz cA wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv
      cR wbr wi vz cA wral wa vx cA wral vx cv vx cv cR wbr wn vz cA wral vx cA
      wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA
      wral vx cA wral wa vx cv vx cv cR wbr wn vx cA wral vx cA wral vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA wral vx cA
      wral wa vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi wa vz cA wral vx cv vx cv cR wbr wn vz cA wral vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA wral wa vx
      cA vx cv vx cv cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv
      vz cv cR wbr wi vz cA r19.26 ralbii vx cv vx cv cR wbr wn vz cA wral vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA wral vx
      cA r19.26 vx cv vx cv cR wbr wn vz cA wral vx cA wral vx cv vx cv cR wbr
      wn vx cA wral vx cA wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv
      vz cv cR wbr wi vz cA wral vx cA wral vx cv vx cv cR wbr wn vx cA wral vx
      cA wral vx cv vx cv cR wbr wn vx cA wral vx cv vx cv cR wbr wn vz cA wral
      vx cA wral vx cv vx cv cR wbr wn vx cA ralidm vx cv vx cv cR wbr wn vx cA
      wral vx cv vx cv cR wbr wn vz cA wral vx cA wral wb cA c0 vx cv vx cv cR
      wbr wn vx cA wral vx cv vx cv cR wbr wn vz cA wral vx cA wral vx cv vx cv
      cR wbr wn vx cA wral vx cv vx cv cR wbr wn vz cA wral vx cA wral wb cA c0
      wceq vx cv vx cv cR wbr wn vx cA wral vx cv vx cv cR wbr wn vz cA wral vx
      cA wral pm5.1 vx cv vx cv cR wbr wn vx cA rzal vx cv vx cv cR wbr wn vz
      cA wral vx cA rzal sylanc cA c0 wne vx cv vx cv cR wbr wn vx cv vx cv cR
      wbr wn vz cA wral vx cA vx cv vx cv cR wbr wn vz cA r19.3rzv ralbidv
      pm2.61ine bitr2i anbi1i 3bitri vx cv vx cv cR wbr wn vx cA wral vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA wral vx cA
      r19.26 bitr4i vx cv vx cv cR wbr wn vx cA wral vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA wral wa vz cv vz cv cR ccnv
      wbr wn vz cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR
      ccnv wbr wi wa vz cA wral vx cA vz cv vz cv cR ccnv wbr wn vz cv vy cv cR
      ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi wa vz cA
      wral vz cv vz cv cR ccnv wbr wn vz cA wral vz cv vy cv cR ccnv wbr vy cv
      vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi vz cA wral wa vx cv vx cv
      cR wbr wn vx cA wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv
      cR wbr wi vz cA wral wa vz cv vz cv cR ccnv wbr wn vz cv vy cv cR ccnv
      wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi vz cA r19.26 vz
      cv vz cv cR ccnv wbr wn vz cA wral vx cv vx cv cR wbr wn vx cA wral vz cv
      vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi
      vz cA wral vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      vz cA wral vz cv vz cv cR ccnv wbr wn vx cv vx cv cR wbr wn vz vx cA vz
      cv vx cv wceq vz cv vz cv cR ccnv wbr vx cv vx cv cR wbr vz cv vx cv wceq
      vz cv vz cv cR wbr vx cv vx cv cR wbr vz cv vz cv cR ccnv wbr vz cv vx cv
      wceq vz cv vx cv vz cv vx cv cR vz cv vx cv wceq id vz cv vx cv wceq id
      breq12d vz cv vz cv cR vz visset vz visset brcnv syl5bb notbid cbvralv vz
      cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr
      wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz cA
      vz cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vz cv vx cv cR ccnv wbr vx cv vz cv cR wbr vz cv vy cv
      cR ccnv wbr vy cv vx cv cR ccnv wbr wa vy cv vz cv cR wbr vx cv vy cv cR
      wbr wa vx cv vy cv cR wbr vy cv vz cv cR wbr wa vz cv vy cv cR ccnv wbr
      vy cv vz cv cR wbr vy cv vx cv cR ccnv wbr vx cv vy cv cR wbr vz cv vy cv
      cR vz visset vy visset brcnv vy cv vx cv cR vy visset vx visset brcnv
      anbi12i vy cv vz cv cR wbr vx cv vy cv cR wbr ancom bitri vz cv vx cv cR
      vz visset vx visset brcnv imbi12i ralbii anbi12i bitr2i ralbii vz cv vz
      cv cR ccnv wbr wn vz cv vy cv cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz
      cv vx cv cR ccnv wbr wi wa vx vz cA cA ralcom 3bitri ralbii vx cv vx cv
      cR wbr wn vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      wa vz cA wral vx vy cA cA ralcom vz cv vz cv cR ccnv wbr wn vz cv vy cv
      cR ccnv wbr vy cv vx cv cR ccnv wbr wa vz cv vx cv cR ccnv wbr wi wa vx
      cA wral vz vy cA cA ralcom 3bitr4i vx vy vz cA cR df-po vz vy vx cA cR
      ccnv df-po 3bitr4i $.
      $( [15-Jun-2005] $) $( [15-Jun-2005] $)

    $( The converse of a strict order relation is a strict order relation. $)
    cnvso $p |- ( R Or A <-> `' R Or A ) $=
      cA cR wpo vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy
      cA wral vx cA wral wa cA cR ccnv wpo vy cv vx cv cR ccnv wbr vy cv vx cv
      wceq vx cv vy cv cR ccnv wbr w3o vx cA wral vy cA wral wa cA cR wor cA cR
      ccnv wor cA cR wpo cA cR ccnv wpo vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o vy cA wral vx cA wral vy cv vx cv cR ccnv wbr vy cv
      vx cv wceq vx cv vy cv cR ccnv wbr w3o vx cA wral vy cA wral cA cR cnvpo
      vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vy cA wral vx
      cA wral vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv cR wbr w3o vx cA
      wral vy cA wral vy cv vx cv cR ccnv wbr vy cv vx cv wceq vx cv vy cv cR
      ccnv wbr w3o vx cA wral vy cA wral vx cv vy cv cR wbr vx cv vy cv wceq vy
      cv vx cv cR wbr w3o vx vy cA cA ralcom vy cv vx cv cR ccnv wbr vy cv vx
      cv wceq vx cv vy cv cR ccnv wbr w3o vx cv vy cv cR wbr vx cv vy cv wceq
      vy cv vx cv cR wbr w3o vy vx cA cA vy cv vx cv cR ccnv wbr vx cv vy cv cR
      wbr vy cv vx cv wceq vx cv vy cv wceq vx cv vy cv cR ccnv wbr vy cv vx cv
      cR wbr vy cv vx cv cR vy visset vx visset brcnv vy cv vx cv eqcom vx cv
      vy cv cR vx visset vy visset brcnv 3orbi123i 2ralbii bitr4i anbi12i vx vy
      cA cR df-so vy vx cA cR ccnv df-so 3bitr4i $.
      $( [19-Jun-2005] $) $( [15-Jun-2005] $)
  $}

  $( The composition of two sets is a set. $)
  coexg $p |- ( ( A e. C /\ B e. D ) -> ( A o. B ) e. _V ) $=
    cA cB ccom cB cdm cA crn cxp wss cB cdm cA crn cxp cvv wcel cA cB ccom cvv
    wcel cA cC wcel cB cD wcel wa cA cB ccom cB cdm cA crn cxp cvv ssexg cA cB
    ccom wrel cA cB ccom cB cdm cA crn cxp wss cA cB relco cA cB ccom wrel cA
    cB ccom cA cB ccom cdm cA cB ccom crn cxp wss cA cB ccom cB cdm cA crn cxp
    wss cA cB ccom relssdmrn cA cB ccom cA cB ccom cdm cA cB ccom crn cxp wss
    cA cB ccom cdm cA cB ccom crn cxp cB cdm cA crn cxp wss cA cB ccom cB cdm
    cA crn cxp wss cA cB ccom cdm cB cdm wss cA cB ccom crn cA crn wss cA cB
    ccom cdm cA cB ccom crn cxp cB cdm cA crn cxp wss cA cB dmcoss cA cB rncoss
    cA cB ccom cdm cB cdm cA cB ccom crn cA crn ssxp mp2an cA cB ccom cA cB
    ccom cdm cA cB ccom crn cxp cB cdm cA crn cxp sstr2 mpi syl ax-mp cB cD
    wcel cA cC wcel cB cdm cA crn cxp cvv wcel cB cdm cvv wcel cA crn cvv wcel
    cB cdm cA crn cxp cvv wcel cB cD wcel cA cC wcel cB cdm cA crn cvv cvv
    xpexg cB cD dmexg cA cC rnexg syl2an ancoms sylancr $.
    $( [19-Mar-1998] $)

  ${
    coex.1 $e |- A e. _V $.
    coex.2 $e |- B e. _V $.
    $( The composition of two sets is a set. $)
    coex $p |- ( A o. B ) e. _V $=
      cA cvv wcel cB cvv wcel cA cB ccom cvv wcel coex.1 coex.2 cA cB cvv cvv
      coexg mp2an $.
      $( [16-Dec-2003] $) $( [15-Dec-2003] $)
  $}

  ${
    $d x y z A $.
    $( Alternate definition of a function. $)
    dffun2 $p |- ( Fun A <-> ( Rel A /\
                 A. x A. y A. z ( ( x A y /\ x A z ) -> y = z ) ) ) $=
      cA wfun cA wrel cA cA ccnv ccom cid wss wa cA wrel vx cv vy cv cA wbr vx
      cv vz cv cA wbr wa vy cv vz cv wceq wi vz wal vy wal vx wal wa cA df-fun
      cA cA ccnv ccom cid wss vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz
      cv wceq wi vz wal vy wal vx wal cA wrel cA cA ccnv ccom cid wss vy cv vx
      cv cA ccnv wbr vx cv vz cv cA wbr wa vx wex vy cv vz cv wceq wi vz wal vy
      wal vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq wi vz wal
      vx wal vy wal vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq
      wi vz wal vy wal vx wal cA cA ccnv ccom cid wss cA cA ccnv ccom vy cv vz
      cv wceq vy vz copab wss vy cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx
      wex vy vz copab vy cv vz cv wceq vy vz copab wss vy cv vx cv cA ccnv wbr
      vx cv vz cv cA wbr wa vx wex vy cv vz cv wceq wi vz wal vy wal cid vy cv
      vz cv wceq vy vz copab cA cA ccnv ccom vy vz df-id sseq2i cA cA ccnv ccom
      vy cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx wex vy vz copab vy cv vz
      cv wceq vy vz copab vy vz vx cA cA ccnv df-co sseq1i vy cv vx cv cA ccnv
      wbr vx cv vz cv cA wbr wa vx wex vy cv vz cv wceq vy vz ssopab2 3bitri vy
      cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx wex vy cv vz cv wceq wi vz
      wal vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq wi vz wal
      vx wal vy vy cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx wex vy cv vz
      cv wceq wi vz wal vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv
      wceq wi vx wal vz wal vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz
      cv wceq wi vz wal vx wal vy cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx
      wex vy cv vz cv wceq wi vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz
      cv wceq wi vx wal vz vy cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx wex
      vy cv vz cv wceq wi vx cv vy cv cA wbr vx cv vz cv cA wbr wa vx wex vy cv
      vz cv wceq wi vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq
      wi vx wal vy cv vx cv cA ccnv wbr vx cv vz cv cA wbr wa vx wex vx cv vy
      cv cA wbr vx cv vz cv cA wbr wa vx wex vy cv vz cv wceq vy cv vx cv cA
      ccnv wbr vx cv vz cv cA wbr wa vx cv vy cv cA wbr vx cv vz cv cA wbr wa
      vx vy cv vx cv cA ccnv wbr vx cv vy cv cA wbr vx cv vz cv cA wbr vy cv vx
      cv cA vy visset vx visset brcnv anbi1i exbii imbi1i vx cv vy cv cA wbr vx
      cv vz cv cA wbr wa vy cv vz cv wceq vx 19.23v bitr4i albii vx cv vy cv cA
      wbr vx cv vz cv cA wbr wa vy cv vz cv wceq wi vz vx alcom bitri albii vx
      cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq wi vz wal vy vx
      alcom 3bitri anbi2i bitri $.
      $( [23-Apr-2004] $) $( [29-Dec-1996] $)

    $( Alternate definition of function. $)
    dffun3 $p |- ( Fun A <-> ( Rel A /\
                 A. x E. z A. y ( x A y -> y = z ) ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq
      wi vz wal vy wal vx wal wa cA wrel vx cv vy cv cA wbr vy cv vz cv wceq wi
      vy wal vz wex vx wal wa vx vy vz cA dffun2 vx cv vy cv cA wbr vx cv vz cv
      cA wbr wa vy cv vz cv wceq wi vz wal vy wal vx wal vx cv vy cv cA wbr vy
      cv vz cv wceq wi vy wal vz wex vx wal cA wrel vx cv vy cv cA wbr vx cv vz
      cv cA wbr wa vy cv vz cv wceq wi vz wal vy wal vx cv vy cv cA wbr vy cv
      vz cv wceq wi vy wal vz wex vx vx cv vy cv cA wbr vx cv vz cv cA wbr wa
      vy cv vz cv wceq wi vz wal vy wal vx cv vy cv cA wbr vy wmo vx cv vy cv
      cA wbr vy cv vz cv wceq wi vy wal vz wex vx cv vy cv cA wbr vx cv vz cv
      cA wbr vy vz vy cv vz cv vx cv cA breq2 mo4 vx cv vy cv cA wbr vy vz vx
      cv vy cv cA wbr vz ax-17 mo2 bitr3i albii anbi2i bitri $.
      $( [23-Apr-2004] $) $( [29-Dec-1996] $)

    $( Alternate definition of a function.  Definition 6.4(4) of
       [TakeutiZaring] p. 24. $)
    dffun4 $p |- ( Fun A <-> ( Rel A /\
                 A. x A. y A. z ( ( <. x , y >. e. A /\ <. x , z >. e. A )
                 -> y = z ) ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq
      wi vz wal vy wal vx wal wa cA wrel vx cv vy cv cop cA wcel vx cv vz cv
      cop cA wcel wa vy cv vz cv wceq wi vz wal vy wal vx wal wa vx vy vz cA
      dffun2 vx cv vy cv cA wbr vx cv vz cv cA wbr wa vy cv vz cv wceq wi vz
      wal vy wal vx wal vx cv vy cv cop cA wcel vx cv vz cv cop cA wcel wa vy
      cv vz cv wceq wi vz wal vy wal vx wal cA wrel vx cv vy cv cA wbr vx cv vz
      cv cA wbr wa vy cv vz cv wceq wi vz wal vx cv vy cv cop cA wcel vx cv vz
      cv cop cA wcel wa vy cv vz cv wceq wi vz wal vx vy vx cv vy cv cA wbr vx
      cv vz cv cA wbr wa vy cv vz cv wceq wi vx cv vy cv cop cA wcel vx cv vz
      cv cop cA wcel wa vy cv vz cv wceq wi vz vx cv vy cv cA wbr vx cv vz cv
      cA wbr wa vx cv vy cv cop cA wcel vx cv vz cv cop cA wcel wa vy cv vz cv
      wceq vx cv vy cv cA wbr vx cv vy cv cop cA wcel vx cv vz cv cA wbr vx cv
      vz cv cop cA wcel vx cv vy cv cA df-br vx cv vz cv cA df-br anbi12i
      imbi1i albii 2albii anbi2i bitri $.
      $( [29-Dec-1996] $)

    $( Alternate definition of function. $)
    dffun5 $p |- ( Fun A <-> ( Rel A /\
                 A. x E. z A. y ( <. x , y >. e. A -> y = z ) ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vy cv vz cv wceq wi vy wal vz wex vx
      wal wa cA wrel vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy wal vz wex
      vx wal wa vx vy vz cA dffun3 vx cv vy cv cA wbr vy cv vz cv wceq wi vy
      wal vz wex vx wal vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy wal vz
      wex vx wal cA wrel vx cv vy cv cA wbr vy cv vz cv wceq wi vy wal vz wex
      vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy wal vz wex vx vx cv vy cv
      cA wbr vy cv vz cv wceq wi vy wal vx cv vy cv cop cA wcel vy cv vz cv
      wceq wi vy wal vz vx cv vy cv cA wbr vy cv vz cv wceq wi vx cv vy cv cop
      cA wcel vy cv vz cv wceq wi vy vx cv vy cv cA wbr vx cv vy cv cop cA wcel
      vy cv vz cv wceq vx cv vy cv cA df-br imbi1i albii exbii albii anbi2i
      bitri $.
      $( [29-Dec-1996] $)
  $}

  ${
    $d x y z w v u $.  $d z A w v u $.
    dffunmof.1 $e |- ( z e. A -> A. x z e. A ) $.
    dffunmof.2 $e |- ( z e. A -> A. y z e. A ) $.
    $( Definition of function, using bound-variable hypotheses instead of
       distinct variable conditions. $)
    dffun6f $p |- ( Fun A <-> ( Rel A /\ A. x E* y x A y ) ) $=
      cA wfun cA wrel vw cv vv cv cA wbr vv cv vu cv wceq wi vv wal vu wex vw
      wal wa cA wrel vx cv vy cv cA wbr vy wmo vx wal wa vw vv vu cA dffun3 vx
      cv vy cv cA wbr vy wmo vx wal vw cv vv cv cA wbr vv cv vu cv wceq wi vv
      wal vu wex vw wal cA wrel vw cv vv cv cA wbr vv wmo vw wal vw cv vy cv cA
      wbr vy wmo vw wal vw cv vv cv cA wbr vv cv vu cv wceq wi vv wal vu wex vw
      wal vx cv vy cv cA wbr vy wmo vx wal vw cv vv cv cA wbr vv wmo vw cv vy
      cv cA wbr vy wmo vw vw cv vv cv cA wbr vw cv vy cv cA wbr vv vy vy vz vw
      cv vv cv cA vz cv vw cv wcel vy ax-17 dffunmof.2 vz cv vv cv wcel vy
      ax-17 hbbr vw cv vy cv cA wbr vv ax-17 vv cv vy cv vw cv cA breq2 cbvmo
      albii vw cv vv cv cA wbr vv wmo vw cv vv cv cA wbr vv cv vu cv wceq wi vv
      wal vu wex vw vw cv vv cv cA wbr vv vu vw cv vv cv cA wbr vu ax-17 mo2
      albii vw cv vy cv cA wbr vy wmo vx cv vy cv cA wbr vy wmo vw vx vw cv vy
      cv cA wbr vx vy vx vz vw cv vy cv cA vz cv vw cv wcel vx ax-17 dffunmof.1
      vz cv vy cv wcel vx ax-17 hbbr hbmo vx cv vy cv cA wbr vy wmo vw ax-17 vw
      cv vx cv wceq vw cv vy cv cA wbr vx cv vy cv cA wbr vy vw cv vx cv wceq
      vy ax-17 vw cv vx cv vy cv cA breq1 mobid cbval 3bitr3ri anbi2i bitr4i $.
      $( [15-Aug-2004] $) $( [9-Mar-1995] $)
  $}

  ${
    $d x y z A $.
    $( Alternate definition of a function using "at most one" notation. $)
    dffun6 $p |- ( Fun A <-> ( Rel A /\ A. x E* y x A y ) ) $=
      vx vy vz cA vz cv cA wcel vx ax-17 vz cv cA wcel vy ax-17 dffun6f $.
      $( [15-Aug-2004] $) $( [9-Mar-1995] $)

    $( A function has at most one value for each argument. $)
    funmo $p |- ( Fun A -> E* y x A y ) $=
      cA wfun vx cv vy cv cA wbr vy wmo vx cA wfun cA wrel vx cv vy cv cA wbr
      vy wmo vx wal vx vy cA dffun6 pm3.27bi 19.21bi $.
      $( [15-Aug-2004] $) $( [24-May-1998] $)
  $}

  $( A function is a relation. $)
  funrel $p |- ( Fun A -> Rel A ) $=
    cA wfun cA wrel cA cA ccnv ccom cid wss cA df-fun pm3.26bi $.
    $( [1-Aug-1994] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( Subclass theorem for function predicate. $)
    funss $p |- ( A C_ B -> ( Fun B -> Fun A ) ) $=
      cA cB wss cB wfun cA wrel vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy
      wal vz wex vx wal wa cA wfun cA cB wss cB wfun cA wrel vx cv vy cv cop cA
      wcel vy cv vz cv wceq wi vy wal vz wex vx wal cA cB wss cB wrel cA wrel
      cB wfun cA cB relss cB funrel syl5 cA cB wss vx cv vy cv cop cB wcel vy
      cv vz cv wceq wi vy wal vz wex vx wal vx cv vy cv cop cA wcel vy cv vz cv
      wceq wi vy wal vz wex vx wal cB wfun cA cB wss vx cv vy cv cop cB wcel vy
      cv vz cv wceq wi vy wal vz wex vx cv vy cv cop cA wcel vy cv vz cv wceq
      wi vy wal vz wex vx cA cB wss vx cv vy cv cop cB wcel vy cv vz cv wceq wi
      vy wal vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy wal vz cA cB wss vx
      cv vy cv cop cB wcel vy cv vz cv wceq wi vx cv vy cv cop cA wcel vy cv vz
      cv wceq wi vy cA cB wss vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel
      vy cv vz cv wceq cA cB vx cv vy cv cop ssel imim1d 19.20dv 19.22dv
      19.20dv cB wfun cB wrel vx cv vy cv cop cB wcel vy cv vz cv wceq wi vy
      wal vz wex vx wal vx vy vz cB dffun5 pm3.27bi syl5 jcad vx vy vz cA
      dffun5 syl6ibr $.
      $( [16-Aug-1994] $)
  $}

  $( Equality theorem for function predicate. $)
  funeq $p |- ( A = B -> ( Fun A <-> Fun B ) ) $=
    cA cB wss cB cA wss wa cA wfun cB wfun wi cB wfun cA wfun wi wa cA cB wceq
    cA wfun cB wfun wb cB cA wss cA cB wss cA wfun cB wfun wi cB wfun cA wfun
    wi wa cB cA wss cA wfun cB wfun wi cA cB wss cB wfun cA wfun wi cB cA funss
    cA cB funss anim12i ancoms cA cB eqss cA wfun cB wfun dfbi2 3imtr4i $.
    $( [16-Aug-1994] $)

  ${
    $d y F $.  $d x y $.
    hbfun.1 $e |- ( y e. F -> A. x y e. F ) $.
    $( Bound-variable hypothesis builder for a function. $)
    hbfun $p |- ( Fun F -> A. x Fun F ) $=
      cF wrel cF cF ccnv ccom cid wss wa cF wrel cF cF ccnv ccom cid wss wa vx
      wal cF wfun cF wfun vx wal cF wrel cF cF ccnv ccom cid wss vx vx vy cF
      hbfun.1 hbrel vx vy cF cF ccnv ccom cid vx vy cF cF ccnv hbfun.1 vx vy cF
      hbfun.1 hbcnv hbco vy cv cid wcel vx ax-17 hbss hban cF df-fun cF wfun cF
      wrel cF cF ccnv ccom cid wss wa vx cF df-fun albii 3imtr4i $.
      $( [31-Jan-2004] $) $( [30-Jan-2004] $)
  $}

  ${
    $d x y z F $.
    $( There is exactly one value of a function. $)
    funeu $p |- ( ( Fun F /\ x F y ) -> E! y x F y ) $=
      vx cv vy cv cF wbr cF wfun vx cv vy cv cF wbr vy weu vx cv vy cv cF wbr
      cF wfun wa vx cv vy cv cF wbr vy wex vx cv vy cv cF wbr vy cv vz cv wceq
      wi vy wal vz wex wa vx cv vy cv cF wbr vy weu vx cv vy cv cF wbr vx cv vy
      cv cF wbr vy wex cF wfun vx cv vy cv cF wbr vy cv vz cv wceq wi vy wal vz
      wex vx cv vy cv cF wbr vy 19.8a cF wfun vx cv vy cv cF wbr vy cv vz cv
      wceq wi vy wal vz wex vx cF wfun cF wrel vx cv vy cv cF wbr vy cv vz cv
      wceq wi vy wal vz wex vx wal vx vy vz cF dffun3 pm3.27bi 19.21bi anim12i
      vx cv vy cv cF wbr vy vz vx cv vy cv cF wbr vz ax-17 eu3 sylibr ancoms $.
      $( [24-Apr-2004] $) $( [22-Apr-2004] $)

    $( There is exactly one value of a function. $)
    funeu2 $p |- ( ( Fun F /\ <. x , y >. e. F ) -> E! y <. x , y >. e. F ) $=
      cF wfun vx cv vy cv cF wbr wa vx cv vy cv cF wbr vy weu cF wfun vx cv vy
      cv cop cF wcel wa vx cv vy cv cop cF wcel vy weu vx vy cF funeu vx cv vy
      cv cF wbr vx cv vy cv cop cF wcel cF wfun vx cv vy cv cF df-br anbi2i vx
      cv vy cv cF wbr vx cv vy cv cop cF wcel vy vx cv vy cv cF df-br eubii
      3imtr3i $.
      $( [3-Aug-1994] $)
  $}

  ${
    $d x y A $.
    $( Alternate definition of a function.  One possibility for the definition
       of a function in [Enderton] p. 42.  (Enderton's definition is ambiguous
       because "there is only one" could mean either "there is at most one" or
       "there is exactly one."  However, ~ dffun8 shows that it doesn't matter
       which meaning we pick.) $)
    dffun7 $p |- ( Fun A <-> ( Rel A /\ A. x e. dom A E* y x A y ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vy wmo vx wal wa cA wrel vx cv vy cv
      cA wbr vy wmo vx cA cdm wral wa vx vy cA dffun6 vx cv vy cv cA wbr vy wmo
      vx wal vx cv vy cv cA wbr vy wmo vx cA cdm wral cA wrel vx cv vy cv cA
      wbr vy wmo vx wal vx cv cA cdm wcel vx cv vy cv cA wbr vy wmo wi vx wal
      vx cv vy cv cA wbr vy wmo vx cA cdm wral vx cv vy cv cA wbr vy wmo vx cv
      cA cdm wcel vx cv vy cv cA wbr vy wmo wi vx vx cv vy cv cA wbr vy wmo vx
      cv vy cv cA wbr vy wex vx cv vy cv cA wbr vy wmo wi vx cv cA cdm wcel vx
      cv vy cv cA wbr vy wmo wi vx cv vy cv cA wbr vy moabs vx cv cA cdm wcel
      vx cv vy cv cA wbr vy wex vx cv vy cv cA wbr vy wmo vy vx cv cA vx visset
      eldm imbi1i bitr4i albii vx cv vy cv cA wbr vy wmo vx cA cdm df-ral
      bitr4i anbi2i bitri $.
      $( [4-Nov-2002] $)

    $( Alternate definition of a function.  One possibility for the
       definition of a function in [Enderton] p. 42.  Compare ~ dffun7 . $)
    dffun8 $p |- ( Fun A <-> ( Rel A /\ A. x e. dom A E! y x A y ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vy weu vx cA cdm wral wa cA wfun cA
      wrel vx cv vy cv cA wbr vy weu vx cA cdm wral cA funrel cA wfun vx cv vy
      cv cA wbr vy weu vx cA cdm cA wfun vx cv vy cv cop cA wcel vy wex vx cv
      vy cv cop cA wcel vy weu vx cv cA cdm wcel vx cv vy cv cA wbr vy weu cA
      wfun vx cv vy cv cop cA wcel vx cv vy cv cop cA wcel vy weu vy cA wfun vy
      ax-17 vx cv vy cv cop cA wcel vy hbeu1 cA wfun vx cv vy cv cop cA wcel vx
      cv vy cv cop cA wcel vy weu vx vy cA funeu2 ex 19.23ad vy vx cv cA vx
      visset eldm2 vx cv vy cv cA wbr vx cv vy cv cop cA wcel vy vx cv vy cv cA
      df-br eubii 3imtr4g r19.21aiv jca cA wrel vx cv vy cv cA wbr vy weu vx cA
      cdm wral wa cA wrel vx cv vy cv cA wbr vy wmo vx cA cdm wral wa cA wfun
      vx cv vy cv cA wbr vy weu vx cA cdm wral vx cv vy cv cA wbr vy wmo vx cA
      cdm wral cA wrel vx cv vy cv cA wbr vy weu vx cv vy cv cA wbr vy wmo vx
      cA cdm vx cv vy cv cA wbr vy eumo r19.20si anim2i vx vy cA dffun7 sylibr
      impbii $.
      $( [4-Nov-2002] $)

    $( Alternate definition of a function. $)
    dffun9 $p |- ( Fun A <->
                 ( Rel A /\ A. x e. dom A E* y ( y e. ran A /\ x A y ) ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vy wmo vx cA cdm wral wa cA wrel vy cv
      cA crn wcel vx cv vy cv cA wbr wa vy wmo vx cA cdm wral wa vx vy cA
      dffun7 vx cv vy cv cA wbr vy wmo vx cA cdm wral vy cv cA crn wcel vx cv
      vy cv cA wbr wa vy wmo vx cA cdm wral cA wrel vx cv vy cv cA wbr vy wmo
      vy cv cA crn wcel vx cv vy cv cA wbr wa vy wmo vx cA cdm vx cv vy cv cA
      wbr vy cv cA crn wcel vx cv vy cv cA wbr wa vy vx cv vy cv cA wbr vy cv
      cA crn wcel vx cv vy cv cA vx visset vy visset brelrn pm4.71ri mobii
      ralbii anbi2i bitri $.
      $( [28-Mar-2007] $) $( [28-Mar-2007] $)
  $}

  $( An equivalence for the function predicate. $)
  funfn $p |- ( Fun A <-> A Fn dom A ) $=
    cA wfun cA wfun cA cdm cA cdm wceq wa cA cA cdm wfn cA cdm cA cdm wceq cA
    wfun cA cdm eqid biantru cA cA cdm df-fn bitr4i $.
    $( [1-Nov-2004] $) $( [13-Aug-2004] $)

  ${
    $d x y z A $.  $d x y z B $.
    funsn.1 $e |- A e. _V $.
    funsn.2 $e |- B e. _V $.
    $( A singleton of an ordered pair is a function.  Theorem 10.5 of [Quine]
       p. 65. $)
    funsn $p |- Fun { <. A , B >. } $=
      cA cB cop csn wfun cA cB cop csn wrel vx cv vy cv cop cA cB cop csn wcel
      vx cv vz cv cop cA cB cop csn wcel wa vy cv vz cv wceq wi vz wal vy wal
      vx wal vx vy vz cA cB cop csn dffun4 cA cB funsn.1 relsn vx cv vy cv cop
      cA cB cop csn wcel vx cv vz cv cop cA cB cop csn wcel wa vy cv vz cv wceq
      wi vz wal vx vy vx cv vy cv cop cA cB cop csn wcel vx cv vz cv cop cA cB
      cop csn wcel wa vy cv vz cv wceq wi vz vy cv cB wceq vz cv cB wceq vy cv
      vz cv wceq vx cv vy cv cop cA cB cop csn wcel vx cv vz cv cop cA cB cop
      csn wcel vy cv vz cv cB eqtr3 vx cv vy cv cop cA cB cop csn wcel vx cv vy
      cv cop cA cB cop wceq vy cv cB wceq vx cv vy cv cop cA cB cop vx cv vy cv
      opex elsnc vx cv vy cv cA cB vy visset funsn.2 opth2 sylbi vx cv vz cv
      cop cA cB cop csn wcel vx cv vz cv cop cA cB cop wceq vz cv cB wceq vx cv
      vz cv cop cA cB cop vx cv vz cv opex elsnc vx cv vz cv cA cB vz visset
      funsn.2 opth2 sylbi syl2an ax-gen gen2 mpbir2an $.
      $( [12-Aug-1994] $)
  $}

  $( The empty set is a function.  Theorem 10.3 of [Quine] p. 65. $)
  fun0 $p |- Fun (/) $=
    c0 c0 c0 cop csn wss c0 c0 cop csn wfun c0 wfun c0 c0 cop csn 0ss c0 c0 0ex
    0ex funsn c0 c0 c0 cop csn funss mp2 $.
    $( [7-Apr-1998] $)

  $( The identity relation is a function.  Part of Theorem 10.4 of [Quine]
     p. 65. $)
  funi $p |- Fun _I $=
    cid wfun cid wrel cid cid ccnv ccom cid wss cid df-fun reli cid cid ccnv
    ccom cid cid cid ccnv ccom cid ccnv cid cid ccnv wrel cid cid ccnv ccom cid
    ccnv wceq cid relcnv cid ccnv coi2 ax-mp cnvi eqtri eqimssi mpbir2an $.
    $( [30-Apr-1998] $)

  $( The universe is not a function.  (Contributed by Raph Levien,
     27-Jan-2004.) $)
  nfunv $p |- -. Fun _V $=
    cvv wfun cvv wrel cvv wrel c0 cvv cvv cxp wcel cvv cvv 0nelxp cvv wrel c0
    cvv wcel c0 cvv cvv cxp wcel 0ex cvv wrel cvv cvv cvv cxp c0 cvv wrel cvv
    cvv cvv cxp wss cvv df-rel biimpi sseld mpi mto cvv funrel mto $.
    $( [27-Jan-2004] $) $( [27-Jan-2004] $)

  ${
    $d t u v w x y z A $.  $d t u v w x y z B $.
    $( A Kuratowski ordered pair is a function only if its components are
       equal. $)
    funopg $p |- ( ( B e. C /\ Fun <. A , B >. ) -> A = B ) $=
      cB cC wcel cA cB cop wfun cA cB wceq cA cvv wcel cB cC wcel cA cB cop
      wfun cA cB wceq wi vu cv vt cv cop wfun vu cv vt cv wceq wi cA vt cv cop
      wfun cA vt cv wceq wi cA cB cop wfun cA cB wceq wi vu vt cA cB cvv cC vu
      cv cA wceq vu cv vt cv cop wfun cA vt cv cop wfun vu cv vt cv wceq cA vt
      cv wceq vu cv cA wceq vu cv vt cv cop cA vt cv cop wceq vu cv vt cv cop
      wfun cA vt cv cop wfun wb vu cv cA vt cv opeq1 vu cv vt cv cop cA vt cv
      cop funeq syl vu cv cA vt cv eqeq1 imbi12d vt cv cB wceq cA vt cv cop
      wfun cA cB cop wfun cA vt cv wceq cA cB wceq vt cv cB wceq cA vt cv cop
      cA cB cop wceq cA vt cv cop wfun cA cB cop wfun wb vt cv cB cA opeq2 cA
      vt cv cop cA cB cop funeq syl vt cv cB cA eqeq2 imbi12d vu cv vt cv cop
      wfun vu cv vx cv csn wceq vt cv vx cv vy cv cpr wceq wa vy wex vx wex vu
      cv vt cv wceq vu cv vt cv cop wfun vu cv vt cv cop wrel vu cv vx cv csn
      wceq vt cv vx cv vy cv cpr wceq wa vy wex vx wex vu cv vt cv cop funrel
      vx vy vu cv vt cv vu visset vt visset relop sylib vu cv vt cv cop wfun vu
      cv vx cv csn wceq vt cv vx cv vy cv cpr wceq wa vu cv vt cv wceq vx vy vu
      cv vt cv cop wfun vu cv vx cv csn wceq vt cv vx cv vy cv cpr wceq wa vx
      cv vy cv wceq vu cv vt cv wceq vu cv vt cv cop wfun vu cv vt cv cop vx cv
      vx cv cop vx cv vy cv cop cpr wceq vx cv vy cv wceq vu cv vx cv csn wceq
      vt cv vx cv vy cv cpr wceq wa vu cv vt cv cop wfun vz cv vw cv cop vu cv
      vt cv cop wcel vz cv vv cv cop vu cv vt cv cop wcel wa vw cv vv cv wceq
      wi vv wal vw wal vz wal vu cv vt cv cop vx cv vx cv cop vx cv vy cv cop
      cpr wceq vx cv vy cv wceq wi vu cv vt cv cop wfun vu cv vt cv cop wrel vz
      cv vw cv cop vu cv vt cv cop wcel vz cv vv cv cop vu cv vt cv cop wcel wa
      vw cv vv cv wceq wi vv wal vw wal vz wal vz vw vv vu cv vt cv cop dffun4
      pm3.27bi vz cv vw cv cop vu cv vt cv cop wcel vz cv vv cv cop vu cv vt cv
      cop wcel wa vw cv vv cv wceq wi vv wal vw wal vz wal vx cv vx cv cop vu
      cv vt cv cop wcel vx cv vy cv cop vu cv vt cv cop wcel wa vx cv vy cv
      wceq vu cv vt cv cop vx cv vx cv cop vx cv vy cv cop cpr wceq vx cv cvv
      wcel vx cv cvv wcel vy cv cvv wcel vz cv vw cv cop vu cv vt cv cop wcel
      vz cv vv cv cop vu cv vt cv cop wcel wa vw cv vv cv wceq wi vv wal vw wal
      vz wal vx cv vx cv cop vu cv vt cv cop wcel vx cv vy cv cop vu cv vt cv
      cop wcel wa vx cv vy cv wceq wi wi vx visset vx visset vy visset vz cv vw
      cv cop vu cv vt cv cop wcel vz cv vv cv cop vu cv vt cv cop wcel wa vw cv
      vv cv wceq wi vx cv vx cv cop vu cv vt cv cop wcel vx cv vy cv cop vu cv
      vt cv cop wcel wa vx cv vy cv wceq wi vz vw vv vx cv vx cv vy cv cvv cvv
      cvv vz cv vx cv wceq vw cv vx cv wceq vv cv vy cv wceq w3a vz cv vw cv
      cop vu cv vt cv cop wcel vz cv vv cv cop vu cv vt cv cop wcel wa vx cv vx
      cv cop vu cv vt cv cop wcel vx cv vy cv cop vu cv vt cv cop wcel wa vw cv
      vv cv wceq vx cv vy cv wceq vz cv vx cv wceq vw cv vx cv wceq vv cv vy cv
      wceq w3a vz cv vw cv cop vu cv vt cv cop wcel vx cv vx cv cop vu cv vt cv
      cop wcel vz cv vv cv cop vu cv vt cv cop wcel vx cv vy cv cop vu cv vt cv
      cop wcel vz cv vx cv wceq vw cv vx cv wceq vv cv vy cv wceq w3a vz cv vw
      cv cop vx cv vx cv cop vu cv vt cv cop vz cv vx cv wceq vw cv vx cv wceq
      vz cv vw cv cop vx cv vx cv cop wceq vv cv vy cv wceq vz cv vw cv vx cv
      vx cv opeq12 3adant3 eleq1d vz cv vx cv wceq vw cv vx cv wceq vv cv vy cv
      wceq w3a vz cv vv cv cop vx cv vy cv cop vu cv vt cv cop vz cv vx cv wceq
      vv cv vy cv wceq vz cv vv cv cop vx cv vy cv cop wceq vw cv vx cv wceq vz
      cv vv cv vx cv vy cv opeq12 3adant2 eleq1d anbi12d vw cv vx cv wceq vv cv
      vy cv wceq vw cv vv cv wceq vx cv vy cv wceq wb vz cv vx cv wceq vw cv vx
      cv vv cv vy cv eqeq12 3adant1 imbi12d cla43gv mp3an vu cv vt cv cop vx cv
      vx cv cop vx cv vy cv cop cpr wceq vx cv vx cv cop vu cv vt cv cop wcel
      vx cv vy cv cop vu cv vt cv cop wcel vu cv vt cv cop vx cv vx cv cop vx
      cv vy cv cop cpr wceq vx cv vx cv cop vu cv vt cv cop wcel vx cv vx cv
      cop vx cv vx cv cop vx cv vy cv cop cpr wcel vx cv vx cv cop vx cv vy cv
      cop vx cv vx cv opex prid1 vu cv vt cv cop vx cv vx cv cop vx cv vy cv
      cop cpr vx cv vx cv cop eleq2 mpbiri vu cv vt cv cop vx cv vx cv cop vx
      cv vy cv cop cpr wceq vx cv vy cv cop vu cv vt cv cop wcel vx cv vy cv
      cop vx cv vx cv cop vx cv vy cv cop cpr wcel vx cv vx cv cop vx cv vy cv
      cop vx cv vy cv opex prid2 vu cv vt cv cop vx cv vx cv cop vx cv vy cv
      cop cpr vx cv vy cv cop eleq2 mpbiri jca syl5 syl vu cv vx cv csn wceq vt
      cv vx cv vy cv cpr wceq wa vu cv vt cv cop vx cv csn vx cv vy cv cpr cop
      wceq vu cv vt cv cop vx cv vx cv cop vx cv vy cv cop cpr wceq vu cv vt cv
      vx cv csn vx cv vy cv cpr vu visset vt visset vx vy zfpair2 opth vx cv
      csn vx cv vy cv cpr cop vx cv vx cv cop vx cv vy cv cop cpr vu cv vt cv
      cop vx cv vx cv cop vx cv csn vx cv vy cv cpr cpr cpr vx cv csn csn vx cv
      csn vx cv vy cv cpr cpr cpr vx cv vx cv cop vx cv vy cv cop cpr vx cv csn
      vx cv vy cv cpr cop vx cv vx cv cop vx cv csn csn wceq vx cv vx cv cop vx
      cv csn vx cv vy cv cpr cpr cpr vx cv csn csn vx cv csn vx cv vy cv cpr
      cpr cpr wceq vx cv csn vx cv csn cpr vx cv csn vx cv vx cv cpr cpr vx cv
      csn csn vx cv vx cv cop vx cv csn vx cv vx cv cpr wceq vx cv csn vx cv
      csn cpr vx cv csn vx cv vx cv cpr cpr wceq vx cv dfsn2 vx cv csn vx cv vx
      cv cpr vx cv csn preq2 ax-mp vx cv csn dfsn2 vx cv vx cv df-op 3eqtr4ri
      vx cv vx cv cop vx cv csn csn vx cv csn vx cv vy cv cpr cpr preq1 ax-mp
      vx cv vy cv cop vx cv csn vx cv vy cv cpr cpr wceq vx cv vx cv cop vx cv
      vy cv cop cpr vx cv vx cv cop vx cv csn vx cv vy cv cpr cpr cpr wceq vx
      cv vy cv df-op vx cv vy cv cop vx cv csn vx cv vy cv cpr cpr vx cv vx cv
      cop preq2 ax-mp vx cv csn vx cv vy cv cpr df-op 3eqtr4ri eqeq2i bitr3i
      syl5ib vu cv vx cv csn wceq vt cv vx cv vy cv cpr wceq vx cv vy cv wceq
      vu cv vt cv wceq wi vx cv vy cv wceq vt cv vx cv vy cv cpr wceq vu cv vx
      cv csn wceq vu cv vt cv wceq vx cv vy cv wceq vt cv vx cv vy cv cpr wceq
      vt cv vx cv csn wceq vu cv vx cv csn wceq vu cv vt cv wceq wi vx cv vy cv
      wceq vx cv vy cv cpr vx cv csn vt cv vx cv vy cv wceq vx cv vx cv cpr vx
      cv vy cv cpr vx cv csn vx cv vy cv vx cv preq2 vx cv dfsn2 syl5req eqeq2d
      vu cv vx cv csn wceq vt cv vx cv csn wceq vu cv vt cv wceq vu cv vt cv vx
      cv csn eqtr3 expcom syl6bi com13 imp sylcom 19.23advv mpd vtocl2g cA cvv
      wcel wn cA cB cop wfun cA cB wceq wi cB cC wcel cA cvv wcel wn cA cB cop
      wfun cA cB wceq cA cvv wcel wn c0 cA cB cop wcel cA cB cop wfun wn cA cB
      opprc1b cA cB cop wfun c0 cA cB cop wcel cA cB cop wfun cA cB cop wrel c0
      cA cB cop wcel wn cA cB cop funrel cA cB cop wrel cA cB cop cvv cvv cxp
      wss c0 cA cB cop wcel wn cA cB cop df-rel cA cB cop cvv cvv cxp wss c0 cA
      cB cop wcel c0 cvv cvv cxp wcel cvv cvv 0nelxp cA cB cop cvv cvv cxp c0
      ssel mtoi sylbi syl con2i sylbi pm2.21d adantr pm2.61ian imp $.
      $( [8-Jun-2008] $) $( [5-Jun-2008] $)
  $}


  ${
    $d x y z $.  $d z ph $.
    $( A class of ordered pairs is a function when there is at most one
       second member for each pair. $)
    funopab $p |- ( Fun { <. x , y >. | ph } <-> A. x E* y ph ) $=
      wph vx vy copab wfun vx cv vy cv wph vx vy copab wbr vy wmo vx wal wph vy
      wmo vx wal wph vx vy copab wfun wph vx vy copab wrel vx cv vy cv wph vx
      vy copab wbr vy wmo vx wal vx vy vz wph vx vy copab wph vx vy vz hbopab1
      wph vx vy vz hbopab2 dffun6f wph vx vy relopab mpbiran vx cv vy cv wph vx
      vy copab wbr vy wmo wph vy wmo vx vx cv vy cv wph vx vy copab wbr wph vy
      vx cv vy cv wph vx vy copab wbr vx cv vy cv cop wph vx vy copab wcel wph
      vx cv vy cv wph vx vy copab df-br wph vx vy opabid bitri mobii albii
      bitri $.
      $( [16-May-1995] $)
  $}

  ${
    $d x y $.  $d y A $.
    $( A class of ordered pairs of values is a function. $)
    funopabeq $p |- Fun { <. x , y >. | y = A } $=
      vy cv cA wceq vx vy copab wfun vy cv cA wceq vy wmo vx vy cv cA wceq vx
      vy funopab vy cA moeq mpgbir $.
      $( [14-Nov-1995] $)
  $}

  ${
    $d x y z F $.  $d x y z G $.
    $( The composition of two functions is a function.  Exercise 29 of
       [TakeutiZaring] p. 25. $)
    funco $p |- ( ( Fun F /\ Fun G ) -> Fun ( F o. G ) ) $=
      cF wfun cG wfun wa cF cG ccom wrel vx cv vy cv cF cG ccom wbr vy wmo vx
      wal wa cF cG ccom wfun cF wfun cG wfun wa vx cv vy cv cF cG ccom wbr vy
      wmo vx wal cF cG ccom wrel cF wfun cG wfun wa vx cv vy cv cF cG ccom wbr
      vy wmo vx cF wfun cG wfun wa vx cv vz cv cG wbr vz cv vy cv cF wbr wa vz
      wex vy wmo vx cv vy cv cF cG ccom wbr vy wmo cG wfun cF wfun vx cv vz cv
      cG wbr vz cv vy cv cF wbr wa vz wex vy wmo vx cv vz cv cG wbr vz wmo vz
      cv vy cv cF wbr vy wmo vz wal vx cv vz cv cG wbr vz cv vy cv cF wbr wa vz
      wex vy wmo cG wfun cF wfun vx cv vz cv cG wbr vz cv vy cv cF wbr vz vy
      moexexv vx vz cG funmo cF wfun cF wrel vz cv vy cv cF wbr vy wmo vz wal
      vz vy cF dffun6 pm3.27bi syl2an ancoms vx cv vy cv cF cG ccom wbr vx cv
      vz cv cG wbr vz cv vy cv cF wbr wa vz wex vy vz vx cv vy cv cF cG vx
      visset vy visset brco mobii sylibr 19.21aiv cF cG relco jctil vx vy cF cG
      ccom dffun6 sylibr $.
      $( [26-Jan-1997] $)
  $}

  ${
    $d x y z F $.  $d x y z A $.
    $( A restriction of a function is a function.  Compare Exercise 18 of
       [TakeutiZaring] p. 25. $)
    funres $p |- ( Fun F -> Fun ( F |` A ) ) $=
      cF cA cres cF wss cF wfun cF cA cres wfun wi cF cA resss cF cA cres cF
      funss ax-mp $.
      $( [16-Aug-1994] $)
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y A $.
    $( The restriction of a function to the domain of a subclass equals the
       subclass. $)
    funssres $p |- ( ( Fun F /\ G C_ F ) -> ( F |` dom G ) = G ) $=
      cF wfun cG cF wss wa cF cG cdm cres cG wceq vx cv vy cv cop cF cG cdm
      cres wcel vx cv vy cv cop cG wcel wb vy wal vx wal cF wfun cG cF wss wa
      vx cv vy cv cop cF cG cdm cres wcel vx cv vy cv cop cG wcel wb vx vy cF
      wfun cG cF wss wa vx cv vy cv cop cG wcel vx cv vy cv cop cF wcel vx cv
      cG cdm wcel wa vx cv vy cv cop cF cG cdm cres wcel cF wfun cG cF wss wa
      vx cv vy cv cop cG wcel vx cv vy cv cop cF wcel vx cv cG cdm wcel wa cG
      cF wss vx cv vy cv cop cG wcel vx cv vy cv cop cF wcel vx cv cG cdm wcel
      wa wi cF wfun cG cF wss vx cv vy cv cop cG wcel vx cv vy cv cop cF wcel
      vx cv cG cdm wcel cG cF vx cv vy cv cop ssel vx cv vy cv cop cG wcel vx
      cv cG cdm wcel wi cG cF wss vx cv vy cv cG vx visset opeldm a1i jcad
      adantl cF wfun cG cF wss wa vx cv vy cv cop cF wcel vx cv cG cdm wcel vx
      cv vy cv cop cG wcel cF wfun cG cF wss wa vx cv vy cv cop cF wcel vx cv
      cG cdm wcel vx cv vy cv cop cG wcel wi cF wfun cG cF wss wa vx cv vy cv
      cop cF wcel vx cv cG cdm wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG
      wcel cF wfun cG cF wss vx cv vy cv cop cF wcel vx cv cG cdm wcel vx cv vy
      cv cop cF wcel vx cv vy cv cop cG wcel wi wi wi cF wfun vx cv vy cv cop
      cF wcel cG cF wss vx cv cG cdm wcel vx cv vy cv cop cF wcel vx cv vy cv
      cop cG wcel wi wi cF wfun vx cv vy cv cop cF wcel cG cF wss vx cv cG cdm
      wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wi vx cv vy cv cop
      cF wcel vy weu vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wa vy wex
      vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wi cF wfun vx cv vy cv
      cop cF wcel wa cG cF wss vx cv cG cdm wcel wa vx cv vy cv cop cF wcel vx
      cv vy cv cop cG wcel vy eupick vx vy cF funeu2 cG cF wss vx cv cG cdm
      wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wa vy wex cG cF wss
      vx cv vy cv cop cG wcel vy wex vx cv vy cv cop cF wcel vx cv vy cv cop cG
      wcel wa vy wex vx cv cG cdm wcel cG cF wss vx cv vy cv cop cG wcel vx cv
      vy cv cop cF wcel vx cv vy cv cop cG wcel wa vy cG cF wss vx cv vy cv cop
      cG wcel vx cv vy cv cop cF wcel cG cF vx cv vy cv cop ssel ancrd 19.22dv
      vy vx cv cG vx visset eldm2 syl5ib imp syl2an exp43 com23 imp com34
      pm2.43d imp3a impbid vx cv vy cv cF cG cdm vy visset opelres syl6rbbr
      19.21aivv cF cG cdm cres wrel cG wrel cF cG cdm cres cG wceq vx cv vy cv
      cop cF cG cdm cres wcel vx cv vy cv cop cG wcel wb vy wal vx wal wb cF
      wfun cG cF wss wa vx vy cF cG cdm cres cG eqrel cF cG cdm relres cF wfun
      cG cF wss cG wrel cG cF wss cF wrel cG wrel cF wfun cG cF relss cF funrel
      syl5com imp sylancr mpbird $.
      $( [19-Mar-2004] $) $( [15-Aug-1994] $)
  $}

  $( Equality of restrictions of a function and a subclass. $)
  fun2ssres $p |- ( ( Fun F /\ G C_ F /\ A C_ dom G ) ->
                  ( F |` A ) = ( G |` A ) ) $=
    cF wfun cG cF wss cA cG cdm wss cF cA cres cG cA cres wceq cA cG cdm wss cF
    wfun cG cF wss wa cF cA cres cF cG cdm cres cA cres cG cA cres cA cG cdm
    wss cF cG cdm cres cA cres cF cA cres cF cA cG cdm resabs1 eqcomd cF wfun
    cG cF wss wa cF cG cdm cres cG wceq cF cG cdm cres cA cres cG cA cres wceq
    cF cG funssres cF cG cdm cres cG cA reseq1 syl sylan9eqr 3impa $.
    $( [2-Jun-2007] $) $( [16-Aug-1994] $)

  ${
    $d x y z F $.  $d x y z G $.
    $( The union of functions with disjoint domains is a function.  Theorem
       4.6 of [Monk1] p. 43. $)
    funun $p |- ( ( ( Fun F /\ Fun G ) /\ ( dom F i^i dom G ) = (/) ) ->
                Fun ( F u. G ) ) $=
      cF cG cun wfun cF cG cun wrel vx cv vy cv cop cF cG cun wcel vx cv vz cv
      cop cF cG cun wcel wa vy cv vz cv wceq wi vz wal vy wal vx wal cF wfun cG
      wfun wa cF cdm cG cdm cin c0 wceq wa vx vy vz cF cG cun dffun4 cF wfun cG
      wfun wa cF cG cun wrel cF cdm cG cdm cin c0 wceq cF wfun cG wfun wa cF
      wrel cG wrel wa cF cG cun wrel cF wfun cF wrel cG wfun cG wrel cF funrel
      cG funrel anim12i cF cG relun sylibr adantr cF wfun cG wfun wa cF cdm cG
      cdm cin c0 wceq wa vx cv vy cv cop cF cG cun wcel vx cv vz cv cop cF cG
      cun wcel wa vy cv vz cv wceq wi vz wal vx vy cF wfun cG wfun wa cF cdm cG
      cdm cin c0 wceq wa vx cv vy cv cop cF cG cun wcel vx cv vz cv cop cF cG
      cun wcel wa vy cv vz cv wceq wi vz cF wfun cG wfun wa cF cdm cG cdm cin
      c0 wceq wa vx cv vy cv cop cF cG cun wcel vx cv vz cv cop cF cG cun wcel
      wa vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cG
      wcel vx cv vz cv cop cG wcel wa wo vy cv vz cv wceq cF wfun cG wfun wa cF
      cdm cG cdm cin c0 wceq wa vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel
      wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa wo vx cv vy cv cop
      cG wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cG wcel vx cv vz cv
      cop cG wcel wa wo wo vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa
      vx cv vy cv cop cG wcel vx cv vz cv cop cG wcel wa wo vx cv vy cv cop cF
      cG cun wcel vx cv vz cv cop cF cG cun wcel wa cF cdm cG cdm cin c0 wceq
      vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cF
      wcel vx cv vz cv cop cG wcel wa wo vx cv vy cv cop cG wcel vx cv vz cv
      cop cF wcel wa vx cv vy cv cop cG wcel vx cv vz cv cop cG wcel wa wo wo
      vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cG
      wcel vx cv vz cv cop cG wcel wa wo wi cF wfun cG wfun wa cF cdm cG cdm
      cin c0 wceq vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa vx cv vy
      cv cop cF wcel vx cv vz cv cop cG wcel wa wo vx cv vy cv cop cF wcel vx
      cv vz cv cop cF wcel wa vx cv vy cv cop cG wcel vx cv vz cv cop cF wcel
      wa vx cv vy cv cop cG wcel vx cv vz cv cop cG wcel wa wo vx cv vy cv cop
      cG wcel vx cv vz cv cop cG wcel wa cF cdm cG cdm cin c0 wceq vx cv vy cv
      cop cF wcel vx cv vz cv cop cG wcel wa wn vx cv vy cv cop cF wcel vx cv
      vz cv cop cF wcel wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa
      wo vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa wi cF cdm cG cdm
      cin c0 wceq vx cv cF cdm wcel vx cv cG cdm wcel wa vx cv vy cv cop cF
      wcel vx cv vz cv cop cG wcel wa cF cdm cG cdm cin c0 wceq vx cv cF cdm
      wcel vx cv cG cdm wcel wn wi vx cv cF cdm wcel vx cv cG cdm wcel wa wn cF
      cdm cG cdm cin c0 wceq vx cv cF cdm wcel vx cv cG cdm wcel wn wi vx cF
      cdm cG cdm cin c0 wceq vx cv cF cdm wcel vx cv cG cdm wcel wn wi vx wal
      vx cF cdm cG cdm disj1 biimpi 19.21bi vx cv cF cdm wcel vx cv cG cdm wcel
      imnan sylib vx cv vy cv cop cF wcel vx cv cF cdm wcel vx cv vz cv cop cG
      wcel vx cv cG cdm wcel vx cv vy cv cF vx visset opeldm vx cv vz cv cG vx
      visset opeldm anim12i nsyl vx cv vy cv cop cF wcel vx cv vz cv cop cG
      wcel wa vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa orel2 syl cF
      cdm cG cdm cin c0 wceq vx cv vy cv cop cG wcel vx cv vz cv cop cF wcel wa
      wn vx cv vy cv cop cG wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cG
      wcel vx cv vz cv cop cG wcel wa wo vx cv vy cv cop cG wcel vx cv vz cv
      cop cG wcel wa wi cF cdm cG cdm cin c0 wceq vx cv cG cdm wcel vx cv cF
      cdm wcel wa vx cv vy cv cop cG wcel vx cv vz cv cop cF wcel wa cF cdm cG
      cdm cin c0 wceq vx cv cG cdm wcel vx cv cF cdm wcel wn wi vx cv cG cdm
      wcel vx cv cF cdm wcel wa wn cF cdm cG cdm cin c0 wceq vx cv cF cdm wcel
      vx cv cG cdm wcel cF cdm cG cdm cin c0 wceq vx cv cF cdm wcel vx cv cG
      cdm wcel wn wi vx cF cdm cG cdm cin c0 wceq vx cv cF cdm wcel vx cv cG
      cdm wcel wn wi vx wal vx cF cdm cG cdm disj1 biimpi 19.21bi con2d vx cv
      cG cdm wcel vx cv cF cdm wcel imnan sylib vx cv vy cv cop cG wcel vx cv
      cG cdm wcel vx cv vz cv cop cF wcel vx cv cF cdm wcel vx cv vy cv cG vx
      visset opeldm vx cv vz cv cF vx visset opeldm anim12i nsyl vx cv vy cv
      cop cG wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cG wcel vx cv vz
      cv cop cG wcel wa orel1 syl orim12d adantl vx cv vy cv cop cF cG cun wcel
      vx cv vz cv cop cF cG cun wcel wa vx cv vy cv cop cF wcel vx cv vy cv cop
      cG wcel wo vx cv vz cv cop cF wcel vx cv vz cv cop cG wcel wo wa vx cv vy
      cv cop cF wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cF wcel vx cv
      vz cv cop cG wcel wa wo vx cv vy cv cop cG wcel vx cv vz cv cop cF wcel
      wa vx cv vy cv cop cG wcel vx cv vz cv cop cG wcel wa wo wo vx cv vy cv
      cop cF cG cun wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wo vx
      cv vz cv cop cF cG cun wcel vx cv vz cv cop cF wcel vx cv vz cv cop cG
      wcel wo vx cv vy cv cop cF cG elun vx cv vz cv cop cF cG elun anbi12i vx
      cv vy cv cop cF wcel vx cv vy cv cop cG wcel vx cv vz cv cop cF wcel vx
      cv vz cv cop cG wcel anddi bitri syl5ib cF wfun cG wfun wa vx cv vy cv
      cop cF wcel vx cv vz cv cop cF wcel wa vx cv vy cv cop cG wcel vx cv vz
      cv cop cG wcel wa wo vy cv vz cv wceq wi cF cdm cG cdm cin c0 wceq cF
      wfun vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa vy cv vz cv wceq
      cG wfun vx cv vy cv cop cG wcel vx cv vz cv cop cG wcel wa cF wfun vx cv
      vy cv cop cF wcel vx cv vz cv cop cF wcel wa vy cv vz cv wceq wi vy vz cF
      wfun vx cv vy cv cop cF wcel vx cv vz cv cop cF wcel wa vy cv vz cv wceq
      wi vz wal vy wal vx cF wfun cF wrel vx cv vy cv cop cF wcel vx cv vz cv
      cop cF wcel wa vy cv vz cv wceq wi vz wal vy wal vx wal vx vy vz cF
      dffun4 pm3.27bi 19.21bi 19.21bbi cG wfun vx cv vy cv cop cG wcel vx cv vz
      cv cop cG wcel wa vy cv vz cv wceq wi vy vz cG wfun vx cv vy cv cop cG
      wcel vx cv vz cv cop cG wcel wa vy cv vz cv wceq wi vz wal vy wal vx cG
      wfun cG wrel vx cv vy cv cop cG wcel vx cv vz cv cop cG wcel wa vy cv vz
      cv wceq wi vz wal vy wal vx wal vx vy vz cG dffun4 pm3.27bi 19.21bi
      19.21bbi jaao adantr syld 19.21aiv 19.21aivv sylanbrc $.
      $( [12-Aug-1994] $)
  $}

  $( The double converse of a function is a function. $)
  funcnvcnv $p |- ( Fun A -> Fun `' `' A ) $=
    cA ccnv ccnv cA wss cA wfun cA ccnv ccnv wfun wi cA cnvcnvss cA ccnv ccnv
    cA funss ax-mp $.
    $( [22-Sep-2004] $) $( [21-Sep-2004] $)

  ${
    $d f g x y z w v A $.  $d x y B $.  $d x y R $.
    $( A simpler equivalence for single-rooted (see ~ funcnv ). $)
    funcnv2 $p |- ( Fun `' A <-> A. y E* x x A y ) $=
      cA ccnv wfun cA ccnv wrel vy cv vx cv cA ccnv wbr vx wmo vy wal wa vy cv
      vx cv cA ccnv wbr vx wmo vy wal vx cv vy cv cA wbr vx wmo vy wal vy vx cA
      ccnv dffun6 cA ccnv wrel vy cv vx cv cA ccnv wbr vx wmo vy wal cA relcnv
      biantrur vy cv vx cv cA ccnv wbr vx wmo vx cv vy cv cA wbr vx wmo vy vy
      cv vx cv cA ccnv wbr vx cv vy cv cA wbr vx vy cv vx cv cA vy visset vx
      visset brcnv mobii albii 3bitr2i $.
      $( [3-Oct-2004] $) $( [9-Aug-2004] $)

    $( The converse of a class is a function iff the class is single-rooted,
       which means that for any ` y ` in the range of ` A ` there is at most
       one ` x ` such that ` x A y ` .  Definition of single-rooted in
       [Enderton] p. 43.  See ~ funcnv2 for a simpler version. $)
    funcnv $p |- ( Fun `' A <-> A. y e. ran A E* x x A y ) $=
      vx cv vy cv cA wbr vx wmo vy wal vy cv cA crn wcel vx cv vy cv cA wbr vx
      wmo wi vy wal cA ccnv wfun vx cv vy cv cA wbr vx wmo vy cA crn wral vx cv
      vy cv cA wbr vx wmo vy cv cA crn wcel vx cv vy cv cA wbr vx wmo wi vy vx
      cv vy cv cA wbr vx wmo vy cv cA crn wcel vx cv vy cv cA wbr wa vx wmo vy
      cv cA crn wcel vx cv vy cv cA wbr vx wmo wi vx cv vy cv cA wbr vy cv cA
      crn wcel vx cv vy cv cA wbr wa vx vx cv vy cv cA wbr vy cv cA crn wcel vx
      cv vy cv cA vx visset vy visset brelrn pm4.71ri mobii vy cv cA crn wcel
      vx cv vy cv cA wbr vx moanimv bitri albii vx vy cA funcnv2 vx cv vy cv cA
      wbr vx wmo vy cA crn df-ral 3bitr4i $.
      $( [3-Oct-2004] $) $( [13-Aug-2004] $)

    $( A condition showing a class is single-rooted.  (See ~ funcnv ). $)
    funcnv3 $p |- ( Fun `' A <-> A. y e. ran A E! x e. dom A x A y ) $=
      vx cv vy cv cA wbr vx wmo vy cA crn wral vx cv vy cv cA wbr vx wex vx cv
      vy cv cA wbr vx wmo wa vy cA crn wral cA ccnv wfun vx cv vy cv cA wbr vx
      cA cdm wreu vy cA crn wral vx cv vy cv cA wbr vx wmo vx cv vy cv cA wbr
      vx wex vx cv vy cv cA wbr vx wmo wa vy cA crn vy cv cA crn wcel vx cv vy
      cv cA wbr vx wex vx cv vy cv cA wbr vx wmo vy cv cA crn wcel vx cv vy cv
      cA wbr vx wex vx cv vy cv cA wbr vx wex vy cA crn vx vy cA dfrn2 abeq2i
      biimpi biantrurd ralbiia vx vy cA funcnv vx cv vy cv cA wbr vx cA cdm
      wreu vx cv vy cv cA wbr vx wex vx cv vy cv cA wbr vx wmo wa vy cA crn vx
      cv vy cv cA wbr vx cA cdm wreu vx cv cA cdm wcel vx cv vy cv cA wbr wa vx
      weu vx cv vy cv cA wbr vx weu vx cv vy cv cA wbr vx wex vx cv vy cv cA
      wbr vx wmo wa vx cv vy cv cA wbr vx cA cdm df-reu vx cv vy cv cA wbr vx
      cv cA cdm wcel vx cv vy cv cA wbr wa vx vx cv vy cv cA wbr vx cv cA cdm
      wcel vx cv vy cv cA vx visset breldm pm4.71ri eubii vx cv vy cv cA wbr vx
      eu5 3bitr2i ralbii 3bitr4i $.
      $( [30-May-2006] $) $( [26-May-2006] $)

    $( The double converse of a class is a function iff the class is
       single-valued.  Each side is equivalent to Definition 6.4(2) of
       [TakeutiZaring] p. 23, who use the notation "Un(A)" for single-valued.
       Note that ` A ` is not necessarily a function. $)
    fun2cnv $p |- ( Fun `' `' A <-> A. x E* y x A y ) $=
      cA ccnv ccnv wfun vy cv vx cv cA ccnv wbr vy wmo vx wal vx cv vy cv cA
      wbr vy wmo vx wal vy vx cA ccnv funcnv2 vy cv vx cv cA ccnv wbr vy wmo vx
      cv vy cv cA wbr vy wmo vx vy cv vx cv cA ccnv wbr vx cv vy cv cA wbr vy
      vy cv vx cv cA vy visset vx visset brcnv mobii albii bitri $.
      $( [2-Nov-2004] $) $( [13-Aug-2004] $)

    $( A single-valued relation is a function.  (See ~ fun2cnv for
       "single-valued.")  Definition 6.4(4) of [TakeutiZaring] p. 24. $)
    svrelfun $p |- ( Fun A <-> ( Rel A /\ Fun `' `' A ) ) $=
      cA wfun cA wrel vx cv vy cv cA wbr vy wmo vx wal wa cA wrel cA ccnv ccnv
      wfun wa vx vy cA dffun6 cA ccnv ccnv wfun vx cv vy cv cA wbr vy wmo vx
      wal cA wrel vx vy cA fun2cnv anbi2i bitr4i $.
      $( [17-Jan-2006] $) $( [17-Jan-2006] $)

    $( Single-rootedness (see ~ funcnv ) of a class cut down by a cross
       product. $)
    fncnv $p |- ( `' ( R i^i ( A X. B ) ) Fn B <->
                  A. y e. B E! x e. A x R y ) $=
      cR cA cB cxp cin ccnv cB wfn cR cA cB cxp cin ccnv wfun cR cA cB cxp cin
      ccnv cdm cB wceq wa cR cA cB cxp cin ccnv wfun cR cA cB cxp cin crn cB
      wceq wa vx cv vy cv cR wbr vx cA wreu vy cB wral cR cA cB cxp cin ccnv cB
      df-fn cR cA cB cxp cin crn cB wceq cR cA cB cxp cin ccnv cdm cB wceq cR
      cA cB cxp cin ccnv wfun cR cA cB cxp cin crn cR cA cB cxp cin ccnv cdm cB
      cR cA cB cxp cin df-rn eqeq1i anbi2i cR cA cB cxp cin crn cB wceq cR cA
      cB cxp cin ccnv wfun wa vx cv vy cv cR wbr vx cA wrex vx cv cA wcel vx cv
      vy cv cR wbr wa vx wmo wa vy cB wral cR cA cB cxp cin ccnv wfun cR cA cB
      cxp cin crn cB wceq wa vx cv vy cv cR wbr vx cA wreu vy cB wral cR cA cB
      cxp cin crn cB wceq vx cv cA wcel vx cv vy cv cR wbr wa vx wmo vy cB wral
      wa vx cv vy cv cR wbr vx cA wrex vy cB wral vx cv cA wcel vx cv vy cv cR
      wbr wa vx wmo vy cB wral wa cR cA cB cxp cin crn cB wceq cR cA cB cxp cin
      ccnv wfun wa vx cv vy cv cR wbr vx cA wrex vx cv cA wcel vx cv vy cv cR
      wbr wa vx wmo wa vy cB wral cR cA cB cxp cin crn cB wceq vx cv vy cv cR
      wbr vx cA wrex vy cB wral vx cv cA wcel vx cv vy cv cR wbr wa vx wmo vy
      cB wral vx vy cA cB cR rninxp anbi1i cR cA cB cxp cin crn cB wceq cR cA
      cB cxp cin ccnv wfun vx cv cA wcel vx cv vy cv cR wbr wa vx wmo vy cB
      wral cR cA cB cxp cin crn cB wceq vx cv vy cv cR cA cB cxp cin wbr vx wmo
      vy cR cA cB cxp cin crn wral vx cv cA wcel vx cv vy cv cR wbr wa vx wmo
      vy cB wral cR cA cB cxp cin ccnv wfun cR cA cB cxp cin crn cB wceq vx cv
      vy cv cR cA cB cxp cin wbr vx wmo vy cR cA cB cxp cin crn wral vx cv vy
      cv cR cA cB cxp cin wbr vx wmo vy cB wral vx cv cA wcel vx cv vy cv cR
      wbr wa vx wmo vy cB wral vx cv vy cv cR cA cB cxp cin wbr vx wmo vy cR cA
      cB cxp cin crn cB raleq1 vx cv vy cv cR cA cB cxp cin wbr vx wmo vx cv cA
      wcel vx cv vy cv cR wbr wa vx wmo vy cB vy cv cB wcel vx cv cA wcel vx cv
      vy cv cR wbr wa vx wmo vy cv cB wcel vx cv cA wcel vx cv vy cv cR wbr wa
      vx wmo wi vx cv vy cv cR cA cB cxp cin wbr vx wmo vy cv cB wcel vx cv cA
      wcel vx cv vy cv cR wbr wa vx wmo biimt vx cv vy cv cR cA cB cxp cin wbr
      vx wmo vy cv cB wcel vx cv cA wcel vx cv vy cv cR wbr wa wa vx wmo vy cv
      cB wcel vx cv cA wcel vx cv vy cv cR wbr wa vx wmo wi vx cv vy cv cR cA
      cB cxp cin wbr vy cv cB wcel vx cv cA wcel vx cv vy cv cR wbr wa wa vx vx
      cv vy cv cR cA cB cxp cin wbr vx cv cA wcel vy cv cB wcel vx cv vy cv cR
      wbr w3a vy cv cB wcel vx cv cA wcel vx cv vy cv cR wbr w3a vy cv cB wcel
      vx cv cA wcel vx cv vy cv cR wbr wa wa vy cv cvv wcel vx cv vy cv cR cA
      cB cxp cin wbr vx cv cA wcel vy cv cB wcel vx cv vy cv cR wbr w3a wb vy
      visset vx cv vy cv cA cB cR cvv brinxp2 ax-mp vx cv cA wcel vy cv cB wcel
      vx cv vy cv cR wbr 3ancoma vy cv cB wcel vx cv cA wcel vx cv vy cv cR wbr
      3anass 3bitri mobii vy cv cB wcel vx cv cA wcel vx cv vy cv cR wbr wa vx
      moanimv bitri syl6rbbr ralbiia syl6bb vx vy cR cA cB cxp cin funcnv
      syl5bb pm5.32i vx cv vy cv cR wbr vx cA wrex vx cv cA wcel vx cv vy cv cR
      wbr wa vx wmo vy cB r19.26 3bitr4i cR cA cB cxp cin ccnv wfun cR cA cB
      cxp cin crn cB wceq ancom vx cv vy cv cR wbr vx cA wreu vx cv vy cv cR
      wbr vx cA wrex vx cv cA wcel vx cv vy cv cR wbr wa vx wmo wa vy cB vx cv
      vy cv cR wbr vx cA reu5 ralbii 3bitr4i 3bitr2i $.
      $( [5-Mar-2007] $) $( [5-Mar-2007] $)

    $( Two ways of stating that ` A ` is one-to-one (but not necessarily a
       function).  Each side is equivalent to Definition 6.4(3) of
       [TakeutiZaring] p. 24, who use the notation "Un_2 (A)" for one-to-one
       (but not necessarily a function). $)
    fun11 $p |- ( ( Fun `' `' A /\ Fun `' A ) <->
         A. x A. y A. z A. w ( ( x A y /\ z A w ) -> ( x = z <-> y = w ) ) ) $=
      vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi vy wal vw
      wal vz wal vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi
      vx wal vw wal vz wal wa vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz
      cv wceq vy cv vw cv wceq wb wi vy wal vx wal vw wal vz wal cA ccnv ccnv
      wfun cA ccnv wfun wa vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv
      wceq vy cv vw cv wceq wb wi vw wal vz wal vy wal vx wal vx cv vy cv cA
      wbr vz cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wb wi vy wal
      vx wal vw wal vz wal vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv
      wceq wi vy wal vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq
      wi vx wal wa vw wal vz wal vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv
      vw cv wceq wi vy wal vw wal vz wal vx cv vw cv cA wbr vz cv vw cv cA wbr
      wa vx cv vz cv wceq wi vx wal vw wal vz wal wa vx cv vy cv cA wbr vz cv
      vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wb wi vy wal vx wal vz
      cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi vy wal vx cv vw
      cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal wa vz vw vx cv
      vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wb
      wi vy wal vx wal vx cv vz cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr
      wa vy cv vw cv wceq wi wi vy cv vw cv wceq vx cv vy cv cA wbr vz cv vw cv
      cA wbr wa vx cv vz cv wceq wi wi wa vy wal vx wal vx cv vz cv wceq vx cv
      vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi wi vy wal vx wal
      vy cv vw cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv
      wceq wi wi vy wal vx wal wa vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy
      cv vw cv wceq wi vy wal vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz
      cv wceq wi vx wal wa vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv
      wceq vy cv vw cv wceq wb wi vx cv vz cv wceq vx cv vy cv cA wbr vz cv vw
      cv cA wbr wa vy cv vw cv wceq wi wi vy cv vw cv wceq vx cv vy cv cA wbr
      vz cv vw cv cA wbr wa vx cv vz cv wceq wi wi wa vx vy vx cv vy cv cA wbr
      vz cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wb wi vx cv vy cv
      cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wi vy cv
      vw cv wceq vx cv vz cv wceq wi wa wi vx cv vy cv cA wbr vz cv vw cv cA
      wbr wa vx cv vz cv wceq vy cv vw cv wceq wi wi vx cv vy cv cA wbr vz cv
      vw cv cA wbr wa vy cv vw cv wceq vx cv vz cv wceq wi wi wa vx cv vz cv
      wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi wi vy
      cv vw cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq
      wi wi wa vx cv vz cv wceq vy cv vw cv wceq wb vx cv vz cv wceq vy cv vw
      cv wceq wi vy cv vw cv wceq vx cv vz cv wceq wi wa vx cv vy cv cA wbr vz
      cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq dfbi2 imbi2i vx cv
      vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wi
      vy cv vw cv wceq vx cv vz cv wceq wi pm4.76 vx cv vy cv cA wbr vz cv vw
      cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wi wi vx cv vz cv wceq vx
      cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi wi vx cv vy cv
      cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq vx cv vz cv wceq wi wi vy
      cv vw cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq
      wi wi vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq vy cv vw
      cv wceq bi2.04 vx cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq
      vx cv vz cv wceq bi2.04 anbi12i 3bitr2i 2albii vx cv vz cv wceq vx cv vy
      cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi wi vy cv vw cv wceq
      vx cv vy cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi wi vx vy
      19.26-2 vx cv vz cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv
      vw cv wceq wi wi vy wal vx wal vz cv vy cv cA wbr vz cv vw cv cA wbr wa
      vy cv vw cv wceq wi vy wal vy cv vw cv wceq vx cv vy cv cA wbr vz cv vw
      cv cA wbr wa vx cv vz cv wceq wi wi vy wal vx wal vx cv vw cv cA wbr vz
      cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal vx cv vz cv wceq vx cv vy
      cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi wi vy wal vx wal vx
      cv vz cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq
      wi wi vx wal vy wal vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv
      wceq wi vy wal vx cv vz cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr wa
      vy cv vw cv wceq wi wi vx vy alcom vx cv vz cv wceq vx cv vy cv cA wbr vz
      cv vw cv cA wbr wa vy cv vw cv wceq wi wi vx wal vz cv vy cv cA wbr vz cv
      vw cv cA wbr wa vy cv vw cv wceq wi vy vx cv vy cv cA wbr vz cv vw cv cA
      wbr wa vy cv vw cv wceq wi vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv
      vw cv wceq wi vx vz vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv
      wceq wi vx ax-17 vx cv vz cv wceq vx cv vy cv cA wbr vz cv vw cv cA wbr
      wa vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq vx cv vz cv
      wceq vx cv vy cv cA wbr vz cv vy cv cA wbr vz cv vw cv cA wbr vx cv vz cv
      vy cv cA breq1 anbi1d imbi1d equsal albii bitri vy cv vw cv wceq vx cv vy
      cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi wi vy wal vx cv vw cv
      cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx vx cv vy cv cA wbr vz
      cv vw cv cA wbr wa vx cv vz cv wceq wi vx cv vw cv cA wbr vz cv vw cv cA
      wbr wa vx cv vz cv wceq wi vy vw vx cv vw cv cA wbr vz cv vw cv cA wbr wa
      vx cv vz cv wceq wi vy ax-17 vy cv vw cv wceq vx cv vy cv cA wbr vz cv vw
      cv cA wbr wa vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq vy
      cv vw cv wceq vx cv vy cv cA wbr vx cv vw cv cA wbr vz cv vw cv cA wbr vy
      cv vw cv vx cv cA breq2 anbi1d imbi1d equsal albii anbi12i 3bitri 2albii
      vz cv vy cv cA wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi vy wal vx cv
      vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal vz vw
      19.26-2 bitr2i cA ccnv ccnv wfun vz cv vy cv cA wbr vz cv vw cv cA wbr wa
      vy cv vw cv wceq wi vy wal vw wal vz wal cA ccnv wfun vx cv vw cv cA wbr
      vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal vw wal vz wal cA ccnv
      ccnv wfun vz cv vy cv cA wbr vy wmo vz wal vz cv vy cv cA wbr vz cv vw cv
      cA wbr wa vy cv vw cv wceq wi vw wal vy wal vz wal vz cv vy cv cA wbr vz
      cv vw cv cA wbr wa vy cv vw cv wceq wi vy wal vw wal vz wal vz vy cA
      fun2cnv vz cv vy cv cA wbr vy wmo vz cv vy cv cA wbr vz cv vw cv cA wbr
      wa vy cv vw cv wceq wi vw wal vy wal vz vz cv vy cv cA wbr vz cv vw cv cA
      wbr vy vw vy cv vw cv vz cv cA breq2 mo4 albii vz cv vy cv cA wbr vz cv
      vw cv cA wbr wa vy cv vw cv wceq wi vw wal vy wal vz cv vy cv cA wbr vz
      cv vw cv cA wbr wa vy cv vw cv wceq wi vy wal vw wal vz vz cv vy cv cA
      wbr vz cv vw cv cA wbr wa vy cv vw cv wceq wi vy vw alcom albii 3bitri cA
      ccnv wfun vx cv vw cv cA wbr vx wmo vw wal vx cv vw cv cA wbr vz cv vw cv
      cA wbr wa vx cv vz cv wceq wi vz wal vx wal vw wal vx cv vw cv cA wbr vz
      cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal vw wal vz wal vx vw cA
      funcnv2 vx cv vw cv cA wbr vx wmo vx cv vw cv cA wbr vz cv vw cv cA wbr
      wa vx cv vz cv wceq wi vz wal vx wal vw vx cv vw cv cA wbr vz cv vw cv cA
      wbr vx vz vx cv vz cv vw cv cA breq1 mo4 albii vx cv vw cv cA wbr vz cv
      vw cv cA wbr wa vx cv vz cv wceq wi vz wal vx wal vw wal vx cv vw cv cA
      wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal vz wal vw wal vx cv
      vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx wal vw wal vz
      wal vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vz wal
      vx wal vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq wi vx
      wal vz wal vw vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv wceq
      wi vx vz alcom albii vx cv vw cv cA wbr vz cv vw cv cA wbr wa vx cv vz cv
      wceq wi vx wal vw vz alcom bitri 3bitri anbi12i vx cv vy cv cA wbr vz cv
      vw cv cA wbr wa vx cv vz cv wceq vy cv vw cv wceq wb wi vx vy vz vw
      alrot4 3bitr4i $.
      $( [30-Jan-2006] $) $( [17-Jan-2006] $)

    $( The union of a chain (with respect to inclusion) of functions is a
       function. $)
    fununi $p |- ( A. f e. A ( Fun f /\ A. g e. A ( f C_ g \/ g C_ f ) ) ->
                 Fun U. A ) $=
      cA cuni wfun cA cuni wrel vx cv vy cv cop cA cuni wcel vx cv vz cv cop cA
      cuni wcel wa vy cv vz cv wceq wi vz wal vy wal vx wal vf cv wfun vf cv vg
      cv wss vg cv vf cv wss wo vg cA wral wa vf cA wral vx vy vz cA cuni
      dffun4 vf cv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA
      wral vf cv wrel vf cA wral cA cuni wrel vf cv wfun vf cv vg cv wss vg cv
      vf cv wss wo vg cA wral wa vf cv wrel vf cA vf cv wfun vf cv wrel vf cv
      vg cv wss vg cv vf cv wss wo vg cA wral vf cv funrel adantr r19.20si vf
      cA reluni sylibr vf cv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral
      wa vf cA wral vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral
      vf cA wral vx cv vy cv cop cA cuni wcel vx cv vz cv cop cA cuni wcel wa
      vy cv vz cv wceq wi vz wal vy wal vx wal vf cv wfun vf cv vg cv wss vg cv
      vf cv wss wo vg cA wral wa vf cv wfun vf cv vg cv wss vg cv vf cv wss wo
      wa vg cA wral vf cA vf cv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA
      r19.28av r19.20si vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA
      wral vf cA wral vx cv vy cv cop cA cuni wcel vx cv vz cv cop cA cuni wcel
      wa vy cv vz cv wceq wi vz wal vx vy vf cv wfun vf cv vg cv wss vg cv vf
      cv wss wo wa vg cA wral vf cA wral vx cv vy cv cop cA cuni wcel vx cv vz
      cv cop cA cuni wcel wa vy cv vz cv wceq wi vz vw cv wfun vv cv wfun wa vw
      cv vv cv wss vv cv vw cv wss wo wa vv cA wral vw cA wral vx cv vy cv cop
      vw cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi vv cA wral
      vw cA wral vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral vf
      cA wral vx cv vy cv cop cA cuni wcel vx cv vz cv cop cA cuni wcel wa vy
      cv vz cv wceq wi vw cv wfun vv cv wfun wa vw cv vv cv wss vv cv vw cv wss
      wo wa vv cA wral vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa
      vy cv vz cv wceq wi vv cA wral vw cA vw cv wfun vv cv wfun wa vw cv vv cv
      wss vv cv vw cv wss wo wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv
      cv wcel wa vy cv vz cv wceq wi vv cA vw cv wfun vv cv wfun wa vw cv vv cv
      wss vv cv vw cv wss wo vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv
      wcel wa vy cv vz cv wceq wi vw cv wfun vv cv wfun wa vw cv vv cv wss vx
      cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi
      vv cv vw cv wss vv cv wfun vw cv vv cv wss vx cv vy cv cop vw cv wcel vx
      cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi wi vw cv wfun vw cv vv cv
      wss vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa vx cv vy cv
      cop vv cv wcel vx cv vz cv cop vv cv wcel wa vv cv wfun vy cv vz cv wceq
      vw cv vv cv wss vx cv vy cv cop vw cv wcel vx cv vy cv cop vv cv wcel vx
      cv vz cv cop vv cv wcel vw cv vv cv vx cv vy cv cop ssel anim1d vv cv
      wfun vx cv vy cv cop vv cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv
      wceq wi vz wal vy wal vx wal vx cv vy cv cop vv cv wcel vx cv vz cv cop
      vv cv wcel wa vy cv vz cv wceq wi vz wal vx cv vy cv cop vv cv wcel vx cv
      vz cv cop vv cv wcel wa vy cv vz cv wceq wi vv cv wfun vv cv wrel vx cv
      vy cv cop vv cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi vz
      wal vy wal vx wal vx vy vz vv cv dffun4 pm3.27bi vx cv vy cv cop vv cv
      wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi vz wal vy wal vx
      cv vy cv cop vv cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi
      vz wal vx vx cv vy cv cop vv cv wcel vx cv vz cv cop vv cv wcel wa vy cv
      vz cv wceq wi vz wal vy ax-4 a4s vx cv vy cv cop vv cv wcel vx cv vz cv
      cop vv cv wcel wa vy cv vz cv wceq wi vz ax-4 3syl syl9r adantl vw cv
      wfun vv cv vw cv wss vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv
      wcel wa vy cv vz cv wceq wi wi vv cv wfun vv cv vw cv wss vx cv vy cv cop
      vw cv wcel vx cv vz cv cop vv cv wcel wa vx cv vy cv cop vw cv wcel vx cv
      vz cv cop vw cv wcel wa vw cv wfun vy cv vz cv wceq vv cv vw cv wss vx cv
      vz cv cop vv cv wcel vx cv vz cv cop vw cv wcel vx cv vy cv cop vw cv
      wcel vv cv vw cv vx cv vz cv cop ssel anim2d vw cv wfun vx cv vy cv cop
      vw cv wcel vx cv vz cv cop vw cv wcel wa vy cv vz cv wceq wi vz wal vy
      wal vx wal vx cv vy cv cop vw cv wcel vx cv vz cv cop vw cv wcel wa vy cv
      vz cv wceq wi vz wal vx cv vy cv cop vw cv wcel vx cv vz cv cop vw cv
      wcel wa vy cv vz cv wceq wi vw cv wfun vw cv wrel vx cv vy cv cop vw cv
      wcel vx cv vz cv cop vw cv wcel wa vy cv vz cv wceq wi vz wal vy wal vx
      wal vx vy vz vw cv dffun4 pm3.27bi vx cv vy cv cop vw cv wcel vx cv vz cv
      cop vw cv wcel wa vy cv vz cv wceq wi vz wal vy wal vx cv vy cv cop vw cv
      wcel vx cv vz cv cop vw cv wcel wa vy cv vz cv wceq wi vz wal vx vx cv vy
      cv cop vw cv wcel vx cv vz cv cop vw cv wcel wa vy cv vz cv wceq wi vz
      wal vy ax-4 a4s vx cv vy cv cop vw cv wcel vx cv vz cv cop vw cv wcel wa
      vy cv vz cv wceq wi vz ax-4 3syl syl9r adantr jaod imp r19.20si r19.20si
      vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral vf cA wral vf
      cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral vf cA wral wa vw
      cv wfun vw cv vv cv wss vv cv vw cv wss wo wa vv cA wral vw cA wral vv cv
      wfun vw cv vv cv wss vv cv vw cv wss wo wa vv cA wral vw cA wral wa vf cv
      wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral vf cA wral vw cv
      wfun vv cv wfun wa vw cv vv cv wss vv cv vw cv wss wo wa vv cA wral vw cA
      wral vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral vf cA
      wral vw cv wfun vw cv vv cv wss vv cv vw cv wss wo wa vv cA wral vw cA
      wral vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vg cA wral vf cA
      wral vv cv wfun vw cv vv cv wss vv cv vw cv wss wo wa vv cA wral vw cA
      wral vf cv wfun vf cv vg cv wss vg cv vf cv wss wo wa vw cv wfun vw cv vv
      cv wss vv cv vw cv wss wo wa vw cv wfun vw cv vg cv wss vg cv vw cv wss
      wo wa vf vg vw vv cA cA vf cv vw cv wceq vf cv wfun vw cv wfun vf cv vg
      cv wss vg cv vf cv wss wo vw cv vg cv wss vg cv vw cv wss wo vf cv vw cv
      funeq vf cv vw cv wceq vf cv vg cv wss vw cv vg cv wss vg cv vf cv wss vg
      cv vw cv wss vf cv vw cv vg cv sseq1 vf cv vw cv vg cv sseq2 orbi12d
      anbi12d vg cv vv cv wceq vw cv vg cv wss vg cv vw cv wss wo vw cv vv cv
      wss vv cv vw cv wss wo vw cv wfun vg cv vv cv wceq vw cv vg cv wss vw cv
      vv cv wss vg cv vw cv wss vv cv vw cv wss vg cv vv cv vw cv sseq2 vg cv
      vv cv vw cv sseq1 orbi12d anbi2d cbvral2v vf cv wfun vf cv vg cv wss vg
      cv vf cv wss wo wa vg cA wral vf cA wral vf cv wfun vf cv vg cv wss vg cv
      vf cv wss wo wa vf cA wral vg cA wral vv cv wfun vw cv vv cv wss vv cv vw
      cv wss wo wa vv cA wral vw cA wral vf cv wfun vf cv vg cv wss vg cv vf cv
      wss wo wa vf vg cA cA ralcom vf cv wfun vf cv vg cv wss vg cv vf cv wss
      wo wa vv cv wfun vw cv vv cv wss vv cv vw cv wss wo wa vf cv wfun vw cv
      vf cv wss vf cv vw cv wss wo wa vg vf vw vv cA cA vg cv vw cv wceq vf cv
      vg cv wss vg cv vf cv wss wo vw cv vf cv wss vf cv vw cv wss wo vf cv
      wfun vg cv vw cv wceq vg cv vf cv wss vf cv vg cv wss wo vw cv vf cv wss
      vf cv vw cv wss wo vf cv vg cv wss vg cv vf cv wss wo vg cv vw cv wceq vg
      cv vf cv wss vw cv vf cv wss vf cv vg cv wss vf cv vw cv wss vg cv vw cv
      vf cv sseq1 vg cv vw cv vf cv sseq2 orbi12d vf cv vg cv wss vg cv vf cv
      wss orcom syl5bb anbi2d vf cv vv cv wceq vf cv wfun vv cv wfun vw cv vf
      cv wss vf cv vw cv wss wo vw cv vv cv wss vv cv vw cv wss wo vf cv vv cv
      funeq vf cv vv cv wceq vw cv vf cv wss vw cv vv cv wss vf cv vw cv wss vv
      cv vw cv wss vf cv vv cv vw cv sseq2 vf cv vv cv vw cv sseq1 orbi12d
      anbi12d cbvral2v bitri anbi12i vf cv wfun vf cv vg cv wss vg cv vf cv wss
      wo wa vg cA wral vf cA wral anidm vw cv wfun vv cv wfun wa vw cv vv cv
      wss vv cv vw cv wss wo wa vv cA wral vw cA wral vw cv wfun vw cv vv cv
      wss vv cv vw cv wss wo wa vv cv wfun vw cv vv cv wss vv cv vw cv wss wo
      wa wa vv cA wral vw cA wral vw cv wfun vw cv vv cv wss vv cv vw cv wss wo
      wa vv cA wral vw cA wral vv cv wfun vw cv vv cv wss vv cv vw cv wss wo wa
      vv cA wral vw cA wral wa vw cv wfun vv cv wfun wa vw cv vv cv wss vv cv
      vw cv wss wo wa vw cv wfun vw cv vv cv wss vv cv vw cv wss wo wa vv cv
      wfun vw cv vv cv wss vv cv vw cv wss wo wa wa vw vv cA cA vw cv wfun vv
      cv wfun vw cv vv cv wss vv cv vw cv wss wo anandir 2ralbii vw cv wfun vw
      cv vv cv wss vv cv vw cv wss wo wa vv cv wfun vw cv vv cv wss vv cv vw cv
      wss wo wa vw vv cA cA r19.26-2 bitr2i 3bitr3i vx cv vy cv cop cA cuni
      wcel vx cv vz cv cop cA cuni wcel wa vy cv vz cv wceq wi vw cv cA wcel vv
      cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa wa
      vv wex vw wex vy cv vz cv wceq wi vx cv vy cv cop vw cv wcel vx cv vz cv
      cop vv cv wcel wa vy cv vz cv wceq wi vv cA wral vw cA wral vx cv vy cv
      cop cA cuni wcel vx cv vz cv cop cA cuni wcel wa vw cv cA wcel vv cv cA
      wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa wa vv
      wex vw wex vy cv vz cv wceq vx cv vy cv cop cA cuni wcel vx cv vz cv cop
      cA cuni wcel wa vx cv vy cv cop vw cv wcel vw cv cA wcel wa vw wex vx cv
      vz cv cop vv cv wcel vv cv cA wcel wa vv wex wa vx cv vy cv cop vw cv
      wcel vw cv cA wcel wa vx cv vz cv cop vv cv wcel vv cv cA wcel wa wa vv
      wex vw wex vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx
      cv vz cv cop vv cv wcel wa wa vv wex vw wex vx cv vy cv cop cA cuni wcel
      vx cv vy cv cop vw cv wcel vw cv cA wcel wa vw wex vx cv vz cv cop cA
      cuni wcel vx cv vz cv cop vv cv wcel vv cv cA wcel wa vv wex vw vx cv vy
      cv cop cA eluni vv vx cv vz cv cop cA eluni anbi12i vx cv vy cv cop vw cv
      wcel vw cv cA wcel wa vx cv vz cv cop vv cv wcel vv cv cA wcel wa vw vv
      eeanv vx cv vy cv cop vw cv wcel vw cv cA wcel wa vx cv vz cv cop vv cv
      wcel vv cv cA wcel wa wa vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop
      vw cv wcel vx cv vz cv cop vv cv wcel wa wa vw vv vx cv vy cv cop vw cv
      wcel vw cv cA wcel wa vx cv vz cv cop vv cv wcel vv cv cA wcel wa wa vx
      cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa vw cv cA wcel vv cv
      cA wcel wa wa vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel
      vx cv vz cv cop vv cv wcel wa wa vx cv vy cv cop vw cv wcel vw cv cA wcel
      vx cv vz cv cop vv cv wcel vv cv cA wcel an4 vx cv vy cv cop vw cv wcel
      vx cv vz cv cop vv cv wcel wa vw cv cA wcel vv cv cA wcel wa ancom bitri
      2exbii 3bitr2i imbi1i vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw
      cv wcel vx cv vz cv cop vv cv wcel wa wa vy cv vz cv wceq wi vv wal vw
      wal vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv
      cop vv cv wcel wa wa vv wex vy cv vz cv wceq wi vw wal vx cv vy cv cop vw
      cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi vv cA wral vw
      cA wral vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv
      vz cv cop vv cv wcel wa wa vv wex vw wex vy cv vz cv wceq wi vw cv cA
      wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv
      wcel wa wa vy cv vz cv wceq wi vv wal vw cv cA wcel vv cv cA wcel wa vx
      cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa wa vv wex vy cv vz
      cv wceq wi vw vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel
      vx cv vz cv cop vv cv wcel wa wa vy cv vz cv wceq vv 19.23v albii vw cv
      cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv
      wcel wa wa vy cv vz cv wceq wi vv wal vw wal vw cv cA wcel vv cv cA wcel
      wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa vy cv vz cv
      wceq wi wi vv wal vw wal vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv
      wcel wa vy cv vz cv wceq wi vv cA wral vw cA wral vw cv cA wcel vv cv cA
      wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa wa vy cv
      vz cv wceq wi vw cv cA wcel vv cv cA wcel wa vx cv vy cv cop vw cv wcel
      vx cv vz cv cop vv cv wcel wa vy cv vz cv wceq wi wi vw vv vw cv cA wcel
      vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa
      vy cv vz cv wceq impexp 2albii vx cv vy cv cop vw cv wcel vx cv vz cv cop
      vv cv wcel wa vy cv vz cv wceq wi vw vv cA cA r2al bitr4i vw cv cA wcel
      vv cv cA wcel wa vx cv vy cv cop vw cv wcel vx cv vz cv cop vv cv wcel wa
      wa vv wex vy cv vz cv wceq vw 19.23v 3bitr3ri bitri 3imtr4i 19.21aiv
      19.21aivv syl sylanbrc $.
      $( [1-Oct-2004] $) $( [10-Aug-2004] $)

    $( The union of a chain (with respect to inclusion) of single-rooted sets
       is single-rooted.  (See ~ funcnv for "single-rooted" definition.) $)
    funcnvuni $p |- ( A. f e. A ( Fun `' f /\ A. g e. A ( f C_ g \/ g C_ f ) )
                    -> Fun `' U. A ) $=
      vf cv ccnv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA
      wral vy cv vx cv ccnv wceq vx cA wrex vy cab cuni wfun cA cuni ccnv wfun
      vf cv ccnv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA
      wral vz cv wfun vz cv vw cv wss vw cv vz cv wss wo vw vy cv vx cv ccnv
      wceq vx cA wrex vy cab wral wa vz vy cv vx cv ccnv wceq vx cA wrex vy cab
      wral vy cv vx cv ccnv wceq vx cA wrex vy cab cuni wfun vf cv ccnv wfun vf
      cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA wral vz cv vx cv ccnv
      wceq vx cA wrex vz cv wfun vw cv vx cv ccnv wceq vx cA wrex vz cv vw cv
      wss vw cv vz cv wss wo wi vw wal wa wi vz wal vz cv wfun vz cv vw cv wss
      vw cv vz cv wss wo vw vy cv vx cv ccnv wceq vx cA wrex vy cab wral wa vz
      vy cv vx cv ccnv wceq vx cA wrex vy cab wral vf cv ccnv wfun vf cv vg cv
      wss vg cv vf cv wss wo vg cA wral wa vf cA wral vz cv vx cv ccnv wceq vx
      cA wrex vz cv wfun vw cv vx cv ccnv wceq vx cA wrex vz cv vw cv wss vw cv
      vz cv wss wo wi vw wal wa wi vz vf cv ccnv wfun vf cv vg cv wss vg cv vf
      cv wss wo vg cA wral wa vf cA wral vz cv vv cv ccnv wceq vv cA wrex vz cv
      wfun vw cv vx cv ccnv wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss wo
      wi vw wal wa vz cv vx cv ccnv wceq vx cA wrex vf cv ccnv wfun vf cv vg cv
      wss vg cv vf cv wss wo vg cA wral wa vf cA wral vz cv vv cv ccnv wceq vz
      cv wfun vw cv vx cv ccnv wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss
      wo wi vw wal wa vv cA vv cv cA wcel vf cv ccnv wfun vf cv vg cv wss vg cv
      vf cv wss wo vg cA wral wa vf cA wral vv cv ccnv wfun vv cv vg cv wss vg
      cv vv cv wss wo vg cA wral wa vz cv vv cv ccnv wceq vz cv wfun vw cv vx
      cv ccnv wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw wal wa
      wi vf cv ccnv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vv cv
      ccnv wfun vv cv vg cv wss vg cv vv cv wss wo vg cA wral wa vf vv cv cA vf
      cv vv cv wceq vf cv ccnv wfun vv cv ccnv wfun vf cv vg cv wss vg cv vf cv
      wss wo vg cA wral vv cv vg cv wss vg cv vv cv wss wo vg cA wral vf cv vv
      cv wceq vf cv ccnv vv cv ccnv wceq vf cv ccnv wfun vv cv ccnv wfun wb vf
      cv vv cv cnveq vf cv ccnv vv cv ccnv funeq syl vf cv vv cv wceq vf cv vg
      cv wss vg cv vf cv wss wo vv cv vg cv wss vg cv vv cv wss wo vg cA vf cv
      vv cv wceq vf cv vg cv wss vv cv vg cv wss vg cv vf cv wss vg cv vv cv
      wss vf cv vv cv vg cv sseq1 vf cv vv cv vg cv sseq2 orbi12d ralbidv
      anbi12d rcla4v vv cv ccnv wfun vz cv vv cv ccnv wceq vz cv wfun vv cv vg
      cv wss vg cv vv cv wss wo vg cA wral vw cv vx cv ccnv wceq vx cA wrex vz
      cv vw cv wss vw cv vz cv wss wo wi vw wal vz cv vv cv ccnv wceq vz cv
      wfun vv cv ccnv wfun vz cv vv cv ccnv funeq biimprcd vv cv vg cv wss vg
      cv vv cv wss wo vg cA wral vz cv vv cv ccnv wceq vw cv vx cv ccnv wceq vx
      cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw vv cv vg cv wss vg cv vv
      cv wss wo vg cA wral vw cv vx cv ccnv wceq vx cA wrex vz cv vv cv ccnv
      wceq vz cv vw cv wss vw cv vz cv wss wo vv cv vg cv wss vg cv vv cv wss
      wo vg cA wral vw cv vx cv ccnv wceq vz cv vv cv ccnv wceq vz cv vw cv wss
      vw cv vz cv wss wo wi vx cA vx cv cA wcel vv cv vg cv wss vg cv vv cv wss
      wo vg cA wral vv cv vx cv wss vx cv vv cv wss wo vw cv vx cv ccnv wceq vz
      cv vv cv ccnv wceq vz cv vw cv wss vw cv vz cv wss wo wi wi vv cv vg cv
      wss vg cv vv cv wss wo vv cv vx cv wss vx cv vv cv wss wo vg vx cv cA vg
      cv vx cv wceq vv cv vg cv wss vv cv vx cv wss vg cv vv cv wss vx cv vv cv
      wss vg cv vx cv vv cv sseq2 vg cv vx cv vv cv sseq1 orbi12d rcla4v vv cv
      vx cv wss vx cv vv cv wss wo vw cv vx cv ccnv wceq vz cv vv cv ccnv wceq
      vz cv vw cv wss vw cv vz cv wss wo vw cv vx cv ccnv wceq vz cv vv cv ccnv
      wceq wa vz cv vw cv wss vw cv vz cv wss wo vv cv ccnv vx cv ccnv wss vx
      cv ccnv vv cv ccnv wss wo vv cv vx cv wss vx cv vv cv wss wo vw cv vx cv
      ccnv wceq vz cv vv cv ccnv wceq wa vz cv vw cv wss vv cv ccnv vx cv ccnv
      wss vw cv vz cv wss vx cv ccnv vv cv ccnv wss vz cv vv cv ccnv wceq vw cv
      vx cv ccnv wceq vz cv vw cv wss vv cv ccnv vx cv ccnv wss wb vz cv vv cv
      ccnv vw cv vx cv ccnv sseq12 ancoms vw cv vx cv ccnv vz cv vv cv ccnv
      sseq12 orbi12d vv cv vx cv wss vv cv ccnv vx cv ccnv wss vx cv vv cv wss
      vx cv ccnv vv cv ccnv wss vv cv vx cv cnvss vx cv vv cv cnvss orim12i
      syl5cbir exp3a syl6com r19.23adv com23 19.21adv anim12ii syl6com
      r19.23adv vz cv vx cv ccnv wceq vz cv vv cv ccnv wceq vx vv cA vx cv vv
      cv wceq vx cv ccnv vv cv ccnv vz cv vx cv vv cv cnveq eqeq2d cbvrexv
      syl5ib 19.21aiv vz cv wfun vz cv vw cv wss vw cv vz cv wss wo vw vy cv vx
      cv ccnv wceq vx cA wrex vy cab wral wa vz vy cv vx cv ccnv wceq vx cA
      wrex vy cab wral vz cv vy cv vx cv ccnv wceq vx cA wrex vy cab wcel vz cv
      wfun vz cv vw cv wss vw cv vz cv wss wo vw vy cv vx cv ccnv wceq vx cA
      wrex vy cab wral wa wi vz wal vz cv vx cv ccnv wceq vx cA wrex vz cv wfun
      vw cv vx cv ccnv wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw
      wal wa wi vz wal vz cv wfun vz cv vw cv wss vw cv vz cv wss wo vw vy cv
      vx cv ccnv wceq vx cA wrex vy cab wral wa vz vy cv vx cv ccnv wceq vx cA
      wrex vy cab df-ral vz cv vy cv vx cv ccnv wceq vx cA wrex vy cab wcel vz
      cv wfun vz cv vw cv wss vw cv vz cv wss wo vw vy cv vx cv ccnv wceq vx cA
      wrex vy cab wral wa wi vz cv vx cv ccnv wceq vx cA wrex vz cv wfun vw cv
      vx cv ccnv wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw wal
      wa wi vz vz cv vy cv vx cv ccnv wceq vx cA wrex vy cab wcel vz cv vx cv
      ccnv wceq vx cA wrex vz cv wfun vz cv vw cv wss vw cv vz cv wss wo vw vy
      cv vx cv ccnv wceq vx cA wrex vy cab wral wa vz cv wfun vw cv vx cv ccnv
      wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw wal wa vy cv vx
      cv ccnv wceq vx cA wrex vz cv vx cv ccnv wceq vx cA wrex vy vz cv vz
      visset vy cv vz cv wceq vy cv vx cv ccnv wceq vz cv vx cv ccnv wceq vx cA
      vy cv vz cv vx cv ccnv eqeq1 rexbidv elab vz cv vw cv wss vw cv vz cv wss
      wo vw vy cv vx cv ccnv wceq vx cA wrex vy cab wral vw cv vx cv ccnv wceq
      vx cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw wal vz cv wfun vz cv
      vw cv wss vw cv vz cv wss wo vw vy cv vx cv ccnv wceq vx cA wrex vy cab
      wral vw cv vy cv vx cv ccnv wceq vx cA wrex vy cab wcel vz cv vw cv wss
      vw cv vz cv wss wo wi vw wal vw cv vx cv ccnv wceq vx cA wrex vz cv vw cv
      wss vw cv vz cv wss wo wi vw wal vz cv vw cv wss vw cv vz cv wss wo vw vy
      cv vx cv ccnv wceq vx cA wrex vy cab df-ral vw cv vy cv vx cv ccnv wceq
      vx cA wrex vy cab wcel vz cv vw cv wss vw cv vz cv wss wo wi vw cv vx cv
      ccnv wceq vx cA wrex vz cv vw cv wss vw cv vz cv wss wo wi vw vw cv vy cv
      vx cv ccnv wceq vx cA wrex vy cab wcel vw cv vx cv ccnv wceq vx cA wrex
      vz cv vw cv wss vw cv vz cv wss wo vy cv vx cv ccnv wceq vx cA wrex vw cv
      vx cv ccnv wceq vx cA wrex vy vw cv vw visset vy cv vw cv wceq vy cv vx
      cv ccnv wceq vw cv vx cv ccnv wceq vx cA vy cv vw cv vx cv ccnv eqeq1
      rexbidv elab imbi1i albii bitri anbi2i imbi12i albii bitr2i sylib vy cv
      vx cv ccnv wceq vx cA wrex vy cab vz vw fununi syl cA cuni ccnv vy cv vx
      cv ccnv wceq vx cA wrex vy cab cuni wceq cA cuni ccnv wfun vy cv vx cv
      ccnv wceq vx cA wrex vy cab cuni wfun wb cA cuni ccnv vx cA vx cv ccnv
      ciun vy cv vx cv ccnv wceq vx cA wrex vy cab cuni vx cA cnvuni vx vy cA
      vx cv ccnv vx cv vx visset cnvex dfiun2 eqtri cA cuni ccnv vy cv vx cv
      ccnv wceq vx cA wrex vy cab cuni funeq ax-mp sylibr $.
      $( [2-Oct-2004] $) $( [11-Aug-2004] $)

    $( The union of a chain (with respect to inclusion) of one-to-one functions
       is a one-to-one function. $)
    fun11uni $p |- ( A. f e. A ( ( Fun f /\ Fun `' f ) /\
                   A. g e. A ( f C_ g \/ g C_ f ) ) ->
                   ( Fun U. A /\ Fun `' U. A ) ) $=
      vf cv wfun vf cv ccnv wfun wa vf cv vg cv wss vg cv vf cv wss wo vg cA
      wral wa vf cA wral cA cuni wfun cA cuni ccnv wfun vf cv wfun vf cv ccnv
      wfun wa vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA wral vf cv
      wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA wral cA cuni
      wfun vf cv wfun vf cv ccnv wfun wa vf cv vg cv wss vg cv vf cv wss wo vg
      cA wral wa vf cv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf
      cA vf cv wfun vf cv ccnv wfun wa vf cv wfun vf cv vg cv wss vg cv vf cv
      wss wo vg cA wral vf cv wfun vf cv ccnv wfun pm3.26 anim1i r19.20si cA vf
      vg fununi syl vf cv wfun vf cv ccnv wfun wa vf cv vg cv wss vg cv vf cv
      wss wo vg cA wral wa vf cA wral vf cv ccnv wfun vf cv vg cv wss vg cv vf
      cv wss wo vg cA wral wa vf cA wral cA cuni ccnv wfun vf cv wfun vf cv
      ccnv wfun wa vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cv ccnv
      wfun vf cv vg cv wss vg cv vf cv wss wo vg cA wral wa vf cA vf cv wfun vf
      cv ccnv wfun wa vf cv ccnv wfun vf cv vg cv wss vg cv vf cv wss wo vg cA
      wral vf cv wfun vf cv ccnv wfun pm3.27 anim1i r19.20si cA vf vg funcnvuni
      syl jca $.
      $( [2-Oct-2004] $) $( [11-Aug-2004] $)
  $}

  ${
    $d x y F $.  $d x y G $.
    $( The intersection with a function is a function.  Exercise 14(a) of
       [Enderton] p. 53. $)
    funin $p |- ( Fun F -> Fun ( F i^i G ) ) $=
      cF wrel vx cv vy cv cF wbr vy wmo vx wal wa cF cG cin wrel vx cv vy cv cF
      cG cin wbr vy wmo vx wal wa cF wfun cF cG cin wfun cF wrel cF cG cin wrel
      vx cv vy cv cF wbr vy wmo vx wal vx cv vy cv cF cG cin wbr vy wmo vx wal
      cF cG relin1 vx cv vy cv cF wbr vy wmo vx cv vy cv cF cG cin wbr vy wmo
      vx vx cv vy cv cF wbr vy wmo vx cv vy cv cop cG wcel vx cv vy cv cF wbr
      wa vy wmo vx cv vy cv cF cG cin wbr vy wmo vx cv vy cv cF wbr vx cv vy cv
      cop cG wcel vy moan vx cv vy cv cop cG wcel vx cv vy cv cF wbr wa vx cv
      vy cv cF cG cin wbr vy vx cv vy cv cop cG wcel vx cv vy cv cF wbr wa vx
      cv vy cv cF wbr vx cv vy cv cop cG wcel wa vx cv vy cv cF cG cin wbr vx
      cv vy cv cop cG wcel vx cv vy cv cF wbr ancom vx cv vy cv cop cF cG cin
      wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wa vx cv vy cv cF cG
      cin wbr vx cv vy cv cF wbr vx cv vy cv cop cG wcel wa vx cv vy cv cop cF
      cG elin vx cv vy cv cF cG cin df-br vx cv vy cv cF wbr vx cv vy cv cop cF
      wcel vx cv vy cv cop cG wcel vx cv vy cv cF df-br anbi1i 3bitr4i bitr4i
      mobii sylib 19.20i anim12i vx vy cF dffun6 vx vy cF cG cin dffun6 3imtr4i
      $.
      $( [20-Mar-2004] $) $( [19-Mar-2004] $)
  $}

  $( The restriction of a one-to-one function is one-to-one. $)
  funres11 $p |- ( Fun `' F -> Fun `' ( F |` A ) ) $=
    cF cA cres ccnv cF ccnv wss cF ccnv wfun cF cA cres ccnv wfun wi cF cA cres
    cF wss cF cA cres ccnv cF ccnv wss cF cA resss cF cA cres cF cnvss ax-mp cF
    cA cres ccnv cF ccnv funss ax-mp $.
    $( [25-Mar-1998] $)

  $( The converse of a restricted function. $)
  funcnvres $p |- ( Fun `' F -> `' ( F |` A ) = ( `' F |` ( F " A ) ) ) $=
    cF ccnv wfun cF ccnv cF cA cres ccnv cdm cres cF cA cres ccnv cF ccnv cF cA
    cima cres cF ccnv wfun cF cA cres ccnv cF ccnv wss cF ccnv cF cA cres ccnv
    cdm cres cF cA cres ccnv wceq cF cA cres cF wss cF cA cres ccnv cF ccnv wss
    cF cA resss cF cA cres cF cnvss ax-mp cF ccnv cF cA cres ccnv funssres
    mpan2 cF cA cima cF cA cres ccnv cdm wceq cF ccnv cF cA cima cres cF ccnv
    cF cA cres ccnv cdm cres wceq cF cA cima cF cA cres crn cF cA cres ccnv cdm
    cF cA df-ima cF cA cres df-rn eqtri cF cA cima cF cA cres ccnv cdm cF ccnv
    reseq2 ax-mp syl5req $.
    $( [27-Mar-1998] $)

  $( Converse of a restricted identity function.  (Contributed by FL,
     4-Mar-2007.) $)
  cnvresid $p |- `' ( _I |` A ) = ( _I |` A ) $=
    cid ccnv wfun cid cA cres ccnv cid cA cres wceq cid cid ccnv wceq cid ccnv
    wfun cid ccnv cid cnvi eqcomi cid cid ccnv wceq cid wfun cid ccnv wfun funi
    cid cid ccnv funeq mpbii ax-mp cid ccnv wfun cid cA cres ccnv cid ccnv cid
    cA cima cres cid cA cres cA cid funcnvres cid ccnv cid wceq cid ccnv cid cA
    cima cres cid cA cres wceq cnvi cid ccnv cid wceq cid ccnv cid cA cima cres
    cid cid cA cima cres cid cA cres cid ccnv cid cid cA cima reseq1 cid cA
    cima cA wceq cid cid cA cima cres cid cA cres wceq cA imai cid cA cima cA
    cid reseq2 ax-mp syl6eq ax-mp syl6eq ax-mp $.
    $( [5-Mar-2007] $) $( [20-Feb-2007] $)

  $( The converse of a restriction of the converse of a function equals the
     function restricted to the image of its converse. $)
  funcnvres2 $p |- ( Fun F -> `' ( `' F |` A ) = ( F |` ( `' F " A ) ) ) $=
    cF wfun cF ccnv cA cres ccnv cF ccnv ccnv cF ccnv cA cima cres cF cF ccnv
    cA cima cres cF wfun cF ccnv ccnv wfun cF ccnv cA cres ccnv cF ccnv ccnv cF
    ccnv cA cima cres wceq cF funcnvcnv cA cF ccnv funcnvres syl cF wfun cF
    ccnv ccnv cF wceq cF ccnv ccnv cF ccnv cA cima cres cF cF ccnv cA cima cres
    wceq cF wfun cF wrel cF ccnv ccnv cF wceq cF funrel cF dfrel2 sylib cF ccnv
    ccnv cF cF ccnv cA cima reseq1 syl eqtrd $.
    $( [6-May-2005] $) $( [4-May-2005] $)

  $( The image of the pre-image of a function. $)
  funimacnv $p |- ( Fun F -> ( F " ( `' F " A ) ) = ( A i^i ran F ) ) $=
    cF wfun cF cF ccnv cA cima cima cF ccnv cA cres ccnv crn cA cF crn cin cF
    wfun cF ccnv cA cres ccnv crn cF cF ccnv cA cima cres crn cF cF ccnv cA
    cima cima cF wfun cF ccnv cA cres ccnv cF cF ccnv cA cima cres cA cF
    funcnvres2 rneqd cF cF ccnv cA cima df-ima syl6reqr cA cF crn cin cA cF
    ccnv cdm cin cF ccnv cA cres cdm cF ccnv cA cres ccnv crn cF crn cF ccnv
    cdm cA cF df-rn ineq2i cF ccnv cA dmres cF ccnv cA cres dfdm4 3eqtr2ri
    syl6eq $.
    $( [7-Jun-2004] $) $( [25-May-2004] $)

  $( A kind of contraposition law that infers a subclass of an image from
     a pre-image subclass. $)
  funimass1 $p |- ( ( Fun F /\ A C_ ran F ) ->
                 ( ( `' F " A ) C_ B -> A C_ ( F " B ) ) ) $=
    cF wfun cA cF crn wss wa cF cF ccnv cA cima cima cF cB cima wss cA cF cB
    cima wss cF ccnv cA cima cB wss cF wfun cA cF crn wss wa cF cF ccnv cA cima
    cima cA cF cB cima cF wfun cA cF crn wss cF cF ccnv cA cima cima cA cF crn
    cin cA cA cF funimacnv cA cF crn wss cA cA cF crn cin cA cF crn wss cA cA
    cF crn cin wceq cA cF crn dfss biimpi eqcomd sylan9eq sseq1d cF ccnv cA
    cima cB cF imass2 syl5bi $.
    $( [10-Jun-2004] $) $( [25-May-2004] $)

  $( A kind of contraposition law that infers an image subclass from a subclass
     of a pre-image. $)
  funimass2 $p |- ( ( Fun F /\ A C_ ( `' F " B ) ) -> ( F " A ) C_ B ) $=
    cF wfun cF cA cima cF cF ccnv cB cima cima wss cF cA cima cB wss cA cF ccnv
    cB cima wss cF wfun cF cA cima cF cF ccnv cB cima cima wss cF cA cima cB
    wss cF wfun cF cA cima cF cF ccnv cB cima cima wss cF cA cima cB cF crn cin
    wss cF cA cima cB wss cF wfun cF cF ccnv cB cima cima cB cF crn cin cF cA
    cima cB cF funimacnv sseq2d cF cA cima cB cF crn cin wss cB cF crn cin cB
    wss cF cA cima cB wss cB cF crn inss1 cF cA cima cB cF crn cin cB sstr2 mpi
    syl6bi imp cA cF ccnv cB cima cF imass2 sylan2 $.
    $( [4-May-2007] $) $( [25-May-2004] $)

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( The image of a difference is the difference of images. $)
    imadif $p |- ( Fun `' F ->
                 ( F " ( A \ B ) ) = ( ( F " A ) \ ( F " B ) ) ) $=
      cF ccnv wfun vy cF cA cB cdif cima cF cA cima cF cB cima cdif cF ccnv
      wfun vx cv cA cB cdif wcel vx cv vy cv cF wbr wa vx wex vy cv cF cA cima
      wcel vy cv cF cB cima wcel wn wa vy cv cF cA cB cdif cima wcel vy cv cF
      cA cima cF cB cima cdif wcel cF ccnv wfun vx cv cA wcel vx cv cB wcel wn
      wa vx cv vy cv cF wbr wa vx wex vx cv cA wcel vx cv vy cv cF wbr wa vx
      wex vx cv cB wcel vx cv vy cv cF wbr wa vx wex wn wa vx cv cA cB cdif
      wcel vx cv vy cv cF wbr wa vx wex vy cv cF cA cima wcel vy cv cF cB cima
      wcel wn wa cF ccnv wfun vx cv cA wcel vx cv cB wcel wn wa vx cv vy cv cF
      wbr wa vx wex vx cv cA wcel vx cv vy cv cF wbr wa vx wex vx cv cB wcel vx
      cv vy cv cF wbr wa vx wex wn wa cF ccnv wfun vx cv cA wcel vx cv vy cv cF
      wbr wa vx wex vx cv cB wcel wn vx cv vy cv cF wbr wa vx wex wa vx cv cA
      wcel vx cv vy cv cF wbr wa vx wex vx cv cB wcel vx cv vy cv cF wbr wa vx
      wex wn wa vx cv cA wcel vx cv cB wcel wn wa vx cv vy cv cF wbr wa vx wex
      cF ccnv wfun vx cv cB wcel wn vx cv vy cv cF wbr wa vx wex vx cv cB wcel
      vx cv vy cv cF wbr wa vx wex wn vx cv cA wcel vx cv vy cv cF wbr wa vx
      wex cF ccnv wfun vx cv vy cv cF wbr vx cv cB wcel wn wa vx wex vx cv cB
      wcel vx cv vy cv cF wbr wa wn vx wal vx cv cB wcel wn vx cv vy cv cF wbr
      wa vx wex vx cv cB wcel vx cv vy cv cF wbr wa vx wex wn cF ccnv wfun vx
      cv vy cv cF wbr vx cv cB wcel wn wa vx wex vx cv cB wcel vx cv vy cv cF
      wbr wa wn vx wal cF ccnv wfun vx cv vy cv cF wbr vx cv cB wcel wn wa vx
      wex wa vx cv cB wcel vx cv vy cv cF wbr wa wn vx cF ccnv wfun vx cv vy cv
      cF wbr vx cv cB wcel wn wa vx wex vx cF ccnv wfun vx ax-17 vx cv vy cv cF
      wbr vx cv cB wcel wn wa vx hbe1 hban cF ccnv wfun vx cv vy cv cF wbr vx
      cv cB wcel wn wa vx wex wa vx cv cB wcel vx cv vy cv cF wbr wn wi vx cv
      cB wcel vx cv vy cv cF wbr wa wn cF ccnv wfun vx cv vy cv cF wbr vx cv cB
      wcel wn wa vx wex wa vx cv vy cv cF wbr vx cv cB wcel vx cv vy cv cF wbr
      vx wmo vx cv vy cv cF wbr vx cv cB wcel wn wa vx wex vx cv vy cv cF wbr
      vx cv cB wcel wn wi cF ccnv wfun vx cv vy cv cF wbr vx cv cB wcel wn vx
      mopick cF ccnv wfun vy cv vx cv cF ccnv wbr vx wmo vx cv vy cv cF wbr vx
      wmo vy vx cF ccnv funmo vy cv vx cv cF ccnv wbr vx cv vy cv cF wbr vx vy
      cv vx cv cF vy visset vx visset brcnv mobii sylib sylan con2d vx cv cB
      wcel vx cv vy cv cF wbr imnan sylib 19.21ai ex vx cv vy cv cF wbr vx cv
      cB wcel wn vx exancom vx cv cB wcel vx cv vy cv cF wbr wa vx alnex
      3imtr3g anim2d vx cv cA wcel vx cv cB wcel wn wa vx cv vy cv cF wbr wa vx
      wex vx cv cA wcel vx cv vy cv cF wbr wa vx cv cB wcel wn vx cv vy cv cF
      wbr wa wa vx wex vx cv cA wcel vx cv vy cv cF wbr wa vx wex vx cv cB wcel
      wn vx cv vy cv cF wbr wa vx wex wa vx cv cA wcel vx cv cB wcel wn wa vx
      cv vy cv cF wbr wa vx cv cA wcel vx cv vy cv cF wbr wa vx cv cB wcel wn
      vx cv vy cv cF wbr wa wa vx vx cv cA wcel vx cv cB wcel wn vx cv vy cv cF
      wbr anandir exbii vx cv cA wcel vx cv vy cv cF wbr wa vx cv cB wcel wn vx
      cv vy cv cF wbr wa vx 19.40 sylbi syl5 vx cv cA wcel vx cv vy cv cF wbr
      wa vx wex vx cv cB wcel vx cv vy cv cF wbr wa vx wex wn wa vx cv cA wcel
      vx cv vy cv cF wbr wa vx cv cB wcel vx cv vy cv cF wbr wa wn wa vx wex vx
      cv cA wcel vx cv cB wcel wn wa vx cv vy cv cF wbr wa vx wex vx cv cA wcel
      vx cv vy cv cF wbr wa vx wex vx cv cB wcel vx cv vy cv cF wbr wa wn vx
      wal vx cv cA wcel vx cv vy cv cF wbr wa vx cv cB wcel vx cv vy cv cF wbr
      wa wn wa vx wex vx cv cB wcel vx cv vy cv cF wbr wa vx wex wn vx cv cA
      wcel vx cv vy cv cF wbr wa vx cv cB wcel vx cv vy cv cF wbr wa wn vx
      19.29r vx cv cB wcel vx cv vy cv cF wbr wa vx alnex sylan2br vx cv cA
      wcel vx cv vy cv cF wbr wa vx cv cB wcel vx cv vy cv cF wbr wa wn wa vx
      cv cA wcel vx cv cB wcel wn wa vx cv vy cv cF wbr wa vx vx cv cA wcel vx
      cv vy cv cF wbr wa vx cv cB wcel wn vx cv vy cv cF wbr wn wo wa vx cv cA
      wcel vx cv vy cv cF wbr wa vx cv cB wcel wn wa vx cv cA wcel vx cv vy cv
      cF wbr wa vx cv vy cv cF wbr wn wa wo vx cv cA wcel vx cv vy cv cF wbr wa
      vx cv cB wcel vx cv vy cv cF wbr wa wn wa vx cv cA wcel vx cv cB wcel wn
      wa vx cv vy cv cF wbr wa vx cv cA wcel vx cv vy cv cF wbr wa vx cv cB
      wcel wn vx cv vy cv cF wbr wn andi vx cv cB wcel vx cv vy cv cF wbr wa wn
      vx cv cB wcel wn vx cv vy cv cF wbr wn wo vx cv cA wcel vx cv vy cv cF
      wbr wa vx cv cB wcel vx cv vy cv cF wbr ianor anbi2i vx cv cA wcel vx cv
      cB wcel wn wa vx cv vy cv cF wbr wa vx cv cA wcel vx cv vy cv cF wbr wa
      vx cv cB wcel wn wa vx cv cA wcel vx cv vy cv cF wbr wa vx cv cB wcel wn
      wa vx cv cA wcel vx cv vy cv cF wbr wa vx cv vy cv cF wbr wn wa wo vx cv
      cA wcel vx cv cB wcel wn vx cv vy cv cF wbr an23 vx cv cA wcel vx cv vy
      cv cF wbr wa vx cv vy cv cF wbr wn wa vx cv cA wcel vx cv vy cv cF wbr wa
      vx cv cB wcel wn wa vx cv cA wcel vx cv vy cv cF wbr wa vx cv vy cv cF
      wbr wn wa vx cv cA wcel vx cv vy cv cF wbr vx cv vy cv cF wbr wn wa wa vx
      cv vy cv cF wbr vx cv vy cv cF wbr wn wa vx cv cA wcel vx cv vy cv cF wbr
      pm3.24 intnan vx cv cA wcel vx cv vy cv cF wbr vx cv vy cv cF wbr wn
      anass mtbir biorfi bitri 3bitr4i exbii sylib impbid1 vx cv cA cB cdif
      wcel vx cv vy cv cF wbr wa vx cv cA wcel vx cv cB wcel wn wa vx cv vy cv
      cF wbr wa vx vx cv cA cB cdif wcel vx cv cA wcel vx cv cB wcel wn wa vx
      cv vy cv cF wbr vx cv cA cB eldif anbi1i exbii vy cv cF cA cima wcel vx
      cv cA wcel vx cv vy cv cF wbr wa vx wex vy cv cF cB cima wcel wn vx cv cB
      wcel vx cv vy cv cF wbr wa vx wex wn vx vy cv cF cA vy visset elima2 vy
      cv cF cB cima wcel vx cv cB wcel vx cv vy cv cF wbr wa vx wex vx vy cv cF
      cB vy visset elima2 notbii anbi12i 3bitr4g vx vy cv cF cA cB cdif vy
      visset elima2 vy cv cF cA cima cF cB cima eldif 3bitr4g eqrdv $.
      $( [24-May-1998] $)
  $}

  $( The image of an intersection is the intersection of images.  (Contributed
     by Paul Chapman, 11-Apr-2009.) $)
  imain $p |- ( Fun `' F ->
                ( F " ( A i^i B ) ) = ( ( F " A ) i^i ( F " B ) ) ) $=
    cF ccnv wfun cF cA cA cB cdif cdif cima cF cA cima cF cA cima cF cB cima
    cdif cdif cF cA cB cin cima cF cA cima cF cB cima cin cF ccnv wfun cF cA cA
    cB cdif cdif cima cF cA cima cF cA cB cdif cima cdif cF cA cima cF cA cima
    cF cB cima cdif cdif cA cA cB cdif cF imadif cF ccnv wfun cF cA cB cdif
    cima cF cA cima cF cB cima cdif cF cA cima cA cB cF imadif difeq2d eqtrd cA
    cB cin cA cA cB cdif cdif cF cA cB dfin4 imaeq2i cF cA cima cF cB cima
    dfin4 3eqtr4g $.
    $( [14-Apr-2009] $) $( [11-Apr-2009] $)

  ${
    $d w B $.  $d x y z w A $.
    $( Axiom of Replacement using abbreviations.  Axiom 39(vi) of [Quine]
       p. 284.  Compare Exercise 9 of [TakeutiZaring] p. 29. $)
    funimaexg $p |- ( ( Fun A /\ B e. C ) -> ( A " B ) e. _V ) $=
      cB cC wcel cA wfun cA cB cima cvv wcel cA wfun cA vw cv cima cvv wcel wi
      cA wfun cA cB cima cvv wcel wi vw cB cC vw cv cB wceq cA vw cv cima cvv
      wcel cA cB cima cvv wcel cA wfun vw cv cB wceq cA vw cv cima cA cB cima
      cvv vw cv cB cA imaeq2 eleq1d imbi2d cA wfun vx cv vy cv cop cA wcel vy
      cv vz cv wceq wi vy wal vz wex vx wal cA vw cv cima cvv wcel cA wfun cA
      wrel vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy wal vz wex vx wal vx
      vy vz cA dffun5 pm3.27bi vx cv vy cv cop cA wcel vy cv vz cv wceq wi vy
      wal vz wex vx wal vy cv vz cv wcel vx cv vw cv wcel vx cv vy cv cop cA
      wcel wa vx wex wb vy wal vz wex cA vw cv cima cvv wcel vx cv vy cv cop cA
      wcel vx vy vz vw vx cv vy cv cop cA wcel vz ax-17 axrep4 cA vw cv cima
      cvv wcel vz cv cA vw cv cima wceq vz wex vy cv vz cv wcel vx cv vw cv
      wcel vx cv vy cv cop cA wcel wa vx wex wb vy wal vz wex vz cA vw cv cima
      isset vz cv cA vw cv cima wceq vy cv vz cv wcel vx cv vw cv wcel vx cv vy
      cv cop cA wcel wa vx wex wb vy wal vz vz cv cA vw cv cima wceq vz cv vx
      cv vw cv wcel vx cv vy cv cop cA wcel wa vx wex vy cab wceq vy cv vz cv
      wcel vx cv vw cv wcel vx cv vy cv cop cA wcel wa vx wex wb vy wal cA vw
      cv cima vx cv vw cv wcel vx cv vy cv cop cA wcel wa vx wex vy cab vz cv
      vx vy cA vw cv dfima3 eqeq2i vx cv vw cv wcel vx cv vy cv cop cA wcel wa
      vx wex vy vz cv abeq2 bitri exbii bitri sylibr syl vtoclg impcom $.
      $( [11-Sep-2006] $) $( [10-Sep-2006] $)
  $}

  ${
    zfrep5.1 $e |- B e. _V $.
    $( The image of a set under any function is also a set.  Equivalent of
       Axiom of Replacement ~ ax-rep .  Axiom 39(vi) of [Quine] p. 284.
       Compare Exercise 9 of [TakeutiZaring] p. 29. $)
    funimaex $p |- ( Fun A -> ( A " B ) e. _V ) $=
      cA wfun cB cvv wcel cA cB cima cvv wcel zfrep5.1 cA cB cvv funimaexg
      mpan2 $.
      $( [17-Nov-2002] $)
  $}

  ${
    $d x z A $.  $d b x y z $.  $d z ph $.
    $( Part of a study of the Axiom of Replacement used by the Isabelle prover.
       The object PrimReplace is apparently the  image of the function encoded
       by ` ph ( x , y ) ` i.e. the class ` ( { <. x , y >. | ph } " A ) ` .
       If so, we can prove Isabelle's "Axiom of Replacement" conclusion without
       using the Axiom of Replacement, for which I (N. Megill) currently have
       no explanation. $)
    isarep1 $p |- ( b e. ( { <. x , y >. | ph } " A ) <->
                 E. x e. A [ b / y ] ph ) $=
      vb cv wph vx vy copab cA cima wcel vz cv vb cv wph vx vy copab wbr vz cA
      wrex wph vx vz cv wsbc vy vb cv wsbc vz cA wrex wph vy vb cv wsbc vx cA
      wrex vz vb cv wph vx vy copab cA vb visset elima vz cv vb cv wph vx vy
      copab wbr wph vx vz cv wsbc vy vb cv wsbc vz cA vz cv vb cv wph vx vy
      copab wbr vz cv vb cv cop wph vx vy copab wcel wph vx vz cv wsbc vy vb cv
      wsbc vz cv vb cv wph vx vy copab df-br wph vx vy vz vb opelopabsb bitri
      rexbii wph vx vz cv wsbc vy vb cv wsbc wph vy vb cv wsbc vz vx cA wph vx
      vz cv wsbc vy vb vx wph vx vz hbs1 hbsb wph vy vb cv wsbc vz ax-17 vz cv
      vx cv wceq vb cv cvv wcel wph vx vz cv wsbc vy vb cv wsbc wph vy vb cv
      wsbc wb vb visset vz cv vx cv wceq wph vx vz cv wsbc wph vy vb cv cvv wph
      vz vx sbequ12r sbcbidv mpan2 cbvrex 3bitri $.
      $( [26-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  ${
    $d w x y A $.  $d b x y $.  $d y z $.  $d w ph $.  $d z ph $.
    isarep2.1 $e |- A e. _V $.
    isarep2.2 $e |- A. x e. A A. y A. z ( ( ph /\ [ z / y ] ph ) -> y = z ) $.
    $( Part of a study of the Axiom of Replacement used by the Isabelle prover.
       In Isabelle, the sethood of PrimReplace is apparently postulated
       implicitly by its type signature " ` [ ` i, ` [ ` i, i ` ] ` => o ` ] `
       => i", which automatically asserts that it is a set without using any
       axioms.  To prove that it is a set in Metamath, we need the hypotheses
       of Isabelle's "Axiom of Replacement" as well as the Axiom of Replacement
       in the form ~ funimaex . $)
    isarep2 $p |- E. w w = ( { <. x , y >. | ph } " A ) $=
      wph vx vy copab cA cima cvv wcel vw cv wph vx vy copab cA cima wceq vw
      wex wph vx vy copab cA cima vx cv cA wcel wph wa vx vy copab cA cima cvv
      wph vx vy copab cA cres cA cima wph vx vy copab cA cima vx cv cA wcel wph
      wa vx vy copab cA cima wph vx vy copab cA resima wph vx vy copab cA cres
      vx cv cA wcel wph wa vx vy copab cA wph vx vy cA resopab imaeq1i eqtr3i
      vx cv cA wcel wph wa vx vy copab wfun vx cv cA wcel wph wa vx vy copab cA
      cima cvv wcel vx cv cA wcel wph wa vx vy copab wfun vx cv cA wcel wph wa
      vy wmo vx vx cv cA wcel wph wa vx vy funopab vx cv cA wcel wph wa vy wmo
      vx cv cA wcel wph vy wmo wi vx cv cA wcel wph wph vy vz cv wsbc wa vy cv
      vz cv wceq wi vz wal vy wal wph vy wmo wph wph vy vz cv wsbc wa vy cv vz
      cv wceq wi vz wal vy wal vx cA isarep2.2 rspec wph vy vz wph vz ax-17 mo3
      sylibr vx cv cA wcel wph vy moanimv mpbir mpgbir vx cv cA wcel wph wa vx
      vy copab cA isarep2.1 funimaex ax-mp eqeltri vw wph vx vy copab cA cima
      isset mpbi $.
      $( [26-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  $( The restriction of a function to a set exists.  Compare Proposition
     6.17 of [TakeutiZaring] p. 28. $)
  resfunexg $p |- ( ( Fun A /\ B e. C ) -> ( A |` B ) e. _V ) $=
    cA wfun cB cC wcel wa cA cB cres cdm cvv wcel cA cB cres crn cvv wcel wa cA
    cB cres cdm cA cB cres crn cxp cvv wcel cA cB cres cvv wcel cA wfun cB cC
    wcel wa cA cB cres cdm cvv wcel cA cB cres crn cvv wcel cB cC wcel cA cB
    cres cdm cvv wcel cA wfun cA cB cC dmresexg adantl cA wfun cB cC wcel wa cA
    cB cima cvv cA cB cres crn cA cB cC funimaexg cA cB df-ima syl5eqelr jca cA
    cB cres cdm cA cB cres crn cvv cvv xpexg cA cB cres cA cB cres cdm cA cB
    cres crn cxp wss cA cB cres cdm cA cB cres crn cxp cvv wcel cA cB cres cvv
    wcel cA cB cres wrel cA cB cres cA cB cres cdm cA cB cres crn cxp wss cA cB
    relres cA cB cres relssdmrn ax-mp cA cB cres cA cB cres cdm cA cB cres crn
    cxp cvv ssexg mpan 3syl $.
    $( [12-Sep-2006] $) $( [7-Apr-1995] $)

  $( Existence of a composition when the first member is a function. $)
  cofunexg $p |- ( ( Fun A /\ B e. C ) -> ( A o. B ) e. _V ) $=
    cA cB ccom cA cB ccom cdm cA cB ccom crn cxp wss cA cB ccom cdm cA cB ccom
    crn cxp cvv wcel cA cB ccom cvv wcel cA wfun cB cC wcel wa cA cB ccom cA cB
    ccom cdm cA cB ccom crn cxp cvv ssexg cA cB ccom wrel cA cB ccom cA cB ccom
    cdm cA cB ccom crn cxp wss cA cB relco cA cB ccom relssdmrn ax-mp cA cB
    ccom cdm cvv wcel cA cB ccom crn cvv wcel cA cB ccom cdm cA cB ccom crn cxp
    cvv wcel cA wfun cB cC wcel wa cA cB ccom cdm cA cB ccom crn cvv cvv xpexg
    cB cC wcel cA cB ccom cdm cvv wcel cA wfun cA cB ccom cdm cB cdm wss cB cdm
    cvv wcel cA cB ccom cdm cvv wcel cB cC wcel cA cB ccom cdm cB cdm cvv ssexg
    cA cB dmcoss cB cC dmexg sylancr adantl cA wfun cB cC wcel wa cA cB crn
    cres crn cvv cA cB ccom crn cA wfun cB cC wcel wa cA cB crn cres cvv wcel
    cA cB crn cres crn cvv wcel cA wfun cB crn cvv wcel cA cB crn cres cvv wcel
    cB cC wcel cA cB crn cvv resfunexg cB cC rnexg sylan2 cA cB crn cres cvv
    rnexg syl cA cB rnco syl5eqel sylanc sylancr $.
    $( [9-Oct-2007] $) $( [8-Oct-2007] $)

  $( Existence of a composition when the second member is one-to-one. $)
  cofunex2g $p |- ( ( A e. C /\ Fun `' B ) -> ( A o. B ) e. _V ) $=
    cB ccnv wfun cA cC wcel cA cB ccom cvv wcel cB ccnv wfun cA cC wcel wa cB
    ccnv cA ccnv ccom cvv wcel cA cB ccom cvv wcel cB ccnv wfun cA ccnv cvv
    wcel cB ccnv cA ccnv ccom cvv wcel cA cC wcel cB ccnv cA ccnv cvv cofunexg
    cA cC cnvexg sylan2 cB ccnv cA ccnv ccom cvv wcel cB ccnv cA ccnv ccom ccnv
    cvv cA cB ccom cB ccnv cA ccnv ccom cvv cnvexg cB ccnv cA ccnv ccom ccnv cA
    ccnv ccnv cB ccnv ccnv ccom cA ccnv ccnv cB ccom cA cB ccom cB ccnv cA ccnv
    cnvco cA ccnv ccnv cB cocnvcnv2 cA cB cocnvcnv1 3eqtrri syl5eqel syl ancoms
    $.
    $( [21-Dec-2007] $) $( [8-Oct-2007] $)

  $( Equality theorem for function predicate with domain. $)
  fneq1 $p |- ( F = G -> ( F Fn A <-> G Fn A ) ) $=
    cF cG wceq cF wfun cF cdm cA wceq wa cG wfun cG cdm cA wceq wa cF cA wfn cG
    cA wfn cF cG wceq cF wfun cG wfun cF cdm cA wceq cG cdm cA wceq cF cG funeq
    cF cG wceq cF cdm cG cdm cA cF cG dmeq eqeq1d anbi12d cF cA df-fn cG cA
    df-fn 3bitr4g $.
    $( [1-Aug-1994] $)

  $( Equality theorem for function predicate with domain. $)
  fneq2 $p |- ( A = B -> ( F Fn A <-> F Fn B ) ) $=
    cA cB wceq cF wfun cF cdm cA wceq wa cF wfun cF cdm cB wceq wa cF cA wfn cF
    cB wfn cA cB wceq cF cdm cA wceq cF cdm cB wceq cF wfun cA cB cF cdm eqeq2
    anbi2d cF cA df-fn cF cB df-fn 3bitr4g $.
    $( [1-Aug-1994] $)

  ${
    $d y F $.  $d y A $.  $d x y $.
    hbfn.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbfn.2 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for a function with domain. $)
    hbfn $p |- ( F Fn A -> A. x F Fn A ) $=
      cF wfun cF cdm cA wceq wa cF wfun cF cdm cA wceq wa vx wal cF cA wfn cF
      cA wfn vx wal cF wfun cF cdm cA wceq vx vx vy cF hbfn.1 hbfun vx vy vy cF
      cdm cA vx vy cF hbfn.1 hbdm hbfn.2 hbeq hban cF cA df-fn cF cA wfn cF
      wfun cF cdm cA wceq wa vx cF cA df-fn albii 3imtr4i $.
      $( [31-Jan-2004] $) $( [30-Jan-2004] $)
  $}

  $( A function with domain is a function. $)
  fnfun $p |- ( F Fn A -> Fun F ) $=
    cF cA wfn cF wfun cF cdm cA wceq cF cA df-fn pm3.26bi $.
    $( [1-Aug-1994] $)

  $( A function with domain is a relation. $)
  fnrel $p |- ( F Fn A -> Rel F ) $=
    cF cA wfn cF wfun cF wrel cA cF fnfun cF funrel syl $.
    $( [1-Aug-1994] $)

  $( The domain of a function. $)
  fndm $p |- ( F Fn A -> dom F = A ) $=
    cF cA wfn cF wfun cF cdm cA wceq cF cA df-fn pm3.27bi $.
    $( [2-Aug-1994] $)

  ${
    funfni.1 $e |- ( ( Fun F /\ B e. dom F ) -> ph ) $.
    $( Inference to convert a function and domain antecedent. $)
    funfni $p |- ( ( F Fn A /\ B e. A ) -> ph ) $=
      cF wfun cB cF cdm wcel wph cF cA wfn cB cA wcel wa funfni.1 cF cA wfn cF
      wfun cB cA wcel cA cF fnfun adantr cF cA wfn cB cF cdm wcel cB cA wcel cF
      cA wfn cF cdm cA cB cA cF fndm eleq2d biimpar sylanc $.
      $( [25-Apr-2004] $) $( [22-Apr-2004] $)
  $}

  $( A function has a unique domain. $)
  fndmu $p |- ( ( F Fn A /\ F Fn B ) -> A = B ) $=
    cF cA wfn cF cB wfn cA cF cdm cB cA cF fndm cB cF fndm sylan9req $.
    $( [11-Aug-1994] $)

  $( The first argument of binary relation on a function belongs to the
     function's domain. $)
  fnbr $p |- ( ( F Fn A /\ B F C ) -> B e. A ) $=
    cF cA wfn cB cC cF wbr cB cF cdm wcel cB cA wcel cF cA wfn cB cC cF wbr cB
    cvv wcel cB cF cdm wcel cF wrel cB cC cF wbr cB cvv wcel cF cA wfn cB cC cF
    brrelex cA cF fnrel sylan cB cC cvv cF breldmg sylancom cF cA wfn cB cF cdm
    wcel cB cA wcel cF cA wfn cF cdm cA cB cA cF fndm eleq2d biimpa syldan $.
    $( [24-Mar-2007] $) $( [7-May-2004] $)

  $( The first argument of an ordered pair in a function belongs to the
     function's domain. $)
  fnop $p |- ( ( F Fn A /\ <. B , C >. e. F ) -> B e. A ) $=
    cF cA wfn cB cC cF wbr cB cA wcel cB cC cop cF wcel cA cB cC cF fnbr cB cC
    cF df-br sylan2br $.
    $( [25-Mar-2007] $) $( [8-Aug-1994] $)

  ${
    $d x y F $.  $d x y B $.  $d x A $.
    $( There is exactly one value of a function. $)
    fneu $p |- ( ( F Fn A /\ B e. A ) -> E! y B F y ) $=
      cF cA wfn cB cA wcel cB vy cv cF wbr vy weu cF cA wfn vx cv cA wcel wa vx
      cv vy cv cF wbr vy weu wi cF cA wfn cB cA wcel wa cB vy cv cF wbr vy weu
      wi vx cB cA vx cv cB wceq cF cA wfn vx cv cA wcel wa cF cA wfn cB cA wcel
      wa vx cv vy cv cF wbr vy weu cB vy cv cF wbr vy weu vx cv cB wceq vx cv
      cA wcel cB cA wcel cF cA wfn vx cv cB cA eleq1 anbi2d vx cv cB wceq vx cv
      vy cv cF wbr cB vy cv cF wbr vy vx cv cB vy cv cF breq1 eubidv imbi12d cF
      cA wfn vx cv cA wcel vx cv vy cv cF wbr vy weu vx cv cA wcel cF cA wfn vx
      cv vy cv cF wbr vy weu cF cA wfn vx cv cA wcel vx cv vy cv cF wbr vy wex
      cF cA wfn vx cv vy cv cF wbr vy weu wi cF cA wfn vx cv cF cdm wcel vx cv
      cA wcel vx cv vy cv cF wbr vy wex cF cA wfn cF cdm cA vx cv cA cF fndm
      eleq2d vy vx cv cF vx visset eldm syl5bbr vx cv vy cv cF wbr vy wex cF
      wfun vx cv vy cv cF wbr vy weu cF cA wfn vx cv vy cv cF wbr cF wfun vx cv
      vy cv cF wbr vy weu wi vy cF wfun vx cv vy cv cF wbr vy weu vy cF wfun vy
      ax-17 vx cv vy cv cF wbr vy hbeu1 hbim cF wfun vx cv vy cv cF wbr vx cv
      vy cv cF wbr vy weu vx vy cF funeu expcom 19.23ai cA cF fnfun syl5
      syl6bir pm2.43a imp vtoclg anabsi7 $.
      $( [24-Apr-2004] $) $( [22-Apr-2004] $)

    $( There is exactly one value of a function. $)
    fneu2 $p |- ( ( F Fn A /\ B e. A ) -> E! y <. B , y >. e. F ) $=
      cF cA wfn cB cA wcel wa cB vy cv cF wbr vy weu cB vy cv cop cF wcel vy
      weu vy cA cB cF fneu cB vy cv cF wbr cB vy cv cop cF wcel vy cB vy cv cF
      df-br eubii sylib $.
      $( [7-Nov-1995] $)
  $}

  $( The union of two functions with disjoint domains. $)
  fnun $p |- ( ( ( F Fn A /\ G Fn B ) /\ ( A i^i B ) = (/) ) ->
             ( F u. G ) Fn ( A u. B ) ) $=
    cF cA wfn cG cB wfn wa cA cB cin c0 wceq cF cG cun cA cB cun wfn cF wfun cF
    cdm cA wceq wa cG wfun cG cdm cB wceq wa cA cB cin c0 wceq cF cG cun cA cB
    cun wfn wi cF cA wfn cG cB wfn cF wfun cG wfun cF cdm cA wceq cG cdm cB
    wceq cA cB cin c0 wceq cF cG cun cA cB cun wfn wi cF cdm cA wceq cG cdm cB
    wceq wa cF wfun cG wfun wa cA cB cin c0 wceq cF cG cun cA cB cun wfn wi cF
    cdm cA wceq cG cdm cB wceq wa cF wfun cG wfun wa cA cB cin c0 wceq cF cG
    cun cA cB cun wfn cF cdm cA wceq cG cdm cB wceq wa cF wfun cG wfun wa cA cB
    cin c0 wceq wa cF cG cun wfun cF cG cun cdm cA cB cun wceq wa cF cG cun cA
    cB cun wfn cF cdm cA wceq cG cdm cB wceq wa cF wfun cG wfun wa cA cB cin c0
    wceq wa cF cG cun wfun cF cG cun cdm cA cB cun wceq cF cdm cA wceq cG cdm
    cB wceq wa cF wfun cG wfun wa cA cB cin c0 wceq wa cF wfun cG wfun wa cF
    cdm cG cdm cin c0 wceq wa cF cG cun wfun cF cdm cA wceq cG cdm cB wceq wa
    cF cdm cG cdm cin c0 wceq cA cB cin c0 wceq cF wfun cG wfun wa cF cdm cA
    wceq cG cdm cB wceq wa cF cdm cG cdm cin cA cB cin c0 cF cdm cA cG cdm cB
    ineq12 eqeq1d anbi2d cF cG funun syl6bir cF cdm cA wceq cG cdm cB wceq wa
    cF cdm cG cdm cun cA cB cun cF cG cun cdm cF cdm cA cG cdm cB uneq12 cF cG
    dmun syl5eq jctird cF cG cun cA cB cun df-fn syl6ibr exp3a impcom an4s cF
    cA df-fn cG cB df-fn syl2anb imp $.
    $( [23-Sep-2004] $) $( [22-Sep-2004] $)

  $( Composition of two functions. $)
  fnco $p |- ( ( F Fn A /\ G Fn B /\ ran G C_ A ) -> ( F o. G ) Fn B ) $=
    cF cG ccom cB wfn cF cG ccom wfun cF cG ccom cdm cB wceq cF cA wfn cG cB
    wfn cG crn cA wss w3a cF cG ccom cB df-fn cF cA wfn cG cB wfn cF cG ccom
    wfun cG crn cA wss cF wfun cG wfun cF cG ccom wfun cF cA wfn cG cB wfn cF
    cG funco cA cF fnfun cB cG fnfun syl2an 3adant3 cF cA wfn cG cB wfn cG crn
    cA wss w3a cF cG ccom cdm cG cdm cB cF cA wfn cG crn cA wss cF cG ccom cdm
    cG cdm wceq cG cB wfn cF cA wfn cG crn cA wss wa cG crn cF cdm wss cF cG
    ccom cdm cG cdm wceq cF cA wfn cG crn cF cdm wss cG crn cA wss cF cA wfn cF
    cdm cA cG crn cA cF fndm sseq2d biimpar cF cG dmcosseq syl 3adant2 cG cB
    wfn cF cA wfn cG cdm cB wceq cG crn cA wss cB cG fndm 3ad2ant2 eqtrd
    sylanbrc $.
    $( [22-May-2006] $) $( [22-May-2006] $)

  $( A function does not change when restricted to its domain. $)
  fnresdm $p |- ( F Fn A -> ( F |` A ) = F ) $=
    cF wrel cF cdm cA wss cF cA cres cF wceq cF cA wfn cF cA relssres cA cF
    fnrel cF cA wfn cF cdm cA wceq cF cdm cA wss cA cF fndm cF cdm cA eqimss
    syl sylanc $.
    $( [7-Sep-2004] $) $( [5-Sep-2004] $)

  $( A function restricted to a class disjoint with its domain is empty. $)
  fnresdisj $p |- ( F Fn A -> ( ( A i^i B ) = (/) <-> ( F |` B ) = (/) ) ) $=
    cF cA wfn cF cB cres cdm c0 wceq cA cB cin c0 wceq cF cB cres c0 wceq cF cA
    wfn cF cB cres cdm cA cB cin c0 cF cA wfn cF cdm cB cin cA cB cin cF cB
    cres cdm cF cA wfn cF cdm cA cB cA cF fndm ineq1d cF cB cres cdm cB cF cdm
    cin cF cdm cB cin cF cB dmres cB cF cdm incom eqtri syl5eq eqeq1d cF cB
    cres wrel cF cB cres c0 wceq cF cB cres cdm c0 wceq wb cF cB relres cF cB
    cres reldm0 ax-mp syl5rbb $.
    $( [17-Oct-2004] $) $( [23-Sep-2004] $)

  $( Membership in two functions restricted by each other's domain. $)
  2elresin $p |- ( ( F Fn A /\ G Fn B ) ->
                 ( ( <. x , y >. e. F /\ <. x , z >. e. G ) <->
                   ( <. x , y >. e. ( F |` ( A i^i B ) ) /\
                     <. x , z >. e. ( G |` ( A i^i B ) ) ) ) ) $=
    cF cA wfn cG cB wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa
    vx cv vy cv cop cF cA cB cin cres wcel vx cv vz cv cop cG cA cB cin cres
    wcel wa cF cA wfn cG cB wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG
    wcel wa vx cv vy cv cop cF cA cB cin cres wcel vx cv vz cv cop cG cA cB cin
    cres wcel wa cF cA wfn cG cB wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop
    cG wcel wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa vx cv vy cv
    cop cF cA cB cin cres wcel vx cv vz cv cop cG cA cB cin cres wcel wa wi cF
    cA wfn cG cB wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa wa
    vx cv cA cB cin wcel vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa vx
    cv vy cv cop cF cA cB cin cres wcel vx cv vz cv cop cG cA cB cin cres wcel
    wa wi cF cA wfn vx cv vy cv cop cF wcel wa cG cB wfn vx cv vz cv cop cG
    wcel wa wa vx cv cA wcel vx cv cB wcel wa cF cA wfn cG cB wfn wa vx cv vy
    cv cop cF wcel vx cv vz cv cop cG wcel wa wa vx cv cA cB cin wcel cF cA wfn
    vx cv vy cv cop cF wcel wa vx cv cA wcel cG cB wfn vx cv vz cv cop cG wcel
    wa vx cv cB wcel cA vx cv vy cv cF fnop cB vx cv vz cv cG fnop anim12i cF
    cA wfn cG cB wfn vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel an4 vx cv
    cA cB elin 3imtr4i vx cv cA cB cin wcel vx cv vy cv cop cF cA cB cin cres
    wcel vx cv vz cv cop cG cA cB cin cres wcel wa vx cv vy cv cop cF wcel vx
    cv vz cv cop cG wcel wa vx cv cA cB cin wcel vx cv vy cv cop cF cA cB cin
    cres wcel vx cv vy cv cop cF wcel vx cv vz cv cop cG cA cB cin cres wcel vx
    cv vz cv cop cG wcel vx cv vy cv cF cA cB cin vy visset opres vx cv vz cv
    cG cA cB cin vz visset opres anbi12d biimprd syl ex pm2.43d vx cv vy cv cop
    cF cA cB cin cres wcel vx cv vy cv cop cF wcel vx cv vz cv cop cG cA cB cin
    cres wcel vx cv vz cv cop cG wcel cF cA cB cin cres cF vx cv vy cv cop cF
    cA cB cin resss sseli cG cA cB cin cres cG vx cv vz cv cop cG cA cB cin
    resss sseli anim12i impbid1 $.
    $( [8-Aug-1994] $)

  $( Restriction of a function with a subclass of its domain. $)
  fnssresb $p |- ( F Fn A -> ( ( F |` B ) Fn B <-> B C_ A ) ) $=
    cF cA wfn cF cB cres wfun cF cB cres cdm cB wceq wa cB cA wss cF cB cres cB
    wfn cF cA wfn cF cB cres cdm cB wceq cF cB cres wfun cF cB cres cdm cB wceq
    wa cB cA wss cF cA wfn cF cB cres wfun cF cB cres cdm cB wceq cF cA wfn cF
    wfun cF cB cres wfun cA cF fnfun cB cF funres syl biantrurd cF cA wfn cB cF
    cdm wss cB cA wss cF cB cres cdm cB wceq cF cA wfn cF cdm cA cB cA cF fndm
    sseq2d cB cF ssdmres syl5bbr bitr3d cF cB cres cB df-fn syl5bb $.
    $( [10-Oct-2007] $) $( [10-Oct-2007] $)

  $( Restriction of a function with a subclass of its domain. $)
  fnssres $p |- ( ( F Fn A /\ B C_ A ) -> ( F |` B ) Fn B ) $=
    cF cA wfn cF cB cres cB wfn cB cA wss cA cB cF fnssresb biimpar $.
    $( [25-Sep-2004] $) $( [2-Aug-1994] $)

  $( Restriction of a function's domain with an intersection. $)
  fnresin1 $p |- ( F Fn A -> ( F |` ( A i^i B ) ) Fn ( A i^i B ) ) $=
    cF cA wfn cA cB cin cA wss cF cA cB cin cres cA cB cin wfn cA cB inss1 cA
    cA cB cin cF fnssres mpan2 $.
    $( [9-Aug-1994] $)

  $( Restriction of a function's domain with an intersection. $)
  fnresin2 $p |- ( F Fn A -> ( F |` ( B i^i A ) ) Fn ( B i^i A ) ) $=
    cF cA wfn cB cA cin cA wss cF cB cA cin cres cB cA cin wfn cB cA inss2 cA
    cB cA cin cF fnssres mpan2 $.
    $( [9-Aug-1994] $)

  $( Functionality and domain of restricted identity. $)
  fnresi $p |- ( _I |` A ) Fn A $=
    cid cA cres cA wfn cid cA cres wfun cid cA cres cdm cA wceq cid cA cres cA
    df-fn cid wfun cid cA cres wfun funi cA cid funres ax-mp cA dmresi mpbir2an
    $.
    $( [28-Aug-2004] $) $( [27-Aug-2004] $)

  $( The image of a function's domain is its range. $)
  fnima $p |- ( F Fn A -> ( F " A ) = ran F ) $=
    cF cA wfn cF cdm cA wceq cF cA cima cF crn wceq cA cF fndm cF cdm cA wceq
    cF cF cdm cima cF cA cima cF crn cF cdm cA cF imaeq2 cF imadmrn syl5reqr
    syl $.
    $( [6-Nov-2004] $) $( [4-Nov-2004] $)

  ${
    $d x y F $.
    $( A function with empty domain is empty. $)
    fn0 $p |- ( F Fn (/) <-> F = (/) ) $=
      cF c0 wfn cF c0 wceq cF c0 wfn cF c0 wceq vx cv vy cv cop cF wcel vx cv
      vy cv cop c0 wcel wb vy wal vx wal cF c0 wfn vx cv vy cv cop cF wcel vx
      cv vy cv cop c0 wcel wb vx vy cF c0 wfn cF cdm c0 wceq vx cv vy cv cop cF
      wcel wn vx cv vy cv cop c0 wcel wn wa vx cv vy cv cop cF wcel vx cv vy cv
      cop c0 wcel wb c0 cF fndm cF cdm c0 wceq vx cv vy cv cop cF wcel wn vx cv
      vy cv cop c0 wcel wn cF cdm c0 wceq vx cv vy cv cop cF wcel wn vy cF cdm
      c0 wceq vx cv vy cv cop cF wcel vy wex wn vx cv vy cv cop cF wcel wn vy
      wal cF cdm c0 wceq vx cv cF cdm wcel wn vx cv vy cv cop cF wcel vy wex wn
      cF cdm c0 wceq vx cv cF cdm wcel vx cv c0 wcel vx cv noel cF cdm c0 vx cv
      eleq2 mtbiri vx cv cF cdm wcel vx cv vy cv cop cF wcel vy wex vy vx cv cF
      vx visset eldm2 notbii sylib vx cv vy cv cop cF wcel vy alnex sylibr
      19.21bi vx cv vy cv cop noel jctir vx cv vy cv cop cF wcel vx cv vy cv
      cop c0 wcel pm5.21 3syl 19.21aivv cF wrel c0 wrel cF c0 wceq vx cv vy cv
      cop cF wcel vx cv vy cv cop c0 wcel wb vy wal vx wal wb cF c0 wfn vx vy
      cF c0 eqrel c0 cF fnrel rel0 sylancl mpbird cF c0 wceq cF c0 wfn c0 c0
      wfn c0 c0 wfn c0 wfun c0 cdm c0 wceq c0 c0 df-fn fun0 dm0 mpbir2an c0 cF
      c0 fneq1 mpbiri impbii $.
      $( [15-Apr-1998] $)
  $}

  $( A class that is disjoint with the domain of a function has an empty image
     under the function.  (Contributed by FL, 24-Jan-2007.) $)
  funimadisj $p |- ( ( F Fn A /\ ( A i^i C ) = (/) ) -> ( F " C ) = (/) ) $=
    cF cA wfn cA cC cin c0 wceq wa cF cdm cC cin c0 wceq cF cC cima c0 wceq cF
    cA wfn cF cdm cC cin c0 wceq cA cC cin c0 wceq cF cA wfn cF cdm cC cin cA
    cC cin c0 cF cA wfn cF cdm cA cC cA cF fndm ineq1d eqeq1d biimpar cF cC
    imadisj sylibr $.
    $( [25-Jan-2007] $) $( [23-Jan-2007] $)

  $( If the domain of a function is a set, the function is a set.  Theorem
     6.16(1) of [TakeutiZaring] p. 28.  This theorem is derived using the
     Axiom of Replacement in the form of ~ funimaexg . $)
  fnex $p |- ( ( F Fn A /\ A e. B ) -> F e. _V ) $=
    cF cF cdm cF crn cxp wss cF cdm cF crn cxp cvv wcel cF cvv wcel cF cA wfn
    cA cB wcel wa cF cF cdm cF crn cxp cvv ssexg cF cA wfn cF cF cdm cF crn cxp
    wss cA cB wcel cF cA wfn cF wrel cF cF cdm cF crn cxp wss cA cF fnrel cF
    relssdmrn syl adantr cF cdm cB wcel cF crn cvv wcel cF cdm cF crn cxp cvv
    wcel cF cA wfn cA cB wcel wa cF cdm cF crn cB cvv xpexg cF cA wfn cF cdm cB
    wcel cA cB wcel cF cA wfn cF cdm cA cB cA cF fndm eleq1d biimpar cF cA wfn
    cA cB wcel cF cA cima cvv wcel cF crn cvv wcel cF wfun cA cB wcel cF cA
    cima cvv wcel cF cA wfn cF cA cB funimaexg cA cF fnfun sylan cF cA wfn cF
    crn cvv wcel cF cA cima cvv wcel cF cA wfn cF crn cF cA cima cvv cF cA wfn
    cF cF cdm cima cF cA cima cF crn cF cA wfn cF cdm cA cF cA cF fndm imaeq2d
    cF imadmrn syl5eqr eleq1d biimpar syldan sylanc sylanc $.
    $( [11-Sep-2006] $) $( [14-Aug-1994] $)

  $( If the domain of a function exists, so the function.  Part of Theorem
     4.15(v) of [Monk1] p. 46.  This theorem is derived using the Axiom of
     Replacement in the form of ~ fnex .  (Note:  Any resemblance between
     F.U.N.E.X. and "Have You Any Eggs" is purely a coincidence originated by
     Swedish chefs.) $)
  funex $p |- ( ( Fun F /\ dom F e. B ) -> F e. _V ) $=
    cF cF cdm wfn cF cdm cB wcel cF cvv wcel cF wfun cF cdm cB cF fnex cF funfn
    sylanb $.
    $( [9-Sep-2006] $) $( [11-Nov-1995] $)

  ${
    $d x y A $.
    opabex.1 $e |- A e. _V $.
    opabex.2 $e |- ( x e. A -> E* y ph ) $.
    $( Existence of a function expressed as class of ordered pairs. $)
    opabex $p |- { <. x , y >. | ( x e. A /\ ph ) } e. _V $=
      vx cv cA wcel wph wa vx vy copab wfun vx cv cA wcel wph wa vx vy copab
      cdm cvv wcel vx cv cA wcel wph wa vx vy copab cvv wcel vx cv cA wcel wph
      wa vx vy copab wfun vx cv cA wcel wph wa vy wmo vx vx cv cA wcel wph wa
      vx vy funopab vx cv cA wcel wph wa vy wmo vx cv cA wcel wph vy wmo wi
      opabex.2 vx cv cA wcel wph vy moanimv mpbir mpgbir vx cv cA wcel wph wa
      vx vy copab cdm cA opabex.1 wph vx vy cA dmopabss ssexi cvv vx cv cA wcel
      wph wa vx vy copab funex mp2an $.
      $( [21-Jul-1996] $)
  $}

  ${
    $d x y A $.  $d y B $.
    opabex2.1 $e |- A e. _V $.
    $( Existence of a function expressed as class of ordered pairs. $)
    opabex2 $p |- { <. x , y >. | ( x e. A /\ y = B ) } e. _V $=
      vy cv cB wceq vx vy cA opabex2.1 vy cv cB wceq vy wmo vx cv cA wcel vy cB
      moeq a1i opabex $.
      $( [24-Apr-2005] $) $( [22-Apr-2005] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( Existence of a function expressed as class of ordered pairs. $)
    opabex2g $p |- ( A e. C ->
                      { <. x , y >. | ( x e. A /\ y = B ) } e. _V ) $=
      vx cv cA wcel vy cv cB wceq wa vx vy copab wfun vx cv cA wcel vy cv cB
      wceq wa vx vy copab cdm cvv wcel vx cv cA wcel vy cv cB wceq wa vx vy
      copab cvv wcel cA cC wcel cvv vx cv cA wcel vy cv cB wceq wa vx vy copab
      funex vx cv cA wcel vy cv cB wceq wa vx vy copab wfun vx cv cA wcel vy cv
      cB wceq wa vy wmo vx vx cv cA wcel vy cv cB wceq wa vx vy funopab vy cv
      cB wceq vx cv cA wcel vy vy cB moeq moani mpgbir vx cv cA wcel vy cv cB
      wceq wa vx vy copab cdm cA wss cA cC wcel vx cv cA wcel vy cv cB wceq wa
      vx vy copab cdm cvv wcel vy cv cB wceq vx vy cA dmopabss vx cv cA wcel vy
      cv cB wceq wa vx vy copab cdm cA cC ssexg mpan sylancr $.
      $( [12-Sep-2006] $) $( [9-Sep-2006] $)
  $}

  ${
    $d x y A $.  $d y B $.
    fopabex2.1 $e |- A e. _V $.
    fopabex2.3 $e |- F = { <. x , y >. | ( x e. A /\ y = B ) } $.
    $( Existence of a function expressed as class of ordered pairs. $)
    fopabex2 $p |- F e. _V $=
      cF vx cv cA wcel vy cv cB wceq wa vx vy copab cvv fopabex2.3 vx vy cA cB
      fopabex2.1 opabex2 eqeltri $.
      $( [31-Jul-2007] $) $( [30-Jul-2007] $)
  $}

  ${
    $d w x y z A $.  $d w y z B $.
    iunfopab.1 $e |- B e. _V $.
    $( Two ways to express a function as a class of ordered pairs. $)
    iunfopab $p |- U_ x e. A { <. x , B >. }
                    = { <. x , y >. | ( x e. A /\ y = B ) } $=
      vz vw vx cA vx cv cB cop csn ciun vx cv cA wcel vy cv cB wceq wa vx vy
      copab vx cA vx cv cB cop csn ciun wrel vx cv cB cop csn wrel vx cA vx cA
      vx cv cB cop csn reliun vx cv cB cop csn wrel vx cv cA wcel vx cv cB vx
      visset relsn a1i mprgbir vx cv cA wcel vy cv cB wceq wa vx vy relopab vz
      cv vw cv cop vx cv cB cop csn wcel vx cA wrex vz cv cA wcel vw cv vx vz
      cv cB csb wceq wa vz cv vw cv cop vx cA vx cv cB cop csn ciun wcel vz cv
      vw cv cop vx cv cA wcel vy cv cB wceq wa vx vy copab wcel vz cv vw cv cop
      vx cv cB cop csn wcel vx cA wrex vx cv vz cv wceq vw cv cB wceq wa vx cA
      wrex vz cv cA wcel vw cv vx vz cv cB csb wceq wa vz cv vw cv cop vx cv cB
      cop csn wcel vx cv vz cv wceq vw cv cB wceq wa vx cA vz cv vw cv cop vx
      cv cB cop wceq vz cv vx cv wceq vw cv cB wceq wa vz cv vw cv cop vx cv cB
      cop csn wcel vx cv vz cv wceq vw cv cB wceq wa vz cv vw cv vx cv cB vz
      visset vw visset iunfopab.1 opth vz cv vw cv cop vx cv cB cop vz cv vw cv
      opex elsnc vx cv vz cv wceq vz cv vx cv wceq vw cv cB wceq vx cv vz cv
      eqcom anbi1i 3bitr4i rexbii vx cv vz cv wceq vw cv cB wceq wa vx cA wrex
      vx cv cA wcel vx cv vz cv wceq vw cv cB wceq wa wa vx wex vx cv vz cv
      wceq vx cv cA wcel vw cv cB wceq wa wa vx wex vz cv cA wcel vw cv vx vz
      cv cB csb wceq wa vx cv vz cv wceq vw cv cB wceq wa vx cA df-rex vx cv vz
      cv wceq vx cv cA wcel vw cv cB wceq wa wa vx cv cA wcel vx cv vz cv wceq
      vw cv cB wceq wa wa vx vx cv vz cv wceq vx cv cA wcel vw cv cB wceq an12
      exbii vx cv cA wcel vw cv cB wceq wa vz cv cA wcel vw cv vx vz cv cB csb
      wceq wa vx vz vz cv cA wcel vw cv vx vz cv cB csb wceq vx vz cv cA wcel
      vx ax-17 vx vw vx vz cv cB csb vx vw vz cv cB vz visset vw cv vz cv wcel
      vx ax-17 hbcsb1 hbeleq hban vx cv vz cv wceq vx cv cA wcel vz cv cA wcel
      vw cv cB wceq vw cv vx vz cv cB csb wceq vx cv vz cv cA eleq1 vx cv vz cv
      wceq cB vx vz cv cB csb vw cv vx vz cv cB csbeq1a eqeq2d anbi12d equsex
      3bitr2ri bitr4i vx vz cv vw cv cop cA vx cv cB cop csn eliun vx cv cA
      wcel vy cv cB wceq wa vz cv cA wcel vy cv vx vz cv cB csb wceq wa vz cv
      cA wcel vw cv vx vz cv cB csb wceq wa vx vy vz cv vw cv vz cv cA wcel vy
      cv vx vz cv cB csb wceq vx vz cv cA wcel vx ax-17 vx vy vx vz cv cB csb
      vx vy vz cv cB vz visset vy cv vz cv wcel vx ax-17 hbcsb1 hbeleq hban vz
      cv cA wcel vw cv vx vz cv cB csb wceq vy vz cv cA wcel vy ax-17 vw cv vx
      vz cv cB csb wceq vy ax-17 hban vz visset vw visset vx cv vz cv wceq vx
      cv cA wcel vz cv cA wcel vy cv cB wceq vy cv vx vz cv cB csb wceq vx cv
      vz cv cA eleq1 vx cv vz cv wceq cB vx vz cv cB csb vy cv vx vz cv cB
      csbeq1a eqeq2d anbi12d vy cv vw cv wceq vy cv vx vz cv cB csb wceq vw cv
      vx vz cv cB csb wceq vz cv cA wcel vy cv vw cv vx vz cv cB csb eqeq1
      anbi2d opelopabf 3bitr4i eqrelriv $.
      $( [11-Jan-2009] $) $( [19-Dec-2008] $)
  $}

  $( If the domain of a function exists, so does its range.  Part of Theorem
     4.15(v) of [Monk1] p. 46.  This theorem is derived using the Axiom of
     Replacement in the form of ~ funex . $)
  funrnex $p |- ( dom F e. B -> ( Fun F -> ran F e. _V ) ) $=
    cF wfun cF cdm cB wcel cF cvv wcel cF crn cvv wcel cF wfun cF cdm cB wcel
    cF cvv wcel cB cF funex ex cF cvv rnexg syl6com $.
    $( [11-Nov-1995] $)

  ${
    $d ph w v $.  $d x y z w v $.
    $( A version of the Axiom of Replacement.  Normally ` ph ` would have free
       variables ` x ` and ` y ` .  Axiom 6 of [Kunen] p. 12.  The Separation
       Scheme ~ ax-sep cannot be derived from this version and must be stated
       as a separate axiom in an axiom system (such as Kunen's) that uses this
       version in place of our ~ ax-rep . $)
    zfrep6 $p |- ( A. x e. z E! y ph -> E. w A. x e. z E. y e. w ph ) $=
      vx cv vz cv wcel wph wa vx vy copab crn cvv wcel wph vy vx cv vz cv wcel
      wph wa vx vy copab crn wrex vx vz cv wral wph vy vw cv wrex vx vz cv wral
      vw wex wph vy weu vx vz cv wral wph vy vw cv wrex vx vz cv wral wph vy vx
      cv vz cv wcel wph wa vx vy copab crn wrex vx vz cv wral vw vv vx cv vz cv
      wcel wph wa vx vy copab crn cvv vv cv vx cv vz cv wcel wph wa vx vy copab
      crn wcel vw ax-17 wph vy vx cv vz cv wcel wph wa vx vy copab crn wrex vx
      vz cv wral vw ax-17 vw cv vx cv vz cv wcel wph wa vx vy copab crn wceq
      wph vy vw cv wrex wph vy vx cv vz cv wcel wph wa vx vy copab crn wrex vx
      vz cv vx vw vx cv vz cv wcel wph wa vx vy copab crn vx vw vx cv vz cv
      wcel wph wa vx vy copab vx cv vz cv wcel wph wa vx vy vw hbopab1 hbrn
      hbeleq wph vy vv vw cv vx cv vz cv wcel wph wa vx vy copab crn vv cv vw
      cv wcel vy ax-17 vy vv vx cv vz cv wcel wph wa vx vy copab vx cv vz cv
      wcel wph wa vx vy vv hbopab2 hbrn rexeq1f ralbid cla4egf vx cv vz cv wcel
      wph wa vx vy copab cdm cvv wcel vx cv vz cv wcel wph wa vx vy copab wfun
      vx cv vz cv wcel wph wa vx vy copab crn cvv wcel wph vy weu vx vz cv wral
      cvv vx cv vz cv wcel wph wa vx vy copab funrnex wph vy weu vx vz cv wral
      vx cv vz cv wcel wph wa vx vy copab cdm vz cv cvv wph vy weu vx vz cv
      wral vz cv wph vy wex vx vz cv crab vx cv vz cv wcel wph wa vx vy copab
      cdm wph vy weu vx vz cv wral wph vy wex vx vz cv wral vz cv wph vy wex vx
      vz cv crab wceq wph vy weu wph vy wex vx vz cv wph vy euex r19.20si wph
      vy wex vx vz cv rabid2 sylibr vx cv vz cv wcel wph wa vy wex vx cab vx cv
      vz cv wcel wph vy wex wa vx cab vx cv vz cv wcel wph wa vx vy copab cdm
      wph vy wex vx vz cv crab vx cv vz cv wcel wph wa vy wex vx cv vz cv wcel
      wph vy wex wa vx vx cv vz cv wcel wph vy 19.42v abbii vx cv vz cv wcel
      wph wa vx vy dmopab wph vy wex vx vz cv df-rab 3eqtr4i syl6reqr vz visset
      syl6eqel vx cv vz cv wcel wph vy weu wi vx wal vx cv vz cv wcel wph wa vy
      wmo vx wal wph vy weu vx vz cv wral vx cv vz cv wcel wph wa vx vy copab
      wfun vx cv vz cv wcel wph vy weu wi vx cv vz cv wcel wph wa vy wmo vx vx
      cv vz cv wcel wph vy weu wi vx cv vz cv wcel wph vy wmo wi vx cv vz cv
      wcel wph wa vy wmo wph vy weu wph vy wmo vx cv vz cv wcel wph vy eumo
      imim2i vx cv vz cv wcel wph vy moanimv sylibr 19.20i wph vy weu vx vz cv
      df-ral vx cv vz cv wcel wph wa vx vy funopab 3imtr4i sylc wph vy weu vx
      vz cv wral wph vy vx cv vz cv wcel wph wa vx vy copab crn wrex vx vz cv
      wph vy weu vx vz cv hbra1 wph vy weu vx vz cv wral vx cv vz cv wcel vx cv
      vx cv vz cv wcel wph wa vx vy copab cdm wcel wph vy vx cv vz cv wcel wph
      wa vx vy copab crn wrex wph vy weu vx vz cv wral vx cv vz cv wcel wph wa
      vx vy copab cdm vz cv vx cv wph vy weu vx vz cv wral vz cv wph vy wex vx
      vz cv crab vx cv vz cv wcel wph wa vx vy copab cdm wph vy weu vx vz cv
      wral wph vy wex vx vz cv wral vz cv wph vy wex vx vz cv crab wceq wph vy
      weu wph vy wex vx vz cv wph vy euex r19.20si wph vy wex vx vz cv rabid2
      sylibr vx cv vz cv wcel wph wa vy wex vx cab vx cv vz cv wcel wph vy wex
      wa vx cab vx cv vz cv wcel wph wa vx vy copab cdm wph vy wex vx vz cv
      crab vx cv vz cv wcel wph wa vy wex vx cv vz cv wcel wph vy wex wa vx vx
      cv vz cv wcel wph vy 19.42v abbii vx cv vz cv wcel wph wa vx vy dmopab
      wph vy wex vx vz cv df-rab 3eqtr4i syl6reqr eleq2d vx cv vz cv wcel wph
      wa vy wex vy cv vx cv vz cv wcel wph wa vx vy copab crn wcel wph wa vy
      wex vx cv vx cv vz cv wcel wph wa vx vy copab cdm wcel wph vy vx cv vz cv
      wcel wph wa vx vy copab crn wrex vx cv vz cv wcel wph wa vy cv vx cv vz
      cv wcel wph wa vx vy copab crn wcel wph wa vy vx cv vz cv wcel wph vy cv
      vx cv vz cv wcel wph wa vx vy copab crn wcel vx cv vz cv wcel wph vy cv
      vx cv vz cv wcel wph wa vx vy copab crn wcel vx cv vz cv wcel wph wa vx
      cv vy cv cop vx cv vz cv wcel wph wa vx vy copab wcel vy cv vx cv vz cv
      wcel wph wa vx vy copab crn wcel vx cv vz cv wcel wph wa vx vy opabid vx
      cv vy cv vx cv vz cv wcel wph wa vx vy copab vx visset vy visset opelrn
      sylbir ex impac 19.22i vx cv vz cv wcel wph wa vy wex vx vx cv vz cv wcel
      wph wa vx vy copab cdm vx cv vz cv wcel wph wa vx vy dmopab abeq2i wph vy
      vx cv vz cv wcel wph wa vx vy copab crn df-rex 3imtr4i syl6bir r19.21ai
      sylc $.
      $( [10-Oct-2003] $) $( [10-Oct-2003] $)
  $}

  ${
    $d x y z A $.  $d z F $.  $d x y z w $.
    fnopabg.1 $e |- F = { <. x , y >. | ( x e. A /\ ph ) } $.
    $( Functionality and domain of an ordered-pair class abstraction. $)
    fnopabg $p |- ( A. x e. A E! y ph <-> F Fn A ) $=
      wph vy weu vx cA wral cF cA wfn wph vy weu vx cA wral vx cv cA wcel wph
      wa vx vy copab cA wfn cF cA wfn vx cv cA wcel wph wa vx vy copab cA wfn
      vx cv cA wcel wph wa vx vy copab wfun vx cv cA wcel wph wa vx vy copab
      cdm cA wceq wph vy weu vx cA wral vx cv cA wcel wph wa vx vy copab cA
      df-fn wph vy weu vx cA wral vx cv cA wcel wph wa vy wmo vx wal vx cv cA
      wcel wph wa vx vy copab wfun wph vy weu vx cA wral vx cv cA wcel wph wa
      vy wmo vx wph vy weu vx cA hbra1 wph vy weu vx cA wral vx cv cA wcel wph
      vy weu wi vx cv cA wcel wph wa vy wmo wph vy weu vx cA ra4 vx cv cA wcel
      wph vy weu wi vx cv cA wcel wph vy wmo wi vx cv cA wcel wph wa vy wmo wph
      vy weu wph vy wmo vx cv cA wcel wph vy eumo imim2i vx cv cA wcel wph vy
      moanimv sylibr syl 19.21ai vx cv cA wcel wph wa vx vy funopab sylibr wph
      vy weu vx cA wral wph vy wex vx cA wral vx cv cA wcel wph wa vx vy copab
      cdm cA wceq wph vy weu wph vy wex vx cA wph vy euex r19.20si wph vx vy cA
      dmopab3 sylib sylanbrc cF vx cv cA wcel wph wa vx vy copab wceq cF cA wfn
      vx cv cA wcel wph wa vx vy copab cA wfn wb fnopabg.1 cA cF vx cv cA wcel
      wph wa vx vy copab fneq1 ax-mp sylibr cF cA wfn wph vy weu vx cA vx vz cA
      cF vx vz cF vx cv cA wcel wph wa vx vy copab fnopabg.1 vx cv cA wcel wph
      wa vx vy vz hbopab1 hbxfr vz cv cA wcel vx ax-17 hbfn cF cA wfn vx cv cA
      wcel wph vy weu cF cA wfn vx cv cA wcel wa vx cv vy cv cop cF wcel vy weu
      wph vy weu cF cA wfn vx cv cA wcel wa vx cv vz cv cop cF wcel vz weu vx
      cv vy cv cop cF wcel vy weu vz cA vx cv cF fneu2 vx cv vz cv cop cF wcel
      vx cv vy cv cop cF wcel vz vy vy vw vz vx cv vz cv cop cF vw cv vx cv vz
      cv cop wcel vy ax-17 vy vz cF vx cv cA wcel wph wa vx vy copab fnopabg.1
      vx cv cA wcel wph wa vx vy vz hbopab2 hbxfr hbel vx cv vy cv cop cF wcel
      vz ax-17 vz cv vy cv wceq vx cv vz cv cop vx cv vy cv cop cF vz cv vy cv
      vx cv opeq2 eleq1d cbveu sylib vx cv vy cv cop cF wcel vy weu vx cv cA
      wcel wph vy weu vx cv vy cv cop cF wcel vy weu vx cv cA wcel wph wa vy
      weu vx cv cA wcel wph vy weu wa vx cv vy cv cop cF wcel vx cv cA wcel wph
      wa vy vx cv vy cv cop cF wcel vx cv vy cv cop vx cv cA wcel wph wa vx vy
      copab wcel vx cv cA wcel wph wa cF vx cv cA wcel wph wa vx vy copab vx cv
      vy cv cop fnopabg.1 eleq2i vx cv cA wcel wph wa vx vy opabid bitri eubii
      vx cv cA wcel wph vy euanv bitri pm3.27bi syl ex r19.21ai impbii $.
      $( [31-Jan-2004] $) $( [30-Jan-2004] $)
  $}

  ${
    $d x y A $.  $d y B $.
    fnopab2g.1 $e |- F = { <. x , y >. | ( x e. A /\ y = B ) } $.
    $( Functionality and domain of an ordered-pair class abstraction. $)
    fnopab2g $p |- ( A. x e. A B e. _V <-> F Fn A ) $=
      cB cvv wcel vx cA wral vy cv cB wceq vy weu vx cA wral cF cA wfn cB cvv
      wcel vy cv cB wceq vy weu vx cA vy cB eueq ralbii vy cv cB wceq vx vy cA
      cF fnopab2g.1 fnopabg bitri $.
      $( [31-Mar-2006] $) $( [23-Mar-2006] $)
  $}

  ${
    $d x y A $.
    fnopab.1 $e |- ( x e. A -> E! y ph ) $.
    fnopab.2 $e |- F = { <. x , y >. | ( x e. A /\ ph ) } $.
    $( Functionality and domain of an ordered-pair class abstraction. $)
    fnopab $p |- F Fn A $=
      wph vy weu vx cA wral cF cA wfn wph vy weu vx cA fnopab.1 rgen wph vx vy
      cA cF fnopab.2 fnopabg mpbi $.
      $( [5-Mar-1996] $)
  $}

  ${
    $d x y A $.  $d y B $.
    fnopab2.1 $e |- B e. _V $.
    fnopab2.2 $e |- F = { <. x , y >. | ( x e. A /\ y = B ) } $.
    $( Functionality and domain of an ordered-pair class abstraction. $)
    fnopab2 $p |- F Fn A $=
      vy cv cB wceq vx vy cA cF vy cv cB wceq vy weu vx cv cA wcel vy cB
      fnopab2.1 eueq1 a1i fnopab2.2 fnopab $.
      $( [24-Feb-2004] $) $( [29-Jan-2004] $)

    $( Domain of an ordered-pair class abstraction that specifies a
       function. $)
    dmopab2 $p |- dom F = A $=
      cF cA wfn cF cdm cA wceq vx vy cA cB cF fnopab2.1 fnopab2.2 fnopab2 cA cF
      fndm ax-mp $.
      $( [7-Sep-2005] $) $( [6-Sep-2005] $)
  $}

  $( Equality theorem for functions. $)
  feq1 $p |- ( F = G -> ( F : A --> B <-> G : A --> B ) ) $=
    cF cG wceq cF cA wfn cF crn cB wss wa cG cA wfn cG crn cB wss wa cA cB cF
    wf cA cB cG wf cF cG wceq cF cA wfn cG cA wfn cF crn cB wss cG crn cB wss
    cA cF cG fneq1 cF cG wceq cF crn cG crn cB cF cG rneq sseq1d anbi12d cA cB
    cF df-f cA cB cG df-f 3bitr4g $.
    $( [1-Aug-1994] $)

  $( Equality theorem for functions. $)
  feq2 $p |- ( A = B -> ( F : A --> C <-> F : B --> C ) ) $=
    cA cB wceq cF cA wfn cF crn cC wss wa cF cB wfn cF crn cC wss wa cA cC cF
    wf cB cC cF wf cA cB wceq cF cA wfn cF cB wfn cF crn cC wss cA cB cF fneq2
    anbi1d cA cC cF df-f cB cC cF df-f 3bitr4g $.
    $( [1-Aug-1994] $)

  $( Equality theorem for functions. $)
  feq3 $p |- ( A = B -> ( F : C --> A <-> F : C --> B ) ) $=
    cA cB wceq cF cC wfn cF crn cA wss wa cF cC wfn cF crn cB wss wa cC cA cF
    wf cC cB cF wf cA cB wceq cF crn cA wss cF crn cB wss cF cC wfn cA cB cF
    crn sseq2 anbi2d cC cA cF df-f cC cB cF df-f 3bitr4g $.
    $( [1-Aug-1994] $)

  $( Equality theorem for functions.  (Contributed by FL, 14-Jul-2007.) $)
  feq23 $p |- ( ( A = C /\ B = D ) -> ( F : A --> B <-> F : C --> D ) ) $=
    cA cC wceq cB cD wceq wa cF cA wfn cF crn cB wss wa cF cC wfn cF crn cD wss
    wa cA cB cF wf cC cD cF wf cA cC wceq cF cA wfn cF cC wfn cB cD wceq cF crn
    cB wss cF crn cD wss cA cC cF fneq2 cB cD cF crn sseq2 bi2anan9 cA cB cF
    df-f cC cD cF df-f 3bitr4g $.
    $( [11-Oct-2007] $) $( [14-Jul-2007] $)

  ${
    feq1d.1 $e |- ( ph -> F = G ) $.
    $( Equality deduction for mappings. $)
    feq1d $p |- ( ph -> ( F : A --> B <-> G : A --> B ) ) $=
      wph cF cG wceq cA cB cF wf cA cB cG wf wb feq1d.1 cA cB cF cG feq1 syl $.
      $( [20-Feb-2008] $) $( [19-Feb-2008] $)
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    hbf.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbf.2 $e |- ( y e. A -> A. x y e. A ) $.
    hbf.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for a mapping. $)
    hbf $p |- ( F : A --> B -> A. x F : A --> B ) $=
      cF cA wfn cF crn cB wss wa cF cA wfn cF crn cB wss wa vx wal cA cB cF wf
      cA cB cF wf vx wal cF cA wfn cF crn cB wss vx vx vy cA cF hbf.1 hbf.2
      hbfn vx vy cF crn cB vx vy cF hbf.1 hbrn hbf.3 hbss hban cA cB cF df-f cA
      cB cF wf cF cA wfn cF crn cB wss wa vx cA cB cF df-f albii 3imtr4i $.
      $( [2-Feb-2004] $) $( [29-Jan-2004] $)
  $}

  ${
    elimf.1 $e |- G : A --> B $.
    $( Eliminate a mapping hypothesis for the weak deduction theorem ~ dedth ,
       when a special case ` G : A --> B ` is provable, in order to convert
       ` F : A --> B ` from a hypothesis to an antecedent. $)
    elimf $p |- if ( F : A --> B , F , G ) : A --> B $=
      cA cB cF wf cA cB cA cB cF wf cF cG cif wf cA cB cG wf cF cG cA cB cF cA
      cB cF wf cF cG cif feq1 cA cB cG cA cB cF wf cF cG cif feq1 elimf.1
      elimhyp $.
      $( [24-Aug-2006] $) $( [24-Aug-2006] $)
  $}

  $( A mapping is a function. $)
  ffn $p |- ( F : A --> B -> F Fn A ) $=
    cA cB cF wf cF cA wfn cF crn cB wss cA cB cF df-f pm3.26bi $.
    $( [2-Aug-1994] $)

  $( Any function is a mapping into ` _V ` . $)
  dffn2 $p |- ( F Fn A <-> F : A --> _V ) $=
    cF cA wfn cA cvv cF wf cF cA wfn cF crn cvv wss cA cvv cF wf cF crn ssv cA
    cvv cF wf cF cA wfn cF crn cvv wss wa cA cvv cF df-f biimpri mpan2 cA cvv
    cF ffn impbii $.
    $( [31-Oct-1995] $)

  $( A mapping is a function. $)
  ffun $p |- ( F : A --> B -> Fun F ) $=
    cA cB cF wf cF cA wfn cF wfun cA cB cF ffn cA cF fnfun syl $.
    $( [3-Aug-1994] $)

  $( A mapping is a relation. $)
  frel $p |- ( F : A --> B -> Rel F ) $=
    cA cB cF wf cF cA wfn cF wrel cA cB cF ffn cA cF fnrel syl $.
    $( [3-Aug-1994] $)

  $( The domain of a mapping. $)
  fdm $p |- ( F : A --> B -> dom F = A ) $=
    cA cB cF wf cF cA wfn cF cdm cA wceq cA cB cF ffn cA cF fndm syl $.
    $( [2-Aug-1994] $)

  ${
    fdmi.1 $e |- F : A --> B $.
    $( The domain of a mapping. $)
    fdmi $p |- dom F = A $=
      cA cB cF wf cF cdm cA wceq fdmi.1 cA cB cF fdm ax-mp $.
      $( [28-Jul-2008] $) $( [28-Jul-2008] $)
  $}

  $( The range of a mapping. $)
  frn $p |- ( F : A --> B -> ran F C_ B ) $=
    cA cB cF wf cF cA wfn cF crn cB wss cA cB cF df-f pm3.27bi $.
    $( [3-Aug-1994] $)

  $( A function maps to its range. $)
  dffn3 $p |- ( F Fn A <-> F : A --> ran F ) $=
    cF cA wfn cF cA wfn cF crn cF crn wss wa cA cF crn cF wf cF crn cF crn wss
    cF cA wfn cF crn ssid biantru cA cF crn cF df-f bitr4i $.
    $( [1-Sep-1999] $)

  $( Expanding the codomain of a mapping. $)
  fss $p |- ( ( F : A --> B /\ B C_ C ) -> F : A --> C ) $=
    cA cC cF wf cF cA wfn cF crn cC wss cA cB cF wf cB cC wss wa cA cC cF df-f
    cA cB cF wf cF cA wfn cB cC wss cA cB cF ffn adantr cA cB cF wf cB cC wss
    cF crn cC wss cA cB cF wf cF crn cB wss cB cC wss cF crn cC wss wi cA cB cF
    frn cF crn cB cC sstr2 syl imp sylanbrc $.
    $( [10-May-1998] $)

  $( Composition of two mappings. $)
  fco $p |- ( ( F : B --> C /\ G : A --> B ) -> ( F o. G ) : A --> C ) $=
    cA cC cF cG ccom wf cF cG ccom cA wfn cF cG ccom crn cC wss cB cC cF wf cA
    cB cG wf wa cA cC cF cG ccom df-f cF cG ccom cA wfn cF cG ccom wfun cF cG
    ccom cdm cA wceq cB cC cF wf cA cB cG wf wa cF cG ccom cA df-fn cF wfun cG
    wfun cF cG ccom wfun cB cC cF wf cA cB cG wf cF cG funco cB cC cF ffun cA
    cB cG ffun syl2an cB cC cF wf cA cB cG wf wa cF cG ccom cdm cG cdm cA cB cC
    cF wf cA cB cG wf wa cG crn cF cdm wss cF cG ccom cdm cG cdm wceq cB cC cF
    wf cA cB cG wf cG crn cF cdm wss cB cC cF wf cG crn cF cdm wss cG crn cB
    wss cA cB cG wf cB cC cF wf cF cdm cB cG crn cB cC cF fdm sseq2d cA cB cG
    frn syl5bir imp cF cG dmcosseq syl cA cB cG wf cG cdm cA wceq cB cC cF wf
    cA cB cG fdm adantl eqtrd sylanbrc cB cC cF wf cF cG ccom crn cC wss cA cB
    cG wf cF cG ccom crn cF crn wss cB cC cF wf cF cG ccom crn cC wss wi cF cG
    rncoss cF cG ccom crn cF crn wss cF crn cC wss cF cG ccom crn cC wss cB cC
    cF wf cF cG ccom crn cF crn cC sstr2 cB cC cF frn syl5 ax-mp adantr
    sylanbrc $.
    $( [29-Aug-1999] $)

  $( A mapping is a class of ordered pairs. $)
  fssxp $p |- ( F : A --> B -> F C_ ( A X. B ) ) $=
    cA cB cF wf cF cdm cF crn cxp cA cB cxp wss cF cA cB cxp wss cA cB cF wf cF
    cdm cF crn cxp cA cB cxp wss cA cF crn cxp cA cB cxp wss cA cA wss cF crn
    cB wss cA cF crn cxp cA cB cxp wss cA cB cF wf cA cA cF crn cB ssxp cA ssid
    cA cB cF frn sylancr cA cB cF wf cF cdm cA wceq cF cdm cF crn cxp cA cF crn
    cxp wceq cF cdm cF crn cxp cA cB cxp wss cA cF crn cxp cA cB cxp wss wb cA
    cB cF fdm cF cdm cA cF crn xpeq1 cF cdm cF crn cxp cA cF crn cxp cA cB cxp
    sseq1 3syl mpbird cA cB cF wf cF wrel cF cF cdm cF crn cxp wss cF cdm cF
    crn cxp cA cB cxp wss cF cA cB cxp wss wi cA cB cF frel cF relssdmrn cF cF
    cdm cF crn cxp cA cB cxp sstr2 3syl mpd $.
    $( [3-Aug-1994] $)

  $( Two ways of specifying a partial function from ` A ` to ` B ` . $)
  funssxp $p |- ( ( Fun F /\ F C_ ( A X. B ) ) <->
             ( F : dom F --> B /\ dom F C_ A ) ) $=
    cF wfun cF cA cB cxp wss wa cF cdm cB cF wf cF cdm cA wss wa cF wfun cF cA
    cB cxp wss wa cF cdm cB cF wf cF cdm cA wss cF wfun cF cA cB cxp wss wa cF
    cF cdm wfn cF crn cB wss wa cF cdm cB cF wf cF wfun cF cF cdm wfn cF cA cB
    cxp wss cF crn cB wss cF wfun cF cF cdm wfn cF funfn biimpi cF crn cA cB
    cxp crn wss cA cB cxp crn cB wss cF crn cB wss cF cA cB cxp wss cF crn cA
    cB cxp crn cB sstr cF cA cB cxp rnss cA cB rnxpss sylancl anim12i cF cdm cB
    cF df-f sylibr cF cA cB cxp wss cF cdm cA wss cF wfun cF cdm cA cB cxp cdm
    wss cA cB cxp cdm cA wss cF cdm cA wss cF cA cB cxp wss cF cdm cA cB cxp
    cdm cA sstr cF cA cB cxp dmss cA cB dmxpss sylancl adantl jca cF cdm cB cF
    wf cF cdm cA wss wa cF wfun cF cA cB cxp wss cF cdm cB cF wf cF wfun cF cdm
    cA wss cF cdm cB cF ffun adantr cF cdm cB cF wf cF cdm cA wss cF cF cdm cB
    cxp cA cB cxp cF cdm cB cF fssxp cF cdm cA wss cB cB wss cF cdm cB cxp cA
    cB cxp wss cB ssid cF cdm cA cB cB ssxp mpan2 sylan9ss jca impbii $.
    $( [14-Nov-2007] $) $( [13-Nov-2007] $)

  $( A mapping is a partial function. $)
  ffdm $p |- ( F : A --> B -> ( F : dom F --> B /\ dom F C_ A ) ) $=
    cA cB cF wf cF cdm cB cF wf cF cdm cA wss cA cB cF wf cF cdm cB cF wf cA cB
    cF wf cF cdm cA wceq cF cdm cB cF wf cA cB cF wf wb cA cB cF fdm cF cdm cA
    cB cF feq2 syl ibir cA cB cF wf cF cdm cA wceq cF cdm cA wss cA cB cF fdm
    cF cdm cA eqimss syl jca $.
    $( [27-Nov-2007] $) $( [25-Nov-2007] $)

  ${
    opelf.1 $e |- D e. _V $.
    $( The members of an ordered pair element of a mapping belong to the
       mapping's domain and codomain. $)
    opelf $p |- ( ( F : A --> B /\ <. C , D >. e. F ) ->
                ( C e. A /\ D e. B ) ) $=
      cA cB cF wf cC cD cop cF wcel cC cA wcel cD cB wcel wa cA cB cF wf cC cD
      cop cF wcel cC cD cop cA cB cxp wcel cC cA wcel cD cB wcel wa cA cB cF wf
      cF cA cB cxp cC cD cop cA cB cF fssxp sseld cC cD cA cB opelf.1 opelxp
      syl6ib imp $.
      $( [11-Dec-2003] $) $( [10-Dec-2003] $)
  $}

  $( The union of two functions with disjoint domains. $)
  fun $p |- ( ( ( F : A --> C /\ G : B --> D ) /\ ( A i^i B ) = (/) ) ->
             ( F u. G ) : ( A u. B ) --> ( C u. D ) ) $=
    cA cB cin c0 wceq cA cC cF wf cB cD cG wf wa cA cB cun cC cD cun cF cG cun
    wf cA cB cin c0 wceq cF cA wfn cG cB wfn wa cF crn cC wss cG crn cD wss wa
    wa cF cG cun cA cB cun wfn cF cG cun crn cC cD cun wss wa cA cC cF wf cB cD
    cG wf wa cA cB cun cC cD cun cF cG cun wf cA cB cin c0 wceq cF cA wfn cG cB
    wfn wa cF cG cun cA cB cun wfn cF crn cC wss cG crn cD wss wa cF cG cun crn
    cC cD cun wss cF cA wfn cG cB wfn wa cA cB cin c0 wceq cF cG cun cA cB cun
    wfn cA cB cF cG fnun expcom cF crn cC wss cG crn cD wss wa cF cG cun crn cC
    cD cun wss wi cA cB cin c0 wceq cF crn cC wss cG crn cD wss wa cF crn cG
    crn cun cC cD cun cF cG cun crn cF crn cC cG crn cD unss12 cF cG rnun
    syl5ss a1i anim12d cA cC cF wf cB cD cG wf wa cF cA wfn cF crn cC wss wa cG
    cB wfn cG crn cD wss wa wa cF cA wfn cG cB wfn wa cF crn cC wss cG crn cD
    wss wa wa cA cC cF wf cF cA wfn cF crn cC wss wa cB cD cG wf cG cB wfn cG
    crn cD wss wa cA cC cF df-f cB cD cG df-f anbi12i cF cA wfn cF crn cC wss
    cG cB wfn cG crn cD wss an4 bitri cA cB cun cC cD cun cF cG cun df-f
    3imtr4g impcom $.
    $( [7-Nov-2004] $) $( [22-Sep-2004] $)

  $( Composition of two functions. $)
  fnfco $p |- ( ( F Fn A /\ G : B --> A ) -> ( F o. G ) Fn B ) $=
    cF cA wfn cG cB wfn cG crn cA wss wa cF cG ccom cB wfn cB cA cG wf cF cA
    wfn cG cB wfn cG crn cA wss cF cG ccom cB wfn cA cB cF cG fnco 3expb cB cA
    cG df-f sylan2b $.
    $( [22-May-2006] $) $( [22-May-2006] $)

  $( Restriction of a function with a subclass of its domain. $)
  fssres $p |- ( ( F : A --> B /\ C C_ A ) -> ( F |` C ) : C --> B ) $=
    cA cB cF wf cC cA wss wa cF cC cres cC wfn cF cC cres crn cB wss wa cC cB
    cF cC cres wf cF cA wfn cF crn cB wss wa cC cA wss cF cC cres cC wfn cF cC
    cres crn cB wss wa cA cB cF wf cF cA wfn cC cA wss cF crn cB wss cF cC cres
    cC wfn cF cC cres crn cB wss wa cF cA wfn cC cA wss wa cF cC cres cC wfn cF
    crn cB wss cF cC cres crn cB wss cA cC cF fnssres cF cC cres crn cF crn wss
    cF crn cB wss cF cC cres crn cB wss cF cC cres cF wss cF cC cres crn cF crn
    wss cF cC resss cF cC cres cF rnss ax-mp cF cC cres crn cF crn cB sstr mpan
    anim12i an1rs cA cB cF df-f sylanb cC cB cF cC cres df-f sylibr $.
    $( [17-Oct-2004] $) $( [23-Sep-2004] $)

  $( Restriction of a restricted function with a subclass of its domain. $)
  fssres2 $p |- ( ( ( F |` A ) : A --> B /\ C C_ A ) ->
                ( F |` C ) : C --> B ) $=
    cA cB cF cA cres wf cC cA wss wa cC cB cF cA cres cC cres wf cC cB cF cC
    cres wf cA cB cC cF cA cres fssres cC cA wss cC cB cF cA cres cC cres wf cC
    cB cF cC cres wf wb cA cB cF cA cres wf cC cA wss cC cB cF cA cres cC cres
    cF cC cres cF cC cA resabs1 feq1d adantl mpbid $.
    $( [22-Jul-2005] $) $( [21-Jul-2005] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.
    $( Composition of a mapping and restricted identity. $)
    fcoi1 $p |- ( F : A --> B -> ( F o. ( _I |` A ) ) = F ) $=
      cA cB cF wf cF cA wfn cF cid cA cres ccom cF wceq cA cB cF ffn cF cA wfn
      cF cid cA cres ccom cF wceq vx cv vy cv cop cF cid cA cres ccom wcel vx
      cv vy cv cop cF wcel wb vy wal vx wal cF cA wfn vx cv vy cv cop cF cid cA
      cres ccom wcel vx cv vy cv cop cF wcel wb vx vy cF cA wfn vx cv vy cv cop
      cF wcel vx cv cA wcel vx cv vy cv cop cF wcel wa vx cv vy cv cop cF cid
      cA cres ccom wcel cF cA wfn vx cv vy cv cop cF wcel vx cv cA wcel cF cA
      wfn vx cv vy cv cop cF wcel vx cv cA wcel cA vx cv vy cv cF fnop ex
      pm4.71rd vx cv vy cv cop cF cid cA cres ccom wcel vx cv vz cv cop cid cA
      cres wcel vz cv vy cv cop cF wcel wa vz wex vz cv vx cv wceq vx cv cA
      wcel vz cv vy cv cop cF wcel wa wa vz wex vx cv cA wcel vx cv vy cv cop
      cF wcel wa vx cv cvv wcel vy cv cvv wcel vx cv vy cv cop cF cid cA cres
      ccom wcel vx cv vz cv cop cid cA cres wcel vz cv vy cv cop cF wcel wa vz
      wex wb vx visset vy visset vz vx cv vy cv cF cid cA cres cvv cvv opelco2g
      mp2an vx cv vz cv cop cid cA cres wcel vz cv vy cv cop cF wcel wa vz cv
      vx cv wceq vx cv cA wcel vz cv vy cv cop cF wcel wa wa vz vx cv vz cv cop
      cid cA cres wcel vz cv vy cv cop cF wcel wa vz cv vx cv wceq vx cv cA
      wcel wa vz cv vy cv cop cF wcel wa vz cv vx cv wceq vx cv cA wcel vz cv
      vy cv cop cF wcel wa wa vx cv vz cv cop cid cA cres wcel vz cv vx cv wceq
      vx cv cA wcel wa vz cv vy cv cop cF wcel vx cv vz cv cop cid cA cres wcel
      vx cv vz cv cop cid wcel vx cv cA wcel wa vz cv vx cv wceq vx cv cA wcel
      wa vx cv vz cv cid cA vz visset opelres vx cv vz cv cop cid wcel vz cv vx
      cv wceq vx cv cA wcel vx cv vz cv cid wbr vx cv vz cv wceq vx cv vz cv
      cop cid wcel vz cv vx cv wceq vx cv vz cv vz visset ideq vx cv vz cv cid
      df-br vx cv vz cv eqcom 3bitr3i anbi1i bitri anbi1i vz cv vx cv wceq vx
      cv cA wcel vz cv vy cv cop cF wcel anass bitri exbii vx cv cA wcel vz cv
      vy cv cop cF wcel wa vx cv cA wcel vx cv vy cv cop cF wcel wa vz vx cv vx
      visset vz cv vx cv wceq vz cv vy cv cop cF wcel vx cv vy cv cop cF wcel
      vx cv cA wcel vz cv vx cv wceq vz cv vy cv cop vx cv vy cv cop cF vz cv
      vx cv vy cv opeq1 eleq1d anbi2d ceqsexv 3bitri syl6rbbr 19.21aivv cF cid
      cA cres ccom wrel cF wrel cF cid cA cres ccom cF wceq vx cv vy cv cop cF
      cid cA cres ccom wcel vx cv vy cv cop cF wcel wb vy wal vx wal wb cF cA
      wfn vx vy cF cid cA cres ccom cF eqrel cF cid cA cres relco cA cF fnrel
      sylancr mpbird syl $.
      $( [24-Dec-2003] $) $( [13-Dec-2003] $)

    $( Composition of restricted identity and a mapping. $)
    fcoi2 $p |- ( F : A --> B -> ( ( _I |` B ) o. F ) = F ) $=
      cA cB cF wf cid cB cres cF ccom cF wceq vx cv vy cv cop cid cB cres cF
      ccom wcel vx cv vy cv cop cF wcel wb vy wal vx wal cA cB cF wf vx cv vy
      cv cop cid cB cres cF ccom wcel vx cv vy cv cop cF wcel wb vx vy cA cB cF
      wf vx cv vy cv cop cF wcel vx cv vy cv cop cF wcel vy cv cB wcel wa vx cv
      vy cv cop cid cB cres cF ccom wcel cA cB cF wf vx cv vy cv cop cF wcel vy
      cv cB wcel wi vx cv vy cv cop cF wcel vx cv vy cv cop cF wcel vy cv cB
      wcel wa wb cA cB cF wf vx cv vy cv cop cF wcel vy cv cB wcel cA cB cF wf
      vx cv vy cv cop cF wcel wa vx cv cA wcel vy cv cB wcel cA cB vx cv vy cv
      cF vy visset opelf pm3.27d ex vx cv vy cv cop cF wcel vy cv cB wcel
      pm4.71 sylib vx cv vy cv cop cid cB cres cF ccom wcel vx cv vz cv cop cF
      wcel vz cv vy cv cop cid cB cres wcel wa vz wex vz cv vy cv wceq vx cv vz
      cv cop cF wcel vz cv cB wcel wa wa vz wex vx cv vy cv cop cF wcel vy cv
      cB wcel wa vx cv cvv wcel vy cv cvv wcel vx cv vy cv cop cid cB cres cF
      ccom wcel vx cv vz cv cop cF wcel vz cv vy cv cop cid cB cres wcel wa vz
      wex wb vx visset vy visset vz vx cv vy cv cid cB cres cF cvv cvv opelco2g
      mp2an vx cv vz cv cop cF wcel vz cv vy cv cop cid cB cres wcel wa vz cv
      vy cv wceq vx cv vz cv cop cF wcel vz cv cB wcel wa wa vz vx cv vz cv cop
      cF wcel vz cv vy cv cop cid cB cres wcel wa vx cv vz cv cop cF wcel vz cv
      vy cv wceq vz cv cB wcel wa wa vz cv vy cv wceq vx cv vz cv cop cF wcel
      vz cv cB wcel wa wa vz cv vy cv cop cid cB cres wcel vz cv vy cv wceq vz
      cv cB wcel wa vx cv vz cv cop cF wcel vz cv vy cv cop cid cB cres wcel vz
      cv vy cv cop cid wcel vz cv cB wcel wa vz cv vy cv wceq vz cv cB wcel wa
      vz cv vy cv cid cB vy visset opelres vz cv vy cv cop cid wcel vz cv vy cv
      wceq vz cv cB wcel vz cv vy cv cop cid wcel vz cv vy cv cid wbr vz cv vy
      cv wceq vz cv vy cv cid df-br vz cv vy cv vy visset ideq bitr3i anbi1i
      bitri anbi2i vx cv vz cv cop cF wcel vz cv vy cv wceq vz cv cB wcel an12
      bitri exbii vx cv vz cv cop cF wcel vz cv cB wcel wa vx cv vy cv cop cF
      wcel vy cv cB wcel wa vz vy cv vy visset vz cv vy cv wceq vx cv vz cv cop
      cF wcel vx cv vy cv cop cF wcel vz cv cB wcel vy cv cB wcel vz cv vy cv
      wceq vx cv vz cv cop vx cv vy cv cop cF vz cv vy cv vx cv opeq2 eleq1d vz
      cv vy cv cB eleq1 anbi12d ceqsexv 3bitri syl6rbbr 19.21aivv cid cB cres
      cF ccom wrel cF wrel cid cB cres cF ccom cF wceq vx cv vy cv cop cid cB
      cres cF ccom wcel vx cv vy cv cop cF wcel wb vy wal vx wal wb cA cB cF wf
      vx vy cid cB cres cF ccom cF eqrel cid cB cres cF relco cA cB cF frel
      sylancr mpbird $.
      $( [16-May-2004] $) $( [13-Dec-2003] $)
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.  $d y C $.
    $( There is exactly one value of a function in its codomain. $)
    feu $p |- ( ( F : A --> B /\ C e. A ) -> E! y e. B <. C , y >. e. F ) $=
      cA cB cF wf cC cA wcel wa vy cv cB wcel cC vy cv cop cF wcel wa vy weu cC
      vy cv cop cF wcel vy cB wreu cA cB cF wf cC cA wcel wa cC vy cv cop cF
      wcel vy weu vy cv cB wcel cC vy cv cop cF wcel wa vy weu cF cA wfn cC cA
      wcel cC vy cv cop cF wcel vy weu cA cB cF wf vy cA cC cF fneu2 cA cB cF
      ffn sylan cA cB cF wf cC vy cv cop cF wcel vy weu vy cv cB wcel cC vy cv
      cop cF wcel wa vy weu wb cC cA wcel cA cB cF wf cC vy cv cop cF wcel vy
      cv cB wcel cC vy cv cop cF wcel wa vy cA cB cF wf cC vy cv cop cF wcel vy
      cv cB wcel cA cB cF wf cC vy cv cop cF wcel vy cv cB wcel cA cB cF wf cC
      vy cv cop cF wcel wa cC cA wcel vy cv cB wcel cA cB cC vy cv cF vy visset
      opelf pm3.27d ex pm4.71rd eubidv adantr mpbid cC vy cv cop cF wcel vy cB
      df-reu sylibr $.
      $( [12-Dec-2003] $) $( [10-Dec-2003] $)
  $}

  ${
    $d x y F $.  $d x y A $.  $d x y B $.
    $( The converse of a restriction of a function. $)
    fcnvres $p |- ( F : A --> B -> `' ( F |` A ) = ( `' F |` B ) ) $=
      cA cB cF wf vy cv vx cv cop cF cA cres ccnv wcel vy cv vx cv cop cF ccnv
      cB cres wcel wb vx wal vy wal cF cA cres ccnv cF ccnv cB cres wceq cA cB
      cF wf vy cv vx cv cop cF cA cres ccnv wcel vy cv vx cv cop cF ccnv cB
      cres wcel wb vy vx cA cB cF wf vx cv vy cv cop cF wcel vy cv vx cv cop cF
      cA cres ccnv wcel vy cv vx cv cop cF ccnv cB cres wcel cA cB cF wf vx cv
      vy cv cop cF wcel vx cv vy cv cop cF wcel vx cv cA wcel wa vy cv vx cv
      cop cF cA cres ccnv wcel cA cB cF wf vx cv vy cv cop cF wcel vx cv cA
      wcel wi vx cv vy cv cop cF wcel vx cv vy cv cop cF wcel vx cv cA wcel wa
      wb cA cB cF wf vx cv vy cv cop cF wcel vx cv cA wcel cA cB cF wf vx cv vy
      cv cop cF wcel wa vx cv cA wcel vy cv cB wcel cA cB vx cv vy cv cF vy
      visset opelf pm3.26d ex vx cv vy cv cop cF wcel vx cv cA wcel pm4.71
      sylib vy cv vx cv cop cF cA cres ccnv wcel vx cv vy cv cop cF cA cres
      wcel vx cv vy cv cop cF wcel vx cv cA wcel wa vy cv vx cv cF cA cres vy
      visset vx visset opelcnv vx cv vy cv cF cA vy visset opelres bitri
      syl6bbr cA cB cF wf vx cv vy cv cop cF wcel vx cv vy cv cop cF wcel vy cv
      cB wcel wa vy cv vx cv cop cF ccnv cB cres wcel cA cB cF wf vx cv vy cv
      cop cF wcel vy cv cB wcel wi vx cv vy cv cop cF wcel vx cv vy cv cop cF
      wcel vy cv cB wcel wa wb cA cB cF wf vx cv vy cv cop cF wcel vy cv cB
      wcel cA cB cF wf vx cv vy cv cop cF wcel wa vx cv cA wcel vy cv cB wcel
      cA cB vx cv vy cv cF vy visset opelf pm3.27d ex vx cv vy cv cop cF wcel
      vy cv cB wcel pm4.71 sylib vy cv vx cv cop cF ccnv cB cres wcel vy cv vx
      cv cop cF ccnv wcel vy cv cB wcel wa vx cv vy cv cop cF wcel vy cv cB
      wcel wa vy cv vx cv cF ccnv cB vx visset opelres vy cv vx cv cop cF ccnv
      wcel vx cv vy cv cop cF wcel vy cv cB wcel vy cv vx cv cF vy visset vx
      visset opelcnv anbi1i bitri syl6bbr bitr3d 19.21aivv cF cA cres ccnv wrel
      cF ccnv cB cres wrel cF cA cres ccnv cF ccnv cB cres wceq vy cv vx cv cop
      cF cA cres ccnv wcel vy cv vx cv cop cF ccnv cB cres wcel wb vx wal vy
      wal wb cF cA cres relcnv cF ccnv cB relres vy vx cF cA cres ccnv cF ccnv
      cB cres eqrel mp2an sylibr $.
      $( [26-Mar-1998] $)
  $}

  $( The pre-image of a class disjoint with a mapping's codomain is empty.
     (Contributed by FL, 24-Jan-2007.) $)
  fimacnvdisj $p |- ( ( F : A --> B /\ ( B i^i C ) = (/) ) ->
    ( `' F " C ) = (/) ) $=
    cA cB cF wf cB cC cin c0 wceq wa cF ccnv cdm cC cin c0 wceq cF ccnv cC cima
    c0 wceq cA cB cF wf cB cC cin c0 wceq cF ccnv cdm cB wss cF ccnv cdm cC cin
    c0 wceq cA cB cF wf cB cC cin c0 wceq wa cF crn cB cF ccnv cdm cA cB cF wf
    cF crn cB wss cB cC cin c0 wceq cA cB cF frn adantr cF df-rn syl5ssr cF
    ccnv cdm cB cC ssdisj sylancom cF ccnv cC imadisj sylibr $.
    $( [25-Jan-2007] $) $( [23-Jan-2007] $)

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    fint.1 $e |- B =/= (/) $.
    $( Function into an intersection. $)
    fint $p |- ( F : A --> |^| B <-> A. x e. B F : A --> x ) $=
      cF cA wfn cF crn cB cint wss wa cF cA wfn cF crn vx cv wss wa vx cB wral
      cA cB cint cF wf cA vx cv cF wf vx cB wral cF cA wfn cF crn cB cint wss
      wa cF cA wfn vx cB wral cF crn vx cv wss vx cB wral wa cF cA wfn cF crn
      vx cv wss wa vx cB wral cF cA wfn cF cA wfn vx cB wral cF crn cB cint wss
      cF crn vx cv wss vx cB wral cB c0 wne cF cA wfn cF cA wfn vx cB wral wb
      fint.1 cF cA wfn vx cB r19.3rzv ax-mp vx cF crn cB ssint anbi12i cF cA
      wfn cF crn vx cv wss vx cB r19.26 bitr4i cA cB cint cF df-f cA vx cv cF
      wf cF cA wfn cF crn vx cv wss wa vx cB cA vx cv cF df-f ralbii 3bitr4i $.
      $( [25-Jan-2007] $) $( [14-Oct-1999] $)
  $}

  $( Mapping into an intersection. $)
  fin $p |- ( F : A --> ( B i^i C ) <-> ( F : A --> B /\ F : A --> C ) ) $=
    cF cA wfn cF crn cB cC cin wss wa cF cA wfn cF crn cB wss wa cF cA wfn cF
    crn cC wss wa wa cA cB cC cin cF wf cA cB cF wf cA cC cF wf wa cF cA wfn cF
    crn cB cC cin wss wa cF cA wfn cF cA wfn wa cF crn cB wss cF crn cC wss wa
    wa cF cA wfn cF crn cB wss wa cF cA wfn cF crn cC wss wa wa cF cA wfn cF cA
    wfn wa cF cA wfn cF crn cB wss cF crn cC wss wa cF crn cB cC cin wss cF cA
    wfn anidm cF crn cB cC ssin anbi12i cF cA wfn cF cA wfn cF crn cB wss cF
    crn cC wss an4 bitr3i cA cB cC cin cF df-f cA cB cF wf cF cA wfn cF crn cB
    wss wa cA cC cF wf cF cA wfn cF crn cC wss wa cA cB cF df-f cA cC cF df-f
    anbi12i 3bitr4i $.
    $( [14-Sep-1999] $)

  $( If the domain of a mapping is a set, the function is a set. $)
  fex $p |- ( ( F : A --> B /\ A e. C ) -> F e. _V ) $=
    cF cA wfn cA cC wcel cF cvv wcel cA cB cF wf cA cC cF fnex cA cB cF ffn
    sylan $.
    $( [11-Sep-2006] $) $( [3-Oct-1999] $)

  ${
    $d A x $.  $d B x $.
    fabexg.1 $e |- F = { x | ( x : A --> B /\ ph ) } $.
    $( Existence of a set of functions.  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    fabexg $p |- ( ( A e. C /\ B e. D ) -> F e. _V ) $=
      cA cC wcel cB cD wcel wa cA cB cxp cvv wcel cA cB cxp cpw cvv wcel cF cvv
      wcel cA cB cC cD xpexg cA cB cxp cvv pwexg cF cA cB cxp cpw wss cA cB cxp
      cpw cvv wcel cF cvv wcel cF vx cv cA cB cxp cpw wcel wph wa vx cab cA cB
      cxp cpw cF cA cB vx cv wf wph wa vx cab vx cv cA cB cxp cpw wcel wph wa
      vx cab fabexg.1 cA cB vx cv wf wph wa vx cv cA cB cxp cpw wcel wph wa vx
      cA cB vx cv wf vx cv cA cB cxp cpw wcel wph cA cB vx cv wf vx cv cA cB
      cxp wss vx cv cA cB cxp cpw wcel cA cB vx cv fssxp vx cv cA cB cxp vx
      visset elpw sylibr anim1i ss2abi eqsstri wph vx cA cB cxp cpw ssab2 sstri
      cF cA cB cxp cpw cvv ssexg mpan 3syl $.
      $( [25-Feb-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d x A $.  $d x B $.
    fabex.1 $e |- A e. _V $.
    fabex.2 $e |- B e. _V $.
    fabex.3 $e |- F = { x | ( x : A --> B /\ ph ) } $.
    $( Existence of a set of functions. $)
    fabex $p |- F e. _V $=
      cA cvv wcel cB cvv wcel cF cvv wcel fabex.1 fabex.2 wph vx cA cB cvv cvv
      cF fabex.3 fabexg mp2an $.
      $( [10-Mar-2008] $) $( [3-Dec-2007] $)
  $}

  $( If a mapping is a set, its domain is a set. $)
  dmfex $p |- ( ( F e. C /\ F : A --> B ) -> A e. _V ) $=
    cF cC wcel cF cdm cA wceq cA cvv wcel cA cB cF wf cF cC wcel cF cdm cA wceq
    wa cF cdm cA cvv cF cC wcel cF cdm cA wceq pm3.27 cF cC wcel cF cdm cvv
    wcel cF cdm cA wceq cF cC dmexg adantr eqeltrrd cA cB cF fdm sylan2 $.
    $( [28-Aug-2006] $) $( [27-Aug-2006] $)

  $( The empty function. $)
  f0 $p |- (/) : (/) --> A $=
    c0 cA c0 wf c0 c0 wfn c0 crn cA wss c0 cA c0 df-f c0 c0 wfn c0 c0 wceq c0
    eqid c0 fn0 mpbir c0 crn c0 cA rn0 cA 0ss eqsstri mpbir2an $.
    $( [14-Aug-1999] $)

  $( A class is a function with empty codomain iff it and its domain are
     empty. $)
  f00 $p |- ( F : A --> (/) <-> ( F = (/) /\ A = (/) ) ) $=
    cA c0 cF wf cF c0 wceq cA c0 wceq wa cA c0 cF wf cF c0 wceq cA c0 wceq cA
    c0 cF wf cF c0 wfn cF c0 wceq cF c0 wfn cF wfun cF cdm c0 wceq cA c0 cF wf
    cF c0 df-fn cA c0 cF ffun cA c0 cF wf cF crn c0 wceq cF cdm c0 wceq cA c0
    cF wf cF crn c0 wss cF crn c0 wceq cA c0 cF frn cF crn ss0 syl cF dm0rn0
    sylibr sylanbrc cF fn0 sylib cA c0 cF wf cF cdm cA c0 cA c0 cF fdm cA c0 cF
    wf cF crn c0 wceq cF cdm c0 wceq cA c0 cF wf cF crn c0 wss cF crn c0 wceq
    cA c0 cF frn cF crn ss0 syl cF dm0rn0 sylibr eqtr3d jca cF c0 wceq cA c0
    wceq wa cA c0 cF wf c0 c0 c0 wf c0 f0 cF c0 wceq cA c0 cF wf cA c0 c0 wf cA
    c0 wceq c0 c0 c0 wf cA c0 cF c0 feq1 cA c0 c0 c0 feq2 sylan9bb mpbiri
    impbii $.
    $( [27-Dec-2003] $) $( [10-Dec-2003] $)

  ${
    $d x y A $.  $d x y B $.
    fconst.1 $e |- B e. _V $.
    $( A cross product with a singleton is a constant function. $)
    fconst $p |- ( A X. { B } ) : A --> { B } $=
      cA cB csn cA cB csn cxp wf cA c0 cA c0 wceq cA cB csn cA cB csn cxp wf c0
      cB csn c0 wf cB csn f0 cA c0 wceq cA cB csn cA cB csn cxp wf cA cB csn c0
      wf c0 cB csn c0 wf cA c0 wceq cA cB csn cA cB csn cxp c0 cA c0 wceq cA cB
      csn cxp c0 cB csn cxp c0 cA c0 cB csn xpeq1 cB csn xp0r syl6eq feq1d cA
      c0 cB csn c0 feq2 bitrd mpbiri cA c0 wne cA cB csn cxp cA wfn cA cB csn
      cxp crn cB csn wss wa cA cB csn cA cB csn cxp wf cA c0 wne cA cB csn cxp
      crn cB csn wss cA cB csn cxp cA wfn cA c0 wne cA cB csn cxp crn cB csn
      wceq cA cB csn cxp crn cB csn wss cA cB csn rnxp cA cB csn cxp crn cB csn
      eqimss syl cA cB csn cxp cA wfn cA cB csn cxp wfun cA cB csn cxp cdm cA
      wceq cA cB csn cxp cA df-fn cA cB csn cxp wfun cA cB csn cxp wrel vx cv
      vy cv cA cB csn cxp wbr vy wmo vx wal vx vy cA cB csn cxp dffun6 cA cB
      csn relxp vx cv vy cv cA cB csn cxp wbr vy wmo vx vx cv vy cv cA cB csn
      cxp wbr vy wmo vx cv cA wcel vy cv cB wceq wa vy wmo vy cv cB wceq vx cv
      cA wcel vy vy cB moeq moani vx cv vy cv cA cB csn cxp wbr vx cv cA wcel
      vy cv cB wceq wa vy vx cv vy cv cA cB csn cxp wbr vx cv cA wcel vy cv cB
      csn wcel wa vx cv cA wcel vy cv cB wceq wa vx cv vy cv cA cB csn vy
      visset brxp vy cv cB csn wcel vy cv cB wceq vx cv cA wcel vy cB elsn
      anbi2i bitri mobii mpbir ax-gen mpbir2an cB csn c0 wne cA cB csn cxp cdm
      cA wceq cB fconst.1 snnz cA cB csn dmxp ax-mp mpbir2an jctil cA cB csn cA
      cB csn cxp df-f sylibr pm2.61ine $.
      $( [14-Aug-1999] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( A cross product with a singleton is a constant function. $)
    fconstg $p |- ( B e. C -> ( A X. { B } ) : A --> { B } ) $=
      cA vx cv csn cA vx cv csn cxp wf cA cB csn cA cB csn cxp wf vx cB cC cA
      vx cv csn cxp cA cB csn cxp wceq vx cv csn cB csn wceq cA vx cv csn cA vx
      cv csn cxp wf cA cB csn cA cB csn cxp wf wb vx cv cB wceq cA vx cv csn
      cxp cA cB csn cxp wceq cA vx cv csn cA vx cv csn cxp wf cA vx cv csn cA
      cB csn cxp wf vx cv csn cB csn wceq cA cB csn cA cB csn cxp wf cA vx cv
      csn cA vx cv csn cxp cA cB csn cxp feq1 vx cv csn cB csn cA cA cB csn cxp
      feq3 sylan9bb vx cv cB wceq vx cv csn cB csn wceq cA vx cv csn cxp cA cB
      csn cxp wceq vx cv cB sneq vx cv csn cB csn cA xpeq2 syl vx cv cB sneq
      sylanc cA vx cv vx visset fconst vtoclg $.
      $( [22-Oct-2004] $) $( [19-Oct-2004] $)
  $}

  $( Equality theorem for one-to-one functions. $)
  f1eq1 $p |- ( F = G -> ( F : A -1-1-> B <-> G : A -1-1-> B ) ) $=
    cF cG wceq cA cB cF wf cF ccnv wfun wa cA cB cG wf cG ccnv wfun wa cA cB cF
    wf1 cA cB cG wf1 cF cG wceq cA cB cF wf cA cB cG wf cF ccnv wfun cG ccnv
    wfun cA cB cF cG feq1 cF cG wceq cF ccnv cG ccnv wceq cF ccnv wfun cG ccnv
    wfun wb cF cG cnveq cF ccnv cG ccnv funeq syl anbi12d cA cB cF df-f1 cA cB
    cG df-f1 3bitr4g $.
    $( [10-Feb-1997] $)

  $( Equality theorem for one-to-one functions. $)
  f1eq2 $p |- ( A = B -> ( F : A -1-1-> C <-> F : B -1-1-> C ) ) $=
    cA cB wceq cA cC cF wf cF ccnv wfun wa cB cC cF wf cF ccnv wfun wa cA cC cF
    wf1 cB cC cF wf1 cA cB wceq cA cC cF wf cB cC cF wf cF ccnv wfun cA cB cC
    cF feq2 anbi1d cA cC cF df-f1 cB cC cF df-f1 3bitr4g $.
    $( [10-Feb-1997] $)

  $( Equality theorem for one-to-one functions. $)
  f1eq3 $p |- ( A = B -> ( F : C -1-1-> A <-> F : C -1-1-> B ) ) $=
    cA cB wceq cC cA cF wf cF ccnv wfun wa cC cB cF wf cF ccnv wfun wa cC cA cF
    wf1 cC cB cF wf1 cA cB wceq cC cA cF wf cC cB cF wf cF ccnv wfun cA cB cC
    cF feq3 anbi1d cC cA cF df-f1 cC cB cF df-f1 3bitr4g $.
    $( [10-Feb-1997] $)

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    hbf1.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbf1.2 $e |- ( y e. A -> A. x y e. A ) $.
    hbf1.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for a one-to-one function. $)
    hbf1 $p |- ( F : A -1-1-> B -> A. x F : A -1-1-> B ) $=
      cA cB cF wf cF ccnv wfun wa cA cB cF wf cF ccnv wfun wa vx wal cA cB cF
      wf1 cA cB cF wf1 vx wal cA cB cF wf cF ccnv wfun vx vx vy cA cB cF hbf1.1
      hbf1.2 hbf1.3 hbf vx vy cF ccnv vx vy cF hbf1.1 hbcnv hbfun hban cA cB cF
      df-f1 cA cB cF wf1 cA cB cF wf cF ccnv wfun wa vx cA cB cF df-f1 albii
      3imtr4i $.
      $( [16-May-2004] $) $( [16-May-2004] $)
  $}

  ${
    $d x y F $.
    $( Alternate definition of a one-to-one function. $)
    dff12 $p |- ( F : A -1-1-> B <-> ( F : A --> B /\ A. y E* x x F y ) ) $=
      cA cB cF wf1 cA cB cF wf cF ccnv wfun wa cA cB cF wf vx cv vy cv cF wbr
      vx wmo vy wal wa cA cB cF df-f1 cF ccnv wfun vx cv vy cv cF wbr vx wmo vy
      wal cA cB cF wf cF ccnv wfun vy cv vx cv cF ccnv wbr vx wmo vy wal vx cv
      vy cv cF wbr vx wmo vy wal cF ccnv wfun cF ccnv wrel vy cv vx cv cF ccnv
      wbr vx wmo vy wal vy vx cF ccnv dffun6 cF relcnv mpbiran vy cv vx cv cF
      ccnv wbr vx wmo vx cv vy cv cF wbr vx wmo vy vy cv vx cv cF ccnv wbr vx
      cv vy cv cF wbr vx vy cv vx cv cF vy visset vx visset brcnv mobii albii
      bitri anbi2i bitri $.
      $( [22-Sep-2004] $) $( [31-Dec-1996] $)
  $}

  $( A one-to-one mapping is a mapping. $)
  f1f $p |- ( F : A -1-1-> B -> F : A --> B ) $=
    cA cB cF wf1 cA cB cF wf cF ccnv wfun cA cB cF df-f1 pm3.26bi $.
    $( [31-Dec-1996] $)

  $( Two ways to express that a set ` A ` (not necessarily a function) is
     one-to-one.  Each side is equivalent to Definition 6.4(3) of
     [TakeutiZaring] p. 24, who use the notation "Un_2 (A)" for one-to-one.
     We do not introduce a separate notation since we rarely use it. $)
  f1cnv $p |- ( `' `' A : dom A -1-1-> _V <-> ( Fun `' A /\ Fun `' `' A ) ) $=
    cA cdm cvv cA ccnv ccnv wf1 cA cdm cvv cA ccnv ccnv wf cA ccnv ccnv ccnv
    wfun wa cA ccnv ccnv wfun cA ccnv wfun wa cA ccnv wfun cA ccnv ccnv wfun wa
    cA cdm cvv cA ccnv ccnv df-f1 cA cdm cvv cA ccnv ccnv wf cA ccnv ccnv wfun
    cA ccnv ccnv ccnv wfun cA ccnv wfun cA cdm cvv cA ccnv ccnv wf cA ccnv ccnv
    cA cdm wfn cA ccnv ccnv wfun cA cdm cA ccnv ccnv dffn2 cA ccnv ccnv cA cdm
    wfn cA ccnv ccnv wfun cA ccnv ccnv cdm cA cdm wceq cA ccnv ccnv cA cdm
    df-fn cA dmcnvcnv mpbiran2 bitr3i cA ccnv ccnv ccnv cA ccnv wceq cA ccnv
    ccnv ccnv wfun cA ccnv wfun wb cA ccnv wrel cA ccnv ccnv ccnv cA ccnv wceq
    cA relcnv cA ccnv dfrel2 mpbi cA ccnv ccnv ccnv cA ccnv funeq ax-mp anbi12i
    cA ccnv ccnv wfun cA ccnv wfun ancom 3bitri $.
    $( [5-Nov-2004] $) $( [13-Aug-2004] $)

  $( Composition of one-to-one functions.  Exercise 30 of [TakeutiZaring]
     p. 25. $)
  f1co $p |- ( ( F : B -1-1-> C /\ G : A -1-1-> B ) ->
              ( F o. G ) : A -1-1-> C ) $=
    cB cC cF wf cF ccnv wfun wa cA cB cG wf cG ccnv wfun wa wa cA cC cF cG ccom
    wf cF cG ccom ccnv wfun wa cB cC cF wf1 cA cB cG wf1 wa cA cC cF cG ccom
    wf1 cB cC cF wf cA cB cG wf cF ccnv wfun cG ccnv wfun cA cC cF cG ccom wf
    cF cG ccom ccnv wfun wa cB cC cF wf cA cB cG wf wa cA cC cF cG ccom wf cF
    ccnv wfun cG ccnv wfun wa cF cG ccom ccnv wfun cA cB cC cF cG fco cG ccnv
    wfun cF ccnv wfun cF cG ccom ccnv wfun cG ccnv wfun cF ccnv wfun wa cG ccnv
    cF ccnv ccom wfun cF cG ccom ccnv wfun cG ccnv cF ccnv funco cF cG ccom
    ccnv cG ccnv cF ccnv ccom wceq cF cG ccom ccnv wfun cG ccnv cF ccnv ccom
    wfun wb cF cG cnvco cF cG ccom ccnv cG ccnv cF ccnv ccom funeq ax-mp sylibr
    ancoms anim12i an4s cB cC cF wf1 cB cC cF wf cF ccnv wfun wa cA cB cG wf1
    cA cB cG wf cG ccnv wfun wa cB cC cF df-f1 cA cB cG df-f1 anbi12i cA cC cF
    cG ccom df-f1 3imtr4i $.
    $( [28-May-1998] $)

  $( Equality theorem for onto functions. $)
  foeq1 $p |- ( F = G -> ( F : A -onto-> B <-> G : A -onto-> B ) ) $=
    cF cG wceq cF cA wfn cF crn cB wceq wa cG cA wfn cG crn cB wceq wa cA cB cF
    wfo cA cB cG wfo cF cG wceq cF cA wfn cG cA wfn cF crn cB wceq cG crn cB
    wceq cA cF cG fneq1 cF cG wceq cF crn cG crn cB cF cG rneq eqeq1d anbi12d
    cA cB cF df-fo cA cB cG df-fo 3bitr4g $.
    $( [1-Aug-1994] $)

  $( Equality theorem for onto functions. $)
  foeq2 $p |- ( A = B -> ( F : A -onto-> C <-> F : B -onto-> C ) ) $=
    cA cB wceq cF cA wfn cF crn cC wceq wa cF cB wfn cF crn cC wceq wa cA cC cF
    wfo cB cC cF wfo cA cB wceq cF cA wfn cF cB wfn cF crn cC wceq cA cB cF
    fneq2 anbi1d cA cC cF df-fo cB cC cF df-fo 3bitr4g $.
    $( [1-Aug-1994] $)

  $( Equality theorem for onto functions. $)
  foeq3 $p |- ( A = B -> ( F : C -onto-> A <-> F : C -onto-> B ) ) $=
    cA cB wceq cF cC wfn cF crn cA wceq wa cF cC wfn cF crn cB wceq wa cC cA cF
    wfo cC cB cF wfo cA cB wceq cF crn cA wceq cF crn cB wceq cF cC wfn cA cB
    cF crn eqeq2 anbi2d cC cA cF df-fo cC cB cF df-fo 3bitr4g $.
    $( [1-Aug-1994] $)

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    hbfo.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbfo.2 $e |- ( y e. A -> A. x y e. A ) $.
    hbfo.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for an onto function. $)
    hbfo $p |- ( F : A -onto-> B -> A. x F : A -onto-> B ) $=
      cF cA wfn cF crn cB wceq wa cF cA wfn cF crn cB wceq wa vx wal cA cB cF
      wfo cA cB cF wfo vx wal cF cA wfn cF crn cB wceq vx vx vy cA cF hbfo.1
      hbfo.2 hbfn vx vy vy cF crn cB vx vy cF hbfo.1 hbrn hbfo.3 hbeq hban cA
      cB cF df-fo cA cB cF wfo cF cA wfn cF crn cB wceq wa vx cA cB cF df-fo
      albii 3imtr4i $.
      $( [16-May-2004] $) $( [16-May-2004] $)
  $}

  $( An onto mapping is a mapping. $)
  fof $p |- ( F : A -onto-> B -> F : A --> B ) $=
    cF cA wfn cF crn cB wceq wa cF cA wfn cF crn cB wss wa cA cB cF wfo cA cB
    cF wf cF crn cB wceq cF crn cB wss cF cA wfn cF crn cB eqimss anim2i cA cB
    cF df-fo cA cB cF df-f 3imtr4i $.
    $( [3-Aug-1994] $)

  $( An onto mapping is a function. $)
  fofun $p |- ( F : A -onto-> B -> Fun F ) $=
    cA cB cF wfo cA cB cF wf cF wfun cA cB cF fof cA cB cF ffun syl $.
    $( [30-Mar-2008] $) $( [29-Mar-2008] $)

  $( An onto mapping is a function on its domain. $)
  fofn $p |- ( F : A -onto-> B -> F Fn A ) $=
    cA cB cF wfo cA cB cF wf cF cA wfn cA cB cF fof cA cB cF ffn syl $.
    $( [16-Dec-2008] $) $( [16-Dec-2008] $)

  $( The codomain of an onto function is its range. $)
  forn $p |- ( F : A -onto-> B -> ran F = B ) $=
    cA cB cF wfo cF cA wfn cF crn cB wceq cA cB cF df-fo pm3.27bi $.
    $( [3-Aug-1994] $)

  $( Alternate definition of an onto function. $)
  dffo2 $p |- ( F : A -onto-> B <-> ( F : A --> B /\ ran F = B ) ) $=
    cA cB cF wfo cA cB cF wf cF crn cB wceq wa cA cB cF wfo cA cB cF wf cF crn
    cB wceq cA cB cF fof cA cB cF forn jca cF cA wfn cF crn cB wceq cA cB cF
    wfo cA cB cF wf cA cB cF wfo cF cA wfn cF crn cB wceq wa cA cB cF df-fo
    biimpri cA cB cF ffn sylan impbii $.
    $( [23-Mar-2006] $) $( [22-Mar-2006] $)

  $( The image of the domain of an onto function. $)
  foima $p |- ( F : A -onto-> B -> ( F " A ) = B ) $=
    cA cB cF wfo cF cA cima cF crn cB cA cB cF wfo cF cF cdm cima cF cA cima cF
    crn cA cB cF wfo cA cB cF wf cF cdm cA wceq cF cF cdm cima cF cA cima wceq
    cA cB cF fof cA cB cF fdm cF cdm cA cF imaeq2 3syl cF imadmrn syl5reqr cA
    cB cF forn eqtrd $.
    $( [29-Nov-2002] $)

  $( A function maps onto its range. $)
  dffn4 $p |- ( F Fn A <-> F : A -onto-> ran F ) $=
    cF cA wfn cF cA wfn cF crn cF crn wceq wa cA cF crn cF wfo cF crn cF crn
    wceq cF cA wfn cF crn eqid biantru cA cF crn cF df-fo bitr4i $.
    $( [10-May-1998] $)

  $( A function maps its domain onto its range. $)
  funforn $p |- ( Fun A <-> A : dom A -onto-> ran A ) $=
    cA wfun cA cA cdm wfn cA cdm cA crn cA wfo cA funfn cA cdm cA dffn4 bitri
    $.
    $( [30-Jul-2004] $) $( [23-Jul-2004] $)

  $( If the domain of an onto function exists, so does its codomain. $)
  fornex $p |- ( A e. C -> ( F : A -onto-> B -> B e. _V ) ) $=
    cA cB cF wfo cA cC wcel cB cvv wcel cA cB cF wfo cF cdm cC wcel cF crn cvv
    wcel cA cC wcel cB cvv wcel cA cB cF wfo cF wfun cF cdm cC wcel cF crn cvv
    wcel wi cA cB cF fofun cF cdm cC wcel cF wfun cF crn cvv wcel cC cF funrnex
    com12 syl cA cB cF wfo cF cdm cA cC cA cB cF wfo cA cB cF wf cF cdm cA wceq
    cA cB cF fof cA cB cF fdm syl eleq1d cA cB cF wfo cF crn cB cvv cA cB cF
    forn eleq1d 3imtr3d com12 $.
    $( [30-Jul-2004] $) $( [23-Jul-2004] $)

  $( An onto function has unique domain and range. $)
  fodmrnu $p |- ( ( F : A -onto-> B /\ F : C -onto-> D ) ->
                ( A = C /\ B = D ) ) $=
    cA cB cF wfo cC cD cF wfo wa cA cC wceq cB cD wceq cF cA wfn cF cC wfn cA
    cC wceq cA cB cF wfo cC cD cF wfo cA cC cF fndmu cA cB cF fofn cC cD cF
    fofn syl2an cA cB cF wfo cC cD cF wfo cB cF crn cD cA cB cF forn cC cD cF
    forn sylan9req jca $.
    $( [10-Jan-2007] $) $( [5-Nov-2006] $)

  $( Restriction of a function. $)
  fores $p |- ( ( Fun F /\ A C_ dom F ) ->
              ( F |` A ) :  A -onto-> ( F " A ) ) $=
    cF wfun cA cF cdm wss wa cF cA cres wfun cA cF cdm wss wa cA cF cA cima cF
    cA cres wfo cF wfun cF cA cres wfun cA cF cdm wss cA cF funres anim1i cF cA
    cres cA wfn cF cA cres wfun cF cA cres cdm cA wceq wa cA cF cA cima cF cA
    cres wfo cF cA cres wfun cA cF cdm wss wa cF cA cres cA df-fn cA cF cA cima
    cF cA cres wfo cF cA cres cA wfn cF cA cres crn cF cA cima wceq cA cF cA
    cima cF cA cres df-fo cF cA cima cF cA cres crn cF cA df-ima eqcomi
    mpbiran2 cA cF cdm wss cF cA cres cdm cA wceq cF cA cres wfun cA cF ssdmres
    anbi2i 3bitr4i sylibr $.
    $( [4-Mar-1997] $)

  $( Composition of onto functions. $)
  foco $p |- ( ( F : B -onto-> C /\ G : A -onto-> B ) ->
             ( F o. G ) : A -onto-> C ) $=
    cB cC cF wf cF crn cC wceq wa cA cB cG wf cG crn cB wceq wa wa cA cC cF cG
    ccom wf cF cG ccom crn cC wceq wa cB cC cF wfo cA cB cG wfo wa cA cC cF cG
    ccom wfo cB cC cF wf cF crn cC wceq wa cA cB cG wf cG crn cB wceq wa wa cA
    cC cF cG ccom wf cF cG ccom crn cC wceq cB cC cF wf cA cB cG wf cA cC cF cG
    ccom wf cF crn cC wceq cG crn cB wceq cA cB cC cF cG fco ad2ant2r cB cC cF
    wf cF crn cC wceq wa cG crn cB wceq cF cG ccom crn cC wceq cA cB cG wf cB
    cC cF wf cG crn cB wceq cF crn cC wceq cF cG ccom crn cC wceq cF cdm cG crn
    wceq cF crn cC wceq cF cG ccom crn cC wceq cB cC cF wf cG crn cB wceq wa cF
    cdm cG crn wceq cF cG ccom crn cC wceq cF crn cC wceq cF cdm cG crn wceq cF
    cG ccom crn cF crn cC cF cG rncoeq eqeq1d biimpar cF cdm cB wceq cG crn cB
    wceq cF cdm cG crn wceq cB cC cF wf cF cdm cG crn cB eqtr3 cB cC cF fdm
    sylan sylan an1rs adantrl jca cB cC cF wfo cB cC cF wf cF crn cC wceq wa cA
    cB cG wfo cA cB cG wf cG crn cB wceq wa cB cC cF dffo2 cA cB cG dffo2
    anbi12i cA cC cF cG ccom dffo2 3imtr4i $.
    $( [23-Mar-2006] $) $( [22-Mar-2006] $)

  $( A non-zero constant function is onto. $)
  foconst $p |- ( ( F : A --> { B } /\ F =/= (/) ) -> F : A -onto-> { B } ) $=
    cA cB csn cF wf cF c0 wne wa cA cB csn cF wf cF crn cB csn wceq wa cA cB
    csn cF wfo cA cB csn cF wf cF c0 wne cF crn cB csn wceq cA cB csn cF wf cF
    c0 wne cF crn c0 wceq wn cF crn cB csn wceq cA cB csn cF wf cF wrel cF c0
    wne cF crn c0 wceq wn wb cA cB csn cF frel cF wrel cF crn c0 wceq cF c0 cF
    relrn0 necon3abid syl cA cB csn cF wf cF crn c0 wceq cF crn cB csn wceq cA
    cB csn cF wf cF crn cB csn wss cF crn c0 wceq cF crn cB csn wceq wo cA cB
    csn cF frn cF crn cB sssn sylib ord sylbid imdistani cA cB csn cF dffo2
    sylibr $.
    $( [19-Jan-2007] $) $( [12-Jan-2007] $)

  $( Equality theorem for one-to-one onto functions. $)
  f1oeq1 $p |- ( F = G -> ( F : A -1-1-onto-> B <-> G : A -1-1-onto-> B ) ) $=
    cF cG wceq cA cB cF wf1 cA cB cF wfo wa cA cB cG wf1 cA cB cG wfo wa cA cB
    cF wf1o cA cB cG wf1o cF cG wceq cA cB cF wf1 cA cB cG wf1 cA cB cF wfo cA
    cB cG wfo cA cB cF cG f1eq1 cA cB cF cG foeq1 anbi12d cA cB cF df-f1o cA cB
    cG df-f1o 3bitr4g $.
    $( [10-Feb-1997] $)

  $( Equality theorem for one-to-one onto functions. $)
  f1oeq2 $p |- ( A = B -> ( F : A -1-1-onto-> C <-> F : B -1-1-onto-> C ) ) $=
    cA cB wceq cA cC cF wf1 cA cC cF wfo wa cB cC cF wf1 cB cC cF wfo wa cA cC
    cF wf1o cB cC cF wf1o cA cB wceq cA cC cF wf1 cB cC cF wf1 cA cC cF wfo cB
    cC cF wfo cA cB cC cF f1eq2 cA cB cC cF foeq2 anbi12d cA cC cF df-f1o cB cC
    cF df-f1o 3bitr4g $.
    $( [10-Feb-1997] $)

  $( Equality theorem for one-to-one onto functions. $)
  f1oeq3 $p |- ( A = B -> ( F : C -1-1-onto-> A <-> F : C -1-1-onto-> B ) ) $=
    cA cB wceq cC cA cF wf1 cC cA cF wfo wa cC cB cF wf1 cC cB cF wfo wa cC cA
    cF wf1o cC cB cF wf1o cA cB wceq cC cA cF wf1 cC cB cF wf1 cC cA cF wfo cC
    cB cF wfo cA cB cC cF f1eq3 cA cB cC cF foeq3 anbi12d cC cA cF df-f1o cC cB
    cF df-f1o 3bitr4g $.
    $( [10-Feb-1997] $)

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    hbf1o.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbf1o.2 $e |- ( y e. A -> A. x y e. A ) $.
    hbf1o.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for a one-to-one onto function. $)
    hbf1o $p |- ( F : A -1-1-onto-> B -> A. x F : A -1-1-onto-> B ) $=
      cA cB cF wf1 cA cB cF wfo wa cA cB cF wf1 cA cB cF wfo wa vx wal cA cB cF
      wf1o cA cB cF wf1o vx wal cA cB cF wf1 cA cB cF wfo vx vx vy cA cB cF
      hbf1o.1 hbf1o.2 hbf1o.3 hbf1 vx vy cA cB cF hbf1o.1 hbf1o.2 hbf1o.3 hbfo
      hban cA cB cF df-f1o cA cB cF wf1o cA cB cF wf1 cA cB cF wfo wa vx cA cB
      cF df-f1o albii 3imtr4i $.
      $( [16-May-2004] $) $( [16-May-2004] $)
  $}

  $( A one-to-one onto mapping is a one-to-one mapping. $)
  f1of1 $p |- ( F : A -1-1-onto-> B -> F : A -1-1-> B ) $=
    cA cB cF wf1o cA cB cF wf1 cA cB cF wfo cA cB cF df-f1o pm3.26bi $.
    $( [17-Dec-2003] $) $( [12-Dec-2003] $)

  $( A one-to-one onto mapping is a mapping. $)
  f1of $p |- ( F : A -1-1-onto-> B -> F : A --> B ) $=
    cA cB cF wf1o cA cB cF wf1 cA cB cF wf cA cB cF f1of1 cA cB cF f1f syl $.
    $( [12-Dec-2003] $) $( [12-Dec-2003] $)

  $( A one-to-one onto mapping is function on its domain. $)
  f1ofn $p |- ( F : A -1-1-onto-> B -> F Fn A ) $=
    cA cB cF wf1o cA cB cF wf cF cA wfn cA cB cF f1of cA cB cF ffn syl $.
    $( [17-Dec-2003] $) $( [12-Dec-2003] $)

  $( A one-to-one onto mapping is a function. $)
  f1ofun $p |- ( F : A -1-1-onto-> B -> Fun F ) $=
    cA cB cF wf1o cF cA wfn cF wfun cA cB cF f1ofn cA cF fnfun syl $.
    $( [17-Dec-2003] $) $( [12-Dec-2003] $)

  $( A one-to-one onto mapping is a relation. $)
  f1orel $p |- ( F : A -1-1-onto-> B -> Rel F ) $=
    cA cB cF wf1o cF wfun cF wrel cA cB cF f1ofun cF funrel syl $.
    $( [6-Jan-2004] $) $( [13-Dec-2003] $)

  $( Alternate definition of one-to-one onto function. $)
  dff1o2 $p |- ( F : A -1-1-onto-> B
        <-> ( F Fn A /\ Fun `' F /\ ran F = B ) ) $=
    cA cB cF wf1 cA cB cF wfo wa cF cA wfn cF ccnv wfun cF crn cB wceq wa wa cA
    cB cF wf1o cF cA wfn cF ccnv wfun cF crn cB wceq w3a cA cB cF wf1 cA cB cF
    wfo wa cF ccnv wfun cF cA wfn cF crn cB wceq wa wa cF cA wfn cF ccnv wfun
    cF crn cB wceq wa wa cA cB cF wf1 cA cB cF wfo wa cF ccnv wfun cF cA wfn cF
    crn cB wceq wa wa cA cB cF wf1 cF ccnv wfun cA cB cF wfo cF cA wfn cF crn
    cB wceq wa cA cB cF wf1 cA cB cF wf cF ccnv wfun cA cB cF df-f1 pm3.27bi cA
    cB cF wfo cF cA wfn cF crn cB wceq wa cA cB cF df-fo biimpi anim12i cF ccnv
    wfun cF cA wfn cF crn cB wceq wa wa cA cB cF wf1 cA cB cF wfo cF cA wfn cF
    crn cB wceq wa cF ccnv wfun cA cB cF wf1 cF cA wfn cF crn cB wceq wa cF
    ccnv wfun wa cA cB cF wf cF ccnv wfun wa cA cB cF wf1 cF cA wfn cF crn cB
    wceq wa cA cB cF wf cF ccnv wfun cF cA wfn cF crn cB wceq wa cF cA wfn cF
    crn cB wss wa cA cB cF wf cF crn cB wceq cF crn cB wss cF cA wfn cF crn cB
    eqimss anim2i cA cB cF df-f sylibr anim1i cA cB cF df-f1 sylibr ancoms cF
    cA wfn cF crn cB wceq wa cA cB cF wfo cF ccnv wfun cA cB cF wfo cF cA wfn
    cF crn cB wceq wa cA cB cF df-fo biimpri adantl jca impbii cF ccnv wfun cF
    cA wfn cF crn cB wceq an12 bitri cA cB cF df-f1o cF cA wfn cF ccnv wfun cF
    crn cB wceq 3anass 3bitr4i $.
    $( [10-Feb-1997] $)

  $( Alternate definition of one-to-one onto function. $)
  dff1o3 $p |- ( F : A -1-1-onto-> B <-> ( F : A -onto-> B /\ Fun `' F ) ) $=
    cA cB cF wf1 cA cB cF wfo wa cF cA wfn cF crn cB wceq wa cF ccnv wfun wa cA
    cB cF wf1o cA cB cF wfo cF ccnv wfun wa cA cB cF wf cF ccnv wfun wa cF cA
    wfn cF crn cB wceq wa wa cA cB cF wf cF cA wfn cF crn cB wceq wa wa cF ccnv
    wfun wa cA cB cF wf1 cA cB cF wfo wa cF cA wfn cF crn cB wceq wa cF ccnv
    wfun wa cA cB cF wf cF ccnv wfun cF cA wfn cF crn cB wceq wa an23 cA cB cF
    wf1 cA cB cF wf cF ccnv wfun wa cA cB cF wfo cF cA wfn cF crn cB wceq wa cA
    cB cF df-f1 cA cB cF df-fo anbi12i cF cA wfn cF crn cB wceq wa cA cB cF wf
    cF cA wfn cF crn cB wceq wa wa cF ccnv wfun cF cA wfn cF crn cB wceq wa cA
    cB cF wf cF cA wfn cF crn cB wceq wa cF cA wfn cF crn cB wss wa cA cB cF wf
    cF crn cB wceq cF crn cB wss cF cA wfn cF crn cB eqimss anim2i cA cB cF
    df-f sylibr pm4.71ri anbi1i 3bitr4i cA cB cF df-f1o cA cB cF wfo cF cA wfn
    cF crn cB wceq wa cF ccnv wfun cA cB cF df-fo anbi1i 3bitr4i $.
    $( [25-Mar-1998] $)

  $( A one-to-one onto function is an onto function. $)
  f1ofo $p |- ( F : A -1-1-onto-> B -> F : A -onto-> B ) $=
    cA cB cF wf1o cA cB cF wfo cF ccnv wfun cA cB cF dff1o3 pm3.26bi $.
    $( [30-Apr-2004] $) $( [28-Apr-2004] $)

  $( Alternate definition of one-to-one onto function. $)
  dff1o4 $p |- ( F : A -1-1-onto-> B <-> ( F Fn A /\ `' F Fn B ) ) $=
    cF cA wfn cF ccnv wfun cF crn cB wceq w3a cF cA wfn cF ccnv wfun cF crn cB
    wceq wa wa cA cB cF wf1o cF cA wfn cF ccnv cB wfn wa cF cA wfn cF ccnv wfun
    cF crn cB wceq 3anass cA cB cF dff1o2 cF ccnv cB wfn cF ccnv wfun cF crn cB
    wceq wa cF cA wfn cF ccnv cB wfn cF ccnv wfun cF ccnv cdm cB wceq wa cF
    ccnv wfun cF crn cB wceq wa cF ccnv cB df-fn cF crn cB wceq cF ccnv cdm cB
    wceq cF ccnv wfun cF crn cF ccnv cdm cB cF df-rn eqeq1i anbi2i bitr4i
    anbi2i 3bitr4i $.
    $( [25-Mar-1998] $)

  $( Alternate definition of one-to-one onto function. $)
  dff1o5 $p |- ( F : A -1-1-onto-> B <-> ( F : A -1-1-> B /\ ran F = B ) ) $=
    cA cB cF wf1o cA cB cF wf1 cA cB cF wfo wa cA cB cF wf1 cF cA wfn cF crn cB
    wceq wa wa cA cB cF wf1 cF crn cB wceq wa cA cB cF df-f1o cA cB cF wfo cF
    cA wfn cF crn cB wceq wa cA cB cF wf1 cA cB cF df-fo anbi2i cA cB cF wf1 cF
    cA wfn cF crn cB wceq wa wa cF cA wfn cA cB cF wf1 cF crn cB wceq wa wa cA
    cB cF wf1 cF crn cB wceq wa cA cB cF wf1 cF cA wfn cF crn cB wceq an12 cA
    cB cF wf1 cF crn cB wceq wa cF cA wfn cA cB cF wf1 cF cA wfn cF crn cB wceq
    cA cB cF wf1 cA cB cF wf cF cA wfn cA cB cF f1f cA cB cF ffn syl adantr
    pm4.71ri bitr4i 3bitri $.
    $( [16-Feb-2004] $) $( [10-Dec-2003] $)

  $( A one-to-one function maps onto its range. $)
  f1orn $p |- ( F : A -1-1-onto-> ran F <-> ( F Fn A /\ Fun `' F ) ) $=
    cF cA wfn cF ccnv wfun cF crn cF crn wceq w3a cF cA wfn cF ccnv wfun wa cF
    crn cF crn wceq wa cA cF crn cF wf1o cF cA wfn cF ccnv wfun wa cF cA wfn cF
    ccnv wfun cF crn cF crn wceq df-3an cA cF crn cF dff1o2 cF crn cF crn wceq
    cF cA wfn cF ccnv wfun wa cF crn eqid biantru 3bitr4i $.
    $( [5-Sep-2004] $) $( [13-Aug-2004] $)

  $( A one-to-one function maps one-to-one onto its range. $)
  f1f1orn $p |- ( F : A -1-1-> B -> F : A -1-1-onto-> ran F ) $=
    cA cF crn cF wf1o cF cA wfn cF ccnv wfun cA cB cF wf1 cA cF f1orn cA cB cF
    wf1 cA cB cF wf cF cA wfn cA cB cF f1f cA cB cF ffn syl cA cB cF wf1 cA cB
    cF wf cF ccnv wfun cA cB cF df-f1 pm3.27bi sylanbrc $.
    $( [5-Sep-2004] $) $( [4-Sep-2004] $)

  ${
    $d A f $.  $d B f $.
    f1oabexg.1 $e |- F = { f | ( f : A -1-1-onto-> B /\ ph ) } $.
    $( The class of all 1-1-onto functions mapping one set to another is a set.
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    f1oabexg $p |- ( ( A e. C /\ B e. D ) -> F e. _V ) $=
      cA cC wcel cB cD wcel wa cA cB vf cv wf1o wph wa vf cab cvv cF cA cB vf
      cv wf1o wph wa vf cab cA cB vf cv wf wph wa vf cab wss cA cB vf cv wf wph
      wa vf cab cvv wcel cA cB vf cv wf1o wph wa vf cab cvv wcel cA cC wcel cB
      cD wcel wa cA cB vf cv wf1o wph wa vf cab cA cB vf cv wf wph wa vf cab
      cvv ssexg cA cB vf cv wf1o wph wa cA cB vf cv wf wph wa vf cA cB vf cv
      wf1o cA cB vf cv wf wph cA cB vf cv f1of anim1i ss2abi wph vf cA cB cC cD
      cA cB vf cv wf wph wa vf cab cA cB vf cv wf wph wa vf cab eqid fabexg
      sylancr f1oabexg.1 syl5eqel $.
      $( [26-Feb-2008] $) $( [25-Feb-2008] $)
  $}

  $( The converse of a one-to-one onto function is also one-to-one onto. $)
  f1ocnv $p |- ( F : A -1-1-onto-> B -> `' F : B -1-1-onto-> A ) $=
    cF cA wfn cF ccnv wfun cF crn cB wceq wa wa cF ccnv cB wfn cF ccnv ccnv
    wfun cF ccnv crn cA wceq wa wa cA cB cF wf1o cB cA cF ccnv wf1o cF ccnv
    wfun cF crn cB wceq wa cF cA wfn cF ccnv cB wfn cF ccnv ccnv wfun cF ccnv
    crn cA wceq wa wa cF ccnv wfun cF crn cB wceq wa cF ccnv cB wfn cF cA wfn
    cF ccnv ccnv wfun cF ccnv crn cA wceq wa cF ccnv wfun cF crn cB wceq wa cF
    ccnv cB wfn cF ccnv wfun cF crn cB wceq wa cF ccnv wfun cF ccnv cdm cB wceq
    wa cF ccnv cB wfn cF crn cB wceq cF ccnv cdm cB wceq cF ccnv wfun cF crn cF
    ccnv cdm cB cF df-rn eqeq1i anbi2i cF ccnv cB df-fn bitr4i biimpi cF cA wfn
    cF ccnv ccnv wfun cF ccnv crn cA wceq cF cA wfn cF wfun cF ccnv ccnv wfun
    cA cF fnfun cF funcnvcnv syl cF cA wfn cF cdm cA cF ccnv crn cA cF fndm cF
    dfdm4 syl5eqr jca anim12i ancoms cA cB cF wf1o cF cA wfn cF ccnv wfun cF
    crn cB wceq w3a cF cA wfn cF ccnv wfun cF crn cB wceq wa wa cA cB cF dff1o2
    cF cA wfn cF ccnv wfun cF crn cB wceq 3anass bitri cB cA cF ccnv wf1o cF
    ccnv cB wfn cF ccnv ccnv wfun cF ccnv crn cA wceq w3a cF ccnv cB wfn cF
    ccnv ccnv wfun cF ccnv crn cA wceq wa wa cB cA cF ccnv dff1o2 cF ccnv cB
    wfn cF ccnv ccnv wfun cF ccnv crn cA wceq 3anass bitri 3imtr4i $.
    $( [11-Feb-1997] $)

  $( A relation is a one-to-one onto function iff its converse is a one-to-one
     onto function with domain and range interchanged. $)
  f1ocnvb $p |- ( Rel F ->
                ( F : A -1-1-onto-> B <-> `' F : B -1-1-onto-> A ) ) $=
    cF wrel cA cB cF wf1o cB cA cF ccnv wf1o cA cB cF f1ocnv cF wrel cA cB cF
    ccnv ccnv wf1o cA cB cF wf1o cB cA cF ccnv wf1o cF wrel cF ccnv ccnv cF
    wceq cA cB cF ccnv ccnv wf1o cA cB cF wf1o wb cF dfrel2 cA cB cF ccnv ccnv
    cF f1oeq1 sylbi cB cA cF ccnv f1ocnv syl5bi impbid2 $.
    $( [17-May-2004] $) $( [8-Dec-2003] $)

  $( The restriction of a one-to-one function maps one-to-one onto the
     image. $)
  f1ores $p |- ( ( F : A -1-1-> B /\ C C_ A ) -> ( F |` C ) : C -1-1-onto->
            ( F " C ) ) $=
    cA cB cF wf cF ccnv wfun wa cC cA wss wa cC cF cC cima cF cC cres wfo cF cC
    cres ccnv wfun wa cA cB cF wf1 cC cA wss wa cC cF cC cima cF cC cres wf1o
    cA cB cF wf cC cA wss cF ccnv wfun cC cF cC cima cF cC cres wfo cF cC cres
    ccnv wfun wa cA cB cF wf cC cA wss wa cC cF cC cima cF cC cres wfo cF ccnv
    wfun cF cC cres ccnv wfun cF wfun cC cF cdm wss cC cF cC cima cF cC cres
    wfo cA cB cF wf cC cA wss wa cC cF fores cA cB cF wf cF wfun cC cA wss cA
    cB cF ffun adantr cA cB cF wf cC cF cdm wss cC cA wss cA cB cF wf cF cdm cA
    cC cA cB cF fdm sseq2d biimpar sylanc cC cF funres11 anim12i an1rs cA cB cF
    wf1 cA cB cF wf cF ccnv wfun wa cC cA wss cA cB cF df-f1 anbi1i cC cF cC
    cima cF cC cres dff1o3 3imtr4i $.
    $( [25-Mar-1998] $)

  $( The converse of a one-to-one-onto restricted function.  (Contributed by
     Paul Chapman, 21-Apr-2008.) $)
  f1orescnv $p |- ( ( Fun `' F /\ ( F |` R ) : R -1-1-onto-> P ) ->
                    ( `' F |` P ) : P -1-1-onto-> R ) $=
    cF ccnv wfun cR cP cF cR cres wf1o wa cP cR cF cR cres ccnv wf1o cP cR cF
    ccnv cP cres wf1o cR cP cF cR cres wf1o cP cR cF cR cres ccnv wf1o cF ccnv
    wfun cR cP cF cR cres f1ocnv adantl cF ccnv wfun cR cP cF cR cres wf1o wa
    cF cR cres ccnv cF ccnv cP cres wceq cP cR cF cR cres ccnv wf1o cP cR cF
    ccnv cP cres wf1o wb cF ccnv wfun cR cP cF cR cres wf1o cF cR cres ccnv cF
    ccnv cF cR cima cres cF ccnv cP cres cR cF funcnvres cR cP cF cR cres wf1o
    cF cR cima cP wceq cF ccnv cF cR cima cres cF ccnv cP cres wceq cR cP cF cR
    cres wf1o cF cR cres crn cP cF cR cima cR cP cF cR cres wf1o cR cP cF cR
    cres wf1 cF cR cres crn cP wceq cR cP cF cR cres dff1o5 pm3.27bi cF cR
    df-ima syl5eq cF cR cima cP cF ccnv reseq2 syl sylan9eq cP cR cF cR cres
    ccnv cF ccnv cP cres f1oeq1 syl mpbid $.
    $( [24-Apr-2008] $) $( [21-Apr-2008] $)

  $( Pre-image of an image. $)
  f1imacnv $p |- ( ( F : A -1-1-> B /\ C C_ A )
                 -> ( `' F " ( F " C ) ) = C ) $=
    cA cB cF wf1 cC cA wss wa cF ccnv cF cC cima cres cF cC cima cima cC cF
    ccnv cF cC cima cima cA cB cF wf1 cC cA wss wa cF cC cres ccnv cF cC cima
    cima cF ccnv cF cC cima cres cF cC cima cima cC cA cB cF wf1 cC cA wss wa
    cF ccnv wfun cF cC cres ccnv cF ccnv cF cC cima cres wceq cF cC cres ccnv
    cF cC cima cima cF ccnv cF cC cima cres cF cC cima cima wceq cA cB cF wf1
    cF ccnv wfun cC cA wss cA cB cF wf1 cA cB cF wf cF ccnv wfun cA cB cF df-f1
    pm3.27bi adantr cC cF funcnvres cF cC cres ccnv cF ccnv cF cC cima cres cF
    cC cima imaeq1 3syl cA cB cF wf1 cC cA wss wa cC cF cC cima cF cC cres wf1o
    cF cC cima cC cF cC cres ccnv wf1o cF cC cres ccnv cF cC cima cima cC wceq
    cA cB cC cF f1ores cC cF cC cima cF cC cres f1ocnv cF cC cima cC cF cC cres
    ccnv wf1o cF cC cres ccnv cF cC cima cima cF cC cres ccnv crn cC cF cC cima
    cC cF cC cres ccnv wf1o cF cC cres ccnv cF cC cres ccnv cdm cima cF cC cres
    ccnv cF cC cima cima cF cC cres ccnv crn cF cC cima cC cF cC cres ccnv wf1o
    cF cC cima cC cF cC cres ccnv wf cF cC cres ccnv cdm cF cC cima wceq cF cC
    cres ccnv cF cC cres ccnv cdm cima cF cC cres ccnv cF cC cima cima wceq cF
    cC cima cC cF cC cres ccnv f1of cF cC cima cC cF cC cres ccnv fdm cF cC
    cres ccnv cdm cF cC cima cF cC cres ccnv imaeq2 3syl cF cC cres ccnv
    imadmrn syl5reqr cF cC cima cC cF cC cres ccnv wf1o cF cC cima cC cF cC
    cres ccnv wfo cF cC cres ccnv crn cC wceq cF cC cima cC cF cC cres ccnv
    f1ofo cF cC cima cC cF cC cres ccnv forn syl eqtrd 3syl eqtr3d cF ccnv cF
    cC cima resima syl5eqr $.
    $( [9-Oct-2004] $) $( [30-Sep-2004] $)

  $( A reverse version of ~ f1imacnv .  (Contributed by Jeffrey Hankins,
     16-Jul-2009.) $)
  foimacnv $p |- ( ( F : A -onto-> B /\ C C_ B )
                 -> ( F " ( `' F " C ) ) = C ) $=
    cA cB cF wfo cC cB wss wa cF cF ccnv cC cima cres cF ccnv cC cima cima cC
    cF cF ccnv cC cima cima cA cB cF wfo cC cB wss wa cF ccnv cC cres ccnv cF
    ccnv cC cima cima cF cF ccnv cC cima cres cF ccnv cC cima cima cC cA cB cF
    wfo cC cB wss wa cF wfun cF ccnv cC cres ccnv cF cF ccnv cC cima cres wceq
    cF ccnv cC cres ccnv cF ccnv cC cima cima cF cF ccnv cC cima cres cF ccnv
    cC cima cima wceq cA cB cF wfo cF wfun cC cB wss cA cB cF fofun adantr cC
    cF funcnvres2 cF ccnv cC cres ccnv cF cF ccnv cC cima cres cF ccnv cC cima
    imaeq1 3syl cA cB cF wfo cC cB wss wa cF ccnv cC cima cC cF ccnv cC cres
    ccnv wfo cF ccnv cC cres ccnv cF ccnv cC cima cima cC wceq cF ccnv cC cima
    cC cF ccnv cC cres ccnv wfo cF ccnv cC cres ccnv cF ccnv cC cima wfn cF
    ccnv cC cres ccnv crn cC wceq cA cB cF wfo cC cB wss wa cF ccnv cC cima cC
    cF ccnv cC cres ccnv df-fo cA cB cF wfo cC cB wss wa cF ccnv cC cres ccnv
    wfun cF ccnv cC cres ccnv cdm cF ccnv cC cima wceq wa cF ccnv cC cres ccnv
    cF ccnv cC cima wfn cA cB cF wfo cC cB wss wa cF ccnv cC cres ccnv wfun cF
    ccnv cC cres ccnv cdm cF ccnv cC cima wceq cA cB cF wfo cF ccnv cC cres
    ccnv wfun cC cB wss cA cB cF wfo cF wfun cF ccnv cC cres ccnv wfun cA cB cF
    fofun cF ccnv cC cres ccnv cF wss cF wfun cF ccnv cC cres ccnv wfun wi cF
    ccnv cC cres ccnv cF ccnv ccnv cF cF ccnv cC cres cF ccnv wss cF ccnv cC
    cres ccnv cF ccnv ccnv wss cF ccnv cC resss cF ccnv cC cres cF ccnv cnvss
    ax-mp cF cnvcnvss sstri cF ccnv cC cres ccnv cF funss ax-mp syl adantr cF
    ccnv cC cima cF ccnv cC cres crn cF ccnv cC cres ccnv cdm cF ccnv cC df-ima
    cF ccnv cC cres df-rn eqtr2i jctir cF ccnv cC cres ccnv cF ccnv cC cima
    df-fn sylibr cA cB cF wfo cC cB wss wa cF ccnv cC cres cdm cC cF ccnv cC
    cres ccnv crn cA cB cF wfo cC cB wss wa cC cF ccnv cdm wss cF ccnv cC cres
    cdm cC wceq cA cB cF wfo cC cB wss wa cC cF crn cF ccnv cdm cA cB cF wfo cC
    cF crn wss cC cB wss cA cB cF wfo cF crn cB cC cA cB cF forn sseq2d biimpar
    cF df-rn syl6ss cC cF ccnv ssdmres sylib cF ccnv cC cres dfdm4 syl5eqr
    sylanbrc cF ccnv cC cima cC cF ccnv cC cres ccnv foima syl eqtr3d cF cF
    ccnv cC cima resima syl5eqr $.
    $( [23-Jul-2009] $) $( [9-Jul-2009] $)

  $( The union of two one-to-one onto functions with disjoint domains and
     ranges. $)
  f1oun $p |- ( ( ( F : A -1-1-onto-> B /\ G : C -1-1-onto-> D )
            /\ ( ( A i^i C ) = (/) /\ ( B i^i D ) = (/) ) )
           -> ( F u. G ) : ( A u. C ) -1-1-onto-> ( B u. D ) ) $=
    cA cB cF wf1o cC cD cG wf1o wa cA cC cin c0 wceq cB cD cin c0 wceq wa cA cC
    cun cB cD cun cF cG cun wf1o cA cB cF wf1o cC cD cG wf1o wa cA cC cin c0
    wceq cB cD cin c0 wceq wa cF cG cun cA cC cun wfn cF cG cun ccnv cB cD cun
    wfn wa cA cC cun cB cD cun cF cG cun wf1o cF cA wfn cF ccnv cB wfn wa cG cC
    wfn cG ccnv cD wfn wa cA cC cin c0 wceq cB cD cin c0 wceq wa cF cG cun cA
    cC cun wfn cF cG cun ccnv cB cD cun wfn wa wi cA cB cF wf1o cC cD cG wf1o
    cF cA wfn cG cC wfn cF ccnv cB wfn cG ccnv cD wfn cA cC cin c0 wceq cB cD
    cin c0 wceq wa cF cG cun cA cC cun wfn cF cG cun ccnv cB cD cun wfn wa wi
    cF cA wfn cG cC wfn wa cA cC cin c0 wceq cF cG cun cA cC cun wfn cF ccnv cB
    wfn cG ccnv cD wfn wa cB cD cin c0 wceq cF cG cun ccnv cB cD cun wfn cF cA
    wfn cG cC wfn wa cA cC cin c0 wceq cF cG cun cA cC cun wfn cA cC cF cG fnun
    ex cF ccnv cB wfn cG ccnv cD wfn wa cB cD cin c0 wceq cF cG cun ccnv cB cD
    cun wfn cF ccnv cB wfn cG ccnv cD wfn wa cB cD cin c0 wceq wa cF ccnv cG
    ccnv cun cB cD cun wfn cF cG cun ccnv cB cD cun wfn cB cD cF ccnv cG ccnv
    fnun cF cG cun ccnv cF ccnv cG ccnv cun wceq cF cG cun ccnv cB cD cun wfn
    cF ccnv cG ccnv cun cB cD cun wfn wb cF cG cnvun cB cD cun cF cG cun ccnv
    cF ccnv cG ccnv cun fneq1 ax-mp sylibr ex im2anan9 an4s cA cB cF dff1o4 cC
    cD cG dff1o4 syl2anb cA cC cun cB cD cun cF cG cun dff1o4 syl6ibr imp $.
    $( [26-Mar-1998] $)

  $( The restriction of a one-to-one onto function to a difference maps onto
     the difference of the images.  (Contributed by Paul Chapman,
     11-Apr-2009.) $)
  resdif $p |- ( ( Fun `' F /\ ( F |` A ) : A -onto-> C /\
                               ( F |` B ) : B -onto-> D ) ->
                 ( F |` ( A \ B ) ) : ( A \ B ) -1-1-onto-> ( C \ D ) ) $=
    cF ccnv wfun cA cC cF cA cres wfo cB cD cF cB cres wfo w3a cA cB cdif cF cA
    cB cdif cima cF cA cB cdif cres wf1o cA cB cdif cC cD cdif cF cA cB cdif
    cres wf1o cF ccnv wfun cA cC cF cA cres wfo cA cB cdif cF cA cB cdif cima
    cF cA cB cdif cres wf1o cB cD cF cB cres wfo cA cC cF cA cres wfo cF ccnv
    wfun cA cB cdif cF cA cB cdif cima cF cA cB cdif cres wf1o cA cB cdif cF cA
    cB cdif cima cF cA cB cdif cres wfo cF cA cB cdif cres ccnv wfun cA cB cdif
    cF cA cB cdif cima cF cA cB cdif cres wf1o cA cC cF cA cres wfo cF ccnv
    wfun cA cB cdif cF cA cB cdif cima cF cA cB cdif cres wf1o cA cB cdif cF cA
    cB cdif cima cF cA cB cdif cres wfo cF cA cB cdif cres ccnv wfun wa cA cB
    cdif cF cA cB cdif cima cF cA cB cdif cres dff1o3 biimpri cA cC cF cA cres
    wfo cA cB cdif cF cA cres cA cB cdif cima cF cA cres cA cB cdif cres wfo cA
    cB cdif cF cA cB cdif cima cF cA cB cdif cres wfo cF cA cres wfun cA cB
    cdif cF cA cres cdm wss cA cB cdif cF cA cres cA cB cdif cima cF cA cres cA
    cB cdif cres wfo cA cC cF cA cres wfo cA cB cdif cF cA cres fores cA cC cF
    cA cres fofun cA cC cF cA cres wfo cA cB cdif cF cA cres cdm wss cA cB cdif
    cA wss cA cB difss cA cC cF cA cres wfo cF cA cres cdm cA cA cB cdif cA cC
    cF cA cres wfo cA cC cF cA cres wf cF cA cres cdm cA wceq cA cC cF cA cres
    fof cA cC cF cA cres fdm syl sseq2d mpbiri sylanc cA cB cdif cF cA cres cA
    cB cdif cima cF cA cres cA cB cdif cres wfo cA cB cdif cF cA cres cA cB
    cdif cima cF cA cB cdif cres wfo cA cB cdif cF cA cB cdif cima cF cA cB
    cdif cres wfo cF cA cres cA cB cdif cres cF cA cB cdif cres wceq cA cB cdif
    cF cA cres cA cB cdif cima cF cA cres cA cB cdif cres wfo cA cB cdif cF cA
    cres cA cB cdif cima cF cA cB cdif cres wfo wb cF cA cres cA cB cdif cres
    cF cA cA cB cdif cin cres cF cA cB cdif cres cF cA cA cB cdif resres cA cA
    cB cdif cin cA cB cdif wceq cF cA cA cB cdif cin cres cF cA cB cdif cres
    wceq cA cB indif cA cA cB cdif cin cA cB cdif cF reseq2 ax-mp eqtri cA cB
    cdif cF cA cres cA cB cdif cima cF cA cres cA cB cdif cres cF cA cB cdif
    cres foeq1 ax-mp cF cA cres cA cB cdif cima cF cA cB cdif cima wceq cA cB
    cdif cF cA cres cA cB cdif cima cF cA cB cdif cres wfo cA cB cdif cF cA cB
    cdif cima cF cA cB cdif cres wfo wb cF cA cres cA cB cdif cres crn cF cA cB
    cdif cres crn cF cA cres cA cB cdif cima cF cA cB cdif cima cF cA cres cA
    cB cdif cres cF cA cB cdif cres cF cA cres cA cB cdif cres cF cA cA cB cdif
    cin cres cF cA cB cdif cres cF cA cA cB cdif resres cA cA cB cdif cin cA cB
    cdif wceq cF cA cA cB cdif cin cres cF cA cB cdif cres wceq cA cB indif cA
    cA cB cdif cin cA cB cdif cF reseq2 ax-mp eqtri rneqi cF cA cres cA cB cdif
    df-ima cF cA cB cdif df-ima 3eqtr4i cF cA cres cA cB cdif cima cF cA cB
    cdif cima cA cB cdif cF cA cB cdif cres foeq3 ax-mp bitri sylib cA cB cdif
    cF funres11 syl2an ancoms 3adant3 cF ccnv wfun cA cC cF cA cres wfo cB cD
    cF cB cres wfo w3a cF cA cB cdif cima cC cD cdif wceq cA cB cdif cF cA cB
    cdif cima cF cA cB cdif cres wf1o cA cB cdif cC cD cdif cF cA cB cdif cres
    wf1o wb cF ccnv wfun cA cC cF cA cres wfo cB cD cF cB cres wfo cF cA cB
    cdif cima cC cD cdif wceq cF ccnv wfun cF cA cima cC wceq cF cB cima cD
    wceq wa cF cA cB cdif cima cC cD cdif wceq cA cC cF cA cres wfo cB cD cF cB
    cres wfo wa cF ccnv wfun cF cA cima cC wceq cF cB cima cD wceq wa cF cA cB
    cdif cima cF cA cima cF cB cima cdif cC cD cdif cA cB cF imadif cF cA cima
    cC wceq cF cB cima cD wceq cF cA cima cF cB cima cdif cC cF cB cima cdif cC
    cD cdif cF cA cima cC cF cB cima difeq1 cF cB cima cD cC difeq2 sylan9eq
    sylan9eq cA cC cF cA cres wfo cF cA cima cC wceq cB cD cF cB cres wfo cF cB
    cima cD wceq cA cC cF cA cres wfo cF cA cres crn cC cF cA cima cA cC cF cA
    cres forn cF cA df-ima syl5eq cB cD cF cB cres wfo cF cB cres crn cD cF cB
    cima cB cD cF cB cres forn cF cB df-ima syl5eq anim12i sylan2 3impb cF cA
    cB cdif cima cC cD cdif cA cB cdif cF cA cB cdif cres f1oeq3 syl mpbid $.
    $( [14-Apr-2009] $) $( [11-Apr-2009] $)

  $( The restriction of a one-to-one onto function to an intersection maps onto
     the intersection of the images.  (Contributed by Paul Chapman,
     11-Apr-2009.) $)
  resin $p |- ( ( Fun `' F /\ ( F |` A ) : A -onto-> C /\
                               ( F |` B ) : B -onto-> D ) ->
      ( F |` ( A i^i B ) ) : ( A i^i B ) -1-1-onto-> ( C i^i D ) ) $=
    cF ccnv wfun cA cC cF cA cres wfo cB cD cF cB cres wfo w3a cA cA cB cdif
    cdif cC cC cD cdif cdif cF cA cA cB cdif cdif cres wf1o cA cB cin cC cD cin
    cF cA cB cin cres wf1o cF ccnv wfun cA cC cF cA cres wfo cA cB cdif cC cD
    cdif cF cA cB cdif cres wfo cA cA cB cdif cdif cC cC cD cdif cdif cF cA cA
    cB cdif cdif cres wf1o cB cD cF cB cres wfo cA cA cB cdif cC cC cD cdif cF
    resdif cF ccnv wfun cA cC cF cA cres wfo cB cD cF cB cres wfo w3a cA cB
    cdif cC cD cdif cF cA cB cdif cres wf1o cA cB cdif cC cD cdif cF cA cB cdif
    cres wfo cA cB cC cD cF resdif cA cB cdif cC cD cdif cF cA cB cdif cres
    f1ofo syl syld3an3 cA cB cin cC cD cin cF cA cB cin cres wf1o cA cB cin cC
    cC cD cdif cdif cF cA cB cin cres wf1o cA cA cB cdif cdif cC cC cD cdif
    cdif cF cA cB cin cres wf1o cA cA cB cdif cdif cC cC cD cdif cdif cF cA cA
    cB cdif cdif cres wf1o cC cD cin cC cC cD cdif cdif wceq cA cB cin cC cD
    cin cF cA cB cin cres wf1o cA cB cin cC cC cD cdif cdif cF cA cB cin cres
    wf1o wb cC cD dfin4 cC cD cin cC cC cD cdif cdif cA cB cin cF cA cB cin
    cres f1oeq3 ax-mp cA cB cin cA cA cB cdif cdif wceq cA cB cin cC cC cD cdif
    cdif cF cA cB cin cres wf1o cA cA cB cdif cdif cC cC cD cdif cdif cF cA cB
    cin cres wf1o wb cA cB dfin4 cA cB cin cA cA cB cdif cdif cC cC cD cdif
    cdif cF cA cB cin cres f1oeq2 ax-mp cF cA cB cin cres cF cA cA cB cdif cdif
    cres wceq cA cA cB cdif cdif cC cC cD cdif cdif cF cA cB cin cres wf1o cA
    cA cB cdif cdif cC cC cD cdif cdif cF cA cA cB cdif cdif cres wf1o wb cA cB
    cin cA cA cB cdif cdif wceq cF cA cB cin cres cF cA cA cB cdif cdif cres
    wceq cA cB dfin4 cA cB cin cA cA cB cdif cdif cF reseq2 ax-mp cA cA cB cdif
    cdif cC cC cD cdif cdif cF cA cB cin cres cF cA cA cB cdif cdif cres f1oeq1
    ax-mp 3bitrri sylib $.
    $( [14-Apr-2009] $) $( [11-Apr-2009] $)

  $( Composition of one-to-one onto functions. $)
  f1oco $p |- ( ( F : B -1-1-onto-> C /\ G : A -1-1-onto-> B ) ->
              ( F o. G ) : A -1-1-onto-> C ) $=
    cB cC cF wf1 cB cC cF wfo wa cA cB cG wf1 cA cB cG wfo wa wa cA cC cF cG
    ccom wf1 cA cC cF cG ccom wfo wa cB cC cF wf1o cA cB cG wf1o wa cA cC cF cG
    ccom wf1o cB cC cF wf1 cA cB cG wf1 cB cC cF wfo cA cB cG wfo cA cC cF cG
    ccom wf1 cA cC cF cG ccom wfo wa cB cC cF wf1 cA cB cG wf1 wa cA cC cF cG
    ccom wf1 cB cC cF wfo cA cB cG wfo wa cA cC cF cG ccom wfo cA cB cC cF cG
    f1co cA cB cC cF cG foco anim12i an4s cB cC cF wf1o cB cC cF wf1 cB cC cF
    wfo wa cA cB cG wf1o cA cB cG wf1 cA cB cG wfo wa cB cC cF df-f1o cA cB cG
    df-f1o anbi12i cA cC cF cG ccom df-f1o 3imtr4i $.
    $( [19-Mar-1998] $)

  $( The composition of a one-to-one onto function and its converse equals
     the identity relation restricted to the function's range. $)
  f1ococnv2 $p |- ( F : A -1-1-onto-> B -> ( F o. `' F ) = ( _I |` B ) ) $=
    cA cB cF wf1o cF cF ccnv ccom cid cF cF ccnv ccom cdm cres cid cB cres cA
    cB cF wf1o cF cF ccnv ccom cid wss cF cF ccnv ccom cid cF cF ccnv ccom cdm
    cres wceq cA cB cF wf1o cA cB cF wf cF wfun cF cF ccnv ccom cid wss cA cB
    cF f1of cA cB cF ffun cF wfun cF wrel cF cF ccnv ccom cid wss cF df-fun
    pm3.27bi 3syl cF cF ccnv ccom iss sylib cA cB cF wf1o cF cF ccnv ccom cdm
    cB wceq cid cF cF ccnv ccom cdm cres cid cB cres wceq cA cB cF wf1o cF cF
    ccnv ccom cdm cF ccnv cdm cB cA cB cF wf1o cF cdm cF ccnv crn wceq cF cF
    ccnv ccom cdm cF ccnv cdm wceq cA cB cF wf1o cF cdm cA cF ccnv crn cA cB cF
    wf1o cA cB cF wf cF cdm cA wceq cA cB cF f1of cA cB cF fdm syl cA cB cF
    wf1o cB cA cF ccnv wf1o cB cA cF ccnv wfo cF ccnv crn cA wceq cA cB cF
    f1ocnv cB cA cF ccnv f1ofo cB cA cF ccnv forn 3syl eqtr4d cF cF ccnv dmcoeq
    syl cA cB cF wf1o cB cA cF ccnv wf1o cB cA cF ccnv wf cF ccnv cdm cB wceq
    cA cB cF f1ocnv cB cA cF ccnv f1of cB cA cF ccnv fdm 3syl eqtrd cF cF ccnv
    ccom cdm cB cid reseq2 syl eqtrd $.
    $( [20-Dec-2003] $) $( [13-Dec-2003] $)

  $( The composition of a one-to-one onto function's converse and itself
     equals the identity relation restricted to the function's domain. $)
  f1ococnv1 $p |- ( F : A -1-1-onto-> B -> ( `' F o. F ) = ( _I |` A ) ) $=
    cA cB cF wf1o cF ccnv cF ccnv ccnv ccom cF ccnv cF ccom cid cA cres cA cB
    cF wf1o cF ccnv ccnv cF cF ccnv cA cB cF wf1o cF wrel cF ccnv ccnv cF wceq
    cA cB cF f1orel cF dfrel2 sylib coeq2d cA cB cF wf1o cB cA cF ccnv wf1o cF
    ccnv cF ccnv ccnv ccom cid cA cres wceq cA cB cF f1ocnv cB cA cF ccnv
    f1ococnv2 syl eqtr3d $.
    $( [17-May-2004] $) $( [13-Dec-2003] $)

  $( If the codomain of a one-to-one function exists, so does its domain.
     This theorem is equivalent to the Axiom of Replacement ~ ax-rep . $)
  f1dmex $p |- ( ( F : A -1-1-> B /\ B e. C ) -> A e. _V ) $=
    cA cB cF wf1 cB cC wcel cA cvv wcel cA cB cF wf1 cB cC wcel cF crn cvv wcel
    cA cvv wcel cA cB cF wf1 cB cC wcel cF crn cvv wcel cF crn cB wss cB cC
    wcel cF crn cvv wcel cA cB cF wf1 cF crn cB cC ssexg cA cB cF wf1 cA cB cF
    wf cF crn cB wss cA cB cF f1f cA cB cF frn syl sylan ex cF crn cvv wcel cF
    crn cA cF ccnv wfo cA cvv wcel cA cB cF wf1 cF crn cA cvv cF ccnv fornex cA
    cB cF wf1 cA cF crn cF wf1o cF crn cA cF ccnv wf1o cF crn cA cF ccnv wfo cA
    cB cF f1f1orn cA cF crn cF f1ocnv cF crn cA cF ccnv f1ofo 3syl syl5com syld
    imp $.
    $( [12-Sep-2006] $) $( [4-Sep-2004] $)

  ${
    $d x F $.  $d x A $.  $d x B $.
    f11o.1 $e |- F e. _V $.
    $( Relationship between a mapping and an onto mapping.  Figure 38 of
       [Enderton] p. 145. $)
    ffoss $p |- ( F : A --> B <-> E. x ( F : A -onto-> x /\ x C_ B ) ) $=
      cA cB cF wf cA vx cv cF wfo vx cv cB wss wa vx wex cA cB cF wf cA cF crn
      cF wfo cF crn cB wss wa cA vx cv cF wfo vx cv cB wss wa vx wex cA cB cF
      wf cF cA wfn cF crn cB wss wa cA cF crn cF wfo cF crn cB wss wa cA cB cF
      df-f cF cA wfn cA cF crn cF wfo cF crn cB wss cA cF dffn4 anbi1i bitri cA
      vx cv cF wfo vx cv cB wss wa cA cF crn cF wfo cF crn cB wss wa vx cF crn
      cF f11o.1 rnex vx cv cF crn wceq cA vx cv cF wfo cA cF crn cF wfo vx cv
      cB wss cF crn cB wss vx cv cF crn cA cF foeq3 vx cv cF crn cB sseq1
      anbi12d cla4ev sylbi cA vx cv cF wfo vx cv cB wss wa cA cB cF wf vx cA vx
      cv cF wf vx cv cB wss cA cB cF wf cA vx cv cF wfo cA vx cv cB cF fss cA
      vx cv cF fof sylan 19.23aiv impbii $.
      $( [10-May-1998] $)

    $( Relationship between one-to-one and one-to-one onto function. $)
    f11o $p |- ( F : A -1-1-> B <-> E. x ( F : A -1-1-onto-> x /\ x C_ B ) ) $=
      cA cB cF wf cF ccnv wfun wa cA vx cv cF wfo vx cv cB wss wa vx wex cF
      ccnv wfun wa cA cB cF wf1 cA vx cv cF wf1o vx cv cB wss wa vx wex cA cB
      cF wf cA vx cv cF wfo vx cv cB wss wa vx wex cF ccnv wfun vx cA cB cF
      f11o.1 ffoss anbi1i cA cB cF df-f1 cA vx cv cF wf1o vx cv cB wss wa vx
      wex cA vx cv cF wfo vx cv cB wss wa cF ccnv wfun wa vx wex cA vx cv cF
      wfo vx cv cB wss wa vx wex cF ccnv wfun wa cA vx cv cF wf1o vx cv cB wss
      wa cA vx cv cF wfo vx cv cB wss wa cF ccnv wfun wa vx cA vx cv cF wf1o vx
      cv cB wss wa cA vx cv cF wfo cF ccnv wfun wa vx cv cB wss wa cA vx cv cF
      wfo vx cv cB wss wa cF ccnv wfun wa cA vx cv cF wf1o cA vx cv cF wfo cF
      ccnv wfun wa vx cv cB wss cA vx cv cF dff1o3 anbi1i cA vx cv cF wfo cF
      ccnv wfun vx cv cB wss an23 bitri exbii cA vx cv cF wfo vx cv cB wss wa
      cF ccnv wfun vx 19.41v bitri 3bitr4i $.
      $( [4-Apr-1998] $)
  $}

  $( The empty set maps one-to-one into any class. $)
  f10 $p |- (/) : (/) -1-1-> A $=
    c0 cA c0 wf1 c0 cA c0 wf c0 ccnv wfun c0 cA c0 df-f1 cA f0 c0 ccnv wfun c0
    wfun fun0 c0 ccnv c0 wceq c0 ccnv wfun c0 wfun wb cnv0 c0 ccnv c0 funeq
    ax-mp mpbir mpbir2an $.
    $( [7-Apr-1998] $)

  $( One-to-one onto mapping of the empty set. $)
  f1o00 $p |- ( F : (/) -1-1-onto-> A <-> ( F = (/) /\ A = (/) ) ) $=
    c0 cA cF wf1o cF c0 wfn cF ccnv cA wfn wa cF c0 wceq cA c0 wceq wa c0 cA cF
    dff1o4 cF c0 wfn cF ccnv cA wfn wa cF c0 wceq cA c0 wceq wa cF c0 wfn cF
    ccnv cA wfn wa cF c0 wceq cA c0 wceq cF c0 wfn cF c0 wceq cF ccnv cA wfn cF
    c0 wfn cF c0 wceq cF fn0 biimpi adantr cF c0 wfn cF ccnv cA wfn wa c0 cdm
    cA c0 cF c0 wfn cF ccnv cA wfn wa c0 cA wfn c0 cdm cA wceq cF c0 wfn cF
    ccnv cA wfn c0 cA wfn cF c0 wfn cF ccnv c0 wceq cF ccnv cA wfn c0 cA wfn wb
    cF c0 wfn cF c0 wceq cF ccnv c0 wceq cF fn0 cF c0 wceq cF ccnv c0 ccnv c0
    cF c0 cnveq cnv0 syl6eq sylbi cA cF ccnv c0 fneq1 syl biimpa cA c0 fndm syl
    dm0 syl5reqr jca cF c0 wceq cA c0 wceq wa cF c0 wfn cF ccnv cA wfn cF c0
    wceq cF c0 wfn cA c0 wceq cF c0 wfn cF c0 wceq cF fn0 biimpri adantr cF c0
    wceq cA c0 wceq wa cF ccnv cA wfn c0 c0 wfn c0 c0 wfn c0 c0 wceq c0 eqid c0
    fn0 mpbir cF c0 wceq cF ccnv cA wfn c0 cA wfn cA c0 wceq c0 c0 wfn cF c0
    wceq cF ccnv c0 wceq cF ccnv cA wfn c0 cA wfn wb cF c0 wceq cF ccnv c0 ccnv
    c0 cF c0 cnveq cnv0 syl6eq cA cF ccnv c0 fneq1 syl cA c0 c0 fneq2 sylan9bb
    mpbiri jca impbii bitri $.
    $( [15-Apr-1998] $)

  $( Onto mapping of the empty set. $)
  fo00 $p |- ( F : (/) -onto-> A <-> ( F = (/) /\ A = (/) ) ) $=
    c0 cA cF wfo c0 cA cF wf1o cF c0 wceq cA c0 wceq wa c0 cA cF wfo c0 cA cF
    wf1o c0 cA cF wfo c0 cA cF wf1 c0 cA cF wfo wa c0 cA cF wf1o c0 cA cF wfo
    c0 cA cF wf1 c0 cA cF wfo cF c0 wfn c0 cA cF wf1 c0 cA cF fofn cF c0 wfn cF
    c0 wceq c0 cA cF wf1 cF fn0 cF c0 wceq c0 cA cF wf1 c0 cA c0 wf1 cA f10 c0
    cA cF c0 f1eq1 mpbiri sylbi syl ancri c0 cA cF df-f1o sylibr c0 cA cF f1ofo
    impbii cA cF f1o00 bitri $.
    $( [27-Mar-2006] $) $( [22-Mar-2006] $)

  $( One-to-one onto mapping of the empty set. $)
  f1o0 $p |- (/) : (/) -1-1-onto-> (/) $=
    c0 c0 c0 wf1o c0 c0 wceq c0 c0 wceq c0 c0 f1o00 c0 eqid c0 eqid mpbir2an $.
    $( [16-Feb-2004] $) $( [10-Sep-2004] $)

  $( A restriction of the identity relation is a one-to-one onto function. $)
  f1oi $p |- ( _I |` A ) : A -1-1-onto-> A $=
    cA cA cid cA cres wf1o cA cA cid cA cres wfo cid cA cres ccnv wfun cA cA
    cid cA cres dff1o3 cA cA cid cA cres wfo cid cA cres cA wfn cid cA cres crn
    cA wceq cA cA cid cA cres df-fo cA fnresi cA rnresi mpbir2an cid ccnv wfun
    cid cA cres ccnv wfun cid ccnv wfun cid wfun funi cid ccnv cid wceq cid
    ccnv wfun cid wfun wb cnvi cid ccnv cid funeq ax-mp mpbir cA cid funres11
    ax-mp mpbir2an $.
    $( [30-Apr-1998] $)

  $( The identity relation is a one-to-one onto function on the universe. $)
  f1ovi $p |- _I : _V -1-1-onto-> _V $=
    cvv cvv cid cvv cres wf1o cvv cvv cid wf1o cvv f1oi cid cvv cres cid wceq
    cvv cvv cid cvv cres wf1o cvv cvv cid wf1o wb cid wrel cid cvv cres cid
    wceq reli cid dfrel3 mpbi cvv cvv cid cvv cres cid f1oeq1 ax-mp mpbi $.
    $( [17-May-2004] $) $( [16-May-2004] $)

  ${
    f1osn.1 $e |- A e. _V $.
    f1osn.2 $e |- B e. _V $.
    $( A singleton of an ordered pair is one-to-one onto function. $)
    f1osn $p |- { <. A , B >. } : { A } -1-1-onto-> { B } $=
      cA csn cB csn cA cB cop csn wf1o cA cB cop csn cA csn wfn cA cB cop csn
      ccnv cB csn wfn cA csn cB csn cA cB cop csn dff1o4 cA cB cop csn cA csn
      wfn cA cB cop csn wfun cA cB cop csn cdm cA csn wceq cA cB cop csn cA csn
      df-fn cA cB f1osn.1 f1osn.2 funsn cA cB dmsnop mpbir2an cA cB cop csn
      ccnv cB csn wfn cB cA cop csn cB csn wfn cB cA cop csn cB csn wfn cB cA
      cop csn wfun cB cA cop csn cdm cB csn wceq cB cA cop csn cB csn df-fn cB
      cA f1osn.2 f1osn.1 funsn cB cA dmsnop mpbir2an cA cB cop csn ccnv cB cA
      cop csn wceq cA cB cop csn ccnv cB csn wfn cB cA cop csn cB csn wfn wb cA
      cB f1osn.1 f1osn.2 cnvsn cB csn cA cB cop csn ccnv cB cA cop csn fneq1
      ax-mp mpbir mpbir2an $.
      $( [18-May-1998] $)
  $}

  ${
    $d x y A $.  $d x y F $.
    fv2.1 $e |- A e. _V $.
    $( Alternate definition of function value.  Definition 10.11 of [Quine]
       p. 68. $)
    fv2 $p |- ( F ` A ) = U. { x | A. y ( A F y <-> y = x ) } $=
      cA cF cfv cF cA csn cima vx cv csn wceq vx cab cuni cA vy cv cF wbr vy cv
      vx cv wceq wb vy wal vx cab cuni vx cA cF df-fv cF cA csn cima vx cv csn
      wceq vx cab cA vy cv cF wbr vy cv vx cv wceq wb vy wal vx cab cF cA csn
      cima vx cv csn wceq cA vy cv cF wbr vy cv vx cv wceq wb vy wal vx cF cA
      csn cima vx cv csn wceq vy cv cF cA csn cima wcel vy cv vx cv csn wcel wb
      vy wal cA vy cv cF wbr vy cv vx cv wceq wb vy wal vy cF cA csn cima vx cv
      csn dfcleq vy cv cF cA csn cima wcel vy cv vx cv csn wcel wb cA vy cv cF
      wbr vy cv vx cv wceq wb vy vy cv cF cA csn cima wcel cA vy cv cF wbr vy
      cv vx cv csn wcel vy cv vx cv wceq vy cv cF cA csn cima wcel vx cv cA csn
      wcel vx cv vy cv cF wbr wa vx wex vx cv cA wceq vx cv vy cv cF wbr wa vx
      wex cA vy cv cF wbr vy cv cF cA csn cima wcel vx cv vy cv cF wbr vx cA
      csn wrex vx cv cA csn wcel vx cv vy cv cF wbr wa vx wex vx cv vy cv cF
      wbr vx cA csn wrex vy cF cA csn cima vx vy cF cA csn dfima2 abeq2i vx cv
      vy cv cF wbr vx cA csn df-rex bitri vx cv cA csn wcel vx cv vy cv cF wbr
      wa vx cv cA wceq vx cv vy cv cF wbr wa vx vx cv cA csn wcel vx cv cA wceq
      vx cv vy cv cF wbr vx cA elsn anbi1i exbii vx cv vy cv cF wbr cA vy cv cF
      wbr vx cA fv2.1 vx cv cA vy cv cF breq1 ceqsexv 3bitri vy vx cv elsn
      bibi12i albii bitri abbii unieqi eqtri $.
      $( [1-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x F $.
    $( A function's value at a proper class is the empty set. $)
    fvprc $p |- ( -. A e. _V -> ( F ` A ) = (/) ) $=
      cA cvv wcel wn cA cF cfv c0 cuni c0 cA cvv wcel wn cF cA csn cima vx cv
      csn wceq vx cab cuni c0 cuni cA cF cfv cA cvv wcel wn cF cA csn cima vx
      cv csn wceq vx cab c0 cA cvv wcel wn cF cA csn cima vx cv csn wceq vx wex
      wn cF cA csn cima vx cv csn wceq vx cab c0 wceq cA cvv wcel wn cF cA csn
      cima vx cv csn wceq vx cA cvv wcel wn cF cA csn cima vx cv csn wceq vx cv
      csn c0 wceq vx cv csn c0 wne vx cv csn c0 wceq wn vx cv vx visset snnz vx
      cv csn c0 df-ne mpbi cA cvv wcel wn cF cA csn cima vx cv csn wceq c0 vx
      cv csn wceq vx cv csn c0 wceq cA cvv wcel wn cF cA csn cima c0 vx cv csn
      cA cvv wcel wn cF cA csn cima cF c0 cima c0 cA cvv wcel wn cA csn c0 wceq
      cF cA csn cima cF c0 cima wceq cA snprc cA csn c0 cF imaeq2 sylbi cF ima0
      syl6eq eqeq1d c0 vx cv csn eqcom syl6bb mtbiri nexdv cF cA csn cima vx cv
      csn wceq vx wex cF cA csn cima vx cv csn wceq vx cab c0 cF cA csn cima vx
      cv csn wceq vx abn0 necon1bbii sylib unieqd vx cA cF df-fv syl5eq uni0
      syl6eq $.
      $( [20-May-1998] $)
  $}

  ${
    $d x A $.  $d x y B $.  $d x y F $.
    elfv.1 $e |- B e. _V $.
    $( Membership in a function value. $)
    elfv $p |- ( A e. ( F ` B ) <->
               E. x ( A e. x /\ A. y ( B F y <-> y = x ) ) ) $=
      cA cB cF cfv wcel cA cB vy cv cF wbr vy cv vx cv wceq wb vy wal vx cab
      cuni wcel cA vx cv wcel cB vy cv cF wbr vy cv vx cv wceq wb vy wal wa vx
      wex cB cF cfv cB vy cv cF wbr vy cv vx cv wceq wb vy wal vx cab cuni cA
      vx vy cB cF elfv.1 fv2 eleq2i cB vy cv cF wbr vy cv vx cv wceq wb vy wal
      vx cA eluniab bitri $.
      $( [1-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x G $.
    $( Equality theorem for function value. $)
    fveq1 $p |- ( F = G -> ( F ` A ) = ( G ` A ) ) $=
      cF cG wceq cF cA csn cima vx cv csn wceq vx cab cuni cG cA csn cima vx cv
      csn wceq vx cab cuni cA cF cfv cA cG cfv cF cG wceq cF cA csn cima vx cv
      csn wceq vx cab cG cA csn cima vx cv csn wceq vx cab cF cG wceq cF cA csn
      cima vx cv csn wceq cG cA csn cima vx cv csn wceq vx cF cG wceq cF cA csn
      cima cG cA csn cima vx cv csn cF cG cA csn imaeq1 eqeq1d abbidv unieqd vx
      cA cF df-fv vx cA cG df-fv 3eqtr4g $.
      $( [29-Dec-1996] $)

    $( Equality theorem for function value. $)
    fveq2 $p |- ( A = B -> ( F ` A ) = ( F ` B ) ) $=
      cA cB wceq cF cA csn cima vx cv csn wceq vx cab cuni cF cB csn cima vx cv
      csn wceq vx cab cuni cA cF cfv cB cF cfv cA cB wceq cF cA csn cima vx cv
      csn wceq vx cab cF cB csn cima vx cv csn wceq vx cab cA cB wceq cF cA csn
      cima vx cv csn wceq cF cB csn cima vx cv csn wceq vx cA cB wceq cF cA csn
      cima cF cB csn cima vx cv csn cA cB wceq cA csn cB csn cF cA cB sneq
      imaeq2d eqeq1d abbidv unieqd vx cA cF df-fv vx cB cF df-fv 3eqtr4g $.
      $( [29-Dec-1996] $)
  $}

  ${
    fveq1i.1 $e |- F = G $.
    $( Equality inference for function value. $)
    fveq1i $p |- ( F ` A ) = ( G ` A ) $=
      cF cG wceq cA cF cfv cA cG cfv wceq fveq1i.1 cA cF cG fveq1 ax-mp $.
      $( [2-Sep-2003] $)
  $}

  ${
    fveq1d.1 $e |- ( ph -> F = G ) $.
    $( Equality deduction for function value. $)
    fveq1d $p |- ( ph -> ( F ` A ) = ( G ` A ) ) $=
      wph cF cG wceq cA cF cfv cA cG cfv wceq fveq1d.1 cA cF cG fveq1 syl $.
      $( [2-Sep-2003] $)
  $}

  ${
    fveq2i.1 $e |- A = B $.
    $( Equality inference for function value. $)
    fveq2i $p |- ( F ` A ) = ( F ` B ) $=
      cA cB wceq cA cF cfv cB cF cfv wceq fveq2i.1 cA cB cF fveq2 ax-mp $.
      $( [28-Jul-1999] $)
  $}

  ${
    fveq2d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function value. $)
    fveq2d $p |- ( ph -> ( F ` A ) = ( F ` B ) ) $=
      wph cA cB wceq cA cF cfv cB cF cfv wceq fveq2d.1 cA cB cF fveq2 syl $.
      $( [29-May-1999] $)
  $}

  ${
    $d y z F $.  $d y z A $.  $d x y z $.
    hbfv.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbfv.2 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for function value. $)
    hbfv $p |- ( y e. ( F ` A ) -> A. x y e. ( F ` A ) ) $=
      vx vy cA cF cfv cF cA csn cima vz cv csn wceq vz cab cuni vz cA cF df-fv
      vx vy cF cA csn cima vz cv csn wceq vz cab cF cA csn cima vz cv csn wceq
      vx vz vy vx vy vy cF cA csn cima vz cv csn vx vy cF cA csn hbfv.1 vx vy
      cA hbfv.2 hbsn hbima vy cv vz cv csn wcel vx ax-17 hbeq hbab hbuni hbxfr
      $.
      $( [14-Nov-1995] $)
  $}

  ${
    $d y z A $.  $d y z F $.  $d y ph $.  $d x y z $.
    hbfvd.1 $e |- ( ph -> A. x ph ) $.
    hbfvd.2 $e |- ( ph -> ( y e. F -> A. x y e. F ) ) $.
    hbfvd.3 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbfv .
       If a closed theorem version is desired, see ~ hbfvd2 . $)
    hbfvd $p |- ( ph -> ( y e. ( F ` A ) -> A. x y e. ( F ` A ) ) ) $=
      wph vy cv vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv
      wcel vy cv vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv
      wcel vx wal vy cv cA cF cfv wcel vy cv cA cF cfv wcel vx wal vy cv vz cv
      cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv wcel vy cv vz cv cA
      wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv wcel vx wal wi wph vx
      vy vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab vz cv cF wcel
      vx wal vx vz vy vz cv cF wcel vx hba1 hbab vz cv cA wcel vx wal vx vz vy
      vz cv cA wcel vx hba1 hbab hbfv a1i wph vz cv cA wcel vx wal vz cab vz cv
      cF wcel vx wal vz cab cfv cA cF cfv vy cv wph vz cv cA wcel vx wal vz cab
      vz cv cF wcel vx wal vz cab cfv vz cv cA wcel vx wal vz cab cF cfv cA cF
      cfv wph vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cF wph vy
      cv cF wcel vy cv cF wcel vx wal wi vy wal vz cv cF wcel vx wal vz cab cF
      wceq wph vy cv cF wcel vy cv cF wcel vx wal wi vy hbfvd.2 19.21aiv vx vy
      vz cF abidhb syl fveq1d wph vz cv cA wcel vx wal vz cab cA cF wph vy cv
      cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz cab cA
      wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy hbfvd.3 19.21aiv vx vy
      vz cA abidhb syl fveq2d eqtrd eleq2d wph vy cv vz cv cA wcel vx wal vz
      cab vz cv cF wcel vx wal vz cab cfv wcel vy cv cA cF cfv wcel vx hbfvd.1
      wph vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv cA cF cfv
      vy cv wph vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv vz
      cv cA wcel vx wal vz cab cF cfv cA cF cfv wph vz cv cA wcel vx wal vz cab
      vz cv cF wcel vx wal vz cab cF wph vy cv cF wcel vy cv cF wcel vx wal wi
      vy wal vz cv cF wcel vx wal vz cab cF wceq wph vy cv cF wcel vy cv cF
      wcel vx wal wi vy hbfvd.2 19.21aiv vx vy vz cF abidhb syl fveq1d wph vz
      cv cA wcel vx wal vz cab cA cF wph vy cv cA wcel vy cv cA wcel vx wal wi
      vy wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA
      wcel vx wal wi vy hbfvd.3 19.21aiv vx vy vz cA abidhb syl fveq2d eqtrd
      eleq2d albid 3imtr3d $.
      $( [21-Dec-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d y z A $.  $d y z F $.  $d x y z $.
    hbfvd2.1 $e |- ( ph -> A. x A. y ph ) $.
    hbfvd2.2 $e |- ( ph -> ( y e. F -> A. x y e. F ) ) $.
    hbfvd2.3 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbfv .
       This variant of ~ hbfvd allows us to create a closed theorem form
       by replacing the uncommitted antecedent ` ph ` with an appropriate
       substitution instance. $)
    hbfvd2 $p |- ( ph -> ( y e. ( F ` A ) -> A. x y e. ( F ` A ) ) ) $=
      wph vy cv vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv
      wcel vy cv vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv
      wcel vx wal vy cv cA cF cfv wcel vy cv cA cF cfv wcel vx wal vy cv vz cv
      cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv wcel vy cv vz cv cA
      wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv wcel vx wal wi wph vx
      vy vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab vz cv cF wcel
      vx wal vx vz vy vz cv cF wcel vx hba1 hbab vz cv cA wcel vx wal vx vz vy
      vz cv cA wcel vx hba1 hbab hbfv a1i wph vz cv cA wcel vx wal vz cab vz cv
      cF wcel vx wal vz cab cfv cA cF cfv vy cv wph vz cv cA wcel vx wal vz cab
      vz cv cF wcel vx wal vz cab cfv vz cv cA wcel vx wal vz cab cF cfv cA cF
      cfv wph vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cF wph vy
      cv cF wcel vy cv cF wcel vx wal wi vy wal vz cv cF wcel vx wal vz cab cF
      wceq wph vy cv cF wcel vy cv cF wcel vx wal wi vy wph wph vy wal vx
      hbfvd2.1 19.21bi hbfvd2.2 19.21ai vx vy vz cF abidhb syl fveq1d wph vz cv
      cA wcel vx wal vz cab cA cF wph vy cv cA wcel vy cv cA wcel vx wal wi vy
      wal vz cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA wcel
      vx wal wi vy wph wph vy wal vx hbfvd2.1 19.21bi hbfvd2.3 19.21ai vx vy vz
      cA abidhb syl fveq2d eqtrd eleq2d wph vy cv vz cv cA wcel vx wal vz cab
      vz cv cF wcel vx wal vz cab cfv wcel vy cv cA cF cfv wcel vx wph wph vy
      wal vx wal wph vx wal hbfvd2.1 wph wph vx wal vy vx wph vx wal vy ax-4
      a7s syl wph vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz cab cfv
      cA cF cfv vy cv wph vz cv cA wcel vx wal vz cab vz cv cF wcel vx wal vz
      cab cfv vz cv cA wcel vx wal vz cab cF cfv cA cF cfv wph vz cv cA wcel vx
      wal vz cab vz cv cF wcel vx wal vz cab cF wph vy cv cF wcel vy cv cF wcel
      vx wal wi vy wal vz cv cF wcel vx wal vz cab cF wceq wph vy cv cF wcel vy
      cv cF wcel vx wal wi vy wph wph vy wal vx hbfvd2.1 19.21bi hbfvd2.2
      19.21ai vx vy vz cF abidhb syl fveq1d wph vz cv cA wcel vx wal vz cab cA
      cF wph vy cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal
      vz cab cA wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy wph wph vy
      wal vx hbfvd2.1 19.21bi hbfvd2.3 19.21ai vx vy vz cA abidhb syl fveq2d
      eqtrd eleq2d albid 3imtr3d $.
      $( [17-Nov-2005] $) $( [10-Nov-2005] $)
  $}

  ${
    $d x A $.  $d x F $.
    $( The value of a class exists.  Corollary 6.13 of [TakeutiZaring]
       p. 27. $)
    fvex $p |- ( F ` A ) e. _V $=
      cA cF cfv cF cA csn cima vx cv csn wceq vx cab cuni cvv vx cA cF df-fv cF
      cA csn cima vx cv csn wceq vx cab cF cA csn cima vx cv csn wceq vx wmo cF
      cA csn cima vx cv csn wceq vx cab cvv wcel vx cv cF cA csn cima cuni wceq
      vx wmo cF cA csn cima vx cv csn wceq vx wmo vx cF cA csn cima cuni moeq
      cF cA csn cima vx cv csn wceq vx cv cF cA csn cima cuni wceq vx cF cA csn
      cima vx cv csn wceq cF cA csn cima cuni vx cv csn cuni vx cv cF cA csn
      cima vx cv csn unieq vx cv vx visset unisn syl6req immoi ax-mp cF cA csn
      cima vx cv csn wceq vx moabex ax-mp uniex eqeltri $.
      $( [30-Dec-1996] $)
  $}

  ${
    $d x y z F $.  $d x y z A $.
    fv3.1 $e |- A e. _V $.
    $( Alternate definition of the value of a function.  Definition 6.11 of
       [TakeutiZaring] p. 26. $)
    fv3 $p |- ( F ` A ) =  { x | ( E. y ( x e. y /\ A F y ) /\
              E! y A F y ) } $=
      vx cv vy cv wcel cA vy cv cF wbr wa vy wex cA vy cv cF wbr vy weu wa vx
      cA cF cfv vx cv cA cF cfv wcel vx cv vz cv wcel cA vy cv cF wbr vy cv vz
      cv wceq wb vy wal wa vz wex vx cv vy cv wcel cA vy cv cF wbr wa vy wex cA
      vy cv cF wbr vy weu wa vz vy vx cv cA cF fv3.1 elfv vx cv vz cv wcel cA
      vy cv cF wbr vy cv vz cv wceq wb vy wal wa vz wex vx cv vy cv wcel cA vy
      cv cF wbr wa vy wex cA vy cv cF wbr vy weu wa vx cv vz cv wcel cA vy cv
      cF wbr vy cv vz cv wceq wb vy wal wa vz wex vx cv vy cv wcel cA vy cv cF
      wbr wa vy wex cA vy cv cF wbr vy weu vx cv vz cv wcel cA vy cv cF wbr vy
      cv vz cv wceq wb vy wal wa vz wex vx cv vz cv wcel cA vz cv cF wbr wa vz
      wex vx cv vy cv wcel cA vy cv cF wbr wa vy wex vx cv vz cv wcel cA vy cv
      cF wbr vy cv vz cv wceq wb vy wal wa vx cv vz cv wcel cA vz cv cF wbr wa
      vz cA vy cv cF wbr vy cv vz cv wceq wb vy wal cA vz cv cF wbr vx cv vz cv
      wcel cA vy cv cF wbr vy cv vz cv wceq wb vy wal vy cv vz cv wceq cA vy cv
      cF wbr wi vy wal cA vz cv cF wbr cA vy cv cF wbr vy cv vz cv wceq wb vy
      cv vz cv wceq cA vy cv cF wbr wi vy cA vy cv cF wbr vy cv vz cv wceq bi2
      19.20i cA vy cv cF wbr cA vz cv cF wbr vy vz cv vz visset vy cv vz cv cA
      cF breq2 ceqsalv sylib anim2i 19.22i vx cv vz cv wcel cA vz cv cF wbr wa
      vx cv vy cv wcel cA vy cv cF wbr wa vz vy vz cv vy cv wceq vx cv vz cv
      wcel vx cv vy cv wcel cA vz cv cF wbr cA vy cv cF wbr vz cv vy cv vx cv
      eleq2 vz cv vy cv cA cF breq2 anbi12d cbvexv sylib vx cv vz cv wcel cA vy
      cv cF wbr vy cv vz cv wceq wb vy wal wa vz wex cA vy cv cF wbr vy cv vz
      cv wceq wb vy wal vz wex cA vy cv cF wbr vy weu vx cv vz cv wcel cA vy cv
      cF wbr vy cv vz cv wceq wb vy wal wa vz wex vx cv vz cv wcel vz wex cA vy
      cv cF wbr vy cv vz cv wceq wb vy wal vz wex vx cv vz cv wcel cA vy cv cF
      wbr vy cv vz cv wceq wb vy wal vz 19.40 pm3.27d cA vy cv cF wbr vy vz
      df-eu sylibr jca vx cv vy cv wcel cA vy cv cF wbr wa vy wex cA vy cv cF
      wbr vy weu vx cv vz cv wcel cA vy cv cF wbr vy cv vz cv wceq wb vy wal wa
      vz wex vx cv vy cv wcel cA vy cv cF wbr wa cA vy cv cF wbr vy weu vx cv
      vz cv wcel cA vy cv cF wbr vy cv vz cv wceq wb vy wal wa vz wex wi vy cA
      vy cv cF wbr vy weu vx cv vz cv wcel cA vy cv cF wbr vy cv vz cv wceq wb
      vy wal wa vz wex vy cA vy cv cF wbr vy hbeu1 vx cv vz cv wcel cA vy cv cF
      wbr vy cv vz cv wceq wb vy wal wa vy vz vx cv vz cv wcel cA vy cv cF wbr
      vy cv vz cv wceq wb vy wal vy vx cv vz cv wcel vy ax-17 cA vy cv cF wbr
      vy cv vz cv wceq wb vy hba1 hban hbex hbim vx cv vy cv wcel cA vy cv cF
      wbr wa cA vy cv cF wbr vy cv vz cv wceq wb vy wal vz wex vx cv vz cv wcel
      cA vy cv cF wbr vy cv vz cv wceq wb vy wal wa vz wex cA vy cv cF wbr vy
      weu vx cv vy cv wcel cA vy cv cF wbr wa cA vy cv cF wbr vy cv vz cv wceq
      wb vy wal vx cv vz cv wcel cA vy cv cF wbr vy cv vz cv wceq wb vy wal wa
      vz cA vy cv cF wbr vy cv vz cv wceq wb vy wal vx cv vy cv wcel cA vy cv
      cF wbr wa vx cv vz cv wcel cA vy cv cF wbr vy cv vz cv wceq wb vy wal wa
      cA vy cv cF wbr vy cv vz cv wceq wb vy wal vx cv vy cv wcel cA vy cv cF
      wbr wa vx cv vz cv wcel cA vy cv cF wbr vy cv vz cv wceq wb vx cv vy cv
      wcel cA vy cv cF wbr wa vx cv vz cv wcel wi vy cA vy cv cF wbr vy cv vz
      cv wceq wb vx cv vy cv wcel cA vy cv cF wbr vx cv vz cv wcel cA vy cv cF
      wbr vy cv vz cv wceq wb cA vy cv cF wbr vx cv vy cv wcel vx cv vz cv wcel
      cA vy cv cF wbr vy cv vz cv wceq wb cA vy cv cF wbr vy cv vz cv wceq vx
      cv vy cv wcel vx cv vz cv wcel wi cA vy cv cF wbr vy cv vz cv wceq bi1 vy
      vz vx ax-14 syl6 com23 imp3a a4s anc2ri com12 19.22dv cA vy cv cF wbr vy
      vz df-eu syl5ib 19.23ai imp impbii bitri abbi2i $.
      $( [1-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x F $.  $d x A $.  $d x B $.
    $( The value of a restricted function. $)
    fvres $p |- ( A e. B -> ( ( F |` B ) ` A ) = ( F ` A ) ) $=
      cA cB wcel cF cB cres cA csn cima vx cv csn wceq vx cab cuni cF cA csn
      cima vx cv csn wceq vx cab cuni cA cF cB cres cfv cA cF cfv cA cB wcel cF
      cB cres cA csn cima vx cv csn wceq vx cab cF cA csn cima vx cv csn wceq
      vx cab cA cB wcel cF cB cres cA csn cima vx cv csn wceq cF cA csn cima vx
      cv csn wceq vx cA cB wcel cF cB cres cA csn cima cF cA csn cima vx cv csn
      cA cB wcel cF cB cres cA csn cres crn cF cA csn cres crn cF cB cres cA
      csn cima cF cA csn cima cA cB wcel cA csn cB wss cF cB cres cA csn cres
      cF cA csn cres wceq cF cB cres cA csn cres crn cF cA csn cres crn wceq cA
      cB snssi cF cA csn cB resabs1 cF cB cres cA csn cres cF cA csn cres rneq
      3syl cF cB cres cA csn df-ima cF cA csn df-ima 3eqtr4g eqeq1d abbidv
      unieqd vx cA cF cB cres df-fv vx cA cF df-fv 3eqtr4g $.
      $( [16-Feb-2004] $) $( [2-Aug-1994] $)
  $}

  $( The value of a member of the domain of a subclass of a function. $)
  funssfv $p |- ( ( Fun F /\ G C_ F /\ A e. dom G ) ->
                ( F ` A ) = ( G ` A ) ) $=
    cF wfun cG cF wss cA cG cdm wcel cA cF cfv cA cG cfv wceq cA cG cdm wcel cF
    wfun cG cF wss wa cA cF cfv cA cF cG cdm cres cfv cA cG cfv cA cG cdm wcel
    cA cF cG cdm cres cfv cA cF cfv cA cG cdm cF fvres eqcomd cF wfun cG cF wss
    wa cA cF cG cdm cres cG cF cG funssres fveq1d sylan9eqr 3impa $.
    $( [29-May-2007] $) $( [15-Aug-1994] $)

  ${
    $d y z F $.  $d y z A $.
    tz6.12.1 $e |- A e. _V $.
    $( Function value.  Theorem 6.12(1) of [TakeutiZaring] p. 27. $)
    tz6.12-1 $p |- ( ( A F y /\ E! y A F y ) -> ( F ` A ) = y ) $=
      cA vy cv cF wbr cA vy cv cF wbr vy weu wa vz cA cF cfv vy cv cA vy cv cF
      wbr cA vy cv cF wbr vy weu wa vz cv cA cF cfv wcel vz cv vy cv wcel cA vy
      cv cF wbr vz cv cA cF cfv wcel vz cv vy cv wcel wi cA vy cv cF wbr vy weu
      vz cv cA cF cfv wcel cA vy cv cF wbr vz cv vy cv wcel vz cv cA cF cfv
      wcel vz cv vy cv wcel cA vy cv cF wbr wa vy wex cA vy cv cF wbr vy weu wa
      cA vy cv cF wbr vz cv vy cv wcel wi vz cv vy cv wcel cA vy cv cF wbr wa
      vy wex cA vy cv cF wbr vy weu wa vz cA cF cfv vz vy cA cF tz6.12.1 fv3
      abeq2i vz cv vy cv wcel cA vy cv cF wbr wa vy wex cA vy cv cF wbr vy weu
      wa cA vy cv cF wbr vy weu cA vy cv cF wbr vz cv vy cv wcel wa vy wex wa
      cA vy cv cF wbr vz cv vy cv wcel wi vz cv vy cv wcel cA vy cv cF wbr wa
      vy wex cA vy cv cF wbr vy weu wa cA vy cv cF wbr vz cv vy cv wcel wa vy
      wex cA vy cv cF wbr vy weu wa cA vy cv cF wbr vy weu cA vy cv cF wbr vz
      cv vy cv wcel wa vy wex wa vz cv vy cv wcel cA vy cv cF wbr wa vy wex cA
      vy cv cF wbr vz cv vy cv wcel wa vy wex cA vy cv cF wbr vy weu vz cv vy
      cv wcel cA vy cv cF wbr vy exancom anbi1i cA vy cv cF wbr vz cv vy cv
      wcel wa vy wex cA vy cv cF wbr vy weu ancom bitri cA vy cv cF wbr vz cv
      vy cv wcel vy eupick sylbi sylbi com12 adantr vz cv vy cv wcel cA vy cv
      cF wbr cA vy cv cF wbr vy weu wa vz cv cA cF cfv wcel vz cv vy cv wcel cA
      vy cv cF wbr cA vy cv cF wbr vy weu wa wa vz cv vy cv wcel cA vy cv cF
      wbr wa vy wex cA vy cv cF wbr vy weu wa vz cv cA cF cfv wcel vz cv vy cv
      wcel cA vy cv cF wbr cA vy cv cF wbr vy weu vz cv vy cv wcel cA vy cv cF
      wbr wa vy wex cA vy cv cF wbr vy weu wa vz cv vy cv wcel cA vy cv cF wbr
      wa vz cv vy cv wcel cA vy cv cF wbr wa vy wex cA vy cv cF wbr vy weu vz
      cv vy cv wcel cA vy cv cF wbr wa vy 19.8a anim1i anasss vz cv vy cv wcel
      cA vy cv cF wbr wa vy wex cA vy cv cF wbr vy weu wa vz cA cF cfv vz vy cA
      cF tz6.12.1 fv3 abeq2i sylibr expcom impbid eqrdv $.
      $( [1-May-2004] $) $( [30-Apr-2004] $)

    $( Function value.  Theorem 6.12(1) of [TakeutiZaring] p. 27. $)
    tz6.12 $p |- ( ( <. A , y >. e. F /\ E! y <. A , y >. e. F ) ->
                 ( F ` A ) = y ) $=
      cA vy cv cF wbr cA vy cv cF wbr vy weu cA cF cfv vy cv wceq cA vy cv cop
      cF wcel cA vy cv cop cF wcel vy weu vy cA cF tz6.12.1 tz6.12-1 cA vy cv
      cF df-br cA vy cv cF wbr cA vy cv cop cF wcel vy cA vy cv cF df-br eubii
      syl2anbr $.
      $( [10-Jul-1994] $)
  $}

  ${
    $d x y z w $.  $d z w v F $.
    tz6.12f.1 $e |- ( w e. F -> A. y w e. F ) $.
    $( Function value, using bound-variable hypotheses instead of distinct
       variable conditions. $)
    tz6.12f $p |- ( ( <. x , y >. e. F /\ E! y <. x , y >. e. F ) ->
                 ( F ` x ) = y ) $=
      vx cv vz cv cop cF wcel vx cv vz cv cop cF wcel vz weu wa vx cv cF cfv vz
      cv wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop cF wcel vy weu wa vx
      cv cF cfv vy cv wceq wi vz vy vx cv vy cv cop cF wcel vx cv vy cv cop cF
      wcel vy weu wa vx cv cF cfv vy cv wceq wi vz ax-17 vz cv vy cv wceq vx cv
      vz cv cop cF wcel vx cv vz cv cop cF wcel vz weu wa vx cv vy cv cop cF
      wcel vx cv vy cv cop cF wcel vy weu wa vx cv cF cfv vz cv wceq vx cv cF
      cfv vy cv wceq vz cv vy cv wceq vx cv vz cv cop cF wcel vx cv vy cv cop
      cF wcel vx cv vz cv cop cF wcel vz weu vx cv vy cv cop cF wcel vy weu vz
      cv vy cv wceq vx cv vz cv cop vx cv vy cv cop cF vz cv vy cv vx cv opeq2
      eleq1d vx cv vz cv cop cF wcel vz weu vx cv vy cv cop cF wcel vy weu wb
      vz cv vy cv wceq vx cv vz cv cop cF wcel vx cv vy cv cop cF wcel vz vy vy
      vw vw vx cv vz cv cop cF vw cv vx cv vz cv cop wcel vy ax-17 tz6.12f.1
      hbel vx cv vy cv cop cF wcel vz ax-17 vz cv vy cv wceq vx cv vz cv cop vx
      cv vy cv cop cF vz cv vy cv vx cv opeq2 eleq1d cbveu a1i anbi12d vz cv vy
      cv vx cv cF cfv eqeq2 imbi12d vz vx cv cF vx visset tz6.12 chvar $.
      $( [30-Aug-1999] $)
  $}

  ${
    $d x y z A $.  $d x y z F $.
    $( Function value when ` F ` is not a function.  Theorem 6.12(2) of
       [TakeutiZaring] p. 27. $)
    tz6.12-2 $p |- ( -. E! y A F y -> ( F ` A ) = (/) ) $=
      cA cvv wcel cA vy cv cF wbr vy weu wn cA cF cfv c0 wceq wi cA vy cv cF
      wbr vy weu wn cA cvv wcel cA cF cfv c0 wss cA cF cfv c0 wceq cA vy cv cF
      wbr vy weu wn cA cF cfv cA vy cv cF wbr vy weu vx cab wss cA cF cfv c0
      wss cA cvv wcel cA vy cv cF wbr vy weu wn cA vy cv cF wbr vy weu vx cab
      c0 cA cF cfv cA vy cv cF wbr vy weu wn cA vy cv cF wbr vy weu wn vz wal
      cA vy cv cF wbr vy weu vx cab c0 wceq cA vy cv cF wbr vy weu wn vz ax-17
      cA vy cv cF wbr vy weu vx cab c0 wceq vz cv cA vy cv cF wbr vy weu vx cab
      wcel wn vz wal cA vy cv cF wbr vy weu wn vz wal vz cA vy cv cF wbr vy weu
      vx cab eq0 vz cv cA vy cv cF wbr vy weu vx cab wcel wn cA vy cv cF wbr vy
      weu wn vz vz cv cA vy cv cF wbr vy weu vx cab wcel cA vy cv cF wbr vy weu
      cA vy cv cF wbr vy weu cA vy cv cF wbr vy weu vx vz cv vz visset vx cv vz
      cv wceq cA vy cv cF wbr vy weu biidd elab notbii albii bitr2i sylib
      sseq2d vz cv cF cfv vz cv vy cv cF wbr vy weu vx cab wss cA cF cfv cA vy
      cv cF wbr vy weu vx cab wss vz cA cvv vz cv cA wceq vz cv cF cfv cA cF
      cfv vz cv vy cv cF wbr vy weu vx cab cA vy cv cF wbr vy weu vx cab vz cv
      cA cF fveq2 vz cv cA wceq vz cv vy cv cF wbr vy weu cA vy cv cF wbr vy
      weu vx vz cv cA wceq vz cv vy cv cF wbr cA vy cv cF wbr vy vz cv cA vy cv
      cF breq1 eubidv abbidv sseq12d vz cv cF cfv vx cv vy cv wcel vz cv vy cv
      cF wbr wa vy wex vz cv vy cv cF wbr vy weu wa vx cab vz cv vy cv cF wbr
      vy weu vx cab vx vy vz cv cF vz visset fv3 vx cv vy cv wcel vz cv vy cv
      cF wbr wa vy wex vz cv vy cv cF wbr vy weu wa vz cv vy cv cF wbr vy weu
      vx vx cv vy cv wcel vz cv vy cv cF wbr wa vy wex vz cv vy cv cF wbr vy
      weu pm3.27 ss2abi eqsstri vtoclg syl5bi cA cF cfv ss0 syl6com cA cvv wcel
      wn cA cF cfv c0 wceq cA vy cv cF wbr vy weu wn cA cF fvprc a1d pm2.61i $.
      $( [1-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d y F $.  $d y A $.
    tz6.12c.1 $e |- A e. _V $.
    $( Corollary of Theorem 6.12(1) of [TakeutiZaring] p. 27. $)
    tz6.12c $p |- ( E! y A F y -> ( ( F ` A ) = y <-> A F y ) ) $=
      cA vy cv cF wbr vy weu cA cF cfv vy cv wceq cA vy cv cF wbr cA cF cfv vy
      cv wceq cA cA cF cfv cF wbr cA vy cv cF wbr cA vy cv cF wbr vy weu cA cF
      cfv vy cv cA cF breq2 cA vy cv cF wbr vy wex cA vy cv cF wbr vy weu cA cA
      cF cfv cF wbr cA vy cv cF wbr vy euex cA vy cv cF wbr cA vy cv cF wbr vy
      weu cA cA cF cfv cF wbr wi vy cA vy cv cF wbr vy weu cA cA cF cfv cF wbr
      vy cA vy cv cF wbr vy hbeu1 cA cA cF cfv cF wbr vy ax-17 hbim cA vy cv cF
      wbr vy weu cA vy cv cF wbr cA cA cF cfv cF wbr cA vy cv cF wbr cA vy cv
      cF wbr vy weu cA cF cfv vy cv wceq cA cA cF cfv cF wbr cA vy cv cF wbr cA
      vy cv cF wbr vy weu cA cF cfv vy cv wceq vy cA cF tz6.12c.1 tz6.12-1
      expcom cA cF cfv vy cv wceq cA cA cF cfv cF wbr cA vy cv cF wbr cA cF cfv
      vy cv cA cF breq2 biimprd syli com12 19.23ai mpcom syl5cbi cA vy cv cF
      wbr cA vy cv cF wbr vy weu cA cF cfv vy cv wceq vy cA cF tz6.12c.1
      tz6.12-1 expcom impbid $.
      $( [1-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.
    tz6.12i.1 $e |- A e. _V $. $( (Note: hypothesis could be eliminated) $)
    $( Corollary of Theorem 6.12(2) of [TakeutiZaring] p. 27. $)
    tz6.12i $p |- ( B =/= (/) -> ( ( F ` A ) = B -> A F B ) ) $=
      cA cF cfv cB wceq cB c0 wne cA cB cF wbr cB cvv wcel cA cF cfv cB wceq cB
      c0 wne cA cB cF wbr wi cA cF cfv cB wceq cA cF cfv cvv wcel cB cvv wcel
      cA cF fvex cA cF cfv cB cvv eleq1 mpbii cA cF cfv vy cv wceq vy cv c0 wne
      cA vy cv cF wbr wi wi cA cF cfv cB wceq cB c0 wne cA cB cF wbr wi wi vy
      cB cvv vy cv cB wceq cA cF cfv vy cv wceq cA cF cfv cB wceq vy cv c0 wne
      cA vy cv cF wbr wi cB c0 wne cA cB cF wbr wi vy cv cB cA cF cfv eqeq2 vy
      cv cB wceq vy cv c0 wne cB c0 wne cA vy cv cF wbr cA cB cF wbr vy cv cB
      c0 neeq1 vy cv cB cA cF breq2 imbi12d imbi12d vy cv c0 wne cA cF cfv vy
      cv wceq cA vy cv cF wbr cA cF cfv vy cv wceq vy cv c0 wne cA cF cfv c0
      wne cA cF cfv vy cv wceq cA vy cv cF wbr wi cA cF cfv vy cv c0 neeq1 cA
      cF cfv c0 wne cA cF cfv vy cv wceq cA vy cv cF wbr cA cF cfv c0 wne cA vy
      cv cF wbr vy weu cA cF cfv vy cv wceq cA vy cv cF wbr wb cA vy cv cF wbr
      vy weu cA cF cfv c0 vy cA cF tz6.12-2 necon1ai vy cA cF tz6.12i.1 tz6.12c
      syl biimpd syl6bir pm2.43a vtoclg mpcom com12 $.
      $( [6-Apr-2007] $) $( [30-Apr-2004] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y z F $.  $d x y z $.
    $( Move class substitution in and out of a function value. $)
    csbfv12g $p |- ( A e. C ->
                 [_ A / x ]_ ( F ` B ) = ( [_ A / x ]_ F ` [_ A / x ]_ B ) ) $=
      cA cC wcel vy cA vx vy cv cB cF cfv csb csb vy cA vx vy cv cB csb csb vy
      cA vx vy cv cF csb csb cfv vx cA cB cF cfv csb vx cA cB csb vx cA cF csb
      cfv vy vz cA vx vy cv cB cF cfv csb vy cA vx vy cv cB csb csb vy cA vx vy
      cv cF csb csb cfv cC cA cC wcel vy vz vy cA vx vy cv cB csb csb vy cA vx
      vy cv cF csb csb cA cC wcel vy ax-17 vy vz cA vx vy cv cF csb cC vz cv cA
      wcel vy ax-17 hbcsb1g vy vz cA vx vy cv cB csb cC vz cv cA wcel vy ax-17
      hbcsb1g hbfvd vy cv cA wceq vx vy cv cB cF cfv csb vx vy cv cB csb vx vy
      cv cF csb cfv vx vy cv cB csb vy cA vx vy cv cF csb csb cfv vy cA vx vy
      cv cB csb csb vy cA vx vy cv cF csb csb cfv vx vy cv cB cF cfv csb vx vy
      cv cB csb vx vy cv cF csb cfv wceq vy cv cA wceq vx cv vy cv wceq vx wex
      vx vy cv cB cF cfv csb vx vy cv cB csb vx vy cv cF csb cfv wceq vx vy a9e
      vx cv vy cv wceq vx vy cv cB cF cfv csb vx vy cv cB csb vx vy cv cF csb
      cfv wceq vx vx vz vz vx vy cv cB cF cfv csb vx vy cv cB csb vx vy cv cF
      csb cfv vx vz vy cv cB cF cfv vy visset vz cv vy cv wcel vx ax-17 hbcsb1
      vx vz vx vy cv cB csb vx vy cv cF csb vx vz vy cv cF vy visset vz cv vy
      cv wcel vx ax-17 hbcsb1 vx vz vy cv cB vy visset vz cv vy cv wcel vx
      ax-17 hbcsb1 hbfv hbeq vx cv vy cv wceq cB cF cfv cB vx vy cv cF csb cfv
      vx vy cv cB cF cfv csb vx vy cv cB csb vx vy cv cF csb cfv vx cv vy cv
      wceq cB cF vx vy cv cF csb vx vy cv cF csbeq1a fveq1d vx vy cv cB cF cfv
      csbeq1a vx cv vy cv wceq cB vx vy cv cB csb vx vy cv cF csb vx vy cv cB
      csbeq1a fveq2d 3eqtr3d 19.23ai ax-mp a1i vy cv cA wceq vx vy cv cB csb vx
      vy cv cF csb vy cA vx vy cv cF csb csb vy cA vx vy cv cF csb csbeq1a
      fveq1d vy cv cA wceq vx vy cv cB csb vy cA vx vy cv cB csb csb vy cA vx
      vy cv cF csb csb vy cA vx vy cv cB csb csbeq1a fveq2d 3eqtrd csbiegf vx
      vy cA cB cF cfv cC csbcog cA cC wcel vy cA vx vy cv cB csb csb vy cA vx
      vy cv cF csb csb cfv vy cA vx vy cv cB csb csb vx cA cF csb cfv vx cA cB
      csb vx cA cF csb cfv cA cC wcel vy cA vx vy cv cB csb csb vy cA vx vy cv
      cF csb csb vx cA cF csb vx vy cA cF cC csbcog fveq1d cA cC wcel vy cA vx
      vy cv cB csb csb vx cA cB csb vx cA cF csb vx vy cA cB cC csbcog fveq2d
      eqtrd 3eqtr3d $.
      $( [3-Jan-2006] $) $( [11-Nov-2005] $)
  $}

  ${
    $d y A $.  $d y C $.  $d x y F $.
    $( Move class substitution in and out of a function value. $)
    csbfv2g $p |- ( A e. C -> [_ A / x ]_ ( F ` B ) =
                  ( F ` [_ A / x ]_ B ) ) $=
      cA cC wcel vx cA cB cF cfv csb vx cA cB csb vx cA cF csb cfv vx cA cB csb
      cF cfv vx cA cB cC cF csbfv12g cA cC wcel vx cA cB csb vx cA cF csb cF vx
      vy cA cF cC vy cv cF wcel vx ax-17 csbconstgf fveq1d eqtrd $.
      $( [7-Jan-2006] $) $( [10-Nov-2005] $)

    $( Substitution for a function value. $)
    csbfvg $p |- ( A e. C -> [_ A / x ]_ ( F ` x ) = ( F ` A ) ) $=
      cA cC wcel vx cA vx cv cF cfv csb vx cA vx cv csb cF cfv cA cF cfv vx cA
      vx cv cC cF csbfv2g cA cC wcel vx cA vx cv csb cA cF vx cA cC csbvarg
      fveq2d eqtrd $.
      $( [9-Jan-2006] $) $( [1-Jan-2006] $)
  $}

  ${
    $d x y A $.  $d x y F $.
    $( The value of a class outside its domain is the empty set. $)
    ndmfv $p |- ( -. A e. dom F -> ( F ` A ) = (/) ) $=
      cA cvv wcel cA cF cdm wcel wn cA cF cfv c0 wceq wi cA cvv wcel cA cF cdm
      wcel wn cA vy cv cF wbr vy weu wn cA cF cfv c0 wceq cA cvv wcel cA vy cv
      cF wbr vy weu cA cF cdm wcel cA cvv wcel cA cF cdm wcel cA vy cv cF wbr
      vy wex cA vy cv cF wbr vy weu vx cv cF cdm wcel vx cv vy cv cF wbr vy wex
      cA cF cdm wcel cA vy cv cF wbr vy wex vx cA cvv vx cv cA cF cdm eleq1 vx
      cv cA wceq vx cv vy cv cF wbr cA vy cv cF wbr vy vx cv cA vy cv cF breq1
      exbidv vy vx cv cF vx visset eldm vtoclbg cA vy cv cF wbr vy euex syl5bir
      con3d vy cA cF tz6.12-2 syl6 cA cvv wcel wn cA cF cfv c0 wceq cA cF cdm
      wcel wn cA cF fvprc a1d pm2.61i $.
      $( [24-Aug-1995] $)
  $}

  ${
    ndmfvrcl.1 $e |- dom F = S $.
    ndmfvrcl.2 $e |- -. (/) e. S $.
    $( Reverse closure law for function with the empty set not in its
       domain. $)
    ndmfvrcl $p |- ( ( F ` A ) e. S -> A e. S ) $=
      cA cF cfv cS wcel cA cF cdm cS cA cF cdm wcel cA cF cfv cS wcel cA cF cdm
      wcel wn cA cF cfv cS wcel c0 cS wcel ndmfvrcl.2 cA cF cdm wcel wn cA cF
      cfv c0 cS cA cF ndmfv eleq1d mtbiri con4i ndmfvrcl.1 syl6eleq $.
      $( [26-Apr-1996] $)
  $}

  $( If a function value has a member, the argument belongs to the domain. $)
  elfvdm $p |- ( A e. ( F ` B ) -> B e. dom F ) $=
    cA cB cF cfv wcel cB cF cfv c0 wne cB cF cdm wcel cB cF cfv cA ne0i cB cF
    cdm wcel cB cF cfv c0 cB cF ndmfv necon1ai syl $.
    $( [15-Feb-2007] $) $( [12-Feb-2007] $)

  $( The value of a non-member of a restriction is the empty set. $)
  nfvres $p |- ( -. A e. B -> ( ( F |` B ) ` A ) = (/) ) $=
    cA cB wcel wn cA cF cB cres cdm wcel wn cA cF cB cres cfv c0 wceq cA cF cB
    cres cdm wcel cA cB wcel cA cF cB cres cdm wcel cA cB wcel cA cF cdm wcel
    cA cF cB cres cdm wcel cA cB cF cdm cin wcel cA cB wcel cA cF cdm wcel wa
    cF cB cres cdm cB cF cdm cin cA cF cB dmres eleq2i cA cB cF cdm elin bitri
    pm3.26bi con3i cA cF cB cres ndmfv syl $.
    $( [13-Nov-1995] $)

  ${
    $d x y A $. $d x y F $.
    $( If the restriction of a class to a singleton is not a function,
       its value is the empty set. $)
    nfunsn $p |- ( -. Fun ( F |` { A } ) -> ( F ` A ) = (/) ) $=
      cF cA csn cres wfun wn cA cF cA csn cres cfv c0 cA cF cfv cF cA csn cres
      wfun wn cA cF cA csn cres cdm wcel cA cF cA csn cres cfv c0 wceq cA cF cA
      csn cres cdm wcel cF cA csn cres wfun wn cA vy cv cF cA csn cres wbr vy
      weu wn cA cF cA csn cres cfv c0 wceq cA cF cA csn cres cdm wcel cA vy cv
      cF cA csn cres wbr vy weu cF cA csn cres wfun cA cF cA csn cres cdm wcel
      cA vy cv cF cA csn cres wbr vy weu cF cA csn cres wrel vx cv vy cv cF cA
      csn cres wbr vy weu vx cF cA csn cres cdm wral wa cF cA csn cres wfun cA
      cF cA csn cres cdm wcel cA vy cv cF cA csn cres wbr vy weu cF cA csn cres
      wrel vx cv vy cv cF cA csn cres wbr vy weu vx cF cA csn cres cdm wral wa
      cA cF cA csn cres cdm wcel cA vy cv cF cA csn cres wbr vy weu wa vx cv vy
      cv cF cA csn cres wbr vy weu vx cF cA csn cres cdm wral cF cA csn cres
      wrel cA cF cA csn cres cdm wcel cA vy cv cF cA csn cres wbr vy weu wa vx
      cv vy cv cF cA csn cres wbr vy weu vx cF cA csn cres cdm cA cF cA csn
      cres cdm wcel cA vy cv cF cA csn cres wbr vy weu vx cv cF cA csn cres cdm
      wcel vx cv vy cv cF cA csn cres wbr vy weu wi cA cF cA csn cres cdm wcel
      vx cv cF cA csn cres cdm wcel cA vy cv cF cA csn cres wbr vy weu vx cv vy
      cv cF cA csn cres wbr vy weu cA cF cA csn cres cdm wcel vx cv cF cA csn
      cres cdm wcel cA vy cv cF cA csn cres wbr vy weu vx cv vy cv cF cA csn
      cres wbr vy weu wi cA cF cA csn cres cdm wcel vx cv cF cA csn cres cdm
      wcel wa vx cv cA wceq cA vy cv cF cA csn cres wbr vy weu vx cv vy cv cF
      cA csn cres wbr vy weu wi cF cA csn cres cdm cA csn wceq vx cv cF cA csn
      cres cdm wcel vx cv cA wceq cA cF cA csn cres cdm wcel cF cA csn cres cdm
      cA csn wceq vx cv cF cA csn cres cdm wcel vx cv cA wceq cF cA csn cres
      cdm cA csn wceq vx cv cF cA csn cres cdm wcel vx cv cA csn wcel vx cv cA
      wceq cF cA csn cres cdm cA csn vx cv eleq2 vx cA elsn syl6bb biimpa cA cF
      cA csn cres cdm wcel cA csn cF cA csn cres cdm wss cF cA csn cres cdm cA
      csn wceq cA cF cA csn cres cdm snssi cA csn cF cA csn cres cdm wss cF cA
      csn cres cA csn cres cdm cA csn cF cA csn cres cdm cA csn cF cA csn cres
      cdm wss cF cA csn cres cA csn cres cdm cA csn wceq cA csn cF cA csn cres
      ssdmres biimpi cF cA csn cres cA csn cres cF cA csn cres cF cA csn residm
      dmeqi syl5eqr syl sylan vx cv cA wceq vx cv vy cv cF cA csn cres wbr vy
      weu cA vy cv cF cA csn cres wbr vy weu vx cv cA wceq vx cv vy cv cF cA
      csn cres wbr cA vy cv cF cA csn cres wbr vy vx cv cA vy cv cF cA csn cres
      breq1 eubidv biimprd syl ex com23 imp r19.21aiv cF cA csn relres jctil ex
      vx vy cF cA csn cres dffun8 syl6ibr con3d vy cA cF cA csn cres tz6.12-2
      syl6com cA cF cA csn cres ndmfv pm2.61d1 cA cvv wcel cA cF cA csn cres
      cfv cA cF cfv wceq cA cvv wcel cA cA csn wcel cA cF cA csn cres cfv cA cF
      cfv wceq cA snidb cA cA csn cF fvres sylbi cA cvv wcel wn cA cF cA csn
      cres cfv c0 cA cF cfv cA cF cA csn cres fvprc cA cF fvprc eqtr4d pm2.61i
      syl5eqr $.
      $( [9-Aug-2010] $) $( [8-Aug-2010] $)
  $}

  $( Equal values imply equal values in a restriction. $)
  fveqres $p |- ( ( F ` A ) = ( G ` A ) ->
                ( ( F |` B ) ` A ) = ( ( G |` B ) ` A ) ) $=
    cA cB wcel cA cF cfv cA cG cfv wceq cA cF cB cres cfv cA cG cB cres cfv
    wceq wi cA cB wcel cA cF cB cres cfv cA cG cB cres cfv wceq cA cF cfv cA cG
    cfv wceq cA cB wcel cA cF cB cres cfv cA cF cfv cA cG cB cres cfv cA cG cfv
    cA cB cF fvres cA cB cG fvres eqeq12d biimprd cA cB wcel wn cA cF cB cres
    cfv cA cG cB cres cfv wceq cA cF cfv cA cG cfv wceq cA cB wcel wn cA cF cB
    cres cfv c0 cA cG cB cres cfv cA cB cF nfvres cA cB cG nfvres eqtr4d a1d
    pm2.61i $.
    $( [13-Nov-1995] $)

  ${
    $d x y A $.  $d x y F $.  $d x y B $.
    funbrfv.1 $e |- B e. _V $.
    $( The second argument of a binary relation on a function is the function's
       value. $)
    funbrfv $p |- ( Fun F -> ( A F B -> ( F ` A ) = B ) ) $=
      cF wfun cA cB cF wbr cA cF cfv cB wceq cA cvv wcel cF wfun cA cB cF wbr
      wa cA cF cfv cB wceq cF wrel cA cB cF wbr cA cvv wcel cF wfun cA cB cF
      brrelex cF funrel sylan cA cvv wcel cB cvv wcel cF wfun cA cB cF wbr wa
      cA cF cfv cB wceq wi funbrfv.1 cF wfun vx cv vy cv cF wbr wa vx cv cF cfv
      vy cv wceq wi cF wfun cA vy cv cF wbr wa cA cF cfv vy cv wceq wi cF wfun
      cA cB cF wbr wa cA cF cfv cB wceq wi vx vy cA cB cvv cvv vx cv cA wceq cF
      wfun vx cv vy cv cF wbr wa cF wfun cA vy cv cF wbr wa vx cv cF cfv vy cv
      wceq cA cF cfv vy cv wceq vx cv cA wceq vx cv vy cv cF wbr cA vy cv cF
      wbr cF wfun vx cv cA vy cv cF breq1 anbi2d vx cv cA wceq vx cv cF cfv cA
      cF cfv vy cv vx cv cA cF fveq2 eqeq1d imbi12d vy cv cB wceq cF wfun cA vy
      cv cF wbr wa cF wfun cA cB cF wbr wa cA cF cfv vy cv wceq cA cF cfv cB
      wceq vy cv cB wceq cA vy cv cF wbr cA cB cF wbr cF wfun vy cv cB cA cF
      breq2 anbi2d vy cv cB cA cF cfv eqeq2 imbi12d cF wfun vx cv vy cv cF wbr
      vx cv cF cfv vy cv wceq vx cv vy cv cF wbr vx cv vy cv cF wbr vy weu vx
      cv cF cfv vy cv wceq cF wfun vx cv vy cv cF wbr wa vy vx cv cF vx visset
      tz6.12-1 vx vy cF funeu sylan2 anabss7 vtocl2g mpan2 mpcom ex $.
      $( [18-May-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y B $.

    funopfv.1 $e |- B e. _V $.
    $( The second element in an ordered pair member of a function is the
       function's value. $)
    funopfv $p |- ( Fun F -> ( <. A , B >. e. F -> ( F ` A ) = B ) ) $=
      cF wfun cA cB cF wbr cA cF cfv cB wceq cA cB cop cF wcel cA cB cF
      funopfv.1 funbrfv cA cB cF df-br syl5ibr $.
      $( [19-Jul-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( The second element in an ordered pair member of a function is the
       function's value. $)
    funopfvg $p |- ( ( B e. C /\ Fun F ) ->
                   ( <. A , B >. e. F -> ( F ` A ) = B ) ) $=
      cB cC wcel cF wfun cA cB cop cF wcel cA cF cfv cB wceq wi cF wfun cA vx
      cv cop cF wcel cA cF cfv vx cv wceq wi wi cF wfun cA cB cop cF wcel cA cF
      cfv cB wceq wi wi vx cB cC vx cv cB wceq cA vx cv cop cF wcel cA cF cfv
      vx cv wceq wi cA cB cop cF wcel cA cF cfv cB wceq wi cF wfun vx cv cB
      wceq cA vx cv cop cF wcel cA cB cop cF wcel cA cF cfv vx cv wceq cA cF
      cfv cB wceq vx cv cB wceq cA vx cv cop cA cB cop cF vx cv cB cA opeq2
      eleq1d vx cv cB cA cF cfv eqeq2 imbi12d imbi2d cA vx cv cF vx visset
      funopfv vtoclg imp $.
      $( [14-Sep-1999] $)
  $}


  ${
    $d x y F $.  $d x A $.  $d x y B $.  $d x C $.
    fnfvbr.1 $e |- C e. _V $.
    $( Equivalence of function value and binary relation. $)
    fnbrfvb $p |- ( ( F Fn A /\ B e. A ) ->
                   ( ( F ` B ) = C <-> B F C ) ) $=
      cF cA wfn cB cA wcel wa cB cF cfv vx cv wceq cB vx cv cF wbr wb wi cF cA
      wfn cB cA wcel wa cB cF cfv cC wceq cB cC cF wbr wb wi vx cC fnfvbr.1 vx
      cv cC wceq cB cF cfv vx cv wceq cB vx cv cF wbr wb cB cF cfv cC wceq cB
      cC cF wbr wb cF cA wfn cB cA wcel wa vx cv cC wceq cB cF cfv vx cv wceq
      cB cF cfv cC wceq cB vx cv cF wbr cB cC cF wbr vx cv cC cB cF cfv eqeq2
      vx cv cC cB cF breq2 bibi12d imbi2d cF cA wfn cB cA wcel wa cB vx cv cF
      wbr vx weu cB cF cfv vx cv wceq cB vx cv cF wbr wb vx cA cB cF fneu cB cA
      wcel cB vx cv cF wbr vx weu cB cF cfv vx cv wceq cB vx cv cF wbr wb wi cF
      cA wfn vy cv vx cv cF wbr vx weu vy cv cF cfv vx cv wceq vy cv vx cv cF
      wbr wb wi cB vx cv cF wbr vx weu cB cF cfv vx cv wceq cB vx cv cF wbr wb
      wi vy cB cA vy cv cB wceq vy cv vx cv cF wbr vx weu cB vx cv cF wbr vx
      weu vy cv cF cfv vx cv wceq vy cv vx cv cF wbr wb cB cF cfv vx cv wceq cB
      vx cv cF wbr wb vy cv cB wceq vy cv vx cv cF wbr cB vx cv cF wbr vx vy cv
      cB vx cv cF breq1 eubidv vy cv cB wceq vy cv cF cfv vx cv wceq cB cF cfv
      vx cv wceq vy cv vx cv cF wbr cB vx cv cF wbr vy cv cB wceq vy cv cF cfv
      cB cF cfv vx cv vy cv cB cF fveq2 eqeq1d vy cv cB vx cv cF breq1 bibi12d
      imbi12d vx vy cv cF vy visset tz6.12c vtoclg adantl mpd vtocl $.
      $( [24-Apr-2004] $) $( [19-Apr-2004] $)

    $( Equivalence of function value and ordered pair membership. $)
    fnopfvb $p |- ( ( F Fn A /\ B e. A ) ->
                   ( ( F ` B ) = C <-> <. B , C >. e. F ) ) $=
      cF cA wfn cB cA wcel wa cB cF cfv cC wceq cB cC cF wbr cB cC cop cF wcel
      cA cB cC cF fnfvbr.1 fnbrfvb cB cC cF df-br syl6bb $.
      $( [7-Nov-1995] $)
  $}

  ${
    funbrfvb.1 $e |- B e. _V $.
    $( Equivalence of function value and binary relation. $)
    funbrfvb $p |- ( ( Fun F /\ A e. dom F ) ->
                   ( ( F ` A ) = B <-> A F B ) ) $=
      cF cF cdm wfn cA cF cdm wcel cA cF cfv cB wceq cA cB cF wbr wb cF wfun cF
      cdm cA cB cF funbrfvb.1 fnbrfvb cF cF cdm wfn cF wfun cF cdm cF cdm wceq
      cF cF cdm df-fn cF cdm eqid mpbiran2 sylanbr $.
      $( [27-Mar-2006] $) $( [26-Mar-2006] $)

    $( Equivalence of function value and ordered pair membership.  Theorem
       4.3(ii) of [Monk1] p. 42. $)
    funopfvb $p |- ( ( Fun F /\ A e. dom F ) ->
                   ( ( F ` A ) = B <-> <. A , B >. e. F ) ) $=
      cF wfun cA cF cdm wcel wa cA cF cfv cB wceq cA cB cF wbr cA cB cop cF
      wcel cA cB cF funbrfvb.1 funbrfvb cA cB cF df-br syl6bb $.
      $( [26-Jan-1997] $)
  $}

  ${
    $d x y z w A $.  $d x y B $.  $d x y z w F $.  $d x C $.
    $( Function value in terms of a binary relation. $)
    funbrfvbg $p |- ( ( Fun F /\ A e. dom F /\ B e. C ) ->
                   ( ( F ` A ) = B <-> A F B ) ) $=
      cB cC wcel cF wfun cA cF cdm wcel cA cF cfv cB wceq cA cB cF wbr wb cB cC
      wcel cF wfun cA cF cdm wcel cA cF cfv cB wceq cA cB cF wbr wb cF wfun cA
      cF cdm wcel wa cA cF cfv vx cv wceq cA vx cv cF wbr wb wi cF wfun cA cF
      cdm wcel wa cA cF cfv cB wceq cA cB cF wbr wb wi vx cB cC vx cv cB wceq
      cA cF cfv vx cv wceq cA vx cv cF wbr wb cA cF cfv cB wceq cA cB cF wbr wb
      cF wfun cA cF cdm wcel wa vx cv cB wceq cA cF cfv vx cv wceq cA cF cfv cB
      wceq cA vx cv cF wbr cA cB cF wbr vx cv cB cA cF cfv eqeq2 vx cv cB cA cF
      breq2 bibi12d imbi2d cA vx cv cF vx visset funbrfvb vtoclg 3impib 3coml
      $.
      $( [10-Feb-2007] $) $( [20-Jan-2007] $)

    $( Representation of a function in terms of its values. $)
    dffn5 $p |- ( F Fn A <->
                   F = { <. x , y >. | ( x e. A /\ y = ( F ` x ) ) } ) $=
      cF cA wfn cF vx cv cA wcel vy cv vx cv cF cfv wceq wa vx vy copab wceq cF
      cA wfn cF vx cv cA wcel vy cv vx cv cF cfv wceq wa vx vy copab wceq vz cv
      vw cv cop cF wcel vz cv vw cv cop vx cv cA wcel vy cv vx cv cF cfv wceq
      wa vx vy copab wcel wb vw wal vz wal cF cA wfn vz cv vw cv cop cF wcel vz
      cv vw cv cop vx cv cA wcel vy cv vx cv cF cfv wceq wa vx vy copab wcel wb
      vz vw cF cA wfn vz cv vw cv cop cF wcel vz cv cA wcel vw cv vz cv cF cfv
      wceq wa vz cv vw cv cop vx cv cA wcel vy cv vx cv cF cfv wceq wa vx vy
      copab wcel cF cA wfn vz cv vw cv cop cF wcel vz cv cA wcel vz cv vw cv
      cop cF wcel wa vz cv cA wcel vw cv vz cv cF cfv wceq wa cF cA wfn vz cv
      vw cv cop cF wcel vz cv cA wcel cF cA wfn vz cv vw cv cop cF wcel vz cv
      cA wcel cA vz cv vw cv cF fnop ex pm4.71rd cF cA wfn vz cv cA wcel vw cv
      vz cv cF cfv wceq vz cv vw cv cop cF wcel cF cA wfn vz cv cA wcel wa vz
      cv cF cfv vw cv wceq vz cv vw cv cop cF wcel vw cv vz cv cF cfv wceq cA
      vz cv vw cv cF vw visset fnopfvb vw cv vz cv cF cfv eqcom syl5bb pm5.32da
      bitr4d vx cv cA wcel vy cv vx cv cF cfv wceq wa vz cv cA wcel vy cv vz cv
      cF cfv wceq wa vz cv cA wcel vw cv vz cv cF cfv wceq wa vx vy vz cv vw cv
      vz visset vw visset vx cv vz cv wceq vx cv cA wcel vz cv cA wcel vy cv vx
      cv cF cfv wceq vy cv vz cv cF cfv wceq vx cv vz cv cA eleq1 vx cv vz cv
      wceq vx cv cF cfv vz cv cF cfv vy cv vx cv vz cv cF fveq2 eqeq2d anbi12d
      vy cv vw cv wceq vy cv vz cv cF cfv wceq vw cv vz cv cF cfv wceq vz cv cA
      wcel vy cv vw cv vz cv cF cfv eqeq1 anbi2d opelopab syl6bbr 19.21aivv cF
      wrel vx cv cA wcel vy cv vx cv cF cfv wceq wa vx vy copab wrel cF vx cv
      cA wcel vy cv vx cv cF cfv wceq wa vx vy copab wceq vz cv vw cv cop cF
      wcel vz cv vw cv cop vx cv cA wcel vy cv vx cv cF cfv wceq wa vx vy copab
      wcel wb vw wal vz wal wb cF cA wfn vz vw cF vx cv cA wcel vy cv vx cv cF
      cfv wceq wa vx vy copab eqrel cA cF fnrel vx cv cA wcel vy cv vx cv cF
      cfv wceq wa vx vy relopab sylancl mpbird cF vx cv cA wcel vy cv vx cv cF
      cfv wceq wa vx vy copab wceq cF cA wfn vx cv cA wcel vy cv vx cv cF cfv
      wceq wa vx vy copab cA wfn vx vy cA vx cv cF cfv vx cv cA wcel vy cv vx
      cv cF cfv wceq wa vx vy copab vx cv cF fvex vx cv cA wcel vy cv vx cv cF
      cfv wceq wa vx vy copab eqid fnopab2 cA cF vx cv cA wcel vy cv vx cv cF
      cfv wceq wa vx vy copab fneq1 mpbiri impbii $.
      $( [30-Jan-2004] $) $( [29-Jan-2004] $)

    $( The range of a function expressed as a collection of the function's
       values. $)
    fnrnfv $p |- ( F Fn A -> ran F = { y | E. x e. A y = ( F ` x ) } ) $=
      cF cA wfn vx cv vy cv cop cF wcel vx wex vy cab vy cv vx cv cF cfv wceq
      vx cA wrex vy cab cF crn cF cA wfn vx cv vy cv cop cF wcel vx wex vy cv
      vx cv cF cfv wceq vx cA wrex vy cF cA wfn vx cv vy cv cop cF wcel vx wex
      vx cv cA wcel vy cv vx cv cF cfv wceq wa vx wex vy cv vx cv cF cfv wceq
      vx cA wrex cF cA wfn vx cv vy cv cop cF wcel vx cv cA wcel vy cv vx cv cF
      cfv wceq wa vx cF cA wfn vx cv vy cv cop cF wcel vx cv cA wcel vx cv vy
      cv cop cF wcel wa vx cv cA wcel vy cv vx cv cF cfv wceq wa cF cA wfn vx
      cv vy cv cop cF wcel vx cv cA wcel cF cA wfn vx cv cF cdm wcel vx cv cA
      wcel vx cv vy cv cop cF wcel cF cA wfn cF cdm cA vx cv cA cF fndm eleq2d
      vx cv vy cv cF vx visset opeldm syl5bi pm4.71rd cF cA wfn vx cv cA wcel
      vx cv vy cv cop cF wcel vy cv vx cv cF cfv wceq cF cA wfn vx cv cA wcel
      wa vx cv cF cfv vy cv wceq vx cv vy cv cop cF wcel vy cv vx cv cF cfv
      wceq cA vx cv vy cv cF vy visset fnopfvb vx cv cF cfv vy cv eqcom
      syl5rbbr pm5.32da bitrd exbidv vy cv vx cv cF cfv wceq vx cA df-rex
      syl6bbr abbidv vx vy cF dfrn3 syl5eq $.
      $( [22-Oct-2005] $) $( [20-Oct-2005] $)

    $( A member of a function's range is a value of the function. $)
    fvelrnb $p |- ( F Fn A -> ( B e. ran F <-> E. x e. A ( F ` x ) = B ) ) $=
      cF cA wfn cB cF crn wcel cB vy cv vx cv cF cfv wceq vx cA wrex vy cab
      wcel vx cv cF cfv cB wceq vx cA wrex cF cA wfn cF crn vy cv vx cv cF cfv
      wceq vx cA wrex vy cab cB vx vy cA cF fnrnfv eleq2d vy cv vx cv cF cfv
      wceq vx cA wrex vx cv cF cfv cB wceq vx cA wrex vy cB vx cv cF cfv cB
      wceq cB cvv wcel vx cA vx cv cF cfv cB wceq cB cvv wcel wi vx cv cA wcel
      vx cv cF cfv cB wceq vx cv cF cfv cvv wcel cB cvv wcel vx cv cF fvex vx
      cv cF cfv cB cvv eleq1 mpbii a1i r19.23aiv vy cv cB wceq vy cv vx cv cF
      cfv wceq vx cv cF cfv cB wceq vx cA vy cv cB wceq vy cv vx cv cF cfv wceq
      cB vx cv cF cfv wceq vx cv cF cfv cB wceq vy cv cB vx cv cF cfv eqeq1 cB
      vx cv cF cfv eqcom syl6bb rexbidv elab3 syl6bb $.
      $( [31-Oct-1995] $)

    $( Alternate definition of the image of a function.  (Contributed by Raph
       Levien, 20-Nov-2006.) $)
    dfimafn $p |- ( ( Fun F /\ A C_ dom F ) ->
                  ( F " A ) = { y | E. x e. A ( F ` x ) = y } ) $=
      cF wfun cA cF cdm wss wa vx cv cF cfv vy cv wceq vx cA wrex vy cab vx cv
      vy cv cF wbr vx cA wrex vy cab cF cA cima cF wfun cA cF cdm wss wa vx cv
      cF cfv vy cv wceq vx cA wrex vx cv vy cv cF wbr vx cA wrex vy cF wfun cA
      cF cdm wss wa vx cv cF cfv vy cv wceq vx cv vy cv cF wbr vx cA cF wfun cA
      cF cdm wss vx cv cA wcel vx cv cF cfv vy cv wceq vx cv vy cv cF wbr wb cA
      cF cdm wss vx cv cA wcel vx cv cF cdm wcel cF wfun vx cv cF cfv vy cv
      wceq vx cv vy cv cF wbr wb cA cF cdm vx cv ssel cF wfun vx cv cF cdm wcel
      vx cv cF cfv vy cv wceq vx cv vy cv cF wbr wb vx cv vy cv cF vy visset
      funbrfvb ex syl9r imp31 rexbidva abbidv vx vy cF cA dfima2 syl6reqr $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)

    $( Alternate definition of the image of a function as an indexed union of
       singletons of function values.   (Contributed by Raph Levien,
       20-Nov-2006.) $)
    dfimafn2 $p |- ( ( Fun F /\ A C_ dom F ) ->
                   ( F " A ) = U_ x e. A { ( F ` x ) } ) $=
      cF wfun cA cF cdm wss wa cF cA cima vx cA vx cv cF cfv vy cv wceq vy cab
      ciun vx cA vx cv cF cfv csn ciun cF wfun cA cF cdm wss wa cF cA cima vx
      cv cF cfv vy cv wceq vx cA wrex vy cab vx cA vx cv cF cfv vy cv wceq vy
      cab ciun vx vy cA cF dfimafn vx cv cF cfv vy cv wceq vx vy cA iunab
      syl6eqr vx cA vx cv cF cfv csn vx cv cF cfv vy cv wceq vy cab vx cv cF
      cfv csn vx cv cF cfv vy cv wceq vy cab wceq vx cv cA wcel vx cv cF cfv
      csn vy cv vx cv cF cfv wceq vy cab vx cv cF cfv vy cv wceq vy cab vy vx
      cv cF cfv df-sn vy cv vx cv cF cfv wceq vx cv cF cfv vy cv wceq vy vy cv
      vx cv cF cfv eqcom abbii eqtri a1i iuneq2i syl6eqr $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)

    $( Membership relation for the values of a function whose image is a
       subclass.  (Contributed by Raph Levien, 20-Nov-2006.) $)
    funimass4 $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( ( F " A ) C_ B <-> A. x e. A ( F ` x ) e. B ) ) $=
      cA cF cdm wss cF wfun cF cA cima cB wss vx cv cF cfv cB wcel vx cA wral
      wb cA cF cdm wss cF wfun wa vy cv cF cA cima wcel vy cv cB wcel wi vy wal
      vx cv cF cfv cB wcel vx cA wral cF cA cima cB wss cA cF cdm wss cF wfun
      wa vy cv cF cA cima wcel vy cv cB wcel wi vy wal vy cv vx cv cF cfv wceq
      vy cv cB wcel wi vx cA wral vy wal vx cv cF cfv cB wcel vx cA wral cA cF
      cdm wss cF wfun wa vy cv cF cA cima wcel vy cv cB wcel wi vy cv vx cv cF
      cfv wceq vy cv cB wcel wi vx cA wral vy cA cF cdm wss cF wfun wa vy cv cF
      cA cima wcel vy cv cB wcel wi vy cv vx cv cF cfv wceq vx cA wrex vy cv cB
      wcel wi vy cv vx cv cF cfv wceq vy cv cB wcel wi vx cA wral cA cF cdm wss
      cF wfun wa vy cv cF cA cima wcel vy cv vx cv cF cfv wceq vx cA wrex vy cv
      cB wcel cA cF cdm wss cF wfun wa vy cv vx cv cF cfv wceq vx cA wrex vx cv
      vy cv cF wbr vx cA wrex vy cv cF cA cima wcel cA cF cdm wss cF wfun wa vy
      cv vx cv cF cfv wceq vx cv vy cv cF wbr vx cA cA cF cdm wss cF wfun wa vx
      cv cA wcel wa vx cv cF cfv vy cv wceq vx cv vy cv cF wbr vy cv vx cv cF
      cfv wceq cA cF cdm wss cF wfun vx cv cA wcel vx cv cF cfv vy cv wceq vx
      cv vy cv cF wbr wb cA cF cdm wss vx cv cA wcel vx cv cF cdm wcel cF wfun
      vx cv cF cfv vy cv wceq vx cv vy cv cF wbr wb cA cF cdm vx cv ssel cF
      wfun vx cv cF cdm wcel vx cv cF cfv vy cv wceq vx cv vy cv cF wbr wb vx
      cv vy cv cF vy visset funbrfvb ex syl9 imp31 vy cv vx cv cF cfv eqcom
      syl5bb rexbidva vx vy cv cF cA vy visset elima syl6rbbr imbi1d vy cv vx
      cv cF cfv wceq vy cv cB wcel vx cA r19.23v syl6bbr albidv vy cv vx cv cF
      cfv wceq vy cv cB wcel wi vx cA wral vy wal vy cv vx cv cF cfv wceq vy cv
      cB wcel wi vy wal vx cA wral vx cv cF cfv cB wcel vx cA wral vy cv vx cv
      cF cfv wceq vy cv cB wcel wi vx vy cA ralcom4 vy cv vx cv cF cfv wceq vy
      cv cB wcel wi vy wal vx cv cF cfv cB wcel vx cA vy cv cB wcel vx cv cF
      cfv cB wcel vy vx cv cF cfv vx cv cF fvex vy cv vx cv cF cfv cB eleq1
      ceqsalv ralbii bitr3i syl6bb vy cF cA cima cB dfss2 syl5bb ancoms $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)

    $( Function value in an image.  Part of Theorem 4.4(iii) of [Monk1]
       p. 42. $)
    fvelima $p |- ( ( Fun F /\ A e. ( F " B ) ) ->
                  E. x  e. B ( F ` x ) = A ) $=
      cF wfun cA cF cB cima wcel vx cv cF cfv cA wceq vx cB wrex cF wfun cA cF
      cB cima wcel vx cv cF cfv cA wceq vx cB wrex cF wfun vy cv cF cB cima
      wcel vx cv cF cfv vy cv wceq vx cB wrex wi wi cF wfun cA cF cB cima wcel
      vx cv cF cfv cA wceq vx cB wrex wi wi vy cA cF cB cima vy cv cA wceq vy
      cv cF cB cima wcel vx cv cF cfv vy cv wceq vx cB wrex wi cA cF cB cima
      wcel vx cv cF cfv cA wceq vx cB wrex wi cF wfun vy cv cA wceq vy cv cF cB
      cima wcel cA cF cB cima wcel vx cv cF cfv vy cv wceq vx cB wrex vx cv cF
      cfv cA wceq vx cB wrex vy cv cA cF cB cima eleq1 vy cv cA wceq vx cv cF
      cfv vy cv wceq vx cv cF cfv cA wceq vx cB vy cv cA vx cv cF cfv eqeq2
      rexbidv imbi12d imbi2d cF wfun vx cv vy cv cF wbr vx cB wrex vx cv cF cfv
      vy cv wceq vx cB wrex vy cv cF cB cima wcel cF wfun vx cv vy cv cF wbr vx
      cv cF cfv vy cv wceq vx cB vx cv vy cv cF vy visset funbrfv r19.22sdv vx
      vy cv cF cB vy visset elima syl5ib vtoclg pm2.43b imp $.
      $( [1-May-2004] $) $( [29-Apr-2004] $)

    $( Function value in an image. $)
    fvelimab $p |- ( ( F Fn A /\ B C_ A ) -> ( C e. ( F " B ) <->
                  E. x  e. B ( F ` x ) = C ) ) $=
      cF cA wfn cB cA wss wa cC cF cB cima wcel vx cv cF cfv cC wceq vx cB wrex
      cF cA wfn cB cA wss wa cC cvv wcel wa cC cF cB cima wcel cC cvv wcel cF
      cA wfn cB cA wss wa cC cF cB cima elisset anim2i vx cv cF cfv cC wceq vx
      cB wrex cC cvv wcel cF cA wfn cB cA wss wa vx cv cF cfv cC wceq cC cvv
      wcel vx cB vx cv cF cfv cC wceq cC cvv wcel wi vx cv cB wcel vx cv cF cfv
      cC wceq vx cv cF cfv cvv wcel cC cvv wcel vx cv cF fvex vx cv cF cfv cC
      cvv eleq1 mpbii a1i r19.23aiv anim2i cF cA wfn cB cA wss wa cC cvv wcel
      wa cC cF cB cima wcel vx cv cC cF wbr vx cB wrex vx cv cF cfv cC wceq vx
      cB wrex cC cvv wcel cC cF cB cima wcel vx cv cC cF wbr vx cB wrex wb cF
      cA wfn cB cA wss wa vx cC cF cB cvv elimag adantl cF cA wfn cB cA wss wa
      cC cvv wcel wa vx cv cF cfv cC wceq vx cv cC cF wbr vx cB cF wfun vx cv
      cF cdm wcel cC cvv wcel vx cv cF cfv cC wceq vx cv cC cF wbr wb cF cA wfn
      cB cA wss wa cC cvv wcel wa vx cv cB wcel wa vx cv cC cvv cF funbrfvbg cF
      cA wfn cB cA wss wa cF wfun cC cvv wcel vx cv cB wcel cF cA wfn cF wfun
      cB cA wss cA cF fnfun adantr ad2antrr cF cA wfn cB cA wss wa vx cv cB
      wcel vx cv cF cdm wcel cC cvv wcel cF cA wfn cB cA wss wa vx cv cB wcel
      vx cv cF cdm wcel cF cA wfn cB cA wss wa vx cv cB wcel vx cv cA wcel vx
      cv cF cdm wcel cB cA wss vx cv cB wcel vx cv cA wcel wi cF cA wfn cB cA
      vx cv ssel adantl cF cA wfn vx cv cF cdm wcel vx cv cA wcel wb cB cA wss
      cF cA wfn cF cdm cA vx cv cA cF fndm eleq2d adantr sylibrd imp adantlr cF
      cA wfn cB cA wss wa cC cvv wcel vx cv cB wcel simplr syl3anc rexbidva
      bitr4d pm5.21nd $.
      $( [22-Feb-2007] $) $( [20-Jan-2007] $)

    $( The indexed intersection of a function's values is the intersection of
       its range. $)
    fniinfv $p |- ( F Fn A -> |^|_ x e. A ( F ` x ) = |^| ran F ) $=
      cF cA wfn cF crn cint vy cv vx cv cF cfv wceq vx cA wrex vy cab cint vx
      cA vx cv cF cfv ciin cF cA wfn cF crn vy cv vx cv cF cfv wceq vx cA wrex
      vy cab vx vy cA cF fnrnfv inteqd vx vy cA vx cv cF cfv vx cv cF fvex
      dfiin2 syl6reqr $.
      $( [9-Dec-2005] $) $( [20-Oct-2005] $)

    $( Singleton of function value. $)
    fnsnfv $p |- ( ( F Fn A /\ B e. A ) -> { ( F ` B ) } = ( F " { B } ) ) $=
      cF cA wfn cB cA wcel wa vy cv cB cF cfv wceq vy cab cB vy cv cF wbr vy
      cab cB cF cfv csn cF cB csn cima cF cA wfn cB cA wcel wa vy cv cB cF cfv
      wceq cB vy cv cF wbr vy cF cA wfn cB cA wcel wa cB cF cfv vy cv wceq cB
      vy cv cF wbr vy cv cB cF cfv wceq cA cB vy cv cF vy visset fnbrfvb vy cv
      cB cF cfv eqcom syl5bb abbidv cB cF cfv csn vy cv cB cF cfv wceq vy cab
      wceq cF cA wfn cB cA wcel wa vy cB cF cfv df-sn a1i cF cA wfn cF cB csn
      cima cB vy cv cF wbr vy cab wceq cB cA wcel cF cA wfn cF wrel cF cB csn
      cima cB vy cv cF wbr vy cab wceq cA cF fnrel vy cB cF relimasn syl adantr
      3eqtr4d $.
      $( [22-May-1998] $)
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z F $.
    ssimaex.1 $e |- A e. _V $.
    $( The existence of a subimage. $)
    ssimaex $p |- ( ( Fun F /\ B C_ ( F " A ) ) ->
                 E. x ( x C_ A /\ B = ( F " x ) ) ) $=
      cF wfun cB cF cA cF cdm cin cima wss vx cv cA wss cB cF vx cv cima wceq
      wa vx wex cB cF cA cima wss cF wfun cB cF cA cF cdm cin cima wss wa vx cv
      cA cF cdm cin wss cB cF vx cv cima wceq wa vx wex vx cv cA wss cB cF vx
      cv cima wceq wa vx wex vy cv cF cfv cB wcel vy cA cF cdm cin crab cA cF
      cdm cin wss cB cF vy cv cF cfv cB wcel vy cA cF cdm cin crab cima wceq vx
      cv cA cF cdm cin wss cB cF vx cv cima wceq wa vx wex cF wfun cB cF cA cF
      cdm cin cima wss wa vx cv cA cF cdm cin wss cB cF vx cv cima wceq wa vy
      cv cF cfv cB wcel vy cA cF cdm cin crab cA cF cdm cin wss cB cF vy cv cF
      cfv cB wcel vy cA cF cdm cin crab cima wceq wa vx vy cv cF cfv cB wcel vy
      cA cF cdm cin crab vy cv cF cfv cB wcel vy cA cF cdm cin cA cF cdm
      ssimaex.1 inex1 rabex vx cv vy cv cF cfv cB wcel vy cA cF cdm cin crab
      wceq vx cv cA cF cdm cin wss vy cv cF cfv cB wcel vy cA cF cdm cin crab
      cA cF cdm cin wss cB cF vx cv cima wceq cB cF vy cv cF cfv cB wcel vy cA
      cF cdm cin crab cima wceq vx cv vy cv cF cfv cB wcel vy cA cF cdm cin
      crab cA cF cdm cin sseq1 vx cv vy cv cF cfv cB wcel vy cA cF cdm cin crab
      wceq cF vx cv cima cF vy cv cF cfv cB wcel vy cA cF cdm cin crab cima cB
      vx cv vy cv cF cfv cB wcel vy cA cF cdm cin crab cF imaeq2 eqeq2d anbi12d
      cla4ev vy cv cF cfv cB wcel vy cA cF cdm cin ssrab2 cF wfun cB cF cA cF
      cdm cin cima wss wa vz cB cF vy cv cF cfv cB wcel vy cA cF cdm cin crab
      cima cF wfun cB cF cA cF cdm cin cima wss wa vz cv cB wcel vz cv cF vy cv
      cF cfv cB wcel vy cA cF cdm cin crab cima wcel cF wfun cB cF cA cF cdm
      cin cima wss wa vz cv cB wcel vz cv cF vy cv cF cfv cB wcel vy cA cF cdm
      cin crab cima wcel cF wfun cB cF cA cF cdm cin cima wss wa vz cv cB wcel
      wa vz cv cF cA cF cdm cin cima wcel vz cv cF vy cv cF cfv cB wcel vy cA
      cF cdm cin crab cima wcel cB cF cA cF cdm cin cima wss vz cv cB wcel vz
      cv cF cA cF cdm cin cima wcel cF wfun cB cF cA cF cdm cin cima vz cv
      ssel2 adantll cF wfun vz cv cB wcel vz cv cF cA cF cdm cin cima wcel vz
      cv cF vy cv cF cfv cB wcel vy cA cF cdm cin crab cima wcel wi cB cF cA cF
      cdm cin cima wss cF wfun vz cv cB wcel wa vz cv cF cA cF cdm cin cima
      wcel vw cv cF cfv vz cv wceq vw cA cF cdm cin wrex vz cv cF vy cv cF cfv
      cB wcel vy cA cF cdm cin crab cima wcel cF wfun vz cv cF cA cF cdm cin
      cima wcel vw cv cF cfv vz cv wceq vw cA cF cdm cin wrex wi vz cv cB wcel
      cF wfun vz cv cF cA cF cdm cin cima wcel vw cv cF cfv vz cv wceq vw cA cF
      cdm cin wrex vw vz cv cA cF cdm cin cF fvelima ex adantr cF wfun vz cv cB
      wcel wa vw cv cF cfv vz cv wceq vw cA cF cdm cin wrex vw cv cF cfv vz cv
      wceq vw vy cv cF cfv cB wcel vy cA cF cdm cin crab wrex vz cv cF vy cv cF
      cfv cB wcel vy cA cF cdm cin crab cima wcel vz cv cB wcel vw cv cF cfv vz
      cv wceq vw cA cF cdm cin wrex vw cv cF cfv vz cv wceq vw vy cv cF cfv cB
      wcel vy cA cF cdm cin crab wrex wi cF wfun vz cv cB wcel vw cv cF cfv vz
      cv wceq vw cv cF cfv vz cv wceq vw cA cF cdm cin vy cv cF cfv cB wcel vy
      cA cF cdm cin crab vz cv cB wcel vw cv cA cF cdm cin wcel vw cv cF cfv vz
      cv wceq wa vw cv vy cv cF cfv cB wcel vy cA cF cdm cin crab wcel vw cv cF
      cfv vz cv wceq vz cv cB wcel vw cv cA cF cdm cin wcel vw cv cF cfv vz cv
      wceq wa vw cv cA cF cdm cin wcel vw cv cF cfv cB wcel wa vw cv vy cv cF
      cfv cB wcel vy cA cF cdm cin crab wcel vz cv cB wcel vw cv cF cfv vz cv
      wceq vw cv cF cfv cB wcel vw cv cA cF cdm cin wcel vz cv cB vw cv cF cfv
      eleq1a anim2d vy cv cF cfv cB wcel vw cv cF cfv cB wcel vy vw cv cA cF
      cdm cin vy cv vw cv wceq vy cv cF cfv vw cv cF cfv cB vy cv vw cv cF
      fveq2 eleq1d elrab syl6ibr vw cv cA cF cdm cin wcel vw cv cF cfv vz cv
      wceq wa vw cv cF cfv vz cv wceq wi vz cv cB wcel vw cv cA cF cdm cin wcel
      vw cv cF cfv vz cv wceq pm3.27 a1i jcad r19.22dv2 adantl cF wfun vz cv cF
      vy cv cF cfv cB wcel vy cA cF cdm cin crab cima wcel vw cv cF cfv vz cv
      wceq vw vy cv cF cfv cB wcel vy cA cF cdm cin crab wrex wb vz cv cB wcel
      cF wfun cF cF cdm wfn vz cv cF vy cv cF cfv cB wcel vy cA cF cdm cin crab
      cima wcel vw cv cF cfv vz cv wceq vw vy cv cF cfv cB wcel vy cA cF cdm
      cin crab wrex wb cF funfn cF cF cdm wfn vy cv cF cfv cB wcel vy cA cF cdm
      cin crab cF cdm wss vz cv cF vy cv cF cfv cB wcel vy cA cF cdm cin crab
      cima wcel vw cv cF cfv vz cv wceq vw vy cv cF cfv cB wcel vy cA cF cdm
      cin crab wrex wb vy cv cF cfv cB wcel vy cA cF cdm cin crab cA cF cdm cin
      cF cdm vy cv cF cfv cB wcel vy cA cF cdm cin ssrab2 cA cF cdm inss2 sstri
      vw cF cdm vy cv cF cfv cB wcel vy cA cF cdm cin crab vz cv cF fvelimab
      mpan2 sylbi adantr sylibrd syld adantlr mpd ex cF wfun vz cv cF vy cv cF
      cfv cB wcel vy cA cF cdm cin crab cima wcel vz cv cB wcel wi cB cF cA cF
      cdm cin cima wss cF wfun vz cv cF vy cv cF cfv cB wcel vy cA cF cdm cin
      crab cima wcel vw cv cF cfv vz cv wceq vw vy cv cF cfv cB wcel vy cA cF
      cdm cin crab wrex vz cv cB wcel cF wfun vz cv cF vy cv cF cfv cB wcel vy
      cA cF cdm cin crab cima wcel vw cv cF cfv vz cv wceq vw vy cv cF cfv cB
      wcel vy cA cF cdm cin crab wrex vw vz cv vy cv cF cfv cB wcel vy cA cF
      cdm cin crab cF fvelima ex vw cv cF cfv vz cv wceq vz cv cB wcel vw vy cv
      cF cfv cB wcel vy cA cF cdm cin crab vw cv vy cv cF cfv cB wcel vy cA cF
      cdm cin crab wcel vw cv cA cF cdm cin wcel vw cv cF cfv cB wcel wa vw cv
      cF cfv vz cv wceq vz cv cB wcel wi vy cv cF cfv cB wcel vw cv cF cfv cB
      wcel vy vw cv cA cF cdm cin vy cv vw cv wceq vy cv cF cfv vw cv cF cfv cB
      vy cv vw cv cF fveq2 eleq1d elrab vw cv cF cfv cB wcel vw cv cF cfv vz cv
      wceq vz cv cB wcel wi vw cv cA cF cdm cin wcel vw cv cF cfv vz cv wceq vw
      cv cF cfv cB wcel vz cv cB wcel vw cv cF cfv vz cv cB eleq1 biimpcd
      adantl sylbi r19.23aiv syl6 adantr impbid eqrdv sylancr vx cv cA cF cdm
      cin wss cB cF vx cv cima wceq wa vx cv cA wss cB cF vx cv cima wceq wa vx
      vx cv cA cF cdm cin wss vx cv cA wss cB cF vx cv cima wceq vx cv cA cF
      cdm cin wss cA cF cdm cin cA wss vx cv cA wss cA cF cdm inss1 vx cv cA cF
      cdm cin cA sstr mpan2 anim1i 19.22i syl cF cA cF cdm cin cima cF cA cima
      cB cF cF cA cres cdm cima cF cA cF cdm cin cima cF cA cima cF cA cres cdm
      cA cF cdm cin cF cF cA dmres imaeq2i cF cA imadmres eqtr3i sseq2i
      sylan2br $.
      $( [8-Apr-2007] $) $( [8-Apr-2007] $)
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.
    $( The existence of a subimage.  (Contributed by FL, 15-Apr-2007.) $)
    ssimaexg $p |- ( ( A e. C /\ Fun F /\ B C_ ( F " A ) ) ->
                 E. x ( x C_ A /\ B = ( F " x ) ) ) $=
      cA cC wcel cF wfun cB cF cA cima wss vx cv cA wss cB cF vx cv cima wceq
      wa vx wex cF wfun cB cF vy cv cima wss wa vx cv vy cv wss cB cF vx cv
      cima wceq wa vx wex wi cF wfun cB cF cA cima wss wa vx cv cA wss cB cF vx
      cv cima wceq wa vx wex wi vy cA cC vy cv cA wceq cF wfun cB cF vy cv cima
      wss wa cF wfun cB cF cA cima wss wa vx cv vy cv wss cB cF vx cv cima wceq
      wa vx wex vx cv cA wss cB cF vx cv cima wceq wa vx wex vy cv cA wceq cB
      cF vy cv cima wss cB cF cA cima wss cF wfun vy cv cA wceq cF vy cv cima
      cF cA cima cB vy cv cA cF imaeq2 sseq2d anbi2d vy cv cA wceq vx cv vy cv
      wss cB cF vx cv cima wceq wa vx cv cA wss cB cF vx cv cima wceq wa vx vy
      cv cA wceq vx cv vy cv wss vx cv cA wss cB cF vx cv cima wceq vy cv cA vx
      cv sseq2 anbi1d exbidv imbi12d vx vy cv cB cF vy visset ssimaex vtoclg
      3impib $.
      $( [17-May-2007] $) $( [10-Apr-2007] $)
  $}

  $( A simplified expression for the value of a function when we know it's
     a function. $)
  funfv $p |- ( Fun F -> ( F ` A ) = U. ( F " { A } ) ) $=
    cF wfun cA cF cdm wcel cA cF cfv cF cA csn cima cuni wceq cF wfun cA cF cdm
    wcel cA cF cfv cF cA csn cima cuni wceq cF wfun cA cF cdm wcel wa cA cF cfv
    csn cuni cF cA csn cima cuni cA cF cfv cF wfun cA cF cdm wcel wa cA cF cfv
    csn cF cA csn cima cF cF cdm wfn cA cF cdm wcel cA cF cfv csn cF cA csn
    cima wceq cF wfun cF cdm cA cF fnsnfv cF cF cdm wfn cF wfun cF cdm cF cdm
    wceq cF cF cdm df-fn cF cdm eqid mpbiran2 sylanbr unieqd cA cF cfv cA cF
    fvex unisn syl5eqr ex cA cF cdm wcel wn cA cF cfv c0 cF cA csn cima cuni cA
    cF ndmfv cA cF cdm wcel wn cF cA csn cima cuni c0 cuni c0 cA cF cdm wcel wn
    cF cA csn cima c0 cA cF ndmima unieqd uni0 syl6eq eqtr4d pm2.61d1 $.
    $( [22-May-1998] $)

  ${
    $d y A $.  $d y F $.
    $( The value of a function.  Definition of function value in [Enderton]
       p. 43. $)
    funfv2 $p |- ( Fun F -> ( F ` A ) = U. { y | A F y } ) $=
      cF wfun cA cF cfv cF cA csn cima cuni cA vy cv cF wbr vy cab cuni cA cF
      funfv cF wfun cF cA csn cima cA vy cv cF wbr vy cab cF wfun cF wrel cF cA
      csn cima cA vy cv cF wbr vy cab wceq cF funrel vy cA cF relimasn syl
      unieqd eqtrd $.
      $( [11-May-2005] $) $( [22-May-1998] $)
  $}

  ${
    $d w z A $.  $d w z F $.  $d w y z $.
    funfv2f.1 $e |- ( z e. A -> A. y z e. A ) $.
    funfv2f.2 $e |- ( z e. F -> A. y z e. F ) $.
    $( The value of a function.  Version of ~ funfv2 using a bound-variable
       hypotheses instead of distinct variable conditions. $)
    funfv2f $p |- ( Fun F -> ( F ` A ) = U. { y | A F y } ) $=
      cF wfun cA cF cfv cA vw cv cF wbr vw cab cuni cA vy cv cF wbr vy cab cuni
      vw cA cF funfv2 cA vw cv cF wbr vw cab cA vy cv cF wbr vy cab cA vw cv cF
      wbr cA vy cv cF wbr vw vy vy vz cA vw cv cF funfv2f.1 funfv2f.2 vz cv vw
      cv wcel vy ax-17 hbbr cA vy cv cF wbr vw ax-17 vw cv vy cv cA cF breq2
      cbvab unieqi syl6eq $.
      $( [27-Feb-2006] $) $( [19-Feb-2006] $)
  $}

  ${
    $d x y z A $.  $d x y z F $.
    $( Alternate definition of function value ~ df-fv that doesn't require
       dummy variables. $)
    dffv2 $p |- ( F ` A ) = U. ( ( F " { A } )
            \ U. U. ( ( ( F |` { A } ) o. `' ( F |` { A } ) ) \ _I ) ) $=
      cF cA csn cres wfun cA cF cfv cF cA csn cima cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif cuni cuni cdif cuni wceq cF cA csn cres wfun cA
      cF cA csn cres cfv cF cA csn cima cF cA csn cres cF cA csn cres ccnv ccom
      cid cdif cuni cuni cdif cuni cA cF cfv cF cA csn cres wfun cA cF cA csn
      cres cfv cF cA csn cres cA csn cima cuni cF cA csn cima cF cA csn cres cF
      cA csn cres ccnv ccom cid cdif cuni cuni cdif cuni cA cF cA csn cres
      funfv cF cA csn cres wfun cF cA csn cres cA csn cima cF cA csn cima cF cA
      csn cres cF cA csn cres ccnv ccom cid cdif cuni cuni cdif cF cA csn cres
      wfun cF cA csn cima cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni
      cuni cdif cF cA csn cima c0 cdif cF cA csn cres cA csn cima cF cA csn
      cres wfun cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni cuni c0
      cF cA csn cima cF cA csn cres wfun cF cA csn cres cF cA csn cres ccnv
      ccom cid cdif cuni cuni c0 cuni c0 cF cA csn cres wfun cF cA csn cres cF
      cA csn cres ccnv ccom cid cdif cuni c0 cF cA csn cres wfun cF cA csn cres
      cF cA csn cres ccnv ccom cid cdif cuni c0 cuni c0 cF cA csn cres wfun cF
      cA csn cres cF cA csn cres ccnv ccom cid cdif c0 cF cA csn cres wfun cF
      cA csn cres cF cA csn cres ccnv ccom cid wss cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif c0 wceq cF cA csn cres wfun cF cA csn cres wrel
      cF cA csn cres cF cA csn cres ccnv ccom cid wss cF cA csn cres df-fun
      pm3.27bi cF cA csn cres cF cA csn cres ccnv ccom cid ssdif0 sylib unieqd
      uni0 syl6eq unieqd uni0 syl6eq difeq2d cF cA csn cres cA csn cima cF cA
      csn cima cF cA csn cima c0 cdif cF cA csn resima cF cA csn cima dif0
      eqtr4i syl6reqr unieqd eqtrd cA cvv wcel cA cF cA csn cres cfv cA cF cfv
      wceq cA cvv wcel cA cA csn wcel cA cF cA csn cres cfv cA cF cfv wceq cA
      snidb cA cA csn cF fvres sylbi cA cvv wcel wn cA cF cA csn cres cfv c0 cA
      cF cfv cA cF cA csn cres fvprc cA cF fvprc eqtr4d pm2.61i syl5eqr cF cA
      csn cres wfun wn cA cF cfv c0 cF cA csn cima cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif cuni cuni cdif cuni cA cF nfunsn cF cA csn cres
      wfun wn cF cA csn cima cF cA csn cres cF cA csn cres ccnv ccom cid cdif
      cuni cuni cdif cuni c0 cuni c0 cF cA csn cres wfun wn cF cA csn cima cF
      cA csn cres cF cA csn cres ccnv ccom cid cdif cuni cuni cdif c0 cF cA csn
      cres wfun wn cA cF cA csn cres cdm wcel cF cA csn cima cF cA csn cres cF
      cA csn cres ccnv ccom cid cdif cuni cuni cdif c0 wceq cF cA csn cres wfun
      wn cA cF cA csn cres cdm wcel cF cA csn cima cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif cuni cuni cdif c0 wceq cF cA csn cres wfun wn cA
      cF cA csn cres cdm wcel wa cF cA csn cima cF cA csn cres cF cA csn cres
      ccnv ccom cid cdif cuni cuni wss cF cA csn cima cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif cuni cuni cdif c0 wceq cF cA csn cres wfun wn cA
      cF cA csn cres cdm wcel wa vy cF cA csn cima cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif cuni cuni cF cA csn cres wfun wn cA cF cA csn
      cres cdm wcel wa cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz
      wex vy cv cF cA csn cima wcel vy cv cF cA csn cres cF cA csn cres ccnv
      ccom cid cdif cuni cuni wcel wi cF cA csn cres wfun wn vx cv vz cv cF cA
      csn cres wbr vz cv vy cv wceq wn wa vz wex vx wex cA cF cA csn cres cdm
      wcel cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex cF cA csn
      cres wfun wn vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex
      vy wal vx wex vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz
      wex vx wex vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex
      vy wal vx wex cF cA csn cres wfun cF cA csn cres wfun vx cv vz cv cF cA
      csn cres wbr vz cv vy cv wceq wi vz wal vy wex vx wal vx cv vz cv cF cA
      csn cres wbr vz cv vy cv wceq wn wa vz wex vy wal wn vx wal vx cv vz cv
      cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vy wal vx wex wn cF cA
      csn cres wfun cF cA csn cres wrel vx cv vz cv cF cA csn cres wbr vz cv vy
      cv wceq wi vz wal vy wex vx wal vx vz vy cF cA csn cres dffun3 cF cA csn
      relres mpbiran vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wi vz wal
      vy wex vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vy
      wal wn vx vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wi vz wal vy
      wex vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex wn vy
      wex vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vy wal
      wn vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wi vz wal vx cv vz cv
      cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex wn vy vx cv vz cv cF cA
      csn cres wbr vz cv vy cv wceq wi vz wal vx cv vz cv cF cA csn cres wbr vz
      cv vy cv wceq wn wa wn vz wal vx cv vz cv cF cA csn cres wbr vz cv vy cv
      wceq wn wa vz wex wn vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wi
      vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa wn vz vx cv vz cv
      cF cA csn cres wbr vz cv vy cv wceq iman albii vx cv vz cv cF cA csn cres
      wbr vz cv vy cv wceq wn wa vz alnex bitri exbii vx cv vz cv cF cA csn
      cres wbr vz cv vy cv wceq wn wa vz wex vy exnal bitri albii vx cv vz cv
      cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vy wal vx alnex 3bitrri
      con1bii vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vy
      wal vx cv vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vx vx cv
      vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz wex vy ax-4 19.22i
      sylbi cA cF cA csn cres cdm wcel vx cv vz cv cF cA csn cres wbr vz cv vy
      cv wceq wn wa vz wex cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa
      vz wex vx cA cF cA csn cres cdm wcel vx cv vz cv cF cA csn cres wbr vz cv
      vy cv wceq wn wa cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vz cA
      cF cA csn cres cdm wcel vx cv vz cv cF cA csn cres wbr cA vz cv cF cA csn
      cres wbr vz cv vy cv wceq wn cA cF cA csn cres cdm wcel vx cv vz cv cF cA
      csn cres wbr cA vz cv cF cA csn cres wbr cA cF cA csn cres cdm wcel vx cv
      vz cv cF cA csn cres wbr vx cv vz cv cF cA csn cres wbr cA vz cv cF cA
      csn cres wbr wi cA cF cA csn cres cdm wcel vx cv vz cv cF cA csn cres wbr
      wa vx cv vz cv cF cA csn cres wbr cA vz cv cF cA csn cres wbr cA cF cA
      csn cres cdm wcel vx cv vz cv cF cA csn cres wbr wa vx cv cA vz cv cF cA
      csn cres cF cA csn cres cdm cA csn wceq vx cv cF cA csn cres cdm wcel vx
      cv cA wceq cA cF cA csn cres cdm wcel vx cv vz cv cF cA csn cres wbr cF
      cA csn cres cdm cA csn wceq vx cv cF cA csn cres cdm wcel vx cv cA wceq
      cF cA csn cres cdm cA csn wceq vx cv cF cA csn cres cdm wcel vx cv cA csn
      wcel vx cv cA wceq cF cA csn cres cdm cA csn vx cv eleq2 vx cA elsn
      syl6bb biimpa cA cF cA csn cres cdm wcel cA csn cF cA csn cres cdm wss cF
      cA csn cres cdm cA csn wceq cA cF cA csn cres cdm snssi cA csn cF cA csn
      cres cdm wss cF cA csn cres cA csn cres cdm cA csn cF cA csn cres cdm cA
      csn cF cA csn cres cdm wss cF cA csn cres cA csn cres cdm cA csn wceq cA
      csn cF cA csn cres ssdmres biimpi cF cA csn cres cA csn cres cF cA csn
      cres cF cA csn residm dmeqi syl5eqr syl vx cv vz cv cF cA csn cres vx
      visset breldm syl2an breq1d biimpd ex pm2.43d anim1d 19.22dv 19.23adv
      mpan9 cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa vy cv cF cA csn
      cima wcel vy cv cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni
      cuni wcel wi vz cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa cA vy
      cv cF cA csn cres wbr vy cv cF cA csn cres cF cA csn cres ccnv ccom cid
      cdif cuni cuni wcel vy cv cF cA csn cima wcel cA vz cv cF cA csn cres wbr
      vz cv vy cv wceq wn wa cA vy cv cF cA csn cres wbr vy cv cF cA csn cres
      cF cA csn cres ccnv ccom cid cdif cuni cuni wcel cA vz cv cF cA csn cres
      wbr vz cv vy cv wceq wn wa cA vy cv cF cA csn cres wbr wa vy cv cF cA csn
      cres cF cA csn cres ccnv ccom cid cdif cuni cuni wcel vz cv cF cA csn
      cres cF cA csn cres ccnv ccom cid cdif cuni cuni wcel cA vz cv cF cA csn
      cres wbr vz cv vy cv wceq wn wa cA vy cv cF cA csn cres wbr wa vy cv vz
      cv cpr cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni cuni wss vy
      cv cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni cuni wcel vz cv
      cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni cuni wcel wa cA vz
      cv cF cA csn cres wbr vz cv vy cv wceq wn wa cA vy cv cF cA csn cres wbr
      wa vy cv vz cv cop cuni cF cA csn cres cF cA csn cres ccnv ccom cid cdif
      cuni cuni vy cv vz cv cpr cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn
      wa cA vy cv cF cA csn cres wbr wa vy cv vz cv cop cF cA csn cres cF cA
      csn cres ccnv ccom cid cdif cuni wss vy cv vz cv cop cuni cF cA csn cres
      cF cA csn cres ccnv ccom cid cdif cuni cuni wss cA vz cv cF cA csn cres
      wbr vz cv vy cv wceq wn wa cA vy cv cF cA csn cres wbr wa vy cv vz cv cop
      csn cuni cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni vy cv vz
      cv cop cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa cA vy cv cF cA
      csn cres wbr wa vy cv vz cv cop cF cA csn cres cF cA csn cres ccnv ccom
      cid cdif wcel vy cv vz cv cop csn cF cA csn cres cF cA csn cres ccnv ccom
      cid cdif wss vy cv vz cv cop csn cuni cF cA csn cres cF cA csn cres ccnv
      ccom cid cdif cuni wss cA vz cv cF cA csn cres wbr vz cv vy cv wceq wn wa
      cA vy cv cF cA csn cres wbr wa vy cv vx cv cF cA csn cres ccnv wbr vx cv
      vz cv cF cA csn cres wbr wa vx cvv wrex vz cv vy cv wceq wn wa vy cv vz
      cv cop cF cA csn cres cF cA csn cres ccnv ccom cid cdif wcel cA vz cv cF
      cA csn cres wbr cA vy cv cF cA csn cres wbr vz cv vy cv wceq wn vy cv vx
      cv cF cA csn cres ccnv wbr vx cv vz cv cF cA csn cres wbr wa vx cvv wrex
      vz cv vy cv wceq wn wa cA vz cv cF cA csn cres wbr cA vy cv cF cA csn
      cres wbr wa vy cv vx cv cF cA csn cres ccnv wbr vx cv vz cv cF cA csn
      cres wbr wa vx cvv wrex vz cv vy cv wceq wn cA vz cv cF cA csn cres wbr
      cA vy cv cF cA csn cres wbr vy cv cA cF cA csn cres ccnv wbr vy cv vx cv
      cF cA csn cres ccnv wbr vx cv vz cv cF cA csn cres wbr wa vx cvv wrex cA
      vz cv cF cA csn cres wbr vy cv cA cF cA csn cres ccnv wbr cA vy cv cF cA
      csn cres wbr vy cv cvv wcel cA cvv wcel vy cv cA cF cA csn cres ccnv wbr
      cA vy cv cF cA csn cres wbr wb cA vz cv cF cA csn cres wbr vy cv cA cvv
      cvv cF cA csn cres brcnvg vy visset cA vz cv cF cA csn cres cF cA csn
      relres brrelexi sylancr biimpar vy cv cA cF cA csn cres ccnv wbr cA vz cv
      cF cA csn cres wbr vy cv vx cv cF cA csn cres ccnv wbr vx cv vz cv cF cA
      csn cres wbr wa vx cvv wrex cA cvv wcel vy cv cA cF cA csn cres ccnv wbr
      cA vz cv cF cA csn cres wbr wa vy cv vx cv cF cA csn cres ccnv wbr vx cv
      vz cv cF cA csn cres wbr wa vx cvv wrex cA vz cv cF cA csn cres wbr cA
      cvv wcel vy cv cA cF cA csn cres ccnv wbr cA vz cv cF cA csn cres cF cA
      csn relres brrelexi adantl vy cv vx cv cF cA csn cres ccnv wbr vx cv vz
      cv cF cA csn cres wbr wa vy cv cA cF cA csn cres ccnv wbr cA vz cv cF cA
      csn cres wbr wa vx cA cvv vx cv cA wceq vy cv vx cv cF cA csn cres ccnv
      wbr vy cv cA cF cA csn cres ccnv wbr vx cv vz cv cF cA csn cres wbr cA vz
      cv cF cA csn cres wbr vx cv cA vy cv cF cA csn cres ccnv breq2 vx cv cA
      vz cv cF cA csn cres breq1 anbi12d rcla4ev mpancom ancoms syldan anim1i
      an1rs vy cv vz cv cop cF cA csn cres cF cA csn cres ccnv ccom cid cdif
      wcel vy cv vz cv cop cF cA csn cres cF cA csn cres ccnv ccom wcel vy cv
      vz cv cop cid wcel wn wa vy cv vx cv cF cA csn cres ccnv wbr vx cv vz cv
      cF cA csn cres wbr wa vx cvv wrex vz cv vy cv wceq wn wa vy cv vz cv cop
      cF cA csn cres cF cA csn cres ccnv ccom cid eldif vy cv vz cv cop cF cA
      csn cres cF cA csn cres ccnv ccom wcel vy cv vx cv cF cA csn cres ccnv
      wbr vx cv vz cv cF cA csn cres wbr wa vx cvv wrex vy cv vz cv cop cid
      wcel wn vz cv vy cv wceq wn vy cv vx cv cF cA csn cres ccnv wbr vx cv vz
      cv cF cA csn cres wbr wa vx cvv wrex vy cv vx cv cF cA csn cres ccnv wbr
      vx cv vz cv cF cA csn cres wbr wa vx wex vy cv vz cv cF cA csn cres cF cA
      csn cres ccnv ccom wbr vy cv vz cv cop cF cA csn cres cF cA csn cres ccnv
      ccom wcel vy cv vx cv cF cA csn cres ccnv wbr vx cv vz cv cF cA csn cres
      wbr wa vx rexv vx vy cv vz cv cF cA csn cres cF cA csn cres ccnv vy
      visset vz visset brco vy cv vz cv cF cA csn cres cF cA csn cres ccnv ccom
      df-br 3bitr2ri vy cv vz cv cop cid wcel vz cv vy cv wceq vy cv vz cv cid
      wbr vy cv vz cv wceq vy cv vz cv cop cid wcel vz cv vy cv wceq vy cv vz
      cv vz visset ideq vy cv vz cv cid df-br vy vz equcom 3bitr3i notbii
      anbi12i bitr2i sylib vy cv vz cv cop cF cA csn cres cF cA csn cres ccnv
      ccom cid cdif snssi vy cv vz cv cop csn cF cA csn cres cF cA csn cres
      ccnv ccom cid cdif uniss 3syl vy cv vz cv cop vy cv vz cv opex unisn
      syl5ssr vy cv vz cv cop cF cA csn cres cF cA csn cres ccnv ccom cid cdif
      cuni uniss syl vy cv vz cv uniop syl5ssr vy cv vz cv cF cA csn cres cF cA
      csn cres ccnv ccom cid cdif cuni cuni vy visset vz visset prss sylibr
      pm3.26d ex vy cv cF cA csn cima wcel vy cv cF cA csn cres cA csn cima
      wcel cA vy cv cF cA csn cres wbr cF cA csn cres cA csn cima cF cA csn
      cima vy cv cF cA csn resima eleq2i cF cA csn cres cA vy cv elimasni
      sylbir syl5 19.23aiv syl ssrdv cF cA csn cima cF cA csn cres cF cA csn
      cres ccnv ccom cid cdif cuni cuni ssdif0 sylib ex cA cF cA csn cres cdm
      wcel wn cF cA csn cima cF cA csn cres cF cA csn cres ccnv ccom cid cdif
      cuni cuni cdif c0 cF cA csn cres cF cA csn cres ccnv ccom cid cdif cuni
      cuni cdif c0 cA cF cA csn cres cdm wcel wn cF cA csn cima c0 cF cA csn
      cres cF cA csn cres ccnv ccom cid cdif cuni cuni cA cF cA csn cres cdm
      wcel wn cF cA csn cres cA csn cima c0 cF cA csn cima cA cF cA csn cres
      ndmima cF cA csn resima syl5eqr difeq1d cF cA csn cres cF cA csn cres
      ccnv ccom cid cdif cuni cuni 0dif syl6eq pm2.61d1 unieqd uni0 syl6eq
      eqtr4d pm2.61i $.
      $( [7-Aug-2010] $) $( [4-Aug-2010] $)
  $}

  ${
    $d y z A $.  $d y z F $.  $d y z G $.
    $( Domains of a function composition. $)
    dmfco $p |- ( ( Fun G /\ A e. dom G ) ->
               ( A e. dom ( F o. G ) <-> ( G ` A ) e. dom F ) ) $=
      cG wfun cA cG cdm wcel wa cA cF cG ccom cdm wcel cA vz cv cop cG wcel vz
      cv vy cv cop cF wcel wa vz wex vy wex cA cG cfv cF cdm wcel cA cG cdm
      wcel cA cF cG ccom cdm wcel cA vz cv cop cG wcel vz cv vy cv cop cF wcel
      wa vz wex vy wex wb cG wfun cA cG cdm wcel cA cF cG ccom cdm wcel cA vy
      cv cop cF cG ccom wcel vy wex cA vz cv cop cG wcel vz cv vy cv cop cF
      wcel wa vz wex vy wex vy cA cF cG ccom cG cdm eldm2g cA cG cdm wcel cA vy
      cv cop cF cG ccom wcel cA vz cv cop cG wcel vz cv vy cv cop cF wcel wa vz
      wex vy cA cG cdm wcel vy cv cvv wcel cA vy cv cop cF cG ccom wcel cA vz
      cv cop cG wcel vz cv vy cv cop cF wcel wa vz wex wb vy visset vz cA vy cv
      cF cG cG cdm cvv opelco2g mpan2 exbidv bitrd adantl cG wfun cA cG cdm
      wcel wa cA cG cfv vy cv cop cF wcel vy wex cA vz cv cop cG wcel vz cv vy
      cv cop cF wcel wa vz wex vy wex cA cG cfv cF cdm wcel cG wfun cA cG cdm
      wcel wa cA cG cfv vy cv cop cF wcel cA vz cv cop cG wcel vz cv vy cv cop
      cF wcel wa vz wex vy cG wfun cA cG cdm wcel wa vz cv cA cG cfv wceq vz cv
      vy cv cop cF wcel wa vz wex cA vz cv cop cG wcel vz cv vy cv cop cF wcel
      wa vz wex cA cG cfv vy cv cop cF wcel cG wfun cA cG cdm wcel wa vz cv cA
      cG cfv wceq vz cv vy cv cop cF wcel wa cA vz cv cop cG wcel vz cv vy cv
      cop cF wcel wa vz cG wfun cA cG cdm wcel wa vz cv cA cG cfv wceq cA vz cv
      cop cG wcel vz cv vy cv cop cF wcel cG wfun cA cG cdm wcel wa cA cG cfv
      vz cv wceq cA vz cv cop cG wcel vz cv cA cG cfv wceq cA vz cv cG vz
      visset funopfvb vz cv cA cG cfv eqcom syl5bb anbi1d exbidv vz cv vy cv
      cop cF wcel cA cG cfv vy cv cop cF wcel vz cA cG cfv cA cG fvex vz cv cA
      cG cfv wceq vz cv vy cv cop cA cG cfv vy cv cop cF vz cv cA cG cfv vy cv
      opeq1 eleq1d ceqsexv syl5bbr exbidv vy cA cG cfv cF cA cG fvex eldm2
      syl5bb bitr4d $.
      $( [27-Jan-1997] $)

    $( Value of a function composition.  Similar to Exercise 5 of
       [TakeutiZaring] p. 28. $)
    fvco $p |- ( ( Fun F /\ Fun G /\ A e. dom G ) ->
               ( ( F o. G ) ` A ) = ( F ` ( G ` A ) ) ) $=
      cF wfun cG wfun cA cG cdm wcel w3a cA cF cG ccom cdm wcel cA cF cG ccom
      cfv cA cG cfv cF cfv wceq cF wfun cG wfun cA cG cdm wcel w3a cA cF cG
      ccom cdm wcel cA cF cG ccom cfv cA cG cfv cF cfv wceq cF wfun cG wfun cA
      cG cdm wcel w3a cA cF cG ccom cdm wcel wa cA cF cG ccom cfv cA cG cfv cF
      cfv wceq cA cA cG cfv cF cfv cop cF cG ccom wcel cF wfun cG wfun cA cG
      cdm wcel cA cF cG ccom cdm wcel cA cA cG cfv cF cfv cop cF cG ccom wcel
      cG wfun cA cG cdm wcel cF wfun cA cF cG ccom cdm wcel cA cA cG cfv cF cfv
      cop cF cG ccom wcel wi cG wfun cA cG cdm wcel cF wfun cA cF cG ccom cdm
      wcel cA cA cG cfv cF cfv cop cF cG ccom wcel cG wfun cA cG cdm wcel wa cF
      wfun cA cF cG ccom cdm wcel wa cF wfun cA cG cfv cF cdm wcel wa cA cA cG
      cfv cF cfv cop cF cG ccom wcel cG wfun cA cG cdm wcel wa cA cF cG ccom
      cdm wcel cA cG cfv cF cdm wcel cF wfun cA cF cG dmfco anbi2d cG wfun cA
      cG cdm wcel wa cA cA cG cfv cF cfv cop cF cG ccom wcel cA cG cfv cA cG
      cfv cF cfv cop cF wcel cF wfun cA cG cfv cF cdm wcel wa cG wfun cA cG cdm
      wcel wa cA cA cG cfv cF cfv cop cF cG ccom wcel cA vz cv cop cG wcel vz
      cv cA cG cfv cF cfv cop cF wcel wa vz wex cA cG cfv cA cG cfv cF cfv cop
      cF wcel cA cG cdm wcel cA cA cG cfv cF cfv cop cF cG ccom wcel cA vz cv
      cop cG wcel vz cv cA cG cfv cF cfv cop cF wcel wa vz wex wb cG wfun cA cG
      cdm wcel cA cG cfv cF cfv cvv wcel cA cA cG cfv cF cfv cop cF cG ccom
      wcel cA vz cv cop cG wcel vz cv cA cG cfv cF cfv cop cF wcel wa vz wex wb
      cA cG cfv cF fvex vz cA cA cG cfv cF cfv cF cG cG cdm cvv opelco2g mpan2
      adantl cG wfun cA cG cdm wcel wa vz cv cA cG cfv wceq vz cv cA cG cfv cF
      cfv cop cF wcel wa vz wex cA vz cv cop cG wcel vz cv cA cG cfv cF cfv cop
      cF wcel wa vz wex cA cG cfv cA cG cfv cF cfv cop cF wcel cG wfun cA cG
      cdm wcel wa vz cv cA cG cfv wceq vz cv cA cG cfv cF cfv cop cF wcel wa cA
      vz cv cop cG wcel vz cv cA cG cfv cF cfv cop cF wcel wa vz cG wfun cA cG
      cdm wcel wa vz cv cA cG cfv wceq cA vz cv cop cG wcel vz cv cA cG cfv cF
      cfv cop cF wcel cG wfun cA cG cdm wcel wa cA cG cfv vz cv wceq cA vz cv
      cop cG wcel vz cv cA cG cfv wceq cA vz cv cG vz visset funopfvb vz cv cA
      cG cfv eqcom syl5bb anbi1d exbidv vz cv cA cG cfv cF cfv cop cF wcel cA
      cG cfv cA cG cfv cF cfv cop cF wcel vz cA cG cfv cA cG fvex vz cv cA cG
      cfv wceq vz cv cA cG cfv cF cfv cop cA cG cfv cA cG cfv cF cfv cop cF vz
      cv cA cG cfv cA cG cfv cF cfv opeq1 eleq1d ceqsexv syl5bbr bitr4d cF wfun
      cA cG cfv cF cdm wcel wa cA cG cfv cF cfv cA cG cfv cF cfv wceq cA cG cfv
      cA cG cfv cF cfv cop cF wcel cA cG cfv cF cfv eqid cA cG cfv cA cG cfv cF
      cfv cF cA cG cfv cF fvex funopfvb mpbii syl5bir sylbid exp4b com3r 3imp1
      cF wfun cG wfun cA cF cG ccom cdm wcel cA cF cG ccom cfv cA cG cfv cF cfv
      wceq cA cA cG cfv cF cfv cop cF cG ccom wcel wb cA cG cdm wcel cF cG ccom
      wfun cA cF cG ccom cdm wcel cA cF cG ccom cfv cA cG cfv cF cfv wceq cA cA
      cG cfv cF cfv cop cF cG ccom wcel wb cF wfun cG wfun wa cA cA cG cfv cF
      cfv cF cG ccom cA cG cfv cF fvex funopfvb cF cG funco sylan 3adantl3
      mpbird ex cG wfun cA cG cdm wcel cA cF cG ccom cdm wcel wn cA cF cG ccom
      cfv cA cG cfv cF cfv wceq wi cF wfun cG wfun cA cG cdm wcel wa cA cF cG
      ccom cdm wcel wn cA cF cG ccom cfv cA cG cfv cF cfv wceq cG wfun cA cG
      cdm wcel wa cA cF cG ccom cdm wcel wn wa cA cF cG ccom cfv c0 cA cG cfv
      cF cfv cA cF cG ccom cdm wcel wn cA cF cG ccom cfv c0 wceq cG wfun cA cG
      cdm wcel wa cA cF cG ccom ndmfv adantl cG wfun cA cG cdm wcel wa cA cF cG
      ccom cdm wcel wn cA cG cfv cF cfv c0 wceq cG wfun cA cG cdm wcel wa cA cF
      cG ccom cdm wcel wn cA cG cfv cF cdm wcel wn cA cG cfv cF cfv c0 wceq cG
      wfun cA cG cdm wcel wa cA cF cG ccom cdm wcel cA cG cfv cF cdm wcel cA cF
      cG dmfco notbid cA cG cfv cF ndmfv syl6bi imp eqtr4d ex 3adant1 pm2.61d
      $.
      $( [24-Apr-2006] $) $( [22-Apr-2006] $)
  $}

  $( Value of a function composition.  Similar to second part of Theorem 3H of
     [Enderton] p. 47. $)
  fvco2 $p |- ( ( Fun F /\ G Fn A /\ C e. A ) ->
             ( ( F o. G ) ` C ) = ( F ` ( G ` C ) ) ) $=
    cF wfun cG cA wfn cC cA wcel cC cF cG ccom cfv cC cG cfv cF cfv wceq cG cA
    wfn cC cA wcel cF wfun cC cF cG ccom cfv cC cG cfv cF cfv wceq cG cA wfn cC
    cA wcel cF wfun cC cF cG ccom cfv cC cG cfv cF cfv wceq wi cF wfun cC cF cG
    ccom cfv cC cG cfv cF cfv wceq wi cA cC cG cG wfun cC cG cdm wcel cF wfun
    cC cF cG ccom cfv cC cG cfv cF cfv wceq wi cF wfun cG wfun cC cG cdm wcel
    cC cF cG ccom cfv cC cG cfv cF cfv wceq cF wfun cG wfun cC cG cdm wcel cC
    cF cG ccom cfv cC cG cfv cF cfv wceq cC cF cG fvco 3exp com3l imp funfni ex
    com3r 3imp $.
    $( [20-Aug-2006] $) $( [9-Oct-2004] $)

  $( Value of a function composition. $)
  fvco3 $p |- ( ( Fun F /\ G : A --> B /\ C e. A ) ->
             ( ( F o. G ) ` C ) = ( F ` ( G ` C ) ) ) $=
    cF wfun cG cA wfn cC cA wcel cC cF cG ccom cfv cC cG cfv cF cfv wceq cA cB
    cG wf cA cC cF cG fvco2 cA cB cG ffn syl3an2 $.
    $( [21-Aug-2006] $) $( [3-Jan-2004] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y ch $.
    fvopab3.1 $e |- B e. _V $.
    fvopab3.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    fvopab3.3 $e |- ( y = B -> ( ps <-> ch ) ) $.
    fvopab3.4 $e |- ( x e. C -> E! y ph ) $.
    fvopab3.5 $e |- F = { <. x , y >. | ( x e. C /\ ph ) } $.
    $( Value of a function given by ordered-pair class abstraction. $)
    fvopab3 $p |- ( A e. C -> ( ( F ` A ) = B <-> ch ) ) $=
      cA cC wcel cA cB cop vx cv cC wcel wph wa vx vy copab wcel cA cC wcel wch
      wa cA cF cfv cB wceq wch cA cC wcel cB cvv wcel cA cB cop vx cv cC wcel
      wph wa vx vy copab wcel cA cC wcel wch wa wb fvopab3.1 vx cv cC wcel wph
      wa cA cC wcel wps wa cA cC wcel wch wa vx vy cA cB cC cvv vx cv cA wceq
      vx cv cC wcel cA cC wcel wph wps vx cv cA cC eleq1 fvopab3.2 anbi12d vy
      cv cB wceq wps wch cA cC wcel fvopab3.3 anbi2d opelopabg mpan2 cA cC wcel
      cA cF cfv cB wceq cA cB cop cF wcel cA cB cop vx cv cC wcel wph wa vx vy
      copab wcel cF cC wfn cA cC wcel cA cF cfv cB wceq cA cB cop cF wcel wb
      wph vx vy cC cF fvopab3.4 fvopab3.5 fnopab cC cA cB cF fvopab3.1 fnopfvb
      mpan cF vx cv cC wcel wph wa vx vy copab cA cB cop fvopab3.5 eleq2i
      syl6bb cA cC wcel wch ibar 3bitr4d $.
      $( [6-Mar-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y ch $.
    fvopab3ig.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    fvopab3ig.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    fvopab3ig.3 $e |- ( x e. C -> E* y ph ) $.
    fvopab3ig.4 $e |- F = { <. x , y >. | ( x e. C /\ ph ) } $.
    $( Value of a function given by ordered-pair class abstraction. $)
    fvopab3ig $p |- ( ( A e. C /\ B e. D ) -> ( ch -> ( F ` A ) = B ) ) $=
      cA cC wcel cB cD wcel wa wch cA vx cv cC wcel wph wa vx vy copab cfv cB
      wceq cA cF cfv cB wceq cA cC wcel cB cD wcel wa wch cA cB cop vx cv cC
      wcel wph wa vx vy copab wcel cA vx cv cC wcel wph wa vx vy copab cfv cB
      wceq cA cC wcel cB cD wcel wch cA cB cop vx cv cC wcel wph wa vx vy copab
      wcel wi cB cD wcel cA cC wcel wch cA cB cop vx cv cC wcel wph wa vx vy
      copab wcel wi cA cC wcel cB cD wcel cA cC wcel wch cA cB cop vx cv cC
      wcel wph wa vx vy copab wcel cA cC wcel cB cD wcel wa cA cB cop vx cv cC
      wcel wph wa vx vy copab wcel cA cC wcel wch wa vx cv cC wcel wph wa cA cC
      wcel wps wa cA cC wcel wch wa vx vy cA cB cC cD vx cv cA wceq vx cv cC
      wcel cA cC wcel wph wps vx cv cA cC eleq1 fvopab3ig.1 anbi12d vy cv cB
      wceq wps wch cA cC wcel fvopab3ig.2 anbi2d opelopabg biimpar exp43
      pm2.43a imp cB cD wcel cA cB cop vx cv cC wcel wph wa vx vy copab wcel cA
      vx cv cC wcel wph wa vx vy copab cfv cB wceq wi cA cC wcel cB cD wcel vx
      cv cC wcel wph wa vx vy copab wfun cA cB cop vx cv cC wcel wph wa vx vy
      copab wcel cA vx cv cC wcel wph wa vx vy copab cfv cB wceq wi vx cv cC
      wcel wph wa vx vy copab wfun vx cv cC wcel wph wa vy wmo vx vx cv cC wcel
      wph wa vx vy funopab vx cv cC wcel wph wa vy wmo vx cv cC wcel wph vy wmo
      wi fvopab3ig.3 vx cv cC wcel wph vy moanimv mpbir mpgbir cA cB cD vx cv
      cC wcel wph wa vx vy copab funopfvg mpan2 adantl syld cA cF cfv cA vx cv
      cC wcel wph wa vx vy copab cfv cB cA cF vx cv cC wcel wph wa vx vy copab
      fvopab3ig.4 fveq1i eqeq1i syl6ibr $.
      $( [23-Oct-1999] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.
    fvopab4g.1 $e |- ( x = A -> B = C ) $.
    fvopab4g.2 $e |- F = { <. x , y >. | ( x e. D /\ y = B ) } $.
    $( Value of a function given by ordered-pair class abstraction. $)
    fvopab4g $p |- ( ( A e. D /\ C e. R ) -> ( F ` A ) = C ) $=
      cA cD wcel cC cR wcel wa cC cC wceq cA cF cfv cC wceq cC eqid vy cv cB
      wceq vy cv cC wceq cC cC wceq vx vy cA cC cD cR cF vx cv cA wceq cB cC vy
      cv fvopab4g.1 eqeq2d vy cv cC cC eqeq1 vy cv cB wceq vy wmo vx cv cD wcel
      vy cB moeq a1i fvopab4g.2 fvopab3ig mpi $.
      $( [23-Oct-1999] $)

    ${
      fvopab4.3 $e |- C e. _V $.
      $( Value of a function given by ordered-pair class abstraction. $)
      fvopab4 $p |- ( A e. D -> ( F ` A ) = C ) $=
        cA cD wcel cC cvv wcel cA cF cfv cC wceq fvopab4.3 vx vy cA cB cC cD
        cvv cF fvopab4g.1 fvopab4g.2 fvopab4g mpan2 $.
        $( [23-Oct-1999] $)
    $}
  $}

  ${
    $d v w z A $.  $d u v w y B $.  $d z w v C $.  $d v w x y D $.  $d u x z $.
    fvopab4gf.1 $e |- ( z e. A -> A. x z e. A ) $.
    fvopab4gf.2 $e |- ( z e. C -> A. x z e. C ) $.
    fvopab4gf.3 $e |- ( x = A -> B = C ) $.
    fvopab4gf.4 $e |- F = { <. x , y >. | ( x e. D /\ y = B ) } $.
    $( Value of a function given by an ordered-pair class abstraction.  This
       version of ~ fvopab4g uses bound-variable hypotheses instead of distinct
       variable conditions. $)
    fvopab4gf $p |- ( ( A e. D /\ C e. R ) -> ( F ` A ) = C ) $=
      cA cD wcel cC cR wcel wa cA vw cv cD wcel vv cv vx vw cv cB csb wceq wa
      vw vv copab cfv cC cA cF cfv vw vv cA vx vw cv cB csb cC cD cR vw cv cD
      wcel vv cv vx vw cv cB csb wceq wa vw vv copab vx vw vz cA cB cC
      fvopab4gf.1 fvopab4gf.2 fvopab4gf.3 csbhypf vw cv cD wcel vv cv vx vw cv
      cB csb wceq wa vw vv copab eqid fvopab4g cA cF cfv cA vx cv cD wcel vy cv
      cB wceq wa vx vy copab cfv cA vw cv cD wcel vv cv vx vw cv cB csb wceq wa
      vw vv copab cfv cA cF vx cv cD wcel vy cv cB wceq wa vx vy copab
      fvopab4gf.4 fveq1i cA vx cv cD wcel vy cv cB wceq wa vx vy copab vw cv cD
      wcel vv cv vx vw cv cB csb wceq wa vw vv copab vx cv cD wcel vy cv cB
      wceq wa vw cv cD wcel vv cv vx vw cv cB csb wceq wa vx vy vw vv vx cv cD
      wcel vy cv cB wceq wa vw ax-17 vx cv cD wcel vy cv cB wceq wa vv ax-17 vw
      cv cD wcel vv cv vx vw cv cB csb wceq vx vw cv cD wcel vx ax-17 vx vv vx
      vw cv cB csb vx vv vw cv cB vw visset vv cv vw cv wcel vx ax-17 hbcsb1
      hbeleq hban vw cv cD wcel vv cv vx vw cv cB csb wceq wa vy ax-17 vx cv vw
      cv wceq vy cv vv cv wceq wa vx cv cD wcel vw cv cD wcel vy cv cB wceq vv
      cv vx vw cv cB csb wceq vx cv vw cv wceq vx cv cD wcel vw cv cD wcel wb
      vy cv vv cv wceq vx cv vw cv cD eleq1 adantr vy cv vv cv wceq vx cv vw cv
      wceq vy cv vv cv cB vx vw cv cB csb vy cv vv cv wceq id vx vw cv cB
      csbeq1a eqeqan12rd anbi12d cbvopab fveq1i eqtri syl5eq $.
      $( [20-Dec-2008] $) $( [8-Nov-2005] $)
  $}

  ${
    $d z A $.  $d y B $.  $d z B $.  $d x y C $.  $d x z $.
    fvopab4sf.1 $e |- A e. _V $.
    fvopab4sf.2 $e |- B e. _V $.
    fvopab4sf.3 $e |- ( z e. A -> A. x z e. A ) $.
    fvopab4sf.4 $e |- F = { <. x , y >. | ( x e. C /\ y = B ) } $.
    $( Value of a function given by ordered-pair class abstraction, using
       explicit class substitution. $)
    fvopab4sf $p |- ( A e. C -> ( F ` A ) = [_ A / x ]_ B ) $=
      cA cC wcel vx cA cB csb cvv wcel cA cF cfv vx cA cB csb wceq vx cA cB
      fvopab4sf.1 fvopab4sf.2 csbex vx vy vz cA cB vx cA cB csb cC cvv cF
      fvopab4sf.3 vx vz cA cB fvopab4sf.1 fvopab4sf.3 hbcsb1 vx cA cB csbeq1a
      fvopab4sf.4 fvopab4gf mpan2 $.
      $( [10-Apr-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x z A $.  $d y z B $.  $d x y C $.
    fvopab4s.1 $e |- A e. _V $.
    fvopab4s.2 $e |- B e. _V $.
    fvopab4s.3 $e |- F = { <. x , y >. | ( x e. C /\ y = B ) } $.
    $( Value of a function given by ordered-pair class abstraction, using
       explicit class substitution. $)
    fvopab4s $p |- ( A e. C -> ( F ` A ) = [_ A / x ]_ B ) $=
      vx vy vz cA cB cC cF fvopab4s.1 fvopab4s.2 vz cv cA wcel vx ax-17
      fvopab4s.3 fvopab4sf $.
      $( [18-Apr-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x y A $.
    fvopab4ndm.1 $e |- F = { <. x , y >. | ( x e. A /\ ph ) } $.
    $( Value of a function given by an ordered-pair class abstraction, outside
       of its domain. $)
    fvopab4ndm $p |- ( -. B e. A -> ( F ` B ) = (/) ) $=
      cB cA wcel wn cB cF cdm wcel wn cB cF cfv c0 wceq cB cF cdm wcel cB cA
      wcel cF cdm cA cB cF cdm vx cv cA wcel wph wa vx vy copab cdm cA cF vx cv
      cA wcel wph wa vx vy copab fvopab4ndm.1 dmeqi wph vx vy cA dmopabss
      eqsstri sseli con3i cB cF ndmfv syl $.
      $( [8-Apr-2008] $) $( [28-Mar-2008] $)
  $}

  ${
    $d x y z w A $.  $d y z w B $.  $d x y z w C $.
    fvopabg.1 $e |- ( x = A -> B = C ) $.
    $( The value of a function given by ordered-pair class abstraction. $)
    fvopabg $p |- ( ( A e. D /\ C e. R ) ->
                    ( { <. x , y >. | y = B } ` A ) = C ) $=
      cA cvv wcel cC cR wcel cA vy cv cB wceq vx vy copab cfv cC wceq cA cD
      wcel vx vy cA cB cC cvv cR vy cv cB wceq vx vy copab fvopabg.1 vy cv cB
      wceq vx cv cvv wcel vy cv cB wceq wa vx vy vx cv cvv wcel vy cv cB wceq
      vx visset biantrur opabbii fvopab4g cA cD elisset sylan $.
      $( [2-Sep-2003] $)
  $}

  ${
    $d x y z w A $.  $d z w B $.  $d x y z w C $.
    fvopabn.1 $e |- ( x = A -> B = C ) $.
    $( This somewhat non-intuitive theorem tells us the value of its function
       is the empty set when the class ` C ` it would otherwise map to is a
       proper class.  This is a technical lemma that can help eliminate
       redundant sethood antecedents otherwise required by ~ fvopabg . $)
    fvopabn $p |- ( -. C e. _V -> ( { <. x , y >. | y = B } ` A ) = (/) ) $=
      cA cvv wcel cC cvv wcel wn cA vy cv cB wceq vx vy copab cfv c0 wceq wi cA
      cvv wcel cC cvv wcel wn cA vy cv cB wceq vx vy copab cfv c0 wceq cA cvv
      wcel cC cvv wcel wn wa cA vy cv cB wceq vx vy copab cfv c0 cuni c0 cA cvv
      wcel cC cvv wcel wn wa vy cv cB wceq vx vy copab cA csn cima vz cv csn
      wceq vz cab cuni c0 cuni cA vy cv cB wceq vx vy copab cfv cA cvv wcel cC
      cvv wcel wn wa vy cv cB wceq vx vy copab cA csn cima vz cv csn wceq vz
      cab c0 cA cvv wcel cC cvv wcel wn wa vy cv cB wceq vx vy copab cA csn
      cima vz cv csn wceq vz wex wn vy cv cB wceq vx vy copab cA csn cima vz cv
      csn wceq vz cab c0 wceq cA cvv wcel cC cvv wcel wn wa vy cv cB wceq vx vy
      copab cA csn cima vz cv csn wceq vz cA cvv wcel cC cvv wcel wn wa vy cv
      cB wceq vx vy copab cA csn cima vz cv csn wceq vz cv csn c0 wceq vz cv
      csn c0 wne vz cv csn c0 wceq wn vz cv vz visset snnz vz cv csn c0 df-ne
      mpbi cA cvv wcel cC cvv wcel wn wa vy cv cB wceq vx vy copab cA csn cima
      vz cv csn wceq c0 vz cv csn wceq vz cv csn c0 wceq cA cvv wcel cC cvv
      wcel wn wa vy cv cB wceq vx vy copab cA csn cima c0 vz cv csn cA cvv wcel
      cC cvv wcel wn wa vz cv cA csn wcel vz cv vw cv cop vy cv cB wceq vx vy
      copab wcel wa vz wex vw cab c0 vy cv cB wceq vx vy copab cA csn cima cA
      cvv wcel cC cvv wcel wn vz cv cA csn wcel vz cv vw cv cop vy cv cB wceq
      vx vy copab wcel wa vz wex vw cab vw cv cC wceq vw cab c0 cA cvv wcel vz
      cv cA csn wcel vz cv vw cv cop vy cv cB wceq vx vy copab wcel wa vz wex
      vw cv cC wceq vw cA cvv wcel vz cv cA csn wcel vz cv vw cv cop vy cv cB
      wceq vx vy copab wcel wa vz wex cA vw cv cop vy cv cB wceq vx vy copab
      wcel vw cv cC wceq cA cvv wcel vz cv cA wceq vz cv vw cv cop vy cv cB
      wceq vx vy copab wcel wa vz wex cA vw cv cop vy cv cB wceq vx vy copab
      wcel vz cv cA csn wcel vz cv vw cv cop vy cv cB wceq vx vy copab wcel wa
      vz wex vz cv vw cv cop vy cv cB wceq vx vy copab wcel cA vw cv cop vy cv
      cB wceq vx vy copab wcel vz cA cvv vz cv cA wceq vz cv vw cv cop cA vw cv
      cop vy cv cB wceq vx vy copab vz cv cA vw cv opeq1 eleq1d ceqsexgv vz cv
      cA csn wcel vz cv vw cv cop vy cv cB wceq vx vy copab wcel wa vz cv cA
      wceq vz cv vw cv cop vy cv cB wceq vx vy copab wcel wa vz vz cv cA csn
      wcel vz cv cA wceq vz cv vw cv cop vy cv cB wceq vx vy copab wcel vz cA
      elsn anbi1i exbii syl5bb cA cvv wcel vw cv cvv wcel cA vw cv cop vy cv cB
      wceq vx vy copab wcel vw cv cC wceq wb vw visset vy cv cB wceq vy cv cC
      wceq vw cv cC wceq vx vy cA vw cv cvv cvv vx cv cA wceq cB cC vy cv
      fvopabn.1 eqeq2d vy cv vw cv cC eqeq1 opelopabg mpan2 bitrd abbidv cC cvv
      wcel wn vw cv cC wceq vw wex wn vw cv cC wceq vw cab c0 wceq vw cv cC
      wceq vw wex cC cvv wcel vw cv cC wceq cC cvv wcel vw vw cv cC wceq vw cv
      cvv wcel cC cvv wcel vw visset vw cv cC cvv eleq1 mpbii 19.23aiv con3i vw
      cv cC wceq vw wex vw cv cC wceq vw cab c0 vw cv cC wceq vw abn0
      necon1bbii sylib sylan9eq vz vw vy cv cB wceq vx vy copab cA csn dfima3
      syl5eq eqeq1d c0 vz cv csn eqcom syl6bb mtbiri nexdv vy cv cB wceq vx vy
      copab cA csn cima vz cv csn wceq vz wex vy cv cB wceq vx vy copab cA csn
      cima vz cv csn wceq vz cab c0 vy cv cB wceq vx vy copab cA csn cima vz cv
      csn wceq vz abn0 necon1bbii sylib unieqd vz cA vy cv cB wceq vx vy copab
      df-fv syl5eq uni0 syl6eq ex cA cvv wcel wn cA vy cv cB wceq vx vy copab
      cfv c0 wceq cC cvv wcel wn cA vy cv cB wceq vx vy copab fvprc a1d pm2.61i
      $.
      $( [7-Nov-2003] $) $( [21-Oct-2003] $)
  $}

  ${
    $d z w v A $.  $d y w v B $.  $d z w v C $.  $d x y w v $.  $d x z $.
    fvopabgf.1 $e |- ( z e. A -> A. x z e. A ) $.
    fvopabgf.2 $e |- ( z e. C -> A. x z e. C ) $.
    fvopabgf.3 $e |- ( x = A -> B = C ) $.
    $( The value of a function given by ordered-pair class abstraction. $)
    fvopabgf $p |- ( ( A e. D /\ C e. R ) ->
                    ( { <. x , y >. | y = B } ` A ) = C ) $=
      cA cD wcel cC cR wcel wa cA vv cv vx vw cv cB csb wceq vw vv copab cfv cC
      cA vy cv cB wceq vx vy copab cfv vw vv cA vx vw cv cB csb cC cD cR vx vw
      vz cA cB cC fvopabgf.1 fvopabgf.2 fvopabgf.3 csbhypf fvopabg cA vy cv cB
      wceq vx vy copab vv cv vx vw cv cB csb wceq vw vv copab vy cv cB wceq vv
      cv vx vw cv cB csb wceq vx vy vw vv vy cv cB wceq vw ax-17 vy cv cB wceq
      vv ax-17 vx vv vx vw cv cB csb vx vv vw cv cB vw visset vv cv vw cv wcel
      vx ax-17 hbcsb1 hbeleq vv cv vx vw cv cB csb wceq vy ax-17 vy cv vv cv
      wceq vx cv vw cv wceq vy cv vv cv cB vx vw cv cB csb vy cv vv cv wceq id
      vx vw cv cB csbeq1a eqeqan12rd cbvopab fveq1i syl5eq $.
      $( [28-Oct-2003] $) $( [21-Oct-2003] $)

    $( The value of a function given by an ordered-pair class abstraction is
       the empty set when the class it would otherwise map to is a proper
       class.  This version of ~ fvopabn uses bound-variable hypotheses instead
       of distinct variable conditions. $)
    fvopabnf $p |- ( -. C e. _V -> ( { <. x , y >. | y = B } ` A ) = (/) ) $=
      cC cvv wcel wn cA vv cv vx vw cv cB csb wceq vw vv copab cfv c0 cA vy cv
      cB wceq vx vy copab cfv vw vv cA vx vw cv cB csb cC vx vw vz cA cB cC
      fvopabgf.1 fvopabgf.2 fvopabgf.3 csbhypf fvopabn cA vy cv cB wceq vx vy
      copab vv cv vx vw cv cB csb wceq vw vv copab vy cv cB wceq vv cv vx vw cv
      cB csb wceq vx vy vw vv vy cv cB wceq vw ax-17 vy cv cB wceq vv ax-17 vx
      vv vx vw cv cB csb vx vv vw cv cB vw visset vv cv vw cv wcel vx ax-17
      hbcsb1 hbeleq vv cv vx vw cv cB csb wceq vy ax-17 vy cv vv cv wceq vx cv
      vw cv wceq vy cv vv cv cB vx vw cv cB csb vy cv vv cv wceq id vx vw cv cB
      csbeq1a eqeqan12rd cbvopab fveq1i syl5eq $.
      $( [21-Dec-2008] $) $( [21-Oct-2003] $)
  $}

  ${
    $d z A $.  $d y B $.  $d z C $.  $d x y $.
    $d x u $.  $d x z $.
    fvopabf.1 $e |- ( z e. A -> A. x z e. A ) $.
    fvopabf.2 $e |- ( z e. C -> A. x z e. C ) $.
    fvopabf.3 $e |- A e. _V $.
    fvopabf.4 $e |- C e. _V $.
    fvopabf.5 $e |- ( x = A -> B = C ) $.
    $( The value of a function given by ordered-pair class abstraction. $)
    fvopabf $p |- ( { <. x , y >. | y = B } ` A ) = C $=
      cA cvv wcel cC cvv wcel cA vy cv cB wceq vx vy copab cfv cC wceq
      fvopabf.3 fvopabf.4 vx vy vz cA cB cC cvv cvv fvopabf.1 fvopabf.2
      fvopabf.5 fvopabgf mp2an $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d x z A $.  $d y B $.  $d x z C $.  $d x y z $.
    fvopab.1 $e |- A e. _V $.
    fvopab.2 $e |- C e. _V $.
    fvopab.3 $e |- ( x = A -> B = C ) $.
    $( The value of a function given by an ordered-pair class abstraction. $)
    fvopab $p |- ( { <. x , y >. | y = B } ` A ) = C $=
      vx vy vz cA cB cC vz cv cA wcel vx ax-17 vz cv cC wcel vx ax-17 fvopab.1
      fvopab.2 fvopab.3 fvopabf $.
      $( [17-Apr-1995] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d x y z $.
    $( Value of a function given by an ordered-pair class abstraction. $)
    fvopab2 $p |- ( ( x e. A /\ B e. C ) ->
                   ( { <. x , y >. | ( x e. A /\ y = B ) } ` x ) = B ) $=
      cB cC wcel vx cv cA wcel vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab
      cfv cB wceq cB cC wcel vy cv cB wceq vy wex vx cv cA wcel vx cv vx cv cA
      wcel vy cv cB wceq wa vx vy copab cfv cB wceq wi vy cB cC elex vy cv cB
      wceq vx cv cA wcel vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab cfv
      cB wceq wi vy vx cv cA wcel vx cv vx cv cA wcel vy cv cB wceq wa vx vy
      copab cfv cB wceq vy vx cv cA wcel vy ax-17 vy vz vz vx cv vx cv cA wcel
      vy cv cB wceq wa vx vy copab cfv cB vy vz vx cv vx cv cA wcel vy cv cB
      wceq wa vx vy copab vx cv cA wcel vy cv cB wceq wa vx vy vz hbopab2 vz cv
      vx cv wcel vy ax-17 hbfv vz cv cB wcel vy ax-17 hbeq hbim vy cv cB wceq
      vx cv cA wcel vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab cfv vy cv
      wceq vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab cfv cB wceq vx cv
      cA wcel vy cv cB wceq vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab
      cfv vy cv wceq vx cv cA wcel vy cv cB wceq cB cvv wcel vx cv vx cv cA
      wcel vy cv cB wceq wa vx vy copab cfv vy cv wceq vy cv cB wceq vy cv cvv
      wcel cB cvv wcel vy visset vy cv cB cvv eleq1 mpbii vy cv cB wceq vx cv
      cA wcel cB cvv wcel vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab cfv
      vy cv wceq wi vx cv cA wcel vy cv cB wceq vx cv cA wcel cB cvv wcel vx cv
      vx cv cA wcel vy cv cB wceq wa vx vy copab cfv vy cv wceq vx cv cA wcel
      vy cv cB wceq wa vx cv vy cv cop vx cv cA wcel vy cv cB wceq wa vx vy
      copab wcel vy weu vx cv vx cv cA wcel vy cv cB wceq wa vx vy copab cfv vy
      cv wceq vx cv cA wcel cB cvv wcel wa vx cv vy cv cop vx cv cA wcel vy cv
      cB wceq wa vx vy copab wcel vx cv vy cv cop vx cv cA wcel vy cv cB wceq
      wa vx vy copab wcel vy weu vx cv vx cv cA wcel vy cv cB wceq wa vx vy
      copab cfv vy cv wceq vx cv cA wcel vy cv cB wceq wa vx vy vz vx cv cA
      wcel vy cv cB wceq wa vx vy copab vx cv cA wcel vy cv cB wceq wa vx vy vz
      hbopab2 tz6.12f vx cv cA wcel vy cv cB wceq wa vx vy opabid sylanbr vx cv
      cA wcel vy cv cB wceq wa vy weu vx cv cA wcel vy cv cB wceq vy weu wa vx
      cv vy cv cop vx cv cA wcel vy cv cB wceq wa vx vy copab wcel vy weu vx cv
      cA wcel cB cvv wcel wa vx cv cA wcel vy cv cB wceq vy euanv vx cv vy cv
      cop vx cv cA wcel vy cv cB wceq wa vx vy copab wcel vx cv cA wcel vy cv
      cB wceq wa vy vx cv cA wcel vy cv cB wceq wa vx vy opabid eubii cB cvv
      wcel vy cv cB wceq vy weu vx cv cA wcel vy cB eueq anbi2i 3bitr4ri
      sylan2b exp43 pm2.43a mpdi com12 vy cv cB vx cv vx cv cA wcel vy cv cB
      wceq wa vx vy copab cfv eqeq2 sylibd 19.23ai syl impcom $.
      $( [2-Feb-2004] $) $( [30-Aug-1999] $)
  $}

  ${
    $d x z A $.  $d y z B $.  $d x y $.
    fvopabs.1 $e |- A e. _V $.
    fvopabs.2 $e |- B e. _V $.
    $( The value of a function given by an ordered-pair class abstraction,
       using class substitution. $)
    fvopabs $p |- ( { <. x , y >. | y = B } ` A ) = [_ A / x ]_ B $=
      vx vy vz cA cB vx cA cB csb vz cv cA wcel vx ax-17 vx vz cA cB fvopabs.1
      vz cv cA wcel vx ax-17 hbcsb1 fvopabs.1 vx cA cB fvopabs.1 fvopabs.2
      csbex vx cA cB csbeq1a fvopabf $.
      $( [27-Apr-2006] $) $( [25-Mar-2006] $)
  $}

  ${
    $d x y z A $.  $d z F $.  $d z ph $.  $d x ps $.
    fvopab5.1 $e |- F = { <. x , y >. | ph } $.
    fvopab5.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( The value of a function that is expressed as an ordered pair
       abstraction. $)
    fvopab5 $p |- ( ( Fun F /\ A e. B ) -> ( F ` A ) = U. { y | ps } ) $=
      cF wfun cA cB wcel cA cF cfv cA vy cv cF wbr vy cab cuni wps vy cab cuni
      vy vz cA cF vz cv cA wcel vy ax-17 vy vz cF wph vx vy copab fvopab5.1 wph
      vx vy vz hbopab2 hbxfr funfv2f cA cB wcel cA vy cv cF wbr vy cab wps vy
      cab cA cB wcel vx cv cA wceq vx wex cA vy cv cF wbr vy cab wps vy cab
      wceq vx cA cB elex vx cv cA wceq vx wex cA vy cv cF wbr wps vy vx cv cA
      wceq vx wex cA vy cv cop wph vx vy copab wcel wps cA vy cv cF wbr vx cv
      cA wceq cA vy cv cop wph vx vy copab wcel wps wb vx cA vy cv cop wph vx
      vy copab wcel wps vx vx vz vz cA vy cv cop wph vx vy copab vz cv cA vy cv
      cop wcel vx ax-17 wph vx vy vz hbopab1 hbel wps vx ax-17 hbbi vx cv cA
      wceq vx cv vy cv cop wph vx vy copab wcel cA vy cv cop wph vx vy copab
      wcel wps vx cv cA wceq vx cv vy cv cop cA vy cv cop wph vx vy copab vx cv
      cA vy cv opeq1 eleq1d vx cv cA wceq wph wps vx cv vy cv cop wph vx vy
      copab wcel fvopab5.2 wph vx vy opabid syl5bb bitr3d 19.23ai cA vy cv cF
      wbr cA vy cv cop cF wcel cA vy cv cop wph vx vy copab wcel cA vy cv cF
      df-br cF wph vx vy copab cA vy cv cop fvopab5.1 eleq2i bitri syl5bb
      abbidv syl unieqd sylan9eq $.
      $( [3-Mar-2006] $) $( [19-Feb-2006] $)
  $}

  ${
    $d A x y $. $d ps x y $. $d B y $. $d C x y $.
    fvopab6.1 $e |- F = { <. x , y >. | ( ph /\ y = B ) } $.
    fvopab6.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    fvopab6.3 $e |- ( x = A -> B = C ) $.
    $( Value of a function given by ordered-pair class abstraction.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    fvopab6 $p |- ( ( A e. D /\ C e. R /\ ps ) -> ( F ` A ) = C ) $=
      cA cD wcel cC cR wcel wps w3a cA cF cfv wps vy cv cC wceq wa vy cab cuni
      cC cF wfun cA cD wcel cA cF cfv wps vy cv cC wceq wa vy cab cuni wceq cA
      cD wcel cC cR wcel wps w3a wph vy cv cB wceq wa wps vy cv cC wceq wa vx
      vy cA cD cF fvopab6.1 vx cv cA wceq wph wps vy cv cB wceq vy cv cC wceq
      fvopab6.2 vx cv cA wceq cB cC vy cv fvopab6.3 eqeq2d anbi12d fvopab5 cF
      wfun wph vy cv cB wceq wa vy wmo vx cF wfun wph vy cv cB wceq wa vx vy
      copab wfun wph vy cv cB wceq wa vy wmo vx wal cF wph vy cv cB wceq wa vx
      vy copab wceq cF wfun wph vy cv cB wceq wa vx vy copab wfun wb fvopab6.1
      cF wph vy cv cB wceq wa vx vy copab funeq ax-mp wph vy cv cB wceq wa vx
      vy funopab bitri vy cv cB wceq wph vy vy cB moeq moani mpgbir cA cD wcel
      cC cR wcel wps 3simp1 sylancr cC cR wcel wps wps vy cv cC wceq wa vy cab
      cuni cC wceq cA cD wcel wps cC cR wcel wps vy cv cC wceq wa vy cab cuni
      vy cv cC wceq vy cab cuni cC wps wps vy cv cC wceq wa vy cab vy cv cC
      wceq vy cab wps wps vy cv cC wceq wa vy cv cC wceq vy wps wps vy cv cC
      wceq wa vy cv cC wceq wps vy cv cC wceq pm3.27 wps vy cv cC wceq pm3.2
      impbid2 abbidv unieqd cC cR wcel cC csn cuni cC vy cv cC wceq vy cab cuni
      cC cR unisng vy cv cC wceq vy cab cC csn cC csn vy cv cC wceq vy cab vy
      cC df-sn eqcomi unieqi syl5eq sylan9eqr 3adant1 eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    fvsn.1 $e |- A e. _V $.
    fvsn.2 $e |- B e. _V $.
    $( The value of a singleton of an ordered pair is the second member. $)
    fvsn $p |- ( { <. A , B >. } ` A ) = B $=
      cA cB cop csn wfun cA cB cop cA cB cop csn wcel cA cA cB cop csn cfv cB
      wceq cA cB fvsn.1 fvsn.2 funsn cA cB cop cA cB opex snid cA cB cA cB cop
      csn fvsn.2 funopfv mp2 $.
      $( [12-Aug-1994] $)
  $}

  ${
    fvsnun.1 $e |- A e. _V $.
    fvsnun.2 $e |- B e. _V $.
    fvsnun.3 $e |- G = ( { <. A , B >. } u. ( F |` ( C \ { A } ) ) ) $.
    $( The value of a function with one of its ordered pairs replaced, at the
       replaced ordered pair.  See also ~ fvsnun2 . $)
    fvsnun1 $p |- ( G ` A ) = B $=
      cA cG cA csn cres cfv cA cG cfv cB cA cA csn wcel cA cG cA csn cres cfv
      cA cG cfv wceq cA fvsnun.1 snid cA cA csn cG fvres ax-mp cA cG cA csn
      cres cfv cA cA cB cop csn cA csn cres cfv cA cA cB cop csn cfv cB cA cG
      cA csn cres cA cB cop csn cA csn cres cG cA csn cres cA cB cop csn cF cC
      cA csn cdif cres cun cA csn cres cA cB cop csn cA csn cres cF cC cA csn
      cdif cres cA csn cres cun cA cB cop csn cA csn cres cG cA cB cop csn cF
      cC cA csn cdif cres cun wceq cG cA csn cres cA cB cop csn cF cC cA csn
      cdif cres cun cA csn cres wceq fvsnun.3 cG cA cB cop csn cF cC cA csn
      cdif cres cun cA csn reseq1 ax-mp cA cB cop csn cF cC cA csn cdif cres cA
      csn resundir cA cB cop csn cA csn cres cF cC cA csn cdif cres cA csn cres
      cun cA cB cop csn cA csn cres c0 cun cA cB cop csn cA csn cres cF cC cA
      csn cdif cres cA csn cres c0 cA cB cop csn cA csn cres cC cA csn cdif cA
      csn cin c0 wceq cF cC cA csn cdif cres cA csn cres c0 wceq cC cA csn cdif
      cA csn cin cA csn cC cA csn cdif cin c0 cC cA csn cdif cA csn incom cA
      csn cC difdisj eqtri cC cA csn cdif cA csn cF resdisj ax-mp uneq2i cA cB
      cop csn cA csn cres un0 eqtri 3eqtri fveq1i cA cA csn wcel cA cA cB cop
      csn cA csn cres cfv cA cA cB cop csn cfv wceq cA fvsnun.1 snid cA cA csn
      cA cB cop csn fvres ax-mp cA cB fvsnun.1 fvsnun.2 fvsn 3eqtri eqtr3i $.
      $( [24-Sep-2007] $) $( [23-Sep-2007] $)

    $( The value of a function with one of its ordered pairs replaced, at
       arguments other than the replaced one.  See also ~ fvsnun1 . $)
    fvsnun2 $p |- ( D e. ( C \ { A } ) -> ( G ` D ) = ( F ` D ) ) $=
      cD cC cA csn cdif wcel cD cG cC cA csn cdif cres cfv cD cG cfv cD cF cfv
      cD cC cA csn cdif cG fvres cD cC cA csn cdif wcel cD cF cC cA csn cdif
      cres cfv cD cF cfv cD cG cC cA csn cdif cres cfv cD cC cA csn cdif cF
      fvres cD cG cC cA csn cdif cres cF cC cA csn cdif cres cG cC cA csn cdif
      cres cA cB cop csn cF cC cA csn cdif cres cun cC cA csn cdif cres cA cB
      cop csn cC cA csn cdif cres cF cC cA csn cdif cres cC cA csn cdif cres
      cun cF cC cA csn cdif cres cG cA cB cop csn cF cC cA csn cdif cres cun
      wceq cG cC cA csn cdif cres cA cB cop csn cF cC cA csn cdif cres cun cC
      cA csn cdif cres wceq fvsnun.3 cG cA cB cop csn cF cC cA csn cdif cres
      cun cC cA csn cdif reseq1 ax-mp cA cB cop csn cF cC cA csn cdif cres cC
      cA csn cdif resundir cA cB cop csn cC cA csn cdif cres cF cC cA csn cdif
      cres cC cA csn cdif cres cun c0 cF cC cA csn cdif cres cun cF cC cA csn
      cdif cres c0 cun cF cC cA csn cdif cres cA cB cop csn cC cA csn cdif cres
      c0 cF cC cA csn cdif cres cC cA csn cdif cres cF cC cA csn cdif cres cA
      csn cC cA csn cdif cin c0 wceq cA cB cop csn cC cA csn cdif cres c0 wceq
      cA csn cC difdisj cA cB cop csn cA csn wfn cA csn cC cA csn cdif cin c0
      wceq cA cB cop csn cC cA csn cdif cres c0 wceq wb cA csn cB csn cA cB cop
      csn wf1o cA cB cop csn cA csn wfn cA cB fvsnun.1 fvsnun.2 f1osn cA csn cB
      csn cA cB cop csn f1ofn ax-mp cA csn cC cA csn cdif cA cB cop csn
      fnresdisj ax-mp mpbi cF cC cA csn cdif residm uneq12i c0 cF cC cA csn
      cdif cres uncom cF cC cA csn cdif cres un0 3eqtri 3eqtri fveq1i syl5eq
      eqtr3d $.
      $( [24-Sep-2007] $) $( [23-Sep-2007] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y F $.  $d x y G $.
    $( Equality of functions is determined by their values.  Exercise 4 of
       [TakeutiZaring] p. 28. $)
    eqfnfv $p |- ( ( F Fn A /\ G Fn B ) -> ( F = G <->
                 ( A = B /\ A. x e. A ( F ` x ) = ( G ` x ) ) ) ) $=
      cF cA wfn cG cB wfn wa cF cG wceq cA cB wceq vx cv cF cfv vx cv cG cfv
      wceq vx cA wral wa cF cA wfn cG cB wfn wa cF cG wceq cA cB wceq vx cv cF
      cfv vx cv cG cfv wceq vx cA wral cF cdm cA wceq cG cdm cB wceq cF cG wceq
      cA cB wceq wi cF cA wfn cG cB wfn cF cdm cA wceq cG cdm cB wceq wa cF cdm
      cG cdm wceq cA cB wceq cF cG wceq cF cdm cA cG cdm cB eqeq12 cF cG dmeq
      syl5bi cA cF fndm cB cG fndm syl2an cF cG wceq vx cv cF cfv vx cv cG cfv
      wceq vx cA wral wi cF cA wfn cG cB wfn wa cF cG wceq vx cv cF cfv vx cv
      cG cfv wceq vx cA cF cG wceq vx cv cF cfv vx cv cG cfv wceq vx cv cA wcel
      vx cv cF cG fveq1 a1d r19.21aiv a1i jcad cF cA wfn cG cB wfn cA cB wceq
      vx cv cF cfv vx cv cG cfv wceq vx cA wral cF cG wceq cF cA wfn cG cB wfn
      cA cB wceq vx cv cF cfv vx cv cG cfv wceq vx cA wral cF cG wceq wi cF cA
      wfn cG cA wfn vx cv cF cfv vx cv cG cfv wceq vx cA wral cF cG wceq wi cG
      cB wfn cA cB wceq wa cF cA wfn cG cA wfn wa vx cv cF cfv vx cv cG cfv
      wceq vx cA wral vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb vy wal
      vx wal cF cG wceq cF cA wfn cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv
      cG cfv wceq wi vx wal vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb
      vy wal vx wal vx cv cF cfv vx cv cG cfv wceq vx cA wral cF cA wfn cG cA
      wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq wi vx cv vy cv cop cF
      wcel vx cv vy cv cop cG wcel wb vy wal vx cF cA wfn cG cA wfn wa vx cv cA
      wcel vx cv cF cfv vx cv cG cfv wceq wi vx cv vy cv cop cF wcel vx cv vy
      cv cop cG wcel wb vy vx cv cA wcel cF cA wfn cG cA wfn wa vx cv cA wcel
      vx cv cF cfv vx cv cG cfv wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop
      cG wcel wb wi wi cF cA wfn cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv
      cG cfv wceq wi vx cv cA wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG
      wcel wb cF cA wfn cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv
      wceq vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb cF cA wfn cG cA
      wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq vx cv vy cv cop cF
      wcel vx cv vy cv cop cG wcel wb wi cF cA wfn cG cA wfn wa vx cv cA wcel
      wa vx cv cF cfv vy cv wceq vx cv cG cfv vy cv wceq wb vx cv vy cv cop cF
      wcel vx cv vy cv cop cG wcel wb vx cv cF cfv vx cv cG cfv wceq cF cA wfn
      cG cA wfn wa vx cv cA wcel wa vx cv cF cfv vy cv wceq vx cv vy cv cop cF
      wcel vx cv cG cfv vy cv wceq vx cv vy cv cop cG wcel cF cA wfn vx cv cA
      wcel vx cv cF cfv vy cv wceq vx cv vy cv cop cF wcel wb cG cA wfn cA vx
      cv vy cv cF vy visset fnopfvb adantlr cG cA wfn vx cv cA wcel vx cv cG
      cfv vy cv wceq vx cv vy cv cop cG wcel wb cF cA wfn cA vx cv vy cv cG vy
      visset fnopfvb adantll bibi12d vx cv cF cfv vx cv cG cfv vy cv eqeq1
      syl5bi ex a2d com3r cF cA wfn cG cA wfn wa vx cv cA wcel wn vx cv vy cv
      cop cF wcel wn vx cv vy cv cop cG wcel wn wa vx cv cA wcel vx cv cF cfv
      vx cv cG cfv wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb
      wi cF cA wfn vx cv cA wcel wn vx cv vy cv cop cF wcel wn cG cA wfn vx cv
      vy cv cop cG wcel wn cF cA wfn vx cv vy cv cop cF wcel vx cv cA wcel cF
      cA wfn vx cv cF cdm wcel vx cv cA wcel vx cv vy cv cop cF wcel cF cA wfn
      cF cdm cA vx cv cA cF fndm eleq2d vx cv vy cv cF vx visset opeldm syl5bi
      con3d cG cA wfn vx cv vy cv cop cG wcel vx cv cA wcel cG cA wfn vx cv cG
      cdm wcel vx cv cA wcel vx cv vy cv cop cG wcel cG cA wfn cG cdm cA vx cv
      cA cG fndm eleq2d vx cv vy cv cG vx visset opeldm syl5bi con3d anim12ii
      vx cv vy cv cop cF wcel wn vx cv vy cv cop cG wcel wn wa vx cv vy cv cop
      cF wcel vx cv vy cv cop cG wcel wb vx cv cA wcel vx cv cF cfv vx cv cG
      cfv wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel pm5.21 a1d
      syl6com pm2.61i 19.21adv 19.20dv vx cv cF cfv vx cv cG cfv wceq vx cA
      df-ral syl5ib cF wrel cG wrel cF cG wceq vx cv vy cv cop cF wcel vx cv vy
      cv cop cG wcel wb vy wal vx wal wb cF cA wfn cG cA wfn vx vy cF cG eqrel
      cA cF fnrel cA cG fnrel syl2an sylibrd cA cB wceq cG cA wfn cG cB wfn cA
      cB cG fneq2 biimparc sylan2 exp32 imp4b impbid $.
      $( [5-Feb-2004] $) $( [3-Aug-1994] $)

    $( Equality of functions is determined by their values.  Special case of
       Exercise 4 of [TakeutiZaring] p. 28 (with domain equality omitted). $)
    eqfnfvALT $p |- ( ( F Fn A /\ G Fn A ) -> ( F = G <->
                 A. x e. A ( F ` x ) = ( G ` x ) ) ) $=
      cF cA wfn cG cA wfn wa cF cG wceq cA cA wceq vx cv cF cfv vx cv cG cfv
      wceq vx cA wral wa vx cv cF cfv vx cv cG cfv wceq vx cA wral vx cA cA cF
      cG eqfnfv cA cA wceq vx cv cF cfv vx cv cG cfv wceq vx cA wral wa cA cA
      wceq vx cv cF cfv vx cv cG cfv wceq vx cA wral cA cA wceq vx cv cF cfv vx
      cv cG cfv wceq vx cA wral wa biid cA eqid mpbiran syl6bb $.
      $( [17-Apr-2009] $) $( [3-Aug-1994] $)

    $( Equality of functions is determined by their values.  Special case of
       Exercise 4 of [TakeutiZaring] p. 28 (with domain equality omitted). $)
    eqfnfv2 $p |- ( ( F Fn A /\ G Fn A ) -> ( F = G <->
                 A. x e. A ( F ` x ) = ( G ` x ) ) ) $=
      cF cA wfn cG cA wfn wa cF cG wceq vx cv cF cfv vx cv cG cfv wceq vx cA
      wral cF cG wceq vx cv cF cfv vx cv cG cfv wceq vx cA cF cG wceq vx cv cF
      cfv vx cv cG cfv wceq vx cv cA wcel vx cv cF cG fveq1 a1d r19.21aiv cF cA
      wfn cG cA wfn wa vx cv cF cfv vx cv cG cfv wceq vx cA wral vx cv vy cv
      cop cF wcel vx cv vy cv cop cG wcel wb vy wal vx wal cF cG wceq cF cA wfn
      cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq wi vx wal vx cv
      vy cv cop cF wcel vx cv vy cv cop cG wcel wb vy wal vx wal vx cv cF cfv
      vx cv cG cfv wceq vx cA wral cF cA wfn cG cA wfn wa vx cv cA wcel vx cv
      cF cfv vx cv cG cfv wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop cG
      wcel wb vy wal vx cF cA wfn cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv
      cG cfv wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb vy vx
      cv cA wcel cF cA wfn cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv
      wceq wi vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb wi wi cF cA
      wfn cG cA wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq wi vx cv cA
      wcel vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb cF cA wfn cG cA
      wfn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq vx cv vy cv cop cF
      wcel vx cv vy cv cop cG wcel wb cF cA wfn cG cA wfn wa vx cv cA wcel vx
      cv cF cfv vx cv cG cfv wceq vx cv vy cv cop cF wcel vx cv vy cv cop cG
      wcel wb wi cF cA wfn cG cA wfn wa vx cv cA wcel wa vx cv cF cfv vy cv
      wceq vx cv cG cfv vy cv wceq wb vx cv vy cv cop cF wcel vx cv vy cv cop
      cG wcel wb vx cv cF cfv vx cv cG cfv wceq cF cA wfn cG cA wfn wa vx cv cA
      wcel wa vx cv cF cfv vy cv wceq vx cv vy cv cop cF wcel vx cv cG cfv vy
      cv wceq vx cv vy cv cop cG wcel cF cA wfn vx cv cA wcel vx cv cF cfv vy
      cv wceq vx cv vy cv cop cF wcel wb cG cA wfn cA vx cv vy cv cF vy visset
      fnopfvb adantlr cG cA wfn vx cv cA wcel vx cv cG cfv vy cv wceq vx cv vy
      cv cop cG wcel wb cF cA wfn cA vx cv vy cv cG vy visset fnopfvb adantll
      bibi12d vx cv cF cfv vx cv cG cfv vy cv eqeq1 syl5bi ex a2d com3r cF cA
      wfn cG cA wfn wa vx cv cA wcel wn vx cv vy cv cop cF wcel wn vx cv vy cv
      cop cG wcel wn wa vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq wi vx cv
      vy cv cop cF wcel vx cv vy cv cop cG wcel wb wi cF cA wfn vx cv cA wcel
      wn vx cv vy cv cop cF wcel wn cG cA wfn vx cv vy cv cop cG wcel wn cF cA
      wfn vx cv vy cv cop cF wcel vx cv cA wcel cF cA wfn vx cv cF cdm wcel vx
      cv cA wcel vx cv vy cv cop cF wcel cF cA wfn cF cdm cA vx cv cA cF fndm
      eleq2d vx cv vy cv cF vx visset opeldm syl5bi con3d cG cA wfn vx cv vy cv
      cop cG wcel vx cv cA wcel cG cA wfn vx cv cG cdm wcel vx cv cA wcel vx cv
      vy cv cop cG wcel cG cA wfn cG cdm cA vx cv cA cG fndm eleq2d vx cv vy cv
      cG vx visset opeldm syl5bi con3d anim12ii vx cv vy cv cop cF wcel wn vx
      cv vy cv cop cG wcel wn wa vx cv vy cv cop cF wcel vx cv vy cv cop cG
      wcel wb vx cv cA wcel vx cv cF cfv vx cv cG cfv wceq wi vx cv vy cv cop
      cF wcel vx cv vy cv cop cG wcel pm5.21 a1d syl6com pm2.61i 19.21adv
      19.20dv vx cv cF cfv vx cv cG cfv wceq vx cA df-ral syl5ib cF wrel cG
      wrel cF cG wceq vx cv vy cv cop cF wcel vx cv vy cv cop cG wcel wb vy wal
      vx wal wb cF cA wfn cG cA wfn vx vy cF cG eqrel cA cF fnrel cA cG fnrel
      syl2an sylibrd impbid2 $.
      $( [23-Mar-2009] $) $( [3-Aug-1994] $)
  $}

  ${
    $d x z A $.  $d y z F $.  $d y z G $.  $d x y $.
    eqfnfvf2.1 $e |- ( y e. F -> A. x y e. F ) $.
    eqfnfvf2.2 $e |- ( y e. G -> A. x y e. G ) $.
    $( Equality of functions is determined by their values.  Special case of
       Exercise 4 of [TakeutiZaring] p. 28 (with domain equality omitted).
       This version of ~ eqfnfv2 uses bound-variable hypotheses instead of
       distinct variable conditions. $)
    eqfnfvf2 $p |- ( ( F Fn A /\ G Fn A ) -> ( F = G <->
                 A. x e. A ( F ` x ) = ( G ` x ) ) ) $=
      cF cA wfn cG cA wfn wa cF cG wceq vz cv cF cfv vz cv cG cfv wceq vz cA
      wral vx cv cF cfv vx cv cG cfv wceq vx cA wral vz cA cF cG eqfnfv2 vz cv
      cF cfv vz cv cG cfv wceq vx cv cF cfv vx cv cG cfv wceq vz vx cA vx vy vy
      vz cv cF cfv vz cv cG cfv vx vy vz cv cF eqfnfvf2.1 vy cv vz cv wcel vx
      ax-17 hbfv vx vy vz cv cG eqfnfvf2.2 vy cv vz cv wcel vx ax-17 hbfv hbeq
      vx cv cF cfv vx cv cG cfv wceq vz ax-17 vz cv vx cv wceq vz cv cF cfv vx
      cv cF cfv vz cv cG cfv vx cv cG cfv vz cv vx cv cF fveq2 vz cv vx cv cG
      fveq2 eqeq12d cbvral syl6bb $.
      $( [22-Mar-2009] $) $( [29-Jan-2004] $)
  $}

  ${
    $d x B $.  $d x F $.  $d x G $.
    $( Equality of restricted functions is determined by their values. $)
    fvreseq $p |- ( ( ( F Fn A /\ G Fn A ) /\ B C_ A ) ->
         ( ( F |` B ) = ( G |` B ) <-> A. x e. B ( F ` x ) = ( G ` x ) ) ) $=
      cF cA wfn cG cA wfn wa cB cA wss wa cF cB cres cB wfn cG cB cres cB wfn
      wa cF cB cres cG cB cres wceq vx cv cF cfv vx cv cG cfv wceq vx cB wral
      wb cF cA wfn cG cA wfn cB cA wss cF cB cres cB wfn cG cB cres cB wfn wa
      cF cA wfn cB cA wss wa cF cB cres cB wfn cG cA wfn cB cA wss wa cG cB
      cres cB wfn cA cB cF fnssres cA cB cG fnssres anim12i anandirs cF cB cres
      cB wfn cG cB cres cB wfn wa cF cB cres cG cB cres wceq vx cv cF cB cres
      cfv vx cv cG cB cres cfv wceq vx cB wral vx cv cF cfv vx cv cG cfv wceq
      vx cB wral vx cB cF cB cres cG cB cres eqfnfv2 vx cv cF cB cres cfv vx cv
      cG cB cres cfv wceq vx cv cF cfv vx cv cG cfv wceq vx cB vx cv cB wcel vx
      cv cF cB cres cfv vx cv cF cfv vx cv cG cB cres cfv vx cv cG cfv vx cv cB
      cF fvres vx cv cB cG fvres eqeq12d ralbiia syl6bb syl $.
      $( [6-Feb-2004] $) $( [3-Aug-1994] $)
  $}

  ${
    $d x y z A $.  $d y B $.  $d z F $.  $d w x z C $.  $d w F $.
    elrnopabg.1 $e |- F = { <. x , y >. | ( x e. A
             /\ y = B ) } $.
    $( Membership in the range of an ordered pair class abstraction. $)
    elrnopabg $p |- ( A. x e. A B e. D ->
                    ( C e. ran F <-> E. x e. A C = B ) ) $=
      cB cD wcel vx cA wral cB cvv wcel vx cA wral cC cF crn wcel cC cB wceq vx
      cA wrex wb cB cD wcel cB cvv wcel vx cA cB cD elisset r19.20si cB cvv
      wcel vx cA wral cF cA wfn cC cF crn wcel cC cB wceq vx cA wrex wb cB cvv
      wcel vx cA wral vy cv cB wceq vy weu vx cA wral cF cA wfn cB cvv wcel vy
      cv cB wceq vy weu vx cA cB cvv wcel vy cv cB wceq vy weu vy cB eueq
      biimpi r19.20si vy cv cB wceq vx vy cA cF elrnopabg.1 fnopabg sylib cF cA
      wfn cC cF crn wcel vz cv cF cfv cC wceq vz cA wrex cB cvv wcel vx cA wral
      cC cB wceq vx cA wrex vz cA cC cF fvelrnb cB cvv wcel vx cA wral vx cv cF
      cfv cC wceq vx cA wrex cC cB wceq vx cA wrex vz cv cF cfv cC wceq vz cA
      wrex cB cvv wcel vx cA wral vx cv cF cfv cC wceq cC cB wceq vx cA cB cvv
      wcel vx cA hbra1 cB cvv wcel vx cA wral vx cv cA wcel wa vx cv cA wcel cB
      cvv wcel wa vx cv cF cfv cC wceq cC cB wceq wb cB cvv wcel vx cA wral vx
      cv cA wcel vx cv cA wcel cB cvv wcel wa cB cvv wcel vx cA wral vx cv cA
      wcel cB cvv wcel cB cvv wcel vx cA ra4 ancld imp vx cv cA wcel cB cvv
      wcel wa vx cv cF cfv cC wceq cB cC wceq cC cB wceq vx cv cA wcel cB cvv
      wcel wa vx cv cF cfv cB cC vx cv cA wcel cB cvv wcel wa vx cv vx cv cA
      wcel vy cv cB wceq wa vx vy copab cfv cB vx cv cF cfv vx vy cA cB cvv
      fvopab2 vx cv cF vx cv cA wcel vy cv cB wceq wa vx vy copab elrnopabg.1
      fveq1i syl5eq eqeq1d cB cC eqcom syl6bb syl rexbida vz cv cF cfv cC wceq
      vx cv cF cfv cC wceq vz vx cA vx vw vw vz cv cF cfv cC vx vw vz cv cF vx
      vw cF vx cv cA wcel vy cv cB wceq wa vx vy copab elrnopabg.1 vx cv cA
      wcel vy cv cB wceq wa vx vy vw hbopab1 hbxfr vw cv vz cv wcel vx ax-17
      hbfv vw cv cC wcel vx ax-17 hbeq vx cv cF cfv cC wceq vz ax-17 vz cv vx
      cv wceq vz cv cF cfv vx cv cF cfv cC vz cv vx cv cF fveq2 eqeq1d cbvrex
      syl5bb sylan9bbr mpdan syl $.
      $( [30-Aug-2007] $) $( [27-Aug-2007] $)
  $}

  ${
    $d x y z A $.  $d y B $.  $d z F $.  $d w x z C $.  $d w F $.
    elrnopab.1 $e |- B e. _V $.
    elrnopab.2 $e |- F = { <. x , y >. | ( x e. A
             /\ y = B ) } $.
    $( Membership in the range of an ordered pair class abstraction. $)
    elrnopab $p |- ( C e. ran F <-> E. x e. A C = B ) $=
      cB cvv wcel cC cF crn wcel cC cB wceq vx cA wrex wb vx cA vx vy cA cB cC
      cvv cF elrnopab.2 elrnopabg cB cvv wcel vx cv cA wcel elrnopab.1 a1i mprg
      $.
      $( [20-Sep-2004] $) $( [30-Aug-2004] $)
  $}

  ${
    $d x y A $.  $d x y F $.
    $( The range of a choice function (a function that chooses an element from
       each member of its domain) is included in the union of its domain. $)
    chfnrn $p |- ( ( F Fn A /\ A. x e. A ( F ` x ) e. x ) -> ran F C_ U. A ) $=
      cF cA wfn vx cv cF cfv vx cv wcel vx cA wral wa vy cF crn cA cuni cF cA
      wfn vx cv cF cfv vx cv wcel vx cA wral wa vy cv cF crn wcel vy cv vx cv
      wcel vx cA wrex vy cv cA cuni wcel cF cA wfn vy cv cF crn wcel vx cv cF
      cfv vy cv wceq vx cA wrex vx cv cF cfv vx cv wcel vx cA wral vy cv vx cv
      wcel vx cA wrex cF cA wfn vy cv cF crn wcel vx cv cF cfv vy cv wceq vx cA
      wrex vx cA vy cv cF fvelrnb biimpd vx cv cF cfv vx cv wcel vx cA wral vx
      cv cF cfv vy cv wceq vy cv vx cv wcel vx cA vx cv cF cfv vx cv wcel vx cA
      hbra1 vx cv cF cfv vx cv wcel vx cA wral vx cv cA wcel vx cv cF cfv vx cv
      wcel vx cv cF cfv vy cv wceq vy cv vx cv wcel wi vx cv cF cfv vx cv wcel
      vx cA ra4 vx cv cF cfv vy cv wceq vx cv cF cfv vx cv wcel vy cv vx cv
      wcel vx cv cF cfv vy cv vx cv eleq1 biimpcd syl6 r19.22d sylan9 vx vy cv
      cA eluni2 syl6ibr ssrdv $.
      $( [31-Aug-1999] $)
  $}

  ${
    $d x F $.  $d x A $.
    $( Ordered pair with function value.  Part of Theorem 4.3(i) of [Monk1]
       p. 41. $)
    funfvop $p |- ( ( Fun F /\ A e. dom F ) -> <. A , ( F ` A ) >. e. F ) $=
      cF wfun cA cF cdm wcel wa vx cv cA cF cfv wceq vx wex cA cA cF cfv cop cF
      wcel vx cA cF cfv cA cF fvex isseti cF wfun cA cF cdm wcel wa vx cv cA cF
      cfv wceq cA cA cF cfv cop cF wcel vx cF wfun cA cF cdm wcel wa cA cF cfv
      vx cv wceq cA cA cF cfv cop cF wcel vx cv cA cF cfv wceq cF wfun cA cF
      cdm wcel wa cA cF cfv vx cv wceq cA cA cF cfv cop cF wcel cF wfun cA cF
      cdm wcel wa cA cF cfv vx cv wceq cA vx cv cop cF wcel cA cF cfv vx cv
      wceq cA cA cF cfv cop cF wcel wi cA vx cv cF vx visset funopfvb cA cF cfv
      vx cv wceq cA cA cF cfv cop cF wcel cA vx cv cop cF wcel cA cF cfv vx cv
      wceq cA cA cF cfv cop cA vx cv cop cF cA cF cfv vx cv cA opeq2 eleq1d
      biimprcd syl6bi pm2.43d vx cv cA cF cfv eqcom syl5ib 19.23adv mpi $.
      $( [14-Oct-1996] $)
  $}

  $( A member of a preimage is a function value argument. $)
  fvimacnvi $p |- ( ( Fun F /\ A e. ( `' F " B ) ) -> ( F ` A ) e. B ) $=
    cF wfun cA cF ccnv cB cima wcel wa cA cF cfv cB wcel cF cA csn cima cB wss
    cF wfun cA csn cF ccnv cB cima wss cF cA csn cima cB wss cA cF ccnv cB cima
    wcel cA csn cB cF funimass2 cA cF ccnv cB cima snssi sylan2 cF wfun cA cF
    ccnv cB cima wcel wa cA cF cfv csn cB wss cF cA csn cima cB wss cA cF cfv
    cB wcel cF wfun cA cF ccnv cB cima wcel wa cA cF cfv csn cF cA csn cima cB
    cF wfun cA cF cdm wcel cA cF cfv csn cF cA csn cima wceq cA cF ccnv cB cima
    wcel cF cF cdm wfn cA cF cdm wcel cA cF cfv csn cF cA csn cima wceq cF wfun
    cF cdm cA cF fnsnfv cF funfn sylanb cF ccnv cB cima cF cdm cA cF cB
    cnvimass sseli sylan2 sseq1d cA cF cfv cB cA cF fvex snss syl5bb mpbird $.
    $( [5-May-2007] $) $( [4-May-2007] $)

  $( The argument of a function value belongs to the pre-image of any class
     containing the function value.  (Contributed by Raph Levien, 20-Nov-2006.
     He remarks: "This proof is unsatisfying, because it seems to me that
     ~ funimass2 could probably be strengthened to a biconditional.") $)
  fvimacnv $p |- ( ( Fun F /\ A e. dom F ) ->
                 ( ( F ` A ) e. B <-> A e. ( `' F " B ) ) ) $=
    cF wfun cA cF cdm wcel wa cA cF cfv cB wcel cA cF ccnv cB cima wcel cA cF
    cfv cB wcel cA cF ccnv cA cF cfv csn cima wcel cA cF ccnv cB cima wcel cF
    wfun cA cF cdm wcel wa cA cF cfv cB wcel cF ccnv cA cF cfv csn cima cF ccnv
    cB cima cA cA cF cfv cB wcel cA cF cfv csn cB wss cF ccnv cA cF cfv csn
    cima cF ccnv cB cima wss cA cF cfv cB cA cF fvex snss cA cF cfv csn cB cF
    ccnv imass2 sylbi sseld cF wfun cA cF cdm wcel wa cA cF ccnv cA cF cfv csn
    cima wcel cA cF cfv cA cop cF ccnv wcel cF wfun cA cF cdm wcel wa cA cF cfv
    cA cop cF ccnv wcel cA cA cF cfv cop cF wcel cA cF funfvop cA cF cdm wcel
    cA cF cfv cA cop cF ccnv wcel cA cA cF cfv cop cF wcel wb cF wfun cA cF cfv
    cvv wcel cA cF cdm wcel cA cF cfv cA cop cF ccnv wcel cA cA cF cfv cop cF
    wcel wb cA cF fvex cA cF cfv cA cvv cF cdm cF opelcnvg mpan adantl mpbird
    cA cF cdm wcel cA cF ccnv cA cF cfv csn cima wcel cA cF cfv cA cop cF ccnv
    wcel wb cF wfun cA cF cfv cvv wcel cA cF cdm wcel cA cF ccnv cA cF cfv csn
    cima wcel cA cF cfv cA cop cF ccnv wcel wb cA cF fvex cF ccnv cA cF cfv cA
    cvv cF cdm elimasng mpan adantl mpbird syl5com cF wfun cA cF ccnv cB cima
    wcel cA cF cfv cB wcel wi cA cF cdm wcel cF wfun cA cF ccnv cB cima wcel cA
    cF cfv cB wcel cA cB cF fvimacnvi ex adantr impbid $.
    $( [21-Nov-2006] $) $( [20-Nov-2006] $)

  ${
    $d F x $.  $d A x $.  $d B x $.
    $( A kind of contraposition law that infers an image subclass from a
       subclass of a pre-image.  (Contributed by Raph Levien, 20-Nov-2006.
       He remarks: "Likely this could be proved directly, and ~ fvimacnv would
       be the special case of ` A ` being a singleton, but it works this way
       round too.") $)
    funimass3 $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( ( F " A ) C_ B <-> A C_ ( `' F " B ) ) ) $=
      cF wfun cA cF cdm wss wa cF cA cima cB wss vx cv cF ccnv cB cima wcel vx
      cA wral cA cF ccnv cB cima wss cF wfun cA cF cdm wss wa cF cA cima cB wss
      vx cv cF cfv cB wcel vx cA wral vx cv cF ccnv cB cima wcel vx cA wral vx
      cA cB cF funimass4 cF wfun cA cF cdm wss wa vx cv cF cfv cB wcel vx cv cF
      ccnv cB cima wcel vx cA cF wfun cA cF cdm wss vx cv cA wcel vx cv cF cfv
      cB wcel vx cv cF ccnv cB cima wcel wb cA cF cdm wss vx cv cA wcel vx cv
      cF cdm wcel cF wfun vx cv cF cfv cB wcel vx cv cF ccnv cB cima wcel wb cA
      cF cdm vx cv ssel cF wfun vx cv cF cdm wcel vx cv cF cfv cB wcel vx cv cF
      ccnv cB cima wcel wb vx cv cB cF fvimacnv ex syl9r imp31 ralbidva bitrd
      vx cA cF ccnv cB cima dfss3 syl6bbr $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)

    $( A subclass of a preimage in terms of function values. $)
    funimass5 $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( A C_ ( `' F " B ) <-> A. x e. A ( F ` x ) e. B ) ) $=
      cF wfun cA cF cdm wss wa cF cA cima cB wss cA cF ccnv cB cima wss vx cv
      cF cfv cB wcel vx cA wral cA cB cF funimass3 vx cA cB cF funimass4 bitr3d
      $.
      $( [15-May-2007] $) $( [15-May-2007] $)

    $( Two ways of specifying that a function is constant on a subdomain. $)
    funconstss $p |- ( ( Fun F /\ A C_ dom F ) ->
                     ( A. x e. A ( F ` x ) = B <-> A C_ ( `' F " { B } ) ) ) $=
      cF wfun cA cF cdm wss wa vx cv cF cfv cB wceq vx cA wral cF cA cima cB
      csn wss cA cF ccnv cB csn cima wss cF wfun cA cF cdm wss wa cF cA cima cB
      csn wss vx cv cF cfv cB csn wcel vx cA wral vx cv cF cfv cB wceq vx cA
      wral vx cA cB csn cF funimass4 vx cv cF cfv cB csn wcel vx cv cF cfv cB
      wceq vx cA vx cv cF cfv cB vx cv cF fvex elsnc ralbii syl6rbb cA cB csn
      cF funimass3 bitrd $.
      $( [8-Mar-2007] $) $( [8-Mar-2007] $)
  $}


  $( Another proof of ~ fvimacnv , based on ~ funimass3 .  If ~ funimass3 is
     ever proved directly, as opposed to using ~ funimacnv pointwise, then the
     proof of ~ funimacnv should be replaced with this one.  (Contributed by
     Raph Levien, 20-Nov-2006.) $)
  fvimacnvALT $p |- ( ( Fun F /\ A e. dom F ) ->
                    ( ( F ` A ) e. B <-> A e. ( `' F " B ) ) ) $=
    cF wfun cA cF cdm wcel wa cF cA csn cima cB wss cA csn cF ccnv cB cima wss
    cA cF cfv cB wcel cA cF ccnv cB cima wcel cF wfun cA csn cF cdm wss cF cA
    csn cima cB wss cA csn cF ccnv cB cima wss wb cA cF cdm wcel cA csn cB cF
    funimass3 cA cF cdm snssi sylan2 cF wfun cA cF cdm wcel wa cA cF cfv csn cB
    wss cF cA csn cima cB wss cA cF cfv cB wcel cF wfun cA cF cdm wcel wa cA cF
    cfv csn cF cA csn cima cB cF cF cdm wfn cA cF cdm wcel cA cF cfv csn cF cA
    csn cima wceq cF wfun cF cdm cA cF fnsnfv cF wfun cF cdm cF cdm wceq cF cF
    cdm wfn cF cdm eqid cF cF cdm wfn cF wfun cF cdm cF cdm wceq wa cF cF cdm
    df-fn biimpri mpan2 sylan sseq1d cA cF cfv cB cA cF fvex snss syl5bb cA cF
    cdm wcel cA cF ccnv cB cima wcel cA csn cF ccnv cB cima wss wb cF wfun cA
    cF ccnv cB cima cF cdm snssg adantl 3bitr4d $.
    $( [21-Nov-2006] $) $( [20-Nov-2006] $)

  $( The pre-image of the codomain of a mapping is the mapping's domain.
     (Contributed by FL, 25-Jan-2007.) $)
  fimacnv $p |- ( F : A --> B -> ( `' F " B ) = A ) $=
    cA cB cF wf cF ccnv cB cima cA cA cB cF wf cF ccnv cB cima cF ccnv crn cA
    cF ccnv cB cima cF ccnv crn wss cA cB cF wf cF ccnv cB imassrn a1i cA cB cF
    wf cF cdm cA cF ccnv crn cA cB cF wf cF cdm cA cA cA cB cF fdm cA cA wss cA
    cB cF wf cA ssid a1i eqsstrd cF dfdm4 syl5ssr sstrd cA cB cF wf cF cA cima
    cB wss cA cF ccnv cB cima wss cA cB cF wf cF cA cima cF crn cB cF cA cima
    cF crn wss cA cB cF wf cF cA imassrn a1i cA cB cF frn sstrd cF wfun cA cF
    cdm wss cF cA cima cB wss cA cF ccnv cB cima wss wb cA cB cF wf cA cB cF
    funimass3 cA cB cF ffun cA cB cF wf cA cA cF cdm cA cA wss cA cB cF wf cA
    ssid a1i cA cB cF fdm sseqtr4d sylanc mpbid eqssd $.
    $( [25-Jan-2007] $) $( [25-Jan-2007] $)

  $( Ordered pair with function value.  Part of Theorem 4.3(i) of [Monk1]
     p. 41. $)
  fnopfv $p |- ( ( F Fn A /\ B e. A ) -> <. B , ( F ` B ) >. e. F ) $=
    cB cB cF cfv cop cF wcel cA cB cF cB cF funfvop funfni $.
    $( [9-Oct-2004] $) $( [30-Sep-2004] $)

  ${
    $d x y F $.  $d x A $.
    $( A function's value belongs to its range. $)
    fvelrn $p |- ( ( Fun F /\ A e. dom F ) -> ( F ` A ) e. ran F ) $=
      cF wfun cA cF cdm wcel cA cF cfv cF crn wcel cF wfun vx cv cF cdm wcel wa
      vx cv cF cfv cF crn wcel wi cF wfun cA cF cdm wcel wa cA cF cfv cF crn
      wcel wi vx cA cF cdm vx cv cA wceq cF wfun vx cv cF cdm wcel wa cF wfun
      cA cF cdm wcel wa vx cv cF cfv cF crn wcel cA cF cfv cF crn wcel vx cv cA
      wceq vx cv cF cdm wcel cA cF cdm wcel cF wfun vx cv cA cF cdm eleq1
      anbi2d vx cv cA wceq vx cv cF cfv cA cF cfv cF crn vx cv cA cF fveq2
      eleq1d imbi12d cF wfun vx cv cF cdm wcel wa vy cv vx cv cF cfv cop cF
      wcel vy wex vx cv cF cfv cF crn wcel cF wfun vx cv cF cdm wcel wa vx cv
      vx cv cF cfv cop cF wcel vy cv vx cv cF cfv cop cF wcel vy wex vx cv cF
      funfvop vy cv vx cv cF cfv cop cF wcel vx cv vx cv cF cfv cop cF wcel vy
      vx cv vx visset vy cv vx cv wceq vy cv vx cv cF cfv cop vx cv vx cv cF
      cfv cop cF vy cv vx cv vx cv cF cfv opeq1 eleq1d cla4ev syl vy vx cv cF
      cfv cF vx cv cF fvex elrn2 sylibr vtoclg anabsi7 $.
      $( [14-Oct-1996] $)
  $}

  $( A function's value belongs to its range. $)
  fnfvelrn $p |- ( ( F Fn A /\ B e. A ) -> ( F ` B ) e. ran F ) $=
    cB cF cfv cF crn wcel cA cB cF cB cF fvelrn funfni $.
    $( [15-Oct-1996] $)

  $( A function's value belongs to its codomain. $)
  ffvelrn $p |- ( ( F : A --> B /\ C e. A ) -> ( F ` C ) e. B ) $=
    cA cB cF wf cC cA wcel wa cC cF cfv cF crn wcel cC cF cfv cB wcel cF cA wfn
    cC cA wcel cC cF cfv cF crn wcel cA cB cF wf cA cC cF fnfvelrn cA cB cF ffn
    sylan cA cB cF wf cC cF cfv cF crn wcel cC cF cfv cB wcel wi cC cA wcel cA
    cB cF wf cF crn cB cC cF cfv cA cB cF frn sseld adantr mpd $.
    $( [12-Aug-1999] $)

  ${
    ffvrni.1 $e |- F : A --> B $.
    $( A function's value belongs to its codomain. $)
    ffvelrni $p |- ( C e. A -> ( F ` C ) e. B ) $=
      cA cB cF wf cC cA wcel cC cF cfv cB wcel ffvrni.1 cA cB cC cF ffvelrn
      mpan $.
      $( [8-Apr-2005] $) $( [6-Apr-2005] $)
  $}

  $( Alternate definition of a mapping. $)
  dff2 $p |- ( F : A --> B <-> ( F Fn A /\ F C_ ( A X. B ) ) ) $=
    cA cB cF wf cF cA wfn cF cA cB cxp wss wa cA cB cF wf cF cA wfn cF cA cB
    cxp wss cA cB cF ffn cA cB cF fssxp jca cF cA wfn cF cA cB cxp wss wa cF cA
    wfn cF crn cB wss wa cA cB cF wf cF cA cB cxp wss cF crn cB wss cF cA wfn
    cF crn cA cB cxp crn wss cA cB cxp crn cB wss cF crn cB wss cF cA cB cxp
    wss cF crn cA cB cxp crn cB sstr cF cA cB cxp rnss cA cB rnxpss sylancl
    anim2i cA cB cF df-f sylibr impbii $.
    $( [17-Nov-2007] $) $( [14-Nov-2007] $)

  ${
    $d f g x y z A $.  $d f g x y z B $.  $d x y z F $.
    $( Alternate definition of a mapping. $)
    dff3 $p |- ( F : A --> B <->
              ( F C_ ( A X. B ) /\ A. x e. A E! y x F y ) ) $=
      cA cB cF wf cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx cA wral wa cA
      cB cF wf cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx cA wral cA cB cF
      fssxp cA cB cF wf vx cv vy cv cF wbr vy weu vx cA vx cv vy cv cF wbr vy
      weu vx cv vy cv cF wbr vy wex vx cv vy cv cF wbr vy wmo cA cB cF wf vx cv
      cA wcel wa vx cv vy cv cF wbr vy eu5 cA cB cF wf vx cv cA wcel wa vx cv
      vx cv cF cfv cF wbr vx cv vy cv cF wbr vy wex cA cB cF wf vx cv cA wcel
      wa vx cv vx cv cF cfv cop cF wcel vx cv vx cv cF cfv cF wbr cF wfun vx cv
      cF cdm wcel vx cv vx cv cF cfv cop cF wcel cA cB cF wf vx cv cA wcel wa
      vx cv cF funfvop cA cB cF wf cF wfun vx cv cA wcel cA cB cF ffun adantr
      cA cB cF wf vx cv cF cdm wcel vx cv cA wcel cA cB cF wf cF cdm cA vx cv
      cA cB cF fdm eleq2d biimpar sylanc vx cv vx cv cF cfv cF df-br sylibr vx
      cv vy cv cF wbr vx cv vx cv cF cfv cF wbr vy vx cv cF cfv vx cv cF fvex
      vy cv vx cv cF cfv vx cv cF breq2 cla4ev syl cA cB cF wf vx cv vy cv cF
      wbr vy wmo vx cv cA wcel cA cB cF wf cF wfun vx cv vy cv cF wbr vy wmo cA
      cB cF ffun vx vy cF funmo syl adantr sylanbrc r19.21aiva jca cA cB cF wf
      cF cA wfn cF crn cB wss cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx cA
      wral wa cA cB cF df-f cF cA wfn cF wfun cF cdm cA wceq cF cA cB cxp wss
      vx cv vy cv cF wbr vy weu vx cA wral wa cF cA df-fn cF wfun cF wrel vx cv
      vy cv cF wbr vy wmo vx wal cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx
      cA wral wa vx vy cF dffun6 cF cA cB cxp wss cF wrel vx cv vy cv cF wbr vy
      weu vx cA wral cF cA cB cxp wss cF cvv cvv cxp wss cF wrel cF cA cB cxp
      wss cA cB cxp cvv cvv cxp wss cF cvv cvv cxp wss cA cB xpss cF cA cB cxp
      cvv cvv cxp sstr mpan2 cF df-rel sylibr adantr cF cA cB cxp wss vx cv vy
      cv cF wbr vy weu vx cA wral vx cv vy cv cF wbr vy wmo vx wal cF cA cB cxp
      wss vx cv cA wcel vx cv vy cv cF wbr vy weu wi vx wal vx cv vy cv cF wbr
      vy wmo vx wal vx cv vy cv cF wbr vy weu vx cA wral cF cA cB cxp wss vx cv
      cA wcel vx cv vy cv cF wbr vy weu wi vx cv vy cv cF wbr vy wmo vx cF cA
      cB cxp wss vx cv cA wcel vx cv vy cv cF wbr vy weu wi vx cv vy cv cF wbr
      vy wmo cF cA cB cxp wss vx cv cA wcel vx cv vy cv cF wbr vy weu wi wa vx
      cv cA wcel vx cv vy cv cF wbr vy wmo vx cv cA wcel vx cv vy cv cF wbr vy
      weu wi vx cv cA wcel vx cv vy cv cF wbr vy wmo wi cF cA cB cxp wss vx cv
      vy cv cF wbr vy weu vx cv vy cv cF wbr vy wmo vx cv cA wcel vx cv vy cv
      cF wbr vy eumo imim2i adantl cF cA cB cxp wss vx cv cA wcel wn vx cv vy
      cv cF wbr vy wmo wi vx cv cA wcel vx cv vy cv cF wbr vy weu wi cF cA cB
      cxp wss vx cv cA wcel wn vx cv vy cv cF wbr vy wex wn vx cv vy cv cF wbr
      vy wmo cF cA cB cxp wss vx cv vy cv cF wbr vy wex vx cv cA wcel cF cA cB
      cxp wss vx cv vy cv cF wbr vx cv cA wcel vy cF cA cB cxp wss vx cv vy cv
      cF wbr vx cv vy cv cop cA cB cxp wcel vx cv cA wcel cF cA cB cxp wss vx
      cv vy cv cop cF wcel vx cv vy cv cop cA cB cxp wcel vx cv vy cv cF wbr cF
      cA cB cxp vx cv vy cv cop ssel vx cv vy cv cF df-br syl5ib vx cv vy cv
      cop cA cB cxp wcel vx cv cA wcel vy cv cB wcel vx cv vy cv cA cB vy
      visset opelxp pm3.26bi syl6 19.23adv con3d vx cv vy cv cF wbr vy wex vx
      cv vy cv cF wbr vy wmo vx cv vy cv cF wbr vy exmo ori syl6 adantr pm2.61d
      ex 19.20dv vx cv vy cv cF wbr vy weu vx cA df-ral syl5ib imp sylanbrc cF
      cA cB cxp wss vx cv vy cv cF wbr vy weu vx cA wral wa cF cdm cA wss cA cF
      cdm wss wa cF cdm cA wceq cF cA cB cxp wss cF cdm cA wss vx cv vy cv cF
      wbr vy weu vx cA wral cA cF cdm wss cF cdm cA cB cxp cdm wss cA cB cxp
      cdm cA wss cF cdm cA wss cF cA cB cxp wss cF cdm cA cB cxp cdm cA sstr cF
      cA cB cxp dmss cA cB dmxpss sylancl vx cv vy cv cF wbr vy weu vx cA wral
      vz cA cF cdm vx cv vy cv cF wbr vy weu vx cA wral vz cv cA wcel vz cv vy
      cv cF wbr vy weu vz cv cF cdm wcel vx cv vy cv cF wbr vy weu vz cv vy cv
      cF wbr vy weu vx vz cv cA vx cv vz cv wceq vx cv vy cv cF wbr vz cv vy cv
      cF wbr vy vx cv vz cv vy cv cF breq1 eubidv rcla4cv vz cv vy cv cF wbr vy
      weu vz cv vy cv cF wbr vy wex vz cv cF cdm wcel vz cv vy cv cF wbr vy
      euex vy vz cv cF vz visset eldm sylibr syl6 ssrdv anim12i cF cdm cA eqss
      sylibr sylanbrc cF cA cB cxp wss cF crn cB wss vx cv vy cv cF wbr vy weu
      vx cA wral cF crn cA cB cxp crn wss cA cB cxp crn cB wss cF crn cB wss cF
      cA cB cxp wss cF crn cA cB cxp crn cB sstr cF cA cB cxp rnss cA cB rnxpss
      sylancl adantr sylanbrc impbii $.
      $( [20-Mar-2007] $) $( [20-Mar-2007] $)

    $( Alternate definition of a mapping. $)
    dff4 $p |- ( F : A --> B <->
              ( F C_ ( A X. B ) /\ A. x e. A E! y e. B x F y ) ) $=
      cA cB cF wf cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx cA wral wa cF
      cA cB cxp wss vx cv vy cv cF wbr vy cB wreu vx cA wral wa vx vy cA cB cF
      dff3 cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx cA wral vx cv vy cv cF
      wbr vy cB wreu vx cA wral cF cA cB cxp wss vx cv vy cv cF wbr vy weu vx
      cv vy cv cF wbr vy cB wreu vx cA cF cA cB cxp wss vx cv vy cv cF wbr vy
      weu vy cv cB wcel vx cv vy cv cF wbr wa vy weu vx cv vy cv cF wbr vy cB
      wreu cF cA cB cxp wss vx cv vy cv cF wbr vy cv cB wcel vx cv vy cv cF wbr
      wa vy cF cA cB cxp wss vx cv vy cv cF wbr vy cv cB wcel cF cA cB cxp wss
      vx cv vy cv cop cF wcel vy cv cB wcel vx cv vy cv cF wbr cF cA cB cxp wss
      vx cv vy cv cop cF wcel vx cv vy cv cop cA cB cxp wcel vy cv cB wcel cF
      cA cB cxp vx cv vy cv cop ssel vx cv vy cv cop cA cB cxp wcel vx cv cA
      wcel vy cv cB wcel vx cv vy cv cA cB vy visset opelxp pm3.27bi syl6 vx cv
      vy cv cF df-br syl5ib pm4.71rd eubidv vx cv vy cv cF wbr vy cB df-reu
      syl6bbr ralbidv pm5.32i bitri $.
      $( [22-Mar-2007] $) $( [20-Mar-2007] $)

    $( An onto mapping expressed in terms of function values. $)
    dffo3 $p |- ( F : A -onto-> B <-> ( F : A --> B /\
                  A. y e. B E. x e. A y = ( F ` x ) ) ) $=
      cA cB cF wfo cA cB cF wf cF crn cB wceq wa cA cB cF wf vy cv vx cv cF cfv
      wceq vx cA wrex vy cB wral wa cA cB cF dffo2 cA cB cF wf cF crn cB wceq
      vy cv vx cv cF cfv wceq vx cA wrex vy cB wral cA cB cF wf cF crn cB wceq
      vy cv vx cv cF cfv wceq vx cA wrex vy cab cB wceq vy cv vx cv cF cfv wceq
      vx cA wrex vy cB wral cA cB cF wf cF cA wfn cF crn cB wceq vy cv vx cv cF
      cfv wceq vx cA wrex vy cab cB wceq wb cA cB cF ffn cF cA wfn cF crn vy cv
      vx cv cF cfv wceq vx cA wrex vy cab cB vx vy cA cF fnrnfv eqeq1d syl cA
      cB cF wf vy cv vx cv cF cfv wceq vx cA wrex vy cv cB wcel wb vy wal vy cv
      cB wcel vy cv vx cv cF cfv wceq vx cA wrex wi vy wal vy cv vx cv cF cfv
      wceq vx cA wrex vy cab cB wceq vy cv vx cv cF cfv wceq vx cA wrex vy cB
      wral cA cB cF wf vy cv vx cv cF cfv wceq vx cA wrex vy cv cB wcel wb vy
      cv cB wcel vy cv vx cv cF cfv wceq vx cA wrex wi vy cA cB cF wf vy cv cB
      wcel vy cv vx cv cF cfv wceq vx cA wrex wi vy cv vx cv cF cfv wceq vx cA
      wrex vy cv cB wcel wi vy cv cB wcel vy cv vx cv cF cfv wceq vx cA wrex wi
      wa vy cv vx cv cF cfv wceq vx cA wrex vy cv cB wcel wb cA cB cF wf vy cv
      vx cv cF cfv wceq vx cA wrex vy cv cB wcel wi vy cv cB wcel vy cv vx cv
      cF cfv wceq vx cA wrex wi cA cB cF wf vy cv vx cv cF cfv wceq vy cv cB
      wcel vx cA cA cB cF wf vx cv cA wcel vy cv vx cv cF cfv wceq vy cv cB
      wcel cA cB cF wf vx cv cA wcel wa vy cv vx cv cF cfv wceq wa vy cv vx cv
      cF cfv cB cA cB cF wf vx cv cA wcel wa vy cv vx cv cF cfv wceq pm3.27 cA
      cB cF wf vx cv cA wcel wa vx cv cF cfv cB wcel vy cv vx cv cF cfv wceq cA
      cB vx cv cF ffvelrn adantr eqeltrd exp31 r19.23adv biantrurd vy cv vx cv
      cF cfv wceq vx cA wrex vy cv cB wcel dfbi2 syl6rbbr albidv vy cv vx cv cF
      cfv wceq vx cA wrex vy cB abeq1 vy cv vx cv cF cfv wceq vx cA wrex vy cB
      df-ral 3bitr4g bitrd pm5.32i bitri $.
      $( [30-Oct-2006] $) $( [29-Oct-2006] $)

    $( Alternate definition of an onto mapping. $)
    dffo4 $p |- ( F : A -onto-> B <->
                ( F : A --> B /\ A. y e. B E. x e. A x F y ) ) $=
      cA cB cF wfo cA cB cF wf vx cv vy cv cF wbr vx cA wrex vy cB wral wa cA
      cB cF wfo cA cB cF wf cF crn cB wceq wa cA cB cF wf vx cv vy cv cF wbr vx
      cA wrex vy cB wral wa cA cB cF dffo2 cA cB cF wf cF crn cB wceq wa cA cB
      cF wf vx cv vy cv cF wbr vx cA wrex vy cB wral cA cB cF wf cF crn cB wceq
      pm3.26 cA cB cF wf cF crn cB wceq wa vx cv vy cv cF wbr vx cA wrex vy cB
      cA cB cF wf cF crn cB wceq wa vy cv cB wcel wa vx cv vy cv cF wbr vx wex
      vx cv vy cv cF wbr vx cA wrex cF crn cB wceq vy cv cB wcel vx cv vy cv cF
      wbr vx wex cA cB cF wf cF crn cB wceq vx cv vy cv cF wbr vx wex vy cv cB
      wcel cF crn cB wceq vy cv cF crn wcel vy cv cB wcel vx cv vy cv cF wbr vx
      wex cF crn cB vy cv eleq2 vx vy cv cF vy visset elrn syl5bbr biimpar
      adantll cA cB cF wf vx cv vy cv cF wbr vx wex vx cv vy cv cF wbr vx cA
      wrex wi cF crn cB wceq vy cv cB wcel cA cB cF wf vx cv vy cv cF wbr vx
      wex vx cv cA wcel vx cv vy cv cF wbr wa vx wex vx cv vy cv cF wbr vx cA
      wrex cA cB cF wf vx cv vy cv cF wbr vx cv cA wcel vx cv vy cv cF wbr wa
      vx cA cB cF wf vx cv vy cv cF wbr vx cv cA wcel cA cB cF wf cF cA wfn vx
      cv vy cv cF wbr vx cv cA wcel wi cA cB cF ffn cF cA wfn vx cv vy cv cF
      wbr vx cv cA wcel cA vx cv vy cv cF fnbr ex syl ancrd 19.22dv vx cv vy cv
      cF wbr vx cA df-rex syl6ibr ad2antrr mpd r19.21aiva jca sylbi cA cB cF wf
      vx cv vy cv cF wbr vx cA wrex vy cB wral wa cA cB cF wf vy cv vx cv cF
      cfv wceq vx cA wrex vy cB wral wa cA cB cF wfo cA cB cF wf vx cv vy cv cF
      wbr vx cA wrex vy cB wral vy cv vx cv cF cfv wceq vx cA wrex vy cB wral
      cA cB cF wf vx cv vy cv cF wbr vx cA wrex vy cv vx cv cF cfv wceq vx cA
      wrex vy cB cA cB cF wf vx cv vy cv cF wbr vy cv vx cv cF cfv wceq vx cA
      cF cA wfn vx cv cA wcel vx cv vy cv cF wbr vy cv vx cv cF cfv wceq wi cA
      cB cF wf cF cA wfn vx cv cA wcel wa vx cv vy cv cF wbr vx cv cF cfv vy cv
      wceq vy cv vx cv cF cfv wceq cF cA wfn vx cv cA wcel wa vx cv cF cfv vy
      cv wceq vx cv vy cv cF wbr cA vx cv vy cv cF vy visset fnbrfvb biimprd vx
      cv cF cfv vy cv eqcom syl6ib cA cB cF ffn sylan r19.22dva r19.20sdv
      imdistani vx vy cA cB cF dffo3 sylibr impbii $.
      $( [22-Mar-2007] $) $( [20-Mar-2007] $)

    $( Alternate definition of an onto mapping. $)
    dffo5 $p |- ( F : A -onto-> B <->
                ( F : A --> B /\ A. y e. B E. x x F y ) ) $=
      cA cB cF wfo cA cB cF wf vx cv vy cv cF wbr vx cA wrex vy cB wral wa cA
      cB cF wf vx cv vy cv cF wbr vx wex vy cB wral wa vx vy cA cB cF dffo4 cA
      cB cF wf vx cv vy cv cF wbr vx cA wrex vy cB wral wa cA cB cF wf vx cv vy
      cv cF wbr vx wex vy cB wral wa vx cv vy cv cF wbr vx cA wrex vy cB wral
      vx cv vy cv cF wbr vx wex vy cB wral cA cB cF wf vx cv vy cv cF wbr vx cA
      wrex vx cv vy cv cF wbr vx wex vy cB vx cv vy cv cF wbr vx cA rexex
      r19.20si anim2i cA cB cF wf vx cv vy cv cF wbr vx wex vy cB wral vx cv vy
      cv cF wbr vx cA wrex vy cB wral cA cB cF wf vx cv vy cv cF wbr vx wex vx
      cv vy cv cF wbr vx cA wrex vy cB cA cB cF wf vx cv vy cv cF wbr vx wex vx
      cv cA wcel vx cv vy cv cF wbr wa vx wex vx cv vy cv cF wbr vx cA wrex cA
      cB cF wf vx cv vy cv cF wbr vx cv cA wcel vx cv vy cv cF wbr wa vx cA cB
      cF wf vx cv vy cv cF wbr vx cv cA wcel cA cB cF wf cF cA wfn vx cv vy cv
      cF wbr vx cv cA wcel wi cA cB cF ffn cF cA wfn vx cv vy cv cF wbr vx cv
      cA wcel cA vx cv vy cv cF fnbr ex syl ancrd 19.22dv vx cv vy cv cF wbr vx
      cA df-rex syl6ibr r19.20sdv imdistani impbii bitri $.
      $( [3-Jul-2007] $) $( [20-Mar-2007] $)

    $( A relation equivalent to the existence of an onto mapping.  The
       right-hand ` f ` is not necessarily a function. $)
    exfo $p |- ( E. f f : A -onto-> B <->
           E. f ( A. x e. A E! y e. B x f y /\ A. x e. B E. y e. A y f x ) ) $=
      cA cB vf cv wfo vf wex vx cv vy cv vf cv wbr vy cB wreu vx cA wral vy cv
      vx cv vf cv wbr vy cA wrex vx cB wral wa vf wex cA cB vf cv wfo vx cv vy
      cv vf cv wbr vy cB wreu vx cA wral vy cv vx cv vf cv wbr vy cA wrex vx cB
      wral wa vf cA cB vf cv wfo cA cB vf cv wf vy cv vx cv vf cv wbr vy cA
      wrex vx cB wral wa vx cv vy cv vf cv wbr vy cB wreu vx cA wral vy cv vx
      cv vf cv wbr vy cA wrex vx cB wral wa vy vx cA cB vf cv dffo4 cA cB vf cv
      wf vx cv vy cv vf cv wbr vy cB wreu vx cA wral vy cv vx cv vf cv wbr vy
      cA wrex vx cB wral cA cB vf cv wf vf cv cA cB cxp wss vx cv vy cv vf cv
      wbr vy cB wreu vx cA wral vx vy cA cB vf cv dff4 pm3.27bi anim1i sylbi
      19.22i vx cv vy cv vf cv wbr vy cB wreu vx cA wral vy cv vx cv vf cv wbr
      vy cA wrex vx cB wral wa vf wex cA cB vg cv wfo vg wex cA cB vf cv wfo vf
      wex vx cv vy cv vf cv wbr vy cB wreu vx cA wral vy cv vx cv vf cv wbr vy
      cA wrex vx cB wral wa cA cB vg cv wfo vg wex vf vx cv vy cv vf cv wbr vy
      cB wreu vx cA wral vy cv vx cv vf cv wbr vy cA wrex vx cB wral wa cA cB
      vf cv cA cB cxp cin wfo cA cB vg cv wfo vg wex vx cv vy cv vf cv wbr vy
      cB wreu vx cA wral vy cv vx cv vf cv wbr vy cA wrex vx cB wral wa cA cB
      vf cv cA cB cxp cin wf vf cv cA cB cxp cin crn cB wceq wa cA cB vf cv cA
      cB cxp cin wfo vx cv vy cv vf cv wbr vy cB wreu vx cA wral cA cB vf cv cA
      cB cxp cin wf vy cv vx cv vf cv wbr vy cA wrex vx cB wral vf cv cA cB cxp
      cin crn cB wceq vx cv vy cv vf cv wbr vy cB wreu vx cA wral vf cv cA cB
      cxp cin cA cB cxp wss vx cv vy cv vf cv cA cB cxp cin wbr vy cB wreu vx
      cA wral wa cA cB vf cv cA cB cxp cin wf vx cv vy cv vf cv wbr vy cB wreu
      vx cA wral vx cv vy cv vf cv cA cB cxp cin wbr vy cB wreu vx cA wral vf
      cv cA cB cxp cin cA cB cxp wss vx cv vy cv vf cv wbr vy cB wreu vx cv vy
      cv vf cv cA cB cxp cin wbr vy cB wreu vx cA vx cv cA wcel vx cv vy cv vf
      cv wbr vy cB wreu vx cv vy cv vf cv cA cB cxp cin wbr vy cB wreu vx cv cA
      wcel vx cv vy cv vf cv wbr vx cv vy cv vf cv cA cB cxp cin wbr vy cB vx
      cv vy cv cA cB vf cv brinxp reubidva biimpd r19.20i vf cv cA cB cxp inss2
      jctil vx vy cA cB vf cv cA cB cxp cin dff4 sylibr vf cv cA cB cxp cin crn
      cB wceq vy cv vx cv vf cv wbr vy cA wrex vx cB wral vy vx cA cB vf cv
      rninxp biimpri anim12i cA cB vf cv cA cB cxp cin dffo2 sylibr cA cB vg cv
      wfo cA cB vf cv cA cB cxp cin wfo vg vf cv cA cB cxp cin vf cv cA cB cxp
      vf visset inex1 cA cB vg cv vf cv cA cB cxp cin foeq1 cla4ev syl 19.23aiv
      cA cB vg cv wfo cA cB vf cv wfo vg vf cA cB vg cv vf cv foeq1 cbvexv
      sylib impbii $.
      $( [22-Mar-2007] $) $( [20-Mar-2007] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d y z C $.  $d z F $.
    fopab2.1 $e |- F = { <. x , y >. | ( x e. A /\ y = C ) } $.
    $( Functionality of an ordered-pair class abstraction. $)
    fopab2 $p |- ( A. x e. A C e. B <-> F : A --> B ) $=
      cC cB wcel vx cA wral cA cB cF wf cA cB cF wf cF cA wfn cF crn cB wss cC
      cB wcel vx cA wral cA cB cF df-f cC cB wcel vx cA wral vy cv cC wceq vy
      weu vx cA wral cF cA wfn cC cB wcel vy cv cC wceq vy weu vx cA cC cB wcel
      cC cvv wcel vy cv cC wceq vy weu cC cB elisset vy cC eueq sylib r19.20si
      vy cv cC wceq vx vy cA cF fopab2.1 fnopabg sylib cC cB wcel vx cA wral vx
      cv cA wcel vy cv cC wceq wa vx vy copab crn cB cF crn cC cB wcel vx cA
      wral vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab crn wcel vy cv cB
      wcel wi vy wal vx cv cA wcel vy cv cC wceq wa vx vy copab crn cB wss cC
      cB wcel vx cA wral vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab crn
      wcel vy cv cB wcel wi vy cC cB wcel vx cA wral vx cv cA wcel vy cv cC
      wceq wa vx wex vy cv cB wcel vy cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab crn wcel cC cB wcel vx cA wral vx cv cA wcel vy cv cC wceq wa vy cv
      cB wcel vx cC cB wcel vx cA hbra1 vy cv cB wcel vx ax-17 cC cB wcel vx cA
      wral vx cv cA wcel cC cB wcel wi vx cv cA wcel vy cv cC wceq wa vy cv cB
      wcel wi cC cB wcel vx cA ra4 vx cv cA wcel cC cB wcel wi vx cv cA wcel vy
      cv cC wceq vy cv cB wcel cC cB wcel vy cv cC wceq vy cv cB wcel wi vx cv
      cA wcel cC cB vy cv eleq1a imim2i imp3a syl 19.23ad vx cv cA wcel vy cv
      cC wceq wa vx wex vy vx cv cA wcel vy cv cC wceq wa vx vy copab crn vx cv
      cA wcel vy cv cC wceq wa vx vy rnopab abeq2i syl5ib 19.21aiv vy vz vx cv
      cA wcel vy cv cC wceq wa vx vy copab crn cB vy vz vx cv cA wcel vy cv cC
      wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx vy vz hbopab2 hbrn
      vz cv cB wcel vy ax-17 dfss2f sylibr cF vx cv cA wcel vy cv cC wceq wa vx
      vy copab fopab2.1 rneqi syl5ss sylanbrc cA cB cF wf cC cvv wcel vx cA
      wral cC cB wcel vx cA wral cA cB cF wf cF cdm cA wceq cC cvv wcel vx cA
      wral cA cB cF fdm vy cv cC wceq vy wex vx cA wral vx cv cA wcel vy cv cC
      wceq wa vx vy copab cdm cA wceq cC cvv wcel vx cA wral cF cdm cA wceq vy
      cv cC wceq vx vy cA dmopab3 cC cvv wcel vy cv cC wceq vy wex vx cA vy cC
      isset ralbii cF cdm vx cv cA wcel vy cv cC wceq wa vx vy copab cdm cA cF
      vx cv cA wcel vy cv cC wceq wa vx vy copab fopab2.1 dmeqi eqeq1i 3bitr4ri
      sylib cA cB cF wf cC cvv wcel cC cB wcel vx cA cA cB vx cv cA wcel vy cv
      cC wceq wa vx vy copab wf cA cB vx cv cA wcel vy cv cC wceq wa vx vy
      copab wf vx wal cA cB cF wf cA cB cF wf vx wal vx vz cA cB vx cv cA wcel
      vy cv cC wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx vy vz
      hbopab1 vz cv cA wcel vx ax-17 vz cv cB wcel vx ax-17 hbf cF vx cv cA
      wcel vy cv cC wceq wa vx vy copab wceq cA cB cF wf cA cB vx cv cA wcel vy
      cv cC wceq wa vx vy copab wf wb fopab2.1 cA cB cF vx cv cA wcel vy cv cC
      wceq wa vx vy copab feq1 ax-mp cA cB cF wf cA cB vx cv cA wcel vy cv cC
      wceq wa vx vy copab wf vx cF vx cv cA wcel vy cv cC wceq wa vx vy copab
      wceq cA cB cF wf cA cB vx cv cA wcel vy cv cC wceq wa vx vy copab wf wb
      fopab2.1 cA cB cF vx cv cA wcel vy cv cC wceq wa vx vy copab feq1 ax-mp
      albii 3imtr4i cA cB cF wf vx cv cA wcel wa cC cvv wcel cC cB wcel cA cB
      cF wf vx cv cA wcel wa cC cvv wcel wa vx cv cF cfv cB wcel cC cB wcel cA
      cB cF wf vx cv cA wcel wa vx cv cF cfv cB wcel cC cvv wcel cA cB vx cv cF
      ffvelrn adantr vx cv cA wcel cC cvv wcel vx cv cF cfv cB wcel cC cB wcel
      wb cA cB cF wf vx cv cA wcel cC cvv wcel wa vx cv cF cfv cC cB vx cv cA
      wcel cC cvv wcel wa vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv
      cC vx cv cF cfv vx vy cA cC cvv fvopab2 vx cv cF vx cv cA wcel vy cv cC
      wceq wa vx vy copab fopab2.1 fveq1i syl5eq eleq1d adantll mpbid ex
      r19.20da mpd impbii $.
      $( [2-Feb-2004] $) $( [29-Jan-2004] $)

    $( Inclusion of a function in a cross product. $)
    fopabssxp $p |- ( A. x e. A C e. B -> F C_ ( A X. B ) ) $=
      cC cB wcel vx cA wral cA cB cF wf cF cA cB cxp wss vx vy cA cB cC cF
      fopab2.1 fopab2 cA cB cF fssxp sylbi $.
      $( [6-Jun-2007] $) $( [5-Jun-2007] $)

    ${
      rnssopab.2 $e |- C e. _V $.
      $( Range of a function that is expressed as an ordered-pair class
         abstraction. $)
      rnssopab $p |- ( A. x e. A C e. B <-> ran F C_ B ) $=
        cC cB wcel vx cA wral cF crn cB wss cC cB wcel vx cA wral cA cB cF wf
        cF crn cB wss vx vy cA cB cC cF fopab2.1 fopab2 cA cB cF frn sylbi cF
        crn cB wss cC cB wcel vx cA vx vz cF crn cB vx vz cF vx vz cF vx cv cA
        wcel vy cv cC wceq wa vx vy copab fopab2.1 vx cv cA wcel vy cv cC wceq
        wa vx vy vz hbopab1 hbxfr hbrn vz cv cB wcel vx ax-17 hbss cF crn cB
        wss cC cF crn wcel cC cB wcel vx cv cA wcel cF crn cB cC ssel vx cv cA
        wcel vx cv cF cfv cC cF crn vx cv cA wcel vx cv vx cv cA wcel vy cv cC
        wceq wa vx vy copab cfv cC vx cv cF cfv vx cv cA wcel cC cvv wcel vx cv
        vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq rnssopab.2 vx vy
        cA cC cvv fvopab2 mpan2 vx cv cF vx cv cA wcel vy cv cC wceq wa vx vy
        copab fopab2.1 fveq1i syl5eq cF cA wfn vx cv cA wcel vx cv cF cfv cF
        crn wcel vx vy cA cC cF rnssopab.2 fopab2.1 fnopab2 cA vx cv cF
        fnfvelrn mpan eqeltrrd syl5 r19.21ai impbii $.
        $( [5-Jun-2006] $) $( [23-May-2006] $)

      $( Functionality of an ordered-pair class abstraction. $)
      fopab3 $p |- ( ran F C_ B <-> F : A --> B ) $=
        cF crn cB wss cC cB wcel vx cA wral cA cB cF wf vx vy cA cB cC cF
        fopab2.1 rnssopab.2 rnssopab vx vy cA cB cC cF fopab2.1 fopab2 bitr3i
        $.
        $( [12-Jun-2007] $) $( [23-May-2006] $)
    $}

    ${
      fopab.2 $e |- ( x e. A -> C e. B ) $.
      $( Functionality of an ordered-pair class abstraction. $)
      fopab $p |- F : A --> B $=
        cC cB wcel vx cA wral cA cB cF wf cC cB wcel vx cA fopab.2 rgen vx vy
        cA cB cC cF fopab2.1 fopab2 mpbi $.
        $( [21-Mar-2005] $) $( [19-Mar-2005] $)
    $}
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( A function maps to a class to which all values belong. $)
    ffnfv $p |- ( F : A --> B <-> ( F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      cA cB cF wf cF cA wfn vx cv cF cfv cB wcel vx cA wral wa cA cB cF wf cF
      cA wfn vx cv cF cfv cB wcel vx cA wral cA cB cF ffn cA cB cF wf vx cv cF
      cfv cB wcel vx cA cA cB vx cv cF ffvelrn r19.21aiva jca cA cB cF wf cF cA
      wfn cF crn cB wss cF cA wfn vx cv cF cfv cB wcel vx cA wral wa cA cB cF
      df-f cF cA wfn vx cv cF cfv cB wcel vx cA wral pm3.26 cF cA wfn vx cv cF
      cfv cB wcel vx cA wral wa vy cv cB wcel vy cF crn wral cF crn cB wss cF
      cA wfn vx cv cF cfv cB wcel vx cA wral wa vy cv cB wcel vy cF crn cF cA
      wfn vy cv cF crn wcel vx cv cF cfv vy cv wceq vx cA wrex vx cv cF cfv cB
      wcel vx cA wral vy cv cB wcel cF cA wfn vy cv cF crn wcel vx cv cF cfv vy
      cv wceq vx cA wrex vx cA vy cv cF fvelrnb biimpd vx cv cF cfv cB wcel vx
      cA wral vx cv cF cfv vy cv wceq vy cv cB wcel vx cA vx cv cF cfv cB wcel
      vx cA hbra1 vy cv cB wcel vx ax-17 vx cv cF cfv cB wcel vx cA wral vx cv
      cA wcel vx cv cF cfv cB wcel vx cv cF cfv vy cv wceq vy cv cB wcel wi vx
      cv cF cfv cB wcel vx cA ra4 vx cv cF cfv vy cv wceq vx cv cF cfv cB wcel
      vy cv cB wcel vx cv cF cfv vy cv cB eleq1 biimpcd syl6 r19.23ad sylan9
      r19.21aiv vy cF crn cB dfss3 sylibr sylanbrc impbii $.
      $( [19-May-2004] $) $( [3-Dec-2003] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z F $.  $d x y z $.
    ffnfvf.1 $e |- ( y e. A -> A. x y e. A ) $.
    ffnfvf.2 $e |- ( y e. B -> A. x y e. B ) $.
    ffnfvf.3 $e |- ( y e. F -> A. x y e. F ) $.
    $( A function maps to a class to which all values belong.  This version of
       ~ ffnfv uses bound-variable hypotheses instead of distinct variable
       conditions. $)
    ffnfvf $p |-  ( F : A --> B <-> ( F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      cA cB cF wf cF cA wfn vz cv cF cfv cB wcel vz cA wral wa cF cA wfn vx cv
      cF cfv cB wcel vx cA wral wa vz cA cB cF ffnfv vz cv cF cfv cB wcel vz cA
      wral vx cv cF cfv cB wcel vx cA wral cF cA wfn vz cv cF cfv cB wcel vx cv
      cF cfv cB wcel vz vx vy cA vy cv cA wcel vz ax-17 ffnfvf.1 vx vy vy vz cv
      cF cfv cB vx vy vz cv cF ffnfvf.3 vy cv vz cv wcel vx ax-17 hbfv ffnfvf.2
      hbel vx cv cF cfv cB wcel vz ax-17 vz cv vx cv wceq vz cv cF cfv vx cv cF
      cfv cB vz cv vx cv cF fveq2 eleq1d cbvralf anbi2i bitri $.
      $( [29-Sep-2006] $) $( [28-Sep-2006] $)
  $}

  ${
    $d x y A $.  $d x B $.  $d x y F $.
    $( An upper bound for range determined by function values. $)
    fnfvrnss $p |- ( ( F Fn A /\ A. x e. A ( F ` x ) e. B ) -> ran F C_ B ) $=
      cF cA wfn vx cv cF cfv cB wcel vx cA wral wa cA cB cF wf cF crn cB wss vx
      cA cB cF ffnfv cA cB cF frn sylbir $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)

    $( Representation of a mapping in terms of its values. $)
    fopabfv $p |- ( F : A --> B <->
         ( F = { <. x , y >. | ( x e. A /\ y = ( F ` x ) ) }
         /\ A. x e. A ( F ` x ) e. B ) ) $=
      cA cB cF wf cF cA wfn vx cv cF cfv cB wcel vx cA wral wa cF vx cv cA wcel
      vy cv vx cv cF cfv wceq wa vx vy copab wceq vx cv cF cfv cB wcel vx cA
      wral wa vx cA cB cF ffnfv cF cA wfn cF vx cv cA wcel vy cv vx cv cF cfv
      wceq wa vx vy copab wceq vx cv cF cfv cB wcel vx cA wral vx vy cA cF
      dffn5 anbi1i bitri $.
      $( [19-May-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x y A $.  $d u w x z B $.  $d u F $.  $d u x G $.  $d u H $.  $d w S $.
    $d w y z R $.  $d u w y z T $.  $d u v x A $.  $d v T $.
    fopabco.1 $e |- R e. _V $.
    fopabco.2 $e |- S e. _V $.
    fopabco.3 $e |- T e. _V $.
    fopabco.4 $e |- ( z = R -> S = T ) $.
    fopabco.5 $e |- F = { <. x , y >. | ( x e. A /\ y = R ) } $.
    fopabco.6 $e |- G = { <. z , w >. | ( z e. B /\ w = S ) } $.
    fopabco.7 $e |- H = { <. x , v >. | ( x e. A /\ v = T ) } $.
    $( Composition of two functions expressed as ordered-pair class
       abstractions.  Note that ` v ` may be assigned to ` w ` , ` y ` , or
       ` z ` if desired. $)
    fopabco $p |- ( ran F C_ B -> ( G o. F ) = H ) $=
      cF crn cB wss cG cF ccom cH wceq vx cv cG cF ccom cfv vx cv cH cfv wceq
      vx cA wral cF crn cB wss vx cv cG cF ccom cfv vx cv cH cfv wceq vx cA vx
      vu cF crn cB vx vu cF vx vu cF vx cv cA wcel vy cv cR wceq wa vx vy copab
      fopabco.5 vx cv cA wcel vy cv cR wceq wa vx vy vu hbopab1 hbxfr hbrn vu
      cv cB wcel vx ax-17 hbss cF crn cB wss vx cv cA wcel vx cv cG cF ccom cfv
      vx cv cH cfv wceq cF crn cB wss vx cv cA wcel wa vx cv cF cfv cG cfv cT
      vx cv cG cF ccom cfv vx cv cH cfv cF crn cB wss vx cv cA wcel wa vx cv cF
      cfv cG cfv cR cG cfv cT vx cv cA wcel vx cv cF cfv cG cfv cR cG cfv wceq
      cF crn cB wss vx cv cA wcel vx cv cF cfv cR cG vx cv cA wcel vx cv vx cv
      cA wcel vy cv cR wceq wa vx vy copab cfv cR vx cv cF cfv vx cv cA wcel cR
      cvv wcel vx cv vx cv cA wcel vy cv cR wceq wa vx vy copab cfv cR wceq
      fopabco.1 vx vy cA cR cvv fvopab2 mpan2 vx cv cF vx cv cA wcel vy cv cR
      wceq wa vx vy copab fopabco.5 fveq1i syl5eq fveq2d adantl cF crn cB wss
      vx cv cA wcel wa cR cB wcel cR cG cfv cT wceq cF crn cB wss vx cv cA wcel
      wa vx cv cF cfv cB wcel cR cB wcel cA cB cF wf vx cv cA wcel vx cv cF cfv
      cB wcel cF crn cB wss cA cB vx cv cF ffvelrn cF cA wfn cF crn cB wss cA
      cB cF wf vx vy cA cR cF fopabco.1 fopabco.5 fnopab2 cA cB cF wf cF cA wfn
      cF crn cB wss wa cA cB cF df-f biimpri mpan sylan vx cv cA wcel vx cv cF
      cfv cB wcel cR cB wcel wb cF crn cB wss vx cv cA wcel vx cv cF cfv cR cB
      vx cv cA wcel vx cv vx cv cA wcel vy cv cR wceq wa vx vy copab cfv cR vx
      cv cF cfv vx cv cA wcel cR cvv wcel vx cv vx cv cA wcel vy cv cR wceq wa
      vx vy copab cfv cR wceq fopabco.1 vx vy cA cR cvv fvopab2 mpan2 vx cv cF
      vx cv cA wcel vy cv cR wceq wa vx vy copab fopabco.5 fveq1i syl5eq eleq1d
      adantl mpbid vz vw cR cS cT cB cG fopabco.4 fopabco.6 fopabco.3 fvopab4
      syl eqtrd vx cv cA wcel vx cv cG cF ccom cfv vx cv cF cfv cG cfv wceq cF
      crn cB wss vx cv cA wcel vx cv cF cdm wcel vx cv cG cF ccom cfv vx cv cF
      cfv cG cfv wceq cF cdm cA vx cv vx vy cA cR cF fopabco.1 fopabco.5
      dmopab2 eleq2i cG wfun cF wfun vx cv cF cdm wcel vx cv cG cF ccom cfv vx
      cv cF cfv cG cfv wceq cG cB wfn cG wfun vz vw cB cS cG fopabco.2
      fopabco.6 fnopab2 cB cG fnfun ax-mp cF cA wfn cF wfun vx vy cA cR cF
      fopabco.1 fopabco.5 fnopab2 cA cF fnfun ax-mp vx cv cG cF fvco mp3an12
      sylbir adantl vx cv cA wcel vx cv cH cfv cT wceq cF crn cB wss vx cv cA
      wcel cT cvv wcel vx cv cH cfv cT wceq fopabco.3 vx cv cA wcel cT cvv wcel
      wa vx cv vx cv cA wcel vv cv cT wceq wa vx vv copab cfv cT vx cv cH cfv
      vx vv cA cT cvv fvopab2 vx cv cH vx cv cA wcel vv cv cT wceq wa vx vv
      copab fopabco.7 fveq1i syl5eq mpan2 adantl 3eqtr4d ex r19.21ai cG cF ccom
      cA wfn cH cA wfn cG cF ccom cH wceq vx cv cG cF ccom cfv vx cv cH cfv
      wceq vx cA wral wb cF crn cB wss vx vu cA cG cF ccom cH vx vu cG cF vu cv
      cG wcel vx ax-17 vx vu cF vx cv cA wcel vy cv cR wceq wa vx vy copab
      fopabco.5 vx cv cA wcel vy cv cR wceq wa vx vy vu hbopab1 hbxfr hbco vx
      vu cH vx cv cA wcel vv cv cT wceq wa vx vv copab fopabco.7 vx cv cA wcel
      vv cv cT wceq wa vx vv vu hbopab1 hbxfr eqfnfvf2 cG cB wfn cF cA wfn cF
      crn cB wss cG cF ccom cA wfn vz vw cB cS cG fopabco.2 fopabco.6 fnopab2
      vx vy cA cR cF fopabco.1 fopabco.5 fnopab2 cB cA cG cF fnco mp3an12 vx vv
      cA cT cH fopabco.3 fopabco.7 fnopab2 sylancl mpbird $.
      $( [25-Aug-2007] $) $( [21-Aug-2007] $)
  $}

  ${
    $d x y z A $.  $d w x y z B $.  $d w y z C $.  $d w y z D $.  $d w z F $.
    $d w z G $.
    fopabcos.1 $e |- C e. _V $.
    fopabcos.2 $e |- D e. _V $.
    fopabcos.3 $e |- F = { <. x , y >. | ( x e. A /\ y = C ) } $.
    fopabcos.4 $e |- G = { <. x , y >. | ( x e. B /\ y = D ) } $.
    $( MAY BE REVISED - prove from fopabco4? $)
    $( Composition of two functions expressed as ordered-pair class
       abstractions. $)
    fopabcos $p |- ( ran G C_ A -> ( F o. G ) =
                  { <. x , y >. | ( x e. B /\ y = [_ D / x ]_ C ) } ) $=
      cG crn cA wss cF cG ccom vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy
      copab wceq vz cv cF cG ccom cfv vz cv vx cv cB wcel vy cv vx cD cC csb
      wceq wa vx vy copab cfv wceq vz cB wral cG crn cA wss vz cv cF cG ccom
      cfv vz cv vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab cfv wceq
      vz cB cG crn cA wss vz cv cB wcel wa vx vz cv cD csb cF cfv vx vx vz cv
      cD csb cC csb vz cv cF cG ccom cfv vz cv vx cv cB wcel vy cv vx cD cC csb
      wceq wa vx vy copab cfv cG crn cA wss vz cv cB wcel wa vx vz cv cD csb cA
      wcel vx vz cv cD csb cF cfv vx vx vz cv cD csb cC csb wceq cG crn cA wss
      vz cv cB wcel wa vz cv cG cfv vx vz cv cD csb cA vz cv cB wcel vz cv cG
      cfv vx vz cv cD csb wceq cG crn cA wss vx vy vz cv cD cB cG vz visset
      fopabcos.2 fopabcos.4 fvopab4s adantl cG crn cA wss vz cv cB wcel wa vz
      cv cG cfv cG crn wcel vz cv cG cfv cA wcel vz cv cB wcel vz cv cG cfv cG
      crn wcel cG crn cA wss cG cB wfn vz cv cB wcel vz cv cG cfv cG crn wcel
      vx vy cB cD cG fopabcos.2 fopabcos.4 fnopab2 cB vz cv cG fnfvelrn mpan
      adantl cG crn cA wss vz cv cG cfv cG crn wcel vz cv cG cfv cA wcel wi vz
      cv cB wcel cG crn cA vz cv cG cfv ssel adantr mpd eqeltrrd vx vy vw vx vz
      cv cD csb cC cA cF vx vz cv cD vz visset fopabcos.2 csbex fopabcos.1 vx
      vw vz cv cD vz visset vw cv vz cv wcel vx ax-17 hbcsb1 fopabcos.3
      fvopab4sf syl vz cv cB wcel vz cv cF cG ccom cfv vx vz cv cD csb cF cfv
      wceq cG crn cA wss vz cv cB wcel vz cv cF cG ccom cfv vz cv cG cfv cF cfv
      vx vz cv cD csb cF cfv vz cv cB wcel vz cv cG cdm wcel vz cv cF cG ccom
      cfv vz cv cG cfv cF cfv wceq cG cdm cB vz cv vx vy cB cD cG fopabcos.2
      fopabcos.4 dmopab2 eleq2i cF wfun cG wfun vz cv cG cdm wcel vz cv cF cG
      ccom cfv vz cv cG cfv cF cfv wceq cF cA wfn cF wfun vx vy cA cC cF
      fopabcos.1 fopabcos.3 fnopab2 cA cF fnfun ax-mp cG cB wfn cG wfun vx vy
      cB cD cG fopabcos.2 fopabcos.4 fnopab2 cB cG fnfun ax-mp vz cv cF cG fvco
      mp3an12 sylbir vz cv cB wcel vz cv cG cfv vx vz cv cD csb cF vx vy vz cv
      cD cB cG vz visset fopabcos.2 fopabcos.4 fvopab4s fveq2d eqtrd adantl vz
      cv cB wcel vz cv vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab cfv
      vx vx vz cv cD csb cC csb wceq cG crn cA wss vz cv cB wcel vz cv vx cv cB
      wcel vy cv vx cD cC csb wceq wa vx vy copab cfv vx vz cv vx cD cC csb csb
      vx vx vz cv cD csb cC csb vx vy vz cv vx cD cC csb cB vx cv cB wcel vy cv
      vx cD cC csb wceq wa vx vy copab vz visset vx cD cC fopabcos.2 fopabcos.1
      csbex vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab eqid fvopab4s
      vz cv cvv wcel cD cvv wcel vx wal vx vz cv vx cD cC csb csb vx vx vz cv
      cD csb cC csb wceq vz visset cD cvv wcel vx fopabcos.2 ax-gen vx vz cv cD
      cC cvv cvv csbnest1g mp2an syl6eq adantl 3eqtr4d r19.21aiva cF cG ccom cB
      wfn vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab cB wfn cF cG
      ccom vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab wceq vz cv cF
      cG ccom cfv vz cv vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab
      cfv wceq vz cB wral wb cG crn cA wss vz vw cB cF cG ccom vx cv cB wcel vy
      cv vx cD cC csb wceq wa vx vy copab vw cv cF cG ccom wcel vz ax-17 vw cv
      vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab wcel vz ax-17
      eqfnfvf2 cF cA wfn cG cB wfn cG crn cA wss cF cG ccom cB wfn vx vy cA cC
      cF fopabcos.1 fopabcos.3 fnopab2 vx vy cB cD cG fopabcos.2 fopabcos.4
      fnopab2 cA cB cF cG fnco mp3an12 vx vy cB vx cD cC csb vx cv cB wcel vy
      cv vx cD cC csb wceq wa vx vy copab vx cD cC fopabcos.2 fopabcos.1 csbex
      vx cv cB wcel vy cv vx cD cC csb wceq wa vx vy copab eqid fnopab2 sylancl
      mpbird $.
      $( [2-Jun-2006] $) $( [22-May-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    fsn.1 $e |- A e. _V $.
    fsn.2 $e |- B e. _V $.
    $( A function maps a singleton to a singleton iff it is the singleton of a
       ordered pair. $)
    fsn $p |- ( F : { A } --> { B } <-> F = { <. A , B >. } ) $=
      cA csn cB csn cF wf cF cA cB cop csn wceq cA csn cB csn cF wf cF cA cB
      cop csn wceq vx cv vy cv cop cF wcel vx cv vy cv cop cA cB cop csn wcel
      wb vy wal vx wal cA csn cB csn cF wf vx cv vy cv cop cF wcel vx cv vy cv
      cop cA cB cop csn wcel wb vx vy cA csn cB csn cF wf vx cv vy cv cop cF
      wcel vx cv cA wceq vy cv cB wceq wa vx cv vy cv cop cA cB cop csn wcel cA
      csn cB csn cF wf vx cv vy cv cop cF wcel vx cv cA wceq vy cv cB wceq wa
      cA csn cB csn cF wf vx cv vy cv cop cF wcel vx cv cA wceq vy cv cB wceq
      wa cA csn cB csn cF wf vx cv vy cv cop cF wcel wa vx cv cA csn wcel vy cv
      cB csn wcel wa vx cv cA wceq vy cv cB wceq wa cA csn cB csn vx cv vy cv
      cF vy visset opelf vx cv cA csn wcel vx cv cA wceq vy cv cB csn wcel vy
      cv cB wceq vx cA elsn vy cB elsn anbi12i sylib ex vx cv cA wceq vy cv cB
      wceq wa vx cv vy cv cop cF wcel cA cB cop cF wcel cA csn cB csn cF wf vx
      cv cA wceq vy cv cB wceq wa vx cv vy cv cop cA cB cop cF vx cv vy cv cA
      cB opeq12 eleq1d cA csn cB csn cF wf cA vy cv cop cF wcel vy cB csn wreu
      cA cB cop cF wcel cA csn cB csn cF wf cA cA csn wcel cA vy cv cop cF wcel
      vy cB csn wreu cA fsn.1 snid vy cA csn cB csn cA cF feu mpan2 cA cB cop
      cF wcel cA cB cop cF wcel vy cv cB wceq vy weu wa cA cB cop cF wcel vy cv
      cB wceq wa vy weu cA vy cv cop cF wcel vy cB csn wreu vy cv cB wceq vy
      weu cA cB cop cF wcel vy cB fsn.2 eueq1 biantru cA cB cop cF wcel vy cv
      cB wceq vy euanv cA cB cop cF wcel vy cv cB wceq wa vy weu vy cv cB csn
      wcel cA vy cv cop cF wcel wa vy weu cA vy cv cop cF wcel vy cB csn wreu
      cA cB cop cF wcel vy cv cB wceq wa vy cv cB csn wcel cA vy cv cop cF wcel
      wa vy vy cv cB wceq cA vy cv cop cF wcel wa vy cv cB wceq cA cB cop cF
      wcel wa vy cv cB csn wcel cA vy cv cop cF wcel wa cA cB cop cF wcel vy cv
      cB wceq wa vy cv cB wceq cA vy cv cop cF wcel cA cB cop cF wcel vy cv cB
      wceq cA vy cv cop cA cB cop cF vy cv cB cA opeq2 eleq1d pm5.32i vy cv cB
      csn wcel vy cv cB wceq cA vy cv cop cF wcel vy cB elsn anbi1i cA cB cop
      cF wcel vy cv cB wceq ancom 3bitr4ri eubii cA vy cv cop cF wcel vy cB csn
      df-reu bitr4i 3bitr2i sylibr syl5cbir impbid vx cv vy cv cop cA cB cop
      csn wcel vx cv vy cv cop cA cB cop wceq vx cv cA wceq vy cv cB wceq wa vx
      cv vy cv cop cA cB cop vx cv vy cv opex elsnc vx cv vy cv cA cB vx visset
      vy visset fsn.2 opth bitr2i syl6bb 19.21aivv cF wrel cA cB cop csn wrel
      cF cA cB cop csn wceq vx cv vy cv cop cF wcel vx cv vy cv cop cA cB cop
      csn wcel wb vy wal vx wal wb cA csn cB csn cF wf vx vy cF cA cB cop csn
      eqrel cA csn cB csn cF frel cA cB fsn.1 relsn sylancl mpbird cF cA cB cop
      csn wceq cA csn cB csn cF wf1o cA csn cB csn cF wf cF cA cB cop csn wceq
      cA csn cB csn cF wf1o cA csn cB csn cA cB cop csn wf1o cA cB fsn.1 fsn.2
      f1osn cA csn cB csn cF cA cB cop csn f1oeq1 mpbiri cA csn cB csn cF f1of
      syl impbii $.
      $( [13-Dec-2003] $) $( [10-Dec-2003] $)

    $( The cross product of two singletons. $)
    xpsn $p |- ( { A } X. { B } ) = { <. A , B >. } $=
      cA csn cB csn cA csn cB csn cxp wf cA csn cB csn cxp cA cB cop csn wceq
      cA csn cB fsn.2 fconst cA cB cA csn cB csn cxp fsn.1 fsn.2 fsn mpbi $.
      $( [4-Nov-2006] $) $( [4-Nov-2006] $)
  $}

  ${
    fsn2.1 $e |- A e. _V $.
    $( A function that maps a singleton to a class is the singleton of an
       ordered pair. $)
    fsn2 $p |- ( F : { A } --> B <->
               ( ( F ` A ) e. B /\ F = { <. A , ( F ` A ) >. } ) ) $=
      cA csn cB cF wf cA cF cfv cB wcel cA csn cA cF cfv csn cF wf wa cA cF cfv
      cB wcel cF cA cA cF cfv cop csn wceq wa cA csn cB cF wf cA cF cfv cB wcel
      cA csn cA cF cfv csn cF wf wa cA csn cB cF wf cA cF cfv cB wcel cA csn cA
      cF cfv csn cF wf cA csn cB cF wf cA cA csn wcel cA cF cfv cB wcel cA
      fsn2.1 snid cA csn cB cA cF ffvelrn mpan2 cA csn cB cF wf cF cA csn wfn
      cA csn cA cF cfv csn cF wf cA csn cB cF ffn cF cA csn wfn cA csn cF crn
      cF wf cA csn cA cF cfv csn cF wf cF cA csn wfn cA csn cF crn cF wf cA csn
      cF dffn3 biimpi cF cA csn wfn cF crn cA cF cfv csn wceq cA csn cF crn cF
      wf cA csn cA cF cfv csn cF wf wb cF cA csn wfn cF crn cF cA csn cima cA
      cF cfv csn cF cA csn wfn cF cF cdm cima cF cA csn cima cF crn cF cA csn
      wfn cF cdm cA csn cF cA csn cF fndm imaeq2d cF imadmrn syl5eqr cF cA csn
      wfn cA cA csn wcel cA cF cfv csn cF cA csn cima wceq cA fsn2.1 snid cA
      csn cA cF fnsnfv mpan2 eqtr4d cF crn cA cF cfv csn cA csn cF feq3 syl
      mpbid syl jca cA cF cfv csn cB wss cA csn cA cF cfv csn cF wf cA csn cB
      cF wf cA cF cfv cB wcel cA csn cA cF cfv csn cF wf cA cF cfv csn cB wss
      cA csn cB cF wf cA csn cA cF cfv csn cB cF fss ancoms cA cF cfv cB snssi
      sylan impbii cA csn cA cF cfv csn cF wf cF cA cA cF cfv cop csn wceq cA
      cF cfv cB wcel cA cA cF cfv cF fsn2.1 cA cF fvex fsn anbi2i bitri $.
      $( [20-May-2004] $) $( [19-May-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( A function restricted to a singleton. $)
    fnressn $p |- ( ( F Fn A /\ B e. A ) ->
                  ( F |` { B } ) = { <. B , ( F ` B ) >. } ) $=
      cB cA wcel cF cA wfn cF cB csn cres cB cB cF cfv cop csn wceq cF cA wfn
      cF vx cv csn cres vx cv vx cv cF cfv cop csn wceq wi cF cA wfn cF cB csn
      cres cB cB cF cfv cop csn wceq wi vx cB cA vx cv cB wceq cF vx cv csn
      cres vx cv vx cv cF cfv cop csn wceq cF cB csn cres cB cB cF cfv cop csn
      wceq cF cA wfn vx cv cB wceq cF vx cv csn cres cF cB csn cres vx cv vx cv
      cF cfv cop csn cB cB cF cfv cop csn vx cv cB wceq vx cv csn cB csn wceq
      cF vx cv csn cres cF cB csn cres wceq vx cv cB sneq vx cv csn cB csn cF
      reseq2 syl vx cv cB wceq vx cv vx cv cF cfv cop cB cB cF cfv cop vx cv cB
      wceq vx cv cF cfv cB cF cfv wceq vx cv vx cv cF cfv cop cB cB cF cfv cop
      wceq vx cv cB cF fveq2 vx cv vx cv cF cfv cB cB cF cfv opeq12 mpdan sneqd
      eqeq12d imbi2d cF cA wfn vx cv cA wcel cF vx cv csn cres vx cv vx cv cF
      cfv cop csn wceq cF cA wfn vx cv cA wcel wa cF vx cv csn cres vx cv csn
      wfn cF vx cv csn cres vx cv vx cv cF cfv cop csn wceq cF cA wfn vx cv csn
      cA wss cF vx cv csn cres vx cv csn wfn vx cv cA wcel cA vx cv csn cF
      fnssres vx cv cA vx visset snss sylan2b cF vx cv csn cres vx cv csn wfn
      vx cv csn cvv cF vx cv csn cres wf vx cv cF vx cv csn cres cfv cvv wcel
      cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop csn wceq wa cF vx
      cv csn cres vx cv vx cv cF cfv cop csn wceq vx cv csn cF vx cv csn cres
      dffn2 vx cv cvv cF vx cv csn cres vx visset fsn2 vx cv cF vx cv csn cres
      cfv cvv wcel cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop csn
      wceq wa cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop csn wceq
      cF vx cv csn cres vx cv vx cv cF cfv cop csn wceq vx cv cF vx cv csn cres
      cfv cvv wcel cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop csn
      wceq vx cv cF vx cv csn cres fvex biantrur vx cv vx cv cF vx cv csn cres
      cfv cop csn vx cv vx cv cF cfv cop csn cF vx cv csn cres vx cv vx cv cF
      vx cv csn cres cfv cop vx cv vx cv cF cfv cop vx cv cF vx cv csn cres cfv
      vx cv cF cfv vx cv vx cv vx cv csn wcel vx cv cF vx cv csn cres cfv vx cv
      cF cfv wceq vx cv vx visset snid vx cv vx cv csn cF fvres ax-mp opeq2i
      sneqi eqeq2i bitr3i 3bitri sylib expcom vtoclga impcom $.
      $( [13-Nov-2004] $) $( [9-Oct-2004] $)

    $( The value of a function restricted to a singleton. $)
    fressnfv $p |- ( ( F Fn A /\ B e. A ) ->
                 ( ( F |` { B } ) : { B } --> C <-> ( F ` B ) e. C ) ) $=
      cB cA wcel cF cA wfn cB csn cC cF cB csn cres wf cB cF cfv cC wcel wb cF
      cA wfn vx cv csn cC cF vx cv csn cres wf vx cv cF cfv cC wcel wb wi cF cA
      wfn cB csn cC cF cB csn cres wf cB cF cfv cC wcel wb wi vx cB cA vx cv cB
      wceq vx cv csn cC cF vx cv csn cres wf vx cv cF cfv cC wcel wb cB csn cC
      cF cB csn cres wf cB cF cfv cC wcel wb cF cA wfn vx cv cB wceq vx cv csn
      cC cF vx cv csn cres wf cB csn cC cF cB csn cres wf vx cv cF cfv cC wcel
      cB cF cfv cC wcel vx cv cB wceq vx cv csn cB csn wceq vx cv csn cC cF vx
      cv csn cres wf cB csn cC cF cB csn cres wf wb vx cv cB sneq vx cv csn cB
      csn wceq vx cv csn cC cF vx cv csn cres wf vx cv csn cC cF cB csn cres wf
      cB csn cC cF cB csn cres wf vx cv csn cB csn wceq vx cv csn cC cF vx cv
      csn cres cF cB csn cres vx cv csn cB csn cF reseq2 feq1d vx cv csn cB csn
      cC cF cB csn cres feq2 bitrd syl vx cv cB wceq vx cv cF cfv cB cF cfv cC
      vx cv cB cF fveq2 eleq1d bibi12d imbi2d cF cA wfn vx cv cA wcel vx cv csn
      cC cF vx cv csn cres wf vx cv cF cfv cC wcel wb cF cA wfn vx cv cA wcel
      wa cF vx cv csn cres vx cv vx cv cF cfv cop csn wceq vx cv csn cC cF vx
      cv csn cres wf vx cv cF cfv cC wcel wb cA vx cv cF fnressn cF vx cv csn
      cres vx cv vx cv cF cfv cop csn wceq cF vx cv csn cres vx cv vx cv cF vx
      cv csn cres cfv cop csn wceq vx cv csn cC cF vx cv csn cres wf vx cv cF
      cfv cC wcel wb vx cv vx cv cF vx cv csn cres cfv cop csn vx cv vx cv cF
      cfv cop csn cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop vx cv
      vx cv cF cfv cop vx cv cF vx cv csn cres cfv vx cv cF cfv vx cv vx cv vx
      cv csn wcel vx cv cF vx cv csn cres cfv vx cv cF cfv wceq vx cv vx visset
      snid vx cv vx cv csn cF fvres ax-mp opeq2i sneqi eqeq2i cF vx cv csn cres
      vx cv vx cv cF vx cv csn cres cfv cop csn wceq vx cv cF vx cv csn cres
      cfv cC wcel cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop csn
      wceq wa vx cv cF cfv cC wcel vx cv csn cC cF vx cv csn cres wf cF vx cv
      csn cres vx cv vx cv cF vx cv csn cres cfv cop csn wceq vx cv cF vx cv
      csn cres cfv cC wcel vx cv cF vx cv csn cres cfv cC wcel cF vx cv csn
      cres vx cv vx cv cF vx cv csn cres cfv cop csn wceq wa vx cv cF cfv cC
      wcel cF vx cv csn cres vx cv vx cv cF vx cv csn cres cfv cop csn wceq vx
      cv cF vx cv csn cres cfv cC wcel iba vx cv cF vx cv csn cres cfv vx cv cF
      cfv cC vx cv vx cv csn wcel vx cv cF vx cv csn cres cfv vx cv cF cfv wceq
      vx cv vx visset snid vx cv vx cv csn cF fvres ax-mp eleq1i syl5rbbr vx cv
      cC cF vx cv csn cres vx visset fsn2 syl5bb sylbir syl expcom vtoclga
      impcom $.
      $( [16-Nov-2004] $) $( [9-Oct-2004] $)
  $}

  $( The value of a constant function. $)
  fvconst $p |- ( ( F : A --> { B } /\ C e. A ) -> ( F ` C ) = B ) $=
    cA cB csn cF wf cC cA wcel wa cC cF cfv cB csn wcel cC cF cfv cB wceq cA cB
    csn cC cF ffvelrn cC cF cfv cB elsni syl $.
    $( [30-May-1999] $)

  ${
    $d x y z A $.  $d x y z B $.
    fopabsn.1 $e |- A e. _V $.
    fopabsn.2 $e |- B e. _V $.
    $( The singleton of an ordered pair expressed as an ordered pair class
       abstraction. $)
    fopabsn $p |- { <. A , B >. } =
                  { <. x , y >. | ( x e. { A } /\ y = B ) } $=
      cA cB cop csn vx cv cA csn wcel vy cv cB wceq wa vx vy copab wceq vx cv
      cA cB cop csn cfv vx cv vx cv cA csn wcel vy cv cB wceq wa vx vy copab
      cfv wceq vx cA csn wral vx cv cA cB cop csn cfv vx cv vx cv cA csn wcel
      vy cv cB wceq wa vx vy copab cfv wceq vx cA csn vx cv cA csn wcel vx cv
      cA wceq vx cv cA cB cop csn cfv vx cv vx cv cA csn wcel vy cv cB wceq wa
      vx vy copab cfv wceq vx cA elsn vx cv cA wceq cA cA cB cop csn cfv cB vx
      cv cA cB cop csn cfv vx cv vx cv cA csn wcel vy cv cB wceq wa vx vy copab
      cfv cA cB fopabsn.1 fopabsn.2 fvsn vx cv cA cA cB cop csn fveq2 vx cv cA
      wceq vx cv cA csn wcel vx cv vx cv cA csn wcel vy cv cB wceq wa vx vy
      copab cfv cB wceq vx cA elsn vx cv cA csn wcel cB cvv wcel vx cv vx cv cA
      csn wcel vy cv cB wceq wa vx vy copab cfv cB wceq fopabsn.2 vx vy cA csn
      cB cvv fvopab2 mpan2 sylbir 3eqtr4a sylbi rgen cA cB cop csn cA csn wfn
      vx cv cA csn wcel vy cv cB wceq wa vx vy copab cA csn wfn cA cB cop csn
      vx cv cA csn wcel vy cv cB wceq wa vx vy copab wceq vx cv cA cB cop csn
      cfv vx cv vx cv cA csn wcel vy cv cB wceq wa vx vy copab cfv wceq vx cA
      csn wral wb cA csn cB csn cA cB cop csn wf cA cB cop csn cA csn wfn cA
      csn cB csn cA cB cop csn wf1o cA csn cB csn cA cB cop csn wf cA cB
      fopabsn.1 fopabsn.2 f1osn cA csn cB csn cA cB cop csn f1of ax-mp cA csn
      cB csn cA cB cop csn ffn ax-mp vx vy cA csn cB vx cv cA csn wcel vy cv cB
      wceq wa vx vy copab fopabsn.2 vx cv cA csn wcel vy cv cB wceq wa vx vy
      copab eqid fnopab2 vx vz cA csn cA cB cop csn vx cv cA csn wcel vy cv cB
      wceq wa vx vy copab vz cv cA cB cop csn wcel vx ax-17 vx cv cA csn wcel
      vy cv cB wceq wa vx vy vz hbopab1 eqfnfvf2 mp2an mpbir $.
      $( [1-Aug-2006] $) $( [6-Jun-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    fopabap.0a $e |- A e. _V $.
    fopabap.0b $e |- B e. _V $.
    fopabap.1 $e |- ( R u. { A } ) = S $.
    fopabap.2 $e |- ( x = A -> C = B ) $.
    $( Append an additional value to a function. $)
    fopabap $p |- ( { <. x , y >. | ( x e. R /\ y = C ) } u. { <. A , B >. } )
                  = { <. x , y >. | ( x e. S /\ y = C ) } $=
      vx cv cR wcel vy cv cC wceq wa vx vy copab cA cB cop csn cun vx cv cR
      wcel vy cv cC wceq wa vx vy copab vx cv cA csn wcel vy cv cB wceq wa vx
      vy copab cun vx cv cR wcel vy cv cC wceq wa vx cv cA csn wcel vy cv cB
      wceq wa wo vx vy copab vx cv cS wcel vy cv cC wceq wa vx vy copab cA cB
      cop csn vx cv cA csn wcel vy cv cB wceq wa vx vy copab vx cv cR wcel vy
      cv cC wceq wa vx vy copab vx vy cA cB fopabap.0a fopabap.0b fopabsn
      uneq2i vx cv cR wcel vy cv cC wceq wa vx cv cA csn wcel vy cv cB wceq wa
      vx vy unopab vx cv cR wcel vy cv cC wceq wa vx cv cA csn wcel vy cv cB
      wceq wa wo vx cv cS wcel vy cv cC wceq wa vx vy vx cv cS wcel vy cv cC
      wceq wa vx cv cR wcel vx cv cA csn wcel wo vy cv cC wceq wa vx cv cR wcel
      vy cv cC wceq wa vx cv cA csn wcel vy cv cC wceq wa wo vx cv cR wcel vy
      cv cC wceq wa vx cv cA csn wcel vy cv cB wceq wa wo vx cv cS wcel vx cv
      cR wcel vx cv cA csn wcel wo vy cv cC wceq vx cv cS wcel vx cv cR cA csn
      cun wcel vx cv cR wcel vx cv cA csn wcel wo cR cA csn cun cS vx cv
      fopabap.1 eleq2i vx cv cR cA csn elun bitr3i anbi1i vx cv cR wcel vx cv
      cA csn wcel vy cv cC wceq andir vx cv cA csn wcel vy cv cC wceq wa vx cv
      cA csn wcel vy cv cB wceq wa vx cv cR wcel vy cv cC wceq wa vx cv cA csn
      wcel vy cv cC wceq vy cv cB wceq vx cv cA csn wcel cC cB vy cv vx cv cA
      csn wcel vx cv cA wceq cC cB wceq vx cA elsn fopabap.2 sylbi eqeq2d
      pm5.32i orbi2i 3bitrri opabbii 3eqtri $.
      $( [15-Jun-2007] $) $( [6-Jun-2006] $)
  $}

  ${
    $d x A $.
    $( The value of the identity function. $)
    fvi $p |- ( A e. B -> ( _I ` A ) = A ) $=
      vx cv cid cfv vx cv wceq cA cid cfv cA wceq vx cA cB vx cv cA wceq vx cv
      cid cfv cA cid cfv vx cv cA vx cv cA cid fveq2 vx cv cA wceq id eqeq12d
      cid cvv wfn vx cv cvv wcel vx cv cid cfv vx cv wceq cid cvv wfn cid wfun
      cid cdm cvv wceq cid cvv df-fn funi dmi mpbir2an vx visset cid cvv wfn vx
      cv cvv wcel wa vx cv cid cfv vx cv wceq vx cv vx cv cop cid wcel vx cv vx
      cv cid wbr vx cv vx cv cop cid wcel vx cv cvv wcel vx cv vx cv cid wbr vx
      visset vx cv cvv ididg ax-mp vx cv vx cv cid df-br mpbi cvv vx cv vx cv
      cid vx visset fnopfvb mpbiri mp2an vtoclg $.
      $( [2-May-2004] $) $( [1-May-2004] $)
  $}

  $( The value of a restricted identity function. $)
  fvresi $p |- ( B e. A -> ( ( _I |` A ) ` B ) = B ) $=
    cB cA wcel cB cid cA cres cfv cB cid cfv cB cB cA cid fvres cB cA fvi eqtrd
    $.
    $( [20-May-2004] $) $( [19-May-2004] $)

  $( The value of a constant function. $)
  fvconst2g $p |- ( ( B e. D /\ C e. A ) -> ( ( A X. { B } ) ` C ) = B ) $=
    cA cB csn cA cB csn cxp wf cC cA wcel cC cA cB csn cxp cfv cB wceq cB cD
    wcel cA cB cC cA cB csn cxp fvconst cA cB cD fconstg sylan $.
    $( [30-Aug-2005] $) $( [20-Aug-2005] $)

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( A constant function expressed as a cross product. $)
    fconst2g $p |- ( B e. C -> ( F : A --> { B } <-> F = ( A X. { B } ) ) ) $=
      cB cC wcel cA cB csn cF wf cF cA cB csn cxp wceq cA cB csn cF wf cB cC
      wcel cF cA cB csn cxp wceq cA cB csn cF wf cB cC wcel wa cF cA cB csn cxp
      wceq vx cv cF cfv vx cv cA cB csn cxp cfv wceq vx cA wral cA cB csn cF wf
      cB cC wcel wa vx cv cF cfv vx cv cA cB csn cxp cfv wceq vx cA cA cB csn
      cF wf cB cC wcel wa vx cv cA wcel wa vx cv cF cfv cB vx cv cA cB csn cxp
      cfv cA cB csn cF wf vx cv cA wcel vx cv cF cfv cB wceq cB cC wcel cA cB
      vx cv cF fvconst adantlr cB cC wcel vx cv cA wcel vx cv cA cB csn cxp cfv
      cB wceq cA cB csn cF wf cA cB vx cv cC fvconst2g adantll eqtr4d
      r19.21aiva cF cA wfn cA cB csn cxp cA wfn cF cA cB csn cxp wceq vx cv cF
      cfv vx cv cA cB csn cxp cfv wceq vx cA wral wb cA cB csn cF wf cB cC wcel
      vx cA cF cA cB csn cxp eqfnfv2 cA cB csn cF ffn cB cC wcel cA cB csn cA
      cB csn cxp wf cA cB csn cxp cA wfn cA cB cC fconstg cA cB csn cA cB csn
      cxp ffn syl syl2an mpbird expcom cF cA cB csn cxp wceq cA cB csn cF wf cA
      cB csn cA cB csn cxp wf cB cC wcel cA cB csn cF cA cB csn cxp feq1 cA cB
      cC fconstg syl5cbir impbid $.
      $( [28-Nov-2007] $) $( [27-Nov-2007] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    fvconst2.1 $e |- B e. _V $.
    $( The value of a constant function. $)
    fvconst2 $p |- ( C e. A -> ( ( A X. { B } ) ` C ) = B ) $=
      cB cvv wcel cC cA wcel cC cA cB csn cxp cfv cB wceq fvconst2.1 cA cB cC
      cvv fvconst2g mpan $.
      $( [18-Apr-2005] $) $( [16-Apr-2005] $)

    $( A constant function expressed as a cross product. $)
    fconst2 $p |- ( F : A --> { B } <-> F = ( A X. { B } ) ) $=
      cB cvv wcel cA cB csn cF wf cF cA cB csn cxp wceq wb fvconst2.1 cA cB cvv
      cF fconst2g ax-mp $.
      $( [20-Aug-1999] $)
  $}

  $( Two ways to express that a function is constant. $)
  fconst5 $p |- ( ( F Fn A /\ A =/= (/) ) -> ( F = ( A X. { B } ) <->
                 ran F = { B } ) ) $=
    cF cA wfn cA c0 wne wa cF cA cB csn cxp wceq cF crn cB csn wceq cA c0 wne
    cF cA cB csn cxp wceq cF crn cB csn wceq wi cF cA wfn cA c0 wne cF crn cA
    cB csn cxp crn wceq cF crn cB csn wceq cF cA cB csn cxp wceq cA c0 wne cA
    cB csn cxp crn cB csn cF crn cA cB csn rnxp eqeq2d cF cA cB csn cxp rneq
    syl5bi adantl cB cvv wcel cF cA wfn cA c0 wne wa cF crn cB csn wceq cF cA
    cB csn cxp wceq wi wi cB cvv wcel cF cA wfn cF crn cB csn wceq cF cA cB csn
    cxp wceq wi cA c0 wne cB cvv wcel cF cA wfn cF crn cB csn wceq cF cA cB csn
    cxp wceq cB cvv wcel cA cB csn cF wf cF cA cB csn cxp wceq cF cA wfn cF crn
    cB csn wceq wa cA cB cvv cF fconst2g cF cA wfn cF crn cB csn wceq wa cA cB
    csn cF wfo cA cB csn cF wf cA cB csn cF df-fo cA cB csn cF fof sylbir
    syl5bi exp3a adantrd cB cvv wcel wn cF cA wfn cF crn cB csn wceq cF cA cB
    csn cxp wceq wi cA c0 wne cB cvv wcel wn cF wrel cF crn cB csn wceq cF cA
    cB csn cxp wceq wi cF cA wfn cB cvv wcel wn cB csn c0 wceq cF wrel cF crn
    cB csn wceq cF cA cB csn cxp wceq wi wi cB snprc cB csn c0 wceq cF wrel cF
    crn cB csn wceq cF cA cB csn cxp wceq wi cB csn c0 wceq cF wrel wa cF crn
    c0 wceq cF c0 wceq cF crn cB csn wceq cF cA cB csn cxp wceq cF wrel cF crn
    c0 wceq cF c0 wceq wi cB csn c0 wceq cF wrel cF c0 wceq cF crn c0 wceq cF
    relrn0 biimprd adantl cB csn c0 wceq cF crn cB csn wceq cF crn c0 wceq wb
    cF wrel cB csn c0 cF crn eqeq2 adantr cB csn c0 wceq cF cA cB csn cxp wceq
    cF c0 wceq wb cF wrel cB csn c0 wceq cA cB csn cxp c0 cF cB csn c0 wceq cA
    cB csn cxp cA c0 cxp c0 cB csn c0 cA xpeq2 cA xp0 syl6eq eqeq2d adantr
    3imtr4d ex sylbi cA cF fnrel syl5 adantrd pm2.61i impbid $.
    $( [25-Dec-2007] $) $( [27-Nov-2007] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.
    $( A constant function expressed in terms of its functionality, domain, and
       value.  See also ~ fconst2 . $)
    fconstfv $p |- ( F : A --> { B } <->
                   ( F Fn A /\ A. x e. A ( F ` x ) = B ) ) $=
      cA cB csn cF wf cF cA wfn vx cv cF cfv cB wceq vx cA wral wa cA cB csn cF
      wf cF cA wfn vx cv cF cfv cB wceq vx cA wral cA cB csn cF ffn cA cB csn
      cF wf vx cv cF cfv cB wceq vx cA cA cB vx cv cF fvconst r19.21aiva jca cF
      cA wfn vx cv cF cfv cB wceq vx cA wral wa cA cB csn cF wf wi cA c0 cA c0
      wceq cF cA wfn cA cB csn cF wf vx cv cF cfv cB wceq vx cA wral cA c0 wceq
      cF cA wfn c0 cB csn cF wf cA cB csn cF wf cA c0 wceq cF cA wfn cF c0 wceq
      c0 cB csn cF wf cA c0 wceq cF cA wfn cF c0 wfn cF c0 wceq cA c0 cF fneq2
      cF fn0 syl6bb cF c0 wceq c0 cB csn cF wf c0 cB csn c0 wf cB csn f0 c0 cB
      csn cF c0 feq1 mpbiri syl6bi cA c0 cB csn cF feq2 sylibrd adantrd cA c0
      wne cF cA wfn vx cv cF cfv cB wceq vx cA wral wa cF cA wfn cF crn cB csn
      wceq wa cA cB csn cF wf cA c0 wne cF cA wfn vx cv cF cfv cB wceq vx cA
      wral cF crn cB csn wceq cA c0 wne cF cA wfn vx cv cF cfv cB wceq vx cA
      wral cF crn cB csn wceq cA c0 wne vx cv cF cfv cB wceq vx cA wral cF cA
      wfn cF crn cB csn wceq cA c0 wne vx cv cF cfv cB wceq vx cA wral wa cF cA
      wfn wa vy cF crn cB csn cA c0 wne vx cv cF cfv cB wceq vx cA wral wa cF
      cA wfn wa vy cv cF crn wcel cB vy cv wceq vy cv cB csn wcel cF cA wfn vy
      cv cF crn wcel vz cv cF cfv vy cv wceq vz cA wrex cA c0 wne vx cv cF cfv
      cB wceq vx cA wral wa cB vy cv wceq vz cA vy cv cF fvelrnb vx cv cF cfv
      cB wceq vx cA wral vz cv cF cfv vy cv wceq vz cA wrex cB vy cv wceq vz cA
      wrex cA c0 wne cB vy cv wceq vx cv cF cfv cB wceq vx cA wral vz cv cF cfv
      vy cv wceq cB vy cv wceq vz cA vx cv cF cfv cB wceq vx cA wral vz cv cA
      wcel wa vz cv cF cfv cB vy cv vx cv cF cfv cB wceq vz cv cF cfv cB wceq
      vx vz cv cA vx cv vz cv wceq vx cv cF cfv vz cv cF cfv cB vx cv vz cv cF
      fveq2 eqeq1d rcla4cva eqeq1d rexbidva cA c0 wne cB vy cv wceq cB vy cv
      wceq vz cA wrex cB vy cv wceq vz cA r19.9rzv bicomd sylan9bbr sylan9bbr
      vy cv cB csn wcel vy cv cB wceq cB vy cv wceq vy cB elsn vy cv cB eqcom
      bitr2i syl6bb eqrdv an1rs exp31 imdistand cF cA wfn cF crn cB csn wceq wa
      cA cB csn cF wfo cA cB csn cF wf cA cB csn cF df-fo cA cB csn cF fof
      sylbir syl6 pm2.61ine impbii $.
      $( [28-Aug-2004] $) $( [27-Aug-2004] $)

    $( Two ways to express a constant function. $)
    fconst3 $p |- ( F : A --> { B } <->
                  ( F Fn A /\ A C_ ( `' F " { B } ) ) ) $=
      cA cB csn cF wf cF cA wfn vx cv cF cfv cB wceq vx cA wral wa cF cA wfn cA
      cF ccnv cB csn cima wss wa vx cA cB cF fconstfv cF cA wfn vx cv cF cfv cB
      wceq vx cA wral cA cF ccnv cB csn cima wss cF wfun cA cF cdm wss vx cv cF
      cfv cB wceq vx cA wral cA cF ccnv cB csn cima wss wb cF cA wfn vx cA cB
      cF funconstss cA cF fnfun cF cA wfn cF cdm cA wceq cA cF cdm wss cA cF
      fndm cA cF cdm eqimss2 syl sylanc pm5.32i bitri $.
      $( [13-Apr-2007] $) $( [15-Mar-2007] $)
  $}

  $( Two ways to express a constant function. $)
  fconst4 $p |- ( F : A --> { B } <->
                ( F Fn A /\ ( `' F " { B } ) = A ) ) $=
    cA cB csn cF wf cF cA wfn cA cF ccnv cB csn cima wss wa cF cA wfn cF ccnv
    cB csn cima cA wceq wa cA cB cF fconst3 cF cA wfn cA cF ccnv cB csn cima
    wss cF ccnv cB csn cima cA wceq cF cA wfn cA cF ccnv cB csn cima wss cF
    ccnv cB csn cima cA wss cA cF ccnv cB csn cima wss wa cF ccnv cB csn cima
    cA wceq cF cA wfn cF ccnv cB csn cima cA wss cA cF ccnv cB csn cima wss cF
    cA wfn cF ccnv cB csn cima cF cdm cA cF ccnv cB csn cima cF cdm wss cF cA
    wfn cF cB csn cnvimass a1i cA cF fndm sseqtrd biantrurd cF ccnv cB csn cima
    cA eqss syl6bbr pm5.32i bitri $.
    $( [19-Jun-2007] $) $( [8-Mar-2007] $)

  $( A function's value in a pre-image belongs to the image. $)
  funfvima $p |- ( ( Fun F /\ B e. dom F ) -> ( B e. A ->
                 ( F ` B ) e. ( F " A ) ) ) $=
    cF wfun cB cF cdm wcel wa cB cA wcel cB cF cfv cF cA cima wcel cB cA wcel
    cF wfun cB cF cdm wcel cB cA wcel cB cF cfv cF cA cima wcel wi cF wfun cB
    cA wcel cB cF cdm wcel cB cA wcel cB cF cfv cF cA cima wcel wi wi cF wfun
    cB cA wcel cB cF cdm wcel cB cA wcel cB cF cfv cF cA cima wcel wi cF wfun
    cB cF cA cres cdm wcel cB cA wcel cB cF cfv cF cA cima wcel wi cB cA wcel
    cB cF cdm wcel wa cF wfun cB cF cA cres cdm wcel cB cA wcel cB cF cfv cF cA
    cima wcel wi cB cA wcel cB cF cfv cF cA cima wcel cB cF cA cres cfv cF cA
    cres crn wcel cF wfun cB cF cA cres cdm wcel wa cB cA wcel cB cF cA cres
    cfv cF cA cres crn wcel cB cF cfv cF cA cres crn wcel cB cF cfv cF cA cima
    wcel cB cA wcel cB cF cA cres cfv cB cF cfv cF cA cres crn cB cA cF fvres
    eleq1d cF cA cima cF cA cres crn cB cF cfv cF cA df-ima eleq2i syl6rbbr cF
    cA cres wfun cB cF cA cres cdm wcel cB cF cA cres cfv cF cA cres crn wcel
    cF wfun cB cF cA cres fvelrn cA cF funres sylan syl5cbir ex cB cF cA cres
    cdm wcel cB cA cF cdm cin wcel cB cA wcel cB cF cdm wcel wa cF cA cres cdm
    cA cF cdm cin cB cF cA dmres eleq2i cB cA cF cdm elin bitri syl5ibr exp3a
    com12 imp3a pm2.43b $.
    $( [23-Sep-2003] $)

  $( A function's value in an included pre-image belongs to the image. $)
  funfvima2 $p |- ( ( Fun F /\ A C_ dom F ) -> ( B e. A ->
                  ( F ` B ) e. ( F " A ) ) ) $=
    cF wfun cA cF cdm wss cB cA wcel cB cF cfv cF cA cima wcel wi cF wfun cB cA
    wcel cB cF cdm wcel wi cB cA wcel cB cF cfv cF cA cima wcel wi cA cF cdm
    wss cF wfun cB cA wcel cB cF cdm wcel cB cF cfv cF cA cima wcel cF wfun cB
    cF cdm wcel cB cA wcel cB cF cfv cF cA cima wcel cF wfun cB cF cdm wcel cB
    cA wcel cB cF cfv cF cA cima wcel wi cA cB cF funfvima ex com23 a2d cA cF
    cdm cB ssel syl5 imp $.
    $( [3-Feb-1997] $)

  ${
    $d x A $.  $d x F $.  $d x G $.
    $( A class including a function contains the function's value in the image
       of the singleton of the argument. $)
    funfvima3 $p |- ( ( Fun F /\ F C_ G ) -> ( A e. dom F ->
                    ( F ` A ) e. ( G " { A } ) ) ) $=
      cF cG wss cF wfun cA cF cdm wcel cA cF cfv cG cA csn cima wcel wi cF cG
      wss cF wfun cA cF cdm wcel cA cF cfv cG cA csn cima wcel cF cG wss cF
      wfun cA cF cdm wcel wa wa cA cF cfv cG cA csn cima wcel cA cA cF cfv cop
      cG wcel cF cG wss cF wfun cA cF cdm wcel wa cA cA cF cfv cop cG wcel cF
      cG wss cA cA cF cfv cop cF wcel cA cA cF cfv cop cG wcel cF wfun cA cF
      cdm wcel wa cF cG cA cA cF cfv cop ssel cA cF funfvop syl5 imp cA cF cdm
      wcel cA cF cfv cG cA csn cima wcel cA cA cF cfv cop cG wcel wb cF cG wss
      cF wfun cA cF cfv cG vx cv csn cima wcel vx cv cA cF cfv cop cG wcel cA
      cF cfv cG cA csn cima wcel cA cA cF cfv cop cG wcel vx cA cF cdm vx cv cA
      wceq cG vx cv csn cima cG cA csn cima cA cF cfv vx cv cA wceq vx cv csn
      cA csn cG vx cv cA sneq imaeq2d eleq2d vx cv cA wceq vx cv cA cF cfv cop
      cA cA cF cfv cop cG vx cv cA cA cF cfv opeq1 eleq1d cG vx cv cA cF cfv vx
      visset cA cF fvex elimasn vtoclbg ad2antll mpbird exp32 impcom $.
      $( [24-Mar-2004] $) $( [23-Mar-2004] $)
  $}

  ${
    $d x y F $.
    $( Upper bound for the class of values of a class. $)
    fvclss $p |- { y | E. x y = ( F ` x ) } C_ ( ran F u. { (/) } ) $=
      vy cv vx cv cF cfv wceq vx wex vy cab vy cv cF crn wcel vy cv c0 csn wcel
      wo vy cab cF crn c0 csn cun vy cv vx cv cF cfv wceq vx wex vy cv cF crn
      wcel vy cv c0 csn wcel wo vy vy cv vx cv cF cfv wceq vx wex vy cv cF crn
      wcel vy cv c0 csn wcel vy cv vx cv cF cfv wceq vx wex vy cv cF crn wcel
      wn vy cv c0 wceq vy cv c0 csn wcel vy cv vx cv cF cfv wceq vx wex vy cv
      cF crn wcel vy cv c0 vy cv c0 wne vy cv vx cv cF cfv wceq vx wex vy cv cF
      crn wcel vy cv c0 wne vy cv vx cv cF cfv wceq vx wex vx cv vy cv cF wbr
      vx wex vy cv cF crn wcel vy cv c0 wne vy cv vx cv cF cfv wceq vx cv vy cv
      cF wbr vx vy cv c0 wne vx cv cF cfv vy cv wceq vx cv vy cv cF wbr vy cv
      vx cv cF cfv wceq vx cv vy cv cF vx visset tz6.12i vy cv vx cv cF cfv
      eqcom syl5ib 19.22dv vx vy cv cF vy visset elrn syl6ibr com12 necon1bd vy
      c0 elsn syl6ibr orrd ss2abi vy cF crn c0 csn df-un sseqtr4i $.
      $( [9-Nov-1995] $)
  $}

  ${
    $d x y F $.
    fvclex.1 $e |- F e. _V $.
    $( Existence of the class of values of a set. $)
    fvclex $p |- { y | E. x y = ( F ` x ) } e. _V $=
      vy cv vx cv cF cfv wceq vx wex vy cab cF crn c0 csn cun cF crn c0 csn cF
      fvclex.1 rnex p0ex unex vx vy cF fvclss ssexi $.
      $( [9-Nov-1995] $)
  $}

  ${
    $d x y z w F $.  $d x y A $.
    fvresex.1 $e |- A e. _V $.
    $( Existence of the class of values of a restricted class. $)
    fvresex $p |- { y | E. x y = ( ( F |` A ) ` x ) } e. _V $=
      vy cv vx cv vw cv vz cv cF cfv wceq vz vw copab cA cres cfv wceq vx wex
      vy cab vy cv vx cv cF cA cres cfv wceq vx wex vy cab cvv vy cv vx cv vw
      cv vz cv cF cfv wceq vz vw copab cA cres cfv wceq vx wex vy cv vx cv cF
      cA cres cfv wceq vx wex vy vy cv vx cv vw cv vz cv cF cfv wceq vz vw
      copab cA cres cfv wceq vy cv vx cv cF cA cres cfv wceq vx vx cv vw cv vz
      cv cF cfv wceq vz vw copab cA cres cfv vx cv cF cA cres cfv vy cv vx cv
      vw cv vz cv cF cfv wceq vz vw copab cfv vx cv cF cfv wceq vx cv vw cv vz
      cv cF cfv wceq vz vw copab cA cres cfv vx cv cF cA cres cfv wceq vz vw vx
      cv vz cv cF cfv vx cv cF cfv vx visset vx cv cF fvex vz cv vx cv cF fveq2
      fvopab vx cv cA vw cv vz cv cF cfv wceq vz vw copab cF fveqres ax-mp
      eqeq2i exbii abbii vx vy vw cv vz cv cF cfv wceq vz vw copab cA cres vw
      cv vz cv cF cfv wceq vz vw copab wfun cA cvv wcel vw cv vz cv cF cfv wceq
      vz vw copab cA cres cvv wcel vz vw vz cv cF cfv funopabeq fvresex.1 vw cv
      vz cv cF cfv wceq vz vw copab cA cvv resfunexg mp2an fvclex eqeltrri $.
      $( [14-Nov-1995] $)
  $}

  ${
    $d x y F $.  $d x y A $.
    abrexexlem1.1 $e |- A e. _V $.
    $( Lemma for ~ abrexex .  Shows the existence of a class of existentially
       restricted function values. $)
    abrexexlem1 $p |- { y | E. x e. A y = ( F ` x ) } e. _V $=
      vy cv vx cv cF cfv wceq vx cA wrex vy cab vy cv vx cv cF cA cres cfv wceq
      vx wex vy cab vx vy cA cF abrexexlem1.1 fvresex vy cv vx cv cF cfv wceq
      vx cA wrex vy cv vx cv cF cA cres cfv wceq vx wex vy vy cv vx cv cF cfv
      wceq vx cA wrex vx cv cA wcel vy cv vx cv cF cfv wceq wa vx wex vy cv vx
      cv cF cA cres cfv wceq vx wex vy cv vx cv cF cfv wceq vx cA df-rex vx cv
      cA wcel vy cv vx cv cF cfv wceq wa vy cv vx cv cF cA cres cfv wceq vx vx
      cv cA wcel vy cv vx cv cF cA cres cfv wceq vy cv vx cv cF cfv wceq vx cv
      cA wcel vx cv cF cA cres cfv vx cv cF cfv vy cv vx cv cA cF fvres eqeq2d
      biimpar 19.22i sylbi ss2abi ssexi $.
      $( [26-Apr-2004] $) $( [22-Apr-2004] $)
  $}

  ${
    $d x y z w A $.  $d y z w B $.
    abrexexlem2.1 $e |- A e. _V $.
    abrexexlem2.2 $e |- B e. _V $.
    $( Lemma for ~ abrexex .  Almost there, but still requires that ` B ` be
       a set. $)
    abrexexlem2 $p |- { y | E. x e. A y = B } e. _V $=
      vy cv cB wceq vx cA wrex vy cab vw cv vz cv vy cv cB wceq vx vy copab cfv
      wceq vz cA wrex vw cab cvv vy cv cB wceq vx cA wrex vy cab vy cv vz cv vy
      cv cB wceq vx vy copab cfv wceq vz cA wrex vy cab vw cv vz cv vy cv cB
      wceq vx vy copab cfv wceq vz cA wrex vw cab vy cv cB wceq vx cA wrex vy
      cv vz cv vy cv cB wceq vx vy copab cfv wceq vz cA wrex vy vy cv cB wceq
      vx cA wrex vy cv vx cv vy cv cB wceq vx vy copab cfv wceq vx cA wrex vy
      cv vz cv vy cv cB wceq vx vy copab cfv wceq vz cA wrex vy cv vx cv vy cv
      cB wceq vx vy copab cfv wceq vy cv cB wceq vx cA vx cv vy cv cB wceq vx
      vy copab cfv cB vy cv vx cv vy cv cB wceq vx vy copab cfv vx cv vx cv cvv
      wcel vy cv cB wceq wa vx vy copab cfv cB vx cv vy cv cB wceq vx vy copab
      vx cv cvv wcel vy cv cB wceq wa vx vy copab vy cv cB wceq vx cv cvv wcel
      vy cv cB wceq wa vx vy vx cv cvv wcel vy cv cB wceq vx visset biantrur
      opabbii fveq1i vx cv cvv wcel cB cvv wcel vx cv vx cv cvv wcel vy cv cB
      wceq wa vx vy copab cfv cB wceq vx visset abrexexlem2.2 vx vy cvv cB cvv
      fvopab2 mp2an eqtri eqeq2i rexbii vy cv vx cv vy cv cB wceq vx vy copab
      cfv wceq vy cv vz cv vy cv cB wceq vx vy copab cfv wceq vx vz cA vy cv vx
      cv vy cv cB wceq vx vy copab cfv wceq vz ax-17 vx vw vw vy cv vz cv vy cv
      cB wceq vx vy copab cfv vw cv vy cv wcel vx ax-17 vx vw vz cv vy cv cB
      wceq vx vy copab vy cv cB wceq vx vy vw hbopab1 vw cv vz cv wcel vx ax-17
      hbfv hbeq vx cv vz cv wceq vx cv vy cv cB wceq vx vy copab cfv vz cv vy
      cv cB wceq vx vy copab cfv vy cv vx cv vz cv vy cv cB wceq vx vy copab
      fveq2 eqeq2d cbvrex bitr3i abbii vy cv vz cv vy cv cB wceq vx vy copab
      cfv wceq vz cA wrex vw cv vz cv vy cv cB wceq vx vy copab cfv wceq vz cA
      wrex vy vw vy cv vz cv vy cv cB wceq vx vy copab cfv wceq vz cA wrex vw
      ax-17 vw cv vz cv vy cv cB wceq vx vy copab cfv wceq vy vz cA vz cv cA
      wcel vy ax-17 vy vx vw vw cv vz cv vy cv cB wceq vx vy copab cfv vx cv vw
      cv wcel vy ax-17 vy vw vz cv vy cv cB wceq vx vy copab vy cv cB wceq vx
      vy vw hbopab2 vw cv vz cv wcel vy ax-17 hbfv hbeq hbrex vy cv vw cv wceq
      vy cv vz cv vy cv cB wceq vx vy copab cfv wceq vw cv vz cv vy cv cB wceq
      vx vy copab cfv wceq vz cA vy cv vw cv vz cv vy cv cB wceq vx vy copab
      cfv eqeq1 rexbidv cbvab eqtri vz vw cA vy cv cB wceq vx vy copab
      abrexexlem2.1 abrexexlem1 eqeltri $.
      $( [14-Oct-2003] $) $( [16-Oct-2003] $)
  $}

  ${
    $d x y z A $.  $d y z B $.
    abrexex.1 $e |- A e. _V $.
    $( Existence of a class abstraction of existentially restricted sets.
       ` x ` is normally a free-variable parameter in the class expression
       substituted for ` B ` , which can be thought of as ` B ( x ) ` .  This
       simple-looking theorem is actually quite powerful and appears to involve
       the Axiom of Replacement in an intrinsic way, as can be seen by tracing
       back through the path ~ abrexexlem2 , ~ abrexexlem1 , ~ fvresex ,
       ~ resfunexg , and ~ funimaexg .  See also ~ abrexex2 . $)
    abrexex $p |- { y | E. x e. A y = B } e. _V $=
      vy cv cB wceq vx cA wrex vy cab vy cv cB cvv wcel vz cB crab wceq vx cA
      wrex vy cab vx vy cA cB cvv wcel vz cB crab abrexex.1 vz cB class2set
      abrexexlem2 vy cv cB wceq vx cA wrex vy cv cB cvv wcel vz cB crab wceq vx
      cA wrex vy vy cv cB wceq vy cv cB cvv wcel vz cB crab wceq vx cA vy cv cB
      wceq vy cv cB cvv wcel vz cB crab wceq vy cv cB wceq cB cvv wcel vy cv cB
      wceq vy cv cB cvv wcel vz cB crab wceq wb vy cv cB wceq vy cv cvv wcel cB
      cvv wcel vy visset vy cv cB cvv eleq1 mpbii cB cvv wcel cB cB cvv wcel vz
      cB crab vy cv cB cvv wcel cB cvv wcel vz cB wral cB cB cvv wcel vz cB
      crab wceq cB cvv wcel cB cvv wcel vz cB cB cvv wcel vz cv cB wcel ax-1
      r19.21aiv cB cvv wcel vz cB rabid2 sylibr eqeq2d syl ibi r19.22si ss2abi
      ssexi $.
      $( [18-Oct-2003] $) $( [16-Oct-2003] $)
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( Existence of a class abstraction of existentially restricted sets.
       ` x ` is normally a free-variable parameter in ` B ` .  The antecedent
       assures us that ` A ` is a set. $)
    abrexexg $p |- ( A e. C -> { y | E. x e. A y = B } e. _V ) $=
      vy cv cB wceq vx vz cv wrex vy cab cvv wcel vy cv cB wceq vx cA wrex vy
      cab cvv wcel vz cA cC vz cv cA wceq vy cv cB wceq vx vz cv wrex vy cab vy
      cv cB wceq vx cA wrex vy cab cvv vz cv cA wceq vy cv cB wceq vx vz cv
      wrex vy cv cB wceq vx cA wrex vy vy cv cB wceq vx vz cv cA rexeq1 abbidv
      eleq1d vx vy vz cv cB vz visset abrexex vtoclg $.
      $( [8-Nov-2003] $) $( [3-Nov-2003] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( The existence of an indexed union.  ` x ` is normally a free-variable
       parameter in ` B ` . $)
    iunexg $p |- ( ( A e. C /\ A. x e. A B e. D ) -> U_ x e. A B e. _V ) $=
      cA cC wcel cB cD wcel vx cA wral wa vx cA cB ciun vy cv cB wceq vx cA
      wrex vy cab cuni cvv cB cD wcel vx cA wral vx cA cB ciun vy cv cB wceq vx
      cA wrex vy cab cuni wceq cA cC wcel vx vy cA cB cD dfiun2g adantl cA cC
      wcel vy cv cB wceq vx cA wrex vy cab cuni cvv wcel cB cD wcel vx cA wral
      cA cC wcel vy cv cB wceq vx cA wrex vy cab cvv wcel vy cv cB wceq vx cA
      wrex vy cab cuni cvv wcel vx vy cA cB cC abrexexg vy cv cB wceq vx cA
      wrex vy cab cvv uniexg syl adantr eqeltrd $.
      $( [26-Mar-2006] $) $( [23-Mar-2006] $)
  $}

  ${
    $d x A $.
    iunex.1 $e |- A e. _V $.
    iunex.2 $e |- B e. _V $.
    $( The existence of an indexed union.  ` x ` is normally a free-variable
       parameter in the class expression substituted for ` B ` , which can be
       read informally as ` B ( x ) ` . $)
    iunex $p |- U_ x e. A B e. _V $=
      cA cvv wcel cB cvv wcel vx cA wral vx cA cB ciun cvv wcel iunex.1 cB cvv
      wcel vx cA cB cvv wcel vx cv cA wcel iunex.2 a1i rgen vx cA cB cvv cvv
      iunexg mp2an $.
      $( [13-Oct-2003] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The image of a union is the indexed union of the images.  Theorem 3K(a)
       of [Enderton] p. 50. $)
    imaiun $p |- ( A " U. B ) = U_ x e. B ( A " x ) $=
      vy cA cB cuni cima vx cB cA vx cv cima ciun vz cv cB cuni wcel vz cv vy
      cv cop cA wcel wa vz wex vy cv cA vx cv cima wcel vx cB wrex vy cv cA cB
      cuni cima wcel vy cv vx cB cA vx cv cima ciun wcel vz cv cB cuni wcel vz
      cv vy cv cop cA wcel wa vz wex vz cv vx cv wcel vx cv cB wcel wa vx wex
      vz cv vy cv cop cA wcel wa vz wex vx cv cB wcel vz cv vx cv wcel vz cv vy
      cv cop cA wcel wa vz wex wa vx wex vy cv cA vx cv cima wcel vx cB wrex vz
      cv cB cuni wcel vz cv vy cv cop cA wcel wa vz cv vx cv wcel vx cv cB wcel
      wa vx wex vz cv vy cv cop cA wcel wa vz vz cv cB cuni wcel vz cv vx cv
      wcel vx cv cB wcel wa vx wex vz cv vy cv cop cA wcel vx vz cv cB eluni
      anbi1i exbii vz cv vx cv wcel vx cv cB wcel wa vx wex vz cv vy cv cop cA
      wcel wa vz wex vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop cA wcel wa
      wa vx wex vz wex vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop cA wcel
      wa wa vz wex vx wex vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop cA
      wcel wa vz wex wa vx wex vz cv vx cv wcel vx cv cB wcel wa vx wex vz cv
      vy cv cop cA wcel wa vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop cA
      wcel wa wa vx wex vz vz cv vx cv wcel vx cv cB wcel wa vx wex vz cv vy cv
      cop cA wcel wa vz cv vx cv wcel vx cv cB wcel wa vz cv vy cv cop cA wcel
      wa vx wex vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop cA wcel wa wa vx
      wex vz cv vx cv wcel vx cv cB wcel wa vz cv vy cv cop cA wcel vx 19.41v
      vz cv vx cv wcel vx cv cB wcel wa vz cv vy cv cop cA wcel wa vx cv cB
      wcel vz cv vx cv wcel vz cv vy cv cop cA wcel wa wa vx vz cv vx cv wcel
      vx cv cB wcel wa vz cv vy cv cop cA wcel wa vz cv vx cv wcel vx cv cB
      wcel vz cv vy cv cop cA wcel wa wa vx cv cB wcel vz cv vx cv wcel vz cv
      vy cv cop cA wcel wa wa vz cv vx cv wcel vx cv cB wcel vz cv vy cv cop cA
      wcel anass vz cv vx cv wcel vx cv cB wcel vz cv vy cv cop cA wcel an12
      bitri exbii bitr3i exbii vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop
      cA wcel wa wa vz vx excom vx cv cB wcel vz cv vx cv wcel vz cv vy cv cop
      cA wcel wa vx vz exdistr 3bitri vy cv cA vx cv cima wcel vx cB wrex vz cv
      vx cv wcel vz cv vy cv cop cA wcel wa vz wex vx cB wrex vx cv cB wcel vz
      cv vx cv wcel vz cv vy cv cop cA wcel wa vz wex wa vx wex vy cv cA vx cv
      cima wcel vz cv vx cv wcel vz cv vy cv cop cA wcel wa vz wex vx cB vz vy
      cv cA vx cv vy visset elima3 rexbii vz cv vx cv wcel vz cv vy cv cop cA
      wcel wa vz wex vx cB df-rex bitr2i 3bitri vz vy cv cA cB cuni vy visset
      elima3 vx vy cv cB cA vx cv cima eliun 3bitr4i eqriv $.
      $( [1-Sep-2004] $) $( [9-Aug-2004] $)
  $}

  ${
    $d w x y z A $.  $d w x y z F $.
    $( The indexed union of a function's values is the union of its range.
       Compare Definition 5.4 of [Monk1] p. 50. $)
    fniunfv $p |- ( F Fn A -> U_ x e. A ( F ` x ) = U. ran F ) $=
      cF cA wfn cF crn cuni vy cv vx cv cF cfv wceq vx cA wrex vy cab cuni vx
      cA vx cv cF cfv ciun cF cA wfn cF crn vy cv vx cv cF cfv wceq vx cA wrex
      vy cab vx vy cA cF fnrnfv unieqd vx vy cA vx cv cF cfv vx cv cF fvex
      dfiun2 syl6reqr $.
      $( [12-Nov-2004] $) $( [27-Sep-2004] $)

    $( The indexed union of a function's values is the union of its image
       under the index class.

       Note: This theorem depends on the fact that our function value is the
       empty set outside of its domain.  If the antecedent is changed to
       ` F Fn A ` , the theorem can be proved without this dependency. $)
    funiunfv $p |- ( Fun F -> U_ x e. A ( F ` x ) = U. ( F " A ) ) $=
      cF wfun vx cA vx cv cF cfv ciun vy cv cA wcel vz cv vy cv cF cfv wceq wa
      vy vz copab crn cuni cF cA cima cuni cF wfun vx cA vx cv vy cv cA wcel vz
      cv vy cv cF cfv wceq wa vy vz copab cfv ciun vy cv cA wcel vz cv vy cv cF
      cfv wceq wa vy vz copab crn cuni vx cA vx cv cF cfv ciun vx cA vx cv vy
      cv cA wcel vz cv vy cv cF cfv wceq wa vy vz copab cfv ciun vy cv cA wcel
      vz cv vy cv cF cfv wceq wa vy vz copab crn cuni wceq cF wfun vy cv cA
      wcel vz cv vy cv cF cfv wceq wa vy vz copab cA wfn vx cA vx cv vy cv cA
      wcel vz cv vy cv cF cfv wceq wa vy vz copab cfv ciun vy cv cA wcel vz cv
      vy cv cF cfv wceq wa vy vz copab crn cuni wceq vy vz cA vy cv cF cfv vy
      cv cA wcel vz cv vy cv cF cfv wceq wa vy vz copab vy cv cF fvex vy cv cA
      wcel vz cv vy cv cF cfv wceq wa vy vz copab eqid fnopab2 vx cA vy cv cA
      wcel vz cv vy cv cF cfv wceq wa vy vz copab fniunfv ax-mp a1i vx cA vx cv
      vy cv cA wcel vz cv vy cv cF cfv wceq wa vy vz copab cfv vx cv cF cfv vy
      vz vx cv vy cv cF cfv vx cv cF cfv cA vy cv cA wcel vz cv vy cv cF cfv
      wceq wa vy vz copab vy cv vx cv cF fveq2 vy cv cA wcel vz cv vy cv cF cfv
      wceq wa vy vz copab eqid vx cv cF fvex fvopab4 iuneq2i syl5eqr cF wfun vz
      cv vy cv cF cfv wceq vy cA wrex vz cab cuni cF cA cima cuni vy cv cA wcel
      vz cv vy cv cF cfv wceq wa vy vz copab crn cuni cF wfun vw vz cv vy cv cF
      cfv wceq vy cA wrex vz cab cuni cF cA cima cuni cF wfun vw cv vz cv wcel
      vz cv vy cv cF cfv wceq vy cA wrex wa vz wex vw cv cF cA cima cuni wcel
      vw cv vz cv vy cv cF cfv wceq vy cA wrex vz cab cuni wcel cF wfun vw cv
      vz cv wcel vz cv vy cv cF cfv wceq vy cA wrex wa vz wex vw cv vz cv wcel
      vy cv vz cv cF wbr vy cA wrex wa vz wex vw cv cF cA cima cuni wcel cF
      wfun vw cv vz cv wcel vz cv vy cv cF cfv wceq vy cA wrex wa vw cv vz cv
      wcel vy cv vz cv cF wbr vy cA wrex wa vz cF wfun vw cv vz cv wcel vz cv
      vy cv cF cfv wceq vy cA wrex vy cv vz cv cF wbr vy cA wrex cF wfun vw cv
      vz cv wcel wa vz cv vy cv cF cfv wceq vy cv vz cv cF wbr vy cA cF wfun vw
      cv vz cv wcel wa vy cv cF cfv vz cv wceq vy cv vz cv cF wbr vz cv vy cv
      cF cfv wceq cF wfun vw cv vz cv wcel wa vy cv cF cfv vz cv wceq vy cv vz
      cv cF wbr cF wfun vw cv vz cv wcel wa vy cv cF cfv vz cv wceq vy cv vz cv
      cF wbr cF wfun vw cv vz cv wcel wa vy cv cF cfv vz cv wceq vy cv cF cfv
      vz cv wceq vy cv vz cv cF wbr wi cF wfun vw cv vz cv wcel vy cv cF cfv vz
      cv wceq vy cv cF cfv vz cv wceq vy cv vz cv cF wbr wi cF wfun vy cv cF
      cdm wcel vy cv cF cfv vz cv wceq vy cv vz cv cF wbr wi vw cv vz cv wcel
      vy cv cF cfv vz cv wceq wa cF wfun vy cv cF cdm wcel wa vy cv cF cfv vz
      cv wceq vy cv vz cv cF wbr vy cv vz cv cF vz visset funbrfvb biimpd vz cv
      c0 wceq wn vy cv cF cfv vz cv wceq vy cv cF cdm wcel vw cv vz cv wcel vy
      cv cF cfv vz cv wceq vz cv c0 wceq wn vy cv cF cdm wcel vy cv cF cfv vz
      cv wceq vy cv cF cdm wcel vz cv c0 wceq vy cv cF cfv vz cv wceq vy cv cF
      cfv c0 wceq vz cv c0 wceq vy cv cF cdm wcel wn vy cv cF cfv vz cv c0
      eqeq1 vy cv cF ndmfv syl5bi con1d impcom vz cv vw cv n0i sylan sylan2
      anassrs ex pm2.43d cF wfun vy cv vz cv cF wbr vy cv cF cfv vz cv wceq wi
      vw cv vz cv wcel vy cv vz cv cF vz visset funbrfv adantr impbid vz cv vy
      cv cF cfv eqcom syl5bb rexbidv pm5.32da exbidv vw cv cF cA cima cuni wcel
      vw cv vz cv wcel vz cv cF cA cima wcel wa vz wex vw cv vz cv wcel vy cv
      vz cv cF wbr vy cA wrex wa vz wex vz vw cv cF cA cima eluni vw cv vz cv
      wcel vz cv cF cA cima wcel wa vw cv vz cv wcel vy cv vz cv cF wbr vy cA
      wrex wa vz vz cv cF cA cima wcel vy cv vz cv cF wbr vy cA wrex vw cv vz
      cv wcel vy vz cv cF cA vz visset elima anbi2i exbii bitr2i syl6bb vz cv
      vy cv cF cfv wceq vy cA wrex vz vw cv eluniab syl5bb eqrdv vy cv cA wcel
      vz cv vy cv cF cfv wceq wa vy vz copab crn vz cv vy cv cF cfv wceq vy cA
      wrex vz cab vy vz cA vy cv cF cfv rnopab2 unieqi syl5eq eqtrd $.
      $( [3-Apr-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( Membership in the union of an image of a function. $)
    eluniima $p |- ( Fun F ->
                   ( B e. U. ( F " A ) <-> E. x e. A B e. ( F ` x ) ) ) $=
      cF wfun cB vx cA vx cv cF cfv ciun wcel cB cF cA cima cuni wcel cB vx cv
      cF cfv wcel vx cA wrex cF wfun vx cA vx cv cF cfv ciun cF cA cima cuni cB
      vx cA cF funiunfv eleq2d vx cB cA vx cv cF cfv eliun syl5rbbr $.
      $( [29-Sep-2006] $) $( [28-Sep-2006] $)

    $( Membership in the union of the range of a function. $)
    elunirn $p |- ( Fun F ->
                     ( A e. U. ran F <-> E. x e. dom F A e. ( F ` x ) ) ) $=
      cF wfun cA cF cF cdm cima cuni wcel cA vx cv cF cfv wcel vx cF cdm wrex
      cA cF crn cuni wcel vx cF cdm cA cF eluniima cF cF cdm cima cuni cF crn
      cuni cA cF cF cdm cima cF crn cF imadmrn unieqi eleq2i syl5bbr $.
      $( [26-Mar-2007] $) $( [24-Sep-2006] $)
  $}

  ${
    $d x y A $.  $d x y F $.
    $( Membership in the union of the range of a function, proved directly.
       Unlike ~ elunirn , it doesn't appeal to ~ ndmfv (via ~ funiunfv ). $)
    elunirnALT $p |- ( Fun F -> ( A e. U. ran F <->
                E. x e. dom F A e. ( F ` x ) ) ) $=
      cF wfun cA vy cv wcel vy cv cF crn wcel wa vy wex cA vx cv cF cfv wcel vx
      cF cdm wrex cA cF crn cuni wcel cF wfun cA vy cv wcel vy cv cF crn wcel
      wa vy wex cA vx cv cF cfv wcel vx cF cdm wrex cF wfun cA vy cv wcel vy cv
      cF crn wcel wa cA vx cv cF cfv wcel vx cF cdm wrex vy cF wfun cA vy cv
      wcel vy cv cF crn wcel wa cA vy cv wcel vx cv cF cfv vy cv wceq wa vx cF
      cdm wrex cA vx cv cF cfv wcel vx cF cdm wrex cF wfun cA vy cv wcel vy cv
      cF crn wcel wa cA vy cv wcel vx cv cF cfv vy cv wceq vx cF cdm wrex wa cA
      vy cv wcel vx cv cF cfv vy cv wceq wa vx cF cdm wrex cF wfun vy cv cF crn
      wcel vx cv cF cfv vy cv wceq vx cF cdm wrex cA vy cv wcel cF wfun cF cF
      cdm wfn vy cv cF crn wcel vx cv cF cfv vy cv wceq vx cF cdm wrex wb cF
      funfn vx cF cdm vy cv cF fvelrnb sylbi anbi2d cA vy cv wcel vx cv cF cfv
      vy cv wceq vx cF cdm r19.42v syl6bbr cA vy cv wcel vx cv cF cfv vy cv
      wceq wa cA vx cv cF cfv wcel vx cF cdm vx cv cF cfv vy cv wceq cA vx cv
      cF cfv wcel cA vy cv wcel vx cv cF cfv vy cv cA eleq2 biimparc r19.22si
      syl6bi 19.23adv cF wfun cA vx cv cF cfv wcel cA vy cv wcel vy cv cF crn
      wcel wa vy wex vx cF cdm cF wfun vx cv cF cdm wcel wa cA vx cv cF cfv
      wcel cA vx cv cF cfv wcel vx cv cF cfv cF crn wcel wa cA vy cv wcel vy cv
      cF crn wcel wa vy wex cF wfun vx cv cF cdm wcel wa cA vx cv cF cfv wcel
      vx cv cF cfv cF crn wcel cF wfun vx cv cF cdm wcel wa vx cv cF cfv cF crn
      wcel cA vx cv cF cfv wcel vx cv cF fvelrn a1d ancld cA vy cv wcel vy cv
      cF crn wcel wa cA vx cv cF cfv wcel vx cv cF cfv cF crn wcel wa vy vx cv
      cF cfv vx cv cF fvex vy cv vx cv cF cfv wceq cA vy cv wcel cA vx cv cF
      cfv wcel vy cv cF crn wcel vx cv cF cfv cF crn wcel vy cv vx cv cF cfv cA
      eleq2 vy cv vx cv cF cfv cF crn eleq1 anbi12d cla4ev syl6 r19.23adva
      impbid vy cA cF crn eluni syl5bb $.
      $( [11-Oct-2006] $) $( [24-Sep-2006] $)
  $}

  ${
    $d x y z A $.  $d y z F $.
    funiunfvf.1 $e |- ( y e. F -> A. x y e. F ) $.
    $( The indexed union of a function's values is the union of its image
       under the index class.  This version of ~ funiunfv uses a
       bound-variable hypothesis in place of a distinct variable condition. $)
    funiunfvf $p |- ( Fun F -> U_ x e. A ( F ` x ) = U. ( F " A ) ) $=
      cF wfun vz cA vz cv cF cfv ciun cF cA cima cuni vx cA vx cv cF cfv ciun
      vz cA cF funiunfv vz vx vy cA vz cv cF cfv vx cv cF cfv vx vy vz cv cF
      funiunfvf.1 vy cv vz cv wcel vx ax-17 hbfv vy cv vx cv cF cfv wcel vz
      ax-17 vz cv vx cv cF fveq2 cbviun syl5eqr $.
      $( [4-Apr-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x y z A $.  $d z ph $.
    abrexex2.1 $e |- A e. _V $.
    abrexex2.2 $e |- { y | ph } e. _V $.
    $( Existence of an existentially restricted class abstraction.  ` ph ` is
       normally has free-variable parameters ` x ` and ` y ` .  This is a
       powerful generalization of ~ abrexex . $)
    abrexex2 $p |- { y | E. x e. A ph } e. _V $=
      wph vx cA wrex vy cab vz cv wph vy cab wcel vx cA wrex vz cab cvv wph vx
      cA wrex vy cab wph vy vz cv wsbc vx cA wrex vz cab vz cv wph vy cab wcel
      vx cA wrex vz cab wph vx cA wrex wph vy vz cv wsbc vx cA wrex vy vz wph
      vx cA wrex vz ax-17 wph vy vz cv wsbc vy vx cA vx cv cA wcel vy ax-17 wph
      vy vz hbs1 hbrex vy cv vz cv wceq wph wph vy vz cv wsbc vx cA wph vy vz
      sbequ12 rexbidv cbvab vz cv wph vy cab wcel vx cA wrex wph vy vz cv wsbc
      vx cA wrex vz vz cv wph vy cab wcel wph vy vz cv wsbc vx cA wph vz vy
      df-clab rexbii abbii eqtr4i vx cA wph vy cab ciun vz cv wph vy cab wcel
      vx cA wrex vz cab cvv vx vz cA wph vy cab df-iun vx cA wph vy cab
      abrexex2.1 abrexex2.2 iunex eqeltrri eqeltri $.
      $( [14-Sep-2004] $) $( [12-Sep-2004] $)

    $( Existence of a class abstraction with an existentially quantified
       expression.  Both ` x ` and ` y ` can be free in ` ph ` . $)
    abexssex $p |- { y | E. x ( x C_ A /\ ph ) } e. _V $=
      wph vx cA cpw wrex vy cab vx cv cA wss wph wa vx wex vy cab cvv wph vx cA
      cpw wrex vx cv cA wss wph wa vx wex vy wph vx cA cpw wrex vx cv cA cpw
      wcel wph wa vx wex vx cv cA wss wph wa vx wex wph vx cA cpw df-rex vx cv
      cA cpw wcel wph wa vx cv cA wss wph wa vx vx cv cA cpw wcel vx cv cA wss
      wph vx cv cA vx visset elpw anbi1i exbii bitri abbii wph vx vy cA cpw cA
      abrexex2.1 pwex abrexex2.2 abrexex2 eqeltrri $.
      $( [30-Jul-2006] $) $( [29-Jul-2006] $)
  $}

  ${
    $d x y A $.
    abexex.1 $e |- A e. _V $.
    abexex.2 $e |- ( ph -> x e. A ) $.
    abexex.3 $e |- { y | ph } e. _V $.
    $( A condition where a class builder continues to exist after its wff is
       existentially quantified. $)
    abexex $p |- { y | E. x ph } e. _V $=
      wph vx cA wrex vy cab wph vx wex vy cab cvv wph vx cA wrex wph vx wex vy
      wph vx cA wrex vx cv cA wcel wph wa vx wex wph vx wex wph vx cA df-rex
      wph vx cv cA wcel wph wa vx wph vx cv cA wcel abexex.2 pm4.71ri exbii
      bitr4i abbii wph vx vy cA abexex.1 abexex.3 abrexex2 eqeltrri $.
      $( [5-Mar-2007] $) $( [4-Mar-2007] $)
  $}

  ${
    $d x y z A $.  $d z B $.  $d x y z F $.
    $( A one-to-one function in terms of function values.  Compare Theorem
       4.8(iv) of [Monk1] p. 43. $)
    dff13 $p |- ( F : A -1-1-> B <-> ( F : A --> B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      cA cB cF wf1 cA cB cF wf vx cv vz cv cF wbr vx wmo vz wal wa cA cB cF wf
      vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral
      wa vx vz cA cB cF dff12 cA cB cF wf vx cv vz cv cF wbr vx wmo vz wal vx
      cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral cA
      cB cF wf cF cA wfn vx cv vz cv cF wbr vx wmo vz wal vx cv cF cfv vy cv cF
      cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral wb cA cB cF ffn cF cA
      wfn vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq wi vz wal
      vy wal vx wal vx cv cA wcel vy cv cA wcel wa vx cv cF cfv vy cv cF cfv
      wceq vx cv vy cv wceq wi wi vy wal vx wal vx cv vz cv cF wbr vx wmo vz
      wal vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA
      wral cF cA wfn vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq
      wi vz wal vx cv cA wcel vy cv cA wcel wa vx cv cF cfv vy cv cF cfv wceq
      vx cv vy cv wceq wi wi vx vy cF cA wfn vx cv vz cv cF wbr vy cv vz cv cF
      wbr wa vx cv vy cv wceq wi vz wal vx cv cA wcel vy cv cA wcel wa vz cv vx
      cv cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq wi wi vz wal
      vx cv cA wcel vy cv cA wcel wa vx cv cF cfv vy cv cF cfv wceq vx cv vy cv
      wceq wi wi cF cA wfn vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv
      wceq wi vx cv cA wcel vy cv cA wcel wa vz cv vx cv cF cfv wceq vz cv vy
      cv cF cfv wceq wa vx cv vy cv wceq wi wi vz cF cA wfn vx cv vz cv cF wbr
      vy cv vz cv cF wbr wa vx cv vy cv wceq wi vx cv cA wcel vy cv cA wcel wa
      vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq wa wa vx cv vy cv wceq wi
      vx cv cA wcel vy cv cA wcel wa vz cv vx cv cF cfv wceq vz cv vy cv cF cfv
      wceq wa vx cv vy cv wceq wi wi cF cA wfn vx cv vz cv cF wbr vy cv vz cv
      cF wbr wa vx cv cA wcel vy cv cA wcel wa vz cv vx cv cF cfv wceq vz cv vy
      cv cF cfv wceq wa wa vx cv vy cv wceq cF cA wfn vx cv vz cv cF wbr vy cv
      vz cv cF wbr wa vx cv cA wcel vy cv cA wcel wa vx cv vz cv cF wbr vy cv
      vz cv cF wbr wa wa vx cv cA wcel vy cv cA wcel wa vz cv vx cv cF cfv wceq
      vz cv vy cv cF cfv wceq wa wa cF cA wfn vx cv vz cv cF wbr vy cv vz cv cF
      wbr wa vx cv cA wcel vy cv cA wcel wa cF cA wfn vx cv vz cv cF wbr vx cv
      cA wcel vy cv vz cv cF wbr vy cv cA wcel cF cA wfn vx cv cF cdm wcel vx
      cv cA wcel vx cv vz cv cF wbr cF cA wfn cF cdm cA vx cv cA cF fndm eleq2d
      vx cv vz cv cF vx visset breldm syl5bi cF cA wfn vy cv cF cdm wcel vy cv
      cA wcel vy cv vz cv cF wbr cF cA wfn cF cdm cA vy cv cA cF fndm eleq2d vy
      cv vz cv cF vy visset breldm syl5bi anim12d pm4.71rd cF cA wfn vx cv cA
      wcel vy cv cA wcel wa vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq wa
      vx cv vz cv cF wbr vy cv vz cv cF wbr wa cF cA wfn vx cv cA wcel vy cv cA
      wcel vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vz cv cF
      wbr vy cv vz cv cF wbr wa wb cF cA wfn vx cv cA wcel wa vz cv vx cv cF
      cfv wceq vx cv vz cv cF wbr cF cA wfn vy cv cA wcel wa vz cv vy cv cF cfv
      wceq vy cv vz cv cF wbr cF cA wfn vx cv cA wcel wa vx cv cF cfv vz cv
      wceq vx cv vz cv cF wbr vz cv vx cv cF cfv wceq cA vx cv vz cv cF vz
      visset fnbrfvb vz cv vx cv cF cfv eqcom syl5bb cF cA wfn vy cv cA wcel wa
      vy cv cF cfv vz cv wceq vy cv vz cv cF wbr vz cv vy cv cF cfv wceq cA vy
      cv vz cv cF vz visset fnbrfvb vz cv vy cv cF cfv eqcom syl5bb bi2anan9
      anandis pm5.32da bitr4d imbi1d vx cv cA wcel vy cv cA wcel wa vz cv vx cv
      cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq impexp syl6bb
      albidv vx cv cA wcel vy cv cA wcel wa vz cv vx cv cF cfv wceq vz cv vy cv
      cF cfv wceq wa vx cv vy cv wceq wi wi vz wal vx cv cA wcel vy cv cA wcel
      wa vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq wi
      vz wal wi vx cv cA wcel vy cv cA wcel wa vx cv cF cfv vy cv cF cfv wceq
      vx cv vy cv wceq wi wi vx cv cA wcel vy cv cA wcel wa vz cv vx cv cF cfv
      wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq wi vz 19.21v vz cv vx cv
      cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq wi vz wal vx cv
      cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vx cv cA wcel vy cv cA wcel
      wa vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq wi
      vz wal vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq wa vz wex vx cv vy
      cv wceq wi vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vz cv vx cv
      cF cfv wceq vz cv vy cv cF cfv wceq wa vx cv vy cv wceq vz 19.23v vx cv
      cF cfv vy cv cF cfv wceq vz cv vx cv cF cfv wceq vz cv vy cv cF cfv wceq
      wa vz wex vx cv vy cv wceq vz vx cv cF cfv vy cv cF cfv vx cv cF fvex
      eqvinc imbi1i bitr4i imbi2i bitri syl6bb 2albidv vx cv vz cv cF wbr vx
      wmo vz wal vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq wi
      vy wal vx wal vz wal vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv
      wceq wi vy wal vz wal vx wal vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx
      cv vy cv wceq wi vz wal vy wal vx wal vx cv vz cv cF wbr vx wmo vx cv vz
      cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq wi vy wal vx wal vz vx
      cv vz cv cF wbr vy cv vz cv cF wbr vx vy vx cv vy cv vz cv cF breq1 mo4
      albii vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq wi vy wal
      vz vx alcom vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq wi
      vy wal vz wal vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv wceq
      wi vz wal vy wal vx vx cv vz cv cF wbr vy cv vz cv cF wbr wa vx cv vy cv
      wceq wi vz vy alcom albii 3bitri vx cv cF cfv vy cv cF cfv wceq vx cv vy
      cv wceq wi vx vy cA cA r2al 3bitr4g syl pm5.32i bitri $.
      $( [29-Oct-1996] $)
  $}

  ${
    $d x y w v A $.  $d w v B $.  $d z w v F $.  $d x y z $.
    f1fvf.1 $e |- ( z e. F -> A. x z e. F ) $.
    f1fvf.2 $e |- ( z e. F -> A. y z e. F ) $.
    $( A one-to-one function in terms of function values.  Compare Theorem
       4.8(iv) of [Monk1] p. 43. $)
    dff13f $p |- ( F : A -1-1-> B <-> ( F : A --> B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      cA cB cF wf1 cA cB cF wf vw cv cF cfv vv cv cF cfv wceq vw cv vv cv wceq
      wi vv cA wral vw cA wral wa cA cB cF wf vx cv cF cfv vy cv cF cfv wceq vx
      cv vy cv wceq wi vy cA wral vx cA wral wa vw vv cA cB cF dff13 vw cv cF
      cfv vv cv cF cfv wceq vw cv vv cv wceq wi vv cA wral vw cA wral vx cv cF
      cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral cA cB cF
      wf vw cv cF cfv vv cv cF cfv wceq vw cv vv cv wceq wi vv cA wral vw cA
      wral vw cv cF cfv vy cv cF cfv wceq vw cv vy cv wceq wi vy cA wral vw cA
      wral vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA
      wral vw cv cF cfv vv cv cF cfv wceq vw cv vv cv wceq wi vv cA wral vw cv
      cF cfv vy cv cF cfv wceq vw cv vy cv wceq wi vy cA wral vw cA vw cv cF
      cfv vv cv cF cfv wceq vw cv vv cv wceq wi vw cv cF cfv vy cv cF cfv wceq
      vw cv vy cv wceq wi vv vy cA vw cv cF cfv vv cv cF cfv wceq vw cv vv cv
      wceq vy vy vz vz vw cv cF cfv vv cv cF cfv vy vz vw cv cF f1fvf.2 vz cv
      vw cv wcel vy ax-17 hbfv vy vz vv cv cF f1fvf.2 vz cv vv cv wcel vy ax-17
      hbfv hbeq vw cv vv cv wceq vy ax-17 hbim vw cv cF cfv vy cv cF cfv wceq
      vw cv vy cv wceq vv vw cv cF cfv vy cv cF cfv wceq vv ax-17 vw cv vy cv
      wceq vv ax-17 hbim vv cv vy cv wceq vw cv cF cfv vv cv cF cfv wceq vw cv
      cF cfv vy cv cF cfv wceq vw cv vv cv wceq vw cv vy cv wceq vv cv vy cv
      wceq vv cv cF cfv vy cv cF cfv vw cv cF cfv vv cv vy cv cF fveq2 eqeq2d
      vv cv vy cv vw cv eqeq2 imbi12d cbvral ralbii vw cv cF cfv vy cv cF cfv
      wceq vw cv vy cv wceq wi vy cA wral vx cv cF cfv vy cv cF cfv wceq vx cv
      vy cv wceq wi vy cA wral vw vx cA vw cv cF cfv vy cv cF cfv wceq vw cv vy
      cv wceq wi vx vy cA vy cv cA wcel vx ax-17 vw cv cF cfv vy cv cF cfv wceq
      vw cv vy cv wceq vx vx vz vz vw cv cF cfv vy cv cF cfv vx vz vw cv cF
      f1fvf.1 vz cv vw cv wcel vx ax-17 hbfv vx vz vy cv cF f1fvf.1 vz cv vy cv
      wcel vx ax-17 hbfv hbeq vw cv vy cv wceq vx ax-17 hbim hbral vx cv cF cfv
      vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vw ax-17 vw cv vx cv
      wceq vw cv cF cfv vy cv cF cfv wceq vw cv vy cv wceq wi vx cv cF cfv vy
      cv cF cfv wceq vx cv vy cv wceq wi vy cA vw cv vx cv wceq vw cv cF cfv vy
      cv cF cfv wceq vx cv cF cfv vy cv cF cfv wceq vw cv vy cv wceq vx cv vy
      cv wceq vw cv vx cv wceq vw cv cF cfv vx cv cF cfv vy cv cF cfv vw cv vx
      cv cF fveq2 eqeq1d vw cv vx cv vy cv eqeq1 imbi12d ralbidv cbvral bitri
      anbi2i bitri $.
      $( [31-Jul-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y F $.
    $( Equality of function values for a one-to-one function. $)
    f1fveq $p |- ( ( F : A -1-1-> B /\ ( C e. A /\ D e. A ) ) ->
                 ( ( F ` C ) = ( F ` D ) <-> C = D ) ) $=
      cA cB cF wf1 cC cA wcel cD cA wcel wa wa cC cF cfv cD cF cfv wceq cC cD
      wceq cC cA wcel cD cA wcel wa cA cB cF wf1 cC cF cfv cD cF cfv wceq cC cD
      wceq wi cA cB cF wf1 vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi
      wi cA cB cF wf1 cC cF cfv vy cv cF cfv wceq cC vy cv wceq wi wi cA cB cF
      wf1 cC cF cfv cD cF cfv wceq cC cD wceq wi wi vx vy cC cD cA cA vx cv cC
      wceq vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi cC cF cfv vy cv
      cF cfv wceq cC vy cv wceq wi cA cB cF wf1 vx cv cC wceq vx cv cF cfv vy
      cv cF cfv wceq cC cF cfv vy cv cF cfv wceq vx cv vy cv wceq cC vy cv wceq
      vx cv cC wceq vx cv cF cfv cC cF cfv vy cv cF cfv vx cv cC cF fveq2
      eqeq1d vx cv cC vy cv eqeq1 imbi12d imbi2d vy cv cD wceq cC cF cfv vy cv
      cF cfv wceq cC vy cv wceq wi cC cF cfv cD cF cfv wceq cC cD wceq wi cA cB
      cF wf1 vy cv cD wceq cC cF cfv vy cv cF cfv wceq cC cF cfv cD cF cfv wceq
      cC vy cv wceq cC cD wceq vy cv cD wceq vy cv cF cfv cD cF cfv cC cF cfv
      vy cv cD cF fveq2 eqeq2d vy cv cD cC eqeq2 imbi12d imbi2d cA cB cF wf1 vx
      cv cA wcel vy cv cA wcel wa vx cv cF cfv vy cv cF cfv wceq vx cv vy cv
      wceq wi cA cB cF wf1 vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi
      vy cA wral vx cA wral vx cv cA wcel vy cv cA wcel wa vx cv cF cfv vy cv
      cF cfv wceq vx cv vy cv wceq wi wi cA cB cF wf1 cA cB cF wf vx cv cF cfv
      vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral vx vy cA cB
      cF dff13 pm3.27bi vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vx
      vy cA cA ra42 syl com12 vtocl2ga impcom cC cD cF fveq2 impbid1 $.
      $( [11-Feb-1997] $)
  $}

  ${
    $d x y A $.  $d x y F $.
    $( A one-to-one onto function in terms of function values. $)
    dff1o6 $p |- ( F : A -1-1-onto-> B <-> ( F Fn A /\ ran F = B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      cA cB cF wf1o cA cB cF wf1 cA cB cF wfo wa cA cB cF wf vx cv cF cfv vy cv
      cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral wa cF cA wfn cF crn
      cB wceq wa wa cF cA wfn cF crn cB wceq vx cv cF cfv vy cv cF cfv wceq vx
      cv vy cv wceq wi vy cA wral vx cA wral w3a cA cB cF df-f1o cA cB cF wf1
      cA cB cF wf vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral
      vx cA wral wa cA cB cF wfo cF cA wfn cF crn cB wceq wa vx vy cA cB cF
      dff13 cA cB cF df-fo anbi12i cF cA wfn cF crn cB wceq vx cv cF cfv vy cv
      cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral w3a cF cA wfn cF
      crn cB wceq wa vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA
      wral vx cA wral wa cA cB cF wf cF cA wfn cF crn cB wceq wa wa vx cv cF
      cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral wa cA cB
      cF wf vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA
      wral wa cF cA wfn cF crn cB wceq wa wa cF cA wfn cF crn cB wceq vx cv cF
      cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral df-3an cF
      cA wfn cF crn cB wceq wa cA cB cF wf cF cA wfn cF crn cB wceq wa wa vx cv
      cF cfv vy cv cF cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral cF cA
      wfn cF crn cB wceq wa cA cB cF wf cF cA wfn cF crn cB wceq wa cF cA wfn
      cF crn cB wss wa cA cB cF wf cF crn cB wceq cF crn cB wss cF cA wfn cF
      crn cB eqimss anim2i cA cB cF df-f sylibr pm4.71ri anbi1i cA cB cF wf cF
      cA wfn cF crn cB wceq wa vx cv cF cfv vy cv cF cfv wceq vx cv vy cv wceq
      wi vy cA wral vx cA wral an23 3bitrri 3bitri $.
      $( [29-Mar-2008] $) $( [29-Mar-2008] $)
  $}

  $( The converse value of the value of a one-to-one onto function. $)
  f1ocnvfv1 $p |- ( ( F : A -1-1-onto-> B /\ C e. A ) ->
                 ( `' F ` ( F ` C ) ) = C ) $=
    cA cB cF wf1o cC cA wcel wa cC cF ccnv cF ccom cfv cC cid cA cres cfv cC cF
    cfv cF ccnv cfv cC cA cB cF wf1o cC cF ccnv cF ccom cfv cC cid cA cres cfv
    wceq cC cA wcel cA cB cF wf1o cC cF ccnv cF ccom cid cA cres cA cB cF
    f1ococnv1 fveq1d adantr cF ccnv wfun cA cB cF wf wa cC cA wcel cC cF ccnv
    cF ccom cfv cC cF cfv cF ccnv cfv wceq cA cB cF wf1o cF ccnv wfun cA cB cF
    wf cC cA wcel cC cF ccnv cF ccom cfv cC cF cfv cF ccnv cfv wceq cA cB cC cF
    ccnv cF fvco3 3expa cA cB cF wf1o cF ccnv wfun cA cB cF wf cA cB cF wf1o cB
    cA cF ccnv wf1o cF ccnv wfun cA cB cF f1ocnv cB cA cF ccnv f1ofun syl cA cB
    cF f1of jca sylan cC cA wcel cC cid cA cres cfv cC wceq cA cB cF wf1o cA cC
    fvresi adantl 3eqtr3d $.
    $( [21-May-2004] $) $( [20-May-2004] $)

  $( The value of the converse value of a one-to-one onto function. $)
  f1ocnvfv2 $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                 ( F ` ( `' F ` C ) ) = C ) $=
    cA cB cF wf1o cC cB wcel wa cC cF cF ccnv ccom cfv cC cid cB cres cfv cC cF
    ccnv cfv cF cfv cC cA cB cF wf1o cC cF cF ccnv ccom cfv cC cid cB cres cfv
    wceq cC cB wcel cA cB cF wf1o cC cF cF ccnv ccom cid cB cres cA cB cF
    f1ococnv2 fveq1d adantr cF wfun cB cA cF ccnv wf wa cC cB wcel cC cF cF
    ccnv ccom cfv cC cF ccnv cfv cF cfv wceq cA cB cF wf1o cF wfun cB cA cF
    ccnv wf cC cB wcel cC cF cF ccnv ccom cfv cC cF ccnv cfv cF cfv wceq cB cA
    cC cF cF ccnv fvco3 3expa cA cB cF wf1o cF wfun cB cA cF ccnv wf cA cB cF
    f1ofun cA cB cF wf1o cB cA cF ccnv wf1o cB cA cF ccnv wf cA cB cF f1ocnv cB
    cA cF ccnv f1of syl jca sylan cC cB wcel cC cid cB cres cfv cC wceq cA cB
    cF wf1o cB cC fvresi adantl 3eqtr3d $.
    $( [21-May-2004] $) $( [20-May-2004] $)

  $( Relationship between the value of a one-to-one onto function and the
     value of its converse.  (Contributed by Raph Levien, 10-Apr-2004.) $)
  f1ocnvfv $p |- ( ( F : A -1-1-onto-> B /\ C e. A ) ->
                  ( ( F ` C ) = D -> ( `' F ` D ) = C ) ) $=
    cA cB cF wf1o cC cA wcel wa cD cF ccnv cfv cC cF cfv cF ccnv cfv wceq cD cF
    ccnv cfv cC wceq cC cF cfv cD wceq cA cB cF wf1o cC cA wcel wa cC cF cfv cF
    ccnv cfv cC cD cF ccnv cfv cA cB cC cF f1ocnvfv1 eqeq2d cD cF ccnv cfv cC
    cF cfv cF ccnv cfv wceq cD cC cF cfv cD cC cF cfv cF ccnv fveq2 eqcoms
    syl5bi $.
    $( [21-May-2004] $) $( [10-Apr-2004] $)

  $( Relationship between the value of a one-to-one onto function and the
     value of its converse. $)
  f1ocnvfvb $p |- ( ( F : A -1-1-onto-> B /\ C e. A /\ D e. B ) ->
                  ( ( F ` C ) = D <-> ( `' F ` D ) = C ) ) $=
    cA cB cF wf1o cC cA wcel cD cB wcel w3a cC cF cfv cD wceq cD cF ccnv cfv cC
    wceq cA cB cF wf1o cC cA wcel cC cF cfv cD wceq cD cF ccnv cfv cC wceq wi
    cD cB wcel cA cB cC cD cF f1ocnvfv 3adant3 cA cB cF wf1o cD cB wcel cD cF
    ccnv cfv cC wceq cC cF cfv cD wceq wi cC cA wcel cA cB cF wf1o cD cB wcel
    wa cC cF cfv cD cF ccnv cfv cF cfv wceq cC cF cfv cD wceq cD cF ccnv cfv cC
    wceq cA cB cF wf1o cD cB wcel wa cD cF ccnv cfv cF cfv cD cC cF cfv cA cB
    cD cF f1ocnvfv2 eqeq2d cC cF cfv cD cF ccnv cfv cF cfv wceq cC cD cF ccnv
    cfv cC cD cF ccnv cfv cF fveq2 eqcoms syl5bi 3adant2 impbid $.
    $( [9-Aug-2006] $) $( [20-May-2004] $)

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( There is one domain element for each value of a one-to-one onto
       function. $)
    f1ofveu $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                  E! x e. A ( F ` x ) = C ) $=
      cA cB cF wf1o cC cB wcel wa vx cv cF cfv cC wceq vx cA wreu cC vx cv cop
      cF ccnv wcel vx cA wreu cB cA cF ccnv wf cC cB wcel cC vx cv cop cF ccnv
      wcel vx cA wreu cA cB cF wf1o vx cB cA cC cF ccnv feu cA cB cF wf1o cB cA
      cF ccnv wf1o cB cA cF ccnv wf cA cB cF f1ocnv cB cA cF ccnv f1of syl
      sylan cA cB cF wf1o cC cB wcel wa vx cv cF cfv cC wceq cC vx cv cop cF
      ccnv wcel vx cA cA cB cF wf1o cC cB wcel vx cv cA wcel vx cv cF cfv cC
      wceq cC vx cv cop cF ccnv wcel wb cA cB cF wf1o cC cB wcel vx cv cA wcel
      w3a vx cv cF cfv cC wceq cC cF ccnv cfv vx cv wceq cC vx cv cop cF ccnv
      wcel cA cB cF wf1o vx cv cA wcel cC cB wcel vx cv cF cfv cC wceq cC cF
      ccnv cfv vx cv wceq wb cA cB vx cv cC cF f1ocnvfvb 3com23 cF ccnv cB wfn
      cC cB wcel vx cv cA wcel cC cF ccnv cfv vx cv wceq cC vx cv cop cF ccnv
      wcel wb cA cB cF wf1o cF ccnv cB wfn cC cB wcel cC cF ccnv cfv vx cv wceq
      cC vx cv cop cF ccnv wcel wb vx cv cA wcel cB cC vx cv cF ccnv vx visset
      fnopfvb 3adant3 cA cB cF wf1o cF cA wfn cF ccnv cB wfn cA cB cF dff1o4
      pm3.27bi syl3an1 bitrd 3expa reubidva mpbird $.
      $( [15-Aug-2006] $) $( [26-May-2006] $)

    $( Value of the converse of a one-to-one onto function. $)
    f1ocnvfv3 $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                  ( `' F ` C ) = U. { x e. A | ( F ` x ) = C } ) $=
      cA cB cF wf1o cC cB wcel wa cC cF ccnv cfv cF cfv cC wceq cC cF ccnv cfv
      vx cv cF cfv cC wceq vx cA crab cuni wceq cA cB cC cF f1ocnvfv2 cC cF
      ccnv cfv cA wcel vx cv cF cfv cC wceq vx cA wreu cC cF ccnv cfv cF cfv cC
      wceq cC cF ccnv cfv vx cv cF cfv cC wceq vx cA crab cuni wceq wb cA cB cF
      wf1o cC cB wcel wa cC cF ccnv cfv cA wcel vx cv cF cfv cC wceq vx cA wreu
      wa cC cF ccnv cfv cF cfv cC wceq vx cv cF cfv cC wceq vx cA crab cuni cC
      cF ccnv cfv wceq cC cF ccnv cfv vx cv cF cfv cC wceq vx cA crab cuni wceq
      vx cv cF cfv cC wceq cC cF ccnv cfv cF cfv cC wceq vx cA cC cF ccnv cfv
      vx cv cC cF ccnv cfv wceq vx cv cF cfv cC cF ccnv cfv cF cfv cC vx cv cC
      cF ccnv cfv cF fveq2 eqeq1d reuuni2 vx cv cF cfv cC wceq vx cA crab cuni
      cC cF ccnv cfv eqcom syl6bb cB cA cF ccnv wf cC cB wcel cC cF ccnv cfv cA
      wcel cA cB cF wf1o cB cA cC cF ccnv ffvelrn cA cB cF wf1o cB cA cF ccnv
      wf1o cB cA cF ccnv wf cA cB cF f1ocnv cB cA cF ccnv f1of syl sylan vx cA
      cB cC cF f1ofveu sylanc mpbid $.
      $( [3-Nov-2006] $) $( [26-May-2006] $)
  $}

  $( The value of the converse of a one-to-one onto function belongs to its
     domain. $)
     f1ocnvdm $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                    ( `' F ` C ) e. A ) $=
       cB cA cF ccnv wf cC cB wcel cC cF ccnv cfv cA wcel cA cB cF wf1o cB cA
       cC cF ccnv ffvelrn cA cB cF wf1o cB cA cF ccnv wf1o cB cA cF ccnv wf cA
       cB cF f1ocnv cB cA cF ccnv f1of syl sylan $.
       $( [9-Jul-2006] $) $( [26-May-2006] $)

  ${
    $d x A $.  $d y B $.  $d x y F $.  $d y ph $.  $d x ps $.
    cbvfo.1 $e |- ( ( F ` x ) = y -> ( ph <-> ps ) ) $.
    $( Change bound variable between domain and range of function. $)
    cbvfo $p |- ( F : A -onto-> B -> ( A. x e. A ph <-> A. y e. B ps ) ) $=
      cA cB cF wfo wph vx cF cdm wral wps vy cF crn wral wph vx cA wral wps vy
      cB wral cA cB cF wfo cF wfun wph vx cF cdm wral wps vy cF crn wral wb cA
      cB cF fofun cF wfun vx cv cF cdm wcel wph wi vx wal vy cv cF crn wcel wps
      wi vy wal wph vx cF cdm wral wps vy cF crn wral cF wfun vx cv cF cdm wcel
      wph wi vx wal vy cv cF crn wcel wps wi vy wal cF wfun vx cv cF cdm wcel
      wph wi vx wal vy cv cF crn wcel wps wi vy cF wfun vy cv cF crn wcel vx cv
      cF cdm wcel vx cv cF cfv vy cv wceq wa vx wex vx cv cF cdm wcel wph wi vx
      wal wps cF wfun vx cv vy cv cF wbr vx wex vx cv cF cdm wcel vx cv cF cfv
      vy cv wceq wa vx wex vy cv cF crn wcel cF wfun vx cv vy cv cF wbr vx cv
      cF cdm wcel vx cv cF cfv vy cv wceq wa vx cF wfun vx cv vy cv cF wbr vx
      cv cF cdm wcel vx cv cF cfv vy cv wceq vx cv vy cv cF wbr vx cv cF cdm
      wcel wi cF wfun vx cv vy cv cF vx visset breldm a1i vx cv vy cv cF vy
      visset funbrfv jcad 19.22dv vx vy cv cF vy visset elrn syl5ib vx cv cF
      cdm wcel wph wi vx wal vx cv cF cdm wcel vx cv cF cfv vy cv wceq wa wps
      vx vx cv cF cdm wcel wph wi vx hba1 wps vx ax-17 vx cv cF cdm wcel wph wi
      vx cv cF cdm wcel vx cv cF cfv vy cv wceq wa wps wi vx vx cv cF cdm wcel
      wph wi vx cv cF cdm wcel vx cv cF cfv vy cv wceq wps wph vx cv cF cfv vy
      cv wceq wps wi vx cv cF cdm wcel vx cv cF cfv vy cv wceq wph wps cbvfo.1
      biimpcd imim2i imp3a a4s 19.23ad syl9 19.21adv cF wfun vy cv cF crn wcel
      wps wi vy wal vx cv cF cdm wcel wph wi vx cF wfun vx cv cF cdm wcel vy cv
      cF crn wcel vx cv cF cfv vy cv wceq wa vy wex vy cv cF crn wcel wps wi vy
      wal wph cF wfun vx cv vy cv cF wbr vy wex vy cv cF crn wcel vx cv cF cfv
      vy cv wceq wa vy wex vx cv cF cdm wcel cF wfun vx cv vy cv cF wbr vy cv
      cF crn wcel vx cv cF cfv vy cv wceq wa vy cF wfun vx cv vy cv cF wbr vy
      cv cF crn wcel vx cv cF cfv vy cv wceq vx cv vy cv cF wbr vy cv cF crn
      wcel wi cF wfun vx cv vy cv cF vx visset vy visset brelrn a1i vx cv vy cv
      cF vy visset funbrfv jcad 19.22dv vy vx cv cF vx visset eldm syl5ib vy cv
      cF crn wcel wps wi vy wal vy cv cF crn wcel vx cv cF cfv vy cv wceq wa
      wph vy vy cv cF crn wcel wps wi vy hba1 wph vy ax-17 vy cv cF crn wcel
      wps wi vy cv cF crn wcel vx cv cF cfv vy cv wceq wa wph wi vy vy cv cF
      crn wcel wps wi vy cv cF crn wcel vx cv cF cfv vy cv wceq wph wps vx cv
      cF cfv vy cv wceq wph wi vy cv cF crn wcel vx cv cF cfv vy cv wceq wph
      wps cbvfo.1 biimprcd imim2i imp3a a4s 19.23ad syl9 19.21adv impbid wph vx
      cF cdm df-ral wps vy cF crn df-ral 3bitr4g syl cA cB cF wfo cA cB cF wf
      cF cdm cA wceq wph vx cF cdm wral wph vx cA wral wb cA cB cF fof cA cB cF
      fdm wph vx cF cdm cA raleq1 3syl cA cB cF wfo wps vy cF crn cB cA cB cF
      forn raleq1d 3bitr3d $.
      $( [23-Feb-1997] $)

    $( Change bound variable between domain and range of function. $)
    cbvexfo $p |- ( F : A -onto-> B -> ( E. x e. A ph <-> E. y e. B ps ) ) $=
      cA cB cF wfo wph wn vx cA wral wn wps wn vy cB wral wn wph vx cA wrex wps
      vy cB wrex cA cB cF wfo wph wn vx cA wral wps wn vy cB wral wph wn wps wn
      vx vy cA cB cF vx cv cF cfv vy cv wceq wph wps cbvfo.1 notbid cbvfo
      notbid wph vx cA dfrex2 wps vy cB dfrex2 3bitr4g $.
      $( [23-Feb-1997] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y H $.  $d x y G $.
    $d x y R $.  $d x y S $.  $d x y T $.
    $( Equality theorem for isomorphisms. $)
    isoeq1 $p |- ( H = G ->
          ( H Isom R , S ( A , B ) <-> G Isom R , S ( A , B ) ) ) $=
      cH cG wceq cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS
      wbr wb vy cA wral vx cA wral wa cA cB cG wf1o vx cv vy cv cR wbr vx cv cG
      cfv vy cv cG cfv cS wbr wb vy cA wral vx cA wral wa cA cB cR cS cH wiso
      cA cB cR cS cG wiso cH cG wceq cA cB cH wf1o cA cB cG wf1o vx cv vy cv cR
      wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vx cv vy cv
      cR wbr vx cv cG cfv vy cv cG cfv cS wbr wb vy cA wral vx cA wral cA cB cH
      cG f1oeq1 cH cG wceq vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr
      wb vx cv vy cv cR wbr vx cv cG cfv vy cv cG cfv cS wbr wb vx vy cA cA cH
      cG wceq vx cv cH cfv vy cv cH cfv cS wbr vx cv cG cfv vy cv cG cfv cS wbr
      vx cv vy cv cR wbr cH cG wceq vx cv cH cfv vx cv cG cfv vy cv cH cfv vy
      cv cG cfv cS vx cv cH cG fveq1 vy cv cH cG fveq1 breq12d bibi2d 2ralbidv
      anbi12d vx vy cA cB cR cS cH df-iso vx vy cA cB cR cS cG df-iso 3bitr4g
      $.
      $( [23-May-2004] $) $( [17-May-2004] $)

    $( Equality theorem for isomorphisms. $)
    isoeq2 $p |- ( R = T ->
          ( H Isom R , S ( A , B ) <-> H Isom T , S ( A , B ) ) ) $=
      cR cT wceq cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS
      wbr wb vy cA wral vx cA wral wa cA cB cH wf1o vx cv vy cv cT wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa cA cB cR cS cH wiso
      cA cB cT cS cH wiso cR cT wceq vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral vx cv vy cv cT wbr vx cv cH cfv vy cv
      cH cfv cS wbr wb vy cA wral vx cA wral cA cB cH wf1o cR cT wceq vx cv vy
      cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vx cv vy cv cT wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vx vy cA cA cR cT wceq vx cv vy cv cR wbr vx
      cv vy cv cT wbr vx cv cH cfv vy cv cH cfv cS wbr vx cv vy cv cR cT breq
      bibi1d 2ralbidv anbi2d vx vy cA cB cR cS cH df-iso vx vy cA cB cT cS cH
      df-iso 3bitr4g $.
      $( [23-May-2004] $) $( [17-May-2004] $)

    $( Equality theorem for isomorphisms. $)
    isoeq3 $p |- ( S = T ->
          ( H Isom R , S ( A , B ) <-> H Isom R , T ( A , B ) ) ) $=
      cS cT wceq cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS
      wbr wb vy cA wral vx cA wral wa cA cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cT wbr wb vy cA wral vx cA wral wa cA cB cR cS cH wiso
      cA cB cR cT cH wiso cS cT wceq vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral vx cv vy cv cR wbr vx cv cH cfv vy cv
      cH cfv cT wbr wb vy cA wral vx cA wral cA cB cH wf1o cS cT wceq vx cv vy
      cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cT wbr wb vx vy cA cA cS cT wceq vx cv cH cfv vy cv cH
      cfv cS wbr vx cv cH cfv vy cv cH cfv cT wbr vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS cT breq bibi2d 2ralbidv anbi2d vx vy cA cB cR cS cH
      df-iso vx vy cA cB cR cT cH df-iso 3bitr4g $.
      $( [29-May-2004] $) $( [17-May-2004] $)

    $( Equality theorem for isomorphisms. $)
    isoeq4 $p |- ( A = C ->
          ( H Isom R , S ( A , B ) <-> H Isom R , S ( C , B ) ) ) $=
      cA cC wceq cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS
      wbr wb vy cA wral vx cA wral wa cC cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cC wral vx cC wral wa cA cB cR cS cH wiso
      cC cB cR cS cH wiso cA cC wceq cA cB cH wf1o cC cB cH wf1o vx cv vy cv cR
      wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vx cv vy cv
      cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cC wral vx cC wral cA cC cB
      cH f1oeq2 vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA
      wral vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cC wral vx
      cA cC vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA cC
      raleq1 raleqd anbi12d vx vy cA cB cR cS cH df-iso vx vy cC cB cR cS cH
      df-iso 3bitr4g $.
      $( [29-May-2004] $) $( [17-May-2004] $)

    $( Equality theorem for isomorphisms. $)
    isoeq5 $p |- ( B = C ->
          ( H Isom R , S ( A , B ) <-> H Isom R , S ( A , C ) ) ) $=
      cB cC wceq cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS
      wbr wb vy cA wral vx cA wral wa cA cC cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa cA cB cR cS cH wiso
      cA cC cR cS cH wiso cB cC wceq cA cB cH wf1o cA cC cH wf1o vx cv vy cv cR
      wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral cB cC cA cH
      f1oeq3 anbi1d vx vy cA cB cR cS cH df-iso vx vy cA cC cR cS cH df-iso
      3bitr4g $.
      $( [29-May-2004] $) $( [17-May-2004] $)
  $}


  ${
    $d y z w H $.  $d y z w R $.  $d y z w S $.  $d y z w A $.  $d y z w B $.
    $d x y z w $.
    hbiso.1 $e |- ( y e. H -> A. x y e. H ) $.
    hbiso.2 $e |- ( y e. R -> A. x y e. R ) $.
    hbiso.3 $e |- ( y e. S -> A. x y e. S ) $.
    hbiso.4 $e |- ( y e. A -> A. x y e. A ) $.
    hbiso.5 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for an isomorphism. $)
    hbiso $p |- ( H Isom R , S ( A , B ) -> A. x H Isom R , S ( A , B ) ) $=
      cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw
      cA wral vz cA wral wa cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv
      cH cfv cS wbr wb vw cA wral vz cA wral wa vx wal cA cB cR cS cH wiso cA
      cB cR cS cH wiso vx wal cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw
      cv cH cfv cS wbr wb vw cA wral vz cA wral vx vx vy cA cB cH hbiso.1
      hbiso.4 hbiso.5 hbf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr
      wb vw cA wral vx vz cA vx vy vy vz cv cA vy cv vz cv wcel vx ax-17
      hbiso.4 hbel vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vx vw
      cA vx vy vy vw cv cA vy cv vw cv wcel vx ax-17 hbiso.4 hbel vz cv vw cv
      cR wbr vz cv cH cfv vw cv cH cfv cS wbr vx vx vy vz cv vw cv cR vy cv vz
      cv wcel vx ax-17 hbiso.2 vy cv vw cv wcel vx ax-17 hbbr vx vy vz cv cH
      cfv vw cv cH cfv cS vx vy vz cv cH hbiso.1 vy cv vz cv wcel vx ax-17 hbfv
      hbiso.3 vx vy vw cv cH hbiso.1 vy cv vw cv wcel vx ax-17 hbfv hbbr hbbi
      hbral hbral hban vz vw cA cB cR cS cH df-iso cA cB cR cS cH wiso cA cB cH
      wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz
      cA wral wa vx vz vw cA cB cR cS cH df-iso albii 3imtr4i $.
      $( [29-May-2004] $) $( [17-May-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $( An isomorphism is a one-to-one onto function. $)
    isof1o $p |- ( H Isom R , S ( A , B ) -> H : A -1-1-onto-> B ) $=
      cA cB cR cS cH wiso cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv
      cH cfv cS wbr wb vy cA wral vx cA wral vx vy cA cB cR cS cH df-iso
      pm3.26bi $.
      $( [29-May-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $d x y C $.  $d x y D $.
    $( An isomorphism connects binary relations via its function values. $)
    isorel $p |- ( ( H Isom R , S ( A , B ) /\ ( C e. A /\ D e. A ) ) ->
                 ( C R D <-> ( H ` C ) S ( H ` D ) ) ) $=
      cA cB cR cS cH wiso cC cA wcel cD cA wcel wa cC cD cR wbr cC cH cfv cD cH
      cfv cS wbr wb cC cA wcel cD cA wcel wa vx cv vy cv cR wbr vx cv cH cfv vy
      cv cH cfv cS wbr wb vy cA wral vx cA wral cC cD cR wbr cC cH cfv cD cH
      cfv cS wbr wb cA cB cR cS cH wiso vx cv vy cv cR wbr vx cv cH cfv vy cv
      cH cfv cS wbr wb cC cD cR wbr cC cH cfv cD cH cfv cS wbr wb cC vy cv cR
      wbr cC cH cfv vy cv cH cfv cS wbr wb vx vy cC cD cA cA vx cv cC wceq vx
      cv vy cv cR wbr cC vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr cC cH
      cfv vy cv cH cfv cS wbr vx cv cC vy cv cR breq1 vx cv cC wceq vx cv cH
      cfv cC cH cfv vy cv cH cfv cS vx cv cC cH fveq2 breq1d bibi12d vy cv cD
      wceq cC vy cv cR wbr cC cD cR wbr cC cH cfv vy cv cH cfv cS wbr cC cH cfv
      cD cH cfv cS wbr vy cv cD cC cR breq2 vy cv cD wceq vy cv cH cfv cD cH
      cfv cC cH cfv cS vy cv cD cH fveq2 breq2d bibi12d rcla42v cA cB cR cS cH
      wiso cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb
      vy cA wral vx cA wral vx vy cA cB cR cS cH df-iso pm3.27bi syl5com imp $.
      $( [31-May-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y R $.
    $( Identity law for isomorphism.  Proposition 6.30(1) of [TakeutiZaring]
       p. 33. $)
    isoid $p |- ( _I |` A ) Isom R , R ( A , A ) $=
      cA cA cR cR cid cA cres wiso cA cA cid cA cres wf1o vx cv vy cv cR wbr vx
      cv cid cA cres cfv vy cv cid cA cres cfv cR wbr wb vy cA wral vx cA wral
      vx vy cA cA cR cR cid cA cres df-iso cA f1oi vx cv vy cv cR wbr vx cv cid
      cA cres cfv vy cv cid cA cres cfv cR wbr wb vx vy cA vx cv cA wcel vy cv
      cA wcel wa vx cv cid cA cres cfv vy cv cid cA cres cfv cR wbr vx cv vy cv
      cR wbr vx cv cA wcel vy cv cA wcel vx cv cid cA cres cfv vx cv vy cv cid
      cA cres cfv vy cv cR cA vx cv fvresi cA vy cv fvresi breqan12d bicomd
      rgen2a mpbir2an $.
      $( [2-May-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w R $.  $d x y z w S $.
    $d x y z w H $.
    $( Converse law for isomorphism.  Proposition 6.30(2) of [TakeutiZaring]
       p. 33. $)
    isocnv $p |- ( H Isom R , S ( A , B ) -> `' H Isom S , R ( B , A ) ) $=
      cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy
      cA wral vx cA wral wa cB cA cH ccnv wf1o vz cv vw cv cS wbr vz cv cH ccnv
      cfv vw cv cH ccnv cfv cR wbr wb vw cB wral vz cB wral wa cA cB cR cS cH
      wiso cB cA cS cR cH ccnv wiso cA cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa cB cA cH ccnv wf1o vz
      cv vw cv cS wbr vz cv cH ccnv cfv vw cv cH ccnv cfv cR wbr wb vw cB wral
      vz cB wral cA cB cH wf1o cB cA cH ccnv wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral cA cB cH f1ocnv adantr
      cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy
      cA wral vx cA wral wa vz cv vw cv cS wbr vz cv cH ccnv cfv vw cv cH ccnv
      cfv cR wbr wb vw cB wral vz cB cA cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa vz cv cB wcel vz cv
      vw cv cS wbr vz cv cH ccnv cfv vw cv cH ccnv cfv cR wbr wb vw cB cA cB cH
      wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx
      cA wral wa vz cv cB wcel vw cv cB wcel vz cv vw cv cS wbr vz cv cH ccnv
      cfv vw cv cH ccnv cfv cR wbr wb cA cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa vz cv cB wcel vw cv
      cB wcel wa wa vz cv cH ccnv cfv cH cfv vw cv cH ccnv cfv cH cfv cS wbr vz
      cv vw cv cS wbr vz cv cH ccnv cfv vw cv cH ccnv cfv cR wbr cA cB cH wf1o
      vz cv cB wcel vw cv cB wcel wa vz cv cH ccnv cfv cH cfv vw cv cH ccnv cfv
      cH cfv cS wbr vz cv vw cv cS wbr wb vx cv vy cv cR wbr vx cv cH cfv vy cv
      cH cfv cS wbr wb vy cA wral vx cA wral cA cB cH wf1o vz cv cB wcel vw cv
      cB wcel wa wa vz cv cH ccnv cfv cH cfv vz cv vw cv cH ccnv cfv cH cfv vw
      cv cS cA cB cH wf1o vz cv cB wcel vz cv cH ccnv cfv cH cfv vz cv wceq vw
      cv cB wcel cA cB vz cv cH f1ocnvfv2 adantrr cA cB cH wf1o vw cv cB wcel
      vw cv cH ccnv cfv cH cfv vw cv wceq vz cv cB wcel cA cB vw cv cH
      f1ocnvfv2 adantrl breq12d adantlr cB cA cH ccnv wf vx cv vy cv cR wbr vx
      cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vz cv cB wcel vw
      cv cB wcel wa vz cv cH ccnv cfv cH cfv vw cv cH ccnv cfv cH cfv cS wbr vz
      cv cH ccnv cfv vw cv cH ccnv cfv cR wbr wb cA cB cH wf1o cB cA cH ccnv wf
      vz cv cB wcel vw cv cB wcel wa vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral vz cv cH ccnv cfv cH cfv vw cv cH
      ccnv cfv cH cfv cS wbr vz cv cH ccnv cfv vw cv cH ccnv cfv cR wbr wb vz
      cv cH ccnv cfv cA wcel vw cv cH ccnv cfv cA wcel wa vx cv vy cv cR wbr vx
      cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vz cv cH ccnv cfv
      cH cfv vw cv cH ccnv cfv cH cfv cS wbr vz cv cH ccnv cfv vw cv cH ccnv
      cfv cR wbr wb cB cA cH ccnv wf vz cv cB wcel vw cv cB wcel wa wa vz cv cH
      ccnv cfv cA wcel vw cv cH ccnv cfv cA wcel wa vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vz cv cH ccnv cfv cH cfv
      vw cv cH ccnv cfv cH cfv cS wbr vz cv cH ccnv cfv vw cv cH ccnv cfv cR
      wbr wb vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vz cv cH
      ccnv cfv cH cfv vw cv cH ccnv cfv cH cfv cS wbr vz cv cH ccnv cfv vw cv
      cH ccnv cfv cR wbr wb vz cv cH ccnv cfv cH cfv vy cv cH cfv cS wbr vz cv
      cH ccnv cfv vy cv cR wbr wb vx vy vz cv cH ccnv cfv vw cv cH ccnv cfv cA
      cA vx cv vz cv cH ccnv cfv wceq vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vz cv cH ccnv cfv vy cv cR wbr vz cv cH ccnv cfv cH cfv vy
      cv cH cfv cS wbr wb vz cv cH ccnv cfv cH cfv vy cv cH cfv cS wbr vz cv cH
      ccnv cfv vy cv cR wbr wb vx cv vz cv cH ccnv cfv wceq vx cv vy cv cR wbr
      vz cv cH ccnv cfv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr vz cv cH
      ccnv cfv cH cfv vy cv cH cfv cS wbr vx cv vz cv cH ccnv cfv vy cv cR
      breq1 vx cv vz cv cH ccnv cfv wceq vx cv cH cfv vz cv cH ccnv cfv cH cfv
      vy cv cH cfv cS vx cv vz cv cH ccnv cfv cH fveq2 breq1d bibi12d vz cv cH
      ccnv cfv vy cv cR wbr vz cv cH ccnv cfv cH cfv vy cv cH cfv cS wbr bicom
      syl6bb vy cv vw cv cH ccnv cfv wceq vz cv cH ccnv cfv cH cfv vy cv cH cfv
      cS wbr vz cv cH ccnv cfv cH cfv vw cv cH ccnv cfv cH cfv cS wbr vz cv cH
      ccnv cfv vy cv cR wbr vz cv cH ccnv cfv vw cv cH ccnv cfv cR wbr vy cv vw
      cv cH ccnv cfv wceq vy cv cH cfv vw cv cH ccnv cfv cH cfv vz cv cH ccnv
      cfv cH cfv cS vy cv vw cv cH ccnv cfv cH fveq2 breq2d vy cv vw cv cH ccnv
      cfv vz cv cH ccnv cfv cR breq2 bibi12d rcla42v imp cB cA cH ccnv wf vz cv
      cB wcel vw cv cB wcel vz cv cH ccnv cfv cA wcel vw cv cH ccnv cfv cA wcel
      wa cB cA cH ccnv wf vz cv cB wcel wa vz cv cH ccnv cfv cA wcel cB cA cH
      ccnv wf vw cv cB wcel wa vw cv cH ccnv cfv cA wcel cB cA vz cv cH ccnv
      ffvelrn cB cA vw cv cH ccnv ffvelrn anim12i anandis sylan an1rs cA cB cH
      wf1o cB cA cH ccnv wf1o cB cA cH ccnv wf cA cB cH f1ocnv cB cA cH ccnv
      f1of syl sylanl1 bitr3d exp32 r19.21adv r19.21aiv jca vx vy cA cB cR cS
      cH df-iso vz vw cB cA cS cR cH ccnv df-iso 3imtr4i $.
      $( [30-May-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u R $.  $d x y z w v u S $.  $d x y z w v u T $.
    $d x y z w v u G $.  $d x y z w v u H $.
    $( Composition (transitive) law for isomorphism.  Proposition 6.30(3) of
       [TakeutiZaring] p. 33. $)
    isotr $p |- ( ( H Isom R , S ( A , B ) /\ G Isom S , T ( B , C ) ) ->
               ( G o. H ) Isom R , T ( A , C ) ) $=
      cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw
      cA wral vz cA wral wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv
      cG cfv cT wbr wb vu cB wral vv cB wral wa wa cA cC cG cH ccom wf1o vx cv
      vy cv cR wbr vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr wb vy cA
      wral vx cA wral wa cA cB cR cS cH wiso cB cC cS cT cG wiso wa cA cC cR cT
      cG cH ccom wiso cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH
      cfv cS wbr wb vw cA wral vz cA wral wa cB cC cG wf1o vv cv vu cv cS wbr
      vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral wa wa cA cC cG
      cH ccom wf1o vx cv vy cv cR wbr vx cv cG cH ccom cfv vy cv cG cH ccom cfv
      cT wbr wb vy cA wral vx cA wral cA cB cH wf1o vz cv vw cv cR wbr vz cv cH
      cfv vw cv cH cfv cS wbr wb vw cA wral vz cA wral wa cB cC cG wf1o vv cv
      vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral wa
      wa cB cC cG wf1o cA cB cH wf1o wa cA cC cG cH ccom wf1o cB cC cG wf1o vv
      cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral
      wa cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb
      vw cA wral vz cA wral wa cB cC cG wf1o cA cB cH wf1o wa cB cC cG wf1o vv
      cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral
      wa cB cC cG wf1o cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH
      cfv cS wbr wb vw cA wral vz cA wral wa cA cB cH wf1o cB cC cG wf1o vv cv
      vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral
      pm3.26 cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr
      wb vw cA wral vz cA wral pm3.26 anim12i ancoms cA cB cC cG cH f1oco syl
      cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw
      cA wral vz cA wral wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv
      cG cfv cT wbr wb vu cB wral vv cB wral wa wa vx cv vy cv cR wbr vx cv cG
      cH ccom cfv vy cv cG cH ccom cfv cT wbr wb vy cA wral vx cA cA cB cH wf1o
      vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz cA
      wral wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr
      wb vu cB wral vv cB wral wa wa vx cv cA wcel vx cv vy cv cR wbr vx cv cG
      cH ccom cfv vy cv cG cH ccom cfv cT wbr wb vy cA cA cB cH wf1o vz cv vw
      cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz cA wral wa cB
      cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB
      wral vv cB wral wa wa vx cv cA wcel vy cv cA wcel vx cv vy cv cR wbr vx
      cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr wb cA cB cH wf1o vz cv vw
      cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz cA wral wa cB
      cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB
      wral vv cB wral wa wa vx cv cA wcel vy cv cA wcel wa wa vx cv cH cfv vy
      cv cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr vx cv vy
      cv cR wbr vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr cA cB cH wf1o
      vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz cA
      wral wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr
      wb vu cB wral vv cB wral wa wa vx cv cA wcel vy cv cA wcel wa vx cv cH
      cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb
      cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw
      cA wral vz cA wral wa vx cv cA wcel vy cv cA wcel wa vx cv cH cfv cB wcel
      vy cv cH cfv cB wcel wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu
      cv cG cfv cT wbr wb vu cB wral vv cB wral wa vx cv cH cfv vy cv cH cfv cS
      wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb cA cB cH wf1o vx cv
      cA wcel vy cv cA wcel wa vx cv cH cfv cB wcel vy cv cH cfv cB wcel wa wi
      vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz cA
      wral cA cB cH wf1o cA cB cH wf vx cv cA wcel vy cv cA wcel wa vx cv cH
      cfv cB wcel vy cv cH cfv cB wcel wa wi cA cB cH f1of cA cB cH wf vx cv cA
      wcel vx cv cH cfv cB wcel vy cv cA wcel vy cv cH cfv cB wcel cA cB cH wf
      vx cv cA wcel vx cv cH cfv cB wcel cA cB vx cv cH ffvelrn ex cA cB cH wf
      vy cv cA wcel vy cv cH cfv cB wcel cA cB vy cv cH ffvelrn ex anim12d syl
      adantr vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral
      vv cB wral vx cv cH cfv cB wcel vy cv cH cfv cB wcel wa vx cv cH cfv vy
      cv cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb wi cB
      cC cG wf1o vx cv cH cfv cB wcel vy cv cH cfv cB wcel wa vv cv vu cv cS
      wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral vx cv cH
      cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb
      vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vx cv cH cfv vy cv
      cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb vx cv cH
      cfv vu cv cS wbr vx cv cH cfv cG cfv vu cv cG cfv cT wbr wb vv vu vx cv
      cH cfv vy cv cH cfv cB cB vv cv vx cv cH cfv wceq vv cv vu cv cS wbr vx
      cv cH cfv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr vx cv cH cfv cG
      cfv vu cv cG cfv cT wbr vv cv vx cv cH cfv vu cv cS breq1 vv cv vx cv cH
      cfv wceq vv cv cG cfv vx cv cH cfv cG cfv vu cv cG cfv cT vv cv vx cv cH
      cfv cG fveq2 breq1d bibi12d vu cv vy cv cH cfv wceq vx cv cH cfv vu cv cS
      wbr vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv vu cv cG cfv cT
      wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr vu cv vy cv cH cfv vx
      cv cH cfv cS breq2 vu cv vy cv cH cfv wceq vu cv cG cfv vy cv cH cfv cG
      cfv vx cv cH cfv cG cfv cT vu cv vy cv cH cfv cG fveq2 breq2d bibi12d
      rcla42v com12 adantl sylan9 imp cA cB cH wf1o vz cv vw cv cR wbr vz cv cH
      cfv vw cv cH cfv cS wbr wb vw cA wral vz cA wral wa vx cv cA wcel vy cv
      cA wcel wa vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb cB cC
      cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb vu cB wral
      vv cB wral wa vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw
      cA wral vz cA wral vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx
      cv cH cfv vy cv cH cfv cS wbr wb cA cB cH wf1o vx cv cA wcel vy cv cA
      wcel wa vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral
      vz cA wral vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vz cv
      vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vx cv vy cv cR wbr vx cv
      cH cfv vy cv cH cfv cS wbr wb vx cv vw cv cR wbr vx cv cH cfv vw cv cH
      cfv cS wbr wb vz vw vx cv vy cv cA cA vz cv vx cv wceq vz cv vw cv cR wbr
      vx cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr vx cv cH cfv vw cv cH
      cfv cS wbr vz cv vx cv vw cv cR breq1 vz cv vx cv wceq vz cv cH cfv vx cv
      cH cfv vw cv cH cfv cS vz cv vx cv cH fveq2 breq1d bibi12d vw cv vy cv
      wceq vx cv vw cv cR wbr vx cv vy cv cR wbr vx cv cH cfv vw cv cH cfv cS
      wbr vx cv cH cfv vy cv cH cfv cS wbr vw cv vy cv vx cv cR breq2 vw cv vy
      cv wceq vw cv cH cfv vy cv cH cfv vx cv cH cfv cS vw cv vy cv cH fveq2
      breq2d bibi12d rcla42v impcom adantll adantlr cB cC cG wf1o cA cB cH wf1o
      wa vx cv cA wcel vy cv cA wcel wa vx cv cG cH ccom cfv vy cv cG cH ccom
      cfv cT wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb cA cB cH
      wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz
      cA wral wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT
      wbr wb vu cB wral vv cB wral wa wa cG wfun cA cB cH wf wa vx cv cA wcel
      vy cv cA wcel wa vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr vx cv
      cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb cB cC cG wf1o cA cB cH wf1o
      wa cG wfun cA cB cH wf wa vx cv cA wcel vy cv cA wcel vx cv cG cH ccom
      cfv vy cv cG cH ccom cfv cT wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv
      cT wbr wb cG wfun cA cB cH wf wa vx cv cA wcel wa cG wfun cA cB cH wf wa
      vy cv cA wcel wa vx cv cG cH ccom cfv vx cv cH cfv cG cfv vy cv cG cH
      ccom cfv vy cv cH cfv cG cfv cT cG wfun cA cB cH wf vx cv cA wcel vx cv
      cG cH ccom cfv vx cv cH cfv cG cfv wceq cA cB vx cv cG cH fvco3 3expa cG
      wfun cA cB cH wf vy cv cA wcel vy cv cG cH ccom cfv vy cv cH cfv cG cfv
      wceq cA cB vy cv cG cH fvco3 3expa breqan12d anandis cB cC cG wf1o cG
      wfun cA cB cH wf1o cA cB cH wf cB cC cG f1ofun cA cB cH f1of anim12i
      sylan cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr
      wb vu cB wral vv cB wral wa cA cB cH wf1o vz cv vw cv cR wbr vz cv cH cfv
      vw cv cH cfv cS wbr wb vw cA wral vz cA wral wa cB cC cG wf1o cA cB cH
      wf1o wa cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr
      wb vu cB wral vv cB wral wa cB cC cG wf1o cA cB cH wf1o vz cv vw cv cR
      wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz cA wral wa cA cB cH
      wf1o cB cC cG wf1o vv cv vu cv cS wbr vv cv cG cfv vu cv cG cfv cT wbr wb
      vu cB wral vv cB wral pm3.26 cA cB cH wf1o vz cv vw cv cR wbr vz cv cH
      cfv vw cv cH cfv cS wbr wb vw cA wral vz cA wral pm3.26 anim12i ancoms
      sylan 3bitr4d exp32 r19.21adv r19.21aiv jca cA cB cR cS cH wiso cA cB cH
      wf1o vz cv vw cv cR wbr vz cv cH cfv vw cv cH cfv cS wbr wb vw cA wral vz
      cA wral wa cB cC cS cT cG wiso cB cC cG wf1o vv cv vu cv cS wbr vv cv cG
      cfv vu cv cG cfv cT wbr wb vu cB wral vv cB wral wa vz vw cA cB cR cS cH
      df-iso vv vu cB cC cS cT cG df-iso anbi12i vx vy cA cC cR cT cG cH ccom
      df-iso 3imtr4i $.
      $( [13-Jun-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w R $.
    $d x y z w S $.  $d x y z w T $.  $d x y z w G $.  $d x y z w H $.
    $( Composition (transitive) law for isomorphism.  Proposition 6.30(3) of
       [TakeutiZaring] p. 33.  This proof is shorter than ~ isotr in set.mm
       and uses fewer dummy variables, but it takes 240K vs. 207K for the web
       page. $)
    isotrALT $p |- ( ( H Isom R , S ( A , B ) /\ G Isom S , T ( B , C ) ) ->
               ( G o. H ) Isom R , T ( A , C ) ) $=
      cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy
      cA wral vx cA wral wa cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv
      cG cfv cT wbr wb vw cB wral vz cB wral wa wa cA cC cG cH ccom wf1o vx cv
      vy cv cR wbr vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr wb vy cA
      wral vx cA wral wa cA cB cR cS cH wiso cB cC cS cT cG wiso wa cA cC cR cT
      cG cH ccom wiso cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral wa cB cC cG wf1o vz cv vw cv cS wbr
      vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral wa wa cA cC cG
      cH ccom wf1o vx cv vy cv cR wbr vx cv cG cH ccom cfv vy cv cG cH ccom cfv
      cT wbr wb vy cA wral vx cA wral cA cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa cB cC cG wf1o vz cv
      vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral wa
      wa cB cC cG wf1o cA cB cH wf1o wa cA cC cG cH ccom wf1o cB cC cG wf1o vz
      cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral
      wa cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb
      vy cA wral vx cA wral wa cB cC cG wf1o cA cB cH wf1o wa cB cC cG wf1o vz
      cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral
      wa cB cC cG wf1o cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral wa cA cB cH wf1o cB cC cG wf1o vz cv
      vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral
      pm3.26 cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr
      wb vy cA wral vx cA wral pm3.26 anim12i ancoms cA cB cC cG cH f1oco syl
      cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy
      cA wral vx cA wral wa cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv
      cG cfv cT wbr wb vw cB wral vz cB wral wa wa vx cv vy cv cR wbr vx cv cG
      cH ccom cfv vy cv cG cH ccom cfv cT wbr wb vy cA wral vx cA cA cB cH wf1o
      vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA
      wral wa cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr
      wb vw cB wral vz cB wral wa vx cA cB cH wf1o vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vx cA cB cH wf1o vx
      ax-17 vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral
      vx cA hbra1 hban cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv cG
      cfv cT wbr wb vw cB wral vz cB wral wa vx ax-17 hban cA cB cH wf1o vx cv
      vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa
      cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw
      cB wral vz cB wral wa wa vx cv cA wcel vx cv vy cv cR wbr vx cv cG cH
      ccom cfv vy cv cG cH ccom cfv cT wbr wb vy cA cA cB cH wf1o vx cv vy cv
      cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa cB cC
      cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral
      vz cB wral wa vy cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral vy cA cB cH wf1o vy ax-17 vx cv vy cv
      cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vy vx cA vx cv cA
      wcel vy ax-17 vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy
      cA hbra1 hbral hban cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv
      cG cfv cT wbr wb vw cB wral vz cB wral wa vy ax-17 hban vx cv cA wcel vy
      ax-17 cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr
      wb vy cA wral vx cA wral wa cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv
      vw cv cG cfv cT wbr wb vw cB wral vz cB wral wa wa vx cv cA wcel vy cv cA
      wcel vx cv vy cv cR wbr vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr
      wb cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb
      vy cA wral vx cA wral wa cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw
      cv cG cfv cT wbr wb vw cB wral vz cB wral wa wa vx cv cA wcel vy cv cA
      wcel wa wa vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH
      cfv cG cfv cT wbr vx cv vy cv cR wbr vx cv cG cH ccom cfv vy cv cG cH
      ccom cfv cT wbr cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral wa cB cC cG wf1o vz cv vw cv cS wbr
      vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral wa wa vx cv cA
      wcel vy cv cA wcel wa vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG
      cfv vy cv cH cfv cG cfv cT wbr wb cA cB cH wf1o vx cv vy cv cR wbr vx cv
      cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa vx cv cA wcel vy
      cv cA wcel wa vx cv cH cfv cB wcel vy cv cH cfv cB wcel wa cB cC cG wf1o
      vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB
      wral wa vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv vy cv cH cfv
      cG cfv cT wbr wb cA cB cH wf1o vx cv cA wcel vy cv cA wcel wa vx cv cH
      cfv cB wcel vy cv cH cfv cB wcel wa wi vx cv vy cv cR wbr vx cv cH cfv vy
      cv cH cfv cS wbr wb vy cA wral vx cA wral cA cB cH wf1o cA cB cH wf vx cv
      cA wcel vy cv cA wcel wa vx cv cH cfv cB wcel vy cv cH cfv cB wcel wa wi
      cA cB cH f1of cA cB cH wf vx cv cA wcel vx cv cH cfv cB wcel vy cv cA
      wcel vy cv cH cfv cB wcel cA cB cH wf vx cv cA wcel vx cv cH cfv cB wcel
      cA cB vx cv cH ffvelrn ex cA cB cH wf vy cv cA wcel vy cv cH cfv cB wcel
      cA cB vy cv cH ffvelrn ex anim12d syl adantr vz cv vw cv cS wbr vz cv cG
      cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral vx cv cH cfv cB wcel vy
      cv cH cfv cB wcel wa vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv
      vy cv cH cfv cG cfv cT wbr wb wi cB cC cG wf1o vx cv cH cfv cB wcel vy cv
      cH cfv cB wcel wa vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb
      vw cB wral vz cB wral vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG
      cfv vy cv cH cfv cG cfv cT wbr wb vz cv vw cv cS wbr vz cv cG cfv vw cv
      cG cfv cT wbr wb vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv cG cfv vy
      cv cH cfv cG cfv cT wbr wb vx cv cH cfv vw cv cS wbr vx cv cH cfv cG cfv
      vw cv cG cfv cT wbr wb vz vw vx cv cH cfv vy cv cH cfv cB cB vz cv vx cv
      cH cfv wceq vz cv vw cv cS wbr vx cv cH cfv vw cv cS wbr vz cv cG cfv vw
      cv cG cfv cT wbr vx cv cH cfv cG cfv vw cv cG cfv cT wbr vz cv vx cv cH
      cfv vw cv cS breq1 vz cv vx cv cH cfv wceq vz cv cG cfv vx cv cH cfv cG
      cfv vw cv cG cfv cT vz cv vx cv cH cfv cG fveq2 breq1d bibi12d vw cv vy
      cv cH cfv wceq vx cv cH cfv vw cv cS wbr vx cv cH cfv vy cv cH cfv cS wbr
      vx cv cH cfv cG cfv vw cv cG cfv cT wbr vx cv cH cfv cG cfv vy cv cH cfv
      cG cfv cT wbr vw cv vy cv cH cfv vx cv cH cfv cS breq2 vw cv vy cv cH cfv
      wceq vw cv cG cfv vy cv cH cfv cG cfv vx cv cH cfv cG cfv cT vw cv vy cv
      cH cfv cG fveq2 breq2d bibi12d rcla42v com12 adantl sylan9 imp cA cB cH
      wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx
      cA wral wa vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx cv cH cfv
      vy cv cH cfv cS wbr wb cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw
      cv cG cfv cT wbr wb vw cB wral vz cB wral wa vx cv vy cv cR wbr vx cv cH
      cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral vx cv cA wcel vy cv cA
      wcel wa vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb cA cB cH
      wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx
      cA wral vx cv cA wcel vy cv cA wcel wa vx cv vy cv cR wbr vx cv cH cfv vy
      cv cH cfv cS wbr wb vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr
      wb vx vy cA cA ra42 imp adantll adantlr cB cC cG wf1o cA cB cH wf1o wa vx
      cv cA wcel vy cv cA wcel wa vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT
      wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb cA cB cH wf1o vx cv
      vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa
      cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw
      cB wral vz cB wral wa wa cG wfun cA cB cH wf wa vx cv cA wcel vy cv cA
      wcel wa vx cv cG cH ccom cfv vy cv cG cH ccom cfv cT wbr vx cv cH cfv cG
      cfv vy cv cH cfv cG cfv cT wbr wb cB cC cG wf1o cA cB cH wf1o wa cG wfun
      cA cB cH wf wa vx cv cA wcel vy cv cA wcel vx cv cG cH ccom cfv vy cv cG
      cH ccom cfv cT wbr vx cv cH cfv cG cfv vy cv cH cfv cG cfv cT wbr wb cG
      wfun cA cB cH wf wa vx cv cA wcel wa cG wfun cA cB cH wf wa vy cv cA wcel
      wa vx cv cG cH ccom cfv vx cv cH cfv cG cfv vy cv cG cH ccom cfv vy cv cH
      cfv cG cfv cT cG wfun cA cB cH wf vx cv cA wcel vx cv cG cH ccom cfv vx
      cv cH cfv cG cfv wceq cA cB vx cv cG cH fvco3 3expa cG wfun cA cB cH wf
      vy cv cA wcel vy cv cG cH ccom cfv vy cv cH cfv cG cfv wceq cA cB vy cv
      cG cH fvco3 3expa breqan12d anandis cB cC cG wf1o cG wfun cA cB cH wf1o
      cA cB cH wf cB cC cG f1ofun cA cB cH f1of anim12i sylan cB cC cG wf1o vz
      cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral
      wa cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr wb
      vy cA wral vx cA wral wa cB cC cG wf1o cA cB cH wf1o wa cB cC cG wf1o vz
      cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral
      wa cB cC cG wf1o cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH
      cfv cS wbr wb vy cA wral vx cA wral wa cA cB cH wf1o cB cC cG wf1o vz cv
      vw cv cS wbr vz cv cG cfv vw cv cG cfv cT wbr wb vw cB wral vz cB wral
      pm3.26 cA cB cH wf1o vx cv vy cv cR wbr vx cv cH cfv vy cv cH cfv cS wbr
      wb vy cA wral vx cA wral pm3.26 anim12i ancoms sylan 3bitr4d exp32
      r19.21ad r19.21ai jca cA cB cR cS cH wiso cA cB cH wf1o vx cv vy cv cR
      wbr vx cv cH cfv vy cv cH cfv cS wbr wb vy cA wral vx cA wral wa cB cC cS
      cT cG wiso cB cC cG wf1o vz cv vw cv cS wbr vz cv cG cfv vw cv cG cfv cT
      wbr wb vw cB wral vz cB wral wa vx vy cA cB cR cS cH df-iso vz vw cB cC
      cS cT cG df-iso anbi12i vx vy cA cC cR cT cG cH ccom df-iso 3imtr4i $.
      $( [13-Jun-2004] $) $( [27-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $d x y C $.  $d x y D $.
    $( Isomorphisms preserve minimal elements.  Note that ` ( ``' R " { D } ) `
       is Takeuti and Zaring's idiom for the initial segment
       ` { x | x R D } ` .  Proposition 6.31(1) of [TakeutiZaring] p. 33. $)
    isomin $p |- ( ( H Isom R , S ( A , B ) /\ ( C C_ A /\ D e. A ) ) ->
               ( ( C i^i ( `' R " { D } ) ) = (/) <->
               ( ( H " C ) i^i ( `' S " { ( H ` D ) } ) ) = (/) ) ) $=
      cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa cC cR ccnv cD csn cima cin
      c0 wceq cH cC cima cS ccnv cD cH cfv csn cima cin c0 wceq cA cB cR cS cH
      wiso cC cA wss cD cA wcel wa wa cH cC cima cS ccnv cD cH cfv csn cima cin
      c0 wceq cC cR ccnv cD csn cima cin c0 wceq cA cB cR cS cH wiso cC cA wss
      cD cA wcel wa wa vy cv cH cC cima cS ccnv cD cH cfv csn cima cin wcel vy
      wex cC cR ccnv cD csn cima cin c0 wceq wn cH cC cima cS ccnv cD cH cfv
      csn cima cin c0 wceq wn cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa vy
      cv cH cC cima cS ccnv cD cH cfv csn cima cin wcel cC cR ccnv cD csn cima
      cin c0 wceq wn vy cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa vy cv cH
      cC cima cS ccnv cD cH cfv csn cima cin wcel vx cv cR ccnv cD csn cima
      wcel vx cC wrex cC cR ccnv cD csn cima cin c0 wceq wn cA cB cR cS cH wiso
      cC cA wss cD cA wcel wa wa vy cv cH cC cima cS ccnv cD cH cfv csn cima
      cin wcel vx cv cH cfv vy cv wceq vy cv cD cH cfv cS wbr wa vx cC wrex vx
      cv cR ccnv cD csn cima wcel vx cC wrex cA cB cR cS cH wiso cC cA wss vy
      cv cH cC cima cS ccnv cD cH cfv csn cima cin wcel vx cv cH cfv vy cv wceq
      vy cv cD cH cfv cS wbr wa vx cC wrex wb cD cA wcel cA cB cR cS cH wiso cC
      cA wss wa vy cv cH cC cima wcel vy cv cS ccnv cD cH cfv csn cima wcel wa
      vx cv cH cfv vy cv wceq vx cC wrex vy cv cD cH cfv cS wbr wa vy cv cH cC
      cima cS ccnv cD cH cfv csn cima cin wcel vx cv cH cfv vy cv wceq vy cv cD
      cH cfv cS wbr wa vx cC wrex cA cB cR cS cH wiso cC cA wss wa vy cv cH cC
      cima wcel vx cv cH cfv vy cv wceq vx cC wrex vy cv cS ccnv cD cH cfv csn
      cima wcel vy cv cD cH cfv cS wbr cA cB cR cS cH wiso cC cA wss wa vx cv
      cH cfv vy cv wceq vx cC wrex vx cv vy cv cH wbr vx cC wrex vy cv cH cC
      cima wcel cA cB cR cS cH wiso cC cA wss wa vx cv cH cfv vy cv wceq vx cv
      vy cv cH wbr vx cC cA cB cR cS cH wiso cC cA wss vx cv cC wcel vx cv cH
      cfv vy cv wceq vx cv vy cv cH wbr wb cC cA wss vx cv cC wcel vx cv cA
      wcel cA cB cR cS cH wiso vx cv cH cfv vy cv wceq vx cv vy cv cH wbr wb cC
      cA vx cv ssel cA cB cR cS cH wiso cA cB cH wf1o cH cA wfn vx cv cA wcel
      vx cv cH cfv vy cv wceq vx cv vy cv cH wbr wb wi cA cB cR cS cH isof1o cA
      cB cH f1ofn cH cA wfn vx cv cA wcel vx cv cH cfv vy cv wceq vx cv vy cv
      cH wbr wb cA vx cv vy cv cH vy visset fnbrfvb ex 3syl syl9r imp31
      rexbidva vx vy cv cH cC vy visset elima syl6rbbr vy cv cS ccnv cD cH cfv
      csn cima wcel vy cv cD cH cfv cS wbr wb cA cB cR cS cH wiso cC cA wss wa
      cD cH cfv cvv wcel vy cv cS ccnv cD cH cfv csn cima wcel vy cv cD cH cfv
      cS wbr wb cD cH fvex cS cD cH cfv vy cv cvv vy visset eliniseg ax-mp a1i
      anbi12d vy cv cH cC cima cS ccnv cD cH cfv csn cima elin vx cv cH cfv vy
      cv wceq vy cv cD cH cfv cS wbr vx cC r19.41v 3bitr4g adantrr cA cB cR cS
      cH wiso cC cA wss cD cA wcel wa wa vx cv cH cfv vy cv wceq vy cv cD cH
      cfv cS wbr wa vx cv cR ccnv cD csn cima wcel vx cC cA cB cR cS cH wiso cC
      cA wss cD cA wcel vx cv cC wcel vx cv cH cfv vy cv wceq vy cv cD cH cfv
      cS wbr wa vx cv cR ccnv cD csn cima wcel wi wi cA cB cR cS cH wiso cC cA
      wss vx cv cC wcel cD cA wcel vx cv cH cfv vy cv wceq vy cv cD cH cfv cS
      wbr wa vx cv cR ccnv cD csn cima wcel wi cC cA wss vx cv cC wcel vx cv cA
      wcel cA cB cR cS cH wiso cD cA wcel vx cv cH cfv vy cv wceq vy cv cD cH
      cfv cS wbr wa vx cv cR ccnv cD csn cima wcel wi wi cC cA vx cv ssel cA cB
      cR cS cH wiso vx cv cA wcel cD cA wcel vx cv cH cfv vy cv wceq vy cv cD
      cH cfv cS wbr wa vx cv cR ccnv cD csn cima wcel wi cA cB cR cS cH wiso vx
      cv cA wcel cD cA wcel wa wa vx cv cR ccnv cD csn cima wcel vx cv cH cfv
      cD cH cfv cS wbr vx cv cH cfv vy cv wceq vy cv cD cH cfv cS wbr wa cA cB
      cR cS cH wiso vx cv cA wcel cD cA wcel wa wa vx cv cR ccnv cD csn cima
      wcel vx cv cD cR wbr vx cv cH cfv cD cH cfv cS wbr cD cA wcel vx cv cR
      ccnv cD csn cima wcel vx cv cD cR wbr wb cA cB cR cS cH wiso vx cv cA
      wcel cR cD vx cv cA vx visset eliniseg ad2antll cA cB vx cv cD cR cS cH
      isorel bitrd vx cv cH cfv vy cv wceq vx cv cH cfv cD cH cfv cS wbr vy cv
      cD cH cfv cS wbr vx cv cH cfv vy cv cD cH cfv cS breq1 biimpar syl5bir
      exp32 syl9r com34 imp32 r19.22dv sylbid vx cv cC cR ccnv cD csn cima cin
      wcel vx wex vx cv cC wcel vx cv cR ccnv cD csn cima wcel wa vx wex cC cR
      ccnv cD csn cima cin c0 wceq wn vx cv cR ccnv cD csn cima wcel vx cC wrex
      vx cv cC cR ccnv cD csn cima cin wcel vx cv cC wcel vx cv cR ccnv cD csn
      cima wcel wa vx vx cv cC cR ccnv cD csn cima elin exbii vx cC cR ccnv cD
      csn cima cin neq0 vx cv cR ccnv cD csn cima wcel vx cC df-rex 3bitr4i
      syl6ibr 19.23adv vy cH cC cima cS ccnv cD cH cfv csn cima cin neq0 syl5ib
      con4d cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa cC cR ccnv cD csn
      cima cin c0 wceq cH cC cima cS ccnv cD cH cfv csn cima cin c0 wceq cA cB
      cR cS cH wiso cC cA wss cD cA wcel wa wa vx cv cC cR ccnv cD csn cima cin
      wcel vx wex cH cC cima cS ccnv cD cH cfv csn cima cin c0 wceq wn cC cR
      ccnv cD csn cima cin c0 wceq wn cA cB cR cS cH wiso cC cA wss cD cA wcel
      wa wa vx cv cC cR ccnv cD csn cima cin wcel cH cC cima cS ccnv cD cH cfv
      csn cima cin c0 wceq wn vx cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa
      vx cv cC cR ccnv cD csn cima cin wcel vx cv cH cfv cH cC cima cS ccnv cD
      cH cfv csn cima cin wcel cH cC cima cS ccnv cD cH cfv csn cima cin c0
      wceq wn cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa vx cv cC wcel vx
      cv cR ccnv cD csn cima wcel wa vx cv cH cfv cH cC cima wcel vx cv cH cfv
      cS ccnv cD cH cfv csn cima wcel wa vx cv cC cR ccnv cD csn cima cin wcel
      vx cv cH cfv cH cC cima cS ccnv cD cH cfv csn cima cin wcel cA cB cR cS
      cH wiso cC cA wss cD cA wcel wa wa vx cv cC wcel vx cv cR ccnv cD csn
      cima wcel wa vx cv cH cfv cH cC cima wcel vx cv cH cfv cS ccnv cD cH cfv
      csn cima wcel cA cB cR cS cH wiso cC cA wss cD cA wcel wa wa vx cv cC
      wcel vx cv cH cfv cH cC cima wcel vx cv cR ccnv cD csn cima wcel cH cA
      wfn cC cA wss cD cA wcel wa vx cv cC wcel vx cv cH cfv cH cC cima wcel wi
      cA cB cR cS cH wiso cH cA wfn cC cA wss vx cv cC wcel vx cv cH cfv cH cC
      cima wcel wi cD cA wcel cH cA wfn cC cA wss vx cv cC wcel vx cv cH cfv cH
      cC cima wcel wi vx cv cC wcel cC cA wss cH cA wfn vx cv cH cfv cH cC cima
      wcel vx cv cC wcel cC cA wss vx cv cA wcel cH cA wfn vx cv cH cfv cH cC
      cima wcel wi cC cA wss vx cv cC wcel vx cv cA wcel cC cA vx cv ssel com12
      cH cA wfn vx cv cA wcel vx cv cC wcel vx cv cH cfv cH cC cima wcel cH cA
      wfn vx cv cA wcel vx cv cC wcel vx cv cH cfv cH cC cima wcel wi vx cv cC
      wcel vx cv cH cfv cH cC cima wcel wi cA vx cv cH cC vx cv cH funfvima
      funfni ex com13 syld com13 imp adantrr cA cB cR cS cH wiso cA cB cH wf1o
      cH cA wfn cA cB cR cS cH isof1o cA cB cH f1ofn syl sylan adantrd cA cB cR
      cS cH wiso cC cA wss cD cA wcel wa wa vx cv cC wcel vx cv cR ccnv cD csn
      cima wcel vx cv cH cfv cS ccnv cD cH cfv csn cima wcel cA cB cR cS cH
      wiso cC cA wss cD cA wcel vx cv cC wcel vx cv cR ccnv cD csn cima wcel vx
      cv cH cfv cS ccnv cD cH cfv csn cima wcel wi wi cA cB cR cS cH wiso cC cA
      wss vx cv cC wcel cD cA wcel vx cv cR ccnv cD csn cima wcel vx cv cH cfv
      cS ccnv cD cH cfv csn cima wcel wi cC cA wss vx cv cC wcel vx cv cA wcel
      cA cB cR cS cH wiso cD cA wcel vx cv cR ccnv cD csn cima wcel vx cv cH
      cfv cS ccnv cD cH cfv csn cima wcel wi wi cC cA vx cv ssel cA cB cR cS cH
      wiso vx cv cA wcel cD cA wcel vx cv cR ccnv cD csn cima wcel vx cv cH cfv
      cS ccnv cD cH cfv csn cima wcel wi cA cB cR cS cH wiso vx cv cA wcel cD
      cA wcel wa wa vx cv cR ccnv cD csn cima wcel vx cv cD cR wbr vx cv cH cfv
      cS ccnv cD cH cfv csn cima wcel cD cA wcel vx cv cR ccnv cD csn cima wcel
      vx cv cD cR wbr wb cA cB cR cS cH wiso vx cv cA wcel cR cD vx cv cA vx
      visset eliniseg ad2antll cA cB cR cS cH wiso vx cv cA wcel cD cA wcel wa
      wa vx cv cD cR wbr vx cv cH cfv cD cH cfv cS wbr vx cv cH cfv cS ccnv cD
      cH cfv csn cima wcel cA cB cR cS cH wiso vx cv cA wcel cD cA wcel wa wa
      vx cv cD cR wbr vx cv cH cfv cD cH cfv cS wbr cA cB vx cv cD cR cS cH
      isorel biimpd cD cH cfv cvv wcel vx cv cH cfv cS ccnv cD cH cfv csn cima
      wcel vx cv cH cfv cD cH cfv cS wbr wb cD cH fvex cS cD cH cfv vx cv cH
      cfv cvv vx cv cH fvex eliniseg ax-mp syl6ibr sylbid exp32 syl9r com34
      imp32 imp3a jcad vx cv cC cR ccnv cD csn cima elin vx cv cH cfv cH cC
      cima cS ccnv cD cH cfv csn cima elin 3imtr4g cH cC cima cS ccnv cD cH cfv
      csn cima cin vx cv cH cfv n0i syl6 19.23adv vx cC cR ccnv cD csn cima cin
      neq0 syl5ib con4d impbid $.
      $( [7-Jun-2004] $) $( [19-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $d x y D $.
    $( Isomorphisms preserve initial segments.  Proposition 6.31(2) of
       [TakeutiZaring] p. 33. $)
    isoini $p |- ( ( H Isom R , S ( A , B ) /\ D e. A ) ->
               ( H " ( A i^i ( `' R " { D } ) ) ) =
               ( B i^i ( `' S " { ( H ` D ) } ) ) ) $=
      cA cB cR cS cH wiso cD cA wcel wa cB cS ccnv cD cH cfv csn cima cin vx cv
      vy cv cH wbr vx cA cR ccnv cD csn cima cin wrex vy cab cH cA cR ccnv cD
      csn cima cin cima cA cB cR cS cH wiso cD cA wcel wa vx cv vy cv cH wbr vx
      cA cR ccnv cD csn cima cin wrex vy cB cS ccnv cD cH cfv csn cima cin cA
      cB cR cS cH wiso cD cA wcel wa vy cv cB wcel vy cv cS ccnv cD cH cfv csn
      cima wcel wa vx cv vy cv cH wbr vx cA cR ccnv cD csn cima cin wrex vy cv
      cB cS ccnv cD cH cfv csn cima cin wcel cA cB cR cS cH wiso cD cA wcel wa
      vy cv cB wcel vy cv cS ccnv cD cH cfv csn cima wcel wa vx cv cH cfv vy cv
      wceq vx cA wrex vy cv cD cH cfv cS wbr wa vx cv vy cv cH wbr vx cA cR
      ccnv cD csn cima cin wrex cA cB cR cS cH wiso vy cv cB wcel vy cv cS ccnv
      cD cH cfv csn cima wcel wa vx cv cH cfv vy cv wceq vx cA wrex vy cv cD cH
      cfv cS wbr wa wb cD cA wcel cA cB cR cS cH wiso vy cv cB wcel vx cv cH
      cfv vy cv wceq vx cA wrex vy cv cS ccnv cD cH cfv csn cima wcel vy cv cD
      cH cfv cS wbr cA cB cR cS cH wiso vy cv cH crn wcel vy cv cB wcel vx cv
      cH cfv vy cv wceq vx cA wrex cA cB cR cS cH wiso cA cB cH wf1o cA cB cH
      wfo vy cv cH crn wcel vy cv cB wcel wb cA cB cR cS cH isof1o cA cB cH
      f1ofo cA cB cH wfo cH crn cB vy cv cA cB cH forn eleq2d 3syl cA cB cR cS
      cH wiso cA cB cH wf1o cH cA wfn vy cv cH crn wcel vx cv cH cfv vy cv wceq
      vx cA wrex wb cA cB cR cS cH isof1o cA cB cH f1ofn vx cA vy cv cH fvelrnb
      3syl bitr3d vy cv cS ccnv cD cH cfv csn cima wcel vy cv cD cH cfv cS wbr
      wb cA cB cR cS cH wiso cD cH cfv cvv wcel vy cv cS ccnv cD cH cfv csn
      cima wcel vy cv cD cH cfv cS wbr wb cD cH fvex cS cD cH cfv vy cv cvv vy
      visset eliniseg ax-mp a1i anbi12d adantr cA cB cR cS cH wiso cD cA wcel
      wa vx cv vy cv cH wbr vx cA cR ccnv cD csn cima cin wrex vx cv cH cfv vy
      cv wceq vy cv cD cH cfv cS wbr wa vx cA wrex vx cv cH cfv vy cv wceq vx
      cA wrex vy cv cD cH cfv cS wbr wa cA cB cR cS cH wiso cD cA wcel wa vx cv
      vy cv cH wbr vx cv cH cfv vy cv wceq vy cv cD cH cfv cS wbr wa vx cA cR
      ccnv cD csn cima cin cA cA cB cR cS cH wiso cD cA wcel wa vx cv cA cR
      ccnv cD csn cima cin wcel vx cv vy cv cH wbr wa vx cv cA wcel vx cv cD cR
      wbr vx cv vy cv cH wbr wa wa vx cv cA wcel vx cv cH cfv vy cv wceq vy cv
      cD cH cfv cS wbr wa wa cD cA wcel vx cv cA cR ccnv cD csn cima cin wcel
      vx cv vy cv cH wbr wa vx cv cA wcel vx cv cD cR wbr vx cv vy cv cH wbr wa
      wa wb cA cB cR cS cH wiso cD cA wcel vx cv cA cR ccnv cD csn cima cin
      wcel vx cv vy cv cH wbr wa vx cv cA wcel vx cv cD cR wbr wa vx cv vy cv
      cH wbr wa vx cv cA wcel vx cv cD cR wbr vx cv vy cv cH wbr wa wa cD cA
      wcel vx cv cA cR ccnv cD csn cima cin wcel vx cv cA wcel vx cv cD cR wbr
      wa vx cv vy cv cH wbr cD cA wcel vx cv cA wcel vx cv cR ccnv cD csn cima
      wcel wa vx cv cA wcel vx cv cD cR wbr wa vx cv cA cR ccnv cD csn cima cin
      wcel cD cA wcel vx cv cR ccnv cD csn cima wcel vx cv cD cR wbr vx cv cA
      wcel cR cD vx cv cA vx visset eliniseg anbi2d vx cv cA cR ccnv cD csn
      cima elin syl5bb anbi1d vx cv cA wcel vx cv cD cR wbr vx cv vy cv cH wbr
      anass syl6bb adantl cA cB cR cS cH wiso cD cA wcel wa vx cv cA wcel vx cv
      cD cR wbr vx cv vy cv cH wbr wa vx cv cH cfv vy cv wceq vy cv cD cH cfv
      cS wbr wa cA cB cR cS cH wiso cD cA wcel vx cv cA wcel vx cv cD cR wbr vx
      cv vy cv cH wbr wa vx cv cH cfv vy cv wceq vy cv cD cH cfv cS wbr wa wb
      wi cA cB cR cS cH wiso vx cv cA wcel cD cA wcel vx cv cD cR wbr vx cv vy
      cv cH wbr wa vx cv cH cfv vy cv wceq vy cv cD cH cfv cS wbr wa wb cA cB
      cR cS cH wiso vx cv cA wcel cD cA wcel vx cv cD cR wbr vx cv vy cv cH wbr
      wa vx cv cH cfv vy cv wceq vy cv cD cH cfv cS wbr wa wb cA cB cR cS cH
      wiso vx cv cA wcel cD cA wcel wa wa vx cv cD cR wbr vx cv vy cv cH wbr wa
      vx cv cH cfv cD cH cfv cS wbr vx cv cH cfv vy cv wceq wa vx cv cH cfv vy
      cv wceq vy cv cD cH cfv cS wbr wa cA cB cR cS cH wiso vx cv cA wcel cD cA
      wcel wa wa vx cv cD cR wbr vx cv cH cfv cD cH cfv cS wbr vx cv vy cv cH
      wbr vx cv cH cfv vy cv wceq cA cB vx cv cD cR cS cH isorel cA cB cR cS cH
      wiso vx cv cA wcel vx cv vy cv cH wbr vx cv cH cfv vy cv wceq wb cD cA
      wcel cH cA wfn vx cv cA wcel vx cv vy cv cH wbr vx cv cH cfv vy cv wceq
      wb cA cB cR cS cH wiso cH cA wfn vx cv cA wcel wa vx cv cH cfv vy cv wceq
      vx cv vy cv cH wbr cA vx cv vy cv cH vy visset fnbrfvb bicomd cA cB cR cS
      cH wiso cA cB cH wf1o cH cA wfn cA cB cR cS cH isof1o cA cB cH f1ofn syl
      sylan adantrr anbi12d vx cv cH cfv cD cH cfv cS wbr vx cv cH cfv vy cv
      wceq wa vx cv cH cfv vy cv wceq vx cv cH cfv cD cH cfv cS wbr wa vx cv cH
      cfv vy cv wceq vy cv cD cH cfv cS wbr wa vx cv cH cfv cD cH cfv cS wbr vx
      cv cH cfv vy cv wceq ancom vx cv cH cfv vy cv wceq vx cv cH cfv cD cH cfv
      cS wbr vy cv cD cH cfv cS wbr vx cv cH cfv vy cv cD cH cfv cS breq1
      pm5.32i bitri syl6bb exp32 com23 imp pm5.32d bitrd rexbidv2 vx cv cH cfv
      vy cv wceq vy cv cD cH cfv cS wbr vx cA r19.41v syl6bb bitr4d vy cv cB cS
      ccnv cD cH cfv csn cima elin syl5bb abbi2dv vx vy cH cA cR ccnv cD csn
      cima cin dfima2 syl6reqr $.
      $( [17-Jun-2004] $) $( [20-Apr-2004] $)
  $}

  ${
    $d x y w A $.  $d x y z w B $.  $d x y w R $.  $d x y z w S $.
    $d x y z w H $.
    $( Lemma for ~ isofr . $)
    isofrlem $p |- ( H Isom R , S ( A , B ) -> ( S Fr B -> R Fr A ) ) $=
      cA cB cR cS cH wiso cB cS wfr vx cv cA wss vx cv c0 wne wa vx cv cR ccnv
      vy cv csn cima cin c0 wceq vy vx cv wrex wi vx wal cA cR wfr cA cB cR cS
      cH wiso cB cS wfr vx cv cA wss vx cv c0 wne wa vx cv cR ccnv vy cv csn
      cima cin c0 wceq vy vx cv wrex wi vx cA cB cR cS cH wiso cB cS wfr vx cv
      cA wss vx cv c0 wne wa cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq
      vw cH vx cv cima wrex wi vx cv cA wss vx cv c0 wne wa vx cv cR ccnv vy cv
      csn cima cin c0 wceq vy vx cv wrex wi cA cB cR cS cH wiso cB cS wfr cH vx
      cv cima cB wss cH vx cv cima c0 wne wa cH vx cv cima cS ccnv vw cv csn
      cima cin c0 wceq vw cH vx cv cima wrex vx cv cA wss vx cv c0 wne wa cA cB
      cR cS cH wiso vz cv cB wss vz cv c0 wne wa vz cv cS ccnv vw cv csn cima
      cin c0 wceq vw vz cv wrex wi vz wal cH vx cv cima cB wss cH vx cv cima c0
      wne wa cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq vw cH vx cv cima
      wrex wi cB cS wfr cA cB cR cS cH wiso cA cB cH wf1o cH wfun vz cv cB wss
      vz cv c0 wne wa vz cv cS ccnv vw cv csn cima cin c0 wceq vw vz cv wrex wi
      vz wal cH vx cv cima cB wss cH vx cv cima c0 wne wa cH vx cv cima cS ccnv
      vw cv csn cima cin c0 wceq vw cH vx cv cima wrex wi wi cA cB cR cS cH
      isof1o cA cB cH f1ofun cH wfun cH vx cv cima cvv wcel vz cv cB wss vz cv
      c0 wne wa vz cv cS ccnv vw cv csn cima cin c0 wceq vw vz cv wrex wi vz
      wal cH vx cv cima cB wss cH vx cv cima c0 wne wa cH vx cv cima cS ccnv vw
      cv csn cima cin c0 wceq vw cH vx cv cima wrex wi wi cH vx cv vx visset
      funimaex vz cv cB wss vz cv c0 wne wa vz cv cS ccnv vw cv csn cima cin c0
      wceq vw vz cv wrex wi cH vx cv cima cB wss cH vx cv cima c0 wne wa cH vx
      cv cima cS ccnv vw cv csn cima cin c0 wceq vw cH vx cv cima wrex wi vz cH
      vx cv cima cvv vz cv cH vx cv cima wceq vz cv cB wss vz cv c0 wne wa cH
      vx cv cima cB wss cH vx cv cima c0 wne wa vz cv cS ccnv vw cv csn cima
      cin c0 wceq vw vz cv wrex cH vx cv cima cS ccnv vw cv csn cima cin c0
      wceq vw cH vx cv cima wrex vz cv cH vx cv cima wceq vz cv cB wss cH vx cv
      cima cB wss vz cv c0 wne cH vx cv cima c0 wne vz cv cH vx cv cima cB
      sseq1 vz cv cH vx cv cima c0 neeq1 anbi12d vz cv cS ccnv vw cv csn cima
      cin c0 wceq cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq vw vz cv cH
      vx cv cima vz cv cH vx cv cima wceq vz cv cS ccnv vw cv csn cima cin cH
      vx cv cima cS ccnv vw cv csn cima cin c0 vz cv cH vx cv cima cS ccnv vw
      cv csn cima ineq1 eqeq1d rexeqd imbi12d cla4gv syl 3syl vz vw cB cS dffr3
      syl5ib cA cB cR cS cH wiso cA cB cH wf1o vx cv cA wss vx cv c0 wne wa cH
      vx cv cima cB wss cH vx cv cima c0 wne wa wi cA cB cR cS cH isof1o cA cB
      cH wf1o vx cv cA wss vx cv c0 wne wa cH vx cv cima c0 wne cH vx cv cima
      cB wss cA cB cH wf1o cH cA wfn vx cv cA wss vx cv c0 wne wa cH vx cv cima
      c0 wne wi cA cB cH f1ofn cH cA wfn vx cv cA wss vx cv c0 wne cH vx cv
      cima c0 wne cH cA wfn vx cv cA wss wa vy cv vx cv wcel vy wex cH vx cv
      cima c0 wne vx cv c0 wne cH cA wfn vx cv cA wss wa vy cv vx cv wcel cH vx
      cv cima c0 wne vy cH cA wfn vx cv cA wss wa vy cv vx cv wcel cH vx cv
      cima c0 wne vx cv cA wss vy cv vx cv wcel vy cv cA wcel cH cA wfn vy cv
      vx cv wcel cH vx cv cima c0 wne wi vx cv cA vy cv ssel cH cA wfn vy cv cA
      wcel vy cv vx cv wcel cH vx cv cima c0 wne wi cH cA wfn vy cv cA wcel wa
      vy cv vx cv wcel vy cv cH cfv cH vx cv cima wcel cH vx cv cima c0 wne vy
      cv vx cv wcel vy cv cH cfv cH vx cv cima wcel wi cA vy cv cH vx cv vy cv
      cH funfvima funfni cH vx cv cima vy cv cH cfv ne0i syl6 ex sylan9r
      pm2.43d 19.23adv vy vx cv n0 syl5ib expimpd syl cA cB cH wf1o cA cB cH
      wfo cH vx cv cima cB wss cA cB cH f1ofo cA cB cH wfo cH vx cv cima cH crn
      wss cH vx cv cima cB wss cH vx cv imassrn cA cB cH wfo cH crn cB cH vx cv
      cima cA cB cH forn sseq2d mpbii syl jctild syl syl5d cA cB cR cS cH wiso
      vx cv cA wss vx cv c0 wne wa cH vx cv cima cS ccnv vw cv csn cima cin c0
      wceq vw cH vx cv cima wrex vx cv cR ccnv vy cv csn cima cin c0 wceq vy vx
      cv wrex cA cB cR cS cH wiso vx cv cA wss cH vx cv cima cS ccnv vw cv csn
      cima cin c0 wceq vw cH vx cv cima wrex vx cv cR ccnv vy cv csn cima cin
      c0 wceq vy vx cv wrex wi vx cv c0 wne cA cB cR cS cH wiso vx cv cA wss cH
      vx cv cima cS ccnv vw cv csn cima cin c0 wceq vw cH vx cv cima wrex vx cv
      cR ccnv vy cv csn cima cin c0 wceq vy vx cv wrex wi cA cB cR cS cH wiso
      vx cv cA wss wa cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq vx cv cR
      ccnv vy cv csn cima cin c0 wceq vy vx cv wrex vw cH vx cv cima cA cB cR
      cS cH wiso vx cv cA wss wa vw cv cH vx cv cima wcel cH vx cv cima cS ccnv
      vw cv csn cima cin c0 wceq vx cv cR ccnv vy cv csn cima cin c0 wceq vy vx
      cv wrex cA cB cR cS cH wiso vx cv cA wss wa vw cv cH vx cv cima wcel cH
      vx cv cima cS ccnv vw cv csn cima cin c0 wceq wa wa vy cv cH cfv vw cv
      wceq vy vx cv wrex vx cv cR ccnv vy cv csn cima cin c0 wceq vy vx cv wrex
      cH wfun vw cv cH vx cv cima wcel vy cv cH cfv vw cv wceq vy vx cv wrex cA
      cB cR cS cH wiso vx cv cA wss wa vw cv cH vx cv cima wcel cH vx cv cima
      cS ccnv vw cv csn cima cin c0 wceq wa vy vw cv vx cv cH fvelima cA cB cR
      cS cH wiso vx cv cA wss wa cA cB cH wf1o cH wfun cA cB cR cS cH wiso cA
      cB cH wf1o vx cv cA wss cA cB cR cS cH isof1o adantr cA cB cH f1ofun syl
      vw cv cH vx cv cima wcel cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq
      pm3.26 syl2an cA cB cR cS cH wiso vx cv cA wss wa vw cv cH vx cv cima
      wcel cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq wa wa vy cv cH cfv
      vw cv wceq vx cv cR ccnv vy cv csn cima cin c0 wceq vy vx cv cA cB cR cS
      cH wiso vx cv cA wss wa vw cv cH vx cv cima wcel cH vx cv cima cS ccnv vw
      cv csn cima cin c0 wceq wa vy cv vx cv wcel vy cv cH cfv vw cv wceq vx cv
      cR ccnv vy cv csn cima cin c0 wceq wi wi vy cv vx cv wcel vy cv cH cfv vw
      cv wceq cA cB cR cS cH wiso vx cv cA wss wa vw cv cH vx cv cima wcel cH
      vx cv cima cS ccnv vw cv csn cima cin c0 wceq wa vx cv cR ccnv vy cv csn
      cima cin c0 wceq cA cB cR cS cH wiso vx cv cA wss wa vy cv vx cv wcel vy
      cv cH cfv vw cv wceq vw cv cH vx cv cima wcel cH vx cv cima cS ccnv vw cv
      csn cima cin c0 wceq wa vx cv cR ccnv vy cv csn cima cin c0 wceq wi cA cB
      cR cS cH wiso vx cv cA wss vy cv vx cv wcel vy cv cH cfv vw cv wceq vw cv
      cH vx cv cima wcel cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq wa vx
      cv cR ccnv vy cv csn cima cin c0 wceq wi wi wi cA cB cR cS cH wiso vx cv
      cA wss vy cv vx cv wcel vy cv cH cfv vw cv wceq vw cv cH vx cv cima wcel
      cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq wa vx cv cR ccnv vy cv
      csn cima cin c0 wceq wi cA cB cR cS cH wiso vx cv cA wss vy cv vx cv wcel
      wa wa vy cv cH cfv vw cv wceq wa vx cv cR ccnv vy cv csn cima cin c0 wceq
      cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq vw cv cH vx cv cima wcel
      cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq wa cA cB cR cS cH wiso
      vx cv cA wss vy cv vx cv wcel wa wa vx cv cR ccnv vy cv csn cima cin c0
      wceq cH vx cv cima cS ccnv vy cv cH cfv csn cima cin c0 wceq vy cv cH cfv
      vw cv wceq cH vx cv cima cS ccnv vw cv csn cima cin c0 wceq cA cB cR cS
      cH wiso vx cv cA wss vy cv cA wcel wa vx cv cR ccnv vy cv csn cima cin c0
      wceq cH vx cv cima cS ccnv vy cv cH cfv csn cima cin c0 wceq wb vx cv cA
      wss vy cv vx cv wcel wa cA cB vx cv vy cv cR cS cH isomin vx cv cA wss vy
      cv vx cv wcel vy cv cA wcel vx cv cA vy cv ssel imdistani sylan2 vy cv cH
      cfv vw cv wceq cH vx cv cima cS ccnv vy cv cH cfv csn cima cin cH vx cv
      cima cS ccnv vw cv csn cima cin c0 vy cv cH cfv vw cv wceq cS ccnv vy cv
      cH cfv csn cima cS ccnv vw cv csn cima cH vx cv cima vy cv cH cfv vw cv
      wceq vy cv cH cfv csn vw cv csn cS ccnv vy cv cH cfv vw cv sneq imaeq2d
      ineq2d eqeq1d sylan9bb vw cv cH vx cv cima wcel cH vx cv cima cS ccnv vw
      cv csn cima cin c0 wceq pm3.27 syl5bir exp42 imp com3l com4t imp r19.22dv
      mpd exp32 r19.23adv ex adantrd a2d syld 19.21adv vx vy cA cR dffr3
      syl6ibr $.
      $( [8-Jun-2004] $) $( [29-Apr-2004] $)
  $}

  $( An isomorphism preserves foundedness.  Proposition 6.32(1) of
     [TakeutiZaring] p. 33. $)
  isofr $p |- ( H Isom R , S ( A , B ) -> ( R Fr A <-> S Fr B ) ) $=
    cA cB cR cS cH wiso cA cR wfr cB cS wfr cA cB cR cS cH wiso cB cA cS cR cH
    ccnv wiso cA cR wfr cB cS wfr wi cA cB cR cS cH isocnv cB cA cS cR cH ccnv
    isofrlem syl cA cB cR cS cH isofrlem impbid $.
    $( [8-Jun-2004] $) $( [30-Apr-2004] $)

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y R $.  $d x y z w S $.
    $d x y z w H $.
    $( An isomorphism preserves well ordering.  Proposition 6.32(3) of
       [TakeutiZaring] p. 33. $)
  isowe $p |- ( H Isom R , S ( A , B ) -> ( R We A <-> S We B ) ) $=
    cA cB cR cS cH wiso cA cR wfr vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx
    cv cR wbr w3o vy cA wral vx cA wral wa cB cS wfr vz cv vw cv cS wbr vz cv
    vw cv wceq vw cv vz cv cS wbr w3o vw cB wral vz cB wral wa cA cR wwe cB cS
    wwe cA cB cR cS cH wiso cA cR wfr cB cS wfr vx cv vy cv cR wbr vx cv vy cv
    wceq vy cv vx cv cR wbr w3o vy cA wral vx cA wral vz cv vw cv cS wbr vz cv
    vw cv wceq vw cv vz cv cS wbr w3o vw cB wral vz cB wral cA cB cR cS cH
    isofr cA cB cR cS cH wiso vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx cv
    cR wbr w3o vy cA wral vx cA wral vx cv cH cfv vy cv cH cfv cS wbr vx cv cH
    cfv vy cv cH cfv wceq vy cv cH cfv vx cv cH cfv cS wbr w3o vy cA wral vx cA
    wral vz cv vw cv cS wbr vz cv vw cv wceq vw cv vz cv cS wbr w3o vw cB wral
    vz cB wral cA cB cR cS cH wiso vx cv vy cv cR wbr vx cv vy cv wceq vy cv vx
    cv cR wbr w3o vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv vy cv cH cfv
    wceq vy cv cH cfv vx cv cH cfv cS wbr w3o vx vy cA cA cA cB cR cS cH wiso
    vx cv cA wcel vy cv cA wcel wa wa vx cv vy cv cR wbr vx cv cH cfv vy cv cH
    cfv cS wbr vx cv vy cv wceq vx cv cH cfv vy cv cH cfv wceq vy cv vx cv cR
    wbr vy cv cH cfv vx cv cH cfv cS wbr cA cB vx cv vy cv cR cS cH isorel cA
    cB cR cS cH wiso vx cv cA wcel vy cv cA wcel wa wa vx cv cH cfv vy cv cH
    cfv wceq vx cv vy cv wceq cA cB cH wf1 vx cv cA wcel vy cv cA wcel wa vx cv
    cH cfv vy cv cH cfv wceq vx cv vy cv wceq wb cA cB cR cS cH wiso cA cB vx
    cv vy cv cH f1fveq cA cB cR cS cH wiso cA cB cH wf1o cA cB cH wf1 cA cB cR
    cS cH isof1o cA cB cH f1of1 syl sylan bicomd cA cB cR cS cH wiso vy cv cA
    wcel vx cv cA wcel vy cv vx cv cR wbr vy cv cH cfv vx cv cH cfv cS wbr wb
    cA cB vy cv vx cv cR cS cH isorel ancom2s 3orbi123d 2ralbidva cA cB cR cS
    cH wiso cA cB cH wf1o cA cB cH wfo vx cv cH cfv vy cv cH cfv cS wbr vx cv
    cH cfv vy cv cH cfv wceq vy cv cH cfv vx cv cH cfv cS wbr w3o vy cA wral vx
    cA wral vz cv vw cv cS wbr vz cv vw cv wceq vw cv vz cv cS wbr w3o vw cB
    wral vz cB wral wb cA cB cR cS cH isof1o cA cB cH f1ofo cA cB cH wfo vx cv
    cH cfv vy cv cH cfv cS wbr vx cv cH cfv vy cv cH cfv wceq vy cv cH cfv vx
    cv cH cfv cS wbr w3o vy cA wral vx cA wral vx cv cH cfv vw cv cS wbr vx cv
    cH cfv vw cv wceq vw cv vx cv cH cfv cS wbr w3o vw cB wral vx cA wral vz cv
    vw cv cS wbr vz cv vw cv wceq vw cv vz cv cS wbr w3o vw cB wral vz cB wral
    cA cB cH wfo vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv vy cv cH cfv
    wceq vy cv cH cfv vx cv cH cfv cS wbr w3o vy cA wral vx cv cH cfv vw cv cS
    wbr vx cv cH cfv vw cv wceq vw cv vx cv cH cfv cS wbr w3o vw cB wral vx cA
    vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv vy cv cH cfv wceq vy cv cH
    cfv vx cv cH cfv cS wbr w3o vx cv cH cfv vw cv cS wbr vx cv cH cfv vw cv
    wceq vw cv vx cv cH cfv cS wbr w3o vy vw cA cB cH vy cv cH cfv vw cv wceq
    vx cv cH cfv vy cv cH cfv cS wbr vx cv cH cfv vw cv cS wbr vx cv cH cfv vy
    cv cH cfv wceq vx cv cH cfv vw cv wceq vy cv cH cfv vx cv cH cfv cS wbr vw
    cv vx cv cH cfv cS wbr vy cv cH cfv vw cv vx cv cH cfv cS breq2 vy cv cH
    cfv vw cv vx cv cH cfv eqeq2 vy cv cH cfv vw cv vx cv cH cfv cS breq1
    3orbi123d cbvfo ralbidv vx cv cH cfv vw cv cS wbr vx cv cH cfv vw cv wceq
    vw cv vx cv cH cfv cS wbr w3o vw cB wral vz cv vw cv cS wbr vz cv vw cv
    wceq vw cv vz cv cS wbr w3o vw cB wral vx vz cA cB cH vx cv cH cfv vz cv
    wceq vx cv cH cfv vw cv cS wbr vx cv cH cfv vw cv wceq vw cv vx cv cH cfv
    cS wbr w3o vz cv vw cv cS wbr vz cv vw cv wceq vw cv vz cv cS wbr w3o vw cB
    vx cv cH cfv vz cv wceq vx cv cH cfv vw cv cS wbr vz cv vw cv cS wbr vx cv
    cH cfv vw cv wceq vz cv vw cv wceq vw cv vx cv cH cfv cS wbr vw cv vz cv cS
    wbr vx cv cH cfv vz cv vw cv cS breq1 vx cv cH cfv vz cv vw cv eqeq1 vx cv
    cH cfv vz cv vw cv cS breq2 3orbi123d ralbidv cbvfo bitrd 3syl bitrd
    anbi12d vx vy cA cR dfwe2 vz vw cB cS dfwe2 3bitr4g $.
    $( [12-Jun-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d x y z w v u A $.  $d x y v u B $.  $d x y z w v u H $.
    $d x y z w v u R $.  $d v u S $.
    $( Any one-to-one onto function determines an isomorphism with an
       induced relation ` S ` .  Proposition 6.33 of [TakeutiZaring] p. 34. $)
    f1oiso $p |- ( ( H : A -1-1-onto-> B /\ S = { <. z , w >. |
     E. x e. A E. y e. A ( ( z = ( H ` x ) /\ w = ( H ` y ) ) /\ x R y ) } ) ->
                  H Isom R , S ( A , B ) ) $=
      cA cB cR cS cH wiso cA cB cH wf1o vv cv vu cv cR wbr vv cv cH cfv vu cv
      cH cfv cS wbr wb vu cA wral vv cA wral cA cB cH wf1o cS vz cv vx cv cH
      cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx
      cA wrex vz vw copab wceq wa vv vu cA cB cR cS cH df-iso cA cB cH wf1o cS
      vz cv vx cv cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa
      vy cA wrex vx cA wrex vz vw copab wceq pm3.26 cA cB cH wf1 cS vz cv vx cv
      cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex
      vx cA wrex vz vw copab wceq vv cv vu cv cR wbr vv cv cH cfv vu cv cH cfv
      cS wbr wb vu cA wral vv cA wral cA cB cH wf1o cA cB cH wf1 cS vz cv vx cv
      cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex
      vx cA wrex vz vw copab wceq wa vv cv vu cv cR wbr vv cv cH cfv vu cv cH
      cfv cS wbr wb vu cA wral vv cA cA cB cH wf1 cS vz cv vx cv cH cfv wceq vw
      cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz vw
      copab wceq wa vv cv cA wcel vv cv vu cv cR wbr vv cv cH cfv vu cv cH cfv
      cS wbr wb vu cA cA cB cH wf1 cS vz cv vx cv cH cfv wceq vw cv vy cv cH
      cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz vw copab wceq
      wa vv cv cA wcel vu cv cA wcel vv cv vu cv cR wbr vv cv cH cfv vu cv cH
      cfv cS wbr wb cA cB cH wf1 cS vz cv vx cv cH cfv wceq vw cv vy cv cH cfv
      wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz vw copab wceq wa
      vv cv cA wcel vu cv cA wcel wa wa vv cv cH cfv vu cv cH cfv cop cS wcel
      vv cv vu cv cR wbr vv cv cH cfv vu cv cH cfv cS wbr cA cB cH wf1 vv cv cA
      wcel vu cv cA wcel wa cS vz cv vx cv cH cfv wceq vw cv vy cv cH cfv wceq
      wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz vw copab wceq vv cv cH
      cfv vu cv cH cfv cop cS wcel vv cv vu cv cR wbr wb cS vz cv vx cv cH cfv
      wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA
      wrex vz vw copab wceq vv cv cH cfv vu cv cH cfv cop cS wcel vv cv cH cfv
      vu cv cH cfv cop vz cv vx cv cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv
      vy cv cR wbr wa vy cA wrex vx cA wrex vz vw copab wcel cA cB cH wf1 vv cv
      cA wcel vu cv cA wcel wa wa vv cv vu cv cR wbr cS vz cv vx cv cH cfv wceq
      vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz
      vw copab vv cv cH cfv vu cv cH cfv cop eleq2 cA cB cH wf1 vv cv cA wcel
      vu cv cA wcel wa wa vv cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH
      cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vv cv vu cv cR
      wbr vv cv cH cfv vu cv cH cfv cop vz cv vx cv cH cfv wceq vw cv vy cv cH
      cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz vw copab wcel
      cA cB cH wf1 vv cv cA wcel vu cv cA wcel vv cv cH cfv vx cv cH cfv wceq
      vu cv cH cfv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA
      wrex vv cv vu cv cR wbr wb cA cB cH wf1 vv cv cA wcel wa vv cv cH cfv vx
      cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy
      cA wrex vx cA wrex vu cv cH cfv vy cv cH cfv wceq vv cv vy cv cR wbr wa
      vy cA wrex cA cB cH wf1 vu cv cA wcel wa vv cv vu cv cR wbr cA cB cH wf1
      vv cv cA wcel wa vv cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH cfv
      wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vx cv vv cv wceq vu
      cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr wa vy cA wrex wa vx cA
      wrex vu cv cH cfv vy cv cH cfv wceq vv cv vy cv cR wbr wa vy cA wrex cA
      cB cH wf1 vv cv cA wcel wa vv cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy
      cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cv vv cv wceq vu cv
      cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr wa vy cA wrex wa vx cA cA cB
      cH wf1 vv cv cA wcel wa vx cv cA wcel wa vv cv cH cfv vx cv cH cfv wceq
      vu cv cH cfv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cv
      vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr wa wa vy cA
      wrex vx cv vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr
      wa vy cA wrex wa cA cB cH wf1 vv cv cA wcel wa vx cv cA wcel wa vv cv cH
      cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq wa vx cv vy cv cR
      wbr wa vx cv vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr
      wa wa vy cA cA cB cH wf1 vv cv cA wcel wa vx cv cA wcel wa vv cv cH cfv
      vx cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr wa wa
      vx cv vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr wa wa
      vv cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq wa vx cv vy
      cv cR wbr wa cA cB cH wf1 vv cv cA wcel wa vx cv cA wcel wa vv cv cH cfv
      vx cv cH cfv wceq vx cv vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv
      vy cv cR wbr wa cA cB cH wf1 vv cv cA wcel vx cv cA wcel vv cv cH cfv vx
      cv cH cfv wceq vx cv vv cv wceq wb cA cB cH wf1 vv cv cA wcel vx cv cA
      wcel wa wa vv cv cH cfv vx cv cH cfv wceq vv cv vx cv wceq vx cv vv cv
      wceq cA cB vv cv vx cv cH f1fveq vv cv vx cv eqcom syl6bb anassrs anbi1d
      vv cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv
      cR wbr anass syl5bb rexbidv vx cv vv cv wceq vu cv cH cfv vy cv cH cfv
      wceq vx cv vy cv cR wbr wa vy cA r19.42v syl6bb rexbidva vv cv cA wcel vx
      cv vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR wbr wa vy cA
      wrex wa vx cA wrex vu cv cH cfv vy cv cH cfv wceq vv cv vy cv cR wbr wa
      vy cA wrex wb cA cB cH wf1 vu cv cH cfv vy cv cH cfv wceq vx cv vy cv cR
      wbr wa vy cA wrex vu cv cH cfv vy cv cH cfv wceq vv cv vy cv cR wbr wa vy
      cA wrex vx vv cv cA vx cv vv cv wceq vu cv cH cfv vy cv cH cfv wceq vx cv
      vy cv cR wbr wa vu cv cH cfv vy cv cH cfv wceq vv cv vy cv cR wbr wa vy
      cA vx cv vv cv wceq vx cv vy cv cR wbr vv cv vy cv cR wbr vu cv cH cfv vy
      cv cH cfv wceq vx cv vv cv vy cv cR breq1 anbi2d rexbidv ceqsrexv adantl
      bitrd cA cB cH wf1 vu cv cA wcel wa vu cv cH cfv vy cv cH cfv wceq vv cv
      vy cv cR wbr wa vy cA wrex vy cv vu cv wceq vv cv vy cv cR wbr wa vy cA
      wrex vv cv vu cv cR wbr cA cB cH wf1 vu cv cA wcel wa vu cv cH cfv vy cv
      cH cfv wceq vv cv vy cv cR wbr wa vy cv vu cv wceq vv cv vy cv cR wbr wa
      vy cA cA cB cH wf1 vu cv cA wcel wa vy cv cA wcel wa vu cv cH cfv vy cv
      cH cfv wceq vy cv vu cv wceq vv cv vy cv cR wbr cA cB cH wf1 vu cv cA
      wcel vy cv cA wcel vu cv cH cfv vy cv cH cfv wceq vy cv vu cv wceq wb cA
      cB cH wf1 vu cv cA wcel vy cv cA wcel wa wa vu cv cH cfv vy cv cH cfv
      wceq vu cv vy cv wceq vy cv vu cv wceq cA cB vu cv vy cv cH f1fveq vu cv
      vy cv eqcom syl6bb anassrs anbi1d rexbidva vu cv cA wcel vy cv vu cv wceq
      vv cv vy cv cR wbr wa vy cA wrex vv cv vu cv cR wbr wb cA cB cH wf1 vv cv
      vy cv cR wbr vv cv vu cv cR wbr vy vu cv cA vy cv vu cv vv cv cR breq2
      ceqsrexv adantl bitrd sylan9bb anandis vz cv vx cv cH cfv wceq vw cv vy
      cv cH cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vv cv cH
      cfv vx cv cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vy
      cA wrex vx cA wrex vv cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH
      cfv wceq wa vx cv vy cv cR wbr wa vy cA wrex vx cA wrex vz vw vv cv cH
      cfv vu cv cH cfv vv cv cH fvex vu cv cH fvex vz cv vv cv cH cfv wceq vz
      cv vx cv cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vv
      cv cH cfv vx cv cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr
      wa vx vy cA cA vz cv vv cv cH cfv wceq vz cv vx cv cH cfv wceq vw cv vy
      cv cH cfv wceq wa vv cv cH cfv vx cv cH cfv wceq vw cv vy cv cH cfv wceq
      wa vx cv vy cv cR wbr vz cv vv cv cH cfv wceq vz cv vx cv cH cfv wceq vv
      cv cH cfv vx cv cH cfv wceq vw cv vy cv cH cfv wceq vz cv vv cv cH cfv vx
      cv cH cfv eqeq1 anbi1d anbi1d 2rexbidv vw cv vu cv cH cfv wceq vv cv cH
      cfv vx cv cH cfv wceq vw cv vy cv cH cfv wceq wa vx cv vy cv cR wbr wa vv
      cv cH cfv vx cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq wa vx cv vy cv
      cR wbr wa vx vy cA cA vw cv vu cv cH cfv wceq vv cv cH cfv vx cv cH cfv
      wceq vw cv vy cv cH cfv wceq wa vv cv cH cfv vx cv cH cfv wceq vu cv cH
      cfv vy cv cH cfv wceq wa vx cv vy cv cR wbr vw cv vu cv cH cfv wceq vw cv
      vy cv cH cfv wceq vu cv cH cfv vy cv cH cfv wceq vv cv cH cfv vx cv cH
      cfv wceq vw cv vu cv cH cfv vy cv cH cfv eqeq1 anbi2d anbi1d 2rexbidv
      opelopab syl5bb sylan9bbr an1rs vv cv cH cfv vu cv cH cfv cS df-br
      syl5rbb exp32 r19.21adv r19.21aiv cA cB cH f1of1 sylan sylanbrc $.
      $( [21-Jun-2004] $) $( [30-Apr-2004] $)
  $}

  ${
    $d z w R $.  $d x y z w S $.  $d z w A $.  $d z w B $.  $d x y z w F $.
    f1owe.1 $e |- R = { <. x , y >. | ( F ` x ) S ( F ` y ) } $.
    $( Well-ordering of isomorphic relations. $)
    f1owe $p |- ( F : A -1-1-onto-> B -> ( S We B -> R We A ) ) $=
      cA cB cF wf1o cA cR wwe cB cS wwe cA cB cF wf1o vz cv vw cv cR wbr vz cv
      cF cfv vw cv cF cfv cS wbr wb vw cA wral vz cA wral cA cR wwe cB cS wwe
      wb vz cv vw cv cR wbr vz cv cF cfv vw cv cF cfv cS wbr wb vz vw cA vx cv
      cF cfv vy cv cF cfv cS wbr vz cv cF cfv vy cv cF cfv cS wbr vz cv cF cfv
      vw cv cF cfv cS wbr vx vy vz cv vw cv cA cA cR vx cv vz cv wceq vx cv cF
      cfv vz cv cF cfv vy cv cF cfv cS vx cv vz cv cF fveq2 breq1d vy cv vw cv
      wceq vy cv cF cfv vw cv cF cfv vz cv cF cfv cS vy cv vw cv cF fveq2
      breq2d f1owe.1 brabg rgen2a cA cB cF wf1o vz cv vw cv cR wbr vz cv cF cfv
      vw cv cF cfv cS wbr wb vw cA wral vz cA wral wa cA cB cR cS cF wiso cA cR
      wwe cB cS wwe wb vz vw cA cB cR cS cF df-iso cA cB cR cS cF isowe sylbir
      mpan2 biimprd $.
      $( [13-Jun-2004] $) $( [4-Mar-1997] $)
  $}

  ${
    $d z w v u f R $.  $d x y z w v u f S $.  $d z w v u f A $.
    $d z w v u f B $.  $d x y z w v u f F $.
    f1oweALT.1 $e |- R = { <. x , y >. | ( F ` x ) S ( F ` y ) } $.
    $( Well-ordering of isomorphic relations.  (This version is proved directly
       instead of wit the isomorphism predicate.) $)
    f1oweALT $p |- ( F : A -1-1-onto-> B -> ( S We B -> R We A ) ) $=
      cA cB cF wf1o cB cS wfr vu cv vf cv cS wbr vu cv vf cv wceq vf cv vu cv
      cS wbr w3o vf cB wral vu cB wral wa cA cR wfr vw cv vv cv cR wbr vw cv vv
      cv wceq vv cv vw cv cR wbr w3o vv cA wral vw cA wral wa cB cS wwe cA cR
      wwe cA cB cF wf1o cB cS wfr cA cR wfr vu cv vf cv cS wbr vu cv vf cv wceq
      vf cv vu cv cS wbr w3o vf cB wral vu cB wral vw cv vv cv cR wbr vw cv vv
      cv wceq vv cv vw cv cR wbr w3o vv cA wral vw cA wral cA cB cF wf1o cA cB
      cF wfo cB cS wfr cA cR wfr wi cA cB cF f1ofo cA cB cF wfo cF cA wfn cF
      crn cB wceq wa cB cS wfr cA cR wfr wi cA cB cF df-fo cF crn cB wceq cB cS
      wfr cF crn cS wfr cF cA wfn cA cR wfr cF crn cB wceq cF crn cS wfr cB cS
      wfr cF crn cB cS freq2 biimprd cF cA wfn cF wfun cF cdm cA wceq wa cF crn
      cS wfr cA cR wfr wi cF cA df-fn cF wfun cF crn cS wfr cF cdm cR wfr cF
      cdm cA wceq cA cR wfr cF wfun cF crn cS wfr vz cv cF cdm wss vz cv c0 wne
      wa vv cv vw cv cR wbr wn vv vz cv wral vw vz cv wrex wi vz wal cF cdm cR
      wfr cF wfun cF crn cS wfr vz cv cF cdm wss vz cv c0 wne wa vv cv vw cv cR
      wbr wn vv vz cv wral vw vz cv wrex wi vz cF wfun cF crn cS wfr vz cv cF
      cdm wss vz cv c0 wne vv cv vw cv cR wbr wn vv vz cv wral vw vz cv wrex cF
      wfun vz cv cF cdm wss cF crn cS wfr vz cv c0 wne vv cv vw cv cR wbr wn vv
      vz cv wral vw vz cv wrex wi cF wfun vz cv cF cdm wss vz cv c0 wne cF crn
      cS wfr vv cv vw cv cR wbr wn vv vz cv wral vw vz cv wrex cF wfun vz cv cF
      cdm wss vz cv c0 wne cF crn cS wfr vv cv vw cv cR wbr wn vv vz cv wral vw
      vz cv wrex cF wfun vz cv cF cdm wss wa vz cv c0 wne cF crn cS wfr wa vf
      cv vu cv cS wbr wn vf cF vz cv cima wral vu cF vz cv cima wrex vv cv vw
      cv cR wbr wn vv vz cv wral vw vz cv wrex cF wfun vz cv cF cdm wss wa vz
      cv c0 wne cF crn cS wfr vf cv vu cv cS wbr wn vf cF vz cv cima wral vu cF
      vz cv cima wrex cF wfun vz cv cF cdm wss vz cv c0 wne cF crn cS wfr vf cv
      vu cv cS wbr wn vf cF vz cv cima wral vu cF vz cv cima wrex wi wi cF wfun
      cF wfun vz cv cF cdm wss wa vz cv c0 wne cF crn cS wfr vf cv vu cv cS wbr
      wn vf cF vz cv cima wral vu cF vz cv cima wrex wi cF wfun cF crn cS wfr
      cF wfun vz cv cF cdm wss wa vz cv c0 wne wa vf cv vu cv cS wbr wn vf cF
      vz cv cima wral vu cF vz cv cima wrex cF wfun vw cv cF crn wss vw cv c0
      wne wa vf cv vu cv cS wbr wn vf vw cv wral vu vw cv wrex wi vw wal cF
      wfun vz cv cF cdm wss wa vz cv c0 wne wa vf cv vu cv cS wbr wn vf cF vz
      cv cima wral vu cF vz cv cima wrex wi cF crn cS wfr cF wfun cF vz cv cima
      cvv wcel vw cv cF crn wss vw cv c0 wne wa vf cv vu cv cS wbr wn vf vw cv
      wral vu vw cv wrex wi vw wal cF wfun vz cv cF cdm wss wa vz cv c0 wne wa
      vf cv vu cv cS wbr wn vf cF vz cv cima wral vu cF vz cv cima wrex wi wi
      cF vz cv vz visset funimaex cF vz cv cima cvv wcel vw cv cF crn wss vw cv
      c0 wne wa vf cv vu cv cS wbr wn vf vw cv wral vu vw cv wrex wi vw wal cF
      vz cv cima cF crn wss cF vz cv cima c0 wne wa vf cv vu cv cS wbr wn vf cF
      vz cv cima wral vu cF vz cv cima wrex cF wfun vz cv cF cdm wss wa vz cv
      c0 wne wa vw cv cF crn wss vw cv c0 wne wa vf cv vu cv cS wbr wn vf vw cv
      wral vu vw cv wrex wi cF vz cv cima cF crn wss cF vz cv cima c0 wne wa vf
      cv vu cv cS wbr wn vf cF vz cv cima wral vu cF vz cv cima wrex wi vw cF
      vz cv cima cvv vw cv cF vz cv cima wceq vw cv cF crn wss vw cv c0 wne wa
      cF vz cv cima cF crn wss cF vz cv cima c0 wne wa vf cv vu cv cS wbr wn vf
      vw cv wral vu vw cv wrex vf cv vu cv cS wbr wn vf cF vz cv cima wral vu
      cF vz cv cima wrex vw cv cF vz cv cima wceq vw cv cF crn wss cF vz cv
      cima cF crn wss vw cv c0 wne cF vz cv cima c0 wne vw cv cF vz cv cima cF
      crn sseq1 vw cv cF vz cv cima c0 neeq1 anbi12d vf cv vu cv cS wbr wn vf
      vw cv wral vf cv vu cv cS wbr wn vf cF vz cv cima wral vu vw cv cF vz cv
      cima vf cv vu cv cS wbr wn vf vw cv cF vz cv cima raleq1 rexeqd imbi12d
      cla4gv cF wfun vz cv cF cdm wss wa vz cv c0 wne wa cF vz cv cima c0 wne
      cF vz cv cima cF crn wss cF wfun vz cv cF cdm wss wa vz cv c0 wne cF vz
      cv cima c0 wne cF wfun vz cv cF cdm wss wa vw cv vz cv wcel vw wex cF vz
      cv cima c0 wne vz cv c0 wne cF wfun vz cv cF cdm wss wa vw cv vz cv wcel
      cF vz cv cima c0 wne vw cF wfun vz cv cF cdm wss wa vw cv vz cv wcel vw
      cv cF cfv cF vz cv cima wcel cF vz cv cima c0 wne vz cv vw cv cF
      funfvima2 cF vz cv cima vw cv cF cfv ne0i syl6 19.23adv vw vz cv n0
      syl5ib imp cF vz cv imassrn jctil syl7 syl vw vu vf cF crn cS df-fr
      syl5ib com23 exp3a anabsi5 imp3a cF wfun vz cv cF cdm wss wa vz cv cF vz
      cv cima cF vz cv cres wfo vv cv vw cv cR wbr wn vv vz cv wral vw vz cv
      wrex vf cv vu cv cS wbr wn vf cF vz cv cima wral vu cF vz cv cima wrex wb
      vz cv cF fores vz cv cF vz cv cima cF vz cv cres wfo vv cv cF vz cv cres
      cfv vw cv cF vz cv cres cfv cS wbr wn vv vz cv wral vw vz cv wrex vf cv
      vu cv cS wbr wn vf cF vz cv cima wral vu cF vz cv cima wrex vv cv vw cv
      cR wbr wn vv vz cv wral vw vz cv wrex vz cv cF vz cv cima cF vz cv cres
      wfo vv cv cF vz cv cres cfv vw cv cF vz cv cres cfv cS wbr wn vv vz cv
      wral vw vz cv wrex vf cv vw cv cF vz cv cres cfv cS wbr wn vf cF vz cv
      cima wral vw vz cv wrex vf cv vu cv cS wbr wn vf cF vz cv cima wral vu cF
      vz cv cima wrex vz cv cF vz cv cima cF vz cv cres wfo vv cv cF vz cv cres
      cfv vw cv cF vz cv cres cfv cS wbr wn vv vz cv wral vf cv vw cv cF vz cv
      cres cfv cS wbr wn vf cF vz cv cima wral vw vz cv vv cv cF vz cv cres cfv
      vw cv cF vz cv cres cfv cS wbr wn vf cv vw cv cF vz cv cres cfv cS wbr wn
      vv vf vz cv cF vz cv cima cF vz cv cres vv cv cF vz cv cres cfv vf cv
      wceq vv cv cF vz cv cres cfv vw cv cF vz cv cres cfv cS wbr vf cv vw cv
      cF vz cv cres cfv cS wbr vv cv cF vz cv cres cfv vf cv vw cv cF vz cv
      cres cfv cS breq1 notbid cbvfo rexbidv vf cv vw cv cF vz cv cres cfv cS
      wbr wn vf cF vz cv cima wral vf cv vu cv cS wbr wn vf cF vz cv cima wral
      vw vu vz cv cF vz cv cima cF vz cv cres vw cv cF vz cv cres cfv vu cv
      wceq vf cv vw cv cF vz cv cres cfv cS wbr wn vf cv vu cv cS wbr wn vf cF
      vz cv cima vw cv cF vz cv cres cfv vu cv wceq vf cv vw cv cF vz cv cres
      cfv cS wbr vf cv vu cv cS wbr vw cv cF vz cv cres cfv vu cv vf cv cS
      breq2 notbid ralbidv cbvexfo bitrd vv cv vw cv cR wbr wn vv vz cv wral vv
      cv cF vz cv cres cfv vw cv cF vz cv cres cfv cS wbr wn vv vz cv wral vw
      vz cv vw cv vz cv wcel vv cv vw cv cR wbr wn vv cv cF vz cv cres cfv vw
      cv cF vz cv cres cfv cS wbr wn vv vz cv vw cv vz cv wcel vv cv vz cv wcel
      wa vv cv vw cv cR wbr vv cv cF vz cv cres cfv vw cv cF vz cv cres cfv cS
      wbr vw cv vz cv wcel vv cv vz cv wcel wa vv cv cF vz cv cres cfv vw cv cF
      vz cv cres cfv cS wbr vv cv cF cfv vw cv cF cfv cS wbr vv cv vw cv cR wbr
      vv cv vz cv wcel vw cv vz cv wcel vv cv cF vz cv cres cfv vv cv cF cfv vw
      cv cF vz cv cres cfv vw cv cF cfv cS vv cv vz cv cF fvres vw cv vz cv cF
      fvres breqan12rd vx cv cF cfv vy cv cF cfv cS wbr vv cv cF cfv vy cv cF
      cfv cS wbr vv cv cF cfv vw cv cF cfv cS wbr vx vy vv cv vw cv cR vv
      visset vw visset vx cv vv cv wceq vx cv cF cfv vv cv cF cfv vy cv cF cfv
      cS vx cv vv cv cF fveq2 breq1d vy cv vw cv wceq vy cv cF cfv vw cv cF cfv
      vv cv cF cfv cS vy cv vw cv cF fveq2 breq2d f1oweALT.1 brab syl6rbbr
      notbid ralbidva rexbiia syl5bb syl sylibrd exp4b com34 com23 imp4a
      19.21adv vz vw vv cF cdm cR df-fr syl6ibr cF cdm cA wceq cF cdm cR wfr cA
      cR wfr cF cdm cA cR freq2 biimpd sylan9 sylbi sylan9r sylbi syl cA cB cF
      wf1o vw cv vv cv cR wbr vw cv vv cv wceq vv cv vw cv cR wbr w3o vv cA
      wral vw cA wral vu cv vf cv cS wbr vu cv vf cv wceq vf cv vu cv cS wbr
      w3o vf cB wral vu cB wral cA cB cF wf1o cA cB cF wf1 cA cB cF wfo wa vw
      cv vv cv cR wbr vw cv vv cv wceq vv cv vw cv cR wbr w3o vv cA wral vw cA
      wral vu cv vf cv cS wbr vu cv vf cv wceq vf cv vu cv cS wbr w3o vf cB
      wral vu cB wral wb cA cB cF df-f1o cA cB cF wf1 vw cv vv cv cR wbr vw cv
      vv cv wceq vv cv vw cv cR wbr w3o vv cA wral vw cA wral vw cv cF cfv vv
      cv cF cfv cS wbr vw cv cF cfv vv cv cF cfv wceq vv cv cF cfv vw cv cF cfv
      cS wbr w3o vv cA wral vw cA wral cA cB cF wfo vu cv vf cv cS wbr vu cv vf
      cv wceq vf cv vu cv cS wbr w3o vf cB wral vu cB wral cA cB cF wf1 vw cv
      vv cv cR wbr vw cv vv cv wceq vv cv vw cv cR wbr w3o vw cv cF cfv vv cv
      cF cfv cS wbr vw cv cF cfv vv cv cF cfv wceq vv cv cF cfv vw cv cF cfv cS
      wbr w3o vw vv cA cA cA cB cF wf1 vw cv cA wcel vv cv cA wcel wa wa vw cv
      vv cv cR wbr vw cv cF cfv vv cv cF cfv cS wbr vw cv vv cv wceq vw cv cF
      cfv vv cv cF cfv wceq vv cv vw cv cR wbr vv cv cF cfv vw cv cF cfv cS wbr
      vw cv vv cv cR wbr vw cv cF cfv vv cv cF cfv cS wbr wb cA cB cF wf1 vw cv
      cA wcel vv cv cA wcel wa wa vx cv cF cfv vy cv cF cfv cS wbr vw cv cF cfv
      vy cv cF cfv cS wbr vw cv cF cfv vv cv cF cfv cS wbr vx vy vw cv vv cv cR
      vw visset vv visset vx cv vw cv wceq vx cv cF cfv vw cv cF cfv vy cv cF
      cfv cS vx cv vw cv cF fveq2 breq1d vy cv vv cv wceq vy cv cF cfv vv cv cF
      cfv vw cv cF cfv cS vy cv vv cv cF fveq2 breq2d f1oweALT.1 brab a1i cA cB
      cF wf1 vw cv cA wcel vv cv cA wcel wa wa vw cv cF cfv vv cv cF cfv wceq
      vw cv vv cv wceq cA cB vw cv vv cv cF f1fveq bicomd vv cv vw cv cR wbr vv
      cv cF cfv vw cv cF cfv cS wbr wb cA cB cF wf1 vw cv cA wcel vv cv cA wcel
      wa wa vx cv cF cfv vy cv cF cfv cS wbr vv cv cF cfv vy cv cF cfv cS wbr
      vv cv cF cfv vw cv cF cfv cS wbr vx vy vv cv vw cv cR vv visset vw visset
      vx cv vv cv wceq vx cv cF cfv vv cv cF cfv vy cv cF cfv cS vx cv vv cv cF
      fveq2 breq1d vy cv vw cv wceq vy cv cF cfv vw cv cF cfv vv cv cF cfv cS
      vy cv vw cv cF fveq2 breq2d f1oweALT.1 brab a1i 3orbi123d 2ralbidva cA cB
      cF wfo vw cv cF cfv vv cv cF cfv cS wbr vw cv cF cfv vv cv cF cfv wceq vv
      cv cF cfv vw cv cF cfv cS wbr w3o vv cA wral vw cA wral vu cv vv cv cF
      cfv cS wbr vu cv vv cv cF cfv wceq vv cv cF cfv vu cv cS wbr w3o vv cA
      wral vu cB wral vu cv vf cv cS wbr vu cv vf cv wceq vf cv vu cv cS wbr
      w3o vf cB wral vu cB wral vw cv cF cfv vv cv cF cfv cS wbr vw cv cF cfv
      vv cv cF cfv wceq vv cv cF cfv vw cv cF cfv cS wbr w3o vv cA wral vu cv
      vv cv cF cfv cS wbr vu cv vv cv cF cfv wceq vv cv cF cfv vu cv cS wbr w3o
      vv cA wral vw vu cA cB cF vw cv cF cfv vu cv wceq vw cv cF cfv vv cv cF
      cfv cS wbr vw cv cF cfv vv cv cF cfv wceq vv cv cF cfv vw cv cF cfv cS
      wbr w3o vu cv vv cv cF cfv cS wbr vu cv vv cv cF cfv wceq vv cv cF cfv vu
      cv cS wbr w3o vv cA vw cv cF cfv vu cv wceq vw cv cF cfv vv cv cF cfv cS
      wbr vu cv vv cv cF cfv cS wbr vw cv cF cfv vv cv cF cfv wceq vu cv vv cv
      cF cfv wceq vv cv cF cfv vw cv cF cfv cS wbr vv cv cF cfv vu cv cS wbr vw
      cv cF cfv vu cv vv cv cF cfv cS breq1 vw cv cF cfv vu cv vv cv cF cfv
      eqeq1 vw cv cF cfv vu cv vv cv cF cfv cS breq2 3orbi123d ralbidv cbvfo cA
      cB cF wfo vu cv vv cv cF cfv cS wbr vu cv vv cv cF cfv wceq vv cv cF cfv
      vu cv cS wbr w3o vv cA wral vu cv vf cv cS wbr vu cv vf cv wceq vf cv vu
      cv cS wbr w3o vf cB wral vu cB vu cv vv cv cF cfv cS wbr vu cv vv cv cF
      cfv wceq vv cv cF cfv vu cv cS wbr w3o vu cv vf cv cS wbr vu cv vf cv
      wceq vf cv vu cv cS wbr w3o vv vf cA cB cF vv cv cF cfv vf cv wceq vu cv
      vv cv cF cfv cS wbr vu cv vf cv cS wbr vu cv vv cv cF cfv wceq vu cv vf
      cv wceq vv cv cF cfv vu cv cS wbr vf cv vu cv cS wbr vv cv cF cfv vf cv
      vu cv cS breq2 vv cv cF cfv vf cv vu cv eqeq2 vv cv cF cfv vf cv vu cv cS
      breq1 3orbi123d cbvfo ralbidv bitrd sylan9bb sylbi biimprd anim12d vu vf
      cB cS dfwe2 vw vv cA cR dfwe2 3imtr4g $.
      $( [4-Mar-1997] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend class notation to include the value of an operation ` F ` (such
     as ` + ` ) for two arguments ` A ` and ` B ` .  Note that the syntax is
     simply three class symbols in a row surrounded by parentheses.  Since
     operation values are the only possible class expressions consisting of
     three class expressions in a row surrounded by parentheses, the syntax is
     unambiguous.  (For an example of how syntax could become ambiguous if we
     are not careful, see the comment in ~ cneg .) $)
  co $a class ( A F B ) $.

  $( Extend class notation to include class abstraction (class builder) of
     nested ordered pairs. $)
  copab2 $a class { <. <. x , y >. , z >. | ph } $.

  $( Define the value of an operation.  Definition of operation value in
     [Enderton] p. 79.  Note that the syntax is simply three class
     expressions in a row bracketed by parentheses.  There are no
     restrictions of any kind on what those class expressions may be,
     although only certain kinds of class expressions - a binary operation
     ` F ` and its arguments ` A ` and ` B ` - will be useful for proving
     meaningful theorems.  For example, if class ` F ` is the operation ` + `
     and arguments ` A ` and ` B ` are ` 3 ` and ` 2 ` , the expression
     ` ( 3 + 2 ) ` can be proved to equal ` 5 ` (see ~ 3p2e5 ).  This
     definition is well-defined, although not very meaningful, when classes
     ` A ` and/or ` B ` are proper classes (i.e. are not sets); see ~ oprprc1
     and ~ oprprc2 .  On the other hand, we often find uses for this
     definition when ` F ` is a proper class, such as ` +o ` in ~ oav .  ` F `
     is normally equal to a class of nested ordered pairs of the form defined
     by ~ df-oprab . $)
  df-opr $a |- ( A F B ) = ( F ` <. A , B >. ) $.

  ${
    $d x w $.  $d y w $.  $d z w $.  $d w ph $.
    $( Define the class abstraction (class builder) of a collection of nested
       ordered pairs (for use in defining operations).  This is a special case
       of Definition 4.16 of [TakeutiZaring] p. 14.  Normally ` x ` , ` y ` ,
       and ` z ` are distinct, although the definition doesn't strictly require
       it.  See ~ df-opr for the value of an operation.  The brace notation is
       called "class abstraction" by Quine; it is also called a "class builder"
       in the literature.  The value of the most common operation class builder
       is given by ~ oprabval2 . $)
    df-oprab $a |- { <. <. x , y >. , z >. | ph } =
                  { w | E. x E. y E. z ( w = <. <. x , y >. , z >. /\ ph ) } $.
  $}

  $( Equality theorem for operation value. $)
  opreq $p |- ( F = G -> ( A F B ) = ( A G B ) ) $=
    cF cG wceq cA cB cop cF cfv cA cB cop cG cfv cA cB cF co cA cB cG co cA cB
    cop cF cG fveq1 cA cB cF df-opr cA cB cG df-opr 3eqtr4g $.
    $( [28-Feb-1995] $)

  $( Equality theorem for operation value. $)
  opreq1 $p |- ( A = B -> ( A F C ) = ( B F C ) ) $=
    cA cB wceq cA cC cop cF cfv cB cC cop cF cfv cA cC cF co cB cC cF co cA cB
    wceq cA cC cop cB cC cop cF cA cB cC opeq1 fveq2d cA cC cF df-opr cB cC cF
    df-opr 3eqtr4g $.
    $( [28-Feb-1995] $)

  $( Equality theorem for operation value. $)
  opreq2 $p |- ( A = B -> ( C F A ) = ( C F B ) ) $=
    cA cB wceq cC cA cop cF cfv cC cB cop cF cfv cC cA cF co cC cB cF co cA cB
    wceq cC cA cop cC cB cop cF cA cB cC opeq2 fveq2d cC cA cF df-opr cC cB cF
    df-opr 3eqtr4g $.
    $( [28-Feb-1995] $)

  $( Equality theorem for operation value. $)
  opreq12 $p |- ( ( A = B /\ C = D ) -> ( A F C ) = ( B F D ) ) $=
    cA cB wceq cC cD wceq cA cC cF co cB cC cF co cB cD cF co cA cB cC cF
    opreq1 cC cD cB cF opreq2 sylan9eq $.
    $( [16-Jul-1995] $)

  ${
    opreq1i.1 $e |- A = B $.
    $( Equality inference for operation value. $)
    opreq1i $p |- ( A F C ) = ( B F C ) $=
      cA cB wceq cA cC cF co cB cC cF co wceq opreq1i.1 cA cB cC cF opreq1
      ax-mp $.
      $( [28-Feb-1995] $)

    $( Equality inference for operation value. $)
    opreq2i $p |- ( C F A ) = ( C F B ) $=
      cA cB wceq cC cA cF co cC cB cF co wceq opreq1i.1 cA cB cC cF opreq2
      ax-mp $.
      $( [28-Feb-1995] $)

    ${
      opreq12i.2 $e |- C = D $.
      $( Equality inference for operation value. $)
      opreq12i $p |- ( A F C ) = ( B F D ) $=
        cA cC cF co cB cC cF co cB cD cF co cA cB cC cF opreq1i.1 opreq1i cC cD
        cB cF opreq12i.2 opreq2i eqtri $.
        $( [28-Feb-1995] $)
    $}

    $( Equality inference for operation value. $)
    opreqi $p |- ( C A D ) = ( C B D ) $=
      cA cB wceq cC cD cA co cC cD cB co wceq opreq1i.1 cC cD cA cB opreq ax-mp
      $.
      $( [27-Nov-2007] $) $( [24-Nov-2007] $)
  $}

  ${
    opreq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for operation value. $)
    opreq1d $p |- ( ph -> ( A F C ) = ( B F C ) ) $=
      wph cA cB wceq cA cC cF co cB cC cF co wceq opreq1d.1 cA cB cC cF opreq1
      syl $.
      $( [13-Mar-1995] $)

    $( Equality deduction for operation value. $)
    opreq2d $p |- ( ph -> ( C F A ) = ( C F B ) ) $=
      wph cA cB wceq cC cA cF co cC cB cF co wceq opreq1d.1 cA cB cC cF opreq2
      syl $.
      $( [13-Mar-1995] $)

    $( Equality deduction for operation value. $)
    opreqd $p |- ( ph -> ( C A D ) = ( C B D ) ) $=
      wph cA cB wceq cC cD cA co cC cD cB co wceq opreq1d.1 cC cD cA cB opreq
      syl $.
      $( [10-Sep-2006] $) $( [9-Sep-2006] $)

    ${
      opreq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for operation value. $)
      opreq12d $p |- ( ph -> ( A F C ) = ( B F D ) ) $=
        wph cA cC cF co cB cC cF co cB cD cF co wph cA cB cC cF opreq1d.1
        opreq1d wph cC cD cB cF opreq12d.2 opreq2d eqtrd $.
        $( [13-Mar-1995] $)
    $}

    ${
      opreqan12i.2 $e |- ( ps -> C = D ) $.
      $( Equality deduction for operation value. $)
      opreqan12d $p |- ( ( ph /\ ps ) -> ( A F C ) = ( B F D ) ) $=
        cA cB wceq cC cD wceq cA cC cF co cB cD cF co wceq wph wps cA cB cC cD
        cF opreq12 opreq1d.1 opreqan12i.2 syl2an $.
        $( [10-Aug-1995] $)

      $( Equality deduction for operation value. $)
      opreqan12rd $p |- ( ( ps /\ ph ) -> ( A F C ) = ( B F D ) ) $=
        wph wps cA cC cF co cB cD cF co wceq wph wps cA cB cC cD cF opreq1d.1
        opreqan12i.2 opreqan12d ancoms $.
        $( [10-Aug-1995] $)
    $}
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    hbopr.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbopr.2 $e |- ( y e. F -> A. x y e. F ) $.
    hbopr.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for operation value. $)
    hbopr $p |- ( y e. ( A F B ) -> A. x y e. ( A F B ) ) $=
      vx vy cA cB cF co cA cB cop cF cfv cA cB cF df-opr vx vy cA cB cop cF
      hbopr.2 vx vy cA cB hbopr.1 hbopr.3 hbop hbfv hbxfr $.
      $( [5-May-2004] $) $( [4-May-2004] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z F $.  $d x y z $.  $d y ph $.
    hboprd.1 $e |- ( ph -> A. x ph ) $.
    hboprd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    hboprd.3 $e |- ( ph -> ( y e. F -> A. x y e. F ) ) $.
    hboprd.4 $e |- ( ph -> ( y e. B -> A. x y e. B ) ) $.
    $( Deduction version of bound-variable hypothesis builder ~ hbopr . $)
    hboprd $p |- ( ph -> ( y e. ( A F B ) -> A. x y e. ( A F B ) ) ) $=
      wph vy cv vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv
      cF wcel vx wal vz cab co wcel vy cv vz cv cA wcel vx wal vz cab vz cv cB
      wcel vx wal vz cab vz cv cF wcel vx wal vz cab co wcel vx wal vy cv cA cB
      cF co wcel vy cv cA cB cF co wcel vx wal vy cv vz cv cA wcel vx wal vz
      cab vz cv cB wcel vx wal vz cab vz cv cF wcel vx wal vz cab co wcel vy cv
      vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv cF wcel vx
      wal vz cab co wcel vx wal wi wph vx vy vz cv cA wcel vx wal vz cab vz cv
      cB wcel vx wal vz cab vz cv cF wcel vx wal vz cab vz cv cA wcel vx wal vx
      vz vy vz cv cA wcel vx hba1 hbab vz cv cF wcel vx wal vx vz vy vz cv cF
      wcel vx hba1 hbab vz cv cB wcel vx wal vx vz vy vz cv cB wcel vx hba1
      hbab hbopr a1i wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz
      cab vz cv cF wcel vx wal vz cab co cA cB cF co vy cv wph vz cv cA wcel vx
      wal vz cab vz cv cB wcel vx wal vz cab vz cv cF wcel vx wal vz cab co cA
      cB vz cv cF wcel vx wal vz cab co cA cB cF co wph vz cv cA wcel vx wal vz
      cab cA vz cv cB wcel vx wal vz cab cB vz cv cF wcel vx wal vz cab wph vy
      cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz cab cA
      wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy hboprd.2 19.21aiv vx vy
      vz cA abidhb syl wph vy cv cB wcel vy cv cB wcel vx wal wi vy wal vz cv
      cB wcel vx wal vz cab cB wceq wph vy cv cB wcel vy cv cB wcel vx wal wi
      vy hboprd.4 19.21aiv vx vy vz cB abidhb syl opreq12d wph vy cv cF wcel vy
      cv cF wcel vx wal wi vy wal vz cv cF wcel vx wal vz cab cF wceq cA cB vz
      cv cF wcel vx wal vz cab co cA cB cF co wceq wph vy cv cF wcel vy cv cF
      wcel vx wal wi vy hboprd.3 19.21aiv vx vy vz cF abidhb cA cB vz cv cF
      wcel vx wal vz cab cF opreq 3syl eqtrd eleq2d wph vy cv vz cv cA wcel vx
      wal vz cab vz cv cB wcel vx wal vz cab vz cv cF wcel vx wal vz cab co
      wcel vy cv cA cB cF co wcel vx hboprd.1 wph vz cv cA wcel vx wal vz cab
      vz cv cB wcel vx wal vz cab vz cv cF wcel vx wal vz cab co cA cB cF co vy
      cv wph vz cv cA wcel vx wal vz cab vz cv cB wcel vx wal vz cab vz cv cF
      wcel vx wal vz cab co cA cB vz cv cF wcel vx wal vz cab co cA cB cF co
      wph vz cv cA wcel vx wal vz cab cA vz cv cB wcel vx wal vz cab cB vz cv
      cF wcel vx wal vz cab wph vy cv cA wcel vy cv cA wcel vx wal wi vy wal vz
      cv cA wcel vx wal vz cab cA wceq wph vy cv cA wcel vy cv cA wcel vx wal
      wi vy hboprd.2 19.21aiv vx vy vz cA abidhb syl wph vy cv cB wcel vy cv cB
      wcel vx wal wi vy wal vz cv cB wcel vx wal vz cab cB wceq wph vy cv cB
      wcel vy cv cB wcel vx wal wi vy hboprd.4 19.21aiv vx vy vz cB abidhb syl
      opreq12d wph vy cv cF wcel vy cv cF wcel vx wal wi vy wal vz cv cF wcel
      vx wal vz cab cF wceq cA cB vz cv cF wcel vx wal vz cab co cA cB cF co
      wceq wph vy cv cF wcel vy cv cF wcel vx wal wi vy hboprd.3 19.21aiv vx vy
      vz cF abidhb cA cB vz cv cF wcel vx wal vz cab cF opreq 3syl eqtrd eleq2d
      albid 3imtr3d $.
      $( [8-Mar-2006] $) $( [13-Dec-2005] $)
  $}

  $( The result of an operation is a set. $)
  oprex $p |- ( A F B ) e. _V $=
    cA cB cF co cA cB cop cF cfv cvv cA cB cF df-opr cA cB cop cF fvex eqeltri
    $.
    $( [13-Mar-1995] $)

  ${
    oprprc1.1 $e |- Rel dom F $.
    $( The value of an operation when the first argument is a proper class.
       Note: this theorem is dependent on our particular definitions of
       operation value, function value, and ordered pair. $)
    oprprc1 $p |- ( -. A e. _V -> ( A F B ) = (/) ) $=
      cA cvv wcel wn cA cB cop cF cfv c0 cA cB cF co cA cvv wcel wn cA cB cop
      cF cdm wcel wn cA cB cop cF cfv c0 wceq cA cB cop cF cdm wcel cA cvv wcel
      cA cB cop cF cdm wcel cA cB cF cdm wbr cA cvv wcel cA cB cF cdm df-br cA
      cB cF cdm oprprc1.1 brrelexi sylbir con3i cA cB cop cF ndmfv syl cA cB cF
      df-opr syl5eq $.
      $( [17-Jun-2004] $) $( [16-Jun-2004] $)
  $}

  $( The value of an operation when the second argument is a proper class.
     Note: this theorem is dependent on our particular definitions of operation
     value, function value, and ordered pair. $)
  oprprc2 $p |- ( -. B e. _V -> ( A F B ) = ( A F A ) ) $=
    cB cvv wcel wn cA cB cop cF cfv cA cA cop cF cfv cA cB cF co cA cA cF co cB
    cvv wcel wn cA cB cop cA cA cop cF cA cB opprc2 fveq2d cA cB cF df-opr cA
    cA cF df-opr 3eqtr4g $.
    $( [22-Jun-2004] $) $( [16-Jun-2004] $)

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y z D $.  $d y z F $.
    $d x y z $.
    $( Move class substitution in and out of an operation. $)
    csboprg $p |- ( A e. D -> [_ A / x ]_ ( B F C ) =
           ( [_ A / x ]_ B [_ A / x ]_ F  [_ A / x ]_ C ) ) $=
      cA cD wcel vy cA vx vy cv cB cC cF co csb csb vy cA vx vy cv cB csb csb
      vy cA vx vy cv cC csb csb vy cA vx vy cv cF csb csb co vx cA cB cC cF co
      csb vx cA cB csb vx cA cC csb vx cA cF csb co vy vz cA vx vy cv cB cC cF
      co csb vy cA vx vy cv cB csb csb vy cA vx vy cv cC csb csb vy cA vx vy cv
      cF csb csb co cD cA cD wcel vy vz vy cA vx vy cv cB csb csb vy cA vx vy
      cv cC csb csb vy cA vx vy cv cF csb csb cA cD wcel vy ax-17 vy vz cA vx
      vy cv cB csb cD vz cv cA wcel vy ax-17 hbcsb1g vy vz cA vx vy cv cF csb
      cD vz cv cA wcel vy ax-17 hbcsb1g vy vz cA vx vy cv cC csb cD vz cv cA
      wcel vy ax-17 hbcsb1g hboprd vy cv cA wceq vx vy cv cB cC cF co csb vx vy
      cv cB csb vx vy cv cC csb vx vy cv cF csb co vy cA vx vy cv cB csb csb vy
      cA vx vy cv cC csb csb vx vy cv cF csb co vy cA vx vy cv cB csb csb vy cA
      vx vy cv cC csb csb vy cA vx vy cv cF csb csb co vx vy cv cB cC cF co csb
      vx vy cv cB csb vx vy cv cC csb vx vy cv cF csb co wceq vy cv cA wceq vx
      cv vy cv wceq vx wex vx vy cv cB cC cF co csb vx vy cv cB csb vx vy cv cC
      csb vx vy cv cF csb co wceq vx vy a9e vx cv vy cv wceq vx vy cv cB cC cF
      co csb vx vy cv cB csb vx vy cv cC csb vx vy cv cF csb co wceq vx vx vz
      vz vx vy cv cB cC cF co csb vx vy cv cB csb vx vy cv cC csb vx vy cv cF
      csb co vx vz vy cv cB cC cF co vy visset vz cv vy cv wcel vx ax-17 hbcsb1
      vx vz vx vy cv cB csb vx vy cv cC csb vx vy cv cF csb vx vz vy cv cB vy
      visset vz cv vy cv wcel vx ax-17 hbcsb1 vx vz vy cv cF vy visset vz cv vy
      cv wcel vx ax-17 hbcsb1 vx vz vy cv cC vy visset vz cv vy cv wcel vx
      ax-17 hbcsb1 hbopr hbeq vx cv vy cv wceq cB cC cF co vx vy cv cB csb vx
      vy cv cC csb cF co vx vy cv cB cC cF co csb vx vy cv cB csb vx vy cv cC
      csb vx vy cv cF csb co vx cv vy cv wceq cB vx vy cv cB csb cC vx vy cv cC
      csb cF vx vy cv cB csbeq1a vx vy cv cC csbeq1a opreq12d vx vy cv cB cC cF
      co csbeq1a vx cv vy cv wceq cF vx vy cv cF csb vx vy cv cB csb vx vy cv
      cC csb vx vy cv cF csbeq1a opreqd 3eqtr3d 19.23ai ax-mp a1i vy cv cA wceq
      vx vy cv cB csb vy cA vx vy cv cB csb csb vx vy cv cC csb vy cA vx vy cv
      cC csb csb vx vy cv cF csb vy cA vx vy cv cB csb csbeq1a vy cA vx vy cv
      cC csb csbeq1a opreq12d vy cv cA wceq vx vy cv cF csb vy cA vx vy cv cF
      csb csb vy cA vx vy cv cB csb csb vy cA vx vy cv cC csb csb vy cA vx vy
      cv cF csb csbeq1a opreqd 3eqtrd csbiegf vx vy cA cB cC cF co cD csbcog cA
      cD wcel vy cA vx vy cv cB csb csb vy cA vx vy cv cC csb csb vy cA vx vy
      cv cF csb csb co vx cA cB csb vx cA cC csb vy cA vx vy cv cF csb csb co
      vx cA cB csb vx cA cC csb vx cA cF csb co cA cD wcel vy cA vx vy cv cB
      csb csb vx cA cB csb vy cA vx vy cv cC csb csb vx cA cC csb vy cA vx vy
      cv cF csb csb vx vy cA cB cD csbcog vx vy cA cC cD csbcog opreq12d cA cD
      wcel vy cA vx vy cv cF csb csb vx cA cF csb vx cA cB csb vx cA cC csb vx
      vy cA cF cD csbcog opreqd eqtrd 3eqtr3d $.
      $( [13-Dec-2005] $) $( [12-Nov-2005] $)
  $}

  ${
    $d y A $.  $d y C $.  $d y D $.  $d x y F $.
    $( Move class substitution in and out of an operation. $)
    csbopr12g $p |- ( A e. D ->
                 [_ A / x ]_ ( B F C ) = ( [_ A / x ]_ B F [_ A / x ]_ C ) ) $=
      cA cD wcel vx cA cB cC cF co csb vx cA cB csb vx cA cC csb vx cA cF csb
      co vx cA cB csb vx cA cC csb cF co vx cA cB cC cD cF csboprg cA cD wcel
      vx cA cF csb cF vx cA cB csb vx cA cC csb vx vy cA cF cD vy cv cF wcel vx
      ax-17 csbconstgf opreqd eqtrd $.
      $( [13-Dec-2005] $) $( [12-Nov-2005] $)
  $}

  ${
    $d y A $.  $d x y C $.  $d y D $.  $d x y F $.
    $( Move class substitution in and out of an operation. $)
    csbopr1g $p |- ( A e. D ->
                  [_ A / x ]_ ( B F C ) = ( [_ A / x ]_ B F C ) ) $=
      cA cD wcel vx cA cB cC cF co csb vx cA cB csb vx cA cC csb cF co vx cA cB
      csb cC cF co vx cA cB cC cD cF csbopr12g cA cD wcel vx cA cC csb cC vx cA
      cB csb cF vx vy cA cC cD vy cv cC wcel vx ax-17 csbconstgf opreq2d eqtrd
      $.
      $( [13-Dec-2005] $) $( [12-Nov-2005] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d y D $.  $d x y F $.
    $( Move class substitution in and out of an operation. $)
    csbopr2g $p |- ( A e. D ->
                  [_ A / x ]_ ( B F C ) = ( B F [_ A / x ]_ C ) ) $=
      cA cD wcel vx cA cB cC cF co csb vx cA cB csb vx cA cC csb cF co cB vx cA
      cC csb cF co vx cA cB cC cD cF csbopr12g cA cD wcel vx cA cB csb cB vx cA
      cC csb cF vx vy cA cB cD vy cv cB wcel vx ax-17 csbconstgf opreq1d eqtrd
      $.
      $( [13-Jan-2006] $) $( [12-Nov-2005] $)
  $}

  ${
    $d x A $.  $d x y B $.  $d x y C $.  $d y D $.  $d x y F $.  $d x y S $.
    $( A frequently used special case of ~ rcla42ev for operation values. $)
    rcla4eopr $p |- ( ( C e. A /\ D e. B /\ S = ( C F D ) ) ->
                 E. x e. A E. y e. B S = ( x F y ) ) $=
      cS vx cv vy cv cF co wceq cS cC cD cF co wceq cS cC vy cv cF co wceq vx
      vy cC cD cA cB vx cv cC wceq vx cv vy cv cF co cC vy cv cF co cS vx cv cC
      vy cv cF opreq1 eqeq2d vy cv cD wceq cC vy cv cF co cC cD cF co cS vy cv
      cD cC cF opreq2 eqeq2d rcla42ev $.
      $( [23-Mar-2007] $) $( [21-Mar-2007] $)
  $}

  ${
    fnotoprb.1 $e |- R e. _V $.
    $( Equivalence of operation value and ordered triple membership, analogous
       to ~ fnopfvb . $)
    fnotoprb $p |- ( ( F Fn ( A X. B ) /\ C e. A /\ D e. B ) ->
                   ( ( C F D ) = R <-> <. <. C , D >. , R >. e. F ) ) $=
      cF cA cB cxp wfn cC cA wcel cD cB wcel cC cD cF co cR wceq cC cD cop cR
      cop cF wcel wb cF cA cB cxp wfn cC cD cop cA cB cxp wcel cC cD cF co cR
      wceq cC cD cop cR cop cF wcel wb cC cA wcel cD cB wcel wa cF cA cB cxp
      wfn cC cD cop cA cB cxp wcel wa cC cD cop cF cfv cR wceq cC cD cop cR cop
      cF wcel cC cD cF co cR wceq cA cB cxp cC cD cop cR cF fnotoprb.1 fnopfvb
      cC cD cF co cC cD cop cF cfv cR cC cD cF df-opr eqeq1i syl5bb cC cD cA cB
      opelxpi sylan2 3impb $.
      $( [9-Feb-2009] $) $( [17-Dec-2008] $)
  $}

  ${
    $d x z w v $.  $d y z w v $.  $d w ph v $.
    $( Class abstraction for operations in terms of class abstraction of
       ordered pairs. $)
    dfoprab2 $p |- { <. <. x , y >. , z >. | ph } =
                   { <. w , z >. | E. x E. y ( w = <. x , y >. /\ ph ) } $=
      vv cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy wex vx wex vv cab
      vv cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wph wa vy wex vx
      wex wa vz wex vw wex vv cab wph vx vy vz copab2 vw cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vw vz copab vv cv vx cv vy cv cop vz cv cop
      wceq wph wa vz wex vy wex vx wex vv cv vw cv vz cv cop wceq vw cv vx cv
      vy cv cop wceq wph wa vy wex vx wex wa vz wex vw wex vv vv cv vw cv vz cv
      cop wceq vw cv vx cv vy cv cop wceq wph wa wa vy wex vx wex vw wex vz wex
      vv cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wph wa wa vy wex vx
      wex vz wex vw wex vv cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy
      wex vx wex vv cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wph wa
      vy wex vx wex wa vz wex vw wex vv cv vw cv vz cv cop wceq vw cv vx cv vy
      cv cop wceq wph wa wa vy wex vx wex vz vw excom vv cv vw cv vz cv cop
      wceq vw cv vx cv vy cv cop wceq wph wa wa vy wex vx wex vw wex vz wex vv
      cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wph wa wa vw wex vz
      wex vy wex vx wex vv cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy
      wex vx wex vv cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wph wa
      wa vz vw vx vy exrot4 vv cv vw cv vz cv cop wceq vw cv vx cv vy cv cop
      wceq wph wa wa vw wex vv cv vx cv vy cv cop vz cv cop wceq wph wa vx vy
      vz vv cv vx cv vy cv cop vz cv cop wceq wph wa vw cv vx cv vy cv cop wceq
      wa vw wex vv cv vx cv vy cv cop vz cv cop wceq wph wa vw cv vx cv vy cv
      cop wceq vw wex wa vv cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq
      wph wa wa vw wex vv cv vx cv vy cv cop vz cv cop wceq wph wa vv cv vx cv
      vy cv cop vz cv cop wceq wph wa vw cv vx cv vy cv cop wceq vw 19.42v vv
      cv vw cv vz cv cop wceq vw cv vx cv vy cv cop wceq wph wa wa vv cv vx cv
      vy cv cop vz cv cop wceq wph wa vw cv vx cv vy cv cop wceq wa vw vv cv vw
      cv vz cv cop wceq vw cv vx cv vy cv cop wceq wa wph wa vv cv vx cv vy cv
      cop vz cv cop wceq vw cv vx cv vy cv cop wceq wa wph wa vv cv vw cv vz cv
      cop wceq vw cv vx cv vy cv cop wceq wph wa wa vv cv vx cv vy cv cop vz cv
      cop wceq wph wa vw cv vx cv vy cv cop wceq wa vv cv vw cv vz cv cop wceq
      vw cv vx cv vy cv cop wceq wa vv cv vx cv vy cv cop vz cv cop wceq vw cv
      vx cv vy cv cop wceq wa wph vw cv vx cv vy cv cop wceq vv cv vw cv vz cv
      cop wceq vv cv vx cv vy cv cop vz cv cop wceq vw cv vx cv vy cv cop wceq
      vw cv vz cv cop vx cv vy cv cop vz cv cop vv cv vw cv vx cv vy cv cop vz
      cv opeq1 eqeq2d pm5.32ri anbi1i vv cv vw cv vz cv cop wceq vw cv vx cv vy
      cv cop wceq wph anass vv cv vx cv vy cv cop vz cv cop wceq vw cv vx cv vy
      cv cop wceq wph an23 3bitr3i exbii vw cv vx cv vy cv cop wceq vw wex vv
      cv vx cv vy cv cop vz cv cop wceq wph wa vw vx cv vy cv cop vx cv vy cv
      opex isseti biantru 3bitr4i 3exbii bitri vv cv vw cv vz cv cop wceq vw cv
      vx cv vy cv cop wceq wph wa wa vy wex vx wex vv cv vw cv vz cv cop wceq
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex wa vw vz vv cv vw cv vz
      cv cop wceq vw cv vx cv vy cv cop wceq wph wa vx vy 19.42vv 2exbii
      3bitr3i abbii wph vx vy vz vv df-oprab vw cv vx cv vy cv cop wceq wph wa
      vy wex vx wex vw vz vv df-opab 3eqtr4i $.
      $( [12-Mar-1995] $)

    $( An operation class abstraction is a relation. $)
    reloprab $p |- Rel { <. <. x , y >. , z >. | ph } $=
      wph vx vy vz copab2 wrel vw cv vx cv vy cv cop wceq wph wa vy wex vx wex
      vw vz copab wrel vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw vz
      relopab wph vx vy vz copab2 vw cv vx cv vy cv cop wceq wph wa vy wex vx
      wex vw vz copab wph vx vy vz vw dfoprab2 releqi mpbir $.
      $( [22-Jun-2004] $) $( [16-Jun-2004] $)
  $}

$(
  @{
    @d x y z w v @.  @d ph v @.
    dfoprab2f.1 @e |- ( ph -> A. w ph ) @.
    @( Class abstraction for operations in terms of class abstraction of
       ordered pairs.  This is a version of ~ dfoprab2 with bound-variable
       hypothesis instead of distinct variable requirement. @)
    dfoprab2f @p |- { <. <. x , y >. , z >. | ph } =
                   { <. w , z >. | E. x E. y ( w = <. x , y >. /\ ph ) } @=
      ( vv copab2 cv cop wceq wa wex copab dfoprab2 ax-17 hban hbex weq eqeq1
      anbi1d 2exbidv cbvopab1
      eqtri ) ABCDHGIZBICIJZKZALZCMZBMZGDNEIZUFKZALZCMBM
      ZEDNABCDGOUJUNGDEUIEBUHECUGAEUGEPFQRRUNGPGESZUHUMBCUOUGULAUEUKUFTUAUBUCUD
      @.
  @}
$)

  ${
    $d x y z v $.  $d x w $.  $d ph v $.
    $( The abstraction variables in an operation class abstraction are not
       free. $)
    hboprab1 $p |- ( w e. { <. <. x , y >. , z >. | ph } ->
                   A. x w e. { <. <. x , y >. , z >. | ph } ) $=
      vx vw wph vx vy vz copab2 vv cv vx cv vy cv cop vz cv cop wceq wph wa vz
      wex vy wex vx wex vv cab wph vx vy vz vv df-oprab vv cv vx cv vy cv cop
      vz cv cop wceq wph wa vz wex vy wex vx wex vx vv vw vv cv vx cv vy cv cop
      vz cv cop wceq wph wa vz wex vy wex vx hbe1 hbab hbxfr $.
      $( [25-Apr-1995] $)
  $}

  ${
    $d x y z v $.  $d y w $.  $d ph v $.
    $( The abstraction variables in an operation class abstraction are not
       free. $)
    hboprab2 $p |- ( w e. { <. <. x , y >. , z >. | ph } ->
                   A. y w e. { <. <. x , y >. , z >. | ph } ) $=
      vy vw wph vx vy vz copab2 vv cv vx cv vy cv cop vz cv cop wceq wph wa vz
      wex vy wex vx wex vv cab wph vx vy vz vv df-oprab vv cv vx cv vy cv cop
      vz cv cop wceq wph wa vz wex vy wex vx wex vy vv vw vv cv vx cv vy cv cop
      vz cv cop wceq wph wa vz wex vy wex vy vx vv cv vx cv vy cv cop vz cv cop
      wceq wph wa vz wex vy hbe1 hbex hbab hbxfr $.
      $( [25-Apr-1995] $)
  $}

$(
  @{
    @d x y z w v @.  @d x y w v A @.  @d x y w v B @.  @d x y C @.
    @d x y v ph @.
    @( An operation class abstraction expressed in terms of an ordered pair
       class abstraction. @)
    oprab3 @p |- { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
                   /\ [ <. x , y >. / w ] ph ) } =
                  { <. w , z >. | ( w e. ( A X. B ) /\ ph ) } @=
      ( vv cv wcel wa cop wsbc copab2 wceq wex copab cxp dfoprab2 ax-17 opex
      hbsbc1v hban hbex weq eqeq1 anbi1d 2exbidv cbvopab1 eqtri elxp anbi1i
      19.41vv anass sbceq1a anbi2d pm5.32i bitri 2exbii bitr3i
      opabbii eqtr4i ) BIZFJ
      CIZGJKZAEVCVDLZMZKZBCDNZEIZVFOZVHKZCPBPZEDQZVJFGRJZAKZEDQVIHIZVFOZVHKZCPZ
      BPZHDQVNVHBCDHSWAVMHDEVTEBVSECVRVHEVRETVEVGEVEETAEVFVCVDUAUBUCUCUDUDVMHTH
      EUEZVSVLBCWBVRVKVHVQVJVFUFUGUHUIUJVPVMEDVPVKVEKZCPBPZAKZVMVOWDABCVJFGUKUL
      WEWCAKZCPBPVMWCABCUMWFVLBCWFVKVEAKZKVLVKVEAUNVKWGVHVKAVGVEAEVFUOUPUQURUSU
      TURVAVB @.
  @}
$)

  ${
    $d x z w $.  $d y z w $.  $d w ph $.  $d w ps $.  $d w ch $.
    oprabbid.1 $e |- ( ph -> A. x ph ) $.
    oprabbid.2 $e |- ( ph -> A. y ph ) $.
    oprabbid.3 $e |- ( ph -> A. z ph ) $.
    oprabbid.4 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal operation class abstractions (deduction
       rule). $)
    oprabbid $p |- ( ph ->
           { <. <. x , y >. , z >. | ps } = { <. <. x , y >. , z >. | ch } ) $=
      wph vw cv vx cv vy cv cop wceq wps wa vy wex vx wex vw vz copab vw cv vx
      cv vy cv cop wceq wch wa vy wex vx wex vw vz copab wps vx vy vz copab2
      wch vx vy vz copab2 wph vw cv vx cv vy cv cop wceq wps wa vy wex vx wex
      vw cv vx cv vy cv cop wceq wch wa vy wex vx wex vw vz wph vw ax-17
      oprabbid.3 wph vw cv vx cv vy cv cop wceq wps wa vy wex vw cv vx cv vy cv
      cop wceq wch wa vy wex vx oprabbid.1 wph vw cv vx cv vy cv cop wceq wps
      wa vw cv vx cv vy cv cop wceq wch wa vy oprabbid.2 wph wps wch vw cv vx
      cv vy cv cop wceq oprabbid.4 anbi2d exbid exbid opabbid wps vx vy vz vw
      dfoprab2 wch vx vy vz vw dfoprab2 3eqtr4g $.
      $( [24-Feb-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x z w ph $.  $d y z w ph $.  $d w ps $.  $d w ch $.
    oprabbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal operation class abstractions (deduction
       rule). $)
    oprabbidv $p |- ( ph ->
           { <. <. x , y >. , z >. | ps } = { <. <. x , y >. , z >. | ch } ) $=
      wph wps wch vx vy vz wph vx ax-17 wph vy ax-17 wph vz ax-17 oprabbidv.1
      oprabbid $.
      $( [24-Feb-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x y z w $.  $d w ph $.  $d w ps $.
    oprabbii.1 $e |- ( ph <-> ps ) $.
    $( Equivalent wff's yield equal operation class abstractions. $)
    oprabbii $p |- { <. <. x , y >. , z >. | ph }
                 = { <. <. x , y >. , z >. | ps } $=
      vw cv vw cv wceq wph vx vy vz copab2 wps vx vy vz copab2 wceq vw cv eqid
      vw cv vw cv wceq wph wps vx vy vz wph wps wb vw cv vw cv wceq oprabbii.1
      a1i oprabbidv ax-mp $.
      $( [28-May-1995] $)
  $}

  ${
    $d x y z w v $.  $d v ph $.  $d v ps $.
    cbvoprab1.1 $e |- ( ph -> A. w ph ) $.
    cbvoprab1.2 $e |- ( ps -> A. x ps ) $.
    cbvoprab1.3 $e |- ( x = w -> ( ph <-> ps ) ) $.
    $( MAY BE REVISED - this probably doesn't have any uses; will be deleted $)
    $( Rule used to change first bound variable in an operation abstraction,
       using implicit substitution. $)
    cbvoprab1 $p |- { <. <. x , y >. , z >. | ph }
                  = { <. <. w , y >. , z >. | ps } $=
      vv cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy wex vx wex vv cab
      vv cv vw cv vy cv cop vz cv cop wceq wps wa vz wex vy wex vw wex vv cab
      wph vx vy vz copab2 wps vw vy vz copab2 vv cv vx cv vy cv cop vz cv cop
      wceq wph wa vz wex vy wex vx wex vv cv vw cv vy cv cop vz cv cop wceq wps
      wa vz wex vy wex vw wex vv vv cv vx cv vy cv cop vz cv cop wceq wph wa vz
      wex vy wex vv cv vw cv vy cv cop vz cv cop wceq wps wa vz wex vy wex vx
      vw vv cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vw vy vv cv vx cv
      vy cv cop vz cv cop wceq wph wa vw vz vv cv vx cv vy cv cop vz cv cop
      wceq wph vw vv cv vx cv vy cv cop vz cv cop wceq vw ax-17 cbvoprab1.1
      hban hbex hbex vv cv vw cv vy cv cop vz cv cop wceq wps wa vz wex vx vy
      vv cv vw cv vy cv cop vz cv cop wceq wps wa vx vz vv cv vw cv vy cv cop
      vz cv cop wceq wps vx vv cv vw cv vy cv cop vz cv cop wceq vx ax-17
      cbvoprab1.2 hban hbex hbex vx cv vw cv wceq vv cv vx cv vy cv cop vz cv
      cop wceq wph wa vv cv vw cv vy cv cop vz cv cop wceq wps wa vy vz vx cv
      vw cv wceq vv cv vx cv vy cv cop vz cv cop wceq vv cv vw cv vy cv cop vz
      cv cop wceq wph wps vx cv vw cv wceq vx cv vy cv cop vz cv cop vw cv vy
      cv cop vz cv cop vv cv vx cv vw cv wceq vx cv vy cv cop vw cv vy cv cop
      vz cv vx cv vw cv vy cv opeq1 opeq1d eqeq2d cbvoprab1.3 anbi12d 2exbidv
      cbvex abbii wph vx vy vz vv df-oprab wps vw vy vz vv df-oprab 3eqtr4i $.
      $( [20-Dec-2008] $) $( [20-Dec-2008] $)
  $}

  ${
    $d x y z w v u $.  $d u ph $.  $d u ps $.
    cbvoprab12.1 $e |- ( ph -> A. w ph ) $.
    cbvoprab12.2 $e |- ( ph -> A. v ph ) $.
    cbvoprab12.3 $e |- ( ps -> A. x ps ) $.
    cbvoprab12.4 $e |- ( ps -> A. y ps ) $.
    cbvoprab12.5 $e |- ( ( x = w /\ y = v ) -> ( ph <-> ps ) ) $.
    $( Rule used to change first two bound variables in an operation
       abstraction, using implicit substitution. $)
    cbvoprab12 $p |- { <. <. x , y >. , z >. | ph }
                   = { <. <. w , v >. , z >. | ps } $=
      vu cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy wex vx wex vu cab
      vu cv vw cv vv cv cop vz cv cop wceq wps wa vz wex vv wex vw wex vu cab
      wph vx vy vz copab2 wps vw vv vz copab2 vu cv vx cv vy cv cop vz cv cop
      wceq wph wa vz wex vy wex vx wex vu cv vw cv vv cv cop vz cv cop wceq wps
      wa vz wex vv wex vw wex vu vu cv vx cv vy cv cop vz cv cop wceq wph wa vz
      wex vu cv vw cv vv cv cop vz cv cop wceq wps wa vz wex vx vy vw vv vu cv
      vx cv vy cv cop vz cv cop wceq wph wa vw vz vu cv vx cv vy cv cop vz cv
      cop wceq wph vw vu cv vx cv vy cv cop vz cv cop wceq vw ax-17
      cbvoprab12.1 hban hbex vu cv vx cv vy cv cop vz cv cop wceq wph wa vv vz
      vu cv vx cv vy cv cop vz cv cop wceq wph vv vu cv vx cv vy cv cop vz cv
      cop wceq vv ax-17 cbvoprab12.2 hban hbex vu cv vw cv vv cv cop vz cv cop
      wceq wps wa vx vz vu cv vw cv vv cv cop vz cv cop wceq wps vx vu cv vw cv
      vv cv cop vz cv cop wceq vx ax-17 cbvoprab12.3 hban hbex vu cv vw cv vv
      cv cop vz cv cop wceq wps wa vy vz vu cv vw cv vv cv cop vz cv cop wceq
      wps vy vu cv vw cv vv cv cop vz cv cop wceq vy ax-17 cbvoprab12.4 hban
      hbex vx cv vw cv wceq vy cv vv cv wceq wa vu cv vx cv vy cv cop vz cv cop
      wceq wph wa vu cv vw cv vv cv cop vz cv cop wceq wps wa vz vx cv vw cv
      wceq vy cv vv cv wceq wa vu cv vx cv vy cv cop vz cv cop wceq vu cv vw cv
      vv cv cop vz cv cop wceq wph wps vx cv vw cv wceq vy cv vv cv wceq wa vx
      cv vy cv cop vz cv cop vw cv vv cv cop vz cv cop vu cv vx cv vw cv wceq
      vy cv vv cv wceq wa vx cv vy cv cop vw cv vv cv cop vz cv vx cv vy cv vw
      cv vv cv opeq12 opeq1d eqeq2d cbvoprab12.5 anbi12d exbidv cbvex2 abbii
      wph vx vy vz vu df-oprab wps vw vv vz vu df-oprab 3eqtr4i $.
      $( [23-Jun-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x y z w v u $.  $d u w v ph $.  $d u x y ps $.
    cbvoprab12v.1 $e |- ( ( x = w /\ y = v ) -> ( ph <-> ps ) ) $.
    $( Rule used to change first two bound variables in an operation
       abstraction, using implicit substitution. $)
    cbvoprab12v $p |- { <. <. x , y >. , z >. | ph }
                    = { <. <. w , v >. , z >. | ps } $=
      wph wps vx vy vz vw vv wph vw ax-17 wph vv ax-17 wps vx ax-17 wps vy
      ax-17 cbvoprab12v.1 cbvoprab12 $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)
  $}

  ${
    $d x y z w v $.  $d w v ph $.  $d z v ps $.
    cbvoprab3v.1 $e |- ( z = w -> ( ph <-> ps ) ) $.
    $( Rule used to change the third bound variable in an operation
       abstraction, using implicit substitution. $)
    cbvoprab3v $p |- { <. <. x , y >. , z >. | ph } =
                     { <. <. x , y >. , w >. | ps } $=
      vv cv vx cv vy cv cop wceq wph wa vy wex vx wex vv vz copab vv cv vx cv
      vy cv cop wceq wps wa vy wex vx wex vv vw copab wph vx vy vz copab2 wps
      vx vy vw copab2 vv cv vx cv vy cv cop wceq wph wa vy wex vx wex vv cv vx
      cv vy cv cop wceq wps wa vy wex vx wex vv vz vw vz cv vw cv wceq vv cv vx
      cv vy cv cop wceq wph wa vv cv vx cv vy cv cop wceq wps wa vx vy vz cv vw
      cv wceq wph wps vv cv vx cv vy cv cop wceq cbvoprab3v.1 anbi2d 2exbidv
      cbvopab2v wph vx vy vz vv dfoprab2 wps vx vy vw vv dfoprab2 3eqtr4i $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)
  $}

  ${
    elimdeloprv.1 $e |- ( ph -> C e. ( A F B ) ) $.
    elimdeloprv.2 $e |- Z e. ( X F Y ) $.
    $( Eliminate a hypothesis which is a predicate expressing membership in the
       result of an operator (deduction version).  See ~ ghomgrplem for an
       example of its use.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
    elimdeloprv $p |- if ( ph , C , Z ) e.
                     ( if ( ph , A , X ) F if ( ph , B , Y ) ) $=
      wph wph cC cZ cif wph cA cX cif wph cB cY cif cF co wcel wph wph cC cZ
      cif cA cB cF co wph cA cX cif wph cB cY cif cF co wph wph cC cZ cif cC cA
      cB cF co wph cC cZ iftrue elimdeloprv.1 eqeltrd wph wph cA cX cif cA wph
      cB cY cif cB cF wph cA cX iftrue wph cB cY iftrue opreq12d eleqtrrd wph
      wn wph cC cZ cif cX cY cF co wph cA cX cif wph cB cY cif cF co wph wn wph
      cC cZ cif cZ cX cY cF co wph cC cZ iffalse elimdeloprv.2 syl6eqel wph wn
      wph cA cX cif cX wph cB cY cif cY cF wph cA cX iffalse wph cB cY iffalse
      opreq12d eleqtrrd pm2.61i $.
      $( [26-Mar-2008] $) $( [25-Mar-2008] $)
  $}

  ${
    $d x y z w $.  $d w ph $.
    $( The domain of an operation class abstraction. $)
    dmoprab $p |- dom { <. <. x , y >. , z >. | ph } =
                  { <. x , y >. | E. z ph } $=
      wph vx vy vz copab2 cdm vw cv vx cv vy cv cop wceq wph wa vy wex vx wex
      vw vz copab cdm vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vz wex vw
      cab wph vz wex vx vy copab wph vx vy vz copab2 vw cv vx cv vy cv cop wceq
      wph wa vy wex vx wex vw vz copab wph vx vy vz vw dfoprab2 dmeqi vw cv vx
      cv vy cv cop wceq wph wa vy wex vx wex vw vz dmopab vw cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vz wex vw cab vw cv vx cv vy cv cop wceq wph vz
      wex wa vy wex vx wex vw cab wph vz wex vx vy copab vw cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vz wex vw cv vx cv vy cv cop wceq wph vz wex wa
      vy wex vx wex vw vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vz wex
      vw cv vx cv vy cv cop wceq wph wa vz wex vy wex vx wex vw cv vx cv vy cv
      cop wceq wph vz wex wa vy wex vx wex vw cv vx cv vy cv cop wceq wph wa vz
      vx vy exrot3 vw cv vx cv vy cv cop wceq wph wa vz wex vw cv vx cv vy cv
      cop wceq wph vz wex wa vx vy vw cv vx cv vy cv cop wceq wph vz 19.42v
      2exbii bitri abbii wph vz wex vx vy vw df-opab eqtr4i 3eqtri $.
      $( [17-Mar-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The domain of an operation class abstraction. $)
    dmoprabss $p |- dom { <. <. x , y >. , z >. |
           ( ( x e. A /\ y e. B ) /\ ph ) } C_ ( A X. B ) $=
      vx cv cA wcel vy cv cB wcel wa wph wa vx vy vz copab2 cdm vx cv cA wcel
      vy cv cB wcel wa wph wa vz wex vx vy copab cA cB cxp vx cv cA wcel vy cv
      cB wcel wa wph wa vx vy vz dmoprab vx cv cA wcel vy cv cB wcel wa wph wa
      vz wex vx vy copab vx cv cA wcel vy cv cB wcel wa wph vz wex wa vx vy
      copab cA cB cxp vx cv cA wcel vy cv cB wcel wa wph wa vz wex vx cv cA
      wcel vy cv cB wcel wa wph vz wex wa vx vy vx cv cA wcel vy cv cB wcel wa
      wph vz 19.42v opabbii wph vz wex vx vy cA cB opabssxp eqsstri eqsstri $.
      $( [24-Aug-1995] $)
  $}

  ${
    $d x y z w $.  $d w ph $.
    $( The range of an operation class abstraction. $)
    rnoprab $p |- ran { <. <. x , y >. , z >. | ph } =
                  { z | E. x E. y ph } $=
      wph vx vy vz copab2 crn vw cv vx cv vy cv cop wceq wph wa vy wex vx wex
      vw vz copab crn vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw wex vz
      cab wph vy wex vx wex vz cab wph vx vy vz copab2 vw cv vx cv vy cv cop
      wceq wph wa vy wex vx wex vw vz copab wph vx vy vz vw dfoprab2 rneqi vw
      cv vx cv vy cv cop wceq wph wa vy wex vx wex vw vz rnopab vw cv vx cv vy
      cv cop wceq wph wa vy wex vx wex vw wex wph vy wex vx wex vz vw cv vx cv
      vy cv cop wceq wph wa vy wex vx wex vw wex vw cv vx cv vy cv cop wceq wph
      wa vw wex vy wex vx wex wph vy wex vx wex vw cv vx cv vy cv cop wceq wph
      wa vw vx vy exrot3 vw cv vx cv vy cv cop wceq wph wa vw wex wph vx vy vw
      cv vx cv vy cv cop wceq wph wa vw wex vw cv vx cv vy cv cop wceq vw wex
      wph vw cv vx cv vy cv cop wceq wph vw 19.41v vw vx cv vy cv cop vx cv vy
      cv opex isseti mpbiran 2exbii bitri abbii 3eqtri $.
      $( [19-Sep-2004] $) $( [30-Aug-2004] $)
  $}

  ${
    $d x y z $.
    $( The domain of an operation class abstraction is a relation. $)
    reldmoprab $p |- Rel dom { <. <. x , y >. , z >. | ph } $=
      wph vx vy vz copab2 cdm wrel wph vz wex vx vy copab wrel wph vz wex vx vy
      relopab wph vx vy vz copab2 cdm wph vz wex vx vy copab wph vx vy vz
      dmoprab releqi mpbir $.
      $( [17-Mar-1995] $)

    $( Structure of an operation class abstraction. $)
    oprabss $p |- { <. <. x , y >. , z >. | ph } C_ ( ( _V X. _V ) X. _V ) $=
      wph vx vy vz copab2 wph vx vy vz copab2 cdm wph vx vy vz copab2 crn cxp
      cvv cvv cxp cvv cxp wph vx vy vz copab2 wrel wph vx vy vz copab2 wph vx
      vy vz copab2 cdm wph vx vy vz copab2 crn cxp wss wph vx vy vz reloprab
      wph vx vy vz copab2 relssdmrn ax-mp wph vx vy vz copab2 cdm cvv cvv cxp
      wss wph vx vy vz copab2 crn cvv wss wph vx vy vz copab2 cdm wph vx vy vz
      copab2 crn cxp cvv cvv cxp cvv cxp wss wph vx vy vz copab2 cdm wrel wph
      vx vy vz copab2 cdm cvv cvv cxp wss wph vx vy vz reldmoprab wph vx vy vz
      copab2 cdm df-rel mpbi wph vx vy vz copab2 crn ssv wph vx vy vz copab2
      cdm cvv cvv cxp wph vx vy vz copab2 crn cvv ssxp mp2an sstri $.
      $( [28-Nov-2006] $) $( [28-Nov-2006] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.
    $d w ph $.  $d x ps $.  $d x y ch $.  $d x y z w th $.
    eloprabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    eloprabg.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    eloprabg.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    $( The law of concretion for operation class abstraction.  Compare
       ~ elopab . $)
    eloprabg $p |- ( ( A e. D /\ B e. R /\ C e. S ) ->
       ( <. <. A , B >. , C >. e. { <. <. x , y >. , z >. | ph } <-> th ) ) $=
      cA cvv wcel cB cvv wcel cC cvv wcel cA cB cop cC cop wph vx vy vz copab2
      wcel wth wb cA cD wcel cB cR wcel cC cS wcel cA cvv wcel cB cvv wcel cC
      cvv wcel w3a cA cB cop cC cop wph vx vy vz copab2 wcel wth wb wi vw cA cB
      cop cC cop cA cB cop cC opex cA cvv wcel cB cvv wcel cC cvv wcel w3a vw
      cv cA cB cop cC cop wceq cA cB cop cC cop wph vx vy vz copab2 wcel wth wb
      cA cvv wcel cB cvv wcel cC cvv wcel w3a vw cv cA cB cop cC cop wceq wa vw
      cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy wex vx wex vx cv cA
      wceq vy cv cB wceq vz cv cC wceq w3a wth wa vz wex vy wex vx wex cA cB
      cop cC cop wph vx vy vz copab2 wcel wth cA cvv wcel cB cvv wcel cC cvv
      wcel w3a vw cv cA cB cop cC cop wceq wa vw cv vx cv vy cv cop vz cv cop
      wceq wph wa vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a wth wa vx vy vz
      cA cvv wcel cB cvv wcel cC cvv wcel w3a vw cv cA cB cop cC cop wceq wa vw
      cv vx cv vy cv cop vz cv cop wceq wph wa vx cv cA wceq vy cv cB wceq vz
      cv cC wceq w3a wph wa vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a wth
      wa cA cvv wcel cB cvv wcel cC cvv wcel w3a vw cv cA cB cop cC cop wceq wa
      vw cv vx cv vy cv cop vz cv cop wceq vx cv cA wceq vy cv cB wceq vz cv cC
      wceq w3a wph vw cv cA cB cop cC cop wceq vw cv vx cv vy cv cop vz cv cop
      wceq vx cv vy cv cop vz cv cop cA cB cop cC cop wceq cA cvv wcel cB cvv
      wcel cC cvv wcel w3a vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a vw cv
      cA cB cop cC cop wceq vw cv vx cv vy cv cop vz cv cop wceq cA cB cop cC
      cop vx cv vy cv cop vz cv cop wceq vx cv vy cv cop vz cv cop cA cB cop cC
      cop wceq vw cv cA cB cop cC cop vx cv vy cv cop vz cv cop eqeq1 cA cB cop
      cC cop vx cv vy cv cop vz cv cop eqcom syl6bb cB cvv wcel cC cvv wcel vx
      cv vy cv cop vz cv cop cA cB cop cC cop wceq vx cv cA wceq vy cv cB wceq
      vz cv cC wceq w3a wb cA cvv wcel vx cv vy cv cA cB vz cv cC cvv cvv vx
      visset vy visset vz visset otthg 3adant1 sylan9bbr anbi1d vx cv cA wceq
      vy cv cB wceq vz cv cC wceq w3a wph wth vx cv cA wceq wph wps vy cv cB
      wceq wch vz cv cC wceq wth eloprabg.1 eloprabg.2 eloprabg.3 syl3an9b
      pm5.32i syl6bb 3exbidv vw cv cA cB cop cC cop wceq vw cv vx cv vy cv cop
      vz cv cop wceq wph wa vz wex vy wex vx wex cA cB cop cC cop wph vx vy vz
      copab2 wcel wb cA cvv wcel cB cvv wcel cC cvv wcel w3a vw cv cA cB cop cC
      cop wceq vw cv wph vx vy vz copab2 wcel cA cB cop cC cop wph vx vy vz
      copab2 wcel vw cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy wex vx
      wex vw cv cA cB cop cC cop wph vx vy vz copab2 eleq1 vw cv wph vx vy vz
      copab2 wcel vw cv vw cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy
      wex vx wex vw cab wcel vw cv vx cv vy cv cop vz cv cop wceq wph wa vz wex
      vy wex vx wex wph vx vy vz copab2 vw cv vx cv vy cv cop vz cv cop wceq
      wph wa vz wex vy wex vx wex vw cab vw cv wph vx vy vz vw df-oprab eleq2i
      vw cv vx cv vy cv cop vz cv cop wceq wph wa vz wex vy wex vx wex vw abid
      bitr2i syl5bb adantl cA cvv wcel cB cvv wcel cC cvv wcel w3a vx cv cA
      wceq vy cv cB wceq vz cv cC wceq w3a wth wa vz wex vy wex vx wex wth wb
      vw cv cA cB cop cC cop wceq cA cvv wcel cB cvv wcel cC cvv wcel w3a wth
      vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a vz wex vy wex vx wex wth wa
      vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a wth wa vz wex vy wex vx wex
      cA cvv wcel cB cvv wcel cC cvv wcel w3a vx cv cA wceq vy cv cB wceq vz cv
      cC wceq w3a vz wex vy wex vx wex wth cA cvv wcel cB cvv wcel cC cvv wcel
      w3a vx cv cA wceq vx wex vy cv cB wceq vy wex vz cv cC wceq vz wex w3a vx
      cv cA wceq vy cv cB wceq vz cv cC wceq w3a vz wex vy wex vx wex cA cvv
      wcel vx cv cA wceq vx wex cB cvv wcel vy cv cB wceq vy wex cC cvv wcel vz
      cv cC wceq vz wex vx cA cvv elex vy cB cvv elex vz cC cvv elex 3anim123i
      vx cv cA wceq vy cv cB wceq vz cv cC wceq vx vy vz eeeanv sylibr
      biantrurd vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a wth vx vy vz
      19.41vvv syl6rbbr adantr 3bitr3d expcom vtocle cA cD elisset cB cR
      elisset cC cS elisset syl3an $.
      $( [14-Sep-1999] $)
  $}

  ${
    $d ph w $.  $d ps w $.  $d x y z w $.
    ssoprab2i.1 $e |- ( ph -> ps ) $.
    $( Inference of operation class abstraction subclass from implication. $)
    ssoprab2i $p |- { <. <. x , y >. , z >. | ph } C_
                    { <. <. x , y >. , z >. | ps } $=
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw vz copab vw cv vx cv
      vy cv cop wceq wps wa vy wex vx wex vw vz copab wph vx vy vz copab2 wps
      vx vy vz copab2 vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cv vx
      cv vy cv cop wceq wps wa vy wex vx wex vw vz vw cv vx cv vy cv cop wceq
      wph wa vw cv vx cv vy cv cop wceq wps wa vx vy wph wps vw cv vx cv vy cv
      cop wceq ssoprab2i.1 anim2i 19.22i2 ssopab2i wph vx vy vz vw dfoprab2 wps
      vx vy vz vw dfoprab2 3sstr4i $.
      $( [11-Nov-1995] $)
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w ph $.
    $( Restriction of an operation class abstraction. $)
    resoprab $p |- ( { <. <. x , y >. , z >. | ph } |` ( A X. B ) ) =
                  { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ph ) } $=
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw vz copab cA cB cxp
      cres vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa
      vy wex vx wex vw vz copab wph vx vy vz copab2 cA cB cxp cres vx cv cA
      wcel vy cv cB wcel wa wph wa vx vy vz copab2 vw cv vx cv vy cv cop wceq
      wph wa vy wex vx wex vw vz copab cA cB cxp cres vw cv cA cB cxp wcel vw
      cv vx cv vy cv cop wceq wph wa vy wex vx wex wa vw vz copab vw cv vx cv
      vy cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vy wex vx wex vw
      vz copab vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw vz cA cB cxp
      resopab vw cv cA cB cxp wcel vw cv vx cv vy cv cop wceq wph wa vy wex vx
      wex wa vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa
      wa vy wex vx wex vw vz vw cv cA cB cxp wcel vw cv vx cv vy cv cop wceq
      wph wa vy wex vx wex wa vw cv cA cB cxp wcel vw cv vx cv vy cv cop wceq
      wph wa wa vy wex vx wex vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB
      wcel wa wph wa wa vy wex vx wex vw cv cA cB cxp wcel vw cv vx cv vy cv
      cop wceq wph wa vx vy 19.42vv vw cv cA cB cxp wcel vw cv vx cv vy cv cop
      wceq wph wa wa vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa
      wph wa wa vx vy vw cv cA cB cxp wcel vw cv vx cv vy cv cop wceq wph wa wa
      vw cv vx cv vy cv cop wceq vw cv cA cB cxp wcel wph wa wa vw cv vx cv vy
      cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vw cv cA cB cxp wcel
      vw cv vx cv vy cv cop wceq wph an12 vw cv vx cv vy cv cop wceq vw cv cA
      cB cxp wcel wph wa vx cv cA wcel vy cv cB wcel wa wph wa vw cv vx cv vy
      cv cop wceq vw cv cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa wph vw cv
      vx cv vy cv cop wceq vw cv cA cB cxp wcel vx cv vy cv cop cA cB cxp wcel
      vx cv cA wcel vy cv cB wcel wa vw cv vx cv vy cv cop cA cB cxp eleq1 vx
      cv vy cv cA cB vy visset opelxp syl6bb anbi1d pm5.32i bitri 2exbii bitr3i
      opabbii eqtri wph vx vy vz copab2 vw cv vx cv vy cv cop wceq wph wa vy
      wex vx wex vw vz copab wceq wph vx vy vz copab2 cA cB cxp cres vw cv vx
      cv vy cv cop wceq wph wa vy wex vx wex vw vz copab cA cB cxp cres wceq
      wph vx vy vz vw dfoprab2 wph vx vy vz copab2 vw cv vx cv vy cv cop wceq
      wph wa vy wex vx wex vw vz copab cA cB cxp reseq1 ax-mp vx cv cA wcel vy
      cv cB wcel wa wph wa vx vy vz vw dfoprab2 3eqtr4i $.
      $( [10-Feb-2007] $) $( [10-Feb-2007] $)
  $}

  ${
    $d x y z w $.  $d w ph $.
    $( "At most one" is a sufficient condition for an operation class
       abstraction to be a function. $)
    funoprabg $p |- ( A. x A. y E* z ph ->
                    Fun { <. <. x , y >. , z >. | ph } ) $=
      wph vz wmo vy wal vx wal vw cv vx cv vy cv cop wceq wph wa vy wex vx wex
      vz wmo vw wal wph vx vy vz copab2 wfun wph vz wmo vy wal vx wal vw cv vx
      cv vy cv cop wceq wph wa vy wex vx wex vz wmo vw wph vz vx vy vw cv
      mosubopt 19.21aiv wph vx vy vz copab2 wfun vw cv vx cv vy cv cop wceq wph
      wa vy wex vx wex vw vz copab wfun vw cv vx cv vy cv cop wceq wph wa vy
      wex vx wex vz wmo vw wal wph vx vy vz copab2 vw cv vx cv vy cv cop wceq
      wph wa vy wex vx wex vw vz copab wceq wph vx vy vz copab2 wfun vw cv vx
      cv vy cv cop wceq wph wa vy wex vx wex vw vz copab wfun wb wph vx vy vz
      vw dfoprab2 wph vx vy vz copab2 vw cv vx cv vy cv cop wceq wph wa vy wex
      vx wex vw vz copab funeq ax-mp vw cv vx cv vy cv cop wceq wph wa vy wex
      vx wex vw vz funopab bitr2i sylib $.
      $( [29-Aug-2007] $) $( [28-Aug-2007] $)
  $}

  ${
    $d x y z w $.  $d w ph $.
    funoprab.1 $e |- E* z ph $.
    $( "At most one" is a sufficient condition for an operation class
       abstraction to be a function. $)
    funoprab $p |- Fun { <. <. x , y >. , z >. | ph } $=
      wph vz wmo vy wal vx wal wph vx vy vz copab2 wfun wph vz wmo vx vy
      funoprab.1 gen2 wph vx vy vz funoprabg ax-mp $.
      $( [17-Mar-1995] $)
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Functionality and domain of an operation class abstraction. $)
    fnoprabg $p |- ( A. x A. y ( ph -> E! z ps ) ->
  { <. <. x , y >. , z >. | ( ph /\ ps ) } Fn { <. x , y >. | ph } ) $=
      wph wps wa vx vy vz copab2 wph vx vy copab wfn wph wps wa vx vy vz copab2
      wfun wph wps wa vx vy vz copab2 cdm wph vx vy copab wceq wph wps vz weu
      wi vy wal vx wal wph wps wa vx vy vz copab2 wph vx vy copab df-fn wph wps
      vz weu wi vy wal vx wal wph wps wa vz wmo vy wal vx wal wph wps wa vx vy
      vz copab2 wfun wph wps vz weu wi wph wps wa vz wmo vx vy wph wps vz weu
      wi wph wps vz wmo wi wph wps wa vz wmo wps vz weu wps vz wmo wph wps vz
      eumo imim2i wph wps vz moanimv sylibr 19.20i2 wph wps wa vx vy vz
      funoprabg syl wph wps vz weu wi vy wal vx wal wph wps wa vz wex vx vy
      copab wph vx vy copab wph wps wa vx vy vz copab2 cdm wph wps vz weu wi vy
      wal vx wal wph wps wa vz wex wph vx vy wph wps vz weu wi vy wal vx hba1
      wph wps vz weu wi vy vx hba2 wph wps vz weu wi vy wal wph wps wa vz wex
      wph wb vx wph wps vz weu wi wph wps wa vz wex wph wb vy wph wps vz weu wi
      wph wps wa vz wex wph wph wps wa wph vz wph wps pm3.26 19.23aiv wph wps
      vz weu wi wph wph wps vz wex wa wph wps wa vz wex wph wps vz weu wi wph
      wps vz wex wps vz weu wps vz wex wph wps vz euex imim2i ancld wph wps vz
      19.42v syl6ibr impbid2 a4s a4s opabbid wph wps wa vx vy vz dmoprab syl5eq
      sylanbrc $.
      $( [29-Aug-2007] $) $( [28-Aug-2007] $)
  $}

  ${
    $d x y z $.  $d z ph $.
    fnoprab.1 $e |- ( ph -> E! z ps ) $.
    $( Functionality and domain of an operation class abstraction. $)
    fnoprab $p |- { <. <. x , y >. , z >. | ( ph /\ ps ) } Fn
                    { <. x , y >. | ph } $=
      wph wps vz weu wi vy wal vx wal wph wps wa vx vy vz copab2 wph vx vy
      copab wfn wph wps vz weu wi vx vy fnoprab.1 gen2 wph wps vx vy vz
      fnoprabg ax-mp $.
      $( [15-May-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w F $.
    $( An operation maps to a class to which all values belong. $)
    ffnoprv $p |- ( F : ( A X. B ) --> C <-> ( F Fn ( A X. B ) /\
         A. x e. A A. y e. B ( x F y ) e. C ) ) $=
      cA cB cxp cC cF wf cF cA cB cxp wfn vw cv cF cfv cC wcel vw cA cB cxp
      wral wa cF cA cB cxp wfn vx cv vy cv cF co cC wcel vy cB wral vx cA wral
      wa vw cA cB cxp cC cF ffnfv vw cv cF cfv cC wcel vw cA cB cxp wral vx cv
      vy cv cF co cC wcel vy cB wral vx cA wral cF cA cB cxp wfn vw cv cF cfv
      cC wcel vx cv vy cv cF co cC wcel vw vx vy cA cB vw cv vx cv vy cv cop
      wceq vw cv cF cfv vx cv vy cv cF co cC vw cv vx cv vy cv cop wceq vw cv
      cF cfv vx cv vy cv cop cF cfv vx cv vy cv cF co vw cv vx cv vy cv cop cF
      fveq2 vx cv vy cv cF df-opr syl6eqr eleq1d ralxp anbi2i bitri $.
      $( [23-Jun-2004] $) $( [7-Feb-2004] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y F $.  $d x y R $.  $d x y S $.
    foprcl.1 $e |- F : ( R X. S ) --> C $.
    $( Closure law for an operation. $)
    foprcl $p |- ( ( A e. R /\ B e. S ) -> ( A F B ) e. C ) $=
      cA cR wcel cB cS wcel wa vx cv vy cv cF co cC wcel vy cS wral vx cR wral
      cA cB cF co cC wcel cR cS cxp cC cF wf vx cv vy cv cF co cC wcel vy cS
      wral vx cR wral foprcl.1 cR cS cxp cC cF wf cF cR cS cxp wfn vx cv vy cv
      cF co cC wcel vy cS wral vx cR wral vx vy cR cS cC cF ffnoprv pm3.27bi
      ax-mp vx cv vy cv cF co cC wcel cA cB cF co cC wcel cA vy cv cF co cC
      wcel vx vy cA cB cR cS vx cv cA wceq vx cv vy cv cF co cA vy cv cF co cC
      vx cv cA vy cv cF opreq1 eleq1d vy cv cB wceq cA vy cv cF co cA cB cF co
      cC vy cv cB cA cF opreq2 eleq1d rcla42v mpi $.
      $( [19-Apr-2007] $) $( [19-Apr-2007] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.  $d z D $.
    $d x y z F $.  $d x y z G $.
    $( Equality of two operations is determined by their values. $)
    eqfnoprv $p |- ( ( F Fn ( A X. B ) /\ G Fn ( C X. D ) ) -> ( F = G <->
( ( A X. B ) = ( C X. D ) /\ A. x e. A A. y e. B ( x F y ) = ( x G y ) ) ) ) $=
      cF cA cB cxp wfn cG cC cD cxp wfn wa cF cG wceq cA cB cxp cC cD cxp wceq
      vz cv cF cfv vz cv cG cfv wceq vz cA cB cxp wral wa cA cB cxp cC cD cxp
      wceq vx cv vy cv cF co vx cv vy cv cG co wceq vy cB wral vx cA wral wa vz
      cA cB cxp cC cD cxp cF cG eqfnfv vz cv cF cfv vz cv cG cfv wceq vz cA cB
      cxp wral vx cv vy cv cF co vx cv vy cv cG co wceq vy cB wral vx cA wral
      cA cB cxp cC cD cxp wceq vz cv cF cfv vz cv cG cfv wceq vx cv vy cv cF co
      vx cv vy cv cG co wceq vz vx vy cA cB vz cv vx cv vy cv cop wceq vz cv cF
      cfv vz cv cG cfv wceq vx cv vy cv cop cF cfv vx cv vy cv cop cG cfv wceq
      vx cv vy cv cF co vx cv vy cv cG co wceq vz cv vx cv vy cv cop wceq vz cv
      cF cfv vx cv vy cv cop cF cfv vz cv cG cfv vx cv vy cv cop cG cfv vz cv
      vx cv vy cv cop cF fveq2 vz cv vx cv vy cv cop cG fveq2 eqeq12d vx cv vy
      cv cF co vx cv vy cv cop cF cfv vx cv vy cv cG co vx cv vy cv cop cG cfv
      vx cv vy cv cF df-opr vx cv vy cv cG df-opr eqeq12i syl6bbr ralxp anbi2i
      syl6bb $.
      $( [12-Sep-2005] $) $( [1-Sep-2005] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w F $.
    $( Representation of an operation class abstraction in terms of its
       values. $)
    fnoprv $p |- ( F Fn ( A X. B ) <->  F = { <. <. x , y >. , z >. |
                    ( ( x e. A /\ y e. B ) /\ z = ( x F y ) ) } ) $=
      cF cA cB cxp wfn cF vw cv cA cB cxp wcel vz cv vw cv cF cfv wceq wa vw vz
      copab wceq cF vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cF co wceq
      wa vx vy vz copab2 wceq vw vz cA cB cxp cF dffn5 vw cv cA cB cxp wcel vz
      cv vw cv cF cfv wceq wa vw vz copab vx cv cA wcel vy cv cB wcel wa vz cv
      vx cv vy cv cF co wceq wa vx vy vz copab2 cF vw cv cA cB cxp wcel vz cv
      vw cv cF cfv wceq wa vw vz copab vw cv vx cv vy cv cop wceq vx cv cA wcel
      vy cv cB wcel wa vz cv vx cv vy cv cF co wceq wa wa vy wex vx wex vw vz
      copab vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cF co wceq wa vx
      vy vz copab2 vw cv cA cB cxp wcel vz cv vw cv cF cfv wceq wa vw cv vx cv
      vy cv cop wceq vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cF co
      wceq wa wa vy wex vx wex vw vz vw cv cA cB cxp wcel vz cv vw cv cF cfv
      wceq wa vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa wa vy
      wex vx wex vz cv vw cv cF cfv wceq wa vw cv vx cv vy cv cop wceq vx cv cA
      wcel vy cv cB wcel wa wa vz cv vw cv cF cfv wceq wa vy wex vx wex vw cv
      vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cF
      co wceq wa wa vy wex vx wex vw cv cA cB cxp wcel vw cv vx cv vy cv cop
      wceq vx cv cA wcel vy cv cB wcel wa wa vy wex vx wex vz cv vw cv cF cfv
      wceq vx vy vw cv cA cB elxp anbi1i vw cv vx cv vy cv cop wceq vx cv cA
      wcel vy cv cB wcel wa wa vz cv vw cv cF cfv wceq vx vy 19.41vv vw cv vx
      cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa wa vz cv vw cv cF cfv
      wceq wa vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa vz cv
      vx cv vy cv cF co wceq wa wa vx vy vw cv vx cv vy cv cop wceq vx cv cA
      wcel vy cv cB wcel wa wa vz cv vw cv cF cfv wceq wa vw cv vx cv vy cv cop
      wceq vx cv cA wcel vy cv cB wcel wa vz cv vw cv cF cfv wceq wa wa vw cv
      vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cF
      co wceq wa wa vw cv vx cv vy cv cop wceq vx cv cA wcel vy cv cB wcel wa
      vz cv vw cv cF cfv wceq anass vw cv vx cv vy cv cop wceq vx cv cA wcel vy
      cv cB wcel wa vz cv vw cv cF cfv wceq wa vx cv cA wcel vy cv cB wcel wa
      vz cv vx cv vy cv cF co wceq wa vw cv vx cv vy cv cop wceq vz cv vw cv cF
      cfv wceq vz cv vx cv vy cv cF co wceq vx cv cA wcel vy cv cB wcel wa vw
      cv vx cv vy cv cop wceq vw cv cF cfv vx cv vy cv cF co vz cv vw cv vx cv
      vy cv cop wceq vw cv cF cfv vx cv vy cv cop cF cfv vx cv vy cv cF co vw
      cv vx cv vy cv cop cF fveq2 vx cv vy cv cF df-opr syl6eqr eqeq2d anbi2d
      pm5.32i bitri 2exbii 3bitr2i opabbii vx cv cA wcel vy cv cB wcel wa vz cv
      vx cv vy cv cF co wceq wa vx vy vz vw dfoprab2 eqtr4i eqeq2i bitri $.
      $( [23-Jun-2004] $) $( [7-Feb-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z F $.
    $( Representation of an operation class abstraction in terms of its
       values. $)
    foprv $p |- ( F : ( A X. B ) --> C <-> ( F = { <. <. x , y >. , z >. |
                  ( ( x e. A /\ y e. B ) /\ z = ( x F y ) ) }
                /\ A. x e. A A. y e. B ( x F y ) e. C ) ) $=
      cA cB cxp cC cF wf cF cA cB cxp wfn vx cv vy cv cF co cC wcel vy cB wral
      vx cA wral wa cF vx cv cA wcel vy cv cB wcel wa vz cv vx cv vy cv cF co
      wceq wa vx vy vz copab2 wceq vx cv vy cv cF co cC wcel vy cB wral vx cA
      wral wa vx vy cA cB cC cF ffnoprv cF cA cB cxp wfn cF vx cv cA wcel vy cv
      cB wcel wa vz cv vx cv vy cv cF co wceq wa vx vy vz copab2 wceq vx cv vy
      cv cF co cC wcel vy cB wral vx cA wral vx vy vz cA cB cF fnoprv anbi1i
      bitri $.
      $( [25-Jun-2004] $) $( [7-Feb-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    oprabex.1 $e |- A e. _V $.
    oprabex.2 $e |- B e. _V $.
    oprabex.3 $e |- ( ( x e. A /\ y e. B ) -> E* z ph ) $.
    oprabex.4 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ ph ) } $.
    $( Existence of an operation class abstraction. $)
    oprabex $p |- F e. _V $=
      cF vx cv cA wcel vy cv cB wcel wa wph wa vx vy vz copab2 cvv oprabex.4 vx
      cv cA wcel vy cv cB wcel wa wph wa vx vy vz copab2 wfun vx cv cA wcel vy
      cv cB wcel wa wph wa vx vy vz copab2 cdm cvv wcel vx cv cA wcel vy cv cB
      wcel wa wph wa vx vy vz copab2 cvv wcel vx cv cA wcel vy cv cB wcel wa
      wph wa vx vy vz vx cv cA wcel vy cv cB wcel wa wph wa vz wmo vx cv cA
      wcel vy cv cB wcel wa wph vz wmo wi oprabex.3 vx cv cA wcel vy cv cB wcel
      wa wph vz moanimv mpbir funoprab vx cv cA wcel vy cv cB wcel wa wph wa vx
      vy vz copab2 cdm cA cB cxp cA cB oprabex.1 oprabex.2 xpex wph vx vy vz cA
      cB dmoprabss ssexi cvv vx cv cA wcel vy cv cB wcel wa wph wa vx vy vz
      copab2 funex mp2an eqeltri $.
      $( [21-Oct-2004] $) $( [19-Oct-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.
    oprabex2g.1 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Existence of an operation class abstraction (special case). $)
    oprabex2g $p |- ( ( A e. R /\ B e. S ) -> F e. _V ) $=
      cA cR wcel cB cS wcel wa vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa
      vx vy vz copab2 cvv cF vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx
      vy vz copab2 wfun vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy
      vz copab2 cdm cvv wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx
      vy vz copab2 cvv wcel cA cR wcel cB cS wcel wa cvv vx cv cA wcel vy cv cB
      wcel wa vz cv cC wceq wa vx vy vz copab2 funex vx cv cA wcel vy cv cB
      wcel wa vz cv cC wceq wa vx vy vz vz cv cC wceq vx cv cA wcel vy cv cB
      wcel wa vz vz cC moeq moani funoprab vx cv cA wcel vy cv cB wcel wa vz cv
      cC wceq wa vx vy vz copab2 cdm cA cB cxp wss cA cB cxp cvv wcel vx cv cA
      wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 cdm cvv wcel cA cR
      wcel cB cS wcel wa vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy
      vz copab2 cdm cA cB cxp cvv ssexg vz cv cC wceq vx vy vz cA cB dmoprabss
      cA cB cR cS xpexg sylancr sylancr oprabex2g.1 syl5eqel $.
      $( [31-Aug-2007] $) $( [27-Aug-2007] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.
    oprabex2.1 $e |- A e. _V $.
    oprabex2.2 $e |- B e. _V $.
    oprabex2.3 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Existence of an operation class abstraction (special case). $)
    oprabex2 $p |- F e. _V $=
      cA cvv wcel cB cvv wcel cF cvv wcel oprabex2.1 oprabex2.2 vx vy vz cA cB
      cC cvv cvv cF oprabex2.3 oprabex2g mp2an $.
      $( [11-Nov-1995] $)
  $}

  ${
    $d x y z w v u f A $.  $d x y z w v u f B $.  $d x y z w v u f C $.
    $d x y z w v u f D $.  $d x y z w v u f H $.  $d x y z R $.
    $d x y z w v u f S $.
    oprabex3.1 $e |- H e. _V $.
    oprabex3.2 $e |- F = { <. <. x , y >. , z >. | ( ( x e. ( H X. H ) /\
                      y e. ( H X. H ) ) /\
                      E. w E. v E. u E. f ( ( x = <. w , v >. /\
                      y = <. u , f >. ) /\ z = R ) ) } $.
    $( Existence of an operation class abstraction (special case). $)
    oprabex3 $p |- F e. _V $=
      vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa
      vf wex vu wex vv wex vw wex vx vy vz cH cH cxp cH cH cxp cF cH cH
      oprabex3.1 oprabex3.1 xpex cH cH oprabex3.1 oprabex3.1 xpex vx cv vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu
      wex vv wex vw wex vz wmo vx cv cH cH cxp wcel vy cv cH cH cxp wcel wa vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf
      wex vu wex vv wex vw wex vz wmo vx cv vw cv vv cv cop wceq vy cv vu cv vf
      cv cop wceq vz cv cR wceq wa vf wex vu wex wa vv wex vw wex vz wmo vy cv
      vu cv vf cv cop wceq vz cv cR wceq wa vf wex vu wex vz vw vv vx cv vz cv
      cR wceq vz vu vf vy cv vz cR moeq mosubop mosubop vx cv vw cv vv cv cop
      wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu wex vv wex
      vw wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv cR
      wceq wa vf wex vu wex wa vv wex vw wex vz vx cv vw cv vv cv cop wceq vy
      cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu wex vx cv vw cv vv
      cv cop wceq vy cv vu cv vf cv cop wceq vz cv cR wceq wa vf wex vu wex wa
      vw vv vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR
      wceq wa vf wex vu wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq vz cv cR wceq wa wa vf wex vu wex vx cv vw cv vv cv cop wceq vy cv
      vu cv vf cv cop wceq vz cv cR wceq wa vf wex vu wex wa vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq vz cv cR wceq wa wa vu vf vx cv vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv cR wceq anass 2exbii vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv cR wceq wa vu vf
      19.42vv bitri 2exbii mobii mpbir a1i oprabex3.2 oprabex $.
      $( [22-Oct-2004] $) $( [19-Oct-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z S $.
    $d x ps $.  $d x y ch $.  $d x y z th $.
    oprabval.1 $e |- C e. _V $.
    oprabval.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    oprabval.3 $e |- ( y = B -> ( ps <-> ch ) ) $.
    oprabval.4 $e |- ( z = C -> ( ch <-> th ) ) $.
    oprabval.5 $e |- ( ( x e. R /\ y e. S ) -> E! z ph ) $.
    oprabval.6 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction. $)
    oprabval $p |- ( ( A e. R /\ B e. S ) -> ( ( A F B ) = C <-> th ) ) $=
      cA cR wcel cB cS wcel wa cA cB cF co cC wceq wth cA cR wcel cB cS wcel wa
      cA cB cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 cfv cC
      wceq cA cR wcel cB cS wcel wa wth wa cA cB cF co cC wceq cA cR wcel cB cS
      wcel wa cA cB cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2
      cfv cC wceq cA cB cop cC cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy
      vz copab2 wcel cA cR wcel cB cS wcel wa wth wa vx cv cR wcel vy cv cS
      wcel wa wph wa vx vy vz copab2 vx cv cR wcel vy cv cS wcel wa vx vy copab
      wfn cA cB cop vx cv cR wcel vy cv cS wcel wa vx vy copab wcel cA cB cop
      vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 cfv cC wceq cA cB
      cop cC cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 wcel wb
      cA cR wcel cB cS wcel wa vx cv cR wcel vy cv cS wcel wa vx vy copab cA cB
      cop cC vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 oprabval.1
      fnopfvb vx cv cR wcel vy cv cS wcel wa wph vx vy vz oprabval.5 fnoprab cA
      cR wcel cB cS wcel wa cA cB cop vx cv cR wcel vy cv cS wcel wa vx vy
      copab wcel vx cv cR wcel vy cv cS wcel wa cA cR wcel vy cv cS wcel wa cA
      cR wcel cB cS wcel wa vx vy cA cB cR cS vx cv cA wceq vx cv cR wcel cA cR
      wcel vy cv cS wcel vx cv cA cR eleq1 anbi1d vy cv cB wceq vy cv cS wcel
      cB cS wcel cA cR wcel vy cv cB cS eleq1 anbi2d opelopabg ibir sylancr cA
      cR wcel cB cS wcel cC cvv wcel cA cB cop cC cop vx cv cR wcel vy cv cS
      wcel wa wph wa vx vy vz copab2 wcel cA cR wcel cB cS wcel wa wth wa wb
      oprabval.1 vx cv cR wcel vy cv cS wcel wa wph wa cA cR wcel vy cv cS wcel
      wa wps wa cA cR wcel cB cS wcel wa wch wa cA cR wcel cB cS wcel wa wth wa
      vx vy vz cA cB cC cR cS cvv vx cv cA wceq vx cv cR wcel vy cv cS wcel wa
      cA cR wcel vy cv cS wcel wa wph wps vx cv cA wceq vx cv cR wcel cA cR
      wcel vy cv cS wcel vx cv cA cR eleq1 anbi1d oprabval.2 anbi12d vy cv cB
      wceq cA cR wcel vy cv cS wcel wa cA cR wcel cB cS wcel wa wps wch vy cv
      cB wceq vy cv cS wcel cB cS wcel cA cR wcel vy cv cB cS eleq1 anbi2d
      oprabval.3 anbi12d vz cv cC wceq wch wth cA cR wcel cB cS wcel wa
      oprabval.4 anbi2d eloprabg mp3an3 bitrd cA cB cF co cA cB cop vx cv cR
      wcel vy cv cS wcel wa wph wa vx vy vz copab2 cfv cC cA cB cF co cA cB cop
      cF cfv cA cB cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2
      cfv cA cB cF df-opr cA cB cop cF vx cv cR wcel vy cv cS wcel wa wph wa vx
      vy vz copab2 oprabval.6 fveq1i eqtri eqeq1i syl5bb bianabs $.
      $( [16-May-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z S $.
    $d x ps $.  $d x y ch $.  $d x y z th $.
    oprabvalig.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    oprabvalig.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    oprabvalig.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    oprabvalig.4 $e |- ( ( x e. R /\ y e. S ) -> E* z ph ) $.
    oprabvalig.5 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction (weak version). $)
    oprabvalig $p |- ( ( A e. R /\ B e. S /\ C e. D ) ->
                         ( th -> ( A F B ) = C ) ) $=
      cA cR wcel cB cS wcel cC cD wcel w3a wth cA cB cop vx cv cR wcel vy cv cS
      wcel wa wph wa vx vy vz copab2 cfv cC wceq cA cB cF co cC wceq cA cR wcel
      cB cS wcel cC cD wcel w3a wth cA cB cop cC cop vx cv cR wcel vy cv cS
      wcel wa wph wa vx vy vz copab2 wcel cA cB cop vx cv cR wcel vy cv cS wcel
      wa wph wa vx vy vz copab2 cfv cC wceq cA cR wcel cB cS wcel cC cD wcel
      w3a wth cA cB cop cC cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz
      copab2 wcel wi cA cR wcel cB cS wcel cA cR wcel cB cS wcel cC cD wcel w3a
      wth cA cB cop cC cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz
      copab2 wcel wi wi cC cD wcel cA cR wcel cB cS wcel cC cD wcel w3a cA cR
      wcel cB cS wcel wa wth cA cB cop cC cop vx cv cR wcel vy cv cS wcel wa
      wph wa vx vy vz copab2 wcel wi cA cR wcel cB cS wcel cC cD wcel w3a cA cR
      wcel cB cS wcel wa wth cA cB cop cC cop vx cv cR wcel vy cv cS wcel wa
      wph wa vx vy vz copab2 wcel cA cR wcel cB cS wcel cC cD wcel w3a cA cB
      cop cC cop vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 wcel cA
      cR wcel cB cS wcel wa wth wa vx cv cR wcel vy cv cS wcel wa wph wa cA cR
      wcel vy cv cS wcel wa wps wa cA cR wcel cB cS wcel wa wch wa cA cR wcel
      cB cS wcel wa wth wa vx vy vz cA cB cC cR cS cD vx cv cA wceq vx cv cR
      wcel vy cv cS wcel wa cA cR wcel vy cv cS wcel wa wph wps vx cv cA wceq
      vx cv cR wcel cA cR wcel vy cv cS wcel vx cv cA cR eleq1 anbi1d
      oprabvalig.1 anbi12d vy cv cB wceq cA cR wcel vy cv cS wcel wa cA cR wcel
      cB cS wcel wa wps wch vy cv cB wceq vy cv cS wcel cB cS wcel cA cR wcel
      vy cv cB cS eleq1 anbi2d oprabvalig.2 anbi12d vz cv cC wceq wch wth cA cR
      wcel cB cS wcel wa oprabvalig.3 anbi2d eloprabg biimpar exp32 com12
      3adant3 pm2.43i cC cD wcel cA cR wcel cA cB cop cC cop vx cv cR wcel vy
      cv cS wcel wa wph wa vx vy vz copab2 wcel cA cB cop vx cv cR wcel vy cv
      cS wcel wa wph wa vx vy vz copab2 cfv cC wceq wi cB cS wcel cC cD wcel vx
      cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 wfun cA cB cop cC cop
      vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 wcel cA cB cop vx
      cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 cfv cC wceq wi vx cv
      cR wcel vy cv cS wcel wa wph wa vx vy vz vx cv cR wcel vy cv cS wcel wa
      wph wa vz wmo vx cv cR wcel vy cv cS wcel wa wph vz wmo wi oprabvalig.4
      vx cv cR wcel vy cv cS wcel wa wph vz moanimv mpbir funoprab cA cB cop cC
      cD vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 funopfvg mpan2
      3ad2ant3 syld cA cB cF co cA cB cop vx cv cR wcel vy cv cS wcel wa wph wa
      vx vy vz copab2 cfv cC cA cB cF co cA cB cop cF cfv cA cB cop vx cv cR
      wcel vy cv cS wcel wa wph wa vx vy vz copab2 cfv cA cB cF df-opr cA cB
      cop cF vx cv cR wcel vy cv cS wcel wa wph wa vx vy vz copab2 oprabvalig.5
      fveq1i eqtri eqeq1i syl6ibr $.
      $( [14-Sep-1999] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z S $.
    $d x ps $.  $d x y ch $.  $d x y z th $.
    oprabvali.1 $e |- C e. _V $.
    oprabvali.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    oprabvali.3 $e |- ( y = B -> ( ps <-> ch ) ) $.
    oprabvali.4 $e |- ( z = C -> ( ch <-> th ) ) $.
    oprabvali.5 $e |- ( ( x e. R /\ y e. S ) -> E* z ph ) $.
    oprabvali.6 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction (weak version). $)
    oprabvali $p |- ( ( A e. R /\ B e. S ) -> ( th -> ( A F B ) = C ) ) $=
      cA cR wcel cB cS wcel cC cvv wcel wth cA cB cF co cC wceq wi oprabvali.1
      wph wps wch wth vx vy vz cA cB cC cvv cR cS cF oprabvali.2 oprabvali.3
      oprabvali.4 oprabvali.5 oprabvali.6 oprabvalig mp3an3 $.
      $( [16-May-1995] $)
  $}

  ${
    $d u v x y z A $.  $d u v y z B $.  $d u v x y z C $.  $d u v w G $.
    $d u v x y z D $.  $d u v w z R $.  $d u v w z S $.  $d x y w $.
    oprabval2gf.1 $e |- ( w e. G -> A. x w e. G ) $.
    oprabval2gf.2 $e |- ( w e. S -> A. y w e. S ) $.
    oprabval2gf.3 $e |- ( x = A -> R = G ) $.
    oprabval2gf.4 $e |- ( y = B -> G = S ) $.
    oprabval2gf.5 $e |- F = { <. <. x , y >. , z >. | ( ( x e. C /\ y e. D )
                      /\ z = R ) } $.
    $( The value of an operation class abstraction.  A version of ~ oprabval2g
       using bound-variable hypotheses. $)
    oprabval2gf $p |- ( ( A e. C /\ B e. D /\ S e. H ) -> ( A F B ) = S ) $=
      cA cC wcel cB cD wcel cS cH wcel w3a cA cB vu cv cC wcel vv cv cD wcel wa
      vz cv vy vv cv vx vu cv cR csb csb wceq wa vu vv vz copab2 co cS cA cB cF
      co cA cC wcel cB cD wcel cS cH wcel w3a cS cS wceq cA cB vu cv cC wcel vv
      cv cD wcel wa vz cv vy vv cv vx vu cv cR csb csb wceq wa vu vv vz copab2
      co cS wceq cS eqid vz cv vy vv cv vx vu cv cR csb csb wceq vz cv vy vv cv
      cG csb wceq vz cv cS wceq cS cS wceq vu vv vz cA cB cS cH cC cD vu cv cC
      wcel vv cv cD wcel wa vz cv vy vv cv vx vu cv cR csb csb wceq wa vu vv vz
      copab2 vu cv cA wceq vy vv cv vx vu cv cR csb csb vy vv cv cG csb vz cv
      vu cv cA wceq vv cv cvv wcel vy vv cv vx vu cv cR csb csb vy vv cv cG csb
      wceq vv visset vu cv cA wceq vy vv cv vx vu cv cR csb cG cvv vu cv cA
      wceq vy ax-17 vx vu vv cA cR cG vv cv cA wcel vx ax-17 vx vw vv cG
      oprabval2gf.1 hblem oprabval2gf.3 csbhypf csbeq2d mpan2 eqeq2d vv cv cB
      wceq vy vv cv cG csb cS vz cv vy vv vu cB cG cS vu cv cB wcel vy ax-17 vy
      vw vu cS oprabval2gf.2 hblem oprabval2gf.4 csbhypf eqeq2d vz cv cS cS
      eqeq1 vz cv vy vv cv vx vu cv cR csb csb wceq vz wmo vu cv cC wcel vv cv
      cD wcel wa vz vy vv cv vx vu cv cR csb csb moeq a1i vu cv cC wcel vv cv
      cD wcel wa vz cv vy vv cv vx vu cv cR csb csb wceq wa vu vv vz copab2
      eqid oprabvalig mpi cF vu cv cC wcel vv cv cD wcel wa vz cv vy vv cv vx
      vu cv cR csb csb wceq wa vu vv vz copab2 cA cB cF vx cv cC wcel vy cv cD
      wcel wa vz cv cR wceq wa vx vy vz copab2 vu cv cC wcel vv cv cD wcel wa
      vz cv vy vv cv vx vu cv cR csb csb wceq wa vu vv vz copab2 oprabval2gf.5
      vx cv cC wcel vy cv cD wcel wa vz cv cR wceq wa vu cv cC wcel vv cv cD
      wcel wa vz cv vy vv cv vx vu cv cR csb csb wceq wa vx vy vz vu vv vx cv
      cC wcel vy cv cD wcel wa vz cv cR wceq wa vu ax-17 vx cv cC wcel vy cv cD
      wcel wa vz cv cR wceq wa vv ax-17 vu cv cC wcel vv cv cD wcel wa vz cv vy
      vv cv vx vu cv cR csb csb wceq vx vu cv cC wcel vv cv cD wcel wa vx ax-17
      vx vw vw vz cv vy vv cv vx vu cv cR csb csb vw cv vz cv wcel vx ax-17 vv
      cv cvv wcel vw cv vy vv cv vx vu cv cR csb csb wcel vw cv vy vv cv vx vu
      cv cR csb csb wcel vx wal wi vv visset vx vy vw vv cv vx vu cv cR csb cvv
      vw cv vv cv wcel vx ax-17 vx vw vu cv cR vu visset vw cv vu cv wcel vx
      ax-17 hbcsb1 hbcsbg ax-mp hbeq hban vu cv cC wcel vv cv cD wcel wa vz cv
      vy vv cv vx vu cv cR csb csb wceq vy vu cv cC wcel vv cv cD wcel wa vy
      ax-17 vy vw vw vz cv vy vv cv vx vu cv cR csb csb vw cv vz cv wcel vy
      ax-17 vy vw vv cv vx vu cv cR csb vv visset vw cv vv cv wcel vy ax-17
      hbcsb1 hbeq hban vx cv vu cv wceq vx cv cC wcel vy cv cD wcel wa vz cv cR
      wceq wa vu cv cC wcel vy cv cD wcel wa vz cv vx vu cv cR csb wceq wa vy
      cv vv cv wceq vu cv cC wcel vv cv cD wcel wa vz cv vy vv cv vx vu cv cR
      csb csb wceq wa vx cv vu cv wceq vx cv cC wcel vy cv cD wcel wa vu cv cC
      wcel vy cv cD wcel wa vz cv cR wceq vz cv vx vu cv cR csb wceq vx cv vu
      cv wceq vx cv cC wcel vu cv cC wcel vy cv cD wcel vx cv vu cv cC eleq1
      anbi1d vx cv vu cv wceq cR vx vu cv cR csb vz cv vx vu cv cR csbeq1a
      eqeq2d anbi12d vy cv vv cv wceq vu cv cC wcel vy cv cD wcel wa vu cv cC
      wcel vv cv cD wcel wa vz cv vx vu cv cR csb wceq vz cv vy vv cv vx vu cv
      cR csb csb wceq vy cv vv cv wceq vy cv cD wcel vv cv cD wcel vu cv cC
      wcel vy cv vv cv cD eleq1 anbi2d vy cv vv cv wceq vx vu cv cR csb vy vv
      cv vx vu cv cR csb csb vz cv vy vv cv vx vu cv cR csb csbeq1a eqeq2d
      anbi12d sylan9bb cbvoprab12 eqtri opreqi syl5eq $.
      $( [20-Dec-2008] $) $( [17-Aug-2006] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    $d x w G $.  $d w z R $.  $d w y z S $.
    oprabval2g.1 $e |- ( x = A -> R = G ) $.
    oprabval2g.2 $e |- ( y = B -> G = S ) $.
    oprabval2g.3 $e |- F = { <. <. x , y >. , z >. | ( ( x e. C /\ y e. D )
                      /\ z = R ) } $.
    $( The value of an operation class abstraction.  Special case. $)
    oprabval2g $p |- ( ( A e. C /\ B e. D /\ S e. H ) -> ( A F B ) = S ) $=
      vx vy vz vw cA cB cC cD cR cS cF cG cH vw cv cG wcel vx ax-17 vw cv cS
      wcel vy ax-17 oprabval2g.1 oprabval2g.2 oprabval2g.3 oprabval2gf $.
      $( [14-Sep-1999] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    $d x G $.  $d z R $.  $d y z S $.
    oprabval2.1 $e |- S e. _V $.
    oprabval2.2 $e |- ( x = A -> R = G ) $.
    oprabval2.3 $e |- ( y = B -> G = S ) $.
    oprabval2.4 $e |- F = { <. <. x , y >. , z >. | ( ( x e. C /\ y e. D )
                      /\ z = R ) } $.
    $( The value of an operation class abstraction.  Special case. $)
    oprabval2 $p |- ( ( A e. C /\ B e. D ) -> ( A F B ) = S ) $=
      cA cC wcel cB cD wcel cS cvv wcel cA cB cF co cS wceq oprabval2.1 vx vy
      vz cA cB cC cD cR cS cF cG cvv oprabval2.2 oprabval2.3 oprabval2.4
      oprabval2g mp3an3 $.
      $( [16-May-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $d x G $.  $d z R $.  $d y z S $.
    oprabval5.1 $e |- S e. _V $.
    oprabval5.2 $e |- ( x = A -> R = G ) $.
    oprabval5.3 $e |- ( y = B -> G = S ) $.
    oprabval5.4 $e |- F = { <. <. x , y >. , z >. | z = R } $.
    $( The value of an operation class abstraction.  Special case. $)
    oprabval5 $p |- ( ( A e. C /\ B e. D ) -> ( A F B ) = S ) $=
      cA cvv wcel cB cvv wcel cA cB cF co cS wceq cA cC wcel cB cD wcel vx vy
      vz cA cB cvv cvv cR cS cF cG oprabval5.1 oprabval5.2 oprabval5.3 cF vz cv
      cR wceq vx vy vz copab2 vx cv cvv wcel vy cv cvv wcel wa vz cv cR wceq wa
      vx vy vz copab2 oprabval5.4 vz cv cR wceq vx cv cvv wcel vy cv cvv wcel
      wa vz cv cR wceq wa vx vy vz vx cv cvv wcel vy cv cvv wcel wa vz cv cR
      wceq vx cv cvv wcel vy cv cvv wcel vx visset vy visset pm3.2i biantrur
      oprabbii eqtri oprabval2 cA cC elisset cB cD elisset syl2an $.
      $( [23-Jul-2005] $) $( [19-Jul-2005] $)
  $}

  ${
    $d x y z w v u f A $.  $d x y z w v u f B $.  $d x y z w v u f C $.
    $d x y z w v u f D $.  $d x y z w v u f H $.  $d x y z R $.
    $d x y z w v u f S $.
    oprabval3.1 $e |- S e. _V $.
    oprabval3.2 $e |- ( ( ( w = A /\ v = B ) /\ ( u = C /\ f = D ) ) ->
         R = S ) $.
    oprabval3.3 $e |- F = { <. <. x , y >. , z >. | ( ( x e. ( H X. H ) /\
                      y e. ( H X. H ) ) /\
                      E. w E. v E. u E. f ( ( x = <. w , v >. /\
                      y = <. u , f >. ) /\ z = R ) ) } $.
    $( The value of an operation class abstraction.  Special case. $)
    oprabval3 $p |- ( ( ( A e. H /\ B e. H ) /\ ( C e. H /\ D e. H ) ) ->
        ( <. A , B >. F <. C , D >. ) = S ) $=
      cA cB cop cH cH cxp wcel cC cD cop cH cH cxp wcel wa cA cB cop vw cv vv
      cv cop wceq cC cD cop vu cv vf cv cop wceq wa cS cR wceq wa vf wex vu wex
      vv wex vw wex cA cB cop cC cD cop cF co cS wceq cA cH wcel cB cH wcel wa
      cC cH wcel cD cH wcel wa wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv
      cop wceq wa vz cv cR wceq wa vf wex vu wex vv wex vw wex cA cB cop vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu
      wex vv wex vw wex cA cB cop vw cv vv cv cop wceq cC cD cop vu cv vf cv
      cop wceq wa vz cv cR wceq wa vf wex vu wex vv wex vw wex cA cB cop vw cv
      vv cv cop wceq cC cD cop vu cv vf cv cop wceq wa cS cR wceq wa vf wex vu
      wex vv wex vw wex vx vy vz cA cB cop cC cD cop cS cH cH cxp cH cH cxp cF
      oprabval3.1 vx cv cA cB cop wceq vx cv vw cv vv cv cop wceq vy cv vu cv
      vf cv cop wceq wa vz cv cR wceq wa cA cB cop vw cv vv cv cop wceq vy cv
      vu cv vf cv cop wceq wa vz cv cR wceq wa vw vv vu vf vx cv cA cB cop wceq
      vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa cA cB cop vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq vx cv cA cB
      cop wceq vx cv vw cv vv cv cop wceq cA cB cop vw cv vv cv cop wceq vy cv
      vu cv vf cv cop wceq vx cv cA cB cop vw cv vv cv cop eqeq1 anbi1d anbi1d
      4exbidv vy cv cC cD cop wceq cA cB cop vw cv vv cv cop wceq vy cv vu cv
      vf cv cop wceq wa vz cv cR wceq wa cA cB cop vw cv vv cv cop wceq cC cD
      cop vu cv vf cv cop wceq wa vz cv cR wceq wa vw vv vu vf vy cv cC cD cop
      wceq cA cB cop vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa cA cB
      cop vw cv vv cv cop wceq cC cD cop vu cv vf cv cop wceq wa vz cv cR wceq
      vy cv cC cD cop wceq vy cv vu cv vf cv cop wceq cC cD cop vu cv vf cv cop
      wceq cA cB cop vw cv vv cv cop wceq vy cv cC cD cop vu cv vf cv cop eqeq1
      anbi2d anbi1d 4exbidv vz cv cS wceq cA cB cop vw cv vv cv cop wceq cC cD
      cop vu cv vf cv cop wceq wa vz cv cR wceq wa cA cB cop vw cv vv cv cop
      wceq cC cD cop vu cv vf cv cop wceq wa cS cR wceq wa vw vv vu vf vz cv cS
      wceq vz cv cR wceq cS cR wceq cA cB cop vw cv vv cv cop wceq cC cD cop vu
      cv vf cv cop wceq wa vz cv cS cR eqeq1 anbi2d 4exbidv vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu wex vv
      wex vw wex vz wmo vx cv cH cH cxp wcel vy cv cH cH cxp wcel wa vx cv vw
      cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex
      vu wex vv wex vw wex vz wmo vx cv vw cv vv cv cop wceq vy cv vu cv vf cv
      cop wceq vz cv cR wceq wa vf wex vu wex wa vv wex vw wex vz wmo vy cv vu
      cv vf cv cop wceq vz cv cR wceq wa vf wex vu wex vz vw vv vx cv vz cv cR
      wceq vz vu vf vy cv vz cR moeq mosubop mosubop vx cv vw cv vv cv cop wceq
      vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu wex vv wex vw
      wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv cR wceq
      wa vf wex vu wex wa vv wex vw wex vz vx cv vw cv vv cv cop wceq vy cv vu
      cv vf cv cop wceq wa vz cv cR wceq wa vf wex vu wex vx cv vw cv vv cv cop
      wceq vy cv vu cv vf cv cop wceq vz cv cR wceq wa vf wex vu wex wa vw vv
      vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv cR wceq wa
      vf wex vu wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv
      cR wceq wa wa vf wex vu wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv
      cop wceq vz cv cR wceq wa vf wex vu wex wa vx cv vw cv vv cv cop wceq vy
      cv vu cv vf cv cop wceq wa vz cv cR wceq wa vx cv vw cv vv cv cop wceq vy
      cv vu cv vf cv cop wceq vz cv cR wceq wa wa vu vf vx cv vw cv vv cv cop
      wceq vy cv vu cv vf cv cop wceq vz cv cR wceq anass 2exbii vx cv vw cv vv
      cv cop wceq vy cv vu cv vf cv cop wceq vz cv cR wceq wa vu vf 19.42vv
      bitri 2exbii mobii mpbir a1i oprabval3.3 oprabvali cA cH wcel cB cH wcel
      wa cA cB cop cH cH cxp wcel cC cH wcel cD cH wcel wa cC cD cop cH cH cxp
      wcel cA cB cH cH opelxpi cC cD cH cH opelxpi anim12i cA cH wcel cB cH
      wcel wa cC cH wcel cD cH wcel wa wa cA cB cop vw cv vv cv cop wceq cC cD
      cop vu cv vf cv cop wceq wa cS cR wceq wa vf wex vu wex vv wex vw wex cS
      cS wceq cS eqid cS cR wceq cS cS wceq vw vv vu vf cA cB cC cD cH cH vw cv
      cA wceq vv cv cB wceq wa vu cv cC wceq vf cv cD wceq wa wa cR cS cS
      oprabval3.2 eqeq2d copsex4g mpbiri sylc $.
      $( [28-May-1995] $)
  $}

  ${
    $d x y z w v u f A $.  $d x y z w v u f B $.  $d z w v u f C $.
    $d w v D $.
    oprabval4g.1 $e |- F =
          { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ z = C ) } $.
    $( Value of an operation given by an ordered-pair class abstraction.
       (This is the operation analog of ~ fvopab2 .) $)
    oprabval4g $p |- ( ( x e. A /\ y e. B /\ C e. D ) -> ( x F y ) = C ) $=
      vx cv cA wcel vy cv cB wcel cC cvv wcel vx cv vy cv cF co cC wceq cC cD
      wcel vw vv vz vx cv vy cv cA cB vf cv vu cv cC wcel vy vv cv wsbc vu cab
      wcel vx vw cv wsbc vf cab cC cF vu cv cC wcel vy vv cv wsbc vu cab cvv vf
      cv vu cv cC wcel vy vv cv wsbc vu cab wcel vx vw cv wsbc vf cab vu cv cC
      wcel vy vv cv wsbc vu cab wceq vx vw vx cv vw cv wceq vu cv cC wcel vy vv
      cv wsbc vu cab vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel vx vw cv
      wsbc vf cab vx vw vf vu cv cC wcel vy vv cv wsbc vu cab sbab eqcomd
      equcoms vu cv cC wcel vy vv cv wsbc vu cab cC wceq vy vv vy cv vv cv wceq
      cC vu cv cC wcel vy vv cv wsbc vu cab vy vv vu cC sbab eqcomd equcoms cF
      vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 vw cv cA
      wcel vv cv cB wcel wa vz cv vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel
      vx vw cv wsbc vf cab wceq wa vw vv vz copab2 oprabval4g.1 vw cv cA wcel
      vv cv cB wcel wa vz cv vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel vx
      vw cv wsbc vf cab wceq wa vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa
      vw vv vz vx vy vw cv cA wcel vv cv cB wcel wa vz cv vf cv vu cv cC wcel
      vy vv cv wsbc vu cab wcel vx vw cv wsbc vf cab wceq vx vw cv cA wcel vv
      cv cB wcel wa vx ax-17 vx vz vf cv vu cv cC wcel vy vv cv wsbc vu cab
      wcel vx vw cv wsbc vf cab vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel
      vx vw cv wsbc vx vf vz vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel vx
      vw hbs1 hbab hbeleq hban vw cv cA wcel vv cv cB wcel wa vz cv vf cv vu cv
      cC wcel vy vv cv wsbc vu cab wcel vx vw cv wsbc vf cab wceq vy vw cv cA
      wcel vv cv cB wcel wa vy ax-17 vy vz vf cv vu cv cC wcel vy vv cv wsbc vu
      cab wcel vx vw cv wsbc vf cab vf cv vu cv cC wcel vy vv cv wsbc vu cab
      wcel vx vw cv wsbc vy vf vz vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel
      vx vw vy vu cv cC wcel vy vv cv wsbc vy vu vf vu cv cC wcel vy vv hbs1
      hbab hbsb hbab hbeleq hban vx cv cA wcel vy cv cB wcel wa vz cv cC wceq
      wa vw ax-17 vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vv ax-17 vw
      cv vx cv wceq vv cv vy cv wceq wa vw cv cA wcel vv cv cB wcel wa vx cv cA
      wcel vy cv cB wcel wa vz cv vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel
      vx vw cv wsbc vf cab wceq vz cv cC wceq vw cv vx cv wceq vw cv cA wcel vx
      cv cA wcel vv cv vy cv wceq vv cv cB wcel vy cv cB wcel vw cv vx cv cA
      eleq1 vv cv vy cv cB eleq1 bi2anan9 vw cv vx cv wceq vv cv vy cv wceq wa
      vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel vx vw cv wsbc vf cab cC vz
      cv vw cv vx cv wceq vv cv vy cv wceq vf cv vu cv cC wcel vy vv cv wsbc vu
      cab wcel vx vw cv wsbc vf cab vu cv cC wcel vy vv cv wsbc vu cab cC vf cv
      vu cv cC wcel vy vv cv wsbc vu cab wcel vx vw cv wsbc vf cab vu cv cC
      wcel vy vv cv wsbc vu cab wceq vx vw vx cv vw cv wceq vu cv cC wcel vy vv
      cv wsbc vu cab vf cv vu cv cC wcel vy vv cv wsbc vu cab wcel vx vw cv
      wsbc vf cab vx vw vf vu cv cC wcel vy vv cv wsbc vu cab sbab eqcomd
      equcoms vu cv cC wcel vy vv cv wsbc vu cab cC wceq vy vv vy cv vv cv wceq
      cC vu cv cC wcel vy vv cv wsbc vu cab vy vv vu cC sbab eqcomd equcoms
      sylan9eq eqeq2d anbi12d cbvoprab12 eqtr4i oprabval2g cC cD elisset
      syl3an3 $.
      $( [1-Jul-2004] $) $( [21-Feb-2004] $)

    $( MAY BE REVISED - this proof eliminates sbab with csb* stuff, but
       the proof ends up longer. $)
    $( Value of an operation given by an ordered-pair class abstraction.
       (This is the operation analog of ~ fvopab2 .) $)
    oprabval4gALT $p |- ( ( x e. A /\ y e. B /\ C e. D ) -> ( x F y ) = C ) $=
      vx cv cA wcel vy cv cB wcel cC cvv wcel vx cv vy cv cF co cC wceq cC cD
      wcel vw vv vz vx cv vy cv cA cB vx vw cv vy vv cv cC csb csb cC cF vy vv
      cv cC csb cvv vx vw cv vy vv cv cC csb csb vy vv cv cC csb wceq vx vw vx
      cv vw cv wceq vy vv cv cC csb vx vw cv vy vv cv cC csb csb vx vw cv vy vv
      cv cC csb csbeq1a eqcomd equcoms vy vv cv cC csb cC wceq vy vv vy cv vv
      cv wceq cC vy vv cv cC csb vy vv cv cC csbeq1a eqcomd equcoms cF vx cv cA
      wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 vw cv cA wcel vv
      cv cB wcel wa vz cv vx vw cv vy vv cv cC csb csb wceq wa vw vv vz copab2
      oprabval4g.1 vw cv cA wcel vv cv cB wcel wa vz cv vx vw cv vy vv cv cC
      csb csb wceq wa vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vw vv vz
      vx vy vw cv cA wcel vv cv cB wcel wa vz cv vx vw cv vy vv cv cC csb csb
      wceq vx vw cv cA wcel vv cv cB wcel wa vx ax-17 vx vz vx vw cv vy vv cv
      cC csb csb vx vz vw cv vy vv cv cC csb vw visset vz cv vw cv wcel vx
      ax-17 hbcsb1 hbeleq hban vw cv cA wcel vv cv cB wcel wa vz cv vx vw cv vy
      vv cv cC csb csb wceq vy vw cv cA wcel vv cv cB wcel wa vy ax-17 vy vz vx
      vw cv vy vv cv cC csb csb vw cv cvv wcel vz cv vx vw cv vy vv cv cC csb
      csb wcel vz cv vx vw cv vy vv cv cC csb csb wcel vy wal wi vw visset vy
      vx vz vw cv vy vv cv cC csb cvv vz cv vw cv wcel vy ax-17 vy vz vv cv cC
      vv visset vz cv vv cv wcel vy ax-17 hbcsb1 hbcsbg ax-mp hbeleq hban vx cv
      cA wcel vy cv cB wcel wa vz cv cC wceq wa vw ax-17 vx cv cA wcel vy cv cB
      wcel wa vz cv cC wceq wa vv ax-17 vw cv vx cv wceq vv cv vy cv wceq wa vw
      cv cA wcel vv cv cB wcel wa vx cv cA wcel vy cv cB wcel wa vz cv vx vw cv
      vy vv cv cC csb csb wceq vz cv cC wceq vw cv vx cv wceq vw cv cA wcel vx
      cv cA wcel vv cv vy cv wceq vv cv cB wcel vy cv cB wcel vw cv vx cv cA
      eleq1 vv cv vy cv cB eleq1 bi2anan9 vw cv vx cv wceq vv cv vy cv wceq wa
      vx vw cv vy vv cv cC csb csb cC vz cv vw cv vx cv wceq vv cv vy cv wceq
      vx vw cv vy vv cv cC csb csb vy vv cv cC csb cC vx vw cv vy vv cv cC csb
      csb vy vv cv cC csb wceq vx vw vx cv vw cv wceq vy vv cv cC csb vx vw cv
      vy vv cv cC csb csb vx vw cv vy vv cv cC csb csbeq1a eqcomd equcoms vy vv
      cv cC csb cC wceq vy vv vy cv vv cv wceq cC vy vv cv cC csb vy vv cv cC
      csbeq1a eqcomd equcoms sylan9eq eqeq2d anbi12d cbvoprab12 eqtr4i
      oprabval2g cC cD elisset syl3an3 $.
      $( [1-Jul-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.  $d w z R $.
    $d w x y z S $.
    oprabval6g.1 $e |- ( <. x , y >. = <. A , B >. -> R = S ) $.
    oprabval6g.2 $e |- F = { <. <. x , y >. , z >. | ( <. x , y >. e. C
                      /\ z = R ) } $.
    $( The value of an operation class abstraction.  Special case. $)
    oprabval6g $p |- ( ( ( A e. G /\ B e. H /\ <. A , B >. e. C ) /\ S e. J )
                     -> ( A F B ) = S ) $=
      cA cG wcel cB cH wcel cA cB cop cC wcel w3a cS cJ wcel wa cA cB cop cF
      cfv cS cA cB cF co cA cG wcel cB cH wcel cA cB cop cC wcel w3a cS cJ wcel
      wa cA cB cop vx cv vy cv cop wceq cS cS wceq wa vy wex vx wex cA cB cop
      cF cfv cS wceq cA cG wcel cB cH wcel cA cB cop cC wcel w3a cA cB cop vx
      cv vy cv cop wceq cS cS wceq wa vy wex vx wex cS cJ wcel cA cG wcel cB cH
      wcel cA cB cop vx cv vy cv cop wceq cS cS wceq wa vy wex vx wex cA cB cop
      cC wcel cA cG wcel cB cH wcel wa cA cB cop vx cv vy cv cop wceq cS cS
      wceq wa vy wex vx wex cS cS wceq cS eqid cS cS wceq cS cS wceq vx vy cA
      cB cG cH vx cv cA wceq vy cv cB wceq wa cS cS wceq biidd copsex2g mpbiri
      3adant3 adantr cA cB cop cC wcel cA cG wcel cS cJ wcel cA cB cop vx cv vy
      cv cop wceq cS cS wceq wa vy wex vx wex cA cB cop cF cfv cS wceq wi cB cH
      wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa vy wex vx wex cA cB cop
      vx cv vy cv cop wceq vz cv cS wceq wa vy wex vx wex cA cB cop vx cv vy cv
      cop wceq cS cS wceq wa vy wex vx wex vw vz cA cB cop cS cC cJ cF vw cv cA
      cB cop wceq vw cv vx cv vy cv cop wceq vz cv cR wceq wa cA cB cop vx cv
      vy cv cop wceq vz cv cS wceq wa vx vy vw cv cA cB cop wceq vw cv vx cv vy
      cv cop wceq vz cv cR wceq wa cA cB cop vx cv vy cv cop wceq vz cv cR wceq
      wa cA cB cop vx cv vy cv cop wceq vz cv cS wceq wa vw cv cA cB cop wceq
      vw cv vx cv vy cv cop wceq cA cB cop vx cv vy cv cop wceq vz cv cR wceq
      vw cv cA cB cop vx cv vy cv cop eqeq1 anbi1d cA cB cop vx cv vy cv cop
      wceq vz cv cR wceq vz cv cS wceq vz cv cR wceq vz cv cS wceq wb vx cv vy
      cv cop cA cB cop vx cv vy cv cop cA cB cop wceq cR cS vz cv oprabval6g.1
      eqeq2d eqcoms pm5.32i syl6bb 2exbidv vz cv cS wceq cA cB cop vx cv vy cv
      cop wceq vz cv cS wceq wa cA cB cop vx cv vy cv cop wceq cS cS wceq wa vx
      vy vz cv cS wceq vz cv cS wceq cS cS wceq cA cB cop vx cv vy cv cop wceq
      vz cv cS cS eqeq1 anbi2d 2exbidv vw cv vx cv vy cv cop wceq vz cv cR wceq
      wa vy wex vx wex vz wmo vw cv cC wcel vz cv cR wceq vz vx vy vw cv vz cR
      moeq mosubop a1i cF vx cv vy cv cop cC wcel vz cv cR wceq wa vx vy vz
      copab2 vw cv vx cv vy cv cop wceq vx cv vy cv cop cC wcel vz cv cR wceq
      wa wa vy wex vx wex vw vz copab vw cv cC wcel vw cv vx cv vy cv cop wceq
      vz cv cR wceq wa vy wex vx wex wa vw vz copab oprabval6g.2 vx cv vy cv
      cop cC wcel vz cv cR wceq wa vx vy vz vw dfoprab2 vw cv vx cv vy cv cop
      wceq vx cv vy cv cop cC wcel vz cv cR wceq wa wa vy wex vx wex vw cv cC
      wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa vy wex vx wex wa vw vz
      vw cv vx cv vy cv cop wceq vx cv vy cv cop cC wcel vz cv cR wceq wa wa vy
      wex vx wex vw cv cC wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa wa
      vy wex vx wex vw cv cC wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa
      vy wex vx wex wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cC wcel vz cv
      cR wceq wa wa vw cv cC wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa
      wa vx vy vw cv vx cv vy cv cop wceq vx cv vy cv cop cC wcel vz cv cR wceq
      wa wa vw cv vx cv vy cv cop wceq vw cv cC wcel vz cv cR wceq wa wa vw cv
      cC wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa wa vw cv vx cv vy cv
      cop wceq vw cv cC wcel vz cv cR wceq wa vx cv vy cv cop cC wcel vz cv cR
      wceq wa vw cv vx cv vy cv cop wceq vw cv cC wcel vx cv vy cv cop cC wcel
      vz cv cR wceq vw cv vx cv vy cv cop cC eleq1 anbi1d pm5.32i vw cv vx cv
      vy cv cop wceq vw cv cC wcel vz cv cR wceq an12 bitr3i 2exbii vw cv cC
      wcel vw cv vx cv vy cv cop wceq vz cv cR wceq wa vx vy 19.42vv bitri
      opabbii 3eqtri fvopab3ig 3ad2antl3 mpd cA cB cF df-opr syl5eq $.
      $( [13-Nov-2006] $) $( [13-Nov-2006] $)
  $}

  $( The value of a restricted operation.  (Contributed by FL,
     10-Nov-2006.) $)
  oprvres $p |- ( ( A e. C /\ B e. D ) ->  ( A ( F |` ( C X. D ) ) B )
    = ( A F B ) ) $=
    cA cC wcel cB cD wcel wa cA cB cop cF cC cD cxp cres cfv cA cB cop cF cfv
    cA cB cF cC cD cxp cres co cA cB cF co cA cC wcel cB cD wcel wa cA cB cop
    cC cD cxp wcel cA cB cop cF cC cD cxp cres cfv cA cB cop cF cfv wceq cA cB
    cC cD opelxpi cA cB cop cC cD cxp cF fvres syl cA cB cF cC cD cxp cres
    df-opr cA cB cF df-opr 3eqtr4g $.
    $( [10-Nov-2006] $) $( [3-Nov-2006] $)

  $( The value of a member of the domain of a subclass of an operation. $)
  oprssoprv $p |- ( ( ( Fun F /\ G Fn ( C X. D ) /\ G C_ F ) /\
        ( A e. C /\ B e. D ) ) -> ( A F B ) = ( A G B ) ) $=
    cF wfun cG cC cD cxp wfn cG cF wss w3a cA cC wcel cB cD wcel wa wa cA cB cF
    cC cD cxp cres co cA cB cF co cA cB cG co cA cC wcel cB cD wcel wa cA cB cF
    cC cD cxp cres co cA cB cF co wceq cF wfun cG cC cD cxp wfn cG cF wss w3a
    cA cB cC cD cF oprvres adantl cF wfun cG cC cD cxp wfn cG cF wss w3a cA cB
    cF cC cD cxp cres co cA cB cG co wceq cA cC wcel cB cD wcel wa cF wfun cG
    cC cD cxp wfn cG cF wss w3a cF cC cD cxp cres cG cA cB cF wfun cG cC cD cxp
    wfn cG cF wss w3a cF cG cdm cres cF cC cD cxp cres cG cG cC cD cxp wfn cF
    wfun cF cG cdm cres cF cC cD cxp cres wceq cG cF wss cG cC cD cxp wfn cG
    cdm cC cD cxp wceq cF cG cdm cres cF cC cD cxp cres wceq cC cD cxp cG fndm
    cG cdm cC cD cxp cF reseq2 syl 3ad2ant2 cF wfun cG cF wss cF cG cdm cres cG
    wceq cG cC cD cxp wfn cF cG funssres 3adant2 eqtr3d opreqd adantr eqtr3d $.
    $( [30-Jan-2008] $) $( [23-Aug-2007] $)

  $( A operations's value belongs to its codomain. $)
  foprrn $p |- ( ( F : ( R X. S ) --> C /\ A e. R /\ B e. S ) ->
               ( A F B ) e. C ) $=
    cR cS cxp cC cF wf cA cR wcel cB cS wcel cA cB cF co cC wcel cR cS cxp cC
    cF wf cA cB cop cR cS cxp wcel cA cB cF co cC wcel cA cR wcel cB cS wcel wa
    cR cS cxp cC cF wf cA cB cop cR cS cxp wcel wa cA cB cop cF cfv cC cA cB cF
    co cR cS cxp cC cA cB cop cF ffvelrn cA cB cF df-opr syl5eqel cA cB cR cS
    opelxpi sylan2 3impb $.
    $( [31-Aug-2006] $) $( [27-Aug-2006] $)

  ${
    $d w x y z A $.  $d w x y z B $.  $d w z C $.  $d w x y z F $.
    $( The range of an operation expressed as a collection of the operation's
       values. $)
    fnrnoprv $p |- ( F Fn ( A X. B ) -> ran F = { z | E. x e. A E. y e. B
                     z = ( x F y ) } ) $=
      cF cA cB cxp wfn cF crn vz cv vw cv cF cfv wceq vw cA cB cxp wrex vz cab
      vz cv vx cv vy cv cF co wceq vy cB wrex vx cA wrex vz cab vw vz cA cB cxp
      cF fnrnfv vz cv vw cv cF cfv wceq vw cA cB cxp wrex vz cv vx cv vy cv cF
      co wceq vy cB wrex vx cA wrex vz vz cv vw cv cF cfv wceq vz cv vx cv vy
      cv cF co wceq vw vx vy cA cB vw cv vx cv vy cv cop wceq vw cv cF cfv vx
      cv vy cv cF co vz cv vw cv vx cv vy cv cop wceq vw cv cF cfv vx cv vy cv
      cop cF cfv vx cv vy cv cF co vw cv vx cv vy cv cop cF fveq2 vx cv vy cv
      cF df-opr syl6eqr eqeq2d rexxp abbii syl6eq $.
      $( [29-Oct-2006] $) $( [29-Oct-2006] $)

    $( An onto mapping of an operation expressed in terms of operation
       values. $)
    fooprv $p |- ( F : ( A X. B ) -onto-> C <-> ( F : ( A X. B ) --> C /\
                  A. z e. C E. x e. A E. y e. B z = ( x F y ) ) ) $=
      cA cB cxp cC cF wfo cA cB cxp cC cF wf vz cv vw cv cF cfv wceq vw cA cB
      cxp wrex vz cC wral wa cA cB cxp cC cF wf vz cv vx cv vy cv cF co wceq vy
      cB wrex vx cA wrex vz cC wral wa vw vz cA cB cxp cC cF dffo3 vz cv vw cv
      cF cfv wceq vw cA cB cxp wrex vz cC wral vz cv vx cv vy cv cF co wceq vy
      cB wrex vx cA wrex vz cC wral cA cB cxp cC cF wf vz cv vw cv cF cfv wceq
      vw cA cB cxp wrex vz cv vx cv vy cv cF co wceq vy cB wrex vx cA wrex vz
      cC vz cv vw cv cF cfv wceq vz cv vx cv vy cv cF co wceq vw vx vy cA cB vw
      cv vx cv vy cv cop wceq vw cv cF cfv vx cv vy cv cF co vz cv vw cv vx cv
      vy cv cop wceq vw cv cF cfv vx cv vy cv cop cF cfv vx cv vy cv cF co vw
      cv vx cv vy cv cop cF fveq2 vx cv vy cv cF df-opr syl6eqr eqeq2d rexxp
      ralbii anbi2i bitri $.
      $( [30-Oct-2006] $) $( [29-Oct-2006] $)
  $}

  $( An operation's value belongs to its range. $)
  fnoprvrn $p |- ( ( F Fn ( A X. B ) /\ C e. A /\ D e. B ) ->
                   ( C F D ) e. ran F ) $=
    cF cA cB cxp wfn cC cA wcel cD cB wcel cC cD cF co cF crn wcel cF cA cB cxp
    wfn cC cD cop cA cB cxp wcel cC cD cF co cF crn wcel cC cA wcel cD cB wcel
    wa cF cA cB cxp wfn cC cD cop cA cB cxp wcel wa cC cD cop cF cfv cF crn cC
    cD cF co cA cB cxp cC cD cop cF fnfvelrn cC cD cF df-opr syl5eqel cC cD cA
    cB opelxpi sylan2 3impb $.
    $( [14-Feb-2007] $) $( [10-Feb-2007] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z F $.
    $( A member of an operation's range is a value of the operation. $)
    oprvelrn $p |- ( F Fn ( A X. B ) -> ( C e. ran F <->
                  E. x e. A E. y e. B ( x F y ) = C ) ) $=
      cF cA cB cxp wfn cC cF crn wcel cC vz cv vx cv vy cv cF co wceq vy cB
      wrex vx cA wrex vz cab wcel vx cv vy cv cF co cC wceq vy cB wrex vx cA
      wrex cF cA cB cxp wfn cF crn vz cv vx cv vy cv cF co wceq vy cB wrex vx
      cA wrex vz cab cC vx vy vz cA cB cF fnrnoprv eleq2d vz cv vx cv vy cv cF
      co wceq vy cB wrex vx cA wrex vx cv vy cv cF co cC wceq vy cB wrex vx cA
      wrex vz cC vx cv vy cv cF co cC wceq vy cB wrex cC cvv wcel vx cA vx cv
      vy cv cF co cC wceq vy cB wrex cC cvv wcel wi vx cv cA wcel vx cv vy cv
      cF co cC wceq cC cvv wcel vy cB vx cv vy cv cF co cC wceq cC cvv wcel wi
      vy cv cB wcel vx cv vy cv cF co cC wceq vx cv vy cv cF co cvv wcel cC cvv
      wcel vx cv vy cv cF oprex vx cv vy cv cF co cC cvv eleq1 mpbii a1i
      r19.23aiv a1i r19.23aiv vz cv cC wceq vz cv vx cv vy cv cF co wceq vx cv
      vy cv cF co cC wceq vx vy cA cB vz cv cC wceq vz cv vx cv vy cv cF co
      wceq cC vx cv vy cv cF co wceq vx cv vy cv cF co cC wceq vz cv cC vx cv
      vy cv cF co eqeq1 cC vx cv vy cv cF co eqcom syl6bb 2rexbidv elab3 syl6bb
      $.
      $( [13-Feb-2007] $) $( [7-Feb-2007] $)
  $}

  ${
    oprvalconst2.1 $e |- C e. _V $.
    $( The value of a constant operation. $)
    oprvconst2 $p |- ( ( R e. A /\ S e. B ) ->
                       ( R ( ( A X. B ) X. { C } ) S ) = C ) $=
      cR cA wcel cS cB wcel wa cR cS cop cA cB cxp cC csn cxp cfv cC cR cS cA
      cB cxp cC csn cxp co cR cA wcel cS cB wcel wa cR cS cop cA cB cxp wcel cR
      cS cop cA cB cxp cC csn cxp cfv cC wceq cR cS cA cB opelxpi cA cB cxp cC
      cR cS cop oprvalconst2.1 fvconst2 syl cR cS cA cB cxp cC csn cxp df-opr
      syl5eq $.
      $( [17-Nov-2006] $) $( [5-Nov-2006] $)
  $}

  ${
    $d x y z w F $.  $d x y z w A $.  $d x y z w B $.
    oprvalex.1 $e |- A e. _V $.
    oprvalex.2 $e |- B e. _V $.
    $( Existence of a class of operation values. $)
    oprvex $p |- { z | E. x e. A E. y e. B z = ( x F y ) } e. _V $=
      vz cv vw cv cF cfv wceq vw cA cB cxp wrex vz cab vz cv vx cv vy cv cF co
      wceq vy cB wrex vx cA wrex vz cab cvv vz cv vw cv cF cfv wceq vw cA cB
      cxp wrex vz cv vx cv vy cv cF co wceq vy cB wrex vx cA wrex vz vz cv vw
      cv cF cfv wceq vz cv vx cv vy cv cF co wceq vw vx vy cA cB vw cv vx cv vy
      cv cop wceq vw cv cF cfv vx cv vy cv cF co vz cv vw cv vx cv vy cv cop
      wceq vw cv cF cfv vx cv vy cv cop cF cfv vx cv vy cv cF co vw cv vx cv vy
      cv cop cF fveq2 vx cv vy cv cF df-opr syl6eqr eqeq2d rexxp abbii vw vz cA
      cB cxp vw cv cF cfv cA cB oprvalex.1 oprvalex.2 xpex abrexex eqeltrri $.
      $( [15-Nov-1995] $)
  $}

  ${
    $d x y S $.  $d x y F $.
    oprssdm.1 $e |- -. (/) e. S $.
    oprssdm.2 $e |- ( ( x e. S /\ y e. S ) -> ( x F y ) e. S ) $.
    $( Domain of closure of an operation. $)
    oprssdm $p |- ( S X. S ) C_ dom F $=
      vx vy cS cS cxp cF cdm cS cS relxp vx cv vy cv cop cS cS cxp wcel vx cv
      cS wcel vy cv cS wcel wa vx cv vy cv cop cF cdm wcel vx cv vy cv cS cS vy
      visset opelxp vx cv vy cv cop cF cdm wcel vx cv cS wcel vy cv cS wcel wa
      vx cv vy cv cop cF cdm wcel wn vx cv vy cv cop cF cfv c0 wceq vx cv cS
      wcel vy cv cS wcel wa wn vx cv vy cv cop cF ndmfv vx cv vy cv cop cF cfv
      c0 wceq vx cv vy cv cF co c0 wceq vx cv cS wcel vy cv cS wcel wa wn vx cv
      vy cv cF co vx cv vy cv cop cF cfv c0 vx cv vy cv cF df-opr eqeq1i vx cv
      vy cv cF co c0 wceq vx cv vy cv cF co cS wcel vx cv cS wcel vy cv cS wcel
      wa vx cv vy cv cF co c0 wceq vx cv vy cv cF co cS wcel c0 cS wcel
      oprssdm.1 vx cv vy cv cF co c0 cS eleq1 mtbiri oprssdm.2 nsyl sylbir syl
      con4i sylbi relssi $.
      $( [24-Aug-1995] $)
  $}

  $( The value of an operation outside its domain. $)
  ndmoprg $p |- ( ( dom F = ( R X. S ) /\ B e. C /\ -. ( A e. R /\ B e. S ) )
              -> ( A F B ) = (/) ) $=
    cF cdm cR cS cxp wceq cB cC wcel cA cR wcel cB cS wcel wa wn cA cB cF co c0
    wceq cF cdm cR cS cxp wceq cB cC wcel wa cA cR wcel cB cS wcel wa wn cA cB
    cop cF cdm wcel wn cA cB cF co c0 wceq cF cdm cR cS cxp wceq cB cC wcel wa
    cA cB cop cF cdm wcel cA cR wcel cB cS wcel wa cF cdm cR cS cxp wceq cA cB
    cop cF cdm wcel cA cB cop cR cS cxp wcel cB cC wcel cA cR wcel cB cS wcel
    wa cF cdm cR cS cxp cA cB cop eleq2 cA cB cR cS cC opelxpg sylan9bb notbid
    cA cB cop cF cdm wcel wn cA cB cop cF cfv c0 cA cB cF co cA cB cop cF ndmfv
    cA cB cF df-opr syl5eq syl6bir 3impia $.
    $( [18-Apr-2008] $) $( [28-Mar-2008] $)

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x S $.
    ndmoprcl.1 $e |- dom F = ( S X. S ) $.
    ndmoprcl.2 $e |- ( ( A e. S /\ x e. S ) -> ( A F x ) e. S ) $.
    ndmoprcl.3 $e |- (/) e. S $.
    $( The closure of an operation outside its domain, when the domain
       includes the empty set.  This technical lemma can make the operation
       more convenient to work in some cases.  It is is dependent on our
       particular definitions of operation value, function value, and ordered
       pair. $)
    ndmoprcl $p |- ( A F B ) e. S $=
      cA cvv wcel cA cB cF co cS wcel cA cvv wcel cB cvv wcel cA cB cF co cS
      wcel cB cvv wcel wn cA cB cF co cS wcel cA cA cF co cS wcel cA cvv wcel
      cB cvv wcel wn cA cB cF co cA cA cF co cS cA cB cF oprprc2 eleq1d cA cvv
      wcel cA cS wcel cA cS wcel wa cA cA cF co cS wcel cA cvv wcel cA cS wcel
      cA cS wcel wa wn cA cA cF co cS wcel cA cvv wcel cA cS wcel cA cS wcel wa
      wn wa cA cA cF co c0 cS cF cdm cS cS cxp wceq cA cvv wcel cA cS wcel cA
      cS wcel wa wn cA cA cF co c0 wceq ndmoprcl.1 cA cA cvv cS cS cF ndmoprg
      mp3an1 ndmoprcl.3 syl6eqel ex cA cS wcel cA cS wcel cA cA cF co cS wcel
      cA cS wcel cA vx cv cF co cS wcel wi cA cS wcel cA cA cF co cS wcel wi vx
      cA cS vx cv cA wceq cA vx cv cF co cS wcel cA cA cF co cS wcel cA cS wcel
      vx cv cA wceq cA vx cv cF co cA cA cF co cS vx cv cA cA cF opreq2 eleq1d
      imbi2d cA cS wcel vx cv cS wcel cA vx cv cF co cS wcel ndmoprcl.2 expcom
      vtoclga imp pm2.61d2 syl5cbir cB cvv wcel cA cS wcel cB cS wcel wa cA cB
      cF co cS wcel cB cvv wcel cA cS wcel cB cS wcel wa wn cA cB cF co cS wcel
      cB cvv wcel cA cS wcel cB cS wcel wa wn wa cA cB cF co c0 cS cF cdm cS cS
      cxp wceq cB cvv wcel cA cS wcel cB cS wcel wa wn cA cB cF co c0 wceq
      ndmoprcl.1 cA cB cvv cS cS cF ndmoprg mp3an1 ndmoprcl.3 syl6eqel ex cB cS
      wcel cA cS wcel cA cB cF co cS wcel cA cS wcel cA vx cv cF co cS wcel wi
      cA cS wcel cA cB cF co cS wcel wi vx cB cS vx cv cB wceq cA vx cv cF co
      cS wcel cA cB cF co cS wcel cA cS wcel vx cv cB wceq cA vx cv cF co cA cB
      cF co cS vx cv cB cA cF opreq2 eleq1d imbi2d cA cS wcel vx cv cS wcel cA
      vx cv cF co cS wcel ndmoprcl.2 expcom vtoclga impcom pm2.61d2 pm2.61d2 cA
      cvv wcel wn cA cB cF co c0 cS cA cB cF cF cdm wrel cS cS cxp wrel cS cS
      relxp cF cdm cS cS cxp ndmoprcl.1 releqi mpbir oprprc1 ndmoprcl.3
      syl6eqel pm2.61i $.
      $( [16-Nov-2004] $) $( [24-Sep-2004] $)
  $}

  ${
    ndmopr.1 $e |- B e. _V $.
    ndmopr.2 $e |- dom F = ( S X. S ) $.
    $( The value of an operation outside its domain. $)
    ndmopr $p |- ( -. ( A e. S /\ B e. S ) -> ( A F B ) = (/) ) $=
      cF cdm cS cS cxp wceq cB cvv wcel cA cS wcel cB cS wcel wa wn cA cB cF co
      c0 wceq ndmopr.2 ndmopr.1 cA cB cvv cS cS cF ndmoprg mp3an12 $.
      $( [24-Aug-1995] $)

    ${
      ndmoprrcl.3 $e |- -. (/) e. S $.
      $( Reverse closure law, when an operation's domain doesn't contain the
         empty set. $)
      ndmoprrcl $p |- ( ( A F B ) e. S -> ( A e. S /\ B e. S ) ) $=
        cA cS wcel cB cS wcel wa cA cB cF co cS wcel cA cS wcel cB cS wcel wa
        wn cA cB cF co cS wcel c0 cS wcel ndmoprrcl.3 cA cS wcel cB cS wcel wa
        wn cA cB cF co c0 cS cA cB cS cF ndmopr.1 ndmopr.2 ndmopr eleq1d mtbiri
        con4i $.
        $( [3-Feb-1996] $)
    $}

    ${
      ndmopr.3 $e |- A e. _V $.
      $( Any operation is commutative outside its domain. $)
      ndmoprcom $p |- ( -. ( A e. S /\ B e. S ) -> ( A F B ) = ( B F A ) ) $=
        cA cS wcel cB cS wcel wa wn cA cB cF co c0 cB cA cF co cA cB cS cF
        ndmopr.1 ndmopr.2 ndmopr cA cS wcel cB cS wcel wa wn cB cS wcel cA cS
        wcel wa wn cB cA cF co c0 wceq cA cS wcel cB cS wcel wa cB cS wcel cA
        cS wcel wa cA cS wcel cB cS wcel ancom notbii cB cA cS cF ndmopr.3
        ndmopr.2 ndmopr sylbi eqtr4d $.
        $( [24-Aug-1995] $)
    $}

    ${
      ndmopr.4 $e |- C e. _V $.
      ndmopr.5 $e |- -. (/) e. S $.
      $( Any operation is associative outside its domain, if the domain
         doesn't contain the empty set. $)
      ndmoprass $p |- ( -. ( A e. S /\ B e. S /\ C e. S ) ->
              ( ( A F B ) F C ) = ( A F ( B F C ) ) ) $=
        cA cS wcel cB cS wcel cC cS wcel w3a wn cA cB cF co cC cF co c0 cA cB
        cC cF co cF co cA cS wcel cB cS wcel cC cS wcel w3a wn cA cB cF co cS
        wcel cC cS wcel wa wn cA cB cF co cC cF co c0 wceq cA cB cF co cS wcel
        cC cS wcel wa cA cS wcel cB cS wcel cC cS wcel w3a cA cB cF co cS wcel
        cC cS wcel wa cA cS wcel cB cS wcel wa cC cS wcel wa cA cS wcel cB cS
        wcel cC cS wcel w3a cA cB cF co cS wcel cA cS wcel cB cS wcel wa cC cS
        wcel cA cB cS cF ndmopr.1 ndmopr.2 ndmopr.5 ndmoprrcl anim1i cA cS wcel
        cB cS wcel cC cS wcel df-3an sylibr con3i cA cB cF co cC cS cF ndmopr.4
        ndmopr.2 ndmopr syl cA cS wcel cB cS wcel cC cS wcel w3a wn cA cS wcel
        cB cC cF co cS wcel wa wn cA cB cC cF co cF co c0 wceq cA cS wcel cB cC
        cF co cS wcel wa cA cS wcel cB cS wcel cC cS wcel w3a cA cS wcel cB cC
        cF co cS wcel wa cA cS wcel cB cS wcel cC cS wcel wa wa cA cS wcel cB
        cS wcel cC cS wcel w3a cB cC cF co cS wcel cB cS wcel cC cS wcel wa cA
        cS wcel cB cC cS cF ndmopr.4 ndmopr.2 ndmopr.5 ndmoprrcl anim2i cA cS
        wcel cB cS wcel cC cS wcel 3anass sylibr con3i cA cB cC cF co cS cF cB
        cC cF oprex ndmopr.2 ndmopr syl eqtr4d $.
        $( [24-Aug-1995] $)

      ${
        ndmopr.6 $e |- dom G = ( S X. S ) $.
        $( Any operation is distributive outside its domain, if the domain
           doesn't contain the empty set. $)
        ndmoprdistr $p |- ( -. ( A e. S /\ B e. S /\ C e. S ) ->
            ( A G ( B F C ) ) = ( ( A G B ) F ( A G C ) ) ) $=
          cA cS wcel cB cS wcel cC cS wcel w3a wn cA cB cC cF co cG co c0 cA cB
          cG co cA cC cG co cF co cA cS wcel cB cS wcel cC cS wcel w3a wn cA cS
          wcel cB cC cF co cS wcel wa wn cA cB cC cF co cG co c0 wceq cA cS
          wcel cB cC cF co cS wcel wa cA cS wcel cB cS wcel cC cS wcel w3a cA
          cS wcel cB cC cF co cS wcel wa cA cS wcel cB cS wcel cC cS wcel wa wa
          cA cS wcel cB cS wcel cC cS wcel w3a cB cC cF co cS wcel cB cS wcel
          cC cS wcel wa cA cS wcel cB cC cS cF ndmopr.4 ndmopr.2 ndmopr.5
          ndmoprrcl anim2i cA cS wcel cB cS wcel cC cS wcel 3anass sylibr con3i
          cA cB cC cF co cS cG cB cC cF oprex ndmopr.6 ndmopr syl cA cS wcel cB
          cS wcel cC cS wcel w3a wn cA cB cG co cS wcel cA cC cG co cS wcel wa
          wn cA cB cG co cA cC cG co cF co c0 wceq cA cB cG co cS wcel cA cC cG
          co cS wcel wa cA cS wcel cB cS wcel cC cS wcel w3a cA cB cG co cS
          wcel cA cC cG co cS wcel wa cA cS wcel cB cS wcel wa cA cS wcel cC cS
          wcel wa wa cA cS wcel cB cS wcel cC cS wcel w3a cA cB cG co cS wcel
          cA cS wcel cB cS wcel wa cA cC cG co cS wcel cA cS wcel cC cS wcel wa
          cA cB cS cG ndmopr.1 ndmopr.6 ndmopr.5 ndmoprrcl cA cC cS cG ndmopr.4
          ndmopr.6 ndmopr.5 ndmoprrcl anim12i cA cS wcel cB cS wcel cC cS wcel
          w3a cA cS wcel cB cS wcel cC cS wcel wa wa cA cS wcel cB cS wcel wa
          cA cS wcel cC cS wcel wa wa cA cS wcel cB cS wcel cC cS wcel 3anass
          cA cS wcel cB cS wcel cC cS wcel anandi bitri sylibr con3i cA cB cG
          co cA cC cG co cS cF cA cC cG oprex ndmopr.2 ndmopr syl eqtr4d $.
          $( [24-Aug-1995] $)
      $}
    $}

    ${
      ndmord.3 $e |- A e. _V $.
      ndmord.4 $e |- R C_ ( S X. S ) $.
      ndmord.5 $e |- -. (/) e. S $.
      ndmord.6 $e |- ( ( A e. S /\ B e. S /\ C e. S ) ->
                     ( A R B <-> ( C F A ) R ( C F B ) ) ) $.
        $( Elimination of redundant antecedents in an ordering law. $)
      ndmord $p |- ( C e. S -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $=
        cA cS wcel cB cS wcel wa cC cS wcel cA cB cR wbr cC cA cF co cC cB cF
        co cR wbr wb wi cA cS wcel cB cS wcel cC cS wcel cA cB cR wbr cC cA cF
        co cC cB cF co cR wbr wb ndmord.6 3expia cA cS wcel cB cS wcel wa wn cA
        cB cR wbr cC cA cF co cC cB cF co cR wbr wb cC cS wcel cA cB cR wbr cA
        cS wcel cB cS wcel wa cC cA cF co cC cB cF co cR wbr cA cB cS cS cR
        ndmopr.1 ndmord.4 brel cC cA cF co cC cB cF co cR wbr cC cA cF co cS
        wcel cC cB cF co cS wcel wa cA cS wcel cB cS wcel wa cC cA cF co cC cB
        cF co cS cS cR cC cB cF oprex ndmord.4 brel cC cA cF co cS wcel cA cS
        wcel cC cB cF co cS wcel cB cS wcel cC cA cF co cS wcel cC cS wcel cA
        cS wcel cC cA cS cF ndmord.3 ndmopr.2 ndmord.5 ndmoprrcl pm3.27d cC cB
        cF co cS wcel cC cS wcel cB cS wcel cC cB cS cF ndmopr.1 ndmopr.2
        ndmord.5 ndmoprrcl pm3.27d anim12i syl pm5.21ni a1d pm2.61i $.
        $( [7-Mar-1996] $)
    $}
  $}

  ${
    ndmordi.3 $e |- A e. _V $.
    ndmordi.2 $e |- dom F = ( S X. S ) $.
    ndmordi.4 $e |- R C_ ( S X. S ) $.
    ndmordi.5 $e |- -. (/) e. S $.
    ndmordi.6 $e |- ( C e. S -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $.
    $( Elimination of redundant antecedent in an ordering law. $)
    ndmordi $p |- ( ( C F A ) R ( C F B ) -> A R B ) $=
      cC cS wcel cC cA cF co cC cB cF co cR wbr cA cB cR wbr cC cA cF co cC cB
      cF co cR wbr cC cA cF co cS wcel cC cS wcel cC cA cF co cC cB cF co cR
      wbr cC cA cF co cS wcel cC cB cF co cS wcel cC cA cF co cC cB cF co cS cS
      cR cC cB cF oprex ndmordi.4 brel pm3.26d cC cA cF co cS wcel cC cS wcel
      cA cS wcel cC cA cS cF ndmordi.3 ndmordi.2 ndmordi.5 ndmoprrcl pm3.26d
      syl cC cS wcel cA cB cR wbr cC cA cF co cC cB cF co cR wbr ndmordi.6
      biimprd mpcom $.
      $( [25-Jun-1998] $)
  $}

  ${
    $d w z A $.  $d w B $.  $d w x y z F $.  $d w x y z S $.
    caoprcl.1 $e |- ( ( x e. S /\ y e. S ) -> ( x F y ) e. S ) $.
    $( Convert an operation closure law to class notation. $)
    caoprcl $p |- ( ( A e. S /\ B e. S ) -> ( A F B ) e. S ) $=
      vz cv vw cv cF co cS wcel cA vw cv cF co cS wcel cA cB cF co cS wcel vz
      vw cA cB cS cS vz cv cA wceq vz cv vw cv cF co cA vw cv cF co cS vz cv cA
      vw cv cF opreq1 eleq1d vw cv cB wceq cA vw cv cF co cA cB cF co cS vw cv
      cB cA cF opreq2 eleq1d vx cv vy cv cF co cS wcel vz cv vy cv cF co cS
      wcel vz cv vw cv cF co cS wcel vx vy vz cv vw cv cS cS vx cv vz cv wceq
      vx cv vy cv cF co vz cv vy cv cF co cS vx cv vz cv vy cv cF opreq1 eleq1d
      vy cv vw cv wceq vz cv vy cv cF co vz cv vw cv cF co cS vy cv vw cv vz cv
      cF opreq2 eleq1d caoprcl.1 vtocl2ga vtocl2ga $.
      $( [4-Aug-1995] $)
  $}

  ${
    $( General laws for commutative, associative, distributive operations. $)
    $d x y z F $.  $d x y z S $.  $d x y z A $.  $d x y z B $.  $d x y z C $.
    $d x y z D $.  $d x y z G $.  $d x y z R $.
    ${
      caoprcom.1 $e |- A e. _V $.
      caoprcom.2 $e |- B e. _V $.
      caoprcom.3 $e |- ( x F y ) = ( y F x ) $.
      $( Convert an operation commutative law to class notation. $)
      caoprcom $p |- ( A F B ) = ( B F A ) $=
        vx cv vy cv cF co vy cv vx cv cF co wceq cA cB cF co cB cA cF co wceq
        vx vy cA cB caoprcom.1 caoprcom.2 vx cv cA wceq vx cv vy cv cF co vy cv
        vx cv cF co wceq cA vy cv cF co vy cv cA cF co wceq vy cv cB wceq cA cB
        cF co cB cA cF co wceq vx cv cA wceq vx cv vy cv cF co cA vy cv cF co
        vy cv vx cv cF co vy cv cA cF co vx cv cA vy cv cF opreq1 vx cv cA vy
        cv cF opreq2 eqeq12d vy cv cB wceq cA vy cv cF co cA cB cF co vy cv cA
        cF co cB cA cF co vy cv cB cA cF opreq2 vy cv cB cA cF opreq1 eqeq12d
        sylan9bb caoprcom.3 vtocl2 $.
        $( [26-Aug-1995] $)
    $}

    ${
      caoprass.1 $e |- A e. _V $.
      caoprass.2 $e |- B e. _V $.
      caoprass.3 $e |- C e. _V $.
      caoprass.4 $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
      $( Convert an operation associative law to class notation. $)
      caoprass $p |- ( ( A F B ) F C ) = ( A F ( B F C ) ) $=
        vx cv vy cv cF co vz cv cF co vx cv vy cv vz cv cF co cF co wceq cA cB
        cF co cC cF co cA cB cC cF co cF co wceq vx vy vz cA cB cC caoprass.1
        caoprass.2 caoprass.3 vx cv cA wceq vx cv vy cv cF co vz cv cF co vx cv
        vy cv vz cv cF co cF co wceq cA vy cv cF co vz cv cF co cA vy cv vz cv
        cF co cF co wceq vy cv cB wceq cA cB cF co vz cv cF co cA cB vz cv cF
        co cF co wceq vz cv cC wceq cA cB cF co cC cF co cA cB cC cF co cF co
        wceq vx cv cA wceq vx cv vy cv cF co vz cv cF co cA vy cv cF co vz cv
        cF co vx cv vy cv vz cv cF co cF co cA vy cv vz cv cF co cF co vx cv cA
        wceq vx cv vy cv cF co cA vy cv cF co vz cv cF vx cv cA vy cv cF opreq1
        opreq1d vx cv cA vy cv vz cv cF co cF opreq1 eqeq12d vy cv cB wceq cA
        vy cv cF co vz cv cF co cA cB cF co vz cv cF co cA vy cv vz cv cF co cF
        co cA cB vz cv cF co cF co vy cv cB wceq cA vy cv cF co cA cB cF co vz
        cv cF vy cv cB cA cF opreq2 opreq1d vy cv cB wceq vy cv vz cv cF co cB
        vz cv cF co cA cF vy cv cB vz cv cF opreq1 opreq2d eqeq12d vz cv cC
        wceq cA cB cF co vz cv cF co cA cB cF co cC cF co cA cB vz cv cF co cF
        co cA cB cC cF co cF co vz cv cC cA cB cF co cF opreq2 vz cv cC wceq cB
        vz cv cF co cB cC cF co cA cF vz cv cC cB cF opreq2 opreq2d eqeq12d
        syl3an9b caoprass.4 vtocl3 $.
        $( [26-Aug-1995] $)
    $}

    ${
      caoprcan.1 $e |- C e. _V $.
      caoprcan.2 $e |- ( ( x e. S /\ y e. S ) ->
                   ( ( x F y ) = ( x F z ) -> y = z ) ) $.
      $( Convert an operation cancellation law to class notation. $)
      caoprcan $p |- ( ( A e. S /\ B e. S ) ->
                   ( ( A F B ) = ( A F C ) -> B = C ) ) $=
        vx cv vy cv cF co vx cv cC cF co wceq vy cv cC wceq wi cA vy cv cF co
        cA cC cF co wceq vy cv cC wceq wi cA cB cF co cA cC cF co wceq cB cC
        wceq wi vx vy cA cB cS cS vx cv cA wceq vx cv vy cv cF co vx cv cC cF
        co wceq cA vy cv cF co cA cC cF co wceq vy cv cC wceq vx cv cA wceq vx
        cv vy cv cF co cA vy cv cF co vx cv cC cF co cA cC cF co vx cv cA vy cv
        cF opreq1 vx cv cA cC cF opreq1 eqeq12d imbi1d vy cv cB wceq cA vy cv
        cF co cA cC cF co wceq cA cB cF co cA cC cF co wceq vy cv cC wceq cB cC
        wceq vy cv cB wceq cA vy cv cF co cA cB cF co cA cC cF co vy cv cB cA
        cF opreq2 eqeq1d vy cv cB cC eqeq1 imbi12d vx cv cS wcel vy cv cS wcel
        wa vx cv vy cv cF co vx cv vz cv cF co wceq vy cv vz cv wceq wi wi vx
        cv cS wcel vy cv cS wcel wa vx cv vy cv cF co vx cv cC cF co wceq vy cv
        cC wceq wi wi vz cC caoprcan.1 vz cv cC wceq vx cv vy cv cF co vx cv vz
        cv cF co wceq vy cv vz cv wceq wi vx cv vy cv cF co vx cv cC cF co wceq
        vy cv cC wceq wi vx cv cS wcel vy cv cS wcel wa vz cv cC wceq vx cv vy
        cv cF co vx cv vz cv cF co wceq vx cv vy cv cF co vx cv cC cF co wceq
        vy cv vz cv wceq vy cv cC wceq vz cv cC wceq vx cv vz cv cF co vx cv cC
        cF co vx cv vy cv cF co vz cv cC vx cv cF opreq2 eqeq2d vz cv cC vy cv
        eqeq2 imbi12d imbi2d caoprcan.2 vtocl vtocl2ga $.
        $( [20-Aug-1995] $)
    $}

    ${
      caoprord.1 $e |- A e. _V $.
      caoprord.2 $e |- B e. _V $.
      caoprord.3 $e |- ( z e. S -> ( x R y <-> ( z F x ) R ( z F y ) ) ) $.
      $( Convert an operation ordering law to class notation. $)
      caoprord $p |- ( C e. S -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $=
        cA cB cR wbr vz cv cA cF co vz cv cB cF co cR wbr wb cA cB cR wbr cC cA
        cF co cC cB cF co cR wbr wb vz cC cS vz cv cC wceq vz cv cA cF co vz cv
        cB cF co cR wbr cC cA cF co cC cB cF co cR wbr cA cB cR wbr vz cv cC
        wceq vz cv cA cF co cC cA cF co vz cv cB cF co cC cB cF co cR vz cv cC
        cA cF opreq1 vz cv cC cB cF opreq1 breq12d bibi2d vz cv cS wcel vx cv
        vy cv cR wbr vz cv vx cv cF co vz cv vy cv cF co cR wbr wb wi vz cv cS
        wcel cA cB cR wbr vz cv cA cF co vz cv cB cF co cR wbr wb wi vx vy cA
        cB caoprord.1 caoprord.2 vx cv cA wceq vy cv cB wceq wa vx cv vy cv cR
        wbr vz cv vx cv cF co vz cv vy cv cF co cR wbr wb cA cB cR wbr vz cv cA
        cF co vz cv cB cF co cR wbr wb vz cv cS wcel vx cv cA wceq vx cv vy cv
        cR wbr vz cv vx cv cF co vz cv vy cv cF co cR wbr wb cA vy cv cR wbr vz
        cv cA cF co vz cv vy cv cF co cR wbr wb vy cv cB wceq cA cB cR wbr vz
        cv cA cF co vz cv cB cF co cR wbr wb vx cv cA wceq vx cv vy cv cR wbr
        cA vy cv cR wbr vz cv vx cv cF co vz cv vy cv cF co cR wbr vz cv cA cF
        co vz cv vy cv cF co cR wbr vx cv cA vy cv cR breq1 vx cv cA wceq vz cv
        vx cv cF co vz cv cA cF co vz cv vy cv cF co cR vx cv cA vz cv cF
        opreq2 breq1d bibi12d vy cv cB wceq cA vy cv cR wbr cA cB cR wbr vz cv
        cA cF co vz cv vy cv cF co cR wbr vz cv cA cF co vz cv cB cF co cR wbr
        vy cv cB cA cR breq2 vy cv cB wceq vz cv vy cv cF co vz cv cB cF co vz
        cv cA cF co cR vy cv cB vz cv cF opreq2 breq2d bibi12d sylan9bb imbi2d
        caoprord.3 vtocl2 vtoclga $.
        $( [19-Feb-1996] $)

      ${
        $( (We don't bother to eliminate this redundant hypothesis.) $)
        caoprord2.3 $e |- C e. _V $.
        caoprord2.com $e |- ( x F y ) = ( y F x ) $.
        $( Operation ordering law with commuted arguments. $)
        caoprord2 $p |- ( C e. S -> ( A R B <-> ( A F C ) R ( B F C ) ) ) $=
          cC cS wcel cA cB cR wbr cC cA cF co cC cB cF co cR wbr cA cC cF co cB
          cC cF co cR wbr vx vy vz cA cB cC cR cS cF caoprord.1 caoprord.2
          caoprord.3 caoprord cC cA cF co cA cC cF co cC cB cF co cB cC cF co
          cR vx vy cC cA cF caoprord2.3 caoprord.1 caoprord2.com caoprcom vx vy
          cC cB cF caoprord2.3 caoprord.2 caoprord2.com caoprcom breq12i syl6bb
          $.
          $( [27-Feb-1996] $)


        ${
          $( (We don't bother to eliminate redundant hypotheses.) $)
          caoprord3.4 $e |- D e. _V $.
          $( Ordering law. $)
          caoprord3 $p |- ( ( ( B e. S /\ C e. S ) /\
                    ( A F B ) = ( C F D ) ) -> ( A R C <-> D R B ) ) $=
            cB cS wcel cC cS wcel wa cA cB cF co cC cD cF co wceq wa cA cC cR
            wbr cC cD cF co cC cB cF co cR wbr cD cB cR wbr cB cS wcel cC cS
            wcel wa cA cC cR wbr cA cB cF co cC cB cF co cR wbr cA cB cF co cC
            cD cF co wceq cC cD cF co cC cB cF co cR wbr cB cS wcel cA cC cR
            wbr cA cB cF co cC cB cF co cR wbr wb cC cS wcel vx vy vz cA cC cB
            cR cS cF caoprord.1 caoprord2.3 caoprord.3 caoprord.2 caoprord2.com
            caoprord2 adantr cA cB cF co cC cD cF co cC cB cF co cR breq1
            sylan9bb cC cS wcel cD cB cR wbr cC cD cF co cC cB cF co cR wbr wb
            cB cS wcel cA cB cF co cC cD cF co wceq vx vy vz cD cB cC cR cS cF
            caoprord3.4 caoprord.2 caoprord.3 caoprord ad2antlr bitr4d $.
            $( [29-Feb-1996] $)
        $}
      $}

    $}


    ${
      caoprdistr.1 $e |- A e. _V $.
      caoprdistr.2 $e |- B e. _V $.
      caoprdistr.3 $e |- C e. _V $.
      caoprdistr.4 $e |- ( x G ( y F z ) ) = ( ( x G y ) F ( x G z ) ) $.
      $( Convert an operation distributive law to class notation. $)
      caoprdistr $p |- ( A G ( B F C ) ) = ( ( A G B ) F ( A G C ) ) $=
        vx cv vy cv vz cv cF co cG co vx cv vy cv cG co vx cv vz cv cG co cF co
        wceq cA cB cC cF co cG co cA cB cG co cA cC cG co cF co wceq vx vy vz
        cA cB cC caoprdistr.1 caoprdistr.2 caoprdistr.3 vx cv cA wceq vx cv vy
        cv vz cv cF co cG co vx cv vy cv cG co vx cv vz cv cG co cF co wceq cA
        vy cv vz cv cF co cG co cA vy cv cG co cA vz cv cG co cF co wceq vy cv
        cB wceq cA cB vz cv cF co cG co cA cB cG co cA vz cv cG co cF co wceq
        vz cv cC wceq cA cB cC cF co cG co cA cB cG co cA cC cG co cF co wceq
        vx cv cA wceq vx cv vy cv vz cv cF co cG co cA vy cv vz cv cF co cG co
        vx cv vy cv cG co vx cv vz cv cG co cF co cA vy cv cG co cA vz cv cG co
        cF co vx cv cA vy cv vz cv cF co cG opreq1 vx cv cA wceq vx cv vy cv cG
        co cA vy cv cG co vx cv vz cv cG co cA vz cv cG co cF vx cv cA vy cv cG
        opreq1 vx cv cA vz cv cG opreq1 opreq12d eqeq12d vy cv cB wceq cA vy cv
        vz cv cF co cG co cA cB vz cv cF co cG co cA vy cv cG co cA vz cv cG co
        cF co cA cB cG co cA vz cv cG co cF co vy cv cB wceq vy cv vz cv cF co
        cB vz cv cF co cA cG vy cv cB vz cv cF opreq1 opreq2d vy cv cB wceq cA
        vy cv cG co cA cB cG co cA vz cv cG co cF vy cv cB cA cG opreq2 opreq1d
        eqeq12d vz cv cC wceq cA cB vz cv cF co cG co cA cB cC cF co cG co cA
        cB cG co cA vz cv cG co cF co cA cB cG co cA cC cG co cF co vz cv cC
        wceq cB vz cv cF co cB cC cF co cA cG vz cv cC cB cF opreq2 opreq2d vz
        cv cC wceq cA vz cv cG co cA cC cG co cA cB cG co cF vz cv cC cA cG
        opreq2 opreq2d eqeq12d syl3an9b caoprdistr.4 vtocl3 $.
        $( [25-Aug-1995] $)
    $}

    ${
      caopr.1 $e |- A e. _V $.
      caopr.2 $e |- B e. _V $.
      caopr.3 $e |- C e. _V $.
      caopr.com $e |- ( x F y ) = ( y F x ) $.
      caopr.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.

      $( Rearrange arguments in a commutative, associative operation. $)
      caopr32 $p |- ( ( A F B ) F C ) = ( ( A F C ) F B ) $=
        cA cB cC cF co cF co cA cC cB cF co cF co cA cB cF co cC cF co cA cC cF
        co cB cF co cB cC cF co cC cB cF co cA cF vx vy cB cC cF caopr.2
        caopr.3 caopr.com caoprcom opreq2i vx vy vz cA cB cC cF caopr.1 caopr.2
        caopr.3 caopr.ass caoprass vx vy vz cA cC cB cF caopr.1 caopr.3 caopr.2
        caopr.ass caoprass 3eqtr4i $.
        $( [26-Aug-1995] $)

      $( Rearrange arguments in a commutative, associative operation. $)
      caopr12 $p |- ( A F ( B F C ) ) = ( B F ( A F C ) ) $=
        cA cB cF co cC cF co cB cA cF co cC cF co cA cB cC cF co cF co cB cA cC
        cF co cF co cA cB cF co cB cA cF co cC cF vx vy cA cB cF caopr.1
        caopr.2 caopr.com caoprcom opreq1i vx vy vz cA cB cC cF caopr.1 caopr.2
        caopr.3 caopr.ass caoprass vx vy vz cB cA cC cF caopr.2 caopr.1 caopr.3
        caopr.ass caoprass 3eqtr3i $.
        $( [26-Aug-1995] $)

      $( Rearrange arguments in a commutative, associative operation. $)
      caopr31 $p |- ( ( A F B ) F C ) = ( ( C F B ) F A ) $=
        cA cC cF co cB cF co cC cA cB cF co cF co cA cB cF co cC cF co cC cB cF
        co cA cF co cA cC cF co cB cF co cA cC cB cF co cF co cC cA cB cF co cF
        co vx vy vz cA cC cB cF caopr.1 caopr.3 caopr.2 caopr.ass caoprass vx
        vy vz cA cC cB cF caopr.1 caopr.3 caopr.2 caopr.com caopr.ass caopr12
        eqtri vx vy vz cA cB cC cF caopr.1 caopr.2 caopr.3 caopr.com caopr.ass
        caopr32 cC cA cF co cB cF co cC cB cF co cA cF co cC cA cB cF co cF co
        vx vy vz cC cA cB cF caopr.3 caopr.1 caopr.2 caopr.com caopr.ass
        caopr32 vx vy vz cC cA cB cF caopr.3 caopr.1 caopr.2 caopr.ass caoprass
        eqtr3i 3eqtr4i $.
        $( [26-Aug-1995] $)

      $( Rearrange arguments in a commutative, associative operation. $)
      caopr13 $p |- ( A F ( B F C ) ) = ( C F ( B F A ) ) $=
        cA cB cF co cC cF co cC cB cF co cA cF co cA cB cC cF co cF co cC cB cA
        cF co cF co vx vy vz cA cB cC cF caopr.1 caopr.2 caopr.3 caopr.com
        caopr.ass caopr31 vx vy vz cA cB cC cF caopr.1 caopr.2 caopr.3
        caopr.ass caoprass vx vy vz cC cB cA cF caopr.3 caopr.2 caopr.1
        caopr.ass caoprass 3eqtr3i $.
        $( [26-Aug-1995] $)

      ${
        caopr.4 $e |- D e. _V $.

        $( Rearrange arguments in a commutative, associative operation. $)
        caopr4 $p |- ( ( A F B ) F ( C F D ) ) = ( ( A F C ) F ( B F D ) ) $=
          cA cB cC cD cF co cF co cF co cA cC cB cD cF co cF co cF co cA cB cF
          co cC cD cF co cF co cA cC cF co cB cD cF co cF co cB cC cD cF co cF
          co cC cB cD cF co cF co cA cF vx vy vz cB cC cD cF caopr.2 caopr.3
          caopr.4 caopr.com caopr.ass caopr12 opreq2i vx vy vz cA cB cC cD cF
          co cF caopr.1 caopr.2 cC cD cF oprex caopr.ass caoprass vx vy vz cA
          cC cB cD cF co cF caopr.1 caopr.3 cB cD cF oprex caopr.ass caoprass
          3eqtr4i $.
          $( [26-Aug-1995] $)

        $( Rearrange arguments in a commutative, associative operation. $)
        caopr411 $p |- ( ( A F B ) F ( C F D ) ) = ( ( C F B ) F ( A F D ) ) $=
          cA cB cF co cC cF co cD cF co cC cB cF co cA cF co cD cF co cA cB cF
          co cC cD cF co cF co cC cB cF co cA cD cF co cF co cA cB cF co cC cF
          co cC cB cF co cA cF co cD cF vx vy vz cA cB cC cF caopr.1 caopr.2
          caopr.3 caopr.com caopr.ass caopr31 opreq1i vx vy vz cA cB cF co cC
          cD cF cA cB cF oprex caopr.3 caopr.4 caopr.ass caoprass vx vy vz cC
          cB cF co cA cD cF cC cB cF oprex caopr.1 caopr.4 caopr.ass caoprass
          3eqtr3i $.
          $( [26-Aug-1995] $)

        $( Rearrange arguments in a commutative, associative operation. $)
        caopr42 $p |- ( ( A F B ) F ( C F D ) ) =
                        ( ( A F C ) F ( D F B ) ) $=
          cA cB cF co cC cD cF co cF co cA cC cF co cB cD cF co cF co cA cC cF
          co cD cB cF co cF co vx vy vz cA cB cC cD cF caopr.1 caopr.2 caopr.3
          caopr.com caopr.ass caopr.4 caopr4 cB cD cF co cD cB cF co cA cC cF
          co cF vx vy cB cD cF caopr.2 caopr.4 caopr.com caoprcom opreq2i eqtri
          $.
          $( [26-Aug-1995] $)
      $}
    $}

    ${
      caoprd.1 $e |- A e. _V $.
      caoprd.2 $e |- B e. _V $.
      caoprd.3 $e |- C e. _V $.
      caoprd.com $e |- ( x G y ) = ( y G x ) $.
      caoprd.distr $e |- ( x G ( y F z ) ) = ( ( x G y ) F ( x G z ) ) $.
      $( Reverse distributive law. $)
      caoprdistrr $p |- ( ( A F B ) G C ) = ( ( A G C ) F ( B G C ) ) $=
        cC cA cB cF co cG co cC cA cG co cC cB cG co cF co cA cB cF co cC cG co
        cA cC cG co cB cC cG co cF co vx vy vz cC cA cB cF cG caoprd.3 caoprd.1
        caoprd.2 caoprd.distr caoprdistr vx vy cC cA cB cF co cG caoprd.3 cA cB
        cF oprex caoprd.com caoprcom cC cA cG co cA cC cG co cC cB cG co cB cC
        cG co cF vx vy cC cA cG caoprd.3 caoprd.1 caoprd.com caoprcom vx vy cC
        cB cG caoprd.3 caoprd.2 caoprd.com caoprcom opreq12i 3eqtr3i $.
        $( [26-Aug-1995] $)

      ${
        $d x y z H $.  $d x y z R $.
        caoprdl.4 $e |- D e. _V $.
        caoprdl.5 $e |- H e. _V $.
        caoprdl.ass $e |- ( ( x G y ) G z ) = ( x G ( y G z ) ) $.
        $( Lemma used by real number construction. $)
        caoprdilem $p |- ( ( ( A G C ) F ( B G D ) ) G H ) =
                         ( ( A G ( C G H ) ) F ( B G ( D G H ) ) ) $=
          cA cC cG co cB cD cG co cF co cH cG co cA cC cG co cH cG co cB cD cG
          co cH cG co cF co cA cC cH cG co cG co cB cD cH cG co cG co cF co vx
          vy vz cA cC cG co cB cD cG co cH cF cG cA cC cG oprex cB cD cG oprex
          caoprdl.5 caoprd.com caoprd.distr caoprdistrr cA cC cG co cH cG co cA
          cC cH cG co cG co cB cD cG co cH cG co cB cD cH cG co cG co cF vx vy
          vz cA cC cH cG caoprd.1 caoprd.3 caoprdl.5 caoprdl.ass caoprass vx vy
          vz cB cD cH cG caoprd.2 caoprdl.4 caoprdl.5 caoprdl.ass caoprass
          opreq12i eqtri $.
          $( [26-Aug-1995] $)

        ${
          caoprdl2.6 $e |- R e. _V $.
          caoprdl2.com $e |- ( x F y ) = ( y F x ) $.
          caoprdl2.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
          $( Lemma used in real number construction. $)
          caoprlem2 $p |- ( ( ( ( A G C ) F ( B G D ) ) G H ) F
                            ( ( ( A G D ) F ( B G C ) ) G R ) ) =
   ( ( A G ( ( C G H ) F ( D G R ) ) ) F ( B G ( ( C G R ) F ( D G H ) ) ) ) $=
            cA cC cH cG co cG co cB cD cH cG co cG co cF co cA cD cR cG co cG
            co cB cC cR cG co cG co cF co cF co cA cC cH cG co cG co cA cD cR
            cG co cG co cF co cB cC cR cG co cG co cB cD cH cG co cG co cF co
            cF co cA cC cG co cB cD cG co cF co cH cG co cA cD cG co cB cC cG
            co cF co cR cG co cF co cA cC cH cG co cD cR cG co cF co cG co cB
            cC cR cG co cD cH cG co cF co cG co cF co vx vy vz cA cC cH cG co
            cG co cB cD cH cG co cG co cA cD cR cG co cG co cB cC cR cG co cG
            co cF cA cC cH cG co cG oprex cB cD cH cG co cG oprex cA cD cR cG
            co cG oprex caoprdl2.com caoprdl2.ass cB cC cR cG co cG oprex
            caopr42 cA cC cG co cB cD cG co cF co cH cG co cA cC cH cG co cG co
            cB cD cH cG co cG co cF co cA cD cG co cB cC cG co cF co cR cG co
            cA cD cR cG co cG co cB cC cR cG co cG co cF co cF vx vy vz cA cB
            cC cD cF cG cH caoprd.1 caoprd.2 caoprd.3 caoprd.com caoprd.distr
            caoprdl.4 caoprdl.5 caoprdl.ass caoprdilem vx vy vz cA cB cD cC cF
            cG cR caoprd.1 caoprd.2 caoprdl.4 caoprd.com caoprd.distr caoprd.3
            caoprdl2.6 caoprdl.ass caoprdilem opreq12i cA cC cH cG co cD cR cG
            co cF co cG co cA cC cH cG co cG co cA cD cR cG co cG co cF co cB
            cC cR cG co cD cH cG co cF co cG co cB cC cR cG co cG co cB cD cH
            cG co cG co cF co cF vx vy vz cA cC cH cG co cD cR cG co cF cG
            caoprd.1 cC cH cG oprex cD cR cG oprex caoprd.distr caoprdistr vx
            vy vz cB cC cR cG co cD cH cG co cF cG caoprd.2 cC cR cG oprex cD
            cH cG oprex caoprd.distr caoprdistr opreq12i 3eqtr4i $.
            $( [26-Aug-1995] $)
        $}
      $}
    $}

    ${
      $d x y z w v $.
      $d w v S $.  $d w v A $.  $d w v B $.  $d w v F $.
      caoprmo.1 $e |- A e. _V $.
      $( Identity element. $)
      caoprmo.2 $e |- B e. S $.
      caoprmo.dom $e |- dom F = ( S X. S ) $.
      caoprmo.3 $e |- -. (/) e. S $.
      caoprmo.com $e |- ( x F y ) = ( y F x ) $.
      caoprmo.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
      caoprmo.id $e |- ( x e. S -> ( x F B ) = x ) $.
      $( Uniqueness of inverse element in commutative, associative operation
         with identity.  Remark in proof of Proposition 9-2.4 of [Gleason]
         p. 119. $)
      caoprmo $p |- E* w ( A F w ) = B $=
        vw cv cS wcel cA vw cv cF co cB wceq wa vw wmo cA vw cv cF co cB wceq
        vw wmo vw cv cS wcel cA vw cv cF co cB wceq wa vw wmo vw cv cS wcel cA
        vw cv cF co cB wceq wa vv cv cS wcel cA vv cv cF co cB wceq wa wa vw cv
        vv cv wceq wi vv wal vw vw cv cS wcel cA vw cv cF co cB wceq wa vv cv
        cS wcel cA vv cv cF co cB wceq wa vw vv vw cv vv cv wceq vw cv cS wcel
        vv cv cS wcel cA vw cv cF co cB wceq cA vv cv cF co cB wceq vw cv vv cv
        cS eleq1 vw cv vv cv wceq cA vw cv cF co cA vv cv cF co cB vw cv vv cv
        cA cF opreq2 eqeq1d anbi12d mo4 vw cv cS wcel cA vw cv cF co cB wceq wa
        vv cv cS wcel cA vv cv cF co cB wceq wa wa vw cv vv cv wceq wi vv vw cv
        cS wcel cA vw cv cF co cB wceq wa vv cv cS wcel cA vv cv cF co cB wceq
        wa wa cA vw cv cF co vv cv cF co vw cv vv cv vw cv cS wcel cA vv cv cF
        co cB wceq cA vw cv cF co vv cv cF co vw cv wceq cA vw cv cF co cB wceq
        vv cv cS wcel vw cv cS wcel cA vv cv cF co cB wceq wa vw cv cA vv cv cF
        co cF co vw cv cA vw cv cF co vv cv cF co cA vv cv cF co cB wceq vw cv
        cS wcel vw cv cA vv cv cF co cF co vw cv cB cF co vw cv cA vv cv cF co
        cB vw cv cF opreq2 vx cv cB cF co vx cv wceq vw cv cB cF co vw cv wceq
        vx vw cv cS vx cv vw cv wceq vx cv cB cF co vw cv cB cF co vx cv vw cv
        vx cv vw cv cB cF opreq1 vx cv vw cv wceq id eqeq12d caoprmo.id vtoclga
        sylan9eqr cA vw cv cF co vv cv cF co cA vw cv vv cv cF co cF co vw cv
        cA vv cv cF co cF co vx vy vz cA vw cv vv cv cF caoprmo.1 vw visset vv
        visset caoprmo.ass caoprass vx vy vz cA vw cv vv cv cF caoprmo.1 vw
        visset vv visset caoprmo.com caoprmo.ass caopr12 eqtri syl5eq ad2ant2rl
        cA vw cv cF co cB wceq vv cv cS wcel cA vw cv cF co vv cv cF co vv cv
        wceq vw cv cS wcel cA vv cv cF co cB wceq cA vw cv cF co cB wceq vv cv
        cS wcel cA vw cv cF co vv cv cF co cB vv cv cF co vv cv cA vw cv cF co
        cB vv cv cF opreq1 vv cv cS wcel vv cv cB cF co vv cv cB vv cv cF co vx
        cv cB cF co vx cv wceq vv cv cB cF co vv cv wceq vx vv cv cS vx cv vv
        cv wceq vx cv cB cF co vv cv cB cF co vx cv vv cv vx cv vv cv cB cF
        opreq1 vx cv vv cv wceq id eqeq12d caoprmo.id vtoclga vx vy cB vv cv cF
        cB cS caoprmo.2 elisseti vv visset caoprmo.com caoprcom syl5eq sylan9eq
        ad2ant2lr eqtr3d ax-gen mpgbir cA vw cv cF co cB wceq vw cv cS wcel cA
        vw cv cF co cB wceq wa vw cA vw cv cF co cB wceq vw cv cS wcel cA vw cv
        cF co cB wceq cA vw cv cF co cS wcel vw cv cS wcel cA vw cv cF co cB
        wceq cA vw cv cF co cS wcel cB cS wcel caoprmo.2 cA vw cv cF co cB cS
        eleq1 mpbiri cA vw cv cF co cS wcel cA cS wcel vw cv cS wcel cA vw cv
        cS cF vw visset caoprmo.dom caoprmo.3 ndmoprrcl pm3.27d syl ancri immoi
        ax-mp $.
        $( [4-Mar-1996] $)
    $}

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        "Maps to" notation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c |-> $.  $( "Maps to" symbol $)

  $( Extend the definition of a class to include "maps to" notation for
     defining a function via a rule. $)
  cmpt $a class ( x e. A |-> B ) $.

  $( Extend the definition of a class to include "maps to" notation for
     defining an operation via a rule. $)
  cmpt2 $a class ( x e. A , y e. B |-> C ) $.

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Define "maps to" notation for defining a function via a rule.  Read as
       "the function defined by the map from ` x ` (in ` A ` ) to
       ` B ( x ) ` ."  The class expression ` B ` is the value of the function
       at ` x ` and normally contains the variable ` x ` .  An example is the
       square function for complex numbers, ` ( x e. CC |-> ( x ^ 2 ) ` .
       Similar to the definition of mapping in [ChoquetDD] p. 2. $)
    df-mpt $a |- ( x e. A |-> B ) =
                    { <. x , y >. | ( x e. A /\ y = B ) } $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z B $.  $d z C $.
    $( Define "maps to" notation for defining an operation via a rule.  Read as
       "the operation defined by the map from ` x , y ` (in ` A X. B ` ) to
       ` B ( x , y ) ` ."  An extension of ~ df-mpt for two arguments. $)
    df-mpt2 $a |- ( x e. A , y e. B |-> C ) =
             { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ z = C ) } $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C y $.  $d x D y $.
    mptg.1 $e |- ( x = A -> B = C ) $.
    mptg.2 $e |- F = ( x e. D |-> B ) $.
    $( Value of a function given by a "maps to" rule.  Equivalent to
       ~ fvopab4g . $)
    mptg $p |- ( ( A e. D /\ C e. R ) -> ( F ` A ) = C ) $=
      vx vy cA cB cC cD cR cF mptg.1 cF vx cD cB cmpt vx cv cD wcel vy cv cB
      wceq wa vx vy copab mptg.2 vx vy cD cB df-mpt eqtri fvopab4g $.
      $( [4-Aug-2008] $) $( [2-Oct-2007] $)
  $}

  ${
    $d x y z A $.  $d x B y z $.  $d x C y z $.  $d x D y z $.  $d x G $.
    $d z R $.  $d y S z $.
    mpt2g.1 $e |- ( x = A -> R = G ) $.
    mpt2g.2 $e |- ( y = B -> G = S ) $.
    mpt2g.3 $e |- F = ( x e. C , y e. D |-> R ) $.
    $( Value of an operation given by a "maps to" rule.  Equivalent to
       ~ oprabval2g . $)
    mpt2g $p |- ( ( A e. C /\ B e. D /\ S e. H ) -> ( A F B ) = S ) $=
      vx vy vz cA cB cC cD cR cS cF cG cH mpt2g.1 mpt2g.2 cF vx vy cC cD cR
      cmpt2 vx cv cC wcel vy cv cD wcel wa vz cv cR wceq wa vx vy vz copab2
      mpt2g.3 vx vy vz cC cD cR df-mpt2 eqtri oprabval2g $.
      $( [6-Aug-2008] $) $( [2-Oct-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        First and second members of an ordered pair
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c 1st $. $( First member of an ordered pair $)
  $c 2nd $. $( Second member of an ordered pair $)

  $( Extend the definition of a class to include the first member an
     ordered pair function. $)
  c1st $a class 1st $.

  $( Extend the definition of a class to include the second member an
     ordered pair function. $)
  c2nd $a class 2nd $.

  ${
    $d x y z $.
    $( Define a function that extracts the first member of an ordered pair.
       Theorem ~ op1st proves that it does this.  Equivalent to Definition 5.13
       (i) of [Monk1] p. 52 (compare ~ op1sta and ~ op1stb ).  The notation is
       the same as Monk's. $)
    df-1st $a |- 1st = { <. x , y >. | y = U. dom { x } } $.

    $( Define a function that extracts the second member of an ordered pair.
       Theorem ~ op2nd proves that it does this.  Equivalent to Definition 5.13
       (ii) of [Monk1] p. 52 (compare ~ op2nda and ~ op2ndb ).  The notation is
       the same as Monk's. $)
    df-2nd $a |- 2nd = { <. x , y >. | y = U. ran { x } } $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The value of the function that extracts the first member of an ordered
       pair. $)
    1stval $p |- ( 1st ` A ) = U. dom { A } $=
      cA cvv wcel cA c1st cfv cA csn cdm cuni wceq cA cvv wcel cA csn cdm cuni
      cvv wcel cA c1st cfv cA csn cdm cuni wceq cA csn cdm cA csn cA snex dmex
      uniex cA cvv wcel cA csn cdm cuni cvv wcel wa cA vy cv vx cv csn cdm cuni
      wceq vx vy copab cfv cA csn cdm cuni cA c1st cfv vx vy cA vx cv csn cdm
      cuni cA csn cdm cuni cvv cvv vx cv cA wceq vx cv csn cdm cA csn cdm vx cv
      cA wceq vx cv csn cA csn vx cv cA sneq dmeqd unieqd fvopabg cA c1st vy cv
      vx cv csn cdm cuni wceq vx vy copab vx vy df-1st fveq1i syl5eq mpan2 cA
      cvv wcel wn cA c1st cfv c0 cA csn cdm cuni cA c1st fvprc cA cvv wcel wn
      cA csn cdm cuni c0 cuni c0 cA cvv wcel wn cA csn cdm c0 cA cvv wcel wn cA
      csn cdm c0 cdm c0 cA cvv wcel wn cA csn c0 cA cvv wcel wn cA csn c0 wceq
      cA snprc biimpi dmeqd dm0 syl6eq unieqd uni0 syl6eq eqtr4d pm2.61i $.
      $( [14-Oct-2004] $) $( [9-Oct-2004] $)

    $( The value of the function that extracts the second member of an ordered
       pair. $)
    2ndval $p |- ( 2nd ` A ) = U. ran { A } $=
      cA cvv wcel cA c2nd cfv cA csn crn cuni wceq cA cvv wcel cA csn crn cuni
      cvv wcel cA c2nd cfv cA csn crn cuni wceq cA csn crn cA csn cA snex rnex
      uniex cA cvv wcel cA csn crn cuni cvv wcel wa cA vy cv vx cv csn crn cuni
      wceq vx vy copab cfv cA csn crn cuni cA c2nd cfv vx vy cA vx cv csn crn
      cuni cA csn crn cuni cvv cvv vx cv cA wceq vx cv csn crn cA csn crn vx cv
      cA wceq vx cv csn cA csn vx cv cA sneq rneqd unieqd fvopabg cA c2nd vy cv
      vx cv csn crn cuni wceq vx vy copab vx vy df-2nd fveq1i syl5eq mpan2 cA
      cvv wcel wn cA c2nd cfv c0 cA csn crn cuni cA c2nd fvprc cA cvv wcel wn
      cA csn crn cuni c0 cuni c0 cA cvv wcel wn cA csn crn c0 cA cvv wcel wn cA
      csn crn c0 crn c0 cA cvv wcel wn cA csn c0 cA cvv wcel wn cA csn c0 wceq
      cA snprc biimpi rneqd rn0 syl6eq unieqd uni0 syl6eq eqtr4d pm2.61i $.
      $( [14-Oct-2004] $) $( [9-Oct-2004] $)
  $}

  $( The value of the first-member function at the empty set. $)
  1st0 $p |- ( 1st ` (/) ) = (/) $=
    c0 c1st cfv c0 csn cdm cuni c0 cuni c0 c0 1stval c0 csn cdm c0 dmsn0 unieqi
    uni0 3eqtri $.
    $( [26-Apr-2007] $) $( [23-Apr-2007] $)

  $( The value of the second-member function at the empty set. $)
  2nd0 $p |- ( 2nd ` (/) ) = (/) $=
    c0 c2nd cfv c0 csn crn cuni c0 cuni c0 c0 2ndval c0 csn crn c0 c0 csn cdm
    c0 wceq c0 csn crn c0 wceq dmsn0 c0 csn dm0rn0 mpbi unieqi uni0 3eqtri $.
    $( [1-May-2007] $) $( [23-Apr-2007] $)

  ${
    op1st.1 $e |- A e. _V $.
    $( Extract the first member of an ordered pair. $)
    op1st $p |- ( 1st ` <. A , B >. ) = A $=
      cA cB cop c1st cfv cA cB cop csn cdm cuni cA cA cB cop 1stval cA cB
      op1st.1 op1sta eqtri $.
      $( [16-Oct-2004] $) $( [5-Oct-2004] $)

    ${
      op2n.2 $e |- B e. _V $.
      $( Extract the second member of an ordered pair. $)
      op2nd $p |- ( 2nd ` <. A , B >. ) = B $=
        cA cB cop c2nd cfv cA cB cop csn crn cuni cB cA cB cop 2ndval cA cB
        op1st.1 op2n.2 op2nda eqtri $.
        $( [16-Oct-2004] $) $( [5-Oct-2004] $)
    $}
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Extract the first member of an ordered pair. $)
    op1stg $p |- ( A e. C -> ( 1st ` <. A , B >. ) = A ) $=
      vx cv cB cop c1st cfv vx cv wceq cA cB cop c1st cfv cA wceq vx cA cC vx
      cv cA wceq vx cv cB cop c1st cfv cA cB cop c1st cfv vx cv cA vx cv cA
      wceq vx cv cB cop cA cB cop c1st vx cv cA cB opeq1 fveq2d vx cv cA wceq
      id eqeq12d vx cv cB vx visset op1st vtoclg $.
      $( [20-Jul-2005] $) $( [19-Jul-2005] $)

    $( Extract the second member of an ordered pair. $)
    op2ndg $p |- ( ( A e. C /\ B e. D ) -> ( 2nd ` <. A , B >. ) = B ) $=
      vx cv vy cv cop c2nd cfv vy cv wceq cA vy cv cop c2nd cfv vy cv wceq cA
      cB cop c2nd cfv cB wceq vx vy cA cB cC cD vx cv cA wceq vx cv vy cv cop
      c2nd cfv cA vy cv cop c2nd cfv vy cv vx cv cA wceq vx cv vy cv cop cA vy
      cv cop c2nd vx cv cA vy cv opeq1 fveq2d eqeq1d vy cv cB wceq cA vy cv cop
      c2nd cfv cA cB cop c2nd cfv vy cv cB vy cv cB wceq cA vy cv cop cA cB cop
      c2nd vy cv cB cA opeq2 fveq2d vy cv cB wceq id eqeq12d vx cv vy cv vx
      visset vy visset op2nd vtocl2g $.
      $( [24-Jul-2005] $) $( [19-Jul-2005] $)

    $( Alternate value of the function that extracts the first member of an
       ordered pair.  Definition 5.13 (i) of [Monk1] p. 52. $)
    1stval2 $p |- ( A e. ( _V X. _V ) -> ( 1st ` A ) = |^| |^| A ) $=
      cA cvv cvv cxp wcel cA vx cv vy cv cop wceq vy wex vx wex cA c1st cfv cA
      cint cint wceq vx vy cA elvv cA vx cv vy cv cop wceq cA c1st cfv cA cint
      cint wceq vx vy cA vx cv vy cv cop wceq vx cv vy cv cop c1st cfv vx cv vy
      cv cop cint cint cA c1st cfv cA cint cint vx cv vy cv cop c1st cfv vx cv
      vx cv vy cv cop cint cint vx cv vy cv vx visset op1st vx cv vy cv vx
      visset op1stb eqtr4i cA vx cv vy cv cop c1st fveq2 cA vx cv vy cv cop
      wceq cA cint vx cv vy cv cop cint cA vx cv vy cv cop inteq inteqd 3eqtr4a
      19.23aivv sylbi $.
      $( [14-Oct-2006] $) $( [18-Aug-2006] $)

    $( Alternate value of the function that extracts the second member of an
       ordered pair.  Definition 5.13 (ii) of [Monk1] p. 52. $)
    2ndval2 $p |- ( A e. ( _V X. _V )
               -> ( 2nd ` A ) = |^| |^| |^| `' { A } ) $=
      cA cvv cvv cxp wcel cA vx cv vy cv cop wceq vy wex vx wex cA c2nd cfv cA
      csn ccnv cint cint cint wceq vx vy cA elvv cA vx cv vy cv cop wceq cA
      c2nd cfv cA csn ccnv cint cint cint wceq vx vy cA vx cv vy cv cop wceq vx
      cv vy cv cop c2nd cfv vx cv vy cv cop csn ccnv cint cint cint cA c2nd cfv
      cA csn ccnv cint cint cint vx cv vy cv cop c2nd cfv vy cv vx cv vy cv cop
      csn ccnv cint cint cint vx cv vy cv vx visset vy visset op2nd vx cv vy cv
      vx visset vy visset op2ndb eqtr4i cA vx cv vy cv cop c2nd fveq2 cA vx cv
      vy cv cop wceq cA csn ccnv cint cint vx cv vy cv cop csn ccnv cint cint
      cA vx cv vy cv cop wceq cA csn ccnv cint vx cv vy cv cop csn ccnv cint cA
      vx cv vy cv cop wceq cA csn ccnv vx cv vy cv cop csn ccnv cA vx cv vy cv
      cop wceq cA csn vx cv vy cv cop csn wceq cA csn ccnv vx cv vy cv cop csn
      ccnv wceq cA vx cv vy cv cop sneq cA csn vx cv vy cv cop csn cnveq syl
      inteqd inteqd inteqd 3eqtr4a 19.23aivv sylbi $.
      $( [18-Aug-2006] $) $( [18-Aug-2006] $)
  $}

  ${
    $d x y z w v A $.  $d x y z B $.  $d x y z w v u $.
    $( The ` 1st ` function maps the universe onto the universe. $)
    fo1st $p |- 1st : _V -onto-> _V $=
      cvv cvv c1st wfo cvv cvv vy cv vx cv csn cdm cuni wceq vx vy copab wfo
      cvv cvv vy cv vx cv csn cdm cuni wceq vx vy copab wfo vy cv vx cv csn cdm
      cuni wceq vx vy copab cvv wfn vy cv vx cv csn cdm cuni wceq vx vy copab
      crn cvv wceq cvv cvv vy cv vx cv csn cdm cuni wceq vx vy copab df-fo vx
      vy cvv vx cv csn cdm cuni vy cv vx cv csn cdm cuni wceq vx vy copab vx cv
      csn cdm vx cv csn vx cv snex dmex uniex vy cv vx cv csn cdm cuni wceq vx
      cv cvv wcel vy cv vx cv csn cdm cuni wceq wa vx vy vx cv cvv wcel vy cv
      vx cv csn cdm cuni wceq vx visset biantrur opabbii fnopab2 vy cv vx cv
      csn cdm cuni wceq vx wex vy cab vy cv vy cv wceq vy cab vy cv vx cv csn
      cdm cuni wceq vx vy copab crn cvv vy cv vx cv csn cdm cuni wceq vx wex vy
      cv vy cv wceq vy vy cv vx cv csn cdm cuni wceq vx wex vy cv vy cv wceq vy
      cv vy cv vy cv cop csn cdm cuni wceq vy cv vx cv csn cdm cuni wceq vx wex
      vy cv vy cv cop csn cdm cuni vy cv vy cv vy cv vy visset op1sta eqcomi vy
      cv vx cv csn cdm cuni wceq vy cv vy cv vy cv cop csn cdm cuni wceq vx vy
      cv vy cv cop vy cv vy cv opex vx cv vy cv vy cv cop wceq vx cv csn cdm
      cuni vy cv vy cv cop csn cdm cuni vy cv vx cv vy cv vy cv cop wceq vx cv
      csn cdm vy cv vy cv cop csn cdm vx cv vy cv vy cv cop wceq vx cv csn vy
      cv vy cv cop csn vx cv vy cv vy cv cop sneq dmeqd unieqd eqeq2d cla4ev
      ax-mp vy equid 2th abbii vy cv vx cv csn cdm cuni wceq vx vy rnopab vy
      df-v 3eqtr4i mpbir2an c1st vy cv vx cv csn cdm cuni wceq vx vy copab wceq
      cvv cvv c1st wfo cvv cvv vy cv vx cv csn cdm cuni wceq vx vy copab wfo wb
      vx vy df-1st cvv cvv c1st vy cv vx cv csn cdm cuni wceq vx vy copab foeq1
      ax-mp mpbir $.
      $( [16-Oct-2004] $) $( [14-Oct-2004] $)

    $d x y z w v A $.  $d x y z B $.  $d x y z w v u $.
    $( The ` 2nd ` function maps the universe onto the universe. $)
    fo2nd $p |- 2nd : _V -onto-> _V $=
      cvv cvv c2nd wfo cvv cvv vy cv vx cv csn crn cuni wceq vx vy copab wfo
      cvv cvv vy cv vx cv csn crn cuni wceq vx vy copab wfo vy cv vx cv csn crn
      cuni wceq vx vy copab cvv wfn vy cv vx cv csn crn cuni wceq vx vy copab
      crn cvv wceq cvv cvv vy cv vx cv csn crn cuni wceq vx vy copab df-fo vx
      vy cvv vx cv csn crn cuni vy cv vx cv csn crn cuni wceq vx vy copab vx cv
      csn crn vx cv csn vx cv snex rnex uniex vy cv vx cv csn crn cuni wceq vx
      cv cvv wcel vy cv vx cv csn crn cuni wceq wa vx vy vx cv cvv wcel vy cv
      vx cv csn crn cuni wceq vx visset biantrur opabbii fnopab2 vy cv vx cv
      csn crn cuni wceq vx wex vy cab vy cv vy cv wceq vy cab vy cv vx cv csn
      crn cuni wceq vx vy copab crn cvv vy cv vx cv csn crn cuni wceq vx wex vy
      cv vy cv wceq vy vy cv vx cv csn crn cuni wceq vx wex vy cv vy cv wceq vy
      cv vy cv vy cv cop csn crn cuni wceq vy cv vx cv csn crn cuni wceq vx wex
      vy cv vy cv cop csn crn cuni vy cv vy cv vy cv vy visset vy visset op2nda
      eqcomi vy cv vx cv csn crn cuni wceq vy cv vy cv vy cv cop csn crn cuni
      wceq vx vy cv vy cv cop vy cv vy cv opex vx cv vy cv vy cv cop wceq vx cv
      csn crn cuni vy cv vy cv cop csn crn cuni vy cv vx cv vy cv vy cv cop
      wceq vx cv csn crn vy cv vy cv cop csn crn vx cv vy cv vy cv cop wceq vx
      cv csn vy cv vy cv cop csn vx cv vy cv vy cv cop sneq rneqd unieqd eqeq2d
      cla4ev ax-mp vy equid 2th abbii vy cv vx cv csn crn cuni wceq vx vy
      rnopab vy df-v 3eqtr4i mpbir2an c2nd vy cv vx cv csn crn cuni wceq vx vy
      copab wceq cvv cvv c2nd wfo cvv cvv vy cv vx cv csn crn cuni wceq vx vy
      copab wfo wb vx vy df-2nd cvv cvv c2nd vy cv vx cv csn crn cuni wceq vx
      vy copab foeq1 ax-mp mpbir $.
      $( [16-Oct-2004] $) $( [14-Oct-2004] $)

    $( Mapping of a restriction of the ` 1st ` (first member of an ordered
       pair) function. $)
    f1stres $p |- ( 1st |` ( A X. B ) ) : ( A X. B ) --> A $=
      vx cv csn cdm cuni cA wcel vx cA cB cxp wral cA cB cxp cA c1st cA cB cxp
      cres wf vx cv csn cdm cuni cA wcel vx cA cB cxp wral vy cv vz cv cop csn
      cdm cuni cA wcel vz cB wral vy cA wral vy cv vz cv cop csn cdm cuni cA
      wcel vy vz cA cB vy cv cA wcel vy cv vz cv cop csn cdm cuni cA wcel vz cv
      cB wcel vy cv vz cv cop csn cdm cuni cA wcel vy cv cA wcel vy cv vz cv
      cop csn cdm cuni vy cv cA vy cv vz cv vy visset op1sta eleq1i biimpri
      adantr rgen2 vx cv csn cdm cuni cA wcel vy cv vz cv cop csn cdm cuni cA
      wcel vx vy vz cA cB vx cv vy cv vz cv cop wceq vx cv csn cdm cuni vy cv
      vz cv cop csn cdm cuni cA vx cv vy cv vz cv cop wceq vx cv csn cdm vy cv
      vz cv cop csn cdm vx cv vy cv vz cv cop wceq vx cv csn vy cv vz cv cop
      csn vx cv vy cv vz cv cop sneq dmeqd unieqd eleq1d ralxp mpbir vx vy cA
      cB cxp cA vx cv csn cdm cuni c1st cA cB cxp cres c1st cA cB cxp cres vy
      cv vx cv csn cdm cuni wceq vx vy copab cA cB cxp cres vx cv cA cB cxp
      wcel vy cv vx cv csn cdm cuni wceq wa vx vy copab c1st vy cv vx cv csn
      cdm cuni wceq vx vy copab wceq c1st cA cB cxp cres vy cv vx cv csn cdm
      cuni wceq vx vy copab cA cB cxp cres wceq vx vy df-1st c1st vy cv vx cv
      csn cdm cuni wceq vx vy copab cA cB cxp reseq1 ax-mp vy cv vx cv csn cdm
      cuni wceq vx vy cA cB cxp resopab eqtri fopab2 mpbi $.
      $( [16-Oct-2004] $) $( [11-Oct-2004] $)

    $( Mapping of a restriction of the ` 2nd ` (second member of an ordered
       pair) function. $)
    f2ndres $p |- ( 2nd |` ( A X. B ) ) : ( A X. B ) --> B $=
      vx cv csn crn cuni cB wcel vx cA cB cxp wral cA cB cxp cB c2nd cA cB cxp
      cres wf vx cv csn crn cuni cB wcel vx cA cB cxp wral vy cv vz cv cop csn
      crn cuni cB wcel vz cB wral vy cA wral vy cv vz cv cop csn crn cuni cB
      wcel vy vz cA cB vz cv cB wcel vy cv vz cv cop csn crn cuni cB wcel vy cv
      cA wcel vy cv vz cv cop csn crn cuni cB wcel vz cv cB wcel vy cv vz cv
      cop csn crn cuni vz cv cB vy cv vz cv vy visset vz visset op2nda eleq1i
      biimpri adantl rgen2 vx cv csn crn cuni cB wcel vy cv vz cv cop csn crn
      cuni cB wcel vx vy vz cA cB vx cv vy cv vz cv cop wceq vx cv csn crn cuni
      vy cv vz cv cop csn crn cuni cB vx cv vy cv vz cv cop wceq vx cv csn crn
      vy cv vz cv cop csn crn vx cv vy cv vz cv cop wceq vx cv csn vy cv vz cv
      cop csn vx cv vy cv vz cv cop sneq rneqd unieqd eleq1d ralxp mpbir vx vy
      cA cB cxp cB vx cv csn crn cuni c2nd cA cB cxp cres c2nd cA cB cxp cres
      vy cv vx cv csn crn cuni wceq vx vy copab cA cB cxp cres vx cv cA cB cxp
      wcel vy cv vx cv csn crn cuni wceq wa vx vy copab c2nd vy cv vx cv csn
      crn cuni wceq vx vy copab wceq c2nd cA cB cxp cres vy cv vx cv csn crn
      cuni wceq vx vy copab cA cB cxp cres wceq vx vy df-2nd c2nd vy cv vx cv
      csn crn cuni wceq vx vy copab cA cB cxp reseq1 ax-mp vy cv vx cv csn crn
      cuni wceq vx vy cA cB cxp resopab eqtri fopab2 mpbi $.
      $( [10-Mar-2007] $) $( [7-Aug-2006] $)

    $( Onto mapping of a restriction of the ` 1st ` (first member of an ordered
       pair) function. $)
    fo1stres $p |- ( B =/= (/) ->
                 ( 1st |` ( A X. B ) ) : ( A X. B ) -onto-> A ) $=
      cB c0 wne cA cB cxp cA c1st cA cB cxp cres wf c1st cA cB cxp cres crn cA
      wceq wa cA cB cxp cA c1st cA cB cxp cres wfo cB c0 wne c1st cA cB cxp
      cres crn cA wceq cA cB cxp cA c1st cA cB cxp cres wf cB c0 wne c1st cA cB
      cxp cres crn cA wss cA c1st cA cB cxp cres crn wss wa c1st cA cB cxp cres
      crn cA wceq cB c0 wne cA c1st cA cB cxp cres crn wss c1st cA cB cxp cres
      crn cA wss cB c0 wne vx cA c1st cA cB cxp cres crn cB c0 wne vy cv cB
      wcel vy wex vx cv cA wcel vx cv c1st cA cB cxp cres crn wcel wi vy cB n0
      vy cv cB wcel vx cv cA wcel vx cv c1st cA cB cxp cres crn wcel wi vy vx
      cv cA wcel vy cv cB wcel vx cv c1st cA cB cxp cres crn wcel vx cv cA wcel
      vy cv cB wcel wa vx cv vy cv cop cA cB cxp wcel vx cv c1st cA cB cxp cres
      crn wcel vx cv vy cv cA cB vy visset opelxp vx cv vy cv cop cA cB cxp
      wcel vx cv vx cv vy cv cop c1st cA cB cxp cres cfv c1st cA cB cxp cres
      crn vx cv vy cv cop cA cB cxp wcel vx cv vy cv cop c1st cA cB cxp cres
      cfv vx cv vy cv cop c1st cfv vx cv vx cv vy cv cop cA cB cxp c1st fvres
      vx cv vy cv vx visset op1st syl6req c1st cA cB cxp cres cA cB cxp wfn vx
      cv vy cv cop cA cB cxp wcel vx cv vy cv cop c1st cA cB cxp cres cfv c1st
      cA cB cxp cres crn wcel cA cB cxp cA c1st cA cB cxp cres wf c1st cA cB
      cxp cres cA cB cxp wfn cA cB f1stres cA cB cxp cA c1st cA cB cxp cres ffn
      ax-mp cA cB cxp vx cv vy cv cop c1st cA cB cxp cres fnfvelrn mpan eqeltrd
      sylbir expcom 19.23aiv sylbi ssrdv cA cB cxp cA c1st cA cB cxp cres wf
      c1st cA cB cxp cres crn cA wss cA cB f1stres cA cB cxp cA c1st cA cB cxp
      cres frn ax-mp jctil c1st cA cB cxp cres crn cA eqss sylibr cA cB f1stres
      jctil cA cB cxp cA c1st cA cB cxp cres dffo2 sylibr $.
      $( [2-Jan-2009] $) $( [14-Dec-2008] $)

    $( Onto mapping of a restriction of the ` 2nd ` (second member of an
       ordered pair) function. $)
    fo2ndres $p |- ( A =/= (/) ->
                 ( 2nd |` ( A X. B ) ) : ( A X. B ) -onto-> B ) $=
      cA c0 wne cA cB cxp cB c2nd cA cB cxp cres wf c2nd cA cB cxp cres crn cB
      wceq wa cA cB cxp cB c2nd cA cB cxp cres wfo cA c0 wne c2nd cA cB cxp
      cres crn cB wceq cA cB cxp cB c2nd cA cB cxp cres wf cA c0 wne c2nd cA cB
      cxp cres crn cB wss cB c2nd cA cB cxp cres crn wss wa c2nd cA cB cxp cres
      crn cB wceq cA c0 wne cB c2nd cA cB cxp cres crn wss c2nd cA cB cxp cres
      crn cB wss cA c0 wne vy cB c2nd cA cB cxp cres crn cA c0 wne vx cv cA
      wcel vx wex vy cv cB wcel vy cv c2nd cA cB cxp cres crn wcel wi vx cA n0
      vx cv cA wcel vy cv cB wcel vy cv c2nd cA cB cxp cres crn wcel wi vx vx
      cv cA wcel vy cv cB wcel vy cv c2nd cA cB cxp cres crn wcel vx cv cA wcel
      vy cv cB wcel wa vx cv vy cv cop cA cB cxp wcel vy cv c2nd cA cB cxp cres
      crn wcel vx cv vy cv cA cB vy visset opelxp vx cv vy cv cop cA cB cxp
      wcel vy cv vx cv vy cv cop c2nd cA cB cxp cres cfv c2nd cA cB cxp cres
      crn vx cv vy cv cop cA cB cxp wcel vx cv vy cv cop c2nd cA cB cxp cres
      cfv vx cv vy cv cop c2nd cfv vy cv vx cv vy cv cop cA cB cxp c2nd fvres
      vx cv vy cv vx visset vy visset op2nd syl6req c2nd cA cB cxp cres cA cB
      cxp wfn vx cv vy cv cop cA cB cxp wcel vx cv vy cv cop c2nd cA cB cxp
      cres cfv c2nd cA cB cxp cres crn wcel cA cB cxp cB c2nd cA cB cxp cres wf
      c2nd cA cB cxp cres cA cB cxp wfn cA cB f2ndres cA cB cxp cB c2nd cA cB
      cxp cres ffn ax-mp cA cB cxp vx cv vy cv cop c2nd cA cB cxp cres fnfvelrn
      mpan eqeltrd sylbir ex 19.23aiv sylbi ssrdv cA cB cxp cB c2nd cA cB cxp
      cres wf c2nd cA cB cxp cres crn cB wss cA cB f2ndres cA cB cxp cB c2nd cA
      cB cxp cres frn ax-mp jctil c2nd cA cB cxp cres crn cB eqss sylibr cA cB
      f2ndres jctil cA cB cxp cB c2nd cA cB cxp cres dffo2 sylibr $.
      $( [14-Dec-2008] $) $( [14-Dec-2008] $)

    $( Value of an alternate definition of the ` 1st ` function. $)
    1st2val $p |- ( { <. <. x , y >. , z >. | z = x } ` A ) = ( 1st ` A ) $=
      cA cvv cvv cxp wcel cA vz cv vx cv wceq vx vy vz copab2 cfv cA c1st cfv
      wceq cA cvv cvv cxp wcel cA vw cv vv cv cop wceq vv wex vw wex cA vz cv
      vx cv wceq vx vy vz copab2 cfv cA c1st cfv wceq vw vv cA elvv cA vw cv vv
      cv cop wceq cA vz cv vx cv wceq vx vy vz copab2 cfv cA c1st cfv wceq vw
      vv cA vw cv vv cv cop wceq vw cv vv cv cop vz cv vx cv wceq vx vy vz
      copab2 cfv vw cv vv cv cop c1st cfv cA vz cv vx cv wceq vx vy vz copab2
      cfv cA c1st cfv vw cv vv cv cop c1st cfv vw cv vw cv vv cv vz cv vx cv
      wceq vx vy vz copab2 co vw cv vv cv cop vz cv vx cv wceq vx vy vz copab2
      cfv vw cv vv cv vw visset op1st vw cv cvv wcel vv cv cvv wcel vw cv vv cv
      vz cv vx cv wceq vx vy vz copab2 co vw cv wceq vw visset vv visset vx vy
      vz vw cv vv cv cvv cvv vx cv vw cv vz cv vx cv wceq vx vy vz copab2 vw cv
      vw visset vx cv vw cv wceq id vy cv vv cv wceq vw cv eqidd vz cv vx cv
      wceq vx vy vz copab2 eqid oprabval5 mp2an vw cv vv cv vz cv vx cv wceq vx
      vy vz copab2 df-opr 3eqtr2ri cA vw cv vv cv cop vz cv vx cv wceq vx vy vz
      copab2 fveq2 cA vw cv vv cv cop c1st fveq2 3eqtr4a 19.23aivv sylbi cA cvv
      cvv cxp wcel wn cA vz cv vx cv wceq vx vy vz copab2 cfv cA csn cdm cuni
      cA c1st cfv cA cvv cvv cxp wcel wn cA vz cv vx cv wceq vx vy vz copab2
      cfv c0 cA csn cdm cuni cA cvv cvv cxp wcel wn cA vz cv vx cv wceq vx vy
      vz copab2 cdm wcel wn cA vz cv vx cv wceq vx vy vz copab2 cfv c0 wceq cA
      vz cv vx cv wceq vx vy vz copab2 cdm wcel cA cvv cvv cxp wcel vz cv vx cv
      wceq vx vy vz copab2 cdm cvv cvv cxp cA vx cv cvv wcel vy cv cvv wcel wa
      vx vy copab vz cv vx cv wceq vz wex vx vy copab cvv cvv cxp vz cv vx cv
      wceq vx vy vz copab2 cdm vx cv cvv wcel vy cv cvv wcel wa vz cv vx cv
      wceq vz wex vx vy vx cv cvv wcel vy cv cvv wcel wa vz cv vx cv wceq vz
      wex vx cv cvv wcel vy cv cvv wcel vx visset vy visset pm3.2i vz vx a9e
      2th opabbii vx vy cvv cvv df-xp vz cv vx cv wceq vx vy vz dmoprab
      3eqtr4ri eleq2i notbii cA vz cv vx cv wceq vx vy vz copab2 ndmfv sylbir
      cA cvv cvv cxp wcel wn cA csn cdm cuni c0 cuni c0 cA cvv cvv cxp wcel wn
      cA csn cdm c0 cA cvv cvv cxp wcel cA csn cdm c0 cA cvv cvv cxp wcel cA
      csn cdm c0 wne cA dmsnn0 biimpri necon1bi unieqd uni0 syl6eq eqtr4d cA
      1stval syl6eqr pm2.61i $.
      $( [17-Dec-2008] $) $( [14-Oct-2004] $)

    $( Value of an alternate definition of the ` 2nd ` function. $)
    2nd2val $p |- ( { <. <. x , y >. , z >. | z = y } ` A ) = ( 2nd ` A ) $=
      cA cvv cvv cxp wcel cA vz cv vy cv wceq vx vy vz copab2 cfv cA c2nd cfv
      wceq cA cvv cvv cxp wcel cA vw cv vv cv cop wceq vv wex vw wex cA vz cv
      vy cv wceq vx vy vz copab2 cfv cA c2nd cfv wceq vw vv cA elvv cA vw cv vv
      cv cop wceq cA vz cv vy cv wceq vx vy vz copab2 cfv cA c2nd cfv wceq vw
      vv cA vw cv vv cv cop wceq vw cv vv cv cop vz cv vy cv wceq vx vy vz
      copab2 cfv vw cv vv cv cop c2nd cfv cA vz cv vy cv wceq vx vy vz copab2
      cfv cA c2nd cfv vw cv vv cv cop c2nd cfv vv cv vw cv vv cv vz cv vy cv
      wceq vx vy vz copab2 co vw cv vv cv cop vz cv vy cv wceq vx vy vz copab2
      cfv vw cv vv cv vw visset vv visset op2nd vw cv cvv wcel vv cv cvv wcel
      vw cv vv cv vz cv vy cv wceq vx vy vz copab2 co vv cv wceq vw visset vv
      visset vx vy vz vw cv vv cv cvv cvv vy cv vv cv vz cv vy cv wceq vx vy vz
      copab2 vy cv vv visset vx cv vw cv wceq vy cv eqidd vy cv vv cv wceq id
      vz cv vy cv wceq vx vy vz copab2 eqid oprabval5 mp2an vw cv vv cv vz cv
      vy cv wceq vx vy vz copab2 df-opr 3eqtr2ri cA vw cv vv cv cop vz cv vy cv
      wceq vx vy vz copab2 fveq2 cA vw cv vv cv cop c2nd fveq2 3eqtr4a
      19.23aivv sylbi cA cvv cvv cxp wcel wn cA vz cv vy cv wceq vx vy vz
      copab2 cfv cA csn crn cuni cA c2nd cfv cA cvv cvv cxp wcel wn cA vz cv vy
      cv wceq vx vy vz copab2 cfv c0 cA csn crn cuni cA cvv cvv cxp wcel wn cA
      vz cv vy cv wceq vx vy vz copab2 cdm wcel wn cA vz cv vy cv wceq vx vy vz
      copab2 cfv c0 wceq cA vz cv vy cv wceq vx vy vz copab2 cdm wcel cA cvv
      cvv cxp wcel vz cv vy cv wceq vx vy vz copab2 cdm cvv cvv cxp cA vx cv
      cvv wcel vy cv cvv wcel wa vx vy copab vz cv vy cv wceq vz wex vx vy
      copab cvv cvv cxp vz cv vy cv wceq vx vy vz copab2 cdm vx cv cvv wcel vy
      cv cvv wcel wa vz cv vy cv wceq vz wex vx vy vx cv cvv wcel vy cv cvv
      wcel wa vz cv vy cv wceq vz wex vx cv cvv wcel vy cv cvv wcel vx visset
      vy visset pm3.2i vz vy a9e 2th opabbii vx vy cvv cvv df-xp vz cv vy cv
      wceq vx vy vz dmoprab 3eqtr4ri eleq2i notbii cA vz cv vy cv wceq vx vy vz
      copab2 ndmfv sylbir cA cvv cvv cxp wcel wn cA csn crn cuni c0 cuni c0 cA
      cvv cvv cxp wcel wn cA csn crn c0 cA cvv cvv cxp wcel cA csn crn c0 cA
      cvv cvv cxp wcel cA csn crn c0 wne cA rnsnn0 biimpri necon1bi unieqd uni0
      syl6eq eqtr4d cA 2ndval syl6eqr pm2.61i $.
      $( [18-Dec-2008] $) $( [10-Aug-2006] $)
  $}

  $( Composition of the first member function with another function. $)
  1stcof $p |- ( F : A --> ( B X. C ) -> ( 1st o. F ) : A --> B ) $=
    cA cB c1st cF ccom wf c1st cF ccom cA wfn c1st cF ccom crn cB wss cA cB cC
    cxp cF wf cA cB c1st cF ccom df-f c1st cvv wfn cA cvv cF wf c1st cF ccom cA
    wfn cA cB cC cxp cF wf cvv cA c1st cF fnfco cvv cvv c1st wfo c1st cvv wfn
    fo1st cvv cvv c1st fofn ax-mp cA cB cC cxp cF wf cF cA wfn cA cvv cF wf cA
    cB cC cxp cF ffn cA cF dffn2 sylib sylancr cA cB cC cxp cF wf c1st cF crn
    cres crn cB c1st cF ccom crn cA cB cC cxp cF wf c1st cF crn cres crn c1st
    cB cC cxp cres crn cB cA cB cC cxp cF wf cF crn cB cC cxp wss c1st cF crn
    cres c1st cB cC cxp cres wss c1st cF crn cres crn c1st cB cC cxp cres crn
    wss cA cB cC cxp cF frn cF crn cB cC cxp c1st ssres2 c1st cF crn cres c1st
    cB cC cxp cres rnss 3syl c1st cB cC cxp cres crn cB wss cA cB cC cxp cF wf
    cB cC cxp cB c1st cB cC cxp cres wf c1st cB cC cxp cres crn cB wss cB cC
    f1stres cB cC cxp cB c1st cB cC cxp cres frn ax-mp a1i sstrd c1st cF rnco
    syl5ss sylanbrc $.
    $( [5-Nov-2007] $) $( [12-Oct-2007] $)

  $( Membership in a cross product.  This version requires no quantifiers or
     dummy variables.  See also ~ elxp4 . $)
  elxp6 $p |- ( A e. ( B X. C ) <-> ( A = <. ( 1st ` A ) , ( 2nd ` A ) >.
               /\ ( ( 1st ` A ) e. B /\ ( 2nd ` A ) e. C ) ) ) $=
    cA cB cC cxp wcel cA cA csn cdm cuni cA csn crn cuni cop wceq cA csn cdm
    cuni cB wcel cA csn crn cuni cC wcel wa wa cA cA c1st cfv cA c2nd cfv cop
    wceq cA c1st cfv cB wcel cA c2nd cfv cC wcel wa wa cA cB cC elxp4 cA cA
    c1st cfv cA c2nd cfv cop wceq cA cA csn cdm cuni cA csn crn cuni cop wceq
    cA c1st cfv cB wcel cA c2nd cfv cC wcel wa cA csn cdm cuni cB wcel cA csn
    crn cuni cC wcel wa cA c1st cfv cA c2nd cfv cop cA csn cdm cuni cA csn crn
    cuni cop cA cA c1st cfv cA csn cdm cuni cA c2nd cfv cA csn crn cuni cA
    1stval cA 2ndval opeq12i eqeq2i cA c1st cfv cB wcel cA csn cdm cuni cB wcel
    cA c2nd cfv cC wcel cA csn crn cuni cC wcel cA c1st cfv cA csn cdm cuni cB
    cA 1stval eleq1i cA c2nd cfv cA csn crn cuni cC cA 2ndval eleq1i anbi12i
    anbi12i bitr4i $.
    $( [14-Oct-2004] $) $( [9-Oct-2004] $)

  $( Membership in a cross product.  This version requires no quantifiers or
     dummy variables.  See also ~ elxp4 . $)
  elxp7 $p |- ( A e. ( B X. C ) <-> ( A e. ( _V X. _V )
               /\ ( ( 1st ` A ) e. B /\ ( 2nd ` A ) e. C ) ) ) $=
    cA cB cC cxp wcel cA cA c1st cfv cA c2nd cfv cop wceq cA c1st cfv cB wcel
    cA c2nd cfv cC wcel wa wa cA cvv cvv cxp wcel cA c1st cfv cB wcel cA c2nd
    cfv cC wcel wa wa cA cB cC elxp6 cA cvv cvv cxp wcel cA cA c1st cfv cA c2nd
    cfv cop wceq cA c1st cfv cB wcel cA c2nd cfv cC wcel wa cA cvv cvv cxp wcel
    cA cA c1st cfv cA c2nd cfv cop wceq cA c1st cfv cvv wcel cA c2nd cfv cvv
    wcel wa cA cvv cvv elxp6 cA c1st cfv cvv wcel cA c2nd cfv cvv wcel cA c1st
    fvex cA c2nd fvex pm3.2i mpbiran2 anbi1i bitr4i $.
    $( [19-Aug-2006] $) $( [19-Aug-2006] $)

  $( Equality with an ordered pair. $)
  eqopi $p |- ( ( A e. ( _V X. _V ) /\ ( ( 1st ` A ) = B /\ ( 2nd ` A ) = C ) )
              -> A = <. B , C >. ) $=
    cA cvv cvv cxp wcel cA c1st cfv cB wceq cA c2nd cfv cC wceq wa cA cA c1st
    cfv cA c2nd cfv cop cB cC cop cA cvv cvv cxp wcel cA cA c1st cfv cA c2nd
    cfv cop wceq cA c1st cfv cvv wcel cA c2nd cfv cvv wcel wa cA cvv cvv elxp6
    pm3.26bi cA c1st cfv cA c2nd cfv cB cC opeq12 sylan9eq $.
    $( [16-Dec-2008] $) $( [15-Dec-2008] $)

  ${
    eqop.1 $e |- C e. _V $.
    $( Two ways to express equality with an ordered pair. $)
    eqop $p |- ( A e. ( _V X. _V ) -> ( A = <. B , C >. <->
               ( ( 1st ` A ) = B /\ ( 2nd ` A ) = C ) ) ) $=
      cA cvv cvv cxp wcel cA cB cC cop wceq cA c1st cfv cB wceq cA c2nd cfv cC
      wceq wa cA cvv cvv cxp wcel cA cB cC cop wceq cB cvv wcel cA c1st cfv cB
      wceq cA c2nd cfv cC wceq wa cA cvv cvv cxp wcel cA cB cC cop wceq wa cB
      cC cop cvv cvv cxp wcel cB cvv wcel cA cB cC cop wceq cA cvv cvv cxp wcel
      cB cC cop cvv cvv cxp wcel cA cB cC cop cvv cvv cxp eleq1 biimpac cB cC
      cvv cvv opelxp1 syl cB cvv wcel cA cB cC cop wceq wa cA c1st cfv cB wceq
      cA c2nd cfv cC wceq cA cB cC cop wceq cB cvv wcel cA c1st cfv cB cC cop
      c1st cfv cB cA cB cC cop c1st fveq2 cB cC cvv op1stg sylan9eqr cA cB cC
      cop wceq cB cvv wcel cA c2nd cfv cB cC cop c2nd cfv cC cA cB cC cop c2nd
      fveq2 cB cvv wcel cC cvv wcel cB cC cop c2nd cfv cC wceq eqop.1 cB cC cvv
      cvv op2ndg mpan2 sylan9eqr jca sylancom cA cB cC eqopi impbida $.
      $( [6-Sep-2007] $) $( [3-Sep-2007] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Representation of cross product based on ordered pair component
       functions. $)
    xp2 $p |- ( A X. B ) = { x e. ( _V X. _V ) | ( ( 1st ` x ) e. A /\
              ( 2nd ` x ) e. B ) } $=
      cA cB cxp vx cv cvv cvv cxp wcel vx cv c1st cfv cA wcel vx cv c2nd cfv cB
      wcel wa wa vx cab vx cv c1st cfv cA wcel vx cv c2nd cfv cB wcel wa vx cvv
      cvv cxp crab vx cv cvv cvv cxp wcel vx cv c1st cfv cA wcel vx cv c2nd cfv
      cB wcel wa wa vx cA cB cxp vx cv cA cB elxp7 abbi2i vx cv c1st cfv cA
      wcel vx cv c2nd cfv cB wcel wa vx cvv cvv cxp df-rab eqtr4i $.
      $( [23-Oct-2006] $) $( [16-Sep-2006] $)
  $}

  $( An ordered pair theorem for members of cross products. $)
  xpopth $p |- ( ( A e. ( C X. D ) /\ B e. ( R X. S ) ) ->
       ( ( ( 1st ` A ) = ( 1st ` B ) /\
     ( 2nd ` A ) = ( 2nd ` B ) ) <-> A = B ) ) $=
    cA cC cD cxp wcel cB cR cS cxp wcel wa cA cB wceq cA c1st cfv cA c2nd cfv
    cop cB c1st cfv cB c2nd cfv cop wceq cA c1st cfv cB c1st cfv wceq cA c2nd
    cfv cB c2nd cfv wceq wa cA cC cD cxp wcel cB cR cS cxp wcel cA cA c1st cfv
    cA c2nd cfv cop cB cB c1st cfv cB c2nd cfv cop cA cC cD cxp wcel cA cA c1st
    cfv cA c2nd cfv cop wceq cA c1st cfv cC wcel cA c2nd cfv cD wcel wa cA cC
    cD elxp6 pm3.26bi cB cR cS cxp wcel cB cB c1st cfv cB c2nd cfv cop wceq cB
    c1st cfv cR wcel cB c2nd cfv cS wcel wa cB cR cS elxp6 pm3.26bi eqeqan12d
    cA c1st cfv cA c2nd cfv cB c1st cfv cB c2nd cfv cA c1st fvex cA c2nd fvex
    cB c2nd fvex opth syl6rbb $.
    $( [1-Jul-2007] $) $( [20-Jun-2007] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( The membership relation for a cross product is inherited by union. $)
    unielxp $p |- ( A e. ( B X. C ) -> U. A e. U. ( B X. C ) ) $=
      cA cB cC cxp wcel cA cvv cvv cxp wcel cA c1st cfv cB wcel cA c2nd cfv cC
      wcel wa wa cA cuni cB cC cxp cuni wcel cA cB cC elxp7 cA cuni cA wcel cA
      cvv cvv cxp wcel cA c1st cfv cB wcel cA c2nd cfv cC wcel wa wa cA cuni cB
      cC cxp cuni wcel cA cvv cvv cxp wcel cA cuni cA wcel cA c1st cfv cB wcel
      cA c2nd cfv cC wcel wa cA elvvuni adantr cA cuni cA wcel cA cvv cvv cxp
      wcel cA c1st cfv cB wcel cA c2nd cfv cC wcel wa wa wa cA cuni vx cv cvv
      cvv cxp wcel vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa wa vx cab
      cuni cB cC cxp cuni cA cuni cA wcel cA cvv cvv cxp wcel cA c1st cfv cB
      wcel cA c2nd cfv cC wcel wa wa wa cA cuni vx cv wcel vx cv cvv cvv cxp
      wcel vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa wa wa vx wex cA
      cuni vx cv cvv cvv cxp wcel vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel
      wa wa vx cab cuni wcel cA cvv cvv cxp wcel cA cuni cA wcel cA cvv cvv cxp
      wcel cA c1st cfv cB wcel cA c2nd cfv cC wcel wa wa wa cA cuni vx cv wcel
      vx cv cvv cvv cxp wcel vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa
      wa wa vx wex cA cuni cA wcel cA cvv cvv cxp wcel cA c1st cfv cB wcel cA
      c2nd cfv cC wcel wa simprl cA cuni vx cv wcel vx cv cvv cvv cxp wcel vx
      cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa wa wa cA cuni cA wcel cA
      cvv cvv cxp wcel cA c1st cfv cB wcel cA c2nd cfv cC wcel wa wa wa vx cA
      cvv cvv cxp vx cv cA wceq cA cuni vx cv wcel cA cuni cA wcel vx cv cvv
      cvv cxp wcel vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa wa cA cvv
      cvv cxp wcel cA c1st cfv cB wcel cA c2nd cfv cC wcel wa wa vx cv cA cA
      cuni eleq2 vx cv cA wceq vx cv cvv cvv cxp wcel cA cvv cvv cxp wcel vx cv
      c1st cfv cB wcel vx cv c2nd cfv cC wcel wa cA c1st cfv cB wcel cA c2nd
      cfv cC wcel wa vx cv cA cvv cvv cxp eleq1 vx cv cA wceq vx cv c1st cfv cB
      wcel cA c1st cfv cB wcel vx cv c2nd cfv cC wcel cA c2nd cfv cC wcel vx cv
      cA wceq vx cv c1st cfv cA c1st cfv cB vx cv cA c1st fveq2 eleq1d vx cv cA
      wceq vx cv c2nd cfv cA c2nd cfv cC vx cv cA c2nd fveq2 eleq1d anbi12d
      anbi12d anbi12d cla4egv mpcom vx cv cvv cvv cxp wcel vx cv c1st cfv cB
      wcel vx cv c2nd cfv cC wcel wa wa vx cA cuni eluniab sylibr cB cC cxp vx
      cv cvv cvv cxp wcel vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa wa
      vx cab cB cC cxp vx cv c1st cfv cB wcel vx cv c2nd cfv cC wcel wa vx cvv
      cvv cxp crab vx cv cvv cvv cxp wcel vx cv c1st cfv cB wcel vx cv c2nd cfv
      cC wcel wa wa vx cab vx cB cC xp2 vx cv c1st cfv cB wcel vx cv c2nd cfv
      cC wcel wa vx cvv cvv cxp df-rab eqtri unieqi syl6eleqr mpancom sylbi $.
      $( [14-Nov-2006] $) $( [16-Sep-2006] $)
  $}

  $( Reconstruction of a member of a relation in terms of its ordered pair
     components. $)
  1st2nd $p |- ( ( Rel B /\ A e. B ) ->
               A = <. ( 1st ` A ) , ( 2nd ` A ) >. ) $=
    cB wrel cA cB wcel wa cA cvv cvv cxp wcel cA cA c1st cfv cA c2nd cfv cop
    wceq cB cvv cvv cxp wss cA cB wcel cA cvv cvv cxp wcel cB wrel cB cvv cvv
    cxp cA ssel2 cB df-rel sylanb cA cvv cvv cxp wcel cA cA c1st cfv cA c2nd
    cfv cop wceq cA c1st cfv cvv wcel cA c2nd cfv cvv wcel wa cA cvv cvv elxp6
    pm3.26bi syl $.
    $( [30-Aug-2006] $) $( [29-Aug-2006] $)

  $( The first ordered pair component of a member of a relation belongs to
     the domain of the relation. $)
  1stdm $p |- ( ( Rel R /\ A e. R ) -> ( 1st ` A ) e. dom R ) $=
    cR wrel cA cR wcel wa cA c1st cfv cA cint cint cR cdm cR wrel cA cR wcel wa
    cA cvv cvv cxp wcel cA c1st cfv cA cint cint wceq cR wrel cA cR wcel cA cvv
    cvv cxp wcel cR wrel cR cvv cvv cxp cA cR wrel cR cvv cvv cxp wss cR df-rel
    biimpi sseld imp cA 1stval2 syl cR cA elreldm eqeltrd $.
    $( [11-Jul-2007] $) $( [17-Sep-2006] $)

  $( The second ordered pair component of a member of a relation belongs to
     the range of the relation. $)
  2ndrn $p |- ( ( Rel R /\ A e. R ) -> ( 2nd ` A ) e. ran R ) $=
    cR wrel cA cR wcel wa cA c1st cfv cA c2nd cfv cop cR wcel cA c2nd cfv cR
    crn wcel cR wrel cA cR wcel wa cA cA c1st cfv cA c2nd cfv cop cR cA cR
    1st2nd cR wrel cA cR wcel pm3.27 eqeltrrd cA c1st cfv cA c2nd cfv cR cA
    c1st fvex cA c2nd fvex opelrn syl $.
    $( [15-Aug-2007] $) $( [17-Sep-2006] $)

  $( Equality theorem for substitution of a class for an ordered pair (analog
     of ~ sbceq1a , that avoids the existential quantifiers of ~ copsexg ). $)
  sbcopeq1a $p |- ( <. x , y >. = A -> ( ph <->
                  [ ( 1st ` A ) / x ] [ ( 2nd ` A ) / y ] ph ) ) $=
    vy cv cA c2nd cfv wceq vx cv cA c1st cfv wceq wph wph vy cA c2nd cfv wsbc
    vx cA c1st cfv wsbc wb vx cv vy cv cop cA wceq vy cv cA c2nd cfv wceq wph
    wph vy cA c2nd cfv wsbc vx cv cA c1st cfv wceq wph vy cA c2nd cfv wsbc vx
    cA c1st cfv wsbc wph vy cA c2nd cfv sbceq1a wph vy cA c2nd cfv wsbc vx cA
    c1st cfv sbceq1a sylan9bb vx cv vy cv cop cA wceq vx cv vy cv cop c2nd cfv
    cA c2nd cfv vy cv vx cv vy cv cop cA c2nd fveq2 vx cv vy cv vx visset vy
    visset op2nd syl5eqr vx cv vy cv cop cA wceq vx cv vy cv cop c1st cfv cA
    c1st cfv vx cv vx cv vy cv cop cA c1st fveq2 vx cv vy cv vx visset op1st
    syl5eqr sylanc $.
    $( [19-Jul-2007] $) $( [19-Aug-2006] $)

  $( Equality theorem for substitution of a class ` A ` for an ordered pair
     ` <. x , y >. ` in ` B ` (analog of ~ csbeq1a ). $)
  csbopeq1a $p |- ( <. x , y >. = A -> B =
                  [_ ( 1st ` A ) / x ]_ [_ ( 2nd ` A ) / y ]_ B ) $=
    vy cv cA c2nd cfv wceq vx cv cA c1st cfv wceq cB vx cA c1st cfv vy cA c2nd
    cfv cB csb csb wceq vx cv vy cv cop cA wceq vy cv cA c2nd cfv wceq vx cv cA
    c1st cfv wceq cB vy cA c2nd cfv cB csb vx cA c1st cfv vy cA c2nd cfv cB csb
    csb vy cA c2nd cfv cB csbeq1a vx cA c1st cfv vy cA c2nd cfv cB csb csbeq1a
    sylan9eq vx cv vy cv cop cA wceq vx cv vy cv cop c2nd cfv cA c2nd cfv vy cv
    vx cv vy cv cop cA c2nd fveq2 vx cv vy cv vx visset vy visset op2nd syl5eqr
    vx cv vy cv cop cA wceq vx cv vy cv cop c1st cfv cA c1st cfv vx cv vx cv vy
    cv cop cA c1st fveq2 vx cv vy cv vx visset op1st syl5eqr sylanc $.
    $( [22-Aug-2006] $) $( [19-Aug-2006] $)

  ${
    $d z ph $.  $d x y z $.
    $( A way to define an ordered-pair class abstraction without using
       existential quantifiers. $)
    dfopab2 $p |- { <. x , y >. | ph } = { z | ( z e. ( _V X. _V ) /\
                  [ ( 1st ` z ) / x ] [ ( 2nd ` z ) / y ] ph ) } $=
      wph vx vy copab vz cv vx cv vy cv cop wceq wph wa vy wex vx wex vz cab vz
      cv cvv cvv cxp wcel wph vy vz cv c2nd cfv wsbc vx vz cv c1st cfv wsbc wa
      vz cab wph vx vy vz df-opab vz cv vx cv vy cv cop wceq wph wa vy wex vx
      wex vz cv cvv cvv cxp wcel wph vy vz cv c2nd cfv wsbc vx vz cv c1st cfv
      wsbc wa vz vz cv vx cv vy cv cop wceq vy wex wph vy vz cv c2nd cfv wsbc
      vx vz cv c1st cfv wsbc wa vx wex vz cv vx cv vy cv cop wceq vy wex vx wex
      wph vy vz cv c2nd cfv wsbc vx vz cv c1st cfv wsbc wa vz cv vx cv vy cv
      cop wceq wph wa vy wex vx wex vz cv cvv cvv cxp wcel wph vy vz cv c2nd
      cfv wsbc vx vz cv c1st cfv wsbc wa vz cv vx cv vy cv cop wceq vy wex wph
      vy vz cv c2nd cfv wsbc vx vz cv c1st cfv wsbc vx wph vy vz cv c2nd cfv
      wsbc vx vz cv c1st cfv vz cv c1st fvex hbsbc1v 19.41 vz cv vx cv vy cv
      cop wceq wph wa vy wex vz cv vx cv vy cv cop wceq vy wex wph vy vz cv
      c2nd cfv wsbc vx vz cv c1st cfv wsbc wa vx vz cv vx cv vy cv cop wceq wph
      wa vy wex vz cv vx cv vy cv cop wceq wph vy vz cv c2nd cfv wsbc vx vz cv
      c1st cfv wsbc wa vy wex vz cv vx cv vy cv cop wceq vy wex wph vy vz cv
      c2nd cfv wsbc vx vz cv c1st cfv wsbc wa vz cv vx cv vy cv cop wceq wph wa
      vz cv vx cv vy cv cop wceq wph vy vz cv c2nd cfv wsbc vx vz cv c1st cfv
      wsbc wa vy vz cv vx cv vy cv cop wceq wph wph vy vz cv c2nd cfv wsbc vx
      vz cv c1st cfv wsbc vz cv vx cv vy cv cop wceq wph wph vy vz cv c2nd cfv
      wsbc wph vy vz cv c2nd cfv wsbc vx vz cv c1st cfv wsbc vz cv vx cv vy cv
      cop wceq vy cv vz cv c2nd cfv wceq wph wph vy vz cv c2nd cfv wsbc wb vz
      cv vx cv vy cv cop wceq vz cv c2nd cfv vx cv vy cv cop c2nd cfv vy cv vz
      cv vx cv vy cv cop c2nd fveq2 vx cv vy cv vx visset vy visset op2nd
      syl6req wph vy vz cv c2nd cfv sbceq1a syl vz cv vx cv vy cv cop wceq vx
      cv vz cv c1st cfv wceq wph vy vz cv c2nd cfv wsbc wph vy vz cv c2nd cfv
      wsbc vx vz cv c1st cfv wsbc wb vz cv vx cv vy cv cop wceq vz cv c1st cfv
      vx cv vy cv cop c1st cfv vx cv vz cv vx cv vy cv cop c1st fveq2 vx cv vy
      cv vx visset op1st syl6req wph vy vz cv c2nd cfv wsbc vx vz cv c1st cfv
      sbceq1a syl bitrd pm5.32i exbii vz cv vx cv vy cv cop wceq wph vy vz cv
      c2nd cfv wsbc vx vz cv c1st cfv wsbc vy vz cv c1st cfv cvv wcel wph vy vz
      cv c2nd cfv wsbc vx vz cv c1st cfv wsbc wph vy vz cv c2nd cfv wsbc vx vz
      cv c1st cfv wsbc vy wal wi vz cv c1st fvex wph vy vz cv c2nd cfv wsbc vy
      vx vx vz cv c1st cfv cvv vx cv vz cv c1st cfv wcel vy ax-17 wph vy vz cv
      c2nd cfv vz cv c2nd fvex hbsbc1v hbsbcg ax-mp 19.41 bitri exbii vz cv cvv
      cvv cxp wcel vz cv vx cv vy cv cop wceq vy wex vx wex wph vy vz cv c2nd
      cfv wsbc vx vz cv c1st cfv wsbc vx vy vz cv elvv anbi1i 3bitr4i abbii
      eqtri $.
      $( [19-Oct-2006] $) $( [18-Aug-2006] $)
  $}

  ${
    $d w ph $.  $d x y z w $.
    $( A way to define an operation class abstraction without using existential
       quantifiers. $)
    dfoprab3 $p |- { <. <. x , y >. , z >. | ph } = { <. w , z >. |
       ( w e. ( _V X. _V ) /\ [ ( 1st ` w ) / x ] [ ( 2nd ` w ) / y ] ph ) } $=
      wph vx vy vz copab2 vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw vz
      copab vw cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv
      wsbc wa vw vz copab wph vx vy vz vw dfoprab2 vw cv vx cv vy cv cop wceq
      wph wa vy wex vx wex vw cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx
      vw cv c1st cfv wsbc wa vw vz vw cv vx cv vy cv cop wceq vy wex wph vy vw
      cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vx wex vw cv vx cv vy cv cop
      wceq vy wex vx wex wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa
      vw cv vx cv vy cv cop wceq wph wa vy wex vx wex vw cv cvv cvv cxp wcel
      wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vw cv vx cv vy cv
      cop wceq vy wex wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc vx wph
      vy vw cv c2nd cfv wsbc vx vw cv c1st cfv vw cv c1st fvex hbsbc1v 19.41 vw
      cv vx cv vy cv cop wceq wph wa vy wex vw cv vx cv vy cv cop wceq vy wex
      wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vx vw cv vx cv vy cv
      cop wceq wph wa vy wex vw cv vx cv vy cv cop wceq wph vy vw cv c2nd cfv
      wsbc vx vw cv c1st cfv wsbc wa vy wex vw cv vx cv vy cv cop wceq vy wex
      wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vw cv vx cv vy cv
      cop wceq wph wa vw cv vx cv vy cv cop wceq wph vy vw cv c2nd cfv wsbc vx
      vw cv c1st cfv wsbc wa vy vw cv vx cv vy cv cop wceq wph wph vy vw cv
      c2nd cfv wsbc vx vw cv c1st cfv wsbc vw cv vx cv vy cv cop wceq wph wph
      vy vw cv c2nd cfv wsbc wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc
      vw cv vx cv vy cv cop wceq vy cv vw cv c2nd cfv wceq wph wph vy vw cv
      c2nd cfv wsbc wb vw cv vx cv vy cv cop wceq vw cv c2nd cfv vx cv vy cv
      cop c2nd cfv vy cv vw cv vx cv vy cv cop c2nd fveq2 vx cv vy cv vx visset
      vy visset op2nd syl6req wph vy vw cv c2nd cfv sbceq1a syl vw cv vx cv vy
      cv cop wceq vx cv vw cv c1st cfv wceq wph vy vw cv c2nd cfv wsbc wph vy
      vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wb vw cv vx cv vy cv cop wceq
      vw cv c1st cfv vx cv vy cv cop c1st cfv vx cv vw cv vx cv vy cv cop c1st
      fveq2 vx cv vy cv vx visset op1st syl6req wph vy vw cv c2nd cfv wsbc vx
      vw cv c1st cfv sbceq1a syl bitrd pm5.32i exbii vw cv vx cv vy cv cop wceq
      wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc vy vw cv c1st cfv cvv
      wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wph vy vw cv c2nd
      cfv wsbc vx vw cv c1st cfv wsbc vy wal wi vw cv c1st fvex wph vy vw cv
      c2nd cfv wsbc vy vx vx vw cv c1st cfv cvv vx cv vw cv c1st cfv wcel vy
      ax-17 wph vy vw cv c2nd cfv vw cv c2nd fvex hbsbc1v hbsbcg ax-mp 19.41
      bitri exbii vw cv cvv cvv cxp wcel vw cv vx cv vy cv cop wceq vy wex vx
      wex wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc vx vy vw cv elvv
      anbi1i 3bitr4i opabbii eqtri $.
      $( [7-Sep-2006] $) $( [18-Aug-2006] $)
  $}

  ${
    $d w ph $.  $d x y ps $.  $d x y z w $.
    dfoprab3s.1 $e |- ( <. x , y >. = w -> ( ph <-> ps ) ) $.
    $( Operation class abstraction expressed without existential
       quantifiers. $)
    dfoprab3s $p |- { <. <. x , y >. , z >. | ph }
                    = { <. w , z >. | ( w e. ( _V X. _V ) /\ ps ) } $=
      wph vx vy vz copab2 vw cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx
      vw cv c1st cfv wsbc wa vw vz copab vw cv cvv cvv cxp wcel wps wa vw vz
      copab wph vx vy vz vw dfoprab3 vw cv cvv cvv cxp wcel wph vy vw cv c2nd
      cfv wsbc vx vw cv c1st cfv wsbc wa vw cv cvv cvv cxp wcel wps wa vw vz vw
      cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wps
      vw cv cvv cvv cxp wcel wph wps vx vy vw cv c1st cfv vw cv c2nd cfv vw cv
      c1st fvex vw cv c2nd fvex vw cv cvv cvv cxp wcel vx cv vw cv c1st cfv
      wceq vy cv vw cv c2nd cfv wceq wa wph wps wb vw cv cvv cvv cxp wcel vx cv
      vw cv c1st cfv wceq vy cv vw cv c2nd cfv wceq wa wa vx cv vy cv cop vw cv
      wceq wph wps wb vw cv cvv cvv cxp wcel vx cv vw cv c1st cfv wceq vy cv vw
      cv c2nd cfv wceq wa wa vw cv vx cv vy cv cop vw cv cvv cvv cxp wcel vw cv
      c1st cfv vx cv wceq vw cv c2nd cfv vy cv wceq wa vw cv vx cv vy cv cop
      wceq vx cv vw cv c1st cfv wceq vy cv vw cv c2nd cfv wceq wa vw cv vx cv
      vy cv eqopi vx cv vw cv c1st cfv wceq vw cv c1st cfv vx cv wceq vy cv vw
      cv c2nd cfv wceq vw cv c2nd cfv vy cv wceq vx cv vw cv c1st cfv eqcom vy
      cv vw cv c2nd cfv eqcom anbi12i sylan2b eqcomd dfoprab3s.1 syl ex
      sbc2iedv pm5.32i opabbii eqtri $.
      $( [1-Jan-2009] $) $( [16-Dec-2008] $)
  $}

  ${
    $d w x y A $.  $d w x y B $.  $d w C $.  $d x y D $.  $d w x y z $.
    dfoprab4s.1 $e |- ( <. x , y >. = w -> C = D ) $.
    $( Operation class abstraction expressed without existential
       quantifiers. $)
    dfoprab4s $p |- { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ z = C )
           } = { <. w , z >. | ( w e. ( A X. B ) /\ z = D ) } $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 vw cv cvv
      cvv cxp wcel vw cv cA cB cxp wcel vz cv cD wceq wa wa vw vz copab vw cv
      cA cB cxp wcel vz cv cD wceq wa vw vz copab vx cv cA wcel vy cv cB wcel
      wa vz cv cC wceq wa vw cv cA cB cxp wcel vz cv cD wceq wa vx vy vz vw vx
      cv vy cv cop vw cv wceq vx cv cA wcel vy cv cB wcel wa vw cv cA cB cxp
      wcel vz cv cC wceq vz cv cD wceq vx cv vy cv cop vw cv wceq vx cv vy cv
      cop cA cB cxp wcel vw cv cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa vx
      cv vy cv cop vw cv cA cB cxp eleq1 vx cv vy cv cA cB vy visset opelxp
      syl5bbr vx cv vy cv cop vw cv wceq cC cD vz cv dfoprab4s.1 eqeq2d anbi12d
      dfoprab3s vw cv cA cB cxp wcel vz cv cD wceq wa vw cv cvv cvv cxp wcel vw
      cv cA cB cxp wcel vz cv cD wceq wa wa vw vz vw cv cA cB cxp wcel vz cv cD
      wceq wa vw cv cvv cvv cxp wcel vw cv cA cB cxp wcel vw cv cvv cvv cxp
      wcel vz cv cD wceq cA cB cxp cvv cvv cxp vw cv cA cB xpss sseli adantr
      pm4.71ri opabbii eqtr4i $.
      $( [4-Jan-2009] $) $( [3-Sep-2007] $)
  $}

  ${
    $d w x y A $.  $d w x y B $.  $d w C $.  $d x y D $.  $d w x y z $.
    dfoprab5s.1 $e |- ( ( x = ( 1st ` w ) /\ y = ( 2nd ` w ) ) -> C = D ) $.
    $( Operation class abstraction expressed without existential
       quantifiers. $)
    dfoprab5s $p |- { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ z = C )
           } = { <. w , z >. | ( w e. ( A X. B ) /\ z = D ) } $=
      vx vy vz vw cA cB cC cD vx cv vw cv c1st cfv wceq vy cv vw cv c2nd cfv
      wceq cC cD wceq vx cv vy cv cop vw cv wceq dfoprab5s.1 vx cv vy cv cop vw
      cv wceq vx cv vy cv cop c1st cfv vw cv c1st cfv vx cv vx cv vy cv cop vw
      cv c1st fveq2 vx cv vy cv vx visset op1st syl5eqr vx cv vy cv cop vw cv
      wceq vx cv vy cv cop c2nd cfv vw cv c2nd cfv vy cv vx cv vy cv cop vw cv
      c2nd fveq2 vx cv vy cv vx visset vy visset op2nd syl5eqr sylanc dfoprab4s
      $.
      $( [11-Sep-2007] $) $( [27-Aug-2007] $)
  $}

  ${
    $d t u v w x y A $.  $d t u v w x y B $.  $d s t u w C $.  $d t u v D $.
    $d s t u v w x y z $.
    dfoprab5sf.x $e |- ( v e. D -> A. x v e. D ) $.
    dfoprab5sf.y $e |- ( v e. D -> A. y v e. D ) $.
    dfoprab5sf.1 $e |- ( ( x = ( 1st ` w ) /\ y = ( 2nd ` w ) ) -> C = D ) $.
    $( Operation class abstraction expressed without existential
       quantifiers. $)
    dfoprab5sf $p |- { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\
           z = C ) } = { <. w , z >. | ( w e. ( A X. B ) /\ z = D ) } $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 vt cv cA
      wcel vu cv cB wcel wa vz cv vx vt cv vy vu cv cC csb csb wceq wa vt vu vz
      copab2 vw cv cA cB cxp wcel vz cv cD wceq wa vw vz copab vx cv cA wcel vy
      cv cB wcel wa vz cv cC wceq wa vt cv cA wcel vu cv cB wcel wa vz cv vx vt
      cv vy vu cv cC csb csb wceq wa vx vy vz vt vu vx cv cA wcel vy cv cB wcel
      wa vz cv cC wceq wa vt ax-17 vx cv cA wcel vy cv cB wcel wa vz cv cC wceq
      wa vu ax-17 vt cv cA wcel vu cv cB wcel wa vz cv vx vt cv vy vu cv cC csb
      csb wceq vx vt cv cA wcel vu cv cB wcel wa vx ax-17 vx vs vs vz cv vx vt
      cv vy vu cv cC csb csb vs cv vz cv wcel vx ax-17 vx vs vt cv vy vu cv cC
      csb vt visset vs cv vt cv wcel vx ax-17 hbcsb1 hbeq hban vt cv cA wcel vu
      cv cB wcel wa vz cv vx vt cv vy vu cv cC csb csb wceq vy vt cv cA wcel vu
      cv cB wcel wa vy ax-17 vy vs vs vz cv vx vt cv vy vu cv cC csb csb vs cv
      vz cv wcel vy ax-17 vt cv cvv wcel vs cv vx vt cv vy vu cv cC csb csb
      wcel vs cv vx vt cv vy vu cv cC csb csb wcel vy wal wi vt visset vy vx vs
      vt cv vy vu cv cC csb cvv vs cv vt cv wcel vy ax-17 vy vs vu cv cC vu
      visset vs cv vu cv wcel vy ax-17 hbcsb1 hbcsbg ax-mp hbeq hban vx cv vt
      cv wceq vy cv vu cv wceq wa vx cv cA wcel vy cv cB wcel wa vt cv cA wcel
      vu cv cB wcel wa vz cv cC wceq vz cv vx vt cv vy vu cv cC csb csb wceq vx
      cv vt cv wceq vx cv cA wcel vt cv cA wcel vy cv vu cv wceq vy cv cB wcel
      vu cv cB wcel vx cv vt cv cA eleq1 vy cv vu cv cB eleq1 bi2anan9 vx cv vt
      cv wceq vy cv vu cv wceq wa cC vx vt cv vy vu cv cC csb csb vz cv vy cv
      vu cv wceq vx cv vt cv wceq cC vy vu cv cC csb vx vt cv vy vu cv cC csb
      csb vy vu cv cC csbeq1a vx vt cv vy vu cv cC csb csbeq1a sylan9eqr eqeq2d
      anbi12d cbvoprab12 vt vu vz vw cA cB vx vt cv vy vu cv cC csb csb cD vt
      cv vw cv c1st cfv wceq vu cv vw cv c2nd cfv wceq wa vx cv vt cv wceq vx
      cv vw cv c1st cfv wceq wa vy cv vu cv wceq vy cv vw cv c2nd cfv wceq wa
      wa vy wex vx wex vx vt cv vy vu cv cC csb csb cD wceq vt cv vw cv c1st
      cfv wceq vu cv vw cv c2nd cfv wceq wa vx cv vt cv wceq vx cv vw cv c1st
      cfv wceq wa vx wex vy cv vu cv wceq vy cv vw cv c2nd cfv wceq wa vy wex
      wa vx cv vt cv wceq vx cv vw cv c1st cfv wceq wa vy cv vu cv wceq vy cv
      vw cv c2nd cfv wceq wa wa vy wex vx wex vt cv vw cv c1st cfv wceq vx cv
      vt cv wceq vx cv vw cv c1st cfv wceq wa vx wex vu cv vw cv c2nd cfv wceq
      vy cv vu cv wceq vy cv vw cv c2nd cfv wceq wa vy wex vx vt cv vw cv c1st
      cfv vt visset eqvinc vy vu cv vw cv c2nd cfv vu visset eqvinc anbi12i vx
      cv vt cv wceq vx cv vw cv c1st cfv wceq wa vy cv vu cv wceq vy cv vw cv
      c2nd cfv wceq wa wa vy wex vx wex vx cv vt cv wceq vx cv vw cv c1st cfv
      wceq wa vx wex vy cv vu cv wceq vy cv vw cv c2nd cfv wceq wa vy wex wa vx
      cv vt cv wceq vx cv vw cv c1st cfv wceq wa vy cv vu cv wceq vy cv vw cv
      c2nd cfv wceq wa vx vy eeanv bicomi bitri vx cv vt cv wceq vx cv vw cv
      c1st cfv wceq wa vy cv vu cv wceq vy cv vw cv c2nd cfv wceq wa wa vy wex
      vx vt cv vy vu cv cC csb csb cD wceq vx vx vs vv vx vt cv vy vu cv cC csb
      csb cD vx vs vt cv vy vu cv cC csb vt visset vs cv vt cv wcel vx ax-17
      hbcsb1 dfoprab5sf.x hbeq vx cv vt cv wceq vx cv vw cv c1st cfv wceq wa vy
      cv vu cv wceq vy cv vw cv c2nd cfv wceq wa wa vx vt cv vy vu cv cC csb
      csb cD wceq vy vy vs vv vx vt cv vy vu cv cC csb csb cD vt cv cvv wcel vs
      cv vx vt cv vy vu cv cC csb csb wcel vs cv vx vt cv vy vu cv cC csb csb
      wcel vy wal wi vt visset vy vx vs vt cv vy vu cv cC csb cvv vs cv vt cv
      wcel vy ax-17 vy vs vu cv cC vu visset vs cv vu cv wcel vy ax-17 hbcsb1
      hbcsbg ax-mp dfoprab5sf.y hbeq vx cv vt cv wceq vy cv vu cv wceq vx cv vw
      cv c1st cfv wceq vy cv vw cv c2nd cfv wceq vx vt cv vy vu cv cC csb csb
      cD wceq vx cv vt cv wceq vy cv vu cv wceq wa vx cv vw cv c1st cfv wceq vy
      cv vw cv c2nd cfv wceq wa vx vt cv vy vu cv cC csb csb cC cD vx cv vt cv
      wceq vy cv vu cv wceq wa cC vx vt cv vy vu cv cC csb csb vy cv vu cv wceq
      vx cv vt cv wceq cC vy vu cv cC csb vx vt cv vy vu cv cC csb csb vy vu cv
      cC csbeq1a vx vt cv vy vu cv cC csb csbeq1a sylan9eqr eqcomd dfoprab5sf.1
      sylan9eq an4s 19.23ai 19.23ai sylbi dfoprab5s eqtri $.
      $( [3-Feb-2009] $) $( [20-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d x y ch $.
    elopabi.1 $e |- ( x = ( 1st ` A ) -> ( ph <-> ps ) ) $.
    elopabi.2 $e |- ( y = ( 2nd ` A ) -> ( ps <-> ch ) ) $.
    $( A consequence of membership in an ordered-pair class abstraction, using
       ordered pair extractors. $)
    elopabi $p |- ( A e. { <. x , y >. | ph } -> ch ) $=
      cA wph vx vy copab wcel cA cA c1st cfv cA c2nd cfv cop wceq wch wph vx vy
      copab wrel cA wph vx vy copab wcel cA cA c1st cfv cA c2nd cfv cop wceq
      wph vx vy relopab cA wph vx vy copab 1st2nd mpan cA cA c1st cfv cA c2nd
      cfv cop wceq cA wph vx vy copab wcel wch cA cA c1st cfv cA c2nd cfv cop
      wceq cA wph vx vy copab wcel cA c1st cfv cA c2nd cfv cop wph vx vy copab
      wcel wch cA cA c1st cfv cA c2nd cfv cop wph vx vy copab eleq1 wph wps wch
      vx vy cA c1st cfv cA c2nd cfv cA c1st fvex cA c2nd fvex elopabi.1
      elopabi.2 opelopab syl6bb biimpcd mpd $.
      $( [3-Sep-2006] $) $( [29-Aug-2006] $)
  $}

  ${
    $d w x y z A $.  $d x y ch $.  $d w ph $.  $d x ps $.  $d x y z th $.
    eloprabi.1 $e |- ( x = ( 1st ` ( 1st ` A ) ) -> ( ph <-> ps ) ) $.
    eloprabi.2 $e |- ( y = ( 2nd ` ( 1st ` A ) ) -> ( ps <-> ch ) ) $.
    eloprabi.3 $e |- ( z = ( 2nd ` A ) -> ( ch <-> th ) ) $.
    $( A consequence of membership in an operation class abstraction, using
       ordered pair extractors. $)
    eloprabi $p |- ( A e. { <. <. x , y >. , z >. | ph } -> th ) $=
      cA wph vx vy vz copab2 wcel cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv
      cop cA c2nd cfv cop wceq wth cA wph vx vy vz copab2 wcel cA cA c1st cfv
      cA c2nd cfv cop cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv
      cop wph vx vy vz copab2 wrel cA wph vx vy vz copab2 wcel cA cA c1st cfv
      cA c2nd cfv cop wceq wph vx vy vz reloprab cA wph vx vy vz copab2 1st2nd
      mpan cA wph vx vy vz copab2 wcel cA c1st cfv cA c1st cfv c1st cfv cA c1st
      cfv c2nd cfv cop cA c2nd cfv cA wph vx vy vz copab2 wcel cA vw cv cvv cvv
      cxp wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vw vz copab
      wcel cA c1st cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq wph
      vx vy vz copab2 vw cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx vw
      cv c1st cfv wsbc wa vw vz copab cA wph vx vy vz vw dfoprab3 eleq2i cA vw
      cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa
      vw vz copab wcel cA vw cv cvv cvv cxp wcel vw vz copab wcel cA c1st cfv
      cvv cvv cxp wcel cA c1st cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv
      cop wceq vw cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st
      cfv wsbc wa vw vz copab vw cv cvv cvv cxp wcel vw vz copab cA vw cv cvv
      cvv cxp wcel wph vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vw cv
      cvv cvv cxp wcel vw vz vw cv cvv cvv cxp wcel wph vy vw cv c2nd cfv wsbc
      vx vw cv c1st cfv wsbc pm3.26 ssopab2i sseli vw cv cvv cvv cxp wcel cA
      c1st cfv cvv cvv cxp wcel cA c1st cfv cvv cvv cxp wcel vw vz cA vw cv cA
      c1st cfv cvv cvv cxp eleq1 vz cv cA c2nd cfv wceq cA c1st cfv cvv cvv cxp
      wcel biidd elopabi cvv cvv cxp wrel cA c1st cfv cvv cvv cxp wcel cA c1st
      cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq cvv cvv relxp cA
      c1st cfv cvv cvv cxp 1st2nd mpan 3syl sylbi opeq1d eqtrd cA cA c1st cfv
      c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv cop wceq cA wph vx vy vz
      copab2 wcel wth cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd
      cfv cop wceq cA wph vx vy vz copab2 wcel cA c1st cfv c1st cfv cA c1st cfv
      c2nd cfv cop cA c2nd cfv cop wph vx vy vz copab2 wcel wth cA cA c1st cfv
      c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv cop wph vx vy vz copab2
      eleq1 cA c1st cfv c1st cfv cvv wcel cA c1st cfv c2nd cfv cvv wcel cA c2nd
      cfv cvv wcel cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv
      cop wph vx vy vz copab2 wcel wth wb cA c1st cfv c1st fvex cA c1st cfv
      c2nd fvex cA c2nd fvex wph wps wch wth vx vy vz cA c1st cfv c1st cfv cA
      c1st cfv c2nd cfv cA c2nd cfv cvv cvv cvv eloprabi.1 eloprabi.2
      eloprabi.3 eloprabg mp3an syl6bb biimpcd mpd $.
      $( [16-Nov-2006] $) $( [6-Nov-2006] $)
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w z C $.  $d w x y z D $.
    foprab2.1 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Mapping of an operation class abstraction. $)
    foprab2 $p |- ( A. x e. A A. y e. B C e. D <-> F : ( A X. B ) --> D ) $=
      cC cD wcel vy cB wral vx cA wral vx vw cv c1st cfv vy vw cv c2nd cfv cC
      csb csb cD wcel vw cA cB cxp wral cA cB cxp cD cF wf vx vw cv c1st cfv vy
      vw cv c2nd cfv cC csb csb cD wcel cC cD wcel vw vx vy cA cB vx vz vz vx
      vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cD vx vz vw cv c1st cfv vy vw
      cv c2nd cfv cC csb vw cv c1st fvex vz cv vw cv c1st cfv wcel vx ax-17
      hbcsb1 vz cv cD wcel vx ax-17 hbel vy vz vz vx vw cv c1st cfv vy vw cv
      c2nd cfv cC csb csb cD vw cv c1st cfv cvv wcel vz cv vx vw cv c1st cfv vy
      vw cv c2nd cfv cC csb csb wcel vz cv vx vw cv c1st cfv vy vw cv c2nd cfv
      cC csb csb wcel vy wal wi vw cv c1st fvex vy vx vz vw cv c1st cfv vy vw
      cv c2nd cfv cC csb cvv vz cv vw cv c1st cfv wcel vy ax-17 vy vz vw cv
      c2nd cfv cC vw cv c2nd fvex vz cv vw cv c2nd cfv wcel vy ax-17 hbcsb1
      hbcsbg ax-mp vz cv cD wcel vy ax-17 hbel cC cD wcel vw ax-17 vw cv vx cv
      vy cv cop wceq vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cC cD vw cv
      vx cv vy cv cop wceq cC vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cC
      vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb wceq vx cv vy cv cop vw cv
      vx vy vw cv cC csbopeq1a eqcoms eqcomd eleq1d ralxpf vw vz cA cB cxp cD
      vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cF vx cv cA wcel vy cv cB
      wcel wa vz cv cC wceq wa vx vy vz copab2 vw cv cvv cvv cxp wcel vx cv cA
      wcel vy cv cB wcel wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx vw cv
      c1st cfv wsbc wa vw vz copab cF vw cv cA cB cxp wcel vz cv vx vw cv c1st
      cfv vy vw cv c2nd cfv cC csb csb wceq wa vw vz copab vx cv cA wcel vy cv
      cB wcel wa vz cv cC wceq wa vx vy vz vw dfoprab3 foprab2.1 vw cv cA cB
      cxp wcel vz cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb wceq wa vw
      cv cvv cvv cxp wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vy vw
      cv c2nd cfv wsbc vx vw cv c1st cfv wsbc wa vw vz vw cv cvv cvv cxp wcel
      vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa wa vz cv vx vw cv c1st
      cfv vy vw cv c2nd cfv cC csb csb wceq wa vw cv cvv cvv cxp wcel vw cv
      c1st cfv cA wcel vw cv c2nd cfv cB wcel wa vz cv vx vw cv c1st cfv vy vw
      cv c2nd cfv cC csb csb wceq wa wa vw cv cA cB cxp wcel vz cv vx vw cv
      c1st cfv vy vw cv c2nd cfv cC csb csb wceq wa vw cv cvv cvv cxp wcel vx
      cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx vw
      cv c1st cfv wsbc wa vw cv cvv cvv cxp wcel vw cv c1st cfv cA wcel vw cv
      c2nd cfv cB wcel wa vz cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb
      wceq anass vw cv cA cB cxp wcel vw cv cvv cvv cxp wcel vw cv c1st cfv cA
      wcel vw cv c2nd cfv cB wcel wa wa vz cv vx vw cv c1st cfv vy vw cv c2nd
      cfv cC csb csb wceq vw cv cA cB elxp7 anbi1i vx cv cA wcel vy cv cB wcel
      wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc vw cv
      c1st cfv cA wcel vw cv c2nd cfv cB wcel wa vz cv vx vw cv c1st cfv vy vw
      cv c2nd cfv cC csb csb wceq wa vw cv cvv cvv cxp wcel vx cv cA wcel vy cv
      cB wcel wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx vw cv c1st cfv wsbc
      vx cv cA wcel vw cv c2nd cfv cB wcel wa vz cv vy vw cv c2nd cfv cC csb
      wceq wa vx vw cv c1st cfv wsbc vx cv cA wcel vw cv c2nd cfv cB wcel wa vx
      vw cv c1st cfv wsbc vz cv vy vw cv c2nd cfv cC csb wceq vx vw cv c1st cfv
      wsbc wa vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa vz cv vx vw cv
      c1st cfv vy vw cv c2nd cfv cC csb csb wceq wa vw cv c1st cfv cvv wcel vx
      cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx vw
      cv c1st cfv wsbc vx cv cA wcel vw cv c2nd cfv cB wcel wa vz cv vy vw cv
      c2nd cfv cC csb wceq wa vx vw cv c1st cfv wsbc wb vw cv c1st fvex vx cv
      cA wcel vy cv cB wcel wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx cv cA
      wcel vw cv c2nd cfv cB wcel wa vz cv vy vw cv c2nd cfv cC csb wceq wa vx
      vw cv c1st cfv cvv vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vy vw
      cv c2nd cfv wsbc vx cv cA wcel vy cv cB wcel wa vy vw cv c2nd cfv wsbc vz
      cv cC wceq vy vw cv c2nd cfv wsbc wa vx cv cA wcel vw cv c2nd cfv cB wcel
      wa vz cv vy vw cv c2nd cfv cC csb wceq wa vw cv c2nd cfv cvv wcel vx cv
      cA wcel vy cv cB wcel wa vz cv cC wceq wa vy vw cv c2nd cfv wsbc vx cv cA
      wcel vy cv cB wcel wa vy vw cv c2nd cfv wsbc vz cv cC wceq vy vw cv c2nd
      cfv wsbc wa wb vw cv c2nd fvex vx cv cA wcel vy cv cB wcel wa vz cv cC
      wceq vy vw cv c2nd cfv cvv sbcang ax-mp vx cv cA wcel vy cv cB wcel wa vy
      vw cv c2nd cfv wsbc vx cv cA wcel vw cv c2nd cfv cB wcel wa vz cv cC wceq
      vy vw cv c2nd cfv wsbc vz cv vy vw cv c2nd cfv cC csb wceq vx cv cA wcel
      vy cv cB wcel wa vy vw cv c2nd cfv wsbc vx cv cA wcel vy vw cv c2nd cfv
      wsbc vy cv cB wcel vy vw cv c2nd cfv wsbc wa vx cv cA wcel vw cv c2nd cfv
      cB wcel wa vw cv c2nd cfv cvv wcel vx cv cA wcel vy cv cB wcel wa vy vw
      cv c2nd cfv wsbc vx cv cA wcel vy vw cv c2nd cfv wsbc vy cv cB wcel vy vw
      cv c2nd cfv wsbc wa wb vw cv c2nd fvex vx cv cA wcel vy cv cB wcel vy vw
      cv c2nd cfv cvv sbcang ax-mp vx cv cA wcel vy vw cv c2nd cfv wsbc vx cv
      cA wcel vy cv cB wcel vy vw cv c2nd cfv wsbc vw cv c2nd cfv cB wcel vw cv
      c2nd cfv cvv wcel vx cv cA wcel vy vw cv c2nd cfv wsbc vx cv cA wcel wb
      vw cv c2nd fvex vx cv cA wcel vy vw cv c2nd cfv cvv vx cv cA wcel vy
      ax-17 sbcgf ax-mp vw cv c2nd cfv cvv wcel vy cv cB wcel vy vw cv c2nd cfv
      wsbc vw cv c2nd cfv cB wcel wb vw cv c2nd fvex vy vw cv c2nd cfv cB cvv
      sbcel1gv ax-mp anbi12i bitri vw cv c2nd cfv cvv wcel vz cv cC wceq vy vw
      cv c2nd cfv wsbc vz cv vy vw cv c2nd cfv cC csb wceq wb vw cv c2nd fvex
      vy vw cv c2nd cfv vz cv cC cvv sbceq2dig ax-mp anbi12i bitri sbcbii ax-mp
      vw cv c1st cfv cvv wcel vx cv cA wcel vw cv c2nd cfv cB wcel wa vz cv vy
      vw cv c2nd cfv cC csb wceq wa vx vw cv c1st cfv wsbc vx cv cA wcel vw cv
      c2nd cfv cB wcel wa vx vw cv c1st cfv wsbc vz cv vy vw cv c2nd cfv cC csb
      wceq vx vw cv c1st cfv wsbc wa wb vw cv c1st fvex vx cv cA wcel vw cv
      c2nd cfv cB wcel wa vz cv vy vw cv c2nd cfv cC csb wceq vx vw cv c1st cfv
      cvv sbcang ax-mp vx cv cA wcel vw cv c2nd cfv cB wcel wa vx vw cv c1st
      cfv wsbc vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa vz cv vy vw cv
      c2nd cfv cC csb wceq vx vw cv c1st cfv wsbc vz cv vx vw cv c1st cfv vy vw
      cv c2nd cfv cC csb csb wceq vx cv cA wcel vw cv c2nd cfv cB wcel wa vx vw
      cv c1st cfv wsbc vx cv cA wcel vx vw cv c1st cfv wsbc vw cv c2nd cfv cB
      wcel vx vw cv c1st cfv wsbc wa vw cv c1st cfv cA wcel vw cv c2nd cfv cB
      wcel wa vw cv c1st cfv cvv wcel vx cv cA wcel vw cv c2nd cfv cB wcel wa
      vx vw cv c1st cfv wsbc vx cv cA wcel vx vw cv c1st cfv wsbc vw cv c2nd
      cfv cB wcel vx vw cv c1st cfv wsbc wa wb vw cv c1st fvex vx cv cA wcel vw
      cv c2nd cfv cB wcel vx vw cv c1st cfv cvv sbcang ax-mp vx cv cA wcel vx
      vw cv c1st cfv wsbc vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel vx vw
      cv c1st cfv wsbc vw cv c2nd cfv cB wcel vw cv c1st cfv cvv wcel vx cv cA
      wcel vx vw cv c1st cfv wsbc vw cv c1st cfv cA wcel wb vw cv c1st fvex vx
      vw cv c1st cfv cA cvv sbcel1gv ax-mp vw cv c1st cfv cvv wcel vw cv c2nd
      cfv cB wcel vx vw cv c1st cfv wsbc vw cv c2nd cfv cB wcel wb vw cv c1st
      fvex vw cv c2nd cfv cB wcel vx vw cv c1st cfv cvv vw cv c2nd cfv cB wcel
      vx ax-17 sbcgf ax-mp anbi12i bitri vw cv c1st cfv cvv wcel vz cv vy vw cv
      c2nd cfv cC csb wceq vx vw cv c1st cfv wsbc vz cv vx vw cv c1st cfv vy vw
      cv c2nd cfv cC csb csb wceq wb vw cv c1st fvex vx vw cv c1st cfv vz cv vy
      vw cv c2nd cfv cC csb cvv sbceq2dig ax-mp anbi12i 3bitri anbi2i 3bitr4i
      opabbii 3eqtr4i fopab2 bitr3i $.
      $( [17-Sep-2006] $) $( [18-Aug-2006] $)

    ${
      foprab.2 $e |- ( ( x e. A /\ y e. B ) -> C e. D ) $.
      $( Mapping of an operation class abstraction. $)
      foprab $p |- F : ( A X. B ) --> D $=
        cC cD wcel vy cB wral vx cA wral cA cB cxp cD cF wf cC cD wcel vx vy cA
        cB foprab.2 rgen2 vx vy vz cA cB cC cD cF foprab2.1 foprab2 mpbi $.
        $( [9-Aug-2007] $) $( [1-Jan-2007] $)
    $}
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.
    fnoprab2g.1 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Functionality and domain of an operation class abstraction. $)
    fnoprab2g $p |- ( A. x e. A A. y e. B C e. _V <-> F Fn ( A X. B ) ) $=
      cC cvv wcel vy cB wral vx cA wral cA cB cxp cvv cF wf cF cA cB cxp wfn vx
      vy vz cA cB cC cvv cF fnoprab2g.1 foprab2 cA cB cxp cF dffn2 bitr4i $.
      $( [4-Sep-2007] $) $( [29-Aug-2007] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.
    fnoprab2.1 $e |- C e. _V $.
    fnoprab2.2 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Functionality and domain of an operation class abstraction. $)
    fnoprab2 $p |- F Fn ( A X. B ) $=
      cC cvv wcel vy cB wral vx cA wral cF cA cB cxp wfn cC cvv wcel vx vy cA
      cB cC cvv wcel vx cv cA wcel vy cv cB wcel wa fnoprab2.1 a1i rgen2 vx vy
      vz cA cB cC cF fnoprab2.2 fnoprab2g mpbi $.
      $( [26-Aug-1995] $)

    $( Domain of an operation class abstraction. $)
    dmoprab2 $p |- dom F = ( A X. B ) $=
      cF cA cB cxp wfn cF cdm cA cB cxp wceq vx vy vz cA cB cC cF fnoprab2.1
      fnoprab2.2 fnoprab2 cA cB cxp cF fndm ax-mp $.
      $( [14-Nov-2004] $) $( [23-Sep-2004] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d z C $.  $d x y w v u D $.
    $d w v u F $.
    elrnoprabg.1 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Membership in the range of an operation class abstraction. $)
    elrnoprabg $p |- ( A. x e. A A. y e. B C e. R ->
                     ( D e. ran F <-> E. x e. A E. y e. B D = C ) ) $=
      cC cR wcel vy cB wral vx cA wral cF cA cB cxp wfn cD cF crn wcel cD cC
      wceq vy cB wrex vx cA wrex wb cC cR wcel vy cB wral vx cA wral cC cvv
      wcel vy cB wral vx cA wral cF cA cB cxp wfn cC cR wcel vy cB wral cC cvv
      wcel vy cB wral vx cA cC cR wcel cC cvv wcel vy cB cC cR elisset r19.20si
      r19.20si vx vy vz cA cB cC cF elrnoprabg.1 fnoprab2g sylib cF cA cB cxp
      wfn cD cF crn wcel vw cv cF cfv cD wceq vw cA cB cxp wrex cC cR wcel vy
      cB wral vx cA wral cD cC wceq vy cB wrex vx cA wrex vw cA cB cxp cD cF
      fvelrnb cC cR wcel vy cB wral vx cA wral vx cv vy cv cF co cD wceq vy cB
      wrex vx cA wrex cD cC wceq vy cB wrex vx cA wrex vw cv cF cfv cD wceq vw
      cA cB cxp wrex cC cR wcel vy cB wral vx cA wral vx cv vy cv cF co cD wceq
      vy cB wrex cD cC wceq vy cB wrex vx cA cC cR wcel vy cB wral vx cA hbra1
      cC cR wcel vy cB wral vx cA wral vx cv cA wcel wa vx cv vy cv cF co cD
      wceq cD cC wceq vy cB cC cR wcel vy cB wral vx cA wral vx cv cA wcel vy
      cC cR wcel vy cB wral vy vx cA vx cv cA wcel vy ax-17 cC cR wcel vy cB
      hbra1 hbral vx cv cA wcel vy ax-17 hban cC cR wcel vy cB wral vx cA wral
      vx cv cA wcel vy cv cB wcel vx cv vy cv cF co cD wceq cD cC wceq wb cC cR
      wcel vy cB wral vx cA wral vx cv cA wcel vy cv cB wcel vx cv vy cv cF co
      cD wceq cD cC wceq wb cC cR wcel vy cB wral vx cA wral vx cv cA wcel vy
      cv cB wcel wa cC cR wcel vx cv vy cv cF co cD wceq cD cC wceq wb cC cR
      wcel vx vy cA cB ra42 vx cv cA wcel vy cv cB wcel cC cR wcel vx cv vy cv
      cF co cD wceq cD cC wceq wb vx cv cA wcel vy cv cB wcel cC cR wcel w3a vx
      cv vy cv cF co cD wceq cC cD wceq cD cC wceq vx cv cA wcel vy cv cB wcel
      cC cR wcel w3a vx cv vy cv cF co cC cD vx vy vz cA cB cC cR cF
      elrnoprabg.1 oprabval4g eqeq1d cC cD eqcom syl6bb 3expia sylcom exp3a
      imp31 rexbida rexbida vw cv cF cfv cD wceq vw cA cB cxp wrex vv cv vu cv
      cF co cD wceq vu cB wrex vv cA wrex vx cv vu cv cF co cD wceq vu cB wrex
      vx cA wrex vx cv vy cv cF co cD wceq vy cB wrex vx cA wrex vw cv cF cfv
      cD wceq vv cv vu cv cF co cD wceq vw vv vu cA cB vw cv vv cv vu cv cop
      wceq vw cv cF cfv vv cv vu cv cF co cD vw cv vv cv vu cv cop wceq vw cv
      cF cfv vv cv vu cv cop cF cfv vv cv vu cv cF co vw cv vv cv vu cv cop cF
      fveq2 vv cv vu cv cF df-opr syl6eqr eqeq1d rexxp vv cv vu cv cF co cD
      wceq vu cB wrex vx cv vu cv cF co cD wceq vu cB wrex vv vx cA vv cv vu cv
      cF co cD wceq vx vu cB vu cv cB wcel vx ax-17 vx vw vw vv cv vu cv cF co
      cD vx vw vv cv vu cv cF vw cv vv cv wcel vx ax-17 vx vw cF vx cv cA wcel
      vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 elrnoprabg.1 vx cv cA
      wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz vw hboprab1 hbxfr vw cv
      vu cv wcel vx ax-17 hbopr vw cv cD wcel vx ax-17 hbeq hbrex vx cv vu cv
      cF co cD wceq vu cB wrex vv ax-17 vv cv vx cv wceq vv cv vu cv cF co cD
      wceq vx cv vu cv cF co cD wceq vu cB vv cv vx cv wceq vv cv vu cv cF co
      vx cv vu cv cF co cD vv cv vx cv vu cv cF opreq1 eqeq1d rexbidv cbvrex vx
      cv vu cv cF co cD wceq vu cB wrex vx cv vy cv cF co cD wceq vy cB wrex vx
      cA vx cv vu cv cF co cD wceq vx cv vy cv cF co cD wceq vu vy cB vy vw vw
      vx cv vu cv cF co cD vy vw vx cv vu cv cF vw cv vx cv wcel vy ax-17 vy vw
      cF vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2
      elrnoprabg.1 vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz vw
      hboprab2 hbxfr vw cv vu cv wcel vy ax-17 hbopr vw cv cD wcel vy ax-17
      hbeq vx cv vy cv cF co cD wceq vu ax-17 vu cv vy cv wceq vx cv vu cv cF
      co vx cv vy cv cF co cD vu cv vy cv vx cv cF opreq2 eqeq1d cbvrex rexbii
      3bitri syl5bb sylan9bbr mpdan $.
      $( [4-Sep-2007] $) $( [27-Aug-2007] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d z C $.  $d x y w v u D $.
    $d w v u F $.
    elrnoprab.1 $e |- C e. _V $.
    elrnoprab.2 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ z = C ) } $.
    $( Membership in the range of an operation class abstraction. $)
    elrnoprab $p |- ( D e. ran F <-> E. x e. A E. y e. B D = C ) $=
      cC cvv wcel vy cB wral cD cF crn wcel cD cC wceq vy cB wrex vx cA wrex wb
      vx cA vx vy vz cA cB cC cD cvv cF elrnoprab.2 elrnoprabg cC cvv wcel vy
      cB wral vx cv cA wcel cC cvv wcel vy cB cC cvv wcel vy cv cB wcel
      elrnoprab.1 a1i rgen a1i mprg $.
      $( [6-Aug-2004] $) $( [1-Aug-2004] $)
  $}

  ${
    $d w x y z $.
    $( An alternate possible definition of the ` 1st ` function. $)
    df1st2 $p |- { <. <. x , y >. , z >. | z = x } = ( 1st |` ( _V X. _V ) ) $=
      vz cv vw cv c1st cfv wceq vw vz copab cvv cvv cxp cres vw cv cvv cvv cxp
      wcel vz cv vw cv c1st cfv wceq wa vw vz copab c1st cvv cvv cxp cres vz cv
      vx cv wceq vx vy vz copab2 vz cv vw cv c1st cfv wceq vw vz cvv cvv cxp
      resopab c1st vz cv vw cv c1st cfv wceq vw vz copab wceq c1st cvv cvv cxp
      cres vz cv vw cv c1st cfv wceq vw vz copab cvv cvv cxp cres wceq c1st vw
      cv cvv wcel vz cv vw cv c1st cfv wceq wa vw vz copab vz cv vw cv c1st cfv
      wceq vw vz copab c1st cvv wfn c1st vw cv cvv wcel vz cv vw cv c1st cfv
      wceq wa vw vz copab wceq cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st
      fofn ax-mp vw vz cvv c1st dffn5 mpbi vz cv vw cv c1st cfv wceq vw cv cvv
      wcel vz cv vw cv c1st cfv wceq wa vw vz vw cv cvv wcel vz cv vw cv c1st
      cfv wceq vw visset biantrur opabbii eqtr4i c1st vz cv vw cv c1st cfv wceq
      vw vz copab cvv cvv cxp reseq1 ax-mp vz cv vx cv wceq vz cv vw cv c1st
      cfv wceq vx vy vz vw vx cv vy cv cop vw cv wceq vx cv vw cv c1st cfv vz
      cv vx cv vy cv cop vw cv wceq vx cv vy cv cop c1st cfv vw cv c1st cfv vx
      cv vx cv vy cv cop vw cv c1st fveq2 vx cv vy cv vx visset op1st syl5eqr
      eqeq2d dfoprab3s 3eqtr4ri $.
      $( [10-Jan-2009] $) $( [14-Oct-2004] $)

    $( An alternate possible definition of the ` 2nd ` function. $)
    df2nd2 $p |- { <. <. x , y >. , z >. | z = y } = ( 2nd |` ( _V X. _V ) ) $=
      vz cv vw cv c2nd cfv wceq vw vz copab cvv cvv cxp cres vw cv cvv cvv cxp
      wcel vz cv vw cv c2nd cfv wceq wa vw vz copab c2nd cvv cvv cxp cres vz cv
      vy cv wceq vx vy vz copab2 vz cv vw cv c2nd cfv wceq vw vz cvv cvv cxp
      resopab c2nd vz cv vw cv c2nd cfv wceq vw vz copab wceq c2nd cvv cvv cxp
      cres vz cv vw cv c2nd cfv wceq vw vz copab cvv cvv cxp cres wceq c2nd vw
      cv cvv wcel vz cv vw cv c2nd cfv wceq wa vw vz copab vz cv vw cv c2nd cfv
      wceq vw vz copab c2nd cvv wfn c2nd vw cv cvv wcel vz cv vw cv c2nd cfv
      wceq wa vw vz copab wceq cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd
      fofn ax-mp vw vz cvv c2nd dffn5 mpbi vz cv vw cv c2nd cfv wceq vw cv cvv
      wcel vz cv vw cv c2nd cfv wceq wa vw vz vw cv cvv wcel vz cv vw cv c2nd
      cfv wceq vw visset biantrur opabbii eqtr4i c2nd vz cv vw cv c2nd cfv wceq
      vw vz copab cvv cvv cxp reseq1 ax-mp vz cv vy cv wceq vz cv vw cv c2nd
      cfv wceq vx vy vz vw vx cv vy cv cop vw cv wceq vy cv vw cv c2nd cfv vz
      cv vx cv vy cv cop vw cv wceq vx cv vy cv cop c2nd cfv vw cv c2nd cfv vy
      cv vx cv vy cv cop vw cv c2nd fveq2 vx cv vy cv vx visset vy visset op2nd
      syl5eqr eqeq2d dfoprab3s 3eqtr4ri $.
      $( [16-Jan-2009] $) $( [10-Aug-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( The mapping of a restriction of the ` 1st ` function to a constant
       function. $)
    1stconst $p |- ( B e. C ->
             ( 1st |` ( A X. { B } ) ) : ( A X. { B } ) -1-1-onto-> A ) $=
      cA cB csn cxp cA c1st cA cB csn cxp cres wf1o cA cB csn cxp cA c1st cA cB
      csn cxp cres wfo c1st cA cB csn cxp cres ccnv wfun cB cC wcel cA cB csn
      cxp cA c1st cA cB csn cxp cres dff1o3 cB cC wcel cB csn c0 wne cA cB csn
      cxp cA c1st cA cB csn cxp cres wfo cB cC snnzg cA cB csn fo1stres syl cB
      cC wcel vx cv vy cv c1st cA cB csn cxp cres wbr vx wmo vy wal c1st cA cB
      csn cxp cres ccnv wfun cB cC wcel vx cv vy cv c1st cA cB csn cxp cres wbr
      vx wmo vy cB cC wcel vx cv vy cv c1st cA cB csn cxp cres wbr vx wmo vy cv
      cA wcel vx cv vy cv cB cop wceq wa vx wmo vx cv vy cv cB cop wceq vy cv
      cA wcel vx vx vy cv cB cop moeq moani cB cC wcel vx cv vy cv c1st cA cB
      csn cxp cres wbr vy cv cA wcel vx cv vy cv cB cop wceq wa vx cB cC wcel
      vx ax-17 cB cC wcel vx cv vy cv c1st wbr vx cv cA cB csn cxp wcel wa vy
      cv cA wcel vx cv vy cv cB cop wceq wa vx cv vy cv c1st cA cB csn cxp cres
      wbr cB cC wcel vx cv c1st cfv vy cv wceq vx cv cA cB csn cxp wcel wa vy
      cv cA wcel vx cv vy cv cB cop wceq wa vx cv vy cv c1st wbr vx cv cA cB
      csn cxp wcel wa cB cC wcel vx cv c1st cfv vy cv wceq vx cv cA cB csn cxp
      wcel wa vy cv cA wcel vx cv vy cv cB cop wceq wa vx cv c1st cfv vy cv
      wceq vx cv cA cB csn cxp wcel wa vy cv cA wcel vx cv vy cv cB cop wceq wa
      cB cC wcel vx cv c1st cfv vy cv wceq vx cv cvv cvv cxp wcel vx cv c1st
      cfv cA wcel vx cv c2nd cfv cB csn wcel wa wa vy cv cA wcel vx cv vy cv cB
      cop wceq wa vx cv cA cB csn cxp wcel vx cv c1st cfv vy cv wceq vx cv cvv
      cvv cxp wcel vx cv c1st cfv cA wcel vx cv c2nd cfv cB csn wcel wa wa wa
      vy cv cA wcel vx cv vy cv cB cop wceq vx cv c1st cfv vy cv wceq vx cv
      c1st cfv cA wcel vx cv c2nd cfv cB csn wcel wa vy cv cA wcel vx cv cvv
      cvv cxp wcel vx cv c1st cfv vy cv wceq vx cv c1st cfv cA wcel vy cv cA
      wcel vx cv c2nd cfv cB csn wcel vx cv c1st cfv vy cv wceq vx cv c1st cfv
      cA wcel vy cv cA wcel vx cv c1st cfv vy cv cA eleq1 biimpa adantrr
      adantrl vx cv c1st cfv vy cv wceq vx cv cvv cvv cxp wcel vx cv c2nd cfv
      cB csn wcel vx cv vy cv cB cop wceq vx cv c1st cfv cA wcel vx cv c1st cfv
      vy cv wceq vx cv cvv cvv cxp wcel vx cv c2nd cfv cB wceq vx cv vy cv cB
      cop wceq vx cv c2nd cfv cB csn wcel vx cv cvv cvv cxp wcel vx cv c1st cfv
      vy cv wceq vx cv c2nd cfv cB wceq vx cv vy cv cB cop wceq vx cv vy cv cB
      eqopi an1s vx cv c2nd cfv cB elsni sylanr2 adantrrl jca vx cv cA cB csn
      elxp7 sylan2b adantl cB cC wcel vy cv cA wcel vx cv vy cv cB cop wceq wa
      wa vx cv c1st cfv vy cv wceq vx cv cA cB csn cxp wcel vx cv vy cv cB cop
      wceq vx cv c1st cfv vy cv wceq cB cC wcel vy cv cA wcel vx cv vy cv cB
      cop wceq vx cv c1st cfv vy cv cB cop c1st cfv vy cv vx cv vy cv cB cop
      c1st fveq2 vy cv cB vy visset op1st syl6eq ad2antll cB cC wcel vy cv cA
      wcel vx cv vy cv cB cop wceq wa wa vx cv vy cv cB cop cA cB csn cxp cB cC
      wcel vy cv cA wcel vx cv vy cv cB cop wceq simprr vy cv cA wcel cB cB csn
      wcel vy cv cB cop cA cB csn cxp wcel cB cC wcel vy cv cA wcel vx cv vy cv
      cB cop wceq wa wa vy cv cB cA cB csn opelxpi cB cC wcel vy cv cA wcel vx
      cv vy cv cB cop wceq simprl cB cC wcel cB cB csn wcel vy cv cA wcel vx cv
      vy cv cB cop wceq wa cB cC snidg adantr sylanc eqeltrd jca impbida vx cv
      c1st cfv vy cv wceq vx cv vy cv c1st wbr vx cv cA cB csn cxp wcel c1st
      cvv wfn vx cv cvv wcel vx cv c1st cfv vy cv wceq vx cv vy cv c1st wbr wb
      cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp vx visset cvv
      vx cv vy cv c1st vy visset fnbrfvb mp2an anbi1i syl5bbr vx cv vy cv c1st
      cA cB csn cxp vy visset brres syl5bb mobid mpbiri 19.21aiv vx vy c1st cA
      cB csn cxp cres funcnv2 sylibr sylanbrc $.
      $( [7-Jan-2009] $) $( [14-Dec-2008] $)

    $( The mapping of a restriction of the ` 2nd ` function to a converse
       constant function. $)
    2ndconst $p |- ( A e. C ->
             ( 2nd |` ( { A } X. B ) ) : ( { A } X. B ) -1-1-onto-> B ) $=
      cA csn cB cxp cB c2nd cA csn cB cxp cres wf1o cA csn cB cxp cB c2nd cA
      csn cB cxp cres wfo c2nd cA csn cB cxp cres ccnv wfun cA cC wcel cA csn
      cB cxp cB c2nd cA csn cB cxp cres dff1o3 cA cC wcel cA csn c0 wne cA csn
      cB cxp cB c2nd cA csn cB cxp cres wfo cA cC snnzg cA csn cB fo2ndres syl
      cA cC wcel vx cv vy cv c2nd cA csn cB cxp cres wbr vx wmo vy wal c2nd cA
      csn cB cxp cres ccnv wfun cA cC wcel vx cv vy cv c2nd cA csn cB cxp cres
      wbr vx wmo vy cA cC wcel vx cv vy cv c2nd cA csn cB cxp cres wbr vx wmo
      vy cv cB wcel vx cv cA vy cv cop wceq wa vx wmo vx cv cA vy cv cop wceq
      vy cv cB wcel vx vx cA vy cv cop moeq moani cA cC wcel vx cv vy cv c2nd
      cA csn cB cxp cres wbr vy cv cB wcel vx cv cA vy cv cop wceq wa vx cA cC
      wcel vx ax-17 cA cC wcel vx cv vy cv c2nd wbr vx cv cA csn cB cxp wcel wa
      vy cv cB wcel vx cv cA vy cv cop wceq wa vx cv vy cv c2nd cA csn cB cxp
      cres wbr cA cC wcel vx cv c2nd cfv vy cv wceq vx cv cA csn cB cxp wcel wa
      vy cv cB wcel vx cv cA vy cv cop wceq wa vx cv vy cv c2nd wbr vx cv cA
      csn cB cxp wcel wa cA cC wcel vx cv c2nd cfv vy cv wceq vx cv cA csn cB
      cxp wcel wa vy cv cB wcel vx cv cA vy cv cop wceq wa vx cv c2nd cfv vy cv
      wceq vx cv cA csn cB cxp wcel wa vy cv cB wcel vx cv cA vy cv cop wceq wa
      cA cC wcel vx cv c2nd cfv vy cv wceq vx cv cvv cvv cxp wcel vx cv c1st
      cfv cA csn wcel vx cv c2nd cfv cB wcel wa wa vy cv cB wcel vx cv cA vy cv
      cop wceq wa vx cv cA csn cB cxp wcel vx cv c2nd cfv vy cv wceq vx cv cvv
      cvv cxp wcel vx cv c1st cfv cA csn wcel vx cv c2nd cfv cB wcel wa wa wa
      vy cv cB wcel vx cv cA vy cv cop wceq vx cv c2nd cfv vy cv wceq vx cv
      c1st cfv cA csn wcel vx cv c2nd cfv cB wcel wa vy cv cB wcel vx cv cvv
      cvv cxp wcel vx cv c2nd cfv vy cv wceq vx cv c2nd cfv cB wcel vy cv cB
      wcel vx cv c1st cfv cA csn wcel vx cv c2nd cfv vy cv wceq vx cv c2nd cfv
      cB wcel vy cv cB wcel vx cv c2nd cfv vy cv cB eleq1 biimpa adantrl
      adantrl vx cv c2nd cfv vy cv wceq vx cv cvv cvv cxp wcel vx cv c1st cfv
      cA csn wcel vx cv cA vy cv cop wceq vx cv c2nd cfv cB wcel vx cv c2nd cfv
      vy cv wceq vx cv cvv cvv cxp wcel vx cv c1st cfv cA wceq vx cv cA vy cv
      cop wceq vx cv c1st cfv cA csn wcel vx cv cvv cvv cxp wcel vx cv c2nd cfv
      vy cv wceq vx cv c1st cfv cA wceq vx cv cA vy cv cop wceq vx cv cvv cvv
      cxp wcel vx cv c1st cfv cA wceq vx cv c2nd cfv vy cv wceq vx cv cA vy cv
      cop wceq vx cv cA vy cv eqopi ancom2s an1s vx cv c1st cfv cA elsni
      sylanr2 adantrrr jca vx cv cA csn cB elxp7 sylan2b adantl cA cC wcel vy
      cv cB wcel vx cv cA vy cv cop wceq wa wa vx cv c2nd cfv vy cv wceq vx cv
      cA csn cB cxp wcel cA cC wcel vx cv cA vy cv cop wceq vx cv c2nd cfv vy
      cv wceq vy cv cB wcel vx cv cA vy cv cop wceq cA cC wcel vx cv c2nd cfv
      cA vy cv cop c2nd cfv vy cv vx cv cA vy cv cop c2nd fveq2 cA cC wcel vy
      cv cvv wcel cA vy cv cop c2nd cfv vy cv wceq vy visset cA vy cv cC cvv
      op2ndg mpan2 sylan9eqr adantrl cA cC wcel vy cv cB wcel vx cv cA vy cv
      cop wceq wa wa vx cv cA vy cv cop cA csn cB cxp cA cC wcel vy cv cB wcel
      vx cv cA vy cv cop wceq simprr cA cA csn wcel vy cv cB wcel cA vy cv cop
      cA csn cB cxp wcel cA cC wcel vy cv cB wcel vx cv cA vy cv cop wceq wa wa
      cA vy cv cA csn cB opelxpi cA cC wcel cA cA csn wcel vy cv cB wcel vx cv
      cA vy cv cop wceq wa cA cC snidg adantr cA cC wcel vy cv cB wcel vx cv cA
      vy cv cop wceq simprl sylanc eqeltrd jca impbida vx cv c2nd cfv vy cv
      wceq vx cv vy cv c2nd wbr vx cv cA csn cB cxp wcel c2nd cvv wfn vx cv cvv
      wcel vx cv c2nd cfv vy cv wceq vx cv vy cv c2nd wbr wb cvv cvv c2nd wfo
      c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp vx visset cvv vx cv vy cv c2nd
      vy visset fnbrfvb mp2an anbi1i syl5bbr vx cv vy cv c2nd cA csn cB cxp vy
      visset brres syl5bb mobid mpbiri 19.21aiv vx vy c2nd cA csn cB cxp cres
      funcnv2 sylibr sylanbrc $.
      $( [14-Dec-2008] $) $( [27-Mar-2008] $)
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.  $d v w z C $.
    iunfoprab.1 $e |- C e. _V $.
    $( Two ways to express an operation as a class of ordered pairs. $)
    iunfoprab $p |- U_ x e. A U_ y e. B { <. <. x , y >. , C >. }
            = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ z = C ) } $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 vw cv cA
      cB cxp wcel vz cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb wceq wa
      vw vz copab vw cA cB cxp vw cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb
      csb cop csn ciun vx cA vy cB vx cv vy cv cop cC cop csn ciun ciun vx vy
      vz vw vv cA cB cC vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb vx vv vw
      cv c1st cfv vy vw cv c2nd cfv cC csb vw cv c1st fvex vv cv vw cv c1st cfv
      wcel vx ax-17 hbcsb1 vw cv c1st cfv cvv wcel vv cv vx vw cv c1st cfv vy
      vw cv c2nd cfv cC csb csb wcel vv cv vx vw cv c1st cfv vy vw cv c2nd cfv
      cC csb csb wcel vy wal wi vw cv c1st fvex vy vx vv vw cv c1st cfv vy vw
      cv c2nd cfv cC csb cvv vv cv vw cv c1st cfv wcel vy ax-17 vy vv vw cv
      c2nd cfv cC vw cv c2nd fvex vv cv vw cv c2nd cfv wcel vy ax-17 hbcsb1
      hbcsbg ax-mp vy cv vw cv c2nd cfv wceq vx cv vw cv c1st cfv wceq cC vy vw
      cv c2nd cfv cC csb vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb vy vw
      cv c2nd cfv cC csbeq1a vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csbeq1a
      sylan9eqr dfoprab5sf vw vz cA cB cxp vx vw cv c1st cfv vy vw cv c2nd cfv
      cC csb csb vx vw cv c1st cfv vy vw cv c2nd cfv cC csb vw cv c1st fvex vy
      vw cv c2nd cfv cC vw cv c2nd fvex iunfoprab.1 csbex csbex iunfopab vw vx
      vy vv cA cB vw cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cop csn
      vx cv vy cv cop cC cop csn vx vv vw cv vx vw cv c1st cfv vy vw cv c2nd
      cfv cC csb csb cop vx vv vw cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb
      csb vv cv vw cv wcel vx ax-17 vx vv vw cv c1st cfv vy vw cv c2nd cfv cC
      csb vw cv c1st fvex vv cv vw cv c1st cfv wcel vx ax-17 hbcsb1 hbop hbsn
      vy vv vw cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cop vy vv vw
      cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb vv cv vw cv wcel vy
      ax-17 vw cv c1st cfv cvv wcel vv cv vx vw cv c1st cfv vy vw cv c2nd cfv
      cC csb csb wcel vv cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb wcel
      vy wal wi vw cv c1st fvex vy vx vv vw cv c1st cfv vy vw cv c2nd cfv cC
      csb cvv vv cv vw cv c1st cfv wcel vy ax-17 vy vv vw cv c2nd cfv cC vw cv
      c2nd fvex vv cv vw cv c2nd cfv wcel vy ax-17 hbcsb1 hbcsbg ax-mp hbop
      hbsn vv cv vx cv vy cv cop cC cop csn wcel vw ax-17 vw cv vx cv vy cv cop
      wceq vw cv vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cop vx cv vy cv
      cop cC cop vw cv vx cv vy cv cop wceq vw cv vx cv vy cv cop vx vw cv c1st
      cfv vy vw cv c2nd cfv cC csb csb cC vw cv vx cv vy cv cop wceq id vw cv
      vx cv vy cv cop wceq cC vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb cC
      vx vw cv c1st cfv vy vw cv c2nd cfv cC csb csb wceq vx cv vy cv cop vw cv
      vx vy vw cv cC csbopeq1a eqcoms eqcomd opeq12d sneqd iunxpf 3eqtr2ri $.
      $( [3-Feb-2009] $) $( [19-Dec-2008] $)
  $}


  ${
    $d x y A $.  $d y B $.
    dfmpt.1 $e |- B e. _V $.
    $( Alternate definition for the "maps to" notation ~ df-mpt (although it
       requires that ` B ` be a set). $)
    dfmpt $p |- ( x e. A |-> B ) = U_ x e. A { <. x , B >. } $=
      vx cA cB cmpt vx cv cA wcel vy cv cB wceq wa vx vy copab vx cA vx cv cB
      cop csn ciun vx vy cA cB df-mpt vx vy cA cB dfmpt.1 iunfopab eqtr4i $.
      $( [24-Aug-2010] $) $( [24-Aug-2010] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.
    dfmp2t.1 $e |- C e. _V $.
    $( Alternate definition for the "maps to" notation ~ df-mpt2 (although it
       requires that ` C ` be a set). $)
    dfmpt2 $p |- ( x e. A , y e. B |-> C )
                = U_ x e. A U_ y e. B { <. <. x , y >. , C >. } $=
      vx vy cA cB cC cmpt2 vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx
      vy vz copab2 vx cA vy cB vx cv vy cv cop cC cop csn ciun ciun vx vy vz cA
      cB cC df-mpt2 vx vy vz cA cB cC dfmp2t.1 iunfoprab eqtr4i $.
      $( [29-Aug-2010] $) $( [24-Aug-2010] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y D $.  $d x y z F $.
    $d z G $.
    curry1.1 $e |- G = ( F o. `' ( 2nd |` ( { C } X. _V ) ) ) $.
    $( Composition with ` ``' ( 2nd |`` ( { C } X. _V ) ) ` turns any binary
       operation ` F ` with a constant first operand into a function ` G ` of
       the second operand only.  This transformation is called "currying." $)
    curry1 $p |- ( ( F Fn ( A X. B ) /\ C e. A ) ->
                 G = { <. x , y >. | ( x e. B /\ y = ( C F x ) ) } ) $=
      cF cA cB cxp wfn cC cA wcel wa cG vx cv cB wcel vy cv cC vx cv cF co wceq
      wa vx vy copab wceq vz cv cG cfv vz cv vx cv cB wcel vy cv cC vx cv cF co
      wceq wa vx vy copab cfv wceq vz cB wral cF cA cB cxp wfn cC cA wcel wa vz
      cv cG cfv vz cv vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab
      cfv wceq vz cB cF cA cB cxp wfn cC cA wcel wa vz cv cB wcel wa vz cv c2nd
      cC csn cvv cxp cres ccnv cfv cF cfv cC vz cv cF co vz cv cG cfv vz cv vx
      cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab cfv cF cA cB cxp wfn
      cC cA wcel wa vz cv cB wcel wa vz cv c2nd cC csn cvv cxp cres ccnv cfv cF
      cfv cC vz cv cop cF cfv cC vz cv cF co cC cA wcel vz cv cB wcel vz cv
      c2nd cC csn cvv cxp cres ccnv cfv cF cfv cC vz cv cop cF cfv wceq cF cA
      cB cxp wfn cC cA wcel vz cv cB wcel wa vz cv c2nd cC csn cvv cxp cres
      ccnv cfv cC vz cv cop cF cC csn cvv cxp cvv c2nd cC csn cvv cxp cres wf1o
      cC vz cv cop cC csn cvv cxp wcel wa cC vz cv cop c2nd cC csn cvv cxp cres
      cfv vz cv wceq vz cv c2nd cC csn cvv cxp cres ccnv cfv cC vz cv cop wceq
      cC cA wcel vz cv cB wcel wa cC csn cvv cxp cvv cC vz cv cop vz cv c2nd cC
      csn cvv cxp cres f1ocnvfv cC cA wcel vz cv cB wcel wa cC csn cvv cxp cvv
      c2nd cC csn cvv cxp cres wf1o cC vz cv cop cC csn cvv cxp wcel cC cA wcel
      cC csn cvv cxp cvv c2nd cC csn cvv cxp cres wf1o vz cv cB wcel cC cvv cA
      2ndconst adantr cC cA wcel cC vz cv cop cC csn cvv cxp wcel vz cv cB wcel
      cC cA wcel cC cC csn wcel vz cv cvv wcel wa cC vz cv cop cC csn cvv cxp
      wcel cC cA wcel cC cC csn wcel vz cv cvv wcel cC cA snidg vz visset jctir
      cC vz cv cC csn cvv vz visset opelxp sylibr adantr jca cC cA wcel cC vz
      cv cop c2nd cC csn cvv cxp cres cfv vz cv wceq vz cv cB wcel cC cA wcel
      cC vz cv cop c2nd cC csn cvv cxp cres cfv cC vz cv cop c2nd cfv vz cv cC
      cA wcel cC vz cv cop cC csn cvv cxp wcel cC vz cv cop c2nd cC csn cvv cxp
      cres cfv cC vz cv cop c2nd cfv wceq cC cA wcel cC cC csn wcel vz cv cvv
      wcel wa cC vz cv cop cC csn cvv cxp wcel cC cA wcel cC cC csn wcel vz cv
      cvv wcel cC cA snidg vz visset jctir cC vz cv cC csn cvv vz visset opelxp
      sylibr cC vz cv cop cC csn cvv cxp c2nd fvres syl cC cA wcel vz cv cvv
      wcel cC vz cv cop c2nd cfv vz cv wceq vz visset cC vz cv cA cvv op2ndg
      mpan2 eqtrd adantr sylc fveq2d adantll cC vz cv cF df-opr syl6eqr cF cA
      cB cxp wfn cC cA wcel wa vz cv cB wcel wa vz cv cF c2nd cC csn cvv cxp
      cres ccnv ccom cfv vz cv c2nd cC csn cvv cxp cres ccnv cfv cF cfv vz cv
      cG cfv cF cA cB cxp wfn cC cA wcel wa vz cv cF c2nd cC csn cvv cxp cres
      ccnv ccom cfv vz cv c2nd cC csn cvv cxp cres ccnv cfv cF cfv wceq vz cv
      cB wcel cF wfun c2nd cC csn cvv cxp cres ccnv cvv wfn vz cv cF c2nd cC
      csn cvv cxp cres ccnv ccom cfv vz cv c2nd cC csn cvv cxp cres ccnv cfv cF
      cfv wceq cF cA cB cxp wfn cC cA wcel cF wfun c2nd cC csn cvv cxp cres
      ccnv cvv wfn vz cv cvv wcel vz cv cF c2nd cC csn cvv cxp cres ccnv ccom
      cfv vz cv c2nd cC csn cvv cxp cres ccnv cfv cF cfv wceq vz visset cvv vz
      cv cF c2nd cC csn cvv cxp cres ccnv fvco2 mp3an3 cA cB cxp cF fnfun cC cA
      wcel c2nd cC csn cvv cxp cres cC csn cvv cxp wfn c2nd cC csn cvv cxp cres
      ccnv cvv wfn cC cA wcel cC csn cvv cxp cvv c2nd cC csn cvv cxp cres wf1o
      c2nd cC csn cvv cxp cres cC csn cvv cxp wfn c2nd cC csn cvv cxp cres ccnv
      cvv wfn wa cC cvv cA 2ndconst cC csn cvv cxp cvv c2nd cC csn cvv cxp cres
      dff1o4 sylib pm3.27d syl2an adantr vz cv cG cF c2nd cC csn cvv cxp cres
      ccnv ccom curry1.1 fveq1i syl5eq vz cv cB wcel vz cv vx cv cB wcel vy cv
      cC vx cv cF co wceq wa vx vy copab cfv cC vz cv cF co wceq cF cA cB cxp
      wfn cC cA wcel wa vx vy vz cv cC vx cv cF co cC vz cv cF co cB vx cv cB
      wcel vy cv cC vx cv cF co wceq wa vx vy copab vx cv vz cv cC cF opreq2 vx
      cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab eqid cC vz cv cF
      oprex fvopab4 adantl 3eqtr4d r19.21aiva cG cB wfn vx cv cB wcel vy cv cC
      vx cv cF co wceq wa vx vy copab cB wfn cG vx cv cB wcel vy cv cC vx cv cF
      co wceq wa vx vy copab wceq vz cv cG cfv vz cv vx cv cB wcel vy cv cC vx
      cv cF co wceq wa vx vy copab cfv wceq vz cB wral wb cF cA cB cxp wfn cC
      cA wcel wa vz cB cG vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy
      copab eqfnfv2 cG cB wfn cF c2nd cC csn cvv cxp cres ccnv ccom wfun cF
      c2nd cC csn cvv cxp cres ccnv ccom cdm cB wceq cF cA cB cxp wfn cC cA
      wcel wa cG cB wfn cF c2nd cC csn cvv cxp cres ccnv ccom cB wfn cF c2nd cC
      csn cvv cxp cres ccnv ccom wfun cF c2nd cC csn cvv cxp cres ccnv ccom cdm
      cB wceq wa cG cF c2nd cC csn cvv cxp cres ccnv ccom wceq cG cB wfn cF
      c2nd cC csn cvv cxp cres ccnv ccom cB wfn wb curry1.1 cB cG cF c2nd cC
      csn cvv cxp cres ccnv ccom fneq1 ax-mp cF c2nd cC csn cvv cxp cres ccnv
      ccom cB df-fn bitri cF wfun c2nd cC csn cvv cxp cres ccnv wfun cF c2nd cC
      csn cvv cxp cres ccnv ccom wfun cF cA cB cxp wfn cC cA wcel cF c2nd cC
      csn cvv cxp cres ccnv funco cA cB cxp cF fnfun cC cA wcel cC csn cvv cxp
      cvv c2nd cC csn cvv cxp cres wf1o c2nd cC csn cvv cxp cres ccnv wfun cC
      cvv cA 2ndconst cC csn cvv cxp cvv c2nd cC csn cvv cxp cres wf1o cC csn
      cvv cxp cvv c2nd cC csn cvv cxp cres wfo c2nd cC csn cvv cxp cres ccnv
      wfun cC csn cvv cxp cvv c2nd cC csn cvv cxp cres dff1o3 pm3.27bi syl
      syl2an cF cA cB cxp wfn cC cA wcel wa c2nd cC csn cvv cxp cres ccnv ccnv
      cF cdm cima cB cF c2nd cC csn cvv cxp cres ccnv ccom cdm cF cA cB cxp wfn
      cC cA wcel wa c2nd cC csn cvv cxp cres ccnv ccnv cF cdm cima c2nd cC csn
      cvv cxp cres ccnv ccnv cA cB cxp cima cB cF cA cB cxp wfn cC cA wcel wa
      cF cdm cA cB cxp c2nd cC csn cvv cxp cres ccnv ccnv cF cA cB cxp wfn cF
      cdm cA cB cxp wceq cC cA wcel cA cB cxp cF fndm adantr imaeq2d cC cA wcel
      c2nd cC csn cvv cxp cres ccnv ccnv cA cB cxp cima cB wceq cF cA cB cxp
      wfn cC cA wcel c2nd cC csn cvv cxp cA cB cxp cin cres crn cB c2nd cC csn
      cvv cxp cres ccnv ccnv cA cB cxp cima cC cA wcel c2nd cC csn cvv cxp cA
      cB cxp cin cres crn c2nd cC csn cB cxp cres crn cB cC cA wcel c2nd cC csn
      cvv cxp cA cB cxp cin cres c2nd cC csn cB cxp cres cC cA wcel cC csn cvv
      cxp cA cB cxp cin cC csn cB cxp wceq c2nd cC csn cvv cxp cA cB cxp cin
      cres c2nd cC csn cB cxp cres wceq cC cA wcel cC csn cA cin cB cxp cC csn
      cB cxp cC csn cvv cxp cA cB cxp cin cC cA wcel cC csn cA cin cC csn wceq
      cC csn cA cin cB cxp cC csn cB cxp wceq cC cA wcel cC csn cA wss cC csn
      cA cin cC csn wceq cC cA snssi cC csn cA df-ss sylib cC csn cA cin cC csn
      cB xpeq1 syl cC csn cvv cxp cA cB cxp cin cC csn cA cin cvv cB cin cxp cC
      csn cA cin cB cxp cC csn cvv cA cB inxp cvv cB cin cB cC csn cA cin cvv
      cB cin cB cvv cin cB cvv cB incom cB inv1 eqtri xpeq2i eqtri syl5eq cC
      csn cvv cxp cA cB cxp cin cC csn cB cxp c2nd reseq2 syl rneqd cC cA wcel
      cC csn cB cxp cB c2nd cC csn cB cxp cres wfo c2nd cC csn cB cxp cres crn
      cB wceq cC cA wcel cC csn cB cxp cB c2nd cC csn cB cxp cres wf1o cC csn
      cB cxp cB c2nd cC csn cB cxp cres wfo cC cB cA 2ndconst cC csn cB cxp cB
      c2nd cC csn cB cxp cres f1ofo syl cC csn cB cxp cB c2nd cC csn cB cxp
      cres forn syl eqtrd c2nd cC csn cvv cxp cres ccnv ccnv cA cB cxp cima
      c2nd cC csn cvv cxp cres cA cB cxp cima c2nd cC csn cvv cxp cres cA cB
      cxp cres crn c2nd cC csn cvv cxp cA cB cxp cin cres crn c2nd cC csn cvv
      cxp cres cA cB cxp imacnvcnv c2nd cC csn cvv cxp cres cA cB cxp df-ima
      c2nd cC csn cvv cxp cres cA cB cxp cres c2nd cC csn cvv cxp cA cB cxp cin
      cres c2nd cC csn cvv cxp cA cB cxp resres rneqi 3eqtri syl5eq adantl
      eqtrd cF c2nd cC csn cvv cxp cres ccnv dmco syl5eq sylanbrc vx vy cB cC
      vx cv cF co vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab cC vx
      cv cF oprex vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab eqid
      fnopab2 sylancl mpbird $.
      $( [28-Mar-2008] $) $( [28-Mar-2008] $)

    $( Functionality of a curried function with a constant first argument. $)
    curry1f $p |- ( ( F : ( A X. B ) --> D /\ C e. A ) ->
                 G : B --> D ) $=
      cA cB cxp cD cF wf cC cA wcel wa cB cD cG wf cB cD vx cv cB wcel vy cv cC
      vx cv cF co wceq wa vx vy copab wf cA cB cxp cD cF wf cC cA wcel wa cC vx
      cv cF co cD wcel vx cB wral cB cD vx cv cB wcel vy cv cC vx cv cF co wceq
      wa vx vy copab wf cA cB cxp cD cF wf cC cA wcel wa cC vx cv cF co cD wcel
      vx cB cA cB cxp cD cF wf cC cA wcel vx cv cB wcel cC vx cv cF co cD wcel
      cC vx cv cD cA cB cF foprrn 3expa r19.21aiva vx vy cB cD cC vx cv cF co
      vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab vx cv cB wcel vy
      cv cC vx cv cF co wceq wa vx vy copab eqid fopab2 sylib cA cB cxp cD cF
      wf cC cA wcel wa cB cD cG vx cv cB wcel vy cv cC vx cv cF co wceq wa vx
      vy copab cF cA cB cxp wfn cC cA wcel cG vx cv cB wcel vy cv cC vx cv cF
      co wceq wa vx vy copab wceq cA cB cxp cD cF wf vx vy cA cB cC cF cG
      curry1.1 curry1 cA cB cxp cD cF ffn sylan feq1d mpbird $.
      $( [5-May-2008] $) $( [29-Mar-2008] $)

    $( The value of a curried function with a constant first argument. $)
    curry1val $p |- ( ( F Fn ( A X. B ) /\ C e. A /\ D e. U ) ->
        ( G ` D ) = ( C F D ) ) $=
      cF cA cB cxp wfn cC cA wcel cD cU wcel w3a cD cG cfv cD vx cv cB wcel vy
      cv cC vx cv cF co wceq wa vx vy copab cfv cC cD cF co cF cA cB cxp wfn cC
      cA wcel cD cG cfv cD vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy
      copab cfv wceq cD cU wcel cF cA cB cxp wfn cC cA wcel wa cD cG vx cv cB
      wcel vy cv cC vx cv cF co wceq wa vx vy copab vx vy cA cB cC cF cG
      curry1.1 curry1 fveq1d 3adant3 cF cA cB cxp wfn cD cU wcel cD vx cv cB
      wcel vy cv cC vx cv cF co wceq wa vx vy copab cfv cC cD cF co wceq cC cA
      wcel cF cA cB cxp wfn cD cU wcel wa cD cB wcel cD vx cv cB wcel vy cv cC
      vx cv cF co wceq wa vx vy copab cfv cC cD cF co wceq cF cA cB cxp wfn cD
      cU wcel cD cB wcel wn cD vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy
      copab cfv cC cD cF co wceq cF cA cB cxp wfn cD cU wcel cD cB wcel wn w3a
      cD vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab cfv c0 cC cD cF
      co cD cB wcel wn cF cA cB cxp wfn cD vx cv cB wcel vy cv cC vx cv cF co
      wceq wa vx vy copab cfv c0 wceq cD cU wcel vy cv cC vx cv cF co wceq vx
      vy cB cD vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab vx cv cB
      wcel vy cv cC vx cv cF co wceq wa vx vy copab eqid fvopab4ndm 3ad2ant3 cF
      cdm cA cB cxp wceq cD cU wcel cC cA wcel cD cB wcel wa wn cC cD cF co c0
      wceq cF cA cB cxp wfn cD cU wcel cD cB wcel wn cC cD cU cA cB cF ndmoprg
      cA cB cxp cF fndm cD cU wcel id cC cA wcel cD cB wcel wa cD cB wcel cC cA
      wcel cD cB wcel pm3.27 con3i syl3an eqtr4d 3expia vx vy cD cC vx cv cF co
      cC cD cF co cB vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab vx
      cv cD cC cF opreq2 vx cv cB wcel vy cv cC vx cv cF co wceq wa vx vy copab
      eqid cC cD cF oprex fvopab4 pm2.61d2 3adant2 eqtrd $.
      $( [5-May-2008] $) $( [28-Mar-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y D $.  $d x y z F $.
    $d z G $.
    curry2.1 $e |- G = ( F o. `' ( 1st |` ( _V X. { C } ) ) ) $.
    $( Composition with ` ``' ( 1st |`` ( _V X. { C } ) ) ` turns any binary
       operation ` F ` with a constant second operand into a function ` G ` of
       the first operand only.  This transformation is called "currying."
       (If this becomes frequently used, we can introduce a new notation for
       the hypothesis.) $)
    curry2 $p |- ( ( F Fn ( A X. B ) /\ C e. B ) ->
                 G = { <. x , y >. | ( x e. A /\ y = ( x F C ) ) } ) $=
      cF cA cB cxp wfn cC cB wcel wa cG vx cv cA wcel vy cv vx cv cC cF co wceq
      wa vx vy copab wceq vz cv cG cfv vz cv vx cv cA wcel vy cv vx cv cC cF co
      wceq wa vx vy copab cfv wceq vz cA wral cF cA cB cxp wfn cC cB wcel wa vz
      cv cG cfv vz cv vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab
      cfv wceq vz cA cF cA cB cxp wfn cC cB wcel wa vz cv cA wcel wa vz cv c1st
      cvv cC csn cxp cres ccnv cfv cF cfv vz cv cC cF co vz cv cG cfv vz cv vx
      cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab cfv cF cA cB cxp wfn
      cC cB wcel wa vz cv cA wcel wa vz cv c1st cvv cC csn cxp cres ccnv cfv cF
      cfv vz cv cC cop cF cfv vz cv cC cF co cC cB wcel vz cv cA wcel vz cv
      c1st cvv cC csn cxp cres ccnv cfv cF cfv vz cv cC cop cF cfv wceq cF cA
      cB cxp wfn cC cB wcel vz cv cA wcel wa vz cv c1st cvv cC csn cxp cres
      ccnv cfv vz cv cC cop cF cvv cC csn cxp cvv c1st cvv cC csn cxp cres wf1o
      vz cv cC cop cvv cC csn cxp wcel wa vz cv cC cop c1st cvv cC csn cxp cres
      cfv vz cv wceq vz cv c1st cvv cC csn cxp cres ccnv cfv vz cv cC cop wceq
      cC cB wcel vz cv cA wcel wa cvv cC csn cxp cvv vz cv cC cop vz cv c1st
      cvv cC csn cxp cres f1ocnvfv cC cB wcel vz cv cA wcel wa cvv cC csn cxp
      cvv c1st cvv cC csn cxp cres wf1o vz cv cC cop cvv cC csn cxp wcel cC cB
      wcel cvv cC csn cxp cvv c1st cvv cC csn cxp cres wf1o vz cv cA wcel cvv
      cC cB 1stconst adantr cC cB wcel vz cv cC cop cvv cC csn cxp wcel vz cv
      cA wcel cC cB wcel vz cv cC cop cvv cC csn cxp wcel vz cv cvv wcel cC cC
      csn wcel wa cC cB wcel cC cC csn wcel vz cv cvv wcel cC cB snidg vz
      visset jctil vz cv cC cvv cC csn cB opelxpg mpbird adantr jca cC cB wcel
      vz cv cC cop c1st cvv cC csn cxp cres cfv vz cv wceq vz cv cA wcel cC cB
      wcel vz cv cC cop c1st cvv cC csn cxp cres cfv vz cv cC cop c1st cfv vz
      cv cC cB wcel vz cv cC cop cvv cC csn cxp wcel vz cv cC cop c1st cvv cC
      csn cxp cres cfv vz cv cC cop c1st cfv wceq cC cB wcel vz cv cC cop cvv
      cC csn cxp wcel vz cv cvv wcel cC cC csn wcel wa cC cB wcel cC cC csn
      wcel vz cv cvv wcel cC cB snidg vz visset jctil vz cv cC cvv cC csn cB
      opelxpg mpbird vz cv cC cop cvv cC csn cxp c1st fvres syl vz cv cC vz
      visset op1st syl6eq adantr sylc fveq2d adantll vz cv cC cF df-opr syl6eqr
      cF cA cB cxp wfn cC cB wcel wa vz cv cA wcel wa vz cv cF c1st cvv cC csn
      cxp cres ccnv ccom cfv vz cv c1st cvv cC csn cxp cres ccnv cfv cF cfv vz
      cv cG cfv cF cA cB cxp wfn cC cB wcel wa vz cv cF c1st cvv cC csn cxp
      cres ccnv ccom cfv vz cv c1st cvv cC csn cxp cres ccnv cfv cF cfv wceq vz
      cv cA wcel cF wfun c1st cvv cC csn cxp cres ccnv cvv wfn vz cv cF c1st
      cvv cC csn cxp cres ccnv ccom cfv vz cv c1st cvv cC csn cxp cres ccnv cfv
      cF cfv wceq cF cA cB cxp wfn cC cB wcel cF wfun c1st cvv cC csn cxp cres
      ccnv cvv wfn vz cv cvv wcel vz cv cF c1st cvv cC csn cxp cres ccnv ccom
      cfv vz cv c1st cvv cC csn cxp cres ccnv cfv cF cfv wceq vz visset cvv vz
      cv cF c1st cvv cC csn cxp cres ccnv fvco2 mp3an3 cA cB cxp cF fnfun cC cB
      wcel c1st cvv cC csn cxp cres cvv cC csn cxp wfn c1st cvv cC csn cxp cres
      ccnv cvv wfn cC cB wcel cvv cC csn cxp cvv c1st cvv cC csn cxp cres wf1o
      c1st cvv cC csn cxp cres cvv cC csn cxp wfn c1st cvv cC csn cxp cres ccnv
      cvv wfn wa cvv cC cB 1stconst cvv cC csn cxp cvv c1st cvv cC csn cxp cres
      dff1o4 sylib pm3.27d syl2an adantr vz cv cG cF c1st cvv cC csn cxp cres
      ccnv ccom curry2.1 fveq1i syl5eq vz cv cA wcel vz cv vx cv cA wcel vy cv
      vx cv cC cF co wceq wa vx vy copab cfv vz cv cC cF co wceq cF cA cB cxp
      wfn cC cB wcel wa vx vy vz cv vx cv cC cF co vz cv cC cF co cA vx cv cA
      wcel vy cv vx cv cC cF co wceq wa vx vy copab vx cv vz cv cC cF opreq1 vx
      cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab eqid vz cv cC cF
      oprex fvopab4 adantl 3eqtr4d r19.21aiva cG cA wfn vx cv cA wcel vy cv vx
      cv cC cF co wceq wa vx vy copab cA wfn cG vx cv cA wcel vy cv vx cv cC cF
      co wceq wa vx vy copab wceq vz cv cG cfv vz cv vx cv cA wcel vy cv vx cv
      cC cF co wceq wa vx vy copab cfv wceq vz cA wral wb cF cA cB cxp wfn cC
      cB wcel wa vz cA cG vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy
      copab eqfnfv2 cG cA wfn cF c1st cvv cC csn cxp cres ccnv ccom wfun cF
      c1st cvv cC csn cxp cres ccnv ccom cdm cA wceq cF cA cB cxp wfn cC cB
      wcel wa cG cA wfn cF c1st cvv cC csn cxp cres ccnv ccom cA wfn cF c1st
      cvv cC csn cxp cres ccnv ccom wfun cF c1st cvv cC csn cxp cres ccnv ccom
      cdm cA wceq wa cG cF c1st cvv cC csn cxp cres ccnv ccom wceq cG cA wfn cF
      c1st cvv cC csn cxp cres ccnv ccom cA wfn wb curry2.1 cA cG cF c1st cvv
      cC csn cxp cres ccnv ccom fneq1 ax-mp cF c1st cvv cC csn cxp cres ccnv
      ccom cA df-fn bitri cF wfun c1st cvv cC csn cxp cres ccnv wfun cF c1st
      cvv cC csn cxp cres ccnv ccom wfun cF cA cB cxp wfn cC cB wcel cF c1st
      cvv cC csn cxp cres ccnv funco cA cB cxp cF fnfun cC cB wcel cvv cC csn
      cxp cvv c1st cvv cC csn cxp cres wf1o c1st cvv cC csn cxp cres ccnv wfun
      cvv cC cB 1stconst cvv cC csn cxp cvv c1st cvv cC csn cxp cres wf1o cvv
      cC csn cxp cvv c1st cvv cC csn cxp cres wfo c1st cvv cC csn cxp cres ccnv
      wfun cvv cC csn cxp cvv c1st cvv cC csn cxp cres dff1o3 pm3.27bi syl
      syl2an cF cA cB cxp wfn cC cB wcel wa c1st cvv cC csn cxp cres ccnv ccnv
      cF cdm cima cA cF c1st cvv cC csn cxp cres ccnv ccom cdm cF cA cB cxp wfn
      cC cB wcel wa c1st cvv cC csn cxp cres ccnv ccnv cF cdm cima c1st cvv cC
      csn cxp cres ccnv ccnv cA cB cxp cima cA cF cA cB cxp wfn cC cB wcel wa
      cF cdm cA cB cxp c1st cvv cC csn cxp cres ccnv ccnv cF cA cB cxp wfn cF
      cdm cA cB cxp wceq cC cB wcel cA cB cxp cF fndm adantr imaeq2d cC cB wcel
      c1st cvv cC csn cxp cres ccnv ccnv cA cB cxp cima cA wceq cF cA cB cxp
      wfn cC cB wcel c1st cvv cC csn cxp cA cB cxp cin cres crn cA c1st cvv cC
      csn cxp cres ccnv ccnv cA cB cxp cima cC cB wcel c1st cvv cC csn cxp cA
      cB cxp cin cres crn c1st cA cC csn cxp cres crn cA cC cB wcel c1st cvv cC
      csn cxp cA cB cxp cin cres c1st cA cC csn cxp cres cC cB wcel cvv cC csn
      cxp cA cB cxp cin cA cC csn cxp wceq c1st cvv cC csn cxp cA cB cxp cin
      cres c1st cA cC csn cxp cres wceq cC cB wcel cA cC csn cB cin cxp cA cC
      csn cxp cvv cC csn cxp cA cB cxp cin cC cB wcel cC csn cB cin cC csn wceq
      cA cC csn cB cin cxp cA cC csn cxp wceq cC cB wcel cC csn cB wss cC csn
      cB cin cC csn wceq cC cB snssi cC csn cB df-ss sylib cC csn cB cin cC csn
      cA xpeq2 syl cvv cC csn cxp cA cB cxp cin cvv cA cin cC csn cB cin cxp cA
      cC csn cB cin cxp cvv cC csn cA cB inxp cvv cA cin cA cC csn cB cin cvv
      cA cin cA cvv cin cA cvv cA incom cA inv1 eqtri xpeq1i eqtri syl5eq cvv
      cC csn cxp cA cB cxp cin cA cC csn cxp c1st reseq2 syl rneqd cC cB wcel
      cA cC csn cxp cA c1st cA cC csn cxp cres wfo c1st cA cC csn cxp cres crn
      cA wceq cC cB wcel cA cC csn cxp cA c1st cA cC csn cxp cres wf1o cA cC
      csn cxp cA c1st cA cC csn cxp cres wfo cA cC cB 1stconst cA cC csn cxp cA
      c1st cA cC csn cxp cres f1ofo syl cA cC csn cxp cA c1st cA cC csn cxp
      cres forn syl eqtrd c1st cvv cC csn cxp cres ccnv ccnv cA cB cxp cima
      c1st cvv cC csn cxp cres cA cB cxp cima c1st cvv cC csn cxp cres cA cB
      cxp cres crn c1st cvv cC csn cxp cA cB cxp cin cres crn c1st cvv cC csn
      cxp cres cA cB cxp imacnvcnv c1st cvv cC csn cxp cres cA cB cxp df-ima
      c1st cvv cC csn cxp cres cA cB cxp cres c1st cvv cC csn cxp cA cB cxp cin
      cres c1st cvv cC csn cxp cA cB cxp resres rneqi 3eqtri syl5eq adantl
      eqtrd cF c1st cvv cC csn cxp cres ccnv dmco syl5eq sylanbrc vx vy cA vx
      cv cC cF co vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab vx cv
      cC cF oprex vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab eqid
      fnopab2 sylancl mpbird $.
      $( [8-Jan-2009] $) $( [16-Dec-2008] $)

    $( Functionality of a curried function with a constant second argument. $)
    curry2f $p |- ( ( F : ( A X. B ) --> D /\ C e. B ) ->
                 G : A --> D ) $=
      cA cB cxp cD cF wf cC cB wcel wa cA cD cG wf cA cD vx cv cA wcel vy cv vx
      cv cC cF co wceq wa vx vy copab wf cA cB cxp cD cF wf cC cB wcel wa vx cv
      cC cF co cD wcel vx cA wral cA cD vx cv cA wcel vy cv vx cv cC cF co wceq
      wa vx vy copab wf cA cB cxp cD cF wf cC cB wcel wa vx cv cC cF co cD wcel
      vx cA cA cB cxp cD cF wf cC cB wcel vx cv cA wcel vx cv cC cF co cD wcel
      cA cB cxp cD cF wf vx cv cA wcel cC cB wcel vx cv cC cF co cD wcel vx cv
      cC cD cA cB cF foprrn 3com23 3expa r19.21aiva vx vy cA cD vx cv cC cF co
      vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab vx cv cA wcel vy
      cv vx cv cC cF co wceq wa vx vy copab eqid fopab2 sylib cA cB cxp cD cF
      wf cC cB wcel wa cA cD cG vx cv cA wcel vy cv vx cv cC cF co wceq wa vx
      vy copab cF cA cB cxp wfn cC cB wcel cG vx cv cA wcel vy cv vx cv cC cF
      co wceq wa vx vy copab wceq cA cB cxp cD cF wf vx vy cA cB cC cF cG
      curry2.1 curry2 cA cB cxp cD cF ffn sylan feq1d mpbird $.
      $( [6-Feb-2009] $) $( [16-Dec-2008] $)

    $( The value of a curried function with a constant second argument. $)
    curry2val $p |- ( ( F Fn ( A X. B ) /\ C e. B /\ D e. U ) ->
        ( G ` D ) = ( D F C ) ) $=
      cF cA cB cxp wfn cC cB wcel cD cU wcel w3a cD cG cfv cD vx cv cA wcel vy
      cv vx cv cC cF co wceq wa vx vy copab cfv cD cC cF co cF cA cB cxp wfn cC
      cB wcel cD cG cfv cD vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy
      copab cfv wceq cD cU wcel cF cA cB cxp wfn cC cB wcel wa cD cG vx cv cA
      wcel vy cv vx cv cC cF co wceq wa vx vy copab vx vy cA cB cC cF cG
      curry2.1 curry2 fveq1d 3adant3 cF cA cB cxp wfn cC cB wcel cD vx cv cA
      wcel vy cv vx cv cC cF co wceq wa vx vy copab cfv cD cC cF co wceq cD cU
      wcel cF cA cB cxp wfn cC cB wcel wa cD cA wcel cD vx cv cA wcel vy cv vx
      cv cC cF co wceq wa vx vy copab cfv cD cC cF co wceq cF cA cB cxp wfn cC
      cB wcel cD cA wcel wn cD vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy
      copab cfv cD cC cF co wceq cF cA cB cxp wfn cC cB wcel cD cA wcel wn w3a
      cD vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab cfv c0 cD cC cF
      co cD cA wcel wn cF cA cB cxp wfn cD vx cv cA wcel vy cv vx cv cC cF co
      wceq wa vx vy copab cfv c0 wceq cC cB wcel vy cv vx cv cC cF co wceq vx
      vy cA cD vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab vx cv cA
      wcel vy cv vx cv cC cF co wceq wa vx vy copab eqid fvopab4ndm 3ad2ant3 cF
      cdm cA cB cxp wceq cC cB wcel cD cA wcel cC cB wcel wa wn cD cC cF co c0
      wceq cF cA cB cxp wfn cC cB wcel cD cA wcel wn cD cC cB cA cB cF ndmoprg
      cA cB cxp cF fndm cC cB wcel id cD cA wcel cC cB wcel wa cD cA wcel cD cA
      wcel cC cB wcel pm3.26 con3i syl3an eqtr4d 3expia vx vy cD vx cv cC cF co
      cD cC cF co cA vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab vx
      cv cD cC cF opreq1 vx cv cA wcel vy cv vx cv cC cF co wceq wa vx vy copab
      eqid cD cC cF oprex fvopab4 pm2.61d2 3adant3 eqtrd $.
      $( [10-Feb-2009] $) $( [16-Dec-2008] $)
  $}

  ${
    $d x A $.  $d y B $.  $d v w x y z F $.  $d v w x y z G $.
    $d s t u v w x y z $.
    $( Lemma for ~ fpar . $)
    fparlem1 $p |- ( `' ( 1st |` ( _V X. _V ) ) " { x } ) = ( { x } X. _V ) $=
      c1st cvv cvv cxp cres ccnv vx cv csn cima vy cv vx cv c1st cvv cvv cxp
      cres wbr vy cab vy cv cvv cvv cxp wcel vw cv vx cv wceq vz vy cv c2nd cfv
      wsbc vw vy cv c1st cfv wsbc wa vy cab vx cv csn cvv cxp vx cv cvv wcel
      c1st cvv cvv cxp cres ccnv vx cv csn cima vy cv vx cv c1st cvv cvv cxp
      cres wbr vy cab wceq vx visset vy c1st cvv cvv cxp cres vx cv cvv iniseg
      ax-mp vy cv vx cv c1st cvv cvv cxp cres wbr vy cv cvv cvv cxp wcel vw cv
      vx cv wceq vz vy cv c2nd cfv wsbc vw vy cv c1st cfv wsbc wa vy vy cv vx
      cv c1st cvv cvv cxp cres wbr vy cv vx cv c1st wbr vy cv cvv cvv cxp wcel
      wa vy cv cvv cvv cxp wcel vy cv vx cv c1st wbr wa vy cv cvv cvv cxp wcel
      vw cv vx cv wceq vz vy cv c2nd cfv wsbc vw vy cv c1st cfv wsbc wa vy cv
      vx cv c1st cvv cvv cxp vx visset brres vy cv vx cv c1st wbr vy cv cvv cvv
      cxp wcel ancom vy cv cvv cvv cxp wcel vy cv vx cv c1st wbr vw cv vx cv
      wceq vz vy cv c2nd cfv wsbc vw vy cv c1st cfv wsbc vy cv cvv cvv cxp wcel
      vy cv vx cv c1st wbr vy cv c1st cfv vy cv c2nd cfv cop vx cv c1st wbr vw
      cv vx cv wceq vz vy cv c2nd cfv wsbc vw vy cv c1st cfv wsbc vy cv cvv cvv
      cxp wcel vy cv vy cv c1st cfv vy cv c2nd cfv cop vx cv c1st cvv cvv cxp
      wrel vy cv cvv cvv cxp wcel vy cv vy cv c1st cfv vy cv c2nd cfv cop wceq
      cvv cvv relxp vy cv cvv cvv cxp 1st2nd mpan breq1d vy cv cvv cvv cxp wcel
      vy cv c1st cfv vx cv wceq vw cv vx cv wceq vz vy cv c2nd cfv wsbc vw vy
      cv c1st cfv wsbc vy cv c1st cfv vy cv c2nd cfv cop vx cv c1st wbr vy cv
      c1st cfv vx cv wceq vw cv vx cv wceq vz vy cv c2nd cfv wsbc vw vy cv c1st
      cfv wsbc wb vy cv cvv cvv cxp wcel vw cv vx cv wceq vz vy cv c2nd cfv
      wsbc vw vy cv c1st cfv wsbc vw cv vx cv wceq vw vy cv c1st cfv wsbc vy cv
      c1st cfv vx cv wceq vy cv c1st cfv cvv wcel vw cv vx cv wceq vz vy cv
      c2nd cfv wsbc vw vy cv c1st cfv wsbc vw cv vx cv wceq vw vy cv c1st cfv
      wsbc wb vy cv c1st fvex vw cv vx cv wceq vz vy cv c2nd cfv wsbc vw cv vx
      cv wceq vw vy cv c1st cfv cvv vy cv c2nd cfv cvv wcel vw cv vx cv wceq vz
      vy cv c2nd cfv wsbc vw cv vx cv wceq wb vy cv c2nd fvex vw cv vx cv wceq
      vz vy cv c2nd cfv cvv vw cv vx cv wceq vz ax-17 sbcgf ax-mp sbcbii ax-mp
      vw cv vx cv wceq vy cv c1st cfv vx cv wceq vw vy cv c1st cfv vy cv c1st
      fvex vw cv vy cv c1st cfv vx cv eqeq1 sbcie bitr2i a1i vy cv c1st cfv vy
      cv c2nd cfv cop vx cv c1st wbr vy cv c1st cfv vy cv c2nd cfv cop vx cv
      cop c1st wcel vy cv c1st cfv vy cv c2nd cfv cop c1st cfv vx cv wceq vy cv
      c1st cfv vx cv wceq vy cv c1st cfv vy cv c2nd cfv cop vx cv c1st df-br
      c1st cvv wfn vy cv c1st cfv vy cv c2nd cfv cop cvv wcel vy cv c1st cfv vy
      cv c2nd cfv cop c1st cfv vx cv wceq vy cv c1st cfv vy cv c2nd cfv cop vx
      cv cop c1st wcel wb cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn
      ax-mp vy cv c1st cfv vy cv c2nd cfv opex cvv vy cv c1st cfv vy cv c2nd
      cfv cop vx cv c1st vx visset fnopfvb mp2an vy cv c1st cfv vy cv c2nd cfv
      cop c1st cfv vy cv c1st cfv vx cv vy cv c1st cfv vy cv c2nd cfv vy cv
      c1st fvex op1st eqeq1i 3bitr2i syl5bb bitrd pm5.32i 3bitri abbii vy cv
      cvv cvv cxp wcel vw cv vx cv wceq vz vy cv c2nd cfv wsbc vw vy cv c1st
      cfv wsbc wa vy cab vz cv cvv wcel vw cv vx cv wceq wa vz vw copab ccnv
      cvv vx cv csn cxp ccnv vx cv csn cvv cxp vz cv cvv wcel vw cv vx cv wceq
      wa vz vw copab ccnv vz cv cvv wcel vw cv vx cv wceq wa vw vz copab vw cv
      vx cv wceq vw vz copab vy cv cvv cvv cxp wcel vw cv vx cv wceq vz vy cv
      c2nd cfv wsbc vw vy cv c1st cfv wsbc wa vy cab vz cv cvv wcel vw cv vx cv
      wceq wa vz vw cnvopab vw cv vx cv wceq vz cv cvv wcel vw cv vx cv wceq wa
      vw vz vz cv cvv wcel vw cv vx cv wceq vz visset biantrur opabbii vw cv vx
      cv wceq vw vz vy dfopab2 3eqtr2ri cvv vx cv csn cxp vz cv cvv wcel vw cv
      vx cv wceq wa vz vw copab vz vw cvv vx cv fconstopab cnveqi cvv vx cv csn
      cnvxp 3eqtr2i 3eqtri $.
      $( [4-Feb-2009] $) $( [22-Dec-2008] $)

    $( Lemma for ~ fpar . $)
    fparlem2 $p |- ( `' ( 2nd |` ( _V X. _V ) ) " { y } ) = ( _V X. { y } ) $=
      vx cv vy cv c2nd cvv cvv cxp cres wbr vx cab vz cv cvv wcel vw cv vy cv
      wceq wa vz vw copab c2nd cvv cvv cxp cres ccnv vy cv csn cima cvv vy cv
      csn cxp vx cv vy cv c2nd cvv cvv cxp cres wbr vx cab vx cv cvv cvv cxp
      wcel vw cv vy cv wceq vw vx cv c2nd cfv wsbc vz vx cv c1st cfv wsbc wa vx
      cab vw cv vy cv wceq vz vw copab vz cv cvv wcel vw cv vy cv wceq wa vz vw
      copab vx cv vy cv c2nd cvv cvv cxp cres wbr vx cv cvv cvv cxp wcel vw cv
      vy cv wceq vw vx cv c2nd cfv wsbc vz vx cv c1st cfv wsbc wa vx vx cv vy
      cv c2nd cvv cvv cxp cres wbr vx cv vy cv c2nd wbr vx cv cvv cvv cxp wcel
      wa vx cv cvv cvv cxp wcel vx cv vy cv c2nd wbr wa vx cv cvv cvv cxp wcel
      vw cv vy cv wceq vw vx cv c2nd cfv wsbc vz vx cv c1st cfv wsbc wa vx cv
      vy cv c2nd cvv cvv cxp vy visset brres vx cv vy cv c2nd wbr vx cv cvv cvv
      cxp wcel ancom vx cv cvv cvv cxp wcel vx cv vy cv c2nd wbr vw cv vy cv
      wceq vw vx cv c2nd cfv wsbc vz vx cv c1st cfv wsbc vx cv cvv cvv cxp wcel
      vx cv vy cv c2nd wbr vx cv c1st cfv vx cv c2nd cfv cop vy cv c2nd wbr vw
      cv vy cv wceq vw vx cv c2nd cfv wsbc vz vx cv c1st cfv wsbc vx cv cvv cvv
      cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop vy cv c2nd cvv cvv cxp
      wrel vx cv cvv cvv cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq
      cvv cvv relxp vx cv cvv cvv cxp 1st2nd mpan breq1d vx cv cvv cvv cxp wcel
      vx cv c2nd cfv vy cv wceq vw cv vy cv wceq vw vx cv c2nd cfv wsbc vz vx
      cv c1st cfv wsbc vx cv c1st cfv vx cv c2nd cfv cop vy cv c2nd wbr vx cv
      c2nd cfv vy cv wceq vw cv vy cv wceq vw vx cv c2nd cfv wsbc vz vx cv c1st
      cfv wsbc wb vx cv cvv cvv cxp wcel vw cv vy cv wceq vw vx cv c2nd cfv
      wsbc vz vx cv c1st cfv wsbc vw cv vy cv wceq vw vx cv c2nd cfv wsbc vx cv
      c2nd cfv vy cv wceq vx cv c1st cfv cvv wcel vw cv vy cv wceq vw vx cv
      c2nd cfv wsbc vz vx cv c1st cfv wsbc vw cv vy cv wceq vw vx cv c2nd cfv
      wsbc wb vx cv c1st fvex vw cv vy cv wceq vw vx cv c2nd cfv wsbc vz vx cv
      c1st cfv cvv vw cv vy cv wceq vw vx cv c2nd cfv wsbc vz ax-17 sbcgf ax-mp
      vw cv vy cv wceq vx cv c2nd cfv vy cv wceq vw vx cv c2nd cfv vx cv c2nd
      fvex vw cv vx cv c2nd cfv vy cv eqeq1 sbcie bitr2i a1i vx cv c1st cfv vx
      cv c2nd cfv cop vy cv c2nd wbr vx cv c1st cfv vx cv c2nd cfv cop vy cv
      cop c2nd wcel vx cv c1st cfv vx cv c2nd cfv cop c2nd cfv vy cv wceq vx cv
      c2nd cfv vy cv wceq vx cv c1st cfv vx cv c2nd cfv cop vy cv c2nd df-br
      c2nd cvv wfn vx cv c1st cfv vx cv c2nd cfv cop cvv wcel vx cv c1st cfv vx
      cv c2nd cfv cop c2nd cfv vy cv wceq vx cv c1st cfv vx cv c2nd cfv cop vy
      cv cop c2nd wcel wb cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn
      ax-mp vx cv c1st cfv vx cv c2nd cfv opex cvv vx cv c1st cfv vx cv c2nd
      cfv cop vy cv c2nd vy visset fnopfvb mp2an vx cv c1st cfv vx cv c2nd cfv
      cop c2nd cfv vx cv c2nd cfv vy cv vx cv c1st cfv vx cv c2nd cfv vx cv
      c1st fvex vx cv c2nd fvex op2nd eqeq1i 3bitr2i syl5bb bitrd pm5.32i
      3bitri abbii vw cv vy cv wceq vz vw vx dfopab2 vw cv vy cv wceq vz cv cvv
      wcel vw cv vy cv wceq wa vz vw vz cv cvv wcel vw cv vy cv wceq vz visset
      biantrur opabbii 3eqtr2i vy cv cvv wcel c2nd cvv cvv cxp cres ccnv vy cv
      csn cima vx cv vy cv c2nd cvv cvv cxp cres wbr vx cab wceq vy visset vx
      c2nd cvv cvv cxp cres vy cv cvv iniseg ax-mp vz vw cvv vy cv fconstopab
      3eqtr4i $.
      $( [4-Feb-2009] $) $( [22-Dec-2008] $)

    $( Lemma for ~ fpar . $)
    fparlem3 $p |- ( F Fn A
          -> ( `' ( 1st |` ( _V X. _V ) ) o. ( F o. ( 1st |` ( _V X. _V ) ) ) )
            = U_ x e. A ( ( { x } X. _V ) X. ( { ( F ` x ) } X. _V ) ) ) $=
      cF cA wfn c1st cvv cvv cxp cres ccnv cF c1st cvv cvv cxp cres ccom ccom
      c1st cvv cvv cxp cres ccnv vx cA vx cv csn cvv cxp vx cv cF cfv csn cxp
      ciun ccom vx cA c1st cvv cvv cxp cres ccnv vx cv csn cvv cxp vx cv cF cfv
      csn cxp ccom ciun vx cA vx cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp
      ciun cF cA wfn cF c1st cvv cvv cxp cres ccom vx cA vx cv csn cvv cxp vx
      cv cF cfv csn cxp ciun c1st cvv cvv cxp cres ccnv cF cA wfn cF c1st cvv
      cvv cxp cres ccom vx cA c1st cvv cvv cxp cres ccnv vx cv csn cima cF vx
      cv csn cima cxp ciun vx cA vx cv csn cvv cxp vx cv cF cfv csn cxp ciun cF
      cA wfn cF cdm c1st cvv cvv cxp cres crn cin cA wss cF c1st cvv cvv cxp
      cres ccom vx cA c1st cvv cvv cxp cres ccnv vx cv csn cima cF vx cv csn
      cima cxp ciun wceq cF cA wfn cF cdm c1st cvv cvv cxp cres crn cin cF cdm
      cA cF cdm c1st cvv cvv cxp cres crn cin cF cdm wss cF cA wfn cF cdm c1st
      cvv cvv cxp cres crn inss1 a1i cA cF fndm sseqtrd vx cF c1st cvv cvv cxp
      cres cA dfco2a syl cF cA wfn vx cA vx cv csn cvv cxp vx cv cF cfv csn cxp
      c1st cvv cvv cxp cres ccnv vx cv csn cima cF vx cv csn cima cxp cF cA wfn
      vx cv cA wcel wa c1st cvv cvv cxp cres ccnv vx cv csn cima vx cv cF cfv
      csn cxp c1st cvv cvv cxp cres ccnv vx cv csn cima cF vx cv csn cima cxp
      vx cv csn cvv cxp vx cv cF cfv csn cxp cF cA wfn vx cv cA wcel wa vx cv
      cF cfv csn cF vx cv csn cima wceq c1st cvv cvv cxp cres ccnv vx cv csn
      cima vx cv cF cfv csn cxp c1st cvv cvv cxp cres ccnv vx cv csn cima cF vx
      cv csn cima cxp wceq cA vx cv cF fnsnfv vx cv cF cfv csn cF vx cv csn
      cima c1st cvv cvv cxp cres ccnv vx cv csn cima xpeq2 syl c1st cvv cvv cxp
      cres ccnv vx cv csn cima vx cv csn cvv cxp vx cv cF cfv csn vx fparlem1
      xpeq1i syl5eqr iuneq2dv eqtr4d coeq2d c1st cvv cvv cxp cres ccnv vx cA vx
      cv csn cvv cxp vx cv cF cfv csn cxp ciun ccom vx cA c1st cvv cvv cxp cres
      ccnv vx cv csn cvv cxp vx cv cF cfv csn cxp ccom ciun wceq cF cA wfn vx
      c1st cvv cvv cxp cres ccnv vx cv csn cvv cxp vx cv cF cfv csn cxp cA
      coiun a1i cF cA wfn vx cA c1st cvv cvv cxp cres ccnv vx cv csn cvv cxp vx
      cv cF cfv csn cxp ccom vx cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp
      c1st cvv cvv cxp cres ccnv vx cv csn cvv cxp vx cv cF cfv csn cxp ccom vx
      cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp wceq cF cA wfn vx cv cA wcel
      wa c1st cvv cvv cxp cres ccnv vx cv csn cvv cxp vx cv cF cfv csn cxp ccom
      vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom ccnv vx
      cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp ccnv vx cv csn cvv cxp vx cv
      cF cfv csn cvv cxp cxp vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv
      cvv cxp cres ccom ccnv c1st cvv cvv cxp cres ccnv vx cv cF cfv csn vx cv
      csn cvv cxp cxp ccnv ccom c1st cvv cvv cxp cres ccnv vx cv csn cvv cxp vx
      cv cF cfv csn cxp ccom vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv
      cvv cxp cres cnvco vx cv cF cfv csn vx cv csn cvv cxp cxp ccnv vx cv csn
      cvv cxp vx cv cF cfv csn cxp c1st cvv cvv cxp cres ccnv vx cv cF cfv csn
      vx cv csn cvv cxp cnvxp coeq2i eqtr2i vx cv cF cfv csn vx cv csn cvv cxp
      cxp c1st cvv cvv cxp cres ccom vx cv cF cfv csn cvv cxp vx cv csn cvv cxp
      cxp vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom vx
      cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp wceq vy cv vz cv cop vw cv
      cop vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom
      wcel vy cv vz cv cop vw cv cop vx cv cF cfv csn cvv cxp vx cv csn cvv cxp
      cxp wcel wb vw wal vz wal vy wal vy cv vz cv cop vw cv cop vx cv cF cfv
      csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom wcel vy cv vz cv cop
      vw cv cop vx cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp wcel wb vw wal
      vy vz vy cv vz cv cop vw cv cop vx cv cF cfv csn vx cv csn cvv cxp cxp
      c1st cvv cvv cxp cres ccom wcel vy cv vz cv cop vw cv cop vx cv cF cfv
      csn cvv cxp vx cv csn cvv cxp cxp wcel wb vw vy cv vz cv cop vx cv cF cfv
      csn cvv cxp wcel vw cv vx cv csn cvv cxp wcel wa vy cv vx cv cF cfv wceq
      vw cv vx cv csn cvv cxp wcel wa vy cv vz cv cop vw cv cop vx cv cF cfv
      csn cvv cxp vx cv csn cvv cxp cxp wcel vy cv vz cv cop vw cv cop vx cv cF
      cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom wcel vy cv vz cv
      cop vx cv cF cfv csn cvv cxp wcel vy cv vx cv cF cfv wceq vw cv vx cv csn
      cvv cxp wcel vy cv vz cv cop vx cv cF cfv csn cvv cxp wcel vy cv vx cv cF
      cfv csn wcel vz cv cvv wcel wa vy cv vx cv cF cfv csn wcel vy cv vx cv cF
      cfv wceq vy cv vz cv vx cv cF cfv csn cvv vz visset opelxp vz cv cvv wcel
      vy cv vx cv cF cfv csn wcel vz visset biantru vy vx cv cF cfv elsn
      3bitr2i anbi1i vy cv vz cv cop vw cv vx cv cF cfv csn cvv cxp vx cv csn
      cvv cxp vw visset opelxp vy cv vz cv cop vw cv cop vx cv cF cfv csn vx cv
      csn cvv cxp cxp c1st cvv cvv cxp cres ccom wcel vy cv vz cv cop vv cv
      c1st cvv cvv cxp cres wbr vv cv vw cv vx cv cF cfv csn vx cv csn cvv cxp
      cxp wbr wa vv wex vv cv vy cv wceq vv cv vx cv cF cfv wceq vw cv vx cv
      csn cvv cxp wcel wa wa vv wex vy cv vx cv cF cfv wceq vw cv vx cv csn cvv
      cxp wcel wa vv vy cv vz cv cop vw cv vx cv cF cfv csn vx cv csn cvv cxp
      cxp c1st cvv cvv cxp cres vy cv vz cv opex vw visset opelco vy cv vz cv
      cop vv cv c1st cvv cvv cxp cres wbr vv cv vw cv vx cv cF cfv csn vx cv
      csn cvv cxp cxp wbr wa vv cv vy cv wceq vv cv vx cv cF cfv wceq vw cv vx
      cv csn cvv cxp wcel wa wa vv vy cv vz cv cop vv cv c1st cvv cvv cxp cres
      wbr vv cv vy cv wceq vv cv vw cv vx cv cF cfv csn vx cv csn cvv cxp cxp
      wbr vv cv vx cv cF cfv wceq vw cv vx cv csn cvv cxp wcel wa vy cv vz cv
      cop vv cv c1st cvv cvv cxp cres wbr vy cv vz cv cop vv cv cop c1st cvv
      cvv cxp cres wcel vy cv vz cv cop vv cv cop vs cv vu cv wceq vu vt vs
      copab2 wcel vv cv vy cv wceq vy cv vz cv cop vv cv c1st cvv cvv cxp cres
      df-br vs cv vu cv wceq vu vt vs copab2 c1st cvv cvv cxp cres vy cv vz cv
      cop vv cv cop vu vt vs df1st2 eleq2i vy cv cvv wcel vz cv cvv wcel vv cv
      cvv wcel vy cv vz cv cop vv cv cop vs cv vu cv wceq vu vt vs copab2 wcel
      vv cv vy cv wceq wb vy visset vz visset vv visset vs cv vu cv wceq vs cv
      vy cv wceq vs cv vy cv wceq vv cv vy cv wceq vu vt vs vy cv vz cv vv cv
      cvv cvv cvv vu vy vs equequ2 vt cv vz cv wceq vs cv vy cv wceq biidd vs
      vv vy equequ1 eloprabg mp3an 3bitr2i vv cv vw cv vx cv cF cfv csn vx cv
      csn cvv cxp cxp wbr vv cv vw cv cop vx cv cF cfv csn vx cv csn cvv cxp
      cxp wcel vv cv vx cv cF cfv csn wcel vw cv vx cv csn cvv cxp wcel wa vv
      cv vx cv cF cfv wceq vw cv vx cv csn cvv cxp wcel wa vv cv vw cv vx cv cF
      cfv csn vx cv csn cvv cxp cxp df-br vv cv vw cv vx cv cF cfv csn vx cv
      csn cvv cxp vw visset opelxp vv cv vx cv cF cfv csn wcel vv cv vx cv cF
      cfv wceq vw cv vx cv csn cvv cxp wcel vv vx cv cF cfv elsn anbi1i 3bitri
      anbi12i exbii vv cv vx cv cF cfv wceq vw cv vx cv csn cvv cxp wcel wa vy
      cv vx cv cF cfv wceq vw cv vx cv csn cvv cxp wcel wa vv vy cv vy visset
      vv cv vy cv wceq vv cv vx cv cF cfv wceq vy cv vx cv cF cfv wceq vw cv vx
      cv csn cvv cxp wcel vv cv vy cv vx cv cF cfv eqeq1 anbi1d ceqsexv 3bitri
      3bitr4ri ax-gen gen2 vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv
      cxp cres ccom vx cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp cun cvv cvv
      cxp cvv cxp wss vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp
      cres ccom vx cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp wceq vy cv vz cv
      cop vw cv cop vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp
      cres ccom wcel vy cv vz cv cop vw cv cop vx cv cF cfv csn cvv cxp vx cv
      csn cvv cxp cxp wcel wb vw wal vz wal vy wal wb vx cv cF cfv csn vx cv
      csn cvv cxp cxp c1st cvv cvv cxp cres ccom vx cv cF cfv csn cvv cxp vx cv
      csn cvv cxp cxp cvv cvv cxp cvv cxp vx cv cF cfv csn vx cv csn cvv cxp
      cxp c1st cvv cvv cxp cres ccom wrel vx cv cF cfv csn vx cv csn cvv cxp
      cxp c1st cvv cvv cxp cres ccom cdm wrel wa vx cv cF cfv csn vx cv csn cvv
      cxp cxp c1st cvv cvv cxp cres ccom cvv cvv cxp cvv cxp wss vx cv cF cfv
      csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom wrel vx cv cF cfv
      csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom cdm wrel vx cv cF
      cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres relco vx cv cF cfv
      csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom cdm cvv cvv cxp wss
      cvv cvv cxp wrel vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp
      cres ccom cdm wrel vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv
      cxp cres ccom cdm c1st cvv cvv cxp cres cdm cvv cvv cxp vx cv cF cfv csn
      vx cv csn cvv cxp cxp c1st cvv cvv cxp cres dmcoss c1st cvv cvv cxp cres
      cdm cvv cvv cxp c1st cdm cin cvv cvv cxp c1st cvv cvv cxp dmres cvv cvv
      cxp c1st cdm inss1 eqsstri sstri cvv cvv relxp vx cv cF cfv csn vx cv csn
      cvv cxp cxp c1st cvv cvv cxp cres ccom cdm cvv cvv cxp relss mp2 pm3.2i
      vx cv cF cfv csn vx cv csn cvv cxp cxp c1st cvv cvv cxp cres ccom
      relrelss mpbi vx cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp wrel vx cv
      cF cfv csn cvv cxp vx cv csn cvv cxp cxp cdm wrel wa vx cv cF cfv csn cvv
      cxp vx cv csn cvv cxp cxp cvv cvv cxp cvv cxp wss vx cv cF cfv csn cvv
      cxp vx cv csn cvv cxp cxp wrel vx cv cF cfv csn cvv cxp vx cv csn cvv cxp
      cxp cdm wrel vx cv cF cfv csn cvv cxp vx cv csn cvv cxp relxp vx cv cF
      cfv csn cvv cxp vx cv csn cvv cxp cxp cdm vx cv cF cfv csn cvv cxp wss vx
      cv cF cfv csn cvv cxp wrel vx cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp
      cdm wrel vx cv cF cfv csn cvv cxp vx cv csn cvv cxp dmxpss vx cv cF cfv
      csn cvv relxp vx cv cF cfv csn cvv cxp vx cv csn cvv cxp cxp cdm vx cv cF
      cfv csn cvv cxp relss mp2 pm3.2i vx cv cF cfv csn cvv cxp vx cv csn cvv
      cxp cxp relrelss mpbi unssi vy vz vw vx cv cF cfv csn vx cv csn cvv cxp
      cxp c1st cvv cvv cxp cres ccom vx cv cF cfv csn cvv cxp vx cv csn cvv cxp
      cxp eqrelrel ax-mp mpbir cnveqi vx cv cF cfv csn cvv cxp vx cv csn cvv
      cxp cnvxp 3eqtri a1i iuneq2dv 3eqtrd $.
      $( [4-Feb-2009] $) $( [22-Dec-2008] $)

    $( Lemma for ~ fpar . $)
    fparlem4 $p |- ( G Fn B
          -> ( `' ( 2nd |` ( _V X. _V ) ) o. ( G o. ( 2nd |` ( _V X. _V ) ) ) )
            = U_ y e. B ( ( _V X. { y } ) X. ( _V X. { ( G ` y ) } ) ) ) $=
      cG cB wfn c2nd cvv cvv cxp cres ccnv cG c2nd cvv cvv cxp cres ccom ccom
      c2nd cvv cvv cxp cres ccnv vy cB cvv vy cv csn cxp vy cv cG cfv csn cxp
      ciun ccom vy cB c2nd cvv cvv cxp cres ccnv cvv vy cv csn cxp vy cv cG cfv
      csn cxp ccom ciun vy cB cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp
      ciun cG cB wfn cG c2nd cvv cvv cxp cres ccom vy cB cvv vy cv csn cxp vy
      cv cG cfv csn cxp ciun c2nd cvv cvv cxp cres ccnv cG cB wfn cG c2nd cvv
      cvv cxp cres ccom vy cB c2nd cvv cvv cxp cres ccnv vy cv csn cima cG vy
      cv csn cima cxp ciun vy cB cvv vy cv csn cxp vy cv cG cfv csn cxp ciun cG
      cB wfn cG cdm c2nd cvv cvv cxp cres crn cin cB wss cG c2nd cvv cvv cxp
      cres ccom vy cB c2nd cvv cvv cxp cres ccnv vy cv csn cima cG vy cv csn
      cima cxp ciun wceq cG cB wfn cG cdm c2nd cvv cvv cxp cres crn cin cG cdm
      cB cG cdm c2nd cvv cvv cxp cres crn cin cG cdm wss cG cB wfn cG cdm c2nd
      cvv cvv cxp cres crn inss1 a1i cB cG fndm sseqtrd vy cG c2nd cvv cvv cxp
      cres cB dfco2a syl cG cB wfn vy cB cvv vy cv csn cxp vy cv cG cfv csn cxp
      c2nd cvv cvv cxp cres ccnv vy cv csn cima cG vy cv csn cima cxp cG cB wfn
      vy cv cB wcel wa c2nd cvv cvv cxp cres ccnv vy cv csn cima vy cv cG cfv
      csn cxp c2nd cvv cvv cxp cres ccnv vy cv csn cima cG vy cv csn cima cxp
      cvv vy cv csn cxp vy cv cG cfv csn cxp cG cB wfn vy cv cB wcel wa vy cv
      cG cfv csn cG vy cv csn cima wceq c2nd cvv cvv cxp cres ccnv vy cv csn
      cima vy cv cG cfv csn cxp c2nd cvv cvv cxp cres ccnv vy cv csn cima cG vy
      cv csn cima cxp wceq cB vy cv cG fnsnfv vy cv cG cfv csn cG vy cv csn
      cima c2nd cvv cvv cxp cres ccnv vy cv csn cima xpeq2 syl c2nd cvv cvv cxp
      cres ccnv vy cv csn cima cvv vy cv csn cxp vy cv cG cfv csn vy fparlem2
      xpeq1i syl5eqr iuneq2dv eqtr4d coeq2d c2nd cvv cvv cxp cres ccnv vy cB
      cvv vy cv csn cxp vy cv cG cfv csn cxp ciun ccom vy cB c2nd cvv cvv cxp
      cres ccnv cvv vy cv csn cxp vy cv cG cfv csn cxp ccom ciun wceq cG cB wfn
      vy c2nd cvv cvv cxp cres ccnv cvv vy cv csn cxp vy cv cG cfv csn cxp cB
      coiun a1i cG cB wfn vy cB c2nd cvv cvv cxp cres ccnv cvv vy cv csn cxp vy
      cv cG cfv csn cxp ccom cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp
      c2nd cvv cvv cxp cres ccnv cvv vy cv csn cxp vy cv cG cfv csn cxp ccom
      cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp wceq cG cB wfn vy cv cB
      wcel wa c2nd cvv cvv cxp cres ccnv cvv vy cv csn cxp vy cv cG cfv csn cxp
      ccom vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom
      ccnv cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp ccnv cvv vy cv csn
      cxp cvv vy cv cG cfv csn cxp cxp vy cv cG cfv csn cvv vy cv csn cxp cxp
      c2nd cvv cvv cxp cres ccom ccnv c2nd cvv cvv cxp cres ccnv vy cv cG cfv
      csn cvv vy cv csn cxp cxp ccnv ccom c2nd cvv cvv cxp cres ccnv cvv vy cv
      csn cxp vy cv cG cfv csn cxp ccom vy cv cG cfv csn cvv vy cv csn cxp cxp
      c2nd cvv cvv cxp cres cnvco vy cv cG cfv csn cvv vy cv csn cxp cxp ccnv
      cvv vy cv csn cxp vy cv cG cfv csn cxp c2nd cvv cvv cxp cres ccnv vy cv
      cG cfv csn cvv vy cv csn cxp cnvxp coeq2i eqtr2i vy cv cG cfv csn cvv vy
      cv csn cxp cxp c2nd cvv cvv cxp cres ccom cvv vy cv cG cfv csn cxp cvv vy
      cv csn cxp cxp vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp
      cres ccom cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp wceq vx cv vz cv
      cop vw cv cop vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp
      cres ccom wcel vx cv vz cv cop vw cv cop cvv vy cv cG cfv csn cxp cvv vy
      cv csn cxp cxp wcel wb vw wal vz wal vx wal vx cv vz cv cop vw cv cop vy
      cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom wcel vx cv
      vz cv cop vw cv cop cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp wcel
      wb vw wal vx vz vx cv vz cv cop vw cv cop vy cv cG cfv csn cvv vy cv csn
      cxp cxp c2nd cvv cvv cxp cres ccom wcel vx cv vz cv cop vw cv cop cvv vy
      cv cG cfv csn cxp cvv vy cv csn cxp cxp wcel wb vw vx cv vz cv cop cvv vy
      cv cG cfv csn cxp wcel vw cv cvv vy cv csn cxp wcel wa vz cv vy cv cG cfv
      wceq vw cv cvv vy cv csn cxp wcel wa vx cv vz cv cop vw cv cop cvv vy cv
      cG cfv csn cxp cvv vy cv csn cxp cxp wcel vx cv vz cv cop vw cv cop vy cv
      cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom wcel vx cv vz
      cv cop cvv vy cv cG cfv csn cxp wcel vz cv vy cv cG cfv wceq vw cv cvv vy
      cv csn cxp wcel vx cv vz cv cop cvv vy cv cG cfv csn cxp wcel vx cv cvv
      wcel vz cv vy cv cG cfv csn wcel wa vz cv vy cv cG cfv csn wcel vz cv vy
      cv cG cfv wceq vx cv vz cv cvv vy cv cG cfv csn vz visset opelxp vx cv
      cvv wcel vz cv vy cv cG cfv csn wcel vx visset biantrur vz vy cv cG cfv
      elsn 3bitr2i anbi1i vx cv vz cv cop vw cv cvv vy cv cG cfv csn cxp cvv vy
      cv csn cxp vw visset opelxp vx cv vz cv cop vw cv cop vy cv cG cfv csn
      cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom wcel vx cv vz cv cop vv
      cv c2nd cvv cvv cxp cres wbr vv cv vw cv vy cv cG cfv csn cvv vy cv csn
      cxp cxp wbr wa vv wex vv cv vz cv wceq vv cv vy cv cG cfv wceq vw cv cvv
      vy cv csn cxp wcel wa wa vv wex vz cv vy cv cG cfv wceq vw cv cvv vy cv
      csn cxp wcel wa vv vx cv vz cv cop vw cv vy cv cG cfv csn cvv vy cv csn
      cxp cxp c2nd cvv cvv cxp cres vx cv vz cv opex vw visset opelco vx cv vz
      cv cop vv cv c2nd cvv cvv cxp cres wbr vv cv vw cv vy cv cG cfv csn cvv
      vy cv csn cxp cxp wbr wa vv cv vz cv wceq vv cv vy cv cG cfv wceq vw cv
      cvv vy cv csn cxp wcel wa wa vv vx cv vz cv cop vv cv c2nd cvv cvv cxp
      cres wbr vv cv vz cv wceq vv cv vw cv vy cv cG cfv csn cvv vy cv csn cxp
      cxp wbr vv cv vy cv cG cfv wceq vw cv cvv vy cv csn cxp wcel wa vx cv vz
      cv cop vv cv c2nd cvv cvv cxp cres wbr vx cv vz cv cop vv cv cop c2nd cvv
      cvv cxp cres wcel vx cv vz cv cop vv cv cop vs cv vt cv wceq vu vt vs
      copab2 wcel vv cv vz cv wceq vx cv vz cv cop vv cv c2nd cvv cvv cxp cres
      df-br vs cv vt cv wceq vu vt vs copab2 c2nd cvv cvv cxp cres vx cv vz cv
      cop vv cv cop vu vt vs df2nd2 eleq2i vx cv cvv wcel vz cv cvv wcel vv cv
      cvv wcel vx cv vz cv cop vv cv cop vs cv vt cv wceq vu vt vs copab2 wcel
      vv cv vz cv wceq wb vx visset vz visset vv visset vs cv vt cv wceq vs cv
      vt cv wceq vs cv vz cv wceq vv cv vz cv wceq vu vt vs vx cv vz cv vv cv
      cvv cvv cvv vu cv vx cv wceq vs cv vt cv wceq biidd vt vz vs equequ2 vs
      vv vz equequ1 eloprabg mp3an 3bitr2i vv cv vw cv vy cv cG cfv csn cvv vy
      cv csn cxp cxp wbr vv cv vw cv cop vy cv cG cfv csn cvv vy cv csn cxp cxp
      wcel vv cv vy cv cG cfv csn wcel vw cv cvv vy cv csn cxp wcel wa vv cv vy
      cv cG cfv wceq vw cv cvv vy cv csn cxp wcel wa vv cv vw cv vy cv cG cfv
      csn cvv vy cv csn cxp cxp df-br vv cv vw cv vy cv cG cfv csn cvv vy cv
      csn cxp vw visset opelxp vv cv vy cv cG cfv csn wcel vv cv vy cv cG cfv
      wceq vw cv cvv vy cv csn cxp wcel vv vy cv cG cfv elsn anbi1i 3bitri
      anbi12i exbii vv cv vy cv cG cfv wceq vw cv cvv vy cv csn cxp wcel wa vz
      cv vy cv cG cfv wceq vw cv cvv vy cv csn cxp wcel wa vv vz cv vz visset
      vv cv vz cv wceq vv cv vy cv cG cfv wceq vz cv vy cv cG cfv wceq vw cv
      cvv vy cv csn cxp wcel vv cv vz cv vy cv cG cfv eqeq1 anbi1d ceqsexv
      3bitri 3bitr4ri ax-gen gen2 vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd
      cvv cvv cxp cres ccom cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp cun
      cvv cvv cxp cvv cxp wss vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv
      cvv cxp cres ccom cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp wceq vx
      cv vz cv cop vw cv cop vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv
      cvv cxp cres ccom wcel vx cv vz cv cop vw cv cop cvv vy cv cG cfv csn cxp
      cvv vy cv csn cxp cxp wcel wb vw wal vz wal vx wal wb vy cv cG cfv csn
      cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom cvv vy cv cG cfv csn cxp
      cvv vy cv csn cxp cxp cvv cvv cxp cvv cxp vy cv cG cfv csn cvv vy cv csn
      cxp cxp c2nd cvv cvv cxp cres ccom wrel vy cv cG cfv csn cvv vy cv csn
      cxp cxp c2nd cvv cvv cxp cres ccom cdm wrel wa vy cv cG cfv csn cvv vy cv
      csn cxp cxp c2nd cvv cvv cxp cres ccom cvv cvv cxp cvv cxp wss vy cv cG
      cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom wrel vy cv cG
      cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom cdm wrel vy cv
      cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres relco vy cv cG cfv
      csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom cdm cvv cvv cxp wss
      cvv cvv cxp wrel vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp
      cres ccom cdm wrel vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv
      cxp cres ccom cdm c2nd cvv cvv cxp cres cdm cvv cvv cxp vy cv cG cfv csn
      cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres dmcoss c2nd cvv cvv cxp cres
      cdm cvv cvv cxp c2nd cdm cin cvv cvv cxp c2nd cvv cvv cxp dmres cvv cvv
      cxp c2nd cdm inss1 eqsstri sstri cvv cvv relxp vy cv cG cfv csn cvv vy cv
      csn cxp cxp c2nd cvv cvv cxp cres ccom cdm cvv cvv cxp relss mp2 pm3.2i
      vy cv cG cfv csn cvv vy cv csn cxp cxp c2nd cvv cvv cxp cres ccom
      relrelss mpbi cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp wrel cvv vy
      cv cG cfv csn cxp cvv vy cv csn cxp cxp cdm wrel wa cvv vy cv cG cfv csn
      cxp cvv vy cv csn cxp cxp cvv cvv cxp cvv cxp wss cvv vy cv cG cfv csn
      cxp cvv vy cv csn cxp cxp wrel cvv vy cv cG cfv csn cxp cvv vy cv csn cxp
      cxp cdm wrel cvv vy cv cG cfv csn cxp cvv vy cv csn cxp relxp cvv vy cv
      cG cfv csn cxp cvv vy cv csn cxp cxp cdm cvv vy cv cG cfv csn cxp wss cvv
      vy cv cG cfv csn cxp wrel cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp
      cdm wrel cvv vy cv cG cfv csn cxp cvv vy cv csn cxp dmxpss cvv vy cv cG
      cfv csn relxp cvv vy cv cG cfv csn cxp cvv vy cv csn cxp cxp cdm cvv vy
      cv cG cfv csn cxp relss mp2 pm3.2i cvv vy cv cG cfv csn cxp cvv vy cv csn
      cxp cxp relrelss mpbi unssi vx vz vw vy cv cG cfv csn cvv vy cv csn cxp
      cxp c2nd cvv cvv cxp cres ccom cvv vy cv cG cfv csn cxp cvv vy cv csn cxp
      cxp eqrelrel ax-mp mpbir cnveqi cvv vy cv cG cfv csn cxp cvv vy cv csn
      cxp cnvxp 3eqtri a1i iuneq2dv 3eqtrd $.
      $( [4-Feb-2009] $) $( [22-Dec-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z G $.
    fpar.1 $e |- H = ( ( `' ( 1st |` ( _V X. _V ) )
                        o. ( F o. ( 1st |` ( _V X. _V ) ) ) )
                i^i ( `' ( 2nd |` ( _V X. _V ) )
                       o. ( G o. ( 2nd |` ( _V X. _V ) ) ) ) ) $.
    $( Merge two functions in parallel.  Use as the second argument of a
       composition with a (2-place) operation to build compound operations
       such as ` z = ( ( sqr `` x ) + ( abs `` y ) ) ` . $)
    fpar $p |- ( ( F Fn A /\ G Fn B )
                 -> H = { <. <. x , y >. , z >. |
            ( ( x e. A /\ y e. B ) /\ z = <. ( F ` x ) , ( G ` y ) >. ) } ) $=
      cF cA wfn cG cB wfn wa cH c1st cvv cvv cxp cres ccnv cF c1st cvv cvv cxp
      cres ccom ccom c2nd cvv cvv cxp cres ccnv cG c2nd cvv cvv cxp cres ccom
      ccom cin vx cA vx cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp ciun vy cB
      cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp ciun cin vx cv cA wcel vy
      cv cB wcel wa vz cv vx cv cF cfv vy cv cG cfv cop wceq wa vx vy vz copab2
      cH c1st cvv cvv cxp cres ccnv cF c1st cvv cvv cxp cres ccom ccom c2nd cvv
      cvv cxp cres ccnv cG c2nd cvv cvv cxp cres ccom ccom cin wceq cF cA wfn
      cG cB wfn wa fpar.1 a1i cF cA wfn cG cB wfn c1st cvv cvv cxp cres ccnv cF
      c1st cvv cvv cxp cres ccom ccom vx cA vx cv csn cvv cxp vx cv cF cfv csn
      cvv cxp cxp ciun c2nd cvv cvv cxp cres ccnv cG c2nd cvv cvv cxp cres ccom
      ccom vy cB cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp ciun vx cA cF
      fparlem3 vy cB cG fparlem4 ineqan12d vx cA vx cv csn cvv cxp vx cv cF cfv
      csn cvv cxp cxp ciun vy cB cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp
      ciun cin vx cv cA wcel vy cv cB wcel wa vz cv vx cv cF cfv vy cv cG cfv
      cop wceq wa vx vy vz copab2 wceq cF cA wfn cG cB wfn wa vx cA vy cB vx cv
      csn cvv cxp vx cv cF cfv csn cvv cxp cxp cvv vy cv csn cxp cvv vy cv cG
      cfv csn cxp cxp cin ciun ciun vx cA vy cB vx cv vy cv cop vx cv cF cfv vy
      cv cG cfv cop cop csn ciun ciun vx cA vx cv csn cvv cxp vx cv cF cfv csn
      cvv cxp cxp ciun vy cB cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp
      ciun cin vx cv cA wcel vy cv cB wcel wa vz cv vx cv cF cfv vy cv cG cfv
      cop wceq wa vx vy vz copab2 vx cA vy cB vx cv csn cvv cxp vx cv cF cfv
      csn cvv cxp cxp cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp cin ciun
      vy cB vx cv vy cv cop vx cv cF cfv vy cv cG cfv cop cop csn ciun vy cB vx
      cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp cvv vy cv csn cxp cvv vy cv
      cG cfv csn cxp cxp cin ciun vy cB vx cv vy cv cop vx cv cF cfv vy cv cG
      cfv cop cop csn ciun wceq vx cv cA wcel vy cB vx cv csn cvv cxp vx cv cF
      cfv csn cvv cxp cxp cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp cin vx
      cv vy cv cop vx cv cF cfv vy cv cG cfv cop cop csn vx cv csn cvv cxp vx
      cv cF cfv csn cvv cxp cxp cvv vy cv csn cxp cvv vy cv cG cfv csn cxp cxp
      cin vx cv vy cv cop vx cv cF cfv vy cv cG cfv cop cop csn wceq vy cv cB
      wcel vx cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp cvv vy cv csn cxp cvv
      vy cv cG cfv csn cxp cxp cin vx cv csn cvv cxp cvv vy cv csn cxp cin vx
      cv cF cfv csn cvv cxp cvv vy cv cG cfv csn cxp cin cxp vx cv vy cv cop
      csn vx cv cF cfv vy cv cG cfv cop csn cxp vx cv vy cv cop vx cv cF cfv vy
      cv cG cfv cop cop csn vx cv csn cvv cxp vx cv cF cfv csn cvv cxp cvv vy
      cv csn cxp cvv vy cv cG cfv csn cxp inxp vx cv csn cvv cxp cvv vy cv csn
      cxp cin vx cv cF cfv csn cvv cxp cvv vy cv cG cfv csn cxp cin cxp vx cv
      vy cv cop csn vx cv cF cfv csn cvv cxp cvv vy cv cG cfv csn cxp cin cxp
      vx cv vy cv cop csn vx cv cF cfv vy cv cG cfv cop csn cxp vx cv csn cvv
      cxp cvv vy cv csn cxp cin vx cv vy cv cop csn vx cv cF cfv csn cvv cxp
      cvv vy cv cG cfv csn cxp cin vx cv csn cvv cxp cvv vy cv csn cxp cin vx
      cv csn cvv cin cvv vy cv csn cin cxp vx cv csn vy cv csn cxp vx cv vy cv
      cop csn vx cv csn cvv cvv vy cv csn inxp vx cv csn cvv cin cvv vy cv csn
      cin cxp vx cv csn cvv vy cv csn cin cxp vx cv csn vy cv csn cxp vx cv csn
      cvv cin vx cv csn cvv vy cv csn cin vx cv csn inv1 xpeq1i cvv vy cv csn
      cin vy cv csn vx cv csn cvv vy cv csn cin vy cv csn cvv cin vy cv csn cvv
      vy cv csn incom vy cv csn inv1 eqtri xpeq2i eqtri vx cv vy cv vx visset
      vy visset xpsn 3eqtri xpeq1i vx cv cF cfv csn cvv cxp cvv vy cv cG cfv
      csn cxp cin vx cv cF cfv vy cv cG cfv cop csn vx cv vy cv cop csn vx cv
      cF cfv csn cvv cxp cvv vy cv cG cfv csn cxp cin vx cv cF cfv csn cvv cin
      cvv vy cv cG cfv csn cin cxp vx cv cF cfv csn vy cv cG cfv csn cxp vx cv
      cF cfv vy cv cG cfv cop csn vx cv cF cfv csn cvv cvv vy cv cG cfv csn
      inxp vx cv cF cfv csn cvv cin cvv vy cv cG cfv csn cin cxp vx cv cF cfv
      csn cvv vy cv cG cfv csn cin cxp vx cv cF cfv csn vy cv cG cfv csn cxp vx
      cv cF cfv csn cvv cin vx cv cF cfv csn cvv vy cv cG cfv csn cin vx cv cF
      cfv csn inv1 xpeq1i cvv vy cv cG cfv csn cin vy cv cG cfv csn vx cv cF
      cfv csn cvv vy cv cG cfv csn cin vy cv cG cfv csn cvv cin vy cv cG cfv
      csn cvv vy cv cG cfv csn incom vy cv cG cfv csn inv1 eqtri xpeq2i eqtri
      vx cv cF cfv vy cv cG cfv vx cv cF fvex vy cv cG fvex xpsn 3eqtri xpeq2i
      eqtri vx cv vy cv cop vx cv cF cfv vy cv cG cfv cop vx cv vy cv opex vx
      cv cF cfv vy cv cG cfv opex xpsn 3eqtri a1i iuneq2i a1i iuneq2i vx vy cA
      cB vx cv csn cvv cxp vx cv cF cfv csn cvv cxp cxp cvv vy cv csn cxp cvv
      vy cv cG cfv csn cxp cxp 2iunin vx vy vz cA cB vx cv cF cfv vy cv cG cfv
      cop vx cv cF cfv vy cv cG cfv opex iunfoprab 3eqtr3i a1i 3eqtrd $.
      $( [4-Feb-2009] $) $( [17-Sep-2007] $)
  $}

  ${
    $d w x y z $.
    $( A function that can be used to feed a common value to both operands
       of an operation.  Use as the second argument of a composition with
       the function of ~ fpar in order to build compound functions such
       as ` y = ( ( sqr `` x ) + ( abs `` x ) ) ` . $)
    fsplit $p |- `' ( 1st |` _I ) = { <. x , y >. | y = <. x , x >. } $=
      vw vz c1st cid cres ccnv vy cv vx cv vx cv cop wceq vx vy copab c1st cid
      cres relcnv vy cv vx cv vx cv cop wceq vx vy relopab vz cv vw cv cop c1st
      cid cres wcel vz cv vw cv vw cv cop wceq vw cv vz cv cop c1st cid cres
      ccnv wcel vw cv vz cv cop vy cv vx cv vx cv cop wceq vx vy copab wcel vz
      cv vw cv cop c1st cid cres wcel vz cv vw cv cop c1st wcel vz cv cid wcel
      wa vz cv vw cv vw cv cop wceq vz cv vw cv c1st cid vw visset opelres vz
      cv vw cv vw cv cop wceq vz cv c1st cfv vw cv wceq vz cv vx cv vx cv cop
      wceq wa vx wex vz cv c1st cfv vw cv wceq vz cv vx cv vx cv cop wceq vx
      wex wa vz cv vw cv cop c1st wcel vz cv cid wcel wa vz cv c1st cfv vw cv
      wceq vz cv vx cv vx cv cop wceq wa vx wex vx cv vw cv wceq vz cv vx cv vx
      cv cop wceq wa vx wex vz cv vw cv vw cv cop wceq vz cv c1st cfv vw cv
      wceq vz cv vx cv vx cv cop wceq wa vx cv vw cv wceq vz cv vx cv vx cv cop
      wceq wa vx vz cv vx cv vx cv cop wceq vz cv c1st cfv vw cv wceq vx cv vw
      cv wceq vz cv vx cv vx cv cop wceq vz cv c1st cfv vx cv vw cv vz cv vx cv
      vx cv cop wceq vz cv c1st cfv vx cv vx cv cop c1st cfv vx cv vz cv vx cv
      vx cv cop c1st fveq2 vx cv vx cv vx visset op1st syl6eq eqeq1d pm5.32ri
      exbii vz cv vx cv vx cv cop wceq vz cv vw cv vw cv cop wceq vx vw cv vw
      visset vx cv vw cv wceq vx cv vx cv cop vw cv vw cv cop vz cv vx cv vw cv
      wceq vx cv vx cv cop vw cv vx cv cop vw cv vw cv cop vx cv vw cv vx cv
      opeq1 vx cv vw cv vw cv opeq2 eqtrd eqeq2d ceqsexv bitr2i vz cv c1st cfv
      vw cv wceq vz cv vx cv vx cv cop wceq vx 19.42v vz cv c1st cfv vw cv wceq
      vz cv vw cv cop c1st wcel vz cv vx cv vx cv cop wceq vx wex vz cv cid
      wcel c1st cvv wfn vz cv cvv wcel vz cv c1st cfv vw cv wceq vz cv vw cv
      cop c1st wcel wb cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn
      ax-mp vz visset cvv vz cv vw cv c1st vw visset fnopfvb mp2an vz cv vx cv
      vy cv wceq vx vy copab wcel vz cv vx cv vy cv cop wceq vx cv vy cv wceq
      wa vy wex vx wex vz cv cid wcel vz cv vx cv vx cv cop wceq vx wex vx cv
      vy cv wceq vx vy vz cv elopab cid vx cv vy cv wceq vx vy copab vz cv vx
      vy df-id eleq2i vz cv vx cv vx cv cop wceq vz cv vx cv vy cv cop wceq vx
      cv vy cv wceq wa vy wex vx vz cv vx cv vx cv cop wceq vy cv vx cv wceq vz
      cv vx cv vy cv cop wceq wa vy wex vz cv vx cv vy cv cop wceq vx cv vy cv
      wceq wa vy wex vz cv vx cv vy cv cop wceq vz cv vx cv vx cv cop wceq vy
      vx cv vx visset vy cv vx cv wceq vx cv vy cv cop vx cv vx cv cop vz cv vy
      cv vx cv vx cv opeq2 eqeq2d ceqsexv vy cv vx cv wceq vz cv vx cv vy cv
      cop wceq wa vz cv vx cv vy cv cop wceq vx cv vy cv wceq wa vy vy cv vx cv
      wceq vz cv vx cv vy cv cop wceq wa vx cv vy cv wceq vz cv vx cv vy cv cop
      wceq wa vz cv vx cv vy cv cop wceq vx cv vy cv wceq wa vy cv vx cv wceq
      vx cv vy cv wceq vz cv vx cv vy cv cop wceq vy vx equcom anbi1i vx cv vy
      cv wceq vz cv vx cv vy cv cop wceq ancom bitri exbii bitr3i exbii
      3bitr4ri anbi12i 3bitrri bitri vw cv vz cv c1st cid cres vw visset vz
      visset opelcnv vy cv vx cv vx cv cop wceq vy cv vw cv vw cv cop wceq vz
      cv vw cv vw cv cop wceq vx vy vw cv vz cv vw visset vz visset vx cv vw cv
      wceq vx cv vx cv cop vw cv vw cv cop vy cv vx cv vw cv wceq vx cv vx cv
      cop vw cv vx cv cop vw cv vw cv cop vx cv vw cv vx cv opeq1 vx cv vw cv
      vw cv opeq2 eqtrd eqeq2d vy cv vz cv vw cv vw cv cop eqeq1 opelopab
      3bitr4i eqrelriv $.
      $( [3-Mar-2009] $) $( [17-Sep-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cantor's Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y F $.
    canth.1 $e |- A e. _V $.
    $( No set ` A ` is equinumerous to its power set (Cantor's theorem), i.e.
       no function can map ` A ` it onto its power set.  Compare Theorem 6B(b)
       of [Enderton] p. 132.  For the equinumerosity version, see ~ canth2 .
       Note that ` A ` must be a set:  this theorem does not hold when ` A ` is
       too large to be a set; see ~ ncanth for a counterexample.  (Use ~ nex
       if you want the form ` -. E. f f : A -onto-> ~P A ` .) $)
    canth $p |- -. F : A -onto-> ~P A $=
      cA cA cpw cF wfo cF crn cA cpw wceq cA cA cpw cF forn cA cA cpw cF wfo cA
      cA cpw cF wf vx cv vx cv cF cfv wcel wn vx cA crab cF crn wcel wn cF crn
      cA cpw wceq wn cA cA cpw cF fof cA cA cpw cF wf vy cv cF cfv vx cv vx cv
      cF cfv wcel wn vx cA crab wceq wn vy cA wral vx cv vx cv cF cfv wcel wn
      vx cA crab cF crn wcel wn vy cv cF cfv vx cv vx cv cF cfv wcel wn vx cA
      crab wceq wn vy cA vy cv cA wcel vy cv vy cv cF cfv wcel wn vy cv vx cv
      vx cv cF cfv wcel wn vx cA crab wcel wb vy cv cF cfv vx cv vx cv cF cfv
      wcel wn vx cA crab wceq wn vy cv vx cv vx cv cF cfv wcel wn vx cA crab
      wcel vy cv cA wcel vy cv vy cv cF cfv wcel wn vx cv vx cv cF cfv wcel wn
      vy cv vy cv cF cfv wcel wn vx vy cv cA vx cv vy cv wceq vx cv vx cv cF
      cfv wcel vy cv vy cv cF cfv wcel vx cv vy cv wceq vx cv vy cv vx cv cF
      cfv vy cv cF cfv vx cv vy cv wceq id vx cv vy cv cF fveq2 eleq12d notbid
      elrab baibr vy cv vy cv cF cfv wcel wn vy cv vx cv vx cv cF cfv wcel wn
      vx cA crab wcel wb vy cv vy cv cF cfv wcel vy cv vx cv vx cv cF cfv wcel
      wn vx cA crab wcel wb wn vy cv cF cfv vx cv vx cv cF cfv wcel wn vx cA
      crab wceq wn vy cv vy cv cF cfv wcel vy cv vx cv vx cv cF cfv wcel wn vx
      cA crab wcel nbbn vy cv cF cfv vx cv vx cv cF cfv wcel wn vx cA crab wceq
      vy cv vy cv cF cfv wcel vy cv vx cv vx cv cF cfv wcel wn vx cA crab wcel
      wb vy cv cF cfv vx cv vx cv cF cfv wcel wn vx cA crab vy cv eleq2 con3i
      sylbi syl rgen cA cA cpw cF wf vy cv cF cfv vx cv vx cv cF cfv wcel wn vx
      cA crab wceq vy cA wrex wn vx cv vx cv cF cfv wcel wn vx cA crab cF crn
      wcel wn vy cv cF cfv vx cv vx cv cF cfv wcel wn vx cA crab wceq wn vy cA
      wral cA cA cpw cF wf vx cv vx cv cF cfv wcel wn vx cA crab cF crn wcel vy
      cv cF cfv vx cv vx cv cF cfv wcel wn vx cA crab wceq vy cA wrex cA cA cpw
      cF wf cF cA wfn vx cv vx cv cF cfv wcel wn vx cA crab cF crn wcel vy cv
      cF cfv vx cv vx cv cF cfv wcel wn vx cA crab wceq vy cA wrex wi cA cA cpw
      cF ffn cF cA wfn vx cv vx cv cF cfv wcel wn vx cA crab cF crn wcel vy cv
      cF cfv vx cv vx cv cF cfv wcel wn vx cA crab wceq vy cA wrex vy cA vx cv
      vx cv cF cfv wcel wn vx cA crab cF fvelrnb biimpd syl con3d vy cv cF cfv
      vx cv vx cv cF cfv wcel wn vx cA crab wceq vy cA ralnex syl5ib mpi cF crn
      cA cpw wceq vx cv vx cv cF cfv wcel wn vx cA crab cF crn wcel cF crn cA
      cpw wceq vx cv vx cv cF cfv wcel wn vx cA crab cF crn wcel vx cv vx cv cF
      cfv wcel wn vx cA crab cA cpw wcel vx cv vx cv cF cfv wcel wn vx cA crab
      cA cpw wcel vx cv vx cv cF cfv wcel wn vx cA crab cA wss vx cv vx cv cF
      cfv wcel wn vx cA ssrab2 vx cv vx cv cF cfv wcel wn vx cA crab cA vx cv
      vx cv cF cfv wcel wn vx cA canth.1 rabex elpw mpbir cF crn cA cpw vx cv
      vx cv cF cfv wcel wn vx cA crab eleq2 mpbiri con3i 3syl pm2.65i $.
      $( [7-Aug-1994] $)
  $}

  $( Cantor's theorem fails for the universal class (which is not a set but a
     proper class by ~ vprc ).  Specifically, the identity function maps the
     universe onto its power class.  Compare ~ canth that works for sets.  See
     also the remark in ~ ru about NF, in which Cantor's theorem fails for sets
     that are "too large."  This theorem gives some intuition behind that
     failure:  in NF the universal class is a set, and it equals its own power
     set. $)
  ncanth $p |- _I : _V -onto-> ~P _V $=
    cvv cvv cpw cid wf1o cvv cvv cpw cid wfo cvv cvv cpw cid wf1o cvv cvv cid
    wf1o f1ovi cvv cpw cvv wceq cvv cvv cpw cid wf1o cvv cvv cid wf1o wb pwv
    cvv cpw cvv cvv cid f1oeq3 ax-mp mpbir cvv cvv cpw cid f1ofo ax-mp $.
    $( [29-Jun-2004] $) $( [29-Jun-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Miscellaneous ordinal theorems (that depend on functions and relations)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d y z B $.
    iunon.1 $e |- A e. _V $.
    iunon.2 $e |- B e. _V $.
    $( The indexed union of a set of ordinal numbers ` B ( x ) ` is an ordinal
       number. $)
    iunon $p |- ( A. x e. A B e. On -> U_ x e. A B e. On ) $=
      cB con0 wcel vx cA wral vy cv cB wceq vx cA wrex vy cab cuni con0 vx cA
      cB ciun cB con0 wcel vx cA wral vy cv cB wceq vx cA wrex vy cab con0 wss
      vy cv cB wceq vx cA wrex vy cab cuni con0 wcel cB con0 wcel vx cA wral vy
      cv vy cv cB wceq vx cA wrex vy cab wcel vy cv con0 wcel wi vy wal vy cv
      cB wceq vx cA wrex vy cab con0 wss cB con0 wcel vx cA wral vy cv vy cv cB
      wceq vx cA wrex vy cab wcel vy cv con0 wcel wi vy cB con0 wcel vx cA wral
      vy cv cB wceq vx cA wrex vy cv con0 wcel vy cv vy cv cB wceq vx cA wrex
      vy cab wcel cB con0 wcel vx cA wral vy cv cB wceq vy cv con0 wcel vx cA
      cB con0 wcel vx cA hbra1 vy cv con0 wcel vx ax-17 cB con0 wcel vx cA wral
      vx cv cA wcel cB con0 wcel vy cv cB wceq vy cv con0 wcel wi cB con0 wcel
      vx cA ra4 cB con0 vy cv eleq1a syl6 r19.23ad vy cv cB wceq vx cA wrex vy
      abid syl5ib 19.21aiv vy vz vy cv cB wceq vx cA wrex vy cab con0 vy cv cB
      wceq vx cA wrex vy vz hbab1 vz cv con0 wcel vy ax-17 dfss2f sylibr vy cv
      cB wceq vx cA wrex vy cab vx vy cA cB iunon.1 abrexex ssonunii syl vx vy
      cA cB iunon.2 dfiun2 syl5eqel $.
      $( [14-Oct-2003] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y z A $.  $d y z B $.
    iinon.1 $e |- B e. _V $.
    $( The nonempty indexed intersection of a class of ordinal numbers
       ` B ( x ) ` is an ordinal number. $)
    iinon $p |- ( ( A. x e. A B e. On /\ A =/= (/) ) ->
                |^|_ x e. A B e. On ) $=
      cB con0 wcel vx cA wral cA c0 wne wa vy cv cB wceq vx cA wrex vy cab cint
      con0 vx cA cB ciin vy cv cB wceq vx cA wrex vy cab con0 wss cA c0 wne vy
      cv cB wceq vx cA wrex vy cab cint con0 wcel cB con0 wcel vx cA wral vy cv
      cB wceq vx cA wrex vy cab con0 wss vy cv cB wceq vx cA wrex vy cab c0 wne
      vy cv cB wceq vx cA wrex vy cab cint con0 wcel cA c0 wne vy cv cB wceq vx
      cA wrex vy cab oninton vx cv cA wcel vx wex vy cv cB wceq vx cA wrex vy
      wex cA c0 wne vy cv cB wceq vx cA wrex vy cab c0 wne vy cv cB wceq vx cA
      wrex vy wex vx cv cA wcel vy cv cB wceq wa vx wex vy wex vx cv cA wcel vy
      cv cB wceq wa vy wex vx wex vx cv cA wcel vx wex vy cv cB wceq vx cA wrex
      vx cv cA wcel vy cv cB wceq wa vx wex vy vy cv cB wceq vx cA df-rex exbii
      vx cv cA wcel vy cv cB wceq wa vx vy excom vx cv cA wcel vy cv cB wceq wa
      vy wex vx cv cA wcel vx vx cv cA wcel vy cv cB wceq wa vy wex vx cv cA
      wcel vy cv cB wceq vy wex vx cv cA wcel vy cv cB wceq vy 19.42v vy cB
      iinon.1 isseti mpbiran2 exbii 3bitr2ri vx cA n0 vy cv cB wceq vx cA wrex
      vy abn0 3bitr4i sylan2b cB con0 wcel vx cA wral vy cv vy cv cB wceq vx cA
      wrex vy cab wcel vy cv con0 wcel wi vy wal vy cv cB wceq vx cA wrex vy
      cab con0 wss cB con0 wcel vx cA wral vy cv vy cv cB wceq vx cA wrex vy
      cab wcel vy cv con0 wcel wi vy cB con0 wcel vx cA wral vy cv cB wceq vx
      cA wrex vy cv con0 wcel vy cv vy cv cB wceq vx cA wrex vy cab wcel cB
      con0 wcel vx cA wral vy cv cB wceq vy cv con0 wcel vx cA cB con0 wcel vx
      cA hbra1 vy cv con0 wcel vx ax-17 cB con0 wcel vx cA wral vx cv cA wcel
      cB con0 wcel vy cv cB wceq vy cv con0 wcel wi cB con0 wcel vx cA ra4 cB
      con0 vy cv eleq1a syl6 r19.23ad vy cv cB wceq vx cA wrex vy abid syl5ib
      19.21aiv vy vz vy cv cB wceq vx cA wrex vy cab con0 vy cv cB wceq vx cA
      wrex vy vz hbab1 vz cv con0 wcel vy ax-17 dfss2f sylibr sylan vx vy cA cB
      iinon.1 dfiin2 syl5eqel $.
      $( [17-May-2007] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y S $.  $d x y F $.  $d x T $.
    onfununi.1 $e |- ( Lim y -> ( F ` y ) = U_ x e. y ( F ` x ) ) $.
    onfununi.2 $e |- ( ( x e. On /\ y e. On /\ x C_ y )
                  -> ( F ` x ) C_ ( F ` y ) ) $.
    $( A property of functions on ordinal numbers.  Generalization of Theorem
       Schema 8E of [Enderton] p. 218.  (Contributed by Eric Schmidt,
       26-May-2009.) $)
    onfununi $p |- ( ( S e. T /\ S C_ On /\ S =/= (/) )
                -> ( F ` U. S ) = U_ x e. S ( F ` x ) ) $=
      cS cT wcel cS con0 wss cS c0 wne w3a cS cuni cF cfv vx cS vx cv cF cfv
      ciun cS cT wcel cS con0 wss cS c0 wne w3a cS cuni cS wcel cS cuni cF cfv
      vx cS vx cv cF cfv ciun wss cS cT wcel cS con0 wss cS c0 wne w3a cS cuni
      cS wcel wn cS cuni cF cfv vx cS vx cv cF cfv ciun wss cS cT wcel cS con0
      wss cS c0 wne w3a cS cuni cS wcel wn wa cS cuni cF cfv vx cS cuni vx cv
      cF cfv ciun vx cS vx cv cF cfv ciun cS cT wcel cS con0 wss cS c0 wne w3a
      cS cuni cS wcel wn wa cS cuni wlim cS cuni cF cfv vx cS cuni vx cv cF cfv
      ciun wceq cS con0 wss cS c0 wne cS cuni cS wcel wn cS cuni wlim cS cT
      wcel cS con0 wss cS cuni cS wcel wn cS c0 wne cS cuni wlim cS con0 wss cS
      cuni cS wcel wn wa cS c0 wne wa cS cuni word cS cuni c0 wne cS cuni cS
      cuni cuni wceq w3a cS cuni wlim cS con0 wss cS cuni cS wcel wn wa cS c0
      wne wa cS cuni word cS cuni c0 wne cS cuni cS cuni cuni wceq cS con0 wss
      cS cuni word cS cuni cS wcel wn cS c0 wne cS ssorduni ad2antrr cS cS cuni
      wss cS c0 wne cS cuni c0 wne cS con0 wss cS cuni cS wcel wn wa cS cS cuni
      ssn0 cS con0 wss cS cuni cS wcel wn wa vx cS cS cuni cS con0 wss cS cuni
      cS wcel wn vx cv cS wcel vx cv cS cuni wcel wi cS con0 wss vx cv cS wcel
      cS cuni cS wcel wn vx cv cS cuni wcel cS con0 wss vx cv cS wcel cS cuni
      cS wcel wn vx cv cS cuni wcel wi cS con0 wss vx cv cS wcel vx cv cS wcel
      cS cuni cS wcel wn vx cv cS cuni wcel cS con0 wss vx cv cS wcel wa vx cv
      cS cuni wceq wn vx cv cS cuni wcel vx cv cS wcel cS cuni cS wcel wn wa cS
      con0 wss vx cv cS wcel wa vx cv cS cuni wcel vx cv cS cuni wceq cS con0
      wss vx cv cS wcel wa vx cv cS cuni wcel vx cv cS cuni wceq cS con0 wss vx
      cv cS wcel wa vx cv cS cuni wss vx cv cS cuni wcel vx cv cS cuni wceq wo
      vx cv cS wcel vx cv cS cuni wss cS con0 wss vx cv cS elssuni adantl cS
      con0 wss vx cv cS wcel vx cv cS cuni wss vx cv cS cuni wcel vx cv cS cuni
      wceq wo wb vx cv word cS cuni word vx cv cS cuni wss vx cv cS cuni wcel
      vx cv cS cuni wceq wo wb cS con0 wss vx cv cS wcel wa cS con0 wss vx cv
      cS cuni ordsseleq cS con0 wss vx cv cS wcel vx cv word cS con0 wss vx cv
      cS wcel vx cv con0 wcel vx cv word cS con0 vx cv ssel vx cv eloni syl6
      imp cS ssorduni syl2an anabss1 mpbid ord con1d vx cv cS cuni cS nelneq
      syl5 exp4b pm2.43d com23 imp ssrdv sylan cS con0 wss cS cuni cS wcel wn
      wa cS cuni cS cuni cuni wceq cS c0 wne cS con0 wss cS cuni cS wcel wn wa
      cS cuni cS cuni cuni cS con0 wss cS cuni cS wcel wn wa cS cS cuni wss cS
      cuni cS cuni cuni wss cS con0 wss cS cuni cS wcel wn wa vx cS cS cuni cS
      con0 wss cS cuni cS wcel wn vx cv cS wcel vx cv cS cuni wcel wi cS con0
      wss vx cv cS wcel cS cuni cS wcel wn vx cv cS cuni wcel cS con0 wss vx cv
      cS wcel cS cuni cS wcel wn vx cv cS cuni wcel wi cS con0 wss vx cv cS
      wcel vx cv cS wcel cS cuni cS wcel wn vx cv cS cuni wcel cS con0 wss vx
      cv cS wcel wa vx cv cS cuni wceq wn vx cv cS cuni wcel vx cv cS wcel cS
      cuni cS wcel wn wa cS con0 wss vx cv cS wcel wa vx cv cS cuni wcel vx cv
      cS cuni wceq cS con0 wss vx cv cS wcel wa vx cv cS cuni wcel vx cv cS
      cuni wceq cS con0 wss vx cv cS wcel wa vx cv cS cuni wss vx cv cS cuni
      wcel vx cv cS cuni wceq wo vx cv cS wcel vx cv cS cuni wss cS con0 wss vx
      cv cS elssuni adantl cS con0 wss vx cv cS wcel vx cv cS cuni wss vx cv cS
      cuni wcel vx cv cS cuni wceq wo wb vx cv word cS cuni word vx cv cS cuni
      wss vx cv cS cuni wcel vx cv cS cuni wceq wo wb cS con0 wss vx cv cS wcel
      wa cS con0 wss vx cv cS cuni ordsseleq cS con0 wss vx cv cS wcel vx cv
      word cS con0 wss vx cv cS wcel vx cv con0 wcel vx cv word cS con0 vx cv
      ssel vx cv eloni syl6 imp cS ssorduni syl2an anabss1 mpbid ord con1d vx
      cv cS cuni cS nelneq syl5 exp4b pm2.43d com23 imp ssrdv cS cS cuni uniss
      syl cS con0 wss cS cuni cuni cS cuni wss cS cuni cS wcel wn cS con0 wss
      cS cuni word cS cuni cuni cS cuni wss cS ssorduni cS cuni orduniss syl
      adantr eqssd adantr 3jca cS cuni df-lim sylibr an1rs 3adantl1 cS cT wcel
      cS con0 wss cS c0 wne w3a cS cuni wlim cS cuni cF cfv vx cS cuni vx cv cF
      cfv ciun wceq wi cS cuni cS wcel wn cS cT wcel cS con0 wss cS cuni wlim
      cS cuni cF cfv vx cS cuni vx cv cF cfv ciun wceq wi cS c0 wne cS cT wcel
      cS con0 wss cS cuni wlim cS cuni cF cfv vx cS cuni vx cv cF cfv ciun wceq
      wi cS cT wcel cS con0 wss cS cuni con0 wcel cS cuni wlim cS cuni cF cfv
      vx cS cuni vx cv cF cfv ciun wceq wi cS cT ssonuni vy cv wlim vy cv cF
      cfv vx vy cv vx cv cF cfv ciun wceq wi cS cuni wlim cS cuni cF cfv vx cS
      cuni vx cv cF cfv ciun wceq wi vy cS cuni con0 vy cv cS cuni wceq vy cv
      wlim cS cuni wlim vy cv cF cfv vx vy cv vx cv cF cfv ciun wceq cS cuni cF
      cfv vx cS cuni vx cv cF cfv ciun wceq vy cv cS cuni limeq vy cv cS cuni
      wceq vy cv cF cfv cS cuni cF cfv vx vy cv vx cv cF cfv ciun vx cS cuni vx
      cv cF cfv ciun vy cv cS cuni cF fveq2 vx vy cv cS cuni vx cv cF cfv
      iuneq1 eqeq12d imbi12d onfununi.1 vtoclg syl6 imp 3adant3 adantr mpd cS
      cT wcel cS con0 wss cS c0 wne w3a vx cS cuni vx cv cF cfv ciun vx cS vx
      cv cF cfv ciun wss cS cuni cS wcel wn cS con0 wss cS cT wcel vx cS cuni
      vx cv cF cfv ciun vx cS vx cv cF cfv ciun wss cS c0 wne cS con0 wss vx cS
      cuni vx cv cF cfv ciun vy cS vy cv cF cfv ciun vx cS vx cv cF cfv ciun cS
      con0 wss vx cv cF cfv vy cS vy cv cF cfv ciun wss vx cS cuni wral vx cS
      cuni vx cv cF cfv ciun vy cS vy cv cF cfv ciun wss cS con0 wss vx cv cF
      cfv vy cS vy cv cF cfv ciun wss vx cS cuni cS con0 wss vx cv cS cuni wcel
      vx cv cF cfv vy cv cF cfv wss vy cS wrex vx cv cF cfv vy cS vy cv cF cfv
      ciun wss cS con0 wss vx cv vy cv wcel vy cS wrex vx cv cF cfv vy cv cF
      cfv wss vy cS wrex vx cv cS cuni wcel cS con0 wss vx cv vy cv wcel vx cv
      cF cfv vy cv cF cfv wss vy cS cS con0 wss vy cv cS wcel vx cv vy cv wcel
      vx cv cF cfv vy cv cF cfv wss cS con0 wss vy cv cS wcel vx cv vy cv wcel
      wa vx cv con0 wcel vy cv con0 wcel vx cv vy cv wss w3a vx cv cF cfv vy cv
      cF cfv wss cS con0 wss vy cv cS wcel vx cv vy cv wcel wa vx cv con0 wcel
      vy cv con0 wcel vx cv vy cv wss cS con0 wss vy cv cS wcel vx cv vy cv
      wcel wa vy cv con0 wcel vx cv vy cv wcel wa vx cv con0 wcel cS con0 wss
      vy cv cS wcel vy cv con0 wcel vx cv vy cv wcel cS con0 vy cv ssel anim1d
      vy cv vx cv onelon syl6 cS con0 wss vy cv cS wcel vy cv con0 wcel vx cv
      vy cv wcel cS con0 vy cv ssel adantrd cS con0 wss vy cv word vx cv vy cv
      wcel vx cv vy cv wss vy cv cS wcel vy cv word vx cv vy cv wcel wa vx cv
      vy cv wss wi cS con0 wss vy cv vx cv ordelss a1i cS con0 wss vy cv cS
      wcel vy cv con0 wcel vy cv word cS con0 vy cv ssel vy cv eloni syl6
      syland 3jcad onfununi.2 syl6 exp3a r19.22dv vy vx cv cS eluni2 syl5ib vy
      cS vy cv cF cfv vx cv cF cfv ssiun syl6 r19.21aiv vx cS cuni vx cv cF cfv
      vy cS vy cv cF cfv ciun iunss sylibr vy vx cS vy cv cF cfv vx cv cF cfv
      vy cv vx cv cF fveq2 cbviunv syl6ss 3ad2ant2 adantr eqsstrd ex vx cS vx
      cv cF cfv cS cuni cS cuni cF cfv vx cv cS cuni cF fveq2 ssiun2s pm2.61d2
      cS cT wcel cS con0 wss cS c0 wne w3a vx cv cF cfv cS cuni cF cfv wss vx
      cS wral vx cS vx cv cF cfv ciun cS cuni cF cfv wss cS cT wcel cS con0 wss
      cS c0 wne w3a vx cv cF cfv cS cuni cF cfv wss vx cS cS cT wcel cS con0
      wss cS c0 wne w3a vx cv cS wcel vx cv con0 wcel vx cv cS cuni wss wa vx
      cv cF cfv cS cuni cF cfv wss cS cT wcel cS con0 wss cS c0 wne w3a vx cv
      cS wcel vx cv con0 wcel vx cv cS cuni wss cS con0 wss cS cT wcel vx cv cS
      wcel vx cv con0 wcel wi cS c0 wne cS con0 vx cv ssel 3ad2ant2 vx cv cS
      wcel vx cv cS cuni wss wi cS cT wcel cS con0 wss cS c0 wne w3a vx cv cS
      elssuni a1i jcad cS cT wcel cS con0 wss cS c0 wne w3a cS cuni con0 wcel
      vx cv con0 wcel vx cv cS cuni wss wa vx cv cF cfv cS cuni cF cfv wss wi
      cS cT wcel cS con0 wss cS cuni con0 wcel cS c0 wne cS cT wcel cS con0 wss
      cS cuni con0 wcel cS cT ssonuni imp 3adant3 vx cv con0 wcel vx cv vy cv
      wss wa vx cv cF cfv vy cv cF cfv wss wi vx cv con0 wcel vx cv cS cuni wss
      wa vx cv cF cfv cS cuni cF cfv wss wi vy cS cuni con0 vy cv cS cuni wceq
      vx cv con0 wcel vx cv vy cv wss wa vx cv con0 wcel vx cv cS cuni wss wa
      vx cv cF cfv vy cv cF cfv wss vx cv cF cfv cS cuni cF cfv wss vy cv cS
      cuni wceq vx cv vy cv wss vx cv cS cuni wss vx cv con0 wcel vy cv cS cuni
      vx cv sseq2 anbi2d vy cv cS cuni wceq vy cv cF cfv cS cuni cF cfv vx cv
      cF cfv vy cv cS cuni cF fveq2 sseq2d imbi12d vy cv con0 wcel vx cv con0
      wcel vx cv vy cv wss vx cv cF cfv vy cv cF cfv wss vx cv con0 wcel vy cv
      con0 wcel vx cv vy cv wss vx cv cF cfv vy cv cF cfv wss onfununi.2 3com12
      3expib vtoclga syl syld r19.21aiv vx cS vx cv cF cfv cS cuni cF cfv iunss
      sylibr eqssd $.
      $( [26-May-2009] $) $( [26-May-2009] $)
  $}

  ${
    $d w x y z A $.  $d w x y z F $.  $d w x y z K $.  $d w x y L $.
    $d w x y z S $.  $d x T $.
    onopruni.1 $e |- ( Lim y -> ( A F y ) = U_ x e. y ( A F x ) ) $.
    onopruni.2 $e |- ( ( x e. On /\ y e. On /\ x C_ y )
                  -> ( A F x ) C_ ( A F y ) ) $.
    $( A variant of ~ onfununi for operations.  (Contributed by Eric Schmidt,
       26-May-2009.) $)
    onopruni $p |- ( ( S e. T /\ S C_ On /\ S =/= (/) )
                   -> ( A F U. S ) = U_ x e. S ( A F x ) ) $=
      cS cT wcel cS con0 wss cS c0 wne w3a cS cuni vw cv cA vz cv cF co wceq vz
      vw copab cfv vx cS vx cv vw cv cA vz cv cF co wceq vz vw copab cfv ciun
      cA cS cuni cF co vx cS cA vx cv cF co ciun vx vy cS cT vw cv cA vz cv cF
      co wceq vz vw copab vy cv wlim cA vy cv cF co vx vy cv cA vx cv cF co
      ciun vy cv vw cv cA vz cv cF co wceq vz vw copab cfv vx vy cv vx cv vw cv
      cA vz cv cF co wceq vz vw copab cfv ciun onopruni.1 vz vw vy cv cA vz cv
      cF co cA vy cv cF co vy visset cA vy cv cF oprex vz cv vy cv cA cF opreq2
      fvopab vx vy cv vx cv vw cv cA vz cv cF co wceq vz vw copab cfv cA vx cv
      cF co vx cv vw cv cA vz cv cF co wceq vz vw copab cfv cA vx cv cF co wceq
      vx cv vy cv wcel vz vw vx cv cA vz cv cF co cA vx cv cF co vx visset cA
      vx cv cF oprex vz cv vx cv cA cF opreq2 fvopab a1i iuneq2i 3eqtr4g vx cv
      con0 wcel vy cv con0 wcel vx cv vy cv wss w3a cA vx cv cF co cA vy cv cF
      co vx cv vw cv cA vz cv cF co wceq vz vw copab cfv vy cv vw cv cA vz cv
      cF co wceq vz vw copab cfv onopruni.2 vz vw vx cv cA vz cv cF co cA vx cv
      cF co vx visset cA vx cv cF oprex vz cv vx cv cA cF opreq2 fvopab vz vw
      vy cv cA vz cv cF co cA vy cv cF co vy visset cA vy cv cF oprex vz cv vy
      cv cA cF opreq2 fvopab 3sstr4g onfununi cS cT wcel cS con0 wss cS cuni vw
      cv cA vz cv cF co wceq vz vw copab cfv cA cS cuni cF co wceq cS c0 wne cS
      cuni cvv wcel cA cS cuni cF co cvv wcel cS cuni vw cv cA vz cv cF co wceq
      vz vw copab cfv cA cS cuni cF co wceq cS cT wcel vz vw cS cuni cA vz cv
      cF co cA cS cuni cF co cvv cvv vz cv cS cuni cA cF opreq2 fvopabg cS cT
      uniexg cA cS cuni cF oprex sylancl 3ad2ant1 vx cS vx cv vw cv cA vz cv cF
      co wceq vz vw copab cfv ciun vx cS cA vx cv cF co ciun wceq cS cT wcel cS
      con0 wss cS c0 wne w3a vx cS vx cv vw cv cA vz cv cF co wceq vz vw copab
      cfv cA vx cv cF co vx cv vw cv cA vz cv cF co wceq vz vw copab cfv cA vx
      cv cF co wceq vx cv cS wcel vz vw vx cv cA vz cv cF co cA vx cv cF co vx
      visset cA vx cv cF oprex vz cv vx cv cA cF opreq2 fvopab a1i iuneq2i a1i
      3eqtr3d $.
      $( [26-May-2009] $) $( [26-May-2009] $)

    $( A variant of ~ onopruni with indexed unions.  (Contributed by Eric
       Schmidt, 26-May-2009.) $)
    onopriun $p |- ( ( K e. T /\ A. z e. K L e. On /\ K =/= (/) )
                -> ( A F U_ z e. K L ) = U_ z e. K ( A F L ) ) $=
      cK cT wcel cL con0 wcel vz cK wral cK c0 wne w3a cA vz cK cL ciun cF co
      cA vw cv cL wceq vz cK wrex vw cab cuni cF co vx vw cv cL wceq vz cK wrex
      vw cab cA vx cv cF co ciun vz cK cA cL cF co ciun cL con0 wcel vz cK wral
      cK cT wcel cA vz cK cL ciun cF co cA vw cv cL wceq vz cK wrex vw cab cuni
      cF co wceq cK c0 wne cL con0 wcel vz cK wral vz cK cL ciun vw cv cL wceq
      vz cK wrex vw cab cuni cA cF vz vw cK cL con0 dfiun2g opreq2d 3ad2ant2 vw
      cv cL wceq vz cK wrex vw cab cvv wcel vw cv cL wceq vz cK wrex vw cab
      con0 wss vw cv cL wceq vz cK wrex vw cab c0 wne cA vw cv cL wceq vz cK
      wrex vw cab cuni cF co vx vw cv cL wceq vz cK wrex vw cab cA vx cv cF co
      ciun wceq cK cT wcel cL con0 wcel vz cK wral cK c0 wne w3a vx vy cA vw cv
      cL wceq vz cK wrex vw cab cvv cF onopruni.1 onopruni.2 onopruni cK cT
      wcel cL con0 wcel vz cK wral vw cv cL wceq vz cK wrex vw cab cvv wcel cK
      c0 wne vz vw cK cL cT abrexexg 3ad2ant1 cL con0 wcel vz cK wral cK cT
      wcel vw cv cL wceq vz cK wrex vw cab con0 wss cK c0 wne cL con0 wcel vz
      cK wral vw cv cL wceq vz cK wrex vw con0 cL con0 wcel vz cK wral vw cv cL
      wceq vw cv con0 wcel vz cK cL con0 wcel vz cK hbra1 vw cv con0 wcel vz
      ax-17 cL con0 wcel vz cK wral vw cv cL wceq vz cv cK wcel vw cv con0 wcel
      cL con0 wcel vz cK wral vz cv cK wcel cL con0 wcel vw cv cL wceq vw cv
      con0 wcel cL con0 wcel vz cK ra4 vw cv cL wceq vw cv con0 wcel cL con0
      wcel vw cv cL con0 eleq1 biimprd syl9 com23 r19.23ad abssdv 3ad2ant2 cL
      con0 wcel vz cK wral cK c0 wne vw cv cL wceq vz cK wrex vw cab c0 wne cK
      cT wcel cK c0 wne cL con0 wcel vz cK wral vw cv cL wceq vz cK wrex vw cab
      c0 wne cK c0 wne cL con0 wcel vz cK wral wa vw cv cL wceq vz cK wrex vw
      wex vw cv cL wceq vz cK wrex vw cab c0 wne cK c0 wne cL con0 wcel vz cK
      wral wa vw cv cL wceq vw wex vz cK wrex vw cv cL wceq vz cK wrex vw wex
      cK c0 wne cL con0 wcel vz cK wral wa cL con0 wcel vz cK wrex vw cv cL
      wceq vw wex vz cK wrex cL con0 wcel vz cK r19.2z cL con0 wcel vw cv cL
      wceq vw wex vz cK vw cL con0 elex r19.22si syl vw cv cL wceq vz vw cK
      rexcom4 sylib vw cv cL wceq vz cK wrex vw abn0 sylibr ancoms 3adant1
      syl3anc cL con0 wcel vz cK wral cK cT wcel vx vw cv cL wceq vz cK wrex vw
      cab cA vx cv cF co ciun vz cK cA cL cF co ciun wceq cK c0 wne cL con0
      wcel vz cK wral vy cv cA vx cv cF co wceq vx vw cv cL wceq vz cK wrex vw
      cab wrex vy cab cuni vy cv cA cL cF co wceq vz cK wrex vy cab cuni vx vw
      cv cL wceq vz cK wrex vw cab cA vx cv cF co ciun vz cK cA cL cF co ciun
      cL con0 wcel vz cK wral vy cv cA vx cv cF co wceq vx vw cv cL wceq vz cK
      wrex vw cab wrex vy cab vy cv cA cL cF co wceq vz cK wrex vy cab cL con0
      wcel vz cK wral vy cv cA vx cv cF co wceq vx vw cv cL wceq vz cK wrex vw
      cab wrex vy cv cA cL cF co wceq vz cK wrex vy cL con0 wcel vz cK wral vx
      cv cL wceq vy cv cA vx cv cF co wceq wa vx wex vz cK wrex vy cv cA cL cF
      co wceq vz cK wrex vy cv cA vx cv cF co wceq vx vw cv cL wceq vz cK wrex
      vw cab wrex cL con0 wcel vz cK wral vx cv cL wceq vy cv cA vx cv cF co
      wceq wa vx wex vy cv cA cL cF co wceq vz cK cL con0 wcel vz cK hbra1 cL
      con0 wcel vz cK wral vz cv cK wcel wa cL con0 wcel vx cv cL wceq vy cv cA
      vx cv cF co wceq wa vx wex vy cv cA cL cF co wceq wb cL con0 wcel vz cK
      wral vz cv cK wcel cL con0 wcel cL con0 wcel vz cK ra4 imp vy cv cA vx cv
      cF co wceq vy cv cA cL cF co wceq vx cL con0 vx cv cL wceq cA vx cv cF co
      cA cL cF co vy cv vx cv cL cA cF opreq2 eqeq2d ceqsexgv syl rexbida vx cv
      vw cv cL wceq vz cK wrex vw cab wcel vy cv cA vx cv cF co wceq wa vx wex
      vx cv cL wceq vy cv cA vx cv cF co wceq wa vz cK wrex vx wex vy cv cA vx
      cv cF co wceq vx vw cv cL wceq vz cK wrex vw cab wrex vx cv cL wceq vy cv
      cA vx cv cF co wceq wa vx wex vz cK wrex vx cv vw cv cL wceq vz cK wrex
      vw cab wcel vy cv cA vx cv cF co wceq wa vx cv cL wceq vy cv cA vx cv cF
      co wceq wa vz cK wrex vx vx cv vw cv cL wceq vz cK wrex vw cab wcel vy cv
      cA vx cv cF co wceq wa vx cv cL wceq vz cK wrex vy cv cA vx cv cF co wceq
      wa vx cv cL wceq vy cv cA vx cv cF co wceq wa vz cK wrex vx cv vw cv cL
      wceq vz cK wrex vw cab wcel vx cv cL wceq vz cK wrex vy cv cA vx cv cF co
      wceq vw cv cL wceq vz cK wrex vx cv cL wceq vz cK wrex vw vx cv vx visset
      vw cv vx cv wceq vw cv cL wceq vx cv cL wceq vz cK vw cv vx cv cL eqeq1
      rexbidv elab anbi1i vx cv cL wceq vy cv cA vx cv cF co wceq vz cK r19.41v
      bitr4i exbii vy cv cA vx cv cF co wceq vx vw cv cL wceq vz cK wrex vw cab
      df-rex vx cv cL wceq vy cv cA vx cv cF co wceq wa vz vx cK rexcom4
      3bitr4i syl5bb abbidv unieqd vx vy vw cv cL wceq vz cK wrex vw cab cA vx
      cv cF co cA vx cv cF oprex dfiun2 vz vy cK cA cL cF co cA cL cF oprex
      dfiun2 3eqtr4g 3ad2ant2 3eqtrd $.
      $( [26-May-2009] $) $( [26-May-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Transfinite recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z w F $.  $d x y z w G $.
    $( A technical lemma for transfinite recursion.  Compare Lemma 1 of
       [TakeutiZaring] p. 47. $)
    tfrlem1 $p |- ( A e. On -> ( ( F Fn A /\ G Fn A ) ->
                  ( A. x e. A ( ( F ` x ) = ( B ` ( F |` x ) ) /\
                                        ( G ` x ) = ( B ` ( G |` x ) ) ) ->
                  A. x e. A ( F ` x ) = ( G ` x ) ) ) ) $=
      cA con0 wcel cF cA wfn cG cA wfn wa cA cA wss vx cv cF cfv cF vx cv cres
      cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cA wral vx cv cF
      cfv vx cv cG cfv wceq vx cA wral wi cA ssid cF cA wfn cG cA wfn wa vy cv
      cA wss vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres
      cB cfv wceq wa vx vy cv wral vx cv cF cfv vx cv cG cfv wceq vx vy cv wral
      wi wi wi cF cA wfn cG cA wfn wa cA cA wss vx cv cF cfv cF vx cv cres cB
      cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cA wral vx cv cF
      cfv vx cv cG cfv wceq vx cA wral wi wi wi vy cA con0 vy cv cA wceq vy cv
      cA wss vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres
      cB cfv wceq wa vx vy cv wral vx cv cF cfv vx cv cG cfv wceq vx vy cv wral
      wi wi cA cA wss vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx
      cv cres cB cfv wceq wa vx cA wral vx cv cF cfv vx cv cG cfv wceq vx cA
      wral wi wi cF cA wfn cG cA wfn wa vy cv cA wceq vy cv cA wss cA cA wss vx
      cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv
      wceq wa vx vy cv wral vx cv cF cfv vx cv cG cfv wceq vx vy cv wral wi vx
      cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv
      wceq wa vx cA wral vx cv cF cfv vx cv cG cfv wceq vx cA wral wi vy cv cA
      cA sseq1 vy cv cA wceq vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG
      cfv cG vx cv cres cB cfv wceq wa vx vy cv wral vx cv cF cfv cF vx cv cres
      cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cA wral vx cv cF
      cfv vx cv cG cfv wceq vx vy cv wral vx cv cF cfv vx cv cG cfv wceq vx cA
      wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB
      cfv wceq wa vx vy cv cA raleq1 vx cv cF cfv vx cv cG cfv wceq vx vy cv cA
      raleq1 imbi12d imbi12d imbi2d vy cv con0 wcel cF cA wfn cG cA wfn wa vy
      cv cA wss vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv
      cres cB cfv wceq wa vx vy cv wral vx cv cF cfv vx cv cG cfv wceq vx vy cv
      wral cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF cfv cF vx cv cres cB
      cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral wa vx cv
      cF cfv vx cv cG cfv wceq vx vy cv wral wi cF cA wfn cG cA wfn wa vz cv cA
      wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres
      cB cfv wceq wa vx vz cv wral wa vx cv cF cfv vx cv cG cfv wceq vx vz cv
      wral wi vy vz vy cv vz cv wceq cF cA wfn cG cA wfn wa vy cv cA wss wa vx
      cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv
      wceq wa vx vy cv wral wa cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF
      cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa
      vx vz cv wral wa vx cv cF cfv vx cv cG cfv wceq vx vy cv wral vx cv cF
      cfv vx cv cG cfv wceq vx vz cv wral vy cv vz cv wceq cF cA wfn cG cA wfn
      wa vy cv cA wss wa cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF cfv cF
      vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv
      wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB
      cfv wceq wa vx vz cv wral vy cv vz cv wceq vy cv cA wss vz cv cA wss cF
      cA wfn cG cA wfn wa vy cv vz cv cA sseq1 anbi2d vx cv cF cfv cF vx cv
      cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv vz cv
      raleq1 anbi12d vx cv cF cfv vx cv cG cfv wceq vx vy cv vz cv raleq1
      imbi12d vy cv con0 wcel cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF
      cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa
      vx vz cv wral wa vz vy cv wral vx cv cF cfv vx cv cG cfv wceq vx vz cv
      wral vz vy cv wral wi cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF cfv
      cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy
      cv wral wa vx cv cF cfv vx cv cG cfv wceq vx vy cv wral wi cF cA wfn cG
      cA wfn wa vz cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG
      cfv cG vx cv cres cB cfv wceq wa vx vz cv wral wa vx cv cF cfv vx cv cG
      cfv wceq vx vz cv wral wi vz vy cv wral vy cv con0 wcel cF cA wfn cG cA
      wfn wa vz cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG
      cfv cG vx cv cres cB cfv wceq wa vx vz cv wral wa vz vy cv wral vx cv cF
      cfv vx cv cG cfv wceq vx vz cv wral vz vy cv wral wi cF cA wfn cG cA wfn
      wa vy cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG
      vx cv cres cB cfv wceq wa vx vy cv wral wa cF cA wfn cG cA wfn wa vy cv
      cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv
      cres cB cfv wceq wa vx vy cv wral wa vx cv cF cfv vx cv cG cfv wceq vx vy
      cv wral wi wi cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF cfv cF vx
      cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv
      wral wa vx cv cF cfv vx cv cG cfv wceq vx vy cv wral wi vy cv con0 wcel
      cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv
      wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral wa cF cA wfn
      cG cA wfn wa vz cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv
      cG cfv cG vx cv cres cB cfv wceq wa vx vz cv wral wa vz vy cv wral vx cv
      cF cfv vx cv cG cfv wceq vx vz cv wral vz vy cv wral cF cA wfn cG cA wfn
      wa vy cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG
      vx cv cres cB cfv wceq wa vx vy cv wral wa vx cv cF cfv vx cv cG cfv wceq
      vx vy cv wral wi vy cv con0 wcel cF cA wfn cG cA wfn wa vy cv cA wss wa
      vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv
      wceq wa vx vy cv wral wa cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF
      cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa
      vx vz cv wral wa vz vy cv vy cv con0 wcel vz cv vy cv wcel cF cA wfn cG
      cA wfn wa vy cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG
      cfv cG vx cv cres cB cfv wceq wa vx vy cv wral wa cF cA wfn cG cA wfn wa
      vz cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx
      cv cres cB cfv wceq wa vx vz cv wral wa vy cv con0 wcel vz cv vy cv wcel
      vz cv vy cv wss cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF cfv cF vx
      cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv
      wral wa cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF cfv cF vx cv cres
      cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vz cv wral wa wi
      vy cv vz cv onelss vz cv vy cv wss cF cA wfn cG cA wfn wa vy cv cA wss wa
      cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF cfv cF vx cv cres cB cfv
      wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral vx cv cF cfv
      cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vz
      cv wral vz cv vy cv wss vy cv cA wss vz cv cA wss cF cA wfn cG cA wfn wa
      vz cv vy cv cA sstr2 anim2d vz cv vy cv wss vx cv cF cfv cF vx cv cres cB
      cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral vx cv cF
      cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa
      vx vz cv vz cv vy cv wss vx ax-17 vx cv cF cfv cF vx cv cres cB cfv wceq
      vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv hbra1 vz cv vy cv wss
      vx cv vz cv wcel vx cv vy cv wcel vx cv cF cfv cF vx cv cres cB cfv wceq
      vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral vx cv cF cfv cF
      vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vz cv vy
      cv vx cv ssel vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx
      cv cres cB cfv wceq wa vx vy cv ra4 syl9 r19.21ad anim12d syl6 com23
      r19.21adv vy cv con0 wcel vx cv cF cfv vx cv cG cfv wceq vx vz cv wral vz
      vy cv wral cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF cfv cF vx cv
      cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral
      vx cv cF cfv vx cv cG cfv wceq vx vy cv wral vy cv con0 wcel cF cA wfn cG
      cA wfn wa vy cv cA wss wa vx cv cF cfv vx cv cG cfv wceq vx vz cv wral vz
      vy cv wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv
      cres cB cfv wceq wa vx vy cv wral vx cv cF cfv vx cv cG cfv wceq vx vy cv
      wral wi vy cv con0 wcel cF cA wfn cG cA wfn wa vy cv cA wss wa vx cv cF
      cfv vx cv cG cfv wceq vx vz cv wral vz vy cv wral vx cv cF cfv cF vx cv
      cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral
      vx cv cF cfv vx cv cG cfv wceq vx vy cv wral wi wi vy cv con0 wcel cF cA
      wfn cG cA wfn wa vy cv cA wss wa wa vw cv cF cfv vw cv cG cfv wceq vw vx
      cv wral vx vy cv wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv
      cG vx cv cres cB cfv wceq wa vx vy cv wral vx cv cF cfv vx cv cG cfv wceq
      vx vy cv wral wi vx cv cF cfv vx cv cG cfv wceq vx vz cv wral vz vy cv
      wral vy cv con0 wcel cF cA wfn cG cA wfn wa vy cv cA wss wa wa vw cv cF
      cfv vw cv cG cfv wceq vw vx cv wral vx vy cv wral vx cv cF cfv cF vx cv
      cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cv cF cfv
      vx cv cG cfv wceq wi vx vy cv wral vx cv cF cfv cF vx cv cres cB cfv wceq
      vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vy cv wral vx cv cF cfv vx
      cv cG cfv wceq vx vy cv wral wi vy cv con0 wcel cF cA wfn cG cA wfn wa vy
      cv cA wss wa wa vw cv cF cfv vw cv cG cfv wceq vw vx cv wral vx cv cF cfv
      cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cv
      cF cfv vx cv cG cfv wceq wi vx vy cv vy cv con0 wcel cF cA wfn cG cA wfn
      wa vy cv cA wss wa vx cv vy cv wcel vw cv cF cfv vw cv cG cfv wceq vw vx
      cv wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres
      cB cfv wceq wa vx cv cF cfv vx cv cG cfv wceq wi wi vy cv con0 wcel vx cv
      vy cv wcel cF cA wfn cG cA wfn wa vy cv cA wss wa vw cv cF cfv vw cv cG
      cfv wceq vw vx cv wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG
      cfv cG vx cv cres cB cfv wceq wa vx cv cF cfv vx cv cG cfv wceq wi wi vy
      cv con0 wcel vx cv vy cv wcel cF cA wfn cG cA wfn wa vy cv cA wss vw cv
      cF cfv vw cv cG cfv wceq vw vx cv wral vx cv cF cfv cF vx cv cres cB cfv
      wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cv cF cfv vx cv cG cfv
      wceq wi wi vy cv con0 wcel vx cv vy cv wcel vx cv vy cv wss cF cA wfn cG
      cA wfn wa vy cv cA wss vw cv cF cfv vw cv cG cfv wceq vw vx cv wral vx cv
      cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq
      wa vx cv cF cfv vx cv cG cfv wceq wi wi wi wi vy cv vx cv onelss vx cv vy
      cv wss vy cv cA wss vx cv cA wss cF cA wfn cG cA wfn wa vw cv cF cfv vw
      cv cG cfv wceq vw vx cv wral vx cv cF cfv cF vx cv cres cB cfv wceq vx cv
      cG cfv cG vx cv cres cB cfv wceq wa vx cv cF cfv vx cv cG cfv wceq wi wi
      vx cv vy cv cA sstr2 vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv
      cG vx cv cres cB cfv wceq wa cF cA wfn cG cA wfn wa vx cv cA wss vw cv cF
      cfv vw cv cG cfv wceq vw vx cv wral vx cv cF cfv vx cv cG cfv wceq vx cv
      cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq
      wa cF cA wfn cG cA wfn wa vx cv cA wss vw cv cF cfv vw cv cG cfv wceq vw
      vx cv wral vx cv cF cfv vx cv cG cfv wceq vx cv cF cfv cF vx cv cres cB
      cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cv cF cfv vx cv cG
      cfv wceq cF vx cv cres cB cfv cG vx cv cres cB cfv wceq cF cA wfn cG cA
      wfn wa vx cv cA wss wa vw cv cF cfv vw cv cG cfv wceq vw vx cv wral wa vx
      cv cF cfv cF vx cv cres cB cfv vx cv cG cfv cG vx cv cres cB cfv eqeq12
      cF cA wfn cG cA wfn wa vx cv cA wss wa vw cv cF cfv vw cv cG cfv wceq vw
      vx cv wral wa cF vx cv cres cG vx cv cres cB cF cA wfn cG cA wfn wa vx cv
      cA wss wa cF vx cv cres cG vx cv cres wceq vw cv cF cfv vw cv cG cfv wceq
      vw vx cv wral vw cA vx cv cF cG fvreseq biimpar fveq2d syl5bir exp4c
      com4l syl9 syl6 imp4a com23 imp31 r19.20dva vx cv cF cfv cF vx cv cres cB
      cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx cv cF cfv vx cv cG
      cfv wceq vx vy cv r19.20 syl6 vx cv cF cfv vx cv cG cfv wceq vx vz cv
      wral vw cv cF cfv vw cv cG cfv wceq vw vx cv wral vz vx vy cv vx cv cF
      cfv vx cv cG cfv wceq vx vz cv hbra1 vw cv cF cfv vw cv cG cfv wceq vw vx
      cv wral vz ax-17 vz cv vx cv wceq vw cv cF cfv vw cv cG cfv wceq vw vz cv
      wral vw cv cF cfv vw cv cG cfv wceq vw vx cv wral vx cv cF cfv vx cv cG
      cfv wceq vx vz cv wral vw cv cF cfv vw cv cG cfv wceq vw vz cv vx cv
      raleq1 vx cv cF cfv vx cv cG cfv wceq vw cv cF cfv vw cv cG cfv wceq vx
      vw vz cv vx cv vw cv wceq vx cv cF cfv vw cv cF cfv vx cv cG cfv vw cv cG
      cfv vx cv vw cv cF fveq2 vx cv vw cv cG fveq2 eqeq12d cbvralv syl5bb
      cbvral syl5ib ex com23 imp4a imim12d cF cA wfn cG cA wfn wa vy cv cA wss
      wa vx cv cF cfv cF vx cv cres cB cfv wceq vx cv cG cfv cG vx cv cres cB
      cfv wceq wa vx vy cv wral wa vx cv cF cfv vx cv cG cfv wceq vx vy cv wral
      pm2.43 syl6 cF cA wfn cG cA wfn wa vz cv cA wss wa vx cv cF cfv cF vx cv
      cres cB cfv wceq vx cv cG cfv cG vx cv cres cB cfv wceq wa vx vz cv wral
      wa vx cv cF cfv vx cv cG cfv wceq vx vz cv wral vz vy cv r19.20 syl5
      tfis2 exp4c vtoclga mpii $.
      $( [2-May-2004] $) $( [23-Mar-1995] $)
  $}

  ${
    $d w A $.  $d w B $.  $d w F $.  $d w G $.  $d w x $.  $d w y $.
    $( Lemma for transfinite recursion.  This provides some messy details
       needed to link ~ tfrlem1 into the main proof. $)
    tfrlem2 $p |- ( ( F Fn A /\ G Fn A ) ->
       ( ( <. x , y >. e. F /\ <. x , z >. e. G ) ->
       ( A e. On -> ( A. w ( A e. On -> ( w e. A ->
          ( ( F ` w ) = ( B ` ( F |` w ) ) /\
            ( G ` w ) = ( B ` ( G |` w ) ) ) ) ) ->
       y = z ) ) ) ) $=
      cF cA wfn cG cA wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa
      cA con0 wcel cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB cfv
      wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi wi vw wal vy cv vz cv
      wceq cF cA wfn cG cA wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG
      wcel wa wa cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB cfv
      wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi vw wal wa vy cv vz cv
      wceq cA con0 wcel cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres
      cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi wi vw wal wa cF
      cA wfn cG cA wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa wa
      cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw cv
      cG cfv cG vw cv cres cB cfv wceq wa wi vw wal wa wa vx cv cF cfv vx cv cG
      cfv wceq vy cv vz cv wceq cF cA wfn cG cA wfn wa vx cv vy cv cop cF wcel
      vx cv vz cv cop cG wcel wa wa cA con0 wcel vw cv cF cfv cF vw cv cres cB
      cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa vw cA wral wa vx cv cF
      cfv vx cv cG cfv wceq cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv
      cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi vw wal wa
      cF cA wfn cG cA wfn wa vx cv vy cv cop cF wcel cA con0 wcel vw cv cF cfv
      cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa vw cA
      wral wa vx cv cF cfv vx cv cG cfv wceq vx cv vz cv cop cG wcel cF cA wfn
      cG cA wfn wa vx cv vy cv cop cF wcel wa cA con0 wcel vw cv cF cfv cF vw
      cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa vw cA wral
      wa vx cv cF cfv vx cv cG cfv wceq cF cA wfn cG cA wfn wa vx cv vy cv cop
      cF wcel wa cA con0 wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw cv cG
      cfv cG vw cv cres cB cfv wceq wa vw cA wral wa vw cv cF cfv vw cv cG cfv
      wceq vw cA wral vx cv cF cfv vx cv cG cfv wceq cF cA wfn cG cA wfn wa cA
      con0 wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv
      cres cB cfv wceq wa vw cA wral wa vw cv cF cfv vw cv cG cfv wceq vw cA
      wral wi vx cv vy cv cop cF wcel cF cA wfn cG cA wfn wa cA con0 wcel vw cv
      cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq
      wa vw cA wral vw cv cF cfv vw cv cG cfv wceq vw cA wral cA con0 wcel cF
      cA wfn cG cA wfn wa vw cv cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv
      cG vw cv cres cB cfv wceq wa vw cA wral vw cv cF cfv vw cv cG cfv wceq vw
      cA wral wi vw cA cB cF cG tfrlem1 com12 imp3a adantr cF cA wfn cG cA wfn
      wa vx cv vy cv cop cF wcel wa vx cv cA wcel vw cv cF cfv vw cv cG cfv
      wceq vw cA wral vx cv cF cfv vx cv cG cfv wceq wi cF cA wfn vx cv vy cv
      cop cF wcel vx cv cA wcel cG cA wfn cA vx cv vy cv cF fnop adantlr vw cv
      cF cfv vw cv cG cfv wceq vx cv cF cfv vx cv cG cfv wceq vw vx cv cA vw cv
      vx cv wceq vw cv cF cfv vx cv cF cfv vw cv cG cfv vx cv cG cfv vw cv vx
      cv cF fveq2 vw cv vx cv cG fveq2 eqeq12d rcla4v syl syld imp adantlrr vw
      cv cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv
      wceq wa vw cA wral vw cv cA wcel vw cv cF cfv cF vw cv cres cB cfv wceq
      vw cv cG cfv cG vw cv cres cB cfv wceq wa wi vw wal cA con0 wcel vw cv cF
      cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa
      vw cA df-ral anbi2i sylan2br cF cA wfn cG cA wfn wa vx cv vy cv cop cF
      wcel vx cv vz cv cop cG wcel wa wa vx cv cF cfv vx cv cG cfv wceq vy cv
      vz cv wceq wb cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB
      cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi vw wal wa cF cA wfn
      cG cA wfn wa vx cv vy cv cop cF wcel vx cv vz cv cop cG wcel wa wa vx cv
      cF cfv vy cv wceq vx cv cG cfv vz cv wceq wa vx cv cF cfv vx cv cG cfv
      wceq vy cv vz cv wceq wb cF wfun cG wfun wa vx cv vy cv cop cF wcel vx cv
      vz cv cop cG wcel wa vx cv cF cfv vy cv wceq vx cv cG cfv vz cv wceq wa
      cF cA wfn cG cA wfn wa cF wfun vx cv vy cv cop cF wcel cG wfun vx cv vz
      cv cop cG wcel vx cv cF cfv vy cv wceq vx cv cG cfv vz cv wceq wa cF wfun
      vx cv vy cv cop cF wcel wa vx cv cF cfv vy cv wceq cG wfun vx cv vz cv
      cop cG wcel wa vx cv cG cfv vz cv wceq cF wfun vx cv vy cv cop cF wcel vx
      cv cF cfv vy cv wceq vx cv vy cv cF vy visset funopfv imp cG wfun vx cv
      vz cv cop cG wcel vx cv cG cfv vz cv wceq vx cv vz cv cG vz visset
      funopfv imp anim12i an4s cF cA wfn cF wfun cG cA wfn cG wfun cA cF fnfun
      cA cG fnfun anim12i sylan vx cv cF cfv vy cv vx cv cG cfv vz cv eqeq12
      syl adantr mpbid cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB
      cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi wa vw wal cA con0
      wcel cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw
      cv cG cfv cG vw cv cres cB cfv wceq wa wi wi wa vw wal cA con0 wcel vw cv
      cA wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres
      cB cfv wceq wa wi vw wal wa cA con0 wcel cA con0 wcel vw cv cA wcel vw cv
      cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq
      wa wi wi vw wal wa cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres
      cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi wa cA con0 wcel
      cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw cv
      cG cfv cG vw cv cres cB cfv wceq wa wi wi wa vw cA con0 wcel vw cv cA
      wcel vw cv cF cfv cF vw cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB
      cfv wceq wa wi abai albii cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw
      cv cres cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi vw
      19.28v cA con0 wcel cA con0 wcel vw cv cA wcel vw cv cF cfv cF vw cv cres
      cB cfv wceq vw cv cG cfv cG vw cv cres cB cfv wceq wa wi wi vw 19.28v
      3bitr3ri sylan2b exp43 $.
      $( [23-Mar-1995] $)
  $}

  ${
    $d x y f g $.  $d x y z $.  $d g z $.  $d f g G $.  $d x z G $.
    tfrlem3.1 $e |- A = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( G ` ( f |` y ) ) ) } $.
    $( Lemma for transfinite recursion.  Let ` A ` be the class of "acceptable"
       functions.  The final thing we're interested in is the union of all
       these acceptable functions.  This lemma just changes some bound
       variables in ` A ` for later use. $)
    tfrlem3 $p |- A = { g | E. z e. On ( g Fn z /\
                A. y e. z ( g ` y ) = ( G ` ( g |` y ) ) ) } $=
      cA vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv
      wral wa vx con0 wrex vf cab vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv
      cres cG cfv wceq vy vz cv wral wa vz con0 wrex vg cab tfrlem3.1 vg cv vz
      cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral wa vz
      con0 wrex vg vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq
      vy vx cv wral wa vx con0 wrex vf cab vg cv vf cv vx cv wfn vy cv vf cv
      cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vf cab
      wcel vg cv vx cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vx
      cv wral wa vx con0 wrex vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres
      cG cfv wceq vy vz cv wral wa vz con0 wrex vf cv vx cv wfn vy cv vf cv cfv
      vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vg cv vx cv
      wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0
      wrex vf vg cv vg visset vf cv vg cv wceq vf cv vx cv wfn vy cv vf cv cfv
      vf cv vy cv cres cG cfv wceq vy vx cv wral wa vg cv vx cv wfn vy cv vg cv
      cfv vg cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 vf cv vg cv
      wceq vf cv vx cv wfn vg cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG
      cfv wceq vy vx cv wral vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vx
      cv wral vx cv vf cv vg cv fneq1 vf cv vg cv wceq vy cv vf cv cfv vf cv vy
      cv cres cG cfv wceq vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vx cv
      vf cv vg cv wceq vy cv vf cv cfv vy cv vg cv cfv vf cv vy cv cres cG cfv
      vg cv vy cv cres cG cfv vy cv vf cv vg cv fveq1 vf cv vg cv wceq vf cv vy
      cv cres vg cv vy cv cres cG vf cv vg cv vy cv reseq1 fveq2d eqeq12d
      ralbidv anbi12d rexbidv elab vg cv vx cv wfn vy cv vg cv cfv vg cv vy cv
      cres cG cfv wceq vy vx cv wral wa vg cv vz cv wfn vy cv vg cv cfv vg cv
      vy cv cres cG cfv wceq vy vz cv wral wa vx vz con0 vx cv vz cv wceq vg cv
      vx cv wfn vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy
      vx cv wral vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral vx
      cv vz cv vg cv fneq2 vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vx
      cv vz cv raleq1 anbi12d cbvrexv bitri abbi2i eqtri $.
      $( [3-May-2004] $) $( [9-Apr-1995] $)
  $}

  ${
    $d x y f g h A $.  $d x y z w v u f F $.
    $d x y z w f g h G $.  $d x y B $.  $d z w v u g h $.
    tfrlem.1 $e |- A = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( G ` ( f |` y ) ) ) } $.

    $( Let ` F ` be the union of all acceptable functions. $)
    tfrlem.2 $e |- F = U. A $.

    $( Lemma for transfinite recursion. ` A ` is the class of all "acceptable"
       functions, and ` F ` is their union.  First we show that an acceptable
       function is in fact a function. $)
    tfrlem4 $p |- ( g e. A -> Fun g ) $=
      vg cv cA wcel vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv
      wceq vy vz cv wral wa vz con0 wrex vg cv wfun vg cv vz cv wfn vy cv vg cv
      cfv vg cv vy cv cres cG cfv wceq vy vz cv wral wa vz con0 wrex vg cA vx
      vy vz cA vf vg cG tfrlem.1 tfrlem3 abeq2i vg cv vz cv wfn vy cv vg cv cfv
      vg cv vy cv cres cG cfv wceq vy vz cv wral wa vg cv wfun vz con0 vg cv vz
      cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral wa vg
      cv wfun wi vz cv con0 wcel vg cv vz cv wfn vg cv wfun vy cv vg cv cfv vg
      cv vy cv cres cG cfv wceq vy vz cv wral vz cv vg cv fnfun adantr a1i
      r19.23aiv sylbi $.
      $( [3-May-2004] $) $( [9-Apr-1995] $)

    $( Lemma for transfinite recursion.  The values of two acceptable
       functions are the same within their domains. $)
    tfrlem5 $p |- ( ( g e. A /\ h e. A ) ->
                  ( ( <. x , u >. e. g /\ <. x , v >. e. h ) -> u = v ) ) $=
      vg cv cA wcel vh cv cA wcel wa vg cv vz cv wfn vy cv vg cv cfv vg cv vy
      cv cres cG cfv wceq vy vz cv wral wa vh cv vw cv wfn vy cv vh cv cfv vh
      cv vy cv cres cG cfv wceq vy vw cv wral wa wa vw con0 wrex vz con0 wrex
      vx cv vu cv cop vg cv wcel vx cv vv cv cop vh cv wcel wa vu cv vv cv wceq
      wi vg cv cA wcel vh cv cA wcel wa vg cv vz cv wfn vy cv vg cv cfv vg cv
      vy cv cres cG cfv wceq vy vz cv wral wa vz con0 wrex vh cv vw cv wfn vy
      cv vh cv cfv vh cv vy cv cres cG cfv wceq vy vw cv wral wa vw con0 wrex
      wa vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv
      wral wa vh cv vw cv wfn vy cv vh cv cfv vh cv vy cv cres cG cfv wceq vy
      vw cv wral wa wa vw con0 wrex vz con0 wrex vg cv cA wcel vg cv vz cv wfn
      vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral wa vz con0
      wrex vh cv cA wcel vh cv vw cv wfn vy cv vh cv cfv vh cv vy cv cres cG
      cfv wceq vy vw cv wral wa vw con0 wrex vg cv vz cv wfn vy cv vg cv cfv vg
      cv vy cv cres cG cfv wceq vy vz cv wral wa vz con0 wrex vg cA vx vy vz cA
      vf vg cG tfrlem.1 tfrlem3 abeq2i vh cv vw cv wfn vy cv vh cv cfv vh cv vy
      cv cres cG cfv wceq vy vw cv wral wa vw con0 wrex vh cA vx vy vw cA vf vh
      cG tfrlem.1 tfrlem3 abeq2i anbi12i vg cv vz cv wfn vy cv vg cv cfv vg cv
      vy cv cres cG cfv wceq vy vz cv wral wa vh cv vw cv wfn vy cv vh cv cfv
      vh cv vy cv cres cG cfv wceq vy vw cv wral wa vz vw con0 con0 reeanv
      bitr4i vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz
      cv wral wa vh cv vw cv wfn vy cv vh cv cfv vh cv vy cv cres cG cfv wceq
      vy vw cv wral wa wa vx cv vu cv cop vg cv wcel vx cv vv cv cop vh cv wcel
      wa vu cv vv cv wceq wi vz vw con0 con0 vz cv con0 wcel vw cv con0 wcel wa
      vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv
      wral wa vh cv vw cv wfn vy cv vh cv cfv vh cv vy cv cres cG cfv wceq vy
      vw cv wral wa wa vx cv vu cv cop vg cv wcel vx cv vv cv cop vh cv wcel wa
      vu cv vv cv wceq wi vz cv vw cv cin con0 wcel vg cv vz cv wfn vh cv vw cv
      wfn wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy cv vg cv
      vz cv vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv
      wceq vy cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres vy
      cv cres cG cfv wceq wa wi wi vy wal wa vx cv vu cv cop vg cv wcel vx cv
      vv cv cop vh cv wcel wa vu cv vv cv wceq wi vz cv con0 wcel vw cv con0
      wcel wa vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy
      vz cv wral wa vh cv vw cv wfn vy cv vh cv cfv vh cv vy cv cres cG cfv
      wceq vy vw cv wral wa wa vz cv vw cv cin con0 wcel vg cv vz cv wfn vh cv
      vw cv wfn wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy cv
      vg cv vz cv vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG
      cfv wceq vy cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres
      vy cv cres cG cfv wceq wa wi wi vy wal vx cv vu cv cop vg cv wcel vx cv
      vv cv cop vh cv wcel wa vu cv vv cv wceq wi vg cv vz cv wfn vh cv vw cv
      wfn wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy cv vg cv
      vz cv vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv
      wceq vy cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres vy
      cv cres cG cfv wceq wa wi wi vy wal vz cv vw cv cin con0 wcel vx cv vu cv
      cop vg cv wcel vx cv vv cv cop vh cv wcel wa vu cv vv cv wceq wi vg cv vz
      cv wfn vh cv vw cv wfn wa vx cv vu cv cop vg cv wcel vx cv vv cv cop vh
      cv wcel wa vz cv vw cv cin con0 wcel vz cv vw cv cin con0 wcel vy cv vz
      cv vw cv cin wcel vy cv vg cv vz cv vw cv cin cres cfv vg cv vz cv vw cv
      cin cres vy cv cres cG cfv wceq vy cv vh cv vz cv vw cv cin cres cfv vh
      cv vz cv vw cv cin cres vy cv cres cG cfv wceq wa wi wi vy wal vu cv vv
      cv wceq vg cv vz cv wfn vh cv vw cv wfn wa vx cv vu cv cop vg cv wcel vx
      cv vv cv cop vh cv wcel wa vx cv vu cv cop vg cv vz cv vw cv cin cres
      wcel vx cv vv cv cop vh cv vz cv vw cv cin cres wcel wa vz cv vw cv cin
      con0 wcel vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy cv vg
      cv vz cv vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv
      wceq vy cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres vy
      cv cres cG cfv wceq wa wi wi vy wal vu cv vv cv wceq wi wi vx vu vv vz cv
      vw cv vg cv vh cv 2elresin vg cv vz cv vw cv cin cres vz cv vw cv cin wfn
      vh cv vz cv vw cv cin cres vz cv vw cv cin wfn vx cv vu cv cop vg cv vz
      cv vw cv cin cres wcel vx cv vv cv cop vh cv vz cv vw cv cin cres wcel wa
      vz cv vw cv cin con0 wcel vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin
      wcel vy cv vg cv vz cv vw cv cin cres cfv vg cv vz cv vw cv cin cres vy
      cv cres cG cfv wceq vy cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw
      cv cin cres vy cv cres cG cfv wceq wa wi wi vy wal vu cv vv cv wceq wi wi
      wi vg cv vz cv wfn vh cv vw cv wfn vx vu vv vy vz cv vw cv cin cG vg cv
      vz cv vw cv cin cres vh cv vz cv vw cv cin cres tfrlem2 vz cv vw cv vg cv
      fnresin1 vw cv vz cv vh cv fnresin2 syl2an sylbid com24 com3r imp32 vz cv
      vw cv onin vg cv vz cv wfn vh cv vw cv wfn vy cv vg cv cfv vg cv vy cv
      cres cG cfv wceq vy vz cv wral vy cv vh cv cfv vh cv vy cv cres cG cfv
      wceq vy vw cv wral vg cv vz cv wfn vh cv vw cv wfn wa vz cv vw cv cin
      con0 wcel vy cv vz cv vw cv cin wcel vy cv vg cv vz cv vw cv cin cres cfv
      vg cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy cv vh cv vz cv vw cv
      cin cres cfv vh cv vz cv vw cv cin cres vy cv cres cG cfv wceq wa wi wi
      vy wal wa vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral vy
      cv vh cv cfv vh cv vy cv cres cG cfv wceq vy vw cv wral wa vz cv vw cv
      cin con0 wcel vy cv vz cv vw cv cin wcel vy cv vg cv vz cv vw cv cin cres
      cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy cv vh cv vz cv
      vw cv cin cres cfv vh cv vz cv vw cv cin cres vy cv cres cG cfv wceq wa
      wi wi vy wal vg cv vz cv wfn vh cv vw cv wfn wa vy cv vg cv cfv vg cv vy
      cv cres cG cfv wceq vy vz cv wral vy cv vh cv cfv vh cv vy cv cres cG cfv
      wceq vy vw cv wral wa vy cv vz cv wcel vy cv vg cv cfv vg cv vy cv cres
      cG cfv wceq wi vy cv vw cv wcel vy cv vh cv cfv vh cv vy cv cres cG cfv
      wceq wi wa vy wal vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy
      cv vg cv vz cv vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres
      cG cfv wceq vy cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin
      cres vy cv cres cG cfv wceq wa wi wi vy wal vy cv vg cv cfv vg cv vy cv
      cres cG cfv wceq vy cv vh cv cfv vh cv vy cv cres cG cfv wceq vy vz cv vw
      cv r19.26m vy cv vz cv wcel vy cv vg cv cfv vg cv vy cv cres cG cfv wceq
      wi vy cv vw cv wcel vy cv vh cv cfv vh cv vy cv cres cG cfv wceq wi wa vz
      cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy cv vg cv vz cv vw cv
      cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy cv vh
      cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres vy cv cres cG cfv
      wceq wa wi wi vy vy cv vz cv wcel vy cv vg cv cfv vg cv vy cv cres cG cfv
      wceq wi vy cv vw cv wcel vy cv vh cv cfv vh cv vy cv cres cG cfv wceq wi
      wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel vy cv vg cv vz cv
      vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy
      cv vh cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres vy cv cres
      cG cfv wceq wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel wa vy
      cv vg cv cfv vg cv vy cv cres cG cfv wceq vy cv vh cv cfv vh cv vy cv
      cres cG cfv wceq wa vy cv vg cv vz cv vw cv cin cres cfv vg cv vz cv vw
      cv cin cres vy cv cres cG cfv wceq vy cv vh cv vz cv vw cv cin cres cfv
      vh cv vz cv vw cv cin cres vy cv cres cG cfv wceq wa vy cv vz cv wcel vy
      cv vg cv cfv vg cv vy cv cres cG cfv wceq wi vy cv vw cv wcel vy cv vh cv
      cfv vh cv vy cv cres cG cfv wceq wi wa vy cv vz cv wcel vy cv vg cv cfv
      vg cv vy cv cres cG cfv wceq wi vy cv vw cv wcel vy cv vh cv cfv vh cv vy
      cv cres cG cfv wceq wi wa vy cv vz cv wcel vy cv vw cv wcel wa vy cv vg
      cv cfv vg cv vy cv cres cG cfv wceq vy cv vh cv cfv vh cv vy cv cres cG
      cfv wceq wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel wa vy cv
      vz cv wcel vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy cv vw cv wcel
      vy cv vh cv cfv vh cv vy cv cres cG cfv wceq prth vz cv vw cv cin con0
      wcel vy cv vz cv vw cv cin wcel wa vy cv vz cv vw cv cin wcel vy cv vz cv
      wcel vy cv vw cv wcel wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin
      wcel pm3.27 vy cv vz cv vw cv elin sylib syl5 vz cv vw cv cin con0 wcel
      vy cv vz cv vw cv cin wcel wa vy cv vg cv vz cv vw cv cin cres cfv vg cv
      vz cv vw cv cin cres vy cv cres cG cfv wceq vy cv vh cv vz cv vw cv cin
      cres cfv vh cv vz cv vw cv cin cres vy cv cres cG cfv wceq wa vy cv vg cv
      cfv vg cv vy cv cres cG cfv wceq vy cv vh cv cfv vh cv vy cv cres cG cfv
      wceq wa vz cv vw cv cin con0 wcel vy cv vz cv vw cv cin wcel wa vy cv vz
      cv vw cv cin wss vy cv vz cv vw cv cin wcel wa vy cv vg cv vz cv vw cv
      cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy cv vh
      cv vz cv vw cv cin cres cfv vh cv vz cv vw cv cin cres vy cv cres cG cfv
      wceq wa vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy cv vh cv cfv vh
      cv vy cv cres cG cfv wceq wa wb vz cv vw cv cin con0 wcel vy cv vz cv vw
      cv cin wcel vy cv vz cv vw cv cin wss vz cv vw cv cin vy cv onelss impac
      vy cv vz cv vw cv cin wss vy cv vz cv vw cv cin wcel wa vy cv vg cv vz cv
      vw cv cin cres cfv vg cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy
      cv vg cv cfv vg cv vy cv cres cG cfv wceq vy cv vh cv vz cv vw cv cin
      cres cfv vh cv vz cv vw cv cin cres vy cv cres cG cfv wceq vy cv vh cv
      cfv vh cv vy cv cres cG cfv wceq vy cv vz cv vw cv cin wcel vy cv vz cv
      vw cv cin wss vy cv vg cv vz cv vw cv cin cres cfv vy cv vg cv cfv vg cv
      vz cv vw cv cin cres vy cv cres cG cfv vg cv vy cv cres cG cfv vy cv vz
      cv vw cv cin vg cv fvres vy cv vz cv vw cv cin wss vg cv vz cv vw cv cin
      cres vy cv cres vg cv vy cv cres cG vg cv vy cv vz cv vw cv cin resabs1
      fveq2d eqeqan12rd vy cv vz cv vw cv cin wcel vy cv vz cv vw cv cin wss vy
      cv vh cv vz cv vw cv cin cres cfv vy cv vh cv cfv vh cv vz cv vw cv cin
      cres vy cv cres cG cfv vh cv vy cv cres cG cfv vy cv vz cv vw cv cin vh
      cv fvres vy cv vz cv vw cv cin wss vh cv vz cv vw cv cin cres vy cv cres
      vh cv vy cv cres cG vh cv vy cv vz cv vw cv cin resabs1 fveq2d eqeqan12rd
      anbi12d syl bicomd mpbidi exp3a 19.20i sylbir anim2i an4s syl2an ex
      r19.23aivv sylbi $.
      $( [3-May-2004] $) $( [9-Apr-1995] $)

    $( Lemma for transfinite recursion.  The union of all acceptable functions
       is a relation. $)
    tfrlem6 $p |- Rel F $=
      cF cA cuni wceq cF wrel tfrlem.2 cF cA cuni wceq cF wrel cA cuni wrel cA
      cuni wrel vg cv wrel vg cA vg cA reluni vg cv cA wcel vg cv wfun vg cv
      wrel vx vy cA vf vg cF cG tfrlem.1 tfrlem.2 tfrlem4 vg cv funrel syl
      mprgbir cF cA cuni releq mpbiri ax-mp $.
      $( [3-May-2004] $) $( [8-Aug-1994] $)

    $( Lemma for transfinite recursion.  The union of all acceptable functions
       is a function. $)
    tfrlem7 $p |- Fun F $=
      cF wfun cF wrel vx cv vu cv cop cF wcel vx cv vv cv cop cF wcel wa vu cv
      vv cv wceq wi vv wal vu wal vx wal vx vu vv cF dffun4 vx vy cA vf cF cG
      tfrlem.1 tfrlem.2 tfrlem6 vx cv vu cv cop cF wcel vx cv vv cv cop cF wcel
      wa vu cv vv cv wceq wi vv wal vx vu vx cv vu cv cop cF wcel vx cv vv cv
      cop cF wcel wa vu cv vv cv wceq wi vv vx cv vu cv cop cF wcel vx cv vv cv
      cop cF wcel wa vx cv vu cv cop vg cv wcel vg cv cA wcel wa vx cv vv cv
      cop vh cv wcel vh cv cA wcel wa wa vh wex vg wex vu cv vv cv wceq vx cv
      vu cv cop cF wcel vx cv vv cv cop cF wcel wa vx cv vu cv cop vg cv wcel
      vg cv cA wcel wa vg wex vx cv vv cv cop vh cv wcel vh cv cA wcel wa vh
      wex wa vx cv vu cv cop vg cv wcel vg cv cA wcel wa vx cv vv cv cop vh cv
      wcel vh cv cA wcel wa wa vh wex vg wex vx cv vu cv cop cF wcel vx cv vu
      cv cop vg cv wcel vg cv cA wcel wa vg wex vx cv vv cv cop cF wcel vx cv
      vv cv cop vh cv wcel vh cv cA wcel wa vh wex vx cv vu cv cop cF wcel vx
      cv vu cv cop cA cuni wcel vx cv vu cv cop vg cv wcel vg cv cA wcel wa vg
      wex cF cA cuni vx cv vu cv cop tfrlem.2 eleq2i vg vx cv vu cv cop cA
      eluni bitri vx cv vv cv cop cF wcel vx cv vv cv cop cA cuni wcel vx cv vv
      cv cop vh cv wcel vh cv cA wcel wa vh wex cF cA cuni vx cv vv cv cop
      tfrlem.2 eleq2i vh vx cv vv cv cop cA eluni bitri anbi12i vx cv vu cv cop
      vg cv wcel vg cv cA wcel wa vx cv vv cv cop vh cv wcel vh cv cA wcel wa
      vg vh eeanv bitr4i vx cv vu cv cop vg cv wcel vg cv cA wcel wa vx cv vv
      cv cop vh cv wcel vh cv cA wcel wa wa vu cv vv cv wceq vg vh vx cv vu cv
      cop vg cv wcel vg cv cA wcel wa vx cv vv cv cop vh cv wcel vh cv cA wcel
      wa wa vg cv cA wcel vh cv cA wcel wa vx cv vu cv cop vg cv wcel vx cv vv
      cv cop vh cv wcel wa wa vu cv vv cv wceq vx cv vu cv cop vg cv wcel vg cv
      cA wcel wa vx cv vv cv cop vh cv wcel vh cv cA wcel wa wa vx cv vu cv cop
      vg cv wcel vx cv vv cv cop vh cv wcel wa vg cv cA wcel vh cv cA wcel wa
      wa vg cv cA wcel vh cv cA wcel wa vx cv vu cv cop vg cv wcel vx cv vv cv
      cop vh cv wcel wa wa vx cv vu cv cop vg cv wcel vg cv cA wcel vx cv vv cv
      cop vh cv wcel vh cv cA wcel an4 vx cv vu cv cop vg cv wcel vx cv vv cv
      cop vh cv wcel wa vg cv cA wcel vh cv cA wcel wa ancom bitri vg cv cA
      wcel vh cv cA wcel wa vx cv vu cv cop vg cv wcel vx cv vv cv cop vh cv
      wcel wa vu cv vv cv wceq vx vy vv vu cA vf vg vh cF cG tfrlem.1 tfrlem.2
      tfrlem5 imp sylbi 19.23aivv sylbi ax-gen gen2 mpbir2an $.
      $( [4-May-2004] $) $( [9-Aug-1994] $)

    $( Lemma for transfinite recursion.  The domain of ` F ` is ordinal.
       (The proof was shortened by Alan Sare, 11-Mar-2008.) $)
    tfrlem8 $p |- Ord dom F $=
      cF cdm word vx cv vf cv cdm wceq vf cA wrex vx cab cuni word vx cv vf cv
      cdm wceq vf cA wrex vx cab con0 wss vx cv vf cv cdm wceq vf cA wrex vx
      cab cuni word vx cv vf cv cdm wceq vf cA wrex vx con0 vx cv vf cv cdm
      wceq vx cv con0 wcel vf cA vf cv cdm con0 wcel vx cv vf cv cdm wceq vx cv
      con0 wcel vf cv cA wcel vf cv cdm con0 wcel vx cv vf cv cdm wceq vx cv
      con0 wcel vf cv cdm con0 vx cv eleq1a imp vf cv cA wcel vx cv con0 wcel
      vf cv vx cv wfn wa vx wex vf cv cdm con0 wcel vf cv cA wcel vf cv vx cv
      wfn vx con0 wrex vx cv con0 wcel vf cv vx cv wfn wa vx wex vf cv cA wcel
      vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv
      wral wa vx con0 wrex vf cv vx cv wfn vx con0 wrex vf cv vx cv wfn vy cv
      vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vf
      cA tfrlem.1 abeq2i vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG
      cfv wceq vy vx cv wral wa vf cv vx cv wfn vx con0 vf cv vx cv wfn vy cv
      vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral pm3.26 r19.22si
      sylbi vf cv vx cv wfn vx con0 df-rex sylib vx cv con0 wcel vf cv vx cv
      wfn wa vf cv cdm con0 wcel vx vx cv con0 wcel vf cv cdm vx cv wceq vf cv
      cdm con0 wcel vf cv vx cv wfn vx cv con0 wcel vf cv cdm vx cv wceq vf cv
      cdm con0 wcel vx cv con0 vf cv cdm eleq1a imp vx cv vf cv fndm sylan2
      19.23aiv syl sylan r19.23aiva abssi vx cv vf cv cdm wceq vf cA wrex vx
      cab ssorduni ax-mp cF cdm vx cv vf cv cdm wceq vf cA wrex vx cab cuni
      wceq cF cdm word vx cv vf cv cdm wceq vf cA wrex vx cab cuni word wb cF
      cdm cA cuni cdm vf cA vf cv cdm ciun vx cv vf cv cdm wceq vf cA wrex vx
      cab cuni cF cA cuni tfrlem.2 dmeqi vf cA dmuni vf vx cA vf cv cdm vf cv
      vf visset dmex dfiun2 3eqtri cF cdm vx cv vf cv cdm wceq vf cA wrex vx
      cab cuni ordeq ax-mp mpbir $.
      $( [12-Mar-2008] $) $( [14-Aug-1994] $)

    $( Lemma for transfinite recursion.  Here we compute the value of
       ` F ` (the union of all acceptable functions). $)
    tfrlem9 $p |- ( y e. dom F -> ( F ` y ) = ( G ` ( F |` y ) ) ) $=
      vy cv cF cdm wcel vy cv vz cv cop cF wcel vz wex vy cv cF cfv cF vy cv
      cres cG cfv wceq vz vy cv cF vy visset eldm2 vy cv vz cv cop cF wcel vy
      cv cF cfv cF vy cv cres cG cfv wceq vz vy cv vz cv cop cF wcel vy cv vz
      cv cop vf cv wcel vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv
      wceq vy vx cv wral wa vx con0 wrex wa vf wex vy cv cF cfv cF vy cv cres
      cG cfv wceq vy cv vz cv cop cF wcel vy cv vz cv cop vf cv vx cv wfn vy cv
      vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vf
      cab cuni wcel vy cv vz cv cop vf cv wcel vf cv vx cv wfn vy cv vf cv cfv
      vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex wa vf wex cF
      vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv
      wral wa vx con0 wrex vf cab cuni vy cv vz cv cop cF cA cuni vf cv vx cv
      wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0
      wrex vf cab cuni tfrlem.2 cA vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv
      cres cG cfv wceq vy vx cv wral wa vx con0 wrex vf cab tfrlem.1 unieqi
      eqtri eleq2i vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq
      vy vx cv wral wa vx con0 wrex vf vy cv vz cv cop eluniab bitri vy cv vz
      cv cop vf cv wcel vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv
      wceq vy vx cv wral wa vx con0 wrex wa vy cv cF cfv cF vy cv cres cG cfv
      wceq vf vy cv vz cv cop vf cv wcel vf cv vx cv wfn vy cv vf cv cfv vf cv
      vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vy cv cF cfv cF vy
      cv cres cG cfv wceq vy cv vz cv cop vf cv wcel vf cv vx cv wfn vy cv vf
      cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vy cv cF cfv cF vy
      cv cres cG cfv wceq vx con0 vy cv vz cv cop vf cv wcel vx cv con0 wcel vf
      cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral
      vy cv cF cfv cF vy cv cres cG cfv wceq vf cv vx cv wfn vy cv vz cv cop vf
      cv wcel vx cv con0 wcel vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy
      vx cv wral vy cv cF cfv cF vy cv cres cG cfv wceq wi vf cv vx cv wfn vy
      cv vz cv cop vf cv wcel vx cv con0 wcel vy cv vf cv cfv vf cv vy cv cres
      cG cfv wceq vy vx cv wral vy cv cF cfv cF vy cv cres cG cfv wceq wi wi wi
      vf cv vx cv wfn vy cv vz cv cop vf cv wcel vx cv con0 wcel vf cv vx cv
      wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral vy cv cF
      cfv cF vy cv cres cG cfv wceq wi vf cv vx cv wfn vy cv vz cv cop vf cv
      wcel vx cv con0 wcel vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG
      cfv wceq vy vx cv wral vy cv cF cfv cF vy cv cres cG cfv wceq wi wi wi vf
      cv vx cv wfn vy cv vz cv cop vf cv wcel wa vx cv con0 wcel vf cv vx cv
      wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral vy cv cF
      cfv cF vy cv cres cG cfv wceq vf cv vx cv wfn vy cv vz cv cop vf cv wcel
      wa vy cv vx cv wcel vx cv con0 wcel vf cv vx cv wfn vy cv vf cv cfv vf cv
      vy cv cres cG cfv wceq vy vx cv wral wa wa vy cv cF cfv cF vy cv cres cG
      cfv wceq wi vx cv vy cv vz cv vf cv fnop vy cv vx cv wcel vx cv con0 wcel
      vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv
      wral wa wa vf cv cF wss vy cv cF cfv cF vy cv cres cG cfv wceq vx cv con0
      wcel vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx
      cv wral wa wa vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv
      wceq vy vx cv wral wa vx con0 wrex vf cv cF wss vf cv vx cv wfn vy cv vf
      cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 ra4e vf cv
      vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa
      vx con0 wrex vf cv cA wcel vf cv cF wss vf cv vx cv wfn vy cv vf cv cfv
      vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vf cA tfrlem.1
      abeq2i vf cv cA wcel vf cv cA cuni cF vf cv cA elssuni tfrlem.2 syl6ssr
      sylbir syl vy cv vx cv wcel vx cv con0 wcel vf cv vx cv wfn vy cv vf cv
      cfv vf cv vy cv cres cG cfv wceq vy vx cv wral vf cv cF wss vy cv cF cfv
      cF vy cv cres cG cfv wceq wi vy cv vx cv wcel vy cv vf cv cfv vf cv vy cv
      cres cG cfv wceq vy vx cv wral vf cv vx cv wfn vx cv con0 wcel vf cv cF
      wss vy cv cF cfv cF vy cv cres cG cfv wceq wi vy cv vx cv wcel vy cv vf
      cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral vy cv vf cv cfv vf cv
      vy cv cres cG cfv wceq vf cv vx cv wfn vx cv con0 wcel vf cv cF wss vy cv
      cF cfv cF vy cv cres cG cfv wceq wi wi wi vy cv vf cv cfv vf cv vy cv
      cres cG cfv wceq vy vx cv wral vy cv vx cv wcel vy cv vf cv cfv vf cv vy
      cv cres cG cfv wceq vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv
      ra4 com12 vf cv vx cv wfn vy cv vx cv wcel vy cv vf cv cfv vf cv vy cv
      cres cG cfv wceq vx cv con0 wcel vf cv cF wss vy cv cF cfv cF vy cv cres
      cG cfv wceq wi wi vf cv vx cv wfn vy cv vx cv wcel vy cv vf cv cdm wcel
      vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vx cv con0 wcel vf cv cF wss
      vy cv cF cfv cF vy cv cres cG cfv wceq wi wi wi vf cv vx cv wfn vf cv cdm
      vx cv vy cv vx cv vf cv fndm eleq2d vf cv vx cv wfn vx cv con0 wcel vy cv
      vf cv cfv vf cv vy cv cres cG cfv wceq vy cv vf cv cdm wcel vf cv cF wss
      vy cv cF cfv cF vy cv cres cG cfv wceq wi vf cv vx cv wfn vx cv con0 wcel
      vy cv vf cv cdm wcel vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vf cv
      cF wss vy cv cF cfv cF vy cv cres cG cfv wceq wi vf cv vx cv wfn vx cv
      con0 wcel vy cv vf cv cdm wcel vy cv vf cv cfv vf cv vy cv cres cG cfv
      wceq vf cv cF wss vy cv cF cfv cF vy cv cres cG cfv wceq wi wi vf cv cF
      wss vf cv vx cv wfn vx cv con0 wcel wa vy cv vf cv cdm wcel wa vy cv vf
      cv cfv vf cv vy cv cres cG cfv wceq vy cv cF cfv cF vy cv cres cG cfv
      wceq vf cv cF wss vf cv vx cv wfn vx cv con0 wcel wa vy cv vf cv cdm wcel
      wa vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy cv cF cfv cF vy cv
      cres cG cfv wceq wi vf cv cF wss vf cv vx cv wfn vx cv con0 wcel wa vy cv
      vf cv cdm wcel wa wa vy cv cF cfv cF vy cv cres cG cfv wceq vy cv vf cv
      cfv vf cv vy cv cres cG cfv wceq vf cv cF wss vf cv vx cv wfn vx cv con0
      wcel wa vy cv vf cv cdm wcel wa wa vy cv cF cfv vy cv vf cv cfv cF vy cv
      cres cG cfv vf cv vy cv cres cG cfv vf cv cF wss vy cv vf cv cdm wcel vy
      cv cF cfv vy cv vf cv cfv wceq vf cv vx cv wfn vx cv con0 wcel wa cF wfun
      vf cv cF wss vy cv vf cv cdm wcel vy cv cF cfv vy cv vf cv cfv wceq vx vy
      cA vf cF cG tfrlem.1 tfrlem.2 tfrlem7 vy cv cF vf cv funssfv mp3an1
      adantrl vf cv cF wss vy cv vf cv cdm wss cF vy cv cres cG cfv vf cv vy cv
      cres cG cfv wceq vf cv vx cv wfn vx cv con0 wcel wa vy cv vf cv cdm wcel
      wa cF wfun vf cv cF wss vy cv vf cv cdm wss cF vy cv cres cG cfv vf cv vy
      cv cres cG cfv wceq vx vy cA vf cF cG tfrlem.1 tfrlem.2 tfrlem7 cF wfun
      vf cv cF wss vy cv vf cv cdm wss w3a cF vy cv cres vf cv vy cv cres cG vy
      cv cF vf cv fun2ssres fveq2d mp3an1 vf cv vx cv wfn vx cv con0 wcel vy cv
      vf cv cdm wcel vy cv vf cv cdm wss vf cv vx cv wfn vx cv con0 wcel vf cv
      cdm con0 wcel vy cv vf cv cdm wcel vy cv vf cv cdm wss wi vf cv vx cv wfn
      vf cv cdm vx cv con0 vx cv vf cv fndm eleq1d vf cv cdm vy cv onelss
      syl6bir imp31 sylan2 eqeq12d biimprd ex com3l exp31 com34 com24 sylbird
      com3l syld com24 imp4d mpdi syl exp4d ex com4r pm2.43i com3l imp4a
      r19.23adv imp 19.23aiv sylbi 19.23aiv sylbi $.
      $( [4-May-2004] $) $( [17-Aug-1994] $)

    ${
      $d x y f C $.
      tfrlem.3 $e |- C = ( F u. { <. dom F , ( G ` ( F |` dom F ) ) >. } ) $.
      $( Lemma for transfinite recursion.  We define class ` C ` by extending
         ` F ` with one ordered pair.  We will assume, falsely, that domain of
         ` F ` is a member of, and thus not equal to, ` On ` .  Using this
         assumption we will prove facts about ` C ` that will lead to a
         contradiction in ~ tfrlem13 , thus showing the domain of ` F ` does in
         fact equal ` On ` .  Here we show (under the false assumption) that
         ` C ` is a function extending the domain of ` F ` by one.  (The proof
         was shortened by Alan Sare, 20-Feb-2008.) $)
      tfrlem10 $p |- ( dom F e. On -> C Fn suc dom F ) $=
        cF cdm con0 wcel cF cF cdm cF cF cdm cres cG cfv cop csn cun cF cdm
        csuc wfn cC cF cdm csuc wfn cF cdm con0 wcel cF cF cdm cF cF cdm cres
        cG cfv cop csn cun wfun cF cF cdm cF cF cdm cres cG cfv cop csn cun cdm
        cF cdm csuc wceq wa cF cF cdm cF cF cdm cres cG cfv cop csn cun cF cdm
        csuc wfn cF cdm con0 wcel cF cF cdm cF cF cdm cres cG cfv cop csn cun
        wfun cF cF cdm cF cF cdm cres cG cfv cop csn cun cdm cF cdm csuc wceq
        cF wfun cF cdm cF cF cdm cres cG cfv cop csn wfun wa cF cdm cF cdm cF
        cF cdm cres cG cfv cop csn cdm cin c0 wceq cF cF cdm cF cF cdm cres cG
        cfv cop csn cun wfun cF cdm con0 wcel cF cF cdm cF cF cdm cres cG cfv
        cop csn funun cF cdm con0 wcel cF cdm cF cF cdm cres cG cfv cop csn
        wfun cF wfun vw cv cF cF cdm cres cG cfv cop csn wfun cF cdm cF cF cdm
        cres cG cfv cop csn wfun vw cF cdm con0 vw cv cF cdm wceq vw cv cF cF
        cdm cres cG cfv cop cF cdm cF cF cdm cres cG cfv cop wceq vw cv cF cF
        cdm cres cG cfv cop csn cF cdm cF cF cdm cres cG cfv cop csn wceq vw cv
        cF cF cdm cres cG cfv cop csn wfun cF cdm cF cF cdm cres cG cfv cop csn
        wfun wb vw cv cF cdm cF cF cdm cres cG cfv opeq1 vw cv cF cF cdm cres
        cG cfv cop cF cdm cF cF cdm cres cG cfv cop sneq vw cv cF cF cdm cres
        cG cfv cop csn cF cdm cF cF cdm cres cG cfv cop csn funeq 3syl vw cv cF
        cF cdm cres cG cfv vw visset cF cF cdm cres cG fvex funsn vtoclg vx vy
        cA vf cF cG tfrlem.1 tfrlem.2 tfrlem7 jctil cF cdm cF cdm cF cF cdm
        cres cG cfv cop csn cdm cin cF cdm cF cdm csn cin c0 cF cdm cF cF cdm
        cres cG cfv cop csn cdm cF cdm csn cF cdm cF cdm cF cF cdm cres cG cfv
        dmsnop ineq2i cF cdm word cF cdm cF cdm csn cin c0 wceq vx vy cA vf cF
        cG tfrlem.1 tfrlem.2 tfrlem8 cF cdm orddisj ax-mp eqtri sylancl cF cdm
        cF cdm cF cF cdm cres cG cfv cop csn cdm cun cF cdm cF cdm csn cun cF
        cF cdm cF cF cdm cres cG cfv cop csn cun cdm cF cdm csuc cF cdm cF cF
        cdm cres cG cfv cop csn cdm cF cdm csn cF cdm cF cdm cF cF cdm cres cG
        cfv dmsnop uneq2i cF cF cdm cF cF cdm cres cG cfv cop csn dmun cF cdm
        df-suc 3eqtr4i jctir cF cF cdm cF cF cdm cres cG cfv cop csn cun cF cdm
        csuc df-fn sylibr cC cF cF cdm cF cF cdm cres cG cfv cop csn cun wceq
        cC cF cdm csuc wfn cF cF cdm cF cF cdm cres cG cfv cop csn cun cF cdm
        csuc wfn wb tfrlem.3 cF cdm csuc cC cF cF cdm cF cF cdm cres cG cfv cop
        csn cun fneq1 ax-mp sylibr $.
        $( [20-Feb-2008] $) $( [14-Aug-1994] $)

      $( Lemma for transfinite recursion.  Compute the value of ` C ` . $)
      tfrlem11 $p |- ( dom F e. On ->
                     ( y e. suc dom F -> ( C ` y ) = ( G ` ( C |` y ) ) ) ) $=
        cF cdm con0 wcel vy cv cF cdm wcel vy cv cF cdm wceq wo vy cv cC cfv cC
        vy cv cres cG cfv wceq vy cv cF cdm csuc wcel cF cdm con0 wcel vy cv cF
        cdm wcel vy cv cC cfv cC vy cv cres cG cfv wceq vy cv cF cdm wceq cF
        cdm con0 wcel vy cv cF cdm wcel vy cv cC cfv cC vy cv cres cG cfv wceq
        cF cdm con0 wcel vy cv cF cdm wcel vy cv cF cdm wcel vy cv cC cfv cC vy
        cv cres cG cfv wceq wi wi cF cdm con0 wcel cF cdm con0 wcel vy cv cF
        cdm wcel vy cv cF cdm wcel vy cv cC cfv cC vy cv cres cG cfv wceq wi cC
        wfun cF cdm con0 wcel vy cv cF cdm wcel wa vy cv cF cdm wcel vy cv cC
        cfv cC vy cv cres cG cfv wceq wi cF cdm con0 wcel cC wfun cF cC wss cF
        cdm con0 wcel vy cv cF cdm wcel wa vy cv cF cdm wcel vy cv cC cfv cC vy
        cv cres cG cfv wceq wi cF cF cF cdm cF cF cdm cres cG cfv cop csn cun
        cC cF cF cdm cF cF cdm cres cG cfv cop csn ssun1 tfrlem.3 sseqtr4i cC
        wfun cF cC wss wa cF cdm con0 wcel vy cv cF cdm wcel wa wa vy cv cC cfv
        cC vy cv cres cG cfv wceq vy cv cF cfv cF vy cv cres cG cfv wceq vy cv
        cF cdm wcel cC wfun cF cC wss wa cF cdm con0 wcel vy cv cF cdm wcel wa
        wa vy cv cC cfv vy cv cF cfv cC vy cv cres cG cfv cF vy cv cres cG cfv
        cC wfun cF cC wss wa vy cv cF cdm wcel vy cv cC cfv vy cv cF cfv wceq
        cF cdm con0 wcel cC wfun cF cC wss vy cv cF cdm wcel vy cv cC cfv vy cv
        cF cfv wceq vy cv cC cF funssfv 3expa adantrl cC wfun cF cC wss wa vy
        cv cF cdm wss cC vy cv cres cG cfv cF vy cv cres cG cfv wceq cF cdm
        con0 wcel vy cv cF cdm wcel wa cC wfun cF cC wss wa vy cv cF cdm wss wa
        cC vy cv cres cF vy cv cres cG cC wfun cF cC wss vy cv cF cdm wss cC vy
        cv cres cF vy cv cres wceq vy cv cC cF fun2ssres 3expa fveq2d cF cdm
        con0 wcel vy cv cF cdm wcel vy cv cF cdm wss cF cdm vy cv onelss imp
        sylan2 eqeq12d vx vy cA vf cF cG tfrlem.1 tfrlem.2 tfrlem9 syl5bir
        mpanl2 cF cdm con0 wcel cC cF cdm csuc wfn cC wfun vx vy cA cC vf cF cG
        tfrlem.1 tfrlem.2 tfrlem.3 tfrlem10 cF cdm csuc cC fnfun syl sylan
        exp32 pm2.43i pm2.43d cF cdm con0 wcel vy cv cF cdm wceq vy cv cC cfv
        cC vy cv cres cG cfv wceq cF cdm con0 wcel vy cv cF cdm wceq wa vy cv
        cC cfv cC vy cv cres cG cfv wceq vy cv cC vy cv cres cG cfv cop cC wcel
        cF cdm con0 wcel vy cv cF cdm wceq wa vy cv cC vy cv cres cG cfv cop cF
        cF cdm cF cF cdm cres cG cfv cop csn cun cC cF cdm con0 wcel vy cv cF
        cdm wceq wa vy cv cC vy cv cres cG cfv cop cF cdm cF cF cdm cres cG cfv
        cop csn wcel vy cv cC vy cv cres cG cfv cop cF cF cdm cF cF cdm cres cG
        cfv cop csn cun wcel cF cdm con0 wcel vy cv cF cdm wceq wa vy cv cC vy
        cv cres cG cfv cop csn cF cdm cF cF cdm cres cG cfv cop csn vy cv cC vy
        cv cres cG cfv cop cF cdm con0 wcel vy cv cF cdm wceq wa vy cv cC vy cv
        cres cG cfv cop cF cdm cF cF cdm cres cG cfv cop cF cdm con0 wcel vy cv
        cF cdm wceq wa vy cv cC vy cv cres cG cfv cop cF cdm cC vy cv cres cG
        cfv cop cF cdm cF cF cdm cres cG cfv cop vy cv cF cdm wceq vy cv cC vy
        cv cres cG cfv cop cF cdm cC vy cv cres cG cfv cop wceq cF cdm con0
        wcel vy cv cF cdm cC vy cv cres cG cfv opeq1 adantl cF cdm con0 wcel vy
        cv cF cdm wceq wa cC vy cv cres cF cF cdm cres wceq cC vy cv cres cG
        cfv cF cF cdm cres cG cfv wceq cF cdm cC vy cv cres cG cfv cop cF cdm
        cF cF cdm cres cG cfv cop wceq cF cdm con0 wcel vy cv cF cdm wceq wa cC
        vy cv cres cF vy cv cres cF cF cdm cres cC wfun vy cv cF cdm wss cC vy
        cv cres cF vy cv cres wceq cF cdm con0 wcel vy cv cF cdm wceq cC wfun
        cF cC wss vy cv cF cdm wss cC vy cv cres cF vy cv cres wceq cF cF cF
        cdm cF cF cdm cres cG cfv cop csn cun cC cF cF cdm cF cF cdm cres cG
        cfv cop csn ssun1 tfrlem.3 sseqtr4i vy cv cC cF fun2ssres mp3an2 cF cdm
        con0 wcel cC cF cdm csuc wfn cC wfun vx vy cA cC vf cF cG tfrlem.1
        tfrlem.2 tfrlem.3 tfrlem10 cF cdm csuc cC fnfun syl vy cv cF cdm eqimss
        syl2an vy cv cF cdm wceq cF vy cv cres cF cF cdm cres wceq cF cdm con0
        wcel vy cv cF cdm cF reseq2 adantl eqtrd cC vy cv cres cF cF cdm cres
        cG fveq2 cC vy cv cres cG cfv cF cF cdm cres cG cfv cF cdm opeq2 3syl
        eqtrd sneqd vy cv cC vy cv cres cG cfv cop vy cv cC vy cv cres cG cfv
        opex snid syl5eleq vy cv cC vy cv cres cG cfv cop cF cdm cF cF cdm cres
        cG cfv cop csn cF elun2 syl tfrlem.3 syl6eleqr cC cF cdm csuc wfn vy cv
        cF cdm csuc wcel vy cv cC cfv cC vy cv cres cG cfv wceq vy cv cC vy cv
        cres cG cfv cop cC wcel wb cF cdm con0 wcel vy cv cF cdm wceq cF cdm
        csuc vy cv cC vy cv cres cG cfv cC cC vy cv cres cG fvex fnopfvb vx vy
        cA cC vf cF cG tfrlem.1 tfrlem.2 tfrlem.3 tfrlem10 vy cv cF cdm vy
        visset eqelsuc syl2an mpbird ex jaod vy cv cF cdm elsuci syl5 $.
        $( [4-May-2004] $) $( [18-Aug-1994] $)

      $( Lemma for transfinite recursion.  Show ` C ` is an acceptable
         function. $)
      tfrlem12 $p |- ( dom F e. On -> C e. A ) $=
        cF cdm con0 wcel cC cA wcel cC vx cv wfn vy cv cC cfv cC vy cv cres cG
        cfv wceq vy vx cv wral wa vx con0 wrex cF cdm csuc con0 wcel cC cF cdm
        csuc wfn vy cv cC cfv cC vy cv cres cG cfv wceq vy cF cdm csuc wral wa
        cC vx cv wfn vy cv cC cfv cC vy cv cres cG cfv wceq vy vx cv wral wa vx
        con0 wrex cF cdm con0 wcel cC vx cv wfn vy cv cC cfv cC vy cv cres cG
        cfv wceq vy vx cv wral wa cC cF cdm csuc wfn vy cv cC cfv cC vy cv cres
        cG cfv wceq vy cF cdm csuc wral wa vx cF cdm csuc con0 vx cv cF cdm
        csuc wceq cC vx cv wfn cC cF cdm csuc wfn vy cv cC cfv cC vy cv cres cG
        cfv wceq vy vx cv wral vy cv cC cfv cC vy cv cres cG cfv wceq vy cF cdm
        csuc wral vx cv cF cdm csuc cC fneq2 vy cv cC cfv cC vy cv cres cG cfv
        wceq vy vx cv cF cdm csuc raleq1 anbi12d rcla4ev cF cdm suceloni cF cdm
        con0 wcel cC cF cdm csuc wfn vy cv cC cfv cC vy cv cres cG cfv wceq vy
        cF cdm csuc wral vx vy cA cC vf cF cG tfrlem.1 tfrlem.2 tfrlem.3
        tfrlem10 cF cdm con0 wcel vy cv cC cfv cC vy cv cres cG cfv wceq vy cF
        cdm csuc vx vy cA cC vf cF cG tfrlem.1 tfrlem.2 tfrlem.3 tfrlem11
        r19.21aiv jca sylanc cF cdm con0 wcel cC cvv wcel cC cA wcel cC vx cv
        wfn vy cv cC cfv cC vy cv cres cG cfv wceq vy vx cv wral wa vx con0
        wrex wb cC cF cdm csuc wfn cF cdm csuc con0 wcel cC cvv wcel cF cdm
        con0 wcel cF cdm csuc con0 cC fnex vx vy cA cC vf cF cG tfrlem.1
        tfrlem.2 tfrlem.3 tfrlem10 cF cdm suceloni sylanc vf cv vx cv wfn vy cv
        vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex cC
        vx cv wfn vy cv cC cfv cC vy cv cres cG cfv wceq vy vx cv wral wa vx
        con0 wrex vf cC cA cvv vf cv cC wceq vf cv vx cv wfn vy cv vf cv cfv vf
        cv vy cv cres cG cfv wceq vy vx cv wral wa cC vx cv wfn vy cv cC cfv cC
        vy cv cres cG cfv wceq vy vx cv wral wa vx con0 vf cv cC wceq vf cv vx
        cv wfn cC vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx
        cv wral vy cv cC cfv cC vy cv cres cG cfv wceq vy vx cv wral vx cv vf
        cv cC fneq1 vf cv cC wceq vy cv vf cv cfv vf cv vy cv cres cG cfv wceq
        vy cv cC cfv cC vy cv cres cG cfv wceq vy vx cv vf cv cC wceq vy cv vf
        cv cfv vy cv cC cfv vf cv vy cv cres cG cfv cC vy cv cres cG cfv vy cv
        vf cv cC fveq1 vf cv cC wceq vf cv vy cv cres cC vy cv cres cG vf cv cC
        vy cv reseq1 fveq2d eqeq12d ralbidv anbi12d rexbidv tfrlem.1 elab2g syl
        mpbird $.
        $( [4-May-2004] $) $( [15-Aug-1994] $)

      $( Lemma for transfinite recursion.  If ` dom F ` is in ` On ` , then
         ` C ` is acceptable, and thus a subset of ` F ` , but ` dom C ` is
         bigger than ` dom F ` .  This is a contradiction, so ` dom F ` must be
         ` On ` . $)
      tfrlem13 $p |- dom F = On $=
        cF cdm con0 wcel wn cF cdm con0 wcel cF cdm con0 wceq wo cF cdm con0
        wceq cF cdm word cF cdm con0 wcel wn vx vy cA vf cF cG tfrlem.1
        tfrlem.2 tfrlem8 cF cdm word cF cdm cF cdm wcel cF cdm con0 wcel cF cdm
        ordirr cC cA wcel cF cdm cC cdm wcel cF cdm cF cdm wcel cF cdm con0
        wcel cC cA wcel cC cF wss cC cdm cF cdm wss cF cdm cC cdm wcel cF cdm
        cF cdm wcel wi cC cA wcel cC cA cuni cF cC cA elssuni tfrlem.2 syl6ssr
        cC cF dmss cC cdm cF cdm cF cdm ssel 3syl vx vy cA cC vf cF cG tfrlem.1
        tfrlem.2 tfrlem.3 tfrlem12 cF cdm con0 wcel cF cdm cF cdm csuc cC cdm
        cF cdm con0 sucidg cF cdm con0 wcel cC cF cdm csuc wfn cC cdm cF cdm
        csuc wceq vx vy cA cC vf cF cG tfrlem.1 tfrlem.2 tfrlem.3 tfrlem10 cF
        cdm csuc cC fndm syl eleqtrrd sylc nsyl ax-mp cF cdm word cF cdm con0
        wcel cF cdm con0 wceq wo vx vy cA vf cF cG tfrlem.1 tfrlem.2 tfrlem8 cF
        cdm ordeleqon mpbi cF cdm con0 wcel cF cdm con0 wceq orel1 mp2 $.
        $( [4-May-2004] $) $( [14-Aug-1994] $)

    $}
  $}

  ${
    $d x y f A $.  $d x y f F $.
    $d x y f G $.  $d x y B $.  $d y z $.
    tfr.1 $e |- A = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( G ` ( f |` y ) ) ) } $.

    $( Let ` F ` be the union of all acceptable functions. $)
    tfr.2 $e |- F = U. A $.

    $( Principle of Transfinite Recursion, part 1 of 3.  Theorem 7.41(1) of
       [TakeutiZaring] p. 47.  We start with an arbitrary class ` G ` ,
       normally a function, and define a class ` A ` of all "acceptable"
       functions.  The final function we're interested in is the union
       ` F ` of them.  ` F ` is then said to be defined by transfinite
       recursion.  The purpose of the 3 parts of this theorem is to
       demonstrate properties of ` F ` .  In this first part we
       show that ` F ` is a function whose domain is all ordinal numbers. $)
    tfr1 $p |- F Fn On $=
      cF con0 wfn cF wfun cF cdm con0 wceq cF con0 df-fn vx vy cA vf cF cG
      tfr.1 tfr.2 tfrlem7 vx vy cA cF cF cdm cF cF cdm cres cG cfv cop csn cun
      vf cF cG tfr.1 tfr.2 cF cF cdm cF cF cdm cres cG cfv cop csn cun eqid
      tfrlem13 mpbir2an $.
      $( [5-May-2004] $) $( [17-Aug-1994] $)

    $( Principle of Transfinite Recursion, part 2 of 3.  Theorem 7.41(2) of
       [TakeutiZaring] p. 47.  Here we show that the function ` F ` has the
       property that for any function ` G ` whatsoever, the "next" value
       of ` F ` is ` G ` recursively applied to all "previous" values of
       ` F ` . $)
    tfr2 $p |- ( z e. On -> ( F ` z ) = ( G ` ( F |` z ) ) ) $=
      vy cv cF cfv cF vy cv cres cG cfv wceq vz cv cF cfv cF vz cv cres cG cfv
      wceq vy vz cv con0 vy cv vz cv wceq vy cv cF cfv vz cv cF cfv cF vy cv
      cres cG cfv cF vz cv cres cG cfv vy cv vz cv cF fveq2 vy cv vz cv wceq cF
      vy cv cres cF vz cv cres cG vy cv vz cv cF reseq2 fveq2d eqeq12d vy cv
      con0 wcel vy cv cF cdm wcel vy cv cF cfv cF vy cv cres cG cfv wceq cF cdm
      con0 vy cv vx vy cA cF cF cdm cF cF cdm cres cG cfv cop csn cun vf cF cG
      tfr.1 tfr.2 cF cF cdm cF cF cdm cres cG cfv cop csn cun eqid tfrlem13
      eleq2i vx vy cA vf cF cG tfr.1 tfr.2 tfrlem9 sylbir vtoclga $.
      $( [5-May-2004] $) $( [9-Apr-1995] $)

    $( Principle of Transfinite Recursion, part 3 of 3.  Theorem 7.41(3) of
       [TakeutiZaring] p. 47.  Finally we show that ` F ` is unique.  We do
       this by showing that any class ` B ` with the same properties of ` F `
       that we showed in parts 1 and 2 is identical to ` F ` . $)
    tfr3 $p |- ( ( B Fn On /\
               A. x e. On ( B ` x ) = ( G ` ( B |` x ) ) ) -> B = F ) $=
      cB con0 wfn vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 wral vx cv cB
      cfv vx cv cF cfv wceq vx con0 wral cB cF wceq cB con0 wfn vx cv cB cfv cB
      vx cv cres cG cfv wceq vx con0 wral wa vx cv cB cfv vx cv cF cfv wceq vx
      con0 cB con0 wfn vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 wral vx
      cB con0 wfn vx ax-17 vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 hbra1
      hban vx cv con0 wcel cB con0 wfn vx cv cB cfv cB vx cv cres cG cfv wceq
      vx con0 wral wa vx cv cB cfv vx cv cF cfv wceq cB con0 wfn vx cv cB cfv
      cB vx cv cres cG cfv wceq vx con0 wral wa vx cv cB cfv vx cv cF cfv wceq
      wi cB con0 wfn vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 wral wa vy
      cv cB cfv vy cv cF cfv wceq wi vx vy cB con0 wfn vx cv cB cfv cB vx cv
      cres cG cfv wceq vx con0 wral wa vy cv cB cfv vy cv cF cfv wceq vx cB
      con0 wfn vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 wral vx cB con0
      wfn vx ax-17 vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 hbra1 hban vy
      cv cB cfv vy cv cF cfv wceq vx ax-17 hbim vx cv vy cv wceq vx cv cB cfv
      vx cv cF cfv wceq vy cv cB cfv vy cv cF cfv wceq cB con0 wfn vx cv cB cfv
      cB vx cv cres cG cfv wceq vx con0 wral wa vx cv vy cv wceq vx cv cB cfv
      vy cv cB cfv vx cv cF cfv vy cv cF cfv vx cv vy cv cB fveq2 vx cv vy cv
      cF fveq2 eqeq12d imbi2d vx cv con0 wcel cB con0 wfn vx cv cB cfv cB vx cv
      cres cG cfv wceq vx con0 wral wa vy cv cB cfv vy cv cF cfv wceq vy vx cv
      wral wi cB con0 wfn vx cv cB cfv cB vx cv cres cG cfv wceq vx con0 wral
      wa vx cv cB cfv vx cv cF cfv wceq wi cB con0 wfn vx cv cB cfv cB vx cv
      cres cG cfv wceq vx con0 wral wa vy cv cB cfv vy cv cF cfv wceq wi vy vx
      cv wral vx cv con0 wcel cB con0 wfn vx cv cB cfv cB vx cv cres cG cfv
      wceq vx con0 wral wa vy cv cB cfv vy cv cF cfv wceq vy vx cv wral vx cv
      cB cfv vx cv cF cfv wceq vx cv con0 wcel cB con0 wfn vx cv cB cfv cB vx
      cv cres cG cfv wceq vx con0 wral vy cv cB cfv vy cv cF cfv wceq vy vx cv
      wral vx cv cB cfv vx cv cF cfv wceq wi vx cv cB cfv cB vx cv cres cG cfv
      wceq vx con0 wral vx cv con0 wcel cB con0 wfn vy cv cB cfv vy cv cF cfv
      wceq vy vx cv wral vx cv cB cfv vx cv cF cfv wceq wi vx cv cB cfv cB vx
      cv cres cG cfv wceq vx con0 wral vx cv con0 wcel vx cv cB cfv cB vx cv
      cres cG cfv wceq wi vx cv con0 wcel cB con0 wfn vy cv cB cfv vy cv cF cfv
      wceq vy vx cv wral vx cv cB cfv vx cv cF cfv wceq wi wi wi vx cv cB cfv
      cB vx cv cres cG cfv wceq vx con0 ra4 vx cv con0 wcel vx cv cB cfv cB vx
      cv cres cG cfv wceq wi vx cv con0 wcel cB con0 wfn vy cv cB cfv vy cv cF
      cfv wceq vy vx cv wral vx cv cB cfv vx cv cF cfv wceq wi wi vx cv con0
      wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi vx cv con0 wcel vx cv con0
      wcel cB con0 wfn vy cv cB cfv vy cv cF cfv wceq vy vx cv wral vx cv cB
      cfv vx cv cF cfv wceq wi vx cv con0 wcel cB con0 wfn wa vy cv cB cfv vy
      cv cF cfv wceq vy vx cv wral vx cv con0 wcel vx cv cB cfv cB vx cv cres
      cG cfv wceq wi vx cv con0 wcel vx cv cB cfv vx cv cF cfv wceq vx cv con0
      wcel cB con0 wfn wa vy cv cB cfv vy cv cF cfv wceq vy vx cv wral vx cv
      con0 wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi vx cv con0 wcel vx cv
      cB cfv vx cv cF cfv wceq vx cv con0 wcel cB con0 wfn wa vy cv cB cfv vy
      cv cF cfv wceq vy vx cv wral wa vx cv con0 wcel vx cv cB cfv cB vx cv
      cres cG cfv wceq wi vx cv con0 wcel wa wa vx cv cB cfv vx cv cF cfv wceq
      cB vx cv cres cG cfv cF vx cv cres cG cfv wceq vx cv con0 wcel cB con0
      wfn wa vy cv cB cfv vy cv cF cfv wceq vy vx cv wral wa cB vx cv cres cG
      cfv cF vx cv cres cG cfv wceq vx cv con0 wcel vx cv cB cfv cB vx cv cres
      cG cfv wceq wi vx cv con0 wcel wa vx cv con0 wcel cB con0 wfn wa vy cv cB
      cfv vy cv cF cfv wceq vy vx cv wral cB vx cv cres cG cfv cF vx cv cres cG
      cfv wceq cB con0 wfn vx cv con0 wcel vy cv cB cfv vy cv cF cfv wceq vy vx
      cv wral cB vx cv cres cG cfv cF vx cv cres cG cfv wceq wi cB con0 wfn vx
      cv con0 wss vy cv cB cfv vy cv cF cfv wceq vy vx cv wral cB vx cv cres cG
      cfv cF vx cv cres cG cfv wceq wi vx cv con0 wcel cB con0 wfn vx cv con0
      wss wa vy cv cB cfv vy cv cF cfv wceq vy vx cv wral cB vx cv cres cF vx
      cv cres wceq cB vx cv cres cG cfv cF vx cv cres cG cfv wceq cB con0 wfn
      cF con0 wfn vx cv con0 wss cB vx cv cres cF vx cv cres wceq vy cv cB cfv
      vy cv cF cfv wceq vy vx cv wral wb vx vy cA vf cF cG tfr.1 tfr.2 tfr1 vy
      con0 vx cv cB cF fvreseq mpanl2 cB vx cv cres cF vx cv cres cG fveq2
      syl6bir vx cv onss sylan2 ancoms imp adantr vx cv con0 wcel vx cv cB cfv
      cB vx cv cres cG cfv wceq wi vx cv con0 wcel wa vx cv cB cfv vx cv cF cfv
      wceq cB vx cv cres cG cfv cF vx cv cres cG cfv wceq wb vx cv con0 wcel cB
      con0 wfn wa vy cv cB cfv vy cv cF cfv wceq vy vx cv wral wa vx cv con0
      wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi vx cv con0 wcel vx cv cB
      cfv vx cv cF cfv wceq cB vx cv cres cG cfv cF vx cv cres cG cfv wceq wb
      vx cv con0 wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi vx cv con0 wcel
      vx cv cB cfv cB vx cv cres cG cfv wceq vx cv cF cfv cF vx cv cres cG cfv
      wceq wa vx cv cB cfv vx cv cF cfv wceq cB vx cv cres cG cfv cF vx cv cres
      cG cfv wceq wb vx cv con0 wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi
      vx cv con0 wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi vx cv con0 wcel
      vx cv cF cfv cF vx cv cres cG cfv wceq wi wa vx cv con0 wcel vx cv cB cfv
      cB vx cv cres cG cfv wceq vx cv cF cfv cF vx cv cres cG cfv wceq wa wi vx
      cv con0 wcel vx cv cB cfv cB vx cv cres cG cfv wceq wi vx cv con0 wcel vx
      cv cF cfv cF vx cv cres cG cfv wceq wi vx vy vx cA vf cF cG tfr.1 tfr.2
      tfr2 jctr vx cv con0 wcel vx cv cB cfv cB vx cv cres cG cfv wceq vx cv cF
      cfv cF vx cv cres cG cfv wceq jcab sylibr vx cv cB cfv cB vx cv cres cG
      cfv vx cv cF cfv cF vx cv cres cG cfv eqeq12 syl6 imp adantl mpbird exp43
      com4t exp4a pm2.43d syl com3l imp3a a2d cB con0 wfn vx cv cB cfv cB vx cv
      cres cG cfv wceq vx con0 wral wa vy cv cB cfv vy cv cF cfv wceq vy vx cv
      r19.21v syl5ib tfis2f com12 r19.21ai cB con0 wfn con0 con0 wceq vx cv cB
      cfv vx cv cF cfv wceq vx con0 wral cB cF wceq con0 eqid cB con0 wfn cB cF
      wceq con0 con0 wceq vx cv cB cfv vx cv cF cfv wceq vx con0 wral wa cB
      con0 wfn cF con0 wfn cB cF wceq con0 con0 wceq vx cv cB cfv vx cv cF cfv
      wceq vx con0 wral wa wb vx vy cA vf cF cG tfr.1 tfr.2 tfr1 vx con0 con0
      cB cF eqfnfv mpan2 biimpar mpanr1 syldan $.
      $( [5-May-2004] $) $( [18-Aug-1994] $)
  $}

  ${
    $d x y A $.  $d x F $.  $d x G $.  $d y H $.
    tz7.44lem1.1 $e |- G = { <. x , y >. | ( ( x = (/) /\ y = A ) \/
            ( -. ( x = (/) \/ Lim dom x ) /\ y = ( H ` ( x ` U. dom x ) ) )
                \/ ( Lim dom x /\ y = U. ran x ) ) } $.
    $( ` G ` is a function.  Lemma for ~ tz7.44-1 , ~ tz7.44-2 , and
       ~ tz7.44-3 . $)
    tz7.44lem1 $p |- Fun G $=
      cG wfun vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo wn
      vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv
      crn cuni wceq wa w3o vx vy copab wfun vx cv c0 wceq vy cv cA wceq wa vx
      cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv
      wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa w3o vx vy copab wfun
      vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv
      vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn
      cuni wceq wa w3o vy wmo vx vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq
      vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv
      cdm wlim vy cv vx cv crn cuni wceq wa w3o vx vy funopab vx cv c0 wceq vx
      cv cdm wlim vy cA vx cv cdm cuni vx cv cfv cH cfv vx cv crn cuni vx cv
      cdm cuni vx cv cfv cH fvex vx cv cvv wcel vx cv crn cuni cvv wcel vx
      visset vx cv cvv wcel vx cv crn cvv wcel vx cv crn cuni cvv wcel vx cv
      cvv rnexg vx cv crn cvv uniexg syl ax-mp vx cv c0 wceq vx cv cdm wlim wa
      c0 cdm wlim c0 cdm wlim c0 wlim nlim0 c0 cdm c0 wceq c0 cdm wlim c0 wlim
      wb dm0 c0 cdm c0 limeq ax-mp mtbir vx cv c0 wceq vx cv cdm wlim c0 cdm
      wlim vx cv c0 wceq vx cv cdm c0 cdm wceq vx cv cdm wlim c0 cdm wlim wb vx
      cv c0 dmeq vx cv cdm c0 cdm limeq syl biimpa mto moeq3 mpgbir cG vx cv c0
      wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm
      cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa
      w3o vx vy copab wceq cG wfun vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq
      vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv
      cdm wlim vy cv vx cv crn cuni wceq wa w3o vx vy copab wfun wb
      tz7.44lem1.1 cG vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm
      wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim
      vy cv vx cv crn cuni wceq wa w3o vx vy copab funeq ax-mp mpbir $.
      $( [23-Apr-1995] $)
  $}

  ${
    $d x y A $.  $d x F $.  $d x G $.  $d y H $.
    tz7.44.1 $e |- G = { <. x , y >. | ( ( x = (/) /\ y = A ) \/
            ( -. ( x = (/) \/ Lim dom x ) /\ y = ( H ` ( x ` U. dom x ) ) )
                \/ ( Lim dom x /\ y = U. ran x ) ) } $.
    tz7.44.2 $e |- F Fn On $.
    tz7.44.3 $e |- ( x e. On -> ( F ` x ) = ( G ` ( F |` x ) ) ) $.
    ${
      tz7.44.4 $e |- A e. _V $.
      $( The value of ` F ` at ` (/) ` .  Part 1 of Theorem 7.44 of
         [TakeutiZaring] p. 49. $)
      tz7.44-1 $p |- ( F ` (/) ) = A $=
        c0 cF cfv cF c0 cres cG cfv c0 cG cfv cA c0 con0 wcel c0 cF cfv cF c0
        cres cG cfv wceq 0elon vx cv cF cfv cF vx cv cres cG cfv wceq c0 cF cfv
        cF c0 cres cG cfv wceq vx c0 con0 vx cv c0 wceq vx cv cF cfv c0 cF cfv
        cF vx cv cres cG cfv cF c0 cres cG cfv vx cv c0 cF fveq2 vx cv c0 wceq
        cF vx cv cres cF c0 cres cG vx cv c0 cF reseq2 fveq2d eqeq12d tz7.44.3
        vtoclga ax-mp cF c0 cres c0 cG cF res0 fveq2i cG wfun c0 cA cop cG wcel
        c0 cG cfv cA wceq vx vy cA cG cH tz7.44.1 tz7.44lem1 vx cv c0 wceq vy
        cv cA wceq wa vx vy copab cG c0 cA cop vx cv c0 wceq vy cv cA wceq wa
        vx vy copab vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim
        wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy
        cv vx cv crn cuni wceq wa w3o vx vy copab cG vx cv c0 wceq vy cv cA
        wceq wa vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo
        wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv
        vx cv crn cuni wceq wa w3o vx vy vx cv c0 wceq vy cv cA wceq wa vx cv
        c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq
        wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa 3mix1 ssopab2i tz7.44.1
        sseqtr4i c0 cA cop vx cv c0 wceq vy cv cA wceq wa vx vy copab wcel c0
        c0 wceq cA cA wceq vx cv c0 wceq vy cv cA wceq wa c0 c0 wceq vy cv cA
        wceq wa c0 c0 wceq cA cA wceq wa vx vy c0 cA 0ex tz7.44.4 vx cv c0 wceq
        vx cv c0 wceq c0 c0 wceq vy cv cA wceq vx cv c0 c0 eqeq1 anbi1d vy cv
        cA wceq vy cv cA wceq cA cA wceq c0 c0 wceq vy cv cA cA eqeq1 anbi2d
        opelopab c0 eqid cA eqid mpbir2an sselii c0 cA cG tz7.44.4 funopfv mp2
        3eqtri $.
        $( [23-Apr-1995] $)
    $}

    ${
      $d x y B $.  $d y F $.  $d x H $.
      tz7.44.5 $e |- B e. On $.
      $( The value of ` F ` at a successor ordinal.  Part 2 of Theorem 7.44
         of [TakeutiZaring] p. 49. $)
      tz7.44-2 $p |- ( F ` suc B ) = ( H ` ( F ` B ) ) $=
        cB csuc cF cfv cF cB csuc cres cG cfv cB cF cfv cH cfv cB csuc con0
        wcel cB csuc cF cfv cF cB csuc cres cG cfv wceq cB tz7.44.5 onsuci vx
        cv cF cfv cF vx cv cres cG cfv wceq cB csuc cF cfv cF cB csuc cres cG
        cfv wceq vx cB csuc con0 vx cv cB csuc wceq vx cv cF cfv cB csuc cF cfv
        cF vx cv cres cG cfv cF cB csuc cres cG cfv vx cv cB csuc cF fveq2 vx
        cv cB csuc wceq cF vx cv cres cF cB csuc cres cG vx cv cB csuc cF
        reseq2 fveq2d eqeq12d tz7.44.3 vtoclga ax-mp cG wfun cF cB csuc cres cB
        cF cfv cH cfv cop cG wcel cF cB csuc cres cG cfv cB cF cfv cH cfv wceq
        vx vy cA cG cH tz7.44.1 tz7.44lem1 vx cv c0 wceq vx cv cdm wlim wo wn
        vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx vy copab cG cF cB csuc
        cres cB cF cfv cH cfv cop vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx
        cv cdm cuni vx cv cfv cH cfv wceq wa vx vy copab vx cv c0 wceq vy cv cA
        wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv
        cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa w3o vx
        vy copab cG vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx
        cv cfv cH cfv wceq wa vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx
        cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv
        cdm wlim vy cv vx cv crn cuni wceq wa w3o vx vy vx cv c0 wceq vx cv cdm
        wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv c0 wceq
        vy cv cA wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa 3mix2
        ssopab2i tz7.44.1 sseqtr4i cF cB csuc cres cB cF cfv cH cfv cop vx cv
        c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq
        wa vx vy copab wcel cF cB csuc cres c0 wceq cF cB csuc cres cdm wlim wo
        wn cB cF cfv cH cfv cF cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv
        wceq vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv
        cH cfv wceq wa cF cB csuc cres c0 wceq cF cB csuc cres cdm wlim wo wn
        vy cv cF cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv wceq wa cF cB
        csuc cres c0 wceq cF cB csuc cres cdm wlim wo wn cB cF cfv cH cfv cF cB
        csuc cres cdm cuni cF cB csuc cres cfv cH cfv wceq wa vx vy cF cB csuc
        cres cB cF cfv cH cfv cF wfun cB csuc con0 wcel cF cB csuc cres cvv
        wcel cF con0 wfn cF wfun tz7.44.2 con0 cF fnfun ax-mp cB tz7.44.5
        onsuci cF cB csuc con0 resfunexg mp2an cB cF cfv cH fvex vx cv cF cB
        csuc cres wceq vx cv c0 wceq vx cv cdm wlim wo wn cF cB csuc cres c0
        wceq cF cB csuc cres cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH
        cfv wceq vy cv cF cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv wceq
        vx cv cF cB csuc cres wceq vx cv c0 wceq vx cv cdm wlim wo cF cB csuc
        cres c0 wceq cF cB csuc cres cdm wlim wo vx cv cF cB csuc cres wceq vx
        cv c0 wceq cF cB csuc cres c0 wceq vx cv cdm wlim cF cB csuc cres cdm
        wlim vx cv cF cB csuc cres c0 eqeq1 vx cv cF cB csuc cres wceq vx cv
        cdm cF cB csuc cres cdm wceq vx cv cdm wlim cF cB csuc cres cdm wlim wb
        vx cv cF cB csuc cres dmeq vx cv cdm cF cB csuc cres cdm limeq syl
        orbi12d notbid vx cv cF cB csuc cres wceq vx cv cdm cuni vx cv cfv cH
        cfv cF cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv vy cv vx cv cF
        cB csuc cres wceq vx cv cdm cuni vx cv cfv cF cB csuc cres cdm cuni cF
        cB csuc cres cfv cH vx cv cF cB csuc cres wceq vx cv cdm cuni vx cv cfv
        cF cB csuc cres cdm cuni vx cv cfv cF cB csuc cres cdm cuni cF cB csuc
        cres cfv vx cv cF cB csuc cres wceq vx cv cdm cF cB csuc cres cdm wceq
        vx cv cdm cuni cF cB csuc cres cdm cuni wceq vx cv cdm cuni vx cv cfv
        cF cB csuc cres cdm cuni vx cv cfv wceq vx cv cF cB csuc cres dmeq vx
        cv cdm cF cB csuc cres cdm unieq vx cv cdm cuni cF cB csuc cres cdm
        cuni vx cv fveq2 3syl cF cB csuc cres cdm cuni vx cv cF cB csuc cres
        fveq1 eqtrd fveq2d eqeq2d anbi12d vy cv cB cF cfv cH cfv wceq vy cv cF
        cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv wceq cB cF cfv cH cfv
        cF cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv wceq cF cB csuc
        cres c0 wceq cF cB csuc cres cdm wlim wo wn vy cv cB cF cfv cH cfv cF
        cB csuc cres cdm cuni cF cB csuc cres cfv cH cfv eqeq1 anbi2d opelopab
        cF cB csuc cres c0 wceq cF cB csuc cres cdm wlim cF cB csuc cres c0
        wceq cF cB csuc cres cdm c0 wceq cF cB csuc cres cdm c0 wceq cB csuc c0
        cB nsuceq0 cF cB csuc cres cdm cB csuc c0 cB csuc cF cdm cin cB csuc
        con0 cin cF cB csuc cres cdm cB csuc cF cdm con0 cB csuc cF con0 wfn cF
        cdm con0 wceq tz7.44.2 con0 cF fndm ax-mp ineq2i cF cB csuc dmres cB
        csuc con0 wss cB csuc cB csuc con0 cin wceq cB csuc cB tz7.44.5 onsuci
        onssi cB csuc con0 dfss mpbi 3eqtr4i eqeq1i nemtbir cF cB csuc cres c0
        wceq cF cB csuc cres cdm c0 cdm c0 cF cB csuc cres c0 dmeq dm0 syl6eq
        mto cF cB csuc cres cdm wlim cB csuc wlim cB cvv wcel cB csuc wlim wn
        cB con0 tz7.44.5 elisseti cB cvv nlimsucg ax-mp cF cB csuc cres cdm cB
        csuc wceq cF cB csuc cres cdm wlim cB csuc wlim wb cB csuc cF cdm cin
        cB csuc con0 cin cF cB csuc cres cdm cB csuc cF cdm con0 cB csuc cF
        con0 wfn cF cdm con0 wceq tz7.44.2 con0 cF fndm ax-mp ineq2i cF cB csuc
        dmres cB csuc con0 wss cB csuc cB csuc con0 cin wceq cB csuc cB
        tz7.44.5 onsuci onssi cB csuc con0 dfss mpbi 3eqtr4i cF cB csuc cres
        cdm cB csuc limeq ax-mp mtbir pm3.2ni cB cF cfv cF cB csuc cres cdm
        cuni cF cB csuc cres cfv cH cB cF cB csuc cres cfv cB cF cfv cF cB csuc
        cres cdm cuni cF cB csuc cres cfv cB cB csuc wcel cB cF cB csuc cres
        cfv cB cF cfv wceq cB cB con0 tz7.44.5 elisseti sucid cB cB csuc cF
        fvres ax-mp cB cF cB csuc cres cdm cuni cF cB csuc cres cF cB csuc cres
        cdm cuni cB csuc cuni cB cF cB csuc cres cdm cB csuc cB csuc cF cdm cin
        cB csuc con0 cin cF cB csuc cres cdm cB csuc cF cdm con0 cB csuc cF
        con0 wfn cF cdm con0 wceq tz7.44.2 con0 cF fndm ax-mp ineq2i cF cB csuc
        dmres cB csuc con0 wss cB csuc cB csuc con0 cin wceq cB csuc cB
        tz7.44.5 onsuci onssi cB csuc con0 dfss mpbi 3eqtr4i unieqi cB tz7.44.5
        onunisuci eqtr2i fveq2i eqtr3i fveq2i mpbir2an sselii cF cB csuc cres
        cB cF cfv cH cfv cG cB cF cfv cH fvex funopfv mp2 eqtri $.
        $( [23-Apr-1995] $)

      $( The value of ` F ` at a limit ordinal.  Part 3 of Theorem 7.44 of
         [TakeutiZaring] p. 49. $)
      tz7.44-3 $p |- ( Lim B -> ( F ` B ) = U. ( F " B ) ) $=
        cB wlim cF cB cres cG cfv cF cB cima cuni cB cF cfv cB wlim cF cB cres
        cF cB cima cuni cop vx cv cdm wlim vy cv vx cv crn cuni wceq wa vx vy
        copab wcel cF cB cres cF cB cima cuni cop cG wcel cF cB cres cG cfv cF
        cB cima cuni wceq cB wlim cF cB cres cdm wlim cF cB cima cuni cF cB
        cres crn cuni wceq wa cF cB cres cF cB cima cuni cop vx cv cdm wlim vy
        cv vx cv crn cuni wceq wa vx vy copab wcel cB wlim cF cB cres cdm wlim
        cF cB cima cuni cF cB cres crn cuni wceq cF cB cres cdm wlim cB wlim cF
        cB cres cdm cB wceq cF cB cres cdm wlim cB wlim wb cB cF cdm cin cB
        con0 cin cF cB cres cdm cB cF cdm con0 cB cF con0 wfn cF cdm con0 wceq
        tz7.44.2 con0 cF fndm ax-mp ineq2i cF cB dmres cB con0 wss cB cB con0
        cin wceq cB tz7.44.5 onssi cB con0 dfss mpbi 3eqtr4i cF cB cres cdm cB
        limeq ax-mp biimpri cF cB cima cF cB cres crn cF cB df-ima unieqi jctir
        vx cv cdm wlim vy cv vx cv crn cuni wceq wa cF cB cres cdm wlim vy cv
        cF cB cres crn cuni wceq wa cF cB cres cdm wlim cF cB cima cuni cF cB
        cres crn cuni wceq wa vx vy cF cB cres cF cB cima cuni cF wfun cB con0
        wcel cF cB cres cvv wcel cF con0 wfn cF wfun tz7.44.2 con0 cF fnfun
        ax-mp tz7.44.5 cF cB con0 resfunexg mp2an cF cB cima cF wfun cF cB cima
        cvv wcel cF con0 wfn cF wfun tz7.44.2 con0 cF fnfun ax-mp cF cB cB con0
        tz7.44.5 elisseti funimaex ax-mp uniex vx cv cF cB cres wceq vx cv cdm
        wlim cF cB cres cdm wlim vy cv vx cv crn cuni wceq vy cv cF cB cres crn
        cuni wceq vx cv cF cB cres wceq vx cv cdm cF cB cres cdm wceq vx cv cdm
        wlim cF cB cres cdm wlim wb vx cv cF cB cres dmeq vx cv cdm cF cB cres
        cdm limeq syl vx cv cF cB cres wceq vx cv crn cuni cF cB cres crn cuni
        vy cv vx cv cF cB cres wceq vx cv crn cF cB cres crn vx cv cF cB cres
        rneq unieqd eqeq2d anbi12d vy cv cF cB cima cuni wceq vy cv cF cB cres
        crn cuni wceq cF cB cima cuni cF cB cres crn cuni wceq cF cB cres cdm
        wlim vy cv cF cB cima cuni cF cB cres crn cuni eqeq1 anbi2d opelopab
        sylibr vx cv cdm wlim vy cv vx cv crn cuni wceq wa vx vy copab cG cF cB
        cres cF cB cima cuni cop vx cv cdm wlim vy cv vx cv crn cuni wceq wa vx
        vy copab vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo
        wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv
        vx cv crn cuni wceq wa w3o vx vy copab cG vx cv cdm wlim vy cv vx cv
        crn cuni wceq wa vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm
        wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim
        vy cv vx cv crn cuni wceq wa w3o vx vy vx cv cdm wlim vy cv vx cv crn
        cuni wceq wa vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm
        wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa 3mix3 ssopab2i
        tz7.44.1 sseqtr4i sseli cG wfun cF cB cres cF cB cima cuni cop cG wcel
        cF cB cres cG cfv cF cB cima cuni wceq wi vx vy cA cG cH tz7.44.1
        tz7.44lem1 cF cB cres cF cB cima cuni cG cF cB cima cF wfun cF cB cima
        cvv wcel cF con0 wfn cF wfun tz7.44.2 con0 cF fnfun ax-mp cF cB cB con0
        tz7.44.5 elisseti funimaex ax-mp uniex funopfv ax-mp 3syl cB con0 wcel
        cB cF cfv cF cB cres cG cfv wceq tz7.44.5 vx cv cF cfv cF vx cv cres cG
        cfv wceq cB cF cfv cF cB cres cG cfv wceq vx cB con0 vx cv cB wceq vx
        cv cF cfv cB cF cfv cF vx cv cres cG cfv cF cB cres cG cfv vx cv cB cF
        fveq2 vx cv cB wceq cF vx cv cres cF cB cres cG vx cv cB cF reseq2
        fveq2d eqeq12d tz7.44.3 vtoclga ax-mp syl5eq $.
        $( [23-Apr-1995] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Recursive definition generator
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define a constant for the recursive definition generator. $)
  $c rec $.

  $( Extend class notation with the recursive definition generator. $)
  crdg $a class rec ( A , B ) $.

  ${
    $d x y z f g F $.  $d x y z f g A $.
    $( Define a recursive definition generator on ` On ` (the class of ordinal
       numbers) with characteristic function ` F ` and initial value ` A ` .
       This combines functions ` F ` in ~ tfr1 and ` G ` in ~ tz7.44-1 into one
       definition.  This rather amazing operation allows us to define, with
       compact direct definitions, functions that are usually defined in
       textbooks only with indirect self-referencing recursive definitions.  A
       recursive definition requires advanced metalogic to justify - in
       particular, eliminating a recursive definition is very difficult and
       often not even shown in textbooks.  On the other hand, the elimination
       of a direct definition is a matter of simple mechanical substitution.
       The price paid is the daunting complexity of our ` rec ` operation.
       But once we get past this hurdle, otherwise recursive definitions become
       relatively simple, as in for example ~ oav , from which we prove
       the recursive textbook definition as theorems ~ oa0 , ~ oasuc , and
       ~ oalim (with the help of theorems ~ rdg0 , ~rdgsuc , and ~ rdglimi ).
       We can also restrict the ` rec ` operation to define otherwise recursive
       functions on the natural numbers ` om ` ; see ~ fr0g and ~ frsuc .
       Our ` rec ` operation apparently does not appear in published
       literature, although closely related is Definition 25.2 of [Quine]
       p. 177, which he uses to "turn...a recursion into a genuine or direct
       definition" (p. 174).  Note that the ` if ` operations (see ~ df-if )
       select cases based on whether the domain of ` g ` is zero, a successor,
       or a limit ordinal.

       An important use of this definition is in the recursive sequence
       generator ~ df-seq1 on the natural numbers (as a subset of the complex
       numbers), allowing us to define, with direct definitions, recursive
       infinite sequences such as the factorial function ~ df-fac and integer
       powers ~ df-exp .

       _Note: We introduce ` rec ` with the philosophical goal of being able_
       _to eliminate all definitions with direct mechanical substitution and_
       _to verify easily the soundness of definitions.  Metamath itself has no_
       _built-in technical limitation that prevents recursive definitions in_
       _the traditional textbook style_. $)
    df-rdg $a |- rec ( F , A ) = U. { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( { <. g , z >. | z = if ( g = (/) , A ,
                if ( Lim dom g , U. ran g , ( F ` ( g ` U. dom g ) ) ) ) }
                ` ( f |` y ) ) ) } $.
  $}

  ${
    $d x y z f g F $.  $d x y z f g A $.
    $( Alternate definition of a recursive definition generator.  (This was the
       original definition, but it was later replaced with the slightly shorter
       ~ df-rdg .) $)
    dfrdg2 $p |- rec ( F , A ) = U. { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = (
                    { <. g , z >. | ( ( g = (/) /\ z = A ) \/
                    ( -. ( g = (/) \/ Lim dom g ) /\
                        z = ( F ` ( g ` U. dom g ) ) )
                    \/ ( Lim dom g /\ z = U. ran g ) ) }
                ` ( f |` y ) ) ) } $=
      cF cA crdg vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv
      c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv
      cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab
      cuni vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vg cv c0 wceq vz cv
      cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv
      cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o vg vz
      copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab cuni vx vy vz cA vf
      vg cF df-rdg vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv
      c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv
      cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab vf
      cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vg cv c0 wceq vz cv cA wceq
      wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv cfv cF
      cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o vg vz copab
      cfv wceq vy vx cv wral wa vx con0 wrex vf cab vf cv vx cv wfn vy cv vf cv
      cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni
      vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vy vx
      cv wral wa vx con0 wrex vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres
      vg cv c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv
      vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn
      cuni wceq wa w3o vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf vf
      cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg
      cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq
      vg vz copab cfv wceq vy vx cv wral wa vf cv vx cv wfn vy cv vf cv cfv vf
      cv vy cv cres vg cv c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim
      wo wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv
      vg cv crn cuni wceq wa w3o vg vz copab cfv wceq vy vx cv wral wa vx con0
      vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg
      cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz copab cfv
      wceq vy vx cv wral vy cv vf cv cfv vf cv vy cv cres vg cv c0 wceq vz cv
      cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv
      cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o vg vz
      copab cfv wceq vy vx cv wral vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv
      cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vy cv vf cv cfv vf cv
      vy cv cres vg cv c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo
      wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg
      cv crn cuni wceq wa w3o vg vz copab cfv wceq vy vx cv vf cv vy cv cres vz
      cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv
      cfv cF cfv cif cif wceq vg vz copab cfv vf cv vy cv cres vg cv c0 wceq vz
      cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg
      cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o vg
      vz copab cfv vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg
      cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq
      vg vz copab vg cv c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim
      wo wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv
      vg cv crn cuni wceq wa w3o vg vz copab vz cv vg cv c0 wceq cA vg cv cdm
      wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg cv c0
      wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm
      cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa
      w3o vg vz vg cv c0 wceq vz cv cA wceq wa vg cv c0 wceq wn vz cv vg cv cdm
      wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif wceq wa wo vg cv
      c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv
      cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni
      wceq wa wo wo vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv
      cdm cuni vg cv cfv cF cfv cif cif wceq vg cv c0 wceq vz cv cA wceq wa vg
      cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv cfv cF cfv
      wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o vg cv c0 wceq wn
      vz cv vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif
      wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv cfv
      cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa wo vg cv c0
      wceq vz cv cA wceq wa vg cv c0 wceq wn vz cv vg cv cdm wlim vg cv crn
      cuni vg cv cdm cuni vg cv cfv cF cfv cif wceq wa vg cv c0 wceq wn vg cv
      cdm wlim vz cv vg cv crn cuni wceq wa vg cv cdm wlim wn vz cv vg cv cdm
      cuni vg cv cfv cF cfv wceq wa wo wa vg cv c0 wceq wn vg cv cdm wlim wn vz
      cv vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn
      cuni wceq wa wo wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm
      cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa
      wo vz cv vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv
      cif wceq vg cv cdm wlim vz cv vg cv crn cuni wceq wa vg cv cdm wlim wn vz
      cv vg cv cdm cuni vg cv cfv cF cfv wceq wa wo vg cv c0 wceq wn vg cv cdm
      wlim vz cv vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv eqif anbi2i vg
      cv cdm wlim vz cv vg cv crn cuni wceq wa vg cv cdm wlim wn vz cv vg cv
      cdm cuni vg cv cfv cF cfv wceq wa wo vg cv cdm wlim wn vz cv vg cv cdm
      cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa
      wo vg cv c0 wceq wn vg cv cdm wlim vz cv vg cv crn cuni wceq wa vg cv cdm
      wlim wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa orcom anbi2i vg cv
      c0 wceq wn vg cv cdm wlim wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq
      wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa wo wa vg cv c0 wceq wn vg
      cv cdm wlim wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa wa vg cv c0
      wceq wn vg cv cdm wlim vz cv vg cv crn cuni wceq wa wa wo vg cv c0 wceq
      vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv
      cdm wlim vz cv vg cv crn cuni wceq wa wo vg cv c0 wceq wn vg cv cdm wlim
      wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg
      cv crn cuni wceq wa andi vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv
      cdm cuni vg cv cfv cF cfv wceq wa vg cv c0 wceq wn vg cv cdm wlim wn vz
      cv vg cv cdm cuni vg cv cfv cF cfv wceq wa wa vg cv cdm wlim vz cv vg cv
      crn cuni wceq wa vg cv c0 wceq wn vg cv cdm wlim vz cv vg cv crn cuni
      wceq wa wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv
      cfv cF cfv wceq wa vg cv c0 wceq wn vg cv cdm wlim wn wa vz cv vg cv cdm
      cuni vg cv cfv cF cfv wceq wa vg cv c0 wceq wn vg cv cdm wlim wn vz cv vg
      cv cdm cuni vg cv cfv cF cfv wceq wa wa vg cv c0 wceq vg cv cdm wlim wo
      wn vg cv c0 wceq wn vg cv cdm wlim wn wa vz cv vg cv cdm cuni vg cv cfv
      cF cfv wceq vg cv c0 wceq vg cv cdm wlim ioran anbi1i vg cv c0 wceq wn vg
      cv cdm wlim wn vz cv vg cv cdm cuni vg cv cfv cF cfv wceq anass bitri vg
      cv cdm wlim vz cv vg cv crn cuni wceq wa vg cv c0 wceq wn vg cv cdm wlim
      wa vz cv vg cv crn cuni wceq wa vg cv c0 wceq wn vg cv cdm wlim vz cv vg
      cv crn cuni wceq wa wa vg cv cdm wlim vg cv c0 wceq wn vg cv cdm wlim wa
      vz cv vg cv crn cuni wceq vg cv cdm wlim vg cv c0 wceq wn vg cv c0 wceq
      vg cv cdm wlim vg cv c0 wceq vg cv cdm c0 wceq vg cv cdm wlim wn vg cv c0
      wceq vg cv cdm c0 cdm c0 vg cv c0 dmeq dm0 syl6eq vg cv cdm c0 wceq vg cv
      cdm wlim c0 wlim nlim0 vg cv cdm c0 limeq mtbiri syl con2i pm4.71ri
      anbi1i vg cv c0 wceq wn vg cv cdm wlim vz cv vg cv crn cuni wceq anass
      bitri orbi12i bitr4i 3bitri orbi2i vg cv c0 wceq vz cv cA vg cv cdm wlim
      vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif eqif vg cv c0 wceq vz
      cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg
      cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa 3orass
      3bitr4i opabbii fveq1i eqeq2i ralbii anbi2i rexbii abbii unieqi eqtri $.
      $( [16-Feb-2005] $) $( [15-Feb-2005] $)
  $}

  ${
    $d x y z f g F $.  $d x y z f g G $.  $d x y z f g A $.  $d x y z f g B $.
    $( Equality theorem for the recursive definition generator. $)
    rdgeq1 $p |- ( F = G -> rec ( F , A ) = rec ( G , A ) ) $=
      cF cG wceq vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv
      c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv
      cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab
      cuni vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq
      cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cG cfv cif cif
      wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab cuni cF cA
      crdg cG cA crdg cF cG wceq vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv
      cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx
      con0 wrex vf cab vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv
      vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv
      cG cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf
      cab cF cG wceq vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cv
      vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg cv
      cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cG cfv cif cif wceq vg
      vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cF cG wceq vf cv vx cv
      wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg cv cdm
      wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz
      copab cfv wceq vy vx cv wral wa vf cv vx cv wfn vy cv vf cv cfv vf cv vy
      cv cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm
      cuni vg cv cfv cG cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa
      vx con0 cF cG wceq vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq
      cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif
      wceq vg vz copab cfv wceq vy vx cv wral vy cv vf cv cfv vf cv vy cv cres
      vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv
      cfv cG cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral vf cv vx cv
      wfn cF cG wceq vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg
      cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq
      vg vz copab cfv wceq vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq
      cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cG cfv cif cif
      wceq vg vz copab cfv wceq vy vx cv cF cG wceq vf cv vy cv cres vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab cfv vf cv vy cv cres vz cv vg cv c0 wceq cA
      vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cG cfv cif cif
      wceq vg vz copab cfv vy cv vf cv cfv cF cG wceq vf cv vy cv cres vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv
      crn cuni vg cv cdm cuni vg cv cfv cG cfv cif cif wceq vg vz copab cF cG
      wceq vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cF cfv cif cif wceq vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv
      crn cuni vg cv cdm cuni vg cv cfv cG cfv cif cif wceq vg vz cF cG wceq vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cG cfv cif cif vz cv cF cG wceq vg cv c0 wceq vg cv cdm wlim vg
      cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif vg cv cdm wlim vg cv crn
      cuni vg cv cdm cuni vg cv cfv cG cfv cif cA cF cG wceq vg cv cdm wlim vg
      cv cdm cuni vg cv cfv cF cfv vg cv cdm cuni vg cv cfv cG cfv vg cv crn
      cuni vg cv cdm cuni vg cv cfv cF cG fveq1 ifeq2d ifeq2d eqeq2d opabbidv
      fveq1d eqeq2d ralbidv anbi2d rexbidv abbidv unieqd vx vy vz cA vf vg cF
      df-rdg vx vy vz cA vf vg cG df-rdg 3eqtr4g $.
      $( [9-Apr-1995] $)


    $( Equality theorem for the recursive definition generator. $)
    rdgeq2 $p |- ( A = B -> rec ( F , A ) = rec ( F , B ) ) $=
      cA cB wceq vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv
      c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv
      cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab
      cuni vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq
      cB vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif
      wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cab cuni cF cA
      crdg cF cB crdg cA cB wceq vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv
      cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx
      con0 wrex vf cab vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv
      vg cv c0 wceq cB vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv
      cF cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf
      cab cA cB wceq vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cv
      vx cv wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cB vg cv
      cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg
      vz copab cfv wceq vy vx cv wral wa vx con0 wrex vf cA cB wceq vf cv vx cv
      wfn vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg cv cdm
      wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz
      copab cfv wceq vy vx cv wral wa vf cv vx cv wfn vy cv vf cv cfv vf cv vy
      cv cres vz cv vg cv c0 wceq cB vg cv cdm wlim vg cv crn cuni vg cv cdm
      cuni vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral wa
      vx con0 cA cB wceq vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq
      cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif
      wceq vg vz copab cfv wceq vy vx cv wral vy cv vf cv cfv vf cv vy cv cres
      vz cv vg cv c0 wceq cB vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv
      cfv cF cfv cif cif wceq vg vz copab cfv wceq vy vx cv wral vf cv vx cv
      wfn cA cB wceq vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq cA vg
      cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq
      vg vz copab cfv wceq vy cv vf cv cfv vf cv vy cv cres vz cv vg cv c0 wceq
      cB vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif
      wceq vg vz copab cfv wceq vy vx cv cA cB wceq vf cv vy cv cres vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab cfv vf cv vy cv cres vz cv vg cv c0 wceq cB
      vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif
      wceq vg vz copab cfv vy cv vf cv cfv cA cB wceq vf cv vy cv cres vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab vz cv vg cv c0 wceq cB vg cv cdm wlim vg cv
      crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz copab cA cB
      wceq vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cF cfv cif cif wceq vz cv vg cv c0 wceq cB vg cv cdm wlim vg cv
      crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz cA cB wceq vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif vg cv c0 wceq cB vg cv cdm wlim vg cv crn cuni vg cv cdm cuni
      vg cv cfv cF cfv cif cif vz cv vg cv c0 wceq cA cB vg cv cdm wlim vg cv
      crn cuni vg cv cdm cuni vg cv cfv cF cfv cif ifeq1 eqeq2d opabbidv fveq1d
      eqeq2d ralbidv anbi2d rexbidv abbidv unieqd vx vy vz cA vf vg cF df-rdg
      vx vy vz cB vf vg cF df-rdg 3eqtr4g $.
      $( [9-Apr-1995] $)
  $}

  ${
    $d y z w v f g F $.  $d y z w v f g A $.  $d x y z w v f g $.
    hbrdg.1 $e |- ( y e. F -> A. x y e. F ) $.
    hbrdg.2 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for the recursive definition
       generator. $)
    hbrdg $p |- ( y e. rec ( F , A ) -> A. x y e. rec ( F , A ) ) $=
      vx vy cF cA crdg vf cv vw cv wfn vv cv vf cv cfv vf cv vv cv cres vz cv
      vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv
      cF cfv cif cif wceq vg vz copab cfv wceq vv vw cv wral wa vw con0 wrex vf
      cab cuni vw vv vz cA vf vg cF df-rdg vx vy vf cv vw cv wfn vv cv vf cv
      cfv vf cv vv cv cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni
      vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vv vw
      cv wral wa vw con0 wrex vf cab vf cv vw cv wfn vv cv vf cv cfv vf cv vv
      cv cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm
      cuni vg cv cfv cF cfv cif cif wceq vg vz copab cfv wceq vv vw cv wral wa
      vw con0 wrex vx vf vy vf cv vw cv wfn vv cv vf cv cfv vf cv vv cv cres vz
      cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv
      cfv cF cfv cif cif wceq vg vz copab cfv wceq vv vw cv wral wa vx vw con0
      vw cv con0 wcel vx ax-17 vf cv vw cv wfn vv cv vf cv cfv vf cv vv cv cres
      vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv
      cfv cF cfv cif cif wceq vg vz copab cfv wceq vv vw cv wral vx vf cv vw cv
      wfn vx ax-17 vv cv vf cv cfv vf cv vv cv cres vz cv vg cv c0 wceq cA vg
      cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq
      vg vz copab cfv wceq vx vv vw cv vv cv vw cv wcel vx ax-17 vx vy vy vv cv
      vf cv cfv vf cv vv cv cres vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv
      crn cuni vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz copab cfv vy
      cv vv cv vf cv cfv wcel vx ax-17 vx vy vf cv vv cv cres vz cv vg cv c0
      wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif
      cif wceq vg vz copab vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni
      vg cv cdm cuni vg cv cfv cF cfv cif cif wceq vg vz vx vy vx vy vy vz cv
      vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv
      cF cfv cif cif vy cv vz cv wcel vx ax-17 vg cv c0 wceq vx vy cA vg cv cdm
      wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif vg cv c0 wceq vx
      ax-17 hbrdg.2 vg cv cdm wlim vx vy vg cv crn cuni vg cv cdm cuni vg cv
      cfv cF cfv vg cv cdm wlim vx ax-17 vy cv vg cv crn cuni wcel vx ax-17 vx
      vy vg cv cdm cuni vg cv cfv cF hbrdg.1 vy cv vg cv cdm cuni vg cv cfv
      wcel vx ax-17 hbfv hbif hbif hbeq hbopab vy cv vf cv vv cv cres wcel vx
      ax-17 hbfv hbeq hbral hban hbrex hbab hbuni hbxfr $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d x y f g $.  $d x y z g $.  $d f g G $.  $d x z G $.  $d y z w g G $.
    $( Lemma used with the recursive definition generator.  This is a trivial
       lemma that just changes bound variables for later use. $)
    rdglem1 $p |- { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( G ` ( f |` y ) ) ) }
                = { g | E. z e. On ( g Fn z /\
                A. w e. z ( g ` w ) = ( G ` ( g |` w ) ) ) } $=
      vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv
      wral wa vx con0 wrex vf cab vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv
      cres cG cfv wceq vy vz cv wral wa vz con0 wrex vg cab vg cv vz cv wfn vw
      cv vg cv cfv vg cv vw cv cres cG cfv wceq vw vz cv wral wa vz con0 wrex
      vg cab vx vy vz vf cv vx cv wfn vy cv vf cv cfv vf cv vy cv cres cG cfv
      wceq vy vx cv wral wa vx con0 wrex vf cab vf vg cG vf cv vx cv wfn vy cv
      vf cv cfv vf cv vy cv cres cG cfv wceq vy vx cv wral wa vx con0 wrex vf
      cab eqid tfrlem3 vg cv vz cv wfn vy cv vg cv cfv vg cv vy cv cres cG cfv
      wceq vy vz cv wral wa vz con0 wrex vg cv vz cv wfn vw cv vg cv cfv vg cv
      vw cv cres cG cfv wceq vw vz cv wral wa vz con0 wrex vg vg cv vz cv wfn
      vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral wa vg cv vz cv
      wfn vw cv vg cv cfv vg cv vw cv cres cG cfv wceq vw vz cv wral wa vz con0
      vy cv vg cv cfv vg cv vy cv cres cG cfv wceq vy vz cv wral vw cv vg cv
      cfv vg cv vw cv cres cG cfv wceq vw vz cv wral vg cv vz cv wfn vy cv vg
      cv cfv vg cv vy cv cres cG cfv wceq vw cv vg cv cfv vg cv vw cv cres cG
      cfv wceq vy vw vz cv vy cv vw cv wceq vy cv vg cv cfv vw cv vg cv cfv vg
      cv vy cv cres cG cfv vg cv vw cv cres cG cfv vy cv vw cv vg cv fveq2 vy
      cv vw cv wceq vg cv vy cv cres vg cv vw cv cres cG vy cv vw cv vg cv
      reseq2 fveq2d eqeq12d cbvralv anbi2i rexbii abbii eqtri $.
      $( [7-May-2004] $) $( [9-Apr-1995] $)
  $}

  ${
    $d x y z w $.  $d x z w A $.  $d x z w H $.
    $( Lemma used with the recursive definition generator.  This is a trivial
       lemma that just changes bound variables for later use. $)
    rdglem2 $p |- { <. x , y >. | ( ( x = (/) /\ y = A ) \/
            ( -. ( x = (/) \/ Lim dom x ) /\ y = ( H ` ( x ` U. dom x ) ) )
                \/ ( Lim dom x /\ y = U. ran x ) ) }
                = { <. z , y >. | ( ( z = (/) /\ y = A ) \/
            ( -. ( z = (/) \/ Lim dom z ) /\ y = ( H ` ( z ` U. dom z ) ) )
                \/ ( Lim dom z /\ y = U. ran z ) ) } $=
      vw cv vx cv vy cv cop wceq vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq
      vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv
      cdm wlim vy cv vx cv crn cuni wceq wa w3o wa vy wex vx wex vw cab vw cv
      vz cv vy cv cop wceq vz cv c0 wceq vy cv cA wceq wa vz cv c0 wceq vz cv
      cdm wlim wo wn vy cv vz cv cdm cuni vz cv cfv cH cfv wceq wa vz cv cdm
      wlim vy cv vz cv crn cuni wceq wa w3o wa vy wex vz wex vw cab vx cv c0
      wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm
      cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa
      w3o vx vy copab vz cv c0 wceq vy cv cA wceq wa vz cv c0 wceq vz cv cdm
      wlim wo wn vy cv vz cv cdm cuni vz cv cfv cH cfv wceq wa vz cv cdm wlim
      vy cv vz cv crn cuni wceq wa w3o vz vy copab vw cv vx cv vy cv cop wceq
      vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv
      vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn
      cuni wceq wa w3o wa vy wex vx wex vw cv vz cv vy cv cop wceq vz cv c0
      wceq vy cv cA wceq wa vz cv c0 wceq vz cv cdm wlim wo wn vy cv vz cv cdm
      cuni vz cv cfv cH cfv wceq wa vz cv cdm wlim vy cv vz cv crn cuni wceq wa
      w3o wa vy wex vz wex vw vw cv vx cv vy cv cop wceq vx cv c0 wceq vy cv cA
      wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv
      cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa w3o wa vy wex
      vw cv vz cv vy cv cop wceq vz cv c0 wceq vy cv cA wceq wa vz cv c0 wceq
      vz cv cdm wlim wo wn vy cv vz cv cdm cuni vz cv cfv cH cfv wceq wa vz cv
      cdm wlim vy cv vz cv crn cuni wceq wa w3o wa vy wex vx vz vx cv vz cv
      wceq vw cv vx cv vy cv cop wceq vx cv c0 wceq vy cv cA wceq wa vx cv c0
      wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa
      vx cv cdm wlim vy cv vx cv crn cuni wceq wa w3o wa vw cv vz cv vy cv cop
      wceq vz cv c0 wceq vy cv cA wceq wa vz cv c0 wceq vz cv cdm wlim wo wn vy
      cv vz cv cdm cuni vz cv cfv cH cfv wceq wa vz cv cdm wlim vy cv vz cv crn
      cuni wceq wa w3o wa vy vx cv vz cv wceq vw cv vx cv vy cv cop wceq vw cv
      vz cv vy cv cop wceq vx cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv
      cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm
      wlim vy cv vx cv crn cuni wceq wa w3o vz cv c0 wceq vy cv cA wceq wa vz
      cv c0 wceq vz cv cdm wlim wo wn vy cv vz cv cdm cuni vz cv cfv cH cfv
      wceq wa vz cv cdm wlim vy cv vz cv crn cuni wceq wa w3o vx cv vz cv wceq
      vx cv vy cv cop vz cv vy cv cop vw cv vx cv vz cv vy cv opeq1 eqeq2d vx
      cv vz cv wceq vx cv c0 wceq vy cv cA wceq wa vz cv c0 wceq vy cv cA wceq
      wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx cv cdm cuni vx cv cfv cH
      cfv wceq wa vz cv c0 wceq vz cv cdm wlim wo wn vy cv vz cv cdm cuni vz cv
      cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn cuni wceq wa vz cv cdm
      wlim vy cv vz cv crn cuni wceq wa vx cv vz cv wceq vx cv c0 wceq vz cv c0
      wceq vy cv cA wceq vx cv vz cv c0 eqeq1 anbi1d vx cv vz cv wceq vx cv c0
      wceq vx cv cdm wlim wo wn vz cv c0 wceq vz cv cdm wlim wo wn vy cv vx cv
      cdm cuni vx cv cfv cH cfv wceq vy cv vz cv cdm cuni vz cv cfv cH cfv wceq
      vx cv vz cv wceq vx cv c0 wceq vx cv cdm wlim wo vz cv c0 wceq vz cv cdm
      wlim wo vx cv vz cv wceq vx cv c0 wceq vz cv c0 wceq vx cv cdm wlim vz cv
      cdm wlim vx cv vz cv c0 eqeq1 vx cv vz cv wceq vx cv cdm vz cv cdm wceq
      vx cv cdm wlim vz cv cdm wlim wb vx cv vz cv dmeq vx cv cdm vz cv cdm
      limeq syl orbi12d notbid vx cv vz cv wceq vx cv cdm cuni vx cv cfv cH cfv
      vz cv cdm cuni vz cv cfv cH cfv vy cv vx cv vz cv wceq vx cv cdm cuni vx
      cv cfv vz cv cdm cuni vz cv cfv cH vx cv vz cv wceq vx cv cdm cuni vx cv
      cfv vz cv cdm cuni vx cv cfv vz cv cdm cuni vz cv cfv vx cv vz cv wceq vx
      cv cdm vz cv cdm wceq vx cv cdm cuni vz cv cdm cuni wceq vx cv cdm cuni
      vx cv cfv vz cv cdm cuni vx cv cfv wceq vx cv vz cv dmeq vx cv cdm vz cv
      cdm unieq vx cv cdm cuni vz cv cdm cuni vx cv fveq2 3syl vz cv cdm cuni
      vx cv vz cv fveq1 eqtrd fveq2d eqeq2d anbi12d vx cv vz cv wceq vx cv cdm
      wlim vz cv cdm wlim vy cv vx cv crn cuni wceq vy cv vz cv crn cuni wceq
      vx cv vz cv wceq vx cv cdm vz cv cdm wceq vx cv cdm wlim vz cv cdm wlim
      wb vx cv vz cv dmeq vx cv cdm vz cv cdm limeq syl vx cv vz cv wceq vx cv
      crn cuni vz cv crn cuni vy cv vx cv vz cv wceq vx cv crn vz cv crn vx cv
      vz cv rneq unieqd eqeq2d anbi12d 3orbi123d anbi12d exbidv cbvexv abbii vx
      cv c0 wceq vy cv cA wceq wa vx cv c0 wceq vx cv cdm wlim wo wn vy cv vx
      cv cdm cuni vx cv cfv cH cfv wceq wa vx cv cdm wlim vy cv vx cv crn cuni
      wceq wa w3o vx vy vw df-opab vz cv c0 wceq vy cv cA wceq wa vz cv c0 wceq
      vz cv cdm wlim wo wn vy cv vz cv cdm cuni vz cv cfv cH cfv wceq wa vz cv
      cdm wlim vy cv vz cv crn cuni wceq wa w3o vz vy vw df-opab 3eqtr4i $.
      $( [9-Apr-1995] $)
  $}

  ${
    $d x y z f g u v w F $.  $d x y z f g u v w A $.
    $( The recursive definition generator is a function on ordinal numbers. $)
    rdgfnon $p |- rec ( F , A ) Fn On $=
      vx vy vw cv vu cv wfn vv cv vw cv cfv vw cv vv cv cres vz cv vg cv c0
      wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF cfv cif
      cif wceq vg vz copab cfv wceq vv vu cv wral wa vu con0 wrex vw cab vf cF
      cA crdg vz cv vg cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm
      cuni vg cv cfv cF cfv cif cif wceq vg vz copab vu vv vx vy vw vf vz cv vg
      cv c0 wceq cA vg cv cdm wlim vg cv crn cuni vg cv cdm cuni vg cv cfv cF
      cfv cif cif wceq vg vz copab rdglem1 vu vv vz cA vw vg cF df-rdg tfr1 $.
      $( [9-Apr-1995] $)
  $}

  ${
    $d x y z f g u v w F $.  $d x y z f g u v w A $.
    $( Value of the recursive definition generator. $)
    rdgval $p |- ( g e. On -> ( rec ( F , A ) ` g ) = (
                       { <. w , z >. | ( ( w = (/) /\ z = A ) \/
                       ( -. ( w = (/) \/ Lim dom w ) /\
                               z = ( F ` ( w ` U. dom w ) ) )
                       \/ ( Lim dom w /\ z = U. ran w ) ) }
                   ` ( rec ( F , A ) |` g ) ) ) $=
      vg cv con0 wcel vg cv cF cA crdg cfv cF cA crdg vg cv cres vg cv c0 wceq
      vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni
      vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o
      vg vz copab cfv cF cA crdg vg cv cres vw cv c0 wceq vz cv cA wceq wa vw
      cv c0 wceq vw cv cdm wlim wo wn vz cv vw cv cdm cuni vw cv cfv cF cfv
      wceq wa vw cv cdm wlim vz cv vw cv crn cuni wceq wa w3o vw vz copab cfv
      vx vy vg vw cv vu cv wfn vv cv vw cv cfv vw cv vv cv cres vg cv c0 wceq
      vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni
      vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o
      vg vz copab cfv wceq vv vu cv wral wa vu con0 wrex vw cab vf cF cA crdg
      vg cv c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv
      vg cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn
      cuni wceq wa w3o vg vz copab vu vv vx vy vw vf vg cv c0 wceq vz cv cA
      wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg cv cdm cuni vg cv cfv
      cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni wceq wa w3o vg vz
      copab rdglem1 vu vv vz cA vw vg cF dfrdg2 tfr2 cF cA crdg vg cv cres vg
      cv c0 wceq vz cv cA wceq wa vg cv c0 wceq vg cv cdm wlim wo wn vz cv vg
      cv cdm cuni vg cv cfv cF cfv wceq wa vg cv cdm wlim vz cv vg cv crn cuni
      wceq wa w3o vg vz copab vw cv c0 wceq vz cv cA wceq wa vw cv c0 wceq vw
      cv cdm wlim wo wn vz cv vw cv cdm cuni vw cv cfv cF cfv wceq wa vw cv cdm
      wlim vz cv vw cv crn cuni wceq wa w3o vw vz copab vg vz vw cA cF rdglem2
      fveq1i syl6eq $.
      $( [9-Apr-1995] $)
  $}

  ${
    $d z g w F $.  $d z g w A $.
    ${
      rdg.1 $e |- A e. _V $.
      $( The initial value of the recursive definition generator. $)
      rdg0 $p |- ( rec ( F , A ) ` (/) ) = A $=
        vg vz cA cF cA crdg vw cv c0 wceq vz cv cA wceq wa vw cv c0 wceq vw cv
        cdm wlim wo wn vz cv vw cv cdm cuni vw cv cfv cF cfv wceq wa vw cv cdm
        wlim vz cv vw cv crn cuni wceq wa w3o vw vz copab cF vw vz vg cA cF
        rdglem2 cA cF rdgfnon vz vw cA vg cF rdgval rdg.1 tz7.44-1 $.
        $( [23-Apr-1995] $)
    $}

    ${
      $d z g B $.
      rdg.2 $e |- B e. On $.
      $( The value of the recursive definition generator at a successor. $)
      rdgsuci $p |- ( rec ( F , A ) ` suc B )
                   = ( F ` ( rec ( F , A ) ` B ) ) $=
        vg vz cA cB cF cA crdg vw cv c0 wceq vz cv cA wceq wa vw cv c0 wceq vw
        cv cdm wlim wo wn vz cv vw cv cdm cuni vw cv cfv cF cfv wceq wa vw cv
        cdm wlim vz cv vw cv crn cuni wceq wa w3o vw vz copab cF vw vz vg cA cF
        rdglem2 cA cF rdgfnon vz vw cA vg cF rdgval rdg.2 tz7.44-2 $.
        $( [23-Apr-1995] $)

      $( The value of the recursive definition generator at a limit ordinal. $)
      rdglimi $p |- ( Lim B ->
                   ( rec ( F , A ) ` B ) = U. ( rec ( F , A ) " B ) ) $=
        vg vz cA cB cF cA crdg vw cv c0 wceq vz cv cA wceq wa vw cv c0 wceq vw
        cv cdm wlim wo wn vz cv vw cv cdm cuni vw cv cfv cF cfv wceq wa vw cv
        cdm wlim vz cv vw cv crn cuni wceq wa w3o vw vz copab cF vw vz vg cA cF
        rdglem2 cA cF rdgfnon vz vw cA vg cF rdgval rdg.2 tz7.44-3 $.
        $( [23-Apr-1995] $)
    $}
  $}

  ${
    $d x A $.  $d x F $.
    $( The initial value of the recursive definition generator. $)
    rdg0g $p |- ( A e. C -> ( rec ( F , A ) ` (/) ) = A ) $=
      c0 cF vx cv crdg cfv vx cv wceq c0 cF cA crdg cfv cA wceq vx cA cC vx cv
      cA wceq c0 cF vx cv crdg cfv c0 cF cA crdg cfv vx cv cA vx cv cA wceq c0
      cF vx cv crdg cF cA crdg vx cv cA cF rdgeq2 fveq1d vx cv cA wceq id
      eqeq12d vx cv cF vx visset rdg0 vtoclg $.
      $( [25-Apr-1995] $)
  $}

  $( The value of the recursive definition generator at a successor. $)
  rdgsuc $p |- ( B e. On ->
               ( rec ( F , A ) ` suc B ) = ( F ` ( rec ( F , A ) ` B ) ) ) $=
    cB con0 wcel cB csuc cF cA crdg cfv cB cF cA crdg cfv cF cfv wceq cB con0
    wcel cB c0 cif csuc cF cA crdg cfv cB con0 wcel cB c0 cif cF cA crdg cfv cF
    cfv wceq cB c0 cB cB con0 wcel cB c0 cif wceq cB csuc cF cA crdg cfv cB
    con0 wcel cB c0 cif csuc cF cA crdg cfv cB cF cA crdg cfv cF cfv cB con0
    wcel cB c0 cif cF cA crdg cfv cF cfv cB cB con0 wcel cB c0 cif wceq cB csuc
    cB con0 wcel cB c0 cif csuc cF cA crdg cB cB con0 wcel cB c0 cif suceq
    fveq2d cB cB con0 wcel cB c0 cif wceq cB cF cA crdg cfv cB con0 wcel cB c0
    cif cF cA crdg cfv cF cB cB con0 wcel cB c0 cif cF cA crdg fveq2 fveq2d
    eqeq12d cA cB con0 wcel cB c0 cif cF cB c0 con0 0elon elimel rdgsuci dedth
    $.
    $( [23-Apr-1995] $)

  ${
    $d z D $.  $d y z C $.  $d z A $.  $d z B $.  $d x y z $.
    rdgsucopab.1 $e |- ( z e. A -> A. x z e. A ) $.
    rdgsucopab.2 $e |- ( z e. B -> A. x z e. B ) $.
    rdgsucopab.3 $e |- ( z e. D -> A. x z e. D ) $.
    rdgsucopab.4 $e |- F = rec ( { <. x , y >. | y = C } , A ) $.
    rdgsucopab.5 $e |- ( x = ( F ` B ) -> C = D ) $.
    $( The value of the recursive definition generator at a successor (special
       case where the characteristic function is an ordered pair
       abstraction). $)
    rdgsucopab $p |- ( ( B e. On /\ D e. R ) ->  ( F ` suc B ) = D ) $=
      cB con0 wcel cD cR wcel cB csuc cF cfv cB vy cv cC wceq vx vy copab cA
      crdg cfv vy cv cC wceq vx vy copab cfv cD cB con0 wcel cB csuc vy cv cC
      wceq vx vy copab cA crdg cfv cB vy cv cC wceq vx vy copab cA crdg cfv vy
      cv cC wceq vx vy copab cfv cB csuc cF cfv cA cB vy cv cC wceq vx vy copab
      rdgsuc cB csuc cF vy cv cC wceq vx vy copab cA crdg rdgsucopab.4 fveq1i
      syl5eq cB vy cv cC wceq vx vy copab cA crdg cfv cvv wcel cD cR wcel cB vy
      cv cC wceq vx vy copab cA crdg cfv vy cv cC wceq vx vy copab cfv cD wceq
      cB vy cv cC wceq vx vy copab cA crdg fvex vx vy vz cB vy cv cC wceq vx vy
      copab cA crdg cfv cC cD cvv cR vx vz cB vy cv cC wceq vx vy copab cA crdg
      vx vz cA vy cv cC wceq vx vy copab vy cv cC wceq vx vy vz hbopab1
      rdgsucopab.1 hbrdg rdgsucopab.2 hbfv rdgsucopab.3 vx cv cB vy cv cC wceq
      vx vy copab cA crdg cfv wceq vx cv cB cF cfv wceq cC cD wceq cB cF cfv cB
      vy cv cC wceq vx vy copab cA crdg cfv vx cv cB cF vy cv cC wceq vx vy
      copab cA crdg rdgsucopab.4 fveq1i eqeq2i rdgsucopab.5 sylbir fvopabgf
      mpan sylan9eq $.
      $( [30-Oct-2003] $) $( [22-Oct-2003] $)

    $( The value of the recursive definition generator at a successor (special
       case where the characteristic function is an ordered-pair class
       abstraction and where the mapping class ` D ` is a proper class).  This
       is a technical lemma that can be used together with ~ rdgsucopab to help
       eliminate redundant sethood antecedents. $)
    rdgsucopabn $p |- ( -. D e. _V ->  ( F ` suc B ) = (/) ) $=
      cB con0 wcel cD cvv wcel wn cB csuc cF cfv c0 wceq wi cB con0 wcel cD cvv
      wcel wn cB csuc cF cfv c0 wceq cB con0 wcel cD cvv wcel wn cB csuc cF cfv
      cB vy cv cC wceq vx vy copab cA crdg cfv vy cv cC wceq vx vy copab cfv c0
      cB con0 wcel cB csuc vy cv cC wceq vx vy copab cA crdg cfv cB vy cv cC
      wceq vx vy copab cA crdg cfv vy cv cC wceq vx vy copab cfv cB csuc cF cfv
      cA cB vy cv cC wceq vx vy copab rdgsuc cB csuc cF vy cv cC wceq vx vy
      copab cA crdg rdgsucopab.4 fveq1i syl5eq vx vy vz cB vy cv cC wceq vx vy
      copab cA crdg cfv cC cD vx vz cB vy cv cC wceq vx vy copab cA crdg vx vz
      cA vy cv cC wceq vx vy copab vy cv cC wceq vx vy vz hbopab1 rdgsucopab.1
      hbrdg rdgsucopab.2 hbfv rdgsucopab.3 vx cv cB vy cv cC wceq vx vy copab
      cA crdg cfv wceq vx cv cB cF cfv wceq cC cD wceq cB cF cfv cB vy cv cC
      wceq vx vy copab cA crdg cfv vx cv cB cF vy cv cC wceq vx vy copab cA
      crdg rdgsucopab.4 fveq1i eqeq2i rdgsucopab.5 sylbir fvopabnf sylan9eq ex
      cB con0 wcel wn cB csuc cF cfv c0 wceq cD cvv wcel wn cB con0 wcel wn cB
      csuc cF cdm wcel wn cB csuc cF cfv c0 wceq cB con0 wcel cB csuc cF cdm
      wcel cB con0 wcel cB csuc con0 wcel cB csuc cF cdm wcel cB sucelon cF cdm
      con0 cB csuc cF cdm vy cv cC wceq vx vy copab cA crdg cdm con0 cF vy cv
      cC wceq vx vy copab cA crdg rdgsucopab.4 dmeqi vy cv cC wceq vx vy copab
      cA crdg con0 wfn vy cv cC wceq vx vy copab cA crdg cdm con0 wceq cA vy cv
      cC wceq vx vy copab rdgfnon con0 vy cv cC wceq vx vy copab cA crdg fndm
      ax-mp eqtri eleq2i bitr4i notbii cB csuc cF ndmfv sylbi a1d pm2.61i $.
      $( [8-Nov-2003] $) $( [22-Oct-2003] $)
  $}

  $( The value of the recursive definition generator at a limit ordinal. $)
  rdglim $p |- ( ( B e. C /\ Lim B ) ->
                 ( rec ( F , A ) ` B ) = U. ( rec ( F , A ) " B ) ) $=
    cB cC wcel cB wlim cB con0 wcel cB cF cA crdg cfv cF cA crdg cB cima cuni
    wceq cB cC limelon cB con0 wcel cB wlim cB cF cA crdg cfv cF cA crdg cB
    cima cuni wceq cB con0 wcel cB wlim cB cF cA crdg cfv cF cA crdg cB cima
    cuni wceq wi cB con0 wcel cB c0 cif wlim cB con0 wcel cB c0 cif cF cA crdg
    cfv cF cA crdg cB con0 wcel cB c0 cif cima cuni wceq wi cB c0 cB cB con0
    wcel cB c0 cif wceq cB wlim cB con0 wcel cB c0 cif wlim cB cF cA crdg cfv
    cF cA crdg cB cima cuni wceq cB con0 wcel cB c0 cif cF cA crdg cfv cF cA
    crdg cB con0 wcel cB c0 cif cima cuni wceq cB cB con0 wcel cB c0 cif limeq
    cB cB con0 wcel cB c0 cif wceq cB cF cA crdg cfv cB con0 wcel cB c0 cif cF
    cA crdg cfv cF cA crdg cB cima cuni cF cA crdg cB con0 wcel cB c0 cif cima
    cuni cB cB con0 wcel cB c0 cif cF cA crdg fveq2 cB cB con0 wcel cB c0 cif
    wceq cF cA crdg cB cima cF cA crdg cB con0 wcel cB c0 cif cima cB cB con0
    wcel cB c0 cif cF cA crdg imaeq2 unieqd eqeq12d imbi12d cA cB con0 wcel cB
    c0 cif cF cB c0 con0 0elon elimel rdglimi dedth imp sylancom $.
    $( [23-Apr-1995] $)

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( The value of the recursive definition generator at a limit ordinal,
       in terms of the union of all smaller values. $)
    rdglim2 $p |- ( ( B e. C /\ Lim B ) -> ( rec ( F , A ) ` B ) =
                  U. { y | E. x e. B y = ( rec ( F , A ) ` x ) } ) $=
      cB cC wcel cB wlim wa cB cF cA crdg cfv cF cA crdg cB cima cuni vy cv vx
      cv cF cA crdg cfv wceq vx cB wrex vy cab cuni cA cB cC cF rdglim cB wlim
      cF cA crdg cB cima cuni vy cv vx cv cF cA crdg cfv wceq vx cB wrex vy cab
      cuni wceq cB cC wcel cB wlim cF cA crdg cB cima vy cv vx cv cF cA crdg
      cfv wceq vx cB wrex vy cab cB wlim vx cv cB wcel vx cv vy cv cop cF cA
      crdg wcel wa vx wex vy cab vy cv vx cv cF cA crdg cfv wceq vx cB wrex vy
      cab cF cA crdg cB cima cB wlim vx cv cB wcel vx cv vy cv cop cF cA crdg
      wcel wa vx wex vy cv vx cv cF cA crdg cfv wceq vx cB wrex vy cB wlim vx
      cv cB wcel vy cv vx cv cF cA crdg cfv wceq wa vx wex vx cv cB wcel vx cv
      vy cv cop cF cA crdg wcel wa vx wex vy cv vx cv cF cA crdg cfv wceq vx cB
      wrex cB wlim vx cv cB wcel vy cv vx cv cF cA crdg cfv wceq wa vx cv cB
      wcel vx cv vy cv cop cF cA crdg wcel wa vx cB wlim vx cv cB wcel vy cv vx
      cv cF cA crdg cfv wceq vx cv vy cv cop cF cA crdg wcel cB wlim vx cv cB
      wcel vx cv con0 wcel vy cv vx cv cF cA crdg cfv wceq vx cv vy cv cop cF
      cA crdg wcel wb cB wlim cB word vx cv cB wcel vx cv con0 wcel wi cB
      limord cB word vx cv cB wcel vx cv word vx cv con0 wcel cB word vx cv cB
      wcel vx cv word cB vx cv ordelord ex vx cv vx visset elon syl6ibr syl vx
      cv con0 wcel vx cv cF cA crdg cfv vy cv wceq vx cv vy cv cop cF cA crdg
      wcel vy cv vx cv cF cA crdg cfv wceq cF cA crdg con0 wfn vx cv con0 wcel
      vx cv cF cA crdg cfv vy cv wceq vx cv vy cv cop cF cA crdg wcel wb cA cF
      rdgfnon con0 vx cv vy cv cF cA crdg vy visset fnopfvb mpan vy cv vx cv cF
      cA crdg cfv eqcom syl5bb syl6 pm5.32d exbidv vy cv vx cv cF cA crdg cfv
      wceq vx cB df-rex syl5rbb abbidv vx vy cF cA crdg cB dfima3 syl5eq unieqd
      adantl eqtrd $.
      $( [23-Apr-1995] $)

    $( The value of the recursive definition generator at a limit ordinal,
       in terms of indexed union of all smaller values. $)
    rdglim2a $p |- ( ( B e. C /\ Lim B ) -> ( rec ( F , A ) ` B ) =
                  U_ x e. B ( rec ( F , A ) ` x ) ) $=
      cB cC wcel cB wlim wa cB cF cA crdg cfv vy cv vx cv cF cA crdg cfv wceq
      vx cB wrex vy cab cuni vx cB vx cv cF cA crdg cfv ciun vx vy cA cB cC cF
      rdglim2 vx vy cB vx cv cF cA crdg cfv vx cv cF cA crdg fvex dfiun2
      syl6eqr $.
      $( [28-Jun-1998] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( We use the next 3 theorems for finite recursion.  Note that we take
     advantage of what we have done for transfinite recursion, which allows
     us to explicitly specify the function and moreover not require the
     existence of omega. $)

  $( The function generated by finite recursive definition generation is a
     function on omega. $)
  frfnom $p |- ( rec ( F , A ) |` om ) Fn om $=
    cF cA crdg com cres com wfn cF cA crdg com cres wfun cF cA crdg com cres
    cdm com wceq cF cA crdg com cres com df-fn cF cA crdg wfun cF cA crdg com
    cres wfun cF cA crdg con0 wfn cF cA crdg wfun cA cF rdgfnon con0 cF cA crdg
    fnfun ax-mp com cF cA crdg funres ax-mp com cF cA crdg cdm cin com con0 cin
    cF cA crdg com cres cdm com cF cA crdg cdm con0 com cF cA crdg con0 wfn cF
    cA crdg cdm con0 wceq cA cF rdgfnon con0 cF cA crdg fndm ax-mp ineq2i cF cA
    crdg com dmres com con0 wss com com con0 cin wceq omsson com con0 dfss mpbi
    3eqtr4i mpbir2an $.
    $( [15-Oct-1996] $)

  $( The initial value resulting from finite recursive definition
     generation. $)
  fr0g $p |- ( A e. B -> ( ( rec ( F , A ) |` om ) ` (/) ) = A ) $=
    cA cB wcel c0 cF cA crdg cfv cA c0 cF cA crdg com cres cfv cA cB cF rdg0g
    c0 com wcel c0 cF cA crdg com cres cfv c0 cF cA crdg cfv wceq peano1 c0 com
    cF cA crdg fvres ax-mp syl5eq $.
    $( [15-Oct-1996] $)

  $( The successor value resulting from finite recursive definition
     generation. $)
  frsuc $p |- ( B e. om -> ( ( rec ( F , A ) |` om ) ` suc B ) =
              ( F ` ( ( rec ( F , A ) |` om ) ` B ) ) ) $=
    cB com wcel cB csuc cF cA crdg cfv cB cF cA crdg cfv cF cfv cB csuc cF cA
    crdg com cres cfv cB cF cA crdg com cres cfv cF cfv cB com wcel cB con0
    wcel cB csuc cF cA crdg cfv cB cF cA crdg cfv cF cfv wceq cB nnon cA cB cF
    rdgsuc syl cB com wcel cB csuc com wcel cB csuc cF cA crdg com cres cfv cB
    csuc cF cA crdg cfv wceq cB peano2b cB csuc com cF cA crdg fvres sylbi cB
    com wcel cB cF cA crdg com cres cfv cB cF cA crdg cfv cF cB com cF cA crdg
    fvres fveq2d 3eqtr4d $.
    $( [15-Oct-1996] $)

  ${
    $d z D $.  $d y z C $.  $d z A $.  $d z B $.  $d x y z $.
    frsucopab.1 $e |- ( z e. A -> A. x z e. A ) $.
    frsucopab.2 $e |- ( z e. B -> A. x z e. B ) $.
    frsucopab.3 $e |- ( z e. D -> A. x z e. D ) $.
    frsucopab.4 $e |- F = ( rec ( { <. x , y >. | y = C } , A ) |` om ) $.
    frsucopab.5 $e |- ( x = ( F ` B ) -> C = D ) $.
    $( The successor value resulting from finite recursive definition
       generation (special case where the generation function is an ordered
       pair abstraction). $)
    frsucopab $p |- ( ( B e. om /\ D e. R ) ->  ( F ` suc B ) = D ) $=
      cB com wcel cD cR wcel cB csuc cF cfv cB vy cv cC wceq vx vy copab cA
      crdg com cres cfv vy cv cC wceq vx vy copab cfv cD cB com wcel cB csuc vy
      cv cC wceq vx vy copab cA crdg com cres cfv cB vy cv cC wceq vx vy copab
      cA crdg com cres cfv vy cv cC wceq vx vy copab cfv cB csuc cF cfv cA cB
      vy cv cC wceq vx vy copab frsuc cB csuc cF vy cv cC wceq vx vy copab cA
      crdg com cres frsucopab.4 fveq1i syl5eq cB vy cv cC wceq vx vy copab cA
      crdg com cres cfv cvv wcel cD cR wcel cB vy cv cC wceq vx vy copab cA
      crdg com cres cfv vy cv cC wceq vx vy copab cfv cD wceq cB vy cv cC wceq
      vx vy copab cA crdg com cres fvex vx vy vz cB vy cv cC wceq vx vy copab
      cA crdg com cres cfv cC cD cvv cR vx vz cB vy cv cC wceq vx vy copab cA
      crdg com cres vx vz vy cv cC wceq vx vy copab cA crdg com vx vz cA vy cv
      cC wceq vx vy copab vy cv cC wceq vx vy vz hbopab1 frsucopab.1 hbrdg vz
      cv com wcel vx ax-17 hbres frsucopab.2 hbfv frsucopab.3 vx cv cB vy cv cC
      wceq vx vy copab cA crdg com cres cfv wceq vx cv cB cF cfv wceq cC cD
      wceq cB cF cfv cB vy cv cC wceq vx vy copab cA crdg com cres cfv vx cv cB
      cF vy cv cC wceq vx vy copab cA crdg com cres frsucopab.4 fveq1i eqeq2i
      frsucopab.5 sylbir fvopabgf mpan sylan9eq $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d x y z w F $.  $d x y z w A $.
    tz7.48.1 $e |- F Fn On $.
    $( A way of showing an ordinal function is one-to-one. $)
    tz7.48lem $p |- ( ( A C_ On /\ A. x e. A A. y e. x
                    -. ( F ` x ) = ( F ` y ) ) -> Fun `' ( F |` A ) ) $=
      cA con0 wss vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx cA wral wa
      cA con0 wss vx cv cF cA cres cfv vy cv cF cA cres cfv wceq vx cv vy cv
      wceq wi vy cA wral vx cA wral wa cF cA cres ccnv wfun cA con0 wss vx cv
      cF cfv vy cv cF cfv wceq wn vy vx cv wral vx cA wral vx cv cF cA cres cfv
      vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA wral vx cA wral cA
      con0 wss vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx
      cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vy cA wral vx cA wral vx
      cv cF cA cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA
      wral vx cA wral vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx cA
      wral cA con0 wss vx cv cA wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cF
      cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv cF cfv vy cv cF cfv
      wceq wn wi wa wi vy wal vx wal vx cv cA wcel vy cv cA wcel wa vx cv cF cA
      cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi wi vy wal vx wal
      vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx
      cv cF cfv vy cv cF cfv wceq wn wi wa vy cA wral vx cA wral vx cv cF cA
      cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA wral vx cA
      wral cA con0 wss vx cv cA wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cF
      cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv cF cfv vy cv cF cfv
      wceq wn wi wa wi vy wal vx cv cA wcel vy cv cA wcel wa vx cv cF cA cres
      cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi wi vy wal vx cA con0
      wss vx cv cA wcel vy cv cA wcel wa vx cv vy cv wcel vy cv cF cfv vx cv cF
      cfv wceq wn wi vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa
      wi vx cv cA wcel vy cv cA wcel wa vx cv cF cA cres cfv vy cv cF cA cres
      cfv wceq vx cv vy cv wceq wi wi vy cA con0 wss vx cv cA wcel vy cv cA
      wcel wa vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vx cv cF cA cres cfv vy cv
      cF cA cres cfv wceq vx cv vy cv wceq wi cA con0 wss vx cv cA wcel vy cv
      cA wcel wa vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx
      cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vx cv cF cA cres cfv vy
      cv cF cA cres cfv wceq vx cv vy cv wceq wi cA con0 wss vx cv cA wcel vy
      cv cA wcel wa vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv
      vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa wa wa vx cv cF cA cres
      cfv vy cv cF cA cres cfv wceq vx cv cF cfv vy cv cF cfv wceq vx cv vy cv
      wceq vx cv cA wcel vy cv cA wcel wa vx cv cF cA cres cfv vy cv cF cA cres
      cfv wceq vx cv cF cfv vy cv cF cfv wceq wb cA con0 wss vx cv vy cv wcel
      vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv cF cfv vy cv
      cF cfv wceq wn wi wa vx cv cA wcel vy cv cA wcel vx cv cF cA cres cfv vx
      cv cF cfv vy cv cF cA cres cfv vy cv cF cfv vx cv cA cF fvres vy cv cA cF
      fvres eqeqan12d ad2antrl cA con0 wss vx cv cA wcel vy cv cA wcel wa vx cv
      vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv cF
      cfv vy cv cF cfv wceq wn wi wa vx cv cF cfv vy cv cF cfv wceq vx cv vy cv
      wceq wi cA con0 wss vx cv cA wcel vy cv cA wcel wa vx cv con0 wcel vy cv
      con0 wcel wa vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv
      vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vx cv cF cfv vy cv cF
      cfv wceq vx cv vy cv wceq wi wi cA con0 wss vx cv cA wcel vx cv con0 wcel
      vy cv cA wcel vy cv con0 wcel cA con0 vx cv ssel cA con0 vy cv ssel
      anim12d vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vx cv cF cfv vy cv cF cfv
      wceq vx cv vy cv wcel vy cv vx cv wcel wo wn vx cv con0 wcel vy cv con0
      wcel wa vx cv vy cv wceq vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq
      wn wi vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vx cv vy
      cv wcel vy cv vx cv wcel wo vx cv cF cfv vy cv cF cfv wceq vx cv vy cv
      wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv cF cfv
      vy cv cF cfv wceq wn wi wa vx cv vy cv wcel vy cv vx cv wcel wo vy cv cF
      cfv vx cv cF cfv wceq wn vx cv cF cfv vy cv cF cfv wceq wn wo vx cv cF
      cfv vy cv cF cfv wceq wn vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq
      wn vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn pm3.48 vx cv cF cfv
      vy cv cF cfv wceq wn vx cv cF cfv vy cv cF cfv wceq wn vx cv cF cfv vy cv
      cF cfv wceq wn wo vy cv cF cfv vx cv cF cfv wceq wn vx cv cF cfv vy cv cF
      cfv wceq wn wo vx cv cF cfv vy cv cF cfv wceq wn oridm vx cv cF cfv vy cv
      cF cfv wceq wn vy cv cF cfv vx cv cF cfv wceq wn vx cv cF cfv vy cv cF
      cfv wceq wn vx cv cF cfv vy cv cF cfv wceq vy cv cF cfv vx cv cF cfv wceq
      vx cv cF cfv vy cv cF cfv eqcom notbii orbi1i bitr3i syl6ibr con2d vx cv
      word vy cv word vx cv vy cv wcel vy cv vx cv wcel wo wn vx cv vy cv wceq
      wi vx cv con0 wcel vy cv con0 wcel vx cv word vy cv word wa vx cv vy cv
      wceq vx cv vy cv wcel vy cv vx cv wcel wo wn vx cv vy cv ordtri3 biimprd
      vx cv eloni vy cv eloni syl2an syl9r syl6 imp32 sylbid exp32 a2d 19.20dv
      19.20dv vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn wi wa vx vy cA cA r2al vx cv cF cA
      cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vx vy cA cA r2al
      3imtr4g vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx cA wral vy cv
      vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cA wral vx cA wral vx
      cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv
      cF cfv vy cv cF cfv wceq wn wi wa vy cA wral vx cA wral vx cv cA wcel vy
      cv vx cv wcel wa vx cv cF cfv vy cv cF cfv wceq wn wi vy wal vx wal vx cv
      cA wcel vy cv cA wcel wa vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq
      wn wi wi vy wal vx wal vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx
      cA wral vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cA wral
      vx cA wral vx cv cA wcel vy cv vx cv wcel wa vx cv cF cfv vy cv cF cfv
      wceq wn wi vx cv cA wcel vy cv cA wcel wa vy cv vx cv wcel vx cv cF cfv
      vy cv cF cfv wceq wn wi wi vx vy vx cv cA wcel vy cv vx cv wcel wa vx cv
      cF cfv vy cv cF cfv wceq wn wi vx cv cA wcel vy cv cA wcel wa vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn vx cv cA wcel vy cv cA wcel wa vy
      cv vx cv wcel wa vx cv cA wcel vy cv vx cv wcel wa vx cv cF cfv vy cv cF
      cfv wceq wn vx cv cA wcel vy cv cA wcel wa vx cv cA wcel vy cv vx cv wcel
      vx cv cA wcel vy cv cA wcel pm3.26 anim1i imim1i exp3a 19.20i2 vx cv cF
      cfv vy cv cF cfv wceq wn vx vy cA vx cv r2al vy cv vx cv wcel vx cv cF
      cfv vy cv cF cfv wceq wn wi vx vy cA cA r2al 3imtr4i vy cv vx cv wcel vx
      cv cF cfv vy cv cF cfv wceq wn wi vy cA wral vx cA wral vx cv vy cv wcel
      vy cv cF cfv vx cv cF cfv wceq wn wi vy cA wral vx cA wral vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cA wral vx cA wral wa vx cv
      vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cv vx cv wcel vx cv cF
      cfv vy cv cF cfv wceq wn wi wa vy cA wral vx cA wral vy cv vx cv wcel vx
      cv cF cfv vy cv cF cfv wceq wn wi vy cA wral vx cA wral vx cv vy cv wcel
      vy cv cF cfv vx cv cF cfv wceq wn wi vy cA wral vx cA wral vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cA wral vx cA wral vx cv vy
      cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vx cA wral vy cA wral vx cv
      vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vy cA wral vx cA wral vy
      cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cA wral vx cA wral
      vw cv vx cv wcel vx cv cF cfv vw cv cF cfv wceq wn wi vw cA wral vx cA
      wral vw cv vz cv wcel vz cv cF cfv vw cv cF cfv wceq wn wi vw cA wral vz
      cA wral vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn wi vx cA wral
      vy cA wral vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cA
      wral vw cv vx cv wcel vx cv cF cfv vw cv cF cfv wceq wn wi vw cA wral vx
      cA vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vw cv vx cv wcel
      vx cv cF cfv vw cv cF cfv wceq wn wi vy vw cA vy cv vw cv wceq vy cv vx
      cv wcel vw cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn vx cv cF cfv
      vw cv cF cfv wceq wn vy cv vw cv vx cv eleq1 vy cv vw cv wceq vx cv cF
      cfv vy cv cF cfv wceq vx cv cF cfv vw cv cF cfv wceq vy cv vw cv wceq vy
      cv cF cfv vw cv cF cfv vx cv cF cfv vy cv vw cv cF fveq2 eqeq2d notbid
      imbi12d cbvralv ralbii vw cv vx cv wcel vx cv cF cfv vw cv cF cfv wceq wn
      wi vw cA wral vw cv vz cv wcel vz cv cF cfv vw cv cF cfv wceq wn wi vw cA
      wral vx vz cA vx cv vz cv wceq vw cv vx cv wcel vx cv cF cfv vw cv cF cfv
      wceq wn wi vw cv vz cv wcel vz cv cF cfv vw cv cF cfv wceq wn wi vw cA vx
      cv vz cv wceq vw cv vx cv wcel vw cv vz cv wcel vx cv cF cfv vw cv cF cfv
      wceq wn vz cv cF cfv vw cv cF cfv wceq wn vx cv vz cv vw cv eleq2 vx cv
      vz cv wceq vx cv cF cfv vw cv cF cfv wceq vz cv cF cfv vw cv cF cfv wceq
      vx cv vz cv wceq vx cv cF cfv vz cv cF cfv vw cv cF cfv vx cv vz cv cF
      fveq2 eqeq1d notbid imbi12d ralbidv cbvralv vw cv vz cv wcel vz cv cF cfv
      vw cv cF cfv wceq wn wi vw cA wral vz cA wral vx cv vz cv wcel vz cv cF
      cfv vx cv cF cfv wceq wn wi vx cA wral vz cA wral vx cv vy cv wcel vy cv
      cF cfv vx cv cF cfv wceq wn wi vx cA wral vy cA wral vw cv vz cv wcel vz
      cv cF cfv vw cv cF cfv wceq wn wi vw cA wral vx cv vz cv wcel vz cv cF
      cfv vx cv cF cfv wceq wn wi vx cA wral vz cA vw cv vz cv wcel vz cv cF
      cfv vw cv cF cfv wceq wn wi vx cv vz cv wcel vz cv cF cfv vx cv cF cfv
      wceq wn wi vw vx cA vw cv vx cv wceq vw cv vz cv wcel vx cv vz cv wcel vz
      cv cF cfv vw cv cF cfv wceq wn vz cv cF cfv vx cv cF cfv wceq wn vw cv vx
      cv vz cv eleq1 vw cv vx cv wceq vz cv cF cfv vw cv cF cfv wceq vz cv cF
      cfv vx cv cF cfv wceq vw cv vx cv wceq vw cv cF cfv vx cv cF cfv vz cv cF
      cfv vw cv vx cv cF fveq2 eqeq2d notbid imbi12d cbvralv ralbii vx cv vz cv
      wcel vz cv cF cfv vx cv cF cfv wceq wn wi vx cA wral vx cv vy cv wcel vy
      cv cF cfv vx cv cF cfv wceq wn wi vx cA wral vz vy cA vz cv vy cv wceq vx
      cv vz cv wcel vz cv cF cfv vx cv cF cfv wceq wn wi vx cv vy cv wcel vy cv
      cF cfv vx cv cF cfv wceq wn wi vx cA vz cv vy cv wceq vx cv vz cv wcel vx
      cv vy cv wcel vz cv cF cfv vx cv cF cfv wceq wn vy cv cF cfv vx cv cF cfv
      wceq wn vz cv vy cv vx cv eleq2 vz cv vy cv wceq vz cv cF cfv vx cv cF
      cfv wceq vy cv cF cfv vx cv cF cfv wceq vz cv vy cv wceq vz cv cF cfv vy
      cv cF cfv vx cv cF cfv vz cv vy cv cF fveq2 eqeq1d notbid imbi12d ralbidv
      cbvralv bitri 3bitri vx cv vy cv wcel vy cv cF cfv vx cv cF cfv wceq wn
      wi vy vx cA ralcom2 sylbi ancri vx cv vy cv wcel vy cv cF cfv vx cv cF
      cfv wceq wn wi vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vx
      vy cA cA r19.26-2 sylibr syl syl5 imdistani cF cA cres cA wfn vx cv cF cA
      cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA wral vx cA
      wral cF cA cres ccnv wfun cA con0 wss cA cvv cF cA cres wf vx cv cF cA
      cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA wral vx cA
      wral cF cA cres ccnv wfun cF cA cres cA wfn cA cvv cF cA cres wf vx cv cF
      cA cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA wral vx
      cA wral wa cA cvv cF cA cres wf cF cA cres ccnv wfun cA cvv cF cA cres wf
      vx cv cF cA cres cfv vy cv cF cA cres cfv wceq vx cv vy cv wceq wi vy cA
      wral vx cA wral wa cA cvv cF cA cres wf1 cA cvv cF cA cres wf cF cA cres
      ccnv wfun wa vx vy cA cvv cF cA cres dff13 cA cvv cF cA cres df-f1 bitr3i
      pm3.27bi cA cF cA cres dffn2 sylanb cF con0 wfn cA con0 wss cF cA cres cA
      wfn tz7.48.1 con0 cA cF fnssres mpan sylan syl $.
      $( [9-Feb-1997] $)

    $( Proposition 7.48(1) of [TakeutiZaring] p. 51. $)
    tz7.48-1 $p |- ( A. x e. On ( F ` x ) e. ( A \ ( F " x ) ) ->
                   ran F C_ A ) $=
      vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral vy cF crn cA vx cv
      cF cfv cA cF vx cv cima cdif wcel vx con0 wral vx cv con0 wcel vx cv cF
      cfv vy cv wceq wa vx wex vy cv cA wcel vy cv cF crn wcel vx cv cF cfv cA
      cF vx cv cima cdif wcel vx con0 wral vx cv con0 wcel vx cv cF cfv vy cv
      wceq wa vy cv cA wcel vx vx cv cF cfv cA cF vx cv cima cdif wcel vx con0
      hbra1 vy cv cA wcel vx ax-17 vx cv cF cfv cA cF vx cv cima cdif wcel vx
      con0 wral vx cv con0 wcel vx cv cF cfv cA cF vx cv cima cdif wcel wi vx
      cv con0 wcel vx cv cF cfv vy cv wceq wa vy cv cA wcel wi vx cv cF cfv cA
      cF vx cv cima cdif wcel vx con0 ra4 vx cv con0 wcel vx cv cF cfv cA cF vx
      cv cima cdif wcel wi vx cv con0 wcel vx cv cF cfv vy cv wceq vy cv cA
      wcel vx cv cF cfv cA cF vx cv cima cdif wcel vx cv cF cfv vy cv wceq vy
      cv cA wcel wi vx cv con0 wcel vx cv cF cfv vy cv wceq vx cv cF cfv cA
      wcel vy cv cA wcel vx cv cF cfv cA cF vx cv cima cdif wcel vx cv cF cfv
      vy cv cA eleq1 vx cv cF cfv cA cF vx cv cima eldifi syl5cbi imim2i imp3a
      syl 19.23ad vy cv cF crn wcel vx cv vy cv cop cF wcel vx wex vx cv con0
      wcel vx cv cF cfv vy cv wceq wa vx wex vx vy cv cF vy visset elrn2 vx cv
      vy cv cop cF wcel vx cv con0 wcel vx cv cF cfv vy cv wceq wa vx vx cv vy
      cv cop cF wcel vx cv con0 wcel vx cv vy cv cop cF wcel wa vx cv con0 wcel
      vx cv cF cfv vy cv wceq wa vx cv vy cv cop cF wcel vx cv con0 wcel vx cv
      vy cv cop cF wcel vx cv cF cdm con0 vx cv vy cv cF vx visset opeldm cF
      con0 wfn cF cdm con0 wceq tz7.48.1 con0 cF fndm ax-mp syl6eleq ancri vx
      cv con0 wcel vx cv cF cfv vy cv wceq vx cv vy cv cop cF wcel cF con0 wfn
      vx cv con0 wcel vx cv cF cfv vy cv wceq vx cv vy cv cop cF wcel wb
      tz7.48.1 con0 vx cv vy cv cF vy visset fnopfvb mpan pm5.32i sylibr 19.22i
      sylbi syl5 ssrdv $.
      $( [9-Feb-1997] $)

    $( Proposition 7.48(2) of [TakeutiZaring] p. 51. $)
    tz7.48-2 $p |- ( A. x e. On ( F ` x ) e. ( A \ ( F " x ) ) -> Fun `' F ) $=
      vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral cF con0 cres ccnv
      wfun cF ccnv wfun con0 con0 wss vx cv cF cfv vy cv cF cfv wceq wn vy vx
      cv wral vx con0 wral cF con0 cres ccnv wfun vx cv cF cfv cA cF vx cv cima
      cdif wcel vx con0 wral vx vy con0 cF tz7.48.1 tz7.48lem con0 ssid vx cv
      cF cfv cA cF vx cv cima cdif wcel vx cv cF cfv vy cv cF cfv wceq wn vy vx
      cv wral vx con0 vx cv con0 wcel vx cv cF cfv cA cF vx cv cima cdif wcel
      wa vx cv cF cfv vy cv cF cfv wceq wn vy vx cv vy cv vx cv wcel vx cv con0
      wcel vx cv cF cfv cA cF vx cv cima cdif wcel wa vx cv cF cfv vy cv cF cfv
      wceq wn vy cv vx cv wcel vx cv con0 wcel vx cv cF cfv cA cF vx cv cima
      cdif wcel vx cv cF cfv vy cv cF cfv wceq wn vy cv vx cv wcel vx cv con0
      wcel vy cv con0 wcel vx cv cF cfv cA cF vx cv cima cdif wcel vx cv cF cfv
      vy cv cF cfv wceq wn wi vx cv con0 wcel vy cv vx cv wcel vy cv con0 wcel
      vx cv vy cv onelon ancoms vy cv vx cv wcel vy cv cF cdm wcel vx cv cF cfv
      cA cF vx cv cima cdif wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cv
      con0 wcel vy cv vx cv wcel vy cv cF cdm wcel wa vy cv cF cfv cF vx cv
      cima wcel vx cv cF cfv cA cF vx cv cima cdif wcel vx cv cF cfv vy cv cF
      cfv wceq wn wi vy cv vx cv wcel vy cv cF cdm wcel wa vy cv cF cfv cF vx
      cv cima wcel vy cv cF vx cv cres cfv cF vx cv cres crn wcel vy cv vx cv
      wcel vy cv cF cdm wcel wa vy cv cF vx cv cres cdm wcel vy cv cF vx cv
      cres cfv cF vx cv cres crn wcel vy cv cF vx cv cres cdm wcel vy cv vx cv
      cF cdm cin wcel vy cv vx cv wcel vy cv cF cdm wcel wa cF vx cv cres cdm
      vx cv cF cdm cin vy cv cF vx cv dmres eleq2i vy cv vx cv cF cdm elin
      bitri cF vx cv cres wfun vy cv cF vx cv cres cdm wcel vy cv cF vx cv cres
      cfv cF vx cv cres crn wcel cF wfun cF vx cv cres wfun cF con0 wfn cF wfun
      tz7.48.1 con0 cF fnfun ax-mp vx cv cF funres ax-mp vy cv cF vx cv cres
      fvelrn mpan sylbir vy cv vx cv wcel vy cv cF cfv cF vx cv cima wcel vy cv
      cF vx cv cres cfv cF vx cv cres crn wcel wb vy cv cF cdm wcel vy cv vx cv
      wcel vy cv cF vx cv cres cfv cF vx cv cres crn wcel vy cv cF cfv cF vx cv
      cres crn wcel vy cv cF cfv cF vx cv cima wcel vy cv vx cv wcel vy cv cF
      vx cv cres cfv vy cv cF cfv cF vx cv cres crn vy cv vx cv cF fvres eleq1d
      cF vx cv cima cF vx cv cres crn vy cv cF cfv cF vx cv df-ima eleq2i
      syl6rbbr adantr mpbird vy cv cF cfv cF vx cv cima wcel vx cv cF cfv vy cv
      cF cfv wceq vx cv cF cfv cF vx cv cima wcel vx cv cF cfv cA cF vx cv cima
      cdif wcel vy cv cF cfv cF vx cv cima vx cv cF cfv eleq1a vx cv cF cfv cA
      cF vx cv cima eldifn nsyli syl cF cdm con0 vy cv cF con0 wfn cF cdm con0
      wceq tz7.48.1 con0 cF fndm ax-mp eleq2i sylan2br syldan expimpd com12
      r19.21aiv r19.20ia sylancr cF con0 cres ccnv cF ccnv wceq cF con0 cres
      ccnv wfun cF ccnv wfun wb cF con0 cres cF cF wrel cF cdm con0 wss cF con0
      cres cF wceq cF con0 wfn cF wrel tz7.48.1 con0 cF fnrel ax-mp cF cdm con0
      cF con0 wfn cF cdm con0 wceq tz7.48.1 con0 cF fndm ax-mp eqimssi cF con0
      relssres mp2an cnveqi cF con0 cres ccnv cF ccnv funeq ax-mp sylib $.
      $( [9-Feb-1997] $)

    $( Proposition 7.48(3) of [TakeutiZaring] p. 51. $)
    tz7.48-3 $p |- ( A. x e. On ( F ` x ) e. ( A \ ( F " x ) ) ->
                    -. A e. _V ) $=
      vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral cA cvv wcel cF crn
      cvv wcel vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral cF crn cvv
      wcel cF cdm cvv wcel cF cdm cvv wcel con0 cvv wcel onprc cF cdm con0 cvv
      cF con0 wfn cF cdm con0 wceq tz7.48.1 con0 cF fndm ax-mp eleq1i mtbir vx
      cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral cF ccnv wfun cF crn cvv
      wcel cF cdm cvv wcel wi vx cA cF tz7.48.1 tz7.48-2 cF ccnv wfun cF ccnv
      cdm cvv wcel cF ccnv crn cvv wcel cF crn cvv wcel cF cdm cvv wcel cF ccnv
      cdm cvv wcel cF ccnv wfun cF ccnv crn cvv wcel cvv cF ccnv funrnex com12
      cF crn cF ccnv cdm cvv cF df-rn eleq1i cF cdm cF ccnv crn cvv cF dfdm4
      eleq1i 3imtr4g syl mtoi vx cv cF cfv cA cF vx cv cima cdif wcel vx con0
      wral cF crn cA wss cA cvv wcel cF crn cvv wcel wi vx cA cF tz7.48.1
      tz7.48-1 cF crn cA wss cA cvv wcel cF crn cvv wcel cF crn cA cvv ssexg ex
      syl mtod $.
      $( [9-Feb-1997] $)

    ${
      tz7.49.2 $e |- A e. _V $.
      $( Proposition 7.49 of [TakeutiZaring] p. 51. $)
      tz7.49 $p |- ( A. x e. On ( ( A \ ( F " x ) ) =/= (/) ->
                   ( F ` x ) e. ( A \ ( F " x ) ) ) ->
                   E. x e. On ( A. y e. x ( A \ ( F " y ) ) =/= (/) /\
                   ( F " x ) = A /\ Fun `' ( F |` x ) ) ) $=
        cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi
        vx con0 wral cA cF vx cv cima cdif c0 wceq cA cF vy cv cima cdif c0 wne
        vy vx cv wral wa vx con0 wrex cA cF vy cv cima cdif c0 wne vy vx cv
        wral cF vx cv cima cA wceq cF vx cv cres ccnv wfun w3a vx con0 wrex cA
        cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx
        con0 wral cA cF vx cv cima cdif c0 wceq cA cF vy cv cima cdif c0 wceq
        wn vy vx cv wral wa vx con0 wrex cA cF vx cv cima cdif c0 wceq cA cF vy
        cv cima cdif c0 wne vy vx cv wral wa vx con0 wrex cA cF vx cv cima cdif
        c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vx
        cv cima cdif c0 wceq vx con0 wrex cA cF vx cv cima cdif c0 wceq cA cF
        vy cv cima cdif c0 wceq wn vy vx cv wral wa vx con0 wrex cA cF vx cv
        cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0
        wral cA cF vx cv cima cdif c0 wceq wn vx con0 wral wn cA cF vx cv cima
        cdif c0 wceq vx con0 wrex cA cF vx cv cima cdif c0 wne vx cv cF cfv cA
        cF vx cv cima cdif wcel wi vx con0 wral cA cF vx cv cima cdif c0 wceq
        wn vx con0 wral vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral vx
        cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral cA cvv wcel tz7.49.2
        vx cA cF tz7.48.1 tz7.48-3 mt2 cA cF vx cv cima cdif c0 wne vx cv cF
        cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vx cv cima cdif c0
        wne vx con0 wral vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 wral
        cA cF vx cv cima cdif c0 wceq wn vx con0 wral cA cF vx cv cima cdif c0
        wne vx cv cF cfv cA cF vx cv cima cdif wcel vx con0 r19.20 cA cF vx cv
        cima cdif c0 wne cA cF vx cv cima cdif c0 wceq wn vx con0 cA cF vx cv
        cima cdif c0 df-ne ralbii syl5ibr mtoi cA cF vx cv cima cdif c0 wceq vx
        con0 dfrex2 sylibr cA cF vx cv cima cdif c0 wceq cA cF vy cv cima cdif
        c0 wceq vx vy vx cv vy cv wceq cA cF vx cv cima cdif cA cF vy cv cima
        cdif c0 vx cv vy cv wceq cF vx cv cima cF vy cv cima cA vx cv vy cv cF
        imaeq2 difeq2d eqeq1d onminex syl cA cF vx cv cima cdif c0 wceq cA cF
        vy cv cima cdif c0 wne vy vx cv wral wa cA cF vx cv cima cdif c0 wceq
        cA cF vy cv cima cdif c0 wceq wn vy vx cv wral wa vx con0 cA cF vy cv
        cima cdif c0 wne vy vx cv wral cA cF vy cv cima cdif c0 wceq wn vy vx
        cv wral cA cF vx cv cima cdif c0 wceq cA cF vy cv cima cdif c0 wne cA
        cF vy cv cima cdif c0 wceq wn vy vx cv cA cF vy cv cima cdif c0 df-ne
        ralbii anbi2i rexbii sylibr cA cF vx cv cima cdif c0 wne vx cv cF cfv
        cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vx cv cima cdif c0
        wceq cA cF vy cv cima cdif c0 wne vy vx cv wral wa cA cF vy cv cima
        cdif c0 wne vy vx cv wral cF vx cv cima cA wceq cF vx cv cres ccnv wfun
        w3a vx con0 cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 hbra1 cA cF vx cv cima cdif c0 wne vx cv cF cfv cA
        cF vx cv cima cdif wcel wi vx con0 wral vx cv con0 wcel cA cF vx cv
        cima cdif c0 wceq cA cF vy cv cima cdif c0 wne vy vx cv wral cA cF vy
        cv cima cdif c0 wne vy vx cv wral cF vx cv cima cA wceq cF vx cv cres
        ccnv wfun w3a cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv
        cima cdif wcel wi vx con0 wral vx cv con0 wcel cA cF vy cv cima cdif c0
        wne vy vx cv wral cA cF vx cv cima cdif c0 wceq cA cF vy cv cima cdif
        c0 wne vy vx cv wral cF vx cv cima cA wceq cF vx cv cres ccnv wfun w3a
        cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi
        vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral vx cv con0 wcel
        cA cF vx cv cima cdif c0 wceq cA cF vy cv cima cdif c0 wne vy vx cv
        wral cF vx cv cima cA wceq cF vx cv cres ccnv wfun w3a wi cA cF vx cv
        cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0
        wral cA cF vy cv cima cdif c0 wne vy vx cv wral vx cv con0 wcel cA cF
        vx cv cima cdif c0 wceq cA cF vy cv cima cdif c0 wne vy vx cv wral cF
        vx cv cima cA wceq cF vx cv cres ccnv wfun w3a cA cF vx cv cima cdif c0
        wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv
        cima cdif c0 wne vy vx cv wral wa vx cv con0 wcel wa cA cF vx cv cima
        cdif c0 wceq wa cA cF vy cv cima cdif c0 wne vy vx cv wral cF vx cv
        cima cA wceq cF vx cv cres ccnv wfun cA cF vx cv cima cdif c0 wne vx cv
        cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv cima cdif
        c0 wne vy vx cv wral vx cv con0 wcel cA cF vx cv cima cdif c0 wceq
        simpllr cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif
        wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral wa vx
        cv con0 wcel wa cA cF vx cv cima cdif c0 wceq wa cF vx cv cima cA wss
        cA cF vx cv cima wss wa cF vx cv cima cA wceq cA cF vx cv cima cdif c0
        wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv
        cima cdif c0 wne vy vx cv wral wa vx cv con0 wcel wa cF vx cv cima cA
        wss cA cF vx cv cima cdif c0 wceq cA cF vx cv cima wss cA cF vx cv cima
        cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA
        cF vy cv cima cdif c0 wne vy vx cv wral wa vx cv con0 wcel wa vz cF vx
        cv cima cA cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral wa
        vx cv con0 wcel vz cv cF vx cv cima wcel vz cv cA wcel wi cA cF vx cv
        cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0
        wral cA cF vy cv cima cdif c0 wne vy vx cv wral wa vz cv cF vx cv cima
        wcel vx cv con0 wcel vz cv cA wcel cA cF vx cv cima cdif c0 wne vx cv
        cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv cima cdif
        c0 wne vy vx cv wral wa vy cv cF cfv vz cv wceq vy vx cv wrex vx cv
        con0 wcel vz cv cA wcel wi vz cv cF vx cv cima wcel cA cF vx cv cima
        cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA
        cF vy cv cima cdif c0 wne vy vx cv wral wa vy cv cF cfv vz cv wceq vx
        cv con0 wcel vz cv cA wcel wi vy vx cv cA cF vx cv cima cdif c0 wne vx
        cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv cima
        cdif c0 wne vy vx cv wral vy cA cF vx cv cima cdif c0 wne vx cv cF cfv
        cA cF vx cv cima cdif wcel wi vx con0 wral vy ax-17 cA cF vy cv cima
        cdif c0 wne vy vx cv hbra1 hban vx cv con0 wcel vz cv cA wcel wi vy
        ax-17 cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif
        wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral wa vy
        cv vx cv wcel vx cv con0 wcel vy cv cF cfv vz cv wceq vz cv cA wcel cA
        cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx
        con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral wa vy cv vx cv
        wcel vx cv con0 wcel vy cv cF cfv cA cF vy cv cima cdif wcel vy cv cF
        cfv vz cv wceq vz cv cA wcel wi cA cF vx cv cima cdif c0 wne vx cv cF
        cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0
        wne vy vx cv wral wa vx cv con0 wcel vy cv vx cv wcel vy cv cF cfv cA
        cF vy cv cima cdif wcel cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF
        vx cv cima cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx
        cv wral wa vx cv con0 wcel vy cv vx cv wcel vy cv cF cfv cA cF vy cv
        cima cdif wcel cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv
        cima cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv
        wral vx cv con0 wcel vy cv vx cv wcel wa vy cv cF cfv cA cF vy cv cima
        cdif wcel wi cA cF vy cv cima cdif c0 wne vy vx cv wral vx cv con0 wcel
        vy cv vx cv wcel wa cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx
        cv cima cdif wcel wi vx con0 wral vy cv cF cfv cA cF vy cv cima cdif
        wcel cA cF vy cv cima cdif c0 wne vy vx cv wral vx cv con0 wcel vy cv
        vx cv wcel wa cA cF vy cv cima cdif c0 wne cA cF vx cv cima cdif c0 wne
        vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral vy cv cF cfv cA
        cF vy cv cima cdif wcel wi cA cF vy cv cima cdif c0 wne vy vx cv wral
        vy cv vx cv wcel cA cF vy cv cima cdif c0 wne vx cv con0 wcel cA cF vy
        cv cima cdif c0 wne vy vx cv ra4 adantld vx cv con0 wcel vy cv vx cv
        wcel wa vy cv con0 wcel cA cF vy cv cima cdif c0 wne cA cF vx cv cima
        cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral vy
        cv cF cfv cA cF vy cv cima cdif wcel wi wi vx cv vy cv onelon vy cv
        con0 wcel cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy cv cF cfv cA
        cF vy cv cima cdif wcel cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF
        vx cv cima cdif wcel wi cA cF vy cv cima cdif c0 wne vy cv cF cfv cA cF
        vy cv cima cdif wcel wi vx vy cv con0 vx cv vy cv wceq cA cF vx cv cima
        cdif c0 wne cA cF vy cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel vy cv cF cfv cA cF vy cv cima cdif wcel vx cv vy cv wceq cA
        cF vx cv cima cdif cA cF vy cv cima cdif c0 vx cv vy cv wceq cF vx cv
        cima cF vy cv cima cA vx cv vy cv cF imaeq2 difeq2d neeq1d vx cv vy cv
        wceq vx cv cF cfv vy cv cF cfv cA cF vx cv cima cdif cA cF vy cv cima
        cdif vx cv vy cv cF fveq2 vx cv vy cv wceq cF vx cv cima cF vy cv cima
        cA vx cv vy cv cF imaeq2 difeq2d eleq12d imbi12d rcla4v com23 syl
        sylcom com3r imp exp3a com23 vy cv cF cfv vz cv wceq vy cv cF cfv cA
        wcel vz cv cA wcel vy cv cF cfv cA cF vy cv cima cdif wcel vy cv cF cfv
        vz cv cA eleq1 vy cv cF cfv cA cF vy cv cima eldifi syl5cbi syl8 com34
        r19.23ad cF wfun vz cv cF vx cv cima wcel vy cv cF cfv vz cv wceq vy vx
        cv wrex cF con0 wfn cF wfun tz7.48.1 con0 cF fnfun ax-mp vy vz cv vx cv
        cF fvelima mpan syl5 com23 imp ssrdv cA cF vx cv cima wss cA cF vx cv
        cima cdif c0 wceq cA cF vx cv cima ssdif0 biimpri anim12i cF vx cv cima
        cA eqss sylibr cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv
        cima cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv
        wral wa vx cv con0 wcel wa cF vx cv cres ccnv wfun cA cF vx cv cima
        cdif c0 wceq cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral wa
        vx cv con0 wcel cF vx cv cres ccnv wfun cA cF vy cv cima cdif c0 wne vy
        vx cv wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 wral vx cv con0 wcel cF vx cv cres ccnv wfun wi cA
        cF vy cv cima cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne vx
        cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral wa vx cv con0 wss
        cF vx cv cres ccnv wfun vx cv con0 wcel cA cF vy cv cima cdif c0 wne vy
        vx cv wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 wral wa vx cv con0 wss vx cv con0 wss vy cv cF cfv
        vz cv cF cfv wceq wn vz vy cv wral vy vx cv wral wa cF vx cv cres ccnv
        wfun cA cF vy cv cima cdif c0 wne vy vx cv wral cA cF vx cv cima cdif
        c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral wa vx cv
        con0 wss vy cv cF cfv vz cv cF cfv wceq wn vz vy cv wral vy vx cv wral
        cA cF vy cv cima cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne
        vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral wa vx cv con0
        wss vy cv vx cv wcel vz cv vy cv wcel wa vy cv cF cfv vz cv cF cfv wceq
        wn wi vz wal vy wal vy cv cF cfv vz cv cF cfv wceq wn vz vy cv wral vy
        vx cv wral cA cF vy cv cima cdif c0 wne vy vx cv wral cA cF vx cv cima
        cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral wa
        vx cv con0 wss vy cv vx cv wcel vz cv vy cv wcel wa vy cv cF cfv vz cv
        cF cfv wceq wn wi vz wal vy cA cF vy cv cima cdif c0 wne vy vx cv wral
        cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi
        vx con0 wral vy cA cF vy cv cima cdif c0 wne vy vx cv hbra1 cA cF vx cv
        cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0
        wral vy ax-17 hban vx cv con0 wss vy ax-17 cA cF vy cv cima cdif c0 wne
        vy vx cv wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv
        cima cdif wcel wi vx con0 wral wa vx cv con0 wss vy cv vx cv wcel vz cv
        vy cv wcel wa vy cv cF cfv vz cv cF cfv wceq wn wi vz cA cF vy cv cima
        cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA
        cF vx cv cima cdif wcel wi vx con0 wral wa vx cv con0 wss vy cv vx cv
        wcel vz cv vy cv wcel vy cv cF cfv vz cv cF cfv wceq wn vx cv con0 wss
        vy cv vx cv wcel vz cv vy cv wcel cA cF vy cv cima cdif c0 wne vy vx cv
        wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif
        wcel wi vx con0 wral wa vy cv cF cfv vz cv cF cfv wceq wn vx cv con0
        wss vy cv vx cv wcel vz cv vy cv wcel vz cv cF cfv cF vy cv cima wcel
        cA cF vy cv cima cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne
        vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral wa vy cv cF cfv
        vz cv cF cfv wceq wn wi vx cv con0 wss vy cv vx cv wcel vy cv con0 wcel
        vz cv vy cv wcel vz cv cF cfv cF vy cv cima wcel wi vx cv con0 vy cv
        ssel cF wfun vy cv cF cdm wss vz cv vy cv wcel vz cv cF cfv cF vy cv
        cima wcel wi vy cv con0 wcel vy cv vz cv cF funfvima2 cF con0 wfn cF
        wfun tz7.48.1 con0 cF fnfun ax-mp vy cv con0 wcel vy cv con0 cF cdm vy
        cv onss cF con0 wfn cF cdm con0 wceq tz7.48.1 con0 cF fndm ax-mp
        syl6ssr sylancr syl6 vx cv con0 wss vy cv vx cv wcel cA cF vy cv cima
        cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA
        cF vx cv cima cdif wcel wi vx con0 wral wa vz cv cF cfv cF vy cv cima
        wcel vy cv cF cfv vz cv cF cfv wceq wn vx cv con0 wss vy cv vx cv wcel
        cA cF vy cv cima cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne
        vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral wa vy cv cF cfv
        cA cF vy cv cima cdif wcel vz cv cF cfv cF vy cv cima wcel vy cv cF cfv
        vz cv cF cfv wceq wn wi vx cv con0 wss vy cv vx cv wcel cA cF vy cv
        cima cdif c0 wne vy vx cv wral cA cF vx cv cima cdif c0 wne vx cv cF
        cfv cA cF vx cv cima cdif wcel wi vx con0 wral vy cv cF cfv cA cF vy cv
        cima cdif wcel vx cv con0 wss vy cv vx cv wcel cA cF vy cv cima cdif c0
        wne vy vx cv wral cA cF vy cv cima cdif c0 wne cA cF vx cv cima cdif c0
        wne vx cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral vy cv cF
        cfv cA cF vy cv cima cdif wcel wi vy cv vx cv wcel cA cF vy cv cima
        cdif c0 wne vy vx cv wral cA cF vy cv cima cdif c0 wne wi wi vx cv con0
        wss cA cF vy cv cima cdif c0 wne vy vx cv wral vy cv vx cv wcel cA cF
        vy cv cima cdif c0 wne cA cF vy cv cima cdif c0 wne vy vx cv ra4 com12
        a1i vx cv con0 wss vy cv vx cv wcel vy cv con0 wcel cA cF vy cv cima
        cdif c0 wne cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
        cdif wcel wi vx con0 wral vy cv cF cfv cA cF vy cv cima cdif wcel wi wi
        vx cv con0 vy cv ssel vy cv con0 wcel cA cF vx cv cima cdif c0 wne vx
        cv cF cfv cA cF vx cv cima cdif wcel wi vx con0 wral cA cF vy cv cima
        cdif c0 wne vy cv cF cfv cA cF vy cv cima cdif wcel cA cF vx cv cima
        cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi cA cF vy cv cima
        cdif c0 wne vy cv cF cfv cA cF vy cv cima cdif wcel wi vx vy cv con0 vx
        cv vy cv wceq cA cF vx cv cima cdif c0 wne cA cF vy cv cima cdif c0 wne
        vx cv cF cfv cA cF vx cv cima cdif wcel vy cv cF cfv cA cF vy cv cima
        cdif wcel vx cv vy cv wceq cA cF vx cv cima cdif cA cF vy cv cima cdif
        c0 vx cv vy cv wceq cF vx cv cima cF vy cv cima cA vx cv vy cv cF
        imaeq2 difeq2d neeq1d vx cv vy cv wceq vx cv cF cfv vy cv cF cfv cA cF
        vx cv cima cdif cA cF vy cv cima cdif vx cv vy cv cF fveq2 vx cv vy cv
        wceq cF vx cv cima cF vy cv cima cA vx cv vy cv cF imaeq2 difeq2d
        eleq12d imbi12d rcla4v com23 syl6 syldd imp4a vz cv cF cfv cF vy cv
        cima wcel vy cv cF cfv cF vy cv cima wcel wn vy cv cF cfv vz cv cF cfv
        wceq wn vy cv cF cfv cA cF vy cv cima cdif wcel vz cv cF cfv cF vy cv
        cima wcel vy cv cF cfv vz cv cF cfv wceq vy cv cF cfv cF vy cv cima
        wcel vz cv cF cfv cF vy cv cima vy cv cF cfv eleq1a con3d vy cv cF cfv
        cA cF vy cv cima eldifn syl5com syl8 com34 syldd com4r imp4a 19.21adv
        19.21ad vy cv cF cfv vz cv cF cfv wceq wn vy vz vx cv vy cv r2al
        syl6ibr ancld vy vz vx cv cF tz7.48.1 tz7.48lem syl6 vx cv onss syl5
        ancoms imp adantr 3jca exp41 com23 com34 imp4a r19.22d mpd $.
        $( [4-May-2007] $) $( [10-Feb-1997] $)

      $( Corollary of Proposition 7.49 of [TakeutiZaring] p. 51. $)
      tz7.49c $p |- ( A. x e. On ( ( A \ ( F " x ) ) =/= (/) ->
                   ( F ` x ) e. ( A \ ( F " x ) ) ) ->
                   E. x e. On ( F |` x ) : x -1-1-onto-> A ) $=
        cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif wcel wi
        vx con0 wral cA cF vy cv cima cdif c0 wne vy vx cv wral cF vx cv cima
        cA wceq cF vx cv cres ccnv wfun w3a vx con0 wrex vx cv cA cF vx cv cres
        wf1o vx con0 wrex vx vy cA cF tz7.48.1 tz7.49.2 tz7.49 cA cF vy cv cima
        cdif c0 wne vy vx cv wral cF vx cv cima cA wceq cF vx cv cres ccnv wfun
        w3a vx cv cA cF vx cv cres wf1o vx con0 vx cv con0 wcel cF vx cv cima
        cA wceq cF vx cv cres ccnv wfun wa vx cv cA cF vx cv cres wf1o cA cF vy
        cv cima cdif c0 wne vy vx cv wral cF vx cv cima cA wceq cF vx cv cres
        ccnv wfun w3a vx cv con0 wcel cF vx cv cima cA wceq cF vx cv cres ccnv
        wfun vx cv cA cF vx cv cres wf1o vx cv con0 wcel cF vx cv cima cA wceq
        cF vx cv cres ccnv wfun vx cv cA cF vx cv cres wf1o vx cv con0 wcel cF
        vx cv cima cA wceq wa cF vx cv cres ccnv wfun wa cF vx cv cres vx cv
        wfn cF vx cv cres crn cA wceq wa cF vx cv cres ccnv wfun wa vx cv cA cF
        vx cv cres wf1o vx cv con0 wcel cF vx cv cima cA wceq wa cF vx cv cres
        vx cv wfn cF vx cv cres crn cA wceq wa cF vx cv cres ccnv wfun vx cv
        con0 wcel cF vx cv cres vx cv wfn cF vx cv cima cA wceq cF vx cv cres
        crn cA wceq cF con0 wfn vx cv con0 wss cF vx cv cres vx cv wfn vx cv
        con0 wcel con0 vx cv cF fnssres tz7.48.1 vx cv onss sylancr cF vx cv
        cima cA wceq cF vx cv cres crn cA wceq cF vx cv cima cF vx cv cres crn
        cA cF vx cv df-ima eqeq1i biimpi anim12i anim1i vx cv cA cF vx cv cres
        wf1o cF vx cv cres vx cv wfn cF vx cv cres ccnv wfun cF vx cv cres crn
        cA wceq w3a cF vx cv cres vx cv wfn cF vx cv cres ccnv wfun wa cF vx cv
        cres crn cA wceq wa cF vx cv cres vx cv wfn cF vx cv cres crn cA wceq
        wa cF vx cv cres ccnv wfun wa vx cv cA cF vx cv cres dff1o2 cF vx cv
        cres vx cv wfn cF vx cv cres ccnv wfun cF vx cv cres crn cA wceq df-3an
        cF vx cv cres vx cv wfn cF vx cv cres ccnv wfun cF vx cv cres crn cA
        wceq an23 3bitri sylibr exp31 imp3a cA cF vy cv cima cdif c0 wne vy vx
        cv wral cF vx cv cima cA wceq cF vx cv cres ccnv wfun 3simpc syl5
        r19.22i syl $.
        $( [5-May-2007] $) $( [10-Feb-1997] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Abian's "most fundamental" fixed point theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y v A $.  $d x y z w v u F $.  $d y v u G $.
    abianfp.1 $e |- A e. _V $.
    abianfp.2 $e |- G = rec ( { <. z , w >. | w = ( F ` z ) } , x ) $.
    $( Lemma for ~ abianfp .  We prove by transfinite induction that if ` F `
       has a fixed point ` x ` , then its iterates also equal ` x ` .  This
       lemma is used for the "trivial" direction of the main theorem. $)
    abianfplem $p |- ( v e. On -> ( ( F ` x ) = x -> ( G ` v ) = x ) ) $=
      vv cv cG cfv vx cv wceq c0 cG cfv vx cv wceq vy cv cG cfv vx cv wceq vy
      cv csuc cG cfv vx cv wceq vx cv cF cfv vx cv wceq vv vy vv cv c0 wceq vv
      cv cG cfv c0 cG cfv vx cv vv cv c0 cG fveq2 eqeq1d vv cv vy cv wceq vv cv
      cG cfv vy cv cG cfv vx cv vv cv vy cv cG fveq2 eqeq1d vv cv vy cv csuc
      wceq vv cv cG cfv vy cv csuc cG cfv vx cv vv cv vy cv csuc cG fveq2
      eqeq1d c0 cG cfv vx cv wceq vx cv cF cfv vx cv wceq c0 cG cfv c0 vw cv vz
      cv cF cfv wceq vz vw copab vx cv crdg cfv vx cv c0 cG vw cv vz cv cF cfv
      wceq vz vw copab vx cv crdg abianfp.2 fveq1i vx cv vw cv vz cv cF cfv
      wceq vz vw copab vx visset rdg0 eqtri a1i vy cv con0 wcel vx cv cF cfv vx
      cv wceq vy cv cG cfv vx cv wceq vy cv csuc cG cfv vx cv wceq vy cv con0
      wcel vx cv cF cfv vx cv wceq vy cv cG cfv vx cv wceq wa vy cv csuc cG cfv
      vy cv cG cfv cF cfv vx cv vy cv con0 wcel vy cv cG cfv cF cfv cvv wcel vy
      cv csuc cG cfv vy cv cG cfv cF cfv wceq vy cv cG cfv cF fvex vz vw vu vx
      cv vy cv vz cv cF cfv vy cv cG cfv cF cfv cvv cG vu cv vx cv wcel vz
      ax-17 vu cv vy cv wcel vz ax-17 vz vu vy cv cG cfv cF vu cv cF wcel vz
      ax-17 vz vu vy cv cG vz vu cG vw cv vz cv cF cfv wceq vz vw copab vx cv
      crdg abianfp.2 vz vu vx cv vw cv vz cv cF cfv wceq vz vw copab vw cv vz
      cv cF cfv wceq vz vw vu hbopab1 vu cv vx cv wcel vz ax-17 hbrdg hbxfr vu
      cv vy cv wcel vz ax-17 hbfv hbfv abianfp.2 vz cv vy cv cG cfv cF fveq2
      rdgsucopab mpan2 vy cv cG cfv vx cv wceq vx cv cF cfv vx cv wceq vy cv cG
      cfv cF cfv vx cv cF cfv vx cv vy cv cG cfv vx cv cF fveq2 vx cv cF cfv vx
      cv wceq id sylan9eqr sylan9eq exp32 vv cv wlim vy cv cG cfv vx cv wceq vy
      vv cv wral vv cv cG cfv vx cv wceq wi vx cv cF cfv vx cv wceq vv cv wlim
      vy cv cG cfv vx cv wceq vy vv cv wral vv cv cG cfv vx cv wceq vv cv wlim
      vy cv cG cfv vx cv wceq vy vv cv wral wa vv cv cG cfv vy vv cv vy cv cG
      cfv ciun vx cv vv cv wlim vv cv cG cfv vy vv cv vy cv cG cfv ciun wceq vy
      cv cG cfv vx cv wceq vy vv cv wral vv cv wlim vv cv vw cv vz cv cF cfv
      wceq vz vw copab vx cv crdg cfv vy vv cv vy cv vw cv vz cv cF cfv wceq vz
      vw copab vx cv crdg cfv ciun vv cv cG cfv vy vv cv vy cv cG cfv ciun vv
      cv cvv wcel vv cv wlim vv cv vw cv vz cv cF cfv wceq vz vw copab vx cv
      crdg cfv vy vv cv vy cv vw cv vz cv cF cfv wceq vz vw copab vx cv crdg
      cfv ciun wceq vv visset vy vx cv vv cv cvv vw cv vz cv cF cfv wceq vz vw
      copab rdglim2a mpan vv cv cG vw cv vz cv cF cfv wceq vz vw copab vx cv
      crdg abianfp.2 fveq1i vy vv cv vy cv cG cfv vy cv vw cv vz cv cF cfv wceq
      vz vw copab vx cv crdg cfv vy cv cG cfv vy cv vw cv vz cv cF cfv wceq vz
      vw copab vx cv crdg cfv wceq vy cv vv cv wcel vy cv cG vw cv vz cv cF cfv
      wceq vz vw copab vx cv crdg abianfp.2 fveq1i a1i iuneq2i 3eqtr4g adantr
      vy cv cG cfv vx cv wceq vy vv cv wral vv cv wlim vy vv cv vy cv cG cfv
      ciun vy vv cv vx cv ciun vx cv vy vv cv vy cv cG cfv vx cv iuneq2 vv cv
      wlim vv cv c0 wne vy vv cv vx cv ciun vx cv wceq vv cv wlim vv cv word vv
      cv c0 wne vv cv vv cv cuni wceq w3a vv cv c0 wne vv cv df-lim vv cv word
      vv cv c0 wne vv cv vv cv cuni wceq 3simp2 sylbi vy vv cv vx cv iunconst
      syl sylan9eqr eqtrd ex a1d tfinds2 $.
      $( [7-Sep-2004] $) $( [4-Sep-2004] $)

    $( No longer active:
       ~ http://www.math.ucdavis.edu/~~suh/abian/abian-themostfixed.html . $)
    $( "A most fundamental fixed point theorem" of Alexander Abian (1923-1999),
       apparently proved in 1998.  Let ` G `` 0 = x ` , ` G `` 1 = F `` x ` ,
       ` G `` 2 = F `` ( F `` x ) ` ,... be the iterates of ` F ` .  The
       theorem reads (using our variable names):  "Let ` F ` be a mapping from
       a set ` A ` into itself.  Then ` F ` has a fixed point if and only if:
       There exists an element ` x ` of ` A ` such that for every ordinal ` v `
       , ` G `` v ` is an element of ` A ` , and if ` G `` v ` is not a fixed
       point of ` F ` then the ` G `` u ` 's are all distinct for every ordinal
       ` u e. v ` ." See ~ df-rdg for the ` rec ` operation.  The proof's key
       idea is to assume that ` F ` does not have a fixed point, then use the
       Axiom of Replacement in the form of ~ f1dmex to derive that the class of
       all ordinal numbers exists, contradicting ~ onprc .  Our version of this
       theorem does not require the hypothesis that ` F ` be a mapping.
       Reference: ~ http://us2.metamath.org:88/abian-themostfixed.html .
       For an application of this theorem, see
       ~ http://groups.google.com/group/sci.stat.math/msg/1737ee1133c24aeb
       for its use in a proof of Tarski's fixed point theorem. $)
    abianfp $p |- ( E. x e. A ( F ` x ) = x <-> E. x e. A
           A. v e. On ( ( G ` v ) e. A /\ ( -. ( F ` ( G ` v ) ) = ( G ` v ) ->
                    A. u e. v -. ( G ` v ) = ( G ` u ) ) ) ) $=
      vx cv cF cfv vx cv wceq vx cA wrex vv cv cG cfv cA wcel vv cv cG cfv cF
      cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral
      wi wa vv con0 wral vx cA wrex vx cv cF cfv vx cv wceq vv cv cG cfv cA
      wcel vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv
      wceq wn vu vv cv wral wi wa vv con0 wral vx cA vx cv cA wcel vx cv cF cfv
      vx cv wceq vv cv cG cfv cA wcel vv cv cG cfv cF cfv vv cv cG cfv wceq wn
      vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi wa vv con0 vv cv con0
      wcel vx cv cF cfv vx cv wceq vx cv cA wcel vv cv cG cfv cA wcel vv cv cG
      cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv
      cv wral wi wa vv cv con0 wcel vx cv cF cfv vx cv wceq vx cv cA wcel vv cv
      cG cfv cA wcel vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu
      cv cG cfv wceq wn vu vv cv wral wi wa wi vv cv con0 wcel vx cv cF cfv vx
      cv wceq wa vx cv cA wcel vv cv cG cfv cA wcel vv cv cG cfv cF cfv vv cv
      cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi vv cv
      con0 wcel vx cv cF cfv vx cv wceq wa vv cv cG cfv cA wcel vx cv cA wcel
      vv cv con0 wcel vx cv cF cfv vx cv wceq wa vv cv cG cfv vx cv cA vv cv
      con0 wcel vx cv cF cfv vx cv wceq vv cv cG cfv vx cv wceq vx vz vw vv cA
      cF cG abianfp.1 abianfp.2 abianfplem imp eleq1d biimprd vv cv con0 wcel
      vx cv cF cfv vx cv wceq wa vv cv cG cfv cF cfv vv cv cG cfv wceq vv cv cG
      cfv vu cv cG cfv wceq wn vu vv cv wral vv cv con0 wcel vx cv cF cfv vx cv
      wceq vv cv cG cfv cF cfv vv cv cG cfv wceq vv cv con0 wcel vx cv cF cfv
      vx cv wceq vv cv cG cfv vx cv wceq vv cv cG cfv cF cfv vv cv cG cfv wceq
      vx vz vw vv cA cF cG abianfp.1 abianfp.2 abianfplem vv cv cG cfv vx cv
      wceq vv cv cG cfv cF cfv vv cv cG cfv wceq vx cv cF cfv vx cv wceq vv cv
      cG cfv vx cv wceq vv cv cG cfv cF cfv vx cv cF cfv vv cv cG cfv vx cv vv
      cv cG cfv vx cv cF fveq2 vv cv cG cfv vx cv wceq id eqeq12d biimprcd
      sylcom imp pm2.24d jctird ex com13 r19.21adv r19.22i vv cv cG cfv cA wcel
      vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq
      wn vu vv cv wral wi wa vv con0 wral vx cA wrex vy cv cF cfv vy cv wceq wn
      vy cA wral wn vx cv cF cfv vx cv wceq vx cA wrex vv cv cG cfv cA wcel vv
      cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn
      vu vv cv wral wi wa vv con0 wral vy cv cF cfv vy cv wceq wn vy cA wral wn
      vx cA vv cv cG cfv cA wcel vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv
      cG cfv vu cv cG cfv wceq wn vu vv cv wral wi wa vv con0 wral vy cv cF cfv
      vy cv wceq wn vy cA wral wn wi vx cv cA wcel vv cv cG cfv cA wcel vv cv
      cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu
      vv cv wral wi wa vv con0 wral vy cv cF cfv vy cv wceq wn vy cA wral con0
      cvv wcel onprc vv cv cG cfv cA wcel vv cv cG cfv cF cfv vv cv cG cfv wceq
      wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi wa vv con0 wral vv
      cv cG cfv cA wcel vv con0 wral vv cv cG cfv cF cfv vv cv cG cfv wceq wn
      vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi vv con0 wral wa vy cv
      cF cfv vy cv wceq wn vy cA wral con0 cvv wcel wi vv cv cG cfv cA wcel vv
      cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn
      vu vv cv wral wi vv con0 r19.26 vv cv cG cfv cA wcel vv con0 wral vv cv
      cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu
      vv cv wral wi vv con0 wral vy cv cF cfv vy cv wceq wn vy cA wral con0 cvv
      wcel wi vv cv cG cfv cA wcel vv con0 wral vy cv cF cfv vy cv wceq wn vy
      cA wral vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG
      cfv wceq wn vu vv cv wral wi vv con0 wral con0 cvv wcel vv cv cG cfv cA
      wcel vv con0 wral vy cv cF cfv vy cv wceq wn vy cA wral vv cv cG cfv cF
      cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral
      wi vv con0 wral con0 cvv wcel vv cv cG cfv cA wcel vv con0 wral vy cv cF
      cfv vy cv wceq wn vy cA wral vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv
      cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi vv con0 wral wa vv cv cG
      cfv vu cv cG cfv wceq wn vu vv cv wral vv con0 wral con0 cvv wcel vy cv
      cF cfv vy cv wceq wn vy cA wral vv cv cG cfv cF cfv vv cv cG cfv wceq wn
      vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi vv con0 wral wa vv cv
      cG cfv cA wcel vv con0 wral vv cv cG cfv vu cv cG cfv wceq wn vu vv cv
      wral vv con0 wral vy cv cF cfv vy cv wceq wn vy cA wral vv cv cG cfv cF
      cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral
      wi vv con0 wral vv cv cG cfv cA wcel vv con0 wral vv cv cG cfv vu cv cG
      cfv wceq wn vu vv cv wral vv con0 wral wi vy cv cF cfv vy cv wceq wn vy
      cA wral vv cv cG cfv cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG
      cfv wceq wn vu vv cv wral wi vv con0 wral vv cv cG cfv cA wcel vv cv cG
      cfv vu cv cG cfv wceq wn vu vv cv wral wi vv con0 wral vv cv cG cfv cA
      wcel vv con0 wral vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral vv con0
      wral wi vy cv cF cfv vy cv wceq wn vy cA wral vv cv cG cfv cF cfv vv cv
      cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi vv cv
      cG cfv cA wcel vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral wi vv con0
      vy cv cF cfv vy cv wceq wn vy cA wral vv cv cG cfv cA wcel vv cv cG cfv
      cF cfv vv cv cG cfv wceq wn vv cv cG cfv vu cv cG cfv wceq wn vu vv cv
      wral vy cv cF cfv vy cv wceq wn vv cv cG cfv cF cfv vv cv cG cfv wceq wn
      vy vv cv cG cfv cA vy cv vv cv cG cfv wceq vy cv cF cfv vy cv wceq vv cv
      cG cfv cF cfv vv cv cG cfv wceq vy cv vv cv cG cfv wceq vy cv cF cfv vv
      cv cG cfv cF cfv vy cv vv cv cG cfv vy cv vv cv cG cfv cF fveq2 vy cv vv
      cv cG cfv wceq id eqeq12d notbid rcla4cv imim1d r19.20sdv vv cv cG cfv cA
      wcel vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral vv con0 r19.20 syl6
      imp com12 vv cv cG cfv cA wcel vv con0 wral vv cv cG cfv vu cv cG cfv
      wceq wn vu vv cv wral vv con0 wral con0 cvv wcel con0 cA cG wf1 cA cvv
      wcel con0 cvv wcel vv cv cG cfv cA wcel vv con0 wral vv cv cG cfv vu cv
      cG cfv wceq wn vu vv cv wral vv con0 wral wa con0 cA cvv cG f1dmex vv cv
      cG cfv cA wcel vv con0 wral vv cv cG cfv vu cv cG cfv wceq wn vu vv cv
      wral vv con0 wral wa con0 cA cG wf cG ccnv wfun wa con0 cA cG wf1 vv cv
      cG cfv cA wcel vv con0 wral con0 cA cG wf vv cv cG cfv vu cv cG cfv wceq
      wn vu vv cv wral vv con0 wral cG ccnv wfun cG con0 wfn vv cv cG cfv cA
      wcel vv con0 wral con0 cA cG wf cG con0 wfn vw cv vz cv cF cfv wceq vz vw
      copab vx cv crdg con0 wfn vx cv vw cv vz cv cF cfv wceq vz vw copab
      rdgfnon cG vw cv vz cv cF cfv wceq vz vw copab vx cv crdg wceq cG con0
      wfn vw cv vz cv cF cfv wceq vz vw copab vx cv crdg con0 wfn wb abianfp.2
      con0 cG vw cv vz cv cF cfv wceq vz vw copab vx cv crdg fneq1 ax-mp mpbir
      con0 cA cG wf cG con0 wfn vv cv cG cfv cA wcel vv con0 wral wa vv con0 cA
      cG ffnfv biimpri mpan vv cv cG cfv vu cv cG cfv wceq wn vu vv cv wral vv
      con0 wral cG con0 cres ccnv wfun cG ccnv wfun con0 con0 wss vv cv cG cfv
      vu cv cG cfv wceq wn vu vv cv wral vv con0 wral cG con0 cres ccnv wfun
      con0 ssid vv vu con0 cG cG con0 wfn vw cv vz cv cF cfv wceq vz vw copab
      vx cv crdg con0 wfn vx cv vw cv vz cv cF cfv wceq vz vw copab rdgfnon cG
      vw cv vz cv cF cfv wceq vz vw copab vx cv crdg wceq cG con0 wfn vw cv vz
      cv cF cfv wceq vz vw copab vx cv crdg con0 wfn wb abianfp.2 con0 cG vw cv
      vz cv cF cfv wceq vz vw copab vx cv crdg fneq1 ax-mp mpbir tz7.48lem mpan
      cG con0 cres ccnv cG ccnv wceq cG con0 cres ccnv wfun cG ccnv wfun wb cG
      con0 cres cG cG con0 wfn cG con0 cres cG wceq cG con0 wfn vw cv vz cv cF
      cfv wceq vz vw copab vx cv crdg con0 wfn vx cv vw cv vz cv cF cfv wceq vz
      vw copab rdgfnon cG vw cv vz cv cF cfv wceq vz vw copab vx cv crdg wceq
      cG con0 wfn vw cv vz cv cF cfv wceq vz vw copab vx cv crdg con0 wfn wb
      abianfp.2 con0 cG vw cv vz cv cF cfv wceq vz vw copab vx cv crdg fneq1
      ax-mp mpbir con0 cG fnresdm ax-mp cnveqi cG con0 cres ccnv cG ccnv funeq
      ax-mp sylib anim12i con0 cA cG df-f1 sylibr abianfp.1 sylancl ex syld
      exp3a com23 imp sylbi mtoi a1i r19.23aiv vx cv cF cfv vx cv wceq vx cA
      wrex vy cv cF cfv vy cv wceq vy cA wrex vy cv cF cfv vy cv wceq wn vy cA
      wral wn vx cv cF cfv vx cv wceq vy cv cF cfv vy cv wceq vx vy cA vx cv vy
      cv wceq vx cv cF cfv vy cv cF cfv vx cv vy cv vx cv vy cv cF fveq2 vx cv
      vy cv wceq id eqeq12d cbvrexv vy cv cF cfv vy cv wceq vy cA dfrex2 bitr2i
      sylib impbii $.
      $( [10-Jun-2009] $) $( [5-Sep-2004] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordinal arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c 1o $. $( The ordinal number 1 $)
  $c 2o $. $( The ordinal number 2 $)
  $c +o $.  $( Ordinal addition operation (plus subscript o) $)
  $c .o $.  $( Ordinal multiplication operation (center dot subscript o) $)
  $c ^o $.  $( Ordinal exponentiation operation (caret subscript o) $)

  $( Extend the definition of a class to include the ordinal number 1. $)
  c1o $a class 1o $.

  $( Extend the definition of a class to include the ordinal number 2. $)
  c2o $a class 2o $.

  $( Extend the definition of a class to include the ordinal addition
     operation. $)
  coa $a class +o $.

  $( Extend the definition of a class to include the ordinal multiplication
     operation. $)
  comu $a class .o $.

  $( Extend the definition of a class to include the ordinal exponentiation
     operation. $)
  coe $a class ^o $.

  $( Define the ordinal number 1. $)
  df-1o $a |- 1o = suc (/) $.

  $( Define the ordinal number 2. $)
  df-2o $a |- 2o = suc 1o $.

  ${
    $d x y z w v $.
    $( Define the ordinal addition operation. $)
    df-oadd $a |- +o = { <. <. x , y >. , z >. | ( ( x e. On /\ y e. On ) /\
                z = ( rec ( { <. w , v >. | v = suc w } , x ) ` y ) ) } $.
  $}

  ${
    $d x y z w v $.
    $( Define the ordinal multiplication operation. $)
    df-omul $a |- .o = { <. <. x , y >. , z >. | ( ( x e. On /\ y e. On ) /\
             z = ( rec ( { <. w , v >. | v = ( w +o x ) } , (/) ) ` y ) ) } $.
  $}

  ${
    $d x y z w v $.
    $( Define the ordinal exponentiation operation. $)
    df-oexp $a |- ^o = { <. <. x , y >. , z >. | ( ( x e. On /\ y e. On ) /\
                   z = if ( x = (/) , ( 1o \ y ) ,
                 ( rec ( { <. w , v >. | v = ( w .o x ) } , 1o ) ` y ) ) ) } $.
  $}

  $( Ordinal 1 is an ordinal number. $)
  1on $p |- 1o e. On $=
    c1o c0 csuc con0 df-1o c0 0elon onsuci eqeltri $.
    $( [29-Oct-1995] $)

  $( Ordinal 2 is an ordinal number. $)
  2on $p |- 2o e. On $=
    c1o con0 wcel c2o con0 wcel 1on c1o con0 wcel c1o csuc con0 wcel c2o con0
    wcel c1o sucelon c2o c1o csuc con0 df-2o eleq1i bitr4i mpbi $.
    $( [19-Feb-2004] $) $( [18-Feb-2004] $)

  $( Expanded value of the ordinal number 1. $)
  df1o2 $p |- 1o = { (/) } $=
    c1o c0 csuc c0 csn df-1o suc0 eqtri $.
    $( [4-Nov-2002] $)

  $( Expanded value of the ordinal number 2. $)
  df2o2 $p |- 2o = { (/) , { (/) } } $=
    c2o c1o csuc c1o c1o csn cun c0 c0 csn cpr df-2o c1o df-suc c1o c1o csn cun
    c0 csn c0 csn csn cun c0 c0 csn cpr c1o c0 csn c1o csn c0 csn csn df1o2 c1o
    c0 csn df1o2 sneqi uneq12i c0 c0 csn df-pr eqtr4i 3eqtri $.
    $( [19-Feb-2004] $) $( [29-Jan-2004] $)

  $( Ordinal one is not equal to ordinal zero. $)
  1n0 $p |- 1o =/= (/) $=
    c1o c0 wne c0 csn c0 wne c0 0ex snnz c1o c0 csn c0 df1o2 neeq1i mpbir $.
    $( [30-Apr-2007] $) $( [26-Dec-2004] $)

  $( Cross products with the singletons of ordinals 0 and 1 are disjoint. $)
  xp01disj $p |- ( ( A X. { (/) } ) i^i ( C X. { 1o } ) ) = (/) $=
    c0 c1o wne cA c0 csn cxp cC c1o csn cxp cin c0 wceq c1o c0 wne c0 c1o wne
    1n0 c1o c0 necom mpbi cA c0 cC c1o xpsndisj ax-mp $.
    $( [5-Jun-2007] $) $( [2-Jun-2007] $)

  $( Two ways to express that an ordinal class is positive. $)
  ordgt0ge1 $p |- ( Ord A -> ( (/) e. A <-> 1o C_ A ) ) $=
    cA word c0 cA wcel c0 csuc cA wss c1o cA wss c0 con0 wcel cA word c0 cA
    wcel c0 csuc cA wss wb 0elon c0 cA con0 ordelsuc mpan c1o c0 csuc cA df-1o
    sseq1i syl6bbr $.
    $( [1-Jan-2005] $) $( [21-Dec-2004] $)

  $( An ordinal greater than or equal to 1 is nonzero. $)
  ordge1n0 $p |- ( Ord A -> ( 1o C_ A <-> A =/= (/) ) ) $=
    cA word c0 cA wcel c1o cA wss cA c0 wne cA ordgt0ge1 cA ord0eln0 bitr3d $.
    $( [29-May-2007] $) $( [21-Dec-2004] $)

  $( Membership in ordinal one. $)
  el1o $p |- ( A e. 1o <-> A = (/) ) $=
    cA c1o wcel cA c0 csn wcel cA c0 wceq c1o c0 csn cA df1o2 eleq2i cA c0 0ex
    elsnc2 bitri $.
    $( [8-Jan-2005] $) $( [5-Jan-2005] $)

  $( Ordinal zero is less than ordinal one. $)
  0lt1o $p |- (/) e. 1o $=
    c0 c1o wcel c0 c0 wceq c0 eqid c0 el1o mpbir $.
    $( [8-Jan-2005] $) $( [5-Jan-2005] $)

  ${
    $d x y z w v $.
    $( Functionality and domain of ordinal addition. $)
    fnoa $p |- +o Fn ( On X. On ) $=
      vx vy vz con0 con0 vy cv vv cv vw cv csuc wceq vw vv copab vx cv crdg cfv
      coa vy cv vv cv vw cv csuc wceq vw vv copab vx cv crdg fvex vx vy vz vw
      vv df-oadd fnoprab2 $.
      $( [26-Aug-1995] $)
  $}

  ${
    $d x y z w v $.
    $( Functionality and domain of ordinal multiplication. $)
    fnom $p |- .o Fn ( On X. On ) $=
      vx vy vz con0 con0 vy cv vv cv vw cv vx cv coa co wceq vw vv copab c0
      crdg cfv comu vy cv vv cv vw cv vx cv coa co wceq vw vv copab c0 crdg
      fvex vx vy vz vw vv df-omul fnoprab2 $.
      $( [26-Aug-1995] $)
  $}

  ${
    $d x y z w v $.  $d z w v A $.  $d z w v B $.
    $( Value of ordinal addition. $)
    oav $p |- ( ( A e. On /\ B e. On ) ->
             ( A +o B ) = ( rec ( { <. x , y >. | y = suc x } , A ) ` B ) ) $=
      vw vv vz cA cB con0 con0 vv cv vy cv vx cv csuc wceq vx vy copab vw cv
      crdg cfv cB vy cv vx cv csuc wceq vx vy copab cA crdg cfv coa vv cv vy cv
      vx cv csuc wceq vx vy copab cA crdg cfv cB vy cv vx cv csuc wceq vx vy
      copab cA crdg fvex vw cv cA wceq vv cv vy cv vx cv csuc wceq vx vy copab
      vw cv crdg vy cv vx cv csuc wceq vx vy copab cA crdg vw cv cA vy cv vx cv
      csuc wceq vx vy copab rdgeq2 fveq1d vv cv cB vy cv vx cv csuc wceq vx vy
      copab cA crdg fveq2 vw vv vz vx vy df-oadd oprabval2 $.
      $( [3-May-1995] $)
  $}

  ${
    $d x y z w v A $.  $d z w v B $.
    $( Value of ordinal multiplication. $)
    omv $p |- ( ( A e. On /\ B e. On ) ->
     ( A .o B ) = ( rec ( { <. x , y >. | y = ( x +o A ) } , (/) ) ` B ) ) $=
      vw vv vz cA cB con0 con0 vv cv vy cv vx cv vw cv coa co wceq vx vy copab
      c0 crdg cfv cB vy cv vx cv cA coa co wceq vx vy copab c0 crdg cfv comu vv
      cv vy cv vx cv cA coa co wceq vx vy copab c0 crdg cfv cB vy cv vx cv cA
      coa co wceq vx vy copab c0 crdg fvex vw cv cA wceq vy cv vx cv vw cv coa
      co wceq vx vy copab vy cv vx cv cA coa co wceq vx vy copab wceq vy cv vx
      cv vw cv coa co wceq vx vy copab c0 crdg vy cv vx cv cA coa co wceq vx vy
      copab c0 crdg wceq vv cv vy cv vx cv vw cv coa co wceq vx vy copab c0
      crdg cfv vv cv vy cv vx cv cA coa co wceq vx vy copab c0 crdg cfv wceq vw
      cv cA wceq vy cv vx cv vw cv coa co wceq vy cv vx cv cA coa co wceq vx vy
      vw cv cA wceq vx cv vw cv coa co vx cv cA coa co vy cv vw cv cA vx cv coa
      opreq2 eqeq2d opabbidv c0 vy cv vx cv vw cv coa co wceq vx vy copab vy cv
      vx cv cA coa co wceq vx vy copab rdgeq1 vv cv vy cv vx cv vw cv coa co
      wceq vx vy copab c0 crdg vy cv vx cv cA coa co wceq vx vy copab c0 crdg
      fveq1 3syl vv cv cB vy cv vx cv cA coa co wceq vx vy copab c0 crdg fveq2
      vw vv vz vx vy df-omul oprabval2 $.
      $( [17-Sep-1995] $)
  $}

  ${
    oe0lem.1 $e |- ( ( ph /\ A = (/) ) -> ps ) $.
    oe0lem.2 $e |- ( ( ( A e. On /\ ph ) /\ (/) e. A ) -> ps ) $.
    $( A helper lemma for ~ oe0 and others. $)
    oe0lem $p |- ( ( A e. On /\ ph ) -> ps ) $=
      cA con0 wcel wph wa wps cA c0 wph cA c0 wceq wps wi cA con0 wcel wph cA
      c0 wceq wps oe0lem.1 ex adantl cA con0 wcel wph wa cA c0 wne c0 cA wcel
      wps cA con0 wcel c0 cA wcel cA c0 wne wb wph cA on0eln0 adantr cA con0
      wcel wph wa c0 cA wcel wps oe0lem.2 ex sylbird pm2.61dne $.
      $( [8-Jan-2005] $) $( [6-Jan-2005] $)
  $}

  ${
    $d x y z w v A $.  $d z w v B $.
    $( Value of ordinal exponentiation. $)
    oev $p |- ( ( A e. On /\ B e. On ) ->  ( A ^o B ) = if ( A = (/) ,
      ( 1o \ B ) , ( rec ( { <. x , y >. | y = ( x .o A ) } , 1o ) ` B ) ) ) $=
      vw vv vz cA cB con0 con0 vw cv c0 wceq c1o vv cv cdif vv cv vy cv vx cv
      vw cv comu co wceq vx vy copab c1o crdg cfv cif cA c0 wceq c1o cB cdif cB
      vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cif coe cA c0 wceq
      c1o vv cv cdif vv cv vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv
      cif cA c0 wceq c1o cB cdif cB vy cv vx cv cA comu co wceq vx vy copab c1o
      crdg cfv c1o con0 wcel c1o cB cdif cvv wcel 1on c1o cB con0 difexg ax-mp
      cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg fvex ifex vw cv cA
      wceq vw cv c0 wceq c1o vv cv cdif vv cv vy cv vx cv vw cv comu co wceq vx
      vy copab c1o crdg cfv cif cA c0 wceq c1o vv cv cdif vv cv vy cv vx cv vw
      cv comu co wceq vx vy copab c1o crdg cfv cif cA c0 wceq c1o vv cv cdif vv
      cv vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cif vw cv cA wceq
      vw cv c0 wceq cA c0 wceq c1o vv cv cdif vv cv vy cv vx cv vw cv comu co
      wceq vx vy copab c1o crdg cfv vw cv cA c0 eqeq1 ifbid vw cv cA wceq cA c0
      wceq vv cv vy cv vx cv vw cv comu co wceq vx vy copab c1o crdg cfv vv cv
      vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv c1o vv cv cdif vw cv
      cA wceq vy cv vx cv vw cv comu co wceq vx vy copab vy cv vx cv cA comu co
      wceq vx vy copab wceq vy cv vx cv vw cv comu co wceq vx vy copab c1o crdg
      vy cv vx cv cA comu co wceq vx vy copab c1o crdg wceq vv cv vy cv vx cv
      vw cv comu co wceq vx vy copab c1o crdg cfv vv cv vy cv vx cv cA comu co
      wceq vx vy copab c1o crdg cfv wceq vw cv cA wceq vy cv vx cv vw cv comu
      co wceq vy cv vx cv cA comu co wceq vx vy vw cv cA wceq vx cv vw cv comu
      co vx cv cA comu co vy cv vw cv cA vx cv comu opreq2 eqeq2d opabbidv c1o
      vy cv vx cv vw cv comu co wceq vx vy copab vy cv vx cv cA comu co wceq vx
      vy copab rdgeq1 vv cv vy cv vx cv vw cv comu co wceq vx vy copab c1o crdg
      vy cv vx cv cA comu co wceq vx vy copab c1o crdg fveq1 3syl ifeq2d eqtrd
      vv cv cB wceq cA c0 wceq c1o vv cv cdif vv cv vy cv vx cv cA comu co wceq
      vx vy copab c1o crdg cfv cif cA c0 wceq c1o cB cdif vv cv vy cv vx cv cA
      comu co wceq vx vy copab c1o crdg cfv cif cA c0 wceq c1o cB cdif cB vy cv
      vx cv cA comu co wceq vx vy copab c1o crdg cfv cif vv cv cB wceq cA c0
      wceq c1o vv cv cdif c1o cB cdif vv cv vy cv vx cv cA comu co wceq vx vy
      copab c1o crdg cfv vv cv cB c1o difeq2 ifeq1d vv cv cB wceq cA c0 wceq vv
      cv vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cB vy cv vx cv cA
      comu co wceq vx vy copab c1o crdg cfv c1o cB cdif vv cv cB vy cv vx cv cA
      comu co wceq vx vy copab c1o crdg fveq2 ifeq2d eqtrd vw vv vz vx vy
      df-oexp oprabval2 $.
      $( [1-Jan-2005] $) $( [30-Dec-2004] $)

    $( Value of ordinal exponentiation at a nonzero mantissa. $)
    oevn0 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. A ) -> ( A ^o B ) =
                ( rec ( { <. x , y >. | y = ( x .o A ) } , 1o ) ` B ) ) $=
      cA con0 wcel cB con0 wcel wa c0 cA wcel cA cB coe co cB vy cv vx cv cA
      comu co wceq vx vy copab c1o crdg cfv wceq cA con0 wcel cB con0 wcel wa
      c0 cA wcel cA c0 wceq wn cA cB coe co cB vy cv vx cv cA comu co wceq vx
      vy copab c1o crdg cfv wceq cA con0 wcel c0 cA wcel cA c0 wceq wn wb cB
      con0 wcel cA con0 wcel c0 cA wcel cA c0 wne cA c0 wceq wn cA on0eln0 cA
      c0 df-ne syl6bb adantr cA con0 wcel cB con0 wcel wa cA c0 wceq wn cA cB
      coe co cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv wceq cA
      con0 wcel cB con0 wcel wa cA c0 wceq wn cA cB coe co cA c0 wceq c1o cB
      cdif cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cif cB vy cv
      vx cv cA comu co wceq vx vy copab c1o crdg cfv vx vy cA cB oev cA c0 wceq
      c1o cB cdif cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv
      iffalse sylan9eq ex sylbid imp $.
      $( [2-Jan-2005] $) $( [31-Dec-2004] $)
  $}

  ${
    $d x y A $.
    $( Addition with zero.  Proposition 8.3 of [TakeutiZaring] p. 57. $)
    oa0 $p |- ( A e. On -> ( A +o (/) ) = A ) $=
      cA con0 wcel cA c0 coa co c0 vy cv vx cv csuc wceq vx vy copab cA crdg
      cfv cA cA con0 wcel c0 con0 wcel cA c0 coa co c0 vy cv vx cv csuc wceq vx
      vy copab cA crdg cfv wceq 0elon vx vy cA c0 oav mpan2 cA con0 vy cv vx cv
      csuc wceq vx vy copab rdg0g eqtrd $.
      $( [3-May-1995] $)

    $( Ordinal multiplication with zero.  Definition 8.15 of [TakeutiZaring]
       p. 62. $)
    om0 $p |- ( A e. On -> ( A .o (/) ) = (/) ) $=
      cA con0 wcel cA c0 comu co c0 vy cv vx cv cA coa co wceq vx vy copab c0
      crdg cfv c0 cA con0 wcel c0 con0 wcel cA c0 comu co c0 vy cv vx cv cA coa
      co wceq vx vy copab c0 crdg cfv wceq 0elon vx vy cA c0 omv mpan2 c0 vy cv
      vx cv cA coa co wceq vx vy copab 0ex rdg0 syl6eq $.
      $( [17-Sep-1995] $)

    $( Ordinal exponentiation with zero mantissa. $)
    oe0m $p |- ( A e. On -> ( (/) ^o A ) = ( 1o \ A ) ) $=
      cA con0 wcel c0 cA coe co c0 c0 wceq c1o cA cdif cA vy cv vx cv c0 comu
      co wceq vx vy copab c1o crdg cfv cif c1o cA cdif c0 con0 wcel cA con0
      wcel c0 cA coe co c0 c0 wceq c1o cA cdif cA vy cv vx cv c0 comu co wceq
      vx vy copab c1o crdg cfv cif wceq 0elon vx vy c0 cA oev mpan c0 c0 wceq
      c0 c0 wceq c1o cA cdif cA vy cv vx cv c0 comu co wceq vx vy copab c1o
      crdg cfv cif c1o cA cdif wceq c0 eqid c0 c0 wceq c1o cA cdif cA vy cv vx
      cv c0 comu co wceq vx vy copab c1o crdg cfv iftrue ax-mp syl6eq $.
      $( [3-Jan-2005] $) $( [31-Dec-2004] $)
  $}

  $( Ordinal multiplication with zero.  Definition 8.15 of [TakeutiZaring]
     p. 62.  Unlike ~ om0 , this version works whether or not ` A ` is an
     ordinal.  However, since it is an artifact of our particular function
     value definition outside the domain, we will not use it in order to be
     conventional and present it only as a curiosity. $)
  om0x $p |- ( A .o (/) ) = (/) $=
    cA con0 wcel c0 con0 wcel wa cA c0 comu co c0 wceq cA con0 wcel cA c0 comu
    co c0 wceq c0 con0 wcel cA om0 adantr cA c0 con0 comu 0ex comu con0 con0
    cxp wfn comu cdm con0 con0 cxp wceq fnom con0 con0 cxp comu fndm ax-mp
    ndmopr pm2.61i $.
    $( [1-Feb-1996] $)

  $( Ordinal exponentiation with zero mantissa and zero exponent.
     Proposition 8.31 of [TakeutiZaring] p. 67. $)
  oe0m0 $p |- ( (/) ^o (/) ) = 1o $=
    c0 con0 wcel c0 c0 coe co c1o wceq 0elon c0 con0 wcel c0 c0 coe co c1o c0
    cdif c1o c0 oe0m c1o dif0 syl6eq ax-mp $.
    $( [3-Jan-2005] $) $( [31-Dec-2004] $)

  $( Ordinal exponentiation with zero mantissa and nonzero exponent.
     Proposition 8.31(2) of [TakeutiZaring] p. 67 and its converse. $)
  oe0m1 $p |- ( A e. On -> ( (/) e. A <-> ( (/) ^o A ) = (/) ) ) $=
    cA con0 wcel c0 cA wcel c1o cA wss c0 cA coe co c0 wceq cA con0 wcel cA
    word c0 cA wcel c1o cA wss wb cA eloni cA ordgt0ge1 syl cA con0 wcel c0 cA
    coe co c0 wceq c1o cA cdif c0 wceq c1o cA wss cA con0 wcel c0 cA coe co c1o
    cA cdif c0 cA oe0m eqeq1d c1o cA ssdif0 syl6rbbr bitrd $.
    $( [21-Mar-2005] $) $( [5-Jan-2005] $)

  ${
    $d x y A $.
    $( Ordinal exponentiation with zero exponent.  Definition 8.30 of
       [TakeutiZaring] p. 67. $)
    oe0 $p |- ( A e. On -> ( A ^o (/) ) = 1o ) $=
      cA con0 wcel cA c0 coe co c1o wceq cA con0 wcel cA c0 coe co c1o wceq cA
      cA c0 wceq cA c0 coe co c1o wceq cA con0 wcel cA c0 wceq cA c0 coe co c0
      c0 coe co c1o cA c0 c0 coe opreq1 oe0m0 syl6eq adantl cA con0 wcel c0 cA
      wcel cA c0 coe co c1o wceq cA con0 wcel cA con0 wcel c0 cA wcel wa cA c0
      coe co c0 vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv c1o cA
      con0 wcel c0 con0 wcel c0 cA wcel cA c0 coe co c0 vy cv vx cv cA comu co
      wceq vx vy copab c1o crdg cfv wceq 0elon vx vy cA c0 oevn0 mpanl2 c1o vy
      cv vx cv cA comu co wceq vx vy copab c1o con0 1on elisseti rdg0 syl6eq
      adantll oe0lem anidms $.
      $( [4-Jan-2005] $) $( [31-Dec-2004] $)

    $( Alternate value of ordinal exponentiation.  Compare ~ oev . $)
    oev2 $p |- ( ( A e. On /\ B e. On ) ->  ( A ^o B ) = ( ( rec ( {
               <. x , y >. | y = ( x .o A ) } , 1o ) ` B )
                  i^i ( ( _V \ |^| A ) u. |^| B ) ) ) $=
      cB con0 wcel cA cB coe co cB vy cv vx cv cA comu co wceq vx vy copab c1o
      crdg cfv cvv cA cint cdif cB cint cun cin wceq cA cB con0 wcel cA c0 wceq
      wa cA cB coe co cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv
      cB cint cin cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cvv
      cA cint cdif cB cint cun cin cA c0 wceq cA cB coe co cB vy cv vx cv cA
      comu co wceq vx vy copab c1o crdg cfv cB cint cin wceq cB cA c0 wceq cB
      c0 wceq wa c0 c0 coe co c1o cA cB coe co cB vy cv vx cv cA comu co wceq
      vx vy copab c1o crdg cfv cB cint cin oe0m0 cA c0 cB c0 coe opreq12 cB c0
      wceq cA c0 wceq cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv
      cB cint cin c1o cvv cin c1o cB c0 wceq cB vy cv vx cv cA comu co wceq vx
      vy copab c1o crdg cfv c1o cB cint cvv cB c0 wceq cB vy cv vx cv cA comu
      co wceq vx vy copab c1o crdg cfv c0 vy cv vx cv cA comu co wceq vx vy
      copab c1o crdg cfv c1o cB c0 vy cv vx cv cA comu co wceq vx vy copab c1o
      crdg fveq2 c1o vy cv vx cv cA comu co wceq vx vy copab c1o con0 1on
      elisseti rdg0 syl6eq cB c0 wceq cB cint c0 cint cvv cB c0 inteq int0
      syl6eq ineq12d c1o cvv cin c1o wceq cA c0 wceq c1o inv1 a1i sylan9eqr
      3eqtr4a cB con0 wcel cA c0 wceq wa c0 cB wcel wa cA cB coe co c0 cB vy cv
      vx cv cA comu co wceq vx vy copab c1o crdg cfv cB cint cin cB con0 wcel
      c0 cB wcel cA c0 wceq cA cB coe co c0 wceq cA c0 wceq cB con0 wcel c0 cB
      wcel wa cA cB coe co c0 cB coe co c0 cA c0 cB coe opreq1 cB con0 wcel c0
      cB wcel c0 cB coe co c0 wceq cB oe0m1 biimpa sylan9eqr an1rs c0 cB wcel
      cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cB cint cin c0
      wceq cB con0 wcel cA c0 wceq wa c0 cB wcel cB vy cv vx cv cA comu co wceq
      vx vy copab c1o crdg cfv cB cint cin cB vy cv vx cv cA comu co wceq vx vy
      copab c1o crdg cfv c0 cin c0 c0 cB wcel cB cint c0 cB vy cv vx cv cA comu
      co wceq vx vy copab c1o crdg cfv cB int0el ineq2d cB vy cv vx cv cA comu
      co wceq vx vy copab c1o crdg cfv in0 syl6eq adantl eqtr4d oe0lem cB con0
      wcel cA c0 wceq wa cvv cA cint cdif cB cint cun cB cint cB vy cv vx cv cA
      comu co wceq vx vy copab c1o crdg cfv cA c0 wceq cvv cA cint cdif cB cint
      cun cB cint wceq cB con0 wcel cA c0 wceq cB cint cvv cA cint cdif cun cB
      cint c0 cun cvv cA cint cdif cB cint cun cB cint cA c0 wceq cvv cA cint
      cdif c0 cB cint cA c0 wceq cvv cA cint cdif cvv cvv cdif c0 cA c0 wceq cA
      cint cvv cvv cA c0 wceq cA cint c0 cint cvv cA c0 inteq int0 syl6eq
      difeq2d cvv difid syl6eq uneq2d cB cint cvv cA cint cdif uncom cB cint
      un0 3eqtr3g adantl ineq2d eqtr4d cA con0 wcel cB con0 wcel wa c0 cA wcel
      wa cA cB coe co cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv
      cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cvv cA cint cdif
      cB cint cun cin vx vy cA cB oevn0 cA con0 wcel cB con0 wcel wa c0 cA wcel
      wa cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cvv cA cint
      cdif cB cint cun cin cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg
      cfv cvv cin cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cA
      con0 wcel cB con0 wcel wa c0 cA wcel wa cvv cA cint cdif cB cint cun cvv
      cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv c0 cA wcel cvv cA
      cint cdif cB cint cun cvv wceq cA con0 wcel cB con0 wcel wa c0 cA wcel cB
      cint cvv cA cint cdif cun cB cint cvv cun cvv cA cint cdif cB cint cun
      cvv c0 cA wcel cvv cA cint cdif cvv cB cint c0 cA wcel cvv cA cint cdif
      cvv c0 cdif cvv c0 cA wcel cA cint c0 cvv cA int0el difeq2d cvv dif0
      syl6eq uneq2d cB cint cvv cA cint cdif uncom cB cint unv 3eqtr3g adantl
      ineq2d cB vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv inv1
      syl6req eqtrd oe0lem $.
      $( [21-Jul-2006] $) $( [2-Jan-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Addition with successor.  Definition 8.1 of [TakeutiZaring] p. 56. $)
    oasuc $p |- ( ( A e. On /\ B e. On ) ->
                ( A +o suc B ) = suc ( A +o B ) ) $=
      cA con0 wcel cB con0 wcel wa cB csuc vy cv vx cv csuc wceq vx vy copab cA
      crdg cfv cB vy cv vx cv csuc wceq vx vy copab cA crdg cfv vy cv vx cv
      csuc wceq vx vy copab cfv cA cB csuc coa co cA cB coa co csuc cB con0
      wcel cB csuc vy cv vx cv csuc wceq vx vy copab cA crdg cfv cB vy cv vx cv
      csuc wceq vx vy copab cA crdg cfv vy cv vx cv csuc wceq vx vy copab cfv
      wceq cA con0 wcel cA cB vy cv vx cv csuc wceq vx vy copab rdgsuc adantl
      cA con0 wcel cB csuc con0 wcel cA cB csuc coa co cB csuc vy cv vx cv csuc
      wceq vx vy copab cA crdg cfv wceq cB con0 wcel vx vy cA cB csuc oav cB
      suceloni sylan2 cA con0 wcel cB con0 wcel wa cA cB coa co vy cv vx cv
      csuc wceq vx vy copab cfv cB vy cv vx cv csuc wceq vx vy copab cA crdg
      cfv vy cv vx cv csuc wceq vx vy copab cfv cA cB coa co csuc cA con0 wcel
      cB con0 wcel wa cA cB coa co cB vy cv vx cv csuc wceq vx vy copab cA crdg
      cfv vy cv vx cv csuc wceq vx vy copab vx vy cA cB oav fveq2d vx vy cA cB
      coa co vx cv csuc cA cB coa co csuc cA cB coa oprex cA cB coa co cA cB
      coa oprex sucex vx cv cA cB coa co suceq fvopab syl5eqr 3eqtr4d $.
      $( [3-May-1995] $)
  $}

  $( Addition with 1 is same as successor.  Proposition 4.34(a) of [Mendelson]
     p. 266. $)
  oa1suc $p |- ( A e. On ->
                ( A +o 1o ) = suc A ) $=
    cA con0 wcel cA c1o coa co cA c0 coa co csuc cA csuc cA con0 wcel cA c0
    csuc coa co cA c0 coa co csuc cA c1o coa co cA con0 wcel c0 con0 wcel cA c0
    csuc coa co cA c0 coa co csuc wceq 0elon cA c0 oasuc mpan2 c1o c0 csuc cA
    coa df-1o opreq2i syl5eq cA con0 wcel cA c0 coa co cA wceq cA c0 coa co
    csuc cA csuc wceq cA oa0 cA c0 coa co cA suceq syl eqtrd $.
    $( [29-Oct-1995] $)

  ${
    $d x y A $.  $d x y B $.
    $( Multiplication with successor.  Definition 8.15 of [TakeutiZaring]
       p. 62. $)
    omsuc $p |- ( ( A e. On /\ B e. On ) ->
                ( A .o suc B ) = ( ( A .o B ) +o A ) ) $=
      cA con0 wcel cB con0 wcel wa cB csuc vy cv vx cv cA coa co wceq vx vy
      copab c0 crdg cfv cB vy cv vx cv cA coa co wceq vx vy copab c0 crdg cfv
      vy cv vx cv cA coa co wceq vx vy copab cfv cA cB csuc comu co cA cB comu
      co cA coa co cB con0 wcel cB csuc vy cv vx cv cA coa co wceq vx vy copab
      c0 crdg cfv cB vy cv vx cv cA coa co wceq vx vy copab c0 crdg cfv vy cv
      vx cv cA coa co wceq vx vy copab cfv wceq cA con0 wcel c0 cB vy cv vx cv
      cA coa co wceq vx vy copab rdgsuc adantl cA con0 wcel cB csuc con0 wcel
      cA cB csuc comu co cB csuc vy cv vx cv cA coa co wceq vx vy copab c0 crdg
      cfv wceq cB con0 wcel vx vy cA cB csuc omv cB suceloni sylan2 cA con0
      wcel cB con0 wcel wa cA cB comu co vy cv vx cv cA coa co wceq vx vy copab
      cfv cB vy cv vx cv cA coa co wceq vx vy copab c0 crdg cfv vy cv vx cv cA
      coa co wceq vx vy copab cfv cA cB comu co cA coa co cA con0 wcel cB con0
      wcel wa cA cB comu co cB vy cv vx cv cA coa co wceq vx vy copab c0 crdg
      cfv vy cv vx cv cA coa co wceq vx vy copab vx vy cA cB omv fveq2d vx vy
      cA cB comu co vx cv cA coa co cA cB comu co cA coa co cA cB comu oprex cA
      cB comu co cA coa oprex vx cv cA cB comu co cA coa opreq1 fvopab syl5eqr
      3eqtr4d $.
      $( [17-Sep-1995] $)

    $( Ordinal exponentiation with a successor exponent.  Definition 8.30 of
       [TakeutiZaring] p. 67. $)
    oesuc $p |- ( ( A e. On /\ B e. On ) ->
                ( A ^o suc B ) = ( ( A ^o B ) .o A ) ) $=
      cB con0 wcel cA cB csuc coe co cA cB coe co cA comu co wceq cA cB con0
      wcel cA c0 wceq wa cA cB csuc coe co c0 cA cB coe co cA comu co cA c0
      wceq cB con0 wcel cA cB csuc coe co c0 cB csuc coe co c0 cA c0 cB csuc
      coe opreq1 cB csuc con0 wcel c0 cB csuc wcel c0 cB csuc coe co c0 wceq cB
      con0 wcel cB csuc con0 wcel c0 cB csuc wcel c0 cB csuc coe co c0 wceq cB
      csuc oe0m1 biimpa cB suceloni cB con0 wcel cB word c0 cB csuc wcel cB
      eloni cB 0elsuc syl sylanc sylan9eqr cA c0 wceq cB con0 wcel cA cB coe co
      cA comu co c0 cB coe co c0 comu co c0 cA c0 wceq cA cB coe co c0 cB coe
      co cA c0 comu cA c0 cB coe opreq1 cA c0 wceq id opreq12d cB con0 wcel c0
      cB coe co con0 wcel c0 cB coe co c0 comu co c0 wceq cB con0 wcel c0 cB
      coe co con0 wcel cB con0 wcel c0 cB coe co con0 wcel cB cB c0 wceq c0 cB
      coe co con0 wcel cB con0 wcel cB c0 wceq c0 cB coe co c0 c0 coe co con0
      cB c0 c0 coe opreq2 c0 c0 coe co c1o con0 oe0m0 1on eqeltri syl6eqel
      adantl cB con0 wcel c0 cB wcel c0 cB coe co con0 wcel cB con0 wcel cB
      con0 wcel c0 cB wcel wa c0 cB coe co c0 con0 cB con0 wcel c0 cB wcel c0
      cB coe co c0 wceq cB oe0m1 biimpa 0elon syl6eqel adantll oe0lem anidms c0
      cB coe co om0 syl sylan9eqr eqtr4d cA con0 wcel cB con0 wcel wa c0 cA
      wcel wa cB csuc vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cB
      vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv vy cv vx cv cA comu
      co wceq vx vy copab cfv cA cB csuc coe co cA cB coe co cA comu co cB con0
      wcel cB csuc vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv cB vy
      cv vx cv cA comu co wceq vx vy copab c1o crdg cfv vy cv vx cv cA comu co
      wceq vx vy copab cfv wceq cA con0 wcel c0 cA wcel c1o cB vy cv vx cv cA
      comu co wceq vx vy copab rdgsuc ad2antlr cA con0 wcel cB csuc con0 wcel
      c0 cA wcel cA cB csuc coe co cB csuc vy cv vx cv cA comu co wceq vx vy
      copab c1o crdg cfv wceq cB con0 wcel vx vy cA cB csuc oevn0 cB suceloni
      sylanl2 cA con0 wcel cB con0 wcel wa c0 cA wcel wa cA cB coe co vy cv vx
      cv cA comu co wceq vx vy copab cfv cB vy cv vx cv cA comu co wceq vx vy
      copab c1o crdg cfv vy cv vx cv cA comu co wceq vx vy copab cfv cA cB coe
      co cA comu co cA con0 wcel cB con0 wcel wa c0 cA wcel wa cA cB coe co cB
      vy cv vx cv cA comu co wceq vx vy copab c1o crdg cfv vy cv vx cv cA comu
      co wceq vx vy copab vx vy cA cB oevn0 fveq2d vx vy cA cB coe co vx cv cA
      comu co cA cB coe co cA comu co cA cB coe oprex cA cB coe co cA comu
      oprex vx cv cA cB coe co cA comu opreq1 fvopab syl5eqr 3eqtr4d oe0lem $.
      $( [21-Jul-2006] $) $( [31-Dec-2004] $)
  $}

  ${
    $d x y z A $.  $d x B $.
    $( Ordinal addition with a limit ordinal.  Definition 8.1 of
       [TakeutiZaring] p. 56. $)
    oalim $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) ->
                ( A +o B ) = U_ x e. B ( A +o x ) ) $=
      cA con0 wcel cB con0 wcel cB wlim wa cA cB coa co vx cB cA vx cv coa co
      ciun wceq cB cC wcel cB wlim wa cA con0 wcel cB con0 wcel cB wlim wa wa
      cA cB coa co vx cB cA vx cv coa co ciun wceq cB vz cv vy cv csuc wceq vy
      vz copab cA crdg cfv vx cB vx cv vz cv vy cv csuc wceq vy vz copab cA
      crdg cfv ciun wceq cB con0 wcel cB wlim wa cB vz cv vy cv csuc wceq vy vz
      copab cA crdg cfv vx cB vx cv vz cv vy cv csuc wceq vy vz copab cA crdg
      cfv ciun wceq cA con0 wcel vx cA cB con0 vz cv vy cv csuc wceq vy vz
      copab rdglim2a adantl cA con0 wcel cB con0 wcel cA cB coa co vx cB cA vx
      cv coa co ciun wceq cB vz cv vy cv csuc wceq vy vz copab cA crdg cfv vx
      cB vx cv vz cv vy cv csuc wceq vy vz copab cA crdg cfv ciun wceq wb cB
      wlim cA con0 wcel cB con0 wcel wa cA cB coa co cB vz cv vy cv csuc wceq
      vy vz copab cA crdg cfv vx cB cA vx cv coa co ciun vx cB vx cv vz cv vy
      cv csuc wceq vy vz copab cA crdg cfv ciun vy vz cA cB oav cA con0 wcel cB
      con0 wcel wa vx cB cA vx cv coa co vx cv vz cv vy cv csuc wceq vy vz
      copab cA crdg cfv cA con0 wcel cB con0 wcel vx cv cB wcel cA vx cv coa co
      vx cv vz cv vy cv csuc wceq vy vz copab cA crdg cfv wceq cA con0 wcel vx
      cv con0 wcel cA vx cv coa co vx cv vz cv vy cv csuc wceq vy vz copab cA
      crdg cfv wceq cB con0 wcel vx cv cB wcel wa vy vz cA vx cv oav cB vx cv
      onelon sylan2 anassrs iuneq2dv eqeq12d adantrr mpbird cB cC wcel cB wlim
      wa cB con0 wcel cB wlim cB cC limelon cB cC wcel cB wlim pm3.27 jca
      sylan2 $.
      $( [5-Aug-2004] $) $( [3-Aug-2004] $)

    $( Ordinal multiplication with a limit ordinal.  Definition 8.15 of
       [TakeutiZaring] p. 62. $)
    omlim $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) ->
                ( A .o B ) = U_ x e. B ( A .o x ) ) $=
      cA con0 wcel cB con0 wcel cB wlim wa cA cB comu co vx cB cA vx cv comu co
      ciun wceq cB cC wcel cB wlim wa cA con0 wcel cB con0 wcel cB wlim wa wa
      cA cB comu co vx cB cA vx cv comu co ciun wceq cB vz cv vy cv cA coa co
      wceq vy vz copab c0 crdg cfv vx cB vx cv vz cv vy cv cA coa co wceq vy vz
      copab c0 crdg cfv ciun wceq cB con0 wcel cB wlim wa cB vz cv vy cv cA coa
      co wceq vy vz copab c0 crdg cfv vx cB vx cv vz cv vy cv cA coa co wceq vy
      vz copab c0 crdg cfv ciun wceq cA con0 wcel vx c0 cB con0 vz cv vy cv cA
      coa co wceq vy vz copab rdglim2a adantl cA con0 wcel cB con0 wcel cA cB
      comu co vx cB cA vx cv comu co ciun wceq cB vz cv vy cv cA coa co wceq vy
      vz copab c0 crdg cfv vx cB vx cv vz cv vy cv cA coa co wceq vy vz copab
      c0 crdg cfv ciun wceq wb cB wlim cA con0 wcel cB con0 wcel wa cA cB comu
      co cB vz cv vy cv cA coa co wceq vy vz copab c0 crdg cfv vx cB cA vx cv
      comu co ciun vx cB vx cv vz cv vy cv cA coa co wceq vy vz copab c0 crdg
      cfv ciun vy vz cA cB omv cA con0 wcel cB con0 wcel wa vx cB cA vx cv comu
      co vx cv vz cv vy cv cA coa co wceq vy vz copab c0 crdg cfv cA con0 wcel
      cB con0 wcel vx cv cB wcel cA vx cv comu co vx cv vz cv vy cv cA coa co
      wceq vy vz copab c0 crdg cfv wceq cA con0 wcel vx cv con0 wcel cA vx cv
      comu co vx cv vz cv vy cv cA coa co wceq vy vz copab c0 crdg cfv wceq cB
      con0 wcel vx cv cB wcel wa vy vz cA vx cv omv cB vx cv onelon sylan2
      anassrs iuneq2dv eqeq12d adantrr mpbird cB cC wcel cB wlim wa cB con0
      wcel cB wlim cB cC limelon cB cC wcel cB wlim pm3.27 jca sylan2 $.
      $( [5-Aug-2004] $) $( [3-Aug-2004] $)

    $( Ordinal exponentiation with a limit exponent and nonzero mantissa.
       Definition 8.30 of [TakeutiZaring] p. 67. $)
    oelim $p |- ( ( ( A e. On /\ ( B e. C /\ Lim B ) ) /\ (/) e. A ) ->
                ( A ^o B ) = U_ x e. B ( A ^o x ) ) $=
      cA con0 wcel cB con0 wcel cB wlim wa c0 cA wcel cA cB coe co vx cB cA vx
      cv coe co ciun wceq cB cC wcel cB wlim wa cA con0 wcel cB con0 wcel cB
      wlim wa wa c0 cA wcel wa cA cB coe co vx cB cA vx cv coe co ciun wceq cB
      vz cv vy cv cA comu co wceq vy vz copab c1o crdg cfv vx cB vx cv vz cv vy
      cv cA comu co wceq vy vz copab c1o crdg cfv ciun wceq cB con0 wcel cB
      wlim wa cB vz cv vy cv cA comu co wceq vy vz copab c1o crdg cfv vx cB vx
      cv vz cv vy cv cA comu co wceq vy vz copab c1o crdg cfv ciun wceq cA con0
      wcel c0 cA wcel vx c1o cB con0 vz cv vy cv cA comu co wceq vy vz copab
      rdglim2a ad2antlr cA con0 wcel cB con0 wcel c0 cA wcel cA cB coe co vx cB
      cA vx cv coe co ciun wceq cB vz cv vy cv cA comu co wceq vy vz copab c1o
      crdg cfv vx cB vx cv vz cv vy cv cA comu co wceq vy vz copab c1o crdg cfv
      ciun wceq wb cB wlim cA con0 wcel cB con0 wcel wa c0 cA wcel wa cA cB coe
      co cB vz cv vy cv cA comu co wceq vy vz copab c1o crdg cfv vx cB cA vx cv
      coe co ciun vx cB vx cv vz cv vy cv cA comu co wceq vy vz copab c1o crdg
      cfv ciun vy vz cA cB oevn0 cA con0 wcel cB con0 wcel wa c0 cA wcel wa vx
      cB cA vx cv coe co vx cv vz cv vy cv cA comu co wceq vy vz copab c1o crdg
      cfv cA con0 wcel cB con0 wcel c0 cA wcel vx cv cB wcel cA vx cv coe co vx
      cv vz cv vy cv cA comu co wceq vy vz copab c1o crdg cfv wceq cA con0 wcel
      cB con0 wcel vx cv cB wcel c0 cA wcel cA vx cv coe co vx cv vz cv vy cv
      cA comu co wceq vy vz copab c1o crdg cfv wceq cA con0 wcel cB con0 wcel
      vx cv cB wcel c0 cA wcel cA vx cv coe co vx cv vz cv vy cv cA comu co
      wceq vy vz copab c1o crdg cfv wceq cA con0 wcel vx cv con0 wcel c0 cA
      wcel cA vx cv coe co vx cv vz cv vy cv cA comu co wceq vy vz copab c1o
      crdg cfv wceq cB con0 wcel vx cv cB wcel wa vy vz cA vx cv oevn0 cB vx cv
      onelon sylanl2 exp42 com34 imp41 iuneq2dv eqeq12d adantlrr mpbird cB cC
      wcel cB wlim wa cB con0 wcel cB wlim cB cC limelon cB cC wcel cB wlim
      pm3.27 jca sylanl2 $.
      $( [5-Jan-2005] $) $( [1-Jan-2005] $)
  $}

  ${
    $d x y A $.  $d x B $.
    $( Closure law for ordinal addition.  Proposition 8.2 of [TakeutiZaring]
       p. 57. $)
    oacl $p |- ( ( A e. On /\ B e. On ) -> ( A +o B ) e. On ) $=
      cB con0 wcel cA con0 wcel cA cB coa co con0 wcel cA vx cv coa co con0
      wcel cA c0 coa co con0 wcel cA vy cv coa co con0 wcel cA vy cv csuc coa
      co con0 wcel cA cB coa co con0 wcel vx vy cB cA con0 wcel vx cv c0 wceq
      cA vx cv coa co cA c0 coa co con0 vx cv c0 cA coa opreq2 eleq1d vx cv vy
      cv wceq cA vx cv coa co cA vy cv coa co con0 vx cv vy cv cA coa opreq2
      eleq1d vx cv vy cv csuc wceq cA vx cv coa co cA vy cv csuc coa co con0 vx
      cv vy cv csuc cA coa opreq2 eleq1d vx cv cB wceq cA vx cv coa co cA cB
      coa co con0 vx cv cB cA coa opreq2 eleq1d cA con0 wcel cA c0 coa co con0
      wcel cA con0 wcel cA c0 coa co cA con0 cA oa0 eleq1d ibir cA con0 wcel vy
      cv con0 wcel cA vy cv coa co con0 wcel cA vy cv csuc coa co con0 wcel wi
      cA con0 wcel vy cv con0 wcel wa cA vy cv csuc coa co con0 wcel cA vy cv
      coa co csuc con0 wcel cA vy cv coa co con0 wcel cA con0 wcel vy cv con0
      wcel wa cA vy cv csuc coa co cA vy cv coa co csuc con0 cA vy cv oasuc
      eleq1d cA vy cv coa co suceloni syl5bir expcom cA con0 wcel vx cv wlim cA
      vy cv coa co con0 wcel vy vx cv wral cA vx cv coa co con0 wcel wi cA con0
      wcel vx cv wlim wa cA vx cv coa co con0 wcel vy vx cv cA vy cv coa co
      ciun con0 wcel cA vy cv coa co con0 wcel vy vx cv wral cA con0 wcel vx cv
      wlim wa cA vx cv coa co vy vx cv cA vy cv coa co ciun con0 cA con0 wcel
      vx cv cvv wcel vx cv wlim cA vx cv coa co vy vx cv cA vy cv coa co ciun
      wceq vx visset vy cA vx cv cvv oalim mpanr1 eleq1d vy vx cv cA vy cv coa
      co vx visset cA vy cv coa oprex iunon syl5bir expcom tfinds3 impcom $.
      $( [5-May-1995] $)

    $( Closure law for ordinal multiplication.  Proposition 8.16 of
       [TakeutiZaring] p. 57. $)
    omcl $p |- ( ( A e. On /\ B e. On ) -> ( A .o B ) e. On ) $=
      cB con0 wcel cA con0 wcel cA cB comu co con0 wcel cA vx cv comu co con0
      wcel cA c0 comu co con0 wcel cA vy cv comu co con0 wcel cA vy cv csuc
      comu co con0 wcel cA cB comu co con0 wcel vx vy cB cA con0 wcel vx cv c0
      wceq cA vx cv comu co cA c0 comu co con0 vx cv c0 cA comu opreq2 eleq1d
      vx cv vy cv wceq cA vx cv comu co cA vy cv comu co con0 vx cv vy cv cA
      comu opreq2 eleq1d vx cv vy cv csuc wceq cA vx cv comu co cA vy cv csuc
      comu co con0 vx cv vy cv csuc cA comu opreq2 eleq1d vx cv cB wceq cA vx
      cv comu co cA cB comu co con0 vx cv cB cA comu opreq2 eleq1d cA con0 wcel
      cA c0 comu co c0 con0 cA om0 0elon syl6eqel cA con0 wcel cA vy cv comu co
      con0 wcel vy cv con0 wcel cA vy cv csuc comu co con0 wcel cA con0 wcel cA
      vy cv comu co con0 wcel vy cv con0 wcel cA vy cv csuc comu co con0 wcel
      wi wi cA con0 wcel vy cv con0 wcel cA vy cv comu co con0 wcel cA con0
      wcel cA vy cv csuc comu co con0 wcel cA con0 wcel vy cv con0 wcel cA vy
      cv comu co con0 wcel cA con0 wcel cA vy cv csuc comu co con0 wcel cA con0
      wcel vy cv con0 wcel wa cA vy cv csuc comu co con0 wcel cA vy cv comu co
      cA coa co con0 wcel cA vy cv comu co con0 wcel cA con0 wcel wa cA con0
      wcel vy cv con0 wcel wa cA vy cv csuc comu co cA vy cv comu co cA coa co
      con0 cA vy cv omsuc eleq1d cA vy cv comu co cA oacl syl5bir exp4b com24
      pm2.43i com3r vx cv wlim cA con0 wcel cA vy cv comu co con0 wcel vy vx cv
      wral cA vx cv comu co con0 wcel wi vx cv wlim cA con0 wcel wa cA vx cv
      comu co con0 wcel vy vx cv cA vy cv comu co ciun con0 wcel cA vy cv comu
      co con0 wcel vy vx cv wral vx cv wlim cA con0 wcel wa cA vx cv comu co vy
      vx cv cA vy cv comu co ciun con0 cA con0 wcel vx cv wlim cA vx cv comu co
      vy vx cv cA vy cv comu co ciun wceq cA con0 wcel vx cv cvv wcel vx cv
      wlim cA vx cv comu co vy vx cv cA vy cv comu co ciun wceq vx visset vy cA
      vx cv cvv omlim mpanr1 ancoms eleq1d vy vx cv cA vy cv comu co vx visset
      cA vy cv comu oprex iunon syl5bir ex tfinds3 impcom $.
      $( [6-Aug-2004] $) $( [3-Aug-2004] $)

    $( Closure law for ordinal exponentiation. $)
    oecl $p |- ( ( A e. On /\ B e. On ) -> ( A ^o B ) e. On ) $=
      cB con0 wcel cA cB coe co con0 wcel cA cA c0 wceq cB con0 wcel cA cB coe
      co con0 wcel cA c0 wceq cA cB coe co con0 wcel c0 cB coe co con0 wcel cB
      con0 wcel cA c0 wceq cA cB coe co c0 cB coe co con0 cA c0 cB coe opreq1
      eleq1d cB con0 wcel c0 cB coe co con0 wcel cB con0 wcel c0 cB coe co con0
      wcel cB cB c0 wceq c0 cB coe co con0 wcel cB con0 wcel cB c0 wceq c0 cB
      coe co c0 c0 coe co con0 cB c0 c0 coe opreq2 c0 c0 coe co c1o con0 oe0m0
      1on eqeltri syl6eqel adantl cB con0 wcel c0 cB wcel c0 cB coe co con0
      wcel cB con0 wcel cB con0 wcel c0 cB wcel wa c0 cB coe co c0 con0 cB con0
      wcel c0 cB wcel c0 cB coe co c0 wceq cB oe0m1 biimpa 0elon syl6eqel
      adantll oe0lem anidms syl5bir impcom cA con0 wcel cB con0 wcel c0 cA wcel
      cA cB coe co con0 wcel cB con0 wcel cA con0 wcel c0 cA wcel cA cB coe co
      con0 wcel wi cB con0 wcel cA con0 wcel c0 cA wcel cA cB coe co con0 wcel
      cA vx cv coe co con0 wcel cA c0 coe co con0 wcel cA vy cv coe co con0
      wcel cA vy cv csuc coe co con0 wcel cA cB coe co con0 wcel vx vy cB cA
      con0 wcel c0 cA wcel wa vx cv c0 wceq cA vx cv coe co cA c0 coe co con0
      vx cv c0 cA coe opreq2 eleq1d vx cv vy cv wceq cA vx cv coe co cA vy cv
      coe co con0 vx cv vy cv cA coe opreq2 eleq1d vx cv vy cv csuc wceq cA vx
      cv coe co cA vy cv csuc coe co con0 vx cv vy cv csuc cA coe opreq2 eleq1d
      vx cv cB wceq cA vx cv coe co cA cB coe co con0 vx cv cB cA coe opreq2
      eleq1d cA con0 wcel cA c0 coe co con0 wcel c0 cA wcel cA con0 wcel cA c0
      coe co c1o con0 cA oe0 1on syl6eqel adantr vy cv con0 wcel cA con0 wcel
      cA vy cv coe co con0 wcel cA vy cv csuc coe co con0 wcel wi c0 cA wcel cA
      con0 wcel cA vy cv coe co con0 wcel vy cv con0 wcel cA vy cv csuc coe co
      con0 wcel cA con0 wcel cA vy cv coe co con0 wcel vy cv con0 wcel cA vy cv
      csuc coe co con0 wcel wi wi cA con0 wcel vy cv con0 wcel cA vy cv coe co
      con0 wcel cA con0 wcel cA vy cv csuc coe co con0 wcel cA con0 wcel vy cv
      con0 wcel cA vy cv coe co con0 wcel cA con0 wcel cA vy cv csuc coe co
      con0 wcel cA con0 wcel vy cv con0 wcel wa cA vy cv csuc coe co con0 wcel
      cA vy cv coe co cA comu co con0 wcel cA vy cv coe co con0 wcel cA con0
      wcel wa cA con0 wcel vy cv con0 wcel wa cA vy cv csuc coe co cA vy cv coe
      co cA comu co con0 cA vy cv oesuc eleq1d cA vy cv coe co cA omcl syl5bir
      exp4b com24 pm2.43i com3r adantrd vx cv wlim cA con0 wcel c0 cA wcel wa
      cA vy cv coe co con0 wcel vy vx cv wral cA vx cv coe co con0 wcel wi vx
      cv wlim cA con0 wcel c0 cA wcel wa wa cA vx cv coe co con0 wcel vy vx cv
      cA vy cv coe co ciun con0 wcel cA vy cv coe co con0 wcel vy vx cv wral vx
      cv wlim cA con0 wcel c0 cA wcel wa wa cA vx cv coe co vy vx cv cA vy cv
      coe co ciun con0 cA con0 wcel vx cv wlim c0 cA wcel cA vx cv coe co vy vx
      cv cA vy cv coe co ciun wceq cA con0 wcel vx cv wlim c0 cA wcel cA vx cv
      coe co vy vx cv cA vy cv coe co ciun wceq cA con0 wcel vx cv cvv wcel vx
      cv wlim c0 cA wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq vx
      visset vy cA vx cv cvv oelim mpanlr1 anasss an1s eleq1d vy vx cv cA vy cv
      coe co vx visset cA vy cv coe oprex iunon syl5bir ex tfinds3 exp3a com12
      imp31 oe0lem $.
      $( [21-Jul-2006] $) $( [1-Jan-2005] $)
  $}

  ${
    $d x y $.  $d x A $.
    $( Ordinal addition with zero.  Proposition 8.3 of [TakeutiZaring]
       p. 57. $)
    oa0r $p |- ( A e. On -> ( (/) +o A ) = A ) $=
      c0 vx cv coa co vx cv wceq c0 c0 coa co c0 wceq c0 vy cv coa co vy cv
      wceq c0 vy cv csuc coa co vy cv csuc wceq c0 cA coa co cA wceq vx vy cA
      vx cv c0 wceq c0 vx cv coa co c0 c0 coa co vx cv c0 vx cv c0 c0 coa
      opreq2 vx cv c0 wceq id eqeq12d vx cv vy cv wceq c0 vx cv coa co c0 vy cv
      coa co vx cv vy cv vx cv vy cv c0 coa opreq2 vx cv vy cv wceq id eqeq12d
      vx cv vy cv csuc wceq c0 vx cv coa co c0 vy cv csuc coa co vx cv vy cv
      csuc vx cv vy cv csuc c0 coa opreq2 vx cv vy cv csuc wceq id eqeq12d vx
      cv cA wceq c0 vx cv coa co c0 cA coa co vx cv cA vx cv cA c0 coa opreq2
      vx cv cA wceq id eqeq12d c0 con0 wcel c0 c0 coa co c0 wceq 0elon c0 oa0
      ax-mp vy cv con0 wcel c0 vy cv coa co vy cv wceq c0 vy cv csuc coa co vy
      cv csuc wceq vy cv con0 wcel c0 vy cv coa co vy cv wceq c0 vy cv csuc coa
      co c0 vy cv coa co csuc vy cv csuc c0 con0 wcel vy cv con0 wcel c0 vy cv
      csuc coa co c0 vy cv coa co csuc wceq 0elon c0 vy cv oasuc mpan c0 vy cv
      coa co vy cv suceq sylan9eq ex vx cv wlim c0 vx cv coa co vx cv wceq vy
      vx cv c0 vy cv coa co ciun vx cv cuni wceq c0 vy cv coa co vy cv wceq vy
      vx cv wral vx cv wlim c0 vx cv coa co vy vx cv c0 vy cv coa co ciun vx cv
      vx cv cuni vx cv cvv wcel vx cv wlim c0 vx cv coa co vy vx cv c0 vy cv
      coa co ciun wceq vx visset c0 con0 wcel vx cv cvv wcel vx cv wlim wa c0
      vx cv coa co vy vx cv c0 vy cv coa co ciun wceq 0elon vy c0 vx cv cvv
      oalim mpan mpan vx cv limuni eqeq12d c0 vy cv coa co vy cv wceq vy vx cv
      wral vy vx cv c0 vy cv coa co ciun vy vx cv vy cv ciun vx cv cuni vy vx
      cv c0 vy cv coa co vy cv iuneq2 vy vx cv uniiun syl6eqr syl5bir tfinds $.
      $( [5-May-1995] $)
  $}

  ${
    $d x y A $.
    $( Ordinal multiplication with zero.  Proposition 8.18(1) of
       [TakeutiZaring] p. 63. $)
    om0r $p |- ( A e. On -> ( (/) .o A ) = (/) ) $=
      c0 vx cv comu co c0 wceq c0 c0 comu co c0 wceq c0 vy cv comu co c0 wceq
      c0 vy cv csuc comu co c0 wceq c0 cA comu co c0 wceq vx vy cA vx cv c0
      wceq c0 vx cv comu co c0 c0 comu co c0 vx cv c0 c0 comu opreq2 eqeq1d vx
      cv vy cv wceq c0 vx cv comu co c0 vy cv comu co c0 vx cv vy cv c0 comu
      opreq2 eqeq1d vx cv vy cv csuc wceq c0 vx cv comu co c0 vy cv csuc comu
      co c0 vx cv vy cv csuc c0 comu opreq2 eqeq1d vx cv cA wceq c0 vx cv comu
      co c0 cA comu co c0 vx cv cA c0 comu opreq2 eqeq1d c0 con0 wcel c0 c0
      comu co c0 wceq 0elon c0 om0 ax-mp vy cv con0 wcel c0 vy cv csuc comu co
      c0 wceq c0 vy cv comu co c0 coa co c0 c0 coa co wceq c0 vy cv comu co c0
      wceq vy cv con0 wcel c0 vy cv csuc comu co c0 vy cv comu co c0 coa co c0
      c0 c0 coa co c0 con0 wcel vy cv con0 wcel c0 vy cv csuc comu co c0 vy cv
      comu co c0 coa co wceq 0elon c0 vy cv omsuc mpan c0 c0 c0 coa co wceq vy
      cv con0 wcel c0 c0 coa co c0 c0 con0 wcel c0 c0 coa co c0 wceq 0elon c0
      oa0 ax-mp eqcomi a1i eqeq12d c0 vy cv comu co c0 c0 coa opreq1 syl5bir vx
      cv wlim c0 vx cv comu co c0 wceq vy vx cv c0 vy cv comu co ciun c0 wceq
      c0 vy cv comu co c0 wceq vy vx cv wral vx cv wlim c0 vx cv comu co vy vx
      cv c0 vy cv comu co ciun c0 vx cv cvv wcel vx cv wlim c0 vx cv comu co vy
      vx cv c0 vy cv comu co ciun wceq vx visset c0 con0 wcel vx cv cvv wcel vx
      cv wlim wa c0 vx cv comu co vy vx cv c0 vy cv comu co ciun wceq 0elon vy
      c0 vx cv cvv omlim mpan mpan eqeq1d c0 vy cv comu co c0 wceq vy vx cv
      wral vy vx cv c0 vy cv comu co ciun vy vx cv c0 ciun c0 vy vx cv c0 vy cv
      comu co c0 iuneq2 vy vx cv iun0 syl6eq syl5bir tfinds $.
      $( [5-Aug-2004] $) $( [3-Aug-2004] $)
  $}

  $( 1 + 1 = 2 for ordinal numbers. $)
  o1p1e2 $p |- ( 1o +o 1o ) = 2o $=
    c1o c1o coa co c1o csuc c2o c1o con0 wcel c1o c1o coa co c1o csuc wceq 1on
    c1o oa1suc ax-mp df-2o eqtr4i $.
    $( [19-Feb-2004] $) $( [18-Feb-2004] $)

  $( Ordinal multiplication with 1.  Proposition 8.18(2) of [TakeutiZaring]
     p. 63. $)
  om1 $p |- ( A e. On -> ( A .o 1o ) = A ) $=
    cA con0 wcel cA c1o comu co cA c0 comu co cA coa co c0 cA coa co cA cA con0
    wcel cA c0 csuc comu co cA c0 comu co cA coa co cA c1o comu co cA con0 wcel
    c0 con0 wcel cA c0 csuc comu co cA c0 comu co cA coa co wceq 0elon cA c0
    omsuc mpan2 c1o c0 csuc cA comu df-1o opreq2i syl5eq cA con0 wcel cA c0
    comu co c0 cA coa cA om0 opreq1d cA oa0r 3eqtrd $.
    $( [29-Oct-1995] $)

  ${
    $d x y $.  $d x A $.
    $( Ordinal multiplication with 1.  Proposition 8.18(2) of [TakeutiZaring]
       p. 63. $)
    om1r $p |- ( A e. On -> ( 1o .o A ) = A ) $=
      c1o vx cv comu co vx cv wceq c1o c0 comu co c0 wceq c1o vy cv comu co vy
      cv wceq c1o vy cv csuc comu co vy cv csuc wceq c1o cA comu co cA wceq vx
      vy cA vx cv c0 wceq c1o vx cv comu co c1o c0 comu co vx cv c0 vx cv c0
      c1o comu opreq2 vx cv c0 wceq id eqeq12d vx cv vy cv wceq c1o vx cv comu
      co c1o vy cv comu co vx cv vy cv vx cv vy cv c1o comu opreq2 vx cv vy cv
      wceq id eqeq12d vx cv vy cv csuc wceq c1o vx cv comu co c1o vy cv csuc
      comu co vx cv vy cv csuc vx cv vy cv csuc c1o comu opreq2 vx cv vy cv
      csuc wceq id eqeq12d vx cv cA wceq c1o vx cv comu co c1o cA comu co vx cv
      cA vx cv cA c1o comu opreq2 vx cv cA wceq id eqeq12d c1o con0 wcel c1o c0
      comu co c0 wceq 1on c1o om0 ax-mp vy cv con0 wcel c1o vy cv comu co vy cv
      wceq c1o vy cv csuc comu co vy cv csuc wceq vy cv con0 wcel c1o vy cv
      comu co vy cv wceq wa c1o vy cv csuc comu co vy cv c1o coa co vy cv csuc
      vy cv con0 wcel c1o vy cv comu co vy cv wceq c1o vy cv csuc comu co c1o
      vy cv comu co c1o coa co vy cv c1o coa co c1o con0 wcel vy cv con0 wcel
      c1o vy cv csuc comu co c1o vy cv comu co c1o coa co wceq 1on c1o vy cv
      omsuc mpan c1o vy cv comu co vy cv c1o coa opreq1 sylan9eq vy cv con0
      wcel vy cv c1o coa co vy cv csuc wceq c1o vy cv comu co vy cv wceq vy cv
      oa1suc adantr eqtrd ex vx cv wlim c1o vx cv comu co vx cv wceq vy vx cv
      c1o vy cv comu co ciun vx cv cuni wceq c1o vy cv comu co vy cv wceq vy vx
      cv wral vx cv wlim c1o vx cv comu co vy vx cv c1o vy cv comu co ciun vx
      cv vx cv cuni vx cv cvv wcel vx cv wlim c1o vx cv comu co vy vx cv c1o vy
      cv comu co ciun wceq vx visset c1o con0 wcel vx cv cvv wcel vx cv wlim wa
      c1o vx cv comu co vy vx cv c1o vy cv comu co ciun wceq 1on vy c1o vx cv
      cvv omlim mpan mpan vx cv limuni eqeq12d c1o vy cv comu co vy cv wceq vy
      vx cv wral vy vx cv c1o vy cv comu co ciun vy vx cv vy cv ciun vx cv cuni
      vy vx cv c1o vy cv comu co vy cv iuneq2 vy vx cv uniiun syl6eqr syl5bir
      tfinds $.
      $( [7-Aug-2004] $) $( [3-Aug-2004] $)
  $}

  $( Ordinal exponentiation with an exponent of 1. $)
  oe1 $p |- ( A e. On -> ( A ^o 1o ) = A ) $=
    cA con0 wcel cA c1o coe co cA c0 coe co cA comu co c1o cA comu co cA cA
    con0 wcel cA c0 csuc coe co cA c0 coe co cA comu co cA c1o coe co cA con0
    wcel c0 con0 wcel cA c0 csuc coe co cA c0 coe co cA comu co wceq 0elon cA
    c0 oesuc mpan2 c1o c0 csuc cA coe df-1o opreq2i syl5eq cA con0 wcel cA c0
    coe co c1o cA comu cA oe0 opreq1d cA om1r 3eqtrd $.
    $( [8-Jan-2005] $) $( [2-Jan-2005] $)

  ${
    $d x y $.  $d x A $.
    $( Ordinal exponentiation with a mantissa of 1.  Proposition 8.31(3) of
       [TakeutiZaring] p. 67. $)
    oe1m $p |- ( A e. On -> ( 1o ^o A ) = 1o ) $=
      c1o vx cv coe co c1o wceq c1o c0 coe co c1o wceq c1o vy cv coe co c1o
      wceq c1o vy cv csuc coe co c1o wceq c1o cA coe co c1o wceq vx vy cA vx cv
      c0 wceq c1o vx cv coe co c1o c0 coe co c1o vx cv c0 c1o coe opreq2 eqeq1d
      vx cv vy cv wceq c1o vx cv coe co c1o vy cv coe co c1o vx cv vy cv c1o
      coe opreq2 eqeq1d vx cv vy cv csuc wceq c1o vx cv coe co c1o vy cv csuc
      coe co c1o vx cv vy cv csuc c1o coe opreq2 eqeq1d vx cv cA wceq c1o vx cv
      coe co c1o cA coe co c1o vx cv cA c1o coe opreq2 eqeq1d c1o con0 wcel c1o
      c0 coe co c1o wceq 1on c1o oe0 ax-mp vy cv con0 wcel c1o vy cv coe co c1o
      wceq c1o vy cv csuc coe co c1o wceq vy cv con0 wcel c1o vy cv coe co c1o
      wceq c1o vy cv csuc coe co c1o vy cv coe co c1o comu co c1o c1o con0 wcel
      vy cv con0 wcel c1o vy cv csuc coe co c1o vy cv coe co c1o comu co wceq
      1on c1o vy cv oesuc mpan c1o vy cv coe co c1o wceq c1o vy cv coe co c1o
      comu co c1o c1o comu co c1o c1o vy cv coe co c1o c1o comu opreq1 c1o con0
      wcel c1o c1o comu co c1o wceq 1on c1o om1 ax-mp syl6eq sylan9eq ex vx cv
      wlim c1o vx cv coe co c1o wceq vy vx cv c1o vy cv coe co ciun vy vx cv
      c1o ciun wceq c1o vy cv coe co c1o wceq vy vx cv wral vx cv wlim c1o vx
      cv coe co c1o wceq vy vx cv c1o vy cv coe co ciun c1o wceq vy vx cv c1o
      vy cv coe co ciun vy vx cv c1o ciun wceq vx cv wlim c1o vx cv coe co vy
      vx cv c1o vy cv coe co ciun c1o vx cv cvv wcel vx cv wlim c1o vx cv coe
      co vy vx cv c1o vy cv coe co ciun wceq vx visset c1o con0 wcel vx cv cvv
      wcel vx cv wlim wa c1o vx cv coe co vy vx cv c1o vy cv coe co ciun wceq
      1on c1o con0 wcel vx cv cvv wcel vx cv wlim wa wa c0 c1o wcel c1o vx cv
      coe co vy vx cv c1o vy cv coe co ciun wceq 0lt1o vy c1o vx cv cvv oelim
      mpan2 mpan mpan eqeq1d vx cv wlim vy vx cv c1o ciun c1o vy vx cv c1o vy
      cv coe co ciun vx cv wlim c0 vx cv wcel vx cv c0 wne vy vx cv c1o ciun
      c1o wceq vx cv 0ellim vx cv c0 ne0i vy vx cv c1o iunconst 3syl eqeq2d
      bitr4d vy vx cv c1o vy cv coe co c1o iuneq2 syl5bir tfinds $.
      $( [8-Jan-2005] $) $( [2-Jan-2005] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Ordering property of ordinal addition.  Proposition 8.4 of
       [TakeutiZaring] p. 58. $)
    oaordi $p |- ( ( B e. On /\ C e. On ) ->
                 ( A e. B -> ( C +o A ) e. ( C +o B ) ) ) $=
      cC con0 wcel cB con0 wcel cA cB wcel cC cA coa co cC cB coa co wcel wi cC
      con0 wcel cB con0 wcel wa cA cB wcel cC cA coa co cC cB coa co wcel cC
      con0 wcel cB con0 wcel wa cA cB wcel wa cA con0 wcel cC cA coa co cC cB
      coa co wcel cB con0 wcel cA cB wcel cA con0 wcel cC con0 wcel cB cA
      onelon adantll cC con0 wcel cB con0 wcel wa cA con0 wcel cA cB wcel cC cA
      coa co cC cB coa co wcel cC con0 wcel cB con0 wcel wa cA con0 wcel wa cA
      cB wcel cC cA coa co cC cB coa co wcel cC con0 wcel cB con0 wcel wa cA
      con0 wcel wa cA cB wcel cA csuc cB wss cC cA csuc coa co cC cB coa co wss
      cC cA coa co cC cB coa co wcel cB con0 wcel cA cB wcel cA csuc cB wss wi
      cC con0 wcel cA con0 wcel cB con0 wcel cB word cA cB wcel cA csuc cB wss
      wi cB eloni cA cB ordsucss syl ad2antlr cC con0 wcel cB con0 wcel cA con0
      wcel cA csuc cB wss cC cA csuc coa co cC cB coa co wss wi cB con0 wcel cA
      con0 wcel cA csuc cB wss cC con0 wcel cC cA csuc coa co cC cB coa co wss
      cB con0 wcel cA csuc con0 wcel cA csuc cB wss cC con0 wcel cC cA csuc coa
      co cC cB coa co wss wi wi cA con0 wcel cB con0 wcel cA csuc con0 wcel cA
      csuc cB wss cC con0 wcel cC cA csuc coa co cC cB coa co wss wi cC con0
      wcel cC cA csuc coa co cC vx cv coa co wss wi cC con0 wcel cC cA csuc coa
      co cC cA csuc coa co wss wi cC con0 wcel cC cA csuc coa co cC vy cv coa
      co wss wi cC con0 wcel cC cA csuc coa co cC vy cv csuc coa co wss wi cC
      con0 wcel cC cA csuc coa co cC cB coa co wss wi vx vy cB cA csuc vx cv cA
      csuc wceq cC cA csuc coa co cC vx cv coa co wss cC cA csuc coa co cC cA
      csuc coa co wss cC con0 wcel vx cv cA csuc wceq cC vx cv coa co cC cA
      csuc coa co cC cA csuc coa co vx cv cA csuc cC coa opreq2 sseq2d imbi2d
      vx cv vy cv wceq cC cA csuc coa co cC vx cv coa co wss cC cA csuc coa co
      cC vy cv coa co wss cC con0 wcel vx cv vy cv wceq cC vx cv coa co cC vy
      cv coa co cC cA csuc coa co vx cv vy cv cC coa opreq2 sseq2d imbi2d vx cv
      vy cv csuc wceq cC cA csuc coa co cC vx cv coa co wss cC cA csuc coa co
      cC vy cv csuc coa co wss cC con0 wcel vx cv vy cv csuc wceq cC vx cv coa
      co cC vy cv csuc coa co cC cA csuc coa co vx cv vy cv csuc cC coa opreq2
      sseq2d imbi2d vx cv cB wceq cC cA csuc coa co cC vx cv coa co wss cC cA
      csuc coa co cC cB coa co wss cC con0 wcel vx cv cB wceq cC vx cv coa co
      cC cB coa co cC cA csuc coa co vx cv cB cC coa opreq2 sseq2d imbi2d cA
      csuc con0 wcel cC con0 wcel cC cA csuc coa co cC cA csuc coa co wss cC cA
      csuc coa co ssid a1i12 vy cv con0 wcel cA csuc con0 wcel wa cA csuc vy cv
      wss wa cC con0 wcel cC cA csuc coa co cC vy cv coa co wss cC cA csuc coa
      co cC vy cv csuc coa co wss vy cv con0 wcel cC con0 wcel cC cA csuc coa
      co cC vy cv coa co wss cC cA csuc coa co cC vy cv csuc coa co wss wi wi
      cA csuc con0 wcel cA csuc vy cv wss vy cv con0 wcel cC con0 wcel cC cA
      csuc coa co cC vy cv coa co wss cC cA csuc coa co cC vy cv csuc coa co
      wss wi vy cv con0 wcel cC con0 wcel wa cC cA csuc coa co cC vy cv csuc
      coa co wss cC cA csuc coa co cC vy cv coa co csuc wss cC cA csuc coa co
      cC vy cv coa co wss vy cv con0 wcel cC con0 wcel wa cC vy cv csuc coa co
      cC vy cv coa co csuc cC cA csuc coa co cC con0 wcel vy cv con0 wcel cC vy
      cv csuc coa co cC vy cv coa co csuc wceq cC vy cv oasuc ancoms sseq2d cC
      cA csuc coa co cC vy cv coa co wss cC vy cv coa co cC vy cv coa co csuc
      wss cC cA csuc coa co cC vy cv coa co csuc wss cC vy cv coa co sssucid cC
      cA csuc coa co cC vy cv coa co cC vy cv coa co csuc sstr2 mpi syl5bir ex
      ad2antrr a2d vx cv wlim cA csuc con0 wcel wa cA csuc vx cv wss wa cC con0
      wcel cC cA csuc coa co cC vx cv coa co wss wi cA csuc vy cv wss cC con0
      wcel cC cA csuc coa co cC vy cv coa co wss wi wi vy vx cv wral vx cv wlim
      cA csuc con0 wcel wa cA csuc vx cv wss wa cC con0 wcel cC cA csuc coa co
      cC vx cv coa co wss vx cv wlim cA csuc con0 wcel wa cA csuc vx cv wss wa
      cC con0 wcel wa cC cA csuc coa co vy vx cv cC vy cv coa co ciun cC vx cv
      coa co vx cv wlim cA csuc con0 wcel wa cA csuc vx cv wss wa cC cA csuc
      coa co vy vx cv cC vy cv coa co ciun wss cC con0 wcel vx cv wlim cA csuc
      con0 wcel wa cA csuc vx cv wss wa cA csuc vx cv wcel cC cA csuc coa co vy
      vx cv cC vy cv coa co ciun wss vx cv wlim cA csuc con0 wcel wa cA csuc vx
      cv wss cA csuc vx cv wcel cA csuc con0 wcel cA csuc vx cv wss cA vx cv
      wcel vx cv wlim cA csuc vx cv wcel cA csuc con0 wcel cA con0 wcel cA csuc
      vx cv wss cA vx cv wcel wi cA sucelon cA vx cv con0 sucssel sylbir vx cv
      wlim cA vx cv wcel cA csuc vx cv wcel vx cv cA limsuc biimpd sylan9r imp
      vy vx cv cC vy cv coa co cA csuc cC cA csuc coa co vy cv cA csuc cC coa
      opreq2 ssiun2s syl adantr vx cv wlim cA csuc con0 wcel wa cC con0 wcel cC
      vx cv coa co vy vx cv cC vy cv coa co ciun wceq cA csuc vx cv wss vx cv
      wlim cC con0 wcel cC vx cv coa co vy vx cv cC vy cv coa co ciun wceq cA
      csuc con0 wcel cC con0 wcel vx cv wlim cC vx cv coa co vy vx cv cC vy cv
      coa co ciun wceq cC con0 wcel vx cv cvv wcel vx cv wlim cC vx cv coa co
      vy vx cv cC vy cv coa co ciun wceq vx visset vy cC vx cv cvv oalim mpanr1
      ancoms adantlr adantlr sseqtr4d ex a1d tfindsg exp31 cA sucelon syl5ib
      com4r imp31 cC con0 wcel cA con0 wcel cC cA csuc coa co cC cB coa co wss
      cC cA coa co cC cB coa co wcel wi cB con0 wcel cC con0 wcel cA con0 wcel
      wa cC cA csuc coa co cC cB coa co wss cC cA coa co csuc cC cB coa co wss
      cC cA coa co cC cB coa co wcel cC con0 wcel cA con0 wcel wa cC cA csuc
      coa co cC cA coa co csuc cC cB coa co cC cA oasuc sseq1d cC cA coa co cvv
      wcel cC cA coa co csuc cC cB coa co wss cC cA coa co cC cB coa co wcel wi
      cC cA coa oprex cC cA coa co cC cB coa co cvv sucssel ax-mp syl6bi
      adantlr 3syld imp an1rs mpdan ex ancoms $.
      $( [7-Dec-2004] $) $( [5-Dec-2004] $)
  $}

  $( Ordering property of ordinal addition.  Proposition 8.4 of [TakeutiZaring]
     p. 58 and its converse. $)
  oaord $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A e. B <-> ( C +o A ) e. ( C +o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wcel cC cA coa co cC cB
    coa co wcel cB con0 wcel cC con0 wcel cA cB wcel cC cA coa co cC cB coa co
    wcel wi cA con0 wcel cA cB cC oaordi 3adant1 cA con0 wcel cB con0 wcel cC
    con0 wcel w3a cC cA coa co cC cB coa co wceq cC cB coa co cC cA coa co wcel
    wo wn cA cB wceq cB cA wcel wo wn cC cA coa co cC cB coa co wcel cA cB wcel
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wceq cB cA wcel wo cC cA
    coa co cC cB coa co wceq cC cB coa co cC cA coa co wcel wo cA con0 wcel cB
    con0 wcel cC con0 wcel w3a cA cB wceq cC cA coa co cC cB coa co wceq cB cA
    wcel cC cB coa co cC cA coa co wcel cA cB wceq cC cA coa co cC cB coa co
    wceq wi cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB cC coa opreq2 a1i
    cA con0 wcel cC con0 wcel cB cA wcel cC cB coa co cC cA coa co wcel wi cB
    con0 wcel cB cA cC oaordi 3adant2 orim12d con3d cA con0 wcel cB con0 wcel
    cC con0 wcel w3a cC cA coa co word cC cB coa co word wa cC cA coa co cC cB
    coa co wcel cC cA coa co cC cB coa co wceq cC cB coa co cC cA coa co wcel
    wo wn wb cA con0 wcel cB con0 wcel cC con0 wcel w3a cC con0 wcel cA con0
    wcel wa cC con0 wcel cB con0 wcel wa wa cC cA coa co word cC cB coa co word
    wa cA con0 wcel cB con0 wcel cC con0 wcel w3a cA con0 wcel cB con0 wcel wa
    cC con0 wcel wa cC con0 wcel cA con0 wcel cB con0 wcel wa wa cC con0 wcel
    cA con0 wcel wa cC con0 wcel cB con0 wcel wa wa cA con0 wcel cB con0 wcel
    cC con0 wcel df-3an cA con0 wcel cB con0 wcel wa cC con0 wcel ancom cC con0
    wcel cA con0 wcel cB con0 wcel anandi 3bitri cC con0 wcel cA con0 wcel wa
    cC cA coa co word cC con0 wcel cB con0 wcel wa cC cB coa co word cC con0
    wcel cA con0 wcel wa cC cA coa co con0 wcel cC cA coa co word cC cA oacl cC
    cA coa co eloni syl cC con0 wcel cB con0 wcel wa cC cB coa co con0 wcel cC
    cB coa co word cC cB oacl cC cB coa co eloni syl anim12i sylbi cC cA coa co
    cC cB coa co ordtri2 syl cA con0 wcel cB con0 wcel cC con0 wcel w3a cA con0
    wcel cB con0 wcel wa cA word cB word wa cA cB wcel cA cB wceq cB cA wcel wo
    wn wb cA con0 wcel cB con0 wcel cC con0 wcel 3simpa cA con0 wcel cA word cB
    con0 wcel cB word cA eloni cB eloni anim12i cA cB ordtri2 3syl 3imtr4d
    impbid $.
    $( [7-Dec-2004] $) $( [5-Dec-2004] $)

  $( Left cancellation law for ordinal addition.  Corollary 8.5 of
     [TakeutiZaring] p. 58. $)
  oacan $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                   ( ( A +o B ) = ( A +o C ) <-> B = C ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cB cC wcel cC cB wcel wo wn cA
    cB coa co cA cC coa co wcel cA cC coa co cA cB coa co wcel wo wn cB cC wceq
    cA cB coa co cA cC coa co wceq cA con0 wcel cB con0 wcel cC con0 wcel w3a
    cB cC wcel cC cB wcel wo cA cB coa co cA cC coa co wcel cA cC coa co cA cB
    coa co wcel wo cA con0 wcel cB con0 wcel cC con0 wcel w3a cB cC wcel cA cB
    coa co cA cC coa co wcel cC cB wcel cA cC coa co cA cB coa co wcel cB con0
    wcel cC con0 wcel cA con0 wcel cB cC wcel cA cB coa co cA cC coa co wcel wb
    cB cC cA oaord 3comr cC con0 wcel cB con0 wcel cA con0 wcel cC cB wcel cA
    cC coa co cA cB coa co wcel wb cC cB cA oaord 3com13 orbi12d notbid cB con0
    wcel cC con0 wcel cB cC wceq cB cC wcel cC cB wcel wo wn wb cA con0 wcel cB
    word cC word cB cC wceq cB cC wcel cC cB wcel wo wn wb cB con0 wcel cC con0
    wcel cB cC ordtri3 cB eloni cC eloni syl2an 3adant1 cA con0 wcel cB con0
    wcel cC con0 wcel cA cB coa co cA cC coa co wceq cA cB coa co cA cC coa co
    wcel cA cC coa co cA cB coa co wcel wo wn wb cA cB coa co word cA cC coa co
    word cA cB coa co cA cC coa co wceq cA cB coa co cA cC coa co wcel cA cC
    coa co cA cB coa co wcel wo wn wb cA con0 wcel cB con0 wcel wa cA con0 wcel
    cC con0 wcel wa cA cB coa co cA cC coa co ordtri3 cA con0 wcel cB con0 wcel
    wa cA cB coa co con0 wcel cA cB coa co word cA cB oacl cA cB coa co eloni
    syl cA con0 wcel cC con0 wcel wa cA cC coa co con0 wcel cA cC coa co word
    cA cC oacl cA cC coa co eloni syl syl2an 3impdi 3bitr4rd $.
    $( [7-Dec-2004] $) $( [5-Dec-2004] $)

  $( Weak ordering property of ordinal addition. $)
  oaword $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A C_ B <-> ( C +o A ) C_ ( C +o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wcel cA cB wceq wo cC cA
    coa co cC cB coa co wcel cC cA coa co cC cB coa co wceq wo cA cB wss cC cA
    coa co cC cB coa co wss cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB
    wcel cC cA coa co cC cB coa co wcel cA cB wceq cC cA coa co cC cB coa co
    wceq cA cB cC oaord cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA coa co
    cC cB coa co wceq cA cB wceq cC con0 wcel cA con0 wcel cB con0 wcel cC cA
    coa co cC cB coa co wceq cA cB wceq wb cC cA cB oacan 3coml bicomd orbi12d
    cA con0 wcel cB con0 wcel cA cB wss cA cB wcel cA cB wceq wo wb cC con0
    wcel cA cB onsseleq 3adant3 cA con0 wcel cB con0 wcel cC con0 wcel w3a cC
    cA coa co con0 wcel cC cB coa co con0 wcel wa cC cA coa co cC cB coa co wss
    cC cA coa co cC cB coa co wcel cC cA coa co cC cB coa co wceq wo wb cA con0
    wcel cB con0 wcel cC con0 wcel cC cA coa co con0 wcel cC cB coa co con0
    wcel wa cC con0 wcel cA con0 wcel cB con0 wcel wa cC cA coa co con0 wcel cC
    cB coa co con0 wcel wa cC con0 wcel cA con0 wcel cB con0 wcel cC cA coa co
    con0 wcel cC cB coa co con0 wcel wa cC con0 wcel cA con0 wcel wa cC cA coa
    co con0 wcel cC con0 wcel cB con0 wcel wa cC cB coa co con0 wcel cC cA oacl
    cC cB oacl anim12i anandis ancoms 3impa cC cA coa co cC cB coa co onsseleq
    syl 3bitr4d $.
    $( [8-Dec-2004] $) $( [6-Dec-2004] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Weak ordering property of ordinal addition.  Proposition 8.7 of
       [TakeutiZaring] p. 59. $)
    oawordri $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A C_ B -> ( A +o C ) C_ ( B +o C ) ) ) $=
      cA con0 wcel cB con0 wcel cC con0 wcel cA cB wss cA cC coa co cB cC coa
      co wss wi cC con0 wcel cA con0 wcel cB con0 wcel cA cB wss cA cC coa co
      cB cC coa co wss wi cC con0 wcel cA con0 wcel cB con0 wcel cA cB wss cA
      cC coa co cB cC coa co wss cA vx cv coa co cB vx cv coa co wss cA c0 coa
      co cB c0 coa co wss cA vy cv coa co cB vy cv coa co wss cA vy cv csuc coa
      co cB vy cv csuc coa co wss cA cC coa co cB cC coa co wss vx vy cC cA
      con0 wcel cB con0 wcel wa cA cB wss wa vx cv c0 wceq cA vx cv coa co cA
      c0 coa co cB vx cv coa co cB c0 coa co vx cv c0 cA coa opreq2 vx cv c0 cB
      coa opreq2 sseq12d vx cv vy cv wceq cA vx cv coa co cA vy cv coa co cB vx
      cv coa co cB vy cv coa co vx cv vy cv cA coa opreq2 vx cv vy cv cB coa
      opreq2 sseq12d vx cv vy cv csuc wceq cA vx cv coa co cA vy cv csuc coa co
      cB vx cv coa co cB vy cv csuc coa co vx cv vy cv csuc cA coa opreq2 vx cv
      vy cv csuc cB coa opreq2 sseq12d vx cv cC wceq cA vx cv coa co cA cC coa
      co cB vx cv coa co cB cC coa co vx cv cC cA coa opreq2 vx cv cC cB coa
      opreq2 sseq12d cA con0 wcel cB con0 wcel wa cA c0 coa co cB c0 coa co wss
      cA cB wss cA con0 wcel cB con0 wcel wa cA c0 coa co cA cB c0 coa co cB cA
      con0 wcel cA c0 coa co cA wceq cB con0 wcel cA oa0 adantr cB con0 wcel cB
      c0 coa co cB wceq cA con0 wcel cB oa0 adantl sseq12d biimpar vy cv con0
      wcel cA con0 wcel cB con0 wcel wa cA vy cv coa co cB vy cv coa co wss cA
      vy cv csuc coa co cB vy cv csuc coa co wss wi cA cB wss cA con0 wcel cB
      con0 wcel wa vy cv con0 wcel cA vy cv coa co cB vy cv coa co wss cA vy cv
      csuc coa co cB vy cv csuc coa co wss wi cA con0 wcel cB con0 wcel wa vy
      cv con0 wcel wa cA vy cv coa co cB vy cv coa co wss cA vy cv csuc coa co
      cB vy cv csuc coa co wss cA con0 wcel cB con0 wcel wa vy cv con0 wcel wa
      cA vy cv coa co cB vy cv coa co wss cA vy cv coa co csuc cB vy cv coa co
      csuc wss cA vy cv csuc coa co cB vy cv csuc coa co wss cA con0 wcel cB
      con0 wcel vy cv con0 wcel cA vy cv coa co cB vy cv coa co wss cA vy cv
      coa co csuc cB vy cv coa co csuc wss wb cA vy cv coa co word cB vy cv coa
      co word cA vy cv coa co cB vy cv coa co wss cA vy cv coa co csuc cB vy cv
      coa co csuc wss wb cA con0 wcel vy cv con0 wcel wa cB con0 wcel vy cv
      con0 wcel wa cA vy cv coa co cB vy cv coa co ordsucsssuc cA con0 wcel vy
      cv con0 wcel wa cA vy cv coa co con0 wcel cA vy cv coa co word cA vy cv
      oacl cA vy cv coa co eloni syl cB con0 wcel vy cv con0 wcel wa cB vy cv
      coa co con0 wcel cB vy cv coa co word cB vy cv oacl cB vy cv coa co eloni
      syl syl2an anandirs cA con0 wcel cB con0 wcel wa vy cv con0 wcel wa cA vy
      cv csuc coa co cA vy cv coa co csuc cB vy cv csuc coa co cB vy cv coa co
      csuc cA con0 wcel vy cv con0 wcel cA vy cv csuc coa co cA vy cv coa co
      csuc wceq cB con0 wcel cA vy cv oasuc adantlr cB con0 wcel vy cv con0
      wcel cB vy cv csuc coa co cB vy cv coa co csuc wceq cA con0 wcel cB vy cv
      oasuc adantll sseq12d bitr4d biimpd expcom adantrd vx cv wlim cA con0
      wcel cB con0 wcel wa cA vy cv coa co cB vy cv coa co wss vy vx cv wral cA
      vx cv coa co cB vx cv coa co wss wi cA cB wss cA con0 wcel cB con0 wcel
      wa vx cv wlim cA vy cv coa co cB vy cv coa co wss vy vx cv wral cA vx cv
      coa co cB vx cv coa co wss wi cA con0 wcel cB con0 wcel wa vx cv cvv wcel
      vx cv wlim cA vy cv coa co cB vy cv coa co wss vy vx cv wral cA vx cv coa
      co cB vx cv coa co wss wi vx visset cA con0 wcel cB con0 wcel wa vx cv
      cvv wcel vx cv wlim wa wa cA vx cv coa co cB vx cv coa co wss vy vx cv cA
      vy cv coa co ciun vy vx cv cB vy cv coa co ciun wss cA vy cv coa co cB vy
      cv coa co wss vy vx cv wral cA con0 wcel cB con0 wcel wa vx cv cvv wcel
      vx cv wlim wa wa cA vx cv coa co vy vx cv cA vy cv coa co ciun cB vx cv
      coa co vy vx cv cB vy cv coa co ciun cA con0 wcel vx cv cvv wcel vx cv
      wlim wa cA vx cv coa co vy vx cv cA vy cv coa co ciun wceq cB con0 wcel
      vy cA vx cv cvv oalim adantlr cB con0 wcel vx cv cvv wcel vx cv wlim wa
      cB vx cv coa co vy vx cv cB vy cv coa co ciun wceq cA con0 wcel vy cB vx
      cv cvv oalim adantll sseq12d vy vx cv cA vy cv coa co cB vy cv coa co
      ss2iun syl5bir mpanr1 expcom adantrd tfinds3 exp4c com3l 3imp $.
      $( [12-Dec-2004] $) $( [7-Dec-2004] $)
  $}

  $( An ordinal is less than its sum with a non-zero ordinal.  Theorem 18 of
     [Suppes] p. 209 and its converse. $)
  oaord1 $p |- ( ( A e. On /\ B e. On ) ->
               ( (/) e. B <-> A e. ( A +o B ) ) ) $=
    cB con0 wcel cA con0 wcel c0 cB wcel cA cA cB coa co wcel wb cB con0 wcel
    cA con0 wcel wa c0 cB wcel cA c0 coa co cA cB coa co wcel cA cA cB coa co
    wcel c0 con0 wcel cB con0 wcel cA con0 wcel c0 cB wcel cA c0 coa co cA cB
    coa co wcel wb 0elon c0 cB cA oaord mp3an1 cB con0 wcel cA con0 wcel wa cA
    c0 coa co cA cA cB coa co cA con0 wcel cA c0 coa co cA wceq cB con0 wcel cA
    oa0 adantl eleq1d bitrd ancoms $.
    $( [11-Dec-2004] $) $( [6-Dec-2004] $)

  $( An ordinal is less than or equal to its sum with another.  Part of
     Exercise 5 of [TakeutiZaring] p. 62.  (For the other part see
     ~ oaord1 .) $)
  oaword1 $p |- ( ( A e. On /\ B e. On ) -> A C_ ( A +o B ) ) $=
    cA con0 wcel cB con0 wcel wa cA cA c0 coa co cA cB coa co cA con0 wcel cA
    c0 coa co cA wceq cB con0 wcel cA oa0 adantr cA con0 wcel cB con0 wcel wa
    c0 cB wss cA c0 coa co cA cB coa co wss cB 0ss cA con0 wcel cB con0 wcel c0
    con0 wcel c0 cB wss cA c0 coa co cA cB coa co wss wb 0elon c0 con0 wcel cB
    con0 wcel cA con0 wcel c0 cB wss cA c0 coa co cA cB coa co wss wb c0 cB cA
    oaword 3com13 mp3an3 mpbii eqsstr3d $.
    $( [8-Dec-2004] $) $( [6-Dec-2004] $)

  $( An ordinal is less than or equal to its sum with another.  Theorem 21 of
     [Suppes] p. 209. $)
  oaword2 $p |- ( ( A e. On /\ B e. On ) -> A C_ ( B +o A ) ) $=
    cB con0 wcel cA con0 wcel cA cB cA coa co wss cB con0 wcel cA con0 wcel wa
    c0 cB wss cA cB cA coa co wss cB 0ss cB con0 wcel cA con0 wcel wa c0 cB wss
    c0 cA coa co cB cA coa co wss cA cB cA coa co wss c0 con0 wcel cB con0 wcel
    cA con0 wcel c0 cB wss c0 cA coa co cB cA coa co wss wi 0elon c0 cB cA
    oawordri mp3an1 cB con0 wcel cA con0 wcel wa c0 cA coa co cA cB cA coa co
    cA con0 wcel c0 cA coa co cA wceq cB con0 wcel cA oa0r adantl sseq1d sylibd
    mpi ancoms $.
    $( [14-Dec-2004] $) $( [7-Dec-2004] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x z S $.
    oawordeulem.1 $e |- A e. On $.
    oawordeulem.2 $e |- B e. On $.
    oawordeulem.3 $e |- S = { y e. On | B C_ ( A +o y ) } $.
    $( Lemma for ~ oawordex . $)
    oawordeulem $p |- ( A C_ B -> E! x e. On ( A +o x ) = B ) $=
      cA cB wss cA vx cv coa co cB wceq vx con0 wrex cA vx cv coa co cB wceq cA
      vy cv coa co cB wceq wa vx cv vy cv wceq wi vy con0 wral vx con0 wral wa
      cA vx cv coa co cB wceq vx con0 wreu cA cB wss cA vx cv coa co cB wceq vx
      con0 wrex cA vx cv coa co cB wceq cA vy cv coa co cB wceq wa vx cv vy cv
      wceq wi vy con0 wral vx con0 wral cS cint con0 wcel cA cS cint coa co cB
      wceq cA vx cv coa co cB wceq vx con0 wrex cA cB wss cA vx cv coa co cB
      wceq cA cS cint coa co cB wceq vx cS cint con0 vx cv cS cint wceq cA vx
      cv coa co cA cS cint coa co cB vx cv cS cint cA coa opreq2 eqeq1d rcla4ev
      cS con0 wss cS c0 wne cS cint con0 wcel cS cB cA vy cv coa co wss vy con0
      crab con0 oawordeulem.3 cB cA vy cv coa co wss vy con0 ssrab2 eqsstri cB
      cS wcel cS c0 wne cB cS wcel cB con0 wcel cB cA cB coa co wss cB cA vy cv
      coa co wss cB cA cB coa co wss vy cB con0 cS vy cv cB wceq cA vy cv coa
      co cA cB coa co cB vy cv cB cA coa opreq2 sseq2d oawordeulem.3 elrab2
      oawordeulem.2 cB con0 wcel cA con0 wcel cB cA cB coa co wss oawordeulem.2
      oawordeulem.1 cB cA oaword2 mp2an mpbir2an cS cB ne0i ax-mp cS oninton
      mp2an cA cB wss cA cS cint coa co cB wss cB cA cS cint coa co wss wa cA
      cS cint coa co cB wceq cA cB wss cA cS cint coa co cB wss cB cA cS cint
      coa co wss cS cint c0 wceq cS cint vz cv csuc wceq vz con0 wrex cS cint
      cvv wcel cS cint wlim wa w3o cA cB wss cA cS cint coa co cB wss wi cS
      cint con0 wcel cS cint c0 wceq cS cint vz cv csuc wceq vz con0 wrex cS
      cint cvv wcel cS cint wlim wa w3o cS con0 wss cS c0 wne cS cint con0 wcel
      cS cB cA vy cv coa co wss vy con0 crab con0 oawordeulem.3 cB cA vy cv coa
      co wss vy con0 ssrab2 eqsstri cB cS wcel cS c0 wne cB cS wcel cB con0
      wcel cB cA cB coa co wss cB cA vy cv coa co wss cB cA cB coa co wss vy cB
      con0 cS vy cv cB wceq cA vy cv coa co cA cB coa co cB vy cv cB cA coa
      opreq2 sseq2d oawordeulem.3 elrab2 oawordeulem.2 cB con0 wcel cA con0
      wcel cB cA cB coa co wss oawordeulem.2 oawordeulem.1 cB cA oaword2 mp2an
      mpbir2an cS cB ne0i ax-mp cS oninton mp2an vz cS cint onzsl mpbi cS cint
      c0 wceq cA cB wss cA cS cint coa co cB wss wi cS cint vz cv csuc wceq vz
      con0 wrex cS cint cvv wcel cS cint wlim wa cS cint c0 wceq cA cS cint coa
      co cB wss cA cB wss cS cint c0 wceq cA cS cint coa co cA cB cS cint c0
      wceq cA cS cint coa co cA c0 coa co cA cS cint c0 cA coa opreq2 cA con0
      wcel cA c0 coa co cA wceq oawordeulem.1 cA oa0 ax-mp syl6eq sseq1d
      biimprd cS cint vz cv csuc wceq vz con0 wrex cA cS cint coa co cB wss cA
      cB wss cS cint vz cv csuc wceq cA cS cint coa co cB wss vz con0 vz cv
      con0 wcel cS cint vz cv csuc wceq wa cA cS cint coa co cA vz cv coa co
      csuc cB cS cint vz cv csuc wceq vz cv con0 wcel cA cS cint coa co cA vz
      cv csuc coa co cA vz cv coa co csuc cS cint vz cv csuc cA coa opreq2 cA
      con0 wcel vz cv con0 wcel cA vz cv csuc coa co cA vz cv coa co csuc wceq
      oawordeulem.1 cA vz cv oasuc mpan sylan9eqr cS cint vz cv csuc wceq cA vz
      cv coa co csuc cB wss vz cv con0 wcel cS cint vz cv csuc wceq vz cv cS
      cint wcel cA vz cv coa co cB wcel cA vz cv coa co csuc cB wss cS cint vz
      cv csuc wceq vz cv cS cint wcel vz cv vz cv csuc wcel vz cv vz visset
      sucid cS cint vz cv csuc vz cv eleq2 mpbiri vz cv con0 wcel vz cv cS cint
      wcel cA vz cv coa co cB wcel cS cint vz cv cS con0 wss cS c0 wne cS cint
      con0 wcel cS cB cA vy cv coa co wss vy con0 crab con0 oawordeulem.3 cB cA
      vy cv coa co wss vy con0 ssrab2 eqsstri cB cS wcel cS c0 wne cB cS wcel
      cB con0 wcel cB cA cB coa co wss cB cA vy cv coa co wss cB cA cB coa co
      wss vy cB con0 cS vy cv cB wceq cA vy cv coa co cA cB coa co cB vy cv cB
      cA coa opreq2 sseq2d oawordeulem.3 elrab2 oawordeulem.2 cB con0 wcel cA
      con0 wcel cB cA cB coa co wss oawordeulem.2 oawordeulem.1 cB cA oaword2
      mp2an mpbir2an cS cB ne0i ax-mp cS oninton mp2an oneli vz cv con0 wcel vz
      cv cS cint wcel cB cA vz cv coa co wss wn cA vz cv coa co cB wcel vz cv
      con0 wcel vz cv cB cA vy cv coa co wss vy con0 crab cint wcel cB cA vz cv
      coa co wss wn vz cv cS cint wcel cB cA vy cv coa co wss cB cA vz cv coa
      co wss vy vz cv vy cv vz cv wceq cA vy cv coa co cA vz cv coa co cB vy cv
      vz cv cA coa opreq2 sseq2d onnminsb cS cint cB cA vy cv coa co wss vy
      con0 crab cint vz cv cS cB cA vy cv coa co wss vy con0 crab oawordeulem.3
      inteqi eleq2i syl5ib vz cv con0 wcel cB cA vz cv coa co wss cA vz cv coa
      co cB wcel cB con0 wcel cA vz cv coa co con0 wcel cB cA vz cv coa co wss
      cA vz cv coa co cB wcel wn wb vz cv con0 wcel cB cA vz cv coa co ontri1
      oawordeulem.2 cA con0 wcel vz cv con0 wcel cA vz cv coa co con0 wcel
      oawordeulem.1 cA vz cv oacl mpan sylancr con2bid sylibrd mpcom cB word cA
      vz cv coa co cB wcel cA vz cv coa co csuc cB wss wi cB oawordeulem.2
      onordi cA vz cv coa co cB ordsucss ax-mp 3syl adantl eqsstrd r19.23aiva
      a1d cS cint cvv wcel cS cint wlim wa cA cS cint coa co cB wss cA cB wss
      cS cint cvv wcel cS cint wlim wa cA cS cint coa co cB wss vz cS cint cA
      vz cv coa co ciun cB wss vz cS cint cA vz cv coa co ciun cB wss cA vz cv
      coa co cB wss vz cS cint vz cS cint cA vz cv coa co cB iunss vz cv cS
      cint wcel cA vz cv coa co cB wcel cA vz cv coa co cB wss vz cv con0 wcel
      vz cv cS cint wcel cA vz cv coa co cB wcel cS cint vz cv cS con0 wss cS
      c0 wne cS cint con0 wcel cS cB cA vy cv coa co wss vy con0 crab con0
      oawordeulem.3 cB cA vy cv coa co wss vy con0 ssrab2 eqsstri cB cS wcel cS
      c0 wne cB cS wcel cB con0 wcel cB cA cB coa co wss cB cA vy cv coa co wss
      cB cA cB coa co wss vy cB con0 cS vy cv cB wceq cA vy cv coa co cA cB coa
      co cB vy cv cB cA coa opreq2 sseq2d oawordeulem.3 elrab2 oawordeulem.2 cB
      con0 wcel cA con0 wcel cB cA cB coa co wss oawordeulem.2 oawordeulem.1 cB
      cA oaword2 mp2an mpbir2an cS cB ne0i ax-mp cS oninton mp2an oneli vz cv
      con0 wcel vz cv cS cint wcel cB cA vz cv coa co wss wn cA vz cv coa co cB
      wcel vz cv con0 wcel vz cv cB cA vy cv coa co wss vy con0 crab cint wcel
      cB cA vz cv coa co wss wn vz cv cS cint wcel cB cA vy cv coa co wss cB cA
      vz cv coa co wss vy vz cv vy cv vz cv wceq cA vy cv coa co cA vz cv coa
      co cB vy cv vz cv cA coa opreq2 sseq2d onnminsb cS cint cB cA vy cv coa
      co wss vy con0 crab cint vz cv cS cB cA vy cv coa co wss vy con0 crab
      oawordeulem.3 inteqi eleq2i syl5ib vz cv con0 wcel cB cA vz cv coa co wss
      cA vz cv coa co cB wcel cB con0 wcel cA vz cv coa co con0 wcel cB cA vz
      cv coa co wss cA vz cv coa co cB wcel wn wb vz cv con0 wcel cB cA vz cv
      coa co ontri1 oawordeulem.2 cA con0 wcel vz cv con0 wcel cA vz cv coa co
      con0 wcel oawordeulem.1 cA vz cv oacl mpan sylancr con2bid sylibrd mpcom
      cB cA vz cv coa co oawordeulem.2 onelssi syl mprgbir cS cint cvv wcel cS
      cint wlim wa cA cS cint coa co vz cS cint cA vz cv coa co ciun cB cA con0
      wcel cS cint cvv wcel cS cint wlim wa cA cS cint coa co vz cS cint cA vz
      cv coa co ciun wceq oawordeulem.1 vz cA cS cint cvv oalim mpan sseq1d
      mpbiri a1d 3jaoi ax-mp cB cA cB cA vy cv coa co wss vy con0 crab cint coa
      co cA cS cint coa co cB cA vy cv coa co wss vy con0 wrex cB cA cB cA vy
      cv coa co wss vy con0 crab cint coa co wss cB con0 wcel cB cA cB coa co
      wss cB cA vy cv coa co wss vy con0 wrex oawordeulem.2 cB con0 wcel cA
      con0 wcel cB cA cB coa co wss oawordeulem.2 oawordeulem.1 cB cA oaword2
      mp2an cB cA vy cv coa co wss cB cA cB coa co wss vy cB con0 vy cv cB wceq
      cA vy cv coa co cA cB coa co cB vy cv cB cA coa opreq2 sseq2d rcla4ev
      mp2an cB cA vy cv coa co wss cB cA cB cA vy cv coa co wss vy con0 crab
      cint coa co wss vy vy vz cB cA cB cA vy cv coa co wss vy con0 crab cint
      coa co vz cv cB wcel vy ax-17 vy vz cA cB cA vy cv coa co wss vy con0
      crab cint coa vz cv cA wcel vy ax-17 vz cv coa wcel vy ax-17 vy vz cB cA
      vy cv coa co wss vy con0 crab cB cA vy cv coa co wss vy vz con0 hbrab1
      hbint hbopr hbss vy cv cB cA vy cv coa co wss vy con0 crab cint wceq cA
      vy cv coa co cA cB cA vy cv coa co wss vy con0 crab cint coa co cB vy cv
      cB cA vy cv coa co wss vy con0 crab cint cA coa opreq2 sseq2d onminsb
      ax-mp cS cint cB cA vy cv coa co wss vy con0 crab cint cA coa cS cB cA vy
      cv coa co wss vy con0 crab oawordeulem.3 inteqi opreq2i sseqtr4i jctir cA
      cS cint coa co cB eqss sylibr sylancr cA vx cv coa co cB wceq cA vy cv
      coa co cB wceq wa vx cv vy cv wceq wi vx vy con0 vx cv con0 wcel vy cv
      con0 wcel wa cA vx cv coa co cA vy cv coa co wceq vx cv vy cv wceq cA vx
      cv coa co cB wceq cA vy cv coa co cB wceq wa cA con0 wcel vx cv con0 wcel
      vy cv con0 wcel cA vx cv coa co cA vy cv coa co wceq vx cv vy cv wceq wb
      oawordeulem.1 cA vx cv vy cv oacan mp3an1 cA vx cv coa co cA vy cv coa co
      cB eqtr3 syl5bi rgen2a jctir cA vx cv coa co cB wceq cA vy cv coa co cB
      wceq vx vy con0 vx cv vy cv wceq cA vx cv coa co cA vy cv coa co cB vx cv
      vy cv cA coa opreq2 eqeq1d reu4 sylibr $.
      $( [14-Dec-2004] $) $( [11-Dec-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Existence theorem for weak ordering of ordinal sum.  Proposition 8.8 of
       [TakeutiZaring] p. 59. $)
    oawordeu $p |- ( ( ( A e. On /\ B e. On ) /\ A C_ B ) ->
                  E! x e. On ( A +o x ) = B ) $=
      cA con0 wcel cB con0 wcel wa cA cB wss cA vx cv coa co cB wceq vx con0
      wreu cA con0 wcel cB con0 wcel cA cB wss cA vx cv coa co cB wceq vx con0
      wreu wi cA con0 wcel cA c0 cif cB wss cA con0 wcel cA c0 cif vx cv coa co
      cB wceq vx con0 wreu wi cA con0 wcel cA c0 cif cB con0 wcel cB c0 cif wss
      cA con0 wcel cA c0 cif vx cv coa co cB con0 wcel cB c0 cif wceq vx con0
      wreu wi cA cB c0 c0 cA cA con0 wcel cA c0 cif wceq cA cB wss cA con0 wcel
      cA c0 cif cB wss cA vx cv coa co cB wceq vx con0 wreu cA con0 wcel cA c0
      cif vx cv coa co cB wceq vx con0 wreu cA cA con0 wcel cA c0 cif cB sseq1
      cA cA con0 wcel cA c0 cif wceq cA vx cv coa co cB wceq cA con0 wcel cA c0
      cif vx cv coa co cB wceq vx con0 cA cA con0 wcel cA c0 cif wceq cA vx cv
      coa co cA con0 wcel cA c0 cif vx cv coa co cB cA cA con0 wcel cA c0 cif
      vx cv coa opreq1 eqeq1d reubidv imbi12d cB cB con0 wcel cB c0 cif wceq cA
      con0 wcel cA c0 cif cB wss cA con0 wcel cA c0 cif cB con0 wcel cB c0 cif
      wss cA con0 wcel cA c0 cif vx cv coa co cB wceq vx con0 wreu cA con0 wcel
      cA c0 cif vx cv coa co cB con0 wcel cB c0 cif wceq vx con0 wreu cB cB
      con0 wcel cB c0 cif cA con0 wcel cA c0 cif sseq2 cB cB con0 wcel cB c0
      cif wceq cA con0 wcel cA c0 cif vx cv coa co cB wceq cA con0 wcel cA c0
      cif vx cv coa co cB con0 wcel cB c0 cif wceq vx con0 cB cB con0 wcel cB
      c0 cif cA con0 wcel cA c0 cif vx cv coa co eqeq2 reubidv imbi12d vx vy cA
      con0 wcel cA c0 cif cB con0 wcel cB c0 cif cB con0 wcel cB c0 cif cA con0
      wcel cA c0 cif vy cv coa co wss vy con0 crab cA c0 con0 0elon elimel cB
      c0 con0 0elon elimel cB con0 wcel cB c0 cif cA con0 wcel cA c0 cif vy cv
      coa co wss vy con0 crab eqid oawordeulem dedth2h imp $.
      $( [14-Dec-2004] $) $( [11-Dec-2004] $)

    $( Existence theorem for weak ordering of ordinal sum. $)
    oawordexr $p |- ( ( A e. On /\ E. x e. On ( A +o x ) = B ) -> A C_ B ) $=
      cA con0 wcel cA vx cv coa co cB wceq vx con0 wrex cA cB wss cA con0 wcel
      cA vx cv coa co cB wceq cA cB wss vx con0 cA vx cv coa co cB wceq cA cA
      vx cv coa co wss cA cB wss cA con0 wcel vx cv con0 wcel wa cA vx cv coa
      co cB cA sseq2 cA vx cv oaword1 syl5cbi r19.23adva imp $.
      $( [14-Dec-2004] $) $( [12-Dec-2004] $)

    $( Existence theorem for weak ordering of ordinal sum.  Proposition 8.8 of
       [TakeutiZaring] p. 59 and its converse.  See ~ oawordeu for
       uniqueness. $)
    oawordex $p |- ( ( A e. On /\ B e. On ) ->
                  ( A C_ B <-> E. x e. On ( A +o x ) = B ) ) $=
      cA con0 wcel cB con0 wcel wa cA cB wss cA vx cv coa co cB wceq vx con0
      wrex cA con0 wcel cB con0 wcel wa cA cB wss cA vx cv coa co cB wceq vx
      con0 wreu cA vx cv coa co cB wceq vx con0 wrex cA con0 wcel cB con0 wcel
      wa cA cB wss cA vx cv coa co cB wceq vx con0 wreu vx cA cB oawordeu ex cA
      vx cv coa co cB wceq vx con0 reurex syl6 cA con0 wcel cA vx cv coa co cB
      wceq vx con0 wrex cA cB wss wi cB con0 wcel cA con0 wcel cA vx cv coa co
      cB wceq vx con0 wrex cA cB wss vx cA cB oawordexr ex adantr impbid $.
      $( [14-Dec-2004] $) $( [12-Dec-2004] $)

    $( Existence theorem for ordering of ordinal sum.  Similar to Proposition
       4.34(f) of [Mendelson] p. 266 and its converse. $)
    oaordex $p |- ( ( A e. On /\ B e. On ) ->
                  ( A e. B <-> E. x e. On ( (/) e. x /\ ( A +o x ) = B ) ) ) $=
      cA con0 wcel cB con0 wcel wa cA cB wcel c0 vx cv wcel cA vx cv coa co cB
      wceq wa vx con0 wrex cA con0 wcel cB con0 wcel wa cA cB wcel cA vx cv coa
      co cB wceq vx con0 wrex c0 vx cv wcel cA vx cv coa co cB wceq wa vx con0
      wrex cA con0 wcel cB con0 wcel wa cA cB wcel cA cB wss cA vx cv coa co cB
      wceq vx con0 wrex cB con0 wcel cA cB wcel cA cB wss wi cA con0 wcel cB cA
      onelss adantl vx cA cB oawordex sylibd cA con0 wcel cA cB wcel cA vx cv
      coa co cB wceq vx con0 wrex c0 vx cv wcel cA vx cv coa co cB wceq wa vx
      con0 wrex wi wi cB con0 wcel cA con0 wcel cA cB wcel cA vx cv coa co cB
      wceq vx con0 wrex c0 vx cv wcel cA vx cv coa co cB wceq wa vx con0 wrex
      wi cA con0 wcel cA cB wcel wa cA vx cv coa co cB wceq c0 vx cv wcel cA vx
      cv coa co cB wceq wa vx con0 cA con0 wcel cA cB wcel wa vx cv con0 wcel
      cA vx cv coa co cB wceq c0 vx cv wcel cA vx cv coa co cB wceq wa cA con0
      wcel cA cB wcel wa vx cv con0 wcel cA vx cv coa co cB wceq wa c0 vx cv
      wcel cA vx cv coa co cB wceq cA con0 wcel cA cB wcel vx cv con0 wcel cA
      vx cv coa co cB wceq c0 vx cv wcel cA cB wcel cA con0 wcel vx cv con0
      wcel cA vx cv coa co cB wceq c0 vx cv wcel wi wi cA cB wcel cA con0 wcel
      vx cv con0 wcel cA vx cv coa co cB wceq c0 vx cv wcel cA con0 wcel vx cv
      con0 wcel wa cA vx cv coa co cB wceq wa c0 vx cv wcel cA cB wcel cA con0
      wcel vx cv con0 wcel wa c0 vx cv wcel cA cA vx cv coa co wcel cA vx cv
      coa co cB wceq cA cB wcel cA vx cv oaord1 cA vx cv coa co cB cA eleq2
      sylan9bb biimprcd exp4c com12 imp4b vx cv con0 wcel cA vx cv coa co cB
      wceq wa cA vx cv coa co cB wceq wi cA con0 wcel cA cB wcel wa vx cv con0
      wcel cA vx cv coa co cB wceq pm3.27 a1i jcad exp3a r19.22dv ex adantr
      mpdd cA con0 wcel c0 vx cv wcel cA vx cv coa co cB wceq wa vx con0 wrex
      cA cB wcel wi cB con0 wcel cA con0 wcel c0 vx cv wcel cA vx cv coa co cB
      wceq wa cA cB wcel vx con0 cA con0 wcel vx cv con0 wcel c0 vx cv wcel cA
      vx cv coa co cB wceq cA cB wcel cA con0 wcel vx cv con0 wcel cA vx cv coa
      co cB wceq c0 vx cv wcel cA cB wcel cA con0 wcel vx cv con0 wcel cA vx cv
      coa co cB wceq c0 vx cv wcel cA cB wcel wi cA con0 wcel vx cv con0 wcel
      wa cA vx cv coa co cB wceq wa c0 vx cv wcel cA cB wcel cA con0 wcel vx cv
      con0 wcel wa c0 vx cv wcel cA cA vx cv coa co wcel cA vx cv coa co cB
      wceq cA cB wcel cA vx cv oaord1 cA vx cv coa co cB cA eleq2 sylan9bb
      biimpd exp31 com34 imp4a r19.23adv adantr impbid $.
      $( [14-Dec-2004] $) $( [12-Dec-2004] $)
  $}

  $( An ordinal sum is zero iff both of its arguments are zero. $)
  oa00 $p |- ( ( A e. On /\ B e. On ) ->
             ( ( A +o B ) = (/) <-> ( A = (/) /\ B = (/) ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB coa co c0 wceq cA c0 wceq cB c0 wceq wa
    cA con0 wcel cB con0 wcel wa cA cB coa co c0 wceq cA c0 wceq cB c0 wceq cA
    con0 wcel cB con0 wcel wa cA c0 cA cB coa co c0 cA con0 wcel cB con0 wcel
    wa cA c0 wne c0 cA cB coa co wcel cA cB coa co c0 wne cA con0 wcel cB con0
    wcel wa cA c0 wne c0 cA wcel c0 cA cB coa co wcel cA con0 wcel c0 cA wcel
    cA c0 wne wb cB con0 wcel cA on0eln0 adantr cA con0 wcel cB con0 wcel wa cA
    cA cB coa co c0 cA cB oaword1 sseld sylbird cA cB coa co c0 ne0i syl6
    necon4d cA con0 wcel cB con0 wcel wa cB c0 cA cB coa co c0 cA con0 wcel cB
    con0 wcel wa cB c0 wne cA c0 coa co cA cB coa co wcel cA cB coa co c0 wne
    cA con0 wcel cB con0 wcel wa c0 cB wcel cB c0 wne cA c0 coa co cA cB coa co
    wcel cB con0 wcel c0 cB wcel cB c0 wne wb cA con0 wcel cB on0eln0 adantl cB
    con0 wcel cA con0 wcel c0 cB wcel cA c0 coa co cA cB coa co wcel wb c0 con0
    wcel cB con0 wcel cA con0 wcel c0 cB wcel cA c0 coa co cA cB coa co wcel wb
    0elon c0 cB cA oaord mp3an1 ancoms bitr3d cA cB coa co cA c0 coa co ne0i
    syl6bi necon4d jcad cA c0 wceq cB c0 wceq wa cA cB coa co c0 c0 coa co c0
    cA c0 cB c0 coa opreq12 c0 con0 wcel c0 c0 coa co c0 wceq 0elon c0 oa0
    ax-mp syl6eq impbid1 $.
    $( [25-Dec-2004] $) $( [6-Dec-2004] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( The ordinal sum with a limit ordinal is a limit ordinal.  Proposition
       8.11 of [TakeutiZaring] p. 60. $)
    oalimcl $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) -> Lim ( A +o B ) ) $=
      cA cB coa co wlim cA cB coa co word cA cB coa co c0 wceq cA cB coa co vy
      cv csuc wceq vy con0 wrex wo wn cA con0 wcel cB cC wcel cB wlim wa wa vy
      cA cB coa co dflim3 cA con0 wcel cB con0 wcel cA cB coa co word cB cC
      wcel cB wlim wa cA con0 wcel cB con0 wcel wa cA cB coa co con0 wcel cA cB
      coa co word cA cB oacl cA cB coa co eloni syl cB cC limelon sylan2 cA cB
      coa co c0 wceq cA cB coa co vy cv csuc wceq vy con0 wrex wo wn cA cB coa
      co c0 wceq wn cA cB coa co vy cv csuc wceq vy con0 wrex wn cA con0 wcel
      cB cC wcel cB wlim wa wa cA cB coa co c0 wceq cA cB coa co vy cv csuc
      wceq vy con0 wrex ioran cA con0 wcel cB cC wcel cB wlim wa wa cB c0 wceq
      wn cA cB coa co c0 wceq wn cB wlim cB c0 wceq wn cA con0 wcel cB cC wcel
      cB wlim c0 cB wcel cB c0 wceq wn cB 0ellim cB c0 n0i syl ad2antll cA con0
      wcel cB con0 wcel cB c0 wceq wn cA cB coa co c0 wceq wn wi cB cC wcel cB
      wlim wa cA con0 wcel cB con0 wcel wa cA cB coa co c0 wceq cB c0 wceq cA
      con0 wcel cB con0 wcel wa cA cB coa co c0 wceq cA c0 wceq cB c0 wceq wa
      cB c0 wceq cA cB oa00 cA c0 wceq cB c0 wceq pm3.27 syl6bi con3d cB cC
      limelon sylan2 mpd cA con0 wcel cB cC wcel cB wlim wa wa cA cB coa co vy
      cv csuc wceq vy con0 cA con0 wcel cB cC wcel cB wlim wa wa cA cB coa co
      vy cv csuc wceq wn vy cv con0 wcel cA con0 wcel cB cC wcel cB wlim wa wa
      cA cB coa co vy cv csuc wceq cA cB coa co vy cv csuc wceq cA con0 wcel cB
      cC wcel cB wlim wa wa cA cB coa co vy cv csuc wceq wn cA cB coa co vy cv
      csuc wceq cA con0 wcel cB cC wcel cB wlim wa wa wa vy cv cA vx cv coa co
      wcel vx cB wrex cA cB coa co vy cv csuc wceq wn cA cB coa co vy cv csuc
      wceq cA con0 wcel cB cC wcel cB wlim wa wa wa vy cv vx cB cA vx cv coa co
      ciun wcel vy cv cA vx cv coa co wcel vx cB wrex cA cB coa co vy cv csuc
      wceq cA con0 wcel cB cC wcel cB wlim wa wa wa vy cv csuc vx cB cA vx cv
      coa co ciun vy cv cA cB coa co vy cv csuc wceq cA con0 wcel cB cC wcel cB
      wlim wa wa vy cv csuc vx cB cA vx cv coa co ciun wceq cA cB coa co vy cv
      csuc wceq cA cB coa co vx cB cA vx cv coa co ciun wceq vy cv csuc vx cB
      cA vx cv coa co ciun wceq cA con0 wcel cB cC wcel cB wlim wa wa cA cB coa
      co vy cv csuc vx cB cA vx cv coa co ciun eqeq1 vx cA cB cC oalim syl5bi
      imp vy cv vy visset sucid syl5eleq vx vy cv cB cA vx cv coa co eliun
      sylib cA con0 wcel cB cC wcel cB wlim wa wa vy cv cA vx cv coa co wcel vx
      cB wrex cA cB coa co vy cv csuc wceq wn wi cA cB coa co vy cv csuc wceq
      cA con0 wcel cB cC wcel cB wlim wa wa vy cv cA vx cv coa co wcel cA cB
      coa co vy cv csuc wceq wn vx cB cA con0 wcel cB cC wcel cB wlim wa vx cv
      cB wcel vy cv cA vx cv coa co wcel cA cB coa co vy cv csuc wceq wn wi wi
      cA con0 wcel cB cC wcel cB wlim wa vx cv cB wcel vy cv cA vx cv coa co
      wcel cA cB coa co vy cv csuc wceq wn cA con0 wcel cB cC wcel cB wlim wa
      vx cv cB wcel wa vy cv cA vx cv coa co wcel wa wa cA cB coa co vy cv csuc
      wceq cB vx cv csuc wcel cB cC wcel cB wlim wa vx cv cB wcel wa cB vx cv
      csuc wcel wn cA con0 wcel vy cv cA vx cv coa co wcel cB cC wcel cB wlim
      wa vx cv cB wcel wa vx cv con0 wcel cB vx cv csuc wcel wn cB con0 wcel vx
      cv cB wcel vx cv con0 wcel cB cC wcel cB wlim wa cB vx cv onelon cB cC
      limelon sylan vx cv cB wcel vx cv con0 wcel cB vx cv csuc wcel wn wi cB
      cC wcel cB wlim wa vx cv con0 wcel vx cv cB wcel cB vx cv csuc wcel wn vx
      cv con0 wcel vx cv cB wcel cB vx cv csuc wcel wa wn vx cv cB wcel cB vx
      cv csuc wcel wn wi vx cv cB onnbtwn vx cv cB wcel cB vx cv csuc wcel
      imnan sylibr com12 adantl mpd ad2antrl cA con0 wcel cB cC wcel cB wlim wa
      vx cv cB wcel wa vy cv cA vx cv coa co wcel cA cB coa co vy cv csuc wceq
      cB vx cv csuc wcel wi cA cB coa co vy cv csuc wceq cA con0 wcel cB cC
      wcel cB wlim wa vx cv cB wcel wa vy cv cA vx cv coa co wcel cB vx cv csuc
      wcel cA cB coa co vy cv csuc wceq cA con0 wcel cB cC wcel cB wlim wa vx
      cv cB wcel wa vy cv cA vx cv coa co wcel cB vx cv csuc wcel wi cA cB coa
      co vy cv csuc wceq cA con0 wcel cB cC wcel cB wlim wa vx cv cB wcel wa wa
      wa vy cv cA vx cv coa co wcel cB vx cv csuc wcel cA cB coa co vy cv csuc
      wceq cA con0 wcel cB cC wcel cB wlim wa vx cv cB wcel wa wa wa vy cv cA
      vx cv coa co wcel cA cB coa co cA vx cv csuc coa co wcel cB vx cv csuc
      wcel cA con0 wcel cB cC wcel cB wlim wa vx cv cB wcel wa wa vy cv cA vx
      cv coa co wcel vy cv csuc cA vx cv csuc coa co wcel cA cB coa co vy cv
      csuc wceq cA cB coa co cA vx cv csuc coa co wcel cA con0 wcel vx cv con0
      wcel vy cv cA vx cv coa co wcel vy cv csuc cA vx cv csuc coa co wcel wb
      cB cC wcel cB wlim wa vx cv cB wcel wa cA con0 wcel vx cv con0 wcel wa vy
      cv cA vx cv coa co wcel vy cv csuc cA vx cv coa co csuc wcel vy cv csuc
      cA vx cv csuc coa co wcel cA con0 wcel vx cv con0 wcel wa cA vx cv coa co
      con0 wcel cA vx cv coa co word vy cv cA vx cv coa co wcel vy cv csuc cA
      vx cv coa co csuc wcel wb cA vx cv oacl cA vx cv coa co eloni vy cv cA vx
      cv coa co ordsucelsuc 3syl cA con0 wcel vx cv con0 wcel wa cA vx cv csuc
      coa co cA vx cv coa co csuc vy cv csuc cA vx cv oasuc eleq2d bitr4d cB
      con0 wcel vx cv cB wcel vx cv con0 wcel cB cC wcel cB wlim wa cB vx cv
      onelon cB cC limelon sylan sylan2 cA cB coa co vy cv csuc wceq cA cB coa
      co cA vx cv csuc coa co wcel vy cv csuc cA vx cv csuc coa co wcel cA cB
      coa co vy cv csuc cA vx cv csuc coa co eleq1 bicomd sylan9bbr cA con0
      wcel cB cC wcel cB wlim wa vx cv cB wcel wa wa cB vx cv csuc wcel cA cB
      coa co cA vx cv csuc coa co wcel wb cA cB coa co vy cv csuc wceq cB cC
      wcel cB wlim wa vx cv cB wcel wa cA con0 wcel cB vx cv csuc wcel cA cB
      coa co cA vx cv csuc coa co wcel wb cB con0 wcel vx cv csuc con0 wcel wa
      cA con0 wcel cB vx cv csuc wcel cA cB coa co cA vx cv csuc coa co wcel wb
      cB cC wcel cB wlim wa vx cv cB wcel wa cB con0 wcel vx cv csuc con0 wcel
      cA con0 wcel cB vx cv csuc wcel cA cB coa co cA vx cv csuc coa co wcel wb
      cB vx cv csuc cA oaord 3expa cB cC wcel cB wlim wa vx cv cB wcel wa cB
      con0 wcel vx cv csuc con0 wcel cB cC wcel cB wlim wa cB con0 wcel vx cv
      cB wcel cB cC limelon adantr cB cC wcel cB wlim wa vx cv cB wcel wa vx cv
      con0 wcel vx cv csuc con0 wcel cB con0 wcel vx cv cB wcel vx cv con0 wcel
      cB cC wcel cB wlim wa cB vx cv onelon cB cC limelon sylan vx cv sucelon
      sylib jca sylan ancoms adantl bitr4d biimpd exp32 com4l imp32 mtod exp44
      imp r19.23adv adantl mpd expcom pm2.01d adantr nrexdv sylanbrc sylanbrc
      $.
      $( [25-Dec-2004] $) $( [8-Dec-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x C $.
    $( Ordinal addition is associative.  Theorem 25 of [Suppes] p. 211. $)
    oaass $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( ( A +o B ) +o C ) = ( A +o ( B +o C ) ) ) $=
      cA con0 wcel cB con0 wcel cC con0 wcel cA cB coa co cC coa co cA cB cC
      coa co coa co wceq cC con0 wcel cA con0 wcel cB con0 wcel wa cA cB coa co
      cC coa co cA cB cC coa co coa co wceq cA cB coa co vx cv coa co cA cB vx
      cv coa co coa co wceq cA cB coa co c0 coa co cA cB c0 coa co coa co wceq
      cA cB coa co vy cv coa co cA cB vy cv coa co coa co wceq cA cB coa co vy
      cv csuc coa co cA cB vy cv csuc coa co coa co wceq cA cB coa co cC coa co
      cA cB cC coa co coa co wceq vx vy cC cA con0 wcel cB con0 wcel wa vx cv
      c0 wceq cA cB coa co vx cv coa co cA cB coa co c0 coa co cA cB vx cv coa
      co coa co cA cB c0 coa co coa co vx cv c0 cA cB coa co coa opreq2 vx cv
      c0 wceq cB vx cv coa co cB c0 coa co cA coa vx cv c0 cB coa opreq2
      opreq2d eqeq12d vx cv vy cv wceq cA cB coa co vx cv coa co cA cB coa co
      vy cv coa co cA cB vx cv coa co coa co cA cB vy cv coa co coa co vx cv vy
      cv cA cB coa co coa opreq2 vx cv vy cv wceq cB vx cv coa co cB vy cv coa
      co cA coa vx cv vy cv cB coa opreq2 opreq2d eqeq12d vx cv vy cv csuc wceq
      cA cB coa co vx cv coa co cA cB coa co vy cv csuc coa co cA cB vx cv coa
      co coa co cA cB vy cv csuc coa co coa co vx cv vy cv csuc cA cB coa co
      coa opreq2 vx cv vy cv csuc wceq cB vx cv coa co cB vy cv csuc coa co cA
      coa vx cv vy cv csuc cB coa opreq2 opreq2d eqeq12d vx cv cC wceq cA cB
      coa co vx cv coa co cA cB coa co cC coa co cA cB vx cv coa co coa co cA
      cB cC coa co coa co vx cv cC cA cB coa co coa opreq2 vx cv cC wceq cB vx
      cv coa co cB cC coa co cA coa vx cv cC cB coa opreq2 opreq2d eqeq12d cA
      con0 wcel cB con0 wcel wa cA cB coa co c0 coa co cA cB coa co cA cB c0
      coa co coa co cA con0 wcel cB con0 wcel wa cA cB coa co con0 wcel cA cB
      coa co c0 coa co cA cB coa co wceq cA cB oacl cA cB coa co oa0 syl cB
      con0 wcel cA cB c0 coa co coa co cA cB coa co wceq cA con0 wcel cB con0
      wcel cB c0 coa co cB cA coa cB oa0 opreq2d adantl eqtr4d cA con0 wcel cB
      con0 wcel wa vy cv con0 wcel cA cB coa co vy cv coa co cA cB vy cv coa co
      coa co wceq cA cB coa co vy cv csuc coa co cA cB vy cv csuc coa co coa co
      wceq wi cA con0 wcel cB con0 wcel wa vy cv con0 wcel wa cA cB coa co vy
      cv csuc coa co cA cB vy cv csuc coa co coa co wceq cA cB coa co vy cv coa
      co csuc cA cB vy cv coa co coa co csuc wceq cA cB coa co vy cv coa co cA
      cB vy cv coa co coa co wceq cA con0 wcel cB con0 wcel wa vy cv con0 wcel
      wa cA cB coa co vy cv csuc coa co cA cB coa co vy cv coa co csuc cA cB vy
      cv csuc coa co coa co cA cB vy cv coa co coa co csuc cA cB coa co con0
      wcel vy cv con0 wcel cA cB coa co vy cv csuc coa co cA cB coa co vy cv
      coa co csuc wceq cA con0 wcel cB con0 wcel wa cA cB coa co vy cv oasuc cA
      cB oacl sylan cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB vy cv csuc
      coa co coa co cA cB vy cv coa co coa co csuc wceq cA con0 wcel cB con0
      wcel vy cv con0 wcel wa wa cA cB vy cv csuc coa co coa co cA cB vy cv coa
      co csuc coa co cA cB vy cv coa co coa co csuc cB con0 wcel vy cv con0
      wcel wa cA cB vy cv csuc coa co coa co cA cB vy cv coa co csuc coa co
      wceq cA con0 wcel cB con0 wcel vy cv con0 wcel wa cB vy cv csuc coa co cB
      vy cv coa co csuc cA coa cB vy cv oasuc opreq2d adantl cA con0 wcel cB vy
      cv coa co con0 wcel cA cB vy cv coa co csuc coa co cA cB vy cv coa co coa
      co csuc wceq cB con0 wcel vy cv con0 wcel wa cA cB vy cv coa co oasuc cB
      vy cv oacl sylan2 eqtrd anassrs eqeq12d cA cB coa co vy cv coa co cA cB
      vy cv coa co coa co suceq syl5bir expcom vx cv wlim cA con0 wcel cB con0
      wcel wa cA cB coa co vy cv coa co cA cB vy cv coa co coa co wceq vy vx cv
      wral cA cB coa co vx cv coa co cA cB vx cv coa co coa co wceq vx cv wlim
      cA con0 wcel cB con0 wcel wa wa cA cB coa co vy cv coa co cA cB vy cv coa
      co coa co wceq vy vx cv wral wa vy vx cv cA cB coa co vy cv coa co ciun
      vy vx cv cA cB vy cv coa co coa co ciun cA cB coa co vx cv coa co cA cB
      vx cv coa co coa co cA cB coa co vy cv coa co cA cB vy cv coa co coa co
      wceq vy vx cv wral vy vx cv cA cB coa co vy cv coa co ciun vy vx cv cA cB
      vy cv coa co coa co ciun wceq vx cv wlim cA con0 wcel cB con0 wcel wa wa
      vy vx cv cA cB coa co vy cv coa co cA cB vy cv coa co coa co iuneq2
      adantl vx cv wlim cA con0 wcel cB con0 wcel wa wa cA cB coa co vx cv coa
      co vy vx cv cA cB coa co vy cv coa co ciun wceq cA cB coa co vy cv coa co
      cA cB vy cv coa co coa co wceq vy vx cv wral cA con0 wcel cB con0 wcel wa
      vx cv wlim cA cB coa co vx cv coa co vy vx cv cA cB coa co vy cv coa co
      ciun wceq cA cB coa co con0 wcel vx cv wlim cA cB coa co vx cv coa co vy
      vx cv cA cB coa co vy cv coa co ciun wceq cA con0 wcel cB con0 wcel wa cA
      cB coa co con0 wcel vx cv cvv wcel vx cv wlim cA cB coa co vx cv coa co
      vy vx cv cA cB coa co vy cv coa co ciun wceq vx visset vy cA cB coa co vx
      cv cvv oalim mpanr1 cA cB oacl sylan ancoms adantr vx cv wlim cA con0
      wcel cB con0 wcel wa wa cA cB vx cv coa co coa co vy vx cv cA cB vy cv
      coa co coa co ciun wceq cA cB coa co vy cv coa co cA cB vy cv coa co coa
      co wceq vy vx cv wral cA con0 wcel vx cv wlim cB con0 wcel cA cB vx cv
      coa co coa co vy vx cv cA cB vy cv coa co coa co ciun wceq cA con0 wcel
      vx cv wlim cB con0 wcel wa wa cA cB vx cv coa co coa co vz cB vx cv coa
      co cA vz cv coa co ciun vy vx cv cA cB vy cv coa co coa co ciun cA con0
      wcel cB vx cv coa co wlim cA cB vx cv coa co coa co vz cB vx cv coa co cA
      vz cv coa co ciun wceq vx cv wlim cB con0 wcel wa cA con0 wcel cB vx cv
      coa co cvv wcel cB vx cv coa co wlim cA cB vx cv coa co coa co vz cB vx
      cv coa co cA vz cv coa co ciun wceq cB vx cv coa oprex vz cA cB vx cv coa
      co cvv oalim mpanr1 cB con0 wcel vx cv wlim cB vx cv coa co wlim cB con0
      wcel vx cv cvv wcel vx cv wlim cB vx cv coa co wlim vx visset cB vx cv
      cvv oalimcl mpanr1 ancoms sylan2 cA con0 wcel vx cv wlim cB con0 wcel wa
      wa vz cB vx cv coa co cA vz cv coa co ciun vy vx cv cA cB vy cv coa co
      coa co ciun vx cv wlim cB con0 wcel wa cA con0 wcel vz cB vx cv coa co cA
      vz cv coa co ciun vy vx cv cA cB vy cv coa co coa co ciun wss vx cv wlim
      cB con0 wcel wa cA con0 wcel wa cA vz cv coa co cA cB vy cv coa co coa co
      wss vy vx cv wrex vz cB vx cv coa co wral vz cB vx cv coa co cA vz cv coa
      co ciun vy vx cv cA cB vy cv coa co coa co ciun wss vx cv wlim cB con0
      wcel wa cA con0 wcel wa cA vz cv coa co cA cB vy cv coa co coa co wss vy
      vx cv wrex vz cB vx cv coa co vx cv wlim cB con0 wcel cA con0 wcel vz cv
      cB vx cv coa co wcel cA vz cv coa co cA cB vy cv coa co coa co wss vy vx
      cv wrex wi vx cv wlim cB con0 wcel cA con0 wcel vz cv cB vx cv coa co
      wcel cA vz cv coa co cA cB vy cv coa co coa co wss vy vx cv wrex vx cv
      wlim vx cv con0 wcel cB con0 wcel cA con0 wcel vz cv cB vx cv coa co wcel
      wa cA vz cv coa co cA cB vy cv coa co coa co wss vy vx cv wrex wi wi vx
      cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv cvv limelon mpan
      vx cv wlim vx cv con0 wcel cB con0 wcel cA con0 wcel vz cv cB vx cv coa
      co wcel wa cA vz cv coa co cA cB vy cv coa co coa co wss vy vx cv wrex wi
      vx cv wlim vx cv con0 wcel cB con0 wcel wa wa cA con0 wcel vz cv cB vx cv
      coa co wcel wa vz cv con0 wcel cA vz cv coa co cA cB vy cv coa co coa co
      wss vy vx cv wrex vx cv con0 wcel cB con0 wcel wa cA con0 wcel vz cv cB
      vx cv coa co wcel wa vz cv con0 wcel wi vx cv wlim vx cv con0 wcel cB
      con0 wcel wa vz cv cB vx cv coa co wcel vz cv con0 wcel cA con0 wcel vx
      cv con0 wcel cB con0 wcel wa cB vx cv coa co con0 wcel vz cv cB vx cv coa
      co wcel vz cv con0 wcel wi cB con0 wcel vx cv con0 wcel cB vx cv coa co
      con0 wcel cB vx cv oacl ancoms cB vx cv coa co con0 wcel vz cv cB vx cv
      coa co wcel vz cv con0 wcel cB vx cv coa co vz cv onelon ex syl adantld
      adantl vx cv wlim vx cv con0 wcel cB con0 wcel wa wa cA con0 wcel vz cv
      cB vx cv coa co wcel wa vz cv con0 wcel cA vz cv coa co cA cB vy cv coa
      co coa co wss vy vx cv wrex vx cv wlim vx cv con0 wcel cB con0 wcel wa wa
      cA con0 wcel vz cv cB vx cv coa co wcel wa vz cv con0 wcel wa wa vz cv cB
      vy cv coa co wss vy vx cv wrex cA vz cv coa co cA cB vy cv coa co coa co
      wss vy vx cv wrex vx cv wlim vx cv con0 wcel cB con0 wcel wa wa cA con0
      wcel vz cv cB vx cv coa co wcel wa vz cv con0 wcel vz cv cB vy cv coa co
      wss vy vx cv wrex vx cv wlim vx cv con0 wcel cB con0 wcel wa wa vz cv cB
      vx cv coa co wcel vz cv con0 wcel vz cv cB vy cv coa co wss vy vx cv wrex
      wi cA con0 wcel vx cv wlim vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv
      coa co wcel vz cv con0 wcel vz cv cB vy cv coa co wss vy vx cv wrex wi wi
      vx cv wlim vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv coa co wcel vz
      cv con0 wcel vz cv cB vy cv coa co wss vy vx cv wrex vx cv wlim vx cv
      con0 wcel cB con0 wcel wa vz cv cB vx cv coa co wcel vz cv con0 wcel wa
      wa wa vz cv cB wcel cB vz cv wss wo vz cv cB vy cv coa co wss vy vx cv
      wrex vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv coa co wcel vz cv
      con0 wcel wa wa vz cv cB wcel cB vz cv wss wo vx cv wlim cB con0 wcel vz
      cv con0 wcel vz cv cB wcel cB vz cv wss wo vx cv con0 wcel vz cv cB vx cv
      coa co wcel cB word vz cv word vz cv cB wcel cB vz cv wss wo cB con0 wcel
      vz cv con0 wcel vz cv word cB word vz cv cB wcel cB vz cv wss wo vz cv cB
      ordtri2or ancoms cB eloni vz cv eloni syl2an ad2ant2l adantl vx cv wlim
      vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv coa co wcel vz cv con0
      wcel wa wa wa vz cv cB wcel vz cv cB vy cv coa co wss vy vx cv wrex cB vz
      cv wss vx cv wlim vx cv con0 wcel cB con0 wcel wa vz cv cB wcel vz cv cB
      vy cv coa co wss vy vx cv wrex wi vz cv cB vx cv coa co wcel vz cv con0
      wcel wa vx cv wlim cB con0 wcel vz cv cB wcel vz cv cB vy cv coa co wss
      vy vx cv wrex wi vx cv con0 wcel vx cv wlim cB con0 wcel vz cv cB wcel vz
      cv cB vy cv coa co wss vy vx cv wrex wi vx cv wlim cB con0 wcel vz cv cB
      wcel vz cv cB vy cv coa co wss vy vx cv wrex c0 vx cv wcel vz cv cB c0
      coa co wss vz cv cB vy cv coa co wss vy vx cv wrex vx cv wlim cB con0
      wcel vz cv cB wcel wa vz cv cB vy cv coa co wss vz cv cB c0 coa co wss vy
      c0 vx cv vy cv c0 wceq cB vy cv coa co cB c0 coa co vz cv vy cv c0 cB coa
      opreq2 sseq2d rcla4ev vx cv 0ellim cB con0 wcel vz cv cB wcel vz cv cB c0
      coa co wss cB con0 wcel vz cv cB wcel vz cv cB wss vz cv cB c0 coa co wss
      cB vz cv onelss cB con0 wcel cB c0 coa co cB vz cv cB oa0 sseq2d sylibrd
      imp syl2an exp32 imp adantrl adantrr vx cv con0 wcel cB con0 wcel wa vz
      cv cB vx cv coa co wcel vz cv con0 wcel wa wa cB vz cv wss vz cv cB vy cv
      coa co wss vy vx cv wrex wi vx cv wlim vx cv con0 wcel cB con0 wcel wa vz
      cv cB vx cv coa co wcel vz cv con0 wcel wa wa cB vz cv wss cB vy cv coa
      co vz cv wceq vy con0 wrex vz cv cB vy cv coa co wss vy vx cv wrex cB
      con0 wcel vz cv con0 wcel cB vz cv wss cB vy cv coa co vz cv wceq vy con0
      wrex wb vx cv con0 wcel vz cv cB vx cv coa co wcel vy cB vz cv oawordex
      ad2ant2l vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv coa co wcel cB vy
      cv coa co vz cv wceq vy con0 wrex vz cv cB vy cv coa co wss vy vx cv wrex
      wi vz cv con0 wcel vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv coa co
      wcel wa cB vy cv coa co vz cv wceq vz cv cB vy cv coa co wss vy con0 vx
      cv vy cv con0 wcel cB vy cv coa co vz cv wceq wa vx cv con0 wcel cB con0
      wcel wa vz cv cB vx cv coa co wcel wa vy cv vx cv wcel vz cv cB vy cv coa
      co wss wa vy cv con0 wcel cB vy cv coa co vz cv wceq wa vx cv con0 wcel
      cB con0 wcel wa vz cv cB vx cv coa co wcel vy cv vx cv wcel vz cv cB vy
      cv coa co wss wa vy cv con0 wcel cB vy cv coa co vz cv wceq wa vx cv con0
      wcel cB con0 wcel wa wa vz cv cB vx cv coa co wcel wa vy cv vx cv wcel vz
      cv cB vy cv coa co wss vy cv con0 wcel cB vy cv coa co vz cv wceq wa vx
      cv con0 wcel cB con0 wcel wa wa vy cv vx cv wcel vz cv cB vx cv coa co
      wcel vy cv con0 wcel vx cv con0 wcel cB con0 wcel wa cB vy cv coa co vz
      cv wceq vy cv vx cv wcel vz cv cB vx cv coa co wcel wb vy cv con0 wcel vx
      cv con0 wcel cB con0 wcel wa wa vy cv vx cv wcel cB vy cv coa co cB vx cv
      coa co wcel cB vy cv coa co vz cv wceq vz cv cB vx cv coa co wcel vy cv
      con0 wcel vx cv con0 wcel cB con0 wcel vy cv vx cv wcel cB vy cv coa co
      cB vx cv coa co wcel wb vy cv vx cv cB oaord 3expb cB vy cv coa co vz cv
      cB vx cv coa co eleq1 sylan9bb an1rs biimpar vy cv con0 wcel cB vy cv coa
      co vz cv wceq wa vz cv cB vy cv coa co wss vx cv con0 wcel cB con0 wcel
      wa vz cv cB vx cv coa co wcel cB vy cv coa co vz cv wceq vz cv cB vy cv
      coa co wss vy cv con0 wcel vz cv cB vy cv coa co eqimss2 adantl ad2antrr
      jca anasss expcom r19.22dv2 adantrr sylbid adantl jaod mpd exp45 imp
      adantld imp32 vx cv wlim vx cv con0 wcel cB con0 wcel wa wa cA con0 wcel
      vz cv cB vx cv coa co wcel wa vz cv con0 wcel wa wa vz cv cB vy cv coa co
      wss cA vz cv coa co cA cB vy cv coa co coa co wss vy vx cv vz cv con0
      wcel cB vy cv coa co con0 wcel cA con0 wcel vz cv cB vy cv coa co wss cA
      vz cv coa co cA cB vy cv coa co coa co wss wb vx cv wlim vx cv con0 wcel
      cB con0 wcel wa wa cA con0 wcel vz cv cB vx cv coa co wcel wa vz cv con0
      wcel wa wa vy cv vx cv wcel wa vz cv cB vy cv coa co cA oaword vx cv wlim
      vx cv con0 wcel cB con0 wcel wa wa cA con0 wcel vz cv cB vx cv coa co
      wcel wa vz cv con0 wcel vy cv vx cv wcel simplrr vx cv wlim vx cv con0
      wcel cB con0 wcel wa wa vy cv vx cv wcel cB vy cv coa co con0 wcel cA
      con0 wcel vz cv cB vx cv coa co wcel wa vz cv con0 wcel wa vx cv con0
      wcel cB con0 wcel wa vy cv vx cv wcel cB vy cv coa co con0 wcel vx cv
      wlim vx cv con0 wcel cB con0 wcel vy cv vx cv wcel cB vy cv coa co con0
      wcel cB con0 wcel vx cv con0 wcel vy cv vx cv wcel cB vy cv coa co con0
      wcel wi cB con0 wcel vx cv con0 wcel vy cv vx cv wcel cB vy cv coa co
      con0 wcel cB con0 wcel vy cv con0 wcel cB vy cv coa co con0 wcel vx cv
      con0 wcel vy cv vx cv wcel wa cB vy cv oacl vx cv vy cv onelon sylan2
      exp32 com12 imp31 adantll adantlr cA con0 wcel vz cv cB vx cv coa co wcel
      wa vz cv con0 wcel wa cA con0 wcel vx cv wlim vx cv con0 wcel cB con0
      wcel wa wa vy cv vx cv wcel cA con0 wcel vz cv cB vx cv coa co wcel vz cv
      con0 wcel simpll ad2antlr syl3anc rexbidva mpbid exp32 mpdd exp32 mpd
      exp4a imp31 r19.21aiv vz vy cB vx cv coa co vx cv cA vz cv coa co cA cB
      vy cv coa co coa co iunss2 syl ancoms vx cv wlim cB con0 wcel wa vy vx cv
      cA cB vy cv coa co coa co ciun vz cB vx cv coa co cA vz cv coa co ciun
      wss cA con0 wcel vx cv con0 wcel cB con0 wcel vy vx cv cA cB vy cv coa co
      coa co ciun vz cB vx cv coa co cA vz cv coa co ciun wss vx cv wlim vx cv
      con0 wcel cB con0 wcel wa vw vy vx cv cA cB vy cv coa co coa co ciun vz
      cB vx cv coa co cA vz cv coa co ciun vx cv con0 wcel cB con0 wcel wa vw
      cv cA cB vy cv coa co coa co wcel vy vx cv wrex vw cv cA vz cv coa co
      wcel vz cB vx cv coa co wrex vw cv vy vx cv cA cB vy cv coa co coa co
      ciun wcel vw cv vz cB vx cv coa co cA vz cv coa co ciun wcel vx cv con0
      wcel cB con0 wcel wa vw cv cA cB vy cv coa co coa co wcel vw cv cA vz cv
      coa co wcel vz cB vx cv coa co wrex vy vx cv vx cv con0 wcel cB con0 wcel
      wa vy cv vx cv wcel vw cv cA cB vy cv coa co coa co wcel vw cv cA vz cv
      coa co wcel vz cB vx cv coa co wrex vx cv con0 wcel cB con0 wcel wa vy cv
      vx cv wcel vw cv cA cB vy cv coa co coa co wcel wa cB vy cv coa co cB vx
      cv coa co wcel vw cv cA cB vy cv coa co coa co wcel wa vw cv cA vz cv coa
      co wcel vz cB vx cv coa co wrex vx cv con0 wcel cB con0 wcel wa vy cv vx
      cv wcel cB vy cv coa co cB vx cv coa co wcel vw cv cA cB vy cv coa co coa
      co wcel vy cv vx cv cB oaordi anim1d vw cv cA vz cv coa co wcel vw cv cA
      cB vy cv coa co coa co wcel vz cB vy cv coa co cB vx cv coa co vz cv cB
      vy cv coa co wceq cA vz cv coa co cA cB vy cv coa co coa co vw cv vz cv
      cB vy cv coa co cA coa opreq2 eleq2d rcla4ev syl6 exp3a r19.23adv vy vw
      cv vx cv cA cB vy cv coa co coa co eliun vz vw cv cB vx cv coa co cA vz
      cv coa co eliun 3imtr4g ssrdv vx cv cvv wcel vx cv wlim vx cv con0 wcel
      vx visset vx cv cvv limelon mpan sylan adantl eqssd eqtrd an1s adantr
      3eqtr4d exp31 tfinds3 com12 3impia $.
      $( [25-Dec-2004] $) $( [10-Dec-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z B $.
    $( Recursive definition of ordinal addition.  Exercise 25 of [Enderton]
       p. 240. $)
    oarec $p |- ( ( A e. On /\ B e. On ) ->
                ( A +o B ) = ( A u. { x | E. y e. B x = ( A +o y ) } ) ) $=
      cB con0 wcel cA con0 wcel cA cB coa co cA vx cv cA vy cv coa co wceq vy
      cB wrex vx cab cun wceq cA vz cv coa co cA vx cv cA vy cv coa co wceq vy
      vz cv wrex vx cab cun wceq cA c0 coa co cA vx cv cA vy cv coa co wceq vy
      c0 wrex vx cab cun wceq cA vw cv coa co cA vx cv cA vy cv coa co wceq vy
      vw cv wrex vx cab cun wceq cA vw cv csuc coa co cA vx cv cA vy cv coa co
      wceq vy vw cv csuc wrex vx cab cun wceq cA cB coa co cA vx cv cA vy cv
      coa co wceq vy cB wrex vx cab cun wceq vz vw cB cA con0 wcel vz cv c0
      wceq cA vz cv coa co cA c0 coa co cA vx cv cA vy cv coa co wceq vy vz cv
      wrex vx cab cun cA vx cv cA vy cv coa co wceq vy c0 wrex vx cab cun vz cv
      c0 cA coa opreq2 vz cv c0 wceq vx cv cA vy cv coa co wceq vy vz cv wrex
      vx cab vx cv cA vy cv coa co wceq vy c0 wrex vx cab cA vz cv c0 wceq vx
      cv cA vy cv coa co wceq vy vz cv wrex vx cv cA vy cv coa co wceq vy c0
      wrex vx vx cv cA vy cv coa co wceq vy vz cv c0 rexeq1 abbidv uneq2d
      eqeq12d vz cv vw cv wceq cA vz cv coa co cA vw cv coa co cA vx cv cA vy
      cv coa co wceq vy vz cv wrex vx cab cun cA vx cv cA vy cv coa co wceq vy
      vw cv wrex vx cab cun vz cv vw cv cA coa opreq2 vz cv vw cv wceq vx cv cA
      vy cv coa co wceq vy vz cv wrex vx cab vx cv cA vy cv coa co wceq vy vw
      cv wrex vx cab cA vz cv vw cv wceq vx cv cA vy cv coa co wceq vy vz cv
      wrex vx cv cA vy cv coa co wceq vy vw cv wrex vx vx cv cA vy cv coa co
      wceq vy vz cv vw cv rexeq1 abbidv uneq2d eqeq12d vz cv vw cv csuc wceq cA
      vz cv coa co cA vw cv csuc coa co cA vx cv cA vy cv coa co wceq vy vz cv
      wrex vx cab cun cA vx cv cA vy cv coa co wceq vy vw cv csuc wrex vx cab
      cun vz cv vw cv csuc cA coa opreq2 vz cv vw cv csuc wceq vx cv cA vy cv
      coa co wceq vy vz cv wrex vx cab vx cv cA vy cv coa co wceq vy vw cv csuc
      wrex vx cab cA vz cv vw cv csuc wceq vx cv cA vy cv coa co wceq vy vz cv
      wrex vx cv cA vy cv coa co wceq vy vw cv csuc wrex vx vx cv cA vy cv coa
      co wceq vy vz cv vw cv csuc rexeq1 abbidv uneq2d eqeq12d vz cv cB wceq cA
      vz cv coa co cA cB coa co cA vx cv cA vy cv coa co wceq vy vz cv wrex vx
      cab cun cA vx cv cA vy cv coa co wceq vy cB wrex vx cab cun vz cv cB cA
      coa opreq2 vz cv cB wceq vx cv cA vy cv coa co wceq vy vz cv wrex vx cab
      vx cv cA vy cv coa co wceq vy cB wrex vx cab cA vz cv cB wceq vx cv cA vy
      cv coa co wceq vy vz cv wrex vx cv cA vy cv coa co wceq vy cB wrex vx vx
      cv cA vy cv coa co wceq vy vz cv cB rexeq1 abbidv uneq2d eqeq12d cA con0
      wcel cA c0 coa co cA cA vx cv cA vy cv coa co wceq vy c0 wrex vx cab cun
      cA oa0 cA vx cv cA vy cv coa co wceq vy c0 wrex vx cab cun cA c0 cun cA
      vx cv cA vy cv coa co wceq vy c0 wrex vx cab c0 cA vx cv cA vy cv coa co
      wceq vy c0 wrex vx wex wn vx cv cA vy cv coa co wceq vy c0 wrex vx cab c0
      wceq vx cv cA vy cv coa co wceq vy c0 wrex vx vx cv cA vy cv coa co wceq
      vy rex0 nex vx cv cA vy cv coa co wceq vy c0 wrex vx wex vx cv cA vy cv
      coa co wceq vy c0 wrex vx cab c0 vx cv cA vy cv coa co wceq vy c0 wrex vx
      abn0 necon1bbii mpbi uneq2i cA un0 eqtr2i syl6eq cA con0 wcel vw cv con0
      wcel cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab
      cun wceq cA vw cv csuc coa co cA vx cv cA vy cv coa co wceq vy vw cv csuc
      wrex vx cab cun wceq wi cA con0 wcel vw cv con0 wcel cA vw cv coa co cA
      vx cv cA vy cv coa co wceq vy vw cv wrex vx cab cun wceq cA vw cv csuc
      coa co cA vx cv cA vy cv coa co wceq vy vw cv csuc wrex vx cab cun wceq
      cA con0 wcel vw cv con0 wcel wa cA vw cv coa co cA vx cv cA vy cv coa co
      wceq vy vw cv wrex vx cab cun wceq cA vw cv csuc coa co cA vw cv coa co
      csuc cA vx cv cA vy cv coa co wceq vy vw cv csuc wrex vx cab cun cA vw cv
      oasuc cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab
      cun wceq cA vw cv coa co cA vw cv coa co csn cun cA vx cv cA vy cv coa co
      wceq vy vw cv wrex vx cab cun vx cv cA vw cv coa co wceq vx cab cun cA vw
      cv coa co csuc cA vx cv cA vy cv coa co wceq vy vw cv csuc wrex vx cab
      cun cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab
      cun wceq cA vw cv coa co csn vx cv cA vw cv coa co wceq vx cab wceq cA vw
      cv coa co cA vw cv coa co csn cun cA vx cv cA vy cv coa co wceq vy vw cv
      wrex vx cab cun vx cv cA vw cv coa co wceq vx cab cun wceq vx cA vw cv
      coa co df-sn cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex
      vx cab cun cA vw cv coa co csn vx cv cA vw cv coa co wceq vx cab uneq12
      mpan2 cA vw cv coa co df-suc cA vx cv cA vy cv coa co wceq vy vw cv csuc
      wrex vx cab cun cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab vx cv
      cA vw cv coa co wceq vx cab cun cun cA vx cv cA vy cv coa co wceq vy vw
      cv wrex vx cab cun vx cv cA vw cv coa co wceq vx cab cun vx cv cA vy cv
      coa co wceq vy vw cv csuc wrex vx cab vx cv cA vy cv coa co wceq vy vw cv
      wrex vx cab vx cv cA vw cv coa co wceq vx cab cun cA vx cv cA vy cv coa
      co wceq vy vw cv csuc wrex vx cab vx cv cA vy cv coa co wceq vy vw cv
      wrex vx cv cA vw cv coa co wceq wo vx cab vx cv cA vy cv coa co wceq vy
      vw cv wrex vx cab vx cv cA vw cv coa co wceq vx cab cun vx cv cA vy cv
      coa co wceq vy vw cv csuc wrex vx cv cA vy cv coa co wceq vy vw cv wrex
      vx cv cA vw cv coa co wceq wo vx vy cv vw cv csuc wcel vx cv cA vy cv coa
      co wceq wa vy wex vy cv vw cv wcel vx cv cA vy cv coa co wceq wa vy wex
      vy cv vw cv wceq vx cv cA vy cv coa co wceq wa vy wex wo vx cv cA vy cv
      coa co wceq vy vw cv csuc wrex vx cv cA vy cv coa co wceq vy vw cv wrex
      vx cv cA vw cv coa co wceq wo vy cv vw cv csuc wcel vx cv cA vy cv coa co
      wceq wa vy wex vy cv vw cv wcel vx cv cA vy cv coa co wceq wa vy cv vw cv
      wceq vx cv cA vy cv coa co wceq wa wo vy wex vy cv vw cv wcel vx cv cA vy
      cv coa co wceq wa vy wex vy cv vw cv wceq vx cv cA vy cv coa co wceq wa
      vy wex wo vy cv vw cv csuc wcel vx cv cA vy cv coa co wceq wa vy cv vw cv
      wcel vx cv cA vy cv coa co wceq wa vy cv vw cv wceq vx cv cA vy cv coa co
      wceq wa wo vy vy cv vw cv csuc wcel vx cv cA vy cv coa co wceq wa vy cv
      vw cv wcel vy cv vw cv wceq wo vx cv cA vy cv coa co wceq wa vy cv vw cv
      wcel vx cv cA vy cv coa co wceq wa vy cv vw cv wceq vx cv cA vy cv coa co
      wceq wa wo vy cv vw cv csuc wcel vy cv vw cv wcel vy cv vw cv wceq wo vx
      cv cA vy cv coa co wceq vy cv vw cv vy visset elsuc anbi1i vy cv vw cv
      wcel vy cv vw cv wceq vx cv cA vy cv coa co wceq andir bitri exbii vy cv
      vw cv wcel vx cv cA vy cv coa co wceq wa vy cv vw cv wceq vx cv cA vy cv
      coa co wceq wa vy 19.43 bitri vx cv cA vy cv coa co wceq vy vw cv csuc
      df-rex vx cv cA vy cv coa co wceq vy vw cv wrex vy cv vw cv wcel vx cv cA
      vy cv coa co wceq wa vy wex vx cv cA vw cv coa co wceq vy cv vw cv wceq
      vx cv cA vy cv coa co wceq wa vy wex vx cv cA vy cv coa co wceq vy vw cv
      df-rex vy cv vw cv wceq vx cv cA vy cv coa co wceq wa vy wex vx cv cA vw
      cv coa co wceq vx cv cA vy cv coa co wceq vx cv cA vw cv coa co wceq vy
      vw cv vw visset vy cv vw cv wceq cA vy cv coa co cA vw cv coa co vx cv vy
      cv vw cv cA coa opreq2 eqeq2d ceqsexv bicomi orbi12i 3bitr4i abbii vx cv
      cA vy cv coa co wceq vy vw cv wrex vx cv cA vw cv coa co wceq vx unab
      eqtr4i uneq2i cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab vx cv cA
      vw cv coa co wceq vx cab unass eqtr4i 3eqtr4g sylan9eq exp31 com12 vz cv
      wlim cA con0 wcel cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw cv
      wrex vx cab cun wceq vw vz cv wral cA vz cv coa co cA vx cv cA vy cv coa
      co wceq vy vz cv wrex vx cab cun wceq vz cv wlim cA con0 wcel wa cA vw cv
      coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab cun wceq vw vz
      cv wral wa cA vz cv coa co vw vz cv cA vw cv coa co ciun vw vz cv cA vx
      cv cA vy cv coa co wceq vy vw cv wrex vx cab cun ciun cA vx cv cA vy cv
      coa co wceq vy vz cv wrex vx cab cun vz cv wlim cA con0 wcel wa cA vz cv
      coa co vw vz cv cA vw cv coa co ciun wceq cA vw cv coa co cA vx cv cA vy
      cv coa co wceq vy vw cv wrex vx cab cun wceq vw vz cv wral cA con0 wcel
      vz cv wlim cA vz cv coa co vw vz cv cA vw cv coa co ciun wceq cA con0
      wcel vz cv cvv wcel vz cv wlim cA vz cv coa co vw vz cv cA vw cv coa co
      ciun wceq vz visset vw cA vz cv cvv oalim mpanr1 ancoms adantr cA vw cv
      coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab cun wceq vw vz
      cv wral vw vz cv cA vw cv coa co ciun vw vz cv cA vx cv cA vy cv coa co
      wceq vy vw cv wrex vx cab cun ciun wceq vz cv wlim cA con0 wcel wa vw vz
      cv cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab cun
      iuneq2 adantl vz cv wlim vw vz cv cA vx cv cA vy cv coa co wceq vy vw cv
      wrex vx cab cun ciun cA vx cv cA vy cv coa co wceq vy vz cv wrex vx cab
      cun wceq cA con0 wcel cA vw cv coa co cA vx cv cA vy cv coa co wceq vy vw
      cv wrex vx cab cun wceq vw vz cv wral vz cv wlim vw vz cv cA ciun vw vz
      cv vx cv cA vy cv coa co wceq vy vw cv wrex vx cab ciun cun cA vx cv cA
      vy cv coa co wceq vy vz cv wrex vx cab cun vw vz cv cA vx cv cA vy cv coa
      co wceq vy vw cv wrex vx cab cun ciun vz cv wlim vw vz cv cA ciun cA vw
      vz cv vx cv cA vy cv coa co wceq vy vw cv wrex vx cab ciun vx cv cA vy cv
      coa co wceq vy vz cv wrex vx cab vz cv wlim c0 vz cv wcel vz cv c0 wne vw
      vz cv cA ciun cA wceq vz cv 0ellim vz cv c0 ne0i vw vz cv cA iunconst
      3syl vz cv wlim vx cv cA vy cv coa co wceq vy vw cv wrex vw vz cv wrex vx
      cab vx cv cA vy cv coa co wceq vy vz cv wrex vx cab vw vz cv vx cv cA vy
      cv coa co wceq vy vw cv wrex vx cab ciun vz cv wlim vx cv cA vy cv coa co
      wceq vy vw cv wrex vw vz cv wrex vx cv cA vy cv coa co wceq vy vz cv wrex
      vx vz cv wlim vx cv cA vy cv coa co wceq vy vw cv wrex vw vz cv wrex vx
      cv cA vy cv coa co wceq vy vz cv wrex vz cv wlim vx cv cA vy cv coa co
      wceq vy vw cv wrex vx cv cA vy cv coa co wceq vy vz cv wrex vw vz cv vz
      cv wlim vw cv vz cv wcel wa vx cv cA vy cv coa co wceq vx cv cA vy cv coa
      co wceq vy vw cv vz cv vz cv wlim vw cv vz cv wcel wa vy cv vw cv wcel vy
      cv vz cv wcel vx cv cA vy cv coa co wceq vz cv wlim vw cv vz cv wcel vy
      cv vw cv wcel vy cv vz cv wcel wi vz cv wlim vy cv vw cv wcel vw cv vz cv
      wcel vy cv vz cv wcel vz cv wlim vy cv vw cv wcel vw cv vz cv wcel vy cv
      vz cv wcel vz cv wlim vz cv word vy cv vw cv wcel vw cv vz cv wcel wa vy
      cv vz cv wcel wi vz cv limord vy cv vw cv vz cv ordtr1 syl exp3a com23
      imp anim1d r19.22dv2 r19.23adva vz cv wlim vx cv cA vy cv coa co wceq vx
      cv cA vy cv coa co wceq vy vw cv wrex vw vz cv wrex vy vz cv vz cv wlim
      vy ax-17 vx cv cA vy cv coa co wceq vy vw cv wrex vy vw vz cv vw cv vz cv
      wcel vy ax-17 vx cv cA vy cv coa co wceq vy vw cv hbre1 hbrex vz cv wlim
      vy cv vz cv wcel vx cv cA vy cv coa co wceq vx cv cA vy cv coa co wceq vy
      vw cv wrex vw vz cv wrex vz cv wlim vy cv vz cv wcel vx cv cA vy cv coa
      co wceq wa vy cv csuc vz cv wcel vy cv vy cv csuc wcel wa vx cv cA vy cv
      coa co wceq wa vx cv cA vy cv coa co wceq vy vw cv wrex vw vz cv wrex vz
      cv wlim vy cv vz cv wcel vy cv csuc vz cv wcel vy cv vy cv csuc wcel wa
      vx cv cA vy cv coa co wceq vz cv wlim vy cv vz cv wcel vy cv csuc vz cv
      wcel vy cv vy cv csuc wcel vz cv wlim vy cv vz cv wcel vy cv csuc vz cv
      wcel vz cv vy cv limsuc biimpd vy cv vz cv wcel vy cv vy cv csuc wcel wi
      vz cv wlim vy cv vz cv sucidg a1i jcad anim1d vy cv csuc vz cv wcel vy cv
      vy cv csuc wcel vx cv cA vy cv coa co wceq vx cv cA vy cv coa co wceq vy
      vw cv wrex vw vz cv wrex vy cv csuc vz cv wcel vy cv vy cv csuc wcel vx
      cv cA vy cv coa co wceq wa wa vy cv vw cv wcel vx cv cA vy cv coa co wceq
      wa vw vz cv wrex vx cv cA vy cv coa co wceq vy vw cv wrex vw vz cv wrex
      vy cv vw cv wcel vx cv cA vy cv coa co wceq wa vy cv vy cv csuc wcel vx
      cv cA vy cv coa co wceq wa vw vy cv csuc vz cv vw cv vy cv csuc wceq vy
      cv vw cv wcel vy cv vy cv csuc wcel vx cv cA vy cv coa co wceq vw cv vy
      cv csuc vy cv eleq2 anbi1d rcla4ev vy cv vw cv wcel vx cv cA vy cv coa co
      wceq wa vx cv cA vy cv coa co wceq vy vw cv wrex vw vz cv vx cv cA vy cv
      coa co wceq vy vw cv ra4e r19.22si syl anassrs syl6 exp3a r19.23ad impbid
      abbidv vx cv cA vy cv coa co wceq vy vw cv wrex vw vx vz cv iunab syl5eq
      uneq12d vw vz cv cA vx cv cA vy cv coa co wceq vy vw cv wrex vx cab iunun
      syl5eq ad2antrr 3eqtrd exp31 tfinds3 impcom $.
      $( [24-Jan-2005] $) $( [26-Dec-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Ordering property of ordinal multiplication.  Half of Proposition 8.19
       of [TakeutiZaring] p. 63. $)
    omordi $p |- ( ( ( B e. On /\ C e. On ) /\ (/) e. C ) ->
                 ( A e. B -> ( C .o A ) e. ( C .o B ) ) ) $=
      cB con0 wcel cC con0 wcel c0 cC wcel cA cB wcel cC cA comu co cC cB comu
      co wcel wi cB con0 wcel cA cB wcel c0 cC wcel cC con0 wcel cC cA comu co
      cC cB comu co wcel cB con0 wcel cA cB wcel cC con0 wcel c0 cC wcel cC cA
      comu co cC cB comu co wcel cB con0 wcel cA cB wcel cA con0 wcel cC con0
      wcel c0 cC wcel cC cA comu co cC cB comu co wcel wi wi cB con0 wcel cA cB
      wcel cA con0 wcel cB cA onelon ex cB con0 wcel cA cB wcel cA con0 wcel cC
      con0 wcel c0 cC wcel cC cA comu co cC cB comu co wcel wi cB con0 wcel cA
      cB wcel cA con0 wcel cC con0 wcel wa c0 cC wcel cC cA comu co cC cB comu
      co wcel cB con0 wcel cA con0 wcel cC con0 wcel wa c0 cC wcel wa cA cB
      wcel cC cA comu co cC cB comu co wcel cA vx cv wcel cC cA comu co cC vx
      cv comu co wcel wi cA c0 wcel cC cA comu co cC c0 comu co wcel wi cA vy
      cv wcel cC cA comu co cC vy cv comu co wcel wi cA vy cv csuc wcel cC cA
      comu co cC vy cv csuc comu co wcel wi cA cB wcel cC cA comu co cC cB comu
      co wcel wi vx vy cB cA con0 wcel cC con0 wcel wa c0 cC wcel wa vx cv c0
      wceq cA vx cv wcel cA c0 wcel cC cA comu co cC vx cv comu co wcel cC cA
      comu co cC c0 comu co wcel vx cv c0 cA eleq2 vx cv c0 wceq cC vx cv comu
      co cC c0 comu co cC cA comu co vx cv c0 cC comu opreq2 eleq2d imbi12d vx
      cv vy cv wceq cA vx cv wcel cA vy cv wcel cC cA comu co cC vx cv comu co
      wcel cC cA comu co cC vy cv comu co wcel vx cv vy cv cA eleq2 vx cv vy cv
      wceq cC vx cv comu co cC vy cv comu co cC cA comu co vx cv vy cv cC comu
      opreq2 eleq2d imbi12d vx cv vy cv csuc wceq cA vx cv wcel cA vy cv csuc
      wcel cC cA comu co cC vx cv comu co wcel cC cA comu co cC vy cv csuc comu
      co wcel vx cv vy cv csuc cA eleq2 vx cv vy cv csuc wceq cC vx cv comu co
      cC vy cv csuc comu co cC cA comu co vx cv vy cv csuc cC comu opreq2
      eleq2d imbi12d vx cv cB wceq cA vx cv wcel cA cB wcel cC cA comu co cC vx
      cv comu co wcel cC cA comu co cC cB comu co wcel vx cv cB cA eleq2 vx cv
      cB wceq cC vx cv comu co cC cB comu co cC cA comu co vx cv cB cC comu
      opreq2 eleq2d imbi12d cA c0 wcel cC cA comu co cC c0 comu co wcel wi cA
      con0 wcel cC con0 wcel wa c0 cC wcel wa cA c0 wcel cC cA comu co cC c0
      comu co wcel cA noel pm2.21i a1i vy cv con0 wcel cA con0 wcel cC con0
      wcel wa c0 cC wcel cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi
      cA vy cv csuc wcel cC cA comu co cC vy cv csuc comu co wcel wi wi vy cv
      con0 wcel cC con0 wcel c0 cC wcel cA vy cv wcel cC cA comu co cC vy cv
      comu co wcel wi cA vy cv csuc wcel cC cA comu co cC vy cv csuc comu co
      wcel wi wi wi cA con0 wcel cC con0 wcel vy cv con0 wcel c0 cC wcel cA vy
      cv wcel cC cA comu co cC vy cv comu co wcel wi cA vy cv csuc wcel cC cA
      comu co cC vy cv csuc comu co wcel wi wi wi cC con0 wcel vy cv con0 wcel
      c0 cC wcel cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi cA vy cv
      csuc wcel cC cA comu co cC vy cv csuc comu co wcel wi cC con0 wcel vy cv
      con0 wcel wa c0 cC wcel cA vy cv wcel cC cA comu co cC vy cv comu co wcel
      wi wa wa cA vy cv csuc wcel cC cA comu co cC vy cv comu co cC coa co wcel
      cC cA comu co cC vy cv csuc comu co wcel cC con0 wcel vy cv con0 wcel wa
      c0 cC wcel cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi wa wa cA
      vy cv wcel cA vy cv wceq wo cC cA comu co cC vy cv comu co cC coa co wcel
      cA vy cv csuc wcel cC vy cv comu co con0 wcel cC con0 wcel wa c0 cC wcel
      cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi wa cA vy cv wcel cA
      vy cv wceq wo cC cA comu co cC vy cv comu co cC coa co wcel wi cC con0
      wcel vy cv con0 wcel wa cC vy cv comu co con0 wcel cC con0 wcel wa c0 cC
      wcel cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi wa wa cA vy cv
      wcel cC cA comu co cC vy cv comu co cC coa co wcel cA vy cv wceq cC vy cv
      comu co con0 wcel cC con0 wcel wa cA vy cv wcel cC cA comu co cC vy cv
      comu co wcel wi cA vy cv wcel cC cA comu co cC vy cv comu co cC coa co
      wcel wi c0 cC wcel cC vy cv comu co con0 wcel cC con0 wcel wa cA vy cv
      wcel cC cA comu co cC vy cv comu co wcel wi cA vy cv wcel cC cA comu co
      cC vy cv comu co cC coa co wcel wi cC vy cv comu co con0 wcel cC con0
      wcel wa cC cA comu co cC vy cv comu co wcel cC cA comu co cC vy cv comu
      co cC coa co wcel cA vy cv wcel cC vy cv comu co con0 wcel cC con0 wcel
      wa cC vy cv comu co cC vy cv comu co cC coa co cC cA comu co cC vy cv
      comu co cC oaword1 sseld imim2d imp adantrl cC vy cv comu co con0 wcel cC
      con0 wcel wa c0 cC wcel cA vy cv wceq cC cA comu co cC vy cv comu co cC
      coa co wcel wi cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi cA vy
      cv wceq cC cA comu co cC vy cv comu co cC coa co wcel cC vy cv comu co cC
      vy cv comu co cC coa co wcel cC vy cv comu co con0 wcel cC con0 wcel wa
      c0 cC wcel wa cA vy cv wceq cC cA comu co cC vy cv comu co cC vy cv comu
      co cC coa co cA vy cv cC comu opreq2 eleq1d cC vy cv comu co con0 wcel cC
      con0 wcel wa c0 cC wcel cC vy cv comu co cC vy cv comu co cC coa co wcel
      cC vy cv comu co cC oaord1 biimpa syl5cbir adantrr jaod cC con0 wcel vy
      cv con0 wcel wa cC vy cv comu co con0 wcel cC con0 wcel cC vy cv omcl cC
      con0 wcel vy cv con0 wcel pm3.26 jca sylan cA vy cv elsuci syl5 cC con0
      wcel vy cv con0 wcel wa cC cA comu co cC vy cv csuc comu co wcel cC cA
      comu co cC vy cv comu co cC coa co wcel wb c0 cC wcel cA vy cv wcel cC cA
      comu co cC vy cv comu co wcel wi wa cC con0 wcel vy cv con0 wcel wa cC vy
      cv csuc comu co cC vy cv comu co cC coa co cC cA comu co cC vy cv omsuc
      eleq2d adantr sylibrd exp43 com12 adantld imp3a vx cv wlim cA con0 wcel
      cC con0 wcel wa c0 cC wcel wa cA vx cv wcel cC cA comu co cC vx cv comu
      co wcel wi cA vy cv wcel cC cA comu co cC vy cv comu co wcel wi vy vx cv
      wral vx cv wlim cA con0 wcel cC con0 wcel c0 cC wcel cA vx cv wcel cC cA
      comu co cC vx cv comu co wcel wi cC con0 wcel cA con0 wcel vx cv wlim c0
      cC wcel cA vx cv wcel cC cA comu co cC vx cv comu co wcel wi wi cC con0
      wcel cA con0 wcel vx cv wlim c0 cC wcel cA vx cv wcel cC cA comu co cC vx
      cv comu co wcel wi cC con0 wcel cA con0 wcel wa vx cv wlim c0 cC wcel wa
      wa cA vx cv wcel cC cA comu co cC vx cv comu co wcel cC con0 wcel cA con0
      wcel wa vx cv wlim c0 cC wcel wa wa cA vx cv wcel wa cC cA csuc comu co
      cC vx cv comu co cC cA comu co cC con0 wcel vx cv wlim wa cA vx cv wcel
      cC cA csuc comu co cC vx cv comu co wss cC con0 wcel cA con0 wcel wa vx
      cv wlim c0 cC wcel wa wa cC con0 wcel vx cv wlim wa cA vx cv wcel wa cC
      cA csuc comu co vy vx cv cC vy cv comu co ciun cC vx cv comu co vx cv
      wlim cA vx cv wcel cC cA csuc comu co vy vx cv cC vy cv comu co ciun wss
      cC con0 wcel vx cv wlim cA vx cv wcel wa cA csuc vx cv wcel cC cA csuc
      comu co vy vx cv cC vy cv comu co ciun wss vx cv wlim cA vx cv wcel cA
      csuc vx cv wcel vx cv cA limsuc biimpa vy vx cv cC vy cv comu co cA csuc
      cC cA csuc comu co vy cv cA csuc cC comu opreq2 ssiun2s syl adantll cC
      con0 wcel vx cv wlim wa cC vx cv comu co vy vx cv cC vy cv comu co ciun
      wceq cA vx cv wcel cC con0 wcel vx cv cvv wcel vx cv wlim cC vx cv comu
      co vy vx cv cC vy cv comu co ciun wceq vx visset vy cC vx cv cvv omlim
      mpanr1 adantr sseqtr4d cC con0 wcel vx cv wlim cC con0 wcel vx cv wlim wa
      cA con0 wcel c0 cC wcel cC con0 wcel vx cv wlim wa id ad2ant2r sylan cC
      con0 wcel cA con0 wcel wa vx cv wlim c0 cC wcel wa wa cC cA comu co cC cA
      csuc comu co wcel cA vx cv wcel cC con0 wcel cA con0 wcel wa c0 cC wcel
      cC cA comu co cC cA csuc comu co wcel vx cv wlim cC con0 wcel cA con0
      wcel wa c0 cC wcel wa cC cA comu co cC cA comu co cC coa co cC cA csuc
      comu co cC con0 wcel cA con0 wcel wa c0 cC wcel cC cA comu co cC cA comu
      co cC coa co wcel cC con0 wcel cA con0 wcel c0 cC wcel cC cA comu co cC
      cA comu co cC coa co wcel wb cC cA comu co con0 wcel cC con0 wcel c0 cC
      wcel cC cA comu co cC cA comu co cC coa co wcel wb cC con0 wcel cA con0
      wcel wa cC cA comu co cC oaord1 cC cA omcl sylan anabss1 biimpa cC con0
      wcel cA con0 wcel wa cC cA csuc comu co cC cA comu co cC coa co wceq c0
      cC wcel cC cA omsuc adantr eleqtrrd adantrl adantr sseldd ex exp43 com13
      imp4c a1dd tfinds3 com23 exp4a exp4a mpdd com34 com24 imp31 $.
      $( [10-Jan-2005] $) $( [14-Dec-2004] $)
  $}

  $( Ordering property of ordinal multiplication. $)
  omord2 $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. C ) ->
               ( A e. B <-> ( C .o A ) e. ( C .o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel wa cA cB wcel cC cA
    comu co cC cB comu co wcel cB con0 wcel cC con0 wcel c0 cC wcel cA cB wcel
    cC cA comu co cC cB comu co wcel wi cA con0 wcel cA cB cC omordi 3adantl1
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel wa cC cA comu co cC
    cB comu co wceq cC cB comu co cC cA comu co wcel wo wn cA cB wceq cB cA
    wcel wo wn cC cA comu co cC cB comu co wcel cA cB wcel cA con0 wcel cB con0
    wcel cC con0 wcel w3a c0 cC wcel wa cA cB wceq cB cA wcel wo cC cA comu co
    cC cB comu co wceq cC cB comu co cC cA comu co wcel wo cA con0 wcel cB con0
    wcel cC con0 wcel w3a c0 cC wcel wa cA cB wceq cC cA comu co cC cB comu co
    wceq cB cA wcel cC cB comu co cC cA comu co wcel cA cB wceq cC cA comu co
    cC cB comu co wceq wi cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel
    wa cA cB cC comu opreq2 a1i cA con0 wcel cC con0 wcel c0 cC wcel cB cA wcel
    cC cB comu co cC cA comu co wcel wi cB con0 wcel cB cA cC omordi 3adantl2
    orim12d con3d cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA comu co cC
    cB comu co wcel cC cA comu co cC cB comu co wceq cC cB comu co cC cA comu
    co wcel wo wn wb c0 cC wcel cA con0 wcel cB con0 wcel cC con0 wcel cC cA
    comu co cC cB comu co wcel cC cA comu co cC cB comu co wceq cC cB comu co
    cC cA comu co wcel wo wn wb cC con0 wcel cA con0 wcel cB con0 wcel wa cC cA
    comu co cC cB comu co wcel cC cA comu co cC cB comu co wceq cC cB comu co
    cC cA comu co wcel wo wn wb cC con0 wcel cA con0 wcel cB con0 wcel cC cA
    comu co cC cB comu co wcel cC cA comu co cC cB comu co wceq cC cB comu co
    cC cA comu co wcel wo wn wb cC cA comu co con0 wcel cC cB comu co con0 wcel
    cC cA comu co cC cB comu co wcel cC cA comu co cC cB comu co wceq cC cB
    comu co cC cA comu co wcel wo wn wb cC con0 wcel cA con0 wcel wa cC con0
    wcel cB con0 wcel wa cC cA comu co word cC cB comu co word cC cA comu co cC
    cB comu co wcel cC cA comu co cC cB comu co wceq cC cB comu co cC cA comu
    co wcel wo wn wb cC cA comu co con0 wcel cC cB comu co con0 wcel cC cA comu
    co cC cB comu co ordtri2 cC cA comu co eloni cC cB comu co eloni syl2an cC
    cA omcl cC cB omcl syl2an anandis ancoms 3impa adantr cA con0 wcel cB con0
    wcel cC con0 wcel w3a cA cB wcel cA cB wceq cB cA wcel wo wn wb c0 cC wcel
    cA con0 wcel cB con0 wcel cA cB wcel cA cB wceq cB cA wcel wo wn wb cC con0
    wcel cA word cB word cA cB wcel cA cB wceq cB cA wcel wo wn wb cA con0 wcel
    cB con0 wcel cA cB ordtri2 cA eloni cB eloni syl2an 3adant3 adantr 3imtr4d
    impbid $.
    $( [26-Jan-2005] $) $( [25-Dec-2004] $)

  $( Ordering property of ordinal multiplication.  Proposition 8.19 of
     [TakeutiZaring] p. 63. $)
  omord $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
               ( ( A e. B /\ (/) e. C ) <-> ( C .o A ) e. ( C .o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wcel c0 cC wcel wa cC cA
    comu co cC cB comu co wcel c0 cC wcel wa cC cA comu co cC cB comu co wcel
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel cA cB wcel cC cA comu
    co cC cB comu co wcel cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel
    cA cB wcel cC cA comu co cC cB comu co wcel wb cA cB cC omord2 ex pm5.32rd
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA comu co cC cB comu co wcel
    c0 cC wcel wa cC cA comu co cC cB comu co wcel cC cA comu co cC cB comu co
    wcel c0 cC wcel pm3.26 cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA
    comu co cC cB comu co wcel c0 cC wcel cB con0 wcel cC con0 wcel cC cA comu
    co cC cB comu co wcel c0 cC wcel wi cA con0 wcel cB con0 wcel cC con0 wcel
    wa cC cA comu co cC cB comu co wcel cC c0 wne c0 cC wcel cB con0 wcel cC cA
    comu co cC cB comu co wcel cC c0 wne wi cC con0 wcel cB con0 wcel cC cB
    comu co c0 wne cC c0 wne cC cA comu co cC cB comu co wcel cB con0 wcel cC
    c0 cC cB comu co c0 cC c0 wceq cC cB comu co c0 wceq c0 cB comu co c0 wceq
    cB con0 wcel cC c0 wceq cC cB comu co c0 cB comu co c0 cC c0 cB comu opreq1
    eqeq1d cB om0r syl5cbir necon3d cC cB comu co cC cA comu co ne0i syl5
    adantr cC con0 wcel c0 cC wcel cC c0 wne wb cB con0 wcel cC on0eln0 adantl
    sylibrd 3adant1 ancld impbid2 bitrd $.
    $( [28-Feb-2005] $) $( [14-Dec-2004] $)

  $( Left cancellation law for ordinal multiplication.  Proposition 8.20 of
     [TakeutiZaring] p. 63 and its converse. $)
  omcan $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. A ) ->
                   ( ( A .o B ) = ( A .o C ) <-> B = C ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cA wcel wa cA cB comu co cA
    cC comu co wceq cB cC wceq cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cA
    wcel wa cA cB comu co cA cC comu co wcel cA cC comu co cA cB comu co wcel
    wo wn cB cC wcel cC cB wcel wo wn cA cB comu co cA cC comu co wceq cB cC
    wceq cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cA wcel wa cB cC wcel cC
    cB wcel wo cA cB comu co cA cC comu co wcel cA cC comu co cA cB comu co
    wcel wo cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cA wcel wa cB cC wcel
    cA cB comu co cA cC comu co wcel cC cB wcel cA cC comu co cA cB comu co
    wcel cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cA wcel cB cC wcel cA cB
    comu co cA cC comu co wcel wi cA con0 wcel cC con0 wcel c0 cA wcel cB cC
    wcel cA cB comu co cA cC comu co wcel wi wi cB con0 wcel cC con0 wcel cA
    con0 wcel c0 cA wcel cB cC wcel cA cB comu co cA cC comu co wcel wi wi cC
    con0 wcel cA con0 wcel wa c0 cA wcel cB cC wcel cA cB comu co cA cC comu co
    wcel wi cB cC cA omordi ex ancoms 3adant2 imp cA con0 wcel cB con0 wcel cC
    con0 wcel w3a c0 cA wcel cC cB wcel cA cC comu co cA cB comu co wcel wi cA
    con0 wcel cB con0 wcel c0 cA wcel cC cB wcel cA cC comu co cA cB comu co
    wcel wi wi cC con0 wcel cB con0 wcel cA con0 wcel c0 cA wcel cC cB wcel cA
    cC comu co cA cB comu co wcel wi wi cB con0 wcel cA con0 wcel wa c0 cA wcel
    cC cB wcel cA cC comu co cA cB comu co wcel wi cC cB cA omordi ex ancoms
    3adant3 imp orim12d con3d cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB
    comu co cA cC comu co wceq cA cB comu co cA cC comu co wcel cA cC comu co
    cA cB comu co wcel wo wn wb c0 cA wcel cA con0 wcel cB con0 wcel cC con0
    wcel cA cB comu co cA cC comu co wceq cA cB comu co cA cC comu co wcel cA
    cC comu co cA cB comu co wcel wo wn wb cA cB comu co word cA cC comu co
    word cA cB comu co cA cC comu co wceq cA cB comu co cA cC comu co wcel cA
    cC comu co cA cB comu co wcel wo wn wb cA con0 wcel cB con0 wcel wa cA con0
    wcel cC con0 wcel wa cA cB comu co cA cC comu co ordtri3 cA con0 wcel cB
    con0 wcel wa cA cB comu co con0 wcel cA cB comu co word cA cB omcl cA cB
    comu co eloni syl cA con0 wcel cC con0 wcel wa cA cC comu co con0 wcel cA
    cC comu co word cA cC omcl cA cC comu co eloni syl syl2an 3impdi adantr cA
    con0 wcel cB con0 wcel cC con0 wcel w3a cB cC wceq cB cC wcel cC cB wcel wo
    wn wb c0 cA wcel cB con0 wcel cC con0 wcel cB cC wceq cB cC wcel cC cB wcel
    wo wn wb cA con0 wcel cB word cC word cB cC wceq cB cC wcel cC cB wcel wo
    wn wb cB con0 wcel cC con0 wcel cB cC ordtri3 cB eloni cC eloni syl2an
    3adant1 adantr 3imtr4d cB cC cA comu opreq2 impbid1 $.
    $( [29-Jan-2005] $) $( [14-Dec-2004] $)

  $( Weak ordering property of ordinal multiplication. $)
  omword $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. C ) ->
                   ( A C_ B <-> ( C .o A ) C_ ( C .o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel wa cA cB wcel cA cB
    wceq wo cC cA comu co cC cB comu co wcel cC cA comu co cC cB comu co wceq
    wo cA cB wss cC cA comu co cC cB comu co wss cA con0 wcel cB con0 wcel cC
    con0 wcel w3a c0 cC wcel wa cA cB wcel cC cA comu co cC cB comu co wcel cA
    cB wceq cC cA comu co cC cB comu co wceq cA cB cC omord2 cA con0 wcel cB
    con0 wcel cC con0 wcel w3a c0 cC wcel wa cC cA comu co cC cB comu co wceq
    cA cB wceq cC con0 wcel cA con0 wcel cB con0 wcel w3a c0 cC wcel cC cA comu
    co cC cB comu co wceq cA cB wceq wb cA con0 wcel cB con0 wcel cC con0 wcel
    w3a cC cA cB omcan cC con0 wcel cA con0 wcel cB con0 wcel 3anrot sylanbr
    bicomd orbi12d cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wss cA cB
    wcel cA cB wceq wo wb c0 cC wcel cA con0 wcel cB con0 wcel cA cB wss cA cB
    wcel cA cB wceq wo wb cC con0 wcel cA cB onsseleq 3adant3 adantr cA con0
    wcel cB con0 wcel cC con0 wcel w3a cC cA comu co cC cB comu co wss cC cA
    comu co cC cB comu co wcel cC cA comu co cC cB comu co wceq wo wb c0 cC
    wcel cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA comu co con0 wcel cC
    cB comu co con0 wcel wa cC cA comu co cC cB comu co wss cC cA comu co cC cB
    comu co wcel cC cA comu co cC cB comu co wceq wo wb cA con0 wcel cB con0
    wcel cC con0 wcel cC cA comu co con0 wcel cC cB comu co con0 wcel wa cC
    con0 wcel cA con0 wcel cB con0 wcel wa cC cA comu co con0 wcel cC cB comu
    co con0 wcel wa cC con0 wcel cA con0 wcel cB con0 wcel cC cA comu co con0
    wcel cC cB comu co con0 wcel wa cC con0 wcel cA con0 wcel wa cC cA comu co
    con0 wcel cC con0 wcel cB con0 wcel wa cC cB comu co con0 wcel cC cA omcl
    cC cB omcl anim12i anandis ancoms 3impa cC cA comu co cC cB comu co
    onsseleq syl adantr 3bitr4d $.
    $( [22-Mar-2005] $) $( [21-Dec-2004] $)

  $( Weak ordering property of ordinal multiplication. $)
  omwordi $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                   ( A C_ B -> ( C .o A ) C_ ( C .o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel cA cB wss cC cA comu
    co cC cB comu co wss wi cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC
    wcel cA cB wss cC cA comu co cC cB comu co wss wi cA con0 wcel cB con0 wcel
    cC con0 wcel w3a c0 cC wcel wa cA cB wss cC cA comu co cC cB comu co wss cA
    cB cC omword biimpd ex cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC
    wcel wn cC cA comu co cC cB comu co wss cA cB wss cA con0 wcel cB con0 wcel
    cC con0 wcel w3a c0 cC wcel wn cC c0 wceq cC cA comu co cC cB comu co wss
    cC con0 wcel cA con0 wcel cC c0 wceq c0 cC wcel wn wb cB con0 wcel cC con0
    wcel cC word cC c0 wceq c0 cC wcel wn wb cC eloni cC word c0 cC wcel cC c0
    cC ord0eln0 necon2bbid syl 3ad2ant3 cA con0 wcel cB con0 wcel cC c0 wceq cC
    cA comu co cC cB comu co wss wi cC con0 wcel cC c0 wceq cC cA comu co cC cB
    comu co wss c0 cA comu co c0 cB comu co wss cA con0 wcel cB con0 wcel wa cC
    c0 wceq cC cA comu co c0 cA comu co cC cB comu co c0 cB comu co cC c0 cA
    comu opreq1 cC c0 cB comu opreq1 sseq12d cA con0 wcel cB con0 wcel wa c0 cA
    comu co c0 cB comu co wss c0 c0 wss c0 ssid cA con0 wcel cB con0 wcel wa c0
    cA comu co c0 c0 cB comu co c0 cA con0 wcel c0 cA comu co c0 wceq cB con0
    wcel cA om0r adantr cB con0 wcel c0 cB comu co c0 wceq cA con0 wcel cB om0r
    adantl sseq12d mpbiri syl5cbir 3adant3 sylbird a1dd pm2.61d $.
    $( [11-Apr-2005] $) $( [21-Dec-2004] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Weak ordering property of ordinal multiplication.  Proposition 8.21 of
       [TakeutiZaring] p. 63. $)
    omwordri $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
        ( A C_ B -> ( A .o C ) C_ ( B .o C ) ) ) $=
      cC con0 wcel cA con0 wcel cB con0 wcel cA cB wss cA cC comu co cB cC comu
      co wss wi cC con0 wcel cA con0 wcel cB con0 wcel cA cB wss cA cC comu co
      cB cC comu co wss wi cC con0 wcel cA con0 wcel cB con0 wcel wa cA cB wss
      cA cC comu co cB cC comu co wss cA vx cv comu co cB vx cv comu co wss cA
      c0 comu co cB c0 comu co wss cA vy cv comu co cB vy cv comu co wss cA vy
      cv csuc comu co cB vy cv csuc comu co wss cA cC comu co cB cC comu co wss
      vx vy cC cA con0 wcel cB con0 wcel wa cA cB wss wa vx cv c0 wceq cA vx cv
      comu co cA c0 comu co cB vx cv comu co cB c0 comu co vx cv c0 cA comu
      opreq2 vx cv c0 cB comu opreq2 sseq12d vx cv vy cv wceq cA vx cv comu co
      cA vy cv comu co cB vx cv comu co cB vy cv comu co vx cv vy cv cA comu
      opreq2 vx cv vy cv cB comu opreq2 sseq12d vx cv vy cv csuc wceq cA vx cv
      comu co cA vy cv csuc comu co cB vx cv comu co cB vy cv csuc comu co vx
      cv vy cv csuc cA comu opreq2 vx cv vy cv csuc cB comu opreq2 sseq12d vx
      cv cC wceq cA vx cv comu co cA cC comu co cB vx cv comu co cB cC comu co
      vx cv cC cA comu opreq2 vx cv cC cB comu opreq2 sseq12d cA con0 wcel cA
      c0 comu co cB c0 comu co wss cB con0 wcel cA cB wss cA con0 wcel cA c0
      comu co cB c0 comu co wss c0 cB c0 comu co wss cB c0 comu co 0ss cA con0
      wcel cA c0 comu co c0 cB c0 comu co cA om0 sseq1d mpbiri ad2antrr vy cv
      con0 wcel cA con0 wcel cB con0 wcel cA cB wss cA vy cv comu co cB vy cv
      comu co wss cA vy cv csuc comu co cB vy cv csuc comu co wss wi cA con0
      wcel cB con0 wcel vy cv con0 wcel cA cB wss cA vy cv comu co cB vy cv
      comu co wss cA vy cv csuc comu co cB vy cv csuc comu co wss wi wi cA con0
      wcel cB con0 wcel vy cv con0 wcel cA cB wss cA vy cv comu co cB vy cv
      comu co wss cA vy cv csuc comu co cB vy cv csuc comu co wss wi wi cA con0
      wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss cA vy cv comu co cB vy cv
      comu co wss cA vy cv csuc comu co cB vy cv csuc comu co wss cA con0 wcel
      cB con0 wcel vy cv con0 wcel w3a cA cB wss cA vy cv comu co cB vy cv comu
      co wss wa wa cA vy cv comu co cA coa co cB vy cv comu co cB coa co cA vy
      cv csuc comu co cB vy cv csuc comu co cA con0 wcel cB con0 wcel vy cv
      con0 wcel w3a cA cB wss cA vy cv comu co cB vy cv comu co wss wa wa cA vy
      cv comu co cA coa co cB vy cv comu co cA coa co cB vy cv comu co cB coa
      co cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA vy cv comu co cB vy
      cv comu co wss cA vy cv comu co cA coa co cB vy cv comu co cA coa co wss
      cA cB wss cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA vy cv comu co
      cB vy cv comu co wss cA vy cv comu co cA coa co cB vy cv comu co cA coa
      co wss cA vy cv comu co con0 wcel cB vy cv comu co con0 wcel cA con0 wcel
      cA vy cv comu co cB vy cv comu co wss cA vy cv comu co cA coa co cB vy cv
      comu co cA coa co wss wi cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA
      vy cv comu co cB vy cv comu co cA oawordri cA con0 wcel vy cv con0 wcel
      cA vy cv comu co con0 wcel cB con0 wcel cA vy cv omcl 3adant2 cB con0
      wcel vy cv con0 wcel cB vy cv comu co con0 wcel cA con0 wcel cB vy cv
      omcl 3adant1 cA con0 wcel cB con0 wcel vy cv con0 wcel 3simp1 syl3anc imp
      adantrl cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss cB vy cv
      comu co cA coa co cB vy cv comu co cB coa co wss cA vy cv comu co cB vy
      cv comu co wss cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss cB
      vy cv comu co cA coa co cB vy cv comu co cB coa co wss cA con0 wcel cB
      con0 wcel cB vy cv comu co con0 wcel cA cB wss cB vy cv comu co cA coa co
      cB vy cv comu co cB coa co wss wb vy cv con0 wcel cA cB cB vy cv comu co
      oaword cB con0 wcel vy cv con0 wcel cB vy cv comu co con0 wcel cA con0
      wcel cB vy cv omcl 3adant1 syld3an3 biimpa adantrr sstrd cA con0 wcel cB
      con0 wcel vy cv con0 wcel w3a cA vy cv csuc comu co cA vy cv comu co cA
      coa co wceq cA cB wss cA vy cv comu co cB vy cv comu co wss wa cA con0
      wcel vy cv con0 wcel cA vy cv csuc comu co cA vy cv comu co cA coa co
      wceq cB con0 wcel cA vy cv omsuc 3adant2 adantr cA con0 wcel cB con0 wcel
      vy cv con0 wcel w3a cB vy cv csuc comu co cB vy cv comu co cB coa co wceq
      cA cB wss cA vy cv comu co cB vy cv comu co wss wa cB con0 wcel vy cv
      con0 wcel cB vy cv csuc comu co cB vy cv comu co cB coa co wceq cA con0
      wcel cB vy cv omsuc 3adant1 adantr 3sstr4d exp32 3exp com3r imp4c vx cv
      wlim cA con0 wcel cB con0 wcel wa cA vy cv comu co cB vy cv comu co wss
      vy vx cv wral cA vx cv comu co cB vx cv comu co wss wi cA cB wss cA con0
      wcel cB con0 wcel wa vx cv wlim cA vy cv comu co cB vy cv comu co wss vy
      vx cv wral cA vx cv comu co cB vx cv comu co wss wi cA con0 wcel cB con0
      wcel wa vx cv cvv wcel vx cv wlim cA vy cv comu co cB vy cv comu co wss
      vy vx cv wral cA vx cv comu co cB vx cv comu co wss wi vx visset cA con0
      wcel cB con0 wcel vx cv cvv wcel vx cv wlim wa cA vy cv comu co cB vy cv
      comu co wss vy vx cv wral cA vx cv comu co cB vx cv comu co wss wi cA
      con0 wcel vx cv cvv wcel vx cv wlim wa wa cB con0 wcel vx cv cvv wcel vx
      cv wlim wa wa wa cA vx cv comu co cB vx cv comu co wss vy vx cv cA vy cv
      comu co ciun vy vx cv cB vy cv comu co ciun wss cA vy cv comu co cB vy cv
      comu co wss vy vx cv wral cA con0 wcel vx cv cvv wcel vx cv wlim wa wa cB
      con0 wcel vx cv cvv wcel vx cv wlim wa wa wa cA vx cv comu co vy vx cv cA
      vy cv comu co ciun cB vx cv comu co vy vx cv cB vy cv comu co ciun cA
      con0 wcel vx cv cvv wcel vx cv wlim wa cA vx cv comu co vy vx cv cA vy cv
      comu co ciun wceq vx cv cvv wcel vx cv wlim wa cB con0 wcel vy cA vx cv
      cvv omlim ad2ant2rl cB con0 wcel vx cv cvv wcel vx cv wlim wa wa cB vx cv
      comu co vy vx cv cB vy cv comu co ciun wceq cA con0 wcel vx cv cvv wcel
      vx cv wlim wa wa vy cB vx cv cvv omlim adantl sseq12d vy vx cv cA vy cv
      comu co cB vy cv comu co ss2iun syl5bir anandirs mpanr1 expcom adantrd
      tfinds3 exp3a 3impib 3coml $.
      $( [12-Apr-2005] $) $( [20-Dec-2004] $)
  $}

  $( An ordinal is less than or equal to its product with another. $)
  omword1 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. B ) ->
                 A C_ ( A .o B ) ) $=
    cA con0 wcel cB con0 wcel wa c0 cB wcel cA cA cB comu co wss cA con0 wcel
    cB con0 wcel wa c0 cB wcel c1o cB wss cA cA cB comu co wss cB con0 wcel c0
    cB wcel c1o cB wss wb cA con0 wcel cB con0 wcel cB word c0 cB wcel c1o cB
    wss wb cB eloni cB ordgt0ge1 syl adantl cA con0 wcel cB con0 wcel wa c1o cB
    wss cA c1o comu co cA cB comu co wss cA cA cB comu co wss cB con0 wcel cA
    con0 wcel c1o cB wss cA c1o comu co cA cB comu co wss wi c1o con0 wcel cB
    con0 wcel cA con0 wcel c1o cB wss cA c1o comu co cA cB comu co wss wi 1on
    c1o cB cA omwordi mp3an1 ancoms cA con0 wcel cB con0 wcel wa cA c1o comu co
    cA cA cB comu co cA con0 wcel cA c1o comu co cA wceq cB con0 wcel cA om1
    adantr sseq1d sylibd sylbid imp $.
    $( [12-Apr-2005] $) $( [21-Dec-2004] $)

  $( An ordinal is less than or equal to its product with another. $)
  omword2 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. B ) ->
                 A C_ ( B .o A ) ) $=
    cA con0 wcel cB con0 wcel wa c0 cB wcel wa cA c1o cA comu co cB cA comu co
    cA con0 wcel c1o cA comu co cA wceq cB con0 wcel c0 cB wcel cA om1r
    ad2antrr cA con0 wcel cB con0 wcel wa c0 cB wcel wa c1o cB wss c1o cA comu
    co cB cA comu co wss cB con0 wcel c0 cB wcel c1o cB wss cA con0 wcel cB
    word c0 cB wcel c1o cB wss cB con0 wcel cB word c0 cB wcel c1o cB wss cB
    ordgt0ge1 biimpa cB eloni sylan adantll cA con0 wcel cB con0 wcel wa c1o cB
    wss c1o cA comu co cB cA comu co wss wi c0 cB wcel cB con0 wcel cA con0
    wcel c1o cB wss c1o cA comu co cB cA comu co wss wi c1o con0 wcel cB con0
    wcel cA con0 wcel c1o cB wss c1o cA comu co cB cA comu co wss wi 1on c1o cB
    cA omwordri mp3an1 ancoms adantr mpd eqsstr3d $.
    $( [16-Apr-2005] $) $( [21-Dec-2004] $)

  $( The product of two ordinal numbers is zero iff at least one of them is
     zero.  Proposition 8.22 of [TakeutiZaring] p. 64. $)
  om00 $p |- ( ( A e. On /\ B e. On ) -> ( ( A .o B ) = (/) <->
              ( A = (/) \/ B = (/) ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB comu co c0 wceq cA c0 wceq cB c0 wceq wo
    cA con0 wcel cB con0 wcel wa cA c0 wceq cB c0 wceq wo cA cB comu co c0 cA
    con0 wcel cB con0 wcel wa cA c0 wceq cB c0 wceq wo wn c1o cA cB comu co wss
    cA cB comu co c0 wne cA con0 wcel cB con0 wcel wa cA c0 wne cB c0 wne wa
    c1o cA cB comu co wss cA c0 wceq cB c0 wceq wo wn cA con0 wcel cB con0 wcel
    wa cA c0 wne cB c0 wne wa c1o cA wss cA cA cB comu co wss wa c1o cA cB comu
    co wss cA con0 wcel cB con0 wcel wa cA c0 wne c1o cA wss cB c0 wne cA cA cB
    comu co wss cA con0 wcel cA c0 wne c1o cA wss wi cB con0 wcel cA con0 wcel
    c1o cA wss cA c0 wne cA con0 wcel cA word c1o cA wss cA c0 wne wb cA eloni
    cA ordge1n0 syl biimprd adantr cA con0 wcel cB con0 wcel wa cB c0 wne c0 cB
    wcel cA cA cB comu co wss cB con0 wcel c0 cB wcel cB c0 wne wb cA con0 wcel
    cB on0eln0 adantl cA con0 wcel cB con0 wcel wa c0 cB wcel cA cA cB comu co
    wss cA cB omword1 ex sylbird anim12d c1o cA cA cB comu co sstr syl6 cA c0
    cB c0 neanior syl5ibr cA con0 wcel cB con0 wcel wa cA cB comu co con0 wcel
    cA cB comu co word c1o cA cB comu co wss cA cB comu co c0 wne wb cA cB omcl
    cA cB comu co eloni cA cB comu co ordge1n0 3syl sylibd necon4bd cA con0
    wcel cB con0 wcel wa cA c0 wceq cA cB comu co c0 wceq cB c0 wceq cB con0
    wcel cA c0 wceq cA cB comu co c0 wceq wi cA con0 wcel cB con0 wcel cA c0
    wceq cA cB comu co c0 wceq cA c0 wceq cB con0 wcel cA cB comu co c0 cB comu
    co c0 cA c0 cB comu opreq1 cB om0r sylan9eqr ex adantl cA con0 wcel cB c0
    wceq cA cB comu co c0 wceq wi cB con0 wcel cA con0 wcel cB c0 wceq cA cB
    comu co c0 wceq cB c0 wceq cA con0 wcel cA cB comu co cA c0 comu co c0 cB
    c0 cA comu opreq2 cA om0 sylan9eqr ex adantr jaod impbid $.
    $( [14-Apr-2005] $) $( [21-Dec-2004] $)

  $( The product of two nonzero ordinal numbers is nonzero. $)
  om00el $p |- ( ( A e. On /\ B e. On ) -> ( (/) e. ( A .o B ) <->
              ( (/) e. A /\ (/) e. B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB comu co c0 wne cA c0 wceq cB c0 wceq wo
    wn c0 cA cB comu co wcel c0 cA wcel c0 cB wcel wa cA con0 wcel cB con0 wcel
    wa cA c0 wceq cB c0 wceq wo cA cB comu co c0 cA cB om00 necon3abid cA con0
    wcel cB con0 wcel wa cA cB comu co con0 wcel c0 cA cB comu co wcel cA cB
    comu co c0 wne wb cA cB omcl cA cB comu co on0eln0 syl cA con0 wcel cB con0
    wcel wa c0 cA wcel c0 cB wcel wa cA c0 wne cB c0 wne wa cA c0 wceq cB c0
    wceq wo wn cA con0 wcel c0 cA wcel cA c0 wne cB con0 wcel c0 cB wcel cB c0
    wne cA on0eln0 cB on0eln0 bi2anan9 cA c0 cB c0 neanior syl6bb 3bitr4d $.
    $( [15-Apr-2005] $) $( [28-Dec-2004] $)

  ${
    $d x y z w v A $.  $d x y z w v B $.  $d x y C $.
    $( Ordering involving the product of a limit ordinal.  Proposition 8.23 of
       [TakeutiZaring] p. 64. $)
    omordlim $p |- ( ( ( A e. On /\ ( B e. D /\ Lim B ) ) /\ C e. ( A .o B ) )
                -> E. x e. B C e. ( A .o x ) ) $=
      cA con0 wcel cB cD wcel cB wlim wa wa cC cA cB comu co wcel cC cA vx cv
      comu co wcel vx cB wrex cA con0 wcel cB cD wcel cB wlim wa wa cC cA cB
      comu co wcel cC vx cB cA vx cv comu co ciun wcel cC cA vx cv comu co wcel
      vx cB wrex cA con0 wcel cB cD wcel cB wlim wa wa cA cB comu co vx cB cA
      vx cv comu co ciun cC vx cA cB cD omlim eleq2d vx cC cB cA vx cv comu co
      eliun syl6bb biimpa $.
      $( [15-Apr-2005] $) $( [25-Dec-2004] $)

    $( The product of any nonzero ordinal with a limit ordinal is a limit
       ordinal.  Proposition 8.24 of [TakeutiZaring] p. 64. $)
    omlimcl $p |- ( ( ( A e. On /\ ( B e. C /\ Lim B ) ) /\ (/) e. A ) ->
                  Lim ( A .o B ) ) $=
      cA cB comu co wlim cA cB comu co word cA cB comu co c0 wceq cA cB comu co
      vy cv csuc wceq vy con0 wrex wo wn cA con0 wcel cB cC wcel cB wlim wa wa
      c0 cA wcel wa vy cA cB comu co dflim3 cA con0 wcel cB cC wcel cB wlim wa
      wa cA cB comu co word c0 cA wcel cA con0 wcel cB con0 wcel cA cB comu co
      word cB cC wcel cB wlim wa cA con0 wcel cB con0 wcel wa cA cB comu co
      con0 wcel cA cB comu co word cA cB omcl cA cB comu co eloni syl cB cC
      limelon sylan2 adantr cA cB comu co c0 wceq cA cB comu co vy cv csuc wceq
      vy con0 wrex wo wn cA cB comu co c0 wceq wn cA cB comu co vy cv csuc wceq
      vy con0 wrex wn cA con0 wcel cB cC wcel cB wlim wa wa c0 cA wcel wa cA cB
      comu co c0 wceq cA cB comu co vy cv csuc wceq vy con0 wrex ioran cA con0
      wcel cB cC wcel cB wlim wa wa c0 cA wcel wa cA cB comu co c0 wceq wn cA
      c0 wceq wn cB c0 wceq wn wa cB cC wcel cB wlim wa c0 cA wcel cA c0 wceq
      wn cB c0 wceq wn wa cA con0 wcel cB wlim c0 cA wcel cA c0 wceq wn cB c0
      wceq wn wa cB cC wcel c0 cA wcel cB wlim cA c0 wceq wn cB c0 wceq wn wa
      c0 cA wcel cA c0 wceq wn cB wlim cB c0 wceq wn cA c0 n0i cB wlim c0 cB
      wcel cB c0 wceq wn cB 0ellim cB c0 n0i syl anim12i ancoms adantll adantll
      cA con0 wcel cB cC wcel cB wlim wa wa cA cB comu co c0 wceq wn cA c0 wceq
      wn cB c0 wceq wn wa wb c0 cA wcel cA con0 wcel cB con0 wcel cA cB comu co
      c0 wceq wn cA c0 wceq wn cB c0 wceq wn wa wb cB cC wcel cB wlim wa cA
      con0 wcel cB con0 wcel wa cA cB comu co c0 wceq wn cA c0 wceq cB c0 wceq
      wo wn cA c0 wceq wn cB c0 wceq wn wa cA con0 wcel cB con0 wcel wa cA cB
      comu co c0 wceq cA c0 wceq cB c0 wceq wo cA cB om00 notbid cA c0 wceq cB
      c0 wceq ioran syl6bb cB cC limelon sylan2 adantr mpbird cA con0 wcel cB
      cC wcel cB wlim wa wa c0 cA wcel wa cA cB comu co vy cv csuc wceq vy con0
      cA con0 wcel cB cC wcel cB wlim wa wa c0 cA wcel wa cA cB comu co vy cv
      csuc wceq wn vy cv con0 wcel cA con0 wcel cB cC wcel cB wlim wa wa c0 cA
      wcel wa cA cB comu co vy cv csuc wceq cA con0 wcel cB cC wcel cB wlim wa
      wa c0 cA wcel wa cA cB comu co vy cv csuc wceq cA cB comu co vy cv csuc
      wceq wn cA con0 wcel cB cC wcel cB wlim wa wa c0 cA wcel wa cA cB comu co
      vy cv csuc wceq wa vy cv cA vx cv comu co wcel vx cB wrex cA cB comu co
      vy cv csuc wceq wn cA con0 wcel cB cC wcel cB wlim wa wa cA cB comu co vy
      cv csuc wceq vy cv cA vx cv comu co wcel vx cB wrex c0 cA wcel cA con0
      wcel cB cC wcel cB wlim wa wa cA cB comu co vy cv csuc wceq wa vy cv vx
      cB cA vx cv comu co ciun wcel vy cv cA vx cv comu co wcel vx cB wrex cA
      con0 wcel cB cC wcel cB wlim wa wa cA cB comu co vy cv csuc wceq wa vy cv
      csuc vx cB cA vx cv comu co ciun vy cv cA cB comu co vx cB cA vx cv comu
      co ciun wceq cA cB comu co vy cv csuc wceq vy cv csuc vx cB cA vx cv comu
      co ciun wceq cA con0 wcel cB cC wcel cB wlim wa wa cA cB comu co vy cv
      csuc wceq cA cB comu co vx cB cA vx cv comu co ciun wceq vy cv csuc vx cB
      cA vx cv comu co ciun wceq cA cB comu co vy cv csuc vx cB cA vx cv comu
      co ciun eqeq1 biimpac vx cA cB cC omlim sylan vy cv vy visset sucid
      syl5eleq vx vy cv cB cA vx cv comu co eliun sylib adantlr cA con0 wcel cB
      cC wcel cB wlim wa wa c0 cA wcel wa vy cv cA vx cv comu co wcel vx cB
      wrex cA cB comu co vy cv csuc wceq wn wi cA cB comu co vy cv csuc wceq cA
      con0 wcel cB cC wcel cB wlim wa wa c0 cA wcel wa vy cv cA vx cv comu co
      wcel cA cB comu co vy cv csuc wceq wn vx cB cA con0 wcel cB cC wcel cB
      wlim wa wa c0 cA wcel wa vx cv cB wcel vy cv cA vx cv comu co wcel cA cB
      comu co vy cv csuc wceq wn cA con0 wcel cB cC wcel cB wlim wa wa c0 cA
      wcel wa vx cv cB wcel wa vy cv cA vx cv comu co wcel wa cA cB comu co vy
      cv csuc wceq cB vx cv csuc wcel cA con0 wcel cB cC wcel cB wlim wa wa c0
      cA wcel wa vx cv cB wcel wa cB vx cv csuc wcel wn vy cv cA vx cv comu co
      wcel cA con0 wcel cB cC wcel cB wlim wa wa vx cv cB wcel cB vx cv csuc
      wcel wn c0 cA wcel cB cC wcel cB wlim wa vx cv cB wcel cB vx cv csuc wcel
      wn cA con0 wcel cB cC wcel cB wlim wa vx cv cB wcel wa vx cv con0 wcel cB
      vx cv csuc wcel wn cB con0 wcel vx cv cB wcel vx cv con0 wcel cB cC wcel
      cB wlim wa cB vx cv onelon cB cC limelon sylan vx cv cB wcel vx cv con0
      wcel cB vx cv csuc wcel wn wi cB cC wcel cB wlim wa vx cv con0 wcel vx cv
      cB wcel cB vx cv csuc wcel wn vx cv con0 wcel vx cv cB wcel cB vx cv csuc
      wcel wa wn vx cv cB wcel cB vx cv csuc wcel wn wi vx cv cB onnbtwn vx cv
      cB wcel cB vx cv csuc wcel imnan sylibr com12 adantl mpd adantll adantlr
      adantr cA con0 wcel cB cC wcel cB wlim wa wa c0 cA wcel wa vx cv cB wcel
      wa vy cv cA vx cv comu co wcel cA cB comu co vy cv csuc wceq cB vx cv
      csuc wcel wi cA con0 wcel cB cC wcel cB wlim wa wa vx cv cB wcel c0 cA
      wcel vy cv cA vx cv comu co wcel cA cB comu co vy cv csuc wceq cB vx cv
      csuc wcel wi wi cA con0 wcel cB con0 wcel vx cv con0 wcel wa wa c0 cA
      wcel vy cv cA vx cv comu co wcel cA cB comu co vy cv csuc wceq cB vx cv
      csuc wcel wi wi cA con0 wcel cB cC wcel cB wlim wa wa vx cv cB wcel wa cA
      con0 wcel cB con0 wcel vx cv con0 wcel wa wa c0 cA wcel wa vy cv cA vx cv
      comu co wcel cA cB comu co vy cv csuc wceq cA cB comu co cA vx cv csuc
      comu co wcel cB vx cv csuc wcel cA con0 wcel vx cv con0 wcel c0 cA wcel
      vy cv cA vx cv comu co wcel cA cB comu co vy cv csuc wceq cA cB comu co
      cA vx cv csuc comu co wcel wi wi cB con0 wcel cA con0 wcel vx cv con0
      wcel wa c0 cA wcel wa cA cB comu co vy cv csuc wceq vy cv cA vx cv comu
      co wcel cA cB comu co cA vx cv csuc comu co wcel cA con0 wcel vx cv con0
      wcel wa c0 cA wcel wa vy cv cA vx cv comu co wcel vy cv csuc cA vx cv
      csuc comu co wcel cA cB comu co vy cv csuc wceq cA cB comu co cA vx cv
      csuc comu co wcel cA con0 wcel vx cv con0 wcel wa c0 cA wcel wa vy cv cA
      vx cv comu co wcel vy cv csuc cA vx cv comu co c1o coa co wcel vy cv csuc
      cA vx cv csuc comu co wcel cA con0 wcel vx cv con0 wcel wa vy cv cA vx cv
      comu co wcel vy cv csuc cA vx cv comu co c1o coa co wcel wb c0 cA wcel cA
      con0 wcel vx cv con0 wcel wa cA vx cv comu co con0 wcel vy cv cA vx cv
      comu co wcel vy cv csuc cA vx cv comu co c1o coa co wcel wb cA vx cv omcl
      cA vx cv comu co con0 wcel vy cv cA vx cv comu co wcel vy cv csuc cA vx
      cv comu co csuc wcel vy cv csuc cA vx cv comu co c1o coa co wcel cA vx cv
      comu co con0 wcel cA vx cv comu co word vy cv cA vx cv comu co wcel vy cv
      csuc cA vx cv comu co csuc wcel wb cA vx cv comu co eloni vy cv cA vx cv
      comu co ordsucelsuc syl cA vx cv comu co con0 wcel cA vx cv comu co c1o
      coa co cA vx cv comu co csuc vy cv csuc cA vx cv comu co oa1suc eleq2d
      bitr4d syl adantr cA con0 wcel vx cv con0 wcel wa c0 cA wcel wa cA vx cv
      comu co c1o coa co cA vx cv csuc comu co vy cv csuc cA con0 wcel vx cv
      con0 wcel wa c0 cA wcel wa cA vx cv comu co c1o coa co cA vx cv comu co
      cA coa co cA vx cv csuc comu co cA con0 wcel vx cv con0 wcel wa c0 cA
      wcel cA vx cv comu co c1o coa co cA vx cv comu co cA coa co wss cA con0
      wcel vx cv con0 wcel wa c0 cA wcel c1o cA wss cA vx cv comu co c1o coa co
      cA vx cv comu co cA coa co wss cA con0 wcel c0 cA wcel c1o cA wss wb vx
      cv con0 wcel cA con0 wcel cA word c0 cA wcel c1o cA wss wb cA eloni cA
      ordgt0ge1 syl adantr cA con0 wcel vx cv con0 wcel cA vx cv comu co con0
      wcel c1o cA wss cA vx cv comu co c1o coa co cA vx cv comu co cA coa co
      wss wb cA vx cv omcl c1o con0 wcel cA con0 wcel cA vx cv comu co con0
      wcel c1o cA wss cA vx cv comu co c1o coa co cA vx cv comu co cA coa co
      wss wb 1on c1o cA cA vx cv comu co oaword mp3an1 syldan bitrd biimpa cA
      con0 wcel vx cv con0 wcel wa cA vx cv csuc comu co cA vx cv comu co cA
      coa co wceq c0 cA wcel cA vx cv omsuc adantr sseqtr4d sseld sylbid cA cB
      comu co vy cv csuc wceq cA cB comu co cA vx cv csuc comu co wcel vy cv
      csuc cA vx cv csuc comu co wcel cA cB comu co vy cv csuc cA vx cv csuc
      comu co eleq1 biimprd syl9 com23 adantlrl cA con0 wcel cB con0 wcel vx cv
      con0 wcel wa wa cA cB comu co cA vx cv csuc comu co wcel cB vx cv csuc
      wcel wi c0 cA wcel cA con0 wcel cB con0 wcel vx cv con0 wcel cA cB comu
      co cA vx cv csuc comu co wcel cB vx cv csuc wcel wi cB con0 wcel vx cv
      con0 wcel cA con0 wcel cA cB comu co cA vx cv csuc comu co wcel cB vx cv
      csuc wcel wi cB con0 wcel vx cv csuc con0 wcel cA con0 wcel cA cB comu co
      cA vx cv csuc comu co wcel cB vx cv csuc wcel wi vx cv con0 wcel cB con0
      wcel vx cv csuc con0 wcel cA con0 wcel w3a cA cB comu co cA vx cv csuc
      comu co wcel cB vx cv csuc wcel c0 cA wcel wa cB vx cv csuc wcel cB vx cv
      csuc cA omord cB vx cv csuc wcel c0 cA wcel pm3.26 syl6bir vx cv sucelon
      syl3an2b 3comr 3expb adantr syl6d cA con0 wcel cB cC wcel cB wlim wa vx
      cv cB wcel cA con0 wcel cB con0 wcel vx cv con0 wcel wa wa cB cC wcel cB
      wlim wa vx cv cB wcel wa cB con0 wcel vx cv con0 wcel wa cA con0 wcel cB
      con0 wcel vx cv cB wcel cB con0 wcel vx cv con0 wcel wa cB cC wcel cB
      wlim wa cB con0 wcel vx cv cB wcel wa cB con0 wcel vx cv con0 wcel cB
      con0 wcel vx cv cB wcel pm3.26 cB vx cv onelon jca cB cC limelon sylan
      anim2i anassrs sylan an1rs imp mtod exp31 r19.23adv adantr mpd ex pm2.01d
      adantr nrexdv sylanbrc sylanbrc $.
      $( [10-May-2005] $) $( [25-Dec-2004] $)

    $( Distributive law for ordinal arithmetic.  Proposition 8.25 of
       [TakeutiZaring] p. 64.  _Warning:  The HTML proof page is 3/4 megabyte
       in size_. $)
    odi $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A .o ( B +o C ) ) = ( ( A .o B ) +o ( A .o C ) ) ) $=
      cA con0 wcel cB con0 wcel cC con0 wcel cA cB cC coa co comu co cA cB comu
      co cA cC comu co coa co wceq cC con0 wcel cA con0 wcel cB con0 wcel cA cB
      cC coa co comu co cA cB comu co cA cC comu co coa co wceq cC con0 wcel cA
      con0 wcel cB con0 wcel cA cB cC coa co comu co cA cB comu co cA cC comu
      co coa co wceq cA cB vx cv coa co comu co cA cB comu co cA vx cv comu co
      coa co wceq cA cB c0 coa co comu co cA cB comu co cA c0 comu co coa co
      wceq cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co coa co
      wceq cA cB vy cv csuc coa co comu co cA cB comu co cA vy cv csuc comu co
      coa co wceq cA cB cC coa co comu co cA cB comu co cA cC comu co coa co
      wceq vx vy cC cA con0 wcel cB con0 wcel wa vx cv c0 wceq cA cB vx cv coa
      co comu co cA cB c0 coa co comu co cA cB comu co cA vx cv comu co coa co
      cA cB comu co cA c0 comu co coa co vx cv c0 wceq cB vx cv coa co cB c0
      coa co cA comu vx cv c0 cB coa opreq2 opreq2d vx cv c0 wceq cA vx cv comu
      co cA c0 comu co cA cB comu co coa vx cv c0 cA comu opreq2 opreq2d
      eqeq12d vx cv vy cv wceq cA cB vx cv coa co comu co cA cB vy cv coa co
      comu co cA cB comu co cA vx cv comu co coa co cA cB comu co cA vy cv comu
      co coa co vx cv vy cv wceq cB vx cv coa co cB vy cv coa co cA comu vx cv
      vy cv cB coa opreq2 opreq2d vx cv vy cv wceq cA vx cv comu co cA vy cv
      comu co cA cB comu co coa vx cv vy cv cA comu opreq2 opreq2d eqeq12d vx
      cv vy cv csuc wceq cA cB vx cv coa co comu co cA cB vy cv csuc coa co
      comu co cA cB comu co cA vx cv comu co coa co cA cB comu co cA vy cv csuc
      comu co coa co vx cv vy cv csuc wceq cB vx cv coa co cB vy cv csuc coa co
      cA comu vx cv vy cv csuc cB coa opreq2 opreq2d vx cv vy cv csuc wceq cA
      vx cv comu co cA vy cv csuc comu co cA cB comu co coa vx cv vy cv csuc cA
      comu opreq2 opreq2d eqeq12d vx cv cC wceq cA cB vx cv coa co comu co cA
      cB cC coa co comu co cA cB comu co cA vx cv comu co coa co cA cB comu co
      cA cC comu co coa co vx cv cC wceq cB vx cv coa co cB cC coa co cA comu
      vx cv cC cB coa opreq2 opreq2d vx cv cC wceq cA vx cv comu co cA cC comu
      co cA cB comu co coa vx cv cC cA comu opreq2 opreq2d eqeq12d cA con0 wcel
      cB con0 wcel wa cA cB comu co c0 coa co cA cB comu co cA cB comu co cA c0
      comu co coa co cA cB c0 coa co comu co cA con0 wcel cB con0 wcel wa cA cB
      comu co con0 wcel cA cB comu co c0 coa co cA cB comu co wceq cA cB omcl
      cA cB comu co oa0 syl cA con0 wcel cB con0 wcel wa cA c0 comu co c0 cA cB
      comu co coa cA con0 wcel cA c0 comu co c0 wceq cB con0 wcel cA om0 adantr
      opreq2d cA con0 wcel cB con0 wcel wa cB c0 coa co cB cA comu cB con0 wcel
      cB c0 coa co cB wceq cA con0 wcel cB oa0 adantl opreq2d 3eqtr4rd vy cv
      con0 wcel cA con0 wcel cB con0 wcel cA cB vy cv coa co comu co cA cB comu
      co cA vy cv comu co coa co wceq cA cB vy cv csuc coa co comu co cA cB
      comu co cA vy cv csuc comu co coa co wceq wi cA con0 wcel cB con0 wcel vy
      cv con0 wcel cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq cA cB vy cv csuc coa co comu co cA cB comu co cA vy cv csuc
      comu co coa co wceq wi cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB vy
      cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq cA cB vy cv
      csuc coa co comu co cA cB comu co cA vy cv csuc comu co coa co wceq wi cA
      con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB vy cv csuc coa co comu
      co cA cB comu co cA vy cv csuc comu co coa co wceq cA cB vy cv coa co
      comu co cA coa co cA cB comu co cA vy cv comu co coa co cA coa co wceq cA
      cB vy cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq cA
      con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB vy cv csuc coa co comu
      co cA cB vy cv coa co comu co cA coa co cA cB comu co cA vy cv csuc comu
      co coa co cA cB comu co cA vy cv comu co coa co cA coa co cA con0 wcel cB
      con0 wcel vy cv con0 wcel w3a cA cB vy cv csuc coa co comu co cA cB vy cv
      coa co csuc comu co cA cB vy cv coa co comu co cA coa co cA con0 wcel cB
      con0 wcel vy cv con0 wcel w3a cB vy cv csuc coa co cB vy cv coa co csuc
      cA comu cB con0 wcel vy cv con0 wcel cB vy cv csuc coa co cB vy cv coa co
      csuc wceq cA con0 wcel cB vy cv oasuc 3adant1 opreq2d cA con0 wcel cB
      con0 wcel vy cv con0 wcel cA cB vy cv coa co csuc comu co cA cB vy cv coa
      co comu co cA coa co wceq cA con0 wcel cB vy cv coa co con0 wcel cA cB vy
      cv coa co csuc comu co cA cB vy cv coa co comu co cA coa co wceq cB con0
      wcel vy cv con0 wcel wa cA cB vy cv coa co omsuc cB vy cv oacl sylan2
      3impb eqtrd cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB comu co
      cA vy cv csuc comu co coa co cA cB comu co cA vy cv comu co cA coa co coa
      co cA cB comu co cA vy cv comu co coa co cA coa co cA con0 wcel cB con0
      wcel vy cv con0 wcel w3a cA vy cv csuc comu co cA vy cv comu co cA coa co
      cA cB comu co coa cA con0 wcel vy cv con0 wcel cA vy cv csuc comu co cA
      vy cv comu co cA coa co wceq cB con0 wcel cA vy cv omsuc 3adant2 opreq2d
      cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB comu co cA vy cv comu co
      coa co cA coa co cA cB comu co cA vy cv comu co cA coa co coa co wceq cA
      con0 wcel cB con0 wcel vy cv con0 wcel cA cB comu co cA vy cv comu co coa
      co cA coa co cA cB comu co cA vy cv comu co cA coa co coa co wceq wi wi
      cA con0 wcel cB con0 wcel vy cv con0 wcel cA con0 wcel cA cB comu co cA
      vy cv comu co coa co cA coa co cA cB comu co cA vy cv comu co cA coa co
      coa co wceq cB con0 wcel cA con0 wcel vy cv con0 wcel cA con0 wcel cA cB
      comu co cA vy cv comu co coa co cA coa co cA cB comu co cA vy cv comu co
      cA coa co coa co wceq wi wi cA con0 wcel cB con0 wcel cA con0 wcel vy cv
      con0 wcel cA con0 wcel cA cB comu co cA vy cv comu co coa co cA coa co cA
      cB comu co cA vy cv comu co cA coa co coa co wceq wi cA con0 wcel cB con0
      wcel wa cA con0 wcel vy cv con0 wcel wa cA con0 wcel cA cB comu co cA vy
      cv comu co coa co cA coa co cA cB comu co cA vy cv comu co cA coa co coa
      co wceq cA con0 wcel cB con0 wcel wa cA vy cv comu co con0 wcel cA con0
      wcel cA cB comu co cA vy cv comu co coa co cA coa co cA cB comu co cA vy
      cv comu co cA coa co coa co wceq cA con0 wcel vy cv con0 wcel wa cA cB
      comu co con0 wcel cA vy cv comu co con0 wcel cA con0 wcel cA cB comu co
      cA vy cv comu co coa co cA coa co cA cB comu co cA vy cv comu co cA coa
      co coa co wceq cA con0 wcel cB con0 wcel wa cA cB comu co cA vy cv comu
      co cA oaass cA cB omcl syl3an1 cA vy cv omcl syl3an2 3exp exp4b pm2.43a
      com4r pm2.43i 3imp eqtr4d eqeq12d cA cB vy cv coa co comu co cA cB comu
      co cA vy cv comu co coa co cA coa opreq1 syl5bir 3exp com3r imp3a cA con0
      wcel cB con0 wcel wa vx cv wlim cA cB vy cv coa co comu co cA cB comu co
      cA vy cv comu co coa co wceq vy vx cv wral cA cB vx cv coa co comu co cA
      cB comu co cA vx cv comu co coa co wceq wi cB con0 wcel vx cv wlim cA cB
      vy cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv
      wral cA cB vx cv coa co comu co cA cB comu co cA vx cv comu co coa co
      wceq wi wi cA cB con0 wcel cA c0 wceq wa vx cv wlim cA cB vx cv coa co
      comu co cA cB comu co cA vx cv comu co coa co wceq cA cB vy cv coa co
      comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral cB con0
      wcel cA c0 wceq vx cv wlim cA cB vx cv coa co comu co cA cB comu co cA vx
      cv comu co coa co wceq wi cA c0 wceq vx cv wlim cB con0 wcel cA cB vx cv
      coa co comu co cA cB comu co cA vx cv comu co coa co wceq cA c0 wceq vx
      cv wlim cB con0 wcel cA cB vx cv coa co comu co cA cB comu co cA vx cv
      comu co coa co wceq cA c0 wceq cA cB vx cv coa co comu co cA cB comu co
      cA vx cv comu co coa co wceq c0 cB vx cv coa co comu co c0 cB comu co c0
      vx cv comu co coa co wceq vx cv wlim cB con0 wcel wa cA c0 wceq cA cB vx
      cv coa co comu co c0 cB vx cv coa co comu co cA cB comu co cA vx cv comu
      co coa co c0 cB comu co c0 vx cv comu co coa co cA c0 cB vx cv coa co
      comu opreq1 cA c0 wceq cA cB comu co c0 cB comu co cA vx cv comu co c0 vx
      cv comu co coa cA c0 cB comu opreq1 cA c0 vx cv comu opreq1 opreq12d
      eqeq12d cB con0 wcel vx cv wlim c0 cB vx cv coa co comu co c0 cB comu co
      c0 vx cv comu co coa co wceq cB con0 wcel vx cv con0 wcel c0 cB vx cv coa
      co comu co c0 cB comu co c0 vx cv comu co coa co wceq vx cv wlim cB con0
      wcel vx cv con0 wcel wa c0 cB vx cv coa co comu co c0 c0 cB comu co c0 vx
      cv comu co coa co cB con0 wcel vx cv con0 wcel wa cB vx cv coa co con0
      wcel c0 cB vx cv coa co comu co c0 wceq cB vx cv oacl cB vx cv coa co
      om0r syl cB con0 wcel vx cv con0 wcel wa c0 cB comu co c0 vx cv comu co
      coa co c0 c0 coa co c0 cB con0 wcel vx cv con0 wcel c0 cB comu co c0 c0
      vx cv comu co c0 coa cB om0r vx cv om0r opreqan12d c0 con0 wcel c0 c0 coa
      co c0 wceq 0elon c0 oa0 ax-mp syl6req eqtrd vx cv cvv wcel vx cv wlim vx
      cv con0 wcel vx visset vx cv cvv limelon mpan sylan2 ancoms syl5bir exp3a
      com3r imp a1dd cA con0 wcel cB con0 wcel wa c0 cA wcel vx cv wlim cA cB
      vy cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv
      wral cA cB vx cv coa co comu co cA cB comu co cA vx cv comu co coa co
      wceq wi wi vx cv wlim cA con0 wcel cB con0 wcel wa c0 cA wcel cA cB vy cv
      coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral
      cA cB vx cv coa co comu co cA cB comu co cA vx cv comu co coa co wceq wi
      vx cv wlim cA con0 wcel cB con0 wcel wa c0 cA wcel cA cB vy cv coa co
      comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral cA cB vx
      cv coa co comu co cA cB comu co cA vx cv comu co coa co wceq vx cv wlim
      cA con0 wcel cB con0 wcel wa wa c0 cA wcel cA cB vy cv coa co comu co cA
      cB comu co cA vy cv comu co coa co wceq vy vx cv wral wa wa vz cB vx cv
      coa co cA vz cv comu co ciun vw cA vx cv comu co cA cB comu co vw cv coa
      co ciun cA cB vx cv coa co comu co cA cB comu co cA vx cv comu co coa co
      vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel cA cB vy cv coa co
      comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral wa wa vz
      cB vx cv coa co cA vz cv comu co ciun vw cA vx cv comu co cA cB comu co
      vw cv coa co ciun vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel
      cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy
      vx cv wral wa wa cA vz cv comu co cA cB comu co vw cv coa co wss vw cA vx
      cv comu co wrex vz cB vx cv coa co wral vz cB vx cv coa co cA vz cv comu
      co ciun vw cA vx cv comu co cA cB comu co vw cv coa co ciun wss vx cv
      wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel cA cB vy cv coa co comu
      co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral wa wa cA vz
      cv comu co cA cB comu co vw cv coa co wss vw cA vx cv comu co wrex vz cB
      vx cv coa co vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel cA cB
      vy cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv
      wral wa wa vz cv cB vx cv coa co wcel wa vz cv cB wcel vv cv vx cv wcel
      cB vv cv coa co vz cv wceq wa vv con0 wrex wo cA vz cv comu co cA cB comu
      co vw cv coa co wss vw cA vx cv comu co wrex vx cv wlim cA con0 wcel cB
      con0 wcel wa wa vz cv cB vx cv coa co wcel vz cv cB wcel vv cv vx cv wcel
      cB vv cv coa co vz cv wceq wa vv con0 wrex wo c0 cA wcel cA cB vy cv coa
      co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral wa vx
      cv wlim cB con0 wcel vz cv cB vx cv coa co wcel vz cv cB wcel vv cv vx cv
      wcel cB vv cv coa co vz cv wceq wa vv con0 wrex wo cA con0 wcel vx cv
      con0 wcel cB con0 wcel vz cv cB vx cv coa co wcel vz cv cB wcel vv cv vx
      cv wcel cB vv cv coa co vz cv wceq wa vv con0 wrex wo vx cv wlim vx cv
      con0 wcel cB con0 wcel wa vz cv cB vx cv coa co wcel wa vz cv cB wcel vv
      cv vx cv wcel cB vv cv coa co vz cv wceq wa vv con0 wrex vx cv con0 wcel
      cB con0 wcel wa vz cv cB vx cv coa co wcel wa vz cv cB wcel wn cB vv cv
      coa co vz cv wceq vv con0 wrex vv cv vx cv wcel cB vv cv coa co vz cv
      wceq wa vv con0 wrex cB con0 wcel vz cv con0 wcel vz cv cB wcel wn cB vv
      cv coa co vz cv wceq vv con0 wrex wb vx cv con0 wcel cB con0 wcel wa vz
      cv cB vx cv coa co wcel wa cB con0 wcel vz cv con0 wcel wa cB vz cv wss
      vz cv cB wcel wn cB vv cv coa co vz cv wceq vv con0 wrex cB vz cv ontri1
      vv cB vz cv oawordex bitr3d vx cv con0 wcel cB con0 wcel vz cv cB vx cv
      coa co wcel simplr cB vx cv coa co con0 wcel vz cv cB vx cv coa co wcel
      vz cv con0 wcel vx cv con0 wcel cB con0 wcel wa cB vx cv coa co vz cv
      onelon cB con0 wcel vx cv con0 wcel cB vx cv coa co con0 wcel cB vx cv
      oacl ancoms sylan sylanc vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv
      coa co wcel wa cB vv cv coa co vz cv wceq vv cv vx cv wcel cB vv cv coa
      co vz cv wceq wa vv con0 vx cv con0 wcel cB con0 wcel wa vz cv cB vx cv
      coa co wcel vv cv con0 wcel cB vv cv coa co vz cv wceq vv cv vx cv wcel
      cB vv cv coa co vz cv wceq wa wi wi vz cv cB vx cv coa co wcel vv cv con0
      wcel cB vv cv coa co vz cv wceq vx cv con0 wcel cB con0 wcel wa vv cv vx
      cv wcel cB vv cv coa co vz cv wceq wa vz cv cB vx cv coa co wcel vv cv
      con0 wcel cB vv cv coa co vz cv wceq vx cv con0 wcel cB con0 wcel wa vv
      cv vx cv wcel cB vv cv coa co vz cv wceq wa vv cv con0 wcel cB vv cv coa
      co vz cv wceq wa vx cv con0 wcel cB con0 wcel wa wa vz cv cB vx cv coa co
      wcel vv cv vx cv wcel cB vv cv coa co vz cv wceq wa vv cv con0 wcel vx cv
      con0 wcel cB con0 wcel wa cB vv cv coa co vz cv wceq vz cv cB vx cv coa
      co wcel vv cv vx cv wcel cB vv cv coa co vz cv wceq wa wb vv cv con0 wcel
      vx cv con0 wcel cB con0 wcel wa wa cB vv cv coa co vz cv wceq wa vv cv vx
      cv wcel vz cv cB vx cv coa co wcel vv cv vx cv wcel cB vv cv coa co vz cv
      wceq wa vv cv con0 wcel vx cv con0 wcel cB con0 wcel wa wa vv cv vx cv
      wcel cB vv cv coa co cB vx cv coa co wcel cB vv cv coa co vz cv wceq vz
      cv cB vx cv coa co wcel vv cv con0 wcel vx cv con0 wcel cB con0 wcel vv
      cv vx cv wcel cB vv cv coa co cB vx cv coa co wcel wb vv cv vx cv cB
      oaord 3expb cB vv cv coa co vz cv cB vx cv coa co eleq1 sylan9bb cB vv cv
      coa co vz cv wceq vv cv vx cv wcel vv cv vx cv wcel cB vv cv coa co vz cv
      wceq wa wb vv cv con0 wcel vx cv con0 wcel cB con0 wcel wa wa cB vv cv
      coa co vz cv wceq vv cv vx cv wcel iba adantl bitr3d an1rs biimpcd exp4c
      com4r imp r19.22dv sylbid orrd vx cv cvv wcel vx cv wlim vx cv con0 wcel
      vx visset vx cv cvv limelon mpan sylanl1 adantlrl adantlr vx cv wlim cA
      con0 wcel cB con0 wcel wa wa c0 cA wcel cA cB vy cv coa co comu co cA cB
      comu co cA vy cv comu co coa co wceq vy vx cv wral wa wa vz cv cB wcel vv
      cv vx cv wcel cB vv cv coa co vz cv wceq wa vv con0 wrex wo cA vz cv comu
      co cA cB comu co vw cv coa co wss vw cA vx cv comu co wrex wi vz cv cB vx
      cv coa co wcel vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel cA
      cB vy cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx
      cv wral wa wa vz cv cB wcel cA vz cv comu co cA cB comu co vw cv coa co
      wss vw cA vx cv comu co wrex vv cv vx cv wcel cB vv cv coa co vz cv wceq
      wa vv con0 wrex vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel vz
      cv cB wcel cA vz cv comu co cA cB comu co vw cv coa co wss vw cA vx cv
      comu co wrex wi cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq vy vx cv wral vx cv wlim cA con0 wcel cB con0 wcel wa wa c0
      cA wcel wa vz cv cB wcel c0 cA vx cv comu co wcel cA vz cv comu co cA cB
      comu co c0 coa co wss wa cA vz cv comu co cA cB comu co vw cv coa co wss
      vw cA vx cv comu co wrex vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA
      wcel wa vz cv cB wcel c0 cA vx cv comu co wcel cA vz cv comu co cA cB
      comu co c0 coa co wss vx cv wlim cA con0 wcel c0 cA wcel vz cv cB wcel c0
      cA vx cv comu co wcel wi cB con0 wcel vx cv wlim cA con0 wcel wa c0 cA
      wcel wa c0 cA vx cv comu co wcel vz cv cB wcel vx cv wlim cA con0 wcel c0
      cA wcel c0 cA vx cv comu co wcel cA con0 wcel vx cv wlim c0 cA wcel c0 cA
      vx cv comu co wcel wi cA con0 wcel vx cv wlim c0 cA wcel vx cv wlim c0 cA
      vx cv comu co wcel cA con0 wcel vx cv wlim c0 cA wcel vx cv wlim c0 cA vx
      cv comu co wcel cA con0 wcel vx cv con0 wcel c0 cA wcel vx cv wlim wa c0
      cA vx cv comu co wcel wi vx cv wlim cA con0 wcel vx cv con0 wcel wa c0 cA
      wcel c0 vx cv wcel c0 cA vx cv comu co wcel vx cv wlim cA con0 wcel vx cv
      con0 wcel wa c0 cA vx cv comu co wcel c0 cA wcel c0 vx cv wcel wa cA vx
      cv om00el biimprd vx cv 0ellim sylan2i vx cv cvv wcel vx cv wlim vx cv
      con0 wcel vx visset vx cv cvv limelon mpan sylan2 exp4b com4r pm2.43a
      imp31 a1d adantlrr cA con0 wcel cB con0 wcel wa c0 cA wcel vz cv cB wcel
      cA vz cv comu co cA cB comu co c0 coa co wss wi vx cv wlim cA con0 wcel
      cB con0 wcel wa c0 cA wcel wa vz cv cB wcel cA vz cv comu co cA cB comu
      co wcel cA vz cv comu co cA cB comu co c0 coa co wss cB con0 wcel cA con0
      wcel c0 cA wcel vz cv cB wcel cA vz cv comu co cA cB comu co wcel wi vz
      cv cB cA omordi ancom1s cA con0 wcel cB con0 wcel wa cA vz cv comu co cA
      cB comu co wcel cA vz cv comu co cA cB comu co c0 coa co wss wi c0 cA
      wcel cA con0 wcel cB con0 wcel wa cA cB comu co con0 wcel cA vz cv comu
      co cA cB comu co wcel cA vz cv comu co cA cB comu co c0 coa co wss wi cA
      cB omcl cA cB comu co con0 wcel cA vz cv comu co cA cB comu co wcel cA vz
      cv comu co cA cB comu co wss cA vz cv comu co cA cB comu co c0 coa co wss
      cA cB comu co cA vz cv comu co onelss cA cB comu co con0 wcel cA cB comu
      co c0 coa co cA cB comu co cA vz cv comu co cA cB comu co oa0 sseq2d
      sylibrd syl adantr syld adantll jcad cA vz cv comu co cA cB comu co vw cv
      coa co wss cA vz cv comu co cA cB comu co c0 coa co wss vw c0 cA vx cv
      comu co vw cv c0 wceq cA cB comu co vw cv coa co cA cB comu co c0 coa co
      cA vz cv comu co vw cv c0 cA cB comu co coa opreq2 sseq2d rcla4ev syl6
      adantrr vx cv wlim cA con0 wcel c0 cA wcel cA cB vy cv coa co comu co cA
      cB comu co cA vy cv comu co coa co wceq vy vx cv wral wa vv cv vx cv wcel
      cB vv cv coa co vz cv wceq wa vv con0 wrex cA vz cv comu co cA cB comu co
      vw cv coa co wss vw cA vx cv comu co wrex wi cB con0 wcel vx cv wlim cA
      con0 wcel wa c0 cA wcel cA cB vy cv coa co comu co cA cB comu co cA vy cv
      comu co coa co wceq vy vx cv wral wa wa vv cv vx cv wcel cB vv cv coa co
      vz cv wceq wa cA vz cv comu co cA cB comu co vw cv coa co wss vw cA vx cv
      comu co wrex vv con0 vx cv wlim cA con0 wcel wa c0 cA wcel cA cB vy cv
      coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral
      wa wa vv cv vx cv wcel cB vv cv coa co vz cv wceq wa cA vz cv comu co cA
      cB comu co vw cv coa co wss vw cA vx cv comu co wrex wi vv cv con0 wcel
      vx cv wlim cA con0 wcel wa c0 cA wcel cA cB vy cv coa co comu co cA cB
      comu co cA vy cv comu co coa co wceq vy vx cv wral wa wa vv cv vx cv wcel
      cB vv cv coa co vz cv wceq wa cA vv cv comu co cA vx cv comu co wcel cA
      vz cv comu co cA cB comu co cA vv cv comu co coa co wss wa cA vz cv comu
      co cA cB comu co vw cv coa co wss vw cA vx cv comu co wrex vx cv wlim cA
      con0 wcel wa c0 cA wcel cA cB vy cv coa co comu co cA cB comu co cA vy cv
      comu co coa co wceq vy vx cv wral wa wa vv cv vx cv wcel cB vv cv coa co
      vz cv wceq wa cA vv cv comu co cA vx cv comu co wcel cA vz cv comu co cA
      cB comu co cA vv cv comu co coa co wss vx cv wlim cA con0 wcel wa c0 cA
      wcel vv cv vx cv wcel cB vv cv coa co vz cv wceq wa cA vv cv comu co cA
      vx cv comu co wcel wi cA cB vy cv coa co comu co cA cB comu co cA vy cv
      comu co coa co wceq vy vx cv wral vx cv wlim cA con0 wcel wa c0 cA wcel
      wa vv cv vx cv wcel cA vv cv comu co cA vx cv comu co wcel cB vv cv coa
      co vz cv wceq vx cv con0 wcel cA con0 wcel c0 cA wcel vv cv vx cv wcel cA
      vv cv comu co cA vx cv comu co wcel wi vx cv wlim vv cv vx cv cA omordi
      vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv cvv limelon
      mpan sylanl1 adantrd adantrr cA cB vy cv coa co comu co cA cB comu co cA
      vy cv comu co coa co wceq vy vx cv wral vv cv vx cv wcel cB vv cv coa co
      vz cv wceq wa cA vz cv comu co cA cB comu co cA vv cv comu co coa co wss
      wi vx cv wlim cA con0 wcel wa c0 cA wcel cA cB vy cv coa co comu co cA cB
      comu co cA vy cv comu co coa co wceq vy vx cv wral vv cv vx cv wcel cA cB
      vv cv coa co comu co cA cB comu co cA vv cv comu co coa co wceq wi vv cv
      vx cv wcel cB vv cv coa co vz cv wceq wa cA vz cv comu co cA cB comu co
      cA vv cv comu co coa co wss wi cA cB vy cv coa co comu co cA cB comu co
      cA vy cv comu co coa co wceq cA cB vv cv coa co comu co cA cB comu co cA
      vv cv comu co coa co wceq vy vv cv vx cv vy cv vv cv wceq cA cB vy cv coa
      co comu co cA cB vv cv coa co comu co cA cB comu co cA vy cv comu co coa
      co cA cB comu co cA vv cv comu co coa co vy cv vv cv wceq cB vy cv coa co
      cB vv cv coa co cA comu vy cv vv cv cB coa opreq2 opreq2d vy cv vv cv
      wceq cA vy cv comu co cA vv cv comu co cA cB comu co coa vy cv vv cv cA
      comu opreq2 opreq2d eqeq12d rcla4cv vv cv vx cv wcel cA cB vv cv coa co
      comu co cA cB comu co cA vv cv comu co coa co wceq wi vv cv vx cv wcel cB
      vv cv coa co vz cv wceq cA vz cv comu co cA cB comu co cA vv cv comu co
      coa co wss cA cB vv cv coa co comu co cA cB comu co cA vv cv comu co coa
      co wceq cB vv cv coa co vz cv wceq cA vz cv comu co cA cB comu co cA vv
      cv comu co coa co wss wi vv cv vx cv wcel cA cB vv cv coa co comu co cA
      cB comu co cA vv cv comu co coa co wceq cB vv cv coa co vz cv wceq cA cB
      comu co cA vv cv comu co coa co cA vz cv comu co wceq cA vz cv comu co cA
      cB comu co cA vv cv comu co coa co wss cA cB vv cv coa co comu co cA cB
      comu co cA vv cv comu co coa co wceq cA cB vv cv coa co comu co cA vz cv
      comu co wceq cA cB comu co cA vv cv comu co coa co cA vz cv comu co wceq
      cB vv cv coa co vz cv wceq cA cB vv cv coa co comu co cA cB comu co cA vv
      cv comu co coa co cA vz cv comu co eqeq1 cB vv cv coa co vz cv cA comu
      opreq2 syl5bi cA vz cv comu co cA cB comu co cA vv cv comu co coa co
      eqimss2 syl6 imim2i imp3a syl ad2antll jcad cA vz cv comu co cA cB comu
      co vw cv coa co wss cA vz cv comu co cA cB comu co cA vv cv comu co coa
      co wss vw cA vv cv comu co cA vx cv comu co vw cv cA vv cv comu co wceq
      cA cB comu co vw cv coa co cA cB comu co cA vv cv comu co coa co cA vz cv
      comu co vw cv cA vv cv comu co cA cB comu co coa opreq2 sseq2d rcla4ev
      syl6 a1d r19.23adv adantlrr jaod adantr mpd r19.21aiva vz vw cB vx cv coa
      co cA vx cv comu co cA vz cv comu co cA cB comu co vw cv coa co iunss2
      syl vx cv wlim cA con0 wcel cB con0 wcel wa wa cA cB vy cv coa co comu co
      cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral vw cA vx cv comu
      co cA cB comu co vw cv coa co ciun vz cB vx cv coa co cA vz cv comu co
      ciun wss c0 cA wcel vx cv wlim cA con0 wcel cB con0 wcel wa wa cA cB vy
      cv coa co comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv
      wral wa cA cB comu co vw cv coa co cA vz cv comu co wss vz cB vx cv coa
      co wrex vw cA vx cv comu co wral vw cA vx cv comu co cA cB comu co vw cv
      coa co ciun vz cB vx cv coa co cA vz cv comu co ciun wss vx cv wlim cA
      con0 wcel cB con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA
      vy cv comu co coa co wceq vy vx cv wral wa cA cB comu co vw cv coa co cA
      vz cv comu co wss vz cB vx cv coa co wrex vw cA vx cv comu co vx cv wlim
      cA con0 wcel cB con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co
      cA vy cv comu co coa co wceq vy vx cv wral wa vw cv cA vx cv comu co wcel
      wa vw cv cA vv cv comu co wcel vv vx cv wrex cA cB comu co vw cv coa co
      cA vz cv comu co wss vz cB vx cv coa co wrex vx cv wlim cA con0 wcel cB
      con0 wcel wa wa vw cv cA vx cv comu co wcel vw cv cA vv cv comu co wcel
      vv vx cv wrex cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq vy vx cv wral vx cv wlim cA con0 wcel vw cv cA vx cv comu co
      wcel vw cv cA vv cv comu co wcel vv vx cv wrex cB con0 wcel vx cv wlim cA
      con0 wcel wa vw cv cA vx cv comu co wcel vw cv cA vv cv comu co wcel vv
      vx cv wrex cA con0 wcel vx cv wlim vw cv cA vx cv comu co wcel vw cv cA
      vv cv comu co wcel vv vx cv wrex wi cA con0 wcel vx cv cvv wcel vx cv
      wlim vw cv cA vx cv comu co wcel vw cv cA vv cv comu co wcel vv vx cv
      wrex wi vx visset cA con0 wcel vx cv cvv wcel vx cv wlim wa wa vw cv cA
      vx cv comu co wcel vw cv cA vv cv comu co wcel vv vx cv wrex vv cA vx cv
      vw cv cvv omordlim ex mpanr1 ancoms imp adantlrr adantlr vx cv wlim cA
      con0 wcel cB con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA
      vy cv comu co coa co wceq vy vx cv wral wa vw cv cA vv cv comu co wcel vv
      vx cv wrex cA cB comu co vw cv coa co cA vz cv comu co wss vz cB vx cv
      coa co wrex wi vw cv cA vx cv comu co wcel vx cv wlim cA con0 wcel cB
      con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq vy vx cv wral wa vw cv cA vv cv comu co wcel cA cB comu co vw
      cv coa co cA vz cv comu co wss vz cB vx cv coa co wrex vv vx cv vx cv
      wlim cA con0 wcel cB con0 wcel wa wa cA cB vy cv coa co comu co cA cB
      comu co cA vy cv comu co coa co wceq vy vx cv wral wa vv cv vx cv wcel wa
      vw cv cA vv cv comu co wcel cB vv cv coa co cB vx cv coa co wcel cA cB
      comu co vw cv coa co cA cB vv cv coa co comu co wss wa cA cB comu co vw
      cv coa co cA vz cv comu co wss vz cB vx cv coa co wrex vx cv wlim cA con0
      wcel cB con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA vy cv
      comu co coa co wceq vy vx cv wral wa vv cv vx cv wcel wa vw cv cA vv cv
      comu co wcel cB vv cv coa co cB vx cv coa co wcel cA cB comu co vw cv coa
      co cA cB vv cv coa co comu co wss vx cv wlim cA con0 wcel cB con0 wcel wa
      wa vv cv vx cv wcel vw cv cA vv cv comu co wcel cB vv cv coa co cB vx cv
      coa co wcel wi cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq vy vx cv wral vx cv wlim cA con0 wcel cB con0 wcel wa wa vv
      cv vx cv wcel wa cB vv cv coa co cB vx cv coa co wcel vw cv cA vv cv comu
      co wcel vx cv wlim cB con0 wcel vv cv vx cv wcel cB vv cv coa co cB vx cv
      coa co wcel cA con0 wcel vx cv wlim cB con0 wcel wa vv cv vx cv wcel cB
      vv cv coa co cB vx cv coa co wcel vx cv con0 wcel cB con0 wcel vv cv vx
      cv wcel cB vv cv coa co cB vx cv coa co wcel wi vx cv wlim vv cv vx cv cB
      oaordi vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv cvv
      limelon mpan sylan imp adantlrl a1d adantlr vx cv wlim cA con0 wcel cB
      con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq vy vx cv wral wa vv cv vx cv wcel wa vw cv cA vv cv comu co
      wcel cA cB comu co vw cv coa co cA cB vv cv coa co comu co wcel cA cB
      comu co vw cv coa co cA cB vv cv coa co comu co wss vx cv wlim cA con0
      wcel cB con0 wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA vy cv
      comu co coa co wceq vy vx cv wral wa vv cv vx cv wcel wa vw cv cA vv cv
      comu co wcel cA cB comu co vw cv coa co cA cB comu co cA vv cv comu co
      coa co wcel cA cB comu co vw cv coa co cA cB vv cv coa co comu co wcel vx
      cv wlim cA con0 wcel cB con0 wcel wa wa vv cv vx cv wcel vw cv cA vv cv
      comu co wcel cA cB comu co vw cv coa co cA cB comu co cA vv cv comu co
      coa co wcel wi cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co
      coa co wceq vy vx cv wral vx cv wlim vv cv vx cv wcel cA con0 wcel cB
      con0 wcel wa vw cv cA vv cv comu co wcel cA cB comu co vw cv coa co cA cB
      comu co cA vv cv comu co coa co wcel wi vv cv con0 wcel cA con0 wcel cB
      con0 wcel wa vw cv cA vv cv comu co wcel cA cB comu co vw cv coa co cA cB
      comu co cA vv cv comu co coa co wcel wi vx cv wlim vv cv vx cv wcel wa cA
      vv cv comu co con0 wcel cA cB comu co con0 wcel vw cv cA vv cv comu co
      wcel cA cB comu co vw cv coa co cA cB comu co cA vv cv comu co coa co
      wcel wi vv cv con0 wcel cA con0 wcel cB con0 wcel wa wa vw cv cA vv cv
      comu co cA cB comu co oaordi vv cv con0 wcel cA con0 wcel cA vv cv comu
      co con0 wcel cB con0 wcel cA con0 wcel vv cv con0 wcel cA vv cv comu co
      con0 wcel cA vv cv omcl ancoms adantrr cA con0 wcel cB con0 wcel wa cA cB
      comu co con0 wcel vv cv con0 wcel cA cB omcl adantl sylanc vx cv word vv
      cv vx cv wcel vv cv con0 wcel vx cv wlim vx cv vv cv ordelon vx cv limord
      sylan sylan an1rs adantlr cA cB vy cv coa co comu co cA cB comu co cA vy
      cv comu co coa co wceq vy vx cv wral vv cv vx cv wcel cA cB comu co vw cv
      coa co cA cB vv cv coa co comu co wcel cA cB comu co vw cv coa co cA cB
      comu co cA vv cv comu co coa co wcel wb vx cv wlim cA con0 wcel cB con0
      wcel wa wa cA cB vy cv coa co comu co cA cB comu co cA vy cv comu co coa
      co wceq vy vx cv wral vv cv vx cv wcel wa cA cB vv cv coa co comu co cA
      cB comu co cA vv cv comu co coa co cA cB comu co vw cv coa co cA cB vy cv
      coa co comu co cA cB comu co cA vy cv comu co coa co wceq cA cB vv cv coa
      co comu co cA cB comu co cA vv cv comu co coa co wceq vy vv cv vx cv vy
      cv vv cv wceq cA cB vy cv coa co comu co cA cB vv cv coa co comu co cA cB
      comu co cA vy cv comu co coa co cA cB comu co cA vv cv comu co coa co vy
      cv vv cv wceq cB vy cv coa co cB vv cv coa co cA comu vy cv vv cv cB coa
      opreq2 opreq2d vy cv vv cv wceq cA vy cv comu co cA vv cv comu co cA cB
      comu co coa vy cv vv cv cA comu opreq2 opreq2d eqeq12d rcla4cva eleq2d
      adantll sylibrd vx cv wlim cA con0 wcel cB con0 wcel wa wa vv cv vx cv
      wcel cA cB comu co vw cv coa co cA cB vv cv coa co comu co wcel cA cB
      comu co vw cv coa co cA cB vv cv coa co comu co wss wi cA cB vy cv coa co
      comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral vx cv
      wlim cA con0 wcel cB con0 wcel wa wa vv cv vx cv wcel wa cA cB vv cv coa
      co comu co con0 wcel cA cB comu co vw cv coa co cA cB vv cv coa co comu
      co wcel cA cB comu co vw cv coa co cA cB vv cv coa co comu co wss wi vx
      cv wlim vv cv vx cv wcel cA con0 wcel cB con0 wcel wa cA cB vv cv coa co
      comu co con0 wcel vv cv con0 wcel cA con0 wcel cB con0 wcel wa cA cB vv
      cv coa co comu co con0 wcel vx cv wlim vv cv vx cv wcel wa cA con0 wcel
      vv cv con0 wcel cB con0 wcel cA cB vv cv coa co comu co con0 wcel cA con0
      wcel cB vv cv coa co con0 wcel cA cB vv cv coa co comu co con0 wcel vv cv
      con0 wcel cB con0 wcel wa cA cB vv cv coa co omcl cB con0 wcel vv cv con0
      wcel cB vv cv coa co con0 wcel cB vv cv oacl ancoms sylan2 an1s vx cv
      word vv cv vx cv wcel vv cv con0 wcel vx cv wlim vx cv vv cv ordelon vx
      cv limord sylan sylan an1rs cA cB vv cv coa co comu co cA cB comu co vw
      cv coa co onelss syl adantlr syld jcad cA cB comu co vw cv coa co cA vz
      cv comu co wss cA cB comu co vw cv coa co cA cB vv cv coa co comu co wss
      vz cB vv cv coa co cB vx cv coa co vz cv cB vv cv coa co wceq cA vz cv
      comu co cA cB vv cv coa co comu co cA cB comu co vw cv coa co vz cv cB vv
      cv coa co cA comu opreq2 sseq2d rcla4ev syl6 r19.23adva adantr mpd
      r19.21aiva vw vz cA vx cv comu co cB vx cv coa co cA cB comu co vw cv coa
      co cA vz cv comu co iunss2 syl adantrl eqssd vx cv wlim cA con0 wcel cB
      con0 wcel wa wa cA cB vx cv coa co comu co vz cB vx cv coa co cA vz cv
      comu co ciun wceq c0 cA wcel cA cB vy cv coa co comu co cA cB comu co cA
      vy cv comu co coa co wceq vy vx cv wral wa vx cv wlim cA con0 wcel cB
      con0 wcel wa wa cA con0 wcel cB vx cv coa co wlim wa cA cB vx cv coa co
      comu co vz cB vx cv coa co cA vz cv comu co ciun wceq cA con0 wcel vx cv
      wlim cB con0 wcel cA con0 wcel cB vx cv coa co wlim wa vx cv wlim cB con0
      wcel wa cB vx cv coa co wlim cA con0 wcel cB con0 wcel vx cv wlim cB vx
      cv coa co wlim cB con0 wcel vx cv cvv wcel vx cv wlim cB vx cv coa co
      wlim vx visset cB vx cv cvv oalimcl mpanr1 ancoms anim2i an1s cA con0
      wcel cB vx cv coa co cvv wcel cB vx cv coa co wlim cA cB vx cv coa co
      comu co vz cB vx cv coa co cA vz cv comu co ciun wceq cB vx cv coa oprex
      vz cA cB vx cv coa co cvv omlim mpanr1 syl adantr vx cv wlim cA con0 wcel
      cB con0 wcel wa wa c0 cA wcel cA cB comu co cA vx cv comu co coa co vw cA
      vx cv comu co cA cB comu co vw cv coa co ciun wceq cA cB vy cv coa co
      comu co cA cB comu co cA vy cv comu co coa co wceq vy vx cv wral cA cB
      comu co con0 wcel cA vx cv comu co cvv wcel cA vx cv comu co wlim wa cA
      cB comu co cA vx cv comu co coa co vw cA vx cv comu co cA cB comu co vw
      cv coa co ciun wceq vx cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel
      wa vw cA cB comu co cA vx cv comu co cvv oalim cA con0 wcel cB con0 wcel
      wa cA cB comu co con0 wcel vx cv wlim c0 cA wcel cA cB omcl ad2antlr vx
      cv wlim cA con0 wcel cB con0 wcel wa wa c0 cA wcel wa cA vx cv comu co
      wlim cA vx cv comu co cvv wcel vx cv wlim cA con0 wcel c0 cA wcel cA vx
      cv comu co wlim cB con0 wcel cA con0 wcel vx cv cvv wcel vx cv wlim wa wa
      c0 cA wcel cA vx cv comu co wlim vx cv wlim cA con0 wcel wa cA vx cv cvv
      omlimcl cA con0 wcel vx cv wlim cA con0 wcel vx cv cvv wcel vx cv wlim wa
      wa vx cv wlim vx cv cvv wcel vx cv wlim wa cA con0 wcel vx cv wlim vx cv
      cvv wcel vx visset jctl anim2i ancoms sylan adantlrr cA vx cv comu oprex
      jctil sylanc adantrr 3eqtr4d exp43 com3l imp oe0lem com12 tfinds3 exp3a
      com3l 3imp $.
      $( [20-May-2005] $) $( [26-Dec-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( Multiplication of ordinal numbers is associative.  Theorem 8.26 of
       [TakeutiZaring] p. 65. $)
    omass $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( ( A .o B ) .o C ) = ( A .o ( B .o C ) ) ) $=
      cA con0 wcel cB con0 wcel cC con0 wcel cA cB comu co cC comu co cA cB cC
      comu co comu co wceq cC con0 wcel cA con0 wcel cB con0 wcel cA cB comu co
      cC comu co cA cB cC comu co comu co wceq cC con0 wcel cA con0 wcel cB
      con0 wcel cA cB comu co cC comu co cA cB cC comu co comu co wceq cA cB
      comu co vx cv comu co cA cB vx cv comu co comu co wceq cA cB comu co c0
      comu co cA cB c0 comu co comu co wceq cA cB comu co vy cv comu co cA cB
      vy cv comu co comu co wceq cA cB comu co vy cv csuc comu co cA cB vy cv
      csuc comu co comu co wceq cA cB comu co cC comu co cA cB cC comu co comu
      co wceq vx vy cC cA con0 wcel cB con0 wcel wa vx cv c0 wceq cA cB comu co
      vx cv comu co cA cB comu co c0 comu co cA cB vx cv comu co comu co cA cB
      c0 comu co comu co vx cv c0 cA cB comu co comu opreq2 vx cv c0 wceq cB vx
      cv comu co cB c0 comu co cA comu vx cv c0 cB comu opreq2 opreq2d eqeq12d
      vx cv vy cv wceq cA cB comu co vx cv comu co cA cB comu co vy cv comu co
      cA cB vx cv comu co comu co cA cB vy cv comu co comu co vx cv vy cv cA cB
      comu co comu opreq2 vx cv vy cv wceq cB vx cv comu co cB vy cv comu co cA
      comu vx cv vy cv cB comu opreq2 opreq2d eqeq12d vx cv vy cv csuc wceq cA
      cB comu co vx cv comu co cA cB comu co vy cv csuc comu co cA cB vx cv
      comu co comu co cA cB vy cv csuc comu co comu co vx cv vy cv csuc cA cB
      comu co comu opreq2 vx cv vy cv csuc wceq cB vx cv comu co cB vy cv csuc
      comu co cA comu vx cv vy cv csuc cB comu opreq2 opreq2d eqeq12d vx cv cC
      wceq cA cB comu co vx cv comu co cA cB comu co cC comu co cA cB vx cv
      comu co comu co cA cB cC comu co comu co vx cv cC cA cB comu co comu
      opreq2 vx cv cC wceq cB vx cv comu co cB cC comu co cA comu vx cv cC cB
      comu opreq2 opreq2d eqeq12d cA con0 wcel cB con0 wcel wa cA cB comu co c0
      comu co c0 cA cB c0 comu co comu co cA con0 wcel cB con0 wcel wa cA cB
      comu co con0 wcel cA cB comu co c0 comu co c0 wceq cA cB omcl cA cB comu
      co om0 syl cB con0 wcel cA con0 wcel cA cB c0 comu co comu co cA c0 comu
      co c0 cB con0 wcel cB c0 comu co c0 cA comu cB om0 opreq2d cA om0
      sylan9eqr eqtr4d vy cv con0 wcel cA con0 wcel cB con0 wcel cA cB comu co
      vy cv comu co cA cB vy cv comu co comu co wceq cA cB comu co vy cv csuc
      comu co cA cB vy cv csuc comu co comu co wceq wi cA con0 wcel cB con0
      wcel vy cv con0 wcel cA cB comu co vy cv comu co cA cB vy cv comu co comu
      co wceq cA cB comu co vy cv csuc comu co cA cB vy cv csuc comu co comu co
      wceq wi cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB comu co vy cv
      comu co cA cB vy cv comu co comu co wceq cA cB comu co vy cv csuc comu co
      cA cB vy cv csuc comu co comu co wceq wi cA con0 wcel cB con0 wcel vy cv
      con0 wcel w3a cA cB comu co vy cv csuc comu co cA cB vy cv csuc comu co
      comu co wceq cA cB comu co vy cv comu co cA cB comu co coa co cA cB vy cv
      comu co comu co cA cB comu co coa co wceq cA cB comu co vy cv comu co cA
      cB vy cv comu co comu co wceq cA con0 wcel cB con0 wcel vy cv con0 wcel
      w3a cA cB comu co vy cv csuc comu co cA cB comu co vy cv comu co cA cB
      comu co coa co cA cB vy cv csuc comu co comu co cA cB vy cv comu co comu
      co cA cB comu co coa co cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB
      comu co vy cv csuc comu co cA cB comu co vy cv comu co cA cB comu co coa
      co wceq cA cB comu co con0 wcel vy cv con0 wcel cA cB comu co vy cv csuc
      comu co cA cB comu co vy cv comu co cA cB comu co coa co wceq cA con0
      wcel cB con0 wcel wa cA cB comu co vy cv omsuc cA cB omcl sylan 3impa cA
      con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB vy cv csuc comu co comu
      co cA cB vy cv comu co cB coa co comu co cA cB vy cv comu co comu co cA
      cB comu co coa co cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cB vy cv
      csuc comu co cB vy cv comu co cB coa co cA comu cB con0 wcel vy cv con0
      wcel cB vy cv csuc comu co cB vy cv comu co cB coa co wceq cA con0 wcel
      cB vy cv omsuc 3adant1 opreq2d cA con0 wcel cB con0 wcel vy cv con0 wcel
      cA cB vy cv comu co cB coa co comu co cA cB vy cv comu co comu co cA cB
      comu co coa co wceq cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB vy cv
      comu co cB coa co comu co cA cB vy cv comu co comu co cA cB comu co coa
      co wceq wi cA con0 wcel cB con0 wcel vy cv con0 wcel cB con0 wcel cA cB
      vy cv comu co cB coa co comu co cA cB vy cv comu co comu co cA cB comu co
      coa co wceq cA con0 wcel cB con0 wcel vy cv con0 wcel cB con0 wcel cA cB
      vy cv comu co cB coa co comu co cA cB vy cv comu co comu co cA cB comu co
      coa co wceq wi cA con0 wcel cB con0 wcel vy cv con0 wcel wa cB con0 wcel
      cA cB vy cv comu co cB coa co comu co cA cB vy cv comu co comu co cA cB
      comu co coa co wceq cA con0 wcel cB vy cv comu co con0 wcel cB con0 wcel
      cA cB vy cv comu co cB coa co comu co cA cB vy cv comu co comu co cA cB
      comu co coa co wceq cB con0 wcel vy cv con0 wcel wa cA cB vy cv comu co
      cB odi cB vy cv omcl syl3an2 3exp exp3a com34 pm2.43d 3imp eqtrd eqeq12d
      cA cB comu co vy cv comu co cA cB vy cv comu co comu co cA cB comu co coa
      opreq1 syl5bir 3exp com3r imp3a vx cv wlim cA con0 wcel cB con0 wcel cA
      cB comu co vy cv comu co cA cB vy cv comu co comu co wceq vy vx cv wral
      cA cB comu co vx cv comu co cA cB vx cv comu co comu co wceq wi cB con0
      wcel vx cv wlim cA con0 wcel cA cB comu co vy cv comu co cA cB vy cv comu
      co comu co wceq vy vx cv wral cA cB comu co vx cv comu co cA cB vx cv
      comu co comu co wceq wi cB con0 wcel vx cv wlim cA con0 wcel cA cB comu
      co vy cv comu co cA cB vy cv comu co comu co wceq vy vx cv wral cA cB
      comu co vx cv comu co cA cB vx cv comu co comu co wceq wi cB con0 wcel vx
      cv wlim wa cA con0 wcel wa c0 cB wcel cA cB comu co vy cv comu co cA cB
      vy cv comu co comu co wceq vy vx cv wral cA cB comu co vx cv comu co cA
      cB vx cv comu co comu co wceq wi cB con0 wcel vx cv wlim wa cA con0 wcel
      wa c0 cB wcel cA cB comu co vy cv comu co cA cB vy cv comu co comu co
      wceq vy vx cv wral cA cB comu co vx cv comu co cA cB vx cv comu co comu
      co wceq cB con0 wcel vx cv wlim wa cA con0 wcel wa c0 cB wcel wa cA cB
      comu co vy cv comu co cA cB vy cv comu co comu co wceq vy vx cv wral wa
      cA cB comu co vx cv comu co vy vx cv cA cB comu co vy cv comu co ciun cA
      cB vx cv comu co comu co cB con0 wcel vx cv wlim wa cA con0 wcel wa cA cB
      comu co vx cv comu co vy vx cv cA cB comu co vy cv comu co ciun wceq c0
      cB wcel cA cB comu co vy cv comu co cA cB vy cv comu co comu co wceq vy
      vx cv wral cB con0 wcel cA con0 wcel vx cv wlim cA cB comu co vx cv comu
      co vy vx cv cA cB comu co vy cv comu co ciun wceq cA cB comu co con0 wcel
      vx cv wlim cA cB comu co vx cv comu co vy vx cv cA cB comu co vy cv comu
      co ciun wceq cB con0 wcel cA con0 wcel wa cA cB comu co con0 wcel vx cv
      cvv wcel vx cv wlim cA cB comu co vx cv comu co vy vx cv cA cB comu co vy
      cv comu co ciun wceq vx visset vy cA cB comu co vx cv cvv omlim mpanr1 cA
      con0 wcel cB con0 wcel cA cB comu co con0 wcel cA cB omcl ancoms sylan
      an1rs ad2antrr cA cB comu co vy cv comu co cA cB vy cv comu co comu co
      wceq vy vx cv wral cB con0 wcel vx cv wlim wa cA con0 wcel wa c0 cB wcel
      wa vy vx cv cA cB comu co vy cv comu co ciun vy vx cv cA cB vy cv comu co
      comu co ciun cA cB vx cv comu co comu co vy vx cv cA cB comu co vy cv
      comu co cA cB vy cv comu co comu co iuneq2 cB con0 wcel vx cv wlim wa cA
      con0 wcel wa c0 cB wcel wa vy vx cv cA cB vy cv comu co comu co ciun vz
      cB vx cv comu co cA vz cv comu co ciun cA cB vx cv comu co comu co cB
      con0 wcel vx cv wlim wa cA con0 wcel wa c0 cB wcel wa vy vx cv cA cB vy
      cv comu co comu co ciun vz cB vx cv comu co cA vz cv comu co ciun cB con0
      wcel vx cv wlim wa c0 cB wcel vy vx cv cA cB vy cv comu co comu co ciun
      vz cB vx cv comu co cA vz cv comu co ciun wss cA con0 wcel cB con0 wcel
      vx cv wlim wa c0 cB wcel wa cA cB vy cv comu co comu co cA vz cv comu co
      wss vz cB vx cv comu co wrex vy vx cv wral vy vx cv cA cB vy cv comu co
      comu co ciun vz cB vx cv comu co cA vz cv comu co ciun wss cB con0 wcel
      vx cv wlim wa c0 cB wcel wa cA cB vy cv comu co comu co cA vz cv comu co
      wss vz cB vx cv comu co wrex vy vx cv cB con0 wcel vx cv wlim wa c0 cB
      wcel wa vy cv vx cv wcel cB vy cv comu co cB vx cv comu co wcel cA cB vy
      cv comu co comu co cA vz cv comu co wss vz cB vx cv comu co wrex vx cv
      con0 wcel cB con0 wcel wa c0 cB wcel vy cv vx cv wcel cB vy cv comu co cB
      vx cv comu co wcel wi cB con0 wcel vx cv wlim wa vy cv vx cv cB omordi vx
      cv wlim cB con0 wcel vx cv con0 wcel cB con0 wcel wa vx cv wlim vx cv
      con0 wcel cB con0 wcel vx cv cvv wcel vx cv wlim vx cv con0 wcel vx
      visset vx cv cvv limelon mpan anim1i ancoms sylan cB vy cv comu co cB vx
      cv comu co wcel cA cB vy cv comu co comu co cA cB vy cv comu co comu co
      wss cA cB vy cv comu co comu co cA vz cv comu co wss vz cB vx cv comu co
      wrex cA cB vy cv comu co comu co ssid cA cB vy cv comu co comu co cA vz
      cv comu co wss cA cB vy cv comu co comu co cA cB vy cv comu co comu co
      wss vz cB vy cv comu co cB vx cv comu co vz cv cB vy cv comu co wceq cA
      vz cv comu co cA cB vy cv comu co comu co cA cB vy cv comu co comu co vz
      cv cB vy cv comu co cA comu opreq2 sseq2d rcla4ev mpan2 syl6 r19.21aiv vy
      vz vx cv cB vx cv comu co cA cB vy cv comu co comu co cA vz cv comu co
      iunss2 syl adantlr cB con0 wcel vx cv wlim wa cA con0 wcel wa vz cB vx cv
      comu co cA vz cv comu co ciun vy vx cv cA cB vy cv comu co comu co ciun
      wss c0 cB wcel cB con0 wcel vx cv wlim wa cA con0 wcel wa cA vz cv comu
      co cA cB vy cv comu co comu co wss vy vx cv wrex vz cB vx cv comu co wral
      vz cB vx cv comu co cA vz cv comu co ciun vy vx cv cA cB vy cv comu co
      comu co ciun wss cB con0 wcel vx cv wlim wa cA con0 wcel wa cA vz cv comu
      co cA cB vy cv comu co comu co wss vy vx cv wrex vz cB vx cv comu co vz
      cv con0 wcel cB con0 wcel vx cv wlim wa cA con0 wcel wa vz cv cB vx cv
      comu co wcel wa cA vz cv comu co cA cB vy cv comu co comu co wss vy vx cv
      wrex cB con0 wcel vx cv wlim wa vz cv cB vx cv comu co wcel vz cv con0
      wcel cA con0 wcel cB vx cv comu co con0 wcel vz cv cB vx cv comu co wcel
      vz cv con0 wcel cB con0 wcel vx cv wlim wa cB vx cv comu co vz cv onelon
      cB con0 wcel vx cv con0 wcel cB vx cv comu co con0 wcel vx cv wlim cB vx
      cv omcl vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv cvv
      limelon mpan sylan2 sylan adantlr vz cv con0 wcel cB con0 wcel vx cv wlim
      wa cA con0 wcel vz cv cB vx cv comu co wcel cA vz cv comu co cA cB vy cv
      comu co comu co wss vy vx cv wrex vz cv con0 wcel cB con0 wcel vx cv wlim
      wa cA con0 wcel vz cv cB vx cv comu co wcel cA vz cv comu co cA cB vy cv
      comu co comu co wss vy vx cv wrex wi vz cv con0 wcel cB con0 wcel vx cv
      wlim wa wa cA con0 wcel wa vz cv cB vx cv comu co wcel vz cv cB vy cv
      comu co wcel vy vx cv wrex cA vz cv comu co cA cB vy cv comu co comu co
      wss vy vx cv wrex cB con0 wcel vx cv wlim wa vz cv cB vx cv comu co wcel
      vz cv cB vy cv comu co wcel vy vx cv wrex wi vz cv con0 wcel cA con0 wcel
      cB con0 wcel vx cv cvv wcel vx cv wlim vz cv cB vx cv comu co wcel vz cv
      cB vy cv comu co wcel vy vx cv wrex wi vx visset cB con0 wcel vx cv cvv
      wcel vx cv wlim wa wa vz cv cB vx cv comu co wcel vz cv cB vy cv comu co
      wcel vy vx cv wrex vy cB vx cv vz cv cvv omordlim ex mpanr1 ad2antlr vz
      cv con0 wcel cB con0 wcel vx cv wlim wa wa cA con0 wcel wa vz cv cB vy cv
      comu co wcel cA vz cv comu co cA cB vy cv comu co comu co wss vy vx cv vz
      cv con0 wcel cB con0 wcel vx cv wlim wa wa cA con0 wcel vy cv vx cv wcel
      vz cv cB vy cv comu co wcel cA vz cv comu co cA cB vy cv comu co comu co
      wss wi wi vz cv con0 wcel cB con0 wcel vx cv wlim wa wa vy cv vx cv wcel
      cA con0 wcel vz cv cB vy cv comu co wcel cA vz cv comu co cA cB vy cv
      comu co comu co wss wi vz cv con0 wcel cB con0 wcel vx cv wlim vy cv vx
      cv wcel cA con0 wcel vz cv cB vy cv comu co wcel cA vz cv comu co cA cB
      vy cv comu co comu co wss wi wi wi vz cv con0 wcel cB con0 wcel vx cv
      wlim vy cv vx cv wcel cA con0 wcel vz cv cB vy cv comu co wcel cA vz cv
      comu co cA cB vy cv comu co comu co wss wi wi vz cv con0 wcel cB vy cv
      comu co con0 wcel cA con0 wcel vz cv cB vy cv comu co wcel cA vz cv comu
      co cA cB vy cv comu co comu co wss wi wi cB con0 wcel vx cv wlim vy cv vx
      cv wcel wa wa vz cv con0 wcel cB vy cv comu co con0 wcel cA con0 wcel vz
      cv cB vy cv comu co wcel cA vz cv comu co cA cB vy cv comu co comu co wss
      wi vz cv con0 wcel cB vy cv comu co con0 wcel cA con0 wcel w3a vz cv cB
      vy cv comu co wcel vz cv cB vy cv comu co wss cA vz cv comu co cA cB vy
      cv comu co comu co wss cB vy cv comu co con0 wcel vz cv con0 wcel vz cv
      cB vy cv comu co wcel vz cv cB vy cv comu co wss wi cA con0 wcel cB vy cv
      comu co vz cv onelss 3ad2ant2 vz cv cB vy cv comu co cA omwordi syld 3exp
      cB con0 wcel vy cv con0 wcel cB vy cv comu co con0 wcel vx cv wlim vy cv
      vx cv wcel wa cB vy cv omcl vx cv con0 wcel vy cv vx cv wcel vy cv con0
      wcel vx cv wlim vx cv vy cv onelon vx cv cvv wcel vx cv wlim vx cv con0
      wcel vx visset vx cv cvv limelon mpan sylan sylan2 syl5 exp4d imp32 com23
      imp r19.22dv syld exp31 imp4c mpcom r19.21aiva vz vy cB vx cv comu co vx
      cv cA vz cv comu co cA cB vy cv comu co comu co iunss2 syl adantr eqssd
      cB con0 wcel vx cv wlim wa c0 cB wcel cA con0 wcel cA cB vx cv comu co
      comu co vz cB vx cv comu co cA vz cv comu co ciun wceq cA con0 wcel cB
      con0 wcel vx cv wlim wa c0 cB wcel wa cA cB vx cv comu co comu co vz cB
      vx cv comu co cA vz cv comu co ciun wceq cA con0 wcel cB vx cv comu co
      wlim cA cB vx cv comu co comu co vz cB vx cv comu co cA vz cv comu co
      ciun wceq cB con0 wcel vx cv wlim wa c0 cB wcel wa cA con0 wcel cB vx cv
      comu co cvv wcel cB vx cv comu co wlim cA cB vx cv comu co comu co vz cB
      vx cv comu co cA vz cv comu co ciun wceq cB vx cv comu oprex vz cA cB vx
      cv comu co cvv omlim mpanr1 cB con0 wcel vx cv cvv wcel vx cv wlim c0 cB
      wcel cB vx cv comu co wlim vx visset cB vx cv cvv omlimcl mpanlr1 sylan2
      ancoms an1rs eqtr4d sylan9eqr eqtrd exp31 cB con0 wcel vx cv wlim wa cA
      con0 wcel wa c0 cB wcel wn cA cB comu co vx cv comu co cA cB vx cv comu
      co comu co wceq cA cB comu co vy cv comu co cA cB vy cv comu co comu co
      wceq vy vx cv wral cB con0 wcel vx cv wlim wa cA con0 wcel wa c0 cB wcel
      wn cB c0 wceq cA cB comu co vx cv comu co cA cB vx cv comu co comu co
      wceq cB con0 wcel cB c0 wceq c0 cB wcel wn wb vx cv wlim cA con0 wcel cB
      con0 wcel cB word cB c0 wceq c0 cB wcel wn wb cB eloni cB word c0 cB wcel
      cB c0 cB ord0eln0 necon2bbid syl ad2antrr vx cv wlim cA con0 wcel cB c0
      wceq cA cB comu co vx cv comu co cA cB vx cv comu co comu co wceq wi cB
      con0 wcel vx cv con0 wcel cA con0 wcel cB c0 wceq cA cB comu co vx cv
      comu co cA cB vx cv comu co comu co wceq wi vx cv wlim vx cv con0 wcel cA
      con0 wcel wa cB c0 wceq cA cB comu co vx cv comu co cA cB vx cv comu co
      comu co wceq vx cv con0 wcel cA con0 wcel wa cB c0 wceq wa cA cB comu co
      vx cv comu co c0 cA cB vx cv comu co comu co vx cv con0 wcel cA con0 wcel
      cB c0 wceq cA cB comu co vx cv comu co c0 wceq cA con0 wcel cB c0 wceq wa
      vx cv con0 wcel cA cB comu co vx cv comu co c0 vx cv comu co c0 cA con0
      wcel cB c0 wceq wa cA cB comu co c0 vx cv comu cB c0 wceq cA con0 wcel cA
      cB comu co cA c0 comu co c0 cB c0 cA comu opreq2 cA om0 sylan9eqr opreq1d
      vx cv om0r sylan9eqr anassrs vx cv con0 wcel cB c0 wceq cA con0 wcel cA
      cB vx cv comu co comu co c0 wceq vx cv con0 wcel cB c0 wceq wa cA con0
      wcel cA cB vx cv comu co comu co cA c0 comu co c0 vx cv con0 wcel cB c0
      wceq wa cB vx cv comu co c0 cA comu cB c0 wceq vx cv con0 wcel cB vx cv
      comu co c0 vx cv comu co c0 cB c0 vx cv comu opreq1 vx cv om0r sylan9eqr
      opreq2d cA om0 sylan9eq an1rs eqtr4d ex vx cv cvv wcel vx cv wlim vx cv
      con0 wcel vx visset vx cv cvv limelon mpan sylan adantll sylbird a1dd
      pm2.61d exp31 com3l imp3a tfinds3 exp3a com3l 3imp $.
      $( [23-May-2005] $) $( [28-Dec-2004] $)
  $}

  $( If an ordinal number is even, its successor is odd. $)
  oneo $p |- ( ( A e. On /\ B e. On /\ C = ( 2o .o A ) ) ->
              -. suc C = ( 2o .o B ) ) $=
    cA con0 wcel cB con0 wcel cC c2o cA comu co wceq w3a cC csuc c2o cB comu co
    wceq cA cB wcel cB cA csuc wcel wa cA con0 wcel cB con0 wcel cA cB wcel cB
    cA csuc wcel wa wn cC c2o cA comu co wceq cA cB onnbtwn 3ad2ant1 cA con0
    wcel cB con0 wcel cC c2o cA comu co wceq w3a cC csuc c2o cB comu co wceq
    c2o cA comu co csuc c2o cB comu co wceq cA cB wcel cB cA csuc wcel wa cC
    c2o cA comu co wceq cA con0 wcel cC csuc c2o cB comu co wceq c2o cA comu co
    csuc c2o cB comu co wceq wb cB con0 wcel cC c2o cA comu co wceq cC csuc c2o
    cA comu co csuc c2o cB comu co cC c2o cA comu co suceq eqeq1d 3ad2ant3 cA
    con0 wcel cB con0 wcel c2o cA comu co csuc c2o cB comu co wceq cA cB wcel
    cB cA csuc wcel wa wi cC c2o cA comu co wceq cA con0 wcel cB con0 wcel wa
    c2o cA comu co csuc c2o cB comu co wceq cA cB wcel cB cA csuc wcel cA con0
    wcel cB con0 wcel wa c2o cA comu co c2o cB comu co wcel cA cB wcel c2o cA
    comu co csuc c2o cB comu co wceq cA con0 wcel cB con0 wcel wa c2o cA comu
    co c2o cB comu co wcel cA cB wcel c0 c2o wcel wa cA cB wcel cA con0 wcel cB
    con0 wcel c2o con0 wcel cA cB wcel c0 c2o wcel wa c2o cA comu co c2o cB
    comu co wcel wb 2on cA cB c2o omord mp3an3 cA cB wcel c0 c2o wcel pm3.26
    syl6bir c2o cA comu co csuc c2o cB comu co wceq c2o cA comu co c2o cA comu
    co csuc wcel c2o cA comu co c2o cB comu co wcel c2o cA comu co c2o cA comu
    oprex sucid c2o cA comu co csuc c2o cB comu co c2o cA comu co eleq2 mpbii
    syl5 cA con0 wcel cB con0 wcel wa c2o cA comu co csuc c2o cB comu co wceq
    cB cA csuc wcel cA con0 wcel cB con0 wcel wa c2o cA comu co csuc c2o cB
    comu co wceq wa cB cA csuc wcel c0 c2o wcel cA con0 wcel cB con0 wcel wa
    c2o cA comu co csuc c2o cB comu co wceq wa cB cA csuc wcel c0 c2o wcel wa
    c2o cB comu co c2o cA csuc comu co wcel cA con0 wcel cB con0 wcel wa c2o cA
    comu co csuc c2o cB comu co wceq wa c2o cA comu co csuc c2o cB comu co c2o
    cA csuc comu co cA con0 wcel cB con0 wcel wa c2o cA comu co csuc c2o cB
    comu co wceq pm3.27 cA con0 wcel c2o cA comu co csuc c2o cA csuc comu co
    wcel cB con0 wcel c2o cA comu co csuc c2o cB comu co wceq cA con0 wcel c2o
    cA comu co c1o coa co c2o cA comu co csuc c2o cA csuc comu co cA con0 wcel
    c2o cA comu co con0 wcel c2o cA comu co c1o coa co c2o cA comu co csuc wceq
    c2o con0 wcel cA con0 wcel c2o cA comu co con0 wcel 2on c2o cA omcl mpan
    c2o cA comu co oa1suc syl cA con0 wcel c2o cA comu co c1o coa co c2o cA
    comu co c2o coa co c2o cA csuc comu co cA con0 wcel c1o c2o wcel c2o cA
    comu co c1o coa co c2o cA comu co c2o coa co wcel c1o c1o csuc c2o c1o c1o
    con0 1on elisseti sucid df-2o eleqtrri cA con0 wcel c2o cA comu co con0
    wcel c1o c2o wcel c2o cA comu co c1o coa co c2o cA comu co c2o coa co wcel
    wb c2o con0 wcel cA con0 wcel c2o cA comu co con0 wcel 2on c2o cA omcl mpan
    c1o con0 wcel c2o con0 wcel c2o cA comu co con0 wcel c1o c2o wcel c2o cA
    comu co c1o coa co c2o cA comu co c2o coa co wcel wb 1on 2on c1o c2o c2o cA
    comu co oaord mp3an12 syl mpbii c2o con0 wcel cA con0 wcel c2o cA csuc comu
    co c2o cA comu co c2o coa co wceq 2on c2o cA omsuc mpan eleqtrrd eqeltrrd
    ad2antrr eqeltrrd cA con0 wcel cB con0 wcel wa cB cA csuc wcel c0 c2o wcel
    wa c2o cB comu co c2o cA csuc comu co wcel wb c2o cA comu co csuc c2o cB
    comu co wceq cB con0 wcel cA con0 wcel cB cA csuc wcel c0 c2o wcel wa c2o
    cB comu co c2o cA csuc comu co wcel wb cB con0 wcel cA csuc con0 wcel cB cA
    csuc wcel c0 c2o wcel wa c2o cB comu co c2o cA csuc comu co wcel wb cA con0
    wcel cB con0 wcel cA csuc con0 wcel c2o con0 wcel cB cA csuc wcel c0 c2o
    wcel wa c2o cB comu co c2o cA csuc comu co wcel wb 2on cB cA csuc c2o omord
    mp3an3 cA suceloni sylan2 ancoms adantr mpbird pm3.26d ex jcad 3adant3
    sylbid mtod $.
    $( [26-Jan-2006] $) $( [26-Jan-2006] $)

  ${
    $d x y A $.  $d x y B $.
    $( Ordinal exponentiation with a nonzero mantissa is nonzero.  Proposition
       8.32 of [TakeutiZaring] p. 67. $)
    oen0 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. A ) ->
               (/) e. ( A ^o B ) ) $=
      cA con0 wcel cB con0 wcel c0 cA wcel c0 cA cB coe co wcel cB con0 wcel cA
      con0 wcel c0 cA wcel c0 cA cB coe co wcel wi cB con0 wcel cA con0 wcel c0
      cA wcel c0 cA cB coe co wcel c0 cA vx cv coe co wcel c0 cA c0 coe co wcel
      c0 cA vy cv coe co wcel c0 cA vy cv csuc coe co wcel c0 cA cB coe co wcel
      vx vy cB cA con0 wcel c0 cA wcel wa vx cv c0 wceq cA vx cv coe co cA c0
      coe co c0 vx cv c0 cA coe opreq2 eleq2d vx cv vy cv wceq cA vx cv coe co
      cA vy cv coe co c0 vx cv vy cv cA coe opreq2 eleq2d vx cv vy cv csuc wceq
      cA vx cv coe co cA vy cv csuc coe co c0 vx cv vy cv csuc cA coe opreq2
      eleq2d vx cv cB wceq cA vx cv coe co cA cB coe co c0 vx cv cB cA coe
      opreq2 eleq2d cA con0 wcel c0 cA c0 coe co wcel c0 cA wcel cA con0 wcel
      c1o cA c0 coe co c0 cA oe0 0lt1o syl5eleqr adantr vy cv con0 wcel cA con0
      wcel c0 cA wcel c0 cA vy cv coe co wcel c0 cA vy cv csuc coe co wcel wi
      vy cv con0 wcel cA con0 wcel c0 cA vy cv coe co wcel c0 cA wcel c0 cA vy
      cv csuc coe co wcel cA con0 wcel vy cv con0 wcel c0 cA vy cv coe co wcel
      c0 cA wcel c0 cA vy cv csuc coe co wcel wi wi cA con0 wcel vy cv con0
      wcel c0 cA vy cv coe co wcel c0 cA wcel c0 cA vy cv csuc coe co wcel wi
      cA con0 wcel vy cv con0 wcel wa c0 cA vy cv coe co wcel wa c0 cA wcel c0
      cA vy cv coe co cA comu co wcel c0 cA vy cv csuc coe co wcel cA con0 wcel
      cA vy cv coe co con0 wcel wa c0 cA vy cv coe co wcel c0 cA wcel c0 cA vy
      cv coe co cA comu co wcel wi cA con0 wcel vy cv con0 wcel wa cA con0 wcel
      cA vy cv coe co con0 wcel wa c0 cA vy cv coe co wcel wa c0 cA wcel cA vy
      cv coe co c0 comu co cA vy cv coe co cA comu co wcel c0 cA vy cv coe co
      cA comu co wcel c0 cA cA vy cv coe co omordi cA vy cv coe co con0 wcel cA
      vy cv coe co c0 comu co cA vy cv coe co cA comu co wcel c0 cA vy cv coe
      co cA comu co wcel wb cA con0 wcel c0 cA vy cv coe co wcel cA vy cv coe
      co con0 wcel cA vy cv coe co c0 comu co c0 cA vy cv coe co cA comu co cA
      vy cv coe co om0 eleq1d ad2antlr sylibd cA con0 wcel vy cv con0 wcel wa
      cA con0 wcel cA vy cv coe co con0 wcel cA con0 wcel vy cv con0 wcel
      pm3.26 cA vy cv oecl jca sylan cA con0 wcel vy cv con0 wcel wa c0 cA vy
      cv csuc coe co wcel c0 cA vy cv coe co cA comu co wcel wb c0 cA vy cv coe
      co wcel cA con0 wcel vy cv con0 wcel wa cA vy cv csuc coe co cA vy cv coe
      co cA comu co c0 cA vy cv oesuc eleq2d adantr sylibrd exp31 com12 com34
      imp3a vx cv wlim cA con0 wcel c0 cA wcel wa c0 cA vx cv coe co wcel c0 cA
      vy cv coe co wcel vy vx cv wral vx cv wlim cA con0 wcel c0 cA wcel wa c0
      cA vx cv coe co wcel vx cv wlim cA con0 wcel c0 cA wcel wa wa c0 cA vx cv
      coe co wcel c1o cA vx cv coe co wss vx cv wlim cA con0 wcel c0 cA wcel wa
      wa c1o vy vx cv cA vy cv coe co ciun cA vx cv coe co vx cv wlim cA con0
      wcel c1o vy vx cv cA vy cv coe co ciun wss c0 cA wcel vx cv wlim cA con0
      wcel wa c0 vx cv wcel c1o cA c0 coe co wss wa c1o cA vy cv coe co wss vy
      vx cv wrex c1o vy vx cv cA vy cv coe co ciun wss vx cv wlim c0 vx cv wcel
      cA con0 wcel c1o cA c0 coe co wss vx cv 0ellim cA con0 wcel cA c0 coe co
      c1o wceq c1o cA c0 coe co wss cA oe0 c1o cA c0 coe co eqimss2 syl anim12i
      c1o cA vy cv coe co wss c1o cA c0 coe co wss vy c0 vx cv vy cv c0 wceq cA
      vy cv coe co cA c0 coe co c1o vy cv c0 cA coe opreq2 sseq2d rcla4ev vy vx
      cv cA vy cv coe co c1o ssiun 3syl adantrr cA con0 wcel vx cv wlim c0 cA
      wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq cA con0 wcel vx
      cv wlim c0 cA wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq cA
      con0 wcel vx cv cvv wcel vx cv wlim c0 cA wcel cA vx cv coe co vy vx cv
      cA vy cv coe co ciun wceq vx visset vy cA vx cv cvv oelim mpanlr1 anasss
      an1s sseqtr4d vx cv wlim cA con0 wcel c0 cA vx cv coe co wcel c1o cA vx
      cv coe co wss wb c0 cA wcel vx cv wlim cA con0 wcel wa cA vx cv coe co
      con0 wcel cA vx cv coe co word c0 cA vx cv coe co wcel c1o cA vx cv coe
      co wss wb vx cv con0 wcel cA con0 wcel cA vx cv coe co con0 wcel vx cv
      wlim cA con0 wcel vx cv con0 wcel cA vx cv coe co con0 wcel cA vx cv oecl
      ancoms vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv cvv
      limelon mpan sylan cA vx cv coe co eloni cA vx cv coe co ordgt0ge1 3syl
      adantrr mpbird ex a1dd tfinds3 exp3a com12 imp31 $.
      $( [10-Jan-2005] $) $( [4-Jan-2005] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Ordering law for ordinal exponentiation.  Proposition 8.33 of
       [TakeutiZaring] p. 67. $)
    oeordi $p |- ( ( ( B e. On /\ C e. On ) /\ 1o e. C ) ->
                 ( A e. B -> ( C ^o A ) e. ( C ^o B ) ) ) $=
      cB con0 wcel cC con0 wcel c1o cC wcel cA cB wcel cC cA coe co cC cB coe
      co wcel wi cB con0 wcel cA cB wcel c1o cC wcel cC con0 wcel cC cA coe co
      cC cB coe co wcel cB con0 wcel cA cB wcel cC con0 wcel c1o cC wcel cC cA
      coe co cC cB coe co wcel cB con0 wcel cA cB wcel cC con0 wcel c1o cC wcel
      cC cA coe co cC cB coe co wcel cC con0 wcel c1o cC wcel wa cC cA coe co
      cC vx cv coe co wcel wi cC con0 wcel c1o cC wcel wa cC cA coe co cC cA
      csuc coe co wcel wi cC con0 wcel c1o cC wcel wa cC cA coe co cC vy cv coe
      co wcel wi cC con0 wcel c1o cC wcel wa cC cA coe co cC vy cv csuc coe co
      wcel wi cC con0 wcel c1o cC wcel wa cC cA coe co cC cB coe co wcel wi vx
      vy cB cA vx cv cA csuc wceq cC cA coe co cC vx cv coe co wcel cC cA coe
      co cC cA csuc coe co wcel cC con0 wcel c1o cC wcel wa vx cv cA csuc wceq
      cC vx cv coe co cC cA csuc coe co cC cA coe co vx cv cA csuc cC coe
      opreq2 eleq2d imbi2d vx cv vy cv wceq cC cA coe co cC vx cv coe co wcel
      cC cA coe co cC vy cv coe co wcel cC con0 wcel c1o cC wcel wa vx cv vy cv
      wceq cC vx cv coe co cC vy cv coe co cC cA coe co vx cv vy cv cC coe
      opreq2 eleq2d imbi2d vx cv vy cv csuc wceq cC cA coe co cC vx cv coe co
      wcel cC cA coe co cC vy cv csuc coe co wcel cC con0 wcel c1o cC wcel wa
      vx cv vy cv csuc wceq cC vx cv coe co cC vy cv csuc coe co cC cA coe co
      vx cv vy cv csuc cC coe opreq2 eleq2d imbi2d vx cv cB wceq cC cA coe co
      cC vx cv coe co wcel cC cA coe co cC cB coe co wcel cC con0 wcel c1o cC
      wcel wa vx cv cB wceq cC vx cv coe co cC cB coe co cC cA coe co vx cv cB
      cC coe opreq2 eleq2d imbi2d cA con0 wcel cC con0 wcel c1o cC wcel cC cA
      coe co cC cA csuc coe co wcel cC con0 wcel cA con0 wcel c1o cC wcel cC cA
      coe co cC cA csuc coe co wcel wi cC con0 wcel cA con0 wcel wa c1o cC wcel
      cC cA coe co c1o comu co cC cA coe co cC comu co wcel cC cA coe co cC cA
      csuc coe co wcel c1o cC wcel cC con0 wcel cA con0 wcel wa cC con0 wcel cC
      cA coe co con0 wcel wa c0 cC cA coe co wcel wa cC cA coe co c1o comu co
      cC cA coe co cC comu co wcel cC con0 wcel cA con0 wcel wa c1o cC wcel c0
      cC cA coe co wcel cC con0 wcel cC cA coe co con0 wcel wa cC con0 wcel cA
      con0 wcel wa c1o cC wcel c0 cC wcel c0 cC cA coe co wcel cC con0 wcel c1o
      cC wcel c0 cC wcel wi cA con0 wcel cC con0 wcel c0 c1o wcel c1o cC wcel
      c0 cC wcel 0lt1o c0 c1o cC ontr1 mpani adantr cC con0 wcel cA con0 wcel
      wa c0 cC wcel c0 cC cA coe co wcel cC cA oen0 ex syld cC con0 wcel cA
      con0 wcel wa cC con0 wcel cC cA coe co con0 wcel cC con0 wcel cA con0
      wcel pm3.26 cC cA oecl jca jctild c1o cC cC cA coe co omordi syli cC con0
      wcel cA con0 wcel wa cC cA coe co c1o comu co cC cA coe co cC comu co
      wcel cC cA coe co cC cA coe co cC comu co wcel cC cA coe co cC cA csuc
      coe co wcel cC con0 wcel cA con0 wcel wa cC cA coe co c1o comu co cC cA
      coe co cC cA coe co cC comu co cC con0 wcel cA con0 wcel wa cC cA coe co
      con0 wcel cC cA coe co c1o comu co cC cA coe co wceq cC cA oecl cC cA coe
      co om1 syl eleq1d cC con0 wcel cA con0 wcel wa cC cA csuc coe co cC cA
      coe co cC comu co cC cA coe co cC cA oesuc eleq2d bitr4d sylibd expcom
      imp3a vy cv con0 wcel cA vy cv wcel wa cC con0 wcel c1o cC wcel wa cC cA
      coe co cC vy cv coe co wcel cC cA coe co cC vy cv csuc coe co wcel vy cv
      con0 wcel cC con0 wcel c1o cC wcel wa cC cA coe co cC vy cv coe co wcel
      cC cA coe co cC vy cv csuc coe co wcel wi wi cA vy cv wcel vy cv con0
      wcel cC con0 wcel c1o cC wcel cC cA coe co cC vy cv coe co wcel cC cA coe
      co cC vy cv csuc coe co wcel wi cC con0 wcel vy cv con0 wcel c1o cC wcel
      cC cA coe co cC vy cv coe co wcel cC cA coe co cC vy cv csuc coe co wcel
      wi wi cC con0 wcel vy cv con0 wcel wa c1o cC wcel cC vy cv coe co cC vy
      cv csuc coe co wcel cC cA coe co cC vy cv coe co wcel cC cA coe co cC vy
      cv csuc coe co wcel wi cC con0 wcel vy cv con0 wcel wa c1o cC wcel cC vy
      cv coe co c1o comu co cC vy cv coe co cC comu co wcel cC vy cv coe co cC
      vy cv csuc coe co wcel c1o cC wcel cC con0 wcel vy cv con0 wcel wa cC
      con0 wcel cC vy cv coe co con0 wcel wa c0 cC vy cv coe co wcel wa cC vy
      cv coe co c1o comu co cC vy cv coe co cC comu co wcel cC con0 wcel vy cv
      con0 wcel wa c1o cC wcel c0 cC vy cv coe co wcel cC con0 wcel cC vy cv
      coe co con0 wcel wa cC con0 wcel vy cv con0 wcel wa c1o cC wcel c0 cC
      wcel c0 cC vy cv coe co wcel cC con0 wcel c1o cC wcel c0 cC wcel wi vy cv
      con0 wcel cC con0 wcel c0 c1o wcel c1o cC wcel c0 cC wcel 0lt1o c0 c1o cC
      ontr1 mpani adantr cC con0 wcel vy cv con0 wcel wa c0 cC wcel c0 cC vy cv
      coe co wcel cC vy cv oen0 ex syld cC con0 wcel vy cv con0 wcel wa cC con0
      wcel cC vy cv coe co con0 wcel cC con0 wcel vy cv con0 wcel pm3.26 cC vy
      cv oecl jca jctild c1o cC cC vy cv coe co omordi syli cC con0 wcel vy cv
      con0 wcel wa cC vy cv coe co c1o comu co cC vy cv coe co cC comu co wcel
      cC vy cv coe co cC vy cv coe co cC comu co wcel cC vy cv coe co cC vy cv
      csuc coe co wcel cC con0 wcel vy cv con0 wcel wa cC vy cv coe co c1o comu
      co cC vy cv coe co cC vy cv coe co cC comu co cC con0 wcel vy cv con0
      wcel wa cC vy cv coe co con0 wcel cC vy cv coe co c1o comu co cC vy cv
      coe co wceq cC vy cv oecl cC vy cv coe co om1 syl eleq1d cC con0 wcel vy
      cv con0 wcel wa cC vy cv csuc coe co cC vy cv coe co cC comu co cC vy cv
      coe co cC vy cv oesuc eleq2d bitr4d sylibd cC con0 wcel vy cv con0 wcel
      wa cC cA coe co cC vy cv coe co wcel cC vy cv coe co cC vy cv csuc coe co
      wcel cC cA coe co cC vy cv csuc coe co wcel cC con0 wcel vy cv con0 wcel
      wa cC cA coe co cC vy cv coe co wcel cC vy cv coe co cC vy cv csuc coe co
      wcel cC cA coe co cC vy cv csuc coe co wcel cC con0 wcel vy cv con0 wcel
      wa cC vy cv csuc coe co con0 wcel cC cA coe co cC vy cv coe co wcel cC vy
      cv coe co cC vy cv csuc coe co wcel wa cC cA coe co cC vy cv csuc coe co
      wcel wi cC con0 wcel vy cv csuc con0 wcel cC vy cv csuc coe co con0 wcel
      vy cv con0 wcel cC vy cv csuc oecl vy cv sucelon sylan2b cC cA coe co cC
      vy cv coe co cC vy cv csuc coe co ontr1 syl exp3a com23 syld expcom imp3a
      adantr a2d vx cv wlim cA vx cv wcel wa cC con0 wcel c1o cC wcel wa cA vy
      cv wcel cC cA coe co cC vy cv coe co wcel wi vy vx cv wral wi cC con0
      wcel c1o cC wcel wa cC cA coe co cC vx cv coe co wcel wi cA vy cv wcel cC
      con0 wcel c1o cC wcel wa cC cA coe co cC vy cv coe co wcel wi wi vy vx cv
      wral vx cv wlim cA vx cv wcel wa cC con0 wcel c1o cC wcel wa cA vy cv
      wcel cC cA coe co cC vy cv coe co wcel wi vy vx cv wral cC cA coe co cC
      vx cv coe co wcel vx cv wlim cA vx cv wcel wa cC con0 wcel c1o cC wcel wa
      cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi vy vx cv wral cC cA
      coe co cC vx cv coe co wcel wi vx cv wlim cA vx cv wcel wa cC con0 wcel
      c1o cC wcel wa wa cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi vy
      vx cv wral cC cA coe co vy vx cv cC vy cv coe co ciun wcel cC cA coe co
      cC vx cv coe co wcel vx cv wlim cA vx cv wcel wa cA vy cv wcel cC cA coe
      co cC vy cv coe co wcel wi vy vx cv wral cC cA coe co vy vx cv cC vy cv
      coe co ciun wcel wi cC con0 wcel c1o cC wcel wa vx cv wlim cA vx cv wcel
      wa cA csuc vx cv wcel cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi
      vy vx cv wral cC cA coe co vy vx cv cC vy cv coe co ciun wcel wi vx cv
      wlim cA vx cv wcel cA csuc vx cv wcel vx cv cA limsuc biimpa cA csuc vx
      cv wcel cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi vy vx cv wral
      cA csuc vx cv wcel cC cA coe co cC cA csuc coe co wcel wa cC cA coe co vy
      vx cv cC vy cv coe co ciun wcel cA csuc vx cv wcel cA vy cv wcel cC cA
      coe co cC vy cv coe co wcel wi vy vx cv wral cC cA coe co cC cA csuc coe
      co wcel cA csuc vx cv wcel cA vy cv wcel cC cA coe co cC vy cv coe co
      wcel wi vy vx cv wral cA cA csuc wcel cC cA coe co cC cA csuc coe co wcel
      cA csuc vx cv wcel cA csuc cvv wcel cA cA csuc wcel cA csuc vx cv elisset
      cA csuc cvv wcel cA cvv wcel cA cA csuc wcel cA sucexb cA cvv sucidg
      sylbir syl cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi cA cA csuc
      wcel cC cA coe co cC cA csuc coe co wcel wi vy cA csuc vx cv vy cv cA
      csuc wceq cA vy cv wcel cA cA csuc wcel cC cA coe co cC vy cv coe co wcel
      cC cA coe co cC cA csuc coe co wcel vy cv cA csuc cA eleq2 vy cv cA csuc
      wceq cC vy cv coe co cC cA csuc coe co cC cA coe co vy cv cA csuc cC coe
      opreq2 eleq2d imbi12d rcla4v mpid anc2li cA csuc vx cv wcel cC cA coe co
      cC cA csuc coe co wcel wa cC cA coe co cC vy cv coe co wcel vy vx cv wrex
      cC cA coe co vy vx cv cC vy cv coe co ciun wcel cC cA coe co cC vy cv coe
      co wcel cC cA coe co cC cA csuc coe co wcel vy cA csuc vx cv vy cv cA
      csuc wceq cC vy cv coe co cC cA csuc coe co cC cA coe co vy cv cA csuc cC
      coe opreq2 eleq2d rcla4ev vy cC cA coe co vx cv cC vy cv coe co eliun
      sylibr syl6 syl adantr vx cv wlim cA vx cv wcel wa cC con0 wcel c1o cC
      wcel wa wa cC vx cv coe co vy vx cv cC vy cv coe co ciun cC cA coe co vx
      cv wlim cC con0 wcel c1o cC wcel wa cC vx cv coe co vy vx cv cC vy cv coe
      co ciun wceq cA vx cv wcel cC con0 wcel vx cv wlim c1o cC wcel cC vx cv
      coe co vy vx cv cC vy cv coe co ciun wceq cC con0 wcel vx cv wlim c1o cC
      wcel cC vx cv coe co vy vx cv cC vy cv coe co ciun wceq cC con0 wcel vx
      cv wlim wa c1o cC wcel cC vx cv coe co vy vx cv cC vy cv coe co ciun wceq
      cC con0 wcel vx cv wlim wa c1o cC wcel c0 cC wcel cC vx cv coe co vy vx
      cv cC vy cv coe co ciun wceq cC con0 wcel c1o cC wcel c0 cC wcel wi vx cv
      wlim cC con0 wcel c0 c1o wcel c1o cC wcel c0 cC wcel 0lt1o c0 c1o cC
      ontr1 mpani adantr cC con0 wcel vx cv wlim wa c0 cC wcel cC vx cv coe co
      vy vx cv cC vy cv coe co ciun wceq cC con0 wcel vx cv cvv wcel vx cv wlim
      c0 cC wcel cC vx cv coe co vy vx cv cC vy cv coe co ciun wceq vx visset
      vy cC vx cv cvv oelim mpanlr1 ex syld imp anasss an1s adantlr eleq2d
      sylibrd ex a2d cA vy cv wcel cC con0 wcel c1o cC wcel wa cC cA coe co cC
      vy cv coe co wcel wi wi vy vx cv wral cC con0 wcel c1o cC wcel wa cA vy
      cv wcel cC cA coe co cC vy cv coe co wcel wi wi vy vx cv wral cC con0
      wcel c1o cC wcel wa cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi vy
      vx cv wral wi cA vy cv wcel cC con0 wcel c1o cC wcel wa cC cA coe co cC
      vy cv coe co wcel wi wi cC con0 wcel c1o cC wcel wa cA vy cv wcel cC cA
      coe co cC vy cv coe co wcel wi wi vy vx cv cA vy cv wcel cC con0 wcel c1o
      cC wcel wa cC cA coe co cC vy cv coe co wcel bi2.04 ralbii cC con0 wcel
      c1o cC wcel wa cA vy cv wcel cC cA coe co cC vy cv coe co wcel wi vy vx
      cv r19.21v bitri syl5ib tfindsg2 exp4b com34 com24 imp31 $.
      $( [14-Jan-2005] $) $( [5-Jan-2005] $)
  $}

  $( Ordering property of ordinal exponentiation.  Corollary 8.34 of
     [TakeutiZaring] p. 68 and its converse. $)
  oeord $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ 1o e. C ) ->
               ( A e. B <-> ( C ^o A ) e. ( C ^o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cC wcel wa cA cB wcel cC cA
    coe co cC cB coe co wcel cB con0 wcel cC con0 wcel c1o cC wcel cA cB wcel
    cC cA coe co cC cB coe co wcel wi cA con0 wcel cA cB cC oeordi 3adantl1 cA
    con0 wcel cB con0 wcel cC con0 wcel w3a c1o cC wcel wa cC cA coe co cC cB
    coe co wceq cC cB coe co cC cA coe co wcel wo wn cA cB wceq cB cA wcel wo
    wn cC cA coe co cC cB coe co wcel cA cB wcel cA con0 wcel cB con0 wcel cC
    con0 wcel w3a c1o cC wcel wa cA cB wceq cB cA wcel wo cC cA coe co cC cB
    coe co wceq cC cB coe co cC cA coe co wcel wo cA con0 wcel cB con0 wcel cC
    con0 wcel w3a c1o cC wcel wa cA cB wceq cC cA coe co cC cB coe co wceq cB
    cA wcel cC cB coe co cC cA coe co wcel cA cB wceq cC cA coe co cC cB coe co
    wceq wi cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cC wcel wa cA cB cC
    coe opreq2 a1i cA con0 wcel cC con0 wcel c1o cC wcel cB cA wcel cC cB coe
    co cC cA coe co wcel wi cB con0 wcel cB cA cC oeordi 3adantl2 orim12d con3d
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA coe co cC cB coe co wcel
    cC cA coe co cC cB coe co wceq cC cB coe co cC cA coe co wcel wo wn wb c1o
    cC wcel cA con0 wcel cB con0 wcel cC con0 wcel cC cA coe co cC cB coe co
    wcel cC cA coe co cC cB coe co wceq cC cB coe co cC cA coe co wcel wo wn wb
    cC con0 wcel cA con0 wcel cB con0 wcel wa cC cA coe co cC cB coe co wcel cC
    cA coe co cC cB coe co wceq cC cB coe co cC cA coe co wcel wo wn wb cC con0
    wcel cA con0 wcel cB con0 wcel cC cA coe co cC cB coe co wcel cC cA coe co
    cC cB coe co wceq cC cB coe co cC cA coe co wcel wo wn wb cC cA coe co con0
    wcel cC cB coe co con0 wcel cC cA coe co cC cB coe co wcel cC cA coe co cC
    cB coe co wceq cC cB coe co cC cA coe co wcel wo wn wb cC con0 wcel cA con0
    wcel wa cC con0 wcel cB con0 wcel wa cC cA coe co word cC cB coe co word cC
    cA coe co cC cB coe co wcel cC cA coe co cC cB coe co wceq cC cB coe co cC
    cA coe co wcel wo wn wb cC cA coe co con0 wcel cC cB coe co con0 wcel cC cA
    coe co cC cB coe co ordtri2 cC cA coe co eloni cC cB coe co eloni syl2an cC
    cA oecl cC cB oecl syl2an anandis ancoms 3impa adantr cA con0 wcel cB con0
    wcel cC con0 wcel w3a cA cB wcel cA cB wceq cB cA wcel wo wn wb c1o cC wcel
    cA con0 wcel cB con0 wcel cA cB wcel cA cB wceq cB cA wcel wo wn wb cC con0
    wcel cA word cB word cA cB wcel cA cB wceq cB cA wcel wo wn wb cA con0 wcel
    cB con0 wcel cA cB ordtri2 cA eloni cB eloni syl2an 3adant3 adantr 3imtr4d
    impbid $.
    $( [16-Apr-2005] $) $( [6-Jan-2005] $)

  $( Left cancellation law for ordinal exponentiation. $)
  oecan $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ 1o e. A ) ->
                   ( ( A ^o B ) = ( A ^o C ) <-> B = C ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cA wcel wa cA cB coe co cA
    cC coe co wceq cB cC wceq cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cA
    wcel wa cA cB coe co cA cC coe co wcel cA cC coe co cA cB coe co wcel wo wn
    cB cC wcel cC cB wcel wo wn cA cB coe co cA cC coe co wceq cB cC wceq cA
    con0 wcel cB con0 wcel cC con0 wcel w3a c1o cA wcel wa cB cC wcel cC cB
    wcel wo cA cB coe co cA cC coe co wcel cA cC coe co cA cB coe co wcel wo cA
    con0 wcel cB con0 wcel cC con0 wcel w3a c1o cA wcel wa cB cC wcel cA cB coe
    co cA cC coe co wcel cC cB wcel cA cC coe co cA cB coe co wcel cA con0 wcel
    cB con0 wcel cC con0 wcel w3a c1o cA wcel cB cC wcel cA cB coe co cA cC coe
    co wcel wi cA con0 wcel cC con0 wcel c1o cA wcel cB cC wcel cA cB coe co cA
    cC coe co wcel wi wi cB con0 wcel cC con0 wcel cA con0 wcel c1o cA wcel cB
    cC wcel cA cB coe co cA cC coe co wcel wi wi cC con0 wcel cA con0 wcel wa
    c1o cA wcel cB cC wcel cA cB coe co cA cC coe co wcel wi cB cC cA oeordi ex
    ancoms 3adant2 imp cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cA wcel
    cC cB wcel cA cC coe co cA cB coe co wcel wi cA con0 wcel cB con0 wcel c1o
    cA wcel cC cB wcel cA cC coe co cA cB coe co wcel wi wi cC con0 wcel cB
    con0 wcel cA con0 wcel c1o cA wcel cC cB wcel cA cC coe co cA cB coe co
    wcel wi wi cB con0 wcel cA con0 wcel wa c1o cA wcel cC cB wcel cA cC coe co
    cA cB coe co wcel wi cC cB cA oeordi ex ancoms 3adant3 imp orim12d con3d cA
    con0 wcel cB con0 wcel cC con0 wcel w3a cA cB coe co cA cC coe co wceq cA
    cB coe co cA cC coe co wcel cA cC coe co cA cB coe co wcel wo wn wb c1o cA
    wcel cA con0 wcel cB con0 wcel cC con0 wcel cA cB coe co cA cC coe co wceq
    cA cB coe co cA cC coe co wcel cA cC coe co cA cB coe co wcel wo wn wb cA
    cB coe co word cA cC coe co word cA cB coe co cA cC coe co wceq cA cB coe
    co cA cC coe co wcel cA cC coe co cA cB coe co wcel wo wn wb cA con0 wcel
    cB con0 wcel wa cA con0 wcel cC con0 wcel wa cA cB coe co cA cC coe co
    ordtri3 cA con0 wcel cB con0 wcel wa cA cB coe co con0 wcel cA cB coe co
    word cA cB oecl cA cB coe co eloni syl cA con0 wcel cC con0 wcel wa cA cC
    coe co con0 wcel cA cC coe co word cA cC oecl cA cC coe co eloni syl syl2an
    3impdi adantr cA con0 wcel cB con0 wcel cC con0 wcel w3a cB cC wceq cB cC
    wcel cC cB wcel wo wn wb c1o cA wcel cB con0 wcel cC con0 wcel cB cC wceq
    cB cC wcel cC cB wcel wo wn wb cA con0 wcel cB word cC word cB cC wceq cB
    cC wcel cC cB wcel wo wn wb cB con0 wcel cC con0 wcel cB cC ordtri3 cB
    eloni cC eloni syl2an 3adant1 adantr 3imtr4d cB cC cA coe opreq2 impbid1 $.
    $( [15-Jan-2005] $) $( [6-Jan-2005] $)

  $( Weak ordering property of ordinal exponentiation. $)
  oeword $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ 1o e. C ) ->
                   ( A C_ B <-> ( C ^o A ) C_ ( C ^o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cC wcel wa cA cB wcel cA cB
    wceq wo cC cA coe co cC cB coe co wcel cC cA coe co cC cB coe co wceq wo cA
    cB wss cC cA coe co cC cB coe co wss cA con0 wcel cB con0 wcel cC con0 wcel
    w3a c1o cC wcel wa cA cB wcel cC cA coe co cC cB coe co wcel cA cB wceq cC
    cA coe co cC cB coe co wceq cA cB cC oeord cA con0 wcel cB con0 wcel cC
    con0 wcel w3a c1o cC wcel wa cC cA coe co cC cB coe co wceq cA cB wceq cC
    con0 wcel cA con0 wcel cB con0 wcel w3a c1o cC wcel cC cA coe co cC cB coe
    co wceq cA cB wceq wb cA con0 wcel cB con0 wcel cC con0 wcel w3a cC cA cB
    oecan cC con0 wcel cA con0 wcel cB con0 wcel 3anrot sylanbr bicomd orbi12d
    cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wss cA cB wcel cA cB wceq
    wo wb c1o cC wcel cA con0 wcel cB con0 wcel cA cB wss cA cB wcel cA cB wceq
    wo wb cC con0 wcel cA cB onsseleq 3adant3 adantr cA con0 wcel cB con0 wcel
    cC con0 wcel w3a cC cA coe co cC cB coe co wss cC cA coe co cC cB coe co
    wcel cC cA coe co cC cB coe co wceq wo wb c1o cC wcel cA con0 wcel cB con0
    wcel cC con0 wcel w3a cC cA coe co con0 wcel cC cB coe co con0 wcel wa cC
    cA coe co cC cB coe co wss cC cA coe co cC cB coe co wcel cC cA coe co cC
    cB coe co wceq wo wb cA con0 wcel cB con0 wcel cC con0 wcel cC cA coe co
    con0 wcel cC cB coe co con0 wcel wa cC con0 wcel cA con0 wcel cB con0 wcel
    wa cC cA coe co con0 wcel cC cB coe co con0 wcel wa cC con0 wcel cA con0
    wcel cB con0 wcel cC cA coe co con0 wcel cC cB coe co con0 wcel wa cC con0
    wcel cA con0 wcel wa cC cA coe co con0 wcel cC con0 wcel cB con0 wcel wa cC
    cB coe co con0 wcel cC cA oecl cC cB oecl anim12i anandis ancoms 3impa cC
    cA coe co cC cB coe co onsseleq syl adantr 3bitr4d $.
    $( [14-May-2005] $) $( [6-Jan-2005] $)

  $( Weak ordering property of ordinal exponentiation. $)
  oewordi $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. C ) ->
                   ( A C_ B -> ( C ^o A ) C_ ( C ^o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC wcel cA cB wss cC cA coe
    co cC cB coe co wss wi cA con0 wcel cB con0 wcel cC con0 wcel w3a c0 cC
    wcel c1o cC wcel c1o cC wceq wo cA cB wss cC cA coe co cC cB coe co wss wi
    cC con0 wcel cA con0 wcel c0 cC wcel c1o cC wcel c1o cC wceq wo wb cB con0
    wcel cC con0 wcel c0 cC wcel c1o cC wss c1o cC wcel c1o cC wceq wo cC con0
    wcel cC word c0 cC wcel c1o cC wss wb cC eloni cC ordgt0ge1 syl c1o con0
    wcel cC con0 wcel c1o cC wss c1o cC wcel c1o cC wceq wo wb 1on c1o cC
    onsseleq mpan bitrd 3ad2ant3 cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o
    cC wcel cA cB wss cC cA coe co cC cB coe co wss wi c1o cC wceq cA con0 wcel
    cB con0 wcel cC con0 wcel w3a c1o cC wcel cA cB wss cC cA coe co cC cB coe
    co wss wi cA con0 wcel cB con0 wcel cC con0 wcel w3a c1o cC wcel wa cA cB
    wss cC cA coe co cC cB coe co wss cA cB cC oeword biimpd ex cA con0 wcel cB
    con0 wcel cC con0 wcel w3a c1o cC wceq cC cA coe co cC cB coe co wss cA cB
    wss cA con0 wcel cB con0 wcel c1o cC wceq cC cA coe co cC cB coe co wss wi
    cC con0 wcel c1o cC wceq c1o cA coe co c1o cB coe co wss cC cA coe co cC cB
    coe co wss cA con0 wcel cB con0 wcel wa c1o cC wceq c1o cA coe co cC cA coe
    co c1o cB coe co cC cB coe co c1o cC cA coe opreq1 c1o cC cB coe opreq1
    sseq12d cA con0 wcel cB con0 wcel wa c1o cA coe co c1o cB coe co wceq c1o
    cA coe co c1o cB coe co wss cA con0 wcel cB con0 wcel wa c1o cA coe co c1o
    c1o cB coe co cA con0 wcel c1o cA coe co c1o wceq cB con0 wcel cA oe1m
    adantr cB con0 wcel c1o cB coe co c1o wceq cA con0 wcel cB oe1m adantl
    eqtr4d c1o cA coe co c1o cB coe co eqimss syl syl5cbi 3adant3 a1dd jaod
    sylbid imp $.
    $( [20-May-2005] $) $( [6-Jan-2005] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Weak ordering property of ordinal exponentiation.  Proposition 8.35 of
       [TakeutiZaring] p. 68. $)
    oewordri $p |- ( ( B e. On /\ C e. On ) ->
        ( A e. B -> ( A ^o C ) C_ ( B ^o C ) ) ) $=
      cC con0 wcel cB con0 wcel cA cB wcel cA cC coe co cB cC coe co wss wi cC
      con0 wcel cB con0 wcel cA cB wcel cA cC coe co cB cC coe co wss cA vx cv
      coe co cB vx cv coe co wss cA c0 coe co cB c0 coe co wss cA vy cv coe co
      cB vy cv coe co wss cA vy cv csuc coe co cB vy cv csuc coe co wss cA cC
      coe co cB cC coe co wss vx vy cC cB con0 wcel cA cB wcel wa vx cv c0 wceq
      cA vx cv coe co cA c0 coe co cB vx cv coe co cB c0 coe co vx cv c0 cA coe
      opreq2 vx cv c0 cB coe opreq2 sseq12d vx cv vy cv wceq cA vx cv coe co cA
      vy cv coe co cB vx cv coe co cB vy cv coe co vx cv vy cv cA coe opreq2 vx
      cv vy cv cB coe opreq2 sseq12d vx cv vy cv csuc wceq cA vx cv coe co cA
      vy cv csuc coe co cB vx cv coe co cB vy cv csuc coe co vx cv vy cv csuc
      cA coe opreq2 vx cv vy cv csuc cB coe opreq2 sseq12d vx cv cC wceq cA vx
      cv coe co cA cC coe co cB vx cv coe co cB cC coe co vx cv cC cA coe
      opreq2 vx cv cC cB coe opreq2 sseq12d cB con0 wcel cA cB wcel wa cA c0
      coe co cB c0 coe co wceq cA c0 coe co cB c0 coe co wss cB con0 wcel cA cB
      wcel wa cA c0 coe co c1o cB c0 coe co cB con0 wcel cA cB wcel wa cA con0
      wcel cA c0 coe co c1o wceq cB cA onelon cA oe0 syl cB con0 wcel cB c0 coe
      co c1o wceq cA cB wcel cB oe0 adantr eqtr4d cA c0 coe co cB c0 coe co
      eqimss syl vy cv con0 wcel cA con0 wcel cB con0 wcel wa cA cB wss wa cA
      vy cv coe co cB vy cv coe co wss cA vy cv csuc coe co cB vy cv csuc coe
      co wss wi cB con0 wcel cA cB wcel wa vy cv con0 wcel cA con0 wcel cB con0
      wcel cA cB wss cA vy cv coe co cB vy cv coe co wss cA vy cv csuc coe co
      cB vy cv csuc coe co wss wi cA con0 wcel cB con0 wcel vy cv con0 wcel cA
      cB wss cA vy cv coe co cB vy cv coe co wss cA vy cv csuc coe co cB vy cv
      csuc coe co wss wi wi cA con0 wcel cB con0 wcel vy cv con0 wcel cA cB wss
      cA vy cv coe co cB vy cv coe co wss cA vy cv csuc coe co cB vy cv csuc
      coe co wss wi wi cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss
      cA vy cv coe co cB vy cv coe co wss cA vy cv csuc coe co cB vy cv csuc
      coe co wss cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss cA vy
      cv coe co cB vy cv coe co wss wa wa cA vy cv coe co cA comu co cB vy cv
      coe co cB comu co cA vy cv csuc coe co cB vy cv csuc coe co cA con0 wcel
      cB con0 wcel vy cv con0 wcel w3a cA cB wss cA vy cv coe co cB vy cv coe
      co wss wa wa cA vy cv coe co cA comu co cB vy cv coe co cA comu co cB vy
      cv coe co cB comu co cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA vy
      cv coe co cB vy cv coe co wss cA vy cv coe co cA comu co cB vy cv coe co
      cA comu co wss cA cB wss cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA
      vy cv coe co cB vy cv coe co wss cA vy cv coe co cA comu co cB vy cv coe
      co cA comu co wss cA vy cv coe co con0 wcel cB vy cv coe co con0 wcel cA
      con0 wcel cA vy cv coe co cB vy cv coe co wss cA vy cv coe co cA comu co
      cB vy cv coe co cA comu co wss wi cA con0 wcel cB con0 wcel vy cv con0
      wcel w3a cA vy cv coe co cB vy cv coe co cA omwordri cA con0 wcel vy cv
      con0 wcel cA vy cv coe co con0 wcel cB con0 wcel cA vy cv oecl 3adant2 cB
      con0 wcel vy cv con0 wcel cB vy cv coe co con0 wcel cA con0 wcel cB vy cv
      oecl 3adant1 cA con0 wcel cB con0 wcel vy cv con0 wcel 3simp1 syl3anc imp
      adantrl cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss cB vy cv
      coe co cA comu co cB vy cv coe co cB comu co wss cA vy cv coe co cB vy cv
      coe co wss cA con0 wcel cB con0 wcel vy cv con0 wcel w3a cA cB wss cB vy
      cv coe co cA comu co cB vy cv coe co cB comu co wss cA con0 wcel cB con0
      wcel cB vy cv coe co con0 wcel cA cB wss cB vy cv coe co cA comu co cB vy
      cv coe co cB comu co wss wi vy cv con0 wcel cA cB cB vy cv coe co omwordi
      cB con0 wcel vy cv con0 wcel cB vy cv coe co con0 wcel cA con0 wcel cB vy
      cv oecl 3adant1 syld3an3 imp adantrr sstrd cA con0 wcel cB con0 wcel vy
      cv con0 wcel w3a cA vy cv csuc coe co cA vy cv coe co cA comu co wceq cA
      cB wss cA vy cv coe co cB vy cv coe co wss wa cA con0 wcel vy cv con0
      wcel cA vy cv csuc coe co cA vy cv coe co cA comu co wceq cB con0 wcel cA
      vy cv oesuc 3adant2 adantr cA con0 wcel cB con0 wcel vy cv con0 wcel w3a
      cB vy cv csuc coe co cB vy cv coe co cB comu co wceq cA cB wss cA vy cv
      coe co cB vy cv coe co wss wa cB con0 wcel vy cv con0 wcel cB vy cv csuc
      coe co cB vy cv coe co cB comu co wceq cA con0 wcel cB vy cv oesuc
      3adant1 adantr 3sstr4d exp32 3exp com3r imp4c cB con0 wcel cA cB wcel wa
      cA con0 wcel cB con0 wcel cA cB wss cB cA onelon cB con0 wcel cA cB wcel
      pm3.26 cB con0 wcel cA cB wcel cA cB wss cB cA onelss imp jca31 syl5 vx
      cv wlim cA con0 wcel cB con0 wcel cA cB wcel wa wa cA vy cv coe co cB vy
      cv coe co wss vy vx cv wral cA vx cv coe co cB vx cv coe co wss wi cB
      con0 wcel cA cB wcel wa cA con0 wcel cB con0 wcel cA cB wcel wa wa vx cv
      wlim cA vy cv coe co cB vy cv coe co wss vy vx cv wral cA vx cv coe co cB
      vx cv coe co wss wi cB con0 wcel cA cB wcel wa vx cv wlim cA vy cv coe co
      cB vy cv coe co wss vy vx cv wral cA vx cv coe co cB vx cv coe co wss wi
      wi cA cB con0 wcel cA cB wcel wa cA c0 wceq wa vx cv wlim cA vx cv coe co
      cB vx cv coe co wss cA vy cv coe co cB vy cv coe co wss vy vx cv wral cA
      c0 wceq vx cv wlim cA vx cv coe co cB vx cv coe co wss wi cB con0 wcel cA
      cB wcel wa cA c0 wceq cA vx cv coe co cB vx cv coe co wss c0 vx cv coe co
      cB vx cv coe co wss vx cv wlim cA c0 wceq cA vx cv coe co c0 vx cv coe co
      cB vx cv coe co cA c0 vx cv coe opreq1 sseq1d vx cv wlim c0 vx cv coe co
      c0 cB vx cv coe co vx cv con0 wcel c0 vx cv wcel c0 vx cv coe co c0 wceq
      vx cv wlim vx cv con0 wcel c0 vx cv wcel c0 vx cv coe co c0 wceq vx cv
      oe0m1 biimpa vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv
      cvv limelon mpan vx cv 0ellim sylanc c0 cB vx cv coe co wss vx cv wlim cB
      vx cv coe co 0ss a1i eqsstrd syl5bir adantl a1dd cA con0 wcel cB con0
      wcel cA cB wcel wa wa c0 cA wcel wa vx cv wlim cA vy cv coe co cB vy cv
      coe co wss vy vx cv wral cA vx cv coe co cB vx cv coe co wss wi cA con0
      wcel cB con0 wcel cA cB wcel wa wa c0 cA wcel wa vx cv wlim wa cA vx cv
      coe co cB vx cv coe co wss vy vx cv cA vy cv coe co ciun vy vx cv cB vy
      cv coe co ciun wss cA vy cv coe co cB vy cv coe co wss vy vx cv wral cA
      con0 wcel cB con0 wcel cA cB wcel wa wa c0 cA wcel wa vx cv wlim wa cA vx
      cv coe co vy vx cv cA vy cv coe co ciun cB vx cv coe co vy vx cv cB vy cv
      coe co ciun cA con0 wcel c0 cA wcel vx cv wlim cA vx cv coe co vy vx cv
      cA vy cv coe co ciun wceq cB con0 wcel cA cB wcel wa cA con0 wcel vx cv
      wlim c0 cA wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq cA
      con0 wcel vx cv cvv wcel vx cv wlim c0 cA wcel cA vx cv coe co vy vx cv
      cA vy cv coe co ciun wceq vx visset vy cA vx cv cvv oelim mpanlr1 an1rs
      adantllr cB con0 wcel cA cB wcel wa c0 cA wcel vx cv wlim cB vx cv coe co
      vy vx cv cB vy cv coe co ciun wceq cA con0 wcel cB con0 wcel cA cB wcel
      wa vx cv wlim cB vx cv coe co vy vx cv cB vy cv coe co ciun wceq c0 cA
      wcel cB con0 wcel vx cv wlim wa c0 cB wcel cB vx cv coe co vy vx cv cB vy
      cv coe co ciun wceq cB con0 wcel cA cB wcel wa vx cv wlim wa cB con0 wcel
      vx cv cvv wcel vx cv wlim c0 cB wcel cB vx cv coe co vy vx cv cB vy cv
      coe co ciun wceq vx visset vy cB vx cv cvv oelim mpanlr1 cB con0 wcel cA
      cB wcel wa cB con0 wcel vx cv wlim cB con0 wcel cA cB wcel pm3.26 anim1i
      cB con0 wcel cA cB wcel wa c0 cB wcel vx cv wlim cB con0 wcel cA cB wcel
      c0 cB wcel cB con0 wcel c0 cB wcel cB c0 wne cA cB wcel cB on0eln0 cB cA
      ne0i syl5bir imp adantr sylanc adantlr adantlll sseq12d vy vx cv cA vy cv
      coe co cB vy cv coe co ss2iun syl5bir ex oe0lem com12 cB con0 wcel cA cB
      wcel wa cA con0 wcel cB cA onelon ancri syl5 tfinds3 exp3a impcom $.
      $( [22-Jul-2006] $) $( [6-Jan-2005] $)

    $( Ordinal exponentiation compared to its exponent.  Proposition 8.37 of
       [TakeutiZaring] p. 68. $)
    oeworde $p |- ( ( ( A e. On /\ B e. On ) /\ 1o e. A ) ->
                  B C_ ( A ^o B ) ) $=
      cA con0 wcel cB con0 wcel c1o cA wcel cB cA cB coe co wss cB con0 wcel cA
      con0 wcel c1o cA wcel cB cA cB coe co wss wi cB con0 wcel cA con0 wcel
      c1o cA wcel cB cA cB coe co wss vx cv cA vx cv coe co wss c0 cA c0 coe co
      wss vy cv cA vy cv coe co wss vy cv csuc cA vy cv csuc coe co wss cB cA
      cB coe co wss vx vy cB cA con0 wcel c1o cA wcel wa vx cv c0 wceq vx cv c0
      cA vx cv coe co cA c0 coe co vx cv c0 wceq id vx cv c0 cA coe opreq2
      sseq12d vx cv vy cv wceq vx cv vy cv cA vx cv coe co cA vy cv coe co vx
      cv vy cv wceq id vx cv vy cv cA coe opreq2 sseq12d vx cv vy cv csuc wceq
      vx cv vy cv csuc cA vx cv coe co cA vy cv csuc coe co vx cv vy cv csuc
      wceq id vx cv vy cv csuc cA coe opreq2 sseq12d vx cv cB wceq vx cv cB cA
      vx cv coe co cA cB coe co vx cv cB wceq id vx cv cB cA coe opreq2 sseq12d
      c0 cA c0 coe co wss cA con0 wcel c1o cA wcel wa cA c0 coe co 0ss a1i vy
      cv con0 wcel cA con0 wcel c1o cA wcel wa vy cv cA vy cv coe co wss vy cv
      csuc cA vy cv csuc coe co wss wi vy cv con0 wcel cA con0 wcel c1o cA wcel
      wa wa vy cv cA vy cv coe co wss vy cv csuc cA vy cv coe co csuc wss vy cv
      csuc cA vy cv csuc coe co wss vy cv con0 wcel cA con0 wcel vy cv cA vy cv
      coe co wss vy cv csuc cA vy cv coe co csuc wss wb c1o cA wcel vy cv word
      cA vy cv coe co word vy cv cA vy cv coe co wss vy cv csuc cA vy cv coe co
      csuc wss wb vy cv con0 wcel cA con0 wcel wa vy cv cA vy cv coe co
      ordsucsssuc vy cv con0 wcel vy cv word cA con0 wcel vy cv eloni adantr vy
      cv con0 wcel cA con0 wcel wa cA vy cv coe co con0 wcel cA vy cv coe co
      word cA con0 wcel vy cv con0 wcel cA vy cv coe co con0 wcel cA vy cv oecl
      ancoms cA vy cv coe co eloni syl sylanc adantrr vy cv csuc cA vy cv coe
      co csuc wss cA vy cv coe co csuc cA vy cv csuc coe co wss vy cv csuc cA
      vy cv csuc coe co wss vy cv con0 wcel cA con0 wcel c1o cA wcel wa wa vy
      cv csuc cA vy cv coe co csuc cA vy cv csuc coe co sstr2 vy cv csuc con0
      wcel cA con0 wcel c1o cA wcel wa cA vy cv coe co csuc cA vy cv csuc coe
      co wss vy cv con0 wcel vy cv csuc con0 wcel cA con0 wcel c1o cA wcel wa
      wa cA vy cv coe co cA vy cv csuc coe co wcel cA vy cv coe co csuc cA vy
      cv csuc coe co wss vy cv csuc con0 wcel cA con0 wcel c1o cA wcel cA vy cv
      coe co cA vy cv csuc coe co wcel vy cv csuc con0 wcel cA con0 wcel wa c1o
      cA wcel wa vy cv vy cv csuc wcel cA vy cv coe co cA vy cv csuc coe co
      wcel vy cv vy visset sucid vy cv vy cv csuc cA oeordi mpi anasss vy cv
      csuc con0 wcel cA con0 wcel cA vy cv coe co cA vy cv csuc coe co wcel cA
      vy cv coe co csuc cA vy cv csuc coe co wss wi c1o cA wcel vy cv csuc con0
      wcel cA con0 wcel wa cA vy cv csuc coe co word cA vy cv coe co cA vy cv
      csuc coe co wcel cA vy cv coe co csuc cA vy cv csuc coe co wss wi cA con0
      wcel vy cv csuc con0 wcel cA vy cv csuc coe co word cA con0 wcel vy cv
      csuc con0 wcel wa cA vy cv csuc coe co con0 wcel cA vy cv csuc coe co
      word cA vy cv csuc oecl cA vy cv csuc coe co eloni syl ancoms cA vy cv
      coe co cA vy cv csuc coe co ordsucss syl adantrr mpd vy cv sucelon sylanb
      syl5com sylbid ex vx cv wlim cA con0 wcel c0 cA wcel wa vy cv cA vy cv
      coe co wss vy vx cv wral vx cv cA vx cv coe co wss wi cA con0 wcel c1o cA
      wcel wa vx cv wlim cA con0 wcel c0 cA wcel wa vy cv cA vy cv coe co wss
      vy vx cv wral vx cv cA vx cv coe co wss wi vx cv wlim cA con0 wcel c0 cA
      wcel wa wa vx cv cA vx cv coe co wss vy vx cv vy cv ciun vy vx cv cA vy
      cv coe co ciun wss vy cv cA vy cv coe co wss vy vx cv wral vx cv wlim cA
      con0 wcel c0 cA wcel wa wa vx cv vy vx cv vy cv ciun cA vx cv coe co vy
      vx cv cA vy cv coe co ciun vx cv wlim vx cv vy vx cv vy cv ciun wceq cA
      con0 wcel c0 cA wcel wa vx cv wlim vx cv vx cv cuni vy vx cv vy cv ciun
      vx cv limuni vy vx cv uniiun syl6eq adantr cA con0 wcel vx cv wlim c0 cA
      wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq cA con0 wcel vx
      cv wlim c0 cA wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq cA
      con0 wcel vx cv cvv wcel vx cv wlim c0 cA wcel cA vx cv coe co vy vx cv
      cA vy cv coe co ciun wceq vx visset vy cA vx cv cvv oelim mpanlr1 anasss
      an1s sseq12d vy vx cv vy cv cA vy cv coe co ss2iun syl5bir ex cA con0
      wcel c1o cA wcel c0 cA wcel cA con0 wcel c0 cA wcel cA c0 wne c1o cA wcel
      cA on0eln0 cA c1o ne0i syl5bir imdistani syl5 tfinds3 exp3a com12 imp31
      $.
      $( [18-Jan-2005] $) $( [7-Jan-2005] $)
  $}

  $( Ordering property of ordinal exponentiation with a successor exponent.
     Corollary 8.36 of [TakeutiZaring] p. 68. $)
  oeordsuc $p |- ( ( B e. On /\ C e. On ) ->
      ( A e. B -> ( A ^o suc C ) e. ( B ^o suc C ) ) ) $=
    cB con0 wcel cC con0 wcel wa cA cB wcel cA con0 wcel cA cC csuc coe co cB
    cC csuc coe co wcel cB con0 wcel cA cB wcel cA con0 wcel wi cC con0 wcel cB
    con0 wcel cA cB wcel cA con0 wcel cB cA onelon ex adantr cB con0 wcel cC
    con0 wcel cA cB wcel cA con0 wcel cA cC csuc coe co cB cC csuc coe co wcel
    wi wi cA con0 wcel cB con0 wcel cC con0 wcel cA cB wcel cA cC csuc coe co
    cB cC csuc coe co wcel cA con0 wcel cB con0 wcel cC con0 wcel cA cB wcel cA
    cC csuc coe co cB cC csuc coe co wcel wi cA con0 wcel cB con0 wcel wa cC
    con0 wcel wa cA cB wcel cA cC csuc coe co cB cC coe co cA comu co wss cB cC
    coe co cA comu co cB cC csuc coe co wcel wa cA cC csuc coe co cB cC csuc
    coe co wcel cA con0 wcel cB con0 wcel cC con0 wcel cA cB wcel cA cC csuc
    coe co cB cC coe co cA comu co wss cB cC coe co cA comu co cB cC csuc coe
    co wcel wa wi cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wcel cA cC
    csuc coe co cB cC coe co cA comu co wss cB cC coe co cA comu co cB cC csuc
    coe co wcel cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wcel cA cC coe
    co cA comu co cB cC coe co cA comu co wss cA cC csuc coe co cB cC coe co cA
    comu co wss cA con0 wcel cB con0 wcel cC con0 wcel w3a cA cB wcel cA cC coe
    co cB cC coe co wss cA cC coe co cA comu co cB cC coe co cA comu co wss cB
    con0 wcel cC con0 wcel cA cB wcel cA cC coe co cB cC coe co wss wi cA con0
    wcel cA cB cC oewordri 3adant1 cA cC coe co con0 wcel cB cC coe co con0
    wcel cA con0 wcel cA cC coe co cB cC coe co wss cA cC coe co cA comu co cB
    cC coe co cA comu co wss wi cA con0 wcel cB con0 wcel cC con0 wcel w3a cA
    cC coe co cB cC coe co cA omwordri cA con0 wcel cC con0 wcel cA cC coe co
    con0 wcel cB con0 wcel cA cC oecl 3adant2 cB con0 wcel cC con0 wcel cB cC
    coe co con0 wcel cA con0 wcel cB cC oecl 3adant1 cA con0 wcel cB con0 wcel
    cC con0 wcel 3simp1 syl3anc syld cA con0 wcel cB con0 wcel cC con0 wcel w3a
    cA cC csuc coe co cA cC coe co cA comu co cB cC coe co cA comu co cA con0
    wcel cC con0 wcel cA cC csuc coe co cA cC coe co cA comu co wceq cB con0
    wcel cA cC oesuc 3adant2 sseq1d sylibrd cA con0 wcel cB con0 wcel cC con0
    wcel w3a cA cB wcel cB cC coe co cA comu co cB cC coe co cB comu co wcel cB
    cC coe co cA comu co cB cC csuc coe co wcel cB con0 wcel cC con0 wcel cA cB
    wcel cB cC coe co cA comu co cB cC coe co cB comu co wcel wi cA con0 wcel
    cB con0 wcel cC con0 wcel wa cA cB wcel c0 cB cC coe co wcel cB cC coe co
    cA comu co cB cC coe co cB comu co wcel cB con0 wcel cC con0 wcel wa cA cB
    wcel c0 cB wcel c0 cB cC coe co wcel cB con0 wcel cA cB wcel c0 cB wcel wi
    cC con0 wcel cB con0 wcel c0 cB wcel cB c0 wne cA cB wcel cB on0eln0 cB cA
    ne0i syl5bir adantr cB con0 wcel cC con0 wcel wa c0 cB wcel c0 cB cC coe co
    wcel cB cC oen0 ex syld cB con0 wcel cC con0 wcel wa c0 cB cC coe co wcel
    cA cB wcel cB cC coe co cA comu co cB cC coe co cB comu co wcel cB con0
    wcel cC con0 wcel wa c0 cB cC coe co wcel cA cB wcel cB cC coe co cA comu
    co cB cC coe co cB comu co wcel wi cB con0 wcel cB cC coe co con0 wcel wa
    c0 cB cC coe co wcel cA cB wcel cB cC coe co cA comu co cB cC coe co cB
    comu co wcel wi cB con0 wcel cC con0 wcel wa cA cB cB cC coe co omordi cB
    con0 wcel cC con0 wcel wa cB con0 wcel cB cC coe co con0 wcel cB con0 wcel
    cC con0 wcel pm3.26 cB cC oecl jca sylan ex com23 mpdd 3adant1 cA con0 wcel
    cB con0 wcel cC con0 wcel w3a cB cC csuc coe co cB cC coe co cB comu co cB
    cC coe co cA comu co cB con0 wcel cC con0 wcel cB cC csuc coe co cB cC coe
    co cB comu co wceq cA con0 wcel cB cC oesuc 3adant1 eleq2d sylibrd jcad
    3expa cA con0 wcel cB con0 wcel wa cC csuc con0 wcel cA cC csuc coe co cB
    cC coe co cA comu co wss cB cC coe co cA comu co cB cC csuc coe co wcel wa
    cA cC csuc coe co cB cC csuc coe co wcel wi cC con0 wcel cA con0 wcel cB
    con0 wcel cC csuc con0 wcel cA cC csuc coe co cB cC coe co cA comu co wss
    cB cC coe co cA comu co cB cC csuc coe co wcel wa cA cC csuc coe co cB cC
    csuc coe co wcel wi cA cC csuc coe co con0 wcel cB cC csuc coe co con0 wcel
    cA cC csuc coe co cB cC coe co cA comu co wss cB cC coe co cA comu co cB cC
    csuc coe co wcel wa cA cC csuc coe co cB cC csuc coe co wcel wi cA con0
    wcel cC csuc con0 wcel wa cB con0 wcel cC csuc con0 wcel wa cA cC csuc coe
    co cB cC coe co cA comu co cB cC csuc coe co ontr2 cA cC csuc oecl cB cC
    csuc oecl syl2an anandirs cC sucelon sylan2b syld exp31 com4l imp mpdd $.
    $( [8-Jun-2005] $) $( [7-Jan-2005] $)

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Ordinal exponentiation with a limit exponent.  Part of Exercise 4.36 of
       [Mendelson] p. 250. $)
    oelim2 $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) ->
                ( A ^o B ) = U_ x e. ( B \ 1o ) ( A ^o x ) ) $=
      cB cC wcel cB wlim wa cA cB coe co vx cB c1o cdif cA vx cv coe co ciun
      wceq cA cA c0 wceq cB cC wcel cB wlim wa cA cB coe co vx cB c1o cdif cA
      vx cv coe co ciun wceq cA c0 wceq cA cB coe co vx cB c1o cdif cA vx cv
      coe co ciun wceq c0 cB coe co vx cB c1o cdif c0 vx cv coe co ciun wceq cB
      cC wcel cB wlim wa cA c0 wceq cA cB coe co c0 cB coe co vx cB c1o cdif cA
      vx cv coe co ciun vx cB c1o cdif c0 vx cv coe co ciun cA c0 cB coe opreq1
      cA c0 wceq vx cB c1o cdif cA vx cv coe co c0 vx cv coe co cA c0 wceq cA
      vx cv coe co c0 vx cv coe co wceq vx cv cB c1o cdif wcel cA c0 vx cv coe
      opreq1 adantr iuneq2dv eqeq12d cB cC wcel cB wlim wa c0 cB coe co c0 vx
      cB c1o cdif c0 vx cv coe co ciun cB con0 wcel c0 cB wcel c0 cB coe co c0
      wceq cB cC wcel cB wlim wa cB con0 wcel c0 cB wcel c0 cB coe co c0 wceq
      cB oe0m1 biimpa cB cC limelon cB wlim c0 cB wcel cB cC wcel cB 0ellim
      adantl sylanc cB wlim vx cB c1o cdif c0 vx cv coe co ciun c0 wceq cB cC
      wcel cB wlim vx cB c1o cdif c0 vx cv coe co ciun vx cB c1o cdif c0 ciun
      c0 cB wlim vx cB c1o cdif c0 vx cv coe co c0 cB wlim vx cv cB wcel vx cv
      c1o wcel wn wa c0 vx cv coe co c0 wceq vx cv cB c1o cdif wcel cB wlim vx
      cv cB wcel vx cv c1o wcel wn c0 vx cv coe co c0 wceq cB wlim vx cv cB
      wcel vx cv c1o wcel wn c0 vx cv coe co c0 wceq wi cB wlim vx cv cB wcel
      wa vx cv con0 wcel vx cv c1o wcel wn c0 vx cv coe co c0 wceq wi cB word
      vx cv cB wcel vx cv con0 wcel cB wlim cB vx cv ordelon cB limord sylan vx
      cv con0 wcel vx cv c1o wcel wn c0 vx cv wcel c0 vx cv coe co c0 wceq vx
      cv con0 wcel c0 vx cv wcel vx cv c0 wne vx cv c1o wcel wn vx cv on0eln0
      vx cv c1o wcel vx cv c0 vx cv el1o necon3bbii syl6bbr vx cv con0 wcel c0
      vx cv wcel c0 vx cv coe co c0 wceq vx cv oe0m1 biimpd sylbird syl ex
      imp32 vx cv cB c1o eldif sylan2b iuneq2dv cB wlim c1o cB c1o cdif wcel cB
      c1o cdif c0 wne vx cB c1o cdif c0 ciun c0 wceq cB wlim c1o cB wcel c1o
      c1o wcel wn wa c1o cB c1o cdif wcel cB wlim c1o cB wcel c1o c1o wcel wn
      cB wlim c0 csuc cB c1o cB wlim c0 cB wcel c0 csuc cB wcel cB 0ellim cB c0
      limsuc mpbid df-1o syl5eqel c1o 1on onirri jctir c1o cB c1o eldif sylibr
      cB c1o cdif c1o ne0i vx cB c1o cdif c0 iunconst 3syl eqtrd adantl eqtr4d
      syl5bir impcom cA con0 wcel cB cC wcel cB wlim wa wa c0 cA wcel wa cA cB
      coe co vy cB cA vy cv coe co ciun vx cB c1o cdif cA vx cv coe co ciun vy
      cA cB cC oelim cA con0 wcel cB wlim c0 cA wcel vy cB cA vy cv coe co ciun
      vx cB c1o cdif cA vx cv coe co ciun wceq cB cC wcel cA con0 wcel cB wlim
      wa c0 cA wcel wa vy cB cA vy cv coe co ciun vx cB c1o cdif cA vx cv coe
      co ciun cA con0 wcel cB wlim wa c0 cA wcel wa cA vy cv coe co cA vx cv
      coe co wss vx cB c1o cdif wrex vy cB wral vy cB cA vy cv coe co ciun vx
      cB c1o cdif cA vx cv coe co ciun wss cA con0 wcel cB wlim wa c0 cA wcel
      wa cA vy cv coe co cA vx cv coe co wss vx cB c1o cdif wrex vy cB cA con0
      wcel cB wlim wa c0 cA wcel wa vy cv cB wcel vy cv csuc cB c1o cdif wcel
      cA vy cv coe co cA vy cv csuc coe co wss wa cA vy cv coe co cA vx cv coe
      co wss vx cB c1o cdif wrex cA con0 wcel cB wlim wa c0 cA wcel wa vy cv cB
      wcel vy cv csuc cB c1o cdif wcel cA vy cv coe co cA vy cv csuc coe co wss
      cB wlim vy cv cB wcel vy cv csuc cB c1o cdif wcel wi cA con0 wcel c0 cA
      wcel cB wlim vy cv cB wcel vy cv csuc cB c1o cdif wcel cB wlim vy cv cB
      wcel wa vy cv csuc cB wcel vy cv csuc c1o wcel wn wa vy cv csuc cB c1o
      cdif wcel cB wlim vy cv cB wcel wa vy cv csuc cB wcel vy cv csuc c1o wcel
      wn cB wlim vy cv cB wcel vy cv csuc cB wcel cB vy cv limsuc biimpa vy cv
      csuc c1o wcel vy cv csuc c0 vy cv nsuceq0 vy cv csuc el1o nemtbir jctir
      vy cv csuc cB c1o eldif sylibr ex ad2antlr cA con0 wcel cB wlim wa c0 cA
      wcel wa vy cv cB wcel cA vy cv coe co cA vy cv csuc coe co wss cA con0
      wcel cB wlim wa c0 cA wcel wa vy cv cB wcel wa vy cv vy cv csuc wss cA vy
      cv coe co cA vy cv csuc coe co wss vy cv sssucid cA con0 wcel cB wlim wa
      vy cv cB wcel c0 cA wcel vy cv vy cv csuc wss cA vy cv coe co cA vy cv
      csuc coe co wss wi vy cv con0 wcel vy cv csuc con0 wcel cA con0 wcel w3a
      c0 cA wcel vy cv vy cv csuc wss cA vy cv coe co cA vy cv csuc coe co wss
      wi cA con0 wcel cB wlim wa vy cv cB wcel wa vy cv vy cv csuc cA oewordi
      cA con0 wcel cB wlim vy cv cB wcel vy cv con0 wcel vy cv csuc con0 wcel
      cA con0 wcel w3a cA con0 wcel vy cv con0 wcel vy cv csuc con0 wcel wa vy
      cv con0 wcel vy cv csuc con0 wcel cA con0 wcel w3a cB wlim vy cv cB wcel
      wa vy cv con0 wcel vy cv csuc con0 wcel wa cA con0 wcel vy cv con0 wcel
      vy cv csuc con0 wcel cA con0 wcel w3a vy cv con0 wcel vy cv csuc con0
      wcel cA con0 wcel vy cv con0 wcel vy cv csuc con0 wcel cA con0 wcel w3a
      vy cv con0 wcel vy cv csuc con0 wcel cA con0 wcel w3a id 3expa ancoms cB
      wlim vy cv cB wcel wa vy cv con0 wcel vy cv con0 wcel vy cv csuc con0
      wcel wa cB word vy cv cB wcel vy cv con0 wcel cB wlim cB vy cv ordelon cB
      limord sylan vy cv con0 wcel vy cv csuc con0 wcel vy cv suceloni ancli
      syl sylan2 anassrs sylan an1rs mpi ex jcad cA vy cv coe co cA vx cv coe
      co wss cA vy cv coe co cA vy cv csuc coe co wss vx vy cv csuc cB c1o cdif
      vx cv vy cv csuc wceq cA vx cv coe co cA vy cv csuc coe co cA vy cv coe
      co vx cv vy cv csuc cA coe opreq2 sseq2d rcla4ev syl6 r19.21aiv vy vx cB
      cB c1o cdif cA vy cv coe co cA vx cv coe co iunss2 syl vx cB c1o cdif cA
      vx cv coe co ciun vy cB cA vy cv coe co ciun wss cA con0 wcel cB wlim wa
      c0 cA wcel wa vx cB c1o cdif cA vx cv coe co ciun vx cB cA vx cv coe co
      ciun vy cB cA vy cv coe co ciun cB c1o cdif cB wss vx cB c1o cdif cA vx
      cv coe co ciun vx cB cA vx cv coe co ciun wss cB c1o difss vx cB c1o cdif
      cB cA vx cv coe co iunss1 ax-mp vx vy cB cA vx cv coe co cA vy cv coe co
      vx cv vy cv cA coe opreq2 cbviunv sseqtri a1i eqssd adantlrl eqtrd oe0lem
      $.
      $( [21-Jul-2006] $) $( [6-Jan-2005] $)
  $}

  ${
    $d x C $. $d x y z w A $. $d x y z w B $.
    oeoalem.1 $e |- A e. On $.
    oeoalem.2 $e |- (/) e. A $.
    oeoalem.3 $e |- B e. On $.
    $( Lemma for ~ oeoa . $)
    oeoalem $p |- ( C e. On
               -> ( A ^o ( B +o C ) ) = ( ( A ^o B ) .o ( A ^o C ) ) ) $=
      cA cB vx cv coa co coe co cA cB coe co cA vx cv coe co comu co wceq cA cB
      c0 coa co coe co cA cB coe co cA c0 coe co comu co wceq cA cB vy cv coa
      co coe co cA cB coe co cA vy cv coe co comu co wceq cA cB vy cv csuc coa
      co coe co cA cB coe co cA vy cv csuc coe co comu co wceq cA cB cC coa co
      coe co cA cB coe co cA cC coe co comu co wceq vx vy cC vx cv c0 wceq cA
      cB vx cv coa co coe co cA cB c0 coa co coe co cA cB coe co cA vx cv coe
      co comu co cA cB coe co cA c0 coe co comu co vx cv c0 wceq cB vx cv coa
      co cB c0 coa co cA coe vx cv c0 cB coa opreq2 opreq2d vx cv c0 wceq cA vx
      cv coe co cA c0 coe co cA cB coe co comu vx cv c0 cA coe opreq2 opreq2d
      eqeq12d vx cv vy cv wceq cA cB vx cv coa co coe co cA cB vy cv coa co coe
      co cA cB coe co cA vx cv coe co comu co cA cB coe co cA vy cv coe co comu
      co vx cv vy cv wceq cB vx cv coa co cB vy cv coa co cA coe vx cv vy cv cB
      coa opreq2 opreq2d vx cv vy cv wceq cA vx cv coe co cA vy cv coe co cA cB
      coe co comu vx cv vy cv cA coe opreq2 opreq2d eqeq12d vx cv vy cv csuc
      wceq cA cB vx cv coa co coe co cA cB vy cv csuc coa co coe co cA cB coe
      co cA vx cv coe co comu co cA cB coe co cA vy cv csuc coe co comu co vx
      cv vy cv csuc wceq cB vx cv coa co cB vy cv csuc coa co cA coe vx cv vy
      cv csuc cB coa opreq2 opreq2d vx cv vy cv csuc wceq cA vx cv coe co cA vy
      cv csuc coe co cA cB coe co comu vx cv vy cv csuc cA coe opreq2 opreq2d
      eqeq12d vx cv cC wceq cA cB vx cv coa co coe co cA cB cC coa co coe co cA
      cB coe co cA vx cv coe co comu co cA cB coe co cA cC coe co comu co vx cv
      cC wceq cB vx cv coa co cB cC coa co cA coe vx cv cC cB coa opreq2
      opreq2d vx cv cC wceq cA vx cv coe co cA cC coe co cA cB coe co comu vx
      cv cC cA coe opreq2 opreq2d eqeq12d cA cB coe co c1o comu co cA cB coe co
      cA cB coe co cA c0 coe co comu co cA cB c0 coa co coe co cA cB coe co
      con0 wcel cA cB coe co c1o comu co cA cB coe co wceq cA con0 wcel cB con0
      wcel cA cB coe co con0 wcel oeoalem.1 oeoalem.3 cA cB oecl mp2an cA cB
      coe co om1 ax-mp cA c0 coe co c1o cA cB coe co comu cA con0 wcel cA c0
      coe co c1o wceq oeoalem.1 cA oe0 ax-mp opreq2i cB c0 coa co cB cA coe cB
      con0 wcel cB c0 coa co cB wceq oeoalem.3 cB oa0 ax-mp opreq2i 3eqtr4ri vy
      cv con0 wcel cA cB vy cv coa co coe co cA cB coe co cA vy cv coe co comu
      co wceq cA cB vy cv csuc coa co coe co cA cB coe co cA vy cv csuc coe co
      comu co wceq vy cv con0 wcel cA cB vy cv coa co coe co cA cB coe co cA vy
      cv coe co comu co wceq wa cA cB vy cv csuc coa co coe co cA cB coe co cA
      vy cv coe co comu co cA comu co cA cB coe co cA vy cv csuc coe co comu co
      vy cv con0 wcel cA cB vy cv coa co coe co cA cB coe co cA vy cv coe co
      comu co wceq cA cB vy cv csuc coa co coe co cA cB vy cv coa co coe co cA
      comu co cA cB coe co cA vy cv coe co comu co cA comu co cB con0 wcel vy
      cv con0 wcel cA cB vy cv csuc coa co coe co cA cB vy cv coa co coe co cA
      comu co wceq oeoalem.3 cB con0 wcel vy cv con0 wcel wa cA cB vy cv csuc
      coa co coe co cA cB vy cv coa co csuc coe co cA cB vy cv coa co coe co cA
      comu co cB con0 wcel vy cv con0 wcel wa cB vy cv csuc coa co cB vy cv coa
      co csuc cA coe cB vy cv oasuc opreq2d cA con0 wcel cB vy cv coa co con0
      wcel cA cB vy cv coa co csuc coe co cA cB vy cv coa co coe co cA comu co
      wceq cB con0 wcel vy cv con0 wcel wa cA cB vy cv coa co oesuc oeoalem.1
      cB vy cv oacl sylancr eqtrd mpan cA cB vy cv coa co coe co cA cB coe co
      cA vy cv coe co comu co cA comu opreq1 sylan9eq vy cv con0 wcel cA cB coe
      co cA vy cv coe co comu co cA comu co cA cB coe co cA vy cv csuc coe co
      comu co wceq cA cB vy cv coa co coe co cA cB coe co cA vy cv coe co comu
      co wceq cA con0 wcel vy cv con0 wcel cA cB coe co cA vy cv coe co comu co
      cA comu co cA cB coe co cA vy cv csuc coe co comu co wceq oeoalem.1 cA
      con0 wcel vy cv con0 wcel wa cA cB coe co cA vy cv coe co comu co cA comu
      co cA cB coe co cA vy cv coe co cA comu co comu co cA cB coe co cA vy cv
      csuc coe co comu co cA con0 wcel vy cv con0 wcel wa cA vy cv coe co con0
      wcel cA cB coe co cA vy cv coe co comu co cA comu co cA cB coe co cA vy
      cv coe co cA comu co comu co wceq cA vy cv oecl cA cB coe co con0 wcel cA
      vy cv coe co con0 wcel cA con0 wcel cA cB coe co cA vy cv coe co comu co
      cA comu co cA cB coe co cA vy cv coe co cA comu co comu co wceq cA con0
      wcel cB con0 wcel cA cB coe co con0 wcel oeoalem.1 oeoalem.3 cA cB oecl
      mp2an oeoalem.1 cA cB coe co cA vy cv coe co cA omass mp3an13 syl cA con0
      wcel vy cv con0 wcel wa cA vy cv csuc coe co cA vy cv coe co cA comu co
      cA cB coe co comu cA vy cv oesuc opreq2d eqtr4d mpan adantr eqtrd ex vx
      cv wlim cA cB vy cv coa co coe co cA cB coe co cA vy cv coe co comu co
      wceq vy vx cv wral cA cB vx cv coa co coe co cA cB coe co cA vx cv coe co
      comu co wceq vx cv wlim cA cB vy cv coa co coe co cA cB coe co cA vy cv
      coe co comu co wceq vy vx cv wral wa cA cB vx cv coa co coe co vy vx cv
      cA cB coe co cA vy cv coe co comu co ciun cA cB coe co cA vx cv coe co
      comu co vx cv wlim cA cB vy cv coa co coe co cA cB coe co cA vy cv coe co
      comu co wceq vy vx cv wral cA cB vx cv coa co coe co vy vx cv cA cB vy cv
      coa co coe co ciun vy vx cv cA cB coe co cA vy cv coe co comu co ciun vx
      cv wlim cA cB vx cv coa co coe co cA vy vx cv cB vy cv coa co ciun coe co
      vy vx cv cA cB vy cv coa co coe co ciun vx cv wlim cB vx cv coa co vy vx
      cv cB vy cv coa co ciun cA coe vx cv cvv wcel vx cv wlim cB vx cv coa co
      vy vx cv cB vy cv coa co ciun wceq vx visset cB con0 wcel vx cv cvv wcel
      vx cv wlim wa cB vx cv coa co vy vx cv cB vy cv coa co ciun wceq
      oeoalem.3 vy cB vx cv cvv oalim mpan mpan opreq2d vx cv cvv wcel cB vy cv
      coa co con0 wcel vy vx cv wral vx cv c0 wne cA vy vx cv cB vy cv coa co
      ciun coe co vy vx cv cA cB vy cv coa co coe co ciun wceq vx cv wlim vz vw
      vy cA cvv coe vx cv cB vy cv coa co vw cv cvv wcel vw cv wlim cA vw cv
      coe co vz vw cv cA vz cv coe co ciun wceq vw visset cA con0 wcel vw cv
      cvv wcel vw cv wlim wa cA vw cv coe co vz vw cv cA vz cv coe co ciun wceq
      oeoalem.1 cA con0 wcel vw cv cvv wcel vw cv wlim wa wa c0 cA wcel cA vw
      cv coe co vz vw cv cA vz cv coe co ciun wceq oeoalem.2 vz cA vw cv cvv
      oelim mpan2 mpan mpan vz cv con0 wcel vw cv con0 wcel vz cv vw cv wss cA
      vz cv coe co cA vw cv coe co wss vz cv con0 wcel vw cv con0 wcel cA con0
      wcel vz cv vw cv wss cA vz cv coe co cA vw cv coe co wss wi oeoalem.1 vz
      cv con0 wcel vw cv con0 wcel cA con0 wcel w3a c0 cA wcel vz cv vw cv wss
      cA vz cv coe co cA vw cv coe co wss wi oeoalem.2 vz cv vw cv cA oewordi
      mpan2 mp3an3 3impia onopriun vx cv cvv wcel vx cv wlim vx visset a1i vx
      cv wlim cB vy cv coa co con0 wcel vy vx cv cB con0 wcel vy cv con0 wcel
      cB vy cv coa co con0 wcel vx cv wlim vy cv vx cv wcel wa cB vy cv oacl
      oeoalem.3 vx cv word vy cv vx cv wcel vy cv con0 wcel vx cv wlim vx cv vy
      cv ordelon vx cv limord sylan sylancr r19.21aiva vx cv wlim c0 vx cv wcel
      vx cv c0 wne vx cv 0ellim vx cv c0 ne0i syl syl3anc eqtrd vy vx cv cA cB
      vy cv coa co coe co cA cB coe co cA vy cv coe co comu co iuneq2 sylan9eq
      vx cv wlim cA cB coe co cA vx cv coe co comu co vy vx cv cA cB coe co cA
      vy cv coe co comu co ciun wceq cA cB vy cv coa co coe co cA cB coe co cA
      vy cv coe co comu co wceq vy vx cv wral vx cv wlim cA cB coe co cA vx cv
      coe co comu co cA cB coe co vy vx cv cA vy cv coe co ciun comu co vy vx
      cv cA cB coe co cA vy cv coe co comu co ciun vx cv wlim cA vx cv coe co
      vy vx cv cA vy cv coe co ciun cA cB coe co comu vx cv cvv wcel vx cv wlim
      cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq vx visset cA con0 wcel
      vx cv cvv wcel vx cv wlim wa cA vx cv coe co vy vx cv cA vy cv coe co
      ciun wceq oeoalem.1 cA con0 wcel vx cv cvv wcel vx cv wlim wa wa c0 cA
      wcel cA vx cv coe co vy vx cv cA vy cv coe co ciun wceq oeoalem.2 vy cA
      vx cv cvv oelim mpan2 mpan mpan opreq2d vx cv cvv wcel cA vy cv coe co
      con0 wcel vy vx cv wral vx cv c0 wne cA cB coe co vy vx cv cA vy cv coe
      co ciun comu co vy vx cv cA cB coe co cA vy cv coe co comu co ciun wceq
      vx cv wlim vz vw vy cA cB coe co cvv comu vx cv cA vy cv coe co vw cv cvv
      wcel vw cv wlim cA cB coe co vw cv comu co vz vw cv cA cB coe co vz cv
      comu co ciun wceq vw visset cA cB coe co con0 wcel vw cv cvv wcel vw cv
      wlim wa cA cB coe co vw cv comu co vz vw cv cA cB coe co vz cv comu co
      ciun wceq cA con0 wcel cB con0 wcel cA cB coe co con0 wcel oeoalem.1
      oeoalem.3 cA cB oecl mp2an vz cA cB coe co vw cv cvv omlim mpan mpan vz
      cv con0 wcel vw cv con0 wcel vz cv vw cv wss cA cB coe co vz cv comu co
      cA cB coe co vw cv comu co wss vz cv con0 wcel vw cv con0 wcel cA cB coe
      co con0 wcel vz cv vw cv wss cA cB coe co vz cv comu co cA cB coe co vw
      cv comu co wss wi cA con0 wcel cB con0 wcel cA cB coe co con0 wcel
      oeoalem.1 oeoalem.3 cA cB oecl mp2an vz cv vw cv cA cB coe co omwordi
      mp3an3 3impia onopriun vx cv cvv wcel vx cv wlim vx visset a1i vx cv wlim
      cA vy cv coe co con0 wcel vy vx cv cA con0 wcel vy cv con0 wcel cA vy cv
      coe co con0 wcel vx cv wlim vy cv vx cv wcel wa cA vy cv oecl oeoalem.1
      vx cv word vy cv vx cv wcel vy cv con0 wcel vx cv wlim vx cv vy cv
      ordelon vx cv limord sylan sylancr r19.21aiva vx cv wlim c0 vx cv wcel vx
      cv c0 wne vx cv 0ellim vx cv c0 ne0i syl syl3anc eqtrd adantr eqtr4d ex
      tfinds $.
      $( [26-May-2009] $) $( [26-May-2009] $)
  $}

  $( Sum of exponents law for ordinal exponentiation.  Theorem 8R of [Enderton]
     p. 238.  Also Proposition 8.41 of [TakeutiZaring] p. 69.  (Contributed by
     Eric Schmidt, 26-May-2009.) $)
  oeoa $p |- ( ( A e. On /\ B e. On /\ C e. On )
          -> ( A ^o ( B +o C ) ) = ( ( A ^o B ) .o ( A ^o C ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB cC coa co coe co cA cB coe co
    cA cC coe co comu co wceq cB con0 wcel cC con0 wcel wa cA cB cC coa co coe
    co cA cB coe co cA cC coe co comu co wceq cA cA c0 wceq cB con0 wcel cC
    con0 wcel wa cA cB cC coa co coe co cA cB coe co cA cC coe co comu co wceq
    cA c0 wceq cA cB cC coa co coe co cA cB coe co cA cC coe co comu co wceq c0
    cB cC coa co coe co c0 cB coe co c0 cC coe co comu co wceq cB con0 wcel cC
    con0 wcel wa cA c0 wceq cA cB cC coa co coe co c0 cB cC coa co coe co cA cB
    coe co cA cC coe co comu co c0 cB coe co c0 cC coe co comu co cA c0 cB cC
    coa co coe opreq1 cA c0 wceq cA cB coe co c0 cB coe co cA cC coe co c0 cC
    coe co comu cA c0 cB coe opreq1 cA c0 cC coe opreq1 opreq12d eqeq12d cB
    con0 wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wa c0 cB cC coa co coe co
    c0 cB coe co c0 cC coe co comu co wceq cB con0 wcel cC con0 wcel wa cB c0
    wceq cC c0 wceq wa wa c0 cB cC coa co coe co c0 c0 coe co c0 cB coe co c0
    cC coe co comu co cB con0 wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wa wa
    cB cC coa co c0 c0 coe cB con0 wcel cC con0 wcel wa cB cC coa co c0 wceq cB
    c0 wceq cC c0 wceq wa cB cC oa00 biimpar opreq2d cB c0 wceq cC c0 wceq wa
    c0 cB coe co c0 cC coe co comu co c0 c0 coe co wceq cB con0 wcel cC con0
    wcel wa cB c0 wceq cC c0 wceq wa c0 cB coe co c0 cC coe co comu co c0 c0
    coe co c1o comu co c0 c0 coe co cB c0 wceq cC c0 wceq c0 cB coe co c0 c0
    coe co c0 cC coe co c1o comu cB c0 c0 coe opreq2 cC c0 wceq c0 cC coe co c0
    c0 coe co c1o cC c0 c0 coe opreq2 oe0m0 syl6eq opreqan12d c0 c0 coe co con0
    wcel c0 c0 coe co c1o comu co c0 c0 coe co wceq c0 con0 wcel c0 con0 wcel
    c0 c0 coe co con0 wcel 0elon 0elon c0 c0 oecl mp2an c0 c0 coe co om1 ax-mp
    syl6eq adantl eqtr4d cB con0 wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wa
    wn wa c0 cB cC coa co coe co c0 c0 cB coe co c0 cC coe co comu co cB con0
    wcel cC con0 wcel wa c0 cB cC coa co coe co c0 wceq cB c0 wceq cC c0 wceq
    wa wn cB con0 wcel cC con0 wcel wa c0 cB cC coa co wcel cB cC coa co c0 wne
    c0 cB cC coa co coe co c0 wceq cB c0 wceq cC c0 wceq wa wn cB con0 wcel cC
    con0 wcel wa cB cC coa co con0 wcel c0 cB cC coa co wcel cB cC coa co c0
    wne wb cB cC oacl cB cC coa co on0eln0 syl cB con0 wcel cC con0 wcel wa cB
    cC coa co con0 wcel c0 cB cC coa co wcel c0 cB cC coa co coe co c0 wceq wb
    cB cC oacl cB cC coa co oe0m1 syl cB con0 wcel cC con0 wcel wa cB c0 wceq
    cC c0 wceq wa cB cC coa co c0 cB cC oa00 necon3abid 3bitr3d biimpar cB con0
    wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wa wn c0 cB coe co c0 cC coe co
    comu co c0 wceq cB con0 wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wa wn c0
    cB wcel c0 cC wcel wo c0 cB coe co c0 cC coe co comu co c0 wceq cB con0
    wcel cC con0 wcel wa c0 cB wcel c0 cC wcel wo cB c0 wne cC c0 wne wo cB c0
    wceq cC c0 wceq wa wn cB con0 wcel cC con0 wcel wa c0 cB wcel cB c0 wne c0
    cC wcel cC c0 wne cB con0 wcel c0 cB wcel cB c0 wne wb cC con0 wcel cB
    on0eln0 adantr cC con0 wcel c0 cC wcel cC c0 wne wb cB con0 wcel cC on0eln0
    adantl orbi12d cB c0 cC c0 neorian syl6bb cB con0 wcel cC con0 wcel wa c0
    cB wcel c0 cC wcel wo c0 cB coe co c0 cC coe co comu co c0 wceq cB con0
    wcel cC con0 wcel wa c0 cB wcel c0 cB coe co c0 cC coe co comu co c0 wceq
    c0 cC wcel cB con0 wcel c0 cB wcel cC con0 wcel c0 cB coe co c0 cC coe co
    comu co c0 wceq cB con0 wcel c0 cB wcel wa cC con0 wcel c0 cB coe co c0 cC
    coe co comu co c0 c0 cC coe co comu co c0 cB con0 wcel c0 cB wcel wa c0 cB
    coe co c0 c0 cC coe co comu cB con0 wcel c0 cB wcel c0 cB coe co c0 wceq cB
    oe0m1 biimpa opreq1d cC con0 wcel c0 cC coe co con0 wcel c0 c0 cC coe co
    comu co c0 wceq c0 con0 wcel cC con0 wcel c0 cC coe co con0 wcel 0elon c0
    cC oecl mpan c0 cC coe co om0r syl sylan9eq an1rs cB con0 wcel cC con0 wcel
    c0 cC wcel c0 cB coe co c0 cC coe co comu co c0 wceq cC con0 wcel c0 cC
    wcel wa cB con0 wcel c0 cB coe co c0 cC coe co comu co c0 cB coe co c0 comu
    co c0 cC con0 wcel c0 cC wcel wa c0 cC coe co c0 c0 cB coe co comu cC con0
    wcel c0 cC wcel c0 cC coe co c0 wceq cC oe0m1 biimpa opreq2d cB con0 wcel
    c0 cB coe co con0 wcel c0 cB coe co c0 comu co c0 wceq c0 con0 wcel cB con0
    wcel c0 cB coe co con0 wcel 0elon c0 cB oecl mpan c0 cB coe co om0 syl
    sylan9eqr anassrs jaodan ex sylbird imp eqtr4d pm2.61dan syl5bir impcom cA
    con0 wcel c0 cA wcel cB con0 wcel cC con0 wcel wa cA cB cC coa co coe co cA
    cB coe co cA cC coe co comu co wceq cA con0 wcel c0 cA wcel wa cB con0 wcel
    cC con0 wcel cA cB cC coa co coe co cA cB coe co cA cC coe co comu co wceq
    cA con0 wcel c0 cA wcel wa cB con0 wcel wa cC con0 wcel cA cB cC coa co coe
    co cA cB coe co cA cC coe co comu co wceq cA con0 wcel c0 cA wcel wa cB
    con0 wcel cC con0 wcel cA cB cC coa co coe co cA cB coe co cA cC coe co
    comu co wceq wi cC con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif cB cC
    coa co coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cA con0 wcel
    c0 cA wcel wa cA c1o cif cC coe co comu co wceq wi cC con0 wcel cA con0
    wcel c0 cA wcel wa cA c1o cif cB con0 wcel cB c1o cif cC coa co coe co cA
    con0 wcel c0 cA wcel wa cA c1o cif cB con0 wcel cB c1o cif coe co cA con0
    wcel c0 cA wcel wa cA c1o cif cC coe co comu co wceq wi cA cB c1o c1o cA cA
    con0 wcel c0 cA wcel wa cA c1o cif wceq cA cB cC coa co coe co cA cB coe co
    cA cC coe co comu co wceq cA con0 wcel c0 cA wcel wa cA c1o cif cB cC coa
    co coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cA con0 wcel c0
    cA wcel wa cA c1o cif cC coe co comu co wceq cC con0 wcel cA cA con0 wcel
    c0 cA wcel wa cA c1o cif wceq cA cB cC coa co coe co cA con0 wcel c0 cA
    wcel wa cA c1o cif cB cC coa co coe co cA cB coe co cA cC coe co comu co cA
    con0 wcel c0 cA wcel wa cA c1o cif cB coe co cA con0 wcel c0 cA wcel wa cA
    c1o cif cC coe co comu co cA cA con0 wcel c0 cA wcel wa cA c1o cif cB cC
    coa co coe opreq1 cA cA con0 wcel c0 cA wcel wa cA c1o cif wceq cA cB coe
    co cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cA cC coe co cA con0
    wcel c0 cA wcel wa cA c1o cif cC coe co comu cA cA con0 wcel c0 cA wcel wa
    cA c1o cif cB coe opreq1 cA cA con0 wcel c0 cA wcel wa cA c1o cif cC coe
    opreq1 opreq12d eqeq12d imbi2d cB cB con0 wcel cB c1o cif wceq cA con0 wcel
    c0 cA wcel wa cA c1o cif cB cC coa co coe co cA con0 wcel c0 cA wcel wa cA
    c1o cif cB coe co cA con0 wcel c0 cA wcel wa cA c1o cif cC coe co comu co
    wceq cA con0 wcel c0 cA wcel wa cA c1o cif cB con0 wcel cB c1o cif cC coa
    co coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB con0 wcel cB c1o cif coe
    co cA con0 wcel c0 cA wcel wa cA c1o cif cC coe co comu co wceq cC con0
    wcel cB cB con0 wcel cB c1o cif wceq cA con0 wcel c0 cA wcel wa cA c1o cif
    cB cC coa co coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB con0 wcel cB
    c1o cif cC coa co coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cA
    con0 wcel c0 cA wcel wa cA c1o cif cC coe co comu co cA con0 wcel c0 cA
    wcel wa cA c1o cif cB con0 wcel cB c1o cif coe co cA con0 wcel c0 cA wcel
    wa cA c1o cif cC coe co comu co cB cB con0 wcel cB c1o cif wceq cB cC coa
    co cB con0 wcel cB c1o cif cC coa co cA con0 wcel c0 cA wcel wa cA c1o cif
    coe cB cB con0 wcel cB c1o cif cC coa opreq1 opreq2d cB cB con0 wcel cB c1o
    cif wceq cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cA con0 wcel c0 cA
    wcel wa cA c1o cif cB con0 wcel cB c1o cif coe co cA con0 wcel c0 cA wcel
    wa cA c1o cif cC coe co comu cB cB con0 wcel cB c1o cif cA con0 wcel c0 cA
    wcel wa cA c1o cif coe opreq2 opreq1d eqeq12d imbi2d cA con0 wcel c0 cA
    wcel wa cA c1o cif cB con0 wcel cB c1o cif cC cA con0 wcel c0 cA wcel wa cA
    c1o cif con0 wcel c0 cA con0 wcel c0 cA wcel wa cA c1o cif wcel cA con0
    wcel c0 cA wcel wa cA con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 cA
    con0 wcel c0 cA wcel wa cA c1o cif wcel wa c1o con0 wcel c0 c1o wcel wa cA
    c1o cA cA con0 wcel c0 cA wcel wa cA c1o cif wceq cA con0 wcel cA con0 wcel
    c0 cA wcel wa cA c1o cif con0 wcel c0 cA wcel c0 cA con0 wcel c0 cA wcel wa
    cA c1o cif wcel cA cA con0 wcel c0 cA wcel wa cA c1o cif con0 eleq1 cA cA
    con0 wcel c0 cA wcel wa cA c1o cif c0 eleq2 anbi12d c1o cA con0 wcel c0 cA
    wcel wa cA c1o cif wceq c1o con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif
    con0 wcel c0 c1o wcel c0 cA con0 wcel c0 cA wcel wa cA c1o cif wcel c1o cA
    con0 wcel c0 cA wcel wa cA c1o cif con0 eleq1 c1o cA con0 wcel c0 cA wcel
    wa cA c1o cif c0 eleq2 anbi12d c1o con0 wcel c0 c1o wcel 1on 0lt1o pm3.2i
    elimhyp pm3.26i cA con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 cA con0
    wcel c0 cA wcel wa cA c1o cif wcel cA con0 wcel c0 cA wcel wa cA con0 wcel
    c0 cA wcel wa cA c1o cif con0 wcel c0 cA con0 wcel c0 cA wcel wa cA c1o cif
    wcel wa c1o con0 wcel c0 c1o wcel wa cA c1o cA cA con0 wcel c0 cA wcel wa
    cA c1o cif wceq cA con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif con0
    wcel c0 cA wcel c0 cA con0 wcel c0 cA wcel wa cA c1o cif wcel cA cA con0
    wcel c0 cA wcel wa cA c1o cif con0 eleq1 cA cA con0 wcel c0 cA wcel wa cA
    c1o cif c0 eleq2 anbi12d c1o cA con0 wcel c0 cA wcel wa cA c1o cif wceq c1o
    con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 c1o wcel c0 cA
    con0 wcel c0 cA wcel wa cA c1o cif wcel c1o cA con0 wcel c0 cA wcel wa cA
    c1o cif con0 eleq1 c1o cA con0 wcel c0 cA wcel wa cA c1o cif c0 eleq2
    anbi12d c1o con0 wcel c0 c1o wcel 1on 0lt1o pm3.2i elimhyp pm3.27i cB c1o
    con0 1on elimel oeoalem dedth2h imp anasss an1rs oe0lem 3impb $.
    $( [26-May-2009] $) $( [26-May-2009] $)

  ${
    $d x C $. $d x y z w A $. $d x y z w B $.
    oeoelem.1 $e |- A e. On $.
    oeoelem.2 $e |- (/) e. A $.
    $( Lemma for ~ oeoe . $)
    oeoelem $p |- ( ( B e. On /\ C e. On )
               -> ( ( A ^o B ) ^o C ) = ( A ^o ( B .o C ) ) ) $=
      cC con0 wcel cB con0 wcel cA cB coe co cC coe co cA cB cC comu co coe co
      wceq cA cB coe co vx cv coe co cA cB vx cv comu co coe co wceq cA cB coe
      co c0 coe co cA cB c0 comu co coe co wceq cA cB coe co vy cv coe co cA cB
      vy cv comu co coe co wceq cA cB coe co vy cv csuc coe co cA cB vy cv csuc
      comu co coe co wceq cA cB coe co cC coe co cA cB cC comu co coe co wceq
      vx vy cC cB con0 wcel vx cv c0 wceq cA cB coe co vx cv coe co cA cB coe
      co c0 coe co cA cB vx cv comu co coe co cA cB c0 comu co coe co vx cv c0
      cA cB coe co coe opreq2 vx cv c0 wceq cB vx cv comu co cB c0 comu co cA
      coe vx cv c0 cB comu opreq2 opreq2d eqeq12d vx cv vy cv wceq cA cB coe co
      vx cv coe co cA cB coe co vy cv coe co cA cB vx cv comu co coe co cA cB
      vy cv comu co coe co vx cv vy cv cA cB coe co coe opreq2 vx cv vy cv wceq
      cB vx cv comu co cB vy cv comu co cA coe vx cv vy cv cB comu opreq2
      opreq2d eqeq12d vx cv vy cv csuc wceq cA cB coe co vx cv coe co cA cB coe
      co vy cv csuc coe co cA cB vx cv comu co coe co cA cB vy cv csuc comu co
      coe co vx cv vy cv csuc cA cB coe co coe opreq2 vx cv vy cv csuc wceq cB
      vx cv comu co cB vy cv csuc comu co cA coe vx cv vy cv csuc cB comu
      opreq2 opreq2d eqeq12d vx cv cC wceq cA cB coe co vx cv coe co cA cB coe
      co cC coe co cA cB vx cv comu co coe co cA cB cC comu co coe co vx cv cC
      cA cB coe co coe opreq2 vx cv cC wceq cB vx cv comu co cB cC comu co cA
      coe vx cv cC cB comu opreq2 opreq2d eqeq12d cB con0 wcel cA cB coe co c0
      coe co c1o cA cB c0 comu co coe co cB con0 wcel cA cB coe co con0 wcel cA
      cB coe co c0 coe co c1o wceq cA con0 wcel cB con0 wcel cA cB coe co con0
      wcel oeoelem.1 cA cB oecl mpan cA cB coe co oe0 syl cB con0 wcel cA cB c0
      comu co coe co cA c0 coe co c1o cB con0 wcel cB c0 comu co c0 cA coe cB
      om0 opreq2d cA con0 wcel cA c0 coe co c1o wceq oeoelem.1 cA oe0 ax-mp
      syl6eq eqtr4d cB con0 wcel vy cv con0 wcel cA cB coe co vy cv coe co cA
      cB vy cv comu co coe co wceq cA cB coe co vy cv csuc coe co cA cB vy cv
      csuc comu co coe co wceq wi cB con0 wcel vy cv con0 wcel wa cA cB coe co
      vy cv csuc coe co cA cB vy cv csuc comu co coe co wceq cA cB coe co vy cv
      coe co cA cB coe co comu co cA cB vy cv comu co coe co cA cB coe co comu
      co wceq cA cB coe co vy cv coe co cA cB vy cv comu co coe co wceq cB con0
      wcel vy cv con0 wcel wa cA cB coe co vy cv csuc coe co cA cB coe co vy cv
      coe co cA cB coe co comu co cA cB vy cv csuc comu co coe co cA cB vy cv
      comu co coe co cA cB coe co comu co cA cB coe co con0 wcel vy cv con0
      wcel cA cB coe co vy cv csuc coe co cA cB coe co vy cv coe co cA cB coe
      co comu co wceq cB con0 wcel cA cB coe co vy cv oesuc cA con0 wcel cB
      con0 wcel cA cB coe co con0 wcel oeoelem.1 cA cB oecl mpan sylan cB con0
      wcel vy cv con0 wcel wa cA cB vy cv csuc comu co coe co cA cB vy cv comu
      co cB coa co coe co cA cB vy cv comu co coe co cA cB coe co comu co cB
      con0 wcel vy cv con0 wcel wa cB vy cv csuc comu co cB vy cv comu co cB
      coa co cA coe cB vy cv omsuc opreq2d cB con0 wcel vy cv con0 wcel cA cB
      vy cv comu co cB coa co coe co cA cB vy cv comu co coe co cA cB coe co
      comu co wceq cB vy cv comu co con0 wcel cB con0 wcel cA cB vy cv comu co
      cB coa co coe co cA cB vy cv comu co coe co cA cB coe co comu co wceq cB
      con0 wcel vy cv con0 wcel wa cA con0 wcel cB vy cv comu co con0 wcel cB
      con0 wcel cA cB vy cv comu co cB coa co coe co cA cB vy cv comu co coe co
      cA cB coe co comu co wceq oeoelem.1 cA cB vy cv comu co cB oeoa mp3an1 cB
      vy cv omcl sylan anabss1 eqtrd eqeq12d cA cB coe co vy cv coe co cA cB vy
      cv comu co coe co cA cB coe co comu opreq1 syl5bir expcom cB con0 wcel vx
      cv wlim cA cB coe co vy cv coe co cA cB vy cv comu co coe co wceq vy vx
      cv wral cA cB coe co vx cv coe co cA cB vx cv comu co coe co wceq wi cB
      con0 wcel vx cv wlim wa cA cB coe co vx cv coe co cA cB vx cv comu co coe
      co wceq vy vx cv cA cB coe co vy cv coe co ciun vy vx cv cA cB vy cv comu
      co coe co ciun wceq cA cB coe co vy cv coe co cA cB vy cv comu co coe co
      wceq vy vx cv wral cB con0 wcel vx cv wlim wa cA cB coe co vx cv coe co
      vy vx cv cA cB coe co vy cv coe co ciun cA cB vx cv comu co coe co vy vx
      cv cA cB vy cv comu co coe co ciun cB con0 wcel vx cv cvv wcel vx cv wlim
      cA cB coe co vx cv coe co vy vx cv cA cB coe co vy cv coe co ciun wceq vx
      visset cA con0 wcel cB con0 wcel vx cv cvv wcel vx cv wlim wa cA cB coe
      co vx cv coe co vy vx cv cA cB coe co vy cv coe co ciun wceq oeoelem.1 cA
      con0 wcel cB con0 wcel wa vx cv cvv wcel vx cv wlim wa cA cB coe co vx cv
      coe co vy vx cv cA cB coe co vy cv coe co ciun wceq cA con0 wcel cB con0
      wcel wa vx cv cvv wcel vx cv wlim wa wa c0 cA cB coe co wcel cA cB coe co
      vx cv coe co vy vx cv cA cB coe co vy cv coe co ciun wceq cA con0 wcel cB
      con0 wcel wa cA cB coe co con0 wcel vx cv cvv wcel vx cv wlim wa c0 cA cB
      coe co wcel cA cB coe co vx cv coe co vy vx cv cA cB coe co vy cv coe co
      ciun wceq cA con0 wcel cB con0 wcel wa vy cA cB coe co vx cv cvv oelim cA
      cB oecl sylanl1 cA con0 wcel cB con0 wcel wa c0 cA wcel c0 cA cB coe co
      wcel oeoelem.2 cA cB oen0 mpan2 sylan2 anabss1 mpanl1 mpanr1 cB con0 wcel
      vx cv wlim wa cA cB vx cv comu co coe co cA vy vx cv cB vy cv comu co
      ciun coe co vy vx cv cA cB vy cv comu co coe co ciun cB con0 wcel vx cv
      wlim wa cB vx cv comu co vy vx cv cB vy cv comu co ciun cA coe cB con0
      wcel vx cv cvv wcel vx cv wlim cB vx cv comu co vy vx cv cB vy cv comu co
      ciun wceq vx visset vy cB vx cv cvv omlim mpanr1 opreq2d vx cv cvv wcel
      cB vy cv comu co con0 wcel vy vx cv wral vx cv c0 wne cA vy vx cv cB vy
      cv comu co ciun coe co vy vx cv cA cB vy cv comu co coe co ciun wceq cB
      con0 wcel vx cv wlim wa vz vw vy cA cvv coe vx cv cB vy cv comu co vw cv
      cvv wcel vw cv wlim cA vw cv coe co vz vw cv cA vz cv coe co ciun wceq vw
      visset cA con0 wcel vw cv cvv wcel vw cv wlim wa cA vw cv coe co vz vw cv
      cA vz cv coe co ciun wceq oeoelem.1 cA con0 wcel vw cv cvv wcel vw cv
      wlim wa wa c0 cA wcel cA vw cv coe co vz vw cv cA vz cv coe co ciun wceq
      oeoelem.2 vz cA vw cv cvv oelim mpan2 mpan mpan vz cv con0 wcel vw cv
      con0 wcel vz cv vw cv wss cA vz cv coe co cA vw cv coe co wss vz cv con0
      wcel vw cv con0 wcel cA con0 wcel vz cv vw cv wss cA vz cv coe co cA vw
      cv coe co wss wi oeoelem.1 vz cv con0 wcel vw cv con0 wcel cA con0 wcel
      w3a c0 cA wcel vz cv vw cv wss cA vz cv coe co cA vw cv coe co wss wi
      oeoelem.2 vz cv vw cv cA oewordi mpan2 mp3an3 3impia onopriun vx cv cvv
      wcel cB con0 wcel vx cv wlim wa vx visset a1i cB con0 wcel vx cv wlim wa
      cB vy cv comu co con0 wcel vy vx cv cB con0 wcel vx cv wlim vy cv vx cv
      wcel cB vy cv comu co con0 wcel cB con0 wcel vy cv con0 wcel cB vy cv
      comu co con0 wcel vx cv wlim vy cv vx cv wcel wa cB vy cv omcl vx cv word
      vy cv vx cv wcel vy cv con0 wcel vx cv wlim vx cv vy cv ordelon vx cv
      limord sylan sylan2 anassrs r19.21aiva vx cv wlim vx cv c0 wne cB con0
      wcel vx cv wlim c0 vx cv wcel vx cv c0 wne vx cv 0ellim vx cv c0 ne0i syl
      adantl syl3anc eqtrd eqeq12d vy vx cv cA cB coe co vy cv coe co cA cB vy
      cv comu co coe co iuneq2 syl5bir expcom tfinds3 impcom $.
      $( [26-May-2009] $) $( [26-May-2009] $)
  $}

  $( Product of exponents law for ordinal exponentiation.  Theorem 8S of
     [Enderton] p. 238.  Also Proposition 8.42 of [TakeutiZaring] p. 70.
     (Contributed by Eric Schmidt, 26-May-2009.) $)
  oeoe $p |- ( ( A e. On /\ B e. On /\ C e. On )
          -> ( ( A ^o B ) ^o C ) = ( A ^o ( B .o C ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB coe co cC coe co cA cB cC comu
    co coe co wceq cB con0 wcel cC con0 wcel wa cA cB coe co cC coe co cA cB cC
    comu co coe co wceq cA cA c0 wceq cB con0 wcel cC con0 wcel wa cA cB coe co
    cC coe co cA cB cC comu co coe co wceq cA c0 wceq cA cB coe co cC coe co cA
    cB cC comu co coe co wceq c0 cB coe co cC coe co c0 cB cC comu co coe co
    wceq cB con0 wcel cC con0 wcel wa cA c0 wceq cA cB coe co cC coe co c0 cB
    coe co cC coe co cA cB cC comu co coe co c0 cB cC comu co coe co cA c0 wceq
    cA cB coe co c0 cB coe co cC coe cA c0 cB coe opreq1 opreq1d cA c0 cB cC
    comu co coe opreq1 eqeq12d cB con0 wcel cC con0 wcel wa cB c0 wceq cC c0
    wceq wo c0 cB coe co cC coe co c0 cB cC comu co coe co wceq cB con0 wcel cC
    con0 wcel wa cB c0 wceq cC c0 wceq wo wa c0 cB coe co cC coe co c1o c0 cB
    cC comu co coe co cB con0 wcel cC con0 wcel wa cB c0 wceq c0 cB coe co cC
    coe co c1o wceq cC c0 wceq cC con0 wcel cB c0 wceq c0 cB coe co cC coe co
    c1o wceq cB con0 wcel cB c0 wceq cC con0 wcel c0 cB coe co cC coe co c1o cC
    coe co c1o cB c0 wceq c0 cB coe co c1o cC coe cB c0 wceq c0 cB coe co c0 c0
    coe co c1o cB c0 c0 coe opreq2 oe0m0 syl6eq opreq1d cC oe1m sylan9eqr
    adantll cB con0 wcel cC c0 wceq c0 cB coe co cC coe co c1o wceq cC con0
    wcel cC c0 wceq cB con0 wcel c0 cB coe co cC coe co c0 cB coe co c0 coe co
    c1o cC c0 c0 cB coe co coe opreq2 cB con0 wcel c0 cB coe co con0 wcel c0 cB
    coe co c0 coe co c1o wceq c0 con0 wcel cB con0 wcel c0 cB coe co con0 wcel
    0elon c0 cB oecl mpan c0 cB coe co oe0 syl sylan9eqr adantlr jaodan cB con0
    wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wo wa c0 cB cC comu co coe co c0
    c0 coe co c1o cB con0 wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wo wa cB
    cC comu co c0 c0 coe cB con0 wcel cC con0 wcel wa cB cC comu co c0 wceq cB
    c0 wceq cC c0 wceq wo cB cC om00 biimpar opreq2d oe0m0 syl6eq eqtr4d cB
    con0 wcel cC con0 wcel wa cB c0 wceq cC c0 wceq wo wn c0 cB coe co cC coe
    co c0 cB cC comu co coe co wceq cB con0 wcel cC con0 wcel wa cB c0 wceq cC
    c0 wceq wo wn c0 cB wcel c0 cC wcel wa c0 cB coe co cC coe co c0 cB cC comu
    co coe co wceq cB con0 wcel cC con0 wcel wa c0 cB wcel c0 cC wcel wa cB c0
    wne cC c0 wne wa cB c0 wceq cC c0 wceq wo wn cB con0 wcel c0 cB wcel cB c0
    wne cC con0 wcel c0 cC wcel cC c0 wne cB on0eln0 cC on0eln0 bi2anan9 cB c0
    cC c0 neanior syl6bb cB con0 wcel cC con0 wcel wa c0 cB wcel c0 cC wcel wa
    c0 cB coe co cC coe co c0 cB cC comu co coe co wceq cB con0 wcel cC con0
    wcel wa c0 cB wcel c0 cC wcel wa wa c0 cB coe co cC coe co c0 c0 cB cC comu
    co coe co cB con0 wcel c0 cB wcel cC con0 wcel c0 cC wcel c0 cB coe co cC
    coe co c0 wceq cB con0 wcel c0 cB wcel wa cC con0 wcel c0 cC wcel wa c0 cB
    coe co cC coe co c0 cC coe co c0 cB con0 wcel c0 cB wcel wa c0 cB coe co c0
    cC coe cB con0 wcel c0 cB wcel c0 cB coe co c0 wceq cB oe0m1 biimpa opreq1d
    cC con0 wcel c0 cC wcel c0 cC coe co c0 wceq cC oe0m1 biimpa sylan9eq an4s
    cB con0 wcel cC con0 wcel wa c0 cB wcel c0 cC wcel wa c0 cB cC comu co coe
    co c0 wceq cB con0 wcel cC con0 wcel wa c0 cB cC comu co wcel c0 cB wcel c0
    cC wcel wa c0 cB cC comu co coe co c0 wceq cB cC om00el cB con0 wcel cC
    con0 wcel wa cB cC comu co con0 wcel c0 cB cC comu co wcel c0 cB cC comu co
    coe co c0 wceq wb cB cC omcl cB cC comu co oe0m1 syl bitr3d biimpa eqtr4d
    ex sylbird imp pm2.61dan syl5bir impcom cA con0 wcel c0 cA wcel cB con0
    wcel cC con0 wcel wa cA cB coe co cC coe co cA cB cC comu co coe co wceq cA
    con0 wcel c0 cA wcel wa cB con0 wcel cC con0 wcel wa cA cB coe co cC coe co
    cA cB cC comu co coe co wceq cA con0 wcel c0 cA wcel wa cB con0 wcel cC
    con0 wcel wa cA cB coe co cC coe co cA cB cC comu co coe co wceq wi cB con0
    wcel cC con0 wcel wa cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cC coe
    co cA con0 wcel c0 cA wcel wa cA c1o cif cB cC comu co coe co wceq wi cA
    c1o cA cA con0 wcel c0 cA wcel wa cA c1o cif wceq cA cB coe co cC coe co cA
    cB cC comu co coe co wceq cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co
    cC coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB cC comu co coe co wceq
    cB con0 wcel cC con0 wcel wa cA cA con0 wcel c0 cA wcel wa cA c1o cif wceq
    cA cB coe co cC coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cC
    coe co cA cB cC comu co coe co cA con0 wcel c0 cA wcel wa cA c1o cif cB cC
    comu co coe co cA cA con0 wcel c0 cA wcel wa cA c1o cif wceq cA cB coe co
    cA con0 wcel c0 cA wcel wa cA c1o cif cB coe co cC coe cA cA con0 wcel c0
    cA wcel wa cA c1o cif cB coe opreq1 opreq1d cA cA con0 wcel c0 cA wcel wa
    cA c1o cif cB cC comu co coe opreq1 eqeq12d imbi2d cA con0 wcel c0 cA wcel
    wa cA c1o cif cB cC cA con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 cA
    con0 wcel c0 cA wcel wa cA c1o cif wcel cA con0 wcel c0 cA wcel wa cA con0
    wcel c0 cA wcel wa cA c1o cif con0 wcel c0 cA con0 wcel c0 cA wcel wa cA
    c1o cif wcel wa c1o con0 wcel c0 c1o wcel wa cA c1o cA cA con0 wcel c0 cA
    wcel wa cA c1o cif wceq cA con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif
    con0 wcel c0 cA wcel c0 cA con0 wcel c0 cA wcel wa cA c1o cif wcel cA cA
    con0 wcel c0 cA wcel wa cA c1o cif con0 eleq1 cA cA con0 wcel c0 cA wcel wa
    cA c1o cif c0 eleq2 anbi12d c1o cA con0 wcel c0 cA wcel wa cA c1o cif wceq
    c1o con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 c1o wcel
    c0 cA con0 wcel c0 cA wcel wa cA c1o cif wcel c1o cA con0 wcel c0 cA wcel
    wa cA c1o cif con0 eleq1 c1o cA con0 wcel c0 cA wcel wa cA c1o cif c0 eleq2
    anbi12d c1o con0 wcel c0 c1o wcel 1on 0lt1o pm3.2i elimhyp pm3.26i cA con0
    wcel c0 cA wcel wa cA c1o cif con0 wcel c0 cA con0 wcel c0 cA wcel wa cA
    c1o cif wcel cA con0 wcel c0 cA wcel wa cA con0 wcel c0 cA wcel wa cA c1o
    cif con0 wcel c0 cA con0 wcel c0 cA wcel wa cA c1o cif wcel wa c1o con0
    wcel c0 c1o wcel wa cA c1o cA cA con0 wcel c0 cA wcel wa cA c1o cif wceq cA
    con0 wcel cA con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 cA wcel c0 cA
    con0 wcel c0 cA wcel wa cA c1o cif wcel cA cA con0 wcel c0 cA wcel wa cA
    c1o cif con0 eleq1 cA cA con0 wcel c0 cA wcel wa cA c1o cif c0 eleq2
    anbi12d c1o cA con0 wcel c0 cA wcel wa cA c1o cif wceq c1o con0 wcel cA
    con0 wcel c0 cA wcel wa cA c1o cif con0 wcel c0 c1o wcel c0 cA con0 wcel c0
    cA wcel wa cA c1o cif wcel c1o cA con0 wcel c0 cA wcel wa cA c1o cif con0
    eleq1 c1o cA con0 wcel c0 cA wcel wa cA c1o cif c0 eleq2 anbi12d c1o con0
    wcel c0 c1o wcel 1on 0lt1o pm3.2i elimhyp pm3.27i oeoelem dedth imp an1rs
    oe0lem 3impb $.
    $( [26-May-2009] $) $( [26-May-2009] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Natural number arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Addition with zero.  Theorem 4I(A1) of [Enderton] p. 79. $)
  nna0 $p |- ( A e. om -> ( A +o (/) ) = A ) $=
    cA com wcel cA con0 wcel cA c0 coa co cA wceq cA nnon cA oa0 syl $.
    $( [20-Sep-1995] $)

  $( Multiplication with zero.  Theorem 4J(A1) of [Enderton] p. 80. $)
  nnm0 $p |- ( A e. om -> ( A .o (/) ) = (/) ) $=
    cA com wcel cA con0 wcel cA c0 comu co c0 wceq cA nnon cA om0 syl $.
    $( [20-Sep-1995] $)

  $( Addition with successor.  Theorem 4I(A2) of [Enderton] p. 79. $)
  nnasuc $p |- ( ( A e. om /\ B e. om ) ->
                ( A +o suc B ) = suc ( A +o B ) ) $=
    cA con0 wcel cB con0 wcel cA cB csuc coa co cA cB coa co csuc wceq cA com
    wcel cB com wcel cA cB oasuc cA nnon cB nnon syl2an $.
    $( [20-Sep-1995] $)

  $( Multiplication with successor.  Theorem 4J(A2) of [Enderton] p. 80. $)
  nnmsuc $p |- ( ( A e. om /\ B e. om ) ->
                ( A .o suc B ) = ( ( A .o B ) +o A ) ) $=
    cA con0 wcel cB con0 wcel cA cB csuc comu co cA cB comu co cA coa co wceq
    cA com wcel cB com wcel cA cB omsuc cA nnon cB nnon syl2an $.
    $( [20-Sep-1995] $)

  $( Addition to zero.  Remark in proof of Theorem 4K(2) of [Enderton]
     p. 81. $)
  nna0r $p |- ( A e. om -> ( (/) +o A ) = A ) $=
    cA com wcel cA con0 wcel c0 cA coa co cA wceq cA nnon cA oa0r syl $.
    $( [20-Sep-1995] $)

  $( Multiplication with zero.  Exercise 16 of [Enderton] p. 82. $)
  nnm0r $p |- ( A e. om -> ( (/) .o A ) = (/) ) $=
    cA com wcel cA con0 wcel c0 cA comu co c0 wceq cA nnon cA om0r syl $.
    $( [20-Sep-1995] $)

  ${
    $d x y A $.  $d x B $.
    $( Closure of addition of natural numbers.  Proposition 8.9 of
       [TakeutiZaring] p. 59. $)
    nnacl $p |- ( ( A e. om /\ B e. om ) -> ( A +o B ) e. om ) $=
      cB com wcel cA com wcel cA cB coa co com wcel cA com wcel cA vx cv coa co
      com wcel wi cA com wcel cA c0 coa co com wcel wi cA com wcel cA vy cv coa
      co com wcel wi cA com wcel cA vy cv csuc coa co com wcel wi cA com wcel
      cA cB coa co com wcel wi vx vy cB vx cv c0 wceq cA vx cv coa co com wcel
      cA c0 coa co com wcel cA com wcel vx cv c0 wceq cA vx cv coa co cA c0 coa
      co com vx cv c0 cA coa opreq2 eleq1d imbi2d vx cv vy cv wceq cA vx cv coa
      co com wcel cA vy cv coa co com wcel cA com wcel vx cv vy cv wceq cA vx
      cv coa co cA vy cv coa co com vx cv vy cv cA coa opreq2 eleq1d imbi2d vx
      cv vy cv csuc wceq cA vx cv coa co com wcel cA vy cv csuc coa co com wcel
      cA com wcel vx cv vy cv csuc wceq cA vx cv coa co cA vy cv csuc coa co
      com vx cv vy cv csuc cA coa opreq2 eleq1d imbi2d vx cv cB wceq cA vx cv
      coa co com wcel cA cB coa co com wcel cA com wcel vx cv cB wceq cA vx cv
      coa co cA cB coa co com vx cv cB cA coa opreq2 eleq1d imbi2d cA com wcel
      cA c0 coa co com wcel cA com wcel cA c0 coa co cA com cA nna0 eleq1d ibir
      vy cv com wcel cA com wcel cA vy cv coa co com wcel cA vy cv csuc coa co
      com wcel cA com wcel vy cv com wcel cA vy cv coa co com wcel cA vy cv
      csuc coa co com wcel wi cA com wcel vy cv com wcel wa cA vy cv csuc coa
      co com wcel cA vy cv coa co csuc com wcel cA vy cv coa co com wcel cA com
      wcel vy cv com wcel wa cA vy cv csuc coa co cA vy cv coa co csuc com cA
      vy cv nnasuc eleq1d cA vy cv coa co peano2 syl5bir expcom a2d finds
      impcom $.
      $( [20-Sep-1995] $)
  $}

  ${
    $d x y A $.  $d x B $.
    $( Closure of multiplication of natural numbers.  Proposition 8.17 of
       [TakeutiZaring] p. 63. $)
    nnmcl $p |- ( ( A e. om /\ B e. om ) -> ( A .o B ) e. om ) $=
      cB com wcel cA com wcel cA cB comu co com wcel cA com wcel cA vx cv comu
      co com wcel wi cA com wcel cA c0 comu co com wcel wi cA com wcel cA vy cv
      comu co com wcel wi cA com wcel cA vy cv csuc comu co com wcel wi cA com
      wcel cA cB comu co com wcel wi vx vy cB vx cv c0 wceq cA vx cv comu co
      com wcel cA c0 comu co com wcel cA com wcel vx cv c0 wceq cA vx cv comu
      co cA c0 comu co com vx cv c0 cA comu opreq2 eleq1d imbi2d vx cv vy cv
      wceq cA vx cv comu co com wcel cA vy cv comu co com wcel cA com wcel vx
      cv vy cv wceq cA vx cv comu co cA vy cv comu co com vx cv vy cv cA comu
      opreq2 eleq1d imbi2d vx cv vy cv csuc wceq cA vx cv comu co com wcel cA
      vy cv csuc comu co com wcel cA com wcel vx cv vy cv csuc wceq cA vx cv
      comu co cA vy cv csuc comu co com vx cv vy cv csuc cA comu opreq2 eleq1d
      imbi2d vx cv cB wceq cA vx cv comu co com wcel cA cB comu co com wcel cA
      com wcel vx cv cB wceq cA vx cv comu co cA cB comu co com vx cv cB cA
      comu opreq2 eleq1d imbi2d cA com wcel cA c0 comu co c0 com cA nnm0 peano1
      syl6eqel vy cv com wcel cA com wcel cA vy cv comu co com wcel cA vy cv
      csuc comu co com wcel cA com wcel cA vy cv comu co com wcel vy cv com
      wcel cA vy cv csuc comu co com wcel cA com wcel cA vy cv comu co com wcel
      vy cv com wcel cA vy cv csuc comu co com wcel wi wi cA com wcel vy cv com
      wcel cA vy cv comu co com wcel cA com wcel cA vy cv csuc comu co com wcel
      cA com wcel vy cv com wcel cA vy cv comu co com wcel cA com wcel cA vy cv
      csuc comu co com wcel cA com wcel vy cv com wcel wa cA vy cv csuc comu co
      com wcel cA vy cv comu co cA coa co com wcel cA vy cv comu co com wcel cA
      com wcel wa cA com wcel vy cv com wcel wa cA vy cv csuc comu co cA vy cv
      comu co cA coa co com cA vy cv nnmsuc eleq1d cA vy cv comu co cA nnacl
      syl5bir exp4b com24 pm2.43i com3r a2d finds impcom $.
      $( [20-Sep-1995] $)
  $}

  ${
    $d x y A $.  $d x B $.
    $( Closure of exponentiation of natural numbers.  Proposition 8.17 of
       [TakeutiZaring] p. 63. $)
    nnecl $p |- ( ( A e. om /\ B e. om ) -> ( A ^o B ) e. om ) $=
      cB com wcel cA com wcel cA cB coe co com wcel cA com wcel cA vx cv coe co
      com wcel wi cA com wcel cA c0 coe co com wcel wi cA com wcel cA vy cv coe
      co com wcel wi cA com wcel cA vy cv csuc coe co com wcel wi cA com wcel
      cA cB coe co com wcel wi vx vy cB vx cv c0 wceq cA vx cv coe co com wcel
      cA c0 coe co com wcel cA com wcel vx cv c0 wceq cA vx cv coe co cA c0 coe
      co com vx cv c0 cA coe opreq2 eleq1d imbi2d vx cv vy cv wceq cA vx cv coe
      co com wcel cA vy cv coe co com wcel cA com wcel vx cv vy cv wceq cA vx
      cv coe co cA vy cv coe co com vx cv vy cv cA coe opreq2 eleq1d imbi2d vx
      cv vy cv csuc wceq cA vx cv coe co com wcel cA vy cv csuc coe co com wcel
      cA com wcel vx cv vy cv csuc wceq cA vx cv coe co cA vy cv csuc coe co
      com vx cv vy cv csuc cA coe opreq2 eleq1d imbi2d vx cv cB wceq cA vx cv
      coe co com wcel cA cB coe co com wcel cA com wcel vx cv cB wceq cA vx cv
      coe co cA cB coe co com vx cv cB cA coe opreq2 eleq1d imbi2d cA com wcel
      cA c0 coe co c1o com cA com wcel cA con0 wcel cA c0 coe co c1o wceq cA
      nnon cA oe0 syl c1o c0 csuc com df-1o c0 com wcel c0 csuc com wcel peano1
      c0 peano2 ax-mp eqeltri syl6eqel vy cv com wcel cA com wcel cA vy cv coe
      co com wcel cA vy cv csuc coe co com wcel cA com wcel cA vy cv coe co com
      wcel vy cv com wcel cA vy cv csuc coe co com wcel cA com wcel cA vy cv
      coe co com wcel vy cv com wcel cA vy cv csuc coe co com wcel wi wi cA com
      wcel vy cv com wcel cA vy cv coe co com wcel cA com wcel cA vy cv csuc
      coe co com wcel cA com wcel vy cv com wcel cA vy cv coe co com wcel cA
      com wcel cA vy cv csuc coe co com wcel cA com wcel vy cv com wcel wa cA
      vy cv csuc coe co com wcel cA vy cv coe co cA comu co com wcel cA vy cv
      coe co com wcel cA com wcel wa cA com wcel vy cv com wcel wa cA vy cv
      csuc coe co cA vy cv coe co cA comu co com cA con0 wcel vy cv con0 wcel
      cA vy cv csuc coe co cA vy cv coe co cA comu co wceq cA com wcel vy cv
      com wcel cA vy cv oesuc cA nnon vy cv nnon syl2an eleq1d cA vy cv coe co
      cA nnmcl syl5bir exp4b com24 pm2.43i com3r a2d finds impcom $.
      $( [5-Jun-2007] $) $( [24-Mar-2007] $)
  $}

  $( Reverse closure law for addition of natural numbers.  Exercise 1 of
     [TakeutiZaring] p. 62 and its converse. $)
  nnarcl $p |- ( ( A e. On /\ B e. On ) ->
               ( ( A +o B ) e. om <-> ( A e. om /\ B e. om ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB coa co com wcel cA com wcel cB com wcel
    wa cA con0 wcel cB con0 wcel wa cA cB coa co com wcel cA com wcel cB com
    wcel cA con0 wcel cB con0 wcel wa cA cA cB coa co wss cA cB coa co com wcel
    cA com wcel wi cA cB oaword1 cA con0 wcel cA cA cB coa co wss cA cB coa co
    com wcel cA com wcel wi wi cB con0 wcel cA con0 wcel cA cA cB coa co wss cA
    cB coa co com wcel cA com wcel cA word com word cA cA cB coa co wss cA cB
    coa co com wcel wa cA com wcel wi cA con0 wcel cA cA cB coa co com ordtr2
    cA eloni ordom sylancl exp3a adantr mpd cA con0 wcel cB con0 wcel wa cB cA
    cB coa co wss cA cB coa co com wcel cB com wcel wi cB con0 wcel cA con0
    wcel cB cA cB coa co wss cB cA oaword2 ancoms cB con0 wcel cB cA cB coa co
    wss cA cB coa co com wcel cB com wcel wi wi cA con0 wcel cB con0 wcel cB cA
    cB coa co wss cA cB coa co com wcel cB com wcel cB word com word cB cA cB
    coa co wss cA cB coa co com wcel wa cB com wcel wi cB con0 wcel cB cA cB
    coa co com ordtr2 cB eloni ordom sylancl exp3a adantl mpd jcad cA cB nnacl
    impbid1 $.
    $( [14-Dec-2004] $) $( [12-Dec-2004] $)

  ${
    $d x A $.  $d x y z B $.
    $( Addition of natural numbers is commutative.  Theorem 4K(2) of
       [Enderton] p. 81. $)
    nnacom $p |- ( ( A e. om /\ B e. om ) -> ( A +o B ) = ( B +o A ) ) $=
      cA com wcel cB com wcel cA cB coa co cB cA coa co wceq cB com wcel vx cv
      cB coa co cB vx cv coa co wceq wi cB com wcel c0 cB coa co cB c0 coa co
      wceq wi cB com wcel vy cv cB coa co cB vy cv coa co wceq wi cB com wcel
      vy cv csuc cB coa co cB vy cv csuc coa co wceq wi cB com wcel cA cB coa
      co cB cA coa co wceq wi vx vy cA vx cv c0 wceq vx cv cB coa co cB vx cv
      coa co wceq c0 cB coa co cB c0 coa co wceq cB com wcel vx cv c0 wceq vx
      cv cB coa co c0 cB coa co cB vx cv coa co cB c0 coa co vx cv c0 cB coa
      opreq1 vx cv c0 cB coa opreq2 eqeq12d imbi2d vx cv vy cv wceq vx cv cB
      coa co cB vx cv coa co wceq vy cv cB coa co cB vy cv coa co wceq cB com
      wcel vx cv vy cv wceq vx cv cB coa co vy cv cB coa co cB vx cv coa co cB
      vy cv coa co vx cv vy cv cB coa opreq1 vx cv vy cv cB coa opreq2 eqeq12d
      imbi2d vx cv vy cv csuc wceq vx cv cB coa co cB vx cv coa co wceq vy cv
      csuc cB coa co cB vy cv csuc coa co wceq cB com wcel vx cv vy cv csuc
      wceq vx cv cB coa co vy cv csuc cB coa co cB vx cv coa co cB vy cv csuc
      coa co vx cv vy cv csuc cB coa opreq1 vx cv vy cv csuc cB coa opreq2
      eqeq12d imbi2d vx cv cA wceq vx cv cB coa co cB vx cv coa co wceq cA cB
      coa co cB cA coa co wceq cB com wcel vx cv cA wceq vx cv cB coa co cA cB
      coa co cB vx cv coa co cB cA coa co vx cv cA cB coa opreq1 vx cv cA cB
      coa opreq2 eqeq12d imbi2d cB com wcel c0 cB coa co cB cB c0 coa co cB
      nna0r cB nna0 eqtr4d vy cv com wcel cB com wcel vy cv cB coa co cB vy cv
      coa co wceq vy cv csuc cB coa co cB vy cv csuc coa co wceq cB com wcel vy
      cv com wcel vy cv cB coa co cB vy cv coa co wceq vy cv csuc cB coa co cB
      vy cv csuc coa co wceq wi cB com wcel vy cv com wcel wa vy cv csuc cB coa
      co cB vy cv csuc coa co wceq vy cv cB coa co csuc cB vy cv coa co csuc
      wceq vy cv cB coa co cB vy cv coa co wceq cB com wcel vy cv com wcel wa
      vy cv csuc cB coa co vy cv cB coa co csuc cB vy cv csuc coa co cB vy cv
      coa co csuc cB com wcel vy cv com wcel vy cv csuc cB coa co vy cv cB coa
      co csuc wceq vy cv com wcel vy cv csuc vx cv coa co vy cv vx cv coa co
      csuc wceq wi vy cv com wcel vy cv csuc c0 coa co vy cv c0 coa co csuc
      wceq wi vy cv com wcel vy cv csuc vz cv coa co vy cv vz cv coa co csuc
      wceq wi vy cv com wcel vy cv csuc vz cv csuc coa co vy cv vz cv csuc coa
      co csuc wceq wi vy cv com wcel vy cv csuc cB coa co vy cv cB coa co csuc
      wceq wi vx vz cB vx cv c0 wceq vy cv csuc vx cv coa co vy cv vx cv coa co
      csuc wceq vy cv csuc c0 coa co vy cv c0 coa co csuc wceq vy cv com wcel
      vx cv c0 wceq vy cv csuc vx cv coa co vy cv csuc c0 coa co vy cv vx cv
      coa co csuc vy cv c0 coa co csuc vx cv c0 vy cv csuc coa opreq2 vx cv c0
      wceq vy cv vx cv coa co vy cv c0 coa co wceq vy cv vx cv coa co csuc vy
      cv c0 coa co csuc wceq vx cv c0 vy cv coa opreq2 vy cv vx cv coa co vy cv
      c0 coa co suceq syl eqeq12d imbi2d vx cv vz cv wceq vy cv csuc vx cv coa
      co vy cv vx cv coa co csuc wceq vy cv csuc vz cv coa co vy cv vz cv coa
      co csuc wceq vy cv com wcel vx cv vz cv wceq vy cv csuc vx cv coa co vy
      cv csuc vz cv coa co vy cv vx cv coa co csuc vy cv vz cv coa co csuc vx
      cv vz cv vy cv csuc coa opreq2 vx cv vz cv wceq vy cv vx cv coa co vy cv
      vz cv coa co wceq vy cv vx cv coa co csuc vy cv vz cv coa co csuc wceq vx
      cv vz cv vy cv coa opreq2 vy cv vx cv coa co vy cv vz cv coa co suceq syl
      eqeq12d imbi2d vx cv vz cv csuc wceq vy cv csuc vx cv coa co vy cv vx cv
      coa co csuc wceq vy cv csuc vz cv csuc coa co vy cv vz cv csuc coa co
      csuc wceq vy cv com wcel vx cv vz cv csuc wceq vy cv csuc vx cv coa co vy
      cv csuc vz cv csuc coa co vy cv vx cv coa co csuc vy cv vz cv csuc coa co
      csuc vx cv vz cv csuc vy cv csuc coa opreq2 vx cv vz cv csuc wceq vy cv
      vx cv coa co vy cv vz cv csuc coa co wceq vy cv vx cv coa co csuc vy cv
      vz cv csuc coa co csuc wceq vx cv vz cv csuc vy cv coa opreq2 vy cv vx cv
      coa co vy cv vz cv csuc coa co suceq syl eqeq12d imbi2d vx cv cB wceq vy
      cv csuc vx cv coa co vy cv vx cv coa co csuc wceq vy cv csuc cB coa co vy
      cv cB coa co csuc wceq vy cv com wcel vx cv cB wceq vy cv csuc vx cv coa
      co vy cv csuc cB coa co vy cv vx cv coa co csuc vy cv cB coa co csuc vx
      cv cB vy cv csuc coa opreq2 vx cv cB wceq vy cv vx cv coa co vy cv cB coa
      co wceq vy cv vx cv coa co csuc vy cv cB coa co csuc wceq vx cv cB vy cv
      coa opreq2 vy cv vx cv coa co vy cv cB coa co suceq syl eqeq12d imbi2d vy
      cv com wcel vy cv csuc c0 coa co vy cv csuc vy cv c0 coa co csuc vy cv
      com wcel vy cv csuc com wcel vy cv csuc c0 coa co vy cv csuc wceq vy cv
      peano2b vy cv csuc nna0 sylbi vy cv com wcel vy cv c0 coa co vy cv wceq
      vy cv c0 coa co csuc vy cv csuc wceq vy cv nna0 vy cv c0 coa co vy cv
      suceq syl eqtr4d vz cv com wcel vy cv com wcel vy cv csuc vz cv coa co vy
      cv vz cv coa co csuc wceq vy cv csuc vz cv csuc coa co vy cv vz cv csuc
      coa co csuc wceq vy cv com wcel vz cv com wcel vy cv csuc vz cv coa co vy
      cv vz cv coa co csuc wceq vy cv csuc vz cv csuc coa co vy cv vz cv csuc
      coa co csuc wceq wi vy cv com wcel vz cv com wcel wa vy cv csuc vz cv
      csuc coa co vy cv vz cv csuc coa co csuc wceq vy cv csuc vz cv coa co
      csuc vy cv vz cv coa co csuc csuc wceq vy cv csuc vz cv coa co vy cv vz
      cv coa co csuc wceq vy cv com wcel vz cv com wcel wa vy cv csuc vz cv
      csuc coa co vy cv csuc vz cv coa co csuc vy cv vz cv csuc coa co csuc vy
      cv vz cv coa co csuc csuc vy cv csuc con0 wcel vz cv con0 wcel vy cv csuc
      vz cv csuc coa co vy cv csuc vz cv coa co csuc wceq vy cv com wcel vz cv
      com wcel vy cv csuc vz cv oasuc vy cv com wcel vy cv con0 wcel vy cv csuc
      con0 wcel vy cv nnon vy cv suceloni syl vz cv nnon syl2an vy cv com wcel
      vz cv com wcel wa vy cv con0 wcel vz cv con0 wcel wa vy cv vz cv csuc coa
      co vy cv vz cv coa co csuc wceq vy cv vz cv csuc coa co csuc vy cv vz cv
      coa co csuc csuc wceq vy cv com wcel vy cv con0 wcel vz cv com wcel vz cv
      con0 wcel vy cv nnon vz cv nnon anim12i vy cv vz cv oasuc vy cv vz cv
      csuc coa co vy cv vz cv coa co csuc suceq 3syl eqeq12d vy cv csuc vz cv
      coa co vy cv vz cv coa co csuc suceq syl5bir expcom a2d finds imp cB vy
      cv nnasuc eqeq12d vy cv cB coa co cB vy cv coa co suceq syl5bir expcom
      a2d finds imp $.
      $( [6-May-1995] $)
  $}

  $( Ordering property of addition.  Proposition 8.4 of [TakeutiZaring] p. 58,
     limited to natural numbers. $)
  nnaordi $p |- ( ( B e. om /\ C e. om ) ->
               ( A e. B -> ( C +o A ) e. ( C +o B ) ) ) $=
    cB con0 wcel cC con0 wcel cA cB wcel cC cA coa co cC cB coa co wcel wi cB
    com wcel cC com wcel cA cB cC oaordi cB nnon cC nnon syl2an $.
    $( [3-Feb-1996] $)

  $( Ordering property of addition.  Proposition 8.4 of [TakeutiZaring] p. 58,
     limited to natural numbers, and its converse. $)
  nnaord $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( A e. B <-> ( C +o A ) e. ( C +o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB wcel cC cA coa co cC cB coa co
    wcel wb cA com wcel cB com wcel cC com wcel cA cB cC oaord cA nnon cB nnon
    cC nnon syl3an $.
    $( [7-Mar-1996] $)

  $( Ordering property of addition of natural numbers. $)
  nnaordr $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( A e. B <-> ( A +o C ) e. ( B +o C ) ) ) $=
    cA com wcel cB com wcel cC com wcel w3a cA cB wcel cC cA coa co cC cB coa
    co wcel cA cC coa co cB cC coa co wcel cA cB cC nnaord cA com wcel cB com
    wcel cC com wcel w3a cC cA coa co cA cC coa co cC cB coa co cB cC coa co cA
    com wcel cC com wcel cC cA coa co cA cC coa co wceq cB com wcel cC com wcel
    cA com wcel cC cA coa co cA cC coa co wceq cC cA nnacom ancoms 3adant2 cB
    com wcel cC com wcel cC cB coa co cB cC coa co wceq cA com wcel cC com wcel
    cB com wcel cC cB coa co cB cC coa co wceq cC cB nnacom ancoms 3adant1
    eleq12d bitrd $.
    $( [9-Nov-2002] $)

  $( Addition of natural numbers is associative.  (For brevity, this is just a
     special case of the proof for ordinals.  A direct proof would be about 1/3
     the size of the ordinal proof, since it would use finite induction and not
     require the limit ordinal case..)  Theorem 4K(1) of [Enderton] p. 81. $)
  nnaass $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
               ( ( A +o B ) +o C ) = ( A +o ( B +o C ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB coa co cC coa co cA cB cC coa
    co coa co wceq cA com wcel cB com wcel cC com wcel cA cB cC oaass cA nnon
    cB nnon cC nnon syl3an $.
    $( [20-Sep-1995] $)

  $( Distributive law for natural numbers.  (For brevity, this is just a
     special case of the proof for ordinals.  A direct proof would be about 1/4
     the size of the ordinal proof, since it would use finite induction and not
     require the limit ordinal case.)  Theorem 4K(3) of [Enderton] p. 81. $)
  nndi $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
               ( A .o ( B +o C ) ) = ( ( A .o B ) +o ( A .o C ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB cC coa co comu co cA cB comu
    co cA cC comu co coa co wceq cA com wcel cB com wcel cC com wcel cA cB cC
    odi cA nnon cB nnon cC nnon syl3an $.
    $( [20-Sep-1995] $)

  $( Multiplication of natural numbers is associative.  (For brevity, this is
     just a special case of the proof for ordinals.  A direct proof would be
     about 1/3 the size of the ordinal proof, since it would use finite
     induction and not require the limit ordinal case..)  Theorem 4K(4) of
     [Enderton] p. 81. $)
  nnmass $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
               ( ( A .o B ) .o C ) = ( A .o ( B .o C ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB comu co cC comu co cA cB cC
    comu co comu co wceq cA com wcel cB com wcel cC com wcel cA cB cC omass cA
    nnon cB nnon cC nnon syl3an $.
    $( [20-Sep-1995] $)

  ${
    $d x y A $.  $d x B $.
    $( Multiplication with successor.  Exercise 16 of [Enderton] p. 82. $)
    nnmsucr $p |- ( ( A e. om /\ B e. om ) ->
                  ( suc A .o B ) = ( ( A .o B ) +o B ) ) $=
      cB com wcel cA com wcel cA csuc cB comu co cA cB comu co cB coa co wceq
      cA com wcel cA csuc vx cv comu co cA vx cv comu co vx cv coa co wceq wi
      cA com wcel cA csuc c0 comu co cA c0 comu co c0 coa co wceq wi cA com
      wcel cA csuc vy cv comu co cA vy cv comu co vy cv coa co wceq wi cA com
      wcel cA csuc vy cv csuc comu co cA vy cv csuc comu co vy cv csuc coa co
      wceq wi cA com wcel cA csuc cB comu co cA cB comu co cB coa co wceq wi vx
      vy cB vx cv c0 wceq cA csuc vx cv comu co cA vx cv comu co vx cv coa co
      wceq cA csuc c0 comu co cA c0 comu co c0 coa co wceq cA com wcel vx cv c0
      wceq cA csuc vx cv comu co cA csuc c0 comu co cA vx cv comu co vx cv coa
      co cA c0 comu co c0 coa co vx cv c0 cA csuc comu opreq2 vx cv c0 wceq cA
      vx cv comu co cA c0 comu co vx cv c0 coa vx cv c0 cA comu opreq2 vx cv c0
      wceq id opreq12d eqeq12d imbi2d vx cv vy cv wceq cA csuc vx cv comu co cA
      vx cv comu co vx cv coa co wceq cA csuc vy cv comu co cA vy cv comu co vy
      cv coa co wceq cA com wcel vx cv vy cv wceq cA csuc vx cv comu co cA csuc
      vy cv comu co cA vx cv comu co vx cv coa co cA vy cv comu co vy cv coa co
      vx cv vy cv cA csuc comu opreq2 vx cv vy cv wceq cA vx cv comu co cA vy
      cv comu co vx cv vy cv coa vx cv vy cv cA comu opreq2 vx cv vy cv wceq id
      opreq12d eqeq12d imbi2d vx cv vy cv csuc wceq cA csuc vx cv comu co cA vx
      cv comu co vx cv coa co wceq cA csuc vy cv csuc comu co cA vy cv csuc
      comu co vy cv csuc coa co wceq cA com wcel vx cv vy cv csuc wceq cA csuc
      vx cv comu co cA csuc vy cv csuc comu co cA vx cv comu co vx cv coa co cA
      vy cv csuc comu co vy cv csuc coa co vx cv vy cv csuc cA csuc comu opreq2
      vx cv vy cv csuc wceq cA vx cv comu co cA vy cv csuc comu co vx cv vy cv
      csuc coa vx cv vy cv csuc cA comu opreq2 vx cv vy cv csuc wceq id
      opreq12d eqeq12d imbi2d vx cv cB wceq cA csuc vx cv comu co cA vx cv comu
      co vx cv coa co wceq cA csuc cB comu co cA cB comu co cB coa co wceq cA
      com wcel vx cv cB wceq cA csuc vx cv comu co cA csuc cB comu co cA vx cv
      comu co vx cv coa co cA cB comu co cB coa co vx cv cB cA csuc comu opreq2
      vx cv cB wceq cA vx cv comu co cA cB comu co vx cv cB coa vx cv cB cA
      comu opreq2 vx cv cB wceq id opreq12d eqeq12d imbi2d cA com wcel cA csuc
      c0 comu co c0 cA c0 comu co c0 coa co cA com wcel cA csuc com wcel cA
      csuc c0 comu co c0 wceq cA peano2b cA csuc nnm0 sylbi cA com wcel cA c0
      comu co c0 coa co c0 c0 coa co c0 cA com wcel cA c0 comu co c0 c0 coa cA
      nnm0 opreq1d c0 com wcel c0 c0 coa co c0 wceq peano1 c0 nna0 ax-mp syl6eq
      eqtr4d vy cv com wcel cA com wcel cA csuc vy cv comu co cA vy cv comu co
      vy cv coa co wceq cA csuc vy cv csuc comu co cA vy cv csuc comu co vy cv
      csuc coa co wceq cA com wcel vy cv com wcel cA csuc vy cv comu co cA vy
      cv comu co vy cv coa co wceq cA csuc vy cv csuc comu co cA vy cv csuc
      comu co vy cv csuc coa co wceq wi cA com wcel vy cv com wcel wa cA csuc
      vy cv csuc comu co cA vy cv csuc comu co vy cv csuc coa co wceq cA csuc
      vy cv comu co cA csuc coa co cA vy cv comu co vy cv coa co cA csuc coa co
      wceq cA csuc vy cv comu co cA vy cv comu co vy cv coa co wceq cA com wcel
      vy cv com wcel wa cA csuc vy cv csuc comu co cA csuc vy cv comu co cA
      csuc coa co cA vy cv csuc comu co vy cv csuc coa co cA vy cv comu co vy
      cv coa co cA csuc coa co cA csuc com wcel vy cv com wcel cA csuc vy cv
      csuc comu co cA csuc vy cv comu co cA csuc coa co wceq cA com wcel cA
      csuc vy cv nnmsuc cA peano2b sylanb cA com wcel vy cv com wcel wa cA vy
      cv csuc comu co vy cv csuc coa co cA vy cv comu co cA coa co vy cv csuc
      coa co cA vy cv comu co vy cv coa co cA csuc coa co cA com wcel vy cv com
      wcel wa cA vy cv csuc comu co cA vy cv comu co cA coa co vy cv csuc coa
      cA vy cv nnmsuc opreq1d cA com wcel vy cv com wcel wa cA vy cv comu co cA
      vy cv csuc coa co coa co cA vy cv comu co vy cv cA csuc coa co coa co cA
      vy cv comu co cA coa co vy cv csuc coa co cA vy cv comu co vy cv coa co
      cA csuc coa co cA com wcel vy cv com wcel wa cA vy cv csuc coa co vy cv
      cA csuc coa co cA vy cv comu co coa cA com wcel vy cv com wcel wa cA vy
      cv coa co csuc vy cv cA coa co csuc cA vy cv csuc coa co vy cv cA csuc
      coa co cA com wcel vy cv com wcel wa cA vy cv coa co vy cv cA coa co wceq
      cA vy cv coa co csuc vy cv cA coa co csuc wceq cA vy cv nnacom cA vy cv
      coa co vy cv cA coa co suceq syl cA vy cv nnasuc vy cv com wcel cA com
      wcel vy cv cA csuc coa co vy cv cA coa co csuc wceq vy cv cA nnasuc
      ancoms 3eqtr4d opreq2d cA com wcel vy cv com wcel wa cA vy cv comu co cA
      coa co vy cv csuc coa co cA vy cv comu co cA vy cv csuc coa co coa co
      wceq cA com wcel vy cv com wcel wa cA com wcel vy cv com wcel cA vy cv
      comu co cA coa co vy cv csuc coa co cA vy cv comu co cA vy cv csuc coa co
      coa co wceq cA vy cv comu co com wcel cA com wcel vy cv com wcel cA vy cv
      comu co cA coa co vy cv csuc coa co cA vy cv comu co cA vy cv csuc coa co
      coa co wceq cA com wcel vy cv com wcel wa cA vy cv comu co com wcel cA
      com wcel vy cv csuc com wcel cA vy cv comu co cA coa co vy cv csuc coa co
      cA vy cv comu co cA vy cv csuc coa co coa co wceq vy cv com wcel cA vy cv
      comu co cA vy cv csuc nnaass vy cv peano2b syl3an3b cA vy cv nnmcl
      syl3an1 3expb anidms cA com wcel vy cv com wcel wa cA vy cv comu co vy cv
      coa co cA csuc coa co cA vy cv comu co vy cv cA csuc coa co coa co wceq
      cA com wcel vy cv com wcel vy cv com wcel cA com wcel cA vy cv comu co vy
      cv coa co cA csuc coa co cA vy cv comu co vy cv cA csuc coa co coa co
      wceq cA com wcel vy cv com wcel wa vy cv com wcel cA com wcel cA vy cv
      comu co vy cv coa co cA csuc coa co cA vy cv comu co vy cv cA csuc coa co
      coa co wceq cA vy cv comu co com wcel vy cv com wcel cA com wcel cA vy cv
      comu co vy cv coa co cA csuc coa co cA vy cv comu co vy cv cA csuc coa co
      coa co wceq cA com wcel vy cv com wcel wa cA vy cv comu co com wcel vy cv
      com wcel cA csuc com wcel cA vy cv comu co vy cv coa co cA csuc coa co cA
      vy cv comu co vy cv cA csuc coa co coa co wceq cA com wcel cA vy cv comu
      co vy cv cA csuc nnaass cA peano2b syl3an3b cA vy cv nnmcl syl3an1 3expb
      an42s anidms 3eqtr4d eqtrd eqeq12d cA csuc vy cv comu co cA vy cv comu co
      vy cv coa co cA csuc coa opreq1 syl5bir expcom a2d finds impcom $.
      $( [21-Sep-1995] $)
  $}

  ${
    $d x A $.  $d x y B $.
    $( Multiplication of natural numbers is commutative.  Theorem 4K(5) of
       [Enderton] p. 81. $)
    nnmcom $p |- ( ( A e. om /\ B e. om ) -> ( A .o B ) = ( B .o A ) ) $=
      cA com wcel cB com wcel cA cB comu co cB cA comu co wceq cB com wcel vx
      cv cB comu co cB vx cv comu co wceq wi cB com wcel c0 cB comu co cB c0
      comu co wceq wi cB com wcel vy cv cB comu co cB vy cv comu co wceq wi cB
      com wcel vy cv csuc cB comu co cB vy cv csuc comu co wceq wi cB com wcel
      cA cB comu co cB cA comu co wceq wi vx vy cA vx cv c0 wceq vx cv cB comu
      co cB vx cv comu co wceq c0 cB comu co cB c0 comu co wceq cB com wcel vx
      cv c0 wceq vx cv cB comu co c0 cB comu co cB vx cv comu co cB c0 comu co
      vx cv c0 cB comu opreq1 vx cv c0 cB comu opreq2 eqeq12d imbi2d vx cv vy
      cv wceq vx cv cB comu co cB vx cv comu co wceq vy cv cB comu co cB vy cv
      comu co wceq cB com wcel vx cv vy cv wceq vx cv cB comu co vy cv cB comu
      co cB vx cv comu co cB vy cv comu co vx cv vy cv cB comu opreq1 vx cv vy
      cv cB comu opreq2 eqeq12d imbi2d vx cv vy cv csuc wceq vx cv cB comu co
      cB vx cv comu co wceq vy cv csuc cB comu co cB vy cv csuc comu co wceq cB
      com wcel vx cv vy cv csuc wceq vx cv cB comu co vy cv csuc cB comu co cB
      vx cv comu co cB vy cv csuc comu co vx cv vy cv csuc cB comu opreq1 vx cv
      vy cv csuc cB comu opreq2 eqeq12d imbi2d vx cv cA wceq vx cv cB comu co
      cB vx cv comu co wceq cA cB comu co cB cA comu co wceq cB com wcel vx cv
      cA wceq vx cv cB comu co cA cB comu co cB vx cv comu co cB cA comu co vx
      cv cA cB comu opreq1 vx cv cA cB comu opreq2 eqeq12d imbi2d cB com wcel
      c0 cB comu co c0 cB c0 comu co cB nnm0r cB nnm0 eqtr4d vy cv com wcel cB
      com wcel vy cv cB comu co cB vy cv comu co wceq vy cv csuc cB comu co cB
      vy cv csuc comu co wceq vy cv com wcel cB com wcel vy cv cB comu co cB vy
      cv comu co wceq vy cv csuc cB comu co cB vy cv csuc comu co wceq wi vy cv
      com wcel cB com wcel wa vy cv csuc cB comu co cB vy cv csuc comu co wceq
      vy cv cB comu co cB coa co cB vy cv comu co cB coa co wceq vy cv cB comu
      co cB vy cv comu co wceq vy cv com wcel cB com wcel wa vy cv csuc cB comu
      co vy cv cB comu co cB coa co cB vy cv csuc comu co cB vy cv comu co cB
      coa co vy cv cB nnmsucr cB com wcel vy cv com wcel cB vy cv csuc comu co
      cB vy cv comu co cB coa co wceq cB vy cv nnmsuc ancoms eqeq12d vy cv cB
      comu co cB vy cv comu co cB coa opreq1 syl5bir ex a2d finds imp $.
      $( [21-Sep-1995] $)
  $}

  $( Cancellation law for addition of natural numbers. $)
  nnacan $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                   ( ( A +o B ) = ( A +o C ) <-> B = C ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB coa co cA cC coa co wceq cB cC
    wceq wb cA com wcel cB com wcel cC com wcel cA cB cC oacan cA nnon cB nnon
    cC nnon syl3an $.
    $( [27-Oct-1995] $)

  $( Weak ordering property of addition. $)
  nnaword $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                ( A C_ B <-> ( C +o A ) C_ ( C +o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB wss cC cA coa co cC cB coa co
    wss wb cA com wcel cB com wcel cC com wcel cA cB cC oaword cA nnon cB nnon
    cC nnon syl3an $.
    $( [17-Sep-1995] $)

  $( Weak ordering property of addition. $)
  nnaword1 $p |- ( ( A e. om /\ B e. om ) -> A C_ ( A +o B ) ) $=
    cA con0 wcel cB con0 wcel cA cA cB coa co wss cA com wcel cB com wcel cA cB
    oaword1 cA nnon cB nnon syl2an $.
    $( [9-Nov-2002] $)

  $( Weak ordering property of addition. $)
  nnaword2 $p |- ( ( A e. om /\ B e. om ) -> A C_ ( B +o A ) ) $=
    cA com wcel cB com wcel wa cA cA cB coa co cB cA coa co cA cB nnaword1 cA
    cB nnacom sseqtrd $.
    $( [9-Nov-2002] $)

  $( Ordering property of multiplication.  Half of Proposition 8.19 of
     [TakeutiZaring] p. 63, limited to natural numbers. $)
  nnmordi $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
               ( ( A e. B /\ (/) e. C ) -> ( C .o A ) e. ( C .o B ) ) ) $=
    cB com wcel cC com wcel cA cB wcel c0 cC wcel wa cC cA comu co cC cB comu
    co wcel wi cA com wcel cB com wcel cC com wcel wa cA cB wcel c0 cC wcel cC
    cA comu co cC cB comu co wcel cB com wcel cC com wcel wa c0 cC wcel cA cB
    wcel cC cA comu co cC cB comu co wcel cB con0 wcel cC con0 wcel c0 cC wcel
    cA cB wcel cC cA comu co cC cB comu co wcel wi wi cB com wcel cC com wcel
    cB con0 wcel cC con0 wcel wa c0 cC wcel cA cB wcel cC cA comu co cC cB comu
    co wcel wi cA cB cC omordi ex cB nnon cC nnon syl2an com23 imp3a 3adant1 $.
    $( [18-Sep-1995] $)

  $( Ordering property of multiplication.  Proposition 8.19 of
     [TakeutiZaring] p. 63, limited to natural numbers. $)
  nnmord $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
               ( ( A e. B /\ (/) e. C ) <-> ( C .o A ) e. ( C .o B ) ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel cA cB wcel c0 cC wcel wa cC cA comu
    co cC cB comu co wcel wb cA com wcel cB com wcel cC com wcel cA cB cC omord
    cA nnon cB nnon cC nnon syl3an $.
    $( [22-Jan-1996] $)

  $( Cancellation law for multiplication of natural numbers. $)
  nnmcan $p |- ( ( ( A e. om /\ B e. om /\ C e. om ) /\ (/) e. A ) ->
                   ( ( A .o B ) = ( A .o C ) <-> B = C ) ) $=
    cA con0 wcel cB con0 wcel cC con0 wcel c0 cA wcel cA cB comu co cA cC comu
    co wceq cB cC wceq wb cA com wcel cB com wcel cC com wcel cA cB cC omcan cA
    nnon cB nnon cC nnon syl3anl $.
    $( [26-Oct-1995] $)

  ${
    $d x A $.  $d x B $.
    $( Equivalence for ordering.  Compare Exercise 23 of [Enderton] p. 88. $)
    nnaordex $p |- ( ( A e. om /\ B e. om ) -> ( A e. B <->
                  E. x e. om ( (/) e. x /\ ( A +o x ) = B ) ) ) $=
      cA con0 wcel cB com wcel cA cB wcel c0 vx cv wcel cA vx cv coa co cB wceq
      wa vx com wrex wb cA com wcel cA con0 wcel cB com wcel wa cA cB wcel c0
      vx cv wcel cA vx cv coa co cB wceq wa vx con0 wrex c0 vx cv wcel cA vx cv
      coa co cB wceq wa vx com wrex cA con0 wcel cB con0 wcel cA cB wcel c0 vx
      cv wcel cA vx cv coa co cB wceq wa vx con0 wrex wb cB com wcel vx cA cB
      oaordex cB nnon sylan2 cA con0 wcel cB com wcel wa c0 vx cv wcel cA vx cv
      coa co cB wceq wa c0 vx cv wcel cA vx cv coa co cB wceq wa vx con0 com cA
      con0 wcel cB com wcel wa vx cv con0 wcel c0 vx cv wcel cA vx cv coa co cB
      wceq wa wa vx cv com wcel c0 vx cv wcel cA vx cv coa co cB wceq wa wa cA
      con0 wcel cB com wcel wa vx cv con0 wcel c0 vx cv wcel cA vx cv coa co cB
      wceq wa wa vx cv com wcel c0 vx cv wcel cA vx cv coa co cB wceq wa cA
      con0 wcel cB com wcel vx cv con0 wcel c0 vx cv wcel cA vx cv coa co cB
      wceq wa vx cv com wcel cA con0 wcel c0 vx cv wcel cA vx cv coa co cB wceq
      wa vx cv con0 wcel cB com wcel vx cv com wcel cA con0 wcel cA vx cv coa
      co cB wceq vx cv con0 wcel cB com wcel vx cv com wcel wi wi c0 vx cv wcel
      cA con0 wcel vx cv con0 wcel cA vx cv coa co cB wceq cB com wcel vx cv
      com wcel wi cA con0 wcel vx cv con0 wcel cA vx cv coa co cB wceq cB com
      wcel vx cv com wcel wi cA con0 wcel vx cv con0 wcel wa cA vx cv coa co cB
      wceq wa cB com wcel cA com wcel vx cv com wcel wa vx cv com wcel cA vx cv
      coa co cB wceq cB com wcel cA vx cv coa co com wcel cA con0 wcel vx cv
      con0 wcel wa cA com wcel vx cv com wcel wa cA vx cv coa co cB wceq cA vx
      cv coa co com wcel cB com wcel cA vx cv coa co cB com eleq1 bicomd cA vx
      cv nnarcl sylan9bbr cA com wcel vx cv com wcel pm3.27 syl6bi exp31 com23
      adantld com24 imp4b vx cv con0 wcel c0 vx cv wcel cA vx cv coa co cB wceq
      wa wa c0 vx cv wcel cA vx cv coa co cB wceq wa wi cA con0 wcel cB com
      wcel wa vx cv con0 wcel c0 vx cv wcel cA vx cv coa co cB wceq wa pm3.27
      a1i jcad vx cv com wcel vx cv con0 wcel c0 vx cv wcel cA vx cv coa co cB
      wceq wa vx cv nnon anim1i impbid1 rexbidv2 bitrd cA nnon sylan $.
      $( [5-Dec-1995] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Equivalence for weak ordering of natural numbers. $)
    nnawordex $p |- ( ( A e. om /\ B e. om ) -> ( A C_ B <->
                  E. x e. om ( A +o x ) = B ) ) $=
      cA con0 wcel cB com wcel cA cB wss cA vx cv coa co cB wceq vx com wrex wb
      cA com wcel cA con0 wcel cB com wcel wa cA cB wss cA vx cv coa co cB wceq
      vx con0 wrex cA vx cv coa co cB wceq vx com wrex cA con0 wcel cB con0
      wcel cA cB wss cA vx cv coa co cB wceq vx con0 wrex wb cB com wcel vx cA
      cB oawordex cB nnon sylan2 cA con0 wcel cB com wcel wa cA vx cv coa co cB
      wceq cA vx cv coa co cB wceq vx con0 com cA con0 wcel cB com wcel wa vx
      cv con0 wcel cA vx cv coa co cB wceq wa vx cv com wcel cA vx cv coa co cB
      wceq wa cA con0 wcel cB com wcel wa vx cv con0 wcel cA vx cv coa co cB
      wceq wa vx cv com wcel cA vx cv coa co cB wceq cA con0 wcel cB com wcel
      vx cv con0 wcel cA vx cv coa co cB wceq vx cv com wcel cA con0 wcel cA vx
      cv coa co cB wceq vx cv con0 wcel cB com wcel vx cv com wcel cA con0 wcel
      vx cv con0 wcel cA vx cv coa co cB wceq cB com wcel vx cv com wcel wi cA
      con0 wcel vx cv con0 wcel cA vx cv coa co cB wceq cB com wcel vx cv com
      wcel wi cA con0 wcel vx cv con0 wcel wa cA vx cv coa co cB wceq wa cB com
      wcel cA com wcel vx cv com wcel wa vx cv com wcel cA vx cv coa co cB wceq
      cB com wcel cA vx cv coa co com wcel cA con0 wcel vx cv con0 wcel wa cA
      com wcel vx cv com wcel wa cA vx cv coa co cB wceq cA vx cv coa co com
      wcel cB com wcel cA vx cv coa co cB com eleq1 bicomd cA vx cv nnarcl
      sylan9bbr cA com wcel vx cv com wcel pm3.27 syl6bi exp31 com23 com24
      imp4b vx cv con0 wcel cA vx cv coa co cB wceq wa cA vx cv coa co cB wceq
      wi cA con0 wcel cB com wcel wa vx cv con0 wcel cA vx cv coa co cB wceq
      pm3.27 a1i jcad vx cv com wcel vx cv con0 wcel cA vx cv coa co cB wceq vx
      cv nnon anim1i impbid1 rexbidv2 bitrd cA nnon sylan $.
      $( [8-Nov-2002] $)
  $}

  ${
    $d x y A $.  $d x B $.
    $( Lemma for ~ oaabs . $)
    oaabslem $p |- ( ( om e. On /\ A e. om ) -> ( A +o om ) = om ) $=
      com con0 wcel cA com wcel wa cA com coa co com cA com wcel com con0 wcel
      cA com coa co com wss cA com wcel com con0 wcel wa cA com coa co vx com
      cA vx cv coa co ciun com cA con0 wcel com con0 wcel com wlim wa cA com
      coa co vx com cA vx cv coa co ciun wceq cA com wcel com con0 wcel vx cA
      com con0 oalim cA nnon com con0 wcel com wlim limom jctr syl2an cA com
      wcel vx com cA vx cv coa co ciun com wss com con0 wcel cA com wcel cA vx
      cv coa co com wss vx com wral vx com cA vx cv coa co ciun com wss cA com
      wcel cA vx cv coa co com wss vx com com word cA vx cv coa co com wcel cA
      vx cv coa co com wss cA com wcel vx cv com wcel wa com cA vx cv coa co
      ordelss ordom cA vx cv nnacl sylancr r19.21aiva vx com cA vx cv coa co
      com iunss sylibr adantr eqsstrd ancoms com con0 wcel cA con0 wcel com cA
      com coa co wss cA com wcel com cA oaword2 cA nnon sylan2 eqssd $.
      $( [3-Mar-2005] $) $( [9-Dec-2004] $)

    $( Ordinal addition absorbs a natural number added to the left of a
       transfinite number.  Proposition 8.10 of [TakeutiZaring] p. 59. $)
    oaabs $p |- ( ( ( A e. om /\ B e. On ) /\ om C_ B ) -> ( A +o B ) = B ) $=
      cA com wcel cB con0 wcel com cB wss cA cB coa co cB wceq cB con0 wcel com
      cB wss cA com wcel cA cB coa co cB wceq cB con0 wcel com cB wss cA com
      wcel cA cB coa co cB wceq wi cB con0 wcel com cB wss wa com con0 wcel cA
      com wcel cA cB coa co cB wceq wi cB con0 wcel com cB wss com con0 wcel
      com cB wss cB con0 wcel com cvv wcel com con0 wcel com cB wss cB con0
      wcel com cvv wcel com cB con0 ssexg ex com cvv wcel com con0 wcel com
      word ordom com cvv elong mpbiri syl6com imp cB con0 wcel com con0 wcel
      com cB wss cA com wcel cA cB coa co cB wceq wi cA com wcel cA vx cv coa
      co vx cv wceq wi cA com wcel cA com coa co com wceq wi cA com wcel cA vy
      cv coa co vy cv wceq wi cA com wcel cA vy cv csuc coa co vy cv csuc wceq
      wi cA com wcel cA cB coa co cB wceq wi vx vy cB com vx cv com wceq cA vx
      cv coa co vx cv wceq cA com coa co com wceq cA com wcel vx cv com wceq cA
      vx cv coa co cA com coa co vx cv com vx cv com cA coa opreq2 vx cv com
      wceq id eqeq12d imbi2d vx cv vy cv wceq cA vx cv coa co vx cv wceq cA vy
      cv coa co vy cv wceq cA com wcel vx cv vy cv wceq cA vx cv coa co cA vy
      cv coa co vx cv vy cv vx cv vy cv cA coa opreq2 vx cv vy cv wceq id
      eqeq12d imbi2d vx cv vy cv csuc wceq cA vx cv coa co vx cv wceq cA vy cv
      csuc coa co vy cv csuc wceq cA com wcel vx cv vy cv csuc wceq cA vx cv
      coa co cA vy cv csuc coa co vx cv vy cv csuc vx cv vy cv csuc cA coa
      opreq2 vx cv vy cv csuc wceq id eqeq12d imbi2d vx cv cB wceq cA vx cv coa
      co vx cv wceq cA cB coa co cB wceq cA com wcel vx cv cB wceq cA vx cv coa
      co cA cB coa co vx cv cB vx cv cB cA coa opreq2 vx cv cB wceq id eqeq12d
      imbi2d com con0 wcel cA com wcel cA com coa co com wceq cA oaabslem ex vy
      cv con0 wcel com con0 wcel wa com vy cv wss wa cA com wcel cA vy cv coa
      co vy cv wceq cA vy cv csuc coa co vy cv csuc wceq vy cv con0 wcel cA com
      wcel cA vy cv coa co vy cv wceq cA vy cv csuc coa co vy cv csuc wceq wi
      wi com con0 wcel com vy cv wss cA com wcel vy cv con0 wcel cA vy cv coa
      co vy cv wceq cA vy cv csuc coa co vy cv csuc wceq wi cA com wcel vy cv
      con0 wcel cA vy cv coa co vy cv wceq cA vy cv csuc coa co vy cv csuc wceq
      cA com wcel vy cv con0 wcel wa cA vy cv coa co vy cv wceq cA vy cv csuc
      coa co cA vy cv coa co csuc vy cv csuc cA con0 wcel vy cv con0 wcel cA vy
      cv csuc coa co cA vy cv coa co csuc wceq cA com wcel cA vy cv oasuc cA
      nnon sylan cA vy cv coa co vy cv suceq sylan9eq exp31 com12 ad2antrr a2d
      vx cv wlim com vx cv wss com con0 wcel com vy cv wss cA com wcel cA vy cv
      coa co vy cv wceq wi wi vy vx cv wral cA com wcel cA vx cv coa co vx cv
      wceq wi wi com con0 wcel vx cv wlim com vx cv wss wa com vy cv wss cA com
      wcel cA vy cv coa co vy cv wceq wi wi vy vx cv wral cA com wcel cA vx cv
      coa co vx cv wceq wi wi vx cv wlim com vx cv wss wa com vy cv wss cA com
      wcel cA vy cv coa co vy cv wceq wi wi vy vx cv wral cA com wcel com con0
      wcel cA vx cv coa co vx cv wceq vx cv wlim com vx cv wss wa cA com wcel
      com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral wi cA com wcel
      com con0 wcel cA vx cv coa co vx cv wceq wi wi com vy cv wss cA com wcel
      cA vy cv coa co vy cv wceq wi wi vy vx cv wral vx cv wlim com vx cv wss
      wa cA com wcel com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral
      com con0 wcel cA vx cv coa co vx cv wceq wi vx cv wlim com vx cv wss wa
      com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral cA com wcel com
      con0 wcel cA vx cv coa co vx cv wceq wi vx cv wlim com vx cv wss wa com
      vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral cA com wcel com
      con0 wcel cA vx cv coa co vx cv wceq vx cv wlim com vx cv wss wa com vy
      cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral wa cA com wcel com
      con0 wcel wa wa vy com cA vy cv coa co ciun vy vx cv com cdif cA vy cv
      coa co ciun cun com cuni vx cv com cdif cuni cun cA vx cv coa co vx cv vx
      cv wlim com vx cv wss wa com vy cv wss cA vy cv coa co vy cv wceq wi vy
      vx cv wral wa cA com wcel com con0 wcel wa wa vy com cA vy cv coa co ciun
      com cuni vy vx cv com cdif cA vy cv coa co ciun vx cv com cdif cuni cA
      com wcel com con0 wcel wa vy com cA vy cv coa co ciun com cuni wceq vx cv
      wlim com vx cv wss wa com vy cv wss cA vy cv coa co vy cv wceq wi vy vx
      cv wral wa cA com wcel com con0 wcel wa cA com coa co vy com cA vy cv coa
      co ciun com cuni cA con0 wcel com con0 wcel com wlim wa cA com coa co vy
      com cA vy cv coa co ciun wceq cA com wcel com con0 wcel vy cA com con0
      oalim cA nnon com con0 wcel com wlim limom jctr syl2an cA com wcel com
      con0 wcel wa cA com coa co com com cuni com con0 wcel cA com wcel cA com
      coa co com wceq cA oaabslem ancoms com wlim com com cuni wceq limom com
      limuni ax-mp syl6eq eqtr3d adantl vx cv wlim com vx cv wss wa com vy cv
      wss cA vy cv coa co vy cv wceq wi vy vx cv wral wa vy vx cv com cdif cA
      vy cv coa co ciun vx cv com cdif cuni wceq cA com wcel com con0 wcel wa
      vx cv wlim com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral vy
      vx cv com cdif cA vy cv coa co ciun vx cv com cdif cuni wceq com vx cv
      wss vx cv wlim com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral
      vy vx cv com cdif cA vy cv coa co ciun vx cv com cdif cuni wceq vx cv
      wlim com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral cA vy cv
      coa co vy cv wceq vy vx cv com cdif wral vy vx cv com cdif cA vy cv coa
      co ciun vx cv com cdif cuni wceq vx cv wlim com vy cv wss cA vy cv coa co
      vy cv wceq wi cA vy cv coa co vy cv wceq vy vx cv vx cv com cdif vx cv
      wlim vy cv vx cv wcel com vy cv wss wa cA vy cv coa co vy cv wceq wi vy
      cv vx cv com cdif wcel cA vy cv coa co vy cv wceq wi vy cv vx cv wcel com
      vy cv wss cA vy cv coa co vy cv wceq wi wi vx cv wlim vy cv vx cv wcel
      com vy cv wss wa vy cv vx cv com cdif wcel cA vy cv coa co vy cv wceq vx
      cv wlim vy cv vx cv wcel com vy cv wss wa vy cv vx cv wcel vy cv com wcel
      wn wa vy cv vx cv com cdif wcel vx cv wlim vy cv vx cv wcel com vy cv wss
      vy cv com wcel wn vx cv wlim vy cv vx cv wcel wa vy cv con0 wcel vy cv
      word com vy cv wss vy cv com wcel wn wb vx cv word vy cv vx cv wcel vy cv
      con0 wcel vx cv wlim vx cv vy cv ordelon vx cv limord sylan vy cv eloni
      com word vy cv word com vy cv wss vy cv com wcel wn wb ordom com vy cv
      ordtri1 mpan 3syl pm5.32da vy cv vx cv com eldif syl6bbr imbi1d vy cv vx
      cv wcel com vy cv wss cA vy cv coa co vy cv wceq impexp syl5bbr ralbidv2
      cA vy cv coa co vy cv wceq vy vx cv com cdif wral vy vx cv com cdif cA vy
      cv coa co ciun vy vx cv com cdif vy cv ciun vx cv com cdif cuni vy vx cv
      com cdif cA vy cv coa co vy cv iuneq2 vy vx cv com cdif uniiun syl6eqr
      syl6bi imp adantlr adantr uneq12d vx cv wlim com vx cv wss wa cA com wcel
      cA vx cv coa co vy com cA vy cv coa co ciun vy vx cv com cdif cA vy cv
      coa co ciun cun wceq com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv
      wral com con0 wcel vx cv wlim cA com wcel com vx cv wss cA vx cv coa co
      vy com cA vy cv coa co ciun vy vx cv com cdif cA vy cv coa co ciun cun
      wceq vx cv wlim cA com wcel wa com vx cv wss cA vx cv coa co vy vx cv cA
      vy cv coa co ciun vy com cA vy cv coa co ciun vy vx cv com cdif cA vy cv
      coa co ciun cun cA com wcel vx cv wlim cA vx cv coa co vy vx cv cA vy cv
      coa co ciun wceq cA con0 wcel vx cv cvv wcel vx cv wlim wa cA vx cv coa
      co vy vx cv cA vy cv coa co ciun wceq cA com wcel vx cv wlim vy cA vx cv
      cvv oalim cA nnon vx cv wlim vx cv cvv wcel vx visset jctl syl2an ancoms
      com vx cv wss vy com vx cv com cdif cun cA vy cv coa co ciun vy vx cv cA
      vy cv coa co ciun vy com cA vy cv coa co ciun vy vx cv com cdif cA vy cv
      coa co ciun cun com vx cv wss com vx cv com cdif cun vx cv wceq vy com vx
      cv com cdif cun cA vy cv coa co ciun vy vx cv cA vy cv coa co ciun wceq
      com vx cv wss com vx cv cun vx cv com vx cv com cdif cun com vx cv wss
      com vx cv cun vx cv wceq com vx cv ssequn1 biimpi com vx cv undif2 syl5eq
      vy com vx cv com cdif cun vx cv cA vy cv coa co iuneq1 syl vy com vx cv
      com cdif cA vy cv coa co iunxun syl5reqr sylan9eq an1rs ad2ant2r vx cv
      wlim com vx cv wss wa vx cv com cuni vx cv com cdif cuni cun wceq com vy
      cv wss cA vy cv coa co vy cv wceq wi vy vx cv wral cA com wcel com con0
      wcel wa vx cv wlim com vx cv wss vx cv vx cv cuni com cuni vx cv com cdif
      cuni cun vx cv limuni com vx cv wss com vx cv com cdif cun cuni vx cv
      cuni com cuni vx cv com cdif cuni cun com vx cv wss com vx cv com cdif
      cun vx cv com vx cv wss com vx cv cun vx cv com vx cv com cdif cun com vx
      cv wss com vx cv cun vx cv wceq com vx cv ssequn1 biimpi com vx cv undif2
      syl5eq unieqd com vx cv com cdif uniun syl5reqr sylan9eq ad2antrr 3eqtr4d
      exp43 com23 a2d com vy cv wss cA com wcel cA vy cv coa co vy cv wceq wi
      wi vy vx cv wral cA com wcel com vy cv wss cA vy cv coa co vy cv wceq wi
      wi vy vx cv wral cA com wcel com vy cv wss cA vy cv coa co vy cv wceq wi
      vy vx cv wral wi com vy cv wss cA com wcel cA vy cv coa co vy cv wceq wi
      wi cA com wcel com vy cv wss cA vy cv coa co vy cv wceq wi wi vy vx cv
      com vy cv wss cA com wcel cA vy cv coa co vy cv wceq bi2.04 ralbii cA com
      wcel com vy cv wss cA vy cv coa co vy cv wceq wi vy vx cv r19.21v bitri
      syl5ib com4r impcom an1rs tfindsg an1rs mpdan ex com3r imp31 $.
      $( [3-Mar-2005] $) $( [9-Dec-2004] $)
  $}

  $( One is a natural number. $)
  1onn $p |- 1o e. om $=
    c1o c0 csuc com df-1o c0 com wcel c0 csuc com wcel peano1 c0 peano2 ax-mp
    eqeltri $.
    $( [29-Oct-1995] $)

  $( The ordinal 2 is a natural number. $)
  2onn $p |- 2o e. om $=
    c2o c1o csuc com df-2o c1o com wcel c1o csuc com wcel 1onn c1o peano2 ax-mp
    eqeltri $.
    $( [6-Oct-2004] $) $( [28-Sep-2004] $)

  ${
    $d x y z A $.
    $( A natural number is even iff its successor is odd. $)
    nneob $p |- ( A e. om ->
      ( E. x e. om A = ( 2o .o x ) <-> -. E. x e. om suc A = ( 2o .o x ) ) ) $=
      cA com wcel cA c2o vx cv comu co wceq vx com wrex cA csuc c2o vx cv comu
      co wceq vx com wrex wn cA c2o vx cv comu co wceq vx com wrex cA c2o vy cv
      comu co wceq vy com wrex cA csuc c2o vx cv comu co wceq vx com wrex wn cA
      c2o vx cv comu co wceq cA c2o vy cv comu co wceq vx vy com vx cv vy cv
      wceq c2o vx cv comu co c2o vy cv comu co cA vx cv vy cv c2o comu opreq2
      eqeq2d cbvrexv cA c2o vy cv comu co wceq cA csuc c2o vx cv comu co wceq
      vx com wrex wn vy com vy cv com wcel cA c2o vy cv comu co wceq wa cA csuc
      c2o vx cv comu co wceq vx com vy cv com wcel cA c2o vy cv comu co wceq vx
      cv com wcel cA csuc c2o vx cv comu co wceq wn vy cv com wcel vx cv com
      wcel cA c2o vy cv comu co wceq cA csuc c2o vx cv comu co wceq wn vy cv
      con0 wcel vx cv con0 wcel cA c2o vy cv comu co wceq cA csuc c2o vx cv
      comu co wceq wn vy cv com wcel vx cv com wcel cA c2o vy cv comu co wceq
      vy cv vx cv cA oneo vy cv nnon vx cv nnon cA c2o vy cv comu co wceq id
      syl3an 3com23 3expa nrexdv r19.23aiva sylbi vy cv csuc c2o vx cv comu co
      wceq vx com wrex wn vy cv c2o vx cv comu co wceq vx com wrex wi c0 csuc
      c2o vx cv comu co wceq vx com wrex wn c0 c2o vx cv comu co wceq vx com
      wrex wi vz cv csuc c2o vx cv comu co wceq vx com wrex wn vz cv c2o vx cv
      comu co wceq vx com wrex wi vz cv csuc csuc c2o vx cv comu co wceq vx com
      wrex wn vz cv csuc c2o vx cv comu co wceq vx com wrex wi cA csuc c2o vx
      cv comu co wceq vx com wrex wn cA c2o vx cv comu co wceq vx com wrex wi
      vy vz cA vy cv c0 wceq vy cv csuc c2o vx cv comu co wceq vx com wrex wn
      c0 csuc c2o vx cv comu co wceq vx com wrex wn vy cv c2o vx cv comu co
      wceq vx com wrex c0 c2o vx cv comu co wceq vx com wrex vy cv c0 wceq vy
      cv csuc c2o vx cv comu co wceq vx com wrex c0 csuc c2o vx cv comu co wceq
      vx com wrex vy cv c0 wceq vy cv csuc c2o vx cv comu co wceq c0 csuc c2o
      vx cv comu co wceq vx com vy cv c0 wceq vy cv csuc c0 csuc c2o vx cv comu
      co vy cv c0 suceq eqeq1d rexbidv notbid vy cv c0 wceq vy cv c2o vx cv
      comu co wceq c0 c2o vx cv comu co wceq vx com vy cv c0 c2o vx cv comu co
      eqeq1 rexbidv imbi12d vy cv vz cv wceq vy cv csuc c2o vx cv comu co wceq
      vx com wrex wn vz cv csuc c2o vx cv comu co wceq vx com wrex wn vy cv c2o
      vx cv comu co wceq vx com wrex vz cv c2o vx cv comu co wceq vx com wrex
      vy cv vz cv wceq vy cv csuc c2o vx cv comu co wceq vx com wrex vz cv csuc
      c2o vx cv comu co wceq vx com wrex vy cv vz cv wceq vy cv csuc c2o vx cv
      comu co wceq vz cv csuc c2o vx cv comu co wceq vx com vy cv vz cv wceq vy
      cv csuc vz cv csuc c2o vx cv comu co vy cv vz cv suceq eqeq1d rexbidv
      notbid vy cv vz cv wceq vy cv c2o vx cv comu co wceq vz cv c2o vx cv comu
      co wceq vx com vy cv vz cv c2o vx cv comu co eqeq1 rexbidv imbi12d vy cv
      vz cv csuc wceq vy cv csuc c2o vx cv comu co wceq vx com wrex wn vz cv
      csuc csuc c2o vx cv comu co wceq vx com wrex wn vy cv c2o vx cv comu co
      wceq vx com wrex vz cv csuc c2o vx cv comu co wceq vx com wrex vy cv vz
      cv csuc wceq vy cv csuc c2o vx cv comu co wceq vx com wrex vz cv csuc
      csuc c2o vx cv comu co wceq vx com wrex vy cv vz cv csuc wceq vy cv csuc
      c2o vx cv comu co wceq vz cv csuc csuc c2o vx cv comu co wceq vx com vy
      cv vz cv csuc wceq vy cv csuc vz cv csuc csuc c2o vx cv comu co vy cv vz
      cv csuc suceq eqeq1d rexbidv notbid vy cv vz cv csuc wceq vy cv c2o vx cv
      comu co wceq vz cv csuc c2o vx cv comu co wceq vx com vy cv vz cv csuc
      c2o vx cv comu co eqeq1 rexbidv imbi12d vy cv cA wceq vy cv csuc c2o vx
      cv comu co wceq vx com wrex wn cA csuc c2o vx cv comu co wceq vx com wrex
      wn vy cv c2o vx cv comu co wceq vx com wrex cA c2o vx cv comu co wceq vx
      com wrex vy cv cA wceq vy cv csuc c2o vx cv comu co wceq vx com wrex cA
      csuc c2o vx cv comu co wceq vx com wrex vy cv cA wceq vy cv csuc c2o vx
      cv comu co wceq cA csuc c2o vx cv comu co wceq vx com vy cv cA wceq vy cv
      csuc cA csuc c2o vx cv comu co vy cv cA suceq eqeq1d rexbidv notbid vy cv
      cA wceq vy cv c2o vx cv comu co wceq cA c2o vx cv comu co wceq vx com vy
      cv cA c2o vx cv comu co eqeq1 rexbidv imbi12d c0 c2o vx cv comu co wceq
      vx com wrex c0 csuc c2o vx cv comu co wceq vx com wrex wn c0 com wcel c0
      c0 wceq c0 c2o vx cv comu co wceq vx com wrex peano1 c0 eqid c0 c2o vx cv
      comu co wceq c0 c0 wceq vx c0 com vx cv c0 wceq c2o vx cv comu co c0 c0
      vx cv c0 wceq c2o vx cv comu co c2o c0 comu co c0 vx cv c0 c2o comu
      opreq2 c2o con0 wcel c2o c0 comu co c0 wceq 2on c2o om0 ax-mp syl6eq
      eqeq2d rcla4ev mp2an a1i vz cv com wcel vz cv csuc csuc c2o vx cv comu co
      wceq vx com wrex wn vz cv c2o vx cv comu co wceq vx com wrex wn vz cv
      csuc c2o vx cv comu co wceq vx com wrex wn vz cv c2o vx cv comu co wceq
      vx com wrex wi vz cv csuc c2o vx cv comu co wceq vx com wrex vz cv com
      wcel vz cv c2o vx cv comu co wceq vx com wrex vz cv csuc csuc c2o vx cv
      comu co wceq vx com wrex vz cv com wcel vz cv c2o vy cv comu co wceq vy
      com wrex vz cv csuc csuc c2o vx cv comu co wceq vx com wrex vz cv c2o vx
      cv comu co wceq vx com wrex vz cv com wcel vz cv c2o vy cv comu co wceq
      vz cv csuc csuc c2o vx cv comu co wceq vx com wrex vy com vz cv com wcel
      vy cv com wcel wa vz cv c2o vy cv comu co wceq vy cv c1o coa co com wcel
      vz cv csuc csuc c2o vy cv c1o coa co comu co wceq wa vz cv csuc csuc c2o
      vx cv comu co wceq vx com wrex vz cv com wcel vy cv com wcel wa vz cv c2o
      vy cv comu co wceq vz cv csuc csuc c2o vy cv c1o coa co comu co wceq vy
      cv c1o coa co com wcel vz cv com wcel vy cv com wcel wa vz cv c2o vy cv
      comu co wceq vz cv csuc csuc c2o vy cv c1o coa co comu co wceq vz cv com
      wcel vy cv com wcel wa vz cv c2o vy cv comu co wceq wa vz cv csuc csuc vz
      cv c2o coa co c2o vy cv c1o coa co comu co vz cv com wcel vz cv csuc csuc
      vz cv c2o coa co wceq vy cv com wcel vz cv c2o vy cv comu co wceq vz cv
      com wcel vz cv c2o coa co vz cv csuc csuc vz cv com wcel vz cv con0 wcel
      vz cv c2o coa co vz cv csuc csuc wceq vz cv nnon vz cv con0 wcel vz cv
      c2o coa co vz cv c1o coa co c1o coa co vz cv csuc c1o coa co vz cv csuc
      csuc vz cv con0 wcel vz cv c1o coa co c1o coa co vz cv c1o c1o coa co coa
      co vz cv c2o coa co vz cv con0 wcel c1o con0 wcel c1o con0 wcel vz cv c1o
      coa co c1o coa co vz cv c1o c1o coa co coa co wceq 1on 1on vz cv c1o c1o
      oaass mp3an23 c1o c1o coa co c2o vz cv coa o1p1e2 opreq2i syl6req vz cv
      con0 wcel vz cv c1o coa co vz cv csuc c1o coa vz cv oa1suc opreq1d vz cv
      con0 wcel vz cv csuc con0 wcel vz cv csuc c1o coa co vz cv csuc csuc wceq
      vz cv suceloni vz cv csuc oa1suc syl 3eqtrd syl eqcomd ad2antrr vy cv com
      wcel vz cv c2o vy cv comu co wceq vz cv c2o coa co c2o vy cv c1o coa co
      comu co wceq vz cv com wcel vz cv c2o vy cv comu co wceq vy cv com wcel
      vz cv c2o coa co c2o vy cv comu co c2o coa co c2o vy cv c1o coa co comu
      co vz cv c2o vy cv comu co c2o coa opreq1 vy cv com wcel c2o vy cv c1o
      coa co comu co c2o vy cv comu co c2o c1o comu co coa co c2o vy cv comu co
      c2o coa co c2o com wcel vy cv com wcel c1o com wcel c2o vy cv c1o coa co
      comu co c2o vy cv comu co c2o c1o comu co coa co wceq 2onn 1onn c2o vy cv
      c1o nndi mp3an13 c2o c1o comu co c2o c2o vy cv comu co coa c2o con0 wcel
      c2o c1o comu co c2o wceq 2on c2o om1 ax-mp opreq2i syl6req sylan9eqr
      adantll eqtrd ex vy cv com wcel vy cv c1o coa co com wcel vz cv com wcel
      vy cv com wcel c1o com wcel vy cv c1o coa co com wcel 1onn vy cv c1o
      nnacl mpan2 adantl jctild vz cv csuc csuc c2o vx cv comu co wceq vz cv
      csuc csuc c2o vy cv c1o coa co comu co wceq vx vy cv c1o coa co com vx cv
      vy cv c1o coa co wceq c2o vx cv comu co c2o vy cv c1o coa co comu co vz
      cv csuc csuc vx cv vy cv c1o coa co c2o comu opreq2 eqeq2d rcla4ev syl6
      r19.23adva vz cv c2o vx cv comu co wceq vz cv c2o vy cv comu co wceq vx
      vy com vx cv vy cv wceq c2o vx cv comu co c2o vy cv comu co vz cv vx cv
      vy cv c2o comu opreq2 eqeq2d cbvrexv syl5ib con3d vz cv csuc c2o vx cv
      comu co wceq vx com wrex vz cv c2o vx cv comu co wceq vx com wrex con1
      syl9 finds impbid2 $.
      $( [26-Jan-2006] $) $( [26-Jan-2006] $)
  $}

  ${
    $d x y z w v A $.  $d x y z w v F $.
    $( Lemma for ~ omsmo . $)
    omsmolem $p |- ( y e. om -> ( ( ( A C_ On /\ F : om --> A ) /\
        A. x e. om ( F ` x ) e. ( F ` suc x ) ) ->
       ( z e. y -> ( F ` z ) e. ( F ` y ) ) ) ) $=
      vz cv vy cv wcel vz cv cF cfv vy cv cF cfv wcel wi vz cv c0 wcel vz cv cF
      cfv c0 cF cfv wcel wi vz cv vw cv wcel vz cv cF cfv vw cv cF cfv wcel wi
      vz cv vw cv csuc wcel vz cv cF cfv vw cv csuc cF cfv wcel wi cA con0 wss
      com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx com wral wa vy vw
      vy cv c0 wceq vz cv vy cv wcel vz cv c0 wcel vz cv cF cfv vy cv cF cfv
      wcel vz cv cF cfv c0 cF cfv wcel vy cv c0 vz cv eleq2 vy cv c0 wceq vy cv
      cF cfv c0 cF cfv vz cv cF cfv vy cv c0 cF fveq2 eleq2d imbi12d vy cv vw
      cv wceq vz cv vy cv wcel vz cv vw cv wcel vz cv cF cfv vy cv cF cfv wcel
      vz cv cF cfv vw cv cF cfv wcel vy cv vw cv vz cv eleq2 vy cv vw cv wceq
      vy cv cF cfv vw cv cF cfv vz cv cF cfv vy cv vw cv cF fveq2 eleq2d
      imbi12d vy cv vw cv csuc wceq vz cv vy cv wcel vz cv vw cv csuc wcel vz
      cv cF cfv vy cv cF cfv wcel vz cv cF cfv vw cv csuc cF cfv wcel vy cv vw
      cv csuc vz cv eleq2 vy cv vw cv csuc wceq vy cv cF cfv vw cv csuc cF cfv
      vz cv cF cfv vy cv vw cv csuc cF fveq2 eleq2d imbi12d vz cv c0 wcel vz cv
      cF cfv c0 cF cfv wcel wi cA con0 wss com cA cF wf wa vx cv cF cfv vx cv
      csuc cF cfv wcel vx com wral wa vz cv c0 wcel vz cv cF cfv c0 cF cfv wcel
      vz cv noel pm2.21i a1i cA con0 wss com cA cF wf wa vx cv cF cfv vx cv
      csuc cF cfv wcel vx com wral wa vw cv com wcel vz cv vw cv wcel vz cv cF
      cfv vw cv cF cfv wcel wi vz cv vw cv csuc wcel vz cv cF cfv vw cv csuc cF
      cfv wcel wi wi cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv
      wcel vx com wral wa vw cv com wcel vz cv vw cv wcel vz cv cF cfv vw cv cF
      cfv wcel wi vz cv vw cv csuc wcel vz cv cF cfv vw cv csuc cF cfv wcel wi
      cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx com
      wral wa vw cv com wcel wa vz cv vw cv wcel vz cv cF cfv vw cv cF cfv wcel
      wi wa vz cv vw cv wcel vz cv vw cv wceq wo vz cv cF cfv vw cv csuc cF cfv
      wcel vz cv vw cv csuc wcel cA con0 wss com cA cF wf wa vx cv cF cfv vx cv
      csuc cF cfv wcel vx com wral wa vw cv com wcel wa vz cv vw cv wcel vz cv
      cF cfv vw cv cF cfv wcel wi wa vz cv vw cv wcel vz cv cF cfv vw cv csuc
      cF cfv wcel vz cv vw cv wceq cA con0 wss com cA cF wf wa vx cv cF cfv vx
      cv csuc cF cfv wcel vx com wral wa vw cv com wcel wa vz cv vw cv wcel vz
      cv cF cfv vw cv cF cfv wcel wi vz cv vw cv wcel vz cv cF cfv vw cv csuc
      cF cfv wcel wi cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv
      wcel vx com wral wa vw cv com wcel wa vz cv cF cfv vw cv cF cfv wcel vz
      cv cF cfv vw cv csuc cF cfv wcel vz cv vw cv wcel cA con0 wss com cA cF
      wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx com wral wa vw cv com wcel
      wa vw cv cF cfv vw cv csuc cF cfv wcel vz cv cF cfv vw cv cF cfv wcel vz
      cv cF cfv vw cv csuc cF cfv wcel wi vx cv cF cfv vx cv csuc cF cfv wcel
      vx com wral vw cv com wcel vw cv cF cfv vw cv csuc cF cfv wcel cA con0
      wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vw cv cF cfv vw
      cv csuc cF cfv wcel vx vw cv com vx cv vw cv wceq vx cv cF cfv vw cv cF
      cfv vx cv csuc cF cfv vw cv csuc cF cfv vx cv vw cv cF fveq2 vx cv vw cv
      wceq vx cv csuc vw cv csuc cF vx cv vw cv suceq fveq2d eleq12d rcla4cva
      adantll cA con0 wss com cA cF wf wa vw cv com wcel vw cv cF cfv vw cv
      csuc cF cfv wcel vz cv cF cfv vw cv cF cfv wcel vz cv cF cfv vw cv csuc
      cF cfv wcel wi wi vx cv cF cfv vx cv csuc cF cfv wcel vx com wral cA con0
      wss com cA cF wf vw cv com wcel vw cv cF cfv vw cv csuc cF cfv wcel vz cv
      cF cfv vw cv cF cfv wcel vz cv cF cfv vw cv csuc cF cfv wcel wi wi cA
      con0 wss com cA cF wf vw cv com wcel vw cv cF cfv vw cv csuc cF cfv wcel
      vz cv cF cfv vw cv cF cfv wcel vz cv cF cfv vw cv csuc cF cfv wcel wi wi
      cA con0 wss com cA cF wf vw cv com wcel wa vw cv csuc cF cfv con0 wcel vw
      cv cF cfv vw cv csuc cF cfv wcel vz cv cF cfv vw cv cF cfv wcel vz cv cF
      cfv vw cv csuc cF cfv wcel wi wi cA con0 wss vw cv csuc cF cfv cA wcel vw
      cv csuc cF cfv con0 wcel com cA cF wf vw cv com wcel wa cA con0 vw cv
      csuc cF cfv ssel com cA cF wf vw cv csuc com wcel vw cv csuc cF cfv cA
      wcel vw cv com wcel com cA vw cv csuc cF ffvelrn vw cv peano2b sylan2b
      syl5 vw cv csuc cF cfv con0 wcel vz cv cF cfv vw cv cF cfv wcel vw cv cF
      cfv vw cv csuc cF cfv wcel vz cv cF cfv vw cv csuc cF cfv wcel vw cv csuc
      cF cfv con0 wcel vz cv cF cfv vw cv cF cfv wcel vw cv cF cfv vw cv csuc
      cF cfv wcel vz cv cF cfv vw cv csuc cF cfv wcel vz cv cF cfv vw cv cF cfv
      vw cv csuc cF cfv ontr1 exp3a com23 syl6 exp3a imp31 adantlr mpd imim2d
      imp cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx
      com wral wa vw cv com wcel wa vz cv vw cv wceq vz cv cF cfv vw cv csuc cF
      cfv wcel wi vz cv vw cv wcel vz cv cF cfv vw cv cF cfv wcel wi vx cv cF
      cfv vx cv csuc cF cfv wcel vx com wral vw cv com wcel vz cv vw cv wceq vz
      cv cF cfv vw cv csuc cF cfv wcel wi cA con0 wss com cA cF wf wa vz cv vw
      cv wceq vz cv cF cfv vw cv csuc cF cfv wcel vw cv cF cfv vw cv csuc cF
      cfv wcel vx cv cF cfv vx cv csuc cF cfv wcel vx com wral vw cv com wcel
      wa vz cv vw cv wceq vz cv cF cfv vw cv cF cfv vw cv csuc cF cfv vz cv vw
      cv cF fveq2 eleq1d vx cv cF cfv vx cv csuc cF cfv wcel vw cv cF cfv vw cv
      csuc cF cfv wcel vx vw cv com vx cv vw cv wceq vx cv cF cfv vw cv cF cfv
      vx cv csuc cF cfv vw cv csuc cF cfv vx cv vw cv cF fveq2 vx cv vw cv wceq
      vx cv csuc vw cv csuc cF vx cv vw cv suceq fveq2d eleq12d rcla4cva
      syl5cbir adantll adantr jaod vz cv vw cv vz visset elsuc syl5ib exp31
      com12 finds2 $.
      $( [24-Jun-2004] $) $( [30-Nov-2003] $)

    $( A strictly monotonic ordinal function on the set of natural numbers
       is one-to-one. $)
    omsmo $p |- ( ( ( A C_ On /\ F : om --> A ) /\
          A. x e. om ( F ` x ) e. ( F ` suc x ) ) -> F : om -1-1-> A ) $=
      com cA cF wf1 com cA cF wf vy cv cF cfv vz cv cF cfv wceq vy cv vz cv
      wceq wi vz com wral vy com wral cA con0 wss com cA cF wf wa vx cv cF cfv
      vx cv csuc cF cfv wcel vx com wral wa vy vz com cA cF dff13 cA con0 wss
      com cA cF wf vx cv cF cfv vx cv csuc cF cfv wcel vx com wral simplr cA
      con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx com wral
      wa vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi vz com wral vy com
      cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx com
      wral wa vy cv com wcel vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi
      vz com cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx
      com wral wa vy cv com wcel vz cv com wcel vy cv cF cfv vz cv cF cfv wceq
      vy cv vz cv wceq wi cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc
      cF cfv wcel vx com wral wa vy cv com wcel vz cv com wcel wa wa vy cv cF
      cfv vz cv cF cfv wcel vz cv cF cfv vy cv cF cfv wcel wo wn vy cv vz cv
      wcel vz cv vy cv wcel wo wn vy cv cF cfv vz cv cF cfv wceq vy cv vz cv
      wceq cA con0 wss com cA cF wf wa vx cv cF cfv vx cv csuc cF cfv wcel vx
      com wral wa vy cv com wcel vz cv com wcel wa wa vy cv vz cv wcel vz cv vy
      cv wcel wo vy cv cF cfv vz cv cF cfv wcel vz cv cF cfv vy cv cF cfv wcel
      wo vy cv com wcel vz cv com wcel wa cA con0 wss com cA cF wf wa vx cv cF
      cfv vx cv csuc cF cfv wcel vx com wral wa vy cv vz cv wcel vz cv vy cv
      wcel wo vy cv cF cfv vz cv cF cfv wcel vz cv cF cfv vy cv cF cfv wcel wo
      wi vy cv com wcel vz cv com wcel wa cA con0 wss com cA cF wf wa vx cv cF
      cfv vx cv csuc cF cfv wcel vx com wral wa wa vy cv vz cv wcel vy cv cF
      cfv vz cv cF cfv wcel vz cv vy cv wcel vz cv cF cfv vy cv cF cfv wcel vy
      cv com wcel vz cv com wcel wa cA con0 wss com cA cF wf wa vx cv cF cfv vx
      cv csuc cF cfv wcel vx com wral wa vy cv vz cv wcel vy cv cF cfv vz cv cF
      cfv wcel wi vz cv com wcel cA con0 wss com cA cF wf wa vx cv cF cfv vx cv
      csuc cF cfv wcel vx com wral wa vy cv vz cv wcel vy cv cF cfv vz cv cF
      cfv wcel wi wi vy cv com wcel vx vz vy cA cF omsmolem adantl imp vy cv
      com wcel vz cv com wcel wa cA con0 wss com cA cF wf wa vx cv cF cfv vx cv
      csuc cF cfv wcel vx com wral wa vz cv vy cv wcel vz cv cF cfv vy cv cF
      cfv wcel wi vy cv com wcel cA con0 wss com cA cF wf wa vx cv cF cfv vx cv
      csuc cF cfv wcel vx com wral wa vz cv vy cv wcel vz cv cF cfv vy cv cF
      cfv wcel wi wi vz cv com wcel vx vy vz cA cF omsmolem adantr imp orim12d
      ancoms con3d cA con0 wss com cA cF wf wa vy cv com wcel vz cv com wcel wa
      vy cv cF cfv vz cv cF cfv wceq vy cv cF cfv vz cv cF cfv wcel vz cv cF
      cfv vy cv cF cfv wcel wo wn wb vx cv cF cfv vx cv csuc cF cfv wcel vx com
      wral cA con0 wss com cA cF wf wa vy cv com wcel vz cv com wcel wa wa vy
      cv cF cfv word vz cv cF cfv word wa vy cv cF cfv vz cv cF cfv wceq vy cv
      cF cfv vz cv cF cfv wcel vz cv cF cfv vy cv cF cfv wcel wo wn wb cA con0
      wss com cA cF wf wa vy cv com wcel vz cv com wcel wa vy cv cF cfv word vz
      cv cF cfv word wa cA con0 wss com cA cF wf wa vy cv com wcel vy cv cF cfv
      word vz cv com wcel vz cv cF cfv word cA con0 wss com cA cF wf wa vy cv
      com wcel vy cv cF cfv con0 wcel vy cv cF cfv word cA con0 wss com cA cF
      wf vy cv com wcel vy cv cF cfv con0 wcel cA con0 wss vy cv cF cfv cA wcel
      vy cv cF cfv con0 wcel com cA cF wf vy cv com wcel wa cA con0 vy cv cF
      cfv ssel com cA vy cv cF ffvelrn syl5 expdimp vy cv cF cfv eloni syl6 cA
      con0 wss com cA cF wf wa vz cv com wcel vz cv cF cfv con0 wcel vz cv cF
      cfv word cA con0 wss com cA cF wf vz cv com wcel vz cv cF cfv con0 wcel
      cA con0 wss vz cv cF cfv cA wcel vz cv cF cfv con0 wcel com cA cF wf vz
      cv com wcel wa cA con0 vz cv cF cfv ssel com cA vz cv cF ffvelrn syl5
      expdimp vz cv cF cfv eloni syl6 anim12d imp vy cv cF cfv vz cv cF cfv
      ordtri3 syl adantlr vy cv com wcel vz cv com wcel wa vy cv vz cv wceq vy
      cv vz cv wcel vz cv vy cv wcel wo wn wb cA con0 wss com cA cF wf wa vx cv
      cF cfv vx cv csuc cF cfv wcel vx com wral wa vy cv word vz cv word vy cv
      vz cv wceq vy cv vz cv wcel vz cv vy cv wcel wo wn wb vy cv com wcel vz
      cv com wcel vy cv vz cv ordtri3 vy cv nnord vz cv nnord syl2an adantl
      3imtr4d exp32 r19.21adv r19.21aiv sylanbrc $.
      $( [24-Jun-2004] $) $( [30-Nov-2003] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Equivalence relations and classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c Er $.  $( Equivalence predicate $)
  $c /. $.  $( Long slash for quotient set $)

  $( Extend the definition of a wff to include the equivalence predicate. $)
  wer $a wff Er R $.

  $( Extend the definition of a class to include equivalence class. $)
  cec $a class [ A ] R $.

  $( Extend the definition of a class to include quotient set. $)
  cqs $a class ( A /. R ) $.

  $( Define the equivalence predicate.  ` R ` need not be a relation but
     ordinarily will be, in which case we call it an equivalence relation.
     Our notation is not standard.  A formal notation doesn't seem to exist
     in the literature; instead only informal English tends to be used.  Some
     definitions in the literature may also require that ` R ` be a relation.
     The present definition, although somewhat cryptic, nicely avoids dummy
     variables.  In ~ dfer2 we derive a more typical definition.  We show that
     an equivalence relation is reflexive, symmetric, and transitive in
     ~ erref , ~ ersymb , and ~ ertr . $)
  df-er $a |- ( Er R <-> ( `' R u. ( R o. R ) ) C_ R ) $.

  ${
    $d x y z R $.
    $( Alternate definition of equivalence predicate. $)
    dfer2 $p |- ( Er R <-> A. x A. y A. z
              ( ( x R y -> y R x ) /\  ( ( x R y /\ y R z ) -> x R z ) ) ) $=
      cR wer cR ccnv cR cR ccom cun cR wss vx cv vy cv cR wbr vy cv vx cv cR
      wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa
      vz wal vy wal vx wal cR df-er cR ccnv cR wss cR cR ccom cR wss wa vx cv
      vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal wa cR ccnv cR
      cR ccom cun cR wss vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx
      wal cR ccnv cR wss vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal
      cR cR ccom cR wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi vz wal vy wal vx wal vx vy cR cnvsym vx vy vz cR cotr anbi12i cR
      ccnv cR cR ccom cR unss vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx
      wal vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal wa vx wal vx cv vy
      cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal wa vx cv vy cv cR
      wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv
      vz cv cR wbr wi wa vz wal vy wal vx cv vy cv cR wbr vy cv vx cv cR wbr wi
      vy wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz
      wal vy wal wa vx vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR
      wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx cv vy
      cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi vz wal wa vy wal vx cv vy cv cR wbr vy cv vx cv cR
      wbr wi vy wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi vz wal vy wal wa vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vx cv vy cv
      cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi vz wal wa vy vx cv vy cv cR wbr vy cv vx cv cR wbr wi
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz 19.28v
      albii vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy 19.26 bitri albii vx cv
      vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx cv vy cv cR wbr vy cv vz cv
      cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx 19.26 bitr2i 3bitr3i
      bitri $.
      $( [3-Jan-1997] $)
  $}

  $( Define the ` R ` -coset of ` A ` .  Exercise 35 of [Enderton] p. 61.  This
     is called the equivalence class of ` A ` modulo ` R ` when ` R ` is an
     equivalence relation (i.e. when ` Er R ` ; see ~ dfer2 ).  In this case,
     ` A ` is a representative (member) of the equivalence class ` [ A ] R ` ,
     which contains all sets that are equivalent to ` A ` .  Definition of
     [Enderton] p. 57 uses the notation ` [ A ] ` (subscript) ` R ` , although
     we simply follow the brackets by ` R ` since we don't have subscripted
     expressions.  For an alternate definition, see ~ dfec2 . $)
  df-ec $a |- [ A ] R = ( R " { A } ) $.

  ${
    $d y A x $.  $d y R x $.
    ec2.1 $e |- A e. _V $.
    $( Alternate definition of ` R `-coset of ` A ` .  Definition 34 of
       [Suppes] p. 81. $)
    dfec2 $p |- [ A ] R = { y | A R y } $=
      cR cA csn cima vx cv cA csn wcel vx cv vy cv cop cR wcel wa vx wex vy cab
      cA cR cec cA vy cv cR wbr vy cab vx vy cR cA csn dfima3 cA cR df-ec cA vy
      cv cR wbr vx cv cA csn wcel vx cv vy cv cop cR wcel wa vx wex vy vx cv cA
      wceq vx cv vy cv cop cR wcel wa vx wex cA vy cv cop cR wcel vx cv cA csn
      wcel vx cv vy cv cop cR wcel wa vx wex cA vy cv cR wbr vx cv vy cv cop cR
      wcel cA vy cv cop cR wcel vx cA ec2.1 vx cv cA wceq vx cv vy cv cop cA vy
      cv cop cR vx cv cA vy cv opeq1 eleq1d ceqsexv vx cv cA csn wcel vx cv vy
      cv cop cR wcel wa vx cv cA wceq vx cv vy cv cop cR wcel wa vx vx cv cA
      csn wcel vx cv cA wceq vx cv vy cv cop cR wcel vx cA elsn anbi1i exbii cA
      vy cv cR df-br 3bitr4ri abbii 3eqtr4i $.
      $( [3-Jan-1997] $)
  $}

  $( An equivalence class modulo a set is a set. $)
  ecexg $p |- ( R e. B -> [ A ] R e. _V ) $=
    cR cB wcel cR cA csn cima cvv cA cR cec cR cA csn cB imaexg cA cR df-ec
    syl5eqel $.
    $( [24-Jul-1995] $)

  ${
    $d x y A $.  $d x y R $.
    $( Define quotient set.  ` R ` is usually an equivalence relation.
       Definition of [Enderton] p. 58. $)
    df-qs $a |- ( A /. R ) = { y | E. x e. A y = [ x ] R } $.
  $}

  $( Equality theorem for equivalence predicate. $)
  ereq $p |- ( R = S -> ( Er R <-> Er S ) ) $=
    cR cS wceq cR ccnv cR cR ccom cun cR wss cS ccnv cS cS ccom cun cS wss cR
    wer cS wer cR cS wceq cR ccnv cR cR ccom cun cR wss cS ccnv cS cS ccom cun
    cR wss cS ccnv cS cS ccom cun cS wss cR cS wceq cR ccnv cR cR ccom cun cS
    ccnv cS cS ccom cun cR cR cS wceq cR ccnv cS ccnv cR cR ccom cS cS ccom cR
    cS cnveq cR cS wceq cR cR ccom cS cR ccom cS cS ccom cR cS cR coeq1 cR cS
    cS coeq2 eqtrd uneq12d sseq1d cR cS cS ccnv cS cS ccom cun sseq2 bitrd cR
    df-er cS df-er 3bitr4g $.
    $( [4-Jun-1995] $)

  ${
    $d x y z R $.
    ster.1 $e |- ( x R y -> y R x ) $.
    ster.2 $e |- ( ( x R y /\ y R z ) -> x R z ) $.
    $( A symmetric, transitive relation is an equivalence relation. $)
    ster $p |- Er R $=
      cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx vx vy vz cR
      dfer2 vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi wa vy vz vx cv vy cv cR wbr vy cv
      vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi ster.1 ster.2 pm3.2i gen2 mpgbir $.
      $( [4-Jun-1995] $)
  $}

  ${
    $d x y z $.
    $( The identity relation is an equivalence relation. $)
    ider $p |- Er _I $=
      vx vy vz cid vx cv vy cv wceq vy cv vx cv wceq vx cv vy cv cid wbr vy cv
      vx cv cid wbr vx vy equcomi vx cv vy cv vy visset ideq vy cv vx cv vx
      visset ideq 3imtr4i vx cv vy cv wceq vy cv vz cv wceq wa vx cv vz cv wceq
      vx cv vy cv cid wbr vy cv vz cv cid wbr wa vx cv vz cv cid wbr vx cv vy
      cv vz cv eqtr vx cv vy cv cid wbr vx cv vy cv wceq vy cv vz cv cid wbr vy
      cv vz cv wceq vx cv vy cv vy visset ideq vy cv vz cv vz visset ideq
      anbi12i vx cv vz cv vz visset ideq 3imtr4i ster $.
      $( [10-May-1998] $)
  $}

  ${
    $d y A $.  $d v x B $.  $d v w z R $.  $d v w x y z $.
    eqer.1 $e |- ( x = y -> A = B ) $.
    eqer.2 $e |- R = { <. x , y >. | A = B } $.
    $( Lemma for ~ eqer . $)
    eqerlem $p |- ( z R w <-> [_ z / x ]_ A = [_ w / x ]_ A ) $=
      vz cv vw cv cR wbr cA cB wceq vx vz cv wsbc vy vw cv wsbc vx vz cv cA csb
      vx vy cv cA csb wceq vy vw cv wsbc vx vz cv cA csb vx vw cv cA csb wceq
      cA cB wceq vx vy vz vw cR eqer.2 brabsb cA cB wceq vx vz cv wsbc vx vz cv
      cA csb vx vy cv cA csb wceq vy vw cA cB wceq vx vz cv wsbc vx vz cv cA
      csb cB wceq vx vz cv cA csb vx vy cv cA csb wceq vz cv cvv wcel cA cB
      wceq vx vz cv wsbc vx vz cv cA csb cB wceq wb vz visset vx vz cv cA cB
      cvv sbceq1dig ax-mp vx vy cv cA csb cB vx vz cv cA csb vx vv vy cv cA cB
      vy visset vv cv cB wcel vx ax-17 eqer.1 csbief eqeq2i bitr4i sbbii vx vz
      cv cA csb vx vy cv cA csb wceq vy vw cv wsbc vx vz cv cA csb vy vw cv vx
      vy cv cA csb csb wceq vx vz cv cA csb vx vw cv cA csb wceq vw cv cvv wcel
      vx vz cv cA csb vx vy cv cA csb wceq vy vw cv wsbc vx vz cv cA csb vy vw
      cv vx vy cv cA csb csb wceq wb vw visset vy vw cv vx vz cv cA csb vx vy
      cv cA csb cvv sbceq2dig ax-mp vy vw cv vx vy cv cA csb csb vx vw cv cA
      csb vx vz cv cA csb vw cv cvv wcel vy vw cv vx vy cv cA csb csb vx vw cv
      cA csb wceq vw visset vx vy vw cv cA cvv csbcog ax-mp eqeq2i bitri 3bitri
      $.
      $( [17-Mar-2008] $) $( [17-Mar-2008] $)

    $( Equivalence relation involving equality of dependent classes
       ` A ( x ) ` and ` B ( y ) ` . $)
    eqer $p |- Er R $=
      vz vw vv cR vx vz cv cA csb vx vw cv cA csb wceq vx vw cv cA csb vx vz cv
      cA csb wceq vz cv vw cv cR wbr vw cv vz cv cR wbr vx vz cv cA csb vx vw
      cv cA csb wceq vx vz cv cA csb vx vw cv cA csb vx vz cv cA csb vx vw cv
      cA csb wceq id eqcomd vx vy vz vw cA cB cR eqer.1 eqer.2 eqerlem vx vy vw
      vz cA cB cR eqer.1 eqer.2 eqerlem 3imtr4i vx vz cv cA csb vx vw cv cA csb
      wceq vx vw cv cA csb vx vv cv cA csb wceq wa vx vz cv cA csb vx vv cv cA
      csb wceq vz cv vw cv cR wbr vw cv vv cv cR wbr wa vz cv vv cv cR wbr vx
      vz cv cA csb vx vw cv cA csb vx vv cv cA csb eqtr vz cv vw cv cR wbr vx
      vz cv cA csb vx vw cv cA csb wceq vw cv vv cv cR wbr vx vw cv cA csb vx
      vv cv cA csb wceq vx vy vz vw cA cB cR eqer.1 eqer.2 eqerlem vx vy vw vv
      cA cB cR eqer.1 eqer.2 eqerlem anbi12i vx vy vz vv cA cB cR eqer.1 eqer.2
      eqerlem 3imtr4i ster $.
      $( [17-Mar-2008] $) $( [17-Mar-2008] $)
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    ersym.1 $e |- A e. _V $.
    ersym.2 $e |- B e. _V $.
    ersym.3 $e |- Er R $.
    $( An equivalence relation is symmetric. $)
    ersym $p |- ( A R B -> B R A ) $=
      vx cv vy cv cR wbr vy cv vx cv cR wbr wi cA cB cR wbr cB cA cR wbr wi vx
      vy cA cB ersym.1 ersym.2 vx cv cA wceq vy cv cB wceq wa vx cv vy cv cR
      wbr cA cB cR wbr vy cv vx cv cR wbr cB cA cR wbr vx cv cA vy cv cB cR
      breq12 vy cv cB wceq vx cv cA wceq vy cv vx cv cR wbr cB cA cR wbr wb vy
      cv cB vx cv cA cR breq12 ancoms imbi12d vx cv vy cv cR wbr vy cv vx cv cR
      wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vx
      cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi wa vz vx cv vy cv cR wbr vy cv vx cv cR wbr
      wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz
      wal vy vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx cR wer vx cv vy
      cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa
      vx cv vz cv cR wbr wi wa vz wal vy wal vx wal ersym.3 vx vy vz cR dfer2
      mpbi a4i a4i a4i pm3.26i vtocl2 $.
      $( [4-Jun-1995] $)
  $}

  ${
    ersymb.1 $e |- A e. _V $.
    ersymb.2 $e |- B e. _V $.
    ersymb.3 $e |- Er R $.
    $( An equivalence relation is symmetric. $)
    ersymb $p |- ( A R B <-> B R A ) $=
      cA cB cR wbr cB cA cR wbr cA cB cR ersymb.1 ersymb.2 ersymb.3 ersym cB cA
      cR ersymb.2 ersymb.1 ersymb.3 ersym impbii $.
      $( [30-Jul-1995] $)
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.  $d x y z C $.
    ertr.1 $e |- A e. _V $.
    ertr.2 $e |- B e. _V $.
    ertr.3 $e |- C e. _V $.
    ertr.4 $e |- Er R $.
    $( An equivalence relation is transitive. $)
    ertr $p |- ( ( A R B /\ B R C ) -> A R C ) $=
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi cA cB cR
      wbr cB cC cR wbr wa cA cC cR wbr wi vx vy vz cA cB cC ertr.1 ertr.2
      ertr.3 vx cv cA wceq vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv
      cR wbr wi cA vy cv cR wbr vy cv vz cv cR wbr wa cA vz cv cR wbr wi vy cv
      cB wceq cA cB cR wbr cB vz cv cR wbr wa cA vz cv cR wbr wi vz cv cC wceq
      cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi vx cv cA wceq vx cv vy cv cR
      wbr vy cv vz cv cR wbr wa cA vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz
      cv cR wbr cA vz cv cR wbr vx cv cA wceq vx cv vy cv cR wbr cA vy cv cR
      wbr vy cv vz cv cR wbr vx cv cA vy cv cR breq1 anbi1d vx cv cA vz cv cR
      breq1 imbi12d vy cv cB wceq cA vy cv cR wbr vy cv vz cv cR wbr wa cA cB
      cR wbr cB vz cv cR wbr wa cA vz cv cR wbr vy cv cB wceq cA vy cv cR wbr
      cA cB cR wbr vy cv vz cv cR wbr cB vz cv cR wbr vy cv cB cA cR breq2 vy
      cv cB vz cv cR breq1 anbi12d imbi1d vz cv cC wceq cA cB cR wbr cB vz cv
      cR wbr wa cA cB cR wbr cB cC cR wbr wa cA vz cv cR wbr cA cC cR wbr vz cv
      cC wceq cB vz cv cR wbr cB cC cR wbr cA cB cR wbr vz cv cC cB cR breq2
      anbi2d vz cv cC cA cR breq2 imbi12d syl3an9b vx cv vy cv cR wbr vy cv vx
      cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa vz vx cv vy cv cR wbr vy cv vx cv
      cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      wa vz wal vy vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr
      vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx cR wer vx
      cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx wal ertr.4 vx vy vz cR
      dfer2 mpbi a4i a4i a4i pm3.27i vtocl3 $.
      $( [4-Jun-1995] $)
  $}

  ${
    $d x y A $.  $d x y R $.
    erref.1 $e |- Er R $.
    $( An equivalence relation is reflexive on its field.  Compare
       Theorem 3M of [Enderton] p. 56. $)
    erref $p |- ( A e. ( dom R u. ran R ) -> A R A ) $=
      vx cv vx cv cR wbr cA cA cR wbr vx cA cR cdm cR crn cun vx cv cA wceq vx
      cv vx cv cR wbr cA vx cv cR wbr cA cA cR wbr vx cv cA vx cv cR breq1 vx
      cv cA cA cR breq2 bitrd vx cv cR cdm cR crn cun wcel vx cv cR cdm wcel vx
      cv cR crn wcel wo vx cv vx cv cR wbr vx cv cR cdm cR crn elun vx cv cR
      cdm wcel vx cv vx cv cR wbr vx cv cR crn wcel vx cv cR cdm wcel vx cv vy
      cv cR wbr vy wex vx cv vx cv cR wbr vy vx cv cR vx visset eldm vx cv vy
      cv cR wbr vx cv vx cv cR wbr vy vx cv vy cv cR wbr vx cv vx cv cR wbr vx
      cv vy cv cR wbr vy cv vx cv cR wbr vx cv vx cv cR wbr vx cv vy cv cR wbr
      vx cv vy cv vx cv cR vx visset vy visset vx visset erref.1 ertr vx cv vy
      cv cR vx visset vy visset erref.1 ersymb sylan2b anidms 19.23aiv sylbi vx
      cv cR crn wcel vy cv vx cv cR wbr vy wex vx cv vx cv cR wbr vy vx cv cR
      vx visset elrn vy cv vx cv cR wbr vx cv vx cv cR wbr vy vy cv vx cv cR
      wbr vx cv vx cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr vx cv vx cv
      cR wbr vy cv vx cv cR wbr vx cv vy cv vx cv cR vx visset vy visset vx
      visset erref.1 ertr vy cv vx cv cR vy visset vx visset erref.1 ersymb
      sylanb anidms 19.23aiv sylbi jaoi sylbi vtoclga $.
      $( [4-Jun-1995] $)
  $}

  ${
    $d x y R $.
    erdmrn.1 $e |- Er R $.
    $( The range and domain of an equivalence relation are equal. $)
    erdmrn $p |- dom R = ran R $=
      vx cR cdm cR crn vx cv vy cv cR wbr vy wex vy cv vx cv cR wbr vy wex vx
      cv cR cdm wcel vx cv cR crn wcel vx cv vy cv cR wbr vy cv vx cv cR wbr vy
      vx cv vy cv cR vx visset vy visset erdmrn.1 ersymb exbii vy vx cv cR vx
      visset eldm vy vx cv cR vx visset elrn 3bitr4i eqriv $.
      $( [6-Aug-1995] $)
  $}

  $( Equality theorem for equivalence class. $)
  eceq1 $p |- ( A = B -> [ C ] A = [ C ] B ) $=
    cA cB wceq cA cC csn cima cB cC csn cima cC cA cec cC cB cec cA cB cC csn
    imaeq1 cC cA df-ec cC cB df-ec 3eqtr4g $.
    $( [23-Jul-1995] $)

  $( Equality theorem for equivalence class. $)
  eceq2 $p |- ( A = B -> [ A ] C = [ B ] C ) $=
    cA cB wceq cC cA csn cima cC cB csn cima cA cC cec cB cC cec cA cB wceq cA
    csn cB csn cC cA cB sneq imaeq2d cA cC df-ec cB cC df-ec 3eqtr4g $.
    $( [23-Jul-1995] $)

  ${
    $d x A $.  $d x B $.  $d x R $.
    elec.1 $e |- A e. _V $.
    elec.2 $e |- B e. _V $.
    $( Membership in an equivalence class.  Theorem 72 of [Suppes] p. 82. $)
    elec $p |- ( A e. [ B ] R <-> B R A ) $=
      cB vx cv cR wbr cB cA cR wbr vx cA cB cR cec elec.1 vx cv cA cB cR breq2
      vx cB cR elec.2 dfec2 elab2 $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x R $.  $d x A $.
    ecdmn0.1 $e |- A e. _V $.
    $( A representative of a nonempty equivalence class belongs to the domain
       of the equivalence relation. $)
    ecdmn0 $p |- ( A e. dom R <-> [ A ] R =/= (/) ) $=
      vx cv cA cR cec wcel vx wex cA vx cv cR wbr vx wex cA cR cec c0 wne cA cR
      cdm wcel vx cv cA cR cec wcel cA vx cv cR wbr vx vx cv cA cR vx visset
      ecdmn0.1 elec exbii vx cA cR cec n0 vx cA cR ecdmn0.1 eldm 3bitr4ri $.
      $( [28-Dec-2008] $) $( [15-Feb-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    erthi.1 $e |- A e. _V $.
    erthi.2 $e |- B e. _V $.
    erthi.3 $e |- Er R $.
    $( Basic property of equivalence relations.  Part of Lemma 3N of [Enderton]
       p. 57. $)
    erthi $p |- ( A R B -> [ A ] R = [ B ] R ) $=
      cA cB cR wbr vx cA cR cec cB cR cec cA cB cR wbr cA vx cv cR wbr cB vx cv
      cR wbr vx cv cA cR cec wcel vx cv cB cR cec wcel cA cB cR wbr cA vx cv cR
      wbr cB vx cv cR wbr cA cB cR wbr cB cA cR wbr cA vx cv cR wbr cB vx cv cR
      wbr wi cA cB cR erthi.1 erthi.2 erthi.3 ersymb cB cA cR wbr cA vx cv cR
      wbr cB vx cv cR wbr cB cA vx cv cR erthi.2 erthi.1 vx visset erthi.3 ertr
      ex sylbi cA cB cR wbr cB vx cv cR wbr cA vx cv cR wbr cA cB vx cv cR
      erthi.1 erthi.2 vx visset erthi.3 ertr ex impbid vx cv cA cR vx visset
      erthi.1 elec vx cv cB cR vx visset erthi.2 elec 3bitr4g eqrdv $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    erth.1 $e |- B e. _V $.
    erth.2 $e |- Er R $.
    $( Basic property of equivalence relations.  Theorem 73 of [Suppes]
       p. 82. $)
    erth $p |- ( A e. ( dom R u. ran R ) ->
                   ( [ A ] R = [ B ] R <-> A R B ) ) $=
      vx cv cR cec cB cR cec wceq vx cv cB cR wbr wb cA cR cec cB cR cec wceq
      cA cB cR wbr wb vx cA cR cdm cR crn cun vx cv cA wceq vx cv cR cec cB cR
      cec wceq cA cR cec cB cR cec wceq vx cv cB cR wbr cA cB cR wbr vx cv cA
      wceq vx cv cR cec cA cR cec cB cR cec vx cv cA cR eceq2 eqeq1d vx cv cA
      cB cR breq1 bibi12d vx cv cR cdm cR crn cun wcel vx cv cR cec cB cR cec
      wceq vx cv cB cR wbr vx cv cR cec cB cR cec wceq vx cv vx cv cR wbr vx cv
      cB cR wbr vx cv cR cdm cR crn cun wcel vx cv cR cec cB cR cec wceq vx cv
      vx cv cR wbr cB vx cv cR wbr vx cv cB cR wbr vx cv cR cec cB cR cec wceq
      vx cv vx cv cR cec wcel vx cv cB cR cec wcel vx cv vx cv cR wbr cB vx cv
      cR wbr vx cv cR cec cB cR cec vx cv eleq2 vx cv vx cv cR vx visset vx
      visset elec vx cv cB cR vx visset erth.1 elec 3bitr3g cB vx cv cR erth.1
      vx visset erth.2 ersym syl6bi vx cv cR erth.2 erref syl5com vx cv cB cR
      vx visset erth.1 erth.2 erthi impbid1 vtoclga $.
      $( [23-Jul-1995] $)
  $}

  ${
    erthdm.1 $e |- B e. _V $.
    erthdm.2 $e |- Er R $.
    $( Basic property of equivalence relations.  Compare Theorem 73 of [Suppes]
       p. 82.  Assumes membership in the domain instead of just the field. $)
    erthdm $p |- ( A e. dom R -> ( [ A ] R = [ B ] R <-> A R B ) ) $=
      cA cR cdm wcel cA cR cdm cR crn cun wcel cA cR cec cB cR cec wceq cA cB
      cR wbr wb cA cR cdm cR crn elun1 cA cB cR erthdm.1 erthdm.2 erth syl $.
      $( [28-Jul-1995] $)
  $}

  ${
    erthdmr.1 $e |- A e. _V $.
    erthdmr.2 $e |- B e. _V $.
    erthdmr.3 $e |- Er R $.
    $( Basic property of equivalence relations.  Compare Theorem 73 of [Suppes]
        p. 82.  Assumes membership of the second argument in the domain. $)
    erthdmr $p |- ( B e. dom R -> ( [ A ] R = [ B ] R <-> A R B ) ) $=
      cB cR cdm wcel cB cR cec cA cR cec wceq cB cA cR wbr cA cR cec cB cR cec
      wceq cA cB cR wbr cB cA cR erthdmr.1 erthdmr.3 erthdm cA cR cec cB cR cec
      eqcom cA cB cR erthdmr.1 erthdmr.2 erthdmr.3 ersymb 3bitr4g $.
      $( [30-Jul-1995] $)
  $}

  ${
    ereldm.1 $e |- A e. _V $.
    ereldm.2 $e |- B e. _V $.
    ereldm.3 $e |- Er R $.
    ereldm.4 $e |- dom R = D $.
    $( Equality of equivalence classes implies equivalence of domain
       membership. $)
    ereldm $p |- ( [ A ] R = [ B ] R -> ( A e. D <-> B e. D ) ) $=
      cA cR cec cB cR cec wceq cA cR cdm wcel cB cR cdm wcel cA cD wcel cB cD
      wcel cA cR cec cB cR cec wceq cA cR cdm wcel cB cR cdm wcel cA cR cec cB
      cR cec wceq cA cR cdm wcel cA cB cR wbr cB cR cdm wcel cA cR cdm wcel cA
      cR cec cB cR cec wceq cA cB cR wbr cA cB cR ereldm.2 ereldm.3 erthdm
      biimpcd cA cB cR wbr cB cA cR wbr cB cR cdm wcel cA cB cR ereldm.1
      ereldm.2 ereldm.3 ersymb cB cA cR ereldm.2 breldm sylbi syl6 cA cR cec cB
      cR cec wceq cB cR cdm wcel cA cB cR wbr cA cR cdm wcel cB cR cdm wcel cA
      cR cec cB cR cec wceq cA cB cR wbr cA cB cR ereldm.1 ereldm.2 ereldm.3
      erthdmr biimpcd cA cB cR ereldm.1 breldm syl6 impbid cR cdm cD cA
      ereldm.4 eleq2i cR cdm cD cB ereldm.4 eleq2i 3bitr3g $.
      $( [28-Jan-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    erdisj.1 $e |- A e. _V $.
    erdisj.2 $e |- B e. _V $.
    erdisj.3 $e |- Er R $.
    $( Equivalence classes do not overlap.  In other words, two equivalence
       classes are either equal or disjoint.  Theorem 74 of [Suppes] p. 83. $)
    erdisj $p |- ( [ A ] R = [ B ] R \/ ( [ A ] R i^i [ B ] R ) = (/) ) $=
      cA cR cec cB cR cec wceq cA cR cec cB cR cec cin c0 wceq cA cR cec cB cR
      cec wceq wn vx cv cA cR cec wcel vx cv cB cR cec wcel wn wi vx wal cA cR
      cec cB cR cec cin c0 wceq cA cR cec cB cR cec wceq wn vx cv cA cR cec
      wcel vx cv cB cR cec wcel wn wi vx vx cv cA cR cec wcel cA cR cec cB cR
      cec wceq wn vx cv cB cR cec wcel wn vx cv cA cR cec wcel vx cv cB cR cec
      wcel cA cR cec cB cR cec wceq vx cv cA cR cec wcel cA vx cv cR wbr vx cv
      cB cR cec wcel cA cR cec cB cR cec wceq wi vx cv cA cR vx visset erdisj.1
      elec cA vx cv cR wbr vx cv cB cR wbr cA cR cec cB cR cec wceq vx cv cB cR
      cec wcel cA vx cv cR wbr vx cv cB cR wbr cA cB cR wbr cA cR cec cB cR cec
      wceq cA vx cv cR wbr vx cv cB cR wbr cA cB cR wbr cA vx cv cB cR erdisj.1
      vx visset erdisj.2 erdisj.3 ertr ex cA cB cR erdisj.1 erdisj.2 erdisj.3
      erthi syl6 vx cv cB cR cec wcel cB vx cv cR wbr vx cv cB cR wbr vx cv cB
      cR vx visset erdisj.2 elec cB vx cv cR erdisj.2 vx visset erdisj.3 ersymb
      bitri syl5ib sylbi con3d com12 19.21aiv vx cA cR cec cB cR cec disj1
      sylibr orri $.
      $( [16-Jun-2004] $) $( [15-Jun-2004] $)
  $}


  $( An equivalence class modulo the identity relation is a singleton. $)
  ecidsn $p |- [ A ] _I = { A } $=
    cA cid cec cid cA csn cima cA csn cA cid df-ec cA csn imai eqtri $.
    $( [28-Oct-2004] $) $( [24-Oct-2004] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Equality theorem for quotient set. $)
    qseq1 $p |- ( A = B -> ( A /. C ) = ( B /. C ) ) $=
      cA cB wceq vy cv vx cv cC cec wceq vx cA wrex vy cab vy cv vx cv cC cec
      wceq vx cB wrex vy cab cA cC cqs cB cC cqs cA cB wceq vy cv vx cv cC cec
      wceq vx cA wrex vy cv vx cv cC cec wceq vx cB wrex vy vy cv vx cv cC cec
      wceq vx cA cB rexeq1 abbidv vx vy cA cC df-qs vx vy cB cC df-qs 3eqtr4g
      $.
      $( [23-Jul-1995] $)

    $( Equality theorem for quotient set. $)
    qseq2 $p |- ( A = B -> ( C /. A ) = ( C /. B ) ) $=
      cA cB wceq vy cv vx cv cA cec wceq vx cC wrex vy cab vy cv vx cv cB cec
      wceq vx cC wrex vy cab cC cA cqs cC cB cqs cA cB wceq vy cv vx cv cA cec
      wceq vx cC wrex vy cv vx cv cB cec wceq vx cC wrex vy cA cB wceq vy cv vx
      cv cA cec wceq vy cv vx cv cB cec wceq vx cC cA cB wceq vx cv cA cec vx
      cv cB cec vy cv cA cB vx cv eceq1 eqeq2d rexbidv abbidv vx vy cC cA df-qs
      vx vy cC cB df-qs 3eqtr4g $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    elqs.1 $e |- B e. _V $.
    $( Membership in a quotient set. $)
    elqs $p |- ( B e. ( A /. R ) <-> E. x e. A B = [ x ] R ) $=
      vy cv vx cv cR cec wceq vx cA wrex cB vx cv cR cec wceq vx cA wrex vy cB
      cA cR cqs elqs.1 vy cv cB wceq vy cv vx cv cR cec wceq cB vx cv cR cec
      wceq vx cA vy cv cB vx cv cR cec eqeq1 rexbidv vx vy cA cR df-qs elab2 $.
      $( [12-Nov-2008] $) $( [23-Jul-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( Membership in a quotient set. $)
    elqsi $p |- ( B e. ( A /. R ) -> E. x e. A B = [ x ] R ) $=
      vy cv vx cv cR cec wceq vx cA wrex cB vx cv cR cec wceq vx cA wrex vy cB
      cA cR cqs vy cv cB wceq vy cv vx cv cR cec wceq cB vx cv cR cec wceq vx
      cA vy cv cB vx cv cR cec eqeq1 rexbidv vy cv cA cR cqs wcel vy cv vx cv
      cR cec wceq vx cA wrex vx cA vy cv cR vy visset elqs biimpi vtoclga $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    ecelqsi.1 $e |- R e. _V $.
    $( Membership of an equivalence class in a quotient set. $)
    ecelqsi $p |- ( B e. A -> [ B ] R e. ( A /. R ) ) $=
      vy cv cR cec cA cR cqs wcel cB cR cec cA cR cqs wcel vy cB cA vy cv cB
      wceq vy cv cR cec cB cR cec cA cR cqs vy cv cB cR eceq2 eleq1d vy cv cA
      wcel vy cv cR cec vx cv cR cec wceq vx cA wrex vy cv cR cec cA cR cqs
      wcel vy cv cA wcel vy cv cR cec vy cv cR cec wceq vy cv cR cec vx cv cR
      cec wceq vx cA wrex vy cv cR cec eqid vy cv cR cec vx cv cR cec wceq vy
      cv cR cec vy cv cR cec wceq vx vy cv cA vx cv vy cv wceq vx cv cR cec vy
      cv cR cec vy cv cR cec vx cv vy cv cR eceq2 eqeq2d rcla4ev mpan2 vx cA vy
      cv cR cec cR cR cvv wcel vy cv cR cec cvv wcel ecelqsi.1 vy cv cvv cR
      ecexg ax-mp elqs sylibr vtoclga $.
      $( [25-Jul-1995] $)
  $}

  ${
    ecopqsi.1 $e |- R e. _V $.
    ecopqsi.2 $e |- S = ( ( A X. A ) /. R ) $.
    $( "Closure" law for equivalence class of ordered pairs. $)
    ecopqsi $p |- ( ( B e. A /\ C e. A ) -> [ <. B , C >. ] R e. S ) $=
      cB cA wcel cC cA wcel wa cB cC cop cA cA cxp wcel cB cC cop cR cec cS
      wcel cB cC cA cA opelxpi cB cC cop cA cA cxp wcel cB cC cop cR cec cA cA
      cxp cR cqs cS cA cA cxp cB cC cop cR ecopqsi.1 ecelqsi ecopqsi.2
      syl6eleqr syl $.
      $( [25-Mar-1996] $)
  $}

  ${
    $d x y A $.  $d x y R $.
    $( A quotient set exists.  (Contributed by FL, 19-May-2007.) $)
    qsexg $p |- ( A e. _V -> ( A /. R ) e. _V ) $=
      cA cvv wcel vx cv cA wcel vy cv vx cv cR cec wceq wa vx vy copab cvv wcel
      vx cv cA wcel vy cv vx cv cR cec wceq wa vx vy copab crn cvv wcel cA cR
      cqs cvv wcel vx vy cA vx cv cR cec cvv opabex2g vx cv cA wcel vy cv vx cv
      cR cec wceq wa vx vy copab cvv rnexg vx cv cA wcel vy cv vx cv cR cec
      wceq wa vx vy copab crn cvv wcel cA cR cqs cvv wcel vx cv cA wcel vy cv
      vx cv cR cec wceq wa vx vy copab crn cA cR cqs cvv vy cv vx cv cR cec
      wceq vx cA wrex vy cab vx cv cA wcel vy cv vx cv cR cec wceq wa vx wex vy
      cab cA cR cqs vx cv cA wcel vy cv vx cv cR cec wceq wa vx vy copab crn vy
      cv vx cv cR cec wceq vx cA wrex vx cv cA wcel vy cv vx cv cR cec wceq wa
      vx wex vy vy cv vx cv cR cec wceq vx cA df-rex abbii vx vy cA cR df-qs vx
      cv cA wcel vy cv vx cv cR cec wceq wa vx vy rnopab 3eqtr4ri eleq1i biimpi
      3syl $.
      $( [20-May-2007] $) $( [23-Apr-2007] $)
  $}

  ${
    $d x y A $.  $d x y R $.
    qsex.1 $e |- A e. _V $.
    $( A quotient set exists. $)
    qsex $p |- ( A /. R ) e. _V $=
      cA cvv wcel cA cR cqs cvv wcel qsex.1 cA cR qsexg ax-mp $.
      $( [14-Aug-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z R $.
    uniqs.1 $e |- R e. _V $.
    $( The union of a quotient set. $)
    uniqs $p |- U. ( A /. R ) = ( R " A ) $=
      vx cA cR cqs cuni cR cA cima vx cv cA cR cqs cuni wcel vx cv vy cv wcel
      vy cv cA cR cqs wcel wa vy wex vy cv vz cv cR cec wceq vx cv vy cv wcel
      wa vz cA wrex vy wex vx cv cR cA cima wcel vy vx cv cA cR cqs eluni vx cv
      vy cv wcel vy cv cA cR cqs wcel wa vy cv vz cv cR cec wceq vx cv vy cv
      wcel wa vz cA wrex vy vy cv cA cR cqs wcel vx cv vy cv wcel wa vy cv vz
      cv cR cec wceq vz cA wrex vx cv vy cv wcel wa vx cv vy cv wcel vy cv cA
      cR cqs wcel wa vy cv vz cv cR cec wceq vx cv vy cv wcel wa vz cA wrex vy
      cv cA cR cqs wcel vy cv vz cv cR cec wceq vz cA wrex vx cv vy cv wcel vz
      cA vy cv cR vy visset elqs anbi1i vx cv vy cv wcel vy cv cA cR cqs wcel
      ancom vy cv vz cv cR cec wceq vx cv vy cv wcel vz cA r19.41v 3bitr4i
      exbii vx cv cR cA cima wcel vz cv vx cv cR wbr vz cA wrex vy cv vz cv cR
      cec wceq vx cv vy cv wcel wa vy wex vz cA wrex vy cv vz cv cR cec wceq vx
      cv vy cv wcel wa vz cA wrex vy wex vz vx cv cR cA vx visset elima vy cv
      vz cv cR cec wceq vx cv vy cv wcel wa vy wex vz cv vx cv cR wbr vz cA vy
      cv vz cv cR cec wceq vx cv vy cv wcel wa vy wex vx cv vz cv cR cec wcel
      vz cv vx cv cR wbr vx cv vy cv wcel vx cv vz cv cR cec wcel vy vz cv cR
      cec cR cvv wcel vz cv cR cec cvv wcel uniqs.1 vz cv cvv cR ecexg ax-mp vy
      cv vz cv cR cec vx cv eleq2 ceqsexv vx cv vz cv cR vx visset vz visset
      elec bitri rexbii vy cv vz cv cR cec wceq vx cv vy cv wcel wa vz vy cA
      rexcom4 3bitr2ri 3bitri eqriv $.
      $( [9-Dec-2008] $) $( [9-Dec-2008] $)
  $}

  ${
    $d x y A $.  $d x y R $.
    snec.1 $e |- A e. _V $.
    $( The singleton of an equivalence class. $)
    snec $p |- { [ A ] R } = ( { A } /. R ) $=
      vy cv cA cR cec wceq vy cab vy cv vx cv cR cec wceq vx cA csn wrex vy cab
      cA cR cec csn cA csn cR cqs vy cv cA cR cec wceq vy cv vx cv cR cec wceq
      vx cA csn wrex vy vy cv vx cv cR cec wceq vx cA csn wrex vx cv cA csn
      wcel vy cv vx cv cR cec wceq wa vx wex vx cv cA wceq vy cv vx cv cR cec
      wceq wa vx wex vy cv cA cR cec wceq vy cv vx cv cR cec wceq vx cA csn
      df-rex vx cv cA csn wcel vy cv vx cv cR cec wceq wa vx cv cA wceq vy cv
      vx cv cR cec wceq wa vx vx cv cA csn wcel vx cv cA wceq vy cv vx cv cR
      cec wceq vx cA elsn anbi1i exbii vy cv vx cv cR cec wceq vy cv cA cR cec
      wceq vx cA snec.1 vx cv cA wceq vx cv cR cec cA cR cec vy cv vx cv cA cR
      eceq2 eqeq2d ceqsexv 3bitrri abbii vy cA cR cec df-sn vx vy cA csn cR
      df-qs 3eqtr4i $.
      $( [29-Jan-1999] $)
  $}

  ${
    ecqs.1 $e |- R e. _V $.
    $( Equivalence class in terms of quotient set. $)
    ecqs $p |- [ A ] R = U. ( { A } /. R ) $=
      cA cR cec cR cA csn cima cA csn cR cqs cuni cA cR df-ec cA csn cR ecqs.1
      uniqs eqtr4i $.
      $( [15-Jan-2009] $) $( [29-Jan-1999] $)
  $}

  ${
    $d x R $.  $d x A $.
    0nelqs.1 $e |- dom R = A $.
    $( A quotient set doesn't contain the empty set. $)
    0nelqs $p |- -. (/) e. ( A /. R ) $=
      c0 cA cR cqs wcel c0 vx cv cR cec wceq vx cA wrex c0 vx cv cR cec wceq vx
      cA vx cv cA wcel c0 vx cv cR cec wceq wn vx cv cR cdm wcel c0 vx cv cR
      cec wne vx cv cA wcel c0 vx cv cR cec wceq wn vx cv cR cdm wcel vx cv cR
      cec c0 wne c0 vx cv cR cec wne vx cv cR vx visset ecdmn0 vx cv cR cec c0
      necom bitri cR cdm cA vx cv 0nelqs.1 eleq2i c0 vx cv cR cec df-ne 3bitr3i
      biimpi nrex vx cA c0 cR elqsi mto $.
      $( [21-Mar-2007] $) $( [24-Aug-1995] $)
  $}

  ${
    ecelqsdm.1 $e |- B e. _V $.
    ecelqsdm.2 $e |- dom R = A $.
    $( Membership of an equivalence class in a quotient set. $)
    ecelqsdm $p |- ( [ B ] R e. ( A /. R ) -> B e. A ) $=
      cB cA wcel cB cR cec cA cR cqs wcel cB cA wcel wn cB cR cec cA cR cqs
      wcel c0 cA cR cqs wcel cA cR ecelqsdm.2 0nelqs cB cA wcel wn cB cR cec c0
      wceq cB cR cec cA cR cqs wcel c0 cA cR cqs wcel wb cB cA wcel cB cR cec
      c0 cB cR cec c0 wne cB cR cdm wcel cB cA wcel cB cR ecelqsdm.1 ecdmn0 cR
      cdm cA cB ecelqsdm.2 eleq2i bitr3i necon1bbii cB cR cec c0 cA cR cqs
      eleq1 sylbi mtbiri con4i $.
      $( [21-Mar-2007] $) $( [30-Jul-1995] $)
  $}

  ${
    $d y A $.
    ecid.1 $e |- A e. _V $.
    $( A set is equal to its converse epsilon coset.  (Note:  converse epsilon
       is not an equivalence relation.) $)
    ecid $p |- [ A ] `' _E = A $=
      cA cep ccnv cec cA vy cv cep ccnv wbr vy cab vy cv cA wcel vy cab cA vy
      cA cep ccnv ecid.1 dfec2 cA vy cv cep ccnv wbr vy cv cA wcel vy cA vy cv
      cep ccnv wbr vy cv cA cep wbr vy cv cA wcel cA vy cv cep ecid.1 vy visset
      brcnv vy cv cA vy visset ecid.1 epelc bitri abbii vy cA abid2 3eqtri $.
      $( [13-Aug-1995] $)
  $}

  ${
    $d x y A $.
    $( A set is equal to its quotient set mod converse epsilon. (Note: converse
       epsilon is not an equivalence relation.) $)
    qsid $p |- ( A /. `' _E ) = A $=
      cA cep ccnv cqs vy cv vx cv cep ccnv cec wceq vx cA wrex vy cab vy cv cA
      wcel vy cab cA vx vy cA cep ccnv df-qs vy cv vx cv cep ccnv cec wceq vx
      cA wrex vy cv cA wcel vy vy cv vx cv cep ccnv cec wceq vx cA wrex vx cv
      vy cv wceq vx cA wrex vy cv cA wcel vy cv vx cv cep ccnv cec wceq vx cv
      vy cv wceq vx cA vy cv vx cv cep ccnv cec wceq vy cv vx cv wceq vx cv vy
      cv wceq vx cv cep ccnv cec vx cv vy cv vx cv vx visset ecid eqeq2i vy cv
      vx cv eqcom bitri rexbii vx vy cv cA risset bitr4i abbii vy cA abid2
      3eqtri $.
      $( [21-Mar-2007] $) $( [13-Aug-1995] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x ps $.
    ectocl.1 $e |- S = ( B /. R ) $.
    ectocl.2 $e |- ( [ x ] R = A -> ( ph <-> ps ) ) $.
    ectocl.3 $e |- ( x e. B -> ph ) $.
    $( Implicit substitution of class for equivalence class. $)
    ectocl $p |- ( A e. S -> ps ) $=
      cA cS wcel cA cB cR cqs wcel wps cS cB cR cqs cA ectocl.1 eleq2i cA cB cR
      cqs wcel cA vx cv cR cec wceq vx cB wrex wps vx cB cA cR elqsi cA vx cv
      cR cec wceq wps vx cB cA vx cv cR cec wceq wph wps vx cv cB wcel wph wps
      wb vx cv cR cec cA ectocl.2 eqcoms ectocl.3 syl5cbi r19.23aiv syl sylbi
      $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z ps $.

    ecoptocl.1 $e |- S = ( ( B X. C ) /. R ) $.
    ecoptocl.2 $e |- ( [ <. x , y >. ] R = A -> ( ph <-> ps ) ) $.
    ecoptocl.3 $e |- ( ( x e. B /\ y e. C ) -> ph ) $.
    $( Implicit substitution of class for equivalence class of ordered pair. $)
    ecoptocl $p |- ( A e. S -> ps ) $=
      cA cS wcel cA cB cC cxp cR cqs wcel wps cS cB cC cxp cR cqs cA ecoptocl.1
      eleq2i cA cB cC cxp cR cqs wcel cA vz cv cR cec wceq vz cB cC cxp wrex
      wps vz cB cC cxp cA cR elqsi cA vz cv cR cec wceq wps vz cB cC cxp cA vx
      cv vy cv cop cR cec wceq wps wi cA vz cv cR cec wceq wps wi vx vy vz cv
      cB cC cB cC cxp cB cC cxp eqid vx cv vy cv cop vz cv wceq cA vx cv vy cv
      cop cR cec wceq cA vz cv cR cec wceq wps vx cv vy cv cop vz cv wceq vx cv
      vy cv cop cR cec vz cv cR cec cA vx cv vy cv cop vz cv cR eceq2 eqeq2d
      imbi1d cA vx cv vy cv cop cR cec wceq wph wps vx cv cB wcel vy cv cC wcel
      wa wph wps wb vx cv vy cv cop cR cec cA ecoptocl.2 eqcoms ecoptocl.3
      syl5cbi optocl r19.23aiv syl sylbi $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x y z w A $.  $d z w B $.  $d x y z w C $.  $d x y z w D $.
    $d z w S $.  $d x y z w R $.  $d x y ps $.  $d z w ch $.
    2ecoptocl.1 $e |- S = ( ( C X. D ) /. R ) $.
    2ecoptocl.2 $e |- ( [ <. x , y >. ] R = A -> ( ph <-> ps ) ) $.
    2ecoptocl.3 $e |- ( [ <. z , w >. ] R = B -> ( ps <-> ch ) ) $.
    2ecoptocl.4 $e |- ( ( ( x e. C /\ y e. D ) /\
                      ( z e. C /\ w e. D ) ) -> ph ) $.
    $( Implicit substitution of classes for equivalence classes of ordered
       pairs. $)
    2ecoptocl $p |- ( ( A e. S /\ B e. S ) -> ch ) $=
      cB cS wcel cA cS wcel wch cA cS wcel wps wi cA cS wcel wch wi vz vw cB cC
      cD cR cS 2ecoptocl.1 vz cv vw cv cop cR cec cB wceq wps wch cA cS wcel
      2ecoptocl.3 imbi2d cA cS wcel vz cv cC wcel vw cv cD wcel wa wps vz cv cC
      wcel vw cv cD wcel wa wph wi vz cv cC wcel vw cv cD wcel wa wps wi vx vy
      cA cC cD cR cS 2ecoptocl.1 vx cv vy cv cop cR cec cA wceq wph wps vz cv
      cC wcel vw cv cD wcel wa 2ecoptocl.2 imbi2d vx cv cC wcel vy cv cD wcel
      wa vz cv cC wcel vw cv cD wcel wa wph 2ecoptocl.4 ex ecoptocl com12
      ecoptocl impcom $.
      $( [23-Jul-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d z w v u B $.  $d v u C $.  $d x y z w v u D $.
    $d z w v u S $.  $d x y z w v u R $.  $d x y ps $.  $d z w ch $.
    $d v u th $.
    3ecoptocl.1 $e |- S = ( ( D X. D ) /. R ) $.
    3ecoptocl.2 $e |- ( [ <. x , y >. ] R = A -> ( ph <-> ps ) ) $.
    3ecoptocl.3 $e |- ( [ <. z , w >. ] R = B -> ( ps <-> ch ) ) $.
    3ecoptocl.4 $e |- ( [ <. v , u >. ] R = C -> ( ch <-> th ) ) $.
    3ecoptocl.5 $e |- ( ( ( x e. D /\ y e. D ) /\
                      ( z e. D /\ w e. D ) /\ ( v e. D /\ u e. D ) ) -> ph ) $.
    $( Implicit substitution of classes for equivalence classes of ordered
       pairs. $)
    3ecoptocl $p |- ( ( A e. S /\ B e. S /\ C e. S ) -> th ) $=
      cA cS wcel cB cS wcel cC cS wcel wth cB cS wcel cC cS wcel wa cA cS wcel
      wth cA cS wcel wps wi cA cS wcel wch wi cA cS wcel wth wi vz vw vv vu cB
      cC cD cD cR cS 3ecoptocl.1 vz cv vw cv cop cR cec cB wceq wps wch cA cS
      wcel 3ecoptocl.3 imbi2d vv cv vu cv cop cR cec cC wceq wch wth cA cS wcel
      3ecoptocl.4 imbi2d cA cS wcel vz cv cD wcel vw cv cD wcel wa vv cv cD
      wcel vu cv cD wcel wa wa wps vz cv cD wcel vw cv cD wcel wa vv cv cD wcel
      vu cv cD wcel wa wa wph wi vz cv cD wcel vw cv cD wcel wa vv cv cD wcel
      vu cv cD wcel wa wa wps wi vx vy cA cD cD cR cS 3ecoptocl.1 vx cv vy cv
      cop cR cec cA wceq wph wps vz cv cD wcel vw cv cD wcel wa vv cv cD wcel
      vu cv cD wcel wa wa 3ecoptocl.2 imbi2d vx cv cD wcel vy cv cD wcel wa vz
      cv cD wcel vw cv cD wcel wa vv cv cD wcel vu cv cD wcel wa wph
      3ecoptocl.5 3expib ecoptocl com12 2ecoptocl com12 3impib $.
      $( [9-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.  $d x y z w v u S $.  $d x y H $.
    $d z w v u G $.  $d x y ph $.  $d z w v u ps $.
    brecop.1 $e |- S e. _V $.
    brecop.2 $e |- Er S $.
    brecop.3 $e |- dom S = ( G X. G ) $.
    brecop.4 $e |- H = ( ( G X. G ) /. S ) $.
    brecop.5 $e |- R = { <. x , y >. | ( ( x e. H /\ y e. H ) /\
                      E. z E. w E. v E. u ( ( x = [ <. z , w >. ] S /\
                      y = [ <. v , u >. ] S ) /\ ph ) ) } $.
    brecop.6 $e |- ( ( ( ( z e. G /\ w e. G ) /\ ( A e. G /\ B e. G ) ) /\
                       ( ( v e. G /\ u e. G ) /\ ( C e. G /\ D e. G ) ) ) ->
                     ( ( [ <. z , w >. ] S = [ <. A , B >. ] S /\
                         [ <. v , u >. ] S = [ <. C , D >. ] S ) ->
                     ( ph <-> ps ) ) ) $.
    $( Binary relation on a quotient set.  Lemma for real number
       construction. $)
    brecop $p |- ( ( ( A e. G /\ B e. G ) /\ ( C e. G /\ D e. G ) ) ->
                ( [ <. A , B >. ] S R [ <. C , D >. ] S <-> ps ) ) $=
      cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa cA cB cop cS cec cC
      cD cop cS cec cR wbr cA cB cop cS cec vz cv vw cv cop cS cec wceq cC cD
      cop cS cec vv cv vu cv cop cS cec wceq wa wph wa vu wex vv wex vw wex vz
      wex wps cA cB cop cS cec cH wcel cC cD cop cS cec cH wcel cA cB cop cS
      cec cC cD cop cS cec cR wbr cA cB cop cS cec vz cv vw cv cop cS cec wceq
      cC cD cop cS cec vv cv vu cv cop cS cec wceq wa wph wa vu wex vv wex vw
      wex vz wex wb cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa cA cB cop
      cS cec cH wcel cC cD cop cS cec cH wcel wa cA cB cop cS cec cC cD cop cS
      cec cop vx cv cH wcel vy cv cH wcel wa vx cv vz cv vw cv cop cS cec wceq
      vy cv vv cv vu cv cop cS cec wceq wa wph wa vu wex vv wex vw wex vz wex
      wa vx vy copab wcel cA cB cop cS cec vz cv vw cv cop cS cec wceq cC cD
      cop cS cec vv cv vu cv cop cS cec wceq wa wph wa vu wex vv wex vw wex vz
      wex cA cB cop cS cec cC cD cop cS cec cR wbr cA cB cop cS cec cH wcel cC
      cD cop cS cec cH wcel wa cA cB cop cS cec cC cD cop cS cec cop vx cv cH
      wcel vy cv cH wcel wa vx cv vz cv vw cv cop cS cec wceq vy cv vv cv vu cv
      cop cS cec wceq wa wph wa vu wex vv wex vw wex vz wex wa vx vy copab wcel
      cA cB cop cS cec vz cv vw cv cop cS cec wceq cC cD cop cS cec vv cv vu cv
      cop cS cec wceq wa wph wa vu wex vv wex vw wex vz wex vx cv cH wcel vy cv
      cH wcel wa vx cv vz cv vw cv cop cS cec wceq vy cv vv cv vu cv cop cS cec
      wceq wa wph wa vu wex vv wex vw wex vz wex wa cA cB cop cS cec cH wcel vy
      cv cH wcel wa cA cB cop cS cec vz cv vw cv cop cS cec wceq vy cv vv cv vu
      cv cop cS cec wceq wa wph wa vu wex vv wex vw wex vz wex wa cA cB cop cS
      cec cH wcel cC cD cop cS cec cH wcel wa cA cB cop cS cec vz cv vw cv cop
      cS cec wceq cC cD cop cS cec vv cv vu cv cop cS cec wceq wa wph wa vu wex
      vv wex vw wex vz wex wa vx vy cA cB cop cS cec cC cD cop cS cec cH cH vx
      cv cA cB cop cS cec wceq vx cv cH wcel vy cv cH wcel wa cA cB cop cS cec
      cH wcel vy cv cH wcel wa vx cv vz cv vw cv cop cS cec wceq vy cv vv cv vu
      cv cop cS cec wceq wa wph wa vu wex vv wex vw wex vz wex cA cB cop cS cec
      vz cv vw cv cop cS cec wceq vy cv vv cv vu cv cop cS cec wceq wa wph wa
      vu wex vv wex vw wex vz wex vx cv cA cB cop cS cec wceq vx cv cH wcel cA
      cB cop cS cec cH wcel vy cv cH wcel vx cv cA cB cop cS cec cH eleq1
      anbi1d vx cv cA cB cop cS cec wceq vx cv vz cv vw cv cop cS cec wceq vy
      cv vv cv vu cv cop cS cec wceq wa wph wa cA cB cop cS cec vz cv vw cv cop
      cS cec wceq vy cv vv cv vu cv cop cS cec wceq wa wph wa vz vw vv vu vx cv
      cA cB cop cS cec wceq vx cv vz cv vw cv cop cS cec wceq vy cv vv cv vu cv
      cop cS cec wceq wa cA cB cop cS cec vz cv vw cv cop cS cec wceq vy cv vv
      cv vu cv cop cS cec wceq wa wph vx cv cA cB cop cS cec wceq vx cv vz cv
      vw cv cop cS cec wceq cA cB cop cS cec vz cv vw cv cop cS cec wceq vy cv
      vv cv vu cv cop cS cec wceq vx cv cA cB cop cS cec vz cv vw cv cop cS cec
      eqeq1 anbi1d anbi1d 4exbidv anbi12d vy cv cC cD cop cS cec wceq cA cB cop
      cS cec cH wcel vy cv cH wcel wa cA cB cop cS cec cH wcel cC cD cop cS cec
      cH wcel wa cA cB cop cS cec vz cv vw cv cop cS cec wceq vy cv vv cv vu cv
      cop cS cec wceq wa wph wa vu wex vv wex vw wex vz wex cA cB cop cS cec vz
      cv vw cv cop cS cec wceq cC cD cop cS cec vv cv vu cv cop cS cec wceq wa
      wph wa vu wex vv wex vw wex vz wex vy cv cC cD cop cS cec wceq vy cv cH
      wcel cC cD cop cS cec cH wcel cA cB cop cS cec cH wcel vy cv cC cD cop cS
      cec cH eleq1 anbi2d vy cv cC cD cop cS cec wceq cA cB cop cS cec vz cv vw
      cv cop cS cec wceq vy cv vv cv vu cv cop cS cec wceq wa wph wa cA cB cop
      cS cec vz cv vw cv cop cS cec wceq cC cD cop cS cec vv cv vu cv cop cS
      cec wceq wa wph wa vz vw vv vu vy cv cC cD cop cS cec wceq cA cB cop cS
      cec vz cv vw cv cop cS cec wceq vy cv vv cv vu cv cop cS cec wceq wa cA
      cB cop cS cec vz cv vw cv cop cS cec wceq cC cD cop cS cec vv cv vu cv
      cop cS cec wceq wa wph vy cv cC cD cop cS cec wceq vy cv vv cv vu cv cop
      cS cec wceq cC cD cop cS cec vv cv vu cv cop cS cec wceq cA cB cop cS cec
      vz cv vw cv cop cS cec wceq vy cv cC cD cop cS cec vv cv vu cv cop cS cec
      eqeq1 anbi2d anbi1d 4exbidv anbi12d opelopabg bianabs cA cB cop cS cec cC
      cD cop cS cec cR wbr cA cB cop cS cec cC cD cop cS cec cop cR wcel cA cB
      cop cS cec cC cD cop cS cec cop vx cv cH wcel vy cv cH wcel wa vx cv vz
      cv vw cv cop cS cec wceq vy cv vv cv vu cv cop cS cec wceq wa wph wa vu
      wex vv wex vw wex vz wex wa vx vy copab wcel cA cB cop cS cec cC cD cop
      cS cec cR df-br cR vx cv cH wcel vy cv cH wcel wa vx cv vz cv vw cv cop
      cS cec wceq vy cv vv cv vu cv cop cS cec wceq wa wph wa vu wex vv wex vw
      wex vz wex wa vx vy copab cA cB cop cS cec cC cD cop cS cec cop brecop.5
      eleq2i bitri syl5bb cG cA cB cS cH brecop.1 brecop.4 ecopqsi cG cC cD cS
      cH brecop.1 brecop.4 ecopqsi syl2an cA cG wcel cB cG wcel wa cC cG wcel
      cD cG wcel wa wa vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv vu cv
      cop cS cec cC cD cop cS cec wceq wa cA cG wcel cB cG wcel wa cC cG wcel
      cD cG wcel wa wa wph wi wa vu wex vv wex vw wex vz wex cA cG wcel cB cG
      wcel wa cC cG wcel cD cG wcel wa wa wps wi cA cB cop cS cec vz cv vw cv
      cop cS cec wceq cC cD cop cS cec vv cv vu cv cop cS cec wceq wa wph wa vu
      wex vv wex vw wex vz wex wps cA cG wcel cB cG wcel wa cC cG wcel cD cG
      wcel wa wa wph wi cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa
      wps wi vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv vu cv cop cS
      cec cC cD cop cS cec wceq wa vz vw vv vu cA cB cC cD cG cG vz cv cA wceq
      vw cv cB wceq wa vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv cC
      wceq vu cv cD wceq wa vv cv vu cv cop cS cec cC cD cop cS cec wceq vz cv
      cA wceq vw cv cB wceq wa vz cv vw cv cop cA cB cop wceq vz cv vw cv cop
      cS cec cA cB cop cS cec wceq vz cv vw cv cA cB opeq12 vz cv vw cv cop cA
      cB cop cS eceq2 syl vv cv cC wceq vu cv cD wceq wa vv cv vu cv cop cC cD
      cop wceq vv cv vu cv cop cS cec cC cD cop cS cec wceq vv cv vu cv cC cD
      opeq12 vv cv vu cv cop cC cD cop cS eceq2 syl anim12i vz cv vw cv cop cS
      cec cA cB cop cS cec wceq vv cv vu cv cop cS cec cC cD cop cS cec wceq wa
      cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa wph wps vz cv vw cv
      cop cS cec cA cB cop cS cec wceq vv cv vu cv cop cS cec cC cD cop cS cec
      wceq wa cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa vz cv cG
      wcel vw cv cG wcel wa vv cv cG wcel vu cv cG wcel wa wa wph wps wb vz cv
      vw cv cop cS cec cA cB cop cS cec wceq cA cG wcel cB cG wcel wa vz cv cG
      wcel vw cv cG wcel wa vv cv vu cv cop cS cec cC cD cop cS cec wceq cC cG
      wcel cD cG wcel wa vv cv cG wcel vu cv cG wcel wa vz cv vw cv cop cS cec
      cA cB cop cS cec wceq vz cv cG wcel vw cv cG wcel wa cA cB cop cG cG cxp
      wcel cA cG wcel cB cG wcel wa vz cv vw cv cop cS cec cA cB cop cS cec
      wceq vz cv vw cv cop cG cG cxp wcel cA cB cop cG cG cxp wcel vz cv cG
      wcel vw cv cG wcel wa vz cv vw cv cop cA cB cop cG cG cxp cS vz cv vw cv
      opex cA cB opex brecop.2 brecop.3 ereldm vz cv vw cv cG cG vw visset
      opelxp syl5bbr cA cB cG cG opelxpi syl5bir vv cv vu cv cop cS cec cC cD
      cop cS cec wceq vv cv cG wcel vu cv cG wcel wa cC cD cop cG cG cxp wcel
      cC cG wcel cD cG wcel wa vv cv vu cv cop cS cec cC cD cop cS cec wceq vv
      cv vu cv cop cG cG cxp wcel cC cD cop cG cG cxp wcel vv cv cG wcel vu cv
      cG wcel wa vv cv vu cv cop cC cD cop cG cG cxp cS vv cv vu cv opex cC cD
      opex brecop.2 brecop.3 ereldm vv cv vu cv cG cG vu visset opelxp syl5bbr
      cC cD cG cG opelxpi syl5bir im2anan9 vz cv cG wcel vw cv cG wcel wa vv cv
      cG wcel vu cv cG wcel wa wa cA cG wcel cB cG wcel wa cC cG wcel cD cG
      wcel wa wa vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv vu cv cop
      cS cec cC cD cop cS cec wceq wa wph wps wb vz cv cG wcel vw cv cG wcel wa
      vv cv cG wcel vu cv cG wcel wa wa cA cG wcel cB cG wcel wa cC cG wcel cD
      cG wcel wa wa vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv vu cv
      cop cS cec cC cD cop cS cec wceq wa wph wps wb wi vz cv cG wcel vw cv cG
      wcel wa cA cG wcel cB cG wcel wa vv cv cG wcel vu cv cG wcel wa cC cG
      wcel cD cG wcel wa vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv vu
      cv cop cS cec cC cD cop cS cec wceq wa wph wps wb wi brecop.6 an4s ex
      com13 mpdd pm5.74d cgsex4g cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel
      wa wa cA cB cop cS cec vz cv vw cv cop cS cec wceq cC cD cop cS cec vv cv
      vu cv cop cS cec wceq wa wph wa vz cv vw cv cop cS cec cA cB cop cS cec
      wceq vv cv vu cv cop cS cec cC cD cop cS cec wceq wa cA cG wcel cB cG
      wcel wa cC cG wcel cD cG wcel wa wa wph wi wa vz vw vv vu cA cG wcel cB
      cG wcel wa cC cG wcel cD cG wcel wa wa cA cB cop cS cec vz cv vw cv cop
      cS cec wceq cC cD cop cS cec vv cv vu cv cop cS cec wceq wa vz cv vw cv
      cop cS cec cA cB cop cS cec wceq vv cv vu cv cop cS cec cC cD cop cS cec
      wceq wa wph cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa wph wi
      cA cB cop cS cec vz cv vw cv cop cS cec wceq cC cD cop cS cec vv cv vu cv
      cop cS cec wceq wa vz cv vw cv cop cS cec cA cB cop cS cec wceq vv cv vu
      cv cop cS cec cC cD cop cS cec wceq wa wb cA cG wcel cB cG wcel wa cC cG
      wcel cD cG wcel wa wa cA cB cop cS cec vz cv vw cv cop cS cec wceq vz cv
      vw cv cop cS cec cA cB cop cS cec wceq cC cD cop cS cec vv cv vu cv cop
      cS cec wceq vv cv vu cv cop cS cec cC cD cop cS cec wceq cA cB cop cS cec
      vz cv vw cv cop cS cec eqcom cC cD cop cS cec vv cv vu cv cop cS cec
      eqcom anbi12i a1i cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa
      wph biimt anbi12d 4exbidv cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel
      wa wa wps biimt 3bitr4d bitrd $.
      $( [29-Jan-1996] $)
  $}

  ${
    brecop2.1 $e |- S e. _V $.
    brecop2.2 $e |- B e. _V $.
    brecop2.3 $e |- C e. _V $.
    brecop2.4 $e |- D e. _V $.
    brecop2.5 $e |- dom S = ( G X. G ) $.
    brecop2.6 $e |- H = ( ( G X. G ) /. S ) $.
    brecop2.7 $e |- R C_ ( H X. H ) $.
    brecop2.8 $e |- Q C_ ( G X. G ) $.
    brecop2.9 $e |- -. (/) e. G $.
    brecop2.10 $e |- dom F = ( G X. G ) $.
    brecop2.11 $e |- ( ( ( A e. G /\ B e. G ) /\ ( C e. G /\ D e. G ) ) ->
                    ( [ <. A , B >. ] S R [ <. C , D >. ] S <->
                    ( A F D ) Q ( B F C ) ) ) $.
    $( Binary relation on a quotient set.  Lemma for real number
       construction.  Eliminates antecedent from last hypothesis. $)
    brecop2 $p |- ( [ <. A , B >. ] S R [ <. C , D >. ] S <->
                    ( A F D ) Q ( B F C ) ) $=
      cA cB cop cS cec cC cD cop cS cec cR wbr cA cG wcel cB cG wcel wa cC cG
      wcel cD cG wcel wa wa cA cD cF co cB cC cF co cQ wbr cA cB cop cS cec cC
      cD cop cS cec cR wbr cA cB cop cS cec cH wcel cC cD cop cS cec cH wcel wa
      cA cG wcel cB cG wcel wa cC cG wcel cD cG wcel wa wa cA cB cop cS cec cC
      cD cop cS cec cH cH cR cS cvv wcel cC cD cop cS cec cvv wcel brecop2.1 cC
      cD cop cvv cS ecexg ax-mp brecop2.7 brel cA cB cop cS cec cH wcel cA cG
      wcel cB cG wcel wa cC cD cop cS cec cH wcel cC cG wcel cD cG wcel wa cA
      cB cop cS cec cH wcel cA cB cop cG cG cxp wcel cA cG wcel cB cG wcel wa
      cA cB cop cS cec cH wcel cA cB cop cS cec cG cG cxp cS cqs wcel cA cB cop
      cG cG cxp wcel cH cG cG cxp cS cqs cA cB cop cS cec brecop2.6 eleq2i cG
      cG cxp cA cB cop cS cA cB opex brecop2.5 ecelqsdm sylbi cA cB cG cG
      brecop2.2 opelxp sylib cC cD cop cS cec cH wcel cC cD cop cG cG cxp wcel
      cC cG wcel cD cG wcel wa cC cD cop cS cec cH wcel cC cD cop cS cec cG cG
      cxp cS cqs wcel cC cD cop cG cG cxp wcel cH cG cG cxp cS cqs cC cD cop cS
      cec brecop2.6 eleq2i cG cG cxp cC cD cop cS cC cD opex brecop2.5 ecelqsdm
      sylbi cC cD cG cG brecop2.4 opelxp sylib anim12i syl cA cD cF co cB cC cF
      co cQ wbr cA cG wcel cD cG wcel wa cB cG wcel cC cG wcel wa wa cA cG wcel
      cB cG wcel wa cC cG wcel cD cG wcel wa wa cA cD cF co cB cC cF co cQ wbr
      cA cD cF co cG wcel cB cC cF co cG wcel wa cA cG wcel cD cG wcel wa cB cG
      wcel cC cG wcel wa wa cA cD cF co cB cC cF co cG cG cQ cB cC cF oprex
      brecop2.8 brel cA cD cF co cG wcel cA cG wcel cD cG wcel wa cB cC cF co
      cG wcel cB cG wcel cC cG wcel wa cA cD cG cF brecop2.4 brecop2.10
      brecop2.9 ndmoprrcl cB cC cG cF brecop2.3 brecop2.10 brecop2.9 ndmoprrcl
      anim12i syl cA cG wcel cD cG wcel cB cG wcel cC cG wcel an42 sylib
      brecop2.11 pm5.21nii $.
      $( [21-Mar-2007] $) $( [13-Feb-1996] $)
  $}

  ${
    $d f g h t s r A $.  $d f g h t s r B $.  $d f g h t s r C $.
    $d f g h t s r D $.  $d x y z w v u f g h t s r F $.
    $d f g h t s r R $.
    $d x y z w v u f g h t s r S $.
    ecopopr.1 $e |- R = { <. x , y >. | ( ( x e. ( S X. S ) /\ y e. ( S X. S )
          ) /\ E. z E. w E. v E. u ( ( x = <. z , w >. /\ y = <. v , u >. ) /\
          ( z F u ) = ( w F v ) ) ) } $.
    ${
      $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
      $d x y z w v u D $.
      $( This is the first of several theorems about equivalence relations of
         the kind used in construction of fractions and signed reals, involving
         operations on equivalent classes of ordered pairs.  This theorem
         expresses the relation ` R ` (specified by the hypothesis) in terms of
         its operation ` F ` . $)
      ecopopreq $p |- ( ( ( A e. S /\ B e. S ) /\
                     ( C e. S /\ D e. S ) ) ->
          ( <. A , B >. R <. C , D >. <-> ( A F D ) = ( B F C ) ) ) $=
        vz cv vu cv cF co vw cv vv cv cF co wceq cA cD cF co cB cC cF co wceq
        vx vy vz vw vv vu cA cB cC cD cR cS vz cv cA wceq vu cv cD wceq vw cv
        cB wceq vv cv cC wceq vz cv vu cv cF co vw cv vv cv cF co wceq cA cD cF
        co cB cC cF co wceq wb vz cv cA wceq vu cv cD wceq wa vw cv cB wceq vv
        cv cC wceq wa vz cv vu cv cF co cA cD cF co vw cv vv cv cF co cB cC cF
        co vz cv cA vu cv cD cF opreq12 vw cv cB vv cv cC cF opreq12 eqeqan12d
        an42s ecopopr.1 opbrop $.
        $( [16-Aug-1995] $)
    $}

    ${
      ecopopr.com $e |- ( x F y ) = ( y F x ) $.
      $( Assuming the operation ` F ` is commutative, compute the domain the
         relation ` R ` specified by the first hypothesis. $)
      ecopoprdm $p |- dom R = ( S X. S ) $=
        cR cdm cS cS cxp cR cdm cS cS cxp cS cS cxp cxp cdm cS cS cxp cR cS cS
        cxp cS cS cxp cxp wss cR cdm cS cS cxp cS cS cxp cxp cdm wss cR vx cv
        cS cS cxp wcel vy cv cS cS cxp wcel wa vx cv vz cv vw cv cop wceq vy cv
        vv cv vu cv cop wceq wa vz cv vu cv cF co vw cv vv cv cF co wceq wa vu
        wex vv wex vw wex vz wex wa vx vy copab cS cS cxp cS cS cxp cxp
        ecopopr.1 vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz
        cv vu cv cF co vw cv vv cv cF co wceq wa vu wex vv wex vw wex vz wex vx
        vy cS cS cxp cS cS cxp opabssxp eqsstri cR cS cS cxp cS cS cxp cxp dmss
        ax-mp cS cS cxp dmxpid sseqtri vf vg cS cS cxp cR cdm cS cS relxp vf cv
        vg cv cop cS cS cxp wcel vf cv cS wcel vg cv cS wcel wa vf cv vg cv cop
        cR cdm wcel vf cv vg cv cS cS vg visset opelxp vf cv cS wcel vg cv cS
        wcel wa vf cv vg cv cop vf cv vg cv cop cop cR wcel vf cv vg cv cop cR
        cdm wcel vf cv cS wcel vg cv cS wcel wa vf cv vg cv cop vf cv vg cv cop
        cR wbr vf cv vg cv cop vf cv vg cv cop cop cR wcel vf cv cS wcel vg cv
        cS wcel wa vf cv vg cv cop vf cv vg cv cop cR wbr vf cv vg cv cF co vg
        cv vf cv cF co wceq vx vy vf cv vg cv cF vf visset vg visset
        ecopopr.com caoprcom vf cv cS wcel vg cv cS wcel wa vf cv vg cv cop vf
        cv vg cv cop cR wbr vf cv vg cv cF co vg cv vf cv cF co wceq wb vx vy
        vz vw vv vu vf cv vg cv vf cv vg cv cR cS cF ecopopr.1 ecopopreq anidms
        mpbiri vf cv vg cv cop vf cv vg cv cop cR df-br sylib vf cv vg cv cop
        vf cv vg cv cop cR vf cv vg cv opex opeldm syl sylbi relssi eqssi $.
        $( [27-Aug-1995] $)

      ${
        ecopopr.2 $e |- B e. _V $.
        $( Assuming the operation ` F ` is commutative, show that the relation
           ` R ` , specified by the first hypothesis, is symmetric. $)
        ecopoprsym $p |- ( A R B -> B R A ) $=
          cA cB cR wbr cB cA cR wbr cA cB cR wbr cA cS cS cxp wcel cB cS cS cxp
          wcel wa cA cB cR wbr cB cA cR wbr wb cA cB cS cS cxp cS cS cxp cR
          ecopopr.2 cR vx cv cS cS cxp wcel vy cv cS cS cxp wcel wa vx cv vz cv
          vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz cv vu cv cF co vw cv
          vv cv cF co wceq wa vu wex vv wex vw wex vz wex wa vx vy copab cS cS
          cxp cS cS cxp cxp ecopopr.1 vx cv vz cv vw cv cop wceq vy cv vv cv vu
          cv cop wceq wa vz cv vu cv cF co vw cv vv cv cF co wceq wa vu wex vv
          wex vw wex vz wex vx vy cS cS cxp cS cS cxp opabssxp eqsstri brel vf
          cv vg cv cop vh cv vt cv cop cR wbr vh cv vt cv cop vf cv vg cv cop
          cR wbr wb cA vh cv vt cv cop cR wbr vh cv vt cv cop cA cR wbr wb cA
          cB cR wbr cB cA cR wbr wb vf vg vh vt cA cB cS cS cS cS cxp cS cS cxp
          eqid vf cv vg cv cop cA wceq vf cv vg cv cop vh cv vt cv cop cR wbr
          cA vh cv vt cv cop cR wbr vh cv vt cv cop vf cv vg cv cop cR wbr vh
          cv vt cv cop cA cR wbr vf cv vg cv cop cA vh cv vt cv cop cR breq1 vf
          cv vg cv cop cA vh cv vt cv cop cR breq2 bibi12d vh cv vt cv cop cB
          wceq cA vh cv vt cv cop cR wbr cA cB cR wbr vh cv vt cv cop cA cR wbr
          cB cA cR wbr vh cv vt cv cop cB cA cR breq2 vh cv vt cv cop cB cA cR
          breq1 bibi12d vf cv cS wcel vg cv cS wcel wa vh cv cS wcel vt cv cS
          wcel wa wa vf cv vg cv cop vh cv vt cv cop cR wbr vh cv vg cv cF co
          vt cv vf cv cF co wceq vh cv vt cv cop vf cv vg cv cop cR wbr vf cv
          cS wcel vg cv cS wcel wa vh cv cS wcel vt cv cS wcel wa wa vf cv vg
          cv cop vh cv vt cv cop cR wbr vf cv vt cv cF co vg cv vh cv cF co
          wceq vh cv vg cv cF co vt cv vf cv cF co wceq vx vy vz vw vv vu vf cv
          vg cv vh cv vt cv cR cS cF ecopopr.1 ecopopreq vf cv vt cv cF co vg
          cv vh cv cF co wceq vt cv vf cv cF co vh cv vg cv cF co wceq vh cv vg
          cv cF co vt cv vf cv cF co wceq vf cv vt cv cF co vt cv vf cv cF co
          vg cv vh cv cF co vh cv vg cv cF co vx vy vf cv vt cv cF vf visset vt
          visset ecopopr.com caoprcom vx vy vg cv vh cv cF vg visset vh visset
          ecopopr.com caoprcom eqeq12i vt cv vf cv cF co vh cv vg cv cF co
          eqcom bitri syl6bb vh cv cS wcel vt cv cS wcel wa vf cv cS wcel vg cv
          cS wcel wa vh cv vt cv cop vf cv vg cv cop cR wbr vh cv vg cv cF co
          vt cv vf cv cF co wceq wb vx vy vz vw vv vu vh cv vt cv vf cv vg cv
          cR cS cF ecopopr.1 ecopopreq ancoms bitr4d 2optocl syl ibi $.
          $( [27-Aug-1995] $)
      $}

      ${
        $( Assume the operation is closed. $)
        ecopopr.cl $e |- ( ( x e. S /\ y e. S ) -> ( x F y ) e. S ) $.
        $( Assume the operation is associative. $)
        ecopopr.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
        $( Assume the operation has the cancellation property. $)
        ecopopr.can $e |- ( ( x e. S /\ y e. S ) ->
                   ( ( x F y ) = ( x F z ) -> y = z ) ) $.
        ${
          ecopopr.3 $e |- B e. _V $.
          ecopopr.4 $e |- C e. _V $.
          $( Assuming that operation ` F ` is commutative (second hypothesis),
             closed (third hypothesis), associative (fourth hypothesis), and
             has the cancellation property (fifth hypothesis), show that the
             relation ` R ` , specified by the first hypothesis, is
             transitive. $)
          ecopoprtrn $p |- ( ( A R B /\ B R C ) -> A R C ) $=
            cA cS cS cxp wcel cB cS cS cxp wcel cC cS cS cxp wcel w3a cA cB cR
            wbr cB cC cR wbr wa cA cC cR wbr cA cB cR wbr cB cC cR wbr wa cA cS
            cS cxp wcel cB cS cS cxp wcel cC cS cS cxp wcel wa wa cA cS cS cxp
            wcel cB cS cS cxp wcel cC cS cS cxp wcel w3a cA cB cR wbr cA cS cS
            cxp wcel cB cC cR wbr cB cS cS cxp wcel cC cS cS cxp wcel wa cA cB
            cR wbr cA cS cS cxp wcel cB cS cS cxp wcel cA cB cS cS cxp cS cS
            cxp cR ecopopr.3 cR vx cv cS cS cxp wcel vy cv cS cS cxp wcel wa vx
            cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz cv vu cv
            cF co vw cv vv cv cF co wceq wa vu wex vv wex vw wex vz wex wa vx
            vy copab cS cS cxp cS cS cxp cxp ecopopr.1 vx cv vz cv vw cv cop
            wceq vy cv vv cv vu cv cop wceq wa vz cv vu cv cF co vw cv vv cv cF
            co wceq wa vu wex vv wex vw wex vz wex vx vy cS cS cxp cS cS cxp
            opabssxp eqsstri brel pm3.26d cB cC cS cS cxp cS cS cxp cR
            ecopopr.4 cR vx cv cS cS cxp wcel vy cv cS cS cxp wcel wa vx cv vz
            cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz cv vu cv cF co
            vw cv vv cv cF co wceq wa vu wex vv wex vw wex vz wex wa vx vy
            copab cS cS cxp cS cS cxp cxp ecopopr.1 vx cv vz cv vw cv cop wceq
            vy cv vv cv vu cv cop wceq wa vz cv vu cv cF co vw cv vv cv cF co
            wceq wa vu wex vv wex vw wex vz wex vx vy cS cS cxp cS cS cxp
            opabssxp eqsstri brel anim12i cA cS cS cxp wcel cB cS cS cxp wcel
            cC cS cS cxp wcel 3anass sylibr vf cv vg cv cop vh cv vt cv cop cR
            wbr vh cv vt cv cop vs cv vr cv cop cR wbr wa vf cv vg cv cop vs cv
            vr cv cop cR wbr wi cA vh cv vt cv cop cR wbr vh cv vt cv cop vs cv
            vr cv cop cR wbr wa cA vs cv vr cv cop cR wbr wi cA cB cR wbr cB vs
            cv vr cv cop cR wbr wa cA vs cv vr cv cop cR wbr wi cA cB cR wbr cB
            cC cR wbr wa cA cC cR wbr wi vf vg vh vt vs vr cA cB cC cS cS cS
            cxp cS cS cS cxp eqid vf cv vg cv cop cA wceq vf cv vg cv cop vh cv
            vt cv cop cR wbr vh cv vt cv cop vs cv vr cv cop cR wbr wa cA vh cv
            vt cv cop cR wbr vh cv vt cv cop vs cv vr cv cop cR wbr wa vf cv vg
            cv cop vs cv vr cv cop cR wbr cA vs cv vr cv cop cR wbr vf cv vg cv
            cop cA wceq vf cv vg cv cop vh cv vt cv cop cR wbr cA vh cv vt cv
            cop cR wbr vh cv vt cv cop vs cv vr cv cop cR wbr vf cv vg cv cop
            cA vh cv vt cv cop cR breq1 anbi1d vf cv vg cv cop cA vs cv vr cv
            cop cR breq1 imbi12d vh cv vt cv cop cB wceq cA vh cv vt cv cop cR
            wbr vh cv vt cv cop vs cv vr cv cop cR wbr wa cA cB cR wbr cB vs cv
            vr cv cop cR wbr wa cA vs cv vr cv cop cR wbr vh cv vt cv cop cB
            wceq cA vh cv vt cv cop cR wbr cA cB cR wbr vh cv vt cv cop vs cv
            vr cv cop cR wbr cB vs cv vr cv cop cR wbr vh cv vt cv cop cB cA cR
            breq2 vh cv vt cv cop cB vs cv vr cv cop cR breq1 anbi12d imbi1d vs
            cv vr cv cop cC wceq cA cB cR wbr cB vs cv vr cv cop cR wbr wa cA
            cB cR wbr cB cC cR wbr wa cA vs cv vr cv cop cR wbr cA cC cR wbr vs
            cv vr cv cop cC wceq cB vs cv vr cv cop cR wbr cB cC cR wbr cA cB
            cR wbr vs cv vr cv cop cC cB cR breq2 anbi2d vs cv vr cv cop cC cA
            cR breq2 imbi12d vf cv cS wcel vg cv cS wcel wa vh cv cS wcel vt cv
            cS wcel wa vs cv cS wcel vr cv cS wcel wa w3a vf cv vg cv cop vh cv
            vt cv cop cR wbr vh cv vt cv cop vs cv vr cv cop cR wbr wa vf cv vr
            cv cF co vg cv vs cv cF co wceq vf cv vg cv cop vs cv vr cv cop cR
            wbr vf cv cS wcel vg cv cS wcel wa vh cv cS wcel vt cv cS wcel wa
            vs cv cS wcel vr cv cS wcel wa w3a vf cv vg cv cop vh cv vt cv cop
            cR wbr vh cv vt cv cop vs cv vr cv cop cR wbr wa vh cv vt cv cF co
            vf cv vr cv cF co cF co vh cv vt cv cF co vg cv vs cv cF co cF co
            wceq vf cv vr cv cF co vg cv vs cv cF co wceq vf cv cS wcel vg cv
            cS wcel wa vh cv cS wcel vt cv cS wcel wa vs cv cS wcel vr cv cS
            wcel wa w3a vf cv vg cv cop vh cv vt cv cop cR wbr vh cv vt cv cop
            vs cv vr cv cop cR wbr wa vf cv vt cv cF co vg cv vh cv cF co wceq
            vh cv vr cv cF co vt cv vs cv cF co wceq wa vh cv vt cv cF co vf cv
            vr cv cF co cF co vh cv vt cv cF co vg cv vs cv cF co cF co wceq vf
            cv cS wcel vg cv cS wcel wa vh cv cS wcel vt cv cS wcel wa vs cv cS
            wcel vr cv cS wcel wa w3a vf cv vg cv cop vh cv vt cv cop cR wbr vf
            cv vt cv cF co vg cv vh cv cF co wceq vh cv vt cv cop vs cv vr cv
            cop cR wbr vh cv vr cv cF co vt cv vs cv cF co wceq vf cv cS wcel
            vg cv cS wcel wa vh cv cS wcel vt cv cS wcel wa vf cv vg cv cop vh
            cv vt cv cop cR wbr vf cv vt cv cF co vg cv vh cv cF co wceq wb vs
            cv cS wcel vr cv cS wcel wa vx vy vz vw vv vu vf cv vg cv vh cv vt
            cv cR cS cF ecopopr.1 ecopopreq 3adant3 vh cv cS wcel vt cv cS wcel
            wa vs cv cS wcel vr cv cS wcel wa vh cv vt cv cop vs cv vr cv cop
            cR wbr vh cv vr cv cF co vt cv vs cv cF co wceq wb vf cv cS wcel vg
            cv cS wcel wa vx vy vz vw vv vu vh cv vt cv vs cv vr cv cR cS cF
            ecopopr.1 ecopopreq 3adant1 anbi12d vf cv vt cv cF co vg cv vh cv
            cF co wceq vh cv vr cv cF co vt cv vs cv cF co wceq wa vf cv vt cv
            cF co vh cv vr cv cF co cF co vg cv vh cv cF co vt cv vs cv cF co
            cF co vh cv vt cv cF co vf cv vr cv cF co cF co vh cv vt cv cF co
            vg cv vs cv cF co cF co vf cv vt cv cF co vg cv vh cv cF co vh cv
            vr cv cF co vt cv vs cv cF co cF opreq12 vx vy vz vh cv vt cv vf cv
            vr cv cF vh visset vt visset vf visset ecopopr.com ecopopr.ass vr
            visset caopr411 vg cv vt cv cF co vh cv vs cv cF co cF co vh cv vt
            cv cF co vg cv vs cv cF co cF co vg cv vh cv cF co vt cv vs cv cF
            co cF co vx vy vz vg cv vt cv vh cv vs cv cF vg visset vt visset vh
            visset ecopopr.com ecopopr.ass vs visset caopr411 vx vy vz vg cv vt
            cv vh cv vs cv cF vg visset vt visset vh visset ecopopr.com
            ecopopr.ass vs visset caopr4 eqtr3i 3eqtr4g syl6bi vf cv cS wcel vh
            cv cS wcel vt cv cS wcel wa vs cv cS wcel vr cv cS wcel wa vh cv vt
            cv cF co vf cv vr cv cF co cF co vh cv vt cv cF co vg cv vs cv cF
            co cF co wceq vf cv vr cv cF co vg cv vs cv cF co wceq wi vg cv cS
            wcel vf cv cS wcel vh cv cS wcel vt cv cS wcel wa vr cv cS wcel vh
            cv vt cv cF co vf cv vr cv cF co cF co vh cv vt cv cF co vg cv vs
            cv cF co cF co wceq vf cv vr cv cF co vg cv vs cv cF co wceq wi vs
            cv cS wcel vh cv cS wcel vt cv cS wcel wa vf cv cS wcel vr cv cS
            wcel vh cv vt cv cF co vf cv vr cv cF co cF co vh cv vt cv cF co vg
            cv vs cv cF co cF co wceq vf cv vr cv cF co vg cv vs cv cF co wceq
            wi vh cv cS wcel vt cv cS wcel wa vf cv cS wcel vr cv cS wcel vh cv
            vt cv cF co vf cv vr cv cF co cF co vh cv vt cv cF co vg cv vs cv
            cF co cF co wceq vf cv vr cv cF co vg cv vs cv cF co wceq wi vh cv
            vt cv cF co cS wcel vf cv vr cv cF co cS wcel vh cv vt cv cF co vf
            cv vr cv cF co cF co vh cv vt cv cF co vg cv vs cv cF co cF co wceq
            vf cv vr cv cF co vg cv vs cv cF co wceq wi vh cv cS wcel vt cv cS
            wcel wa vf cv cS wcel vr cv cS wcel wa vx vy vz vh cv vt cv cF co
            vf cv vr cv cF co vg cv vs cv cF co cS cF vg cv vs cv cF oprex
            ecopopr.can caoprcan vx vy vh cv vt cv cS cF ecopopr.cl caoprcl vx
            vy vf cv vr cv cS cF ecopopr.cl caoprcl syl2an 3impb 3com12
            3adant3l 3adant1r syld vf cv cS wcel vg cv cS wcel wa vs cv cS wcel
            vr cv cS wcel wa vf cv vg cv cop vs cv vr cv cop cR wbr vf cv vr cv
            cF co vg cv vs cv cF co wceq wb vh cv cS wcel vt cv cS wcel wa vx
            vy vz vw vv vu vf cv vg cv vs cv vr cv cR cS cF ecopopr.1 ecopopreq
            3adant2 sylibrd 3optocl mpcom $.
            $( [11-Feb-1996] $)
        $}

        $( Assuming that operation ` F ` is commutative (second hypothesis),
           closed (third hypothesis), associative (fourth hypothesis), and
           has the cancellation property (fifth hypothesis), show that the
           relation ` R ` , specified by the first hypothesis, is an
           equivalence relation. $)
        ecopoprer $p |- Er R $=
          vf vg vh cR vx vy vz vw vv vu vf cv vg cv cR cS cF ecopopr.1
          ecopopr.com vg visset ecopoprsym vx vy vz vw vv vu vf cv vg cv vh cv
          cR cS cF ecopopr.1 ecopopr.com ecopopr.cl ecopopr.ass ecopopr.can vg
          visset vh visset ecopoprtrn ster $.
          $( [16-Feb-1996] $)
      $}

    $}
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y A $.  $d x y B $.  $d x y C $.
    $d x y D $.
    eceqopreq.2 $e |- B e. _V $.
    $( (We don't bother to eliminate this redundant hypothesis.) $)
    eceqopreq.3 $e |- C e. _V $.
    eceqopreq.4 $e |- D e. _V $.
    eceqopreq.5 $e |- Er R $.
    eceqopreq.6 $e |- dom R = ( S X. S ) $.
    eceqopreq.7 $e |- dom F = ( S X. S ) $.
    eceqopreq.8 $e |- -. (/) e. S $.
    eceqopreq.9 $e |- ( ( x e. S /\ y e. S ) -> ( x F y ) e. S ) $.
    eceqopreq.10 $e |- ( ( ( A e. S /\ B e. S ) /\
                     ( C e. S /\ D e. S ) ) ->
          ( <. A , B >. R <. C , D >. <-> ( A F D ) = ( B F C ) ) ) $.
    $( Equality of equivalence relation in terms of an operation. $)
    eceqopreq $p |- ( ( A e. S /\ C e. S ) ->
                      ( [ <. A , B >. ] R = [ <. C , D >. ] R <->
                      ( A F D ) = ( B F C ) ) ) $=
      cA cS wcel cC cS wcel wa cB cS wcel cA cB cop cR cec cC cD cop cR cec
      wceq cA cD cF co cB cC cF co wceq wb cA cS wcel cC cS wcel cB cS wcel cA
      cB cop cR cec cC cD cop cR cec wceq cA cD cF co cB cC cF co wceq wb wi cA
      cS wcel cB cS wcel cC cS wcel cA cB cop cR cec cC cD cop cR cec wceq cA
      cD cF co cB cC cF co wceq wb cA cS wcel cB cS wcel cC cS wcel cA cB cop
      cR cec cC cD cop cR cec wceq cA cD cF co cB cC cF co wceq wb cA cS wcel
      cB cS wcel cC cS wcel w3a cD cS wcel cA cB cop cR cec cC cD cop cR cec
      wceq cA cD cF co cB cC cF co wceq wb cA cS wcel cB cS wcel cC cS wcel cD
      cS wcel cA cB cop cR cec cC cD cop cR cec wceq cA cD cF co cB cC cF co
      wceq wb wi cA cS wcel cB cS wcel cC cS wcel cD cS wcel cA cB cop cR cec
      cC cD cop cR cec wceq cA cD cF co cB cC cF co wceq wb cA cS wcel cB cS
      wcel wa cC cS wcel cD cS wcel wa wa cA cB cop cR cec cC cD cop cR cec
      wceq cA cB cop cC cD cop cR wbr cA cD cF co cB cC cF co wceq cA cS wcel
      cB cS wcel wa cC cS wcel cD cS wcel wa wa cA cS wcel cB cS wcel wa cA cB
      cop cR cdm wcel cA cB cop cR cec cC cD cop cR cec wceq cA cB cop cC cD
      cop cR wbr wb cA cS wcel cB cS wcel wa cC cS wcel cD cS wcel wa pm3.26 cA
      cS wcel cB cS wcel wa cA cB cop cS cS cxp cR cdm cA cB cS cS opelxpi
      eceqopreq.6 syl6eleqr cA cB cop cC cD cop cR cC cD opex eceqopreq.5
      erthdm 3syl eceqopreq.10 bitrd exp43 3imp cA cS wcel cB cS wcel cC cS
      wcel w3a cD cS wcel wn cA cB cop cR cec cC cD cop cR cec wne cA cD cF co
      cB cC cF co wne wa cA cB cop cR cec cC cD cop cR cec wceq cA cD cF co cB
      cC cF co wceq wb cA cS wcel cB cS wcel cC cS wcel w3a cD cS wcel wn cA cB
      cop cR cec cC cD cop cR cec wne cA cD cF co cB cC cF co wne cA cS wcel cB
      cS wcel cD cS wcel wn cA cB cop cR cec cC cD cop cR cec wne wi cC cS wcel
      cD cS wcel wn cA cS wcel cB cS wcel wa cA cB cop cR cec cC cD cop cR cec
      wne cD cS wcel wn cA cB cop cR cec c0 wne cA cB cop cR cec cC cD cop cR
      cec wne cA cS wcel cB cS wcel wa cD cS wcel wn cC cD cop cR cec c0 wceq
      cA cB cop cR cec c0 wne cA cB cop cR cec cC cD cop cR cec wne wi cD cS
      wcel cC cD cop cR cec c0 cC cD cop cR cec c0 wne cC cS wcel cD cS wcel cC
      cD cop cR cdm wcel cC cD cop cS cS cxp wcel cC cD cop cR cec c0 wne cC cS
      wcel cD cS wcel wa cR cdm cS cS cxp cC cD cop eceqopreq.6 eleq2i cC cD
      cop cR cC cD opex ecdmn0 cC cD cS cS eceqopreq.4 opelxp 3bitr3i pm3.27bi
      necon1bi cC cD cop cR cec c0 wceq cA cB cop cR cec cC cD cop cR cec cA cB
      cop cR cec c0 cA cB cop cR cec cC cD cop cR cec wceq cA cB cop cR cec c0
      wceq cC cD cop cR cec c0 wceq cA cB cop cR cec cC cD cop cR cec c0 eqeq1
      biimprcd necon3d syl cA cB cop cR cdm wcel cA cB cop cS cS cxp wcel cA cB
      cop cR cec c0 wne cA cS wcel cB cS wcel wa cR cdm cS cS cxp cA cB cop
      eceqopreq.6 eleq2i cA cB cop cR cA cB opex ecdmn0 cA cB cS cS eceqopreq.2
      opelxp 3bitr3i syl5ibr com12 3adant3 cB cS wcel cC cS wcel cD cS wcel wn
      cA cD cF co cB cC cF co wne wi cA cS wcel cB cS wcel cC cS wcel wa cD cS
      wcel cA cD cF co cB cC cF co cA cD cF co cB cC cF co wceq cB cS wcel cC
      cS wcel wa cA cD cF co cS wcel cD cS wcel cA cD cF co cB cC cF co wceq cA
      cD cF co cS wcel cB cC cF co cS wcel cB cS wcel cC cS wcel wa cA cD cF co
      cB cC cF co cS eleq1 vx vy cB cC cS cF eceqopreq.9 caoprcl syl5bir cA cD
      cF co cS wcel cA cS wcel cD cS wcel cA cD cS cF eceqopreq.4 eceqopreq.7
      eceqopreq.8 ndmoprrcl pm3.27d syl6com necon3bd 3adant1 jcad cA cB cop cR
      cec cC cD cop cR cec wne cA cD cF co cB cC cF co wne wa cA cB cop cR cec
      cC cD cop cR cec cA cD cF co cB cC cF co cA cB cop cR cec cC cD cop cR
      cec wne cA cD cF co cB cC cF co wne pm5.1 necon4bid syl6 pm2.61d 3exp
      com23 imp cA cS wcel cC cS wcel wa cD cS wcel cB cS wcel wn cA cB cop cR
      cec cC cD cop cR cec wceq cA cD cF co cB cC cF co wceq wb wi cA cS wcel
      cC cS wcel cD cS wcel cB cS wcel wn cA cB cop cR cec cC cD cop cR cec
      wceq cA cD cF co cB cC cF co wceq wb wi cA cS wcel cC cS wcel cD cS wcel
      w3a cB cS wcel wn cA cB cop cR cec cC cD cop cR cec wne cA cD cF co cB cC
      cF co wne wa cA cB cop cR cec cC cD cop cR cec wceq cA cD cF co cB cC cF
      co wceq wb cA cS wcel cC cS wcel cD cS wcel w3a cB cS wcel wn cA cB cop
      cR cec cC cD cop cR cec wne cA cD cF co cB cC cF co wne cC cS wcel cD cS
      wcel cB cS wcel wn cA cB cop cR cec cC cD cop cR cec wne wi cA cS wcel cB
      cS wcel wn cC cS wcel cD cS wcel wa cA cB cop cR cec cC cD cop cR cec wne
      cB cS wcel wn cC cD cop cR cec c0 wne cA cB cop cR cec cC cD cop cR cec
      wne cC cS wcel cD cS wcel wa cB cS wcel wn cA cB cop cR cec c0 wceq cC cD
      cop cR cec c0 wne cA cB cop cR cec cC cD cop cR cec wne wi cB cS wcel cA
      cB cop cR cec c0 cA cB cop cR cec c0 wne cA cS wcel cB cS wcel cA cB cop
      cR cdm wcel cA cB cop cS cS cxp wcel cA cB cop cR cec c0 wne cA cS wcel
      cB cS wcel wa cR cdm cS cS cxp cA cB cop eceqopreq.6 eleq2i cA cB cop cR
      cA cB opex ecdmn0 cA cB cS cS eceqopreq.2 opelxp 3bitr3i pm3.27bi
      necon1bi cA cB cop cR cec c0 wceq cA cB cop cR cec cC cD cop cR cec cC cD
      cop cR cec c0 cA cB cop cR cec cC cD cop cR cec wceq cA cB cop cR cec c0
      wceq cC cD cop cR cec c0 wceq cA cB cop cR cec cC cD cop cR cec c0 eqeq1
      biimpcd necon3d syl cC cD cop cR cdm wcel cC cD cop cS cS cxp wcel cC cD
      cop cR cec c0 wne cC cS wcel cD cS wcel wa cR cdm cS cS cxp cC cD cop
      eceqopreq.6 eleq2i cC cD cop cR cC cD opex ecdmn0 cC cD cS cS eceqopreq.4
      opelxp 3bitr3i syl5ibr com12 3adant1 cA cS wcel cD cS wcel cB cS wcel wn
      cA cD cF co cB cC cF co wne wi cC cS wcel cA cS wcel cD cS wcel wa cB cS
      wcel cA cD cF co cB cC cF co cA cD cF co cB cC cF co wceq cA cS wcel cD
      cS wcel wa cB cC cF co cS wcel cB cS wcel cA cD cF co cB cC cF co wceq cA
      cD cF co cS wcel cB cC cF co cS wcel cA cS wcel cD cS wcel wa cA cD cF co
      cB cC cF co cS eleq1 vx vy cA cD cS cF eceqopreq.9 caoprcl syl5bi cB cC
      cF co cS wcel cB cS wcel cC cS wcel cB cC cS cF eceqopreq.3 eceqopreq.7
      eceqopreq.8 ndmoprrcl pm3.26d syl6com necon3bd 3adant2 jcad cA cB cop cR
      cec cC cD cop cR cec wne cA cD cF co cB cC cF co wne wa cA cB cop cR cec
      cC cD cop cR cec cA cD cF co cB cC cF co cA cB cop cR cec cC cD cop cR
      cec wne cA cD cF co cB cC cF co wne pm5.1 necon4bid syl6 3expia cD cS
      wcel wn cB cS wcel wn cA cB cop cR cec cC cD cop cR cec wceq cA cD cF co
      cB cC cF co wceq wa cA cB cop cR cec cC cD cop cR cec wceq cA cD cF co cB
      cC cF co wceq wb cD cS wcel wn cB cS wcel wn cA cB cop cR cec cC cD cop
      cR cec wceq cA cD cF co cB cC cF co wceq cD cS wcel wn cA cB cop cR cec
      cC cD cop cR cec wceq cA cB cop cR cec c0 wceq cB cS wcel wn cD cS wcel
      wn cC cD cop cR cec c0 cA cB cop cR cec cD cS wcel cC cD cop cR cec c0 cC
      cD cop cR cec c0 wne cC cS wcel cD cS wcel cC cD cop cR cdm wcel cC cD
      cop cS cS cxp wcel cC cD cop cR cec c0 wne cC cS wcel cD cS wcel wa cR
      cdm cS cS cxp cC cD cop eceqopreq.6 eleq2i cC cD cop cR cC cD opex ecdmn0
      cC cD cS cS eceqopreq.4 opelxp 3bitr3i pm3.27bi necon1bi eqeq2d cB cS
      wcel cA cB cop cR cec c0 cA cB cop cR cec c0 wne cA cS wcel cB cS wcel cA
      cB cop cR cdm wcel cA cB cop cS cS cxp wcel cA cB cop cR cec c0 wne cA cS
      wcel cB cS wcel wa cR cdm cS cS cxp cA cB cop eceqopreq.6 eleq2i cA cB
      cop cR cA cB opex ecdmn0 cA cB cS cS eceqopreq.2 opelxp 3bitr3i pm3.27bi
      necon1bi syl5bir cB cS wcel wn cD cS wcel wn cA cD cF co cB cC cF co wceq
      cB cS wcel wn cB cS wcel cC cS wcel wa wn cB cC cF co c0 wceq cD cS wcel
      wn cA cD cF co cB cC cF co wceq wi cB cS wcel cC cS wcel wa cB cS wcel cB
      cS wcel cC cS wcel pm3.26 con3i cB cC cS cF eceqopreq.3 eceqopreq.7
      ndmopr cB cC cF co c0 wceq cA cD cF co cB cC cF co wceq cA cD cF co c0
      wceq cD cS wcel wn cB cC cF co c0 cA cD cF co eqeq2 cD cS wcel wn cA cS
      wcel cD cS wcel wa wn cA cD cF co c0 wceq cA cS wcel cD cS wcel wa cD cS
      wcel cA cS wcel cD cS wcel pm3.27 con3i cA cD cS cF eceqopreq.4
      eceqopreq.7 ndmopr syl syl5bir 3syl com12 jcad cA cB cop cR cec cC cD cop
      cR cec wceq cA cD cF co cB cC cF co wceq pm5.1 syl6 pm2.61d1 pm2.61d $.
      $( [15-Feb-1996] $)
  $}

  ${
    $d x y z w v u F $.
    $d x y z w v u R $.
    $d x y z w v u S $.
    $d x y z w v u A $.
    $d x y z w v u B $.
    th3qlem1.1 $e |- Er R $.
    th3qlem1.2 $e |- dom R = S $.
    $( Compatibility assumption. $)
    th3qlem1.3 $e |- ( ( ( y e. S /\ w e. S ) /\ ( z e. S /\ v e. S ) ) ->
                 ( ( y R w /\ z R v ) -> ( y F z ) R ( w F v ) ) ) $.
    $( Lemma for Exercise 44 version of Theorem 3Q of [Enderton] p. 60.  The
       third hypothesis is the compatibility assumption. $)
    th3qlem1 $p |- ( ( A e. ( S /. R ) /\ B e. ( S /. R ) ) -> E* x
       E. y E. z ( ( A = [ y ] R /\ B = [ z ] R ) /\
       x = [ ( y F z ) ] R ) ) $=
      cA cS cR cqs wcel cB cS cR cqs wcel wa cA vy cv cR cec wceq cB vz cv cR
      cec wceq wa vx cv vy cv vz cv cF co cR cec wceq wa vz wex vy wex cA vw cv
      cR cec wceq cB vv cv cR cec wceq wa vu cv vw cv vv cv cF co cR cec wceq
      wa vv wex vw wex wa vx cv vu cv wceq wi vu wal vx wal cA vy cv cR cec
      wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq wa vz
      wex vy wex vx wmo cA cS cR cqs wcel cB cS cR cqs wcel wa cA vy cv cR cec
      wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq wa vz
      wex vy wex cA vw cv cR cec wceq cB vv cv cR cec wceq wa vu cv vw cv vv cv
      cF co cR cec wceq wa vv wex vw wex wa vx cv vu cv wceq wi vx vu cA cS cR
      cqs wcel cB cS cR cqs wcel wa cA vy cv cR cec wceq cB vz cv cR cec wceq
      wa vx cv vy cv vz cv cF co cR cec wceq wa cA vw cv cR cec wceq cB vv cv
      cR cec wceq wa vu cv vw cv vv cv cF co cR cec wceq wa wa vv wex vw wex vz
      wex vy wex vx cv vu cv wceq cA vy cv cR cec wceq cB vz cv cR cec wceq wa
      vx cv vy cv vz cv cF co cR cec wceq wa vz wex vy wex cA vw cv cR cec wceq
      cB vv cv cR cec wceq wa vu cv vw cv vv cv cF co cR cec wceq wa vv wex vw
      wex wa cA cS cR cqs wcel cB cS cR cqs wcel wa cA vy cv cR cec wceq cB vz
      cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq wa cA vw cv cR cec
      wceq cB vv cv cR cec wceq wa vu cv vw cv vv cv cF co cR cec wceq wa wa vv
      wex vw wex vx cv vu cv wceq vy vz cA cS cR cqs wcel cB cS cR cqs wcel wa
      cA vy cv cR cec wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv cF co cR
      cec wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa vu cv vw cv vv
      cv cF co cR cec wceq wa wa vx cv vu cv wceq vw vv cA cS cR cqs wcel cB cS
      cR cqs wcel wa cA vy cv cR cec wceq cB vz cv cR cec wceq wa cA vw cv cR
      cec wceq cB vv cv cR cec wceq wa wa vx cv vy cv vz cv cF co cR cec wceq
      vu cv vw cv vv cv cF co cR cec wceq wa wa vx cv vu cv wceq cA vy cv cR
      cec wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq wa
      cA vw cv cR cec wceq cB vv cv cR cec wceq wa vu cv vw cv vv cv cF co cR
      cec wceq wa wa cA cS cR cqs wcel cB cS cR cqs wcel wa cA vy cv cR cec
      wceq cB vz cv cR cec wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa
      wa vx cv vy cv vz cv cF co cR cec wceq vu cv vw cv vv cv cF co cR cec
      wceq wa vx cv vu cv wceq cA cS cR cqs wcel cA cS cR cqs wcel wa cB cS cR
      cqs wcel cB cS cR cqs wcel wa wa cA vy cv cR cec wceq cB vz cv cR cec
      wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa wa vx cv vy cv vz cv
      cF co cR cec wceq vu cv vw cv vv cv cF co cR cec wceq wa vx cv vu cv wceq
      wi cA cS cR cqs wcel cB cS cR cqs wcel wa cA cS cR cqs wcel cA cS cR cqs
      wcel wa cB cS cR cqs wcel cB cS cR cqs wcel wa wa cA vy cv cR cec wceq cB
      vz cv cR cec wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa wa wa
      vy cv cR cec cS cR cqs wcel cA vy cv cR cec wceq wa vw cv cR cec cS cR
      cqs wcel cA vw cv cR cec wceq wa wa vz cv cR cec cS cR cqs wcel cB vz cv
      cR cec wceq wa vv cv cR cec cS cR cqs wcel cB vv cv cR cec wceq wa wa wa
      vx cv vy cv vz cv cF co cR cec wceq vu cv vw cv vv cv cF co cR cec wceq
      wa vx cv vu cv wceq wi cA cS cR cqs wcel cA cS cR cqs wcel wa cB cS cR
      cqs wcel cB cS cR cqs wcel wa wa cA vy cv cR cec wceq cB vz cv cR cec
      wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa wa wa cA cS cR cqs
      wcel cA cS cR cqs wcel wa cB cS cR cqs wcel cB cS cR cqs wcel wa wa cA vy
      cv cR cec wceq cA vw cv cR cec wceq wa cB vz cv cR cec wceq cB vv cv cR
      cec wceq wa wa wa cA cS cR cqs wcel cA cS cR cqs wcel wa cA vy cv cR cec
      wceq cA vw cv cR cec wceq wa wa cB cS cR cqs wcel cB cS cR cqs wcel wa cB
      vz cv cR cec wceq cB vv cv cR cec wceq wa wa wa vy cv cR cec cS cR cqs
      wcel cA vy cv cR cec wceq wa vw cv cR cec cS cR cqs wcel cA vw cv cR cec
      wceq wa wa vz cv cR cec cS cR cqs wcel cB vz cv cR cec wceq wa vv cv cR
      cec cS cR cqs wcel cB vv cv cR cec wceq wa wa wa cA vy cv cR cec wceq cB
      vz cv cR cec wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa wa cA
      vy cv cR cec wceq cA vw cv cR cec wceq wa cB vz cv cR cec wceq cB vv cv
      cR cec wceq wa wa cA cS cR cqs wcel cA cS cR cqs wcel wa cB cS cR cqs
      wcel cB cS cR cqs wcel wa wa cA vy cv cR cec wceq cB vz cv cR cec wceq cA
      vw cv cR cec wceq cB vv cv cR cec wceq an4 anbi2i cA cS cR cqs wcel cA cS
      cR cqs wcel wa cB cS cR cqs wcel cB cS cR cqs wcel wa cA vy cv cR cec
      wceq cA vw cv cR cec wceq wa cB vz cv cR cec wceq cB vv cv cR cec wceq wa
      an4 cA cS cR cqs wcel cA cS cR cqs wcel wa cA vy cv cR cec wceq cA vw cv
      cR cec wceq wa wa vy cv cR cec cS cR cqs wcel cA vy cv cR cec wceq wa vw
      cv cR cec cS cR cqs wcel cA vw cv cR cec wceq wa wa cB cS cR cqs wcel cB
      cS cR cqs wcel wa cB vz cv cR cec wceq cB vv cv cR cec wceq wa wa vz cv
      cR cec cS cR cqs wcel cB vz cv cR cec wceq wa vv cv cR cec cS cR cqs wcel
      cB vv cv cR cec wceq wa wa cA cS cR cqs wcel cA cS cR cqs wcel wa cA vy
      cv cR cec wceq cA vw cv cR cec wceq wa wa cA cS cR cqs wcel cA vy cv cR
      cec wceq wa cA cS cR cqs wcel cA vw cv cR cec wceq wa wa vy cv cR cec cS
      cR cqs wcel cA vy cv cR cec wceq wa vw cv cR cec cS cR cqs wcel cA vw cv
      cR cec wceq wa wa cA cS cR cqs wcel cA cS cR cqs wcel cA vy cv cR cec
      wceq cA vw cv cR cec wceq an4 cA cS cR cqs wcel cA vy cv cR cec wceq wa
      vy cv cR cec cS cR cqs wcel cA vy cv cR cec wceq wa cA cS cR cqs wcel cA
      vw cv cR cec wceq wa vw cv cR cec cS cR cqs wcel cA vw cv cR cec wceq wa
      cA vy cv cR cec wceq cA cS cR cqs wcel vy cv cR cec cS cR cqs wcel cA vy
      cv cR cec cS cR cqs eleq1 pm5.32ri cA vw cv cR cec wceq cA cS cR cqs wcel
      vw cv cR cec cS cR cqs wcel cA vw cv cR cec cS cR cqs eleq1 pm5.32ri
      anbi12i bitri cB cS cR cqs wcel cB cS cR cqs wcel wa cB vz cv cR cec wceq
      cB vv cv cR cec wceq wa wa cB cS cR cqs wcel cB vz cv cR cec wceq wa cB
      cS cR cqs wcel cB vv cv cR cec wceq wa wa vz cv cR cec cS cR cqs wcel cB
      vz cv cR cec wceq wa vv cv cR cec cS cR cqs wcel cB vv cv cR cec wceq wa
      wa cB cS cR cqs wcel cB cS cR cqs wcel cB vz cv cR cec wceq cB vv cv cR
      cec wceq an4 cB cS cR cqs wcel cB vz cv cR cec wceq wa vz cv cR cec cS cR
      cqs wcel cB vz cv cR cec wceq wa cB cS cR cqs wcel cB vv cv cR cec wceq
      wa vv cv cR cec cS cR cqs wcel cB vv cv cR cec wceq wa cB vz cv cR cec
      wceq cB cS cR cqs wcel vz cv cR cec cS cR cqs wcel cB vz cv cR cec cS cR
      cqs eleq1 pm5.32ri cB vv cv cR cec wceq cB cS cR cqs wcel vv cv cR cec cS
      cR cqs wcel cB vv cv cR cec cS cR cqs eleq1 pm5.32ri anbi12i bitri
      anbi12i 3bitri vy cv cR cec cS cR cqs wcel vw cv cR cec cS cR cqs wcel wa
      cA vy cv cR cec wceq cA vw cv cR cec wceq wa wa vz cv cR cec cS cR cqs
      wcel vv cv cR cec cS cR cqs wcel wa cB vz cv cR cec wceq cB vv cv cR cec
      wceq wa wa vx cv vy cv vz cv cF co cR cec wceq vu cv vw cv vv cv cF co cR
      cec wceq wa vx cv vu cv wceq wi vy cv cR cec cS cR cqs wcel cA vy cv cR
      cec wceq wa vw cv cR cec cS cR cqs wcel cA vw cv cR cec wceq wa wa vz cv
      cR cec cS cR cqs wcel cB vz cv cR cec wceq wa vv cv cR cec cS cR cqs wcel
      cB vv cv cR cec wceq wa wa vy cv cR cec cS cR cqs wcel vw cv cR cec cS cR
      cqs wcel wa vz cv cR cec cS cR cqs wcel vv cv cR cec cS cR cqs wcel wa cA
      vy cv cR cec wceq cA vw cv cR cec wceq wa cB vz cv cR cec wceq cB vv cv
      cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq vu cv vw cv vv cv cF
      co cR cec wceq wa vx cv vu cv wceq wi vy cv cS wcel vw cv cS wcel wa vz
      cv cS wcel vv cv cS wcel wa wa vy cv cR cec vw cv cR cec wceq vz cv cR
      cec vv cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq vu cv vw cv
      vv cv cF co cR cec wceq wa vx cv vu cv wceq wi vy cv cR cec cS cR cqs
      wcel vw cv cR cec cS cR cqs wcel wa vz cv cR cec cS cR cqs wcel vv cv cR
      cec cS cR cqs wcel wa wa cA vy cv cR cec wceq cA vw cv cR cec wceq wa cB
      vz cv cR cec wceq cB vv cv cR cec wceq wa wa vy cv cS wcel vw cv cS wcel
      wa vz cv cS wcel vv cv cS wcel wa wa vy cv cR cec vw cv cR cec wceq vz cv
      cR cec vv cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec wceq vu cv vw
      cv vv cv cF co cR cec wceq wa vx cv vu cv wceq wi vy cv cS wcel vw cv cS
      wcel wa vz cv cS wcel vv cv cS wcel wa wa vx cv vy cv vz cv cF co cR cec
      wceq vu cv vw cv vv cv cF co cR cec wceq wa vy cv cR cec vw cv cR cec
      wceq vz cv cR cec vv cv cR cec wceq wa vx cv vu cv wceq vy cv cS wcel vw
      cv cS wcel wa vz cv cS wcel vv cv cS wcel wa wa vy cv cR cec vw cv cR cec
      wceq vz cv cR cec vv cv cR cec wceq wa vy cv vz cv cF co vw cv vv cv cF
      co cR wbr vx cv vy cv vz cv cF co cR cec wceq vu cv vw cv vv cv cF co cR
      cec wceq wa vx cv vu cv wceq vy cv cS wcel vw cv cS wcel wa vz cv cS wcel
      vv cv cS wcel wa wa vy cv cR cec vw cv cR cec wceq vz cv cR cec vv cv cR
      cec wceq wa vy cv vw cv cR wbr vz cv vv cv cR wbr wa vy cv vz cv cF co vw
      cv vv cv cF co cR wbr vy cv cS wcel vw cv cS wcel wa vy cv cR cec vw cv
      cR cec wceq vy cv vw cv cR wbr vz cv cS wcel vv cv cS wcel wa vz cv cR
      cec vv cv cR cec wceq vz cv vv cv cR wbr vy cv cS wcel vw cv cS wcel wa
      vy cv cR cdm wcel vy cv cR cec vw cv cR cec wceq vy cv vw cv cR wbr wb vy
      cv cS wcel vw cv cS wcel wa vy cv cS cR cdm vy cv cS wcel vw cv cS wcel
      pm3.26 th3qlem1.2 syl6eleqr vy cv vw cv cR vw visset th3qlem1.1 erthdm
      syl vz cv cS wcel vv cv cS wcel wa vz cv cR cdm wcel vz cv cR cec vv cv
      cR cec wceq vz cv vv cv cR wbr wb vz cv cS wcel vv cv cS wcel wa vz cv cS
      cR cdm vz cv cS wcel vv cv cS wcel pm3.26 th3qlem1.2 syl6eleqr vz cv vv
      cv cR vv visset th3qlem1.1 erthdm syl bi2anan9 th3qlem1.3 sylbid vx cv vy
      cv vz cv cF co cR cec wceq vu cv vw cv vv cv cF co cR cec wceq wa vx cv
      vu cv wceq vy cv vz cv cF co cR cec vw cv vv cv cF co cR cec wceq vy cv
      vz cv cF co vw cv vv cv cF co cR wbr vx cv vy cv vz cv cF co cR cec vu cv
      vw cv vv cv cF co cR cec eqeq12 vy cv vz cv cF co vw cv vv cv cF co cR vy
      cv vz cv cF oprex vw cv vv cv cF oprex th3qlem1.1 erthi syl5bir syl9
      com23 imp vy cv cR cec cS cR cqs wcel vw cv cR cec cS cR cqs wcel wa vy
      cv cS wcel vw cv cS wcel wa vz cv cR cec cS cR cqs wcel vv cv cR cec cS
      cR cqs wcel wa vz cv cS wcel vv cv cS wcel wa vy cv cR cec cS cR cqs wcel
      vy cv cS wcel vw cv cR cec cS cR cqs wcel vw cv cS wcel cS vy cv cR vy
      visset th3qlem1.2 ecelqsdm cS vw cv cR vw visset th3qlem1.2 ecelqsdm
      anim12i vz cv cR cec cS cR cqs wcel vz cv cS wcel vv cv cR cec cS cR cqs
      wcel vv cv cS wcel cS vz cv cR vz visset th3qlem1.2 ecelqsdm cS vv cv cR
      vv visset th3qlem1.2 ecelqsdm anim12i anim12i cA vy cv cR cec wceq cA vw
      cv cR cec wceq wa vy cv cR cec vw cv cR cec wceq cB vz cv cR cec wceq cB
      vv cv cR cec wceq wa vz cv cR cec vv cv cR cec wceq cA vy cv cR cec vw cv
      cR cec eqtr2 cB vz cv cR cec vv cv cR cec eqtr2 anim12i syl2an an4s vy cv
      cR cec cS cR cqs wcel cA vy cv cR cec wceq vw cv cR cec cS cR cqs wcel cA
      vw cv cR cec wceq an4 vz cv cR cec cS cR cqs wcel cB vz cv cR cec wceq vv
      cv cR cec cS cR cqs wcel cB vv cv cR cec wceq an4 syl2anb sylbi cA cS cR
      cqs wcel cA cS cR cqs wcel wa cA cS cR cqs wcel cB cS cR cqs wcel cB cS
      cR cqs wcel wa cB cS cR cqs wcel cA cS cR cqs wcel anidm cB cS cR cqs
      wcel anidm anbi12i sylanbr expimpd cA vy cv cR cec wceq cB vz cv cR cec
      wceq wa vx cv vy cv vz cv cF co cR cec wceq cA vw cv cR cec wceq cB vv cv
      cR cec wceq wa vu cv vw cv vv cv cF co cR cec wceq an4 syl5ib 19.23advv
      19.23advv cA vy cv cR cec wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv
      cF co cR cec wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa vu cv
      vw cv vv cv cF co cR cec wceq wa vy vz vw vv ee4anv syl5ibr 19.21aivv cA
      vy cv cR cec wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec
      wceq wa vz wex vy wex cA vw cv cR cec wceq cB vv cv cR cec wceq wa vu cv
      vw cv vv cv cF co cR cec wceq wa vv wex vw wex vx vu vx cv vu cv wceq cA
      vy cv cR cec wceq cB vz cv cR cec wceq wa vx cv vy cv vz cv cF co cR cec
      wceq wa vz wex vy wex cA vy cv cR cec wceq cB vz cv cR cec wceq wa vu cv
      vy cv vz cv cF co cR cec wceq wa vz wex vy wex cA vw cv cR cec wceq cB vv
      cv cR cec wceq wa vu cv vw cv vv cv cF co cR cec wceq wa vv wex vw wex vx
      cv vu cv wceq cA vy cv cR cec wceq cB vz cv cR cec wceq wa vx cv vy cv vz
      cv cF co cR cec wceq wa cA vy cv cR cec wceq cB vz cv cR cec wceq wa vu
      cv vy cv vz cv cF co cR cec wceq wa vy vz vx cv vu cv wceq vx cv vy cv vz
      cv cF co cR cec wceq vu cv vy cv vz cv cF co cR cec wceq cA vy cv cR cec
      wceq cB vz cv cR cec wceq wa vx cv vu cv vy cv vz cv cF co cR cec eqeq1
      anbi2d 2exbidv cA vy cv cR cec wceq cB vz cv cR cec wceq wa vu cv vy cv
      vz cv cF co cR cec wceq wa cA vw cv cR cec wceq cB vv cv cR cec wceq wa
      vu cv vw cv vv cv cF co cR cec wceq wa vy vz vw vv vy cv vw cv wceq vz cv
      vv cv wceq wa cA vy cv cR cec wceq cB vz cv cR cec wceq wa cA vw cv cR
      cec wceq cB vv cv cR cec wceq wa vu cv vy cv vz cv cF co cR cec wceq vu
      cv vw cv vv cv cF co cR cec wceq vy cv vw cv wceq cA vy cv cR cec wceq cA
      vw cv cR cec wceq vz cv vv cv wceq cB vz cv cR cec wceq cB vv cv cR cec
      wceq vy cv vw cv wceq vy cv cR cec vw cv cR cec cA vy cv vw cv cR eceq2
      eqeq2d vz cv vv cv wceq vz cv cR cec vv cv cR cec cB vz cv vv cv cR eceq2
      eqeq2d bi2anan9 vy cv vw cv wceq vz cv vv cv wceq wa vy cv vz cv cF co cR
      cec vw cv vv cv cF co cR cec vu cv vy cv vw cv wceq vz cv vv cv wceq wa
      vy cv vz cv cF co vw cv vv cv cF co wceq vy cv vz cv cF co cR cec vw cv
      vv cv cF co cR cec wceq vy cv vw cv vz cv vv cv cF opreq12 vy cv vz cv cF
      co vw cv vv cv cF co cR eceq2 syl eqeq2d anbi12d cbvex2v syl6bb mo4
      sylibr $.
      $( [3-Aug-1995] $)
  $}

  ${
    $d x y z w v u t s f g h R $.
    $d x y z w v u t s f g h S $.
    $d x y z w v u t s f g h A $.
    $d x y z w v u t s f g h B $.
    $d x y z w v u t s f g h C $.
    $d x y z w v u t s f g h D $.
    $d x y z w v u t s f g h F $.
    $d x y z w v u t s f g h G $.
    th3q.1 $e |- R e. _V $.
    th3q.2 $e |- Er R $.
    th3q.3 $e |- dom R = ( S X. S ) $.
    $( Compatibility assumption. $)
    th3q.4 $e |- ( ( ( ( w e. S /\ v e. S ) /\ ( u e. S /\ t e. S ) )
       /\ ( ( s e. S /\ f e. S ) /\ ( g e. S /\ h e. S ) ) ) ->
       ( ( <. w , v >. R <. u , t >. /\ <. s , f >. R <. g , h >. ) ->
       ( <. w , v >. F <. s , f >. ) R ( <. u , t >. F <. g , h >. ) ) ) $.
    $( Lemma for Exercise 44 version of Theorem 3Q of [Enderton] p. 60,
       extended to operations on ordered pairs.  The fourth hypothesis is the
       compatibility assumption. $)
    th3qlem2 $p |- ( ( A e. ( ( S X. S ) /. R ) /\ B e. ( ( S X. S ) /. R ) )
           -> E* z E. w E. v E. u E. t (
           ( A = [ <. w , v >. ] R /\ B = [ <. u , t >. ] R ) /\
                  z = [ ( <. w , v >. F <. u , t >. ) ] R ) ) $=
      cA cS cS cxp cR cqs wcel cB cS cS cxp cR cqs wcel wa cA vs cv cR cec wceq
      cB vx cv cR cec wceq wa vz cv vs cv vx cv cF co cR cec wceq wa vx wex vs
      wex vz wmo cA vw cv vv cv cop cR cec wceq cB vu cv vt cv cop cR cec wceq
      wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex vu
      wex vv wex vw wex vz wmo vz vs vx vf vy cA cB cR cS cS cxp cF th3q.2
      th3q.3 vs cv cS cS cxp wcel vf cv cS cS cxp wcel wa vx cv cS cS cxp wcel
      vy cv cS cS cxp wcel wa vs cv vf cv cR wbr vx cv vy cv cR wbr wa vs cv vx
      cv cF co vf cv vy cv cF co cR wbr wi vx cv cS cS cxp wcel vy cv cS cS cxp
      wcel wa vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vw
      cv vv cv cop vx cv cF co vu cv vt cv cop vy cv cF co cR wbr wi wi vx cv
      cS cS cxp wcel vy cv cS cS cxp wcel wa vs cv vu cv vt cv cop cR wbr vx cv
      vy cv cR wbr wa vs cv vx cv cF co vu cv vt cv cop vy cv cF co cR wbr wi
      wi vx cv cS cS cxp wcel vy cv cS cS cxp wcel wa vs cv vf cv cR wbr vx cv
      vy cv cR wbr wa vs cv vx cv cF co vf cv vy cv cF co cR wbr wi wi vw vv vu
      vt vs cv vf cv cS cS cS cS cxp cS cS cxp eqid vw cv vv cv cop vs cv wceq
      vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vw cv vv cv
      cop vx cv cF co vu cv vt cv cop vy cv cF co cR wbr wi vs cv vu cv vt cv
      cop cR wbr vx cv vy cv cR wbr wa vs cv vx cv cF co vu cv vt cv cop vy cv
      cF co cR wbr wi vx cv cS cS cxp wcel vy cv cS cS cxp wcel wa vw cv vv cv
      cop vs cv wceq vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vy cv cR wbr
      wa vs cv vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vw cv vv cv cop vx
      cv cF co vu cv vt cv cop vy cv cF co cR wbr vs cv vx cv cF co vu cv vt cv
      cop vy cv cF co cR wbr vw cv vv cv cop vs cv wceq vw cv vv cv cop vu cv
      vt cv cop cR wbr vs cv vu cv vt cv cop cR wbr vx cv vy cv cR wbr vw cv vv
      cv cop vs cv vu cv vt cv cop cR breq1 anbi1d vw cv vv cv cop vs cv wceq
      vw cv vv cv cop vx cv cF co vs cv vx cv cF co vu cv vt cv cop vy cv cF co
      cR vw cv vv cv cop vs cv vx cv cF opreq1 breq1d imbi12d imbi2d vu cv vt
      cv cop vf cv wceq vs cv vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vs
      cv vx cv cF co vu cv vt cv cop vy cv cF co cR wbr wi vs cv vf cv cR wbr
      vx cv vy cv cR wbr wa vs cv vx cv cF co vf cv vy cv cF co cR wbr wi vx cv
      cS cS cxp wcel vy cv cS cS cxp wcel wa vu cv vt cv cop vf cv wceq vs cv
      vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vs cv vf cv cR wbr vx cv vy
      cv cR wbr wa vs cv vx cv cF co vu cv vt cv cop vy cv cF co cR wbr vs cv
      vx cv cF co vf cv vy cv cF co cR wbr vu cv vt cv cop vf cv wceq vs cv vu
      cv vt cv cop cR wbr vs cv vf cv cR wbr vx cv vy cv cR wbr vu cv vt cv cop
      vf cv vs cv cR breq2 anbi1d vu cv vt cv cop vf cv wceq vu cv vt cv cop vy
      cv cF co vf cv vy cv cF co vs cv vx cv cF co cR vu cv vt cv cop vf cv vy
      cv cF opreq1 breq2d imbi12d imbi2d vx cv cS cS cxp wcel vy cv cS cS cxp
      wcel wa vw cv cS wcel vv cv cS wcel wa vu cv cS wcel vt cv cS wcel wa wa
      vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vw cv vv cv
      cop vx cv cF co vu cv vt cv cop vy cv cF co cR wbr wi vw cv cS wcel vv cv
      cS wcel wa vu cv cS wcel vt cv cS wcel wa wa vw cv vv cv cop vu cv vt cv
      cop cR wbr vs cv vf cv cop vg cv vh cv cop cR wbr wa vw cv vv cv cop vs
      cv vf cv cop cF co vu cv vt cv cop vg cv vh cv cop cF co cR wbr wi wi vw
      cv cS wcel vv cv cS wcel wa vu cv cS wcel vt cv cS wcel wa wa vw cv vv cv
      cop vu cv vt cv cop cR wbr vx cv vg cv vh cv cop cR wbr wa vw cv vv cv
      cop vx cv cF co vu cv vt cv cop vg cv vh cv cop cF co cR wbr wi wi vw cv
      cS wcel vv cv cS wcel wa vu cv cS wcel vt cv cS wcel wa wa vw cv vv cv
      cop vu cv vt cv cop cR wbr vx cv vy cv cR wbr wa vw cv vv cv cop vx cv cF
      co vu cv vt cv cop vy cv cF co cR wbr wi wi vs vf vg vh vx cv vy cv cS cS
      cS cS cxp cS cS cxp eqid vs cv vf cv cop vx cv wceq vw cv vv cv cop vu cv
      vt cv cop cR wbr vs cv vf cv cop vg cv vh cv cop cR wbr wa vw cv vv cv
      cop vs cv vf cv cop cF co vu cv vt cv cop vg cv vh cv cop cF co cR wbr wi
      vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vg cv vh cv cop cR wbr wa vw
      cv vv cv cop vx cv cF co vu cv vt cv cop vg cv vh cv cop cF co cR wbr wi
      vw cv cS wcel vv cv cS wcel wa vu cv cS wcel vt cv cS wcel wa wa vs cv vf
      cv cop vx cv wceq vw cv vv cv cop vu cv vt cv cop cR wbr vs cv vf cv cop
      vg cv vh cv cop cR wbr wa vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vg
      cv vh cv cop cR wbr wa vw cv vv cv cop vs cv vf cv cop cF co vu cv vt cv
      cop vg cv vh cv cop cF co cR wbr vw cv vv cv cop vx cv cF co vu cv vt cv
      cop vg cv vh cv cop cF co cR wbr vs cv vf cv cop vx cv wceq vs cv vf cv
      cop vg cv vh cv cop cR wbr vx cv vg cv vh cv cop cR wbr vw cv vv cv cop
      vu cv vt cv cop cR wbr vs cv vf cv cop vx cv vg cv vh cv cop cR breq1
      anbi2d vs cv vf cv cop vx cv wceq vw cv vv cv cop vs cv vf cv cop cF co
      vw cv vv cv cop vx cv cF co vu cv vt cv cop vg cv vh cv cop cF co cR vs
      cv vf cv cop vx cv vw cv vv cv cop cF opreq2 breq1d imbi12d imbi2d vg cv
      vh cv cop vy cv wceq vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vg cv
      vh cv cop cR wbr wa vw cv vv cv cop vx cv cF co vu cv vt cv cop vg cv vh
      cv cop cF co cR wbr wi vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vy cv
      cR wbr wa vw cv vv cv cop vx cv cF co vu cv vt cv cop vy cv cF co cR wbr
      wi vw cv cS wcel vv cv cS wcel wa vu cv cS wcel vt cv cS wcel wa wa vg cv
      vh cv cop vy cv wceq vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vg cv
      vh cv cop cR wbr wa vw cv vv cv cop vu cv vt cv cop cR wbr vx cv vy cv cR
      wbr wa vw cv vv cv cop vx cv cF co vu cv vt cv cop vg cv vh cv cop cF co
      cR wbr vw cv vv cv cop vx cv cF co vu cv vt cv cop vy cv cF co cR wbr vg
      cv vh cv cop vy cv wceq vx cv vg cv vh cv cop cR wbr vx cv vy cv cR wbr
      vw cv vv cv cop vu cv vt cv cop cR wbr vg cv vh cv cop vy cv vx cv cR
      breq2 anbi2d vg cv vh cv cop vy cv wceq vu cv vt cv cop vg cv vh cv cop
      cF co vu cv vt cv cop vy cv cF co vw cv vv cv cop vx cv cF co cR vg cv vh
      cv cop vy cv vu cv vt cv cop cF opreq2 breq2d imbi12d imbi2d vw cv cS
      wcel vv cv cS wcel wa vu cv cS wcel vt cv cS wcel wa wa vs cv cS wcel vf
      cv cS wcel wa vg cv cS wcel vh cv cS wcel wa wa vw cv vv cv cop vu cv vt
      cv cop cR wbr vs cv vf cv cop vg cv vh cv cop cR wbr wa vw cv vv cv cop
      vs cv vf cv cop cF co vu cv vt cv cop vg cv vh cv cop cF co cR wbr wi
      th3q.4 expcom 2optocl com12 2optocl imp th3qlem1 cA vw cv vv cv cop cR
      cec wceq cB vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv vt
      cv cop cF co cR cec wceq wa vt wex vu wex vv wex vw wex cA vs cv cR cec
      wceq cB vx cv cR cec wceq wa vz cv vs cv vx cv cF co cR cec wceq wa vx
      wex vs wex vz cA vw cv vv cv cop cR cec wceq cB vu cv vt cv cop cR cec
      wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex
      vu wex cA vs cv cR cec wceq cB vx cv cR cec wceq wa vz cv vs cv vx cv cF
      co cR cec wceq wa vx wex vs wex vw vv cA vw cv vv cv cop cR cec wceq cB
      vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF
      co cR cec wceq wa cA vs cv cR cec wceq cB vx cv cR cec wceq wa vz cv vs
      cv vx cv cF co cR cec wceq wa vx wex vs wex vu vt cA vs cv cR cec wceq cB
      vx cv cR cec wceq wa vz cv vs cv vx cv cF co cR cec wceq wa cA vw cv vv
      cv cop cR cec wceq cB vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv
      cop vu cv vt cv cop cF co cR cec wceq wa vs vx vw cv vv cv cop vu cv vt
      cv cop vw cv vv cv opex vu cv vt cv opex vs cv vw cv vv cv cop wceq vx cv
      vu cv vt cv cop wceq wa cA vs cv cR cec wceq cB vx cv cR cec wceq wa cA
      vw cv vv cv cop cR cec wceq cB vu cv vt cv cop cR cec wceq wa vz cv vs cv
      vx cv cF co cR cec wceq vz cv vw cv vv cv cop vu cv vt cv cop cF co cR
      cec wceq vs cv vw cv vv cv cop wceq cA vs cv cR cec wceq cA vw cv vv cv
      cop cR cec wceq vx cv vu cv vt cv cop wceq cB vx cv cR cec wceq cB vu cv
      vt cv cop cR cec wceq vs cv vw cv vv cv cop wceq vs cv cR cec vw cv vv cv
      cop cR cec cA vs cv vw cv vv cv cop cR eceq2 eqeq2d vx cv vu cv vt cv cop
      wceq vx cv cR cec vu cv vt cv cop cR cec cB vx cv vu cv vt cv cop cR
      eceq2 eqeq2d bi2anan9 vs cv vw cv vv cv cop wceq vx cv vu cv vt cv cop
      wceq wa vs cv vx cv cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR
      cec vz cv vs cv vw cv vv cv cop wceq vx cv vu cv vt cv cop wceq wa vs cv
      vx cv cF co vw cv vv cv cop vu cv vt cv cop cF co wceq vs cv vx cv cF co
      cR cec vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq vs cv vw cv vv
      cv cop vx cv vu cv vt cv cop cF opreq12 vs cv vx cv cF co vw cv vv cv cop
      vu cv vt cv cop cF co cR eceq2 syl eqeq2d anbi12d cla42ev 19.23aivv
      19.23aivv immoi syl $.
      $( [4-Aug-1995] $)

      ${
        th3q.5 $e |- G = { <. <. x , y >. , z >. | ( ( x e. ( ( S X. S ) /. R )
           /\ y e. ( ( S X. S ) /. R ) ) /\ E. w E. v E. u E. t ( (
           x = [ <. w , v >. ] R /\ y = [ <. u , t >. ] R ) /\
           z = [ ( <. w , v >. F <. u , t >. ) ] R ) ) } $.

        $( Corollary of Theorem 3Q of [Enderton] p. 60. $)
        th3qcor $p |- Fun G $=
          cG wfun vx cv cS cS cxp cR cqs wcel vy cv cS cS cxp cR cqs wcel wa vx
          cv vw cv vv cv cop cR cec wceq vy cv vu cv vt cv cop cR cec wceq wa
          vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex vu
          wex vv wex vw wex wa vx vy vz copab2 wfun vx cv cS cS cxp cR cqs wcel
          vy cv cS cS cxp cR cqs wcel wa vx cv vw cv vv cv cop cR cec wceq vy
          cv vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv vt cv
          cop cF co cR cec wceq wa vt wex vu wex vv wex vw wex wa vx vy vz vx
          cv cS cS cxp cR cqs wcel vy cv cS cS cxp cR cqs wcel wa vx cv vw cv
          vv cv cop cR cec wceq vy cv vu cv vt cv cop cR cec wceq wa vz cv vw
          cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex vu wex vv
          wex vw wex wa vz wmo vx cv cS cS cxp cR cqs wcel vy cv cS cS cxp cR
          cqs wcel wa vx cv vw cv vv cv cop cR cec wceq vy cv vu cv vt cv cop
          cR cec wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec
          wceq wa vt wex vu wex vv wex vw wex vz wmo wi vz vw vv vu vt vx cv vy
          cv cR cS vf vg vh cF vs th3q.1 th3q.2 th3q.3 th3q.4 th3qlem2 vx cv cS
          cS cxp cR cqs wcel vy cv cS cS cxp cR cqs wcel wa vx cv vw cv vv cv
          cop cR cec wceq vy cv vu cv vt cv cop cR cec wceq wa vz cv vw cv vv
          cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex vu wex vv wex vw
          wex vz moanimv mpbir funoprab cG vx cv cS cS cxp cR cqs wcel vy cv cS
          cS cxp cR cqs wcel wa vx cv vw cv vv cv cop cR cec wceq vy cv vu cv
          vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co
          cR cec wceq wa vt wex vu wex vv wex vw wex wa vx vy vz copab2 wceq cG
          wfun vx cv cS cS cxp cR cqs wcel vy cv cS cS cxp cR cqs wcel wa vx cv
          vw cv vv cv cop cR cec wceq vy cv vu cv vt cv cop cR cec wceq wa vz
          cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex vu wex
          vv wex vw wex wa vx vy vz copab2 wfun wb th3q.5 cG vx cv cS cS cxp cR
          cqs wcel vy cv cS cS cxp cR cqs wcel wa vx cv vw cv vv cv cop cR cec
          wceq vy cv vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv
          vt cv cop cF co cR cec wceq wa vt wex vu wex vv wex vw wex wa vx vy
          vz copab2 funeq ax-mp mpbir $.
          $( [12-Nov-1995] $)

        $( Theorem 3Q of [Enderton] p. 60, extended to operations on ordered
           pairs. $)
        th3q $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) ) ->
                 ( [ <. A , B >. ] R G [ <. C , D >. ] R ) =
                 [ ( <. A , B >. F <. C , D >. ) ] R ) $=
          cA cB cop cR cec cS cS cxp cR cqs wcel cC cD cop cR cec cS cS cxp cR
          cqs wcel wa cA cB cop cR cec vw cv vv cv cop cR cec wceq cC cD cop cR
          cec vu cv vt cv cop cR cec wceq wa cA cB cop cC cD cop cF co cR cec
          vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt wex vu wex vv
          wex vw wex cA cB cop cR cec cC cD cop cR cec cG co cA cB cop cC cD
          cop cF co cR cec wceq cA cS wcel cB cS wcel wa cC cS wcel cD cS wcel
          wa wa vx cv vw cv vv cv cop cR cec wceq vy cv vu cv vt cv cop cR cec
          wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa vt
          wex vu wex vv wex vw wex cA cB cop cR cec vw cv vv cv cop cR cec wceq
          vy cv vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv vt
          cv cop cF co cR cec wceq wa vt wex vu wex vv wex vw wex cA cB cop cR
          cec vw cv vv cv cop cR cec wceq cC cD cop cR cec vu cv vt cv cop cR
          cec wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq
          wa vt wex vu wex vv wex vw wex cA cB cop cR cec vw cv vv cv cop cR
          cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA cB cop cC
          cD cop cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq
          wa vt wex vu wex vv wex vw wex vx vy vz cA cB cop cR cec cC cD cop cR
          cec cA cB cop cC cD cop cF co cR cec cS cS cxp cR cqs cS cS cxp cR
          cqs cG cR cvv wcel cA cB cop cC cD cop cF co cR cec cvv wcel th3q.1
          cA cB cop cC cD cop cF co cvv cR ecexg ax-mp vx cv cA cB cop cR cec
          wceq vx cv vw cv vv cv cop cR cec wceq vy cv vu cv vt cv cop cR cec
          wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa cA
          cB cop cR cec vw cv vv cv cop cR cec wceq vy cv vu cv vt cv cop cR
          cec wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq
          wa vw vv vu vt vx cv cA cB cop cR cec wceq vx cv vw cv vv cv cop cR
          cec wceq vy cv vu cv vt cv cop cR cec wceq wa cA cB cop cR cec vw cv
          vv cv cop cR cec wceq vy cv vu cv vt cv cop cR cec wceq wa vz cv vw
          cv vv cv cop vu cv vt cv cop cF co cR cec wceq vx cv cA cB cop cR cec
          wceq vx cv vw cv vv cv cop cR cec wceq cA cB cop cR cec vw cv vv cv
          cop cR cec wceq vy cv vu cv vt cv cop cR cec wceq vx cv cA cB cop cR
          cec vw cv vv cv cop cR cec eqeq1 anbi1d anbi1d 4exbidv vy cv cC cD
          cop cR cec wceq cA cB cop cR cec vw cv vv cv cop cR cec wceq vy cv vu
          cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv vt cv cop cF
          co cR cec wceq wa cA cB cop cR cec vw cv vv cv cop cR cec wceq cC cD
          cop cR cec vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv
          vt cv cop cF co cR cec wceq wa vw vv vu vt vy cv cC cD cop cR cec
          wceq cA cB cop cR cec vw cv vv cv cop cR cec wceq vy cv vu cv vt cv
          cop cR cec wceq wa cA cB cop cR cec vw cv vv cv cop cR cec wceq cC cD
          cop cR cec vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu cv
          vt cv cop cF co cR cec wceq vy cv cC cD cop cR cec wceq vy cv vu cv
          vt cv cop cR cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq cA
          cB cop cR cec vw cv vv cv cop cR cec wceq vy cv cC cD cop cR cec vu
          cv vt cv cop cR cec eqeq1 anbi2d anbi1d 4exbidv vz cv cA cB cop cC cD
          cop cF co cR cec wceq cA cB cop cR cec vw cv vv cv cop cR cec wceq cC
          cD cop cR cec vu cv vt cv cop cR cec wceq wa vz cv vw cv vv cv cop vu
          cv vt cv cop cF co cR cec wceq wa cA cB cop cR cec vw cv vv cv cop cR
          cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA cB cop cC
          cD cop cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq
          wa vw vv vu vt vz cv cA cB cop cC cD cop cF co cR cec wceq vz cv vw
          cv vv cv cop vu cv vt cv cop cF co cR cec wceq cA cB cop cC cD cop cF
          co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq cA cB cop
          cR cec vw cv vv cv cop cR cec wceq cC cD cop cR cec vu cv vt cv cop
          cR cec wceq wa vz cv cA cB cop cC cD cop cF co cR cec vw cv vv cv cop
          vu cv vt cv cop cF co cR cec eqeq1 anbi2d 4exbidv vz vw vv vu vt vx
          cv vy cv cR cS vf vg vh cF vs th3q.1 th3q.2 th3q.3 th3q.4 th3qlem2
          th3q.5 oprabvali cA cS wcel cB cS wcel wa cA cB cop cR cec cS cS cxp
          cR cqs wcel cC cS wcel cD cS wcel wa cC cD cop cR cec cS cS cxp cR
          cqs wcel cA cS wcel cB cS wcel wa cA cB cop cS cS cxp wcel cA cB cop
          cR cec cS cS cxp cR cqs wcel cA cB cS cS opelxpi cS cS cxp cA cB cop
          cR th3q.1 ecelqsi syl cC cS wcel cD cS wcel wa cC cD cop cS cS cxp
          wcel cC cD cop cR cec cS cS cxp cR cqs wcel cC cD cS cS opelxpi cS cS
          cxp cC cD cop cR th3q.1 ecelqsi syl anim12i cA cS wcel cB cS wcel wa
          cC cS wcel cD cS wcel wa wa cA cB cop cR cec cA cB cop cR cec wceq cC
          cD cop cR cec cC cD cop cR cec wceq wa cA cB cop cC cD cop cF co cR
          cec cA cB cop cC cD cop cF co cR cec wceq cA cB cop cR cec vw cv vv
          cv cop cR cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA
          cB cop cC cD cop cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co
          cR cec wceq wa vt wex vu wex vv wex vw wex cA cB cop cR cec cA cB cop
          cR cec wceq cC cD cop cR cec cC cD cop cR cec wceq cA cB cop cR cec
          eqid cC cD cop cR cec eqid pm3.2i cA cB cop cC cD cop cF co cR cec
          eqid cA cS wcel cB cS wcel wa cA cB cop cR cec cA cB cop cR cec wceq
          cC cD cop cR cec cC cD cop cR cec wceq wa cA cB cop cC cD cop cF co
          cR cec cA cB cop cC cD cop cF co cR cec wceq wa cA cB cop cR cec vw
          cv vv cv cop cR cec wceq cC cD cop cR cec cC cD cop cR cec wceq wa cA
          cB cop cC cD cop cF co cR cec vw cv vv cv cop cC cD cop cF co cR cec
          wceq wa vv wex vw wex cC cS wcel cD cS wcel wa cA cB cop cR cec vw cv
          vv cv cop cR cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa
          cA cB cop cC cD cop cF co cR cec vw cv vv cv cop vu cv vt cv cop cF
          co cR cec wceq wa vt wex vu wex vv wex vw wex cA cB cop cR cec vw cv
          vv cv cop cR cec wceq cC cD cop cR cec cC cD cop cR cec wceq wa cA cB
          cop cC cD cop cF co cR cec vw cv vv cv cop cC cD cop cF co cR cec
          wceq wa cA cB cop cR cec cA cB cop cR cec wceq cC cD cop cR cec cC cD
          cop cR cec wceq wa cA cB cop cC cD cop cF co cR cec cA cB cop cC cD
          cop cF co cR cec wceq wa vw vv cA cB cS cS vw cv cA wceq vv cv cB
          wceq wa vw cv vv cv cop cA cB cop wceq cA cB cop cR cec vw cv vv cv
          cop cR cec wceq cC cD cop cR cec cC cD cop cR cec wceq wa cA cB cop
          cC cD cop cF co cR cec vw cv vv cv cop cC cD cop cF co cR cec wceq wa
          cA cB cop cR cec cA cB cop cR cec wceq cC cD cop cR cec cC cD cop cR
          cec wceq wa cA cB cop cC cD cop cF co cR cec cA cB cop cC cD cop cF
          co cR cec wceq wa wb vw cv vv cv cA cB opeq12 vw cv vv cv cop cA cB
          cop wceq cA cB cop cR cec vw cv vv cv cop cR cec wceq cC cD cop cR
          cec cC cD cop cR cec wceq wa cA cB cop cR cec cA cB cop cR cec wceq
          cC cD cop cR cec cC cD cop cR cec wceq wa cA cB cop cC cD cop cF co
          cR cec vw cv vv cv cop cC cD cop cF co cR cec wceq cA cB cop cC cD
          cop cF co cR cec cA cB cop cC cD cop cF co cR cec wceq vw cv vv cv
          cop cA cB cop wceq cA cB cop cR cec vw cv vv cv cop cR cec wceq cA cB
          cop cR cec cA cB cop cR cec wceq cC cD cop cR cec cC cD cop cR cec
          wceq vw cv vv cv cop cA cB cop wceq vw cv vv cv cop cR cec cA cB cop
          cR cec cA cB cop cR cec vw cv vv cv cop cA cB cop cR eceq2 eqeq2d
          anbi1d vw cv vv cv cop cA cB cop wceq vw cv vv cv cop cC cD cop cF co
          cR cec cA cB cop cC cD cop cF co cR cec cA cB cop cC cD cop cF co cR
          cec vw cv vv cv cop cA cB cop wceq vw cv vv cv cop cC cD cop cF co cA
          cB cop cC cD cop cF co wceq vw cv vv cv cop cC cD cop cF co cR cec cA
          cB cop cC cD cop cF co cR cec wceq vw cv vv cv cop cA cB cop cC cD
          cop cF opreq1 vw cv vv cv cop cC cD cop cF co cA cB cop cC cD cop cF
          co cR eceq2 syl eqeq2d anbi12d syl cla42egv cC cS wcel cD cS wcel wa
          cA cB cop cR cec vw cv vv cv cop cR cec wceq cC cD cop cR cec cC cD
          cop cR cec wceq wa cA cB cop cC cD cop cF co cR cec vw cv vv cv cop
          cC cD cop cF co cR cec wceq wa cA cB cop cR cec vw cv vv cv cop cR
          cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA cB cop cC
          cD cop cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq
          wa vt wex vu wex vw vv cA cB cop cR cec vw cv vv cv cop cR cec wceq
          cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA cB cop cC cD cop
          cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR cec wceq wa cA
          cB cop cR cec vw cv vv cv cop cR cec wceq cC cD cop cR cec cC cD cop
          cR cec wceq wa cA cB cop cC cD cop cF co cR cec vw cv vv cv cop cC cD
          cop cF co cR cec wceq wa vu vt cC cD cS cS vu cv cC wceq vt cv cD
          wceq wa vu cv vt cv cop cC cD cop wceq cA cB cop cR cec vw cv vv cv
          cop cR cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA cB
          cop cC cD cop cF co cR cec vw cv vv cv cop vu cv vt cv cop cF co cR
          cec wceq wa cA cB cop cR cec vw cv vv cv cop cR cec wceq cC cD cop cR
          cec cC cD cop cR cec wceq wa cA cB cop cC cD cop cF co cR cec vw cv
          vv cv cop cC cD cop cF co cR cec wceq wa wb vu cv vt cv cC cD opeq12
          vu cv vt cv cop cC cD cop wceq cA cB cop cR cec vw cv vv cv cop cR
          cec wceq cC cD cop cR cec vu cv vt cv cop cR cec wceq wa cA cB cop cR
          cec vw cv vv cv cop cR cec wceq cC cD cop cR cec cC cD cop cR cec
          wceq wa cA cB cop cC cD cop cF co cR cec vw cv vv cv cop vu cv vt cv
          cop cF co cR cec wceq cA cB cop cC cD cop cF co cR cec vw cv vv cv
          cop cC cD cop cF co cR cec wceq vu cv vt cv cop cC cD cop wceq cC cD
          cop cR cec vu cv vt cv cop cR cec wceq cC cD cop cR cec cC cD cop cR
          cec wceq cA cB cop cR cec vw cv vv cv cop cR cec wceq vu cv vt cv cop
          cC cD cop wceq vu cv vt cv cop cR cec cC cD cop cR cec cC cD cop cR
          cec vu cv vt cv cop cC cD cop cR eceq2 eqeq2d anbi2d vu cv vt cv cop
          cC cD cop wceq vw cv vv cv cop vu cv vt cv cop cF co cR cec vw cv vv
          cv cop cC cD cop cF co cR cec cA cB cop cC cD cop cF co cR cec vu cv
          vt cv cop cC cD cop wceq vw cv vv cv cop vu cv vt cv cop cF co vw cv
          vv cv cop cC cD cop cF co wceq vw cv vv cv cop vu cv vt cv cop cF co
          cR cec vw cv vv cv cop cC cD cop cF co cR cec wceq vu cv vt cv cop cC
          cD cop vw cv vv cv cop cF opreq2 vw cv vv cv cop vu cv vt cv cop cF
          co vw cv vv cv cop cC cD cop cF co cR eceq2 syl eqeq2d anbi12d syl
          cla42egv 19.22dvv sylan9 mp2ani sylc $.
          $( [4-Aug-1995] $)
    $}
  $}

  ${
    $d x y z w v u t s f g h a b c d A $.
    $d x y z w v u t s f g h a b c d B $.
    $d x y z w v u t s f g h a b c d C $.
    $d x y z w v u t s f g h a b c d D $.
    $d x y z t s g h a b c d F $.
    $d x y z t s g h a b c d G $.
    $d x y z w v u f H $.
    $d x y z J $.
    $d x y z w v u f K $.
    $d x y z w v u f L $.
    $d x y z a b c d Q $.
    $d x y z t s g h a b c d R $.
    $d x y z w v u t s f g h a b c d S $.
    $d x y ph $.
    $d z w v u ps $.
    $d z w v u ch $.
    oprec.1 $e |- H e. _V $.
    oprec.2 $e |- K e. _V $.
    oprec.3 $e |- L e. _V $.
    oprec.4 $e |- R e. _V $.
    oprec.5 $e |- Er R $.
    oprec.6 $e |- dom R = ( S X. S ) $.
    $( Equivalence relation. $)
    oprec.7 $e |- R = { <. x , y >. | ( ( x e. ( S X. S ) /\
                      y e. ( S X. S ) ) /\
                      E. z E. w E. v E. u ( ( x = <. z , w >. /\
                      y = <. v , u >. ) /\ ph ) ) } $.
    $( Substitutions for equivalence relation. $)
    oprec.8 $e |- ( ( ( z = a /\ w = b ) /\ ( v = c /\ u = d ) ) ->
                     ( ph <-> ps ) ) $.
    oprec.9 $e |- ( ( ( z = g /\ w = h ) /\ ( v = t /\ u = s ) ) ->
                     ( ph <-> ch ) ) $.
    $( Pre-operation. $)
    oprec.10 $e |- G = { <. <. x , y >. , z >. | ( ( x e. ( S X. S ) /\
                      y e. ( S X. S ) ) /\
                      E. w E. v E. u E. f ( ( x = <. w , v >. /\
                      y = <. u , f >. ) /\ z = J ) ) } $.
    $( Substitutions for pre-operation. $)
    oprec.11 $e |- ( ( ( w = a /\ v = b ) /\ ( u = g /\ f = h ) ) -> J = K ) $.
    oprec.12 $e |- ( ( ( w = c /\ v = d ) /\ ( u = t /\ f = s ) ) -> J = L ) $.
    oprec.13 $e |- ( ( ( w = A /\ v = B ) /\ ( u = C /\ f = D ) ) -> J = H ) $.
    $( Main operation. $)
    oprec.14 $e |- F = { <. <. x , y >. , z >. | ( ( x e. Q /\ y e. Q ) /\
           E. a E. b E. c E. d ( (
           x = [ <. a , b >. ] R /\ y = [ <. c , d >. ] R ) /\
           z = [ ( <. a , b >. G <. c , d >. ) ] R ) ) } $.
    $( Quotient class for main operation. $)
    oprec.15 $e |- Q = ( ( S X. S ) /. R ) $.
    $( Lemma to establish compatibility of pre-operation. $)
    oprec.16 $e |- ( ( ( ( a e. S /\ b e. S ) /\ ( c e. S /\ d e. S ) ) /\
                       ( ( g e. S /\ h e. S ) /\ ( t e. S /\ s e. S ) ) ) ->
                   ( ( ps /\ ch ) -> K R L ) ) $.
    $( Express an operation on equivalence classes of ordered pairs in terms
       of equivalence class of operations on ordered pairs.  (See set.mm for
       additional comments for the hypotheses.) $)
    oprec $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) ) ->
                ( [ <. A , B >. ] R F [ <. C , D >. ] R ) =
                   [ H ] R ) $=
      cA cS wcel cB cS wcel wa cC cS wcel cD cS wcel wa wa cA cB cop cR cec cC
      cD cop cR cec cF co cA cB cop cC cD cop cG co cR cec cH cR cec vx vy vz
      va vb vc vd cA cB cC cD cR cS vh vt vs cG cF vg oprec.4 oprec.5 oprec.6
      va cv cS wcel vb cv cS wcel wa vc cv cS wcel vd cv cS wcel wa wa vg cv cS
      wcel vh cv cS wcel wa vt cv cS wcel vs cv cS wcel wa wa wa wps wch wa cK
      cL cR wbr va cv vb cv cop vc cv vd cv cop cR wbr vg cv vh cv cop vt cv vs
      cv cop cR wbr wa va cv vb cv cop vg cv vh cv cop cG co vc cv vd cv cop vt
      cv vs cv cop cG co cR wbr oprec.16 va cv cS wcel vb cv cS wcel wa vc cv
      cS wcel vd cv cS wcel wa wa va cv vb cv cop vc cv vd cv cop cR wbr wps vg
      cv cS wcel vh cv cS wcel wa vt cv cS wcel vs cv cS wcel wa wa vg cv vh cv
      cop vt cv vs cv cop cR wbr wch wph wps vx vy vz vw vv vu va cv vb cv vc
      cv vd cv cR cS oprec.8 oprec.7 opbrop wph wch vx vy vz vw vv vu vg cv vh
      cv vt cv vs cv cR cS oprec.9 oprec.7 opbrop bi2anan9 va cv cS wcel vb cv
      cS wcel wa vg cv cS wcel vh cv cS wcel wa vc cv cS wcel vd cv cS wcel wa
      vt cv cS wcel vs cv cS wcel wa va cv vb cv cop vg cv vh cv cop cG co vc
      cv vd cv cop vt cv vs cv cop cG co cR wbr cK cL cR wbr wb va cv cS wcel
      vb cv cS wcel wa vg cv cS wcel vh cv cS wcel wa wa vc cv cS wcel vd cv cS
      wcel wa vt cv cS wcel vs cv cS wcel wa wa va cv vb cv cop vg cv vh cv cop
      cG co cK vc cv vd cv cop vt cv vs cv cop cG co cL cR vx vy vz vw vv vu va
      cv vb cv vg cv vh cv cJ cK vf cG cS oprec.2 oprec.11 oprec.10 oprabval3
      vx vy vz vw vv vu vc cv vd cv vt cv vs cv cJ cL vf cG cS oprec.3 oprec.12
      oprec.10 oprabval3 breqan12d an4s 3imtr4d cF vx cv cQ wcel vy cv cQ wcel
      wa vx cv va cv vb cv cop cR cec wceq vy cv vc cv vd cv cop cR cec wceq wa
      vz cv va cv vb cv cop vc cv vd cv cop cG co cR cec wceq wa vd wex vc wex
      vb wex va wex wa vx vy vz copab2 vx cv cS cS cxp cR cqs wcel vy cv cS cS
      cxp cR cqs wcel wa vx cv va cv vb cv cop cR cec wceq vy cv vc cv vd cv
      cop cR cec wceq wa vz cv va cv vb cv cop vc cv vd cv cop cG co cR cec
      wceq wa vd wex vc wex vb wex va wex wa vx vy vz copab2 oprec.14 vx cv cQ
      wcel vy cv cQ wcel wa vx cv va cv vb cv cop cR cec wceq vy cv vc cv vd cv
      cop cR cec wceq wa vz cv va cv vb cv cop vc cv vd cv cop cG co cR cec
      wceq wa vd wex vc wex vb wex va wex wa vx cv cS cS cxp cR cqs wcel vy cv
      cS cS cxp cR cqs wcel wa vx cv va cv vb cv cop cR cec wceq vy cv vc cv vd
      cv cop cR cec wceq wa vz cv va cv vb cv cop vc cv vd cv cop cG co cR cec
      wceq wa vd wex vc wex vb wex va wex wa vx vy vz vx cv cQ wcel vy cv cQ
      wcel wa vx cv cS cS cxp cR cqs wcel vy cv cS cS cxp cR cqs wcel wa vx cv
      va cv vb cv cop cR cec wceq vy cv vc cv vd cv cop cR cec wceq wa vz cv va
      cv vb cv cop vc cv vd cv cop cG co cR cec wceq wa vd wex vc wex vb wex va
      wex vx cv cQ wcel vx cv cS cS cxp cR cqs wcel vy cv cQ wcel vy cv cS cS
      cxp cR cqs wcel cQ cS cS cxp cR cqs vx cv oprec.15 eleq2i cQ cS cS cxp cR
      cqs vy cv oprec.15 eleq2i anbi12i anbi1i oprabbii eqtri th3q cA cS wcel
      cB cS wcel wa cC cS wcel cD cS wcel wa wa cA cB cop cC cD cop cG co cH
      wceq cA cB cop cC cD cop cG co cR cec cH cR cec wceq vx vy vz vw vv vu cA
      cB cC cD cJ cH vf cG cS oprec.1 oprec.13 oprec.10 oprabval3 cA cB cop cC
      cD cop cG co cH cR eceq2 syl eqtrd $.
      $( [6-Aug-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w F $.  $d x y z w R $.
    $d x y z w S $.  $d z w C $.
    ecoprcom.1 $e |- C = ( ( S X. S ) /. R ) $.
    $( D,G for AFB $)
    ecoprcom.2 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
 ( [ <. x , y >. ] R F [ <. z , w >. ] R ) = [ <. D , G >. ] R ) $.
    $( H,J for BFA $)
    ecoprcom.3 $e |- ( ( ( z e. S /\ w e. S ) /\ ( x e. S /\ y e. S ) ) ->
 ( [ <. z , w >. ] R F [ <. x , y >. ] R ) = [ <. H , J >. ] R ) $.
    ecoprcom.4 $e |- D = H $.
    ecoprcom.5 $e |- G = J $.
    $( Lemma used to transfer a commutative law via an equivalence relation. $)
    ecoprcom $p |- ( ( A e. C /\ B e. C ) -> ( A F B ) = ( B F A ) ) $=
      vx cv vy cv cop cR cec vz cv vw cv cop cR cec cF co vz cv vw cv cop cR
      cec vx cv vy cv cop cR cec cF co wceq cA vz cv vw cv cop cR cec cF co vz
      cv vw cv cop cR cec cA cF co wceq cA cB cF co cB cA cF co wceq vx vy vz
      vw cA cB cS cS cR cC ecoprcom.1 vx cv vy cv cop cR cec cA wceq vx cv vy
      cv cop cR cec vz cv vw cv cop cR cec cF co cA vz cv vw cv cop cR cec cF
      co vz cv vw cv cop cR cec vx cv vy cv cop cR cec cF co vz cv vw cv cop cR
      cec cA cF co vx cv vy cv cop cR cec cA vz cv vw cv cop cR cec cF opreq1
      vx cv vy cv cop cR cec cA vz cv vw cv cop cR cec cF opreq2 eqeq12d vz cv
      vw cv cop cR cec cB wceq cA vz cv vw cv cop cR cec cF co cA cB cF co vz
      cv vw cv cop cR cec cA cF co cB cA cF co vz cv vw cv cop cR cec cB cA cF
      opreq2 vz cv vw cv cop cR cec cB cA cF opreq1 eqeq12d vx cv cS wcel vy cv
      cS wcel wa vz cv cS wcel vw cv cS wcel wa wa cD cG cop cR cec cH cJ cop
      cR cec vx cv vy cv cop cR cec vz cv vw cv cop cR cec cF co vz cv vw cv
      cop cR cec vx cv vy cv cop cR cec cF co cD cH wceq cG cJ wceq cD cG cop
      cR cec cH cJ cop cR cec wceq ecoprcom.4 ecoprcom.5 cD cH wceq cG cJ wceq
      wa cD cG cop cH cJ cop wceq cD cG cop cR cec cH cJ cop cR cec wceq cD cG
      cH cJ opeq12 cD cG cop cH cJ cop cR eceq2 syl mp2an ecoprcom.2 vz cv cS
      wcel vw cv cS wcel wa vx cv cS wcel vy cv cS wcel wa vz cv vw cv cop cR
      cec vx cv vy cv cop cR cec cF co cH cJ cop cR cec wceq ecoprcom.3 ancoms
      3eqtr4a 2ecoptocl $.
      $( [29-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u F $.  $d x y z w v u R $.  $d x y z w v u S $.
    $d z w v u D $.
    ecoprass.1 $e |- D = ( ( S X. S ) /. R ) $.
    ecoprass.2 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
 ( [ <. x , y >. ] R F [ <. z , w >. ] R ) = [ <. G , H >. ] R ) $.
    ecoprass.3 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. z , w >. ] R F [ <. v , u >. ] R ) = [ <. N , Q >. ] R ) $.
    ecoprass.4 $e |- ( ( ( G e. S /\ H e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. G , H >. ] R F [ <. v , u >. ] R ) = [ <. J , K >. ] R ) $.
    ecoprass.5 $e |- ( ( ( x e. S /\ y e. S ) /\ ( N e. S /\ Q e. S ) ) ->
 ( [ <. x , y >. ] R F [ <. N , Q >. ] R ) = [ <. L , M >. ] R ) $.
    ecoprass.6 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
                     ( G e. S /\ H e. S ) ) $.
    ecoprass.7 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
                     ( N e. S /\ Q e. S ) ) $.
    ecoprass.8 $e |- J = L $.
    ecoprass.9 $e |- K = M $.
    $( Lemma used to transfer an associative law via an equivalence
       relation. $)
    ecoprass $p |- ( ( A e. D /\ B e. D /\ C e. D ) ->
                 ( ( A F B ) F C ) = ( A F ( B F C ) ) ) $=
      vx cv vy cv cop cR cec vz cv vw cv cop cR cec cF co vv cv vu cv cop cR
      cec cF co vx cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv vu cv cop
      cR cec cF co cF co wceq cA vz cv vw cv cop cR cec cF co vv cv vu cv cop
      cR cec cF co cA vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co cF co
      wceq cA cB cF co vv cv vu cv cop cR cec cF co cA cB vv cv vu cv cop cR
      cec cF co cF co wceq cA cB cF co cC cF co cA cB cC cF co cF co wceq vx vy
      vz vw vv vu cA cB cC cS cR cD ecoprass.1 vx cv vy cv cop cR cec cA wceq
      vx cv vy cv cop cR cec vz cv vw cv cop cR cec cF co vv cv vu cv cop cR
      cec cF co cA vz cv vw cv cop cR cec cF co vv cv vu cv cop cR cec cF co vx
      cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co
      cF co cA vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co cF co vx cv
      vy cv cop cR cec cA wceq vx cv vy cv cop cR cec vz cv vw cv cop cR cec cF
      co cA vz cv vw cv cop cR cec cF co vv cv vu cv cop cR cec cF vx cv vy cv
      cop cR cec cA vz cv vw cv cop cR cec cF opreq1 opreq1d vx cv vy cv cop cR
      cec cA vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co cF opreq1
      eqeq12d vz cv vw cv cop cR cec cB wceq cA vz cv vw cv cop cR cec cF co vv
      cv vu cv cop cR cec cF co cA cB cF co vv cv vu cv cop cR cec cF co cA vz
      cv vw cv cop cR cec vv cv vu cv cop cR cec cF co cF co cA cB vv cv vu cv
      cop cR cec cF co cF co vz cv vw cv cop cR cec cB wceq cA vz cv vw cv cop
      cR cec cF co cA cB cF co vv cv vu cv cop cR cec cF vz cv vw cv cop cR cec
      cB cA cF opreq2 opreq1d vz cv vw cv cop cR cec cB wceq vz cv vw cv cop cR
      cec vv cv vu cv cop cR cec cF co cB vv cv vu cv cop cR cec cF co cA cF vz
      cv vw cv cop cR cec cB vv cv vu cv cop cR cec cF opreq1 opreq2d eqeq12d
      vv cv vu cv cop cR cec cC wceq cA cB cF co vv cv vu cv cop cR cec cF co
      cA cB cF co cC cF co cA cB vv cv vu cv cop cR cec cF co cF co cA cB cC cF
      co cF co vv cv vu cv cop cR cec cC cA cB cF co cF opreq2 vv cv vu cv cop
      cR cec cC wceq cB vv cv vu cv cop cR cec cF co cB cC cF co cA cF vv cv vu
      cv cop cR cec cC cB cF opreq2 opreq2d eqeq12d vx cv cS wcel vy cv cS wcel
      wa vz cv cS wcel vw cv cS wcel wa vv cv cS wcel vu cv cS wcel wa w3a cJ
      cK cop cR cec cL cM cop cR cec vx cv vy cv cop cR cec vz cv vw cv cop cR
      cec cF co vv cv vu cv cop cR cec cF co vx cv vy cv cop cR cec vz cv vw cv
      cop cR cec vv cv vu cv cop cR cec cF co cF co cJ cL wceq cK cM wceq cJ cK
      cop cR cec cL cM cop cR cec wceq ecoprass.8 ecoprass.9 cJ cL wceq cK cM
      wceq wa cJ cK cop cL cM cop wceq cJ cK cop cR cec cL cM cop cR cec wceq
      cJ cK cL cM opeq12 cJ cK cop cL cM cop cR eceq2 syl mp2an vx cv cS wcel
      vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa vv cv cS wcel vu cv cS
      wcel wa vx cv vy cv cop cR cec vz cv vw cv cop cR cec cF co vv cv vu cv
      cop cR cec cF co cJ cK cop cR cec wceq vx cv cS wcel vy cv cS wcel wa vz
      cv cS wcel vw cv cS wcel wa wa vv cv cS wcel vu cv cS wcel wa wa vx cv vy
      cv cop cR cec vz cv vw cv cop cR cec cF co vv cv vu cv cop cR cec cF co
      cG cH cop cR cec vv cv vu cv cop cR cec cF co cJ cK cop cR cec vx cv cS
      wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa wa vx cv vy cv cop
      cR cec vz cv vw cv cop cR cec cF co vv cv vu cv cop cR cec cF co cG cH
      cop cR cec vv cv vu cv cop cR cec cF co wceq vv cv cS wcel vu cv cS wcel
      wa vx cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa wa vx cv
      vy cv cop cR cec vz cv vw cv cop cR cec cF co cG cH cop cR cec vv cv vu
      cv cop cR cec cF ecoprass.2 opreq1d adantr cG cS wcel cH cS wcel wa vv cv
      cS wcel vu cv cS wcel wa cG cH cop cR cec vv cv vu cv cop cR cec cF co cJ
      cK cop cR cec wceq vx cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS
      wcel wa wa ecoprass.4 ecoprass.6 sylan eqtrd 3impa vx cv cS wcel vy cv cS
      wcel wa vz cv cS wcel vw cv cS wcel wa vv cv cS wcel vu cv cS wcel wa vx
      cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co
      cF co cL cM cop cR cec wceq vx cv cS wcel vy cv cS wcel wa vz cv cS wcel
      vw cv cS wcel wa vv cv cS wcel vu cv cS wcel wa wa wa vx cv vy cv cop cR
      cec vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co cF co vx cv vy cv
      cop cR cec cN cQ cop cR cec cF co cL cM cop cR cec vz cv cS wcel vw cv cS
      wcel wa vv cv cS wcel vu cv cS wcel wa wa vx cv vy cv cop cR cec vz cv vw
      cv cop cR cec vv cv vu cv cop cR cec cF co cF co vx cv vy cv cop cR cec
      cN cQ cop cR cec cF co wceq vx cv cS wcel vy cv cS wcel wa vz cv cS wcel
      vw cv cS wcel wa vv cv cS wcel vu cv cS wcel wa wa vz cv vw cv cop cR cec
      vv cv vu cv cop cR cec cF co cN cQ cop cR cec vx cv vy cv cop cR cec cF
      ecoprass.3 opreq2d adantl vx cv cS wcel vy cv cS wcel wa cN cS wcel cQ cS
      wcel wa vx cv vy cv cop cR cec cN cQ cop cR cec cF co cL cM cop cR cec
      wceq vz cv cS wcel vw cv cS wcel wa vv cv cS wcel vu cv cS wcel wa wa
      ecoprass.5 ecoprass.7 sylan2 eqtrd 3impb 3eqtr4a 3ecoptocl $.
      $( [31-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u F $.  $d x y z w v u R $.  $d x y z w v u S $.
    $d x y z w v u G $.  $d z w v u D $.
    ecoprdi.1 $e |- D = ( ( S X. S ) /. R ) $.
    $( M,N for BFC $)
    ecoprdi.2 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. z , w >. ] R F [ <. v , u >. ] R ) = [ <. M , N >. ] R ) $.
    $( H,J for AG(BFC) $)
    ecoprdi.3 $e |- ( ( ( x e. S /\ y e. S ) /\ ( M e. S /\ N e. S ) ) ->
 ( [ <. x , y >. ] R G [ <. M , N >. ] R ) = [ <. H , J >. ] R ) $.
    $( W,X for AGB $)
    ecoprdi.4 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
 ( [ <. x , y >. ] R G [ <. z , w >. ] R ) = [ <. W , X >. ] R ) $.
    $( Y,Z for AGC $)
    ecoprdi.5 $e |- ( ( ( x e. S /\ y e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. x , y >. ] R G [ <. v , u >. ] R ) = [ <. Y , Z >. ] R ) $.
    $( K,L for (AGB)F(AGC) $)
    ecoprdi.6 $e |- ( ( ( W e. S /\ X e. S ) /\ ( Y e. S /\ Z e. S ) ) ->
 ( [ <. W , X >. ] R F [ <. Y , Z >. ] R ) = [ <. K , L >. ] R ) $.
    ecoprdi.7 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
                     ( M e. S /\ N e. S ) ) $.
    ecoprdi.8 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
                     ( W e. S /\ X e. S ) ) $.
    ecoprdi.9 $e |- ( ( ( x e. S /\ y e. S ) /\ ( v e. S /\ u e. S ) ) ->
                     ( Y e. S /\ Z e. S ) ) $.
    ecoprdi.10 $e |- H = K $.
    ecoprdi.11 $e |- J = L $.
    $( Lemma used to transfer a distributive law via an equivalence
       relation. $)
    ecoprdi $p |- ( ( A e. D /\ B e. D /\ C e. D ) ->
                 ( A G ( B F C ) ) = ( ( A G B ) F ( A G C ) ) ) $=
      vx cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF
      co cG co vx cv vy cv cop cR cec vz cv vw cv cop cR cec cG co vx cv vy cv
      cop cR cec vv cv vu cv cop cR cec cG co cF co wceq cA vz cv vw cv cop cR
      cec vv cv vu cv cop cR cec cF co cG co cA vz cv vw cv cop cR cec cG co cA
      vv cv vu cv cop cR cec cG co cF co wceq cA cB vv cv vu cv cop cR cec cF
      co cG co cA cB cG co cA vv cv vu cv cop cR cec cG co cF co wceq cA cB cC
      cF co cG co cA cB cG co cA cC cG co cF co wceq vx vy vz vw vv vu cA cB cC
      cS cR cD ecoprdi.1 vx cv vy cv cop cR cec cA wceq vx cv vy cv cop cR cec
      vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co cG co cA vz cv vw cv
      cop cR cec vv cv vu cv cop cR cec cF co cG co vx cv vy cv cop cR cec vz
      cv vw cv cop cR cec cG co vx cv vy cv cop cR cec vv cv vu cv cop cR cec
      cG co cF co cA vz cv vw cv cop cR cec cG co cA vv cv vu cv cop cR cec cG
      co cF co vx cv vy cv cop cR cec cA vz cv vw cv cop cR cec vv cv vu cv cop
      cR cec cF co cG opreq1 vx cv vy cv cop cR cec cA wceq vx cv vy cv cop cR
      cec vz cv vw cv cop cR cec cG co cA vz cv vw cv cop cR cec cG co vx cv vy
      cv cop cR cec vv cv vu cv cop cR cec cG co cA vv cv vu cv cop cR cec cG
      co cF vx cv vy cv cop cR cec cA vz cv vw cv cop cR cec cG opreq1 vx cv vy
      cv cop cR cec cA vv cv vu cv cop cR cec cG opreq1 opreq12d eqeq12d vz cv
      vw cv cop cR cec cB wceq cA vz cv vw cv cop cR cec vv cv vu cv cop cR cec
      cF co cG co cA cB vv cv vu cv cop cR cec cF co cG co cA vz cv vw cv cop
      cR cec cG co cA vv cv vu cv cop cR cec cG co cF co cA cB cG co cA vv cv
      vu cv cop cR cec cG co cF co vz cv vw cv cop cR cec cB wceq vz cv vw cv
      cop cR cec vv cv vu cv cop cR cec cF co cB vv cv vu cv cop cR cec cF co
      cA cG vz cv vw cv cop cR cec cB vv cv vu cv cop cR cec cF opreq1 opreq2d
      vz cv vw cv cop cR cec cB wceq cA vz cv vw cv cop cR cec cG co cA cB cG
      co cA vv cv vu cv cop cR cec cG co cF vz cv vw cv cop cR cec cB cA cG
      opreq2 opreq1d eqeq12d vv cv vu cv cop cR cec cC wceq cA cB vv cv vu cv
      cop cR cec cF co cG co cA cB cC cF co cG co cA cB cG co cA vv cv vu cv
      cop cR cec cG co cF co cA cB cG co cA cC cG co cF co vv cv vu cv cop cR
      cec cC wceq cB vv cv vu cv cop cR cec cF co cB cC cF co cA cG vv cv vu cv
      cop cR cec cC cB cF opreq2 opreq2d vv cv vu cv cop cR cec cC wceq cA vv
      cv vu cv cop cR cec cG co cA cC cG co cA cB cG co cF vv cv vu cv cop cR
      cec cC cA cG opreq2 opreq2d eqeq12d vx cv cS wcel vy cv cS wcel wa vz cv
      cS wcel vw cv cS wcel wa vv cv cS wcel vu cv cS wcel wa w3a cH cJ cop cR
      cec cK cL cop cR cec vx cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv
      vu cv cop cR cec cF co cG co vx cv vy cv cop cR cec vz cv vw cv cop cR
      cec cG co vx cv vy cv cop cR cec vv cv vu cv cop cR cec cG co cF co cH cK
      wceq cJ cL wceq cH cJ cop cR cec cK cL cop cR cec wceq ecoprdi.10
      ecoprdi.11 cH cK wceq cJ cL wceq wa cH cJ cop cK cL cop wceq cH cJ cop cR
      cec cK cL cop cR cec wceq cH cJ cK cL opeq12 cH cJ cop cK cL cop cR eceq2
      syl mp2an vx cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa
      vv cv cS wcel vu cv cS wcel wa vx cv vy cv cop cR cec vz cv vw cv cop cR
      cec vv cv vu cv cop cR cec cF co cG co cH cJ cop cR cec wceq vx cv cS
      wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa vv cv cS wcel vu cv
      cS wcel wa wa wa vx cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv vu
      cv cop cR cec cF co cG co vx cv vy cv cop cR cec cM cN cop cR cec cG co
      cH cJ cop cR cec vz cv cS wcel vw cv cS wcel wa vv cv cS wcel vu cv cS
      wcel wa wa vx cv vy cv cop cR cec vz cv vw cv cop cR cec vv cv vu cv cop
      cR cec cF co cG co vx cv vy cv cop cR cec cM cN cop cR cec cG co wceq vx
      cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa vv cv cS wcel
      vu cv cS wcel wa wa vz cv vw cv cop cR cec vv cv vu cv cop cR cec cF co
      cM cN cop cR cec vx cv vy cv cop cR cec cG ecoprdi.2 opreq2d adantl vx cv
      cS wcel vy cv cS wcel wa cM cS wcel cN cS wcel wa vx cv vy cv cop cR cec
      cM cN cop cR cec cG co cH cJ cop cR cec wceq vz cv cS wcel vw cv cS wcel
      wa vv cv cS wcel vu cv cS wcel wa wa ecoprdi.3 ecoprdi.7 sylan2 eqtrd
      3impb vx cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa vv cv
      cS wcel vu cv cS wcel wa vx cv vy cv cop cR cec vz cv vw cv cop cR cec cG
      co vx cv vy cv cop cR cec vv cv vu cv cop cR cec cG co cF co cK cL cop cR
      cec wceq vx cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa wa
      vx cv cS wcel vy cv cS wcel wa vv cv cS wcel vu cv cS wcel wa wa wa vx cv
      vy cv cop cR cec vz cv vw cv cop cR cec cG co vx cv vy cv cop cR cec vv
      cv vu cv cop cR cec cG co cF co cW cX cop cR cec cY cZ cop cR cec cF co
      cK cL cop cR cec vx cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS
      wcel wa wa vx cv cS wcel vy cv cS wcel wa vv cv cS wcel vu cv cS wcel wa
      wa vx cv vy cv cop cR cec vz cv vw cv cop cR cec cG co cW cX cop cR cec
      vx cv vy cv cop cR cec vv cv vu cv cop cR cec cG co cY cZ cop cR cec cF
      ecoprdi.4 ecoprdi.5 opreqan12d cW cS wcel cX cS wcel wa cY cS wcel cZ cS
      wcel wa cW cX cop cR cec cY cZ cop cR cec cF co cK cL cop cR cec wceq vx
      cv cS wcel vy cv cS wcel wa vz cv cS wcel vw cv cS wcel wa wa vx cv cS
      wcel vy cv cS wcel wa vv cv cS wcel vu cv cS wcel wa wa ecoprdi.6
      ecoprdi.8 ecoprdi.9 syl2an eqtrd 3impdi 3eqtr4a 3ecoptocl $.
      $( [2-Sep-1995] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The mapping operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c ^m $.  $( The mapping operation. $)
  $c ^pm $.  $( The mapping operation. $)

  $( Extend the definition of a class to include the mapping operation.
     (Read for ` A ^m B ` , "the set of all functions that map from
     ` B ` to ` A ` .) $)
  cm $a class ^m $.

  $( Extend the definition of a class to include the partial mapping operation.
     (Read for ` A ^m B ` , "the set of all partial functions that map from
     ` B ` to ` A ` .) $)
  cpm $a class ^pm $.

  ${
    $d x y z f $.
    $( Define the mapping operation or set exponentiation.  The set of all
       functions that map from ` B ` to ` A ` is written ` ( A ^m B ) ` (see
       ~ mapval ).  Many authors write ` A ` followed by ` B ` as a superscript
       for this operation and rely on context to avoid confusion other
       exponentiation operations (e.g. Definition 10.42 of [TakeutiZaring]
       p. 95).  Other authors show ` B ` as a prefixed superscript, which is
       read " ` A ` pre ` B ` " (e.g. definition of [Enderton] p. 52).
       Definition 8.21 of [Eisenberg] p. 125 uses the notation Map( ` B ` ,
       ` A ` ) for our ` ( A ^m B ) ` .  The up-arrow is used by Donald Knuth
       for iterated exponentiation (_Science_ 194, 1235-1242, 1976).  We adopt
       the first case of his notation (simple exponentiation) and subscript it
       with _m_ to distinguish it from other kinds of exponentiation. $)
    df-map $a |- ^m = { <. <. x , y >. , z >. | z = { f | f : y --> x } } $.

    $( Define the partial mapping operation.  A partial function from ` B ` to
       ` A ` is a function from a subset of ` B ` to ` A ` .  The set of all
       partial functions from ` B ` to ` A ` is written ` ( A ^pm B ) ` (see
       ~ pmvalg ).  A notation for this operation apparently does not appear in
       the literature.  We use ` ^pm ` to distinguish it from the less
       general set exponentiation operation ` ^m ` ( ~ df-map ) .  See
       ~ mapsspm for its relationship to set exponentiation. $)
    df-pm $a |- ^pm = { <. <. x , y >. , z >. | z =
                    { f | ( Fun f /\ f C_ ( y X. x ) ) } } $.
  $}

  $( Note:  an alternate way to express partial functions is as follows,
     which would be added after df-fun above.  The symbol would be _pfun.gif.
     This definition would be needed only if we need proper class partial
     functions, which seems unlikely.  While nice-looking, for ordinary usage
     it would inconveniently require a new set of equality theorems, etc. $)
  $( Define a partial function, which is a function from a subset of the
     domain ` A ` to the codomain ` B ` .  The notation of a stroke through
     the arrow is used by the Z language: see, for example,
     ~ http://staff.washington.edu/jon/z/dcs.html . $)
  $(
  df-fp $a |- ( F : A -|-> B <-> ( Fun F /\ F C_ ( X X. Y ) ) $.
  $)

  ${
    $d f x A $.  $d f x B $.
    $( When ` A ` is a proper class, the class of all functions mapping ` A `
       to ` B ` is empty.  Exercise 4.41 of [Mendelson] p. 255. $)
    mapprc $p |- ( -. A e. _V -> { f | f : A --> B } = (/) ) $=
      cA cvv wcel cA cB vf cv wf vf cab c0 cA cB vf cv wf vf cab c0 wne cA cB
      vf cv wf vf wex cA cvv wcel cA cB vf cv wf vf abn0 cA cB vf cv wf cA cvv
      wcel vf cA cB vf cv wf cA vf cv cdm cvv cA cB vf cv fdm vf cv vf visset
      dmex syl6eqelr 19.23aiv sylbi necon1bi $.
      $( [10-Dec-2003] $) $( [8-Dec-2003] $)

    $( The class of all partial functions from one set to another is a set. $)
    pmex $p |- ( ( A e. C /\ B e. D ) ->
                   { f | ( Fun f /\ f C_ ( A X. B ) ) } e. _V ) $=
      cA cC wcel cB cD wcel wa vf cv cA cB cxp wss vf cv wfun wa vf cab cvv vf
      cv wfun vf cv cA cB cxp wss wa vf cab cA cC wcel cB cD wcel wa cA cB cxp
      cvv wcel vf cv cA cB cxp wss vf cv wfun wa vf cab cvv wcel cA cB cC cD
      xpexg vf cv wfun vf cA cB cxp cvv abssexg syl vf cv wfun vf cv cA cB cxp
      wss wa vf cv cA cB cxp wss vf cv wfun wa vf vf cv wfun vf cv cA cB cxp
      wss ancom abbii syl5eqel $.
      $( [16-Nov-2007] $) $( [15-Nov-2007] $)

    $( The class of all functions mapping one set to another is a set.  Remark
       after Definition 10.24 of [Kunen] p. 31.  (Contributed by Raph Levien,
       4-Dec-2003.) $)
    mapex $p |- ( ( A e. C /\ B e. D ) -> { f | f : A --> B } e. _V ) $=
      cA cB vf cv wf vf cab cA cB cxp cpw wss cA cB cxp cpw cvv wcel cA cB vf
      cv wf vf cab cvv wcel cA cC wcel cB cD wcel wa cA cB vf cv wf vf cab cA
      cB cxp cpw cvv ssexg cA cB vf cv wf vf cab vf cv cA cB cxp wss vf cab cA
      cB cxp cpw cA cB vf cv wf vf cv cA cB cxp wss vf cA cB vf cv fssxp ss2abi
      vf cA cB cxp df-pw sseqtr4i cA cC wcel cB cD wcel wa cA cB cxp cvv wcel
      cA cB cxp cpw cvv wcel cA cB cC cD xpexg cA cB cxp cvv pwexg syl sylancr
      $.
      $( [8-Dec-2003] $) $( [4-Dec-2003] $)
  $}

  ${
    $d f x y z $.
    $( Set exponentiation has a universal domain. $)
    fnmap $p |- ^m Fn ( _V X. _V ) $=
      vx vy vz cvv cvv vy cv vx cv vf cv wf vf cab cm vy cv cvv wcel vx cv cvv
      wcel vy cv vx cv vf cv wf vf cab cvv wcel vy visset vx visset vy cv vx cv
      cvv cvv vf mapex mp2an cm vz cv vy cv vx cv vf cv wf vf cab wceq vx vy vz
      copab2 vx cv cvv wcel vy cv cvv wcel wa vz cv vy cv vx cv vf cv wf vf cab
      wceq wa vx vy vz copab2 vx vy vz vf df-map vz cv vy cv vx cv vf cv wf vf
      cab wceq vx cv cvv wcel vy cv cvv wcel wa vz cv vy cv vx cv vf cv wf vf
      cab wceq wa vx vy vz vx cv cvv wcel vy cv cvv wcel wa vz cv vy cv vx cv
      vf cv wf vf cab wceq vx cv cvv wcel vy cv cvv wcel vx visset vy visset
      pm3.2i biantrur oprabbii eqtri fnoprab2 $.
      $( [16-Jun-2004] $) $( [8-Dec-2003] $)
  $}

  ${
    $d x y z f A $.  $d x y z f B $.
    $( The value of set exponentiation.  ` ( A ^m B ) ` is the set of all
       functions that map from ` B ` to ` A ` .  Definition 10.24 of [Kunen]
       p. 24. $)
    mapvalg $p |- ( ( A e. C /\ B e. D ) ->
                  ( A ^m B ) = { f | f : B --> A } ) $=
      cA cC wcel cB cD wcel wa cB cA vf cv wf vf cab cvv wcel cA cB cm co cB cA
      vf cv wf vf cab wceq cB cD wcel cA cC wcel cB cA vf cv wf vf cab cvv wcel
      cB cA cD cC vf mapex ancoms cA cvv wcel cB cvv wcel cB cA vf cv wf vf cab
      cvv wcel cA cB cm co cB cA vf cv wf vf cab wceq wi cA cC wcel cB cD wcel
      cA cvv wcel cB cvv wcel cB cA vf cv wf vf cab cvv wcel cA cB cm co cB cA
      vf cv wf vf cab wceq vx vy vz cA cB cvv cvv vy cv vx cv vf cv wf vf cab
      cB cA vf cv wf vf cab cm vy cv cA vf cv wf vf cab cvv vx cv cA wceq vy cv
      vx cv vf cv wf vy cv cA vf cv wf vf vx cv cA vy cv vf cv feq3 abbidv vy
      cv cB wceq vy cv cA vf cv wf cB cA vf cv wf vf vy cv cB cA vf cv feq2
      abbidv cm vz cv vy cv vx cv vf cv wf vf cab wceq vx vy vz copab2 vx cv
      cvv wcel vy cv cvv wcel wa vz cv vy cv vx cv vf cv wf vf cab wceq wa vx
      vy vz copab2 vx vy vz vf df-map vz cv vy cv vx cv vf cv wf vf cab wceq vx
      cv cvv wcel vy cv cvv wcel wa vz cv vy cv vx cv vf cv wf vf cab wceq wa
      vx vy vz vx cv cvv wcel vy cv cvv wcel wa vz cv vy cv vx cv vf cv wf vf
      cab wceq vx cv cvv wcel vy cv cvv wcel vx visset vy visset pm3.2i
      biantrur oprabbii eqtri oprabval2g 3expia cA cC elisset cB cD elisset
      syl2an mpd $.
      $( [8-Dec-2003] $) $( [8-Dec-2003] $)

    $( The value of the partial mapping operation.  ` ( A ^pm B ) ` is the set
       of all partial functions that map from ` B ` to ` A ` . $)
    pmvalg $p |- ( ( A e. C /\ B e. D ) ->
                  ( A ^pm B ) = { f | ( Fun f /\ f C_ ( B X. A ) ) } ) $=
      cA cC wcel cB cD wcel wa vf cv wfun vf cv cB cA cxp wss wa vf cab cvv
      wcel cA cB cpm co vf cv wfun vf cv cB cA cxp wss wa vf cab wceq cB cD
      wcel cA cC wcel vf cv wfun vf cv cB cA cxp wss wa vf cab cvv wcel cB cA
      cD cC vf pmex ancoms cA cvv wcel cB cvv wcel vf cv wfun vf cv cB cA cxp
      wss wa vf cab cvv wcel cA cB cpm co vf cv wfun vf cv cB cA cxp wss wa vf
      cab wceq wi cA cC wcel cB cD wcel cA cvv wcel cB cvv wcel vf cv wfun vf
      cv cB cA cxp wss wa vf cab cvv wcel cA cB cpm co vf cv wfun vf cv cB cA
      cxp wss wa vf cab wceq vx vy vz cA cB cvv cvv vf cv wfun vf cv vy cv vx
      cv cxp wss wa vf cab vf cv wfun vf cv cB cA cxp wss wa vf cab cpm vf cv
      wfun vf cv vy cv cA cxp wss wa vf cab cvv vx cv cA wceq vf cv wfun vf cv
      vy cv vx cv cxp wss wa vf cv wfun vf cv vy cv cA cxp wss wa vf vx cv cA
      wceq vf cv vy cv vx cv cxp wss vf cv vy cv cA cxp wss vf cv wfun vx cv cA
      wceq vy cv vx cv cxp vy cv cA cxp vf cv vx cv cA vy cv xpeq2 sseq2d
      anbi2d abbidv vy cv cB wceq vf cv wfun vf cv vy cv cA cxp wss wa vf cv
      wfun vf cv cB cA cxp wss wa vf vy cv cB wceq vf cv vy cv cA cxp wss vf cv
      cB cA cxp wss vf cv wfun vy cv cB wceq vy cv cA cxp cB cA cxp vf cv vy cv
      cB cA xpeq1 sseq2d anbi2d abbidv cpm vz cv vf cv wfun vf cv vy cv vx cv
      cxp wss wa vf cab wceq vx vy vz copab2 vx cv cvv wcel vy cv cvv wcel wa
      vz cv vf cv wfun vf cv vy cv vx cv cxp wss wa vf cab wceq wa vx vy vz
      copab2 vx vy vz vf df-pm vz cv vf cv wfun vf cv vy cv vx cv cxp wss wa vf
      cab wceq vx cv cvv wcel vy cv cvv wcel wa vz cv vf cv wfun vf cv vy cv vx
      cv cxp wss wa vf cab wceq wa vx vy vz vx cv cvv wcel vy cv cvv wcel wa vz
      cv vf cv wfun vf cv vy cv vx cv cxp wss wa vf cab wceq vx cv cvv wcel vy
      cv cvv wcel vx visset vy visset pm3.2i biantrur oprabbii eqtri oprabval2g
      3expia cA cC elisset cB cD elisset syl2an mpd $.
      $( [17-Nov-2007] $) $( [15-Nov-2007] $)
  $}

  ${
    $d f A $.  $d f B $.
    mapval.1 $e |- A e. _V $.
    mapval.2 $e |- B e. _V $.
    $( The value of set exponentiation (inference version).  ` ( A ^m B ) `
       is the set of all functions that map from ` B ` to ` A ` .  Definition
       10.24 of [Kunen] p. 24. $)
    mapval $p |-  ( A ^m B ) = { f | f : B --> A } $=
      cA cvv wcel cB cvv wcel cA cB cm co cB cA vf cv wf vf cab wceq mapval.1
      mapval.2 cA cB cvv cvv vf mapvalg mp2an $.
      $( [8-Dec-2003] $) $( [8-Dec-2003] $)
  $}

  ${
    $d g A $.  $d g B $.  $d g C $.
    $( Membership relation for set exponentiation. $)
    elmapg $p |-  ( ( A e. R /\ B e. S ) ->
                  ( C e. ( A ^m B ) <-> C : B --> A ) ) $=
      cA cR wcel cB cS wcel wa cC cA cB cm co wcel cC cB cA vg cv wf vg cab
      wcel cB cA cC wf cA cR wcel cB cS wcel wa cA cB cm co cB cA vg cv wf vg
      cab cC cA cB cR cS vg mapvalg eleq2d cA cR wcel cB cS wcel wa cB cA cC wf
      cC cvv wcel wi cC cB cA vg cv wf vg cab wcel cB cA cC wf wb cB cS wcel cB
      cA cC wf cC cvv wcel wi cA cR wcel cB cA cC wf cB cS wcel cC cvv wcel cB
      cA cS cC fex expcom adantl cB cA vg cv wf cB cA cC wf vg cC cvv cB cA vg
      cv cC feq1 elab3g syl bitrd $.
      $( [17-Oct-2006] $) $( [17-Oct-2006] $)
  $}

  ${
    $d g A $.  $d f g B $.  $d g F $.
    elmap.1 $e |- A e. _V $.
    elmap.2 $e |- B e. _V $.
    $( Membership relation for set exponentiation. $)
    elmap $p |-  ( F e. ( A ^m B ) <-> F : B --> A ) $=
      cA cvv wcel cB cvv wcel cF cA cB cm co wcel cB cA cF wf wb elmap.1
      elmap.2 cA cB cF cvv cvv elmapg mp2an $.
      $( [30-Jan-2004] $) $( [8-Dec-2003] $)

    $( Alternate expression for the value of set exponentiation. $)
    mapval2 $p |- ( A ^m B ) = ( ~P ( B X. A ) i^i { f | f Fn B } ) $=
      vg cA cB cm co cB cA cxp cpw vf cv cB wfn vf cab cin cB cA vg cv wf vg cv
      cB cA cxp wss vg cv cB wfn wa vg cv cA cB cm co wcel vg cv cB cA cxp cpw
      vf cv cB wfn vf cab cin wcel cB cA vg cv wf vg cv cB wfn vg cv cB cA cxp
      wss wa vg cv cB cA cxp wss vg cv cB wfn wa cB cA vg cv wf vg cv cB wfn vg
      cv cB cA cxp wss wa cB cA vg cv wf vg cv cB wfn vg cv cB cA cxp wss cB cA
      vg cv ffn cB cA vg cv fssxp jca vg cv cB wfn vg cv cB cA cxp wss wa vg cv
      cB wfn vg cv crn cA wss wa cB cA vg cv wf vg cv cB cA cxp wss vg cv crn
      cA wss vg cv cB wfn vg cv crn cB cA cxp crn wss cB cA cxp crn cA wss vg
      cv crn cA wss vg cv cB cA cxp wss vg cv crn cB cA cxp crn cA sstr vg cv
      cB cA cxp rnss cB cA rnxpss sylancl anim2i cB cA vg cv df-f sylibr impbii
      vg cv cB wfn vg cv cB cA cxp wss ancom bitri cA cB vg cv elmap.1 elmap.2
      elmap vg cv cB cA cxp cpw vf cv cB wfn vf cab cin wcel vg cv cB cA cxp
      cpw wcel vg cv vf cv cB wfn vf cab wcel wa vg cv cB cA cxp wss vg cv cB
      wfn wa vg cv cB cA cxp cpw vf cv cB wfn vf cab elin vg cv cB cA cxp cpw
      wcel vg cv cB cA cxp wss vg cv vf cv cB wfn vf cab wcel vg cv cB wfn vg
      cv cB cA cxp vg visset elpw vf cv cB wfn vg cv cB wfn vf vg cv vg visset
      cB vf cv vg cv fneq1 elab anbi12i bitri 3bitr4i eqriv $.
      $( [3-Nov-2007] $) $( [3-Nov-2007] $)

    $( The predicate "is a partial function." $)
    elpm $p |-  ( F e. ( A ^pm B ) <-> ( Fun F /\ F C_ ( B X. A ) ) ) $=
      cF cA cB cpm co wcel cF vg cv wfun vg cv cB cA cxp wss wa vg cab wcel cF
      wfun cF cB cA cxp wss wa cA cB cpm co vg cv wfun vg cv cB cA cxp wss wa
      vg cab cF cA cvv wcel cB cvv wcel cA cB cpm co vg cv wfun vg cv cB cA cxp
      wss wa vg cab wceq elmap.1 elmap.2 cA cB cvv cvv vg pmvalg mp2an eleq2i
      vg cv wfun vg cv cB cA cxp wss wa cF wfun cF cB cA cxp wss wa vg cF cF cB
      cA cxp wss cF cvv wcel cF wfun cF cB cA cxp cB cA elmap.2 elmap.1 xpex
      ssex adantl vg cv cF wceq vg cv wfun cF wfun vg cv cB cA cxp wss cF cB cA
      cxp wss vg cv cF funeq vg cv cF cB cA cxp sseq1 anbi12d elab3 bitri $.
      $( [18-Nov-2007] $) $( [15-Nov-2007] $)

    $( The predicate "is a partial function." $)
    elpm2 $p |-  ( F e. ( A ^pm B ) <-> ( F : dom F --> A /\ dom F C_ B ) ) $=
      cF cA cB cpm co wcel cF wfun cF cB cA cxp wss wa cF cdm cA cF wf cF cdm
      cB wss wa cA cB cF elmap.1 elmap.2 elpm cB cA cF funssxp bitri $.
      $( [19-Nov-2007] $) $( [15-Nov-2007] $)

    $( A total function is a partial function. $)
    fpm $p |- ( F : A --> B -> F e. ( B ^pm A ) ) $=
      cA cB cF wf cF cdm cB cF wf cF cdm cA wss wa cF cB cA cpm co wcel cA cB
      cF ffdm cB cA cF elmap.2 elmap.1 elpm2 sylibr $.
      $( [18-Nov-2007] $) $( [15-Nov-2007] $)

    $( Set exponentiation is a subset of partial maps. $)
    mapsspm $p |- ( A ^m B ) C_ ( A ^pm B ) $=
      vg cA cB cm co cA cB cpm co vg cv cA cB cm co wcel cB cA vg cv wf vg cv
      cA cB cpm co wcel cA cB vg cv elmap.1 elmap.2 elmap cB cA vg cv elmap.2
      elmap.1 fpm sylbi ssriv $.
      $( [10-Dec-2007] $) $( [15-Nov-2007] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x y R $.
    fvopabf4.1 $e |- C e. _V $.
    fvopabf4.2 $e |- D e. _V $.
    fvopabf4.3 $e |- R e. _V $.
    fvopabf4.4 $e |- ( x = A -> B = C ) $.
    fvopabf4.5 $e |- F = { <. x , y >. | ( x : D --> R /\ y = B ) } $.
    $( Special case of ~ fvopab4 for operator theorems. $)
    fvopabf4 $p |- ( A : D --> R -> ( F ` A ) = C ) $=
      cD cR cA wf cA cR cD cm co wcel cA cF cfv cC wceq cR cD cA fvopabf4.3
      fvopabf4.2 elmap vx vy cA cB cC cR cD cm co cF fvopabf4.4 cF cD cR vx cv
      wf vy cv cB wceq wa vx vy copab vx cv cR cD cm co wcel vy cv cB wceq wa
      vx vy copab fvopabf4.5 vx cv cR cD cm co wcel vy cv cB wceq wa cD cR vx
      cv wf vy cv cB wceq wa vx vy vx cv cR cD cm co wcel cD cR vx cv wf vy cv
      cB wceq cR cD vx cv fvopabf4.3 fvopabf4.2 elmap anbi1i opabbii eqtr4i
      fvopabf4.1 fvopab4 sylbir $.
      $( [7-Dec-2007] $) $( [27-Nov-2007] $)
  $}

  ${
    $d f A $.  $d f B $.
    $( Set exponentiation is a subset of the power set of the cross product
       of its arguments. $)
    mapsspw $p |- ( B e. R -> ( A ^m B ) C_ ~P ( B X. A ) ) $=
      cA cvv wcel cB cR wcel cA cB cm co cB cA cxp cpw wss cA cvv wcel cB cR
      wcel wa cA cB cm co cB cA vf cv wf vf cab cB cA cxp cpw cA cB cvv cR vf
      mapvalg cB cA vf cv wf vf cab cB cA cxp cpw wss cA cvv wcel cB cR wcel wa
      cB cA vf cv wf vf cab vf cv cB cA cxp wss vf cab cB cA cxp cpw cB cA vf
      cv wf vf cv cB cA cxp wss vf cB cA vf cv fssxp ss2abi vf cB cA cxp df-pw
      sseqtr4i a1i eqsstrd cA cvv wcel wn cA cB cm co cB cA cxp cpw wss cB cR
      wcel cA cvv wcel wn cA cB cm co c0 cB cA cxp cpw cA cB cm cm cdm wrel cvv
      cvv cxp wrel cvv cvv relxp cm cdm cvv cvv cxp cm cvv cvv cxp wfn cm cdm
      cvv cvv cxp wceq fnmap cvv cvv cxp cm fndm ax-mp releqi mpbir oprprc1 c0
      cB cA cxp cpw wss cA cvv wcel wn cB cA cxp cpw 0ss a1i eqsstrd adantr
      pm2.61ian $.
      $( [8-Dec-2006] $) $( [8-Dec-2006] $)
  $}

  ${
    $d f A $.
    map0e.1 $e |- A e. _V $.
    $( Set exponentiation with an empty exponent (ordinal number 0) is ordinal
       number 1.  Exercise 4.42(a) of [Mendelson] p. 255. $)
    map0e $p |- ( A ^m (/) ) = 1o $=
      cA c0 cm co c0 csn c1o c0 cA vf cv wf vf cab vf cv c0 wceq vf cab cA c0
      cm co c0 csn c0 cA vf cv wf vf cv c0 wceq vf vf cv c0 wfn vf cv crn cA
      wss wa vf cv c0 wceq vf cv crn cA wss wa c0 cA vf cv wf vf cv c0 wceq vf
      cv c0 wfn vf cv c0 wceq vf cv crn cA wss vf cv fn0 anbi1i c0 cA vf cv
      df-f vf cv c0 wceq vf cv crn cA wss vf cv c0 wceq vf cv crn cA wss c0 cA
      wss cA 0ss vf cv c0 wceq vf cv crn c0 cA vf cv c0 wceq vf cv crn c0 crn
      c0 vf cv c0 rneq rn0 syl6eq sseq1d mpbiri pm4.71i 3bitr4i abbii cA c0 vf
      map0e.1 0ex mapval vf c0 df-sn 3eqtr4i df1o2 eqtr4i $.
      $( [10-Dec-2003] $) $( [10-Dec-2003] $)

    $( Set exponentiation with an empty base is the empty set, provided the
       exponent is non-empty.  Theorem 96 of [Suppes] p. 89. $)
    map0b $p |- ( A =/= (/) -> ( (/) ^m A ) = (/) ) $=
      cA c0 wne cA c0 vf cv wf vf cab c0 c0 cA cm co cA c0 vf cv wf vf cab c0
      cA c0 cA c0 vf cv wf vf cab c0 wne cA c0 vf cv wf vf wex cA c0 wceq cA c0
      vf cv wf vf abn0 cA c0 vf cv wf cA c0 wceq vf cA c0 vf cv wf vf cv cdm cA
      c0 cA c0 vf cv fdm cA c0 vf cv wf vf cv crn c0 wceq vf cv cdm c0 wceq cA
      c0 vf cv wf vf cv crn c0 wss vf cv crn c0 wceq cA c0 vf cv frn vf cv crn
      ss0 syl vf cv dm0rn0 sylibr eqtr3d 19.23aiv sylbi necon1i c0 cA vf 0ex
      map0e.1 mapval syl5eq $.
      $( [19-Mar-2007] $) $( [10-Dec-2003] $)
  $}

  ${
    $d f x y A $.  $d f x y B $.
    map0.1 $e |- A e. _V $.
    map0.2 $e |- B e. _V $.
    $( Set exponentiation is empty iff the base is empty and the exponent is
       not empty.  Theorem 97 of [Suppes] p. 89. $)
    map0 $p |- ( ( A ^m B ) = (/) <-> ( A = (/) /\ B =/= (/) ) ) $=
      cA cB cm co c0 wceq cA c0 wceq cB c0 wne wa cA cB cm co c0 wceq cA c0
      wceq cB c0 wne cA cB cm co c0 wceq cB cA vf cv wf vf cab c0 wceq cA c0
      wceq cA cB cm co cB cA vf cv wf vf cab c0 cA cB vf map0.1 map0.2 mapval
      eqeq1i cA c0 cB cA vf cv wf vf cab c0 vx cv cA wcel vx wex cB cA vf cv wf
      vf wex cA c0 wne cB cA vf cv wf vf cab c0 wne vx cv cA wcel cB cA vf cv
      wf vf wex vx vx cv cA wcel vx cv csn cA wss cB cA cB vx cv csn cxp wf cB
      cA vf cv wf vf wex vx cv cA snssi cB vx cv csn cB vx cv csn cxp wf vx cv
      csn cA wss cB cA cB vx cv csn cxp wf cB vx cv vx visset fconst cB vx cv
      csn cA cB vx cv csn cxp fss mpan cB cA vf cv wf cB cA cB vx cv csn cxp wf
      vf cB vx cv csn cxp cB vx cv csn map0.2 vx cv snex xpex cB cA vf cv cB vx
      cv csn cxp feq1 cla4ev 3syl 19.23aiv vx cA n0 cB cA vf cv wf vf abn0
      3imtr4i necon4i sylbi cB c0 cA cB cm co c0 cB c0 wceq cA cB cm co c0 wne
      cA c0 cm co c0 wne cA c0 cm co c0 wne c0 csn c0 wne c0 0ex snnz cA c0 cm
      co c0 csn c0 cA c0 cm co c1o c0 csn cA map0.1 map0e df1o2 eqtri neeq1i
      mpbir cB c0 wceq cA cB cm co cA c0 cm co c0 cB c0 cA cm opreq2 neeq1d
      mpbiri necon2i jca cA c0 wceq cB c0 wne cA cB cm co c0 cB cm co c0 cA c0
      cB cm opreq1 cB map0.2 map0b sylan9eq impbii $.
      $( [17-May-2007] $) $( [10-Dec-2003] $)

    $( The value of set exponentiation with a singleton exponent.  Theorem 98
       of [Suppes] p. 89. $)
    mapsn $p |- ( A ^m { B } ) = { f | E. y e. A f = { <. B , y >. } } $=
      vf cv cB vy cv cop csn wceq vy cA wrex vf cA cB csn cm co vf cv cA cB csn
      cm co wcel cB csn cA vf cv wf vf cv cB vy cv cop csn wceq vy cA wrex cA
      cB csn vf cv map0.1 cB snex elmap cB csn cA vf cv wf vf cv cB vy cv cop
      csn wceq vy cA wrex cB csn cA vf cv wf vy cv cA wcel vf cv cB vy cv cop
      csn wceq wa vy wex vf cv cB vy cv cop csn wceq vy cA wrex cB csn cA vf cv
      wf vf cv crn vy cv csn wceq vy wex vy cv cA wcel vf cv cB vy cv cop csn
      wceq wa vy wex cB csn cA vf cv wf cB vy cv vf cv wbr vy weu vf cv crn vy
      cv csn wceq vy wex vf cv cB csn wfn cB cB csn wcel cB vy cv vf cv wbr vy
      weu cB csn cA vf cv wf vy cB csn cB vf cv fneu cB csn cA vf cv ffn cB
      map0.2 snid sylancl cB csn cA vf cv wf cB vy cv vf cv wbr vy cab vy cv
      csn wceq vy wex vf cv crn vy cv csn wceq vy wex cB vy cv vf cv wbr vy weu
      cB csn cA vf cv wf cB vy cv vf cv wbr vy cab vy cv csn wceq vf cv crn vy
      cv csn wceq vy cB csn cA vf cv wf cB vy cv vf cv wbr vy cab vf cv crn vy
      cv csn cB csn cA vf cv wf vf cv cB csn cima cB vy cv vf cv wbr vy cab vf
      cv crn cB csn cA vf cv wf vf cv wrel vf cv cB csn cima cB vy cv vf cv wbr
      vy cab wceq cB csn cA vf cv frel vy cB vf cv relimasn syl cB csn cA vf cv
      wf vf cv vf cv cdm cima vf cv cB csn cima vf cv crn cB csn cA vf cv wf vf
      cv cdm cB csn vf cv cB csn cA vf cv fdm imaeq2d vf cv imadmrn syl5reqr
      eqtr3d eqeq1d exbidv cB vy cv vf cv wbr vy euabsn syl5bb mpbid cB csn cA
      vf cv wf vf cv crn vy cv csn wceq vy cv cA wcel vf cv cB vy cv cop csn
      wceq wa vy cB csn cA vf cv wf vf cv crn vy cv csn wceq vy cv cA wcel vf
      cv cB vy cv cop csn wceq cB csn cA vf cv wf vy cv vf cv crn wcel vy cv cA
      wcel vf cv crn vy cv csn wceq cB csn cA vf cv wf vf cv crn cA vy cv cB
      csn cA vf cv frn sseld vf cv crn vy cv csn wceq vy cv vf cv crn wcel vy
      cv vy cv csn wcel vy cv vy visset snid vf cv crn vy cv csn vy cv eleq2
      mpbiri syl5 cB csn cA vf cv wf vf cv crn vy cv csn wceq cB csn vy cv csn
      vf cv wf vf cv cB vy cv cop csn wceq vf cv crn vy cv csn wceq cB csn vf
      cv crn vf cv wf cB csn vy cv csn vf cv wf cB csn cA vf cv wf vf cv crn vy
      cv csn cB csn vf cv feq3 cB csn cA vf cv wf cB csn vf cv crn vf cv wfo cB
      csn vf cv crn vf cv wf cB csn cA vf cv wf vf cv cB csn wfn cB csn vf cv
      crn vf cv wfo cB csn cA vf cv ffn cB csn vf cv dffn4 sylib cB csn vf cv
      crn vf cv fof syl syl5cbi cB vy cv vf cv map0.2 vy visset fsn syl6ib jcad
      19.22dv mpd vf cv cB vy cv cop csn wceq vy cA df-rex sylibr vf cv cB vy
      cv cop csn wceq cB csn cA vf cv wf vy cA vf cv cB vy cv cop csn wceq vy
      cv cA wcel cB csn cA vf cv wf cB csn vy cv csn vf cv wf vy cv csn cA wss
      cB csn cA vf cv wf vf cv cB vy cv cop csn wceq vy cv cA wcel cB csn vy cv
      csn cA vf cv fss vf cv cB vy cv cop csn wceq cB csn vy cv csn vf cv wf1o
      cB csn vy cv csn vf cv wf vf cv cB vy cv cop csn wceq cB csn vy cv csn vf
      cv wf1o cB csn vy cv csn cB vy cv cop csn wf1o cB vy cv map0.2 vy visset
      f1osn cB csn vy cv csn vf cv cB vy cv cop csn f1oeq1 mpbiri cB csn vy cv
      csn vf cv f1of syl vy cv cA snssi syl2an expcom r19.23aiv impbii bitri
      abbi2i $.
      $( [15-Dec-2003] $) $( [10-Dec-2003] $)
  $}

  ${
    $d f A $.  $d f B $.  $d f C $.
    mapss.1 $e |- B e. _V $.
    mapss.2 $e |- C e. _V $.
    $( Subset inheritance for set exponentiation.  Theorem 99 of [Suppes]
       p. 89. $)
    mapss $p |- ( A C_ B -> ( A ^m C ) C_ ( B ^m C ) ) $=
      cA cB wss cC cA vf cv wf vf cab cC cB vf cv wf vf cab cA cC cm co cB cC
      cm co cA cB wss cC cA vf cv wf cC cB vf cv wf wi vf wal cC cA vf cv wf vf
      cab cC cB vf cv wf vf cab wss cA cB wss cC cA vf cv wf cC cB vf cv wf wi
      vf cC cA vf cv wf cA cB wss cC cB vf cv wf cC cA cB vf cv fss expcom
      19.21aiv cC cA vf cv wf cC cB vf cv wf vf ss2ab sylibr cA cvv wcel cC cvv
      wcel cA cC cm co cC cA vf cv wf vf cab wceq cA cB wss cA cC cvv cvv vf
      mapvalg cA cB mapss.1 ssex mapss.2 sylancl cB cC cm co cC cB vf cv wf vf
      cab wceq cA cB wss cB cC vf mapss.1 mapss.2 mapval a1i 3sstr4d $.
      $( [15-Dec-2003] $) $( [10-Dec-2003] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Infinite Cartesian products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c X_ $.

  $( Extend class notation to include infinite Cartesian products. $)
  cixp $a class X_ x e. A B $.

  ${
    $d f x $.  $d f A $.  $d f B $.
    $( Definition of infinite Cartesian product of [Enderton] p. 54.  Enderton
       uses a bold "X" with ` x e. A ` written underneath or as a subscript,
       as does Stoll p. 47.  Some books use a capital pi, but we will reserve
       that notation for products of numbers.  Usually ` B ` represents a
       class expression containing ` x ` free and thus can be thought of
       as ` B ( x ) ` .  Normally, ` x ` is not free in ` A ` , although this
       is not a requirement of the definition. $)
    df-ixp $a |- X_ x e. A B =
                 { f | ( f Fn A /\ A. x e. A ( f ` x ) e. B ) } $.
  $}

  ${
    $d f A $.  $d f B $.  $d f x F $.
    $( Membership in an infinite Cartesian product.  See ~ df-ixp for
       discussion of the notation. $)
    elixp2 $p |- ( F e. X_ x e. A B <->
                ( F e. _V /\ F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      cF cvv wcel cF vx cA cB cixp wcel wa cF cvv wcel cF cA wfn vx cv cF cfv
      cB wcel vx cA wral wa wa cF vx cA cB cixp wcel cF cvv wcel cF cA wfn vx
      cv cF cfv cB wcel vx cA wral w3a cF cvv wcel cF vx cA cB cixp wcel cF cA
      wfn vx cv cF cfv cB wcel vx cA wral wa vf cv cA wfn vx cv vf cv cfv cB
      wcel vx cA wral wa cF cA wfn vx cv cF cfv cB wcel vx cA wral wa vf cF vx
      cA cB cixp cvv vf cv cF wceq vf cv cA wfn cF cA wfn vx cv vf cv cfv cB
      wcel vx cA wral vx cv cF cfv cB wcel vx cA wral cA vf cv cF fneq1 vf cv
      cF wceq vx cv vf cv cfv cB wcel vx cv cF cfv cB wcel vx cA vf cv cF wceq
      vx cv vf cv cfv vx cv cF cfv cB vx cv vf cv cF fveq1 eleq1d ralbidv
      anbi12d vx cA cB vf df-ixp elab2g pm5.32i cF vx cA cB cixp wcel cF cvv
      wcel cF vx cA cB cixp elisset pm4.71ri cF cvv wcel cF cA wfn vx cv cF cfv
      cB wcel vx cA wral 3anass 3bitr4i $.
      $( [29-Sep-2006] $) $( [28-Sep-2006] $)
  $}

  ${
    $d x F $.
    elixp.1 $e |- F e. _V $.
    $( Membership in an infinite Cartesian product. $)
    elixp $p |- ( F e. X_ x e. A B <->
                ( F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      cF cvv wcel cF cA wfn vx cv cF cfv cB wcel vx cA wral w3a cF cvv wcel cF
      cA wfn vx cv cF cfv cB wcel vx cA wral wa wa cF vx cA cB cixp wcel cF cA
      wfn vx cv cF cfv cB wcel vx cA wral wa cF cvv wcel cF cA wfn vx cv cF cfv
      cB wcel vx cA wral 3anass vx cA cB cF elixp2 cF cvv wcel cF cA wfn vx cv
      cF cfv cB wcel vx cA wral wa elixp.1 biantrur 3bitr4i $.
      $( [30-Sep-2006] $) $( [28-Sep-2006] $)

    ${
      $d x A $.  $d x B $.
      $( Membership in an infinite Cartesian product of a constant ` B ` . $)
      elixpconst $p |- ( F e. X_ x e. A B <-> F : A --> B ) $=
        cF vx cA cB cixp wcel cF cA wfn vx cv cF cfv cB wcel vx cA wral wa cA
        cB cF wf vx cA cB cF elixp.1 elixp vx cA cB cF ffnfv bitr4i $.
        $( [12-Apr-2008] $) $( [12-Apr-2008] $)
    $}
  $}

  ${
    $d f x A $.  $d f x B $.
    ixpconst.1 $e |- A e. _V $.
    ixpconst.2 $e |- B e. _V $.
    $( Infinite Cartesian product of a constant ` B ` . $)
    ixpconst $p |- X_ x e. A B = ( B ^m A ) $=
      vx cA cB cixp cA cB vf cv wf vf cab cB cA cm co cA cB vf cv wf vf vx cA
      cB cixp vx cA cB vf cv vf visset elixpconst abbi2i cB cA vf ixpconst.2
      ixpconst.1 mapval eqtr4i $.
      $( [20-Apr-2008] $) $( [12-Apr-2008] $)
  $}

  ${
    $d f x A $.  $d f x B $.  $d f C $.
    $( Equality theorem for infinite Cartesian product. $)
    ixpeq1 $p |- ( A = B -> X_ x e. A C = X_ x e. B C ) $=
      cA cB wceq vf cv cA wfn vx cv vf cv cfv cC wcel vx cA wral wa vf cab vf
      cv cB wfn vx cv vf cv cfv cC wcel vx cB wral wa vf cab vx cA cC cixp vx
      cB cC cixp cA cB wceq vf cv cA wfn vx cv vf cv cfv cC wcel vx cA wral wa
      vf cv cB wfn vx cv vf cv cfv cC wcel vx cB wral wa vf cA cB wceq vf cv cA
      wfn vf cv cB wfn vx cv vf cv cfv cC wcel vx cA wral vx cv vf cv cfv cC
      wcel vx cB wral cA cB vf cv fneq2 vx cv vf cv cfv cC wcel vx cA cB raleq1
      anbi12d abbidv vx cA cC vf df-ixp vx cB cC vf df-ixp 3eqtr4g $.
      $( [9-Jun-2007] $) $( [29-Sep-2006] $)
  $}

  ${
    $d f A $.  $d f B $.  $d f C $.  $d f x $.
    $( Subclass theorem for infinite Cartesian product. $)
    ss2ixp $p |- ( A. x e. A B C_ C -> X_ x e. A B C_ X_ x e. A C ) $=
      cB cC wss vx cA wral vf vx cA cB cixp vx cA cC cixp cB cC wss vx cA wral
      vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vf cv cA wfn vx cv vf
      cv cfv cC wcel vx cA wral wa vf cv vx cA cB cixp wcel vf cv vx cA cC cixp
      wcel cB cC wss vx cA wral vx cv vf cv cfv cB wcel vx cA wral vx cv vf cv
      cfv cC wcel vx cA wral vf cv cA wfn cB cC wss vx cv vf cv cfv cB wcel vx
      cv vf cv cfv cC wcel vx cA cB cC vx cv vf cv cfv ssel r19.20sii anim2d vx
      cA cB vf cv vf visset elixp vx cA cC vf cv vf visset elixp 3imtr4g ssrdv
      $.
      $( [17-Oct-2006] $) $( [29-Sep-2006] $)
  $}

  $( Equality theorem for infinite Cartesian product. $)
  ixpeq2 $p |- ( A. x e. A B = C -> X_ x e. A B = X_ x e. A C ) $=
    cB cC wss vx cA wral cC cB wss vx cA wral wa vx cA cB cixp vx cA cC cixp
    wss vx cA cC cixp vx cA cB cixp wss wa cB cC wceq vx cA wral vx cA cB cixp
    vx cA cC cixp wceq cB cC wss vx cA wral vx cA cB cixp vx cA cC cixp wss cC
    cB wss vx cA wral vx cA cC cixp vx cA cB cixp wss vx cA cB cC ss2ixp vx cA
    cC cB ss2ixp anim12i cB cC wceq vx cA wral cB cC wss cC cB wss wa vx cA
    wral cB cC wss vx cA wral cC cB wss vx cA wral wa cB cC wceq cB cC wss cC
    cB wss wa vx cA cB cC eqss ralbii cB cC wss cC cB wss vx cA r19.26 bitri vx
    cA cB cixp vx cA cC cixp eqss 3imtr4i $.
    $( [16-Aug-2007] $) $( [29-Sep-2006] $)

  ${
    $d f x y A $.  $d f y B $.  $d x y F $.
    $( A member of an infinite Cartesian product maps to the indexed union of
       the product argument.  Remark in [Enderton] p. 54. $)
    ixpf $p |- ( F e. X_ x e. A B -> F : A --> U_ x e. A B ) $=
      cF vx cA cB cixp wcel cF cvv wcel cF cA wfn vx cv cF cfv cB wcel vx cA
      wral w3a cA vx cA cB ciun cF wf vx cA cB cF elixp2 cF cA wfn vx cv cF cfv
      cB wcel vx cA wral cA vx cA cB ciun cF wf cF cvv wcel cF cA wfn vx cv cF
      cfv cB wcel vx cA wral wa cF cA wfn vx cv cF cfv vx cA cB ciun wcel vx cA
      wral wa cA vx cA cB ciun cF wf vx cv cF cfv cB wcel vx cA wral vx cv cF
      cfv vx cA cB ciun wcel vx cA wral cF cA wfn vx cv cF cfv cB wcel vx cv cF
      cfv vx cA cB ciun wcel vx cA vx cv cA wcel cB vx cA cB ciun vx cv cF cfv
      vx cA cB ssiun2 sseld r19.20i anim2i vx vy cA vx cA cB ciun cF vy cv cA
      wcel vx ax-17 vx vy cA cB hbiu1 vy cv cF wcel vx ax-17 ffnfvf sylibr
      3adant1 sylbi $.
      $( [4-Oct-2006] $) $( [28-Sep-2006] $)

    $( The union of an infinite Cartesian product is included in a cross
       product. $)
    uniixp $p |- U. X_ x e. A B C_ ( A X. U_ x e. A B ) $=
      vy vx cA cB cixp cuni cA vx cA cB ciun cxp vy cv vx cA cB cixp cuni wcel
      vy cv vf cv wcel cA vx cA cB ciun vf cv wf wa vf wex vy cv cA vx cA cB
      ciun cxp wcel vy cv vx cA cB cixp cuni wcel vy cv vf cv wcel vf cv vx cA
      cB cixp wcel wa vf wex vy cv vf cv wcel cA vx cA cB ciun vf cv wf wa vf
      wex vf vy cv vx cA cB cixp eluni vy cv vf cv wcel vf cv vx cA cB cixp
      wcel wa vy cv vf cv wcel cA vx cA cB ciun vf cv wf wa vf vf cv vx cA cB
      cixp wcel cA vx cA cB ciun vf cv wf vy cv vf cv wcel vx cA cB vf cv ixpf
      anim2i 19.22i sylbi vy cv vf cv wcel cA vx cA cB ciun vf cv wf wa vy cv
      cA vx cA cB ciun cxp wcel vf cA vx cA cB ciun vf cv wf vy cv vf cv wcel
      vy cv cA vx cA cB ciun cxp wcel cA vx cA cB ciun vf cv wf vf cv cA vx cA
      cB ciun cxp vy cv cA vx cA cB ciun vf cv fssxp sseld impcom 19.23aiv syl
      ssriv $.
      $( [24-Oct-2006] $) $( [28-Sep-2006] $)

    $( The existence of an infinite Cartesian product.  ` x ` is normally a
       free-variable parameter in ` B ` .  Remark in Enderton p. 54. $)
    ixpexg $p |- ( ( A e. C /\ A. x e. A B e. D ) -> X_ x e. A B e. _V ) $=
      cA cC wcel cB cD wcel vx cA wral wa vx cA cB cixp cuni cvv wcel vx cA cB
      cixp cvv wcel vx cA cB cixp cuni cA vx cA cB ciun cxp wss cA vx cA cB
      ciun cxp cvv wcel vx cA cB cixp cuni cvv wcel cA cC wcel cB cD wcel vx cA
      wral wa vx cA cB cixp cuni cA vx cA cB ciun cxp cvv ssexg vx cA cB uniixp
      cA cC wcel cB cD wcel vx cA wral vx cA cB ciun cvv wcel cA vx cA cB ciun
      cxp cvv wcel vx cA cB cC cD iunexg cA vx cA cB ciun cC cvv xpexg syldan
      sylancr vx cA cB cixp uniexb sylibr $.
      $( [28-Jun-2007] $) $( [28-Sep-2006] $)
  $}

  ${
    $d f A $.  $d f x $.
    $( An infinite Cartesian product with an empty index set. $)
    ixp0x $p |- X_ x e. (/) A = { (/) } $=
      vx c0 cA cixp vf cv c0 wfn vx cv vf cv cfv cA wcel vx c0 wral wa vf cab
      c0 csn vx c0 cA vf df-ixp vf cv c0 wfn vx cv vf cv cfv cA wcel vx c0 wral
      wa vf c0 csn vf cv c0 csn wcel vf cv c0 wceq vf cv c0 wfn vf cv c0 wfn vx
      cv vf cv cfv cA wcel vx c0 wral wa vf c0 elsn vf cv fn0 vx cv vf cv cfv
      cA wcel vx c0 wral vf cv c0 wfn vx cv vf cv cfv cA wcel vx ral0 biantru
      3bitr2i abbi2i eqtr4i $.
      $( [21-Sep-2007] $) $( [21-Sep-2007] $)
  $}

  $( Membership of the empty set in an infinite Cartesian product.
     (Contributed by Steve Rodriguez, 29-Sep-2006.) $)
  0elixp $p |- (/) e. X_ x e. (/) A $=
    c0 c0 csn vx c0 cA cixp c0 0ex snid vx cA ixp0x eleqtrri $.
    $( [30-Sep-2006] $) $( [29-Sep-2006] $)

  ${
    $d f A $.  $d f B $.  $d f x $.
    $( The infinite Cartesian product of a family ` B ( x ) ` with an empty
       member is empty. $)
    ixp0 $p |- ( E. x e. A B = (/) -> X_ x e. A B = (/) ) $=
      cB c0 wceq vx cA wrex vf vx cA cB cixp c0 cB c0 wceq vx cA wrex vf cv cA
      wfn vx cv vf cv cfv cB wcel vx cA wral wa vf cv c0 wcel vf cv vx cA cB
      cixp wcel vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa wn vf cv c0
      wcel wn vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vf cv c0 wcel
      wb cB c0 wceq vx cA wrex vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral
      wa vf cv c0 wcel pm5.21 cB c0 wceq vx cA wrex vx cv vf cv cfv cB wcel vx
      cA wral vf cv cA wfn cB c0 wceq vx cA wrex vx cv vf cv cfv cB wcel wn vx
      cA wrex vx cv vf cv cfv cB wcel vx cA wral wn cB c0 wceq vx cv vf cv cfv
      cB wcel wn vx cA vx cv vf cv cfv cB wcel cB c0 wceq cB vx cv vf cv cfv
      n0i con2i r19.22si vx cv vf cv cfv cB wcel vx cA rexnal sylib intnand vf
      cv noel sylancl vx cA cB vf cv vf visset elixp syl5bb eqrdv $.
      $( [1-Oct-2006] $) $( [1-Oct-2006] $)
 $}

  ${
    $d f x A $.  $d f B $.
    mapixp.1 $e |- A e. _V $.
    mapixp.2 $e |- B e. _V $.
    ${
      $d x B $.
      $( Express set exponentiation in terms of an infinite Cartesian product.
         Remark in [Stoll] p. 47.  Note that ` B ` is constant, i.e. ` x ` does
         not occur in ` B ` . $)
      mapixp $p |- ( B ^m A ) = X_ x e. A B $=
        vf cB cA cm co vx cA cB cixp cA cB vf cv wf vf cv cA wfn vx cv vf cv
        cfv cB wcel vx cA wral wa vf cv cB cA cm co wcel vf cv vx cA cB cixp
        wcel vx cA cB vf cv ffnfv cB cA vf cv mapixp.2 mapixp.1 elmap vx cA cB
        vf cv vf visset elixp 3bitr4i eqriv $.
        $( [2-Oct-2006] $) $( [28-Sep-2006] $)
    $}

    $( An infinite Cartesian product is a subset of set exponentation.  Remark
       in [Enderton] p. 54. $)
    ixpssmap $p |- X_ x e. A B C_ ( U_ x e. A B ^m A ) $=
      vf vx cA cB cixp vx cA cB ciun cA cm co vf cv vx cA cB cixp wcel cA vx cA
      cB ciun vf cv wf vf cv vx cA cB ciun cA cm co wcel vx cA cB vf cv ixpf vx
      cA cB ciun cA vf cv vx cA cB mapixp.1 mapixp.2 iunex mapixp.1 elmap
      sylibr ssriv $.
      $( [8-Jul-2007] $) $( [28-Sep-2006] $)
  $}

$(
  @{
    xpixp.1 @e |- P = X_ x e. { (/) , 1o } if ( x = (/) , A , B ) @.
    xpixp.1 @e |- P = X_ x e. 2o if ( x = (/) , A , B ) @.
    xpixp.1 @e |- P =
               X_ x e. { (/) , 1o } ( { <. (/) , A >. , <. 1o , B >. } ` x ) @.
    @( A cross product in terms of an infinite Cartesian product. @)
    xpixp @p |- ( A X. B ) =
                ( ran ( U. P |` { (/) } ) X. ran ( U. P |` { 1o } ) ) @=
?@.
      @( [ ?] @) @( [29-Sep-2006] @)
  @}

  @{
    ixpxp.1 @e |- P = ( A X. B ) @.
    @( An infinite Cartesian product in terms of a cross product. @)
    ixpxp @p |- X_ x e. { (/) , 1o } if ( x = (/) , A , B ) =
                { ( { (/) } X. dom P ) , ( { 1o } X. ran P ) } @=
?@.
      @( [ ?] @) @( [29-Sep-2006] @)
  @}
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Equinumerosity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( Introduce new constant symbols. $)
  $c ~~ $.  $( Equinumerosity relation ("approximately equals" symbol) $)
  $c ~<_ $.  $( Dominance relation (curly less-than-or-equal) $)
  $c ~< $.  $( Strict dominance relation (curly less-than) $)
  $c Fin $.  $( Class of all finite sets. $)

  $( Extend class definition to include the equinumerosity relation
     ("approximately equals" symbol) $)
  cen $a class ~~ $.

  $( Extend class definition to include the dominance relation (curly
     less-than-or-equal) $)
  cdom $a class ~<_ $.

  $( Extend class definition to include the strict dominance relation (curly
     less-than) $)
  csdm $a class ~< $.

  $( Extend class definition to include the class of all finite sets. $)
  cfn $a class Fin $.

  ${
    $d x y f $.
    $( Define the equinumerosity relation.  Definition of [Enderton] p. 129.
       We define ` ~~ ` to be a binary relation rather than a connective,
       so its arguments must be sets to be meaningful.  This is acceptable
       because we do not consider equinumerosity for proper classes.  We derive
       the usual definition as ~ bren . $)
    df-en $a |- ~~ = { <. x , y >. | E. f f : x -1-1-onto-> y } $.

    $( Define the dominance relation.  For an alternate definition see
       ~ dfdom2 .  Compare Definition of [Enderton] p. 145.  Typical
       textbook definitions are derived as ~ brdom and ~ domen . $)
    df-dom $a |- ~<_ = { <. x , y >. | E. f f : x -1-1-> y } $.

    $( Define the strict dominance relation.  Alternate possible definitions
       are derived as ~ brsdom and ~ brsdom2 .  Definition 3 of [Suppes]
       p. 97. $)
    df-sdom $a |- ~< = ( ~<_ \ ~~ ) $.

    $( Define the (proper) class of all finite sets.  Similar to Definition
       10.29 of [TakeutiZaring] p. 91, whose "Fin(a)" corresponds to our
       " ` a e. Fin ` ".  This definition is meaningful whether or not we
       accept the Axiom of Infinity ~ ax-inf2 .  If we accept Infinity, we
       can also express ` A e. Fin ` by ` A ~< om ` (theorem ~ isfinite .) $)
    df-fin $a |- Fin = { x | E. y e. om x ~~ y } $.
  $}

  ${
    $d x y f $.  $d x y f $.
    $( Equinumerosity is a relation. $)
    relen $p |- Rel ~~ $=
      cen wrel vx cv vy cv vf cv wf1o vf wex vx vy copab wrel vx cv vy cv vf cv
      wf1o vf wex vx vy relopab cen vx cv vy cv vf cv wf1o vf wex vx vy copab
      vx vy vf df-en releqi mpbir $.
      $( [28-Mar-1998] $)

    $( Dominance is a relation. $)
    reldom $p |- Rel ~<_ $=
      cdom wrel vx cv vy cv vf cv wf1 vf wex vx vy copab wrel vx cv vy cv vf cv
      wf1 vf wex vx vy relopab cdom vx cv vy cv vf cv wf1 vf wex vx vy copab vx
      vy vf df-dom releqi mpbir $.
      $( [28-Mar-1998] $)
  $}

  $( Strict dominance is a relation. $)
  relsdom $p |- Rel ~< $=
    cdom wrel csdm wrel reldom cdom wrel cdom cen cdif wrel csdm wrel cdom cen
    reldif csdm cdom cen cdif df-sdom releqi sylibr ax-mp $.
    $( [31-Mar-1998] $)

  ${
    $d f x y A $.  $d f x y B $.  $d y C $.
    $( Equinumerosity relation. $)
    breng $p |- ( B e. C -> ( A ~~ B <-> E. f f : A -1-1-onto-> B ) ) $=
      cA cvv wcel cB cC wcel cA cB cen wbr cA cB vf cv wf1o vf wex wb wi cA cvv
      wcel cB cC wcel cA cB cen wbr cA cB vf cv wf1o vf wex wb vx cv vy cv vf
      cv wf1o vf wex cA vy cv vf cv wf1o vf wex cA cB vf cv wf1o vf wex vx vy
      cA cB cvv cC cen vx cv cA wceq vx cv vy cv vf cv wf1o cA vy cv vf cv wf1o
      vf vx cv cA vy cv vf cv f1oeq2 exbidv vy cv cB wceq cA vy cv vf cv wf1o
      cA cB vf cv wf1o vf vy cv cB cA vf cv f1oeq3 exbidv vx vy vf df-en brabg
      ex cA cvv wcel wn cA cB cen wbr cA cB vf cv wf1o vf wex wb cB cC wcel cA
      cB cen wbr cA cvv wcel cA cB vf cv wf1o vf wex cA cB cen relen brrelexi
      cA cB vf cv wf1o cA cvv wcel vf cA cB vf cv wf1o vf cv cA wfn cA cvv wcel
      cA cB vf cv f1ofn vf cv cA wfn cA vf cv cdm cvv cA vf cv fndm vf cv vf
      visset dmex syl6eqelr syl 19.23aiv pm5.21ni a1d pm2.61i $.
      $( [15-Jun-1998] $)

    $( Dominance relation. $)
    brdomg $p |- ( B e. C -> ( A ~<_ B <-> E. f f : A -1-1-> B ) ) $=
      cA cvv wcel cB cC wcel cA cB cdom wbr cA cB vf cv wf1 vf wex wb wi cA cvv
      wcel cB cC wcel cA cB cdom wbr cA cB vf cv wf1 vf wex wb vx cv vy cv vf
      cv wf1 vf wex cA vy cv vf cv wf1 vf wex cA cB vf cv wf1 vf wex vx vy cA
      cB cvv cC cdom vx cv cA wceq vx cv vy cv vf cv wf1 cA vy cv vf cv wf1 vf
      vx cv cA vy cv vf cv f1eq2 exbidv vy cv cB wceq cA vy cv vf cv wf1 cA cB
      vf cv wf1 vf vy cv cB cA vf cv f1eq3 exbidv vx vy vf df-dom brabg ex cA
      cvv wcel wn cA cB cdom wbr cA cB vf cv wf1 vf wex wb cB cC wcel cA cB
      cdom wbr cA cvv wcel cA cB vf cv wf1 vf wex cA cB cdom reldom brrelexi cA
      cB vf cv wf1 cA cvv wcel vf cA cB vf cv wf1 cA cB vf cv wf cA cvv wcel cA
      cB vf cv f1f cA cB vf cv wf cA vf cv cdm cvv cA cB vf cv fdm vf cv vf
      visset dmex syl6eqelr syl 19.23aiv pm5.21ni a1d pm2.61i $.
      $( [15-Jun-1998] $)
  $}

  ${
    $d f x y A $.  $d f x y B $.  $d f w x y z $.
    bren.1 $e |- B e. _V $.
    $( Equinumerosity relation.  Compare Definition of [Enderton] p. 129. $)
    bren $p |- ( A ~~ B <-> E. f f : A -1-1-onto-> B ) $=
      cB cvv wcel cA cB cen wbr cA cB vf cv wf1o vf wex wb bren.1 cA cB cvv vf
      breng ax-mp $.
      $( [15-Jun-1998] $)

    $( Dominance relation. $)
    brdom $p |- ( A ~<_ B <-> E. f f : A -1-1-> B ) $=
      cB cvv wcel cA cB cdom wbr cA cB vf cv wf1 vf wex wb bren.1 cA cB cvv vf
      brdomg ax-mp $.
      $( [15-Jun-1998] $)

    $( Dominance in terms of equinumerosity.  Example 1 of [Enderton]
       p. 146. $)
    domen $p |- ( A ~<_ B <-> E. x ( A ~~ x /\ x C_ B ) ) $=
      cA cB vf cv wf1 vf wex cA vx cv vf cv wf1o vx cv cB wss wa vf wex vx wex
      cA cB cdom wbr cA vx cv cen wbr vx cv cB wss wa vx wex cA cB vf cv wf1 vf
      wex cA vx cv vf cv wf1o vx cv cB wss wa vx wex vf wex cA vx cv vf cv wf1o
      vx cv cB wss wa vf wex vx wex cA cB vf cv wf1 cA vx cv vf cv wf1o vx cv
      cB wss wa vx wex vf vx cA cB vf cv vf visset f11o exbii cA vx cv vf cv
      wf1o vx cv cB wss wa vf vx excom bitri cA cB vf bren.1 brdom cA vx cv cen
      wbr vx cv cB wss wa cA vx cv vf cv wf1o vx cv cB wss wa vf wex vx cA vx
      cv cen wbr vx cv cB wss wa cA vx cv vf cv wf1o vf wex vx cv cB wss wa cA
      vx cv vf cv wf1o vx cv cB wss wa vf wex cA vx cv cen wbr cA vx cv vf cv
      wf1o vf wex vx cv cB wss cA vx cv vf vx visset bren anbi1i cA vx cv vf cv
      wf1o vx cv cB wss vf 19.41v bitr4i exbii 3bitr4i $.
      $( [15-Jun-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Dominance in terms of equinumerosity, with the sethood requirement
       expressed as an antecedent.  Example 1 of [Enderton] p. 146. $)
    domeng $p |- ( B e. C -> ( A ~<_ B <-> E. x ( A ~~ x /\ x C_ B ) ) ) $=
      cA vy cv cdom wbr cA vx cv cen wbr vx cv vy cv wss wa vx wex cA cB cdom
      wbr cA vx cv cen wbr vx cv cB wss wa vx wex vy cB cC vy cv cB cA cdom
      breq2 vy cv cB wceq cA vx cv cen wbr vx cv vy cv wss wa cA vx cv cen wbr
      vx cv cB wss wa vx vy cv cB wceq vx cv vy cv wss vx cv cB wss cA vx cv
      cen wbr vy cv cB vx cv sseq2 anbi2d exbidv vx cA vy cv vy visset domen
      vtoclbg $.
      $( [24-Jun-2004] $) $( [24-Apr-2004] $)
  $}

  $( Strict dominance relation, meaning " ` B ` is strictly greater in size
     than ` A ` ."  Definition of [Mendelson] p. 255. $)
  brsdom $p |- ( A ~< B <-> ( A ~<_ B /\ -. A ~~ B ) ) $=
    cA cB cop csdm wcel cA cB cop cdom cen cdif wcel cA cB csdm wbr cA cB cdom
    wbr cA cB cen wbr wn wa csdm cdom cen cdif cA cB cop df-sdom eleq2i cA cB
    csdm df-br cA cB cdom wbr cA cB cen wbr wn wa cA cB cop cdom wcel cA cB cop
    cen wcel wn wa cA cB cop cdom cen cdif wcel cA cB cdom wbr cA cB cop cdom
    wcel cA cB cen wbr wn cA cB cop cen wcel wn cA cB cdom df-br cA cB cen wbr
    cA cB cop cen wcel cA cB cen df-br notbii anbi12i cA cB cop cdom cen eldif
    bitr4i 3bitr4i $.
    $( [25-Jun-1998] $)

  ${
    $d x y f A $.
    $( Express " ` A ` is finite."  Definition 10.29 of [TakeutiZaring]
       p. 91 (whose " ` Fin ` " is a predicate instead of a class). $)
    isfi $p |- ( A e. Fin <-> E. x e. om A ~~ x ) $=
      cA cfn wcel cA vy cv vx cv cen wbr vx com wrex vy cab wcel cA vx cv cen
      wbr vx com wrex cfn vy cv vx cv cen wbr vx com wrex vy cab cA vy vx
      df-fin eleq2i vy cv vx cv cen wbr vx com wrex cA vx cv cen wbr vx com
      wrex vy cA cA vx cv cen wbr cA cvv wcel vx com cA vx cv cen wbr cA cvv
      wcel wi vx cv com wcel cA vx cv cen relen brrelexi a1i r19.23aiv vy cv cA
      wceq vy cv vx cv cen wbr cA vx cv cen wbr vx com vy cv cA vx cv cen breq1
      rexbidv elab3 bitri $.
      $( [28-Aug-2008] $) $( [22-Aug-2008] $)

    $( Equinumerosity implies dominance. $)
    enssdom $p |- ~~ C_ ~<_ $=
      vx vy cen cdom relen vx cv vy cv cop vx cv vy cv vf cv wf1o vf wex vx vy
      copab wcel vx cv vy cv cop vx cv vy cv vf cv wf1 vf wex vx vy copab wcel
      vx cv vy cv cop cen wcel vx cv vy cv cop cdom wcel vx cv vy cv vf cv wf1o
      vf wex vx cv vy cv vf cv wf1 vf wex vx cv vy cv cop vx cv vy cv vf cv
      wf1o vf wex vx vy copab wcel vx cv vy cv cop vx cv vy cv vf cv wf1 vf wex
      vx vy copab wcel vx cv vy cv vf cv wf1o vx cv vy cv vf cv wf1 vf vx cv vy
      cv vf cv f1of1 19.22i vx cv vy cv vf cv wf1o vf wex vx vy opabid vx cv vy
      cv vf cv wf1 vf wex vx vy opabid 3imtr4i cen vx cv vy cv vf cv wf1o vf
      wex vx vy copab vx cv vy cv cop vx vy vf df-en eleq2i cdom vx cv vy cv vf
      cv wf1 vf wex vx vy copab vx cv vy cv cop vx vy vf df-dom eleq2i 3imtr4i
      relssi $.
      $( [31-Mar-1998] $)
  $}

  $( Alternate definition of dominance. $)
  dfdom2 $p |- ~<_ = ( ~< u. ~~ ) $=
    cen csdm cun cen cdom cen cdif cun csdm cen cun cdom csdm cdom cen cdif cen
    df-sdom uneq2i cen csdm uncom cen cdom wss cen cdom cen cdif cun cdom wceq
    enssdom cen cdom undif mpbi 3eqtr3ri $.
    $( [17-Jun-1998] $)

  $( Equinumerosity implies dominance.  Theorem 15 of [Suppes] p. 94. $)
  endom $p |- ( A ~~ B -> A ~<_ B ) $=
    cen cdom cA cB enssdom ssbri $.
    $( [28-May-1998] $)

  $( Strict dominance implies dominance. $)
  sdomdom $p |- ( A ~< B -> A ~<_ B ) $=
    cA cB csdm wbr cA cB cdom wbr cA cB cen wbr wn cA cB brsdom pm3.26bi $.
    $( [10-Jun-1998] $)

  $( Strict dominance implies non-equinumerosity. $)
  sdomnen $p |- ( A ~< B -> -. A ~~ B ) $=
    cA cB csdm wbr cA cB cdom wbr cA cB cen wbr wn cA cB brsdom pm3.27bi $.
    $( [10-Jun-1998] $)

  $( Dominance in terms of strict dominance and equinumerosity.  Theorem 22(iv)
     of [Suppes] p. 97. $)
  brdom2 $p |- ( A ~<_ B <-> ( A ~< B \/ A ~~ B ) ) $=
    cA cB cop cdom wcel cA cB cop csdm cen cun wcel cA cB cdom wbr cA cB csdm
    wbr cA cB cen wbr wo cdom csdm cen cun cA cB cop dfdom2 eleq2i cA cB cdom
    df-br cA cB csdm wbr cA cB cen wbr wo cA cB cop csdm wcel cA cB cop cen
    wcel wo cA cB cop csdm cen cun wcel cA cB csdm wbr cA cB cop csdm wcel cA
    cB cen wbr cA cB cop cen wcel cA cB csdm df-br cA cB cen df-br orbi12i cA
    cB cop csdm cen elun bitr4i 3bitr4i $.
    $( [17-Jun-1998] $)

  $( Equinumerosity expressed in terms of dominance and strict dominance. $)
  bren2 $p |- ( A ~~ B <-> ( A ~<_ B /\ -. A ~< B ) ) $=
    cA cB cen wbr cA cB cdom wbr cA cB csdm wbr wn wa cA cB cen wbr cA cB cdom
    wbr cA cB csdm wbr wn cA cB endom cA cB csdm wbr cA cB cen wbr cA cB
    sdomnen con2i jca cA cB cdom wbr cA cB csdm wbr cA cB cen wbr cA cB cdom
    wbr cA cB csdm wbr cA cB cen wbr wo cA cB brdom2 biimpi orcanai impbii $.
    $( [23-Oct-2004] $) $( [23-Oct-2004] $)

  ${
    $d f A $.
    $( Equinumerosity is reflexive.  Theorem 1 of [Suppes] p. 92. $)
    enrefg $p |- ( A e. B -> A ~~ A ) $=
      cA cB wcel cA cA cen wbr cA cA vf cv wf1o vf wex cA cB wcel cid cA cres
      cvv wcel cA cA vf cv wf1o vf wex cA cB resiexg cid cA cres cvv wcel cA cA
      cid cA cres wf1o cA cA vf cv wf1o vf wex cA f1oi cA cA vf cv wf1o cA cA
      cid cA cres wf1o vf cid cA cres cvv cA cA vf cv cid cA cres f1oeq1
      cla4egv mpi syl cA cA cB vf breng mpbird $.
      $( [20-Jan-2007] $) $( [18-Jun-1998] $)
  $}

  ${
    enref.1 $e |- A e. _V $.
    $( Equinumerosity is reflexive.  Theorem 1 of [Suppes] p. 92. $)
    enref $p |- A ~~ A $=
      cA cvv wcel cA cA cen wbr enref.1 cA cvv enrefg ax-mp $.
      $( [26-Sep-2004] $) $( [25-Sep-2004] $)
  $}

  $( Equality implies equinumerosity. $)
  eqeng $p |- ( A e. C -> ( A = B -> A ~~ B ) ) $=
    cA cB wceq cA cA cen wbr cA cB cen wbr cA cC wcel cA cB cA cen breq2 cA cC
    enrefg syl5cbi $.
    $( [8-Nov-2003] $) $( [26-Oct-2003] $)

  $( Dominance is reflexive. $)
  domrefg $p |- ( A e. B -> A ~<_ A ) $=
    cA cB wcel cA cA cen wbr cA cA cdom wbr cA cB enrefg cA cA endom syl $.
    $( [18-Jun-1998] $)

  ${
    $d f A $.  $d f B $.  $d f F $.
    $( The domain and range of a one-to-one, onto function are equinumerous.
       This variation of ~ f1oeng does not require the Axiom of Replacement. $)
    f1oen2g $p |- ( ( F e. C /\ F : A -1-1-onto-> B ) -> A ~~ B ) $=
      cA cvv wcel cA cB vf cv wf1o vf wex cA cB cen wbr cF cC wcel cA cB cF
      wf1o wa cA cvv wcel cB cvv wcel cA cB vf cv wf1o vf wex cA cB cen wbr wi
      cB cvv wcel wn cA cB vf cv wf1o vf wex cA cvv wcel cA cB cen wbr cB cvv
      wcel wn cA cvv wcel cA cB cen wbr wi cA cB vf cv wf1o vf wex cB cvv wcel
      wn cA cB cen wbr cA cA cen wbr cA cvv wcel cA cB cen brprc cA cvv enrefg
      syl5bir a1d com3r cB cvv wcel cA cB cen wbr cA cB vf cv wf1o vf wex cA cB
      cvv vf breng biimprd pm2.61d2 cF cC wcel cA cB cF wf cA cvv wcel cA cB cF
      wf1o cA cB cC cF dmfex cA cB cF f1of sylan2 cF cC wcel cA cB cF wf1o cA
      cB vf cv wf1o vf wex cA cB vf cv wf1o cA cB cF wf1o vf cF cC cA cB vf cv
      cF f1oeq1 cla4egv imp sylc $.
      $( [15-Jan-2007] $) $( [13-Jan-2007] $)

    $( The domain and range of a one-to-one, onto function are equinumerous. $)
    f1oeng $p |- ( ( A e. C /\ F : A -1-1-onto-> B ) -> A ~~ B ) $=
      cA cC wcel cA cB cF wf1o cF cvv wcel cA cB cen wbr cA cC wcel cF cA wfn
      cF cvv wcel cA cB cF wf1o cF cA wfn cA cC wcel cF cvv wcel cA cC cF fnex
      ancoms cA cB cF f1ofn sylan2 cA cB cvv cF f1oen2g sylancom $.
      $( [30-Jan-2007] $) $( [19-Jun-1998] $)

    $( The domain of a one-to-one function is dominated by its codomain. $)
    f1domg $p |- ( A e. C -> ( F : A -1-1-> B -> A ~<_ B ) ) $=
      cA cC wcel cA cB cF wf1 cA cB vf cv wf1 vf wex cA cB cdom wbr cA cB cF
      wf1 cA cC wcel cF cvv wcel cA cB vf cv wf1 vf wex cA cB cF wf1 cA cC wcel
      cF cvv wcel cA cB cF wf cA cC wcel cF cvv wcel cA cB cF wf1 cA cB cC cF
      fex cA cB cF f1f sylan expcom cA cB vf cv wf1 cA cB cF wf1 vf cF cvv cA
      cB vf cv cF f1eq1 cla4egv syli cA cC wcel cB cvv wcel cA cB vf cv wf1 vf
      wex cA cB cdom wbr wi cB cvv wcel wn cA cB vf cv wf1 vf wex cA cC wcel cA
      cB cdom wbr cB cvv wcel wn cA cC wcel cA cB cdom wbr wi cA cB vf cv wf1
      vf wex cB cvv wcel wn cA cB cdom wbr cA cA cdom wbr cA cC wcel cA cB cdom
      brprc cA cC domrefg syl5bir a1d com3r cB cvv wcel cA cB cdom wbr cA cB vf
      cv wf1 vf wex cA cB cvv vf brdomg biimprd pm2.61d2 syld $.
      $( [18-Jun-1998] $)

    $( The domain of a one-to-one function is dominated by its codomain. $)
    f1dom2g $p |- ( B e. C -> ( F : A -1-1-> B -> A ~<_ B ) ) $=
      cA cB cF wf1 cB cC wcel cA cvv wcel cA cB cdom wbr cA cB cF wf1 cB cC
      wcel cA cvv wcel cA cB cC cF f1dmex expcom cA cB cvv cF f1domg syli $.
      $( [5-Sep-2004] $) $( [4-Sep-2004] $)
  $}

  ${
    f1oen.1 $e |- A e. _V $.
    $( The domain and range of a one-to-one, onto function are equinumerous. $)
    f1oen $p |- ( F : A -1-1-onto-> B -> A ~~ B ) $=
      cA cvv wcel cA cB cF wf1o cA cB cen wbr f1oen.1 cA cB cvv cF f1oeng mpan
      $.
      $( [19-Jun-1998] $)

    $( The domain of a one-to-one function is dominated by its codomain. $)
    f1dom $p |- ( F : A -1-1-> B -> A ~<_ B ) $=
      cA cvv wcel cA cB cF wf1 cA cB cdom wbr wi f1oen.1 cA cB cvv cF f1domg
      ax-mp $.
      $( [19-Jun-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d x y ph $.
    en2d.1 $e |- ( ph -> A e. _V ) $.
    en2d.2 $e |- ( ph -> ( x e. A -> C e. _V ) ) $.
    en2d.3 $e |- ( ph -> ( y e. B -> D e. _V ) ) $.
    en2d.4 $e |- ( ph -> ( ( x e. A /\ y = C ) <-> ( y e. B /\ x = D ) ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function. $)
    en2d $p |- ( ph -> A ~~ B ) $=
      cA cvv wcel cA cB vy cv cB wcel vx cv cD wceq wa vx vy copab wf1o cA cB
      cen wbr wph cA cB cvv vy cv cB wcel vx cv cD wceq wa vx vy copab f1oeng
      en2d.1 cA cB vy cv cB wcel vx cv cD wceq wa vx vy copab wf1o vy cv cB
      wcel vx cv cD wceq wa vx vy copab cA wfn vy cv cB wcel vx cv cD wceq wa
      vx vy copab ccnv cB wfn wph cA cB vy cv cB wcel vx cv cD wceq wa vx vy
      copab dff1o4 wph vx cv cA wcel vy cv cC wceq wa vx vy copab cA wfn vy cv
      cB wcel vx cv cD wceq wa vx vy copab cA wfn wph vy cv cC wceq vy weu vx
      cA wral vx cv cA wcel vy cv cC wceq wa vx vy copab cA wfn wph vy cv cC
      wceq vy weu vx cA wph vx cv cA wcel cC cvv wcel vy cv cC wceq vy weu
      en2d.2 vy cC eueq syl6ib r19.21aiv vy cv cC wceq vx vy cA vx cv cA wcel
      vy cv cC wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx vy copab
      eqid fnopabg sylib wph vx cv cA wcel vy cv cC wceq wa vx vy copab vy cv
      cB wcel vx cv cD wceq wa vx vy copab wceq vx cv cA wcel vy cv cC wceq wa
      vx vy copab cA wfn vy cv cB wcel vx cv cD wceq wa vx vy copab cA wfn wb
      wph vx cv cA wcel vy cv cC wceq wa vy cv cB wcel vx cv cD wceq wa vx vy
      en2d.4 opabbidv cA vx cv cA wcel vy cv cC wceq wa vx vy copab vy cv cB
      wcel vx cv cD wceq wa vx vy copab fneq1 syl mpbid wph vx cv cD wceq vx
      weu vy cB wral vy cv cB wcel vx cv cD wceq wa vx vy copab ccnv cB wfn wph
      vx cv cD wceq vx weu vy cB wph vy cv cB wcel cD cvv wcel vx cv cD wceq vx
      weu en2d.3 vx cD eueq syl6ib r19.21aiv vx cv cD wceq vy vx cB vy cv cB
      wcel vx cv cD wceq wa vx vy copab ccnv vy cv cB wcel vx cv cD wceq wa vx
      vy cnvopab fnopabg sylib sylanbrc sylanc $.
      $( [29-Jul-2004] $) $( [27-Jul-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d x y ph $.
    en3d.1 $e |- ( ph -> A e. _V ) $.
    en3d.2 $e |- ( ph -> ( x e. A -> C e. B ) ) $.
    en3d.3 $e |- ( ph -> ( y e. B -> D e. A ) ) $.
    en3d.4 $e |- ( ph -> ( ( x e. A /\ y e. B ) -> ( x = D <-> y = C ) ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function. $)
    en3d $p |- ( ph -> A ~~ B ) $=
      wph vx vy cA cB cC cD en3d.1 wph vx cv cA wcel cC cB wcel cC cvv wcel
      en3d.2 cC cB elisset syl6 wph vy cv cB wcel cD cA wcel cD cvv wcel en3d.3
      cD cA elisset syl6 wph vx cv cA wcel vy cv cC wceq wa vy cv cB wcel vx cv
      cD wceq wa wph vx cv cA wcel vy cv cC wceq wa wa vy cv cB wcel vx cv cD
      wceq wph vx cv cA wcel vy cv cC wceq vy cv cB wcel wph vx cv cA wcel cC
      cB wcel vy cv cC wceq vy cv cB wcel wi en3d.2 cC cB vy cv eleq1a syl6
      imp32 wph vx cv cA wcel vy cv cC wceq vy cv cB wcel vx cv cD wceq wi wph
      vx cv cA wcel vy cv cB wcel vy cv cC wceq vx cv cD wceq wph vx cv cA wcel
      vy cv cB wcel vy cv cC wceq vx cv cD wceq wph vx cv cA wcel vy cv cB wcel
      wa wa vx cv cD wceq vy cv cC wceq wph vx cv cA wcel vy cv cB wcel wa vx
      cv cD wceq vy cv cC wceq wb en3d.4 imp biimpar exp42 com34 imp32 jcai wph
      vy cv cB wcel vx cv cD wceq wa wa vx cv cA wcel vy cv cC wceq wph vy cv
      cB wcel vx cv cD wceq vx cv cA wcel wph vy cv cB wcel cD cA wcel vx cv cD
      wceq vx cv cA wcel wi en3d.3 cD cA vx cv eleq1a syl6 imp32 wph vy cv cB
      wcel vx cv cD wceq vx cv cA wcel vy cv cC wceq wi wph vy cv cB wcel vx cv
      cA wcel vx cv cD wceq vy cv cC wceq wph vx cv cA wcel vy cv cB wcel vx cv
      cD wceq vy cv cC wceq wi wph vx cv cA wcel vy cv cB wcel vx cv cD wceq vy
      cv cC wceq wph vx cv cA wcel vy cv cB wcel wa wa vx cv cD wceq vy cv cC
      wceq wph vx cv cA wcel vy cv cB wcel wa vx cv cD wceq vy cv cC wceq wb
      en3d.4 imp biimpa exp42 com23 com34 imp32 jcai impbida en2d $.
      $( [7-Aug-2004] $) $( [27-Jul-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    en2.1 $e |- A e. _V $.
    en2.2 $e |- ( x e. A -> C e. _V ) $.
    en2.3 $e |- ( y e. B -> D e. _V ) $.
    en2.4 $e |- ( ( x e. A /\ y = C ) <-> ( y e. B /\ x = D ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function. $)
    en2 $p |- A ~~ B $=
      cA cA wceq cA cB cen wbr cA eqid cA cA wceq vx vy cA cB cC cD cA cvv wcel
      cA cA wceq en2.1 a1i vx cv cA wcel cC cvv wcel wi cA cA wceq en2.2 a1i vy
      cv cB wcel cD cvv wcel wi cA cA wceq en2.3 a1i vx cv cA wcel vy cv cC
      wceq wa vy cv cB wcel vx cv cD wceq wa wb cA cA wceq en2.4 a1i en2d ax-mp
      $.
      $( [25-Jun-2004] $) $( [4-Jan-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    en3.1 $e |- A e. _V $.
    en3.2 $e |- ( x e. A -> C e. B ) $.
    en3.3 $e |- ( y e. B -> D e. A ) $.
    en3.4 $e |- ( ( x e. A /\ y e. B ) -> ( x = D <-> y = C ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function. $)
    en3 $p |- A ~~ B $=
      cA cA wceq cA cB cen wbr cA eqid cA cA wceq vx vy cA cB cC cD cA cvv wcel
      cA cA wceq en3.1 a1i vx cv cA wcel cC cB wcel wi cA cA wceq en3.2 a1i vy
      cv cB wcel cD cA wcel wi cA cA wceq en3.3 a1i vx cv cA wcel vy cv cB wcel
      wa vx cv cD wceq vy cv cC wceq wb wi cA cA wceq en3.4 a1i en3d ax-mp $.
      $( [7-Aug-2004] $) $( [19-Jul-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d y z C $.  $d x z D $.  $d x y ph $.
    dom2d.1 $e |- ( ph -> ( x e. A -> C e. B ) ) $.
    dom2d.2 $e |- ( ph -> ( ( x e. A /\ y e. A ) -> ( C = D <-> x = y ) ) ) $.
    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain. $)
    dom2d $p |- ( ph -> ( A e. R -> A ~<_ B ) ) $=
      cA cR wcel cA cB vx cv cA wcel vy cv cC wceq wa vx vy copab wf1 cA cB
      cdom wbr wph cA cB cR vx cv cA wcel vy cv cC wceq wa vx vy copab f1domg
      cA cB vx cv cA wcel vy cv cC wceq wa vx vy copab wf1 cA cB vx cv cA wcel
      vy cv cC wceq wa vx vy copab wf vx cv vx cv cA wcel vy cv cC wceq wa vx
      vy copab cfv vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv wceq vx
      cv vy cv wceq wi vy cA wral vx cA wral wph vx vy vz cA cB vx cv cA wcel
      vy cv cC wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx vy vz
      hbopab1 vx cv cA wcel vy cv cC wceq wa vx vy vz hbopab2 dff13f wph cC cB
      wcel vx cA wral cA cB vx cv cA wcel vy cv cC wceq wa vx vy copab wf wph
      cC cB wcel vx cA dom2d.1 r19.21aiv vx vy cA cB cC vx cv cA wcel vy cv cC
      wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx vy copab eqid
      fopab2 sylib wph vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv vy
      cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv wceq vx cv vy cv wceq
      wi vx vy cA cA wph vx cv cA wcel vy cv cA wcel wa vx cv vx cv cA wcel vy
      cv cC wceq wa vx vy copab cfv vy cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab cfv wceq vx cv vy cv wceq wi wph vx cv cA wcel vy cv cA wcel wa wa
      vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv vy cv vx cv cA wcel
      vy cv cC wceq wa vx vy copab cfv wceq cC cD wceq vx cv vy cv wceq wph vx
      cv cA wcel vy cv cA wcel wa wa vx cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab cfv cC vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cD wph
      vx cv cA wcel vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC
      wceq vy cv cA wcel wph vx cv cA wcel wa cC cB wcel vx cv vx cv cA wcel vy
      cv cC wceq wa vx vy copab cfv cC wceq wph vx cv cA wcel cC cB wcel
      dom2d.1 imp vx cv cA wcel cC cB wcel vx cv vx cv cA wcel vy cv cC wceq wa
      vx vy copab cfv cC wceq wph vx vy cA cC cB fvopab2 adantll mpdan adantrr
      wph vy cv cA wcel vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cD
      wceq vx cv cA wcel wph vx cv cA wcel wa vx cv vx cv cA wcel vy cv cC wceq
      wa vx vy copab cfv cC wceq wi wph vy cv cA wcel wa vy cv vx cv cA wcel vy
      cv cC wceq wa vx vy copab cfv cD wceq wi vx vy wph vy cv cA wcel wa vy cv
      vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cD wceq vx wph vy cv cA
      wcel wa vx ax-17 vx vz vz vy cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab cfv cD vx vz vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab vx cv
      cA wcel vy cv cC wceq wa vx vy vz hbopab1 vz cv vy cv wcel vx ax-17 hbfv
      vz cv cD wcel vx ax-17 hbeq hbim vx cv vy cv wceq wph vx cv cA wcel wa vx
      cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq wi wph vy cv cA
      wcel wa vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq wi
      wph vy cv cA wcel wa vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv
      cD wceq wi vx cv vy cv wceq wph vx cv cA wcel wa wph vy cv cA wcel wa vx
      cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq vx cv vy cv
      wceq vx cv cA wcel vy cv cA wcel wph vx cv vy cv cA eleq1 anbi2d imbi1d
      vx cv vy cv wceq wph vy cv cA wcel wa vx cv vx cv cA wcel vy cv cC wceq
      wa vx vy copab cfv cC wceq vy cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab cfv cD wceq vx cv vy cv wceq wph vy cv cA wcel wa wph vx cv cA wcel
      vy cv cA wcel wa wa vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv
      cC wceq vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cD wceq wb
      vx cv vy cv wceq vx cv cA wcel vy cv cA wcel wa vy cv cA wcel wph vx cv
      vy cv wceq vx cv cA wcel vy cv cA wcel wa vy cv cA wcel vy cv cA wcel wa
      vy cv cA wcel vx cv vy cv wceq vx cv cA wcel vy cv cA wcel vy cv cA wcel
      vx cv vy cv cA eleq1 anbi1d vy cv cA wcel anidm syl6bb anbi2d vx cv vy cv
      wceq wph vx cv cA wcel vy cv cA wcel wa wa vx cv vx cv cA wcel vy cv cC
      wceq wa vx vy copab cfv cC wceq vy cv vx cv cA wcel vy cv cC wceq wa vx
      vy copab cfv cD wceq wb vx cv vy cv wceq wph vx cv cA wcel vy cv cA wcel
      wa wa wa vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv vy cv vx cv
      cA wcel vy cv cC wceq wa vx vy copab cfv cC cD vx cv vy cv wceq vx cv vx
      cv cA wcel vy cv cC wceq wa vx vy copab cfv vy cv vx cv cA wcel vy cv cC
      wceq wa vx vy copab cfv wceq wph vx cv cA wcel vy cv cA wcel wa wa vx cv
      vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab fveq2 adantr wph vx cv
      cA wcel vy cv cA wcel wa wa cC cD wceq vx cv vy cv wceq wph vx cv cA wcel
      vy cv cA wcel wa cC cD wceq vx cv vy cv wceq wb dom2d.2 imp biimparc
      eqeq12d ex sylbird pm5.74d bitrd wph vx cv cA wcel wa cC cB wcel vx cv vx
      cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq wph vx cv cA wcel cC
      cB wcel dom2d.1 imp vx cv cA wcel cC cB wcel vx cv vx cv cA wcel vy cv cC
      wceq wa vx vy copab cfv cC wceq wph vx vy cA cC cB fvopab2 adantll mpdan
      chvar adantrl eqeq12d wph vx cv cA wcel vy cv cA wcel wa wa cC cD wceq vx
      cv vy cv wceq wph vx cv cA wcel vy cv cA wcel wa cC cD wceq vx cv vy cv
      wceq wb dom2d.2 imp biimpd sylbid ex r19.21aivv sylanbrc syl5com $.
      $( [26-Jul-2004] $) $( [24-Jul-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    dom2.1 $e |- ( x e. A -> C e. B ) $.
    dom2.2 $e |- ( ( x e. A /\ y e. A ) -> ( C = D <-> x = y ) ) $.
    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain.  ` C ` and ` D ` can be
       read ` C ( x ) ` and ` D ( y ) ` , as can be shown from their distinct
       variable conditions. $)
    dom2 $p |- ( A e. R -> A ~<_ B ) $=
      cA cA wceq cA cR wcel cA cB cdom wbr wi cA eqid cA cA wceq vx vy cA cB cC
      cD cR vx cv cA wcel cC cB wcel wi cA cA wceq dom2.1 a1i vx cv cA wcel vy
      cv cA wcel wa cC cD wceq vx cv vy cv wceq wb wi cA cA wceq dom2.2 a1i
      dom2d ax-mp $.
      $( [30-Oct-2003] $) $( [26-Oct-2003] $)
  $}

  ${
    $d x y $.
    $( Equality implies equinumerosity. $)
    idssen $p |- _I C_ ~~ $=
      vx vy cid cen reli vx cv vy cv cid wbr vx cv vy cv cen wbr vx cv vy cv
      cop cid wcel vx cv vy cv cop cen wcel vx cv vy cv cid wbr vx cv vy cv
      wceq vx cv vy cv cen wbr vx cv vy cv vy visset ideq vx cv vy cv wceq vx
      cv vy cv cid vx cv cres wf1o vx cv vy cv cen wbr vx cv vy cv wceq vx cv
      vx cv cid vx cv cres wf1o vx cv vy cv cid vx cv cres wf1o vx cv f1oi vx
      cv vy cv vx cv cid vx cv cres f1oeq3 mpbii vx cv vy cv cid vx cv cres vx
      visset f1oen syl sylbi vx cv vy cv cid df-br vx cv vy cv cen df-br
      3imtr3i relssi $.
      $( [30-Apr-1998] $)
  $}

  $( The domain of equinumerosity. $)
  dmen $p |- dom ~~ = _V $=
    cvv cen cdm wss cen cdm cvv wceq cid cen wss cvv cen cdm wss idssen cid cen
    wss cid cdm cen cdm cvv cid cen dmss dmi syl5ssr ax-mp cen cdm vss mpbi $.
    $( [10-May-1998] $)

  ${
    $d x A $.  $d x B $.
    $( A set dominates its subsets.  Theorem 16 of [Suppes] p. 94. $)
    ssdomg $p |- ( A e. C -> ( A C_ B -> A ~<_ B ) ) $=
      cA cC wcel cA cB cid cA cres wf1 cA cB cdom wbr cA cB wss cA cB cC cid cA
      cres f1domg cA cB wss cA cB cid cA cres wf cid cA cres ccnv wfun wa cA cB
      cid cA cres wf1 cA cB wss cA cB cid cA cres wf cid cA cres ccnv wfun cA
      cA cid cA cres wf cA cB wss cA cB cid cA cres wf cA cA cid cA cres wfo cA
      cA cid cA cres wf cA cA cid cA cres wfo cid cA cres ccnv wfun cA cA cid
      cA cres wf1o cA cA cid cA cres wfo cid cA cres ccnv wfun wa cA f1oi cA cA
      cid cA cres dff1o3 mpbi pm3.26i cA cA cid cA cres fof ax-mp cA cA cB cid
      cA cres fss mpan cid ccnv wfun cid cA cres ccnv wfun cid ccnv wfun cid
      wfun funi cid ccnv cid wceq cid ccnv wfun cid wfun wb cnvi cid ccnv cid
      funeq ax-mp mpbir cA cid funres11 ax-mp jctir cA cB cid cA cres df-f1
      sylibr syl5 $.
      $( [19-Jun-1998] $)
  $}

  $( A set dominates its subsets.  Theorem 16 of [Suppes] p. 94. $)
  ssdom2g $p |- ( B e. C -> ( A C_ B -> A ~<_ B ) ) $=
    cA cB wss cB cC wcel cA cvv wcel cA cB cdom wbr cA cB wss cB cC wcel cA cvv
    wcel cA cB cC ssexg expcom cA cB cvv ssdomg syli $.
    $( [19-Jun-1998] $)

  ${
    $d f g x y z $.
    $( Equinumerosity is an equivalence relation. $)
    ener $p |- Er ~~ $=
      vx vy vz cen vx cv vy cv cen wbr vx cv vy cv vf cv wf1o vf wex vy cv vx
      cv cen wbr vx cv vy cv vf vy visset bren vx cv vy cv vf cv wf1o vy cv vx
      cv cen wbr vf vx cv vy cv vf cv wf1o vy cv vx cv vf cv ccnv wf1o vy cv vx
      cv cen wbr vx cv vy cv vf cv f1ocnv vy cv vx cv vf cv ccnv vy visset
      f1oen syl 19.23aiv sylbi vx cv vy cv vg cv wf1o vg wex vy cv vz cv vf cv
      wf1o vf wex vx cv vz cv cen wbr vx cv vy cv cen wbr vy cv vz cv cen wbr
      vx cv vy cv vg cv wf1o vg wex vy cv vz cv vf cv wf1o vf wex wa vx cv vy
      cv vg cv wf1o vy cv vz cv vf cv wf1o wa vf wex vg wex vx cv vz cv cen wbr
      vx cv vy cv vg cv wf1o vy cv vz cv vf cv wf1o vg vf eeanv vx cv vy cv vg
      cv wf1o vy cv vz cv vf cv wf1o wa vx cv vz cv cen wbr vg vf vx cv vy cv
      vg cv wf1o vy cv vz cv vf cv wf1o wa vx cv vz cv vf cv vg cv ccom wf1o vx
      cv vz cv cen wbr vy cv vz cv vf cv wf1o vx cv vy cv vg cv wf1o vx cv vz
      cv vf cv vg cv ccom wf1o vx cv vy cv vz cv vf cv vg cv f1oco ancoms vx cv
      vz cv vf cv vg cv ccom vx visset f1oen syl 19.23aivv sylbir vx cv vy cv
      vg vy visset bren vy cv vz cv vf vz visset bren syl2anb ster $.
      $( [19-Mar-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Symmetry of equinumerosity.  Theorem 2 of [Suppes] p. 92. $)
    ensymg $p |- ( B e. C -> ( A ~~ B -> B ~~ A ) ) $=
      cB cC wcel cA cB cen wbr cB cA cen wbr cA cB cen wbr cA cvv wcel cB cC
      wcel cA cB cen wbr cB cA cen wbr wi wi cA cB cen relen brrelexi cA cvv
      wcel cB cC wcel cA cB cen wbr cB cA cen wbr wi vx cv vy cv cen wbr vy cv
      vx cv cen wbr wi cA vy cv cen wbr vy cv cA cen wbr wi cA cB cen wbr cB cA
      cen wbr wi vx vy cA cB cvv cC vx cv cA wceq vx cv vy cv cen wbr cA vy cv
      cen wbr vy cv vx cv cen wbr vy cv cA cen wbr vx cv cA vy cv cen breq1 vx
      cv cA vy cv cen breq2 imbi12d vy cv cB wceq cA vy cv cen wbr cA cB cen
      wbr vy cv cA cen wbr cB cA cen wbr vy cv cB cA cen breq2 vy cv cB cA cen
      breq1 imbi12d vx cv vy cv cen vx visset vy visset ener ersym vtocl2g ex
      syl pm2.43b $.
      $( [28-Oct-2003] $) $( [26-Oct-2003] $)
  $}

  ${
    ensym.1 $e |- B e. _V $.
    $( Symmetry of equinumerosity.  Theorem 2 of [Suppes] p. 92. $)
    ensym $p |- ( A ~~ B -> B ~~ A ) $=
      cB cvv wcel cA cB cen wbr cB cA cen wbr wi ensym.1 cA cB cvv ensymg ax-mp
      $.
      $( [26-Sep-2004] $) $( [25-Sep-2004] $)
      ${
      ensymi.2 $e |- A ~~ B $.
      $( Symmetry of equinumerosity.  Theorem 2 of [Suppes] p. 92. $)
      ensymi $p |- B ~~ A $=
        cA cB cen wbr cB cA cen wbr ensymi.2 cA cB ensym.1 ensym ax-mp $.
        $( [26-Sep-2004] $) $( [25-Sep-2004] $)
    $}
  $}

  ${
    $d x y z f g h A $.  $d x y z f g B $.  $d x y z f g h C $.
    $( Transitivity of equinumerosity.  Theorem 3 of [Suppes] p. 92. $)
    entr $p |- ( ( A ~~ B /\ B ~~ C ) -> A ~~ C ) $=
      vx vy vz cA cB cC cen relen vx cv vy cv vz cv cen vx visset vy visset vz
      visset ener ertr vx cv vx visset enref vtoclrbr $.
      $( [9-Jun-1998] $)

    $( Transitivity of dominance relation.  Theorem 17 of [Suppes] p. 94. $)
    domtr $p |- ( ( A ~<_ B /\ B ~<_ C ) -> A ~<_ C ) $=
      vx vy vz cA cB cC cdom reldom vx cv vy cv vg cv wf1 vg wex vy cv vz cv vf
      cv wf1 vf wex vx cv vz cv cdom wbr vx cv vy cv cdom wbr vy cv vz cv cdom
      wbr vx cv vy cv vg cv wf1 vg wex vy cv vz cv vf cv wf1 vf wex wa vx cv vy
      cv vg cv wf1 vy cv vz cv vf cv wf1 wa vf wex vg wex vx cv vz cv cdom wbr
      vx cv vy cv vg cv wf1 vy cv vz cv vf cv wf1 vg vf eeanv vx cv vy cv vg cv
      wf1 vy cv vz cv vf cv wf1 wa vx cv vz cv cdom wbr vg vf vx cv vy cv vg cv
      wf1 vy cv vz cv vf cv wf1 wa vx cv vz cv vf cv vg cv ccom wf1 vx cv vz cv
      cdom wbr vy cv vz cv vf cv wf1 vx cv vy cv vg cv wf1 vx cv vz cv vf cv vg
      cv ccom wf1 vx cv vy cv vz cv vf cv vg cv f1co ancoms vx cv vz cv vf cv
      vg cv ccom vx visset f1dom syl 19.23aivv sylbir vx cv vy cv vg vy visset
      brdom vy cv vz cv vf vz visset brdom syl2anb vx cv cvv wcel vx cv vx cv
      cdom wbr vx visset vx cv cvv domrefg ax-mp vtoclrbr $.
      $( [4-Jun-1998] $)
  $}

  ${
    entri.1 $e |- A ~~ B $.
    entri.2 $e |- B ~~ C $.
    $( A chained equinumerosity inference. $)
    entri $p |- A ~~ C $=
      cA cB cen wbr cB cC cen wbr cA cC cen wbr entri.1 entri.2 cA cB cC entr
      mp2an $.
      $( [28-Sep-2004] $) $( [25-Sep-2004] $)
  $}

  ${
    entr2i.1 $e |- C e. _V $.
    entr2i.2 $e |- A ~~ B $.
    entr2i.3 $e |- B ~~ C $.
    $( A chained equinumerosity inference. $)
    entr2i $p |- C ~~ A $=
      cA cC entr2i.1 cA cB cC entr2i.2 entr2i.3 entri ensymi $.
      $( [2-Oct-2004] $) $( [25-Sep-2004] $)
  $}

  ${
    entr3i.1 $e |- B e. _V $.
    entr3i.2 $e |- A ~~ B $.
    entr3i.3 $e |- A ~~ C $.
    $( A chained equinumerosity inference. $)
    entr3i $p |- B ~~ C $=
      cB cA cC cA cB entr3i.1 entr3i.2 ensymi entr3i.3 entri $.
      $( [2-Oct-2004] $) $( [25-Sep-2004] $)
  $}

  ${
    entr4i.1 $e |- B e. _V $.
    entr4i.2 $e |- A ~~ B $.
    entr4i.3 $e |- C ~~ B $.
    $( A chained equinumerosity inference. $)
    entr4i $p |- A ~~ C $=
      cA cB cC entr4i.2 cC cB entr4i.1 entr4i.3 ensymi entri $.
      $( [28-Sep-2004] $) $( [25-Sep-2004] $)
  $}

  $( Transitivity of equinumerosity and dominance. $)
  endomtr $p |- ( ( A ~~ B /\ B ~<_ C ) -> A ~<_ C ) $=
    cA cB cdom wbr cB cC cdom wbr cA cC cdom wbr cA cB cen wbr cA cB cC domtr
    cA cB endom sylan $.
    $( [7-Jun-1998] $)

  $( Transitivity of dominance and equinumerosity. $)
  domentr $p |- ( ( A ~<_ B /\ B ~~ C ) -> A ~<_ C ) $=
    cA cB cdom wbr cB cC cdom wbr cA cC cdom wbr cB cC cen wbr cA cB cC domtr
    cB cC endom sylan2 $.
    $( [7-Jun-1998] $)

  ${
    f1imaen.1 $e |- C e. _V $.
    $( A one-to-one function's image under a subset of its domain is
       equinumerous to  the subset. $)
    f1imaen $p |- ( ( F : A -1-1-> B /\ C C_ A ) -> ( F " C ) ~~ C ) $=
      cA cB cF wf1 cC cA wss wa cC cF cC cima cF cC cres wf1o cF cC cima cC cen
      wbr cA cB cC cF f1ores cC cF cC cima cF cC cres wf1o cC cF cC cima cen
      wbr cF cC cima cC cen wbr cC cF cC cima cF cC cres f1imaen.1 f1oen cC cF
      cC cima cF cC cres wf1o cC cF cC cima cF cC cres wfo cF cC cima cvv wcel
      cC cF cC cima cen wbr cF cC cima cC cen wbr wi cC cF cC cima cF cC cres
      f1ofo cC cvv wcel cC cF cC cima cF cC cres wfo cF cC cima cvv wcel wi
      f1imaen.1 cC cF cC cima cvv cF cC cres fornex ax-mp cC cF cC cima cvv
      ensymg 3syl mpd syl $.
      $( [9-Oct-2004] $) $( [30-Sep-2004] $)
  $}

  ${
    $d f A $.
    $( The empty set is equinumerous only to itself.  Exercise 1 of
       [TakeutiZaring] p. 88. $)
    en0 $p |- ( A ~~ (/) <-> A = (/) ) $=
      cA c0 cen wbr cA c0 wceq cA c0 cen wbr cA c0 vf cv wf1o vf wex cA c0 wceq
      cA c0 vf 0ex bren cA c0 vf cv wf1o cA c0 wceq vf cA c0 vf cv wf1o c0 cA
      vf cv ccnv wf1o cA c0 wceq cA c0 vf cv f1ocnv c0 cA vf cv ccnv wf1o vf cv
      ccnv c0 wceq cA c0 wceq cA vf cv ccnv f1o00 pm3.27bi syl 19.23aiv sylbi
      cA c0 wceq cA c0 cen wbr c0 c0 cen wbr c0 0ex enref cA c0 c0 cen breq1
      mpbiri impbii $.
      $( [27-May-1998] $)
  $}

  ${
    $d f A $.
    ensn1.1 $e |- A e. _V $.
    $( A singleton is equinumerous to ordinal one. $)
    ensn1 $p |- { A } ~~ 1o $=
      cA csn c0 csn c1o cen cA csn c0 csn cen wbr cA csn c0 csn vf cv wf1o vf
      wex cA csn c0 csn cA c0 cop csn wf1o cA csn c0 csn vf cv wf1o vf wex cA
      c0 ensn1.1 0ex f1osn cA csn c0 csn vf cv wf1o cA csn c0 csn cA c0 cop csn
      wf1o vf cA c0 cop csn cA c0 cop snex cA csn c0 csn vf cv cA c0 cop csn
      f1oeq1 cla4ev ax-mp cA csn c0 csn vf p0ex bren mpbir df1o2 breqtrri $.
      $( [4-Nov-2002] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( A singleton is equinumerous to ordinal one. $)
    ensn1g $p |- ( A e. B -> { A } ~~ 1o ) $=
      vx cv csn c1o cen wbr cA csn c1o cen wbr vx cA cB vx cv cA wceq vx cv csn
      cA csn c1o cen vx cv cA sneq breq1d vx cv vx visset ensn1 vtoclg $.
      $( [2-Jul-2004] $) $( [23-Apr-2004] $)
  $}

  ${
    $d x f A $.
    $( A set is equinumerous to ordinal one iff it is a singleton. $)
    en1 $p |- ( A ~~ 1o <-> E. x A = { x } ) $=
      cA c1o cen wbr cA vx cv csn wceq vx wex cA c1o cen wbr cA c0 csn vf cv
      wf1o vf wex cA vx cv csn wceq vx wex cA c1o cen wbr cA c0 csn cen wbr cA
      c0 csn vf cv wf1o vf wex c1o c0 csn cA cen df1o2 breq2i cA c0 csn vf p0ex
      bren bitri cA c0 csn vf cv wf1o cA vx cv csn wceq vx wex vf cA c0 csn vf
      cv wf1o c0 csn cA vf cv ccnv wf1o cA c0 vf cv ccnv cfv csn wceq cA vx cv
      csn wceq vx wex cA c0 csn vf cv f1ocnv c0 csn cA vf cv ccnv wf1o vf cv
      ccnv crn cA c0 vf cv ccnv cfv csn c0 csn cA vf cv ccnv wf1o c0 csn cA vf
      cv ccnv wfo vf cv ccnv crn cA wceq c0 csn cA vf cv ccnv f1ofo c0 csn cA
      vf cv ccnv forn syl c0 csn cA vf cv ccnv wf1o vf cv ccnv crn c0 c0 vf cv
      ccnv cfv cop csn crn c0 vf cv ccnv cfv csn c0 csn cA vf cv ccnv wf1o vf
      cv ccnv c0 c0 vf cv ccnv cfv cop csn c0 csn cA vf cv ccnv wf1o c0 csn cA
      vf cv ccnv wf vf cv ccnv c0 c0 vf cv ccnv cfv cop csn wceq c0 csn cA vf
      cv ccnv f1of c0 csn cA vf cv ccnv wf c0 vf cv ccnv cfv cA wcel vf cv ccnv
      c0 c0 vf cv ccnv cfv cop csn wceq c0 cA vf cv ccnv 0ex fsn2 pm3.27bi syl
      rneqd c0 c0 vf cv ccnv cfv 0ex c0 vf cv ccnv fvex rnsnop syl6eq eqtr3d cA
      vx cv csn wceq cA c0 vf cv ccnv cfv csn wceq vx c0 vf cv ccnv cfv c0 vf
      cv ccnv fvex vx cv c0 vf cv ccnv cfv wceq vx cv csn c0 vf cv ccnv cfv csn
      cA vx cv c0 vf cv ccnv cfv sneq eqeq2d cla4ev 3syl 19.23aiv sylbi cA vx
      cv csn wceq cA c1o cen wbr vx cA vx cv csn wceq cA c1o cen wbr vx cv csn
      c1o cen wbr vx cv vx visset ensn1 cA vx cv csn c1o cen breq1 mpbiri
      19.23aiv impbii $.
      $( [8-Aug-2004] $) $( [25-Jul-2004] $)
  $}

  ${
    $d x y f A $.
    2dom.1 $e |- A e. _V $.
    $( A set that dominates ordinal 2 has at least 2 different members. $)
    2dom $p |- ( 2o ~<_ A -> E. x e. A E. y e. A -. x = y ) $=
      c2o cA cdom wbr c0 c0 csn cpr cA vf cv wf1 vf wex vx cv vy cv wceq wn vy
      cA wrex vx cA wrex c2o cA cdom wbr c0 c0 csn cpr cA cdom wbr c0 c0 csn
      cpr cA vf cv wf1 vf wex c2o c0 c0 csn cpr cA cdom df2o2 breq1i c0 c0 csn
      cpr cA vf 2dom.1 brdom bitri c0 c0 csn cpr cA vf cv wf1 vx cv vy cv wceq
      wn vy cA wrex vx cA wrex vf c0 vf cv cfv cA wcel c0 csn vf cv cfv cA wcel
      c0 vf cv cfv c0 csn vf cv cfv wceq wn vx cv vy cv wceq wn vy cA wrex vx
      cA wrex c0 c0 csn cpr cA vf cv wf1 vx cv vy cv wceq wn c0 vf cv cfv c0
      csn vf cv cfv wceq wn c0 vf cv cfv vy cv wceq wn vx vy c0 vf cv cfv c0
      csn vf cv cfv cA cA vx cv c0 vf cv cfv wceq vx cv vy cv wceq c0 vf cv cfv
      vy cv wceq vx cv c0 vf cv cfv vy cv eqeq1 notbid vy cv c0 csn vf cv cfv
      wceq c0 vf cv cfv vy cv wceq c0 vf cv cfv c0 csn vf cv cfv wceq vy cv c0
      csn vf cv cfv c0 vf cv cfv eqeq2 notbid rcla42ev c0 c0 csn cpr cA vf cv
      wf c0 c0 c0 csn cpr wcel c0 vf cv cfv cA wcel c0 c0 csn cpr cA vf cv wf1
      c0 c0 csn cpr cA c0 vf cv ffvelrn c0 c0 csn cpr cA vf cv f1f c0 c0 csn
      0ex prid1 sylancl c0 c0 csn cpr cA vf cv wf c0 csn c0 c0 csn cpr wcel c0
      csn vf cv cfv cA wcel c0 c0 csn cpr cA vf cv wf1 c0 c0 csn cpr cA c0 csn
      vf cv ffvelrn c0 c0 csn cpr cA vf cv f1f c0 c0 csn p0ex prid2 sylancl c0
      c0 csn cpr cA vf cv wf1 c0 vf cv cfv c0 csn vf cv cfv wceq c0 c0 csn wceq
      c0 c0 csn wne c0 c0 csn wceq wn 0nep0 c0 c0 csn df-ne mpbi c0 c0 csn cpr
      cA vf cv wf1 c0 c0 c0 csn cpr wcel c0 csn c0 c0 csn cpr wcel c0 vf cv cfv
      c0 csn vf cv cfv wceq c0 c0 csn wceq wb c0 c0 csn 0ex prid1 c0 c0 csn
      p0ex prid2 c0 c0 csn cpr cA c0 c0 csn vf cv f1fveq mpanr12 mtbiri syl3anc
      19.23aiv sylbi $.
      $( [8-Aug-2004] $) $( [25-Jul-2004] $)
  $}

  ${
    $d x y z w F $.
    fundmen.1 $e |- F e. _V $.
    $( A function is equinumerous to its domain.  Exercise 4 of [Suppes]
       p. 98. $)
    fundmen $p |- ( Fun F -> dom F ~~ F ) $=
      cF wfun vx vy cF cdm cF vx cv vx cv cF cfv cop vy cv cint cint cF cdm cvv
      wcel cF wfun cF fundmen.1 dmex a1i cF wfun vx cv cF cdm wcel vx cv vx cv
      cF cfv cop cF wcel vx cv cF funfvop ex cF wfun cF wrel vy cv cF wcel vy
      cv cint cint cF cdm wcel wi cF funrel cF wrel vy cv cF wcel vy cv cint
      cint cF cdm wcel cF vy cv elreldm ex syl cF wfun vx cv cF cdm wcel vy cv
      cF wcel wa vx cv vy cv cint cint wceq vy cv vx cv vx cv cF cfv cop wceq
      wb cF wfun vx cv cF cdm wcel vy cv cF wcel wa wa vx cv vy cv cint cint
      wceq vy cv vx cv vx cv cF cfv cop wceq cF wfun vy cv cF wcel vx cv vy cv
      cint cint wceq vy cv vx cv vx cv cF cfv cop wceq wi vx cv cF cdm wcel cF
      wfun vy cv cF wcel wa vy cv vz cv vw cv cop wceq vw wex vz wex vx cv vy
      cv cint cint wceq vy cv vx cv vx cv cF cfv cop wceq wi cF wfun vy cv cF
      wcel wa vy cv cvv cvv cxp wcel vy cv vz cv vw cv cop wceq vw wex vz wex
      cF cvv cvv cxp wss vy cv cF wcel vy cv cvv cvv cxp wcel cF wfun cF cvv
      cvv cxp vy cv ssel2 cF wfun cF wrel cF cvv cvv cxp wss cF funrel cF
      df-rel sylib sylan vz vw vy cv elvv sylib cF wfun vy cv cF wcel wa vy cv
      vz cv vw cv cop wceq vx cv vy cv cint cint wceq vy cv vx cv vx cv cF cfv
      cop wceq wi vz vw cF wfun vy cv cF wcel wa vy cv vz cv vw cv cop wceq vx
      cv vy cv cint cint wceq vy cv vx cv vx cv cF cfv cop wceq cF wfun vy cv
      cF wcel wa vy cv vz cv vw cv cop wceq vx cv vy cv cint cint wceq wa wa vy
      cv vx cv vw cv cop vx cv vx cv cF cfv cop vy cv vz cv vw cv cop wceq vx
      cv vy cv cint cint wceq wa vy cv vx cv vw cv cop wceq cF wfun vy cv cF
      wcel wa vx cv vy cv cint cint wceq vy cv vz cv vw cv cop wceq vy cv vx cv
      vw cv cop wceq vx cv vy cv cint cint wceq vy cv vz cv vw cv cop wceq wa
      vx cv vw cv cop vz cv vw cv cop wceq vy cv vx cv vw cv cop wceq vx cv vy
      cv cint cint wceq vy cv vz cv vw cv cop wceq vx cv vw cv cop vz cv vw cv
      cop wceq vx cv vy cv cint cint wceq vy cv vz cv vw cv cop wceq vx cv vz
      cv wceq vx cv vw cv cop vz cv vw cv cop wceq vx cv vy cv cint cint wceq
      vx cv vz cv wceq vy cv cint cint vz cv wceq vy cv vz cv vw cv cop wceq vx
      cv vy cv cint cint vz cv eqeq1 vy cv vz cv vw cv cop wceq vy cv cint cint
      vz cv vw cv cop cint cint vz cv vy cv vz cv vw cv cop wceq vy cv cint vz
      cv vw cv cop cint vy cv vz cv vw cv cop inteq inteqd vz cv vw cv vz
      visset op1stb syl6eq syl5bir vx cv vz cv vw cv opeq1 syl6 imp vy cv vz cv
      vw cv cop wceq vx cv vw cv cop vz cv vw cv cop wceq vy cv vx cv vw cv cop
      wceq wi vx cv vy cv cint cint wceq vx cv vw cv cop vz cv vw cv cop wceq
      vy cv vx cv vw cv cop wceq vy cv vz cv vw cv cop wceq vx cv vw cv cop vz
      cv vw cv cop vy cv eqeq2 biimprcd adantl mpd ancoms adantl cF wfun vy cv
      cF wcel wa vy cv vz cv vw cv cop wceq vx cv vy cv cint cint wceq wa wa vx
      cv cF cfv vw cv vx cv cF wfun vy cv cF wcel vy cv vz cv vw cv cop wceq vx
      cv vy cv cint cint wceq vx cv cF cfv vw cv wceq cF wfun vx cv vy cv cint
      cint wceq vy cv vz cv vw cv cop wceq vy cv cF wcel vx cv cF cfv vw cv
      wceq cF wfun vx cv vy cv cint cint wceq vy cv vz cv vw cv cop wceq vy cv
      cF wcel vx cv cF cfv vw cv wceq wi cF wfun vx cv vy cv cint cint wceq vy
      cv vz cv vw cv cop wceq wa wa vy cv cF wcel vx cv vw cv cop cF wcel vx cv
      cF cfv vw cv wceq vx cv vy cv cint cint wceq vy cv vz cv vw cv cop wceq
      wa vy cv cF wcel vx cv vw cv cop cF wcel wb cF wfun vx cv vy cv cint cint
      wceq vy cv vz cv vw cv cop wceq wa vy cv vx cv vw cv cop cF vx cv vy cv
      cint cint wceq vy cv vz cv vw cv cop wceq wa vx cv vw cv cop vz cv vw cv
      cop wceq vy cv vx cv vw cv cop wceq vx cv vy cv cint cint wceq vy cv vz
      cv vw cv cop wceq vx cv vw cv cop vz cv vw cv cop wceq vx cv vy cv cint
      cint wceq vy cv vz cv vw cv cop wceq vx cv vz cv wceq vx cv vw cv cop vz
      cv vw cv cop wceq vx cv vy cv cint cint wceq vx cv vz cv wceq vy cv cint
      cint vz cv wceq vy cv vz cv vw cv cop wceq vx cv vy cv cint cint vz cv
      eqeq1 vy cv vz cv vw cv cop wceq vy cv cint cint vz cv vw cv cop cint
      cint vz cv vy cv vz cv vw cv cop wceq vy cv cint vz cv vw cv cop cint vy
      cv vz cv vw cv cop inteq inteqd vz cv vw cv vz visset op1stb syl6eq
      syl5bir vx cv vz cv vw cv opeq1 syl6 imp vy cv vz cv vw cv cop wceq vx cv
      vw cv cop vz cv vw cv cop wceq vy cv vx cv vw cv cop wceq wi vx cv vy cv
      cint cint wceq vx cv vw cv cop vz cv vw cv cop wceq vy cv vx cv vw cv cop
      wceq vy cv vz cv vw cv cop wceq vx cv vw cv cop vz cv vw cv cop vy cv
      eqeq2 biimprcd adantl mpd eleq1d adantl cF wfun vx cv vw cv cop cF wcel
      vx cv cF cfv vw cv wceq wi vx cv vy cv cint cint wceq vy cv vz cv vw cv
      cop wceq wa vx cv vw cv cF vw visset funopfv adantr sylbid exp32 com24
      imp43 opeq2d eqtr4d exp32 19.23advv mpd adantrl vy cv vx cv vx cv cF cfv
      cop wceq vy cv cint cint vx cv vx cv cF cfv cop cint cint vx cv vy cv vx
      cv vx cv cF cfv cop wceq vy cv cint vx cv vx cv cF cfv cop cint vy cv vx
      cv vx cv cF cfv cop inteq inteqd vx cv vx cv cF cfv vx visset op1stb
      syl6req impbid1 ex en3d $.
      $( [8-Aug-2004] $) $( [28-Jul-2004] $)
  $}

  ${
    $d f y z w A $.  $d f y z w B $.
    mapsnen.1 $e |- A e. _V $.
    mapsnen.2 $e |- B e. _V $.
    $( Set exponentiation to a singleton exponent is equinumerous to its base.
       Exercise 4.43 of [Mendelson] p. 255. $)
    mapsnen $p |- ( A ^m { B } ) ~~ A $=
      vz vw cA cB csn cm co cA cB vz cv cfv cB vw cv cop csn cA cB csn cm oprex
      cB vz cv cfv cvv wcel vz cv cA cB csn cm co wcel cB vz cv fvex a1i cB vw
      cv cop csn cvv wcel vw cv cA wcel cB vw cv cop snex a1i vz cv cA cB csn
      cm co wcel vw cv cB vz cv cfv wceq wa vy cv cA wcel vz cv cB vy cv cop
      csn wceq vw cv cB vz cv cfv wceq wa wa vy wex vy cv vw cv wceq vy cv cA
      wcel vz cv cB vy cv cop csn wceq wa wa vy wex vw cv cA wcel vz cv cB vw
      cv cop csn wceq wa vz cv cA cB csn cm co wcel vw cv cB vz cv cfv wceq wa
      vz cv cB vy cv cop csn wceq vy cA wrex vw cv cB vz cv cfv wceq wa vz cv
      cB vy cv cop csn wceq vw cv cB vz cv cfv wceq wa vy cA wrex vy cv cA wcel
      vz cv cB vy cv cop csn wceq vw cv cB vz cv cfv wceq wa wa vy wex vz cv cA
      cB csn cm co wcel vz cv cB vy cv cop csn wceq vy cA wrex vw cv cB vz cv
      cfv wceq vz cv cB vy cv cop csn wceq vy cA wrex vz cA cB csn cm co vy cA
      cB vz mapsnen.1 mapsnen.2 mapsn abeq2i anbi1i vz cv cB vy cv cop csn wceq
      vw cv cB vz cv cfv wceq vy cA r19.41v vz cv cB vy cv cop csn wceq vw cv
      cB vz cv cfv wceq wa vy cA df-rex 3bitr2i vy cv cA wcel vz cv cB vy cv
      cop csn wceq vw cv cB vz cv cfv wceq wa wa vy cv vw cv wceq vy cv cA wcel
      vz cv cB vy cv cop csn wceq wa wa vy vy cv cA wcel vz cv cB vy cv cop csn
      wceq vw cv cB vz cv cfv wceq wa wa vy cv cA wcel vz cv cB vy cv cop csn
      wceq vy cv vw cv wceq wa wa vy cv cA wcel vz cv cB vy cv cop csn wceq wa
      vy cv vw cv wceq wa vy cv vw cv wceq vy cv cA wcel vz cv cB vy cv cop csn
      wceq wa wa vz cv cB vy cv cop csn wceq vw cv cB vz cv cfv wceq wa vz cv
      cB vy cv cop csn wceq vy cv vw cv wceq wa vy cv cA wcel vz cv cB vy cv
      cop csn wceq vw cv cB vz cv cfv wceq vy cv vw cv wceq vz cv cB vy cv cop
      csn wceq vw cv cB vz cv cfv wceq vw cv vy cv wceq vy cv vw cv wceq vz cv
      cB vy cv cop csn wceq cB vz cv cfv vy cv vw cv vz cv cB vy cv cop csn
      wceq cB vz cv cfv cB cB vy cv cop csn cfv vy cv cB vz cv cB vy cv cop csn
      fveq1 cB vy cv mapsnen.2 vy visset fvsn syl6eq eqeq2d vw vy equcom syl6bb
      pm5.32i anbi2i vy cv cA wcel vz cv cB vy cv cop csn wceq vy cv vw cv wceq
      anass vy cv cA wcel vz cv cB vy cv cop csn wceq wa vy cv vw cv wceq ancom
      3bitr2i exbii vy cv cA wcel vz cv cB vy cv cop csn wceq wa vw cv cA wcel
      vz cv cB vw cv cop csn wceq wa vy vw cv vw visset vy cv vw cv wceq vy cv
      cA wcel vw cv cA wcel vz cv cB vy cv cop csn wceq vz cv cB vw cv cop csn
      wceq vy cv vw cv cA eleq1 vy cv vw cv wceq cB vy cv cop csn cB vw cv cop
      csn vz cv vy cv vw cv wceq cB vy cv cop cB vw cv cop vy cv vw cv cB opeq2
      sneqd eqeq2d anbi12d ceqsexv 3bitri en2 $.
      $( [2-Jul-2004] $) $( [17-Dec-2003] $)
  $}

  ${
    $d x y A $.
    map1.1 $e |- A e. _V $.
    $( Set exponentiation:  ordinal 1 to any set is equinumerous to ordinal 1.
       Exercise 4.42(b) of [Mendelson] p. 255. $)
    map1 $p |- ( 1o ^m A ) ~~ 1o $=
      vx vy c1o cA cm co c1o c0 cA c0 csn cxp c1o cA cm oprex c0 cvv wcel vx cv
      c1o cA cm co wcel 0ex a1i cA c0 csn cxp cvv wcel vy cv c1o wcel cA c0 csn
      map1.1 p0ex xpex a1i vy cv c1o wcel vx cv cA c0 csn cxp wceq wa vx cv cA
      c0 csn cxp wceq vy cv c1o wcel wa vx cv c1o cA cm co wcel vy cv c0 wceq
      wa vy cv c1o wcel vx cv cA c0 csn cxp wceq ancom vx cv cA c0 csn cxp wceq
      vx cv c1o cA cm co wcel vy cv c1o wcel vy cv c0 wceq vx cv c1o cA cm co
      wcel vx cv c0 csn cA cm co wcel cA c0 csn vx cv wf vx cv cA c0 csn cxp
      wceq c1o cA cm co c0 csn cA cm co vx cv c1o c0 csn cA cm df1o2 opreq1i
      eleq2i c0 csn cA vx cv p0ex map1.1 elmap cA c0 vx cv 0ex fconst2 3bitrri
      vy cv el1o anbi12i bitr2i en2 $.
      $( [26-Jun-2004] $) $( [17-Dec-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Two singletons are equinumerous. $)
    en2sn $p |- ( ( A e. C /\ B e. D ) -> { A } ~~ { B } ) $=
      cA csn c1o cen wbr c1o cB csn cen wbr cA csn cB csn cen wbr cA cC wcel cB
      cD wcel cA csn c1o cB csn entr cA cC ensn1g cB cD wcel cB csn c1o cen wbr
      c1o cB csn cen wbr cB cD ensn1g c1o con0 wcel cB csn c1o cen wbr c1o cB
      csn cen wbr wi 1on cB csn c1o con0 ensymg ax-mp syl syl2an $.
      $( [9-Nov-2003] $) $( [9-Nov-2003] $)
  $}

  ${
    $d x A $.
    $( A singleton is finite. $)
    snfi $p |- { A } e. Fin $=
      cA csn cfn wcel cA csn vx cv cen wbr vx com wrex cA cvv wcel cA csn vx cv
      cen wbr vx com wrex c1o com wcel cA csn c1o cen wbr cA csn vx cv cen wbr
      vx com wrex cA cvv wcel cA csn vx cv cen wbr cA csn c1o cen wbr vx c1o
      com vx cv c1o cA csn cen breq2 rcla4ev 1onn cA cvv ensn1g sylancr cA cvv
      wcel wn cA csn c0 wceq cA csn vx cv cen wbr vx com wrex cA snprc cA csn
      c0 wceq cA csn c0 cen wbr cA csn vx cv cen wbr vx com wrex cA csn en0 c0
      com wcel cA csn c0 cen wbr cA csn vx cv cen wbr vx com wrex peano1 cA csn
      vx cv cen wbr cA csn c0 cen wbr vx c0 com vx cv c0 cA csn cen breq2
      rcla4ev mpan sylbir sylbi pm2.61i vx cA csn isfi mpbir $.
      $( [29-Aug-2008] $) $( [4-Nov-2002] $)
  $}

  ${
    $d x y $.
    $( The class of finite sets is a proper class.  (Contributed by Jeffrey
       Hankins, 10-Oct-2008.) $)
    fiprc $p |- Fin e/ _V $=
      vx cv vy cv csn wceq vy wex vx cab cvv wnel cfn cvv wnel vx vy snnex vx
      cv vy cv csn wceq vy wex vx cab cvv wcel wn cfn cvv wcel wn vx cv vy cv
      csn wceq vy wex vx cab cvv wnel cfn cvv wnel cfn cvv wcel vx cv vy cv csn
      wceq vy wex vx cab cvv wcel vx cv vy cv csn wceq vy wex vx cab cfn wss
      cfn cvv wcel vx cv vy cv csn wceq vy wex vx cab cvv wcel vx cv vy cv csn
      wceq vy wex vx cfn vx cv vy cv csn wceq vx cv cfn wcel vy vx cv vy cv csn
      wceq vx cv cfn wcel vy cv csn cfn wcel vy cv snfi vx cv vy cv csn cfn
      eleq1 mpbiri 19.23aiv abssi vx cv vy cv csn wceq vy wex vx cab cfn cvv
      ssexg mpan con3i vx cv vy cv csn wceq vy wex vx cab cvv df-nel cfn cvv
      df-nel 3imtr4i ax-mp $.
      $( [1-Dec-2008] $) $( [3-Oct-2008] $)
  $}

  ${
    $d f g h A $.  $d f g h B $.  $d f g h C $.  $d f g h D $.
    $( Equinumerosity of union of disjoint sets.  Theorem 4 of [Suppes]
       p. 92. $)
    unen $p |- ( ( ( A ~~ B /\ C ~~ D ) /\
  ( ( A i^i C ) = (/) /\ ( B i^i D ) = (/) ) ) -> ( A u. C ) ~~ ( B u. D ) ) $=
      cB cD cun cvv wcel cA cB cen wbr cC cD cen wbr wa cA cC cin c0 wceq cB cD
      cin c0 wceq wa wa cA cC cun cB cD cun cen wbr wi cB cD cun cvv wcel cA cB
      cen wbr cC cD cen wbr wa cA cC cin c0 wceq cB cD cin c0 wceq wa cA cC cun
      cB cD cun cen wbr cB cD cun cvv wcel cA cB cen wbr cC cD cen wbr wa cA cB
      vf cv wf1o vf wex cC cD vg cv wf1o vg wex wa cA cC cin c0 wceq cB cD cin
      c0 wceq wa cA cC cun cB cD cun cen wbr wi cB cD cun cvv wcel cB cvv wcel
      cD cvv wcel wa cA cB cen wbr cC cD cen wbr wa cA cB vf cv wf1o vf wex cC
      cD vg cv wf1o vg wex wa wb cB cD unexb cB cvv wcel cA cB cen wbr cA cB vf
      cv wf1o vf wex cD cvv wcel cC cD cen wbr cC cD vg cv wf1o vg wex cA cB
      cvv vf breng cC cD cvv vg breng bi2anan9 sylbir cB cD cun cvv wcel cA cB
      vf cv wf1o cC cD vg cv wf1o wa vg wex vf wex cA cC cin c0 wceq cB cD cin
      c0 wceq wa cA cC cun cB cD cun cen wbr wi cA cB vf cv wf1o vf wex cC cD
      vg cv wf1o vg wex wa cB cD cun cvv wcel cA cB vf cv wf1o cC cD vg cv wf1o
      wa cA cC cin c0 wceq cB cD cin c0 wceq wa cA cC cun cB cD cun cen wbr wi
      vf vg cB cD cun cvv wcel cA cB vf cv wf1o cC cD vg cv wf1o wa cA cC cin
      c0 wceq cB cD cin c0 wceq wa cA cC cun cB cD cun cen wbr cB cD cun cvv
      wcel cA cC cun cB cD cun cen wbr cA cC cun cB cD cun vh cv wf1o vh wex cA
      cB vf cv wf1o cC cD vg cv wf1o wa cA cC cin c0 wceq cB cD cin c0 wceq wa
      wa cA cC cun cB cD cun cvv vh breng cA cB vf cv wf1o cC cD vg cv wf1o wa
      cA cC cin c0 wceq cB cD cin c0 wceq wa wa cA cC cun cB cD cun vf cv vg cv
      cun wf1o cA cC cun cB cD cun vh cv wf1o vh wex cA cB cC cD vf cv vg cv
      f1oun cA cC cun cB cD cun vh cv wf1o cA cC cun cB cD cun vf cv vg cv cun
      wf1o vh vf cv vg cv cun vf cv vg cv vf visset vg visset unex cA cC cun cB
      cD cun vh cv vf cv vg cv cun f1oeq1 cla4ev syl syl5bir exp3a 19.23advv cA
      cB vf cv wf1o cC cD vg cv wf1o vf vg eeanv syl5ibr sylbid imp3a cB cD cun
      cvv wcel wn cA cB cen wbr cC cD cen wbr wa cA cC cun cB cD cun cen wbr cA
      cC cin c0 wceq cB cD cin c0 wceq wa cB cD cun cvv wcel wn cA cC cun cB cD
      cun cen wbr cA cC cun cA cC cun cen wbr cA cB cen wbr cC cD cen wbr wa cA
      cC cun cB cD cun cen brprc cA cB cen wbr cC cD cen wbr wa cA cC cun cvv
      wcel cA cC cun cA cC cun cen wbr cA cB cen wbr cC cD cen wbr wa cA cvv
      wcel cC cvv wcel wa cA cC cun cvv wcel cA cB cen wbr cA cvv wcel cC cD
      cen wbr cC cvv wcel cA cB cen relen brrelexi cC cD cen relen brrelexi
      anim12i cA cC unexb sylib cA cC cun cvv enrefg syl syl5bir adantrd
      pm2.61i $.
      $( [11-Jun-1998] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    xpsnen.1 $e |- A e. _V $.
    xpsnen.2 $e |- B e. _V $.
    $( A set is equinumerous to its cross-product with a singleton.
       Proposition 4.22(c) of [Mendelson] p. 254. $)
    xpsnen $p |- ( A X. { B } ) ~~ A $=
      vy vx cA cB csn cxp cA vy cv cint cint vx cv cB cop cA cB csn xpsnen.1 cB
      snex xpex vy cv cA cB csn cxp wcel vy cv vx cv vz cv cop wceq vx cv cA
      wcel vz cv cB csn wcel wa wa vz wex vx wex vy cv cint cint cvv wcel vx vz
      vy cv cA cB csn elxp vy cv vx cv vz cv cop wceq vx cv cA wcel vz cv cB
      csn wcel wa wa vy cv cint cint cvv wcel vx vz vy cv vx cv vz cv cop wceq
      vy cv cint cint cvv wcel vx cv cA wcel vz cv cB csn wcel wa vy cv vx cv
      vz cv cop wceq vy cv cint cint vx cv cvv vy cv vx cv vz cv cop wceq vy cv
      cint cint vx cv vz cv cop cint cint vx cv vy cv vx cv vz cv cop wceq vy
      cv cint vx cv vz cv cop cint vy cv vx cv vz cv cop inteq inteqd vx cv vz
      cv vx visset op1stb syl6eq vx visset syl6eqel adantr 19.23aivv sylbi vx
      cv cB cop cvv wcel vx cv cA wcel vx cv cB opex a1i vy cv cA cB csn cxp
      wcel vx cv vy cv cint cint wceq wa vy cv vy cv cint cint cB cop wceq vy
      cv cint cint cA wcel wa vx cv vy cv cint cint wceq wa vy cv vx cv cB cop
      wceq vx cv cA wcel wa vx cv cA wcel vy cv vx cv cB cop wceq wa vx cv vy
      cv cint cint wceq vy cv cA cB csn cxp wcel vy cv vy cv cint cint cB cop
      wceq vy cv cint cint cA wcel wa vx cv vy cv cint cint wceq vy cv cint
      cint cvv wcel vy cv cA cB csn cxp wcel vy cv vy cv cint cint cB cop wceq
      vy cv cint cint cA wcel wa wb vx cv vy cv cint cint wceq vx cv cvv wcel
      vy cv cint cint cvv wcel vx visset vx cv vy cv cint cint cvv eleq1 mpbii
      vy cv cint cint cvv wcel vx cv vy cv cint cint wceq vy cv vx cv cB cop
      wceq vx cv cA wcel wa wa vx wex vy cv vy cv cint cint cB cop wceq vy cv
      cint cint cA wcel wa vy cv cA cB csn cxp wcel vy cv vx cv cB cop wceq vx
      cv cA wcel wa vy cv vy cv cint cint cB cop wceq vy cv cint cint cA wcel
      wa vx vy cv cint cint cvv vx cv vy cv cint cint wceq vy cv vx cv cB cop
      wceq vy cv vy cv cint cint cB cop wceq vx cv cA wcel vy cv cint cint cA
      wcel vx cv vy cv cint cint wceq vx cv cB cop vy cv cint cint cB cop vy cv
      vx cv vy cv cint cint cB opeq1 eqeq2d vx cv vy cv cint cint cA eleq1
      anbi12d ceqsexgv vy cv cA cB csn cxp wcel vy cv vx cv vz cv cop wceq vx
      cv cA wcel vz cv cB csn wcel wa wa vz wex vx wex vx cv vy cv cint cint
      wceq vy cv vx cv cB cop wceq vx cv cA wcel wa wa vx wex vx vz vy cv cA cB
      csn elxp vy cv vx cv vz cv cop wceq vx cv cA wcel vz cv cB csn wcel wa wa
      vz wex vx cv vy cv cint cint wceq vy cv vx cv cB cop wceq vx cv cA wcel
      wa wa vx vy cv vx cv vz cv cop wceq vx cv cA wcel vz cv cB csn wcel wa wa
      vz wex vz cv cB wceq vy cv vx cv vz cv cop wceq vx cv cA wcel wa wa vz
      wex vy cv vx cv cB cop wceq vx cv cA wcel wa vx cv vy cv cint cint wceq
      vy cv vx cv cB cop wceq vx cv cA wcel wa wa vy cv vx cv vz cv cop wceq vx
      cv cA wcel vz cv cB csn wcel wa wa vz cv cB wceq vy cv vx cv vz cv cop
      wceq vx cv cA wcel wa wa vz vy cv vx cv vz cv cop wceq vx cv cA wcel wa
      vz cv cB csn wcel wa vz cv cB csn wcel vy cv vx cv vz cv cop wceq vx cv
      cA wcel wa wa vy cv vx cv vz cv cop wceq vx cv cA wcel vz cv cB csn wcel
      wa wa vz cv cB wceq vy cv vx cv vz cv cop wceq vx cv cA wcel wa wa vy cv
      vx cv vz cv cop wceq vx cv cA wcel wa vz cv cB csn wcel ancom vy cv vx cv
      vz cv cop wceq vx cv cA wcel vz cv cB csn wcel anass vz cv cB csn wcel vz
      cv cB wceq vy cv vx cv vz cv cop wceq vx cv cA wcel wa vz cB elsn anbi1i
      3bitr3i exbii vy cv vx cv vz cv cop wceq vx cv cA wcel wa vy cv vx cv cB
      cop wceq vx cv cA wcel wa vz cB xpsnen.2 vz cv cB wceq vy cv vx cv vz cv
      cop wceq vy cv vx cv cB cop wceq vx cv cA wcel vz cv cB wceq vx cv vz cv
      cop vx cv cB cop vy cv vz cv cB vx cv opeq2 eqeq2d anbi1d ceqsexv vy cv
      vx cv cB cop wceq vx cv cA wcel wa vx cv vy cv cint cint wceq vy cv vx cv
      cB cop wceq wa vx cv cA wcel wa vx cv vy cv cint cint wceq vy cv vx cv cB
      cop wceq vx cv cA wcel wa wa vy cv vx cv cB cop wceq vx cv vy cv cint
      cint wceq vy cv vx cv cB cop wceq wa vx cv cA wcel vy cv vx cv cB cop
      wceq vx cv vy cv cint cint wceq vy cv vx cv cB cop wceq vy cv cint cint
      vx cv cB cop cint cint vx cv vy cv vx cv cB cop wceq vy cv cint vx cv cB
      cop cint vy cv vx cv cB cop inteq inteqd vx cv cB vx visset op1stb
      syl6req pm4.71ri anbi1i vx cv vy cv cint cint wceq vy cv vx cv cB cop
      wceq vx cv cA wcel anass bitri 3bitri exbii bitri syl5bb syl pm5.32ri vy
      cv vx cv cB cop wceq vx cv cA wcel wa vy cv vx cv cB cop wceq vx cv cA
      wcel wa vx cv vy cv cint cint wceq wa vy cv vy cv cint cint cB cop wceq
      vy cv cint cint cA wcel wa vx cv vy cv cint cint wceq wa vy cv vx cv cB
      cop wceq vx cv cA wcel wa vx cv vy cv cint cint wceq vy cv vx cv cB cop
      wceq vx cv vy cv cint cint wceq vx cv cA wcel vy cv vx cv cB cop wceq vy
      cv cint cint vx cv cB cop cint cint vx cv vy cv vx cv cB cop wceq vy cv
      cint vx cv cB cop cint vy cv vx cv cB cop inteq inteqd vx cv cB vx visset
      op1stb syl6req adantr pm4.71i vx cv vy cv cint cint wceq vy cv vx cv cB
      cop wceq vx cv cA wcel wa vy cv vy cv cint cint cB cop wceq vy cv cint
      cint cA wcel wa vx cv vy cv cint cint wceq vy cv vx cv cB cop wceq vy cv
      vy cv cint cint cB cop wceq vx cv cA wcel vy cv cint cint cA wcel vx cv
      vy cv cint cint wceq vx cv cB cop vy cv cint cint cB cop vy cv vx cv vy
      cv cint cint cB opeq1 eqeq2d vx cv vy cv cint cint cA eleq1 anbi12d
      pm5.32ri bitr2i vy cv vx cv cB cop wceq vx cv cA wcel ancom 3bitri en2 $.
      $( [28-Jun-2004] $) $( [4-Jan-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A set is equinumerous to its cross-product with a singleton.
       Proposition 4.22(c) of [Mendelson] p. 254. $)
    xpsneng $p |- ( ( A e. C /\ B e. D ) -> ( A X. { B } ) ~~ A ) $=
      vx cv vy cv csn cxp vx cv cen wbr cA vy cv csn cxp cA cen wbr cA cB csn
      cxp cA cen wbr vx vy cA cB cC cD vx cv cA wceq vx cv vy cv csn cxp cA vy
      cv csn cxp vx cv cA cen vx cv cA vy cv csn xpeq1 vx cv cA wceq id breq12d
      vy cv cB wceq cA vy cv csn cxp cA cB csn cxp cA cen vy cv cB wceq vy cv
      csn cB csn wceq cA vy cv csn cxp cA cB csn cxp wceq vy cv cB sneq vy cv
      csn cB csn cA xpeq2 syl breq1d vx cv vy cv vx visset vy visset xpsnen
      vtocl2g $.
      $( [23-Oct-2004] $) $( [22-Oct-2004] $)
  $}


  ${
    $d x y A $.  $d x y B $.
    endisj.1 $e |- A e. _V $.
    endisj.2 $e |- B e. _V $.
    $( Any two sets are equinumerous to disjoint sets.  Exercise 4.39 of
       [Mendelson] p. 255. $)
    endisj $p |- E. x E. y ( ( x ~~ A /\ y ~~ B ) /\ ( x i^i y ) = (/) ) $=
      cA c0 csn cxp cA cen wbr cB c1o csn cxp cB cen wbr wa cA c0 csn cxp cB
      c1o csn cxp cin c0 wceq vx cv cA cen wbr vy cv cB cen wbr wa vx cv vy cv
      cin c0 wceq wa vy wex vx wex cA c0 csn cxp cA cen wbr cB c1o csn cxp cB
      cen wbr cA c0 endisj.1 0ex xpsnen cB c1o endisj.2 c1o con0 1on elisseti
      xpsnen pm3.2i cA cB xp01disj vx cv cA cen wbr vy cv cB cen wbr wa vx cv
      vy cv cin c0 wceq wa cA c0 csn cxp cA cen wbr cB c1o csn cxp cB cen wbr
      wa cA c0 csn cxp cB c1o csn cxp cin c0 wceq wa vx vy cA c0 csn cxp cB c1o
      csn cxp cA c0 csn endisj.1 p0ex xpex cB c1o csn endisj.2 c1o snex xpex vx
      cv cA c0 csn cxp wceq vy cv cB c1o csn cxp wceq wa vx cv cA cen wbr vy cv
      cB cen wbr wa cA c0 csn cxp cA cen wbr cB c1o csn cxp cB cen wbr wa vx cv
      vy cv cin c0 wceq cA c0 csn cxp cB c1o csn cxp cin c0 wceq vx cv cA c0
      csn cxp wceq vx cv cA cen wbr cA c0 csn cxp cA cen wbr vy cv cB c1o csn
      cxp wceq vy cv cB cen wbr cB c1o csn cxp cB cen wbr vx cv cA c0 csn cxp
      cA cen breq1 vy cv cB c1o csn cxp cB cen breq1 bi2anan9 vx cv cA c0 csn
      cxp wceq vy cv cB c1o csn cxp wceq wa vx cv vy cv cin cA c0 csn cxp cB
      c1o csn cxp cin c0 vx cv cA c0 csn cxp vy cv cB c1o csn cxp ineq12 eqeq1d
      anbi12d cla42ev mp2an $.
      $( [3-Jul-2004] $) $( [16-Apr-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    undom.1 $e |- B e. _V $.
    undom.2 $e |- C e. _V $.
    undom.3 $e |- D e. _V $.
    $( Dominance law for union.  Proposition 4.24(a) of [Mendelson] p. 257. $)
    undom $p |- ( ( ( A ~<_ B /\ C ~<_ D ) /\ ( B i^i D ) = (/) ) ->
                ( A u. C ) ~<_ ( B u. D ) ) $=
      cA cB cdom wbr cC cD cdom wbr wa cB cD cin c0 wceq cA cC cun cB cD cun
      cdom wbr cA cB cdom wbr cC cA cdif cD cdom wbr cB cD cin c0 wceq cA cC
      cun cB cD cun cdom wbr wi cC cD cdom wbr cA vx cv cen wbr vx cv cB wss wa
      vx wex cC cA cdif vy cv cen wbr vy cv cD wss wa vy wex cB cD cin c0 wceq
      cA cC cun cB cD cun cdom wbr wi cA cB cdom wbr cC cA cdif cD cdom wbr cA
      vx cv cen wbr vx cv cB wss wa vx wex cC cA cdif vy cv cen wbr vy cv cD
      wss wa vy wex cB cD cin c0 wceq cA cC cun cB cD cun cdom wbr wi cA vx cv
      cen wbr vx cv cB wss wa vx wex cC cA cdif vy cv cen wbr vy cv cD wss wa
      cB cD cin c0 wceq cA cC cun cB cD cun cdom wbr wi vy cA vx cv cen wbr vx
      cv cB wss wa cC cA cdif vy cv cen wbr vy cv cD wss wa cB cD cin c0 wceq
      cA cC cun cB cD cun cdom wbr wi wi vx cA vx cv cen wbr vx cv cB wss wa cC
      cA cdif vy cv cen wbr vy cv cD wss wa cB cD cin c0 wceq cA cC cun cB cD
      cun cdom wbr wi cA vx cv cen wbr cC cA cdif vy cv cen wbr vx cv cB wss vy
      cv cD wss cB cD cin c0 wceq cA cC cun cB cD cun cdom wbr wi cA vx cv cen
      wbr cC cA cdif vy cv cen wbr wa vx cv cB wss vy cv cD wss wa wa cB cD cin
      c0 wceq cA cC cun cB cD cun cdom wbr cA cC cun vx cv vy cv cun cen wbr vx
      cv vy cv cun cB cD cun cdom wbr cA cC cun cB cD cun cdom wbr cA vx cv cen
      wbr cC cA cdif vy cv cen wbr wa vx cv cB wss vy cv cD wss wa wa cB cD cin
      c0 wceq wa cA cC cun vx cv vy cv cun cB cD cun endomtr cA vx cv cen wbr
      cC cA cdif vy cv cen wbr wa cB cD cin c0 wceq vx cv cB wss vy cv cD wss
      wa cA cC cun vx cv vy cv cun cen wbr cA vx cv cen wbr cC cA cdif vy cv
      cen wbr wa cB cD cin c0 wceq vx cv cB wss vy cv cD wss wa cA cC cun vx cv
      vy cv cun cen wbr cA vx cv cen wbr cC cA cdif vy cv cen wbr wa cA cC cA
      cdif cin c0 wceq vx cv vy cv cin c0 wceq wa cA cC cun vx cv vy cv cun cen
      wbr cB cD cin c0 wceq vx cv cB wss vy cv cD wss wa wa cA vx cv cen wbr cC
      cA cdif vy cv cen wbr wa cA cC cA cdif cin c0 wceq vx cv vy cv cin c0
      wceq wa wa cA cC cA cdif cun vx cv vy cv cun cA cC cun cen cA vx cv cC cA
      cdif vy cv unen cA cC undif2 syl5eqbrr cB cD cin c0 wceq vx cv cB wss vy
      cv cD wss wa wa vx cv vy cv cin c0 wceq cA cC cA cdif cin c0 wceq cB cD
      cin c0 wceq vx cv cB wss vy cv cD wss wa vx cv vy cv cin c0 wceq cB cD
      cin c0 wceq vx cv vy cv cin cB cD cin wss vx cv vy cv cin c0 wceq vx cv
      cB wss vy cv cD wss wa cB cD cin c0 wceq vx cv vy cv cin cB cD cin wss vx
      cv vy cv cin c0 wss vx cv vy cv cin c0 wceq cB cD cin c0 vx cv vy cv cin
      sseq2 vx cv vy cv cin ss0b syl6bb vx cv cB vy cv cD ss2in syl5bi imp cA
      cC difdisj jctil sylan2 anassrs an1rs vx cv cB wss vy cv cD wss wa vx cv
      vy cv cun cB cD cun cdom wbr cA vx cv cen wbr cC cA cdif vy cv cen wbr wa
      cB cD cin c0 wceq vx cv cB wss vy cv cD wss wa vx cv vy cv cun cB cD cun
      wss vx cv vy cv cun cB cD cun cdom wbr vx cv cB vy cv cD unss12 cB cD cun
      cvv wcel vx cv vy cv cun cB cD cun wss vx cv vy cv cun cB cD cun cdom wbr
      wi cB cD undom.1 undom.3 unex vx cv vy cv cun cB cD cun cvv ssdom2g ax-mp
      syl ad2antlr sylanc ex an4s ex 19.23aiv 19.23adv imp vx cA cB undom.1
      domen vy cC cA cdif cD undom.3 domen syl2anb cC cA cdif cC cdom wbr cC cD
      cdom wbr cC cA cdif cD cdom wbr cC cvv wcel cC cA cdif cC wss cC cA cdif
      cC cdom wbr undom.2 cC cA difss cC cA cdif cC cvv ssdom2g mp2 cC cA cdif
      cC cD domtr mpan sylan2 imp $.
      $( [24-Sep-2004] $) $( [3-Sep-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    xpcomen.1 $e |- A e. _V $.
    xpcomen.2 $e |- B e. _V $.
    $( Commutative law for equinumerosity of cross product.  Proposition
       4.22(d) of [Mendelson] p. 254. $)
    xpcomen $p |- ( A X. B ) ~~ ( B X. A ) $=
      vx vy cA cB cxp cB cA cxp vx cv csn ccnv cuni vy cv csn ccnv cuni cA cB
      xpcomen.1 xpcomen.2 xpex vx cv csn ccnv cuni cvv wcel vx cv cA cB cxp
      wcel vx cv csn ccnv vx cv csn vx cv snex cnvex uniex a1i vy cv csn ccnv
      cuni cvv wcel vy cv cB cA cxp wcel vy cv csn ccnv vy cv csn vy cv snex
      cnvex uniex a1i vx cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa
      wa vw wex vz wex vy cv vx cv csn ccnv cuni wceq wa vy cv vw cv vz cv cop
      wceq vw cv cB wcel vz cv cA wcel wa wa vw wex vz wex vx cv vy cv csn ccnv
      cuni wceq wa vx cv cA cB cxp wcel vy cv vx cv csn ccnv cuni wceq wa vy cv
      cB cA cxp wcel vx cv vy cv csn ccnv cuni wceq wa vx cv vz cv vw cv cop
      wceq vz cv cA wcel vw cv cB wcel wa wa vy cv vx cv csn ccnv cuni wceq wa
      vw wex vz wex vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA wcel wa
      wa vx cv vy cv csn ccnv cuni wceq wa vw wex vz wex vx cv vz cv vw cv cop
      wceq vz cv cA wcel vw cv cB wcel wa wa vw wex vz wex vy cv vx cv csn ccnv
      cuni wceq wa vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA wcel wa wa
      vw wex vz wex vx cv vy cv csn ccnv cuni wceq wa vx cv vz cv vw cv cop
      wceq vz cv cA wcel vw cv cB wcel wa wa vy cv vx cv csn ccnv cuni wceq wa
      vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA wcel wa wa vx cv vy cv
      csn ccnv cuni wceq wa vz vw vx cv vz cv vw cv cop wceq vy cv vx cv csn
      ccnv cuni wceq wa vz cv cA wcel vw cv cB wcel wa wa vy cv vw cv vz cv cop
      wceq vx cv vy cv csn ccnv cuni wceq wa vw cv cB wcel vz cv cA wcel wa wa
      vx cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vy cv vx cv
      csn ccnv cuni wceq wa vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA
      wcel wa wa vx cv vy cv csn ccnv cuni wceq wa vx cv vz cv vw cv cop wceq
      vy cv vx cv csn ccnv cuni wceq wa vy cv vw cv vz cv cop wceq vx cv vy cv
      csn ccnv cuni wceq wa vz cv cA wcel vw cv cB wcel wa vw cv cB wcel vz cv
      cA wcel wa vx cv vy cv vz cv vw cv cop vw cv vz cv cop vx cv csn ccnv
      cuni vy cv csn ccnv cuni vx cv vz cv vw cv cop wceq vx cv csn ccnv cuni
      vw cv vz cv cop csn cuni vw cv vz cv cop vx cv vz cv vw cv cop wceq vx cv
      csn ccnv vw cv vz cv cop csn vx cv vz cv vw cv cop wceq vx cv csn ccnv vz
      cv vw cv cop csn ccnv vw cv vz cv cop csn vx cv vz cv vw cv cop wceq vx
      cv csn vz cv vw cv cop csn wceq vx cv csn ccnv vz cv vw cv cop csn ccnv
      wceq vx cv vz cv vw cv cop sneq vx cv csn vz cv vw cv cop csn cnveq syl
      vz cv vw cv vz visset vw visset cnvsn syl6eq unieqd vw cv vz cv cop vw cv
      vz cv opex unisn syl6req vy cv vw cv vz cv cop wceq vy cv csn ccnv cuni
      vz cv vw cv cop csn cuni vz cv vw cv cop vy cv vw cv vz cv cop wceq vy cv
      csn ccnv vz cv vw cv cop csn vy cv vw cv vz cv cop wceq vy cv csn ccnv vw
      cv vz cv cop csn ccnv vz cv vw cv cop csn vy cv vw cv vz cv cop wceq vy
      cv csn vw cv vz cv cop csn wceq vy cv csn ccnv vw cv vz cv cop csn ccnv
      wceq vy cv vw cv vz cv cop sneq vy cv csn vw cv vz cv cop csn cnveq syl
      vw cv vz cv vw visset vz visset cnvsn syl6eq unieqd vz cv vw cv cop vz cv
      vw cv opex unisn syl6req eq2tri vz cv cA wcel vw cv cB wcel ancom anbi12i
      vx cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa vy cv vx cv csn
      ccnv cuni wceq an23 vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA
      wcel wa vx cv vy cv csn ccnv cuni wceq an23 3bitr4i 2exbii vx cv vz cv vw
      cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vy cv vx cv csn ccnv cuni
      wceq vz vw 19.41vv vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA wcel
      wa wa vx cv vy cv csn ccnv cuni wceq vz vw 19.41vv 3bitr3i vx cv cA cB
      cxp wcel vx cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vw
      wex vz wex vy cv vx cv csn ccnv cuni wceq vz vw vx cv cA cB elxp anbi1i
      vy cv cB cA cxp wcel vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA
      wcel wa wa vw wex vz wex vx cv vy cv csn ccnv cuni wceq vy cv cB cA cxp
      wcel vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA wcel wa wa vz wex
      vw wex vy cv vw cv vz cv cop wceq vw cv cB wcel vz cv cA wcel wa wa vw
      wex vz wex vw vz vy cv cB cA elxp vy cv vw cv vz cv cop wceq vw cv cB
      wcel vz cv cA wcel wa wa vw vz excom bitri anbi1i 3bitr4i en2 $.
      $( [4-Jul-2004] $) $( [5-Jan-2004] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( Commutative law for equinumerosity of cross product.  Proposition
       4.22(d) of [Mendelson] p. 254. $)
    xpcomeng $p |- ( ( A e. C /\ B e. D ) -> ( A X. B ) ~~ ( B X. A ) ) $=
      vx cv vy cv cxp vy cv vx cv cxp cen wbr cA vy cv cxp vy cv cA cxp cen wbr
      cA cB cxp cB cA cxp cen wbr vx vy cA cB cC cD vx cv cA wceq vx cv vy cv
      cxp cA vy cv cxp vy cv vx cv cxp vy cv cA cxp cen vx cv cA vy cv xpeq1 vx
      cv cA vy cv xpeq2 breq12d vy cv cB wceq cA vy cv cxp cA cB cxp vy cv cA
      cxp cB cA cxp cen vy cv cB cA xpeq2 vy cv cB cA xpeq1 breq12d vx cv vy cv
      vx visset vy visset xpcomen vtocl2g $.
      $( [29-Mar-2006] $) $( [27-Mar-2006] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    xpassen.1 $e |- A e. _V $.
    xpassen.2 $e |- B e. _V $.
    xpassen.3 $e |- C e. _V $.
    $( Associative law for equinumerosity of cross product.  Proposition
       4.22(e) of [Mendelson] p. 254. $)
    xpassen $p |- ( ( A X. B ) X. C ) ~~ ( A X. ( B X. C ) ) $=
      vx vy cA cB cxp cC cxp cA cB cC cxp cxp vx cv csn cdm cuni csn cdm cuni
      vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni cop cop vy cv csn cdm
      cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni
      cop cA cB cxp cC cA cB xpassen.1 xpassen.2 xpex xpassen.3 xpex vx cv csn
      cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni
      cop cop cvv wcel vx cv cA cB cxp cC cxp wcel vx cv csn cdm cuni csn cdm
      cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni cop opex a1i vy
      cv csn cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni
      csn crn cuni cop cvv wcel vy cv cA cB cC cxp cxp wcel vy cv csn cdm cuni
      vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni opex
      a1i vx cv vz cv vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB wcel wa
      vv cv cC wcel wa wa vv wex vw wex vz wex vy cv vx cv csn cdm cuni csn cdm
      cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni cop cop wceq wa
      vy cv vz cv vw cv vv cv cop cop wceq vz cv cA wcel vw cv cB wcel vv cv cC
      wcel wa wa wa vv wex vw wex vz wex vx cv vy cv csn cdm cuni vy cv csn crn
      cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq wa vx cv
      cA cB cxp cC cxp wcel vy cv vx cv csn cdm cuni csn cdm cuni vx cv csn cdm
      cuni csn crn cuni vx cv csn crn cuni cop cop wceq wa vy cv cA cB cC cxp
      cxp wcel vx cv vy cv csn cdm cuni vy cv csn crn cuni csn cdm cuni cop vy
      cv csn crn cuni csn crn cuni cop wceq wa vx cv vz cv vw cv cop vv cv cop
      wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa vv wex vy cv vx
      cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn
      crn cuni cop cop wceq wa vw wex vz wex vy cv vz cv vw cv vv cv cop cop
      wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vv wex vx cv vy
      cv csn cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni
      csn crn cuni cop wceq wa vw wex vz wex vx cv vz cv vw cv cop vv cv cop
      wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa vv wex vw wex vz
      wex vy cv vx cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni
      vx cv csn crn cuni cop cop wceq wa vy cv vz cv vw cv vv cv cop cop wceq
      vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vv wex vw wex vz wex
      vx cv vy cv csn cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn
      crn cuni csn crn cuni cop wceq wa vx cv vz cv vw cv cop vv cv cop wceq vz
      cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa vv wex vy cv vx cv csn
      cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni
      cop cop wceq wa vy cv vz cv vw cv vv cv cop cop wceq vz cv cA wcel vw cv
      cB wcel vv cv cC wcel wa wa wa vv wex vx cv vy cv csn cdm cuni vy cv csn
      crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq wa vz
      vw vx cv vz cv vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB wcel wa vv
      cv cC wcel wa wa vy cv vx cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni
      csn crn cuni vx cv csn crn cuni cop cop wceq wa vv wex vy cv vz cv vw cv
      vv cv cop cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vx
      cv vy cv csn cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn
      cuni csn crn cuni cop wceq wa vv wex vx cv vz cv vw cv cop vv cv cop wceq
      vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa vv wex vy cv vx cv csn
      cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni
      cop cop wceq wa vy cv vz cv vw cv vv cv cop cop wceq vz cv cA wcel vw cv
      cB wcel vv cv cC wcel wa wa wa vv wex vx cv vy cv csn cdm cuni vy cv csn
      crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq wa vx
      cv vz cv vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB wcel wa vv cv cC
      wcel wa wa vy cv vx cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn
      crn cuni vx cv csn crn cuni cop cop wceq wa vy cv vz cv vw cv vv cv cop
      cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vx cv vy cv
      csn cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni csn
      crn cuni cop wceq wa vv vx cv vz cv vw cv cop vv cv cop wceq vy cv vx cv
      csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn
      cuni cop cop wceq wa vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa
      vy cv vz cv vw cv vv cv cop cop wceq vx cv vy cv csn cdm cuni vy cv csn
      crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq wa vz
      cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vx cv vz cv vw cv cop vv
      cv cop wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa vy cv vx
      cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn
      crn cuni cop cop wceq wa vy cv vz cv vw cv vv cv cop cop wceq vz cv cA
      wcel vw cv cB wcel vv cv cC wcel wa wa wa vx cv vy cv csn cdm cuni vy cv
      csn crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq wa
      vx cv vz cv vw cv cop vv cv cop wceq vy cv vx cv csn cdm cuni csn cdm
      cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni cop cop wceq wa
      vy cv vz cv vw cv vv cv cop cop wceq vx cv vy cv csn cdm cuni vy cv csn
      crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq wa vz
      cv cA wcel vw cv cB wcel wa vv cv cC wcel wa vz cv cA wcel vw cv cB wcel
      vv cv cC wcel wa wa vx cv vy cv vz cv vw cv cop vv cv cop vz cv vw cv vv
      cv cop cop vx cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn
      cuni vx cv csn crn cuni cop cop vy cv csn cdm cuni vy cv csn crn cuni csn
      cdm cuni cop vy cv csn crn cuni csn crn cuni cop vx cv vz cv vw cv cop vv
      cv cop wceq vz cv vx cv csn cdm cuni csn cdm cuni vw cv vv cv cop vx cv
      csn cdm cuni csn crn cuni vx cv csn crn cuni cop vx cv vz cv vw cv cop vv
      cv cop wceq vx cv csn cdm cuni csn cdm cuni vz cv vw cv cop vv cv cop csn
      cdm cuni csn cdm cuni vz cv vx cv vz cv vw cv cop vv cv cop wceq vx cv
      csn cdm cuni csn cdm vz cv vw cv cop vv cv cop csn cdm cuni csn cdm vx cv
      vz cv vw cv cop vv cv cop wceq vx cv csn cdm cuni csn vz cv vw cv cop vv
      cv cop csn cdm cuni csn vx cv vz cv vw cv cop vv cv cop wceq vx cv csn
      cdm cuni vz cv vw cv cop vv cv cop csn cdm cuni vx cv vz cv vw cv cop vv
      cv cop wceq vx cv csn cdm vz cv vw cv cop vv cv cop csn cdm vx cv vz cv
      vw cv cop vv cv cop wceq vx cv csn vz cv vw cv cop vv cv cop csn vx cv vz
      cv vw cv cop vv cv cop sneq dmeqd unieqd sneqd dmeqd unieqd vz cv vw cv
      cop vv cv cop csn cdm cuni csn cdm cuni vz cv vw cv cop csn cdm cuni vz
      cv vz cv vw cv cop vv cv cop csn cdm cuni csn cdm vz cv vw cv cop csn cdm
      vz cv vw cv cop vv cv cop csn cdm cuni csn vz cv vw cv cop csn vz cv vw
      cv cop vv cv cop csn cdm cuni vz cv vw cv cop vz cv vw cv cop vv cv vz cv
      vw cv opex op1sta sneqi dmeqi unieqi vz cv vw cv vz visset op1sta eqtri
      syl6req vx cv vz cv vw cv cop vv cv cop wceq vw cv vx cv csn cdm cuni csn
      crn cuni vv cv vx cv csn crn cuni vx cv vz cv vw cv cop vv cv cop wceq vx
      cv csn cdm cuni csn crn cuni vz cv vw cv cop vv cv cop csn cdm cuni csn
      crn cuni vw cv vx cv vz cv vw cv cop vv cv cop wceq vx cv csn cdm cuni
      csn crn vz cv vw cv cop vv cv cop csn cdm cuni csn crn vx cv vz cv vw cv
      cop vv cv cop wceq vx cv csn cdm cuni csn vz cv vw cv cop vv cv cop csn
      cdm cuni csn vx cv vz cv vw cv cop vv cv cop wceq vx cv csn cdm cuni vz
      cv vw cv cop vv cv cop csn cdm cuni vx cv vz cv vw cv cop vv cv cop wceq
      vx cv csn cdm vz cv vw cv cop vv cv cop csn cdm vx cv vz cv vw cv cop vv
      cv cop wceq vx cv csn vz cv vw cv cop vv cv cop csn vx cv vz cv vw cv cop
      vv cv cop sneq dmeqd unieqd sneqd rneqd unieqd vz cv vw cv cop vv cv cop
      csn cdm cuni csn crn cuni vz cv vw cv cop csn crn cuni vw cv vz cv vw cv
      cop vv cv cop csn cdm cuni csn crn vz cv vw cv cop csn crn vz cv vw cv
      cop vv cv cop csn cdm cuni csn vz cv vw cv cop csn vz cv vw cv cop vv cv
      cop csn cdm cuni vz cv vw cv cop vz cv vw cv cop vv cv vz cv vw cv opex
      op1sta sneqi rneqi unieqi vz cv vw cv vz visset vw visset op2nda eqtri
      syl6req vx cv vz cv vw cv cop vv cv cop wceq vx cv csn crn cuni vz cv vw
      cv cop vv cv cop csn crn cuni vv cv vx cv vz cv vw cv cop vv cv cop wceq
      vx cv csn crn vz cv vw cv cop vv cv cop csn crn vx cv vz cv vw cv cop vv
      cv cop wceq vx cv csn vz cv vw cv cop vv cv cop csn vx cv vz cv vw cv cop
      vv cv cop sneq rneqd unieqd vz cv vw cv cop vv cv vz cv vw cv opex vv
      visset op2nda syl6req opeq12d opeq12d vy cv vz cv vw cv vv cv cop cop
      wceq vz cv vw cv cop vy cv csn cdm cuni vy cv csn crn cuni csn cdm cuni
      cop vv cv vy cv csn crn cuni csn crn cuni vy cv vz cv vw cv vv cv cop cop
      wceq vz cv vy cv csn cdm cuni vw cv vy cv csn crn cuni csn cdm cuni vy cv
      vz cv vw cv vv cv cop cop wceq vy cv csn cdm cuni vz cv vw cv vv cv cop
      cop csn cdm cuni vz cv vy cv vz cv vw cv vv cv cop cop wceq vy cv csn cdm
      vz cv vw cv vv cv cop cop csn cdm vy cv vz cv vw cv vv cv cop cop wceq vy
      cv csn vz cv vw cv vv cv cop cop csn vy cv vz cv vw cv vv cv cop cop sneq
      dmeqd unieqd vz cv vw cv vv cv cop vz visset op1sta syl6req vy cv vz cv
      vw cv vv cv cop cop wceq vy cv csn crn cuni csn cdm cuni vz cv vw cv vv
      cv cop cop csn crn cuni csn cdm cuni vw cv vy cv vz cv vw cv vv cv cop
      cop wceq vy cv csn crn cuni csn cdm vz cv vw cv vv cv cop cop csn crn
      cuni csn cdm vy cv vz cv vw cv vv cv cop cop wceq vy cv csn crn cuni csn
      vz cv vw cv vv cv cop cop csn crn cuni csn vy cv vz cv vw cv vv cv cop
      cop wceq vy cv csn crn cuni vz cv vw cv vv cv cop cop csn crn cuni vy cv
      vz cv vw cv vv cv cop cop wceq vy cv csn crn vz cv vw cv vv cv cop cop
      csn crn vy cv vz cv vw cv vv cv cop cop wceq vy cv csn vz cv vw cv vv cv
      cop cop csn vy cv vz cv vw cv vv cv cop cop sneq rneqd unieqd sneqd dmeqd
      unieqd vz cv vw cv vv cv cop cop csn crn cuni csn cdm cuni vw cv vv cv
      cop csn cdm cuni vw cv vz cv vw cv vv cv cop cop csn crn cuni csn cdm vw
      cv vv cv cop csn cdm vz cv vw cv vv cv cop cop csn crn cuni csn vw cv vv
      cv cop csn vz cv vw cv vv cv cop cop csn crn cuni vw cv vv cv cop vz cv
      vw cv vv cv cop vz visset vw cv vv cv opex op2nda sneqi dmeqi unieqi vw
      cv vv cv vw visset op1sta eqtri syl6req opeq12d vy cv vz cv vw cv vv cv
      cop cop wceq vy cv csn crn cuni csn crn cuni vz cv vw cv vv cv cop cop
      csn crn cuni csn crn cuni vv cv vy cv vz cv vw cv vv cv cop cop wceq vy
      cv csn crn cuni csn crn vz cv vw cv vv cv cop cop csn crn cuni csn crn vy
      cv vz cv vw cv vv cv cop cop wceq vy cv csn crn cuni csn vz cv vw cv vv
      cv cop cop csn crn cuni csn vy cv vz cv vw cv vv cv cop cop wceq vy cv
      csn crn cuni vz cv vw cv vv cv cop cop csn crn cuni vy cv vz cv vw cv vv
      cv cop cop wceq vy cv csn crn vz cv vw cv vv cv cop cop csn crn vy cv vz
      cv vw cv vv cv cop cop wceq vy cv csn vz cv vw cv vv cv cop cop csn vy cv
      vz cv vw cv vv cv cop cop sneq rneqd unieqd sneqd rneqd unieqd vz cv vw
      cv vv cv cop cop csn crn cuni csn crn cuni vw cv vv cv cop csn crn cuni
      vv cv vz cv vw cv vv cv cop cop csn crn cuni csn crn vw cv vv cv cop csn
      crn vz cv vw cv vv cv cop cop csn crn cuni csn vw cv vv cv cop csn vz cv
      vw cv vv cv cop cop csn crn cuni vw cv vv cv cop vz cv vw cv vv cv cop vz
      visset vw cv vv cv opex op2nda sneqi rneqi unieqi vw cv vv cv vw visset
      vv visset op2nda eqtri syl6req opeq12d eq2tri vz cv cA wcel vw cv cB wcel
      vv cv cC wcel anass anbi12i vx cv vz cv vw cv cop vv cv cop wceq vz cv cA
      wcel vw cv cB wcel wa vv cv cC wcel wa vy cv vx cv csn cdm cuni csn cdm
      cuni vx cv csn cdm cuni csn crn cuni vx cv csn crn cuni cop cop wceq an23
      vy cv vz cv vw cv vv cv cop cop wceq vz cv cA wcel vw cv cB wcel vv cv cC
      wcel wa wa vx cv vy cv csn cdm cuni vy cv csn crn cuni csn cdm cuni cop
      vy cv csn crn cuni csn crn cuni cop wceq an23 3bitr4i exbii vx cv vz cv
      vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa
      wa vy cv vx cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni
      vx cv csn crn cuni cop cop wceq vv 19.41v vy cv vz cv vw cv vv cv cop cop
      wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vx cv vy cv csn
      cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn
      cuni cop wceq vv 19.41v 3bitr3i 2exbii vx cv vz cv vw cv cop vv cv cop
      wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel wa wa vv wex vy cv vx
      cv csn cdm cuni csn cdm cuni vx cv csn cdm cuni csn crn cuni vx cv csn
      crn cuni cop cop wceq vz vw 19.41vv vy cv vz cv vw cv vv cv cop cop wceq
      vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vv wex vx cv vy cv csn
      cdm cuni vy cv csn crn cuni csn cdm cuni cop vy cv csn crn cuni csn crn
      cuni cop wceq vz vw 19.41vv 3bitr3i vx cv cA cB cxp cC cxp wcel vx cv vz
      cv vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel
      wa wa vv wex vw wex vz wex vy cv vx cv csn cdm cuni csn cdm cuni vx cv
      csn cdm cuni csn crn cuni vx cv csn crn cuni cop cop wceq vx cv cA cB cxp
      cC cxp wcel vx cv vu cv vv cv cop wceq vu cv cA cB cxp wcel vv cv cC wcel
      wa wa vv wex vu wex vx cv vu cv vv cv cop wceq vu cv cA cB cxp wcel vv cv
      cC wcel wa wa vu wex vv wex vx cv vz cv vw cv cop vv cv cop wceq vz cv cA
      wcel vw cv cB wcel wa vv cv cC wcel wa wa vv wex vw wex vz wex vu vv vx
      cv cA cB cxp cC elxp vx cv vu cv vv cv cop wceq vu cv cA cB cxp wcel vv
      cv cC wcel wa wa vu vv excom vx cv vu cv vv cv cop wceq vu cv cA cB cxp
      wcel vv cv cC wcel wa wa vu wex vv wex vu cv vz cv vw cv cop wceq vz cv
      cA wcel vw cv cB wcel wa wa vx cv vu cv vv cv cop wceq vv cv cC wcel wa
      wa vw wex vz wex vu wex vv wex vu cv vz cv vw cv cop wceq vz cv cA wcel
      vw cv cB wcel wa wa vx cv vu cv vv cv cop wceq vv cv cC wcel wa wa vu wex
      vv wex vw wex vz wex vx cv vz cv vw cv cop vv cv cop wceq vz cv cA wcel
      vw cv cB wcel wa vv cv cC wcel wa wa vv wex vw wex vz wex vx cv vu cv vv
      cv cop wceq vu cv cA cB cxp wcel vv cv cC wcel wa wa vu cv vz cv vw cv
      cop wceq vz cv cA wcel vw cv cB wcel wa wa vx cv vu cv vv cv cop wceq vv
      cv cC wcel wa wa vw wex vz wex vv vu vu cv cA cB cxp wcel vx cv vu cv vv
      cv cop wceq vv cv cC wcel wa wa vu cv vz cv vw cv cop wceq vz cv cA wcel
      vw cv cB wcel wa wa vw wex vz wex vx cv vu cv vv cv cop wceq vv cv cC
      wcel wa wa vx cv vu cv vv cv cop wceq vu cv cA cB cxp wcel vv cv cC wcel
      wa wa vu cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vx cv
      vu cv vv cv cop wceq vv cv cC wcel wa wa vw wex vz wex vu cv cA cB cxp
      wcel vu cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vw wex
      vz wex vx cv vu cv vv cv cop wceq vv cv cC wcel wa vz vw vu cv cA cB elxp
      anbi1i vx cv vu cv vv cv cop wceq vu cv cA cB cxp wcel vv cv cC wcel an12
      vu cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vx cv vu cv
      vv cv cop wceq vv cv cC wcel wa vz vw 19.41vv 3bitr4i 2exbii vu cv vz cv
      vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vx cv vu cv vv cv cop
      wceq vv cv cC wcel wa wa vv vu vz vw exrot4 vu cv vz cv vw cv cop wceq vz
      cv cA wcel vw cv cB wcel wa wa vx cv vu cv vv cv cop wceq vv cv cC wcel
      wa wa vu wex vx cv vz cv vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB
      wcel wa vv cv cC wcel wa wa vz vw vv vu cv vz cv vw cv cop wceq vz cv cA
      wcel vw cv cB wcel wa wa vx cv vu cv vv cv cop wceq vv cv cC wcel wa wa
      vu wex vu cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa vx cv vu
      cv vv cv cop wceq vv cv cC wcel wa wa wa vu wex vz cv cA wcel vw cv cB
      wcel wa vx cv vz cv vw cv cop vv cv cop wceq vv cv cC wcel wa wa vx cv vz
      cv vw cv cop vv cv cop wceq vz cv cA wcel vw cv cB wcel wa vv cv cC wcel
      wa wa vu cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa wa vx cv
      vu cv vv cv cop wceq vv cv cC wcel wa wa vu cv vz cv vw cv cop wceq vz cv
      cA wcel vw cv cB wcel wa vx cv vu cv vv cv cop wceq vv cv cC wcel wa wa
      wa vu vu cv vz cv vw cv cop wceq vz cv cA wcel vw cv cB wcel wa vx cv vu
      cv vv cv cop wceq vv cv cC wcel wa anass exbii vz cv cA wcel vw cv cB
      wcel wa vx cv vu cv vv cv cop wceq vv cv cC wcel wa wa vz cv cA wcel vw
      cv cB wcel wa vx cv vz cv vw cv cop vv cv cop wceq vv cv cC wcel wa wa vu
      vz cv vw cv cop vz cv vw cv opex vu cv vz cv vw cv cop wceq vx cv vu cv
      vv cv cop wceq vv cv cC wcel wa vx cv vz cv vw cv cop vv cv cop wceq vv
      cv cC wcel wa vz cv cA wcel vw cv cB wcel wa vu cv vz cv vw cv cop wceq
      vx cv vu cv vv cv cop wceq vx cv vz cv vw cv cop vv cv cop wceq vv cv cC
      wcel vu cv vz cv vw cv cop wceq vu cv vv cv cop vz cv vw cv cop vv cv cop
      vx cv vu cv vz cv vw cv cop vv cv opeq1 eqeq2d anbi1d anbi2d ceqsexv vz
      cv cA wcel vw cv cB wcel wa vx cv vz cv vw cv cop vv cv cop wceq vv cv cC
      wcel an12 3bitri 3exbii 3bitri 3bitri anbi1i vy cv cA cB cC cxp cxp wcel
      vy cv vz cv vw cv vv cv cop cop wceq vz cv cA wcel vw cv cB wcel vv cv cC
      wcel wa wa wa vv wex vw wex vz wex vx cv vy cv csn cdm cuni vy cv csn crn
      cuni csn cdm cuni cop vy cv csn crn cuni csn crn cuni cop wceq vy cv cA
      cB cC cxp cxp wcel vy cv vz cv vu cv cop wceq vz cv cA wcel vu cv cB cC
      cxp wcel wa wa vu wex vz wex vy cv vz cv vw cv vv cv cop cop wceq vz cv
      cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vv wex vw wex vz wex vz vu
      vy cv cA cB cC cxp elxp vy cv vz cv vu cv cop wceq vz cv cA wcel vu cv cB
      cC cxp wcel wa wa vu wex vy cv vz cv vw cv vv cv cop cop wceq vz cv cA
      wcel vw cv cB wcel vv cv cC wcel wa wa wa vv wex vw wex vz vy cv vz cv vu
      cv cop wceq vz cv cA wcel vu cv cB cC cxp wcel wa wa vu wex vu cv vw cv
      vv cv cop wceq vy cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB wcel vv
      cv cC wcel wa wa wa wa vv wex vw wex vu wex vu cv vw cv vv cv cop wceq vy
      cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa
      wa wa vu wex vv wex vw wex vy cv vz cv vw cv vv cv cop cop wceq vz cv cA
      wcel vw cv cB wcel vv cv cC wcel wa wa wa vv wex vw wex vy cv vz cv vu cv
      cop wceq vz cv cA wcel vu cv cB cC cxp wcel wa wa vu cv vw cv vv cv cop
      wceq vy cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel
      wa wa wa wa vv wex vw wex vu vy cv vz cv vu cv cop wceq vz cv cA wcel wa
      vu cv cB cC cxp wcel wa vy cv vz cv vu cv cop wceq vz cv cA wcel wa vu cv
      vw cv vv cv cop wceq vw cv cB wcel vv cv cC wcel wa wa vv wex vw wex wa
      vy cv vz cv vu cv cop wceq vz cv cA wcel vu cv cB cC cxp wcel wa wa vu cv
      vw cv vv cv cop wceq vy cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB
      wcel vv cv cC wcel wa wa wa wa vv wex vw wex vu cv cB cC cxp wcel vu cv
      vw cv vv cv cop wceq vw cv cB wcel vv cv cC wcel wa wa vv wex vw wex vy
      cv vz cv vu cv cop wceq vz cv cA wcel wa vw vv vu cv cB cC elxp anbi2i vy
      cv vz cv vu cv cop wceq vz cv cA wcel vu cv cB cC cxp wcel anass vy cv vz
      cv vu cv cop wceq vz cv cA wcel wa vu cv vw cv vv cv cop wceq vw cv cB
      wcel vv cv cC wcel wa wa vv wex vw wex wa vy cv vz cv vu cv cop wceq vz
      cv cA wcel wa vu cv vw cv vv cv cop wceq vw cv cB wcel vv cv cC wcel wa
      wa wa vv wex vw wex vu cv vw cv vv cv cop wceq vy cv vz cv vu cv cop wceq
      vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa wa vv wex vw wex vy cv
      vz cv vu cv cop wceq vz cv cA wcel wa vu cv vw cv vv cv cop wceq vw cv cB
      wcel vv cv cC wcel wa wa vw vv 19.42vv vy cv vz cv vu cv cop wceq vz cv
      cA wcel wa vu cv vw cv vv cv cop wceq vw cv cB wcel vv cv cC wcel wa wa
      wa vu cv vw cv vv cv cop wceq vy cv vz cv vu cv cop wceq vz cv cA wcel vw
      cv cB wcel vv cv cC wcel wa wa wa wa vw vv vy cv vz cv vu cv cop wceq vz
      cv cA wcel wa vu cv vw cv vv cv cop wceq vw cv cB wcel vv cv cC wcel wa
      wa wa vu cv vw cv vv cv cop wceq vy cv vz cv vu cv cop wceq vz cv cA wcel
      wa vw cv cB wcel vv cv cC wcel wa wa wa vu cv vw cv vv cv cop wceq vy cv
      vz cv vu cv cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa
      wa vy cv vz cv vu cv cop wceq vz cv cA wcel wa vu cv vw cv vv cv cop wceq
      vw cv cB wcel vv cv cC wcel wa an12 vy cv vz cv vu cv cop wceq vz cv cA
      wcel wa vw cv cB wcel vv cv cC wcel wa wa vy cv vz cv vu cv cop wceq vz
      cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa vu cv vw cv vv cv cop
      wceq vy cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel
      wa anass anbi2i bitri 2exbii bitr3i 3bitr3i exbii vu cv vw cv vv cv cop
      wceq vy cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel
      wa wa wa wa vu vw vv exrot3 vu cv vw cv vv cv cop wceq vy cv vz cv vu cv
      cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa wa wa vu wex vy
      cv vz cv vw cv vv cv cop cop wceq vz cv cA wcel vw cv cB wcel vv cv cC
      wcel wa wa wa vw vv vy cv vz cv vu cv cop wceq vz cv cA wcel vw cv cB
      wcel vv cv cC wcel wa wa wa vy cv vz cv vw cv vv cv cop cop wceq vz cv cA
      wcel vw cv cB wcel vv cv cC wcel wa wa wa vu vw cv vv cv cop vw cv vv cv
      opex vu cv vw cv vv cv cop wceq vy cv vz cv vu cv cop wceq vy cv vz cv vw
      cv vv cv cop cop wceq vz cv cA wcel vw cv cB wcel vv cv cC wcel wa wa vu
      cv vw cv vv cv cop wceq vz cv vu cv cop vz cv vw cv vv cv cop cop vy cv
      vu cv vw cv vv cv cop vz cv opeq2 eqeq2d anbi1d ceqsexv 2exbii 3bitri
      exbii bitri anbi1i 3bitr4i en2 $.
      $( [5-Jul-2004] $) $( [22-Jan-2004] $)
  $}

  ${
    $d t A $.  $d t x y z w v u f B $.  $d t x y z w v u f C $.
    xpdom.1 $e |- B e. _V $.
    xpdom.2 $e |- C e. _V $.
    $( Dominance law for cross product.  Proposition 10.33(2) of
       [TakeutiZaring] p. 92. $)
    xpdom2 $p |- ( A ~<_ B -> ( C X. A ) ~<_ ( C X. B ) ) $=
      cA cvv wcel cA cB cdom wbr cC cA cxp cC cB cxp cdom wbr cA cB cdom reldom
      brrelexi vt cv cB cdom wbr cC vt cv cxp cC cB cxp cdom wbr wi cA cB cdom
      wbr cC cA cxp cC cB cxp cdom wbr wi vt cA cvv vt cv cA wceq vt cv cB cdom
      wbr cA cB cdom wbr cC vt cv cxp cC cB cxp cdom wbr cC cA cxp cC cB cxp
      cdom wbr vt cv cA cB cdom breq1 vt cv cA wceq cC vt cv cxp cC cA cxp cC
      cB cxp cdom vt cv cA cC xpeq2 breq1d imbi12d vt cv cB cdom wbr vt cv cB
      vf cv wf1 vf wex cC vt cv cxp cC cB cxp cdom wbr vt cv cB vf xpdom.1
      brdom vt cv cB vf cv wf1 cC vt cv cxp cC cB cxp cdom wbr vf vt cv cB vf
      cv wf1 cC vt cv cxp cvv wcel cC vt cv cxp cC cB cxp cdom wbr cC vt cv
      xpdom.2 vt visset xpex vt cv cB vf cv wf1 vx vy cC vt cv cxp cC cB cxp vx
      cv csn cdm cuni vx cv csn crn cuni vf cv cfv cop vy cv csn cdm cuni vy cv
      csn crn cuni vf cv cfv cop cvv vt cv cB vf cv wf1 vx cv vx cv csn cdm
      cuni vx cv csn crn cuni cop wceq vx cv csn cdm cuni cC wcel vx cv csn crn
      cuni vt cv wcel wa wa vx cv csn cdm cuni cC wcel vx cv csn crn cuni vf cv
      cfv cB wcel wa vx cv cC vt cv cxp wcel vx cv csn cdm cuni vx cv csn crn
      cuni vf cv cfv cop cC cB cxp wcel vt cv cB vf cv wf1 vx cv csn cdm cuni
      cC wcel vx cv csn crn cuni vt cv wcel wa vx cv csn cdm cuni cC wcel vx cv
      csn crn cuni vf cv cfv cB wcel wa vx cv vx cv csn cdm cuni vx cv csn crn
      cuni cop wceq vt cv cB vf cv wf1 vx cv csn crn cuni vt cv wcel vx cv csn
      crn cuni vf cv cfv cB wcel vx cv csn cdm cuni cC wcel vt cv cB vf cv wf1
      vt cv cB vf cv wf vx cv csn crn cuni vt cv wcel vx cv csn crn cuni vf cv
      cfv cB wcel wi vt cv cB vf cv f1f vt cv cB vf cv wf vx cv csn crn cuni vt
      cv wcel vx cv csn crn cuni vf cv cfv cB wcel vt cv cB vx cv csn crn cuni
      vf cv ffvelrn ex syl anim2d adantld vx cv cC vt cv elxp4 vx cv csn cdm
      cuni vx cv csn crn cuni vf cv cfv cC cB vx cv csn crn cuni vf cv fvex
      opelxp 3imtr4g vx cv cC vt cv cxp wcel vy cv cC vt cv cxp wcel wa vt cv
      cB vf cv wf1 vx cv csn cdm cuni vx cv csn crn cuni vf cv cfv cop vy cv
      csn cdm cuni vy cv csn crn cuni vf cv cfv cop wceq vx cv vy cv wceq wb vx
      cv vz cv vw cv cop wceq vw vt cv wrex vz cC wrex vy cv vv cv vu cv cop
      wceq vu vt cv wrex vv cC wrex vt cv cB vf cv wf1 vx cv csn cdm cuni vx cv
      csn crn cuni vf cv cfv cop vy cv csn cdm cuni vy cv csn crn cuni vf cv
      cfv cop wceq vx cv vy cv wceq wb wi vx cv cC vt cv cxp wcel vy cv cC vt
      cv cxp wcel vx cv vz cv vw cv cop wceq vw vt cv wrex vz cC wrex vy cv vv
      cv vu cv cop wceq vu vt cv wrex vv cC wrex vt cv cB vf cv wf1 vx cv csn
      cdm cuni vx cv csn crn cuni vf cv cfv cop vy cv csn cdm cuni vy cv csn
      crn cuni vf cv cfv cop wceq vx cv vy cv wceq wb wi vx cv vz cv vw cv cop
      wceq vw vt cv wrex vz cC wrex vy cv vv cv vu cv cop wceq vt cv cB vf cv
      wf1 vx cv csn cdm cuni vx cv csn crn cuni vf cv cfv cop vy cv csn cdm
      cuni vy cv csn crn cuni vf cv cfv cop wceq vx cv vy cv wceq wb wi vv vu
      cC vt cv vx cv vz cv vw cv cop wceq vv cv cC wcel vu cv vt cv wcel wa vy
      cv vv cv vu cv cop wceq vt cv cB vf cv wf1 vx cv csn cdm cuni vx cv csn
      crn cuni vf cv cfv cop vy cv csn cdm cuni vy cv csn crn cuni vf cv cfv
      cop wceq vx cv vy cv wceq wb wi wi wi vz vw cC vt cv vz cv cC wcel vw cv
      vt cv wcel wa vv cv cC wcel vu cv vt cv wcel wa vx cv vz cv vw cv cop
      wceq vy cv vv cv vu cv cop wceq vt cv cB vf cv wf1 vx cv csn cdm cuni vx
      cv csn crn cuni vf cv cfv cop vy cv csn cdm cuni vy cv csn crn cuni vf cv
      cfv cop wceq vx cv vy cv wceq wb wi wi vz cv cC wcel vw cv vt cv wcel wa
      vv cv cC wcel vu cv vt cv wcel wa vx cv vz cv vw cv cop wceq vy cv vv cv
      vu cv cop wceq vt cv cB vf cv wf1 vx cv csn cdm cuni vx cv csn crn cuni
      vf cv cfv cop vy cv csn cdm cuni vy cv csn crn cuni vf cv cfv cop wceq vx
      cv vy cv wceq wb wi vz cv cC wcel vw cv vt cv wcel wa vv cv cC wcel vu cv
      vt cv wcel wa wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa
      wa vt cv cB vf cv wf1 vx cv csn cdm cuni vx cv csn crn cuni vf cv cfv cop
      vy cv csn cdm cuni vy cv csn crn cuni vf cv cfv cop wceq vx cv vy cv wceq
      wb vz cv cC wcel vw cv vt cv wcel wa vv cv cC wcel vu cv vt cv wcel wa wa
      vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa wa vt cv cB vf
      cv wf1 wa vz cv vw cv vf cv cfv cop vv cv vu cv vf cv cfv cop wceq vz cv
      vv cv wceq vw cv vu cv wceq wa vx cv csn cdm cuni vx cv csn crn cuni vf
      cv cfv cop vy cv csn cdm cuni vy cv csn crn cuni vf cv cfv cop wceq vx cv
      vy cv wceq vz cv cC wcel vw cv vt cv wcel wa vv cv cC wcel vu cv vt cv
      wcel wa wa vt cv cB vf cv wf1 vz cv vw cv vf cv cfv cop vv cv vu cv vf cv
      cfv cop wceq vz cv vv cv wceq vw cv vu cv wceq wa wb vx cv vz cv vw cv
      cop wceq vy cv vv cv vu cv cop wceq wa vz cv cC wcel vw cv vt cv wcel wa
      vv cv cC wcel vu cv vt cv wcel wa wa vt cv cB vf cv wf1 vz cv vw cv vf cv
      cfv cop vv cv vu cv vf cv cfv cop wceq vz cv vv cv wceq vw cv vu cv wceq
      wa wb vw cv vt cv wcel vu cv vt cv wcel vt cv cB vf cv wf1 vz cv vw cv vf
      cv cfv cop vv cv vu cv vf cv cfv cop wceq vz cv vv cv wceq vw cv vu cv
      wceq wa wb wi vz cv cC wcel vv cv cC wcel vw cv vt cv wcel vu cv vt cv
      wcel wa vt cv cB vf cv wf1 vz cv vw cv vf cv cfv cop vv cv vu cv vf cv
      cfv cop wceq vz cv vv cv wceq vw cv vu cv wceq wa wb vw cv vt cv wcel vu
      cv vt cv wcel wa vt cv cB vf cv wf1 wa vz cv vv cv wceq vw cv vf cv cfv
      vu cv vf cv cfv wceq wa vz cv vv cv wceq vw cv vu cv wceq wa vz cv vw cv
      vf cv cfv cop vv cv vu cv vf cv cfv cop wceq vw cv vt cv wcel vu cv vt cv
      wcel wa vt cv cB vf cv wf1 wa vw cv vf cv cfv vu cv vf cv cfv wceq vw cv
      vu cv wceq vz cv vv cv wceq vt cv cB vf cv wf1 vw cv vt cv wcel vu cv vt
      cv wcel wa vw cv vf cv cfv vu cv vf cv cfv wceq vw cv vu cv wceq wb vt cv
      cB vw cv vu cv vf cv f1fveq ancoms anbi2d vz cv vw cv vf cv cfv vv cv vu
      cv vf cv cfv vz visset vw cv vf cv fvex vu cv vf cv fvex opth syl5bb ex
      ad2ant2l imp adantlr vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop
      wceq wa vx cv csn cdm cuni vx cv csn crn cuni vf cv cfv cop vy cv csn cdm
      cuni vy cv csn crn cuni vf cv cfv cop wceq vz cv vw cv vf cv cfv cop vv
      cv vu cv vf cv cfv cop wceq wb vz cv cC wcel vw cv vt cv wcel wa vv cv cC
      wcel vu cv vt cv wcel wa wa vt cv cB vf cv wf1 vx cv vz cv vw cv cop wceq
      vy cv vv cv vu cv cop wceq vx cv csn cdm cuni vx cv csn crn cuni vf cv
      cfv cop vz cv vw cv vf cv cfv cop vy cv csn cdm cuni vy cv csn crn cuni
      vf cv cfv cop vv cv vu cv vf cv cfv cop vx cv vz cv vw cv cop wceq vx cv
      csn cdm cuni vz cv vx cv csn crn cuni vf cv cfv vw cv vf cv cfv vx cv vz
      cv vw cv cop wceq vx cv csn cdm cuni vz cv vw cv cop csn cdm cuni vz cv
      vx cv vz cv vw cv cop wceq vx cv csn cdm vz cv vw cv cop csn cdm vx cv vz
      cv vw cv cop wceq vx cv csn vz cv vw cv cop csn vx cv vz cv vw cv cop
      sneq dmeqd unieqd vz cv vw cv vz visset op1sta syl6eq vx cv vz cv vw cv
      cop wceq vx cv csn crn cuni vw cv vf cv vx cv vz cv vw cv cop wceq vx cv
      csn crn cuni vz cv vw cv cop csn crn cuni vw cv vx cv vz cv vw cv cop
      wceq vx cv csn crn vz cv vw cv cop csn crn vx cv vz cv vw cv cop wceq vx
      cv csn vz cv vw cv cop csn vx cv vz cv vw cv cop sneq rneqd unieqd vz cv
      vw cv vz visset vw visset op2nda syl6eq fveq2d opeq12d vy cv vv cv vu cv
      cop wceq vy cv csn cdm cuni vv cv vy cv csn crn cuni vf cv cfv vu cv vf
      cv cfv vy cv vv cv vu cv cop wceq vy cv csn cdm cuni vv cv vu cv cop csn
      cdm cuni vv cv vy cv vv cv vu cv cop wceq vy cv csn cdm vv cv vu cv cop
      csn cdm vy cv vv cv vu cv cop wceq vy cv csn vv cv vu cv cop csn vy cv vv
      cv vu cv cop sneq dmeqd unieqd vv cv vu cv vv visset op1sta syl6eq vy cv
      vv cv vu cv cop wceq vy cv csn crn cuni vu cv vf cv vy cv vv cv vu cv cop
      wceq vy cv csn crn cuni vv cv vu cv cop csn crn cuni vu cv vy cv vv cv vu
      cv cop wceq vy cv csn crn vv cv vu cv cop csn crn vy cv vv cv vu cv cop
      wceq vy cv csn vv cv vu cv cop csn vy cv vv cv vu cv cop sneq rneqd
      unieqd vv cv vu cv vv visset vu visset op2nda syl6eq fveq2d opeq12d
      eqeqan12d ad2antlr vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq
      wa vx cv vy cv wceq vz cv vv cv wceq vw cv vu cv wceq wa wb vz cv cC wcel
      vw cv vt cv wcel wa vv cv cC wcel vu cv vt cv wcel wa wa vt cv cB vf cv
      wf1 vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vx cv vy cv
      wceq vz cv vw cv cop vv cv vu cv cop wceq vz cv vv cv wceq vw cv vu cv
      wceq wa vx cv vz cv vw cv cop vy cv vv cv vu cv cop eqeq12 vz cv vw cv vv
      cv vu cv vz visset vw visset vu visset opth syl6bb ad2antlr 3bitr4d ex
      exp43 com23 r19.23aivv r19.23advv imp vz vw vx cv cC vt cv elxp2 vv vu vy
      cv cC vt cv elxp2 syl2anb com12 dom2d mpi 19.23aiv sylbi vtoclg mpcom $.
      $( [29-Mar-2006] $) $( [24-Jul-2004] $)

    $( Dominance law for cross product.  Theorem 6L(c) of [Enderton] p. 149. $)
    xpdom1 $p |- ( A ~<_ B -> ( A X. C ) ~<_ ( B X. C ) ) $=
      cA cC cxp cC cB cxp cdom wbr cC cB cxp cB cC cxp cen wbr cA cC cxp cB cC
      cxp cdom wbr cA cB cdom wbr cA cC cxp cC cB cxp cB cC cxp domentr cA cC
      cxp cC cA cxp cen wbr cC cA cxp cC cB cxp cdom wbr cA cC cxp cC cB cxp
      cdom wbr cA cB cdom wbr cA cC cxp cC cA cxp cC cB cxp endomtr cA cvv wcel
      cC cvv wcel cA cC cxp cC cA cxp cen wbr cA cB cdom wbr cA cC cvv cvv
      xpcomeng cA cB cdom reldom brrelexi xpdom.2 sylancl cA cB cC xpdom.1
      xpdom.2 xpdom2 sylanc cC cB xpdom.2 xpdom.1 xpcomen sylancl $.
      $( [29-Mar-2006] $) $( [28-Sep-2004] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d z C $.
    $( Dominance law for cross product.  Theorem 6L(c) of [Enderton] p. 149. $)
    xpdom1g $p |- ( ( B e. R /\ C e. S /\ A ~<_ B ) ->
                  ( A X. C ) ~<_ ( B X. C ) ) $=
      cB cR wcel cC cS wcel cA cB cdom wbr cA cC cxp cB cC cxp cdom wbr cA vy
      cv cdom wbr cA vz cv cxp vy cv vz cv cxp cdom wbr wi cA cB cdom wbr cA vz
      cv cxp cB vz cv cxp cdom wbr wi cA cB cdom wbr cA cC cxp cB cC cxp cdom
      wbr wi vy vz cB cC cR cS vy cv cB wceq cA vy cv cdom wbr cA cB cdom wbr
      cA vz cv cxp vy cv vz cv cxp cdom wbr cA vz cv cxp cB vz cv cxp cdom wbr
      vy cv cB cA cdom breq2 vy cv cB wceq vy cv vz cv cxp cB vz cv cxp cA vz
      cv cxp cdom vy cv cB vz cv xpeq1 breq2d imbi12d vz cv cC wceq cA vz cv
      cxp cB vz cv cxp cdom wbr cA cC cxp cB cC cxp cdom wbr cA cB cdom wbr vz
      cv cC wceq cA vz cv cxp cA cC cxp cB vz cv cxp cB cC cxp cdom vz cv cC cA
      xpeq2 vz cv cC cB xpeq2 breq12d imbi2d cA vy cv vz cv vy visset vz visset
      xpdom1 vtocl2g 3impia $.
      $( [30-Mar-2006] $) $( [25-Mar-2006] $)
  $}

  ${
    $d x A $.  $d x B $.
    xpdom3.1 $e |- A e. _V $.
    $( A set is dominated by its cross product with a non-empty set.  Exercise
       6 of [Suppes] p. 98. $)
    xpdom3 $p |- ( B =/= (/) -> A ~<_ ( A X. B ) ) $=
      cB c0 wne vx cv cB wcel vx wex cA cA cB cxp cdom wbr vx cB n0 vx cv cB
      wcel cA cA cB cxp cdom wbr vx vx cv cB wcel vx cv csn cB wss cA cA cB cxp
      cdom wbr vx cv cB vx visset snss vx cv csn cB wss cA vx cv csn cxp cA cB
      cxp wss cA vx cv csn cxp cA cB cxp cdom wbr cA cA cB cxp cdom wbr cA cA
      wss vx cv csn cB wss cA vx cv csn cxp cA cB cxp wss cA ssid cA cA vx cv
      csn cB ssxp mpan cA vx cv csn cxp cvv wcel cA vx cv csn cxp cA cB cxp wss
      cA vx cv csn cxp cA cB cxp cdom wbr wi cA vx cv csn xpdom3.1 vx cv snex
      xpex cA vx cv csn cxp cA cB cxp cvv ssdomg ax-mp cA cA vx cv csn cxp cen
      wbr cA vx cv csn cxp cA cB cxp cdom wbr cA cA cB cxp cdom wbr cA vx cv
      csn cxp cA xpdom3.1 cA vx cv xpdom3.1 vx visset xpsnen ensymi cA cA vx cv
      csn cxp cA cB cxp endomtr mpan 3syl sylbi 19.23aiv sylbi $.
      $( [24-Nov-2006] $) $( [27-Jul-2004] $)
  $}

  ${
    $d x y z w v u A $.
    pw2en.1 $e |- A e. _V $.
    $( The power set of a set is equinumerous to set exponentiation with a base
       of ordinal 2.  Proposition 10.44 of [TakeutiZaring] p. 96.  (This proof
       seems excessively long.  An attempt to find a shorter one is on my to-do
       list.) $)
    pw2en $p |- ~P A ~~ ( 2o ^m A ) $=
      vx vy cA cpw c2o cA cm co vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv
      wcel wa vv cab wceq wa vz vw copab vy cv ccnv c0 csn csn cima cA pw2en.1
      pwex vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa
      vz vw copab cvv wcel vx cv cA cpw wcel vz vw cA vv cv c0 wceq vz cv vx cv
      wcel wa vv cab pw2en.1 opabex2 a1i vy cv ccnv c0 csn csn cima cvv wcel vy
      cv c2o cA cm co wcel vy cv ccnv cvv wcel vy cv ccnv c0 csn csn cima cvv
      wcel vy cv vy visset cnvex vy cv ccnv c0 csn csn cvv imaexg ax-mp a1i vx
      cv cA cpw wcel vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel
      wa vv cab wceq wa vz vw copab wceq wa vx cv vy cv ccnv c0 csn csn cima
      wceq vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab
      wceq wa vz vw copab wceq wa vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv
      vx cv wcel wa vv cab wceq wa vz vw copab wceq vx cv vy cv ccnv c0 csn csn
      cima wceq wa vy cv c2o cA cm co wcel vx cv vy cv ccnv c0 csn csn cima
      wceq wa vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv
      cab wceq wa vz vw copab wceq vx cv cA cpw wcel vx cv vy cv ccnv c0 csn
      csn cima wceq vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa
      vv cab wceq wa vz vw copab wceq vx cv cA wss vx cv vy cv ccnv c0 csn csn
      cima wceq vx cv cA cpw wcel vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv
      vx cv wcel wa vv cab wceq wa vz vw copab wceq vx cv cA wss vx cv vy cv
      ccnv c0 csn csn cima wceq vx cv cA wss cA vx cv cin vy cv ccnv c0 csn csn
      cima wceq vx cv vy cv ccnv c0 csn csn cima wceq vy cv vz cv cA wcel vw cv
      vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab wceq vx cv
      cA wss cA vx cv cin vx cv vy cv ccnv c0 csn csn cima vx cv cA wss cA vx
      cv cin vx cv wceq vx cv cA sseqin2 biimpi eqeq1d vy cv vz cv cA wcel vw
      cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab wceq vu
      cA vx cv cin vy cv ccnv c0 csn csn cima vy cv vz cv cA wcel vw cv vv cv
      c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab wceq vu cv vy cv
      ccnv c0 csn csn cima wcel vu cv c0 csn cop vz cv cA wcel vw cv vv cv c0
      wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab wcel vu cv cA vx cv
      cin wcel vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv
      cab wceq wa vz vw copab wceq vu cv c0 csn cop vy cv wcel vu cv c0 csn cop
      vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz
      vw copab wcel vu cv vy cv ccnv c0 csn csn cima wcel vy cv vz cv cA wcel
      vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab vu cv
      c0 csn cop eleq2 vu cv vy cv ccnv c0 csn csn cima wcel c0 csn vu cv cop
      vy cv ccnv wcel vu cv c0 csn cop vy cv wcel vy cv ccnv c0 csn vu cv p0ex
      vu visset elimasn c0 csn vu cv vy cv p0ex vu visset opelcnv bitri syl5bb
      vu cv cA wcel vu cv vx cv wcel wa vu cv cA wcel c0 csn vv cv c0 wceq vu
      cv vx cv wcel wa vv cab wceq wa vu cv cA vx cv cin wcel vu cv c0 csn cop
      vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz
      vw copab wcel vu cv vx cv wcel c0 csn vv cv c0 wceq vu cv vx cv wcel wa
      vv cab wceq vu cv cA wcel vv cv c0 wceq vv cab vv cv c0 wceq vu cv vx cv
      wcel wa vv cab wceq vv cv c0 wceq vv cv c0 wceq vu cv vx cv wcel wa wb vv
      wal c0 csn vv cv c0 wceq vu cv vx cv wcel wa vv cab wceq vu cv vx cv wcel
      vv cv c0 wceq vv cv c0 wceq vu cv vx cv wcel wa vv eq2ab c0 csn vv cv c0
      wceq vv cab vv cv c0 wceq vu cv vx cv wcel wa vv cab vv c0 df-sn eqeq1i
      vu cv vx cv wcel vv cv c0 wceq vv cv c0 wceq vu cv vx cv wcel wa wb vv
      wal vu cv vx cv wcel vv cv c0 wceq vv cv c0 wceq vu cv vx cv wcel wa wb
      vv vu cv vx cv wcel vv cv c0 wceq iba 19.21aiv vv cv c0 wceq vv cv c0
      wceq vu cv vx cv wcel wa wb vv wal c0 c0 wceq c0 c0 wceq vu cv vx cv wcel
      wa wb vu cv vx cv wcel vv cv c0 wceq vv cv c0 wceq vu cv vx cv wcel wa wb
      c0 c0 wceq c0 c0 wceq vu cv vx cv wcel wa wb vv c0 0ex vv cv c0 wceq vv
      cv c0 wceq c0 c0 wceq vv cv c0 wceq vu cv vx cv wcel wa c0 c0 wceq vu cv
      vx cv wcel wa vv cv c0 c0 eqeq1 vv cv c0 wceq vv cv c0 wceq c0 c0 wceq vu
      cv vx cv wcel vv cv c0 c0 eqeq1 anbi1d bibi12d cla4v vu cv vx cv wcel c0
      c0 wceq vu cv vx cv wcel wi c0 c0 wceq c0 c0 wceq vu cv vx cv wcel wa wb
      c0 c0 wceq vu cv vx cv wcel c0 eqid a1bi c0 c0 wceq vu cv vx cv wcel
      pm4.71 bitri sylibr impbii 3bitr4ri anbi2i vu cv cA vx cv elin vz cv cA
      wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vu cv cA wcel
      vw cv vv cv c0 wceq vu cv vx cv wcel wa vv cab wceq wa vu cv cA wcel c0
      csn vv cv c0 wceq vu cv vx cv wcel wa vv cab wceq wa vz vw vu cv c0 csn
      vu visset p0ex vz cv vu cv wceq vz cv cA wcel vu cv cA wcel vw cv vv cv
      c0 wceq vz cv vx cv wcel wa vv cab wceq vw cv vv cv c0 wceq vu cv vx cv
      wcel wa vv cab wceq vz cv vu cv cA eleq1 vz cv vu cv wceq vv cv c0 wceq
      vz cv vx cv wcel wa vv cab vv cv c0 wceq vu cv vx cv wcel wa vv cab vw cv
      vz cv vu cv wceq vv cv c0 wceq vz cv vx cv wcel wa vv cv c0 wceq vu cv vx
      cv wcel wa vv vz cv vu cv wceq vz cv vx cv wcel vu cv vx cv wcel vv cv c0
      wceq vz cv vu cv vx cv eleq1 anbi2d abbidv eqeq2d anbi12d vw cv c0 csn
      wceq vw cv vv cv c0 wceq vu cv vx cv wcel wa vv cab wceq c0 csn vv cv c0
      wceq vu cv vx cv wcel wa vv cab wceq vu cv cA wcel vw cv c0 csn vv cv c0
      wceq vu cv vx cv wcel wa vv cab eqeq1 anbi2d opelopab 3bitr4i syl6rbbr
      eqrdv syl5cbi vx cv vy cv ccnv c0 csn csn cima wceq vx cv cA wss vy cv
      ccnv c0 csn csn cima cA wss vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv
      vx cv wcel wa vv cab wceq wa vz vw copab wceq vx cv vy cv ccnv c0 csn csn
      cima cA sseq1 vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa
      vv cab wceq wa vz vw copab wceq vy cv ccnv c0 csn csn cima vy cv ccnv crn
      wss vy cv ccnv c0 csn csn cima cA wss vy cv ccnv c0 csn csn imassrn vy cv
      vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz
      vw copab wceq vy cv ccnv crn cA vy cv ccnv c0 csn csn cima vy cv vz cv cA
      wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab
      wceq vy cv cdm cA vy cv ccnv crn vy cv vz cv cA wcel vw cv vv cv c0 wceq
      vz cv vx cv wcel wa vv cab wceq wa vz vw copab wceq vy cv cA wfn vy cv
      cdm cA wceq vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa
      vv cab wceq wa vz vw copab wceq vy cv cA wfn vz cv cA wcel vw cv vv cv c0
      wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab cA wfn vz vw cA vv cv
      c0 wceq vz cv vx cv wcel wa vv cab vz cv cA wcel vw cv vv cv c0 wceq vz
      cv vx cv wcel wa vv cab wceq wa vz vw copab vv cv c0 wceq vz cv vx cv
      wcel wa vv cab vv cv c0 wceq vv cab c0 csn vv cv c0 wceq vv cab cvv vv c0
      df-sn p0ex eqeltrri vv cv c0 wceq vz cv vx cv wcel wa vv cv c0 wceq vv vv
      cv c0 wceq vz cv vx cv wcel pm3.26 ss2abi ssexi vz cv cA wcel vw cv vv cv
      c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab eqid fnopab2 cA vy
      cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa
      vz vw copab fneq1 mpbiri cA vy cv fndm syl vy cv dfdm4 syl5eqr sseq2d
      mpbii syl5cbir impbid vx cv cA vx visset elpw syl5bb pm5.32ri vx cv vy cv
      ccnv c0 csn csn cima wceq vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv
      vx cv wcel wa vv cab wceq wa vz vw copab wceq ancom vx cv vy cv ccnv c0
      csn csn cima wceq vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv
      wcel wa vv cab wceq wa vz vw copab wceq vy cv c2o cA cm co wcel vx cv vy
      cv ccnv c0 csn csn cima wceq vy cv vz cv cA wcel vw cv vv cv c0 wceq vz
      cv vx cv wcel wa vv cab wceq wa vz vw copab wceq cA c2o vy cv wf vy cv
      c2o cA cm co wcel vx cv vy cv ccnv c0 csn csn cima wceq vy cv vz cv cA
      wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab
      wceq cA c2o vy cv wf vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv
      wcel wa vv cab wceq wa vz vw copab wceq cA c2o vy cv wf cA c2o vz cv cA
      wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab
      wf vz vw cA c2o vv cv c0 wceq vz cv vx cv wcel wa vv cab vz cv cA wcel vw
      cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab vz cv cA
      wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab
      eqid vv cv c0 wceq vz cv vx cv wcel wa vv cab c2o wcel vz cv cA wcel vz
      cv vx cv wcel vv cv c0 wceq vz cv vx cv wcel wa vv cab c2o wcel vz cv vx
      cv wcel vv cv c0 wceq vz cv vx cv wcel wa vv cab c0 csn c2o vz cv vx cv
      wcel vv cv c0 wceq vz cv vx cv wcel wa vv c0 csn vz cv vx cv wcel vv cv
      c0 wceq vv cv c0 wceq vz cv vx cv wcel wa vv cv c0 csn wcel vz cv vx cv
      wcel vv cv c0 wceq iba vv c0 elsn syl5bb abbi2dv c0 csn c0 c0 csn cpr c2o
      c0 c0 csn p0ex prid2 df2o2 eleqtrri syl6eqelr vz cv vx cv wcel wn vv cv
      c0 wceq vz cv vx cv wcel wa vv cab c0 c2o vz cv vx cv wcel vv cv c0 wceq
      vz cv vx cv wcel wa vv cab c0 vv cv c0 wceq vz cv vx cv wcel wa vv cab c0
      wne vv cv c0 wceq vz cv vx cv wcel wa vv wex vz cv vx cv wcel vv cv c0
      wceq vz cv vx cv wcel wa vv abn0 vv cv c0 wceq vz cv vx cv wcel wa vz cv
      vx cv wcel vv vv cv c0 wceq vz cv vx cv wcel pm3.27 19.23aiv sylbi
      necon1bi c0 c0 c0 csn cpr c2o c0 c0 csn 0ex prid1 df2o2 eleqtrri syl6eqel
      pm2.61i a1i fopab cA c2o vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx
      cv wcel wa vv cab wceq wa vz vw copab feq1 mpbiri vx cv vy cv ccnv c0 csn
      csn cima wceq cA c2o vy cv wf vy cv vz cv cA wcel vw cv vv cv c0 wceq vz
      cv vx cv wcel wa vv cab wceq wa vz vw copab wceq vx cv vy cv ccnv c0 csn
      csn cima wceq cA c2o vy cv wf wa vy cv vz cv cA wcel vw cv vv cv c0 wceq
      vz cv vx cv wcel wa vv cab wceq wa vz vw copab wceq vz cv vy cv cfv vz cv
      vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz
      vw copab cfv wceq vz cA wral vx cv vy cv ccnv c0 csn csn cima wceq cA c2o
      vy cv wf wa vz cv vy cv cfv vz cv vz cv cA wcel vw cv vv cv c0 wceq vz cv
      vx cv wcel wa vv cab wceq wa vz vw copab cfv wceq vz cA vx cv vy cv ccnv
      c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel vz cv vy cv cfv vz cv
      vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz
      vw copab cfv wceq wi vx cv vy cv ccnv c0 csn csn cima wceq cA c2o vy cv
      wf vz cv cA wcel vz cv vy cv cfv vz cv vz cv cA wcel vw cv vv cv c0 wceq
      vz cv vx cv wcel wa vv cab wceq wa vz vw copab cfv wceq vx cv vy cv ccnv
      c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel wa wa vz cv vy cv cfv
      vv cv c0 wceq vz cv vx cv wcel wa vv cab vz cv vz cv cA wcel vw cv vv cv
      c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab cfv vx cv vy cv
      ccnv c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel wa wa vz cv vx cv
      wcel vz cv vy cv cfv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq vx cv
      vy cv ccnv c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel wa wa vz cv
      vx cv wcel wa vz cv vy cv cfv c0 csn vv cv c0 wceq vz cv vx cv wcel wa vv
      cab vx cv vy cv ccnv c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel
      wa wa vz cv vx cv wcel vz cv vy cv cfv c0 csn wceq vx cv vy cv ccnv c0
      csn csn cima wceq vz cv vx cv wcel vz cv c0 csn cop vy cv wcel cA c2o vy
      cv wf vz cv cA wcel wa vz cv vy cv cfv c0 csn wceq vx cv vy cv ccnv c0
      csn csn cima wceq vz cv vx cv wcel vz cv vy cv ccnv c0 csn csn cima wcel
      vz cv c0 csn cop vy cv wcel vx cv vy cv ccnv c0 csn csn cima vz cv eleq2
      vz cv vy cv ccnv c0 csn csn cima wcel c0 csn vz cv cop vy cv ccnv wcel vz
      cv c0 csn cop vy cv wcel vy cv ccnv c0 csn vz cv p0ex vz visset elimasn
      c0 csn vz cv vy cv p0ex vz visset opelcnv bitri syl6bb cA c2o vy cv wf vz
      cv cA wcel wa vz cv vy cv cfv c0 csn wceq vz cv c0 csn cop vy cv wcel vy
      cv cA wfn vz cv cA wcel vz cv vy cv cfv c0 csn wceq vz cv c0 csn cop vy
      cv wcel wb cA c2o vy cv wf cA vz cv c0 csn vy cv p0ex fnopfvb cA c2o vy
      cv ffn sylan bicomd sylan9bb biimpa vz cv vx cv wcel c0 csn vv cv c0 wceq
      vz cv vx cv wcel wa vv cab wceq vx cv vy cv ccnv c0 csn csn cima wceq cA
      c2o vy cv wf vz cv cA wcel wa wa vz cv vx cv wcel vv cv c0 wceq vz cv vx
      cv wcel wa vv c0 csn vz cv vx cv wcel vv cv c0 wceq vv cv c0 wceq vz cv
      vx cv wcel wa vv cv c0 csn wcel vz cv vx cv wcel vv cv c0 wceq iba vv c0
      elsn syl5bb abbi2dv adantl eqtrd vx cv vy cv ccnv c0 csn csn cima wceq cA
      c2o vy cv wf vz cv cA wcel wa wa vz cv vx cv wcel wn wa vz cv vy cv cfv
      c0 vv cv c0 wceq vz cv vx cv wcel wa vv cab vx cv vy cv ccnv c0 csn csn
      cima wceq cA c2o vy cv wf vz cv cA wcel wa wa vz cv vx cv wcel wn vz cv
      vy cv cfv c0 wceq vx cv vy cv ccnv c0 csn csn cima wceq cA c2o vy cv wf
      vz cv cA wcel wa wa vz cv vy cv cfv c0 wceq vz cv vx cv wcel vx cv vy cv
      ccnv c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel wa wa vz cv vy cv
      cfv c0 wceq wn vz cv vy cv cfv c0 csn wceq vz cv vx cv wcel cA c2o vy cv
      wf vz cv cA wcel wa vz cv vy cv cfv c0 wceq wn vz cv vy cv cfv c0 csn
      wceq wi vx cv vy cv ccnv c0 csn csn cima wceq cA c2o vy cv wf vz cv cA
      wcel wa vz cv vy cv cfv c0 wceq vz cv vy cv cfv c0 csn wceq cA c2o vy cv
      wf vz cv cA wcel wa vz cv vy cv cfv c2o wcel vz cv vy cv cfv c0 wceq vz
      cv vy cv cfv c0 csn wceq wo cA c2o vz cv vy cv ffvelrn vz cv vy cv cfv
      c2o wcel vz cv vy cv cfv c0 c0 csn cpr wcel vz cv vy cv cfv c0 wceq vz cv
      vy cv cfv c0 csn wceq wo c2o c0 c0 csn cpr vz cv vy cv cfv df2o2 eleq2i
      vz cv vy cv cfv c0 c0 csn vz cv vy cv fvex elpr bitri sylib ord adantl vx
      cv vy cv ccnv c0 csn csn cima wceq vz cv vx cv wcel vz cv c0 csn cop vy
      cv wcel cA c2o vy cv wf vz cv cA wcel wa vz cv vy cv cfv c0 csn wceq vx
      cv vy cv ccnv c0 csn csn cima wceq vz cv vx cv wcel vz cv vy cv ccnv c0
      csn csn cima wcel vz cv c0 csn cop vy cv wcel vx cv vy cv ccnv c0 csn csn
      cima vz cv eleq2 vz cv vy cv ccnv c0 csn csn cima wcel c0 csn vz cv cop
      vy cv ccnv wcel vz cv c0 csn cop vy cv wcel vy cv ccnv c0 csn vz cv p0ex
      vz visset elimasn c0 csn vz cv vy cv p0ex vz visset opelcnv bitri syl6bb
      cA c2o vy cv wf vz cv cA wcel wa vz cv vy cv cfv c0 csn wceq vz cv c0 csn
      cop vy cv wcel vy cv cA wfn vz cv cA wcel vz cv vy cv cfv c0 csn wceq vz
      cv c0 csn cop vy cv wcel wb cA c2o vy cv wf cA vz cv c0 csn vy cv p0ex
      fnopfvb cA c2o vy cv ffn sylan bicomd sylan9bb sylibrd con1d imp vz cv vx
      cv wcel wn vv cv c0 wceq vz cv vx cv wcel wa vv cab c0 wceq vx cv vy cv
      ccnv c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel wa wa vz cv vx cv
      wcel vv cv c0 wceq vz cv vx cv wcel wa vv cab c0 vv cv c0 wceq vz cv vx
      cv wcel wa vv cab c0 wne vv cv c0 wceq vz cv vx cv wcel wa vv wex vz cv
      vx cv wcel vv cv c0 wceq vz cv vx cv wcel wa vv abn0 vv cv c0 wceq vz cv
      vx cv wcel wa vz cv vx cv wcel vv vv cv c0 wceq vz cv vx cv wcel pm3.27
      19.23aiv sylbi necon1bi adantl eqtr4d pm2.61dan vz cv cA wcel vz cv vz cv
      cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw
      copab cfv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq vx cv vy cv ccnv
      c0 csn csn cima wceq cA c2o vy cv wf vz cv cA wcel vv cv c0 wceq vz cv vx
      cv wcel wa vv cab cvv wcel vz cv vz cv cA wcel vw cv vv cv c0 wceq vz cv
      vx cv wcel wa vv cab wceq wa vz vw copab cfv vv cv c0 wceq vz cv vx cv
      wcel wa vv cab wceq vv cv c0 wceq vz cv vx cv wcel wa vv cab vv cv c0
      wceq vv cab c0 csn vv cv c0 wceq vv cab cvv vv c0 df-sn p0ex eqeltrri vv
      cv c0 wceq vz cv vx cv wcel wa vv cv c0 wceq vv vv cv c0 wceq vz cv vx cv
      wcel pm3.26 ss2abi ssexi vz vw cA vv cv c0 wceq vz cv vx cv wcel wa vv
      cab cvv fvopab2 mpan2 ad2antll eqtr4d exp32 imp r19.21aiv cA c2o vy cv wf
      vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq
      wa vz vw copab wceq vz cv vy cv cfv vz cv vz cv cA wcel vw cv vv cv c0
      wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab cfv wceq vz cA wral
      wb vx cv vy cv ccnv c0 csn csn cima wceq vy cv cA wfn vz cv cA wcel vw cv
      vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw copab cA wfn vy cv
      vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz
      vw copab wceq vz cv vy cv cfv vz cv vz cv cA wcel vw cv vv cv c0 wceq vz
      cv vx cv wcel wa vv cab wceq wa vz vw copab cfv wceq vz cA wral wb cA c2o
      vy cv wf vz vu cA vy cv vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv
      wcel wa vv cab wceq wa vz vw copab vu cv vy cv wcel vz ax-17 vz cv cA
      wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab wceq wa vz vw vu
      hbopab1 eqfnfvf2 cA c2o vy cv ffn vz vw cA vv cv c0 wceq vz cv vx cv wcel
      wa vv cab vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv wcel wa vv cab
      wceq wa vz vw copab vv cv c0 wceq vz cv vx cv wcel wa vv cab vv cv c0
      wceq vv cab c0 csn vv cv c0 wceq vv cab cvv vv c0 df-sn p0ex eqeltrri vv
      cv c0 wceq vz cv vx cv wcel wa vv cv c0 wceq vv vv cv c0 wceq vz cv vx cv
      wcel pm3.26 ss2abi ssexi vz cv cA wcel vw cv vv cv c0 wceq vz cv vx cv
      wcel wa vv cab wceq wa vz vw copab eqid fnopab2 sylancl adantl mpbird ex
      impbid2 c2o cA vy cv c2o con0 2on elisseti pw2en.1 elmap syl6bbr pm5.32ri
      3bitri en2 $.
      $( [6-Jul-2004] $) $( [29-Jan-2004] $)
  $}

  ${
    $d f z B $.  $d f C $.  $d f ph $.  $d f x z $.
    ac6sfilem1.1 $e |- B e. _V $.
    ac6sfilem1.2 $e |- ( C = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Lemma for ~ ac6sfi . $)
    ac6sfilem1 $p |- ( C = ( B ` x ) -> ( ph <-> [ B / f ] ps ) ) $=
      cC vx cv vf cv cfv wceq wph wps wb wi cC vx cv cB cfv wceq wph wps vf cB
      wsbc wb wi vf cB cvv wcel cC vx cv vf cv cfv wceq wph wps wb wi vf wal cC
      vx cv cB cfv wceq wph wps vf cB wsbc wb wi wi ac6sfilem1.1 cC vx cv vf cv
      cfv wceq wph wps wb wi cC vx cv cB cfv wceq wph wps vf cB wsbc wb wi vf
      vz cB cvv vz cv cB wcel vf ax-17 cC vx cv cB cfv wceq wph wps vf cB wsbc
      wb vf cC vx cv cB cfv wceq vf ax-17 wph wps vf cB wsbc vf wph vf ax-17
      wps vf cB ac6sfilem1.1 hbsbc1v hbbi hbim vf cv cB wceq cC vx cv vf cv cfv
      wceq cC vx cv cB cfv wceq wph wps wb wph wps vf cB wsbc wb vf cv cB wceq
      vx cv vf cv cfv vx cv cB cfv cC vx cv vf cv cB fveq1 eqeq2d vf cv cB wceq
      wps wps vf cB wsbc wph wps vf cB sbceq1a bibi2d imbi12d cla4gf ax-mp
      ac6sfilem1.2 mpg $.
      $( [29-Jun-2009] $) $( [26-Jun-2009] $)
  $}

  ${
    ac6sfilem2.1 $e |- A e. _V $.
    $( Lemma for ~ ac6sfi . $)
    ac6sfilem2 $p |- ( F : suc A -1-1-onto-> B
         -> ( ( F " A ) u. { ( F ` A ) } ) = B ) $=
      cA csuc cB cF wf1o cA csuc cB cF wfo cF cA csuc wfn cF cA csuc cima cB
      wceq wa cF cA cima cA cF cfv csn cun cB wceq cA csuc cB cF f1ofo cA csuc
      cB cF wfo cF cA csuc wfn cF cA csuc cima cB wceq cA csuc cB cF fofn cA
      csuc cB cF foima jca cF cA csuc wfn cF cA csuc cima cB wceq cF cA cima cA
      cF cfv csn cun cB wceq cF cA csuc wfn cF cA csuc cima cF cA cima cA cF
      cfv csn cun cB cF cA csuc wfn cF cA csuc cima cF cA cA csn cun cima cF cA
      cima cF cA csn cima cun cF cA cima cA cF cfv csn cun cF cA csuc wfn cA
      csuc cA cA csn cun cF cA csuc cA cA csn cun wceq cF cA csuc wfn cA df-suc
      a1i imaeq2d cF cA cA csn cun cima cF cA cima cF cA csn cima cun wceq cF
      cA csuc wfn cF cA cA csn imaundi a1i cF cA csuc wfn cF cA csn cima cA cF
      cfv csn cF cA cima cF cA csuc wfn cA cA csuc wcel cF cA csn cima cA cF
      cfv csn wceq cA ac6sfilem2.1 sucid cF cA csuc wfn cA cA csuc wcel wa cA
      cF cfv csn cF cA csn cima cA csuc cA cF fnsnfv eqcomd mpan2 uneq2d 3eqtrd
      eqeq1d biimpa 3syl $.
      $( [29-Jun-2009] $) $( [26-Jun-2009] $)
  $}

  ${
    $d f h m x z A $.  $d f g h m t w x y z B $.  $d f g h m t w z ph $.
    $d g h m t w y z ps $.  $d f g h k m t w x y z $.
    ac6sfi.1 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Lemma for ~ ac6sfi . $)
    ac6sfilem3 $p |- ( ( ( y e. B /\ [ ( `' h ` w ) / x ] ph /\ ( w e. om
            /\ `' h : suc w -1-1-onto-> z ) ) /\ ( g : ( `' h " w ) --> B
            /\ A. x e. ( `' h " w ) [ g / f ] ps ) ) -> ( ( g u. {
            <. ( `' h ` w ) , y >. } ) : z --> B /\ A. x e. z [ ( g u.
            { <. ( `' h ` w ) , y >. } ) / f ] ps ) ) $=
      vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc
      vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg
      wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wf wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun wsbc vx vz cv wral vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw
      cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima
      cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vh cv ccnv
      vw cv cima vw cv vh cv ccnv cfv csn cun cB vg cv vw cv vh cv ccnv cfv vy
      cv cop csn cun wf vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      wf vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps
      vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vh cv ccnv vw cv cima vw cv
      vh cv ccnv cfv csn cun cB cB cun vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun wf vh cv ccnv vw cv cima vw cv vh cv ccnv cfv csn cun cB vg cv vw cv
      vh cv ccnv cfv vy cv cop csn cun wf vh cv ccnv vw cv cima cB vg cv wf vw
      cv vh cv ccnv cfv csn cB vw cv vh cv ccnv cfv vy cv cop csn wf wa vh cv
      ccnv vw cv cima vw cv vh cv ccnv cfv csn cin c0 wceq vh cv ccnv vw cv
      cima vw cv vh cv ccnv cfv csn cun cB cB cun vg cv vw cv vh cv ccnv cfv vy
      cv cop csn cun wf vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv
      com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB
      vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vh cv ccnv vw
      cv cima vw cv vh cv ccnv cfv csn cB cB vg cv vw cv vh cv ccnv cfv vy cv
      cop csn fun vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel
      vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf
      wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vh cv ccnv vw cv cima
      cB vg cv wf vw cv vh cv ccnv cfv csn cB vw cv vh cv ccnv cfv vy cv cop
      csn wf vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw
      cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf
      wps vf vg wsb vx vh cv ccnv vw cv cima wral simprl vy cv cB wcel wph vx
      vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o
      wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw
      cv cima wral wa wa vw cv vh cv ccnv cfv csn vy cv csn vw cv vh cv ccnv
      cfv vy cv cop csn wf1o vw cv vh cv ccnv cfv csn cB vw cv vh cv ccnv cfv
      vy cv cop csn wf vw cv vh cv ccnv cfv vy cv vw cv vh cv ccnv fvex vy
      visset f1osn vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com
      wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg
      cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vw cv vh cv ccnv
      cfv csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn wf vw cv vh cv ccnv
      cfv csn cB vw cv vh cv ccnv cfv vy cv cop csn wf vw cv vh cv ccnv cfv csn
      vy cv csn vw cv vh cv ccnv cfv vy cv cop csn wf1o vy cv cB wcel wph vx vw
      cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa
      w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv
      cima wral wa wa vy cv csn cB wss vw cv vh cv ccnv cfv csn vy cv csn vw cv
      vh cv ccnv cfv vy cv cop csn wf vw cv vh cv ccnv cfv csn cB vw cv vh cv
      ccnv cfv vy cv cop csn wf wi vy cv cB wcel wph vx vw cv vh cv ccnv cfv
      wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw
      cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vy
      cv cB wcel vy cv csn cB wss vy cv cB wcel wph vx vw cv vh cv ccnv cfv
      wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa vh cv ccnv vw cv
      cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa 3simpl1
      vy cv cB vy visset snss sylib vw cv vh cv ccnv cfv csn vy cv csn vw cv vh
      cv ccnv cfv vy cv cop csn wf vy cv csn cB wss vw cv vh cv ccnv cfv csn cB
      vw cv vh cv ccnv cfv vy cv cop csn wf vw cv vh cv ccnv cfv csn vy cv csn
      cB vw cv vh cv ccnv cfv vy cv cop csn fss expcom syl vw cv vh cv ccnv cfv
      csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn f1of syl5 mpi jca vy cv
      cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv
      vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx
      vh cv ccnv vw cv cima wral wa wa vw cv vh cv ccnv cfv vh cv ccnv vw cv
      cima wcel wn vh cv ccnv vw cv cima vw cv vh cv ccnv cfv csn cin c0 wceq
      vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc
      vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg
      wsb vx vh cv ccnv vw cv cima wral wa wa vw cv vh cv ccnv cfv vh cv ccnv
      vw cv cima wcel vt cv vh cv ccnv cfv vw cv vh cv ccnv cfv wceq vt vw cv
      wrex vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps
      vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vt cv vh cv ccnv cfv vw cv
      vh cv ccnv cfv wceq vt vw cv vy cv cB wcel wph vx vw cv vh cv ccnv cfv
      wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw
      cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vt
      cv vw cv wcel wa vt cv vh cv ccnv cfv vw cv vh cv ccnv cfv wceq vt cv vw
      cv wceq vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw
      cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf
      wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vt cv vw cv wcel vt cv
      vw cv wceq wn vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com
      wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vt cv vw cv wcel vt cv vw cv
      wceq wn wi vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv
      vw cv cima wral wa wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o wa vt cv vw cv wcel vt cv vw cv wceq wn wi vy
      cv cB wcel vw cv com wcel vt cv vw cv wcel vt cv vw cv wceq wn wi wph vx
      vw cv vh cv ccnv cfv wsbc vw cv csuc vz cv vh cv ccnv wf1o vw cv com wcel
      vw cv word vt cv vw cv wcel vt cv vw cv wceq wn wi vw cv nnord vw cv word
      vt cv vw cv wcel vt cv vw cv wceq wn vw cv word vt cv vw cv wcel wa vw cv
      vt cv wne vt cv vw cv wceq wn vw cv vt cv nordeq vw cv vt cv wne vt cv vw
      cv wne vt cv vw cv wceq wn vw cv vt cv necom vt cv vw cv df-ne bitri
      sylib ex syl ad2antrl 3adant1 adantr imp vw cv csuc vz cv vh cv ccnv wf1
      vt cv vw cv csuc wcel vw cv vw cv csuc wcel wa vt cv vh cv ccnv cfv vw cv
      vh cv ccnv cfv wceq vt cv vw cv wceq wb vy cv cB wcel wph vx vw cv vh cv
      ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh
      cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima
      wral wa wa vt cv vw cv wcel wa vw cv csuc vz cv vt cv vw cv vh cv ccnv
      f1fveq vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw
      cv csuc vz cv vh cv ccnv wf1o wa w3a vw cv csuc vz cv vh cv ccnv wf1 vh
      cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima
      wral wa vt cv vw cv wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel
      vw cv csuc vz cv vh cv ccnv wf1o wa vw cv csuc vz cv vh cv ccnv wf1 vy cv
      cB wcel vw cv csuc vz cv vh cv ccnv wf1o vw cv csuc vz cv vh cv ccnv wf1
      wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv
      ccnv f1of1 ad2antll 3adant1 ad2antrr vy cv cB wcel wph vx vw cv vh cv
      ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh
      cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima
      wral wa wa vt cv vw cv wcel wa vt cv vw cv csuc wcel vw cv vw cv csuc
      wcel vt cv vw cv wcel vt cv vw cv csuc wcel vy cv cB wcel wph vx vw cv vh
      cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a
      vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima
      wral wa wa vt cv vw cv elelsuc adantl vw cv vw visset sucid jctir sylanc
      mtbird nrexdv vh cv ccnv vw cv csuc wfn vw cv vw cv csuc wss vw cv vh cv
      ccnv cfv vh cv ccnv vw cv cima wcel vt cv vh cv ccnv cfv vw cv vh cv ccnv
      cfv wceq vt vw cv wrex wb vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc
      vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv
      cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vt vw
      cv csuc vw cv vw cv vh cv ccnv cfv vh cv ccnv fvelimab vy cv cB wcel wph
      vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv
      wf1o wa w3a vh cv ccnv vw cv csuc wfn vh cv ccnv vw cv cima cB vg cv wf
      wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wph vx vw cv vh cv ccnv
      cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa vh cv ccnv vw
      cv csuc wfn vy cv cB wcel vw cv csuc vz cv vh cv ccnv wf1o vh cv ccnv vw
      cv csuc wfn wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz
      cv vh cv ccnv f1ofn ad2antll 3adant1 adantr vw cv sssucid sylancl mtbird
      vh cv ccnv vw cv cima vw cv vh cv ccnv cfv disjsn sylibr sylanc vy cv cB
      wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh
      cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh
      cv ccnv vw cv cima wral wa wa cB cB cun cB wceq vh cv ccnv vw cv cima vw
      cv vh cv ccnv cfv csn cun cB cB cun vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wf vh cv ccnv vw cv cima vw cv vh cv ccnv cfv csn cun cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf wb cB cB cun cB wceq vy cv cB wcel
      wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv
      ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv
      ccnv vw cv cima wral wa wa cB unidm a1i cB cB cun cB vh cv ccnv vw cv
      cima vw cv vh cv ccnv cfv csn cun vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun feq3 syl mpbid vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw
      cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima
      cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vh cv ccnv
      vw cv cima vw cv vh cv ccnv cfv csn cun vz cv wceq vh cv ccnv vw cv cima
      vw cv vh cv ccnv cfv csn cun cB vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun wf vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wb vy cv
      cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv
      vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima vw cv vh cv ccnv cfv csn cun
      vz cv wceq vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv
      vw cv cima wral wa wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o wa vh cv ccnv vw cv cima vw cv vh cv ccnv cfv
      csn cun vz cv wceq vy cv cB wcel vw cv csuc vz cv vh cv ccnv wf1o vh cv
      ccnv vw cv cima vw cv vh cv ccnv cfv csn cun vz cv wceq wph vx vw cv vh
      cv ccnv cfv wsbc vw cv com wcel vw cv vz cv vh cv ccnv vw visset
      ac6sfilem2 ad2antll 3adant1 adantr vh cv ccnv vw cv cima vw cv vh cv ccnv
      cfv csn cun vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun feq2
      syl mpbid vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel
      vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf
      wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wf wps vf vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wsbc vx vz cv wral vy cv cB wcel wph vx vw cv vh cv ccnv cfv
      wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw
      cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz
      cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wa wps vf vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wsbc vx vz cv vy cv cB wcel wph vx vw
      cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa
      w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv
      cima wral wa wa vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf
      vx vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps
      vf vg wsb vx vh cv ccnv vw cv cima wral wa vx vy cv cB wcel wph vx vw cv
      vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa vx
      vy cv cB wcel vx ax-17 wph vx vw cv vh cv ccnv cfv vw cv vh cv ccnv fvex
      hbsbc1v vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa vx ax-17 hb3an
      vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima
      wral vx vh cv ccnv vw cv cima cB vg cv wf vx ax-17 wps vf vg wsb vx vh cv
      ccnv vw cv cima hbra1 hban hban vz cv cB vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wf vx ax-17 hban vy cv cB wcel wph vx vw cv vh cv ccnv cfv
      wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw
      cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz
      cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vz cv wcel
      vx cv vh cv ccnv vw cv cima wcel vx cv vw cv vh cv ccnv cfv csn wcel wo
      wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vy cv cB wcel
      wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv
      ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv
      ccnv vw cv cima wral wa wa vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wf wa vx cv vz cv wcel vx cv vh cv ccnv vw cv cima vw cv vh cv
      ccnv cfv csn cun wcel vx cv vh cv ccnv vw cv cima wcel vx cv vw cv vh cv
      ccnv cfv csn wcel wo vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv
      com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB
      vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vz cv vh cv ccnv vw cv cima
      vw cv vh cv ccnv cfv csn cun vx cv vy cv cB wcel wph vx vw cv vh cv ccnv
      cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vz cv vh
      cv ccnv vw cv cima vw cv vh cv ccnv cfv csn cun wceq vh cv ccnv vw cv
      cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vz cv cB
      vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wph vx vw cv vh cv ccnv
      cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa vz cv vh cv
      ccnv vw cv cima vw cv vh cv ccnv cfv csn cun wceq vy cv cB wcel vw cv
      csuc vz cv vh cv ccnv wf1o vz cv vh cv ccnv vw cv cima vw cv vh cv ccnv
      cfv csn cun wceq wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o vh cv ccnv vw cv cima vw cv vh cv ccnv cfv csn
      cun vz cv vw cv vz cv vh cv ccnv vw visset ac6sfilem2 eqcomd ad2antll
      3adant1 ad2antrr eleq2d vx cv vh cv ccnv vw cv cima vw cv vh cv ccnv cfv
      csn elun syl6bb vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com
      wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg
      cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vh cv ccnv vw cv cima
      wcel wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vx cv vw cv
      vh cv ccnv cfv csn wcel vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw
      cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima
      cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vh cv ccnv vw cv cima
      wcel wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi vh cv
      ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral
      wa vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vh cv
      ccnv vw cv cima wcel wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      wsbc wi wi vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel
      vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf
      vx cv vh cv ccnv vw cv cima wcel wps vf vg wsb wi vz cv cB vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wf vx cv vh cv ccnv vw cv cima wcel wps vf
      vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi wi wps vf vg wsb vx
      vh cv ccnv vw cv cima wral vx cv vh cv ccnv vw cv cima wcel wps vf vg wsb
      wi vh cv ccnv vw cv cima cB vg cv wf vz cv cB vg cv vw cv vh cv ccnv cfv
      vy cv cop csn cun wf vx cv vh cv ccnv vw cv cima wcel wps vf vg cv vw cv
      vh cv ccnv cfv vy cv cop csn cun wsbc wi wi vx cv vh cv ccnv vw cv cima
      wcel vx cv vh cv ccnv vw cv cima wcel wps vf vg wsb wi vh cv ccnv vw cv
      cima cB vg cv wf vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf
      wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vx cv vh cv ccnv
      vw cv cima wcel vx cv vh cv ccnv vw cv cima wcel wps vf vg wsb wi wps vf
      vg wsb vh cv ccnv vw cv cima cB vg cv wf vz cv cB vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wf wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun wsbc wi wi vx cv vh cv ccnv vw cv cima wcel wps vf vg wsb pm2.27 vx
      cv vh cv ccnv vw cv cima wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg
      cv wf vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wps vf vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vx cv vh cv ccnv vw cv
      cima wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv wf w3a vz cv cB vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wa wps vf vg cv vw cv vh cv
      ccnv cfv vy cv cop csn cun wsbc wps vf vg wsb vx cv vh cv ccnv vw cv cima
      wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv wf vz cv cB vg cv vw cv
      vh cv ccnv cfv vy cv cop csn cun wf 3simpl2 vx cv vh cv ccnv vw cv cima
      wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv wf w3a vz cv cB vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun cfv vx cv vg cv cfv wceq wps vf vg cv vw cv vh cv
      ccnv cfv vy cv cop csn cun wsbc wps vf vg wsb wb vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wfun vg cv vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun wss vx cv vg cv cdm wcel vx cv vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun cfv vx cv vg cv cfv wceq vx cv vh cv ccnv vw cv cima wcel wps vf
      vg wsb vh cv ccnv vw cv cima cB vg cv wf w3a vz cv cB vg cv vw cv vh cv
      ccnv cfv vy cv cop csn cun wf wa vx cv vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun vg cv funssfv vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wfun vx cv vh cv
      ccnv vw cv cima wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv wf w3a
      vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun ffun adantl vg cv
      vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wss vx cv vh cv ccnv vw cv
      cima wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv wf w3a vz cv cB vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vg cv vw cv vh cv ccnv
      cfv vy cv cop csn ssun1 a1i vx cv vh cv ccnv vw cv cima wcel wps vf vg
      wsb vh cv ccnv vw cv cima cB vg cv wf w3a vz cv cB vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wf wa vx cv vh cv ccnv vw cv cima vg cv cdm vx cv
      vh cv ccnv vw cv cima wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv
      wf vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf 3simpl1 vx cv
      vh cv ccnv vw cv cima wcel wps vf vg wsb vh cv ccnv vw cv cima cB vg cv
      wf w3a vg cv cdm vh cv ccnv vw cv cima wceq vz cv cB vg cv vw cv vh cv
      ccnv cfv vy cv cop csn cun wf vh cv ccnv vw cv cima cB vg cv wf vx cv vh
      cv ccnv vw cv cima wcel vg cv cdm vh cv ccnv vw cv cima wceq wps vf vg
      wsb vh cv ccnv vw cv cima cB vg cv fdm 3ad2ant3 adantr eleqtrrd syl3anc
      vx cv vg cv vw cv vh cv ccnv cfv vy cv cop csn cun cfv vx cv vg cv cfv
      wceq wph vy vx cv vg cv cfv wsbc wps vf vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wsbc wps vf vg wsb wph vy vx cv vg cv cfv wsbc wps vf vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wb vx cv vg cv cfv vx cv vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun cfv wph vy vx cv vg cv cfv wsbc
      wps vx vg cv vw cv vh cv ccnv cfv vy cv cop csn cun vx cv vg cv cfv vf vg
      cv vw cv vh cv ccnv cfv vy cv cop csn vg visset vw cv vh cv ccnv cfv vy
      cv cop snex unex vx cv vg cv cfv cvv wcel vy cv vx cv vf cv cfv wceq wph
      wps wb wi vy wal vx cv vg cv cfv vx cv vf cv cfv wceq wph vy vx cv vg cv
      cfv wsbc wps wb wi vx cv vg cv fvex vy cv vx cv vf cv cfv wceq wph wps wb
      wi vy ac6sfi.1 ax-gen vy cv vx cv vf cv cfv wceq wph wps wb wi vx cv vg
      cv cfv vx cv vf cv cfv wceq wph vy vx cv vg cv cfv wsbc wps wb wi vy vm
      vx cv vg cv cfv cvv vm cv vx cv vg cv cfv wcel vy ax-17 vx cv vg cv cfv
      vx cv vf cv cfv wceq wph vy vx cv vg cv cfv wsbc wps wb vy vx cv vg cv
      cfv vx cv vf cv cfv wceq vy ax-17 wph vy vx cv vg cv cfv wsbc wps vy wph
      vy vx cv vg cv cfv vx cv vg cv fvex hbsbc1v wps vy ax-17 hbbi hbim vy cv
      vx cv vg cv cfv wceq vy cv vx cv vf cv cfv wceq vx cv vg cv cfv vx cv vf
      cv cfv wceq wph wps wb wph vy vx cv vg cv cfv wsbc wps wb vy cv vx cv vg
      cv cfv vx cv vf cv cfv eqeq1 vy cv vx cv vg cv cfv wceq wph wph vy vx cv
      vg cv cfv wsbc wps wph vy vx cv vg cv cfv sbceq1a bibi1d imbi12d cla4gf
      mp2 ac6sfilem1 eqcoms vx cv vg cv cfv vx cv vg cv cfv wceq wph vy vx cv
      vg cv cfv wsbc wps vf vg wsb wb vx cv vg cv cfv eqid wph vy vx cv vg cv
      cfv wsbc wps vx vg cv vx cv vg cv cfv vf vg visset vx cv vg cv cfv cvv
      wcel vy cv vx cv vf cv cfv wceq wph wps wb wi vy wal vx cv vg cv cfv vx
      cv vf cv cfv wceq wph vy vx cv vg cv cfv wsbc wps wb wi vx cv vg cv fvex
      vy cv vx cv vf cv cfv wceq wph wps wb wi vy ac6sfi.1 ax-gen vy cv vx cv
      vf cv cfv wceq wph wps wb wi vx cv vg cv cfv vx cv vf cv cfv wceq wph vy
      vx cv vg cv cfv wsbc wps wb wi vy vm vx cv vg cv cfv cvv vm cv vx cv vg
      cv cfv wcel vy ax-17 vx cv vg cv cfv vx cv vf cv cfv wceq wph vy vx cv vg
      cv cfv wsbc wps wb vy vx cv vg cv cfv vx cv vf cv cfv wceq vy ax-17 wph
      vy vx cv vg cv cfv wsbc wps vy wph vy vx cv vg cv cfv vx cv vg cv fvex
      hbsbc1v wps vy ax-17 hbbi hbim vy cv vx cv vg cv cfv wceq vy cv vx cv vf
      cv cfv wceq vx cv vg cv cfv vx cv vf cv cfv wceq wph wps wb wph vy vx cv
      vg cv cfv wsbc wps wb vy cv vx cv vg cv cfv vx cv vf cv cfv eqeq1 vy cv
      vx cv vg cv cfv wceq wph wph vy vx cv vg cv cfv wsbc wps wph vy vx cv vg
      cv cfv sbceq1a bibi1d imbi12d cla4gf mp2 ac6sfilem1 ax-mp syl5rbbr syl
      mpbird 3exp1 syld com4l impcom wps vf vg wsb vx vh cv ccnv vw cv cima ra4
      sylan2 adantl imp vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv
      com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB
      vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv
      wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vx cv vw cv
      vh cv ccnv cfv csn wcel vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh
      cv ccnv cfv csn wceq vw cv vh cv ccnv cfv vw cv vh cv ccnv cfv vy cv cop
      csn cfv vy cv wceq wa vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw
      cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima
      cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv
      cfv wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi wi
      vw cv vh cv ccnv cfv csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn
      wf1o vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq
      vw cv vh cv ccnv cfv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq wa
      vw cv vh cv ccnv cfv vy cv vw cv vh cv ccnv fvex vy visset f1osn vw cv vh
      cv ccnv cfv csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn wf1o vw cv
      vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq vw cv vh
      cv ccnv cfv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vw cv vh cv
      ccnv cfv csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn wf1o vw cv vh
      cv ccnv cfv vy cv cop csn vw cv vh cv ccnv cfv csn wfn vw cv vh cv ccnv
      cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq vw cv vh cv ccnv cfv
      csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn f1ofn vw cv vh cv ccnv
      cfv csn vw cv vh cv ccnv cfv vy cv cop csn fndm syl vw cv vh cv ccnv cfv
      csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn wf1o vw cv vh cv ccnv
      cfv vy cv cop vw cv vh cv ccnv cfv vy cv cop csn wcel vw cv vh cv ccnv
      cfv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vw cv vh cv ccnv
      cfv vy cv cop vw cv vh cv ccnv cfv vy cv opex snid vw cv vh cv ccnv cfv
      csn vy cv csn vw cv vh cv ccnv cfv vy cv cop csn wf1o vw cv vh cv ccnv
      cfv vy cv cop csn wfun vw cv vh cv ccnv cfv vy cv cop vw cv vh cv ccnv
      cfv vy cv cop csn wcel vw cv vh cv ccnv cfv vw cv vh cv ccnv cfv vy cv
      cop csn cfv vy cv wceq wi vw cv vh cv ccnv cfv csn vy cv csn vw cv vh cv
      ccnv cfv vy cv cop csn f1ofun vw cv vh cv ccnv cfv vy cv vw cv vh cv ccnv
      cfv vy cv cop csn vy visset funopfv syl mpi jca ax-mp vw cv vh cv ccnv
      cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq vw cv vh cv ccnv cfv
      vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vy cv cB wcel wph vx vw
      cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa
      w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv
      cima wral wa wa vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf
      wa vx cv vw cv vh cv ccnv cfv wceq wps vf vg cv vw cv vh cv ccnv cfv vy
      cv cop csn cun wsbc wi wi vx cv vw cv vh cv ccnv cfv wceq vw cv vh cv
      ccnv cfv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vy cv cB wcel
      wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv
      ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv
      ccnv vw cv cima wral wa wa vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wf wa vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv
      csn wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vx cv
      vw cv vh cv ccnv cfv wceq vw cv vh cv ccnv cfv vw cv vh cv ccnv cfv vy cv
      cop csn cfv vy cv wceq vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv
      wceq vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv
      csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg cv wf wps
      vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv vw cv vh cv
      ccnv cfv vy cv cop csn cun wf wa vw cv vh cv ccnv cfv vy cv cop csn cdm
      vw cv vh cv ccnv cfv csn wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wsbc wi wi vx cv vw cv vh cv ccnv cfv wceq vw cv vh cv ccnv cfv
      vw cv vh cv ccnv cfv vy cv cop csn cfv vx cv vw cv vh cv ccnv cfv vy cv
      cop csn cfv vy cv vx cv vw cv vh cv ccnv cfv wceq vx cv vw cv vh cv ccnv
      cfv vy cv cop csn cfv vw cv vh cv ccnv cfv vw cv vh cv ccnv cfv vy cv cop
      csn cfv vx cv vw cv vh cv ccnv cfv vw cv vh cv ccnv cfv vy cv cop csn
      fveq2 eqcomd eqeq1d vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv
      com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB
      vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv
      vy cv cop csn cfv vy cv wceq vx cv vw cv vh cv ccnv cfv wceq vw cv vh cv
      ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq wps vf vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wsbc wi vy cv cB wcel wph vx vw cv vh
      cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a
      vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima
      wral wa wa vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv
      vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vx cv vw cv vh cv ccnv
      cfv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn
      wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi wi wi
      wph vx vw cv vh cv ccnv cfv wsbc vy cv cB wcel vh cv ccnv vw cv cima cB
      vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vz cv cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vw cv vh cv ccnv cfv vy cv
      cop csn cfv vy cv wceq vx cv vw cv vh cv ccnv cfv wceq vw cv vh cv ccnv
      cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq wps vf vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wsbc wi wi wi wi vw cv com wcel vw cv csuc
      vz cv vh cv ccnv wf1o wa vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb
      vx vh cv ccnv vw cv cima wral wa wph vx vw cv vh cv ccnv cfv wsbc vz cv
      cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vw cv vh cv ccnv
      cfv vy cv cop csn cfv vy cv wceq vx cv vw cv vh cv ccnv cfv wceq vw cv vh
      cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq wps vf vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi wi wi wi vh cv ccnv vw cv
      cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wph vx vw
      cv vh cv ccnv cfv wsbc wa vx cv vw cv vh cv ccnv cfv wceq vx cv vw cv vh
      cv ccnv cfv vy cv cop csn cfv vy cv wceq vz cv cB vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wf vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh
      cv ccnv cfv csn wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      wsbc wi wph vx vw cv vh cv ccnv cfv wsbc vx cv vw cv vh cv ccnv cfv wceq
      vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vz cv cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf vw cv vh cv ccnv cfv vy cv cop csn
      cdm vw cv vh cv ccnv cfv csn wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wsbc wi wi wi wi vh cv ccnv vw cv cima cB vg cv wf wps vf vg
      wsb vx vh cv ccnv vw cv cima wral wa vx cv vw cv vh cv ccnv cfv wceq wph
      vx vw cv vh cv ccnv cfv wsbc vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv
      vy cv wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vw cv
      vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq wps vf vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi wi wi vx cv vw cv vh cv
      ccnv cfv wceq wph vx vw cv vh cv ccnv cfv wsbc wph vx cv vw cv vh cv ccnv
      cfv vy cv cop csn cfv vy cv wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy
      cv cop csn cun wf vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv
      cfv csn wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi
      wi wi wph vx vw cv vh cv ccnv cfv sbceq1a vx cv vw cv vh cv ccnv cfv wceq
      vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vw cv vh
      cv ccnv cfv vy cv cop csn cfv vy cv wceq wph vw cv vh cv ccnv cfv vy cv
      cop csn cdm vw cv vh cv ccnv cfv csn wceq wps vf vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wsbc wi vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vw cv vh cv ccnv cfv
      vy cv cop csn cfv vy cv wceq wph vw cv vh cv ccnv cfv vy cv cop csn cdm
      vw cv vh cv ccnv cfv csn wceq wps vf vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wsbc wi wi wi vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv vy
      cv cop csn cfv vy cv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh
      cv ccnv cfv csn wceq wph wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun wsbc vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv
      vy cv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv
      csn wceq wph wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi
      vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wf wa vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq
      wa vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq
      wa vy cv vx cv vg cv vw cv vh cv ccnv cfv vy cv cop csn cun cfv wceq wph
      wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc wi vx cv vw cv
      vh cv ccnv cfv wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      wf wa vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq wa vw cv vh
      cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq wa vx cv vg
      cv vw cv vh cv ccnv cfv vy cv cop csn cun cfv vx cv vw cv vh cv ccnv cfv
      vy cv cop csn cfv vy cv vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wfun
      vw cv vh cv ccnv cfv vy cv cop csn vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wss vx cv vw cv vh cv ccnv cfv vy cv cop csn cdm wcel vx cv vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun cfv vx cv vw cv vh cv ccnv cfv vy
      cv cop csn cfv wceq vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv vw cv
      vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv vy cv
      cop csn cfv vy cv wceq wa vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh
      cv ccnv cfv csn wceq wa vx cv vg cv vw cv vh cv ccnv cfv vy cv cop csn
      cun vw cv vh cv ccnv cfv vy cv cop csn funssfv vx cv vw cv vh cv ccnv cfv
      wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wfun vx cv vw cv vh cv ccnv cfv vy cv
      cop csn cfv vy cv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv
      ccnv cfv csn wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      wf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wfun vx cv vw cv vh cv
      ccnv cfv wceq vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun ffun
      adantl ad2antrr vw cv vh cv ccnv cfv vy cv cop csn vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wss vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv
      vy cv cop csn cfv vy cv wceq wa vw cv vh cv ccnv cfv vy cv cop csn cdm vw
      cv vh cv ccnv cfv csn wceq wa vw cv vh cv ccnv cfv vy cv cop csn vg cv
      ssun2 a1i vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv vw cv vh cv ccnv
      cfv vy cv cop csn cun wf wa vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv
      vh cv ccnv cfv csn wceq vx cv vw cv vh cv ccnv cfv vy cv cop csn cdm wcel
      vx cv vw cv vh cv ccnv cfv vy cv cop csn cfv vy cv wceq vx cv vw cv vh cv
      ccnv cfv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv
      csn wceq vx cv vw cv vh cv ccnv cfv vy cv cop csn cdm wcel vz cv cB vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun wf vx cv vw cv vh cv ccnv cfv wceq
      vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq wa
      vx cv vw cv vh cv ccnv cfv csn vw cv vh cv ccnv cfv vy cv cop csn cdm vx
      cv vw cv vh cv ccnv cfv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv
      vh cv ccnv cfv csn wceq wa vx cv vw cv vh cv ccnv cfv vw cv vh cv ccnv
      cfv csn vx cv vw cv vh cv ccnv cfv wceq vw cv vh cv ccnv cfv vy cv cop
      csn cdm vw cv vh cv ccnv cfv csn wceq pm3.26 vw cv vh cv ccnv cfv vw cv
      vh cv ccnv fvex snid syl6eqel vx cv vw cv vh cv ccnv cfv wceq vw cv vh cv
      ccnv cfv vy cv cop csn cdm vw cv vh cv ccnv cfv csn wceq pm3.27 eleqtrrd
      adantlr adantlr syl3anc vx cv vw cv vh cv ccnv cfv wceq vz cv cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf wa vx cv vw cv vh cv ccnv cfv vy
      cv cop csn cfv vy cv wceq vw cv vh cv ccnv cfv vy cv cop csn cdm vw cv vh
      cv ccnv cfv csn wceq simplr eqtr2d vy cv vx cv vg cv vw cv vh cv ccnv cfv
      vy cv cop csn cun cfv wceq wph wps vf vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wsbc wph wps vx vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      vy cv vf vg cv vw cv vh cv ccnv cfv vy cv cop csn vg visset vw cv vh cv
      ccnv cfv vy cv cop snex unex ac6sfi.1 ac6sfilem1 biimpd syl exp31 com34
      ex com24 sylbird com12 adantl com24 ancoms 3ad2antl2 imp com13 sylbid
      com14 imp ax-mp vx vw cv vh cv ccnv cfv elsn syl5ib jaod sylbid r19.21ai
      ex jcai $.
      $( [29-Jun-2009] $) $( [26-Jun-2009] $)

    $( A version of ~ ac6s for finite sets.  (Contributed by Jeffrey Hankins,
       26-Jun-2009.) $)
    ac6sfi $p |- ( ( A e. Fin /\ A. x e. A E. y e. B ph ) ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      cA cfn wcel wph vy cB wrex vx cA wral cA cB vf cv wf wps vx cA wral wa vf
      wex cA cfn wcel cA vm cv cen wbr vm com wrex wph vy cB wrex vx cA wral cA
      cB vf cv wf wps vx cA wral wa vf wex wi vm cA isfi cA vm cv cen wbr wph
      vy cB wrex vx cA wral cA cB vf cv wf wps vx cA wral wa vf wex wi vm com
      cA vm cv cen wbr vm cv com wcel wph vy cB wrex vx cA wral cA cB vf cv wf
      wps vx cA wral wa vf wex wi cA vm cv cen wbr cA cvv wcel vm cv com wcel
      wph vy cB wrex vx cA wral cA cB vf cv wf wps vx cA wral wa vf wex wi wi
      cA vm cv cen relen brrelexi cA vm cv cen wbr cA vm cv vh cv wf1o vh wex
      cA cvv wcel vm cv com wcel wph vy cB wrex vx cA wral cA cB vf cv wf wps
      vx cA wral wa vf wex wi wi wi cA vm cv vh vm visset bren cA cvv wcel vm
      cv com wcel cA vm cv vh cv wf1o vh wex wph vy cB wrex vx cA wral cA cB vf
      cv wf wps vx cA wral wa vf wex wi cA cvv wcel vz cv vm cv vh cv wf1o vh
      wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi wi vz wal cA vm cv vh cv wf1o vh wex wph vy cB wrex vx cA wral
      cA cB vf cv wf wps vx cA wral wa vf wex wi wi vm cv com wcel vz cv vm cv
      vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx
      vz cv wral wa vf wex wi wi cA vm cv vh cv wf1o vh wex wph vy cB wrex vx
      cA wral cA cB vf cv wf wps vx cA wral wa vf wex wi wi vz cA cvv vz cv cA
      wceq vz cv vm cv vh cv wf1o vh wex cA vm cv vh cv wf1o vh wex wph vy cB
      wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wph
      vy cB wrex vx cA wral cA cB vf cv wf wps vx cA wral wa vf wex wi vz cv cA
      wceq vz cv vm cv vh cv wf1o cA vm cv vh cv wf1o vh vz cv cA vm cv vh cv
      f1oeq2 exbidv vz cv cA wceq wph vy cB wrex vx vz cv wral wph vy cB wrex
      vx cA wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex cA cB vf cv wf
      wps vx cA wral wa vf wex wph vy cB wrex vx vz cv cA raleq1 vz cv cA wceq
      vz cv cB vf cv wf wps vx vz cv wral wa cA cB vf cv wf wps vx cA wral wa
      vf vz cv cA wceq vz cv cB vf cv wf cA cB vf cv wf wps vx vz cv wral wps
      vx cA wral vz cv cA cB vf cv feq2 wps vx vz cv cA raleq1 anbi12d exbidv
      imbi12d imbi12d cla4gv vz cv vm cv vh cv wf1o vh wex wph vy cB wrex vx vz
      cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vz wal vz cv
      c0 vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps
      vx vz cv wral wa vf wex wi wi vz wal vz cv vw cv vh cv wf1o vh wex wph vy
      cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi
      vz wal vz cv vw cv csuc vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz
      cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vz wal vm vw vm cv c0
      wceq vz cv vm cv vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB
      vf cv wf wps vx vz cv wral wa vf wex wi wi vz cv c0 vh cv wf1o vh wex wph
      vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi
      wi vz vm cv c0 wceq vz cv vm cv vh cv wf1o vh wex vz cv c0 vh cv wf1o vh
      wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi vm cv c0 wceq vz cv vm cv vh cv wf1o vz cv c0 vh cv wf1o vh vm
      cv c0 vz cv vh cv f1oeq3 exbidv imbi1d albidv vm cv vw cv wceq vz cv vm
      cv vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps
      vx vz cv wral wa vf wex wi wi vz cv vw cv vh cv wf1o vh wex wph vy cB
      wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vz
      vm cv vw cv wceq vz cv vm cv vh cv wf1o vh wex vz cv vw cv vh cv wf1o vh
      wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi vm cv vw cv wceq vz cv vm cv vh cv wf1o vz cv vw cv vh cv wf1o
      vh vm cv vw cv vz cv vh cv f1oeq3 exbidv imbi1d albidv vm cv vw cv csuc
      wceq vz cv vm cv vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB
      vf cv wf wps vx vz cv wral wa vf wex wi wi vz cv vw cv csuc vh cv wf1o vh
      wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi wi vz vm cv vw cv csuc wceq vz cv vm cv vh cv wf1o vh wex vz cv
      vw cv csuc vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB vf cv
      wf wps vx vz cv wral wa vf wex wi vm cv vw cv csuc wceq vz cv vm cv vh cv
      wf1o vz cv vw cv csuc vh cv wf1o vh vm cv vw cv csuc vz cv vh cv f1oeq3
      exbidv imbi1d albidv vz cv c0 vh cv wf1o vh wex wph vy cB wrex vx vz cv
      wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vz vz cv c0 vh
      cv wf1o wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral
      wa vf wex wi vh vz cv c0 vh cv wf1o vz cv cB vf cv wf wps vx vz cv wral
      wa vf wex wph vy cB wrex vx vz cv wral vz cv c0 vh cv wf1o c0 vz cv vh cv
      ccnv wf1o vh cv ccnv c0 wceq vz cv c0 wceq wa vz cv cB vf cv wf wps vx vz
      cv wral wa vf wex vz cv c0 vh cv f1ocnv c0 vz cv vh cv ccnv wf1o vh cv
      ccnv c0 wceq vz cv c0 wceq wa vz cv vh cv ccnv f1o00 biimpi c0 cvv wcel
      vz cv cB c0 wf wps vf c0 wsbc vx vz cv wral wa vz cv cB vf cv wf wps vx
      vz cv wral wa vf wex vh cv ccnv c0 wceq vz cv c0 wceq wa vz cv cB vf cv
      wf wps vx vz cv wral wa vz cv cB c0 wf wps vf c0 wsbc vx vz cv wral wa vf
      vx c0 cvv vx cv c0 wcel vf ax-17 vz cv cB c0 wf wps vf c0 wsbc vx vz cv
      wral vf vz cv cB c0 wf vf ax-17 wps vf c0 wsbc vf vx vz cv vx cv vz cv
      wcel vf ax-17 wps vf c0 0ex hbsbc1v hbral hban vf cv c0 wceq vz cv cB vf
      cv wf vz cv cB c0 wf wps vx vz cv wral wps vf c0 wsbc vx vz cv wral vz cv
      cB vf cv c0 feq1 vf cv c0 wceq wps wps vf c0 wsbc vx vz cv wps vf c0
      sbceq1a ralbidv anbi12d cla4egf c0 cvv wcel vh cv ccnv c0 wceq vz cv c0
      wceq wa 0ex a1i vz cv c0 wceq vz cv cB c0 wf wps vf c0 wsbc vx vz cv wral
      wa vh cv ccnv c0 wceq vz cv c0 wceq vz cv cB c0 wf wps vf c0 wsbc vx vz
      cv wral wa c0 cB c0 wf wps vf c0 wsbc vx c0 wral wa c0 cB c0 wf wps vf c0
      wsbc vx c0 wral cB f0 wps vf c0 wsbc vx ral0 pm3.2i vz cv c0 wceq vz cv
      cB c0 wf c0 cB c0 wf wps vf c0 wsbc vx vz cv wral wps vf c0 wsbc vx c0
      wral vz cv c0 cB c0 feq2 wps vf c0 wsbc vx vz cv c0 raleq1 anbi12d mpbiri
      adantl sylc 3syl a1d 19.23aiv ax-gen vw cv com wcel vt cv vw cv vh cv
      wf1o vh wex wph vy cB wrex vx vt cv wral vt cv cB vf cv wf wps vx vt cv
      wral wa vf wex wi wi vt wal vz cv vw cv csuc vh cv wf1o vh wex wph vy cB
      wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vz
      wal vz cv vw cv vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB
      vf cv wf wps vx vz cv wral wa vf wex wi wi vz wal vw cv com wcel vt cv vw
      cv vh cv wf1o vh wex wph vy cB wrex vx vt cv wral vt cv cB vf cv wf wps
      vx vt cv wral wa vf wex wi wi vt wal vz cv vw cv csuc vh cv wf1o vh wex
      wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf
      wex wi wi vz wal vw cv com wcel vt cv vw cv vh cv wf1o vh wex wph vy cB
      wrex vx vt cv wral vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt
      wal wa vz cv vw cv csuc vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz
      cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vz vw cv com wcel vt cv
      vw cv vk cv wf1o vk wex wph vy cB wrex vx vt cv wral vt cv cB vf cv wf
      wps vx vt cv wral wa vf wex wi wi vt wal vz cv vw cv csuc vh cv wf1o vh
      wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi wi vt cv vw cv vh cv wf1o vh wex wph vy cB wrex vx vt cv wral
      vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt wal vw cv com wcel
      vt cv vw cv vk cv wf1o vk wex wph vy cB wrex vx vt cv wral vt cv cB vf cv
      wf wps vx vt cv wral wa vf wex wi wi vt wal wa vz cv vw cv csuc vh cv
      wf1o wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi vh vw cv com wcel vt cv vw cv vk cv wf1o vk wex wph vy cB wrex
      vx vt cv wral vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt wal
      vz cv vw cv csuc vh cv wf1o wph vy cB wrex vx vz cv wral vz cv cB vf cv
      wf wps vx vz cv wral wa vf wex wi wi vw cv com wcel vz cv vw cv csuc vh
      cv wf1o vt cv vw cv vk cv wf1o vk wex wph vy cB wrex vx vt cv wral vt cv
      cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt wal wph vy cB wrex vx vz
      cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi vw cv com wcel
      vz cv vw cv csuc vh cv wf1o vt cv vw cv vk cv wf1o vk wex wph vy cB wrex
      vx vt cv wral vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt wal
      wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf
      wex wi wi vw cv com wcel vz cv vw cv csuc vh cv wf1o wa vh cv ccnv vw cv
      cima vw cv vk cv wf1o vk wex wph vy cB wrex vx vh cv ccnv vw cv cima wral
      vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf
      wex wi wi wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv
      wral wa vf wex wi vt cv vw cv vk cv wf1o vk wex wph vy cB wrex vx vt cv
      wral vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt wal vw cv com
      wcel vz cv vw cv csuc vh cv wf1o wa vh cv ccnv vw cv cima vw cv vk cv
      wf1o vk wex vh cv ccnv vw cv cima vw cv vk cv wf1o vk wex wph vy cB wrex
      vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh
      cv ccnv vw cv cima wral wa vf wex wi wi wph vy cB wrex vx vz cv wral vz
      cv cB vf cv wf wps vx vz cv wral wa vf wex wi wi vw cv com wcel vz cv vw
      cv csuc vh cv wf1o wa vw cv vh cv ccnv vw cv cima vh cv ccnv vw cv cres
      wf1o vh cv ccnv vw cv cima vw cv vh cv ccnv vw cv cres ccnv wf1o vh cv
      ccnv vw cv cima vw cv vk cv wf1o vk wex vw cv com wcel vw cv csuc vz cv
      vh cv ccnv wf1o vw cv vh cv ccnv vw cv cima vh cv ccnv vw cv cres wf1o vz
      cv vw cv csuc vh cv wf1o vw cv csuc vz cv vh cv ccnv wf1o vw cv vh cv
      ccnv vw cv cima vh cv ccnv vw cv cres wf1o vw cv com wcel vw cv csuc vz
      cv vh cv ccnv wf1 vw cv vw cv csuc wss vw cv vh cv ccnv vw cv cima vh cv
      ccnv vw cv cres wf1o vw cv csuc vz cv vh cv ccnv wf1o vw cv csuc vz cv vw
      cv vh cv ccnv f1ores vw cv csuc vz cv vh cv ccnv f1of1 vw cv sssucid
      sylancl adantl vz cv vw cv csuc vh cv f1ocnv sylan2 vw cv vh cv ccnv vw
      cv cima vh cv ccnv vw cv cres f1ocnv vh cv ccnv vw cv cima vw cv vk cv
      wf1o vh cv ccnv vw cv cima vw cv vh cv ccnv vw cv cres ccnv wf1o vk vh cv
      ccnv vw cv cres ccnv vh cv ccnv vw cv cres vh cv ccnv cvv wcel vh cv ccnv
      vw cv cres cvv wcel vh cv vh visset cnvex vh cv ccnv vw cv cvv resexg
      ax-mp cnvex vh cv ccnv vw cv cima vw cv vk cv vh cv ccnv vw cv cres ccnv
      f1oeq1 cla4ev 3syl vh cv ccnv vw cv cima vw cv vk cv wf1o vk wex vh cv
      ccnv vw cv cima vw cv vk cv wf1o vk wex wph vy cB wrex vx vh cv ccnv vw
      cv cima wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv
      cima wral wa vf wex wi wi vw cv com wcel vz cv vw cv csuc vh cv wf1o wa
      wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral wa vf
      wex wi vh cv ccnv vw cv cima vw cv vk cv wf1o vk wex vh cv ccnv vw cv
      cima vw cv vk cv wf1o vk wex wph vy cB wrex vx vh cv ccnv vw cv cima wral
      vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf
      wex wi wi wph vy cB wrex vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv
      cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf wex wi vw cv com
      wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv wral vz cv cB
      vf cv wf wps vx vz cv wral wa vf wex wi wi vh cv ccnv vw cv cima vw cv vk
      cv wf1o vk wex wph vy cB wrex vx vh cv ccnv vw cv cima wral vh cv ccnv vw
      cv cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf wex wi pm2.27
      vw cv com wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv
      wral wph vy cB wrex vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv cima
      cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf wex wi vz cv cB vf cv
      wf wps vx vz cv wral wa vf wex vw cv com wcel vz cv vw cv csuc vh cv wf1o
      wa wph vy cB wrex vx vz cv wral wph vy cB wrex vx vh cv ccnv vw cv cima
      wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral
      wa vf wex wi vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi vw cv com
      wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv wral wa wph
      vy cB wrex vx vh cv ccnv vw cv cima wral wph vy cB wrex vx vh cv ccnv vw
      cv cima wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv
      cima wral wa vf wex wi vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi
      vw cv com wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv
      wral wph vy cB wrex vx vh cv ccnv vw cv cima wral vz cv vw cv csuc vh cv
      wf1o wph vy cB wrex vx vz cv wral wph vy cB wrex vx vh cv ccnv vw cv cima
      wral wi vw cv com wcel vz cv vw cv csuc vh cv wf1o vw cv csuc vz cv vh cv
      ccnv wf1o vh cv ccnv vw cv cima vz cv wss wph vy cB wrex vx vz cv wral
      wph vy cB wrex vx vh cv ccnv vw cv cima wral wi vz cv vw cv csuc vh cv
      f1ocnv vw cv csuc vz cv vh cv ccnv wf1o vw cv csuc vz cv vh cv ccnv wf1
      vh cv ccnv crn vz cv wceq wa vh cv ccnv crn vz cv wceq vh cv ccnv vw cv
      cima vz cv wss vw cv csuc vz cv vh cv ccnv wf1o vw cv csuc vz cv vh cv
      ccnv wf1 vh cv ccnv crn vz cv wceq wa vw cv csuc vz cv vh cv ccnv dff1o5
      biimpi vw cv csuc vz cv vh cv ccnv wf1 vh cv ccnv crn vz cv wceq pm3.27
      vh cv ccnv crn vz cv wceq vh cv ccnv vw cv cima vh cv ccnv crn wss vh cv
      ccnv vw cv cima vz cv wss vh cv ccnv vw cv imassrn vh cv ccnv crn vz cv
      vh cv ccnv vw cv cima sseq2 mpbii 3syl wph vy cB wrex vx vh cv ccnv vw cv
      cima vz cv ssralv 3syl adantl imp wph vy cB wrex vx vh cv ccnv vw cv cima
      wral wph vy cB wrex vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv cima
      cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf wex wi vw cv com wcel
      vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv wral wa vz cv cB
      vf cv wf wps vx vz cv wral wa vf wex wph vy cB wrex vx vh cv ccnv vw cv
      cima wral wph vy cB wrex vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv
      cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf wex wi vh cv
      ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vf wex
      vw cv com wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv
      wral wa vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wph vy cB wrex
      vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh
      cv ccnv vw cv cima wral wa vf wex pm2.27 vh cv ccnv vw cv cima cB vf cv
      wf wps vx vh cv ccnv vw cv cima wral wa vf wex vh cv ccnv vw cv cima cB
      vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vg wex vw cv com
      wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx vz cv wral wa vz cv
      cB vf cv wf wps vx vz cv wral wa vf wex wi vh cv ccnv vw cv cima cB vf cv
      wf wps vx vh cv ccnv vw cv cima wral wa vh cv ccnv vw cv cima cB vg cv wf
      wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vf vg vh cv ccnv vw cv
      cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral wa vg ax-17 vh cv ccnv
      vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral vf vh
      cv ccnv vw cv cima cB vg cv wf vf ax-17 wps vf vg wsb vf vx vh cv ccnv vw
      cv cima vx cv vh cv ccnv vw cv cima wcel vf ax-17 wps vf vg cv vg visset
      hbsbc1v hbral hban vf cv vg cv wceq vh cv ccnv vw cv cima cB vf cv wf vh
      cv ccnv vw cv cima cB vg cv wf wps vx vh cv ccnv vw cv cima wral wps vf
      vg wsb vx vh cv ccnv vw cv cima wral vh cv ccnv vw cv cima cB vf cv vg cv
      feq1 vf cv vg cv wceq wps wps vf vg wsb vx vh cv ccnv vw cv cima wps vf
      vg sbequ12 ralbidv anbi12d cbvex vh cv ccnv vw cv cima cB vg cv wf wps vf
      vg wsb vx vh cv ccnv vw cv cima wral wa vw cv com wcel vz cv vw cv csuc
      vh cv wf1o wa wph vy cB wrex vx vz cv wral wa vz cv cB vf cv wf wps vx vz
      cv wral wa vf wex wi vg vw cv com wcel vz cv vw cv csuc vh cv wf1o wa wph
      vy cB wrex vx vz cv wral wa vh cv ccnv vw cv cima cB vg cv wf wps vf vg
      wsb vx vh cv ccnv vw cv cima wral wa vz cv cB vf cv wf wps vx vz cv wral
      wa vf wex vw cv com wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx
      vz cv wral wph vy cB wrex vx vw cv vh cv ccnv cfv csn wral vh cv ccnv vw
      cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vz cv
      cB vf cv wf wps vx vz cv wral wa vf wex wi vz cv vw cv csuc vh cv wf1o
      wph vy cB wrex vx vz cv wral wph vy cB wrex vx vw cv vh cv ccnv cfv csn
      wral vw cv com wcel vh cv ccnv vw cv csuc wfn vh cv ccnv vw cv csn cima
      vz cv wss wa wph vy cB wrex vx vz cv wral wph vy cB wrex vx vw cv vh cv
      ccnv cfv csn wral vz cv vw cv csuc vh cv wf1o vw cv vh cv ccnv cfv csn vz
      cv wss wph vy cB wrex vx vz cv wral wph vy cB wrex vx vw cv vh cv ccnv
      cfv csn wral vh cv ccnv vw cv csuc wfn vh cv ccnv vw cv csn cima vz cv
      wss wa vw cv vh cv ccnv cfv csn vz cv wss wph vy cB wrex vx vz cv wral
      wph vy cB wrex vx vw cv vh cv ccnv cfv csn wral wph vy cB wrex vx vw cv
      vh cv ccnv cfv csn vz cv ssralv imp vh cv ccnv vw cv csuc wfn vh cv ccnv
      vw cv csn cima vz cv wss vw cv vh cv ccnv cfv csn vz cv wss vh cv ccnv vw
      cv csuc wfn vh cv ccnv vw cv csn cima vw cv vh cv ccnv cfv csn vz cv vh
      cv ccnv vw cv csuc wfn vw cv vh cv ccnv cfv csn vh cv ccnv vw cv csn cima
      vh cv ccnv vw cv csuc wfn vw cv vw cv csuc wcel vw cv vh cv ccnv cfv csn
      vh cv ccnv vw cv csn cima wceq vw cv vw visset sucid vw cv csuc vw cv vh
      cv ccnv fnsnfv mpan2 eqcomd sseq1d biimpa sylan vz cv vw cv csuc vh cv
      wf1o vh cv ccnv vw cv csuc wfn vh cv ccnv vw cv csn cima vz cv wss vz cv
      vw cv csuc vh cv wf1o vw cv csuc vz cv vh cv ccnv wf1o vw cv csuc vz cv
      vh cv ccnv wfo vh cv ccnv vw cv csuc wfn vz cv vw cv csuc vh cv f1ocnv vw
      cv csuc vz cv vh cv ccnv f1ofo vw cv csuc vz cv vh cv ccnv fofn 3syl vz
      cv vw cv csuc vh cv wf1o vh cv ccnv vw cv csuc cima vz cv wceq vh cv ccnv
      vw cv cima vh cv ccnv vw cv csn cima cun vz cv wceq vh cv ccnv vw cv csn
      cima vz cv wss vz cv vw cv csuc vh cv wf1o vw cv csuc vz cv vh cv ccnv
      wf1o vw cv csuc vz cv vh cv ccnv wfo vh cv ccnv vw cv csuc cima vz cv
      wceq vz cv vw cv csuc vh cv f1ocnv vw cv csuc vz cv vh cv ccnv f1ofo vw
      cv csuc vz cv vh cv ccnv foima 3syl vh cv ccnv vw cv csuc cima vz cv wceq
      vh cv ccnv vw cv cima vh cv ccnv vw cv csn cima cun vz cv wceq vh cv ccnv
      vw cv csuc cima vh cv ccnv vw cv cima vh cv ccnv vw cv csn cima cun vz cv
      vh cv ccnv vw cv csuc cima vh cv ccnv vw cv vw cv csn cun cima vh cv ccnv
      vw cv cima vh cv ccnv vw cv csn cima cun vw cv csuc vw cv vw cv csn cun
      vh cv ccnv vw cv df-suc imaeq2i vh cv ccnv vw cv vw cv csn imaundi eqtri
      eqeq1i biimpi vh cv ccnv vw cv cima vh cv ccnv vw cv csn cima cun vz cv
      wceq vh cv ccnv vw cv csn cima vh cv ccnv vw cv cima vh cv ccnv vw cv csn
      cima cun wss vh cv ccnv vw cv csn cima vz cv wss vh cv ccnv vw cv csn
      cima vh cv ccnv vw cv cima ssun2 vh cv ccnv vw cv cima vh cv ccnv vw cv
      csn cima cun vz cv vh cv ccnv vw cv csn cima sseq2 mpbii 3syl jca sylan
      adantll vw cv com wcel vz cv vw cv csuc vh cv wf1o wa wph vy cB wrex vx
      vw cv vh cv ccnv cfv wsbc vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb
      vx vh cv ccnv vw cv cima wral wa vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi wph vy cB wrex vx vw cv vh cv ccnv cfv csn wral vw cv com wcel
      vz cv vw cv csuc vh cv wf1o wa wph vx vw cv vh cv ccnv cfv wsbc vy cB
      wrex vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv
      cima wral wa vz cv cB vf cv wf wps vx vz cv wral wa vf wex wi wph vy cB
      wrex vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vz cv vw cv csuc vh cv
      wf1o wa wph vx vw cv vh cv ccnv cfv wsbc vy cB wrex vh cv ccnv vw cv cima
      cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vz cv cB vf cv
      wf wps vx vz cv wral wa vf wex wi vw cv com wcel vw cv csuc vz cv vh cv
      ccnv wf1o wph vx vw cv vh cv ccnv cfv wsbc vy cB wrex vh cv ccnv vw cv
      cima cB vg cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa vz cv cB
      vf cv wf wps vx vz cv wral wa vf wex wi wi vz cv vw cv csuc vh cv wf1o
      wph vx vw cv vh cv ccnv cfv wsbc vy cB wrex vw cv com wcel vw cv csuc vz
      cv vh cv ccnv wf1o wa vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx
      vh cv ccnv vw cv cima wral wa vz cv cB vf cv wf wps vx vz cv wral wa vf
      wex wi wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel vw cv csuc vz cv
      vh cv ccnv wf1o wa vh cv ccnv vw cv cima cB vg cv wf wps vf vg wsb vx vh
      cv ccnv vw cv cima wral wa vz cv cB vf cv wf wps vx vz cv wral wa vf wex
      wi wi vy cB vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com wcel
      vw cv csuc vz cv vh cv ccnv wf1o wa vh cv ccnv vw cv cima cB vg cv wf wps
      vf vg wsb vx vh cv ccnv vw cv cima wral wa vz cv cB vf cv wf wps vx vz cv
      wral wa vf wex vy cv cB wcel wph vx vw cv vh cv ccnv cfv wsbc vw cv com
      wcel vw cv csuc vz cv vh cv ccnv wf1o wa w3a vh cv ccnv vw cv cima cB vg
      cv wf wps vf vg wsb vx vh cv ccnv vw cv cima wral wa wa vz cv cB vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun wf wps vf vg cv vw cv vh cv ccnv cfv
      vy cv cop csn cun wsbc vx vz cv wral wa vz cv cB vf cv wf wps vx vz cv
      wral wa vf wex wph wps vx vy vz vw cB vf vg vh ac6sfi.1 ac6sfilem3 vg cv
      vw cv vh cv ccnv cfv vy cv cop csn cun cvv wcel vz cv cB vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wf wps vf vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wsbc vx vz cv wral wa vz cv cB vf cv wf wps vx vz cv wral wa
      vf wex wi vg cv vw cv vh cv ccnv cfv vy cv cop csn vg visset vw cv vh cv
      ccnv cfv vy cv cop snex unex vz cv cB vf cv wf wps vx vz cv wral wa vz cv
      cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf wps vf vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wsbc vx vz cv wral wa vf vt vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun cvv vt cv vg cv vw cv vh cv ccnv cfv vy cv
      cop csn cun wcel vf ax-17 vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wf wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vx vz
      cv wral vf vz cv cB vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wf vf
      ax-17 wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun wsbc vf vx vz
      cv vx cv vz cv wcel vf ax-17 wps vf vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun vg cv vw cv vh cv ccnv cfv vy cv cop csn vg visset vw cv vh cv
      ccnv cfv vy cv cop snex unex hbsbc1v hbral hban vf cv vg cv vw cv vh cv
      ccnv cfv vy cv cop csn cun wceq vz cv cB vf cv wf vz cv cB vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wf wps vx vz cv wral wps vf vg cv vw cv vh
      cv ccnv cfv vy cv cop csn cun wsbc vx vz cv wral vz cv cB vf cv vg cv vw
      cv vh cv ccnv cfv vy cv cop csn cun feq1 vf cv vg cv vw cv vh cv ccnv cfv
      vy cv cop csn cun wceq wps wps vf vg cv vw cv vh cv ccnv cfv vy cv cop
      csn cun wsbc vx vz cv wps vf vg cv vw cv vh cv ccnv cfv vy cv cop csn cun
      sbceq1a ralbidv anbi12d cla4egf ax-mp syl 3exp1 r19.23aiv com12 vz cv vw
      cv csuc vh cv f1ocnv sylan2 imp vw cv vh cv ccnv cfv cvv wcel wph vy cB
      wrex vx vw cv vh cv ccnv cfv wsbc wph vx vw cv vh cv ccnv cfv wsbc vy cB
      wrex wb vw cv vh cv ccnv fvex wph vx vy vw cv vh cv ccnv cfv cB cvv
      sbcrexg ax-mp sylan2b wph vy cB wrex vx vw cv vh cv ccnv cfv vw cv vh cv
      ccnv fvex ralsn sylan2b syldan com12 19.23aiv sylbi syl6 com3r mpd ex
      com3r syl6 com3r mpd vt cv vw cv vk cv wf1o vk wex wph vy cB wrex vx vt
      cv wral vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vh cv ccnv vw
      cv cima vw cv vk cv wf1o vk wex wph vy cB wrex vx vh cv ccnv vw cv cima
      wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv vw cv cima wral
      wa vf wex wi wi vt vh cv ccnv vw cv cima vh cv ccnv cvv wcel vh cv ccnv
      vw cv cima cvv wcel vh cv vh visset cnvex vh cv ccnv vw cv cvv imaexg
      ax-mp vt cv vh cv ccnv vw cv cima wceq vt cv vw cv vk cv wf1o vk wex vh
      cv ccnv vw cv cima vw cv vk cv wf1o vk wex wph vy cB wrex vx vt cv wral
      vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wph vy cB wrex vx vh cv
      ccnv vw cv cima wral vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv
      vw cv cima wral wa vf wex wi vt cv vh cv ccnv vw cv cima wceq vt cv vw cv
      vk cv wf1o vh cv ccnv vw cv cima vw cv vk cv wf1o vk vt cv vh cv ccnv vw
      cv cima vw cv vk cv f1oeq2 exbidv vt cv vh cv ccnv vw cv cima wceq wph vy
      cB wrex vx vt cv wral wph vy cB wrex vx vh cv ccnv vw cv cima wral vt cv
      cB vf cv wf wps vx vt cv wral wa vf wex vh cv ccnv vw cv cima cB vf cv wf
      wps vx vh cv ccnv vw cv cima wral wa vf wex wph vy cB wrex vx vt cv vh cv
      ccnv vw cv cima raleq1 vt cv vh cv ccnv vw cv cima wceq vt cv cB vf cv wf
      wps vx vt cv wral wa vh cv ccnv vw cv cima cB vf cv wf wps vx vh cv ccnv
      vw cv cima wral wa vf vt cv vh cv ccnv vw cv cima wceq vt cv cB vf cv wf
      vh cv ccnv vw cv cima cB vf cv wf wps vx vt cv wral wps vx vh cv ccnv vw
      cv cima wral vt cv vh cv ccnv vw cv cima cB vf cv feq2 wps vx vt cv vh cv
      ccnv vw cv cima raleq1 anbi12d exbidv imbi12d imbi12d cla4v syl5 ex com23
      imp 19.23adv vt cv vw cv vh cv wf1o vh wex wph vy cB wrex vx vt cv wral
      vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vt cv vw cv vk cv
      wf1o vk wex wph vy cB wrex vx vt cv wral vt cv cB vf cv wf wps vx vt cv
      wral wa vf wex wi wi vt vt cv vw cv vh cv wf1o vh wex vt cv vw cv vk cv
      wf1o vk wex wph vy cB wrex vx vt cv wral vt cv cB vf cv wf wps vx vt cv
      wral wa vf wex wi vt cv vw cv vh cv wf1o vt cv vw cv vk cv wf1o vh vk vt
      cv vw cv vh cv vk cv f1oeq1 cbvexv imbi1i albii sylan2b 19.21aiv ex vz cv
      vw cv vh cv wf1o vh wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf
      wps vx vz cv wral wa vf wex wi wi vt cv vw cv vh cv wf1o vh wex wph vy cB
      wrex vx vt cv wral vt cv cB vf cv wf wps vx vt cv wral wa vf wex wi wi vz
      vt vz cv vt cv wceq vz cv vw cv vh cv wf1o vh wex vt cv vw cv vh cv wf1o
      vh wex wph vy cB wrex vx vz cv wral vz cv cB vf cv wf wps vx vz cv wral
      wa vf wex wi wph vy cB wrex vx vt cv wral vt cv cB vf cv wf wps vx vt cv
      wral wa vf wex wi vz cv vt cv wceq vz cv vw cv vh cv wf1o vt cv vw cv vh
      cv wf1o vh vz cv vt cv vw cv vh cv f1oeq2 exbidv vz cv vt cv wceq wph vy
      cB wrex vx vz cv wral wph vy cB wrex vx vt cv wral vz cv cB vf cv wf wps
      vx vz cv wral wa vf wex vt cv cB vf cv wf wps vx vt cv wral wa vf wex wph
      vy cB wrex vx vz cv vt cv raleq1 vz cv vt cv wceq vz cv cB vf cv wf wps
      vx vz cv wral wa vt cv cB vf cv wf wps vx vt cv wral wa vf vz cv vt cv
      wceq vz cv cB vf cv wf vt cv cB vf cv wf wps vx vz cv wral wps vx vt cv
      wral vz cv vt cv cB vf cv feq2 wps vx vz cv vt cv raleq1 anbi12d exbidv
      imbi12d imbi12d cbvalv syl5ib finds1 syl5 com3r sylbi mpd com12 r19.23aiv
      sylbi imp $.
      $( [29-Jun-2009] $) $( [24-Jun-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Schroeder-Bernstein Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.  $d x D $.  $d x f $.  $d x g $.
    sbthlem.1 $e |- A e. _V $.
    sbthlem.2 $e |- D = { x |
                   ( x C_ A /\ ( g " ( B \ ( f " x ) ) ) C_ ( A \ x ) ) } $.
    $( Lemma for ~ sbth . $)
    sbthlem1 $p |- U. D C_ ( A \ ( g " ( B \ ( f " U. D ) ) ) ) $=
      cD cuni cA vg cv cB vf cv cD cuni cima cdif cima cdif wss vx cv cA vg cv
      cB vf cv cD cuni cima cdif cima cdif wss vx cD vx cD cA vg cv cB vf cv cD
      cuni cima cdif cima cdif unissb vx cv cD wcel vx cv cA vg cv cB vf cv vx
      cv cima cdif cima cdif cA vg cv cB vf cv cD cuni cima cdif cima cdif vx
      cv cD wcel vx cv cA wss vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif
      wss wa vx cv cA vg cv cB vf cv vx cv cima cdif cima cdif wss vx cv cA wss
      vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif wss wa vx cD sbthlem.2
      abeq2i vx cv cA wss vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif wss
      vx cv cA vg cv cB vf cv vx cv cima cdif cima cdif wss vx cv cA wss vg cv
      cB vf cv vx cv cima cdif cima cA vx cv cdif wss vx cv cA vg cv cB vf cv
      vx cv cima cdif cima cdif wss vx cv cA wss vg cv cB vf cv vx cv cima cdif
      cima cA wss vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif wss vx cv
      cA vg cv cB vf cv vx cv cima cdif cima cdif wss wi vg cv cB vf cv vx cv
      cima cdif cima cA vx cv cdif wss vx cv cA wss vg cv cB vf cv vx cv cima
      cdif cima cA wss vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif wss vx
      cv cA vg cv cB vf cv vx cv cima cdif cima cdif wss wi vx cv cA wss vg cv
      cB vf cv vx cv cima cdif cima cA wss wa vx cv cA vg cv cB vf cv vx cv
      cima cdif cima cdif wss vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif
      wss vx cv vg cv cB vf cv vx cv cima cdif cima cA ssconb biimprd ex vg cv
      cB vf cv vx cv cima cdif cima cA vx cv cdif wss cA vx cv cdif cA wss vg
      cv cB vf cv vx cv cima cdif cima cA wss cA vx cv difss vg cv cB vf cv vx
      cv cima cdif cima cA vx cv cdif cA sstr2 mpi syl5 pm2.43d imp sylbi vx cv
      cD wcel cB vf cv cD cuni cima cdif cB vf cv vx cv cima cdif wss vg cv cB
      vf cv cD cuni cima cdif cima vg cv cB vf cv vx cv cima cdif cima wss cA
      vg cv cB vf cv vx cv cima cdif cima cdif cA vg cv cB vf cv cD cuni cima
      cdif cima cdif wss vx cv cD wcel vx cv cD cuni wss vf cv vx cv cima vf cv
      cD cuni cima wss cB vf cv cD cuni cima cdif cB vf cv vx cv cima cdif wss
      vx cv cD elssuni vx cv cD cuni vf cv imass2 vf cv vx cv cima vf cv cD
      cuni cima cB sscon 3syl cB vf cv cD cuni cima cdif cB vf cv vx cv cima
      cdif vg cv imass2 vg cv cB vf cv cD cuni cima cdif cima vg cv cB vf cv vx
      cv cima cdif cima cA sscon 3syl sstrd mprgbir $.
      $( [22-Mar-1998] $)

    $( Lemma for ~ sbth . $)
    sbthlem2 $p |- ( ran g C_ A ->
                     ( A \ ( g " ( B \ ( f " U. D ) ) ) ) C_ U. D ) $=
      vg cv crn cA wss cA vg cv cB vf cv cD cuni cima cdif cima cdif cD wcel cA
      vg cv cB vf cv cD cuni cima cdif cima cdif cD cuni wss vg cv crn cA wss
      cA vg cv cB vf cv cD cuni cima cdif cima cdif vx cv cA wss vg cv cB vf cv
      vx cv cima cdif cima cA vx cv cdif wss wa vx cab cD vg cv crn cA wss cA
      vg cv cB vf cv cD cuni cima cdif cima cdif cA wss vg cv cB vf cv cA vg cv
      cB vf cv cD cuni cima cdif cima cdif cima cdif cima cA cA vg cv cB vf cv
      cD cuni cima cdif cima cdif cdif wss wa cA vg cv cB vf cv cD cuni cima
      cdif cima cdif vx cv cA wss vg cv cB vf cv vx cv cima cdif cima cA vx cv
      cdif wss wa vx cab wcel vg cv crn cA wss vg cv cB vf cv cA vg cv cB vf cv
      cD cuni cima cdif cima cdif cima cdif cima cA cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cdif wss cA vg cv cB vf cv cD cuni cima cdif cima
      cdif cA wss vg cv crn cA wss vg cv cB vf cv cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cima cdif cima cA cA vg cv cB vf cv cD cuni cima cdif
      cima cdif cdif wss cA vg cv cB vf cv cD cuni cima cdif cima cdif cA vg cv
      cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif cima
      cdif wss vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif
      cima cdif cima vg cv cB vf cv cD cuni cima cdif cima wss cA vg cv cB vf
      cv cD cuni cima cdif cima cdif cA vg cv cB vf cv cA vg cv cB vf cv cD
      cuni cima cdif cima cdif cima cdif cima cdif wss cB vf cv cA vg cv cB vf
      cv cD cuni cima cdif cima cdif cima cdif cB vf cv cD cuni cima cdif wss
      vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif
      cima vg cv cB vf cv cD cuni cima cdif cima wss vf cv cD cuni cima vf cv
      cA vg cv cB vf cv cD cuni cima cdif cima cdif cima wss cB vf cv cA vg cv
      cB vf cv cD cuni cima cdif cima cdif cima cdif cB vf cv cD cuni cima cdif
      wss cD cuni cA vg cv cB vf cv cD cuni cima cdif cima cdif wss vf cv cD
      cuni cima vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima wss vx
      cA cB cD vf vg sbthlem.1 sbthlem.2 sbthlem1 cD cuni cA vg cv cB vf cv cD
      cuni cima cdif cima cdif vf cv imass2 ax-mp vf cv cD cuni cima vf cv cA
      vg cv cB vf cv cD cuni cima cdif cima cdif cima cB sscon ax-mp cB vf cv
      cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif cB vf cv cD cuni
      cima cdif vg cv imass2 ax-mp vg cv cB vf cv cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cima cdif cima vg cv cB vf cv cD cuni cima cdif cima
      cA sscon ax-mp vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima
      cdif cima cdif cima cA wss cA vg cv cB vf cv cD cuni cima cdif cima cdif
      cA wss vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima
      cdif cima cA cA vg cv cB vf cv cD cuni cima cdif cima cdif cdif wss cA vg
      cv cB vf cv cD cuni cima cdif cima cdif cA vg cv cB vf cv cA vg cv cB vf
      cv cD cuni cima cdif cima cdif cima cdif cima cdif wss wb vg cv crn cA
      wss vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima
      cdif cima cA vg cv cB vf cv cD cuni cima cdif cima cdif cA ssconb vg cv
      cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif cima vg
      cv crn wss vg cv crn cA wss vg cv cB vf cv cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cima cdif cima cA wss wi vg cv cB vf cv cA vg cv cB vf cv
      cD cuni cima cdif cima cdif cima cdif imassrn vg cv cB vf cv cA vg cv cB
      vf cv cD cuni cima cdif cima cdif cima cdif cima vg cv crn cA sstr2 ax-mp
      cA vg cv cB vf cv cD cuni cima cdif cima difss sylancl mpbiri cA vg cv cB
      vf cv cD cuni cima cdif cima difss jctil vx cv cA wss vg cv cB vf cv vx
      cv cima cdif cima cA vx cv cdif wss wa cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cA wss vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif
      cima cdif cima cdif cima cA cA vg cv cB vf cv cD cuni cima cdif cima cdif
      cdif wss wa vx cA vg cv cB vf cv cD cuni cima cdif cima cdif cA vg cv cB
      vf cv cD cuni cima cdif cima cdif cA sbthlem.1 cA vg cv cB vf cv cD cuni
      cima cdif cima difss ssexi vx cv cA vg cv cB vf cv cD cuni cima cdif cima
      cdif wceq vx cv cA wss cA vg cv cB vf cv cD cuni cima cdif cima cdif cA
      wss vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif wss vg cv cB vf cv
      cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif cima cA cA vg cv
      cB vf cv cD cuni cima cdif cima cdif cdif wss vx cv cA vg cv cB vf cv cD
      cuni cima cdif cima cdif cA sseq1 vx cv cA vg cv cB vf cv cD cuni cima
      cdif cima cdif wceq vg cv cB vf cv vx cv cima cdif cima cA vx cv cdif wss
      vg cv cB vf cv vx cv cima cdif cima cA cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cdif wss vg cv cB vf cv cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cima cdif cima cA cA vg cv cB vf cv cD cuni cima cdif cima
      cdif cdif wss vx cv cA vg cv cB vf cv cD cuni cima cdif cima cdif wceq cA
      vx cv cdif cA cA vg cv cB vf cv cD cuni cima cdif cima cdif cdif vg cv cB
      vf cv vx cv cima cdif cima vx cv cA vg cv cB vf cv cD cuni cima cdif cima
      cdif cA difeq2 sseq2d vx cv cA vg cv cB vf cv cD cuni cima cdif cima cdif
      wceq cB vf cv vx cv cima cdif cB vf cv cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cima cdif wceq vg cv cB vf cv vx cv cima cdif cima vg cv
      cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif cima
      wceq vg cv cB vf cv vx cv cima cdif cima cA cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cdif wss vg cv cB vf cv cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cima cdif cima cA cA vg cv cB vf cv cD cuni cima cdif
      cima cdif cdif wss wb vx cv cA vg cv cB vf cv cD cuni cima cdif cima cdif
      wceq vf cv vx cv cima vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif
      cima cB vx cv cA vg cv cB vf cv cD cuni cima cdif cima cdif vf cv imaeq2
      difeq2d cB vf cv vx cv cima cdif cB vf cv cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cima cdif vg cv imaeq2 vg cv cB vf cv vx cv cima cdif cima
      vg cv cB vf cv cA vg cv cB vf cv cD cuni cima cdif cima cdif cima cdif
      cima cA cA vg cv cB vf cv cD cuni cima cdif cima cdif cdif sseq1 3syl
      bitrd anbi12d elab sylibr sbthlem.2 syl6eleqr cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cD elssuni syl $.
      $( [22-Mar-1998] $)

    $( Lemma for ~ sbth . $)
    sbthlem3 $p |- ( ran g C_ A ->
                  ( g " ( B \ ( f " U. D ) ) ) = ( A \ U. D ) ) $=
      vg cv crn cA wss cA cD cuni cdif cA cA vg cv cB vf cv cD cuni cima cdif
      cima cdif cdif vg cv cB vf cv cD cuni cima cdif cima vg cv crn cA wss cD
      cuni cA vg cv cB vf cv cD cuni cima cdif cima cdif cA vg cv crn cA wss cD
      cuni cA vg cv cB vf cv cD cuni cima cdif cima cdif wss cA vg cv cB vf cv
      cD cuni cima cdif cima cdif cD cuni wss wa cD cuni cA vg cv cB vf cv cD
      cuni cima cdif cima cdif wceq vg cv crn cA wss cA vg cv cB vf cv cD cuni
      cima cdif cima cdif cD cuni wss cD cuni cA vg cv cB vf cv cD cuni cima
      cdif cima cdif wss vx cA cB cD vf vg sbthlem.1 sbthlem.2 sbthlem2 vx cA
      cB cD vf vg sbthlem.1 sbthlem.2 sbthlem1 jctil cD cuni cA vg cv cB vf cv
      cD cuni cima cdif cima cdif eqss sylibr difeq2d vg cv crn cA wss vg cv cB
      vf cv cD cuni cima cdif cima cA wss cA cA vg cv cB vf cv cD cuni cima
      cdif cima cdif cdif vg cv cB vf cv cD cuni cima cdif cima wceq vg cv cB
      vf cv cD cuni cima cdif cima vg cv crn wss vg cv crn cA wss vg cv cB vf
      cv cD cuni cima cdif cima cA wss wi vg cv cB vf cv cD cuni cima cdif
      imassrn vg cv cB vf cv cD cuni cima cdif cima vg cv crn cA sstr2 ax-mp vg
      cv cB vf cv cD cuni cima cdif cima cA dfss4 sylib eqtr2d $.
      $( [22-Mar-1998] $)

    $( Lemma for ~ sbth . $)
    sbthlem4 $p |- ( ( ( dom g = B /\ ran g C_ A ) /\ Fun `' g ) ->
                  ( `' g " ( A \ U. D ) ) = ( B \ ( f " U. D ) ) ) $=
      vg cv cdm cB wceq vg cv crn cA wss wa vg cv ccnv wfun wa cB vf cv cD cuni
      cima cdif vg cv ccnv cA cD cuni cdif cres crn vg cv ccnv cA cD cuni cdif
      cima vg cv cdm cB wceq vg cv crn cA wss vg cv ccnv wfun cB vf cv cD cuni
      cima cdif vg cv ccnv cA cD cuni cdif cres crn wceq vg cv cdm cB wceq vg
      cv crn cA wss vg cv ccnv wfun wa cB vf cv cD cuni cima cdif vg cv cB vf
      cv cD cuni cima cdif cres ccnv crn vg cv ccnv cA cD cuni cdif cres crn vg
      cv cdm cB wceq vg cv cB vf cv cD cuni cima cdif cres cdm cB vf cv cD cuni
      cima cdif vg cv cB vf cv cD cuni cima cdif cres ccnv crn vg cv cdm cB
      wceq cB vf cv cD cuni cima cdif vg cv cdm wss vg cv cB vf cv cD cuni cima
      cdif cres cdm cB vf cv cD cuni cima cdif wceq vg cv cdm cB wceq cB vf cv
      cD cuni cima cdif vg cv cdm wss cB vf cv cD cuni cima cdif cB wss cB vf
      cv cD cuni cima difss vg cv cdm cB cB vf cv cD cuni cima cdif sseq2
      mpbiri cB vf cv cD cuni cima cdif vg cv ssdmres sylib vg cv cB vf cv cD
      cuni cima cdif cres dfdm4 syl5reqr vg cv crn cA wss vg cv ccnv wfun wa vg
      cv cB vf cv cD cuni cima cdif cres ccnv vg cv ccnv cA cD cuni cdif cres
      vg cv ccnv wfun vg cv crn cA wss vg cv cB vf cv cD cuni cima cdif cres
      ccnv vg cv ccnv vg cv cB vf cv cD cuni cima cdif cima cres vg cv ccnv cA
      cD cuni cdif cres cB vf cv cD cuni cima cdif vg cv funcnvres vg cv crn cA
      wss vg cv cB vf cv cD cuni cima cdif cima cA cD cuni cdif wceq vg cv ccnv
      vg cv cB vf cv cD cuni cima cdif cima cres vg cv ccnv cA cD cuni cdif
      cres wceq vx cA cB cD vf vg sbthlem.1 sbthlem.2 sbthlem3 vg cv cB vf cv
      cD cuni cima cdif cima cA cD cuni cdif vg cv ccnv reseq2 syl sylan9eqr
      rneqd sylan9eq anassrs vg cv ccnv cA cD cuni cdif df-ima syl6reqr $.
      $( [27-Mar-1998] $)

    ${
      $d x H $.
      sbthlem.3 $e |- H = ( ( f |` U. D ) u. ( `' g |` ( A \ U. D ) ) ) $.

      $( Lemma for ~ sbth . $)
      sbthlem5 $p |- ( ( dom f = A /\ ran g C_ A ) -> dom H = A ) $=
        vf cv cdm cA wceq vg cv crn cA wss wa cH cdm cD cuni cA cD cuni cdif
        cun cA vf cv cdm cA wceq vg cv crn cA wss wa cD cuni cA cD cuni cdif
        cun cD cuni vf cv cdm cin cA cD cuni cdif vg cv crn cin cun cH cdm vf
        cv cdm cA wceq vg cv crn cA wss cD cuni cA cD cuni cdif cun cD cuni vf
        cv cdm cin cA cD cuni cdif cun cD cuni vf cv cdm cin cA cD cuni cdif vg
        cv crn cin cun vf cv cdm cA wceq cD cuni cD cuni vf cv cdm cin cA cD
        cuni cdif vf cv cdm cA wceq cD cuni vf cv cdm wss cD cuni cD cuni vf cv
        cdm cin wceq vf cv cdm cA wceq cD cuni vf cv cdm wss cD cuni cA wss cD
        cuni cA vg cv cB vf cv cD cuni cima cdif cima cdif cA vx cA cB cD vf vg
        sbthlem.1 sbthlem.2 sbthlem1 cA vg cv cB vf cv cD cuni cima cdif cima
        difss sstri vf cv cdm cA cD cuni sseq2 mpbiri cD cuni vf cv cdm dfss
        sylib uneq1d vg cv crn cA wss cA cD cuni cdif cA cD cuni cdif vg cv crn
        cin cD cuni vf cv cdm cin vg cv crn cA wss cA cD cuni cdif vg cv crn
        wss cA cD cuni cdif cA cD cuni cdif vg cv crn cin wceq vg cv crn cA wss
        vg cv cB vf cv cD cuni cima cdif cima vg cv crn wss cA cD cuni cdif vg
        cv crn wss vg cv cB vf cv cD cuni cima cdif imassrn vg cv crn cA wss vg
        cv cB vf cv cD cuni cima cdif cima cA cD cuni cdif vg cv crn vx cA cB
        cD vf vg sbthlem.1 sbthlem.2 sbthlem3 sseq1d mpbii cA cD cuni cdif vg
        cv crn dfss sylib uneq2d sylan9eq cH cdm vf cv cD cuni cres vg cv ccnv
        cA cD cuni cdif cres cun cdm vf cv cD cuni cres cdm vg cv ccnv cA cD
        cuni cdif cres cdm cun cD cuni vf cv cdm cin cA cD cuni cdif vg cv crn
        cin cun cH vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres cun
        sbthlem.3 dmeqi vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres dmun
        vf cv cD cuni cres cdm cD cuni vf cv cdm cin vg cv ccnv cA cD cuni cdif
        cres cdm cA cD cuni cdif vg cv crn cin vf cv cD cuni dmres vg cv ccnv
        cA cD cuni cdif cres cdm cA cD cuni cdif vg cv ccnv cdm cin cA cD cuni
        cdif vg cv crn cin vg cv ccnv cA cD cuni cdif dmres vg cv ccnv cdm vg
        cv crn cA cD cuni cdif vg cv crn vg cv ccnv cdm vg cv df-rn eqcomi
        ineq2i eqtri uneq12i 3eqtri syl6reqr cD cuni cA wss cD cuni cA cD cuni
        cdif cun cA wceq cD cuni cA vg cv cB vf cv cD cuni cima cdif cima cdif
        cA vx cA cB cD vf vg sbthlem.1 sbthlem.2 sbthlem1 cA vg cv cB vf cv cD
        cuni cima cdif cima difss sstri cD cuni cA undif mpbi syl6eq $.
        $( [22-Mar-1998] $)

      $( Lemma for ~ sbth . $)
      sbthlem6 $p |- ( ( ran f C_ B /\
               ( ( dom g = B /\ ran g C_ A ) /\ Fun `' g ) ) -> ran H = B ) $=
        vg cv cdm cB wceq vg cv crn cA wss wa vg cv ccnv wfun wa vf cv crn cB
        wss cH crn vf cv cD cuni cima cB vf cv cD cuni cima cdif cun cB vg cv
        cdm cB wceq vg cv crn cA wss wa vg cv ccnv wfun wa vf cv cD cuni cima
        cB vf cv cD cuni cima cdif cun vf cv cD cuni cima vg cv ccnv cA cD cuni
        cdif cres crn cun cH crn vg cv cdm cB wceq vg cv crn cA wss wa vg cv
        ccnv wfun wa cB vf cv cD cuni cima cdif vg cv ccnv cA cD cuni cdif cres
        crn vf cv cD cuni cima vg cv cdm cB wceq vg cv crn cA wss wa vg cv ccnv
        wfun wa vg cv ccnv cA cD cuni cdif cima cB vf cv cD cuni cima cdif vg
        cv ccnv cA cD cuni cdif cres crn vx cA cB cD vf vg sbthlem.1 sbthlem.2
        sbthlem4 vg cv ccnv cA cD cuni cdif df-ima syl5reqr uneq2d vf cv cD
        cuni cres vg cv ccnv cA cD cuni cdif cres cun crn vf cv cD cuni cres
        crn vg cv ccnv cA cD cuni cdif cres crn cun cH crn vf cv cD cuni cima
        vg cv ccnv cA cD cuni cdif cres crn cun vf cv cD cuni cres vg cv ccnv
        cA cD cuni cdif cres rnun cH vf cv cD cuni cres vg cv ccnv cA cD cuni
        cdif cres cun sbthlem.3 rneqi vf cv cD cuni cima vf cv cD cuni cres crn
        vg cv ccnv cA cD cuni cdif cres crn vf cv cD cuni df-ima uneq1i 3eqtr4i
        syl6reqr vf cv crn cB wss vf cv cD cuni cima cB wss vf cv cD cuni cima
        cB vf cv cD cuni cima cdif cun cB wceq vf cv cD cuni cima vf cv crn wss
        vf cv crn cB wss vf cv cD cuni cima cB wss wi vf cv cD cuni imassrn vf
        cv cD cuni cima vf cv crn cB sstr2 ax-mp vf cv cD cuni cima cB undif
        sylib sylan9eqr $.
        $( [27-Mar-1998] $)

      $( Lemma for ~ sbth . $)
      sbthlem7 $p |- ( ( Fun f /\ Fun `' g ) -> Fun H ) $=
        vf cv wfun vg cv ccnv wfun wa vf cv cD cuni cres vg cv ccnv cA cD cuni
        cdif cres cun wfun cH wfun vf cv cD cuni cres wfun vg cv ccnv cA cD
        cuni cdif cres wfun vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres
        cun wfun vf cv wfun vg cv ccnv wfun vf cv cD cuni cres wfun vg cv ccnv
        cA cD cuni cdif cres wfun wa vf cv cD cuni cres cdm vg cv ccnv cA cD
        cuni cdif cres cdm cin c0 wceq vf cv cD cuni cres vg cv ccnv cA cD cuni
        cdif cres cun wfun vf cv cD cuni cres cdm vg cv ccnv cA cD cuni cdif
        cres cdm cin c0 wss vf cv cD cuni cres cdm vg cv ccnv cA cD cuni cdif
        cres cdm cin c0 wceq vf cv cD cuni cres cdm vg cv ccnv cA cD cuni cdif
        cres cdm cin cD cuni cA cD cuni cdif cin c0 vf cv cD cuni cres cdm vg
        cv ccnv cA cD cuni cdif cres cdm cin cD cuni vg cv ccnv cA cD cuni cdif
        cres cdm cin cD cuni cA cD cuni cdif cin vf cv cD cuni cres cdm cD cuni
        wss vf cv cD cuni cres cdm vg cv ccnv cA cD cuni cdif cres cdm cin cD
        cuni vg cv ccnv cA cD cuni cdif cres cdm cin wss vf cv cD cuni cres cdm
        cD cuni vf cv cdm cin cD cuni vf cv cD cuni dmres cD cuni vf cv cdm
        inss1 eqsstri vf cv cD cuni cres cdm cD cuni vg cv ccnv cA cD cuni cdif
        cres cdm ssrin ax-mp vg cv ccnv cA cD cuni cdif cres cdm cA cD cuni
        cdif wss cD cuni vg cv ccnv cA cD cuni cdif cres cdm cin cD cuni cA cD
        cuni cdif cin wss vg cv ccnv cA cD cuni cdif cres cdm cA cD cuni cdif
        vg cv ccnv cdm cin cA cD cuni cdif vg cv ccnv cA cD cuni cdif dmres cA
        cD cuni cdif vg cv ccnv cdm inss1 eqsstri vg cv ccnv cA cD cuni cdif
        cres cdm cA cD cuni cdif cD cuni sslin ax-mp sstri cD cuni cA difdisj
        sseqtri vf cv cD cuni cres cdm vg cv ccnv cA cD cuni cdif cres cdm cin
        ss0 ax-mp vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres funun
        mpan2 cD cuni vf cv funres cA cD cuni cdif vg cv ccnv funres syl2an cH
        vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres cun wceq cH wfun vf
        cv cD cuni cres vg cv ccnv cA cD cuni cdif cres cun wfun wb sbthlem.3
        cH vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres cun funeq ax-mp
        sylibr $.
        $( [27-Mar-1998] $)

      $( Lemma for ~ sbth . $)
      sbthlem8 $p |- ( ( Fun `' f /\ ( ( ( Fun g /\ dom g = B ) /\ ran g C_ A )
                     /\ Fun `' g ) ) -> Fun `' H ) $=
        vf cv ccnv wfun vg cv wfun vg cv cdm cB wceq wa vg cv crn cA wss wa vg
        cv ccnv wfun wa wa vf cv cD cuni cres ccnv vg cv ccnv cA cD cuni cdif
        cres ccnv cun wfun cH ccnv wfun vf cv cD cuni cres ccnv wfun vg cv ccnv
        cA cD cuni cdif cres ccnv wfun wa vf cv cD cuni cres ccnv cdm vg cv
        ccnv cA cD cuni cdif cres ccnv cdm cin c0 wceq vf cv cD cuni cres ccnv
        vg cv ccnv cA cD cuni cdif cres ccnv cun wfun vf cv ccnv wfun vg cv
        wfun vg cv cdm cB wceq wa vg cv crn cA wss wa vg cv ccnv wfun wa wa vf
        cv cD cuni cres ccnv vg cv ccnv cA cD cuni cdif cres ccnv funun vf cv
        ccnv wfun vf cv cD cuni cres ccnv wfun vg cv wfun vg cv cdm cB wceq wa
        vg cv crn cA wss wa vg cv ccnv wfun wa vg cv ccnv cA cD cuni cdif cres
        ccnv wfun cD cuni vf cv funres11 vg cv wfun vg cv cdm cB wceq wa vg cv
        ccnv cA cD cuni cdif cres ccnv wfun vg cv crn cA wss vg cv ccnv wfun vg
        cv wfun vg cv ccnv cA cD cuni cdif cres ccnv wfun vg cv cdm cB wceq vg
        cv wfun vg cv ccnv ccnv wfun vg cv ccnv cA cD cuni cdif cres ccnv wfun
        vg cv funcnvcnv cA cD cuni cdif vg cv ccnv funres11 syl adantr ad2antrr
        anim12i vg cv wfun vg cv cdm cB wceq wa vg cv crn cA wss wa vg cv ccnv
        wfun wa vf cv cD cuni cres ccnv cdm vg cv ccnv cA cD cuni cdif cres
        ccnv cdm cin c0 wceq vf cv ccnv wfun vg cv cdm cB wceq vg cv crn cA wss
        vg cv ccnv wfun vf cv cD cuni cres ccnv cdm vg cv ccnv cA cD cuni cdif
        cres ccnv cdm cin c0 wceq vg cv wfun vg cv cdm cB wceq vg cv crn cA wss
        wa vg cv ccnv wfun wa vf cv cD cuni cres ccnv cdm vg cv ccnv cA cD cuni
        cdif cres ccnv cdm cin vf cv cD cuni cima cB vf cv cD cuni cima cdif
        cin c0 vf cv cD cuni cres ccnv cdm vf cv cD cuni cima wceq vg cv ccnv
        cA cD cuni cdif cres ccnv cdm cB vf cv cD cuni cima cdif wceq vf cv cD
        cuni cres ccnv cdm vg cv ccnv cA cD cuni cdif cres ccnv cdm cin vf cv
        cD cuni cima cB vf cv cD cuni cima cdif cin wceq vg cv cdm cB wceq vg
        cv crn cA wss wa vg cv ccnv wfun wa vf cv cD cuni cres ccnv cdm vf cv
        cD cuni cima vg cv ccnv cA cD cuni cdif cres ccnv cdm cB vf cv cD cuni
        cima cdif ineq12 vf cv cD cuni cima vf cv cD cuni cres crn vf cv cD
        cuni cres ccnv cdm vf cv cD cuni df-ima vf cv cD cuni cres df-rn eqtr2i
        vg cv cdm cB wceq vg cv crn cA wss wa vg cv ccnv wfun wa vg cv ccnv cA
        cD cuni cdif cima cB vf cv cD cuni cima cdif vg cv ccnv cA cD cuni cdif
        cres ccnv cdm vx cA cB cD vf vg sbthlem.1 sbthlem.2 sbthlem4 vg cv ccnv
        cA cD cuni cdif cima vg cv ccnv cA cD cuni cdif cres crn vg cv ccnv cA
        cD cuni cdif cres ccnv cdm vg cv ccnv cA cD cuni cdif df-ima vg cv ccnv
        cA cD cuni cdif cres df-rn eqtri syl5eqr sylancr vf cv cD cuni cima cB
        difdisj syl6eq adantlll adantl sylanc cH ccnv vf cv cD cuni cres ccnv
        vg cv ccnv cA cD cuni cdif cres ccnv cun wceq cH ccnv wfun vf cv cD
        cuni cres ccnv vg cv ccnv cA cD cuni cdif cres ccnv cun wfun wb cH ccnv
        vf cv cD cuni cres vg cv ccnv cA cD cuni cdif cres cun ccnv vf cv cD
        cuni cres ccnv vg cv ccnv cA cD cuni cdif cres ccnv cun cH vf cv cD
        cuni cres vg cv ccnv cA cD cuni cdif cres cun sbthlem.3 cnveqi vf cv cD
        cuni cres vg cv ccnv cA cD cuni cdif cres cnvun eqtri cH ccnv vf cv cD
        cuni cres ccnv vg cv ccnv cA cD cuni cdif cres ccnv cun funeq ax-mp
        sylibr $.
        $( [27-Mar-1998] $)

      $( Lemma for ~ sbth . $)
      sbthlem9 $p |- ( ( f : A -1-1-> B /\ g : B -1-1-> A ) ->
                    H : A -1-1-onto-> B ) $=
        vf cv wfun vf cv cdm cA wceq wa vf cv crn cB wss wa vf cv ccnv wfun wa
        vg cv wfun vg cv cdm cB wceq wa vg cv crn cA wss wa vg cv ccnv wfun wa
        wa cH wfun cH cdm cA wceq wa cH ccnv wfun cH ccnv cdm cB wceq wa wa cA
        cB vf cv wf1 cB cA vg cv wf1 wa cA cB cH wf1o vf cv wfun vf cv cdm cA
        wceq wa vf cv crn cB wss wa vf cv ccnv wfun wa vg cv wfun vg cv cdm cB
        wceq wa vg cv crn cA wss wa vg cv ccnv wfun wa wa cH wfun cH cdm cA
        wceq wa cH ccnv wfun cH ccnv cdm cB wceq vf cv wfun vf cv cdm cA wceq
        wa vf cv crn cB wss wa vg cv wfun vg cv cdm cB wceq wa vg cv crn cA wss
        wa vg cv ccnv wfun wa cH wfun cH cdm cA wceq wa vf cv ccnv wfun vf cv
        wfun vf cv cdm cA wceq wa vg cv wfun vg cv cdm cB wceq wa vg cv crn cA
        wss wa vg cv ccnv wfun wa cH wfun cH cdm cA wceq wa vf cv crn cB wss vf
        cv wfun vg cv ccnv wfun vf cv cdm cA wceq vg cv wfun vg cv cdm cB wceq
        wa vg cv crn cA wss wa cH wfun cH cdm cA wceq wa vf cv wfun vg cv ccnv
        wfun wa cH wfun vf cv cdm cA wceq vg cv wfun vg cv cdm cB wceq wa vg cv
        crn cA wss wa wa cH cdm cA wceq vx cA cB cD vf vg cH sbthlem.1
        sbthlem.2 sbthlem.3 sbthlem7 vf cv cdm cA wceq vg cv crn cA wss cH cdm
        cA wceq vg cv wfun vg cv cdm cB wceq wa vx cA cB cD vf vg cH sbthlem.1
        sbthlem.2 sbthlem.3 sbthlem5 adantrl anim12i an42s adantlr adantlr vf
        cv ccnv wfun vg cv wfun vg cv cdm cB wceq wa vg cv crn cA wss wa vg cv
        ccnv wfun wa cH ccnv wfun vf cv wfun vf cv cdm cA wceq wa vf cv crn cB
        wss wa vx cA cB cD vf vg cH sbthlem.1 sbthlem.2 sbthlem.3 sbthlem8
        adantll vf cv wfun vf cv cdm cA wceq wa vf cv crn cB wss wa vg cv wfun
        vg cv cdm cB wceq wa vg cv crn cA wss wa vg cv ccnv wfun wa cH ccnv cdm
        cB wceq vf cv ccnv wfun vf cv crn cB wss vg cv wfun vg cv cdm cB wceq
        wa vg cv crn cA wss wa vg cv ccnv wfun wa cH ccnv cdm cB wceq vf cv
        wfun vf cv cdm cA wceq wa vf cv crn cB wss vg cv cdm cB wceq vg cv crn
        cA wss wa vg cv ccnv wfun cH ccnv cdm cB wceq vg cv wfun vg cv cdm cB
        wceq wa vg cv crn cA wss wa vf cv crn cB wss vg cv cdm cB wceq vg cv
        crn cA wss wa vg cv ccnv wfun wa wa cH crn cB cH ccnv cdm vx cA cB cD
        vf vg cH sbthlem.1 sbthlem.2 sbthlem.3 sbthlem6 cH df-rn syl5eqr vg cv
        wfun vg cv cdm cB wceq wa vg cv cdm cB wceq vg cv crn cA wss vg cv wfun
        vg cv cdm cB wceq pm3.27 anim1i sylanr1 adantll adantlr jca32 cA cB vf
        cv wf1 vf cv wfun vf cv cdm cA wceq wa vf cv crn cB wss wa vf cv ccnv
        wfun wa cB cA vg cv wf1 vg cv wfun vg cv cdm cB wceq wa vg cv crn cA
        wss wa vg cv ccnv wfun wa cA cB vf cv wf1 cA cB vf cv wf vf cv ccnv
        wfun wa vf cv wfun vf cv cdm cA wceq wa vf cv crn cB wss wa vf cv ccnv
        wfun wa cA cB vf cv df-f1 cA cB vf cv wf vf cv wfun vf cv cdm cA wceq
        wa vf cv crn cB wss wa vf cv ccnv wfun cA cB vf cv wf vf cv cA wfn vf
        cv crn cB wss wa vf cv wfun vf cv cdm cA wceq wa vf cv crn cB wss wa cA
        cB vf cv df-f vf cv cA wfn vf cv wfun vf cv cdm cA wceq wa vf cv crn cB
        wss vf cv cA df-fn anbi1i bitri anbi1i bitri cB cA vg cv wf1 cB cA vg
        cv wf vg cv ccnv wfun wa vg cv wfun vg cv cdm cB wceq wa vg cv crn cA
        wss wa vg cv ccnv wfun wa cB cA vg cv df-f1 cB cA vg cv wf vg cv wfun
        vg cv cdm cB wceq wa vg cv crn cA wss wa vg cv ccnv wfun cB cA vg cv wf
        vg cv cB wfn vg cv crn cA wss wa vg cv wfun vg cv cdm cB wceq wa vg cv
        crn cA wss wa cB cA vg cv df-f vg cv cB wfn vg cv wfun vg cv cdm cB
        wceq wa vg cv crn cA wss vg cv cB df-fn anbi1i bitri anbi1i bitri
        anbi12i cA cB cH wf1o cH cA wfn cH ccnv cB wfn wa cH wfun cH cdm cA
        wceq wa cH ccnv wfun cH ccnv cdm cB wceq wa wa cA cB cH dff1o4 cH cA
        wfn cH wfun cH cdm cA wceq wa cH ccnv cB wfn cH ccnv wfun cH ccnv cdm
        cB wceq wa cH cA df-fn cH ccnv cB df-fn anbi12i bitri 3imtr4i $.
        $( [28-Mar-1998] $)

      ${
        $d f g A $.  $d f g B $.
        sbthlem.4 $e |- B e. _V $.
        $( Lemma for ~ sbth . $)
        sbthlem10 $p |- ( ( A ~<_ B /\ B ~<_ A ) -> A ~~ B ) $=
          cA cB cdom wbr cB cA cdom wbr wa cA cB vf cv wf1 cB cA vg cv wf1 wa
          vg wex vf wex cA cB cen wbr cA cB cdom wbr cB cA cdom wbr wa cA cB vf
          cv wf1 vf wex cB cA vg cv wf1 vg wex wa cA cB vf cv wf1 cB cA vg cv
          wf1 wa vg wex vf wex cA cB cdom wbr cA cB vf cv wf1 vf wex cB cA cdom
          wbr cB cA vg cv wf1 vg wex cA cB vf sbthlem.4 brdom cB cA vg
          sbthlem.1 brdom anbi12i cA cB vf cv wf1 cB cA vg cv wf1 vf vg eeanv
          bitr4i cA cB vf cv wf1 cB cA vg cv wf1 wa cA cB cen wbr vf vg cA cB
          vf cv wf1 cB cA vg cv wf1 wa cA cB cH wf1o cA cB cen wbr vx cA cB cD
          vf vg cH sbthlem.1 sbthlem.2 sbthlem.3 sbthlem9 cA cB cH sbthlem.1
          f1oen syl 19.23aivv sylbi $.
          $( [20-Jan-2007] $) $( [28-Mar-1998] $)
      $}
    $}

  $}

  ${
    $d x y z w f g A $.  $d x y z w f g B $.
    $( Schroeder-Bernstein Theorem.  Theorem 18 of [Suppes] p. 95.  This
       theorem states that if set ` A ` is smaller (has lower cardinality) than
       ` B ` and vice-versa, then ` A ` and ` B ` are equinumerous (have the
       same cardinality).  The interesting thing is that this can be proved
       without invoking the Axiom of Choice, as we do here, but the proof as
       you can see is quite difficult.  (The theorem can be proved more easily
       if we allow AC.)  The main proof consists of lemmas ~ sbthlem1 through
       ~ sbthlem10 ; this final piece mainly changes bound variables to
       eliminate the hypotheses of ~ sbthlem10 .  We follow closely the proof
       in Suppes, which you should consult to understand our proof at a higher
       level.  Note that Suppes' proof, which is credited to J. M. Whitaker,
       does not require the Axiom of Infinity. $)
    sbth $p |- ( ( A ~<_ B /\ B ~<_ A ) -> A ~~ B ) $=
      cA cB cdom wbr cB cA cdom wbr wa cA cB cen wbr cA cvv wcel cB cvv wcel cA
      cB cdom wbr cB cA cdom wbr wa cA cB cen wbr wi cA cB cdom wbr cB cA cdom
      wbr vz cv vw cv cdom wbr vw cv vz cv cdom wbr wa vz cv vw cv cen wbr wi
      cA vw cv cdom wbr vw cv cA cdom wbr wa cA vw cv cen wbr wi cA cB cdom wbr
      cB cA cdom wbr wa cA cB cen wbr wi vz vw cA cB cvv cvv vz cv cA wceq vz
      cv vw cv cdom wbr vw cv vz cv cdom wbr wa cA vw cv cdom wbr vw cv cA cdom
      wbr wa vz cv vw cv cen wbr cA vw cv cen wbr vz cv cA wceq vz cv vw cv
      cdom wbr cA vw cv cdom wbr vw cv vz cv cdom wbr vw cv cA cdom wbr vz cv
      cA vw cv cdom breq1 vz cv cA vw cv cdom breq2 anbi12d vz cv cA vw cv cen
      breq1 imbi12d vw cv cB wceq cA vw cv cdom wbr vw cv cA cdom wbr wa cA cB
      cdom wbr cB cA cdom wbr wa cA vw cv cen wbr cA cB cen wbr vw cv cB wceq
      cA vw cv cdom wbr cA cB cdom wbr vw cv cA cdom wbr cB cA cdom wbr vw cv
      cB cA cdom breq2 vw cv cB cA cdom breq1 anbi12d vw cv cB cA cen breq2
      imbi12d vx vz cv vw cv vy cv vz cv wss vg cv vw cv vf cv vy cv cima cdif
      cima vz cv vy cv cdif wss wa vy cab vf vg vf cv vy cv vz cv wss vg cv vw
      cv vf cv vy cv cima cdif cima vz cv vy cv cdif wss wa vy cab cuni cres vg
      cv ccnv vz cv vy cv vz cv wss vg cv vw cv vf cv vy cv cima cdif cima vz
      cv vy cv cdif wss wa vy cab cuni cdif cres cun vz visset vy cv vz cv wss
      vg cv vw cv vf cv vy cv cima cdif cima vz cv vy cv cdif wss wa vx cv vz
      cv wss vg cv vw cv vf cv vx cv cima cdif cima vz cv vx cv cdif wss wa vy
      vx vy cv vx cv wceq vy cv vz cv wss vx cv vz cv wss vg cv vw cv vf cv vy
      cv cima cdif cima vz cv vy cv cdif wss vg cv vw cv vf cv vx cv cima cdif
      cima vz cv vx cv cdif wss vy cv vx cv vz cv sseq1 vy cv vx cv wceq vg cv
      vw cv vf cv vy cv cima cdif cima vz cv vy cv cdif wss vg cv vw cv vf cv
      vx cv cima cdif cima vz cv vy cv cdif wss vg cv vw cv vf cv vx cv cima
      cdif cima vz cv vx cv cdif wss vy cv vx cv wceq vw cv vf cv vy cv cima
      cdif vw cv vf cv vx cv cima cdif wceq vg cv vw cv vf cv vy cv cima cdif
      cima vg cv vw cv vf cv vx cv cima cdif cima wceq vg cv vw cv vf cv vy cv
      cima cdif cima vz cv vy cv cdif wss vg cv vw cv vf cv vx cv cima cdif
      cima vz cv vy cv cdif wss wb vy cv vx cv wceq vf cv vy cv cima vf cv vx
      cv cima vw cv vy cv vx cv vf cv imaeq2 difeq2d vw cv vf cv vy cv cima
      cdif vw cv vf cv vx cv cima cdif vg cv imaeq2 vg cv vw cv vf cv vy cv
      cima cdif cima vg cv vw cv vf cv vx cv cima cdif cima vz cv vy cv cdif
      sseq1 3syl vy cv vx cv wceq vz cv vy cv cdif vz cv vx cv cdif vg cv vw cv
      vf cv vx cv cima cdif cima vy cv vx cv vz cv difeq2 sseq2d bitrd anbi12d
      cbvabv vf cv vy cv vz cv wss vg cv vw cv vf cv vy cv cima cdif cima vz cv
      vy cv cdif wss wa vy cab cuni cres vg cv ccnv vz cv vy cv vz cv wss vg cv
      vw cv vf cv vy cv cima cdif cima vz cv vy cv cdif wss wa vy cab cuni cdif
      cres cun eqid vw visset sbthlem10 vtocl2g cA cB cdom reldom brrelexi cB
      cA cdom reldom brrelexi syl2an pm2.43i $.
      $( [20-Jan-2007] $) $( [8-Jun-1998] $)
  $}

  $( Schroeder-Bernstein Theorem and its converse. $)
  sbthbg $p |- ( B e. C -> ( ( A ~<_ B /\ B ~<_ A ) <-> A ~~ B ) ) $=
    cB cC wcel cA cB cdom wbr cB cA cdom wbr wa cA cB cen wbr cA cB sbth cB cC
    wcel cA cB cen wbr cA cB cdom wbr cB cA cdom wbr cA cB cen wbr cA cB cdom
    wbr wi cB cC wcel cA cB endom a1i cB cC wcel cA cB cen wbr cB cA cen wbr cB
    cA cdom wbr cA cB cC ensymg cB cA endom syl6 jcad impbid2 $.
    $( [8-Jun-1998] $)

  ${
    $d x y $.
    $( Schroeder-Bernstein Theorem in class form. $)
    sbthcl $p |- ~~ = ( ~<_ i^i `' ~<_ ) $=
      vx vy cen cdom cdom ccnv cin relen cdom wrel cdom cdom ccnv cin wrel
      reldom cdom cdom ccnv relin1 ax-mp vx cv vy cv cdom wbr vy cv vx cv cdom
      wbr wa vx cv vy cv cen wbr vx cv vy cv cop cdom cdom ccnv cin wcel vx cv
      vy cv cop cen wcel vy cv cvv wcel vx cv vy cv cdom wbr vy cv vx cv cdom
      wbr wa vx cv vy cv cen wbr wb vy visset vx cv vy cv cvv sbthbg ax-mp vx
      cv vy cv cdom wbr vy cv vx cv cdom wbr wa vx cv vy cv cop cdom wcel vx cv
      vy cv cop cdom ccnv wcel wa vx cv vy cv cop cdom cdom ccnv cin wcel vx cv
      vy cv cdom wbr vx cv vy cv cop cdom wcel vy cv vx cv cdom wbr vx cv vy cv
      cop cdom ccnv wcel vx cv vy cv cdom df-br vy cv vx cv cdom wbr vy cv vx
      cv cop cdom wcel vx cv vy cv cop cdom ccnv wcel vy cv vx cv cdom df-br vx
      cv vy cv cdom vx visset vy visset opelcnv bitr4i anbi12i vx cv vy cv cop
      cdom cdom ccnv elin bitr4i vx cv vy cv cen df-br 3bitr3ri eqrelriv $.
      $( [28-Mar-1998] $)
  $}

  $( Alternate definition of strict dominance.  Compare Definition 3 of
     [Suppes] p. 97. $)
  dfsdom2 $p |- ~< = ( ~<_ \ `' ~<_ ) $=
    csdm cdom cen cdif cdom cdom cdom ccnv cin cdif cdom cdom ccnv cdif df-sdom
    cen cdom cdom ccnv cin cdom sbthcl difeq2i cdom cdom ccnv difin 3eqtri $.
    $( [31-Mar-1998] $)

  ${
    brsdom2.1 $e |- A e. _V $.
    brsdom2.2 $e |- B e. _V $.
    $( Alternate definition of strict dominance.  Definition 3 of [Suppes]
       p. 97. $)
    brsdom2 $p |- ( A ~< B <-> ( A ~<_ B /\ -. B ~<_ A ) ) $=
      cA cB cop csdm wcel cA cB cop cdom cdom ccnv cdif wcel cA cB csdm wbr cA
      cB cdom wbr cB cA cdom wbr wn wa csdm cdom cdom ccnv cdif cA cB cop
      dfsdom2 eleq2i cA cB csdm df-br cA cB cdom wbr cB cA cdom wbr wn wa cA cB
      cop cdom wcel cA cB cop cdom ccnv wcel wn wa cA cB cop cdom cdom ccnv
      cdif wcel cA cB cdom wbr cA cB cop cdom wcel cB cA cdom wbr wn cA cB cop
      cdom ccnv wcel wn cA cB cdom df-br cB cA cdom wbr cA cB cop cdom ccnv
      wcel cB cA cdom wbr cB cA cop cdom wcel cA cB cop cdom ccnv wcel cB cA
      cdom df-br cA cB cdom brsdom2.1 brsdom2.2 opelcnv bitr4i notbii anbi12i
      cA cB cop cdom cdom ccnv eldif bitr4i 3bitr4i $.
      $( [19-Aug-2004] $) $( [27-Jul-2004] $)
  $}

  $( Strict dominance is not symmetric.  Theorem 21(ii) of [Suppes] p. 97. $)
  sdomnsym $p |- ( A ~< B -> -. B ~< A ) $=
    cA cB csdm wbr cB cA csdm wbr cA cB cen wbr cA cB sdomnen cA cB csdm wbr cB
    cA csdm wbr cA cB cen wbr cA cB cdom wbr cB cA cdom wbr cA cB cen wbr cA cB
    csdm wbr cB cA csdm wbr cA cB sbth cA cB sdomdom cB cA sdomdom syl2an ex
    mtod $.
    $( [8-Jun-1998] $)

  $( Theorem 22(i) of [Suppes] p. 97. $)
  domnsym $p |- ( A ~<_ B -> -. B ~< A ) $=
    cA cB cdom wbr cA cB csdm wbr cA cB cen wbr wo cB cA csdm wbr wn cA cB
    brdom2 cA cB csdm wbr cB cA csdm wbr wn cA cB cen wbr cA cB sdomnsym cB cA
    csdm wbr cA cB cen wbr cB cvv wcel cB cA cen wbr wn cA cB cen wbr wn cB cA
    csdm wbr cB cvv wcel cA cB cen wbr cB cA cen wbr cA cB cvv ensymg con3d cB
    cA csdm relsdom brrelexi cB cA sdomnen sylc con2i jaoi sylbi $.
    $( [10-Jun-1998] $)

  $( Any set dominates the empty set. $)
  0dom $p |- (/) ~<_ A $=
    c0 cvv wcel c0 cA wss c0 cA cdom wbr 0ex cA 0ss c0 cA cvv ssdomg mp2 $.
    $( [10-Nov-2003] $) $( [26-Oct-2003] $)

  $( A set dominated by the empty set is empty. $)
  dom0 $p |- ( A ~<_ (/) <-> A = (/) ) $=
    cA c0 cdom wbr cA c0 cdom wbr c0 cA cdom wbr wa cA c0 cen wbr cA c0 wceq c0
    cA cdom wbr cA c0 cdom wbr cA 0dom biantru c0 cvv wcel cA c0 cdom wbr c0 cA
    cdom wbr wa cA c0 cen wbr wb 0ex cA c0 cvv sbthbg ax-mp cA en0 3bitri $.
    $( [24-Nov-2004] $) $( [22-Nov-2004] $)

  $( A set strictly dominates the empty set iff it is not empty. $)
  0sdomg $p |- ( A e. B -> ( (/) ~< A <-> A =/= (/) ) ) $=
    cA cB wcel c0 cA cen wbr wn cA c0 wceq wn c0 cA csdm wbr cA c0 wne cA cB
    wcel c0 cA cen wbr cA c0 wceq cA cB wcel c0 cA cen wbr cA c0 cen wbr cA c0
    wceq cA cB wcel c0 cA cen wbr cA c0 cen wbr c0 cA cB ensymg cA c0 0ex ensym
    impbid1 cA en0 syl6bb notbid c0 cA csdm wbr c0 cA cdom wbr c0 cA cen wbr wn
    c0 cA brsdom cA 0dom mpbiran cA c0 df-ne 3bitr4g $.
    $( [25-Nov-2006] $) $( [23-Mar-2006] $)

  ${
    0sdom.1 $e |- A e. _V $.
    $( A set strictly dominates the empty set iff it is not empty. $)
    0sdom $p |- ( (/) ~< A <-> A =/= (/) ) $=
      cA cvv wcel c0 cA csdm wbr cA c0 wne wb 0sdom.1 cA cvv 0sdomg ax-mp $.
      $( [26-Nov-2006] $) $( [29-Jul-2004] $)
  $}

  $( The empty set does not strictly dominate any set. $)
  sdom0 $p |- -. A ~< (/) $=
    c0 cA cdom wbr cA c0 csdm wbr wn cA 0dom c0 cA domnsym ax-mp $.
    $( [10-Nov-2003] $) $( [26-Oct-2003] $)

  $( Transitivity of strict dominance and dominance.  Theorem 22(iii) of
     [Suppes] p. 97. $)
  sdomdomtr $p |- ( C e. D -> ( ( A ~< B /\ B ~<_ C ) -> A ~< C ) ) $=
    cC cD wcel cA cB csdm wbr cB cC cdom wbr wa cA cC csdm wbr cC cD wcel cA cB
    csdm wbr cB cC cdom wbr wa wa cA cC csdm wbr cA cB cen wbr cA cB csdm wbr
    cA cB cen wbr wn cC cD wcel cB cC cdom wbr cA cB sdomnen ad2antrl cC cD
    wcel cA cB csdm wbr cB cC cdom wbr wa wa cA cC csdm wbr wn cA cC cen wbr cC
    cB cen wbr wa cA cB cen wbr cC cD wcel cA cB csdm wbr cB cC cdom wbr wa wa
    cA cC csdm wbr wn cA cC cen wbr cC cB cen wbr cA cB csdm wbr cB cC cdom wbr
    wa cA cC csdm wbr wn cA cC cen wbr wi cC cD wcel cA cB csdm wbr cB cC cdom
    wbr wa cA cC cdom wbr cA cC csdm wbr wn cA cC cen wbr wi cA cB cdom wbr cB
    cC cdom wbr cA cC cdom wbr cA cB csdm wbr cA cB cC domtr cA cB sdomdom
    sylan cA cC cdom wbr cA cC csdm wbr cA cC cen wbr wo cA cC csdm wbr wn cA
    cC cen wbr wi cA cC brdom2 cA cC csdm wbr cA cC cen wbr df-or bitri sylib
    adantl cC cD wcel cA cB csdm wbr cB cC cdom wbr wa wa cA cC csdm wbr wn cC
    cB cdom wbr cB cC cdom wbr wa cC cB cen wbr cC cD wcel cA cB csdm wbr cB cC
    cdom wbr wa wa cA cC csdm wbr wn cC cB cdom wbr cB cC cdom wbr cC cD wcel
    cA cB csdm wbr cB cC cdom wbr wa wa cA cC csdm wbr wn cC cA cdom wbr cA cB
    cdom wbr wa cC cB cdom wbr cC cD wcel cA cB csdm wbr cB cC cdom wbr wa wa
    cA cC csdm wbr wn cC cA cdom wbr cA cB cdom wbr cA cB csdm wbr cB cC cdom
    wbr wa cA cC csdm wbr wn cA cC cen wbr cC cD wcel cC cA cdom wbr cA cB csdm
    wbr cB cC cdom wbr wa cA cC cdom wbr cA cC csdm wbr wn cA cC cen wbr wi cA
    cB cdom wbr cB cC cdom wbr cA cC cdom wbr cA cB csdm wbr cA cB cC domtr cA
    cB sdomdom sylan cA cC cdom wbr cA cC csdm wbr cA cC cen wbr wo cA cC csdm
    wbr wn cA cC cen wbr wi cA cC brdom2 cA cC csdm wbr cA cC cen wbr df-or
    bitri sylib cC cD wcel cA cC cen wbr cC cA cen wbr cC cA cdom wbr cA cC cD
    ensymg cC cA endom syl6 sylan9r cA cB csdm wbr cA cB cdom wbr cC cD wcel cB
    cC cdom wbr cA cB sdomdom ad2antrl jctird cC cA cB domtr syl6 cC cD wcel cA
    cB csdm wbr cB cC cdom wbr simprr jctird cC cB sbth syl6 jcad cA cC cB entr
    syl6 mt3d ex $.
    $( [31-Oct-2003] $) $( [26-Oct-2003] $)

  $( Transitivity of strict dominance and equinumerosity.  Exercise 11 of
     [Suppes] p. 98. $)
  sdomentr $p |- ( C e. D -> ( ( A ~< B /\ B ~~ C ) -> A ~< C ) ) $=
    cC cD wcel cA cB csdm wbr cB cC cdom wbr cA cC csdm wbr cB cC cen wbr cA cB
    cC cD sdomdomtr cB cC endom sylan2i $.
    $( [8-Nov-2003] $) $( [26-Oct-2003] $)

  $( Transitivity of equinumerosity and strict dominance. $)
  ensdomtr $p |- ( ( A ~~ B /\ B ~< C ) -> A ~< C ) $=
    cB cvv wcel cA cB cen wbr cB cC csdm wbr wa cA cC csdm wbr wi cB cvv wcel
    cA cB cen wbr cB cC csdm wbr cA cC csdm wbr cB cvv wcel cA cB cen wbr wa cB
    cC cdom wbr cB cC cen wbr wn wa cA cC cdom wbr cA cC cen wbr wn wa cB cC
    csdm wbr cA cC csdm wbr cB cvv wcel cA cB cen wbr wa cB cC cdom wbr cA cC
    cdom wbr cB cC cen wbr wn cA cC cen wbr wn cA cB cen wbr cB cC cdom wbr cA
    cC cdom wbr wi cB cvv wcel cA cB cen wbr cB cC cdom wbr cA cC cdom wbr cA
    cB cC endomtr ex adantl cB cvv wcel cA cB cen wbr wa cA cC cen wbr cB cC
    cen wbr cB cvv wcel cA cB cen wbr wa cB cA cen wbr cA cC cen wbr cB cC cen
    wbr wi cB cvv wcel cA cB cen wbr cB cA cen wbr cA cB cvv ensymg imp cB cA
    cen wbr cA cC cen wbr cB cC cen wbr cB cA cC entr ex syl con3d anim12d cB
    cC brsdom cA cC brsdom 3imtr4g expimpd cB cvv wcel wn cB cC csdm wbr cA cC
    csdm wbr cA cB cen wbr cB cvv wcel wn cB cC csdm wbr cA cC csdm wbr cB cC
    csdm wbr cB cvv wcel cB cC csdm relsdom brrelexi con3i pm2.21d adantld
    pm2.61i $.
    $( [8-Nov-2003] $) $( [26-Oct-2003] $)

  $( Strict dominance is irreflexive.  Theorem 21(i) of [Suppes] p. 97. $)
  sdomirr $p |- -. A ~< A $=
    cA cvv wcel cA cA csdm wbr wn cA cA csdm wbr cA cA cen wbr cA cvv wcel cA
    cA sdomnen cA cvv enrefg nsyl3 cA cA csdm wbr cA cvv wcel cA cA csdm
    relsdom brrelexi con3i pm2.61i $.
    $( [4-Jun-1998] $)

  $( Technical lemma for simplifying proofs involving strict dominance. $)
  sdomex $p |- ( A ~< B -> ( A e. _V /\ B e. _V ) ) $=
    cA cB csdm wbr cA cvv wcel cB cvv wcel cA cB csdm relsdom brrelexi cB cvv
    wcel cA cB csdm wbr cB cvv wcel wn cA cB csdm wbr cA cA csdm wbr cA sdomirr
    cA cB csdm brprc mtbiri con4i jca $.
    $( [4-Sep-2004] $) $( [3-Sep-2004] $)

  $( Strict dominance is transitive.  Theorem 21(iii) of [Suppes] p. 97. $)
  sdomtr $p |- ( ( A ~< B /\ B ~< C ) -> A ~< C ) $=
    cA cB csdm wbr cB cC csdm wbr cA cC csdm wbr cB cC csdm wbr cC cvv wcel cA
    cB csdm wbr cB cC csdm wbr wa cA cC csdm wbr wi cB cC csdm wbr cB cvv wcel
    cC cvv wcel cB cC sdomex pm3.27d cC cvv wcel cA cB csdm wbr cB cC cdom wbr
    cA cC csdm wbr cB cC csdm wbr cA cB cC cvv sdomdomtr cB cC sdomdom sylan2i
    syl anabsi7 $.
    $( [9-Jun-1998] $)

  $( Strict dominance has no 2-cycle loops. $)
  sdomn2lp $p |- -. ( A ~< B /\ B ~< A ) $=
    cA cB csdm wbr cB cA csdm wbr wa cA cA csdm wbr cA sdomirr cA cB cA sdomtr
    mto $.
    $( [6-May-2008] $) $( [6-May-2008] $)

  $( Transitivity of dominance and strict dominance.  Theorem 22(ii) of
     [Suppes] p. 97. $)
  domsdomtr $p |- ( ( A ~<_ B /\ B ~< C ) -> A ~< C ) $=
    cA cB cdom wbr cB cC csdm wbr cA cC csdm wbr cA cB cdom wbr cA cB csdm wbr
    cA cB cen wbr wo cB cC csdm wbr cA cC csdm wbr wi cA cB brdom2 cA cB csdm
    wbr cB cC csdm wbr cA cC csdm wbr wi cA cB cen wbr cA cB csdm wbr cB cC
    csdm wbr cA cC csdm wbr cA cB cC sdomtr ex cA cB cen wbr cB cC csdm wbr cA
    cC csdm wbr cB cC csdm wbr cB cvv wcel cA cB cen wbr cB cC csdm wbr cA cC
    csdm wbr wi wi cB cC csdm relsdom brrelexi cB cvv wcel cA cB cen wbr cB cC
    csdm wbr cA cC csdm wbr wi cB cvv wcel cA cB cen wbr wa cB cC cdom wbr cB
    cC cen wbr wn wa cA cC cdom wbr cA cC cen wbr wn wa cB cC csdm wbr cA cC
    csdm wbr cB cvv wcel cA cB cen wbr wa cB cC cdom wbr cA cC cdom wbr cB cC
    cen wbr wn cA cC cen wbr wn cA cB cen wbr cB cC cdom wbr cA cC cdom wbr wi
    cB cvv wcel cA cB cen wbr cB cC cdom wbr cA cC cdom wbr cA cB cC endomtr ex
    adantl cB cvv wcel cA cB cen wbr wa cA cC cen wbr cB cC cen wbr cB cvv wcel
    cA cB cen wbr cA cC cen wbr cB cC cen wbr wi cB cvv wcel cA cB cen wbr cB
    cA cen wbr cA cC cen wbr cB cC cen wbr wi cA cB cvv ensymg cB cA cen wbr cA
    cC cen wbr cB cC cen wbr cB cA cC entr ex syl6 imp con3d anim12d cB cC
    brsdom cA cC brsdom 3imtr4g ex syl pm2.43b jaoi sylbi imp $.
    $( [10-Jun-1998] $)

  $( Equality-like theorem for equinumerosity. $)
  enen1 $p |- ( ( B e. D /\ A ~~ B ) -> ( A ~~ C <-> B ~~ C ) ) $=
    cB cD wcel cA cB cen wbr wa cA cC cen wbr cB cC cen wbr cB cD wcel cA cB
    cen wbr wa cB cA cen wbr cA cC cen wbr cB cC cen wbr wi cB cD wcel cA cB
    cen wbr cB cA cen wbr cA cB cD ensymg imp cB cA cen wbr cA cC cen wbr cB cC
    cen wbr cB cA cC entr ex syl cB cD wcel cA cB cen wbr wa cB cC cen wbr cA
    cC cen wbr cA cB cen wbr cB cC cen wbr cA cC cen wbr cB cD wcel cA cB cC
    entr adantll ex impbid $.
    $( [26-Jun-2004] $) $( [18-Dec-2003] $)

  $( Equality-like theorem for equinumerosity. $)
  enen2 $p |- ( ( B e. D /\ A ~~ B ) -> ( C ~~ A <-> C ~~ B ) ) $=
    cB cD wcel cA cB cen wbr wa cC cA cen wbr cC cB cen wbr cA cB cen wbr cC cA
    cen wbr cC cB cen wbr wi cB cD wcel cC cA cen wbr cA cB cen wbr cC cB cen
    wbr cC cA cB entr expcom adantl cC cB cen wbr cB cA cen wbr cC cA cen wbr
    cB cD wcel cA cB cen wbr wa cC cB cen wbr cB cA cen wbr cC cA cen wbr cC cB
    cA entr ex cB cD wcel cA cB cen wbr cB cA cen wbr cA cB cD ensymg imp
    syl5com impbid $.
    $( [15-Feb-2004] $) $( [18-Dec-2003] $)

  $( Equality-like theorem for equinumerosity and dominance. $)
  domen1 $p |- ( ( B e. D /\ A ~~ B ) -> ( A ~<_ C <-> B ~<_ C ) ) $=
    cB cD wcel cA cB cen wbr wa cA cC cdom wbr cB cC cdom wbr cB cD wcel cA cB
    cen wbr wa cB cA cen wbr cA cC cdom wbr cB cC cdom wbr wi cB cD wcel cA cB
    cen wbr cB cA cen wbr cA cB cD ensymg imp cB cA cen wbr cA cC cdom wbr cB
    cC cdom wbr cB cA cC endomtr ex syl cA cB cen wbr cB cC cdom wbr cA cC cdom
    wbr wi cB cD wcel cA cB cen wbr cB cC cdom wbr cA cC cdom wbr cA cB cC
    endomtr ex adantl impbid $.
    $( [28-Jun-2004] $) $( [8-Nov-2003] $)

  $( Equality-like theorem for equinumerosity and dominance. $)
  domen2 $p |- ( ( B e. D /\ A ~~ B ) -> ( C ~<_ A <-> C ~<_ B ) ) $=
    cB cD wcel cA cB cen wbr wa cC cA cdom wbr cC cB cdom wbr cA cB cen wbr cC
    cA cdom wbr cC cB cdom wbr wi cB cD wcel cC cA cdom wbr cA cB cen wbr cC cB
    cdom wbr cC cA cB domentr expcom adantl cC cB cdom wbr cB cA cen wbr cC cA
    cdom wbr cB cD wcel cA cB cen wbr wa cC cB cdom wbr cB cA cen wbr cC cA
    cdom wbr cC cB cA domentr ex cB cD wcel cA cB cen wbr cB cA cen wbr cA cB
    cD ensymg imp syl5com impbid $.
    $( [7-Jul-2004] $) $( [8-Nov-2003] $)

  $( Equality-like theorem for equinumerosity and strict dominance. $)
  sdomen1 $p |- ( ( B e. D /\ A ~~ B ) -> ( A ~< C <-> B ~< C ) ) $=
    cB cD wcel cA cB cen wbr wa cA cC csdm wbr cB cC csdm wbr cB cD wcel cA cB
    cen wbr wa cB cA cen wbr cA cC csdm wbr cB cC csdm wbr wi cB cD wcel cA cB
    cen wbr cB cA cen wbr cA cB cD ensymg imp cB cA cen wbr cA cC csdm wbr cB
    cC csdm wbr cB cA cC ensdomtr ex syl cB cD wcel cA cB cen wbr wa cB cC csdm
    wbr cA cC csdm wbr cA cB cen wbr cB cC csdm wbr cA cC csdm wbr cB cD wcel
    cA cB cC ensdomtr adantll ex impbid $.
    $( [8-Nov-2003] $) $( [8-Nov-2003] $)

  $( Equality-like theorem for equinumerosity and strict dominance. $)
  sdomen2 $p |- ( ( B e. D /\ A ~~ B ) -> ( C ~< A <-> C ~< B ) ) $=
    cA cvv wcel cB cD wcel cA cB cen wbr wa cC cA csdm wbr cC cB csdm wbr wb wi
    cA cvv wcel cB cD wcel cA cB cen wbr cC cA csdm wbr cC cB csdm wbr wb cA
    cvv wcel cB cD wcel cA cB cen wbr cC cA csdm wbr cC cB csdm wbr wb cA cvv
    wcel cB cD wcel wa cA cB cen wbr wa cC cA csdm wbr cC cB csdm wbr cB cD
    wcel cA cB cen wbr cC cA csdm wbr cC cB csdm wbr wi cA cvv wcel cB cD wcel
    cA cB cen wbr cC cA csdm wbr cC cB csdm wbr wi cB cD wcel cC cA csdm wbr cA
    cB cen wbr cC cB csdm wbr cB cD wcel cC cA csdm wbr cA cB cen wbr cC cB
    csdm wbr cC cA cB cD sdomentr exp3a com23 imp adantll cA cvv wcel cB cD
    wcel cA cB cen wbr cC cB csdm wbr cC cA csdm wbr wi cB cD wcel cA cB cen
    wbr cB cA cen wbr cA cvv wcel cC cB csdm wbr cC cA csdm wbr wi cA cB cD
    ensymg cA cvv wcel cC cB csdm wbr cB cA cen wbr cC cA csdm wbr cA cvv wcel
    cC cB csdm wbr cB cA cen wbr cC cA csdm wbr cC cB cA cvv sdomentr exp3a
    com23 syl9r imp31 impbid exp31 imp3a cA cvv wcel wn cA cB cen wbr cC cA
    csdm wbr cC cB csdm wbr wb cB cD wcel cA cvv wcel wn cA cB cen wbr cC cA
    csdm wbr cC cB csdm wbr wb cA cB cen wbr cA cvv wcel cA cB cen relen
    brrelexi con3i pm2.21d adantld pm2.61i $.
    $( [7-Jul-2004] $) $( [8-Nov-2003] $)

  ${
    $d f g z A $.  $d f g z B $.
    $( There exists a mapping from a set onto any (non-empty) set that it
       dominates. $)
    fodomr $p |- ( ( A e. C /\
                 (/) ~< B /\ B ~<_ A ) -> E. f f : A -onto-> B ) $=
      cA cvv wcel vz cv cB wcel vz wex cB cA vg cv wf1 vg wex cA cB vf cv wfo
      vf wex cA cC wcel c0 cB csdm wbr cB cA cdom wbr w3a cA cvv wcel vz cv cB
      wcel vz wex cB cA vg cv wf1 vg wex cA cB vf cv wfo vf wex cA cvv wcel vz
      cv cB wcel cB cA vg cv wf1 vg wex cA cB vf cv wfo vf wex wi vz cA cvv
      wcel vz cv cB wcel cB cA vg cv wf1 vg wex cA cB vf cv wfo vf wex wi cA
      cvv wcel vz cv cB wcel wa cB cA vg cv wf1 cA cB vf cv wfo vf wex vg cA
      cvv wcel vz cv cB wcel cB cA vg cv wf1 cA cB vf cv wfo vf wex cA cvv wcel
      cA cB vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun wfo cA cB vf cv wfo
      vf wex vz cv cB wcel cB cA vg cv wf1 wa cA cvv wcel vg cv ccnv cA vg cv
      crn cdif vz cv csn cxp cun cvv wcel cA cB vg cv ccnv cA vg cv crn cdif vz
      cv csn cxp cun wfo cA cB vf cv wfo vf wex wi cA cvv wcel vg cv ccnv cvv
      wcel cA vg cv crn cdif vz cv csn cxp cvv wcel wa vg cv ccnv cA vg cv crn
      cdif vz cv csn cxp cun cvv wcel cA cvv wcel cA vg cv crn cdif vz cv csn
      cxp cvv wcel vg cv ccnv cvv wcel cA vg cv crn cdif cvv wcel vz cv csn cvv
      wcel cA vg cv crn cdif vz cv csn cxp cvv wcel cA cvv wcel cA vg cv crn
      cdif vz cv csn cvv cvv xpexg cA vg cv crn cvv difexg vz cv snex sylancl
      vg cv vg visset cnvex jctil vg cv ccnv cA vg cv crn cdif vz cv csn cxp
      unexb sylib cA cB vf cv wfo cA cB vg cv ccnv cA vg cv crn cdif vz cv csn
      cxp cun wfo vf vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun cvv cA cB
      vf cv vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun foeq1 cla4egv syl cA
      cB vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun wfo vg cv ccnv cA vg cv
      crn cdif vz cv csn cxp cun cA wfn vg cv ccnv cA vg cv crn cdif vz cv csn
      cxp cun crn cB wceq vz cv cB wcel cB cA vg cv wf1 wa cA cB vg cv ccnv cA
      vg cv crn cdif vz cv csn cxp cun df-fo vg cv ccnv cA vg cv crn cdif vz cv
      csn cxp cun cA wfn vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun wfun vg
      cv ccnv cA vg cv crn cdif vz cv csn cxp cun cdm cA wceq vz cv cB wcel cB
      cA vg cv wf1 wa vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun cA df-fn
      cB cA vg cv wf1 vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun wfun vz cv
      cB wcel vg cv ccnv wfun cA vg cv crn cdif vz cv csn cxp wfun wa vg cv
      ccnv cdm cA vg cv crn cdif vz cv csn cxp cdm cin c0 wceq vg cv ccnv cA vg
      cv crn cdif vz cv csn cxp cun wfun cB cA vg cv wf1 vg cv ccnv cA vg cv
      crn cdif vz cv csn cxp funun cB cA vg cv wf1 vg cv ccnv wfun cA vg cv crn
      cdif vz cv csn cxp wfun cB cA vg cv wf1 cB cA vg cv wf vg cv ccnv wfun cB
      cA vg cv df-f1 pm3.27bi cA vg cv crn cdif vz cv csn cA vg cv crn cdif vz
      cv csn cxp wf cA vg cv crn cdif vz cv csn cxp wfun cA vg cv crn cdif vz
      cv vz visset fconst cA vg cv crn cdif vz cv csn cA vg cv crn cdif vz cv
      csn cxp ffun ax-mp jctir vg cv ccnv cdm cA vg cv crn cdif vz cv csn cxp
      cdm cin vg cv crn cA vg cv crn cdif cin c0 vg cv ccnv cdm vg cv crn cA vg
      cv crn cdif vz cv csn cxp cdm cA vg cv crn cdif vg cv crn vg cv ccnv cdm
      vg cv df-rn eqcomi vz cv csn c0 wne cA vg cv crn cdif vz cv csn cxp cdm
      cA vg cv crn cdif wceq vz cv vz visset snnz cA vg cv crn cdif vz cv csn
      dmxp ax-mp ineq12i vg cv crn cA difdisj eqtri sylancl adantl cB cA vg cv
      wf1 vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun cdm cA wceq vz cv cB
      wcel cB cA vg cv wf1 vg cv crn cA vg cv crn cdif cun cA vg cv ccnv cA vg
      cv crn cdif vz cv csn cxp cun cdm cB cA vg cv wf1 vg cv crn cA wss vg cv
      crn cA vg cv crn cdif cun cA wceq cB cA vg cv wf1 cB cA vg cv wf vg cv
      crn cA wss cB cA vg cv f1f cB cA vg cv frn syl vg cv crn cA undif sylib
      vg cv ccnv cA vg cv crn cdif vz cv csn cxp cun cdm vg cv ccnv cdm cA vg
      cv crn cdif vz cv csn cxp cdm cun vg cv crn cA vg cv crn cdif vz cv csn
      cxp cdm cun vg cv crn cA vg cv crn cdif cun vg cv ccnv cA vg cv crn cdif
      vz cv csn cxp dmun vg cv crn vg cv ccnv cdm cA vg cv crn cdif vz cv csn
      cxp cdm vg cv df-rn uneq1i cA vg cv crn cdif vz cv csn cxp cdm cA vg cv
      crn cdif vg cv crn vz cv csn c0 wne cA vg cv crn cdif vz cv csn cxp cdm
      cA vg cv crn cdif wceq vz cv vz visset snnz cA vg cv crn cdif vz cv csn
      dmxp ax-mp uneq2i 3eqtr2i syl5eq adantl sylanbrc vz cv cB wcel cB cA vg
      cv wf1 wa vg cv ccnv crn cA vg cv crn cdif vz cv csn cxp crn cun cB vg cv
      ccnv cA vg cv crn cdif vz cv csn cxp cun crn cB cA vg cv wf1 vz cv cB
      wcel vg cv ccnv crn cA vg cv crn cdif vz cv csn cxp crn cun cB cA vg cv
      crn cdif vz cv csn cxp crn cun cB cB cA vg cv wf1 vg cv ccnv crn cB cA vg
      cv crn cdif vz cv csn cxp crn cB cA vg cv wf1 vg cv cdm cB vg cv ccnv crn
      cB cA vg cv wf1 cB cA vg cv wf vg cv cdm cB wceq cB cA vg cv f1f cB cA vg
      cv fdm syl vg cv dfdm4 syl5eqr uneq1d vz cv cB wcel cA vg cv crn cdif vz
      cv csn cxp crn cB wss cB cA vg cv crn cdif vz cv csn cxp crn cun cB wceq
      vz cv cB wcel cA vg cv crn cdif vz cv csn cxp crn cB wss wi cA vg cv crn
      cdif c0 cA vg cv crn cdif c0 wceq cA vg cv crn cdif vz cv csn cxp crn cB
      wss vz cv cB wcel cA vg cv crn cdif c0 wceq cA vg cv crn cdif vz cv csn
      cxp crn cB wss c0 cB wss cB 0ss cA vg cv crn cdif c0 wceq cA vg cv crn
      cdif vz cv csn cxp crn c0 cB cA vg cv crn cdif c0 wceq cA vg cv crn cdif
      vz cv csn cxp crn c0 crn c0 cA vg cv crn cdif c0 wceq cA vg cv crn cdif
      vz cv csn cxp c0 cA vg cv crn cdif c0 wceq cA vg cv crn cdif vz cv csn
      cxp c0 vz cv csn cxp c0 cA vg cv crn cdif c0 vz cv csn xpeq1 vz cv csn
      xp0r syl6eq rneqd rn0 syl6eq sseq1d mpbiri a1d cA vg cv crn cdif c0 wne
      vz cv cB wcel cA vg cv crn cdif vz cv csn cxp crn cB wss cA vg cv crn
      cdif c0 wne vz cv cB wcel wa cA vg cv crn cdif vz cv csn cxp crn vz cv
      csn cB cA vg cv crn cdif c0 wne cA vg cv crn cdif vz cv csn cxp crn vz cv
      csn wceq vz cv cB wcel cA vg cv crn cdif vz cv csn rnxp adantr vz cv cB
      wcel vz cv csn cB wss cA vg cv crn cdif c0 wne vz cv cB snssi adantl
      eqsstrd ex pm2.61ine cA vg cv crn cdif vz cv csn cxp crn cB ssequn2 sylib
      sylan9eqr vg cv ccnv cA vg cv crn cdif vz cv csn cxp rnun syl5eq sylanbrc
      syl5 expdimp 19.23adv ex 19.23adv 3imp cA cC wcel c0 cB csdm wbr cA cvv
      wcel cB cA cdom wbr cA cC elisset 3ad2ant1 c0 cB csdm wbr cB cA cdom wbr
      vz cv cB wcel vz wex cA cC wcel cB cA cdom wbr c0 cB csdm wbr vz cv cB
      wcel vz wex cB cA cdom wbr cB cvv wcel c0 cB csdm wbr vz cv cB wcel vz
      wex wb cB cA cdom reldom brrelexi cB cvv wcel c0 cB csdm wbr cB c0 wne vz
      cv cB wcel vz wex cB cvv 0sdomg vz cB n0 syl6bb syl biimpac 3adant1 cA cC
      wcel cB cA cdom wbr cB cA vg cv wf1 vg wex c0 cB csdm wbr cA cC wcel cB
      cA cdom wbr cB cA vg cv wf1 vg wex cB cA cC vg brdomg biimpa 3adant2
      syl3anc $.
      $( [24-Mar-2006] $) $( [23-Mar-2006] $)
  $}

  ${
    $d x y z f A $.
    canth2.1 $e |- A e. _V $.
    $( Cantor's Theorem.  No set is equinumerous to its power set.
       Specifically, any set has a cardinality (size) strictly less than the
       cardinality of its power set.  For example, the cardinality of real
       numbers is the same as the cardinality of the power set of integers,
       so real numbers cannot be put into a one-to-one correspondence
       with integers.  Theorem 23 of [Suppes] p. 97.  For the function version,
       see ~ canth . $)
    canth2 $p |- A ~< ~P A $=
      cA cA cpw csdm wbr cA cA cpw cdom wbr cA cA cpw cen wbr wn cA cA cpw
      brsdom cA cvv wcel cA cA cpw cdom wbr canth2.1 vx vy cA cA cpw vx cv csn
      vy cv csn cvv vx cv cA wcel vx cv csn cA cpw wcel vx cv cA vx visset
      snelpw biimpi vx cv csn vy cv csn wceq vx cv vy cv wceq wb vx cv cA wcel
      vy cv cA wcel wa vx cv csn vy cv csn wceq vx cv vy cv wceq vx cv vy cv vx
      visset sneqr vx cv vy cv sneq impbii a1i dom2 ax-mp cA cA cpw cen wbr cA
      cA cpw vf cv wf1o vf wex cA cA cpw vf cv wf1o vf cA cA cpw vf cv wf1o cA
      cA cpw vf cv wfo cA vf cv canth2.1 canth cA cA cpw vf cv f1ofo mto nex cA
      cA cpw vf cA canth2.1 pwex bren mtbir mpbir2an $.
      $( [1-Apr-198] $)
  $}

  ${
    $d x A $.
    $( Cantor's theorem with the sethood requirement expressed as an
       antecedent.  Theorem 23 of [Suppes] p. 97. $)
    canth2g $p |- ( A e. B -> A ~< ~P A ) $=
      vx cv vx cv cpw csdm wbr cA cA cpw csdm wbr vx cA cB vx cv cA wceq vx cv
      cpw cA cpw wceq vx cv vx cv cpw csdm wbr cA cA cpw csdm wbr wb vx cv cA
      pweq vx cv cA vx cv cpw cA cpw csdm breq12 mpdan vx cv vx visset canth2
      vtoclg $.
      $( [11-Nov-2003] $) $( [7-Nov-2003] $)
  $}

  $( The power set of the union of a set does not belong to the set.  This
     theorem provides a way of constructing a new set that doesn't belong to
     a given set. $)
  pwuninel $p |- -. ~P U. A e. A $=
    cA cvv wcel cA cuni cpw cA wcel wn cA cvv wcel cA cuni cpw cA wcel cA cuni
    cpw cA cuni cpw csdm wbr cA cuni cpw sdomirr cA cvv wcel cA cuni cvv wcel
    cA cuni cpw cA wcel cA cuni cpw cA cuni cpw csdm wbr wi cA uniexb cA cuni
    cvv wcel cA cuni cpw cA cuni wss cA cuni cpw cA cuni cpw csdm wbr cA cuni
    cpw cA wcel cA cuni cvv wcel cA cuni cpw cA cuni wss cA cuni cpw cA cuni
    cdom wbr cA cuni cpw cA cuni cpw csdm wbr cA cuni cpw cA cuni cvv ssdom2g
    cA cuni cpw cA cuni cdom wbr cA cuni cvv wcel cA cuni cpw cA cuni cpw csdm
    wbr cA cuni cpw cA cuni cdom wbr cA cuni cA cuni cpw csdm wbr cA cuni cpw
    cA cuni cpw csdm wbr cA cuni cvv wcel cA cuni cpw cA cuni cA cuni cpw
    domsdomtr cA cuni cvv canth2g sylan2 expcom syld cA cuni cpw cA elssuni
    syl5 sylbi mtoi cA cuni cpw cA wcel cA cvv wcel cA cuni cpw cA wcel cA cuni
    cpw cvv wcel cA cvv wcel cA cuni cpw cA elisset cA cvv wcel cA cuni cvv
    wcel cA cuni cpw cvv wcel cA uniexb cA cuni pwexb bitri sylibr con3i
    pm2.61i $.
    $( [27-Jun-2008] $) $( [27-Jun-2008] $)

  $( The power set of the power set of the union of a set does not belong to
     the set.  This theorem provides a way of constructing a new set that
     doesn't belong to a given set. $)
  2pwuninel $p |- -. ~P ~P U. A e. A $=
    cA cuni cvv wcel cA cuni cpw cpw cA wcel wn cA cuni cvv wcel cA cuni cpw
    cpw cA wcel cA cuni cpw cpw cA cuni cpw cpw csdm wbr cA cuni cpw cpw
    sdomirr cA cuni cvv wcel cA cuni cpw cpw cA cuni wss cA cuni cpw cpw cA
    cuni cpw cpw csdm wbr cA cuni cpw cpw cA wcel cA cuni cvv wcel cA cuni cpw
    cpw cA cuni wss cA cuni cpw cpw cA cuni cdom wbr cA cuni cpw cpw cA cuni
    cpw cpw csdm wbr cA cuni cpw cpw cA cuni cvv ssdom2g cA cuni cpw cpw cA
    cuni cdom wbr cA cuni cA cuni cpw cpw csdm wbr cA cuni cpw cpw cA cuni cpw
    cpw csdm wbr cA cuni cvv wcel cA cuni cpw cpw cA cuni cdom wbr cA cuni cA
    cuni cpw cpw csdm wbr cA cuni cpw cpw cA cuni cpw cpw csdm wbr cA cuni cpw
    cpw cA cuni cA cuni cpw cpw domsdomtr ex cA cuni cA cuni cpw csdm wbr cA
    cuni cpw cA cuni cpw cpw csdm wbr cA cuni cA cuni cpw cpw csdm wbr cA cuni
    cvv wcel cA cuni cA cuni cpw cA cuni cpw cpw sdomtr cA cuni cvv canth2g cA
    cuni cvv wcel cA cuni cpw cvv wcel cA cuni cpw cA cuni cpw cpw csdm wbr cA
    cuni pwexb cA cuni cpw cvv canth2g sylbi sylanc syl5com syld cA cuni cpw
    cpw cA elssuni syl5 mtoi cA cuni cpw cpw cA wcel cA cuni cvv wcel cA cuni
    cpw cpw cA wcel cA cuni cpw cpw cvv wcel cA cuni cvv wcel cA cuni cpw cpw
    cA elisset cA cuni cvv wcel cA cuni cpw cvv wcel cA cuni cpw cpw cvv wcel
    cA cuni pwexb cA cuni cpw pwexb bitri sylibr con3i pm2.61i $.
    $( [7-Jul-2008] $) $( [27-Jun-2008] $)

  $( No set equals its power set. $)
  pwne $p |- ( A e. B -> ~P A =/= A ) $=
    cA cB wcel cA cpw cA wceq wn cA cpw cA wne cA cB wcel cA cpw cA wceq cA cpw
    cA cpw csdm wbr cA cpw sdomirr cA cpw cA wceq cA cpw cA cpw csdm wbr cA cA
    cpw csdm wbr cA cB wcel cA cpw cA cA cpw csdm breq1 cA cB canth2g syl5cbir
    mtoi cA cpw cA df-ne sylibr $.
    $( [19-Nov-2008] $) $( [17-Nov-2008] $)

  $( No set equals the power set of its power set. $)
  2pwne $p |- ( A e. B -> ~P ~P A =/= A ) $=
    cA cB wcel cA cpw cpw cA wceq wn cA cpw cpw cA wne cA cB wcel cA cpw cpw cA
    wceq cA cpw cpw cA cpw cpw csdm wbr cA cpw cpw sdomirr cA cpw cpw cA wceq
    cA cpw cpw cA cpw cpw csdm wbr cA cA cpw cpw csdm wbr cA cB wcel cA cpw cpw
    cA cA cpw cpw csdm breq1 cA cA cpw csdm wbr cA cpw cA cpw cpw csdm wbr cA
    cA cpw cpw csdm wbr cA cB wcel cA cA cpw cA cpw cpw sdomtr cA cB canth2g cA
    cB wcel cA cpw cvv wcel cA cpw cA cpw cpw csdm wbr cA cB pwexg cA cpw cvv
    canth2g syl sylanc syl5cbir mtoi cA cpw cpw cA df-ne sylibr $.
    $( [27-Nov-2008] $) $( [17-Nov-2008] $)

  ${
    xpen.1 $e |- A e. _V $.
    xpen.2 $e |- B e. _V $.
    xpen.3 $e |- C e. _V $.
    xpen.4 $e |- D e. _V $.
    $( Equinumerosity law for cross product.  Proposition 4.22(b) of
       [Mendelson] p. 254. $)
    xpen $p |- ( ( A ~~ B /\ C ~~ D ) -> ( A X. C ) ~~ ( B X. D ) ) $=
      cA cC cxp cB cC cxp cen wbr cB cC cxp cB cD cxp cen wbr cA cC cxp cB cD
      cxp cen wbr cA cB cen wbr cC cD cen wbr cA cC cxp cB cC cxp cB cD cxp
      entr cA cB cen wbr cC cA cxp cC cB cxp cen wbr cA cC cxp cB cC cxp cen
      wbr cA cB cdom wbr cB cA cdom wbr wa cC cA cxp cC cB cxp cdom wbr cC cB
      cxp cC cA cxp cdom wbr wa cA cB cen wbr cC cA cxp cC cB cxp cen wbr cA cB
      cdom wbr cC cA cxp cC cB cxp cdom wbr cB cA cdom wbr cC cB cxp cC cA cxp
      cdom wbr cA cB cC xpen.2 xpen.3 xpdom2 cB cA cC xpen.1 xpen.3 xpdom2
      anim12i cB cvv wcel cA cB cdom wbr cB cA cdom wbr wa cA cB cen wbr wb
      xpen.2 cA cB cvv sbthbg ax-mp cC cB cxp cvv wcel cC cA cxp cC cB cxp cdom
      wbr cC cB cxp cC cA cxp cdom wbr wa cC cA cxp cC cB cxp cen wbr wb cC cB
      xpen.3 xpen.2 xpex cC cA cxp cC cB cxp cvv sbthbg ax-mp 3imtr3i cC cA cxp
      cC cB cxp cen wbr cC cA cxp cB cC cxp cen wbr cA cC cxp cB cC cxp cen wbr
      cB cC cxp cvv wcel cC cB cxp cB cC cxp cen wbr cC cA cxp cC cB cxp cen
      wbr cC cA cxp cB cC cxp cen wbr wb cB cC xpen.2 xpen.3 xpex cC cB xpen.3
      xpen.2 xpcomen cC cB cxp cB cC cxp cC cA cxp cvv enen2 mp2an cA cC cxp
      cvv wcel cC cA cxp cA cC cxp cen wbr cC cA cxp cB cC cxp cen wbr cA cC
      cxp cB cC cxp cen wbr wb cA cC xpen.1 xpen.3 xpex cC cA xpen.3 xpen.1
      xpcomen cC cA cxp cA cC cxp cB cC cxp cvv enen1 mp2an bitri sylib cC cD
      cdom wbr cD cC cdom wbr wa cB cC cxp cB cD cxp cdom wbr cB cD cxp cB cC
      cxp cdom wbr wa cC cD cen wbr cB cC cxp cB cD cxp cen wbr cC cD cdom wbr
      cB cC cxp cB cD cxp cdom wbr cD cC cdom wbr cB cD cxp cB cC cxp cdom wbr
      cC cD cB xpen.4 xpen.2 xpdom2 cD cC cB xpen.3 xpen.2 xpdom2 anim12i cD
      cvv wcel cC cD cdom wbr cD cC cdom wbr wa cC cD cen wbr wb xpen.4 cC cD
      cvv sbthbg ax-mp cB cD cxp cvv wcel cB cC cxp cB cD cxp cdom wbr cB cD
      cxp cB cC cxp cdom wbr wa cB cC cxp cB cD cxp cen wbr wb cB cD xpen.2
      xpen.4 xpex cB cC cxp cB cD cxp cvv sbthbg ax-mp 3imtr3i syl2an $.
      $( [30-Sep-2004] $) $( [24-Jul-2004] $)
  $}

  ${
    $d f g x y z w v A $.  $d f g x y z w v B $.  $d f g x y z w v C $.
    $d f g x y z w v D $.  $d z w v H $.
    mapenlem.1 $e |- A e. _V $.
    mapenlem.2 $e |- B e. _V $.
    mapenlem.3 $e |- C e. _V $.
    mapenlem.4 $e |- D e. _V $.
    mapenlem.5 $e |- H =
         { <. x , y >. | ( x e. ( A ^m C ) /\ y = ( ( f o. x ) o. `' g ) ) } $.
    $( Lemma for ~ mapen . $)
    mapenlem1 $p |- ( ( ( ( f : A -1-1-onto-> B /\ g : C -1-1-onto-> D ) /\ z :
    C --> A ) /\ v e. C ) -> ( ( H ` z ) ` ( g ` v ) ) = ( f ` ( z ` v ) ) ) $=
      cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf wa vv cv cC wcel wa
      vv cv vg cv cfv vz cv cH cfv cfv vv cv vg cv cfv vf cv vz cv ccom vg cv
      ccnv ccom cfv vv cv vz cv cfv vf cv cfv cC cA vz cv wf vv cv vg cv cfv vz
      cv cH cfv cfv vv cv vg cv cfv vf cv vz cv ccom vg cv ccnv ccom cfv wceq
      cA cB vf cv wf1o cC cD vg cv wf1o wa vv cv cC wcel cC cA vz cv wf vv cv
      vg cv cfv vz cv cH cfv vf cv vz cv ccom vg cv ccnv ccom cC cA vz cv wf vz
      cv cA cC cm co wcel vz cv cH cfv vf cv vz cv ccom vg cv ccnv ccom wceq cA
      cC vz cv mapenlem.1 mapenlem.3 elmap vx vy vz cv vf cv vx cv ccom vg cv
      ccnv ccom vf cv vz cv ccom vg cv ccnv ccom cA cC cm co cH vx cv vz cv
      wceq vf cv vx cv ccom vf cv vz cv ccom vg cv ccnv vx cv vz cv vf cv coeq2
      coeq1d mapenlem.5 vf cv vz cv ccom vg cv ccnv vf cv vz cv vf visset vz
      visset coex vg cv vg visset cnvex coex fvopab4 sylbir fveq1d ad2antlr cA
      cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf wa vv cv cC wcel wa vv
      cv vf cv vz cv ccom vg cv ccnv ccom vg cv ccom cfv vv cv vf cv vz cv ccom
      cfv vv cv vg cv cfv vf cv vz cv ccom vg cv ccnv ccom cfv vv cv vz cv cfv
      vf cv cfv cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf wa vv cv vf
      cv vz cv ccom vg cv ccnv ccom vg cv ccom cfv vv cv vf cv vz cv ccom cfv
      wceq vv cv cC wcel cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf wa
      vv cv vf cv vz cv ccom vg cv ccnv ccom vg cv ccom vf cv vz cv ccom cA cB
      vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf wa vf cv vz cv ccom vg cv
      ccnv vg cv ccom ccom vf cv vz cv ccom vf cv vz cv ccom vg cv ccnv ccom vg
      cv ccom cA cB vf cv wf1o cC cA vz cv wf cC cD vg cv wf1o vf cv vz cv ccom
      vg cv ccnv vg cv ccom ccom vf cv vz cv ccom wceq cC cB vf cv vz cv ccom
      wf cC cD vg cv wf1o vf cv vz cv ccom vg cv ccnv vg cv ccom ccom vf cv vz
      cv ccom wceq cA cB vf cv wf1o cC cA vz cv wf wa cC cD vg cv wf1o cC cB vf
      cv vz cv ccom wf vf cv vz cv ccom vg cv ccnv vg cv ccom ccom vf cv vz cv
      ccom cid cC cres ccom vf cv vz cv ccom cC cD vg cv wf1o vg cv ccnv vg cv
      ccom cid cC cres vf cv vz cv ccom cC cD vg cv f1ococnv1 coeq2d cC cB vf
      cv vz cv ccom fcoi1 sylan9eqr cA cB vf cv wf cC cA vz cv wf cC cB vf cv
      vz cv ccom wf cA cB vf cv wf1o cC cA cB vf cv vz cv fco cA cB vf cv f1of
      sylan sylan an1rs vf cv vz cv ccom vg cv ccnv vg cv coass syl5eq fveq1d
      adantr vf cv vz cv ccom vg cv ccnv ccom wfun cC cD vg cv wf wa vv cv cC
      wcel vv cv vf cv vz cv ccom vg cv ccnv ccom vg cv ccom cfv vv cv vg cv
      cfv vf cv vz cv ccom vg cv ccnv ccom cfv wceq cA cB vf cv wf1o cC cD vg
      cv wf1o wa cC cA vz cv wf wa vf cv vz cv ccom vg cv ccnv ccom wfun cC cD
      vg cv wf vv cv cC wcel vv cv vf cv vz cv ccom vg cv ccnv ccom vg cv ccom
      cfv vv cv vg cv cfv vf cv vz cv ccom vg cv ccnv ccom cfv wceq cC cD vv cv
      vf cv vz cv ccom vg cv ccnv ccom vg cv fvco3 3expa cA cB vf cv wf1o cC cA
      vz cv wf cC cD vg cv wf1o vf cv vz cv ccom vg cv ccnv ccom wfun cC cD vg
      cv wf wa cA cB vf cv wf1o cC cA vz cv wf wa cC cD vg cv wf1o vf cv vz cv
      ccom vg cv ccnv ccom wfun cC cD vg cv wf wa cA cB vf cv wf1o cC cA vz cv
      wf wa cC cD vg cv wf1o wa vf cv vz cv ccom vg cv ccnv ccom wfun cC cD vg
      cv wf1o cC cD vg cv wf vf cv vz cv ccom wfun vg cv ccnv wfun vf cv vz cv
      ccom vg cv ccnv ccom wfun cA cB vf cv wf1o cC cA vz cv wf wa cC cD vg cv
      wf1o vf cv vz cv ccom vg cv ccnv funco vf cv wfun vz cv wfun vf cv vz cv
      ccom wfun cA cB vf cv wf1o cC cA vz cv wf vf cv vz cv funco cA cB vf cv
      f1ofun cC cA vz cv ffun syl2an cC cD vg cv wf1o cC cD vg cv wfo vg cv
      ccnv wfun cC cD vg cv dff1o3 pm3.27bi syl2an cC cD vg cv f1of anim12i
      anabss3 an1rs sylan cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf
      vv cv cC wcel vv cv vf cv vz cv ccom cfv vv cv vz cv cfv vf cv cfv wceq
      cA cB vf cv wf1o cC cA vz cv wf vv cv cC wcel wa vv cv vf cv vz cv ccom
      cfv vv cv vz cv cfv vf cv cfv wceq cC cD vg cv wf1o vf cv wfun cC cA vz
      cv wf vv cv cC wcel wa vv cv vf cv vz cv ccom cfv vv cv vz cv cfv vf cv
      cfv wceq cA cB vf cv wf1o vf cv wfun cC cA vz cv wf vv cv cC wcel vv cv
      vf cv vz cv ccom cfv vv cv vz cv cfv vf cv cfv wceq cC cA vv cv vf cv vz
      cv fvco3 3expb cA cB vf cv f1ofun sylan adantlr anassrs 3eqtr3d eqtrd $.
      $( [12-Jul-2004] $) $( [16-Dec-2003] $)

    $( Lemma for ~ mapen . $)
    mapenlem2 $p |- ( ( f : A -1-1-onto-> B /\ g : C -1-1-onto-> D ) ->
             H : ( A ^m C ) -1-1-onto-> ( B ^m D ) ) $=
      cA cC cm co cB cD cm co cH wf1o cA cC cm co cB cD cm co cH wf1 cH crn cB
      cD cm co wceq cA cB vf cv wf1o cC cD vg cv wf1o wa cA cC cm co cB cD cm
      co cH dff1o5 cA cC cm co cB cD cm co cH wf1 cA cC cm co cB cD cm co cH wf
      vz cv cH cfv vw cv cH cfv wceq vz cv vw cv wceq wi vw cA cC cm co wral vz
      cA cC cm co wral cA cB vf cv wf1o cC cD vg cv wf1o wa vz vw cA cC cm co
      cB cD cm co cH dff13 cA cB vf cv wf1o cC cD vg cv wf1o wa vf cv vx cv
      ccom vg cv ccnv ccom cB cD cm co wcel vx cA cC cm co wral cA cC cm co cB
      cD cm co cH wf cA cB vf cv wf1o cC cD vg cv wf1o wa vf cv vx cv ccom vg
      cv ccnv ccom cB cD cm co wcel vx cA cC cm co cA cB vf cv wf1o cC cD vg cv
      wf1o wa cC cA vx cv wf cD cB vf cv vx cv ccom vg cv ccnv ccom wf vx cv cA
      cC cm co wcel vf cv vx cv ccom vg cv ccnv ccom cB cD cm co wcel cA cB vf
      cv wf1o cC cD vg cv wf1o cC cA vx cv wf cD cB vf cv vx cv ccom vg cv ccnv
      ccom wf wi cA cB vf cv wf1o cC cA vx cv wf cC cD vg cv wf1o cD cB vf cv
      vx cv ccom vg cv ccnv ccom wf cA cB vf cv wf1o cC cA vx cv wf cC cD vg cv
      wf1o cD cB vf cv vx cv ccom vg cv ccnv ccom wf cC cB vf cv vx cv ccom wf
      cD cC vg cv ccnv wf cD cB vf cv vx cv ccom vg cv ccnv ccom wf cA cB vf cv
      wf1o cC cA vx cv wf wa cC cD vg cv wf1o cD cC cB vf cv vx cv ccom vg cv
      ccnv fco cA cB vf cv wf cC cA vx cv wf cC cB vf cv vx cv ccom wf cA cB vf
      cv wf1o cC cA cB vf cv vx cv fco cA cB vf cv f1of sylan cC cD vg cv wf1o
      cD cC vg cv ccnv wf1o cD cC vg cv ccnv wf cC cD vg cv f1ocnv cD cC vg cv
      ccnv f1of syl syl2an exp31 com23 imp cA cC vx cv mapenlem.1 mapenlem.3
      elmap cB cD vf cv vx cv ccom vg cv ccnv ccom mapenlem.2 mapenlem.4 elmap
      3imtr4g r19.21aiv vx vy cA cC cm co cB cD cm co vf cv vx cv ccom vg cv
      ccnv ccom cH mapenlem.5 fopab2 sylib cA cB vf cv wf1o cC cD vg cv wf1o wa
      vz cv cH cfv vw cv cH cfv wceq vz cv vw cv wceq wi vw cA cC cm co wral vz
      cA cC cm co cA cB vf cv wf1o cC cD vg cv wf1o wa vz cv cA cC cm co wcel
      vz cv cH cfv vw cv cH cfv wceq vz cv vw cv wceq wi vw cA cC cm co cA cB
      vf cv wf1o cC cD vg cv wf1o wa vz cv cA cC cm co wcel vw cv cA cC cm co
      wcel vz cv cH cfv vw cv cH cfv wceq vz cv vw cv wceq wi cA cB vf cv wf1o
      cC cD vg cv wf1o wa cC cA vz cv wf cC cA vw cv wf wa vz cv cH cfv vw cv
      cH cfv wceq vz cv vw cv wceq wi vz cv cA cC cm co wcel vw cv cA cC cm co
      wcel wa cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf cC cA vw cv
      wf wa vz cv cH cfv vw cv cH cfv wceq vz cv vw cv wceq cA cB vf cv wf1o cC
      cD vg cv wf1o wa cC cA vz cv wf cC cA vw cv wf wa vz cv cH cfv vw cv cH
      cfv wceq wa wa vz cv vw cv wceq vv cv vz cv cfv vv cv vw cv cfv wceq vv
      cC wral cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf cC cA vw cv
      wf wa vz cv cH cfv vw cv cH cfv wceq wa wa vv cv vz cv cfv vv cv vw cv
      cfv wceq vv cC cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf cC cA
      vw cv wf wa vz cv cH cfv vw cv cH cfv wceq wa wa vv cv cC wcel wa vv cv
      vz cv cfv vf cv cfv vv cv vw cv cfv vf cv cfv wceq vv cv vz cv cfv vv cv
      vw cv cfv wceq cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf cC cA
      vw cv wf wa vz cv cH cfv vw cv cH cfv wceq wa wa vv cv cC wcel wa vv cv
      vg cv cfv vz cv cH cfv cfv vv cv vg cv cfv vw cv cH cfv cfv vv cv vz cv
      cfv vf cv cfv vv cv vw cv cfv vf cv cfv cC cA vz cv wf cC cA vw cv wf wa
      vz cv cH cfv vw cv cH cfv wceq wa vv cv vg cv cfv vz cv cH cfv cfv vv cv
      vg cv cfv vw cv cH cfv cfv wceq cA cB vf cv wf1o cC cD vg cv wf1o wa vv
      cv cC wcel vz cv cH cfv vw cv cH cfv wceq vv cv vg cv cfv vz cv cH cfv
      cfv vv cv vg cv cfv vw cv cH cfv cfv wceq cC cA vz cv wf cC cA vw cv wf
      wa vv cv vg cv cfv vz cv cH cfv vw cv cH cfv fveq1 adantl ad2antlr cA cB
      vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf cC cA vw cv wf wa vz cv cH
      cfv vw cv cH cfv wceq vv cv cC wcel vv cv vg cv cfv vz cv cH cfv cfv vv
      cv vz cv cfv vf cv cfv wceq cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz
      cv wf vz cv cH cfv vw cv cH cfv wceq vv cv cC wcel vv cv vg cv cfv vz cv
      cH cfv cfv vv cv vz cv cfv vf cv cfv wceq wi wi cC cA vw cv wf cA cB vf
      cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf vz cv cH cfv vw cv cH cfv wceq
      vv cv cC wcel vv cv vg cv cfv vz cv cH cfv cfv vv cv vz cv cfv vf cv cfv
      wceq cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf wa vv cv cC wcel
      vv cv vg cv cfv vz cv cH cfv cfv vv cv vz cv cfv vf cv cfv wceq vz cv cH
      cfv vw cv cH cfv wceq vx vy vz vv cA cB cC cD vf vg cH mapenlem.1
      mapenlem.2 mapenlem.3 mapenlem.4 mapenlem.5 mapenlem1 adantrl exp43
      adantrd imp42 cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz cv wf cC cA
      vw cv wf wa vz cv cH cfv vw cv cH cfv wceq vv cv cC wcel vv cv vg cv cfv
      vw cv cH cfv cfv vv cv vw cv cfv vf cv cfv wceq cA cB vf cv wf1o cC cD vg
      cv wf1o wa cC cA vw cv wf vz cv cH cfv vw cv cH cfv wceq vv cv cC wcel vv
      cv vg cv cfv vw cv cH cfv cfv vv cv vw cv cfv vf cv cfv wceq wi wi cC cA
      vz cv wf cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vw cv wf vz cv cH cfv
      vw cv cH cfv wceq vv cv cC wcel vv cv vg cv cfv vw cv cH cfv cfv vv cv vw
      cv cfv vf cv cfv wceq cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vw cv wf
      wa vv cv cC wcel vv cv vg cv cfv vw cv cH cfv cfv vv cv vw cv cfv vf cv
      cfv wceq vz cv cH cfv vw cv cH cfv wceq vx vy vw vv cA cB cC cD vf vg cH
      mapenlem.1 mapenlem.2 mapenlem.3 mapenlem.4 mapenlem.5 mapenlem1 adantrl
      exp43 adantld imp42 3eqtr3d cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vz
      cv wf cC cA vw cv wf wa vz cv cH cfv vw cv cH cfv wceq wa vv cv cC wcel
      vv cv vz cv cfv vf cv cfv vv cv vw cv cfv vf cv cfv wceq vv cv vz cv cfv
      vv cv vw cv cfv wceq wb cA cB vf cv wf1o cC cA vz cv wf cC cA vw cv wf wa
      vz cv cH cfv vw cv cH cfv wceq wa vv cv cC wcel wa vv cv vz cv cfv vf cv
      cfv vv cv vw cv cfv vf cv cfv wceq vv cv vz cv cfv vv cv vw cv cfv wceq
      wb cC cD vg cv wf1o cA cB vf cv wf1 vv cv vz cv cfv cA wcel vv cv vw cv
      cfv cA wcel wa vv cv vz cv cfv vf cv cfv vv cv vw cv cfv vf cv cfv wceq
      vv cv vz cv cfv vv cv vw cv cfv wceq wb cA cB vf cv wf1o cC cA vz cv wf
      cC cA vw cv wf wa vz cv cH cfv vw cv cH cfv wceq wa vv cv cC wcel wa cA
      cB vv cv vz cv cfv vv cv vw cv cfv vf cv f1fveq cA cB vf cv f1of1 cC cA
      vz cv wf cC cA vw cv wf wa vv cv cC wcel vv cv vz cv cfv cA wcel vv cv vw
      cv cfv cA wcel wa vz cv cH cfv vw cv cH cfv wceq cC cA vz cv wf cC cA vw
      cv wf wa vv cv cC wcel wa vv cv vz cv cfv cA wcel vv cv vw cv cfv cA wcel
      cC cA vz cv wf vv cv cC wcel vv cv vz cv cfv cA wcel cC cA vw cv wf cC cA
      vv cv vz cv ffvelrn adantlr cC cA vw cv wf vv cv cC wcel vv cv vw cv cfv
      cA wcel cC cA vz cv wf cC cA vv cv vw cv ffvelrn adantll jca adantlr
      syl2an adantlr anassrs mpbid r19.21aiva cC cA vz cv wf cC cA vw cv wf wa
      vz cv vw cv wceq vv cv vz cv cfv vv cv vw cv cfv wceq vv cC wral wb cA cB
      vf cv wf1o cC cD vg cv wf1o wa vz cv cH cfv vw cv cH cfv wceq vz cv cC
      wfn vw cv cC wfn vz cv vw cv wceq vv cv vz cv cfv vv cv vw cv cfv wceq vv
      cC wral wb cC cA vz cv wf cC cA vw cv wf vv cC vz cv vw cv eqfnfv2 cC cA
      vz cv ffn cC cA vw cv ffn syl2an ad2antrl mpbird exp32 vz cv cA cC cm co
      wcel cC cA vz cv wf vw cv cA cC cm co wcel cC cA vw cv wf cA cC vz cv
      mapenlem.1 mapenlem.3 elmap cA cC vw cv mapenlem.1 mapenlem.3 elmap
      anbi12i syl5ib exp3a r19.21adv r19.21aiv sylanbrc cA cB vf cv wf1o cC cD
      vg cv wf1o wa cH crn cB cD cm co cA cB vf cv wf1o cC cD vg cv wf1o wa cA
      cC cm co cB cD cm co cH wf cH crn cB cD cm co wss cA cB vf cv wf1o cC cD
      vg cv wf1o wa vf cv vx cv ccom vg cv ccnv ccom cB cD cm co wcel vx cA cC
      cm co wral cA cC cm co cB cD cm co cH wf cA cB vf cv wf1o cC cD vg cv
      wf1o wa vf cv vx cv ccom vg cv ccnv ccom cB cD cm co wcel vx cA cC cm co
      cA cB vf cv wf1o cC cD vg cv wf1o wa cC cA vx cv wf cD cB vf cv vx cv
      ccom vg cv ccnv ccom wf vx cv cA cC cm co wcel vf cv vx cv ccom vg cv
      ccnv ccom cB cD cm co wcel cA cB vf cv wf1o cC cD vg cv wf1o cC cA vx cv
      wf cD cB vf cv vx cv ccom vg cv ccnv ccom wf wi cA cB vf cv wf1o cC cA vx
      cv wf cC cD vg cv wf1o cD cB vf cv vx cv ccom vg cv ccnv ccom wf cA cB vf
      cv wf1o cC cA vx cv wf cC cD vg cv wf1o cD cB vf cv vx cv ccom vg cv ccnv
      ccom wf cC cB vf cv vx cv ccom wf cD cC vg cv ccnv wf cD cB vf cv vx cv
      ccom vg cv ccnv ccom wf cA cB vf cv wf1o cC cA vx cv wf wa cC cD vg cv
      wf1o cD cC cB vf cv vx cv ccom vg cv ccnv fco cA cB vf cv wf cC cA vx cv
      wf cC cB vf cv vx cv ccom wf cA cB vf cv wf1o cC cA cB vf cv vx cv fco cA
      cB vf cv f1of sylan cC cD vg cv wf1o cD cC vg cv ccnv wf1o cD cC vg cv
      ccnv wf cC cD vg cv f1ocnv cD cC vg cv ccnv f1of syl syl2an exp31 com23
      imp cA cC vx cv mapenlem.1 mapenlem.3 elmap cB cD vf cv vx cv ccom vg cv
      ccnv ccom mapenlem.2 mapenlem.4 elmap 3imtr4g r19.21aiv vx vy cA cC cm co
      cB cD cm co vf cv vx cv ccom vg cv ccnv ccom cH mapenlem.5 fopab2 sylib
      cA cC cm co cB cD cm co cH frn syl cA cB vf cv wf1o cC cD vg cv wf1o wa
      vz cB cD cm co cH crn cA cB vf cv wf1o cC cD vg cv wf1o wa vz cv cB cD cm
      co wcel vw cv cH cfv vz cv wceq vw cA cC cm co wrex vz cv cH crn wcel cA
      cB vf cv wf1o cC cD vg cv wf1o wa vz cv cB cD cm co wcel vf cv ccnv vz cv
      ccom vg cv ccom cA cC cm co wcel vf cv ccnv vz cv ccom vg cv ccom cH cfv
      vz cv wceq wa vw cv cH cfv vz cv wceq vw cA cC cm co wrex cA cB vf cv
      wf1o cC cD vg cv wf1o wa cD cB vz cv wf vf cv ccnv vz cv ccom vg cv ccom
      cA cC cm co wcel vf cv ccnv vz cv ccom vg cv ccom cH cfv vz cv wceq wa vz
      cv cB cD cm co wcel cA cB vf cv wf1o cC cD vg cv wf1o wa cD cB vz cv wf
      vf cv ccnv vz cv ccom vg cv ccom cA cC cm co wcel vf cv ccnv vz cv ccom
      vg cv ccom cH cfv vz cv wceq wa cA cB vf cv wf1o cC cD vg cv wf1o wa cD
      cB vz cv wf wa vf cv ccnv vz cv ccom vg cv ccom cA cC cm co wcel vf cv
      ccnv vz cv ccom vg cv ccom cH cfv vz cv wceq cA cB vf cv wf1o cC cD vg cv
      wf1o wa cD cB vz cv wf wa cC cA vf cv ccnv vz cv ccom vg cv ccom wf vf cv
      ccnv vz cv ccom vg cv ccom cA cC cm co wcel cA cB vf cv wf1o cD cB vz cv
      wf cC cD vg cv wf1o cC cA vf cv ccnv vz cv ccom vg cv ccom wf cD cA vf cv
      ccnv vz cv ccom wf cC cD vg cv wf cC cA vf cv ccnv vz cv ccom vg cv ccom
      wf cA cB vf cv wf1o cD cB vz cv wf wa cC cD vg cv wf1o cC cD cA vf cv
      ccnv vz cv ccom vg cv fco cB cA vf cv ccnv wf cD cB vz cv wf cD cA vf cv
      ccnv vz cv ccom wf cA cB vf cv wf1o cD cB cA vf cv ccnv vz cv fco cA cB
      vf cv wf1o cB cA vf cv ccnv wf1o cB cA vf cv ccnv wf cA cB vf cv f1ocnv
      cB cA vf cv ccnv f1of syl sylan cC cD vg cv f1of syl2an an1rs cA cC vf cv
      ccnv vz cv ccom vg cv ccom mapenlem.1 mapenlem.3 elmap sylibr cA cB vf cv
      wf1o cC cD vg cv wf1o wa cD cB vz cv wf wa vf cv ccnv vz cv ccom vg cv
      ccom cH cfv vf cv vf cv ccnv vz cv ccom vg cv ccom ccom vg cv ccnv ccom
      vz cv cA cB vf cv wf1o cC cD vg cv wf1o wa cD cB vz cv wf wa vf cv ccnv
      vz cv ccom vg cv ccom cA cC cm co wcel vf cv ccnv vz cv ccom vg cv ccom
      cH cfv vf cv vf cv ccnv vz cv ccom vg cv ccom ccom vg cv ccnv ccom wceq
      cA cB vf cv wf1o cC cD vg cv wf1o wa cD cB vz cv wf wa cC cA vf cv ccnv
      vz cv ccom vg cv ccom wf vf cv ccnv vz cv ccom vg cv ccom cA cC cm co
      wcel cA cB vf cv wf1o cD cB vz cv wf cC cD vg cv wf1o cC cA vf cv ccnv vz
      cv ccom vg cv ccom wf cD cA vf cv ccnv vz cv ccom wf cC cD vg cv wf cC cA
      vf cv ccnv vz cv ccom vg cv ccom wf cA cB vf cv wf1o cD cB vz cv wf wa cC
      cD vg cv wf1o cC cD cA vf cv ccnv vz cv ccom vg cv fco cB cA vf cv ccnv
      wf cD cB vz cv wf cD cA vf cv ccnv vz cv ccom wf cA cB vf cv wf1o cD cB
      cA vf cv ccnv vz cv fco cA cB vf cv wf1o cB cA vf cv ccnv wf1o cB cA vf
      cv ccnv wf cA cB vf cv f1ocnv cB cA vf cv ccnv f1of syl sylan cC cD vg cv
      f1of syl2an an1rs cA cC vf cv ccnv vz cv ccom vg cv ccom mapenlem.1
      mapenlem.3 elmap sylibr vx vy vf cv ccnv vz cv ccom vg cv ccom vf cv vx
      cv ccom vg cv ccnv ccom vf cv vf cv ccnv vz cv ccom vg cv ccom ccom vg cv
      ccnv ccom cA cC cm co cH vx cv vf cv ccnv vz cv ccom vg cv ccom wceq vf
      cv vx cv ccom vf cv vf cv ccnv vz cv ccom vg cv ccom ccom vg cv ccnv vx
      cv vf cv ccnv vz cv ccom vg cv ccom vf cv coeq2 coeq1d mapenlem.5 vf cv
      vf cv ccnv vz cv ccom vg cv ccom ccom vg cv ccnv vf cv vf cv ccnv vz cv
      ccom vg cv ccom vf visset vf cv ccnv vz cv ccom vg cv vf cv ccnv vz cv vf
      cv vf visset cnvex vz visset coex vg visset coex coex vg cv vg visset
      cnvex coex fvopab4 syl cA cB vf cv wf1o cC cD vg cv wf1o wa cD cB vz cv
      wf wa vf cv vf cv ccnv ccom vz cv ccom vg cv vg cv ccnv ccom ccom vz cv
      vf cv vf cv ccnv vz cv ccom vg cv ccom ccom vg cv ccnv ccom cA cB vf cv
      wf1o cC cD vg cv wf1o wa cD cB vz cv wf wa vf cv vf cv ccnv ccom vz cv
      ccom vg cv vg cv ccnv ccom ccom vz cv vg cv vg cv ccnv ccom ccom vz cv cA
      cB vf cv wf1o cD cB vz cv wf vf cv vf cv ccnv ccom vz cv ccom vg cv vg cv
      ccnv ccom ccom vz cv vg cv vg cv ccnv ccom ccom wceq cC cD vg cv wf1o cA
      cB vf cv wf1o cD cB vz cv wf wa vf cv vf cv ccnv ccom vz cv ccom vz cv vg
      cv vg cv ccnv ccom cA cB vf cv wf1o cD cB vz cv wf vf cv vf cv ccnv ccom
      vz cv ccom cid cB cres vz cv ccom vz cv cA cB vf cv wf1o vf cv vf cv ccnv
      ccom cid cB cres vz cv cA cB vf cv f1ococnv2 coeq1d cD cB vz cv fcoi2
      sylan9eq coeq1d adantlr cC cD vg cv wf1o cD cB vz cv wf vz cv vg cv vg cv
      ccnv ccom ccom vz cv wceq cA cB vf cv wf1o cC cD vg cv wf1o cD cB vz cv
      wf vz cv vg cv vg cv ccnv ccom ccom vz cv cid cD cres ccom vz cv cC cD vg
      cv wf1o vg cv vg cv ccnv ccom cid cD cres vz cv cC cD vg cv f1ococnv2
      coeq2d cD cB vz cv fcoi1 sylan9eq adantll eqtrd vf cv vf cv ccnv vz cv
      ccom vg cv ccom ccom vg cv ccnv ccom vf cv vf cv ccnv vz cv ccom vg cv
      ccom vg cv ccnv ccom ccom vf cv vf cv ccnv vz cv ccom vg cv vg cv ccnv
      ccom ccom ccom vf cv vf cv ccnv ccom vz cv ccom vg cv vg cv ccnv ccom
      ccom vf cv vf cv ccnv vz cv ccom vg cv ccom vg cv ccnv coass vf cv ccnv
      vz cv ccom vg cv ccom vg cv ccnv ccom vf cv ccnv vz cv ccom vg cv vg cv
      ccnv ccom ccom vf cv vf cv ccnv vz cv ccom vg cv vg cv ccnv coass coeq2i
      vf cv vf cv ccnv ccom vz cv ccom vg cv vg cv ccnv ccom ccom vf cv vf cv
      ccnv vz cv ccom ccom vg cv vg cv ccnv ccom ccom vf cv vf cv ccnv vz cv
      ccom vg cv vg cv ccnv ccom ccom ccom vf cv vf cv ccnv ccom vz cv ccom vf
      cv vf cv ccnv vz cv ccom ccom vg cv vg cv ccnv ccom vf cv vf cv ccnv vz
      cv coass coeq1i vf cv vf cv ccnv vz cv ccom vg cv vg cv ccnv ccom coass
      eqtr2i 3eqtri syl5eq eqtrd jca ex cB cD vz cv mapenlem.2 mapenlem.4 elmap
      syl5ib vw cv cH cfv vz cv wceq vf cv ccnv vz cv ccom vg cv ccom cH cfv vz
      cv wceq vw vf cv ccnv vz cv ccom vg cv ccom cA cC cm co vw cv vf cv ccnv
      vz cv ccom vg cv ccom wceq vw cv cH cfv vf cv ccnv vz cv ccom vg cv ccom
      cH cfv vz cv vw cv vf cv ccnv vz cv ccom vg cv ccom cH fveq2 eqeq1d
      rcla4ev syl6 cA cB vf cv wf1o cC cD vg cv wf1o wa cA cC cm co cB cD cm co
      cH wf cH cA cC cm co wfn vz cv cH crn wcel vw cv cH cfv vz cv wceq vw cA
      cC cm co wrex wb cA cB vf cv wf1o cC cD vg cv wf1o wa vf cv vx cv ccom vg
      cv ccnv ccom cB cD cm co wcel vx cA cC cm co wral cA cC cm co cB cD cm co
      cH wf cA cB vf cv wf1o cC cD vg cv wf1o wa vf cv vx cv ccom vg cv ccnv
      ccom cB cD cm co wcel vx cA cC cm co cA cB vf cv wf1o cC cD vg cv wf1o wa
      cC cA vx cv wf cD cB vf cv vx cv ccom vg cv ccnv ccom wf vx cv cA cC cm
      co wcel vf cv vx cv ccom vg cv ccnv ccom cB cD cm co wcel cA cB vf cv
      wf1o cC cD vg cv wf1o cC cA vx cv wf cD cB vf cv vx cv ccom vg cv ccnv
      ccom wf wi cA cB vf cv wf1o cC cA vx cv wf cC cD vg cv wf1o cD cB vf cv
      vx cv ccom vg cv ccnv ccom wf cA cB vf cv wf1o cC cA vx cv wf cC cD vg cv
      wf1o cD cB vf cv vx cv ccom vg cv ccnv ccom wf cC cB vf cv vx cv ccom wf
      cD cC vg cv ccnv wf cD cB vf cv vx cv ccom vg cv ccnv ccom wf cA cB vf cv
      wf1o cC cA vx cv wf wa cC cD vg cv wf1o cD cC cB vf cv vx cv ccom vg cv
      ccnv fco cA cB vf cv wf cC cA vx cv wf cC cB vf cv vx cv ccom wf cA cB vf
      cv wf1o cC cA cB vf cv vx cv fco cA cB vf cv f1of sylan cC cD vg cv wf1o
      cD cC vg cv ccnv wf1o cD cC vg cv ccnv wf cC cD vg cv f1ocnv cD cC vg cv
      ccnv f1of syl syl2an exp31 com23 imp cA cC vx cv mapenlem.1 mapenlem.3
      elmap cB cD vf cv vx cv ccom vg cv ccnv ccom mapenlem.2 mapenlem.4 elmap
      3imtr4g r19.21aiv vx vy cA cC cm co cB cD cm co vf cv vx cv ccom vg cv
      ccnv ccom cH mapenlem.5 fopab2 sylib cA cC cm co cB cD cm co cH ffn vw cA
      cC cm co vz cv cH fvelrnb 3syl sylibrd ssrdv eqssd sylanbrc $.
      $( [12-Jul-2004] $) $( [16-Dec-2003] $)
  $}

  ${
    $d f g x y A $.  $d f g x y B $.  $d f g x y C $.  $d f g x y D $.
    mapen.1 $e |- A e. _V $.
    mapen.2 $e |- B e. _V $.
    mapen.3 $e |- C e. _V $.
    mapen.4 $e |- D e. _V $.
    $( Two set exponentiations are equinumerous when their bases and exponents
       are equinumerous.  Theorem 6H(c) of [Enderton] p. 139. $)
    mapen $p |- ( ( A ~~ B /\ C ~~ D ) -> ( A ^m C ) ~~ ( B ^m D ) ) $=
      cA cB vf cv wf1o vf wex cC cD vg cv wf1o vg wex cA cC cm co cB cD cm co
      cen wbr cA cB cen wbr cC cD cen wbr cA cB vf cv wf1o vf wex cC cD vg cv
      wf1o vg wex cA cC cm co cB cD cm co cen wbr cA cB vf cv wf1o vf wex cC cD
      vg cv wf1o cA cC cm co cB cD cm co cen wbr vg cA cB vf cv wf1o cC cD vg
      cv wf1o cA cC cm co cB cD cm co cen wbr wi vf cA cB vf cv wf1o cC cD vg
      cv wf1o cA cC cm co cB cD cm co cen wbr cA cB vf cv wf1o cC cD vg cv wf1o
      wa cA cC cm co cB cD cm co vx cv cA cC cm co wcel vy cv vf cv vx cv ccom
      vg cv ccnv ccom wceq wa vx vy copab wf1o cA cC cm co cB cD cm co cen wbr
      vx vy cA cB cC cD vf vg vx cv cA cC cm co wcel vy cv vf cv vx cv ccom vg
      cv ccnv ccom wceq wa vx vy copab mapen.1 mapen.2 mapen.3 mapen.4 vx cv cA
      cC cm co wcel vy cv vf cv vx cv ccom vg cv ccnv ccom wceq wa vx vy copab
      eqid mapenlem2 cA cC cm co cB cD cm co vx cv cA cC cm co wcel vy cv vf cv
      vx cv ccom vg cv ccnv ccom wceq wa vx vy copab cA cC cm oprex f1oen syl
      ex 19.23aiv 19.23adv imp cA cB vf mapen.2 bren cC cD vg mapen.4 bren
      syl2anb $.
      $( [12-Jul-2004] $) $( [16-Dec-2003] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.
    mapdom1.1 $e |- A e. _V $.
    mapdom1.2 $e |- B e. _V $.
    mapdom1.3 $e |- C e. _V $.
    $( Order-preserving property of set exponentiation.  Theorem 6L(c) of
       [Enderton] p. 149. $)
    mapdom1 $p |- ( A ~<_ B -> ( A ^m C ) ~<_ ( B ^m C ) ) $=
      cA cB cdom wbr cA vx cv cen wbr vx cv cB wss wa vx wex cA cC cm co cB cC
      cm co cdom wbr vx cA cB mapdom1.2 domen cA vx cv cen wbr vx cv cB wss wa
      cA cC cm co cB cC cm co cdom wbr vx cA cC cm co vx cv cC cm co cen wbr vx
      cv cC cm co cB cC cm co cdom wbr cA cC cm co cB cC cm co cdom wbr cA vx
      cv cen wbr vx cv cB wss cA cC cm co vx cv cC cm co cB cC cm co endomtr cA
      vx cv cen wbr cC cC cen wbr cA cC cm co vx cv cC cm co cen wbr cC
      mapdom1.3 enref cA vx cv cC cC mapdom1.1 vx visset mapdom1.3 mapdom1.3
      mapen mpan2 vx cv cB wss vx cv cC cm co cB cC cm co wss vx cv cC cm co cB
      cC cm co cdom wbr vx cv cB cC mapdom1.2 mapdom1.3 mapss vx cv cC cm co
      cvv wcel vx cv cC cm co cB cC cm co wss vx cv cC cm co cB cC cm co cdom
      wbr wi vx cv cC cm oprex vx cv cC cm co cB cC cm co cvv ssdomg ax-mp syl
      syl2an 19.23aiv sylbi $.
      $( [8-Oct-2004] $) $( [27-Jul-2004] $)

    $( Lemma for ~ mapdom2 . $)
    mapdom2lem $p |- ( x e. ( C ^m z ) ->
                     ( x i^i ( ( B \ z ) X. { w } ) ) = (/) ) $=
      vx cv cC vz cv cm co wcel vx cv cB vz cv cdif vw cv csn cxp cin cdm c0
      wceq vx cv cB vz cv cdif vw cv csn cxp cin c0 wceq vx cv cC vz cv cm co
      wcel vx cv cdm cB vz cv cdif vw cv csn cxp cdm cin c0 wceq vx cv cB vz cv
      cdif vw cv csn cxp cin cdm c0 wceq vx cv cC vz cv cm co wcel vx cv cdm cB
      vz cv cdif vw cv csn cxp cdm cin vz cv cB vz cv cdif cin c0 vx cv cC vz
      cv cm co wcel vx cv cdm vz cv cB vz cv cdif vw cv csn cxp cdm cB vz cv
      cdif vx cv cC vz cv cm co wcel vz cv cC vx cv wf vx cv cdm vz cv wceq cC
      vz cv vx cv mapdom1.3 vz visset elmap vz cv cC vx cv fdm sylbi cB vz cv
      cdif vw cv csn cxp cdm cB vz cv cdif wceq vx cv cC vz cv cm co wcel cB vz
      cv cdif vw cv csn cB vz cv cdif vw cv csn cxp cB vz cv cdif vw cv vw
      visset fconst fdmi a1i ineq12d vz cv cB difdisj syl6eq vx cv cdm cB vz cv
      cdif vw cv csn cxp cdm cin c0 wceq vx cv cB vz cv cdif vw cv csn cxp cin
      cdm c0 wss vx cv cB vz cv cdif vw cv csn cxp cin cdm c0 wceq vx cv cdm cB
      vz cv cdif vw cv csn cxp cdm cin c0 wceq vx cv cB vz cv cdif vw cv csn
      cxp cin cdm vx cv cdm cB vz cv cdif vw cv csn cxp cdm cin wss vx cv cB vz
      cv cdif vw cv csn cxp cin cdm c0 wss vx cv cB vz cv cdif vw cv csn cxp
      dmin vx cv cdm cB vz cv cdif vw cv csn cxp cdm cin c0 vx cv cB vz cv cdif
      vw cv csn cxp cin cdm sseq2 mpbii vx cv cB vz cv cdif vw cv csn cxp cin
      cdm ss0 syl syl vx cv cB vz cv cdif vw cv csn cxp cin wrel vx cv cB vz cv
      cdif vw cv csn cxp cin c0 wceq vx cv cB vz cv cdif vw cv csn cxp cin cdm
      c0 wceq wb cB vz cv cdif vw cv csn cxp vx cv cin wrel vx cv cB vz cv cdif
      vw cv csn cxp cin wrel cB vz cv cdif vw cv csn cxp wrel cB vz cv cdif vw
      cv csn cxp vx cv cin wrel cB vz cv cdif vw cv csn relxp cB vz cv cdif vw
      cv csn cxp vx cv relin1 ax-mp cB vz cv cdif vw cv csn cxp vx cv cin vx cv
      cB vz cv cdif vw cv csn cxp cin cB vz cv cdif vw cv csn cxp vx cv incom
      releqi mpbi vx cv cB vz cv cdif vw cv csn cxp cin reldm0 ax-mp sylibr $.
      $( [8-Nov-2004] $) $( [23-Sep-2004] $)

    $( Order-preserving property of set exponentiation.  Theorem 6L(d) of
       [Enderton] p. 149. $)
    mapdom2 $p |- ( ( A ~<_ B /\ -. ( A = (/) /\ C = (/) ) ) ->
                  ( C ^m A ) ~<_ ( C ^m B ) ) $=
      cA cB cdom wbr cA c0 wceq wn cC c0 wceq wa cC c0 wceq wn wo cC cA cm co
      cC cB cm co cdom wbr cA c0 wceq cC c0 wceq wa wn cA cB cdom wbr cA c0
      wceq wn cC c0 wceq wa cC c0 wceq wn wo cC cA cm co cC cB cm co cdom wbr
      cA cB cdom wbr cA c0 wceq wn cC c0 wceq wa cC cA cm co cC cB cm co cdom
      wbr cC c0 wceq wn cA c0 wceq wn cC c0 wceq wa cC cA cm co cC cB cm co
      cdom wbr wi cA cB cdom wbr cA c0 wceq wn cC c0 wceq wa cC cA cm co c0 cC
      cB cm co cdom cC c0 wceq cA c0 wceq wn cC cA cm co c0 cA cm co c0 cC c0
      cA cm opreq1 cA c0 wceq wn cA c0 wne c0 cA cm co c0 wceq cA c0 df-ne cA
      mapdom1.1 map0b sylbir sylan9eqr cC cB cm co 0dom syl6eqbr a1i cA cB cdom
      wbr vw cv cC wcel vw wex cC cA cm co cC cB cm co cdom wbr cC c0 wceq wn
      cA cB cdom wbr vw cv cC wcel cC cA cm co cC cB cm co cdom wbr vw cA cB
      cdom wbr cA vz cv cen wbr vz cv cB wss wa vz wex vw cv cC wcel cC cA cm
      co cC cB cm co cdom wbr wi vz cA cB mapdom1.2 domen cA vz cv cen wbr vz
      cv cB wss wa vw cv cC wcel cC cA cm co cC cB cm co cdom wbr wi vz cA vz
      cv cen wbr vz cv cB wss wa vw cv cC wcel cC cA cm co cC cB cm co cdom wbr
      cA vz cv cen wbr vz cv cB wss vw cv cC wcel cC cA cm co cC cB cm co cdom
      wbr cC cA cm co cC vz cv cm co cen wbr cC vz cv cm co cC cB cm co cdom
      wbr cC cA cm co cC cB cm co cdom wbr cA vz cv cen wbr vz cv cB wss vw cv
      cC wcel wa cC cA cm co cC vz cv cm co cC cB cm co endomtr cC cC cen wbr
      cA vz cv cen wbr cC cA cm co cC vz cv cm co cen wbr cC mapdom1.3 enref cC
      cC cA vz cv mapdom1.3 mapdom1.3 mapdom1.1 vz visset mapen mpan vz cv cB
      wss vw cv cC wcel wa cC vz cv cm co cvv wcel cC vz cv cm co cC cB cm co
      cdom wbr cC vz cv cm oprex vz cv cB wss vw cv cC wcel wa vx vy cC vz cv
      cm co cC cB cm co vx cv cB vz cv cdif vw cv csn cxp cun vy cv cB vz cv
      cdif vw cv csn cxp cun cvv vz cv cB wss vw cv cC wcel wa vz cv cC vx cv
      wf cB cC vx cv cB vz cv cdif vw cv csn cxp cun wf vx cv cC vz cv cm co
      wcel vx cv cB vz cv cdif vw cv csn cxp cun cC cB cm co wcel vz cv cB wss
      vw cv cC wcel wa vz cv cB vz cv cdif cun cC vw cv csn cun vx cv cB vz cv
      cdif vw cv csn cxp cun wf cB cC vx cv cB vz cv cdif vw cv csn cxp cun wf
      vz cv cC vx cv wf vz cv cB wss vz cv cB vz cv cdif cun cC vw cv csn cun
      vx cv cB vz cv cdif vw cv csn cxp cun wf cB cC vw cv csn cun vx cv cB vz
      cv cdif vw cv csn cxp cun wf vw cv cC wcel cB cC vx cv cB vz cv cdif vw
      cv csn cxp cun wf vz cv cB wss vz cv cB vz cv cdif cun cB wceq vz cv cB
      vz cv cdif cun cC vw cv csn cun vx cv cB vz cv cdif vw cv csn cxp cun wf
      cB cC vw cv csn cun vx cv cB vz cv cdif vw cv csn cxp cun wf wb vz cv cB
      undif vz cv cB vz cv cdif cun cB cC vw cv csn cun vx cv cB vz cv cdif vw
      cv csn cxp cun feq2 sylbi vw cv cC wcel cC vw cv csn cun cC wceq cB cC vw
      cv csn cun vx cv cB vz cv cdif vw cv csn cxp cun wf cB cC vx cv cB vz cv
      cdif vw cv csn cxp cun wf wb vw cv cC wcel vw cv csn cC wss cC vw cv csn
      cun cC wceq vw cv cC snssi vw cv csn cC ssequn2 sylib cC vw cv csn cun cC
      cB vx cv cB vz cv cdif vw cv csn cxp cun feq3 syl sylan9bb vz cv cC vx cv
      wf cB vz cv cdif vw cv csn cB vz cv cdif vw cv csn cxp wf vz cv cB vz cv
      cdif cun cC vw cv csn cun vx cv cB vz cv cdif vw cv csn cxp cun wf cB vz
      cv cdif vw cv vw visset fconst vz cv cC vx cv wf cB vz cv cdif vw cv csn
      cB vz cv cdif vw cv csn cxp wf wa vz cv cB vz cv cdif cin c0 wceq vz cv
      cB vz cv cdif cun cC vw cv csn cun vx cv cB vz cv cdif vw cv csn cxp cun
      wf vz cv cB difdisj vz cv cB vz cv cdif cC vw cv csn vx cv cB vz cv cdif
      vw cv csn cxp fun mpan2 mpan2 syl5bi cC vz cv vx cv mapdom1.3 vz visset
      elmap cC cB vx cv cB vz cv cdif vw cv csn cxp cun mapdom1.3 mapdom1.2
      elmap 3imtr4g vx cv cC vz cv cm co wcel vy cv cC vz cv cm co wcel wa vx
      cv cB vz cv cdif vw cv csn cxp cun vy cv cB vz cv cdif vw cv csn cxp cun
      wceq vx cv vy cv wceq wb wi vz cv cB wss vw cv cC wcel wa vx cv cC vz cv
      cm co wcel vy cv cC vz cv cm co wcel wa vx cv cB vz cv cdif vw cv csn cxp
      cun vy cv cB vz cv cdif vw cv csn cxp cun wceq vx cv cB vz cv cdif vw cv
      csn cxp cun vy cv cB vz cv cdif vw cv csn cxp cun wceq vx cv cB vz cv
      cdif vw cv csn cxp cin vy cv cB vz cv cdif vw cv csn cxp cin wceq wa vx
      cv vy cv wceq vx cv cC vz cv cm co wcel vy cv cC vz cv cm co wcel wa vx
      cv cB vz cv cdif vw cv csn cxp cin vy cv cB vz cv cdif vw cv csn cxp cin
      wceq vx cv cB vz cv cdif vw cv csn cxp cun vy cv cB vz cv cdif vw cv csn
      cxp cun wceq vx cv cC vz cv cm co wcel vy cv cC vz cv cm co wcel vx cv cB
      vz cv cdif vw cv csn cxp cin c0 vy cv cB vz cv cdif vw cv csn cxp cin vx
      vz vw cA cB cC mapdom1.1 mapdom1.2 mapdom1.3 mapdom2lem vy cv cC vz cv cm
      co wcel vy cv cB vz cv cdif vw cv csn cxp cin c0 vy vz vw cA cB cC
      mapdom1.1 mapdom1.2 mapdom1.3 mapdom2lem eqcomd sylan9eq biantrud vx cv
      vy cv cB vz cv cdif vw cv csn cxp unineq syl6bb a1i dom2d mpi syl2an
      anassrs ex 19.23aiv sylbi 19.23adv vw cC neq0 syl5ib jaod imp cA c0 wceq
      wn cC c0 wceq wn wo cA c0 wceq wn cC c0 wceq wn wo cC c0 wceq cC c0 wceq
      wn wo wa cA c0 wceq cC c0 wceq wa wn cA c0 wceq wn cC c0 wceq wa cC c0
      wceq wn wo cC c0 wceq cC c0 wceq wn wo cA c0 wceq wn cC c0 wceq wn wo cC
      c0 wceq exmid biantru cA c0 wceq cC c0 wceq ianor cA c0 wceq wn cC c0
      wceq cC c0 wceq wn ordir 3bitr4i sylan2b $.
      $( [8-Nov-2004] $) $( [23-Sep-2004] $)
  $}

  ${
    $d x y z w v f g A $.  $d x y z w v f g B $.  $d x y z w v f g C $.
    mapxpen.1 $e |- A e. _V $.
    mapxpen.2 $e |- B e. _V $.
    mapxpen.3 $e |- C e. _V $.
    $( Equinumerosity law for double set exponentiation.  Proposition 10.45 of
       [TakeutiZaring] p. 96. $)
    mapxpen $p |- ( ( A ^m B ) ^m C ) ~~ ( A ^m ( B X. C ) ) $=
      vx vy cA cB cm co cC cm co cA cB cC cxp cm co vz cv cB wcel vw cv cC wcel
      wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 vw cv cC wcel
      vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq
      wa vw vf copab cA cB cm co cC cm oprex vz cv cB wcel vw cv cC wcel wa vv
      cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 cvv wcel vx cv cA cB
      cm co cC cm co wcel vz vw vv cB cC vz cv vw cv vx cv cfv cfv vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv
      copab2 mapxpen.2 mapxpen.3 vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 eqid oprabex2 a1i vw cv cC wcel
      vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq
      wa vw vf copab cvv wcel vy cv cA cB cC cxp cm co wcel vw vf cC vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab mapxpen.3 opabex2 a1i
      vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv
      cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vy cv cA cB
      cC cxp cm co wcel vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw
      cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq wa vx cv cA cB
      cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vy cv cA cB cC cxp cm co
      wcel vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co
      wceq wa vz vg copab wceq wa vw vf copab wceq vy cv cA cB cC cxp cm co
      wcel vy cv cB cC cxp wfn vz cv vw cv vy cv co cA wcel vw cC wral vz cB
      wral vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa
      vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vy cv cA
      cB cC cxp cm co wcel cB cC cxp cA vy cv wf vy cv cB cC cxp wfn vz cv vw
      cv vy cv co cA wcel vw cC wral vz cB wral wa cA cB cC cxp vy cv mapxpen.1
      cB cC mapxpen.2 mapxpen.3 xpex elmap vz vw cB cC cA vy cv ffnoprv bitri
      vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq
      wa vz vw vv copab2 wceq vy cv cB cC cxp wfn vx cv cA cB cm co cC cm co
      wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv
      wceq wa vz vw vv copab2 wceq vy cv cB cC cxp wfn vz cv cB wcel vw cv cC
      wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 cB cC cxp
      wfn vz vw vv cB cC vz cv vw cv vx cv cfv cfv vz cv cB wcel vw cv cC wcel
      wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 vz cv vw cv vx
      cv cfv fvex vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv
      cfv wceq wa vz vw vv copab2 eqid fnoprab2 cB cC cxp vy cv vz cv cB wcel
      vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      fneq1 mpbiri adantl vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel
      vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      wceq wa vz cv vw cv vy cv co cA wcel vw cC wral vz cB vx cv cA cB cm co
      cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx
      cv cfv cfv wceq wa vz vw vv copab2 wceq vz vx cv cA cB cm co cC cm co
      wcel vz ax-17 vz vy vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx
      cv cfv cfv wceq wa vz vw vv copab2 vz cv cB wcel vw cv cC wcel wa vv cv
      vz cv vw cv vx cv cfv cfv wceq wa vz vw vv vy hboprab1 hbeleq hban vx cv
      cA cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz
      cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vz cv cB wcel vz
      cv vw cv vy cv co cA wcel vw cC vx cv cA cB cm co cC cm co wcel vy cv vz
      cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw
      vv copab2 wceq vw vx cv cA cB cm co cC cm co wcel vw ax-17 vw vy vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv
      copab2 vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv
      wceq wa vz vw vv vy hboprab2 hbeleq hban vz cv cB wcel vw ax-17 vx cv cA
      cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv
      vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vz cv cB wcel vw cv
      cC wcel vz cv vw cv vy cv co cA wcel vx cv cA cB cm co cC cm co wcel vy
      cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa
      vz vw vv copab2 wceq wa vz cv cB wcel vw cv cC wcel wa wa vz cv vw cv vy
      cv co cA wcel vz cv vw cv vx cv cfv cfv cA wcel vx cv cA cB cm co cC cm
      co wcel vz cv cB wcel vw cv cC wcel wa vz cv vw cv vx cv cfv cfv cA wcel
      vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq
      wa vz vw vv copab2 wceq vx cv cA cB cm co cC cm co wcel vz cv cB wcel vw
      cv cC wcel vz cv vw cv vx cv cfv cfv cA wcel vx cv cA cB cm co cC cm co
      wcel vw cv cC wcel vz cv cB wcel vz cv vw cv vx cv cfv cfv cA wcel vw cv
      vx cv cfv cA cB cm co wcel vz cv cB wcel vz cv vw cv vx cv cfv cfv cA
      wcel vx cv cA cB cm co cC cm co wcel vw cv cC wcel wa cB cA vw cv vx cv
      cfv wf vz cv cB wcel vz cv vw cv vx cv cfv cfv cA wcel vw cv vx cv cfv cA
      cB cm co wcel cB cA vz cv vw cv vx cv cfv ffvelrn cA cB vw cv vx cv cfv
      mapxpen.1 mapxpen.2 elmap sylanb cC cA cB cm co vx cv wf vw cv cC wcel vw
      cv vx cv cfv cA cB cm co wcel vx cv cA cB cm co cC cm co wcel cC cA cB cm
      co vw cv vx cv ffvelrn cA cB cm co cC vx cv cA cB cm oprex mapxpen.3
      elmap sylanb sylan an1rs anasss adantlr vy cv vz cv cB wcel vw cv cC wcel
      wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vz cv cB
      wcel vw cv cC wcel wa vz cv vw cv vy cv co cA wcel vz cv vw cv vx cv cfv
      cfv cA wcel wb vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv
      cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq
      vz cv cB wcel vw cv cC wcel wa wa vz cv vw cv vy cv co vz cv vw cv vx cv
      cfv cfv cA vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv
      cfv cfv wceq wa vz vw vv copab2 wceq vz cv cB wcel vw cv cC wcel wa vz cv
      vw cv vy cv co vz cv vw cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 co vz cv vw cv vx cv cfv cfv vz
      cv vw cv vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv
      cfv wceq wa vz vw vv copab2 opreq vz cv cB wcel vw cv cC wcel vz cv vw cv
      vx cv cfv cfv cvv wcel vz cv vw cv vz cv cB wcel vw cv cC wcel wa vv cv
      vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 co vz cv vw cv vx cv
      cfv cfv wceq vz cv vw cv vx cv cfv fvex vz vw vv cB cC vz cv vw cv vx cv
      cfv cfv cvv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv
      cfv wceq wa vz vw vv copab2 vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 eqid oprabval4g mp3an3 sylan9eq
      eleq1d adantll mpbird exp32 r19.21ad r19.21ai sylanbrc vx cv cA cB cm co
      cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx
      cv cfv cfv wceq wa vz vw vv copab2 wceq wa vx cv vw cv cC wcel vf cv vw
      cv vx cv cfv wceq wa vw vf copab vw cv cC wcel vf cv vz cv cB wcel vg cv
      vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab vx cv cA cB
      cm co cC cm co wcel vx cv vw cv cC wcel vf cv vw cv vx cv cfv wceq wa vw
      vf copab wceq vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx
      cv cfv cfv wceq wa vz vw vv copab2 wceq vx cv cA cB cm co cC cm co wcel
      cC cA cB cm co vx cv wf vx cv vw cv cC wcel vf cv vw cv vx cv cfv wceq wa
      vw vf copab wceq cA cB cm co cC vx cv cA cB cm oprex mapxpen.3 elmap cC
      cA cB cm co vx cv wf vx cv vw cv cC wcel vf cv vw cv vx cv cfv wceq wa vw
      vf copab wceq vw cv vx cv cfv cA cB cm co wcel vw cC wral vw vf cC cA cB
      cm co vx cv fopabfv pm3.26bi sylbi adantr vx cv cA cB cm co cC cm co wcel
      vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq
      wa vz vw vv copab2 wceq wa vw cv cC wcel vf cv vw cv vx cv cfv wceq wa vw
      cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel
      vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      wceq vw vx cv cA cB cm co cC cm co wcel vw ax-17 vw vy vz cv cB wcel vw
      cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 vz
      cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw
      vv vy hboprab2 hbeleq hban vx cv cA cB cm co cC cm co wcel vy cv vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv
      copab2 wceq wa vf ax-17 vx cv cA cB cm co cC cm co wcel vy cv vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv
      copab2 wceq wa vw cv cC wcel vf cv vw cv vx cv cfv wceq vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq vx cv cA cB cm
      co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv
      vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vw cv cC wcel wa vw cv vx
      cv cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab vf cv
      vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv
      cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vw cv cC
      wcel wa vw cv vx cv cfv cA cB cm co wcel vw cv vx cv cfv vz cv cB wcel vg
      cv vz cv vw cv vy cv co wceq wa vz vg copab wceq vx cv cA cB cm co cC cm
      co wcel vw cv cC wcel vw cv vx cv cfv cA cB cm co wcel vy cv vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv
      copab2 wceq cC cA cB cm co vx cv wf vw cv cC wcel vw cv vx cv cfv cA cB
      cm co wcel vx cv cA cB cm co cC cm co wcel cC cA cB cm co vw cv vx cv
      ffvelrn cA cB cm co cC vx cv cA cB cm oprex mapxpen.3 elmap sylanb
      adantlr vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv
      cfv wceq wa vz vw vv copab2 wceq vw cv cC wcel vw cv vx cv cfv cA cB cm
      co wcel vw cv vx cv cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa
      vz vg copab wceq wi vx cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel
      vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      wceq vw cv cC wcel wa vw cv vx cv cfv vz cv cB wcel vg cv vz cv vw cv vy
      cv co wceq wa vz vg copab wceq vw cv vx cv cfv vz cv cB wcel vg cv vz cv
      vw cv vx cv cfv cfv wceq wa vz vg copab wceq vw cv vx cv cfv cA cB cm co
      wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv
      wceq wa vz vw vv copab2 wceq vw cv cC wcel wa vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab vz cv cB wcel vg cv vz cv vw cv vx cv
      cfv cfv wceq wa vz vg copab vw cv vx cv cfv vy cv vz cv cB wcel vw cv cC
      wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vw
      cv cC wcel wa vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz cv cB
      wcel vg cv vz cv vw cv vx cv cfv cfv wceq wa vz vg vy cv vz cv cB wcel vw
      cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      wceq vw cv cC wcel vz vz vy vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 vz cv cB wcel vw cv cC wcel wa
      vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv vy hboprab1 hbeleq vw cv
      cC wcel vz ax-17 hban vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vw cv cC wcel wa vg ax-17
      vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq
      wa vz vw vv copab2 wceq vw cv cC wcel wa vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq vg cv vz cv vw cv vx cv cfv cfv wceq vy cv vz cv cB wcel vw
      cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      wceq vw cv cC wcel wa vz cv cB wcel wa vz cv vw cv vy cv co vz cv vw cv
      vx cv cfv cfv vg cv vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vz cv cB wcel vw cv cC wcel
      vz cv vw cv vy cv co vz cv vw cv vx cv cfv cfv wceq vy cv vz cv cB wcel
      vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2
      wceq vz cv cB wcel vw cv cC wcel vz cv vw cv vy cv co vz cv vw cv vx cv
      cfv cfv wceq vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv
      cfv cfv wceq wa vz vw vv copab2 wceq vz cv cB wcel vw cv cC wcel wa vz cv
      vw cv vy cv co vz cv vw cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 co vz cv vw cv vx cv cfv cfv vz
      cv vw cv vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv
      cfv wceq wa vz vw vv copab2 opreq vz cv cB wcel vw cv cC wcel vz cv vw cv
      vx cv cfv cfv cvv wcel vz cv vw cv vz cv cB wcel vw cv cC wcel wa vv cv
      vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 co vz cv vw cv vx cv
      cfv cfv wceq vz cv vw cv vx cv cfv fvex vz vw vv cB cC vz cv vw cv vx cv
      cfv cfv cvv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv
      cfv wceq wa vz vw vv copab2 vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw
      cv vx cv cfv cfv wceq wa vz vw vv copab2 eqid oprabval4g mp3an3 sylan9eq
      anassrs an1rs eqeq2d pm5.32da opabbid eqeq2d vw cv vx cv cfv cA cB cm co
      wcel cB cA vw cv vx cv cfv wf vw cv vx cv cfv vz cv cB wcel vg cv vz cv
      vw cv vx cv cfv cfv wceq wa vz vg copab wceq cA cB vw cv vx cv cfv
      mapxpen.1 mapxpen.2 elmap cB cA vw cv vx cv cfv wf vw cv vx cv cfv vz cv
      cB wcel vg cv vz cv vw cv vx cv cfv cfv wceq wa vz vg copab wceq vz cv vw
      cv vx cv cfv cfv cA wcel vz cB wral vz vg cB cA vw cv vx cv cfv fopabfv
      pm3.26bi sylbi syl5bir adantll mpd eqeq2d pm5.32da opabbid eqtrd jca vy
      cv cA cB cC cxp cm co wcel vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv
      vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq wa vx
      cv cA cB cm co cC cm co wcel vy cv vz cv cB wcel vw cv cC wcel wa vv cv
      vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vz cv vw cv vy
      cv co cA wcel vw cC wral vz cB wral vy cv vz cv cB wcel vw cv cC wcel wa
      vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq wa vy cv cA
      cB cC cxp cm co wcel vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq wa vy cv vz
      cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw
      vv copab2 wceq vz cv vw cv vy cv co cA wcel vw cC wral vz cB wral vx cv
      vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz
      vg copab wceq wa vw vf copab wceq vy cv vz cv cB wcel vw cv cC wcel wa vv
      cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vz cv vw cv vy
      cv co cA wcel vw cC wral vz cB wral wa vy cv cA cB cC cxp cm co wcel vx
      cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa
      vz vg copab wceq wa vw vf copab wceq vy cv vz cv cB wcel vw cv cC wcel wa
      vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vz cv vw cv
      vy cv co cA wcel vw cC wral vz cB wral wa vy cv cB cC cxp wfn vz cv vw cv
      vy cv co cA wcel vw cC wral vz cB wral wa vy cv cA cB cC cxp cm co wcel
      vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq
      wa vz vg copab wceq wa vw vf copab wceq vy cv vz cv cB wcel vw cv cC wcel
      wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vy cv cB
      cC cxp wfn vz cv vw cv vy cv co cA wcel vw cC wral vz cB wral vx cv vw cv
      cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf copab wceq vy cv vz cv cB wcel vw cv cC wcel wa vv cv
      vz cv vw cv vx cv cfv cfv wceq wa vz vw vv copab2 wceq vy cv vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vy cv co wceq wa vz vw vv copab2
      wceq vy cv cB cC cxp wfn vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz
      cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vz cv cB
      wcel vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz vw vv
      copab2 vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv vy cv co wceq wa
      vz vw vv copab2 vy cv vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vz cv cB wcel
      vw cv cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq wa vz cv cB wcel vw
      cv cC wcel wa vv cv vz cv vw cv vy cv co wceq wa vz vw vv vz vx vw cv cC
      wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab
      wceq wa vw vf copab vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq wa vz vg copab wceq wa vw vf vz vx vw cv cC wcel vf cv vz
      cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq vz vw cv
      cC wcel vz ax-17 vz vf vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa
      vz vg copab vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg vf
      hbopab1 hbeleq hban hbopab hbeleq vw vx vw cv cC wcel vf cv vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab vw cv
      cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf vx hbopab1 hbeleq vx cv vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab
      wceq vv ax-17 vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vz cv cB wcel vw cv
      cC wcel wa vv cv vz cv vw cv vx cv cfv cfv wceq vv cv vz cv vw cv vy cv
      co wceq vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv
      co wceq wa vz vg copab wceq wa vw vf copab wceq vz cv cB wcel vw cv cC
      wcel wa wa vz cv vw cv vx cv cfv cfv vz cv vw cv vy cv co vv cv vx cv vw
      cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf copab wceq vz cv cB wcel vw cv cC wcel vz cv vw cv vx
      cv cfv cfv vz cv vw cv vy cv co wceq vx cv vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab
      wceq vw cv cC wcel vz cv cB wcel vz cv vw cv vx cv cfv cfv vz cv vw cv vy
      cv co wceq vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy
      cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv cC wcel wa vz cv
      cB wcel vz cv vw cv vx cv cfv cfv vz cv vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq wa vz vg copab cfv vz cv vw cv vy cv co vx cv vw cv cC wcel
      vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq
      wa vw vf copab wceq vw cv cC wcel wa vz cv vw cv vx cv cfv vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab vx cv vw cv cC wcel vf cv
      vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw
      vf copab wceq vw cv cC wcel vw cv vx cv cfv vw cv vw cv cC wcel vf cv vz
      cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf
      copab cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab vw
      cv vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co
      wceq wa vz vg copab wceq wa vw vf copab fveq1 vw cv cC wcel vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab cvv wcel vw cv vw cv cC
      wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab
      wceq wa vw vf copab cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa
      vz vg copab wceq vz vg cB vz cv vw cv vy cv co mapxpen.2 opabex2 vw vf cC
      vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab cvv fvopab2
      mpan2 sylan9eq fveq1d vz cv cB wcel vz cv vw cv vy cv co cvv wcel vz cv
      vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab cfv vz cv vw
      cv vy cv co wceq vz cv vw cv vy cv oprex vz vg cB vz cv vw cv vy cv co
      cvv fvopab2 mpan2 sylan9eq an1rs anasss eqeq2d pm5.32da oprabbid eqeq2d
      vz vw vv cB cC vy cv fnoprv syl6bbr anbi1d vy cv cA cB cC cxp cm co wcel
      cB cC cxp cA vy cv wf vy cv cB cC cxp wfn vz cv vw cv vy cv co cA wcel vw
      cC wral vz cB wral wa cA cB cC cxp vy cv mapxpen.1 cB cC mapxpen.2
      mapxpen.3 xpex elmap vz vw cB cC cA vy cv ffnoprv bitri syl6bbr biimparc
      ancomd vy cv cA cB cC cxp cm co wcel vx cv vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab
      wceq wa vx cv cA cB cm co cC cm co wcel vz cv vw cv vy cv co cA wcel vw
      cC wral vz cB wral vy cv vz cv cB wcel vw cv cC wcel wa vv cv vz cv vw cv
      vx cv cfv cfv wceq wa vz vw vv copab2 wceq vx cv vw cv cC wcel vf cv vz
      cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf
      copab wceq vx cv cA cB cm co cC cm co wcel vz cv vw cv vy cv co cA wcel
      vw cC wral vz cB wral wb vy cv cA cB cC cxp cm co wcel vx cv vw cv cC
      wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab
      wceq wa vw vf copab wceq vx cv cA cB cm co cC cm co wcel vz cv vw cv vy
      cv co cA wcel vz cB wral vw cC wral vz cv vw cv vy cv co cA wcel vw cC
      wral vz cB wral vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv vx cv cfv cA
      cB cm co wcel vw cC wral vx cv cA cB cm co cC cm co wcel vz cv vw cv vy
      cv co cA wcel vz cB wral vw cC wral vx cv vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab
      wceq vw cv vx cv cfv cA cB cm co wcel vw cC wral vx cv cC wfn vw cv vx cv
      cfv cA cB cm co wcel vw cC wral wa vx cv cA cB cm co cC cm co wcel vx cv
      vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz
      vg copab wceq wa vw vf copab wceq vx cv cC wfn vw cv vx cv cfv cA cB cm
      co wcel vw cC wral vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw
      cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vx cv cC wfn vw
      cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf copab cC wfn vw vf cC vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq wa vz vg copab vw cv cC wcel vf cv vz cv cB wcel vg cv vz
      cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab vz vg cB vz cv
      vw cv vy cv co mapxpen.2 opabex2 vw cv cC wcel vf cv vz cv cB wcel vg cv
      vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab eqid fnopab2
      cC vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co
      wceq wa vz vg copab wceq wa vw vf copab fneq1 mpbiri biantrurd vx cv cA
      cB cm co cC cm co wcel cC cA cB cm co vx cv wf vx cv cC wfn vw cv vx cv
      cfv cA cB cm co wcel vw cC wral wa cA cB cm co cC vx cv cA cB cm oprex
      mapxpen.3 elmap vw cC cA cB cm co vx cv ffnfv bitr2i syl6bb vx cv vw cv
      cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf copab wceq vw cv vx cv cfv cA cB cm co wcel vz cv vw
      cv vy cv co cA wcel vz cB wral vw cC vw vx vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab
      vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz
      vg copab wceq wa vw vf vx hbopab1 hbeleq vx cv vw cv cC wcel vf cv vz cv
      cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf
      copab wceq vw cv cC wcel wa vw cv vx cv cfv cA cB cm co wcel vw cv vx cv
      cfv cB wfn vz cv vw cv vy cv co cA wcel vz cB wral wa vz cv vw cv vy cv
      co cA wcel vz cB wral vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv cC wcel
      wa vw cv vx cv cfv cB wfn vz cv vw cv vx cv cfv cfv cA wcel vz cB wral wa
      vw cv vx cv cfv cB wfn vz cv vw cv vy cv co cA wcel vz cB wral wa vw cv
      vx cv cfv cA cB cm co wcel vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv
      vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv
      cC wcel wa vz cv vw cv vx cv cfv cfv cA wcel vz cB wral vz cv vw cv vy cv
      co cA wcel vz cB wral vw cv vx cv cfv cB wfn vx cv vw cv cC wcel vf cv vz
      cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf
      copab wceq vw cv cC wcel wa vz cv vw cv vx cv cfv cfv cA wcel vz cv vw cv
      vy cv co cA wcel vz cB vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz
      cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv cC
      wcel vz vz vx vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv
      co wceq wa vz vg copab wceq wa vw vf copab vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf vz vx
      vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz
      vg copab wceq vz vw cv cC wcel vz ax-17 vz vf vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab vz cv cB wcel vg cv vz cv vw cv vy cv
      co wceq wa vz vg vf hbopab1 hbeleq hban hbopab hbeleq vw cv cC wcel vz
      ax-17 hban vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy
      cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv cC wcel wa vz cv
      cB wcel wa vz cv vw cv vx cv cfv cfv vz cv vw cv vy cv co cA vx cv vw cv
      cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg
      copab wceq wa vw vf copab wceq vw cv cC wcel wa vz cv cB wcel vz cv vw cv
      vx cv cfv cfv vz cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz
      vg copab cfv vz cv vw cv vy cv co vx cv vw cv cC wcel vf cv vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq
      vw cv cC wcel wa vz cv vw cv vx cv cfv vz cv cB wcel vg cv vz cv vw cv vy
      cv co wceq wa vz vg copab vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv
      vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv
      cC wcel vw cv vx cv cfv vw cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz
      cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab cfv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab vw cv vx cv vw cv cC
      wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab
      wceq wa vw vf copab fveq1 vw cv cC wcel vz cv cB wcel vg cv vz cv vw cv
      vy cv co wceq wa vz vg copab cvv wcel vw cv vw cv cC wcel vf cv vz cv cB
      wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab
      cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq vz
      vg cB vz cv vw cv vy cv co mapxpen.2 opabex2 vw vf cC vz cv cB wcel vg cv
      vz cv vw cv vy cv co wceq wa vz vg copab cvv fvopab2 mpan2 sylan9eq
      fveq1d vz cv cB wcel vz cv vw cv vy cv co cvv wcel vz cv vz cv cB wcel vg
      cv vz cv vw cv vy cv co wceq wa vz vg copab cfv vz cv vw cv vy cv co wceq
      vz cv vw cv vy cv oprex vz vg cB vz cv vw cv vy cv co cvv fvopab2 mpan2
      sylan9eq eleq1d ralbida anbi2d vw cv vx cv cfv cA cB cm co wcel cB cA vw
      cv vx cv cfv wf vw cv vx cv cfv cB wfn vz cv vw cv vx cv cfv cfv cA wcel
      vz cB wral wa cA cB vw cv vx cv cfv mapxpen.1 mapxpen.2 elmap vz cB cA vw
      cv vx cv cfv ffnfv bitri syl5bb vx cv vw cv cC wcel vf cv vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq
      vw cv cC wcel wa vw cv vx cv cfv cB wfn vz cv vw cv vy cv co cA wcel vz
      cB wral vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv vw cv vy cv
      co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv cC wcel wa vw cv vx
      cv cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq
      vw cv vx cv cfv cB wfn vx cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz
      cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab wceq vw cv cC
      wcel vw cv vx cv cfv vw cv vw cv cC wcel vf cv vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab cfv vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab vw cv vx cv vw cv cC wcel
      vf cv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq
      wa vw vf copab fveq1 vw cv cC wcel vz cv cB wcel vg cv vz cv vw cv vy cv
      co wceq wa vz vg copab cvv wcel vw cv vw cv cC wcel vf cv vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq wa vw vf copab cfv vz
      cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq vz vg cB
      vz cv vw cv vy cv co mapxpen.2 opabex2 vw vf cC vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab cvv fvopab2 mpan2 sylan9eq vw cv vx cv
      cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab wceq vw
      cv vx cv cfv cB wfn vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz
      vg copab cB wfn vz vg cB vz cv vw cv vy cv co vz cv cB wcel vg cv vz cv
      vw cv vy cv co wceq wa vz vg copab vz cv vw cv vy cv oprex vz cv cB wcel
      vg cv vz cv vw cv vy cv co wceq wa vz vg copab eqid fnopab2 cB vw cv vx
      cv cfv vz cv cB wcel vg cv vz cv vw cv vy cv co wceq wa vz vg copab fneq1
      mpbiri syl biantrurd bitr4d ralbida bitr3d vz cv vw cv vy cv co cA wcel
      vw vz cC cB ralcom syl6bb adantl anbi1d mpbird impbii en2 $.
      $( [15-Jul-2004] $) $( [21-Feb-2004] $)
  $}

  ${
    $d x y z w v f g A $.  $d x y z w v f g B $.  $d x y z w v f g C $.
    xpmapen.1 $e |- A e. _V $.
    xpmapen.2 $e |- B e. _V $.
    xpmapen.3 $e |- C e. _V $.
    ${
      $d y D $.  $d y R $.  $d x S $.
      xpmapenlem.4 $e |- D =
                    { <. z , w >. | ( z e. C /\ w = U. dom { ( x ` z ) } ) } $.
      xpmapenlem.5 $e |- R =
                    { <. z , w >. | ( z e. C /\ w = U. ran { ( x ` z ) } ) } $.
      xpmapenlem.6 $e |- S = { <. z , w >. | ( z e. C /\ w =
                       <. ( U. dom { y } ` z ) , ( U. ran { y } ` z ) >. ) } $.
      $( Lemma for ~ xpmapen . $)
      xpmapenlem1 $p |- ( ( y = <. D , R >. -> A. z y = <. D , R >. ) /\
                           ( y = <. D , R >. -> A. w y = <. D , R >. ) ) $=
        vy cv cD cR cop wceq vy cv cD cR cop wceq vz wal wi vy cv cD cR cop
        wceq vy cv cD cR cop wceq vw wal wi vz vy cD cR cop vz vy cD cR vz vy
        cD vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab
        xpmapenlem.4 vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa
        vz vw vy hbopab1 hbxfr vz vy cR vz cv cC wcel vw cv vz cv vx cv cfv csn
        crn cuni wceq wa vz vw copab xpmapenlem.5 vz cv cC wcel vw cv vz cv vx
        cv cfv csn crn cuni wceq wa vz vw vy hbopab1 hbxfr hbop hbeleq vw vy cD
        cR cop vw vy cD cR vw vy cD vz cv cC wcel vw cv vz cv vx cv cfv csn cdm
        cuni wceq wa vz vw copab xpmapenlem.4 vz cv cC wcel vw cv vz cv vx cv
        cfv csn cdm cuni wceq wa vz vw vy hbopab2 hbxfr vw vy cR vz cv cC wcel
        vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw copab xpmapenlem.5 vz
        cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw vy hbopab2
        hbxfr hbop hbeleq pm3.2i $.
        $( [13-Jul-2004] $) $( [2-May-2004] $)

      $( Lemma for ~ xpmapen . $)
      xpmapenlem2 $p |- ( ( y = <. D , R >. /\ z e. C ) ->
             ( ( U. dom { y } ` z ) = U. dom { ( x ` z ) } /\
               ( U. ran { y } ` z ) = U. ran { ( x ` z ) } ) ) $=
        vy cv cD cR cop wceq vz cv cC wcel wa vz cv vy cv csn cdm cuni cfv vz
        cv vx cv cfv csn cdm cuni wceq vz cv vy cv csn crn cuni cfv vz cv vx cv
        cfv csn crn cuni wceq vy cv cD cR cop wceq vz cv cC wcel vz cv vy cv
        csn cdm cuni cfv vz cv vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni
        wceq wa vz vw copab cfv vz cv vx cv cfv csn cdm cuni vy cv cD cR cop
        wceq vz cv vy cv csn cdm cuni vz cv cC wcel vw cv vz cv vx cv cfv csn
        cdm cuni wceq wa vz vw copab vy cv cD cR cop wceq vy cv csn cdm cuni vz
        cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab cR
        cop csn cdm cuni vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq
        wa vz vw copab vy cv cD cR cop wceq vy cv csn cdm vz cv cC wcel vw cv
        vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab cR cop csn cdm vy cv
        cD cR cop wceq vy cv csn vz cv cC wcel vw cv vz cv vx cv cfv csn cdm
        cuni wceq wa vz vw copab cR cop csn vy cv cD cR cop wceq vy cv csn cD
        cR cop csn vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa vz
        vw copab cR cop csn vy cv cD cR cop sneq cD cR cop vz cv cC wcel vw cv
        vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab cR cop cD vz cv cC
        wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab cR
        xpmapenlem.4 opeq1i sneqi syl6eq dmeqd unieqd vz cv cC wcel vw cv vz cv
        vx cv cfv csn cdm cuni wceq wa vz vw copab cR vz vw cC vz cv vx cv cfv
        csn cdm cuni xpmapen.3 opabex2 op1sta syl6eq fveq1d vz cv cC wcel vz cv
        vx cv cfv csn cdm cuni cvv wcel vz cv vz cv cC wcel vw cv vz cv vx cv
        cfv csn cdm cuni wceq wa vz vw copab cfv vz cv vx cv cfv csn cdm cuni
        wceq vz cv vx cv cfv csn cdm vz cv vx cv cfv csn vz cv vx cv cfv snex
        dmex uniex vz vw cC vz cv vx cv cfv csn cdm cuni cvv fvopab2 mpan2
        sylan9eq vy cv cD cR cop wceq vz cv cC wcel vz cv vy cv csn crn cuni
        cfv vz cv vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz
        vw copab cfv vz cv vx cv cfv csn crn cuni vy cv cD cR cop wceq vz cv vy
        cv csn crn cuni vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq
        wa vz vw copab vy cv cD cR cop wceq vy cv csn crn cuni cD vz cv cC wcel
        vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw copab cop csn crn cuni
        vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw copab vy
        cv cD cR cop wceq vy cv csn crn cD vz cv cC wcel vw cv vz cv vx cv cfv
        csn crn cuni wceq wa vz vw copab cop csn crn vy cv cD cR cop wceq vy cv
        csn cD vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw
        copab cop csn vy cv cD cR cop wceq vy cv csn cD cR cop csn cD vz cv cC
        wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw copab cop csn vy
        cv cD cR cop sneq cD cR cop cD vz cv cC wcel vw cv vz cv vx cv cfv csn
        crn cuni wceq wa vz vw copab cop cR vz cv cC wcel vw cv vz cv vx cv cfv
        csn crn cuni wceq wa vz vw copab cD xpmapenlem.5 opeq2i sneqi syl6eq
        rneqd unieqd cD vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq
        wa vz vw copab vz vw cC vz cv vx cv cfv csn cdm cuni cD xpmapen.3
        xpmapenlem.4 fopabex2 vz vw cC vz cv vx cv cfv csn crn cuni xpmapen.3
        opabex2 op2nda syl6eq fveq1d vz cv cC wcel vz cv vx cv cfv csn crn cuni
        cvv wcel vz cv vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa
        vz vw copab cfv vz cv vx cv cfv csn crn cuni wceq vz cv vx cv cfv csn
        crn vz cv vx cv cfv csn vz cv vx cv cfv snex rnex uniex vz vw cC vz cv
        vx cv cfv csn crn cuni cvv fvopab2 mpan2 sylan9eq jca $.
        $( [13-Jul-2004] $) $( [1-May-2004] $)

      $( Lemma for ~ xpmapen . $)
      xpmapenlem3 $p |- ( ( x : C --> ( A X. B ) /\ y = <. D , R >. ) ->
                        x = S ) $=
        cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vx cv vz cv cC wcel vw cv
        vz cv vx cv cfv wceq wa vz vw copab cS cC cA cB cxp vx cv wf vx cv vz
        cv cC wcel vw cv vz cv vx cv cfv wceq wa vz vw copab wceq vy cv cD cR
        cop wceq cC cA cB cxp vx cv wf vx cv cC wfn vx cv vz cv cC wcel vw cv
        vz cv vx cv cfv wceq wa vz vw copab wceq cC cA cB cxp vx cv ffn vz vw
        cC vx cv dffn5 sylib adantr cC cA cB cxp vx cv wf vy cv cD cR cop wceq
        wa vz cv cC wcel vw cv vz cv vx cv cfv wceq wa vz vw copab vz cv cC
        wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        cop wceq wa vz vw copab cS cC cA cB cxp vx cv wf vy cv cD cR cop wceq
        wa vz cv cC wcel vw cv vz cv vx cv cfv wceq wa vz cv cC wcel vw cv vz
        cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz
        vw cC cA cB cxp vx cv wf vy cv cD cR cop wceq vz cC cA cB cxp vx cv wf
        vz ax-17 vy cv cD cR cop wceq vy cv cD cR cop wceq vz wal wi vy cv cD
        cR cop wceq vy cv cD cR cop wceq vw wal wi vx vy vz vw cA cB cC cD cR
        cS xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5 xpmapenlem.6
        xpmapenlem1 pm3.26i hban cC cA cB cxp vx cv wf vy cv cD cR cop wceq vw
        cC cA cB cxp vx cv wf vw ax-17 vy cv cD cR cop wceq vy cv cD cR cop
        wceq vz wal wi vy cv cD cR cop wceq vy cv cD cR cop wceq vw wal wi vx
        vy vz vw cA cB cC cD cR cS xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4
        xpmapenlem.5 xpmapenlem.6 xpmapenlem1 pm3.27i hban cC cA cB cxp vx cv
        wf vy cv cD cR cop wceq wa vz cv cC wcel vw cv vz cv vx cv cfv wceq vw
        cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq
        cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vz cv cC wcel wa vz cv vx
        cv cfv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop vw
        cv cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vz cv cC wcel wa vz cv
        vx cv cfv vz cv vx cv cfv csn cdm cuni vz cv vx cv cfv csn crn cuni cop
        vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop cC cA cB
        cxp vx cv wf vz cv cC wcel vz cv vx cv cfv vz cv vx cv cfv csn cdm cuni
        vz cv vx cv cfv csn crn cuni cop wceq vy cv cD cR cop wceq cC cA cB cxp
        vx cv wf vz cv cC wcel wa vz cv vx cv cfv cA cB cxp wcel vz cv vx cv
        cfv vz cv vx cv cfv csn cdm cuni vz cv vx cv cfv csn crn cuni cop wceq
        cC cA cB cxp vz cv vx cv ffvelrn vz cv vx cv cfv cA cB cxp wcel vz cv
        vx cv cfv vz cv vx cv cfv csn cdm cuni vz cv vx cv cfv csn crn cuni cop
        wceq vz cv vx cv cfv csn cdm cuni cA wcel vz cv vx cv cfv csn crn cuni
        cB wcel wa vz cv vx cv cfv cA cB elxp4 pm3.26bi syl adantlr vy cv cD cR
        cop wceq vz cv cC wcel vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn
        cuni cfv cop vz cv vx cv cfv csn cdm cuni vz cv vx cv cfv csn crn cuni
        cop wceq cC cA cB cxp vx cv wf vy cv cD cR cop wceq vz cv cC wcel wa vz
        cv vy cv csn cdm cuni cfv vz cv vx cv cfv csn cdm cuni wceq vz cv vy cv
        csn crn cuni cfv vz cv vx cv cfv csn crn cuni wceq wa vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop vz cv vx cv cfv csn cdm
        cuni vz cv vx cv cfv csn crn cuni cop wceq vx vy vz vw cA cA cC cD cR
        cS xpmapen.1 xpmapen.1 xpmapen.3 xpmapenlem.4 xpmapenlem.5 xpmapenlem.6
        xpmapenlem2 vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        vz cv vx cv cfv csn cdm cuni vz cv vx cv cfv csn crn cuni opeq12 syl
        adantll eqtr4d eqeq2d pm5.32da opabbid xpmapenlem.6 syl6eqr eqtrd $.
        $( [13-Jul-2004] $) $( [1-May-2004] $)

      $( Lemma for ~ xpmapen . $)
      xpmapenlem4 $p |- ( ( ( y = <. U. dom { y } , U. ran { y } >. /\
        ( U. dom { y } : C --> A /\ U. ran { y } : C --> B ) ) /\ x = S ) ->
                     ( x : C --> ( A X. B ) /\ y = <. D , R >. ) ) $=
        vy cv vy cv csn cdm cuni vy cv csn crn cuni cop wceq cC cA vy cv csn
        cdm cuni wf cC cB vy cv csn crn cuni wf wa wa vx cv cS wceq wa cC cA cB
        cxp vx cv wf vy cv cD cR cop wceq cC cA vy cv csn cdm cuni wf cC cB vy
        cv csn crn cuni wf wa vx cv cS wceq cC cA cB cxp vx cv wf vy cv vy cv
        csn cdm cuni vy cv csn crn cuni cop wceq vz cv vy cv csn cdm cuni cfv
        cA wcel vz cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa
        vx cv cS wceq cC cA cB cxp vx cv wf cC cA vy cv csn cdm cuni wf cC cB
        vy cv csn crn cuni wf wa vx cv cS wceq vz cv vy cv csn cdm cuni cfv cA
        wcel vz cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa cC
        cA cB cxp vx cv wf vx cv cS wceq cC cA cB cxp vx cv wf cC cA cB cxp vz
        cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni
        cfv cop wceq wa vz vw copab wf vz cv vy cv csn cdm cuni cfv cA wcel vz
        cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa vx cv cS
        wceq cS vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv
        csn crn cuni cfv cop wceq wa vz vw copab wceq cC cA cB cxp vx cv wf cC
        cA cB cxp vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv
        csn crn cuni cfv cop wceq wa vz vw copab wf wb xpmapenlem.6 vx cv cS
        wceq cS vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv
        csn crn cuni cfv cop wceq wa vz vw copab wceq wa cC cA cB cxp vx cv vz
        cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni
        cfv cop wceq wa vz vw copab vx cv cS vz cv cC wcel vw cv vz cv vy cv
        csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab
        eqtr feq1d mpan2 vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni
        cfv cop cA cB cxp wcel vz cC wral vz cv vy cv csn cdm cuni cfv cA wcel
        vz cv vy cv csn crn cuni cfv cB wcel wa vz cC wral cC cA cB cxp vz cv
        cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        cop wceq wa vz vw copab wf vz cv vy cv csn cdm cuni cfv cA wcel vz cC
        wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop cA cB cxp wcel vz cv vy
        cv csn cdm cuni cfv cA wcel vz cv vy cv csn crn cuni cfv cB wcel wa vz
        cC vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cA cB vz
        cv vy cv csn crn cuni fvex opelxp ralbii vz vw cC cA cB cxp vz cv vy cv
        csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop vz cv cC wcel vw cv
        vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa
        vz vw copab vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy
        cv csn crn cuni cfv cop wceq wa vz vw copab eqid fopab2 vz cv vy cv csn
        cdm cuni cfv cA wcel vz cv vy cv csn crn cuni cfv cB wcel vz cC r19.26
        3bitr3ri syl6rbbr biimpac cC cA vy cv csn cdm cuni wf vz cv vy cv csn
        cdm cuni cfv cA wcel vz cC wral cC cB vy cv csn crn cuni wf vz cv vy cv
        csn crn cuni cfv cB wcel vz cC wral cC cA vy cv csn cdm cuni wf vz cv
        vy cv csn cdm cuni cfv cA wcel vz cC cC cA vz cv vy cv csn cdm cuni
        ffvelrn r19.21aiva cC cB vy cv csn crn cuni wf vz cv vy cv csn crn cuni
        cfv cB wcel vz cC cC cB vz cv vy cv csn crn cuni ffvelrn r19.21aiva
        anim12i sylan adantll vy cv vy cv csn cdm cuni vy cv csn crn cuni cop
        wceq cC cA vy cv csn cdm cuni wf cC cB vy cv csn crn cuni wf wa vx cv
        cS wceq vy cv cD cR cop wceq vy cv vy cv csn cdm cuni vy cv csn crn
        cuni cop wceq cC cA vy cv csn cdm cuni wf cC cB vy cv csn crn cuni wf
        wa vx cv cS wceq vy cv cD cR cop wceq vy cv vy cv csn cdm cuni vy cv
        csn crn cuni cop wceq vy cv cD cR cop wceq vy cv csn cdm cuni vy cv csn
        crn cuni cop cD cR cop wceq cC cA vy cv csn cdm cuni wf cC cB vy cv csn
        crn cuni wf wa vx cv cS wceq wa vy cv vy cv csn cdm cuni vy cv csn crn
        cuni cop cD cR cop eqeq1 cC cA vy cv csn cdm cuni wf cC cB vy cv csn
        crn cuni wf wa vx cv cS wceq wa vy cv csn cdm cuni cD vy cv csn crn
        cuni cR cC cA vy cv csn cdm cuni wf vx cv cS wceq vy cv csn cdm cuni cD
        wceq cC cB vy cv csn crn cuni wf cC cA vy cv csn cdm cuni wf vx cv cS
        wceq vy cv csn cdm cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni
        cfv wceq wa vz vw copab cD cC cA vy cv csn cdm cuni wf vy cv csn cdm
        cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv wceq wa vz vw
        copab wceq vz cv vy cv csn cdm cuni cfv cA wcel vz cC wral vz vw cC cA
        vy cv csn cdm cuni fopabfv pm3.26bi vx cv cS wceq vz cv cC wcel vw cv
        vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab vz cv cC wcel vw cv vz
        cv vy cv csn cdm cuni cfv wceq wa vz vw copab cD vx cv cS wceq vz cv cC
        wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa vz cv cC wcel vw cv vz
        cv vy cv csn cdm cuni cfv wceq wa vz vw vz vx cS vz vx cS vz cv cC wcel
        vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop
        wceq wa vz vw copab xpmapenlem.6 vz cv cC wcel vw cv vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw vx hbopab1
        hbxfr hbeleq vw vx cS vw vx cS vz cv cC wcel vw cv vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab
        xpmapenlem.6 vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy
        cv csn crn cuni cfv cop wceq wa vz vw vx hbopab2 hbxfr hbeleq vx cv cS
        wceq vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq vw cv vz cv
        vy cv csn cdm cuni cfv wceq vx cv cS wceq vz cv cC wcel wa vz cv vx cv
        cfv csn cdm cuni vz cv vy cv csn cdm cuni cfv vw cv vx cv cS wceq vz cv
        cC wcel wa vz cv vx cv cfv csn cdm cuni vz cv vy cv csn cdm cuni cfv vz
        cv vy cv csn crn cuni cfv cop csn cdm cuni vz cv vy cv csn cdm cuni cfv
        vx cv cS wceq vz cv cC wcel wa vz cv vx cv cfv csn cdm vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop csn cdm vx cv cS wceq vz
        cv cC wcel wa vz cv vx cv cfv csn vz cv vy cv csn cdm cuni cfv vz cv vy
        cv csn crn cuni cfv cop csn vx cv cS wceq vz cv cC wcel wa vz cv vx cv
        cfv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop vx cv
        cS wceq vz cv cC wcel vz cv vx cv cfv vz cv vz cv cC wcel vw cv vz cv
        vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw
        copab cfv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop
        vx cv cS wceq vz cv vx cv vz cv cC wcel vw cv vz cv vy cv csn cdm cuni
        cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab vx cv cS wceq
        cS vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn
        cuni cfv cop wceq wa vz vw copab wceq vx cv vz cv cC wcel vw cv vz cv
        vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw
        copab wceq xpmapenlem.6 vx cv cS vz cv cC wcel vw cv vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab eqtr
        mpan2 fveq1d vz cv cC wcel vz cv vy cv csn cdm cuni cfv vz cv vy cv csn
        crn cuni cfv cop cvv wcel vz cv vz cv cC wcel vw cv vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab cfv vz cv
        vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq vz cv vy
        cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv opex vz vw cC vz cv vy
        cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop cvv fvopab2 mpan2
        sylan9eq sneqd dmeqd unieqd vz cv vy cv csn cdm cuni cfv vz cv vy cv
        csn crn cuni cfv vz cv vy cv csn cdm cuni fvex op1sta syl6eq eqeq2d
        pm5.32da opabbid xpmapenlem.4 syl5req sylan9eq adantlr cC cB vy cv csn
        crn cuni wf vx cv cS wceq vy cv csn crn cuni cR wceq cC cA vy cv csn
        cdm cuni wf cC cB vy cv csn crn cuni wf vx cv cS wceq vy cv csn crn
        cuni vz cv cC wcel vw cv vz cv vy cv csn crn cuni cfv wceq wa vz vw
        copab cR cC cB vy cv csn crn cuni wf vy cv csn crn cuni vz cv cC wcel
        vw cv vz cv vy cv csn crn cuni cfv wceq wa vz vw copab wceq vz cv vy cv
        csn crn cuni cfv cB wcel vz cC wral vz vw cC cB vy cv csn crn cuni
        fopabfv pm3.26bi vx cv cS wceq vz cv cC wcel vw cv vz cv vx cv cfv csn
        crn cuni wceq wa vz vw copab vz cv cC wcel vw cv vz cv vy cv csn crn
        cuni cfv wceq wa vz vw copab cR vx cv cS wceq vz cv cC wcel vw cv vz cv
        vx cv cfv csn crn cuni wceq wa vz cv cC wcel vw cv vz cv vy cv csn crn
        cuni cfv wceq wa vz vw vz vx cS vz vx cS vz cv cC wcel vw cv vz cv vy
        cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw
        copab xpmapenlem.6 vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz
        cv vy cv csn crn cuni cfv cop wceq wa vz vw vx hbopab1 hbxfr hbeleq vw
        vx cS vw vx cS vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv
        vy cv csn crn cuni cfv cop wceq wa vz vw copab xpmapenlem.6 vz cv cC
        wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        cop wceq wa vz vw vx hbopab2 hbxfr hbeleq vx cv cS wceq vz cv cC wcel
        vw cv vz cv vx cv cfv csn crn cuni wceq vw cv vz cv vy cv csn crn cuni
        cfv wceq vx cv cS wceq vz cv cC wcel wa vz cv vx cv cfv csn crn cuni vz
        cv vy cv csn crn cuni cfv vw cv vx cv cS wceq vz cv cC wcel wa vz cv vx
        cv cfv csn crn cuni vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn
        cuni cfv cop csn crn cuni vz cv vy cv csn crn cuni cfv vx cv cS wceq vz
        cv cC wcel wa vz cv vx cv cfv csn crn vz cv vy cv csn cdm cuni cfv vz
        cv vy cv csn crn cuni cfv cop csn crn vx cv cS wceq vz cv cC wcel wa vz
        cv vx cv cfv csn vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni
        cfv cop csn vx cv cS wceq vz cv cC wcel wa vz cv vx cv cfv vz cv vy cv
        csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop vx cv cS wceq vz cv
        cC wcel vz cv vx cv cfv vz cv vz cv cC wcel vw cv vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab cfv vz cv
        vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop vx cv cS wceq
        vz cv vx cv vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy
        cv csn crn cuni cfv cop wceq wa vz vw copab vx cv cS wceq cS vz cv cC
        wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        cop wceq wa vz vw copab wceq vx cv vz cv cC wcel vw cv vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab wceq
        xpmapenlem.6 vx cv cS vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv
        vz cv vy cv csn crn cuni cfv cop wceq wa vz vw copab eqtr mpan2 fveq1d
        vz cv cC wcel vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        cop cvv wcel vz cv vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz
        cv vy cv csn crn cuni cfv cop wceq wa vz vw copab cfv vz cv vy cv csn
        cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv opex vz vw cC vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv cop cvv fvopab2 mpan2 sylan9eq
        sneqd rneqd unieqd vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn
        cuni cfv vz cv vy cv csn cdm cuni fvex vz cv vy cv csn crn cuni fvex
        op2nda syl6eq eqeq2d pm5.32da opabbid xpmapenlem.5 syl5req sylan9eq
        adantll opeq12d syl5bir exp3a imp31 jca $.
        $( [13-Jul-2004] $) $( [2-May-2004] $)

      $( Lemma for ~ xpmapen . $)
      xpmapenlem5 $p |- ( ( A X. B ) ^m C ) ~~ ( ( A ^m C ) X. ( B ^m C ) ) $=
        vx vy cA cB cxp cC cm co cA cC cm co cB cC cm co cxp cD cR cop cS cA cB
        cxp cC cm oprex cD cR cop cvv wcel vx cv cA cB cxp cC cm co wcel cD cR
        opex a1i cS cvv wcel vy cv cA cC cm co cB cC cm co cxp wcel vz vw cC vz
        cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop cS xpmapen.3
        xpmapenlem.6 fopabex2 a1i cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa
        vy cv vy cv csn cdm cuni vy cv csn crn cuni cop wceq cC cA vy cv csn
        cdm cuni wf cC cB vy cv csn crn cuni wf wa wa vx cv cS wceq wa vx cv cA
        cB cxp cC cm co wcel vy cv cD cR cop wceq wa vy cv cA cC cm co cB cC cm
        co cxp wcel vx cv cS wceq wa cC cA cB cxp vx cv wf vy cv cD cR cop wceq
        wa vy cv vy cv csn cdm cuni vy cv csn crn cuni cop wceq cC cA vy cv csn
        cdm cuni wf cC cB vy cv csn crn cuni wf wa wa vx cv cS wceq wa cC cA cB
        cxp vx cv wf vy cv cD cR cop wceq wa vy cv vy cv csn cdm cuni vy cv csn
        crn cuni cop wceq cC cA vy cv csn cdm cuni wf cC cB vy cv csn crn cuni
        wf wa vx cv cS wceq cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vy cv
        cvv cvv cxp wcel vy cv vy cv csn cdm cuni vy cv csn crn cuni cop wceq
        vy cv cD cR cop wceq vy cv cvv cvv cxp wcel cC cA cB cxp vx cv wf vy cv
        cD cR cop wceq vy cv cvv cvv cxp wcel cD cR cop cvv cvv cxp wcel cD cR
        cop cvv cvv cxp wcel cD cvv wcel cR cvv wcel cD cR cvv cvv vz vw cC vz
        cv vx cv cfv csn crn cuni cR xpmapen.3 xpmapenlem.5 fopabex2 opelxp vz
        vw cC vz cv vx cv cfv csn cdm cuni cD xpmapen.3 xpmapenlem.4 fopabex2
        vz vw cC vz cv vx cv cfv csn crn cuni cR xpmapen.3 xpmapenlem.5
        fopabex2 mpbir2an vy cv cD cR cop cvv cvv cxp eleq1 mpbiri adantl vy cv
        cvv cvv cxp wcel vy cv vy cv csn cdm cuni vy cv csn crn cuni cop wceq
        vy cv csn cdm cuni cvv wcel vy cv csn crn cuni cvv wcel wa vy cv cvv
        cvv elxp4 pm3.26bi syl cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vy
        cv csn cdm cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv wceq
        wa vz vw copab wceq vy cv csn crn cuni vz cv cC wcel vw cv vz cv vy cv
        csn crn cuni cfv wceq wa vz vw copab wceq wa vz cv vy cv csn cdm cuni
        cfv cA wcel vz cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral
        wa wa cC cA vy cv csn cdm cuni wf cC cB vy cv csn crn cuni wf wa cC cA
        cB cxp vx cv wf vy cv cD cR cop wceq wa vy cv csn cdm cuni vz cv cC
        wcel vw cv vz cv vy cv csn cdm cuni cfv wceq wa vz vw copab wceq vy cv
        csn crn cuni vz cv cC wcel vw cv vz cv vy cv csn crn cuni cfv wceq wa
        vz vw copab wceq wa vz cv vy cv csn cdm cuni cfv cA wcel vz cC wral vz
        cv vy cv csn crn cuni cfv cB wcel vz cC wral wa vy cv cD cR cop wceq vy
        cv csn cdm cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv wceq
        wa vz vw copab wceq vy cv csn crn cuni vz cv cC wcel vw cv vz cv vy cv
        csn crn cuni cfv wceq wa vz vw copab wceq wa cC cA cB cxp vx cv wf vy
        cv cD cR cop wceq vy cv csn cdm cuni vz cv cC wcel vw cv vz cv vy cv
        csn cdm cuni cfv wceq wa vz vw copab wceq vy cv csn crn cuni vz cv cC
        wcel vw cv vz cv vy cv csn crn cuni cfv wceq wa vz vw copab wceq vy cv
        cD cR cop wceq cD cR cop csn cdm cuni cD vy cv csn cdm cuni vz cv cC
        wcel vw cv vz cv vy cv csn cdm cuni cfv wceq wa vz vw copab cD cR vz vw
        cC vz cv vx cv cfv csn cdm cuni cD xpmapen.3 xpmapenlem.4 fopabex2
        op1sta vy cv cD cR cop wceq vy cv csn cdm cD cR cop csn cdm vy cv cD cR
        cop wceq vy cv csn cD cR cop csn vy cv cD cR cop sneq dmeqd unieqd vy
        cv cD cR cop wceq vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv wceq
        wa vz vw copab vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa
        vz vw copab cD vy cv cD cR cop wceq vz cv cC wcel vw cv vz cv vy cv csn
        cdm cuni cfv wceq wa vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni
        wceq wa vz vw vy cv cD cR cop wceq vy cv cD cR cop wceq vz wal wi vy cv
        cD cR cop wceq vy cv cD cR cop wceq vw wal wi vx vy vz vw cA cB cC cD
        cR cS xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5
        xpmapenlem.6 xpmapenlem1 pm3.26i vy cv cD cR cop wceq vy cv cD cR cop
        wceq vz wal wi vy cv cD cR cop wceq vy cv cD cR cop wceq vw wal wi vx
        vy vz vw cA cB cC cD cR cS xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4
        xpmapenlem.5 xpmapenlem.6 xpmapenlem1 pm3.27i vy cv cD cR cop wceq vz
        cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv wceq vw cv vz cv vx cv
        cfv csn cdm cuni wceq vy cv cD cR cop wceq vz cv cC wcel wa vz cv vy cv
        csn cdm cuni cfv vz cv vx cv cfv csn cdm cuni vw cv vy cv cD cR cop
        wceq vz cv cC wcel wa vz cv vy cv csn cdm cuni cfv vz cv vx cv cfv csn
        cdm cuni wceq vz cv vy cv csn crn cuni cfv vz cv vx cv cfv csn crn cuni
        wceq vx vy vz vw cA cB cC cD cR cS xpmapen.1 xpmapen.2 xpmapen.3
        xpmapenlem.4 xpmapenlem.5 xpmapenlem.6 xpmapenlem2 pm3.26d eqeq2d
        pm5.32da opabbid xpmapenlem.4 syl6eqr 3eqtr4a vy cv cD cR cop wceq cD
        cR cop csn crn cuni cR vy cv csn crn cuni vz cv cC wcel vw cv vz cv vy
        cv csn crn cuni cfv wceq wa vz vw copab cD cR vz vw cC vz cv vx cv cfv
        csn cdm cuni cD xpmapen.3 xpmapenlem.4 fopabex2 vz vw cC vz cv vx cv
        cfv csn crn cuni cR xpmapen.3 xpmapenlem.5 fopabex2 op2nda vy cv cD cR
        cop wceq vy cv csn crn cD cR cop csn crn vy cv cD cR cop wceq vy cv csn
        cD cR cop csn vy cv cD cR cop sneq rneqd unieqd vy cv cD cR cop wceq vz
        cv cC wcel vw cv vz cv vy cv csn crn cuni cfv wceq wa vz vw copab vz cv
        cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw copab cR vy cv
        cD cR cop wceq vz cv cC wcel vw cv vz cv vy cv csn crn cuni cfv wceq wa
        vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw vy cv cD
        cR cop wceq vy cv cD cR cop wceq vz wal wi vy cv cD cR cop wceq vy cv
        cD cR cop wceq vw wal wi vx vy vz vw cA cB cC cD cR cS xpmapen.1
        xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5 xpmapenlem.6 xpmapenlem1
        pm3.26i vy cv cD cR cop wceq vy cv cD cR cop wceq vz wal wi vy cv cD cR
        cop wceq vy cv cD cR cop wceq vw wal wi vx vy vz vw cA cB cC cD cR cS
        xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5 xpmapenlem.6
        xpmapenlem1 pm3.27i vy cv cD cR cop wceq vz cv cC wcel vw cv vz cv vy
        cv csn crn cuni cfv wceq vw cv vz cv vx cv cfv csn crn cuni wceq vy cv
        cD cR cop wceq vz cv cC wcel wa vz cv vy cv csn crn cuni cfv vz cv vx
        cv cfv csn crn cuni vw cv vy cv cD cR cop wceq vz cv cC wcel wa vz cv
        vy cv csn cdm cuni cfv vz cv vx cv cfv csn cdm cuni wceq vz cv vy cv
        csn crn cuni cfv vz cv vx cv cfv csn crn cuni wceq vx vy vz vw cA cB cC
        cD cR cS xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5
        xpmapenlem.6 xpmapenlem2 pm3.27d eqeq2d pm5.32da opabbid xpmapenlem.5
        syl6eqr 3eqtr4a jca adantl cC cA cB cxp vx cv wf vy cv cD cR cop wceq
        wa vz cv vx cv cfv cA cB cxp wcel vz cC wral vz cv vy cv csn cdm cuni
        cfv cA wcel vz cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral
        wa cC cA cB cxp vx cv wf vz cv vx cv cfv cA cB cxp wcel vz cC wral vy
        cv cD cR cop wceq cC cA cB cxp vx cv wf vz cv vx cv cfv cA cB cxp wcel
        vz cC cC cA cB cxp vz cv vx cv ffvelrn r19.21aiva adantr cC cA cB cxp
        vx cv wf vy cv cD cR cop wceq wa vz cv vx cv cfv cA cB cxp wcel vz cC
        wral vz cv vy cv csn cdm cuni cfv cA wcel vz cv vy cv csn crn cuni cfv
        cB wcel wa vz cC wral vz cv vy cv csn cdm cuni cfv cA wcel vz cC wral
        vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa cC cA cB cxp vx cv
        wf vy cv cD cR cop wceq wa vz cv vx cv cfv cA cB cxp wcel vz cv vy cv
        csn cdm cuni cfv cA wcel vz cv vy cv csn crn cuni cfv cB wcel wa vz cC
        cC cA cB cxp vx cv wf vy cv cD cR cop wceq vz cC cA cB cxp vx cv wf vz
        ax-17 vy cv cD cR cop wceq vy cv cD cR cop wceq vz wal wi vy cv cD cR
        cop wceq vy cv cD cR cop wceq vw wal wi vx vy vz vw cA cB cC cD cR cS
        xpmapen.1 xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5 xpmapenlem.6
        xpmapenlem1 pm3.26i hban cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa
        vz cv cC wcel wa vz cv vx cv cfv cA cB cxp wcel vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv cop cA cB cxp wcel vz cv vy cv
        csn cdm cuni cfv cA wcel vz cv vy cv csn crn cuni cfv cB wcel wa cC cA
        cB cxp vx cv wf vy cv cD cR cop wceq wa vz cv cC wcel wa vz cv vx cv
        cfv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop cA cB
        cxp cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vz cv cC wcel vz cv
        vx cv cfv vz cv cS cfv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn
        cuni cfv cop cC cA cB cxp vx cv wf vy cv cD cR cop wceq wa vz cv vx cv
        cS vx vy vz vw cA cB cC cD cR cS xpmapen.1 xpmapen.2 xpmapen.3
        xpmapenlem.4 xpmapenlem.5 xpmapenlem.6 xpmapenlem3 fveq1d vz cv cC wcel
        vz cv vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn
        crn cuni cfv cop wceq wa vz vw copab cfv vz cv vy cv csn cdm cuni cfv
        vz cv vy cv csn crn cuni cfv cop vz cv cS cfv vz cv cC wcel vz cv vy cv
        csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop cvv wcel vz cv vz cv
        cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv
        cop wceq wa vz vw copab cfv vz cv vy cv csn cdm cuni cfv vz cv vy cv
        csn crn cuni cfv cop wceq vz cv vy cv csn cdm cuni cfv vz cv vy cv csn
        crn cuni cfv opex vz vw cC vz cv vy cv csn cdm cuni cfv vz cv vy cv csn
        crn cuni cfv cop cvv fvopab2 mpan2 vz cv cS vz cv cC wcel vw cv vz cv
        vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni cfv cop wceq wa vz vw
        copab xpmapenlem.6 fveq1i syl5eq sylan9eq eleq1d vz cv vy cv csn cdm
        cuni cfv vz cv vy cv csn crn cuni cfv cA cB vz cv vy cv csn crn cuni
        fvex opelxp syl6bb ralbida vz cv vy cv csn cdm cuni cfv cA wcel vz cv
        vy cv csn crn cuni cfv cB wcel vz cC r19.26 syl6bb mpbid jca vy cv csn
        cdm cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv wceq wa vz vw
        copab wceq vy cv csn crn cuni vz cv cC wcel vw cv vz cv vy cv csn crn
        cuni cfv wceq wa vz vw copab wceq wa vz cv vy cv csn cdm cuni cfv cA
        wcel vz cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa wa
        vy cv csn cdm cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv
        wceq wa vz vw copab wceq vz cv vy cv csn cdm cuni cfv cA wcel vz cC
        wral wa vy cv csn crn cuni vz cv cC wcel vw cv vz cv vy cv csn crn cuni
        cfv wceq wa vz vw copab wceq vz cv vy cv csn crn cuni cfv cB wcel vz cC
        wral wa wa cC cA vy cv csn cdm cuni wf cC cB vy cv csn crn cuni wf wa
        vy cv csn cdm cuni vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv
        wceq wa vz vw copab wceq vy cv csn crn cuni vz cv cC wcel vw cv vz cv
        vy cv csn crn cuni cfv wceq wa vz vw copab wceq vz cv vy cv csn cdm
        cuni cfv cA wcel vz cC wral vz cv vy cv csn crn cuni cfv cB wcel vz cC
        wral an4 cC cA vy cv csn cdm cuni wf vy cv csn cdm cuni vz cv cC wcel
        vw cv vz cv vy cv csn cdm cuni cfv wceq wa vz vw copab wceq vz cv vy cv
        csn cdm cuni cfv cA wcel vz cC wral wa cC cB vy cv csn crn cuni wf vy
        cv csn crn cuni vz cv cC wcel vw cv vz cv vy cv csn crn cuni cfv wceq
        wa vz vw copab wceq vz cv vy cv csn crn cuni cfv cB wcel vz cC wral wa
        vz vw cC cA vy cv csn cdm cuni fopabfv vz vw cC cB vy cv csn crn cuni
        fopabfv anbi12i bitr4i sylib vx vy vz vw cA cB cC cD cR cS xpmapen.1
        xpmapen.2 xpmapen.3 xpmapenlem.4 xpmapenlem.5 xpmapenlem.6 xpmapenlem3
        jca31 vx vy vz vw cA cB cC cD cR cS xpmapen.1 xpmapen.2 xpmapen.3
        xpmapenlem.4 xpmapenlem.5 xpmapenlem.6 xpmapenlem4 impbii vx cv cA cB
        cxp cC cm co wcel cC cA cB cxp vx cv wf vy cv cD cR cop wceq cA cB cxp
        cC vx cv cA cB xpmapen.1 xpmapen.2 xpex xpmapen.3 elmap anbi1i vy cv cA
        cC cm co cB cC cm co cxp wcel vy cv vy cv csn cdm cuni vy cv csn crn
        cuni cop wceq cC cA vy cv csn cdm cuni wf cC cB vy cv csn crn cuni wf
        wa wa vx cv cS wceq vy cv cA cC cm co cB cC cm co cxp wcel vy cv vy cv
        csn cdm cuni vy cv csn crn cuni cop wceq vy cv csn cdm cuni cA cC cm co
        wcel vy cv csn crn cuni cB cC cm co wcel wa wa vy cv vy cv csn cdm cuni
        vy cv csn crn cuni cop wceq cC cA vy cv csn cdm cuni wf cC cB vy cv csn
        crn cuni wf wa wa vy cv cA cC cm co cB cC cm co elxp4 vy cv csn cdm
        cuni cA cC cm co wcel vy cv csn crn cuni cB cC cm co wcel wa cC cA vy
        cv csn cdm cuni wf cC cB vy cv csn crn cuni wf wa vy cv vy cv csn cdm
        cuni vy cv csn crn cuni cop wceq vy cv csn cdm cuni cA cC cm co wcel cC
        cA vy cv csn cdm cuni wf vy cv csn crn cuni cB cC cm co wcel cC cB vy
        cv csn crn cuni wf cA cC vy cv csn cdm cuni xpmapen.1 xpmapen.3 elmap
        cB cC vy cv csn crn cuni xpmapen.2 xpmapen.3 elmap anbi12i anbi2i bitri
        anbi1i 3bitr4i en2 $.
        $( [13-Jul-2004] $) $( [1-May-2004] $)
    $}

    $( Equinumerosity law for set exponentiation of a cross product.
       Exercise 4.47 of [Mendelson] p. 255. $)
    xpmapen $p |- ( ( A X. B ) ^m C ) ~~ ( ( A ^m C ) X. ( B ^m C ) ) $=
      vx vy vz vw cA cB cC vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni
      wceq wa vz vw copab vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq
      wa vz vw copab vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy
      cv csn crn cuni cfv cop wceq wa vz vw copab xpmapen.1 xpmapen.2 xpmapen.3
      vz cv cC wcel vw cv vz cv vx cv cfv csn cdm cuni wceq wa vz vw copab eqid
      vz cv cC wcel vw cv vz cv vx cv cfv csn crn cuni wceq wa vz vw copab eqid
      vz cv cC wcel vw cv vz cv vy cv csn cdm cuni cfv vz cv vy cv csn crn cuni
      cfv cop wceq wa vz vw copab eqid xpmapenlem5 $.
      $( [13-Jul-2004] $) $( [23-Feb-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    mapunen.1 $e |- A e. _V $.
    mapunen.2 $e |- B e. _V $.
    mapunen.3 $e |- C e. _V $.
    $( Equinumerosity law for set exponentiation of a disjoint union.
       Exercise 4.45 of [Mendelson] p. 255. $)
    mapunen $p |- ( ( A i^i B ) = (/) ->
                  ( C ^m ( A u. B ) ) ~~ ( ( C ^m A ) X. ( C ^m B ) ) ) $=
      cA cB cin c0 wceq vx vy cC cA cB cun cm co cC cA cm co cC cB cm co cxp vx
      cv cA cres vx cv cB cres cop vy cv cint cint vy cv csn crn cuni cun cC cA
      cB cun cm co cvv wcel cA cB cin c0 wceq cC cA cB cun cm oprex a1i vx cv
      cC cA cB cun cm co wcel vx cv cA cres vx cv cB cres cop cC cA cm co cC cB
      cm co cxp wcel wi cA cB cin c0 wceq cA cB cun cC vx cv wf vx cv cA cres
      cC cA cm co wcel vx cv cB cres cC cB cm co wcel wa vx cv cC cA cB cun cm
      co wcel vx cv cA cres vx cv cB cres cop cC cA cm co cC cB cm co cxp wcel
      cA cB cun cC vx cv wf vx cv cA cres cC cA cm co wcel vx cv cB cres cC cB
      cm co wcel cA cB cun cC vx cv wf cA cC vx cv cA cres wf vx cv cA cres cC
      cA cm co wcel cA cB cun cC vx cv wf cA cA cB cun wss cA cC vx cv cA cres
      wf cA cB ssun1 cA cB cun cC cA vx cv fssres mpan2 cC cA vx cv cA cres
      mapunen.3 mapunen.1 elmap sylibr cA cB cun cC vx cv wf cB cC vx cv cB
      cres wf vx cv cB cres cC cB cm co wcel cA cB cun cC vx cv wf cB cA cB cun
      wss cB cC vx cv cB cres wf cB cA ssun2 cA cB cun cC cB vx cv fssres mpan2
      cC cB vx cv cB cres mapunen.3 mapunen.2 elmap sylibr jca cC cA cB cun vx
      cv mapunen.3 cA cB mapunen.1 mapunen.2 unex elmap vx cv cA cres vx cv cB
      cres cC cA cm co cC cB cm co vx cv cvv wcel vx cv cB cres cvv wcel vx
      visset vx cv cB cvv resexg ax-mp opelxp 3imtr4i a1i vy cv cC cA cm co cC
      cB cm co cxp wcel cA cB cin c0 wceq vy cv cint cint vy cv csn crn cuni
      cun cC cA cB cun cm co wcel cA cC vy cv cint cint wf cB cC vy cv csn crn
      cuni wf wa cA cB cin c0 wceq vy cv cint cint vy cv csn crn cuni cun cC cA
      cB cun cm co wcel vy cv cC cA cm co cC cB cm co cxp wcel cA cC vy cv cint
      cint wf cB cC vy cv csn crn cuni wf wa cA cB cin c0 wceq wa cA cB cun cC
      cC cun vy cv cint cint vy cv csn crn cuni cun wf vy cv cint cint vy cv
      csn crn cuni cun cC cA cB cun cm co wcel cA cB cC cC vy cv cint cint vy
      cv csn crn cuni fun vy cv cint cint vy cv csn crn cuni cun cC cA cB cun
      cm co wcel cA cB cun cC vy cv cint cint vy cv csn crn cuni cun wf cA cB
      cun cC cC cun vy cv cint cint vy cv csn crn cuni cun wf cC cA cB cun vy
      cv cint cint vy cv csn crn cuni cun mapunen.3 cA cB mapunen.1 mapunen.2
      unex elmap cC cC cun cC wceq cA cB cun cC cC cun vy cv cint cint vy cv
      csn crn cuni cun wf cA cB cun cC vy cv cint cint vy cv csn crn cuni cun
      wf wb cC unidm cC cC cun cC cA cB cun vy cv cint cint vy cv csn crn cuni
      cun feq3 ax-mp bitr4i sylibr vy cv cC cA cm co cC cB cm co cxp wcel vy cv
      cint cint cC cA cm co wcel vy cv csn crn cuni cC cB cm co wcel wa cA cC
      vy cv cint cint wf cB cC vy cv csn crn cuni wf wa vy cv cC cA cm co cC cB
      cm co cxp wcel vy cv vy cv cint cint vy cv csn crn cuni cop wceq vy cv
      cint cint cC cA cm co wcel vy cv csn crn cuni cC cB cm co wcel wa vy cv
      cC cA cm co cC cB cm co elxp5 pm3.27bi vy cv cint cint cC cA cm co wcel
      cA cC vy cv cint cint wf vy cv csn crn cuni cC cB cm co wcel cB cC vy cv
      csn crn cuni wf cC cA vy cv cint cint mapunen.3 mapunen.1 elmap cC cB vy
      cv csn crn cuni mapunen.3 mapunen.2 elmap anbi12i sylib sylan expcom cA
      cB cin c0 wceq vx cv cC cA cB cun cm co wcel vy cv cC cA cm co cC cB cm
      co cxp wcel wa vx cv vy cv cint cint vy cv csn crn cuni cun wceq vy cv vx
      cv cA cres vx cv cB cres cop wceq wb cA cB cin c0 wceq vx cv cC cA cB cun
      cm co wcel vy cv cC cA cm co cC cB cm co cxp wcel wa wa vx cv vy cv cint
      cint vy cv csn crn cuni cun wceq vy cv vx cv cA cres vx cv cB cres cop
      wceq cA cB cin c0 wceq vy cv cC cA cm co cC cB cm co cxp wcel vx cv vy cv
      cint cint vy cv csn crn cuni cun wceq vy cv vx cv cA cres vx cv cB cres
      cop wceq wi vx cv cC cA cB cun cm co wcel vy cv cC cA cm co cC cB cm co
      cxp wcel cA cB cin c0 wceq vx cv vy cv cint cint vy cv csn crn cuni cun
      wceq vy cv vx cv cA cres vx cv cB cres cop wceq wi vy cv cC cA cm co cC
      cB cm co cxp wcel vy cv vy cv cint cint vy cv csn crn cuni cop wceq vy cv
      cint cint cC cA cm co wcel vy cv csn crn cuni cC cB cm co wcel wa wa cA
      cB cin c0 wceq vx cv vy cv cint cint vy cv csn crn cuni cun wceq vy cv vx
      cv cA cres vx cv cB cres cop wceq wi wi vy cv cC cA cm co cC cB cm co
      elxp5 vy cv vy cv cint cint vy cv csn crn cuni cop wceq vy cv cint cint
      cA wfn vy cv csn crn cuni cB wfn wa cA cB cin c0 wceq vx cv vy cv cint
      cint vy cv csn crn cuni cun wceq vy cv vx cv cA cres vx cv cB cres cop
      wceq wi wi vy cv cint cint cC cA cm co wcel vy cv csn crn cuni cC cB cm
      co wcel wa vy cv vy cv cint cint vy cv csn crn cuni cop wceq vy cv cint
      cint cA wfn vy cv csn crn cuni cB wfn wa cA cB cin c0 wceq vx cv vy cv
      cint cint vy cv csn crn cuni cun wceq vy cv vx cv cA cres vx cv cB cres
      cop wceq wi wi vy cv vy cv cint cint vy cv csn crn cuni cop wceq vy cv
      cint cint cA wfn vy cv csn crn cuni cB wfn wa cA cB cin c0 wceq vx cv vy
      cv cint cint vy cv csn crn cuni cun wceq vy cv vx cv cA cres vx cv cB
      cres cop wceq vy cv cint cint cA wfn vy cv csn crn cuni cB wfn wa cA cB
      cin c0 wceq wa vx cv vy cv cint cint vy cv csn crn cuni cun wceq wa vy cv
      vx cv cA cres vx cv cB cres cop wceq vy cv vy cv cint cint vy cv csn crn
      cuni cop wceq vy cv cint cint cA wfn vy cv csn crn cuni cB wfn wa cA cB
      cin c0 wceq wa vx cv vy cv cint cint vy cv csn crn cuni cun wceq wa vx cv
      cA cres vx cv cB cres cop vy cv cint cint vy cv csn crn cuni cop vy cv vy
      cv cint cint cA wfn vy cv csn crn cuni cB wfn wa cA cB cin c0 wceq wa vx
      cv vy cv cint cint vy cv csn crn cuni cun wceq wa vx cv cA cres vy cv
      cint cint vx cv cB cres vy cv csn crn cuni vx cv vy cv cint cint vy cv
      csn crn cuni cun wceq vy cv cint cint cA wfn vy cv csn crn cuni cB wfn wa
      cA cB cin c0 wceq wa vx cv cA cres vy cv cint cint cA cres vy cv csn crn
      cuni cA cres cun vy cv cint cint vx cv vy cv cint cint vy cv csn crn cuni
      cun wceq vx cv cA cres vy cv cint cint vy cv csn crn cuni cun cA cres vy
      cv cint cint cA cres vy cv csn crn cuni cA cres cun vx cv vy cv cint cint
      vy cv csn crn cuni cun cA reseq1 vy cv cint cint vy cv csn crn cuni cA
      resundir syl6eq vy cv cint cint cA wfn vy cv csn crn cuni cB wfn cA cB
      cin c0 wceq vy cv cint cint cA cres vy cv csn crn cuni cA cres cun vy cv
      cint cint wceq vy cv cint cint cA wfn vy cv csn crn cuni cB wfn cA cB cin
      c0 wceq wa vy cv cint cint cA cres vy cv csn crn cuni cA cres cun vy cv
      cint cint vy cv csn crn cuni cA cres cun vy cv cint cint vy cv cint cint
      cA wfn vy cv cint cint cA cres vy cv cint cint vy cv csn crn cuni cA cres
      cA vy cv cint cint fnresdm uneq1d vy cv csn crn cuni cB wfn cA cB cin c0
      wceq wa vy cv cint cint vy cv csn crn cuni cA cres cun vy cv cint cint c0
      cun vy cv cint cint vy cv csn crn cuni cB wfn cA cB cin c0 wceq wa vy cv
      csn crn cuni cA cres c0 vy cv cint cint vy cv csn crn cuni cB wfn cB cA
      cin c0 wceq vy cv csn crn cuni cA cres c0 wceq cA cB cin c0 wceq vy cv
      csn crn cuni cB wfn cB cA cin c0 wceq vy cv csn crn cuni cA cres c0 wceq
      cB cA vy cv csn crn cuni fnresdisj biimpa cA cB cin cB cA cin c0 cA cB
      incom eqeq1i sylan2b uneq2d vy cv cint cint un0 syl6eq sylan9eq anassrs
      sylan9eqr vx cv vy cv cint cint vy cv csn crn cuni cun wceq vy cv cint
      cint cA wfn vy cv csn crn cuni cB wfn wa cA cB cin c0 wceq wa vx cv cB
      cres vy cv cint cint cB cres vy cv csn crn cuni cB cres cun vy cv csn crn
      cuni vx cv vy cv cint cint vy cv csn crn cuni cun wceq vx cv cB cres vy
      cv cint cint vy cv csn crn cuni cun cB cres vy cv cint cint cB cres vy cv
      csn crn cuni cB cres cun vx cv vy cv cint cint vy cv csn crn cuni cun cB
      reseq1 vy cv cint cint vy cv csn crn cuni cB resundir syl6eq vy cv cint
      cint cA wfn cA cB cin c0 wceq vy cv csn crn cuni cB wfn vy cv cint cint
      cB cres vy cv csn crn cuni cB cres cun vy cv csn crn cuni wceq vy cv csn
      crn cuni cB wfn vy cv cint cint cA wfn cA cB cin c0 wceq wa vy cv cint
      cint cB cres vy cv csn crn cuni cB cres cun vy cv cint cint cB cres vy cv
      csn crn cuni cun vy cv csn crn cuni vy cv csn crn cuni cB wfn vy cv csn
      crn cuni cB cres vy cv csn crn cuni vy cv cint cint cB cres cB vy cv csn
      crn cuni fnresdm uneq2d vy cv cint cint cA wfn cA cB cin c0 wceq wa vy cv
      cint cint cB cres vy cv csn crn cuni cun c0 vy cv csn crn cuni cun vy cv
      csn crn cuni vy cv cint cint cA wfn cA cB cin c0 wceq wa vy cv cint cint
      cB cres c0 vy cv csn crn cuni vy cv cint cint cA wfn cA cB cin c0 wceq vy
      cv cint cint cB cres c0 wceq cA cB vy cv cint cint fnresdisj biimpa
      uneq1d c0 vy cv csn crn cuni cun vy cv csn crn cuni c0 cun vy cv csn crn
      cuni c0 vy cv csn crn cuni uncom vy cv csn crn cuni un0 eqtri syl6eq
      sylan9eqr an1rs sylan9eqr opeq12d eqeq2d biimparc exp44 imp vy cv cint
      cint cC cA cm co wcel vy cv cint cint cA wfn vy cv csn crn cuni cC cB cm
      co wcel vy cv csn crn cuni cB wfn vy cv cint cint cC cA cm co wcel cA cC
      vy cv cint cint wf vy cv cint cint cA wfn cC cA vy cv cint cint mapunen.3
      mapunen.1 elmap cA cC vy cv cint cint ffn sylbi vy cv csn crn cuni cC cB
      cm co wcel cB cC vy cv csn crn cuni wf vy cv csn crn cuni cB wfn cC cB vy
      cv csn crn cuni mapunen.3 mapunen.2 elmap cB cC vy cv csn crn cuni ffn
      sylbi anim12i sylan2 sylbi impcom adantrl vx cv cC cA cB cun cm co wcel
      vy cv vx cv cA cres vx cv cB cres cop wceq vx cv vy cv cint cint vy cv
      csn crn cuni cun wceq wi cA cB cin c0 wceq vy cv cC cA cm co cC cB cm co
      cxp wcel vx cv cC cA cB cun cm co wcel vy cv vx cv cA cres vx cv cB cres
      cop wceq vx cv vy cv cint cint vy cv csn crn cuni cun wceq vx cv cC cA cB
      cun cm co wcel vy cv vx cv cA cres vx cv cB cres cop wceq vx cv vx cv cA
      cB cun cres vy cv cint cint vy cv csn crn cuni cun vx cv cC cA cB cun cm
      co wcel vx cv cA cB cun wfn vx cv cA cB cun cres vx cv wceq vx cv cC cA
      cB cun cm co wcel cA cB cun cC vx cv wf vx cv cA cB cun wfn cC cA cB cun
      vx cv mapunen.3 cA cB mapunen.1 mapunen.2 unex elmap cA cB cun cC vx cv
      ffn sylbi cA cB cun vx cv fnresdm syl vy cv vx cv cA cres vx cv cB cres
      cop wceq vy cv cint cint vy cv csn crn cuni cun vx cv cA cres vx cv cB
      cres cun vx cv cA cB cun cres vy cv vx cv cA cres vx cv cB cres cop wceq
      vy cv cint cint vx cv cA cres vy cv csn crn cuni vx cv cB cres vy cv vx
      cv cA cres vx cv cB cres cop wceq vy cv cint cint vx cv cA cres vx cv cB
      cres cop cint cint vx cv cA cres vy cv vx cv cA cres vx cv cB cres cop
      wceq vy cv cint vx cv cA cres vx cv cB cres cop cint vy cv vx cv cA cres
      vx cv cB cres cop inteq inteqd vx cv cA cres vx cv cB cres vx cv cvv wcel
      vx cv cA cres cvv wcel vx visset vx cv cA cvv resexg ax-mp op1stb syl6eq
      vy cv vx cv cA cres vx cv cB cres cop wceq vy cv csn crn cuni vx cv cA
      cres vx cv cB cres cop csn crn cuni vx cv cB cres vy cv vx cv cA cres vx
      cv cB cres cop wceq vy cv csn crn vx cv cA cres vx cv cB cres cop csn crn
      vy cv vx cv cA cres vx cv cB cres cop wceq vy cv csn vx cv cA cres vx cv
      cB cres cop csn vy cv vx cv cA cres vx cv cB cres cop sneq rneqd unieqd
      vx cv cA cres vx cv cB cres vx cv cvv wcel vx cv cA cres cvv wcel vx
      visset vx cv cA cvv resexg ax-mp vx cv cvv wcel vx cv cB cres cvv wcel vx
      visset vx cv cB cvv resexg ax-mp op2nda syl6eq uneq12d vx cv cA cB
      resundi syl6reqr sylan9req ex ad2antrl impbid ex en3d $.
      $( [10-Nov-2004] $) $( [23-Sep-2004] $)
  $}

  ${
    $d x y A $.  $d x B $.
    pwen.1 $e |- B e. _V $.
    $( If two sets are equinumerous, then their power sets are equinumerous.
       Proposition 10.15 of [TakeutiZaring] p. 87. $)
    pwen $p |- ( A ~~ B -> ~P A ~~ ~P B ) $=
      cA cvv wcel cA cB cen wbr cA cpw cB cpw cen wbr cA cB cen relen brrelexi
      vx cv cB cen wbr vx cv cpw cB cpw cen wbr wi cA cB cen wbr cA cpw cB cpw
      cen wbr wi vx cA cvv vx cv cA wceq vx cv cB cen wbr cA cB cen wbr vx cv
      cpw cB cpw cen wbr cA cpw cB cpw cen wbr vx cv cA cB cen breq1 vx cv cA
      wceq vx cv cpw cA cpw cB cpw cen vx cv cA pweq breq1d imbi12d vx cv cB
      cen wbr c2o vx cv cm co c2o cB cm co cen wbr vx cv cpw cB cpw cen wbr c2o
      c2o cen wbr vx cv cB cen wbr c2o vx cv cm co c2o cB cm co cen wbr c2o
      con0 wcel c2o c2o cen wbr 2on c2o con0 enrefg ax-mp c2o c2o vx cv cB c2o
      con0 2on elisseti c2o con0 2on elisseti vx visset pwen.1 mapen mpan vx cv
      cpw cB cpw cen wbr c2o vx cv cm co cB cpw cen wbr c2o vx cv cm co c2o cB
      cm co cen wbr c2o vx cv cm co cvv wcel vx cv cpw c2o vx cv cm co cen wbr
      vx cv cpw cB cpw cen wbr c2o vx cv cm co cB cpw cen wbr wb c2o vx cv cm
      oprex vx cv vx visset pw2en vx cv cpw c2o vx cv cm co cB cpw cvv enen1
      mp2an c2o cB cm co cvv wcel cB cpw c2o cB cm co cen wbr c2o vx cv cm co
      cB cpw cen wbr c2o vx cv cm co c2o cB cm co cen wbr wb c2o cB cm oprex cB
      pwen.1 pw2en cB cpw c2o cB cm co c2o vx cv cm co cvv enen2 mp2an bitr2i
      sylib vtoclg mpcom $.
      $( [29-Mar-2007] $) $( [29-Jan-2004] $)
  $}

  ${
    $d x y z f A $.  $d x y z f B $.  $d x y z f C $.
    ssenen.1 $e |- A e. _V $.
    ssenen.2 $e |- B e. _V $.
    $( Equinumerosity of equinumerous subsets of a  set. $)
    ssenen $p |- ( A ~~ B ->
             { x | ( x C_ A /\ x ~~ C ) } ~~ { x | ( x C_ B /\ x ~~ C ) } ) $=
      cA cB cen wbr cA cpw vx cv cC cen wbr vx cab cin cB cpw vx cv cC cen wbr
      vx cab cin vx cv cA wss vx cv cC cen wbr wa vx cab vx cv cB wss vx cv cC
      cen wbr wa vx cab cen cA cB cen wbr cA cB vf cv wf1o vf wex cA cpw vx cv
      cC cen wbr vx cab cin cB cpw vx cv cC cen wbr vx cab cin cen wbr cA cB vf
      ssenen.2 bren cA cB vf cv wf1o cA cpw vx cv cC cen wbr vx cab cin cB cpw
      vx cv cC cen wbr vx cab cin cen wbr vf cA cB vf cv wf1o vy vz cA cpw vx
      cv cC cen wbr vx cab cin cB cpw vx cv cC cen wbr vx cab cin vf cv vy cv
      cima vf cv ccnv vz cv cima cA cpw vx cv cC cen wbr vx cab cin cvv wcel cA
      cB vf cv wf1o cA cpw vx cv cC cen wbr vx cab cA ssenen.1 pwex inex1 a1i
      cA cB vf cv wf1o vy cv cA wss vy cv cC cen wbr wa vf cv vy cv cima cB wss
      vf cv vy cv cima cC cen wbr wa vy cv cA cpw vx cv cC cen wbr vx cab cin
      wcel vf cv vy cv cima cB cpw vx cv cC cen wbr vx cab cin wcel cA cB vf cv
      wf1o vy cv cA wss vy cv cC cen wbr wa vf cv vy cv cima cC cen wbr vf cv
      vy cv cima cB wss cA cB vf cv wf1o vy cv cA wss vy cv cC cen wbr vf cv vy
      cv cima cC cen wbr cA cB vf cv wf1o vy cv cA wss vy cv cC cen wbr vf cv
      vy cv cima cC cen wbr vf cv vy cv cima vy cv cen wbr vy cv cC cen wbr vf
      cv vy cv cima cC cen wbr cA cB vf cv wf1o vy cv cA wss wa vf cv vy cv
      cima vy cv cC entr cA cB vf cv wf1 vy cv cA wss vf cv vy cv cima vy cv
      cen wbr cA cB vf cv wf1o cA cB vy cv vf cv vy visset f1imaen cA cB vf cv
      f1of1 sylan sylan exp31 imp3a cA cB vf cv wf1o cA cB vf cv wfo vf cv vy
      cv cima cB wss cA cB vf cv f1ofo cA cB vf cv wfo vf cv vy cv cima vf cv
      crn wss vf cv vy cv cima cB wss vf cv vy cv imassrn cA cB vf cv wfo vf cv
      crn cB vf cv vy cv cima cA cB vf cv forn sseq2d mpbii syl jctild vy cv cA
      cpw vx cv cC cen wbr vx cab cin wcel vy cv cA cpw wcel vy cv vx cv cC cen
      wbr vx cab wcel wa vy cv cA wss vy cv cC cen wbr wa vy cv cA cpw vx cv cC
      cen wbr vx cab elin vy cv cA cpw wcel vy cv cA wss vy cv vx cv cC cen wbr
      vx cab wcel vy cv cC cen wbr vy cv cA vy visset elpw vx cv cC cen wbr vy
      cv cC cen wbr vx vy cv vy visset vx cv vy cv cC cen breq1 elab anbi12i
      bitri vf cv vy cv cima cB cpw vx cv cC cen wbr vx cab cin wcel vf cv vy
      cv cima cB cpw wcel vf cv vy cv cima vx cv cC cen wbr vx cab wcel wa vf
      cv vy cv cima cB wss vf cv vy cv cima cC cen wbr wa vf cv vy cv cima cB
      cpw vx cv cC cen wbr vx cab elin vf cv vy cv cima cB cpw wcel vf cv vy cv
      cima cB wss vf cv vy cv cima vx cv cC cen wbr vx cab wcel vf cv vy cv
      cima cC cen wbr vf cv vy cv cima cB vf cv cvv wcel vf cv vy cv cima cvv
      wcel vf visset vf cv vy cv cvv imaexg ax-mp elpw vx cv cC cen wbr vf cv
      vy cv cima cC cen wbr vx vf cv vy cv cima vf cv cvv wcel vf cv vy cv cima
      cvv wcel vf visset vf cv vy cv cvv imaexg ax-mp vx cv vf cv vy cv cima cC
      cen breq1 elab anbi12i bitri 3imtr4g cA cB vf cv wf1o vz cv cB wss vz cv
      cC cen wbr wa vf cv ccnv vz cv cima cA wss vf cv ccnv vz cv cima cC cen
      wbr wa vz cv cB cpw vx cv cC cen wbr vx cab cin wcel vf cv ccnv vz cv
      cima cA cpw vx cv cC cen wbr vx cab cin wcel cA cB vf cv wf1o cB cA vf cv
      ccnv wf1o vz cv cB wss vz cv cC cen wbr wa vf cv ccnv vz cv cima cA wss
      vf cv ccnv vz cv cima cC cen wbr wa wi cA cB vf cv f1ocnv cB cA vf cv
      ccnv wf1o vz cv cB wss vz cv cC cen wbr wa vf cv ccnv vz cv cima cC cen
      wbr vf cv ccnv vz cv cima cA wss cB cA vf cv ccnv wf1o vz cv cB wss vz cv
      cC cen wbr vf cv ccnv vz cv cima cC cen wbr cB cA vf cv ccnv wf1o vz cv
      cB wss vz cv cC cen wbr vf cv ccnv vz cv cima cC cen wbr vf cv ccnv vz cv
      cima vz cv cen wbr vz cv cC cen wbr vf cv ccnv vz cv cima cC cen wbr cB
      cA vf cv ccnv wf1o vz cv cB wss wa vf cv ccnv vz cv cima vz cv cC entr cB
      cA vf cv ccnv wf1 vz cv cB wss vf cv ccnv vz cv cima vz cv cen wbr cB cA
      vf cv ccnv wf1o cB cA vz cv vf cv ccnv vz visset f1imaen cB cA vf cv ccnv
      f1of1 sylan sylan exp31 imp3a cB cA vf cv ccnv wf1o cB cA vf cv ccnv wfo
      vf cv ccnv vz cv cima cA wss cB cA vf cv ccnv f1ofo cB cA vf cv ccnv wfo
      vf cv ccnv vz cv cima vf cv ccnv crn wss vf cv ccnv vz cv cima cA wss vf
      cv ccnv vz cv imassrn cB cA vf cv ccnv wfo vf cv ccnv crn cA vf cv ccnv
      vz cv cima cB cA vf cv ccnv forn sseq2d mpbii syl jctild syl vz cv cB cpw
      vx cv cC cen wbr vx cab cin wcel vz cv cB cpw wcel vz cv vx cv cC cen wbr
      vx cab wcel wa vz cv cB wss vz cv cC cen wbr wa vz cv cB cpw vx cv cC cen
      wbr vx cab elin vz cv cB cpw wcel vz cv cB wss vz cv vx cv cC cen wbr vx
      cab wcel vz cv cC cen wbr vz cv cB vz visset elpw vx cv cC cen wbr vz cv
      cC cen wbr vx vz cv vz visset vx cv vz cv cC cen breq1 elab anbi12i bitri
      vf cv ccnv vz cv cima cA cpw vx cv cC cen wbr vx cab cin wcel vf cv ccnv
      vz cv cima cA cpw wcel vf cv ccnv vz cv cima vx cv cC cen wbr vx cab wcel
      wa vf cv ccnv vz cv cima cA wss vf cv ccnv vz cv cima cC cen wbr wa vf cv
      ccnv vz cv cima cA cpw vx cv cC cen wbr vx cab elin vf cv ccnv vz cv cima
      cA cpw wcel vf cv ccnv vz cv cima cA wss vf cv ccnv vz cv cima vx cv cC
      cen wbr vx cab wcel vf cv ccnv vz cv cima cC cen wbr vf cv ccnv vz cv
      cima cA vf cv ccnv cvv wcel vf cv ccnv vz cv cima cvv wcel vf cv vf
      visset cnvex vf cv ccnv vz cv cvv imaexg ax-mp elpw vx cv cC cen wbr vf
      cv ccnv vz cv cima cC cen wbr vx vf cv ccnv vz cv cima vf cv ccnv cvv
      wcel vf cv ccnv vz cv cima cvv wcel vf cv vf visset cnvex vf cv ccnv vz
      cv cvv imaexg ax-mp vx cv vf cv ccnv vz cv cima cC cen breq1 elab anbi12i
      bitri 3imtr4g cA cB vf cv wf1o vy cv cA cpw vx cv cC cen wbr vx cab cin
      wcel vz cv cB cpw vx cv cC cen wbr vx cab cin wcel wa vy cv vf cv ccnv vz
      cv cima wceq vz cv vf cv vy cv cima wceq wb cA cB vf cv wf1o vy cv cA cpw
      vx cv cC cen wbr vx cab cin wcel vz cv cB cpw vx cv cC cen wbr vx cab cin
      wcel wa wa vy cv vf cv ccnv vz cv cima wceq vz cv vf cv vy cv cima wceq
      cA cB vf cv wf1o vz cv cB cpw vx cv cC cen wbr vx cab cin wcel vy cv vf
      cv ccnv vz cv cima wceq vz cv vf cv vy cv cima wceq wi vy cv cA cpw vx cv
      cC cen wbr vx cab cin wcel cA cB vf cv wf1o vz cv cB wss vy cv vf cv ccnv
      vz cv cima wceq vz cv vf cv vy cv cima wceq wi vz cv cB cpw vx cv cC cen
      wbr vx cab cin wcel cA cB vf cv wf1o vz cv cB wss wa vy cv vf cv ccnv vz
      cv cima wceq vz cv vf cv vy cv cima wceq cA cB vf cv wf1o vz cv cB wss wa
      vy cv vf cv ccnv vz cv cima wceq wa vf cv vy cv cima vz cv vy cv vf cv
      ccnv vz cv cima wceq cA cB vf cv wf1o vz cv cB wss wa vf cv vy cv cima vf
      cv vf cv ccnv vz cv cima cima vz cv vy cv vf cv ccnv vz cv cima vf cv
      imaeq2 cA cB vf cv wf1o vz cv cB wss wa vf cv ccnv ccnv vf cv ccnv vz cv
      cima cima vf cv vf cv ccnv vz cv cima cima vz cv cA cB vf cv wf1o vf cv
      ccnv ccnv vf cv ccnv vz cv cima cima vf cv vf cv ccnv vz cv cima cima
      wceq vz cv cB wss cA cB vf cv wf1o vf cv ccnv ccnv vf cv vf cv ccnv vz cv
      cima cA cB vf cv wf1o vf cv wrel vf cv ccnv ccnv vf cv wceq cA cB vf cv
      f1orel vf cv dfrel2 sylib imaeq1d adantr cB cA vf cv ccnv wf1 vz cv cB
      wss vf cv ccnv ccnv vf cv ccnv vz cv cima cima vz cv wceq cA cB vf cv
      wf1o cB cA vz cv vf cv ccnv f1imacnv cA cB vf cv wf1o cB cA vf cv ccnv
      wf1o cB cA vf cv ccnv wf1 cA cB vf cv f1ocnv cB cA vf cv ccnv f1of1 syl
      sylan eqtr3d sylan9eqr eqcomd ex vz cv cB cpw vx cv cC cen wbr vx cab cin
      wcel vz cv cB cpw wcel vz cv vx cv cC cen wbr vx cab wcel wa vz cv cB wss
      vz cv cB cpw vx cv cC cen wbr vx cab elin vz cv cB cpw wcel vz cv vx cv
      cC cen wbr vx cab wcel wa vz cv cB cpw wcel vz cv cB wss vz cv cB cpw
      wcel vz cv vx cv cC cen wbr vx cab wcel pm3.26 vz cv cB vz visset elpw
      sylib sylbi sylan2 adantrl cA cB vf cv wf1o vy cv cA cpw vx cv cC cen wbr
      vx cab cin wcel vz cv vf cv vy cv cima wceq vy cv vf cv ccnv vz cv cima
      wceq wi vz cv cB cpw vx cv cC cen wbr vx cab cin wcel cA cB vf cv wf1o vy
      cv cA wss vz cv vf cv vy cv cima wceq vy cv vf cv ccnv vz cv cima wceq wi
      vy cv cA cpw vx cv cC cen wbr vx cab cin wcel cA cB vf cv wf1o vy cv cA
      wss wa vz cv vf cv vy cv cima wceq vy cv vf cv ccnv vz cv cima wceq cA cB
      vf cv wf1o vy cv cA wss wa vz cv vf cv vy cv cima wceq wa vf cv ccnv vz
      cv cima vy cv vz cv vf cv vy cv cima wceq cA cB vf cv wf1o vy cv cA wss
      wa vf cv ccnv vz cv cima vf cv ccnv vf cv vy cv cima cima vy cv vz cv vf
      cv vy cv cima vf cv ccnv imaeq2 cA cB vf cv wf1 vy cv cA wss vf cv ccnv
      vf cv vy cv cima cima vy cv wceq cA cB vf cv wf1o cA cB vy cv vf cv
      f1imacnv cA cB vf cv f1of1 sylan sylan9eqr eqcomd ex vy cv cA cpw vx cv
      cC cen wbr vx cab cin wcel vy cv cA cpw wcel vy cv vx cv cC cen wbr vx
      cab wcel wa vy cv cA wss vy cv cA cpw vx cv cC cen wbr vx cab elin vy cv
      cA cpw wcel vy cv vx cv cC cen wbr vx cab wcel wa vy cv cA cpw wcel vy cv
      cA wss vy cv cA cpw wcel vy cv vx cv cC cen wbr vx cab wcel pm3.26 vy cv
      cA vy visset elpw sylib sylbi sylan2 adantrr impbid ex en3d 19.23aiv
      sylbi cA cpw vx cv cC cen wbr vx cab cin vx cv cA wss vx cab vx cv cC cen
      wbr vx cab cin vx cv cA wss vx cv cC cen wbr wa vx cab cA cpw vx cv cA
      wss vx cab vx cv cC cen wbr vx cab vx cA df-pw ineq1i vx cv cA wss vx cv
      cC cen wbr vx inab eqtri cB cpw vx cv cC cen wbr vx cab cin vx cv cB wss
      vx cab vx cv cC cen wbr vx cab cin vx cv cB wss vx cv cC cen wbr wa vx
      cab cB cpw vx cv cB wss vx cab vx cv cC cen wbr vx cab vx cB df-pw ineq1i
      vx cv cB wss vx cv cC cen wbr vx inab eqtri 3brtr3g $.
      $( [21-Mar-2007] $) $( [30-Sep-2004] $)
  $}

  ${
    $d x y A $.
    limenpsi.1 $e |- Lim A $.
    $( A limit ordinal is equinumerous to a proper subset of itself. $)
    limenpsi $p |- ( A e. B -> A ~~ ( A \ { (/) } ) ) $=
      cA cA c0 csn cdif cdom wbr cA c0 csn cdif cA cdom wbr cA cA c0 csn cdif
      cen wbr cA cB wcel cA cA c0 csn cdif sbth vx vy cA cA c0 csn cdif vx cv
      csuc vy cv csuc cB vx cv cA wcel vx cv csuc cA wcel vx cv csuc c0 wne wa
      vx cv csuc cA c0 csn cdif wcel vx cv cA wcel vx cv csuc cA wcel vx cv
      csuc c0 wne vx cv cA wcel vx cv csuc cA wcel cA wlim vx cv cA wcel vx cv
      csuc cA wcel wb limenpsi.1 cA vx cv limsuc ax-mp biimpi vx cv nsuceq0
      jctir vx cv csuc cA c0 eldifsn sylibr vx cv con0 wcel vy cv con0 wcel vx
      cv csuc vy cv csuc wceq vx cv vy cv wceq wb vx cv cA wcel vy cv cA wcel
      vx cv vy cv suc11 cA word vx cv cA wcel vx cv con0 wcel cA wlim cA word
      limenpsi.1 cA limord ax-mp cA vx cv ordelon mpan cA word vy cv cA wcel vy
      cv con0 wcel cA wlim cA word limenpsi.1 cA limord ax-mp cA vy cv ordelon
      mpan syl2an dom2 cA cB wcel cA c0 csn cdif cA wss cA c0 csn cdif cA cdom
      wbr cA c0 csn difss cA c0 csn cdif cA cB ssdom2g mpi sylanc $.
      $( [31-Oct-2003] $) $( [30-Oct-2003] $)
  $}

  ${
    limensuci.1 $e |- Lim A $.
    $( A limit ordinal is equinumerous to its successor. $)
    limensuci $p |- ( A e. B -> A ~~ suc A ) $=
      cA cB wcel cA c0 csn cdif c0 csn cun cA cA csn cun cA cA csuc cen cA c0
      csn cdif cA cen wbr c0 csn cA csn cen wbr cA c0 csn cdif c0 csn cun cA cA
      csn cun cen wbr cA cB wcel cA c0 csn cdif cA cen wbr c0 csn cA csn cen
      wbr wa cA c0 csn cdif c0 csn cin c0 wceq cA cA csn cin c0 wceq cA c0 csn
      cdif c0 csn cun cA cA csn cun cen wbr cA c0 csn cdif c0 csn cin c0 csn cA
      c0 csn cdif cin c0 cA c0 csn cdif c0 csn incom c0 csn cA difdisj eqtri cA
      cA csn cin c0 wceq cA cA wcel wn cA word cA cA wcel wn cA wlim cA word
      limensuci.1 cA limord ax-mp cA ordirr ax-mp cA cA disjsn mpbir cA c0 csn
      cdif cA c0 csn cA csn unen mpanr12 cA c0 csn cdif cvv wcel cA cA c0 csn
      cdif cen wbr cA c0 csn cdif cA cen wbr cA cB wcel cA cA c0 csn cdif cvv
      ensymg cA c0 csn cB difexg cA cB limensuci.1 limenpsi sylc c0 cvv wcel cA
      cB wcel c0 csn cA csn cen wbr 0ex c0 cA cvv cB en2sn mpan sylanc c0 csn
      cA c0 csn cdif cun cA cA c0 csn cdif c0 csn cun c0 csn cA wss c0 csn cA
      c0 csn cdif cun cA wceq c0 cA wcel c0 csn cA wss cA wlim c0 cA wcel
      limensuci.1 cA 0ellim ax-mp c0 cA 0ex snss mpbi c0 csn cA undif mpbi c0
      csn cA c0 csn cdif uncom eqtr3i cA df-suc 3brtr4g $.
      $( [12-Nov-2003] $) $( [30-Oct-2003] $)
  $}

  $( A limit ordinal is equinumerous to its successor. $)
  limensuc $p |- ( ( A e. B /\ Lim A ) -> A ~~ suc A ) $=
    cA wlim cA cB wcel cA cA csuc cen wbr cA wlim cA cB wcel cA cA csuc cen wbr
    wi cA wlim cA con0 cif cB wcel cA wlim cA con0 cif cA wlim cA con0 cif csuc
    cen wbr wi cA con0 cA cA wlim cA con0 cif wceq cA cB wcel cA wlim cA con0
    cif cB wcel cA cA csuc cen wbr cA wlim cA con0 cif cA wlim cA con0 cif csuc
    cen wbr cA cA wlim cA con0 cif cB eleq1 cA cA wlim cA con0 cif wceq cA cA
    wlim cA con0 cif cA csuc cA wlim cA con0 cif csuc cen cA cA wlim cA con0
    cif wceq id cA cA wlim cA con0 cif suceq breq12d imbi12d cA wlim cA con0
    cif cB cA wlim cA wlim cA con0 cif wlim con0 wlim cA con0 cA cA wlim cA
    con0 cif limeq con0 cA wlim cA con0 cif limeq limon elimhyp limensuci dedth
    impcom $.
    $( [12-Nov-2003] $) $( [30-Oct-2003] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Pigeonhole Principle
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for Pigeonhole Principle.  If we join a natural number to itself
     minus an element, we end up with its successor minus the same element. $)
  phplem1 $p |- ( ( A e. om /\ B e. A ) ->
             ( { A } u. ( A \ { B } ) ) = ( suc A \ { B } ) ) $=
    cA com wcel cB cA wcel wa cA csn cB csn cin c0 wceq cA csn cA cB csn cdif
    cun cA csuc cB csn cdif wceq cA word cB cA wcel cA csn cB csn cin c0 wceq
    cA com wcel cA word cB cA wcel wa cA cB wne cA csn cB csn cin c0 wceq cA cB
    nordeq cA cB disjsn2 syl cA nnord sylan cA csn cB csn cin c0 wceq cA csn cA
    cB csn cdif cun cA csn cA cun cB csn cdif cA csuc cB csn cdif cA csn cA cB
    csn undif4 cA csuc cA csn cA cun cB csn cA csuc cA cA csn cun cA csn cA cun
    cA df-suc cA cA csn uncom eqtri difeq1i syl6eqr syl $.
    $( [25-May-1998] $)

  ${
    $d f A $.  $d f B $.
    phplem2.1 $e |- A e. _V $.
    phplem2.2 $e |- B e. _V $.
    $( Lemma for Pigeonhole Principle.  A natural number is equinumerous to its
       successor minus one of its elements. $)
    phplem2 $p |- ( ( A e. om /\ B e. A ) -> A ~~ ( suc A \ { B } ) ) $=
      cA com wcel cB cA wcel wa cB csn cA cB csn cdif cun cA csn cA cB csn cdif
      cun cA cA csuc cB csn cdif cen cA com wcel cB csn cA cB csn cdif cun cA
      csn cA cB csn cdif cun cen wbr cB cA wcel cB csn cA csn cen wbr cA cB csn
      cdif cA cB csn cdif cen wbr wa cB csn cA cB csn cdif cin c0 wceq cA csn
      cA cB csn cdif cin c0 wceq wa cB csn cA cB csn cdif cun cA csn cA cB csn
      cdif cun cen wbr cA com wcel cB csn cA csn cA cB csn cdif cA cB csn cdif
      unen cB csn cA csn cen wbr cA cB csn cdif cA cB csn cdif cen wbr cB csn
      cA csn cB cA cop csn wf1o cB csn cA csn cen wbr cB cA phplem2.2 phplem2.1
      f1osn cB csn cA csn cB cA cop csn cB snex f1oen ax-mp cA cB csn cdif cA
      cB csn cdif cA phplem2.1 cA cB csn difss ssexi enref pm3.2i cA com wcel
      cA csn cA cB csn cdif cin c0 wceq cB csn cA cB csn cdif cin c0 wceq cA
      com wcel cA cB csn cdif cA csn cin c0 cA csn cA cB csn cdif cin cA com
      wcel cA cB csn cdif cA csn cin c0 wss cA cB csn cdif cA csn cin c0 wceq
      cA com wcel cA cB csn cdif cA csn cin cA cA csn cin wss cA cB csn cdif cA
      csn cin c0 wss cA cB csn cdif cA wss cA cB csn cdif cA csn cin cA cA csn
      cin wss cA cB csn difss cA cB csn cdif cA cA csn ssrin ax-mp cA com wcel
      cA cA csn cin c0 cA cB csn cdif cA csn cin cA com wcel cA word cA cA csn
      cin c0 wceq cA nnord cA orddisj syl sseq2d mpbii cA cB csn cdif cA csn
      cin ss0 syl cA csn cA cB csn cdif incom syl5eq cB csn cA difdisj jctil
      sylancr adantr cB cA wcel cB csn cA cB csn cdif cun cA wceq cA com wcel
      cB cA wcel cA cB csn cdif cB csn cun cA cB csn cA cB csn cdif cun cA cB
      difsnid cB csn cA cB csn cdif uncom syl5eq adantl cA cB phplem1 3brtr3d
      $.
      $( [11-Jun-1998] $)

    $( Lemma for Pigeonhole Principle.  A natural number is equinumerous
       to its successor minus any element of the successor. $)
    phplem3 $p |- ( ( A e. om /\ B e. suc A ) -> A ~~ ( suc A \ { B } ) ) $=
      cA com wcel cB cA wcel cB cA wceq wo cA cA csuc cB csn cdif cen wbr cB cA
      csuc wcel cA com wcel cB cA wcel cA cA csuc cB csn cdif cen wbr cB cA
      wceq cA cB phplem2.1 phplem2.2 phplem2 cA com wcel cB cA wceq wa cA cA
      csuc cB csn cdif cA cen cA com wcel cB cA wceq cA cA csuc cA csn cdif cA
      csuc cB csn cdif cA com wcel cA word cA cA csuc cA csn cdif wceq cA nnord
      cA orddif syl cA csuc cA csn cdif cA csuc cB csn cdif wceq cA cB cA cB
      wceq cA csn cB csn cA csuc cA cB sneq difeq2d eqcoms sylan9eq cA
      phplem2.1 enref syl5breq jaodan cB cA elsuci sylan2 $.
      $( [26-May-1998] $)

    $( Lemma for Pigeonhole Principle.  Equinumerosity of successors implies
       equinumerosity of the original natural numbers. $)
    phplem4 $p |- ( ( A e. om /\ B e. om ) -> ( suc A ~~ suc B -> A ~~ B ) ) $=
      cA com wcel cB com wcel wa cA csuc cB csuc vf cv wf1o vf wex cA cB cen
      wbr cA csuc cB csuc cen wbr cA com wcel cB com wcel wa cA csuc cB csuc vf
      cv wf1o cA cB cen wbr vf cA com wcel cB com wcel wa cA csuc cB csuc vf cv
      wf1o cA cB cen wbr cA com wcel cB com wcel cA csuc cB csuc vf cv wf1o cA
      cB cen wbr cA cB csuc cA vf cv cfv csn cdif cen wbr cB csuc cA vf cv cfv
      csn cdif cB cen wbr cA cB cen wbr cA com wcel cA csuc cB csuc vf cv wf1o
      wa cB com wcel cA csuc cB csuc vf cv wf1o wa cA cB csuc cA vf cv cfv csn
      cdif cB entr cA com wcel cA csuc cB csuc vf cv wf1o wa cA vf cv cA cima
      cB csuc cA vf cv cfv csn cdif cen cA csuc cB csuc vf cv wf1o cA vf cv cA
      cima cen wbr cA com wcel cA csuc cB csuc vf cv wf1o cA csuc cB csuc vf cv
      wf1 cA cA csuc wss wa cA vf cv cA cima vf cv cA cres wf1o cA vf cv cA
      cima cen wbr cA csuc cB csuc vf cv wf1o cA csuc cB csuc vf cv wf1 cA cA
      csuc wss cA csuc cB csuc vf cv f1of1 cA sssucid jctir cA csuc cB csuc cA
      vf cv f1ores cA vf cv cA cima vf cv cA cres phplem2.1 f1oen 3syl adantl
      cA com wcel cA csuc cB csuc vf cv wf1o vf cv cA cima vf cv cA csuc cA csn
      cdif cima cB csuc cA vf cv cfv csn cdif cA com wcel cA word cA cA csuc cA
      csn cdif wceq vf cv cA cima vf cv cA csuc cA csn cdif cima wceq cA nnord
      cA orddif cA cA csuc cA csn cdif vf cv imaeq2 3syl cA csuc cB csuc vf cv
      wf1o vf cv cA csuc cima cA vf cv cfv csn cdif vf cv cA csuc cima vf cv cA
      csn cima cdif cB csuc cA vf cv cfv csn cdif vf cv cA csuc cA csn cdif
      cima cA csuc cB csuc vf cv wf1o vf cv cA csuc wfn cA vf cv cfv csn vf cv
      cA csn cima wceq vf cv cA csuc cima cA vf cv cfv csn cdif vf cv cA csuc
      cima vf cv cA csn cima cdif wceq cA csuc cB csuc vf cv f1ofn vf cv cA
      csuc wfn cA cA csuc wcel cA vf cv cfv csn vf cv cA csn cima wceq cA
      phplem2.1 sucid cA csuc cA vf cv fnsnfv mpan2 cA vf cv cfv csn vf cv cA
      csn cima vf cv cA csuc cima difeq2 3syl cA csuc cB csuc vf cv wf1o cB
      csuc vf cv cA csuc cima cA vf cv cfv csn cA csuc cB csuc vf cv wf1o vf cv
      crn vf cv vf cv cdm cima cB csuc vf cv cA csuc cima vf cv crn vf cv vf cv
      cdm cima wceq cA csuc cB csuc vf cv wf1o vf cv vf cv cdm cima vf cv crn
      vf cv imadmrn eqcomi a1i cA csuc cB csuc vf cv wf1o cA csuc cB csuc vf cv
      wfo vf cv crn cB csuc wceq cA csuc cB csuc vf cv f1ofo cA csuc cB csuc vf
      cv forn syl cA csuc cB csuc vf cv wf1o vf cv cA csuc wfn vf cv cdm cA
      csuc wceq vf cv vf cv cdm cima vf cv cA csuc cima wceq cA csuc cB csuc vf
      cv f1ofn cA csuc vf cv fndm vf cv cdm cA csuc vf cv imaeq2 3syl 3eqtr3d
      difeq1d cA csuc cB csuc vf cv wf1o vf cv ccnv wfun vf cv cA csuc cA csn
      cdif cima vf cv cA csuc cima vf cv cA csn cima cdif wceq cA csuc cB csuc
      vf cv wf1o cA csuc cB csuc vf cv wfo vf cv ccnv wfun cA csuc cB csuc vf
      cv dff1o3 pm3.27bi cA csuc cA csn vf cv imadif syl 3eqtr4rd sylan9eq
      breqtrd cB com wcel cA csuc cB csuc vf cv wf1o wa cB cB csuc cA vf cv cfv
      csn cdif cen wbr cB csuc cA vf cv cfv csn cdif cB cen wbr cB com wcel cA
      vf cv cfv cB csuc wcel cB cB csuc cA vf cv cfv csn cdif cen wbr cA csuc
      cB csuc vf cv wf1o cB cA vf cv cfv phplem2.2 cA vf cv fvex phplem3 cA
      csuc cB csuc vf cv wf1o cA vf cv cfv vf cv crn wcel cA vf cv cfv cB csuc
      wcel vf cv cA csuc wfn cA cA csuc wcel cA vf cv cfv vf cv crn wcel cA
      csuc cB csuc vf cv wf1o cA csuc cA vf cv fnfvelrn cA csuc cB csuc vf cv
      f1ofn cA phplem2.1 sucid sylancl cA csuc cB csuc vf cv wf1o cA csuc cB
      csuc vf cv wfo cA vf cv cfv vf cv crn wcel cA vf cv cfv cB csuc wcel wb
      cA csuc cB csuc vf cv f1ofo cA csuc cB csuc vf cv wfo vf cv crn cB csuc
      cA vf cv cfv cA csuc cB csuc vf cv forn eleq2d syl mpbid sylan2 cB cB
      csuc cA vf cv cfv csn cdif cB csuc cA vf cv cfv csn cdif cB csuc cB
      phplem2.2 sucex cB csuc cA vf cv cfv csn difss ssexi ensym syl syl2an
      anandirs ex 19.23adv cA csuc cB csuc vf cB phplem2.2 sucex bren syl5ib $.
      $( [28-May-1998] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Two equinumerous natural numbers are equal.  Proposition 10.20 of
       [TakeutiZaring] p. 90 and its converse.  Also compare Corollary 6E of
       [Enderton] p. 136. $)
    nneneq $p |- ( ( A e. om /\ B e. om ) -> ( A ~~ B <-> A = B ) ) $=
      cA com wcel cB com wcel wa cA cB cen wbr cA cB wceq cB com wcel cA com
      wcel cA cB cen wbr cA cB wceq wi cB com wcel cA vz cv cen wbr cA vz cv
      wceq wi vz com wral cA cB cen wbr cA cB wceq wi cA com wcel cA vz cv cen
      wbr cA vz cv wceq wi cA cB cen wbr cA cB wceq wi vz cB com vz cv cB wceq
      cA vz cv cen wbr cA cB cen wbr cA vz cv wceq cA cB wceq vz cv cB cA cen
      breq2 vz cv cB cA eqeq2 imbi12d rcla4v vx cv vz cv cen wbr vx cv vz cv
      wceq wi vz com wral c0 vz cv cen wbr c0 vz cv wceq wi vz com wral vy cv
      vz cv cen wbr vy cv vz cv wceq wi vz com wral vy cv csuc vz cv cen wbr vy
      cv csuc vz cv wceq wi vz com wral cA vz cv cen wbr cA vz cv wceq wi vz
      com wral vx vy cA vx cv c0 wceq vx cv vz cv cen wbr vx cv vz cv wceq wi
      c0 vz cv cen wbr c0 vz cv wceq wi vz com vx cv c0 wceq vx cv vz cv cen
      wbr c0 vz cv cen wbr vx cv vz cv wceq c0 vz cv wceq vx cv c0 vz cv cen
      breq1 vx cv c0 vz cv eqeq1 imbi12d ralbidv vx cv vy cv wceq vx cv vz cv
      cen wbr vx cv vz cv wceq wi vy cv vz cv cen wbr vy cv vz cv wceq wi vz
      com vx cv vy cv wceq vx cv vz cv cen wbr vy cv vz cv cen wbr vx cv vz cv
      wceq vy cv vz cv wceq vx cv vy cv vz cv cen breq1 vx cv vy cv vz cv eqeq1
      imbi12d ralbidv vx cv vy cv csuc wceq vx cv vz cv cen wbr vx cv vz cv
      wceq wi vy cv csuc vz cv cen wbr vy cv csuc vz cv wceq wi vz com vx cv vy
      cv csuc wceq vx cv vz cv cen wbr vy cv csuc vz cv cen wbr vx cv vz cv
      wceq vy cv csuc vz cv wceq vx cv vy cv csuc vz cv cen breq1 vx cv vy cv
      csuc vz cv eqeq1 imbi12d ralbidv vx cv cA wceq vx cv vz cv cen wbr vx cv
      vz cv wceq wi cA vz cv cen wbr cA vz cv wceq wi vz com vx cv cA wceq vx
      cv vz cv cen wbr cA vz cv cen wbr vx cv vz cv wceq cA vz cv wceq vx cv cA
      vz cv cen breq1 vx cv cA vz cv eqeq1 imbi12d ralbidv c0 vz cv cen wbr c0
      vz cv wceq wi vz com c0 vz cv cen wbr c0 vz cv wceq wi vz cv com wcel c0
      vz cv cen wbr vz cv c0 cen wbr c0 vz cv wceq c0 vz cv vz visset ensym vz
      cv c0 cen wbr vz cv c0 wceq c0 vz cv wceq vz cv en0 vz cv c0 eqcom bitri
      sylib a1i rgen vy cv com wcel vy cv vz cv cen wbr vy cv vz cv wceq wi vz
      com wral vy cv csuc vw cv cen wbr vy cv csuc vw cv wceq wi vw com wral vy
      cv csuc vz cv cen wbr vy cv csuc vz cv wceq wi vz com wral vy cv com wcel
      vy cv vz cv cen wbr vy cv vz cv wceq wi vz com wral vy cv csuc vw cv cen
      wbr vy cv csuc vw cv wceq wi vw com vy cv com wcel vy cv vz cv cen wbr vy
      cv vz cv wceq wi vz com wral vw cv c0 wceq vw cv vz cv csuc wceq vz com
      wrex wo vy cv csuc vw cv cen wbr vy cv csuc vw cv wceq wi vw cv com wcel
      vy cv com wcel vy cv vz cv cen wbr vy cv vz cv wceq wi vz com wral vw cv
      c0 wceq vw cv vz cv csuc wceq vz com wrex wo vy cv csuc vw cv cen wbr vy
      cv csuc vw cv wceq wi wi vy cv com wcel vy cv vz cv cen wbr vy cv vz cv
      wceq wi vz com wral wa vw cv c0 wceq vy cv csuc vw cv cen wbr vy cv csuc
      vw cv wceq wi vw cv vz cv csuc wceq vz com wrex vw cv c0 wceq vy cv csuc
      vw cv cen wbr vy cv csuc vw cv wceq wi wi vy cv com wcel vy cv vz cv cen
      wbr vy cv vz cv wceq wi vz com wral wa vw cv c0 wceq vy cv csuc vw cv cen
      wbr vy cv csuc vw cv wceq vw cv c0 wceq vy cv csuc vw cv cen wbr vy cv
      csuc vw cv wceq wb vy cv csuc c0 cen wbr vy cv csuc c0 wceq wb vy cv csuc
      en0 vw cv c0 wceq vy cv csuc vw cv cen wbr vy cv csuc c0 cen wbr vy cv
      csuc vw cv wceq vy cv csuc c0 wceq vw cv c0 vy cv csuc cen breq2 vw cv c0
      vy cv csuc eqeq2 bibi12d mpbiri biimpd a1i vy cv com wcel vy cv vz cv cen
      wbr vy cv vz cv wceq wi vz com wral wa vw cv vz cv csuc wceq vy cv csuc
      vw cv cen wbr vy cv csuc vw cv wceq wi vz com vy cv com wcel vy cv vz cv
      cen wbr vy cv vz cv wceq wi vz com wral vz vy cv com wcel vz ax-17 vy cv
      vz cv cen wbr vy cv vz cv wceq wi vz com hbra1 hban vy cv csuc vw cv cen
      wbr vy cv csuc vw cv wceq wi vz ax-17 vy cv com wcel vy cv vz cv cen wbr
      vy cv vz cv wceq wi vz com wral wa vz cv com wcel vy cv csuc vz cv csuc
      cen wbr vy cv csuc vz cv csuc wceq wi vw cv vz cv csuc wceq vy cv csuc vw
      cv cen wbr vy cv csuc vw cv wceq wi wi vy cv com wcel vy cv vz cv cen wbr
      vy cv vz cv wceq wi vz com wral wa vz cv com wcel vy cv csuc vz cv csuc
      cen wbr vy cv vz cv wceq vy cv csuc vz cv csuc wceq vy cv com wcel vy cv
      vz cv cen wbr vy cv vz cv wceq wi vz com wral vz cv com wcel vy cv csuc
      vz cv csuc cen wbr vy cv vz cv wceq wi wi vy cv com wcel vz cv com wcel
      vy cv vz cv cen wbr vy cv vz cv wceq wi wi vz cv com wcel vy cv csuc vz
      cv csuc cen wbr vy cv vz cv wceq wi wi vy cv vz cv cen wbr vy cv vz cv
      wceq wi vz com wral vy cv com wcel vz cv com wcel vy cv vz cv cen wbr vy
      cv vz cv wceq wi vy cv csuc vz cv csuc cen wbr vy cv vz cv wceq wi vy cv
      com wcel vz cv com wcel vy cv vz cv cen wbr vy cv vz cv wceq wi vy cv
      csuc vz cv csuc cen wbr vy cv vz cv wceq wi wi vy cv com wcel vz cv com
      wcel wa vy cv csuc vz cv csuc cen wbr vy cv vz cv cen wbr vy cv vz cv
      wceq vy cv vz cv vy visset vz visset phplem4 imim1d ex a2d vy cv vz cv
      cen wbr vy cv vz cv wceq wi vz com ra4 syl5 imp vy cv vz cv suceq syl8 vw
      cv vz cv csuc wceq vy cv csuc vw cv cen wbr vy cv csuc vw cv wceq wi vy
      cv csuc vz cv csuc cen wbr vy cv csuc vz cv csuc wceq wi vw cv vz cv csuc
      wceq vy cv csuc vw cv cen wbr vy cv csuc vz cv csuc cen wbr vy cv csuc vw
      cv wceq vy cv csuc vz cv csuc wceq vw cv vz cv csuc vy cv csuc cen breq2
      vw cv vz cv csuc vy cv csuc eqeq2 imbi12d biimprcd syl6 r19.23ad jaod ex
      vz vw cv nn0suc syl7 r19.21adv vy cv csuc vw cv cen wbr vy cv csuc vw cv
      wceq wi vy cv csuc vz cv cen wbr vy cv csuc vz cv wceq wi vw vz com vw cv
      vz cv wceq vy cv csuc vw cv cen wbr vy cv csuc vz cv cen wbr vy cv csuc
      vw cv wceq vy cv csuc vz cv wceq vw cv vz cv vy cv csuc cen breq2 vw cv
      vz cv vy cv csuc eqeq2 imbi12d cbvralv syl6ib finds syl5 impcom cA com
      wcel cA cB wceq cA cB cen wbr wi cB com wcel cA cB com eqeng adantr
      impbid $.
      $( [28-May-1998] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Pigeonhole Principle.  A natural number is not equinumerous to a
       proper subset of itself.  Theorem (Pigeonhole Principle) of [Enderton]
       p. 134.  The theorem is so-called because you can't put _n_ + 1
       pigeons into _n_ holes (if each hole holds only one pigeon).
       The proof consists of lemmas ~ phplem1 through ~ phplem4 , ~ nneneq ,
       and this final piece of the proof. $)
    php $p |- ( ( A e. om /\ B C. A ) -> -. A ~~ B ) $=
      cA com wcel cB cA wpss cA cB cen wbr wn cA com wcel cB cA wpss cA cB cen
      wbr wn cA com wcel cB cA wpss cB cA wpss cA cB cen wbr wn wi cA com wcel
      cB cA wpss wa cA vx cv csuc wceq vx com wrex cB cA wpss cA cB cen wbr wn
      wi cA com wcel cA c0 wceq wn cA vx cv csuc wceq vx com wrex cB cA wpss cA
      com wcel cA c0 wceq cA vx cv csuc wceq vx com wrex vx cA nn0suc orcanai
      cB cA wpss c0 cA wpss cA c0 wceq wn c0 cB wss cB cA wpss c0 cA wpss cB
      0ss c0 cB cA sspsstr mpan c0 cA wpss cA c0 wne cA c0 wceq wn cA 0pss cA
      c0 df-ne bitri sylib sylan2 cA vx cv csuc wceq cB cA wpss cA cB cen wbr
      wn wi vx com cA vx cv csuc wceq cB cA wpss cA cB cen wbr wn wi cB vx cv
      csuc wpss vx cv csuc cB cen wbr wn wi vx cv com wcel cA vx cv csuc wceq
      cB cA wpss cB vx cv csuc wpss cA cB cen wbr wn vx cv csuc cB cen wbr wn
      cA vx cv csuc cB psseq2 cA vx cv csuc wceq cA cB cen wbr vx cv csuc cB
      cen wbr cA vx cv csuc cB cen breq1 notbid imbi12d cB vx cv csuc wpss vx
      cv com wcel vx cv csuc cB cen wbr wn vx cv com wcel cB vx cv csuc wpss cB
      vx cv cdom wbr vx cv csuc cB cen wbr wn vy cv vx cv csuc wcel vy cv cB
      wcel wn wa vy wex cB vx cv csuc wpss vx cv com wcel cB vx cv cdom wbr wi
      vy cB vx cv csuc pssnel vy cv vx cv csuc wcel vy cv cB wcel wn wa cB vx
      cv csuc wpss vx cv com wcel cB vx cv cdom wbr wi wi vy vy cv vx cv csuc
      wcel vy cv cB wcel wn cB vx cv csuc wpss vx cv com wcel cB vx cv cdom wbr
      wi wi vy cv cB wcel wn cB vx cv csuc wpss vx cv com wcel vy cv vx cv csuc
      wcel cB vx cv cdom wbr vy cv cB wcel wn cB vx cv csuc wpss vx cv com wcel
      vy cv vx cv csuc wcel cB vx cv cdom wbr cB vx cv csuc vy cv csn cdif cdom
      wbr vx cv csuc vy cv csn cdif vx cv cen wbr cB vx cv cdom wbr vy cv cB
      wcel wn cB vx cv csuc wpss wa vx cv com wcel vy cv vx cv csuc wcel wa cB
      vx cv csuc vy cv csn cdif vx cv domentr vy cv cB wcel wn cB vx cv csuc
      wpss cB vx cv csuc vy cv csn cdif cdom wbr vy cv cB wcel wn cB vx cv csuc
      wss cB vx cv csuc vy cv csn cdif cdom wbr cB vx cv csuc wpss vy cv cB
      wcel wn cB vx cv csuc wss cB vx cv csuc vy cv csn cdif wss cB vx cv csuc
      vy cv csn cdif cdom wbr vy cv cB wcel wn cB vx cv csuc vy cv csn cdif wss
      cB vy cv csn cdif vx cv csuc vy cv csn cdif wss cB vx cv csuc wss vy cv
      cB wcel wn cB cB vy cv csn cdif wceq cB vx cv csuc vy cv csn cdif wss cB
      vy cv csn cdif vx cv csuc vy cv csn cdif wss wb vy cv cB wcel wn cB vy cv
      csn cin c0 wceq cB cB vy cv csn cdif wceq cB vy cv disjsn cB vy cv csn
      disj3 bitr3i cB cB vy cv csn cdif vx cv csuc vy cv csn cdif sseq1 sylbi
      cB vx cv csuc vy cv csn ssdif syl5bir vx cv csuc vy cv csn cdif cvv wcel
      cB vx cv csuc vy cv csn cdif wss cB vx cv csuc vy cv csn cdif cdom wbr wi
      vx cv csuc vy cv csn cdif vx cv csuc vx cv vx visset sucex vx cv csuc vy
      cv csn difss ssexi cB vx cv csuc vy cv csn cdif cvv ssdom2g ax-mp syl6 cB
      vx cv csuc pssss syl5 imp vx cv com wcel vy cv vx cv csuc wcel wa vx cv
      vx cv csuc vy cv csn cdif cen wbr vx cv csuc vy cv csn cdif vx cv cen wbr
      vx cv vy cv vx visset vy visset phplem3 vx cv vx cv csuc vy cv csn cdif
      vx cv csuc vy cv csn cdif vx cv csuc vx cv vx visset sucex vx cv csuc vy
      cv csn difss ssexi ensym syl syl2an exp43 com4r imp 19.23aiv mpcom cB vx
      cv cdom wbr vx cv csuc cB cen wbr vx cv csuc vx cv cen wbr vx cv com wcel
      vx cv csuc cB cen wbr cB vx cv cdom wbr vx cv csuc vx cv cen wbr vx cv
      csuc vx cv cdom wbr vx cv vx cv csuc cdom wbr vx cv csuc vx cv cen wbr vx
      cv csuc cB cen wbr cB vx cv cdom wbr wa vx cv csuc vx cv sbth vx cv csuc
      cB vx cv endomtr vx cv csuc cvv wcel vx cv vx cv csuc wss vx cv vx cv
      csuc cdom wbr vx cv vx visset sucex vx cv sssucid vx cv vx cv csuc cvv
      ssdom2g mp2 sylancl expcom vx cv com wcel vx cv csuc vx cv cen wbr wn vx
      cv csuc vx cv wne vx cv csuc word vx cv vx cv csuc wcel vx cv csuc vx cv
      wne vx cv com wcel vx cv csuc vx cv nordeq vx cv com wcel vx cv csuc com
      wcel vx cv csuc word vx cv peano2b vx cv csuc nnord sylbi vx cv vx visset
      sucid sylancl vx cv com wcel vx cv csuc vx cv cen wbr vx cv csuc vx cv vx
      cv com wcel vx cv csuc vx cv cen wbr vx cv csuc vx cv wceq wb vx cv csuc
      com wcel vx cv com wcel vx cv csuc vx cv cen wbr vx cv csuc vx cv wceq wb
      vx cv com wcel vx cv csuc vx cv nneneq vx cv peano2b sylanb anidms
      necon3bbid mpbird nsyli syli com12 syl5cbir r19.23aiv syl ex pm2.43d imp
      $.
      $( [29-May-1998] $)

    $( Corollary of Pigeonhole Principle. $)
    php2 $p |- ( ( A e. om /\ B C. A ) -> B ~< A ) $=
      cA com wcel cB cA wpss cB cA csdm wbr vx cv com wcel cB vx cv wpss wa cB
      vx cv csdm wbr wi cA com wcel cB cA wpss wa cB cA csdm wbr wi vx cA com
      vx cv cA wceq vx cv com wcel cB vx cv wpss wa cA com wcel cB cA wpss wa
      cB vx cv csdm wbr cB cA csdm wbr vx cv cA wceq vx cv com wcel cA com wcel
      cB vx cv wpss cB cA wpss vx cv cA com eleq1 vx cv cA cB psseq2 anbi12d vx
      cv cA cB csdm breq2 imbi12d cB vx cv csdm wbr cB vx cv cdom wbr cB vx cv
      cen wbr wn vx cv com wcel cB vx cv wpss wa cB vx cv brsdom cB vx cv wpss
      cB vx cv cdom wbr vx cv com wcel cB vx cv wpss cB vx cv wss cB vx cv cdom
      wbr cB vx cv pssss vx cv cvv wcel cB vx cv wss cB vx cv cdom wbr wi vx
      visset cB vx cv cvv ssdom2g ax-mp syl adantl vx cv com wcel cB vx cv wpss
      wa vx cv cB cen wbr cB vx cv cen wbr vx cv cB php cB vx cv vx visset
      ensym nsyl sylanbrc vtoclg anabsi5 $.
      $( [31-May-1998] $)
  $}

  ${
    $d f x y A $.  $d f x y B $.
    $( Corollary of Pigeonhole Principle.  If ` A ` is finite and ` B `
       is a proper subset of ` A ` , the ` B ` is strictly less numerous
       than ` A ` .  Stronger version of Corollary 6C of [Enderton] p. 135. $)
    php3 $p |- ( ( A e. Fin /\ B C. A ) -> B ~< A ) $=
      cA cfn wcel cB cA wpss cB cA csdm wbr cA cfn wcel cA vx cv cen wbr vx com
      wrex cB cA wpss cB cA csdm wbr wi vx cA isfi cA vx cv cen wbr cB cA wpss
      cB cA csdm wbr wi vx com vx cv com wcel cA vx cv cen wbr cB cA wpss cB cA
      csdm wbr cB cA csdm wbr cB cA cdom wbr cB cA cen wbr wn vx cv com wcel cA
      vx cv cen wbr wa cB cA wpss wa cB cA brsdom cA vx cv cen wbr cB cA wpss
      cB cA cdom wbr vx cv com wcel cA cvv wcel cB cA wss cB cA cdom wbr cA vx
      cv cen wbr cB cA wpss cA cvv wcel cB cA wss cB cA cdom wbr cB cA cvv
      ssdom2g imp cA vx cv cen relen brrelexi cB cA pssss syl2an adantll vx cv
      com wcel cA vx cv cen wbr wa cB cA wpss wa cB cA cen wbr vx cv cB cen wbr
      vx cv com wcel cA vx cv cen wbr cB cA wpss vx cv cB cen wbr wn vx cv com
      wcel cA vx cv vf cv wf1o vf wex cB cA wpss vx cv cB cen wbr wn wi cA vx
      cv cen wbr vx cv com wcel cA vx cv vf cv wf1o cB cA wpss vx cv cB cen wbr
      wn wi vf vx cv com wcel cA vx cv vf cv wf1o cB cA wpss vx cv cB cen wbr
      wn vx cv com wcel cA vx cv vf cv wf1o cB cA wpss wa wa vx cv cB cen wbr
      vx cv vf cv cB cima cen wbr vx cv com wcel vf cv cB cima vx cv wpss vx cv
      vf cv cB cima cen wbr wn cA vx cv vf cv wf1o cB cA wpss wa vx cv vf cv cB
      cima php cA vx cv vf cv wf1o cB cA wpss wa vf cv cB cima vf cv cA cima
      wpss vf cv cB cima vx cv wpss vf cv cB cima vf cv cA cima wpss vf cv cB
      cima vf cv cA cima wss vf cv cA cima vf cv cB cima wss wn cA vx cv vf cv
      wf1o cB cA wpss wa vf cv cB cima vf cv cA cima dfpss3 cB cA wpss vf cv cB
      cima vf cv cA cima wss cA vx cv vf cv wf1o cB cA wpss cB cA wss vf cv cB
      cima vf cv cA cima wss cB cA pssss cB cA vf cv imass2 syl adantl cA vx cv
      vf cv wf1o cB cA wpss wa vf cv cA cima vf cv cB cima cdif c0 wceq wn vf
      cv cA cima vf cv cB cima wss wn cA vx cv vf cv wf1o vy cv cA wcel vy cv
      cB wcel wn wa vy wex vf cv cA cima vf cv cB cima cdif c0 wceq wn cB cA
      wpss cA vx cv vf cv wf1o vy cv cA wcel vy cv cB wcel wn wa vy wex vf cv
      cA cima vf cv cB cima cdif c0 wceq wn cA vx cv vf cv wf1o vy cv cA wcel
      vy cv cB wcel wn wa vf cv cA cima vf cv cB cima cdif c0 wceq wn vy cA vx
      cv vf cv wf1o vy cv cA cB cdif wcel vf cv cA cima vf cv cB cima cdif c0
      wceq wn vy cv cA wcel vy cv cB wcel wn wa cA vx cv vf cv wf1o vy cv cA cB
      cdif wcel vy cv vf cv cfv vf cv cA cima vf cv cB cima cdif wcel vf cv cA
      cima vf cv cB cima cdif c0 wceq wn cA vx cv vf cv wf1o vy cv cA cB cdif
      wcel vy cv vf cv cfv vf cv cA cB cdif cima wcel vy cv vf cv cfv vf cv cA
      cima vf cv cB cima cdif wcel vf cv wfun cA cB cdif vf cv cdm wss vy cv cA
      cB cdif wcel vy cv vf cv cfv vf cv cA cB cdif cima wcel wi cA vx cv vf cv
      wf1o cA cB cdif vy cv vf cv funfvima2 cA vx cv vf cv f1ofun cA vx cv vf
      cv wf1o cA cB cdif vf cv cdm wss cA cB cdif cA wss cA cB difss cA vx cv
      vf cv wf1o vf cv cA wfn vf cv cdm cA wceq cA cB cdif vf cv cdm wss cA cB
      cdif cA wss wb cA vx cv vf cv f1ofn cA vf cv fndm vf cv cdm cA cA cB cdif
      sseq2 3syl mpbiri sylanc cA vx cv vf cv wf1o vf cv cA cB cdif cima vf cv
      cA cima vf cv cB cima cdif vy cv vf cv cfv cA vx cv vf cv wf1o vf cv ccnv
      wfun vf cv cA cB cdif cima vf cv cA cima vf cv cB cima cdif wceq cA vx cv
      vf cv wf1o cA vx cv vf cv wfo vf cv ccnv wfun cA vx cv vf cv dff1o3
      pm3.27bi cA cB vf cv imadif syl eleq2d sylibd vf cv cA cima vf cv cB cima
      cdif vy cv vf cv cfv n0i syl6 vy cv cA cB eldif syl5ibr 19.23adv imp vy
      cB cA pssnel sylan2 vf cv cA cima vf cv cB cima wss vf cv cA cima vf cv
      cB cima cdif c0 wceq vf cv cA cima vf cv cB cima ssdif0 notbii sylibr
      sylanbrc cA vx cv vf cv wf1o vf cv cB cima vf cv cA cima wpss vf cv cB
      cima vx cv wpss wb cB cA wpss cA vx cv vf cv wf1o vf cv cA cima vx cv vf
      cv cB cima cA vx cv vf cv wf1o vf cv vf cv cdm cima vf cv crn vf cv cA
      cima vx cv vf cv vf cv cdm cima vf cv crn wceq cA vx cv vf cv wf1o vf cv
      imadmrn a1i cA vx cv vf cv wf1o vf cv cA wfn vf cv cdm cA wceq vf cv vf
      cv cdm cima vf cv cA cima wceq cA vx cv vf cv f1ofn cA vf cv fndm vf cv
      cdm cA vf cv imaeq2 3syl cA vx cv vf cv wf1o cA vx cv vf cv wfo vf cv crn
      vx cv wceq cA vx cv vf cv f1ofo cA vx cv vf cv forn syl 3eqtr3d psseq2d
      adantr mpbid sylan2 cA vx cv vf cv wf1o cB cA wpss wa vx cv cB cen wbr vx
      cv vf cv cB cima cen wbr wi vx cv com wcel cA vx cv vf cv wf1o cB cA wpss
      wa cB vf cv cB cima vf cv cB cres wf1o cB vf cv cB cima cen wbr vx cv cB
      cen wbr vx cv vf cv cB cima cen wbr wi cA vx cv vf cv wf1 cB cA wss cB vf
      cv cB cima vf cv cB cres wf1o cA vx cv vf cv wf1o cB cA wpss cA vx cv cB
      vf cv f1ores cA vx cv vf cv f1of1 cB cA pssss syl2an cB vf cv cB cima vf
      cv cB cres wf1o cB vf cv cB cima vy cv wf1o vy wex cB vf cv cB cima cen
      wbr cB vf cv cB cima vy cv wf1o cB vf cv cB cima vf cv cB cres wf1o vy vf
      cv cB cres vf cv cvv wcel vf cv cB cres cvv wcel vf visset vf cv cB cvv
      resexg ax-mp cB vf cv cB cima vy cv vf cv cB cres f1oeq1 cla4ev cB vf cv
      cB cima vy vf cv cvv wcel vf cv cB cima cvv wcel vf visset vf cv cB cvv
      imaexg ax-mp bren sylibr vx cv cB cen wbr cB vf cv cB cima cen wbr vx cv
      vf cv cB cima cen wbr vx cv cB vf cv cB cima entr expcom 3syl adantl mtod
      exp32 19.23adv cA vx cv vf vx visset bren syl5ib imp31 cA vx cv cen wbr
      cB cA cen wbr vx cv cB cen wbr wi vx cv com wcel cB cA wpss cB cA cen wbr
      cA vx cv cen wbr cB vx cv cen wbr vx cv cB cen wbr cB cA cen wbr cA vx cv
      cen wbr cB vx cv cen wbr cB cA vx cv entr ex cB vx cv vx visset ensym
      syl6com ad2antlr mtod sylanbrc exp31 r19.23aiv sylbi imp $.
      $( [3-Sep-2008] $) $( [22-Aug-2008] $)
  $}

  $( Corollary of the Pigeonhole Principle ~ php :  a natural number is
     strictly dominated by its successor. $)
  php4 $p |- ( A e. om -> A ~< suc A ) $=
    cA com wcel cA cA csuc wpss cA cA csuc csdm wbr cA com wcel cA cA csuc wcel
    cA cA csuc wpss cA com sucidg cA com wcel cA word cA word cA csuc word wa
    cA cA csuc wcel cA cA csuc wpss wb cA nnord cA word cA csuc word cA word cA
    csuc word cA ordsuc biimpi ancli cA cA csuc ordelpss 3syl mpbid cA csuc com
    wcel cA cA csuc wpss cA cA csuc csdm wbr cA com wcel cA csuc cA php2 cA
    peano2b sylanb mpdan $.
    $( [3-Sep-2004] $) $( [26-Jul-2004] $)

  $( Corollary of the Pigeonhole Principle ~ php :  a natural number is not
     equinumerous to its successor.  Corollary 10.21(1) of [TakeutiZaring]
     p. 90. $)
  php5 $p |- ( A e. om -> -. A ~~ suc A ) $=
    cA com wcel cA cA csuc csdm wbr cA cA csuc cen wbr wn cA php4 cA cA csuc
    sdomnen syl $.
    $( [8-Sep-2004] $) $( [26-Jul-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Finite sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( An ordinal number equinumerous to a natural number is equal to it.
     Proposition 10.22 of [TakeutiZaring] p. 90 and its converse. $)
  onomeneq $p |- ( ( A e. On /\ B e. om ) -> ( A ~~ B <-> A = B ) ) $=
    cA con0 wcel cB com wcel wa cA cB cen wbr cA cB wceq cA con0 wcel cB com
    wcel wa cA cB cen wbr cA cB wceq cA con0 wcel cB com wcel wa cA cB cen wbr
    cA com wcel cB com wcel wa cA cB wceq cA con0 wcel cB com wcel wa cA cB cen
    wbr wa cA com wcel cB com wcel cA con0 wcel cB com wcel wa cA cB cen wbr wa
    cA com wcel com cA wss wn cA con0 wcel cB com wcel wa cA cB cen wbr wa com
    cA wss cA cB csuc cen wbr cB com wcel cA cB cen wbr cA cB csuc cen wbr wn
    cA con0 wcel cB com wcel cA cB cen wbr wa cA cB csuc cen wbr cB cB csuc cen
    wbr cB com wcel cB cB csuc cen wbr wn cA cB cen wbr cB php5 adantr cA cB cB
    csuc com enen1 mtbird adantll cA con0 wcel cB com wcel wa cA cB cen wbr wa
    com cA wss cA cB csuc cdom wbr cB csuc cA cdom wbr wa cA cB csuc cen wbr cA
    con0 wcel cB com wcel wa cA cB cen wbr wa com cA wss cA cB csuc cdom wbr cB
    csuc cA cdom wbr cB com wcel cA cB cen wbr com cA wss cA cB csuc cdom wbr
    wi cA con0 wcel cB com wcel cA cB cen wbr wa cA cB csuc cdom wbr com cA wss
    cA cB cen wbr cB com wcel cA cB csuc cdom wbr cA cB cen wbr cB cB csuc cdom
    wbr cA cB csuc cdom wbr cB com wcel cA cB cB csuc endomtr cB com wcel cB cB
    csuc wss cB cB csuc cdom wbr cB sssucid cB cB csuc com ssdomg mpi sylan2
    ancoms a1d adantll cA con0 wcel cB com wcel wa com cA wss cB csuc cA cdom
    wbr wi cA cB cen wbr cB com wcel cA con0 wcel com cA wss cB csuc cA cdom
    wbr wi cB com wcel cA con0 wcel wa com cA wss cB csuc cA wss cB csuc cA
    cdom wbr cB com wcel cA con0 wcel wa com cA wss cB cA wcel cB csuc cA wss
    cB com wcel com cA wss cB cA wcel wi cA con0 wcel com cA wss cB com wcel cB
    cA wcel com cA cB ssel com12 adantr cB com wcel cA word cB cA wcel cB csuc
    cA wss wb cA con0 wcel cB cA com ordelsuc cA eloni sylan2 sylibd cA con0
    wcel cB csuc cA wss cB csuc cA cdom wbr wi cB com wcel cB csuc cA con0
    ssdom2g adantl syld ancoms adantr jcad cA cB csuc sbth syl6 mtod cA con0
    wcel cA com wcel com cA wss wn wb cB com wcel cA cB cen wbr cA con0 wcel
    com cA wss cA com wcel com word cA word com cA wss cA com wcel wn wb cA
    con0 wcel com cA ordtri1 ordom cA eloni sylancr con2bid ad2antrr mpbird cA
    con0 wcel cB com wcel cA cB cen wbr simplr jca cA com wcel cB com wcel wa
    cA cB cen wbr cA cB wceq cA cB nneneq biimpa sylancom ex cA con0 wcel cA cB
    wceq cA cB cen wbr wi cB com wcel cA cB con0 eqeng adantr impbid $.
    $( [15-Nov-2004] $) $( [26-Jul-2004] $)

  ${
    $d x A $.
    $( An ordinal number is finite iff it is a natural number.  Proposition
       10.32 of [TakeutiZaring] p. 92. $)
    onfin $p |- ( A e. On -> ( A e. Fin <-> A e. om ) ) $=
      cA con0 wcel cA vx cv cen wbr vx com wrex cA com wcel cA cfn wcel cA con0
      wcel cA vx cv cen wbr vx com wrex cA com wcel cA con0 wcel cA vx cv cen
      wbr cA com wcel vx com cA con0 wcel vx cv com wcel wa cA vx cv cen wbr cA
      vx cv wceq cA com wcel cA vx cv onomeneq vx cv com wcel cA vx cv wceq cA
      com wcel wi cA con0 wcel vx cv com cA eleq1a adantl sylbid r19.23adva cA
      com wcel cA cA cen wbr cA vx cv cen wbr vx com wrex cA com enrefg cA vx
      cv cen wbr cA cA cen wbr vx cA com vx cv cA cA cen breq2 rcla4ev mpdan
      impbid1 vx cA isfi syl5bb $.
      $( [25-Sep-2008] $) $( [26-Jul-2004] $)
  $}

  $( Cardinal ordering agrees with natural number ordering.  Example 3 of
     [Enderton] p. 146. $)
  nndomo $p |- ( ( A e. om /\ B e. om ) -> ( A ~<_ B <-> A C_ B ) ) $=
    cA com wcel cB com wcel wa cA cB cdom wbr cA cB wss cA com wcel cB com wcel
    wa cA cB cdom wbr cB cA wpss wn cA cB wss cA com wcel cA cB cdom wbr cB cA
    wpss wn wi cB com wcel cA com wcel cB cA wpss cB cA csdm wbr cA cB cdom wbr
    cA com wcel cB cA wpss cB cA csdm wbr cA cB php2 ex cA cB domnsym nsyli
    adantr cA word cB word cA cB wss cB cA wpss wn wb cA com wcel cB com wcel
    cA word cB word wa cA cB wss cB cA wcel wn cB cA wpss wn cA cB ordtri1 cA
    word cB word wa cB cA wcel cB cA wpss cB word cA word cB cA wcel cB cA wpss
    wb cB cA ordelpss ancoms notbid bitrd cA nnord cB nnord syl2an sylibrd cA
    com wcel cA cB wss cA cB cdom wbr wi cB com wcel cA cB com ssdomg adantr
    impbid $.
    $( [17-Jun-1998] $)

  $( Cardinal ordering agrees with natural number ordering. $)
  nnsdomo $p |- ( ( A e. om /\ B e. om ) -> ( A ~< B <-> A C. B ) ) $=
    cA com wcel cB com wcel wa cA cB cdom wbr cA cB cen wbr wn wa cA cB wss cA
    cB wceq wn wa cA cB csdm wbr cA cB wpss cA com wcel cB com wcel wa cA cB
    cdom wbr cA cB wss cA cB cen wbr wn cA cB wceq wn cA cB nndomo cA com wcel
    cB com wcel wa cA cB cen wbr cA cB wceq cA cB nneneq notbid anbi12d cA cB
    brsdom cA cB dfpss2 3bitr4g $.
    $( [17-Jun-1998] $)

  $( Strict dominance of natural numbers is the same as dominance over the
     successor of the smaller. $)
  omsucdom $p |- ( ( A e. om /\ B e. om ) -> ( A ~< B <-> suc A ~<_ B ) ) $=
    cA com wcel cB com wcel wa cA cB wpss cA csuc cB wss cA cB csdm wbr cA csuc
    cB cdom wbr cA com wcel cB word cA cB wpss cA csuc cB wss wb cB com wcel cA
    com wcel cB word wa cA cB wcel cA cB wpss cA csuc cB wss cA word cB word cA
    cB wcel cA cB wpss wb cA com wcel cA cB ordelpss cA nnord sylan cA cB com
    ordelsuc bitr3d cB nnord sylan2 cA cB nnsdomo cA csuc com wcel cB com wcel
    cA csuc cB cdom wbr cA csuc cB wss wb cA com wcel cA csuc cB nndomo cA
    peano2b sylanb 3bitr4d $.
    $( [30-Sep-2004] $) $( [25-Jul-2004] $)

  $( Dominance of a set over a successor of a natural number implies strict
     dominance over the number.  For the converse, see ~ sucdom . $)
  sucdomi $p |- ( ( A e. om /\ B e. C ) ->
                   ( suc A ~<_ B -> A ~< B ) ) $=
    cA cA csuc csdm wbr cB cC wcel cA csuc cB cdom wbr cA cB csdm wbr wi cA com
    wcel cB cC wcel cA cA csuc csdm wbr cA csuc cB cdom wbr cA cB csdm wbr wi
    cB cC wcel cA cA csuc csdm wbr cA csuc cB cdom wbr cA cB csdm wbr cA cA
    csuc cB cC sdomdomtr exp3a impcom cA php4 sylan $.
    $( [3-Oct-2004] $) $( [26-Jul-2004] $)

  ${
    $d x A $.
    0sdom1dom.1 $e |- A e. _V $.
    $( Strict dominance over zero is the same as dominance over one. $)
    0sdom1dom $p |- ( (/) ~< A <-> 1o ~<_ A ) $=
      c0 cA csdm wbr c1o cA cdom wbr c0 cA csdm wbr vx cv cA wcel vx wex c1o cA
      cdom wbr c0 cA csdm wbr cA c0 wne vx cv cA wcel vx wex cA 0sdom1dom.1
      0sdom vx cA n0 bitri vx cv cA wcel c1o cA cdom wbr vx vx cv cA wcel vx cv
      csn cA wss vx cv csn cA cdom wbr c1o cA cdom wbr vx cv cA snssi cA cvv
      wcel vx cv csn cA wss vx cv csn cA cdom wbr wi 0sdom1dom.1 vx cv csn cA
      cvv ssdom2g ax-mp c1o vx cv csn cen wbr vx cv csn cA cdom wbr c1o cA cdom
      wbr vx cv csn c1o c1o con0 1on elisseti vx cv vx visset ensn1 ensymi c1o
      vx cv csn cA endomtr mpan 3syl 19.23aiv sylbi c1o cA cdom wbr c0 csuc cA
      cdom wbr c0 cA csdm wbr c1o c0 csuc cA cdom df-1o breq1i c0 com wcel cA
      cvv wcel c0 csuc cA cdom wbr c0 cA csdm wbr wi peano1 0sdom1dom.1 c0 cA
      cvv sucdomi mp2an sylbi impbii $.
      $( [7-Nov-2004] $) $( [28-Sep-2004] $)
  $}

  $( Ordinal 1 is strictly dominated by ordinal 2. $)
  1sdom2 $p |- 1o ~< 2o $=
    c0 csn c0 csn cpw c1o c2o csdm c0 csn p0ex canth2 df1o2 c2o c0 c0 csn cpr
    c0 csn cpw df2o2 pwpw0 eqtr4i 3brtr4i $.
    $( [4-Apr-2007] $) $( [4-Apr-2007] $)

  ${
    $d x A $.  $d x B $.
    $( Strict dominance of a finite set over a natural number is the same as
       dominance over its successor. $)
    finsucdom $p |- ( ( A e. om /\ B e. Fin ) ->
                     ( A ~< B <-> suc A ~<_ B ) ) $=
      cA com wcel cB vx cv cen wbr vx com wrex cA cB csdm wbr cA csuc cB cdom
      wbr wb cB cfn wcel cA com wcel cB vx cv cen wbr vx com wrex cA cB csdm
      wbr cA csuc cB cdom wbr wb cA com wcel cB vx cv cen wbr cA cB csdm wbr cA
      csuc cB cdom wbr wb vx com cA com wcel vx cv com wcel cB vx cv cen wbr cA
      cB csdm wbr cA csuc cB cdom wbr wb cA com wcel vx cv com wcel wa cB vx cv
      cen wbr wa cA vx cv csdm wbr cA csuc vx cv cdom wbr cA cB csdm wbr cA
      csuc cB cdom wbr cA com wcel vx cv com wcel wa cA vx cv csdm wbr cA csuc
      vx cv cdom wbr wb cB vx cv cen wbr cA vx cv omsucdom adantr vx cv com
      wcel cB vx cv cen wbr cA cB csdm wbr cA vx cv csdm wbr wb cA com wcel cB
      vx cv cA com sdomen2 adantll vx cv com wcel cB vx cv cen wbr cA csuc cB
      cdom wbr cA csuc vx cv cdom wbr wb cA com wcel cB vx cv cA csuc com
      domen2 adantll 3bitr4d exp31 r19.23adv imp vx cB isfi sylan2b $.
      $( [9-Sep-2008] $) $( [26-Jul-2004] $)
  $}

  $( A set equinumerous to a proper subset of itself is infinite.  Corollary
     6D(a) of [Enderton] p. 136. $)
  pssinf $p |- ( ( A C. B /\ A ~~ B ) -> -. B e. Fin ) $=
    cA cB wpss cA cB cen wbr cB cfn wcel wn cA cB wpss cB cfn wcel cA cB cen
    wbr cB cfn wcel cA cB wpss cA cB csdm wbr cA cB cen wbr wn cB cfn wcel cA
    cB wpss cA cB csdm wbr cB cA php3 ex cA cB sdomnen syl6com con2d imp $.
    $( [6-Sep-2008] $) $( [2-Jun-1998] $)

  $( The set of natural numbers is infinite.  Corollary 6D(b) of [Enderton]
     p. 136. $)
  ominf $p |- -. om e. Fin $=
    com cfn wcel com cfn wcel wn wi com cfn wcel wn com cfn wcel com vx cv cen
    wbr vx com wrex com cfn wcel wn vx com isfi com vx cv cen wbr com cfn wcel
    wn vx com vx cv com wpss vx cv com cen wbr com cfn wcel wn vx cv com wcel
    com vx cv cen wbr vx cv com pssinf vx cv com wcel vx cv com wss vx cv com
    wne wa vx cv com wpss vx cv com wcel vx cv com wss vx cv com wne wa vx cv
    word com word vx cv com wcel vx cv com wss vx cv com wne wa wb vx cv com
    wcel vx cv com ordelssne vx cv nnord ordom sylancl ibi vx cv com df-pss
    sylibr com vx cv vx visset ensym syl2an r19.23aiva sylbi com cfn wcel
    pm2.01 ax-mp $.
    $( [7-Sep-2008] $) $( [2-Jun-1998] $)

  ${
    $d x A $.
    $( Omega strictly dominates a natural number.  Example 3 of [Enderton]
       p. 146.  Here we use ` A ~<_ om /\ -. om ~~ A ` instead of ` A ~< om `
       because, due to a peculiarity ultimately caused our ordered pair
       definition, we would need the Axiom of infinity (which we have avoided
       up to now) in order to prove the latter. $)
    omsdomnn $p |- ( A e. om -> ( A ~<_ om /\ -. om ~~ A ) ) $=
      cA com wcel cA com cdom wbr com cA cen wbr wn cA com wcel cA com wss cA
      com cdom wbr com word cA com wcel cA com wss ordom com cA ordelss mpan cA
      com com ssdomg mpd com vx cv cen wbr wn com cA cen wbr wn vx cA com vx cv
      cA wceq com vx cv cen wbr com cA cen wbr vx cv cA com cen breq2 notbid
      com vx cv cen wbr wn vx com wral com vx cv cen wbr vx com wrex wn com cfn
      wcel com vx cv cen wbr vx com wrex ominf vx com isfi mtbi com vx cv cen
      wbr vx com ralnex mpbir vtoclri jca $.
      $( [15-Jun-1998] $)

    $( Omega strictly dominates a finite set.  See comment in ~ omsdomnn . $)
    isfinite1 $p |- ( A e. Fin -> ( A ~<_ om /\ -. om ~~ A ) ) $=
      cA cfn wcel cA vx cv cen wbr vx com wrex cA com cdom wbr com cA cen wbr
      wn wa vx cA isfi cA vx cv cen wbr cA com cdom wbr com cA cen wbr wn wa vx
      com vx cv com wcel cA vx cv cen wbr wa cA vx cv cen wbr vx cv com cdom
      wbr wa cA vx cv cen wbr com vx cv cen wbr wn wa wa cA com cdom wbr com cA
      cen wbr wn wa cA vx cv cen wbr vx cv com wcel cA vx cv cen wbr vx cv com
      cdom wbr wa cA vx cv cen wbr com vx cv cen wbr wn wa wa cA vx cv cen wbr
      vx cv com wcel wa cA vx cv cen wbr vx cv com cdom wbr com vx cv cen wbr
      wn wa wa cA vx cv cen wbr vx cv com cdom wbr wa cA vx cv cen wbr com vx
      cv cen wbr wn wa wa vx cv com wcel vx cv com cdom wbr com vx cv cen wbr
      wn wa cA vx cv cen wbr vx cv omsdomnn anim2i cA vx cv cen wbr vx cv com
      cdom wbr com vx cv cen wbr wn anandi sylib ancoms cA vx cv cen wbr vx cv
      com cdom wbr wa cA com cdom wbr cA vx cv cen wbr com vx cv cen wbr wn wa
      com cA cen wbr wn cA vx cv com endomtr cA vx cv cen wbr com vx cv cen wbr
      wn com cA cen wbr wn cA vx cv cen wbr com cA cen wbr com vx cv cen wbr
      com cA cen wbr cA vx cv cen wbr com vx cv cen wbr com cA vx cv entr
      expcom con3d imp anim12i syl r19.23aiva sylbi $.
      $( [14-Sep-2008] $) $( [3-Nov-2002] $)
  $}

  ${
    infsdomnn.1 $e |- A e. _V $.
    $( An infinite set strictly dominates a natural number. $)
    infsdomnn $p |- ( ( om ~<_ A /\ B e. om ) -> B ~< A ) $=
      com cA cdom wbr cB com wcel cB cA csdm wbr com cvv wcel com cA cdom wbr
      cB com wcel cB cA csdm wbr wi com cA cdom reldom brrelexi com cvv wcel cB
      com wcel cB com csdm wbr com cA cdom wbr cB cA csdm wbr com cvv wcel cB
      com wcel cB com cdom wbr cB com cen wbr wn wa cB com csdm wbr com cvv
      wcel cB com cdom wbr com cB cen wbr wn wa cB com cdom wbr cB com cen wbr
      wn wa cB com wcel com cvv wcel com cB cen wbr wn cB com cen wbr wn cB com
      cdom wbr com cvv wcel cB com cen wbr com cB cen wbr cB com cvv ensymg
      con3d anim2d cB omsdomnn syl5 cB com brsdom syl6ibr cB com csdm wbr com
      cA cdom wbr cB cA csdm wbr cA cvv wcel cB com csdm wbr com cA cdom wbr wa
      cB cA csdm wbr wi infsdomnn.1 cB com cA cvv sdomdomtr ax-mp expcom syl9
      mpcom imp $.
      $( [24-Nov-2004] $) $( [22-Nov-2004] $)

    $( An infinite set is not empty. $)
    infn0 $p |- ( om ~<_ A -> A =/= (/) ) $=
      com cA cdom wbr c0 cA csdm wbr cA c0 wne com cA cdom wbr c0 com wcel c0
      cA csdm wbr peano1 cA c0 infsdomnn.1 infsdomnn mpan2 cA infsdomnn.1 0sdom
      sylib $.
      $( [27-Nov-2006] $) $( [23-Oct-2004] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x C $.
    $( Equinmerous sets have the same finiteness. $)
    enfi $p |- ( ( B e. C /\ A ~~ B ) -> ( A e. Fin <-> B e. Fin ) ) $=
      cB cC wcel cA cB cen wbr wa cA vx cv cen wbr vx com wrex cB vx cv cen wbr
      vx com wrex cA cfn wcel cB cfn wcel cB cC wcel cA cB cen wbr wa cA vx cv
      cen wbr cB vx cv cen wbr vx com cA cB vx cv cC enen1 rexbidv vx cA isfi
      vx cB isfi 3bitr4g $.
      $( [6-Sep-2008] $) $( [22-Aug-2008] $)

    $( A proper subset of a natural number is equinumerous to some smaller
       number.  Lemma 6F of [Enderton] p. 137. $)
    pssnn $p |- ( ( A e. om /\ B C. A ) -> E. x e. A B ~~ x ) $=
      cA com wcel cB cA wpss wa cB cvv wcel cB vx cv cen wbr vx cA wrex cB cA
      wpss cA com wcel cB cvv wcel cB cA wss cA com wcel cB cvv wcel cB cA wpss
      cB cA com ssexg cB cA pssss sylan ancoms cA com wcel cB cA wpss cB cvv
      wcel cB vx cv cen wbr vx cA wrex wi cB cvv wcel cA com wcel cB cA wpss cB
      vx cv cen wbr vx cA wrex cB cvv wcel vw cv cA wpss vw cv vx cv cen wbr vx
      cA wrex wi vw wal cB cA wpss cB vx cv cen wbr vx cA wrex wi cA com wcel
      vw cv cA wpss vw cv vx cv cen wbr vx cA wrex wi cB cA wpss cB vx cv cen
      wbr vx cA wrex wi vw cB cvv vw cv cB wceq vw cv cA wpss cB cA wpss vw cv
      vx cv cen wbr vx cA wrex cB vx cv cen wbr vx cA wrex vw cv cB cA psseq1
      vw cv cB wceq vw cv vx cv cen wbr cB vx cv cen wbr vx cA vw cv cB vx cv
      cen breq1 rexbidv imbi12d cla4gv vw cv vz cv wpss vw cv vx cv cen wbr vx
      vz cv wrex wi vw wal vw cv c0 wpss vw cv vx cv cen wbr vx c0 wrex wi vw
      wal vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw wal vw cv vy
      cv csuc wpss vw cv vx cv cen wbr vx vy cv csuc wrex wi vw wal vw cv cA
      wpss vw cv vx cv cen wbr vx cA wrex wi vw wal vz vy cA vz cv c0 wceq vw
      cv vz cv wpss vw cv vx cv cen wbr vx vz cv wrex wi vw cv c0 wpss vw cv vx
      cv cen wbr vx c0 wrex wi vw vz cv c0 wceq vw cv vz cv wpss vw cv c0 wpss
      vw cv vx cv cen wbr vx vz cv wrex vw cv vx cv cen wbr vx c0 wrex vz cv c0
      vw cv psseq2 vw cv vx cv cen wbr vx vz cv c0 rexeq1 imbi12d albidv vz cv
      vy cv wceq vw cv vz cv wpss vw cv vx cv cen wbr vx vz cv wrex wi vw cv vy
      cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw vz cv vy cv wceq vw cv vz
      cv wpss vw cv vy cv wpss vw cv vx cv cen wbr vx vz cv wrex vw cv vx cv
      cen wbr vx vy cv wrex vz cv vy cv vw cv psseq2 vw cv vx cv cen wbr vx vz
      cv vy cv rexeq1 imbi12d albidv vz cv vy cv csuc wceq vw cv vz cv wpss vw
      cv vx cv cen wbr vx vz cv wrex wi vw cv vy cv csuc wpss vw cv vx cv cen
      wbr vx vy cv csuc wrex wi vw vz cv vy cv csuc wceq vw cv vz cv wpss vw cv
      vy cv csuc wpss vw cv vx cv cen wbr vx vz cv wrex vw cv vx cv cen wbr vx
      vy cv csuc wrex vz cv vy cv csuc vw cv psseq2 vw cv vx cv cen wbr vx vz
      cv vy cv csuc rexeq1 imbi12d albidv vz cv cA wceq vw cv vz cv wpss vw cv
      vx cv cen wbr vx vz cv wrex wi vw cv cA wpss vw cv vx cv cen wbr vx cA
      wrex wi vw vz cv cA wceq vw cv vz cv wpss vw cv cA wpss vw cv vx cv cen
      wbr vx vz cv wrex vw cv vx cv cen wbr vx cA wrex vz cv cA vw cv psseq2 vw
      cv vx cv cen wbr vx vz cv cA rexeq1 imbi12d albidv vw cv c0 wpss vw cv vx
      cv cen wbr vx c0 wrex wi vw vw cv c0 wpss vw cv vx cv cen wbr vx c0 wrex
      vw cv npss0 pm2.21i ax-gen vy cv com wcel vw cv vy cv wpss vw cv vx cv
      cen wbr vx vy cv wrex wi vw wal vw cv vy cv csuc wpss vw cv vx cv cen wbr
      vx vy cv csuc wrex wi vw vy cv com wcel vw ax-17 vw cv vy cv wpss vw cv
      vx cv cen wbr vx vy cv wrex wi vw hba1 vy cv com wcel vw cv vy cv wpss vw
      cv vx cv cen wbr vx vy cv wrex wi vw wal vw cv vy cv csuc wpss vw cv vx
      cv cen wbr vx vy cv csuc wrex wi vy cv vw cv wcel vw cv vy cv wceq vy cv
      com wcel vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw wal wa
      vw cv vy cv csuc wpss vw cv vx cv cen wbr vx vy cv csuc wrex wi wi vy cv
      com wcel vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw wal wa
      vw cv vy cv csuc wpss vy cv vw cv wcel wn vw cv vy cv wceq wn vw cv vx cv
      cen wbr vx vy cv csuc wrex vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv
      wrex wi vw wal vw cv vy cv csuc wpss vy cv vw cv wcel wn vw cv vy cv wceq
      wn vw cv vx cv cen wbr vx vy cv csuc wrex wi wi wi vy cv com wcel vw cv
      vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw cv vy cv csuc wpss vy
      cv vw cv wcel wn vw cv vy cv wceq wn vw cv vx cv cen wbr vx vy cv csuc
      wrex wi wi wi vw vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw
      cv vy cv csuc wpss vy cv vw cv wcel wn vw cv vy cv wceq wn vw cv vx cv
      cen wbr vx vy cv csuc wrex vw cv vy cv csuc wpss vy cv vw cv wcel wn wa
      vw cv vy cv wceq wn wa vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex
      vw cv vx cv cen wbr vx vy cv csuc wrex vw cv vy cv csuc wpss vy cv vw cv
      wcel wn wa vw cv vy cv wceq wn wa vw cv vy cv wss vw cv vy cv wceq wn wa
      vw cv vy cv wpss vw cv vy cv csuc wpss vy cv vw cv wcel wn wa vw cv vy cv
      wss vw cv vy cv wceq wn vw cv vy cv csuc wpss vy cv vw cv wcel wn wa vz
      vw cv vy cv vw cv vy cv csuc wpss vy cv vw cv wcel wn vz cv vw cv wcel vz
      cv vy cv wcel wi vw cv vy cv csuc wpss vz cv vw cv wcel vy cv vw cv wcel
      wn vz cv vy cv wcel vw cv vy cv csuc wpss vz cv vw cv wcel vy cv vw cv
      wcel wn vz cv vy cv wcel wi vw cv vy cv csuc wpss vz cv vw cv wcel wa vy
      cv vw cv wcel wn vz cv vy cv wceq wn vz cv vy cv wcel vz cv vw cv wcel vy
      cv vw cv wcel wn vz cv vy cv wceq wn wi vw cv vy cv csuc wpss vz cv vw cv
      wcel vz cv vy cv wceq vy cv vw cv wcel vz cv vy cv wceq vz cv vw cv wcel
      vy cv vw cv wcel vz vy vw elequ1 biimpcd con3d adantl vw cv vy cv csuc
      wpss vz cv vw cv wcel vz cv vy cv wceq wn vz cv vy cv wcel wi vw cv vy cv
      csuc wpss vz cv vw cv wcel vz cv vy cv csuc wcel vz cv vy cv wceq wn vz
      cv vy cv wcel wi vw cv vy cv csuc wpss vw cv vy cv csuc vz cv vw cv vy cv
      csuc pssss sseld vz cv vy cv csuc wcel vz cv vy cv wcel vz cv vy cv wceq
      vz cv vy cv csuc wcel vz cv vy cv wcel vz cv vy cv wceq vz cv vy cv
      elsuci ord con1d syl6 imp syld ex com23 imp ssrdv anim1i vw cv vy cv
      dfpss2 sylibr vw cv vx cv cen wbr vw cv vx cv cen wbr vx vy cv vy cv csuc
      vx cv vy cv wcel vx cv vy cv csuc wcel vw cv vx cv cen wbr vx cv vy cv
      elelsuc anim1i r19.22i2 imim12i exp4c a4s adantl com4t vy cv vw cv wcel
      vy cv com wcel vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw
      wal vw cv vy cv csuc wpss vw cv vx cv cen wbr vx vy cv csuc wrex wi vy cv
      vw cv wcel vy cv com wcel vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv
      wrex wi vw wal vw cv vy cv csuc wpss vw cv vx cv cen wbr vx vy cv csuc
      wrex wi vy cv vw cv wcel vy cv com wcel wa vw cv vy cv wpss vw cv vx cv
      cen wbr vx vy cv wrex wi vw wal wa vw cv vy cv csuc wpss vw cv vy cv csn
      cdif vx cv cen wbr vx vy cv wrex vw cv vx cv cen wbr vx vy cv csuc wrex
      vy cv vw cv wcel vy cv com wcel wa vw cv vy cv csuc wpss vw cv vy cv csn
      cdif vy cv wpss vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw
      wal vw cv vy cv csn cdif vx cv cen wbr vx vy cv wrex vy cv vw cv wcel vy
      cv com wcel wa vw cv vy cv csuc wpss vw cv vy cv csn cdif vy cv wss vw cv
      vy cv csn cdif vy cv wceq wn wa vw cv vy cv csn cdif vy cv wpss vy cv vw
      cv wcel vy cv com wcel wa vw cv vy cv csuc wpss vw cv vy cv csuc wpss wa
      vw cv vy cv csn cdif vy cv wss vw cv vy cv csn cdif vy cv wceq wn wa vw
      cv vy cv csuc wpss vy cv com wcel vw cv vy cv csuc wpss vw cv vy cv csn
      cdif vy cv wss vy cv vw cv wcel vw cv vy cv csuc wpss vw cv vy cv csn
      cdif vy cv wceq wn vy cv com wcel vw cv vy cv csuc wss vw cv vy cv csn
      cdif vy cv wss vw cv vy cv csuc wpss vy cv com wcel vw cv vy cv csn cdif
      vy cv wss vw cv vy cv csn cdif vy cv csuc vy cv csn cdif wss vw cv vy cv
      csuc wss vy cv com wcel vy cv vy cv csuc vy cv csn cdif vw cv vy cv csn
      cdif vy cv com wcel vy cv word vy cv vy cv csuc vy cv csn cdif wceq vy cv
      nnord vy cv orddif syl sseq2d vw cv vy cv csuc vy cv csn ssdif syl5bir vw
      cv vy cv csuc pssss syl5 vy cv vw cv wcel vz cv vy cv csuc wcel vz cv vw
      cv wcel wn wa vz wex vw cv vy cv csn cdif vy cv wceq wn vw cv vy cv csuc
      wpss vy cv vw cv wcel vz cv vy cv csuc wcel vz cv vw cv wcel wn wa vw cv
      vy cv csn cdif vy cv wceq wn vz vy cv vw cv wcel vz cv vy cv csuc wcel vz
      cv vw cv wcel wn vw cv vy cv csn cdif vy cv wceq wn vy cv vw cv wcel vz
      cv vy cv csuc wcel wa vw cv vy cv csn cdif vy cv wceq vz cv vw cv wcel vy
      cv vw cv wcel vz cv vy cv csuc wcel wa vw cv vy cv csn cdif vy cv wceq vz
      cv vw cv wcel vy cv vw cv wcel vz cv vy cv csuc wcel wa vw cv vy cv csn
      cdif vy cv wceq wa vz cv vy cv wcel vz cv vw cv wcel vw cv vy cv csn cdif
      vy cv wceq vz cv vy cv wcel vz cv vw cv wcel wi vy cv vw cv wcel vz cv vy
      cv csuc wcel wa vw cv vy cv csn cdif vy cv wceq vz cv vy cv wcel vz cv vw
      cv vy cv csn cdif wcel vz cv vw cv wcel vw cv vy cv csn cdif vy cv vz cv
      eleq2 vz cv vw cv vy cv csn eldifi syl6bir adantl vy cv vw cv wcel vz cv
      vy cv csuc wcel wa vz cv vy cv wcel wn vz cv vw cv wcel wi vw cv vy cv
      csn cdif vy cv wceq vz cv vy cv csuc wcel vz cv vy cv wcel wn vz cv vy cv
      wceq vy cv vw cv wcel vz cv vw cv wcel vz cv vy cv csuc wcel vz cv vy cv
      wcel vz cv vy cv wceq vz cv vy cv elsuci ord vy cv vw cv vz cv eleq1a
      sylan9r adantr pm2.61d ex con3d expimpd 19.23adv vz vw cv vy cv csuc
      pssnel syl5 im2anan9r vw cv vy cv csuc wpss anidm syl5ibr vw cv vy cv csn
      cdif vy cv dfpss2 syl6ibr vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv
      wrex wi vw wal vz cv vy cv wpss vz cv vx cv cen wbr vx vy cv wrex wi vz
      wal vw cv vy cv csn cdif vy cv wpss vw cv vy cv csn cdif vx cv cen wbr vx
      vy cv wrex wi vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vz cv
      vy cv wpss vz cv vx cv cen wbr vx vy cv wrex wi vw vz vw cv vz cv wceq vw
      cv vy cv wpss vz cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex vz cv vx
      cv cen wbr vx vy cv wrex vw cv vz cv vy cv psseq1 vw cv vz cv wceq vw cv
      vx cv cen wbr vz cv vx cv cen wbr vx vy cv vw cv vz cv vx cv cen breq1
      rexbidv imbi12d cbvalv vz cv vy cv wpss vz cv vx cv cen wbr vx vy cv wrex
      wi vw cv vy cv csn cdif vy cv wpss vw cv vy cv csn cdif vx cv cen wbr vx
      vy cv wrex wi vz vw cv vy cv csn cdif vw cv vy cv csn cdif vw cv vw
      visset vw cv vy cv csn difss ssexi vz cv vw cv vy cv csn cdif wceq vz cv
      vy cv wpss vw cv vy cv csn cdif vy cv wpss vz cv vx cv cen wbr vx vy cv
      wrex vw cv vy cv csn cdif vx cv cen wbr vx vy cv wrex vz cv vw cv vy cv
      csn cdif vy cv psseq1 vz cv vw cv vy cv csn cdif wceq vz cv vx cv cen wbr
      vw cv vy cv csn cdif vx cv cen wbr vx vy cv vz cv vw cv vy cv csn cdif vx
      cv cen breq1 rexbidv imbi12d cla4v sylbi sylan9 vy cv vw cv wcel vy cv
      com wcel wa vw cv vy cv csn cdif vx cv cen wbr vx vy cv wrex vw cv vx cv
      cen wbr vx vy cv csuc wrex wi vw cv vy cv wpss vw cv vx cv cen wbr vx vy
      cv wrex wi vw wal vy cv vw cv wcel vy cv com wcel wa vx cv vy cv wcel vw
      cv vy cv csn cdif vx cv cen wbr wa vx wex vw cv vz cv cen wbr vz vy cv
      csuc wrex vw cv vy cv csn cdif vx cv cen wbr vx vy cv wrex vw cv vx cv
      cen wbr vx vy cv csuc wrex vy cv vw cv wcel vy cv com wcel wa vx cv vy cv
      wcel vw cv vy cv csn cdif vx cv cen wbr wa vw cv vz cv cen wbr vz vy cv
      csuc wrex vx vy cv vw cv wcel vy cv com wcel wa vx cv vy cv wcel vw cv vy
      cv csn cdif vx cv cen wbr wa vx cv csuc vy cv csuc wcel vw cv vx cv csuc
      cen wbr wa vw cv vz cv cen wbr vz vy cv csuc wrex vy cv vw cv wcel vy cv
      com wcel wa vx cv vy cv wcel vw cv vy cv csn cdif vx cv cen wbr wa vx cv
      csuc vy cv csuc wcel vw cv vx cv csuc cen wbr vy cv vw cv wcel vy cv com
      wcel wa vx cv vy cv wcel vx cv csuc vy cv csuc wcel vw cv vy cv csn cdif
      vx cv cen wbr vy cv com wcel vx cv vy cv wcel vx cv csuc vy cv csuc wcel
      wi vy cv vw cv wcel vy cv com wcel vy cv word vx cv vy cv wcel vx cv csuc
      vy cv csuc wcel wi vy cv nnord vy cv word vx cv vy cv wcel vx cv csuc vy
      cv csuc wcel vx cv vy cv ordsucelsuc biimpd syl adantl adantrd vy cv vw
      cv wcel vy cv com wcel vx cv vy cv wcel vw cv vy cv csn cdif vx cv cen
      wbr vw cv vx cv csuc cen wbr vy cv vw cv wcel vw cv vy cv csn cdif vx cv
      cen wbr vx cv vy cv wcel vy cv com wcel vw cv vx cv csuc cen wbr vy cv vw
      cv wcel vw cv vy cv csn cdif vx cv cen wbr vx cv vy cv wcel vy cv com
      wcel vw cv vx cv csuc cen wbr vy cv vw cv wcel vw cv vy cv csn cdif vx cv
      cen wbr vx cv com wcel vw cv vx cv csuc cen wbr vx cv vy cv wcel vy cv
      com wcel wa vy cv vw cv wcel vw cv vx cv csuc cen wbr vw cv vy cv csn
      cdif vy cv csn cun vx cv vx cv csn cun cen wbr vw cv vy cv csn cdif vx cv
      cen wbr vx cv com wcel wa vy cv vw cv wcel vw cv vw cv vy cv csn cdif vy
      cv csn cun vx cv csuc vx cv vx cv csn cun cen vy cv vw cv wcel vw cv vy
      cv csn cdif vy cv csn cun vw cv vw cv vy cv difsnid eqcomd vx cv csuc vx
      cv vx cv csn cun wceq vy cv vw cv wcel vx cv df-suc a1i breq12d vw cv vy
      cv csn cdif vx cv cen wbr vy cv csn vx cv csn cen wbr wa vw cv vy cv csn
      cdif vy cv csn cin c0 wceq vx cv vx cv csn cin c0 wceq wa vw cv vy cv csn
      cdif vy cv csn cun vx cv vx cv csn cun cen wbr vw cv vy cv csn cdif vx cv
      cen wbr vx cv com wcel vw cv vy cv csn cdif vx cv vy cv csn vx cv csn
      unen vw cv vy cv csn cdif vx cv cen wbr vy cv csn vx cv csn cen wbr vy cv
      csn vx cv csn vy cv vx cv cop csn wf1o vy cv csn vx cv csn cen wbr vy cv
      vx cv vy visset vx visset f1osn vy cv csn vx cv csn vy cv vx cv cop csn
      vy cv snex f1oen ax-mp jctr vx cv com wcel vx cv vx cv csn cin c0 wceq vw
      cv vy cv csn cdif vy cv csn cin c0 wceq vx cv com wcel vx cv word vx cv
      vx cv csn cin c0 wceq vx cv nnord vx cv orddisj syl vy cv csn vw cv vy cv
      csn cdif cin vw cv vy cv csn cdif vy cv csn cin c0 vy cv csn vw cv vy cv
      csn cdif incom vy cv csn vw cv difdisj eqtr3i jctil syl2an syl5bir vx cv
      vy cv elnn sylan2i exp4d com24 imp4b jcad vw cv vz cv cen wbr vw cv vx cv
      csuc cen wbr vz vx cv csuc vy cv csuc vz cv vx cv csuc vw cv cen breq2
      rcla4ev syl6 19.23adv vw cv vy cv csn cdif vx cv cen wbr vx vy cv df-rex
      vw cv vx cv cen wbr vw cv vz cv cen wbr vx vz vy cv csuc vx cv vz cv vw
      cv cen breq2 cbvrexv 3imtr4g adantr syld exp31 imp3a vw cv vy cv wceq vw
      cv vy cv csuc wpss vw cv vx cv cen wbr vx vy cv csuc wrex wi vy cv com
      wcel vw cv vy cv wpss vw cv vx cv cen wbr vx vy cv wrex wi vw wal wa vw
      cv vy cv wceq vw cv vx cv cen wbr vx vy cv csuc wrex vw cv vy cv csuc
      wpss vw cv vy cv csuc wcel vw cv vw cv cen wbr vw cv vx cv cen wbr vx vy
      cv csuc wrex vw cv vy cv wceq vw cv vx cv cen wbr vw cv vw cv cen wbr vx
      vw cv vy cv csuc vx cv vw cv vw cv cen breq2 rcla4ev vw cv vy cv vw
      visset eqelsuc vw cv vw visset enref sylancl a1d a1d pm2.61ii ex 19.21ad
      finds syl5 com3l imp mpd $.
      $( [22-Jun-1998] $)

    $( A subset of a natural number is finite. $)
    ssnnfi $p |- ( ( A e. om /\ B C_ A ) -> B e. Fin ) $=
      cA com wcel cB cA wss wa cB vx cv cen wbr vx com wrex cB cfn wcel cA com
      wcel cB cA wpss cB cA wceq wo cB vx cv cen wbr vx com wrex cB cA wss cA
      com wcel cB cA wpss cB vx cv cen wbr vx com wrex cB cA wceq cA com wcel
      cB cA wpss wa cB vx cv cen wbr vx cA wrex cB vx cv cen wbr vx com wrex vx
      cA cB pssnn cA com wcel cB vx cv cen wbr vx cA wrex cB vx cv cen wbr vx
      com wrex wi cB cA wpss cA com wcel cB vx cv cen wbr cB vx cv cen wbr vx
      cA com cA com wcel vx cv cA wcel vx cv com wcel cB vx cv cen wbr vx cv cA
      wcel cA com wcel vx cv com wcel vx cv cA elnn expcom anim1d r19.22dv2
      adantr mpd cA com wcel cB cA wceq wa cB com wcel cB com wcel cB cB cen
      wbr wa cB vx cv cen wbr vx com wrex cB cA wceq cB com wcel cA com wcel cB
      cA com eleq1 biimparc cB com wcel cB cB cen wbr cB com enrefg ancli cB vx
      cv cen wbr cB cB cen wbr vx cB com vx cv cB cB cen breq2 rcla4ev 3syl
      jaodan cB cA sspss sylan2b vx cB isfi sylibr $.
      $( [29-Aug-2008] $) $( [24-Jun-1998] $)

    $( A subset of a finite set is finite.  Corollary 6G of [Enderton]
       p. 138. $)
    ssfi $p |- ( ( A e. Fin /\ B C_ A ) -> B e. Fin ) $=
      cA cfn wcel cB cA wss cB cfn wcel cA cfn wcel cA vx cv cen wbr vx com
      wrex cB cA wss cB cfn wcel wi vx cA isfi cA vx cv cen wbr cB cA wss cB
      cfn wcel wi vx com vx cv com wcel cA vx cv cen wbr cA vx cv vz cv wf1o vz
      wex cB cA wss cB cfn wcel wi cA vx cv com vz breng vx cv com wcel cA vx
      cv vz cv wf1o cB cA wss cB cfn wcel wi vz vx cv com wcel cA vx cv vz cv
      wf1o cB cA wss cB cfn wcel vx cv com wcel cA vx cv vz cv wf1o cB cA wss
      wa wa vz cv cB cima vy cv cen wbr vy com wrex cB cfn wcel vx cv com wcel
      cA vx cv vz cv wf1o vz cv cB cima vy cv cen wbr vy com wrex cB cA wss vx
      cv com wcel vz cv cB cima vx cv wss vz cv cB cima vy cv cen wbr vy com
      wrex cA vx cv vz cv wf1o vx cv com wcel vz cv cB cima vx cv wss wa vz cv
      cB cima cfn wcel vz cv cB cima vy cv cen wbr vy com wrex vx cv vz cv cB
      cima ssnnfi vy vz cv cB cima isfi sylib cA vx cv vz cv wf1o cA vx cv vz
      cv wfo vz cv cB cima vx cv wss cA vx cv vz cv f1ofo cA vx cv vz cv wfo vz
      cv cB cima vz cv crn wss vz cv cB cima vx cv wss vz cv cB imassrn cA vx
      cv vz cv wfo vz cv crn vx cv vz cv cB cima cA vx cv vz cv forn sseq2d
      mpbii syl sylan2 adantrr cA vx cv vz cv wf1o cB cA wss wa vz cv cB cima
      vy cv cen wbr vy com wrex cB cfn wcel wi vx cv com wcel cA vx cv vz cv
      wf1o cB cA wss wa vz cv cB cima vy cv cen wbr vy com wrex cB vy cv cen
      wbr vy com wrex cB cfn wcel cA vx cv vz cv wf1o cB cA wss wa vz cv cB
      cima vy cv cen wbr cB vy cv cen wbr vy com cA vx cv vz cv wf1o cB cA wss
      wa vz cv cB cima vy cv cen wbr cB vy cv cen wbr cB vz cv cB cima vz cv cB
      cres wf1o vz cv cB cima vy cv cen wbr cB vy cv cen wbr cA vx cv vz cv
      wf1o cB cA wss wa cB vz cv cB cima cen wbr vz cv cB cima vy cv cen wbr cB
      vy cv cen wbr cB vz cv cB cima vz cv cB cres wf1o cB vz cv cB cima vy cv
      entr cB vz cv cB cima vz cv cB cres wf1o cB vz cv cB cima vx cv wf1o vx
      wex cB vz cv cB cima cen wbr cB vz cv cB cima vx cv wf1o cB vz cv cB cima
      vz cv cB cres wf1o vx vz cv cB cres vz cv cvv wcel vz cv cB cres cvv wcel
      vz visset vz cv cB cvv resexg ax-mp cB vz cv cB cima vx cv vz cv cB cres
      f1oeq1 cla4ev cB vz cv cB cima vx vz cv cvv wcel vz cv cB cima cvv wcel
      vz visset vz cv cB cvv imaexg ax-mp bren sylibr sylan cA vx cv vz cv wf1
      cB cA wss cB vz cv cB cima vz cv cB cres wf1o cA vx cv vz cv wf1o cA vx
      cv cB vz cv f1ores cA vx cv vz cv f1of1 sylan sylan ex r19.22sdv vy cB
      isfi syl6ibr adantl mpd exp32 19.23adv sylbid r19.23aiv sylbi imp $.
      $( [29-Aug-2008] $) $( [24-Jun-1998] $)

    $( A set dominated by a finite set is finite. $)
    domfi $p |- ( ( A e. Fin /\ B ~<_ A ) -> B e. Fin ) $=
      cA cfn wcel cB cA cdom wbr cB cfn wcel cA cfn wcel cB cA cdom wbr cB vx
      cv cen wbr vx cv cA wss wa vx wex cB cfn wcel vx cB cA cfn domeng cA cfn
      wcel cB vx cv cen wbr vx cv cA wss wa cB cfn wcel vx cA cfn wcel cB vx cv
      cen wbr vx cv cA wss cB cfn wcel cB vx cv cen wbr cA cfn wcel vx cv cA
      wss cB cfn wcel wi cB vx cv cen wbr cA cfn wcel vx cv cA wss cB cfn wcel
      cB vx cv cen wbr cB cfn wcel vx cv cfn wcel cA cfn wcel vx cv cA wss wa
      vx cv cvv wcel cB vx cv cen wbr cB cfn wcel vx cv cfn wcel wb vx visset
      cB vx cv cvv enfi mpan cA vx cv ssfi syl5bir exp3a com12 imp3a 19.23adv
      sylbid imp $.
      $( [18-Sep-2008] $) $( [23-Mar-2006] $)

    $d A x y $.  $d B y $.
    $( The components of a non-empty finite cross product are finite.
       (Contributed by Paul Chapman, 11-Apr-2009.) $)
    xpfi $p |- ( ( ( A X. B ) e. Fin /\ ( A X. B ) =/= (/) ) ->
                 ( A e. Fin /\ B e. Fin ) ) $=
      cA cvv wcel cB cvv wcel wa cA cB cxp cfn wcel cA cB cxp c0 wne wa cA cfn
      wcel cB cfn wcel wa cA cB cfn xpexr2 vx cv vy cv cxp cfn wcel vx cv vy cv
      cxp c0 wne wa vx cv cfn wcel vy cv cfn wcel wa wi cA vy cv cxp cfn wcel
      cA vy cv cxp c0 wne wa cA cfn wcel vy cv cfn wcel wa wi cA cB cxp cfn
      wcel cA cB cxp c0 wne wa cA cfn wcel cB cfn wcel wa wi vx vy cA cB cvv
      cvv vx cv cA wceq vx cv vy cv cxp cfn wcel vx cv vy cv cxp c0 wne wa cA
      vy cv cxp cfn wcel cA vy cv cxp c0 wne wa vx cv cfn wcel vy cv cfn wcel
      wa cA cfn wcel vy cv cfn wcel wa vx cv cA wceq vx cv vy cv cxp cfn wcel
      cA vy cv cxp cfn wcel vx cv vy cv cxp c0 wne cA vy cv cxp c0 wne vx cv cA
      wceq vx cv vy cv cxp cA vy cv cxp cfn vx cv cA vy cv xpeq1 eleq1d vx cv
      cA wceq vx cv vy cv cxp cA vy cv cxp c0 vx cv cA vy cv xpeq1 neeq1d
      anbi12d vx cv cA wceq vx cv cfn wcel cA cfn wcel vy cv cfn wcel vx cv cA
      cfn eleq1 anbi1d imbi12d vy cv cB wceq cA vy cv cxp cfn wcel cA vy cv cxp
      c0 wne wa cA cB cxp cfn wcel cA cB cxp c0 wne wa cA cfn wcel vy cv cfn
      wcel wa cA cfn wcel cB cfn wcel wa vy cv cB wceq cA vy cv cxp cfn wcel cA
      cB cxp cfn wcel cA vy cv cxp c0 wne cA cB cxp c0 wne vy cv cB wceq cA vy
      cv cxp cA cB cxp cfn vy cv cB cA xpeq2 eleq1d vy cv cB wceq cA vy cv cxp
      cA cB cxp c0 vy cv cB cA xpeq2 neeq1d anbi12d vy cv cB wceq vy cv cfn
      wcel cB cfn wcel cA cfn wcel vy cv cB cfn eleq1 anbi2d imbi12d vx cv vy
      cv cxp cfn wcel vx cv c0 wne vy cv c0 wne wa vx cv cfn wcel vy cv cfn
      wcel wa vx cv vy cv cxp c0 wne vx cv c0 wne vy cv c0 wne wa vx cv vy cv
      cxp cfn wcel vx cv cfn wcel vy cv cfn wcel wa vx cv c0 wne vy cv c0 wne
      wa vx cv vx cv vy cv cxp cdom wbr vy cv vx cv vy cv cxp cdom wbr wa vx cv
      vy cv cxp cfn wcel vx cv cfn wcel vy cv cfn wcel wa vy cv c0 wne vx cv c0
      wne vx cv vx cv vy cv cxp cdom wbr vy cv vx cv vy cv cxp cdom wbr wa vy
      cv c0 wne vx cv vx cv vy cv cxp cdom wbr vx cv c0 wne vy cv vx cv vy cv
      cxp cdom wbr vx cv vy cv vx visset xpdom3 vx cv c0 wne vy cv vy cv vx cv
      cxp cdom wbr vy cv vx cv vy cv cxp cdom wbr vy cv vx cv vy visset xpdom3
      vy cv vx cv cxp cvv wcel vx cv vy cv cxp vy cv vx cv cxp cen wbr vy cv vx
      cv vy cv cxp cdom wbr vy cv vy cv vx cv cxp cdom wbr wb vy cv vx cv vy
      visset vx visset xpex vx cv vy cv vx visset vy visset xpcomen vx cv vy cv
      cxp vy cv vx cv cxp vy cv cvv domen2 mp2an sylibr anim12i ancoms vx cv vy
      cv cxp cfn wcel vx cv vx cv vy cv cxp cdom wbr vx cv cfn wcel vy cv vx cv
      vy cv cxp cdom wbr vy cv cfn wcel vx cv vy cv cxp cfn wcel vx cv vx cv vy
      cv cxp cdom wbr vx cv cfn wcel vx cv vy cv cxp vx cv domfi ex vx cv vy cv
      cxp cfn wcel vy cv vx cv vy cv cxp cdom wbr vy cv cfn wcel vx cv vy cv
      cxp vy cv domfi ex anim12d mpan9 ancoms vx cv vy cv xpnz sylan2br vtocl2g
      mpcom $.
      $( [14-Apr-2009] $) $( [11-Apr-2009] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Lemma for ~ unbnn .  After removing the successor of an element from an
       unbounded set of natural numbers, the intersection of the result belongs
       to the original unbounded set. $)
    unblem1 $p |- ( ( ( B C_ om /\ A. x e. om E. y e. B x e. y ) /\
                 A e. B ) -> |^| ( B \ suc A ) e. B ) $=
      cB com wss vx cv vy cv wcel vy cB wrex vx com wral wa cA cB wcel wa cB cA
      csuc cdif con0 wss cB cA csuc cdif c0 wne wa cB cA csuc cdif cint cB cA
      csuc cdif wcel cB cA csuc cdif cint cB wcel cB com wss vx cv vy cv wcel
      vy cB wrex vx com wral wa cA cB wcel wa cB cA csuc cdif con0 wss cB cA
      csuc cdif c0 wne cB com wss cB cA csuc cdif con0 wss vx cv vy cv wcel vy
      cB wrex vx com wral cA cB wcel cB com wss cB con0 wss cB cA csuc cdif
      con0 wss cB com wss com con0 wss cB con0 wss omsson cB com con0 sstr
      mpan2 cB con0 cA csuc ssdifss syl ad2antrr cB com wss vx cv vy cv wcel vy
      cB wrex vx com wral cA cB wcel cB cA csuc cdif c0 wne cB com wss vx cv vy
      cv wcel vy cB wrex vx com wral cA cB wcel cB cA csuc cdif c0 wne cB com
      wss vx cv vy cv wcel vy cB wrex vx com wral cA csuc com wcel cB cA csuc
      cdif c0 wne cA cB wcel cB com wss cA csuc vy cv wcel vy cB wrex cB cA
      csuc cdif c0 wne vx cv vy cv wcel vy cB wrex vx com wral cA csuc com wcel
      wa cB com wss cA csuc vy cv wcel cB cA csuc cdif c0 wne vy cB cB com wss
      vy cv cB wcel cA csuc vy cv wcel cB cA csuc cdif c0 wne cB com wss vy cv
      cB wcel cA csuc vy cv wcel wa vy cv cB wcel vy cv cA csuc wcel wn wa cB
      cA csuc cdif c0 wne cB com wss vy cv cB wcel cA csuc vy cv wcel vy cv cA
      csuc wcel wn cB com wss vy cv cB wcel vy cv com wcel cA csuc vy cv wcel
      vy cv cA csuc wcel wn wi cB com vy cv ssel vy cv com wcel vy cv word cA
      csuc vy cv wcel vy cv cA csuc wcel wn wi vy cv nnord vy cv word vy cv cA
      csuc wcel cA csuc vy cv wcel vy cv word vy cv cA csuc wcel cA csuc vy cv
      wcel wa wn vy cv cA csuc wcel cA csuc vy cv wcel wn wi vy cv cA csuc
      ordn2lp vy cv cA csuc wcel cA csuc vy cv wcel imnan sylibr con2d syl syl6
      imdistand vy cv cB wcel vy cv cA csuc wcel wn wa vy cv cB cA csuc cdif
      wcel cB cA csuc cdif c0 wne vy cv cB cA csuc eldif cB cA csuc cdif vy cv
      ne0i sylbir syl6 exp3a r19.23adv vx cv vy cv wcel vy cB wrex cA csuc vy
      cv wcel vy cB wrex vx cA csuc com vx cv cA csuc wceq vx cv vy cv wcel cA
      csuc vy cv wcel vy cB vx cv cA csuc vy cv eleq1 rexbidv rcla4cva syl5 cB
      com wss cA cB wcel cA com wcel cA csuc com wcel cB com cA ssel cA peano2b
      syl6ib sylan2d exp3a imp31 jca cB cA csuc cdif onint cB cA csuc cdif cint
      cB cA csuc eldifi 3syl $.
      $( [14-Jul-2004] $) $( [3-Dec-2003] $)
  $}

  ${
    $d x y z w v u A $.  $d z w v u F $.
    unblem.1 $e |- ( w e. F -> A. x w e. F ) $.
    unblem.2 $e |- F =
          ( rec ( { <. x , y >. | y = |^| ( A \ suc x ) } , |^| A ) |` om ) $.
    $( Lemma for ~ unbnn .  The value of the function ` F ` belongs to
       the unbounded set of natural numbers ` A ` . $)
    unblem2 $p |- ( ( A C_ om /\ A. w e. om E. v e. A w e. v ) -> ( z e. om ->
                ( F ` z ) e. A ) ) $=
      vz cv com wcel cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa vz
      cv cF cfv cA wcel vz cv cF cfv cA wcel c0 cF cfv cA wcel vu cv cF cfv cA
      wcel vu cv csuc cF cfv cA wcel cA com wss vw cv vv cv wcel vv cA wrex vw
      com wral wa vz vu vz cv c0 wceq vz cv cF cfv c0 cF cfv cA vz cv c0 cF
      fveq2 eleq1d vz cv vu cv wceq vz cv cF cfv vu cv cF cfv cA vz cv vu cv cF
      fveq2 eleq1d vz cv vu cv csuc wceq vz cv cF cfv vu cv csuc cF cfv cA vz
      cv vu cv csuc cF fveq2 eleq1d cA com wss vw cv vv cv wcel vv cA wrex vw
      com wral wa cA cint cA wcel c0 cF cfv cA wcel cA con0 wss cA c0 wne cA
      cint cA wcel cA com wss vw cv vv cv wcel vv cA wrex vw com wral cA onint
      cA com wss com con0 wss cA con0 wss omsson cA com con0 sstr mpan2 vw cv
      vv cv wcel vv cA wrex vw com wral vv cv cA wcel vv wex cA c0 wne vw cv vv
      cv wcel vv cA wrex vw com wral vv cv cA wcel c0 vv cv wcel wa vv wex vv
      cv cA wcel vv wex vw cv vv cv wcel vv cA wrex vw com wral c0 vv cv wcel
      vv cA wrex vv cv cA wcel c0 vv cv wcel wa vv wex c0 com wcel vw cv vv cv
      wcel vv cA wrex vw com wral c0 vv cv wcel vv cA wrex wi peano1 vw cv vv
      cv wcel vv cA wrex c0 vv cv wcel vv cA wrex vw c0 com vw cv c0 wceq vw cv
      vv cv wcel c0 vv cv wcel vv cA vw cv c0 vv cv eleq1 rexbidv rcla4v ax-mp
      c0 vv cv wcel vv cA df-rex sylib vv cv cA wcel c0 vv cv wcel wa vv cv cA
      wcel vv vv cv cA wcel c0 vv cv wcel pm3.26 19.22i syl vv cA n0 sylibr
      syl2an cA cint cA wcel c0 cF cfv cA wcel cA cint cA wcel cA cint c0 cF
      cfv cA cA cint cA wcel c0 vy cv cA vx cv csuc cdif cint wceq vx vy copab
      cA cint crdg com cres cfv cA cint c0 cF cfv cA cint cA vy cv cA vx cv
      csuc cdif cint wceq vx vy copab fr0g c0 cF vy cv cA vx cv csuc cdif cint
      wceq vx vy copab cA cint crdg com cres unblem.2 fveq1i syl5req eleq1d ibi
      syl vu cv com wcel cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa
      vu cv cF cfv cA wcel vu cv csuc cF cfv cA wcel vu cv com wcel cA vu cv cF
      cfv csuc cdif cint cA wcel vu cv csuc cF cfv cA wcel cA com wss vw cv vv
      cv wcel vv cA wrex vw com wral wa vu cv cF cfv cA wcel wa vu cv com wcel
      cA vu cv cF cfv csuc cdif cint cA wcel vu cv csuc cF cfv cA wcel vu cv
      com wcel cA vu cv cF cfv csuc cdif cint cA wcel cA vu cv cF cfv csuc cdif
      cint cA wcel vu cv csuc cF cfv cA wcel wb vu cv com wcel cA vu cv cF cfv
      csuc cdif cint cA wcel wa cA vu cv cF cfv csuc cdif cint vu cv csuc cF
      cfv cA vu cv com wcel cA vu cv cF cfv csuc cdif cint cA wcel wa vu cv
      csuc cF cfv cA vu cv cF cfv csuc cdif cint vx vy vw cA cint vu cv cA vx
      cv csuc cdif cint cA vu cv cF cfv csuc cdif cint cA cF vw cv cA cint wcel
      vx ax-17 vw cv vu cv wcel vx ax-17 vx vw cA vu cv cF cfv csuc cdif vx vw
      cA vu cv cF cfv csuc vw cv cA wcel vx ax-17 vx vw vu cv cF cfv vx vw vu
      cv cF unblem.1 vw cv vu cv wcel vx ax-17 hbfv hbsuc hbdif hbint unblem.2
      vx cv vu cv cF cfv wceq cA vx cv csuc cdif cA vu cv cF cfv csuc cdif vx
      cv vu cv cF cfv wceq vx cv csuc vu cv cF cfv csuc cA vx cv vu cv cF cfv
      suceq difeq2d inteqd frsucopab eqcomd eleq1d ex ibd vw vv vu cv cF cfv cA
      unblem1 syl5 exp3a finds2 com12 $.
      $( [14-Jul-2004] $) $( [3-Dec-2003] $)

    $( Lemma for ~ unbnn .  The value of the function ` F ` is less than
       its value at a successor. $)
    unblem3 $p |- ( ( A C_ om /\ A. w e. om E. v e. A w e. v ) -> ( z e. om ->
                ( F ` z )  e. ( F ` suc z ) ) ) $=
      cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa vz cv com wcel vz
      cv cF cfv vz cv csuc cF cfv wcel cA com wss vw cv vv cv wcel vv cA wrex
      vw com wral wa vz cv com wcel wa vz cv cF cfv cA vz cv cF cfv csuc cdif
      cint vz cv csuc cF cfv cA com wss vw cv vv cv wcel vv cA wrex vw com wral
      wa vz cv com wcel wa cA con0 wss vz cv cF cfv con0 wcel wa vz cv cF cfv
      cA vz cv cF cfv csuc cdif cint wcel cA com wss vw cv vv cv wcel vv cA
      wrex vw com wral wa vz cv com wcel wa vz cv cF cfv cA wcel cA con0 wss vz
      cv cF cfv con0 wcel wa cA com wss vw cv vv cv wcel vv cA wrex vw com wral
      wa vz cv com wcel vz cv cF cfv cA wcel vx vy vz vw vv cA cF unblem.1
      unblem.2 unblem2 imp cA com wss vz cv cF cfv cA wcel cA con0 wss vz cv cF
      cfv con0 wcel wa wi vw cv vv cv wcel vv cA wrex vw com wral vz cv com
      wcel cA com wss cA con0 wss vz cv cF cfv cA wcel cA con0 wss vz cv cF cfv
      con0 wcel wa wi cA com wss com con0 wss cA con0 wss omsson cA com con0
      sstr mpan2 cA con0 wss vz cv cF cfv cA wcel vz cv cF cfv con0 wcel cA
      con0 vz cv cF cfv ssel anc2li syl ad2antrr mpd cA vz cv cF cfv onmindif
      syl cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa vz cv com wcel
      vz cv csuc cF cfv cA vz cv cF cfv csuc cdif cint wceq cA com wss vw cv vv
      cv wcel vv cA wrex vw com wral wa vz cv com wcel cA vz cv cF cfv csuc
      cdif cint cA wcel vz cv csuc cF cfv cA vz cv cF cfv csuc cdif cint wceq
      cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa vz cv com wcel vz
      cv cF cfv cA wcel cA vz cv cF cfv csuc cdif cint cA wcel vx vy vz vw vv
      cA cF unblem.1 unblem.2 unblem2 cA com wss vw cv vv cv wcel vv cA wrex vw
      com wral wa vz cv cF cfv cA wcel cA vz cv cF cfv csuc cdif cint cA wcel
      vw vv vz cv cF cfv cA unblem1 ex syld vz cv com wcel cA vz cv cF cfv csuc
      cdif cint cA wcel vz cv csuc cF cfv cA vz cv cF cfv csuc cdif cint wceq
      vx vy vw cA cint vz cv cA vx cv csuc cdif cint cA vz cv cF cfv csuc cdif
      cint cA cF vw cv cA cint wcel vx ax-17 vw cv vz cv wcel vx ax-17 vx vw cA
      vz cv cF cfv csuc cdif vx vw cA vz cv cF cfv csuc vw cv cA wcel vx ax-17
      vx vw vz cv cF cfv vx vw vz cv cF unblem.1 vw cv vz cv wcel vx ax-17 hbfv
      hbsuc hbdif hbint unblem.2 vx cv vz cv cF cfv wceq cA vx cv csuc cdif cA
      vz cv cF cfv csuc cdif vx cv vz cv cF cfv wceq vx cv csuc vz cv cF cfv
      csuc cA vx cv vz cv cF cfv suceq difeq2d inteqd frsucopab ex sylcom imp
      eleqtrrd ex $.
      $( [14-Jul-2004] $) $( [3-Dec-2003] $)

    $( Lemma for ~ unbnn .  The function ` F ` maps the set of natural
       numbers one-to-one to the set of unbounded natural numbers ` A ` . $)
    unblem4 $p |- ( ( A C_ om /\ A. w e. om E. v e. A w e. v ) ->
                 F : om -1-1-> A ) $=
      cA con0 wss com cA cF wf wa vz cv cF cfv vz cv csuc cF cfv wcel vz com
      wral com cA cF wf1 cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa
      vz cA cF omsmo cA com wss vw cv vv cv wcel vv cA wrex vw com wral wa cA
      con0 wss com cA cF wf cA com wss cA con0 wss vw cv vv cv wcel vv cA wrex
      vw com wral cA com wss com con0 wss cA con0 wss omsson cA com con0 sstr
      mpan2 adantr cF com wfn vz cv cF cfv cA wcel vz com wral com cA cF wf cA
      com wss vw cv vv cv wcel vv cA wrex vw com wral wa com cA cF wf cF com
      wfn vz cv cF cfv cA wcel vz com wral wa vz com cA cF ffnfv biimpri cF com
      wfn vy cv cA vx cv csuc cdif cint wceq vx vy copab cA cint crdg com cres
      com wfn cA cint vy cv cA vx cv csuc cdif cint wceq vx vy copab frfnom cF
      vy cv cA vx cv csuc cdif cint wceq vx vy copab cA cint crdg com cres wceq
      cF com wfn vy cv cA vx cv csuc cdif cint wceq vx vy copab cA cint crdg
      com cres com wfn wb unblem.2 com cF vy cv cA vx cv csuc cdif cint wceq vx
      vy copab cA cint crdg com cres fneq1 ax-mp mpbir cA com wss vw cv vv cv
      wcel vv cA wrex vw com wral wa vz cv cF cfv cA wcel vz com vx vy vz vw vv
      cA cF unblem.1 unblem.2 unblem2 r19.21aiv sylancr jca cA com wss vw cv vv
      cv wcel vv cA wrex vw com wral wa vz cv cF cfv vz cv csuc cF cfv wcel vz
      com vx vy vz vw vv cA cF unblem.1 unblem.2 unblem3 r19.21aiv sylanc $.
      $( [14-Jul-2004] $) $( [3-Dec-2003] $)
  $}

  ${
    $d x y z w A $.
    unbnn.1 $e |- A e. _V $.
    $( Any unbounded subset of natural numbers is equinumerous to the set of
       all natural numbers.  Part of the proof of Theorem 42 of [Suppes]
       p. 151.  See ~ unbnn3 for a stronger version without the hypothesis. $)
    unbnn $p |- ( ( A C_ om /\ A. x e. om E. y e. A x e. y ) -> A ~~ om ) $=
      cA com cdom wbr com cA cdom wbr cA com cen wbr cA com wss vx cv vy cv
      wcel vy cA wrex vx com wral wa cA com sbth cA com wss cA com cdom wbr vx
      cv vy cv wcel vy cA wrex vx com wral cA cvv wcel cA com wss cA com cdom
      wbr wi unbnn.1 cA com cvv ssdomg ax-mp adantr cA com wss vx cv vy cv wcel
      vy cA wrex vx com wral wa com cA vw cv cA vz cv csuc cdif cint wceq vz vw
      copab cA cint crdg com cres wf1 com cA cdom wbr vz vw vx vy cA vw cv cA
      vz cv csuc cdif cint wceq vz vw copab cA cint crdg com cres vz vx vw cv
      cA vz cv csuc cdif cint wceq vz vw copab cA cint crdg com vz vx cA cint
      vw cv cA vz cv csuc cdif cint wceq vz vw copab vw cv cA vz cv csuc cdif
      cint wceq vz vw vx hbopab1 vx cv cA cint wcel vz ax-17 hbrdg vx cv com
      wcel vz ax-17 hbres vw cv cA vz cv csuc cdif cint wceq vz vw copab cA
      cint crdg com cres eqid unblem4 cA cvv wcel com cA vw cv cA vz cv csuc
      cdif cint wceq vz vw copab cA cint crdg com cres wf1 com cA cdom wbr wi
      unbnn.1 com cA cvv vw cv cA vz cv csuc cdif cint wceq vz vw copab cA cint
      crdg com cres f1dom2g ax-mp syl sylanc $.
      $( [14-Jul-2004] $) $( [3-Dec-2003] $)

    $( Version of ~ unbnn that does not require a strict upper bound. $)
    unbnn2 $p |- ( ( A C_ om /\ A. x e. om E. y e. A x C_ y ) -> A ~~ om ) $=
      cA com wss vz cv vy cv wcel vy cA wrex vz com wral cA com cen wbr vx cv
      vy cv wss vy cA wrex vx com wral vz vy cA unbnn.1 unbnn vx cv vy cv wss
      vy cA wrex vx com wral vz cv vy cv wcel vy cA wrex vz com vx cv vy cv wss
      vy cA wrex vx com wral vz cv csuc com wcel vz cv vy cv wcel vy cA wrex vz
      cv com wcel vz cv csuc com wcel vx cv vy cv wss vy cA wrex vx com wral vz
      cv csuc vy cv wss vy cA wrex vz cv vy cv wcel vy cA wrex vx cv vy cv wss
      vy cA wrex vz cv csuc vy cv wss vy cA wrex vx vz cv csuc com vx cv vz cv
      csuc wceq vx cv vy cv wss vz cv csuc vy cv wss vy cA vx cv vz cv csuc vy
      cv sseq1 rexbidv rcla4v vz cv csuc vy cv wss vz cv vy cv wcel vy cA vz cv
      cvv wcel vz cv csuc vy cv wss vz cv vy cv wcel wi vz visset vz cv vy cv
      cvv sucssel ax-mp r19.22si syl6com vz cv peano2 syl5 r19.21aiv sylan2 $.
      $( [17-Jul-2004] $) $( [24-Apr-2004] $)
  $}

  ${
    $d x y z w A $.
    $( Any set strictly dominated by the class of natural numbers is finite.
       Sufficiency part of Theorem 42 of [Suppes] p. 151.  This theorem does
       not require the Axiom of Infinity. $)
    isfinite2 $p |- ( A ~< om -> A e. Fin ) $=
      com cvv wcel cA com csdm wbr cA cfn wcel cA com csdm wbr cA cvv wcel com
      cvv wcel cA com sdomex pm3.27d com cvv wcel cA com csdm wbr cA vy cv cen
      wbr vy cv com wss wa vy wex cA cfn wcel com cvv wcel cA com cdom wbr cA
      vy cv cen wbr vy cv com wss wa vy wex cA com csdm wbr vy cA com cvv
      domeng cA com sdomdom syl5bi cA com csdm wbr cA vy cv cen wbr vy cv com
      wss wa cA cfn wcel vy cA com csdm wbr cA vy cv cen wbr vy cv com wss cA
      cfn wcel vy cv com wss cA vy cv cen wbr cA com csdm wbr cA cfn wcel vy cv
      com wss cA vy cv cen wbr cA com csdm wbr cA cfn wcel wi vy cv com wss cA
      vy cv cen wbr wa cA com csdm wbr vy cv cfn wcel cA cfn wcel vy cv com wss
      cA vy cv cen wbr cA com csdm wbr vy cv cfn wcel vy cv com wss cA vy cv
      cen wbr cA com csdm wbr wa vz cv vw cv wcel vw vy cv wrex vz com wral wn
      vy cv cfn wcel vy cv com wss vy cv com csdm wbr vz cv vw cv wcel vw vy cv
      wrex vz com wral wn cA vy cv cen wbr cA com csdm wbr wa vy cv com wss vz
      cv vw cv wcel vw vy cv wrex vz com wral vy cv com cen wbr vy cv com csdm
      wbr vy cv com wss vz cv vw cv wcel vw vy cv wrex vz com wral vy cv com
      cen wbr vz vw vy cv vy visset unbnn ex vy cv com sdomnen nsyli vy cv cA
      cen wbr cA com csdm wbr vy cv com csdm wbr cA vy cv cen wbr vy cv cA com
      ensdomtr cA vy cv vy visset ensym sylan syl5 vy cv com wss vz cv vw cv
      wcel vw vy cv wrex wn vz com wrex vy cv cfn wcel vz cv vw cv wcel vw vy
      cv wrex vz com wral wn vy cv com wss vz cv vw cv wcel vw vy cv wrex wn vy
      cv cfn wcel vz com vy cv com wss vz cv com wcel wa vz cv vw cv wcel vw vy
      cv wrex wn vy cv vz cv csuc wss vy cv cfn wcel vy cv con0 wss vz cv word
      vz cv vw cv wcel vw vy cv wrex wn vy cv vz cv csuc wss wb vy cv com wss
      vz cv com wcel vy cv con0 wss vz cv word wa vy cv cuni vz cv wss vz cv vw
      cv wcel vw vy cv wrex wn vy cv vz cv csuc wss vy cv con0 wss vz cv word
      wa vw cv vz cv wss vw vy cv wral vz cv vw cv wcel wn vw vy cv wral vy cv
      cuni vz cv wss vz cv vw cv wcel vw vy cv wrex wn vy cv con0 wss vz cv
      word wa vw cv vz cv wss vz cv vw cv wcel wn vw vy cv vy cv con0 wss vw cv
      vy cv wcel vz cv word vw cv vz cv wss vz cv vw cv wcel wn wb vw cv word
      vz cv word vw cv vz cv wss vz cv vw cv wcel wn wb vy cv con0 wss vw cv vy
      cv wcel wa vw cv vz cv ordtri1 vy cv con0 wss vw cv vy cv wcel wa vw cv
      con0 wcel vw cv word vy cv con0 vw cv ssel2 vw cv vw visset elon sylib
      sylan an1rs ralbidva vw vy cv vz cv unissb vz cv vw cv wcel wn vw vy cv
      wral vz cv vw cv wcel vw vy cv wrex wn vz cv vw cv wcel vw vy cv ralnex
      bicomi 3bitr4g vy cv vz cv ordunisssuc bitr3d vy cv com wss com con0 wss
      vy cv con0 wss omsson vy cv com con0 sstr mpan2 vz cv nnord syl2an vz cv
      com wcel vy cv vz cv csuc wss vy cv cfn wcel wi vy cv com wss vz cv com
      wcel vy cv vz cv csuc wss vy cv cfn wcel vz cv csuc com wcel vy cv vz cv
      csuc wss vy cv cfn wcel vz cv com wcel vz cv csuc vy cv ssnnfi vz cv
      peano2b sylanb ex adantl sylbid r19.23adva vz cv vw cv wcel vw vy cv wrex
      vz com rexnal syl5ibr syld expdimp cA vy cv cen wbr cA cfn wcel vy cv cfn
      wcel wb vy cv com wss vy cv cvv wcel cA vy cv cen wbr cA cfn wcel vy cv
      cfn wcel wb vy visset cA vy cv cvv enfi mpan adantl sylibrd ex com13
      imp3a 19.23adv sylcom mpcom $.
      $( [10-Sep-2008] $) $( [24-Apr-2004] $)
  $}

  $( This (useless) theorem, which was proved without the Axiom of Infinity,
     demonstrates an artifact of our definition of strict dominance, which is
     meaningful only when its arguments exist.  In particular, the antecedent
     cannot be satisfied unless ` om ` exists. $)
  fin2inf $p |- ( A ~< om -> om e. _V ) $=
    cA com csdm wbr cA cvv wcel com cvv wcel cA com sdomex pm3.27d $.
    $( [12-Mar-2006] $) $( [13-Nov-2003] $)

  ${
    $d x y z w A $.  $d x y z w B $.  $d z w F $.
    unfilem1.1 $e |- A e. om $.
    unfilem1.2 $e |- B e. om $.
    unfilem1.3 $e |- F = { <. x , y >. | ( x e. B /\ y = ( A +o x ) ) } $.
    $( Lemma for proving that the union of two finite sets is finite. $)
    unfilem1 $p |- ran F = ( ( A +o B ) \ A ) $=
      vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab crn vx cv cB wcel
      vy cv cA vx cv coa co wceq wa vx wex vy cab cF crn cA cB coa co cA cdif
      vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy rnopab cF vx cv cB wcel
      vy cv cA vx cv coa co wceq wa vx vy copab unfilem1.3 rneqi vx cv cB wcel
      vy cv cA vx cv coa co wceq wa vx wex vy cA cB coa co cA cdif vy cv cA cB
      coa co cA cdif wcel vy cv cA cB coa co wcel vy cv cA wcel wn wa vx cv cB
      wcel vy cv cA vx cv coa co wceq wa vx wex vy cv cA cB coa co cA eldif vy
      cv cA cB coa co wcel vy cv cA wcel wn wa vx cv cB wcel vy cv cA vx cv coa
      co wceq wa vx wex vy cv cA cB coa co wcel vy cv cA wcel wn vx cv cB wcel
      vy cv cA vx cv coa co wceq wa vx wex vy cv cA cB coa co wcel vy cv cA
      wcel wn vx cv com wcel cA vx cv coa co vy cv wceq wa vx wex vx cv cB wcel
      vy cv cA vx cv coa co wceq wa vx wex vy cv cA cB coa co wcel vy cv com
      wcel vy cv cA wcel wn vx cv com wcel cA vx cv coa co vy cv wceq wa vx wex
      wb vy cv cA cB coa co wcel cA cB coa co com wcel vy cv com wcel cA com
      wcel cB com wcel cA cB coa co com wcel unfilem1.1 unfilem1.2 cA cB nnacl
      mp2an vy cv cA cB coa co elnn mpan2 vy cv com wcel vy cv cA wcel wn cA vx
      cv coa co vy cv wceq vx com wrex vx cv com wcel cA vx cv coa co vy cv
      wceq wa vx wex cA com wcel vy cv com wcel vy cv cA wcel wn cA vx cv coa
      co vy cv wceq vx com wrex wb unfilem1.1 cA com wcel vy cv com wcel wa cA
      vy cv wss vy cv cA wcel wn cA vx cv coa co vy cv wceq vx com wrex cA word
      vy cv word cA vy cv wss vy cv cA wcel wn wb cA com wcel vy cv com wcel cA
      vy cv ordtri1 cA nnord vy cv nnord syl2an vx cA vy cv nnawordex bitr3d
      mpan cA vx cv coa co vy cv wceq vx com df-rex syl6bb syl vy cv cA cB coa
      co wcel vx cv com wcel cA vx cv coa co vy cv wceq wa vx cv cB wcel vy cv
      cA vx cv coa co wceq wa vx vy cv cA cB coa co wcel vx cv com wcel cA vx
      cv coa co vy cv wceq wa vx cv cB wcel vy cv cA vx cv coa co wceq vx cv
      com wcel cA vx cv coa co vy cv wceq wa vx cv cB wcel vy cv cA cB coa co
      wcel vx cv com wcel vx cv cB wcel cA vx cv coa co cA cB coa co wcel cA vx
      cv coa co vy cv wceq vy cv cA cB coa co wcel vx cv com wcel cB com wcel
      cA com wcel vx cv cB wcel cA vx cv coa co cA cB coa co wcel wb unfilem1.2
      unfilem1.1 vx cv cB cA nnaord mp3an23 cA vx cv coa co vy cv cA cB coa co
      eleq1 sylan9bb biimprcd vx cv com wcel cA vx cv coa co vy cv wceq wa vy
      cv cA vx cv coa co wceq wi vy cv cA cB coa co wcel cA vx cv coa co vy cv
      wceq vy cv cA vx cv coa co wceq vx cv com wcel cA vx cv coa co vy cv wceq
      vy cv cA vx cv coa co wceq cA vx cv coa co vy cv eqcom biimpi adantl a1i
      jcad 19.22dv sylbid imp vx cv cB wcel vy cv cA vx cv coa co wceq wa vy cv
      cA cB coa co wcel vy cv cA wcel wn wa vx cA vx cv coa co cA cB coa co
      wcel cA vx cv coa co cA wcel wn wa vy cv cA vx cv coa co wceq vy cv cA cB
      coa co wcel vy cv cA wcel wn wa vx cv cB wcel vy cv cA vx cv coa co wceq
      vy cv cA cB coa co wcel vy cv cA wcel wn wa cA vx cv coa co cA cB coa co
      wcel cA vx cv coa co cA wcel wn wa vy cv cA vx cv coa co wceq vy cv cA cB
      coa co wcel cA vx cv coa co cA cB coa co wcel vy cv cA wcel wn cA vx cv
      coa co cA wcel wn vy cv cA vx cv coa co cA cB coa co eleq1 vy cv cA vx cv
      coa co wceq vy cv cA wcel cA vx cv coa co cA wcel vy cv cA vx cv coa co
      cA eleq1 notbid anbi12d biimparc vx cv cB wcel cA vx cv coa co cA cB coa
      co wcel cA vx cv coa co cA wcel wn vx cv cB wcel cA vx cv coa co cA cB
      coa co wcel vx cv cB wcel vx cv com wcel vx cv cB wcel cA vx cv coa co cA
      cB coa co wcel wb vx cv cB wcel cB com wcel vx cv com wcel unfilem1.2 vx
      cv cB elnn mpan2 vx cv com wcel cB com wcel cA com wcel vx cv cB wcel cA
      vx cv coa co cA cB coa co wcel wb unfilem1.2 unfilem1.1 vx cv cB cA
      nnaord mp3an23 syl ibi cA com wcel vx cv com wcel cA vx cv coa co cA wcel
      wn vx cv cB wcel cA com wcel vx cv com wcel wa cA cA vx cv coa co wss cA
      vx cv coa co cA wcel wn cA vx cv nnaword1 cA com wcel vx cv com wcel wa
      cA vx cv coa co com wcel cA vx cv coa co word cA cA vx cv coa co wss cA
      vx cv coa co cA wcel wn wb cA vx cv nnacl cA vx cv coa co nnord cA word
      cA vx cv coa co word cA cA vx cv coa co wss cA vx cv coa co cA wcel wn wb
      cA com wcel cA word unfilem1.1 cA nnord ax-mp cA cA vx cv coa co ordtri1
      mpan 3syl mpbid unfilem1.1 vx cv cB wcel cB com wcel vx cv com wcel
      unfilem1.2 vx cv cB elnn mpan2 sylancr jca sylan 19.23aiv impbii bitri
      abbi2i 3eqtr4i $.
      $( [10-Nov-2002] $)

    $( Lemma for proving that the union of two finite sets is finite. $)
    unfilem2 $p |- F : B -1-1-onto-> ( ( A +o B ) \ A ) $=
      cB cA cB coa co cA cdif cF wf1o cB cA cB coa co cA cdif cF wf1 cB cA cB
      coa co cA cdif cF wfo cB cA cB coa co cA cdif cF df-f1o cB cA cB coa co
      cA cdif cF wf1 cB cA cB coa co cA cdif cF wf vz cv cF cfv vw cv cF cfv
      wceq vz cv vw cv wceq wi vw cB wral vz cB wral vz vw cB cA cB coa co cA
      cdif cF dff13 cB cA cB coa co cA cdif cF wfo cB cA cB coa co cA cdif cF
      wf cB cA cB coa co cA cdif cF wfo cF cB wfn cF crn cA cB coa co cA cdif
      wceq cB cA cB coa co cA cdif cF df-fo vx vy cB cA vx cv coa co cF cA vx
      cv coa oprex unfilem1.3 fnopab2 vx vy cA cB cF unfilem1.1 unfilem1.2
      unfilem1.3 unfilem1 mpbir2an cB cA cB coa co cA cdif cF fof ax-mp vz cv
      cF cfv vw cv cF cfv wceq vz cv vw cv wceq wi vz vw cB vz cv cB wcel vw cv
      cB wcel wa vz cv cF cfv vw cv cF cfv wceq vz cv vw cv wceq vz cv cB wcel
      vw cv cB wcel wa vz cv cF cfv vw cv cF cfv wceq cA vz cv coa co cA vw cv
      coa co wceq vz cv vw cv wceq vz cv cB wcel vw cv cB wcel vz cv cF cfv cA
      vz cv coa co vw cv cF cfv cA vw cv coa co vx vy vz cv cA vx cv coa co cA
      vz cv coa co cB cF vx cv vz cv cA coa opreq2 unfilem1.3 cA vz cv coa
      oprex fvopab4 vx vy vw cv cA vx cv coa co cA vw cv coa co cB cF vx cv vw
      cv cA coa opreq2 unfilem1.3 cA vw cv coa oprex fvopab4 eqeqan12d vz cv
      com wcel vw cv com wcel cA vz cv coa co cA vw cv coa co wceq vz cv vw cv
      wceq wb vz cv cB wcel vw cv cB wcel cA com wcel vz cv com wcel vw cv com
      wcel cA vz cv coa co cA vw cv coa co wceq vz cv vw cv wceq wb unfilem1.1
      cA vz cv vw cv nnacan mp3an1 vz cv cB wcel cB com wcel vz cv com wcel
      unfilem1.2 vz cv cB elnn mpan2 vw cv cB wcel cB com wcel vw cv com wcel
      unfilem1.2 vw cv cB elnn mpan2 syl2an bitrd biimpd rgen2a mpbir2an cB cA
      cB coa co cA cdif cF wfo cF cB wfn cF crn cA cB coa co cA cdif wceq cB cA
      cB coa co cA cdif cF df-fo vx vy cB cA vx cv coa co cF cA vx cv coa oprex
      unfilem1.3 fnopab2 vx vy cA cB cF unfilem1.1 unfilem1.2 unfilem1.3
      unfilem1 mpbir2an mpbir2an $.
      $( [10-Nov-2002] $)
  $}

  ${
    $d x y f A $.  $d x y f B $.
    $( Lemma for proving that the union of two finite sets is finite. $)
    unfilem3 $p |- ( ( A e. om /\ B e. om ) -> B ~~ ( ( A +o B ) \ A ) ) $=
      cA com wcel cB com wcel wa cB cA cB coa co cA cdif vf cv wf1o vf wex cB
      cA cB coa co cA cdif cen wbr vx cv cB wcel vy cv cA vx cv coa co wceq wa
      vx vy copab cvv wcel cB cA cB coa co cA cdif vx cv cB wcel vy cv cA vx cv
      coa co wceq wa vx vy copab wf1o cB cA cB coa co cA cdif vf cv wf1o vf wex
      cA com wcel cB com wcel wa cB cA cB coa co cA cdif vf cv wf1o cB cA cB
      coa co cA cdif vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab
      wf1o vf vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab cvv cB cA
      cB coa co cA cdif vf cv vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy
      copab f1oeq1 cla4egv cA com wcel cB com wcel vx cv cB wcel vy cv cA vx cv
      coa co wceq wa vx vy copab cB wfn vx cv cB wcel vy cv cA vx cv coa co
      wceq wa vx vy copab cvv wcel cA com wcel cB com wcel wa cB cA cB coa co
      cA cdif vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab wf1o vx
      cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab cB wfn cA com wcel
      cB com wcel cB cA cB coa co cA cdif vx cv cB wcel vy cv cA vx cv coa co
      wceq wa vx vy copab wf1o cB cA com wcel cA c0 cif cB coa co cA com wcel
      cA c0 cif cdif vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co
      wceq wa vx vy copab wf1o cB com wcel cB c0 cif cA com wcel cA c0 cif cB
      com wcel cB c0 cif coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB
      c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      wf1o cA cB c0 c0 cA cA com wcel cA c0 cif wceq cB cA cB coa co cA cdif vx
      cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab wf1o cB cA cB coa co
      cA cdif vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx
      vy copab wf1o cB cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif
      cdif vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy
      copab wf1o cA cA com wcel cA c0 cif wceq vx cv cB wcel vy cv cA vx cv coa
      co wceq wa vx vy copab vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv
      coa co wceq wa vx vy copab wceq cB cA cB coa co cA cdif vx cv cB wcel vy
      cv cA vx cv coa co wceq wa vx vy copab wf1o cB cA cB coa co cA cdif vx cv
      cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o
      wb cA cA com wcel cA c0 cif wceq vx cv cB wcel vy cv cA vx cv coa co wceq
      wa vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy
      cA cA com wcel cA c0 cif wceq vy cv cA vx cv coa co wceq vy cv cA com
      wcel cA c0 cif vx cv coa co wceq vx cv cB wcel cA cA com wcel cA c0 cif
      wceq cA vx cv coa co cA com wcel cA c0 cif vx cv coa co vy cv cA cA com
      wcel cA c0 cif vx cv coa opreq1 eqeq2d anbi2d opabbidv cB cA cB coa co cA
      cdif vx cv cB wcel vy cv cA vx cv coa co wceq wa vx vy copab vx cv cB
      wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq1
      syl cA cA com wcel cA c0 cif wceq cA cB coa co cA cdif cA com wcel cA c0
      cif cB coa co cA com wcel cA c0 cif cdif wceq cB cA cB coa co cA cdif vx
      cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      wf1o cB cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv
      cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o
      wb cA cA com wcel cA c0 cif wceq cA cB coa co cA cdif cA com wcel cA c0
      cif cB coa co cA cdif cA com wcel cA c0 cif cB coa co cA com wcel cA c0
      cif cdif cA cA com wcel cA c0 cif wceq cA cB coa co cA com wcel cA c0 cif
      cB coa co cA cA cA com wcel cA c0 cif cB coa opreq1 difeq1d cA cA com
      wcel cA c0 cif cA com wcel cA c0 cif cB coa co difeq2 eqtrd cA cB coa co
      cA cdif cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif cB vx
      cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      f1oeq3 syl bitrd cB cB com wcel cB c0 cif wceq cB cA com wcel cA c0 cif
      cB coa co cA com wcel cA c0 cif cdif vx cv cB wcel vy cv cA com wcel cA
      c0 cif vx cv coa co wceq wa vx vy copab wf1o cB cA com wcel cA c0 cif cB
      coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv
      cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cB com wcel
      cB c0 cif cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx
      cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co
      wceq wa vx vy copab wf1o cB com wcel cB c0 cif cA com wcel cA c0 cif cB
      com wcel cB c0 cif coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB
      c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      wf1o cB cB com wcel cB c0 cif wceq vx cv cB wcel vy cv cA com wcel cA c0
      cif vx cv coa co wceq wa vx vy copab vx cv cB com wcel cB c0 cif wcel vy
      cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wceq cB cA com
      wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv cB wcel vy cv
      cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cB cA com
      wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB
      c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      wf1o wb cB cB com wcel cB c0 cif wceq vx cv cB wcel vy cv cA com wcel cA
      c0 cif vx cv coa co wceq wa vx cv cB com wcel cB c0 cif wcel vy cv cA com
      wcel cA c0 cif vx cv coa co wceq wa vx vy cB cB com wcel cB c0 cif wceq
      vx cv cB wcel vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0
      cif vx cv coa co wceq cB cB com wcel cB c0 cif vx cv eleq2 anbi1d
      opabbidv cB cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx
      cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co
      wceq wa vx vy copab f1oeq1 syl cB cB com wcel cB c0 cif cA com wcel cA c0
      cif cB coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel
      vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq2 cB cB
      com wcel cB c0 cif wceq cA com wcel cA c0 cif cB coa co cA com wcel cA c0
      cif cdif cA com wcel cA c0 cif cB com wcel cB c0 cif coa co cA com wcel
      cA c0 cif cdif wceq cB com wcel cB c0 cif cA com wcel cA c0 cif cB coa co
      cA com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv cA com
      wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cB com wcel cB c0
      cif cA com wcel cA c0 cif cB com wcel cB c0 cif coa co cA com wcel cA c0
      cif cdif vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx
      cv coa co wceq wa vx vy copab wf1o wb cB cB com wcel cB c0 cif wceq cA
      com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cB com wcel cB c0 cif
      coa co cA com wcel cA c0 cif cB cB com wcel cB c0 cif cA com wcel cA c0
      cif coa opreq2 difeq1d cA com wcel cA c0 cif cB coa co cA com wcel cA c0
      cif cdif cA com wcel cA c0 cif cB com wcel cB c0 cif coa co cA com wcel
      cA c0 cif cdif cB com wcel cB c0 cif vx cv cB com wcel cB c0 cif wcel vy
      cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq3 syl
      3bitrd vx vy cA com wcel cA c0 cif cB com wcel cB c0 cif vx cv cB com
      wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx
      vy copab cA c0 com peano1 elimel cB c0 com peano1 elimel vx cv cB com
      wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx
      vy copab eqid unfilem2 dedth2h cB cA cB coa co cA cdif vx cv cB wcel vy
      cv cA vx cv coa co wceq wa vx vy copab f1ofn syl cB com vx cv cB wcel vy
      cv cA vx cv coa co wceq wa vx vy copab fnex sylancom cA com wcel cB com
      wcel cB cA cB coa co cA cdif vx cv cB wcel vy cv cA vx cv coa co wceq wa
      vx vy copab wf1o cB cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif
      cdif vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy
      copab wf1o cB com wcel cB c0 cif cA com wcel cA c0 cif cB com wcel cB c0
      cif coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy
      cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cA cB c0
      c0 cA cA com wcel cA c0 cif wceq cB cA cB coa co cA cdif vx cv cB wcel vy
      cv cA vx cv coa co wceq wa vx vy copab wf1o cB cA cB coa co cA cdif vx cv
      cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o
      cB cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv cB
      wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cA
      cA com wcel cA c0 cif wceq vx cv cB wcel vy cv cA vx cv coa co wceq wa vx
      vy copab vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa
      vx vy copab wceq cB cA cB coa co cA cdif vx cv cB wcel vy cv cA vx cv coa
      co wceq wa vx vy copab wf1o cB cA cB coa co cA cdif vx cv cB wcel vy cv
      cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o wb cA cA com
      wcel cA c0 cif wceq vx cv cB wcel vy cv cA vx cv coa co wceq wa vx cv cB
      wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy cA cA com
      wcel cA c0 cif wceq vy cv cA vx cv coa co wceq vy cv cA com wcel cA c0
      cif vx cv coa co wceq vx cv cB wcel cA cA com wcel cA c0 cif wceq cA vx
      cv coa co cA com wcel cA c0 cif vx cv coa co vy cv cA cA com wcel cA c0
      cif vx cv coa opreq1 eqeq2d anbi2d opabbidv cB cA cB coa co cA cdif vx cv
      cB wcel vy cv cA vx cv coa co wceq wa vx vy copab vx cv cB wcel vy cv cA
      com wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq1 syl cA cA com
      wcel cA c0 cif wceq cA cB coa co cA cdif cA com wcel cA c0 cif cB coa co
      cA com wcel cA c0 cif cdif wceq cB cA cB coa co cA cdif vx cv cB wcel vy
      cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cB cA com
      wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv cB wcel vy cv
      cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o wb cA cA com
      wcel cA c0 cif wceq cA cB coa co cA cdif cA com wcel cA c0 cif cB coa co
      cA cdif cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif cA cA
      com wcel cA c0 cif wceq cA cB coa co cA com wcel cA c0 cif cB coa co cA
      cA cA com wcel cA c0 cif cB coa opreq1 difeq1d cA cA com wcel cA c0 cif
      cA com wcel cA c0 cif cB coa co difeq2 eqtrd cA cB coa co cA cdif cA com
      wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif cB vx cv cB wcel vy
      cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq3 syl
      bitrd cB cB com wcel cB c0 cif wceq cB cA com wcel cA c0 cif cB coa co cA
      com wcel cA c0 cif cdif vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv
      coa co wceq wa vx vy copab wf1o cB cA com wcel cA c0 cif cB coa co cA com
      wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA
      c0 cif vx cv coa co wceq wa vx vy copab wf1o cB com wcel cB c0 cif cA com
      wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB
      c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      wf1o cB com wcel cB c0 cif cA com wcel cA c0 cif cB com wcel cB c0 cif
      coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv
      cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o cB cB com
      wcel cB c0 cif wceq vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa
      co wceq wa vx vy copab vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel
      cA c0 cif vx cv coa co wceq wa vx vy copab wceq cB cA com wcel cA c0 cif
      cB coa co cA com wcel cA c0 cif cdif vx cv cB wcel vy cv cA com wcel cA
      c0 cif vx cv coa co wceq wa vx vy copab wf1o cB cA com wcel cA c0 cif cB
      coa co cA com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv
      cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab wf1o wb cB cB com
      wcel cB c0 cif wceq vx cv cB wcel vy cv cA com wcel cA c0 cif vx cv coa
      co wceq wa vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif
      vx cv coa co wceq wa vx vy cB cB com wcel cB c0 cif wceq vx cv cB wcel vx
      cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co
      wceq cB cB com wcel cB c0 cif vx cv eleq2 anbi1d opabbidv cB cA com wcel
      cA c0 cif cB coa co cA com wcel cA c0 cif cdif vx cv cB wcel vy cv cA com
      wcel cA c0 cif vx cv coa co wceq wa vx vy copab vx cv cB com wcel cB c0
      cif wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab
      f1oeq1 syl cB cB com wcel cB c0 cif cA com wcel cA c0 cif cB coa co cA
      com wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv cA com
      wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq2 cB cB com wcel cB
      c0 cif wceq cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif cA
      com wcel cA c0 cif cB com wcel cB c0 cif coa co cA com wcel cA c0 cif
      cdif wceq cB com wcel cB c0 cif cA com wcel cA c0 cif cB coa co cA com
      wcel cA c0 cif cdif vx cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA
      c0 cif vx cv coa co wceq wa vx vy copab wf1o cB com wcel cB c0 cif cA com
      wcel cA c0 cif cB com wcel cB c0 cif coa co cA com wcel cA c0 cif cdif vx
      cv cB com wcel cB c0 cif wcel vy cv cA com wcel cA c0 cif vx cv coa co
      wceq wa vx vy copab wf1o wb cB cB com wcel cB c0 cif wceq cA com wcel cA
      c0 cif cB coa co cA com wcel cA c0 cif cB com wcel cB c0 cif coa co cA
      com wcel cA c0 cif cB cB com wcel cB c0 cif cA com wcel cA c0 cif coa
      opreq2 difeq1d cA com wcel cA c0 cif cB coa co cA com wcel cA c0 cif cdif
      cA com wcel cA c0 cif cB com wcel cB c0 cif coa co cA com wcel cA c0 cif
      cdif cB com wcel cB c0 cif vx cv cB com wcel cB c0 cif wcel vy cv cA com
      wcel cA c0 cif vx cv coa co wceq wa vx vy copab f1oeq3 syl 3bitrd vx vy
      cA com wcel cA c0 cif cB com wcel cB c0 cif vx cv cB com wcel cB c0 cif
      wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab cA c0
      com peano1 elimel cB c0 com peano1 elimel vx cv cB com wcel cB c0 cif
      wcel vy cv cA com wcel cA c0 cif vx cv coa co wceq wa vx vy copab eqid
      unfilem2 dedth2h sylc cB cA cB coa co cA cdif vf cA cB coa co cvv wcel cA
      cB coa co cA cdif cvv wcel cA cB coa oprex cA cB coa co cA cvv difexg
      ax-mp bren sylibr $.
      $( [16-Nov-2002] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The union of two finite sets is finite.  Part of Corollary 6K of
       [Enderton] p. 144. $)
    unfi $p |- ( ( A e. Fin /\ B e. Fin ) -> ( A u. B ) e. Fin ) $=
      cA cfn wcel cB cA cdif cfn wcel cA cB cun cfn wcel cB cfn wcel cA cfn
      wcel cB cA cdif cfn wcel wa cA vx cv cen wbr cB cA cdif vy cv cen wbr wa
      vy com wrex vx com wrex cA cB cun cfn wcel cA vx cv cen wbr cB cA cdif vy
      cv cen wbr wa vy com wrex vx com wrex cA vx cv cen wbr vx com wrex cB cA
      cdif vy cv cen wbr vy com wrex wa cA cfn wcel cB cA cdif cfn wcel wa cA
      vx cv cen wbr cB cA cdif vy cv cen wbr vx vy com com reeanv cA cfn wcel
      cA vx cv cen wbr vx com wrex cB cA cdif cfn wcel cB cA cdif vy cv cen wbr
      vy com wrex vx cA isfi vy cB cA cdif isfi anbi12i bitr4i cA vx cv cen wbr
      cB cA cdif vy cv cen wbr wa cA cB cun cfn wcel vx vy com com vx cv com
      wcel vy cv com wcel wa cA vx cv cen wbr cB cA cdif vy cv cen wbr wa cA cB
      cun vx cv vy cv coa co cen wbr cA cB cun cfn wcel vx cv com wcel vy cv
      com wcel wa cA vx cv cen wbr cB cA cdif vx cv vy cv coa co vx cv cdif cen
      wbr cA cB cun vx cv vy cv coa co cen wbr cB cA cdif vy cv cen wbr vx cv
      com wcel vy cv com wcel wa cA cB cA cdif cun vx cv vx cv vy cv coa co vx
      cv cdif cun cen wbr cA cB cun vx cv vy cv coa co cen wbr cA vx cv cen wbr
      cB cA cdif vx cv vy cv coa co vx cv cdif cen wbr wa vx cv com wcel vy cv
      com wcel wa cA cB cA cdif cun cA cB cun vx cv vx cv vy cv coa co vx cv
      cdif cun vx cv vy cv coa co cen cA cB cA cdif cun cA cB cun wceq vx cv
      com wcel vy cv com wcel wa cA cB undif2 a1i vx cv com wcel vy cv com wcel
      wa vx cv vx cv vy cv coa co wss vx cv vx cv vy cv coa co vx cv cdif cun
      vx cv vy cv coa co wceq vx cv vy cv nnaword1 vx cv vx cv vy cv coa co
      undif sylib breq12d cA vx cv cen wbr cB cA cdif vx cv vy cv coa co vx cv
      cdif cen wbr wa cA cB cA cdif cin c0 wceq vx cv vx cv vy cv coa co vx cv
      cdif cin c0 wceq cA cB cA cdif cun vx cv vx cv vy cv coa co vx cv cdif
      cun cen wbr cA cB difdisj vx cv vx cv vy cv coa co difdisj cA vx cv cB cA
      cdif vx cv vy cv coa co vx cv cdif unen mpanr12 syl5bi vx cv com wcel vy
      cv com wcel wa vy cv vx cv vy cv coa co vx cv cdif cen wbr cB cA cdif vy
      cv cen wbr cB cA cdif vx cv vy cv coa co vx cv cdif cen wbr wi vx cv vy
      cv unfilem3 cB cA cdif vy cv cen wbr vy cv vx cv vy cv coa co vx cv cdif
      cen wbr cB cA cdif vx cv vy cv coa co vx cv cdif cen wbr cB cA cdif vy cv
      vx cv vy cv coa co vx cv cdif entr expcom syl sylan2d vx cv com wcel vy
      cv com wcel wa vx cv vy cv coa co com wcel cA cB cun vx cv vy cv coa co
      cen wbr cA cB cun cfn wcel wi vx cv vy cv nnacl vx cv vy cv coa co com
      wcel cA cB cun vx cv vy cv coa co cen wbr cA cB cun cfn wcel vx cv vy cv
      coa co com wcel cA cB cun vx cv vy cv coa co cen wbr wa cA cB cun vz cv
      cen wbr vz com wrex cA cB cun cfn wcel cA cB cun vz cv cen wbr cA cB cun
      vx cv vy cv coa co cen wbr vz vx cv vy cv coa co com vz cv vx cv vy cv
      coa co cA cB cun cen breq2 rcla4ev vz cA cB cun isfi sylibr ex syl syld
      r19.23aivv sylbir cB cfn wcel cB cA cdif cB wss cB cA cdif cfn wcel cB cA
      difss cB cB cA cdif ssfi mpan2 sylan2 $.
      $( [30-Aug-2008] $) $( [16-Nov-2002] $)
  $}

  $( The union of two finite sets is finite.  Part of Corollary 6K of
     [Enderton] p. 144.  This version of ~ unfi is useful only if we assume
     the Axiom of Infinity (see comments in ~ fin2inf ). $)
  unfi2 $p |- ( ( A ~< om /\ B ~< om ) -> ( A u. B ) ~< om ) $=
    cA com csdm wbr cB com csdm wbr wa cA cB cun com cdom wbr cA cB cun com cen
    wbr wn wa cA cB cun com csdm wbr cA com csdm wbr cB com csdm wbr wa cA cB
    cun com cdom wbr com cA cB cun cen wbr wn wa cA cB cun com cdom wbr cA cB
    cun com cen wbr wn wa cA com csdm wbr cB com csdm wbr wa cA cB cun cfn wcel
    cA cB cun com cdom wbr com cA cB cun cen wbr wn wa cA cfn wcel cB cfn wcel
    cA cB cun cfn wcel cA com csdm wbr cB com csdm wbr cA cB unfi cA isfinite2
    cB isfinite2 syl2an cA cB cun isfinite1 syl cA com csdm wbr cB com csdm wbr
    wa com cA cB cun cen wbr wn cA cB cun com cen wbr wn cA cB cun com cdom wbr
    cA com csdm wbr com cA cB cun cen wbr wn cA cB cun com cen wbr wn wi cB com
    csdm wbr cA com csdm wbr cA cB cun com cen wbr com cA cB cun cen wbr cA com
    csdm wbr com cvv wcel cA cB cun com cen wbr com cA cB cun cen wbr wi cA
    fin2inf cA cB cun com cvv ensymg syl con3d adantr anim2d mpd cA cB cun com
    brsdom sylibr $.
    $( [15-Sep-2008] $) $( [22-Oct-2004] $)

  ${
    $d x A $.
    infcntss.1 $e |- A e. _V $.
    $( Every infinite set has a denumerable subset.  Similar to Exercise 8 of
       [TakeutiZaring] p. 91. (However, we need neither AC nor the Axiom of
       Infinity because of the way we express "infinite" in the antecedent.) $)
    infcntss $p |- ( om ~<_ A -> E. x ( x C_ A /\ x ~~ om ) ) $=
      com cA cdom wbr com vx cv cen wbr vx cv cA wss wa vx wex vx cv cA wss vx
      cv com cen wbr wa vx wex vx com cA infcntss.1 domen com vx cv cen wbr vx
      cv cA wss wa vx cv cA wss vx cv com cen wbr wa vx vx cv cA wss com vx cv
      cen wbr vx cv cA wss vx cv com cen wbr wa com vx cv cen wbr vx cv com cen
      wbr vx cv cA wss com vx cv vx visset ensym anim2i ancoms 19.22i sylbi $.
      $( [2-Nov-2004] $) $( [23-Oct-2004] $)
  $}

  $( An unordered pair is finite. $)
  prfi $p |- { A , B } e. Fin $=
    cA cB cpr cA csn cB csn cun cfn cA cB df-pr cA csn cfn wcel cB csn cfn wcel
    cA csn cB csn cun cfn wcel cA snfi cB snfi cA csn cB csn unfi mp2an eqeltri
    $.
    $( [31-Aug-2008] $) $( [22-Aug-2008] $)

  ${
    $d f j k m x y z A $.
    $( The finite union of finite sets is finite.  Exercise 13 of [Enderton]
       p. 144. $)
    unifi $p |- ( ( A e. Fin /\ A. x e. A x e. Fin ) -> U. A e. Fin ) $=
      cA cfn wcel vx cv cfn wcel vx cA wral cA cuni cfn wcel cA cfn wcel cA vm
      cv cen wbr vm com wrex vx cv cfn wcel vx cA wral cA cuni cfn wcel wi vm
      cA isfi cA vm cv cen wbr vx cv cfn wcel vx cA wral cA cuni cfn wcel wi vm
      com vm cv com wcel vy cv vm cv cen wbr vx cv cfn wcel vx vy cv wral wa vy
      cv cuni cfn wcel wi vy wal cA vm cv cen wbr vx cv cfn wcel vx cA wral cA
      cuni cfn wcel wi wi vy cv vm cv cen wbr vx cv cfn wcel vx vy cv wral wa
      vy cv cuni cfn wcel wi vy wal vy cv c0 cen wbr vx cv cfn wcel vx vy cv
      wral wa vy cv cuni cfn wcel wi vy wal vy cv vk cv cen wbr vx cv cfn wcel
      vx vy cv wral wa vy cv cuni cfn wcel wi vy wal vy cv vk cv csuc cen wbr
      vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn wcel wi vy wal vm vk vm cv
      c0 wceq vy cv vm cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni
      cfn wcel wi vy cv c0 cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni
      cfn wcel wi vy vm cv c0 wceq vy cv vm cv cen wbr vx cv cfn wcel vx vy cv
      wral wa vy cv c0 cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn
      wcel vm cv c0 wceq vy cv vm cv cen wbr vy cv c0 cen wbr vx cv cfn wcel vx
      vy cv wral vm cv c0 vy cv cen breq2 anbi1d imbi1d albidv vm cv vk cv wceq
      vy cv vm cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn wcel
      wi vy cv vk cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn
      wcel wi vy vm cv vk cv wceq vy cv vm cv cen wbr vx cv cfn wcel vx vy cv
      wral wa vy cv vk cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni
      cfn wcel vm cv vk cv wceq vy cv vm cv cen wbr vy cv vk cv cen wbr vx cv
      cfn wcel vx vy cv wral vm cv vk cv vy cv cen breq2 anbi1d imbi1d albidv
      vm cv vk cv csuc wceq vy cv vm cv cen wbr vx cv cfn wcel vx vy cv wral wa
      vy cv cuni cfn wcel wi vy cv vk cv csuc cen wbr vx cv cfn wcel vx vy cv
      wral wa vy cv cuni cfn wcel wi vy vm cv vk cv csuc wceq vy cv vm cv cen
      wbr vx cv cfn wcel vx vy cv wral wa vy cv vk cv csuc cen wbr vx cv cfn
      wcel vx vy cv wral wa vy cv cuni cfn wcel vm cv vk cv csuc wceq vy cv vm
      cv cen wbr vy cv vk cv csuc cen wbr vx cv cfn wcel vx vy cv wral vm cv vk
      cv csuc vy cv cen breq2 anbi1d imbi1d albidv vy cv c0 cen wbr vx cv cfn
      wcel vx vy cv wral wa vy cv cuni cfn wcel wi vy vy cv c0 cen wbr vy cv
      cuni cfn wcel vx cv cfn wcel vx vy cv wral vy cv c0 cen wbr vy cv c0 wceq
      vy cv cuni cfn wcel vy cv en0 vy cv c0 wceq vy cv cuni c0 cfn vy cv c0
      wceq vy cv cuni c0 cuni c0 vy cv c0 unieq uni0 syl6eq c0 com wcel c0 c0
      wss c0 cfn wcel peano1 c0 ssid c0 c0 ssnnfi mp2an syl6eqel sylbi adantr
      ax-gen vy cv vk cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn
      wcel wi vy wal vy cv vk cv csuc cen wbr vx cv cfn wcel vx vy cv wral wa
      vy cv cuni cfn wcel wi vy wal wi vk cv com wcel vy cv vk cv cen wbr vx cv
      cfn wcel vx vy cv wral wa vy cv cuni cfn wcel wi vy wal vz cv vk cv cen
      wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vy cv
      vk cv csuc cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn wcel wi
      vy wal vy cv vk cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn
      wcel wi vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni
      cfn wcel wi vy vz vy cv vz cv wceq vy cv vk cv cen wbr vx cv cfn wcel vx
      vy cv wral wa vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa vy cv
      cuni cfn wcel vz cv cuni cfn wcel vy cv vz cv wceq vy cv vk cv cen wbr vz
      cv vk cv cen wbr vx cv cfn wcel vx vy cv wral vx cv cfn wcel vx vz cv
      wral vy cv vz cv vk cv cen breq1 vx cv cfn wcel vx vy cv vz cv raleq1
      anbi12d vy cv vz cv wceq vy cv cuni vz cv cuni cfn vy cv vz cv unieq
      eleq1d imbi12d cbvalv vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa
      vz cv cuni cfn wcel wi vz wal vy cv vk cv csuc cen wbr vx cv cfn wcel vx
      vy cv wral wa vy cv cuni cfn wcel wi vy vz cv vk cv cen wbr vx cv cfn
      wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vy cv vk cv csuc cen
      wbr vx cv cfn wcel vx vy cv wral vy cv cuni cfn wcel vy cv vk cv csuc cen
      wbr vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn
      wcel wi vz wal vx cv cfn wcel vx vy cv wral vy cv cuni cfn wcel wi vy cv
      vk cv csuc cen wbr vk cv csuc vy cv vf cv wf1o vf wex vz cv vk cv cen wbr
      vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vx cv cfn
      wcel vx vy cv wral vy cv cuni cfn wcel wi wi vy cv vk cv csuc cen wbr vk
      cv csuc vy cv cen wbr vk cv csuc vy cv vf cv wf1o vf wex vy cv vk cv csuc
      vk cv vk visset sucex ensym vk cv csuc vy cv vf vy visset bren sylib vk
      cv csuc vy cv vf cv wf1o vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral
      wa vz cv cuni cfn wcel wi vz wal vx cv cfn wcel vx vy cv wral vy cv cuni
      cfn wcel wi wi vf vk cv csuc vy cv vf cv wf1o vz cv vk cv cen wbr vx cv
      cfn wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vx cv cfn wcel vx
      vy cv wral vy cv cuni cfn wcel vk cv csuc vy cv vf cv wf1o vz cv vk cv
      cen wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vx
      cv cfn wcel vx vy cv wral wa wa vf cv vk cv cima cuni vk cv vf cv cfv cun
      cfn wcel vy cv cuni cfn wcel vf cv vk cv cima cuni cfn wcel vk cv vf cv
      cfv cfn wcel vf cv vk cv cima cuni vk cv vf cv cfv cun cfn wcel vk cv
      csuc vy cv vf cv wf1o vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa
      vz cv cuni cfn wcel wi vz wal vx cv cfn wcel vx vy cv wral wa wa vf cv vk
      cv cima cuni vk cv vf cv cfv unfi vz cv vk cv cen wbr vx cv cfn wcel vx
      vz cv wral wa vz cv cuni cfn wcel wi vz wal vk cv csuc vy cv vf cv wf1o
      vx cv cfn wcel vx vy cv wral vf cv vk cv cima cuni cfn wcel vz cv vk cv
      cen wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vf
      cv vk cv cima vk cv cen wbr vx cv cfn wcel vx vf cv vk cv cima wral wa vf
      cv vk cv cima cuni cfn wcel vk cv csuc vy cv vf cv wf1o vx cv cfn wcel vx
      vy cv wral wa vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa vz cv
      cuni cfn wcel wi vz wal vf cv vk cv cima vk cv cen wbr vx cv cfn wcel vx
      vf cv vk cv cima wral wa vf cv vk cv cima cuni cfn wcel vz cv vk cv cen
      wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn wcel wi vf cv vk cv
      cima vk cv cen wbr vx cv cfn wcel vx vf cv vk cv cima wral wa vf cv vk cv
      cima cuni cfn wcel wi vz vf cv vk cv cima vf cv cvv wcel vf cv vk cv cima
      cvv wcel vf visset vf cv vk cv cvv imaexg ax-mp vz cv vf cv vk cv cima
      wceq vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa vf cv vk cv cima
      vk cv cen wbr vx cv cfn wcel vx vf cv vk cv cima wral wa vz cv cuni cfn
      wcel vf cv vk cv cima cuni cfn wcel vz cv vf cv vk cv cima wceq vz cv vk
      cv cen wbr vf cv vk cv cima vk cv cen wbr vx cv cfn wcel vx vz cv wral vx
      cv cfn wcel vx vf cv vk cv cima wral vz cv vf cv vk cv cima vk cv cen
      breq1 vx cv cfn wcel vx vz cv vf cv vk cv cima raleq1 anbi12d vz cv vf cv
      vk cv cima wceq vz cv cuni vf cv vk cv cima cuni cfn vz cv vf cv vk cv
      cima unieq eleq1d imbi12d cla4v imp vk cv csuc vy cv vf cv wf1o vx cv cfn
      wcel vx vy cv wral wa vf cv vk cv cima vk cv cen wbr vx cv cfn wcel vx vf
      cv vk cv cima wral vk cv csuc vy cv vf cv wf1o vf cv vk cv cima vk cv cen
      wbr vx cv cfn wcel vx vy cv wral vk cv csuc vy cv vf cv wf1o vk cv vf cv
      vk cv cima cen wbr vf cv vk cv cima vk cv cen wbr vk cv csuc vy cv vf cv
      wf1o vk cv csuc vy cv vf cv wf1 vk cv vf cv vk cv cima vf cv vk cv cres
      wf1o vk cv vf cv vk cv cima cen wbr vk cv csuc vy cv vf cv f1of1 vk cv
      csuc vy cv vf cv wf1 vk cv vk cv csuc wss vk cv vf cv vk cv cima vf cv vk
      cv cres wf1o vk cv sssucid vk cv csuc vy cv vk cv vf cv f1ores mpan2 vk
      cv vf cv vk cv cima vf cv vk cv cres vk visset f1oen 3syl vk cv vf cv vk
      cv cima vf cv cvv wcel vf cv vk cv cima cvv wcel vf visset vf cv vk cv
      cvv imaexg ax-mp ensym syl adantr vk cv csuc vy cv vf cv wf1o vx cv cfn
      wcel vx vy cv wral vx cv cfn wcel vx vf cv vk cv cima wral vk cv csuc vy
      cv vf cv wf1o vf cv vk cv cima vy cv wss vx cv cfn wcel vx vy cv wral vx
      cv cfn wcel vx vf cv vk cv cima wral wi vk cv csuc vy cv vf cv wf1o vf cv
      vk cv cima vf cv vk cv cima vk cv vf cv cfv csn cun vy cv vf cv vk cv
      cima vf cv vk cv cima vk cv vf cv cfv csn cun wss vk cv csuc vy cv vf cv
      wf1o vf cv vk cv cima vk cv vf cv cfv csn ssun1 a1i vk cv csuc vy cv vf
      cv wf1o vf cv vk cv cima vk cv vf cv cfv csn cun vf cv vk cv csuc cima vy
      cv vk cv csuc vy cv vf cv wf1o vf cv vk cv cima vk cv vf cv cfv csn cun
      vf cv vk cv cima vf cv vk cv csn cima cun vf cv vk cv csuc cima vk cv
      csuc vy cv vf cv wf1o vk cv vf cv cfv csn vf cv vk cv csn cima vf cv vk
      cv cima vf cv vk cv csuc wfn vk cv vk cv csuc wcel vk cv vf cv cfv csn vf
      cv vk cv csn cima wceq vk cv csuc vy cv vf cv wf1o vk cv csuc vk cv vf cv
      fnsnfv vk cv csuc vy cv vf cv f1ofn vk cv vk visset sucid sylancl uneq2d
      vf cv vk cv csuc cima vf cv vk cv vk cv csn cun cima vf cv vk cv cima vf
      cv vk cv csn cima cun vk cv csuc vk cv vk cv csn cun vf cv vk cv df-suc
      imaeq2i vf cv vk cv vk cv csn imaundi eqtr2i syl6eq vk cv csuc vy cv vf
      cv wf1o vk cv csuc vy cv vf cv wfo vf cv vk cv csuc cima vy cv wceq vk cv
      csuc vy cv vf cv f1ofo vk cv csuc vy cv vf cv foima syl eqtrd sseqtrd vx
      cv cfn wcel vx vf cv vk cv cima vy cv ssralv syl imp jca sylan2 an1s vk
      cv csuc vy cv vf cv wf1o vx cv cfn wcel vx vy cv wral vk cv vf cv cfv cfn
      wcel vz cv vk cv cen wbr vx cv cfn wcel vx vz cv wral wa vz cv cuni cfn
      wcel wi vz wal vk cv vf cv cfv vy cv wcel vx cv cfn wcel vx vy cv wral vk
      cv vf cv cfv cfn wcel vk cv csuc vy cv vf cv wf1o vx cv cfn wcel vk cv vf
      cv cfv cfn wcel vx vk cv vf cv cfv vy cv vx cv vk cv vf cv cfv cfn eleq1
      rcla4va vk cv csuc vy cv vf cv wf vk cv vk cv csuc wcel vk cv vf cv cfv
      vy cv wcel vk cv csuc vy cv vf cv wf1o vk cv csuc vy cv vk cv vf cv
      ffvelrn vk cv csuc vy cv vf cv f1of vk cv vk visset sucid sylancl sylan
      adantrl sylanc vk cv csuc vy cv vf cv wf1o vf cv vk cv cima cuni vk cv vf
      cv cfv cun cfn wcel vy cv cuni cfn wcel wb vz cv vk cv cen wbr vx cv cfn
      wcel vx vz cv wral wa vz cv cuni cfn wcel wi vz wal vx cv cfn wcel vx vy
      cv wral wa vk cv csuc vy cv vf cv wf1o vf cv vk cv cima cuni vk cv vf cv
      cfv cun vy cv cuni cfn vk cv csuc vy cv vf cv wf1o vf cv vk cv cima vk cv
      vf cv cfv csn cun cuni vy cv cuni vf cv vk cv cima cuni vk cv vf cv cfv
      cun vk cv csuc vy cv vf cv wf1o vf cv vk cv cima vk cv vf cv cfv csn cun
      vy cv vk cv csuc vy cv vf cv wf1o vf cv vk cv cima vk cv vf cv cfv csn
      cun vf cv vk cv csuc cima vy cv vk cv csuc vy cv vf cv wf1o vf cv vk cv
      cima vk cv vf cv cfv csn cun vf cv vk cv cima vf cv vk cv csn cima cun vf
      cv vk cv csuc cima vk cv csuc vy cv vf cv wf1o vk cv vf cv cfv csn vf cv
      vk cv csn cima vf cv vk cv cima vf cv vk cv csuc wfn vk cv vk cv csuc
      wcel vk cv vf cv cfv csn vf cv vk cv csn cima wceq vk cv csuc vy cv vf cv
      wf1o vk cv csuc vk cv vf cv fnsnfv vk cv csuc vy cv vf cv f1ofn vk cv vk
      visset sucid sylancl uneq2d vf cv vk cv csuc cima vf cv vk cv vk cv csn
      cun cima vf cv vk cv cima vf cv vk cv csn cima cun vk cv csuc vk cv vk cv
      csn cun vf cv vk cv df-suc imaeq2i vf cv vk cv vk cv csn imaundi eqtr2i
      syl6eq vk cv csuc vy cv vf cv wf1o vk cv csuc vy cv vf cv wfo vf cv vk cv
      csuc cima vy cv wceq vk cv csuc vy cv vf cv f1ofo vk cv csuc vy cv vf cv
      foima syl eqtrd unieqd vf cv vk cv cima vk cv vf cv cfv csn cun cuni vf
      cv vk cv cima cuni vk cv vf cv cfv csn cuni cun vf cv vk cv cima cuni vk
      cv vf cv cfv cun vf cv vk cv cima vk cv vf cv cfv csn uniun vk cv vf cv
      cfv csn cuni vk cv vf cv cfv vf cv vk cv cima cuni vk cv vf cv cfv vk cv
      vf cv fvex unisn uneq2i eqtr2i syl5eq eleq1d adantr mpbid exp32 19.23aiv
      syl com12 imp3a 19.21aiv sylbi a1i finds1 vy cv vm cv cen wbr vx cv cfn
      wcel vx vy cv wral wa vy cv cuni cfn wcel wi vy wal cA vm cv cen wbr vx
      cv cfn wcel vx cA wral cA cuni cfn wcel wi cA vm cv cen wbr cA cvv wcel
      vy cv vm cv cen wbr vx cv cfn wcel vx vy cv wral wa vy cv cuni cfn wcel
      wi vy wal cA vm cv cen wbr vx cv cfn wcel vx cA wral cA cuni cfn wcel wi
      wi wi cA vm cv cen relen brrelexi cA cvv wcel vy cv vm cv cen wbr vx cv
      cfn wcel vx vy cv wral wa vy cv cuni cfn wcel wi vy wal cA vm cv cen wbr
      vx cv cfn wcel vx cA wral cA cuni cfn wcel vy cv vm cv cen wbr vx cv cfn
      wcel vx vy cv wral wa vy cv cuni cfn wcel wi cA vm cv cen wbr vx cv cfn
      wcel vx cA wral wa cA cuni cfn wcel wi vy cA cvv vy cv cA wceq vy cv vm
      cv cen wbr vx cv cfn wcel vx vy cv wral wa cA vm cv cen wbr vx cv cfn
      wcel vx cA wral wa vy cv cuni cfn wcel cA cuni cfn wcel vy cv cA wceq vy
      cv vm cv cen wbr cA vm cv cen wbr vx cv cfn wcel vx vy cv wral vx cv cfn
      wcel vx cA wral vy cv cA vm cv cen breq1 vx cv cfn wcel vx vy cv cA
      raleq1 anbi12d vy cv cA wceq vy cv cuni cA cuni cfn vy cv cA unieq eleq1d
      imbi12d cla4gv exp4a syl pm2.43b syl r19.23aiv sylbi imp $.
      $( [26-Sep-2008] $) $( [22-Aug-2008] $)

    $( The finite union of finite sets is finite.  Exercise 13 of [Enderton]
       p. 144.  This version of ~ unifi is useful only if we assume the Axiom
       of Infinity (see comments in ~ fin2inf ). $)
    unifi2 $p |- ( ( A ~< om /\ A. x e. A x ~< om ) -> U. A ~< om ) $=
      cA com csdm wbr vx cv com csdm wbr vx cA wral wa cA cuni com cdom wbr cA
      cuni com cen wbr wn wa cA cuni com csdm wbr cA com csdm wbr vx cv com
      csdm wbr vx cA wral wa cA cuni com cdom wbr com cA cuni cen wbr wn wa cA
      cuni com cdom wbr cA cuni com cen wbr wn wa cA com csdm wbr vx cv com
      csdm wbr vx cA wral wa cA cuni cfn wcel cA cuni com cdom wbr com cA cuni
      cen wbr wn wa cA cfn wcel vx cv cfn wcel vx cA wral cA cuni cfn wcel cA
      com csdm wbr vx cv com csdm wbr vx cA wral vx cA unifi cA isfinite2 vx cv
      com csdm wbr vx cv cfn wcel vx cA vx cv isfinite2 r19.20si syl2an cA cuni
      isfinite1 syl cA com csdm wbr vx cv com csdm wbr vx cA wral wa com cA
      cuni cen wbr wn cA cuni com cen wbr wn cA cuni com cdom wbr cA com csdm
      wbr com cA cuni cen wbr wn cA cuni com cen wbr wn wi vx cv com csdm wbr
      vx cA wral cA com csdm wbr cA cuni com cen wbr com cA cuni cen wbr cA com
      csdm wbr com cvv wcel cA cuni com cen wbr com cA cuni cen wbr wi cA
      fin2inf cA cuni com cvv ensymg syl con3d adantr anim2d mpd cA cuni com
      brsdom sylibr $.
      $( [28-Sep-2008] $) $( [11-Mar-2006] $)
  $}

  ${
    $d x y z w v f A $.
    $( Equivalent ways of stating the finite intersection property.  We show
       two ways of saying, "the intersection of elements in every finite
       non-empty subcollection of ` A ` is in ` A ` ."  This theorem is
       applicable to a topology, which (among other axioms) is closed under
       finite intersections.  Some texts use the left-hand version of this
       axiom and others the right-hand version, but as our proof here shows,
       their "intuitively obvious" equivalence can be non-trivial to establish
       formally. $)
    fiint $p |- ( A. x e. A A. y e. A ( x i^i y ) e. A <->
  A. x ( ( x C_ A /\ x =/= (/) /\ x e. Fin ) -> |^| x e. A ) ) $=
      vz cv vw cv cin cA wcel vw cA wral vz cA wral vx cv cA wss vx cv c0 wne
      wa vx cv cfn wcel wa vx cv cint cA wcel wi vx wal vx cv vy cv cin cA wcel
      vy cA wral vx cA wral vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv
      cint cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA wral vx
      cv cA wss vx cv c0 wne wa vx cv cfn wcel wa vx cv cint cA wcel wi vx wal
      vz cv vw cv cin cA wcel vw cA wral vz cA wral vx cv cA wss vx cv c0 wne
      wa vx cv cfn wcel wa vx cv cint cA wcel wi vx vz cv vw cv cin cA wcel vw
      cA wral vz cA wral vx cv cA wss vx cv c0 wne wa vx cv cfn wcel vx cv cint
      cA wcel vx cv cfn wcel vx cv cA wss vx cv c0 wne wa vz cv vw cv cin cA
      wcel vw cA wral vz cA wral vx cv cint cA wcel vx cv cfn wcel vx cv vy cv
      cen wbr vy com wrex vx cv cA wss vx cv c0 wne wa vz cv vw cv cin cA wcel
      vw cA wral vz cA wral vx cv cint cA wcel wi wi vy vx cv isfi vx cv vy cv
      cen wbr vx cv cA wss vx cv c0 wne wa vz cv vw cv cin cA wcel vw cA wral
      vz cA wral vx cv cint cA wcel wi wi vy com vy cv com wcel vy cv vx cv cen
      wbr vx cv cA wss vx cv c0 wne wa vz cv vw cv cin cA wcel vw cA wral vz cA
      wral vx cv cint cA wcel wi wi vx cv vy cv cen wbr vy cv com wcel vz cv vw
      cv cin cA wcel vw cA wral vz cA wral vx cv cA wss vx cv c0 wne wa vy cv
      vx cv cen wbr vx cv cint cA wcel vy cv com wcel vz cv vw cv cin cA wcel
      vw cA wral vz cA wral vx cv cA wss vx cv c0 wne wa vy cv vx cv cen wbr vx
      cv cint cA wcel vy cv com wcel vz cv vw cv cin cA wcel vw cA wral vz cA
      wral vx cv cA wss vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv cint cA
      wcel wi vx wal vx cv cA wss vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv
      cint cA wcel wi vx cv cA wss vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv
      cint cA wcel wi vx wal vx cv cA wss vx cv c0 wne wa c0 vx cv cen wbr wa
      vx cv cint cA wcel wi vx wal vx cv cA wss vx cv c0 wne wa vv cv vx cv cen
      wbr wa vx cv cint cA wcel wi vx wal vx cv cA wss vx cv c0 wne wa vv cv
      csuc vx cv cen wbr wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA
      wcel vw cA wral vz cA wral vy vv vy cv c0 wceq vx cv cA wss vx cv c0 wne
      wa vy cv vx cv cen wbr wa vx cv cint cA wcel wi vx cv cA wss vx cv c0 wne
      wa c0 vx cv cen wbr wa vx cv cint cA wcel wi vx vy cv c0 wceq vx cv cA
      wss vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv cA wss vx cv c0 wne wa
      c0 vx cv cen wbr wa vx cv cint cA wcel vy cv c0 wceq vy cv vx cv cen wbr
      c0 vx cv cen wbr vx cv cA wss vx cv c0 wne wa vy cv c0 vx cv cen breq1
      anbi2d imbi1d albidv vy cv vv cv wceq vx cv cA wss vx cv c0 wne wa vy cv
      vx cv cen wbr wa vx cv cint cA wcel wi vx cv cA wss vx cv c0 wne wa vv cv
      vx cv cen wbr wa vx cv cint cA wcel wi vx vy cv vv cv wceq vx cv cA wss
      vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv cA wss vx cv c0 wne wa vv cv
      vx cv cen wbr wa vx cv cint cA wcel vy cv vv cv wceq vy cv vx cv cen wbr
      vv cv vx cv cen wbr vx cv cA wss vx cv c0 wne wa vy cv vv cv vx cv cen
      breq1 anbi2d imbi1d albidv vy cv vv cv csuc wceq vx cv cA wss vx cv c0
      wne wa vy cv vx cv cen wbr wa vx cv cint cA wcel wi vx cv cA wss vx cv c0
      wne wa vv cv csuc vx cv cen wbr wa vx cv cint cA wcel wi vx vy cv vv cv
      csuc wceq vx cv cA wss vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv cA
      wss vx cv c0 wne wa vv cv csuc vx cv cen wbr wa vx cv cint cA wcel vy cv
      vv cv csuc wceq vy cv vx cv cen wbr vv cv csuc vx cv cen wbr vx cv cA wss
      vx cv c0 wne wa vy cv vv cv csuc vx cv cen breq1 anbi2d imbi1d albidv vx
      cv cA wss vx cv c0 wne wa c0 vx cv cen wbr wa vx cv cint cA wcel wi vx
      wal vz cv vw cv cin cA wcel vw cA wral vz cA wral vx cv cA wss vx cv c0
      wne wa c0 vx cv cen wbr wa vx cv cint cA wcel wi vx vx cv cA wss vx cv c0
      wne wa c0 vx cv cen wbr wa vx cv c0 wceq vx cv c0 wne wa vx cv cint cA
      wcel vx cv c0 wne c0 vx cv cen wbr vx cv c0 wceq vx cv c0 wne wa vx cv cA
      wss c0 vx cv cen wbr vx cv c0 wne vx cv c0 wceq vx cv c0 wne wa c0 vx cv
      cen wbr vx cv c0 wceq vx cv c0 wne c0 vx cv cen wbr vx cv c0 cen wbr vx
      cv c0 wceq c0 vx cv vx visset ensym vx cv en0 sylib anim1i ancoms adantll
      vx cv c0 wceq vx cv c0 wceq wn vx cv cint cA wcel vx cv c0 wne vx cv c0
      wceq vx cv c0 wceq wn wa vx cv cint cA wcel vx cv c0 wceq pm3.24 pm2.21i
      vx cv c0 df-ne sylan2b syl ax-gen a1i vz cv vw cv cin cA wcel vw cA wral
      vz cA wral vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint
      cA wcel wi vx wal vx cv cA wss vx cv c0 wne wa vv cv csuc vx cv cen wbr
      wa vx cv cint cA wcel wi vx wal wi wi vv cv com wcel vz cv vw cv cin cA
      wcel vw cA wral vz cA wral vx cv cA wss vx cv c0 wne wa vv cv vx cv cen
      wbr wa vx cv cint cA wcel wi vx wal vx cv cA wss vx cv c0 wne wa vv cv
      csuc vx cv cen wbr wa vx cv cint cA wcel wi vx vz cv vw cv cin cA wcel vw
      cA wral vz cA wral vx ax-17 vx cv cA wss vx cv c0 wne wa vv cv vx cv cen
      wbr wa vx cv cint cA wcel wi vx hba1 vx cv cA wss vx cv c0 wne wa vv cv
      csuc vx cv cen wbr wa vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa
      vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA
      wral vx cv cint cA wcel vx cv cA wss vv cv csuc vx cv cen wbr vx cv cA
      wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA wcel wi vx wal
      vz cv vw cv cin cA wcel vw cA wral vz cA wral vx cv cint cA wcel wi wi vx
      cv c0 wne vx cv cA wss vv cv csuc vx cv cen wbr vx cv cA wss vx cv c0 wne
      wa vv cv vx cv cen wbr wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA
      wcel vw cA wral vz cA wral vx cv cint cA wcel wi wi vx cv cA wss vv cv
      csuc vx cv vf cv wf1o vf wex vx cv cA wss vx cv c0 wne wa vv cv vx cv cen
      wbr wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz
      cA wral vx cv cint cA wcel wi wi vv cv csuc vx cv cen wbr vx cv cA wss vv
      cv csuc vx cv vf cv wf1o vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr
      wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA
      wral vx cv cint cA wcel wi wi vf vx cv cA wss vv cv csuc vx cv vf cv wf1o
      vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA wcel wi
      vx wal vz cv vw cv cin cA wcel vw cA wral vz cA wral vx cv cint cA wcel
      vx cv cA wss vv cv csuc vx cv vf cv wf1o wa vx cv cA wss vx cv c0 wne wa
      vv cv vx cv cen wbr wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA
      wcel vw cA wral vz cA wral wa wa vf cv vv cv cima cint vv cv vf cv cfv
      cin cA wcel vx cv cint cA wcel vx cv cA wss vv cv csuc vx cv vf cv wf1o
      wa vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA wcel
      wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA wral wa wa vv cv vf cv
      cfv cA wcel vf cv vv cv cima cint vv cv vf cv cfv cin cA wcel vx cv cA
      wss vv cv csuc vx cv vf cv wf1o wa vv cv vf cv cfv cA wcel vx cv cA wss
      vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA wcel wi vx wal vz cv
      vw cv cin cA wcel vw cA wral vz cA wral wa vx cv cA wss vv cv csuc vx cv
      vf cv wf1o vv cv vf cv cfv cA wcel vx cv cA wss vv cv vf cv cfv vx cv
      wcel vv cv vf cv cfv cA wcel vv cv csuc vx cv vf cv wf1o vx cv cA vv cv
      vf cv cfv ssel vv cv csuc vx cv vf cv wf1o vv cv csuc vx cv vf cv wfo vv
      cv csuc vx cv vf cv wf vv cv vf cv cfv vx cv wcel vv cv csuc vx cv vf cv
      f1ofo vv cv csuc vx cv vf cv fof vv cv csuc vx cv vf cv wf vv cv vv cv
      csuc wcel vv cv vf cv cfv vx cv wcel vv cv vv visset sucid vv cv csuc vx
      cv vv cv vf cv ffvelrn mpan2 3syl syl5 imp adantr vx cv cA wss vv cv csuc
      vx cv vf cv wf1o wa vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa
      vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA
      wral wa wa vf cv vv cv cima c0 wceq vv cv vf cv cfv cA wcel vf cv vv cv
      cima cint vv cv vf cv cfv cin cA wcel wi vx cv cA wss vv cv csuc vx cv vf
      cv wf1o wa vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint
      cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA wral wa wa vf
      cv vv cv cima c0 wne vv cv vf cv cfv cA wcel vf cv vv cv cima cint vv cv
      vf cv cfv cin cA wcel wi vf cv vv cv cima c0 wceq wn vx cv cA wss vv cv
      csuc vx cv vf cv wf1o vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa
      vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel vw cA wral vz cA
      wral vf cv vv cv cima c0 wne vv cv vf cv cfv cA wcel vf cv vv cv cima
      cint vv cv vf cv cfv cin cA wcel wi wi vz cv vw cv cin cA wcel vw cA wral
      vz cA wral vv cv csuc vx cv vf cv wf1o vx cv cA wss vx cv c0 wne wa vv cv
      vx cv cen wbr wa vx cv cint cA wcel wi vx wal vx cv cA wss vf cv vv cv
      cima c0 wne vv cv vf cv cfv cA wcel vf cv vv cv cima cint vv cv vf cv cfv
      cin cA wcel wi wi vz cv vw cv cin cA wcel vw cA wral vz cA wral vv cv
      csuc vx cv vf cv wf1o vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa
      vx cv cint cA wcel wi vx wal vx cv cA wss vf cv vv cv cima c0 wne vv cv
      vf cv cfv cA wcel vf cv vv cv cima cint vv cv vf cv cfv cin cA wcel wi wi
      wi vz cv vw cv cin cA wcel vw cA wral vz cA wral vv cv csuc vx cv vf cv
      wf1o vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA
      wcel wi vx wal wa vx cv cA wss vf cv vv cv cima c0 wne vv cv vf cv cfv cA
      wcel vf cv vv cv cima cint vv cv vf cv cfv cin cA wcel wi vv cv csuc vx
      cv vf cv wf1o vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv
      cint cA wcel wi vx wal wa vx cv cA wss vf cv vv cv cima c0 wne wa vv cv
      vf cv cfv cA wcel vz cv vw cv cin cA wcel vw cA wral vz cA wral vf cv vv
      cv cima cint vv cv vf cv cfv cin cA wcel vv cv csuc vx cv vf cv wf1o vx
      cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA wcel wi vx
      wal wa vx cv cA wss vf cv vv cv cima c0 wne wa vf cv vv cv cima cint cA
      wcel vv cv vf cv cfv cA wcel vz cv vw cv cin cA wcel vw cA wral vz cA
      wral vf cv vv cv cima cint vv cv vf cv cfv cin cA wcel wi wi vv cv csuc
      vx cv vf cv wf1o vx cv cA wss vf cv vv cv cima c0 wne wa vf cv vv cv cima
      cA wss vf cv vv cv cima c0 wne wa vv cv vf cv vv cv cima cen wbr wa vx cv
      cA wss vx cv c0 wne wa vv cv vx cv cen wbr wa vx cv cint cA wcel wi vx
      wal vf cv vv cv cima cint cA wcel vv cv csuc vx cv vf cv wf1o vx cv cA
      wss vf cv vv cv cima c0 wne wa vf cv vv cv cima cA wss vf cv vv cv cima
      c0 wne wa vv cv vf cv vv cv cima cen wbr vv cv csuc vx cv vf cv wf1o vx
      cv cA wss vf cv vv cv cima cA wss vf cv vv cv cima c0 wne vv cv csuc vx
      cv vf cv wf1o vf cv vv cv cima vx cv wss vx cv cA wss vf cv vv cv cima cA
      wss wi vv cv csuc vx cv vf cv wf1o vf cv vv cv cima vf cv crn wss vf cv
      vv cv cima vx cv wss vf cv vv cv imassrn vv cv csuc vx cv vf cv wf1o vf
      cv crn vx cv vf cv vv cv cima vv cv csuc vx cv vf cv wf1o vf cv vv cv
      csuc wfn vf cv ccnv wfun vf cv crn vx cv wceq w3a vf cv crn vx cv wceq vv
      cv csuc vx cv vf cv dff1o2 vf cv vv cv csuc wfn vf cv ccnv wfun vf cv crn
      vx cv wceq 3simp3 sylbi sseq2d mpbii vf cv vv cv cima vx cv cA sstr2 syl
      anim1d vv cv csuc vx cv vf cv wf1o vv cv csuc vx cv vf cv wf1 vv cv vf cv
      vv cv cima vf cv vv cv cres wf1o vv cv vf cv vv cv cima cen wbr vv cv
      csuc vx cv vf cv f1of1 vv cv csuc vx cv vf cv wf1 vv cv vv cv csuc wss vv
      cv vf cv vv cv cima vf cv vv cv cres wf1o vv cv sssucid vv cv csuc vx cv
      vv cv vf cv f1ores mpan2 vv cv vf cv vv cv cima vf cv vv cv cres vv
      visset f1oen 3syl jctird vx cv cA wss vx cv c0 wne wa vv cv vx cv cen wbr
      wa vx cv cint cA wcel wi vf cv vv cv cima cA wss vf cv vv cv cima c0 wne
      wa vv cv vf cv vv cv cima cen wbr wa vf cv vv cv cima cint cA wcel wi vx
      vf cv vv cv cima vf cv cvv wcel vf cv vv cv cima cvv wcel vf visset vf cv
      vv cv cvv imaexg ax-mp vx cv vf cv vv cv cima wceq vx cv cA wss vx cv c0
      wne wa vv cv vx cv cen wbr wa vf cv vv cv cima cA wss vf cv vv cv cima c0
      wne wa vv cv vf cv vv cv cima cen wbr wa vx cv cint cA wcel vf cv vv cv
      cima cint cA wcel vx cv vf cv vv cv cima wceq vx cv cA wss vx cv c0 wne
      wa vf cv vv cv cima cA wss vf cv vv cv cima c0 wne wa vv cv vx cv cen wbr
      vv cv vf cv vv cv cima cen wbr vx cv vf cv vv cv cima wceq vx cv cA wss
      vf cv vv cv cima cA wss vx cv c0 wne vf cv vv cv cima c0 wne vx cv vf cv
      vv cv cima cA sseq1 vx cv vf cv vv cv cima c0 neeq1 anbi12d vx cv vf cv
      vv cv cima vv cv cen breq2 anbi12d vx cv vf cv vv cv cima wceq vx cv cint
      vf cv vv cv cima cint cA vx cv vf cv vv cv cima inteq eleq1d imbi12d
      cla4v sylan9 vf cv vv cv cima cint cA wcel vv cv vf cv cfv cA wcel vz cv
      vw cv cin cA wcel vw cA wral vz cA wral vf cv vv cv cima cint vv cv vf cv
      cfv cin cA wcel wi vz cv vw cv cin cA wcel vf cv vv cv cima cint vv cv vf
      cv cfv cin cA wcel vf cv vv cv cima cint vw cv cin cA wcel vz vw vf cv vv
      cv cima cint vv cv vf cv cfv cA cA vz cv vf cv vv cv cima cint wceq vz cv
      vw cv cin vf cv vv cv cima cint vw cv cin cA vz cv vf cv vv cv cima cint
      vw cv ineq1 eleq1d vw cv vv cv vf cv cfv wceq vf cv vv cv cima cint vw cv
      cin vf cv vv cv cima cint vv cv vf cv cfv cin cA vw cv vv cv vf cv cfv vf
      cv vv cv cima cint ineq2 eleq1d rcla42v ex syl6 com4r exp4a exp3a com14
      imp43 vf cv vv cv cima c0 df-ne syl5ibr vf cv vv cv cima c0 wceq vf cv vv
      cv cima cint vv cv vf cv cfv cin cA wcel vv cv vf cv cfv cA wcel vf cv vv
      cv cima c0 wceq vf cv vv cv cima cint vv cv vf cv cfv cin vv cv vf cv cfv
      cA vf cv vv cv cima c0 wceq vf cv vv cv cima cint vv cv vf cv cfv cin cvv
      vv cv vf cv cfv cin vv cv vf cv cfv vf cv vv cv cima c0 wceq vf cv vv cv
      cima cint cvv vv cv vf cv cfv vf cv vv cv cima c0 wceq vf cv vv cv cima
      cint c0 cint cvv vf cv vv cv cima c0 inteq int0 syl6eq ineq1d vv cv vf cv
      cfv cvv wss cvv vv cv vf cv cfv cin vv cv vf cv cfv wceq vv cv vf cv cfv
      ssv vv cv vf cv cfv cvv sseqin2 mpbi syl6eq eleq1d biimprd pm2.61d2 mpd
      vv cv csuc vx cv vf cv wf1o vf cv vv cv cima cint vv cv vf cv cfv cin cA
      wcel vx cv cint cA wcel wb vx cv cA wss vx cv cA wss vx cv c0 wne wa vv
      cv vx cv cen wbr wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel
      vw cA wral vz cA wral wa vv cv csuc vx cv vf cv wf1o vf cv vv cv cima
      cint vv cv vf cv cfv cin vx cv cint cA vv cv csuc vx cv vf cv wf1o vf cv
      vv cv cima vv cv vf cv cfv csn cun cint vx cv cint vf cv vv cv cima cint
      vv cv vf cv cfv cin vv cv csuc vx cv vf cv wf1o vf cv vv cv cima vv cv vf
      cv cfv csn cun vx cv vv cv csuc vx cv vf cv wf1o vf cv vv cv cima vv cv
      vf cv cfv csn cun vf cv vv cv csuc cima vx cv vv cv csuc vx cv vf cv wf1o
      vf cv vv cv cima vv cv vf cv cfv csn cun vf cv vv cv cima vf cv vv cv csn
      cima cun vf cv vv cv csuc cima vv cv csuc vx cv vf cv wf1o vv cv vf cv
      cfv csn vf cv vv cv csn cima vf cv vv cv cima vf cv vv cv csuc wfn vv cv
      vv cv csuc wcel vv cv vf cv cfv csn vf cv vv cv csn cima wceq vv cv csuc
      vx cv vf cv wf1o vv cv csuc vv cv vf cv fnsnfv vv cv csuc vx cv vf cv
      f1ofn vv cv vv visset sucid sylancl uneq2d vf cv vv cv csuc cima vf cv vv
      cv vv cv csn cun cima vf cv vv cv cima vf cv vv cv csn cima cun vv cv
      csuc vv cv vv cv csn cun vf cv vv cv df-suc imaeq2i vf cv vv cv vv cv csn
      imaundi eqtr2i syl6eq vv cv csuc vx cv vf cv wf1o vv cv csuc vx cv vf cv
      wfo vf cv vv cv csuc cima vx cv wceq vv cv csuc vx cv vf cv f1ofo vv cv
      csuc vx cv vf cv foima syl eqtrd inteqd vf cv vv cv cima vv cv vf cv cfv
      vv cv vf cv fvex intunsn syl5eqr eleq1d ad2antlr mpbid exp43 19.23adv vv
      cv csuc vx cv vf vx visset bren syl5ib imp adantlr com13 19.21ad a1i
      finds2 vx cv cA wss vx cv c0 wne wa vy cv vx cv cen wbr wa vx cv cint cA
      wcel wi vx ax-4 syl6 exp4a com24 vx cv vy cv vy visset ensym syl5
      r19.23aiv sylbi com13 imp3a 19.21aiv vx cv cA wss vx cv c0 wne wa vx cv
      cfn wcel wa vx cv cint cA wcel wi vx wal vz cv vw cv cin cA wcel vz vw cA
      cA vx cv cA wss vx cv c0 wne wa vx cv cfn wcel wa vx cv cint cA wcel wi
      vx wal vz cv vw cv cpr cA wss vz cv vw cv cpr c0 wne wa vz cv vw cv cpr
      cfn wcel wa vz cv vw cv cpr cint cA wcel vz cv cA wcel vw cv cA wcel wa
      vz cv vw cv cin cA wcel vx cv cA wss vx cv c0 wne wa vx cv cfn wcel wa vx
      cv cint cA wcel wi vz cv vw cv cpr cA wss vz cv vw cv cpr c0 wne wa vz cv
      vw cv cpr cfn wcel wa vz cv vw cv cpr cint cA wcel wi vx vz cv vw cv cpr
      vz vw zfpair2 vx cv vz cv vw cv cpr wceq vx cv cA wss vx cv c0 wne wa vx
      cv cfn wcel wa vz cv vw cv cpr cA wss vz cv vw cv cpr c0 wne wa vz cv vw
      cv cpr cfn wcel wa vx cv cint cA wcel vz cv vw cv cpr cint cA wcel vx cv
      vz cv vw cv cpr wceq vx cv cA wss vx cv c0 wne wa vz cv vw cv cpr cA wss
      vz cv vw cv cpr c0 wne wa vx cv cfn wcel vz cv vw cv cpr cfn wcel vx cv
      vz cv vw cv cpr wceq vx cv cA wss vz cv vw cv cpr cA wss vx cv c0 wne vz
      cv vw cv cpr c0 wne vx cv vz cv vw cv cpr cA sseq1 vx cv vz cv vw cv cpr
      c0 neeq1 anbi12d vx cv vz cv vw cv cpr cfn eleq1 anbi12d vx cv vz cv vw
      cv cpr wceq vx cv cint vz cv vw cv cpr cint cA vx cv vz cv vw cv cpr
      inteq eleq1d imbi12d cla4v vz cv cA wcel vw cv cA wcel wa vz cv vw cv cpr
      cA wss vz cv vw cv cpr cA wss vz cv vw cv cpr c0 wne wa vz cv vw cv cpr
      cA wss vz cv vw cv cpr c0 wne wa vz cv vw cv cpr cfn wcel wa vz cv vw cv
      cA vz visset vw visset prss vz cv vw cv cpr c0 wne vz cv vw cv cpr cA wss
      vz cv vw cv vz visset prnz biantru vz cv vw cv cpr cfn wcel vz cv vw cv
      cpr cA wss vz cv vw cv cpr c0 wne wa vz cv vw cv prfi biantru 3bitrri vz
      cv vw cv cpr cint vz cv vw cv cin cA vz cv vw cv vz visset vw visset
      intpr eleq1i 3imtr3g r19.21aivv impbii vx cv vy cv cin cA wcel vz cv vw
      cv cin cA wcel vz cv vy cv cin cA wcel vx vy vz vw cA cA vx cv vz cv wceq
      vx cv vy cv cin vz cv vy cv cin cA vx cv vz cv vy cv ineq1 eleq1d vy cv
      vw cv wceq vz cv vy cv cin vz cv vw cv cin cA vy cv vw cv vz cv ineq2
      eleq1d cbvral2v vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint
      cA wcel wi vx cv cA wss vx cv c0 wne wa vx cv cfn wcel wa vx cv cint cA
      wcel wi vx vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cA wss vx
      cv c0 wne wa vx cv cfn wcel wa vx cv cint cA wcel vx cv cA wss vx cv c0
      wne vx cv cfn wcel df-3an imbi1i albii 3bitr4i $.
      $( [2-Sep-2008] $) $( [22-Sep-2002] $)
  $}

  ${
    $d x y z $.
    $( Two ways to express the collection of finite intersections of a set
       ` A ` . $)
    abfii1 $p |- |^| { x | ( A C_ x /\
                         A. y e. x A. z e. x ( y i^i z ) e. x ) } =
                  |^| { x | ( A C_ x /\ A. y ( ( y C_ x /\ y =/= (/) /\
                   y e. Fin ) -> |^| y e. x ) ) } $=
      cA vx cv wss vy cv vz cv cin vx cv wcel vz vx cv wral vy vx cv wral wa vx
      cab cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv
      cint vx cv wcel wi vy wal wa vx cab cA vx cv wss vy cv vz cv cin vx cv
      wcel vz vx cv wral vy vx cv wral wa cA vx cv wss vy cv vx cv wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal wa vx vy cv vz cv
      cin vx cv wcel vz vx cv wral vy vx cv wral vy cv vx cv wss vy cv c0 wne
      vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal cA vx cv wss vy vz vx
      cv fiint anbi2i abbii inteqi $.
      $( [29-Sep-2008] $) $( [29-Jul-2006] $)
  $}

  ${
    $d f t u v w x y z A $.
    abfii2.1 $e |- A e. _V $.
    $( Two ways to express the collection of finite intersections of a set
       ` A ` . $)
    abfii2 $p |- { x | E. y ( y C_ A /\ y e. Fin /\ x = |^| y ) }
            = |^| { x | A. y ( ( y C_ A /\ y =/= (/) /\ y e. Fin ) ->
                 |^| y e. x ) } $=
      vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint cA cuni cin vx cv
      wcel wi vy wal vx cab cint vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a
      vx cv vy cv cint cA cuni cin wceq wa vy wex vx cab vy cv cA wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx cab cint vy cv
      cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab vy cv cA
      wss vy cv c0 wne vy cv cfn wcel w3a vx vy vy cv cint cA cuni cin cA cuni
      vy cv cint cA abfii2.1 uniex inex2 vy cv cA wss vy cv c0 wne vy cv cfn
      wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy wex vx cab vy cv cA wss
      vx cv vy cv cint cA cuni cin wceq wa vy wex vx cab vx cv vy cv cint cA
      cuni cin wceq vy vx cA abfii2.1 vy cv cint cA cuni cin csn vx cv vy cv
      cint cA cuni cin wceq vx cab cvv vx vy cv cint cA cuni cin df-sn vy cv
      cint cA cuni cin snex eqeltrri abexssex vy cv cA wss vy cv c0 wne vy cv
      cfn wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy wex vy cv cA wss vx
      cv vy cv cint cA cuni cin wceq wa vy wex vx vy cv cA wss vy cv c0 wne vy
      cv cfn wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy cv cA wss vx cv
      vy cv cint cA cuni cin wceq wa vy vy cv cA wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cA wss vx cv vy cv cint cA cuni cin wceq vy cv cA wss vy
      cv c0 wne vy cv cfn wcel 3simp1 anim1i 19.22i ss2abi ssexi intab vy cv cA
      wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx
      cab vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint cA cuni cin
      vx cv wcel wi vy wal vx cab vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a
      vy cv cint vx cv wcel wi vy wal vy cv cA wss vy cv c0 wne vy cv cfn wcel
      w3a vy cv cint cA cuni cin vx cv wcel wi vy wal vx vy cv cA wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy cv cA wss vy cv c0 wne
      vy cv cfn wcel w3a vy cv cint cA cuni cin vx cv wcel wi vy vy cv cA wss
      vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel vy cv cint cA cuni
      cin vx cv wcel vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vy
      cv cint cA cuni cin vx cv vy cv cA wss vy cv c0 wne vy cv cint vy cv cint
      cA cuni cin wceq vy cv cfn wcel vy cv cA wss vy cv c0 wne wa vy cv cint
      cA cuni wss vy cv cint vy cv cint cA cuni cin wceq vy cv cA intssuni2 vy
      cv cint cA cuni dfss sylib 3adant3 eleq1d pm5.74i albii abbii inteqi vy
      cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vy cv cA wss vy
      cv c0 wne vy cv cfn wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy wex
      vx vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy cv cA wss vy
      cv c0 wne vy cv cfn wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy vy
      cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy cv cA wss vy cv cfn
      wcel wa vx cv vy cv cint wceq wa vy cv cA wss vy cv cfn wcel wa vy cv c0
      wne vx cv vy cv cint wceq wa wa vy cv cA wss vy cv c0 wne vy cv cfn wcel
      w3a vx cv vy cv cint cA cuni cin wceq wa vy cv cA wss vy cv cfn wcel vx
      cv vy cv cint wceq df-3an vx cv vy cv cint wceq vy cv c0 wne vx cv vy cv
      cint wceq wa vy cv cA wss vy cv cfn wcel wa vx cv vy cv cint wceq vy cv
      c0 wne vx cv vy cv cint wceq vy cv cint cvv wcel vy cv c0 wne vx cv vy cv
      cint wceq vx cv cvv wcel vy cv cint cvv wcel vx visset vx cv vy cv cint
      cvv eleq1 mpbii vy cv intex sylibr pm4.71ri anbi2i vy cv cA wss vy cv cfn
      wcel wa vy cv c0 wne vx cv vy cv cint wceq wa wa vy cv cA wss vy cv c0
      wne wa vy cv cfn wcel vx cv vy cv cint wceq wa wa vy cv cA wss vy cv c0
      wne vy cv cfn wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy cv cA wss
      vy cv cfn wcel vy cv c0 wne vx cv vy cv cint wceq an4 vy cv cA wss vy cv
      c0 wne vy cv cfn wcel w3a vx cv vy cv cint wceq wa vy cv cA wss vy cv c0
      wne wa vy cv cfn wcel wa vx cv vy cv cint wceq wa vy cv cA wss vy cv c0
      wne vy cv cfn wcel w3a vx cv vy cv cint cA cuni cin wceq wa vy cv cA wss
      vy cv c0 wne wa vy cv cfn wcel vx cv vy cv cint wceq wa wa vy cv cA wss
      vy cv c0 wne vy cv cfn wcel w3a vy cv cA wss vy cv c0 wne wa vy cv cfn
      wcel wa vx cv vy cv cint wceq vy cv cA wss vy cv c0 wne vy cv cfn wcel
      df-3an anbi1i vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vx cv vy cv
      cint wceq vx cv vy cv cint cA cuni cin wceq vy cv cA wss vy cv c0 wne vx
      cv vy cv cint wceq vx cv vy cv cint cA cuni cin wceq wb vy cv cfn wcel vy
      cv cA wss vy cv c0 wne wa vy cv cint vy cv cint cA cuni cin vx cv vy cv
      cA wss vy cv c0 wne wa vy cv cint cA cuni wss vy cv cint vy cv cint cA
      cuni cin wceq vy cv cA intssuni2 vy cv cint cA cuni dfss sylib eqeq2d
      3adant3 pm5.32i vy cv cA wss vy cv c0 wne wa vy cv cfn wcel vx cv vy cv
      cint wceq anass 3bitr3ri bitri 3bitri exbii abbii 3eqtr4ri $.
      $( [1-Oct-2008] $) $( [29-Jul-2006] $)

    $( Two ways to express the collection of finite intersections of a set
       ` A ` . $)
    abfii3 $p |- |^| { x | ( A C_ x /\ A. y ( ( y C_ A /\ y =/= (/) /\
                   y e. Fin ) -> |^| y e. x ) ) } =
                  |^| { x | A. y ( ( y C_ A /\ y =/= (/) /\
                   y e. Fin ) -> |^| y e. x ) } $=
      cA vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi
      vy wal vx cab cint wss cA vx cv wss vy cv cA wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint vx cv wcel wi vy wal wa vx cab cint vy cv cA wss vy
      cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx cab cint
      wceq cA vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi
      vy wal vx cab cint vz cA vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab vz cv cA wcel vy cv cA wss vy cv cfn wcel vz cv vy
      cv cint wceq w3a vy wex vz cv vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel vz cv cA wcel vz cv csn cA wss vy cv cA
      wss vy cv cfn wcel vz cv vy cv cint wceq w3a vy wex vz cv cA snssi vz cv
      csn cA wss vz cv csn cfn wcel vz cv vz cv wceq vy cv cA wss vy cv cfn
      wcel vz cv vy cv cint wceq w3a vy wex vz cv snfi vz cv eqid vy cv cA wss
      vy cv cfn wcel vz cv vy cv cint wceq w3a vz cv csn cA wss vz cv csn cfn
      wcel vz cv vz cv wceq w3a vy vz cv csn vz cv snex vy cv vz cv csn wceq vy
      cv cA wss vz cv csn cA wss vy cv cfn wcel vz cv csn cfn wcel vz cv vy cv
      cint wceq vz cv vz cv wceq vy cv vz cv csn cA sseq1 vy cv vz cv csn cfn
      eleq1 vy cv vz cv csn wceq vy cv cint vz cv vz cv vy cv vz cv csn wceq vy
      cv cint vz cv csn cint vz cv vy cv vz cv csn inteq vz cv vz visset intsn
      syl6eq eqeq2d 3anbi123d cla4ev mp3an23 syl vy cv cA wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vy cv cA wss vy cv cfn wcel vz cv vy cv
      cint wceq w3a vy wex vx vz cv vz visset vx cv vz cv wceq vy cv cA wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy cv cA wss vy cv cfn wcel vz cv
      vy cv cint wceq w3a vy vx cv vz cv wceq vx cv vy cv cint wceq vz cv vy cv
      cint wceq vy cv cA wss vy cv cfn wcel vx cv vz cv vy cv cint eqeq1
      3anbi3d exbidv elab sylibr ssriv vx vy cA abfii2.1 abfii2 sseqtri vy cv
      cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx
      cA intmin4 ax-mp $.
      $( [2-Oct-2008] $) $( [10-Aug-2006] $)

    $( Two ways to express the collection of finite intersections of a set
       ` A ` .  Even though the expressions differ by only one symbol, the
       proof is not simple. $)
    abfii4 $p |- |^| { x | ( A C_ x /\ A. y ( ( y C_ x /\ y =/= (/) /\
                   y e. Fin ) -> |^| y e. x ) ) } =
                  |^| { x | ( A C_ x /\ A. y ( ( y C_ A /\ y =/= (/) /\
                   y e. Fin ) -> |^| y e. x ) ) } $=
      cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint
      vx cv wcel wi vy wal wa vx cab cint vy cv cA wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint vx cv wcel wi vy wal vx cab cint cA vx cv wss vy cv
      cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal wa
      vx cab cint cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a
      vy cv cint vx cv wcel wi vy wal wa vx cab cint vy cv cA wss vy cv c0 wne
      vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx cab cint cA vx cv
      wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel
      wi vy wal wa vx cab cint vv cv cA wss vv cv cfn wcel vw cv vv cv cint
      wceq w3a vv wex vw cab vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv
      cint vx cv wcel wi vy wal vx cab cint vv cv cA wss vv cv cfn wcel vw cv
      vv cv cint wceq w3a vv wex vw cab cvv wcel cA vx cv wss vy cv vx cv wss
      vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal wa vx cab
      cint vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab
      wss vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab
      vv cv cA wss vw cv vv cv cint wceq wa vv wex vw cab vw cv vv cv cint wceq
      vv vw cA abfii2.1 vv cv cint csn vw cv vv cv cint wceq vw cab cvv vw vv
      cv cint df-sn vv cv cint snex eqeltrri abexssex vv cv cA wss vv cv cfn
      wcel vw cv vv cv cint wceq w3a vv wex vv cv cA wss vw cv vv cv cint wceq
      wa vv wex vw vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv cv
      cA wss vw cv vv cv cint wceq wa vv vv cv cA wss vv cv cfn wcel vw cv vv
      cv cint wceq 3simpb 19.22i ss2abi ssexi cA vx cv wss vy cv vx cv wss vy
      cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal wa cA vv cv
      cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wss vy cv
      vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wss
      vy cv c0 wne vy cv cfn wcel w3a vy cv cint vv cv cA wss vv cv cfn wcel vw
      cv vv cv cint wceq w3a vv wex vw cab wcel wi vy wal wa vx vv cv cA wss vv
      cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab cvv vx cv vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wceq cA vx cv
      wss cA vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw
      cab wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv
      wcel wi vy wal vy cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq
      w3a vv wex vw cab wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel wi vy wal
      vx cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab
      cA sseq2 vx cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv
      wex vw cab wceq vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv
      cint vx cv wcel wi vy cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint
      wceq w3a vv wex vw cab wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vv
      cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel wi
      vy vx cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw
      cab wceq vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint vx cv wcel vy cv cint vv cv cA wss vv
      cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vx cv vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wceq vy cv vx
      cv wss vy cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex
      vw cab wss vy cv c0 wne vy cv cfn wcel vx cv vv cv cA wss vv cv cfn wcel
      vw cv vv cv cint wceq w3a vv wex vw cab vy cv sseq2 3anbi1d vx cv vv cv
      cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab vy cv cint
      eleq2 imbi12d albidv anbi12d cA vv cv cA wss vv cv cfn wcel vw cv vv cv
      cint wceq w3a vv wex vw cab wss vy cv vv cv cA wss vv cv cfn wcel vw cv
      vv cv cint wceq w3a vv wex vw cab wss vy cv c0 wne vy cv cfn wcel w3a vy
      cv cint vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw
      cab wcel wi vy wal cA cA vw cv wss vv cv cA wss vv cv c0 wne vv cv cfn
      wcel w3a vv cv cint vw cv wcel wi vv wal wa vw cab cint vv cv cA wss vv
      cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab vv cv cA wss vv cv c0
      wne vv cv cfn wcel w3a vv cv cint vw cv wcel wi vv wal vw cA ssmin cA vw
      cv wss vv cv cA wss vv cv c0 wne vv cv cfn wcel w3a vv cv cint vw cv wcel
      wi vv wal wa vw cab cint vv cv cA wss vv cv c0 wne vv cv cfn wcel w3a vv
      cv cint vw cv wcel wi vv wal vw cab cint vv cv cA wss vv cv cfn wcel vw
      cv vv cv cint wceq w3a vv wex vw cab vw vv cA abfii2.1 abfii3 vw vv cA
      abfii2.1 abfii2 eqtr4i sseqtri vy cv vz cv cin vv cv cA wss vv cv cfn
      wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vz vv cv cA wss vv cv
      cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wral vy vv cv cA wss vv
      cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wral vy cv vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint vv cv cA wss vv cv cfn wcel vw cv vv cv
      cint wceq w3a vv wex vw cab wcel wi vy wal vy cv vz cv cin vv cv cA wss
      vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vy vz vv cv
      cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab vt cv cA
      wss vt cv cfn wcel vy cv vt cv cint wceq w3a vt wex vf cv cA wss vf cv
      cfn wcel vz cv vf cv cint wceq w3a vf wex vy cv vz cv cin vv cv cA wss vv
      cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vy cv vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vz cv vv
      cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vt
      cv cA wss vt cv cfn wcel vy cv vt cv cint wceq w3a vt wex vf cv cA wss vf
      cv cfn wcel vz cv vf cv cint wceq w3a vf wex wa vv cv cA wss vv cv cfn
      wcel vy cv vz cv cin vv cv cint wceq w3a vv wex vy cv vz cv cin vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vt cv cA
      wss vt cv cfn wcel vy cv vt cv cint wceq w3a vt wex vf cv cA wss vf cv
      cfn wcel vz cv vf cv cint wceq w3a vf wex wa vt cv cA wss vt cv cfn wcel
      vy cv vt cv cint wceq w3a vf cv cA wss vf cv cfn wcel vz cv vf cv cint
      wceq w3a wa vf wex vt wex vv cv cA wss vv cv cfn wcel vy cv vz cv cin vv
      cv cint wceq w3a vv wex vt cv cA wss vt cv cfn wcel vy cv vt cv cint wceq
      w3a vf cv cA wss vf cv cfn wcel vz cv vf cv cint wceq w3a vt vf eeanv vt
      cv cA wss vt cv cfn wcel vy cv vt cv cint wceq w3a vf cv cA wss vf cv cfn
      wcel vz cv vf cv cint wceq w3a wa vv cv cA wss vv cv cfn wcel vy cv vz cv
      cin vv cv cint wceq w3a vv wex vt vf vt cv cA wss vt cv cfn wcel vy cv vt
      cv cint wceq w3a vf cv cA wss vf cv cfn wcel vz cv vf cv cint wceq w3a wa
      vt cv cA wss vf cv cA wss wa vt cv cfn wcel vf cv cfn wcel wa vy cv vt cv
      cint wceq vz cv vf cv cint wceq wa w3a vv cv cA wss vv cv cfn wcel vy cv
      vz cv cin vv cv cint wceq w3a vv wex vt cv cA wss vt cv cfn wcel vy cv vt
      cv cint wceq vf cv cA wss vf cv cfn wcel vz cv vf cv cint wceq an6 vt cv
      vf cv cun cA wss vt cv vf cv cun cfn wcel vy cv vz cv cin vt cv vf cv cun
      cint wceq vv cv cA wss vv cv cfn wcel vy cv vz cv cin vv cv cint wceq w3a
      vv wex vt cv cA wss vf cv cA wss wa vt cv cfn wcel vf cv cfn wcel wa vy
      cv vt cv cint wceq vz cv vf cv cint wceq wa vv cv cA wss vv cv cfn wcel
      vy cv vz cv cin vv cv cint wceq w3a vt cv vf cv cun cA wss vt cv vf cv
      cun cfn wcel vy cv vz cv cin vt cv vf cv cun cint wceq w3a vv vt cv vf cv
      cun vt cv vf cv vt visset vf visset unex vv cv vt cv vf cv cun wceq vv cv
      cA wss vt cv vf cv cun cA wss vv cv cfn wcel vt cv vf cv cun cfn wcel vy
      cv vz cv cin vv cv cint wceq vy cv vz cv cin vt cv vf cv cun cint wceq vv
      cv vt cv vf cv cun cA sseq1 vv cv vt cv vf cv cun cfn eleq1 vv cv vt cv
      vf cv cun wceq vv cv cint vt cv vf cv cun cint vy cv vz cv cin vv cv vt
      cv vf cv cun inteq eqeq2d 3anbi123d cla4ev vt cv cA wss vf cv cA wss wa
      vt cv vf cv cun cA wss vt cv vf cv cA unss biimpi vt cv vf cv unfi vy cv
      vt cv cint wceq vz cv vf cv cint wceq wa vy cv vz cv cin vt cv cint vf cv
      cint cin vt cv vf cv cun cint vy cv vt cv cint vz cv vf cv cint ineq12 vt
      cv vf cv intun syl6eqr syl3an sylbi 19.23aivv sylbir vv cv cA wss vv cv
      cfn wcel vw cv vv cv cint wceq w3a vv wex vv cv cA wss vv cv cfn wcel vy
      cv vz cv cin vv cv cint wceq w3a vv wex vw vy cv vz cv cin vy cv vz cv vy
      visset inex1 vw cv vy cv vz cv cin wceq vv cv cA wss vv cv cfn wcel vw cv
      vv cv cint wceq w3a vv cv cA wss vv cv cfn wcel vy cv vz cv cin vv cv
      cint wceq w3a vv vw cv vy cv vz cv cin wceq vw cv vv cv cint wceq vy cv
      vz cv cin vv cv cint wceq vv cv cA wss vv cv cfn wcel vw cv vy cv vz cv
      cin vv cv cint eqeq1 3anbi3d exbidv elab sylibr vy cv vv cv cA wss vv cv
      cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab wcel vv cv cA wss vv cv
      cfn wcel vy cv vv cv cint wceq w3a vv wex vt cv cA wss vt cv cfn wcel vy
      cv vt cv cint wceq w3a vt wex vv cv cA wss vv cv cfn wcel vw cv vv cv
      cint wceq w3a vv wex vv cv cA wss vv cv cfn wcel vy cv vv cv cint wceq
      w3a vv wex vw vy cv vy visset vw cv vy cv wceq vv cv cA wss vv cv cfn
      wcel vw cv vv cv cint wceq w3a vv cv cA wss vv cv cfn wcel vy cv vv cv
      cint wceq w3a vv vw cv vy cv wceq vw cv vv cv cint wceq vy cv vv cv cint
      wceq vv cv cA wss vv cv cfn wcel vw cv vy cv vv cv cint eqeq1 3anbi3d
      exbidv elab vv cv cA wss vv cv cfn wcel vy cv vv cv cint wceq w3a vt cv
      cA wss vt cv cfn wcel vy cv vt cv cint wceq w3a vv vt vv cv vt cv wceq vv
      cv cA wss vt cv cA wss vv cv cfn wcel vt cv cfn wcel vy cv vv cv cint
      wceq vy cv vt cv cint wceq vv cv vt cv cA sseq1 vv cv vt cv cfn eleq1 vv
      cv vt cv wceq vv cv cint vt cv cint vy cv vv cv vt cv inteq eqeq2d
      3anbi123d cbvexv bitri vz cv vv cv cA wss vv cv cfn wcel vw cv vv cv cint
      wceq w3a vv wex vw cab wcel vv cv cA wss vv cv cfn wcel vz cv vv cv cint
      wceq w3a vv wex vf cv cA wss vf cv cfn wcel vz cv vf cv cint wceq w3a vf
      wex vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vv cv cA
      wss vv cv cfn wcel vz cv vv cv cint wceq w3a vv wex vw vz cv vz visset vw
      cv vz cv wceq vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv cv
      cA wss vv cv cfn wcel vz cv vv cv cint wceq w3a vv vw cv vz cv wceq vw cv
      vv cv cint wceq vz cv vv cv cint wceq vv cv cA wss vv cv cfn wcel vw cv
      vz cv vv cv cint eqeq1 3anbi3d exbidv elab vv cv cA wss vv cv cfn wcel vz
      cv vv cv cint wceq w3a vf cv cA wss vf cv cfn wcel vz cv vf cv cint wceq
      w3a vv vf vv cv vf cv wceq vv cv cA wss vf cv cA wss vv cv cfn wcel vf cv
      cfn wcel vz cv vv cv cint wceq vz cv vf cv cint wceq vv cv vf cv cA sseq1
      vv cv vf cv cfn eleq1 vv cv vf cv wceq vv cv cint vf cv cint vz cv vv cv
      vf cv inteq eqeq2d 3anbi123d cbvexv bitri syl2anb rgen2a vy vz vv cv cA
      wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv wex vw cab fiint mpbi
      pm3.2i intmin3 ax-mp vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq
      w3a vv wex vw cab vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx
      cv wcel wi vy wal vx cab cint vv cv cA wss vv cv cfn wcel vw cv vv cv
      cint wceq w3a vv wex vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vw vx vw cv vx cv wceq vv cv cA wss vv cv cfn wcel vw cv vv cv
      cint wceq w3a vv wex vv cv cA wss vv cv cfn wcel vx cv vv cv cint wceq
      w3a vv wex vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vw cv vx cv wceq vv cv cA wss vv cv cfn wcel vw cv vv cv cint wceq w3a vv
      cv cA wss vv cv cfn wcel vx cv vv cv cint wceq w3a vv vw cv vx cv wceq vw
      cv vv cv cint wceq vx cv vv cv cint wceq vv cv cA wss vv cv cfn wcel vw
      cv vx cv vv cv cint eqeq1 3anbi3d exbidv vv cv cA wss vv cv cfn wcel vx
      cv vv cv cint wceq w3a vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vv vy vv cv vy cv wceq vv cv cA wss vy cv cA wss vv cv cfn wcel vy cv
      cfn wcel vx cv vv cv cint wceq vx cv vy cv cint wceq vv cv vy cv cA sseq1
      vv cv vy cv cfn eleq1 vv cv vy cv wceq vv cv cint vy cv cint vx cv vv cv
      vy cv inteq eqeq2d 3anbi123d cbvexv syl6bb cbvabv vx vy cA abfii2.1
      abfii2 eqtri sseqtri cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint vx cv wcel wi vy wal wa vx cab vy cv cA wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx cab wss vy cv
      cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx
      cab cint cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy
      cv cint vx cv wcel wi vy wal wa vx cab cint wss cA vx cv wss vy cv vx cv
      wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal wa vy
      cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal
      vx cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv
      cint vx cv wcel wi vy wal vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy
      cv cint vx cv wcel wi vy wal cA vx cv wss vy cv vx cv wss vy cv c0 wne vy
      cv cfn wcel w3a vy cv cint vx cv wcel wi vy cv cA wss vy cv c0 wne vy cv
      cfn wcel w3a vy cv cint vx cv wcel wi vy cA vx cv wss vy cv cA wss vy cv
      c0 wne vy cv cfn wcel w3a vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a
      vy cv cint vx cv wcel cA vx cv wss vy cv cA wss vy cv vx cv wss vy cv c0
      wne vy cv c0 wne vy cv cfn wcel vy cv cfn wcel vy cv cA wss cA vx cv wss
      vy cv vx cv wss vy cv cA vx cv sstr2 com12 cA vx cv wss vy cv c0 wne idd
      cA vx cv wss vy cv cfn wcel idd 3anim123d imim1d 19.20dv imp ss2abi cA vx
      cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv
      wcel wi vy wal wa vx cab vy cv cA wss vy cv c0 wne vy cv cfn wcel w3a vy
      cv cint vx cv wcel wi vy wal vx cab intss ax-mp eqssi vx vy cA abfii2.1
      abfii3 eqtr4i $.
      $( [5-Oct-2008] $) $( [10-Aug-2006] $)

    $( Two ways to express the collection of finite intersections of a set
       ` A ` . $)
    abfii5 $p |- |^| { x | ( A C_ x /\
                         A. y e. x A. z e. x ( y i^i z ) e. x ) } =
                  { x | E. y ( y C_ A /\ y e. Fin /\ x = |^| y ) } $=
      cA vx cv wss vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint
      vx cv wcel wi vy wal wa vx cab cint vy cv cA wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint vx cv wcel wi vy wal vx cab cint cA vx cv wss vy cv
      vz cv cin vx cv wcel vz vx cv wral vy vx cv wral wa vx cab cint vy cv cA
      wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab cA vx cv wss
      vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi
      vy wal wa vx cab cint cA vx cv wss vy cv cA wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint vx cv wcel wi vy wal wa vx cab cint vy cv cA wss vy
      cv c0 wne vy cv cfn wcel w3a vy cv cint vx cv wcel wi vy wal vx cab cint
      vx vy cA abfii2.1 abfii4 vx vy cA abfii2.1 abfii3 eqtri vx vy vz cA
      abfii1 vx vy cA abfii2.1 abfii2 3eqtr4i $.
      $( [11-Oct-2008] $) $( [29-Jul-2006] $)
  $}

  ${
    $d f g m k y x A $.  $d f g m x B $.  $d f g m F $.
    $( An onto function implies dominance of domain over range, for finite
       sets.  Unlike ~ fodom for arbitrary sets, this theorem does not require
       the Axiom of Choice for its proof. $)
    fodomfi $p |- ( ( A e. Fin /\ F : A -onto-> B ) -> B ~<_ A ) $=
      cA vm cv cen wbr vm com wrex cA cB cF wfo cB cA cdom wbr cA cfn wcel cA
      vm cv cen wbr vm com wrex cA cB cF wfo cB cA cdom wbr cA vm cv cen wbr cA
      cB cF wfo cB cA cdom wbr wi vm com vm cv com wcel cA vm cv cen wbr cA cB
      cF wfo cB cA cdom wbr cB vm cv cdom wbr vm cv cA cen wbr cB cA cdom wbr
      vm cv com wcel cA vm cv cen wbr cA cB cF wfo wa wa cB vm cv cA domentr cF
      cvv wcel vm cv com wcel cA vm cv cen wbr cA cB cF wfo wa wa cB vm cv cdom
      wbr cA vm cv cen wbr cA cB cF wfo wa cF cvv wcel vm cv com wcel cA cvv
      wcel cA cB cF wf cF cvv wcel cA vm cv cen wbr cA cB cF wfo cA cB cF wf cA
      cvv wcel cF cvv wcel cA cB cvv cF fex ancoms cA vm cv cen relen brrelexi
      cA cB cF fof syl2an adantl cF cvv wcel vm cv com wcel cA vm cv cen wbr cA
      cB cF wfo wa cB vm cv cdom wbr cF cvv wcel vm cv com wcel wa cA vm cv cen
      wbr cA cB cF wfo wa cB vm cv cdom wbr cF cvv wcel vm cv com wcel wa vm cv
      cB cF vg cv ccom wfo vg wex cB vm cv cdom wbr cA vm cv cen wbr cA cB cF
      wfo wa cF cvv wcel vm cv com wcel wa vm cv cB cF vg cv ccom wfo cB vm cv
      cdom wbr vg cF cvv wcel vm cv cB cF vg cv ccom wfo vm cv cB vf cv wfo vf
      wex vm cv com wcel cB vm cv cdom wbr cF cvv wcel cF vg cv ccom cvv wcel
      vm cv cB cF vg cv ccom wfo vm cv cB vf cv wfo vf wex wi cF cvv wcel vg cv
      cvv wcel cF vg cv ccom cvv wcel vg visset cF vg cv cvv cvv coexg mpan2 vm
      cv cB vf cv wfo vm cv cB cF vg cv ccom wfo vf cF vg cv ccom cvv vm cv cB
      vf cv cF vg cv ccom foeq1 cla4egv syl vm cv com wcel vm cv cB vf cv wfo
      vf wex cB vm cv cdom wbr vm cv cB vf cv wfo vf wex cB cvv wcel vm cv com
      wcel vm cv cB vf cv wfo vf wex cB vm cv cdom wbr wi wi vm cv cB vf cv wfo
      cB cvv wcel vf vm cv cvv wcel vm cv cB vf cv wfo cB cvv wcel wi vm visset
      vm cv cB cvv vf cv fornex ax-mp 19.23aiv cB cvv wcel vm cv vx cv vf cv
      wfo vf wex vx cv vm cv cdom wbr wi vx wal vm cv cB vf cv wfo vf wex cB vm
      cv cdom wbr wi vm cv com wcel vm cv vx cv vf cv wfo vf wex vx cv vm cv
      cdom wbr wi vm cv cB vf cv wfo vf wex cB vm cv cdom wbr wi vx cB cvv vx
      cv cB wceq vm cv vx cv vf cv wfo vf wex vm cv cB vf cv wfo vf wex vx cv
      vm cv cdom wbr cB vm cv cdom wbr vx cv cB wceq vm cv vx cv vf cv wfo vm
      cv cB vf cv wfo vf vx cv cB vm cv vf cv foeq3 exbidv vx cv cB vm cv cdom
      breq1 imbi12d cla4gv vm cv vx cv vf cv wfo vf wex vx cv vm cv cdom wbr wi
      vx wal c0 vx cv vf cv wfo vf wex vx cv c0 cdom wbr wi vx wal vk cv vx cv
      vf cv wfo vf wex vx cv vk cv cdom wbr wi vx wal vk cv csuc vx cv vf cv
      wfo vf wex vx cv vk cv csuc cdom wbr wi vx wal vm vk vm cv c0 wceq vm cv
      vx cv vf cv wfo vf wex vx cv vm cv cdom wbr wi c0 vx cv vf cv wfo vf wex
      vx cv c0 cdom wbr wi vx vm cv c0 wceq vm cv vx cv vf cv wfo vf wex c0 vx
      cv vf cv wfo vf wex vx cv vm cv cdom wbr vx cv c0 cdom wbr vm cv c0 wceq
      vm cv vx cv vf cv wfo c0 vx cv vf cv wfo vf vm cv c0 vx cv vf cv foeq2
      exbidv vm cv c0 vx cv cdom breq2 imbi12d albidv vm cv vk cv wceq vm cv vx
      cv vf cv wfo vf wex vx cv vm cv cdom wbr wi vk cv vx cv vf cv wfo vf wex
      vx cv vk cv cdom wbr wi vx vm cv vk cv wceq vm cv vx cv vf cv wfo vf wex
      vk cv vx cv vf cv wfo vf wex vx cv vm cv cdom wbr vx cv vk cv cdom wbr vm
      cv vk cv wceq vm cv vx cv vf cv wfo vk cv vx cv vf cv wfo vf vm cv vk cv
      vx cv vf cv foeq2 exbidv vm cv vk cv vx cv cdom breq2 imbi12d albidv vm
      cv vk cv csuc wceq vm cv vx cv vf cv wfo vf wex vx cv vm cv cdom wbr wi
      vk cv csuc vx cv vf cv wfo vf wex vx cv vk cv csuc cdom wbr wi vx vm cv
      vk cv csuc wceq vm cv vx cv vf cv wfo vf wex vk cv csuc vx cv vf cv wfo
      vf wex vx cv vm cv cdom wbr vx cv vk cv csuc cdom wbr vm cv vk cv csuc
      wceq vm cv vx cv vf cv wfo vk cv csuc vx cv vf cv wfo vf vm cv vk cv csuc
      vx cv vf cv foeq2 exbidv vm cv vk cv csuc vx cv cdom breq2 imbi12d albidv
      c0 vx cv vf cv wfo vf wex vx cv c0 cdom wbr wi vx c0 vx cv vf cv wfo vx
      cv c0 cdom wbr vf c0 vx cv vf cv wfo vx cv c0 c0 cdom c0 vx cv vf cv wfo
      vf cv c0 wceq vx cv c0 wceq vx cv vf cv fo00 pm3.27bi c0 0dom syl6eqbr
      19.23aiv ax-gen vk cv com wcel vk cv vy cv vg cv wfo vg wex vy cv vk cv
      cdom wbr wi vy wal vk cv csuc vx cv vf cv wfo vf wex vx cv vk cv csuc
      cdom wbr wi vx wal vk cv vx cv vf cv wfo vf wex vx cv vk cv cdom wbr wi
      vx wal vk cv com wcel vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr
      wi vy wal vk cv csuc vx cv vf cv wfo vf wex vx cv vk cv csuc cdom wbr wi
      vx vk cv com wcel vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy
      wal vk cv csuc vx cv vf cv wfo vf wex vx cv vk cv csuc cdom wbr wi vk cv
      com wcel vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal wa
      vk cv csuc vx cv vf cv wfo vx cv vk cv csuc cdom wbr vf vk cv com wcel vk
      cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal wa vk cv csuc vx
      cv vf cv wfo vx cv vk cv csuc cdom wbr vk cv com wcel vk cv vy cv vg cv
      wfo vg wex vy cv vk cv cdom wbr wi vy wal wa vk cv csuc vx cv vf cv wfo
      wa vx cv vk cv vk cv csn cun vk cv csuc cdom vk cv com wcel vk cv vy cv
      vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal wa vk cv csuc vx cv vf cv
      wfo wa vf cv vk cv cima vk cv vf cv cfv csn cun vx cv vk cv vk cv csn cun
      cdom vk cv csuc vx cv vf cv wfo vf cv vk cv cima vk cv vf cv cfv csn cun
      vx cv wceq vk cv com wcel vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom
      wbr wi vy wal wa vk cv csuc vx cv vf cv wfo vf cv vk cv cima vk cv vf cv
      cfv csn cun vf cv vk cv cima vf cv vk cv csn cima cun vx cv vk cv csuc vx
      cv vf cv wfo vk cv vf cv cfv csn vf cv vk cv csn cima vf cv vk cv cima vf
      cv vk cv csuc wfn vk cv vk cv csuc wcel vk cv vf cv cfv csn vf cv vk cv
      csn cima wceq vk cv csuc vx cv vf cv wfo vk cv csuc vk cv vf cv fnsnfv vk
      cv csuc vx cv vf cv fofn vk cv vk visset sucid sylancl uneq2d vk cv csuc
      vx cv vf cv wfo vf cv vk cv csuc cima vx cv vf cv vk cv cima vf cv vk cv
      csn cima cun vk cv csuc vx cv vf cv foima vf cv vk cv csuc cima vf cv vk
      cv vk cv csn cun cima vf cv vk cv cima vf cv vk cv csn cima cun vk cv
      csuc vk cv vk cv csn cun vf cv vk cv df-suc imaeq2i vf cv vk cv vk cv csn
      imaundi eqtr2i syl5eq eqtrd adantl vf cv vk cv cima vk cv cdom wbr vk cv
      vf cv cfv csn vk cv csn cdom wbr wa vk cv vk cv csn cin c0 wceq vf cv vk
      cv cima vk cv vf cv cfv csn cun vk cv vk cv csn cun cdom wbr vk cv com
      wcel vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal wa vk cv
      csuc vx cv vf cv wfo wa vf cv vk cv cima vk cv vk cv vf cv cfv csn vk cv
      csn vk visset vk cv vf cv cfv snex vk cv snex undom vk cv com wcel vk cv
      vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal wa vk cv csuc vx cv
      vf cv wfo wa vf cv vk cv cima vk cv cdom wbr vk cv vf cv cfv csn vk cv
      csn cdom wbr vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal
      vk cv csuc vx cv vf cv wfo vf cv vk cv cima vk cv cdom wbr vk cv com wcel
      vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal vk cv vf cv
      vk cv cima vg cv wfo vg wex vf cv vk cv cima vk cv cdom wbr vk cv csuc vx
      cv vf cv wfo vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy wal
      vk cv vf cv vk cv cima vg cv wfo vg wex vf cv vk cv cima vk cv cdom wbr
      vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vk cv vf cv vk cv
      cima vg cv wfo vg wex vf cv vk cv cima vk cv cdom wbr wi vy vf cv vk cv
      cima vf cv cvv wcel vf cv vk cv cima cvv wcel vf visset vf cv vk cv cvv
      imaexg ax-mp vy cv vf cv vk cv cima wceq vk cv vy cv vg cv wfo vg wex vk
      cv vf cv vk cv cima vg cv wfo vg wex vy cv vk cv cdom wbr vf cv vk cv
      cima vk cv cdom wbr vy cv vf cv vk cv cima wceq vk cv vy cv vg cv wfo vk
      cv vf cv vk cv cima vg cv wfo vg vy cv vf cv vk cv cima vk cv vg cv foeq3
      exbidv vy cv vf cv vk cv cima vk cv cdom breq1 imbi12d cla4v imp vk cv
      csuc vx cv vf cv wfo vk cv vf cv vk cv cima vf cv vk cv cres wfo vk cv vf
      cv vk cv cima vg cv wfo vg wex vf cv wfun vk cv vf cv cdm wss vk cv vf cv
      vk cv cima vf cv vk cv cres wfo vk cv csuc vx cv vf cv wfo vk cv vf cv
      fores vk cv csuc vx cv vf cv fofun vk cv csuc vx cv vf cv wfo vk cv csuc
      vx cv vf cv wf vk cv vf cv cdm wss vk cv csuc vx cv vf cv fof vk cv csuc
      vx cv vf cv wf vk cv vf cv cdm wss vk cv vk cv csuc wss vk cv sssucid vk
      cv csuc vx cv vf cv wf vf cv cdm vk cv csuc vk cv vk cv csuc vx cv vf cv
      fdm sseq2d mpbiri syl sylanc vk cv vf cv vk cv cima vg cv wfo vk cv vf cv
      vk cv cima vf cv vk cv cres wfo vg vf cv vk cv cres vf cv cvv wcel vf cv
      vk cv cres cvv wcel vf visset vf cv vk cv cvv resexg ax-mp vk cv vf cv vk
      cv cima vg cv vf cv vk cv cres foeq1 cla4ev syl sylan2 adantll vk cv vf
      cv cfv csn vk cv csn cen wbr vk cv vf cv cfv csn vk cv csn cdom wbr vk cv
      vf cv cfv cvv wcel vk cv cvv wcel vk cv vf cv cfv csn vk cv csn cen wbr
      vk cv vf cv fvex vk visset vk cv vf cv cfv vk cv cvv cvv en2sn mp2an vk
      cv vf cv cfv csn vk cv csn endom ax-mp jctir vk cv com wcel vk cv vk cv
      csn cin c0 wceq vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi vy
      wal vk cv csuc vx cv vf cv wfo vk cv com wcel vk cv word vk cv vk cv csn
      cin c0 wceq vk cv nnord vk cv orddisj syl ad2antrr sylanc eqbrtrrd vk cv
      df-suc syl6breqr ex 19.23adv ex 19.21adv vk cv vx cv vf cv wfo vf wex vx
      cv vk cv cdom wbr wi vk cv vy cv vg cv wfo vg wex vy cv vk cv cdom wbr wi
      vx vy vx cv vy cv wceq vk cv vx cv vf cv wfo vf wex vk cv vy cv vg cv wfo
      vg wex vx cv vk cv cdom wbr vy cv vk cv cdom wbr vx cv vy cv wceq vk cv
      vx cv vf cv wfo vf wex vk cv vy cv vf cv wfo vf wex vk cv vy cv vg cv wfo
      vg wex vx cv vy cv wceq vk cv vx cv vf cv wfo vk cv vy cv vf cv wfo vf vx
      cv vy cv vk cv vf cv foeq3 exbidv vk cv vy cv vf cv wfo vk cv vy cv vg cv
      wfo vf vg vk cv vy cv vf cv vg cv foeq1 cbvexv syl6bb vx cv vy cv vk cv
      cdom breq1 imbi12d cbvalv syl5ib finds1 syl5 syl pm2.43b sylan9 19.23adv
      cA cB cF wfo cA vm cv cen wbr vm cv cB cF vg cv ccom wfo vg wex cA cB cF
      wfo vm cv cA vg cv wfo vg wex vm cv cB cF vg cv ccom wfo vg wex cA vm cv
      cen wbr cA cB cF wfo vm cv cA vg cv wfo vg wex wa cA cB cF wfo vm cv cA
      vg cv wfo wa vg wex vm cv cB cF vg cv ccom wfo vg wex cA cB cF wfo vm cv
      cA vg cv wfo vg 19.42v cA cB cF wfo vm cv cA vg cv wfo wa vm cv cB cF vg
      cv ccom wfo vg vm cv cA cB cF vg cv foco 19.22i sylbir cA vm cv cen wbr
      cA vm cv vf cv wf1o vf wex vm cv cA vg cv wfo vg wex cA vm cv vf vm
      visset bren cA vm cv vf cv wf1o vm cv cA vg cv wfo vg wex vf cA vm cv vf
      cv wf1o vm cv cA vf cv ccnv wf1o vm cv cA vf cv ccnv wfo vm cv cA vg cv
      wfo vg wex cA vm cv vf cv f1ocnv vm cv cA vf cv ccnv f1ofo vm cv cA vg cv
      wfo vm cv cA vf cv ccnv wfo vg vf cv ccnv vf cv vf visset cnvex vm cv cA
      vg cv vf cv ccnv foeq1 cla4ev 3syl 19.23aiv sylbi sylan2 ancoms syl5 imp
      anasss mpancom cA vm cv cen wbr vm cv cA cen wbr vm cv com wcel cA cB cF
      wfo cA vm cv vm visset ensym ad2antrl sylanc exp32 r19.23aiv imp vm cA
      isfi sylanb $.
      $( [17-Sep-2008] $) $( [23-Mar-2006] $)

    $( Equivalence of an onto mapping and dominance for a non-empty finite set.
       Unlike ~ fodomb for arbitrary sets, this theorem does not require the
       Axiom of Choice for its proof. $)
    fodomfib $p |- ( A e. Fin ->
    ( ( A =/= (/) /\ E. f f : A -onto-> B ) <-> ( (/) ~< B /\ B ~<_ A ) ) ) $=
      cA cfn wcel cA c0 wne cA cB vf cv wfo vf wex wa c0 cB csdm wbr cB cA cdom
      wbr wa cA cfn wcel cA c0 wne cA cB vf cv wfo vf wex c0 cB csdm wbr cB cA
      cdom wbr wa cA cfn wcel cA c0 wne wa cA cB vf cv wfo c0 cB csdm wbr cB cA
      cdom wbr wa vf cA cfn wcel cA c0 wne wa cA cB vf cv wfo c0 cB csdm wbr cB
      cA cdom wbr cA cfn wcel cA c0 wne wa cA cB vf cv wfo c0 cB csdm wbr cA
      cfn wcel cA c0 wne wa cA cB vf cv wfo wa c0 cB csdm wbr cB c0 wne cA c0
      wne cA cB vf cv wfo cB c0 wne cA cfn wcel cA cB vf cv wfo cA c0 wne cB c0
      wne cA cB vf cv wfo cA c0 cB c0 cA cB vf cv wfo vf cv cdm c0 wceq cA c0
      wceq cB c0 wceq cA cB vf cv wfo vf cv cdm cA c0 cA cB vf cv wfo cA cB vf
      cv wf vf cv cdm cA wceq cA cB vf cv fof cA cB vf cv fdm syl eqeq1d cA cB
      vf cv wfo vf cv crn c0 wceq cB c0 wceq vf cv cdm c0 wceq cA cB vf cv wfo
      vf cv crn cB c0 cA cB vf cv forn eqeq1d vf cv dm0rn0 syl5bb bitr3d
      necon3bid biimpac adantll cA cfn wcel cA cB vf cv wfo c0 cB csdm wbr cB
      c0 wne wb cA c0 wne cA cfn wcel cA cB vf cv wfo wa cB cvv wcel c0 cB csdm
      wbr cB c0 wne wb cA cfn wcel cA cB vf cv wfo cB cvv wcel cA cB cfn vf cv
      fornex imp cB cvv 0sdomg syl adantlr mpbird ex cA cfn wcel cA cB vf cv
      wfo cB cA cdom wbr wi cA c0 wne cA cfn wcel cA cB vf cv wfo cB cA cdom
      wbr cA cB vf cv fodomfi ex adantr jcad 19.23adv expimpd cA cfn wcel c0 cB
      csdm wbr cB cA cdom wbr wa cA c0 wne cA cB vf cv wfo vf wex cA cfn wcel
      c0 cB csdm wbr cB cA cdom wbr wa c0 cA csdm wbr cA c0 wne c0 cB cA cfn
      sdomdomtr cA cfn 0sdomg sylibd cA cfn wcel c0 cB csdm wbr cB cA cdom wbr
      cA cB vf cv wfo vf wex cA cB cfn vf fodomr 3expib jcad impbid $.
      $( [8-Oct-2008] $) $( [23-Mar-2006] $)
  $}

  ${
    $d w x y z A $.  $d w y z B $.
    $( If a function has a finite domain, its range is finite.  Theorem 37 of
       [Suppes] p. 104. $)
    fofi $p |- ( ( A e. Fin /\ F : A -onto-> B ) -> B e. Fin ) $=
      cA cfn wcel cA cB cF wfo cB cA cdom wbr cB cfn wcel cA cB cF fodomfi cA
      cB domfi syldan $.
      $( [14-Oct-2008] $) $( [25-Mar-2007] $)

    $( The finite union of finite sets is finite.  Exercise 13 of [Enderton]
       p. 144.  This is the indexed union version of ~ unifi .  Note that ` B `
       depends on ` x ` , i.e. can be thought of as ` B ( x ) ` . $)
    iunfi $p |- ( ( A e. Fin /\ A. x e. A B e. Fin )
        -> U_ x e. A B e. Fin ) $=
      cA cfn wcel cB cfn wcel vx cA wral wa vx cA cB ciun cfn wcel vy cv cB
      wceq vx cA wrex vy cab cuni cfn wcel vy cv cB wceq vx cA wrex vy cab cfn
      wcel vy cv cfn wcel vy vy cv cB wceq vx cA wrex vy cab wral vy cv cB wceq
      vx cA wrex vy cab cuni cfn wcel cA cfn wcel cB cfn wcel vx cA wral wa vy
      cv cB wceq vx cA wrex vy cab cfn wcel vz cv cfn wcel vz vy cv cB wceq vx
      cA wrex vy cab wral vy cv cB wceq vx cA wrex vy cab cuni cfn wcel vy cv
      cfn wcel vy vy cv cB wceq vx cA wrex vy cab wral vz vy cv cB wceq vx cA
      wrex vy cab unifi vy cv cfn wcel vz cv cfn wcel vy vz vw vy cv cB wceq vx
      cA wrex vy cab vy cv cB wceq vx cA wrex vy vw hbab1 vw cv vy cv cB wceq
      vx cA wrex vy cab wcel vz ax-17 vy cv cfn wcel vz ax-17 vz cv cfn wcel vy
      ax-17 vy cv vz cv cfn eleq1 cbvralf sylan2b cA cfn wcel cB cvv wcel vx cA
      wral vy cv cB wceq vx cA wrex vy cab cfn wcel cB cfn wcel vx cA wral cA
      cfn wcel cB cvv wcel vx cA wral vy cv cB wceq vx cA wrex vy cab cA cdom
      wbr vy cv cB wceq vx cA wrex vy cab cfn wcel cA cfn wcel cB cvv wcel vx
      cA wral wa vx cv cA wcel vy cv cB wceq wa vx vy copab crn cA vy cv cB
      wceq vx cA wrex vy cab cdom cA cfn wcel cA vx cv cA wcel vy cv cB wceq wa
      vx vy copab crn vx cv cA wcel vy cv cB wceq wa vx vy copab wfo vx cv cA
      wcel vy cv cB wceq wa vx vy copab crn cA cdom wbr cB cvv wcel vx cA wral
      cA vx cv cA wcel vy cv cB wceq wa vx vy copab crn vx cv cA wcel vy cv cB
      wceq wa vx vy copab fodomfi cB cvv wcel vx cA wral vx cv cA wcel vy cv cB
      wceq wa vx vy copab cA wfn cA vx cv cA wcel vy cv cB wceq wa vx vy copab
      crn vx cv cA wcel vy cv cB wceq wa vx vy copab wfo vx vy cA cB vx cv cA
      wcel vy cv cB wceq wa vx vy copab vx cv cA wcel vy cv cB wceq wa vx vy
      copab eqid fnopab2g cA vx cv cA wcel vy cv cB wceq wa vx vy copab dffn4
      bitri sylan2b vx vy cA cB rnopab2 syl5eqbrr cA vy cv cB wceq vx cA wrex
      vy cab domfi syldan cB cfn wcel cB cvv wcel vx cA cB cfn elisset r19.20si
      sylan2 cA cfn wcel cB cfn wcel vx cA wral wa vy cv cfn wcel vy vy cv cB
      wceq vx cA wrex vy cab cA cfn wcel cB cfn wcel vx cA wral wa vy cv cB
      wceq vx cA wrex vy cv cfn wcel vy cv vy cv cB wceq vx cA wrex vy cab wcel
      cB cfn wcel vx cA wral vy cv cB wceq vx cA wrex vy cv cfn wcel wi cA cfn
      wcel cB cfn wcel vx cA wral vy cv cB wceq vx cA wrex vy cv cfn wcel cB
      cfn wcel vx cA wral vy cv cB wceq vx cA wrex wa cB cfn wcel vy cv cB wceq
      wa vx cA wrex vy cv cfn wcel cB cfn wcel vy cv cB wceq vx cA r19.29 cB
      cfn wcel vy cv cB wceq wa vy cv cfn wcel vx cA cB cfn wcel vy cv cB wceq
      wa vy cv cfn wcel wi vx cv cA wcel cB cfn wcel vy cv cB wceq vy cv cfn
      wcel cB cfn vy cv eleq1a imp a1i r19.23aiv syl ex adantl vy cv cB wceq vx
      cA wrex vy abid syl5ib r19.21aiv sylanc cB cfn wcel vx cA wral vx cA cB
      ciun cfn wcel vy cv cB wceq vx cA wrex vy cab cuni cfn wcel wb cA cfn
      wcel cB cfn wcel vx cA wral vx cA cB ciun vy cv cB wceq vx cA wrex vy cab
      cuni cfn vx vy cA cB cfn dfiun2g eleq1d adantl mpbird $.
      $( [14-Oct-2008] $) $( [23-Mar-2006] $)
  $}

  ${
    $d d F $.  $d c d y b $.  $d c d y x $.
    pwfilem.1 $e |- F =
              { <. c , y >. | ( c e. ~P b /\ y = ( c u. { x } ) ) } $.
    $( Lemma for ~ pwfi . $)
    pwfilem $p |- ( ~P b e. Fin ->
                    ~P ( b u. { x } ) e. Fin ) $=
      vb cv cpw cfn wcel vb cv vx cv csn cun cpw vb cv cpw cdif vb cv cpw cun
      cfn wcel vb cv vx cv csn cun cpw cfn wcel vb cv vx cv csn cun cpw vb cv
      cpw cdif cfn wcel vb cv cpw cfn wcel vb cv vx cv csn cun cpw vb cv cpw
      cdif vb cv cpw cun cfn wcel cF crn cfn wcel vb cv vx cv csn cun cpw vb cv
      cpw cdif cF crn cdom wbr vb cv vx cv csn cun cpw vb cv cpw cdif cfn wcel
      vb cv cpw cfn wcel cF crn vb cv vx cv csn cun cpw vb cv cpw cdif domfi vb
      cv cpw cfn wcel cF crn vb cv cpw cdom wbr cF crn cfn wcel vb cv cpw cfn
      wcel vb cv cpw cF crn cF wfo cF crn vb cv cpw cdom wbr cF vb cv cpw wfn
      vb cv cpw cF crn cF wfo vc vy vb cv cpw vc cv vx cv csn cun cF vc cv vx
      cv csn vc visset vx cv snex unex pwfilem.1 fnopab2 vb cv cpw cF dffn4
      mpbi vb cv cpw cF crn cF fodomfi mpan2 vb cv cpw cF crn domfi mpdan vb cv
      vx cv csn cun cpw vb cv cpw cdif cvv wcel vb cv vx cv csn cun cpw vb cv
      cpw cdif cF crn wss vb cv vx cv csn cun cpw vb cv cpw cdif cF crn cdom
      wbr vb cv vx cv csn cun cpw cvv wcel vb cv vx cv csn cun cpw vb cv cpw
      cdif cvv wcel vb cv vx cv csn cun vb cv vx cv csn vb visset vx cv snex
      unex pwex vb cv vx cv csn cun cpw vb cv cpw cvv difexg ax-mp vd vb cv vx
      cv csn cun cpw vb cv cpw cdif cF crn vd cv vb cv vx cv csn cun cpw vb cv
      cpw cdif wcel vd cv vc cv vx cv csn cun wceq vc vb cv cpw wrex vd cv cF
      crn wcel vd cv vx cv csn cdif vb cv cpw wcel vd cv vd cv vx cv csn cdif
      vx cv csn cun wceq vd cv vc cv vx cv csn cun wceq vc vb cv cpw wrex vd cv
      vb cv vx cv csn cun cpw vb cv cpw cdif wcel vd cv vc cv vx cv csn cun
      wceq vd cv vd cv vx cv csn cdif vx cv csn cun wceq vc vd cv vx cv csn
      cdif vb cv cpw vc cv vd cv vx cv csn cdif wceq vc cv vx cv csn cun vd cv
      vx cv csn cdif vx cv csn cun vd cv vc cv vd cv vx cv csn cdif vx cv csn
      uneq1 eqeq2d rcla4ev vd cv vb cv vx cv csn cun cpw vb cv cpw cdif wcel vd
      cv vb cv vx cv csn cun cpw wcel vd cv vx cv csn cdif vb cv cpw wcel vd cv
      vb cv vx cv csn cun cpw vb cv cpw eldifi vd cv vb cv vx cv csn vx cv snex
      elpwun sylib vd cv vb cv vx cv csn cun cpw vb cv cpw cdif wcel vd cv vx
      cv csn cun vd cv vd cv vx cv csn cdif vx cv csn cun vd cv vb cv vx cv csn
      cun cpw vb cv cpw cdif wcel vx cv csn vd cv wss vd cv vx cv csn cun vd cv
      wceq vd cv vb cv vx cv csn cun cpw vb cv cpw cdif wcel vx cv vd cv wcel
      vx cv csn vd cv wss vd cv vb cv vx cv elpwunsn vx cv vd cv snssi syl vx
      cv csn vd cv ssequn2 sylib vd cv vx cv csn undif1 syl5req sylanc vc vy vb
      cv cpw vc cv vx cv csn cun vd cv cF vc cv vx cv csn vc visset vx cv snex
      unex pwfilem.1 elrnopab sylibr ssriv vb cv vx cv csn cun cpw vb cv cpw
      cdif cF crn cvv ssdomg mp2 sylancl vb cv vx cv csn cun cpw vb cv cpw cdif
      vb cv cpw unfi mpancom vb cv vx cv csn cun cpw vb cv vx cv csn cun cpw vb
      cv cpw cdif vb cv cpw cun cfn vb cv vx cv csn pwundif eleq1i sylibr $.
      $( [19-Sep-2008] $) $( [26-Mar-2007] $)
  $}

  ${
    $d m A $.  $d c k m y $.
    $( The power set of a finite set is finite and vice-versa.  Theorem 38 of
       [Suppes] p. 104 and its converse, Theorem 40 of [Suppes] p. 105. $)
    pwfi $p |- ( A e. Fin <-> ~P A e. Fin ) $=
      cA cfn wcel cA cpw cfn wcel cA cfn wcel cA vm cv cen wbr vm com wrex cA
      cpw cfn wcel vm cA isfi cA vm cv cen wbr cA cpw cfn wcel vm com cA vm cv
      cen wbr cA cpw cfn wcel vm cv cpw cfn wcel vm cv com wcel vm cv cpw cvv
      wcel cA cpw vm cv cpw cen wbr cA cpw cfn wcel vm cv cpw cfn wcel wb cA vm
      cv cen wbr cA cpw vm cv cpw cvv enfi vm cv vm visset pwex cA vm cv vm
      visset pwen sylancr vm cv cpw cfn wcel c0 cpw cfn wcel vk cv cpw cfn wcel
      vk cv vk cv csn cun cpw cfn wcel vm vk vm cv c0 wceq vm cv cpw c0 cpw cfn
      vm cv c0 pweq eleq1d vm cv vk cv wceq vm cv cpw vk cv cpw cfn vm cv vk cv
      pweq eleq1d vm cv vk cv csuc wceq vm cv cpw vk cv vk cv csn cun cpw cfn
      vm cv vk cv csuc wceq vm cv cpw vk cv csuc cpw vk cv vk cv csn cun cpw vm
      cv vk cv csuc pweq vk cv csuc vk cv vk cv csn cun wceq vk cv csuc cpw vk
      cv vk cv csn cun cpw wceq vk cv df-suc vk cv csuc vk cv vk cv csn cun
      pweq ax-mp syl6eq eleq1d c0 cpw c1o cfn c0 cpw c0 csn c1o pw0 df1o2
      eqtr4i c1o com wcel c1o c1o wss c1o cfn wcel 1onn c1o ssid c1o c1o ssnnfi
      mp2an eqeltri vk cv cpw cfn wcel vk cv vk cv csn cun cpw cfn wcel wi vk
      cv com wcel vk vy vc cv vk cv cpw wcel vy cv vc cv vk cv csn cun wceq wa
      vc vy copab vk vc vc cv vk cv cpw wcel vy cv vc cv vk cv csn cun wceq wa
      vc vy copab eqid pwfilem a1i finds1 syl5cbir r19.23aiv sylbi cA cpw cfn
      wcel cA cA cpw cdom wbr cA cfn wcel cA cpw cfn wcel cA cvv wcel cA cA cpw
      csdm wbr cA cA cpw cdom wbr cA cpw cfn wcel cA cpw cvv wcel cA cvv wcel
      cA cpw cfn elisset cA pwexb sylibr cA cvv canth2g cA cA cpw sdomdom 3syl
      cA cpw cA domfi mpdan impbii $.
      $( [20-Sep-2008] $) $( [26-Mar-2007] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Theorem *54.43 of [WhiteheadRussell] p. 360.  "From this proposition it
       will follow, when arithmetical addition has been defined, that 1+1=2."
       See ~ http://en.wikipedia.org/wiki/Principia_Mathematica#Quotations .
       This theorem states that two sets of cardinality 1 are disjoint iff
       their union has cardinality 2.

       Whitehead and Russell define 1 as the collection of all sets with
       cardinality 1 (i.e. all singletons; see ~ card1 ), so that their
       ` A e. 1 ` means, in our notation, ` A e. { x | ( card `` x ) = 1o } `
       i.e.  ` ( card `` A ) = 1o ` (by ~ elab ) i.e.  ` A ~~ 1o ` (by ~ carden
       and ~ cardnn ). We do not have several of their earlier lemmas available
       (which would otherwise be unused by our different approach to
       arithmetic), so our proof is longer.  (It is also longer because we must
       show every detail.)

       Theorem ~ pm110.643 shows the derivation of 1+1=2 for cardinal numbers
       from this theorem. $)
    pm54.43 $p |- ( ( A ~~ 1o /\ B ~~ 1o ) -> ( ( A i^i B ) = (/) <->
                  ( A u. B ) ~~ 2o ) ) $=
      cA c1o cen wbr cB c1o cen wbr wa cA cB cin c0 wceq cA cB cun c2o cen wbr
      cA c1o cen wbr cB c1o cen wbr wa cA cB cin c0 wceq cA cB cun c1o c1o csn
      cun cen wbr cA cB cun c2o cen wbr cA c1o cen wbr cB c1o csn cen wbr cA cB
      cin c0 wceq cA cB cun c1o c1o csn cun cen wbr wi cB c1o cen wbr cA c1o
      cen wbr cB c1o csn cen wbr wa cA cB cin c0 wceq cA cB cun c1o c1o csn cun
      cen wbr cA c1o cen wbr cB c1o csn cen wbr wa cA cB cin c0 wceq c1o c1o
      csn cin c0 wceq cA cB cun c1o c1o csn cun cen wbr c1o c1o csn cin c0 wceq
      c1o c1o wcel wn c1o 1on onirri c1o c1o disjsn mpbir cA c1o cB c1o csn
      unen mpanr2 ex cB c1o cen wbr c1o c1o csn cen wbr cB c1o csn cen wbr c1o
      csn c1o c1o con0 1on elisseti c1o c1o con0 1on elisseti ensn1 ensymi cB
      c1o c1o csn entr mpan2 sylan2 c2o c1o c1o csn cun cA cB cun cen c2o c1o
      csuc c1o c1o csn cun df-2o c1o df-suc eqtri breq2i syl6ibr cA vx cv csn
      wceq vx wex cB vy cv csn wceq vy wex cA cB cun c2o cen wbr cA cB cin c0
      wceq wi cA c1o cen wbr cB c1o cen wbr cA vx cv csn wceq vx wex cB vy cv
      csn wceq vy wex cA cB cun c2o cen wbr cA cB cin c0 wceq wi cA vx cv csn
      wceq cB vy cv csn wceq vy wex cA cB cun c2o cen wbr cA cB cin c0 wceq wi
      wi vx cA vx cv csn wceq cB vy cv csn wceq cA cB cun c2o cen wbr cA cB cin
      c0 wceq wi vy cA vx cv csn wceq cB vy cv csn wceq cA cB cun c2o cen wbr
      cA cB cin c0 wceq wi cA vx cv csn wceq cB vy cv csn wceq wa vx cv csn vy
      cv csn cun c2o cen wbr vx cv csn vy cv csn cin c0 wceq cA cB cun c2o cen
      wbr cA cB cin c0 wceq vx cv csn vy cv csn cun c2o cen wbr vx cv csn vy cv
      csn cin c0 wceq wi cA vx cv csn wceq cB vy cv csn wceq wa vx cv csn vy cv
      csn cun c2o cen wbr vx cv vy cv wne vx cv csn vy cv csn cin c0 wceq vx cv
      csn vy cv csn cun c2o cen wbr vx cv vy cv vx cv vy cv wceq vx cv csn vy
      cv csn cun c2o csdm wbr vx cv csn vy cv csn cun c2o cen wbr wn vx cv vy
      cv wceq vx cv csn vy cv csn cun vx cv csn c2o csdm vx cv vy cv wceq vx cv
      csn vx cv csn cun vx cv csn vy cv csn cun vx cv csn vx cv vy cv wceq vx
      cv csn vy cv csn vx cv csn vx cv vy cv sneq uneq2d vx cv csn unidm
      syl5reqr vx cv csn c1o cen wbr c1o c2o csdm wbr vx cv csn c2o csdm wbr vx
      cv vx visset ensn1 1sdom2 vx cv csn c1o c2o ensdomtr mp2an syl6eqbr vx cv
      csn vy cv csn cun c2o sdomnen syl necon2ai vx cv vy cv disjsn2 syl a1i cA
      vx cv csn wceq cB vy cv csn wceq wa cA cB cun vx cv csn vy cv csn cun c2o
      cen cA vx cv csn cB vy cv csn uneq12 breq1d cA vx cv csn wceq cB vy cv
      csn wceq wa cA cB cin vx cv csn vy cv csn cin c0 cA vx cv csn cB vy cv
      csn ineq12 eqeq1d 3imtr4d ex 19.23adv 19.23aiv imp vx cA en1 vy cB en1
      syl2anb impbid $.
      $( [4-Apr-2007] $) $( [4-Apr-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Supremum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Add new constant symbol. $)
  $c sup $.  $( Supremum. $)

  $( Extend class notation to include supremum of class ` A ` .  Here ` R `
     is ordinarily a relation that strictly orders class ` B ` .  For example,
     ` R ` could be 'less than' and ` B ` could be the set of real numbers. $)
  csup $a class sup ( A , B , R ) $.

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    $( Define the supremum of class ` B ` .  It is meaningful when ` R `
       is a relation that strictly orders ` A ` and when the supremum
       exists.  For example, ` R ` could be 'less than', ` A ` could be the
       set of real numbers, and ` B ` could be the set of all positive
       reals whose square is less than 2; in this case the supremum is defined
       as the square root of 2 per ~ sqrval .

       We will also use this notation for "infimum" by replacing ` R ` with
       ` ``' R ` . $)
    df-sup $a |- sup ( B , A , R ) = U. { x e. A | ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) } $.

    $( can't be used if A is a proper class... important?  we already
       have U. as sup for On... but since sup exists, can't use sup for
       On anyway e.g. sup of On itself.
    df-supNEW $a |- sup = { <. <. x , y >. , z >. | z =
             U. { w e. ( 1st ` x ) | ( A. v e. y -. w ( 2nd ` x ) v /\
                  A. v e. ( 1st ` x ) ( v ( 2nd ` x ) w ->
                 E. u e. y v ( 2nd ` x ) u ) ) } } $.
    $)
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.  $d x y z C $.

    $( Equality theorem for supremum. $)
    supeq1 $p |- ( B = C -> sup ( B , A , R ) = sup ( C , A , R ) ) $=
      cB cC wceq vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab cuni vx cv vy cv cR wbr
      wn vy cC wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cC wrex wi vy cA
      wral wa vx cA crab cuni cB cA cR csup cC cA cR csup cB cC wceq vx cv vy
      cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA wral wa vx cA crab vx cv vy cv cR wbr wn vy cC wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cC wrex wi vy cA wral wa vx cA crab cB cC
      wceq vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy cC wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cC wrex wi vy cA wral wa vx cA cB cC wceq
      vx cv vy cv cR wbr wn vy cB wral vx cv vy cv cR wbr wn vy cC wral vy cv
      vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cC wrex wi vy cA wral vx cv vy cv cR wbr wn vy
      cB cC raleq1 cB cC wceq vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cv vx cv cR wbr vy cv vz cv cR wbr vz cC wrex wi vy cA cB cC wceq
      vy cv vz cv cR wbr vz cB wrex vy cv vz cv cR wbr vz cC wrex vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB cC rexeq1 imbi2d ralbidv anbi12d rabbisdv
      unieqd vx vy vz cA cB cR df-sup vx vy vz cA cC cR df-sup 3eqtr4g $.
      $( [22-May-1999] $)
  $}

  ${
    $d x y z w A $.  $d x y z w R $.  $d x y z w B $.  $d w C $.
    supmo.1 $e |- R Or A $.
    $( Any class ` B ` has at most one supremum in ` A ` (where ` R ` is
       interpreted as 'less than'). $)
    supmo $p |- E* x ( x e. A /\ ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
      vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB wrex wi vy cA wral wa wa vx wmo vx cv cA wcel vx cv vy
      cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA wral wa wa vw cv cA wcel vw cv vy cv cR wbr wn vy cB wral vy cv
      vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa wa vx cv
      vw cv wceq wi vw wal vx vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy
      cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa vw cv
      cA wcel vw cv vy cv cR wbr wn vy cB wral vy cv vw cv cR wbr vy cv vz cv
      cR wbr vz cB wrex wi vy cA wral wa wa vx vw vx cv vw cv wceq vx cv cA
      wcel vw cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral wa vw cv vy cv cR wbr wn vy cB
      wral vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx
      cv vw cv cA eleq1 vx cv vw cv wceq vx cv vy cv cR wbr wn vy cB wral vw cv
      vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral vx cv vw cv wceq vx cv vy cv cR wbr wn vw cv vy cv cR wbr wn vy
      cB vx cv vw cv wceq vx cv vy cv cR wbr vw cv vy cv cR wbr vx cv vw cv vy
      cv cR breq1 notbid ralbidv vx cv vw cv wceq vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA vx cv vw cv wceq vy cv vx cv cR wbr vy cv vw cv cR wbr vy cv vz
      cv cR wbr vz cB wrex vx cv vw cv vy cv cR breq2 imbi1d ralbidv anbi12d
      anbi12d mo4 vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa vw cv cA wcel vw cv
      vy cv cR wbr wn vy cB wral vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral wa wa wa vx cv vw cv wceq wi vw vx cv cA wcel vx cv vy
      cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA wral wa wa vw cv cA wcel vw cv vy cv cR wbr wn vy cB wral vy cv
      vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa wa vx cv
      vw cv wceq vx cv vw cv cR wbr wn vw cv vx cv cR wbr wn wa vx cv cA wcel
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa wa vw cv cA wcel vw cv vy cv cR wbr wn vy cB
      wral vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa
      wa vx cv vw cv cR wbr wn vw cv vx cv cR wbr wn vx cv cA wcel vx cv vy cv
      cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi
      vy cA wral wa wa vw cv vy cv cR wbr wn vy cB wral vy cv vw cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cv vw cv cR wbr wn vw cv
      cA wcel vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr
      vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa vy cv vw cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral vx cv vw cv cR wbr wn vw cv vy
      cv cR wbr wn vy cB wral vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy
      cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vx cv vw cv
      cR wbr wn vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral
      vx cv cA wcel vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA
      wral vx cv vy cv cR wbr wn vy cB wral vx cv vw cv cR wbr wn vx cv cA wcel
      vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cv
      vz cv cR wbr vz cB wrex wn vx cv vw cv cR wbr wn vx cv vy cv cR wbr wn vy
      cB wral vx cv cA wcel vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi
      vy cA wral wa vx cv vz cv cR wbr vz cB wrex wn vx cv vw cv cR wbr wn vx
      cv cA wcel vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral
      wa vx cv vw cv cR wbr vx cv vz cv cR wbr vz cB wrex vy cv vw cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vx cv vw cv cR wbr vx cv vz cv cR wbr vz cB
      wrex wi vy vx cv cA vy cv vx cv wceq vy cv vw cv cR wbr vx cv vw cv cR
      wbr vy cv vz cv cR wbr vz cB wrex vx cv vz cv cR wbr vz cB wrex vy cv vx
      cv vw cv cR breq1 vy cv vx cv wceq vy cv vz cv cR wbr vx cv vz cv cR wbr
      vz cB vy cv vx cv vz cv cR breq1 rexbidv imbi12d rcla4va con3d imp vx cv
      vy cv cR wbr wn vy cB wral vx cv vz cv cR wbr wn vz cB wral vx cv vz cv
      cR wbr vz cB wrex wn vx cv vy cv cR wbr wn vx cv vz cv cR wbr wn vy vz cB
      vy cv vz cv wceq vx cv vy cv cR wbr vx cv vz cv cR wbr vy cv vz cv vx cv
      cR breq2 notbid cbvralv vx cv vz cv cR wbr vz cB ralnex bitri sylan2b
      an1rs adantlrr adantrl adantrl vx cv vy cv cR wbr wn vy cB wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vw cv cA wcel vw
      cv vy cv cR wbr wn vy cB wral vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral wa wa vw cv vx cv cR wbr wn vx cv cA wcel vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vw cv cA wcel vw cv vy
      cv cR wbr wn vy cB wral vy cv vw cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA wral wa wa vw cv vx cv cR wbr wn vx cv vy cv cR wbr wn vy cB
      wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vw cv
      cA wcel vw cv vy cv cR wbr wn vy cB wral vw cv vx cv cR wbr wn vy cv vw
      cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vy cv vx cv cR wbr
      vy cv vz cv cR wbr vz cB wrex wi vy cA wral vw cv cA wcel vw cv vy cv cR
      wbr wn vy cB wral vw cv vx cv cR wbr wn vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral vw cv cA wcel wa vw cv vz cv cR wbr vz cB
      wrex wn vw cv vx cv cR wbr wn vw cv vy cv cR wbr wn vy cB wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vw cv cA wcel wa vw
      cv vz cv cR wbr vz cB wrex wn vw cv vx cv cR wbr wn vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral vw cv cA wcel wa vw cv vx cv cR
      wbr vw cv vz cv cR wbr vz cB wrex vy cv vx cv cR wbr vy cv vz cv cR wbr
      vz cB wrex wi vw cv vx cv cR wbr vw cv vz cv cR wbr vz cB wrex wi vy vw
      cv cA vy cv vw cv wceq vy cv vx cv cR wbr vw cv vx cv cR wbr vy cv vz cv
      cR wbr vz cB wrex vw cv vz cv cR wbr vz cB wrex vy cv vw cv vx cv cR
      breq1 vy cv vw cv wceq vy cv vz cv cR wbr vw cv vz cv cR wbr vz cB vy cv
      vw cv vz cv cR breq1 rexbidv imbi12d rcla4cva con3d imp vw cv vy cv cR
      wbr wn vy cB wral vw cv vz cv cR wbr wn vz cB wral vw cv vz cv cR wbr vz
      cB wrex wn vw cv vy cv cR wbr wn vw cv vz cv cR wbr wn vy vz cB vy cv vz
      cv wceq vw cv vy cv cR wbr vw cv vz cv cR wbr vy cv vz cv vw cv cR breq2
      notbid cbvralv vw cv vz cv cR wbr vz cB ralnex bitri sylan2b anasss
      adantrrr adantll adantll jca vx cv cA wcel vw cv cA wcel vx cv vw cv wceq
      vx cv vw cv cR wbr wn vw cv vx cv cR wbr wn wa wb vx cv vy cv cR wbr wn
      vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral
      wa vw cv vy cv cR wbr wn vy cB wral vy cv vw cv cR wbr vy cv vz cv cR wbr
      vz cB wrex wi vy cA wral wa cA cR wor vx cv cA wcel vw cv cA wcel wa vx
      cv vw cv wceq vx cv vw cv cR wbr wn vw cv vx cv cR wbr wn wa wb supmo.1
      cA vx cv vw cv cR sotrieq2 mpan ad2ant2r mpbird ax-gen mpgbir $.
      $( [5-May-1999] $)

    $( A supremum is a set. $)
    supex $p |- sup ( B , A , R ) e. _V $=
      cB cA cR csup vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa vx cab cuni cvv
      cB cA cR csup vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab cuni vx cv cA wcel vx
      cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral wa wa vx cab cuni vx vy vz cA cB cR df-sup vx cv vy cv
      cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi
      vy cA wral wa vx cA crab vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral
      vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa vx
      cab vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral wa vx cA df-rab unieqi eqtri vx cv cA wcel
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa wa vx cab vx cv cA wcel vx cv vy cv cR wbr wn vy
      cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa
      wa vx wmo vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa vx cab cvv wcel vx
      vy vz cA cB cR supmo.1 supmo vx cv cA wcel vx cv vy cv cR wbr wn vy cB
      wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa wa
      vx moabex ax-mp uniex eqeltri $.
      $( [22-May-1999] $)

    $( A supremum is unique.  Similar to Theorem I.26 of [Apostol] p. 24 (but
       for suprema in general). $)
    supeu $p |- ( E. x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) ->
                  E! x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex vx cv vy cv cR wbr wn vy cB wral vy
      cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex
      vx cv cA wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB wrex wi vy cA wral wa wa vx wmo wa vx cv vy cv cR wbr
      wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA
      wral wa vx cA wreu vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex vx cv cA wcel vx
      cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral wa wa vx wmo vx vy vz cA cB cR supmo.1 supmo jctr vx
      cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral wa vx cA reu5 sylibr $.
      $( [13-Oct-2004] $) $( [12-Oct-2004] $)

    $( A supremum belongs to its base class (closure law). $)
    supcl $p |- ( E. x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) ->
                sup ( B , A , R ) e. A ) $=
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex vx cv vy cv cR wbr wn vy cB wral vy
      cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab
      cuni cA cB cA cR csup vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr
      vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex vx cv vy cv cR
      wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral wa vx cA wreu vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr
      vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab cuni cA wcel vx
      vy vz cA cB cR supmo.1 supeu vx cv vy cv cR wbr wn vy cB wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA reucl syl vx
      vy vz cA cB cR df-sup syl5eqel $.
      $( [13-Oct-2004] $) $( [12-Oct-2004] $)

    $( A supremum is an upper bound. $)
    supub $p |- ( E. x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) ->
                 ( C e. B -> -. sup ( B , A , R ) R C ) ) $=
      cC cB wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup cC cR wbr
      wn vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
      vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup vw cv cR wbr wn wi
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup cC cR wbr wn wi vw cC
      cB vw cv cC wceq cB cA cR csup vw cv cR wbr wn cB cA cR csup cC cR wbr wn
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex vw cv cC wceq cB cA cR csup vw cv cR
      wbr cB cA cR csup cC cR wbr vw cv cC cB cA cR csup cR breq2 notbid imbi2d
      vw cv cB wcel cB cA cR csup vy cv cR wbr wn vy cB wral cB cA cR csup vw
      cv cR wbr wn vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup vy cv cR
      wbr wn cB cA cR csup vw cv cR wbr wn vy vw cv cB vy cv vw cv wceq cB cA
      cR csup vy cv cR wbr cB cA cR csup vw cv cR wbr vy cv vw cv cB cA cR csup
      cR breq2 notbid rcla4v vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR
      csup vy cv cR wbr wn vy cB wral vy cv cB cA cR csup cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral vx cv vy cv cR wbr wn vy cB wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR
      csup vy cv cR wbr wn vy cB wral vy cv cB cA cR csup cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy cB wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab cuni
      cB cA cR csup wceq cB cA cR csup vx cv vy cv cR wbr wn vy cB wral vy cv
      vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab
      cuni vx vy vz cA cB cR df-sup eqcomi cB cA cR csup cA wcel vx cv vy cv cR
      wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral wa vx cA wreu cB cA cR csup vy cv cR wbr wn vy cB wral vy cv cB
      cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cv vy
      cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA wral wa vx cA crab cuni cB cA cR csup wceq wb vx cv vy cv cR wbr
      wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA
      wral wa vx cA wrex vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral wa cB cA cR csup vy cv cR wbr wn
      vy cB wral vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral wa vx cA cB cA cR csup vx cv cB cA cR csup wceq vx cv vy cv cR
      wbr wn vy cB wral cB cA cR csup vy cv cR wbr wn vy cB wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vy cv cB cA cR csup cR
      wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vx cv cB cA cR csup wceq
      vx cv vy cv cR wbr wn cB cA cR csup vy cv cR wbr wn vy cB vx cv cB cA cR
      csup wceq vx cv vy cv cR wbr cB cA cR csup vy cv cR wbr vx cv cB cA cR
      csup vy cv cR breq1 notbid ralbidv vx cv cB cA cR csup wceq vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cv cB cA cR csup cR wbr vy cv
      vz cv cR wbr vz cB wrex wi vy cA vx cv cB cA cR csup wceq vy cv vx cv cR
      wbr vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex vx cv cB cA
      cR csup vy cv cR breq2 imbi1d ralbidv anbi12d reuuni2 vx vy vz cA cB cR
      supmo.1 supcl vx vy vz cA cB cR supmo.1 supeu sylanc mpbiri pm3.26d syl5
      vtoclga com12 $.
      $( [13-Oct-2004] $) $( [12-Oct-2004] $)

    ${
      $d z C $.
      $( A supremum is the least upper bound. $)
      suplub $p |- ( E. x e. A ( A. y e. B -. x R y /\
                      A. y e. A ( y R x -> E. z e. B y R z ) ) ->
                    ( ( C e. A /\ C R sup ( B , A , R ) ) ->
                      E. z e. B C R z ) ) $=
        vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vy cA wral wa vx cA wrex cC cA wcel cC cB cA cR csup cR
        wbr cC vz cv cR wbr vz cB wrex cC cA wcel vx cv vy cv cR wbr wn vy cB
        wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa
        vx cA wrex cC cB cA cR csup cR wbr cC vz cv cR wbr vz cB wrex wi vx cv
        vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
        wrex wi vy cA wral wa vx cA wrex vw cv cB cA cR csup cR wbr vw cv vz cv
        cR wbr vz cB wrex wi wi vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR
        wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cC cB cA
        cR csup cR wbr cC vz cv cR wbr vz cB wrex wi wi vw cC cA vw cv cC wceq
        vw cv cB cA cR csup cR wbr vw cv vz cv cR wbr vz cB wrex wi cC cB cA cR
        csup cR wbr cC vz cv cR wbr vz cB wrex wi vx cv vy cv cR wbr wn vy cB
        wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa
        vx cA wrex vw cv cC wceq vw cv cB cA cR csup cR wbr cC cB cA cR csup cR
        wbr vw cv vz cv cR wbr vz cB wrex cC vz cv cR wbr vz cB wrex vw cv cC
        cB cA cR csup cR breq1 vw cv cC wceq vw cv vz cv cR wbr cC vz cv cR wbr
        vz cB vw cv cC vz cv cR breq1 rexbidv imbi12d imbi2d vw cv cA wcel vy
        cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral vw
        cv cB cA cR csup cR wbr vw cv vz cv cR wbr vz cB wrex wi vx cv vy cv cR
        wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi
        vy cA wral wa vx cA wrex vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vw cv cB cA cR csup cR wbr vw cv vz cv cR wbr vz cB wrex
        wi vy vw cv cA vy cv vw cv wceq vy cv cB cA cR csup cR wbr vw cv cB cA
        cR csup cR wbr vy cv vz cv cR wbr vz cB wrex vw cv vz cv cR wbr vz cB
        wrex vy cv vw cv cB cA cR csup cR breq1 vy cv vw cv wceq vy cv vz cv cR
        wbr vw cv vz cv cR wbr vz cB vy cv vw cv vz cv cR breq1 rexbidv imbi12d
        rcla4v vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv
        cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup vy cv cR
        wbr wn vy cB wral vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB
        wrex wi vy cA wral vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr
        vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup
        vy cv cR wbr wn vy cB wral vy cv cB cA cR csup cR wbr vy cv vz cv cR
        wbr vz cB wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy cB wral vy cv
        vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab
        cuni cB cA cR csup wceq cB cA cR csup vx cv vy cv cR wbr wn vy cB wral
        vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA
        crab cuni vx vy vz cA cB cR df-sup eqcomi cB cA cR csup cA wcel vx cv
        vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
        wrex wi vy cA wral wa vx cA wreu cB cA cR csup vy cv cR wbr wn vy cB
        wral vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA
        wral wa vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv
        cR wbr vz cB wrex wi vy cA wral wa vx cA crab cuni cB cA cR csup wceq
        wb vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR
        wbr vz cB wrex wi vy cA wral wa vx cA wrex vx cv vy cv cR wbr wn vy cB
        wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa
        cB cA cR csup vy cv cR wbr wn vy cB wral vy cv cB cA cR csup cR wbr vy
        cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA cB cA cR csup vx cv
        cB cA cR csup wceq vx cv vy cv cR wbr wn vy cB wral cB cA cR csup vy cv
        cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
        wi vy cA wral vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex
        wi vy cA wral vx cv cB cA cR csup wceq vx cv vy cv cR wbr wn cB cA cR
        csup vy cv cR wbr wn vy cB vx cv cB cA cR csup wceq vx cv vy cv cR wbr
        cB cA cR csup vy cv cR wbr vx cv cB cA cR csup vy cv cR breq1 notbid
        ralbidv vx cv cB cA cR csup wceq vy cv vx cv cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vy cv cB cA cR csup cR wbr vy cv vz cv cR wbr vz cB wrex
        wi vy cA vx cv cB cA cR csup wceq vy cv vx cv cR wbr vy cv cB cA cR
        csup cR wbr vy cv vz cv cR wbr vz cB wrex vx cv cB cA cR csup vy cv cR
        breq2 imbi1d ralbidv anbi12d reuuni2 vx vy vz cA cB cR supmo.1 supcl vx
        vy vz cA cB cR supmo.1 supeu sylanc mpbiri pm3.27d syl5 vtoclga com12
        imp3a $.
        $( [14-Oct-2004] $) $( [13-Oct-2004] $)

      $( An upper bound is not less than the supremum. $)
      supnub $p |- ( E. x e. A ( A. y e. B -. x R y /\
                      A. y e. A ( y R x -> E. z e. B y R z ) ) ->
                    ( ( C e. A /\ A. z e. B -. C R z ) ->
                      -. C R sup ( B , A , R ) ) ) $=
        vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vy cA wral wa vx cA wrex cC cA wcel cC vz cv cR wbr wn vz
        cB wral cC cB cA cR csup cR wbr wn vx cv vy cv cR wbr wn vy cB wral vy
        cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA
        wrex cC cA wcel wa cC cB cA cR csup cR wbr cC vz cv cR wbr wn vz cB
        wral vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR
        wbr vz cB wrex wi vy cA wral wa vx cA wrex cC cA wcel wa cC cB cA cR
        csup cR wbr cC vz cv cR wbr vz cB wrex cC vz cv cR wbr wn vz cB wral wn
        vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vy cA wral wa vx cA wrex cC cA wcel cC cB cA cR csup cR
        wbr cC vz cv cR wbr vz cB wrex vx vy vz cA cB cC cR supmo.1 suplub
        expdimp cC vz cv cR wbr vz cB dfrex2 syl6ib con2d expimpd $.
        $( [14-Oct-2004] $) $( [13-Oct-2004] $)
    $}
  $}

  ${
    $d x y z w A $.  $d x y z w R $.  $d x y z w B $.  $d w C $.
    sup.1 $e |- R Or A $.
    sup.2 $e |- E. x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) $.
    $( A supremum is unique.  Similar to Theorem I.26 of [Apostol] p. 24 (but
       for suprema in general). $)
    supeui $p |- E! x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) $=
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex vx cv vy cv cR wbr wn vy cB wral vy
      cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wreu
      sup.2 vx vy vz cA cB cR sup.1 supeu ax-mp $.
      $( [23-May-1999] $)

    $( A supremum belongs to its base class (closure law). $)
    supcli $p |- sup ( B , A , R ) e. A $=
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup cA wcel sup.2 vx vy vz
      cA cB cR sup.1 supcl ax-mp $.
      $( [23-May-1999] $)

    $( A supremum is an upper bound. $)
    supubi $p |- ( C e. B -> -. sup ( B , A , R ) R C ) $=
      vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral wa vx cA wrex cC cB wcel cB cA cR csup cC cR wbr wn
      wi sup.2 vx vy vz cA cB cC cR sup.1 supub ax-mp $.
      $( [23-May-1999] $)

    ${
      $d z C $.
      $( A supremum is the least upper bound. $)
      suplubi $p |- ( ( C e. A /\ C R sup ( B , A , R ) ) ->
                    E. z e. B C R z ) $=
        vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vy cA wral wa vx cA wrex cC cA wcel cC cB cA cR csup cR
        wbr wa cC vz cv cR wbr vz cB wrex wi sup.2 vx vy vz cA cB cC cR sup.1
        suplub ax-mp $.
        $( [23-May-1999] $)

      $( An upper bound is not less than the supremum. $)
      supnubi $p |- ( ( C e. A /\ A. z e. B -. C R z ) ->
                   -. C R sup ( B , A , R ) ) $=
        vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
        vz cB wrex wi vy cA wral wa vx cA wrex cC cA wcel cC vz cv cR wbr wn vz
        cB wral wa cC cB cA cR csup cR wbr wn wi sup.2 vx vy vz cA cB cC cR
        sup.1 supnub ax-mp $.
        $( [23-May-1999] $)
    $}
  $}

  ${
    $d x A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    $( A set that contains a greatest element satisfies the antecedent in
       supremum theorems.  This allows ` sup ( A , B , R ) ` to be used in some
       situations without the completeness axiom.  (Contributed by Jeff
       Hoffman, 17-Jun-2008.) $)
    supmaxlem $p |- (  (  C e. A /\ C e. B /\ A. z e. B -. C R z ) -> E. x e. A
         (  A. y e. B -. x R y /\ A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
      cC cA wcel cC cB wcel cC vz cv cR wbr wn vz cB wral vx cv vy cv cR wbr wn
      vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral
      wa vx cA wrex cC cA wcel cC vy cv cR wbr wn vy cB wral vy cv cC cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy cB
      wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx
      cA wrex cC cB wcel cC vz cv cR wbr wn vz cB wral wa vx cv vy cv cR wbr wn
      vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral
      wa cC vy cv cR wbr wn vy cB wral vy cv cC cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA wral wa vx cC cA vx cv cC wceq vx cv vy cv cR wbr wn vy cB
      wral cC vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr
      vz cB wrex wi vy cA wral vy cv cC cR wbr vy cv vz cv cR wbr vz cB wrex wi
      vy cA wral vx cv cC wceq vx cv vy cv cR wbr wn cC vy cv cR wbr wn vy cB
      vx cv cC wceq vx cv vy cv cR wbr cC vy cv cR wbr vx cv cC vy cv cR breq1
      notbid ralbidv vx cv cC wceq vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cv cC cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA vx cv cC
      wceq vy cv vx cv cR wbr vy cv cC cR wbr vy cv vz cv cR wbr vz cB wrex vx
      cv cC vy cv cR breq2 imbi1d ralbidv anbi12d rcla4ev cC vz cv cR wbr wn vz
      cB wral cC cB wcel cC vy cv cR wbr wn vy cB wral vy cv cC cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA wral wa cC vz cv cR wbr wn vz cB wral cC vy
      cv cR wbr wn vy cB wral cC cB wcel vy cv cC cR wbr vy cv vz cv cR wbr vz
      cB wrex wi vy cA wral cC vz cv cR wbr wn vz cB wral cC vy cv cR wbr wn vy
      cB wral cC vz cv cR wbr wn cC vy cv cR wbr wn vz vy cB vz cv vy cv wceq
      cC vz cv cR wbr cC vy cv cR wbr vz cv vy cv cC cR breq2 notbid cbvralv
      biimpi cC cB wcel vy cv cC cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA
      cC cB wcel vy cv cC cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cv cA wcel
      cC cB wcel vy cv cC cR wbr vy cv vz cv cR wbr vz cB wrex vy cv vz cv cR
      wbr vy cv cC cR wbr vz cC cB vz cv cC vy cv cR breq2 rcla4ev ex a1d
      r19.21aiv anim12i ancoms sylan2 3impb $.
      $( [1-Jul-2008] $) $( [17-Jun-2008] $)
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d R x y z $.
    supmax.1 $e  |- R Or A $.
    $( The greatest element of a set is its supremum.  Note that the converse
       is not true; the supremum might not be an element of the set considered.
       (Contributed by Jeff Hoffman, 17-Jun-2008.) $)
    supmax $p    |- ( (  C e. A /\ C e. B /\ A. y e. B -. C R y )
                           -> sup ( B , A , R ) = C ) $=
      cC cA wcel cC cB wcel cC vy cv cR wbr wn vy cB wral w3a cB cA cR csup cC
      wceq cB cA cR csup cC cR wbr wn cC cB cA cR csup cR wbr wn wa cC cA wcel
      cC cB wcel cC vy cv cR wbr wn vy cB wral w3a cB cA cR csup cC cR wbr wn
      cC cB cA cR csup cR wbr wn vx cv vz cv cR wbr wn vz cB wral vz cv vx cv
      cR wbr vz cv vy cv cR wbr vy cB wrex wi vz cA wral wa vx cA wrex cC cB
      wcel cB cA cR csup cC cR wbr wn cC cA wcel cC cB wcel cC vy cv cR wbr wn
      vy cB wral w3a vx vz vy cA cB cC cR supmax.1 supub vx vz vy cA cB cC cR
      supmaxlem cC cA wcel cC cB wcel cC vy cv cR wbr wn vy cB wral 3simp2 sylc
      vx cv vz cv cR wbr wn vz cB wral vz cv vx cv cR wbr vz cv vy cv cR wbr vy
      cB wrex wi vz cA wral wa vx cA wrex cC cA wcel cC vy cv cR wbr wn vy cB
      wral wa cC cB cA cR csup cR wbr wn cC cA wcel cC cB wcel cC vy cv cR wbr
      wn vy cB wral w3a vx vz vy cA cB cC cR supmax.1 supnub vx vz vy cA cB cC
      cR supmaxlem cC cA wcel cC cB wcel cC vy cv cR wbr wn vy cB wral 3simpb
      sylc jca cB cA cR csup cA wcel cC cA wcel cB cA cR csup cC wceq cB cA cR
      csup cC cR wbr wn cC cB cA cR csup cR wbr wn wa wb cC cA wcel cC cB wcel
      cC vy cv cR wbr wn vy cB wral w3a cA cR wor cB cA cR csup cA wcel cC cA
      wcel wa cB cA cR csup cC wceq cB cA cR csup cC cR wbr wn cC cB cA cR csup
      cR wbr wn wa wb supmax.1 cA cB cA cR csup cC cR sotrieq2 mpan cC cA wcel
      cC cB wcel cC vy cv cR wbr wn vy cB wral w3a vx cv vz cv cR wbr wn vz cB
      wral vz cv vx cv cR wbr vz cv vy cv cR wbr vy cB wrex wi vz cA wral wa vx
      cA wrex cB cA cR csup cA wcel vx vz vy cA cB cC cR supmaxlem vx vz vy cA
      cB cR supmax.1 supcl syl cC cA wcel cC cB wcel cC vy cv cR wbr wn vy cB
      wral 3simp1 sylanc mpbird $.
      $( [1-Jul-2008] $) $( [17-Jun-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    suppr.1 $e |- R Or A $.
    $( The supremum of a pair. $)
    suppr $p |- ( ( B e. A /\ C e. A ) -> sup ( { B , C } , A , R ) =
                if ( C R B , B , C ) ) $=
      cB cA wcel cC cA wcel wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cA
      crab cuni cC cB cR wbr cB cC cif cB cC cpr cA cR csup cB cA wcel cC cA
      wcel wa cC cB cR wbr cB cC cif vy cv cR wbr wn vy cB cC cpr wral vy cv cC
      cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA
      wral wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cA crab cuni cC cB cR
      wbr cB cC cif wceq cB cA wcel cC cA wcel wa cC cB cR wbr cB cC cif vy cv
      cR wbr wn vy cB cC cpr wral vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz
      cv cR wbr vz cB cC cpr wrex wi vy cA wral cB cA wcel cC cA wcel wa cC cB
      cR wbr cB cC cif vy cv cR wbr wn vy cB cC cpr cB cA wcel cC cA wcel wa vy
      cv cB wceq vy cv cC wceq wo cC cB cR wbr cB cC cif vy cv cR wbr wn vy cv
      cB cC cpr wcel cB cA wcel cC cA wcel wa cC cB cR wbr vy cv cB wceq vy cv
      cC wceq wo cC cB cR wbr cB cC cif vy cv cR wbr wn wi cB cA wcel cC cA
      wcel wa cC cB cR wbr wa vy cv cB wceq vy cv cC wceq wo cB vy cv cR wbr wn
      cC cB cR wbr cB cC cif vy cv cR wbr wn cB cA wcel cC cA wcel wa cC cB cR
      wbr wa vy cv cB wceq cB vy cv cR wbr wn vy cv cC wceq vy cv cB wceq cB vy
      cv cR wbr wn cB cB cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wa vy
      cv cB wceq cB vy cv cR wbr cB cB cR wbr vy cv cB cB cR breq2 notbid cB cA
      wcel cB cB cR wbr wn cC cA wcel cC cB cR wbr cA cR wor cB cA wcel cB cB
      cR wbr wn suppr.1 cA cB cR sonr mpan ad2antrr syl5cbir vy cv cC wceq cB
      vy cv cR wbr wn cB cC cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wa
      vy cv cC wceq cB vy cv cR wbr cB cC cR wbr vy cv cC cB cR breq2 notbid cB
      cA wcel cC cA wcel wa cC cB cR wbr cB cC cR wbr wn cC cA wcel cB cA wcel
      cC cB cR wbr cB cC cR wbr wn wi cC cA wcel cB cA wcel wa cC cB cR wbr cB
      cC cR wbr wa wn cC cB cR wbr cB cC cR wbr wn wi cA cR wor cC cA wcel cB
      cA wcel wa cC cB cR wbr cB cC cR wbr wa wn suppr.1 cA cC cB cR so2nr mpan
      cC cB cR wbr cB cC cR wbr imnan sylibr ancoms imp syl5cbir jaod cC cB cR
      wbr cC cB cR wbr cB cC cif vy cv cR wbr wn cB vy cv cR wbr wn wb cB cA
      wcel cC cA wcel wa cC cB cR wbr cC cB cR wbr cB cC cif vy cv cR wbr cB vy
      cv cR wbr cC cB cR wbr cC cB cR wbr cB cC cif cB vy cv cR cC cB cR wbr cB
      cC iftrue breq1d notbid adantl sylibrd cB cA wcel cC cA wcel wa cC cB cR
      wbr wn wa vy cv cB wceq vy cv cC wceq wo cC vy cv cR wbr wn cC cB cR wbr
      cB cC cif vy cv cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wn wa vy
      cv cB wceq cC vy cv cR wbr wn vy cv cC wceq vy cv cB wceq cC vy cv cR wbr
      wn cC cB cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wn wa vy cv cB
      wceq cC vy cv cR wbr cC cB cR wbr vy cv cB cC cR breq2 notbid cB cA wcel
      cC cA wcel wa cC cB cR wbr wn pm3.27 syl5cbir vy cv cC wceq cC vy cv cR
      wbr wn cC cC cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wn wa vy cv
      cC wceq cC vy cv cR wbr cC cC cR wbr vy cv cC cC cR breq2 notbid cC cA
      wcel cC cC cR wbr wn cB cA wcel cC cB cR wbr wn cA cR wor cC cA wcel cC
      cC cR wbr wn suppr.1 cA cC cR sonr mpan ad2antlr syl5cbir jaod cC cB cR
      wbr wn cC cB cR wbr cB cC cif vy cv cR wbr wn cC vy cv cR wbr wn wb cB cA
      wcel cC cA wcel wa cC cB cR wbr wn cC cB cR wbr cB cC cif vy cv cR wbr cC
      vy cv cR wbr cC cB cR wbr wn cC cB cR wbr cB cC cif cC vy cv cR cC cB cR
      wbr cB cC iffalse breq1d notbid adantl sylibrd pm2.61dan vy cv cB cC vy
      visset elpr syl5ib r19.21aiv cB cA wcel cC cA wcel wa vy cv cC cB cR wbr
      cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA cB cA wcel
      cC cA wcel wa vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz
      cB cC cpr wrex wi vy cv cA wcel cB cA wcel cC cA wcel wa vy cv cC cB cR
      wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex cC cB cR wbr cB
      cC cif cB cC cpr wcel vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz cv cR
      wbr vz cB cC cpr wrex cB cA wcel cC cA wcel wa vy cv vz cv cR wbr vy cv
      cC cB cR wbr cB cC cif cR wbr vz cC cB cR wbr cB cC cif cB cC cpr vz cv
      cC cB cR wbr cB cC cif vy cv cR breq2 rcla4ev cC cB cR wbr cB cC cA cA
      ifpr sylan ex a1d r19.21aiv jca cC cB cR wbr cB cC cif cA wcel vx cv vy
      cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB cC cpr wrex wi vy cA wral wa vx cA wreu cC cB cR wbr cB cC cif vy cv
      cR wbr wn vy cB cC cpr wral vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz
      cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy cB
      cC cpr wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy
      cA wral wa vx cA crab cuni cC cB cR wbr cB cC cif wceq wb cB cA wcel cC
      cA wcel wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa cC cB cR wbr cB cC cif
      vy cv cR wbr wn vy cB cC cpr wral vy cv cC cB cR wbr cB cC cif cR wbr vy
      cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cA cC cB cR wbr cB
      cC cif vx cv cC cB cR wbr cB cC cif wceq vx cv vy cv cR wbr wn vy cB cC
      cpr wral cC cB cR wbr cB cC cif vy cv cR wbr wn vy cB cC cpr wral vy cv
      vx cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral vy cv cC
      cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA
      wral vx cv cC cB cR wbr cB cC cif wceq vx cv vy cv cR wbr wn cC cB cR wbr
      cB cC cif vy cv cR wbr wn vy cB cC cpr vx cv cC cB cR wbr cB cC cif wceq
      vx cv vy cv cR wbr cC cB cR wbr cB cC cif vy cv cR wbr vx cv cC cB cR wbr
      cB cC cif vy cv cR breq1 notbid ralbidv vx cv cC cB cR wbr cB cC cif wceq
      vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cv cC cB cR
      wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA vx cv
      cC cB cR wbr cB cC cif wceq vy cv vx cv cR wbr vy cv cC cB cR wbr cB cC
      cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex vx cv cC cB cR wbr cB cC
      cif vy cv cR breq2 imbi1d ralbidv anbi12d reuuni2 cC cB cR wbr cB cC cA
      ifcl cB cA wcel cC cA wcel wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy
      cv vx cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx
      cA wrex vx cv cA wcel vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa wa vx wmo wa
      vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB cC cpr wrex wi vy cA wral wa vx cA wreu cB cA wcel cC cA wcel
      wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv vz cv
      cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cA wrex vx cv cA wcel vx cv
      vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv vz cv cR wbr
      vz cB cC cpr wrex wi vy cA wral wa wa vx wmo cC cB cR wbr cB cC cif cA
      wcel cC cB cR wbr cB cC cif vy cv cR wbr wn vy cB cC cpr wral vy cv cC cB
      cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA
      wral wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cA wrex cB cA wcel cC
      cA wcel wa vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa cC cB cR wbr cB cC cif
      vy cv cR wbr wn vy cB cC cpr wral vy cv cC cB cR wbr cB cC cif cR wbr vy
      cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral wa vx cC cB cR wbr cB cC
      cif cA vx cv cC cB cR wbr cB cC cif wceq vx cv vy cv cR wbr wn vy cB cC
      cpr wral cC cB cR wbr cB cC cif vy cv cR wbr wn vy cB cC cpr wral vy cv
      vx cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA wral vy cv cC
      cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA
      wral vx cv cC cB cR wbr cB cC cif wceq vx cv vy cv cR wbr wn cC cB cR wbr
      cB cC cif vy cv cR wbr wn vy cB cC cpr vx cv cC cB cR wbr cB cC cif wceq
      vx cv vy cv cR wbr cC cB cR wbr cB cC cif vy cv cR wbr vx cv cC cB cR wbr
      cB cC cif vy cv cR breq1 notbid ralbidv vx cv cC cB cR wbr cB cC cif wceq
      vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cv cC cB cR
      wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA vx cv
      cC cB cR wbr cB cC cif wceq vy cv vx cv cR wbr vy cv cC cB cR wbr cB cC
      cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex vx cv cC cB cR wbr cB cC
      cif vy cv cR breq2 imbi1d ralbidv anbi12d rcla4ev cC cB cR wbr cB cC cA
      ifcl cB cA wcel cC cA wcel wa cC cB cR wbr cB cC cif vy cv cR wbr wn vy
      cB cC cpr wral vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz
      cB cC cpr wrex wi vy cA wral cB cA wcel cC cA wcel wa cC cB cR wbr cB cC
      cif vy cv cR wbr wn vy cB cC cpr cB cA wcel cC cA wcel wa vy cv cB wceq
      vy cv cC wceq wo cC cB cR wbr cB cC cif vy cv cR wbr wn vy cv cB cC cpr
      wcel cB cA wcel cC cA wcel wa cC cB cR wbr vy cv cB wceq vy cv cC wceq wo
      cC cB cR wbr cB cC cif vy cv cR wbr wn wi cB cA wcel cC cA wcel wa cC cB
      cR wbr wa vy cv cB wceq vy cv cC wceq wo cB vy cv cR wbr wn cC cB cR wbr
      cB cC cif vy cv cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wa vy cv
      cB wceq cB vy cv cR wbr wn vy cv cC wceq vy cv cB wceq cB vy cv cR wbr wn
      cB cB cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wa vy cv cB wceq cB
      vy cv cR wbr cB cB cR wbr vy cv cB cB cR breq2 notbid cB cA wcel cB cB cR
      wbr wn cC cA wcel cC cB cR wbr cA cR wor cB cA wcel cB cB cR wbr wn
      suppr.1 cA cB cR sonr mpan ad2antrr syl5cbir vy cv cC wceq cB vy cv cR
      wbr wn cB cC cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wa vy cv cC
      wceq cB vy cv cR wbr cB cC cR wbr vy cv cC cB cR breq2 notbid cB cA wcel
      cC cA wcel wa cC cB cR wbr cB cC cR wbr wn cC cA wcel cB cA wcel cC cB cR
      wbr cB cC cR wbr wn wi cC cA wcel cB cA wcel wa cC cB cR wbr cB cC cR wbr
      wa wn cC cB cR wbr cB cC cR wbr wn wi cA cR wor cC cA wcel cB cA wcel wa
      cC cB cR wbr cB cC cR wbr wa wn suppr.1 cA cC cB cR so2nr mpan cC cB cR
      wbr cB cC cR wbr imnan sylibr ancoms imp syl5cbir jaod cC cB cR wbr cC cB
      cR wbr cB cC cif vy cv cR wbr wn cB vy cv cR wbr wn wb cB cA wcel cC cA
      wcel wa cC cB cR wbr cC cB cR wbr cB cC cif vy cv cR wbr cB vy cv cR wbr
      cC cB cR wbr cC cB cR wbr cB cC cif cB vy cv cR cC cB cR wbr cB cC iftrue
      breq1d notbid adantl sylibrd cB cA wcel cC cA wcel wa cC cB cR wbr wn wa
      vy cv cB wceq vy cv cC wceq wo cC vy cv cR wbr wn cC cB cR wbr cB cC cif
      vy cv cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wn wa vy cv cB wceq
      cC vy cv cR wbr wn vy cv cC wceq vy cv cB wceq cC vy cv cR wbr wn cC cB
      cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wn wa vy cv cB wceq cC vy
      cv cR wbr cC cB cR wbr vy cv cB cC cR breq2 notbid cB cA wcel cC cA wcel
      wa cC cB cR wbr wn pm3.27 syl5cbir vy cv cC wceq cC vy cv cR wbr wn cC cC
      cR wbr wn cB cA wcel cC cA wcel wa cC cB cR wbr wn wa vy cv cC wceq cC vy
      cv cR wbr cC cC cR wbr vy cv cC cC cR breq2 notbid cC cA wcel cC cC cR
      wbr wn cB cA wcel cC cB cR wbr wn cA cR wor cC cA wcel cC cC cR wbr wn
      suppr.1 cA cC cR sonr mpan ad2antlr syl5cbir jaod cC cB cR wbr wn cC cB
      cR wbr cB cC cif vy cv cR wbr wn cC vy cv cR wbr wn wb cB cA wcel cC cA
      wcel wa cC cB cR wbr wn cC cB cR wbr cB cC cif vy cv cR wbr cC vy cv cR
      wbr cC cB cR wbr wn cC cB cR wbr cB cC cif cC vy cv cR cC cB cR wbr cB cC
      iffalse breq1d notbid adantl sylibrd pm2.61dan vy cv cB cC vy visset elpr
      syl5ib r19.21aiv cB cA wcel cC cA wcel wa vy cv cC cB cR wbr cB cC cif cR
      wbr vy cv vz cv cR wbr vz cB cC cpr wrex wi vy cA cB cA wcel cC cA wcel
      wa vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB cC cpr
      wrex wi vy cv cA wcel cB cA wcel cC cA wcel wa vy cv cC cB cR wbr cB cC
      cif cR wbr vy cv vz cv cR wbr vz cB cC cpr wrex cC cB cR wbr cB cC cif cB
      cC cpr wcel vy cv cC cB cR wbr cB cC cif cR wbr vy cv vz cv cR wbr vz cB
      cC cpr wrex cB cA wcel cC cA wcel wa vy cv vz cv cR wbr vy cv cC cB cR
      wbr cB cC cif cR wbr vz cC cB cR wbr cB cC cif cB cC cpr vz cv cC cB cR
      wbr cB cC cif vy cv cR breq2 rcla4ev cC cB cR wbr cB cC cA cA ifpr sylan
      ex a1d r19.21aiv jca sylanc vx vy vz cA cB cC cpr cR suppr.1 supmo jctir
      vx cv vy cv cR wbr wn vy cB cC cpr wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB cC cpr wrex wi vy cA wral wa vx cA reu5 sylibr sylanc mpbid vx
      vy vz cA cB cC cpr cR df-sup syl5eq $.
      $( [21-Jun-2007] $) $( [17-Jun-2007] $)

    $( The supremum of a singleton. $)
    supsn $p |- ( B e. A -> sup ( { B } , A , R ) = B ) $=
      cB cA wcel cB csn cA cR csup cB cB cR wbr cB cB cif cB cB cA wcel cB cB
      cpr cA cR csup cB cB cR wbr cB cB cif cB csn cA cR csup cB cA wcel cB cB
      cpr cA cR csup cB cB cR wbr cB cB cif wceq cA cB cB cR suppr.1 suppr
      anidms cB csn cB cB cpr wceq cB csn cA cR csup cB cB cpr cA cR csup wceq
      cB dfsn2 cA cB csn cB cB cpr cR supeq1 ax-mp syl5eq cB cB cR wbr cB ifid
      syl6eq $.
      $( [4-Oct-2007] $) $( [2-Oct-2007] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z R $.
    supsn.1 $e |- R Or A $.
    $( TO BE REVISED - delete this? $)
    $( The supremum of a singleton.  This version of ~ supsn is proved
       directly. $)
    supsnALT $p |- ( B e. A -> sup ( { B } , A , R ) = B ) $=
      cB cA wcel vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB csn wrex wi vy cA wral wa vx cA crab cuni cB cB csn cA
      cR csup cB cA wcel cB vy cv cR wbr wn vy cB csn wral vy cv cB cR wbr vy
      cv vz cv cR wbr vz cB csn wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy
      cB csn wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA
      wral wa vx cA crab cuni cB wceq cB cA wcel cB vy cv cR wbr wn vy cB csn
      wral vy cv cB cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA wral cB
      cA wcel cB vy cv cR wbr wn vy cB csn vy cv cB csn wcel cB cA wcel cB vy
      cv cR wbr wn vy cv cB csn wcel vy cv cB wceq cB cA wcel cB vy cv cR wbr
      wn wi vy cv cB elsni vy cv cB wceq cB vy cv cR wbr wn cB cB cR wbr wn cB
      cA wcel vy cv cB wceq cB vy cv cR wbr cB cB cR wbr vy cv cB cB cR breq2
      notbid cA cR wor cB cA wcel cB cB cR wbr wn supsn.1 cA cB cR sonr mpan
      syl5bir syl com12 r19.21aiv cB cA wcel vy cv cB cR wbr vy cv vz cv cR wbr
      vz cB csn wrex wi vy cA cB cA wcel vy cv cB cR wbr vy cv vz cv cR wbr vz
      cB csn wrex wi vy cv cA wcel cB cA wcel vy cv cB cR wbr vy cv vz cv cR
      wbr vz cB csn wrex cB cB csn wcel vy cv cB cR wbr vy cv vz cv cR wbr vz
      cB csn wrex cB cA wcel vy cv vz cv cR wbr vy cv cB cR wbr vz cB cB csn vz
      cv cB vy cv cR breq2 rcla4ev cB cA snidg sylan ex a1d r19.21aiv jca cB cA
      wcel vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv vz cv
      cR wbr vz cB csn wrex wi vy cA wral wa vx cA wreu cB vy cv cR wbr wn vy
      cB csn wral vy cv cB cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA
      wral wa vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB csn wrex wi vy cA wral wa vx cA crab cuni cB wceq wb cB
      cA wcel vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB csn wrex wi vy cA wral wa vx cA wrex vx cv cA wcel vx cv
      vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cB csn wrex wi vy cA wral wa wa vx wmo wa vx cv vy cv cR wbr wn vy cB csn
      wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA wral
      wa vx cA wreu cB cA wcel vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA wral wa vx cA wrex vx
      cv cA wcel vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB csn wrex wi vy cA wral wa wa vx wmo cB cA wcel cB vy
      cv cR wbr wn vy cB csn wral vy cv cB cR wbr vy cv vz cv cR wbr vz cB csn
      wrex wi vy cA wral wa vx cv vy cv cR wbr wn vy cB csn wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA wral wa vx cA wrex cB cA
      wcel cB vy cv cR wbr wn vy cB csn wral vy cv cB cR wbr vy cv vz cv cR wbr
      vz cB csn wrex wi vy cA wral cB cA wcel cB vy cv cR wbr wn vy cB csn vy
      cv cB csn wcel cB cA wcel cB vy cv cR wbr wn vy cv cB csn wcel vy cv cB
      wceq cB cA wcel cB vy cv cR wbr wn wi vy cv cB elsni vy cv cB wceq cB vy
      cv cR wbr wn cB cB cR wbr wn cB cA wcel vy cv cB wceq cB vy cv cR wbr cB
      cB cR wbr vy cv cB cB cR breq2 notbid cA cR wor cB cA wcel cB cB cR wbr
      wn supsn.1 cA cB cR sonr mpan syl5bir syl com12 r19.21aiv cB cA wcel vy
      cv cB cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA cB cA wcel vy cv
      cB cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cv cA wcel cB cA wcel
      vy cv cB cR wbr vy cv vz cv cR wbr vz cB csn wrex cB cB csn wcel vy cv cB
      cR wbr vy cv vz cv cR wbr vz cB csn wrex cB cA wcel vy cv vz cv cR wbr vy
      cv cB cR wbr vz cB cB csn vz cv cB vy cv cR breq2 rcla4ev cB cA snidg
      sylan ex a1d r19.21aiv jca vx cv vy cv cR wbr wn vy cB csn wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA wral wa cB vy cv cR
      wbr wn vy cB csn wral vy cv cB cR wbr vy cv vz cv cR wbr vz cB csn wrex
      wi vy cA wral wa vx cB cA vx cv cB wceq vx cv vy cv cR wbr wn vy cB csn
      wral cB vy cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB csn wrex wi vy cA wral vy cv cB cR wbr vy cv vz cv cR wbr vz cB
      csn wrex wi vy cA wral vx cv cB wceq vx cv vy cv cR wbr wn cB vy cv cR
      wbr wn vy cB csn vx cv cB wceq vx cv vy cv cR wbr cB vy cv cR wbr vx cv
      cB vy cv cR breq1 notbid ralbidv vx cv cB wceq vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB csn wrex wi vy cv cB cR wbr vy cv vz cv cR wbr vz cB
      csn wrex wi vy cA vx cv cB wceq vy cv vx cv cR wbr vy cv cB cR wbr vy cv
      vz cv cR wbr vz cB csn wrex vx cv cB vy cv cR breq2 imbi1d ralbidv
      anbi12d rcla4ev mpdan vx vy vz cA cB csn cR supsn.1 supmo jctir vx cv vy
      cv cR wbr wn vy cB csn wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      csn wrex wi vy cA wral wa vx cA reu5 sylibr vx cv vy cv cR wbr wn vy cB
      csn wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA
      wral wa cB vy cv cR wbr wn vy cB csn wral vy cv cB cR wbr vy cv vz cv cR
      wbr vz cB csn wrex wi vy cA wral wa vx cA cB vx cv cB wceq vx cv vy cv cR
      wbr wn vy cB csn wral cB vy cv cR wbr wn vy cB csn wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cA wral vy cv cB cR wbr vy cv
      vz cv cR wbr vz cB csn wrex wi vy cA wral vx cv cB wceq vx cv vy cv cR
      wbr wn cB vy cv cR wbr wn vy cB csn vx cv cB wceq vx cv vy cv cR wbr cB
      vy cv cR wbr vx cv cB vy cv cR breq1 notbid ralbidv vx cv cB wceq vy cv
      vx cv cR wbr vy cv vz cv cR wbr vz cB csn wrex wi vy cv cB cR wbr vy cv
      vz cv cR wbr vz cB csn wrex wi vy cA vx cv cB wceq vy cv vx cv cR wbr vy
      cv cB cR wbr vy cv vz cv cR wbr vz cB csn wrex vx cv cB vy cv cR breq2
      imbi1d ralbidv anbi12d reuuni2 mpdan mpbid vx vy vz cA cB csn cR df-sup
      syl5eq $.
      $( [23-May-1999] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Regularity
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Introduce the Axiom of Regularity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Axiom of Regularity.  An axiom of Zermelo-Fraenkel set theory.  Also
       called the Axiom of Foundation.  A rather non-intuitive axiom that
       denies more than it asserts, it states (in the form of ~ zfreg ) that
       every non-empty set contains a set disjoint from itself.  One
       consequence is that it denies the existence of a set containing itself
       ( ~ elirrv ).  A stronger version that works for proper classes is
       proved as ~ zfregs . $)
    ax-reg $a |- ( E. y y e. x ->
                 E. y ( y e. x /\ A. z ( z e. y -> -. z e. x ) ) ) $.

    $( Axiom of Regularity expressed more compactly. $)
    axreg $p |- ( x e. y ->
                 E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) $=
      vx cv vy cv wcel vx cv vy cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi
      vz wal wa vx wex vx vy vx vz ax-reg 19.23bi $.
      $( [14-Aug-2003] $)
  $}

  ${
    $d x y A z $.
    zfregcl.1 $e |- A e. _V $.
    $( The Axiom of Regularity with class variables. $)
    zfregcl $p |- ( E. x x e. A -> E. x e. A A. y e. x -. y e. A ) $=
      vx cv vz cv wcel vx wex vy cv vz cv wcel wn vy vx cv wral vx vz cv wrex
      wi vx cv cA wcel vx wex vy cv cA wcel wn vy vx cv wral vx cA wrex wi vz
      cA zfregcl.1 vz cv cA wceq vx cv vz cv wcel vx wex vx cv cA wcel vx wex
      vy cv vz cv wcel wn vy vx cv wral vx vz cv wrex vy cv cA wcel wn vy vx cv
      wral vx cA wrex vz cv cA wceq vx cv vz cv wcel vx cv cA wcel vx vz cv cA
      vx cv eleq2 exbidv vy cv vz cv wcel wn vy vx cv wral vy cv cA wcel wn vy
      vx cv wral vx vz cv cA vz cv cA wceq vy cv vz cv wcel wn vy cv cA wcel wn
      vy vx cv vz cv cA wceq vy cv vz cv wcel vy cv cA wcel vz cv cA vy cv
      eleq2 notbid ralbidv rexeqd imbi12d vx cv vz cv wcel vy cv vz cv wcel wn
      vy vx cv wral vx vz cv wrex vx vy cv vz cv wcel wn vy vx cv wral vx vz cv
      hbre1 vx cv vz cv wcel vx cv vz cv wcel vy cv vx cv wcel vy cv vz cv wcel
      wn wi vy wal wa vx wex vy cv vz cv wcel wn vy vx cv wral vx vz cv wrex vx
      vz vy axreg vy cv vz cv wcel wn vy vx cv wral vx vz cv wrex vy cv vx cv
      wcel vy cv vz cv wcel wn wi vy wal vx vz cv wrex vx cv vz cv wcel vy cv
      vx cv wcel vy cv vz cv wcel wn wi vy wal wa vx wex vy cv vz cv wcel wn vy
      vx cv wral vy cv vx cv wcel vy cv vz cv wcel wn wi vy wal vx vz cv vy cv
      vz cv wcel wn vy vx cv df-ral rexbii vy cv vx cv wcel vy cv vz cv wcel wn
      wi vy wal vx vz cv df-rex bitr2i sylib 19.23ai vtocl $.
      $( [7-May-2004] $) $( [5-Aug-1994] $)
  $}

  ${
    $d x A y $.
    zfreg.1 $e |- A e. _V $.
    $( The Axiom of Regularity using abbreviations.  Axiom 6 of [TakeutiZaring]
       p. 21.  This is called the "weak form."  There is also a
       "strong form," not requiring that ` A ` be a set, that can be proved
       with more difficulty (see ~ zfregs ). $)
    zfreg $p |- ( A =/= (/) -> E. x e. A ( x i^i A ) = (/) ) $=
      vx cv cA wcel vx wex vy cv cA wcel wn vy vx cv wral vx cA wrex cA c0 wne
      vx cv cA cin c0 wceq vx cA wrex vx vy cA zfreg.1 zfregcl vx cA n0 vx cv
      cA cin c0 wceq vy cv cA wcel wn vy vx cv wral vx cA vy vx cv cA disj
      rexbii 3imtr4i $.
      $( [11-Apr-2007] $) $( [26-Nov-1995] $)
  $}

  ${
    $d x A y $.
    zfreg2.1 $e |- A e. _V $.
    $( The Axiom of Regularity using abbreviations.  This form with the
       intersection arguments commuted (compared to ~ zfreg ) is formally
       more convenient for us in some cases.  Axiom Reg of [BellMachover]
       p. 480. $)
    zfreg2 $p |- ( A =/= (/) -> E. x e. A ( A i^i x ) = (/) ) $=
      vx cv cA wcel vx wex vy cv cA wcel wn vy vx cv wral vx cA wrex cA c0 wne
      cA vx cv cin c0 wceq vx cA wrex vx vy cA zfreg2.1 zfregcl vx cA n0 cA vx
      cv cin c0 wceq vy cv cA wcel wn vy vx cv wral vx cA cA vx cv cin c0 wceq
      vx cv cA cin c0 wceq vy cv cA wcel wn vy vx cv wral cA vx cv cin vx cv cA
      cin c0 cA vx cv incom eqeq1i vy vx cv cA disj bitri rexbii 3imtr4i $.
      $( [12-Apr-2007] $) $( [17-Sep-2003] $)
  $}

  ${
    $d x y z $.
    $( The membership relation is irreflexive:  no set is a member of itself.
       Theorem 105 of [Suppes] p. 54.  (This is trivial to prove from ~ zfregfr
       and ~ efrirr , but this proof is direct from the Axiom of
       Regularity.) $)
    elirrv $p |- -. x e. x $=
      vx cv vx cv wcel vz cv vx cv csn wcel wn vz vy cv wral vy vx cv csn wrex
      vy cv vx cv csn wcel vy wex vz cv vx cv csn wcel wn vz vy cv wral vy vx
      cv csn wrex vy cv vx cv csn wcel vx cv vx cv csn wcel vy vx vy cv vx cv
      vx cv csn eleq1 vx cv vx visset snid a4eiv vy vz vx cv csn vx cv snex
      zfregcl ax-mp vx cv vx cv wcel vz cv vx cv csn wcel wn vz vy cv wral wn
      vy vx cv csn wral vz cv vx cv csn wcel wn vz vy cv wral vy vx cv csn wrex
      wn vx cv vx cv wcel vz cv vx cv csn wcel wn vz vy cv wral wn vy vx cv csn
      vx cv vx cv wcel vz cv vx cv csn wcel wn vz vy cv wral vy cv vx cv csn
      wcel vx cv vx cv wcel vy cv vx cv csn wcel vx cv vy cv wcel vz cv vx cv
      csn wcel wn vz vy cv wral vx cv vx cv wcel vy cv vx cv wceq vx cv vy cv
      wcel vy cv vx cv csn wcel vy cv vx cv wceq vx cv vx cv wcel vx cv vy cv
      wcel vx cv vx cv wcel vx cv vy cv wcel wi vx vy vx vy vx ax-14 equcoms
      com12 vy vx cv elsn syl5ib vz cv vx cv csn wcel wn vz vy cv wral vx cv vy
      cv wcel vx cv vx cv csn wcel vx cv vx visset snid vz cv vx cv csn wcel wn
      vx cv vx cv csn wcel wn vz vx cv vy cv vz cv vx cv wceq vz cv vx cv csn
      wcel vx cv vx cv csn wcel vz cv vx cv vx cv csn eleq1 notbid rcla4cv mt2i
      nsyli con2d r19.21aiv vz cv vx cv csn wcel wn vz vy cv wral vy vx cv csn
      ralnex sylib mt2 $.
      $( [19-Aug-1993] $)
  $}

  ${
    $d A x $.
    $( No class is a member of itself.  Exercise 6 of [TakeutiZaring] p. 22. $)
    elirr $p |- -. A e. A $=
      cA cA wcel cA cA wcel wn wi cA cA wcel wn vx cv vx cv wcel wn cA cA wcel
      wn vx cA cA vx cv cA wceq vx cv vx cv wcel cA cA wcel vx cv cA wceq vx cv
      vx cv wcel vx cv cA wcel cA cA wcel vx cv cA vx cv eleq2 vx cv cA cA
      eleq1 bitrd notbid vx elirrv vtoclg cA cA wcel pm2.01 ax-mp $.
      $( [7-Aug-1994] $)

    $( A class is equal to its successor iff it is a proper class (assuming the
       Axiom of Regularity). $)
     sucprcreg $p |- ( -. A e. _V <-> suc A = A ) $=
       cA cvv wcel wn cA csuc cA wceq cA sucprc cA cvv wcel vx cv cA wceq vx cv
       cA wcel wi vx wal cA csuc cA wceq cA cvv wcel vx cv cA wceq vx cv cA
       wcel wi vx wal cA cA wcel cA elirr vx cv cA wcel cA cA wcel vx cA cvv cA
       cA wcel vx ax-17 vx cv cA cA eleq1 ceqsalg mtbiri cA csuc cA wceq vx cv
       cA wceq vx cv cA wcel wi vx cA csuc cA wceq vx cv cA csn wcel vx cv cA
       wcel vx cv cA wceq cA csuc cA wceq vx cv cA wcel vx cv cA csn wcel wo vx
       cv cA wcel vx cv cA csn wcel cA csuc cA wceq vx cv cA cA csn cun wcel vx
       cv cA wcel vx cv cA wcel vx cv cA csn wcel wo cA csuc cA wceq cA cA csn
       cun cA vx cv cA csuc cA wceq cA cA csn cun cA wss cA cA wss cA ssid cA
       csuc cA wceq cA cA csn cun cA wceq cA cA csn cun cA wss cA cA wss wb cA
       csuc cA cA csn cun cA cA df-suc eqeq1i cA cA csn cun cA cA sseq1 sylbi
       mpbiri sseld vx cv cA cA csn elun syl5ibr vx cv cA csn wcel vx cv cA
       wcel olc syl5 vx cA elsn syl5ibr 19.21aiv nsyl3 impbii $.
       $( [6-Jan-2004] $) $( [9-Jul-2004] $)
  $}

  $( The Russell class is equal to the universe ` _V ` .  Exercise 5 of
     [TakeutiZaring] p. 22.  (Contributed by Alan Sare, 4-Oct-2008.) $)
  ruv $p |- { x | x e/ x } = _V $=
    cvv vx cv vx cv wceq vx cab vx cv vx cv wnel vx cab vx df-v vx cv vx cv
    wceq vx cv vx cv wnel vx vx cv vx cv wceq vx cv vx cv wnel vx equid vx cv
    vx cv wnel vx cv vx cv wcel wn vx elirrv vx cv vx cv df-nel mpbir 2th abbii
    eqtr2i $.
    $( [4-Oct-2008] $) $( [4-Oct-2008] $)

  $( Alternate proof of Russell's Paradox ~ ru , simplified using (indirectly)
     the Axiom of Regularity ~ ax-reg .  (Contributed by Alan Sare,
     4-Oct-2008.) $)
  ruALT $p |- { x | x e/ x } e/ _V $=
    vx cv vx cv wnel vx cab cvv wnel cvv cvv wnel cvv cvv wnel cvv cvv wcel wn
    vprc cvv cvv df-nel mpbir vx cv vx cv wnel vx cab cvv wceq vx cv vx cv wnel
    vx cab cvv wnel cvv cvv wnel wb vx ruv vx cv vx cv wnel vx cab cvv cvv
    neleq1 ax-mp mpbir $.
    $( [4-Oct-2008] $) $( [4-Oct-2008] $)

  ${
    $d x y A $.
    $( The epsilon relation is founded on any class. $)
    zfregfr $p |- _E Fr A $=
      cA cep wfr vx cv cA wss vx cv c0 wne wa vx cv vy cv cin c0 wceq vy vx cv
      wrex wi vx vx vy cA dfepfr vx cv c0 wne vx cv vy cv cin c0 wceq vy vx cv
      wrex vx cv cA wss vy vx cv vx visset zfreg2 adantl mpgbir $.
      $( [26-Nov-1995] $)
  $}

  ${
    $d A x y $.  $d B x y $.
    $( No class has 2-cycle membership loops.  Theorem 7X(b) of [Enderton]
       p. 206. $)
    en2lp $p |- -. ( A e. B /\ B e. A ) $=
      cA cvv wcel cB cvv wcel wa cA cB wcel cB cA wcel wa wn vx cv vy cv wcel
      vy cv vx cv wcel wa wn cA vy cv wcel vy cv cA wcel wa wn cA cB wcel cB cA
      wcel wa wn vx vy cA cB cvv cvv vx cv cA wceq vx cv vy cv wcel vy cv vx cv
      wcel wa cA vy cv wcel vy cv cA wcel wa vx cv cA wceq vx cv vy cv wcel cA
      vy cv wcel vy cv vx cv wcel vy cv cA wcel vx cv cA vy cv eleq1 vx cv cA
      vy cv eleq2 anbi12d notbid vy cv cB wceq cA vy cv wcel vy cv cA wcel wa
      cA cB wcel cB cA wcel wa vy cv cB wceq cA vy cv wcel cA cB wcel vy cv cA
      wcel cB cA wcel vy cv cB cA eleq2 vy cv cB cA eleq1 anbi12d notbid cvv
      cep wfr vx cv cvv wcel vy cv cvv wcel wa vx cv vy cv wcel vy cv vx cv
      wcel wa wn cvv zfregfr vx cv cvv wcel vy cv cvv wcel vx visset vy visset
      pm3.2i vx vy cvv efrn2lp mp2an vtocl2g cA cB wcel cB cA wcel wa cA cvv
      wcel cB cvv wcel wa cA cB wcel cA cvv wcel cB cA wcel cB cvv wcel cA cB
      elisset cB cA elisset anim12i con3i pm2.61i $.
      $( [16-Oct-1996] $)

  $}

  ${
    preleq.1 $e |- A e. _V $.
    preleq.2 $e |- B e. _V $.
    preleq.3 $e |- C e. _V $.
    preleq.4 $e |- D e. _V $.
    $( Equality of two unordered pairs when one member of each pair contains
       the other member. $)
    preleq $p |- ( ( ( A e. B /\ C e. D ) /\ { A , B } = { C , D } ) ->
                   ( A = C /\ B = D ) ) $=
      cA cB cpr cC cD cpr wceq cA cB wcel cC cD wcel wa cA cC wceq cB cD wceq
      wa cA cB cpr cC cD cpr wceq cA cC wceq cB cD wceq wa cA cB wcel cC cD
      wcel wa cA cB cpr cC cD cpr wceq cA cC wceq cB cD wceq wa wn cA cD wceq
      cB cC wceq wa cA cB wcel cC cD wcel wa wn cA cB cpr cC cD cpr wceq cA cC
      wceq cB cD wceq wa cA cD wceq cB cC wceq wa cA cB cpr cC cD cpr wceq cA
      cC wceq cB cD wceq wa cA cD wceq cB cC wceq wa wo cA cB cC cD preleq.1
      preleq.2 preleq.3 preleq.4 preq12b biimpi ord cA cD wceq cB cC wceq wa cA
      cB wcel cC cD wcel wa cD cC wcel cC cD wcel wa cD cC en2lp cA cD wceq cB
      cC wceq wa cA cB wcel cD cC wcel cC cD wcel cA cD cB cC eleq12 anbi1d
      mtbiri syl6 con4d impcom $.
      $( [16-Oct-1996] $)

    $( Theorem for alternate representation of ordered pairs, requiring the
       Axiom of Regularity ~ ax-reg (via the ~ preleq step).  See ~ df-op for a
       description of other ordered pair representations.  Exercise 34 of
       [Enderton] p. 207. $)
    opthreg $p |- ( { A , { A , B } } = { C , { C , D } } <->
                   ( A = C /\ B = D ) ) $=
      cA cA cB cpr cpr cC cC cD cpr cpr wceq cA cC wceq cB cD wceq wa cA cA cB
      cpr cpr cC cC cD cpr cpr wceq cA cC wceq cA cB cpr cC cD cpr wceq wa cA
      cC wceq cB cD wceq wa cA cA cB cpr wcel cC cC cD cpr wcel cA cA cB cpr
      cpr cC cC cD cpr cpr wceq cA cC wceq cA cB cpr cC cD cpr wceq wa cA cB
      preleq.1 prid1 cC cD preleq.3 prid1 cA cA cB cpr cC cC cD cpr preleq.1 cA
      cB prex preleq.3 cC cD prex preleq mpanl12 cA cC wceq cA cB cpr cC cD cpr
      wceq cB cD wceq cA cC wceq cA cB cpr cC cD cpr wceq cC cB cpr cC cD cpr
      wceq cB cD wceq cA cC wceq cA cB cpr cC cB cpr cC cD cpr cA cC cB preq1
      eqeq1d cB cD cC preleq.2 preleq.4 preqr2 syl6bi imdistani syl cA cC wceq
      cB cD wceq wa cA cA cB cpr cpr cC cA cB cpr cpr cC cC cD cpr cpr cA cC
      wceq cA cA cB cpr cpr cC cA cB cpr cpr wceq cB cD wceq cA cC cA cB cpr
      preq1 adantr cA cC wceq cB cD wceq wa cA cB cpr cC cD cpr wceq cC cA cB
      cpr cpr cC cC cD cpr cpr wceq cA cC wceq cB cD wceq cA cB cpr cC cB cpr
      cC cD cpr cA cC cB preq1 cB cD cC preq2 sylan9eq cA cB cpr cC cD cpr cC
      preq2 syl eqtrd impbii $.
      $( [16-Oct-1996] $)
  $}

  $( The successor operation behaves like a one-to-one function (assuming the
     Axiom of Regularity).  Exercise 35 of [Enderton] p. 208 and its
     converse. $)
  suc11reg $p |- ( suc A = suc B <-> A = B ) $=
    cA csuc cB csuc wceq cA cB wceq cA cvv wcel cB cvv wcel cA csuc cB csuc
    wceq cA cB wceq wi cA cvv wcel cB cvv wcel wa cA cB wcel wn cB cA wcel wn
    wo cA csuc cB csuc wceq cA cB wceq wi cA cB wcel cB cA wcel wa wn cA cB
    wcel wn cB cA wcel wn wo cA cB en2lp cA cB wcel cB cA wcel ianor mpbi cA
    cvv wcel cA cB wcel wn cA csuc cB csuc wceq cA cB wceq wi cB cvv wcel cB cA
    wcel wn cA cvv wcel cA csuc cB csuc wceq cA cB wcel wn cA cB wceq cA cvv
    wcel cA csuc cB csuc wceq cA cB wcel wn cA cB wceq wi cA cvv wcel cA csuc
    cB csuc wceq wa cA cB wcel cA cB wceq cA cvv wcel cA csuc cB csuc wceq cA
    cB wcel cA cB wceq wo cA cvv wcel cA csuc cB csuc wceq cA cB csuc wcel cA
    cB wcel cA cB wceq wo cA csuc cB csuc wceq cA cA csuc wcel cA cB csuc wcel
    cA cvv wcel cA csuc cB csuc cA eleq2 cA cvv sucidg syl5cbi cA cB cvv elsucg
    sylibd imp ord ex com23 cB cvv wcel cA csuc cB csuc wceq cB cA wcel wn cA
    cB wceq cB cvv wcel cA csuc cB csuc wceq cB cA wcel wn cA cB wceq wi cB cvv
    wcel cA csuc cB csuc wceq wa cB cA wcel wn cB cA wceq cA cB wceq cB cvv
    wcel cA csuc cB csuc wceq wa cB cA wcel cB cA wceq cB cvv wcel cA csuc cB
    csuc wceq cB cA wcel cB cA wceq wo cB cvv wcel cA csuc cB csuc wceq cB cA
    csuc wcel cB cA wcel cB cA wceq wo cA csuc cB csuc wceq cB cA csuc wcel cB
    cB csuc wcel cB cvv wcel cA csuc cB csuc cB eleq2 cB cvv sucidg syl5cbir cB
    cA cvv elsucg sylibd imp ord cB cA eqcom syl6ib ex com23 jaao mpi cA cvv
    wcel cB cvv wcel wn wa cA csuc cB csuc wceq cA cB wceq cA csuc cvv wcel cB
    csuc cvv wcel wn cA csuc cB csuc wceq wn cA cvv wcel cB cvv wcel wn cA csuc
    cB csuc cvv nelneq cA sucexb cB cvv wcel cB csuc cvv wcel cB sucexb notbii
    syl2anb pm2.21d cA cvv wcel wn cB cvv wcel wa cB csuc cA csuc wceq cA cB
    wceq cA csuc cB csuc wceq cA cvv wcel wn cB cvv wcel wa cB csuc cA csuc
    wceq cA cB wceq cB cvv wcel cA cvv wcel wn cB csuc cA csuc wceq wn cB csuc
    cvv wcel cA csuc cvv wcel wn cB csuc cA csuc wceq wn cB cvv wcel cA cvv
    wcel wn cB csuc cA csuc cvv nelneq cB sucexb cA cvv wcel cA csuc cvv wcel
    cA sucexb notbii syl2anb ancoms pm2.21d cA csuc cB csuc eqcom syl5ib cA cvv
    wcel wn cB cvv wcel wn wa cA csuc cB csuc wceq cA cB wceq cA cvv wcel wn cB
    cvv wcel wn cA csuc cA cB csuc cB cA sucprc cB sucprc eqeqan12d biimpd
    4cases cA cB suceq impbii $.
    $( [27-Oct-2003] $) $( [25-Oct-2003] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Axiom of Infinity equivalents
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( First we prove the equivalence of our version of Infinity with
     some others. $)

  ${
    $d x y z w v u f $.
    inf0.1 $e |- om e. _V $.
    $( Our Axiom of Infinity derived from existence of omega.  The proof shows
       that the especially contrived class
       " ` ran ( rec ( { <. v , u >. | u = suc v } , x ) |`` om ) ` " exists,
       is a subset of its union, and contains a given set ` x ` (and thus is
       non-empty).  Thus it provides an example demonstrating that a set ` y `
       exists with the necessary properties demanded by ~ ax-inf . $)
    inf0 $p |- E. y ( x e. y /\ A. z ( z e. y -> E. w ( z e. w /\ w e. y )
                   ) ) $=
      vx cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel vz
      cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel vz cv
      vw cv wcel vw cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres
      crn wcel wa vw wex wi vz wal vx cv vy cv wcel vz cv vy cv wcel vz cv vw
      cv wcel vw cv vy cv wcel wa vw wex wi vz wal wa vy wex c0 vu cv vv cv
      csuc wceq vv vu copab vx cv crdg com cres cfv vx cv vu cv vv cv csuc wceq
      vv vu copab vx cv crdg com cres crn vx cv cvv wcel c0 vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres cfv vx cv wceq vx visset vx cv cvv
      vu cv vv cv csuc wceq vv vu copab fr0g ax-mp vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres com wfn c0 com wcel c0 vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres crn wcel vx cv vu cv vv cv csuc wceq vv vu copab frfnom
      peano1 com c0 vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres
      fnfvelrn mp2an eqeltrri vz cv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres crn wcel vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres crn wcel wa vw wex wi vz vz cv vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres crn wcel vf cv vu cv vv cv csuc wceq
      vv vu copab vx cv crdg com cres cfv vz cv wceq vf com wrex vz cv vw cv
      wcel vw cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel
      wa vw wex vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres com wfn
      vz cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel vf
      cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv vz cv wceq
      vf com wrex wb vx cv vu cv vv cv csuc wceq vv vu copab frfnom vf com vz
      cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres fvelrnb ax-mp vf
      cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv vz cv wceq
      vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com
      cres crn wcel wa vw wex vf com vf cv vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres cfv vz cv wceq vf cv com wcel vz cv vf cv csuc vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres cfv wcel vf cv csuc vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres cfv vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres crn wcel wa vz cv vw cv wcel vw cv vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres crn wcel wa vw wex vf cv vu
      cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv vz cv wceq vf cv
      com wcel vz cv vf cv csuc vu cv vv cv csuc wceq vv vu copab vx cv crdg
      com cres cfv wcel vf cv csuc vu cv vv cv csuc wceq vv vu copab vx cv crdg
      com cres cfv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn
      wcel vf cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv vz
      cv wceq vf cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv
      vf cv csuc vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv wcel
      vz cv vf cv csuc vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres
      cfv wcel vf cv com wcel vf cv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres cfv vz cv vf cv csuc vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres cfv eleq1 vf cv com wcel vf cv vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv csuc vf cv csuc vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv vf cv vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres cfv vf cv com wcel vf cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres cfv csuc cvv wcel vf cv csuc vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres cfv vf cv vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv csuc wceq vf cv vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv vf cv vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres fvex sucex vv vu vz vx cv vf cv vv cv csuc vf cv vu
      cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv csuc cvv vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres vz cv vx cv wcel vv ax-17 vz
      cv vf cv wcel vv ax-17 vv vz vf cv vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres cfv vv vz vf cv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres vv vz vu cv vv cv csuc wceq vv vu copab vx cv crdg com vv
      vz vx cv vu cv vv cv csuc wceq vv vu copab vu cv vv cv csuc wceq vv vu vz
      hbopab1 vz cv vx cv wcel vv ax-17 hbrdg vz cv com wcel vv ax-17 hbres vz
      cv vf cv wcel vv ax-17 hbfv hbsuc vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres eqid vv cv vf cv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres cfv suceq frsucopab mpan2 vf cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres cfv vf cv vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres fvex sucid syl5eleqr syl5bi vf cv com wcel vf cv csuc vu
      cv vv cv csuc wceq vv vu copab vx cv crdg com cres cfv vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres crn wcel wi vf cv vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres cfv vz cv wceq vf cv com wcel vf cv
      csuc com wcel vf cv csuc vu cv vv cv csuc wceq vv vu copab vx cv crdg com
      cres cfv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel
      vf cv peano2b vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres com
      wfn vf cv csuc com wcel vf cv csuc vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres cfv vu cv vv cv csuc wceq vv vu copab vx cv crdg com
      cres crn wcel vx cv vu cv vv cv csuc wceq vv vu copab frfnom com vf cv
      csuc vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres fnfvelrn mpan
      sylbi a1i jcad vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres crn wcel wa vz cv vf cv csuc vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv wcel vf cv csuc vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres cfv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres crn wcel wa vw vf cv csuc vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres cfv vf cv csuc vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres fvex vw cv vf cv csuc vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres cfv wceq vz cv vw cv wcel vz cv vf cv csuc vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres cfv wcel vw cv vu cv vv cv
      csuc wceq vv vu copab vx cv crdg com cres crn wcel vf cv csuc vu cv vv cv
      csuc wceq vv vu copab vx cv crdg com cres cfv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres crn wcel vw cv vf cv csuc vu cv vv cv csuc wceq
      vv vu copab vx cv crdg com cres cfv vz cv eleq2 vw cv vf cv csuc vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres cfv vu cv vv cv csuc wceq vv
      vu copab vx cv crdg com cres crn eleq1 anbi12d cla4ev syl6com r19.23aiv
      sylbi ax-gen vx cv vy cv wcel vz cv vy cv wcel vz cv vw cv wcel vw cv vy
      cv wcel wa vw wex wi vz wal wa vx cv vu cv vv cv csuc wceq vv vu copab vx
      cv crdg com cres crn wcel vz cv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres crn wcel vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres crn wcel wa vw wex wi vz wal wa vy vu cv vv cv
      csuc wceq vv vu copab vx cv crdg com cres crn vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres cdm cvv wcel vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres wfun vu cv vv cv csuc wceq vv vu copab vx cv crdg com
      cres crn cvv wcel vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres
      cdm com cvv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres com wfn
      vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres cdm com wceq vx cv
      vu cv vv cv csuc wceq vv vu copab frfnom com vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres fndm ax-mp inf0.1 eqeltri vu cv vv cv csuc wceq
      vv vu copab vx cv crdg com cres com wfn vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres wfun vx cv vu cv vv cv csuc wceq vv vu copab frfnom
      com vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres fnfun ax-mp cvv
      vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres funrnex mp2 vy cv
      vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wceq vx cv vy
      cv wcel vx cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn
      wcel vz cv vy cv wcel vz cv vw cv wcel vw cv vy cv wcel wa vw wex wi vz
      wal vz cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel
      vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu copab vx cv crdg com
      cres crn wcel wa vw wex wi vz wal vy cv vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres crn vx cv eleq2 vy cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres crn wceq vz cv vy cv wcel vz cv vw cv wcel vw
      cv vy cv wcel wa vw wex wi vz cv vu cv vv cv csuc wceq vv vu copab vx cv
      crdg com cres crn wcel vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres crn wcel wa vw wex wi vz vy cv vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres crn wceq vz cv vy cv wcel vz cv vu
      cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn wcel vz cv vw cv
      wcel vw cv vy cv wcel wa vw wex vz cv vw cv wcel vw cv vu cv vv cv csuc
      wceq vv vu copab vx cv crdg com cres crn wcel wa vw wex vy cv vu cv vv cv
      csuc wceq vv vu copab vx cv crdg com cres crn vz cv eleq2 vy cv vu cv vv
      cv csuc wceq vv vu copab vx cv crdg com cres crn wceq vz cv vw cv wcel vw
      cv vy cv wcel wa vz cv vw cv wcel vw cv vu cv vv cv csuc wceq vv vu copab
      vx cv crdg com cres crn wcel wa vw vy cv vu cv vv cv csuc wceq vv vu
      copab vx cv crdg com cres crn wceq vw cv vy cv wcel vw cv vu cv vv cv
      csuc wceq vv vu copab vx cv crdg com cres crn wcel vz cv vw cv wcel vy cv
      vu cv vv cv csuc wceq vv vu copab vx cv crdg com cres crn vw cv eleq2
      anbi2d exbidv imbi12d albidv anbi12d cla4ev mp2an $.
      $( [2-Apr-2007] $) $( [15-Oct-1996] $)
  $}

  ${
    $d x y z $.
    inf1.1 $e |- E. x ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) $.
    $( Variation of Axiom of Infinity (using ~ zfinf as a hypothesis).  Axiom
       of Infinity in [FreydScedrov] p. 283. $)
    inf1 $p |- E. x ( x =/= (/) /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) $=
      vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vy wal wa vx wex vx cv c0 wne vy cv vx cv wcel vy cv vz cv wcel vz
      cv vx cv wcel wa vz wex wi vy wal wa vx wex inf1.1 vy cv vx cv wcel vy cv
      vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx cv
      c0 wne vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy
      wal wa vx vy cv vx cv wcel vx cv c0 wne vy cv vx cv wcel vy cv vz cv wcel
      vz cv vx cv wcel wa vz wex wi vy wal vx cv vy cv ne0i anim1i 19.22i ax-mp
      $.
      $( [11-Apr-2007] $) $( [14-Oct-1996] $)

    $( Variation of Axiom of Infinity.  There exists a non-empty set that is a
       subset of its union (using ~ zfinf as a hypothesis).  Abbreviated
       version of the Axiom of Infinity in [FreydScedrov] p. 283. $)
    inf2 $p |- E. x ( x =/= (/) /\ x C_ U. x ) $=
      vx cv c0 wne vx cv vx cv cuni wss wa vx wex vx cv c0 wne vy cv vx cv wcel
      vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex vx vy vz
      inf1.1 inf1 vx cv c0 wne vx cv vx cv cuni wss wa vx cv c0 wne vy cv vx cv
      wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx vx cv vx
      cv cuni wss vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex
      wi vy wal vx cv c0 wne vx cv vx cv cuni wss vy cv vx cv wcel vy cv vx cv
      cuni wcel wi vy wal vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa
      vz wex wi vy wal vy vx cv vx cv cuni dfss2 vy cv vx cv wcel vy cv vx cv
      cuni wcel wi vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex
      wi vy vy cv vx cv cuni wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex
      vy cv vx cv wcel vz vy cv vx cv eluni imbi2i albii bitri anbi2i exbii
      mpbir $.
      $( [11-Apr-2007] $) $( [28-Oct-1996] $)
  $}

  ${
    $d x y z w v u f g $.  $d v u f g G $.  $d v u f g F $.  $d v u f g A $.
    $d v u f g B $.
    inf3lem.1 $e |- G =
         { <. y , z >. | z = { w e. x | ( w i^i x ) C_ y } } $.
    inf3lem.2 $e |- F = ( rec ( G , (/) ) |` om ) $.
    inf3lem.3 $e |- A e. _V $.
    inf3lem.4 $e |- B e. _V $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lema $p |- ( A e. ( G ` B ) <-> ( A e. x /\ ( A i^i x ) C_ B ) ) $=
      vf cv vx cv cin cB wss cA vx cv cin cB wss vf cA vx cv cB cG cfv vf cv cA
      wceq vf cv vx cv cin cA vx cv cin cB vf cv cA vx cv ineq1 sseq1d cB cG
      cfv cB vu cv vf cv vx cv cin vv cv wss vf vx cv crab wceq vv vu copab cfv
      vf cv vx cv cin cB wss vf vx cv crab cB cG vu cv vf cv vx cv cin vv cv
      wss vf vx cv crab wceq vv vu copab cG vz cv vw cv vx cv cin vy cv wss vw
      vx cv crab wceq vy vz copab vu cv vf cv vx cv cin vv cv wss vf vx cv crab
      wceq vv vu copab inf3lem.1 vz cv vw cv vx cv cin vy cv wss vw vx cv crab
      wceq vu cv vf cv vx cv cin vv cv wss vf vx cv crab wceq vy vz vv vu vz cv
      vu cv wceq vy cv vv cv wceq vz cv vu cv vw cv vx cv cin vy cv wss vw vx
      cv crab vf cv vx cv cin vv cv wss vf vx cv crab vz cv vu cv wceq id vy cv
      vv cv wceq vw cv vx cv cin vy cv wss vw vx cv crab vw cv vx cv cin vv cv
      wss vw vx cv crab vf cv vx cv cin vv cv wss vf vx cv crab vy cv vv cv
      wceq vw cv vx cv cin vy cv wss vw cv vx cv cin vv cv wss vw vx cv vy cv
      vv cv vw cv vx cv cin sseq2 rabbisdv vw cv vx cv cin vv cv wss vf cv vx
      cv cin vv cv wss vw vf vx cv vw cv vf cv wceq vw cv vx cv cin vf cv vx cv
      cin vv cv vw cv vf cv vx cv ineq1 sseq1d cbvrabv syl6eq eqeqan12rd
      cbvopabv eqtri fveq1i vv vu cB vf cv vx cv cin vv cv wss vf vx cv crab vf
      cv vx cv cin cB wss vf vx cv crab inf3lem.4 vf cv vx cv cin cB wss vf vx
      cv vx visset rabex vv cv cB wceq vf cv vx cv cin vv cv wss vf cv vx cv
      cin cB wss vf vx cv vv cv cB vf cv vx cv cin sseq2 rabbisdv fvopab eqtri
      elrab2 $.
      $( [28-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lemb $p |- ( F ` (/) ) = (/) $=
      c0 cF cfv c0 cG c0 crdg com cres cfv c0 c0 cF cG c0 crdg com cres
      inf3lem.2 fveq1i c0 cvv wcel c0 cG c0 crdg com cres cfv c0 wceq 0ex c0
      cvv cG fr0g ax-mp eqtri $.
      $( [28-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lemc $p |- ( A e. om -> ( F ` suc A ) = ( G ` ( F ` A ) ) ) $=
      cA com wcel cA csuc cG c0 crdg com cres cfv cA cG c0 crdg com cres cfv cG
      cfv cA csuc cF cfv cA cF cfv cG cfv c0 cA cG frsuc cA csuc cF cG c0 crdg
      com cres inf3lem.2 fveq1i cA cF cfv cA cG c0 crdg com cres cfv cG cA cF
      cG c0 crdg com cres inf3lem.2 fveq1i fveq2i 3eqtr4g $.
      $( [28-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lemd $p |- ( A e. om -> ( F ` A ) C_ x ) $=
      cA com wcel cA cF cfv vx cv wss wi cA c0 cA c0 wceq cA cF cfv vx cv wss
      cA com wcel cA c0 wceq cA cF cfv vx cv wss c0 vx cv wss vx cv 0ss cA c0
      wceq cA cF cfv c0 vx cv cA c0 wceq cA cF cfv c0 cF cfv c0 cA c0 cF fveq2
      vx vy vz vw cA cB cF cG inf3lem.1 inf3lem.2 inf3lem.3 inf3lem.4 inf3lemb
      syl6eq sseq1d mpbiri a1d cA com wcel cA c0 wne cA cF cfv vx cv wss cA com
      wcel cA c0 wne wa cA vv cv csuc wceq vv com wrex cA cF cfv vx cv wss vv
      cA nnsuc cA vv cv csuc wceq cA cF cfv vx cv wss vv com cA vv cv csuc wceq
      cA cF cfv vx cv wss vv cv csuc cF cfv vx cv wss vv cv com wcel cA vv cv
      csuc wceq cA cF cfv vv cv csuc cF cfv vx cv cA vv cv csuc cF fveq2 sseq1d
      vv cv com wcel vu vv cv csuc cF cfv vx cv vv cv com wcel vu cv vv cv csuc
      cF cfv wcel vu cv vv cv cF cfv cG cfv wcel vu cv vx cv wcel vv cv com
      wcel vv cv csuc cF cfv vv cv cF cfv cG cfv vu cv vx vy vz vw vv cv cB cF
      cG inf3lem.1 inf3lem.2 vv visset inf3lem.4 inf3lemc eleq2d vu cv vv cv cF
      cfv cG cfv wcel vu cv vx cv wcel vu cv vx cv cin vv cv cF cfv wss vx vy
      vz vw vu cv vv cv cF cfv cF cG inf3lem.1 inf3lem.2 vu visset vv cv cF
      fvex inf3lema pm3.26bi syl6bi ssrdv syl5cbir r19.23aiv syl expcom
      pm2.61ine $.
      $( [28-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lem1 $p |- ( A e. om -> ( F ` A ) C_ ( F ` suc A ) ) $=
      vv cv cF cfv vv cv csuc cF cfv wss c0 cF cfv c0 csuc cF cfv wss vu cv cF
      cfv vu cv csuc cF cfv wss vu cv csuc cF cfv vu cv csuc csuc cF cfv wss cA
      cF cfv cA csuc cF cfv wss vv vu cA vv cv c0 wceq vv cv cF cfv c0 cF cfv
      vv cv csuc cF cfv c0 csuc cF cfv vv cv c0 cF fveq2 vv cv c0 wceq vv cv
      csuc c0 csuc cF vv cv c0 suceq fveq2d sseq12d vv cv vu cv wceq vv cv cF
      cfv vu cv cF cfv vv cv csuc cF cfv vu cv csuc cF cfv vv cv vu cv cF fveq2
      vv cv vu cv wceq vv cv csuc vu cv csuc cF vv cv vu cv suceq fveq2d
      sseq12d vv cv vu cv csuc wceq vv cv cF cfv vu cv csuc cF cfv vv cv csuc
      cF cfv vu cv csuc csuc cF cfv vv cv vu cv csuc cF fveq2 vv cv vu cv csuc
      wceq vv cv csuc vu cv csuc csuc cF vv cv vu cv csuc suceq fveq2d sseq12d
      vv cv cA wceq vv cv cF cfv cA cF cfv vv cv csuc cF cfv cA csuc cF cfv vv
      cv cA cF fveq2 vv cv cA wceq vv cv csuc cA csuc cF vv cv cA suceq fveq2d
      sseq12d c0 cF cfv c0 c0 csuc cF cfv vx vy vz vw cA cA cF cG inf3lem.1
      inf3lem.2 inf3lem.3 inf3lem.3 inf3lemb c0 csuc cF cfv 0ss eqsstri vu cv
      com wcel vu cv cF cfv vu cv csuc cF cfv wss vu cv csuc cF cfv vu cv csuc
      csuc cF cfv wss vu cv com wcel vu cv cF cfv vu cv csuc cF cfv wss wa vv
      vu cv csuc cF cfv vu cv csuc csuc cF cfv vu cv com wcel vu cv cF cfv vu
      cv csuc cF cfv wss vv cv vu cv csuc cF cfv wcel vv cv vu cv csuc csuc cF
      cfv wcel wi vu cv com wcel vv cv vu cv csuc cF cfv wcel vv cv vu cv csuc
      csuc cF cfv wcel wi vv cv vx cv wcel vv cv vx cv cin vu cv cF cfv wss wa
      vv cv vx cv wcel vv cv vx cv cin vu cv csuc cF cfv wss wa wi vu cv cF cfv
      vu cv csuc cF cfv wss vu cv com wcel vv cv vu cv csuc cF cfv wcel vv cv
      vx cv wcel vv cv vx cv cin vu cv cF cfv wss wa vv cv vu cv csuc csuc cF
      cfv wcel vv cv vx cv wcel vv cv vx cv cin vu cv csuc cF cfv wss wa vu cv
      com wcel vv cv vu cv csuc cF cfv wcel vv cv vu cv cF cfv cG cfv wcel vv
      cv vx cv wcel vv cv vx cv cin vu cv cF cfv wss wa vu cv com wcel vu cv
      csuc cF cfv vu cv cF cfv cG cfv vv cv vx vy vz vw vu cv vu cv cF cG
      inf3lem.1 inf3lem.2 vu visset vu visset inf3lemc eleq2d vx vy vz vw vv cv
      vu cv cF cfv cF cG inf3lem.1 inf3lem.2 vv visset vu cv cF fvex inf3lema
      syl6bb vu cv com wcel vv cv vu cv csuc csuc cF cfv wcel vv cv vu cv csuc
      cF cfv cG cfv wcel vv cv vx cv wcel vv cv vx cv cin vu cv csuc cF cfv wss
      wa vu cv com wcel vu cv csuc csuc cF cfv vu cv csuc cF cfv cG cfv vv cv
      vu cv com wcel vu cv csuc com wcel vu cv csuc csuc cF cfv vu cv csuc cF
      cfv cG cfv wceq vu cv peano2b vx vy vz vw vu cv csuc vu cv cF cG
      inf3lem.1 inf3lem.2 vu cv vu visset sucex vu visset inf3lemc sylbi eleq2d
      vx vy vz vw vv cv vu cv csuc cF cfv cF cG inf3lem.1 inf3lem.2 vv visset
      vu cv csuc cF fvex inf3lema syl6bb imbi12d vu cv cF cfv vu cv csuc cF cfv
      wss vv cv vx cv cin vu cv cF cfv wss vv cv vx cv cin vu cv csuc cF cfv
      wss vv cv vx cv wcel vv cv vx cv cin vu cv cF cfv wss vu cv cF cfv vu cv
      csuc cF cfv wss vv cv vx cv cin vu cv csuc cF cfv wss vv cv vx cv cin vu
      cv cF cfv vu cv csuc cF cfv sstr2 com12 anim2d syl5bir imp ssrdv ex finds
      $.
      $( [28-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lem2 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( A e. om -> ( F ` A ) =/= x ) ) $=
      cA com wcel vx cv c0 wne vx cv vx cv cuni wss wa cA cF cfv vx cv wne vx
      cv c0 wne vx cv vx cv cuni wss wa vv cv cF cfv vx cv wne wi vx cv c0 wne
      vx cv vx cv cuni wss wa c0 cF cfv vx cv wne wi vx cv c0 wne vx cv vx cv
      cuni wss wa vu cv cF cfv vx cv wne wi vx cv c0 wne vx cv vx cv cuni wss
      wa vu cv csuc cF cfv vx cv wne wi vx cv c0 wne vx cv vx cv cuni wss wa cA
      cF cfv vx cv wne wi vv vu cA vv cv c0 wceq vv cv cF cfv vx cv wne c0 cF
      cfv vx cv wne vx cv c0 wne vx cv vx cv cuni wss wa vv cv c0 wceq vv cv cF
      cfv c0 cF cfv vx cv vv cv c0 cF fveq2 neeq1d imbi2d vv cv vu cv wceq vv
      cv cF cfv vx cv wne vu cv cF cfv vx cv wne vx cv c0 wne vx cv vx cv cuni
      wss wa vv cv vu cv wceq vv cv cF cfv vu cv cF cfv vx cv vv cv vu cv cF
      fveq2 neeq1d imbi2d vv cv vu cv csuc wceq vv cv cF cfv vx cv wne vu cv
      csuc cF cfv vx cv wne vx cv c0 wne vx cv vx cv cuni wss wa vv cv vu cv
      csuc wceq vv cv cF cfv vu cv csuc cF cfv vx cv vv cv vu cv csuc cF fveq2
      neeq1d imbi2d vv cv cA wceq vv cv cF cfv vx cv wne cA cF cfv vx cv wne vx
      cv c0 wne vx cv vx cv cuni wss wa vv cv cA wceq vv cv cF cfv cA cF cfv vx
      cv vv cv cA cF fveq2 neeq1d imbi2d vx cv c0 wne c0 cF cfv vx cv wne vx cv
      vx cv cuni wss c0 cF cfv vx cv vx cv c0 c0 cF cfv vx cv wceq vx cv c0
      wceq c0 cF cfv vx cv wceq c0 vx cv wceq vx cv c0 wceq c0 cF cfv c0 vx cv
      vx vy vz vw cA cB cF cG inf3lem.1 inf3lem.2 inf3lem.3 inf3lem.4 inf3lemb
      eqeq1i c0 vx cv eqcom bitri biimpi necon3i adantr vu cv com wcel vx cv c0
      wne vx cv vx cv cuni wss wa vu cv cF cfv vx cv wne vu cv csuc cF cfv vx
      cv wne vu cv com wcel vx cv vx cv cuni wss vu cv cF cfv vx cv wne vu cv
      csuc cF cfv vx cv wne wi vx cv c0 wne vx cv vx cv cuni wss vu cv com wcel
      vu cv cF cfv vx cv wne vu cv csuc cF cfv vx cv wne wi vu cv com wcel vx
      cv vx cv cuni wss vu cv com wcel vu cv cF cfv vx cv wne vu cv csuc cF cfv
      vx cv wne vu cv com wcel vx cv vx cv cuni wss wa vu cv cF cfv vx cv wss
      vu cv cF cfv vx cv wne vu cv csuc cF cfv vx cv wne vu cv com wcel vu cv
      com wcel vx cv vx cv cuni wss wa vv cv vx cv wcel vv cv vu cv cF cfv wcel
      wn wa vv wex vu cv csuc cF cfv vx cv wne vu cv cF cfv vx cv wss vu cv cF
      cfv vx cv wne wa vu cv com wcel vx cv vx cv cuni wss wa vv cv vx cv wcel
      vv cv vu cv cF cfv wcel wn wa vu cv csuc cF cfv vx cv wne vv vu cv com
      wcel vx cv vx cv cuni wss wa vv cv vx cv wcel vv cv vu cv cF cfv wcel wn
      vu cv csuc cF cfv vx cv wne vu cv com wcel vx cv vx cv cuni wss wa vv cv
      vx cv wcel vu cv csuc cF cfv vx cv wceq vv cv vu cv cF cfv wcel wi vv cv
      vu cv cF cfv wcel wn vu cv csuc cF cfv vx cv wne wi vu cv com wcel vx cv
      vx cv cuni wss wa vv cv vx cv wcel vu cv csuc cF cfv vx cv wceq vv cv vu
      cv cF cfv wcel wi vx cv vx cv cuni wss vv cv vx cv wcel vv cv vf cv wcel
      vf cv vx cv wcel wa vf wex vu cv com wcel vv cv vx cv wcel vu cv csuc cF
      cfv vx cv wceq vv cv vu cv cF cfv wcel wi wi vx cv vx cv cuni wss vv cv
      vx cv wcel vv cv vx cv cuni wcel vv cv vf cv wcel vf cv vx cv wcel wa vf
      wex vx cv vx cv cuni vv cv ssel vf vv cv vx cv eluni syl6ib vu cv com
      wcel vv cv vf cv wcel vf cv vx cv wcel wa vv cv vx cv wcel vu cv csuc cF
      cfv vx cv wceq vv cv vu cv cF cfv wcel wi wi vf vu cv com wcel vv cv vf
      cv wcel vf cv vx cv wcel vv cv vx cv wcel vu cv csuc cF cfv vx cv wceq vv
      cv vu cv cF cfv wcel wi wi vu cv com wcel vv cv vf cv wcel vv cv vx cv
      wcel vf cv vx cv wcel vu cv csuc cF cfv vx cv wceq vv cv vu cv cF cfv
      wcel wi vu cv com wcel vv cv vf cv wcel vv cv vx cv wcel vf cv vx cv wcel
      vu cv csuc cF cfv vx cv wceq vv cv vu cv cF cfv wcel wi wi vu cv com wcel
      vv cv vf cv wcel vv cv vx cv wcel wa vf cv vx cv wcel vu cv csuc cF cfv
      vx cv wceq vv cv vu cv cF cfv wcel vu cv com wcel vf cv vx cv wcel vu cv
      csuc cF cfv vx cv wceq wa vv cv vf cv wcel vv cv vx cv wcel wa vv cv vu
      cv cF cfv wcel vu cv com wcel vf cv vu cv csuc cF cfv wcel vv cv vf cv
      wcel vv cv vx cv wcel wa vv cv vu cv cF cfv wcel wi vf cv vx cv wcel vu
      cv csuc cF cfv vx cv wceq wa vu cv com wcel vf cv vu cv csuc cF cfv wcel
      vf cv vu cv cF cfv cG cfv wcel vv cv vf cv wcel vv cv vx cv wcel wa vv cv
      vu cv cF cfv wcel wi vu cv com wcel vu cv csuc cF cfv vu cv cF cfv cG cfv
      vf cv vx vy vz vw vu cv cB cF cG inf3lem.1 inf3lem.2 vu visset inf3lem.4
      inf3lemc eleq2d vf cv vu cv cF cfv cG cfv wcel vv cv vf cv vx cv cin wcel
      vv cv vu cv cF cfv wcel vv cv vf cv wcel vv cv vx cv wcel wa vf cv vu cv
      cF cfv cG cfv wcel vf cv vx cv cin vu cv cF cfv vv cv vf cv vu cv cF cfv
      cG cfv wcel vf cv vx cv wcel vf cv vx cv cin vu cv cF cfv wss vx vy vz vw
      vf cv vu cv cF cfv cF cG inf3lem.1 inf3lem.2 vf visset vu cv cF fvex
      inf3lema pm3.27bi sseld vv cv vf cv vx cv elin syl5ibr syl6bi vu cv csuc
      cF cfv vx cv wceq vf cv vu cv csuc cF cfv wcel vf cv vx cv wcel vu cv
      csuc cF cfv vx cv vf cv eleq2 biimparc syl5 com23 exp4a exp3a com34 imp3a
      19.23adv sylan9r pm2.43d vu cv csuc cF cfv vx cv wceq vv cv vu cv cF cfv
      wcel wi vv cv vu cv cF cfv wcel vu cv csuc cF cfv vx cv vu cv csuc cF cfv
      vx cv wceq vv cv vu cv cF cfv wcel wi id necon3bd syl6 imp3a 19.23adv vu
      cv cF cfv vx cv wss vu cv cF cfv vx cv wne wa vu cv cF cfv vx cv wpss vv
      cv vx cv wcel vv cv vu cv cF cfv wcel wn wa vv wex vu cv cF cfv vx cv
      df-pss vv vu cv cF cfv vx cv pssnel sylbir syl5 vx vy vz vw vu cv cB cF
      cG inf3lem.1 inf3lem.2 vu visset inf3lem.4 inf3lemd sylani exp4b pm2.43a
      adantld a2d finds com12 $.
      $( [28-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  In the proof, we invoke the Axiom of
       Regularity in the form of ~ zfreg . $)
    inf3lem3 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( A e. om -> ( F ` A ) =/= ( F ` suc A ) ) ) $=
      cA com wcel vx cv c0 wne vx cv vx cv cuni wss wa cA cF cfv cA csuc cF cfv
      wne cA com wcel vx cv c0 wne vx cv vx cv cuni wss wa vx cv cA cF cfv cdif
      c0 wne cA cF cfv cA csuc cF cfv wne cA com wcel vx cv c0 wne vx cv vx cv
      cuni wss wa cA cF cfv vx cv wss cA cF cfv vx cv wne wa vx cv cA cF cfv
      cdif c0 wne cA com wcel vx cv c0 wne vx cv vx cv cuni wss wa cA cF cfv vx
      cv wne cA cF cfv vx cv wss vx cv c0 wne vx cv vx cv cuni wss wa cA com
      wcel cA cF cfv vx cv wne vx vy vz vw cA cB cF cG inf3lem.1 inf3lem.2
      inf3lem.3 inf3lem.4 inf3lem2 com12 vx vy vz vw cA cB cF cG inf3lem.1
      inf3lem.2 inf3lem.3 inf3lem.4 inf3lemd jctild cA cF cfv vx cv pssdifn0
      syl6 cA com wcel vv cv vx cv cA cF cfv cdif cin c0 wceq vv vx cv cA cF
      cfv cdif wrex cA cF cfv cA csuc cF cfv wne vx cv cA cF cfv cdif c0 wne cA
      com wcel vv cv vx cv cA cF cfv cdif cin c0 wceq cA cF cfv cA csuc cF cfv
      wne vv vx cv cA cF cfv cdif cA com wcel vv cv vx cv cA cF cfv cdif wcel
      vv cv vx cv cA cF cfv cdif cin c0 wceq cA cF cfv cA csuc cF cfv wne cA
      com wcel vv cv vx cv cA cF cfv cdif wcel vv cv vx cv cA cF cfv cdif cin
      c0 wceq wa vv cv cA csuc cF cfv wcel vv cv cA cF cfv wcel wn wa cA cF cfv
      cA csuc cF cfv wne cA com wcel vv cv vx cv cA cF cfv cdif wcel vv cv vx
      cv cA cF cfv cdif cin c0 wceq wa vv cv cA csuc cF cfv wcel vv cv cA cF
      cfv wcel wn cA com wcel vv cv cA csuc cF cfv wcel vv cv cA cF cfv cG cfv
      wcel vv cv vx cv cA cF cfv cdif wcel vv cv vx cv cA cF cfv cdif cin c0
      wceq wa cA com wcel cA csuc cF cfv cA cF cfv cG cfv vv cv vx vy vz vw cA
      cB cF cG inf3lem.1 inf3lem.2 inf3lem.3 inf3lem.4 inf3lemc eleq2d vv cv vx
      cv cA cF cfv cdif wcel vv cv vx cv cA cF cfv cdif cin c0 wceq wa vv cv vx
      cv wcel vv cv vx cv cin cA cF cfv wss wa vv cv cA cF cfv cG cfv wcel vv
      cv vx cv cA cF cfv cdif wcel vv cv vx cv wcel vv cv vx cv cA cF cfv cdif
      cin c0 wceq vv cv vx cv cin cA cF cfv wss vv cv vx cv cA cF cfv eldifi vv
      cv vx cv cin cA cF cfv wss vv cv vx cv cA cF cfv cdif cin c0 wceq vv cv
      vx cv cA cF cfv inssdif0 biimpri anim12i vx vy vz vw vv cv cA cF cfv cF
      cG inf3lem.1 inf3lem.2 vv visset cA cF fvex inf3lema sylibr syl5bir vv cv
      vx cv cA cF cfv cdif wcel vv cv vx cv cA cF cfv cdif cin c0 wceq wa vv cv
      cA cF cfv wcel wn wi cA com wcel vv cv vx cv cA cF cfv cdif wcel vv cv cA
      cF cfv wcel wn vv cv vx cv cA cF cfv cdif cin c0 wceq vv cv vx cv cA cF
      cfv eldifn adantr a1i jcad vv cv cA csuc cF cfv wcel vv cv cA cF cfv wcel
      wn wa cA cF cfv cA csuc cF cfv cA cF cfv cA csuc cF cfv wceq vv cv cA
      csuc cF cfv wcel vv cv cA cF cfv wcel wi vv cv cA csuc cF cfv wcel vv cv
      cA cF cfv wcel wn wa wn cA cF cfv cA csuc cF cfv wceq vv cv cA cF cfv
      wcel vv cv cA csuc cF cfv wcel cA cF cfv cA csuc cF cfv vv cv eleq2
      biimprd vv cv cA csuc cF cfv wcel vv cv cA cF cfv wcel iman sylib
      necon2ai syl6 exp3a r19.23adv vv vx cv cA cF cfv cdif vx cv cA cF cfv
      cdif vx cv vx visset vx cv cA cF cfv difss ssexi zfreg syl5 syld com12 $.
      $( [29-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lem4 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( A e. om -> ( F ` A ) C. ( F ` suc A ) ) ) $=
      vx cv c0 wne vx cv vx cv cuni wss wa cA com wcel cA cF cfv cA csuc cF cfv
      wss cA cF cfv cA csuc cF cfv wne wa cA cF cfv cA csuc cF cfv wpss vx cv
      c0 wne vx cv vx cv cuni wss wa cA com wcel cA cF cfv cA csuc cF cfv wss
      cA cF cfv cA csuc cF cfv wne cA com wcel cA cF cfv cA csuc cF cfv wss wi
      vx cv c0 wne vx cv vx cv cuni wss wa vx vy vz vw cA cB cF cG inf3lem.1
      inf3lem.2 inf3lem.3 inf3lem.4 inf3lem1 a1i vx vy vz vw cA cB cF cG
      inf3lem.1 inf3lem.2 inf3lem.3 inf3lem.4 inf3lem3 jcad cA cF cfv cA csuc
      cF cfv df-pss syl6ibr $.
      $( [29-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lem5 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( ( A e. om /\ B e. A ) -> ( F ` B ) C. ( F ` A ) ) ) $=
      cA com wcel cB cA wcel wa vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv
      cA cF cfv wpss cA com wcel cB cA wcel wa cB com wcel vx cv c0 wne vx cv
      vx cv cuni wss wa cB cF cfv cA cF cfv wpss wi cB cA wcel cA com wcel cB
      com wcel cB cA elnn ancoms cA com wcel cB cA wcel cB com wcel vx cv c0
      wne vx cv vx cv cuni wss wa cB cF cfv cA cF cfv wpss wi wi cA com wcel cB
      com wcel cB cA wcel vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv cA cF
      cfv wpss wi cA com wcel cB com wcel cB cA wcel vx cv c0 wne vx cv vx cv
      cuni wss wa cB cF cfv cA cF cfv wpss wi wi cA com wcel cB com wcel wa cB
      cA wcel cB csuc cA wss vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv cA
      cF cfv wpss wi cA com wcel cB cA wcel cB csuc cA wss wi cB com wcel cA
      com wcel cA word cB cA wcel cB csuc cA wss wi cA nnord cB cA ordsucss syl
      adantr cA com wcel cB csuc com wcel cB csuc cA wss vx cv c0 wne vx cv vx
      cv cuni wss wa cB cF cfv cA cF cfv wpss wi wi cB com wcel cA com wcel cB
      csuc com wcel wa cB csuc cA wss vx cv c0 wne vx cv vx cv cuni wss wa cB
      cF cfv cA cF cfv wpss wi vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv
      vv cv cF cfv wpss wi vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv cB
      csuc cF cfv wpss wi vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv vu cv
      cF cfv wpss wi vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv vu cv csuc
      cF cfv wpss wi vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv cA cF cfv
      wpss wi vv vu cA cB csuc vv cv cB csuc wceq cB cF cfv vv cv cF cfv wpss
      cB cF cfv cB csuc cF cfv wpss vx cv c0 wne vx cv vx cv cuni wss wa vv cv
      cB csuc wceq vv cv cF cfv cB csuc cF cfv cB cF cfv vv cv cB csuc cF fveq2
      psseq2d imbi2d vv cv vu cv wceq cB cF cfv vv cv cF cfv wpss cB cF cfv vu
      cv cF cfv wpss vx cv c0 wne vx cv vx cv cuni wss wa vv cv vu cv wceq vv
      cv cF cfv vu cv cF cfv cB cF cfv vv cv vu cv cF fveq2 psseq2d imbi2d vv
      cv vu cv csuc wceq cB cF cfv vv cv cF cfv wpss cB cF cfv vu cv csuc cF
      cfv wpss vx cv c0 wne vx cv vx cv cuni wss wa vv cv vu cv csuc wceq vv cv
      cF cfv vu cv csuc cF cfv cB cF cfv vv cv vu cv csuc cF fveq2 psseq2d
      imbi2d vv cv cA wceq cB cF cfv vv cv cF cfv wpss cB cF cfv cA cF cfv wpss
      vx cv c0 wne vx cv vx cv cuni wss wa vv cv cA wceq vv cv cF cfv cA cF cfv
      cB cF cfv vv cv cA cF fveq2 psseq2d imbi2d cB csuc com wcel cB com wcel
      vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv cB csuc cF cfv wpss wi cB
      peano2b vx cv c0 wne vx cv vx cv cuni wss wa cB com wcel cB cF cfv cB
      csuc cF cfv wpss vx vy vz vw cB cB cF cG inf3lem.1 inf3lem.2 inf3lem.4
      inf3lem.4 inf3lem4 com12 sylbir vu cv com wcel vx cv c0 wne vx cv vx cv
      cuni wss wa cB cF cfv vu cv cF cfv wpss wi vx cv c0 wne vx cv vx cv cuni
      wss wa cB cF cfv vu cv csuc cF cfv wpss wi wi cB csuc com wcel cB csuc vu
      cv wss vu cv com wcel vx cv c0 wne vx cv vx cv cuni wss wa cB cF cfv vu
      cv cF cfv wpss cB cF cfv vu cv csuc cF cfv wpss vx cv c0 wne vx cv vx cv
      cuni wss wa vu cv com wcel vu cv cF cfv vu cv csuc cF cfv wpss cB cF cfv
      vu cv cF cfv wpss cB cF cfv vu cv csuc cF cfv wpss wi vx vy vz vw vu cv
      cB cF cG inf3lem.1 inf3lem.2 vu visset inf3lem.4 inf3lem4 cB cF cfv vu cv
      cF cfv wpss vu cv cF cfv vu cv csuc cF cfv wpss cB cF cfv vu cv csuc cF
      cfv wpss cB cF cfv vu cv cF cfv vu cv csuc cF cfv psstr expcom syl6com
      a2d ad2antrr findsg ex cB peano2b sylan2b syld ex com23 imp mpd com12 $.
      $( [29-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description. $)
    inf3lem6 $p |- ( ( x =/= (/) /\ x C_ U. x ) -> F : om -1-1-> ~P x ) $=
      vx cv c0 wne vx cv vx cv cuni wss wa com vx cv cpw cF wf vv cv cF cfv vu
      cv cF cfv wceq vv cv vu cv wceq wi vu com wral vv com wral wa com vx cv
      cpw cF wf1 vx cv c0 wne vx cv vx cv cuni wss wa vv cv cF cfv vu cv cF cfv
      wceq vv cv vu cv wceq wi vu com wral vv com wral com vx cv cpw cF wf vx
      cv c0 wne vx cv vx cv cuni wss wa vv cv com wcel vu cv com wcel wa vv cv
      cF cfv vu cv cF cfv wceq vv cv vu cv wceq wi wi vu wal vv wal vv cv cF
      cfv vu cv cF cfv wceq vv cv vu cv wceq wi vu com wral vv com wral vx cv
      c0 wne vx cv vx cv cuni wss wa vv cv com wcel vu cv com wcel wa vv cv cF
      cfv vu cv cF cfv wceq vv cv vu cv wceq wi wi vv vu vx cv c0 wne vx cv vx
      cv cuni wss wa vv cv com wcel vu cv com wcel wa vv cv cF cfv vu cv cF cfv
      wceq vv cv vu cv wceq wi vx cv c0 wne vx cv vx cv cuni wss wa vv cv com
      wcel vu cv com wcel wa wa vv cv cF cfv vu cv cF cfv wceq vv cv vu cv wcel
      vu cv vv cv wcel wo wn vv cv vu cv wceq vx cv c0 wne vx cv vx cv cuni wss
      wa vv cv com wcel vu cv com wcel wa wa vv cv vu cv wcel vu cv vv cv wcel
      wo vv cv cF cfv vu cv cF cfv wceq vx cv c0 wne vx cv vx cv cuni wss wa vv
      cv com wcel vu cv com wcel wa wa vv cv vu cv wcel vv cv cF cfv vu cv cF
      cfv wceq wn vu cv vv cv wcel vx cv c0 wne vx cv vx cv cuni wss wa vu cv
      com wcel vv cv vu cv wcel vv cv cF cfv vu cv cF cfv wceq wn wi vv cv com
      wcel vx cv c0 wne vx cv vx cv cuni wss wa vu cv com wcel vv cv vu cv wcel
      vv cv cF cfv vu cv cF cfv wceq wn vx cv c0 wne vx cv vx cv cuni wss wa vu
      cv com wcel vv cv vu cv wcel wa vv cv cF cfv vu cv cF cfv wpss vv cv cF
      cfv vu cv cF cfv wceq wn vx vy vz vw vu cv vv cv cF cG inf3lem.1
      inf3lem.2 vu visset vv visset inf3lem5 vv cv cF cfv vu cv cF cfv wpss vv
      cv cF cfv vu cv cF cfv wss vv cv cF cfv vu cv cF cfv wceq wn vv cv cF cfv
      vu cv cF cfv dfpss2 pm3.27bi syl6 expdimp adantrl vx cv c0 wne vx cv vx
      cv cuni wss wa vv cv com wcel vu cv vv cv wcel vv cv cF cfv vu cv cF cfv
      wceq wn wi vu cv com wcel vx cv c0 wne vx cv vx cv cuni wss wa vv cv com
      wcel vu cv vv cv wcel vv cv cF cfv vu cv cF cfv wceq wn vx cv c0 wne vx
      cv vx cv cuni wss wa vv cv com wcel vu cv vv cv wcel wa vu cv cF cfv vv
      cv cF cfv wpss vv cv cF cfv vu cv cF cfv wceq wn vx vy vz vw vv cv vu cv
      cF cG inf3lem.1 inf3lem.2 vv visset vu visset inf3lem5 vu cv cF cfv vv cv
      cF cfv wpss vu cv cF cfv vv cv cF cfv wceq wn vv cv cF cfv vu cv cF cfv
      wceq wn vu cv cF cfv vv cv cF cfv wpss vu cv cF cfv vv cv cF cfv wss vu
      cv cF cfv vv cv cF cfv wceq wn vu cv cF cfv vv cv cF cfv dfpss2 pm3.27bi
      vu cv cF cfv vv cv cF cfv wceq vv cv cF cfv vu cv cF cfv wceq vu cv cF
      cfv vv cv cF cfv eqcom notbii sylib syl6 expdimp adantrr jaod con2d vv cv
      com wcel vu cv com wcel wa vv cv vu cv wceq vv cv vu cv wcel vu cv vv cv
      wcel wo wn wb vx cv c0 wne vx cv vx cv cuni wss wa vv cv word vu cv word
      vv cv vu cv wceq vv cv vu cv wcel vu cv vv cv wcel wo wn wb vv cv com
      wcel vu cv com wcel vv cv vu cv ordtri3 vv cv nnord vu cv nnord syl2an
      adantl sylibrd ex 19.21aivv vv cv cF cfv vu cv cF cfv wceq vv cv vu cv
      wceq wi vv vu com com r2al sylibr com vx cv cpw cF wf cF com wfn cF crn
      vx cv cpw wss wa cF com wfn cF com wfn cF crn vx cv cpw wss wa cF cG c0
      crdg com cres wceq cF com wfn inf3lem.2 cF cG c0 crdg com cres wceq cF
      com wfn cG c0 crdg com cres com wfn c0 cG frfnom com cF cG c0 crdg com
      cres fneq1 mpbiri ax-mp cF com wfn cF crn vx cv cpw wss cF com wfn vu cF
      crn vx cv cpw cF com wfn vu cv cF crn wcel vv cv cF cfv vu cv wceq vv com
      wrex vu cv vx cv cpw wcel vv com vu cv cF fvelrnb vv cv cF cfv vu cv wceq
      vu cv vx cv cpw wcel vv com vv cv cF cfv vu cv wceq vv cv cF cfv vx cv
      cpw wcel vu cv vx cv cpw wcel vv cv com wcel vv cv cF cfv vu cv vx cv cpw
      eleq1 vv cv com wcel vv cv cF cfv vx cv wss vv cv cF cfv vx cv cpw wcel
      vx vy vz vw vv cv cB cF cG inf3lem.1 inf3lem.2 vv visset inf3lem.4
      inf3lemd vv cv cF cfv vx cv vv cv cF fvex elpw sylibr syl5cbi r19.23aiv
      syl6bi ssrdv ancli ax-mp com vx cv cpw cF df-f mpbir jctil vv vu com vx
      cv cpw cF dff13 sylibr $.
      $( [29-Oct-1996] $)

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  In the proof, we invoke the Axiom of
       Replacement in the form of ~ funrnex . $)
    inf3lem7 $p |- ( ( x =/= (/) /\ x C_ U. x ) -> om e. _V ) $=
      vx cv c0 wne vx cv vx cv cuni wss wa com vx cv cpw cF wf1 com cvv wcel vx
      vy vz vw cA cB cF cG inf3lem.1 inf3lem.2 inf3lem.3 inf3lem.4 inf3lem6 com
      vx cv cpw cF wf1 cF ccnv crn com cvv com vx cv cpw cF wf1 cF cdm com cF
      ccnv crn com vx cv cpw cF wf1 com vx cv cpw cF wf cF cdm com wceq com vx
      cv cpw cF f1f com vx cv cpw cF fdm syl cF dfdm4 syl5eqr cF ccnv cdm cvv
      wcel cF ccnv wfun cF ccnv crn cvv wcel com vx cv cpw cF wf1 cvv cF ccnv
      funrnex com vx cv cpw cF wf1 cF crn cvv cF ccnv cdm com vx cv cpw cF wf1
      com vx cv cpw cF wf cF crn vx cv cpw wss cF crn cvv wcel com vx cv cpw cF
      f1f com vx cv cpw cF frn cF crn vx cv cpw vx cv vx visset pwex ssex 3syl
      cF df-rn syl5eqelr com vx cv cpw cF wf1 com vx cv cpw cF wf cF ccnv wfun
      com vx cv cpw cF df-f1 pm3.27bi sylc eqeltrrd syl $.
      $( [29-Oct-1996] $)
  $}

  ${
    $d x y z w $.
    inf3.1 $e |- E. x ( x =/= (/) /\ x C_ U. x ) $.
    $( Note: the special <PRE> tag is handled by mmwtex.c. $)
    $( Our Axiom of Infinity ~ ax-inf implies the standard Axiom of Infinity.
       The hypothesis is a variant of our Axiom of Infinity provided by
       ~ inf2 , and the conclusion is the version of the Axiom of Infinity
       shown as Axiom 7 in [TakeutiZaring] p. 43.  (Other standard versions are
       proved later as ~ axinf2 and ~ zfinf2 .)  The main proof is provided by
       ~ inf3lema through ~ inf3lem7 , and this final piece eliminates the
       auxiliary hypothesis of ~ inf3lem7 .  This proof is due to
       Ian Sutherland, Richard Heck, and Norman Megill and was posted
       on Usenet as shown below.  Although the result is not new, the authors
       were unable to find a published proof.
<PRE>
(As posted to sci.logic on 30-Oct-1996, with annotations added.)

Theorem:  The statement "There exists a non-empty set that is a subset
of its union" implies the Axiom of Infinity.

Proof:  Let X be a nonempty set which is a subset of its union; the latter
property is equivalent to saying that for any y in X, there exists a z in X
such that y is in z.

Define by finite recursion a function F:omega-->(power X) such that
  F_0 = 0  (See ~ inf3lemb .)
  F_n+1 = {y<X | y^X subset F_n}  (See ~ inf3lemc .)
Note: ^ means intersect, < means \in ("element of").
(Finite recursion as typically done requires the existence of omega;
to avoid this we can just use transfinite recursion restricted to omega.
F is a class-term that is not necessarily a set at this point.)

Lemma 1.  F_n subset F_n+1.  (See ~ inf3lem1 .)
Proof:  By induction:  F_0 subset F_1.  If y < F_n+1, then y^X subset F_n,
so if F_n subset F_n+1, then y^X subset F_n+1, so y < F_n+2.

Lemma 2.  F_n =/= X.  (See ~ inf3lem2 .)
Proof:  By induction:  F_0 =/= X because X is not empty.  Assume F_n =/= X.
Then there is a y in X that is not in F_n.  By definition of X, there is a
z in X that contains y.  Suppose F_n+1 = X.  Then z is in F_n+1, and z^X
contains y, so z^X is not a subset of F_n, contrary to the definition of
F_n+1.

Lemma 3.  F_n =/= F_n+1.  (See ~ inf3lem3 .)
Proof:  Using the identity y^X subset F_n <-> y^(X-F_n) = 0, we have
F_n+1 = {y<X | y^(X-F_n) = 0}.  Let q = {y<X-F_n | y^(X-F_n) = 0}.
Then q subset F_n+1.  Since X-F_n is not empty by Lemma 2 and q is the
set of \in-minimal elements of X-F_n, by Foundation q is not empty, so q
and therefore F_n+1 have an element not in F_n.

Lemma 4.  F_n proper_subset F_n+1.  (See ~ inf3lem4 .)
Proof:  Lemmas 1 and 3.

Lemma 5.  F_m proper_subset F_n, m < n.  (See ~ inf3lem5 .)
Proof:  Fix m and use induction on n > m.  Basis: F_m proper_subset F_m+1
by Lemma 4.  Induction:  Assume F_m proper_subset F_n.  Then since F_n
proper_subset F_n+1, F_m proper_subset F_n+1 by transitivity of proper
subset.

By Lemma 5, F_m =/= F_n for m =/= n, so F is 1-1.  (See ~ inf3lem6 .)
Thus the inverse of F is a function with range omega and domain a subset
of power X, so omega exists by Replacement.  (See ~ inf3lem7 .)
Q.E.D.
</PRE> $)
    inf3 $p |- om e. _V $=
      vx cv c0 wne vx cv vx cv cuni wss wa vx wex com cvv wcel inf3.1 vx cv c0
      wne vx cv vx cv cuni wss wa com cvv wcel vx vx vy vz vw vx cv vx cv vz cv
      vw cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres
      vz cv vw cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab vz cv vw
      cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab eqid vz cv vw cv vx
      cv cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres eqid vx
      visset vx visset inf3lem7 19.23aiv ax-mp $.
      $( [29-Oct-1996] $)
  $}

  ${
    $d x y z w $.
    $( The statement "there exists a set that is a proper subset of its
       union" is equivalent to the Axiom of Infinity (shown on the right-hand
       side in the form of ~ omex .)  The left-hand side provides us with a
       very short way to express of the Axiom of Infinity using only elementary
       symbols.  This proof of equivalence does not depend on the Axiom of
       Infinity. $)
    infeq5 $p |- ( E. x x C. U. x <-> om e. _V ) $=
      vx cv vx cv cuni wpss vx wex com cvv wcel vx cv vx cv cuni wpss vx wex vx
      cv c0 wne vx cv vx cv cuni wss wa vx wex com cvv wcel vx cv vx cv cuni
      wpss vx cv c0 wne vx cv vx cv cuni wss wa vx vx cv vx cv cuni wpss vx cv
      vx cv cuni wss vx cv vx cv cuni wne wa vx cv c0 wne vx cv vx cv cuni wss
      wa vx cv vx cv cuni df-pss vx cv vx cv cuni wne vx cv vx cv cuni wss vx
      cv c0 wne vx cv vx cv cuni wss wa vx cv vx cv cuni wne vx cv c0 wne vx cv
      vx cv cuni wss vx cv c0 vx cv vx cv cuni vx cv c0 wceq c0 vx cv cuni wceq
      vx cv vx cv cuni wceq vx cv c0 wceq vx cv cuni c0 cuni c0 vx cv c0 unieq
      uni0 syl6req vx cv c0 vx cv cuni eqtr mpdan necon3i anim1i ancoms sylbi
      19.22i vx cv c0 wne vx cv vx cv cuni wss wa com cvv wcel vx vx vy vz vw
      vx cv vx cv vz cv vw cv vx cv cin vy cv wss vw vx cv crab wceq vy vz
      copab c0 crdg com cres vz cv vw cv vx cv cin vy cv wss vw vx cv crab wceq
      vy vz copab vz cv vw cv vx cv cin vy cv wss vw vx cv crab wceq vy vz
      copab eqid vz cv vw cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab
      c0 crdg com cres eqid vx visset vx visset inf3lem7 19.23aiv syl com cvv
      wcel com c0 csn cdif cvv wcel vx cv vx cv cuni wpss vx wex com c0 csn cvv
      difexg com c0 csn cdif cvv wcel com c0 csn cdif com c0 csn cdif cuni wpss
      vx cv vx cv cuni wpss vx wex com c0 csn cdif com c0 csn cdif cuni wpss
      com c0 csn cdif com wpss c0 c0 csn wcel com c0 csn cdif com wpss c0 0ex
      snid com c0 csn cdif com wpss c0 c0 csn wcel com c0 csn cdif com wpss wn
      com com c0 csn cdif wceq c0 c0 csn wcel wn com c0 csn cdif com wpss wn
      com c0 csn cin c0 wceq com com c0 csn cdif wceq com c0 csn disj4 com c0
      csn disj3 bitr3i com com c0 csn cdif wceq c0 com wcel c0 c0 csn wcel wn
      com com c0 csn cdif wceq c0 com c0 csn cdif wcel c0 com wcel c0 c0 csn
      wcel wn wa com com c0 csn cdif wceq c0 com wcel c0 com c0 csn cdif wcel
      peano1 com com c0 csn cdif c0 eleq2 mpbii c0 com c0 csn eldif sylib
      pm3.27d sylbi con4i ax-mp com c0 csn cdif cuni com com c0 csn cdif com c0
      csn cdif cuni com cuni com com unidif0 com wlim com com cuni wceq limom
      com limuni ax-mp eqtr4i psseq2i mpbir vx cv vx cv cuni wpss com c0 csn
      cdif com c0 csn cdif cuni wpss vx com c0 csn cdif cvv vx cv com c0 csn
      cdif wceq vx cv vx cv cuni wpss com c0 csn cdif vx cv cuni wpss com c0
      csn cdif com c0 csn cdif cuni wpss vx cv com c0 csn cdif vx cv cuni
      psseq1 vx cv com c0 csn cdif wceq vx cv cuni com c0 csn cdif cuni com c0
      csn cdif vx cv com c0 csn cdif unieq psseq2d bitrd cla4egv mpi syl impbii
      $.
      $( [24-Mar-2004] $) $( [23-Mar-2004] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Infinity
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Introduce the Axiom of Infinity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
         +-------------------------------------------------+
         |         "Cantor's Paradise" begins here!        |
         | (i.e. we start to assume the Axiom of Infinity) |
         +-------------------------------------------------+
$)

  ${
    $d x y z w $.
    $( Axiom of Infinity.  An axiom of Zermelo-Fraenkel set theory.  This axiom
       is the gateway to "Cantor's paradise" (an expression coined by Hilbert).
       It asserts that given a starting set ` x ` , an infinite set ` y ` built
       from it exists.  Although our version is apparently not given in the
       literature, it is similar to, but slightly shorter than, the Axiom of
       Infinity in [FreydScedrov] p. 283 (see ~ inf1 and ~ inf2 ).  More
       standard versions, which essentially state that there exists a set
       containing all the natural numbers, are shown as ~ zfinf2 and ~ omex and
       are based on the (nontrivial) proof of ~ inf3 .  Our version has the
       advantage that when expanded to primitives, it has fewer symbols than
       the standard version ~ ax-inf2 .  Theorem ~ inf0 shows the reverse
       derivation of our axiom from a standard one.  Theorem ~ inf5 shows a
       very short way to state this axiom.

       An interesting property of our version is that, unlike the standard
       version, it does not assert the independent existence of any set; it
       needs a starting set ` x ` .  Since none of our other ZFC axioms assert
       the independent existence of any set, we would need to add an axiom of
       existence such as Axiom 0 of [Kunen] p. 10 if we were to use a "free
       logic" predicate calculus that (unlike ours) does not assert (as we do
       with ~ ax-4 and ~ ax-9 ) that at least one thing exists.

       The standard version of Infinity ~ ax-inf2 requires this axiom along
       with Regularity ~ ax-reg for its derivation (as theorem ~ axinf2
       below).  In order to more easily identify the normal uses of Regularity,
       we will usually reference ~ ax-inf2 instead of this one.  The derivation
       of this axiom from ~ ax-inf2 is shown by theorem ~ axinf . $)
    ax-inf $a |- E. y ( x e. y /\
                 A. z ( z e. y -> E. w ( z e. w /\ w e. y ) ) ) $.

    $( Axiom of Infinity expressed with fewest number of different
       variables. $)
    zfinf $p |- E. x ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) $=
      vy cv vx cv wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vw wal wa vx wex vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv
      wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex vy vx vw vz ax-inf vy
      cv vx cv wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vw wal wa vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv
      vx cv wcel wa vz wex wi vy wal wa vx vw cv vx cv wcel vw cv vz cv wcel vz
      cv vx cv wcel wa vz wex wi vw wal vy cv vx cv wcel vy cv vz cv wcel vz cv
      vx cv wcel wa vz wex wi vy wal vy cv vx cv wcel vw cv vx cv wcel vw cv vz
      cv wcel vz cv vx cv wcel wa vz wex wi vy cv vx cv wcel vy cv vz cv wcel
      vz cv vx cv wcel wa vz wex wi vw vy vw cv vy cv wceq vw cv vx cv wcel vy
      cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex vy cv vz cv
      wcel vz cv vx cv wcel wa vz wex vw vy vx elequ1 vw cv vy cv wceq vw cv vz
      cv wcel vz cv vx cv wcel wa vy cv vz cv wcel vz cv vx cv wcel wa vz vw cv
      vy cv wceq vw cv vz cv wcel vy cv vz cv wcel vz cv vx cv wcel vw vy vz
      elequ1 anbi1d exbidv imbi12d cbvalv anbi2i exbii mpbi $.
      $( [14-Aug-2003] $)

    $( A standard version of Axiom of Infinity, expanded to primitives, derived
       from our version of Infinity ~ ax-inf and Regularity ~ ax-reg .

       This theorem should not be referenced in any proof.  Instead, use
       ~ ax-inf2 below so that the ordinary uses of Regularity can be more
       easily identified. $)
    axinf2 $p |- E. x ( E. y ( y e. x /\ A. z -. z e. y ) /\ A. y ( y e. x ->
          E. z ( z e. x /\ A. w ( w e. z <-> ( w e. y \/ w = y ) ) ) ) ) $=
      c0 vx cv wcel vy cv vx cv wcel vy cv csuc vx cv wcel wi vy wal wa vx wex
      vy cv vx cv wcel vz cv vy cv wcel wn vz wal wa vy wex vy cv vx cv wcel vz
      cv vx cv wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw
      wal wa vz wex wi vy wal wa vx wex c0 com wcel vy cv com wcel vy cv csuc
      com wcel wi vy wal c0 vx cv wcel vy cv vx cv wcel vy cv csuc vx cv wcel
      wi vy wal wa vx wex peano1 vy cv com wcel vy cv csuc com wcel wi vy vy cv
      peano2 ax-gen c0 vx cv wcel vy cv vx cv wcel vy cv csuc vx cv wcel wi vy
      wal wa c0 com wcel vy cv com wcel vy cv csuc com wcel wi vy wal wa vx com
      vx vx vy vz vx vy vz zfinf inf2 inf3 vx cv com wceq c0 vx cv wcel c0 com
      wcel vy cv vx cv wcel vy cv csuc vx cv wcel wi vy wal vy cv com wcel vy
      cv csuc com wcel wi vy wal vx cv com c0 eleq2 vx cv com wceq vy cv vx cv
      wcel vy cv csuc vx cv wcel wi vy cv com wcel vy cv csuc com wcel wi vy vx
      cv com wceq vy cv vx cv wcel vy cv com wcel vy cv csuc vx cv wcel vy cv
      csuc com wcel vx cv com vy cv eleq2 vx cv com vy cv csuc eleq2 imbi12d
      albidv anbi12d cla4ev mp2an c0 vx cv wcel vy cv vx cv wcel vy cv csuc vx
      cv wcel wi vy wal wa vy cv vx cv wcel vz cv vy cv wcel wn vz wal wa vy
      wex vy cv vx cv wcel vz cv vx cv wcel vw cv vz cv wcel vw cv vy cv wcel
      vw cv vy cv wceq wo wb vw wal wa vz wex wi vy wal wa vx c0 vx cv wcel vy
      cv vx cv wcel vz cv vy cv wcel wn vz wal wa vy wex vy cv vx cv wcel vy cv
      csuc vx cv wcel wi vy wal vy cv vx cv wcel vz cv vx cv wcel vw cv vz cv
      wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa vz wex wi vy wal
      c0 vx cv wcel vz cv vy cv wcel wn vz wal vy vx cv wrex vy cv vx cv wcel
      vz cv vy cv wcel wn vz wal wa vy wex vy vz vx cv 0el vz cv vy cv wcel wn
      vz wal vy vx cv df-rex bitri vy cv vx cv wcel vy cv csuc vx cv wcel wi vy
      cv vx cv wcel vz cv vx cv wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy
      cv wceq wo wb vw wal wa vz wex wi vy vy cv csuc vx cv wcel vz cv vx cv
      wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa
      vz wex vy cv vx cv wcel vy cv csuc vx cv wcel vw cv vz cv wcel vw cv vy
      cv wcel vw cv vy cv wceq wo wb vw wal vz vx cv wrex vz cv vx cv wcel vw
      cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa vz wex vz
      vw vy cv vx cv sucel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq
      wo wb vw wal vz vx cv df-rex bitri imbi2i albii anbi12i exbii mpbi $.
      $( [6-May-2008] $) $( [3-Nov-1996] $)

    $( A standard version of Axiom of Infinity of ZF set theory.  In English,
       it says:  there exists a set that contains the empty set and the
       successors of all of its members.  Theorem ~ zfinf2 shows it converted
       to abbreviations.  This axiom was derived as theorem ~ axinf2 above,
       using our version of Infinity ~ ax-inf and the Axiom of Regularity
       ~ ax-reg .  We will reference ~ ax-inf2 instead of ~ axinf2 so that the
       ordinary uses of Regularity can be more easily identified.  The reverse
       derivation of ~ ax-inf from ~ ax-inf2 is shown by theorem ~ axinf . $)
    ax-inf2 $a |- E. x ( E. y ( y e. x /\ A. z -. z e. y ) /\ A. y ( y e. x ->
          E. z ( z e. x /\ A. w ( w e. z <-> ( w e. y \/ w = y ) ) ) ) ) $.
  $}

  ${
    $d x y z w $.
    $( A standard version of the Axiom of Infinity, using definitions to
       abbreviate.  Axiom Inf of [BellMachover] p. 472.  (See ~ ax-inf2 for the
       unabbreviated version.) $)
    zfinf2 $p |- E. x ( (/) e. x /\ A. y e. x suc y e. x ) $=
      c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vx wex vy cv vx cv
      wcel vz cv vy cv wcel wn vz wal wa vy wex vy cv vx cv wcel vz cv vx cv
      wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa
      vz wex wi vy wal wa vx wex vx vy vz vw ax-inf2 c0 vx cv wcel vy cv csuc
      vx cv wcel vy vx cv wral wa vy cv vx cv wcel vz cv vy cv wcel wn vz wal
      wa vy wex vy cv vx cv wcel vz cv vx cv wcel vw cv vz cv wcel vw cv vy cv
      wcel vw cv vy cv wceq wo wb vw wal wa vz wex wi vy wal wa vx c0 vx cv
      wcel vy cv vx cv wcel vz cv vy cv wcel wn vz wal wa vy wex vy cv csuc vx
      cv wcel vy vx cv wral vy cv vx cv wcel vz cv vx cv wcel vw cv vz cv wcel
      vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa vz wex wi vy wal c0 vx
      cv wcel vz cv vy cv wcel wn vz wal vy vx cv wrex vy cv vx cv wcel vz cv
      vy cv wcel wn vz wal wa vy wex vy vz vx cv 0el vz cv vy cv wcel wn vz wal
      vy vx cv df-rex bitri vy cv csuc vx cv wcel vy vx cv wral vz cv vx cv
      wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa
      vz wex vy vx cv wral vy cv vx cv wcel vz cv vx cv wcel vw cv vz cv wcel
      vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa vz wex wi vy wal vy cv
      csuc vx cv wcel vz cv vx cv wcel vw cv vz cv wcel vw cv vy cv wcel vw cv
      vy cv wceq wo wb vw wal wa vz wex vy vx cv vy cv csuc vx cv wcel vw cv vz
      cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal vz vx cv wrex vz
      cv vx cv wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw
      wal wa vz wex vz vw vy cv vx cv sucel vw cv vz cv wcel vw cv vy cv wcel
      vw cv vy cv wceq wo wb vw wal vz vx cv df-rex bitri ralbii vz cv vx cv
      wcel vw cv vz cv wcel vw cv vy cv wcel vw cv vy cv wceq wo wb vw wal wa
      vz wex vy vx cv df-ral bitri anbi12i exbii mpbir $.
      $( [4-Mar-2004] $) $( [30-Aug-1993] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Existence of omega (the set of natural numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The existence of omega (the class of natural numbers).  Axiom 7 of
       [TakeutiZaring] p. 43.  This theorem is proved assuming the Axiom of
       Infinity and in fact is equivalent to it, as shown by the reverse
       derivation ~ inf0 .

       A finitist (someone who doesn't believe in infinity) could, without
       contradiction, replace the Axiom of Infinity by its denial
       ` -. om e. _V ` ; this would lead to ` om = On ` (the proper class of
       ordinals) by ~ omon and ~ onprc .  The finitist could still develop
       natural number, integer, and rational number arithmetic but would be
       denied the real numbers (as well as much of the rest of mathematics).
       In deference to the finitist, much of our development is done, when
       possible, without invoking the Axiom of Infinity; an example is Peano's
       axioms ~ peano1 through ~ peano5 (which many textbooks prove more easily
       assuming Infinity). $)
    omex $p |- om e. _V $=
      com vx cv wss vx wex com cvv wcel c0 vx cv wcel vy cv csuc vx cv wcel vy
      vx cv wral wa vx wex com vx cv wss vx wex vx vy zfinf2 c0 vx cv wcel vy
      cv csuc vx cv wcel vy vx cv wral wa com vx cv wss vx c0 vx cv wcel vy cv
      vx cv wcel vy cv csuc vx cv wcel wi vy com wral com vx cv wss vy cv csuc
      vx cv wcel vy vx cv wral vy vx cv peano5 vy cv csuc vx cv wcel vy cv vx
      cv wcel vy cv csuc vx cv wcel wi vy vx cv com vy cv vx cv wcel vy cv csuc
      vx cv wcel wi vy cv com wcel ax-1 r19.20i2 sylan2 19.22i ax-mp com vx cv
      wss com cvv wcel vx com vx cv vx visset ssex 19.23aiv ax-mp $.
      $( [6-Aug-1994] $)
  $}

  ${
    $d x y z w $.
    $( The first version of the Axiom of Infinity ~ ax-inf proved from the
       second version ~ ax-inf2 . $)
    axinf $p |- E. y ( x e. y /\
                 A. z ( z e. y -> E. w ( z e. w /\ w e. y ) ) ) $=
      vx vy vz vw omex inf0 $.
      $( [24-Apr-2009] $) $( [24-Apr-2009] $)
  $}

  ${
    $d x y z w $.
    $( The statement "there exists a set that is a proper subset of its
       union" is equivalent to the Axiom of Infinity (see theorem ~ infeq5 ).
       This provides us with a very compact way to express of the Axiom of
       Infinity using only elementary symbols. $)
    inf5 $p |- E. x x C. U. x $=
      vx cv vx cv cuni wpss vx wex com cvv wcel omex vx infeq5 mpbir $.
      $( [4-Jun-2005] $) $( [3-Jun-2005] $)
  $}

  $( Omega is an ordinal number. $)
  omelon $p |- om e. On $=
    com con0 wcel com con0 wceq com con0 wceq com cvv wcel omex com con0 wceq
    com cvv wcel con0 cvv wcel onprc com con0 cvv eleq1 mtbiri mt2 com con0
    wcel com con0 wceq omon ori mt3 $.
    $( [10-May-1998] $)

  ${
    $d x y z $.
    $( The class of natural numbers omega can be defined as the smallest
       "inductive set," which is valid provided we assume the Axiom of
       Infinity.  Definition 6.3 of [Eisenberg] p. 82. $)
    dfom3 $p |- om = |^| { x | ( (/) e. x /\ A. y e. x suc y e. x ) } $=
      com c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab cint c0
      c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab cint wcel vz
      cv c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab cint wcel
      vz cv csuc c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab
      cint wcel wi vz com wral com c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv
      wral wa vx cab cint wss c0 c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv
      wral wa vx cab cint wcel c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv
      wral wa c0 vx cv wcel wi vx c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv
      wral wa vx c0 0ex elintab c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv
      wral pm3.26 mpgbir vz cv c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv
      wral wa vx cab cint wcel vz cv csuc c0 vx cv wcel vy cv csuc vx cv wcel
      vy vx cv wral wa vx cab cint wcel wi vz com vz cv c0 vx cv wcel vy cv
      csuc vx cv wcel vy vx cv wral wa vx cab cint wcel vz cv csuc c0 vx cv
      wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab cint wcel wi vz cv com
      wcel c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vz cv vx cv
      wcel wi vx wal c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vz cv
      csuc vx cv wcel wi vx wal vz cv c0 vx cv wcel vy cv csuc vx cv wcel vy vx
      cv wral wa vx cab cint wcel vz cv csuc c0 vx cv wcel vy cv csuc vx cv
      wcel vy vx cv wral wa vx cab cint wcel c0 vx cv wcel vy cv csuc vx cv
      wcel vy vx cv wral wa vz cv vx cv wcel wi c0 vx cv wcel vy cv csuc vx cv
      wcel vy vx cv wral wa vz cv csuc vx cv wcel wi vx c0 vx cv wcel vy cv
      csuc vx cv wcel vy vx cv wral wa vz cv vx cv wcel vz cv csuc vx cv wcel
      vy cv csuc vx cv wcel vy vx cv wral vz cv vx cv wcel vz cv csuc vx cv
      wcel wi c0 vx cv wcel vy cv csuc vx cv wcel vz cv csuc vx cv wcel vy vz
      cv vx cv vy cv vz cv wceq vy cv csuc vz cv csuc vx cv vy cv vz cv suceq
      eleq1d rcla4cv adantl a2i 19.20i c0 vx cv wcel vy cv csuc vx cv wcel vy
      vx cv wral wa vx vz cv vz visset elintab c0 vx cv wcel vy cv csuc vx cv
      wcel vy vx cv wral wa vx vz cv csuc vz cv vz visset sucex elintab 3imtr4i
      a1i rgen vz c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab
      cint peano5 mp2an vz c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa
      vx cab cint com vz cv c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral
      wa vx cab cint wcel c0 com wcel vy cv csuc com wcel vy com wral vz cv com
      wcel peano1 vy cv csuc com wcel vy com vy cv peano2 rgen vz cv c0 vx cv
      wcel vy cv csuc vx cv wcel vy vx cv wral wa vx cab cint wcel c0 vx cv
      wcel vy cv csuc vx cv wcel vy vx cv wral wa vz cv vx cv wcel wi vx wal c0
      com wcel vy cv csuc com wcel vy com wral wa vz cv com wcel wi c0 vx cv
      wcel vy cv csuc vx cv wcel vy vx cv wral wa vx vz cv vz visset elintab c0
      vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa vz cv vx cv wcel wi c0
      com wcel vy cv csuc com wcel vy com wral wa vz cv com wcel wi vx com omex
      vx cv com wceq c0 vx cv wcel vy cv csuc vx cv wcel vy vx cv wral wa c0
      com wcel vy cv csuc com wcel vy com wral wa vz cv vx cv wcel vz cv com
      wcel vx cv com wceq c0 vx cv wcel c0 com wcel vy cv csuc vx cv wcel vy vx
      cv wral vy cv csuc com wcel vy com wral vx cv com c0 eleq2 vy cv csuc vx
      cv wcel vy cv csuc com wcel vy vx cv com vx cv com vy cv csuc eleq2
      raleqd anbi12d vx cv com vz cv eleq2 imbi12d cla4v sylbi mp2ani ssriv
      eqssi $.
      $( [27-Jun-2004] $) $( [6-Aug-1994] $)
  $}

  ${
    $d A x $.
    $( A simplification of ~ elom assuming the Axiom of Infinity. $)
    elom3 $p |- ( A e. om <-> A. x ( Lim x -> A e. x ) ) $=
      cA com wcel vx cv wlim cA vx cv wcel wi vx wal cA com wcel cA word vx cv
      wlim cA vx cv wcel wi vx wal cA com wcel cA word vx cv wlim cA vx cv wcel
      wi vx wal wa vx cA com elomg ibi pm3.27d vx cv wlim cA vx cv wcel wi vx
      wal com wlim cA com wcel limom vx cv wlim cA vx cv wcel wi com wlim cA
      com wcel wi vx com omex vx cv com wceq vx cv wlim com wlim cA vx cv wcel
      cA com wcel vx cv com limeq vx cv com cA eleq2 imbi12d cla4v mpi impbii
      $.
      $( [30-May-2003] $)
  $}

  ${
    $d x y $.
    $( A simplification of ~ df-om assuming the Axiom of Infinity. $)
    dfom4 $p |- om = { x | A. y ( Lim y -> x e. y ) } $=
      vy cv wlim vx cv vy cv wcel wi vy wal vx com vy vx cv elom3 abbi2i $.
      $( [30-May-2003] $)
  $}

  $( Ordinal addition is not commutative.  This theorem shows a counterexample.
     Remark in [TakeutiZaring] p. 60. $)
  oancom $p |- ( 1o +o om ) =/= ( om +o 1o ) $=
    c1o com coa co com c1o coa co wcel c1o com coa co com c1o coa co wne c1o
    com coa co com com c1o coa co com con0 wcel c1o com wcel c1o com coa co com
    wceq omelon 1onn c1o oaabslem mp2an com com csuc com c1o coa co com omex
    sucid com con0 wcel com c1o coa co com csuc wceq omelon com oa1suc ax-mp
    eleqtrri eqeltri c1o com coa co com c1o coa co wcel c1o com coa co com c1o
    coa co wss c1o com coa co com c1o coa co wne c1o com coa co con0 wcel com
    c1o coa co con0 wcel c1o com coa co com c1o coa co wcel c1o com coa co com
    c1o coa co wss c1o com coa co com c1o coa co wne wa wb c1o con0 wcel com
    con0 wcel c1o com coa co con0 wcel 1on omelon c1o com oacl mp2an com con0
    wcel c1o con0 wcel com c1o coa co con0 wcel omelon 1on com c1o oacl mp2an
    c1o com coa co com c1o coa co onelpss mp2an pm3.27bi ax-mp $.
    $( [4-Mar-2005] $) $( [10-Dec-2004] $)

  $( A set is strictly dominated by the class of natural numbers iff it is
     finite.  Theorem 42 of [Suppes] p. 151.  This theorem provides two
     equivalent ways to express " ` A ` is finite."  The Axiom of Infinity is
     used for the reverse implication. $)
  isfinite $p |- ( A ~< om <-> A e. Fin ) $=
    cA com csdm wbr cA cfn wcel cA isfinite2 cA cfn wcel cA com cdom wbr com cA
    cen wbr wn wa cA com csdm wbr cA isfinite1 cA com cdom wbr com cA cen wbr
    wn wa cA com cdom wbr cA com cen wbr wn wa cA com csdm wbr com cA cen wbr
    wn cA com cen wbr wn cA com cdom wbr cA com cen wbr com cA cen wbr cA com
    omex ensym con3i anim2i cA com brsdom sylibr syl impbii $.
    $( [22-Sep-2008] $) $( [24-Apr-2004] $)

  $( A natural number is strictly dominated by the set of natural numbers. $)
  nnsdom $p |- ( A e. om -> A ~< om ) $=
    cA com wcel cA com cdom wbr cA com cen wbr wn wa cA com csdm wbr cA com
    wcel cA com cdom wbr com cA cen wbr wn wa cA com cdom wbr cA com cen wbr wn
    wa cA omsdomnn com cA cen wbr wn cA com cen wbr wn cA com cdom wbr cA com
    cen wbr com cA cen wbr cA com omex ensym con3i anim2i syl cA com brsdom
    sylibr $.
    $( [13-Nov-2003] $) $( [28-Oct-2003] $)

  ${
    $d x y $.
    $( Omega is equinumerous to a proper subset of itself.  Example 13.2(4) of
       [Eisenberg] p. 216. $)
    omenps $p |- om ~~ ( om \ { (/) } ) $=
      com cvv wcel com com c0 csn cdif cen wbr omex com cvv limom limenpsi
      ax-mp $.
      $( [30-Jul-2003] $)
  $}

  $( The set of natural numbers is equinumerous to its successor. $)
  omensuc $p |- om ~~ suc om $=
    com cvv wcel com com csuc cen wbr omex com cvv limom limensuci ax-mp $.
    $( [18-Nov-2003] $) $( [30-Oct-2003] $)

  ${
    $d x y A $.
    $( Any infinite ordinal is equinumerous to its successor.  Exercise 7 of
       [TakeutiZaring] p. 88. $)
    infensuc $p |- ( ( A e. On /\ om C_ A ) -> A ~~ suc A ) $=
      cA con0 wcel com con0 wcel com cA wss cA cA csuc cen wbr omelon vx cv vx
      cv csuc cen wbr com com csuc cen wbr vy cv vy cv csuc cen wbr vy cv csuc
      vy cv csuc csuc cen wbr cA cA csuc cen wbr vx vy cA com vx cv com wceq vx
      cv com vx cv csuc com csuc cen vx cv com wceq id vx cv com suceq breq12d
      vx cv vy cv wceq vx cv vy cv vx cv csuc vy cv csuc cen vx cv vy cv wceq
      id vx cv vy cv suceq breq12d vx cv vy cv csuc wceq vx cv vy cv csuc vx cv
      csuc vy cv csuc csuc cen vx cv vy cv csuc wceq id vx cv vy cv csuc suceq
      breq12d vx cv cA wceq vx cv cA vx cv csuc cA csuc cen vx cv cA wceq id vx
      cv cA suceq breq12d com com csuc cen wbr com con0 wcel omensuc a1i vy cv
      con0 wcel vy cv vy cv csuc cen wbr vy cv csuc vy cv csuc csuc cen wbr wi
      com con0 wcel com vy cv wss vy cv vy cv csuc cen wbr vy cv con0 wcel vy
      cv csuc vy cv csuc csuc cen wbr vy cv vy cv csuc cen wbr vy cv csn vy cv
      csuc csn cen wbr vy cv con0 wcel vy cv csuc vy cv csuc csuc cen wbr wi vy
      cv cvv wcel vy cv csuc cvv wcel vy cv csn vy cv csuc csn cen wbr vy
      visset vy cv vy visset sucex vy cv vy cv csuc cvv cvv en2sn mp2an vy cv
      vy cv csuc cen wbr vy cv csn vy cv csuc csn cen wbr wa vy cv vy cv csn
      cin c0 wceq vy cv csuc vy cv csuc csn cin c0 wceq wa vy cv csuc vy cv
      csuc csuc cen wbr vy cv con0 wcel vy cv vy cv csuc cen wbr vy cv csn vy
      cv csuc csn cen wbr wa vy cv vy cv csn cin c0 wceq vy cv csuc vy cv csuc
      csn cin c0 wceq wa vy cv csuc vy cv csuc csuc cen wbr vy cv vy cv csuc
      cen wbr vy cv csn vy cv csuc csn cen wbr wa vy cv vy cv csn cin c0 wceq
      vy cv csuc vy cv csuc csn cin c0 wceq wa wa vy cv vy cv csn cun vy cv
      csuc vy cv csuc csn cun vy cv csuc vy cv csuc csuc cen vy cv vy cv csuc
      vy cv csn vy cv csuc csn unen vy cv df-suc vy cv csuc df-suc 3brtr4g ex
      vy cv con0 wcel vy cv vy cv csn cin c0 wceq vy cv csuc vy cv csuc csn cin
      c0 wceq vy cv con0 wcel vy cv vy cv wcel wn vy cv vy cv csn cin c0 wceq
      vy cv con0 wcel vy cv word vy cv vy cv wcel wn vy cv eloni vy cv ordirr
      syl vy cv vy cv disjsn sylibr vy cv csuc con0 wcel vy cv csuc vy cv csuc
      wcel wn vy cv con0 wcel vy cv csuc vy cv csuc csn cin c0 wceq vy cv csuc
      con0 wcel vy cv csuc word vy cv csuc vy cv csuc wcel wn vy cv csuc eloni
      vy cv csuc ordirr syl vy cv sucelon vy cv csuc vy cv csuc disjsn 3imtr4i
      jca syl5 mpan2 com12 ad2antrr vx cv wlim com con0 wcel wa com vx cv wss
      wa vx cv vx cv csuc cen wbr com vy cv wss vy cv vy cv csuc cen wbr wi vy
      vx cv wral vx cv wlim vx cv vx cv csuc cen wbr com con0 wcel com vx cv
      wss vx cv cvv wcel vx cv wlim vx cv vx cv csuc cen wbr vx visset vx cv
      cvv limensuc mpan ad2antrr a1d tfindsg mpanl2 $.
      $( [19-Nov-2003] $) $( [30-Oct-2003] $)
  $}


  ${
    $d x y z A $.
    $( Any unbounded subset of natural numbers is equinumerous to the set of
       all natural numbers.  This version of ~ unbnn eliminates its hypothesis
       by assuming the Axiom of Infinity. $)
    unbnn3 $p |- ( ( A C_ om /\ A. x e. om E. y e. A x e. y ) -> A ~~ om ) $=
      cA com wss vx cv vy cv wcel vy cA wrex vx com wral cA com cen wbr cA cvv
      wcel cA com wss vx cv vy cv wcel vy cA wrex vx com wral cA com cen wbr wi
      cA com omex ssex cA cvv wcel cA com wss vx cv vy cv wcel vy cA wrex vx
      com wral cA com cen wbr vz cv com wss vx cv vy cv wcel vy vz cv wrex vx
      com wral wa vz cv com cen wbr wi cA com wss vx cv vy cv wcel vy cA wrex
      vx com wral wa cA com cen wbr wi vz cA cvv vz cv cA wceq vz cv com wss vx
      cv vy cv wcel vy vz cv wrex vx com wral wa cA com wss vx cv vy cv wcel vy
      cA wrex vx com wral wa vz cv com cen wbr cA com cen wbr vz cv cA wceq vz
      cv com wss cA com wss vx cv vy cv wcel vy vz cv wrex vx com wral vx cv vy
      cv wcel vy cA wrex vx com wral vz cv cA com sseq1 vz cv cA wceq vx cv vy
      cv wcel vy vz cv wrex vx cv vy cv wcel vy cA wrex vx com vx cv vy cv wcel
      vy vz cv cA rexeq1 ralbidv anbi12d vz cv cA com cen breq1 imbi12d vx vy
      vz cv vz visset unbnn vtoclg exp3a mpcom imp $.
      $( [6-May-2005] $) $( [4-May-2005] $)
  $}

  ${
    $d x y z F $.
    $( Using the Axiom of Regularity in the form ~ zfregfr , show that there
       are no infinite descending ` e. ` -chains.  Proposition 7.34 of
       [TakeutiZaring] p. 44. $)
    noinfep $p |- ( F Fn om -> E. x e. om -. ( F ` suc x ) e. ( F ` x ) ) $=
      cF com wfn vz cv vy cv cep wbr wn vz cF crn wral vy cF crn wrex vx cv
      csuc cF cfv vx cv cF cfv wcel wn vx com wrex cF crn cvv wcel cF crn c0
      wne vz cv vy cv cep wbr wn vz cF crn wral vy cF crn wrex cF com wfn cF
      crn cvv wcel cF crn cep wfr cF crn c0 wne vz cv vy cv cep wbr wn vz cF
      crn wral vy cF crn wrex cF crn zfregfr cF crn cvv wcel cF crn cep wfr wa
      cF crn cF crn wss cF crn c0 wne vz cv vy cv cep wbr wn vz cF crn wral vy
      cF crn wrex cF crn ssid vy vz cF crn cF crn cvv cep fri mpanr1 mpanl2 cF
      cdm cvv wcel cF wfun cF crn cvv wcel cF com wfn cvv cF funrnex cF com wfn
      cF cdm com cvv com cF fndm omex syl6eqel com cF fnfun sylc cF com wfn cF
      cdm com wceq cF crn c0 wne com cF fndm cF cdm com wceq cF cdm c0 wne cF
      crn c0 wne cF cdm com wceq c0 cF cdm wcel cF cdm c0 wne cF cdm com wceq
      c0 cF cdm wcel c0 com wcel peano1 cF cdm com c0 eleq2 mpbiri cF cdm c0
      ne0i syl cF cdm c0 cF crn c0 cF dm0rn0 necon3bii sylib syl sylanc cF com
      wfn vz cv vy cv cep wbr wn vz cF crn wral vx cv csuc cF cfv vx cv cF cfv
      wcel wn vx com wrex vy cF crn cF com wfn vz cv vy cv cep wbr wn vz cF crn
      wral vy cv cF crn wcel vx cv csuc cF cfv vx cv cF cfv wcel wn vx com wrex
      cF com wfn vz cv vy cv cep wbr wn vz cF crn wral vy cv cF crn wcel vx cv
      csuc cF cfv vx cv cF cfv wcel wn vx com wrex wi cF com wfn vz cv vy cv
      cep wbr wn vz cF crn wral wa vy cv cF crn wcel vx cv cF cfv vy cv wceq vx
      com wrex vx cv csuc cF cfv vx cv cF cfv wcel wn vx com wrex cF com wfn vy
      cv cF crn wcel vx cv cF cfv vy cv wceq vx com wrex wb vz cv vy cv cep wbr
      wn vz cF crn wral vx com vy cv cF fvelrnb adantr cF com wfn vz cv vy cv
      cep wbr wn vz cF crn wral wa vx cv cF cfv vy cv wceq vx cv csuc cF cfv vx
      cv cF cfv wcel wn vx com vx cv cF cfv vy cv wceq cF com wfn vz cv vy cv
      cep wbr wn vz cF crn wral wa vx cv com wcel wa vx cv csuc cF cfv vx cv cF
      cfv wcel wn vx cv cF cfv vy cv wceq cF com wfn vz cv vy cv cep wbr wn vz
      cF crn wral wa vx cv csuc com wcel vx cv csuc cF cfv vx cv cF cfv wcel wn
      vx cv com wcel vx cv cF cfv vy cv wceq vx cv csuc cF cfv cF crn wcel vz
      cv vy cv cep wbr wn vz cF crn wral wa vx cv csuc cF cfv vx cv cF cfv wcel
      wn cF com wfn vz cv vy cv cep wbr wn vz cF crn wral wa vx cv csuc com
      wcel wa vx cv cF cfv vy cv wceq vx cv csuc cF cfv vx cv cF cfv wcel wn vx
      cv csuc cF cfv vy cv wcel wn vx cv csuc cF cfv cF crn wcel vz cv vy cv
      cep wbr wn vz cF crn wral wa vx cv cF cfv vy cv wceq vx cv csuc cF cfv vx
      cv cF cfv wcel vx cv csuc cF cfv vy cv wcel vx cv cF cfv vy cv vx cv csuc
      cF cfv eleq2 notbid vz cv vy cv cep wbr wn vx cv csuc cF cfv vy cv wcel
      wn vz vx cv csuc cF cfv cF crn vz cv vx cv csuc cF cfv wceq vz cv vy cv
      cep wbr vx cv csuc cF cfv vy cv wcel vz cv vx cv csuc cF cfv wceq vz cv
      vy cv wcel vx cv csuc cF cfv vy cv wcel vz cv vy cv cep wbr vz cv vx cv
      csuc cF cfv vy cv eleq1 vz vy epel syl5bb notbid rcla4va syl5bir cF com
      wfn vz cv vy cv cep wbr wn vz cF crn wral wa vx cv csuc com wcel wa vx cv
      csuc cF cfv cF crn wcel vz cv vy cv cep wbr wn vz cF crn wral cF com wfn
      vx cv csuc com wcel vx cv csuc cF cfv cF crn wcel vz cv vy cv cep wbr wn
      vz cF crn wral com vx cv csuc cF fnfvelrn adantlr cF com wfn vz cv vy cv
      cep wbr wn vz cF crn wral vx cv csuc com wcel simplr jca syl5 vx cv
      peano2 sylan2i com12 r19.22dva sylbid ex com23 r19.23adv mpd $.
      $( [27-Jan-2006] $) $( [26-Jan-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Rank
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c R1 $. $( Cumulative hierarchy of sets function $)
  $c rank $. $( Rank function $)

  $( Extend class definition to include the cumulative hierarchy of sets
     function. $)
  cr1 $a class R1 $.

  $( Extend class definition to include rank function. $)
  crnk $a class rank $.

  ${
    $d x y z $.
    $( Define the cumulative hierarchy of sets function, using Takeuti and
       Zaring's notation ( ` R1 ` ).  Starting with the empty set, this
       function builds up layers of sets where the next layer is the power
       set of the previous layer (and the union of previous layers when the
       argument is a limit ordinal).  Using the Axiom of Regularity, we can
       show that any set whatsoever belongs to one of the layers of this
       hierarchy (see ~ tz9.13 ).  Our definition expresses Definition 9.9
       of [TakeutiZaring] p. 76 in a closed form, from which we derive the
       recursive definition as theorems ~ r10 , ~ r1suc , and ~ r1lim .
       Theorem ~ r1val1 shows a recursive definition that works for all values,
       and theorems ~ r1val2 and ~ r1val3 show the value expressed in terms of
       rank.  Other notations for this function are  _R_ with the argument
       as a subscript (Equation 3.1 of [BellMachover] p. 477), ` _V ` with a
       a subscript (Definition of [Enderton] p. 202), _M_ with a subscript
       (Definition 15.19 of [Monk1] p. 113), the capital Greek letter psi
       (Definition of [Mendelson] p. 281), and bold-face R (Definition 2.1
       of [Kunen] p. 95). $)
    df-r1 $a |- R1 = rec ( { <. x , y >. | y = ~P x } , (/) ) $.

    $( Define the rank function.  See ~ rankval , ~ rankval2 , ~ rankval3 ,
       or ~ rankval4 its value.  The rank is a kind of "inverse" of the
       cumulative hierarchy of sets function ` R1 ` :  given a set, it returns
       an ordinal number telling us the smallest layer of the hierarchy to
       which the set belongs.  Based on Definition 9.14 of [TakeutiZaring]
       p. 79.  Theorem ~ rankid illustrates the "inverse" concept.  Another
       nice theorem showing the relationship is ~ rankr1a . $)
    df-rank $a |- rank =
          { <. x , y >. | y = |^| { z e. On | x e. ( R1 ` suc z ) } } $.
  $}

  ${
    $d x y z w v u $.  $d y z v A $.  $d y v u F $.
    trcl.1 $e |- A e. _V $.
    trcl.2 $e |- F =
               ( rec ( { <. z , w >. | w = ( z u. U. z ) } , A ) |` om ) $.
    trcl.3 $e |- C = U_ y e. om ( F ` y ) $.
    $( For any set ` A ` , show the properties of its transitive closure
       ` C ` .  Similar to Theorem 9.1 of [TakeutiZaring] p. 73 except that we
       show an explicit expression for the transitive closure rather than just
       its existence.  See ~ tz9.1 for an abbreviated version showing
       existence. $)
    trcl $p |- ( A C_ C /\ Tr C /\ A. x ( ( A C_ x /\ Tr x ) -> C C_ x ) ) $=
      cA cC wss cC wtr cA vx cv wss vx cv wtr wa cC vx cv wss wi vx wal cA vy
      com vy cv cF cfv ciun cC cA vy cv cF cfv wss vy com wrex cA vy com vy cv
      cF cfv ciun wss c0 com wcel cA c0 cF cfv wss cA vy cv cF cfv wss vy com
      wrex peano1 cA c0 cF cfv c0 cF cfv c0 vw cv vz cv vz cv cuni cun wceq vz
      vw copab cA crdg com cres cfv cA c0 cF vw cv vz cv vz cv cuni cun wceq vz
      vw copab cA crdg com cres trcl.2 fveq1i cA cvv wcel c0 vw cv vz cv vz cv
      cuni cun wceq vz vw copab cA crdg com cres cfv cA wceq trcl.1 cA cvv vw
      cv vz cv vz cv cuni cun wceq vz vw copab fr0g ax-mp eqtr2i eqimssi cA vy
      cv cF cfv wss cA c0 cF cfv wss vy c0 com vy cv c0 wceq vy cv cF cfv c0 cF
      cfv cA vy cv c0 cF fveq2 sseq2d rcla4ev mp2an vy com vy cv cF cfv cA
      ssiun ax-mp trcl.3 sseqtr4i cC wtr vy com vy cv cF cfv ciun wtr vy com vy
      cv cF cfv ciun wtr vv cv vu cv wcel vu cv vy com vy cv cF cfv ciun wcel
      wa vv cv vy com vy cv cF cfv ciun wcel wi vu wal vv vv vu vy com vy cv cF
      cfv ciun dftr2 vv cv vu cv wcel vu cv vy com vy cv cF cfv ciun wcel wa vv
      cv vy com vy cv cF cfv ciun wcel wi vu vv cv vu cv wcel vu cv vy com vy
      cv cF cfv ciun wcel wa vv cv vy cv csuc cF cfv wcel vy com wrex vv cv vy
      com vy cv cF cfv ciun wcel vv cv vu cv wcel vu cv vy com vy cv cF cfv
      ciun wcel wa vv cv vu cv wcel vu cv vy cv cF cfv wcel wa vy com wrex vv
      cv vy cv csuc cF cfv wcel vy com wrex vv cv vu cv wcel vu cv vy com vy cv
      cF cfv ciun wcel wa vv cv vu cv wcel vu cv vy cv cF cfv wcel vy com wrex
      wa vv cv vu cv wcel vu cv vy cv cF cfv wcel wa vy com wrex vu cv vy com
      vy cv cF cfv ciun wcel vu cv vy cv cF cfv wcel vy com wrex vv cv vu cv
      wcel vy vu cv com vy cv cF cfv eliun anbi2i vv cv vu cv wcel vu cv vy cv
      cF cfv wcel vy com r19.42v bitr4i vv cv vu cv wcel vu cv vy cv cF cfv
      wcel wa vv cv vy cv csuc cF cfv wcel vy com vy cv com wcel vv cv vy cv cF
      cfv cuni wcel vv cv vy cv csuc cF cfv wcel vv cv vu cv wcel vu cv vy cv
      cF cfv wcel wa vy cv com wcel vy cv cF cfv cuni vy cv csuc cF cfv vv cv
      vy cv com wcel vy cv cF cfv cuni vy cv csuc cF cfv wss vy cv cF cfv cuni
      vy cv cF cfv vy cv cF cfv cuni cun wss vy cv cF cfv cuni vy cv cF cfv
      ssun2 vy cv com wcel vy cv csuc cF cfv vy cv cF cfv vy cv cF cfv cuni cun
      vy cv cF cfv cuni vy cv com wcel vy cv cF cfv vy cv cF cfv cuni cun cvv
      wcel vy cv csuc cF cfv vy cv cF cfv vy cv cF cfv cuni cun wceq vy cv cF
      cfv vy cv cF cfv cuni vy cv cF fvex vy cv cF cfv vy cv cF fvex uniex unex
      vz vw vv cA vy cv vz cv vz cv cuni cun vy cv cF cfv vy cv cF cfv cuni cun
      cvv cF vv cv cA wcel vz ax-17 vv cv vy cv wcel vz ax-17 vz vv vy cv cF
      cfv vy cv cF cfv cuni vz vv vy cv cF vz vv cF vw cv vz cv vz cv cuni cun
      wceq vz vw copab cA crdg com cres trcl.2 vz vv vw cv vz cv vz cv cuni cun
      wceq vz vw copab cA crdg com vz vv cA vw cv vz cv vz cv cuni cun wceq vz
      vw copab vw cv vz cv vz cv cuni cun wceq vz vw vv hbopab1 vv cv cA wcel
      vz ax-17 hbrdg vv cv com wcel vz ax-17 hbres hbxfr vv cv vy cv wcel vz
      ax-17 hbfv vz vv vy cv cF cfv vz vv vy cv cF vz vv cF vw cv vz cv vz cv
      cuni cun wceq vz vw copab cA crdg com cres trcl.2 vz vv vw cv vz cv vz cv
      cuni cun wceq vz vw copab cA crdg com vz vv cA vw cv vz cv vz cv cuni cun
      wceq vz vw copab vw cv vz cv vz cv cuni cun wceq vz vw vv hbopab1 vv cv
      cA wcel vz ax-17 hbrdg vv cv com wcel vz ax-17 hbres hbxfr vv cv vy cv
      wcel vz ax-17 hbfv hbuni hbun trcl.2 vz cv vy cv cF cfv wceq vz cv cuni
      vy cv cF cfv cuni wceq vz cv vz cv cuni cun vy cv cF cfv vy cv cF cfv
      cuni cun wceq vz cv vy cv cF cfv unieq vz cv vy cv cF cfv vz cv cuni vy
      cv cF cfv cuni uneq12 mpdan frsucopab mpan2 sseq2d mpbiri sseld vv cv vu
      cv vy cv cF cfv elunii syl5 r19.22i sylbi vv cv vy cv csuc cF cfv wcel vy
      com wrex vv cv vy cv cF cfv wcel vy com wrex vv cv vy com vy cv cF cfv
      ciun wcel vv cv vy cv csuc cF cfv wcel vy com wrex vv cv vu cv cF cfv
      wcel vu com wrex vv cv vy cv cF cfv wcel vy com wrex vv cv vy cv csuc cF
      cfv wcel vv cv vu cv cF cfv wcel vu com wrex vy com vy cv com wcel vy cv
      csuc com wcel vv cv vy cv csuc cF cfv wcel vv cv vu cv cF cfv wcel vu com
      wrex wi vy cv peano2 vy cv csuc com wcel vv cv vy cv csuc cF cfv wcel vv
      cv vu cv cF cfv wcel vu com wrex vv cv vu cv cF cfv wcel vv cv vy cv csuc
      cF cfv wcel vu vy cv csuc com vu cv vy cv csuc wceq vu cv cF cfv vy cv
      csuc cF cfv vv cv vu cv vy cv csuc cF fveq2 eleq2d rcla4ev ex syl
      r19.23aiv vv cv vy cv cF cfv wcel vv cv vu cv cF cfv wcel vy vu com vy cv
      vu cv wceq vy cv cF cfv vu cv cF cfv vv cv vy cv vu cv cF fveq2 eleq2d
      cbvrexv sylibr vy vv cv com vy cv cF cfv eliun sylibr syl ax-gen mpgbir
      cC vy com vy cv cF cfv ciun wceq cC wtr vy com vy cv cF cfv ciun wtr wb
      trcl.3 cC vy com vy cv cF cfv ciun treq ax-mp mpbir cA vx cv wss vx cv
      wtr wa cC vx cv wss wi vx cA vx cv wss vx cv wtr wa vv cv cF cfv vx cv
      wss vv com wral cC vx cv wss cA vx cv wss vx cv wtr wa vv cv cF cfv vx cv
      wss vv com vv cv com wcel cA vx cv wss vx cv wtr wa vv cv cF cfv vx cv
      wss vv cv cF cfv vx cv wss c0 cF cfv vx cv wss vy cv cF cfv vx cv wss vy
      cv csuc cF cfv vx cv wss cA vx cv wss vx cv wtr wa vv vy vv cv c0 wceq vv
      cv cF cfv c0 cF cfv vx cv vv cv c0 cF fveq2 sseq1d vv cv vy cv wceq vv cv
      cF cfv vy cv cF cfv vx cv vv cv vy cv cF fveq2 sseq1d vv cv vy cv csuc
      wceq vv cv cF cfv vy cv csuc cF cfv vx cv vv cv vy cv csuc cF fveq2
      sseq1d cA vx cv wss c0 cF cfv vx cv wss vx cv wtr c0 cF cfv vx cv wss cA
      vx cv wss c0 cF cfv cA vx cv c0 cF cfv c0 vw cv vz cv vz cv cuni cun wceq
      vz vw copab cA crdg com cres cfv cA c0 cF vw cv vz cv vz cv cuni cun wceq
      vz vw copab cA crdg com cres trcl.2 fveq1i cA cvv wcel c0 vw cv vz cv vz
      cv cuni cun wceq vz vw copab cA crdg com cres cfv cA wceq trcl.1 cA cvv
      vw cv vz cv vz cv cuni cun wceq vz vw copab fr0g ax-mp eqtri sseq1i
      biimpri adantr vy cv com wcel vx cv wtr vy cv cF cfv vx cv wss vy cv csuc
      cF cfv vx cv wss wi cA vx cv wss vy cv com wcel vy cv cF cfv vx cv wss vx
      cv wtr vy cv csuc cF cfv vx cv wss vy cv cF cfv vx cv wss vx cv wtr vy cv
      cF cfv vy cv cF cfv cuni cun vx cv wss vy cv com wcel vy cv csuc cF cfv
      vx cv wss vy cv cF cfv vx cv wss vx cv wtr vy cv cF cfv vx cv wss vy cv
      cF cfv cuni vx cv wss wa vy cv cF cfv vy cv cF cfv cuni cun vx cv wss vy
      cv cF cfv vx cv wss vx cv wtr vy cv cF cfv cuni vx cv wss vy cv cF cfv vx
      cv wss vy cv cF cfv cuni vx cv cuni wss vx cv wtr vy cv cF cfv cuni vx cv
      wss wi vy cv cF cfv vx cv uniss vy cv cF cfv cuni vx cv cuni wss vx cv
      cuni vx cv wss vy cv cF cfv cuni vx cv wss vx cv wtr vy cv cF cfv cuni vx
      cv cuni vx cv sstr2 vx cv df-tr syl5ib syl anc2li vy cv cF cfv vy cv cF
      cfv cuni vx cv unss syl6ib vy cv com wcel vy cv csuc cF cfv vx cv wss vy
      cv cF cfv vy cv cF cfv cuni cun vx cv wss vy cv com wcel vy cv csuc cF
      cfv vy cv cF cfv vy cv cF cfv cuni cun vx cv vy cv com wcel vy cv cF cfv
      vy cv cF cfv cuni cun cvv wcel vy cv csuc cF cfv vy cv cF cfv vy cv cF
      cfv cuni cun wceq vy cv cF cfv vy cv cF cfv cuni vy cv cF fvex vy cv cF
      cfv vy cv cF fvex uniex unex vz vw vv cA vy cv vz cv vz cv cuni cun vy cv
      cF cfv vy cv cF cfv cuni cun cvv cF vv cv cA wcel vz ax-17 vv cv vy cv
      wcel vz ax-17 vz vv vy cv cF cfv vy cv cF cfv cuni vz vv vy cv cF vz vv
      cF vw cv vz cv vz cv cuni cun wceq vz vw copab cA crdg com cres trcl.2 vz
      vv vw cv vz cv vz cv cuni cun wceq vz vw copab cA crdg com vz vv cA vw cv
      vz cv vz cv cuni cun wceq vz vw copab vw cv vz cv vz cv cuni cun wceq vz
      vw vv hbopab1 vv cv cA wcel vz ax-17 hbrdg vv cv com wcel vz ax-17 hbres
      hbxfr vv cv vy cv wcel vz ax-17 hbfv vz vv vy cv cF cfv vz vv vy cv cF vz
      vv cF vw cv vz cv vz cv cuni cun wceq vz vw copab cA crdg com cres trcl.2
      vz vv vw cv vz cv vz cv cuni cun wceq vz vw copab cA crdg com vz vv cA vw
      cv vz cv vz cv cuni cun wceq vz vw copab vw cv vz cv vz cv cuni cun wceq
      vz vw vv hbopab1 vv cv cA wcel vz ax-17 hbrdg vv cv com wcel vz ax-17
      hbres hbxfr vv cv vy cv wcel vz ax-17 hbfv hbuni hbun trcl.2 vz cv vy cv
      cF cfv wceq vz cv cuni vy cv cF cfv cuni wceq vz cv vz cv cuni cun vy cv
      cF cfv vy cv cF cfv cuni cun wceq vz cv vy cv cF cfv unieq vz cv vy cv cF
      cfv vz cv cuni vy cv cF cfv cuni uneq12 mpdan frsucopab mpan2 sseq1d
      biimprd syl9r com23 adantld finds2 com12 r19.21aiv cC vx cv wss vv com vv
      cv cF cfv ciun vx cv wss vv cv cF cfv vx cv wss vv com wral cC vv com vv
      cv cF cfv ciun vx cv cC vy com vy cv cF cfv ciun vv com vv cv cF cfv ciun
      trcl.3 vy vv com vy cv cF cfv vv cv cF cfv vy cv vv cv cF fveq2 cbviunv
      eqtri sseq1i vv com vv cv cF cfv vx cv iunss bitri sylibr ax-gen 3pm3.2i
      $.
      $( [14-Sep-2003] $)
  $}

  ${
    $d A x y z w v $.
    tz9.1.1 $e |- A e. _V $.
    $( Every set has a transitive closure (smallest transitive extension).
       Theorem 9.1 of [TakeutiZaring] p. 73.  See ~ trcl for an explicit
       expression for the transitive closure.  Apparently open problems are
       whether this theorem can be proved without the Axiom of Infinity; if
       not, then whether it implies Infinity; and if not, what is the
       "property" that Infinity has that the other axioms don't have that
       is weaker than Infinity itself? $)
    tz9.1 $p |- E. x ( A C_ x /\ Tr x
                /\ A. y ( ( A C_ y /\ Tr y ) -> x C_ y ) ) $=
      cA vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com
      cres cfv ciun wss vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv
      copab cA crdg com cres cfv ciun wtr cA vy cv wss vy cv wtr wa vz com vz
      cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun
      vy cv wss wi vy wal w3a cA vx cv wss vx cv wtr cA vy cv wss vy cv wtr wa
      vx cv vy cv wss wi vy wal w3a vx wex vy vz vw vv cA vz com vz cv vv cv vw
      cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun vv cv vw cv
      vw cv cuni cun wceq vw vv copab cA crdg com cres tz9.1.1 vv cv vw cv vw
      cv cuni cun wceq vw vv copab cA crdg com cres eqid vz com vz cv vv cv vw
      cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun eqid trcl cA
      vx cv wss vx cv wtr cA vy cv wss vy cv wtr wa vx cv vy cv wss wi vy wal
      w3a cA vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg
      com cres cfv ciun wss vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv
      copab cA crdg com cres cfv ciun wtr cA vy cv wss vy cv wtr wa vz com vz
      cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun
      vy cv wss wi vy wal w3a vx vz com vz cv vv cv vw cv vw cv cuni cun wceq
      vw vv copab cA crdg com cres cfv ciun vz com vz cv vv cv vw cv vw cv cuni
      cun wceq vw vv copab cA crdg com cres cfv omex vz cv vv cv vw cv vw cv
      cuni cun wceq vw vv copab cA crdg com cres fvex iunex vx cv vz com vz cv
      vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun
      wceq cA vx cv wss cA vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv
      copab cA crdg com cres cfv ciun wss vx cv wtr vz com vz cv vv cv vw cv vw
      cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun wtr cA vy cv wss
      vy cv wtr wa vx cv vy cv wss wi vy wal cA vy cv wss vy cv wtr wa vz com
      vz cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv
      ciun vy cv wss wi vy wal vx cv vz com vz cv vv cv vw cv vw cv cuni cun
      wceq vw vv copab cA crdg com cres cfv ciun cA sseq2 vx cv vz com vz cv vv
      cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun treq
      vx cv vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg
      com cres cfv ciun wceq cA vy cv wss vy cv wtr wa vx cv vy cv wss wi cA vy
      cv wss vy cv wtr wa vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv
      copab cA crdg com cres cfv ciun vy cv wss wi vy vx cv vz com vz cv vv cv
      vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv ciun wceq vx
      cv vy cv wss vz com vz cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA
      crdg com cres cfv ciun vy cv wss cA vy cv wss vy cv wtr wa vx cv vz com
      vz cv vv cv vw cv vw cv cuni cun wceq vw vv copab cA crdg com cres cfv
      ciun vy cv sseq1 imbi2d albidv 3anbi123d cla4ev ax-mp $.
      $( [1-Nov-2010] $) $( [15-Sep-2003] $)
  $}

  ${
    $d x y z w A $.
    $( The strong form of the Axiom of Regularity, which does not require
       that ` A ` be a set.  Axiom 6' of [TakeutiZaring] p. 21.  The proof
       makes use of a special case of Proposition 9.4 of [TakeutiZaring]
       p. 75. $)
    zfregs $p |- ( A =/= (/) -> E. x e. A ( x i^i A ) = (/) ) $=
      cA c0 wne vz cv cA wcel vz wex vx cv cA cin c0 wceq vx cA wrex vz cA n0
      vz cv cA wcel vx cv cA cin c0 wceq vx cA wrex vz vz cv csn vy cv wss vy
      cv wtr vz cv csn vw cv wss vw cv wtr wa vy cv vw cv wss wi vw wal w3a vy
      wex vz cv cA wcel vx cv cA cin c0 wceq vx cA wrex wi vy vw vz cv csn vz
      cv snex tz9.1 vz cv csn vy cv wss vy cv wtr vz cv csn vw cv wss vw cv wtr
      wa vy cv vw cv wss wi vw wal w3a vz cv cA wcel vx cv cA cin c0 wceq vx cA
      wrex wi vy vz cv csn vy cv wss vy cv wtr vz cv cA wcel vx cv cA cin c0
      wceq vx cA wrex wi vz cv csn vw cv wss vw cv wtr wa vy cv vw cv wss wi vw
      wal vy cv wtr vz cv csn vy cv wss vz cv cA wcel vx cv cA cin c0 wceq vx
      cA wrex wi vy cv wtr vz cv csn vy cv wss vz cv cA wcel vx cv cA cin c0
      wceq vx cA wrex vy cv wtr vy cv cA cin c0 wne vx cv cA cin c0 wceq vx cA
      wrex vz cv csn vy cv wss vz cv cA wcel wa vy cv wtr vy cv cA cin vx cv
      cin c0 wceq vx vy cv cA cin wrex vx cv cA cin c0 wceq vx cA wrex vy cv cA
      cin c0 wne vy cv wtr vy cv cA cin vx cv cin c0 wceq vx cv cA cin c0 wceq
      vx vy cv cA cin cA vy cv wtr vx cv vy cv wcel vx cv cA wcel vy cv cA cin
      vx cv cin c0 wceq wa wa vx cv cA wcel vx cv cA cin c0 wceq wa vx cv vy cv
      cA cin wcel vy cv cA cin vx cv cin c0 wceq wa vy cv wtr vx cv vy cv wcel
      vx cv cA wcel vy cv cA cin vx cv cin c0 wceq wa vx cv cA wcel vx cv cA
      cin c0 wceq wa vy cv wtr vx cv vy cv wcel wa vy cv cA cin vx cv cin c0
      wceq vx cv cA cin c0 wceq vx cv cA wcel vy cv wtr vx cv vy cv wcel wa vx
      cv cA cin c0 vy cv cA cin vx cv cin c0 vy cv wtr vx cv vy cv wcel vx cv
      cA cin c0 wne vy cv cA cin vx cv cin c0 wne wi vy cv wtr vx cv cA cin c0
      wne vx cv vy cv wcel vy cv cA cin vx cv cin c0 wne vy cv wtr vw cv vx cv
      cA cin wcel vw wex vx cv vy cv wcel vy cv cA cin vx cv cin c0 wne wi vx
      cv cA cin c0 wne vy cv wtr vw cv vx cv cA cin wcel vx cv vy cv wcel vy cv
      cA cin vx cv cin c0 wne wi vw vy cv wtr vw cv vx cv wcel vw cv vx cv cA
      cin wcel wa vx cv vy cv wcel vy cv cA cin vx cv cin c0 wne wi vw cv vx cv
      cA cin wcel vy cv wtr vw cv vx cv wcel vw cv vx cv cA cin wcel vx cv vy
      cv wcel vy cv cA cin vx cv cin c0 wne wi vy cv wtr vw cv vx cv wcel vx cv
      vy cv wcel vw cv vx cv cA cin wcel vy cv cA cin vx cv cin c0 wne vy cv
      wtr vw cv vx cv wcel vx cv vy cv wcel vw cv vx cv cA cin wcel vy cv cA
      cin vx cv cin c0 wne wi vy cv wtr vw cv vx cv wcel vx cv vy cv wcel wa vw
      cv vy cv wcel vw cv vx cv cA cin wcel vy cv cA cin vx cv cin c0 wne wi vy
      cv vw cv vx cv trel vw cv vy cv wcel vw cv vx cv cA cin wcel vy cv cA cin
      vx cv cin c0 wne vw cv vy cv wcel vw cv vx cv cA cin wcel wa vw cv vy cv
      cA cin vx cv cin wcel vy cv cA cin vx cv cin c0 wne vw cv vy cv cA cin vx
      cv cin wcel vw cv vy cv vx cv cA cin cin wcel vw cv vy cv wcel vw cv vx
      cv cA cin wcel wa vy cv cA cin vx cv cin vy cv vx cv cA cin cin vw cv vy
      cv cA cin vx cv cin vy cv cA vx cv cin cin vy cv vx cv cA cin cin vy cv
      cA vx cv inass cA vx cv cin vx cv cA cin vy cv cA vx cv incom ineq2i
      eqtri eleq2i vw cv vy cv vx cv cA cin elin bitr2i vy cv cA cin vx cv cin
      vw cv ne0i sylbi ex syl6 exp3a com34 imp3a vw cv vx cv cA cin wcel vw cv
      vx cv wcel vx cv cA cin vx cv vw cv vx cv cA inss1 sseli ancri syl5
      19.23adv vw vx cv cA cin n0 syl5ib com23 imp necon4d anim2d expimpd vx cv
      vy cv cA cin wcel vy cv cA cin vx cv cin c0 wceq wa vx cv vy cv wcel vx
      cv cA wcel wa vy cv cA cin vx cv cin c0 wceq wa vx cv vy cv wcel vx cv cA
      wcel vy cv cA cin vx cv cin c0 wceq wa wa vx cv vy cv cA cin wcel vx cv
      vy cv wcel vx cv cA wcel wa vy cv cA cin vx cv cin c0 wceq vx cv vy cv cA
      elin anbi1i vx cv vy cv wcel vx cv cA wcel vy cv cA cin vx cv cin c0 wceq
      anass bitri syl5ib r19.22dv2 vx vy cv cA cin vy cv cA vy visset inex1
      zfreg2 syl5 vz cv csn vy cv wss vz cv cA wcel wa vz cv vy cv cA cin wcel
      vy cv cA cin c0 wne vz cv csn vy cv wss vz cv cA wcel wa vz cv csn vy cv
      wss vz cv csn cA wss wa vz cv vy cv cA cin wcel vz cv cA wcel vz cv csn
      cA wss vz cv csn vy cv wss vz cv cA snssi anim2i vz cv csn vy cv wss vz
      cv csn cA wss wa vz cv csn vy cv cA cin wss vz cv vy cv cA cin wcel vz cv
      csn vy cv cA ssin vz cv vy cv cA cin vz visset snss bitr4i sylib vy cv cA
      cin vz cv ne0i syl syl5 exp3a impcom 3adant3 19.23aiv ax-mp 19.23aiv
      sylbi $.
      $( [12-Apr-2007] $) $( [17-Sep-2003] $)
  $}

  ${
    $d x y z A $.
    $( Set (epsilon) induction.  Theorem 5.22 of [TakeutiZaring] p. 21. $)
    setind $p |- ( A. x ( x C_ A -> x e. A ) -> A = _V ) $=
      vx cv cA wss vx cv cA wcel wi vx wal cvv cA cdif c0 wceq cA cvv wceq vx
      cv cA wss vx cv cA wcel wi vx wal vy cv cvv cA cdif cin c0 wceq vy cvv cA
      cdif wrex wn cvv cA cdif c0 wceq vx cv cA wss vx cv cA wcel wi vx wal vy
      cv cvv cA cdif cin c0 wceq vy cvv cA cdif vx cv cA wss vx cv cA wcel wi
      vx wal vy cv cvv cA cdif wcel vy cv cvv cA cdif cin c0 wceq wn vx cv cA
      wss vx cv cA wcel wi vx wal vy cv cvv cA cdif cin c0 wceq vy cv cA wcel
      vy cv cvv cA cdif wcel vx cv cA wss vx cv cA wcel wi vx wal vy cv cA wss
      vy cv cA wcel vy cv cvv cA cdif cin c0 wceq vx cv cA wss vx cv cA wcel wi
      vy cv cA wss vy cv cA wcel wi vx vy vx cv vy cv wceq vx cv cA wss vy cv
      cA wss vx cv cA wcel vy cv cA wcel vx cv vy cv cA sseq1 vx cv vy cv cA
      eleq1 imbi12d a4v vy cv cA ssindif0 syl5ibr vy cv cvv cA eldifn nsyli imp
      nrexdv vy cv cvv cA cdif cin c0 wceq vy cvv cA cdif wrex cvv cA cdif c0
      vy cvv cA cdif zfregs necon1bi syl cA vdif0 sylibr $.
      $( [17-Sep-2003] $)
  $}

  ${
    $d x A $.
    $( Set (epsilon) induction, stated compactly.  Given as a homework problem
       in 1992 by George Boolos (1940-1996). $)
    setind2 $p |- ( ~P A C_ A -> A = _V ) $=
      cA cpw cA wss vx cv cA wss vx cv cA wcel wi vx wal cA cvv wceq cA cpw cA
      wss vx cv cA cpw wcel vx cv cA wcel wi vx wal vx cv cA wss vx cv cA wcel
      wi vx wal vx cA cpw cA dfss2 vx cv cA cpw wcel vx cv cA wcel wi vx cv cA
      wss vx cv cA wcel wi vx vx cv cA cpw wcel vx cv cA wss vx cv cA wcel vx
      cv cA vx visset elpw imbi1i albii bitri vx cA setind sylbi $.
      $( [17-Sep-2003] $)
  $}

  ${
    $d x y $.
    $( The cumulative hierarchy of sets function is a function on the class of
       ordinal numbers. $)
    r1fnon $p |- R1 Fn On $=
      cr1 con0 wfn vy cv vx cv cpw wceq vx vy copab c0 crdg con0 wfn c0 vy cv
      vx cv cpw wceq vx vy copab rdgfnon cr1 vy cv vx cv cpw wceq vx vy copab
      c0 crdg wceq cr1 con0 wfn vy cv vx cv cpw wceq vx vy copab c0 crdg con0
      wfn wb vx vy df-r1 con0 cr1 vy cv vx cv cpw wceq vx vy copab c0 crdg
      fneq1 ax-mp mpbir $.
      $( [5-Oct-2003] $) $( [5-Oct-2003] $)

    $( Value of the cumulative hierarchy of sets function at ` (/) ` .
       Part of Definition 9.9 of [TakeutiZaring] p. 76. $)
    r10 $p |- ( R1 ` (/) ) = (/) $=
      c0 cr1 cfv c0 vy cv vx cv cpw wceq vx vy copab c0 crdg cfv c0 c0 cr1 vy
      cv vx cv cpw wceq vx vy copab c0 crdg vx vy df-r1 fveq1i c0 vy cv vx cv
      cpw wceq vx vy copab 0ex rdg0 eqtri $.
      $( [2-Sep-2003] $)
  $}

  ${
    $d x y z A $.
    $( Value of the cumulative hierarchy of sets function at a successor
       ordinal.  Part of Definition 9.9 of [TakeutiZaring] p. 76. $)
    r1suc $p |- ( A e. On -> ( R1 ` suc A ) = ~P ( R1 ` A ) ) $=
      cA con0 wcel cA cr1 cfv cpw cvv wcel cA csuc cr1 cfv cA cr1 cfv cpw wceq
      cA cr1 cfv cA cr1 fvex pwex vx vy vz c0 cA vx cv cpw cA cr1 cfv cpw cvv
      cr1 vz cv c0 wcel vx ax-17 vz cv cA wcel vx ax-17 vz cv cA cr1 cfv cpw
      wcel vx ax-17 vx vy df-r1 vx cv cA cr1 cfv pweq rdgsucopab mpan2 $.
      $( [2-Sep-2003] $)
  $}

  ${
    $d x y z A $.
    $( Value of the cumulative hierarchy of sets function at a limit
       ordinal.  Part of Definition 9.9 of [TakeutiZaring] p. 76. $)
    r1lim $p |- ( ( A e. B /\ Lim A ) -> ( R1 ` A ) = U_ x e. A ( R1 ` x ) ) $=
      cA cB wcel cA wlim wa cA vz cv vy cv cpw wceq vy vz copab c0 crdg cfv vx
      cA vx cv vz cv vy cv cpw wceq vy vz copab c0 crdg cfv ciun cA cr1 cfv vx
      cA vx cv cr1 cfv ciun vx c0 cA cB vz cv vy cv cpw wceq vy vz copab
      rdglim2a cA cr1 vz cv vy cv cpw wceq vy vz copab c0 crdg vy vz df-r1
      fveq1i vx cA vx cv cr1 cfv vx cv vz cv vy cv cpw wceq vy vz copab c0 crdg
      cfv vx cv cr1 cfv vx cv vz cv vy cv cpw wceq vy vz copab c0 crdg cfv wceq
      vx cv cA wcel vx cv cr1 vz cv vy cv cpw wceq vy vz copab c0 crdg vy vz
      df-r1 fveq1i a1i iuneq2i 3eqtr4g $.
      $( [4-Oct-2003] $) $( [4-Oct-2003] $)
  $}

  ${
    $d x y z A $.
    $( The cumulative hierarchy of sets is transitive.  Lemma 7T of [Enderton]
       p. 202. $)
    r1tr $p |- Tr ( R1 ` A ) $=
      cA con0 wcel cA cr1 cfv wtr vx cv cr1 cfv wtr c0 cr1 cfv wtr vy cv cr1
      cfv wtr vy cv csuc cr1 cfv wtr cA cr1 cfv wtr vx vy cA vx cv c0 wceq vx
      cv cr1 cfv c0 cr1 cfv wceq vx cv cr1 cfv wtr c0 cr1 cfv wtr wb vx cv c0
      cr1 fveq2 vx cv cr1 cfv c0 cr1 cfv treq syl vx cv vy cv wceq vx cv cr1
      cfv vy cv cr1 cfv wceq vx cv cr1 cfv wtr vy cv cr1 cfv wtr wb vx cv vy cv
      cr1 fveq2 vx cv cr1 cfv vy cv cr1 cfv treq syl vx cv vy cv csuc wceq vx
      cv cr1 cfv vy cv csuc cr1 cfv wceq vx cv cr1 cfv wtr vy cv csuc cr1 cfv
      wtr wb vx cv vy cv csuc cr1 fveq2 vx cv cr1 cfv vy cv csuc cr1 cfv treq
      syl vx cv cA wceq vx cv cr1 cfv cA cr1 cfv wceq vx cv cr1 cfv wtr cA cr1
      cfv wtr wb vx cv cA cr1 fveq2 vx cv cr1 cfv cA cr1 cfv treq syl c0 cr1
      cfv wtr c0 wtr tr0 c0 cr1 cfv c0 wceq c0 cr1 cfv wtr c0 wtr wb r10 c0 cr1
      cfv c0 treq ax-mp mpbir vy cv con0 wcel vy cv cr1 cfv wtr vy cv csuc cr1
      cfv wtr vy cv con0 wcel vy cv cr1 cfv wtr wa vx cv vy cv csuc cr1 cfv wss
      vx vy cv csuc cr1 cfv wral vy cv csuc cr1 cfv wtr vy cv con0 wcel vy cv
      cr1 cfv wtr wa vx cv vy cv csuc cr1 cfv wss vx vy cv csuc cr1 cfv vy cv
      con0 wcel vy cv cr1 cfv wtr wa vx cv vy cv csuc cr1 cfv wcel vx cv vy cv
      cr1 cfv wss vx cv vy cv csuc cr1 cfv wss vy cv con0 wcel vx cv vy cv csuc
      cr1 cfv wcel vx cv vy cv cr1 cfv wss wb vy cv cr1 cfv wtr vy cv con0 wcel
      vx cv vy cv csuc cr1 cfv wcel vx cv vy cv cr1 cfv cpw wcel vx cv vy cv
      cr1 cfv wss vy cv con0 wcel vy cv csuc cr1 cfv vy cv cr1 cfv cpw vx cv vy
      cv r1suc eleq2d vx cv vy cv cr1 cfv vx visset elpw syl6bb adantr vy cv
      con0 wcel vy cv cr1 cfv wtr wa vx cv vy cv cr1 cfv wss vx cv vy cv csuc
      cr1 cfv wss vy cv con0 wcel vy cv cr1 cfv wtr wa vx cv vy cv cr1 cfv wss
      wa vz vx cv vy cv csuc cr1 cfv vx cv vy cv cr1 cfv wss vz cv vx cv wcel
      vz cv vy cv cr1 cfv wcel vy cv con0 wcel vy cv cr1 cfv wtr wa vz cv vy cv
      csuc cr1 cfv wcel vx cv vy cv cr1 cfv vz cv ssel vy cv cr1 cfv wtr vz cv
      vy cv cr1 cfv wcel vz cv vy cv cr1 cfv cpw wcel vy cv con0 wcel vz cv vy
      cv csuc cr1 cfv wcel vy cv cr1 cfv wtr vy cv cr1 cfv vy cv cr1 cfv cpw
      wss vz cv vy cv cr1 cfv wcel vz cv vy cv cr1 cfv cpw wcel wi vy cv cr1
      cfv dftr4 vy cv cr1 cfv vy cv cr1 cfv cpw vz cv ssel sylbi vy cv con0
      wcel vz cv vy cv csuc cr1 cfv wcel vz cv vy cv cr1 cfv cpw wcel vy cv
      con0 wcel vy cv csuc cr1 cfv vy cv cr1 cfv cpw vz cv vy cv r1suc eleq2d
      biimprd sylan9r sylan9r ssrdv ex sylbid r19.21aiv vx vy cv csuc cr1 cfv
      dftr3 sylibr ex vx cv wlim vy cv cr1 cfv wtr vy vx cv wral vx cv cr1 cfv
      wtr vx cv wlim vy cv cr1 cfv wtr vy vx cv wral wa vz cv vx cv cr1 cfv wss
      vz vx cv cr1 cfv wral vx cv cr1 cfv wtr vx cv wlim vy cv cr1 cfv wtr vy
      vx cv wral wa vz cv vx cv cr1 cfv wss vz vx cv cr1 cfv vx cv wlim vy cv
      cr1 cfv wtr vy vx cv wral wa vz cv vx cv cr1 cfv wcel vz cv vy cv cr1 cfv
      wss vy vx cv wrex vz cv vx cv cr1 cfv wss vx cv wlim vz cv vx cv cr1 cfv
      wcel vz cv vy cv cr1 cfv wcel vy vx cv wrex vy cv cr1 cfv wtr vy vx cv
      wral vz cv vy cv cr1 cfv wss vy vx cv wrex vx cv wlim vz cv vx cv cr1 cfv
      wcel vz cv vy vx cv vy cv cr1 cfv ciun wcel vz cv vy cv cr1 cfv wcel vy
      vx cv wrex vx cv wlim vx cv cr1 cfv vy vx cv vy cv cr1 cfv ciun vz cv vx
      cv cvv wcel vx cv wlim vx cv cr1 cfv vy vx cv vy cv cr1 cfv ciun wceq vx
      visset vy vx cv cvv r1lim mpan eleq2d vz cv vy vx cv vy cv cr1 cfv ciun
      wcel vz cv vy cv cr1 cfv wcel vy vx cv wrex vy vz cv vx cv vy cv cr1 cfv
      eliun biimpi syl6bi vy cv cr1 cfv wtr vy vx cv wral vz cv vy cv cr1 cfv
      wcel vz cv vy cv cr1 cfv wss vy vx cv vy cv cr1 cfv wtr vy vx cv hbra1 vy
      cv cr1 cfv wtr vy vx cv wral vy cv vx cv wcel vy cv cr1 cfv wtr vz cv vy
      cv cr1 cfv wcel vz cv vy cv cr1 cfv wss wi vy cv cr1 cfv wtr vy vx cv ra4
      vy cv cr1 cfv vz cv trss syl6 r19.22d sylan9 vx cv wlim vz cv vy cv cr1
      cfv wss vy vx cv wrex vz cv vx cv cr1 cfv wss wi vy cv cr1 cfv wtr vy vx
      cv wral vx cv wlim vz cv vx cv cr1 cfv wss vz cv vy vx cv vy cv cr1 cfv
      ciun wss vz cv vy cv cr1 cfv wss vy vx cv wrex vx cv wlim vx cv cr1 cfv
      vy vx cv vy cv cr1 cfv ciun vz cv vx cv cvv wcel vx cv wlim vx cv cr1 cfv
      vy vx cv vy cv cr1 cfv ciun wceq vx visset vy vx cv cvv r1lim mpan sseq2d
      vy vx cv vy cv cr1 cfv vz cv ssiun syl5bir adantr syld r19.21aiv vz vx cv
      cr1 cfv dftr3 sylibr ex tfinds cA con0 wcel wn cA cr1 cfv wtr c0 wtr tr0
      cA con0 wcel wn cA cr1 cfv c0 wceq cA cr1 cfv wtr c0 wtr wb cA con0 wcel
      wn cA cr1 cdm wcel wn cA cr1 cfv c0 wceq cA cr1 cdm wcel cA con0 wcel cr1
      cdm con0 cA cr1 con0 wfn cr1 cdm con0 wceq r1fnon con0 cr1 fndm ax-mp
      eleq2i notbii cA cr1 ndmfv sylbir cA cr1 cfv c0 treq syl mpbiri pm2.61i
      $.
      $( [26-Nov-2003] $) $( [8-Sep-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Ordering relation for the cumulative hierarchy of sets.  Part of
       Proposition 9.10(2) of [TakeutiZaring] p. 77. $)
    r1ord $p |- ( B e. On -> ( A e. B -> ( R1 ` A ) e. ( R1 ` B ) ) ) $=
      cB con0 wcel cA cB wcel cA cr1 cfv cB cr1 cfv wcel cB con0 wcel cA cB
      wcel cA cB wcel cA cr1 cfv cB cr1 cfv wcel wi cB con0 wcel cA csuc con0
      wcel wa cA csuc cB wss cA cB wcel cA cr1 cfv cB cr1 cfv wcel wi cB con0
      wcel cA cB wcel wa cA vx cv wcel cA cr1 cfv vx cv cr1 cfv wcel wi cA cA
      csuc wcel cA cr1 cfv cA csuc cr1 cfv wcel wi cA vy cv wcel cA cr1 cfv vy
      cv cr1 cfv wcel wi cA vy cv csuc wcel cA cr1 cfv vy cv csuc cr1 cfv wcel
      wi cA cB wcel cA cr1 cfv cB cr1 cfv wcel wi vx vy cB cA csuc vx cv cA
      csuc wceq cA vx cv wcel cA cA csuc wcel cA cr1 cfv vx cv cr1 cfv wcel cA
      cr1 cfv cA csuc cr1 cfv wcel vx cv cA csuc cA eleq2 vx cv cA csuc wceq vx
      cv cr1 cfv cA csuc cr1 cfv cA cr1 cfv vx cv cA csuc cr1 fveq2 eleq2d
      imbi12d vx cv vy cv wceq cA vx cv wcel cA vy cv wcel cA cr1 cfv vx cv cr1
      cfv wcel cA cr1 cfv vy cv cr1 cfv wcel vx cv vy cv cA eleq2 vx cv vy cv
      wceq vx cv cr1 cfv vy cv cr1 cfv cA cr1 cfv vx cv vy cv cr1 fveq2 eleq2d
      imbi12d vx cv vy cv csuc wceq cA vx cv wcel cA vy cv csuc wcel cA cr1 cfv
      vx cv cr1 cfv wcel cA cr1 cfv vy cv csuc cr1 cfv wcel vx cv vy cv csuc cA
      eleq2 vx cv vy cv csuc wceq vx cv cr1 cfv vy cv csuc cr1 cfv cA cr1 cfv
      vx cv vy cv csuc cr1 fveq2 eleq2d imbi12d vx cv cB wceq cA vx cv wcel cA
      cB wcel cA cr1 cfv vx cv cr1 cfv wcel cA cr1 cfv cB cr1 cfv wcel vx cv cB
      cA eleq2 vx cv cB wceq vx cv cr1 cfv cB cr1 cfv cA cr1 cfv vx cv cB cr1
      fveq2 eleq2d imbi12d cA csuc con0 wcel cA cA csuc wcel cA cr1 cfv cA csuc
      cr1 cfv wcel cA csuc con0 wcel cA cA csuc wcel wa cA con0 wcel cA cr1 cfv
      cA csuc cr1 cfv wcel cA csuc cA onelon cA con0 wcel cA cr1 cfv cpw cA
      csuc cr1 cfv cA cr1 cfv cA r1suc cA cr1 cfv cA cr1 fvex pwid syl5eleqr
      syl ex vy cv con0 wcel cA csuc con0 wcel cA csuc vy cv wss cA vy cv wcel
      cA cr1 cfv vy cv cr1 cfv wcel wi cA vy cv csuc wcel cA cr1 cfv vy cv csuc
      cr1 cfv wcel wi wi vy cv con0 wcel cA csuc con0 wcel cA csuc vy cv wss cA
      vy cv wcel cA cr1 cfv vy cv cr1 cfv wcel wi cA vy cv csuc wcel cA cr1 cfv
      vy cv csuc cr1 cfv wcel wi wi vy cv con0 wcel cA vy cv csuc wcel cA vy cv
      wcel cA cr1 cfv vy cv cr1 cfv wcel wi cA csuc con0 wcel cA csuc vy cv wss
      wa cA cr1 cfv vy cv csuc cr1 cfv wcel vy cv con0 wcel cA vy cv wcel cA
      cr1 cfv vy cv cr1 cfv wcel wi cA csuc con0 wcel cA csuc vy cv wss wa cA
      cr1 cfv vy cv csuc cr1 cfv wcel wi wi cA vy cv csuc wcel vy cv con0 wcel
      cA vy cv wcel cA cr1 cfv vy cv cr1 cfv wcel wi cA vy cv wcel cA cr1 cfv
      vy cv csuc cr1 cfv wcel cA csuc con0 wcel cA csuc vy cv wss wa vy cv con0
      wcel cA cr1 cfv vy cv cr1 cfv wcel cA cr1 cfv vy cv csuc cr1 cfv wcel cA
      vy cv wcel vy cv con0 wcel vy cv cr1 cfv vy cv csuc cr1 cfv cA cr1 cfv vy
      cv con0 wcel vy cv cr1 cfv vy cv csuc cr1 cfv wcel vy cv cr1 cfv vy cv
      csuc cr1 cfv wss vy cv con0 wcel vy cv cr1 cfv cpw vy cv csuc cr1 cfv vy
      cv cr1 cfv vy cv r1suc vy cv cr1 cfv vy cv cr1 fvex pwid syl5eleqr vy cv
      csuc cr1 cfv wtr vy cv cr1 cfv vy cv csuc cr1 cfv wcel vy cv cr1 cfv vy
      cv csuc cr1 cfv wss wi vy cv csuc r1tr vy cv csuc cr1 cfv vy cv cr1 cfv
      trss ax-mp syl sseld imim2d cA csuc con0 wcel cA csuc vy cv wss cA vy cv
      wcel cA csuc con0 wcel cA cvv wcel cA csuc vy cv wss cA vy cv wcel wi cA
      csuc con0 wcel cA csuc cvv wcel cA cvv wcel cA csuc con0 elisset cA
      sucexb sylibr cA vy cv cvv sucssel syl imp syl7 a1d com24 exp3a imp31 vx
      cv wlim cA csuc con0 wcel wa cA csuc vx cv wss wa cA vx cv wcel cA cr1
      cfv vx cv cr1 cfv wcel wi cA csuc vy cv wss cA vy cv wcel cA cr1 cfv vy
      cv cr1 cfv wcel wi wi vy vx cv wral vx cv wlim cA vx cv wcel cA cr1 cfv
      vx cv cr1 cfv wcel wi cA csuc con0 wcel cA csuc vx cv wss vx cv wlim cA
      vx cv wcel cA cr1 cfv vx cv cr1 cfv wcel vx cv wlim cA vx cv wcel wa cA
      cr1 cfv vx cv cr1 cfv wcel cA cr1 cfv vy vx cv vy cv cr1 cfv ciun wcel vx
      cv wlim cA vx cv wcel wa cA cr1 cfv vy cv cr1 cfv wcel vy vx cv wrex cA
      cr1 cfv vy vx cv vy cv cr1 cfv ciun wcel cA csuc vx cv wcel cA cr1 cfv cA
      csuc cr1 cfv wcel cA cr1 cfv vy cv cr1 cfv wcel vy vx cv wrex vx cv wlim
      cA vx cv wcel wa cA cr1 cfv vy cv cr1 cfv wcel cA cr1 cfv cA csuc cr1 cfv
      wcel vy cA csuc vx cv vy cv cA csuc wceq vy cv cr1 cfv cA csuc cr1 cfv cA
      cr1 cfv vy cv cA csuc cr1 fveq2 eleq2d rcla4ev vx cv wlim cA vx cv wcel
      cA csuc vx cv wcel vx cv cA limsuc biimpa vx cv wlim cA vx cv wcel wa cA
      con0 wcel cA cr1 cfv cA csuc cr1 cfv wcel vx cv con0 wcel cA vx cv wcel
      cA con0 wcel vx cv wlim vx cv cA onelon vx cv wlim vx cv word vx cv con0
      wcel vx cv limord vx cv vx visset elon sylibr sylan cA con0 wcel cA cr1
      cfv cpw cA csuc cr1 cfv cA cr1 cfv cA r1suc cA cr1 cfv cA cr1 fvex pwid
      syl5eleqr syl sylanc vy cA cr1 cfv vx cv vy cv cr1 cfv eliun sylibr vx cv
      wlim cA cr1 cfv vx cv cr1 cfv wcel cA cr1 cfv vy vx cv vy cv cr1 cfv ciun
      wcel wb cA vx cv wcel vx cv wlim vx cv cr1 cfv vy vx cv vy cv cr1 cfv
      ciun cA cr1 cfv vx cv cvv wcel vx cv wlim vx cv cr1 cfv vy vx cv vy cv
      cr1 cfv ciun wceq vx visset vy vx cv cvv r1lim mpan eleq2d adantr mpbird
      ex ad2antrr a1d tfindsg cB con0 wcel cA cB wcel wa cB con0 wcel cA csuc
      con0 wcel cB con0 wcel cA cB wcel pm3.26 cB con0 wcel cA cB wcel wa cA
      con0 wcel cA csuc con0 wcel cB cA onelon cA suceloni syl jca cB con0 wcel
      cA cB wcel cA csuc cB wss cB con0 wcel cB word cA cB wcel cA csuc cB wss
      wi cB eloni cA cB ordsucss syl imp sylanc ex pm2.43d $.
      $( [8-Sep-2003] $)
  $}

  $( Ordering relation for the cumulative hierarchy of sets.  Part of
     Proposition 9.10(2) of [TakeutiZaring] p. 77. $)
  r1ord2 $p |- ( B e. On -> ( A e. B -> ( R1 ` A ) C_ ( R1 ` B ) ) ) $=
    cB con0 wcel cA cB wcel cA cr1 cfv cB cr1 cfv wcel cA cr1 cfv cB cr1 cfv
    wss cA cB r1ord cB cr1 cfv wtr cA cr1 cfv cB cr1 cfv wcel cA cr1 cfv cB cr1
    cfv wss wi cB r1tr cB cr1 cfv cA cr1 cfv trss ax-mp syl6 $.
    $( [22-Sep-2003] $)

  $( Ordering relation for the cumulative hierarchy of sets.  Part of
     Theorem 3.3(i) of [BellMachover] p. 478. $)
  r1ord3 $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B ->
               ( R1 ` A ) C_ ( R1 ` B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB wss cA cB wcel cA cB wceq wo cA cr1 cfv
    cB cr1 cfv wss cA cB onsseleq cA con0 wcel cB con0 wcel wa cA cB wcel cA
    cr1 cfv cB cr1 cfv wss cA cB wceq cB con0 wcel cA cB wcel cA cr1 cfv cB cr1
    cfv wss wi cA con0 wcel cA cB r1ord2 adantl cA cB wceq cA cr1 cfv cB cr1
    cfv wss wi cA con0 wcel cB con0 wcel wa cA cB wceq cA cr1 cfv cB cr1 cfv
    wceq cA cr1 cfv cB cr1 cfv wss cA cB cr1 fveq2 cA cr1 cfv cB cr1 cfv eqimss
    syl a1i jaod sylbid $.
    $( [22-Sep-2003] $)

  ${
    $d x y z w v A $.
    $( The value of the cumulative hierarchy of sets function expressed
       recursively.  Theorem 7Q of [Enderton] p. 202. $)
    r1val1 $p |- ( A e. On -> ( R1 ` A ) = U_ x e. A ~P ( R1 ` x ) ) $=
      cA con0 wcel cA cr1 cfv vx cA vx cv cr1 cfv cpw ciun cA con0 wcel cA c0
      wceq cA vx cv csuc wceq vx con0 wrex cA cvv wcel cA wlim wa w3o cA cr1
      cfv vx cA vx cv cr1 cfv cpw ciun wss vx cA onzsl cA c0 wceq cA cr1 cfv vx
      cA vx cv cr1 cfv cpw ciun wss cA vx cv csuc wceq vx con0 wrex cA cvv wcel
      cA wlim wa cA c0 wceq cA cr1 cfv vx cA vx cv cr1 cfv cpw ciun wss c0 vx
      cA vx cv cr1 cfv cpw ciun wss vx cA vx cv cr1 cfv cpw ciun 0ss cA c0 wceq
      cA cr1 cfv c0 vx cA vx cv cr1 cfv cpw ciun cA c0 wceq cA cr1 cfv c0 cr1
      cfv c0 cA c0 cr1 fveq2 r10 syl6eq sseq1d mpbiri cA vx cv csuc wceq cA cr1
      cfv vx cA vx cv cr1 cfv cpw ciun wss vx con0 vx vy cA cr1 cfv vx cA vx cv
      cr1 cfv cpw ciun vy cv cA cr1 cfv wcel vx ax-17 vx vy cA vx cv cr1 cfv
      cpw hbiu1 hbss vx cv con0 wcel cA vx cv csuc wceq cA cr1 cfv vx cA vx cv
      cr1 cfv cpw ciun wss vx cv con0 wcel cA vx cv csuc wceq wa cA cr1 cfv vx
      cv cr1 cfv cpw vx cA vx cv cr1 cfv cpw ciun cA vx cv csuc wceq vx cv con0
      wcel cA cr1 cfv vx cv csuc cr1 cfv vx cv cr1 cfv cpw cA vx cv csuc cr1
      fveq2 vx cv r1suc sylan9eqr cA vx cv csuc wceq vx cv cr1 cfv cpw vx cA vx
      cv cr1 cfv cpw ciun wss vx cv con0 wcel cA vx cv csuc wceq vx cv cA wcel
      vx cv cr1 cfv cpw vx cA vx cv cr1 cfv cpw ciun wss cA vx cv csuc wceq vx
      cv cA wcel vx cv vx cv csuc wcel vx cv vx visset sucid cA vx cv csuc vx
      cv eleq2 mpbiri vx cA vx cv cr1 cfv cpw ssiun2 syl adantl eqsstrd ex
      r19.23ai cA cvv wcel cA wlim wa cA cr1 cfv vx cA vx cv cr1 cfv ciun vx cA
      vx cv cr1 cfv cpw ciun vx cA cvv r1lim cA wlim vx cA vx cv cr1 cfv ciun
      vx cA vx cv cr1 cfv cpw ciun wss cA cvv wcel cA wlim vx cv cr1 cfv vx cv
      cr1 cfv cpw wss vx cA wral vx cA vx cv cr1 cfv ciun vx cA vx cv cr1 cfv
      cpw ciun wss cA wlim vx cv cr1 cfv vx cv cr1 cfv cpw wss vx cA cA wlim vx
      cv cA wcel wa vx cv con0 wcel vx cv cr1 cfv vx cv cr1 cfv cpw wss cA word
      vx cv cA wcel vx cv con0 wcel cA wlim cA vx cv ordelon cA limord sylan vx
      cv con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv vx cv cr1 cfv cpw vx cv
      con0 wcel vx cv csuc con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv wss vx cv
      sucelon vx cv csuc con0 wcel vx cv vx cv csuc wcel vx cv cr1 cfv vx cv
      csuc cr1 cfv wss vx cv vx visset sucid vx cv vx cv csuc r1ord2 mpi sylbi
      vx cv r1suc sseqtrd syl r19.21aiva vx cA vx cv cr1 cfv vx cv cr1 cfv cpw
      ss2iun syl adantl eqsstrd 3jaoi sylbi cA con0 wcel vx cv cr1 cfv cpw cA
      cr1 cfv wss vx cA wral vx cA vx cv cr1 cfv cpw ciun cA cr1 cfv wss cA
      con0 wcel vx cv cr1 cfv cpw cA cr1 cfv wss vx cA cA con0 wcel vx cv cA
      wcel wa vx cv cr1 cfv cpw vx cv csuc cr1 cfv cA cr1 cfv cA con0 wcel vx
      cv cA wcel wa vx cv con0 wcel vx cv csuc cr1 cfv vx cv cr1 cfv cpw wceq
      cA vx cv onelon vx cv r1suc syl vx cv csuc con0 wcel cA con0 wcel wa vx
      cv csuc cA wss vx cv csuc cr1 cfv cA cr1 cfv wss cA con0 wcel vx cv cA
      wcel wa vx cv csuc cA r1ord3 cA con0 wcel vx cv cA wcel wa vx cv csuc
      con0 wcel cA con0 wcel cA con0 wcel vx cv cA wcel wa vx cv con0 wcel vx
      cv csuc con0 wcel cA vx cv onelon vx cv sucelon sylib cA con0 wcel vx cv
      cA wcel pm3.26 jca cA con0 wcel vx cv cA wcel vx cv csuc cA wss cA con0
      wcel cA word vx cv cA wcel vx cv csuc cA wss wi cA eloni vx cv cA
      ordsucss syl imp sylc eqsstr3d r19.21aiva vx cA vx cv cr1 cfv cpw cA cr1
      cfv iunss sylibr eqssd $.
      $( [28-Feb-2004] $) $( [25-Nov-2003] $)
  $}

  ${
    $d x y z w v A $.  $d x y u F $.
    tz9.12lem.1 $e |- A e. _V $.
    tz9.12lem.2 $e |- F =
                   { <. z , w >. | w = |^| { v e. On | z e. ( R1 ` v ) } } $.
    $( Lemma for ~ tz9.12 . $)
    tz9.12lem1 $p |- ( F " A ) C_ On $=
      vy cF cA cima con0 vy cv cF cA cima wcel vx cv cA wcel vx cv vy cv cop cF
      wcel wa vx wex vy cv con0 wcel vx vy cv cF cA vy visset elima3 vx cv cA
      wcel vx cv vy cv cop cF wcel wa vy cv con0 wcel vx vx cv vy cv cop cF
      wcel vy cv con0 wcel vx cv cA wcel vx cv vy cv cop cF wcel vy cv vx cv vv
      cv cr1 cfv wcel vv con0 crab cint wceq vy cv con0 wcel vx cv vy cv cop cF
      wcel vx cv vy cv cop vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint
      wceq vz vw copab wcel vy cv vx cv vv cv cr1 cfv wcel vv con0 crab cint
      wceq cF vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab
      vx cv vy cv cop tz9.12lem.2 eleq2i vw cv vz cv vv cv cr1 cfv wcel vv con0
      crab cint wceq vw cv vx cv vv cv cr1 cfv wcel vv con0 crab cint wceq vy
      cv vx cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw vx cv vy cv vx
      visset vy visset vz cv vx cv wceq vz cv vv cv cr1 cfv wcel vv con0 crab
      cint vx cv vv cv cr1 cfv wcel vv con0 crab cint vw cv vz cv vx cv wceq vz
      cv vv cv cr1 cfv wcel vv con0 crab vx cv vv cv cr1 cfv wcel vv con0 crab
      vz cv vx cv wceq vz cv vv cv cr1 cfv wcel vx cv vv cv cr1 cfv wcel vv
      con0 vz cv vx cv vv cv cr1 cfv eleq1 rabbisdv inteqd eqeq2d vw cv vy cv
      vx cv vv cv cr1 cfv wcel vv con0 crab cint eqeq1 opelopab bitri vx cv vv
      cv cr1 cfv wcel vv con0 crab cint cvv wcel vy cv vx cv vv cv cr1 cfv wcel
      vv con0 crab cint wceq vy cv con0 wcel vy cv vx cv vv cv cr1 cfv wcel vv
      con0 crab cint wceq vy cv vx cv vv cv cr1 cfv wcel vv con0 crab cint wceq
      vy wex vx cv vv cv cr1 cfv wcel vv con0 crab cint cvv wcel vy cv vx cv vv
      cv cr1 cfv wcel vv con0 crab cint wceq vy 19.8a vy vx cv vv cv cr1 cfv
      wcel vv con0 crab cint isset sylibr vx cv vv cv cr1 cfv wcel vv con0 crab
      cint cvv wcel vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vy cv vx cv vv
      cv cr1 cfv wcel vv con0 crab cint wceq vy cv con0 wcel wi vx cv vv cv cr1
      cfv wcel vv con0 crab intex vy cv vx cv vv cv cr1 cfv wcel vv con0 crab
      cint wceq vy cv con0 wcel vx cv vv cv cr1 cfv wcel vv con0 crab cint con0
      wcel vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vy cv vx cv vv cv cr1
      cfv wcel vv con0 crab cint con0 eleq1 vx cv vv cv cr1 cfv wcel vv con0
      crab con0 wss vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv vv cv
      cr1 cfv wcel vv con0 crab cint con0 wcel vx cv vv cv cr1 cfv wcel vv con0
      ssrab2 vx cv vv cv cr1 cfv wcel vv con0 crab oninton mpan syl5cbir sylbir
      mpcom sylbi adantl 19.23aiv sylbi ssriv $.
      $( [22-Sep-2003] $)

    $( Lemma for ~ tz9.12 . $)
    tz9.12lem2 $p |- suc U. ( F " A ) e. On $=
      cF cA cima cuni cF cA cima con0 wss cF cA cima cuni con0 wcel vz vw vv cA
      cF tz9.12lem.1 tz9.12lem.2 tz9.12lem1 cF cA cima cF wfun cF cA cima cvv
      wcel cF wfun vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw
      copab wfun vz vw vz cv vv cv cr1 cfv wcel vv con0 crab cint funopabeq cF
      vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab wceq cF
      wfun vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab
      wfun wb tz9.12lem.2 cF vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint
      wceq vz vw copab funeq ax-mp mpbir cF cA tz9.12lem.1 funimaex ax-mp
      ssonunii ax-mp onsuci $.
      $( [22-Sep-2003] $)

    $( Lemma for ~ tz9.12 . $)
    tz9.12lem3 $p |- ( A. x e. A E. y e. On x e. ( R1 ` y ) ->
                    A e. ( R1 ` suc suc U. ( F " A ) ) ) $=
      vx cv vy cv cr1 cfv wcel vy con0 wrex vx cA wral vx cv cF cA cima cuni
      csuc cr1 cfv wcel vx cA wral cA cF cA cima cuni csuc csuc cr1 cfv wcel vx
      cv vy cv cr1 cfv wcel vy con0 wrex vx cv cF cA cima cuni csuc cr1 cfv
      wcel vx cA vx cv cA wcel vx cv vy cv cr1 cfv wcel vx cv cF cA cima cuni
      csuc cr1 cfv wcel vy con0 vy cv con0 wcel vx cv vy cv cr1 cfv wcel vx cv
      cA wcel vx cv cF cA cima cuni csuc cr1 cfv wcel vy cv con0 wcel vx cv vy
      cv cr1 cfv wcel vx cv cA wcel vx cv cF cA cima cuni csuc cr1 cfv wcel vy
      cv con0 wcel vx cv vy cv cr1 cfv wcel wa vx cv cA wcel wa vx cv cF cfv
      cr1 cfv cF cA cima cuni csuc cr1 cfv vx cv vy cv con0 wcel vx cv vy cv
      cr1 cfv wcel wa vx cv cA wcel vx cv cF cfv cr1 cfv cF cA cima cuni csuc
      cr1 cfv wss vy cv con0 wcel vx cv vy cv cr1 cfv wcel wa vx cv cA wcel vx
      cv cF cfv cF cA cima wcel vx cv cF cfv cr1 cfv cF cA cima cuni csuc cr1
      cfv wss cF wfun vx cv cF cdm wcel vx cv cA wcel vx cv cF cfv cF cA cima
      wcel wi vy cv con0 wcel vx cv vy cv cr1 cfv wcel wa cA vx cv cF funfvima
      cF wfun vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab
      wfun vz vw vz cv vv cv cr1 cfv wcel vv con0 crab cint funopabeq cF vw cv
      vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab wceq cF wfun
      vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab wfun wb
      tz9.12lem.2 cF vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz
      vw copab funeq ax-mp mpbir vy cv con0 wcel vx cv vy cv cr1 cfv wcel wa vx
      cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv cF cdm wcel vy cv con0
      wcel vx cv vy cv cr1 cfv wcel wa vx cv vv cv cr1 cfv wcel vv con0 wrex vx
      cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv vv cv cr1 cfv wcel vx cv
      vy cv cr1 cfv wcel vv vy cv con0 vv cv vy cv wceq vv cv cr1 cfv vy cv cr1
      cfv vx cv vv cv vy cv cr1 fveq2 eleq2d rcla4ev vx cv vv cv cr1 cfv wcel
      vv con0 rabn0 sylibr vx cv cF cdm wcel vx cv vv cv cr1 cfv wcel vv con0
      crab cint cvv wcel vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv vy
      cv cop cF wcel vy wex vy cv vx cv vv cv cr1 cfv wcel vv con0 crab cint
      wceq vy wex vx cv cF cdm wcel vx cv vv cv cr1 cfv wcel vv con0 crab cint
      cvv wcel vx cv vy cv cop cF wcel vy cv vx cv vv cv cr1 cfv wcel vv con0
      crab cint wceq vy vx cv vy cv cop cF wcel vx cv vy cv cop vw cv vz cv vv
      cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab wcel vy cv vx cv vv cv
      cr1 cfv wcel vv con0 crab cint wceq cF vw cv vz cv vv cv cr1 cfv wcel vv
      con0 crab cint wceq vz vw copab vx cv vy cv cop tz9.12lem.2 eleq2i vw cv
      vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vw cv vx cv vv cv cr1 cfv
      wcel vv con0 crab cint wceq vy cv vx cv vv cv cr1 cfv wcel vv con0 crab
      cint wceq vz vw vx cv vy cv vx visset vy visset vz cv vx cv wceq vz cv vv
      cv cr1 cfv wcel vv con0 crab cint vx cv vv cv cr1 cfv wcel vv con0 crab
      cint vw cv vz cv vx cv wceq vz cv vv cv cr1 cfv wcel vv con0 crab vx cv
      vv cv cr1 cfv wcel vv con0 crab vz cv vx cv wceq vz cv vv cv cr1 cfv wcel
      vx cv vv cv cr1 cfv wcel vv con0 vz cv vx cv vv cv cr1 cfv eleq1 rabbisdv
      inteqd eqeq2d vw cv vy cv vx cv vv cv cr1 cfv wcel vv con0 crab cint
      eqeq1 opelopab bitri exbii vy vx cv cF vx visset eldm2 vy vx cv vv cv cr1
      cfv wcel vv con0 crab cint isset 3bitr4i vx cv vv cv cr1 cfv wcel vv con0
      crab intex bitr4i sylibr sylancr vx cv cF cfv cF cA cima wcel vx cv cF
      cfv cF cA cima cuni csuc wcel vx cv cF cfv cr1 cfv cF cA cima cuni csuc
      cr1 cfv wss cF cA cima cF cA cima cuni csuc vx cv cF cfv cF cA cima con0
      wss cF cA cima cF cA cima cuni csuc wss vz vw vv cA cF tz9.12lem.1
      tz9.12lem.2 tz9.12lem1 cF cA cima onsucuni ax-mp sseli cF cA cima cuni
      csuc con0 wcel vx cv cF cfv cF cA cima cuni csuc wcel vx cv cF cfv cr1
      cfv cF cA cima cuni csuc cr1 cfv wss wi vz vw vv cA cF tz9.12lem.1
      tz9.12lem.2 tz9.12lem2 vx cv cF cfv cF cA cima cuni csuc r1ord2 ax-mp syl
      syl6 imp vy cv con0 wcel vx cv vy cv cr1 cfv wcel wa vx cv vx cv cF cfv
      cr1 cfv wcel vx cv cA wcel vy cv con0 wcel vx cv vy cv cr1 cfv wcel wa vx
      cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv cF cfv vx cv vv cv cr1
      cfv wcel vv con0 crab wcel vx cv vx cv cF cfv cr1 cfv wcel vy cv con0
      wcel vx cv vy cv cr1 cfv wcel wa vx cv vv cv cr1 cfv wcel vv con0 wrex vx
      cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv vv cv cr1 cfv wcel vx cv
      vy cv cr1 cfv wcel vv vy cv con0 vv cv vy cv wceq vv cv cr1 cfv vy cv cr1
      cfv vx cv vv cv vy cv cr1 fveq2 eleq2d rcla4ev vx cv vv cv cr1 cfv wcel
      vv con0 rabn0 sylibr vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv
      cF cfv vx cv vv cv cr1 cfv wcel vv con0 crab cint vx cv vv cv cr1 cfv
      wcel vv con0 crab vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv vv
      cv cr1 cfv wcel vv con0 crab cint cvv wcel vx cv cF cfv vx cv vv cv cr1
      cfv wcel vv con0 crab cint wceq vx cv vv cv cr1 cfv wcel vv con0 crab
      intex vx cv vv cv cr1 cfv wcel vv con0 crab cint cvv wcel vx cv vw cv vz
      cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab cfv vx cv vv cv
      cr1 cfv wcel vv con0 crab cint vx cv cF cfv vx cv cvv wcel vx cv vv cv
      cr1 cfv wcel vv con0 crab cint cvv wcel vx cv vw cv vz cv vv cv cr1 cfv
      wcel vv con0 crab cint wceq vz vw copab cfv vx cv vv cv cr1 cfv wcel vv
      con0 crab cint wceq vx visset vz vw vx cv vz cv vv cv cr1 cfv wcel vv
      con0 crab cint vx cv vv cv cr1 cfv wcel vv con0 crab cint cvv cvv vz cv
      vx cv wceq vz cv vv cv cr1 cfv wcel vv con0 crab vx cv vv cv cr1 cfv wcel
      vv con0 crab vz cv vx cv wceq vz cv vv cv cr1 cfv wcel vx cv vv cv cr1
      cfv wcel vv con0 vz cv vx cv vv cv cr1 cfv eleq1 rabbisdv inteqd fvopabg
      mpan vx cv cF vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw
      copab tz9.12lem.2 fveq1i syl5eq sylbi vx cv vv cv cr1 cfv wcel vv con0
      crab con0 wss vx cv vv cv cr1 cfv wcel vv con0 crab c0 wne vx cv vv cv
      cr1 cfv wcel vv con0 crab cint vx cv vv cv cr1 cfv wcel vv con0 crab wcel
      vx cv vv cv cr1 cfv wcel vv con0 ssrab2 vx cv vv cv cr1 cfv wcel vv con0
      crab onint mpan eqeltrd vx cv cF cfv vx cv vv cv cr1 cfv wcel vv con0
      crab wcel vx cv cF cfv con0 wcel vx cv vx cv cF cfv cr1 cfv wcel vx cv vv
      cv cr1 cfv wcel vx cv vx cv cF cfv cr1 cfv wcel vv vy vx cv cF cfv con0
      vv vy vx cv cF vv vy cF vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint
      wceq vz vw copab tz9.12lem.2 vw cv vz cv vv cv cr1 cfv wcel vv con0 crab
      cint wceq vz vw vv vy vv vw vz cv vv cv cr1 cfv wcel vv con0 crab cint vv
      vw vz cv vv cv cr1 cfv wcel vv con0 crab vz cv vv cv cr1 cfv wcel vv vw
      con0 hbrab1 hbint hbeleq hbopab hbxfr vy cv vx cv wcel vv ax-17 hbfv vy
      cv con0 wcel vv ax-17 vv vy vy vx cv vx cv cF cfv cr1 cfv vy cv vx cv
      wcel vv ax-17 vv vy vx cv cF cfv cr1 vy cv cr1 wcel vv ax-17 vv vy vx cv
      cF vv vy cF vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw
      copab tz9.12lem.2 vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq
      vz vw vv vy vv vw vz cv vv cv cr1 cfv wcel vv con0 crab cint vv vw vz cv
      vv cv cr1 cfv wcel vv con0 crab vz cv vv cv cr1 cfv wcel vv vw con0
      hbrab1 hbint hbeleq hbopab hbxfr vy cv vx cv wcel vv ax-17 hbfv hbfv hbel
      vv cv vx cv cF cfv wceq vv cv cr1 cfv vx cv cF cfv cr1 cfv vx cv vv cv vx
      cv cF cfv cr1 fveq2 eleq2d elrabf pm3.27bi 3syl adantr sseldd exp31 com3r
      r19.23adv r19.20i cA cF cA cima cuni csuc csuc cr1 cfv wcel cA cF cA cima
      cuni csuc cr1 cfv cpw wcel cA cF cA cima cuni csuc cr1 cfv wss vx cv cF
      cA cima cuni csuc cr1 cfv wcel vx cA wral cF cA cima cuni csuc csuc cr1
      cfv cF cA cima cuni csuc cr1 cfv cpw cA cF cA cima cuni csuc con0 wcel cF
      cA cima cuni csuc csuc cr1 cfv cF cA cima cuni csuc cr1 cfv cpw wceq vz
      vw vv cA cF tz9.12lem.1 tz9.12lem.2 tz9.12lem2 cF cA cima cuni csuc r1suc
      ax-mp eleq2i cA cF cA cima cuni csuc cr1 cfv tz9.12lem.1 elpw vx cA cF cA
      cima cuni csuc cr1 cfv dfss3 3bitri sylibr $.
      $( [22-Sep-2003] $)
  $}

  ${
    $d x y z w v A $.
    tz9.12.1 $e |- A e. _V $.
    $( A set is well-founded if all of its elements are well-founded.
       Proposition 9.12 of [TakeutiZaring] p. 78.  The main proof consists
       of ~ tz9.12lem1 through ~ tz9.12lem3 . $)
    tz9.12 $p |- ( A. x e. A E. y e. On x e. ( R1 ` y ) ->
              E. y e. On A e. ( R1 ` y ) ) $=
      vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab cA cima
      cuni csuc csuc con0 wcel cA vw cv vz cv vv cv cr1 cfv wcel vv con0 crab
      cint wceq vz vw copab cA cima cuni csuc csuc cr1 cfv wcel cA vy cv cr1
      cfv wcel vy con0 wrex vx cv vy cv cr1 cfv wcel vy con0 wrex vx cA wral cA
      vy cv cr1 cfv wcel cA vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint
      wceq vz vw copab cA cima cuni csuc csuc cr1 cfv wcel vy vw cv vz cv vv cv
      cr1 cfv wcel vv con0 crab cint wceq vz vw copab cA cima cuni csuc csuc
      con0 vy cv vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw
      copab cA cima cuni csuc csuc wceq vy cv cr1 cfv vw cv vz cv vv cv cr1 cfv
      wcel vv con0 crab cint wceq vz vw copab cA cima cuni csuc csuc cr1 cfv cA
      vy cv vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab
      cA cima cuni csuc csuc cr1 fveq2 eleq2d rcla4ev vw cv vz cv vv cv cr1 cfv
      wcel vv con0 crab cint wceq vz vw copab cA cima cuni csuc vz vw vv cA vw
      cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab tz9.12.1
      vw cv vz cv vv cv cr1 cfv wcel vv con0 crab cint wceq vz vw copab eqid
      tz9.12lem2 onsuci vx vy vz vw vv cA vw cv vz cv vv cv cr1 cfv wcel vv
      con0 crab cint wceq vz vw copab tz9.12.1 vw cv vz cv vv cv cr1 cfv wcel
      vv con0 crab cint wceq vz vw copab eqid tz9.12lem3 sylancr $.
      $( [22-Sep-2003] $)
  $}

  ${
    $d x y z w A $.
    tz9.13.1 $e |- A e. _V $.
    $( Every set is well-founded, assuming the Axiom of Regularity.  In other
       words, every set belongs to a layer of the cumulative hierarchy of sets.
       Proposition 9.13 of [TakeutiZaring] p. 78. $)
    tz9.13 $p |- E. x e. On A e. ( R1 ` x ) $=
      cA vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab wcel cA vx cv cr1 cfv
      wcel vx con0 wrex cA cvv vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab
      tz9.13.1 vz cv vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab wss vz cv vy
      cv vx cv cr1 cfv wcel vx con0 wrex vy cab wcel wi vy cv vx cv cr1 cfv
      wcel vx con0 wrex vy cab cvv wceq vz vz vy cv vx cv cr1 cfv wcel vx con0
      wrex vy cab setind vz cv vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab wss
      vz cv vx cv cr1 cfv wcel vx con0 wrex vz cv vy cv vx cv cr1 cfv wcel vx
      con0 wrex vy cab wcel vz cv vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab
      wss vw cv vx cv cr1 cfv wcel vx con0 wrex vw vz cv wral vz cv vx cv cr1
      cfv wcel vx con0 wrex vz cv vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab
      wss vw cv vx cv cr1 cfv wcel vx con0 wrex vw vz cv vz cv vy cv vx cv cr1
      cfv wcel vx con0 wrex vy cab wss vw cv vz cv wcel vw cv vy cv vx cv cr1
      cfv wcel vx con0 wrex vy cab wcel vw cv vx cv cr1 cfv wcel vx con0 wrex
      vz cv vy cv vx cv cr1 cfv wcel vx con0 wrex vy cab vw cv ssel vy cv vx cv
      cr1 cfv wcel vx con0 wrex vw cv vx cv cr1 cfv wcel vx con0 wrex vy vw cv
      vw visset vy cv vw cv wceq vy cv vx cv cr1 cfv wcel vw cv vx cv cr1 cfv
      wcel vx con0 vy cv vw cv vx cv cr1 cfv eleq1 rexbidv elab syl6ib
      r19.21aiv vw vx vz cv vz visset tz9.12 syl vy cv vx cv cr1 cfv wcel vx
      con0 wrex vz cv vx cv cr1 cfv wcel vx con0 wrex vy vz cv vz visset vy cv
      vz cv wceq vy cv vx cv cr1 cfv wcel vz cv vx cv cr1 cfv wcel vx con0 vy
      cv vz cv vx cv cr1 cfv eleq1 rexbidv elab sylibr mpg eleqtrri vy cv vx cv
      cr1 cfv wcel vx con0 wrex cA vx cv cr1 cfv wcel vx con0 wrex vy cA
      tz9.13.1 vy cv cA wceq vy cv vx cv cr1 cfv wcel cA vx cv cr1 cfv wcel vx
      con0 vy cv cA vx cv cr1 cfv eleq1 rexbidv elab mpbi $.
      $( [23-Sep-2003] $)
  $}

  ${
    $d x y A $.
    $( Every set is well-founded, assuming the Axiom of Regularity.
       Proposition 9.13 of [TakeutiZaring] p. 78.  This variant of ~ tz9.13
       expresses the class existence requirement as an antecedent. $)
    tz9.13g $p |- ( A e. B -> E. x e. On A e. ( R1 ` x ) ) $=
      vy cv vx cv cr1 cfv wcel vx con0 wrex cA vx cv cr1 cfv wcel vx con0 wrex
      vy cA cB vy cv cA wceq vy cv vx cv cr1 cfv wcel cA vx cv cr1 cfv wcel vx
      con0 vy cv cA wceq vx ax-17 vy cv cA vx cv cr1 cfv eleq1 rexbid vx vy cv
      vy visset tz9.13 vtoclg $.
      $( [4-Oct-2003] $) $( [4-Oct-2003] $)
  $}

  ${
    $d x A $.
    $( Every set is well-founded, assuming the Axiom of Regularity.
       Proposition 9.13 of [TakeutiZaring] p. 78.  This variant of
       ~ tz9.13g is useful in proofs of theorems about the rank function. $)
    rankwflem $p |- ( A e. B -> E. x e. On A e. ( R1 ` suc x ) ) $=
      cA cB wcel cA vx cv cr1 cfv wcel vx con0 wrex cA vx cv csuc cr1 cfv wcel
      vx con0 wrex vx cA cB tz9.13g cA vx cv cr1 cfv wcel cA vx cv csuc cr1 cfv
      wcel vx con0 vx cv con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv cA vx cv
      con0 wcel vx cv csuc con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv wss vx cv
      suceloni vx cv csuc con0 wcel vx cv vx cv csuc wcel vx cv cr1 cfv vx cv
      csuc cr1 cfv wss vx cv vx visset sucid vx cv vx cv csuc r1ord2 mpi syl
      sseld r19.22i syl $.
      $( [4-Oct-2003] $) $( [4-Oct-2003] $)
  $}

  ${
    $d x y $.
    $( Every set belongs to some value of the cumulative hierarchy of sets
       function ` R1 ` , i.e. the indexed union of all values of ` R1 ` is the
       universe.  Lemma 9.3 of [Jech] p. 71. $)
    jech9.3 $p |- U_ x e. On ( R1 ` x ) = _V $=
      vy vx con0 vx cv cr1 cfv ciun cvv vy cv vx con0 vx cv cr1 cfv ciun wcel
      vy cv cvv wcel vy cv vx con0 vx cv cr1 cfv ciun wcel vy cv vx cv cr1 cfv
      wcel vx con0 wrex vx vy cv vy visset tz9.13 vx vy cv con0 vx cv cr1 cfv
      eliun mpbir vy visset 2th eqriv $.
      $( [12-Oct-2003] $) $( [4-Oct-2003] $)

    $( The cumulative hierarchy of sets covers the universe.  Proposition 4.45
       (b) to (a) of [Mendelson] p. 281. $)
    unir1 $p |- U. ( R1 " On ) = _V $=
      cr1 con0 cima cuni cr1 crn cuni vx con0 vx cv cr1 cfv ciun cvv cr1 con0
      cima cr1 crn cr1 cr1 cdm cima cr1 con0 cima cr1 crn cr1 cdm con0 cr1 cr1
      con0 wfn cr1 cdm con0 wceq r1fnon con0 cr1 fndm ax-mp imaeq2i cr1 imadmrn
      eqtr3i unieqi cr1 con0 wfn vx con0 vx cv cr1 cfv ciun cr1 crn cuni wceq
      r1fnon vx con0 cr1 fniunfv ax-mp vx jech9.3 3eqtr2i $.
      $( [16-Nov-2004] $) $( [27-Sep-2004] $)
  $}

  ${
    $d x y z A $.
    rankval.1 $e |- A e. _V $.
    $( Value of the rank function.  Definition 9.14 of [TakeutiZaring]
       p. 79 (proved as a theorem from our definition). $)
    rankval $p |- ( rank ` A ) = |^| { x e. On | A e. ( R1 ` suc x ) } $=
      cA crnk cfv cA vz cv vy cv vx cv csuc cr1 cfv wcel vx con0 crab cint wceq
      vy vz copab cfv cA vx cv csuc cr1 cfv wcel vx con0 crab cint cA crnk vz
      cv vy cv vx cv csuc cr1 cfv wcel vx con0 crab cint wceq vy vz copab vy vz
      vx df-rank fveq1i vy vz cA vy cv vx cv csuc cr1 cfv wcel vx con0 crab
      cint cA vx cv csuc cr1 cfv wcel vx con0 crab cint rankval.1 cA vx cv csuc
      cr1 cfv wcel vx con0 crab c0 wne cA vx cv csuc cr1 cfv wcel vx con0 crab
      cint cvv wcel cA vx cv csuc cr1 cfv wcel vx con0 crab c0 wne cA vx cv
      csuc cr1 cfv wcel vx con0 wrex cA cvv wcel cA vx cv csuc cr1 cfv wcel vx
      con0 wrex rankval.1 vx cA cvv rankwflem ax-mp cA vx cv csuc cr1 cfv wcel
      vx con0 rabn0 mpbir cA vx cv csuc cr1 cfv wcel vx con0 crab intex mpbi vy
      cv cA wceq vy cv vx cv csuc cr1 cfv wcel vx con0 crab cA vx cv csuc cr1
      cfv wcel vx con0 crab vy cv cA wceq vy cv vx cv csuc cr1 cfv wcel cA vx
      cv csuc cr1 cfv wcel vx con0 vy cv cA vx cv csuc cr1 cfv eleq1 rabbisdv
      inteqd fvopab eqtri $.
      $( [24-Sep-2003] $)
  $}

  ${
    $d x y A $.
    $( Value of the rank function.  Definition 9.14 of [TakeutiZaring]
       p. 79 (proved as a theorem from our definition).  This
       variant of ~ rankval expresses the class existence requirement as an
       antecedent instead of a hypothesis. $)
    rankvalg $p |- ( A e. B ->
                   ( rank ` A ) = |^| { x e. On | A e. ( R1 ` suc x ) } ) $=
      vy cv crnk cfv vy cv vx cv csuc cr1 cfv wcel vx con0 crab cint wceq cA
      crnk cfv cA vx cv csuc cr1 cfv wcel vx con0 crab cint wceq vy cA cB vy cv
      cA wceq vy cv crnk cfv cA crnk cfv vy cv vx cv csuc cr1 cfv wcel vx con0
      crab cint cA vx cv csuc cr1 cfv wcel vx con0 crab cint vy cv cA crnk
      fveq2 vy cv cA wceq vy cv vx cv csuc cr1 cfv wcel vx con0 crab cA vx cv
      csuc cr1 cfv wcel vx con0 crab vy cv cA wceq vy cv vx cv csuc cr1 cfv
      wcel cA vx cv csuc cr1 cfv wcel vx con0 vy cv cA vx cv csuc cr1 cfv eleq1
      rabbisdv inteqd eqeq12d vx vy cv vy visset rankval vtoclg $.
      $( [5-Oct-2003] $) $( [5-Oct-2003] $)

    $( Value of an alternate definition of the rank function.  Definition of
       [BellMachover] p. 478. $)
    rankval2 $p |- ( A e. B ->
                   ( rank ` A ) = |^| { x e. On | A C_ ( R1 ` x ) } ) $=
      cA cB wcel cA crnk cfv cA vx cv csuc cr1 cfv wcel vx con0 crab cint cA vx
      cv cr1 cfv wss vx con0 crab cint vx cA cB rankvalg cA vx cv csuc cr1 cfv
      wcel vx con0 crab cA vx cv cr1 cfv wss vx con0 crab cA vx cv csuc cr1 cfv
      wcel cA vx cv cr1 cfv wss vx con0 vx cv con0 wcel cA vx cv csuc cr1 cfv
      wcel cA vx cv cr1 cfv cpw wcel cA vx cv cr1 cfv wss vx cv con0 wcel vx cv
      csuc cr1 cfv vx cv cr1 cfv cpw cA vx cv r1suc eleq2d cA vx cv cr1 cfv vx
      cv cr1 fvex elpw2 syl6bb rabbii inteqi syl6eq $.
      $( [8-Oct-2003] $) $( [8-Oct-2003] $)
  $}

  ${
    $d x A $.
    $( The rank of a set is an ordinal number.  Proposition 9.15(1) of
       [TakeutiZaring] p. 79. $)
    rankon $p |- ( rank ` A ) e. On $=
      cA cvv wcel cA crnk cfv con0 wcel cA cvv wcel cA crnk cfv cA vx cv csuc
      cr1 cfv wcel vx con0 crab cint con0 vx cA cvv rankvalg cA vx cv csuc cr1
      cfv wcel vx con0 crab con0 wss cA vx cv csuc cr1 cfv wcel vx con0 crab c0
      wne cA vx cv csuc cr1 cfv wcel vx con0 crab cint con0 wcel cA cvv wcel cA
      vx cv csuc cr1 cfv wcel vx con0 crab oninton cA vx cv csuc cr1 cfv wcel
      vx con0 ssrab2 cA cvv wcel cA vx cv csuc cr1 cfv wcel vx con0 wrex cA vx
      cv csuc cr1 cfv wcel vx con0 crab c0 wne vx cA cvv rankwflem cA vx cv
      csuc cr1 cfv wcel vx con0 rabn0 sylibr sylancr eqeltrd cA cvv wcel wn cA
      crnk cfv c0 con0 cA crnk fvprc 0elon syl6eqel pm2.61i $.
      $( [5-Oct-2003] $) $( [5-Oct-2003] $)
  $}

  ${
    $d x y A $.
    rankid.1 $e |- A e. _V $.
    $( Identity law for the rank function. $)
    rankid $p |- A e. ( R1 ` suc ( rank ` A ) ) $=
      cA cA vx cv csuc cr1 cfv wcel vx con0 crab cint csuc cr1 cfv cA crnk cfv
      csuc cr1 cfv cA vx cv csuc cr1 cfv wcel vx con0 wrex cA cA vx cv csuc cr1
      cfv wcel vx con0 crab cint csuc cr1 cfv wcel cA cvv wcel cA vx cv csuc
      cr1 cfv wcel vx con0 wrex rankid.1 vx cA cvv rankwflem ax-mp cA vx cv
      csuc cr1 cfv wcel cA cA vx cv csuc cr1 cfv wcel vx con0 crab cint csuc
      cr1 cfv wcel vx vx vy vy cA cA vx cv csuc cr1 cfv wcel vx con0 crab cint
      csuc cr1 cfv vy cv cA wcel vx ax-17 vx vy cA vx cv csuc cr1 cfv wcel vx
      con0 crab cint csuc cr1 vy cv cr1 wcel vx ax-17 vx vy cA vx cv csuc cr1
      cfv wcel vx con0 crab cint vx vy cA vx cv csuc cr1 cfv wcel vx con0 crab
      cA vx cv csuc cr1 cfv wcel vx vy con0 hbrab1 hbint hbsuc hbfv hbel vx cv
      cA vx cv csuc cr1 cfv wcel vx con0 crab cint wceq vx cv csuc cr1 cfv cA
      vx cv csuc cr1 cfv wcel vx con0 crab cint csuc cr1 cfv cA vx cv cA vx cv
      csuc cr1 cfv wcel vx con0 crab cint wceq vx cv csuc cA vx cv csuc cr1 cfv
      wcel vx con0 crab cint csuc cr1 vx cv cA vx cv csuc cr1 cfv wcel vx con0
      crab cint suceq fveq2d eleq2d onminsb ax-mp cA crnk cfv csuc cA vx cv
      csuc cr1 cfv wcel vx con0 crab cint csuc cr1 cA crnk cfv cA vx cv csuc
      cr1 cfv wcel vx con0 crab cint wceq cA crnk cfv csuc cA vx cv csuc cr1
      cfv wcel vx con0 crab cint csuc wceq vx cA rankid.1 rankval cA crnk cfv
      cA vx cv csuc cr1 cfv wcel vx con0 crab cint suceq ax-mp fveq2i eleqtrri
      $.
      $( [4-Oct-2003] $) $( [3-Oct-2003] $)
  $}

  ${
    rankr1lem.1 $e |- A e. _V $.
    $( Lemma for ~ rankr1 . $)
    rankr1lem $p |- ( B e. On ->
                    ( -. A e. ( R1 ` B ) -> B C_ ( rank ` A ) ) ) $=
      cB con0 wcel cA cB cr1 cfv wcel wn cB cA crnk cfv csuc wcel cB cA crnk
      cfv wss cB con0 wcel cB cA crnk cfv csuc wcel cA cB cr1 cfv wcel cB con0
      wcel cB cA crnk cfv csuc wcel wn cA crnk cfv csuc cB wss cA cB cr1 cfv
      wcel cA crnk cfv csuc con0 wcel cB con0 wcel cA crnk cfv csuc cB wss cB
      cA crnk cfv csuc wcel wn wb cA crnk cfv cA rankon onsuci cA crnk cfv csuc
      cB ontri1 mpan cB con0 wcel cA crnk cfv csuc cB wss cA cA crnk cfv csuc
      cr1 cfv wcel cA cB cr1 cfv wcel cA rankr1lem.1 rankid cB con0 wcel cA
      crnk cfv csuc cB wss cA crnk cfv csuc cr1 cfv cB cr1 cfv wss cA cA crnk
      cfv csuc cr1 cfv wcel cA cB cr1 cfv wcel wi cA crnk cfv csuc con0 wcel cB
      con0 wcel cA crnk cfv csuc cB wss cA crnk cfv csuc cr1 cfv cB cr1 cfv wss
      wi cA crnk cfv cA rankon onsuci cA crnk cfv csuc cB r1ord3 mpan cA crnk
      cfv csuc cr1 cfv cB cr1 cfv cA ssel syl6 mpii sylbird con1d cB con0 wcel
      cA crnk cfv con0 wcel cB cA crnk cfv wss cB cA crnk cfv csuc wcel wb cA
      rankon cB cA crnk cfv onsssuc mpan2 sylibrd $.
      $( [6-Oct-2003] $) $( [6-Oct-2003] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    rankr1.1 $e |- A e. _V $.
    $( A relationship between the rank function and the cumulative hierarchy
       of sets function ` R1 ` .  Proposition 9.15(2) of [TakeutiZaring]
       p. 79. $)
    rankr1 $p |- ( B = ( rank ` A ) <->
                 ( -. A e. ( R1 ` B ) /\ A e. ( R1 ` suc B ) ) ) $=
      cB cA crnk cfv wceq cA cB cr1 cfv wcel wn cA cB csuc cr1 cfv wcel wa cB
      cA crnk cfv wceq cA cB cr1 cfv wcel wn cA cB csuc cr1 cfv wcel cB con0
      wcel cB cA crnk cfv wceq cA cB cr1 cfv wcel wn cB cA crnk cfv wceq cB
      con0 wcel cA crnk cfv con0 wcel cA rankon cB cA crnk cfv con0 eleq1
      mpbiri cB con0 wcel cB word cB cA crnk cfv wceq cA cB cr1 cfv wcel wn wi
      cB eloni cB word cB c0 wceq cB vx cv csuc wceq vx con0 wrex cB wlim w3o
      cB cA crnk cfv wceq cA cB cr1 cfv wcel wn wi vx cB ordzsl cB c0 wceq cB
      cA crnk cfv wceq cA cB cr1 cfv wcel wn wi cB vx cv csuc wceq vx con0 wrex
      cB wlim cB c0 wceq cA cB cr1 cfv wcel wn cB cA crnk cfv wceq cB c0 wceq
      cA cB cr1 cfv wcel cA c0 wcel cA noel cB c0 wceq cB cr1 cfv c0 cA cB c0
      wceq cB cr1 cfv c0 cr1 cfv c0 cB c0 cr1 fveq2 r10 syl6eq eleq2d mtbiri
      a1d cB vx cv csuc wceq cB cA crnk cfv wceq cA cB cr1 cfv wcel wn wi vx
      con0 vx cv con0 wcel cB vx cv csuc wceq cB cA crnk cfv wceq cA cB cr1 cfv
      wcel wn vx cv con0 wcel cB vx cv csuc wceq wa cB cA crnk cfv wceq wa cA
      cB cr1 cfv wcel cB vx cv wss vx cv con0 wcel cB vx cv csuc wceq wa cB vx
      cv wss wn cB cA crnk cfv wceq vx cv con0 wcel cB vx cv csuc wceq wa vx cv
      cB wcel cB vx cv wss wn cB vx cv csuc wceq vx cv cB wcel vx cv con0 wcel
      cB vx cv csuc wceq vx cv cB wcel vx cv vx cv csuc wcel vx cv vx visset
      sucid cB vx cv csuc vx cv eleq2 mpbiri adantl cB con0 wcel vx cv con0
      wcel vx cv cB wcel cB vx cv wss wn wb vx cv con0 wcel cB vx cv csuc wceq
      wa cB con0 wcel vx cv con0 wcel wa cB vx cv wss vx cv cB wcel cB vx cv
      ontri1 con2bid vx cv csuc con0 wcel cB vx cv csuc wceq cB con0 wcel vx cv
      con0 wcel vx cv csuc con0 wcel cB vx cv csuc wceq cB con0 wcel vx cv csuc
      con0 cB eleq1a imp vx cv suceloni sylan vx cv con0 wcel cB vx cv csuc
      wceq pm3.26 sylanc mpbid adantr vx cv con0 wcel cB vx cv csuc wceq cB cA
      crnk cfv wceq cA cB cr1 cfv wcel cB vx cv wss wi cB cA crnk cfv wceq vx
      cv con0 wcel cB vx cv csuc wceq cA cB cr1 cfv wcel cB vx cv wss wi cB cA
      crnk cfv wceq vx cv con0 wcel cB vx cv csuc wceq cA cB cr1 cfv wcel cB vx
      cv wss cB cA crnk cfv wceq vx cv con0 wcel cA vx cv csuc cr1 cfv wcel cB
      vx cv wss cB vx cv csuc wceq cA cB cr1 cfv wcel wa cB cA crnk cfv wceq cB
      vx cv wss cA vy cv csuc cr1 cfv wcel vy con0 crab cint vx cv wss vx cv
      con0 wcel cA vx cv csuc cr1 cfv wcel wa cB cA crnk cfv wceq cB cA vy cv
      csuc cr1 cfv wcel vy con0 crab cint vx cv cB cA crnk cfv wceq cB cA vy cv
      csuc cr1 cfv wcel vy con0 crab cint wceq cA crnk cfv cA vy cv csuc cr1
      cfv wcel vy con0 crab cint cB vy cA rankr1.1 rankval eqeq2i biimpi sseq1d
      vx cv con0 wcel cA vx cv csuc cr1 cfv wcel cA vy cv csuc cr1 cfv wcel vy
      con0 crab cint vx cv wss cA vy cv csuc cr1 cfv wcel cA vx cv csuc cr1 cfv
      wcel vy vx cv vy cv vx cv wceq vy cv csuc cr1 cfv vx cv csuc cr1 cfv cA
      vy cv vx cv wceq vy cv csuc vx cv csuc cr1 vy cv vx cv suceq fveq2d
      eleq2d onintss imp syl5bir cB vx cv csuc wceq cA cB cr1 cfv wcel cA vx cv
      csuc cr1 cfv wcel cB vx cv csuc wceq cB cr1 cfv vx cv csuc cr1 cfv cA cB
      vx cv csuc cr1 fveq2 eleq2d biimpa sylan2i exp4d com3l imp31 mtod exp31
      r19.23aiv cB cA crnk cfv wceq cB wlim cA cB cr1 cfv wcel wn cB cA crnk
      cfv wceq cB wlim wa cA cB cr1 cfv wcel cA vx cv cr1 cfv wcel vx cB wrex
      cB cA crnk cfv wceq cA vx cv cr1 cfv wcel vx cB wrex wn cB wlim cA vx cv
      cr1 cfv wcel vx cB wrex cB cA crnk cfv wceq cA vx cv cr1 cfv wcel cB cA
      crnk cfv wceq wn vx cB cA vx cv cr1 cfv wcel vx cv cB wcel cB cA crnk cfv
      wceq wn vx cv cB wcel cA vx cv cr1 cfv wcel cB cA crnk cfv wceq vx cv cB
      wcel wn wi vx cv cB wcel cB cA crnk cfv wceq wn wi cB cA crnk cfv wceq vx
      cv cB wcel cA vx cv cr1 cfv wcel vx cv cB wcel wn cB cA crnk cfv wceq vx
      cv cB wcel cB cA crnk cfv wceq vx cv con0 wcel wa cA vx cv cr1 cfv wcel
      vx cv cB wcel wn wi cB cA crnk cfv wceq vx cv cB wcel vx cv con0 wcel cB
      cA crnk cfv wceq vx cv cB wcel vx cv cA crnk cfv wcel vx cv con0 wcel cB
      cA crnk cfv vx cv eleq2 cA crnk cfv vx cv cA rankon oneli syl6bi anc2li
      cB cA crnk cfv wceq vx cv con0 wcel wa cA vx cv cr1 cfv wcel cB vx cv wss
      vx cv cB wcel wn vx cv con0 wcel cA vx cv cr1 cfv wcel cA crnk cfv vx cv
      wss cB cA crnk cfv wceq cB vx cv wss vx cv con0 wcel cA vx cv cr1 cfv
      wcel cA vx cv csuc cr1 cfv wcel cA crnk cfv vx cv wss vx cv con0 wcel vx
      cv cr1 cfv vx cv csuc cr1 cfv cA vx cv con0 wcel vx cv csuc con0 wcel vx
      cv cr1 cfv vx cv csuc cr1 cfv wss vx cv suceloni vx cv csuc con0 wcel vx
      cv vx cv csuc wcel vx cv cr1 cfv vx cv csuc cr1 cfv wss vx cv vx visset
      sucid vx cv vx cv csuc r1ord2 mpi syl sseld vx cv con0 wcel cA vx cv csuc
      cr1 cfv wcel cA vy cv csuc cr1 cfv wcel vy con0 crab cint vx cv wss cA
      crnk cfv vx cv wss cA vy cv csuc cr1 cfv wcel cA vx cv csuc cr1 cfv wcel
      vy vx cv vy cv vx cv wceq vy cv csuc cr1 cfv vx cv csuc cr1 cfv cA vy cv
      vx cv wceq vy cv csuc vx cv csuc cr1 vy cv vx cv suceq fveq2d eleq2d
      onintss cA crnk cfv cA vy cv csuc cr1 cfv wcel vy con0 crab cint vx cv vy
      cA rankr1.1 rankval sseq1i syl6ibr syld cB cA crnk cfv wceq cB vx cv wss
      cA crnk cfv vx cv wss cB cA crnk cfv vx cv sseq1 biimprd sylan9r cB con0
      wcel vx cv con0 wcel cB vx cv wss vx cv cB wcel wn wb cB cA crnk cfv wceq
      cB vx cv ontri1 cB cA crnk cfv wceq cB con0 wcel cA crnk cfv con0 wcel cA
      rankon cB cA crnk cfv con0 eleq1 mpbiri sylan sylibd syl6 com3l cB cA
      crnk cfv wceq vx cv cB wcel con2 syl6 pm2.43a r19.23aiv con2i adantr cB
      cA crnk cfv wceq cB wlim wa cA cB cr1 cfv wcel cA vx cB vx cv cr1 cfv
      ciun wcel cA vx cv cr1 cfv wcel vx cB wrex cB cA crnk cfv wceq cB wlim wa
      cB cr1 cfv vx cB vx cv cr1 cfv ciun cA cB cvv wcel cB wlim cB cr1 cfv vx
      cB vx cv cr1 cfv ciun wceq cB cA crnk cfv wceq vx cB cvv r1lim cB cA crnk
      cfv wceq cB cvv wcel cA crnk cfv cvv wcel cA crnk fvex cB cA crnk cfv cvv
      eleq1 mpbiri sylan eleq2d vx cA cB vx cv cr1 cfv eliun syl6bb mtbird
      expcom 3jaoi sylbi syl mpcom cB cA crnk cfv wceq cB cA vy cv csuc cr1 cfv
      wcel vy con0 crab wcel cA cB csuc cr1 cfv wcel cB cA crnk cfv wceq cB cA
      vy cv csuc cr1 cfv wcel vy con0 crab wcel cA crnk cfv cA vy cv csuc cr1
      cfv wcel vy con0 crab wcel cA crnk cfv cA vy cv csuc cr1 cfv wcel vy con0
      crab cint cA vy cv csuc cr1 cfv wcel vy con0 crab vy cA rankr1.1 rankval
      cA vy cv csuc cr1 cfv wcel vy con0 crab con0 wss cA vy cv csuc cr1 cfv
      wcel vy con0 crab c0 wne cA vy cv csuc cr1 cfv wcel vy con0 crab cint cA
      vy cv csuc cr1 cfv wcel vy con0 crab wcel cA vy cv csuc cr1 cfv wcel vy
      con0 ssrab2 cA vy cv csuc cr1 cfv wcel vy con0 crab c0 wne cA vy cv csuc
      cr1 cfv wcel vy con0 wrex cA cvv wcel cA vy cv csuc cr1 cfv wcel vy con0
      wrex rankr1.1 vy cA cvv rankwflem ax-mp cA vy cv csuc cr1 cfv wcel vy
      con0 rabn0 mpbir cA vy cv csuc cr1 cfv wcel vy con0 crab onint mp2an
      eqeltri cB cA crnk cfv cA vy cv csuc cr1 cfv wcel vy con0 crab eleq1
      mpbiri cB cA vy cv csuc cr1 cfv wcel vy con0 crab wcel cB con0 wcel cA cB
      csuc cr1 cfv wcel cA vy cv csuc cr1 cfv wcel cA cB csuc cr1 cfv wcel vy
      cB con0 vy cv cB wceq vy cv csuc cr1 cfv cB csuc cr1 cfv cA vy cv cB wceq
      vy cv csuc cB csuc cr1 vy cv cB suceq fveq2d eleq2d elrab pm3.27bi syl
      jca cA cB cr1 cfv wcel wn cA cB csuc cr1 cfv wcel wa cB cA crnk cfv cA cB
      cr1 cfv wcel wn cA cB csuc cr1 cfv wcel cB cA crnk cfv wss cA cB cr1 cfv
      wcel wn cB con0 wcel cB cA crnk cfv wss cA cB csuc cr1 cfv wcel cB con0
      wcel cA cB cr1 cfv wcel wn cB cA crnk cfv wss cA cB rankr1.1 rankr1lem
      com12 cA cB csuc cr1 cfv wcel cB csuc cr1 cdm wcel cB con0 wcel cA cB
      csuc cr1 elfvdm cB csuc cr1 cdm wcel cB csuc con0 wcel cB con0 wcel cr1
      cdm con0 cB csuc cr1 con0 wfn cr1 cdm con0 wceq r1fnon con0 cr1 fndm
      ax-mp eleq2i cB sucelon bitr4i sylib syl5 imp cA cB csuc cr1 cfv wcel cA
      crnk cfv cB wss cA cB cr1 cfv wcel wn cA cB csuc cr1 cfv wcel cA vy cv
      csuc cr1 cfv wcel vy con0 crab cint cB cA crnk cfv cB con0 wcel cA cB
      csuc cr1 cfv wcel cA vy cv csuc cr1 cfv wcel vy con0 crab cint cB wss cA
      cB csuc cr1 cfv wcel cB csuc cr1 cdm wcel cB con0 wcel cA cB csuc cr1
      elfvdm cB csuc cr1 cdm wcel cB csuc con0 wcel cB con0 wcel cr1 cdm con0
      cB csuc cr1 con0 wfn cr1 cdm con0 wceq r1fnon con0 cr1 fndm ax-mp eleq2i
      cB sucelon bitr4i sylib cA vy cv csuc cr1 cfv wcel cA cB csuc cr1 cfv
      wcel vy cB vy cv cB wceq vy cv csuc cr1 cfv cB csuc cr1 cfv cA vy cv cB
      wceq vy cv csuc cB csuc cr1 vy cv cB suceq fveq2d eleq2d onintss mpcom vy
      cA rankr1.1 rankval syl5ss adantl eqssd impbii $.
      $( [7-Oct-2003] $) $( [6-Oct-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( A relationship between the rank function and the cumulative hierarchy
       of sets function ` R1 ` .  Proposition 9.15(2) of [TakeutiZaring]
       p. 79. $)
    rankr1g $p |- ( A e. C -> ( B = ( rank ` A ) <->
                 ( -. A e. ( R1 ` B ) /\ A e. ( R1 ` suc B ) ) ) ) $=
      cB vx cv crnk cfv wceq vx cv cB cr1 cfv wcel wn vx cv cB csuc cr1 cfv
      wcel wa wb cB cA crnk cfv wceq cA cB cr1 cfv wcel wn cA cB csuc cr1 cfv
      wcel wa wb vx cA cC vx cv cA wceq cB vx cv crnk cfv wceq cB cA crnk cfv
      wceq vx cv cB cr1 cfv wcel wn vx cv cB csuc cr1 cfv wcel wa cA cB cr1 cfv
      wcel wn cA cB csuc cr1 cfv wcel wa vx cv cA wceq vx cv crnk cfv cA crnk
      cfv cB vx cv cA crnk fveq2 eqeq2d vx cv cA wceq vx cv cB cr1 cfv wcel wn
      cA cB cr1 cfv wcel wn vx cv cB csuc cr1 cfv wcel cA cB csuc cr1 cfv wcel
      vx cv cA wceq vx cv cB cr1 cfv wcel cA cB cr1 cfv wcel vx cv cA cB cr1
      cfv eleq1 notbid vx cv cA cB csuc cr1 cfv eleq1 anbi12d bibi12d vx cv cB
      vx visset rankr1 vtoclg $.
      $( [8-Oct-2003] $) $( [6-Oct-2003] $)
  $}

  ${
    ssrankr1.1 $e |- A e. _V $.
    $( A relationship between an ordinal number less than or equal to a rank,
       and the cumulative hierarchy of sets ` R1 ` .  Proposition 9.15(3) of
       [TakeutiZaring] p. 79. $)
    ssrankr1 $p |- ( B e. On ->
                   ( B C_ ( rank ` A ) <-> -. A e. ( R1 ` B ) ) ) $=
      cB con0 wcel cB cA crnk cfv wss cA cB cr1 cfv wcel wn cB con0 wcel cB cA
      crnk cfv wss cA cB cr1 cfv wcel wn cB con0 wcel cB cA crnk cfv wss wa cA
      cB cr1 cfv wcel cA cA crnk cfv cr1 cfv wcel cA cA crnk cfv cr1 cfv wcel
      wn cA cA crnk cfv csuc cr1 cfv wcel cA crnk cfv cA crnk cfv wceq cA cA
      crnk cfv cr1 cfv wcel wn cA cA crnk cfv csuc cr1 cfv wcel wa cA crnk cfv
      eqid cA cA crnk cfv ssrankr1.1 rankr1 mpbi pm3.26i cB con0 wcel cB cA
      crnk cfv wss wa cB cr1 cfv cA crnk cfv cr1 cfv cA cB con0 wcel cB cA crnk
      cfv wss cB cr1 cfv cA crnk cfv cr1 cfv wss cB con0 wcel cA crnk cfv con0
      wcel cB cA crnk cfv wss cB cr1 cfv cA crnk cfv cr1 cfv wss wi cA rankon
      cB cA crnk cfv r1ord3 mpan2 imp sseld mtoi ex cA cB ssrankr1.1 rankr1lem
      impbid $.
      $( [8-Oct-2003] $) $( [8-Oct-2003] $)
  $}

  ${
    rankr1a.1 $e |- A e. _V $.
    $( A relationship between rank and ` R1 ` , clearly equivalent to
       ~ ssrankr1 and friends through trichotomy, but in Raph's opinion
       considerably more intuitive.  See ~ rankr1b for the subset verion.
       (Contributed by Raph Levien, 29-May-2004.) $)
    rankr1a $p |- ( B e. On -> ( A e. ( R1 ` B ) <-> ( rank ` A ) e. B ) ) $=
      cB con0 wcel cA cB cr1 cfv wcel cA crnk cfv cB wcel cB con0 wcel cB cA
      crnk cfv wss cA cB cr1 cfv wcel wn cA crnk cfv cB wcel wn cA cB rankr1a.1
      ssrankr1 cB con0 wcel cA crnk cfv con0 wcel cB cA crnk cfv wss cA crnk
      cfv cB wcel wn wb cA rankon cB cA crnk cfv ontri1 mpan2 bitr3d con4bid $.
      $( [30-May-2004] $) $( [29-May-2004] $)
  $}

  ${
    $d x y A $.
    $( The value of the cumulative hierarchy of sets function expressed in
       terms of rank.  Definition 15.19 of [Monk1] p. 113. $)
    r1val2 $p |- ( A e. On -> ( R1 ` A ) = { x | ( rank ` x ) e. A } ) $=
      cA con0 wcel vx cv crnk cfv cA wcel vx cA cr1 cfv vx cv cA vx visset
      rankr1a abbi2dv $.
      $( [27-Jun-2004] $) $( [30-Nov-2003] $)

    $( The value of the cumulative hierarchy of sets function expressed in
       terms of rank.  Theorem 15.18 of [Monk1] p. 113. $)
    r1val3 $p |- ( A e. On ->
                 ( R1 ` A ) = U_ x e. A ~P { y | ( rank ` y ) e. x } ) $=
      cA con0 wcel cA cr1 cfv vx cA vx cv cr1 cfv cpw ciun vx cA vy cv crnk cfv
      vx cv wcel vy cab cpw ciun vx cA r1val1 cA con0 wcel vx cv cr1 cfv cpw vy
      cv crnk cfv vx cv wcel vy cab cpw wceq vx cA wral vx cA vx cv cr1 cfv cpw
      ciun vx cA vy cv crnk cfv vx cv wcel vy cab cpw ciun wceq cA con0 wcel vx
      cv cr1 cfv cpw vy cv crnk cfv vx cv wcel vy cab cpw wceq vx cA cA con0
      wcel vx cv cA wcel wa vx cv con0 wcel vx cv cr1 cfv vy cv crnk cfv vx cv
      wcel vy cab wceq vx cv cr1 cfv cpw vy cv crnk cfv vx cv wcel vy cab cpw
      wceq cA vx cv onelon vy vx cv r1val2 vx cv cr1 cfv vy cv crnk cfv vx cv
      wcel vy cab pweq 3syl r19.21aiva vx cA vx cv cr1 cfv cpw vy cv crnk cfv
      vx cv wcel vy cab cpw iuneq2 syl eqtrd $.
      $( [3-Jul-2004] $) $( [30-Nov-2003] $)
  $}

  ${
    rankel.1 $e |- B e. _V $.
    $( The membership relation is inherited by the rank function.  Proposition
       9.16 of [TakeutiZaring] p. 79. $)
    rankel $p |- ( A e. B -> ( rank ` A ) e. ( rank ` B ) ) $=
      cA cB wcel cB cA crnk cfv csuc cr1 cfv wcel cA crnk cfv cB crnk cfv wcel
      cA cB wcel cB cA crnk cfv csuc cr1 cfv wcel cA cA crnk cfv cr1 cfv wcel
      cA cB wcel cA cA crnk cfv cr1 cfv wcel wn cA cA crnk cfv csuc cr1 cfv
      wcel cA cB wcel cA crnk cfv cA crnk cfv wceq cA cA crnk cfv cr1 cfv wcel
      wn cA cA crnk cfv csuc cr1 cfv wcel wa cA crnk cfv eqid cA cA crnk cfv cB
      rankr1g mpbii pm3.26d cB cA crnk cfv csuc cr1 cfv wcel cA cB wcel cA cA
      crnk cfv cr1 cfv wcel cB cA crnk cfv csuc cr1 cfv wcel cB cA crnk cfv cr1
      cfv wss cA cB wcel cA cA crnk cfv cr1 cfv wcel wi cB cA crnk cfv csuc cr1
      cfv wcel cB cA crnk cfv cr1 cfv cpw wcel cB cA crnk cfv cr1 cfv wss cA
      crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw cB cA crnk cfv con0 wcel cA
      crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw wceq cA rankon cA crnk cfv
      r1suc ax-mp eleq2i cB cA crnk cfv cr1 cfv rankel.1 elpw bitri cB cA crnk
      cfv cr1 cfv cA ssel sylbi com12 mtod cA crnk cfv cB crnk cfv wcel wn cB
      crnk cfv cA crnk cfv wss cB cA crnk cfv csuc cr1 cfv wcel cB crnk cfv
      con0 wcel cA crnk cfv con0 wcel cB crnk cfv cA crnk cfv wss cA crnk cfv
      cB crnk cfv wcel wn wb cB rankon cA rankon cB crnk cfv cA crnk cfv ontri1
      mp2an cB crnk cfv cA crnk cfv wss cB crnk cfv csuc cA crnk cfv csuc wss
      cB cA crnk cfv csuc cr1 cfv wcel cB crnk cfv word cA crnk cfv word cB
      crnk cfv cA crnk cfv wss cB crnk cfv csuc cA crnk cfv csuc wss wb cB crnk
      cfv cB rankon onordi cA crnk cfv cA rankon onordi cB crnk cfv cA crnk cfv
      ordsucsssuc mp2an cB crnk cfv csuc cA crnk cfv csuc wss cB cB crnk cfv
      csuc cr1 cfv wcel cB cA crnk cfv csuc cr1 cfv wcel cB rankel.1 rankid cB
      crnk cfv csuc cA crnk cfv csuc wss cB crnk cfv csuc cr1 cfv cA crnk cfv
      csuc cr1 cfv cB cB crnk cfv csuc con0 wcel cA crnk cfv csuc con0 wcel cB
      crnk cfv csuc cA crnk cfv csuc wss cB crnk cfv csuc cr1 cfv cA crnk cfv
      csuc cr1 cfv wss wi cB crnk cfv cB rankon onsuci cA crnk cfv cA rankon
      onsuci cB crnk cfv csuc cA crnk cfv csuc r1ord3 mp2an sseld mpi sylbi
      sylbir nsyl2 $.
      $( [9-Oct-2003] $) $( [4-Oct-2003] $)
  $}

  ${
    $d x y A $.
    rankval3.1 $e |- A e. _V $.
    $( The value of the rank function expressed recursively:  the rank of a set
       is the smallest ordinal number containing the ranks of all members of
       the set.  Proposition 9.17 of [TakeutiZaring] p. 79. $)
    rankval3 $p |- ( rank ` A ) =
                  |^| { x e. On | A. y e. A ( rank ` y ) e. x } $=
      cA crnk cfv vy cv crnk cfv vx cv wcel vy cA wral vx con0 crab cint cA
      crnk cfv cA vx cv csuc cr1 cfv wcel vx con0 crab cint vy cv crnk cfv vx
      cv wcel vy cA wral vx con0 crab cint vx cA rankval3.1 rankval vy cv crnk
      cfv vx cv wcel vy cA wral vx con0 crab cA vx cv csuc cr1 cfv wcel vx con0
      crab wss cA vx cv csuc cr1 cfv wcel vx con0 crab cint vy cv crnk cfv vx
      cv wcel vy cA wral vx con0 crab cint wss vy cv crnk cfv vx cv wcel vy cA
      wral cA vx cv csuc cr1 cfv wcel vx con0 vx cv con0 wcel vy cv crnk cfv vx
      cv wcel vy cA wral vy cv vx cv cr1 cfv wcel vy cA wral cA vx cv csuc cr1
      cfv wcel vx cv con0 wcel vy cv crnk cfv vx cv wcel vy cv vx cv cr1 cfv
      wcel vy cA vx cv con0 wcel vy cv crnk cfv vx cv wcel vy cv vy cv crnk cfv
      csuc cr1 cfv wcel vy cv vx cv cr1 cfv wcel vy cv vy visset rankid vx cv
      con0 wcel vy cv crnk cfv vx cv wcel vy cv crnk cfv csuc cr1 cfv vx cv cr1
      cfv wss vy cv vy cv crnk cfv csuc cr1 cfv wcel vy cv vx cv cr1 cfv wcel
      wi vx cv con0 wcel vy cv crnk cfv vx cv wcel vy cv crnk cfv csuc vx cv
      wss vy cv crnk cfv csuc cr1 cfv vx cv cr1 cfv wss vx cv con0 wcel vx cv
      word vy cv crnk cfv vx cv wcel vy cv crnk cfv csuc vx cv wss wi vx cv
      eloni vy cv crnk cfv vx cv ordsucss syl vy cv crnk cfv csuc con0 wcel vx
      cv con0 wcel vy cv crnk cfv csuc vx cv wss vy cv crnk cfv csuc cr1 cfv vx
      cv cr1 cfv wss wi vy cv crnk cfv vy cv rankon onsuci vy cv crnk cfv csuc
      vx cv r1ord3 mpan syld vy cv crnk cfv csuc cr1 cfv vx cv cr1 cfv vy cv
      ssel syl6 mpii r19.20sdv vx cv con0 wcel cA vx cv csuc cr1 cfv wcel cA vx
      cv cr1 cfv cpw wcel vy cv vx cv cr1 cfv wcel vy cA wral vx cv con0 wcel
      vx cv csuc cr1 cfv vx cv cr1 cfv cpw cA vx cv r1suc eleq2d cA vx cv cr1
      cfv cpw wcel cA vx cv cr1 cfv wss vy cv vx cv cr1 cfv wcel vy cA wral cA
      vx cv cr1 cfv rankval3.1 elpw vy cA vx cv cr1 cfv dfss3 bitri syl6bb
      sylibrd ss2rabi vy cv crnk cfv vx cv wcel vy cA wral vx con0 crab cA vx
      cv csuc cr1 cfv wcel vx con0 crab intss ax-mp eqsstri cA crnk cfv con0
      wcel vy cv crnk cfv cA crnk cfv wcel vy cA wral vy cv crnk cfv vx cv wcel
      vy cA wral vx con0 crab cint cA crnk cfv wss cA rankon vy cv crnk cfv cA
      crnk cfv wcel vy cA vy cv cA rankval3.1 rankel rgen vy cv crnk cfv vx cv
      wcel vy cA wral vy cv crnk cfv cA crnk cfv wcel vy cA wral vx cA crnk cfv
      vx cv cA crnk cfv wceq vy cv crnk cfv vx cv wcel vy cv crnk cfv cA crnk
      cfv wcel vy cA vx cv cA crnk cfv vy cv crnk cfv eleq2 ralbidv onintss mp2
      eqssi $.
      $( [11-Oct-2003] $) $( [11-Oct-2003] $)
  $}

  ${
    $d x y A $.
    $( Any class whose elements have bounded rank is a set.  Proposition 9.19
       of [TakeutiZaring] p. 80. $)
    bndrank $p |- ( E. x e. On A. y e. A ( rank ` y ) C_ x -> A e. _V ) $=
      vy cv crnk cfv vx cv wss vy cA wral cA cvv wcel vx con0 vx cv con0 wcel
      vy cv crnk cfv vx cv wss vy cA wral vy cv vx cv csuc cr1 cfv wcel vy cA
      wral cA cvv wcel vx cv con0 wcel vy cv crnk cfv vx cv wss vy cv vx cv
      csuc cr1 cfv wcel vy cA vx cv con0 wcel vy cv crnk cfv vx cv wss vy cv vy
      cv crnk cfv csuc cr1 cfv wcel vy cv vx cv csuc cr1 cfv wcel vy cv vy
      visset rankid vx cv con0 wcel vy cv crnk cfv vx cv wss vy cv crnk cfv
      csuc cr1 cfv vx cv csuc cr1 cfv wss vy cv vy cv crnk cfv csuc cr1 cfv
      wcel vy cv vx cv csuc cr1 cfv wcel wi vx cv con0 wcel vy cv crnk cfv vx
      cv wss vy cv crnk cfv csuc vx cv csuc wss vy cv crnk cfv csuc cr1 cfv vx
      cv csuc cr1 cfv wss vy cv crnk cfv word vx cv word vy cv crnk cfv vx cv
      wss vy cv crnk cfv csuc vx cv csuc wss wb vx cv con0 wcel vy cv crnk cfv
      vx cv ordsucsssuc vy cv crnk cfv vy cv rankon onordi vx cv eloni sylancr
      vy cv crnk cfv csuc con0 wcel vx cv csuc con0 wcel vy cv crnk cfv csuc vx
      cv csuc wss vy cv crnk cfv csuc cr1 cfv vx cv csuc cr1 cfv wss wi vx cv
      con0 wcel vy cv crnk cfv csuc vx cv csuc r1ord3 vy cv crnk cfv vy cv
      rankon onsuci vx cv suceloni sylancr sylbid vy cv crnk cfv csuc cr1 cfv
      vx cv csuc cr1 cfv vy cv ssel syl6 mpii r19.20sdv vy cv vx cv csuc cr1
      cfv wcel vy cA wral cA vx cv csuc cr1 cfv wss cA cvv wcel vy cA vx cv
      csuc cr1 cfv dfss3 cA vx cv csuc cr1 cfv vx cv csuc cr1 fvex ssex sylbir
      syl6 r19.23aiv $.
      $( [20-Nov-2003] $) $( [13-Oct-2003] $)

    $( The elements of a proper class have unbounded rank.  Exercise 2 of
       [TakeutiZaring] p. 80. $)
    unbndrank $p |- ( -. A e. _V -> A. x e. On E. y e. A x e. ( rank ` y ) ) $=
      vx cv vy cv crnk cfv wcel vy cA wrex vx con0 wral cA cvv wcel vx cv vy cv
      crnk cfv wcel vy cA wrex vx con0 wral wn vy cv crnk cfv vx cv wss vy cA
      wral vx con0 wrex cA cvv wcel vy cv crnk cfv vx cv wss vy cA wral vx con0
      wrex vx cv vy cv crnk cfv wcel vy cA wrex wn vx con0 wrex vx cv vy cv
      crnk cfv wcel vy cA wrex vx con0 wral wn vy cv crnk cfv vx cv wss vy cA
      wral vx cv vy cv crnk cfv wcel vy cA wrex wn vx con0 vx cv con0 wcel vy
      cv crnk cfv vx cv wss vy cA wral vx cv vy cv crnk cfv wcel wn vy cA wral
      vx cv vy cv crnk cfv wcel vy cA wrex wn vx cv con0 wcel vy cv crnk cfv vx
      cv wss vx cv vy cv crnk cfv wcel wn vy cA vy cv crnk cfv con0 wcel vx cv
      con0 wcel vy cv crnk cfv vx cv wss vx cv vy cv crnk cfv wcel wn wb vy cv
      rankon vy cv crnk cfv vx cv ontri1 mpan ralbidv vx cv vy cv crnk cfv wcel
      vy cA ralnex syl6bb rexbiia vx cv vy cv crnk cfv wcel vy cA wrex vx con0
      rexnal bitri vx vy cA bndrank sylbir con1i $.
      $( [21-Nov-2003] $) $( [13-Oct-2003] $)
  $}

  ${
    rankpw.1 $e |- A e. _V $.
    $( The rank of a power set.  Part of Exercise 30 of [Enderton] p. 207. $)
    rankpw $p |- ( rank ` ~P A ) = suc ( rank ` A ) $=
      cA crnk cfv csuc cA cpw crnk cfv cA crnk cfv csuc cA cpw crnk cfv wceq cA
      cpw cA crnk cfv csuc cr1 cfv wcel wn cA cpw cA crnk cfv csuc csuc cr1 cfv
      wcel cA cpw cA crnk cfv csuc cA rankpw.1 pwex rankr1 cA cpw cA crnk cfv
      csuc cr1 cfv wcel cA cpw cA crnk cfv cr1 cfv cpw wcel cA cpw cA crnk cfv
      cr1 cfv cpw wcel cA cpw cA crnk cfv cr1 cfv wss cA cpw cA crnk cfv cr1
      cfv wss cA cA crnk cfv cr1 cfv wcel cA crnk cfv cA crnk cfv wceq cA cA
      crnk cfv cr1 cfv wcel wn cA crnk cfv eqid cA crnk cfv cA crnk cfv wceq cA
      cA crnk cfv cr1 cfv wcel wn cA cA crnk cfv csuc cr1 cfv wcel cA cA crnk
      cfv rankpw.1 rankr1 pm3.26bi ax-mp cA cpw cA crnk cfv cr1 cfv wss cA cA
      cpw wcel cA cA crnk cfv cr1 cfv wcel cA rankpw.1 pwid cA cpw cA crnk cfv
      cr1 cfv cA ssel mpi mto cA cpw cA crnk cfv cr1 cfv cA rankpw.1 pwex elpw
      mtbir cA crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw cA cpw cA crnk cfv
      con0 wcel cA crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw wceq cA rankon
      cA crnk cfv r1suc ax-mp eleq2i mtbir cA cpw cA crnk cfv csuc cr1 cfv cpw
      cA crnk cfv csuc csuc cr1 cfv cA cpw cA crnk cfv csuc cr1 cfv cpw wcel cA
      cpw cA crnk cfv csuc cr1 cfv wss cA cpw cA crnk cfv cr1 cfv cpw cA crnk
      cfv csuc cr1 cfv cA cA crnk cfv cr1 cfv wss cA cpw cA crnk cfv cr1 cfv
      cpw wss cA cA crnk cfv cr1 cfv cpw wcel cA cA crnk cfv cr1 cfv wss cA cA
      crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw cA rankpw.1 rankid cA crnk
      cfv con0 wcel cA crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw wceq cA
      rankon cA crnk cfv r1suc ax-mp eleqtri cA cA crnk cfv cr1 cfv rankpw.1
      elpw mpbi cA cA crnk cfv cr1 cfv sspwb mpbi cA crnk cfv con0 wcel cA crnk
      cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw wceq cA rankon cA crnk cfv r1suc
      ax-mp sseqtr4i cA cpw cA crnk cfv csuc cr1 cfv cA rankpw.1 pwex elpw
      mpbir cA crnk cfv csuc con0 wcel cA crnk cfv csuc csuc cr1 cfv cA crnk
      cfv csuc cr1 cfv cpw wceq cA crnk cfv cA rankon onsuci cA crnk cfv csuc
      r1suc ax-mp eleqtrri mpbir2an eqcomi $.
      $( [22-Nov-2003] $) $( [22-Nov-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The rank of a set belongs to a limit ordinal iff the rank of its power
       set does. $)
    ranklim $p |- ( Lim B ->
                  ( ( rank ` A ) e. B <-> ( rank ` ~P A ) e. B ) ) $=
      cA cvv wcel cB wlim cA crnk cfv cB wcel cA cpw crnk cfv cB wcel wb cA cvv
      wcel cB wlim wa cA crnk cfv cB wcel cA crnk cfv csuc cB wcel cA cpw crnk
      cfv cB wcel cB wlim cA crnk cfv cB wcel cA crnk cfv csuc cB wcel wb cA
      cvv wcel cB cA crnk cfv limsuc adantl cA cvv wcel cA cpw crnk cfv cB wcel
      cA crnk cfv csuc cB wcel wb cB wlim cA cvv wcel cA cpw crnk cfv cA crnk
      cfv csuc cB vx cv cpw crnk cfv vx cv crnk cfv csuc wceq cA cpw crnk cfv
      cA crnk cfv csuc wceq vx cA cvv vx cv cA wceq vx cv cpw crnk cfv cA cpw
      crnk cfv vx cv crnk cfv csuc cA crnk cfv csuc vx cv cA wceq vx cv cpw cA
      cpw crnk vx cv cA pweq fveq2d vx cv cA wceq vx cv crnk cfv cA crnk cfv
      wceq vx cv crnk cfv csuc cA crnk cfv csuc wceq vx cv cA crnk fveq2 vx cv
      crnk cfv cA crnk cfv suceq syl eqeq12d vx cv vx visset rankpw vtoclg
      eleq1d adantr bitr4d cA cvv wcel wn cA crnk cfv cB wcel cA cpw crnk cfv
      cB wcel wb cB wlim cA cvv wcel wn cA crnk cfv cA cpw crnk cfv cB cA cvv
      wcel wn cA crnk cfv c0 cA cpw crnk cfv cA crnk fvprc cA cvv wcel wn cA
      cpw cvv wcel wn cA cpw crnk cfv c0 wceq cA cvv wcel cA cpw cvv wcel cA
      pwexb notbii cA cpw crnk fvprc sylbi eqtr4d eleq1d adantr pm2.61ian $.
      $( [19-Sep-2006] $) $( [18-Sep-2006] $)

    $( A stronger property of ` R1 ` than ~ rankpw .  The latter merely
       proves that ` R1 ` of the successor is a power set, but here we prove
       that if ` A ` is in the cumulative hierarchy, then ` ~P A ` is in the
       cumulative hierarchy of the successor.  (Contributed by Raph Levien,
       29-May-2004.) $)
    r1pw $p |- ( B e. On ->
                 ( A e. ( R1 ` B ) <-> ~P A e. ( R1 ` suc B ) ) ) $=
      cA cvv wcel cB con0 wcel cA cB cr1 cfv wcel cA cpw cB csuc cr1 cfv wcel
      wb wi cB con0 wcel vx cv cB cr1 cfv wcel vx cv cpw cB csuc cr1 cfv wcel
      wb wi cB con0 wcel cA cB cr1 cfv wcel cA cpw cB csuc cr1 cfv wcel wb wi
      vx cA cvv vx cv cA wceq vx cv cB cr1 cfv wcel vx cv cpw cB csuc cr1 cfv
      wcel wb cA cB cr1 cfv wcel cA cpw cB csuc cr1 cfv wcel wb cB con0 wcel vx
      cv cA wceq vx cv cB cr1 cfv wcel cA cB cr1 cfv wcel vx cv cpw cB csuc cr1
      cfv wcel cA cpw cB csuc cr1 cfv wcel vx cv cA cB cr1 cfv eleq1 vx cv cA
      wceq vx cv cpw cA cpw cB csuc cr1 cfv vx cv cA pweq eleq1d bibi12d imbi2d
      cB con0 wcel vx cv cB cr1 cfv wcel vx cv cpw crnk cfv cB csuc wcel vx cv
      cpw cB csuc cr1 cfv wcel cB con0 wcel vx cv cB cr1 cfv wcel vx cv crnk
      cfv csuc cB csuc wcel vx cv cpw crnk cfv cB csuc wcel cB con0 wcel vx cv
      cB cr1 cfv wcel vx cv crnk cfv cB wcel vx cv crnk cfv csuc cB csuc wcel
      vx cv cB vx visset rankr1a cB con0 wcel cB word vx cv crnk cfv cB wcel vx
      cv crnk cfv csuc cB csuc wcel wb cB eloni vx cv crnk cfv cB ordsucelsuc
      syl bitrd vx cv cpw crnk cfv vx cv crnk cfv csuc cB csuc vx cv vx visset
      rankpw eleq1i syl6bbr cB con0 wcel cB csuc con0 wcel vx cv cpw cB csuc
      cr1 cfv wcel vx cv cpw crnk cfv cB csuc wcel wb cB suceloni vx cv cpw cB
      csuc vx cv vx visset pwex rankr1a syl bitr4d vtoclg cA cvv wcel wn cA cB
      cr1 cfv wcel cA cpw cB csuc cr1 cfv wcel wb cB con0 wcel cA cB cr1 cfv
      wcel cA cvv wcel cA cpw cB csuc cr1 cfv wcel cA cB cr1 cfv elisset cA cpw
      cB csuc cr1 cfv wcel cA cpw cvv wcel cA cvv wcel cA cpw cB csuc cr1 cfv
      elisset cA pwexb sylibr pm5.21ni a1d pm2.61i $.
      $( [30-May-2004] $) $( [29-May-2004] $)
  $}

  ${
    $d A x y $.  $d B x y $.
    $( MAY BE REVISED - can ranklim + rankr1a shorten this? $)
    $( The cumulative hierarchy of a limit ordinal is closed under power set.
       (Contributed by Raph Levien, 29-May-2004.) $)
    r1pwcl $p |- ( Lim B -> ( A e. ( R1 ` B ) <-> ~P A e. ( R1 ` B ) ) ) $=
      cB cvv wcel cB wlim cA cB cr1 cfv wcel cA cpw cB cr1 cfv wcel wb wi cB
      cvv wcel cB wlim cA cB cr1 cfv wcel cA cpw cB cr1 cfv wcel wb cB cvv wcel
      cB wlim wa cA cB cr1 cfv wcel cA cpw vx cv cr1 cfv wcel vx cB wrex cA cpw
      cB cr1 cfv wcel cB cvv wcel cB wlim wa cA cB cr1 cfv wcel cA vx cv cr1
      cfv wcel vx cB wrex cA cpw vx cv csuc cr1 cfv wcel vx cB wrex cA cpw vx
      cv cr1 cfv wcel vx cB wrex cB cvv wcel cB wlim wa cA cB cr1 cfv wcel cA
      vx cB vx cv cr1 cfv ciun wcel cA vx cv cr1 cfv wcel vx cB wrex cB cvv
      wcel cB wlim wa cB cr1 cfv vx cB vx cv cr1 cfv ciun cA vx cB cvv r1lim
      eleq2d vx cA cB vx cv cr1 cfv eliun syl6bb cB cvv wcel cB wlim wa cA vx
      cv cr1 cfv wcel cA cpw vx cv csuc cr1 cfv wcel vx cB cB cvv wcel cB wlim
      wa vx cv cB wcel wa vx cv con0 wcel cA vx cv cr1 cfv wcel cA cpw vx cv
      csuc cr1 cfv wcel wb cB con0 wcel vx cv cB wcel vx cv con0 wcel cB cvv
      wcel cB wlim wa cB vx cv onelon cB cvv limelon sylan cA vx cv r1pw syl
      rexbidva cB cvv wcel cB wlim wa cA cpw vx cv csuc cr1 cfv wcel vx cB wrex
      cA cpw vx cv cr1 cfv wcel vx cB wrex cB wlim cA cpw vx cv csuc cr1 cfv
      wcel vx cB wrex cA cpw vx cv cr1 cfv wcel vx cB wrex wi cB cvv wcel cB
      wlim cA cpw vx cv csuc cr1 cfv wcel vx cB wrex cA cpw vy cv cr1 cfv wcel
      vy cB wrex cA cpw vx cv cr1 cfv wcel vx cB wrex cB wlim vx cv cB wcel cA
      cpw vx cv csuc cr1 cfv wcel wa vx wex vy cv cB wcel cA cpw vy cv cr1 cfv
      wcel wa vy wex cA cpw vx cv csuc cr1 cfv wcel vx cB wrex cA cpw vy cv cr1
      cfv wcel vy cB wrex cB wlim vx cv cB wcel cA cpw vx cv csuc cr1 cfv wcel
      wa vy cv cB wcel cA cpw vy cv cr1 cfv wcel wa vy wex vx cB wlim vx cv cB
      wcel cA cpw vx cv csuc cr1 cfv wcel wa vx cv csuc cB wcel cA cpw vx cv
      csuc cr1 cfv wcel wa vy cv cB wcel cA cpw vy cv cr1 cfv wcel wa vy wex cB
      wlim vx cv cB wcel vx cv csuc cB wcel cA cpw vx cv csuc cr1 cfv wcel cB
      vx cv limsuc anbi1d vy cv cB wcel cA cpw vy cv cr1 cfv wcel wa vx cv csuc
      cB wcel cA cpw vx cv csuc cr1 cfv wcel wa vy vx cv csuc vx cv vx visset
      sucex vy cv vx cv csuc wceq vy cv cB wcel vx cv csuc cB wcel cA cpw vy cv
      cr1 cfv wcel cA cpw vx cv csuc cr1 cfv wcel vy cv vx cv csuc cB eleq1 vy
      cv vx cv csuc wceq vy cv cr1 cfv vx cv csuc cr1 cfv cA cpw vy cv vx cv
      csuc cr1 fveq2 eleq2d anbi12d cla4ev syl6bi 19.23adv cA cpw vx cv csuc
      cr1 cfv wcel vx cB df-rex cA cpw vy cv cr1 cfv wcel vy cB df-rex 3imtr4g
      cA cpw vx cv cr1 cfv wcel cA cpw vy cv cr1 cfv wcel vx vy cB vx cv vy cv
      wceq vx cv cr1 cfv vy cv cr1 cfv cA cpw vx cv vy cv cr1 fveq2 eleq2d
      cbvrexv syl6ibr adantl cB cvv wcel cB wlim wa cA cpw vx cv cr1 cfv wcel
      cA cpw vx cv csuc cr1 cfv wcel vx cB cB cvv wcel cB wlim wa vx cv cB wcel
      vx cv con0 wcel cA cpw vx cv cr1 cfv wcel cA cpw vx cv csuc cr1 cfv wcel
      wi cB cvv wcel cB wlim wa vx cv cB wcel vx cv con0 wcel cB con0 wcel vx
      cv cB wcel vx cv con0 wcel cB cvv wcel cB wlim wa cB vx cv onelon cB cvv
      limelon sylan ex vx cv con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv cA cpw
      vx cv con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv wss vx cv con0 wcel vx
      cv csuc con0 wcel vx cv cr1 cfv vx cv csuc cr1 cfv wss vx cv con0 wcel vx
      cv con0 wcel vx cv csuc con0 wcel wa vx cv vx cv csuc wss vx cv cr1 cfv
      vx cv csuc cr1 cfv wss vx cv sssucid vx cv vx cv csuc r1ord3 mpi vx cv
      sucelon sylan2b anidms sseld syl6 r19.22dv impbid 3bitrd cB cvv wcel cB
      wlim wa cA cpw cB cr1 cfv wcel cA cpw vx cB vx cv cr1 cfv ciun wcel cA
      cpw vx cv cr1 cfv wcel vx cB wrex cB cvv wcel cB wlim wa cB cr1 cfv vx cB
      vx cv cr1 cfv ciun cA cpw vx cB cvv r1lim eleq2d vx cA cpw cB vx cv cr1
      cfv eliun syl6bb bitr4d ex cB cvv wcel wn cA cB cr1 cfv wcel cA cpw cB
      cr1 cfv wcel wb cB wlim cA cB cr1 cfv wcel cB cvv wcel cA cpw cB cr1 cfv
      wcel cA cB cr1 cfv wcel cB cr1 cfv c0 wceq cB cvv wcel cB cr1 cfv cA n0i
      cB cr1 fvprc nsyl2 cA cpw cB cr1 cfv wcel cB cr1 cfv c0 wceq cB cvv wcel
      cB cr1 cfv cA cpw n0i cB cr1 fvprc nsyl2 pm5.21ni a1d pm2.61i $.
      $( [1-Jun-2004] $) $( [29-May-2004] $)
  $}

  ${
    rankss.1 $e |- B e. _V $.
    $( The subset relation is inherited by the rank function.  Exercise 1 of
       [TakeutiZaring] p. 80. $)
    rankss $p |- ( A C_ B -> ( rank ` A ) C_ ( rank ` B ) ) $=
      cA cB cpw wcel cA crnk cfv cB cpw crnk cfv wcel cA cB wss cA crnk cfv cB
      crnk cfv wss cA cB cpw cB rankss.1 pwex rankel cA cB rankss.1 elpw2 cA
      crnk cfv cB cpw crnk cfv wcel cA crnk cfv cB crnk cfv csuc wcel cA crnk
      cfv cB crnk cfv wss cB cpw crnk cfv cB crnk cfv csuc cA crnk cfv cB
      rankss.1 rankpw eleq2i cA crnk cfv con0 wcel cB crnk cfv con0 wcel cA
      crnk cfv cB crnk cfv wss cA crnk cfv cB crnk cfv csuc wcel wb cA rankon
      cB rankon cA crnk cfv cB crnk cfv onsssuc mp2an bitr4i 3imtr3i $.
      $( [25-Nov-2003] $) $( [25-Nov-2003] $)
  $}

  ${
    $d x y z A $.
    ranksn.1 $e |- A e. _V $.
    $( The rank of a singleton.  Theorem 15.17(v) of [Monk1] p. 112. $)
    ranksn $p |- ( rank ` { A } ) = suc ( rank ` A ) $=
      vy cv crnk cfv vx cv wcel vy cA csn wral vx con0 crab cint cA crnk cfv vx
      cv wcel vx con0 crab cint cA csn crnk cfv cA crnk cfv csuc vy cv crnk cfv
      vx cv wcel vy cA csn wral vx con0 crab cA crnk cfv vx cv wcel vx con0
      crab vy cv crnk cfv vx cv wcel vy cA csn wral cA crnk cfv vx cv wcel vx
      con0 vy cv crnk cfv vx cv wcel vy cA csn wral cA crnk cfv vx cv wcel wb
      vx cv con0 wcel vy cv crnk cfv vx cv wcel vy cA csn wral vy cv cA csn
      wcel vy cv crnk cfv vx cv wcel wi vy wal vy cv cA wceq vy cv crnk cfv vx
      cv wcel wi vy wal cA crnk cfv vx cv wcel vy cv crnk cfv vx cv wcel vy cA
      csn df-ral vy cv cA csn wcel vy cv crnk cfv vx cv wcel wi vy cv cA wceq
      vy cv crnk cfv vx cv wcel wi vy vy cv cA csn wcel vy cv cA wceq vy cv
      crnk cfv vx cv wcel vy cA elsn imbi1i albii vy cv crnk cfv vx cv wcel cA
      crnk cfv vx cv wcel vy cA ranksn.1 vy cv cA wceq vy cv crnk cfv cA crnk
      cfv vx cv vy cv cA crnk fveq2 eleq1d ceqsalv 3bitri a1i rabbii inteqi vx
      vy cA csn cA snex rankval3 cA crnk cfv con0 wcel cA crnk cfv csuc cA crnk
      cfv vx cv wcel vx con0 crab cint wceq cA rankon vx cA crnk cfv onsucmin
      ax-mp 3eqtr4i $.
      $( [20-Jul-2004] $) $( [28-Nov-2003] $)

    $( The rank of a union.  Part of Theorem 15.17(iv) of [Monk1] p. 112. $)
    rankuni2 $p |- ( rank ` U. A ) = U_ x e. A ( rank ` x ) $=
      cA cuni crnk cfv vx cA vx cv crnk cfv ciun cA cuni crnk cfv vy cv crnk
      cfv vz cv wcel vy cA cuni wral vz con0 crab cint vx cA vx cv crnk cfv
      ciun vz vy cA cuni cA ranksn.1 uniex rankval3 vx cA vx cv crnk cfv ciun
      vy cv crnk cfv vz cv wcel vy cA cuni wral vz con0 crab wcel vy cv crnk
      cfv vz cv wcel vy cA cuni wral vz con0 crab cint vx cA vx cv crnk cfv
      ciun wss vx cA vx cv crnk cfv ciun vy cv crnk cfv vz cv wcel vy cA cuni
      wral vz con0 crab wcel vx cA vx cv crnk cfv ciun con0 wcel vy cv crnk cfv
      vx cA vx cv crnk cfv ciun wcel vy cA cuni wral vy cv crnk cfv vz cv wcel
      vy cA cuni wral vy cv crnk cfv vx cA vx cv crnk cfv ciun wcel vy cA cuni
      wral vz vx cA vx cv crnk cfv ciun con0 vz cv vx cA vx cv crnk cfv ciun
      wceq vy cv crnk cfv vz cv wcel vy cv crnk cfv vx cA vx cv crnk cfv ciun
      wcel vy cA cuni vz cv vx cA vx cv crnk cfv ciun vy cv crnk cfv eleq2
      ralbidv elrab vx cv crnk cfv con0 wcel vx cA vx cv crnk cfv ciun con0
      wcel vx cA vx cA vx cv crnk cfv ranksn.1 vx cv crnk fvex iunon vx cv crnk
      cfv con0 wcel vx cv cA wcel vx cv rankon a1i mprg vy cv crnk cfv vx cA vx
      cv crnk cfv ciun wcel vy cA cuni vy cv cA cuni wcel vy cv vx cv wcel vx
      cA wrex vy cv crnk cfv vx cA vx cv crnk cfv ciun wcel vx vy cv cA eluni2
      vy cv vx cv wcel vy cv crnk cfv vx cA vx cv crnk cfv ciun wcel vx cA vx
      vz vz vy cv crnk cfv vx cA vx cv crnk cfv ciun vz cv vy cv crnk cfv wcel
      vx ax-17 vx vz cA vx cv crnk cfv hbiu1 hbel vx cv cA wcel vy cv crnk cfv
      vx cv crnk cfv wcel vy cv crnk cfv vx cA vx cv crnk cfv ciun wcel vy cv
      vx cv wcel vx cv cA wcel vx cv crnk cfv vx cA vx cv crnk cfv ciun vy cv
      crnk cfv vx cA vx cv crnk cfv ssiun2 sseld vy cv vx cv vx visset rankel
      syl5 r19.23ai sylbi rgen mpbir2an vx cA vx cv crnk cfv ciun vy cv crnk
      cfv vz cv wcel vy cA cuni wral vz con0 crab intss1 ax-mp eqsstri vx cA vx
      cv crnk cfv ciun cA cuni crnk cfv wss vx cv crnk cfv cA cuni crnk cfv wss
      vx cA vx cA vx cv crnk cfv cA cuni crnk cfv iunss vx cv cA wcel vx cv cA
      cuni wss vx cv crnk cfv cA cuni crnk cfv wss vx cv cA elssuni vx cv cA
      cuni cA ranksn.1 uniex rankss syl mprgbir eqssi $.
      $( [21-Jul-2004] $) $( [30-Nov-2003] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    rankun.1 $e |- A e. _V $.
    rankun.2 $e |- B e. _V $.
    $( The rank of the union of two sets.  Theorem 15.17(iii) of [Monk1]
       p. 112. $)
    rankun $p |- ( rank ` ( A u. B ) ) = ( ( rank ` A ) u. ( rank ` B ) ) $=
      cA cB cun crnk cfv cA crnk cfv cB crnk cfv cun vx cA cB cun crnk cfv cA
      crnk cfv cB crnk cfv cun vx cv cA cB cun crnk cfv wcel vz cv crnk cfv vy
      cv wcel vz cA cB cun wral vx cv vy cv wcel wi vy con0 wral vx cv cA crnk
      cfv cB crnk cfv cun wcel vx cv cA cB cun crnk cfv wcel vx cv vz cv crnk
      cfv vy cv wcel vz cA cB cun wral vy con0 crab cint wcel vz cv crnk cfv vy
      cv wcel vz cA cB cun wral vx cv vy cv wcel wi vy con0 wral cA cB cun crnk
      cfv vz cv crnk cfv vy cv wcel vz cA cB cun wral vy con0 crab cint vx cv
      vy vz cA cB cun cA cB rankun.1 rankun.2 unex rankval3 eleq2i vz cv crnk
      cfv vy cv wcel vz cA cB cun wral vy vx cv con0 vx visset elintrab bitri
      vz cv crnk cfv vy cv wcel vz cA cB cun wral vx cv vy cv wcel wi vy con0
      wral vz cv crnk cfv cA crnk cfv cB crnk cfv cun wcel vz cA cB cun wral vx
      cv cA crnk cfv cB crnk cfv cun wcel vz cv crnk cfv cA crnk cfv cB crnk
      cfv cun wcel vz cA cB cun vz cv cA cB cun wcel vz cv cA wcel vz cv cB
      wcel wo vz cv crnk cfv cA crnk cfv cB crnk cfv cun wcel vz cv cA cB elun
      vz cv cA wcel vz cv crnk cfv cA crnk cfv cB crnk cfv cun wcel vz cv cB
      wcel vz cv cA wcel vz cv crnk cfv cA crnk cfv wcel vz cv crnk cfv cA crnk
      cfv cB crnk cfv cun wcel vz cv cA rankun.1 rankel vz cv crnk cfv cA crnk
      cfv cB crnk cfv elun1 syl vz cv cB wcel vz cv crnk cfv cB crnk cfv wcel
      vz cv crnk cfv cA crnk cfv cB crnk cfv cun wcel vz cv cB rankun.2 rankel
      vz cv crnk cfv cB crnk cfv cA crnk cfv elun2 syl jaoi sylbi rgen cA crnk
      cfv cB crnk cfv cun con0 wcel vz cv crnk cfv vy cv wcel vz cA cB cun wral
      vx cv vy cv wcel wi vy con0 wral vz cv crnk cfv cA crnk cfv cB crnk cfv
      cun wcel vz cA cB cun wral vx cv cA crnk cfv cB crnk cfv cun wcel wi wi
      cA crnk cfv cB crnk cfv cA rankon cB rankon onun2i vz cv crnk cfv vy cv
      wcel vz cA cB cun wral vx cv vy cv wcel wi vz cv crnk cfv cA crnk cfv cB
      crnk cfv cun wcel vz cA cB cun wral vx cv cA crnk cfv cB crnk cfv cun
      wcel wi vy cA crnk cfv cB crnk cfv cun con0 vy cv cA crnk cfv cB crnk cfv
      cun wceq vz cv crnk cfv vy cv wcel vz cA cB cun wral vz cv crnk cfv cA
      crnk cfv cB crnk cfv cun wcel vz cA cB cun wral vx cv vy cv wcel vx cv cA
      crnk cfv cB crnk cfv cun wcel vy cv cA crnk cfv cB crnk cfv cun wceq vz
      cv crnk cfv vy cv wcel vz cv crnk cfv cA crnk cfv cB crnk cfv cun wcel vz
      cA cB cun vy cv cA crnk cfv cB crnk cfv cun vz cv crnk cfv eleq2 ralbidv
      vy cv cA crnk cfv cB crnk cfv cun vx cv eleq2 imbi12d rcla4v ax-mp mpi
      sylbi ssriv cA crnk cfv cB crnk cfv cA cB cun crnk cfv cA cA cB cun wss
      cA crnk cfv cA cB cun crnk cfv wss cA cB ssun1 cA cA cB cun cA cB
      rankun.1 rankun.2 unex rankss ax-mp cB cA cB cun wss cB crnk cfv cA cB
      cun crnk cfv wss cB cA ssun2 cB cA cB cun cA cB rankun.1 rankun.2 unex
      rankss ax-mp unssi eqssi $.
      $( [25-Aug-2004] $) $( [26-Nov-2003] $)

    $( The rank of an unordered pair.  Part of Exercise 30 of [Enderton]
       p. 207. $)
    rankpr $p |- ( rank ` { A , B } ) = suc ( ( rank ` A ) u. ( rank ` B ) ) $=
      cA cB cpr crnk cfv cA crnk cfv csuc cB crnk cfv csuc cun cA crnk cfv cB
      crnk cfv cun csuc cA cB cpr crnk cfv cA csn cB csn cun crnk cfv cA csn
      crnk cfv cB csn crnk cfv cun cA crnk cfv csuc cB crnk cfv csuc cun cA cB
      cpr cA csn cB csn cun crnk cA cB df-pr fveq2i cA csn cB csn cA snex cB
      snex rankun cA csn crnk cfv cA crnk cfv csuc cB csn crnk cfv cB crnk cfv
      csuc cA rankun.1 ranksn cB rankun.2 ranksn uneq12i 3eqtri cA crnk cfv
      word cB crnk cfv word cA crnk cfv cB crnk cfv cun csuc cA crnk cfv csuc
      cB crnk cfv csuc cun wceq cA crnk cfv cA rankon onordi cB crnk cfv cB
      rankon onordi cA crnk cfv cB crnk cfv ordsucun mp2an eqtr4i $.
      $( [19-Sep-2004] $) $( [28-Nov-2003] $)

    $( The rank of an ordered pair.  Part of Exercise 4 of [Kunen] p. 107. $)
    rankop $p |- ( rank ` <. A , B >. ) =
                 suc suc ( ( rank ` A ) u. ( rank ` B ) ) $=
      cA cB cop crnk cfv cA csn cA cB cpr cpr crnk cfv cA csn crnk cfv cA cB
      cpr crnk cfv cun csuc cA crnk cfv cB crnk cfv cun csuc csuc cA cB cop cA
      csn cA cB cpr cpr crnk cA cB df-op fveq2i cA csn cA cB cpr cA snex cA cB
      prex rankpr cA csn crnk cfv cA cB cpr crnk cfv cun cA crnk cfv cB crnk
      cfv cun csuc wceq cA csn crnk cfv cA cB cpr crnk cfv cun csuc cA crnk cfv
      cB crnk cfv cun csuc csuc wceq cA csn cA cB cpr cun crnk cfv cA cB cpr
      crnk cfv cA csn crnk cfv cA cB cpr crnk cfv cun cA crnk cfv cB crnk cfv
      cun csuc cA csn cA cB cpr cun cA cB cpr crnk cA csn cA cB cpr wss cA csn
      cA cB cpr cun cA cB cpr wceq cA cB snsspr1 cA csn cA cB cpr ssequn1 mpbi
      fveq2i cA csn cA cB cpr cA snex cA cB prex rankun cA cB rankun.1 rankun.2
      rankpr 3eqtr3i cA csn crnk cfv cA cB cpr crnk cfv cun cA crnk cfv cB crnk
      cfv cun csuc suceq ax-mp 3eqtri $.
      $( [16-Oct-2006] $) $( [13-Sep-2006] $)
  $}

  $( Any set is a subset of the hierarchy of its rank. $)
  r1rankid $p |- ( A e. B -> A C_ ( R1 ` ( rank ` A ) ) ) $=
    cA cB wcel cA cA crnk cfv cr1 cfv cpw wcel cA cA crnk cfv cr1 cfv wss cA cB
    wcel cA cA crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv cpw cA cB wcel cA cA
    crnk cfv cr1 cfv wcel wn cA cA crnk cfv csuc cr1 cfv wcel cA cB wcel cA
    crnk cfv cA crnk cfv wceq cA cA crnk cfv cr1 cfv wcel wn cA cA crnk cfv
    csuc cr1 cfv wcel wa cA crnk cfv eqid cA cA crnk cfv cB rankr1g mpbii
    pm3.27d cA crnk cfv con0 wcel cA crnk cfv csuc cr1 cfv cA crnk cfv cr1 cfv
    cpw wceq cA rankon cA crnk cfv r1suc ax-mp syl6eleq cA cA crnk cfv cr1 cfv
    cB elpwg mpbid $.
    $( [9-Jan-2004] $) $( [14-Oct-2003] $)

  ${
    $d x y z A $.
    $( The rank of an ordinal number is itself.  Proposition 9.18 of
       [TakeutiZaring] p. 79 and its converse. $)
    rankonid $p |- ( A e. On <-> ( rank ` A ) = A ) $=
      cA con0 wcel cA crnk cfv cA wceq vx cv crnk cfv vx cv wceq vy cv crnk cfv
      vy cv wceq cA crnk cfv cA wceq vx vy cA vx cv vy cv wceq vx cv crnk cfv
      vy cv crnk cfv vx cv vy cv vx cv vy cv crnk fveq2 vx cv vy cv wceq id
      eqeq12d vx cv cA wceq vx cv crnk cfv cA crnk cfv vx cv cA vx cv cA crnk
      fveq2 vx cv cA wceq id eqeq12d vx cv con0 wcel vy cv crnk cfv vy cv wceq
      vy vx cv wral vx cv crnk cfv vx cv wceq vy cv crnk cfv vy cv wceq vy vx
      cv wral vx cv con0 wcel vx cv crnk cfv vx cv vz cv wss vz con0 crab cint
      vx cv vy cv crnk cfv vy cv wceq vy vx cv wral vy cv crnk cfv vz cv wcel
      vy vx cv wral vz con0 crab cint vx cv vz cv wss vz con0 crab cint vx cv
      crnk cfv vy cv crnk cfv vy cv wceq vy vx cv wral vy cv crnk cfv vz cv
      wcel vy vx cv wral vz con0 crab vx cv vz cv wss vz con0 crab vy cv crnk
      cfv vy cv wceq vy vx cv wral vy cv crnk cfv vz cv wcel vy vx cv wral vx
      cv vz cv wss vz con0 vy cv crnk cfv vy cv wceq vy vx cv wral vy cv crnk
      cfv vz cv wcel vy vx cv wral vy cv vz cv wcel vy vx cv wral vx cv vz cv
      wss vy cv crnk cfv vy cv wceq vy vx cv wral vy cv crnk cfv vz cv wcel vy
      cv vz cv wcel wb vy vx cv wral vy cv crnk cfv vz cv wcel vy vx cv wral vy
      cv vz cv wcel vy vx cv wral wb vy cv crnk cfv vy cv wceq vy cv crnk cfv
      vz cv wcel vy cv vz cv wcel wb vy vx cv vy cv crnk cfv vy cv vz cv eleq1
      r19.20si vy cv crnk cfv vz cv wcel vy cv vz cv wcel vy vx cv r19.15 syl
      vy vx cv vz cv dfss3 syl6bbr rabbisdv inteqd vz vy vx cv vx visset
      rankval3 syl5eq vz vx cv con0 intmin sylan9eqr ex tfis3 cA crnk cfv cA
      wceq cA crnk cfv con0 wcel cA con0 wcel cA rankon cA crnk cfv cA con0
      eleq1 mpbii impbii $.
      $( [25-Nov-2003] $) $( [14-Oct-2003] $)
  $}

  ${
    $d x A $.
    rankeq0.1 $e |- A e. _V $.
    $( A set is empty iff its rank is empty. $)
    rankeq0 $p |- ( A = (/) <-> ( rank ` A ) = (/) ) $=
      cA c0 wceq cA crnk cfv c0 wceq cA c0 wceq cA crnk cfv c0 crnk cfv c0 cA
      c0 crnk fveq2 c0 con0 wcel c0 crnk cfv c0 wceq 0elon c0 rankonid mpbi
      syl6eq cA crnk cfv c0 wceq cA vx cv cr1 cfv wss vx con0 crab cint c0 wceq
      cA c0 wceq cA crnk cfv cA vx cv cr1 cfv wss vx con0 crab cint c0 cA cvv
      wcel cA crnk cfv cA vx cv cr1 cfv wss vx con0 crab cint wceq rankeq0.1 vx
      cA cvv rankval2 ax-mp eqeq1i cA vx cv cr1 cfv wss vx con0 crab cint c0
      wceq cA c0 wss cA c0 wceq cA vx cv cr1 cfv wss vx con0 crab cint c0 wceq
      c0 cA vx cv cr1 cfv wss vx con0 crab wcel c0 con0 wcel cA c0 cr1 cfv wss
      wa cA c0 wss cA vx cv cr1 cfv wss vx con0 crab con0 wss cA vx cv cr1 cfv
      wss vx con0 crab cint c0 wceq c0 cA vx cv cr1 cfv wss vx con0 crab wcel
      wb cA vx cv cr1 cfv wss vx con0 ssrab2 cA vx cv cr1 cfv wss vx con0 crab
      onint0 ax-mp cA vx cv cr1 cfv wss cA c0 cr1 cfv wss vx c0 con0 vx cv c0
      wceq vx cv cr1 cfv c0 cr1 cfv cA vx cv c0 cr1 fveq2 sseq2d elrab c0 con0
      wcel cA c0 cr1 cfv wss wa cA c0 cr1 cfv wss cA c0 wss c0 con0 wcel cA c0
      cr1 cfv wss 0elon biantrur c0 cr1 cfv c0 cA r10 sseq2i bitr3i 3bitri cA
      ss0 sylbi sylbi impbii $.
      $( [23-Sep-2006] $) $( [18-Sep-2006] $)
  $}

  ${
    $d x y z A $.
    $( The rank of the hierarchy of an ordinal number is itself. $)
    rankr1id $p |- ( A e. On <-> ( rank ` ( R1 ` A ) ) = A ) $=
      cA con0 wcel cA cr1 cfv crnk cfv cA wceq vx cv cr1 cfv crnk cfv vx cv
      wceq cA cr1 cfv crnk cfv cA wceq vx cA con0 vx cv cA wceq vx cv cr1 cfv
      crnk cfv cA cr1 cfv crnk cfv vx cv cA vx cv cA wceq vx cv cr1 cfv cA cr1
      cfv crnk vx cv cA cr1 fveq2 fveq2d vx cv cA wceq id eqeq12d vx cv con0
      wcel vx cv cr1 cfv crnk cfv vx cv vx cv con0 wcel vx cv cr1 cfv vy cv cr1
      cfv wss vy con0 crab cint vx cv vx cv cr1 cfv crnk cfv vx cv con0 wcel vx
      cv cr1 cfv vy cv cr1 cfv wss vy con0 crab cint vx cv vy cv wss vy con0
      crab cint vx cv vx cv con0 wcel vx cv vy cv wss vy con0 crab vx cv cr1
      cfv vy cv cr1 cfv wss vy con0 crab wss vx cv cr1 cfv vy cv cr1 cfv wss vy
      con0 crab cint vx cv vy cv wss vy con0 crab cint wss vx cv con0 wcel vx
      cv vy cv wss vx cv cr1 cfv vy cv cr1 cfv wss vy con0 vx cv vy cv r1ord3
      ss2rabdv vx cv vy cv wss vy con0 crab vx cv cr1 cfv vy cv cr1 cfv wss vy
      con0 crab intss syl vy vx cv con0 intmin sseqtrd vx cv cr1 cfv cvv wcel
      vx cv cr1 cfv crnk cfv vx cv cr1 cfv vy cv cr1 cfv wss vy con0 crab cint
      wceq vx cv cr1 fvex vy vx cv cr1 cfv cvv rankval2 ax-mp syl5ss vx cv con0
      wcel vx cv crnk cfv vx cv wceq vx cv vx cv cr1 cfv crnk cfv wss vx cv
      rankonid vx cv crnk cfv vx cv wceq vx cv crnk cfv vx cv cr1 cfv crnk cfv
      wss vx cv vx cv cr1 cfv crnk cfv wss vx cv crnk cfv vx cv wceq vx cv vx
      cv cr1 cfv wss vx cv crnk cfv vx cv cr1 cfv crnk cfv wss vx cv crnk cfv
      vx cv wceq vx cv vx cv crnk cfv cr1 cfv wss vx cv vx cv cr1 cfv wss vx cv
      cvv wcel vx cv vx cv crnk cfv cr1 cfv wss vx visset vx cv cvv r1rankid
      ax-mp vx cv crnk cfv vx cv wceq vx cv crnk cfv cr1 cfv vx cv cr1 cfv vx
      cv vx cv crnk cfv vx cv cr1 fveq2 sseq2d mpbii vx cv vx cv cr1 cfv vx cv
      cr1 fvex rankss syl vx cv crnk cfv vx cv vx cv cr1 cfv crnk cfv sseq1
      mpbid sylbi eqssd vtoclga cA cr1 cfv crnk cfv cA wceq cA cr1 cfv crnk cfv
      con0 wcel cA con0 wcel cA cr1 cfv rankon cA cr1 cfv crnk cfv cA con0
      eleq1 mpbii impbii $.
      $( [25-Nov-2003] $) $( [14-Oct-2003] $)

    $( The rank of a union.  Part of Exercise 4 of [Kunen] p. 107. $)
    rankuni $p |- ( rank ` U. A ) = U. ( rank ` A ) $=
      cA cvv wcel cA cuni crnk cfv cA crnk cfv cuni wceq vx cv cuni crnk cfv vx
      cv crnk cfv cuni wceq cA cuni crnk cfv cA crnk cfv cuni wceq vx cA cvv vx
      cv cA wceq vx cv cuni crnk cfv cA cuni crnk cfv vx cv crnk cfv cuni cA
      crnk cfv cuni vx cv cA wceq vx cv cuni cA cuni crnk vx cv cA unieq fveq2d
      vx cv cA wceq vx cv crnk cfv cA crnk cfv vx cv cA crnk fveq2 unieqd
      eqeq12d vx cv cuni crnk cfv vx cv crnk cfv cuni vx cv cuni crnk cfv vy cv
      vz cv crnk cfv wceq vz vx cv wrex vy cab cuni vx cv crnk cfv cuni vx cv
      cuni crnk cfv vz vx cv vz cv crnk cfv ciun vy cv vz cv crnk cfv wceq vz
      vx cv wrex vy cab cuni vz vx cv vx visset rankuni2 vz vy vx cv vz cv crnk
      cfv vz cv crnk fvex dfiun2 eqtri vy cv vz cv crnk cfv wceq vz vx cv wrex
      vy cab vx cv crnk cfv wss vy cv vz cv crnk cfv wceq vz vx cv wrex vy cab
      cuni vx cv crnk cfv cuni wss vy cv vz cv crnk cfv wceq vz vx cv wrex vy
      vx cv crnk cfv vy cv vz cv crnk cfv wceq vz vx cv wrex vz cv vx cv wcel
      vy cv vz cv crnk cfv wceq wa vz wex vy cv vx cv crnk cfv wcel vy cv vz cv
      crnk cfv wceq vz vx cv df-rex vz cv vx cv wcel vy cv vz cv crnk cfv wceq
      wa vz wex vz cv crnk cfv vx cv crnk cfv wcel vy cv vz cv crnk cfv wceq wa
      vz wex vy cv vx cv crnk cfv wcel vz cv vx cv wcel vy cv vz cv crnk cfv
      wceq wa vz cv crnk cfv vx cv crnk cfv wcel vy cv vz cv crnk cfv wceq wa
      vz vz cv vx cv wcel vz cv crnk cfv vx cv crnk cfv wcel vy cv vz cv crnk
      cfv wceq vz cv vx cv vx visset rankel anim1i 19.22i vy cv vx cv crnk cfv
      wcel vy cv vz cv crnk cfv wceq wa vz wex vy cv vx cv crnk cfv wcel vy cv
      vz cv crnk cfv wceq vz wex wa vz cv crnk cfv vx cv crnk cfv wcel vy cv vz
      cv crnk cfv wceq wa vz wex vy cv vx cv crnk cfv wcel vy cv vx cv crnk cfv
      wcel vy cv vz cv crnk cfv wceq vz 19.42v vy cv vx cv crnk cfv wcel vy cv
      vz cv crnk cfv wceq wa vz cv crnk cfv vx cv crnk cfv wcel vy cv vz cv
      crnk cfv wceq wa vz vy cv vz cv crnk cfv wceq vy cv vx cv crnk cfv wcel
      vz cv crnk cfv vx cv crnk cfv wcel vy cv vz cv crnk cfv vx cv crnk cfv
      eleq1 pm5.32ri exbii vy cv vx cv crnk cfv wcel vy cv vz cv crnk cfv wceq
      vz wex wa vy cv vx cv crnk cfv wcel vy cv vx cv crnk cfv wcel vy cv vz cv
      crnk cfv wceq vz wex pm3.26 vy cv vx cv crnk cfv wcel vy cv vz cv crnk
      cfv wceq vz wex vy cv vx cv crnk cfv wcel vy cv vy cv cr1 cfv crnk cfv
      wceq vy cv vz cv crnk cfv wceq vz wex vy cv vx cv crnk cfv wcel vy cv cr1
      cfv crnk cfv vy cv vy cv vx cv crnk cfv wcel vy cv con0 wcel vy cv cr1
      cfv crnk cfv vy cv wceq vx cv crnk cfv vy cv vx cv rankon oneli vy cv
      rankr1id sylib eqcomd vy cv vz cv crnk cfv wceq vy cv vy cv cr1 cfv crnk
      cfv wceq vz vy cv cr1 cfv vy cv cr1 fvex vz cv vy cv cr1 cfv wceq vz cv
      crnk cfv vy cv cr1 cfv crnk cfv vy cv vz cv vy cv cr1 cfv crnk fveq2
      eqeq2d cla4ev syl ancli impbii 3bitr3i sylib sylbi abssi vy cv vz cv crnk
      cfv wceq vz vx cv wrex vy cab vx cv crnk cfv uniss ax-mp eqsstri vx cv
      crnk cfv cuni vx cv cuni crnk cfv csuc cuni vx cv cuni crnk cfv vx cv
      crnk cfv vx cv cuni crnk cfv csuc wss vx cv crnk cfv cuni vx cv cuni crnk
      cfv csuc cuni wss vx cv crnk cfv vx cv cuni cpw crnk cfv vx cv cuni crnk
      cfv csuc vx cv vx cv cuni cpw wss vx cv crnk cfv vx cv cuni cpw crnk cfv
      wss vx cv pwuni vx cv vx cv cuni cpw vx cv cuni vx cv vx visset uniex
      pwex rankss ax-mp vx cv cuni vx cv vx visset uniex rankpw sseqtri vx cv
      crnk cfv vx cv cuni crnk cfv csuc uniss ax-mp vx cv cuni crnk cfv vx cv
      cuni rankon onunisuci sseqtri eqssi vtoclg cA cvv wcel wn cA cuni crnk
      cfv c0 cuni cA crnk cfv cuni cA cvv wcel wn cA cuni crnk cfv c0 c0 cuni
      cA cvv wcel wn cA cuni cvv wcel wn cA cuni crnk cfv c0 wceq cA cvv wcel
      cA cuni cvv wcel cA uniexb notbii cA cuni crnk fvprc sylbi uni0 syl6eqr
      cA cvv wcel wn cA crnk cfv c0 cA crnk fvprc unieqd eqtr4d pm2.61i $.
      $( [28-Sep-2006] $) $( [15-Sep-2006] $)
  $}

  ${
    $d x y z A $.  $d x B $.
    rankr1b.1 $e |- A e. _V $.
    $( A relationship between rank and ` R1 ` .  See ~ rankr1a for the
       membership version. $)
    rankr1b $p |- ( B e. On -> ( A C_ ( R1 ` B ) <-> ( rank ` A ) C_ B ) ) $=
      cB con0 wcel cA cB cr1 cfv wss cA crnk cfv cB wss cB con0 wcel cA crnk
      cfv cB cr1 cfv crnk cfv wss cA crnk cfv cB wss cA cB cr1 cfv wss cB con0
      wcel cB cr1 cfv crnk cfv cB cA crnk cfv cB con0 wcel cB cr1 cfv crnk cfv
      cB wceq cB rankr1id biimpi sseq2d cA cB cr1 cfv cB cr1 fvex rankss syl5bi
      cB con0 wcel cA crnk cfv cB wss cA crnk cfv cr1 cfv cB cr1 cfv wss cA cB
      cr1 cfv wss cA crnk cfv con0 wcel cB con0 wcel cA crnk cfv cB wss cA crnk
      cfv cr1 cfv cB cr1 cfv wss wi cA rankon cA crnk cfv cB r1ord3 mpan cA cA
      crnk cfv cr1 cfv wss cA crnk cfv cr1 cfv cB cr1 cfv wss cA cB cr1 cfv wss
      cA cvv wcel cA cA crnk cfv cr1 cfv wss rankr1b.1 cA cvv r1rankid ax-mp cA
      cA crnk cfv cr1 cfv cB cr1 cfv sstr mpan syl6 impbid $.
      $( [22-Sep-2006] $) $( [15-Sep-2006] $)

    $( The rank of a successor. $)
    ranksuc $p |- ( rank ` suc A ) = suc ( rank ` A ) $=
      cA csuc crnk cfv cA cA csn cun crnk cfv cA crnk cfv cA csn crnk cfv cun
      cA crnk cfv csuc cA csuc cA cA csn cun crnk cA df-suc fveq2i cA cA csn
      rankr1b.1 cA snex rankun cA crnk cfv cA csn crnk cfv cun cA crnk cfv cA
      crnk cfv csuc cun cA crnk cfv csuc cA csn crnk cfv cA crnk cfv csuc cA
      crnk cfv cA rankr1b.1 ranksn uneq2i cA crnk cfv cA crnk cfv csuc wss cA
      crnk cfv cA crnk cfv csuc cun cA crnk cfv csuc wceq cA crnk cfv sssucid
      cA crnk cfv cA crnk cfv csuc ssequn1 mpbi eqtri 3eqtri $.
      $( [13-Dec-2006] $) $( [18-Sep-2006] $)

    $( Upper bound of the rank of a union.  Part of Exercise 30 of [Enderton]
       p. 207. $)
    rankuniss $p |- ( rank ` U. A ) C_ ( rank ` A ) $=
      cA cuni crnk cfv cA crnk cfv cuni cA crnk cfv cA rankuni cA crnk cfv word
      cA crnk cfv cuni cA crnk cfv wss cA crnk cfv cA rankon onordi cA crnk cfv
      orduniss ax-mp eqsstri $.
      $( [30-Nov-2003] $) $( [30-Nov-2003] $)

    $( The rank of a set is the supremum of the successors of the ranks of its
       members.  Exercise 9.1 of [Jech] p. 72.  Also a special case of Theorem
       7V(b) of [Enderton] p. 204. $)
    rankval4 $p |- ( rank ` A ) = U_ x e. A suc ( rank ` x ) $=
      cA crnk cfv vx cA vx cv crnk cfv csuc ciun cA crnk cfv vx cA vx cv crnk
      cfv csuc ciun cr1 cfv crnk cfv vx cA vx cv crnk cfv csuc ciun cA vx cA vx
      cv crnk cfv csuc ciun cr1 cfv wss cA crnk cfv vx cA vx cv crnk cfv csuc
      ciun cr1 cfv crnk cfv wss cA vx cA vx cv crnk cfv csuc ciun cr1 cfv wss
      vx cv cA wcel vx cv vx cA vx cv crnk cfv csuc ciun cr1 cfv wcel wi vx vx
      vy cA vx cA vx cv crnk cfv csuc ciun cr1 cfv vy cv cA wcel vx ax-17 vx vy
      vx cA vx cv crnk cfv csuc ciun cr1 vy cv cr1 wcel vx ax-17 vx vy cA vx cv
      crnk cfv csuc hbiu1 hbfv dfss2f vx cv cA wcel vx cv vx cv crnk cfv csuc
      cr1 cfv wcel vx cv vx cA vx cv crnk cfv csuc ciun cr1 cfv wcel vx cv vx
      visset rankid vx cv cA wcel vx cv crnk cfv csuc cr1 cfv vx cA vx cv crnk
      cfv csuc ciun cr1 cfv vx cv vx cv cA wcel vx cv crnk cfv csuc vx cA vx cv
      crnk cfv csuc ciun wss vx cv crnk cfv csuc cr1 cfv vx cA vx cv crnk cfv
      csuc ciun cr1 cfv wss vx cA vx cv crnk cfv csuc ssiun2 vx cv crnk cfv
      csuc con0 wcel vx cA vx cv crnk cfv csuc ciun con0 wcel vx cv crnk cfv
      csuc vx cA vx cv crnk cfv csuc ciun wss vx cv crnk cfv csuc cr1 cfv vx cA
      vx cv crnk cfv csuc ciun cr1 cfv wss wi vx cv crnk cfv vx cv rankon
      onsuci vx cv crnk cfv csuc con0 wcel vx cA vx cv crnk cfv csuc ciun con0
      wcel vx cA vx cA vx cv crnk cfv csuc rankr1b.1 vx cv crnk cfv vx cv crnk
      fvex sucex iunon vx cv crnk cfv csuc con0 wcel vx cv cA wcel vx cv crnk
      cfv vx cv rankon onsuci a1i mprg vx cv crnk cfv csuc vx cA vx cv crnk cfv
      csuc ciun r1ord3 mp2an syl sseld mpi mpgbir cA vx cA vx cv crnk cfv csuc
      ciun cr1 cfv vx cA vx cv crnk cfv csuc ciun cr1 fvex rankss ax-mp vx cA
      vx cv crnk cfv csuc ciun cr1 cfv vy cv cr1 cfv wss vy con0 crab cint vx
      cA vx cv crnk cfv csuc ciun vy cv wss vy con0 crab cint vx cA vx cv crnk
      cfv csuc ciun cr1 cfv crnk cfv vx cA vx cv crnk cfv csuc ciun vx cA vx cv
      crnk cfv csuc ciun vy cv wss vy con0 crab vx cA vx cv crnk cfv csuc ciun
      cr1 cfv vy cv cr1 cfv wss vy con0 crab wss vx cA vx cv crnk cfv csuc ciun
      cr1 cfv vy cv cr1 cfv wss vy con0 crab cint vx cA vx cv crnk cfv csuc
      ciun vy cv wss vy con0 crab cint wss vx cA vx cv crnk cfv csuc ciun vy cv
      wss vx cA vx cv crnk cfv csuc ciun cr1 cfv vy cv cr1 cfv wss vy con0 vx
      cA vx cv crnk cfv csuc ciun con0 wcel vy cv con0 wcel vx cA vx cv crnk
      cfv csuc ciun vy cv wss vx cA vx cv crnk cfv csuc ciun cr1 cfv vy cv cr1
      cfv wss wi vx cv crnk cfv csuc con0 wcel vx cA vx cv crnk cfv csuc ciun
      con0 wcel vx cA vx cA vx cv crnk cfv csuc rankr1b.1 vx cv crnk cfv vx cv
      crnk fvex sucex iunon vx cv crnk cfv csuc con0 wcel vx cv cA wcel vx cv
      crnk cfv vx cv rankon onsuci a1i mprg vx cA vx cv crnk cfv csuc ciun vy
      cv r1ord3 mpan ss2rabi vx cA vx cv crnk cfv csuc ciun vy cv wss vy con0
      crab vx cA vx cv crnk cfv csuc ciun cr1 cfv vy cv cr1 cfv wss vy con0
      crab intss ax-mp vx cA vx cv crnk cfv csuc ciun cr1 cfv cvv wcel vx cA vx
      cv crnk cfv csuc ciun cr1 cfv crnk cfv vx cA vx cv crnk cfv csuc ciun cr1
      cfv vy cv cr1 cfv wss vy con0 crab cint wceq vx cA vx cv crnk cfv csuc
      ciun cr1 fvex vy vx cA vx cv crnk cfv csuc ciun cr1 cfv cvv rankval2
      ax-mp vx cA vx cv crnk cfv csuc ciun vy cv wss vy con0 crab cint vx cA vx
      cv crnk cfv csuc ciun vx cA vx cv crnk cfv csuc ciun con0 wcel vx cA vx
      cv crnk cfv csuc ciun vy cv wss vy con0 crab cint vx cA vx cv crnk cfv
      csuc ciun wceq vx cv crnk cfv csuc con0 wcel vx cA vx cv crnk cfv csuc
      ciun con0 wcel vx cA vx cA vx cv crnk cfv csuc rankr1b.1 vx cv crnk cfv
      vx cv crnk fvex sucex iunon vx cv crnk cfv csuc con0 wcel vx cv cA wcel
      vx cv crnk cfv vx cv rankon onsuci a1i mprg vy vx cA vx cv crnk cfv csuc
      ciun con0 intmin ax-mp eqcomi 3sstr4i sstri vx cA vx cv crnk cfv csuc
      ciun cA crnk cfv wss vx cv crnk cfv csuc cA crnk cfv wss vx cA vx cA vx
      cv crnk cfv csuc cA crnk cfv iunss vx cv cA wcel vx cv crnk cfv cA crnk
      cfv wcel vx cv crnk cfv csuc cA crnk cfv wss vx cv cA rankr1b.1 rankel vx
      cv crnk cfv cA crnk cfv vx cv rankon cA rankon onsucssi sylib mprgbir
      eqssi $.
      $( [7-Nov-2004] $) $( [12-Oct-2003] $)

    $( The rank of a set is bounded by a bound for the successor of its
       members. $)
    rankbnd $p |- ( A. x e. A suc ( rank ` x ) C_ B <-> ( rank ` A ) C_ B ) $=
      cA crnk cfv cB wss vx cA vx cv crnk cfv csuc ciun cB wss vx cv crnk cfv
      csuc cB wss vx cA wral cA crnk cfv vx cA vx cv crnk cfv csuc ciun cB vx
      cA rankr1b.1 rankval4 sseq1i vx cA vx cv crnk cfv csuc cB iunss bitr2i $.
      $( [21-Sep-2006] $) $( [18-Sep-2006] $)

    $( The rank of a set is bounded by the successor of a bound for its
       members. $)
    rankbnd2 $p |- ( B e. On -> ( A. x e. A ( rank ` x ) C_ B <->
                  ( rank ` A ) C_ suc B ) ) $=
      cB con0 wcel cA crnk cfv cuni cB wss cA crnk cfv cB csuc wss vx cv crnk
      cfv cB wss vx cA wral cA crnk cfv con0 wss cB word cA crnk cfv cuni cB
      wss cA crnk cfv cB csuc wss wb cB con0 wcel cA crnk cfv cB ordunisssuc cA
      crnk cfv cA rankon onssi cB eloni sylancr cA crnk cfv cuni cB wss vx cA
      vx cv crnk cfv ciun cB wss vx cv crnk cfv cB wss vx cA wral cA crnk cfv
      cuni vx cA vx cv crnk cfv ciun cB cA cuni crnk cfv cA crnk cfv cuni vx cA
      vx cv crnk cfv ciun cA rankuni vx cA rankr1b.1 rankuni2 eqtr3i sseq1i vx
      cA vx cv crnk cfv cB iunss bitr2i syl5bb $.
      $( [5-Jan-2007] $) $( [15-Sep-2006] $)

    $( A relationship that can be used for computation of rank. $)
    rankc1 $p |- ( A. x e. A ( rank ` x ) e. ( rank ` U. A ) <->
                 ( rank ` A ) = ( rank ` U. A ) ) $=
      cA crnk cfv cA cuni crnk cfv wss cA crnk cfv cA cuni crnk cfv wss cA cuni
      crnk cfv cA crnk cfv wss wa vx cv crnk cfv cA cuni crnk cfv wcel vx cA
      wral cA crnk cfv cA cuni crnk cfv wceq cA cuni crnk cfv cA crnk cfv wss
      cA crnk cfv cA cuni crnk cfv wss cA rankr1b.1 rankuniss biantru vx cA vx
      cv crnk cfv csuc ciun cA cuni crnk cfv wss vx cv crnk cfv csuc cA cuni
      crnk cfv wss vx cA wral cA crnk cfv cA cuni crnk cfv wss vx cv crnk cfv
      cA cuni crnk cfv wcel vx cA wral vx cA vx cv crnk cfv csuc cA cuni crnk
      cfv iunss cA crnk cfv vx cA vx cv crnk cfv csuc ciun cA cuni crnk cfv vx
      cA rankr1b.1 rankval4 sseq1i vx cv crnk cfv cA cuni crnk cfv wcel vx cv
      crnk cfv csuc cA cuni crnk cfv wss vx cA vx cv crnk cfv cA cuni crnk cfv
      vx cv rankon cA cuni rankon onsucssi ralbii 3bitr4ri cA crnk cfv cA cuni
      crnk cfv eqss 3bitr4i $.
      $( [16-Jan-2007] $) $( [16-Sep-2006] $)

    $( A relationship that can be used for computation of rank. $)
    rankc2 $p |- ( E. x e. A ( rank ` x ) = ( rank ` U. A ) ->
                 ( rank ` A ) = suc ( rank ` U. A ) ) $=
      vx cv crnk cfv cA cuni crnk cfv wceq vx cA wrex cA crnk cfv cA cuni crnk
      cfv csuc cA crnk cfv cA cuni crnk cfv csuc wss vx cv crnk cfv cA cuni
      crnk cfv wceq vx cA wrex cA crnk cfv cA cuni cpw crnk cfv cA cuni crnk
      cfv csuc cA cA cuni cpw wss cA crnk cfv cA cuni cpw crnk cfv wss cA pwuni
      cA cA cuni cpw cA cuni cA rankr1b.1 uniex pwex rankss ax-mp cA cuni cA
      rankr1b.1 uniex rankpw sseqtri a1i vx cv crnk cfv cA cuni crnk cfv wceq
      vx cA wrex cA cuni crnk cfv cA crnk cfv wcel cA cuni crnk cfv csuc cA
      crnk cfv wss vx cv crnk cfv cA cuni crnk cfv wceq cA cuni crnk cfv cA
      crnk cfv wcel vx cA vx cv crnk cfv cA cuni crnk cfv wceq vx cv crnk cfv
      cA crnk cfv wcel cA cuni crnk cfv cA crnk cfv wcel vx cv cA wcel vx cv
      crnk cfv cA cuni crnk cfv cA crnk cfv eleq1 vx cv cA rankr1b.1 rankel
      syl5cbi r19.23aiv cA cuni crnk cfv cA crnk cfv cA cuni rankon cA rankon
      onsucssi sylib eqssd $.
      $( [7-Jul-2007] $) $( [16-Sep-2006] $)
  $}

  ${
    rankelun.1 $e |- A e. _V $.
    rankelun.2 $e |- B e. _V $.
    rankelun.3 $e |- C e. _V $.
    rankelun.4 $e |- D e. _V $.
    $( Rank membership is inherited by union. $)
    rankelun $p |- ( ( ( rank ` A ) e. ( rank ` C ) /\ ( rank ` B ) e.
          ( rank ` D ) ) -> ( rank ` ( A u. B ) ) e. ( rank ` ( C u. D ) ) ) $=
      cA crnk cfv cC crnk cfv wcel cB crnk cfv cD crnk cfv wcel wa cA cB cun
      crnk cfv cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv cC cD cun
      crnk cfv cA cC crnk cfv cr1 cfv wcel cB cD crnk cfv cr1 cfv wcel cA cB
      cun crnk cfv cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv wcel cA
      crnk cfv cC crnk cfv wcel cB crnk cfv cD crnk cfv wcel cA cC crnk cfv cr1
      cfv wcel cB cD crnk cfv cr1 cfv wcel wa cA cB cun crnk cfv csuc cC crnk
      cfv cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv wss cA cB cun crnk cfv cC
      crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv wcel cA cC crnk cfv cr1
      cfv wcel cB cD crnk cfv cr1 cfv wcel wa cA cB cpr crnk cfv cC crnk cfv
      cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv cA cB cun crnk cfv csuc cA cC
      crnk cfv cr1 cfv wcel cB cD crnk cfv cr1 cfv wcel wa cA cB cpr cC crnk
      cfv cr1 cfv cD crnk cfv cr1 cfv cun wss cA cB cpr crnk cfv cC crnk cfv
      cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv wss cA cC crnk cfv cr1 cfv wcel
      cB cD crnk cfv cr1 cfv wcel wa cA cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv
      cun wcel cB cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun wcel wa cA cB cpr
      cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun wss cA cC crnk cfv cr1 cfv
      wcel cA cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun wcel cB cD crnk cfv
      cr1 cfv wcel cB cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun wcel cA cC
      crnk cfv cr1 cfv cD crnk cfv cr1 cfv elun1 cB cD crnk cfv cr1 cfv cC crnk
      cfv cr1 cfv elun2 anim12i cA cB cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv
      cun rankelun.1 rankelun.2 prss sylib cA cB cpr cC crnk cfv cr1 cfv cD
      crnk cfv cr1 cfv cun cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cC crnk cfv
      cr1 fvex cD crnk cfv cr1 fvex unex rankss syl cA cB cpr crnk cfv cA crnk
      cfv cB crnk cfv cun csuc cA cB cun crnk cfv csuc cA cB rankelun.1
      rankelun.2 rankpr cA cB cun crnk cfv cA crnk cfv cB crnk cfv cun wceq cA
      cB cun crnk cfv csuc cA crnk cfv cB crnk cfv cun csuc wceq cA cB
      rankelun.1 rankelun.2 rankun cA cB cun crnk cfv cA crnk cfv cB crnk cfv
      cun suceq ax-mp eqtr4i syl5ssr cA cB cun crnk cfv cvv wcel cA cB cun crnk
      cfv csuc cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv wss cA cB
      cun crnk cfv cC crnk cfv cr1 cfv cD crnk cfv cr1 cfv cun crnk cfv wcel wi
      cA cB cun crnk fvex cA cB cun crnk cfv cC crnk cfv cr1 cfv cD crnk cfv
      cr1 cfv cun crnk cfv cvv sucssel ax-mp syl cC crnk cfv con0 wcel cA cC
      crnk cfv cr1 cfv wcel cA crnk cfv cC crnk cfv wcel wb cC rankon cA cC
      crnk cfv rankelun.1 rankr1a ax-mp cD crnk cfv con0 wcel cB cD crnk cfv
      cr1 cfv wcel cB crnk cfv cD crnk cfv wcel wb cD rankon cB cD crnk cfv
      rankelun.2 rankr1a ax-mp syl2anbr cC crnk cfv cr1 cfv crnk cfv cD crnk
      cfv cr1 cfv crnk cfv cun cC crnk cfv cD crnk cfv cun cC crnk cfv cr1 cfv
      cD crnk cfv cr1 cfv cun crnk cfv cC cD cun crnk cfv cC crnk cfv cr1 cfv
      crnk cfv cC crnk cfv cD crnk cfv cr1 cfv crnk cfv cD crnk cfv cC crnk cfv
      con0 wcel cC crnk cfv cr1 cfv crnk cfv cC crnk cfv wceq cC rankon cC crnk
      cfv rankr1id mpbi cD crnk cfv con0 wcel cD crnk cfv cr1 cfv crnk cfv cD
      crnk cfv wceq cD rankon cD crnk cfv rankr1id mpbi uneq12i cC crnk cfv cr1
      cfv cD crnk cfv cr1 cfv cC crnk cfv cr1 fvex cD crnk cfv cr1 fvex rankun
      cC cD rankelun.3 rankelun.4 rankun 3eqtr4i syl6eleq $.
      $( [20-Sep-2006] $) $( [18-Sep-2006] $)

    $( Rank membership is inherited by unordered pairs. $)
    rankelpr $p |- ( ( ( rank ` A ) e. ( rank ` C ) /\ ( rank ` B ) e.
            ( rank ` D ) ) -> ( rank ` { A , B } ) e. ( rank ` { C , D } ) ) $=
      cA crnk cfv cC crnk cfv wcel cB crnk cfv cD crnk cfv wcel wa cA crnk cfv
      cB crnk cfv cun csuc cC cD cpr crnk cfv cA cB cpr crnk cfv cA crnk cfv cC
      crnk cfv wcel cB crnk cfv cD crnk cfv wcel wa cA crnk cfv cB crnk cfv cun
      csuc cC crnk cfv cD crnk cfv cun csuc cC cD cpr crnk cfv cA crnk cfv cC
      crnk cfv wcel cB crnk cfv cD crnk cfv wcel wa cA crnk cfv cB crnk cfv cun
      cC crnk cfv cD crnk cfv cun wcel cA crnk cfv cB crnk cfv cun csuc cC crnk
      cfv cD crnk cfv cun csuc wcel cA crnk cfv cC crnk cfv wcel cB crnk cfv cD
      crnk cfv wcel wa cA cB cun crnk cfv cC crnk cfv cD crnk cfv cun cA crnk
      cfv cB crnk cfv cun cA crnk cfv cC crnk cfv wcel cB crnk cfv cD crnk cfv
      wcel wa cA cB cun crnk cfv cC cD cun crnk cfv cC crnk cfv cD crnk cfv cun
      cA cB cC cD rankelun.1 rankelun.2 rankelun.3 rankelun.4 rankelun cC cD
      rankelun.3 rankelun.4 rankun syl6eleq cA cB rankelun.1 rankelun.2 rankun
      syl5eqelr cC crnk cfv cD crnk cfv cun word cA crnk cfv cB crnk cfv cun cC
      crnk cfv cD crnk cfv cun wcel cA crnk cfv cB crnk cfv cun csuc cC crnk
      cfv cD crnk cfv cun csuc wcel wb cC crnk cfv cD crnk cfv cun cC crnk cfv
      cD crnk cfv cC rankon cD rankon onun2i onordi cA crnk cfv cB crnk cfv cun
      cC crnk cfv cD crnk cfv cun ordsucelsuc ax-mp sylib cC cD rankelun.3
      rankelun.4 rankpr syl6eleqr cA cB rankelun.1 rankelun.2 rankpr syl5eqel
      $.
      $( [23-Oct-2006] $) $( [18-Sep-2006] $)

    $( Rank membership is inherited by ordered pairs. $)
    rankelop $p |- ( ( ( rank ` A ) e. ( rank ` C ) /\ ( rank ` B ) e.
        ( rank ` D ) ) -> ( rank ` <. A , B >. ) e. ( rank ` <. C , D >. ) ) $=
      cA crnk cfv cC crnk cfv wcel cB crnk cfv cD crnk cfv wcel wa cA cB cpr
      crnk cfv csuc cC cD cop crnk cfv cA cB cop crnk cfv cA crnk cfv cC crnk
      cfv wcel cB crnk cfv cD crnk cfv wcel wa cA cB cpr crnk cfv csuc cC cD
      cpr crnk cfv csuc cC cD cop crnk cfv cA crnk cfv cC crnk cfv wcel cB crnk
      cfv cD crnk cfv wcel wa cA cB cpr crnk cfv cC cD cpr crnk cfv wcel cA cB
      cpr crnk cfv csuc cC cD cpr crnk cfv csuc wcel cA cB cC cD rankelun.1
      rankelun.2 rankelun.3 rankelun.4 rankelpr cC cD cpr crnk cfv word cA cB
      cpr crnk cfv cC cD cpr crnk cfv wcel cA cB cpr crnk cfv csuc cC cD cpr
      crnk cfv csuc wcel wb cC cD cpr crnk cfv cC cD cpr rankon onordi cA cB
      cpr crnk cfv cC cD cpr crnk cfv ordsucelsuc ax-mp sylib cC cD cpr crnk
      cfv csuc cC crnk cfv cD crnk cfv cun csuc csuc cC cD cop crnk cfv cC cD
      cpr crnk cfv cC crnk cfv cD crnk cfv cun csuc wceq cC cD cpr crnk cfv
      csuc cC crnk cfv cD crnk cfv cun csuc csuc wceq cC cD rankelun.3
      rankelun.4 rankpr cC cD cpr crnk cfv cC crnk cfv cD crnk cfv cun csuc
      suceq ax-mp cC cD rankelun.3 rankelun.4 rankop eqtr4i syl6eleq cA cB cop
      crnk cfv cA crnk cfv cB crnk cfv cun csuc csuc cA cB cpr crnk cfv csuc cA
      cB rankelun.1 rankelun.2 rankop cA cB cpr crnk cfv cA crnk cfv cB crnk
      cfv cun csuc wceq cA cB cpr crnk cfv csuc cA crnk cfv cB crnk cfv cun
      csuc csuc wceq cA cB rankelun.1 rankelun.2 rankpr cA cB cpr crnk cfv cA
      crnk cfv cB crnk cfv cun csuc suceq ax-mp eqtr4i syl5eqel $.
      $( [25-Jun-2007] $) $( [18-Sep-2006] $)
  $}

  ${
    rankxpl.1 $e |- A e. _V $.
    rankxpl.2 $e |- B e. _V $.
    $( A lower bound on the rank of a cross product. $)
    rankxpl $p |- ( ( A X. B ) =/= (/) -> ( rank ` ( A u. B ) ) C_
                  ( rank ` ( A X. B ) ) ) $=
      cA cB cxp c0 wne cA cB cun crnk cfv cA cB cxp cuni cuni crnk cfv cA cB
      cxp crnk cfv cA cB cxp c0 wne cA cB cxp cuni cuni cA cB cun crnk cA cB
      unixp fveq2d cA cB cxp cuni cuni crnk cfv cA cB cxp crnk cfv wss cA cB
      cxp c0 wne cA cB cxp cuni cuni crnk cfv cA cB cxp cuni crnk cfv cA cB cxp
      crnk cfv cA cB cxp cuni cA cB cxp cA cB rankxpl.1 rankxpl.2 xpex uniex
      rankuniss cA cB cxp cA cB rankxpl.1 rankxpl.2 xpex rankuniss sstri a1i
      eqsstr3d $.
      $( [25-Sep-2006] $) $( [18-Sep-2006] $)

    $( An upper bound on the rank of a cross product. $)
    rankxpu $p |- ( rank ` ( A X. B ) ) C_
                 suc suc ( rank ` ( A u. B ) ) $=
      cA cB cxp crnk cfv cA cB cun cpw cpw crnk cfv cA cB cun crnk cfv csuc
      csuc cA cB cxp cA cB cun cpw cpw wss cA cB cxp crnk cfv cA cB cun cpw cpw
      crnk cfv wss cA cB xpsspw cA cB cxp cA cB cun cpw cpw cA cB cun cpw cA cB
      cun cA cB rankxpl.1 rankxpl.2 unex pwex pwex rankss ax-mp cA cB cun cpw
      cpw crnk cfv cA cB cun cpw crnk cfv csuc cA cB cun crnk cfv csuc csuc cA
      cB cun cpw cA cB cun cA cB rankxpl.1 rankxpl.2 unex pwex rankpw cA cB cun
      cpw crnk cfv cA cB cun crnk cfv csuc wceq cA cB cun cpw crnk cfv csuc cA
      cB cun crnk cfv csuc csuc wceq cA cB cun cA cB rankxpl.1 rankxpl.2 unex
      rankpw cA cB cun cpw crnk cfv cA cB cun crnk cfv csuc suceq ax-mp eqtri
      sseqtri $.
      $( [24-Sep-2006] $) $( [18-Sep-2006] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    rankxplim.1 $e |- A e. _V $.
    rankxplim.2 $e |- B e. _V $.
    $( The rank of a cross product when the rank of the union of its
       arguments is a limit ordinal.  Part of Exercise 4 of [Kunen] p. 107.
       See ~ rankxpsuc for the successor case. $)
    rankxplim $p |- ( ( Lim ( rank ` ( A u. B ) ) /\ ( A X. B ) =/= (/) ) ->
                    ( rank ` ( A X. B ) ) = ( rank ` ( A u. B ) ) ) $=
      cA cB cun crnk cfv wlim cA cB cxp c0 wne wa cA cB cxp crnk cfv cA cB cun
      crnk cfv cA cB cun crnk cfv wlim cA cB cxp crnk cfv cA cB cun crnk cfv
      wss cA cB cxp c0 wne cA cB cun crnk cfv wlim vx cv vy cv cop crnk cfv
      csuc cA cB cun crnk cfv wss vy cB wral vx cA wral cA cB cxp crnk cfv cA
      cB cun crnk cfv wss cA cB cun crnk cfv wlim vx cv vy cv cop crnk cfv csuc
      cA cB cun crnk cfv wss vx vy cA cB cA cB cun crnk cfv wlim vx cv cA wcel
      vy cv cB wcel wa vx cv vy cv cop crnk cfv csuc cA cB cun crnk cfv wss cA
      cB cun crnk cfv wlim vx cv cA wcel vy cv cB wcel wa wa vx cv vy cv cop
      crnk cfv cA cB cun crnk cfv wcel vx cv vy cv cop crnk cfv csuc cA cB cun
      crnk cfv wss vx cv vy cv cop crnk cfv vx cv vy cv cun cpw cpw crnk cfv
      wss vx cv vy cv cun cpw cpw crnk cfv cA cB cun crnk cfv wcel vx cv vy cv
      cop crnk cfv cA cB cun crnk cfv wcel cA cB cun crnk cfv wlim vx cv cA
      wcel vy cv cB wcel wa wa vx cv vy cv cop crnk cfv con0 wcel cA cB cun
      crnk cfv con0 wcel vx cv vy cv cop crnk cfv vx cv vy cv cun cpw cpw crnk
      cfv wss vx cv vy cv cun cpw cpw crnk cfv cA cB cun crnk cfv wcel wa vx cv
      vy cv cop crnk cfv cA cB cun crnk cfv wcel wi vx cv vy cv cop rankon cA
      cB cun rankon vx cv vy cv cop crnk cfv vx cv vy cv cun cpw cpw crnk cfv
      cA cB cun crnk cfv ontr2 mp2an vx cv vy cv cop vx cv vy cv cun cpw cpw
      wss vx cv vy cv cop crnk cfv vx cv vy cv cun cpw cpw crnk cfv wss vx cv
      vy cv cop vx cv vy cv cpr cpw vx cv vy cv cun cpw cpw vx cv vy cv cop vx
      cv vy cv cop cuni cpw vx cv vy cv cpr cpw vx cv vy cv cop pwuni vx cv vy
      cv cop cuni vx cv vy cv cpr wceq vx cv vy cv cop cuni cpw vx cv vy cv cpr
      cpw wceq vx cv vy cv uniop vx cv vy cv cop cuni vx cv vy cv cpr pweq
      ax-mp sseqtri vx cv vy cv cpr vx cv vy cv cun cpw wss vx cv vy cv cpr cpw
      vx cv vy cv cun cpw cpw wss vx cv vy cv cpr vx cv vy cv cpr cuni cpw vx
      cv vy cv cun cpw vx cv vy cv cpr pwuni vx cv vy cv cpr cuni vx cv vy cv
      cun wceq vx cv vy cv cpr cuni cpw vx cv vy cv cun cpw wceq vx cv vy cv vx
      visset vy visset unipr vx cv vy cv cpr cuni vx cv vy cv cun pweq ax-mp
      sseqtri vx cv vy cv cpr vx cv vy cv cun cpw sspwb mpbi sstri vx cv vy cv
      cop vx cv vy cv cun cpw cpw vx cv vy cv cun cpw vx cv vy cv cun vx cv vy
      cv vx visset vy visset unex pwex pwex rankss ax-mp cA cB cun crnk cfv
      wlim vx cv cA wcel vy cv cB wcel wa wa vx cv vy cv cun crnk cfv cA cB cun
      crnk cfv wcel vx cv vy cv cun cpw cpw crnk cfv cA cB cun crnk cfv wcel vx
      cv cA wcel vy cv cB wcel wa vx cv vy cv cun crnk cfv cA cB cun crnk cfv
      wcel cA cB cun crnk cfv wlim vx cv crnk cfv cA crnk cfv wcel vy cv crnk
      cfv cB crnk cfv wcel vx cv vy cv cun crnk cfv cA cB cun crnk cfv wcel vx
      cv cA wcel vy cv cB wcel vx cv vy cv cA cB vx visset vy visset
      rankxplim.1 rankxplim.2 rankelun vx cv cA rankxplim.1 rankel vy cv cB
      rankxplim.2 rankel syl2an adantl cA cB cun crnk cfv wlim vx cv vy cv cun
      crnk cfv cA cB cun crnk cfv wcel vx cv vy cv cun cpw cpw crnk cfv cA cB
      cun crnk cfv wcel wb vx cv cA wcel vy cv cB wcel wa cA cB cun crnk cfv
      wlim vx cv vy cv cun crnk cfv cA cB cun crnk cfv wcel vx cv vy cv cun cpw
      crnk cfv cA cB cun crnk cfv wcel vx cv vy cv cun cpw cpw crnk cfv cA cB
      cun crnk cfv wcel vx cv vy cv cun cA cB cun crnk cfv ranklim vx cv vy cv
      cun cpw cA cB cun crnk cfv ranklim bitrd adantr mpbid sylancr vx cv vy cv
      cop crnk cfv cA cB cun crnk cfv vx cv vy cv cop rankon cA cB cun rankon
      onsucssi sylib ex r19.21aivv vx cv vy cv cop crnk cfv csuc cA cB cun crnk
      cfv wss vy cB wral vx cA wral vz cv crnk cfv csuc cA cB cun crnk cfv wss
      vz cA cB cxp wral cA cB cxp crnk cfv cA cB cun crnk cfv wss vz cv crnk
      cfv csuc cA cB cun crnk cfv wss vx cv vy cv cop crnk cfv csuc cA cB cun
      crnk cfv wss vz vx vy cA cB vz cv vx cv vy cv cop wceq vz cv crnk cfv
      csuc vx cv vy cv cop crnk cfv csuc cA cB cun crnk cfv vz cv vx cv vy cv
      cop wceq vz cv crnk cfv vx cv vy cv cop crnk cfv wceq vz cv crnk cfv csuc
      vx cv vy cv cop crnk cfv csuc wceq vz cv vx cv vy cv cop crnk fveq2 vz cv
      crnk cfv vx cv vy cv cop crnk cfv suceq syl sseq1d ralxp vz cA cB cxp cA
      cB cun crnk cfv cA cB rankxplim.1 rankxplim.2 xpex rankbnd bitr3i sylib
      adantr cA cB cxp c0 wne cA cB cun crnk cfv cA cB cxp crnk cfv wss cA cB
      cun crnk cfv wlim cA cB rankxplim.1 rankxplim.2 rankxpl adantl eqssd $.
      $( [26-Sep-2006] $) $( [19-Sep-2006] $)


    $( If the rank of a cross product is a limit ordinal, so is the rank of
       the union of its arguments. $)
    rankxplim2 $p |- ( Lim ( rank ` ( A X. B ) ) ->
                     Lim ( rank ` ( A u. B ) ) ) $=
      cA cB cxp c0 wne cA cB cxp crnk cfv wlim cA cB cun crnk cfv wlim cA cB
      cxp crnk cfv wlim c0 cA cB cxp crnk cfv wcel cA cB cxp crnk cfv c0 wceq
      wn cA cB cxp c0 wne cA cB cxp crnk cfv 0ellim cA cB cxp crnk cfv c0 n0i
      cA cB cxp crnk cfv c0 wceq wn cA cB cxp c0 wne cA cB cxp c0 wne cA cB cxp
      c0 wceq wn cA cB cxp crnk cfv c0 wceq wn cA cB cxp c0 df-ne cA cB cxp c0
      wceq cA cB cxp crnk cfv c0 wceq cA cB cxp cA cB rankxplim.1 rankxplim.2
      xpex rankeq0 notbii bitr2i biimpi 3syl cA cB cxp c0 wne cA cB cxp crnk
      cfv cuni cuni wlim cA cB cun crnk cfv wlim cA cB cxp crnk cfv wlim cA cB
      cxp c0 wne cA cB cxp crnk cfv cuni cuni cA cB cun crnk cfv wceq cA cB cxp
      crnk cfv cuni cuni wlim cA cB cun crnk cfv wlim wb cA cB cxp c0 wne cA cB
      cxp cuni cuni crnk cfv cA cB cun crnk cfv cA cB cxp crnk cfv cuni cuni cA
      cB cxp c0 wne cA cB cxp cuni cuni cA cB cun crnk cA cB unixp fveq2d cA cB
      cxp cuni cuni crnk cfv cA cB cxp cuni crnk cfv cuni cA cB cxp crnk cfv
      cuni cuni cA cB cxp cuni rankuni cA cB cxp cuni crnk cfv cA cB cxp crnk
      cfv cuni cA cB cxp rankuni unieqi eqtr2i syl5eq cA cB cxp crnk cfv cuni
      cuni cA cB cun crnk cfv limeq syl cA cB cxp crnk cfv wlim cA cB cxp crnk
      cfv cuni wlim cA cB cxp crnk cfv cuni cuni wlim cA cB cxp crnk cfv
      limuni2 cA cB cxp crnk cfv cuni limuni2 syl syl5bi mpcom $.
      $( [29-Sep-2006] $) $( [19-Sep-2006] $)

    $( The rank of a cross product is a limit ordinal iff its union is. $)
    rankxplim3 $p |- ( Lim ( rank ` ( A X. B ) ) <->
                     Lim U. ( rank ` ( A X. B ) ) ) $=
      cA cB cxp crnk cfv wlim cA cB cxp crnk cfv cuni wlim cA cB cxp crnk cfv
      limuni2 cA cB cxp crnk cfv c0 wceq wn cA cB cun crnk cfv vx cv csuc wceq
      vx con0 wrex cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex wa wn cA cB
      cxp crnk cfv wlim cA cB cxp crnk cfv cuni wlim cA cB cxp crnk cfv c0 wceq
      wn cA cB cun crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv vy
      cv csuc wceq vy con0 wrex wa wn wa cA cB cun crnk cfv wlim cA cB cxp crnk
      cfv wlim wo cA cB cxp crnk cfv wlim cA cB cxp crnk cfv c0 wceq wn cA cB
      cun crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv vy cv csuc
      wceq vy con0 wrex wa wn cA cB cun crnk cfv wlim cA cB cxp crnk cfv wlim
      wo cA cB cxp crnk cfv c0 wceq wn cA cB cun crnk cfv vx cv csuc wceq vx
      con0 wrex wn cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex wn wo cA cB
      cun crnk cfv wlim cA cB cxp crnk cfv wlim wo cA cB cun crnk cfv vx cv
      csuc wceq vx con0 wrex cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex wa
      wn cA cB cxp crnk cfv c0 wceq wn cA cB cun crnk cfv vx cv csuc wceq vx
      con0 wrex wn cA cB cun crnk cfv wlim cA cB cxp crnk cfv vy cv csuc wceq
      vy con0 wrex wn cA cB cxp crnk cfv wlim cA cB cxp crnk cfv c0 wceq wn cA
      cB cun crnk cfv vx cv csuc wceq vx con0 wrex wn cA cB cun crnk cfv wlim
      cA cB cun crnk cfv c0 wceq wn cA cB cun crnk cfv vx cv csuc wceq vx con0
      wrex wn cA cB cun crnk cfv wlim cA cB cxp crnk cfv c0 wceq wn cA cB cun
      crnk cfv c0 wceq cA cB cun crnk cfv vx cv csuc wceq vx con0 wrex cA cB
      cun crnk cfv wlim cA cB cun crnk cfv word cA cB cun crnk cfv c0 wceq cA
      cB cun crnk cfv vx cv csuc wceq vx con0 wrex cA cB cun crnk cfv wlim w3o
      cA cB cun crnk cfv cA cB cun rankon onordi vx cA cB cun crnk cfv ordzsl
      mpbi 3ori cA cB cxp c0 wceq wn cA cB cun c0 wceq wn cA cB cxp crnk cfv c0
      wceq wn cA cB cun crnk cfv c0 wceq wn cA cB cun c0 wceq cA cB cxp c0 wceq
      cA cB cun c0 wceq cA c0 wceq cB c0 wceq wo cA cB cxp c0 wceq cA cB cun c0
      wceq cA c0 wceq cB c0 wceq wa cA c0 wceq cB c0 wceq wo cA cB un00 cB c0
      wceq cA c0 wceq cB c0 wceq wo cA c0 wceq cB c0 wceq cA c0 wceq olc adantl
      sylbir cA cB xpeq0 sylibr con3i cA cB cxp c0 wceq cA cB cxp crnk cfv c0
      wceq cA cB cxp cA cB rankxplim.1 rankxplim.2 xpex rankeq0 notbii cA cB
      cun c0 wceq cA cB cun crnk cfv c0 wceq cA cB cun cA cB rankxplim.1
      rankxplim.2 unex rankeq0 notbii 3imtr3i sylan ex cA cB cxp crnk cfv c0
      wceq wn cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex wn cA cB cxp crnk
      cfv wlim cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv vy cv csuc wceq vy
      con0 wrex cA cB cxp crnk cfv wlim cA cB cxp crnk cfv word cA cB cxp crnk
      cfv c0 wceq cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex cA cB cxp
      crnk cfv wlim w3o cA cB cxp crnk cfv cA cB cxp rankon onordi vy cA cB cxp
      crnk cfv ordzsl mpbi 3ori ex orim12d cA cB cun crnk cfv vx cv csuc wceq
      vx con0 wrex cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex ianor syl5ib
      imp cA cB cxp crnk cfv c0 wceq wn cA cB cun crnk cfv wlim cA cB cxp crnk
      cfv wlim wo cA cB cxp crnk cfv wlim wi cA cB cun crnk cfv vx cv csuc wceq
      vx con0 wrex cA cB cxp crnk cfv vy cv csuc wceq vy con0 wrex wa wn cA cB
      cxp crnk cfv c0 wceq wn cA cB cun crnk cfv wlim cA cB cxp crnk cfv wlim
      cA cB cxp crnk cfv wlim cA cB cun crnk cfv wlim cA cB cxp crnk cfv c0
      wceq wn cA cB cxp crnk cfv wlim cA cB cun crnk cfv wlim cA cB cxp crnk
      cfv c0 wceq wn wa cA cB cxp crnk cfv wlim cA cB cun crnk cfv wlim cA cB
      cun crnk cfv wlim cA cB cxp crnk cfv c0 wceq wn pm3.26 cA cB cun crnk cfv
      wlim cA cB cxp crnk cfv c0 wceq wn wa cA cB cxp crnk cfv cA cB cun crnk
      cfv wceq cA cB cxp crnk cfv wlim cA cB cun crnk cfv wlim wb cA cB cun
      crnk cfv wlim cA cB cxp c0 wne cA cB cxp crnk cfv cA cB cun crnk cfv wceq
      cA cB cxp crnk cfv c0 wceq wn cA cB rankxplim.1 rankxplim.2 rankxplim cA
      cB cxp crnk cfv c0 wceq cA cB cxp c0 cA cB cxp cA cB rankxplim.1
      rankxplim.2 xpex rankeq0 necon3abii sylan2br cA cB cxp crnk cfv cA cB cun
      crnk cfv limeq syl mpbird expcom cA cB cxp crnk cfv c0 wceq wn cA cB cxp
      crnk cfv wlim idd jaod adantr mpd cA cB cxp crnk cfv cuni wlim c0 cA cB
      cxp crnk cfv cuni wcel cA cB cxp crnk cfv cuni c0 wceq wn cA cB cxp crnk
      cfv c0 wceq wn cA cB cxp crnk cfv cuni 0ellim cA cB cxp crnk cfv cuni c0
      n0i cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv cuni c0 wceq cA cB cxp
      crnk cfv c0 wceq cA cB cxp crnk cfv cuni c0 cuni c0 cA cB cxp crnk cfv c0
      unieq uni0 syl6eq con3i 3syl cA cB cxp crnk cfv cuni wlim cA cB cun crnk
      cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv vy cv csuc wceq vy
      con0 wrex wa cA cB cun crnk cfv csuc csuc csuc cA cB cxp crnk cfv wss cA
      cB cun crnk cfv csuc csuc csuc cA cB cxp crnk cfv wss cA cB cun crnk cfv
      csuc csuc csuc cA cB cun crnk cfv csuc csuc wss cA cB cun crnk cfv csuc
      csuc cA cB cun crnk cfv csuc csuc csuc wcel cA cB cun crnk cfv csuc csuc
      csuc cA cB cun crnk cfv csuc csuc wss wn cA cB cun crnk cfv csuc csuc cA
      cB cun crnk cfv csuc csuc con0 cA cB cun crnk cfv csuc cA cB cun crnk cfv
      cA cB cun rankon onsuci onsuci elisseti sucid cA cB cun crnk cfv csuc
      csuc csuc cA cB cun crnk cfv csuc csuc wss cA cB cun crnk cfv csuc csuc
      cA cB cun crnk cfv csuc csuc csuc wcel cA cB cun crnk cfv csuc csuc csuc
      con0 wcel cA cB cun crnk cfv csuc csuc con0 wcel cA cB cun crnk cfv csuc
      csuc csuc cA cB cun crnk cfv csuc csuc wss cA cB cun crnk cfv csuc csuc
      cA cB cun crnk cfv csuc csuc csuc wcel wn wb cA cB cun crnk cfv csuc csuc
      cA cB cun crnk cfv csuc cA cB cun crnk cfv cA cB cun rankon onsuci onsuci
      onsuci cA cB cun crnk cfv csuc cA cB cun crnk cfv cA cB cun rankon onsuci
      onsuci cA cB cun crnk cfv csuc csuc csuc cA cB cun crnk cfv csuc csuc
      ontri1 mp2an con2bii mpbi cA cB cun crnk cfv csuc csuc csuc cA cB cxp
      crnk cfv wss cA cB cxp crnk cfv cA cB cun crnk cfv csuc csuc wss cA cB
      cun crnk cfv csuc csuc csuc cA cB cun crnk cfv csuc csuc wss cA cB
      rankxplim.1 rankxplim.2 rankxpu cA cB cun crnk cfv csuc csuc csuc cA cB
      cxp crnk cfv cA cB cun crnk cfv csuc csuc sstr mpan2 mto cA cB cxp crnk
      cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv
      csuc wceq wa vy con0 wrex vx con0 wrex cA cB cun crnk cfv csuc csuc csuc
      cA cB cxp crnk cfv wss cA cB cun crnk cfv vx cv csuc wceq vx con0 wrex cA
      cB cxp crnk cfv vy cv csuc wceq vy con0 wrex wa cA cB cxp crnk cfv cuni
      wlim cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc
      wceq wa cA cB cun crnk cfv csuc csuc csuc cA cB cxp crnk cfv wss vx vy
      con0 con0 cA cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq
      cA cB cxp crnk cfv vy cv csuc wceq wa cA cB cun crnk cfv csuc csuc csuc
      cA cB cxp crnk cfv wss wi vx cv con0 wcel vy cv con0 wcel wa cA cB cxp
      crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv
      vy cv csuc wceq wa cA cB cun crnk cfv csuc csuc csuc cA cB cxp crnk cfv
      wss cA cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq cA cB
      cxp crnk cfv vy cv csuc wceq wa wa cA cB cun crnk cfv csuc csuc cA cB cxp
      crnk cfv wcel cA cB cun crnk cfv csuc csuc csuc cA cB cxp crnk cfv wss cA
      cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq cA cB cxp
      crnk cfv vy cv csuc wceq wa wa cA cB cun crnk cfv csuc csuc cA cB cxp
      crnk cfv cuni csuc cA cB cxp crnk cfv cA cB cxp crnk cfv cuni wlim cA cB
      cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc wceq wa wa cA
      cB cun crnk cfv csuc cA cB cxp crnk cfv cuni wcel cA cB cun crnk cfv csuc
      csuc cA cB cxp crnk cfv cuni csuc wcel cA cB cxp crnk cfv cuni wlim cA cB
      cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc wceq wa wa cA
      cB cun crnk cfv cA cB cxp crnk cfv cuni wcel cA cB cun crnk cfv csuc cA
      cB cxp crnk cfv cuni wcel cA cB cxp crnk cfv cuni wlim cA cB cun crnk cfv
      vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc wceq wa wa cA cB cun crnk
      cfv vx cv csuc cA cB cxp crnk cfv cuni cA cB cxp crnk cfv cuni wlim cA cB
      cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc wceq simprl cA
      cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq cA cB cxp
      crnk cfv vy cv csuc wceq wa wa vx cv cA cB cxp crnk cfv cuni wcel vx cv
      csuc cA cB cxp crnk cfv cuni wcel cA cB cxp crnk cfv cuni wlim cA cB cun
      crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc wceq wa wa vx cv
      csuc cA cB cxp crnk cfv cuni wss vx cv cA cB cxp crnk cfv cuni wcel cA cB
      cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk
      cfv vy cv csuc wceq wa wa vx cv csuc cA cB cxp crnk cfv cuni cuni cA cB
      cxp crnk cfv cuni cA cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv
      csuc wceq vx cv csuc cA cB cxp crnk cfv cuni cuni wss cA cB cxp crnk cfv
      vy cv csuc wceq cA cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv
      csuc wceq wa vx cv csuc cA cB cun crnk cfv cA cB cxp crnk cfv cuni cuni
      cA cB cxp crnk cfv cuni wlim cA cB cun crnk cfv vx cv csuc wceq pm3.27 cA
      cB cxp crnk cfv cuni wlim cA cB cun crnk cfv cA cB cxp crnk cfv cuni cuni
      wss cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv cuni wlim cA cB
      cun crnk cfv cA cB cxp crnk cfv cuni cuni wceq cA cB cun crnk cfv cA cB
      cxp crnk cfv cuni cuni wss cA cB cxp crnk cfv cuni wlim cA cB cxp cuni
      cuni crnk cfv cA cB cun crnk cfv cA cB cxp crnk cfv cuni cuni cA cB cxp
      crnk cfv cuni wlim cA cB cxp cuni cuni cA cB cun crnk cA cB cxp crnk cfv
      cuni wlim cA cB cxp c0 wne cA cB cxp cuni cuni cA cB cun wceq cA cB cxp
      crnk cfv cuni wlim cA cB cxp crnk cfv c0 wceq wn cA cB cxp c0 wne cA cB
      cxp crnk cfv cuni wlim c0 cA cB cxp crnk cfv cuni wcel cA cB cxp crnk cfv
      cuni c0 wceq wn cA cB cxp crnk cfv c0 wceq wn cA cB cxp crnk cfv cuni
      0ellim cA cB cxp crnk cfv cuni c0 n0i cA cB cxp crnk cfv c0 wceq cA cB
      cxp crnk cfv cuni c0 wceq cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv
      cuni c0 cuni c0 cA cB cxp crnk cfv c0 unieq uni0 syl6eq con3i 3syl cA cB
      cxp c0 wne cA cB cxp c0 wceq wn cA cB cxp crnk cfv c0 wceq wn cA cB cxp
      c0 df-ne cA cB cxp c0 wceq cA cB cxp crnk cfv c0 wceq cA cB cxp cA cB
      rankxplim.1 rankxplim.2 xpex rankeq0 notbii bitr2i sylib cA cB unixp syl
      fveq2d cA cB cxp cuni cuni crnk cfv cA cB cxp cuni crnk cfv cuni cA cB
      cxp crnk cfv cuni cuni cA cB cxp cuni rankuni cA cB cxp cuni crnk cfv cA
      cB cxp crnk cfv cuni cA cB cxp rankuni unieqi eqtri syl5reqr cA cB cun
      crnk cfv cA cB cxp crnk cfv cuni cuni eqimss syl adantr eqsstr3d adantrr
      cA cB cxp crnk cfv cuni wlim cA cB cxp crnk cfv cuni cA cB cxp crnk cfv
      cuni cuni wceq cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv vy
      cv csuc wceq wa cA cB cxp crnk cfv cuni limuni adantr sseqtr4d vx cv cvv
      wcel cA cB cxp crnk cfv cuni word vx cv cA cB cxp crnk cfv cuni wcel vx
      cv csuc cA cB cxp crnk cfv cuni wss wb vx visset cA cB cxp crnk cfv word
      cA cB cxp crnk cfv cuni word cA cB cxp crnk cfv cA cB cxp rankon onordi
      cA cB cxp crnk cfv orduni ax-mp vx cv cA cB cxp crnk cfv cuni cvv
      ordelsuc mp2an sylibr cA cB cxp crnk cfv cuni wlim vx cv cA cB cxp crnk
      cfv cuni wcel vx cv csuc cA cB cxp crnk cfv cuni wcel wb cA cB cun crnk
      cfv vx cv csuc wceq cA cB cxp crnk cfv vy cv csuc wceq wa cA cB cxp crnk
      cfv cuni vx cv limsuc adantr mpbid eqeltrd cA cB cxp crnk cfv cuni wlim
      cA cB cun crnk cfv cA cB cxp crnk cfv cuni wcel cA cB cun crnk cfv csuc
      cA cB cxp crnk cfv cuni wcel wb cA cB cun crnk cfv vx cv csuc wceq cA cB
      cxp crnk cfv vy cv csuc wceq wa cA cB cxp crnk cfv cuni cA cB cun crnk
      cfv limsuc adantr mpbid cA cB cxp crnk cfv cuni word cA cB cun crnk cfv
      csuc cA cB cxp crnk cfv cuni wcel cA cB cun crnk cfv csuc csuc cA cB cxp
      crnk cfv cuni csuc wcel wb cA cB cxp crnk cfv word cA cB cxp crnk cfv
      cuni word cA cB cxp crnk cfv cA cB cxp rankon onordi cA cB cxp crnk cfv
      orduni ax-mp cA cB cun crnk cfv csuc cA cB cxp crnk cfv cuni ordsucelsuc
      ax-mp sylib cA cB cxp crnk cfv vy cv csuc wceq cA cB cxp crnk cfv cuni
      csuc cA cB cxp crnk cfv wceq cA cB cxp crnk cfv cuni wlim cA cB cun crnk
      cfv vx cv csuc wceq cA cB cxp crnk cfv con0 wcel cA cB cxp crnk cfv vy cv
      csuc wceq cA cB cxp crnk cfv cuni csuc cA cB cxp crnk cfv wceq cA cB cxp
      rankon cA cB cxp crnk cfv vy cv onsucuni2 mpan ad2antll eleqtrd cA cB cun
      crnk cfv csuc csuc cA cB cxp crnk cfv cA cB cun crnk cfv csuc cA cB cun
      crnk cfv cA cB cun rankon onsuci onsuci cA cB cxp rankon onsucssi sylib
      ex a1d r19.23advv cA cB cun crnk cfv vx cv csuc wceq cA cB cxp crnk cfv
      vy cv csuc wceq vx vy con0 con0 reeanv syl5ibr mtoi sylanc impbii $.
      $( [27-Sep-2006] $) $( [19-Sep-2006] $)

    $( The rank of a cross product when the rank of the union of its arguments
       is a successor ordinal.  Part of Exercise 4 of [Kunen] p. 107.  See
       ~ rankxplim for the limit ordinal case. $)
    rankxpsuc $p |- ( ( ( rank ` ( A u. B ) ) = suc C /\ ( A X. B ) =/= (/) )
                  -> ( rank ` ( A X. B ) ) = suc suc ( rank ` ( A u. B ) ) ) $=
      cA cB cun crnk cfv cC csuc wceq cA cB cxp c0 wne wa cA cB cun crnk cfv
      csuc csuc cA cB cxp crnk cfv cuni csuc cA cB cxp crnk cfv cA cB cun crnk
      cfv cC csuc wceq cA cB cxp c0 wne wa cA cB cun crnk cfv csuc cA cB cxp
      crnk cfv cuni wceq cA cB cun crnk cfv csuc csuc cA cB cxp crnk cfv cuni
      csuc wceq cA cB cun crnk cfv cC csuc wceq cA cB cxp c0 wne wa cA cB cun
      crnk cfv csuc cA cB cxp crnk cfv cuni cuni csuc cA cB cxp crnk cfv cuni
      cA cB cxp c0 wne cA cB cun crnk cfv csuc cA cB cxp crnk cfv cuni cuni
      csuc wceq cA cB cun crnk cfv cC csuc wceq cA cB cxp c0 wne cA cB cun crnk
      cfv cA cB cxp crnk cfv cuni cuni wceq cA cB cun crnk cfv csuc cA cB cxp
      crnk cfv cuni cuni csuc wceq cA cB cxp c0 wne cA cB cxp cuni cuni crnk
      cfv cA cB cun crnk cfv cA cB cxp crnk cfv cuni cuni cA cB cxp c0 wne cA
      cB cxp cuni cuni cA cB cun crnk cA cB unixp fveq2d cA cB cxp cuni cuni
      crnk cfv cA cB cxp cuni crnk cfv cuni cA cB cxp crnk cfv cuni cuni cA cB
      cxp cuni rankuni cA cB cxp cuni crnk cfv cA cB cxp crnk cfv cuni cA cB
      cxp rankuni unieqi eqtri syl5reqr cA cB cun crnk cfv cA cB cxp crnk cfv
      cuni cuni suc11reg sylibr adantl cA cB cun crnk cfv cC csuc wceq cA cB
      cxp c0 wne wa cA cB cxp crnk cfv cuni vx cv csuc wceq vx con0 wrex cA cB
      cxp crnk cfv cuni cuni csuc cA cB cxp crnk cfv cuni wceq cA cB cxp c0 wne
      cA cB cun crnk cfv cC csuc wceq cA cB cxp crnk cfv cuni vx cv csuc wceq
      vx con0 wrex cA cB cxp c0 wne cA cB cun crnk cfv cC csuc wceq cA cB cxp
      crnk cfv cuni wlim wn cA cB cxp crnk cfv cuni vx cv csuc wceq vx con0
      wrex cA cB cun crnk cfv cC csuc wceq cA cB cxp c0 wne cA cB cxp crnk cfv
      vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv cuni wlim wn cA cB cun
      crnk cfv cC csuc wceq cA cB cun crnk cfv wlim wn cA cB cxp crnk cfv wlim
      wn cA cB cxp c0 wne cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex wi cA
      cB cun crnk cfv cC csuc wceq cA cB cun crnk cfv wlim cC csuc wlim cA cB
      cun crnk cfv cC csuc wceq cC cvv wcel cC csuc wlim wn cA cB cun crnk cfv
      cC csuc wceq cC csuc cvv wcel cC cvv wcel cA cB cun crnk cfv cC csuc wceq
      cA cB cun crnk cfv cvv wcel cC csuc cvv wcel cA cB cun crnk fvex cA cB
      cun crnk cfv cC csuc cvv eleq1 mpbii cC sucexb sylibr cC cvv nlimsucg syl
      cA cB cun crnk cfv cC csuc limeq mtbird cA cB cxp crnk cfv wlim cA cB cun
      crnk cfv wlim cA cB rankxplim.1 rankxplim.2 rankxplim2 con3i cA cB cxp c0
      wne cA cB cxp crnk cfv wlim wn cA cB cxp crnk cfv vx cv csuc wceq vx con0
      wrex cA cB cxp c0 wne cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA
      cB cxp crnk cfv wlim cA cB cxp c0 wne cA cB cxp crnk cfv vx cv csuc wceq
      vx con0 wrex cA cB cxp crnk cfv wlim cA cB cxp c0 wne cA cB cxp crnk cfv
      c0 wceq wn cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk
      cfv wlim wo cA cB cxp crnk cfv c0 wceq cA cB cxp c0 cA cB cxp cA cB
      rankxplim.1 rankxplim.2 xpex rankeq0 necon3abii cA cB cxp crnk cfv c0
      wceq cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv
      wlim wo cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv vx cv csuc wceq vx
      con0 wrex cA cB cxp crnk cfv wlim w3o cA cB cxp crnk cfv c0 wceq cA cB
      cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim wo wo
      cA cB cxp crnk cfv word cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv vx
      cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim w3o cA cB cxp crnk cfv
      cA cB cxp rankon onordi vx cA cB cxp crnk cfv ordzsl mpbi cA cB cxp crnk
      cfv c0 wceq cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp
      crnk cfv wlim 3orass mpbi ori sylbi ord con1d com12 3syl cA cB cxp crnk
      cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim wn cA cB cxp
      crnk cfv cuni wlim wn cA cB cxp crnk cfv vx cv csuc wceq cA cB cxp crnk
      cfv wlim wn vx con0 cA cB cxp crnk cfv vx cv csuc wceq cA cB cxp crnk cfv
      wlim wn wi vx cv con0 wcel cA cB cxp crnk cfv vx cv csuc wceq cA cB cxp
      crnk cfv wlim vx cv csuc wlim vx cv cvv wcel vx cv csuc wlim wn vx visset
      vx cv cvv nlimsucg ax-mp cA cB cxp crnk cfv vx cv csuc limeq mtbiri a1i
      r19.23aiv cA cB cxp crnk cfv wlim cA cB cxp crnk cfv cuni wlim cA cB
      rankxplim.1 rankxplim.2 rankxplim3 notbii sylib syl6com cA cB cxp c0 wne
      cA cB cxp crnk cfv cuni vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv
      cuni wlim cA cB cxp c0 wne cA cB cxp crnk cfv cuni vx cv csuc wceq vx
      con0 wrex cA cB cxp crnk cfv cuni wlim cA cB cxp c0 wne cA cB cxp crnk
      cfv cuni c0 wceq wn cA cB cxp crnk cfv cuni vx cv csuc wceq vx con0 wrex
      cA cB cxp crnk cfv cuni wlim wo cA cB cxp crnk cfv cuni c0 wceq cA cB cxp
      c0 cA cB cxp c0 wceq cA cB cxp cuni c0 wceq cA cB cxp cuni crnk cfv c0
      wceq cA cB cxp crnk cfv cuni c0 wceq cA cB unixp0 cA cB cxp cuni cA cB
      cxp cA cB rankxplim.1 rankxplim.2 xpex uniex rankeq0 cA cB cxp cuni crnk
      cfv cA cB cxp crnk cfv cuni c0 cA cB cxp rankuni eqeq1i 3bitri necon3abii
      cA cB cxp crnk cfv cuni c0 wceq cA cB cxp crnk cfv cuni vx cv csuc wceq
      vx con0 wrex cA cB cxp crnk cfv cuni wlim wo cA cB cxp crnk cfv cuni c0
      wceq cA cB cxp crnk cfv cuni vx cv csuc wceq vx con0 wrex cA cB cxp crnk
      cfv cuni wlim w3o cA cB cxp crnk cfv cuni c0 wceq cA cB cxp crnk cfv cuni
      vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv cuni wlim wo wo cA cB cxp
      crnk cfv cuni word cA cB cxp crnk cfv cuni c0 wceq cA cB cxp crnk cfv
      cuni vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv cuni wlim w3o cA cB
      cxp crnk cfv cuni cA cB cxp crnk cfv con0 wcel cA cB cxp crnk cfv cuni
      con0 wcel cA cB cxp rankon cA cB cxp crnk cfv onuni ax-mp onordi vx cA cB
      cxp crnk cfv cuni ordzsl mpbi cA cB cxp crnk cfv cuni c0 wceq cA cB cxp
      crnk cfv cuni vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv cuni wlim
      3orass mpbi ori sylbi ord con1d syld impcom cA cB cxp crnk cfv cuni vx cv
      csuc wceq cA cB cxp crnk cfv cuni cuni csuc cA cB cxp crnk cfv cuni wceq
      vx con0 cA cB cxp crnk cfv cuni vx cv csuc wceq cA cB cxp crnk cfv cuni
      cuni csuc cA cB cxp crnk cfv cuni wceq wi vx cv con0 wcel cA cB cxp crnk
      cfv cuni con0 wcel cA cB cxp crnk cfv cuni vx cv csuc wceq cA cB cxp crnk
      cfv cuni cuni csuc cA cB cxp crnk cfv cuni wceq cA cB cxp crnk cfv con0
      wcel cA cB cxp crnk cfv cuni con0 wcel cA cB cxp rankon cA cB cxp crnk
      cfv onuni ax-mp cA cB cxp crnk cfv cuni vx cv onsucuni2 mpan a1i
      r19.23aiv syl eqtrd cA cB cun crnk cfv csuc cA cB cxp crnk cfv cuni
      suc11reg sylibr cA cB cun crnk cfv cC csuc wceq cA cB cxp c0 wne wa cA cB
      cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv cuni csuc cA
      cB cxp crnk cfv wceq cA cB cun crnk cfv cC csuc wceq cA cB cxp c0 wne cA
      cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cun crnk cfv cC csuc
      wceq cA cB cun crnk cfv wlim wn cA cB cxp crnk cfv wlim wn cA cB cxp c0
      wne cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex wi cA cB cun crnk cfv
      cC csuc wceq cA cB cun crnk cfv wlim cC csuc wlim cA cB cun crnk cfv cC
      csuc wceq cC cvv wcel cC csuc wlim wn cA cB cun crnk cfv cC csuc wceq cC
      csuc cvv wcel cC cvv wcel cA cB cun crnk cfv cC csuc wceq cA cB cun crnk
      cfv cvv wcel cC csuc cvv wcel cA cB cun crnk fvex cA cB cun crnk cfv cC
      csuc cvv eleq1 mpbii cC sucexb sylibr cC cvv nlimsucg syl cA cB cun crnk
      cfv cC csuc limeq mtbird cA cB cxp crnk cfv wlim cA cB cun crnk cfv wlim
      cA cB rankxplim.1 rankxplim.2 rankxplim2 con3i cA cB cxp c0 wne cA cB cxp
      crnk cfv wlim wn cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB
      cxp c0 wne cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk
      cfv wlim cA cB cxp c0 wne cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex
      cA cB cxp crnk cfv wlim cA cB cxp c0 wne cA cB cxp crnk cfv c0 wceq wn cA
      cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim wo
      cA cB cxp crnk cfv c0 wceq cA cB cxp c0 cA cB cxp cA cB rankxplim.1
      rankxplim.2 xpex rankeq0 necon3abii cA cB cxp crnk cfv c0 wceq cA cB cxp
      crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim wo cA cB
      cxp crnk cfv c0 wceq cA cB cxp crnk cfv vx cv csuc wceq vx con0 wrex cA
      cB cxp crnk cfv wlim w3o cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv vx
      cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim wo wo cA cB cxp crnk
      cfv word cA cB cxp crnk cfv c0 wceq cA cB cxp crnk cfv vx cv csuc wceq vx
      con0 wrex cA cB cxp crnk cfv wlim w3o cA cB cxp crnk cfv cA cB cxp rankon
      onordi vx cA cB cxp crnk cfv ordzsl mpbi cA cB cxp crnk cfv c0 wceq cA cB
      cxp crnk cfv vx cv csuc wceq vx con0 wrex cA cB cxp crnk cfv wlim 3orass
      mpbi ori sylbi ord con1d com12 3syl imp cA cB cxp crnk cfv vx cv csuc
      wceq cA cB cxp crnk cfv cuni csuc cA cB cxp crnk cfv wceq vx con0 cA cB
      cxp crnk cfv vx cv csuc wceq cA cB cxp crnk cfv cuni csuc cA cB cxp crnk
      cfv wceq wi vx cv con0 wcel cA cB cxp crnk cfv con0 wcel cA cB cxp crnk
      cfv vx cv csuc wceq cA cB cxp crnk cfv cuni csuc cA cB cxp crnk cfv wceq
      cA cB cxp rankon cA cB cxp crnk cfv vx cv onsucuni2 mpan a1i r19.23aiv
      syl eqtr2d $.
      $( [29-Sep-2006] $) $( [19-Sep-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Scott's trick; collection principle; Hilbert's epsilon
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.
    $( Scott's trick collects all sets that have a certain property and are of
       smallest possible rank.  This theorem shows that the resulting
       collection, expressed as in Equation 9.3 of [Jech] p. 72, is a set. $)
    scottex $p |- { x e. A | A. y e. A ( rank ` x ) C_ ( rank ` y ) } e. _V $=
      cA c0 wceq vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab cvv
      wcel cA c0 wceq cA cvv wcel vx cv crnk cfv vy cv crnk cfv wss vy cA wral
      vx cA crab cvv wcel cA c0 wceq cA cvv wcel c0 cvv wcel 0ex cA c0 cvv
      eleq1 mpbiri vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA cvv
      rabexg syl cA c0 wceq wn vy cv cA wcel vy wex vx cv crnk cfv vy cv crnk
      cfv wss vy cA wral vx cA crab cvv wcel vy cA neq0 vy cv cA wcel vx cv
      crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab cvv wcel vy vy vz vz vx
      cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab cvv vx cv crnk cfv
      vy cv crnk cfv wss vy cA wral vy vx vz cA vx cv crnk cfv vy cv crnk cfv
      wss vy cA hbra1 vz cv cA wcel vy ax-17 hbrab vz cv cvv wcel vy ax-17 hbel
      vy cv cA wcel vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab vx
      cv crnk cfv vy cv crnk cfv wss vx cA crab wss vx cv crnk cfv vy cv crnk
      cfv wss vy cA wral vx cA crab cvv wcel vy cv cA wcel vx cv crnk cfv vy cv
      crnk cfv wss vy cA wral vx cv crnk cfv vy cv crnk cfv wss wi vx cA wral
      vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab vx cv crnk cfv vy
      cv crnk cfv wss vx cA crab wss vy cv cA wcel vx cv crnk cfv vy cv crnk
      cfv wss vy cA wral vx cv crnk cfv vy cv crnk cfv wss wi vx cA vy cv cA
      wcel vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cv crnk cfv vy cv
      crnk cfv wss wi vx cv cA wcel vx cv crnk cfv vy cv crnk cfv wss vy cA
      wral vy cv cA wcel vx cv crnk cfv vy cv crnk cfv wss vx cv crnk cfv vy cv
      crnk cfv wss vy cA ra4 com12 a1d r19.21aiv vx cv crnk cfv vy cv crnk cfv
      wss vy cA wral vx cv crnk cfv vy cv crnk cfv wss vx cA ss2rab sylibr vx
      cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab vx cv crnk cfv vy cv
      crnk cfv wss vx cA crab vw cv crnk cfv vz cv wss vw vx cv crnk cfv vy cv
      crnk cfv wss vx cA crab wral vz con0 wrex vx cv crnk cfv vy cv crnk cfv
      wss vx cA crab cvv wcel vy cv crnk cfv con0 wcel vw cv crnk cfv vy cv
      crnk cfv wss vw vx cv crnk cfv vy cv crnk cfv wss vx cA crab wral vw cv
      crnk cfv vz cv wss vw vx cv crnk cfv vy cv crnk cfv wss vx cA crab wral
      vz con0 wrex vy cv rankon vw cv crnk cfv vy cv crnk cfv wss vw vx cv crnk
      cfv vy cv crnk cfv wss vx cA crab vw cv vx cv crnk cfv vy cv crnk cfv wss
      vx cA crab wcel vw cv cA wcel vw cv crnk cfv vy cv crnk cfv wss vx cv
      crnk cfv vy cv crnk cfv wss vw cv crnk cfv vy cv crnk cfv wss vx vw cv cA
      vx cv vw cv wceq vx cv crnk cfv vw cv crnk cfv vy cv crnk cfv vx cv vw cv
      crnk fveq2 sseq1d elrab pm3.27bi rgen vw cv crnk cfv vz cv wss vw vx cv
      crnk cfv vy cv crnk cfv wss vx cA crab wral vw cv crnk cfv vy cv crnk cfv
      wss vw vx cv crnk cfv vy cv crnk cfv wss vx cA crab wral vz vy cv crnk
      cfv con0 vz cv vy cv crnk cfv wceq vw cv crnk cfv vz cv wss vw cv crnk
      cfv vy cv crnk cfv wss vw vx cv crnk cfv vy cv crnk cfv wss vx cA crab vz
      cv vy cv crnk cfv vw cv crnk cfv sseq2 ralbidv rcla4ev mp2an vz vw vx cv
      crnk cfv vy cv crnk cfv wss vx cA crab bndrank ax-mp ssex syl 19.23ai
      sylbi pm2.61i $.
      $( [21-Dec-2003] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y z w A $.
    $( Scott's trick collects all sets that have a certain property and are of
       smallest possible rank.  This theorem shows that the resulting
       collection, expressed as in Equation 9.3 of [Jech] p. 72, contains at
       least one representative with the property, if there is one.  In other
       words, the collection is empty iff no set has the property (i.e. ` A `
       is empty). $)
    scott0 $p |- ( A = (/) <->
               { x e. A | A. y e. A ( rank ` x ) C_ ( rank ` y ) } = (/) ) $=
      cA c0 wceq vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab c0
      wceq cA c0 wceq vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA crab
      vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx c0 crab c0 vx cv crnk cfv
      vy cv crnk cfv wss vy cA wral vx cA c0 rabeq vx cv crnk cfv vy cv crnk
      cfv wss vy cA wral vx rab0 syl6eq cA c0 vx cv crnk cfv vy cv crnk cfv wss
      vy cA wral vx cA crab c0 cA c0 wne vx cv crnk cfv vy cv crnk cfv wss vy
      cA wral vx cA wrex vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA
      crab c0 wne cA c0 wne vx cA vx cv crnk cfv ciin vy cv vx cv crnk cfv wceq
      vx cA wrex vy cab wcel vx cA vx cv crnk cfv ciin vx cv crnk cfv wceq vx
      cA wrex vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA wrex cA c0 wne
      vy cv vx cv crnk cfv wceq vx cA wrex vy cab c0 wne vx cA vx cv crnk cfv
      ciin vy cv vx cv crnk cfv wceq vx cA wrex vy cab wcel cA c0 wne vy cv vx
      cv crnk cfv wceq vx cA wrex vy wex vy cv vx cv crnk cfv wceq vx cA wrex
      vy cab c0 wne cA c0 wne vx cv crnk cfv vx cv crnk cfv wceq vx cA wrex vy
      cv vx cv crnk cfv wceq vx cA wrex vy wex cA c0 wne vx cv cA wcel vx wex
      vx cv crnk cfv vx cv crnk cfv wceq vx cA wrex vx cA n0 vx cv cA wcel vx
      cv crnk cfv vx cv crnk cfv wceq vx cA wrex vx vx cv crnk cfv vx cv crnk
      cfv wceq vx cA hbre1 vx cv cA wcel vx cv crnk cfv vx cv crnk cfv wceq vx
      cv crnk cfv vx cv crnk cfv wceq vx cA wrex vx cv crnk cfv eqid vx cv crnk
      cfv vx cv crnk cfv wceq vx cA ra4e mpan2 19.23ai sylbi vx cv cA wcel vx
      cv crnk cfv vx cv crnk cfv wceq wa vx wex vx cv cA wcel vy cv vx cv crnk
      cfv wceq wa vx wex vy wex vx cv crnk cfv vx cv crnk cfv wceq vx cA wrex
      vy cv vx cv crnk cfv wceq vx cA wrex vy wex vx cv cA wcel vx cv crnk cfv
      vx cv crnk cfv wceq wa vx wex vx cv cA wcel vy cv vx cv crnk cfv wceq wa
      vy wex vx wex vx cv cA wcel vy cv vx cv crnk cfv wceq wa vx wex vy wex vx
      cv cA wcel vx cv crnk cfv vx cv crnk cfv wceq wa vx cv cA wcel vy cv vx
      cv crnk cfv wceq wa vy wex vx vx cv cA wcel vy cv vx cv crnk cfv wceq wa
      vx cv cA wcel vx cv crnk cfv vx cv crnk cfv wceq wa vy vx cv crnk cfv vx
      cv crnk fvex vy cv vx cv crnk cfv wceq vy cv vx cv crnk cfv wceq vx cv
      crnk cfv vx cv crnk cfv wceq vx cv cA wcel vy cv vx cv crnk cfv vx cv
      crnk cfv eqeq1 anbi2d cla4ev 19.22i vx cv cA wcel vy cv vx cv crnk cfv
      wceq wa vy vx excom sylibr vx cv crnk cfv vx cv crnk cfv wceq vx cA
      df-rex vy cv vx cv crnk cfv wceq vx cA wrex vx cv cA wcel vy cv vx cv
      crnk cfv wceq wa vx wex vy vy cv vx cv crnk cfv wceq vx cA df-rex exbii
      3imtr4i syl vy cv vx cv crnk cfv wceq vx cA wrex vy abn0 sylibr vy cv vx
      cv crnk cfv wceq vx cA wrex vy cab c0 wne vy cv vx cv crnk cfv wceq vx cA
      wrex vy cab cint vy cv vx cv crnk cfv wceq vx cA wrex vy cab vx cA vx cv
      crnk cfv ciin vy cv vx cv crnk cfv wceq vx cA wrex vy cab con0 wss vy cv
      vx cv crnk cfv wceq vx cA wrex vy cab c0 wne vy cv vx cv crnk cfv wceq vx
      cA wrex vy cab cint vy cv vx cv crnk cfv wceq vx cA wrex vy cab wcel vy
      cv vx cv crnk cfv wceq vx cA wrex vy cab con0 wss vy cv vy cv vx cv crnk
      cfv wceq vx cA wrex vy cab wcel vy cv con0 wcel wi vy vy vz vy cv vx cv
      crnk cfv wceq vx cA wrex vy cab con0 vy cv vx cv crnk cfv wceq vx cA wrex
      vy vz hbab1 vz cv con0 wcel vy ax-17 dfss2f vy cv vy cv vx cv crnk cfv
      wceq vx cA wrex vy cab wcel vy cv vx cv crnk cfv wceq vx cA wrex vy cv
      con0 wcel vy cv vx cv crnk cfv wceq vx cA wrex vy abid vy cv vx cv crnk
      cfv wceq vy cv con0 wcel vx cA vy cv vx cv crnk cfv wceq vy cv con0 wcel
      wi vx cv cA wcel vy cv vx cv crnk cfv wceq vy cv con0 wcel vx cv crnk cfv
      con0 wcel vx cv rankon vy cv vx cv crnk cfv con0 eleq1 mpbiri a1i
      r19.23aiv sylbi mpgbir vy cv vx cv crnk cfv wceq vx cA wrex vy cab onint
      mpan vx vy cA vx cv crnk cfv vx cv crnk fvex dfiin2 syl5eqel syl vx cA vx
      cv crnk cfv ciin vy cv vx cv crnk cfv wceq vx cA wrex vy cab wcel vx cA
      vx cv crnk cfv ciin vx cv crnk cfv wceq vx cA wrex vy cv vx cv crnk cfv
      wceq vx cA wrex vx cA vx cv crnk cfv ciin vx cv crnk cfv wceq vx cA wrex
      vy vx cA vx cv crnk cfv ciin vy cv vx cv crnk cfv wceq vx cA wrex vy cab
      vy cv vx cA vx cv crnk cfv ciin wceq vy cv vx cv crnk cfv wceq vx cA vx
      cv crnk cfv ciin vx cv crnk cfv wceq vx cA vx vy vx cA vx cv crnk cfv
      ciin vx vy cA vx cv crnk cfv hbii1 hbeleq vy cv vx cA vx cv crnk cfv ciin
      vx cv crnk cfv eqeq1 rexbid elabg ibi vx cA vx cv crnk cfv ciin vx cv
      crnk cfv wceq vx cv crnk cfv vy cv crnk cfv wss vy cA wral vx cA vx cA vx
      cv crnk cfv ciin vx cv crnk cfv wceq vx cv crnk cfv vy cv crnk cfv wss vy
      cA vx cA vx cv crnk cfv ciin vx cv crnk cfv wceq vx cA vx cv crnk cfv
      ciin vy cv crnk cfv wss vx cv crnk cfv vy cv crnk cfv wss vy cv cA wcel
      vx cA vx cv crnk cfv ciin vx cv crnk cfv vy cv crnk cfv sseq1 vy cv cA
      wcel vx cv crnk cfv vy cv crnk cfv wss vx cA wrex vx cA vx cv crnk cfv
      ciin vy cv crnk cfv wss vy cv cA wcel vy cv crnk cfv vy cv crnk cfv wss
      vx cv crnk cfv vy cv crnk cfv wss vx cA wrex vy cv crnk cfv ssid vx cv
      crnk cfv vy cv crnk cfv wss vy cv crnk cfv vy cv crnk cfv wss vx vy cv cA
      vx cv vy cv wceq vx cv crnk cfv vy cv crnk cfv vy cv crnk cfv vx cv vy cv
      crnk fveq2 sseq1d rcla4ev mpan2 vx cA vx cv crnk cfv vy cv crnk cfv iinss
      syl syl5bi r19.21aiv r19.22si 3syl vx cv crnk cfv vy cv crnk cfv wss vy
      cA wral vx cA rabn0 sylibr necon4i impbii $.
      $( [22-Dec-2003] $) $( [15-Oct-2003] $)
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( Theorem scheme version of ~ scottex .  The collection of all ` x ` of
       minimum rank such that ` ph ( x ) ` is true, is a set. $)
    scottexs $p |- { x | ( ph /\
             A. y ( [ y / x ] ph -> ( rank ` x ) C_ ( rank ` y ) ) ) } e. _V $=
      vz cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz wph vx cab crab
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab cvv vz cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz wph vx
      cab crab vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vx wph vx
      cab crab vx cv wph vx cab wcel vx cv crnk cfv vy cv crnk cfv wss vy wph
      vx cab wral wa vx cab wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv
      wss wi vy wal wa vx cab vz cv crnk cfv vy cv crnk cfv wss vy wph vx cab
      wral vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz vx vy wph vx
      cab vy cv wph vx cab wcel vz ax-17 wph vx vy hbab1 vz cv crnk cfv vy cv
      crnk cfv wss vx vy wph vx cab wph vx vy hbab1 vz cv crnk cfv vy cv crnk
      cfv wss vx ax-17 hbral vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab
      wral vz ax-17 vz cv vx cv wceq vz cv crnk cfv vy cv crnk cfv wss vx cv
      crnk cfv vy cv crnk cfv wss vy wph vx cab vz cv vx cv wceq vz cv crnk cfv
      vx cv crnk cfv vy cv crnk cfv vz cv vx cv crnk fveq2 sseq1d ralbidv
      cbvrab vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vx wph vx cab
      df-rab vx cv wph vx cab wcel vx cv crnk cfv vy cv crnk cfv wss vy wph vx
      cab wral wa wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx vx cv wph vx cab wcel wph vx cv crnk cfv vy cv crnk cfv wss vy
      wph vx cab wral wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wph vx abid vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vy
      cv wph vx cab wcel vx cv crnk cfv vy cv crnk cfv wss wi vy wal wph vx vy
      cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal vx cv crnk cfv vy cv
      crnk cfv wss vy wph vx cab df-ral vy cv wph vx cab wcel vx cv crnk cfv vy
      cv crnk cfv wss wi wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi
      vy vy cv wph vx cab wcel wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv
      wss wph vy vx df-clab imbi1i albii bitri anbi12i abbii 3eqtri vz vy wph
      vx cab scottex eqeltrri $.
      $( [11-Mar-2004] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( Theorem scheme version of ~ scott0 .  The collection of all ` x ` of
       minimum rank such that ` ph ( x ) ` is true, is not empty iff there is
       an ` x ` such that ` ph ( x ) ` holds. $)
    scott0s $p |- ( E. x ph <-> { x | ( ph /\
         A. y ( [ y / x ] ph -> ( rank ` x ) C_ ( rank ` y ) ) ) } =/= (/) ) $=
      wph vx wex wph vx cab c0 wne wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab c0 wne wph vx abn0 wph vx cab c0 wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab c0
      wph vx cab c0 wceq vz cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral
      vz wph vx cab crab c0 wceq wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab c0 wceq vz vy wph vx cab scott0 vz cv
      crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz wph vx cab crab wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab c0 vz
      cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz wph vx cab crab vx
      cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vx wph vx cab crab vx
      cv wph vx cab wcel vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral
      wa vx cab wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx cab vz cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vx cv
      crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz vx vy wph vx cab vy cv
      wph vx cab wcel vz ax-17 wph vx vy hbab1 vz cv crnk cfv vy cv crnk cfv
      wss vx vy wph vx cab wph vx vy hbab1 vz cv crnk cfv vy cv crnk cfv wss vx
      ax-17 hbral vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vz ax-17
      vz cv vx cv wceq vz cv crnk cfv vy cv crnk cfv wss vx cv crnk cfv vy cv
      crnk cfv wss vy wph vx cab vz cv vx cv wceq vz cv crnk cfv vx cv crnk cfv
      vy cv crnk cfv vz cv vx cv crnk fveq2 sseq1d ralbidv cbvrab vx cv crnk
      cfv vy cv crnk cfv wss vy wph vx cab wral vx wph vx cab df-rab vx cv wph
      vx cab wcel vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral wa wph
      wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx vx cv
      wph vx cab wcel wph vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral
      wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wph vx abid
      vx cv crnk cfv vy cv crnk cfv wss vy wph vx cab wral vy cv wph vx cab
      wcel vx cv crnk cfv vy cv crnk cfv wss wi vy wal wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal vx cv crnk cfv vy cv crnk cfv wss
      vy wph vx cab df-ral vy cv wph vx cab wcel vx cv crnk cfv vy cv crnk cfv
      wss wi wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy vy cv
      wph vx cab wcel wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wph
      vy vx df-clab imbi1i albii bitri anbi12i abbii 3eqtri eqeq1i bitri
      necon3bii bitr3i $.
      $( [6-Apr-2007] $) $( [13-Oct-2003] $)
  $}

  ${
    $d x y z w A $.  $d y z w B $.  $d w C $.  $d w D $.
    cplem1.1 $e |- C = { y e. B | A. z e. B ( rank ` y ) C_ ( rank ` z ) } $.
    cplem1.2 $e |- D = U_ x e. A C $.
    $( Lemma for the Collection Principle ~ cp . $)
    cplem1 $p |- A. x e. A ( B =/= (/) -> ( B i^i D ) =/= (/) ) $=
      cB c0 wne cB cD cin c0 wne wi vx cA vx cv cA wcel vw cv cC wcel vw wex cB
      cD cin c0 wne cB c0 wne vx cv cA wcel vw cv cC wcel cB cD cin c0 wne vw
      vx cv cA wcel vw cv cC wcel vw cv cB wcel vw cv cD wcel wa cB cD cin c0
      wne vx cv cA wcel vw cv cC wcel vw cv cB wcel vw cv cD wcel vw cv cC wcel
      vw cv cB wcel wi vx cv cA wcel cC cB vw cv cC vy cv crnk cfv vz cv crnk
      cfv wss vz cB wral vy cB crab cB cplem1.1 vy cv crnk cfv vz cv crnk cfv
      wss vz cB wral vy cB ssrab2 eqsstri sseli a1i vx cv cA wcel cC cD vw cv
      vx cv cA wcel cC vx cA cC ciun cD vx cA cC ssiun2 cplem1.2 syl6ssr sseld
      jcad vw cv cB cD inelcm syl6 19.23adv cB c0 wne cC c0 wne vw cv cC wcel
      vw wex cB c0 cC c0 cB c0 wceq vy cv crnk cfv vz cv crnk cfv wss vz cB
      wral vy cB crab c0 wceq cC c0 wceq vy vz cB scott0 cC vy cv crnk cfv vz
      cv crnk cfv wss vz cB wral vy cB crab c0 cplem1.1 eqeq1i bitr4i necon3bii
      vw cC n0 bitri syl5ib rgen $.
      $( [2-Apr-2007] $) $( [17-Oct-2003] $)
  $}

  ${
    $d x y z w A $.  $d y z w B $.
    cplem2.1 $e |- A e. _V $.
    $( -Lemma for the Collection Principle ~ cp . $)
    cplem2 $p |- E. y A. x e. A ( B =/= (/) -> ( B i^i y ) =/= (/) ) $=
      cB c0 wne cB vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB
      crab ciun cin c0 wne wi vx cA wral cB c0 wne cB vy cv cin c0 wne wi vx cA
      wral vy wex vx vz vw cA cB vz cv crnk cfv vw cv crnk cfv wss vw cB wral
      vz cB crab vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab
      ciun vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab eqid vx cA
      vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab ciun eqid cplem1
      cB c0 wne cB vy cv cin c0 wne wi vx cA wral cB c0 wne cB vx cA vz cv crnk
      cfv vw cv crnk cfv wss vw cB wral vz cB crab ciun cin c0 wne wi vx cA
      wral vy vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab
      ciun vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab
      cplem2.1 vz vw cB scottex iunex vy cv vx cA vz cv crnk cfv vw cv crnk cfv
      wss vw cB wral vz cB crab ciun wceq cB c0 wne cB vy cv cin c0 wne wi cB
      c0 wne cB vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab
      ciun cin c0 wne wi vx cA vx vy vx cA vz cv crnk cfv vw cv crnk cfv wss vw
      cB wral vz cB crab ciun vx vy cA vz cv crnk cfv vw cv crnk cfv wss vw cB
      wral vz cB crab hbiu1 hbeleq vy cv vx cA vz cv crnk cfv vw cv crnk cfv
      wss vw cB wral vz cB crab ciun wceq cB vy cv cin c0 wne cB vx cA vz cv
      crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab ciun cin c0 wne cB c0
      wne vy cv vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB wral vz cB crab
      ciun wceq cB vy cv cin cB vx cA vz cv crnk cfv vw cv crnk cfv wss vw cB
      wral vz cB crab ciun cin c0 vy cv vx cA vz cv crnk cfv vw cv crnk cfv wss
      vw cB wral vz cB crab ciun cB ineq2 neeq1d imbi2d ralbid cla4ev ax-mp $.
      $( [2-Apr-2007] $) $( [17-Oct-2003] $)
  $}

  ${
    $d ph z w $.  $d x y z w $.
    $( Collection Principle.  This remarkable theorem scheme is in effect a
       very strong generalization of the Axiom of Replacement.  The proof
       makes use of Scott's trick ~ scottex that collapses a proper class into
       a set of minimum rank.  The wff ` ph ` can be thought of as
       ` ph ( x , y ) ` .  Scheme "Collection Principle" of [Jech] p. 72. $)
    cp $p |- E. w A. x e. z ( E. y ph -> E. y e. w ph ) $=
      wph vy cab c0 wne wph vy cab vw cv cin c0 wne wi vx vz cv wral vw wex wph
      vy wex wph vy vw cv wrex wi vx vz cv wral vw wex vx vw vz cv wph vy cab
      vz visset cplem2 wph vy cab c0 wne wph vy cab vw cv cin c0 wne wi vx vz
      cv wral wph vy wex wph vy vw cv wrex wi vx vz cv wral vw wph vy cab c0
      wne wph vy cab vw cv cin c0 wne wi wph vy wex wph vy vw cv wrex wi vx vz
      cv wph vy cab c0 wne wph vy wex wph vy cab vw cv cin c0 wne wph vy vw cv
      wrex wph vy abn0 vy cv wph vy cab vw cv cin wcel vy wex vy cv vw cv wcel
      wph wa vy wex wph vy cab vw cv cin c0 wne wph vy vw cv wrex vy cv wph vy
      cab vw cv cin wcel vy cv vw cv wcel wph wa vy vy cv wph vy cab vw cv cin
      wcel vy cv wph vy cab wcel vy cv vw cv wcel wa wph vy cv vw cv wcel wa vy
      cv vw cv wcel wph wa vy cv wph vy cab vw cv elin vy cv wph vy cab wcel
      wph vy cv vw cv wcel wph vy abid anbi1i wph vy cv vw cv wcel ancom 3bitri
      exbii vy vz wph vy cab vw cv cin vy vz wph vy cab vw cv wph vy vz hbab1
      vz cv vw cv wcel vy ax-17 hbin ne0f wph vy vw cv df-rex 3bitr4i imbi12i
      ralbii exbii mpbi $.
      $( [31-Dec-2003] $) $( [17-Oct-2003] $)
  $}

  ${
    $d ph z w $.  $d x y z w $.
    $( A very strong generalization of the Axiom of Replacement (compare
       ~ zfrep6 ), derived from the Collection Principle ~ cp .  Its strength
       lies in the rather profound fact that ` ph ( x , y ) ` does not have to
       be a "function-like" wff, as it does in the standard Axiom of
       Replacement.  This theorem is sometimes called the Boundedness Axiom. $)
    bnd $p |- ( A. x e. z E. y ph -> E. w A. x e. z E. y e. w ph ) $=
      wph vy wex vx vz cv wral wph vy vw cv wrex vx vz cv wral wi vw wex wph vy
      wex vx vz cv wral wph vy vw cv wrex vx vz cv wral vw wex wi wph vy wex
      wph vy vw cv wrex wi vx vz cv wral vw wex wph vy wex vx vz cv wral wph vy
      vw cv wrex vx vz cv wral wi vw wex wph vx vy vz vw cp wph vy wex wph vy
      vw cv wrex wi vx vz cv wral wph vy wex vx vz cv wral wph vy vw cv wrex vx
      vz cv wral wi vw wph vy wex wph vy vw cv wrex vx vz cv r19.20 19.22i
      ax-mp wph vy wex vx vz cv wral wph vy vw cv wrex vx vz cv wral vw 19.37v
      mpbi $.
      $( [2-Jan-2004] $) $( [17-Oct-2004] $)
  $}

  ${
    $d ph z w v $.  $d x z w v A $.  $d x y z w v B $.
    bnd2.1 $e |- A e. _V $.
    $( A variant of the Boundedness Axiom ~ bnd that picks a subset ` z ` out
       of a possibly proper class ` B ` in which a property is true. $)
    bnd2 $p |- ( A. x e. A E. y e. B ph ->
              E. z ( z C_ B /\ A. x e. A E. y e. z ph ) ) $=
      wph vy cB wrex vx cA wral vy cv cB wcel wph wa vy vw cv wrex vx cA wral
      vw wex vz cv cB wss wph vy vz cv wrex vx cA wral wa vz wex wph vy cB wrex
      vx cA wral vy cv cB wcel wph wa vy wex vx cA wral vy cv cB wcel wph wa vy
      vw cv wrex vx cA wral vw wex wph vy cB wrex vy cv cB wcel wph wa vy wex
      vx cA wph vy cB df-rex ralbii vy cv cB wcel wph wa vy wex vx vv cv wral
      vy cv cB wcel wph wa vy vw cv wrex vx vv cv wral vw wex wi vy cv cB wcel
      wph wa vy wex vx cA wral vy cv cB wcel wph wa vy vw cv wrex vx cA wral vw
      wex wi vv cA bnd2.1 vv cv cA wceq vy cv cB wcel wph wa vy wex vx vv cv
      wral vy cv cB wcel wph wa vy wex vx cA wral vy cv cB wcel wph wa vy vw cv
      wrex vx vv cv wral vw wex vy cv cB wcel wph wa vy vw cv wrex vx cA wral
      vw wex vy cv cB wcel wph wa vy wex vx vv cv cA raleq1 vv cv cA wceq vy cv
      cB wcel wph wa vy vw cv wrex vx vv cv wral vy cv cB wcel wph wa vy vw cv
      wrex vx cA wral vw vy cv cB wcel wph wa vy vw cv wrex vx vv cv cA raleq1
      exbidv imbi12d vy cv cB wcel wph wa vx vy vv vw bnd vtocl sylbi vy cv cB
      wcel wph wa vy vw cv wrex vx cA wral vz cv cB wss wph vy vz cv wrex vx cA
      wral wa vz wex vw vz cv cB wss wph vy vz cv wrex vx cA wral wa vy cv cB
      wcel wph wa vy vw cv wrex vx cA wral vz vw cv cB cin vw cv cB vw visset
      inex1 vz cv vw cv cB cin wceq wph vy vz cv wrex vx cA wral vz cv cB wss
      wph vy vz cv wrex vx cA wral wa vy cv cB wcel wph wa vy vw cv wrex vx cA
      wral vz cv vw cv cB cin wceq vz cv cB wss wph vy vz cv wrex vx cA wral vz
      cv vw cv cB cin wceq vz cv cB wss vw cv cB cin cB wss vw cv cB inss2 vz
      cv vw cv cB cin cB sseq1 mpbiri biantrurd vz cv vw cv cB cin wceq wph vy
      vz cv wrex vy cv cB wcel wph wa vy vw cv wrex vx cA vz cv vw cv cB cin
      wceq wph vy vz cv wrex wph vy vw cv cB cin wrex vy cv cB wcel wph wa vy
      vw cv wrex wph vy vz cv vw cv cB cin rexeq1 wph vy cv cB wcel wph wa vy
      vw cv cB cin vw cv vy cv vw cv cB cin wcel wph wa vy cv vw cv wcel vy cv
      cB wcel wa wph wa vy cv vw cv wcel vy cv cB wcel wph wa wa vy cv vw cv cB
      cin wcel vy cv vw cv wcel vy cv cB wcel wa wph vy cv vw cv cB elin anbi1i
      vy cv vw cv wcel vy cv cB wcel wph anass bitri rexbii2 syl6bb ralbidv
      bitr3d cla4ev 19.23aiv syl $.
      $( [23-Jul-2004] $) $( [4-Feb-2004] $)
  $}

  ${
    $d x y z A $.
    $( The collection of all sets equinumerous to a set ` A ` and having least
       possible rank is a set.  This is the part of the justification of the
       definition of kard of [Enderton] p. 222. $)
    kardex $p |- { x | ( x ~~ A /\
                  A. y ( y ~~ A -> ( rank ` x ) C_ ( rank ` y ) ) ) } e. _V $=
      vx cv crnk cfv vy cv crnk cfv wss vy vz cv cA cen wbr vz cab wral vx vz
      cv cA cen wbr vz cab crab vx cv cA cen wbr vy cv cA cen wbr vx cv crnk
      cfv vy cv crnk cfv wss wi vy wal wa vx cab cvv vx cv crnk cfv vy cv crnk
      cfv wss vy vz cv cA cen wbr vz cab wral vx vz cv cA cen wbr vz cab crab
      vx cv vz cv cA cen wbr vz cab wcel vx cv crnk cfv vy cv crnk cfv wss vy
      vz cv cA cen wbr vz cab wral wa vx cab vx cv cA cen wbr vy cv cA cen wbr
      vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab vx cv crnk cfv vy
      cv crnk cfv wss vy vz cv cA cen wbr vz cab wral vx vz cv cA cen wbr vz
      cab df-rab vx cv vz cv cA cen wbr vz cab wcel vx cv crnk cfv vy cv crnk
      cfv wss vy vz cv cA cen wbr vz cab wral wa vx cv cA cen wbr vy cv cA cen
      wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx vx cv vz cv cA cen
      wbr vz cab wcel vx cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss vy vz
      cv cA cen wbr vz cab wral vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv
      wss wi vy wal vz cv cA cen wbr vx cv cA cen wbr vz vx cv vx visset vz cv
      vx cv cA cen breq1 elab vx cv crnk cfv vy cv crnk cfv wss vy vz cv cA cen
      wbr vz cab wral vy cv vz cv cA cen wbr vz cab wcel vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal vx cv crnk cfv vy cv crnk cfv wss vy vz cv cA cen wbr vz cab
      df-ral vy cv vz cv cA cen wbr vz cab wcel vx cv crnk cfv vy cv crnk cfv
      wss wi vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy vy cv vz
      cv cA cen wbr vz cab wcel vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv
      wss vz cv cA cen wbr vy cv cA cen wbr vz vy cv vy visset vz cv vy cv cA
      cen breq1 elab imbi1i albii bitri anbi12i abbii eqtri vx vy vz cv cA cen
      wbr vz cab scottex eqeltrri $.
      $( [21-Mar-2007] $) $( [14-Dec-2003] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d z C $.  $d z D $.
    karden.1 $e |- A e. _V $.
    karden.2 $e |- B e. _V $.
    karden.3 $e |- C =
       { x | ( x ~~ A /\ A. y ( y ~~ A -> ( rank ` x ) C_ ( rank ` y ) ) ) } $.
    karden.4 $e |- D =
       { x | ( x ~~ B /\ A. y ( y ~~ B -> ( rank ` x ) C_ ( rank ` y ) ) ) } $.
    $( If we allow the Axiom of Regularity, we can avoid the Axiom of Choice by
       defining the cardinal number of a set as the set of all sets
       equinumerous to it and having least possible rank.  This theorem proves
       the equinumerosity relationship for this definition (compare ~ carden ).
       The hypotheses correspond to the definition of kard of [Enderton] p. 222
       (which we don't define separately since currently we do not use it
       elsewhere).  This theorem along with ~ kardex justify the definition of
       kard.  The restriction to least rank prevents the proper class that
       would result from ` { x | x ~~ A } ` . $)
    karden $p |- ( C = D <-> A ~~ B ) $=
      cC cD wceq cA cB cen wbr cC cD wceq vz cv crnk cfv vy cv crnk cfv wss vy
      vw cv cA cen wbr vw cab wral vz vw cv cA cen wbr vw cab wrex cA cB cen
      wbr vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA cen wbr vw cab wral vz
      vw cv cA cen wbr vw cab crab c0 wne vz cv crnk cfv vy cv crnk cfv wss vy
      vw cv cA cen wbr vw cab wral vz vw cv cA cen wbr vw cab wrex vw cv cA cen
      wbr vw cab c0 wne vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA cen wbr
      vw cab wral vz vw cv cA cen wbr vw cab crab c0 wne vw cv cA cen wbr vw
      cab c0 wne vw cv cA cen wbr vw wex cA cA cen wbr vw cv cA cen wbr vw wex
      cA karden.1 enref vw cv cA cen wbr cA cA cen wbr vw cA karden.1 vw cv cA
      cA cen breq1 cla4ev ax-mp vw cv cA cen wbr vw abn0 mpbir vw cv cA cen wbr
      vw cab c0 vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA cen wbr vw cab
      wral vz vw cv cA cen wbr vw cab crab c0 vz vy vw cv cA cen wbr vw cab
      scott0 necon3bii mpbi vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA cen
      wbr vw cab wral vz vw cv cA cen wbr vw cab rabn0 mpbi cC cD wceq vz cv
      crnk cfv vy cv crnk cfv wss vy vw cv cA cen wbr vw cab wral cA cB cen wbr
      vz vw cv cA cen wbr vw cab cC cD wceq vz cv vw cv cA cen wbr vw cab wcel
      vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA cen wbr vw cab wral cA cB
      cen wbr cC cD wceq vz cv cA cen wbr vy cv cA cen wbr vz cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa cA cB cen wbr vz cv vw cv cA cen wbr vw cab
      wcel vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA cen wbr vw cab wral wa
      cC cD wceq vz cv cA cen wbr vy cv cA cen wbr vz cv crnk cfv vy cv crnk
      cfv wss wi vy wal wa vz cv cA cen wbr vz cv cB cen wbr wa cA cB cen wbr
      cC cD wceq vz cv cA cen wbr vy cv cA cen wbr vz cv crnk cfv vy cv crnk
      cfv wss wi vy wal wa vz cv cA cen wbr vz cv cB cen wbr vz cv cA cen wbr
      vy cv cA cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa vz cv cA
      cen wbr wi cC cD wceq vz cv cA cen wbr vy cv cA cen wbr vz cv crnk cfv vy
      cv crnk cfv wss wi vy wal pm3.26 a1i cC cD wceq vz cv cA cen wbr vy cv cA
      cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa vz cv cB cen wbr
      vy cv cB cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa vz cv cB
      cen wbr cC cD wceq vx cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cv cB cen wbr vy cv cB cen wbr vx cv crnk
      cfv vy cv crnk cfv wss wi vy wal wa wb vx wal vz cv cA cen wbr vy cv cA
      cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa vz cv cB cen wbr
      vy cv cB cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa wb cC cD
      wceq vx cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal wa vx cab vx cv cB cen wbr vy cv cB cen wbr vx cv crnk cfv vy
      cv crnk cfv wss wi vy wal wa vx cab wceq vx cv cA cen wbr vy cv cA cen
      wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cv cB cen wbr vy cv
      cB cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa wb vx wal cC vx
      cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx cab cD vx cv cB cen wbr vy cv cB cen wbr vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab karden.3 karden.4 eqeq12i vx cv cA cen
      wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cv
      cB cen wbr vy cv cB cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal
      wa vx eq2ab bitri vx cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cv cB cen wbr vy cv cB cen wbr vx cv crnk
      cfv vy cv crnk cfv wss wi vy wal wa wb vz cv cA cen wbr vy cv cA cen wbr
      vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa vz cv cB cen wbr vy cv cB
      cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal wa wb vx vz vx cv vz
      cv wceq vx cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv
      wss wi vy wal wa vz cv cA cen wbr vy cv cA cen wbr vz cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cv cB cen wbr vy cv cB cen wbr vx cv crnk
      cfv vy cv crnk cfv wss wi vy wal wa vz cv cB cen wbr vy cv cB cen wbr vz
      cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cv vz cv wceq vx cv cA cen
      wbr vz cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal vy cv cA cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal vx
      cv vz cv cA cen breq1 vx cv vz cv wceq vy cv cA cen wbr vx cv crnk cfv vy
      cv crnk cfv wss wi vy cv cA cen wbr vz cv crnk cfv vy cv crnk cfv wss wi
      vy vx cv vz cv wceq vx cv crnk cfv vy cv crnk cfv wss vz cv crnk cfv vy
      cv crnk cfv wss vy cv cA cen wbr vx cv vz cv wceq vx cv crnk cfv vz cv
      crnk cfv vy cv crnk cfv vx cv vz cv crnk fveq2 sseq1d imbi2d albidv
      anbi12d vx cv vz cv wceq vx cv cB cen wbr vz cv cB cen wbr vy cv cB cen
      wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal vy cv cB cen wbr vz cv
      crnk cfv vy cv crnk cfv wss wi vy wal vx cv vz cv cB cen breq1 vx cv vz
      cv wceq vy cv cB cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy cv cB
      cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy vx cv vz cv wceq vx cv
      crnk cfv vy cv crnk cfv wss vz cv crnk cfv vy cv crnk cfv wss vy cv cB
      cen wbr vx cv vz cv wceq vx cv crnk cfv vz cv crnk cfv vy cv crnk cfv vx
      cv vz cv crnk fveq2 sseq1d imbi2d albidv anbi12d bibi12d a4v sylbi vz cv
      cB cen wbr vy cv cB cen wbr vz cv crnk cfv vy cv crnk cfv wss wi vy wal
      pm3.26 syl6bi jcad cA vz cv cen wbr vz cv cB cen wbr cA cB cen wbr vz cv
      cA cen wbr cA vz cv cB entr vz cv cA karden.1 ensym sylan syl6 vz cv vw
      cv cA cen wbr vw cab wcel vz cv cA cen wbr vz cv crnk cfv vy cv crnk cfv
      wss vy vw cv cA cen wbr vw cab wral vy cv cA cen wbr vz cv crnk cfv vy cv
      crnk cfv wss wi vy wal vw cv cA cen wbr vz cv cA cen wbr vw vz cv vz
      visset vw cv vz cv cA cen breq1 elab vz cv crnk cfv vy cv crnk cfv wss vy
      vw cv cA cen wbr vw cab wral vy cv vw cv cA cen wbr vw cab wcel vz cv
      crnk cfv vy cv crnk cfv wss wi vy wal vy cv cA cen wbr vz cv crnk cfv vy
      cv crnk cfv wss wi vy wal vz cv crnk cfv vy cv crnk cfv wss vy vw cv cA
      cen wbr vw cab df-ral vy cv vw cv cA cen wbr vw cab wcel vz cv crnk cfv
      vy cv crnk cfv wss wi vy cv cA cen wbr vz cv crnk cfv vy cv crnk cfv wss
      wi vy vy cv vw cv cA cen wbr vw cab wcel vy cv cA cen wbr vz cv crnk cfv
      vy cv crnk cfv wss vw cv cA cen wbr vy cv cA cen wbr vw vy cv vy visset
      vw cv vy cv cA cen breq1 elab imbi1i albii bitri anbi12i syl5ib exp3a
      r19.23adv mpi cA cB cen wbr vx cv cA cen wbr vy cv cA cen wbr vx cv crnk
      cfv vy cv crnk cfv wss wi vy wal wa vx cab vx cv cB cen wbr vy cv cB cen
      wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab cC cD cA cB cen
      wbr vx cv cA cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal wa vx cv cB cen wbr vy cv cB cen wbr vx cv crnk cfv vy cv crnk
      cfv wss wi vy wal wa vx cA cB cen wbr vx cv cA cen wbr vx cv cB cen wbr
      vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal vy cv cB cen
      wbr vx cv crnk cfv vy cv crnk cfv wss wi vy wal cB cvv wcel cA cB cen wbr
      vx cv cA cen wbr vx cv cB cen wbr wb karden.2 cA cB vx cv cvv enen2 mpan
      cA cB cen wbr vy cv cA cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy cv
      cB cen wbr vx cv crnk cfv vy cv crnk cfv wss wi vy cA cB cen wbr vy cv cA
      cen wbr vy cv cB cen wbr vx cv crnk cfv vy cv crnk cfv wss cB cvv wcel cA
      cB cen wbr vy cv cA cen wbr vy cv cB cen wbr wb karden.2 cA cB vy cv cvv
      enen2 mpan imbi1d albidv anbi12d abbidv karden.3 karden.4 3eqtr4g impbii
      $.
      $( [15-Feb-2004] $) $( [18-Dec-2003] $)
  $}

  ${
      $d x y A $.  $d x y R $.
    htalem.1 $e |- A e. _V $.
    htalem.2 $e |- B = U. { x e. A | A. y e. A -. y R x } $.
    $( Lemma for defining an emulation of Hilbert's epsilon.  Hilbert's epsilon
       is described at ~ http://plato.stanford.edu/entries/epsilon-calculus/ .
       This theorem is equivalent to Hilbert's "transfinite axiom," described
       on that page, with the additional ` R We A ` antecedent.  The element
       ` B ` is the epsilon that the theorem emulates. $)
    htalem $p |- ( ( R We A /\ A =/= (/) ) -> B e. A ) $=
      cA cR wwe cA c0 wne wa vy cv vx cv cR wbr wn vy cA wral vx cA crab cuni
      cA cB cA cR wwe cA cA wss cA c0 wne vy cv vx cv cR wbr wn vy cA wral vx
      cA crab cuni cA wcel cA ssid vx vy cA cA cR htalem.1 wereucl mp3an2
      htalem.2 syl5eqel $.
      $( [10-Apr-2007] $) $( [11-Mar-2004] $)
  $}

  ${
    $d z v A $.  $d x y R z v $.  $d y z v ph $.
    hta.1 $e |- A = { x | ( ph /\ A. y ( [ y / x ] ph ->
                                         ( rank ` x ) C_ ( rank ` y ) ) ) } $.
    hta.2 $e |- B = U. { x e. A | A. y e. A -. y R x } $.
    $( A ZFC emulation of Hilbert's transfinite axiom.  The set ` B ` has the
       properties of Hilbert's epsilon, except that it also depends on a
       well-ordering ` R ` .  This theorem arose from discussions with Raph
       Levien on 5-Mar-2004 about translating the HOL proof language, which
       uses Hilbert's epsilon.  See ~ http://ghilbert.org/choice.txt and
       ~ http://us.metamath.org/downloads/megillaward2004.pdf .

       Hilbert's epsilon is described at
       ~ http://plato.stanford.edu/entries/epsilon-calculus/ .  This theorem
       differs from Hilbert's transfinite axiom described on that page in
       that it requires ` R We A ` as an antecedent.  Class ` A ` collects the
       sets of least rank for which ` ph ( x ) ` is true.  Class ` B ` , which
       emulates the epsilon, is the minimum element in a well-ordering ` R ` on
       ` A ` .

       If a well-ordering ` R ` on ` A ` can be expressed in a closed form, as
       might be the case if we are working with say natural numbers, we can
       eliminate the antecedent with modus ponens, giving us the exact
       equivalent of Hilbert's transfinite axiom.  Otherwise, we replace ` R `
       with a dummy set variable, say ` w ` , and attach ` w We A ` as an
       antecedent in each step of the ZFC version of the HOL proof until the
       epsilon is eliminated.  At that point, ` B ` (which will have ` w ` as a
       free variable) will no longer be present, and we can eliminate
       ` w We A ` by applying ~ 19.23aiv and ~ weth , using ~ scottexs to
       establish the existence of ` A ` .

       For a version of this theorem scheme using class (meta)variables
       instead of wff (meta)variables, see ~ htalem . $)
    hta $p |- ( R We A -> ( ph -> [ B / x ] ph ) ) $=
      cA cR wwe wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx cab c0 wne wph vx cB wsbc wph cA cR wwe wph wph vx vy cv wsbc
      vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab c0 wne cB wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wcel
      wph vx cB wsbc cA cR wwe wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk
      cfv wss wi vy wal wa vx cab cR wwe wph wph vx vy cv wsbc vx cv crnk cfv
      vy cv crnk cfv wss wi vy wal wa vx cab c0 wne cB wph wph vx vy cv wsbc vx
      cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wcel wi cA wph wph vx
      vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wceq cA
      cR wwe wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal
      wa vx cab cR wwe wb hta.1 cA wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab cR weeq2 ax-mp wph wph vx vy cv wsbc vx
      cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab cR wwe wph wph vx vy
      cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab c0 wne cB
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab wcel vz vv wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi
      vy wal wa vx cab cB cR wph vx vy scottexs cB vy cv vx cv cR wbr wn vy cA
      wral vx cA crab cuni vv cv vz cv cR wbr wn vv wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral vz wph wph vx vy cv
      wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab crab cuni
      hta.2 vy cv vx cv cR wbr wn vy cA wral vx cA crab vv cv vz cv cR wbr wn
      vv wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa
      vx cab wral vz wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi
      vy wal wa vx cab crab vy cv vx cv cR wbr wn vy cA wral vx cA crab vy cv
      vx cv cR wbr wn vy wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv
      wss wi vy wal wa vx cab wral vx cA crab vy cv vx cv cR wbr wn vy wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral
      vx wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa
      vx cab crab vv cv vz cv cR wbr wn vv wph wph vx vy cv wsbc vx cv crnk cfv
      vy cv crnk cfv wss wi vy wal wa vx cab wral vz wph wph vx vy cv wsbc vx
      cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab crab vy cv vx cv cR
      wbr wn vy cA wral vy cv vx cv cR wbr wn vy wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral vx cA vy cv vx cv cR
      wbr wn vy cA wral vy cv vx cv cR wbr wn vy wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral wb vx cv cA wcel cA
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab wceq vy cv vx cv cR wbr wn vy cA wral vy cv vx cv cR wbr wn vy wph
      wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab
      wral wb hta.1 vy cv vx cv cR wbr wn vy vz cA wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab vy vz cA wph wph vx vy cv
      wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab hta.1 wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vy vx vz wph
      wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal vy wph vy
      ax-17 wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy hba1 hban
      hbab hbxfr wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vy vx vz wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal vy wph vy ax-17 wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv
      wss wi vy hba1 hban hbab raleq1f ax-mp a1i rabbii cA wph wph vx vy cv
      wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wceq vy cv vx
      cv cR wbr wn vy wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal wa vx cab wral vx cA crab vy cv vx cv cR wbr wn vy wph wph vx
      vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral vx
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab crab wceq hta.1 vy cv vx cv cR wbr wn vy wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral vx vz cA wph wph vx
      vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab vx vz cA
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab hta.1 wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx vz hbab1 hbxfr wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk
      cfv wss wi vy wal wa vx vz hbab1 rabeqf ax-mp vy cv vx cv cR wbr wn vy
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab wral vx wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx cab crab vy cv vz cv cR wbr wn vy wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral vz wph wph vx vy cv
      wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab crab vv cv vz
      cv cR wbr wn vv wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss
      wi vy wal wa vx cab wral vz wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab crab vy cv vx cv cR wbr wn vy wph wph vx
      vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral vy
      cv vz cv cR wbr wn vy wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv
      wss wi vy wal wa vx cab wral vx vz vv wph wph vx vy cv wsbc vx cv crnk
      cfv vy cv crnk cfv wss wi vy wal wa vx cab wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx vv hbab1 vv cv wph wph vx vy
      cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wcel vz
      ax-17 vy cv vx cv cR wbr wn vy wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab wral vz ax-17 vy cv vz cv cR wbr wn vx
      vy wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa
      vx cab wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal
      wa vx vy hbab1 vy cv vz cv cR wbr wn vx ax-17 hbral vx cv vz cv wceq vy
      cv vx cv cR wbr wn vy cv vz cv cR wbr wn vy wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab vx cv vz cv wceq vy cv vx
      cv cR wbr vy cv vz cv cR wbr vx cv vz cv vy cv cR breq2 notbid ralbidv
      cbvrab vy cv vz cv cR wbr wn vy wph wph vx vy cv wsbc vx cv crnk cfv vy
      cv crnk cfv wss wi vy wal wa vx cab wral vv cv vz cv cR wbr wn vv wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral
      vz wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa
      vx cab vy cv vz cv cR wbr wn vy wph wph vx vy cv wsbc vx cv crnk cfv vy
      cv crnk cfv wss wi vy wal wa vx cab wral vv cv vz cv cR wbr wn vv wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wral
      wb vz cv wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal wa vx cab wcel vy cv vz cv cR wbr wn vv cv vz cv cR wbr wn vy vv vz
      wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx
      cab wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa
      vy vx vz wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy
      wal vy wph vy ax-17 wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss
      wi vy hba1 hban hbab vz cv wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa vx cab wcel vv ax-17 vy cv vz cv cR wbr wn vv
      ax-17 vv cv vz cv cR wbr wn vy ax-17 vy cv vv cv wceq vy cv vz cv cR wbr
      vv cv vz cv cR wbr vy cv vv cv vz cv cR breq1 notbid cbvralf a1i rabbii
      eqtri 3eqtri unieqi eqtri htalem ex sylbi cB wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab wcel cB wph vx cab wcel
      wph vx cB wsbc wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi
      vy wal wa vx cab wph vx cab cB wph wph vx vy cv wsbc vx cv crnk cfv vy cv
      crnk cfv wss wi vy wal wa wph vx wph wph vx vy cv wsbc vx cv crnk cfv vy
      cv crnk cfv wss wi vy wal pm3.26 ss2abi sseli wph vx cB cB vy cv vx cv cR
      wbr wn vy cA wral vx cA crab cuni cvv hta.2 vy cv vx cv cR wbr wn vy cA
      wral vx cA crab vy cv vx cv cR wbr wn vy cA wral vx cA crab cA cA wph wph
      vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab cvv
      hta.1 wph vx vy scottexs eqeltri vy cv vx cv cR wbr wn vy cA wral vx cA
      crab vy cv vz cv cR wbr wn vy cA wral vz cA crab cA vy cv vx cv cR wbr wn
      vy cA wral vy cv vz cv cR wbr wn vy cA wral vx vz vv cA vx vz vz vv cv cA
      vz cv vv cv wcel vx ax-17 vx vz cA wph wph vx vy cv wsbc vx cv crnk cfv
      vy cv crnk cfv wss wi vy wal wa vx cab hta.1 wph wph vx vy cv wsbc vx cv
      crnk cfv vy cv crnk cfv wss wi vy wal wa vx vz hbab1 hbxfr hbel vv cv cA
      wcel vz ax-17 vy cv vx cv cR wbr wn vy cA wral vz ax-17 vy cv vz cv cR
      wbr wn vx vy cA vx vz vz vy cv cA vz cv vy cv wcel vx ax-17 vx vz cA wph
      wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab
      hta.1 wph wph vx vy cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal
      wa vx vz hbab1 hbxfr hbel vy cv vz cv cR wbr wn vx ax-17 hbral vx cv vz
      cv wceq vy cv vx cv cR wbr wn vy cv vz cv cR wbr wn vy cA vx cv vz cv
      wceq vy cv vx cv cR wbr vy cv vz cv cR wbr vx cv vz cv vy cv cR breq2
      notbid ralbidv cbvrab vy cv vz cv cR wbr wn vy cA wral vz cA ssrab2
      eqsstri ssexi uniex eqeltri elabs sylib syl6 wph wph vx wex wph wph vx vy
      cv wsbc vx cv crnk cfv vy cv crnk cfv wss wi vy wal wa vx cab c0 wne wph
      vx 19.8a wph vx vy scott0s sylib syl5 $.
      $( [12-Mar-2004] $) $( [11-Mar-2004] $)

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Axiom of Choice equivalents
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u t h $.
    $( Equivalence of two versions of the Axiom of Choice ~ ax-ac .  The
       proof uses neither AC nor the Axiom of Regularity.  The right-hand side
       expresses our AC with the fewest number of different variables. $)
    aceq1 $p |- ( E. y A. z e. x A. w e. z E! v e. z E. u e. y
                      ( z e. u /\ v e. u ) <->
                  E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. x A. z ( E. x
           ( ( z e. w /\ w e. x ) /\ ( z e. x /\ x e. y ) ) <-> z = x ) ) ) $=
      vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv
      wral vz vx cv wral vy wex vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv
      wrex vz vw cv wreu vt vw cv wral vw vx cv wral vy wex vz cv vw cv wcel vw
      cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx
      cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vw wal vz
      wal vy wex vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv
      wreu vw vz cv wral vz vx cv wral vw cv vu cv wcel vz cv vu cv wcel wa vu
      vy cv wrex vz vw cv wreu vt vw cv wral vw vx cv wral vy vh cv vu cv wcel
      vv cv vu cv wcel wa vu vy cv wrex vv vh cv wreu vw vh cv wral vh vx cv
      wral vh cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vh cv wreu vt
      vh cv wral vh vx cv wral vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv
      wrex vv vz cv wreu vw vz cv wral vz vx cv wral vw cv vu cv wcel vz cv vu
      cv wcel wa vu vy cv wrex vz vw cv wreu vt vw cv wral vw vx cv wral vh cv
      vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vh cv wreu vw vh cv wral
      vh cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vh cv wreu vt vh cv
      wral vh vx cv vh cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vh cv
      wreu vw vh cv wral vh cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv
      vh cv wreu vt vh cv wral vh cv vu cv wcel vz cv vu cv wcel wa vu vy cv
      wrex vz vh cv wreu vt vh cv wral vh cv vu cv wcel vv cv vu cv wcel wa vu
      vy cv wrex vv vh cv wreu vh cv vu cv wcel vv cv vu cv wcel wa vu vy cv
      wrex vv vh cv wreu vw vt vh cv vw cv vt cv wceq vh cv vu cv wcel vv cv vu
      cv wcel wa vu vy cv wrex vv vh cv wreu biidd cbvralv vh cv vu cv wcel vv
      cv vu cv wcel wa vu vy cv wrex vv vh cv wreu vh cv vu cv wcel vz cv vu cv
      wcel wa vu vy cv wrex vz vh cv wreu vt vh cv vh cv vu cv wcel vv cv vu cv
      wcel wa vu vy cv wrex vh cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex
      vv vz vh cv vv cv vz cv wceq vh cv vu cv wcel vv cv vu cv wcel wa vh cv
      vu cv wcel vz cv vu cv wcel wa vu vy cv vv cv vz cv wceq vv cv vu cv wcel
      vz cv vu cv wcel vh cv vu cv wcel vv cv vz cv vu cv eleq1 anbi2d rexbidv
      cbvreuv ralbii bitri ralbii vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv
      wrex vv vz cv wreu vw vz cv wral vh cv vu cv wcel vv cv vu cv wcel wa vu
      vy cv wrex vv vh cv wreu vw vh cv wral vz vh vx cv vz cv vu cv wcel vv cv
      vu cv wcel wa vu vy cv wrex vv vz cv wreu vh cv vu cv wcel vv cv vu cv
      wcel wa vu vy cv wrex vv vh cv wreu vw vz cv vh cv vz cv vu cv wcel vv cv
      vu cv wcel wa vu vy cv wrex vh cv vu cv wcel vv cv vu cv wcel wa vu vy cv
      wrex vv vz cv vh cv vz cv vh cv wceq vz cv vu cv wcel vv cv vu cv wcel wa
      vh cv vu cv wcel vv cv vu cv wcel wa vu vy cv vz cv vh cv wceq vz cv vu
      cv wcel vh cv vu cv wcel vv cv vu cv wcel vz cv vh cv vu cv eleq1 anbi1d
      rexbidv reueqd raleqd cbvralv vw cv vu cv wcel vz cv vu cv wcel wa vu vy
      cv wrex vz vw cv wreu vt vw cv wral vh cv vu cv wcel vz cv vu cv wcel wa
      vu vy cv wrex vz vh cv wreu vt vh cv wral vw vh vx cv vw cv vu cv wcel vz
      cv vu cv wcel wa vu vy cv wrex vz vw cv wreu vh cv vu cv wcel vz cv vu cv
      wcel wa vu vy cv wrex vz vh cv wreu vt vw cv vh cv vw cv vu cv wcel vz cv
      vu cv wcel wa vu vy cv wrex vh cv vu cv wcel vz cv vu cv wcel wa vu vy cv
      wrex vz vw cv vh cv vw cv vh cv wceq vw cv vu cv wcel vz cv vu cv wcel wa
      vh cv vu cv wcel vz cv vu cv wcel wa vu vy cv vw cv vh cv wceq vw cv vu
      cv wcel vh cv vu cv wcel vz cv vu cv wcel vw cv vh cv vu cv eleq1 anbi1d
      rexbidv reueqd raleqd cbvralv 3bitr4i exbii vw cv vu cv wcel vz cv vu cv
      wcel wa vu vy cv wrex vz vw cv wreu vt vw cv wral vw vx cv wral vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx
      cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex
      wi vw wal vz wal vy vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel
      vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv
      vx cv wceq wb vz wal vx wex wi vz wal vw wal vw cv vx cv wcel vw cv vu cv
      wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv wreu vt vw cv wral wi vw
      wal vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv
      wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq
      wb vz wal vx wex wi vw wal vz wal vw cv vu cv wcel vz cv vu cv wcel wa vu
      vy cv wrex vz vw cv wreu vt vw cv wral vw vx cv wral vz cv vw cv wcel vw
      cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx
      cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vz wal vw
      cv vx cv wcel vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv
      wreu vt vw cv wral wi vw vw cv vx cv wcel vz cv vw cv wcel vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex
      vz cv vx cv wceq wb vz wal vx wex wi wi vz wal vw cv vx cv wcel vz cv vw
      cv wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv
      wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vz wal wi vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx
      cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex
      wi vz wal vw cv vx cv wcel vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv
      wrex vz vw cv wreu vt vw cv wral wi vw cv vx cv wcel vz cv vw cv wcel vz
      cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa
      vx wex vz cv vx cv wceq wb vz wal vx wex wi vz 19.21v vz cv vw cv wcel vw
      cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx
      cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vw cv vx
      cv wcel vz cv vw cv wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv
      wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi
      wi vz vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv
      wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq
      wb vz wal vx wex wi vz cv vw cv wcel vw cv vx cv wcel vz cv vw cv wcel vw
      cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx
      cv wceq wb vz wal vx wex wi wi vw cv vx cv wcel vz cv vw cv wcel vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex wi wi vz cv vw cv wcel vw cv vx cv
      wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv
      wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex impexp vz cv vw cv
      wcel vw cv vx cv wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv
      wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex
      bi2.04 bitri albii vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz
      vw cv wreu vt vw cv wral vz cv vw cv wcel vz cv vw cv wcel vw cv vx cv
      wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq
      wb vz wal vx wex wi vz wal vw cv vx cv wcel vt cv vw cv wcel vw cv vu cv
      wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv wreu wi vt wal vt cv vw
      cv wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv
      wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vt wal vw cv vu cv
      wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv wreu vt vw cv wral vz cv
      vw cv wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy
      cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vz wal vt cv vw
      cv wcel vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv wreu
      wi vt cv vw cv wcel vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel
      vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vt vw
      cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv wreu vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex
      vz cv vx cv wceq wb vz wal vx wex vt cv vw cv wcel vz cv vw cv wcel vw cv
      vu cv wcel vz cv vu cv wcel wa vu vy cv wrex wa vz weu vz cv vw cv wcel
      vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex wa vz cv vx cv wceq wb
      vz wal vx wex vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv
      wreu vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv
      wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex vz cv vw cv wcel vw
      cv vu cv wcel vz cv vu cv wcel wa vu vy cv wrex wa vz vx df-eu vw cv vu
      cv wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv df-reu vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex
      vz cv vx cv wceq wb vz wal vz cv vw cv wcel vw cv vu cv wcel vz cv vu cv
      wcel wa vu vy cv wrex wa vz cv vx cv wceq wb vz wal vx vz cv vw cv wcel
      vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv
      vx cv wceq wb vz cv vw cv wcel vw cv vu cv wcel vz cv vu cv wcel wa vu vy
      cv wrex wa vz cv vx cv wceq wb vz vz cv vw cv wcel vw cv vx cv wcel wa vz
      cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vw cv wcel vw cv vu cv
      wcel vz cv vu cv wcel wa vu vy cv wrex wa vz cv vx cv wceq vz cv vw cv
      wcel vx cv vy cv wcel vw cv vx cv wcel vz cv vx cv wcel wa wa wa vx wex
      vz cv vw cv wcel vx cv vy cv wcel vw cv vx cv wcel vz cv vx cv wcel wa wa
      vx wex wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy
      cv wcel wa wa vx wex vz cv vw cv wcel vw cv vu cv wcel vz cv vu cv wcel
      wa vu vy cv wrex wa vz cv vw cv wcel vx cv vy cv wcel vw cv vx cv wcel vz
      cv vx cv wcel wa wa vx 19.42v vz cv vw cv wcel vw cv vx cv wcel wa vz cv
      vx cv wcel vx cv vy cv wcel wa wa vz cv vw cv wcel vx cv vy cv wcel vw cv
      vx cv wcel vz cv vx cv wcel wa wa wa vx vz cv vw cv wcel vw cv vx cv wcel
      wa vz cv vx cv wcel vx cv vy cv wcel wa wa vz cv vw cv wcel vx cv vy cv
      wcel wa vw cv vx cv wcel vz cv vx cv wcel wa wa vz cv vw cv wcel vx cv vy
      cv wcel vw cv vx cv wcel vz cv vx cv wcel wa wa wa vz cv vw cv wcel vx cv
      vy cv wcel vw cv vx cv wcel vz cv vx cv wcel an42 vz cv vw cv wcel vx cv
      vy cv wcel vw cv vx cv wcel vz cv vx cv wcel wa anass bitr3i exbii vw cv
      vu cv wcel vz cv vu cv wcel wa vu vy cv wrex vx cv vy cv wcel vw cv vx cv
      wcel vz cv vx cv wcel wa wa vx wex vz cv vw cv wcel vw cv vu cv wcel vz
      cv vu cv wcel wa vu vy cv wrex vu cv vy cv wcel vw cv vu cv wcel vz cv vu
      cv wcel wa wa vu wex vx cv vy cv wcel vw cv vx cv wcel vz cv vx cv wcel
      wa wa vx wex vw cv vu cv wcel vz cv vu cv wcel wa vu vy cv df-rex vu cv
      vy cv wcel vw cv vu cv wcel vz cv vu cv wcel wa wa vx cv vy cv wcel vw cv
      vx cv wcel vz cv vx cv wcel wa wa vu vx vu cv vx cv wceq vu cv vy cv wcel
      vx cv vy cv wcel vw cv vu cv wcel vz cv vu cv wcel wa vw cv vx cv wcel vz
      cv vx cv wcel wa vu cv vx cv vy cv eleq1 vu cv vx cv wceq vw cv vu cv
      wcel vw cv vx cv wcel vz cv vu cv wcel vz cv vx cv wcel vu cv vx cv vw cv
      eleq2 vu cv vx cv vz cv eleq2 anbi12d anbi12d cbvexv bitri anbi2i 3bitr4i
      bibi1i albii exbii 3bitr4i imbi2i albii vw cv vu cv wcel vz cv vu cv wcel
      wa vu vy cv wrex vz vw cv wreu vt vw cv df-ral vz cv vw cv wcel vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex wi vt cv vw cv wcel vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex
      vz cv vx cv wceq wb vz wal vx wex wi vz vt vz cv vw cv wcel vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex
      vz cv vx cv wceq wb vz wal vx wex wi vt ax-17 vt cv vw cv wcel vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex vz vt cv vw cv wcel vz ax-17 vz cv
      vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vz vx vz cv vw cv wcel vw cv vx cv wcel wa
      vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz
      hba1 hbex hbim vz cv vt cv wceq vz cv vw cv wcel vt cv vw cv wcel vz cv
      vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex vz cv vt cv vw cv eleq1 imbi1d
      cbval 3bitr4i imbi2i 3bitr4i albii vz cv vw cv wcel vw cv vx cv wcel wa
      vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa
      wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vz vw alcom vw cv vu cv
      wcel vz cv vu cv wcel wa vu vy cv wrex vz vw cv wreu vt vw cv wral vw vx
      cv df-ral 3bitr4ri exbii bitri $.
      $( [26-Jun-2004] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x y z w v u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The proof uses
       neither AC nor the Axiom of Regularity.  The right-hand side is our
       original  ~ ax-ac . $)
    aceq0 $p |- ( E. y A. z e. x A. w e. z E! v e. z E. u e. y
                      ( z e. u /\ v e. u ) <->
                  E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u
     ( E. t ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) ) $=
      vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv
      wral vz vx cv wral vy wex vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex wi vw wal vz wal vy wex vz cv vw cv
      wcel vw cv vx cv wcel wa vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv
      wcel vt cv vy cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal vv wex wi
      vw wal vz wal vy wex vx vy vz vw vv vu aceq1 vz cv vw cv wcel vw cv vx cv
      wcel wa vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv
      wcel wa wa vt wex vu cv vv cv wceq wb vu wal vv wex wi vw wal vz wal vz
      cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz
      cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx
      wex wi vw wal vz wal vy vz cv vw cv wcel vw cv vx cv wcel wa vu cv vw cv
      wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex
      vu cv vv cv wceq wb vu wal vv wex wi vz cv vw cv wcel vw cv vx cv wcel wa
      vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa
      wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vz vw vu cv vw cv wcel vw
      cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vv
      cv wceq wb vu wal vv wex vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv
      wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex vz
      cv vw cv wcel vw cv vx cv wcel wa vu cv vw cv wcel vw cv vt cv wcel wa vu
      cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal vz
      cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa
      vx wex vz cv vx cv wceq wb vz wal vv vx vv cv vx cv wceq vu cv vw cv wcel
      vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv
      vv cv wceq wb vu wal vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv
      wcel vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq wb vu wal vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex
      vz cv vx cv wceq wb vz wal vv cv vx cv wceq vu cv vw cv wcel vw cv vt cv
      wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vv cv wceq
      wb vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel
      wa wa vx wex vu cv vx cv wceq wb vu vv cv vx cv wceq vu cv vw cv wcel vw
      cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vv
      cv wceq wb vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy
      cv wcel wa wa vt wex vu cv vx cv wceq wb vu cv vw cv wcel vw cv vx cv
      wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq
      wb vv cv vx cv wceq vu cv vv cv wceq vu cv vx cv wceq vu cv vw cv wcel vw
      cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vv vx vu
      equequ2 bibi2d vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt
      cv vy cv wcel wa wa vt wex vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx
      cv wcel vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq vu cv vw cv wcel
      vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vu cv vw cv
      wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vt vx vt
      cv vx cv wceq vu cv vw cv wcel vw cv vt cv wcel wa vu cv vw cv wcel vw cv
      vx cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa vu cv vx cv wcel vx cv
      vy cv wcel wa vt cv vx cv wceq vw cv vt cv wcel vw cv vx cv wcel vu cv vw
      cv wcel vt vx vw elequ2 anbi2d vt cv vx cv wceq vu cv vt cv wcel vu cv vx
      cv wcel vt cv vy cv wcel vx cv vy cv wcel vt vx vu elequ2 vt vx vy elequ1
      anbi12d anbi12d cbvexv bibi1i syl6bb albidv vu cv vw cv wcel vw cv vx cv
      wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq
      wb vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel
      wa wa vx wex vz cv vx cv wceq wb vu vz vu cv vz cv wceq vu cv vw cv wcel
      vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv
      vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vu cv vx cv wceq vz cv vx cv wceq vu cv vz cv wceq vu cv vw cv wcel
      vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vz cv vw cv
      wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx vu cv
      vz cv wceq vu cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx
      cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa vz cv vx cv wcel vx cv vy
      cv wcel wa vu cv vz cv wceq vu cv vw cv wcel vz cv vw cv wcel vw cv vx cv
      wcel vu vz vw elequ1 anbi1d vu cv vz cv wceq vu cv vx cv wcel vz cv vx cv
      wcel vx cv vy cv wcel vu vz vx elequ1 anbi1d anbi12d exbidv vu vz vx
      equequ1 bibi12d cbvalv syl6bb cbvexv imbi2i 2albii exbii bitr4i $.
      $( [22-Aug-2004] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x y z w v u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The proof uses
       neither AC nor the Axiom of Regularity. $)
    aceq2 $p |- ( E. y A. z e. x A. w e. z E! v e. z E. u e. y
                     ( z e. u /\ v e. u ) <->
                  E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
                      ( z e. v /\ w e. v ) ) ) $=
      vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv
      wral vz vx cv wral vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv
      vy cv wrex vw vz cv wreu wi vz vx cv wral vy vz cv vu cv wcel vv cv vu cv
      wcel wa vu vy cv wrex vv vz cv wreu vw vz cv wral vz cv c0 wne vz cv vv
      cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv vz cv
      vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vt vz cv wral
      vt cv vz cv wcel vt wex vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv
      wrex vv vz cv wreu wi vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex
      vv vz cv wreu vw vz cv wral vz cv c0 wne vz cv vv cv wcel vw cv vv cv
      wcel wa vv vy cv wrex vw vz cv wreu wi vz cv vu cv wcel vv cv vu cv wcel
      wa vu vy cv wrex vv vz cv wreu vt vz cv wral vt cv vz cv wcel vz cv vu cv
      wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu wi vt wal vt cv vz
      cv wcel vt wex vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz
      cv wreu wi vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv
      wreu vt vz cv df-ral vt cv vz cv wcel vz cv vu cv wcel vv cv vu cv wcel
      wa vu vy cv wrex vv vz cv wreu vt 19.23v bitri vz cv vu cv wcel vv cv vu
      cv wcel wa vu vy cv wrex vv vz cv wreu vz cv vu cv wcel vv cv vu cv wcel
      wa vu vy cv wrex vv vz cv wreu vw vt vz cv vw cv vt cv wceq vz cv vu cv
      wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu biidd cbvralv vz cv
      c0 wne vt cv vz cv wcel vt wex vz cv vv cv wcel vw cv vv cv wcel wa vv vy
      cv wrex vw vz cv wreu vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex
      vv vz cv wreu vt vz cv n0 vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv
      wrex vw vz cv wreu vz cv vu cv wcel vw cv vu cv wcel wa vu vy cv wrex vw
      vz cv wreu vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv
      wreu vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vz cv vu cv wcel
      vw cv vu cv wcel wa vu vy cv wrex vw vz cv vz cv vv cv wcel vw cv vv cv
      wcel wa vz cv vu cv wcel vw cv vu cv wcel wa vv vu vy cv vv cv vu cv wceq
      vz cv vv cv wcel vz cv vu cv wcel vw cv vv cv wcel vw cv vu cv wcel vv cv
      vu cv vz cv eleq2 vv cv vu cv vw cv eleq2 anbi12d cbvrexv reubii vz cv vu
      cv wcel vw cv vu cv wcel wa vu vy cv wrex vz cv vu cv wcel vv cv vu cv
      wcel wa vu vy cv wrex vw vv vz cv vw cv vv cv wceq vz cv vu cv wcel vw cv
      vu cv wcel wa vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv vw cv vv cv
      wceq vw cv vu cv wcel vv cv vu cv wcel vz cv vu cv wcel vw cv vv cv vu cv
      eleq1 anbi2d rexbidv cbvreuv bitri imbi12i 3bitr4i ralbii exbii $.
      $( [7-Apr-2007] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x y z w v u t h g f $.  $d t h g F $.
    aceq3lem.1 $e |- F =
              { <. w , v >. | ( w e. dom y /\ v = ( f ` { u | w y u } ) ) } $.
    $( Lemma for ~ aceq3 . $)
    aceq3lem $p |- ( A. x E. f A. z e. x ( z =/= (/) -> ( f ` z
                 ) e. z ) -> E. f ( f C_ y /\ f Fn dom y ) ) $=
      vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf wex vx wal vg
      cv vy cv wss vg cv vy cv cdm wfn wa vg wex vf cv vy cv wss vf cv vy cv
      cdm wfn wa vf wex vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv
      wral vf wex vx wal vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vy cv
      crn cpw wral vf wex vg cv vy cv wss vg cv vy cv cdm wfn wa vg wex vz cv
      c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf wex vz cv c0 wne vz
      cv vf cv cfv vz cv wcel wi vz vy cv crn cpw wral vf wex vx vy cv crn cpw
      vy cv crn vy cv vy visset rnex pwex vx cv vy cv crn cpw wceq vz cv c0 wne
      vz cv vf cv cfv vz cv wcel wi vz vx cv wral vz cv c0 wne vz cv vf cv cfv
      vz cv wcel wi vz vy cv crn cpw wral vf vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv vy cv crn cpw raleq1 exbidv cla4v vz cv c0 wne vz cv vf
      cv cfv vz cv wcel wi vz vy cv crn cpw wral vg cv vy cv wss vg cv vy cv
      cdm wfn wa vg wex vf cF vy cv wss cF vy cv cdm wfn vg cv vy cv wss vg cv
      vy cv cdm wfn wa vg wex vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vy
      cv crn cpw wral vg cv vy cv wss vg cv vy cv cdm wfn wa cF vy cv wss cF vy
      cv cdm wfn wa vg cF cF vy cv cdm wfn vy cv cdm cvv wcel cF cvv wcel vw vv
      vy cv cdm vw cv vu cv vy cv wbr vu cab vf cv cfv cF vw cv vu cv vy cv wbr
      vu cab vf cv fvex aceq3lem.1 fnopab2 vy cv vy visset dmex vy cv cdm cvv
      cF fnex mp2an vg cv cF wceq vg cv vy cv wss cF vy cv wss vg cv vy cv cdm
      wfn cF vy cv cdm wfn vg cv cF vy cv sseq1 vy cv cdm vg cv cF fneq1
      anbi12d cla4ev vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vy cv crn
      cpw wral vt vh cF vy cv cF wrel vz cv c0 wne vz cv vf cv cfv vz cv wcel
      wi vz vy cv crn cpw wral cF wrel vw cv vy cv cdm wcel vv cv vw cv vu cv
      vy cv wbr vu cab vf cv cfv wceq wa vw vv copab wrel vw cv vy cv cdm wcel
      vv cv vw cv vu cv vy cv wbr vu cab vf cv cfv wceq wa vw vv relopab cF vw
      cv vy cv cdm wcel vv cv vw cv vu cv vy cv wbr vu cab vf cv cfv wceq wa vw
      vv copab aceq3lem.1 releqi mpbir a1i vt cv vh cv cop cF wcel vz cv c0 wne
      vz cv vf cv cfv vz cv wcel wi vz vy cv crn cpw wral vt cv vh cv cop vy cv
      wcel vt cv vh cv cop cF wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel wi
      vz vy cv crn cpw wral vt cv vt cv cF cfv cop vy cv wcel vt cv vh cv cop
      vy cv wcel vt cv vh cv cop cF wcel vt cv vy cv cdm wcel vz cv c0 wne vz
      cv vf cv cfv vz cv wcel wi vz vy cv crn cpw wral vt cv vt cv cF cfv cop
      vy cv wcel wi vt cv vh cv cop cF wcel vt cv vy cv cdm wcel vh cv vt cv vu
      cv vy cv wbr vu cab vf cv cfv wceq vt cv vh cv cop cF wcel vt cv vh cv
      cop vw cv vy cv cdm wcel vv cv vw cv vu cv vy cv wbr vu cab vf cv cfv
      wceq wa vw vv copab wcel vt cv vy cv cdm wcel vh cv vt cv vu cv vy cv wbr
      vu cab vf cv cfv wceq wa cF vw cv vy cv cdm wcel vv cv vw cv vu cv vy cv
      wbr vu cab vf cv cfv wceq wa vw vv copab vt cv vh cv cop aceq3lem.1
      eleq2i vw cv vy cv cdm wcel vv cv vw cv vu cv vy cv wbr vu cab vf cv cfv
      wceq wa vt cv vy cv cdm wcel vv cv vt cv vu cv vy cv wbr vu cab vf cv cfv
      wceq wa vt cv vy cv cdm wcel vh cv vt cv vu cv vy cv wbr vu cab vf cv cfv
      wceq wa vw vv vt cv vh cv vt visset vh visset vw cv vt cv wceq vw cv vy
      cv cdm wcel vt cv vy cv cdm wcel vv cv vw cv vu cv vy cv wbr vu cab vf cv
      cfv wceq vv cv vt cv vu cv vy cv wbr vu cab vf cv cfv wceq vw cv vt cv vy
      cv cdm eleq1 vw cv vt cv wceq vw cv vu cv vy cv wbr vu cab vf cv cfv vt
      cv vu cv vy cv wbr vu cab vf cv cfv vv cv vw cv vt cv wceq vw cv vu cv vy
      cv wbr vu cab vt cv vu cv vy cv wbr vu cab vf cv vw cv vt cv wceq vw cv
      vu cv vy cv wbr vt cv vu cv vy cv wbr vu vw cv vt cv vu cv vy cv breq1
      abbidv fveq2d eqeq2d anbi12d vv cv vh cv wceq vv cv vt cv vu cv vy cv wbr
      vu cab vf cv cfv wceq vh cv vt cv vu cv vy cv wbr vu cab vf cv cfv wceq
      vt cv vy cv cdm wcel vv cv vh cv vt cv vu cv vy cv wbr vu cab vf cv cfv
      eqeq1 anbi2d opelopab bitri pm3.26bi vt cv vy cv cdm wcel vz cv c0 wne vz
      cv vf cv cfv vz cv wcel wi vz vy cv crn cpw wral vt cv vu cv vy cv wbr vu
      cab vf cv cfv vt cv vu cv vy cv wbr vu cab wcel vt cv vt cv cF cfv cop vy
      cv wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vy cv crn cpw wral
      vt cv vy cv cdm wcel vt cv vu cv vy cv wbr vu cab vf cv cfv vt cv vu cv
      vy cv wbr vu cab wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vy cv
      crn cpw wral vt cv vu cv vy cv wbr vu cab c0 wne vt cv vu cv vy cv wbr vu
      cab vf cv cfv vt cv vu cv vy cv wbr vu cab wcel vt cv vy cv cdm wcel vt
      cv vu cv vy cv wbr vu cab vy cv crn cpw wcel vz cv c0 wne vz cv vf cv cfv
      vz cv wcel wi vz vy cv crn cpw wral vt cv vu cv vy cv wbr vu cab c0 wne
      vt cv vu cv vy cv wbr vu cab vf cv cfv vt cv vu cv vy cv wbr vu cab wcel
      wi wi vt cv vu cv vy cv wbr vu cab vy cv crn cpw wcel vt cv vu cv vy cv
      wbr vu cab vy cv crn wss vt cv vu cv vy cv wbr vu cab vt cv vu cv vy cv
      wbr vt wex vu cab vy cv crn vt cv vu cv vy cv wbr vt cv vu cv vy cv wbr
      vt wex vu vt cv vu cv vy cv wbr vt 19.8a ss2abi vt vu vy cv dfrn2
      sseqtr4i vt cv vu cv vy cv wbr vu cab vy cv crn vy cv vy visset rnex
      elpw2 mpbir vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vt cv vu cv vy cv
      wbr vu cab c0 wne vt cv vu cv vy cv wbr vu cab vf cv cfv vt cv vu cv vy
      cv wbr vu cab wcel wi vz vt cv vu cv vy cv wbr vu cab vy cv crn cpw vz cv
      vt cv vu cv vy cv wbr vu cab wceq vz cv c0 wne vt cv vu cv vy cv wbr vu
      cab c0 wne vz cv vf cv cfv vz cv wcel vt cv vu cv vy cv wbr vu cab vf cv
      cfv vt cv vu cv vy cv wbr vu cab wcel vz cv vt cv vu cv vy cv wbr vu cab
      c0 neeq1 vz cv vt cv vu cv vy cv wbr vu cab wceq vz cv vf cv cfv vt cv vu
      cv vy cv wbr vu cab vf cv cfv vz cv vt cv vu cv vy cv wbr vu cab vz cv vt
      cv vu cv vy cv wbr vu cab vf cv fveq2 vz cv vt cv vu cv vy cv wbr vu cab
      wceq id eleq12d imbi12d rcla4v ax-mp vt cv vy cv cdm wcel vt cv vu cv vy
      cv wbr vu wex vt cv vu cv vy cv wbr vu cab c0 wne vu vt cv vy cv vt
      visset eldm vt cv vu cv vy cv wbr vu abn0 bitr4i syl5ib com12 vt cv vy cv
      cdm wcel vt cv cF cfv vt cv vu cv vy cv wbr vu cab wcel vt cv vu cv vy cv
      wbr vu cab vf cv cfv vt cv vu cv vy cv wbr vu cab wcel vt cv vt cv cF cfv
      cop vy cv wcel vt cv vy cv cdm wcel vt cv cF cfv vt cv vu cv vy cv wbr vu
      cab vf cv cfv vt cv vu cv vy cv wbr vu cab vw vv vt cv vw cv vu cv vy cv
      wbr vu cab vf cv cfv vt cv vu cv vy cv wbr vu cab vf cv cfv vy cv cdm cF
      vw cv vt cv wceq vw cv vu cv vy cv wbr vu cab vt cv vu cv vy cv wbr vu
      cab vf cv vw cv vt cv wceq vw cv vu cv vy cv wbr vt cv vu cv vy cv wbr vu
      vw cv vt cv vu cv vy cv breq1 abbidv fveq2d aceq3lem.1 vt cv vu cv vy cv
      wbr vu cab vf cv fvex fvopab4 eleq1d vt cv cF cfv vt cv vu cv vy cv wbr
      vu cab wcel vt cv vt cv cF cfv vy cv wbr vt cv vt cv cF cfv cop vy cv
      wcel vt cv vh cv vy cv wbr vt cv vt cv cF cfv vy cv wbr vh vt cv cF cfv
      vt cv vu cv vy cv wbr vu cab vt cv cF fvex vh cv vt cv cF cfv vt cv vy cv
      breq2 vt cv vu cv vy cv wbr vt cv vh cv vy cv wbr vu vh vu cv vh cv vt cv
      vy cv breq2 cbvabv elab2 vt cv vt cv cF cfv vy cv df-br bitr2i syl5bb
      sylibrd syl vt cv vh cv cop cF wcel vt cv cF cfv vh cv wceq vt cv vt cv
      cF cfv cop vy cv wcel vt cv vh cv cop vy cv wcel wb cF wfun vt cv vh cv
      cop cF wcel vt cv cF cfv vh cv wceq wi cF vy cv cdm wfn cF wfun vw vv vy
      cv cdm vw cv vu cv vy cv wbr vu cab vf cv cfv cF vw cv vu cv vy cv wbr vu
      cab vf cv fvex aceq3lem.1 fnopab2 vy cv cdm cF fnfun ax-mp vt cv vh cv cF
      vh visset funopfv ax-mp vt cv cF cfv vh cv wceq vt cv vt cv cF cfv cop vt
      cv vh cv cop vy cv vt cv cF cfv vh cv vt cv opeq2 eleq1d syl sylibd com12
      relssdv vw vv vy cv cdm vw cv vu cv vy cv wbr vu cab vf cv cfv cF vw cv
      vu cv vy cv wbr vu cab vf cv fvex aceq3lem.1 fnopab2 sylancl 19.23aiv syl
      vg cv vy cv wss vg cv vy cv cdm wfn wa vf cv vy cv wss vf cv vy cv cdm
      wfn wa vg vf vg cv vf cv wceq vg cv vy cv wss vf cv vy cv wss vg cv vy cv
      cdm wfn vf cv vy cv cdm wfn vg cv vf cv vy cv sseq1 vy cv cdm vg cv vf cv
      fneq1 anbi12d cbvexv sylib $.
      $( [14-Apr-2007] $) $( [2-Apr-2004] $)
  $}

  ${
    $d f x y z w v u g h $.
    $( Equivalence of two versions of the Axiom of Choice.  The left-hand side
       is similar to the Axiom of Choice (first form) of [Enderton] p. 49.  The
       right-hand side is the Axiom of Choice of [TakeutiZaring] p. 83.  The
       proof does not depend on AC. $)
    aceq3 $p |- ( A. x E. f ( f C_ x /\ f Fn dom x ) <->
             A. x E. f A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vf cv vy cv wss vf
      cv vy cv cdm wfn wa vf wex vy wal vz cv c0 wne vz cv vf cv cfv vz cv wcel
      wi vz vx cv wral vf wex vx wal vf cv vx cv wss vf cv vx cv cdm wfn wa vf
      wex vf cv vy cv wss vf cv vy cv cdm wfn wa vf wex vx vy vx cv vy cv wceq
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf cv vy cv wss vf cv vy cv cdm
      wfn wa vf vx cv vy cv wceq vf cv vx cv wss vf cv vy cv wss vf cv vx cv
      cdm wfn vf cv vy cv cdm wfn vx cv vy cv vf cv sseq2 vx cv vy cv wceq vx
      cv cdm vy cv cdm wceq vf cv vx cv cdm wfn vf cv vy cv cdm wfn wb vx cv vy
      cv dmeq vx cv cdm vy cv cdm vf cv fneq2 syl anbi12d exbidv cbvalv vf cv
      vy cv wss vf cv vy cv cdm wfn wa vf wex vy wal vz cv c0 wne vz cv vf cv
      cfv vz cv wcel wi vz vx cv wral vf wex vx wal vf cv vy cv wss vf cv vy cv
      cdm wfn wa vf wex vy wal vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx
      cv wral vf wex vx vf cv vy cv wss vf cv vy cv cdm wfn wa vf wex vy wal vf
      cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wss vf cv vw cv vx cv
      wcel vv cv vw cv wcel wa vw vv copab cdm wfn wa vf wex vz cv c0 wne vz cv
      vf cv cfv vz cv wcel wi vz vx cv wral vf wex vf cv vy cv wss vf cv vy cv
      cdm wfn wa vf wex vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      wss vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wfn wa vf
      wex vy vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab vw cv vx cv wcel
      vv cv vw cv wcel wa vw vv copab vx cv vx cv cuni cxp vx cv vx cv cuni vx
      visset vx cv vx visset uniex xpex vw cv vx cv wcel vv cv vw cv wcel wa vw
      vv copab vw cv vx cv wcel vv cv vx cv cuni wcel wa vw vv copab vx cv vx
      cv cuni cxp vw cv vx cv wcel vv cv vw cv wcel wa vw cv vx cv wcel vv cv
      vx cv cuni wcel wa vw vv vw cv vx cv wcel vv cv vw cv wcel wa vw cv vx cv
      wcel vv cv vx cv cuni wcel vw cv vx cv wcel vv cv vw cv wcel pm3.26 vv cv
      vw cv wcel vw cv vx cv wcel vv cv vx cv cuni wcel vv cv vw cv vx cv
      elunii ancoms jca ssopab2i vw vv vx cv vx cv cuni df-xp sseqtr4i ssexi vy
      cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wceq vf cv vy cv wss
      vf cv vy cv cdm wfn wa vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv
      copab wss vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wfn
      wa vf vy cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wceq vf cv
      vy cv wss vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wss vf
      cv vy cv cdm wfn vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      cdm wfn vy cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab vf cv
      sseq2 vy cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wceq vy cv
      cdm vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wceq vf cv vy cv
      cdm wfn vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wfn wb
      vy cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab dmeq vy cv cdm vw
      cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm vf cv fneq2 syl anbi12d
      exbidv cla4v vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wss
      vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wfn wa vz cv
      c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf vf cv vw cv vx cv
      wcel vv cv vw cv wcel wa vw vv copab wss vf cv vw cv vx cv wcel vv cv vw
      cv wcel wa vw vv copab cdm wfn wa vz cv c0 wne vz cv vf cv cfv vz cv wcel
      wi vz vx cv vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wss vf
      cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wfn wa vz cv vx
      cv wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel vf cv vw cv vx cv wcel vv
      cv vw cv wcel wa vw vv copab wss vf cv vw cv vx cv wcel vv cv vw cv wcel
      wa vw vv copab cdm wfn wa vz cv vx cv wcel vz cv c0 wne wa wa vz cv vf cv
      cfv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab vz cv csn cima wcel
      vz cv vf cv cfv vz cv wcel vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw
      vv copab wss vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm
      wfn wa vz cv vx cv wcel vz cv c0 wne wa vz cv vf cv cfv vw cv vx cv wcel
      vv cv vw cv wcel wa vw vv copab vz cv csn cima wcel vf cv vw cv vx cv
      wcel vv cv vw cv wcel wa vw vv copab wss vf cv vw cv vx cv wcel vv cv vw
      cv wcel wa vw vv copab cdm wfn wa vz cv vx cv wcel vz cv c0 wne wa vz cv
      vf cv cdm wcel vz cv vf cv cfv vw cv vx cv wcel vv cv vw cv wcel wa vw vv
      copab vz cv csn cima wcel vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw
      vv copab cdm wfn vz cv vx cv wcel vz cv c0 wne wa vz cv vf cv cdm wcel wb
      vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wss vf cv vw cv vx
      cv wcel vv cv vw cv wcel wa vw vv copab cdm wfn vf cv cdm vw cv vx cv
      wcel vv cv vw cv wcel wa vw vv copab cdm wceq vz cv vx cv wcel vz cv c0
      wne wa vz cv vf cv cdm wcel wb vw cv vx cv wcel vv cv vw cv wcel wa vw vv
      copab cdm vf cv fndm vf cv cdm vw cv vx cv wcel vv cv vw cv wcel wa vw vv
      copab cdm wceq vz cv vf cv cdm wcel vz cv vw cv vx cv wcel vv cv vw cv
      wcel wa vw vv copab cdm wcel vz cv vx cv wcel vz cv c0 wne wa vf cv cdm
      vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm vz cv eleq2 vz cv vw
      cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm wcel vz cv vw cv vx cv
      wcel vv cv vw cv wcel wa vv wex vw cab wcel vz cv vx cv wcel vz cv c0 wne
      wa vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab cdm vw cv vx cv wcel
      vv cv vw cv wcel wa vv wex vw cab vz cv vw cv vx cv wcel vv cv vw cv wcel
      wa vw vv dmopab eleq2i vz cv vx cv wcel vv cv vz cv wcel wa vv wex vz cv
      vx cv wcel vv cv vz cv wcel vv wex wa vz cv vw cv vx cv wcel vv cv vw cv
      wcel wa vv wex vw cab wcel vz cv vx cv wcel vz cv c0 wne wa vz cv vx cv
      wcel vv cv vz cv wcel vv 19.42v vw cv vx cv wcel vv cv vw cv wcel wa vv
      wex vz cv vx cv wcel vv cv vz cv wcel wa vv wex vw vz cv vz visset vw cv
      vz cv wceq vw cv vx cv wcel vv cv vw cv wcel wa vz cv vx cv wcel vv cv vz
      cv wcel wa vv vw cv vz cv wceq vw cv vx cv wcel vz cv vx cv wcel vv cv vw
      cv wcel vv cv vz cv wcel vw cv vz cv vx cv eleq1 vw cv vz cv vv cv eleq2
      anbi12d exbidv elab vz cv c0 wne vv cv vz cv wcel vv wex vz cv vx cv wcel
      vv vz cv n0 anbi2i 3bitr4i bitr2i syl6rbbr syl adantl vf cv vw cv vx cv
      wcel vv cv vw cv wcel wa vw vv copab wss vf cv wfun vz cv vf cv cdm wcel
      vz cv vf cv cfv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab vz cv
      csn cima wcel wi vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      cdm wfn vf cv wfun vf cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      wss vz cv vf cv cdm wcel vz cv vf cv cfv vw cv vx cv wcel vv cv vw cv
      wcel wa vw vv copab vz cv csn cima wcel wi vz cv vf cv vw cv vx cv wcel
      vv cv vw cv wcel wa vw vv copab funfvima3 ancoms vw cv vx cv wcel vv cv
      vw cv wcel wa vw vv copab cdm vf cv fnfun sylan2 sylbid imp vz cv vx cv
      wcel vz cv vf cv cfv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab vz
      cv csn cima wcel vz cv vf cv cfv vz cv wcel wb vf cv vw cv vx cv wcel vv
      cv vw cv wcel wa vw vv copab wss vf cv vw cv vx cv wcel vv cv vw cv wcel
      wa vw vv copab cdm wfn wa vz cv c0 wne vz cv vx cv wcel vw cv vx cv wcel
      vv cv vw cv wcel wa vw vv copab vz cv csn cima vz cv vz cv vf cv cfv vz
      cv vx cv wcel vz cv vz cv vx cv wcel vu cv vz cv wcel wa vu cab vw cv vx
      cv wcel vv cv vw cv wcel wa vw vv copab vz cv csn cima vz cv vx cv wcel
      vz cv vx cv wcel vu cv vz cv wcel wa vu vz cv vz cv vx cv wcel vu cv vz
      cv wcel ibar abbi2dv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab vz
      cv csn cima vz cv vu cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      wbr vu cab vz cv vx cv wcel vu cv vz cv wcel wa vu cab vz cv cvv wcel vw
      cv vx cv wcel vv cv vw cv wcel wa vw vv copab vz cv csn cima vz cv vu cv
      vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab wbr vu cab wceq vz
      visset vu vz cv cvv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      imasng ax-mp vz cv vu cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv copab
      wbr vz cv vx cv wcel vu cv vz cv wcel wa vu vw cv vx cv wcel vv cv vw cv
      wcel wa vz cv vx cv wcel vv cv vz cv wcel wa vz cv vx cv wcel vu cv vz cv
      wcel wa vw vv vz cv vu cv vw cv vx cv wcel vv cv vw cv wcel wa vw vv
      copab vz visset vu visset vw cv vz cv wceq vw cv vx cv wcel vz cv vx cv
      wcel vv cv vw cv wcel vv cv vz cv wcel vw cv vz cv vx cv eleq1 vw cv vz
      cv vv cv eleq2 anbi12d vv cv vu cv wceq vv cv vz cv wcel vu cv vz cv wcel
      vz cv vx cv wcel vv cv vu cv vz cv eleq1 anbi2d vw cv vx cv wcel vv cv vw
      cv wcel wa vw vv copab eqid brab abbii eqtri syl6reqr eleq2d ad2antrl
      mpbid exp32 r19.21aiv 19.22i syl 19.21aiv vz cv c0 wne vz cv vf cv cfv vz
      cv wcel wi vz vx cv wral vf wex vx wal vf cv vy cv wss vf cv vy cv cdm
      wfn wa vf wex vy vx vy vz vw vv vu vf vw cv vy cv cdm wcel vv cv vw cv vu
      cv vy cv wbr vu cab vf cv cfv wceq wa vw vv copab vw cv vy cv cdm wcel vv
      cv vw cv vu cv vy cv wbr vu cab vf cv cfv wceq wa vw vv copab eqid
      aceq3lem 19.21aiv impbii bitri $.
      $( [14-Apr-2007] $) $( [24-Mar-2004] $)
  $}

  ${
    $d f x z y w v $.
    $( Equivalence of two versions of the Axiom of Choice.  The left-hand side
       is similar to the Axiom of Choice (first form) of [Enderton] p. 49.  The
       right-hand side is Axiom AC of [BellMachover] p. 488.  The proof does
       not depend on AC. $)
    aceq4 $p |- ( A. x E. f ( f C_ x /\ f Fn dom x ) <->
        A. x E. f ( f Fn x /\ A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vz cv c0 wne vz cv
      vf cv cfv vz cv wcel wi vz vx cv wral vf wex vx wal vf cv vx cv wfn vz cv
      c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral wa vf wex vx wal vx vz
      vf aceq3 vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf wex
      vf cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral
      wa vf wex vx vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf
      wex vf cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv
      wral wa vf wex vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral
      vf wex vz cv c0 wne vz cv vy cv cfv vz cv wcel wi vz vx cv wral vy wex vf
      cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral wa
      vf wex vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vz cv c0
      wne vz cv vy cv cfv vz cv wcel wi vz vx cv wral vf vy vf cv vy cv wceq vz
      cv c0 wne vz cv vf cv cfv vz cv wcel wi vz cv c0 wne vz cv vy cv cfv vz
      cv wcel wi vz vx cv vf cv vy cv wceq vz cv vf cv cfv vz cv wcel vz cv vy
      cv cfv vz cv wcel vz cv c0 wne vf cv vy cv wceq vz cv vf cv cfv vz cv vy
      cv cfv vz cv vz cv vf cv vy cv fveq1 eleq1d imbi2d ralbidv cbvexv vz cv
      c0 wne vz cv vy cv cfv vz cv wcel wi vz vx cv wral vf cv vx cv wfn vz cv
      c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral wa vf wex vy vz cv c0
      wne vz cv vy cv cfv vz cv wcel wi vz vx cv wral vw cv vx cv wcel vv cv vw
      cv vy cv cfv wceq wa vw vv copab vx cv wfn vz cv c0 wne vz cv vw cv vx cv
      wcel vv cv vw cv vy cv cfv wceq wa vw vv copab cfv vz cv wcel wi vz vx cv
      wral wa vf cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx
      cv wral wa vf wex vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv
      copab vx cv wfn vz cv c0 wne vz cv vw cv vx cv wcel vv cv vw cv vy cv cfv
      wceq wa vw vv copab cfv vz cv wcel wi vz vx cv wral wa vw cv vx cv wcel
      vv cv vw cv vy cv cfv wceq wa vw vv copab vx cv wfn vz cv c0 wne vz cv vy
      cv cfv vz cv wcel wi vz vx cv wral vz cv c0 wne vz cv vw cv vx cv wcel vv
      cv vw cv vy cv cfv wceq wa vw vv copab cfv vz cv wcel wi vz vx cv wral vz
      cv c0 wne vz cv vy cv cfv vz cv wcel wi vz vx cv wral vw cv vx cv wcel vv
      cv vw cv vy cv cfv wceq wa vw vv copab vx cv wfn vz cv c0 wne vz cv vw cv
      vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab cfv vz cv wcel wi vz
      cv c0 wne vz cv vy cv cfv vz cv wcel wi vz vx cv vz cv vx cv wcel vz cv
      vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab cfv vz cv wcel
      vz cv vy cv cfv vz cv wcel vz cv c0 wne vz cv vx cv wcel vz cv vw cv vx
      cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab cfv vz cv vy cv cfv vz
      cv vw vv vz cv vw cv vy cv cfv vz cv vy cv cfv vx cv vw cv vx cv wcel vv
      cv vw cv vy cv cfv wceq wa vw vv copab vw cv vz cv vy cv fveq2 vw cv vx
      cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab eqid vz cv vy cv fvex
      fvopab4 eleq1d imbi2d ralbiia anbi2i vw vv vx cv vw cv vy cv cfv vw cv vx
      cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab vw cv vy cv fvex vw cv
      vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab eqid fnopab2 mpbiran
      vf cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral
      wa vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab vx cv wfn
      vz cv c0 wne vz cv vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv
      copab cfv vz cv wcel wi vz vx cv wral wa vf vw cv vx cv wcel vv cv vw cv
      vy cv cfv wceq wa vw vv copab vw vv vx cv vw cv vy cv cfv vx visset
      opabex2 vf cv vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab
      wceq vf cv vx cv wfn vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv
      copab vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral
      vz cv c0 wne vz cv vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv
      copab cfv vz cv wcel wi vz vx cv wral vx cv vf cv vw cv vx cv wcel vv cv
      vw cv vy cv cfv wceq wa vw vv copab fneq1 vf cv vw cv vx cv wcel vv cv vw
      cv vy cv cfv wceq wa vw vv copab wceq vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz cv c0 wne vz cv vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa
      vw vv copab cfv vz cv wcel wi vz vx cv vf cv vw cv vx cv wcel vv cv vw cv
      vy cv cfv wceq wa vw vv copab wceq vz cv vf cv cfv vz cv wcel vz cv vw cv
      vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab cfv vz cv wcel vz cv
      c0 wne vf cv vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa vw vv copab
      wceq vz cv vf cv cfv vz cv vw cv vx cv wcel vv cv vw cv vy cv cfv wceq wa
      vw vv copab cfv vz cv vz cv vf cv vw cv vx cv wcel vv cv vw cv vy cv cfv
      wceq wa vw vv copab fveq1 eleq1d imbi2d ralbidv anbi12d cla4ev sylbir
      19.23aiv sylbi vf cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi
      vz vx cv wral wa vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral
      vf vf cv vx cv wfn vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv
      wral pm3.27 19.22i impbii albii bitri $.
      $( [17-Apr-2007] $) $( [24-Mar-2004] $)
  $}

  ${
    $d v w y g t $.
    $( Lemma for ~ aceq5 . $)
    aceq5lem1 $p |- ( E! v v e. ( ( { w } X. w ) i^i y ) <->
                      E! g ( g e. w /\ <. w , g >. e. y ) ) $=
      vv cv vw cv csn vw cv cxp vy cv cin wcel vv weu vv cv vw cv vg cv cop
      wceq vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa wa vg wex vv weu vg
      cv vw cv wcel vw cv vg cv cop vy cv wcel wa vg weu vv cv vw cv csn vw cv
      cxp vy cv cin wcel vv cv vw cv vg cv cop wceq vg cv vw cv wcel vw cv vg
      cv cop vy cv wcel wa wa vg wex vv vv cv vw cv csn vw cv cxp vy cv cin
      wcel vv cv vw cv csn vw cv cxp wcel vv cv vy cv wcel wa vv cv vt cv vg cv
      cop wceq vt cv vw cv csn wcel vg cv vw cv wcel wa wa vt wex vg wex vv cv
      vy cv wcel wa vv cv vw cv vg cv cop wceq vg cv vw cv wcel vw cv vg cv cop
      vy cv wcel wa wa vg wex vv cv vw cv csn vw cv cxp vy cv elin vv cv vw cv
      csn vw cv cxp wcel vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv
      vw cv wcel wa wa vt wex vg wex vv cv vy cv wcel vv cv vw cv csn vw cv cxp
      wcel vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv vw cv wcel wa
      wa vg wex vt wex vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv vw
      cv wcel wa wa vt wex vg wex vt vg vv cv vw cv csn vw cv elxp vv cv vt cv
      vg cv cop wceq vt cv vw cv csn wcel vg cv vw cv wcel wa wa vt vg excom
      bitri anbi1i vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv vw cv
      wcel wa wa vt wex vg wex vv cv vy cv wcel wa vv cv vt cv vg cv cop wceq
      vt cv vw cv csn wcel vg cv vw cv wcel wa wa vv cv vy cv wcel wa vt wex vg
      wex vv cv vw cv vg cv cop wceq vg cv vw cv wcel vw cv vg cv cop vy cv
      wcel wa wa vg wex vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv
      vw cv wcel wa wa vv cv vy cv wcel vg vt 19.41vv vv cv vt cv vg cv cop
      wceq vt cv vw cv csn wcel vg cv vw cv wcel wa wa vv cv vy cv wcel wa vt
      wex vv cv vw cv vg cv cop wceq vg cv vw cv wcel vw cv vg cv cop vy cv
      wcel wa wa vg vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv vw cv
      wcel wa wa vv cv vy cv wcel wa vt wex vt cv vw cv wceq vv cv vt cv vg cv
      cop wceq vg cv vw cv wcel vt cv vg cv cop vy cv wcel wa wa wa vt wex vv
      cv vw cv vg cv cop wceq vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa wa
      vv cv vt cv vg cv cop wceq vt cv vw cv csn wcel vg cv vw cv wcel wa wa vv
      cv vy cv wcel wa vt cv vw cv wceq vv cv vt cv vg cv cop wceq vg cv vw cv
      wcel vt cv vg cv cop vy cv wcel wa wa wa vt vv cv vt cv vg cv cop wceq vt
      cv vw cv csn wcel vg cv vw cv wcel wa wa vv cv vy cv wcel wa vv cv vt cv
      vg cv cop wceq vv cv vy cv wcel wa vt cv vw cv csn wcel vg cv vw cv wcel
      wa wa vv cv vt cv vg cv cop wceq vt cv vg cv cop vy cv wcel wa vt cv vw
      cv wceq vg cv vw cv wcel wa wa vt cv vw cv wceq vv cv vt cv vg cv cop
      wceq vg cv vw cv wcel vt cv vg cv cop vy cv wcel wa wa wa vv cv vt cv vg
      cv cop wceq vt cv vw cv csn wcel vg cv vw cv wcel wa vv cv vy cv wcel
      an23 vv cv vt cv vg cv cop wceq vv cv vy cv wcel wa vv cv vt cv vg cv cop
      wceq vt cv vg cv cop vy cv wcel wa vt cv vw cv csn wcel vg cv vw cv wcel
      wa vt cv vw cv wceq vg cv vw cv wcel wa vv cv vt cv vg cv cop wceq vv cv
      vy cv wcel vt cv vg cv cop vy cv wcel vv cv vt cv vg cv cop vy cv eleq1
      pm5.32i vt cv vw cv csn wcel vt cv vw cv wceq vg cv vw cv wcel vt vw cv
      elsn anbi1i anbi12i vv cv vt cv vg cv cop wceq vt cv vg cv cop vy cv wcel
      wa vt cv vw cv wceq vg cv vw cv wcel wa wa vv cv vt cv vg cv cop wceq vt
      cv vw cv wceq wa vt cv vg cv cop vy cv wcel vg cv vw cv wcel wa wa vt cv
      vw cv wceq vv cv vt cv vg cv cop wceq wa vg cv vw cv wcel vt cv vg cv cop
      vy cv wcel wa wa vt cv vw cv wceq vv cv vt cv vg cv cop wceq vg cv vw cv
      wcel vt cv vg cv cop vy cv wcel wa wa wa vv cv vt cv vg cv cop wceq vt cv
      vg cv cop vy cv wcel vt cv vw cv wceq vg cv vw cv wcel an4 vv cv vt cv vg
      cv cop wceq vt cv vw cv wceq wa vt cv vw cv wceq vv cv vt cv vg cv cop
      wceq wa vt cv vg cv cop vy cv wcel vg cv vw cv wcel wa vg cv vw cv wcel
      vt cv vg cv cop vy cv wcel wa vv cv vt cv vg cv cop wceq vt cv vw cv wceq
      ancom vt cv vg cv cop vy cv wcel vg cv vw cv wcel ancom anbi12i vt cv vw
      cv wceq vv cv vt cv vg cv cop wceq vg cv vw cv wcel vt cv vg cv cop vy cv
      wcel wa anass 3bitri 3bitri exbii vv cv vt cv vg cv cop wceq vg cv vw cv
      wcel vt cv vg cv cop vy cv wcel wa wa vv cv vw cv vg cv cop wceq vg cv vw
      cv wcel vw cv vg cv cop vy cv wcel wa wa vt vw cv vw visset vt cv vw cv
      wceq vv cv vt cv vg cv cop wceq vv cv vw cv vg cv cop wceq vg cv vw cv
      wcel vt cv vg cv cop vy cv wcel wa vg cv vw cv wcel vw cv vg cv cop vy cv
      wcel wa vt cv vw cv wceq vt cv vg cv cop vw cv vg cv cop vv cv vt cv vw
      cv vg cv opeq1 eqeq2d vt cv vw cv wceq vt cv vg cv cop vy cv wcel vw cv
      vg cv cop vy cv wcel vg cv vw cv wcel vt cv vw cv wceq vt cv vg cv cop vw
      cv vg cv cop vy cv vt cv vw cv vg cv opeq1 eleq1d anbi2d anbi12d ceqsexv
      bitri exbii bitr3i 3bitri eubii vg cv vw cv wcel vw cv vg cv cop vy cv
      wcel wa vv vg vw cv euop2 bitri $.
      $( [15-Apr-2004] $) $( [12-Apr-2004] $)
  $}

  ${
    $d f x z y w v u t h g $.  $d z w f g B $.  $d x y z w g A $.
    aceq5lem.1 $e |- A =
                    { u | ( u =/= (/) /\ E. t e. h u = ( { t } X. t ) ) } $.
    $( Lemma for ~ aceq5 . $)
    aceq5lem2 $p |- ( <. w , g >. e. U. A <-> ( w e. h /\ g e. w ) ) $=
      vw cv vg cv cop cA cuni wcel vw cv vg cv cop vu cv c0 wne vu cv vt cv csn
      vt cv cxp wceq vt vh cv wrex wa vu cab cuni wcel vt cv vh cv wcel vw cv
      vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq wa vu
      wex wa vt wex vw cv vh cv wcel vg cv vw cv wcel wa cA cuni vu cv c0 wne
      vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab cuni vw cv vg cv
      cop cA vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu
      cab aceq5lem.1 unieqi eleq2i vw cv vg cv cop vu cv c0 wne vu cv vt cv csn
      vt cv cxp wceq vt vh cv wrex wa vu cab cuni wcel vw cv vg cv cop vu cv
      wcel vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa wa vu
      wex vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp
      wceq wa vt vh cv wrex vu wex vt cv vh cv wcel vw cv vg cv cop vu cv wcel
      vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq wa vu wex wa vt wex vu cv
      c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu vw cv vg cv cop
      eluniab vw cv vg cv cop vu cv wcel vu cv c0 wne vu cv vt cv csn vt cv cxp
      wceq vt vh cv wrex wa wa vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv
      vt cv csn vt cv cxp wceq wa vt vh cv wrex vu vw cv vg cv cop vu cv wcel
      vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq wa vt vh cv wrex vw cv vg
      cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq vt vh cv
      wrex wa vw cv vg cv cop vu cv wcel vu cv c0 wne vu cv vt cv csn vt cv cxp
      wceq vt vh cv wrex wa wa vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv
      vt cv csn vt cv cxp wceq vt vh cv r19.42v vw cv vg cv cop vu cv wcel vu
      cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex anass bitr2i exbii
      vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq
      wa vt vh cv wrex vu wex vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv
      vt cv csn vt cv cxp wceq wa vu wex vt vh cv wrex vt cv vh cv wcel vw cv
      vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq wa vu
      wex wa vt wex vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn
      vt cv cxp wceq wa vt vu vh cv rexcom4 vw cv vg cv cop vu cv wcel vu cv c0
      wne wa vu cv vt cv csn vt cv cxp wceq wa vu wex vt vh cv df-rex bitr3i
      3bitri vt cv vh cv wcel vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv
      vt cv csn vt cv cxp wceq wa vu wex wa vt wex vt cv vw cv wceq vt cv vh cv
      wcel vg cv vt cv wcel wa wa vt wex vw cv vh cv wcel vg cv vw cv wcel wa
      vt cv vh cv wcel vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv
      csn vt cv cxp wceq wa vu wex wa vt cv vw cv wceq vt cv vh cv wcel vg cv
      vt cv wcel wa wa vt vt cv vh cv wcel vw cv vg cv cop vu cv wcel vu cv c0
      wne wa vu cv vt cv csn vt cv cxp wceq wa vu wex wa vt cv vh cv wcel vw cv
      vg cv cop vt cv csn vt cv cxp wcel wa vt cv vh cv wcel vt cv vw cv wceq
      vg cv vt cv wcel wa wa vt cv vw cv wceq vt cv vh cv wcel vg cv vt cv wcel
      wa wa vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv
      cxp wceq wa vu wex vw cv vg cv cop vt cv csn vt cv cxp wcel vt cv vh cv
      wcel vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp
      wceq wa vu wex vu cv vt cv csn vt cv cxp wceq vw cv vg cv cop vu cv wcel
      wa vu wex vw cv vg cv cop vt cv csn vt cv cxp wcel vw cv vg cv cop vu cv
      wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq wa vu cv vt cv csn vt
      cv cxp wceq vw cv vg cv cop vu cv wcel wa vu vw cv vg cv cop vu cv wcel
      vu cv c0 wne wa vu cv vt cv csn vt cv cxp wceq wa vu cv vt cv csn vt cv
      cxp wceq vw cv vg cv cop vu cv wcel vu cv c0 wne wa wa vu cv vt cv csn vt
      cv cxp wceq vw cv vg cv cop vu cv wcel wa vw cv vg cv cop vu cv wcel vu
      cv c0 wne wa vu cv vt cv csn vt cv cxp wceq ancom vw cv vg cv cop vu cv
      wcel vw cv vg cv cop vu cv wcel vu cv c0 wne wa vu cv vt cv csn vt cv cxp
      wceq vw cv vg cv cop vu cv wcel vu cv c0 wne vu cv vw cv vg cv cop ne0i
      pm4.71i anbi2i bitr4i exbii vw cv vg cv cop vu cv wcel vw cv vg cv cop vt
      cv csn vt cv cxp wcel vu vt cv csn vt cv cxp vt cv csn vt cv vt cv snex
      vt visset xpex vu cv vt cv csn vt cv cxp vw cv vg cv cop eleq2 ceqsexv
      bitri anbi2i vw cv vg cv cop vt cv csn vt cv cxp wcel vt cv vw cv wceq vg
      cv vt cv wcel wa vt cv vh cv wcel vw cv vg cv cop vt cv csn vt cv cxp
      wcel vw cv vt cv csn wcel vg cv vt cv wcel wa vt cv vw cv wceq vg cv vt
      cv wcel wa vw cv vg cv vt cv csn vt cv vg visset opelxp vw cv vt cv csn
      wcel vt cv vw cv wceq vg cv vt cv wcel vw cv vt cv csn wcel vw cv vt cv
      wceq vt cv vw cv wceq vw vt cv elsn vw cv vt cv eqcom bitri anbi1i bitri
      anbi2i vt cv vh cv wcel vt cv vw cv wceq vg cv vt cv wcel an12 3bitri
      exbii vt cv vh cv wcel vg cv vt cv wcel wa vw cv vh cv wcel vg cv vw cv
      wcel wa vt vw cv vw visset vt cv vw cv wceq vt cv vh cv wcel vw cv vh cv
      wcel vg cv vt cv wcel vg cv vw cv wcel vt cv vw cv vh cv eleq1 vt cv vw
      cv vg cv eleq2 anbi12d ceqsexv bitri 3bitri $.
      $( [3-Apr-2007] $) $( [12-Apr-2004] $)

    $( Lemma for ~ aceq5 . $)
    aceq5lem3 $p |- ( ( { w } X. w ) e. A <-> ( w =/= (/) /\ w e. h ) ) $=
      vw cv csn vw cv cxp vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv
      wrex wa vu cab wcel vw cv csn vw cv cxp c0 wne vw cv csn vw cv cxp vt cv
      csn vt cv cxp wceq vt vh cv wrex wa vw cv csn vw cv cxp cA wcel vw cv c0
      wne vw cv vh cv wcel wa vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh
      cv wrex wa vw cv csn vw cv cxp c0 wne vw cv csn vw cv cxp vt cv csn vt cv
      cxp wceq vt vh cv wrex wa vu vw cv csn vw cv cxp vw cv csn vw cv vw cv
      snex vw visset xpex vu cv vw cv csn vw cv cxp wceq vu cv c0 wne vw cv csn
      vw cv cxp c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex vw cv csn
      vw cv cxp vt cv csn vt cv cxp wceq vt vh cv wrex vu cv vw cv csn vw cv
      cxp c0 neeq1 vu cv vw cv csn vw cv cxp wceq vu cv vt cv csn vt cv cxp
      wceq vw cv csn vw cv cxp vt cv csn vt cv cxp wceq vt vh cv vu cv vw cv
      csn vw cv cxp vt cv csn vt cv cxp eqeq1 rexbidv anbi12d elab cA vu cv c0
      wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab vw cv csn vw
      cv cxp aceq5lem.1 eleq2i vw cv c0 wne vw cv csn vw cv cxp c0 wne vw cv vh
      cv wcel vw cv csn vw cv cxp vt cv csn vt cv cxp wceq vt vh cv wrex vw cv
      c0 vw cv csn vw cv cxp c0 vw cv c0 wceq vw cv csn vw cv cxp c0 wceq vw cv
      c0 wceq vw cv csn vw cv cxp vw cv csn c0 cxp c0 vw cv c0 vw cv csn xpeq2
      vw cv csn xp0 syl6eq vw cv csn vw cv cxp c0 wceq vw cv csn vw cv cxp crn
      c0 crn vw cv c0 vw cv csn vw cv cxp c0 rneq vw cv csn c0 wne vw cv csn vw
      cv cxp crn vw cv wceq vw cv vw visset snnz vw cv csn vw cv rnxp ax-mp rn0
      3eqtr3g impbii necon3bii vw cv csn vw cv cxp vt cv csn vt cv cxp wceq vt
      vh cv wrex vt cv vh cv wcel vw cv csn vw cv cxp vt cv csn vt cv cxp wceq
      wa vt wex vt cv vw cv wceq vt cv vh cv wcel wa vt wex vw cv vh cv wcel vw
      cv csn vw cv cxp vt cv csn vt cv cxp wceq vt vh cv df-rex vt cv vh cv
      wcel vw cv csn vw cv cxp vt cv csn vt cv cxp wceq wa vt cv vw cv wceq vt
      cv vh cv wcel wa vt vt cv vh cv wcel vw cv csn vw cv cxp vt cv csn vt cv
      cxp wceq wa vt cv vh cv wcel vt cv vw cv wceq wa vt cv vw cv wceq vt cv
      vh cv wcel wa vw cv csn vw cv cxp vt cv csn vt cv cxp wceq vt cv vw cv
      wceq vt cv vh cv wcel vw cv csn vw cv cxp vt cv csn vt cv cxp wceq vw cv
      vt cv wceq vt cv vw cv wceq vw cv csn vw cv cxp vt cv csn vt cv cxp wceq
      vw cv vt cv wceq vw cv csn vw cv cxp vt cv csn vt cv cxp wceq vw cv csn
      vw cv cxp crn vt cv csn vt cv cxp crn vw cv vt cv vw cv csn vw cv cxp vt
      cv csn vt cv cxp rneq vw cv csn c0 wne vw cv csn vw cv cxp crn vw cv wceq
      vw cv vw visset snnz vw cv csn vw cv rnxp ax-mp vt cv csn c0 wne vt cv
      csn vt cv cxp crn vt cv wceq vt cv vt visset snnz vt cv csn vt cv rnxp
      ax-mp 3eqtr3g vw cv vt cv wceq vw cv csn vw cv cxp vt cv csn vw cv cxp vt
      cv csn vt cv cxp vw cv vt cv wceq vw cv csn vt cv csn wceq vw cv csn vw
      cv cxp vt cv csn vw cv cxp wceq vw cv vt cv sneq vw cv csn vt cv csn vw
      cv xpeq1 syl vw cv vt cv vt cv csn xpeq2 eqtrd impbii vw cv vt cv eqcom
      bitri anbi2i vt cv vh cv wcel vt cv vw cv wceq ancom bitri exbii vt cv vh
      cv wcel vw cv vh cv wcel vt vw cv vw visset vt cv vw cv vh cv eleq1
      ceqsexv 3bitrri anbi12i 3bitr4i $.
      $( [3-Apr-2007] $) $( [12-Apr-2004] $)

    ${
      aceq5lem.2 $e |- B = ( U. A i^i y ) $.
      aceq5lem.3 $e |- ( ph <-> A. x ( ( A. z e. x z =/= (/) /\
             A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
            E. y A. z e. x E! v v e. ( z i^i y ) ) ) $.
      $( Lemma for ~ aceq5 . $)
      aceq5lem4 $p |- ( ph -> E. y A. z e. A E! v v e. ( z i^i y ) ) $=
        wph vz cv c0 wne vz cA wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi
        vw cA wral vz cA wral vv cv vz cv vy cv cin wcel vv weu vz cA wral vy
        wex vz cv c0 wne vz cA vz cv cA wcel vz cv vu cv c0 wne vu cv vt cv csn
        vt cv cxp wceq vt vh cv wrex wa vu cab wcel vz cv c0 wne cA vu cv c0
        wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab vz cv
        aceq5lem.1 eleq2i vz cv vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt
        vh cv wrex wa vu cab wcel vz cv c0 wne vz cv vt cv csn vt cv cxp wceq
        vt vh cv wrex vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex
        wa vz cv c0 wne vz cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu vz
        cv vz visset vu cv vz cv wceq vu cv c0 wne vz cv c0 wne vu cv vt cv csn
        vt cv cxp wceq vt vh cv wrex vz cv vt cv csn vt cv cxp wceq vt vh cv
        wrex vu cv vz cv c0 neeq1 vu cv vz cv wceq vu cv vt cv csn vt cv cxp
        wceq vz cv vt cv csn vt cv cxp wceq vt vh cv vu cv vz cv vt cv csn vt
        cv cxp eqeq1 rexbidv anbi12d elab pm3.26bi sylbi rgen vz cv vw cv wne
        vz cv vw cv cin c0 wceq wi vz vw cA vz cv cA wcel vw cv cA wcel wa vz
        cv vw cv wne vx cv vz cv wcel vx cv vw cv wcel wn wi vx wal vz cv vw cv
        cin c0 wceq vz cv cA wcel vw cv cA wcel wa vz cv vw cv wne vx cv vz cv
        wcel vx cv vw cv wcel wn wi vx vz cv cA wcel vw cv cA wcel wa vx cv vz
        cv wcel vx cv vw cv wcel wn wi vz cv vw cv vz cv cA wcel vw cv cA wcel
        wa vx cv vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq vx cv vz cv
        wcel vx cv vw cv wcel wn wi wn vz cv vt cv csn vt cv cxp wceq vt vh cv
        wrex vw cv vg cv csn vg cv cxp wceq vg vh cv wrex vx cv vz cv wcel vx
        cv vw cv wcel wa vz cv vw cv wceq wi vz cv cA wcel vw cv cA wcel vz cv
        vt cv csn vt cv cxp wceq vt vh cv wrex vw cv vg cv csn vg cv cxp wceq
        vg vh cv wrex vx cv vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq wi
        vz cv vt cv csn vt cv cxp wceq vt vh cv wrex vw cv vg cv csn vg cv cxp
        wceq vx cv vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq wi vg vh cv
        vz cv vt cv csn vt cv cxp wceq vt vh cv wrex vw cv vg cv csn vg cv cxp
        wceq vx cv vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq wi wi vg cv
        vh cv wcel vz cv vt cv csn vt cv cxp wceq vw cv vg cv csn vg cv cxp
        wceq vx cv vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq wi wi vt vh
        cv vz cv vt cv csn vt cv cxp wceq vw cv vg cv csn vg cv cxp wceq vx cv
        vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq wi wi wi vt cv vh cv
        wcel vz cv vt cv csn vt cv cxp wceq vw cv vg cv csn vg cv cxp wceq vx
        cv vz cv wcel vx cv vw cv wcel wa vz cv vw cv wceq wi vz cv vt cv csn
        vt cv cxp wceq vw cv vg cv csn vg cv cxp wceq wa vx cv vz cv wcel vx cv
        vw cv wcel wa vt cv csn vt cv cxp vg cv csn vg cv cxp wceq vz cv vw cv
        wceq vz cv vt cv csn vt cv cxp wceq vw cv vg cv csn vg cv cxp wceq wa
        vx cv vz cv wcel vx cv vw cv wcel wa vt cv vg cv wceq vt cv csn vt cv
        cxp vg cv csn vg cv cxp wceq vz cv vt cv csn vt cv cxp wceq vw cv vg cv
        csn vg cv cxp wceq wa vx cv vz cv wcel vx cv vw cv wcel wa vx cv vu cv
        vv cv cop wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa vu wex vx cv
        vu cv vy cv cop wceq vu cv vg cv csn wcel vy cv vg cv wcel wa wa vu wex
        wa vy wex vv wex vt cv vg cv wceq vz cv vt cv csn vt cv cxp wceq vw cv
        vg cv csn vg cv cxp wceq wa vx cv vz cv wcel vx cv vw cv wcel wa vx cv
        vu cv vv cv cop wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa vu wex
        vv wex vx cv vu cv vy cv cop wceq vu cv vg cv csn wcel vy cv vg cv wcel
        wa wa vu wex vy wex wa vx cv vu cv vv cv cop wceq vu cv vt cv csn wcel
        vv cv vt cv wcel wa wa vu wex vx cv vu cv vy cv cop wceq vu cv vg cv
        csn wcel vy cv vg cv wcel wa wa vu wex wa vy wex vv wex vz cv vt cv csn
        vt cv cxp wceq vx cv vz cv wcel vx cv vu cv vv cv cop wceq vu cv vt cv
        csn wcel vv cv vt cv wcel wa wa vu wex vv wex vw cv vg cv csn vg cv cxp
        wceq vx cv vw cv wcel vx cv vu cv vy cv cop wceq vu cv vg cv csn wcel
        vy cv vg cv wcel wa wa vu wex vy wex vz cv vt cv csn vt cv cxp wceq vx
        cv vz cv wcel vx cv vt cv csn vt cv cxp wcel vx cv vu cv vv cv cop wceq
        vu cv vt cv csn wcel vv cv vt cv wcel wa wa vu wex vv wex vz cv vt cv
        csn vt cv cxp vx cv eleq2 vx cv vt cv csn vt cv cxp wcel vx cv vu cv vv
        cv cop wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa vv wex vu wex
        vx cv vu cv vv cv cop wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa
        vu wex vv wex vu vv vx cv vt cv csn vt cv elxp vx cv vu cv vv cv cop
        wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa vu vv excom bitri
        syl6bb vw cv vg cv csn vg cv cxp wceq vx cv vw cv wcel vx cv vg cv csn
        vg cv cxp wcel vx cv vu cv vy cv cop wceq vu cv vg cv csn wcel vy cv vg
        cv wcel wa wa vu wex vy wex vw cv vg cv csn vg cv cxp vx cv eleq2 vx cv
        vg cv csn vg cv cxp wcel vx cv vu cv vy cv cop wceq vu cv vg cv csn
        wcel vy cv vg cv wcel wa wa vy wex vu wex vx cv vu cv vy cv cop wceq vu
        cv vg cv csn wcel vy cv vg cv wcel wa wa vu wex vy wex vu vy vx cv vg
        cv csn vg cv elxp vx cv vu cv vy cv cop wceq vu cv vg cv csn wcel vy cv
        vg cv wcel wa wa vu vy excom bitri syl6bb bi2anan9 vx cv vu cv vv cv
        cop wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa vu wex vx cv vu cv
        vy cv cop wceq vu cv vg cv csn wcel vy cv vg cv wcel wa wa vu wex vv vy
        eeanv syl6bbr vx cv vu cv vv cv cop wceq vu cv vt cv csn wcel vv cv vt
        cv wcel wa wa vu wex vx cv vu cv vy cv cop wceq vu cv vg cv csn wcel vy
        cv vg cv wcel wa wa vu wex wa vt cv vg cv wceq vv vy vx cv vu cv vv cv
        cop wceq vu cv vt cv csn wcel vv cv vt cv wcel wa wa vu wex vx cv vu cv
        vy cv cop wceq vu cv vg cv csn wcel vy cv vg cv wcel wa wa vu wex wa vx
        cv vt cv vv cv cop wceq vx cv vg cv vy cv cop wceq wa vt cv vv cv cop
        vg cv vy cv cop wceq vt cv vg cv wceq vx cv vu cv vv cv cop wceq vu cv
        vt cv csn wcel vv cv vt cv wcel wa wa vu wex vx cv vt cv vv cv cop wceq
        vx cv vu cv vy cv cop wceq vu cv vg cv csn wcel vy cv vg cv wcel wa wa
        vu wex vx cv vg cv vy cv cop wceq vx cv vu cv vv cv cop wceq vu cv vt
        cv csn wcel vv cv vt cv wcel wa wa vx cv vt cv vv cv cop wceq vu vx cv
        vu cv vv cv cop wceq vu cv vt cv csn wcel vx cv vt cv vv cv cop wceq vv
        cv vt cv wcel vx cv vu cv vv cv cop wceq vu cv vt cv wceq vx cv vt cv
        vv cv cop wceq vu cv vt cv csn wcel vu cv vt cv wceq vx cv vu cv vv cv
        cop wceq vx cv vt cv vv cv cop wceq vu cv vt cv wceq vu cv vv cv cop vt
        cv vv cv cop vx cv vu cv vt cv vv cv opeq1 eqeq2d biimpac vu vt cv elsn
        sylan2b adantrr 19.23aiv vx cv vu cv vy cv cop wceq vu cv vg cv csn
        wcel vy cv vg cv wcel wa wa vx cv vg cv vy cv cop wceq vu vx cv vu cv
        vy cv cop wceq vu cv vg cv csn wcel vx cv vg cv vy cv cop wceq vy cv vg
        cv wcel vx cv vu cv vy cv cop wceq vu cv vg cv wceq vx cv vg cv vy cv
        cop wceq vu cv vg cv csn wcel vu cv vg cv wceq vx cv vu cv vy cv cop
        wceq vx cv vg cv vy cv cop wceq vu cv vg cv wceq vu cv vy cv cop vg cv
        vy cv cop vx cv vu cv vg cv vy cv opeq1 eqeq2d biimpac vu vg cv elsn
        sylan2b adantrr 19.23aiv anim12i vx cv vt cv vv cv cop vg cv vy cv cop
        eqtr2 vt cv vv cv cop vg cv vy cv cop wceq vt cv vg cv wceq vv cv vy cv
        wceq vt cv vv cv vg cv vy cv vt visset vv visset vy visset opth
        pm3.26bi 3syl 19.23aivv syl6bi vt cv vg cv wceq vt cv csn vt cv cxp vg
        cv csn vt cv cxp vg cv csn vg cv cxp vt cv vg cv wceq vt cv csn vg cv
        csn wceq vt cv csn vt cv cxp vg cv csn vt cv cxp wceq vt cv vg cv sneq
        vt cv csn vg cv csn vt cv xpeq1 syl vt cv vg cv vg cv csn xpeq2 eqtrd
        syl6 vz cv vt cv csn vt cv cxp vw cv vg cv csn vg cv cxp eqeq12 sylibrd
        ex a1i r19.23aiv a1d r19.23adv imp vz cv cA wcel vz cv c0 wne vz cv vt
        cv csn vt cv cxp wceq vt vh cv wrex vu cv c0 wne vu cv vt cv csn vt cv
        cxp wceq vt vh cv wrex wa vz cv c0 wne vz cv vt cv csn vt cv cxp wceq
        vt vh cv wrex wa vu vz cv cA vz visset vu cv vz cv wceq vu cv c0 wne vz
        cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex vz cv vt cv csn
        vt cv cxp wceq vt vh cv wrex vu cv vz cv c0 neeq1 vu cv vz cv wceq vu
        cv vt cv csn vt cv cxp wceq vz cv vt cv csn vt cv cxp wceq vt vh cv vu
        cv vz cv vt cv csn vt cv cxp eqeq1 rexbidv anbi12d aceq5lem.1 elab2
        pm3.27bi vw cv cA wcel vw cv vt cv csn vt cv cxp wceq vt vh cv wrex vw
        cv vg cv csn vg cv cxp wceq vg vh cv wrex vw cv cA wcel vw cv c0 wne vw
        cv vt cv csn vt cv cxp wceq vt vh cv wrex vu cv c0 wne vu cv vt cv csn
        vt cv cxp wceq vt vh cv wrex wa vw cv c0 wne vw cv vt cv csn vt cv cxp
        wceq vt vh cv wrex wa vu vw cv cA vw visset vu cv vw cv wceq vu cv c0
        wne vw cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex vw cv vt
        cv csn vt cv cxp wceq vt vh cv wrex vu cv vw cv c0 neeq1 vu cv vw cv
        wceq vu cv vt cv csn vt cv cxp wceq vw cv vt cv csn vt cv cxp wceq vt
        vh cv vu cv vw cv vt cv csn vt cv cxp eqeq1 rexbidv anbi12d aceq5lem.1
        elab2 pm3.27bi vw cv vt cv csn vt cv cxp wceq vw cv vg cv csn vg cv cxp
        wceq vt vg vh cv vt cv vg cv wceq vt cv csn vt cv cxp vg cv csn vg cv
        cxp vw cv vt cv vg cv wceq vt cv csn vt cv cxp vg cv csn vt cv cxp vg
        cv csn vg cv cxp vt cv vg cv wceq vt cv csn vg cv csn wceq vt cv csn vt
        cv cxp vg cv csn vt cv cxp wceq vt cv vg cv sneq vt cv csn vg cv csn vt
        cv xpeq1 syl vt cv vg cv vg cv csn xpeq2 eqtrd eqeq2d cbvrexv sylib
        syl2an vx cv vz cv wcel vx cv vw cv wcel df-an syl5ibr necon1ad
        19.21adv vx vz cv vw cv disj1 syl6ibr rgen2a wph vz cv c0 wne vz vx cv
        wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv
        wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi vx
        wal vz cv c0 wne vz cA wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi
        vw cA wral vz cA wral wa vv cv vz cv vy cv cin wcel vv weu vz cA wral
        vy wex wi aceq5lem.3 vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv
        vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv vy cv
        cin wcel vv weu vz vx cv wral vy wex wi vz cv c0 wne vz cA wral vz cv
        vw cv wne vz cv vw cv cin c0 wceq wi vw cA wral vz cA wral wa vv cv vz
        cv vy cv cin wcel vv weu vz cA wral vy wex wi vx cA cA vu cv c0 wne vu
        cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab cvv aceq5lem.1 vu
        cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab vu cv
        vt cv csn vt cv cxp wceq vt vh cv wrex vu cab vt vu vh cv vt cv csn vt
        cv cxp vh visset abrexex vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt
        vh cv wrex wa vu cv vt cv csn vt cv cxp wceq vt vh cv wrex vu vu cv c0
        wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex pm3.27 ss2abi ssexi
        eqeltri vx cv cA wceq vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv
        vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vz cv c0 wne vz cA
        wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw cA wral vz cA wral
        wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex vv cv vz cv
        vy cv cin wcel vv weu vz cA wral vy wex vx cv cA wceq vz cv c0 wne vz
        vx cv wral vz cv c0 wne vz cA wral vz cv vw cv wne vz cv vw cv cin c0
        wceq wi vw vx cv wral vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0
        wceq wi vw cA wral vz cA wral vz cv c0 wne vz vx cv cA raleq1 vz cv vw
        cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz cv vw cv wne vz cv
        vw cv cin c0 wceq wi vw cA wral vz vx cv cA vz cv vw cv wne vz cv vw cv
        cin c0 wceq wi vw vx cv cA raleq1 raleqd anbi12d vx cv cA wceq vv cv vz
        cv vy cv cin wcel vv weu vz vx cv wral vv cv vz cv vy cv cin wcel vv
        weu vz cA wral vy vv cv vz cv vy cv cin wcel vv weu vz vx cv cA raleq1
        exbidv imbi12d cla4v sylbi mp2ani $.
        $( [3-Apr-2007] $) $( [11-Apr-2004] $)

      $( Lemma for ~ aceq5 . $)
      aceq5lem5 $p |- ( ph ->
                           E. f A. w e. h ( w =/= (/) -> ( f ` w ) e. w ) ) $=
        wph vv cv vz cv vy cv cin wcel vv weu vz cA wral vy wex vw cv c0 wne vw
        cv vf cv cfv vw cv wcel wi vw vh cv wral vf wex wph vx vy vz vw vv vu
        vt cA cB vh aceq5lem.1 aceq5lem.2 aceq5lem.3 aceq5lem4 vv cv vz cv vy
        cv cin wcel vv weu vz cA wral vw cv c0 wne vw cv vf cv cfv vw cv wcel
        wi vw vh cv wral vf wex vy vv cv vz cv vy cv cin wcel vv weu vz cA wral
        vw cv c0 wne vw cv cB cfv vw cv wcel wi vw vh cv wral vw cv c0 wne vw
        cv vf cv cfv vw cv wcel wi vw vh cv wral vf wex vv cv vz cv vy cv cin
        wcel vv weu vz cA wral vw cv c0 wne vw cv cB cfv vw cv wcel wi vw vh cv
        vv cv vz cv vy cv cin wcel vv weu vz cA wral vw cv c0 wne vw cv vh cv
        wcel vw cv cB cfv vw cv wcel vv cv vz cv vy cv cin wcel vv weu vz cA
        wral vw cv c0 wne vw cv vh cv wcel vw cv cB cfv vw cv wcel vv cv vz cv
        vy cv cin wcel vv weu vz cA wral vw cv c0 wne vw cv vh cv wcel wa vw cv
        vg cv cop cB wcel vg weu vw cv cB cfv vw cv wcel vv cv vz cv vy cv cin
        wcel vv weu vz cA wral vw cv c0 wne vw cv vh cv wcel wa vw cv vh cv
        wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa vg weu wa vw cv vg
        cv cop cB wcel vg weu vv cv vz cv vy cv cin wcel vv weu vz cA wral vw
        cv c0 wne vw cv vh cv wcel wa vw cv vh cv wcel vg cv vw cv wcel vw cv
        vg cv cop vy cv wcel wa vg weu vw cv c0 wne vw cv vh cv wcel wa vw cv
        vh cv wcel wi vv cv vz cv vy cv cin wcel vv weu vz cA wral vw cv c0 wne
        vw cv vh cv wcel pm3.27 a1i vv cv vz cv vy cv cin wcel vv weu vz cA
        wral vw cv csn vw cv cxp cA wcel vv cv vw cv csn vw cv cxp vy cv cin
        wcel vv weu vw cv c0 wne vw cv vh cv wcel wa vg cv vw cv wcel vw cv vg
        cv cop vy cv wcel wa vg weu vv cv vz cv vy cv cin wcel vv weu vv cv vw
        cv csn vw cv cxp vy cv cin wcel vv weu vz vw cv csn vw cv cxp cA vz cv
        vw cv csn vw cv cxp wceq vv cv vz cv vy cv cin wcel vv cv vw cv csn vw
        cv cxp vy cv cin wcel vv vz cv vw cv csn vw cv cxp wceq vz cv vy cv cin
        vw cv csn vw cv cxp vy cv cin vv cv vz cv vw cv csn vw cv cxp vy cv
        ineq1 eleq2d eubidv rcla4cv vw vu vt cA vh aceq5lem.1 aceq5lem3 vy vw
        vv vg aceq5lem1 3imtr3g jcad vw cv vg cv cop cB wcel vg weu vw cv vh cv
        wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa wa vg weu vw cv vh
        cv wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa vg weu wa vw cv
        vg cv cop cB wcel vw cv vh cv wcel vg cv vw cv wcel vw cv vg cv cop vy
        cv wcel wa wa vg vw cv vg cv cop cB wcel vw cv vg cv cop cA cuni vy cv
        cin wcel vw cv vg cv cop cA cuni wcel vw cv vg cv cop vy cv wcel wa vw
        cv vh cv wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa wa cB cA
        cuni vy cv cin vw cv vg cv cop aceq5lem.2 eleq2i vw cv vg cv cop cA
        cuni vy cv elin vw cv vg cv cop cA cuni wcel vw cv vg cv cop vy cv wcel
        wa vw cv vh cv wcel vg cv vw cv wcel wa vw cv vg cv cop vy cv wcel wa
        vw cv vh cv wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa wa vw
        cv vg cv cop cA cuni wcel vw cv vh cv wcel vg cv vw cv wcel wa vw cv vg
        cv cop vy cv wcel vw vu vt cA vg vh aceq5lem.1 aceq5lem2 anbi1i vw cv
        vh cv wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel anass bitri
        3bitri eubii vw cv vh cv wcel vg cv vw cv wcel vw cv vg cv cop vy cv
        wcel wa vg euanv bitr2i syl6ib vw cv vg cv cop cB wcel vg wex vw cv vg
        cv cop cB wcel vg weu vw cv cB cfv vw cv wcel vw cv vg cv cop cB wcel
        vg euex vw cv vg cv cop cB wcel vw cv vg cv cop cB wcel vg weu vw cv cB
        cfv vw cv wcel wi vg vw cv vg cv cop cB wcel vg weu vw cv cB cfv vw cv
        wcel vg vw cv vg cv cop cB wcel vg hbeu1 vw cv cB cfv vw cv wcel vg
        ax-17 hbim vg cv vw cv wcel vw cv vg cv cop cB wcel vw cv vg cv cop cB
        wcel vg weu vw cv cB cfv vw cv wcel wi vw cv vg cv cop cB wcel vg cv vw
        cv wcel vw cv vg cv cop vy cv wcel vw cv vg cv cop cB wcel vw cv vh cv
        wcel vg cv vw cv wcel vw cv vg cv cop vy cv wcel wa vw cv vg cv cop cB
        wcel vw cv vg cv cop cA cuni vy cv cin wcel vw cv vg cv cop cA cuni
        wcel vw cv vg cv cop vy cv wcel wa vw cv vh cv wcel vg cv vw cv wcel vw
        cv vg cv cop vy cv wcel wa wa cB cA cuni vy cv cin vw cv vg cv cop
        aceq5lem.2 eleq2i vw cv vg cv cop cA cuni vy cv elin vw cv vg cv cop cA
        cuni wcel vw cv vg cv cop vy cv wcel wa vw cv vh cv wcel vg cv vw cv
        wcel wa vw cv vg cv cop vy cv wcel wa vw cv vh cv wcel vg cv vw cv wcel
        vw cv vg cv cop vy cv wcel wa wa vw cv vg cv cop cA cuni wcel vw cv vh
        cv wcel vg cv vw cv wcel wa vw cv vg cv cop vy cv wcel vw vu vt cA vg
        vh aceq5lem.1 aceq5lem2 anbi1i vw cv vh cv wcel vg cv vw cv wcel vw cv
        vg cv cop vy cv wcel anass bitri 3bitri pm3.27bi pm3.26d vg cv vw cv
        wcel vw cv vg cv cop cB wcel vw cv vg cv cop cB wcel vg weu vw cv cB
        cfv vw cv wcel vw cv vg cv cop cB wcel vw cv vg cv cop cB wcel vg weu
        wa vw cv cB cfv vw cv wcel vg cv vw cv wcel vw cv vg cv cop cB wcel vw
        cv vg cv cop cB wcel vg weu wa vw cv cB cfv vg cv vw cv vg vw cv cB vw
        visset tz6.12 eleq1d biimparc exp32 mpcom 19.23ai mpcom syl6 exp3a
        com23 r19.21aiv vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vh cv
        wral vw cv c0 wne vw cv cB cfv vw cv wcel wi vw vh cv wral vf cB cB cA
        cuni vy cv cin cvv aceq5lem.2 vy cv cA cuni vy visset inex2 eqeltri vf
        cv cB wceq vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw cv c0 wne vw
        cv cB cfv vw cv wcel wi vw vh cv vf cv cB wceq vw cv vf cv cfv vw cv
        wcel vw cv cB cfv vw cv wcel vw cv c0 wne vf cv cB wceq vw cv vf cv cfv
        vw cv cB cfv vw cv vw cv vf cv cB fveq1 eleq1d imbi2d ralbidv cla4ev
        syl 19.23aiv syl $.
        $( [3-Apr-2007] $) $( [12-Apr-2004] $)
    $}
  $}

  ${
    $d f x z y w v h u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The left-hand side
       is similar to the Axiom of Choice (first form) of [Enderton] p. 49.  The
       right-hand side is Theorem 6M(4) of [Enderton] p. 151 and asserts that
       given a family of mutually disjoint nonempty sets, a set exists
       containing exactly one member from each set in the family.  The proof
       does not depend on AC. $)
    aceq5 $p |- ( A. x E. f ( f C_ x /\ f Fn dom x ) <->
           A. x ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
          E. y A. z e. x E! v v e. ( z i^i y ) ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vz cv c0 wne vz vx
      cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv
      wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi vx wal
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vf cv vx cv wfn vw
      cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv wral wa vf wex vx wal vz
      cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx
      cv wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral
      vy wex wi vx wal vx vw vf aceq4 vf cv vx cv wfn vw cv c0 wne vw cv vf cv
      cfv vw cv wcel wi vw vx cv wral wa vf wex vz cv c0 wne vz vx cv wral vz
      cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vv
      cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi vx vf cv vx cv wfn
      vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv wral wa vz cv c0 wne
      vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz
      vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi
      vf vf cv vx cv wfn vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv
      wral wa vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv vf cv crn cin wcel vv
      weu vz vx cv wral vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex
      vf cv vx cv wfn vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv wral
      vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw
      vx cv wral vz vx cv wral vv cv vz cv vf cv crn cin wcel vv weu vz vx cv
      wral vf cv vx cv wfn vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv
      wral vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq
      wi vw vx cv wral vz vx cv wral vv cv vz cv vf cv crn cin wcel vv weu vz
      vx cv wral wi vf cv vx cv wfn vw cv vf cv cfv vw cv wcel vw vx cv wral vz
      cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral vv cv
      vz cv vf cv crn cin wcel vv weu vz vx cv wral wi vw cv c0 wne vw cv vf cv
      cfv vw cv wcel wi vw vx cv wral vz cv c0 wne vz vx cv wral wa vf cv vx cv
      wfn vw cv vf cv cfv vw cv wcel vw vx cv wral vz cv vw cv wne vz cv vw cv
      cin c0 wceq wi vw vx cv wral vz vx cv wral vv cv vz cv vf cv crn cin wcel
      vv weu vz vx cv wral wi vf cv vx cv wfn vw cv vf cv cfv vw cv wcel vw vx
      cv wral wa vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vv cv
      vz cv vf cv crn cin wcel vv weu vz vx cv vf cv vx cv wfn vw cv vf cv cfv
      vw cv wcel vw vx cv wral wa vz cv vx cv wcel wa vz cv vw cv wne vz cv vw
      cv cin c0 wceq wi vw vx cv wral vv cv vz cv vf cv crn cin wcel vv cv vz
      cv vf cv cfv wceq wb vv wal vv cv vz cv vf cv crn cin wcel vv weu vf cv
      vx cv wfn vw cv vf cv cfv vw cv wcel vw vx cv wral wa vz cv vx cv wcel wa
      vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vv cv vz cv vf
      cv crn cin wcel vv cv vz cv vf cv cfv wceq wb vv vf cv vx cv wfn vw cv vf
      cv cfv vw cv wcel vw vx cv wral wa vz cv vx cv wcel wa vz cv vw cv wne vz
      cv vw cv cin c0 wceq wi vw vx cv wral vv cv vz cv vf cv crn cin wcel vv
      cv vz cv vf cv cfv wceq wb vf cv vx cv wfn vw cv vf cv cfv vw cv wcel vw
      vx cv wral wa vz cv vx cv wcel wa vz cv vw cv wne vz cv vw cv cin c0 wceq
      wi vw vx cv wral wa vv cv vz cv vf cv crn cin wcel vv cv vz cv vf cv cfv
      wceq vf cv vx cv wfn vw cv vf cv cfv vw cv wcel vw vx cv wral wa vz cv vw
      cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vv cv vz cv vf cv crn cin
      wcel vv cv vz cv vf cv cfv wceq wi vz cv vx cv wcel vf cv vx cv wfn vw cv
      vf cv cfv vw cv wcel vw vx cv wral vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vw vx cv wral vv cv vz cv vf cv crn cin wcel vv cv vz cv vf cv
      cfv wceq wi vf cv vx cv wfn vw cv vf cv cfv vw cv wcel vz cv vw cv wne vz
      cv vw cv cin c0 wceq wi wa vw vx cv wral vv cv vz cv vf cv crn cin wcel
      vv cv vz cv vf cv cfv wceq wi vw cv vf cv cfv vw cv wcel vw vx cv wral vz
      cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral wa vf cv vx cv wfn
      vw cv vf cv cfv vw cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi wa
      vw vx cv wral wa vv cv vz cv wcel vv cv vf cv crn wcel wa vv cv vz cv vf
      cv cfv wceq vv cv vz cv vf cv crn cin wcel vf cv vx cv wfn vw cv vf cv
      cfv vw cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi wa vw vx cv
      wral vv cv vz cv wcel vv cv vf cv crn wcel vv cv vz cv vf cv cfv wceq vv
      cv vz cv wcel vv cv vf cv crn wcel vf cv vx cv wfn vw cv vf cv cfv vw cv
      wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi wa vw vx cv wral vv cv vz
      cv vf cv cfv wceq vv cv vz cv wcel vv cv vf cv crn wcel vf cv vx cv wfn
      vw cv vf cv cfv vw cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi wa
      vw vx cv wral vv cv vz cv vf cv cfv wceq wi vv cv vz cv wcel vt cv vf cv
      cfv vv cv wceq vt vx cv wrex vw cv vf cv cfv vw cv wcel vz cv vw cv wne
      vz cv vw cv cin c0 wceq wi wa vw vx cv wral vv cv vz cv vf cv cfv wceq wi
      vv cv vf cv crn wcel vf cv vx cv wfn wa vv cv vz cv wcel vt cv vf cv cfv
      vv cv wceq vw cv vf cv cfv vw cv wcel vz cv vw cv wne vz cv vw cv cin c0
      wceq wi wa vw vx cv wral vv cv vz cv vf cv cfv wceq wi vt vx cv vw cv vf
      cv cfv vw cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi wa vw vx cv
      wral vt cv vx cv wcel vt cv vf cv cfv vv cv wceq vv cv vz cv wcel vv cv
      vz cv vf cv cfv wceq vt cv vx cv wcel vw cv vf cv cfv vw cv wcel vz cv vw
      cv wne vz cv vw cv cin c0 wceq wi wa vw vx cv wral vt cv vf cv cfv vt cv
      wcel vz cv vt cv wne vz cv vt cv cin c0 wceq wi wa vt cv vf cv cfv vv cv
      wceq vv cv vz cv wcel vv cv vz cv vf cv cfv wceq wi wi vw cv vf cv cfv vw
      cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi wa vt cv vf cv cfv vt
      cv wcel vz cv vt cv wne vz cv vt cv cin c0 wceq wi wa vw vt cv vx cv vw
      cv vt cv wceq vw cv vf cv cfv vw cv wcel vt cv vf cv cfv vt cv wcel vz cv
      vw cv wne vz cv vw cv cin c0 wceq wi vz cv vt cv wne vz cv vt cv cin c0
      wceq wi vw cv vt cv wceq vw cv vf cv cfv vt cv vf cv cfv vw cv vt cv vw
      cv vt cv vf cv fveq2 vw cv vt cv wceq id eleq12d vw cv vt cv wceq vz cv
      vw cv wne vz cv vt cv wne vz cv vw cv cin c0 wceq vz cv vt cv cin c0 wceq
      vw cv vt cv vz cv neeq2 vw cv vt cv wceq vz cv vw cv cin vz cv vt cv cin
      c0 vw cv vt cv vz cv ineq2 eqeq1d imbi12d anbi12d rcla4v vt cv vf cv cfv
      vt cv wcel vz cv vt cv wne vz cv vt cv cin c0 wceq wi wa vt cv vf cv cfv
      vv cv wceq vv cv vz cv wcel vv cv vz cv vf cv cfv wceq vt cv vf cv cfv vt
      cv wcel vz cv vt cv wne vz cv vt cv cin c0 wceq wi wa vt cv vf cv cfv vv
      cv wceq vv cv vz cv wcel wa wa vz cv vt cv wceq vv cv vz cv vf cv cfv
      wceq vt cv vf cv cfv vt cv wcel vz cv vt cv wne vz cv vt cv cin c0 wceq
      wi wa vt cv vf cv cfv vz cv wcel vz cv vt cv wceq vt cv vf cv cfv vv cv
      wceq vv cv vz cv wcel wa vt cv vf cv cfv vt cv wcel vz cv vt cv wne vz cv
      vt cv cin c0 wceq wi wa vt cv vf cv cfv vz cv wcel vz cv vt cv wceq vt cv
      vf cv cfv vt cv wcel vz cv vt cv wne vz cv vt cv cin c0 wceq wi wa vt cv
      vf cv cfv vz cv wcel vz cv vt cv vt cv vf cv cfv vt cv wcel vz cv vt cv
      wne vz cv vt cv cin c0 wceq wi vz cv vt cv wne vt cv vf cv cfv vz cv wcel
      wn wi vt cv vf cv cfv vt cv wcel vz cv vt cv cin c0 wceq vt cv vf cv cfv
      vz cv wcel wn vz cv vt cv wne vt cv vf cv cfv vt cv wcel vz cv vt cv cin
      c0 wceq vt cv vf cv cfv vz cv wcel wn vt cv vf cv cfv vt cv vz cv minel
      ex imim2d imp necon4ad imp vt cv vf cv cfv vv cv wceq vt cv vf cv cfv vz
      cv wcel vv cv vz cv wcel vt cv vf cv cfv vv cv vz cv eleq1 biimpar sylan2
      vt cv vf cv cfv vv cv wceq vz cv vt cv wceq vv cv vz cv vf cv cfv wceq wi
      vt cv vf cv cfv vt cv wcel vz cv vt cv wne vz cv vt cv cin c0 wceq wi wa
      vv cv vz cv wcel vt cv vf cv cfv vv cv wceq vz cv vf cv cfv vt cv vf cv
      cfv wceq vv cv vz cv vf cv cfv wceq vz cv vt cv wceq vt cv vf cv cfv vv
      cv wceq vz cv vf cv cfv vt cv vf cv cfv wceq vz cv vf cv cfv vv cv wceq
      vv cv vz cv vf cv cfv wceq vt cv vf cv cfv vv cv vz cv vf cv cfv eqeq2 vz
      cv vf cv cfv vv cv eqcom syl6bb vz cv vt cv vf cv fveq2 syl5bi ad2antrl
      mpd exp32 syl6com com14 r19.23adv vf cv vx cv wfn vv cv vf cv crn wcel vt
      cv vf cv cfv vv cv wceq vt vx cv wrex vt vx cv vv cv vf cv fvelrnb
      biimpac syl5 exp3a com4t imp4b vv cv vz cv vf cv crn elin syl5ib vw cv vf
      cv cfv vw cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv
      r19.26 sylan2br anassrs adantlr vf cv vx cv wfn vw cv vf cv cfv vw cv
      wcel vw vx cv wral wa vz cv vx cv wcel wa vv cv vz cv vf cv cfv wceq vv
      cv vz cv vf cv crn cin wcel wi vz cv vw cv wne vz cv vw cv cin c0 wceq wi
      vw vx cv wral vv cv vz cv vf cv cfv wceq vv cv vz cv vf cv crn cin wcel
      vz cv vf cv cfv vz cv vf cv crn cin wcel vf cv vx cv wfn vw cv vf cv cfv
      vw cv wcel vw vx cv wral wa vz cv vx cv wcel wa vv cv vz cv vf cv cfv vz
      cv vf cv crn cin eleq1 vf cv vx cv wfn vw cv vf cv cfv vw cv wcel vw vx
      cv wral vz cv vx cv wcel vz cv vf cv cfv vz cv vf cv crn cin wcel vz cv
      vx cv wcel vw cv vf cv cfv vw cv wcel vw vx cv wral vf cv vx cv wfn vz cv
      vf cv cfv vz cv vf cv crn cin wcel vz cv vx cv wcel vw cv vf cv cfv vw cv
      wcel vw vx cv wral vf cv vx cv wfn vz cv vf cv cfv vz cv vf cv crn cin
      wcel vz cv vx cv wcel vw cv vf cv cfv vw cv wcel vw vx cv wral vf cv vx
      cv wfn wa vz cv vf cv cfv vz cv wcel vz cv vf cv cfv vf cv crn wcel wa vz
      cv vf cv cfv vz cv vf cv crn cin wcel vz cv vx cv wcel vw cv vf cv cfv vw
      cv wcel vw vx cv wral vz cv vf cv cfv vz cv wcel vf cv vx cv wfn vz cv vf
      cv cfv vf cv crn wcel vw cv vf cv cfv vw cv wcel vz cv vf cv cfv vz cv
      wcel vw vz cv vx cv vw cv vz cv wceq vw cv vf cv cfv vz cv vf cv cfv vw
      cv vz cv vw cv vz cv vf cv fveq2 vw cv vz cv wceq id eleq12d rcla4v vf cv
      vx cv wfn vz cv vx cv wcel vz cv vf cv cfv vf cv crn wcel vx cv vz cv vf
      cv fnfvelrn expcom anim12d vz cv vf cv cfv vz cv vf cv crn elin syl6ibr
      exp3a com13 imp31 syl5cbir adantr impbid ex 19.21adv vv cv vz cv vf cv
      crn cin wcel vv cv vz cv vf cv cfv wceq wb vv wal vv cv vz cv vf cv crn
      cin wcel vv cv vh cv wceq wb vv wal vh wex vv cv vz cv vf cv crn cin wcel
      vv weu vv cv vz cv vf cv crn cin wcel vv cv vh cv wceq wb vv wal vv cv vz
      cv vf cv crn cin wcel vv cv vz cv vf cv cfv wceq wb vv wal vh vz cv vf cv
      cfv vz cv vf cv fvex vh cv vz cv vf cv cfv wceq vv cv vz cv vf cv crn cin
      wcel vv cv vh cv wceq wb vv cv vz cv vf cv crn cin wcel vv cv vz cv vf cv
      cfv wceq wb vv vh cv vz cv vf cv cfv wceq vv cv vh cv wceq vv cv vz cv vf
      cv cfv wceq vv cv vz cv vf cv crn cin wcel vh cv vz cv vf cv cfv vv cv
      eqeq2 bibi2d albidv cla4ev vv cv vz cv vf cv crn cin wcel vv vh df-eu
      sylibr syl6 r19.20dva ex vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx
      cv wral vz cv c0 wne vz vx cv wral wa vw cv c0 wne vw cv vf cv cfv vw cv
      wcel wi vw cv c0 wne wa vw vx cv wral vw cv vf cv cfv vw cv wcel vw vx cv
      wral vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv wral vz cv c0
      wne vz vx cv wral wa vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv
      wral vw cv c0 wne vw vx cv wral wa vw cv c0 wne vw cv vf cv cfv vw cv
      wcel wi vw cv c0 wne wa vw vx cv wral vz cv c0 wne vz vx cv wral vw cv c0
      wne vw vx cv wral vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw vx cv
      wral vz cv c0 wne vw cv c0 wne vz vw vx cv vz cv vw cv c0 neeq1 cbvralv
      anbi2i vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw cv c0 wne vw vx cv
      r19.26 bitr4i vw cv c0 wne vw cv vf cv cfv vw cv wcel wi vw cv c0 wne wa
      vw cv vf cv cfv vw cv wcel vw vx cv vw cv c0 wne vw cv c0 wne vw cv vf cv
      cfv vw cv wcel wi vw cv vf cv cfv vw cv wcel vw cv c0 wne vw cv vf cv cfv
      vw cv wcel pm3.35 ancoms r19.20si sylbi syl5 exp3a imp4b vv cv vz cv vy
      cv cin wcel vv weu vz vx cv wral vv cv vz cv vf cv crn cin wcel vv weu vz
      vx cv wral vy vf cv crn vf cv vf visset rnex vy cv vf cv crn wceq vv cv
      vz cv vy cv cin wcel vv weu vv cv vz cv vf cv crn cin wcel vv weu vz vx
      cv vy cv vf cv crn wceq vv cv vz cv vy cv cin wcel vv cv vz cv vf cv crn
      cin wcel vv vy cv vf cv crn wceq vz cv vy cv cin vz cv vf cv crn cin vv
      cv vy cv vf cv crn vz cv ineq2 eleq2d eubidv ralbidv cla4ev syl6 19.23aiv
      19.20i sylbi vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin
      c0 wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv
      weu vz vx cv wral vy wex wi vx wal vw cv c0 wne vw cv vf cv cfv vw cv
      wcel wi vw vh cv wral vf wex vh wal vf cv vx cv wss vf cv vx cv cdm wfn
      wa vf wex vx wal vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv
      cin c0 wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv vy cv cin wcel
      vv weu vz vx cv wral vy wex wi vx wal vw cv c0 wne vw cv vf cv cfv vw cv
      wcel wi vw vh cv wral vf wex vh vz cv c0 wne vz vx cv wral vz cv vw cv
      wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv
      vy cv cin wcel vv weu vz vx cv wral vy wex wi vx wal vx vy vz vw vv vu vt
      vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab vu cv
      c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu cab cuni vy cv
      cin vf vh vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu
      cab eqid vu cv c0 wne vu cv vt cv csn vt cv cxp wceq vt vh cv wrex wa vu
      cab cuni vy cv cin eqid vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv
      vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv vy cv cin
      wcel vv weu vz vx cv wral vy wex wi vx wal biid aceq5lem5 19.21aiv vf cv
      vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vw cv c0 wne vw cv vf cv
      cfv vw cv wcel wi vw vx cv wral vf wex vx wal vw cv c0 wne vw cv vf cv
      cfv vw cv wcel wi vw vh cv wral vf wex vh wal vx vw vf aceq3 vw cv c0 wne
      vw cv vf cv cfv vw cv wcel wi vw vx cv wral vf wex vw cv c0 wne vw cv vf
      cv cfv vw cv wcel wi vw vh cv wral vf wex vx vh vx cv vh cv wceq vw cv c0
      wne vw cv vf cv cfv vw cv wcel wi vw vx cv wral vw cv c0 wne vw cv vf cv
      cfv vw cv wcel wi vw vh cv wral vf vw cv c0 wne vw cv vf cv cfv vw cv
      wcel wi vw vx cv vh cv raleq1 exbidv cbvalv bitr2i sylib impbii $.
      $( [21-Apr-2007] $) $( [11-Apr-2004] $)
  $}

  ${
    $d x z f y w v u g $.
    $( Our Axiom of Choice (in the form of ~ ac3 ) implies the Axiom of Choice
      (first form) of [Enderton] p. 49.  The proof uses neither AC nor the
      Axiom of Regularity.  See ~ aceq6b for the converse (which does use
      the Axiom of Regularity). $)
    aceq6a $p |- ( A. x E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
                      ( z e. v /\ w e. v ) ) ->
                  A. x E. f ( f C_ x /\ f Fn dom x ) ) $=
      vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv
      wreu wi vz vx cv wral vy wex vx wal vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv wral vf wex vx wal vf cv vx cv wss vf cv vx cv cdm wfn
      wa vf wex vx wal vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy
      cv wrex vw vz cv wreu wi vz vx cv wral vy wex vz cv c0 wne vz cv vf cv
      cfv vz cv wcel wi vz vx cv wral vf wex vx vz cv c0 wne vz cv vv cv wcel
      vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral vz cv c0
      wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf wex vy vz cv c0 wne vz
      cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv
      wral vz cv c0 wne vz cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv
      cv wcel wa vv vy cv wrex vw vu cv crab cuni wceq wa vu vg copab cfv vz cv
      wcel wi vz vx cv wral vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv
      wral vf wex vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv
      wrex vw vz cv wreu wi vz cv c0 wne vz cv vu cv vx cv wcel vg cv vu cv vv
      cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab cuni wceq wa vu
      vg copab cfv vz cv wcel wi vz vx cv vz cv vx cv wcel vz cv vv cv wcel vw
      cv vv cv wcel wa vv vy cv wrex vw vz cv wreu vz cv vu cv vx cv wcel vg cv
      vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab cuni
      wceq wa vu vg copab cfv vz cv wcel vz cv c0 wne vz cv vx cv wcel vz cv vu
      cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw
      vu cv crab cuni wceq wa vu vg copab cfv vz cv wcel vz cv vv cv wcel vw cv
      vv cv wcel wa vv vy cv wrex vw vz cv crab cuni vz cv wcel vz cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu vz cv vx cv wcel vz
      cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv
      wrex vw vu cv crab cuni wceq wa vu vg copab cfv vz cv vv cv wcel vw cv vv
      cv wcel wa vv vy cv wrex vw vz cv crab cuni vz cv vu vg vz cv vu cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab cuni vz cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv crab cuni vx cv vu cv vx
      cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv
      crab cuni wceq wa vu vg copab vu cv vz cv wceq vu cv vv cv wcel vw cv vv
      cv wcel wa vv vy cv wrex vw vu cv crab vz cv vv cv wcel vw cv vv cv wcel
      wa vv vy cv wrex vw vz cv crab vu cv vz cv wceq vw cv vu cv wcel vu cv vv
      cv wcel vw cv vv cv wcel wa vv vy cv wrex wa vw cab vw cv vz cv wcel vz
      cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex wa vw cab vu cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab vz cv vv cv wcel vw
      cv vv cv wcel wa vv vy cv wrex vw vz cv crab vu cv vz cv wceq vw cv vu cv
      wcel vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex wa vw cv vz cv
      wcel vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex wa vw vu cv vz cv
      wceq vw cv vu cv wcel vw cv vz cv wcel vu cv vv cv wcel vw cv vv cv wcel
      wa vv vy cv wrex vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vu cv
      vz cv vw cv eleq2 vu cv vz cv wceq vu cv vv cv wcel vw cv vv cv wcel wa
      vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv vu cv vz cv wceq vu cv vv
      cv wcel vz cv vv cv wcel vw cv vv cv wcel vu cv vz cv vv cv eleq1 anbi1d
      rexbidv anbi12d abbidv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex
      vw vu cv df-rab vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz
      cv df-rab 3eqtr4g unieqd vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv
      cv wcel wa vv vy cv wrex vw vu cv crab cuni wceq wa vu vg copab eqid vz
      cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv crab vz cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv vz visset rabex uniex
      fvopab4 eleq1d vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz
      cv reucl syl5bir imim2d r19.20i vz cv c0 wne vz cv vf cv cfv vz cv wcel
      wi vz vx cv wral vz cv c0 wne vz cv vu cv vx cv wcel vg cv vu cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab cuni wceq wa vu vg
      copab cfv vz cv wcel wi vz vx cv wral vf vu cv vx cv wcel vg cv vu cv vv
      cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab cuni wceq wa vu
      vg copab vu vg vx cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex
      vw vu cv crab cuni vx visset opabex2 vf cv vu cv vx cv wcel vg cv vu cv
      vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vu cv crab cuni wceq wa
      vu vg copab wceq vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz cv c0 wne
      vz cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy
      cv wrex vw vu cv crab cuni wceq wa vu vg copab cfv vz cv wcel wi vz vx cv
      vf cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy
      cv wrex vw vu cv crab cuni wceq wa vu vg copab wceq vz cv vf cv cfv vz cv
      wcel vz cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv
      vy cv wrex vw vu cv crab cuni wceq wa vu vg copab cfv vz cv wcel vz cv c0
      wne vf cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv
      vy cv wrex vw vu cv crab cuni wceq wa vu vg copab wceq vz cv vf cv cfv vz
      cv vu cv vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv
      wrex vw vu cv crab cuni wceq wa vu vg copab cfv vz cv vz cv vf cv vu cv
      vx cv wcel vg cv vu cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vu
      cv crab cuni wceq wa vu vg copab fveq1 eleq1d imbi2d ralbidv cla4ev syl
      19.23aiv 19.20i vx vz vf aceq3 sylibr $.
      $( [30-Apr-2007] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x y z w v u f g h $.
    $( Axiom of Choice (first form) of [Enderton] p. 49 implies of our Axiom
       of Choice (in the form of ~ ac3 ).  The proof does not make use of
       AC.  Note that the Axiom of Regularity is used by the proof.
       Specifically, ~ elirrv and ~ preleq that are referenced in the proof
       each make use of Regularity for their derivations. (The reverse
       implication can be derived without using Regularity; see ~ aceq6a .) $)
    aceq6b $p |- ( A. x E. f ( f C_ x /\ f Fn dom x ) ->
                  A. x E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
                      ( z e. v /\ w e. v ) ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vz cv c0 wne vz cv
      vf cv cfv vz cv wcel wi vz vx cv wral vf wex vx wal vz cv c0 wne vz cv vv
      cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral
      vy wex vx wal vx vz vf aceq3 vz cv c0 wne vz cv vf cv cfv vz cv wcel wi
      vz vx cv wral vf wex vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv
      vy cv wrex vw vz cv wreu wi vz vx cv wral vy wex vx vz cv c0 wne vz cv vf
      cv cfv vz cv wcel wi vz vx cv wral vz cv c0 wne vz cv vv cv wcel vw cv vv
      cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral vy wex vf vz cv
      c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vz cv c0 wne vz cv vv
      cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv
      cpr wceq wa vu vx cv wrex vg cab wrex vw vz cv wreu wi vz vx cv wral vz
      cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv
      wreu wi vz vx cv wral vy wex vz cv c0 wne vz cv vf cv cfv vz cv wcel wi
      vz vx cv wral vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv
      c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex
      vw vz cv wreu wi vz vx cv vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz
      vx cv hbra1 vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vz
      cv vx cv wcel vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv
      c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex
      vw vz cv wreu vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vz
      cv vx cv wcel vz cv c0 wne wa vw cv vz cv wcel vz cv vv cv wcel vw cv vv
      cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx
      cv wrex vg cab wrex wa vw wex vw cv vz cv wcel vz cv vv cv wcel vw cv vv
      cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx
      cv wrex vg cab wrex wa vw wmo wa vz cv vv cv wcel vw cv vv cv wcel wa vv
      vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab
      wrex vw vz cv wreu vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv
      wral vz cv vx cv wcel vz cv c0 wne wa vw cv vz cv wcel vz cv vv cv wcel
      vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq
      wa vu vx cv wrex vg cab wrex wa vw wex vw cv vz cv wcel vz cv vv cv wcel
      vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq
      wa vu vx cv wrex vg cab wrex wa vw wmo vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv wral vz cv vx cv wcel vz cv c0 wne wa vw cv vz cv wcel
      vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv
      cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex wa vw wex vz cv c0 wne vz
      cv vf cv cfv vz cv wcel wi vz vx cv wral vz cv vx cv wcel vz cv c0 wne vz
      cv vx cv wcel vz cv c0 wne wa vw cv vz cv wcel vz cv vv cv wcel vw cv vv
      cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx
      cv wrex vg cab wrex wa vw wex wi vz cv c0 wne vz cv vf cv cfv vz cv wcel
      wi vz vx cv wral vz cv vx cv wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel
      vz cv vx cv wcel vz cv c0 wne wa vw cv vz cv wcel vz cv vv cv wcel vw cv
      vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu
      vx cv wrex vg cab wrex wa vw wex wi vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv ra4 vz cv vf cv cfv vz cv wcel vz cv vx cv wcel vz cv c0
      wne wa vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0
      wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex wa
      vw wex vz cv vf cv cfv vz cv wcel vz cv vv cv wcel vz cv vf cv cfv vv cv
      wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vg cab wrex vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv
      vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab
      wrex wa vw wex vz cv vx cv wcel vz cv c0 wne wa vw cv vz cv wcel vz cv vv
      cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv
      cpr wceq wa vu vx cv wrex vg cab wrex wa vz cv vf cv cfv vz cv wcel vz cv
      vv cv wcel vz cv vf cv cfv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf
      cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex wa vw vz cv vf cv cfv
      vz cv vf cv fvex vw cv vz cv vf cv cfv wceq vw cv vz cv wcel vz cv vf cv
      cfv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv
      vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vz cv vv cv
      wcel vz cv vf cv cfv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv
      vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw cv vz cv vf cv cfv vz cv
      eleq1 vw cv vz cv vf cv cfv wceq vz cv vv cv wcel vw cv vv cv wcel wa vz
      cv vv cv wcel vz cv vf cv cfv vv cv wcel wa vv vu cv c0 wne vg cv vu cv
      vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab vw cv vz cv vf cv cfv
      wceq vw cv vv cv wcel vz cv vf cv cfv vv cv wcel vz cv vv cv wcel vw cv
      vz cv vf cv cfv vv cv eleq1 anbi2d rexbidv anbi12d cla4ev vz cv vf cv cfv
      vz cv cpr vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vg cab wcel vz cv vz cv vf cv cfv vz cv cpr wcel vz cv vf cv cfv vz
      cv vf cv cfv vz cv cpr wcel wa vz cv vv cv wcel vz cv vf cv cfv vv cv
      wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vg cab wrex vz cv vx cv wcel vz cv c0 wne wa vz cv vv cv wcel vz cv
      vf cv cfv vv cv wcel wa vz cv vz cv vf cv cfv vz cv cpr wcel vz cv vf cv
      cfv vz cv vf cv cfv vz cv cpr wcel wa vv vz cv vf cv cfv vz cv cpr vu cv
      c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab vv cv
      vz cv vf cv cfv vz cv cpr wceq vz cv vv cv wcel vz cv vz cv vf cv cfv vz
      cv cpr wcel vz cv vf cv cfv vv cv wcel vz cv vf cv cfv vz cv vf cv cfv vz
      cv cpr wcel vv cv vz cv vf cv cfv vz cv cpr vz cv eleq2 vv cv vz cv vf cv
      cfv vz cv cpr vz cv vf cv cfv eleq2 anbi12d rcla4ev vz cv vx cv wcel vz
      cv c0 wne wa vu cv c0 wne vz cv vf cv cfv vz cv cpr vu cv vf cv cfv vu cv
      cpr wceq wa vu vx cv wrex vz cv vf cv cfv vz cv cpr vu cv c0 wne vg cv vu
      cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wcel vz cv vx cv wcel
      vz cv c0 wne wa vu cv c0 wne vu cv vz cv wceq wa vu vx cv wrex vu cv c0
      wne vz cv vf cv cfv vz cv cpr vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vz cv vx cv wcel vz cv c0 wne vz cv vz cv wceq vu cv c0 wne vu cv vz
      cv wceq wa vu vx cv wrex vz cv eqid vu cv c0 wne vu cv vz cv wceq wa vz
      cv c0 wne vz cv vz cv wceq wa vu vz cv vx cv vu cv vz cv wceq vu cv c0
      wne vz cv c0 wne vu cv vz cv wceq vz cv vz cv wceq vu cv vz cv c0 neeq1
      vu cv vz cv vz cv eqeq1 anbi12d rcla4ev mpanr2 vu cv c0 wne vu cv vz cv
      wceq wa vu cv c0 wne vz cv vf cv cfv vz cv cpr vu cv vf cv cfv vu cv cpr
      wceq wa vu vx cv vu cv vz cv wceq vz cv vf cv cfv vz cv cpr vu cv vf cv
      cfv vu cv cpr wceq vu cv c0 wne vu cv vz cv wceq vu cv vf cv cfv vu cv
      cpr vz cv vf cv cfv vu cv cpr vz cv vf cv cfv vz cv cpr vu cv vz cv wceq
      vu cv vf cv cfv vz cv vf cv cfv wceq vu cv vf cv cfv vu cv cpr vz cv vf
      cv cfv vu cv cpr wceq vu cv vz cv vf cv fveq2 vu cv vf cv cfv vz cv vf cv
      cfv vu cv preq1 syl vu cv vz cv vz cv vf cv cfv preq2 eqtr2d anim2i
      r19.22si syl vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx
      cv wrex vu cv c0 wne vz cv vf cv cfv vz cv cpr vu cv vf cv cfv vu cv cpr
      wceq wa vu vx cv wrex vg vz cv vf cv cfv vz cv cpr vz cv vf cv cfv vz cv
      prex vg cv vz cv vf cv cfv vz cv cpr wceq vu cv c0 wne vg cv vu cv vf cv
      cfv vu cv cpr wceq wa vu cv c0 wne vz cv vf cv cfv vz cv cpr vu cv vf cv
      cfv vu cv cpr wceq wa vu vx cv vg cv vz cv vf cv cfv vz cv cpr wceq vg cv
      vu cv vf cv cfv vu cv cpr wceq vz cv vf cv cfv vz cv cpr vu cv vf cv cfv
      vu cv cpr wceq vu cv c0 wne vg cv vz cv vf cv cfv vz cv cpr vu cv vf cv
      cfv vu cv cpr eqeq1 anbi2d rexbidv elab sylibr vz cv vz cv vf cv cfv vz
      cv cpr wcel vz cv vf cv cfv vz cv vf cv cfv vz cv cpr wcel vz cv vf cv
      cfv vz cv vz visset prid2 vz cv vf cv cfv vz cv vz cv vf cv fvex prid1
      pm3.2i sylancl sylan2 ex syl8 imp3a pm2.43d vz cv c0 wne vz cv vf cv cfv
      vz cv wcel wi vz vx cv wral vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv
      wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vg cab wrex wa vw cv vz cv vf cv cfv wceq wi vw wal vw cv vz cv wcel
      vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv
      cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex wa vw wmo vz cv c0 wne vz
      cv vf cv cfv vz cv wcel wi vz vx cv wral vw cv vz cv wcel vz cv vv cv
      wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr
      wceq wa vu vx cv wrex vg cab wrex wa vw cv vz cv vf cv cfv wceq wi vw vz
      cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vw cv vz cv wcel vz
      cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv
      vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw cv vz cv vf cv cfv wceq vz
      cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vw cv vz cv wcel wa
      vv cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex
      vg cab wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vw cv vz cv vf
      cv cfv wceq vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu
      cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vz cv c0 wne vz
      cv vf cv cfv vz cv wcel wi vz vx cv wral vw cv vz cv wcel wa vv cv vu cv
      c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wcel
      vz cv vv cv wcel vw cv vv cv wcel wa wa vw cv vz cv vf cv cfv wceq vv vz
      cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vw cv vz cv wcel vv
      cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg
      cab wcel vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf cv cfv wceq
      vv cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex
      vg cab wcel vw cv vz cv wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel wi
      vz vx cv wral vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf cv cfv
      wceq wi vv cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx
      cv wrex vg cab wcel vw cv vz cv wcel vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv wral vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf
      cv cfv wceq wi vv cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa
      vu vx cv wrex vg cab wcel vu cv c0 wne vv cv vu cv vf cv cfv vu cv cpr
      wceq wa vu vx cv wrex vw cv vz cv wcel vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv wral wa vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv
      vf cv cfv wceq wi wi vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa
      vu vx cv wrex vu cv c0 wne vv cv vu cv vf cv cfv vu cv cpr wceq wa vu vx
      cv wrex vg vv cv vv visset vg cv vv cv wceq vu cv c0 wne vg cv vu cv vf
      cv cfv vu cv cpr wceq wa vu cv c0 wne vv cv vu cv vf cv cfv vu cv cpr
      wceq wa vu vx cv vg cv vv cv wceq vg cv vu cv vf cv cfv vu cv cpr wceq vv
      cv vu cv vf cv cfv vu cv cpr wceq vu cv c0 wne vg cv vv cv vu cv vf cv
      cfv vu cv cpr eqeq1 anbi2d rexbidv elab vu cv c0 wne vv cv vu cv vf cv
      cfv vu cv cpr wceq wa vw cv vz cv wcel vz cv c0 wne vz cv vf cv cfv vz cv
      wcel wi vz vx cv wral wa vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv
      vf cv cfv wceq wi wi vu vx cv vw cv vz cv wcel vz cv c0 wne vz cv vf cv
      cfv vz cv wcel wi vz vx cv wral wa vu cv vx cv wcel vu cv c0 wne vv cv vu
      cv vf cv cfv vu cv cpr wceq wa vz cv vv cv wcel vw cv vv cv wcel wa vw cv
      vz cv vf cv cfv wceq wi vw cv vz cv wcel vz cv c0 wne vz cv vf cv cfv vz
      cv wcel wi vz vx cv wral wa vu cv vx cv wcel vu cv c0 wne vv cv vu cv vf
      cv cfv vu cv cpr wceq vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf
      cv cfv wceq wi vw cv vz cv wcel vz cv c0 wne vz cv vf cv cfv vz cv wcel
      wi vz vx cv wral vu cv vx cv wcel vu cv c0 wne vv cv vu cv vf cv cfv vu
      cv cpr wceq vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf cv cfv
      wceq wi wi wi wi vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral
      vu cv vx cv wcel vu cv c0 wne vw cv vz cv wcel vv cv vu cv vf cv cfv vu
      cv cpr wceq vz cv vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf cv cfv
      wceq wi wi vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vu cv
      vx cv wcel vu cv c0 wne vu cv vf cv cfv vu cv wcel vw cv vz cv wcel vv cv
      vu cv vf cv cfv vu cv cpr wceq vz cv vv cv wcel vw cv vv cv wcel wa vw cv
      vz cv vf cv cfv wceq wi wi wi vz cv c0 wne vz cv vf cv cfv vz cv wcel wi
      vu cv c0 wne vu cv vf cv cfv vu cv wcel wi vz vu cv vx cv vz cv vu cv
      wceq vz cv c0 wne vu cv c0 wne vz cv vf cv cfv vz cv wcel vu cv vf cv cfv
      vu cv wcel vz cv vu cv c0 neeq1 vz cv vu cv wceq vz cv vf cv cfv vz cv
      wcel vu cv vf cv cfv vz cv wcel vu cv vf cv cfv vu cv wcel vz cv vu cv
      wceq vz cv vf cv cfv vu cv vf cv cfv vz cv vz cv vu cv vf cv fveq2 eleq1d
      vz cv vu cv vu cv vf cv cfv eleq2 bitrd imbi12d rcla4cv vv cv vu cv vf cv
      cfv vu cv cpr wceq vw cv vz cv wcel vu cv vf cv cfv vu cv wcel vz cv vv
      cv wcel vw cv vv cv wcel wa vw cv vz cv vf cv cfv wceq wi vv cv vu cv vf
      cv cfv vu cv cpr wceq vw cv vz cv wcel vu cv vf cv cfv vu cv wcel vz cv
      vv cv wcel vw cv vv cv wcel wa vw cv vz cv vf cv cfv wceq vv cv vu cv vf
      cv cfv vu cv cpr wceq vw cv vz cv wcel vu cv vf cv cfv vu cv wcel wa vz
      cv vv cv wcel vw cv vv cv wcel wa wa vw cv vu cv vf cv cfv wceq vz cv vu
      cv wceq wa vw cv vz cv vf cv cfv wceq vv cv vu cv vf cv cfv vu cv cpr
      wceq vw cv vz cv wcel vu cv vf cv cfv vu cv wcel wa vz cv vv cv wcel vw
      cv vv cv wcel wa wa vw cv vz cv wcel vu cv vf cv cfv vu cv wcel wa vw cv
      vz cv cpr vu cv vf cv cfv vu cv cpr wceq wa vw cv vu cv vf cv cfv wceq vz
      cv vu cv wceq wa vv cv vu cv vf cv cfv vu cv cpr wceq vw cv vz cv wcel vu
      cv vf cv cfv vu cv wcel wa vw cv vz cv cpr vu cv vf cv cfv vu cv cpr wceq
      vz cv vv cv wcel vw cv vv cv wcel wa vv cv vu cv vf cv cfv vu cv cpr wceq
      vw cv vz cv wcel vw cv vz cv cpr vu cv vf cv cfv vu cv cpr wceq vz cv vv
      cv wcel vw cv vv cv wcel wa wb vu cv vf cv cfv vu cv wcel vv cv vu cv vf
      cv cfv vu cv cpr wceq vw cv vz cv wceq wn vw cv vz cv cpr vu cv vf cv cfv
      vu cv cpr wceq vz cv vv cv wcel vw cv vv cv wcel wa wb vw cv vz cv wcel
      vw cv vz cv wceq wn vw cv vz cv cpr vu cv vf cv cfv vu cv cpr wceq vw cv
      vu cv vf cv cfv vu cv cpr wcel vz cv vu cv vf cv cfv vu cv cpr wcel wa vv
      cv vu cv vf cv cfv vu cv cpr wceq vz cv vv cv wcel vw cv vv cv wcel wa vw
      cv vz cv vu cv vf cv cfv vu cv vw visset vz visset vu cv vf cv fvex vu
      visset prel12 vv cv vu cv vf cv cfv vu cv cpr wceq vw cv vv cv wcel vz cv
      vv cv wcel wa vw cv vu cv vf cv cfv vu cv cpr wcel vz cv vu cv vf cv cfv
      vu cv cpr wcel wa vz cv vv cv wcel vw cv vv cv wcel wa vv cv vu cv vf cv
      cfv vu cv cpr wceq vw cv vv cv wcel vw cv vu cv vf cv cfv vu cv cpr wcel
      vz cv vv cv wcel vz cv vu cv vf cv cfv vu cv cpr wcel vv cv vu cv vf cv
      cfv vu cv cpr vw cv eleq2 vv cv vu cv vf cv cfv vu cv cpr vz cv eleq2
      anbi12d vw cv vv cv wcel vz cv vv cv wcel ancom syl5rbbr sylan9bbr vw cv
      vz cv wceq vw cv vz cv wcel vw cv vz cv wceq vw cv vw cv wcel vw cv vz cv
      wcel vw elirrv vw cv vz cv vw cv eleq2 mtbii con2i sylan2 adantrr
      pm5.32da vw cv vz cv vu cv vf cv cfv vu cv vw visset vz visset vu cv vf
      cv fvex vu visset preleq syl6bir vz cv vu cv wceq vw cv vz cv vf cv cfv
      wceq vw cv vu cv vf cv cfv wceq vz cv vu cv wceq vz cv vf cv cfv vu cv vf
      cv cfv vw cv vz cv vu cv vf cv fveq2 eqeq2d biimparc syl6 exp4c com13
      syl8 com4r imp imp4a com3l r19.23aiv sylbi exp3a com13 imp4b 19.23adv vz
      cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv cfv
      vu cv cpr wceq wa vu vx cv wrex vg cab df-rex syl5ib expimpd 19.21aiv vw
      cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv
      vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex wa vw vz cv
      vf cv cfv mo2icl syl jctird vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv
      c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex
      vw vz cv wreu vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv vu
      cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab
      wrex wa vw weu vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv
      vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab
      wrex wa vw wex vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv
      vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab
      wrex wa vw wmo wa vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg
      cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw vz cv
      df-reu vw cv vz cv wcel vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0
      wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex wa
      vw eu5 bitri syl6ibr exp3a r19.21ai vz cv c0 wne vz cv vv cv wcel vw cv
      vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral vz cv c0 wne
      vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg cv vu cv vf cv
      cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw vz cv wreu wi vz vx cv
      wral vy vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vg cab vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv
      wrex vg cab vg cv vu cv vf cv cfv vu cv cpr wceq vu vx cv wrex vg cab vu
      vg vx cv vu cv vf cv cfv vu cv cpr vx visset abrexex vu cv c0 wne vg cv
      vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cv vu cv vf cv cfv vu
      cv cpr wceq vu vx cv wrex vg vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr
      wceq wa vg cv vu cv vf cv cfv vu cv cpr wceq vu vx cv vu cv c0 wne vg cv
      vu cv vf cv cfv vu cv cpr wceq pm3.27 r19.22si ss2abi ssexi vy cv vu cv
      c0 wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wceq
      vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv
      wreu wi vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne
      vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw vz
      cv wreu wi vz vx cv vy cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv cpr
      wceq wa vu vx cv wrex vg cab wceq vz cv vv cv wcel vw cv vv cv wcel wa vv
      vy cv wrex vw vz cv wreu vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0
      wne vg cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw
      vz cv wreu vz cv c0 wne vy cv vu cv c0 wne vg cv vu cv vf cv cfv vu cv
      cpr wceq wa vu vx cv wrex vg cab wceq vz cv vv cv wcel vw cv vv cv wcel
      wa vv vy cv wrex vz cv vv cv wcel vw cv vv cv wcel wa vv vu cv c0 wne vg
      cv vu cv vf cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab wrex vw vz cv
      vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv vu cv c0 wne vg cv vu cv vf
      cv cfv vu cv cpr wceq wa vu vx cv wrex vg cab rexeq1 reubidv imbi2d
      ralbidv cla4ev syl 19.23aiv 19.20i sylbi $.
      $( [30-Apr-2007] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x z f y w v u $.
    $( Equivalence of the Axiom of Choice (first form) of [Enderton] p. 49 and
       our Axiom of Choice (in the form of ~ ac2 ).  The proof does not depend
       AC on but does depend on the Axiom of Regularity. $)
    aceq7 $p |- ( A. x E. f ( f C_ x /\ f Fn dom x ) <->
                  A. x E. y A. z e. x A. w e. z E! v e. z E. u e. y
                      ( z e. u /\ v e. u ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vz cv c0 wne vz cv
      vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv
      wral vy wex vx wal vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv
      vz cv wreu vw vz cv wral vz vx cv wral vy wex vx wal vf cv vx cv wss vf
      cv vx cv cdm wfn wa vf wex vx wal vz cv c0 wne vz cv vv cv wcel vw cv vv
      cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral vy wex vx wal vx
      vy vz vw vv vf aceq6b vx vy vz vw vv vf aceq6a impbii vz cv vu cv wcel vv
      cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv wral vz vx cv wral
      vy wex vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy cv wrex vw
      vz cv wreu wi vz vx cv wral vy wex vx vx vy vz vw vv vu aceq2 albii
      bitr4i $.
      $( [26-Jun-2007] $) $( [5-Apr-2004] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZFC Set Theory - add the Axiom of Choice
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Introduce the Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u t $.
    $( Axiom of Choice.  The Axiom of Choice (AC) is usually considered an
       extension of ZF set theory rather than a proper part of it.  It is
       sometimes considered philosophically controversial because it asserts
       the existence of a set without telling us what the set is.  ZF set
       theory that includes AC is called ZFC.

       The unpublished version given here says that given any set ` x ` , there
       exists a ` y ` that is a collection of unordered pairs, one pair for
       each non-empty member of ` x ` .  One entry in the pair is the member of
       ` x ` , and the other entry is some arbitrary member of that member of
       ` x ` .  See the rewritten version ~ ac3 for a more detailed
       explanation.

       This version was specifically crafted to be short when expanded to
       primitives.  Kurt Maes' 5-quantifier version ~ ackm is slightly shorter
       when the biconditional of ~ ax-ac is expanded into implication and
       negation.

       Standard textbook versions of AC are derived as ~ ac8 , ~ ac5 , and
       ~ ac7 .  The Axiom of Regularity ~ ax-reg (among others) is used to
       derive our version from the standard ones; this reverse derivation is
       shown as theorem ~ aceq6b .  Equivalents to AC are the well-ordering
       theorem ~ weth and Zorn's lemma ~ zorn .  See ~ ac4 for comments about
       stronger versions of AC. $)
    ax-ac $a  |- E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u ( E. t
              ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) $.

    $( Axiom of Choice expressed with fewest number of different variables.
       The penultimate step shows the logical equivalence to ~ ax-ac . $)
    zfac $p  |- E. x A. y A. z ( ( y e. z /\ z e. w ) -> E. w A. y ( E. w
              ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) $=
      vy cv vz cv wcel vz cv vw cv wcel wa vu cv vz cv wcel vz cv vt cv wcel wa
      vu cv vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal
      vv wex wi vz wal vy wal vx wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv
      vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vx wex vw vx vy vz
      vv vu vt ax-ac vy cv vz cv wcel vz cv vw cv wcel wa vu cv vz cv wcel vz
      cv vt cv wcel wa vu cv vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv
      cv wceq wb vu wal vv wex wi vz wal vy wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vx
      vy cv vz cv wcel vz cv vw cv wcel wa vu cv vz cv wcel vz cv vt cv wcel wa
      vu cv vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal
      vv wex wi vy cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vz cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex wi vy vz vu cv vz cv wcel vz cv vt cv wcel wa vu cv
      vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal vv
      wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv wcel vz
      cv vw cv wcel wa vu cv vz cv wcel vz cv vt cv wcel wa vu cv vt cv wcel vt
      cv vx cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal vy cv vz cv wcel vz
      cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw
      cv wceq wb vy wal vv vw vv cv vw cv wceq vu cv vz cv wcel vz cv vt cv
      wcel wa vu cv vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv cv wceq
      wb vu wal vu cv vz cv wcel vz cv vw cv wcel wa vu cv vw cv wcel vw cv vx
      cv wcel wa wa vw wex vu cv vw cv wceq wb vu wal vy cv vz cv wcel vz cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vv cv vw cv wceq vu cv vz cv wcel vz cv vt cv wcel wa vu
      cv vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv cv wceq wb vu cv vz
      cv wcel vz cv vw cv wcel wa vu cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vu cv vw cv wceq wb vu vv cv vw cv wceq vu cv vz cv wcel vz cv vt cv
      wcel wa vu cv vt cv wcel vt cv vx cv wcel wa wa vt wex vu cv vv cv wceq
      wb vu cv vz cv wcel vz cv vt cv wcel wa vu cv vt cv wcel vt cv vx cv wcel
      wa wa vt wex vu cv vw cv wceq wb vu cv vz cv wcel vz cv vw cv wcel wa vu
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vu cv vw cv wceq wb vv cv vw
      cv wceq vu cv vv cv wceq vu cv vw cv wceq vu cv vz cv wcel vz cv vt cv
      wcel wa vu cv vt cv wcel vt cv vx cv wcel wa wa vt wex vv vw vu equequ2
      bibi2d vu cv vz cv wcel vz cv vt cv wcel wa vu cv vt cv wcel vt cv vx cv
      wcel wa wa vt wex vu cv vz cv wcel vz cv vw cv wcel wa vu cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vu cv vw cv wceq vu cv vz cv wcel vz cv vt
      cv wcel wa vu cv vt cv wcel vt cv vx cv wcel wa wa vu cv vz cv wcel vz cv
      vw cv wcel wa vu cv vw cv wcel vw cv vx cv wcel wa wa vt vw vt cv vw cv
      wceq vu cv vz cv wcel vz cv vt cv wcel wa vu cv vz cv wcel vz cv vw cv
      wcel wa vu cv vt cv wcel vt cv vx cv wcel wa vu cv vw cv wcel vw cv vx cv
      wcel wa vt cv vw cv wceq vz cv vt cv wcel vz cv vw cv wcel vu cv vz cv
      wcel vt vw vz elequ2 anbi2d vt cv vw cv wceq vu cv vt cv wcel vu cv vw cv
      wcel vt cv vx cv wcel vw cv vx cv wcel vt vw vu elequ2 vt vw vx elequ1
      anbi12d anbi12d cbvexv bibi1i syl6bb albidv vu cv vz cv wcel vz cv vw cv
      wcel wa vu cv vw cv wcel vw cv vx cv wcel wa wa vw wex vu cv vw cv wceq
      wb vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel
      wa wa vw wex vy cv vw cv wceq wb vu vy vu cv vy cv wceq vu cv vz cv wcel
      vz cv vw cv wcel wa vu cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv
      vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vu cv vw cv wceq vy cv vw cv wceq vu cv vy cv wceq vu cv vz cv wcel
      vz cv vw cv wcel wa vu cv vw cv wcel vw cv vx cv wcel wa wa vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw vu cv
      vy cv wceq vu cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vz cv vw
      cv wcel wa vu cv vw cv wcel vw cv vx cv wcel wa vy cv vw cv wcel vw cv vx
      cv wcel wa vu cv vy cv wceq vu cv vz cv wcel vy cv vz cv wcel vz cv vw cv
      wcel vu vy vz elequ1 anbi1d vu cv vy cv wceq vu cv vw cv wcel vy cv vw cv
      wcel vw cv vx cv wcel vu vy vw elequ1 anbi1d anbi12d exbidv vu vy vw
      equequ1 bibi12d cbvalv syl6bb cbvexv imbi2i 2albii exbii mpbi $.
      $( [14-Aug-2003] $)

    $( Axiom of Choice equivalent.  By using restricted quantifiers, we can
       express the Axiom of Choice with a single explicit conjunction.  (If you
       want to figure it out, the rewritten equivalent ~ ac3 is easier to
       understand.)  Note:  ~ aceq0 shows the logical equivalence to
       ~ ax-ac . $)
    ac2 $p |- E. y A. z e. x A. w e. z E! v e. z E. u e. y
              ( z e. u /\ v e. u ) $=
      vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv
      wral vz vx cv wral vy wex vz cv vw cv wcel vw cv vx cv wcel wa vu cv vw
      cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt
      wex vu cv vv cv wceq wb vu wal vv wex wi vw wal vz wal vy wex vx vy vz vw
      vv vu vt ax-ac vx vy vz vw vv vu vt aceq0 mpbir $.
      $( [18-Jul-1996] $)
  $}

  ${
    $d x y z w v u $.
    $( Axiom of Choice using abbreviations.  The logical equivalence to
       ~ ax-ac can be established by chaining ~ aceq0 and ~ aceq2 .  A standard
       textbook version of AC is derived from this one in ~ aceq6a , and this
       version of AC is derived from the textbook version in ~ aceq6b .

       The following sketch will help you understand this version of the axiom.
       Given any set ` x ` , the axiom says that there exists a ` y ` that is a
       collection of unordered pairs, one pair for each non-empty member of
       ` x ` .  One entry in the pair is the member of ` x ` , and the other
       entry is some arbitrary member of that member of ` x ` .  Using the
       Axiom of Regularity, we can show that ` y ` is really a set of _ordered_
       pairs, very similar to the ordered pair construction ~ opthreg .  The
       key theorem for this (used in the proof of ~ aceq6b ) is ~ preleq .
       With this modified definition of ordered pair, it can be seen that
       ` y ` is actually a choice function on the members of ` x ` .

       For example, suppose
       ` x = { { 1 , 2 } , { 1 , 3 } , { 2 , 3 } } ` . Take
       ` y = { { { 1 , 2 } , 1 } , { { 1 , 3 } , 1 } , { { 2 , 3 } , 2 } } ` .
       For the member (of ` x ` ) ` z = { 1 , 2 } ` , the only assignment
       to ` w ` and ` v ` that satisfies the axiom is ` w = 1 ` and
       ` v = { { 1 , 2 } , 1 } ` , so there is exactly one ` w ` as
       required.  We verify the other two members of ` x ` similarly.  Thus
       ` y ` satisfies the axiom.  Using our modified ordered pair definition,
       it is easy to see that ` y ` is the choice function
       ` { <. { 1 , 2 } , 1 >. , <. { 1 , 3 } , 1 >. , `
       ` <. { 2 , 3 } , 2 >. } ` .  Of course other choices for ` y ` will
       also satisfy the axiom, for example
       ` y = { { { 1 , 2 } , 2 } , { { 1 , 3 } , 1 } , { { 2 , 3 } , 3 } } ` .
       What AC tells us is that there exists at least one such ` y ` ,
       but it doesn't tell us which one. $)
    ac3 $p |- E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
              ( z e. v /\ w e. v ) ) $=
      vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv
      wral vz vx cv wral vy wex vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel
      wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral vy wex vx vy vz vw vv vu
      ac2 vx vy vz vw vv vu aceq2 mpbi $.
      $( [9-Apr-2007] $) $( [19-Jul-1996] $)
  $}

  ${
    $d f x y z w v u $.
    $( An Axiom of Choice equivalent similar to the Axiom of Choice (first
       form) of [Enderton] p. 49. $)
    ac7 $p |- E. f ( f C_ x /\ f Fn dom x ) $=
      vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv
      wral vz vx cv wral vy wex vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex
      vx vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz
      cv wral vz vx cv wral vy wex vx wal vf cv vx cv wss vf cv vx cv cdm wfn
      wa vf wex vx vz cv vu cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv
      wreu vw vz cv wral vz vx cv wral vy wex vx wal vz cv c0 wne vz cv vv cv
      wcel vw cv vv cv wcel wa vv vy cv wrex vw vz cv wreu wi vz vx cv wral vy
      wex vx wal vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vz cv vu
      cv wcel vv cv vu cv wcel wa vu vy cv wrex vv vz cv wreu vw vz cv wral vz
      vx cv wral vy wex vz cv c0 wne vz cv vv cv wcel vw cv vv cv wcel wa vv vy
      cv wrex vw vz cv wreu wi vz vx cv wral vy wex vx vx vy vz vw vv vu aceq2
      albii vx vy vz vw vv vf aceq6a sylbi 19.21bi vx vy vz vw vv vu ac2 mpg $.
      $( [7-Mar-2007] $) $( [29-Apr-2004] $)
  $}

  ${
    $d f x R $.
    $( An Axiom of Choice equivalent similar to the Axiom of Choice (first
       form) of [Enderton] p. 49. $)
    ac7g $p |- ( R e. A -> E. f ( f C_ R /\ f Fn dom R ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vf cv cR wss vf cv cR cdm
      wfn wa vf wex vx cR cA vx cv cR wceq vf cv vx cv wss vf cv vx cv cdm wfn
      wa vf cv cR wss vf cv cR cdm wfn wa vf vx cv cR wceq vf cv vx cv wss vf
      cv cR wss vf cv vx cv cdm wfn vf cv cR cdm wfn vx cv cR vf cv sseq2 vx cv
      cR wceq vx cv cdm cR cdm wceq vf cv vx cv cdm wfn vf cv cR cdm wfn wb vx
      cv cR dmeq vx cv cdm cR cdm vf cv fneq2 syl anbi12d exbidv vx vf ac7
      vtoclg $.
      $( [30-Jul-2004] $) $( [23-Jul-2004] $)
  $}

  ${
    $d x z f $.
    $( Equivalent of Axiom of Choice.  We do not insist that ` f ` be a
       function.  However, theorem ~ ac5 , derived from this one, shows that
       this form of the axiom does imply that at least one such set ` f ` whose
       existence we assert is in fact a function.  Axiom of Choice of
       [TakeutiZaring] p. 83.

       Takeuti and Zaring call this "weak choice" in contrast to "strong
       choice" ` E. F A. z ( z =/= (/) -> ( F `` z ) e. z ) ` , which asserts
       the existence of a universal choice function but requires second-order
       quantification on (proper) class variable ` F ` and thus cannot be
       expressed in our first-order formalization.  However, it has been shown
       that ZF plus strong choice is a conservative extension of ZF plus weak
       choice.  See Ulrich Felgner, "Comparison of the axioms of local and
       universal choice," _Fundamenta Mathematica_, 71, 43-62 (1971).

       Weak choice can be strengthened in a different direction to choose from
       a collection of proper classes; see ~ ac6s5 . $)
    ac4 $p |- E. f A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) $=
      vz cv c0 wne vz cv vf cv cfv vz cv wcel wi vz vx cv wral vf wex vx vf cv
      vx cv wss vf cv vx cv cdm wfn wa vf wex vz cv c0 wne vz cv vf cv cfv vz
      cv wcel wi vz vx cv wral vf wex vx wal vx vx vz vf aceq3 vx vf ac7 mpgbi
      a4i $.
      $( [30-Mar-2008] $) $( [21-Jul-1996] $)
  $}

  ${
    $d x y f A $.
    ac4c.1 $e |- A e. _V $.
    $( Equivalent of Axiom of Choice (class version) $)
    ac4c $p |- E. f A. x e. A ( x =/= (/) -> ( f ` x ) e. x ) $=
      vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv wral vf wex vx cv c0
      wne vx cv vf cv cfv vx cv wcel wi vx cA wral vf wex vy cA ac4c.1 vy cv cA
      wceq vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv wral vx cv c0
      wne vx cv vf cv cfv vx cv wcel wi vx cA wral vf vx cv c0 wne vx cv vf cv
      cfv vx cv wcel wi vx vy cv cA raleq1 exbidv vy vx vf ac4 vtocl $.
      $( [3-May-2007] $) $( [10-Feb-1997] $)
  $}

  ${
    $d f x y A $.
    ac5.1 $e |- A e. _V $.
    $( An Axiom of Choice equivalent:  there exists a function ` f ` (called a
       choice function) with domain ` A ` that maps each nonempty member of the
       domain to an element of that member.  Axiom AC of [BellMachover] p. 488.
       Note that the assertion that ` f ` be a function is not necessary;
       see ~ ac4 . $)
    ac5 $p |- E. f ( f Fn A /\ A. x e. A ( x =/= (/) -> ( f ` x ) e. x ) ) $=
      vf cv vy cv wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv wral
      wa vf wex vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA
      wral wa vf wex vy cA ac5.1 vy cv cA wceq vf cv vy cv wfn vx cv c0 wne vx
      cv vf cv cfv vx cv wcel wi vx vy cv wral wa vf cv cA wfn vx cv c0 wne vx
      cv vf cv cfv vx cv wcel wi vx cA wral wa vf vy cv cA wceq vf cv vy cv wfn
      vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv wral vx
      cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA wral vy cv cA vf cv fneq2
      vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv cA raleq1 anbi12d
      exbidv vf cv vy cv wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy
      cv wral wa vf wex vy vf cv vy cv wss vf cv vy cv cdm wfn wa vf wex vy wal
      vf cv vy cv wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv wral
      wa vf wex vy wal vf cv vy cv wss vf cv vy cv cdm wfn wa vf wex vy wal vx
      cv c0 wne vx cv vf cv cfv vx cv wcel wi vx vy cv wral vf wex vy vy vx vf
      aceq3 vy vx vf ac4 mpgbir vy vx vf aceq4 mpbi a4i vtocl $.
      $( [25-Apr-2007] $) $( [29-Aug-1999] $)
  $}

  ${
    $d x f A $.
    ac5b.1 $e |- A e. _V $.
    $( Equivalent of Axiom of Choice. $)
    ac5b $p |- ( A. x e. A x =/= (/) ->
               E. f ( f : A --> U. A /\ A. x e. A ( f ` x ) e. x ) ) $=
      vx cv c0 wne vx cA wral vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv
      wcel wi vx cA wral wa vf wex cA cA cuni vf cv wf vx cv vf cv cfv vx cv
      wcel vx cA wral wa vf wex vx cA vf ac5b.1 ac5 vx cv c0 wne vx cA wral vf
      cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA wral wa vf wex
      wa vx cv c0 wne vx cA wral vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx
      cv wcel wi vx cA wral wa wa vf wex cA cA cuni vf cv wf vx cv vf cv cfv vx
      cv wcel vx cA wral wa vf wex vx cv c0 wne vx cA wral vf cv cA wfn vx cv
      c0 wne vx cv vf cv cfv vx cv wcel wi vx cA wral wa vf 19.42v vx cv c0 wne
      vx cA wral vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA
      wral wa wa cA cA cuni vf cv wf vx cv vf cv cfv vx cv wcel vx cA wral wa
      vf vf cv cA wfn vx cv c0 wne vx cA wral vx cv c0 wne vx cv vf cv cfv vx
      cv wcel wi vx cA wral cA cA cuni vf cv wf vx cv vf cv cfv vx cv wcel vx
      cA wral wa vf cv cA wfn vx cv vf cv cfv vx cv wcel vx cA wral cA cA cuni
      vf cv wf vx cv vf cv cfv vx cv wcel vx cA wral wa vx cv c0 wne vx cA wral
      vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA wral wa vf cv cA wfn vx
      cv vf cv cfv vx cv wcel vx cA wral cA cA cuni vf cv wf vf cv cA wfn vx cv
      vf cv cfv vx cv wcel vx cA wral vf cv cA wfn vf cv crn cA cuni wss wa cA
      cA cuni vf cv wf vf cv cA wfn vx cv vf cv cfv vx cv wcel vx cA wral vf cv
      crn cA cuni wss vf cv cA wfn vx cv vf cv cfv vx cv wcel vx cA wral vf cv
      crn cA cuni wss vx cA vf cv chfnrn ex anc2li cA cA cuni vf cv df-f
      syl6ibr impac vx cv c0 wne vx cA wral vx cv c0 wne vx cv vf cv cfv vx cv
      wcel wi vx cA wral wa vx cv c0 wne vx cv c0 wne vx cv vf cv cfv vx cv
      wcel wi wa vx cA wral vx cv vf cv cfv vx cv wcel vx cA wral vx cv c0 wne
      vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA r19.26 vx cv c0 wne vx
      cv c0 wne vx cv vf cv cfv vx cv wcel wi wa vx cv vf cv cfv vx cv wcel vx
      cA vx cv c0 wne vx cv vf cv cfv vx cv wcel pm3.35 r19.20si sylbir sylan2
      an1s 19.22i sylbir mpan2 $.
      $( [30-Apr-2007] $) $( [31-Aug-1999] $)
  $}

  ${
    $d f g x y z w A $.  $d f g x y z w B $.  $d ph z w f $.  $d y ps $.
    ac6.1 $e |- A e. _V $.
    ac6.2 $e |- B e. _V $.
    ${
      $d z f g C $.  $d z f g H $.
      ac6lem.4 $e |- C = { y e. B | ph } $.
      ac6lem.5 $e |- H = { <. x , z >. | ( x e. A /\ z = C ) } $.
      $( Lemma for ~ ac6 . $)
      ac6lem $p |- ( A. x e. A E. y e. B ph ->
                   E. f ( f : A --> B /\ A. x e. A ( f ` x ) e. C ) ) $=
        wph vy cB wrex vx cA wral vz cv c0 wne vz cH crn wral cH crn cH crn
        cuni vg cv wf vz cv vg cv cfv vz cv wcel vz cH crn wral wa vg wex cA cB
        vf cv wf vx cv vf cv cfv cC wcel vx cA wral wa vf wex wph vy cB wrex vx
        cA wral vz cv c0 wne vz cH crn wph vy cB wrex vx cA wral vz cv cC wceq
        vx cA wrex vz cv c0 wne vz cv cH crn wcel wph vy cB wrex vx cA wral vz
        cv cC wceq vz cv c0 wne wi vx cA wral vz cv cC wceq vx cA wrex vz cv c0
        wne wi wph vy cB wrex vz cv cC wceq vz cv c0 wne wi vx cA vz cv cC wceq
        vz cv c0 wne wph vy cB wrex vz cv cC wceq vz cv c0 wne wph vy cB crab
        c0 wne wph vy cB wrex vz cv cC wceq vz cv wph vy cB crab c0 vz cv cC
        wceq vz cv wph vy cB crab wceq cC wph vy cB crab vz cv ac6lem.4 eqeq2i
        biimpi neeq1d wph vy cB rabn0 syl6bb biimprcd r19.20si vz cv cC wceq vz
        cv c0 wne vx cA r19.23v sylib vz cv vx cv cA wcel vz cv cC wceq wa vx
        wex vz cab wcel vx cv cA wcel vz cv cC wceq wa vx wex vz cv cH crn wcel
        vz cv cC wceq vx cA wrex vx cv cA wcel vz cv cC wceq wa vx wex vz abid
        cH crn vx cv cA wcel vz cv cC wceq wa vx wex vz cab vz cv cH crn vx cv
        cA wcel vz cv cC wceq wa vx vz copab crn vx cv cA wcel vz cv cC wceq wa
        vx wex vz cab cH vx cv cA wcel vz cv cC wceq wa vx vz copab ac6lem.5
        rneqi vx cv cA wcel vz cv cC wceq wa vx vz rnopab eqtri eleq2i vz cv cC
        wceq vx cA df-rex 3bitr4i syl5ib r19.21aiv vz cH crn vg cH cH cA wfn cA
        cvv wcel cH cvv wcel vx vz cA cC cH cC wph vy cB crab cvv ac6lem.4 wph
        vy cB ac6.2 rabex eqeltri ac6lem.5 fnopab2 ac6.1 cA cvv cH fnex mp2an
        rnex ac5b cH crn cH crn cuni vg cv wf vz cv vg cv cfv vz cv wcel vz cH
        crn wral wa cA cB vf cv wf vx cv vf cv cfv cC wcel vx cA wral wa vf wex
        vg cH crn cH crn cuni vg cv wf vz cv vg cv cfv vz cv wcel vz cH crn
        wral wa cA cB vg cv cH ccom wf vx cv vg cv cH ccom cfv cC wcel vx cA
        wral wa cA cB vf cv wf vx cv vf cv cfv cC wcel vx cA wral wa vf wex cH
        crn cB vg cv wf vz cv vg cv cfv vz cv wcel vz cH crn wral cA cB vg cv
        cH ccom wf vx cv vg cv cH ccom cfv cC wcel vx cA wral wa cH crn cH crn
        cuni vg cv wf cH crn cB vg cv wf vz cv vg cv cfv vz cv wcel vz cH crn
        wral wa cA cB vg cv cH ccom wf vx cv vg cv cH ccom cfv cC wcel vx cA
        wral cH crn cB vg cv wf cA cB vg cv cH ccom wf vz cv vg cv cfv vz cv
        wcel vz cH crn wral cH crn cB vg cv wf cA cH crn cH wf cA cB vg cv cH
        ccom wf cH cA wfn cA cH crn cH wf vx vz cA cC cH cC wph vy cB crab cvv
        ac6lem.4 wph vy cB ac6.2 rabex eqeltri ac6lem.5 fnopab2 cA cH dffn3
        mpbi cA cH crn cB vg cv cH fco mpan2 adantr vg cv wfun vz cv vg cv cfv
        vz cv wcel vz cH crn wral vx cv vg cv cH ccom cfv cC wcel vx cA wral cH
        crn cB vg cv wf vg cv wfun vz cv vg cv cfv vz cv wcel vz cH crn wral wa
        vx cv vg cv cH ccom cfv cC wcel vx cA vg cv wfun vz cv vg cv cfv vz cv
        wcel vz cH crn wral vx vg cv wfun vx ax-17 vz cv vg cv cfv vz cv wcel
        vx vz cH crn vx vz cH vx vz cH vx cv cA wcel vz cv cC wceq wa vx vz
        copab ac6lem.5 vx cv cA wcel vz cv cC wceq wa vx vz vz hbopab1 hbxfr
        hbrn vz cv vg cv cfv vz cv wcel vx ax-17 hbral hban vg cv wfun vz cv vg
        cv cfv vz cv wcel vz cH crn wral wa vx cv cA wcel vx cv vg cv cH ccom
        cfv cC wcel vg cv wfun vz cv vg cv cfv vz cv wcel vz cH crn wral wa vx
        cv cA wcel wa vx cv vg cv cH ccom cfv cC wcel cC vg cv cfv cC wcel vz
        cv vg cv cfv vz cv wcel vz cH crn wral vx cv cA wcel cC vg cv cfv cC
        wcel vg cv wfun vx cv cA wcel vz cv vg cv cfv vz cv wcel vz cH crn wral
        cC vg cv cfv cC wcel vx cv cA wcel cC cH crn wcel vz cv vg cv cfv vz cv
        wcel vz cH crn wral cC vg cv cfv cC wcel wi vx cv cA wcel cC cH crn
        wcel wi vz cC cC wph vy cB crab cvv ac6lem.4 wph vy cB ac6.2 rabex
        eqeltri vz cv cC wceq vx cv cA wcel vz cv cH crn wcel cC cH crn wcel vx
        cv cA wcel vz cv cC wceq vz cv cH crn wcel vx cv cA wcel vz cv cC wceq
        wa vx cv cA wcel vz cv cC wceq wa vx wex vz cv cH crn wcel vx cv cA
        wcel vz cv cC wceq wa vx 19.8a vx cv cA wcel vz cv cC wceq wa vx wex vz
        cH crn cH crn vx cv cA wcel vz cv cC wceq wa vx vz copab crn vx cv cA
        wcel vz cv cC wceq wa vx wex vz cab cH vx cv cA wcel vz cv cC wceq wa
        vx vz copab ac6lem.5 rneqi vx cv cA wcel vz cv cC wceq wa vx vz rnopab
        eqtri abeq2i sylibr expcom vz cv cC cH crn eleq1 sylibd vtocle vz cv vg
        cv cfv vz cv wcel cC vg cv cfv cC wcel vz cC cH crn vz cv cC wceq vz cv
        vg cv cfv cC vg cv cfv vz cv cC vz cv cC vg cv fveq2 vz cv cC wceq id
        eleq12d rcla4v syl impcom adantll vg cv wfun vx cv cA wcel vx cv vg cv
        cH ccom cfv cC wcel cC vg cv cfv cC wcel wb vz cv vg cv cfv vz cv wcel
        vz cH crn wral vg cv wfun vx cv cA wcel wa vx cv vg cv cH ccom cfv cC
        vg cv cfv cC vg cv wfun vx cv cA wcel wa vx cv vg cv cH ccom cfv vx cv
        cH cfv vg cv cfv cC vg cv cfv vg cv wfun vx cv cH cdm wcel vx cv vg cv
        cH ccom cfv vx cv cH cfv vg cv cfv wceq vx cv cA wcel vg cv wfun cH
        wfun vx cv cH cdm wcel vx cv vg cv cH ccom cfv vx cv cH cfv vg cv cfv
        wceq cH cA wfn cH wfun vx vz cA cC cH cC wph vy cB crab cvv ac6lem.4
        wph vy cB ac6.2 rabex eqeltri ac6lem.5 fnopab2 cA cH fnfun ax-mp vx cv
        vg cv cH fvco mp3an2 cH cdm cA vx cv vx vz cA cC cH cC wph vy cB crab
        cvv ac6lem.4 wph vy cB ac6.2 rabex eqeltri ac6lem.5 dmopab2 eleq2i
        sylan2br vx cv cA wcel vx cv cH cfv vg cv cfv cC vg cv cfv wceq vg cv
        wfun vx cv cA wcel vx cv cH cfv cC vg cv vx cv cA wcel vx cv vx cv cA
        wcel vz cv cC wceq wa vx vz copab cfv cC vx cv cH cfv vx cv cA wcel cC
        cvv wcel vx cv vx cv cA wcel vz cv cC wceq wa vx vz copab cfv cC wceq
        cC wph vy cB crab cvv ac6lem.4 wph vy cB ac6.2 rabex eqeltri vx vz cA
        cC cvv fvopab2 mpan2 vx cv cH vx cv cA wcel vz cv cC wceq wa vx vz
        copab ac6lem.5 fveq1i syl5eq fveq2d adantl eqtrd eleq1d adantlr mpbird
        ex r19.21ai cH crn cB vg cv ffun sylan jca cH crn cH crn cuni vg cv wf
        cH crn cuni cB wss cH crn cB vg cv wf cH crn cuni cB wss vz cv cB wss
        vz cH crn vz cH crn cB unissb vz cv cH crn wcel vz cv cC wceq vx cA
        wrex vz cv cB wss vz cv vx cv cA wcel vz cv cC wceq wa vx wex vz cab
        wcel vx cv cA wcel vz cv cC wceq wa vx wex vz cv cH crn wcel vz cv cC
        wceq vx cA wrex vx cv cA wcel vz cv cC wceq wa vx wex vz abid cH crn vx
        cv cA wcel vz cv cC wceq wa vx wex vz cab vz cv cH crn vx cv cA wcel vz
        cv cC wceq wa vx vz copab crn vx cv cA wcel vz cv cC wceq wa vx wex vz
        cab cH vx cv cA wcel vz cv cC wceq wa vx vz copab ac6lem.5 rneqi vx cv
        cA wcel vz cv cC wceq wa vx vz rnopab eqtri eleq2i vz cv cC wceq vx cA
        df-rex 3bitr4i vz cv cC wceq vz cv cB wss vx cA vz cv cC wceq vz cv cB
        wss wi vx cv cA wcel vz cv cC wceq vz cv cB wss cC cB wss cC wph vy cB
        crab cB ac6lem.4 wph vy cB ssrab2 eqsstri vz cv cC cB sseq1 mpbiri a1i
        r19.23aiv sylbi mprgbir cH crn cH crn cuni cB vg cv fss mpan2 sylan cA
        cB vf cv wf vx cv vf cv cfv cC wcel vx cA wral wa cA cB vg cv cH ccom
        wf vx cv vg cv cH ccom cfv cC wcel vx cA wral wa vf vg cv cH ccom vg cv
        cH vg visset cH cA wfn cA cvv wcel cH cvv wcel vx vz cA cC cH cC wph vy
        cB crab cvv ac6lem.4 wph vy cB ac6.2 rabex eqeltri ac6lem.5 fnopab2
        ac6.1 cA cvv cH fnex mp2an coex vf cv vg cv cH ccom wceq cA cB vf cv wf
        cA cB vg cv cH ccom wf vx cv vf cv cfv cC wcel vx cA wral vx cv vg cv
        cH ccom cfv cC wcel vx cA wral cA cB vf cv vg cv cH ccom feq1 vf cv vg
        cv cH ccom wceq vx cv vf cv cfv cC wcel vx cv vg cv cH ccom cfv cC wcel
        vx cA vx vf vg cv cH ccom vx vf vg cv cH vf cv vg cv wcel vx ax-17 vx
        vf cH vx cv cA wcel vz cv cC wceq wa vx vz copab ac6lem.5 vx cv cA wcel
        vz cv cC wceq wa vx vz vf hbopab1 hbxfr hbco hbeleq vf cv vg cv cH ccom
        wceq vx cv vf cv cfv vx cv vg cv cH ccom cfv cC vx cv vf cv vg cv cH
        ccom fveq1 eleq1d ralbid anbi12d cla4ev syl 19.23aiv 3syl $.
        $( [18-Oct-1999] $)
    $}

    ${
      ac6.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
      $( Equivalent of Axiom of Choice.  This is useful for proving that there
         exists, for example, a sequence mapping natural numbers to members of
         a larger set ` B ` , where ` ph ` depends on ` x ` (the
         natural number) and ` y ` (to specify a member of ` B ` ).  A stronger
         version of this theorem, ~ ac6s , allows ` B ` to be a proper
         class. $)
      ac6 $p |- ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
        wph vy cB wrex vx cA wral cA cB vf cv wf vx cv vf cv cfv wph vy cB crab
        wcel vx cA wral wa vf wex cA cB vf cv wf wps vx cA wral wa vf wex wph
        vx vy vz cA cB wph vy cB crab vf vx cv cA wcel vw cv wph vy cB crab
        wceq wa vx vw copab ac6.1 ac6.2 wph vy cB crab eqid vx cv cA wcel vw cv
        wph vy cB crab wceq wa vx cv cA wcel vz cv wph vy cB crab wceq wa vx vw
        vz vw cv vz cv wceq vw cv wph vy cB crab wceq vz cv wph vy cB crab wceq
        vx cv cA wcel vw cv vz cv wph vy cB crab eqeq1 anbi2d cbvopab2v ac6lem
        cA cB vf cv wf vx cv vf cv cfv wph vy cB crab wcel vx cA wral wa cA cB
        vf cv wf wps vx cA wral wa vf vx cv vf cv cfv wph vy cB crab wcel vx cA
        wral wps vx cA wral cA cB vf cv wf vx cv vf cv cfv wph vy cB crab wcel
        wps vx cA vx cv vf cv cfv wph vy cB crab wcel vx cv vf cv cfv cB wcel
        wps wph wps vy vx cv vf cv cfv cB ac6.3 elrab pm3.27bi r19.20si anim2i
        19.22i syl $.
        $( [18-Oct-1999] $)
    $}
  $}

  ${
    $d x y f z A $.  $d x y f z B $.  $d f z ph $.  $d y z ps $.
    ac6s.1 $e |- A e. _V $.
    ac6s.2 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Equivalent of Axiom of Choice.  Using the Boundedness Axiom ~ bnd2 ,
       we derive this strong version of ~ ac6 that doesn't require ` B ` to be
       a set. $)
    ac6s $p |- ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      wph vy cB wrex vx cA wral vz cv cB wss wph vy vz cv wrex vx cA wral wa vz
      wex cA cB vf cv wf wps vx cA wral wa vf wex wph vx vy vz cA cB ac6s.1
      bnd2 vz cv cB wss wph vy vz cv wrex vx cA wral wa vz wex vz cv cB wss cA
      vz cv vf cv wf wps vx cA wral wa vf wex wa vz wex cA cB vf cv wf wps vx
      cA wral wa vf wex vz cv cB wss wph vy vz cv wrex vx cA wral wa vz cv cB
      wss cA vz cv vf cv wf wps vx cA wral wa vf wex wa vz wph vy vz cv wrex vx
      cA wral cA vz cv vf cv wf wps vx cA wral wa vf wex vz cv cB wss wph wps
      vx vy cA vz cv vf ac6s.1 vz visset ac6s.2 ac6 anim2i 19.22i vz cv cB wss
      cA vz cv vf cv wf wps vx cA wral wa vf wex wa cA cB vf cv wf wps vx cA
      wral wa vf wex vz vz cv cB wss cA vz cv vf cv wf wps vx cA wral wa vf wex
      cA cB vf cv wf wps vx cA wral wa vf wex vz cv cB wss cA vz cv vf cv wf
      wps vx cA wral wa cA cB vf cv wf wps vx cA wral wa vf vz cv cB wss cA vz
      cv vf cv wf cA cB vf cv wf wps vx cA wral cA vz cv vf cv wf vz cv cB wss
      cA cB vf cv wf cA vz cv cB vf cv fss expcom anim1d 19.22dv imp 19.23aiv
      syl syl $.
      $( [17-Aug-2004] $) $( [4-Feb-2004] $)

    $( Equivalent of Axiom of Choice.  Contrapositive of ~ ac6s . $)
    ac6n $p |- ( A. f ( f : A --> B -> E. x e. A ps ) ->
                E. x e. A A. y e. B ph ) $=
      cA cB vf cv wf wps wn vx cA wral wa vf wex wn wph wn vy cB wrex vx cA
      wral wn cA cB vf cv wf wps vx cA wrex wi vf wal wph vy cB wral vx cA wrex
      wph wn vy cB wrex vx cA wral cA cB vf cv wf wps wn vx cA wral wa vf wex
      wph wn wps wn vx vy cA cB vf ac6s.1 vy cv vx cv vf cv cfv wceq wph wps
      ac6s.2 notbid ac6s con3i cA cB vf cv wf wps vx cA wrex wi vf wal cA cB vf
      cv wf wps wn vx cA wral wn wi vf wal cA cB vf cv wf wps wn vx cA wral wa
      vf wex wn cA cB vf cv wf wps vx cA wrex wi cA cB vf cv wf wps wn vx cA
      wral wn wi vf wps vx cA wrex wps wn vx cA wral wn cA cB vf cv wf wps vx
      cA dfrex2 imbi2i albii cA cB vf cv wf wps wn vx cA wral vf alinexa bitri
      wph vy cB wral vx cA wrex wph wn vy cB wrex wn vx cA wrex wph wn vy cB
      wrex vx cA wral wn wph vy cB wral wph wn vy cB wrex wn vx cA wph vy cB
      dfral2 rexbii wph wn vy cB wrex vx cA rexnal bitri 3imtr4i $.
      $( [10-Jun-2007] $) $( [10-Jun-2007] $)

    $( Generalization of the Axiom of Choice to classes.  Slightly strengthened
       version of ~ ac6s3 . $)
    ac6s2 $p |- ( A. x e. A E. y ph -> E. f ( f Fn A /\ A. x e. A ps ) ) $=
      wph vy wex vx cA wral wph vy cvv wrex vx cA wral vf cv cA wfn wps vx cA
      wral wa vf wex wph vy cvv wrex wph vy wex vx cA wph vy rexv ralbii wph vy
      cvv wrex vx cA wral cA cvv vf cv wf wps vx cA wral wa vf wex vf cv cA wfn
      wps vx cA wral wa vf wex wph wps vx vy cA cvv vf ac6s.1 ac6s.2 ac6s cA
      cvv vf cv wf wps vx cA wral wa vf cv cA wfn wps vx cA wral wa vf cA cvv
      vf cv wf vf cv cA wfn wps vx cA wral cA cvv vf cv ffn anim1i 19.22i syl
      sylbir $.
      $( [30-Sep-2006] $) $( [29-Sep-2006] $)

    $( Generalization of the Axiom of Choice to classes.  Theorem 10.46 of
       [TakeutiZaring] p. 97. $)
    ac6s3 $p |- ( A. x e. A E. y ph -> E. f A. x e. A ps ) $=
      wph vy wex vx cA wral vf cv cA wfn wps vx cA wral wa vf wex wps vx cA
      wral vf wex wph wps vx vy cA vf ac6s.1 ac6s.2 ac6s2 vf cv cA wfn wps vx
      cA wral wa wps vx cA wral vf vf cv cA wfn wps vx cA wral pm3.27 19.22i
      syl $.
      $( [17-Nov-2004] $) $( [3-Nov-2004] $)
  $}

  ${
    $d f x z A $.  $d x y f z B $.  $d f z ph $.  $d z ps $.
    ac6sf.1 $e |- ( ps -> A. y ps ) $.
    ac6sf.2 $e |- A e. _V $.
    ac6sf.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Version of ~ ac6 with bound-variable hypothesis. $)
    ac6sf $p |- ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      wph vy cB wrex vx cA wral wph vy vz cv wsbc vz cB wrex vx cA wral cA cB
      vf cv wf wps vx cA wral wa vf wex wph vy cB wrex wph vy vz cv wsbc vz cB
      wrex vx cA wph vy vz cB cbvrexsv ralbii wph vy vz cv wsbc wps vx vz cA cB
      vf ac6sf.2 wph wps vy vz vx cv vf cv cfv ac6sf.1 ac6sf.3 sbhypf ac6s
      sylbi $.
      $( [5-Mar-2008] $) $( [2-Mar-2008] $)
  $}

  ${
    $d f x y A $.  $d f y B $.
    ac6s4.1 $e |- A e. _V $.
    $( Generalization of the Axiom of Choice to proper classes.  ` B ` is a
       collection ` B ( x ) ` of nonempty, possible proper classes. $)
    ac6s4 $p |- ( A. x e. A B =/= (/) ->
               E. f ( f Fn A /\ A. x e. A ( f ` x ) e. B ) ) $=
      cB c0 wne vx cA wral vy cv cB wcel vy wex vx cA wral vf cv cA wfn vx cv
      vf cv cfv cB wcel vx cA wral wa vf wex cB c0 wne vy cv cB wcel vy wex vx
      cA vy cB n0 ralbii vy cv cB wcel vx cv vf cv cfv cB wcel vx vy cA vf
      ac6s4.1 vy cv vx cv vf cv cfv cB eleq1 ac6s2 sylbi $.
      $( [1-Oct-2006] $) $( [29-Sep-2006] $)

    $( Generalization of the Axiom of Choice to proper classes.  ` B ` is a
       collection ` B ( x ) ` of nonempty, possible proper classes.  Remark
       after Theorem 10.46 of [TakeutiZaring] p. 98. $)
    ac6s5 $p |- ( A. x e. A B =/= (/) -> E. f A. x e. A ( f ` x ) e. B ) $=
      cB c0 wne vx cA wral vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa
      vf wex vx cv vf cv cfv cB wcel vx cA wral vf wex vx cA cB vf ac6s4.1
      ac6s4 vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vx cv vf cv cfv
      cB wcel vx cA wral vf vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral
      pm3.27 19.22i syl $.
      $( [19-Nov-2006] $) $( [27-Mar-2006] $)
  $}

  ${
    $d x z y w v f $.
    $( An Axiom of Choice equivalent.  Given a family ` x ` of mutually
       disjoint nonempty sets, there exists a set ` y ` containing exactly
       one member from each set in the family.  Theorem 6M(4) of [Enderton]
       p. 151. $)
    ac8 $p |- ( ( A. z e. x z =/= (/) /\
                   A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
               E. y A. z e. x E! v v e. ( z i^i y ) ) $=
      vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw
      vx cv wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv
      wral vy wex wi vx vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vz cv c0
      wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv
      wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy
      wex wi vx wal vx vx vy vz vw vv vf aceq5 vx vf ac7 mpgbi a4i $.
      $( [22-Apr-2007] $) $( [14-May-2004] $)
  $}

  ${
    $d f x A $.  $d f B $.
    ac9.1 $e |- A e. _V $.
    $( An Axiom of Choice equivalent:  the infinite Cartesian product of
       nonempty classes is nonempty.  Axiom of Choice (second form) of
       [Enderton] p. 55 and its converse.  This is a stronger version of the
       axiom in Enderton, with no existence requirement for the family of
       classes ` B ( x ) ` (achieved via the Collection Principle ~ cp ). $)
    ac9s $p |- ( A. x e. A B =/= (/) <-> X_ x e. A B =/= (/) ) $=
      cB c0 wne vx cA wral vx cA cB cixp c0 wne cB c0 wne vx cA wral vf cv cA
      wfn vx cv vf cv cfv cB wcel vx cA wral wa vf wex vx cA cB cixp c0 wne vx
      cA cB vf ac9.1 ac6s4 vx cA cB cixp c0 wne vf cv vx cA cB cixp wcel vf wex
      vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vf wex vf vx cA cB
      cixp n0 vf cv vx cA cB cixp wcel vf cv cA wfn vx cv vf cv cfv cB wcel vx
      cA wral wa vf vx cA cB vf cv vf visset elixp exbii bitr2i sylib vx cA cB
      cixp c0 wceq wn cB c0 wceq vx cA wrex wn vx cA cB cixp c0 wne cB c0 wne
      vx cA wral cB c0 wceq vx cA wrex vx cA cB cixp c0 wceq vx cA cB ixp0
      con3i vx cA cB cixp c0 df-ne cB c0 wne vx cA wral cB c0 wceq wn vx cA
      wral cB c0 wceq vx cA wrex wn cB c0 wne cB c0 wceq wn vx cA cB c0 df-ne
      ralbii cB c0 wceq vx cA ralnex bitri 3imtr4i impbii $.
      $( [1-Oct-2006] $) $( [29-Sep-2006] $)
  $}

  ${
    $d v A $.  $d u v x y ph $.  $d ps x v $.  $d u v w x y z $.
    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, 1 => 2. $)
    kmlem1 $p |- ( A. x ( ( A. z e. x z =/= (/) /\ A. z e. x A. w e. x ph ) ->
                 E. y A. z e. x ps ) -> A. x ( A. z e. x A. w e. x ph ->
                   E. y A. z e. x ( z =/= (/) -> ps ) ) ) $=
      vz cv c0 wne vz vx cv wral wph vw vx cv wral vz vx cv wral wa wps vz vx
      cv wral vy wex wi vx wal wph vw vv cv wral vz vv cv wral vz cv c0 wne wps
      wi vz vv cv wral vy wex wi vv wal wph vw vx cv wral vz vx cv wral vz cv
      c0 wne wps wi vz vx cv wral vy wex wi vx wal vz cv c0 wne vz vx cv wral
      wph vw vx cv wral vz vx cv wral wa wps vz vx cv wral vy wex wi vx wal vz
      cv c0 wne vz vu cv c0 wne vu vv cv crab wral wph vw vu cv c0 wne vu vv cv
      crab wral vz vu cv c0 wne vu vv cv crab wral wa wps vz vu cv c0 wne vu vv
      cv crab wral vy wex wi vv wal wph vw vv cv wral vz vv cv wral vz cv c0
      wne wps wi vz vv cv wral vy wex wi vv wal vz cv c0 wne vz vx cv wral wph
      vw vx cv wral vz vx cv wral wa wps vz vx cv wral vy wex wi vx wal vz cv
      c0 wne vz vu cv c0 wne vu vv cv crab wral wph vw vu cv c0 wne vu vv cv
      crab wral vz vu cv c0 wne vu vv cv crab wral wa wps vz vu cv c0 wne vu vv
      cv crab wral vy wex wi vv vz cv c0 wne vz vx cv wral wph vw vx cv wral vz
      vx cv wral wa wps vz vx cv wral vy wex wi vz cv c0 wne vz vu cv c0 wne vu
      vv cv crab wral wph vw vu cv c0 wne vu vv cv crab wral vz vu cv c0 wne vu
      vv cv crab wral wa wps vz vu cv c0 wne vu vv cv crab wral vy wex wi vx vu
      cv c0 wne vu vv cv crab vu cv c0 wne vu vv cv vv visset rabex vx cv vu cv
      c0 wne vu vv cv crab wceq vz cv c0 wne vz vx cv wral wph vw vx cv wral vz
      vx cv wral wa vz cv c0 wne vz vu cv c0 wne vu vv cv crab wral wph vw vu
      cv c0 wne vu vv cv crab wral vz vu cv c0 wne vu vv cv crab wral wa wps vz
      vx cv wral vy wex wps vz vu cv c0 wne vu vv cv crab wral vy wex vx cv vu
      cv c0 wne vu vv cv crab wceq vz cv c0 wne vz vx cv wral vz cv c0 wne vz
      vu cv c0 wne vu vv cv crab wral wph vw vx cv wral vz vx cv wral wph vw vu
      cv c0 wne vu vv cv crab wral vz vu cv c0 wne vu vv cv crab wral vz cv c0
      wne vz vx cv vu cv c0 wne vu vv cv crab raleq1 wph vw vx cv wral wph vw
      vu cv c0 wne vu vv cv crab wral vz vx cv vu cv c0 wne vu vv cv crab wph
      vw vx cv vu cv c0 wne vu vv cv crab raleq1 raleqd anbi12d vx cv vu cv c0
      wne vu vv cv crab wceq wps vz vx cv wral wps vz vu cv c0 wne vu vv cv
      crab wral vy wps vz vx cv vu cv c0 wne vu vv cv crab raleq1 exbidv
      imbi12d cla4v 19.21aiv vz cv c0 wne vz vu cv c0 wne vu vv cv crab wral
      wph vw vu cv c0 wne vu vv cv crab wral vz vu cv c0 wne vu vv cv crab wral
      wa wps vz vu cv c0 wne vu vv cv crab wral vy wex wi wph vw vv cv wral vz
      vv cv wral vz cv c0 wne wps wi vz vv cv wral vy wex wi vv wph vw vv cv
      wral vz vv cv wral vz cv c0 wne vz vu cv c0 wne vu vv cv crab wral wph vw
      vu cv c0 wne vu vv cv crab wral vz vu cv c0 wne vu vv cv crab wral wa wps
      vz vu cv c0 wne vu vv cv crab wral vy wex vz cv c0 wne wps wi vz vv cv
      wral vy wex wph vw vv cv wral vz vv cv wral wph vw vu cv c0 wne vu vv cv
      crab wral vz vu cv c0 wne vu vv cv crab wral vz cv c0 wne vz vu cv c0 wne
      vu vv cv crab wral wph vw vv cv wral wph vw vu cv c0 wne vu vv cv crab
      wral vz vv cv vu cv c0 wne vu vv cv crab vz cv vu cv c0 wne vu vv cv crab
      wcel vz cv vv cv wcel wph vw vv cv wral wph vw vu cv c0 wne vu vv cv crab
      wral vu cv c0 wne vu vv cv crab vv cv vz cv vu cv c0 wne vu vv cv ssrab2
      sseli wph wph vw vv cv vu cv c0 wne vu vv cv crab vw cv vu cv c0 wne vu
      vv cv crab wcel vw cv vv cv wcel wph vu cv c0 wne vu vv cv crab vv cv vw
      cv vu cv c0 wne vu vv cv ssrab2 sseli imim1i r19.20i2 imim12i r19.20i2 vz
      cv c0 wne vz vu cv c0 wne vu vv cv crab vz cv vu cv c0 wne vu vv cv crab
      wcel vz cv vv cv wcel vz cv c0 wne vu cv c0 wne vz cv c0 wne vu vz cv vv
      cv vu cv vz cv c0 neeq1 elrab pm3.27bi rgen jctil wps vz vu cv c0 wne vu
      vv cv crab wral vz cv c0 wne wps wi vz vv cv wral vy wps vz cv c0 wne wps
      wi vz vu cv c0 wne vu vv cv crab vv cv vz cv vu cv c0 wne vu vv cv crab
      wcel wps wi vz cv vv cv wcel vz cv c0 wne wps vz cv vv cv wcel vz cv c0
      wne wa vz cv vu cv c0 wne vu vv cv crab wcel wps vz cv vu cv c0 wne vu vv
      cv crab wcel vz cv vv cv wcel vz cv c0 wne wa vu cv c0 wne vz cv c0 wne
      vu vz cv vv cv vu cv vz cv c0 neeq1 elrab biimpri imim1i exp3a r19.20i2
      19.22i imim12i 19.20i syl wph vw vv cv wral vz vv cv wral vz cv c0 wne
      wps wi vz vv cv wral vy wex wi wph vw vx cv wral vz vx cv wral vz cv c0
      wne wps wi vz vx cv wral vy wex wi vv vx vv cv vx cv wceq wph vw vv cv
      wral vz vv cv wral wph vw vx cv wral vz vx cv wral vz cv c0 wne wps wi vz
      vv cv wral vy wex vz cv c0 wne wps wi vz vx cv wral vy wex wph vw vv cv
      wral wph vw vx cv wral vz vv cv vx cv wph vw vv cv vx cv raleq1 raleqd vv
      cv vx cv wceq vz cv c0 wne wps wi vz vv cv wral vz cv c0 wne wps wi vz vx
      cv wral vy vz cv c0 wne wps wi vz vv cv vx cv raleq1 exbidv imbi12d
      cbvalv sylib $.
      $( [12-May-2007] $) $( [5-Apr-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem2 $p |- ( E. y A. z e. x ( ph -> E! w w e. ( z i^i y ) ) <->
        E. y ( -. y e. x /\ A. z e. x ( ph -> E! w w e. ( z i^i y ) ) ) ) $=
      wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv wral vy wex vy cv vx cv
      wcel wn wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv wral wa vy wex
      wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv wral vy wex wph vw cv
      vz cv vv cv cin wcel vw weu wi vz vx cv wral vv wex vy cv vx cv wcel wn
      wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv wral wa vy wex wph vw
      cv vz cv vy cv cin wcel vw weu wi vz vx cv wral wph vw cv vz cv vv cv cin
      wcel vw weu wi vz vx cv wral vy vv vy cv vv cv wceq wph vw cv vz cv vy cv
      cin wcel vw weu wi wph vw cv vz cv vv cv cin wcel vw weu wi vz vx cv vy
      cv vv cv wceq vw cv vz cv vy cv cin wcel vw weu vw cv vz cv vv cv cin
      wcel vw weu wph vy cv vv cv wceq vw cv vz cv vy cv cin wcel vw cv vz cv
      vv cv cin wcel vw vy cv vv cv wceq vz cv vy cv cin vz cv vv cv cin vw cv
      vy cv vv cv vz cv ineq2 eleq2d eubidv imbi2d ralbidv cbvexv wph vw cv vz
      cv vv cv cin wcel vw weu wi vz vx cv wral vy cv vx cv wcel wn wph vw cv
      vz cv vy cv cin wcel vw weu wi vz vx cv wral wa vy wex vv vu cv vx cv
      cuni wcel wn vu wex wph vw cv vz cv vv cv cin wcel vw weu wi vz vx cv
      wral vy cv vx cv wcel wn wph vw cv vz cv vy cv cin wcel vw weu wi vz vx
      cv wral wa vy wex wi vu cv vy cv wcel wn vu wex vu cv vx cv cuni wcel wn
      vu wex vy vx cv cuni vx cv vx visset uniex vy cv vx cv cuni wceq vu cv vy
      cv wcel wn vu cv vx cv cuni wcel wn vu vy cv vx cv cuni wceq vu cv vy cv
      wcel vu cv vx cv cuni wcel vy cv vx cv cuni vu cv eleq2 notbid exbidv vu
      cv vy cv wcel wn vu wex vy vu cv vy cv wcel wn vu wex vy wal vu cv vy cv
      wcel vu wal vy wex wn vy vu nalset vu cv vy cv wcel vy vu alexn mpbir a4i
      vtocl vu cv vx cv cuni wcel wn wph vw cv vz cv vv cv cin wcel vw weu wi
      vz vx cv wral vy cv vx cv wcel wn wph vw cv vz cv vy cv cin wcel vw weu
      wi vz vx cv wral wa vy wex wi vu vu cv vx cv cuni wcel wn wph vw cv vz cv
      vv cv cin wcel vw weu wi vz vx cv wral vv cv vu cv csn cun vx cv wcel wn
      wph vw cv vz cv vv cv vu cv csn cun cin wcel vw weu wi vz vx cv wral wa
      vy cv vx cv wcel wn wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv
      wral wa vy wex vu cv vx cv cuni wcel wn wph vw cv vz cv vv cv cin wcel vw
      weu wi vz vx cv wral wph vw cv vz cv vv cv vu cv csn cun cin wcel vw weu
      wi vz vx cv wral vv cv vu cv csn cun vx cv wcel wn wph vw cv vz cv vv cv
      vu cv csn cun cin wcel vw weu wi vz vx cv wral wa vu cv vx cv cuni wcel
      wn wph vw cv vz cv vv cv cin wcel vw weu wi wph vw cv vz cv vv cv vu cv
      csn cun cin wcel vw weu wi vz vx cv vu cv vx cv cuni wcel wn vz cv vx cv
      wcel wa vw cv vz cv vv cv cin wcel vw weu vw cv vz cv vv cv vu cv csn cun
      cin wcel vw weu wph vu cv vx cv cuni wcel wn vz cv vx cv wcel wa vw cv vz
      cv vv cv cin wcel vw cv vz cv vv cv vu cv csn cun cin wcel vw vu cv vx cv
      cuni wcel wn vz cv vx cv wcel wa vz cv vv cv cin vz cv vv cv vu cv csn
      cun cin vw cv vu cv vx cv cuni wcel wn vz cv vx cv wcel wa vz cv vv cv
      cin vz cv vu cv csn cin cun vz cv vv cv cin vz cv vv cv vu cv csn cun cin
      vu cv vx cv cuni wcel wn vz cv vx cv wcel wa vz cv vv cv cin vz cv vu cv
      csn cin cun vz cv vv cv cin c0 cun vz cv vv cv cin vu cv vx cv cuni wcel
      wn vz cv vx cv wcel wa vz cv vu cv csn cin c0 vz cv vv cv cin vz cv vx cv
      wcel vu cv vx cv cuni wcel wn vz cv vu cv csn cin c0 wceq vz cv vx cv
      wcel vu cv vx cv cuni wcel wn vu cv vz cv wcel wn vz cv vu cv csn cin c0
      wceq vz cv vx cv wcel vu cv vz cv wcel vu cv vx cv cuni wcel vz cv vx cv
      wcel vz cv vx cv cuni vu cv vz cv vx cv elssuni sseld con3d vz cv vu cv
      disjsn syl6ibr impcom uneq2d vz cv vv cv cin un0 syl6eq vz cv vv cv vu cv
      csn indi syl5req eleq2d eubidv imbi2d ralbidva vu cv vx cv cuni wcel wn
      vv cv vu cv csn cun vx cv wcel wn wph vw cv vz cv vv cv vu cv csn cun cin
      wcel vw weu wi vz vx cv wral vv cv vu cv csn cun vx cv wcel vu cv vx cv
      cuni wcel vv cv vu cv csn cun vx cv wcel vu cv vv cv vu cv csn cun wcel
      vu cv vx cv cuni wcel vu cv vv cv vu cv csn cun wcel vu cv vv cv wcel vu
      cv vu cv csn wcel wo vu cv vu cv csn wcel vu cv vv cv wcel vu cv vu
      visset snid olci vu cv vv cv vu cv csn elun mpbir vv cv vu cv csn cun vx
      cv wcel vv cv vu cv csn cun vx cv cuni vu cv vv cv vu cv csn cun vx cv
      elssuni sseld mpi con3i biantrurd bitrd vy cv vx cv wcel wn wph vw cv vz
      cv vy cv cin wcel vw weu wi vz vx cv wral wa vv cv vu cv csn cun vx cv
      wcel wn wph vw cv vz cv vv cv vu cv csn cun cin wcel vw weu wi vz vx cv
      wral wa vy vv cv vu cv csn cun vv cv vu cv csn vv visset vu cv snex unex
      vy cv vv cv vu cv csn cun wceq vy cv vx cv wcel wn vv cv vu cv csn cun vx
      cv wcel wn wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv wral wph vw
      cv vz cv vv cv vu cv csn cun cin wcel vw weu wi vz vx cv wral vy cv vv cv
      vu cv csn cun wceq vy cv vx cv wcel vv cv vu cv csn cun vx cv wcel vy cv
      vv cv vu cv csn cun vx cv eleq1 notbid vy cv vv cv vu cv csn cun wceq wph
      vw cv vz cv vy cv cin wcel vw weu wi wph vw cv vz cv vv cv vu cv csn cun
      cin wcel vw weu wi vz vx cv vy cv vv cv vu cv csn cun wceq vw cv vz cv vy
      cv cin wcel vw weu vw cv vz cv vv cv vu cv csn cun cin wcel vw weu wph vy
      cv vv cv vu cv csn cun wceq vw cv vz cv vy cv cin wcel vw cv vz cv vv cv
      vu cv csn cun cin wcel vw vy cv vv cv vu cv csn cun wceq vz cv vy cv cin
      vz cv vv cv vu cv csn cun cin vw cv vy cv vv cv vu cv csn cun vz cv ineq2
      eleq2d eubidv imbi2d ralbidv anbi12d cla4ev syl6bi 19.23aiv ax-mp
      19.23aiv sylbi vy cv vx cv wcel wn wph vw cv vz cv vy cv cin wcel vw weu
      wi vz vx cv wral wa wph vw cv vz cv vy cv cin wcel vw weu wi vz vx cv
      wral vy vy cv vx cv wcel wn wph vw cv vz cv vy cv cin wcel vw weu wi vz
      vx cv wral pm3.27 19.22i impbii $.
      $( [29-Mar-2004] $) $( [25-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.  The
       right-hand side is part of the hypothesis of 4. $)
    kmlem3 $p |- ( ( z \ U. ( x \ { z } ) ) =/= (/) <->
        E. v e. z A. w e. x ( z =/= w -> -. v e. ( z i^i w ) ) ) $=
      vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz cv vw cv wne vv cv vz cv
      vw cv cin wcel wn wi vw vx cv wral vv vz cv crab c0 wne vz cv vw cv wne
      vv cv vz cv vw cv cin wcel wn wi vw vx cv wral vv vz cv wrex vz cv vx cv
      vz cv csn cdif cuni cdif vz cv vw cv wne vv cv vz cv vw cv cin wcel wn wi
      vw vx cv wral vv vz cv crab c0 vz cv vx cv vz cv csn cdif cuni cdif vv cv
      vx cv vz cv csn cdif cuni wcel wn vv vz cv crab vv cv vx cv vz cv csn
      cdif cuni wcel wn vv cv vz cv wcel wn wo vv vz cv crab vz cv vw cv wne vv
      cv vz cv vw cv cin wcel wn wi vw vx cv wral vv vz cv crab vv vz cv vx cv
      vz cv csn cdif cuni dfdif2 vv cv vx cv vz cv csn cdif cuni wcel wn vv vz
      cv crab c0 cun vv cv vx cv vz cv csn cdif cuni wcel wn vv vz cv crab vv
      cv vz cv wcel wn vv vz cv crab cun vv cv vx cv vz cv csn cdif cuni wcel
      wn vv vz cv crab vv cv vx cv vz cv csn cdif cuni wcel wn vv cv vz cv wcel
      wn wo vv vz cv crab c0 vv cv vz cv wcel wn vv vz cv crab vv cv vx cv vz
      cv csn cdif cuni wcel wn vv vz cv crab vv vz cv dfnul3 uneq2i vv cv vx cv
      vz cv csn cdif cuni wcel wn vv vz cv crab un0 vv cv vx cv vz cv csn cdif
      cuni wcel wn vv cv vz cv wcel wn vv vz cv unrab 3eqtr3i vv cv vx cv vz cv
      csn cdif cuni wcel wn vv cv vz cv wcel wn wo vz cv vw cv wne vv cv vz cv
      vw cv cin wcel wn wi vw vx cv wral vv vz cv vv cv vx cv vz cv csn cdif
      cuni wcel wn vv cv vz cv wcel wn wo vz cv vw cv wne vv cv vz cv vw cv cin
      wcel wn wi vw vx cv wral wb vv cv vz cv wcel vv cv vx cv vz cv csn cdif
      cuni wcel wn vv cv vz cv wcel wn wo vv cv vx cv vz cv csn cdif cuni wcel
      vv cv vz cv wcel wa wn vz cv vw cv wne vv cv vz cv vw cv cin wcel wn wi
      vw vx cv wral vv cv vx cv vz cv csn cdif cuni wcel vv cv vz cv wcel ianor
      vz cv vw cv wne vv cv vz cv vw cv cin wcel wn wi vw vx cv wral vv cv vx
      cv vz cv csn cdif cuni wcel vv cv vz cv wcel wa vv cv vx cv vz cv csn
      cdif cuni wcel vv cv vz cv wcel wa vv cv vw cv wcel vw cv vx cv vz cv csn
      cdif wcel wa vw wex vv cv vz cv wcel wa vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wn wi wn vw vx cv wrex vz cv vw cv wne vv cv vz cv vw cv cin
      wcel wn wi vw vx cv wral wn vv cv vx cv vz cv csn cdif cuni wcel vv cv vw
      cv wcel vw cv vx cv vz cv csn cdif wcel wa vw wex vv cv vz cv wcel vw vv
      cv vx cv vz cv csn cdif eluni anbi1i vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wn wi wn vw vx cv wrex vw cv vx cv wcel vz cv vw cv wne vv cv vz
      cv vw cv cin wcel wn wi wn wa vw wex vv cv vw cv wcel vw cv vx cv vz cv
      csn cdif wcel wa vv cv vz cv wcel wa vw wex vv cv vw cv wcel vw cv vx cv
      vz cv csn cdif wcel wa vw wex vv cv vz cv wcel wa vz cv vw cv wne vv cv
      vz cv vw cv cin wcel wn wi wn vw vx cv df-rex vw cv vx cv wcel vz cv vw
      cv wne vv cv vz cv vw cv cin wcel wn wi wn wa vv cv vw cv wcel vw cv vx
      cv vz cv csn cdif wcel wa vv cv vz cv wcel wa vw vv cv vw cv wcel vv cv
      vz cv wcel wa vw cv vx cv vz cv csn cdif wcel wa vw cv vx cv wcel vz cv
      vw cv wne vv cv vz cv wcel vv cv vw cv wcel wa wa wa vv cv vw cv wcel vw
      cv vx cv vz cv csn cdif wcel wa vv cv vz cv wcel wa vw cv vx cv wcel vz
      cv vw cv wne vv cv vz cv vw cv cin wcel wn wi wn wa vv cv vw cv wcel vv
      cv vz cv wcel wa vw cv vx cv vz cv csn cdif wcel wa vv cv vw cv wcel vv
      cv vz cv wcel wa vw cv vx cv wcel vz cv vw cv wne wa wa vw cv vx cv wcel
      vz cv vw cv wne wa vv cv vz cv wcel vv cv vw cv wcel wa wa vw cv vx cv
      wcel vz cv vw cv wne vv cv vz cv wcel vv cv vw cv wcel wa wa wa vw cv vx
      cv vz cv csn cdif wcel vw cv vx cv wcel vz cv vw cv wne wa vv cv vw cv
      wcel vv cv vz cv wcel wa vw cv vx cv vz cv csn cdif wcel vw cv vx cv wcel
      vw cv vz cv wne wa vw cv vx cv wcel vz cv vw cv wne wa vw cv vx cv vz cv
      eldifsn vw cv vz cv wne vz cv vw cv wne vw cv vx cv wcel vw cv vz cv
      necom anbi2i bitri anbi2i vv cv vw cv wcel vv cv vz cv wcel wa vw cv vx
      cv wcel vz cv vw cv wne wa wa vv cv vz cv wcel vv cv vw cv wcel wa vw cv
      vx cv wcel vz cv vw cv wne wa wa vw cv vx cv wcel vz cv vw cv wne wa vv
      cv vz cv wcel vv cv vw cv wcel wa wa vv cv vw cv wcel vv cv vz cv wcel wa
      vv cv vz cv wcel vv cv vw cv wcel wa vw cv vx cv wcel vz cv vw cv wne wa
      vv cv vw cv wcel vv cv vz cv wcel ancom anbi1i vv cv vz cv wcel vv cv vw
      cv wcel wa vw cv vx cv wcel vz cv vw cv wne wa ancom bitri vw cv vx cv
      wcel vz cv vw cv wne vv cv vz cv wcel vv cv vw cv wcel wa anass 3bitri vv
      cv vw cv wcel vv cv vz cv wcel vw cv vx cv vz cv csn cdif wcel an23 vz cv
      vw cv wne vv cv vz cv wcel vv cv vw cv wcel wa wa vz cv vw cv wne vv cv
      vz cv vw cv cin wcel wn wi wn vw cv vx cv wcel vz cv vw cv wne vv cv vz
      cv wcel vv cv vw cv wcel wa wa vz cv vw cv wne vv cv vz cv vw cv cin wcel
      wa vz cv vw cv wne vv cv vz cv vw cv cin wcel wn wi wn vv cv vz cv vw cv
      cin wcel vv cv vz cv wcel vv cv vw cv wcel wa vz cv vw cv wne vv cv vz cv
      vw cv elin anbi2i vz cv vw cv wne vv cv vz cv vw cv cin wcel df-an bitr3i
      anbi2i 3bitr3ri exbii vv cv vw cv wcel vw cv vx cv vz cv csn cdif wcel wa
      vv cv vz cv wcel vw 19.41v 3bitri vz cv vw cv wne vv cv vz cv vw cv cin
      wcel wn wi vw vx cv rexnal 3bitr2ri con1bii bitr3i a1i rabbii 3eqtri
      neeq1i vz cv vw cv wne vv cv vz cv vw cv cin wcel wn wi vw vx cv wral vv
      vz cv rabn0 bitri $.
      $( [12-Oct-2007] $) $( [25-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem4 $p |- ( ( w e. x /\ z =/= w ) ->
                    ( ( z \ U. ( x \ { z } ) ) i^i w ) = (/) ) $=
      vw cv vx cv wcel vz cv vw cv wne wa vy cv vw cv wcel wn vy vz cv vx cv vz
      cv csn cdif cuni cdif wral vz cv vx cv vz cv csn cdif cuni cdif vw cv cin
      c0 wceq vw cv vx cv wcel vz cv vw cv wne wa vy cv vw cv wcel wn vy vz cv
      vx cv vz cv csn cdif cuni cdif vw cv vx cv wcel vz cv vw cv wne wa vv cv
      vx cv wcel vz cv vv cv wne wa vy cv vv cv wcel wn wi vv wal vy cv vw cv
      wcel wn vy cv vz cv vx cv vz cv csn cdif cuni cdif wcel vv cv vx cv wcel
      vz cv vv cv wne wa vy cv vv cv wcel wn wi vv wal vw cv vx cv wcel vz cv
      vw cv wne wa vy cv vw cv wcel wn vv cv vx cv wcel vz cv vv cv wne wa vy
      cv vv cv wcel wn wi vw cv vx cv wcel vz cv vw cv wne wa vy cv vw cv wcel
      wn wi vv vw cv vw visset vv cv vw cv wceq vv cv vx cv wcel vz cv vv cv
      wne wa vw cv vx cv wcel vz cv vw cv wne wa vy cv vv cv wcel wn vy cv vw
      cv wcel wn vv cv vw cv wceq vv cv vx cv wcel vw cv vx cv wcel vz cv vv cv
      wne vz cv vw cv wne vv cv vw cv vx cv eleq1 vv cv vw cv vz cv neeq2
      anbi12d vv cv vw cv wceq vy cv vv cv wcel vy cv vw cv wcel vv cv vw cv vy
      cv eleq2 notbid imbi12d cla4v com12 vy cv vz cv vx cv vz cv csn cdif cuni
      cdif wcel vy cv vz cv wcel vy cv vx cv vz cv csn cdif cuni wcel wn wa vv
      cv vx cv wcel vz cv vv cv wne wa vy cv vv cv wcel wn wi vv wal vy cv vz
      cv vx cv vz cv csn cdif cuni eldif vy cv vz cv wcel vy cv vx cv vz cv csn
      cdif cuni wcel wn wa vy cv vx cv vz cv csn cdif cuni wcel wn vv cv vx cv
      wcel vz cv vv cv wne wa vy cv vv cv wcel wn wi vv wal vy cv vz cv wcel vy
      cv vx cv vz cv csn cdif cuni wcel wn pm3.27 vy cv vx cv vz cv csn cdif
      cuni wcel wn vy cv vv cv wcel vv cv vx cv vz cv csn cdif wcel wa vv wex
      wn vy cv vv cv wcel vv cv vx cv vz cv csn cdif wcel wa wn vv wal vv cv vx
      cv wcel vz cv vv cv wne wa vy cv vv cv wcel wn wi vv wal vy cv vx cv vz
      cv csn cdif cuni wcel vy cv vv cv wcel vv cv vx cv vz cv csn cdif wcel wa
      vv wex vv vy cv vx cv vz cv csn cdif eluni notbii vy cv vv cv wcel vv cv
      vx cv vz cv csn cdif wcel wa vv alnex vy cv vv cv wcel vv cv vx cv vz cv
      csn cdif wcel wa wn vv cv vx cv wcel vz cv vv cv wne wa vy cv vv cv wcel
      wn wi vv vy cv vv cv wcel vv cv vx cv vz cv csn cdif wcel wn wi vv cv vx
      cv vz cv csn cdif wcel vy cv vv cv wcel wn wi vy cv vv cv wcel vv cv vx
      cv vz cv csn cdif wcel wa wn vv cv vx cv wcel vz cv vv cv wne wa vy cv vv
      cv wcel wn wi vy cv vv cv wcel vv cv vx cv vz cv csn cdif wcel con2b vy
      cv vv cv wcel vv cv vx cv vz cv csn cdif wcel imnan vv cv vx cv vz cv csn
      cdif wcel vv cv vx cv wcel vz cv vv cv wne wa vy cv vv cv wcel wn vv cv
      vx cv vz cv csn cdif wcel vv cv vx cv wcel vv cv vz cv wne wa vv cv vx cv
      wcel vz cv vv cv wne wa vv cv vx cv vz cv eldifsn vv cv vz cv wne vz cv
      vv cv wne vv cv vx cv wcel vv cv vz cv necom anbi2i bitri imbi1i 3bitr3i
      albii 3bitr2i sylib sylbi syl5 r19.21aiv vy vz cv vx cv vz cv csn cdif
      cuni cdif vw cv disj sylibr $.
      $( [12-Oct-2007] $) $( [26-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem5 $p |- ( ( w e. x /\ z =/= w ) ->
          ( ( z \ U. ( x \ { z } ) ) i^i ( w \ U. ( x \ { w } ) ) ) = (/) ) $=
      vw cv vx cv wcel vz cv vw cv wne wa vz cv vx cv vz cv csn cdif cuni cdif
      vw cv vx cv vw cv csn cdif cuni cdif cin c0 wss vz cv vx cv vz cv csn
      cdif cuni cdif vw cv vx cv vw cv csn cdif cuni cdif cin c0 wceq vw cv vx
      cv wcel vz cv vw cv wne wa vz cv vx cv vz cv csn cdif cuni cdif vw cv vx
      cv vw cv csn cdif cuni cdif cin vz cv vx cv vz cv csn cdif cuni cdif vw
      cv cin wss vz cv vx cv vz cv csn cdif cuni cdif vw cv vx cv vw cv csn
      cdif cuni cdif cin c0 wss vw cv vx cv vw cv csn cdif cuni cdif vw cv wss
      vz cv vx cv vz cv csn cdif cuni cdif vw cv vx cv vw cv csn cdif cuni cdif
      cin vz cv vx cv vz cv csn cdif cuni cdif vw cv cin wss vw cv vx cv vw cv
      csn cdif cuni difss vw cv vx cv vw cv csn cdif cuni cdif vw cv vz cv vx
      cv vz cv csn cdif cuni cdif sslin ax-mp vw cv vx cv wcel vz cv vw cv wne
      wa vz cv vx cv vz cv csn cdif cuni cdif vw cv cin c0 vz cv vx cv vz cv
      csn cdif cuni cdif vw cv vx cv vw cv csn cdif cuni cdif cin vx vz vw
      kmlem4 sseq2d mpbii vz cv vx cv vz cv csn cdif cuni cdif vw cv vx cv vw
      cv csn cdif cuni cdif cin ss0b sylib $.
      $( [12-Oct-2007] $) $( [25-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 4 => 1. $)
    kmlem6 $p |- ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( ph -> A = (/) ) ) ->
           A. z e. x E. v e. z  A. w e. x ( ph -> -. v e. A ) ) $=
      vz cv c0 wne vz vx cv wral wph cA c0 wceq wi vw vx cv wral vz vx cv wral
      wa vz cv c0 wne wph cA c0 wceq wi vw vx cv wral wa vz vx cv wral wph vv
      cv cA wcel wn wi vw vx cv wral vv vz cv wrex vz vx cv wral vz cv c0 wne
      wph cA c0 wceq wi vw vx cv wral vz vx cv r19.26 vz cv c0 wne wph cA c0
      wceq wi vw vx cv wral wa wph vv cv cA wcel wn wi vw vx cv wral vv vz cv
      wrex vz vx cv vv cv vz cv wcel vv wex wph vv cv cA wcel wn wi vw vx cv
      wral vv wal wph vv cv cA wcel wn wi vw vx cv wral vv vz cv wrex vz cv c0
      wne wph cA c0 wceq wi vw vx cv wral vv cv vz cv wcel vv wex wph vv cv cA
      wcel wn wi vw vx cv wral vv wal wa vv cv vz cv wcel wph vv cv cA wcel wn
      wi vw vx cv wral wa vv wex wph vv cv cA wcel wn wi vw vx cv wral vv vz cv
      wrex vv cv vz cv wcel wph vv cv cA wcel wn wi vw vx cv wral vv 19.29r wph
      vv cv cA wcel wn wi vw vx cv wral vv vz cv df-rex sylibr vz cv c0 wne vv
      cv vz cv wcel vv wex vv vz cv n0 biimpi wph cA c0 wceq wi vw vx cv wral
      wph vv cv cA wcel wn wi vw vx cv wral vv wph cA c0 wceq wi wph vv cv cA
      wcel wn wi vw vx cv cA c0 wceq vv cv cA wcel wn wph vv cv cA wcel cA c0
      cA vv cv ne0i necon2bi imim2i r19.20si 19.21aiv syl2an r19.20si sylbir $.
      $( [12-May-2007] $) $( [26-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 4 => 1. $)
    kmlem7 $p |- ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
       -. E. z e. x A. v e. z  E. w e. x ( z =/= w /\ v e. ( z i^i w ) ) ) $=
      vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw
      vx cv wral vz vx cv wral wa vz cv vw cv wne vv cv vz cv vw cv cin wcel wn
      wi vw vx cv wral vv vz cv wrex vz vx cv wral vz cv vw cv wne vv cv vz cv
      vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex wn vz cv vw
      cv wne vx vz vw vv vz cv vw cv cin kmlem6 vz cv vw cv wne vv cv vz cv vw
      cv cin wcel wn wi vw vx cv wral vv vz cv wrex vz vx cv wral vz cv vw cv
      wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral wn vz vx cv
      wral vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv
      wral vz vx cv wrex wn vz cv vw cv wne vv cv vz cv vw cv cin wcel wn wi vw
      vx cv wral vv vz cv wrex vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw
      vx cv wrex vv vz cv wral wn vz vx cv vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wn wi vw vx cv wral vv vz cv wrex vz cv vw cv wne vv cv vz cv vw
      cv cin wcel wa vw vx cv wrex wn vv vz cv wrex vz cv vw cv wne vv cv vz cv
      vw cv cin wcel wa vw vx cv wrex vv vz cv wral wn vz cv vw cv wne vv cv vz
      cv vw cv cin wcel wn wi vw vx cv wral vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wa vw vx cv wrex wn vv vz cv vz cv vw cv wne vv cv vz cv vw cv
      cin wcel vw vx cv ralinexa rexbii vz cv vw cv wne vv cv vz cv vw cv cin
      wcel wa vw vx cv wrex vv vz cv rexnal bitri ralbii vz cv vw cv wne vv cv
      vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv ralnex bitri
      sylib $.
      $( [12-Oct-2007] $) $( [26-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4 1 <=> 4. $)
    kmlem8 $p |- (  ( -. E. z e. u A. w e. z  ps -> E. y A. z e. u ( z =/= (/)
                  -> E! w w e. ( z i^i y ) ) ) <-> ( E. z e. u A. w e. z  ps \/
                 E. y ( -. y e. u /\ A. z e. u E! w w e. ( z i^i y ) ) ) ) $=
      wps vw vz cv wral vz vu cv wrex wn vz cv c0 wne vw cv vz cv vy cv cin
      wcel vw weu wi vz vu cv wral vy wex wi wps vw vz cv wral vz vu cv wrex wn
      vy cv vu cv wcel wn vw cv vz cv vy cv cin wcel vw weu vz vu cv wral wa vy
      wex wi wps vw vz cv wral vz vu cv wrex vy cv vu cv wcel wn vw cv vz cv vy
      cv cin wcel vw weu vz vu cv wral wa vy wex wo wps vw vz cv wral vz vu cv
      wrex wn vz cv c0 wne vw cv vz cv vy cv cin wcel vw weu wi vz vu cv wral
      vy wex vy cv vu cv wcel wn vw cv vz cv vy cv cin wcel vw weu vz vu cv
      wral wa vy wex wps vw vz cv wral vz vu cv wrex wn vz cv c0 wne vz vu cv
      wral vz cv c0 wne vw cv vz cv vy cv cin wcel vw weu wi vz vu cv wral vy
      wex vy cv vu cv wcel wn vw cv vz cv vy cv cin wcel vw weu vz vu cv wral
      wa vy wex wb wps vw vz cv wral vz vu cv wrex wn wps vw vz cv wral wn vz
      vu cv wral vz cv c0 wne vz vu cv wral wps vw vz cv wral vz vu cv ralnex
      wps vw vz cv wral wn vz cv c0 wne vz vu cv wps vw vz cv wral wn vw cv vz
      cv wcel wps wn wa vw wex vz cv c0 wne vw cv vz cv wcel wps wn wa vw wex
      wps wn vw vz cv wrex wps vw vz cv wral wn wps wn vw vz cv df-rex wps vw
      vz cv rexnal bitr3i vw cv vz cv wcel wps wn wa vw wex vw cv vz cv wcel vw
      wex vz cv c0 wne vw cv vz cv wcel wps wn wa vw cv vz cv wcel vw vw cv vz
      cv wcel wps wn pm3.26 19.22i vw vz cv n0 sylibr sylbir r19.20si sylbir vz
      cv c0 wne vz vu cv wral vy cv vu cv wcel wn vw cv vz cv vy cv cin wcel vw
      weu vz vu cv wral wa vy wex vy cv vu cv wcel wn vz cv c0 wne vw cv vz cv
      vy cv cin wcel vw weu wi vz vu cv wral wa vy wex vz cv c0 wne vw cv vz cv
      vy cv cin wcel vw weu wi vz vu cv wral vy wex vz cv c0 wne vz vu cv wral
      vy cv vu cv wcel wn vw cv vz cv vy cv cin wcel vw weu vz vu cv wral wa vy
      cv vu cv wcel wn vz cv c0 wne vw cv vz cv vy cv cin wcel vw weu wi vz vu
      cv wral wa vy vz cv c0 wne vz vu cv wral vw cv vz cv vy cv cin wcel vw
      weu vz vu cv wral vz cv c0 wne vw cv vz cv vy cv cin wcel vw weu wi vz vu
      cv wral vy cv vu cv wcel wn vz cv c0 wne vz vu cv wral vw cv vz cv vy cv
      cin wcel vw weu vz cv c0 wne vw cv vz cv vy cv cin wcel vw weu wi wb vz
      vu cv wral vw cv vz cv vy cv cin wcel vw weu vz vu cv wral vz cv c0 wne
      vw cv vz cv vy cv cin wcel vw weu wi vz vu cv wral wb vz cv c0 wne vw cv
      vz cv vy cv cin wcel vw weu vz cv c0 wne vw cv vz cv vy cv cin wcel vw
      weu wi wb vz vu cv vz cv c0 wne vw cv vz cv vy cv cin wcel vw weu biimt
      r19.20si vw cv vz cv vy cv cin wcel vw weu vz cv c0 wne vw cv vz cv vy cv
      cin wcel vw weu wi vz vu cv r19.15 syl anbi2d exbidv vz cv c0 wne vu vy
      vz vw kmlem2 syl6rbbr syl pm5.74i wps vw vz cv wral vz vu cv wrex vy cv
      vu cv wcel wn vw cv vz cv vy cv cin wcel vw weu vz vu cv wral wa vy wex
      pm4.64 bitri $.
      $( [12-May-2007] $) $( [4-Apr-2004] $)
  $}

  ${
    $d x y z w v u t h g $.  $d y z w v h g A $.  $d h ph $.
    kmlem9.1 $e |- A = { u | E. t e. x u = ( t \ U. ( x \ { t } ) ) } $.
    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem9 $p |- A. z e. A A. w e. A ( z =/= w -> ( z i^i w ) = (/) ) $=
      vz cv vw cv wne vz cv vw cv cin c0 wceq wi vz vw cA vz cv vt cv vx cv vt
      cv csn cdif cuni cdif wceq vt vx cv wrex vw cv vh cv vx cv vh cv csn cdif
      cuni cdif wceq vh vx cv wrex vz cv vw cv wne vz cv vw cv cin c0 wceq wi
      vz cv cA wcel vw cv cA wcel vz cv vt cv vx cv vt cv csn cdif cuni cdif
      wceq vt vx cv wrex vw cv vh cv vx cv vh cv csn cdif cuni cdif wceq vh vx
      cv wrex wa vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vw cv vh cv vx
      cv vh cv csn cdif cuni cdif wceq wa vh vx cv wrex vt vx cv wrex vz cv vw
      cv wne vz cv vw cv cin c0 wceq wi vz cv vt cv vx cv vt cv csn cdif cuni
      cdif wceq vw cv vh cv vx cv vh cv csn cdif cuni cdif wceq vt vh vx cv vx
      cv reeanv vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vw cv vh cv vx
      cv vh cv csn cdif cuni cdif wceq wa vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vt vh vx cv vx cv vh cv vx cv wcel vz cv vt cv vx cv vt cv csn
      cdif cuni cdif wceq vw cv vh cv vx cv vh cv csn cdif cuni cdif wceq wa vz
      cv vw cv wne vz cv vw cv cin c0 wceq wi wi vt cv vx cv wcel vz cv vt cv
      vx cv vt cv csn cdif cuni cdif wceq vw cv vh cv vx cv vh cv csn cdif cuni
      cdif wceq wa vh cv vx cv wcel vz cv vw cv wne vz cv vw cv cin c0 wceq wi
      vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vw cv vh cv vx cv vh cv
      csn cdif cuni cdif wceq wa vh cv vx cv wcel vt cv vh cv wne vz cv vw cv
      cin c0 wceq vz cv vw cv wne vz cv vt cv vx cv vt cv csn cdif cuni cdif
      wceq vw cv vh cv vx cv vh cv csn cdif cuni cdif wceq wa vh cv vx cv wcel
      vt cv vh cv wne vz cv vw cv cin c0 wceq vz cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vw cv vh cv vx cv vh cv csn cdif cuni cdif wceq wa vz cv
      vw cv cin c0 wceq vt cv vx cv vt cv csn cdif cuni cdif vh cv vx cv vh cv
      csn cdif cuni cdif cin c0 wceq vh cv vx cv wcel vt cv vh cv wne wa vz cv
      vt cv vx cv vt cv csn cdif cuni cdif wceq vw cv vh cv vx cv vh cv csn
      cdif cuni cdif wceq wa vz cv vw cv cin vt cv vx cv vt cv csn cdif cuni
      cdif vh cv vx cv vh cv csn cdif cuni cdif cin c0 vz cv vt cv vx cv vt cv
      csn cdif cuni cdif vw cv vh cv vx cv vh cv csn cdif cuni cdif ineq12
      eqeq1d vx vt vh kmlem5 syl5bir exp3a vz cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vw cv vh cv vx cv vh cv csn cdif cuni cdif wceq wa vt cv
      vh cv vz cv vw cv vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vw cv
      vh cv vx cv vh cv csn cdif cuni cdif wceq wa vz cv vw cv wceq vt cv vx cv
      vt cv csn cdif cuni cdif vh cv vx cv vh cv csn cdif cuni cdif wceq vt cv
      vh cv wceq vz cv vt cv vx cv vt cv csn cdif cuni cdif vw cv vh cv vx cv
      vh cv csn cdif cuni cdif eqeq12 vt cv vh cv wceq vt cv vx cv vt cv csn
      cdif cuni cdif vh cv vx cv vt cv csn cdif cuni cdif vh cv vx cv vh cv csn
      cdif cuni cdif vt cv vh cv vx cv vt cv csn cdif cuni difeq1 vt cv vh cv
      wceq vx cv vt cv csn cdif cuni vx cv vh cv csn cdif cuni vh cv vt cv vh
      cv wceq vx cv vt cv csn cdif vx cv vh cv csn cdif vt cv vh cv wceq vt cv
      csn vh cv csn vx cv vt cv vh cv sneq difeq2d unieqd difeq2d eqtrd syl5bir
      necon3d syl5d com12 adantl r19.23aivv sylbir vu cv vt cv vx cv vt cv csn
      cdif cuni cdif wceq vt vx cv wrex vz cv vt cv vx cv vt cv csn cdif cuni
      cdif wceq vt vx cv wrex vu vz cv cA vz visset vu cv vz cv wceq vu cv vt
      cv vx cv vt cv csn cdif cuni cdif wceq vz cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vt vx cv vu cv vz cv vt cv vx cv vt cv csn cdif cuni cdif
      eqeq1 rexbidv kmlem9.1 elab2 vw cv cA wcel vw cv vt cv vx cv vt cv csn
      cdif cuni cdif wceq vt vx cv wrex vw cv vh cv vx cv vh cv csn cdif cuni
      cdif wceq vh vx cv wrex vu cv vt cv vx cv vt cv csn cdif cuni cdif wceq
      vt vx cv wrex vw cv vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv
      wrex vu vw cv cA vw visset vu cv vw cv wceq vu cv vt cv vx cv vt cv csn
      cdif cuni cdif wceq vw cv vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx
      cv vu cv vw cv vt cv vx cv vt cv csn cdif cuni cdif eqeq1 rexbidv
      kmlem9.1 elab2 vw cv vt cv vx cv vt cv csn cdif cuni cdif wceq vw cv vh
      cv vx cv vh cv csn cdif cuni cdif wceq vt vh vx cv vt cv vh cv wceq vt cv
      vx cv vt cv csn cdif cuni cdif vh cv vx cv vh cv csn cdif cuni cdif vw cv
      vt cv vh cv wceq vt cv vx cv vt cv csn cdif cuni cdif vh cv vx cv vt cv
      csn cdif cuni cdif vh cv vx cv vh cv csn cdif cuni cdif vt cv vh cv vx cv
      vt cv csn cdif cuni difeq1 vt cv vh cv wceq vx cv vt cv csn cdif cuni vx
      cv vh cv csn cdif cuni vh cv vt cv vh cv wceq vx cv vt cv csn cdif vx cv
      vh cv csn cdif vt cv vh cv wceq vt cv csn vh cv csn vx cv vt cv vh cv
      sneq difeq2d unieqd difeq2d eqtrd eqeq2d cbvrexv bitri syl2anb rgen2a $.
      $( [12-Oct-2007] $) $( [25-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem10 $p |- ( A. h ( A. z e. h A. w e. h
                              ( z =/= w -> ( z i^i w ) = (/) ) ->
                         E. y A. z e. h ph ) -> E. y A. z e. A ph ) $=
      vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vh cv wral vz vh cv wral
      wph vz vh cv wral vy wex wi vh wal vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vw cA wral vz cA wral wph vz cA wral vy wex vx vz vw vu vt cA
      kmlem9.1 kmlem9 vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vh cv wral
      vz vh cv wral wph vz vh cv wral vy wex wi vz cv vw cv wne vz cv vw cv cin
      c0 wceq wi vw cA wral vz cA wral wph vz cA wral vy wex wi vh cA cA vu cv
      vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex vu cab cvv
      kmlem9.1 vt vu vx cv vt cv vx cv vt cv csn cdif cuni cdif vx visset
      abrexex eqeltri vh cv cA wceq vz cv vw cv wne vz cv vw cv cin c0 wceq wi
      vw vh cv wral vz vh cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw
      cA wral vz cA wral wph vz vh cv wral vy wex wph vz cA wral vy wex vz cv
      vw cv wne vz cv vw cv cin c0 wceq wi vw vh cv wral vz cv vw cv wne vz cv
      vw cv cin c0 wceq wi vw cA wral vz vh cv cA vz cv vw cv wne vz cv vw cv
      cin c0 wceq wi vw vh cv cA raleq1 raleqd vh cv cA wceq wph vz vh cv wral
      wph vz cA wral vy wph vz vh cv cA raleq1 exbidv imbi12d cla4v mpi $.
      $( [12-Oct-2007] $) $( [25-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem11 $p |- ( z e. x -> ( z i^i U. A ) = ( z \ U. ( x \ { z } ) ) ) $=
      vz cv vx cv wcel vt vx cv vz cv vt cv vx cv vt cv csn cdif cuni cdif cin
      ciun vz cv vx cv vz cv csn cdif cuni cdif vz cv cA cuni cin vz cv vx cv
      wcel vt vx cv vz cv vt cv vx cv vt cv csn cdif cuni cdif cin ciun vz cv
      vz cv vx cv vz cv csn cdif cuni cdif cin c0 cun vz cv vx cv vz cv csn
      cdif cuni cdif vz cv vx cv wcel vt vx cv vz cv vt cv vx cv vt cv csn cdif
      cuni cdif cin ciun vt vz cv csn vx cv vz cv csn cdif cun vz cv vt cv vx
      cv vt cv csn cdif cuni cdif cin ciun vz cv vz cv vx cv vz cv csn cdif
      cuni cdif cin c0 cun vz cv vx cv wcel vx cv vz cv csn vx cv vz cv csn
      cdif cun wceq vt vx cv vz cv vt cv vx cv vt cv csn cdif cuni cdif cin
      ciun vt vz cv csn vx cv vz cv csn cdif cun vz cv vt cv vx cv vt cv csn
      cdif cuni cdif cin ciun wceq vz cv vx cv wcel vz cv csn vx cv cun vx cv
      vz cv csn vx cv vz cv csn cdif cun vz cv vx cv wcel vz cv csn vx cv wss
      vz cv csn vx cv cun vx cv wceq vz cv vx cv snssi vz cv csn vx cv ssequn1
      sylib vz cv csn vx cv undif2 syl5req vt vx cv vz cv csn vx cv vz cv csn
      cdif cun vz cv vt cv vx cv vt cv csn cdif cuni cdif cin iuneq1 syl vz cv
      vx cv wcel vz cv vz cv vx cv vz cv csn cdif cuni cdif cin vt vx cv vz cv
      csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif cin ciun cun vz cv vz
      cv vx cv vz cv csn cdif cuni cdif cin c0 cun vt vz cv csn vx cv vz cv csn
      cdif cun vz cv vt cv vx cv vt cv csn cdif cuni cdif cin ciun vz cv vx cv
      wcel vt vx cv vz cv csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif
      cin ciun c0 vz cv vz cv vx cv vz cv csn cdif cuni cdif cin vz cv vx cv
      wcel vt vx cv vz cv csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif
      cin ciun vt vx cv vz cv csn cdif c0 ciun c0 vz cv vx cv wcel vz cv vt cv
      vx cv vt cv csn cdif cuni cdif cin c0 wceq vt vx cv vz cv csn cdif wral
      vt vx cv vz cv csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif cin
      ciun vt vx cv vz cv csn cdif c0 ciun wceq vz cv vx cv wcel vz cv vt cv vx
      cv vt cv csn cdif cuni cdif cin c0 wceq vt vx cv vz cv csn cdif vz cv vx
      cv wcel vt cv vz cv wne vz cv vt cv vx cv vt cv csn cdif cuni cdif cin c0
      wceq vt cv vx cv vz cv csn cdif wcel vz cv vx cv wcel vt cv vz cv wne vz
      cv vt cv vx cv vt cv csn cdif cuni cdif cin c0 wceq vz cv vx cv wcel vt
      cv vz cv wne wa vt cv vx cv vt cv csn cdif cuni cdif vz cv cin c0 vz cv
      vt cv vx cv vt cv csn cdif cuni cdif cin vx vt vz kmlem4 vz cv vt cv vx
      cv vt cv csn cdif cuni cdif incom syl5eq ex vt cv vx cv vz cv csn cdif
      wcel vt cv vx cv wcel vt cv vz cv wne vt cv vx cv vz cv eldifsn pm3.27bi
      syl5 r19.21aiv vt vx cv vz cv csn cdif vz cv vt cv vx cv vt cv csn cdif
      cuni cdif cin c0 iuneq2 syl vt vx cv vz cv csn cdif iun0 syl6eq uneq2d vt
      vz cv csn vx cv vz cv csn cdif cun vz cv vt cv vx cv vt cv csn cdif cuni
      cdif cin ciun vt vz cv csn vz cv vt cv vx cv vt cv csn cdif cuni cdif cin
      ciun vt vx cv vz cv csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif
      cin ciun cun vz cv vz cv vx cv vz cv csn cdif cuni cdif cin vt vx cv vz
      cv csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif cin ciun cun vt vz
      cv csn vx cv vz cv csn cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif
      cin iunxun vt vz cv csn vz cv vt cv vx cv vt cv csn cdif cuni cdif cin
      ciun vz cv vz cv vx cv vz cv csn cdif cuni cdif cin vt vx cv vz cv csn
      cdif vz cv vt cv vx cv vt cv csn cdif cuni cdif cin ciun vt vz cv vz cv
      vt cv vx cv vt cv csn cdif cuni cdif cin vz cv vz cv vx cv vz cv csn cdif
      cuni cdif cin vz visset vt cv vz cv wceq vt cv vx cv vt cv csn cdif cuni
      cdif vz cv vx cv vz cv csn cdif cuni cdif vz cv vt cv vz cv wceq vt cv vx
      cv vt cv csn cdif cuni cdif vz cv vx cv vt cv csn cdif cuni cdif vz cv vx
      cv vz cv csn cdif cuni cdif vt cv vz cv vx cv vt cv csn cdif cuni difeq1
      vt cv vz cv wceq vx cv vt cv csn cdif cuni vx cv vz cv csn cdif cuni vz
      cv vt cv vz cv wceq vx cv vt cv csn cdif vx cv vz cv csn cdif vt cv vz cv
      wceq vt cv csn vz cv csn vx cv vt cv vz cv sneq difeq2d unieqd difeq2d
      eqtrd ineq2d iunxsn uneq1i eqtri syl5eq eqtrd vz cv vz cv vx cv vz cv csn
      cdif cuni cdif cin c0 cun vz cv vz cv vx cv vz cv csn cdif cuni cdif cin
      vz cv vx cv vz cv csn cdif cuni cdif vz cv vz cv vx cv vz cv csn cdif
      cuni cdif cin un0 vz cv vx cv vz cv csn cdif cuni indif eqtri syl6eq vz
      cv cA cuni cin vz cv vt vx cv vt cv vx cv vt cv csn cdif cuni cdif ciun
      cin vt vx cv vz cv vt cv vx cv vt cv csn cdif cuni cdif cin ciun cA cuni
      vt vx cv vt cv vx cv vt cv csn cdif cuni cdif ciun vz cv cA cuni vu cv vt
      cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex vu cab cuni vt vx cv
      vt cv vx cv vt cv csn cdif cuni cdif ciun cA vu cv vt cv vx cv vt cv csn
      cdif cuni cdif wceq vt vx cv wrex vu cab kmlem9.1 unieqi vt vu vx cv vt
      cv vx cv vt cv csn cdif cuni cdif vt cv cvv wcel vt cv vx cv vt cv csn
      cdif cuni cdif cvv wcel vt visset vt cv vx cv vt cv csn cdif cuni cvv
      difexg ax-mp dfiun2 eqtr4i ineq2i vt vx cv vz cv vt cv vx cv vt cv csn
      cdif cuni cdif iunin2 eqtr4i syl5eq $.
      $( [30-Mar-2004] $) $( [26-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4. $)
    kmlem12 $p |- ( A. z e. x ( z \ U. ( x \ { z } ) ) =/= (/) ->
                    ( A. z e. A ( z =/= (/) -> E! v v e. ( z i^i y ) ) ->
        A. z e. x ( z =/= (/) -> E! v v e. ( z i^i ( y i^i U. A ) ) ) ) ) $=
      vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx cv wral vt cv vx cv vt
      cv csn cdif cuni cdif c0 wne vt vx cv wral vv cv vt cv vx cv vt cv csn
      cdif cuni cdif vy cv cin wcel vv weu vt vx cv wral wi vz cv c0 wne vv cv
      vz cv vy cv cA cuni cin cin wcel vv weu wi vz vx cv wral vz cv c0 wne vv
      cv vz cv vy cv cin wcel vv weu wi vz cA wral vt cv vx cv vt cv csn cdif
      cuni cdif c0 wne vt vx cv wral vv cv vt cv vx cv vt cv csn cdif cuni cdif
      vy cv cin wcel vv weu vt vx cv wral wi vz cv vx cv vz cv csn cdif cuni
      cdif c0 wne vz vx cv wral vz cv c0 wne vv cv vz cv vy cv cA cuni cin cin
      wcel vv weu wi vz vx cv wral vt cv vx cv vt cv csn cdif cuni cdif c0 wne
      vt vx cv wral vv cv vt cv vx cv vt cv csn cdif cuni cdif vy cv cin wcel
      vv weu vt vx cv wral wi vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx
      cv wral vv cv vz cv vx cv vz cv csn cdif cuni cdif vy cv cin wcel vv weu
      vz vx cv wral wi vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx cv
      wral vz cv c0 wne vv cv vz cv vy cv cA cuni cin cin wcel vv weu wi vz vx
      cv wral wi vt cv vx cv vt cv csn cdif cuni cdif c0 wne vt vx cv wral vz
      cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx cv wral vv cv vt cv vx cv
      vt cv csn cdif cuni cdif vy cv cin wcel vv weu vt vx cv wral vv cv vz cv
      vx cv vz cv csn cdif cuni cdif vy cv cin wcel vv weu vz vx cv wral vt cv
      vx cv vt cv csn cdif cuni cdif c0 wne vz cv vx cv vz cv csn cdif cuni
      cdif c0 wne vt vz vx cv vt cv vz cv wceq vt cv vx cv vt cv csn cdif cuni
      cdif vz cv vx cv vz cv csn cdif cuni cdif c0 vt cv vz cv wceq vt cv vx cv
      vt cv csn cdif cuni cdif vz cv vx cv vt cv csn cdif cuni cdif vz cv vx cv
      vz cv csn cdif cuni cdif vt cv vz cv vx cv vt cv csn cdif cuni difeq1 vt
      cv vz cv wceq vx cv vt cv csn cdif cuni vx cv vz cv csn cdif cuni vz cv
      vt cv vz cv wceq vx cv vt cv csn cdif vx cv vz cv csn cdif vt cv vz cv
      wceq vt cv csn vz cv csn vx cv vt cv vz cv sneq difeq2d unieqd difeq2d
      eqtrd neeq1d cbvralv vv cv vt cv vx cv vt cv csn cdif cuni cdif vy cv cin
      wcel vv weu vv cv vz cv vx cv vz cv csn cdif cuni cdif vy cv cin wcel vv
      weu vt vz vx cv vt cv vz cv wceq vv cv vt cv vx cv vt cv csn cdif cuni
      cdif vy cv cin wcel vv cv vz cv vx cv vz cv csn cdif cuni cdif vy cv cin
      wcel vv vt cv vz cv wceq vt cv vx cv vt cv csn cdif cuni cdif vy cv cin
      vz cv vx cv vz cv csn cdif cuni cdif vy cv cin vv cv vt cv vz cv wceq vt
      cv vx cv vt cv csn cdif cuni cdif vz cv vx cv vz cv csn cdif cuni cdif vy
      cv vt cv vz cv wceq vt cv vx cv vt cv csn cdif cuni cdif vz cv vx cv vt
      cv csn cdif cuni cdif vz cv vx cv vz cv csn cdif cuni cdif vt cv vz cv vx
      cv vt cv csn cdif cuni difeq1 vt cv vz cv wceq vx cv vt cv csn cdif cuni
      vx cv vz cv csn cdif cuni vz cv vt cv vz cv wceq vx cv vt cv csn cdif vx
      cv vz cv csn cdif vt cv vz cv wceq vt cv csn vz cv csn vx cv vt cv vz cv
      sneq difeq2d unieqd difeq2d eqtrd ineq1d eleq2d eubidv cbvralv imbi12i vv
      cv vz cv vx cv vz cv csn cdif cuni cdif vy cv cin wcel vv weu vz vx cv
      wral vz cv c0 wne vv cv vz cv vy cv cA cuni cin cin wcel vv weu wi vz vx
      cv wral vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx cv wral vv cv
      vz cv vx cv vz cv csn cdif cuni cdif vy cv cin wcel vv weu vz cv c0 wne
      vv cv vz cv vy cv cA cuni cin cin wcel vv weu wi vz vx cv vz cv vx cv
      wcel vv cv vz cv vx cv vz cv csn cdif cuni cdif vy cv cin wcel vv weu vv
      cv vz cv vy cv cA cuni cin cin wcel vv weu vz cv c0 wne vv cv vz cv vy cv
      cA cuni cin cin wcel vv weu wi vz cv vx cv wcel vv cv vz cv vx cv vz cv
      csn cdif cuni cdif vy cv cin wcel vv cv vz cv vy cv cA cuni cin cin wcel
      vv vz cv vx cv wcel vz cv vx cv vz cv csn cdif cuni cdif vy cv cin vz cv
      vy cv cA cuni cin cin vv cv vz cv vx cv wcel vz cv cA cuni cin vy cv cin
      vz cv vx cv vz cv csn cdif cuni cdif vy cv cin vz cv vy cv cA cuni cin
      cin vz cv vx cv wcel vz cv cA cuni cin vz cv vx cv vz cv csn cdif cuni
      cdif vy cv vx vz vu vt cA kmlem9.1 kmlem11 ineq1d vz cv vy cv cA cuni cin
      cin vy cv vz cv cA cuni cin cin vz cv cA cuni cin vy cv cin vz cv vy cv
      cA cuni in12 vy cv vz cv cA cuni cin incom eqtri syl5req eleq2d eubidv vv
      cv vz cv vy cv cA cuni cin cin wcel vv weu vz cv c0 wne ax-1 syl6bi
      r19.20i imim2i sylbi com12 vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu
      wi vz cA wral vt cv vx cv vt cv csn cdif cuni cdif c0 wne vv cv vt cv vx
      cv vt cv csn cdif cuni cdif vy cv cin wcel vv weu wi vt vx cv wral vt cv
      vx cv vt cv csn cdif cuni cdif c0 wne vt vx cv wral vv cv vt cv vx cv vt
      cv csn cdif cuni cdif vy cv cin wcel vv weu vt vx cv wral wi vz cv c0 wne
      vv cv vz cv vy cv cin wcel vv weu wi vz cA wral vz cv c0 wne vv cv vz cv
      vy cv cin wcel vv weu wi vz vu cv vt cv vx cv vt cv csn cdif cuni cdif
      wceq vt vx cv wrex vu cab wral vz cv vu cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vt vx cv wrex vu cab wcel vz cv c0 wne vv cv vz cv vy cv
      cin wcel vv weu wi wi vz wal vt cv vx cv vt cv csn cdif cuni cdif c0 wne
      vv cv vt cv vx cv vt cv csn cdif cuni cdif vy cv cin wcel vv weu wi vt vx
      cv wral cA vu cv vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex
      vu cab wceq vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz cA wral
      vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vu cv vt cv vx cv vt
      cv csn cdif cuni cdif wceq vt vx cv wrex vu cab wral wb kmlem9.1 vz cv c0
      wne vv cv vz cv vy cv cin wcel vv weu wi vz cA vu cv vt cv vx cv vt cv
      csn cdif cuni cdif wceq vt vx cv wrex vu cab raleq1 ax-mp vz cv c0 wne vv
      cv vz cv vy cv cin wcel vv weu wi vz vu cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vt vx cv wrex vu cab df-ral vz cv vu cv vt cv vx cv vt cv
      csn cdif cuni cdif wceq vt vx cv wrex vu cab wcel vz cv c0 wne vv cv vz
      cv vy cv cin wcel vv weu wi wi vz wal vz cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi wi vt vx
      cv wral vz wal vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vz cv c0
      wne vv cv vz cv vy cv cin wcel vv weu wi wi vz wal vt vx cv wral vt cv vx
      cv vt cv csn cdif cuni cdif c0 wne vv cv vt cv vx cv vt cv csn cdif cuni
      cdif vy cv cin wcel vv weu wi vt vx cv wral vz cv vu cv vt cv vx cv vt cv
      csn cdif cuni cdif wceq vt vx cv wrex vu cab wcel vz cv c0 wne vv cv vz
      cv vy cv cin wcel vv weu wi wi vz cv vt cv vx cv vt cv csn cdif cuni cdif
      wceq vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi wi vt vx cv wral
      vz vz cv vu cv vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex vu
      cab wcel vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi wi vz cv vt cv
      vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex vz cv c0 wne vv cv vz
      cv vy cv cin wcel vv weu wi wi vz cv vt cv vx cv vt cv csn cdif cuni cdif
      wceq vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi wi vt vx cv wral
      vz cv vu cv vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex vu
      cab wcel vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vt vx cv wrex vz
      cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vu cv vt cv vx cv vt cv
      csn cdif cuni cdif wceq vt vx cv wrex vz cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vt vx cv wrex vu vz cv vz visset vu cv vz cv wceq vu cv vt
      cv vx cv vt cv csn cdif cuni cdif wceq vz cv vt cv vx cv vt cv csn cdif
      cuni cdif wceq vt vx cv vu cv vz cv vt cv vx cv vt cv csn cdif cuni cdif
      eqeq1 rexbidv elab imbi1i vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq
      vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vt vx cv r19.23v bitr4i
      albii vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vz cv c0 wne vv cv
      vz cv vy cv cin wcel vv weu wi wi vt vz vx cv ralcom4 vz cv vt cv vx cv
      vt cv csn cdif cuni cdif wceq vz cv c0 wne vv cv vz cv vy cv cin wcel vv
      weu wi wi vz wal vt cv vx cv vt cv csn cdif cuni cdif c0 wne vv cv vt cv
      vx cv vt cv csn cdif cuni cdif vy cv cin wcel vv weu wi vt vx cv vz cv c0
      wne vv cv vz cv vy cv cin wcel vv weu wi vt cv vx cv vt cv csn cdif cuni
      cdif c0 wne vv cv vt cv vx cv vt cv csn cdif cuni cdif vy cv cin wcel vv
      weu wi vz vt cv vx cv vt cv csn cdif cuni cdif vt cv cvv wcel vt cv vx cv
      vt cv csn cdif cuni cdif cvv wcel vt visset vt cv vx cv vt cv csn cdif
      cuni cvv difexg ax-mp vz cv vt cv vx cv vt cv csn cdif cuni cdif wceq vz
      cv c0 wne vt cv vx cv vt cv csn cdif cuni cdif c0 wne vv cv vz cv vy cv
      cin wcel vv weu vv cv vt cv vx cv vt cv csn cdif cuni cdif vy cv cin wcel
      vv weu vz cv vt cv vx cv vt cv csn cdif cuni cdif c0 neeq1 vz cv vt cv vx
      cv vt cv csn cdif cuni cdif wceq vv cv vz cv vy cv cin wcel vv cv vt cv
      vx cv vt cv csn cdif cuni cdif vy cv cin wcel vv vz cv vt cv vx cv vt cv
      csn cdif cuni cdif wceq vz cv vy cv cin vt cv vx cv vt cv csn cdif cuni
      cdif vy cv cin vv cv vz cv vt cv vx cv vt cv csn cdif cuni cdif vy cv
      ineq1 eleq2d eubidv imbi12d ceqsalv ralbii 3bitr2i 3bitri vt cv vx cv vt
      cv csn cdif cuni cdif c0 wne vv cv vt cv vx cv vt cv csn cdif cuni cdif
      vy cv cin wcel vv weu vt vx cv r19.20 sylbi syl5 $.
      $( [12-May-2007] $) $( [27-Mar-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4 1 <=> 4. $)
    kmlem13 $p |- ( A. x ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
         E. y A. z e. x E! v v e. ( z i^i y ) ) <->
          A. x ( -. E. z e. x A. v e. z E. w e. x
                     ( z =/= w /\ v e. ( z i^i w ) ) ->
               E. y A. z e. x ( z =/= (/) ->
                    E! v v e. ( z i^i y ) ) ) ) $=
      vz cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw
      vx cv wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv
      wral vy wex wi vx wal vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx
      cv wrex vv vz cv wral vz vx cv wrex wn vz cv c0 wne vv cv vz cv vy cv cin
      wcel vv weu wi vz vx cv wral vy wex wi vx wal vz cv c0 wne vz vx cv wral
      vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa
      vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi vx wal vz cv vw
      cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral vz cv c0
      wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex wi vx wal
      vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral
      vz vx cv wrex wn vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx
      cv wral vy wex wi vx wal vz cv vw cv wne vz cv vw cv cin c0 wceq wi vv cv
      vz cv vy cv cin wcel vv weu vx vy vz vw kmlem1 vz cv vw cv wne vz cv vw
      cv cin c0 wceq wi vw vx cv wral vz vx cv wral vz cv c0 wne vv cv vz cv vy
      cv cin wcel vv weu wi vz vx cv wral vy wex wi vx wal vz cv vw cv wne vz
      cv vw cv cin c0 wceq wi vw vh cv wral vz vh cv wral vz cv c0 wne vv cv vz
      cv vy cv cin wcel vv weu wi vz vh cv wral vy wex wi vh wal vz cv vw cv
      wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv
      wrex wn vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral
      vy wex wi vx wal vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral
      vz vx cv wral vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv
      wral vy wex wi vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vh cv wral
      vz vh cv wral vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vh cv
      wral vy wex wi vx vh vx cv vh cv wceq vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vw vx cv wral vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vw vh cv wral vz vh cv wral vz cv c0 wne vv cv vz cv vy cv cin
      wcel vv weu wi vz vx cv wral vy wex vz cv c0 wne vv cv vz cv vy cv cin
      wcel vv weu wi vz vh cv wral vy wex vz cv vw cv wne vz cv vw cv cin c0
      wceq wi vw vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vh cv
      wral vz vx cv vh cv vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv
      vh cv raleq1 raleqd vx cv vh cv wceq vz cv c0 wne vv cv vz cv vy cv cin
      wcel vv weu wi vz vx cv wral vz cv c0 wne vv cv vz cv vy cv cin wcel vv
      weu wi vz vh cv wral vy vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi
      vz vx cv vh cv raleq1 exbidv imbi12d cbvalv vz cv vw cv wne vz cv vw cv
      cin c0 wceq wi vw vh cv wral vz vh cv wral vz cv c0 wne vv cv vz cv vy cv
      cin wcel vv weu wi vz vh cv wral vy wex wi vh wal vz cv vw cv wne vv cv
      vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex wn vz
      cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex wi vx
      vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vh cv wral vz vh cv wral vz
      cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vh cv wral vy wex wi vh
      wal vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz cA wral vy wex
      vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral
      vz vx cv wrex wn vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx
      cv wral vy wex wi vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vx vy
      vz vw vu vt cA vh kmlem9.1 kmlem10 vz cv c0 wne vv cv vz cv vy cv cin
      wcel vv weu wi vz cA wral vy wex vz cv c0 wne vv cv vz cv vg cv cin wcel
      vv weu wi vz cA wral vg wex vz cv vw cv wne vv cv vz cv vw cv cin wcel wa
      vw vx cv wrex vv vz cv wral vz vx cv wrex wn vz cv c0 wne vv cv vz cv vy
      cv cin wcel vv weu wi vz vx cv wral vy wex wi vz cv c0 wne vv cv vz cv vy
      cv cin wcel vv weu wi vz cA wral vz cv c0 wne vv cv vz cv vg cv cin wcel
      vv weu wi vz cA wral vy vg vy cv vg cv wceq vz cv c0 wne vv cv vz cv vy
      cv cin wcel vv weu wi vz cv c0 wne vv cv vz cv vg cv cin wcel vv weu wi
      vz cA vy cv vg cv wceq vv cv vz cv vy cv cin wcel vv weu vv cv vz cv vg
      cv cin wcel vv weu vz cv c0 wne vy cv vg cv wceq vv cv vz cv vy cv cin
      wcel vv cv vz cv vg cv cin wcel vv vy cv vg cv wceq vz cv vy cv cin vz cv
      vg cv cin vv cv vy cv vg cv vz cv ineq2 eleq2d eubidv imbi2d ralbidv
      cbvexv vz cv c0 wne vv cv vz cv vg cv cin wcel vv weu wi vz cA wral vg
      wex vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx cv wral vz cv c0
      wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex vz cv vw cv
      wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv
      wrex wn vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz vx cv wral vz cv
      c0 wne vv cv vz cv vg cv cin wcel vv weu wi vz cA wral vg wex vz cv c0
      wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex vz cv vx cv
      vz cv csn cdif cuni cdif c0 wne vz vx cv wral vz cv c0 wne vv cv vz cv vg
      cv cin wcel vv weu wi vz cA wral vz cv c0 wne vv cv vz cv vy cv cin wcel
      vv weu wi vz vx cv wral vy wex vg vz cv vx cv vz cv csn cdif cuni cdif c0
      wne vz vx cv wral vz cv c0 wne vv cv vz cv vg cv cin wcel vv weu wi vz cA
      wral vz cv c0 wne vv cv vz cv vg cv cA cuni cin cin wcel vv weu wi vz vx
      cv wral vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral
      vy wex vx vg vz vv vu vt cA kmlem9.1 kmlem12 vz cv c0 wne vv cv vz cv vy
      cv cin wcel vv weu wi vz vx cv wral vz cv c0 wne vv cv vz cv vg cv cA
      cuni cin cin wcel vv weu wi vz vx cv wral vy vg cv cA cuni cin vg cv cA
      cuni vg visset inex1 vy cv vg cv cA cuni cin wceq vz cv c0 wne vv cv vz
      cv vy cv cin wcel vv weu wi vz cv c0 wne vv cv vz cv vg cv cA cuni cin
      cin wcel vv weu wi vz vx cv vy cv vg cv cA cuni cin wceq vv cv vz cv vy
      cv cin wcel vv weu vv cv vz cv vg cv cA cuni cin cin wcel vv weu vz cv c0
      wne vy cv vg cv cA cuni cin wceq vv cv vz cv vy cv cin wcel vv cv vz cv
      vg cv cA cuni cin cin wcel vv vy cv vg cv cA cuni cin wceq vz cv vy cv
      cin vz cv vg cv cA cuni cin cin vv cv vy cv vg cv cA cuni cin vz cv ineq2
      eleq2d eubidv imbi2d ralbidv cla4ev syl6 19.23adv com12 vz cv vx cv vz cv
      csn cdif cuni cdif c0 wne vz vx cv wral vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wa vw vx cv wrex vv vz cv wral wn vz vx cv wral vz cv vw cv wne
      vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex
      wn vz cv vx cv vz cv csn cdif cuni cdif c0 wne vz cv vw cv wne vv cv vz
      cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral wn vz vx cv vz cv vx cv
      vz cv csn cdif cuni cdif c0 wne vz cv vw cv wne vv cv vz cv vw cv cin
      wcel wn wi vw vx cv wral vv vz cv wrex vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wa vw vx cv wrex wn vv vz cv wrex vz cv vw cv wne vv cv vz cv vw
      cv cin wcel wa vw vx cv wrex vv vz cv wral wn vx vz vw vv kmlem3 vz cv vw
      cv wne vv cv vz cv vw cv cin wcel wn wi vw vx cv wral vz cv vw cv wne vv
      cv vz cv vw cv cin wcel wa vw vx cv wrex wn vv vz cv vz cv vw cv wne vv
      cv vz cv vw cv cin wcel vw vx cv ralinexa rexbii vz cv vw cv wne vv cv vz
      cv vw cv cin wcel wa vw vx cv wrex vv vz cv rexnal 3bitri ralbii vz cv vw
      cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv
      ralnex bitri syl5ibr sylbi syl 19.21aiv sylbi syl vz cv vw cv wne vv cv
      vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex wn vz
      cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex wi vz
      cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx
      cv wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral
      vy wex wi vx vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex
      vv vz cv wral vz vx cv wrex wn vz cv c0 wne vv cv vz cv vy cv cin wcel vv
      weu wi vz vx cv wral vy wex wi vz cv c0 wne vz vx cv wral vz cv vw cv wne
      vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vz cv c0 wne vv
      cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex wi vz cv c0 wne vz
      vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx
      cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi vz
      cv c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx
      cv wral vz vx cv wral wa vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw
      vx cv wrex vv vz cv wral vz vx cv wrex wn vz cv c0 wne vv cv vz cv vy cv
      cin wcel vv weu wi vz vx cv wral vy wex vx vz vw vv kmlem7 imim1i vz cv
      c0 wne vz vx cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv
      wral vz vx cv wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy
      wex vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy
      wex vz cv c0 wne vz vx cv wral vv cv vz cv vy cv cin wcel vv weu vz vx cv
      wral vy wex vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv
      wral vy wex wb vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral
      vz vx cv wral vz cv c0 wne vz vx cv wral vv cv vz cv vy cv cin wcel vv
      weu vz vx cv wral vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx
      cv wral vy vz cv c0 wne vz vx cv wral vv cv vz cv vy cv cin wcel vv weu
      vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi wb vz vx cv wral vv cv
      vz cv vy cv cin wcel vv weu vz vx cv wral vz cv c0 wne vv cv vz cv vy cv
      cin wcel vv weu wi vz vx cv wral wb vz cv c0 wne vv cv vz cv vy cv cin
      wcel vv weu vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi wb vz vx cv
      vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu biimt r19.20si vv cv vz cv
      vy cv cin wcel vv weu vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi
      vz vx cv r19.15 syl exbidv adantr pm5.74i sylibr 19.20i impbii $.
      $( [12-Oct-2007] $) $( [5-Apr-2004] $)
  $}

  ${
    $d x y z w v u $.  $d u ph $.
    kmlem14.1 $e |- ( ph <->
                ( z e. y -> ( ( v e. x /\ y =/= v ) /\ z e. v ) ) ) $.
    kmlem14.2 $e |- ( ps <-> ( z e. x -> ( ( v e. z /\ v e. y ) /\
                ( ( u e. z /\ u e. y ) -> u = v ) ) ) ) $.
    kmlem14.3 $e |- ( ch <->
                A. z e. x E! v v e. ( z i^i y ) ) $.
    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 5 <=> 4. $)
    kmlem14 $p |- ( E. z e. x A. v e. z  E. w e. x
                   ( z =/= w /\ v e. ( z i^i w ) ) <->
                 E. y A. z E. v A. u ( y e. x /\ ph ) ) $=
      vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral
      vz vx cv wrex vy cv vw cv wne vv cv vy cv vw cv cin wcel wa vw vx cv wrex
      vv vy cv wral vy vx cv wrex vy cv vx cv wcel vy cv vw cv wne vv cv vy cv
      vw cv cin wcel wa vw vx cv wrex vv vy cv wral wa vy wex vy cv vx cv wcel
      wph wa vu wal vv wex vz wal vy wex vz cv vw cv wne vv cv vz cv vw cv cin
      wcel wa vw vx cv wrex vv vz cv wral vy cv vw cv wne vv cv vy cv vw cv cin
      wcel wa vw vx cv wrex vv vy cv wral vz vy vx cv vz cv vw cv wne vv cv vz
      cv vw cv cin wcel wa vw vx cv wrex vy cv vw cv wne vv cv vy cv vw cv cin
      wcel wa vw vx cv wrex vv vz cv vy cv vz cv vy cv wceq vz cv vw cv wne vv
      cv vz cv vw cv cin wcel wa vy cv vw cv wne vv cv vy cv vw cv cin wcel wa
      vw vx cv vz cv vy cv wceq vz cv vw cv wne vy cv vw cv wne vv cv vz cv vw
      cv cin wcel vv cv vy cv vw cv cin wcel vz cv vy cv vw cv neeq1 vz cv vy
      cv wceq vz cv vw cv cin vy cv vw cv cin vv cv vz cv vy cv vw cv ineq1
      eleq2d anbi12d rexbidv raleqd cbvrexv vy cv vw cv wne vv cv vy cv vw cv
      cin wcel wa vw vx cv wrex vv vy cv wral vy vx cv df-rex vy cv vx cv wcel
      vy cv vw cv wne vv cv vy cv vw cv cin wcel wa vw vx cv wrex vv vy cv wral
      wa vy cv vx cv wcel wph wa vu wal vv wex vz wal vy vy cv vx cv wcel vy cv
      vw cv wne vv cv vy cv vw cv cin wcel wa vw vx cv wrex vv vy cv wral wa vy
      cv vx cv wcel vz cv vy cv wcel vy cv vw cv wne vz cv vy cv vw cv cin wcel
      wa vw vx cv wrex wi vz wal wa vy cv vx cv wcel vz cv vy cv wcel vy cv vw
      cv wne vz cv vy cv vw cv cin wcel wa vw vx cv wrex wi wa vz wal vy cv vx
      cv wcel wph wa vu wal vv wex vz wal vy cv vw cv wne vv cv vy cv vw cv cin
      wcel wa vw vx cv wrex vv vy cv wral vz cv vy cv wcel vy cv vw cv wne vz
      cv vy cv vw cv cin wcel wa vw vx cv wrex wi vz wal vy cv vx cv wcel vy cv
      vw cv wne vv cv vy cv vw cv cin wcel wa vw vx cv wrex vv vy cv wral vy cv
      vw cv wne vz cv vy cv vw cv cin wcel wa vw vx cv wrex vz vy cv wral vz cv
      vy cv wcel vy cv vw cv wne vz cv vy cv vw cv cin wcel wa vw vx cv wrex wi
      vz wal vy cv vw cv wne vv cv vy cv vw cv cin wcel wa vw vx cv wrex vy cv
      vw cv wne vz cv vy cv vw cv cin wcel wa vw vx cv wrex vv vz vy cv vv cv
      vz cv wceq vy cv vw cv wne vv cv vy cv vw cv cin wcel wa vy cv vw cv wne
      vz cv vy cv vw cv cin wcel wa vw vx cv vv cv vz cv wceq vv cv vy cv vw cv
      cin wcel vz cv vy cv vw cv cin wcel vy cv vw cv wne vv cv vz cv vy cv vw
      cv cin eleq1 anbi2d rexbidv cbvralv vy cv vw cv wne vz cv vy cv vw cv cin
      wcel wa vw vx cv wrex vz vy cv df-ral bitri anbi2i vy cv vx cv wcel vz cv
      vy cv wcel vy cv vw cv wne vz cv vy cv vw cv cin wcel wa vw vx cv wrex wi
      vz 19.28v vy cv vx cv wcel vz cv vy cv wcel vy cv vw cv wne vz cv vy cv
      vw cv cin wcel wa vw vx cv wrex wi wa vy cv vx cv wcel wph wa vu wal vv
      wex vz vy cv vx cv wcel vz cv vy cv wcel vy cv vw cv wne vz cv vy cv vw
      cv cin wcel wa vw vx cv wrex wi wa vy cv vx cv wcel vz cv vy cv wcel vv
      cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa wi vv wex
      wa vy cv vx cv wcel vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wne vz
      cv vy cv vv cv cin wcel wa wa wi wa vv wex vy cv vx cv wcel wph wa vu wal
      vv wex vz cv vy cv wcel vy cv vw cv wne vz cv vy cv vw cv cin wcel wa vw
      vx cv wrex wi vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wne vz cv vy
      cv vv cv cin wcel wa wa wi vv wex vy cv vx cv wcel vz cv vy cv wcel vy cv
      vw cv wne vz cv vy cv vw cv cin wcel wa vw vx cv wrex wi vz cv vy cv wcel
      vv cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa vv wex
      wi vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv
      cin wcel wa wa wi vv wex vy cv vw cv wne vz cv vy cv vw cv cin wcel wa vw
      vx cv wrex vv cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa
      wa vv wex vz cv vy cv wcel vy cv vw cv wne vz cv vy cv vw cv cin wcel wa
      vw vx cv wrex vy cv vv cv wne vz cv vy cv vv cv cin wcel wa vv vx cv wrex
      vv cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa vv wex
      vy cv vw cv wne vz cv vy cv vw cv cin wcel wa vy cv vv cv wne vz cv vy cv
      vv cv cin wcel wa vw vv vx cv vw cv vv cv wceq vy cv vw cv wne vy cv vv
      cv wne vz cv vy cv vw cv cin wcel vz cv vy cv vv cv cin wcel vw cv vv cv
      vy cv neeq2 vw cv vv cv wceq vy cv vw cv cin vy cv vv cv cin vz cv vw cv
      vv cv vy cv ineq2 eleq2d anbi12d cbvrexv vy cv vv cv wne vz cv vy cv vv
      cv cin wcel wa vv vx cv df-rex bitri imbi2i vz cv vy cv wcel vv cv vx cv
      wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa vv 19.37v bitr4i
      anbi2i vy cv vx cv wcel vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wne
      vz cv vy cv vv cv cin wcel wa wa wi vv 19.42v vy cv vx cv wcel vz cv vy
      cv wcel vv cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa
      wi wa vy cv vx cv wcel wph wa vu wal vv vy cv vx cv wcel wph wa vu wal vy
      cv vx cv wcel wph wa vy cv vx cv wcel vz cv vy cv wcel vv cv vx cv wcel
      vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa wi wa vy cv vx cv wcel
      wph wa vu vy cv vx cv wcel wph wa vu ax-17 19.3 wph vz cv vy cv wcel vv
      cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel wa wa wi vy cv
      vx cv wcel wph vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wne wa vz cv
      vv cv wcel wa wi vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wne vz cv
      vy cv vv cv cin wcel wa wa wi kmlem14.1 vz cv vy cv wcel vv cv vx cv wcel
      vy cv vv cv wne wa vz cv vv cv wcel wa vv cv vx cv wcel vy cv vv cv wne
      vz cv vy cv vv cv cin wcel wa wa vz cv vy cv wcel vv cv vx cv wcel vy cv
      vv cv wne wa vz cv vv cv wcel wa vv cv vx cv wcel vy cv vv cv wne wa vz
      cv vy cv vv cv cin wcel wa vv cv vx cv wcel vy cv vv cv wne vz cv vy cv
      vv cv cin wcel wa wa vz cv vy cv wcel vz cv vv cv wcel vz cv vy cv vv cv
      cin wcel vv cv vx cv wcel vy cv vv cv wne wa vz cv vy cv vv cv cin wcel
      vz cv vy cv wcel vz cv vv cv wcel vz cv vy cv vv cv elin baibr anbi2d vv
      cv vx cv wcel vy cv vv cv wne vz cv vy cv vv cv cin wcel anass syl6bb
      pm5.74i bitri anbi2i bitr2i exbii 3bitr2i albii 3bitr2i exbii 3bitri $.
      $( [12-Oct-2007] $) $( [4-Apr-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 5 <=> 4. $)
    kmlem15 $p |- ( ( -. y e. x /\ ch ) <->
                     A. z E. v A. u ( -. y e. x /\ ps ) ) $=
      vy cv vx cv wcel wn wch wa vy cv vx cv wcel wn wps vu wal vv wex vz wal
      wa vy cv vx cv wcel wn wps vu wal vv wex wa vz wal vy cv vx cv wcel wn
      wps wa vu wal vv wex vz wal wch wps vu wal vv wex vz wal vy cv vx cv wcel
      wn wch vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vv cv vz cv wcel
      vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq
      wi wa vu wal vv wex vz vx cv wral wps vu wal vv wex vz wal kmlem14.3 vv
      cv vz cv vy cv cin wcel vv weu vv cv vz cv wcel vv cv vy cv wcel wa vu cv
      vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa vu wal vv wex vz vx
      cv vv cv vz cv vy cv cin wcel vv weu vv cv vz cv vy cv cin wcel vv cv vz
      cv vy cv cin wcel vv vu cv wsbc vv cv vu cv wceq wi vu wal wa vv wex vv
      cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu
      cv vv cv wceq wi wa vu wal vv wex vv cv vz cv vy cv cin wcel vv vu vv cv
      vz cv vy cv cin wcel vu ax-17 eu1 vv cv vz cv vy cv cin wcel vv cv vz cv
      vy cv cin wcel vv vu cv wsbc vv cv vu cv wceq wi vu wal wa vv cv vz cv
      wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv
      wceq wi wa vu wal vv vv cv vz cv vy cv cin wcel vv cv vz cv vy cv cin
      wcel vv vu cv wsbc vv cv vu cv wceq wi vu wal wa vv cv vz cv wcel vv cv
      vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi vu
      wal wa vv cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv
      wcel wa vu cv vv cv wceq wi wa vu wal vv cv vz cv vy cv cin wcel vv cv vz
      cv wcel vv cv vy cv wcel wa vv cv vz cv vy cv cin wcel vv vu cv wsbc vv
      cv vu cv wceq wi vu wal vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv
      wceq wi vu wal vv cv vz cv vy cv elin vv cv vz cv vy cv cin wcel vv vu cv
      wsbc vv cv vu cv wceq wi vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv
      wceq wi vu vv cv vz cv vy cv cin wcel vv vu cv wsbc vu cv vz cv wcel vu
      cv vy cv wcel wa vv cv vu cv wceq vu cv vv cv wceq vv cv vz cv vy cv cin
      wcel vv vu cv wsbc vu cv vz cv vy cv cin wcel vu cv vz cv wcel vu cv vy
      cv wcel wa vv cv vz cv vy cv cin wcel vu cv vz cv vy cv cin wcel vv vu vu
      cv vz cv vy cv cin wcel vv ax-17 vv cv vu cv vz cv vy cv cin eleq1 sbie
      vu cv vz cv vy cv elin bitri vv cv vu cv eqcom imbi12i albii anbi12i vv
      cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu
      cv vv cv wceq wi vu 19.28v bitr4i exbii bitri ralbii vv cv vz cv wcel vv
      cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi
      wa vu wal vv wex vz vx cv wral vz cv vx cv wcel vv cv vz cv wcel vv cv vy
      cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa vu
      wal vv wex wi vz wal wps vu wal vv wex vz wal vv cv vz cv wcel vv cv vy
      cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa vu
      wal vv wex vz vx cv df-ral wps vu wal vv wex vz cv vx cv wcel vv cv vz cv
      wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv
      wceq wi wa vu wal vv wex wi vz wps vu wal vv wex vz cv vx cv wcel vv cv
      vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv
      vv cv wceq wi wa vu wal wi vv wex vz cv vx cv wcel vv cv vz cv wcel vv cv
      vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa
      vu wal vv wex wi wps vu wal vz cv vx cv wcel vv cv vz cv wcel vv cv vy cv
      wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa vu
      wal wi vv wps vu wal vz cv vx cv wcel vv cv vz cv wcel vv cv vy cv wcel
      wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa wi vu wal
      vz cv vx cv wcel vv cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu
      cv vy cv wcel wa vu cv vv cv wceq wi wa vu wal wi wps vz cv vx cv wcel vv
      cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu
      cv vv cv wceq wi wa wi vu kmlem14.2 albii vz cv vx cv wcel vv cv vz cv
      wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv
      wceq wi wa vu 19.21v bitri exbii vz cv vx cv wcel vv cv vz cv wcel vv cv
      vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa
      vu wal vv 19.37v bitri albii bitr4i 3bitri anbi2i vy cv vx cv wcel wn wps
      vu wal vv wex vz 19.28v vy cv vx cv wcel wn wps vu wal vv wex wa vy cv vx
      cv wcel wn wps wa vu wal vv wex vz vy cv vx cv wcel wn wps wa vu wal vv
      wex vy cv vx cv wcel wn wps vu wal wa vv wex vy cv vx cv wcel wn wps vu
      wal vv wex wa vy cv vx cv wcel wn wps wa vu wal vy cv vx cv wcel wn wps
      vu wal wa vv vy cv vx cv wcel wn wps vu 19.28v exbii vy cv vx cv wcel wn
      wps vu wal vv 19.42v bitr2i albii 3bitr2i $.
      $( [10-Apr-2004] $) $( [4-Apr-2004] $)

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4 5 <=> 4. $)
    kmlem16 $p |- ( ( E. z e. x A. v e. z  E. w e. x
       ( z =/= w /\ v e. ( z i^i w ) ) \/ E. y ( -. y e. x /\ ch ) ) <->
       E. y A. z E. v A. u ( ( y e. x /\ ph ) \/ ( -. y e. x /\ ps ) ) ) $=
      vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral
      vz vx cv wrex vy cv vx cv wcel wn wch wa vy wex wo vy cv vx cv wcel wph
      wa vu wal vv wex vz wal vy wex vy cv vx cv wcel wn wps wa vu wal vv wex
      vz wal vy wex wo vy cv vx cv wcel wph wa vu wal vv wex vz wal vy cv vx cv
      wcel wn wps wa vu wal vv wex vz wal wo vy wex vy cv vx cv wcel wph wa vy
      cv vx cv wcel wn wps wa wo vu wal vv wex vz wal vy wex vz cv vw cv wne vv
      cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex vy
      cv vx cv wcel wph wa vu wal vv wex vz wal vy wex vy cv vx cv wcel wn wch
      wa vy wex vy cv vx cv wcel wn wps wa vu wal vv wex vz wal vy wex wph wps
      wch vx vy vz vw vv vu kmlem14.1 kmlem14.2 kmlem14.3 kmlem14 vy cv vx cv
      wcel wn wch wa vy cv vx cv wcel wn wps wa vu wal vv wex vz wal vy wph wps
      wch vx vy vz vv vu kmlem14.1 kmlem14.2 kmlem14.3 kmlem15 exbii orbi12i vy
      cv vx cv wcel wph wa vu wal vv wex vz wal vy cv vx cv wcel wn wps wa vu
      wal vv wex vz wal vy 19.43 vy cv vx cv wcel wph wa vu wal vv wex vz wal
      vy cv vx cv wcel wn wps wa vu wal vv wex vz wal wo vy cv vx cv wcel wph
      wa vy cv vx cv wcel wn wps wa wo vu wal vv wex vz wal vy vy cv vx cv wcel
      wph wa vu wal vv wex vz wal vy cv vx cv wcel wn wps wa vu wal vv wex vz
      wal wo vy cv vx cv wcel wph wa vu wal vv wex vy cv vx cv wcel wn wps wa
      vu wal vv wex wo vz wal vy cv vx cv wcel wph wa vy cv vx cv wcel wn wps
      wa wo vu wal vv wex vz wal vy cv vx cv wcel wph wa vu wal vv wex vz wex
      vy cv vx cv wcel wn wps wa vu wal vv wex vz wex wa wn vy cv vx cv wcel
      wph wa vu wal vv wex vy cv vx cv wcel wn wps wa vu wal vv wex wo vz wal
      vy cv vx cv wcel wph wa vu wal vv wex vz wal vy cv vx cv wcel wn wps wa
      vu wal vv wex vz wal wo wb vy cv vx cv wcel wph wa vu wal vv wex vz wex
      vy cv vx cv wcel wn wps wa vu wal vv wex vz wex wa vy cv vx cv wcel vy cv
      vx cv wcel wn wa vy cv vx cv wcel pm3.24 vy cv vx cv wcel wph wa vu wal
      vv wex vz wex vy cv vx cv wcel vy cv vx cv wcel wn wps wa vu wal vv wex
      vz wex vy cv vx cv wcel wn vy cv vx cv wcel wph wa vu wal vy cv vx cv
      wcel vz vv vy cv vx cv wcel wph wa vy cv vx cv wcel vu vy cv vx cv wcel
      wph pm3.26 a4s 19.23aivv vy cv vx cv wcel wn wps wa vu wal vy cv vx cv
      wcel wn vz vv vy cv vx cv wcel wn wps wa vy cv vx cv wcel wn vu vy cv vx
      cv wcel wn wps pm3.26 a4s 19.23aivv anim12i mto vy cv vx cv wcel wph wa
      vu wal vv wex vy cv vx cv wcel wn wps wa vu wal vv wex vz 19.33b ax-mp vy
      cv vx cv wcel wph wa vu wal vv wex vy cv vx cv wcel wn wps wa vu wal vv
      wex wo vy cv vx cv wcel wph wa vy cv vx cv wcel wn wps wa wo vu wal vv
      wex vz vy cv vx cv wcel wph wa vy cv vx cv wcel wn wps wa wo vu wal vv
      wex vy cv vx cv wcel wph wa vu wal vy cv vx cv wcel wn wps wa vu wal wo
      vv wex vy cv vx cv wcel wph wa vu wal vv wex vy cv vx cv wcel wn wps wa
      vu wal vv wex wo vy cv vx cv wcel wph wa vy cv vx cv wcel wn wps wa wo vu
      wal vy cv vx cv wcel wph wa vu wal vy cv vx cv wcel wn wps wa vu wal wo
      vv vy cv vx cv wcel wph wa vu wex vy cv vx cv wcel wn wps wa vu wex wa wn
      vy cv vx cv wcel wph wa vy cv vx cv wcel wn wps wa wo vu wal vy cv vx cv
      wcel wph wa vu wal vy cv vx cv wcel wn wps wa vu wal wo wb vy cv vx cv
      wcel wph wa vu wex vy cv vx cv wcel wn wps wa vu wex wa vy cv vx cv wcel
      vy cv vx cv wcel wn wa vy cv vx cv wcel pm3.24 vy cv vx cv wcel wph wa vu
      wex vy cv vx cv wcel vy cv vx cv wcel wn wps wa vu wex vy cv vx cv wcel
      wn vy cv vx cv wcel wph wa vy cv vx cv wcel vu vy cv vx cv wcel wph
      pm3.26 19.23aiv vy cv vx cv wcel wn wps wa vy cv vx cv wcel wn vu vy cv
      vx cv wcel wn wps pm3.26 19.23aiv anim12i mto vy cv vx cv wcel wph wa vy
      cv vx cv wcel wn wps wa vu 19.33b ax-mp exbii vy cv vx cv wcel wph wa vu
      wal vy cv vx cv wcel wn wps wa vu wal vv 19.43 bitr2i albii bitr3i exbii
      3bitr2i $.
      $( [12-Oct-2007] $) $( [4-Apr-2004] $)
  $}

  ${
    $d x y z w v u f t h $.
    $( Equivalence of the Axiom of Choice (first form) of [Enderton] p. 49 and
       Maes' AC ~ ackm .  The proof consists of lemmas ~ kmlem1 through
       ~ kmlem16 and this final theorem.  AC is not used for the proof.
       Note:  bypassing the first step (i.e. replacing ~ aceq5 with ~ biid )
       establishes the AC equivalence shown by Mae's writeup.  The
       left-hand-side AC shown here was chosen because it is shorter to
       display. $)
    aceqkm $p |- ( A. x E. f ( f C_ x /\ f Fn dom x ) <->
      A. x E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vx wal vz cv c0 wne vz vx
      cv wral vz cv vw cv wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv
      wral wa vv cv vz cv vy cv cin wcel vv weu vz vx cv wral vy wex wi vx wal
      vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral
      vz vx cv wrex vy cv vx cv wcel wn vv cv vz cv vy cv cin wcel vv weu vz vx
      cv wral wa vy wex wo vx wal vy cv vx cv wcel vz cv vy cv wcel vv cv vx cv
      wcel vy cv vv cv wceq wn wa vz cv vv cv wcel wa wi wa vy cv vx cv wcel wn
      vz cv vx cv wcel vv cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu
      cv vy cv wcel wa vu cv vv cv wceq wi wa wi wa wo vu wal vv wex vz wal vy
      wex vx wal vx vy vz vw vv vf aceq5 vz cv c0 wne vz vx cv wral vz cv vw cv
      wne vz cv vw cv cin c0 wceq wi vw vx cv wral vz vx cv wral wa vv cv vz cv
      vy cv cin wcel vv weu vz vx cv wral vy wex wi vx wal vz cv vw cv wne vv
      cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex wn
      vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral vy wex wi
      vx wal vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz
      cv wral vz vx cv wrex vy cv vx cv wcel wn vv cv vz cv vy cv cin wcel vv
      weu vz vx cv wral wa vy wex wo vx wal vx vy vz vw vv vt vh vt cv vh cv vx
      cv vh cv csn cdif cuni cdif wceq vh vx cv wrex vt cab vt cv vh cv vx cv
      vh cv csn cdif cuni cdif wceq vh vx cv wrex vt cab eqid kmlem13 vz cv vw
      cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv
      wrex wn vz cv c0 wne vv cv vz cv vy cv cin wcel vv weu wi vz vx cv wral
      vy wex wi vz cv vw cv wne vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv
      vz cv wral vz vx cv wrex vy cv vx cv wcel wn vv cv vz cv vy cv cin wcel
      vv weu vz vx cv wral wa vy wex wo vx vz cv vw cv wne vv cv vz cv vw cv
      cin wcel wa vw vx cv wrex vy vz vv vx kmlem8 albii bitri vz cv vw cv wne
      vv cv vz cv vw cv cin wcel wa vw vx cv wrex vv vz cv wral vz vx cv wrex
      vy cv vx cv wcel wn vv cv vz cv vy cv cin wcel vv weu vz vx cv wral wa vy
      wex wo vy cv vx cv wcel vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv
      wceq wn wa vz cv vv cv wcel wa wi wa vy cv vx cv wcel wn vz cv vx cv wcel
      vv cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa
      vu cv vv cv wceq wi wa wi wa wo vu wal vv wex vz wal vy wex vx vz cv vy
      cv wcel vv cv vx cv wcel vy cv vv cv wceq wn wa vz cv vv cv wcel wa wi vz
      cv vx cv wcel vv cv vz cv wcel vv cv vy cv wcel wa vu cv vz cv wcel vu cv
      vy cv wcel wa vu cv vv cv wceq wi wa wi vv cv vz cv vy cv cin wcel vv weu
      vz vx cv wral vx vy vz vw vv vu vv cv vx cv wcel vy cv vv cv wceq wn wa
      vz cv vv cv wcel wa vv cv vx cv wcel vy cv vv cv wne wa vz cv vv cv wcel
      wa vz cv vy cv wcel vv cv vx cv wcel vy cv vv cv wceq wn wa vv cv vx cv
      wcel vy cv vv cv wne wa vz cv vv cv wcel vy cv vv cv wceq wn vy cv vv cv
      wne vv cv vx cv wcel vy cv vv cv wne vy cv vv cv wceq wn vy cv vv cv
      df-ne bicomi anbi2i anbi1i imbi2i vz cv vx cv wcel vv cv vz cv wcel vv cv
      vy cv wcel wa vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa
      wi biid vv cv vz cv vy cv cin wcel vv weu vz vx cv wral biid kmlem16
      albii 3bitri $.
      $( [6-May-2004] $) $( [13-Apr-2004] $)
  $}

  ${
    $d x y z w v u f t h $.
    $( A remarkable equivalent to the Axiom of Choice that has only 5
       quantifiers (when expanded to ` e. ` , ` = ` primitives in prenex form),
       discovered and proved by Kurt Maes.  This establishes a new record,
       reducing from 6 to 5 the largest number of quantified variables needed
       by any ZFC axiom.    The ZF-equivalence to AC is shown by theorem
       ~ aceqkm .  Maes found this version of AC in April, 2004 (replacing a
       longer version, also with 5 quantifiers, that he found in November,
       2003).  See  Kurt Maes, "A 5-quantifier ( ` e. ` ,=)-expression
       ZF-equivalent to the Axiom of Choice"
       ( ~ http://arxiv.org/PS_cache/arxiv/pdf/0705/0705.3162v1.pdf ).

       The original FOM posts are:
       ~ http://www.cs.nyu.edu/pipermail/fom/2003-November/007631.html
       ~ http://www.cs.nyu.edu/pipermail/fom/2003-November/007641.html . $)
    ackm $p |- A. x E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) $=
      vf cv vx cv wss vf cv vx cv cdm wfn wa vf wex vy cv vx cv wcel vz cv vy
      cv wcel vv cv vx cv wcel vy cv vv cv wceq wn wa vz cv vv cv wcel wa wi wa
      vy cv vx cv wcel wn vz cv vx cv wcel vv cv vz cv wcel vv cv vy cv wcel wa
      vu cv vz cv wcel vu cv vy cv wcel wa vu cv vv cv wceq wi wa wi wa wo vu
      wal vv wex vz wal vy wex vx wal vx vx vy vz vv vu vf aceqkm vx vf ac7
      mpgbi $.
      $( [6-May-2004] $) $( [29-Apr-2004] $)

$(
    @( DELETE THIS @)
    ackmxx @p |- ( A. x E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) <-> ph ) @=
      ( cv wcel wceq wn wa wi wo wal wex df-ex df-or df-an imbi1i notbii bitri
      imbi2i imbi12i albii bicomi ) ACGZBGZHZDGZUFHZEGZUGHZUFUKIJZKZUIUKHZKZLZK
      ZUHJZUIUGHZUKUIHZUKUFHZKZFGZUIHZVDUFHZKZVDUKIZLZKZLZKZMZFNZEOZDNZCOZBNZAU
      HUJULUMJLJZUOJZLZJZLZJZLZJZJZUSUTVAVBJLJZVEVFJLJZVHLZJZLZJZLZJZLZJZLZFNZJ
      ZENZJZDNZJZCNZJZBNZVR?VRXGVQXFBVQVPJZCNZJXFVPCPXIXEXHXDCVPXCVOXBDVOVNJZEN
      ZJXBVNEPXKXAXJWTEVNWSVMWRFVMURJZVLLWRURVLQXLWGVLWQURWFURUHUQJZLZJWFUHUQRX
      NWEXMWDUHUQWCUPWBUJUPUNVTLZJWBUNUORXOWAUNVSVTULUMRSTUAUBTUBTUATVLUSVKJZLZ
      JWQUSVKRXQWPXPWOUSVKWNVJWMUTVJVCVIJZLZJWMVCVIRXSWLVCWHXRWKVAVBRVIWJVGWIVH
      VEVFRSTUCTUAUBTUBTUAUCUAUDTUDTUAUDTUDTUAUDUEUAUE @.
      @( [ ?] @) @( [2-Feb-2006] @)

    axacxx @p  |- ( E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u ( E. t
              ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) )
<-> ph ) @=
      ( cv wcel wa wex wceq wb wal wi wn df-ex df-an dfbi1 notbii imbi12i bitri
      albii imbi1i imbi2i bicomi ) ADIEIZJZUHBIJZKZGIZUHJZUHHIZJZKZULUNJZUNCIJZ
      KZKZHLZULFIMZNZGOZFLZPZEOZDOZCLZAUIUJQPQZUMUOQPQZUQURQPQZQZPZQZQZHOZQZVBP
      ZVBVRPZQZPZQZGOZQZFOZQZPZEOZDOZQZCOZQZVI?VIWMVIVHQZCOZQWMVHCRWOWLWNWKCVHW
      JVGWIDVFWHEUKVJVEWGUIUJSVEVDQZFOZQWGVDFRWQWFWPWEFVDWDVCWCGVCVAVBPZVBVAPZQ
      ZPZQWCVAVBTXAWBWRVSWTWAVAVRVBVAUTQZHOZQVRUTHRXCVQXBVPHUTVOUTUPUSQZPZQVOUP
      USSXEVNUPVKXDVMUMUOSUSVLUQURSUAUBUAUCUAUDUAUCZUEWSVTVAVRVBXFUFUAUBUAUCUDU
      AUDUAUCUBUDUDUAUDUAUCUGUCUG @.
      @( [ ?] @) @( [2-Feb-2006] @)

Maes expanded to primitives -  94 symbols
A.  4
e. 10
-> 11
-. 17
(  11
)  11
=   2
var occ 28
vars 5

-. A. y -. A. z -. A. v -. A. u ( ( y e. x -> -. ( z e. y -> -. ( -. ( v
e. x -> y = v ) -> -. z e. v ) ) ) -> -. ( -. y e. x -> -. ( z e. x ->
-. ( -. ( v e. z -> -. v e. y ) -> -. ( -. ( u e. z -> -. u e. y ) -> u
= v ) ) ) ) )

ax-ac expanded to primitives - 99 symbols

A.  7
e. 10
-> 11
-. 16
(  11
)  11
=   2
var occ 31
vars 7

-. A. y -. A. z A. w ( -. ( z e. w -> -. w e. x ) -> -. A. v -. A. u -.
( ( -. A. t ( -. ( u e. w -> -. w e. t ) -> ( u e. t -> -. t e. y ) ) ->
u = v ) -> -. ( u = v -> -. A. t ( -. ( u e. w -> -. w e. t ) -> ( u e.
t -> -. t e. y ) ) ) ) )
$)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       AC equivalents:  well ordering, Zorn's lemma
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)
  ${
    $d x y z f g A $.  $d x y f B $.  $d x y f F $.  $d x y f G $.
    numthlem.1 $e |- A e. _V $.
    $( Hypotheses for transfinite recursion. $)
    numthlem.2 $e |- B = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( G ` ( f |` y ) ) ) } $.
    numthlem.3 $e |- F = U. B $.
    $( Generator function.  ` g ` is a choice function on ` ~P A ` . $)
    numthlem.4 $e |- G = { <. f , y >. | y = ( g ` ( A \ ran f ) ) } $.
    $( Lemma for ~ numth . $)
    numthlem $p |- E. x e. On E. f f : x -1-1-onto-> A $=
      vy cv c0 wne vy cv vg cv cfv vy cv wcel wi vy cA cpw wral vg wex vx cv cA
      vf cv wf1o vf wex vx con0 wrex vy cA cpw vg cA numthlem.1 pwex ac4c vy cv
      c0 wne vy cv vg cv cfv vy cv wcel wi vy cA cpw wral vx cv cA vf cv wf1o
      vf wex vx con0 wrex vg vy cv c0 wne vy cv vg cv cfv vy cv wcel wi vy cA
      cpw wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima cdif
      wcel wi vx con0 wral vx cv cA cF vx cv cres wf1o vx con0 wrex vx cv cA vf
      cv wf1o vf wex vx con0 wrex vy cv c0 wne vy cv vg cv cfv vy cv wcel wi vy
      cA cpw wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx cv cima
      cdif wcel wi vx con0 vx cv con0 wcel vy cv c0 wne vy cv vg cv cfv vy cv
      wcel wi vy cA cpw wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx
      cv cima cdif wcel wi vx cv con0 wcel vy cv c0 wne vy cv vg cv cfv vy cv
      wcel wi vy cA cpw wral cA cF vx cv cima cdif c0 wne vx cv cF cfv cA cF vx
      cv cima cdif wcel vx cv con0 wcel vx cv cF cfv cA cF vx cv cima cdif wcel
      cA cF vx cv cima cdif vg cv cfv cA cF vx cv cima cdif wcel vy cv c0 wne
      vy cv vg cv cfv vy cv wcel wi vy cA cpw wral cA cF vx cv cima cdif c0 wne
      wa vx cv con0 wcel vx cv cF cfv cA cF vx cv cima cdif vg cv cfv cA cF vx
      cv cima cdif vx cv con0 wcel vx cv cF cfv cF vx cv cres cG cfv cA cF vx
      cv cima cdif vg cv cfv vx vy vx cB vf cF cG numthlem.2 numthlem.3 tfr2 cF
      vx cv cres vy cv cA vf cv crn cdif vg cv cfv wceq vf vy copab cfv cA cF
      vx cv cres crn cdif vg cv cfv cF vx cv cres cG cfv cA cF vx cv cima cdif
      vg cv cfv vf vy cF vx cv cres cA vf cv crn cdif vg cv cfv cA cF vx cv
      cres crn cdif vg cv cfv cF wfun vx cv cvv wcel cF vx cv cres cvv wcel vx
      vy cB vf cF cG numthlem.2 numthlem.3 tfrlem7 vx visset cF vx cv cvv
      resfunexg mp2an cA cF vx cv cres crn cdif vg cv fvex vf cv cF vx cv cres
      wceq vf cv crn cF vx cv cres crn wceq cA vf cv crn cdif cA cF vx cv cres
      crn cdif wceq cA vf cv crn cdif vg cv cfv cA cF vx cv cres crn cdif vg cv
      cfv wceq vf cv cF vx cv cres rneq vf cv crn cF vx cv cres crn cA difeq2
      cA vf cv crn cdif cA cF vx cv cres crn cdif vg cv fveq2 3syl fvopab cF vx
      cv cres cG vy cv cA vf cv crn cdif vg cv cfv wceq vf vy copab numthlem.4
      fveq1i cA cF vx cv cima cdif cA cF vx cv cres crn cdif vg cv cF vx cv
      cima cF vx cv cres crn cA cF vx cv df-ima difeq2i fveq2i 3eqtr4i syl6eq
      eleq1d vy cv c0 wne vy cv vg cv cfv vy cv wcel wi vy cA cpw wral cA cF vx
      cv cima cdif c0 wne cA cF vx cv cima cdif vg cv cfv cA cF vx cv cima cdif
      wcel cA cF vx cv cima cdif cA cpw wcel vy cv c0 wne vy cv vg cv cfv vy cv
      wcel wi vy cA cpw wral cA cF vx cv cima cdif c0 wne cA cF vx cv cima cdif
      vg cv cfv cA cF vx cv cima cdif wcel wi wi cA cF vx cv cima cdif cA cpw
      wcel cA cF vx cv cima cdif cA wss cA cF vx cv cima difss cA cF vx cv cima
      cdif cA cA cF vx cv cima cdif cA numthlem.1 cA cF vx cv cima difss ssexi
      elpw mpbir vy cv c0 wne vy cv vg cv cfv vy cv wcel wi cA cF vx cv cima
      cdif c0 wne cA cF vx cv cima cdif vg cv cfv cA cF vx cv cima cdif wcel wi
      vy cA cF vx cv cima cdif cA cpw vy cv cA cF vx cv cima cdif wceq vy cv c0
      wne cA cF vx cv cima cdif c0 wne vy cv vg cv cfv vy cv wcel cA cF vx cv
      cima cdif vg cv cfv cA cF vx cv cima cdif wcel vy cv cA cF vx cv cima
      cdif c0 neeq1 vy cv cA cF vx cv cima cdif wceq vy cv vg cv cfv cA cF vx
      cv cima cdif vg cv cfv vy cv cA cF vx cv cima cdif vy cv cA cF vx cv cima
      cdif vg cv fveq2 vy cv cA cF vx cv cima cdif wceq id eleq12d imbi12d
      rcla4v ax-mp imp syl5bir exp3a com12 r19.21aiv vx cA cF vx vy cB vf cF cG
      numthlem.2 numthlem.3 tfr1 numthlem.1 tz7.49c vx cv cA cF vx cv cres wf1o
      vx cv cA vf cv wf1o vf wex vx con0 vx cv cA vf cv wf1o vx cv cA cF vx cv
      cres wf1o vf cF vx cv cres cF wfun vx cv cvv wcel cF vx cv cres cvv wcel
      vx vy cB vf cF cG numthlem.2 numthlem.3 tfrlem7 vx visset cF vx cv cvv
      resfunexg mp2an vx cv cA vf cv cF vx cv cres f1oeq1 cla4ev r19.22si 3syl
      19.23aiv ax-mp $.
      $( [10-Feb-1997] $)
  $}

  ${
    $d x y z w v u f g h A $.
    numth.1 $e |- A e. _V $.
    $( Numeration theorem:  every set can be put into one-to-one correspondence
       with some ordinal (using AC).  Theorem 10.3 of [TakeutiZaring] p. 84. $)
    numth $p |- E. x e. On E. f f : x -1-1-onto-> A $=
      vx vy cA vg cv vz cv wfn vw cv vg cv cfv vg cv vw cv cres vu cv cA vv cv
      crn cdif vh cv cfv wceq vv vu copab cfv wceq vw vz cv wral wa vz con0
      wrex vg cab vf vh vg cv vz cv wfn vw cv vg cv cfv vg cv vw cv cres vu cv
      cA vv cv crn cdif vh cv cfv wceq vv vu copab cfv wceq vw vz cv wral wa vz
      con0 wrex vg cab cuni vu cv cA vv cv crn cdif vh cv cfv wceq vv vu copab
      numth.1 vz vw vx vy vg vf vu cv cA vv cv crn cdif vh cv cfv wceq vv vu
      copab rdglem1 vg cv vz cv wfn vw cv vg cv cfv vg cv vw cv cres vu cv cA
      vv cv crn cdif vh cv cfv wceq vv vu copab cfv wceq vw vz cv wral wa vz
      con0 wrex vg cab cuni eqid vu cv cA vv cv crn cdif vh cv cfv wceq vy cv
      cA vf cv crn cdif vh cv cfv wceq vv vu vf vy vu cv vy cv wceq vv cv vf cv
      wceq vu cv vy cv cA vv cv crn cdif vh cv cfv cA vf cv crn cdif vh cv cfv
      vu cv vy cv wceq id vv cv vf cv wceq vv cv crn vf cv crn wceq cA vv cv
      crn cdif cA vf cv crn cdif wceq cA vv cv crn cdif vh cv cfv cA vf cv crn
      cdif vh cv cfv wceq vv cv vf cv rneq vv cv crn vf cv crn cA difeq2 cA vv
      cv crn cdif cA vf cv crn cdif vh cv fveq2 3syl eqeqan12rd cbvopabv
      numthlem $.
      $( [10-Feb-1997] $)
  $}

  ${
    $d x y z A $.
    $( Numeration theorem:  any set is equinumerous to some ordinal (using AC).
       Theorem 10.3  of [TakeutiZaring] p. 84. $)
    numth2 $p |- E. x e. On x ~~ A $=
      cA cvv wcel vx cv cA cen wbr vx con0 wrex vx cv vy cv cen wbr vx con0
      wrex vx cv cA cen wbr vx con0 wrex vy cA cvv vy cv cA wceq vx cv vy cv
      cen wbr vx cv cA cen wbr vx con0 vy cv cA vx cv cen breq2 rexbidv vx cv
      vy cv cen wbr vx con0 wrex vx cv vy cv vz cv wf1o vz wex vx con0 wrex vx
      vy cv vz vy visset numth vx cv vy cv cen wbr vx cv vy cv vz cv wf1o vz
      wex vx con0 vx cv vy cv vz vy visset bren rexbii mpbir vtoclg c0 con0
      wcel c0 cA cen wbr vx cv cA cen wbr vx con0 wrex cA cvv wcel wn vx cv cA
      cen wbr c0 cA cen wbr vx c0 con0 vx cv c0 cA cen breq1 rcla4ev 0elon cA
      cvv wcel wn c0 cA cen wbr c0 c0 cen wbr c0 con0 wcel c0 c0 cen wbr 0elon
      c0 con0 enrefg ax-mp c0 cA cen brprc mpbiri sylancr pm2.61i $.
      $( [20-Oct-2003] $) $( [20-Oct-2003] $)
  $}

  ${
    $d x y A $.
    $( Any set is strictly dominated by some ordinal. $)
    numthcor $p |- ( A e. B -> E. x e. On A ~< x ) $=
      vy cv vx cv csdm wbr vx con0 wrex cA vx cv csdm wbr vx con0 wrex vy cA cB
      vy cv cA wceq vy cv vx cv csdm wbr cA vx cv csdm wbr vx con0 vy cv cA vx
      cv csdm breq1 rexbidv vx cv vy cv cpw cen wbr vx con0 wrex vy cv vx cv
      csdm wbr vx con0 wrex vx vy cv cpw numth2 vx cv vy cv cpw cen wbr vy cv
      vx cv csdm wbr vx con0 vy cv vy cv cpw csdm wbr vy cv cpw vx cv cen wbr
      vy cv vx cv csdm wbr vx cv vy cv cpw cen wbr vx cv cvv wcel vy cv vy cv
      cpw csdm wbr vy cv cpw vx cv cen wbr wa vy cv vx cv csdm wbr wi vx visset
      vy cv vy cv cpw vx cv cvv sdomentr ax-mp vy cv vy visset canth2 vx cv vy
      cv cpw vy cv vy visset pwex ensym sylancr r19.22si ax-mp vtoclg $.
      $( [11-Nov-2003] $) $( [22-Oct-2003] $)
  $}

  ${
    $d x y z w f A $.
    weth.1 $e |- A e. _V $.
    $( Well-ordering theorem: any set ` A ` can be well-ordered.  This is an
       equivalent of the Axiom of Choice.  Theorem 6 of [Suppes] p. 242.  First
       proved by Ernst Zermelo (the "Z" in ZFC) in 1904. $)
    weth $p |- E. x x We A $=
      vy cv cA vf cv wf1o vf wex vy con0 wrex cA vx cv wwe vx wex vy cA vf
      weth.1 numth vy cv cA vf cv wf1o vf wex cA vx cv wwe vx wex vy con0 vy cv
      cA vf cv wf1o vf wex vy cv con0 wcel cA vx cv wwe vx wex vy cv cA vf cv
      wf1o vy cv con0 wcel cA vx cv wwe vx wex wi vf vy cv cA vf cv wf1o cA vy
      cv vf cv ccnv wf1o vy cv con0 wcel cA vx cv wwe vx wex wi vy cv cA vf cv
      f1ocnv cA vy cv vf cv ccnv wf1o vy cv cep wwe cA vx cv wwe vx wex vy cv
      con0 wcel cA vy cv vf cv ccnv wf1o vy cv cep wwe cA vz cv vf cv ccnv cfv
      vw cv vf cv ccnv cfv cep wbr vz vw copab wwe cA vx cv wwe vx wex vz vw cA
      vy cv vz cv vf cv ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw copab cep
      vf cv ccnv vz cv vf cv ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw copab
      eqid f1owe cA vz cv vf cv ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw
      copab wwe cA vz cv vf cv ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw
      copab cA cA cxp cin wwe cA vx cv wwe vx wex cA vz cv vf cv ccnv cfv vw cv
      vf cv ccnv cfv cep wbr vz vw copab weinxp cA vx cv wwe cA vz cv vf cv
      ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw copab cA cA cxp cin wwe vx vz
      cv vf cv ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw copab cA cA cxp cin
      cA cA cxp vz cv vf cv ccnv cfv vw cv vf cv ccnv cfv cep wbr vz vw copab
      cA cA weth.1 weth.1 xpex inex2 cA vx cv vz cv vf cv ccnv cfv vw cv vf cv
      ccnv cfv cep wbr vz vw copab cA cA cxp cin weeq1 cla4ev sylbi syl6 vy cv
      con0 wcel vy cv word vy cv cep wwe vy cv eloni vy cv ordwe syl syl5 syl
      19.23aiv com12 r19.23aiv ax-mp $.
      $( [9-Mar-1997] $)
  $}

  ${
    $d x y w h t z f g u v r s a b A $.  $d h t f B $.
    $d x y z v u f g h t r s a b F $.
    $d h t f G $.
    $d t C $.  $d y u v f t a b D $.  $d x y z w g u v f t s r a b R $.
    $d x y u v w f t s r a b $.
    zorn2lem.1 $e |- A e. _V $.
    $( Hypotheses for transfinite recursion. $)
    zorn2lem.2 $e |- B = { f | E. h e. On ( f Fn h /\
                A. t e. h ( f ` t ) = ( G ` ( f |` t ) ) ) } $.
    zorn2lem.3 $e |- F = U. B $.
    $( Auxiliary sets. $)
    zorn2lem.4 $e |- C = { z e. A | A. g e. ran f g R z } $.
    zorn2lem.5 $e |- D = { z e. A | A. g e. ( F " x ) g R z } $.
    $( Generator function.  ` w ` is a well-ordering on ` A ` . $)
    zorn2lem.6 $e |- G =
                { <. f , t >. | t = U. { v e. C | A. u e. C -. u w v } } $.
    $( Lemma for ~ zorn2 . $)
    zorn2lem1 $p |- ( ( x e. On /\ ( w We A /\ D =/= (/) ) ) ->
                   ( F ` x ) e. D ) $=
      vx cv con0 wcel cA vw cv wwe cD c0 wne wa vx cv cF cfv cD wcel vx cv con0
      wcel vx cv cF cfv cD wcel vu cv vv cv vw cv wbr wn vu cD wral vv cD crab
      cuni cD wcel cA vw cv wwe cD c0 wne wa vx cv con0 wcel vx cv cF cfv vu cv
      vv cv vw cv wbr wn vu cD wral vv cD crab cuni cD vx cv con0 wcel vx cv cF
      cfv cF vx cv cres cG cfv vu cv vv cv vw cv wbr wn vu cD wral vv cD crab
      cuni vh vt vx cB vf cF cG zorn2lem.2 zorn2lem.3 tfr2 cF vx cv cres cG cfv
      cF vx cv cres vt cv vu cv vv cv vw cv wbr wn vu cC wral vv cC crab cuni
      wceq vf vt copab cfv vu cv vv cv vw cv wbr wn vu cD wral vv cD crab cuni
      cF vx cv cres cG vt cv vu cv vv cv vw cv wbr wn vu cC wral vv cC crab
      cuni wceq vf vt copab zorn2lem.6 fveq1i vf vt cF vx cv cres vu cv vv cv
      vw cv wbr wn vu cC wral vv cC crab cuni vu cv vv cv vw cv wbr wn vu cD
      wral vv cD crab cuni cF wfun vx cv cvv wcel cF vx cv cres cvv wcel vh vt
      cB vf cF cG zorn2lem.2 zorn2lem.3 tfrlem7 vx visset cF vx cv cvv
      resfunexg mp2an vu cv vv cv vw cv wbr wn vu cD wral vv cD crab vu cv vv
      cv vw cv wbr wn vu cD wral vv cD cD cA zorn2lem.1 cD vg cv vz cv cR wbr
      vg cF vx cv cima wral vz cA crab cA zorn2lem.5 vg cv vz cv cR wbr vg cF
      vx cv cima wral vz cA ssrab2 eqsstri ssexi rabex uniex vf cv cF vx cv
      cres wceq vu cv vv cv vw cv wbr wn vu cC wral vv cC crab vu cv vv cv vw
      cv wbr wn vu cD wral vv cD crab vf cv cF vx cv cres wceq vv cv cC wcel vu
      cv vv cv vw cv wbr wn vu cC wral wa vv cab vv cv cD wcel vu cv vv cv vw
      cv wbr wn vu cD wral wa vv cab vu cv vv cv vw cv wbr wn vu cC wral vv cC
      crab vu cv vv cv vw cv wbr wn vu cD wral vv cD crab vf cv cF vx cv cres
      wceq vv cv cC wcel vu cv vv cv vw cv wbr wn vu cC wral wa vv cv cD wcel
      vu cv vv cv vw cv wbr wn vu cD wral wa vv vf cv cF vx cv cres wceq vv cv
      cC wcel vv cv cD wcel vu cv vv cv vw cv wbr wn vu cC wral vu cv vv cv vw
      cv wbr wn vu cD wral vf cv cF vx cv cres wceq cC cD vv cv vf cv cF vx cv
      cres wceq vg cv vz cv cR wbr vg vf cv crn wral vz cA crab vg cv vz cv cR
      wbr vg cF vx cv cima wral vz cA crab cC cD vf cv cF vx cv cres wceq vg cv
      vz cv cR wbr vg vf cv crn wral vg cv vz cv cR wbr vg cF vx cv cima wral
      vz cA vf cv cF vx cv cres wceq vg cv vz cv cR wbr vg cv vz cv cR wbr vg
      vf cv crn cF vx cv cima vf cv cF vx cv cres wceq vg cv vf cv crn wcel vg
      cv cF vx cv cima wcel vg cv vz cv cR wbr vf cv cF vx cv cres wceq vf cv
      crn cF vx cv cima vg cv vf cv cF vx cv cres wceq vf cv crn cF vx cv cres
      crn cF vx cv cima vf cv cF vx cv cres rneq cF vx cv df-ima syl6eqr eleq2d
      imbi1d ralbidv2 rabbisdv zorn2lem.4 zorn2lem.5 3eqtr4g eleq2d vf cv cF vx
      cv cres wceq vu cv vv cv vw cv wbr wn vu cv vv cv vw cv wbr wn vu cC cD
      vf cv cF vx cv cres wceq vu cv cC wcel vu cv cD wcel vu cv vv cv vw cv
      wbr wn vf cv cF vx cv cres wceq cC cD vu cv vf cv cF vx cv cres wceq vg
      cv vz cv cR wbr vg vf cv crn wral vz cA crab vg cv vz cv cR wbr vg cF vx
      cv cima wral vz cA crab cC cD vf cv cF vx cv cres wceq vg cv vz cv cR wbr
      vg vf cv crn wral vg cv vz cv cR wbr vg cF vx cv cima wral vz cA vf cv cF
      vx cv cres wceq vg cv vz cv cR wbr vg cv vz cv cR wbr vg vf cv crn cF vx
      cv cima vf cv cF vx cv cres wceq vg cv vf cv crn wcel vg cv cF vx cv cima
      wcel vg cv vz cv cR wbr vf cv cF vx cv cres wceq vf cv crn cF vx cv cima
      vg cv vf cv cF vx cv cres wceq vf cv crn cF vx cv cres crn cF vx cv cima
      vf cv cF vx cv cres rneq cF vx cv df-ima syl6eqr eleq2d imbi1d ralbidv2
      rabbisdv zorn2lem.4 zorn2lem.5 3eqtr4g eleq2d imbi1d ralbidv2 anbi12d
      abbidv vu cv vv cv vw cv wbr wn vu cC wral vv cC df-rab vu cv vv cv vw cv
      wbr wn vu cD wral vv cD df-rab 3eqtr4g unieqd fvopab eqtri syl6eq eleq1d
      cA vw cv wwe cD cA wss cD c0 wne vu cv vv cv vw cv wbr wn vu cD wral vv
      cD crab cuni cD wcel cD vg cv vz cv cR wbr vg cF vx cv cima wral vz cA
      crab cA zorn2lem.5 vg cv vz cv cR wbr vg cF vx cv cima wral vz cA ssrab2
      eqsstri vv vu cA cD vw cv cD cA zorn2lem.1 cD vg cv vz cv cR wbr vg cF vx
      cv cima wral vz cA crab cA zorn2lem.5 vg cv vz cv cR wbr vg cF vx cv cima
      wral vz cA ssrab2 eqsstri ssexi wereucl mp3an2 syl5bir imp $.
      $( [3-Apr-1997] $)

    $( Lemma for ~ zorn2 . $)
    zorn2lem2 $p |- ( ( x e. On /\ ( w We A /\ D =/= (/) ) ) ->
                   ( y e. x -> ( F ` y ) R ( F ` x ) ) ) $=
      vx cv con0 wcel cA vw cv wwe cD c0 wne wa wa vy cv vx cv wcel vy cv cF
      cfv cF vx cv cima wcel vy cv cF cfv vx cv cF cfv cR wbr vx cv con0 wcel
      vy cv vx cv wcel vy cv cF cfv cF vx cv cima wcel wi cA vw cv wwe cD c0
      wne wa cF wfun vx cv cF cdm wss vy cv vx cv wcel vy cv cF cfv cF vx cv
      cima wcel wi vx cv con0 wcel vx cv vy cv cF funfvima2 vh vt cB vf cF cG
      zorn2lem.2 zorn2lem.3 tfrlem7 vx cv con0 wcel vx cv con0 cF cdm vx cv
      onss cF con0 wfn cF cdm con0 wceq vh vt cB vf cF cG zorn2lem.2 zorn2lem.3
      tfr1 con0 cF fndm ax-mp syl6ssr sylancr adantr vx cv con0 wcel cA vw cv
      wwe cD c0 wne wa wa vx cv cF cfv cD wcel vg cv vx cv cF cfv cR wbr vg cF
      vx cv cima wral vy cv cF cfv cF vx cv cima wcel vy cv cF cfv vx cv cF cfv
      cR wbr wi vx vz vw vv vu vt cA cB cC cD cR vf vg vh cF cG zorn2lem.1
      zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5 zorn2lem.6 zorn2lem1 vx cv cF
      cfv cD wcel vx cv cF cfv cA wcel vg cv vx cv cF cfv cR wbr vg cF vx cv
      cima wral vg cv vz cv cR wbr vg cF vx cv cima wral vg cv vx cv cF cfv cR
      wbr vg cF vx cv cima wral vz vx cv cF cfv cA cD vz cv vx cv cF cfv wceq
      vg cv vz cv cR wbr vg cv vx cv cF cfv cR wbr vg cF vx cv cima vz cv vx cv
      cF cfv vg cv cR breq2 ralbidv zorn2lem.5 elrab2 pm3.27bi vg cv vx cv cF
      cfv cR wbr vy cv cF cfv vx cv cF cfv cR wbr vg vy cv cF cfv cF vx cv cima
      vg cv vy cv cF cfv vx cv cF cfv cR breq1 rcla4cv 3syl syld $.
      $( [3-Apr-1997] $)

    $( Lemma for ~ zorn2 . $)
    zorn2lem3 $p |- ( ( R Po A /\ ( x e. On /\ ( w We A /\ D =/= (/) ) ) ) ->
                   ( y e. x -> -. ( F ` x ) = ( F ` y ) ) ) $=
      cA cR wpo vx cv con0 wcel cA vw cv wwe cD c0 wne wa wa wa vy cv vx cv
      wcel vy cv cF cfv vx cv cF cfv cR wbr vx cv cF cfv vy cv cF cfv wceq wn
      vx cv con0 wcel cA vw cv wwe cD c0 wne wa wa vy cv vx cv wcel vy cv cF
      cfv vx cv cF cfv cR wbr wi cA cR wpo vx vy vz vw vv vu vt cA cB cC cD cR
      vf vg vh cF cG zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5
      zorn2lem.6 zorn2lem2 adantl cA cR wpo vx cv cF cfv cA wcel vy cv cF cfv
      vx cv cF cfv cR wbr vx cv cF cfv vy cv cF cfv wceq wn wi vx cv con0 wcel
      cA vw cv wwe cD c0 wne wa wa vy cv cF cfv vx cv cF cfv cR wbr cA cR wpo
      vx cv cF cfv cA wcel wa vx cv cF cfv vy cv cF cfv wceq wn vy cv cF cfv vx
      cv cF cfv cR wbr vx cv cF cfv vy cv cF cfv wceq vx cv cF cfv vx cv cF cfv
      cR wbr cA cR wpo vx cv cF cfv cA wcel wa vx cv cF cfv vy cv cF cfv wceq
      vx cv cF cfv vx cv cF cfv cR wbr vy cv cF cfv vx cv cF cfv cR wbr vx cv
      cF cfv vy cv cF cfv vx cv cF cfv cR breq1 biimprcd cA vx cv cF cfv cR
      poirr nsyli com12 vx cv con0 wcel cA vw cv wwe cD c0 wne wa wa vx cv cF
      cfv cD wcel vx cv cF cfv cA wcel vx vz vw vv vu vt cA cB cC cD cR vf vg
      vh cF cG zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5
      zorn2lem.6 zorn2lem1 cD cA vx cv cF cfv cD vg cv vz cv cR wbr vg cF vx cv
      cima wral vz cA crab cA zorn2lem.5 vg cv vz cv cR wbr vg cF vx cv cima
      wral vz cA ssrab2 eqsstri sseli syl sylan2 syld $.
      $( [3-Apr-1997] $)

    $( Lemma for ~ zorn2 . $)
    zorn2lem4 $p |- ( ( R Po A /\ w We A ) -> E. x e. On D = (/) ) $=
      cA cR wpo cA vw cv wwe wa cD c0 wceq vx con0 wrex cF crn cvv wcel cF crn
      cvv wcel wn wa cF crn cvv wcel pm3.24 cA cR wpo cA vw cv wwe wa vx cv
      con0 wcel cD c0 wne wi vx wal cF crn cvv wcel cF crn cvv wcel wn wa cD c0
      wceq vx con0 wrex wn cA cR wpo cA vw cv wwe wa vx cv con0 wcel cD c0 wne
      wi vx wal cF crn cvv wcel cF crn cvv wcel wn cA vw cv wwe vx cv con0 wcel
      cD c0 wne wi vx wal cF crn cvv wcel wi cA cR wpo cA vw cv wwe vx cv con0
      wcel cD c0 wne wi vx wal cF crn cvv wcel cA vw cv wwe vx cv con0 wcel cD
      c0 wne wi vx wal wa cF crn cA wss cF crn cvv wcel cA vw cv wwe vx cv con0
      wcel cD c0 wne wi vx wal wa vy cF crn cA cA vw cv wwe vx cv con0 wcel cD
      c0 wne wi vx wal wa vx cv cF cfv vy cv wceq vx con0 wrex vy cv cA wcel vy
      cv cF crn wcel cA vw cv wwe vx cv con0 wcel cD c0 wne wi vx wal wa vx cv
      cF cfv vy cv wceq vy cv cA wcel vx con0 cA vw cv wwe vx cv con0 wcel cD
      c0 wne wi vx wal vx cA vw cv wwe vx ax-17 vx cv con0 wcel cD c0 wne wi vx
      hba1 hban vy cv cA wcel vx ax-17 cA vw cv wwe vx cv con0 wcel cD c0 wne
      wi vx wal vx cv con0 wcel vx cv cF cfv vy cv wceq vy cv cA wcel wi wi cA
      vw cv wwe vx cv con0 wcel cD c0 wne wi vx cv con0 wcel vx cv cF cfv vy cv
      wceq vy cv cA wcel wi wi vx cA vw cv wwe vx cv con0 wcel cD c0 wne vx cv
      cF cfv vy cv wceq vy cv cA wcel wi vx cv con0 wcel cA vw cv wwe cD c0 wne
      vx cv cF cfv vy cv wceq vy cv cA wcel wi wi vx cv con0 wcel cA vw cv wwe
      cD c0 wne vx cv cF cfv vy cv wceq vy cv cA wcel wi vx cv cF cfv vy cv
      wceq vx cv cF cfv cA wcel vy cv cA wcel vx cv con0 wcel cA vw cv wwe cD
      c0 wne wa wa vx cv cF cfv vy cv cA eleq1 vx cv con0 wcel cA vw cv wwe cD
      c0 wne wa wa vx cv cF cfv cD wcel vx cv cF cfv cA wcel vx vz vw vv vu vt
      cA cB cC cD cR vf vg vh cF cG zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4
      zorn2lem.5 zorn2lem.6 zorn2lem1 cD cA vx cv cF cfv cD vg cv vz cv cR wbr
      vg cF vx cv cima wral vz cA crab cA zorn2lem.5 vg cv vz cv cR wbr vg cF
      vx cv cima wral vz cA ssrab2 eqsstri sseli syl syl5cbi exp32 com12 a2d
      a4sd imp r19.23ad cF con0 wfn vy cv cF crn wcel vx cv cF cfv vy cv wceq
      vx con0 wrex wb vh vt cB vf cF cG zorn2lem.2 zorn2lem.3 tfr1 vx con0 vy
      cv cF fvelrnb ax-mp syl5ib ssrdv cF crn cA zorn2lem.1 ssex syl ex adantl
      cA cR wpo cA vw cv wwe wa vx cv con0 wcel cD c0 wne wi vx wal cF ccnv
      wfun cF crn cvv wcel wn cA cR wpo cA vw cv wwe wa vx cv con0 wcel cD c0
      wne wi vx wal vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx con0
      wral cF ccnv wfun cA cR wpo cA vw cv wwe wa vx cv con0 wcel cD c0 wne wi
      vx wal vx cv con0 wcel vy cv vx cv wcel wa vx cv cF cfv vy cv cF cfv wceq
      wn wi vy wal vx wal vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx
      con0 wral cA cR wpo cA vw cv wwe wa vx cv con0 wcel cD c0 wne wi vx cv
      con0 wcel vy cv vx cv wcel wa vx cv cF cfv vy cv cF cfv wceq wn wi vy wal
      vx cA cR wpo cA vw cv wwe wa vx cv con0 wcel cD c0 wne wi vx cv con0 wcel
      vy cv vx cv wcel wa vx cv cF cfv vy cv cF cfv wceq wn wi vy cA cR wpo cA
      vw cv wwe wa vx cv con0 wcel cD c0 wne wi vx cv con0 wcel vy cv vx cv
      wcel vx cv cF cfv vy cv cF cfv wceq wn cA cR wpo cA vw cv wwe wa vx cv
      con0 wcel cD c0 wne vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi
      cA cR wpo cA vw cv wwe vx cv con0 wcel cD c0 wne vy cv vx cv wcel vx cv
      cF cfv vy cv cF cfv wceq wn wi wi wi cA cR wpo vx cv con0 wcel cA vw cv
      wwe cD c0 wne vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wi cA
      cR wpo vx cv con0 wcel cA vw cv wwe cD c0 wne vy cv vx cv wcel vx cv cF
      cfv vy cv cF cfv wceq wn wi vx vy vz vw vv vu vt cA cB cC cD cR vf vg vh
      cF cG zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5 zorn2lem.6
      zorn2lem3 exp45 com23 imp a2d imp4a 19.21adv 19.20dv vx cv cF cfv vy cv
      cF cfv wceq wn vx vy con0 vx cv r2al syl6ibr vx cv cF cfv vy cv cF cfv
      wceq wn vy vx cv wral vx con0 wral cF con0 cres ccnv wfun cF ccnv wfun
      con0 con0 wss vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx con0
      wral cF con0 cres ccnv wfun con0 ssid vx vy con0 cF vh vt cB vf cF cG
      zorn2lem.2 zorn2lem.3 tfr1 tz7.48lem mpan cF con0 cres ccnv cF ccnv wceq
      cF con0 cres ccnv wfun cF ccnv wfun wb cF con0 cres cF cF wrel cF cdm
      con0 wss cF con0 cres cF wceq vh vt cB vf cF cG zorn2lem.2 zorn2lem.3
      tfrlem6 cF cdm con0 cF con0 wfn cF cdm con0 wceq vh vt cB vf cF cG
      zorn2lem.2 zorn2lem.3 tfr1 con0 cF fndm ax-mp eqimssi cF con0 relssres
      mp2an cnveqi cF con0 cres ccnv cF ccnv funeq ax-mp sylib syl6 cF ccnv
      wfun cF crn cvv wcel con0 cvv wcel onprc cF ccnv wfun cF ccnv cdm cvv
      wcel cF ccnv crn cvv wcel cF crn cvv wcel con0 cvv wcel cF ccnv cdm cvv
      wcel cF ccnv wfun cF ccnv crn cvv wcel cvv cF ccnv funrnex com12 cF crn
      cF ccnv cdm cvv cF df-rn eleq1i con0 cF ccnv crn cvv cF cdm con0 cF ccnv
      crn cF con0 wfn cF cdm con0 wceq vh vt cB vf cF cG zorn2lem.2 zorn2lem.3
      tfr1 con0 cF fndm ax-mp cF dfdm4 eqtr3i eleq1i 3imtr4g mtoi syl6 jcad cD
      c0 wne vx con0 wral cD c0 wceq wn vx con0 wral vx cv con0 wcel cD c0 wne
      wi vx wal cD c0 wceq vx con0 wrex wn cD c0 wne cD c0 wceq wn vx con0 cD
      c0 df-ne ralbii cD c0 wne vx con0 df-ral cD c0 wceq vx con0 ralnex
      3bitr3i syl5ibr mt3i $.
      $( [3-Apr-1997] $)

    ${
      $d x u v f t s r a b H $.
      $( Auxiliary set.  ` H ` is ` D ` with ` x ` substituted for ` y ` . $)
      zorn2lem.7 $e |- H = { z e. A | A. g e. ( F " y ) g R z } $.
      $( Lemma for ~ zorn2 . $)
      zorn2lem5 $p |- ( ( ( w We A /\ x e. On ) /\ A. y e. x H =/= (/) ) ->
            ( F " x ) C_ A ) $=
        cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vs cF vx cv
        cima cA cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vy
        cv cF cfv vs cv wceq vy vx cv wrex vs cv cA wcel vs cv cF vx cv cima
        wcel cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vy cv
        cF cfv vs cv wceq vs cv cA wcel vy vx cv cA vw cv wwe vx cv con0 wcel
        wa cH c0 wne vy vx cv wral vy cA vw cv wwe vx cv con0 wcel wa vy ax-17
        cH c0 wne vy vx cv hbra1 hban vs cv cA wcel vy ax-17 cA vw cv wwe vx cv
        con0 wcel wa cH c0 wne vy vx cv wral vy cv vx cv wcel vy cv cF cfv vs
        cv wceq vs cv cA wcel wi wi cA vw cv wwe vx cv con0 wcel wa vy cv vx cv
        wcel cH c0 wne wi vy wal vy cv vx cv wcel vy cv cF cfv vs cv wceq vs cv
        cA wcel wi wi cH c0 wne vy vx cv wral cA vw cv wwe vx cv con0 wcel wa
        vy cv vx cv wcel cH c0 wne wi vy cv vx cv wcel vy cv cF cfv vs cv wceq
        vs cv cA wcel wi wi vy cA vw cv wwe vx cv con0 wcel wa vy cv vx cv wcel
        cH c0 wne vy cv cF cfv vs cv wceq vs cv cA wcel wi cA vw cv wwe vx cv
        con0 wcel vy cv vx cv wcel cH c0 wne vy cv cF cfv vs cv wceq vs cv cA
        wcel wi wi wi vx cv con0 wcel vy cv vx cv wcel cA vw cv wwe cH c0 wne
        vy cv cF cfv vs cv wceq vs cv cA wcel wi wi vx cv con0 wcel vy cv vx cv
        wcel cA vw cv wwe cH c0 wne vy cv cF cfv vs cv wceq vs cv cA wcel wi vy
        cv cF cfv vs cv wceq vx cv con0 wcel vy cv vx cv wcel wa cA vw cv wwe
        cH c0 wne wa wa vs cv cA wcel vy cv cF cfv vs cv wceq vy cv con0 wcel
        cA vw cv wwe cH c0 wne wa vs cv cA wcel vx cv con0 wcel vy cv vx cv
        wcel wa vy cv cF cfv vs cv wceq vy cv cF cfv cA wcel vs cv cA wcel vy
        cv con0 wcel cA vw cv wwe cH c0 wne wa wa vy cv cF cfv vs cv cA eleq1
        vy cv con0 wcel cA vw cv wwe cH c0 wne wa wa vy cv cF cfv cH wcel vy cv
        cF cfv cA wcel vy vz vw vv vu vt cA cB cC cH cR vf vg vh cF cG
        zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.7 zorn2lem.6
        zorn2lem1 cH cA vy cv cF cfv cH vg cv vz cv cR wbr vg cF vy cv cima
        wral vz cA crab cA zorn2lem.7 vg cv vz cv cR wbr vg cF vy cv cima wral
        vz cA ssrab2 eqsstri sseli syl syl5bi vx cv vy cv onelon sylani com12
        exp43 com3r imp a2d a4sd cH c0 wne vy vx cv df-ral syl5ib imp r19.23ad
        cF wfun vs cv cF vx cv cima wcel vy cv cF cfv vs cv wceq vy vx cv wrex
        vh vt cB vf cF cG zorn2lem.2 zorn2lem.3 tfrlem7 vy vs cv vx cv cF
        fvelima mpan syl5 ssrdv $.
        $( [4-Apr-1997] $)

      $( Lemma for ~ zorn2 . $)
      zorn2lem6 $p |- ( R Po A ->
   ( ( ( w We A /\ x e. On ) /\ A. y e. x H =/= (/) ) -> R Or ( F " x ) ) ) $=
        cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa cF
        vx cv cima cR wpo vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR
        wbr w3o vr cF vx cv cima wral vs cF vx cv cima wral wa cF vx cv cima cR
        wor cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral
        wa cF vx cv cima cR wpo vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv
        cR wbr w3o vr cF vx cv cima wral vs cF vx cv cima wral cA vw cv wwe vx
        cv con0 wcel wa cH c0 wne vy vx cv wral wa cA cR wpo cF vx cv cima cR
        wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa cF vx cv
        cima cA wss cA cR wpo cF vx cv cima cR wpo wi vx vy vz vw vv vu vt cA
        cB cC cD cR vf vg vh cF cG cH zorn2lem.1 zorn2lem.2 zorn2lem.3
        zorn2lem.4 zorn2lem.5 zorn2lem.6 zorn2lem.7 zorn2lem5 cF vx cv cima cA
        cR poss syl com12 cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv
        wral wa vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR wbr w3o vr
        cF vx cv cima wral vs cF vx cv cima wral wi cA cR wpo cA vw cv wwe vx
        cv con0 wcel wa cH c0 wne vy vx cv wral wa vs cv cF vx cv cima wcel vr
        cv cF vx cv cima wcel wa vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs
        cv cR wbr w3o wi vr wal vs wal vs cv vr cv cR wbr vs cv vr cv wceq vr
        cv vs cv cR wbr w3o vr cF vx cv cima wral vs cF vx cv cima wral cA vw
        cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vs cv cF vx cv
        cima wcel vr cv cF vx cv cima wcel wa vs cv vr cv cR wbr vs cv vr cv
        wceq vr cv vs cv cR wbr w3o wi vs vr cA vw cv wwe vx cv con0 wcel wa cH
        c0 wne vy vx cv wral wa vb cv vx cv wcel va cv vx cv wcel wa vb cv cF
        cfv vs cv wceq va cv cF cfv vr cv wceq wa wa va wex vb wex vs cv vr cv
        cR wbr vs cv vr cv wceq vr cv vs cv cR wbr w3o vs cv cF vx cv cima wcel
        vr cv cF vx cv cima wcel wa cA vw cv wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa vb cv vx cv wcel va cv vx cv wcel wa vb cv cF cfv vs
        cv wceq va cv cF cfv vr cv wceq wa wa vs cv vr cv cR wbr vs cv vr cv
        wceq vr cv vs cv cR wbr w3o vb va cA vw cv wwe vx cv con0 wcel wa cH c0
        wne vy vx cv wral vb cv vx cv wcel va cv vx cv wcel wa vb cv cF cfv vs
        cv wceq va cv cF cfv vr cv wceq wa vs cv vr cv cR wbr vs cv vr cv wceq
        vr cv vs cv cR wbr w3o cA vw cv wwe vx cv con0 wcel wa vb cv vx cv wcel
        va cv vx cv wcel wa vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab
        c0 wne vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0 wne wa wi
        vb cv vx cv wcel va cv vx cv wcel wa vb cv cF cfv vs cv wceq va cv cF
        cfv vr cv wceq wa vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR
        wbr w3o wi wi cH c0 wne vy vx cv wral cA vw cv wwe vx cv con0 wcel wa
        vb cv vx cv wcel va cv vx cv wcel wa vg cv vz cv cR wbr vg cF vb cv
        cima wral vz cA crab c0 wne vg cv vz cv cR wbr vg cF va cv cima wral vz
        cA crab c0 wne wa vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa vs
        cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR wbr w3o wi cA vw cv wwe
        vx cv con0 wcel vb cv vx cv wcel va cv vx cv wcel wa vg cv vz cv cR wbr
        vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr vg cF va cv
        cima wral vz cA crab c0 wne wa vb cv cF cfv vs cv wceq va cv cF cfv vr
        cv wceq wa vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR wbr w3o
        wi wi wi vx cv con0 wcel vb cv vx cv wcel va cv vx cv wcel wa cA vw cv
        wwe vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz
        cv cR wbr vg cF va cv cima wral vz cA crab c0 wne wa vb cv cF cfv vs cv
        wceq va cv cF cfv vr cv wceq wa vs cv vr cv cR wbr vs cv vr cv wceq vr
        cv vs cv cR wbr w3o wi wi vx cv con0 wcel vb cv vx cv wcel va cv vx cv
        wcel wa cA vw cv wwe vg cv vz cv cR wbr vg cF vb cv cima wral vz cA
        crab c0 wne vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0 wne
        wa vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa vs cv vr cv cR
        wbr vs cv vr cv wceq vr cv vs cv cR wbr w3o wi vx cv con0 wcel vb cv vx
        cv wcel va cv vx cv wcel wa vb cv con0 wcel va cv con0 wcel wa cA vw cv
        wwe vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz
        cv cR wbr vg cF va cv cima wral vz cA crab c0 wne wa wa vb cv cF cfv vs
        cv wceq va cv cF cfv vr cv wceq wa vs cv vr cv cR wbr vs cv vr cv wceq
        vr cv vs cv cR wbr w3o wi wi vx cv con0 wcel vb cv vx cv wcel va cv vx
        cv wcel wa vb cv con0 wcel va cv con0 wcel wa vx cv con0 wcel vb cv vx
        cv wcel va cv vx cv wcel vb cv con0 wcel va cv con0 wcel wa vx cv con0
        wcel vb cv vx cv wcel wa vb cv con0 wcel vx cv con0 wcel va cv vx cv
        wcel wa va cv con0 wcel vx cv vb cv onelon vx cv va cv onelon anim12i
        anandis ex vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv vz cv
        cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr vg cF
        va cv cima wral vz cA crab c0 wne wa wa vb cv cF cfv vs cv wceq va cv
        cF cfv vr cv wceq wa vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR
        wbr w3o wi wi vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv vz
        cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr vg
        cF va cv cima wral vz cA crab c0 wne wa wa vb cv cF cfv vs cv wceq va
        cv cF cfv vr cv wceq wa vb cv con0 wcel va cv con0 wcel wa vs cv vr cv
        cR wbr vs cv vr cv wceq vr cv vs cv cR wbr w3o vb cv con0 wcel va cv
        con0 wcel wa cA vw cv wwe vg cv vz cv cR wbr vg cF vb cv cima wral vz
        cA crab c0 wne vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0
        wne wa wa vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa vb cv con0
        wcel va cv con0 wcel wa vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv
        cR wbr w3o wi vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv vz
        cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr vg
        cF va cv cima wral vz cA crab c0 wne wa wa wa vb cv cF cfv vs cv wceq
        va cv cF cfv vr cv wceq wa wa vb cv va cv wcel vb cv va cv wceq va cv
        vb cv wcel w3o vs cv vr cv cR wbr vs cv vr cv wceq vr cv vs cv cR wbr
        w3o vb cv con0 wcel va cv con0 wcel wa vb cv con0 wcel va cv con0 wcel
        wa cA vw cv wwe vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0
        wne vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0 wne wa wa wa
        vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa wa vb cv va cv wcel
        vs cv vr cv cR wbr vb cv va cv wceq vs cv vr cv wceq va cv vb cv wcel
        vr cv vs cv cR wbr vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg
        cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR
        wbr vg cF va cv cima wral vz cA crab c0 wne wa wa wa vb cv cF cfv vs cv
        wceq va cv cF cfv vr cv wceq wa vb cv va cv wcel vs cv vr cv cR wbr wi
        vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv vz cv cR wbr vg
        cF va cv cima wral vz cA crab c0 wne vb cv cF cfv vs cv wceq va cv cF
        cfv vr cv wceq wa vb cv va cv wcel vs cv vr cv cR wbr wi wi vg cv vz cv
        cR wbr vg cF vb cv cima wral vz cA crab c0 wne vb cv con0 wcel va cv
        con0 wcel wa cA vw cv wwe vg cv vz cv cR wbr vg cF va cv cima wral vz
        cA crab c0 wne wa wa vb cv va cv wcel vb cv cF cfv vs cv wceq va cv cF
        cfv vr cv wceq wa vs cv vr cv cR wbr vb cv con0 wcel va cv con0 wcel wa
        cA vw cv wwe vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0 wne
        wa wa vb cv va cv wcel vb cv cF cfv va cv cF cfv cR wbr vb cv cF cfv vs
        cv wceq va cv cF cfv vr cv wceq wa vs cv vr cv cR wbr wi va cv con0
        wcel cA vw cv wwe vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab
        c0 wne wa vb cv va cv wcel vb cv cF cfv va cv cF cfv cR wbr wi vb cv
        con0 wcel va vb vz vw vv vu vt cA cB cC vg cv vz cv cR wbr vg cF va cv
        cima wral vz cA crab cR vf vg vh cF cG zorn2lem.1 zorn2lem.2 zorn2lem.3
        zorn2lem.4 vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab eqid
        zorn2lem.6 zorn2lem2 adantll vb cv cF cfv vs cv wceq va cv cF cfv vr cv
        wceq wa vb cv cF cfv va cv cF cfv cR wbr vs cv vr cv cR wbr vb cv cF
        cfv vs cv va cv cF cfv vr cv cR breq12 biimpcd syl6 com23 adantrrl imp
        vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa vb cv va cv wceq vs
        cv vr cv wceq wi vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv
        vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr
        vg cF va cv cima wral vz cA crab c0 wne wa wa wa vb cv cF cfv vs cv
        wceq va cv cF cfv vr cv wceq wa vb cv cF cfv va cv cF cfv wceq vs cv vr
        cv wceq vb cv va cv wceq vb cv cF cfv vs cv va cv cF cfv vr cv eqeq12
        vb cv va cv cF fveq2 syl5bi adantl vb cv con0 wcel va cv con0 wcel wa
        cA vw cv wwe vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne
        vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0 wne wa wa wa vb
        cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa va cv vb cv wcel vr cv
        vs cv cR wbr wi vb cv con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv
        vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vb cv cF cfv vs cv
        wceq va cv cF cfv vr cv wceq wa va cv vb cv wcel vr cv vs cv cR wbr wi
        wi vg cv vz cv cR wbr vg cF va cv cima wral vz cA crab c0 wne vb cv
        con0 wcel va cv con0 wcel wa cA vw cv wwe vg cv vz cv cR wbr vg cF vb
        cv cima wral vz cA crab c0 wne wa wa va cv vb cv wcel vb cv cF cfv vs
        cv wceq va cv cF cfv vr cv wceq wa vr cv vs cv cR wbr vb cv con0 wcel
        va cv con0 wcel wa cA vw cv wwe vg cv vz cv cR wbr vg cF vb cv cima
        wral vz cA crab c0 wne wa wa va cv vb cv wcel va cv cF cfv vb cv cF cfv
        cR wbr vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa vr cv vs cv
        cR wbr wi vb cv con0 wcel cA vw cv wwe vg cv vz cv cR wbr vg cF vb cv
        cima wral vz cA crab c0 wne wa va cv vb cv wcel va cv cF cfv vb cv cF
        cfv cR wbr wi va cv con0 wcel vb va vz vw vv vu vt cA cB cC vg cv vz cv
        cR wbr vg cF vb cv cima wral vz cA crab cR vf vg vh cF cG zorn2lem.1
        zorn2lem.2 zorn2lem.3 zorn2lem.4 vg cv vz cv cR wbr vg cF vb cv cima
        wral vz cA crab eqid zorn2lem.6 zorn2lem2 adantlr vb cv cF cfv vs cv
        wceq va cv cF cfv vr cv wceq wa va cv cF cfv vb cv cF cfv cR wbr vr cv
        vs cv cR wbr va cv cF cfv vr cv wceq vb cv cF cfv vs cv wceq va cv cF
        cfv vb cv cF cfv cR wbr vr cv vs cv cR wbr wb va cv cF cfv vr cv vb cv
        cF cfv vs cv cR breq12 ancoms biimpcd syl6 com23 adantrrr imp 3orim123d
        vb cv word va cv word vb cv va cv wcel vb cv va cv wceq va cv vb cv
        wcel w3o vb cv con0 wcel va cv con0 wcel vb cv va cv ordtri3or vb cv
        eloni va cv eloni syl2an syl5 exp31 com4r pm2.43i syl6 exp4a com3r imp
        a2d cH c0 wne vy vx cv wral vg cv vz cv cR wbr vg cF vy cv cima wral vz
        cA crab c0 wne vy vx cv wral vb cv vx cv wcel va cv vx cv wcel wa vg cv
        vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr
        vg cF va cv cima wral vz cA crab c0 wne wa wi cH c0 wne vg cv vz cv cR
        wbr vg cF vy cv cima wral vz cA crab c0 wne vy vx cv cH vg cv vz cv cR
        wbr vg cF vy cv cima wral vz cA crab c0 zorn2lem.7 neeq1i ralbii vg cv
        vz cv cR wbr vg cF vy cv cima wral vz cA crab c0 wne vy vx cv wral vb
        cv vx cv wcel vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0
        wne va cv vx cv wcel vg cv vz cv cR wbr vg cF va cv cima wral vz cA
        crab c0 wne vg cv vz cv cR wbr vg cF vy cv cima wral vz cA crab c0 wne
        vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 wne vy vb cv vx
        cv vy cv vb cv wceq vg cv vz cv cR wbr vg cF vy cv cima wral vz cA crab
        vg cv vz cv cR wbr vg cF vb cv cima wral vz cA crab c0 vy cv vb cv wceq
        vg cv vz cv cR wbr vg cF vy cv cima wral vg cv vz cv cR wbr vg cF vb cv
        cima wral vz cA vy cv vb cv wceq vg cv vz cv cR wbr vg cF vy cv cima cF
        vb cv cima vy cv vb cv cF imaeq2 raleq1d rabbisdv neeq1d rcla4cv vg cv
        vz cv cR wbr vg cF vy cv cima wral vz cA crab c0 wne vg cv vz cv cR wbr
        vg cF va cv cima wral vz cA crab c0 wne vy va cv vx cv vy cv va cv wceq
        vg cv vz cv cR wbr vg cF vy cv cima wral vz cA crab vg cv vz cv cR wbr
        vg cF va cv cima wral vz cA crab c0 vy cv va cv wceq vg cv vz cv cR wbr
        vg cF vy cv cima wral vg cv vz cv cR wbr vg cF va cv cima wral vz cA vy
        cv va cv wceq vg cv vz cv cR wbr vg cF vy cv cima cF va cv cima vy cv
        va cv cF imaeq2 raleq1d rabbisdv neeq1d rcla4cv anim12d sylbi syl5
        imp4b 19.23advv vs cv cF vx cv cima wcel vr cv cF vx cv cima wcel wa vb
        cv vx cv wcel vb cv cF cfv vs cv wceq wa vb wex va cv vx cv wcel va cv
        cF cfv vr cv wceq wa va wex wa vb cv vx cv wcel va cv vx cv wcel wa vb
        cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa wa va wex vb wex cF
        wfun vs cv cF vx cv cima wcel vr cv cF vx cv cima wcel wa vb cv vx cv
        wcel vb cv cF cfv vs cv wceq wa vb wex va cv vx cv wcel va cv cF cfv vr
        cv wceq wa va wex wa wi cF con0 wfn cF wfun vh vt cB vf cF cG
        zorn2lem.2 zorn2lem.3 tfr1 con0 cF fnfun ax-mp cF wfun vs cv cF vx cv
        cima wcel vb cv vx cv wcel vb cv cF cfv vs cv wceq wa vb wex vr cv cF
        vx cv cima wcel va cv vx cv wcel va cv cF cfv vr cv wceq wa va wex cF
        wfun vs cv cF vx cv cima wcel vb cv vx cv wcel vb cv cF cfv vs cv wceq
        wa vb wex cF wfun vs cv cF vx cv cima wcel wa vb cv cF cfv vs cv wceq
        vb vx cv wrex vb cv vx cv wcel vb cv cF cfv vs cv wceq wa vb wex vb vs
        cv vx cv cF fvelima vb cv cF cfv vs cv wceq vb vx cv df-rex sylib ex cF
        wfun vr cv cF vx cv cima wcel va cv vx cv wcel va cv cF cfv vr cv wceq
        wa va wex cF wfun vr cv cF vx cv cima wcel wa va cv cF cfv vr cv wceq
        va vx cv wrex va cv vx cv wcel va cv cF cfv vr cv wceq wa va wex va vr
        cv vx cv cF fvelima va cv cF cfv vr cv wceq va vx cv df-rex sylib ex
        anim12d ax-mp vb cv vx cv wcel va cv vx cv wcel wa vb cv cF cfv vs cv
        wceq va cv cF cfv vr cv wceq wa wa va wex vb wex vb cv vx cv wcel vb cv
        cF cfv vs cv wceq wa va cv vx cv wcel va cv cF cfv vr cv wceq wa wa va
        wex vb wex vb cv vx cv wcel vb cv cF cfv vs cv wceq wa vb wex va cv vx
        cv wcel va cv cF cfv vr cv wceq wa va wex wa vb cv vx cv wcel va cv vx
        cv wcel wa vb cv cF cfv vs cv wceq va cv cF cfv vr cv wceq wa wa vb cv
        vx cv wcel vb cv cF cfv vs cv wceq wa va cv vx cv wcel va cv cF cfv vr
        cv wceq wa wa vb va vb cv vx cv wcel va cv vx cv wcel vb cv cF cfv vs
        cv wceq va cv cF cfv vr cv wceq an4 2exbii vb cv vx cv wcel vb cv cF
        cfv vs cv wceq wa va cv vx cv wcel va cv cF cfv vr cv wceq wa vb va
        eeanv bitri sylibr syl5 19.21aivv vs cv vr cv cR wbr vs cv vr cv wceq
        vr cv vs cv cR wbr w3o vs vr cF vx cv cima cF vx cv cima r2al sylibr
        a1i jcad vs vr cF vx cv cima cR df-so syl6ibr $.
        $( [4-Apr-1997] $)

      $( Lemma for ~ zorn2 . $)
      zorn2lem7 $p |- ( ( R Po A /\
      A. s ( ( s C_ A /\ R Or s ) -> E. a e. A A. r e. s ( r R a \/ r = a ) ) )
                  -> E. a e. A A. b e. A -. a R b ) $=
        cA cR wpo vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv
        wceq wo vr vs cv wral va cA wrex wi vs wal wa cA vw cv wwe vw wex va cv
        vb cv cR wbr wn vb cA wral va cA wrex vw cA zorn2lem.1 weth cA cR wpo
        vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr
        vs cv wral va cA wrex wi vs wal wa cA vw cv wwe va cv vb cv cR wbr wn
        vb cA wral va cA wrex vw cA cR wpo vs cv cA wss vs cv cR wor wa vr cv
        va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA wrex wi vs wal wa
        cA vw cv wwe va cv vb cv cR wbr wn vb cA wral va cA wrex cA cR wpo vs
        cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs
        cv wral va cA wrex wi vs wal wa cA vw cv wwe wa va cv vb cv cR wbr wn
        vb cA wral va cA wrex cA cR wpo cA vw cv wwe cA cR wpo vs cv cA wss vs
        cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA
        wrex wi vs wal wa cA vw cv wwe wa va cv vb cv cR wbr wn vb cA wral va
        cA wrex wi vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv
        wceq wo vr vs cv wral va cA wrex wi vs wal cA cR wpo cA vw cv wwe wa cD
        c0 wceq vx con0 wrex cD c0 wceq cH c0 wne vy vx cv wral wa vx con0 wrex
        cA cR wpo vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv
        wceq wo vr vs cv wral va cA wrex wi vs wal wa cA vw cv wwe wa va cv vb
        cv cR wbr wn vb cA wral va cA wrex wi vx vz vw vv vu vt cA cB cC cD cR
        vf vg vh cF cG zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5
        zorn2lem.6 zorn2lem4 cD c0 wceq vx con0 wrex cD c0 wceq cH c0 wceq wn
        vy vx cv wral wa vx con0 wrex cD c0 wceq cH c0 wne vy vx cv wral wa vx
        con0 wrex cD c0 wceq cH c0 wceq vx vy vx cv vy cv wceq cD cH c0 vx cv
        vy cv wceq vg cv vz cv cR wbr vg cF vx cv cima wral vz cA crab vg cv vz
        cv cR wbr vg cF vy cv cima wral vz cA crab cD cH vx cv vy cv wceq vg cv
        vz cv cR wbr vg cF vx cv cima wral vg cv vz cv cR wbr vg cF vy cv cima
        wral vz cA vx cv vy cv wceq vg cv vz cv cR wbr vg cF vx cv cima cF vy
        cv cima vx cv vy cv cF imaeq2 raleq1d rabbisdv zorn2lem.5 zorn2lem.7
        3eqtr4g eqeq1d onminex cD c0 wceq cH c0 wne vy vx cv wral wa cD c0 wceq
        cH c0 wceq wn vy vx cv wral wa vx con0 cH c0 wne vy vx cv wral cH c0
        wceq wn vy vx cv wral cD c0 wceq cH c0 wne cH c0 wceq wn vy vx cv cH c0
        df-ne ralbii anbi2i rexbii sylibr cD c0 wceq cH c0 wne vy vx cv wral wa
        cA cR wpo vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv
        wceq wo vr vs cv wral va cA wrex wi vs wal wa cA vw cv wwe wa va cv vb
        cv cR wbr wn vb cA wral va cA wrex wi vx con0 cA cR wpo vs cv cA wss vs
        cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA
        wrex wi vs wal wa cA vw cv wwe wa vx cv con0 wcel cD c0 wceq cH c0 wne
        vy vx cv wral wa va cv vb cv cR wbr wn vb cA wral va cA wrex cA cR wpo
        vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr
        vs cv wral va cA wrex wi vs wal wa cA vw cv wwe wa vx cv con0 wcel cD
        c0 wceq cH c0 wne vy vx cv wral va cv vb cv cR wbr wn vb cA wral va cA
        wrex cA cR wpo vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va
        cv wceq wo vr vs cv wral va cA wrex wi vs wal wa cA vw cv wwe vx cv
        con0 wcel cD c0 wceq cH c0 wne vy vx cv wral va cv vb cv cR wbr wn vb
        cA wral va cA wrex wi wi cA cR wpo vs cv cA wss vs cv cR wor wa vr cv
        va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA wrex wi vs wal wa
        cD c0 wceq cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral va
        cv vb cv cR wbr wn vb cA wral va cA wrex wi cA cR wpo vs cv cA wss vs
        cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA
        wrex wi vs wal wa cD c0 wceq cA vw cv wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral va cv vb cv cR wbr wn vb cA wral va cA wrex cA cR wpo vs
        cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs
        cv wral va cA wrex wi vs wal wa cD c0 wceq cA vw cv wwe vx cv con0 wcel
        wa cH c0 wne vy vx cv wral wa wa wa vr cv va cv cR wbr vr cv va cv wceq
        wo vr cF vx cv cima wral va cA wrex va cv vb cv cR wbr wn vb cA wral va
        cA wrex cA cR wpo vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv
        va cv wceq wo vr vs cv wral va cA wrex wi vs wal wa cD c0 wceq cA vw cv
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa vr cv va cv cR wbr
        vr cv va cv wceq wo vr cF vx cv cima wral va cA wrex cA cR wpo vs cv cA
        wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv
        wral va cA wrex wi vs wal wa cA vw cv wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv
        cima wral va cA wrex cD c0 wceq cA cR wpo cA vw cv wwe vx cv con0 wcel
        wa cH c0 wne vy vx cv wral wa cF vx cv cima cA wss cF vx cv cima cR wor
        wa vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo
        vr vs cv wral va cA wrex wi vs wal vr cv va cv cR wbr vr cv va cv wceq
        wo vr cF vx cv cima wral va cA wrex cA cR wpo cA vw cv wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa cF vx cv cima cA wss cF vx cv cima
        cR wor cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa cF vx
        cv cima cA wss wi cA cR wpo vx vy vz vw vv vu vt cA cB cC cD cR vf vg
        vh cF cG cH zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5
        zorn2lem.6 zorn2lem.7 zorn2lem5 a1i vx vy vz vw vv vu vt cA cB cC cD cR
        vf vg vh cF cG cH zorn2lem.1 zorn2lem.2 zorn2lem.3 zorn2lem.4
        zorn2lem.5 zorn2lem.6 zorn2lem.7 zorn2lem6 jcad vs cv cA wss vs cv cR
        wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA wrex
        wi cF vx cv cima cA wss cF vx cv cima cR wor wa vr cv va cv cR wbr vr
        cv va cv wceq wo vr cF vx cv cima wral va cA wrex wi vs cF vx cv cima
        cF wfun cF vx cv cima cvv wcel vh vt cB vf cF cG zorn2lem.2 zorn2lem.3
        tfrlem7 cF vx cv vx visset funimaex ax-mp vs cv cF vx cv cima wceq vs
        cv cA wss vs cv cR wor wa cF vx cv cima cA wss cF vx cv cima cR wor wa
        vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv wral va cA wrex vr cv
        va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral va cA wrex vs cv
        cF vx cv cima wceq vs cv cA wss cF vx cv cima cA wss vs cv cR wor cF vx
        cv cima cR wor vs cv cF vx cv cima cA sseq1 vs cv cF vx cv cima cR
        soeq2 anbi12d vs cv cF vx cv cima wceq vr cv va cv cR wbr vr cv va cv
        wceq wo vr vs cv wral vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx
        cv cima wral va cA vr cv va cv cR wbr vr cv va cv wceq wo vr vs cv cF
        vx cv cima raleq1 rexbidv imbi12d cla4v sylan9 adantld imp cA cR wpo vs
        cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo vr vs
        cv wral va cA wrex wi vs wal wa cD c0 wceq cA vw cv wwe vx cv con0 wcel
        wa cH c0 wne vy vx cv wral wa vr cv va cv cR wbr vr cv va cv wceq wo vr
        cF vx cv cima wral va cA wrex va cv vb cv cR wbr wn vb cA wral va cA
        wrex wi cA cR wpo cD c0 wceq cA vw cv wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv
        cima wral va cA wrex va cv vb cv cR wbr wn vb cA wral va cA wrex wi wi
        wi vs cv cA wss vs cv cR wor wa vr cv va cv cR wbr vr cv va cv wceq wo
        vr vs cv wral va cA wrex wi vs wal cD c0 wceq cA cR wpo cA vw cv wwe vx
        cv con0 wcel wa cH c0 wne vy vx cv wral wa vr cv va cv cR wbr vr cv va
        cv wceq wo vr cF vx cv cima wral va cA wrex va cv vb cv cR wbr wn vb cA
        wral va cA wrex wi wi cD c0 wceq cA cR wpo cA vw cv wwe vx cv con0 wcel
        wa cH c0 wne vy vx cv wral wa vr cv va cv cR wbr vr cv va cv wceq wo vr
        cF vx cv cima wral va cA wrex va cv vb cv cR wbr wn vb cA wral va cA
        wrex wi cD c0 wceq cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa wa wa vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx
        cv cima wral va cv vb cv cR wbr wn vb cA wral va cA cA cD c0 wceq cA cR
        wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa wa va
        cv cA wcel vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral
        va cv vb cv cR wbr wn vb cA wral cD c0 wceq cA cR wpo cA vw cv wwe vx
        cv con0 wcel wa cH c0 wne vy vx cv wral wa wa wa va cv cA wcel vr cv va
        cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral va cv vb cv cR wbr
        wn vb cA wral cD c0 wceq cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH
        c0 wne vy vx cv wral wa wa wa va cv cA wcel vr cv va cv cR wbr vr cv va
        cv wceq wo vr cF vx cv cima wral wa vb cv cA wcel va cv vb cv cR wbr wn
        wi vb wal va cv vb cv cR wbr wn vb cA wral cD c0 wceq cA cR wpo cA vw
        cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa wa va cv cA
        wcel vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral wa vb
        cv cA wcel va cv vb cv cR wbr wn wi vb cD c0 wceq cA cR wpo cA vw cv
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa wa va cv cA wcel
        vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral vb cv cA
        wcel va cv vb cv cR wbr wn wi vb cv cA wcel cD c0 wceq cA cR wpo cA vw
        cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa wa va cv cA
        wcel vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral va cv
        vb cv cR wbr wn vb cv cA wcel cD c0 wceq cA cR wpo cA vw cv wwe vx cv
        con0 wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vr cv va cv cR
        wbr vr cv va cv wceq wo vr cF vx cv cima wral va cv vb cv cR wbr wn wi
        wi cD c0 wceq vb cv cA wcel cA cR wpo cA vw cv wwe vx cv con0 wcel wa
        cH c0 wne vy vx cv wral wa wa va cv cA wcel vr cv va cv cR wbr vr cv va
        cv wceq wo vr cF vx cv cima wral va cv vb cv cR wbr wn wi wi wi cD c0
        wceq vb cv cA wcel cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa wa vb cv cA wcel va cv cA wcel vr cv va cv cR wbr vr
        cv va cv wceq wo vr cF vx cv cima wral va cv vb cv cR wbr wn wi wi cD
        c0 wceq vb cv cA wcel cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0
        wne vy vx cv wral wa wa vb cv cA wcel va cv cA wcel vr cv va cv cR wbr
        vr cv va cv wceq wo vr cF vx cv cima wral va cv vb cv cR wbr wn wi wi
        wi wi cD c0 wceq vb cv cA wcel wa cA cR wpo cA vw cv wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vb cv cA wcel vr cv
        va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral va cv vb cv cR
        wbr wn wi cD c0 wceq vb cv cA wcel wa cA cR wpo cA vw cv wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vb cv cA wcel vr cv
        va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral va cv vb cv cR
        wbr wn wi cD c0 wceq vb cv cA wcel wa cA cR wpo cA vw cv wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vb cv cA wcel wa vr
        cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral va cv vb cv
        cR wbr wn cD c0 wceq vb cv cA wcel wa cA cR wpo cA vw cv wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vb cv cA wcel wa wa
        wa vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral wa va
        cv vb cv cR wbr vb cv c0 wcel vb cv noel cD c0 wceq vb cv cA wcel wa cA
        cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa va
        cv cA wcel vb cv cA wcel wa wa vr cv va cv cR wbr vr cv va cv wceq wo
        vr cF vx cv cima wral va cv vb cv cR wbr vb cv c0 wcel wi cD c0 wceq vb
        cv cA wcel wa cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx
        cv wral wa wa va cv cA wcel vb cv cA wcel wa wa va cv vb cv cR wbr vr
        cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral vb cv c0 wcel
        cD c0 wceq vb cv cA wcel wa cA cR wpo cA vw cv wwe vx cv con0 wcel wa
        cH c0 wne vy vx cv wral wa wa va cv cA wcel vb cv cA wcel wa wa va cv
        vb cv cR wbr vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima
        wral vb cv c0 wcel wi cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0
        wne vy vx cv wral wa wa va cv cA wcel vb cv cA wcel wa wa va cv vb cv
        cR wbr wa vr cv va cv cR wbr vr cv va cv wceq wo vr cF vx cv cima wral
        vr cv vb cv cR wbr vr cF vx cv cima wral cD c0 wceq vb cv cA wcel wa vb
        cv c0 wcel cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy vx cv
        wral wa wa va cv cA wcel vb cv cA wcel wa wa va cv vb cv cR wbr wa vr
        cv cF vx cv cima wcel vr cv va cv cR wbr vr cv va cv wceq wo wi vr wal
        vr cv cF vx cv cima wcel vr cv vb cv cR wbr wi vr wal vr cv va cv cR
        wbr vr cv va cv wceq wo vr cF vx cv cima wral vr cv vb cv cR wbr vr cF
        vx cv cima wral cA cR wpo cA vw cv wwe vx cv con0 wcel wa cH c0 wne vy
        vx cv wral wa wa va cv cA wcel vb cv cA wcel wa wa va cv vb cv cR wbr
        wa vr cv cF vx cv cima wcel vr cv va cv cR wbr vr cv va cv wceq wo wi
        vr cv cF vx cv cima wcel vr cv vb cv cR wbr wi vr cA cR wpo cA vw cv
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vb
        cv cA wcel wa wa va cv vb cv cR wbr wa vr cv cF vx cv cima wcel vr cv
        va cv cR wbr vr cv va cv wceq wo vr cv vb cv cR wbr cA cR wpo cA vw cv
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa va cv cA wcel vb
        cv cA wcel wa va cv vb cv cR wbr vr cv cF vx cv cima wcel vr cv va cv
        cR wbr vr cv va cv wceq wo vr cv vb cv cR wbr wi wi cA cR wpo cA vw cv
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa va cv vb cv cR wbr
        va cv cA wcel vb cv cA wcel wa vr cv cF vx cv cima wcel vr cv va cv cR
        wbr vr cv va cv wceq wo vr cv vb cv cR wbr wi wi cA cR wpo cA vw cv wwe
        vx cv con0 wcel wa cH c0 wne vy vx cv wral wa wa vr cv cF vx cv cima
        wcel va cv cA wcel vb cv cA wcel wa va cv vb cv cR wbr vr cv va cv cR
        wbr vr cv va cv wceq wo vr cv vb cv cR wbr wi cA vw cv wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa vr cv cF vx cv cima wcel vr cv cA
        wcel cA cR wpo va cv cA wcel vb cv cA wcel wa va cv vb cv cR wbr vr cv
        va cv cR wbr vr cv va cv wceq wo vr cv vb cv cR wbr wi wi wi cA vw cv
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa cF vx cv cima cA vr
        cv vx vy vz vw vv vu vt cA cB cC cD cR vf vg vh cF cG cH zorn2lem.1
        zorn2lem.2 zorn2lem.3 zorn2lem.4 zorn2lem.5 zorn2lem.6 zorn2lem.7
        zorn2lem5 sseld cA cR wpo vr cv cA wcel va cv cA wcel vb cv cA wcel wa
        va cv vb cv cR wbr vr cv va cv cR wbr vr cv va cv wceq wo vr cv vb cv
        cR wbr wi cA cR wpo vr cv cA wcel va cv cA wcel vb cv cA wcel wa wa wa
        va cv vb cv cR wbr wa vr cv va cv cR wbr vr cv vb cv cR wbr vr cv va cv
        wceq cA cR wpo vr cv cA wcel va cv cA wcel vb cv cA wcel wa wa wa va cv
        vb cv cR wbr vr cv va cv cR wbr vr cv vb cv cR wbr wi cA cR wpo vr cv
        cA wcel va cv cA wcel vb cv cA wcel wa wa wa vr cv va cv cR wbr va cv
        vb cv cR wbr vr cv vb cv cR wbr cA cR wpo vr cv cA wcel va cv cA wcel
        vb cv cA wcel wa wa wa vr cv va cv cR wbr va cv vb cv cR wbr vr cv vb
        cv cR wbr cA cR wpo vr cv cA wcel va cv cA wcel vb cv cA wcel w3a vr cv
        va cv cR wbr va cv vb cv cR wbr wa vr cv vb cv cR wbr wi vr cv cA wcel
        va cv cA wcel vb cv cA wcel wa wa cA vr cv va cv vb cv cR potr vr cv cA
        wcel va cv cA wcel vb cv cA wcel 3anass sylan2br exp3a com23 imp va cv
        vb cv cR wbr vr cv va cv wceq vr cv vb cv cR wbr wi cA cR wpo vr cv cA
        wcel va cv cA wcel vb cv cA wcel wa wa wa vr cv va cv wceq vr cv vb cv
        cR wbr va cv vb cv cR wbr vr cv va cv vb cv cR breq1 biimprcd adantl
        jaod exp42 sylan9r com24 com23 imp31 a2d 19.20dv vr cv va cv cR wbr vr
        cv va cv wceq wo vr cF vx cv cima df-ral vr cv vb cv cR wbr vr cF vx cv
        cima df-ral 3imtr4g cD c0 wceq vb cv cA wcel wa vg cv vb cv cR wbr vg
        cF vx cv cima wral vb cv c0 wcel vr cv vb cv cR wbr vr cF vx cv cima
        wral cD c0 wceq vb cv cA wcel vg cv vb cv cR wbr vg cF vx cv cima wral
        vb cv c0 wcel cD c0 wceq vb cv cA wcel vg cv vb cv cR wbr vg cF vx cv
        cima wral wa vb cv c0 wcel cD c0 wceq vb cv vg cv vz cv cR wbr vg cF vx
        cv cima wral vz cA crab wcel vb cv c0 wcel vb cv cA wcel vg cv vb cv cR
        wbr vg cF vx cv cima wral wa cD c0 wceq vg cv vz cv cR wbr vg cF vx cv
        cima wral vz cA crab c0 wceq vb cv vg cv vz cv cR wbr vg cF vx cv cima
        wral vz cA crab wcel vb cv c0 wcel wb cD vg cv vz cv cR wbr vg cF vx cv
        cima wral vz cA crab c0 zorn2lem.5 eqeq1i vg cv vz cv cR wbr vg cF vx
        cv cima wral vz cA crab c0 vb cv eleq2 sylbi vg cv vz cv cR wbr vg cF
        vx cv cima wral vg cv vb cv cR wbr vg cF vx cv cima wral vz vb cv cA vz
        cv vb cv wceq vg cv vz cv cR wbr vg cv vb cv cR wbr vg cF vx cv cima vz
        cv vb cv vg cv cR breq2 ralbidv elrab syl5bbr biimpd expdimp vr cv vb
        cv cR wbr vg cv vb cv cR wbr vr vg cF vx cv cima vr cv vg cv vb cv cR
        breq1 cbvralv syl5ib sylan9r exp32 com34 imp31 mtoi exp42 exp4a com34
        ex com4r pm2.43a imp3a com4l imp3a 19.21adv va cv vb cv cR wbr wn vb cA
        df-ral syl6ibr exp3a imdistand r19.22dv2 exp32 com12 adantr imp32 mpd
        exp45 com23 expdimp imp4a com3l r19.23aiv 3syl adantlr pm2.43i ex
        19.23adv mpi $.
        $( [6-Apr-1997] $)
    $}

  $}

  ${
    $d x y z $.  $d x y w $.
    $( Lemma for ~ zorn . $)
    zornlem $p |- ( z { <. x , y >. | x C. y } w <-> z C. w ) $=
      vx cv vy cv wpss vz cv vy cv wpss vz cv vw cv wpss vx vy vz cv vw cv vx
      cv vy cv wpss vx vy copab vz visset vw visset vx cv vz cv vy cv psseq1 vy
      cv vw cv vz cv psseq2 vx cv vy cv wpss vx vy copab eqid brab $.
      $( [16-Aug-2004] $) $( [13-Aug-2004] $)
  $}

  ${
    $d x y z w v u f g h t s r q a b c d j k m n R $.
    $d x y z w v u f g h t s r q a b c d j k m n A $.
    zorn2.1 $e |- A e. _V $.
    $( Zorn's Lemma of [Monk1] p. 117.  This theorem is equivalent to the
       Axiom of Choice and states that every partially ordered set ` A ` (with
       an ordering relation ` R ` ) in which every totally ordered subset has
       an upper bound, contains at least one maximal element.  The main proof
       consists of lemmas ~ zorn2lem1 through ~ zorn2lem7 ; this final piece
       mainly changes bound variables to eliminate the hypotheses of
       ~ zorn2lem7 . $)
    zorn2 $p |- ( ( R Po A /\
      A. w ( ( w C_ A /\ R Or w ) -> E. x e. A A. z e. w ( z R x \/ z = x ) ) )
                  -> E. x e. A A. y e. A -. x R y ) $=
      vt vu vr vq vn vj vg cA va cv vb cv wfn vc cv va cv cfv va cv vc cv cres
      vk cv vk cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv
      cA crab wral vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni
      wceq vh vk copab cfv wceq vc vb cv wral wa vb con0 wrex va cab vq cv vv
      cv cR wbr vq vd cv crn wral vv cA crab vs cv vr cv cR wbr vs va cv vb cv
      wfn vc cv va cv cfv va cv vc cv cres vk cv vk cv vm cv vq cv wbr wn vk vq
      cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vm vq cv vv cv cR wbr
      vq vh cv crn wral vv cA crab crab cuni wceq vh vk copab cfv wceq vc vb cv
      wral wa vb con0 wrex va cab cuni vt cv cima wral vr cA crab cR vd vs vf
      va cv vb cv wfn vc cv va cv cfv va cv vc cv cres vk cv vk cv vm cv vq cv
      wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vm vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni wceq vh vk copab cfv
      wceq vc vb cv wral wa vb con0 wrex va cab cuni vk cv vk cv vm cv vq cv
      wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vm vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni wceq vh vk copab vs
      cv vr cv cR wbr vs va cv vb cv wfn vc cv va cv cfv va cv vc cv cres vk cv
      vk cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA
      crab wral vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni
      wceq vh vk copab cfv wceq vc vb cv wral wa vb con0 wrex va cab cuni vu cv
      cima wral vr cA crab vw vz vx vy zorn2.1 vb vc vf vg va vd vk cv vk cv vm
      cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral
      vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni wceq vh vk
      copab rdglem1 va cv vb cv wfn vc cv va cv cfv va cv vc cv cres vk cv vk
      cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab
      wral vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni wceq vh
      vk copab cfv wceq vc vb cv wral wa vb con0 wrex va cab cuni eqid vq cv vv
      cv cR wbr vq vd cv crn wral vs cv vr cv cR wbr vs vd cv crn wral vv vr cA
      vv cv vr cv wceq vs cv vv cv cR wbr vs vd cv crn wral vs cv vr cv cR wbr
      vs vd cv crn wral vq cv vv cv cR wbr vq vd cv crn wral vv cv vr cv wceq
      vs cv vv cv cR wbr vs cv vr cv cR wbr vs vd cv crn vv cv vr cv vs cv cR
      breq2 ralbidv vq cv vv cv cR wbr vs cv vv cv cR wbr vq vs vd cv crn vq cv
      vs cv vv cv cR breq1 cbvralv syl5bb cbvrabv vs cv vr cv cR wbr vs va cv
      vb cv wfn vc cv va cv cfv va cv vc cv cres vk cv vk cv vm cv vq cv wbr wn
      vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vm vq cv vv cv cR
      wbr vq vh cv crn wral vv cA crab crab cuni wceq vh vk copab cfv wceq vc
      vb cv wral wa vb con0 wrex va cab cuni vt cv cima wral vr cA crab eqid vk
      cv vk cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA
      crab wral vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni
      wceq vg cv vj cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd cv crn
      wral vv cA crab wral vn vq cv vv cv cR wbr vq vd cv crn wral vv cA crab
      crab cuni wceq vh vk vd vg vk cv vg cv wceq vh cv vd cv wceq vk cv vg cv
      vk cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA
      crab wral vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab crab cuni vj
      cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd cv crn wral vv cA crab
      wral vn vq cv vv cv cR wbr vq vd cv crn wral vv cA crab crab cuni vk cv
      vg cv wceq id vh cv vd cv wceq vk cv vm cv vq cv wbr wn vk vq cv vv cv cR
      wbr vq vh cv crn wral vv cA crab wral vm vq cv vv cv cR wbr vq vh cv crn
      wral vv cA crab crab vj cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd
      cv crn wral vv cA crab wral vn vq cv vv cv cR wbr vq vd cv crn wral vv cA
      crab crab vh cv vd cv wceq vm cv vq cv vv cv cR wbr vq vh cv crn wral vv
      cA crab wcel vk cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn
      wral vv cA crab wral wa vm cab vn cv vq cv vv cv cR wbr vq vd cv crn wral
      vv cA crab wcel vj cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd cv
      crn wral vv cA crab wral wa vn cab vk cv vm cv vq cv wbr wn vk vq cv vv
      cv cR wbr vq vh cv crn wral vv cA crab wral vm vq cv vv cv cR wbr vq vh
      cv crn wral vv cA crab crab vj cv vn cv vq cv wbr wn vj vq cv vv cv cR
      wbr vq vd cv crn wral vv cA crab wral vn vq cv vv cv cR wbr vq vd cv crn
      wral vv cA crab crab vh cv vd cv wceq vn cv vq cv vv cv cR wbr vq vh cv
      crn wral vv cA crab wcel vk cv vn cv vq cv wbr wn vk vq cv vv cv cR wbr
      vq vh cv crn wral vv cA crab wral wa vn cab vn cv vq cv vv cv cR wbr vq
      vd cv crn wral vv cA crab wcel vj cv vn cv vq cv wbr wn vj vq cv vv cv cR
      wbr vq vd cv crn wral vv cA crab wral wa vn cab vm cv vq cv vv cv cR wbr
      vq vh cv crn wral vv cA crab wcel vk cv vm cv vq cv wbr wn vk vq cv vv cv
      cR wbr vq vh cv crn wral vv cA crab wral wa vm cab vh cv vd cv wceq vn cv
      vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wcel vk cv vn cv vq cv
      wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral wa vn cv
      vq cv vv cv cR wbr vq vd cv crn wral vv cA crab wcel vj cv vn cv vq cv
      wbr wn vj vq cv vv cv cR wbr vq vd cv crn wral vv cA crab wral wa vn vh
      cv vd cv wceq vn cv vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wcel
      vn cv vq cv vv cv cR wbr vq vd cv crn wral vv cA crab wcel vk cv vn cv vq
      cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vj cv
      vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd cv crn wral vv cA crab
      wral vh cv vd cv wceq vq cv vv cv cR wbr vq vh cv crn wral vv cA crab vq
      cv vv cv cR wbr vq vd cv crn wral vv cA crab vn cv vh cv vd cv wceq vq cv
      vv cv cR wbr vq vh cv crn wral vq cv vv cv cR wbr vq vd cv crn wral vv cA
      vh cv vd cv wceq vq cv vv cv cR wbr vq vh cv crn vd cv crn vh cv vd cv
      rneq raleq1d rabbisdv eleq2d vh cv vd cv wceq vq cv vv cv cR wbr vq vh cv
      crn wral vv cA crab vq cv vv cv cR wbr vq vd cv crn wral vv cA crab wceq
      vk cv vn cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA
      crab wral vj cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd cv crn
      wral vv cA crab wral wb vh cv vd cv wceq vq cv vv cv cR wbr vq vh cv crn
      wral vq cv vv cv cR wbr vq vd cv crn wral vv cA vh cv vd cv wceq vq cv vv
      cv cR wbr vq vh cv crn vd cv crn vh cv vd cv rneq raleq1d rabbisdv vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab vq cv vv cv cR wbr vq vd cv crn
      wral vv cA crab wceq vj cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vh
      cv crn wral vv cA crab wral vj cv vn cv vq cv wbr wn vj vq cv vv cv cR
      wbr vq vd cv crn wral vv cA crab wral vk cv vn cv vq cv wbr wn vk vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab wral vj cv vn cv vq cv wbr wn
      vj vq cv vv cv cR wbr vq vh cv crn wral vv cA crab vq cv vv cv cR wbr vq
      vd cv crn wral vv cA crab raleq1 vk cv vn cv vq cv wbr wn vj cv vn cv vq
      cv wbr wn vk vj vq cv vv cv cR wbr vq vh cv crn wral vv cA crab vk cv vj
      cv wceq vk cv vn cv vq cv wbr vj cv vn cv vq cv wbr vk cv vj cv vn cv vq
      cv breq1 notbid cbvralv syl5bb syl anbi12d abbidv vm cv vq cv vv cv cR
      wbr vq vh cv crn wral vv cA crab wcel vk cv vm cv vq cv wbr wn vk vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab wral wa vn cv vq cv vv cv cR
      wbr vq vh cv crn wral vv cA crab wcel vk cv vn cv vq cv wbr wn vk vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab wral wa vm vn vm cv vn cv wceq
      vm cv vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wcel vn cv vq cv vv
      cv cR wbr vq vh cv crn wral vv cA crab wcel vk cv vm cv vq cv wbr wn vk
      vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vk cv vn cv vq cv
      wbr wn vk vq cv vv cv cR wbr vq vh cv crn wral vv cA crab wral vm cv vn
      cv vq cv vv cv cR wbr vq vh cv crn wral vv cA crab eleq1 vm cv vn cv wceq
      vk cv vm cv vq cv wbr wn vk cv vn cv vq cv wbr wn vk vq cv vv cv cR wbr
      vq vh cv crn wral vv cA crab vm cv vn cv wceq vk cv vm cv vq cv wbr vk cv
      vn cv vq cv wbr vm cv vn cv vk cv vq cv breq2 notbid ralbidv anbi12d
      cbvabv syl5eq vk cv vm cv vq cv wbr wn vk vq cv vv cv cR wbr vq vh cv crn
      wral vv cA crab wral vm vq cv vv cv cR wbr vq vh cv crn wral vv cA crab
      df-rab vj cv vn cv vq cv wbr wn vj vq cv vv cv cR wbr vq vd cv crn wral
      vv cA crab wral vn vq cv vv cv cR wbr vq vd cv crn wral vv cA crab df-rab
      3eqtr4g unieqd eqeqan12rd cbvopabv vs cv vr cv cR wbr vs va cv vb cv wfn
      vc cv va cv cfv va cv vc cv cres vk cv vk cv vm cv vq cv wbr wn vk vq cv
      vv cv cR wbr vq vh cv crn wral vv cA crab wral vm vq cv vv cv cR wbr vq
      vh cv crn wral vv cA crab crab cuni wceq vh vk copab cfv wceq vc vb cv
      wral wa vb con0 wrex va cab cuni vu cv cima wral vr cA crab eqid
      zorn2lem7 $.
      $( [6-Apr-1997] $)

    $( Zorn's Lemma.  If the union of every chain (with respect to inclusion)
       in a set belongs to the set, then the set contains a maximal element.
       This theorem is equivalent to the Axiom of Choice.  Theorem 6M of
       [Enderton] p. 151.  See ~ zorn2 for a version with general partial
       orderings. $)
    zorn $p |- ( A. z ( ( z C_ A /\
                  A. x e. z A. y e. z ( x C_ y \/ y C_ x ) ) -> U. z e. A ) ->
                E. x e. A A. y e. A -. x C. y ) $=
      vz cv cA wss vx cv vy cv wss vy cv vx cv wss wo vy vz cv wral vx vz cv
      wral wa vz cv cuni cA wcel wi vz wal vx cv vy cv vw cv vv cv wpss vw vv
      copab wbr wn vy cA wral vx cA wrex vx cv vy cv wpss wn vy cA wral vx cA
      wrex cA vw cv vv cv wpss vw vv copab wpo vz cv cA wss vz cv vw cv vv cv
      wpss vw vv copab wor wa vu cv vx cv vw cv vv cv wpss vw vv copab wbr vu
      cv vx cv wceq wo vu vz cv wral vx cA wrex wi vz wal vx cv vy cv vw cv vv
      cv wpss vw vv copab wbr wn vy cA wral vx cA wrex vz cv cA wss vx cv vy cv
      wss vy cv vx cv wss wo vy vz cv wral vx vz cv wral wa vz cv cuni cA wcel
      wi vz wal vx vy vu vz cA vw cv vv cv wpss vw vv copab zorn2.1 zorn2 cA vw
      cv vv cv wpss vw vv copab wpo vu cv vu cv vw cv vv cv wpss vw vv copab
      wbr wn vu cv vy cv vw cv vv cv wpss vw vv copab wbr vy cv vx cv vw cv vv
      cv wpss vw vv copab wbr wa vu cv vx cv vw cv vv cv wpss vw vv copab wbr
      wi wa vx cA wral vy cA wral vu cA wral vu cv vu cv vw cv vv cv wpss vw vv
      copab wbr wn vu cv vy cv vw cv vv cv wpss vw vv copab wbr vy cv vx cv vw
      cv vv cv wpss vw vv copab wbr wa vu cv vx cv vw cv vv cv wpss vw vv copab
      wbr wi wa vu vy vx cA cA cA vu cv vu cv vw cv vv cv wpss vw vv copab wbr
      wn vu cv vy cv vw cv vv cv wpss vw vv copab wbr vy cv vx cv vw cv vv cv
      wpss vw vv copab wbr wa vu cv vx cv vw cv vv cv wpss vw vv copab wbr wi
      wa vu cv cA wcel vy cv cA wcel vx cv cA wcel w3a vu cv vu cv vw cv vv cv
      wpss vw vv copab wbr wn vu cv vy cv vw cv vv cv wpss vw vv copab wbr vy
      cv vx cv vw cv vv cv wpss vw vv copab wbr wa vu cv vx cv vw cv vv cv wpss
      vw vv copab wbr wi vu cv vu cv vw cv vv cv wpss vw vv copab wbr vu cv vu
      cv wpss vu cv pssirr vw vv vu vu zornlem mtbir vu cv vy cv wpss vy cv vx
      cv wpss vu cv vx cv vw cv vv cv wpss vw vv copab wbr vu cv vy cv vw cv vv
      cv wpss vw vv copab wbr vy cv vx cv vw cv vv cv wpss vw vv copab wbr vu
      cv vy cv wpss vy cv vx cv wpss wa vu cv vx cv wpss vu cv vx cv vw cv vv
      cv wpss vw vv copab wbr vu cv vy cv vx cv psstr vw vv vu vx zornlem
      sylibr vw vv vu vy zornlem vw vv vy vx zornlem syl2anb pm3.2i a1i rgen3
      vu vy vx cA vw cv vv cv wpss vw vv copab df-po mpbir vz cv cA wss vx cv
      vy cv wss vy cv vx cv wss wo vy vz cv wral vx vz cv wral wa vz cv cuni cA
      wcel wi vz cv cA wss vz cv vw cv vv cv wpss vw vv copab wor wa vu cv vx
      cv vw cv vv cv wpss vw vv copab wbr vu cv vx cv wceq wo vu vz cv wral vx
      cA wrex wi vz vz cv cA wss vz cv vw cv vv cv wpss vw vv copab wor wa vz
      cv cA wss vx cv vy cv wss vy cv vx cv wss wo vy vz cv wral vx vz cv wral
      wa vz cv cuni cA wcel vu cv vx cv vw cv vv cv wpss vw vv copab wbr vu cv
      vx cv wceq wo vu vz cv wral vx cA wrex vz cv vw cv vv cv wpss vw vv copab
      wor vx cv vy cv wss vy cv vx cv wss wo vy vz cv wral vx vz cv wral vz cv
      cA wss vz cv vw cv vv cv wpss vw vv copab wor vx cv vy cv vw cv vv cv
      wpss vw vv copab wbr vx cv vy cv wceq vy cv vx cv vw cv vv cv wpss vw vv
      copab wbr w3o vy vz cv wral vx vz cv wral vx cv vy cv wss vy cv vx cv wss
      wo vy vz cv wral vx vz cv wral vz cv vw cv vv cv wpss vw vv copab wor vz
      cv vw cv vv cv wpss vw vv copab wpo vx cv vy cv vw cv vv cv wpss vw vv
      copab wbr vx cv vy cv wceq vy cv vx cv vw cv vv cv wpss vw vv copab wbr
      w3o vy vz cv wral vx vz cv wral vx vy vz cv vw cv vv cv wpss vw vv copab
      df-so pm3.27bi vx cv vy cv vw cv vv cv wpss vw vv copab wbr vx cv vy cv
      wceq vy cv vx cv vw cv vv cv wpss vw vv copab wbr w3o vx cv vy cv wss vy
      cv vx cv wss wo vx vy vz cv vz cv vx cv vy cv vw cv vv cv wpss vw vv
      copab wbr vx cv vy cv wceq vy cv vx cv vw cv vv cv wpss vw vv copab wbr
      w3o vx cv vy cv wpss vx cv vy cv wceq vy cv vx cv wpss w3o vx cv vy cv
      wss vy cv vx cv wss wo vx cv vy cv vw cv vv cv wpss vw vv copab wbr vx cv
      vy cv wpss vx cv vy cv wceq vx cv vy cv wceq vy cv vx cv vw cv vv cv wpss
      vw vv copab wbr vy cv vx cv wpss vw vv vx vy zornlem vx cv vy cv wceq
      biid vw vv vy vx zornlem 3orbi123i vx cv vy cv sspsstri bitr4i 2ralbii
      sylib anim2i vz cv cuni cA wcel vx cv vz cv cuni wceq vx cA wrex vu cv vx
      cv vw cv vv cv wpss vw vv copab wbr vu cv vx cv wceq wo vu vz cv wral vx
      cA wrex vx vz cv cuni cA risset vx cv vz cv cuni wceq vu cv vx cv vw cv
      vv cv wpss vw vv copab wbr vu cv vx cv wceq wo vu vz cv wral vx cA vx cv
      vz cv cuni wceq vu cv vx cv wss vu vz cv wral vu cv vx cv vw cv vv cv
      wpss vw vv copab wbr vu cv vx cv wceq wo vu vz cv wral vx cv vz cv cuni
      wceq vz cv cuni vx cv wss vu cv vx cv wss vu vz cv wral vz cv cuni vx cv
      eqimss2 vu vz cv vx cv unissb sylib vu cv vx cv vw cv vv cv wpss vw vv
      copab wbr vu cv vx cv wceq wo vu cv vx cv wss vu vz cv vu cv vx cv vw cv
      vv cv wpss vw vv copab wbr vu cv vx cv wceq wo vu cv vx cv wpss vu cv vx
      cv wceq wo vu cv vx cv wss vu cv vx cv vw cv vv cv wpss vw vv copab wbr
      vu cv vx cv wpss vu cv vx cv wceq vw vv vu vx zornlem orbi1i vu cv vx cv
      sspss bitr4i ralbii sylibr r19.22si sylbi imim12i 19.20i sylancr vx cv vy
      cv vw cv vv cv wpss vw vv copab wbr wn vy cA wral vx cv vy cv wpss wn vy
      cA wral vx cA vx cv vy cv vw cv vv cv wpss vw vv copab wbr wn vx cv vy cv
      wpss wn vy cA vx cv vy cv vw cv vv cv wpss vw vv copab wbr vx cv vy cv
      wpss vw vv vx vy zornlem notbii ralbii rexbii sylib $.
      $( [16-Aug-2004] $) $( [12-Aug-2004] $)
  $}

  ${
     $d f F $.  $d f A $.  $d f B $.
     fodom.1 $e |- A e. _V $.
     $( An onto function implies dominance of domain over range.  Lemma 10.20
        of [Kunen] p. 30.  This theorem uses the Axiom of Choice ~ ac7g .  AC
        is not needed for finite sets - see ~ fodomfi . $)
     fodom $p |- ( F : A -onto-> B -> B ~<_ A ) $=
       cA cB cF wfo vf cv cF ccnv wss vf cv cF ccnv cdm wfn wa vf wex cB cA
       cdom wbr cA cB cF wfo cF cvv wcel cF ccnv cvv wcel vf cv cF ccnv wss vf
       cv cF ccnv cdm wfn wa vf wex cA cB cF wf cA cvv wcel cF cvv wcel cA cB
       cF wfo cA cB cvv cF fex cA cB cF fof fodom.1 sylancl cF cvv cnvexg cvv
       cF ccnv vf ac7g 3syl cA cB cF wfo vf cv cF ccnv wss vf cv cF ccnv cdm
       wfn wa cB cA cdom wbr vf cA cB cF wfo vf cv cF ccnv wss vf cv cF ccnv
       cdm wfn cB cA cdom wbr cA cB cF wfo vf cv cF ccnv cdm wfn vf cv cF ccnv
       wss cB cA cdom wbr cA cB cF wfo vf cv cF ccnv cdm wfn vf cv cB wfn vf cv
       cF ccnv wss cB cA cdom wbr wi cA cB cF wfo cF ccnv cdm cB wceq vf cv cF
       ccnv cdm wfn vf cv cB wfn wb cA cB cF wfo cF crn cB cF ccnv cdm cA cB cF
       forn cF df-rn syl5eqr cF ccnv cdm cB vf cv fneq2 syl cA cB cF wfo vf cv
       cB wfn vf cv cF ccnv wss cB cA cdom wbr cB vf cv crn cdom wbr vf cv crn
       cA cdom wbr cB cA cdom wbr cA cB cF wfo vf cv cB wfn wa vf cv cF ccnv
       wss wa cB vf cv crn cA domtr cA cB cF wfo vf cv cB wfn wa vf cv cF ccnv
       wss wa cB vf cv crn vf cv wf1 cB vf cv crn cdom wbr cB vf cv crn vf cv
       wf1 cB vf cv crn vf cv wf vf cv ccnv wfun cA cB cF wfo vf cv cB wfn wa
       vf cv cF ccnv wss wa cB vf cv crn vf cv df-f1 vf cv cB wfn cB vf cv crn
       vf cv wf cA cB cF wfo vf cv cF ccnv wss vf cv cB wfn cB vf cv crn vf cv
       wf cB vf cv dffn3 biimpi ad2antlr cA cB cF wfo vf cv cF ccnv wss vf cv
       ccnv wfun vf cv cB wfn cF wfun vf cv ccnv cF wss vf cv ccnv wfun cA cB
       cF wfo vf cv cF ccnv wss vf cv ccnv cF wss cF wfun vf cv ccnv wfun vf cv
       ccnv cF funss impcom cA cB cF fofun vf cv ccnv cF ccnv ccnv wss cF ccnv
       ccnv cF wss vf cv ccnv cF wss vf cv cF ccnv wss vf cv ccnv cF ccnv ccnv
       cF sstr vf cv cF ccnv cnvss cF cnvcnvss sylancl syl2an adantlr sylanbrc
       vf cv crn cvv wcel cB vf cv crn vf cv wf1 cB vf cv crn cdom wbr wi vf cv
       vf visset rnex cB vf cv crn cvv vf cv f1dom2g ax-mp syl cA cB cF wfo vf
       cv cF ccnv wss vf cv crn cA cdom wbr vf cv cB wfn cA cB cF wfo vf cv cF
       ccnv wss wa vf cv crn cA wss vf cv crn cA cdom wbr cA cB cF wfo vf cv cF
       ccnv wss wa vf cv crn cF ccnv crn cA vf cv cF ccnv wss vf cv crn cF ccnv
       crn wss cA cB cF wfo vf cv cF ccnv rnss adantl cA cB cF wfo cF ccnv crn
       cA wceq vf cv cF ccnv wss cA cB cF wfo cF cdm cA cF ccnv crn cA cB cF
       wfo cA cB cF wf cF cdm cA wceq cA cB cF fof cA cB cF fdm syl cF dfdm4
       syl5eqr adantr sseqtrd vf cv crn cvv wcel vf cv crn cA wss vf cv crn cA
       cdom wbr wi vf cv vf visset rnex vf cv crn cA cvv ssdomg ax-mp syl
       adantlr sylanc exp31 sylbid com23 imp3a 19.23adv mpd $.
       $( [30-Jul-2004] $) $( [23-Jul-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( An onto function implies dominance of domain over range. $)
    fodomg $p |- ( A e. C -> ( F : A -onto-> B -> B ~<_ A ) ) $=
      vx cv cB cF wfo cB vx cv cdom wbr wi cA cB cF wfo cB cA cdom wbr wi vx cA
      cC vx cv cA wceq vx cv cB cF wfo cA cB cF wfo cB vx cv cdom wbr cB cA
      cdom wbr vx cv cA cB cF foeq2 vx cv cA cB cdom breq2 imbi12d vx cv cB cF
      vx visset fodom vtoclg $.
      $( [30-Jul-2004] $) $( [23-Jul-2004] $)
  $}

  ${
    $d f g z A $.  $d f g z B $.
    fodomb.1 $e |- A e. _V $.
    $( Equivalence of an onto mapping and dominance for a non-empty set.
       Proposition 10.35 of [TakeutiZaring] p. 93. $)
    fodomb $p |- ( ( A =/= (/) /\ E. f f : A -onto-> B ) <->
                 ( (/) ~< B /\ B ~<_ A ) ) $=
      cA c0 wne cA cB vf cv wfo vf wex wa c0 cB csdm wbr cB cA cdom wbr wa cA
      c0 wne cA cB vf cv wfo vf wex c0 cB csdm wbr cB cA cdom wbr wa cA c0 wne
      cA cB vf cv wfo c0 cB csdm wbr cB cA cdom wbr wa vf cA c0 wne cA cB vf cv
      wfo c0 cB csdm wbr cB cA cdom wbr cA c0 wne cA cB vf cv wfo c0 cB csdm
      wbr cA c0 wne cA cB vf cv wfo wa c0 cB csdm wbr cB c0 wne cA cB vf cv wfo
      cA c0 wne cB c0 wne cA cB vf cv wfo cA c0 cB c0 cA cB vf cv wfo vf cv cdm
      c0 wceq cA c0 wceq cB c0 wceq cA cB vf cv wfo vf cv cdm cA c0 cA cB vf cv
      wfo cA cB vf cv wf vf cv cdm cA wceq cA cB vf cv fof cA cB vf cv fdm syl
      eqeq1d cA cB vf cv wfo vf cv crn c0 wceq cB c0 wceq vf cv cdm c0 wceq cA
      cB vf cv wfo vf cv crn cB c0 cA cB vf cv forn eqeq1d vf cv dm0rn0 syl5bb
      bitr3d necon3bid biimpac cA cB vf cv wfo c0 cB csdm wbr cB c0 wne wb cA
      c0 wne cA cB vf cv wfo cB cvv wcel c0 cB csdm wbr cB c0 wne wb cA cvv
      wcel cA cB vf cv wfo cB cvv wcel wi fodomb.1 cA cB cvv vf cv fornex ax-mp
      cB cvv 0sdomg syl adantl mpbird ex cA cB vf cv wfo cB cA cdom wbr wi cA
      c0 wne cA cB vf cv fodomb.1 fodom a1i jcad 19.23adv imp c0 cB csdm wbr cB
      cA cdom wbr wa cA c0 wne cA cB vf cv wfo vf wex c0 cB csdm wbr cB cA cdom
      wbr wa c0 cA csdm wbr cA c0 wne cA cvv wcel c0 cB csdm wbr cB cA cdom wbr
      wa c0 cA csdm wbr wi fodomb.1 c0 cB cA cvv sdomdomtr ax-mp cA fodomb.1
      0sdom sylib cA cvv wcel c0 cB csdm wbr cB cA cdom wbr cA cB vf cv wfo vf
      wex fodomb.1 cA cB cvv vf fodomr mp3an1 jca impbii $.
      $( [24-Feb-2007] $) $( [29-Jul-2004] $)
  $}

  ${
    $d f x y A $.  $d f x y B $.
    brdom3.1 $e |- A e. _V $.
    brdom3.2 $e |- B e. _V $.
    $( Equivalence to a dominance relation. $)
    brdom3 $p |- ( A ~<_ B <-> E. f ( A. x E* y x f y /\
                 A. x e. A E. y e. B y f x ) ) $=
      cA cB cdom wbr vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr
      vy cB wrex vx cA wral wa vf wex cA cB cdom wbr cA c0 wceq cB cA vf cv wfo
      vf wex wo vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy cB
      wrex vx cA wral wa vf wex cA cB cdom wbr cA c0 wceq wn wa cB cA vf cv wfo
      vf wex wi cA cB cdom wbr cA c0 wceq cB cA vf cv wfo vf wex wo wi cA c0
      wceq wn cA cB cdom wbr cB cA vf cv wfo vf wex c0 cA csdm wbr cA cB cdom
      wbr cB cA vf cv wfo vf wex cA c0 wceq wn cB cvv wcel c0 cA csdm wbr cA cB
      cdom wbr cB cA vf cv wfo vf wex brdom3.2 cB cA cvv vf fodomr mp3an1 c0 cA
      csdm wbr cA c0 wne cA c0 wceq wn cA brdom3.1 0sdom cA c0 df-ne bitr2i
      sylanb ancoms cA cB cdom wbr cA c0 wceq cB cA vf cv wfo vf wex pm5.6 mpbi
      cA c0 wceq vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy
      cB wrex vx cA wral wa vf wex cB cA vf cv wfo vf wex vx cv vy cv c0 wbr vy
      wmo vx wal vy cv vx cv c0 wbr vy cB wrex vx cA wral vx cv vy cv vf cv wbr
      vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf wex cA c0
      wceq vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex
      vx cA wral wa vx cv vy cv c0 wbr vy wmo vx wal vy cv vx cv c0 wbr vy cB
      wrex vx cA wral wa vf c0 0ex vf cv c0 wceq vx cv vy cv vf cv wbr vy wmo
      vx wal vx cv vy cv c0 wbr vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex
      vx cA wral vy cv vx cv c0 wbr vy cB wrex vx cA wral vf cv c0 wceq vx cv
      vy cv vf cv wbr vy wmo vx cv vy cv c0 wbr vy wmo vx vf cv c0 wceq vx cv
      vy cv vf cv wbr vx cv vy cv c0 wbr vy vf cv c0 wceq vy ax-17 vx cv vy cv
      vf cv c0 breq mobid albidv vf cv c0 wceq vy cv vx cv vf cv wbr vy cB wrex
      vy cv vx cv c0 wbr vy cB wrex vx cA vf cv c0 wceq vy cv vx cv vf cv wbr
      vy cv vx cv c0 wbr vy cB vy cv vx cv vf cv c0 breq rexbidv ralbidv
      anbi12d cla4ev vx cv vy cv c0 wbr vy wmo vx vx cv vy cv c0 wbr vy wex wn
      vx cv vy cv c0 wbr vy wmo vx cv vy cv c0 wbr vy vx cv vy cv c0 wbr vx cv
      vy cv cop c0 wcel vx cv vy cv cop noel vx cv vy cv c0 df-br mtbir nex vx
      cv vy cv c0 wbr vy wex vx cv vy cv c0 wbr vy wmo vx cv vy cv c0 wbr vy
      exmo ori ax-mp ax-gen vy cv vx cv c0 wbr vy cB wrex vx cA rzal sylancr cB
      cA vf cv wfo vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy
      cB wrex vx cA wral wa vf cB cA vf cv wfo vx cv vy cv vf cv wbr vy wmo vx
      wal vy cv vx cv vf cv wbr vy cB wrex vx cA wral cB cA vf cv wfo vf cv
      wfun vx cv vy cv vf cv wbr vy wmo vx wal cB cA vf cv fofun vf cv wfun vf
      cv wrel vx cv vy cv vf cv wbr vy wmo vx wal vx vy vf cv dffun6 pm3.27bi
      syl cB cA vf cv wfo cB cA vf cv wf vy cv vx cv vf cv wbr vy cB wrex vx cA
      wral vy vx cB cA vf cv dffo4 pm3.27bi jca 19.22i jaoi syl vx cv vy cv vf
      cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa cA cB
      cdom wbr vf vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy
      cB wrex vx cA wral wa vf cv cB cA cxp cin cdm cA vf cv cB cA cxp cin wfo
      cA vf cv cB cA cxp cin cdm cdom wbr cA cB cdom wbr vx cv vy cv vf cv wbr
      vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf cv cB cA
      cxp cin vf cv cB cA cxp cin cdm wfn vf cv cB cA cxp cin crn cA wceq wa vf
      cv cB cA cxp cin cdm cA vf cv cB cA cxp cin wfo vx cv vy cv vf cv wbr vy
      wmo vx wal vf cv cB cA cxp cin vf cv cB cA cxp cin cdm wfn vy cv vx cv vf
      cv wbr vy cB wrex vx cA wral vf cv cB cA cxp cin crn cA wceq vx cv vy cv
      vf cv wbr vy wmo vx wal vf cv cB cA cxp cin wfun vf cv cB cA cxp cin vf
      cv cB cA cxp cin cdm wfn vx cv vy cv vf cv wbr vy wmo vx wal vx cv vy cv
      vf cv cB cA cxp cin wbr vy wmo vx wal vf cv cB cA cxp cin wfun vx cv vy
      cv vf cv wbr vy wmo vx cv vy cv vf cv cB cA cxp cin wbr vy wmo vx vx cv
      vy cv vf cv cB cA cxp cin wbr vx cv vy cv vf cv wbr vy vf cv cB cA cxp
      cin vf cv vx cv vy cv vf cv cB cA cxp inss1 ssbri immoi 19.20i vf cv cB
      cA cxp cin wfun vf cv cB cA cxp cin wrel vx cv vy cv vf cv cB cA cxp cin
      wbr vy wmo vx wal vx vy vf cv cB cA cxp cin dffun6 cB cA cxp wrel vf cv
      cB cA cxp cin wrel cB cA relxp vf cv cB cA cxp relin2 ax-mp mpbiran
      sylibr vf cv cB cA cxp cin funfn sylib vf cv cB cA cxp cin crn cA wceq vy
      cv vx cv vf cv wbr vy cB wrex vx cA wral vy vx cB cA vf cv rninxp biimpri
      anim12i vf cv cB cA cxp cin cdm cA vf cv cB cA cxp cin df-fo sylibr vf cv
      cB cA cxp cin cdm cA vf cv cB cA cxp cin vf cv cB cA cxp cin vf cv cB cA
      cxp vf visset inex1 dmex fodom cA vf cv cB cA cxp cin cdm cdom wbr vf cv
      cB cA cxp cin cdm cB cdom wbr cA cB cdom wbr cB cvv wcel vf cv cB cA cxp
      cin cdm cB wss vf cv cB cA cxp cin cdm cB cdom wbr brdom3.2 vf cv cB cA
      cxp cin cdm cB cA cxp cdm cB vf cv cB cA cxp cin cB cA cxp wss vf cv cB
      cA cxp cin cdm cB cA cxp cdm wss vf cv cB cA cxp inss2 vf cv cB cA cxp
      cin cB cA cxp dmss ax-mp cB cA dmxpss sstri vf cv cB cA cxp cin cdm cB
      cvv ssdom2g mp2 cA vf cv cB cA cxp cin cdm cB domtr mpan2 3syl 19.23aiv
      impbii $.
      $( [27-Mar-2007] $) $( [27-Mar-2007] $)
  $}

  ${
    $d f g x y A v w z $.  $d f g x y B v w z $.
    brdom4.1 $e |- A e. _V $.
    brdom4.2 $e |- B e. _V $.
    $( An equivalence to a dominance relation. $)
    brdom5 $p |- ( A ~<_ B <->
  E. f ( A. x e. B E* y x f y /\ A. x e. A E. y e. B y f x ) ) $=
      cA cB cdom wbr vx cv vy cv vf cv wbr vy wmo vx cB wral vy cv vx cv vf cv
      wbr vy cB wrex vx cA wral wa vf wex cA cB cdom wbr vx cv vy cv vf cv wbr
      vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf wex vx cv
      vy cv vf cv wbr vy wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA
      wral wa vf wex vx vy cA cB vf brdom4.1 brdom4.2 brdom3 vx cv vy cv vf cv
      wbr vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vx cv vy
      cv vf cv wbr vy wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA
      wral wa vf vx cv vy cv vf cv wbr vy wmo vx wal vx cv vy cv vf cv wbr vy
      wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA wral vx cv vy cv vf
      cv wbr vy wmo vx cB alral anim1i 19.22i sylbi vx cv vy cv vf cv wbr vy
      wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa cA cB cdom
      wbr vf vx cv vy cv vf cv wbr vy wmo vx cB wral vy cv vx cv vf cv wbr vy
      cB wrex vx cA wral wa vf cv cB cA cxp cin cdm cA vf cv cB cA cxp cin wfo
      cA vf cv cB cA cxp cin cdm cdom wbr cA cB cdom wbr vx cv vy cv vf cv wbr
      vy wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf cv cB
      cA cxp cin vf cv cB cA cxp cin cdm wfn vf cv cB cA cxp cin crn cA wceq wa
      vf cv cB cA cxp cin cdm cA vf cv cB cA cxp cin wfo vx cv vy cv vf cv wbr
      vy wmo vx cB wral vf cv cB cA cxp cin vf cv cB cA cxp cin cdm wfn vy cv
      vx cv vf cv wbr vy cB wrex vx cA wral vf cv cB cA cxp cin crn cA wceq vx
      cv vy cv vf cv wbr vy wmo vx cB wral vf cv cB cA cxp cin wfun vf cv cB cA
      cxp cin vf cv cB cA cxp cin cdm wfn vx cv vy cv vf cv wbr vy wmo vx cB
      wral vf cv cB cA cxp cin wrel vx cv vy cv vf cv cB cA cxp cin wbr vy wmo
      vx vf cv cB cA cxp cin cdm wral wa vf cv cB cA cxp cin wfun vx cv vy cv
      vf cv wbr vy wmo vx cB wral vx cv vy cv vf cv cB cA cxp cin wbr vy wmo vx
      vf cv cB cA cxp cin cdm wral vf cv cB cA cxp cin wrel vx cv vy cv vf cv
      wbr vy wmo vx cv vy cv vf cv cB cA cxp cin wbr vy wmo vx cB vf cv cB cA
      cxp cin cdm vx cv vf cv cB cA cxp cin cdm wcel vx cv cB wcel vx cv vy cv
      vf cv wbr vy wmo vx cv vy cv vf cv cB cA cxp cin wbr vy wmo vf cv cB cA
      cxp cin cdm cB vx cv vf cv cB cA cxp cin cdm cB cA cxp cdm cB vf cv cB cA
      cxp cin cB cA cxp wss vf cv cB cA cxp cin cdm cB cA cxp cdm wss vf cv cB
      cA cxp inss2 vf cv cB cA cxp cin cB cA cxp dmss ax-mp cB cA dmxpss sstri
      sseli vx cv vy cv vf cv cB cA cxp cin wbr vx cv vy cv vf cv wbr vy vf cv
      cB cA cxp cin vf cv vx cv vy cv vf cv cB cA cxp inss1 ssbri immoi imim12i
      r19.20i2 cB cA cxp wrel vf cv cB cA cxp cin wrel cB cA relxp vf cv cB cA
      cxp relin2 ax-mp jctil vx vy vf cv cB cA cxp cin dffun7 sylibr vf cv cB
      cA cxp cin funfn sylib vf cv cB cA cxp cin crn cA wceq vy cv vx cv vf cv
      wbr vy cB wrex vx cA wral vy vx cB cA vf cv rninxp biimpri anim12i vf cv
      cB cA cxp cin cdm cA vf cv cB cA cxp cin df-fo sylibr vf cv cB cA cxp cin
      cdm cA vf cv cB cA cxp cin vf cv cB cA cxp cin vf cv cB cA cxp vf visset
      inex1 dmex fodom cA vf cv cB cA cxp cin cdm cdom wbr vf cv cB cA cxp cin
      cdm cB cdom wbr cA cB cdom wbr cB cvv wcel vf cv cB cA cxp cin cdm cB wss
      vf cv cB cA cxp cin cdm cB cdom wbr brdom4.2 vf cv cB cA cxp cin cdm cB
      cA cxp cdm cB vf cv cB cA cxp cin cB cA cxp wss vf cv cB cA cxp cin cdm
      cB cA cxp cdm wss vf cv cB cA cxp inss2 vf cv cB cA cxp cin cB cA cxp
      dmss ax-mp cB cA dmxpss sstri vf cv cB cA cxp cin cdm cB cvv ssdom2g mp2
      cA vf cv cB cA cxp cin cdm cB domtr mpan2 3syl 19.23aiv impbii $.
      $( [5-Apr-2007] $) $( [29-Mar-2007] $)

    $( An equivalence to a dominance relation. $)
    brdom4 $p |- ( A ~<_ B <->
  E. f ( A. x e. B E* y ( y e. A /\ x f y ) /\ A. x e. A E. y e. B y f x ) ) $=
      cA cB cdom wbr vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vx cB wral
      vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf wex cA cB cdom wbr vx
      cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv vf cv wbr vy cB wrex vx cA
      wral wa vf wex vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vx cB wral
      vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf wex vx vy cA cB vf
      brdom4.1 brdom4.2 brdom3 vx cv vy cv vf cv wbr vy wmo vx wal vy cv vx cv
      vf cv wbr vy cB wrex vx cA wral wa vy cv cA wcel vx cv vy cv vf cv wbr wa
      vy wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf vx cv
      vy cv vf cv wbr vy wmo vx wal vy cv cA wcel vx cv vy cv vf cv wbr wa vy
      wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA wral vx cv vy cv vf
      cv wbr vy wmo vx wal vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vx wal
      vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vx cB wral vx cv vy cv vf
      cv wbr vy wmo vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vx vx cv vy
      cv vf cv wbr vy cv cA wcel vy moan 19.20i vy cv cA wcel vx cv vy cv vf cv
      wbr wa vy wmo vx cB alral syl anim1i 19.22i sylbi vy cv cA wcel vx cv vy
      cv vf cv wbr wa vy wmo vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA
      wral wa cA cB cdom wbr vf vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo
      vx cB wral vy cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf cv cB cA cxp
      cin cdm cA vf cv cB cA cxp cin wfo cA vf cv cB cA cxp cin cdm cdom wbr cA
      cB cdom wbr vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vx cB wral vy
      cv vx cv vf cv wbr vy cB wrex vx cA wral wa vf cv cB cA cxp cin vf cv cB
      cA cxp cin cdm wfn vf cv cB cA cxp cin crn cA wceq wa vf cv cB cA cxp cin
      cdm cA vf cv cB cA cxp cin wfo vy cv cA wcel vx cv vy cv vf cv wbr wa vy
      wmo vx cB wral vf cv cB cA cxp cin vf cv cB cA cxp cin cdm wfn vy cv vx
      cv vf cv wbr vy cB wrex vx cA wral vf cv cB cA cxp cin crn cA wceq vy cv
      cA wcel vx cv vy cv vf cv wbr wa vy wmo vx cB wral vf cv cB cA cxp cin
      wfun vf cv cB cA cxp cin vf cv cB cA cxp cin cdm wfn vy cv cA wcel vx cv
      vy cv vf cv wbr wa vy wmo vx cB wral vf cv cB cA cxp cin wrel vy cv vf cv
      cB cA cxp cin crn wcel vx cv vy cv vf cv cB cA cxp cin wbr wa vy wmo vx
      vf cv cB cA cxp cin cdm wral wa vf cv cB cA cxp cin wfun vy cv cA wcel vx
      cv vy cv vf cv wbr wa vy wmo vx cB wral vy cv vf cv cB cA cxp cin crn
      wcel vx cv vy cv vf cv cB cA cxp cin wbr wa vy wmo vx vf cv cB cA cxp cin
      cdm wral vf cv cB cA cxp cin wrel vy cv cA wcel vx cv vy cv vf cv wbr wa
      vy wmo vy cv vf cv cB cA cxp cin crn wcel vx cv vy cv vf cv cB cA cxp cin
      wbr wa vy wmo vx cB vf cv cB cA cxp cin cdm vx cv vf cv cB cA cxp cin cdm
      wcel vx cv cB wcel vy cv cA wcel vx cv vy cv vf cv wbr wa vy wmo vy cv vf
      cv cB cA cxp cin crn wcel vx cv vy cv vf cv cB cA cxp cin wbr wa vy wmo
      vf cv cB cA cxp cin cdm cB vx cv vf cv cB cA cxp cin cdm cB cA cxp cdm cB
      vf cv cB cA cxp cin cB cA cxp wss vf cv cB cA cxp cin cdm cB cA cxp cdm
      wss vf cv cB cA cxp inss2 vf cv cB cA cxp cin cB cA cxp dmss ax-mp cB cA
      dmxpss sstri sseli vy cv vf cv cB cA cxp cin crn wcel vx cv vy cv vf cv
      cB cA cxp cin wbr wa vy cv cA wcel vx cv vy cv vf cv wbr wa vy vy cv vf
      cv cB cA cxp cin crn wcel vy cv cA wcel vx cv vy cv vf cv cB cA cxp cin
      wbr vx cv vy cv vf cv wbr vf cv cB cA cxp cin crn cA vy cv vf cv cB cA
      cxp cin crn cB cA cxp crn cA vf cv cB cA cxp cin cB cA cxp wss vf cv cB
      cA cxp cin crn cB cA cxp crn wss vf cv cB cA cxp inss2 vf cv cB cA cxp
      cin cB cA cxp rnss ax-mp cB cA rnxpss sstri sseli vf cv cB cA cxp cin vf
      cv vx cv vy cv vf cv cB cA cxp inss1 ssbri anim12i immoi imim12i r19.20i2
      cB cA cxp wrel vf cv cB cA cxp cin wrel cB cA relxp vf cv cB cA cxp
      relin2 ax-mp jctil vx vy vf cv cB cA cxp cin dffun9 sylibr vf cv cB cA
      cxp cin funfn sylib vf cv cB cA cxp cin crn cA wceq vy cv vx cv vf cv wbr
      vy cB wrex vx cA wral vy vx cB cA vf cv rninxp biimpri anim12i vf cv cB
      cA cxp cin cdm cA vf cv cB cA cxp cin df-fo sylibr vf cv cB cA cxp cin
      cdm cA vf cv cB cA cxp cin vf cv cB cA cxp cin vf cv cB cA cxp vf visset
      inex1 dmex fodom cA vf cv cB cA cxp cin cdm cdom wbr vf cv cB cA cxp cin
      cdm cB cdom wbr cA cB cdom wbr cB cvv wcel vf cv cB cA cxp cin cdm cB wss
      vf cv cB cA cxp cin cdm cB cdom wbr brdom4.2 vf cv cB cA cxp cin cdm cB
      cA cxp cdm cB vf cv cB cA cxp cin cB cA cxp wss vf cv cB cA cxp cin cdm
      cB cA cxp cdm wss vf cv cB cA cxp inss2 vf cv cB cA cxp cin cB cA cxp
      dmss ax-mp cB cA dmxpss sstri vf cv cB cA cxp cin cdm cB cvv ssdom2g mp2
      cA vf cv cB cA cxp cin cdm cB domtr mpan2 3syl 19.23aiv impbii $.
      $( [30-Mar-2007] $) $( [28-Mar-2007] $)
  $}

  ${
    $d f g x y A v w z $.  $d f g x y B v w z $.
    brdom7disj.1 $e |- A e. _V $.
    brdom7disj.2 $e |- B e. _V $.
    brdom7disj.3 $e |- ( A i^i B ) = (/) $.
    $( An equivalence to a dominance relation for disjoint sets. $)
    brdom7disj $p |- ( A ~<_ B <-> E. f ( A. x e. B E* y
      ( y e. A /\ { x , y } e. f ) /\ A. x e. A E. y e. B { y , x } e. f ) ) $=
      cA cB cdom wbr vy cv cA wcel vx cv vy cv vg cv wbr wa vy wmo vx cB wral
      vy cv vx cv vg cv wbr vy cB wrex vx cA wral wa vg wex vy cv cA wcel vx cv
      vy cv cpr vf cv wcel wa vy wmo vx cB wral vy cv vx cv cpr vf cv wcel vy
      cB wrex vx cA wral wa vf wex vx vy cA cB vg brdom7disj.1 brdom7disj.2
      brdom4 vy cv cA wcel vx cv vy cv vg cv wbr wa vy wmo vx cB wral vy cv vx
      cv vg cv wbr vy cB wrex vx cA wral wa vg wex vy cv cA wcel vx cv vy cv
      cpr vf cv wcel wa vy wmo vx cB wral vy cv vx cv cpr vf cv wcel vy cB wrex
      vx cA wral wa vf wex vy cv cA wcel vx cv vy cv vg cv wbr wa vy wmo vx cB
      wral vy cv vx cv vg cv wbr vy cB wrex vx cA wral wa vy cv cA wcel vx cv
      vy cv cpr vf cv wcel wa vy wmo vx cB wral vy cv vx cv cpr vf cv wcel vy
      cB wrex vx cA wral wa vf wex vg vy cv cA wcel vx cv vy cv cpr vv cv vz cv
      vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab
      wcel wa vy wmo vx cB wral vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz
      cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy cB wrex
      vx cA wral vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy wmo vx cB wral
      vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vf wex vy cv cA wcel
      vx cv vy cv vg cv wbr wa vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB
      wrex vx cA wral vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy wmo vx cB
      wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vy cv cA wcel vx
      cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz
      cB wrex vw cA wrex vv cab wcel wa vy wmo vx cB wral vy cv vx cv cpr vv cv
      vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex
      vv cab wcel vy cB wrex vx cA wral wa vf vv cv vz cv vw cv cpr wceq vz cv
      vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab vv cv vz cv vw cv
      cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw vv cA brdom7disj.1
      vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz vv cB
      brdom7disj.2 vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vv
      cab vz cv vw cv cpr csn vz cv vw cv cpr snex vv cv vz cv vw cv cpr wceq
      vz cv vw cv cop vg cv wcel wa vv cab vv cv vz cv vw cv cpr wceq vv cab vz
      cv vw cv cpr csn vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa
      vv cv vz cv vw cv cpr wceq vv vv cv vz cv vw cv cpr wceq vz cv vw cv cop
      vg cv wcel pm3.26 ss2abi vv vz cv vw cv cpr df-sn sseqtr4i ssexi abrexex2
      abrexex2 vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa
      vz cB wrex vw cA wrex vv cab wceq vy cv cA wcel vx cv vy cv cpr vf cv
      wcel wa vy wmo vx cB wral vy cv cA wcel vx cv vy cv cpr vv cv vz cv vw cv
      cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel
      wa vy wmo vx cB wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral vy
      cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz
      cB wrex vw cA wrex vv cab wcel vy cB wrex vx cA wral vf cv vv cv vz cv vw
      cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab
      wceq vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy wmo vy cv cA wcel vx
      cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz
      cB wrex vw cA wrex vv cab wcel wa vy wmo vx cB vf cv vv cv vz cv vw cv
      cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wceq
      vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy cv cA wcel vx cv vy cv cpr
      vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA
      wrex vv cab wcel wa vy vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop
      vg cv wcel wa vz cB wrex vw cA wrex vv cab wceq vy ax-17 vf cv vv cv vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv
      cab wceq vx cv vy cv cpr vf cv wcel vx cv vy cv cpr vv cv vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy
      cv cA wcel vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa
      vz cB wrex vw cA wrex vv cab vx cv vy cv cpr eleq2 anbi2d mobid ralbidv
      vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex
      vw cA wrex vv cab wceq vy cv vx cv cpr vf cv wcel vy cB wrex vy cv vx cv
      cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex
      vw cA wrex vv cab wcel vy cB wrex vx cA vf cv vv cv vz cv vw cv cpr wceq
      vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wceq vy cv vx
      cv cpr vf cv wcel vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv
      cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy cB vf cv vv cv vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv
      cab vy cv vx cv cpr eleq2 rexbidv ralbidv anbi12d cla4ev vy cv cA wcel vx
      cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz
      cB wrex vw cA wrex vv cab wcel wa vy wmo vy cv cA wcel vx cv vy cv vg cv
      wbr wa vy wmo vx cB vx cv cB wcel vy cv cA wcel vx cv vy cv cpr vv cv vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv
      cab wcel wa vy cv cA wcel vx cv vy cv vg cv wbr wa vy vx cv cB wcel vy
      ax-17 vx cv cB wcel vy cv cA wcel vx cv vy cv cpr vv cv vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vx
      cv vy cv vg cv wbr vx cv cB wcel vy cv cA wcel wa vx cv vy cv cpr vv cv
      vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex
      vv cab wcel vz cv vx cv wceq vw cv vy cv wceq wa vz cv vw cv vg cv wbr wa
      vw cA wrex vz cB wrex vx cv vy cv vg cv wbr vx cv cB wcel vx cv vy cv cpr
      vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA
      wrex vv cab wcel vz cv vx cv wceq vw cv vy cv wceq wa vz cv vw cv vg cv
      wbr wa vw cA wrex vz cB wrex wb vy cv cA wcel vx cv cB wcel vz cv vx cv
      wceq vw cv vy cv wceq wa vz cv vw cv vg cv wbr wa vw cA wrex vz cB wrex
      vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vw cA
      wrex vz cB wrex vx cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv
      cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vx cv cB wcel vz cv
      vx cv wceq vw cv vy cv wceq wa vz cv vw cv vg cv wbr wa vw cA wrex vx cv
      vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vw cA wrex
      vz cB vx cv cB wcel vz cv vx cv wceq vw cv vy cv wceq wa vz cv vw cv vg
      cv wbr wa vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel
      wa vw cA vx cv cB wcel vw cv cA wcel wa vz cv vx cv wceq vw cv vy cv wceq
      wa vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv vg cv wbr vz cv vw cv
      cop vg cv wcel vx cv cB wcel vw cv cA wcel wa vx cv vy cv cpr vz cv vw cv
      cpr wceq vx cv vz cv wceq vy cv vw cv wceq wa vz cv vx cv wceq vw cv vy
      cv wceq wa vx cv cB wcel vw cv cA wcel wa vx cv vw cv wne vx cv vy cv cpr
      vz cv vw cv cpr wceq vx cv vz cv wceq vy cv vw cv wceq wa wb cB cA cin c0
      wceq vx cv cB wcel vw cv cA wcel vx cv vw cv wne cB cA cin cA cB cin c0
      cB cA incom brdom7disj.3 eqtri cB cA vx cv vw cv disjne mp3an1 vx cv vy
      cv vz cv vw cv vx visset vy visset vz visset vw visset opthpr syl vx cv
      vz cv wceq vz cv vx cv wceq vy cv vw cv wceq vw cv vy cv wceq vx vz
      equcom vy vw equcom anbi12i syl6rbb vz cv vw cv vg cv wbr vz cv vw cv cop
      vg cv wcel wb vx cv cB wcel vw cv cA wcel wa vz cv vw cv vg cv df-br a1i
      anbi12d rexbidva rexbidv vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv
      cop vg cv wcel wa vw cA wrex vz cB wrex vx cv vy cv cpr vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vx cv vy cv cpr
      vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA
      wrex vv cab wcel vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg
      cv wcel wa vz vw cB cA rexcom vv cv vz cv vw cv cpr wceq vz cv vw cv cop
      vg cv wcel wa vz cB wrex vw cA wrex vx cv vy cv cpr vz cv vw cv cpr wceq
      vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv vx cv vy cv cpr vx
      vy zfpair2 vv cv vx cv vy cv cpr wceq vv cv vz cv vw cv cpr wceq vz cv vw
      cv cop vg cv wcel wa vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop
      vg cv wcel wa vw vz cA cB vv cv vx cv vy cv cpr wceq vv cv vz cv vw cv
      cpr wceq vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel
      vv cv vx cv vy cv cpr vz cv vw cv cpr eqeq1 anbi1d 2rexbidv elab bitr4i
      syl6rbb adantr vz cv vw cv vg cv wbr vx cv vw cv vg cv wbr vx cv vy cv vg
      cv wbr vz vw vx cv vy cv cB cA vz cv vx cv vw cv vg cv breq1 vw cv vy cv
      vx cv vg cv breq2 ceqsrex2v bitrd pm5.32da mobid ralbiia vy cv vx cv cpr
      vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA
      wrex vv cab wcel vy cB wrex vy cv vx cv vg cv wbr vy cB wrex vx cA vx cv
      cA wcel vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv
      wcel wa vz cB wrex vw cA wrex vv cab wcel vy cv vx cv vg cv wbr vy cB vx
      cv cA wcel vy cv cB wcel wa vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz
      cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vw cv vx cv
      wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB wrex vw cA wrex
      vy cv vx cv vg cv wbr vx cv cA wcel vy cv vx cv cpr vv cv vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vw
      cv vx cv wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB wrex vw
      cA wrex wb vy cv cB wcel vx cv cA wcel vy cv vx cv cpr vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vw cv vx cv wceq
      vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB wrex vw cA wrex vy cv
      vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB
      wrex vw cA wrex vv cab wcel vx cv cA wcel vy cv vx cv cpr vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cv vx cv wceq vz cv vy
      cv wceq wa vz cv vw cv vg cv wbr wa vz cB wrex vw cA vx cv cA wcel vy cv
      vx cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vw cv vx cv
      wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB vx cv cA wcel vz
      cv cB wcel wa vy cv vx cv cpr vz cv vw cv cpr wceq vw cv vx cv wceq vz cv
      vy cv wceq wa vz cv vw cv cop vg cv wcel vz cv vw cv vg cv wbr vx cv cA
      wcel vz cv cB wcel wa vz cv vw cv cpr vy cv vx cv cpr wceq vz cv vy cv
      wceq vw cv vx cv wceq wa vy cv vx cv cpr vz cv vw cv cpr wceq vw cv vx cv
      wceq vz cv vy cv wceq wa vx cv cA wcel vz cv cB wcel wa vz cv vx cv wne
      vz cv vw cv cpr vy cv vx cv cpr wceq vz cv vy cv wceq vw cv vx cv wceq wa
      wb vz cv cB wcel vx cv cA wcel vz cv vx cv wne cB cA cin c0 wceq vz cv cB
      wcel vx cv cA wcel vz cv vx cv wne cB cA cin cA cB cin c0 cB cA incom
      brdom7disj.3 eqtri cB cA vz cv vx cv disjne mp3an1 ancoms vz cv vw cv vy
      cv vx cv vz visset vw visset vy visset vx visset opthpr syl vy cv vx cv
      cpr vz cv vw cv cpr eqcom vw cv vx cv wceq vz cv vy cv wceq ancom 3bitr4g
      vz cv vw cv cop vg cv wcel vz cv vw cv vg cv wbr wb vx cv cA wcel vz cv
      cB wcel wa vz cv vw cv vg cv wbr vz cv vw cv cop vg cv wcel vz cv vw cv
      vg cv df-br bicomi a1i anbi12d rexbidva rexbidv vv cv vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vy cv vx cv cpr
      vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex
      vv vy cv vx cv cpr vy vx zfpair2 vv cv vy cv vx cv cpr wceq vv cv vz cv
      vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vy cv vx cv cpr vz cv vw cv
      cpr wceq vz cv vw cv cop vg cv wcel wa vw vz cA cB vv cv vy cv vx cv cpr
      wceq vv cv vz cv vw cv cpr wceq vy cv vx cv cpr vz cv vw cv cpr wceq vz
      cv vw cv cop vg cv wcel vv cv vy cv vx cv cpr vz cv vw cv cpr eqeq1
      anbi1d 2rexbidv elab syl5bb adantr vz cv vw cv vg cv wbr vz cv vx cv vg
      cv wbr vy cv vx cv vg cv wbr vw vz vx cv vy cv cA cB vw cv vx cv vz cv vg
      cv breq2 vz cv vy cv vx cv vg cv breq1 ceqsrex2v bitrd rexbidva ralbiia
      syl2anbr 19.23aiv vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy wmo vx
      cB wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vy cv cA wcel
      vx cv vy cv vg cv wbr wa vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB
      wrex vx cA wral wa vg wex vf vy cv cA wcel vx cv vy cv vw cv vz cv cpr vf
      cv wcel vw vz copab wbr wa vy wmo vx cB wral vy cv vx cv vw cv vz cv cpr
      vf cv wcel vw vz copab wbr vy cB wrex vx cA wral vy cv cA wcel vx cv vy
      cv vg cv wbr wa vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB wrex vx cA
      wral wa vg wex vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy wmo vx cB
      wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral vy cv cA wcel vx cv
      vy cv vg cv wbr wa vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB wrex vx
      cA wral wa vy cv cA wcel vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz
      copab wbr wa vy wmo vx cB wral vy cv vx cv vw cv vz cv cpr vf cv wcel vw
      vz copab wbr vy cB wrex vx cA wral wa vg vw cv vz cv cpr vf cv wcel vw vz
      copab vw cv vz cv cpr vf cv wcel vw vz copab vv cv vw cv vz cv cop wceq
      vw cv vz cv cpr vf cv wcel wa vz wex vw wex vv cab cvv vw cv vz cv cpr vf
      cv wcel vw vz vv df-opab vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf cv
      wcel wa vz wex vw vv vf cv cuni vf cv vf visset uniex vv cv vw cv vz cv
      cop wceq vw cv vz cv cpr vf cv wcel wa vw cv vf cv cuni wcel vz vw cv vz
      cv cpr vf cv wcel vw cv vf cv cuni wcel vv cv vw cv vz cv cop wceq vw cv
      vw cv vz cv cpr wcel vw cv vz cv cpr vf cv wcel vw cv vf cv cuni wcel vw
      cv vz cv vw visset prid1 vw cv vw cv vz cv cpr vf cv elunii mpan adantl
      19.23aiv vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf cv wcel wa vz vv
      vf cv cuni vf cv vf visset uniex vw cv vz cv cpr vf cv wcel vz cv vf cv
      cuni wcel vv cv vw cv vz cv cop wceq vz cv vw cv vz cv cpr wcel vw cv vz
      cv cpr vf cv wcel vz cv vf cv cuni wcel vw cv vz cv vz visset prid2 vz cv
      vw cv vz cv cpr vf cv elunii mpan adantl vv cv vw cv vz cv cop wceq vw cv
      vz cv cpr vf cv wcel wa vv cab vv cv vw cv vz cv cop wceq vv cab vw cv vz
      cv cop csn vv cv vw cv vz cv cop wceq vv cab cvv vv vw cv vz cv cop df-sn
      vw cv vz cv cop snex eqeltrri vv cv vw cv vz cv cop wceq vw cv vz cv cpr
      vf cv wcel wa vv cv vw cv vz cv cop wceq vv vv cv vw cv vz cv cop wceq vw
      cv vz cv cpr vf cv wcel pm3.26 ss2abi ssexi abexex abexex eqeltri vg cv
      vw cv vz cv cpr vf cv wcel vw vz copab wceq vy cv cA wcel vx cv vy cv vg
      cv wbr wa vy wmo vx cB wral vy cv cA wcel vx cv vy cv vw cv vz cv cpr vf
      cv wcel vw vz copab wbr wa vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB
      wrex vx cA wral vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy
      cB wrex vx cA wral vg cv vw cv vz cv cpr vf cv wcel vw vz copab wceq vy
      cv cA wcel vx cv vy cv vg cv wbr wa vy wmo vy cv cA wcel vx cv vy cv vw
      cv vz cv cpr vf cv wcel vw vz copab wbr wa vy wmo vx cB vg cv vw cv vz cv
      cpr vf cv wcel vw vz copab wceq vy cv cA wcel vx cv vy cv vg cv wbr wa vy
      cv cA wcel vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab wbr wa vy
      vg cv vw cv vz cv cpr vf cv wcel vw vz copab wceq vy ax-17 vg cv vw cv vz
      cv cpr vf cv wcel vw vz copab wceq vx cv vy cv vg cv wbr vx cv vy cv vw
      cv vz cv cpr vf cv wcel vw vz copab wbr vy cv cA wcel vx cv vy cv vg cv
      vw cv vz cv cpr vf cv wcel vw vz copab breq anbi2d mobid ralbidv vg cv vw
      cv vz cv cpr vf cv wcel vw vz copab wceq vy cv vx cv vg cv wbr vy cB wrex
      vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy cB wrex vx cA
      vg cv vw cv vz cv cpr vf cv wcel vw vz copab wceq vy cv vx cv vg cv wbr
      vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy cB vy cv vx cv
      vg cv vw cv vz cv cpr vf cv wcel vw vz copab breq rexbidv ralbidv anbi12d
      cla4ev vy cv cA wcel vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab
      wbr wa vy wmo vy cv cA wcel vx cv vy cv cpr vf cv wcel wa vy wmo vx cB vy
      cv cA wcel vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab wbr wa vy
      cv cA wcel vx cv vy cv cpr vf cv wcel wa vy vx cv vy cv vw cv vz cv cpr
      vf cv wcel vw vz copab wbr vx cv vy cv cpr vf cv wcel vy cv cA wcel vw cv
      vz cv cpr vf cv wcel vx cv vz cv cpr vf cv wcel vx cv vy cv cpr vf cv
      wcel vw vz vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab vx visset
      vy visset vw cv vx cv wceq vw cv vz cv cpr vx cv vz cv cpr vf cv vw cv vx
      cv vz cv preq1 eleq1d vz cv vy cv wceq vx cv vz cv cpr vx cv vy cv cpr vf
      cv vz cv vy cv vx cv preq2 eleq1d vw cv vz cv cpr vf cv wcel vw vz copab
      eqid brab anbi2i mobii ralbii vy cv vx cv vw cv vz cv cpr vf cv wcel vw
      vz copab wbr vy cB wrex vy cv vx cv cpr vf cv wcel vy cB wrex vx cA vy cv
      vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy cv vx cv cpr vf cv
      wcel vy cB vw cv vz cv cpr vf cv wcel vy cv vz cv cpr vf cv wcel vy cv vx
      cv cpr vf cv wcel vw vz vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz
      copab vy visset vx visset vw cv vy cv wceq vw cv vz cv cpr vy cv vz cv
      cpr vf cv vw cv vy cv vz cv preq1 eleq1d vz cv vx cv wceq vy cv vz cv cpr
      vy cv vx cv cpr vf cv vz cv vx cv vy cv preq2 eleq1d vw cv vz cv cpr vf
      cv wcel vw vz copab eqid brab rexbii ralbii syl2anbr 19.23aiv impbii
      bitri $.
      $( [31-Mar-2007] $) $( [29-Mar-2007] $)

    $( An equivalence to a dominance relation for disjoint sets. $)
    brdom6disj $p |- ( A ~<_ B <-> E. f ( A. x e. B E* y
      { x , y } e. f /\ A. x e. A E. y e. B { y , x } e. f ) ) $=
      cA cB cdom wbr vx cv vy cv vg cv wbr vy wmo vx cB wral vy cv vx cv vg cv
      wbr vy cB wrex vx cA wral wa vg wex vx cv vy cv cpr vf cv wcel vy wmo vx
      cB wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vf wex vx vy
      cA cB vg brdom7disj.1 brdom7disj.2 brdom5 vx cv vy cv vg cv wbr vy wmo vx
      cB wral vy cv vx cv vg cv wbr vy cB wrex vx cA wral wa vg wex vx cv vy cv
      cpr vf cv wcel vy wmo vx cB wral vy cv vx cv cpr vf cv wcel vy cB wrex vx
      cA wral wa vf wex vx cv vy cv vg cv wbr vy wmo vx cB wral vy cv vx cv vg
      cv wbr vy cB wrex vx cA wral wa vx cv vy cv cpr vf cv wcel vy wmo vx cB
      wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vf wex vg vx cv
      vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB
      wrex vw cA wrex vv cab wcel vy wmo vx cB wral vy cv vx cv cpr vv cv vz cv
      vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab
      wcel vy cB wrex vx cA wral vx cv vy cv cpr vf cv wcel vy wmo vx cB wral
      vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vf wex vx cv vy cv vg
      cv wbr vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB wrex vx cA wral vx
      cv vy cv cpr vf cv wcel vy wmo vx cB wral vy cv vx cv cpr vf cv wcel vy
      cB wrex vx cA wral wa vx cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw
      cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy wmo vx cB wral
      vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa
      vz cB wrex vw cA wrex vv cab wcel vy cB wrex vx cA wral wa vf vv cv vz cv
      vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab
      vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw vv
      cA brdom7disj.1 vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa
      vz vv cB brdom7disj.2 vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv
      wcel wa vv cab vz cv vw cv cpr csn vz cv vw cv cpr snex vv cv vz cv vw cv
      cpr wceq vz cv vw cv cop vg cv wcel wa vv cab vv cv vz cv vw cv cpr wceq
      vv cab vz cv vw cv cpr csn vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg
      cv wcel wa vv cv vz cv vw cv cpr wceq vv vv cv vz cv vw cv cpr wceq vz cv
      vw cv cop vg cv wcel pm3.26 ss2abi vv vz cv vw cv cpr df-sn sseqtr4i
      ssexi abrexex2 abrexex2 vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop
      vg cv wcel wa vz cB wrex vw cA wrex vv cab wceq vx cv vy cv cpr vf cv
      wcel vy wmo vx cB wral vx cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv
      vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy wmo vx cB
      wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral vy cv vx cv cpr vv
      cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA
      wrex vv cab wcel vy cB wrex vx cA wral vf cv vv cv vz cv vw cv cpr wceq
      vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wceq vx cv vy
      cv cpr vf cv wcel vy wmo vx cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv
      vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy wmo vx cB vf
      cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw
      cA wrex vv cab wceq vx cv vy cv cpr vf cv wcel vx cv vy cv cpr vv cv vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv
      cab wcel vy vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel
      wa vz cB wrex vw cA wrex vv cab wceq vy ax-17 vf cv vv cv vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab vx cv vy
      cv cpr eleq2 mobid ralbidv vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv
      cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wceq vy cv vx cv cpr vf cv
      wcel vy cB wrex vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv
      cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy cB wrex vx cA vf
      cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw
      cA wrex vv cab wceq vy cv vx cv cpr vf cv wcel vy cv vx cv cpr vv cv vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv
      cab wcel vy cB vf cv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv
      wcel wa vz cB wrex vw cA wrex vv cab vy cv vx cv cpr eleq2 rexbidv
      ralbidv anbi12d cla4ev vx cv vy cv vg cv wbr vy wmo vx cv vy cv cpr vv cv
      vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex
      vv cab wcel vy wmo vx cB vx cv cB wcel vx cv vy cv cpr vv cv vz cv vw cv
      cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel
      vx cv vy cv vg cv wbr wi vy wal vx cv vy cv vg cv wbr vy wmo vx cv vy cv
      cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex
      vw cA wrex vv cab wcel vy wmo wi vx cv cB wcel vx cv vy cv cpr vv cv vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv
      cab wcel vx cv vy cv vg cv wbr wi vy vx cv cB wcel vx cv vy cv cpr vz cv
      vw cv cpr wceq vz cv vw cv vg cv wbr wa vz cB wrex vw cA wrex vx cv vy cv
      vg cv wbr vx cv vy cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg
      cv wcel wa vz cB wrex vw cA wrex vv cab wcel vx cv cB wcel vx cv vy cv
      cpr vz cv vw cv cpr wceq vz cv vw cv vg cv wbr wa vx cv vy cv vg cv wbr
      vw vz cA cB vx cv cB wcel vw cv cA wcel vx cv vy cv cpr vz cv vw cv cpr
      wceq vz cv vw cv vg cv wbr wa vx cv vy cv vg cv wbr wi vz cv cB wcel vx
      cv cB wcel vw cv cA wcel vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv
      vg cv wbr wa vx cv vy cv vg cv wbr wi vx cv cB wcel vw cv cA wcel wa vx
      cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv vg cv wbr vx cv vy cv vg cv
      wbr vx cv cB wcel vw cv cA wcel wa vx cv vy cv cpr vz cv vw cv cpr wceq
      vx cv vz cv wceq vy cv vw cv wceq wa vz cv vw cv vg cv wbr vx cv vy cv vg
      cv wbr wi vx cv cB wcel vw cv cA wcel wa vx cv vw cv wne vx cv vy cv cpr
      vz cv vw cv cpr wceq vx cv vz cv wceq vy cv vw cv wceq wa wb cB cA cin c0
      wceq vx cv cB wcel vw cv cA wcel vx cv vw cv wne cB cA cin cA cB cin c0
      cB cA incom brdom7disj.3 eqtri cB cA vx cv vw cv disjne mp3an1 vx cv vy
      cv vz cv vw cv vx visset vy visset vz visset vw visset opthpr syl vx cv
      vz cv wceq vy cv vw cv wceq wa vx cv vy cv vg cv wbr vz cv vw cv vg cv
      wbr vx cv vz cv vy cv vw cv vg cv breq12 biimprd syl6bi imp3a ex adantrd
      r19.23advv vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB
      wrex vw cA wrex vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv vg cv
      wbr wa vz cB wrex vw cA wrex vv vx cv vy cv cpr vx vy zfpair2 vv cv vx cv
      vy cv cpr wceq vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa
      vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv vg cv wbr wa vw vz cA cB
      vv cv vx cv vy cv cpr wceq vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg
      cv wcel wa vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv
      wcel wa vx cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv vg cv wbr wa vv
      cv vx cv vy cv cpr wceq vv cv vz cv vw cv cpr wceq vx cv vy cv cpr vz cv
      vw cv cpr wceq vz cv vw cv cop vg cv wcel vv cv vx cv vy cv cpr vz cv vw
      cv cpr eqeq1 anbi1d vz cv vw cv vg cv wbr vz cv vw cv cop vg cv wcel vx
      cv vy cv cpr vz cv vw cv cpr wceq vz cv vw cv vg cv df-br anbi2i syl6bbr
      2rexbidv elab syl5ib 19.21aiv vx cv vy cv cpr vv cv vz cv vw cv cpr wceq
      vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vx cv vy
      cv vg cv wbr vy immo syl r19.20i vy cv vx cv cpr vv cv vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy
      cB wrex vx cA wral vy cv vx cv vg cv wbr vy cB wrex vx cA wral vy cv vx
      cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB
      wrex vw cA wrex vv cab wcel vy cB wrex vy cv vx cv vg cv wbr vy cB wrex
      vx cA vx cv cA wcel vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw
      cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab wcel vy cv vx cv vg cv
      wbr vy cB vx cv cA wcel vy cv cB wcel wa vy cv vx cv cpr vv cv vz cv vw
      cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vv cab
      wcel vw cv vx cv wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB
      wrex vw cA wrex vy cv vx cv vg cv wbr vx cv cA wcel vy cv vx cv cpr vv cv
      vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex
      vv cab wcel vw cv vx cv wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa
      vz cB wrex vw cA wrex wb vy cv cB wcel vx cv cA wcel vy cv vx cv cpr vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vw
      cv vx cv wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB wrex vw
      cA wrex vy cv vx cv cpr vv cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv
      wcel wa vz cB wrex vw cA wrex vv cab wcel vx cv cA wcel vy cv vx cv cpr
      vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cv vx cv
      wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB wrex vw cA vx cv
      cA wcel vy cv vx cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel
      wa vw cv vx cv wceq vz cv vy cv wceq wa vz cv vw cv vg cv wbr wa vz cB vx
      cv cA wcel vz cv cB wcel wa vy cv vx cv cpr vz cv vw cv cpr wceq vw cv vx
      cv wceq vz cv vy cv wceq wa vz cv vw cv cop vg cv wcel vz cv vw cv vg cv
      wbr vx cv cA wcel vz cv cB wcel wa vz cv vw cv cpr vy cv vx cv cpr wceq
      vz cv vy cv wceq vw cv vx cv wceq wa vy cv vx cv cpr vz cv vw cv cpr wceq
      vw cv vx cv wceq vz cv vy cv wceq wa vx cv cA wcel vz cv cB wcel wa vz cv
      vx cv wne vz cv vw cv cpr vy cv vx cv cpr wceq vz cv vy cv wceq vw cv vx
      cv wceq wa wb vz cv cB wcel vx cv cA wcel vz cv vx cv wne cB cA cin c0
      wceq vz cv cB wcel vx cv cA wcel vz cv vx cv wne cB cA cin cA cB cin c0
      cB cA incom brdom7disj.3 eqtri cB cA vz cv vx cv disjne mp3an1 ancoms vz
      cv vw cv vy cv vx cv vz visset vw visset vy visset vx visset opthpr syl
      vy cv vx cv cpr vz cv vw cv cpr eqcom vw cv vx cv wceq vz cv vy cv wceq
      ancom 3bitr4g vz cv vw cv cop vg cv wcel vz cv vw cv vg cv wbr wb vx cv
      cA wcel vz cv cB wcel wa vz cv vw cv vg cv wbr vz cv vw cv cop vg cv wcel
      vz cv vw cv vg cv df-br bicomi a1i anbi12d rexbidva rexbidv vv cv vz cv
      vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex vw cA wrex vy cv
      vx cv cpr vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vz cB wrex
      vw cA wrex vv vy cv vx cv cpr vy vx zfpair2 vv cv vy cv vx cv cpr wceq vv
      cv vz cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vy cv vx cv cpr vz
      cv vw cv cpr wceq vz cv vw cv cop vg cv wcel wa vw vz cA cB vv cv vy cv
      vx cv cpr wceq vv cv vz cv vw cv cpr wceq vy cv vx cv cpr vz cv vw cv cpr
      wceq vz cv vw cv cop vg cv wcel vv cv vy cv vx cv cpr vz cv vw cv cpr
      eqeq1 anbi1d 2rexbidv elab syl5bb adantr vz cv vw cv vg cv wbr vz cv vx
      cv vg cv wbr vy cv vx cv vg cv wbr vw vz vx cv vy cv cA cB vw cv vx cv vz
      cv vg cv breq2 vz cv vy cv vx cv vg cv breq1 ceqsrex2v bitrd rexbidva
      ralbiia biimpri syl2an 19.23aiv vx cv vy cv cpr vf cv wcel vy wmo vx cB
      wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral wa vx cv vy cv vg
      cv wbr vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB wrex vx cA wral wa
      vg wex vf vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy wmo
      vx cB wral vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy cB
      wrex vx cA wral vx cv vy cv vg cv wbr vy wmo vx cB wral vy cv vx cv vg cv
      wbr vy cB wrex vx cA wral wa vg wex vx cv vy cv cpr vf cv wcel vy wmo vx
      cB wral vy cv vx cv cpr vf cv wcel vy cB wrex vx cA wral vx cv vy cv vg
      cv wbr vy wmo vx cB wral vy cv vx cv vg cv wbr vy cB wrex vx cA wral wa
      vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy wmo vx cB wral
      vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy cB wrex vx cA
      wral wa vg vw cv vz cv cpr vf cv wcel vw vz copab vw cv vz cv cpr vf cv
      wcel vw vz copab vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf cv wcel wa
      vz wex vw wex vv cab cvv vw cv vz cv cpr vf cv wcel vw vz vv df-opab vv
      cv vw cv vz cv cop wceq vw cv vz cv cpr vf cv wcel wa vz wex vw vv vf cv
      cuni vf cv vf visset uniex vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf
      cv wcel wa vw cv vf cv cuni wcel vz vw cv vz cv cpr vf cv wcel vw cv vf
      cv cuni wcel vv cv vw cv vz cv cop wceq vw cv vw cv vz cv cpr wcel vw cv
      vz cv cpr vf cv wcel vw cv vf cv cuni wcel vw cv vz cv vw visset prid1 vw
      cv vw cv vz cv cpr vf cv elunii mpan adantl 19.23aiv vv cv vw cv vz cv
      cop wceq vw cv vz cv cpr vf cv wcel wa vz vv vf cv cuni vf cv vf visset
      uniex vw cv vz cv cpr vf cv wcel vz cv vf cv cuni wcel vv cv vw cv vz cv
      cop wceq vz cv vw cv vz cv cpr wcel vw cv vz cv cpr vf cv wcel vz cv vf
      cv cuni wcel vw cv vz cv vz visset prid2 vz cv vw cv vz cv cpr vf cv
      elunii mpan adantl vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf cv wcel
      wa vv cab vv cv vw cv vz cv cop wceq vv cab vw cv vz cv cop csn vv cv vw
      cv vz cv cop wceq vv cab cvv vv vw cv vz cv cop df-sn vw cv vz cv cop
      snex eqeltrri vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf cv wcel wa vv
      cv vw cv vz cv cop wceq vv vv cv vw cv vz cv cop wceq vw cv vz cv cpr vf
      cv wcel pm3.26 ss2abi ssexi abexex abexex eqeltri vg cv vw cv vz cv cpr
      vf cv wcel vw vz copab wceq vx cv vy cv vg cv wbr vy wmo vx cB wral vx cv
      vy cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy wmo vx cB wral vy cv
      vx cv vg cv wbr vy cB wrex vx cA wral vy cv vx cv vw cv vz cv cpr vf cv
      wcel vw vz copab wbr vy cB wrex vx cA wral vg cv vw cv vz cv cpr vf cv
      wcel vw vz copab wceq vx cv vy cv vg cv wbr vy wmo vx cv vy cv vw cv vz
      cv cpr vf cv wcel vw vz copab wbr vy wmo vx cB vg cv vw cv vz cv cpr vf
      cv wcel vw vz copab wceq vx cv vy cv vg cv wbr vx cv vy cv vw cv vz cv
      cpr vf cv wcel vw vz copab wbr vy vg cv vw cv vz cv cpr vf cv wcel vw vz
      copab wceq vy ax-17 vx cv vy cv vg cv vw cv vz cv cpr vf cv wcel vw vz
      copab breq mobid ralbidv vg cv vw cv vz cv cpr vf cv wcel vw vz copab
      wceq vy cv vx cv vg cv wbr vy cB wrex vy cv vx cv vw cv vz cv cpr vf cv
      wcel vw vz copab wbr vy cB wrex vx cA vg cv vw cv vz cv cpr vf cv wcel vw
      vz copab wceq vy cv vx cv vg cv wbr vy cv vx cv vw cv vz cv cpr vf cv
      wcel vw vz copab wbr vy cB vy cv vx cv vg cv vw cv vz cv cpr vf cv wcel
      vw vz copab breq rexbidv ralbidv anbi12d cla4ev vx cv vy cv vw cv vz cv
      cpr vf cv wcel vw vz copab wbr vy wmo vx cv vy cv cpr vf cv wcel vy wmo
      vx cB vx cv vy cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vx cv vy cv
      cpr vf cv wcel vy vw cv vz cv cpr vf cv wcel vx cv vz cv cpr vf cv wcel
      vx cv vy cv cpr vf cv wcel vw vz vx cv vy cv vw cv vz cv cpr vf cv wcel
      vw vz copab vx visset vy visset vw cv vx cv wceq vw cv vz cv cpr vx cv vz
      cv cpr vf cv vw cv vx cv vz cv preq1 eleq1d vz cv vy cv wceq vx cv vz cv
      cpr vx cv vy cv cpr vf cv vz cv vy cv vx cv preq2 eleq1d vw cv vz cv cpr
      vf cv wcel vw vz copab eqid brab mobii ralbii vy cv vx cv vw cv vz cv cpr
      vf cv wcel vw vz copab wbr vy cB wrex vy cv vx cv cpr vf cv wcel vy cB
      wrex vx cA vy cv vx cv vw cv vz cv cpr vf cv wcel vw vz copab wbr vy cv
      vx cv cpr vf cv wcel vy cB vw cv vz cv cpr vf cv wcel vy cv vz cv cpr vf
      cv wcel vy cv vx cv cpr vf cv wcel vw vz vy cv vx cv vw cv vz cv cpr vf
      cv wcel vw vz copab vy visset vx visset vw cv vy cv wceq vw cv vz cv cpr
      vy cv vz cv cpr vf cv vw cv vy cv vz cv preq1 eleq1d vz cv vx cv wceq vy
      cv vz cv cpr vy cv vx cv cpr vf cv vz cv vx cv vy cv preq2 eleq1d vw cv
      vz cv cpr vf cv wcel vw vz copab eqid brab rexbii ralbii syl2anbr
      19.23aiv impbii bitri $.
      $( [5-Apr-2007] $) $( [5-Apr-2007] $)
  $}

  $( An image of a function under a set is dominated by the set.  Proposition
     10.34 of [TakeutiZaring] p. 92. $)
  imadomg $p |- ( A e. B -> ( Fun F -> ( F " A ) ~<_ A ) ) $=
    cA cB wcel cF wfun cF cA cima cF cA cres cdm cdom wbr cF cA cima cA cdom
    wbr cF wfun cA cB wcel cF cA cima cF cA cres cdm cdom wbr cF wfun cA cB
    wcel wa cF cA cres crn cF cA cres cdm cF cA cima cdom cF cA cres cdm cvv
    wcel cF cA cres cdm cF cA cres crn cF cA cres wfo cF cA cres crn cF cA cres
    cdm cdom wbr cF wfun cA cB wcel wa cF cA cres cdm cF cA cres crn cvv cF cA
    cres fodomg cF wfun cA cB wcel wa cF cA cres cvv wcel cF cA cres cdm cvv
    wcel cF cA cB resfunexg cF cA cres cvv dmexg syl cF wfun cF cA cres cdm cF
    cA cres crn cF cA cres wfo cA cB wcel cF wfun cF cA cres wfun cF cA cres
    cdm cF cA cres crn cF cA cres wfo cA cF funres cF cA cres funforn sylib
    adantr sylc cF cA df-ima syl5eqbr expcom cF cA cima cF cA cres cdm cdom wbr
    cA cB wcel cF cA cima cA cdom wbr cF cA cima cF cA cres cdm cdom wbr cF cA
    cres cdm cA cdom wbr cF cA cima cA cdom wbr cA cB wcel cF cA cima cF cA
    cres cdm cA domtr cA cB wcel cF cA cres cdm cA wss cF cA cres cdm cA cdom
    wbr cF cA cres cdm cA cF cdm cin cA cF cA dmres cA cF cdm inss1 eqsstri cF
    cA cres cdm cA cB ssdom2g mpi sylan2 expcom syld $.
    $( [20-Nov-2004] $) $( [23-Jul-2004] $)

  $( The range of a function is dominated by its domain. $)
  fnrndomg $p |- ( A e. B -> ( F Fn A -> ran F ~<_ A ) ) $=
    cA cB wcel cA cF crn cF wfo cF crn cA cdom wbr cF cA wfn cA cF crn cB cF
    fodomg cA cF dffn4 syl5ib $.
    $( [1-Oct-2004] $) $( [1-Sep-2004] $)

  ${
    $d f g h v w x y z A $.  $d f g h v w x y z B $.
    unidom.1 $e |- A e. _V $.
    unidom.2 $e |- B e. _V $.
    $( An upper bound for the cardinality of a union.  Theorem 10.47 of
       [TakeutiZaring] p. 98. $)
    unidom $p |- ( A. x e. A x ~<_ B -> U. A ~<_ ( A X. B ) ) $=
      vx cv cB vx cv vf cv cfv wf1 vx cA wral vf wex vx cv vx cv vh cv cfv wcel
      vx cv vh cv cfv cA wcel wa vx cA cuni wral vh wex cA cuni cA cB cxp cdom
      wbr vx cv cB cdom wbr vx cA wral vx cv cB vx cv vf cv cfv wf1 vx cA wral
      vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vh
      wex cA cuni cA cB cxp cdom wbr wi vf vx cv cB vx cv vf cv cfv wf1 vx cA
      wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni
      wral cA cuni cA cB cxp cdom wbr vh vx cv cB vx cv vf cv cfv wf1 vx cA
      wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni
      wral cA cuni cA cB cxp cdom wbr vx cv cB vx cv vf cv cfv wf1 vx cA wral
      vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral wa
      cA cuni cvv wcel cA cuni cA cB cxp cdom wbr cA unidom.1 uniex vx cv cB vx
      cv vf cv cfv wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA
      wcel wa vx cA cuni wral wa vy vz cA cuni cA cB cxp vy cv vh cv cfv vy cv
      vy cv vh cv cfv vf cv cfv cfv cop vz cv vh cv cfv vz cv vz cv vh cv cfv
      vf cv cfv cfv cop cvv vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv
      vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA
      cuni wcel vy cv vh cv cfv cA wcel vy cv vy cv vh cv cfv vf cv cfv cfv cB
      wcel wa vy cv vh cv cfv vy cv vy cv vh cv cfv vf cv cfv cfv cop cA cB cxp
      wcel vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv vh cv cfv wcel
      vx cv vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA cuni wcel vy cv vh
      cv cfv cA wcel vy cv vy cv vh cv cfv vf cv cfv cfv cB wcel vx cv vx cv vh
      cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vy cv cA cuni wcel
      vy cv vh cv cfv cA wcel wi vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv
      vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vy cv cA
      cuni wcel vy cv vy cv vh cv cfv wcel vy cv vh cv cfv cA wcel wa vy cv vh
      cv cfv cA wcel vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vy
      cv vy cv vh cv cfv wcel vy cv vh cv cfv cA wcel wa vx vy cv cA cuni vx cv
      vy cv wceq vx cv vx cv vh cv cfv wcel vy cv vy cv vh cv cfv wcel vx cv vh
      cv cfv cA wcel vy cv vh cv cfv cA wcel vx cv vy cv wceq vx cv vy cv vx cv
      vh cv cfv vy cv vh cv cfv vx cv vy cv wceq id vx cv vy cv vh cv fveq2
      eleq12d vx cv vy cv wceq vx cv vh cv cfv vy cv vh cv cfv cA vx cv vy cv
      vh cv fveq2 eleq1d anbi12d rcla4cv vy cv vy cv vh cv cfv wcel vy cv vh cv
      cfv cA wcel pm3.27 syl6 adantl vx cv cB vx cv vf cv cfv wf1 vx cA wral vx
      cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vy cv
      cA cuni wcel vy cv vy cv vh cv cfv vf cv cfv cfv cB wcel wi vx cv vx cv
      vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vy cv cA cuni
      wcel vx cv cB vx cv vf cv cfv wf1 vx cA wral vy cv vy cv vh cv cfv vf cv
      cfv cfv cB wcel vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx
      cA cuni wral vy cv cA cuni wcel vy cv vy cv vh cv cfv wcel vy cv vh cv
      cfv cA wcel wa vx cv cB vx cv vf cv cfv wf1 vx cA wral vy cv vy cv vh cv
      cfv vf cv cfv cfv cB wcel wi vx cv vx cv vh cv cfv wcel vx cv vh cv cfv
      cA wcel wa vy cv vy cv vh cv cfv wcel vy cv vh cv cfv cA wcel wa vx vy cv
      cA cuni vx cv vy cv wceq vx cv vx cv vh cv cfv wcel vy cv vy cv vh cv cfv
      wcel vx cv vh cv cfv cA wcel vy cv vh cv cfv cA wcel vx cv vy cv wceq vx
      cv vy cv vx cv vh cv cfv vy cv vh cv cfv vx cv vy cv wceq id vx cv vy cv
      vh cv fveq2 eleq12d vx cv vy cv wceq vx cv vh cv cfv vy cv vh cv cfv cA
      vx cv vy cv vh cv fveq2 eleq1d anbi12d rcla4cv vy cv vh cv cfv cA wcel vx
      cv cB vx cv vf cv cfv wf1 vx cA wral vy cv vh cv cfv cB vy cv vh cv cfv
      vf cv cfv wf vy cv vy cv vh cv cfv wcel vy cv vy cv vh cv cfv vf cv cfv
      cfv cB wcel vy cv vh cv cfv cA wcel vx cv cB vx cv vf cv cfv wf1 vx cA
      wral vy cv vh cv cfv cB vy cv vh cv cfv vf cv cfv wf1 vy cv vh cv cfv cB
      vy cv vh cv cfv vf cv cfv wf vx cv cB vx cv vf cv cfv wf1 vy cv vh cv cfv
      cB vy cv vh cv cfv vf cv cfv wf1 vx vy cv vh cv cfv cA vx cv vy cv vh cv
      cfv wceq vx cv cB vx cv vf cv cfv wf1 vx cv cB vy cv vh cv cfv vf cv cfv
      wf1 vy cv vh cv cfv cB vy cv vh cv cfv vf cv cfv wf1 vx cv vy cv vh cv
      cfv wceq vx cv vf cv cfv vy cv vh cv cfv vf cv cfv wceq vx cv cB vx cv vf
      cv cfv wf1 vx cv cB vy cv vh cv cfv vf cv cfv wf1 wb vx cv vy cv vh cv
      cfv vf cv fveq2 vx cv cB vx cv vf cv cfv vy cv vh cv cfv vf cv cfv f1eq1
      syl vx cv vy cv vh cv cfv cB vy cv vh cv cfv vf cv cfv f1eq2 bitrd rcla4v
      vy cv vh cv cfv cB vy cv vh cv cfv vf cv cfv f1f syl6 vy cv vh cv cfv cB
      vy cv vh cv cfv vf cv cfv wf vy cv vy cv vh cv cfv wcel vy cv vy cv vh cv
      cfv vf cv cfv cfv cB wcel vy cv vh cv cfv cB vy cv vy cv vh cv cfv vf cv
      cfv ffvelrn expcom sylan9r syl6 com3r imp jcad vy cv vh cv cfv vy cv vy
      cv vh cv cfv vf cv cfv cfv cA cB opelxpi syl6 vx cv cB vx cv vf cv cfv
      wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx
      cA cuni wral wa vy cv cA cuni wcel vz cv cA cuni wcel wa vy cv vh cv cfv
      vy cv vy cv vh cv cfv vf cv cfv cfv cop vz cv vh cv cfv vz cv vz cv vh cv
      cfv vf cv cfv cfv cop wceq vy cv vz cv wceq wb vx cv cB vx cv vf cv cfv
      wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx
      cA cuni wral wa vy cv cA cuni wcel vz cv cA cuni wcel wa wa vy cv vh cv
      cfv vy cv vy cv vh cv cfv vf cv cfv cfv cop vz cv vh cv cfv vz cv vz cv
      vh cv cfv vf cv cfv cfv cop wceq vy cv vz cv wceq vx cv cB vx cv vf cv
      cfv wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa
      vx cA cuni wral wa vy cv cA cuni wcel vz cv cA cuni wcel wa wa vy cv vh
      cv cfv vz cv vh cv cfv wceq vy cv vy cv vh cv cfv vf cv cfv cfv vz cv vz
      cv vh cv cfv vf cv cfv cfv wceq wa vy cv vz cv wceq vy cv vh cv cfv vy cv
      vy cv vh cv cfv vf cv cfv cfv cop vz cv vh cv cfv vz cv vz cv vh cv cfv
      vf cv cfv cfv cop wceq vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx
      cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA
      cuni wcel vz cv cA cuni wcel wa wa vy cv vh cv cfv vz cv vh cv cfv wceq
      vy cv vy cv vh cv cfv vf cv cfv cfv vz cv vz cv vh cv cfv vf cv cfv cfv
      wceq vy cv vz cv wceq vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv
      vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA
      cuni wcel vz cv cA cuni wcel wa wa vy cv vh cv cfv vz cv vh cv cfv wceq
      wa vy cv vy cv vh cv cfv vf cv cfv cfv vz cv vz cv vh cv cfv vf cv cfv
      cfv wceq vy cv vy cv vh cv cfv vf cv cfv cfv vz cv vy cv vh cv cfv vf cv
      cfv cfv wceq vy cv vz cv wceq vy cv vh cv cfv vz cv vh cv cfv wceq vy cv
      vy cv vh cv cfv vf cv cfv cfv vz cv vy cv vh cv cfv vf cv cfv cfv wceq vy
      cv vy cv vh cv cfv vf cv cfv cfv vz cv vz cv vh cv cfv vf cv cfv cfv wceq
      wb vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx
      cv vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA cuni wcel vz cv cA
      cuni wcel wa wa vy cv vh cv cfv vz cv vh cv cfv wceq vz cv vy cv vh cv
      cfv vf cv cfv cfv vz cv vz cv vh cv cfv vf cv cfv cfv vy cv vy cv vh cv
      cfv vf cv cfv cfv vy cv vh cv cfv vz cv vh cv cfv wceq vz cv vy cv vh cv
      cfv vf cv cfv vz cv vh cv cfv vf cv cfv vy cv vh cv cfv vz cv vh cv cfv
      vf cv fveq2 fveq1d eqeq2d adantl vy cv vh cv cfv cB vy cv vh cv cfv vf cv
      cfv wf1 vy cv vy cv vh cv cfv wcel vz cv vy cv vh cv cfv wcel wa vy cv vy
      cv vh cv cfv vf cv cfv cfv vz cv vy cv vh cv cfv vf cv cfv cfv wceq vy cv
      vz cv wceq wi vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv vh cv
      cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA cuni wcel
      vz cv cA cuni wcel wa wa vy cv vh cv cfv vz cv vh cv cfv wceq wa vy cv vh
      cv cfv cB vy cv vh cv cfv vf cv cfv wf1 vy cv vy cv vh cv cfv wcel vz cv
      vy cv vh cv cfv wcel wa wa vy cv vy cv vh cv cfv vf cv cfv cfv vz cv vy
      cv vh cv cfv vf cv cfv cfv wceq vy cv vz cv wceq vy cv vh cv cfv cB vy cv
      vz cv vy cv vh cv cfv vf cv cfv f1fveq biimpd vx cv cB vx cv vf cv cfv
      wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx
      cA cuni wral wa vy cv cA cuni wcel vz cv cA cuni wcel wa wa vy cv vh cv
      cfv cB vy cv vh cv cfv vf cv cfv wf1 vy cv vh cv cfv vz cv vh cv cfv wceq
      vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv
      vh cv cfv cA wcel wa vx cA cuni wral wa vy cv cA cuni wcel vy cv vh cv
      cfv cB vy cv vh cv cfv vf cv cfv wf1 vz cv cA cuni wcel vx cv cB vx cv vf
      cv cfv wf1 vx cA wral vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel
      wa vx cA cuni wral vy cv cA cuni wcel vy cv vh cv cfv cB vy cv vh cv cfv
      vf cv cfv wf1 vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA
      cuni wral vy cv cA cuni wcel vx cv cB vx cv vf cv cfv wf1 vx cA wral vy
      cv vh cv cfv cB vy cv vh cv cfv vf cv cfv wf1 vx cv vx cv vh cv cfv wcel
      vx cv vh cv cfv cA wcel wa vx cA cuni wral vy cv cA cuni wcel vy cv vy cv
      vh cv cfv wcel vy cv vh cv cfv cA wcel wa vx cv cB vx cv vf cv cfv wf1 vx
      cA wral vy cv vh cv cfv cB vy cv vh cv cfv vf cv cfv wf1 wi vx cv vx cv
      vh cv cfv wcel vx cv vh cv cfv cA wcel wa vy cv vy cv vh cv cfv wcel vy
      cv vh cv cfv cA wcel wa vx vy cv cA cuni vx cv vy cv wceq vx cv vx cv vh
      cv cfv wcel vy cv vy cv vh cv cfv wcel vx cv vh cv cfv cA wcel vy cv vh
      cv cfv cA wcel vx cv vy cv wceq vx cv vy cv vx cv vh cv cfv vy cv vh cv
      cfv vx cv vy cv wceq id vx cv vy cv vh cv fveq2 eleq12d vx cv vy cv wceq
      vx cv vh cv cfv vy cv vh cv cfv cA vx cv vy cv vh cv fveq2 eleq1d anbi12d
      rcla4cv vy cv vh cv cfv cA wcel vx cv cB vx cv vf cv cfv wf1 vx cA wral
      vy cv vh cv cfv cB vy cv vh cv cfv vf cv cfv wf1 wi vy cv vy cv vh cv cfv
      wcel vx cv cB vx cv vf cv cfv wf1 vy cv vh cv cfv cB vy cv vh cv cfv vf
      cv cfv wf1 vx vy cv vh cv cfv cA vx cv vy cv vh cv cfv wceq vx cv cB vx
      cv vf cv cfv wf1 vx cv cB vy cv vh cv cfv vf cv cfv wf1 vy cv vh cv cfv
      cB vy cv vh cv cfv vf cv cfv wf1 vx cv vy cv vh cv cfv wceq vx cv vf cv
      cfv vy cv vh cv cfv vf cv cfv wceq vx cv cB vx cv vf cv cfv wf1 vx cv cB
      vy cv vh cv cfv vf cv cfv wf1 wb vx cv vy cv vh cv cfv vf cv fveq2 vx cv
      cB vx cv vf cv cfv vy cv vh cv cfv vf cv cfv f1eq1 syl vx cv vy cv vh cv
      cfv cB vy cv vh cv cfv vf cv cfv f1eq2 bitrd rcla4v adantl syl6 com3r
      imp31 adantrr adantr vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel
      wa vx cA cuni wral vy cv cA cuni wcel vz cv cA cuni wcel wa vy cv vh cv
      cfv vz cv vh cv cfv wceq vy cv vy cv vh cv cfv wcel vz cv vy cv vh cv cfv
      wcel wa vx cv cB vx cv vf cv cfv wf1 vx cA wral vx cv vx cv vh cv cfv
      wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vy cv vh cv cfv vz cv vh
      cv cfv wceq vy cv cA cuni wcel vz cv cA cuni wcel wa vy cv vy cv vh cv
      cfv wcel vz cv vy cv vh cv cfv wcel wa vx cv vx cv vh cv cfv wcel vx cv
      vh cv cfv cA wcel wa vx cA cuni wral vy cv vh cv cfv vz cv vh cv cfv wceq
      wa vy cv cA cuni wcel vz cv cA cuni wcel wa vy cv vy cv vh cv cfv wcel vz
      cv vy cv vh cv cfv wcel wa vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA
      wcel wa vx cA cuni wral vy cv vh cv cfv vz cv vh cv cfv wceq wa vy cv cA
      cuni wcel vy cv vy cv vh cv cfv wcel vz cv cA cuni wcel vz cv vy cv vh cv
      cfv wcel vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni
      wral vy cv cA cuni wcel vy cv vy cv vh cv cfv wcel wi vy cv vh cv cfv vz
      cv vh cv cfv wceq vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa
      vx cA cuni wral vy cv cA cuni wcel vy cv vy cv vh cv cfv wcel vy cv vh cv
      cfv cA wcel wa vy cv vy cv vh cv cfv wcel vx cv vx cv vh cv cfv wcel vx
      cv vh cv cfv cA wcel wa vy cv vy cv vh cv cfv wcel vy cv vh cv cfv cA
      wcel wa vx vy cv cA cuni vx cv vy cv wceq vx cv vx cv vh cv cfv wcel vy
      cv vy cv vh cv cfv wcel vx cv vh cv cfv cA wcel vy cv vh cv cfv cA wcel
      vx cv vy cv wceq vx cv vy cv vx cv vh cv cfv vy cv vh cv cfv vx cv vy cv
      wceq id vx cv vy cv vh cv fveq2 eleq12d vx cv vy cv wceq vx cv vh cv cfv
      vy cv vh cv cfv cA vx cv vy cv vh cv fveq2 eleq1d anbi12d rcla4cv vy cv
      vy cv vh cv cfv wcel vy cv vh cv cfv cA wcel pm3.26 syl6 adantr vx cv vx
      cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx cA cuni wral vz cv cA
      cuni wcel vz cv vz cv vh cv cfv wcel vy cv vh cv cfv vz cv vh cv cfv wceq
      vz cv vy cv vh cv cfv wcel vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA
      wcel wa vx cA cuni wral vz cv cA cuni wcel vz cv vz cv vh cv cfv wcel vz
      cv vh cv cfv cA wcel wa vz cv vz cv vh cv cfv wcel vx cv vx cv vh cv cfv
      wcel vx cv vh cv cfv cA wcel wa vz cv vz cv vh cv cfv wcel vz cv vh cv
      cfv cA wcel wa vx vz cv cA cuni vx cv vz cv wceq vx cv vx cv vh cv cfv
      wcel vz cv vz cv vh cv cfv wcel vx cv vh cv cfv cA wcel vz cv vh cv cfv
      cA wcel vx cv vz cv wceq vx cv vz cv vx cv vh cv cfv vz cv vh cv cfv vx
      cv vz cv wceq id vx cv vz cv vh cv fveq2 eleq12d vx cv vz cv wceq vx cv
      vh cv cfv vz cv vh cv cfv cA vx cv vz cv vh cv fveq2 eleq1d anbi12d
      rcla4cv vz cv vz cv vh cv cfv wcel vz cv vh cv cfv cA wcel pm3.26 syl6 vy
      cv vh cv cfv vz cv vh cv cfv wceq vz cv vy cv vh cv cfv wcel vz cv vz cv
      vh cv cfv wcel vy cv vh cv cfv vz cv vh cv cfv vz cv eleq2 biimprd sylan9
      anim12d imp an1rs adantlll sylanc sylbird expimpd vy cv vh cv cfv vy cv
      vy cv vh cv cfv vf cv cfv cfv vz cv vh cv cfv vz cv vz cv vh cv cfv vf cv
      cfv cfv vy cv vh cv fvex vy cv vy cv vh cv cfv vf cv cfv fvex vz cv vz cv
      vh cv cfv vf cv cfv fvex opth syl5ib vy cv vz cv wceq vy cv vh cv cfv vz
      cv vh cv cfv vy cv vy cv vh cv cfv vf cv cfv cfv vz cv vz cv vh cv cfv vf
      cv cfv cfv vy cv vz cv vh cv fveq2 vy cv vz cv wceq vy cv vy cv vh cv cfv
      vf cv cfv cfv vy cv vz cv vh cv cfv vf cv cfv cfv vz cv vz cv vh cv cfv
      vf cv cfv cfv vy cv vz cv wceq vy cv vy cv vh cv cfv vf cv cfv vz cv vh
      cv cfv vf cv cfv vy cv vz cv wceq vy cv vh cv cfv vz cv vh cv cfv vf cv
      vy cv vz cv vh cv fveq2 fveq2d fveq1d vy cv vz cv vz cv vh cv cfv vf cv
      cfv fveq2 eqtrd opeq12d impbid1 ex dom2d mpi ex 19.23adv 19.23aiv vx cv
      cB cdom wbr vx cA wral vx cv cB vg cv wf1 vg wex vx cA wral vx cv cB vx
      cv vf cv cfv wf1 vx cA wral vf wex vx cv cB cdom wbr vx cv cB vg cv wf1
      vg wex vx cA vx cv cB vg unidom.2 brdom ralbii vx cv cB vg cv wf1 vx cv
      cB vx cv vf cv cfv wf1 vx vg cA vf unidom.1 vx cv cB vg cv vx cv vf cv
      cfv f1eq1 ac6s3 sylbi vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel
      wa vx cA cuni wral vh wex vx cv cB cdom wbr vx cA wral vx cv vg cv wcel
      vg cv cA wcel wa vg wex vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA
      wcel wa vx cA cuni wral vh wex vx cA cuni vx cv vg cv wcel vg cv cA wcel
      wa vx cv vx cv vh cv cfv wcel vx cv vh cv cfv cA wcel wa vx vg cA cuni vh
      cA unidom.1 uniex vg cv vx cv vh cv cfv wceq vx cv vg cv wcel vx cv vx cv
      vh cv cfv wcel vg cv cA wcel vx cv vh cv cfv cA wcel vg cv vx cv vh cv
      cfv vx cv eleq2 vg cv vx cv vh cv cfv cA eleq1 anbi12d ac6s3 vx cv cA
      cuni wcel vx cv vg cv wcel vg cv cA wcel wa vg wex vg vx cv cA eluni
      biimpi mprg a1i sylc $.
      $( [27-Mar-2006] $) $( [25-Mar-2006] $)
  $}

  ${
    $d x y z A $.  $d x z B $.
    $( An upper bound for the cardinality of a union.  Theorem 10.47 of
       [TakeutiZaring] p. 98. $)
    unidomg $p |- ( ( A e. C /\ B e. D /\ A. x e. A x ~<_ B ) ->
                   U. A ~<_ ( A X. B ) ) $=
      cA cC wcel cB cD wcel vx cv cB cdom wbr vx cA wral cA cuni cA cB cxp cdom
      wbr vx cv vz cv cdom wbr vx vy cv wral vy cv cuni vy cv vz cv cxp cdom
      wbr wi vx cv vz cv cdom wbr vx cA wral cA cuni cA vz cv cxp cdom wbr wi
      vx cv cB cdom wbr vx cA wral cA cuni cA cB cxp cdom wbr wi vy vz cA cB cC
      cD vy cv cA wceq vx cv vz cv cdom wbr vx vy cv wral vx cv vz cv cdom wbr
      vx cA wral vy cv cuni vy cv vz cv cxp cdom wbr cA cuni cA vz cv cxp cdom
      wbr vx cv vz cv cdom wbr vx vy cv cA raleq1 vy cv cA wceq vy cv cuni cA
      cuni vy cv vz cv cxp cA vz cv cxp cdom vy cv cA unieq vy cv cA vz cv
      xpeq1 breq12d imbi12d vz cv cB wceq vx cv vz cv cdom wbr vx cA wral vx cv
      cB cdom wbr vx cA wral cA cuni cA vz cv cxp cdom wbr cA cuni cA cB cxp
      cdom wbr vz cv cB wceq vx cv vz cv cdom wbr vx cv cB cdom wbr vx cA vz cv
      cB vx cv cdom breq2 ralbidv vz cv cB wceq cA vz cv cxp cA cB cxp cA cuni
      cdom vz cv cB cA xpeq2 breq2d imbi12d vx vy cv vz cv vy visset vz visset
      unidom vtocl2g 3impia $.
      $( [29-Mar-2006] $) $( [25-Mar-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    uniimadom.1 $e |- A e. _V $.
    uniimadom.2 $e |- B e. _V $.
    $( An upper bound for the cardinality of the union of an image.
       Theorem 10.48 of [TakeutiZaring] p. 99. $)
    uniimadom $p |- ( ( Fun F /\ A. x e. A ( F ` x ) ~<_ B ) ->
                 U. ( F " A ) ~<_ ( A X. B ) ) $=
      cF cA cima cuni cF cA cima cB cxp cdom wbr cF cA cima cB cxp cA cB cxp
      cdom wbr cF cA cima cuni cA cB cxp cdom wbr cF wfun vx cv cF cfv cB cdom
      wbr vx cA wral wa cF cA cima cuni cF cA cima cB cxp cA cB cxp domtr cF cA
      cima cvv wcel vy cv cB cdom wbr vy cF cA cima wral cF cA cima cuni cF cA
      cima cB cxp cdom wbr cF wfun vx cv cF cfv cB cdom wbr vx cA wral wa cF cA
      cima cvv wcel cB cvv wcel vy cv cB cdom wbr vy cF cA cima wral cF cA cima
      cuni cF cA cima cB cxp cdom wbr uniimadom.2 vy cF cA cima cB cvv cvv
      unidomg mp3an2 cF wfun cF cA cima cvv wcel vx cv cF cfv cB cdom wbr vx cA
      wral cF cA uniimadom.1 funimaex adantr cF wfun vx cv cF cfv cB cdom wbr
      vx cA wral wa vy cv cB cdom wbr vy cF cA cima cF wfun vx cv cF cfv cB
      cdom wbr vx cA wral vy cv cF cA cima wcel vy cv cB cdom wbr wi cF wfun vy
      cv cF cA cima wcel vx cv cF cfv cB cdom wbr vx cA wral vy cv cB cdom wbr
      cF wfun vy cv cF cA cima wcel vx cv cF cfv vy cv wceq vx cA wrex vx cv cF
      cfv cB cdom wbr vx cA wral vy cv cB cdom wbr wi cF wfun vy cv cF cA cima
      wcel vx cv cF cfv vy cv wceq vx cA wrex vx vy cv cA cF fvelima ex vx cv
      cF cfv vy cv wceq vx cA wrex vx cv cF cfv cB cdom wbr vy cv cB cdom wbr
      wi vx cA wrex vx cv cF cfv cB cdom wbr vx cA wral vy cv cB cdom wbr wi vx
      cv cF cfv vy cv wceq vx cv cF cfv cB cdom wbr vy cv cB cdom wbr wi vx cA
      vx cv cF cfv vy cv wceq vx cv cF cfv cB cdom wbr vy cv cB cdom wbr vx cv
      cF cfv vy cv cB cdom breq1 biimpd r19.22si vx cv cF cfv cB cdom wbr vy cv
      cB cdom wbr vx cA r19.36av syl syl6 com23 imp r19.21aiv sylanc cF wfun cF
      cA cima cB cxp cA cB cxp cdom wbr vx cv cF cfv cB cdom wbr vx cA wral cF
      wfun cF cA cima cA cdom wbr cF cA cima cB cxp cA cB cxp cdom wbr cA cvv
      wcel cF wfun cF cA cima cA cdom wbr wi uniimadom.1 cA cvv cF imadomg
      ax-mp cF cA cima cA cB uniimadom.1 uniimadom.2 xpdom1 syl adantr sylanc
      $.
      $( [30-Mar-2006] $) $( [25-Mar-2006] $)
  $}

  ${
    $d x z A $.  $d x y z B $.  $d y z F $.
    uniimadomf.1 $e |- ( y e. F -> A. x y e. F ) $.
    uniimadomf.2 $e |- A e. _V $.
    uniimadomf.3 $e |- B e. _V $.
    $( An upper bound for the cardinality of the union of an image.
       Theorem 10.48 of [TakeutiZaring] p. 99.  This version of ~ uniimadom
       uses a bound-variable hypothesis in place of a distinct variable
       condition. $)
    uniimadomf $p |- ( ( Fun F /\ A. x e. A ( F ` x ) ~<_ B ) ->
                 U. ( F " A ) ~<_ ( A X. B ) ) $=
      cF wfun vz cv cF cfv cB cdom wbr vz cA wral cF cA cima cuni cA cB cxp
      cdom wbr vx cv cF cfv cB cdom wbr vx cA wral vz cA cB cF uniimadomf.2
      uniimadomf.3 uniimadom vx cv cF cfv cB cdom wbr vz cv cF cfv cB cdom wbr
      vx vz cA vx cv cF cfv cB cdom wbr vz ax-17 vx vy vz cv cF cfv cB cdom vx
      vy vz cv cF uniimadomf.1 vy cv vz cv wcel vx ax-17 hbfv vy cv cdom wcel
      vx ax-17 vy cv cB wcel vx ax-17 hbbr vx cv vz cv wceq vx cv cF cfv vz cv
      cF cfv cB cdom vx cv vz cv cF fveq2 breq1d cbvral sylan2b $.
      $( [3-Apr-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x y z A $.  $d x z B $.  $d y z C $.
    iundom.1 $e |- A e. _V $.
    iundom.2 $e |- B e. _V $.
    iundom.3 $e |- C e. _V $.
    $( An upper bound for the cardinality of an indexed union.  ` C ` depends
       on ` x ` and should be thought of as ` C ( x ) ` . $)
    iundom $p |- ( A. x e. A C ~<_ B -> U_ x e. A C ~<_ ( A X. B ) ) $=
      cC cB cdom wbr vx cA wral vx cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab cfv cB cdom wbr vx cA wral vx cA cC ciun cA cB cxp cdom wbr vx cv
      vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cB cdom wbr cC cB cdom wbr
      vx cA vx cv cA wcel vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv
      cC cB cdom vx cv cA wcel cC cvv wcel vx cv vx cv cA wcel vy cv cC wceq wa
      vx vy copab cfv cC wceq iundom.3 vx vy cA cC cvv fvopab2 mpan2 breq1d
      ralbiia vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cB cdom wbr
      vx cA wral vx cv cA wcel vy cv cC wceq wa vx vy copab cA cima cuni cA cB
      cxp vx cA cC ciun cdom vx cv cA wcel vy cv cC wceq wa vx vy copab wfun vx
      cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cB cdom wbr vx cA wral
      vx cv cA wcel vy cv cC wceq wa vx vy copab cA cima cuni cA cB cxp cdom
      wbr vx cv cA wcel vy cv cC wceq wa vx vy copab cA wfn vx cv cA wcel vy cv
      cC wceq wa vx vy copab wfun vx vy cA cC vx cv cA wcel vy cv cC wceq wa vx
      vy copab iundom.3 vx cv cA wcel vy cv cC wceq wa vx vy copab eqid fnopab2
      cA vx cv cA wcel vy cv cC wceq wa vx vy copab fnfun ax-mp vx vz cA cB vx
      cv cA wcel vy cv cC wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx
      vy vz hbopab1 iundom.1 iundom.2 uniimadomf mpan vx cA vx cv vx cv cA wcel
      vy cv cC wceq wa vx vy copab cfv ciun vx cA cC ciun vx cv cA wcel vy cv
      cC wceq wa vx vy copab cA cima cuni vx cA vx cv vx cv cA wcel vy cv cC
      wceq wa vx vy copab cfv cC vx cv cA wcel cC cvv wcel vx cv vx cv cA wcel
      vy cv cC wceq wa vx vy copab cfv cC wceq iundom.3 vx vy cA cC cvv fvopab2
      mpan2 iuneq2i vx cv cA wcel vy cv cC wceq wa vx vy copab wfun vx cA vx cv
      vx cv cA wcel vy cv cC wceq wa vx vy copab cfv ciun vx cv cA wcel vy cv
      cC wceq wa vx vy copab cA cima cuni wceq vx cv cA wcel vy cv cC wceq wa
      vx vy copab cA wfn vx cv cA wcel vy cv cC wceq wa vx vy copab wfun vx vy
      cA cC vx cv cA wcel vy cv cC wceq wa vx vy copab iundom.3 vx cv cA wcel
      vy cv cC wceq wa vx vy copab eqid fnopab2 cA vx cv cA wcel vy cv cC wceq
      wa vx vy copab fnfun ax-mp vx vz cA vx cv cA wcel vy cv cC wceq wa vx vy
      copab vx cv cA wcel vy cv cC wceq wa vx vy vz hbopab1 funiunfvf ax-mp
      eqtr3i syl5eqbr sylbir $.
      $( [5-Apr-2006] $) $( [26-Mar-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cardinal numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c card $. $( Cardinal size function $)
  $c aleph $. $( Aleph function $)
  $c cf $. $( Cofinality function $)

  $( Extend class definition to include the cardinal size function. $)
  ccrd $a class card $.

  $( Extend class definition to include the aleph function. $)
  cale $a class aleph $.

  $( Extend class definition to include the cofinality function. $)
  ccf $a class cf $.

  ${
    $d x y z $.
    $( Define the cardinal number function.  The cardinal number of a set is
       the least ordinal number equinumerous to it.  In other words, it is the
       "size" of the set.  Definition of [Enderton] p. 197.  See ~ cardval for
       its value, ~ cardval2 for a simpler version of its value.  The principle
       theorem relating cardinality to equinumerosity is ~ carden .  Our
       notation is from Enderton.  Other textbooks often use a double bar over
       the set to express this function. $)
    df-card $a |- card = { <. x , y >. | y = |^| { z e. On | z ~~ x } } $.
  $}

  ${
    $d x y z $.
    $( Define the aleph function.  Our definition expresses Definition 12 of
       [Suppes] p. 229 in a closed form, from which we derive the recursive
       definition as theorems ~ aleph0 , ~ alephsuc , and ~ alephlim .
       The aleph function provides a one-to-one, onto mapping from the ordinal
       numbers to the infinite cardinal numbers.  Roughly, any aleph is the
       smallest infinite cardinal number whose size is strictly greater than
       any aleph before it. $)
    df-aleph $a |- aleph = rec ( { <. x , y >. | y = |^| { z e. On |
                   x ~< z } } , om ) $.
  $}

  ${
    $d x y z w v u $.
    $( Define the cofinality function.  Definition B of Saharon Shelah,
       _Cardinal Arithmetic_ (1994), p. xxx (Roman numeral 30).  See ~ cfval
       for its value and a description. $)
    df-cf $a |- cf = { <. x , y >. | ( x e. On /\
                y = |^| { z | E. w ( z = ( card ` w ) /\
                ( w C_ x /\ A. v e. x E. u e. w v C_ u ) ) } ) } $.
  $}

  ${
    $d x y z A $.
    $( The value of the cardinal number function with an ordinal number as its
       argument.  Unlike ~ cardval , this theorem does not require the Axiom of
       Choice. $)
    oncardval $p |- ( A e. On -> ( card ` A ) = |^| { x e. On | x ~~ A } ) $=
      cA con0 wcel cA vz cv vx cv vy cv cen wbr vx con0 crab cint wceq vy vz
      copab cfv vx cv cA cen wbr vx con0 crab cint cA ccrd cfv cA con0 wcel vx
      cv cA cen wbr vx con0 crab cint con0 wcel cA vz cv vx cv vy cv cen wbr vx
      con0 crab cint wceq vy vz copab cfv vx cv cA cen wbr vx con0 crab cint
      wceq vx cv cA cen wbr vx con0 crab con0 wss vx cv cA cen wbr vx con0 crab
      c0 wne vx cv cA cen wbr vx con0 crab cint con0 wcel cA con0 wcel vx cv cA
      cen wbr vx con0 crab oninton vx cv cA cen wbr vx con0 ssrab2 cA con0 wcel
      vx cv cA cen wbr vx con0 wrex vx cv cA cen wbr vx con0 crab c0 wne cA
      con0 wcel cA cA cen wbr vx cv cA cen wbr vx con0 wrex cA con0 enrefg vx
      cv cA cen wbr cA cA cen wbr vx cA con0 vx cv cA cA cen breq1 rcla4ev
      mpdan vx cv cA cen wbr vx con0 rabn0 sylibr sylancr vy vz cA vx cv vy cv
      cen wbr vx con0 crab cint vx cv cA cen wbr vx con0 crab cint con0 con0 vy
      cv cA wceq vx cv vy cv cen wbr vx con0 crab vx cv cA cen wbr vx con0 crab
      vy cv cA wceq vx cv vy cv cen wbr vx cv cA cen wbr vx con0 vy cv cA vx cv
      cen breq2 rabbisdv inteqd fvopabg mpdan cA ccrd vz cv vx cv vy cv cen wbr
      vx con0 crab cint wceq vy vz copab vy vz vx df-card fveq1i syl5eq $.
      $( [24-Nov-2003] $) $( [24-Nov-2003] $)

    $( The cardinal number of an ordinal number is an ordinal number.  Unlike
       ~ cardon , this theorem does not require the Axiom of Choice. $)
    oncardon $p |- ( A e. On -> ( card ` A ) e. On ) $=
      cA con0 wcel cA ccrd cfv vx cv cA cen wbr vx con0 crab cint con0 vx cA
      oncardval vx cv cA cen wbr vx con0 crab con0 wss vx cv cA cen wbr vx con0
      crab c0 wne vx cv cA cen wbr vx con0 crab cint con0 wcel cA con0 wcel vx
      cv cA cen wbr vx con0 crab oninton vx cv cA cen wbr vx con0 ssrab2 cA
      con0 wcel vx cv cA cen wbr vx con0 crab cint cvv wcel vx cv cA cen wbr vx
      con0 crab c0 wne cA con0 wcel vx cv cA cen wbr vx con0 crab cint cA ccrd
      cfv cvv vx cA oncardval cA ccrd fvex syl6eqelr vx cv cA cen wbr vx con0
      crab intex sylibr sylancr eqeltrd $.
      $( [28-Jul-2004] $) $( [26-Jul-2004] $)

    $( Any ordinal number is equinumerous to its cardinal number.  Unlike
       ~ cardid , this theorem does not require the Axiom of Choice. $)
    oncardid $p |- ( A e. On -> ( card ` A ) ~~ A ) $=
      cA con0 wcel cA ccrd cfv vx cv cA cen wbr vx con0 crab wcel cA ccrd cfv
      cA cen wbr cA con0 wcel cA ccrd cfv vx cv cA cen wbr vx con0 crab cint vx
      cv cA cen wbr vx con0 crab vx cA oncardval vx cv cA cen wbr vx con0 crab
      con0 wss vx cv cA cen wbr vx con0 crab c0 wne vx cv cA cen wbr vx con0
      crab cint vx cv cA cen wbr vx con0 crab wcel cA con0 wcel vx cv cA cen
      wbr vx con0 crab onint vx cv cA cen wbr vx con0 ssrab2 cA con0 wcel vx cv
      cA cen wbr vx con0 crab cint cvv wcel vx cv cA cen wbr vx con0 crab c0
      wne cA con0 wcel vx cv cA cen wbr vx con0 crab cint cA ccrd cfv cvv vx cA
      oncardval cA ccrd fvex syl6eqelr vx cv cA cen wbr vx con0 crab intex
      sylibr sylancr eqeltrd cA ccrd cfv vx cv cA cen wbr vx con0 crab wcel cA
      ccrd cfv con0 wcel cA ccrd cfv cA cen wbr vx cv cA cen wbr cA ccrd cfv cA
      cen wbr vx cA ccrd cfv con0 vx cv cA ccrd cfv cA cen breq1 elrab pm3.27bi
      syl $.
      $( [28-Jul-2004] $) $( [26-Jul-2004] $)

    $( The cardinal of an ordinal number is less than or equal to the
       ordinal number.  Proposition 10.6(3) of [TakeutiZaring] p. 85. $)
    cardonle $p |- ( A e. On -> ( card ` A ) C_ A ) $=
      cA con0 wcel cA ccrd cfv vx cv cA cen wbr vx con0 crab cint cA vx cA
      oncardval cA con0 wcel cA cA cen wbr vx cv cA cen wbr vx con0 crab cint
      cA wss cA con0 enrefg cA con0 wcel cA cA cen wbr wa cA vx cv cA cen wbr
      vx con0 crab wcel vx cv cA cen wbr vx con0 crab cint cA wss vx cv cA cen
      wbr cA cA cen wbr vx cA con0 vx cv cA cA cen breq1 elrab cA vx cv cA cen
      wbr vx con0 crab intss1 sylbir mpdan eqsstrd $.
      $( [25-Nov-2003] $) $( [22-Oct-2003] $)
  $}

  $( The cardinality of the empty set is the empty set. $)
  card0 $p |- ( card ` (/) ) = (/) $=
    c0 ccrd cfv c0 wss c0 ccrd cfv c0 wceq c0 con0 wcel c0 ccrd cfv c0 wss
    0elon c0 cardonle ax-mp c0 ccrd cfv ss0b mpbi $.
    $( [25-Nov-2003] $) $( [25-Oct-2003] $)

  $( The cardinality of a natural number is the number.  Corollary 10.23 of
     [TakeutiZaring] p. 90. $)
  cardnn $p |- ( A e. om -> ( card ` A ) = A ) $=
    cA com wcel cA ccrd cfv cA wcel wn cA ccrd cfv cA wceq cA com wcel cA ccrd
    cfv cA wcel cA ccrd cfv cA csdm wbr cA ccrd cfv cA csdm wbr cA ccrd cfv cA
    cen wbr cA com wcel cA ccrd cfv cA sdomnen cA com wcel cA con0 wcel cA ccrd
    cfv cA cen wbr cA nnon cA oncardid syl nsyl3 cA com wcel cA ccrd cfv cA
    wcel cA ccrd cfv cA wpss cA ccrd cfv cA csdm wbr cA com wcel cA con0 wcel
    cA ccrd cfv cA wcel cA ccrd cfv cA wpss wb cA nnon cA ccrd cfv con0 wcel cA
    con0 wcel cA ccrd cfv cA wcel cA ccrd cfv cA wpss wb cA oncardon cA ccrd
    cfv word cA word cA ccrd cfv cA wcel cA ccrd cfv cA wpss wb cA ccrd cfv
    con0 wcel cA con0 wcel cA ccrd cfv cA ordelpss cA ccrd cfv eloni cA eloni
    syl2an mpancom syl cA ccrd cfv com wcel cA com wcel cA ccrd cfv cA csdm wbr
    cA ccrd cfv cA wpss wb cA com wcel cA ccrd cfv cA wcel cA ccrd cfv cA wceq
    wo cA ccrd cfv com wcel cA com wcel cA con0 wcel cA ccrd cfv cA wcel cA
    ccrd cfv cA wceq wo cA nnon cA con0 wcel cA ccrd cfv cA wss cA ccrd cfv cA
    wcel cA ccrd cfv cA wceq wo cA cardonle cA ccrd cfv con0 wcel cA con0 wcel
    cA ccrd cfv cA wss cA ccrd cfv cA wcel cA ccrd cfv cA wceq wo wb cA
    oncardon cA ccrd cfv cA onsseleq mpancom mpbid syl cA com wcel cA ccrd cfv
    cA wcel cA ccrd cfv com wcel cA ccrd cfv cA wceq cA ccrd cfv cA wcel cA com
    wcel cA ccrd cfv com wcel cA ccrd cfv cA elnn expcom cA com cA ccrd cfv
    eleq1a jaod mpd cA ccrd cfv cA nnsdomo mpancom bitr4d mtbird cA com wcel cA
    ccrd cfv cA wcel cA ccrd cfv cA wceq cA com wcel cA con0 wcel cA ccrd cfv
    cA wcel cA ccrd cfv cA wceq wo cA nnon cA con0 wcel cA ccrd cfv cA wss cA
    ccrd cfv cA wcel cA ccrd cfv cA wceq wo cA cardonle cA ccrd cfv con0 wcel
    cA con0 wcel cA ccrd cfv cA wss cA ccrd cfv cA wcel cA ccrd cfv cA wceq wo
    wb cA oncardon cA ccrd cfv cA onsseleq mpancom mpbid syl ord mpd $.
    $( [10-Jul-2004] $) $( [28-Oct-2003] $)

  $( The cardinality of the successor of a finite ordinal (natural number).
     This theorem does not hold for infinite ordinals; see ~ cardsucinf . $)
  cardsucnn $p |- ( A e. om -> ( card ` suc A ) = suc ( card ` A ) ) $=
    cA com wcel cA csuc ccrd cfv cA csuc cA ccrd cfv csuc cA com wcel cA csuc
    com wcel cA csuc ccrd cfv cA csuc wceq cA peano2 cA csuc cardnn syl cA com
    wcel cA ccrd cfv cA wceq cA ccrd cfv csuc cA csuc wceq cA cardnn cA ccrd
    cfv cA suceq syl eqtr4d $.
    $( [15-Nov-2008] $) $( [7-Nov-2008] $)

  $( The set of natural numbers is a cardinal number.  Theorem 18.11 of [Monk1]
     p. 133. $)
  cardom $p |- ( card ` om ) = om $=
    com ccrd cfv com wcel wn com ccrd cfv com wceq com ccrd cfv com wcel com
    ccrd cfv com cen wbr com con0 wcel com ccrd cfv com cen wbr omelon com
    oncardid ax-mp com ccrd cfv com wcel com ccrd cfv com csdm wbr com ccrd cfv
    com cen wbr wn com ccrd cfv nnsdom com ccrd cfv com sdomnen syl mt2 com
    ccrd cfv com wcel com ccrd cfv com wceq com ccrd cfv com wss com ccrd cfv
    com wcel com ccrd cfv com wceq wo com con0 wcel com ccrd cfv com wss omelon
    com cardonle ax-mp com ccrd cfv com com con0 wcel com ccrd cfv con0 wcel
    omelon com oncardon ax-mp omelon onsseli mpbi ori ax-mp $.
    $( [9-Dec-2003] $) $( [28-Oct-2003] $)

  ${
    $d x y z A $.
    $( The value of the cardinal number function.  Definition 10.4 of
       [TakeutiZaring] p. 85.  See ~ cardval2 for a simpler version of its
       value. $)
    cardval $p |- ( card ` A ) = |^| { x e. On | x ~~ A } $=
      cA cvv wcel cA ccrd cfv vx cv cA cen wbr vx con0 crab cint wceq cA cvv
      wcel cA vz cv vx cv vy cv cen wbr vx con0 crab cint wceq vy vz copab cfv
      vx cv cA cen wbr vx con0 crab cint cA ccrd cfv cA cvv wcel vx cv cA cen
      wbr vx con0 crab cint cvv wcel cA vz cv vx cv vy cv cen wbr vx con0 crab
      cint wceq vy vz copab cfv vx cv cA cen wbr vx con0 crab cint wceq vx cv
      cA cen wbr vx con0 wrex vx cv cA cen wbr vx con0 crab cint cvv wcel vx cA
      numth2 vx cv cA cen wbr vx con0 intexrab mpbi vy vz cA vx cv vy cv cen
      wbr vx con0 crab cint vx cv cA cen wbr vx con0 crab cint cvv cvv vy cv cA
      wceq vx cv vy cv cen wbr vx con0 crab vx cv cA cen wbr vx con0 crab vy cv
      cA wceq vx cv vy cv cen wbr vx cv cA cen wbr vx con0 vy cv cA vx cv cen
      breq2 rabbisdv inteqd fvopabg mpan2 cA ccrd vz cv vx cv vy cv cen wbr vx
      con0 crab cint wceq vy vz copab vy vz vx df-card fveq1i syl5eq cA cvv
      wcel wn cA ccrd cfv c0 vx cv cA cen wbr vx con0 crab cint cA ccrd fvprc
      cA cvv wcel wn vx cv cA cen wbr vx con0 crab cint con0 cint c0 cA cvv
      wcel wn vx cv cA cen wbr vx con0 crab con0 cA cvv wcel wn vx cv cA cen
      wbr vx con0 crab vx cv con0 wcel vx cab con0 cA cvv wcel wn vx cv con0
      wcel vx cab vx cv con0 wcel vx cv cA cen wbr wa vx cab vx cv cA cen wbr
      vx con0 crab cA cvv wcel wn vx cv con0 wcel vx cv con0 wcel vx cv cA cen
      wbr wa vx cA cvv wcel wn vx cv cA cen wbr vx cv con0 wcel cA cvv wcel wn
      vx cv cA cen wbr vx cv vx cv cen wbr vx cv vx visset enref vx cv cA cen
      brprc mpbiri biantrud abbidv vx cv cA cen wbr vx con0 df-rab syl6reqr vx
      con0 abid2 syl6eq inteqd inton syl6eq eqtr4d pm2.61i $.
      $( [21-Oct-2003] $) $( [21-Oct-2003] $)

    $( The cardinal number of a set is an ordinal number.  Proposition 10.6(1)
       of [TakeutiZaring] p. 85.  Unlike Takeuti/Zaring's proposition, we need
       the Axiom of Choice (in ~ cardval ) because of our slightly different
       definition of of cardinal number. $)
    cardon $p |- ( card ` A ) e. On $=
      cA ccrd cfv vx cv cA cen wbr vx con0 crab cint con0 vx cA cardval vx cv
      cA cen wbr vx con0 crab con0 wss vx cv cA cen wbr vx con0 crab c0 wne vx
      cv cA cen wbr vx con0 crab cint con0 wcel vx cv cA cen wbr vx con0 ssrab2
      vx cv cA cen wbr vx con0 crab c0 wne vx cv cA cen wbr vx con0 crab cint
      cvv wcel cA ccrd cfv vx cv cA cen wbr vx con0 crab cint cvv vx cA cardval
      cA ccrd fvex eqeltrri vx cv cA cen wbr vx con0 crab intex mpbir vx cv cA
      cen wbr vx con0 crab oninton mp2an eqeltri $.
      $( [25-Nov-2003] $) $( [22-Oct-2003] $)

    $( Any set is equinumerous to its cardinal number.  Proposition 10.5 of
       [TakeutiZaring] p. 85. $)
    cardid $p |- ( card ` A ) ~~ A $=
      cA ccrd cfv vx cv cA cen wbr vx con0 crab wcel cA ccrd cfv cA cen wbr cA
      ccrd cfv vx cv cA cen wbr vx con0 crab cint vx cv cA cen wbr vx con0 crab
      vx cA cardval vx cv cA cen wbr vx con0 crab con0 wss vx cv cA cen wbr vx
      con0 crab c0 wne vx cv cA cen wbr vx con0 crab cint vx cv cA cen wbr vx
      con0 crab wcel vx cv cA cen wbr vx con0 ssrab2 vx cv cA cen wbr vx con0
      crab c0 wne vx cv cA cen wbr vx con0 crab cint cvv wcel cA ccrd cfv vx cv
      cA cen wbr vx con0 crab cint cvv vx cA cardval cA ccrd fvex eqeltrri vx
      cv cA cen wbr vx con0 crab intex mpbir vx cv cA cen wbr vx con0 crab
      onint mp2an eqeltri cA ccrd cfv vx cv cA cen wbr vx con0 crab wcel cA
      ccrd cfv con0 wcel cA ccrd cfv cA cen wbr vx cv cA cen wbr cA ccrd cfv cA
      cen wbr vx cA ccrd cfv con0 vx cv cA ccrd cfv cA cen breq1 elrab pm3.27bi
      ax-mp $.
      $( [25-Nov-2003] $) $( [22-Oct-2003] $)

    $( A set is a cardinal number iff it equals its own cardinal number.
       Proposition 10.9 of [TakeutiZaring] p. 85. $)
    oncard $p |- ( E. x A = ( card ` x ) <-> A = ( card ` A ) ) $=
      cA vx cv ccrd cfv wceq vx wex cA cA ccrd cfv wceq cA vx cv ccrd cfv wceq
      cA cA ccrd cfv wceq vx cA vx cv ccrd cfv wceq cA cA ccrd cfv cA vx cv
      ccrd cfv wceq cA cA ccrd cfv wss vx cv ccrd cfv cA ccrd cfv wss cA vx cv
      ccrd cfv wceq cA vx cv cen wbr cA ccrd cfv vx cv cen wbr vx cv ccrd cfv
      cA ccrd cfv wss cA vx cv ccrd cfv wceq cA vx cv cen wbr vx cv ccrd cfv vx
      cv cen wbr vx cv cardid cA vx cv ccrd cfv vx cv cen breq1 mpbiri cA ccrd
      cfv cA cen wbr cA vx cv cen wbr cA ccrd cfv vx cv cen wbr cA cardid cA
      ccrd cfv cA vx cv entr mpan cA ccrd cfv vx cv cen wbr vy cv vx cv cen wbr
      vy con0 crab cint cA ccrd cfv vx cv ccrd cfv cA ccrd cfv con0 wcel cA
      ccrd cfv vx cv cen wbr vy cv vx cv cen wbr vy con0 crab cint cA ccrd cfv
      wss wi cA cardon vy cv vx cv cen wbr cA ccrd cfv vx cv cen wbr vy cA ccrd
      cfv vy cv cA ccrd cfv vx cv cen breq1 onintss ax-mp vy vx cv cardval
      syl5ss 3syl cA vx cv ccrd cfv cA ccrd cfv sseq1 mpbird cA vx cv ccrd cfv
      wceq cA con0 wcel cA ccrd cfv cA wss cA vx cv ccrd cfv wceq cA con0 wcel
      vx cv ccrd cfv con0 wcel vx cv cardon cA vx cv ccrd cfv con0 eleq1 mpbiri
      cA cardonle syl eqssd 19.23aiv cA cvv wcel cA cA ccrd cfv wceq cA vx cv
      ccrd cfv wceq vx wex cA cA ccrd cfv wceq cA cvv wcel cA ccrd cfv cvv wcel
      cA ccrd fvex cA cA ccrd cfv cvv eleq1 mpbiri cA vx cv ccrd cfv wceq cA cA
      ccrd cfv wceq vx cA cvv vx cv cA wceq vx cv ccrd cfv cA ccrd cfv cA vx cv
      cA ccrd fveq2 eqeq2d cla4egv mpcom impbii $.
      $( [11-Aug-2004] $) $( [22-Oct-2003] $)

    $( The cardinal number of a finite set is a finite ordinal.  (Contributed
       by Paul Chapman, 11-Apr-2009.) $)
    ficardom $p |- ( A e. Fin -> ( card ` A ) e. om ) $=
      cA cfn wcel cA ccrd cfv cfn wcel cA ccrd cfv com wcel cA cfn wcel cA vx
      cv cen wbr vx com wrex cA ccrd cfv vx cv cen wbr vx com wrex cA ccrd cfv
      cfn wcel cA cfn wcel cA vx cv cen wbr vx com wrex vx cA isfi biimpi cA vx
      cv cen wbr cA ccrd cfv vx cv cen wbr wi vx com wral cA vx cv cen wbr vx
      com wrex cA ccrd cfv vx cv cen wbr vx com wrex wi cA vx cv cen wbr cA
      ccrd cfv vx cv cen wbr wi vx com cA vx cv cen wbr cA ccrd cfv vx cv cen
      wbr wi vx cv com wcel cA ccrd cfv cA cen wbr cA vx cv cen wbr cA ccrd cfv
      vx cv cen wbr cA cardid cA ccrd cfv cA vx cv entr mpan a1i rgen cA vx cv
      cen wbr cA ccrd cfv vx cv cen wbr vx com r19.22 ax-mp cA ccrd cfv cfn
      wcel cA ccrd cfv vx cv cen wbr vx com wrex vx cA ccrd cfv isfi biimpri
      3syl cA ccrd cfv con0 wcel cA ccrd cfv cfn wcel cA ccrd cfv com wcel wb
      cA cardon cA ccrd cfv onfin ax-mp sylib $.
      $( [14-Apr-2009] $) $( [11-Apr-2009] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( No member of a cardinal number of a set is equinumerous to the set.
       Proposition 10.6(2) of [TakeutiZaring] p. 85. $)
    cardne $p |- ( A e. ( card ` B ) -> -. A ~~ B ) $=
      cA con0 wcel cA cB ccrd cfv wcel cA cB cen wbr wn cB ccrd cfv cA cB
      cardon oneli cA con0 wcel cA cB cen wbr cA cB ccrd cfv wcel cA con0 wcel
      cA cB cen wbr cB ccrd cfv cA wss cA cB ccrd cfv wcel wn cA con0 wcel cA
      cB cen wbr vx cv cB cen wbr vx con0 crab cint cA wss cB ccrd cfv cA wss
      vx cv cB cen wbr cA cB cen wbr vx cA vx cv cA cB cen breq1 onintss cB
      ccrd cfv vx cv cB cen wbr vx con0 crab cint cA vx cB cardval sseq1i
      syl6ibr cB ccrd cfv con0 wcel cA con0 wcel cB ccrd cfv cA wss cA cB ccrd
      cfv wcel wn wb cB cardon cB ccrd cfv cA ontri1 mpan sylibd con2d mpcom $.
      $( [14-Dec-2003] $) $( [22-Oct-2003] $)
  $}

  $( Two sets are equinumerous iff their cardinal numbers are equal.  This
     important theorem expresses the essential concept behind "cardinality"
     or "size."  This theorem appears as Proposition 10.10 of [TakeutiZaring]
     p. 85, Theorem 7P of [Enderton] p. 197, and Theorem 9 of [Suppes] p. 242
     (among others).  The Axiom of Choice is required for its proof.

     The theory of cardinality can also be developed without AC by
     introducing "card" as a primitive notion and stating this theorem as an
     axiom, as is done with the axiom for cardinal numbers in [Suppes] p.
     111.  Finally, if we allow the Axiom of Regularity, we can avoid AC by
     defining the cardinal number of a set as the set of all sets
     equinumerous to it and having least possible rank (see ~ karden ). $)
  carden $p |- ( ( A e. C /\ B e. D ) ->
               ( ( card ` A ) = ( card ` B ) <-> A ~~ B ) ) $=
    cA cC wcel cB cD wcel wa cA ccrd cfv cB ccrd cfv wceq cA cB cen wbr cA cC
    wcel cA ccrd cfv cB ccrd cfv wceq cA cB cen wbr wi cB cD wcel cA ccrd cfv
    cB ccrd cfv wceq cA cA ccrd cfv cen wbr cA cB cen wbr cA cC wcel cA ccrd
    cfv cB ccrd cfv wceq cA cA ccrd cfv cen wbr cA cB ccrd cfv cen wbr cA cB
    cen wbr cA ccrd cfv cB ccrd cfv cA cen breq2 cA cB ccrd cfv cen wbr cB ccrd
    cfv cB cen wbr cA cB cen wbr cB cardid cA cB ccrd cfv cB entr mpan2 syl6bi
    cA cC wcel cA ccrd cfv cA cen wbr cA cA ccrd cfv cen wbr cA cardid cA ccrd
    cfv cA cC ensymg mpi syl5com adantr cB cD wcel cA cB cen wbr cA ccrd cfv cB
    ccrd cfv wceq wi cA cC wcel cB cD wcel cA cB cen wbr cA ccrd cfv cB ccrd
    cfv wss cB ccrd cfv cA ccrd cfv wss wa cA ccrd cfv cB ccrd cfv wceq cB cD
    wcel cA cB cen wbr cA ccrd cfv cB ccrd cfv wss cB ccrd cfv cA ccrd cfv wss
    cB cD wcel cA cB cen wbr cB cA cen wbr cA ccrd cfv cB ccrd cfv wss cA cB cD
    ensymg cB cA cen wbr cB ccrd cfv cA cen wbr cA ccrd cfv cB ccrd cfv wss cB
    ccrd cfv cB cen wbr cB cA cen wbr cB ccrd cfv cA cen wbr cB cardid cB ccrd
    cfv cB cA entr mpan cB ccrd cfv cA cen wbr cB ccrd cfv cA ccrd cfv wcel wn
    cA ccrd cfv cB ccrd cfv wss cB ccrd cfv cA ccrd cfv wcel cB ccrd cfv cA cen
    wbr cB ccrd cfv cA cardne con2i cA ccrd cfv con0 wcel cB ccrd cfv con0 wcel
    cA ccrd cfv cB ccrd cfv wss cB ccrd cfv cA ccrd cfv wcel wn wb cA cardon cB
    cardon cA ccrd cfv cB ccrd cfv ontri1 mp2an sylibr syl syl6 cA cB cen wbr
    cB ccrd cfv cA ccrd cfv wss wi cB cD wcel cA cB cen wbr cA ccrd cfv cB cen
    wbr cB ccrd cfv cA ccrd cfv wss cA ccrd cfv cA cen wbr cA cB cen wbr cA
    ccrd cfv cB cen wbr cA cardid cA ccrd cfv cA cB entr mpan cA ccrd cfv cB
    cen wbr cA ccrd cfv cB ccrd cfv wcel wn cB ccrd cfv cA ccrd cfv wss cA ccrd
    cfv cB ccrd cfv wcel cA ccrd cfv cB cen wbr cA ccrd cfv cB cardne con2i cB
    ccrd cfv con0 wcel cA ccrd cfv con0 wcel cB ccrd cfv cA ccrd cfv wss cA
    ccrd cfv cB ccrd cfv wcel wn wb cB cardon cA cardon cB ccrd cfv cA ccrd cfv
    ontri1 mp2an sylibr syl a1i jcad cA ccrd cfv cB ccrd cfv eqss syl6ibr
    adantl impbid $.
    $( [14-Dec-2003] $) $( [22-Oct-2003] $)

  $( Only the empty set has cardinality zero. $)
  cardeq0 $p |- ( A e. B -> ( ( card ` A ) = (/) <-> A = (/) ) ) $=
    cA cB wcel cA ccrd cfv c0 ccrd cfv wceq cA c0 cen wbr cA ccrd cfv c0 wceq
    cA c0 wceq cA cB wcel c0 cvv wcel cA ccrd cfv c0 ccrd cfv wceq cA c0 cen
    wbr wb 0ex cA c0 cB cvv carden mpan2 c0 ccrd cfv c0 cA ccrd cfv card0
    eqeq2i cA en0 3bitr3g $.
    $( [23-Aug-2004] $) $( [23-Apr-2004] $)

  ${
    $d x A $.  $d x B $.
    $( A set has cardinality one iff it is a singleton. $)
    card1 $p |- ( ( card ` A ) = 1o <-> E. x A = { x } ) $=
      cA ccrd cfv c1o wceq cA c1o cen wbr cA vx cv csn wceq vx wex cA ccrd cfv
      c1o wceq cA cvv wcel cA c1o cen wbr cA ccrd cfv c1o wceq cA ccrd cfv c0
      wceq cA cvv wcel cA ccrd cfv c1o wceq cA ccrd cfv c0 wceq c1o c0 wceq c1o
      c0 wne c1o c0 wceq wn 1n0 c1o c0 df-ne mpbi cA ccrd cfv c1o c0 eqeq1
      mtbiri cA ccrd fvprc nsyl2 cA c1o cen relen brrelexi cA cvv wcel cA ccrd
      cfv c1o ccrd cfv wceq cA c1o cen wbr cA ccrd cfv c1o wceq cA cvv wcel c1o
      com wcel cA ccrd cfv c1o ccrd cfv wceq cA c1o cen wbr wb 1onn cA c1o cvv
      com carden mpan2 c1o ccrd cfv c1o cA ccrd cfv c1o com wcel c1o ccrd cfv
      c1o wceq 1onn c1o cardnn ax-mp eqeq2i syl5bbr pm5.21nii vx cA en1 bitri
      $.
      $( [17-May-2008] $) $( [16-May-2008] $)

    $( A singleton has cardinality one. $)
    cardsn $p |- ( A e. B -> ( card ` { A } ) = 1o ) $=
      cA cB wcel cA csn vx cv csn wceq vx wex cA csn ccrd cfv c1o wceq cA cB
      wcel cA csn cA csn wceq cA csn vx cv csn wceq vx wex cA csn eqid cA csn
      vx cv csn wceq cA csn cA csn wceq vx cA cB vx cv cA wceq vx cv csn cA csn
      cA csn vx cv cA sneq eqeq2d cla4egv mpi vx cA csn card1 sylibr $.
      $( [20-Sep-2004] $) $( [23-Apr-2004] $)
  $}

  ${
    unsnen.1 $e |- A e. _V $.
    unsnen.2 $e |- B e. _V $.
    $( Equinumerosity of a set with a new element added. $)
    unsnen $p |- ( -. B e. A -> ( A u. { B } ) ~~ suc ( card ` A ) ) $=
      cB cA wcel wn cA cB csn cun cA ccrd cfv cA ccrd cfv csn cun cA ccrd cfv
      csuc cen cB cA wcel wn cA cB csn cin c0 wceq cA cB csn cun cA ccrd cfv cA
      ccrd cfv csn cun cen wbr cA cB disjsn cA cB csn cin c0 wceq cA ccrd cfv
      cA ccrd cfv csn cin c0 wceq cA cB csn cun cA ccrd cfv cA ccrd cfv csn cun
      cen wbr cA ccrd cfv word cA ccrd cfv cA ccrd cfv csn cin c0 wceq cA ccrd
      cfv cA cardon onordi cA ccrd cfv orddisj ax-mp cA cA ccrd cfv cen wbr cB
      csn cA ccrd cfv csn cen wbr cA cB csn cin c0 wceq cA ccrd cfv cA ccrd cfv
      csn cin c0 wceq wa cA cB csn cun cA ccrd cfv cA ccrd cfv csn cun cen wbr
      cA ccrd cfv cA unsnen.1 cA cardid ensymi cB cvv wcel cA ccrd cfv cvv wcel
      cB csn cA ccrd cfv csn cen wbr unsnen.2 cA ccrd fvex cB cA ccrd cfv cvv
      cvv en2sn mp2an cA cA ccrd cfv cB csn cA ccrd cfv csn unen mpanl12 mpan2
      sylbir cA ccrd cfv df-suc syl6breqr $.
      $( [8-Nov-2008] $) $( [7-Nov-2008] $)
  $}

  $( Two sets have the dominance relationship if their cardinalities have the
     subset relationship. $)
  carddomi $p |- ( A e. C -> ( ( card ` A ) C_ ( card ` B ) -> A ~<_ B ) ) $=
    cA cC wcel cA ccrd cfv cB ccrd cfv wss cA cB cdom wbr cA cB ccrd cfv cdom
    wbr cB ccrd cfv cB cen wbr cA cB cdom wbr cA cC wcel cA ccrd cfv cB ccrd
    cfv wss wa cA cB ccrd cfv cB domentr cA cA ccrd cfv cen wbr cA ccrd cfv cB
    ccrd cfv cdom wbr cA cB ccrd cfv cdom wbr cA cC wcel cA ccrd cfv cB ccrd
    cfv wss cA cA ccrd cfv cB ccrd cfv endomtr cA cC wcel cA ccrd cfv cA cen
    wbr cA cA ccrd cfv cen wbr cA cardid cA ccrd cfv cA cC ensymg mpi cA ccrd
    cfv con0 wcel cA ccrd cfv cB ccrd cfv wss cA ccrd cfv cB ccrd cfv cdom wbr
    wi cA cardon cA ccrd cfv cB ccrd cfv con0 ssdomg ax-mp syl2an cB cardid
    sylancl ex $.
    $( [25-Nov-2003] $) $( [22-Oct-2003] $)

  $( Two sets have the dominance relationship iff their cardinalities have the
     subset relationship.  Equation i of [Quine] p. 232. $)
  carddom $p |- ( ( A e. C /\ B e. D ) ->
               ( ( card ` A ) C_ ( card ` B ) <-> A ~<_ B ) ) $=
    cA cC wcel cB cD wcel wa cA ccrd cfv cB ccrd cfv wss cA cB cdom wbr cA cC
    wcel cA ccrd cfv cB ccrd cfv wss cA cB cdom wbr wi cB cD wcel cA cB cC
    carddomi adantr cA cC wcel cB cD wcel wa cA cB csdm wbr cA cB cen wbr wo cA
    ccrd cfv cB ccrd cfv wss cA cB cdom wbr cA cC wcel cB cD wcel wa cA cB csdm
    wbr cA ccrd cfv cB ccrd cfv wss cA cB cen wbr cB cD wcel cA cB csdm wbr cA
    ccrd cfv cB ccrd cfv wss wi cA cC wcel cB cD wcel cA cB csdm wbr cB ccrd
    cfv cA ccrd cfv wcel wn cA ccrd cfv cB ccrd cfv wss cB cD wcel cB ccrd cfv
    cA ccrd cfv wcel cA cB csdm wbr cB cD wcel cB ccrd cfv cA ccrd cfv wcel cB
    cA cdom wbr cA cB csdm wbr wn cB cD wcel cB ccrd cfv cA ccrd cfv wss cB cA
    cdom wbr cB ccrd cfv cA ccrd cfv wcel cB cA cD carddomi cA ccrd cfv cB ccrd
    cfv cA cardon onelssi syl5 cB cA domnsym syl6 con2d cA ccrd cfv con0 wcel
    cB ccrd cfv con0 wcel cA ccrd cfv cB ccrd cfv wss cB ccrd cfv cA ccrd cfv
    wcel wn wb cA cardon cB cardon cA ccrd cfv cB ccrd cfv ontri1 mp2an syl6ibr
    adantl cA cC wcel cB cD wcel wa cA cB cen wbr cA ccrd cfv cB ccrd cfv wceq
    cA ccrd cfv cB ccrd cfv wss cA cB cC cD carden cA ccrd cfv cB ccrd cfv
    eqimss syl6bir jaod cA cB brdom2 syl5ib impbid $.
    $( [22-Dec-2003] $) $( [22-Oct-2003] $)

  $( Two sets have the strict dominance relationship iff their cardinalities
     have the membership relationship.  Corollary 19.7(2) of [Eisenberg]
     p. 310. $)
  cardsdom $p |- ( ( A e. C /\ B e. D ) ->
               ( ( card ` A ) e. ( card ` B ) <-> A ~< B ) ) $=
    cA cC wcel cB cD wcel wa cA ccrd cfv cB ccrd cfv wss cA ccrd cfv cB ccrd
    cfv wne wa cA cB cdom wbr cA cB cen wbr wn wa cA ccrd cfv cB ccrd cfv wcel
    cA cB csdm wbr cA cC wcel cB cD wcel wa cA ccrd cfv cB ccrd cfv wss cA cB
    cdom wbr cA ccrd cfv cB ccrd cfv wne cA cB cen wbr wn cA cB cC cD carddom
    cA cC wcel cB cD wcel wa cA cB cen wbr cA ccrd cfv cB ccrd cfv cA cB cC cD
    carden necon3abid anbi12d cA ccrd cfv con0 wcel cB ccrd cfv con0 wcel cA
    ccrd cfv cB ccrd cfv wcel cA ccrd cfv cB ccrd cfv wss cA ccrd cfv cB ccrd
    cfv wne wa wb cA cardon cB cardon cA ccrd cfv cB ccrd cfv onelpss mp2an cA
    cB brsdom 3bitr4g $.
    $( [28-Dec-2003] $) $( [22-Oct-2003] $)

  $( Trichotomy law for dominance and strict dominance.  This theorem is
     equivalent to the Axiom of Choice. $)
  domtri $p |- ( ( A e. C /\ B e. D ) -> ( A ~<_ B <-> -. B ~< A ) ) $=
    cA cC wcel cB cD wcel wa cA ccrd cfv cB ccrd cfv wss cA cB cdom wbr cB cA
    csdm wbr wn cA cB cC cD carddom cA cC wcel cB cD wcel wa cB ccrd cfv cA
    ccrd cfv wcel wn cB cA csdm wbr wn cA ccrd cfv cB ccrd cfv wss cA cC wcel
    cB cD wcel wa cB ccrd cfv cA ccrd cfv wcel cB cA csdm wbr cB cD wcel cA cC
    wcel cB ccrd cfv cA ccrd cfv wcel cB cA csdm wbr wb cB cA cD cC cardsdom
    ancoms notbid cA ccrd cfv con0 wcel cB ccrd cfv con0 wcel cA ccrd cfv cB
    ccrd cfv wss cB ccrd cfv cA ccrd cfv wcel wn wb cA cardon cB cardon cA ccrd
    cfv cB ccrd cfv ontri1 mp2an syl5bb bitr3d $.
    $( [4-Jan-2004] $) $( [4-Jan-2004] $)

  $( Trichotomy of equinumerosity and strict dominance.  This theorem is
     equivalent to the Axiom of Choice.  Theorem 8 of [Suppes] p. 242. $)
  entric $p |- ( ( A e. C /\ B e. D ) -> ( A ~< B \/ A ~~ B \/ B ~< A ) ) $=
    cA cC wcel cB cD wcel wa cA cB csdm wbr cA cB cen wbr wo cB cA csdm wbr wo
    cA cB csdm wbr cA cB cen wbr cB cA csdm wbr w3o cA cC wcel cB cD wcel wa cA
    cB csdm wbr cA cB cen wbr wo cB cA csdm wbr cA cC wcel cB cD wcel wa cB cA
    csdm wbr cA cB csdm wbr cA cB cen wbr wo cA cC wcel cB cD wcel wa cB cA
    csdm wbr wn cA cB cdom wbr cA cB csdm wbr cA cB cen wbr wo cA cC wcel cB cD
    wcel wa cA cB cdom wbr cB cA csdm wbr wn cA cB cC cD domtri biimprd cA cB
    brdom2 syl6ib con1d orrd cA cB csdm wbr cA cB cen wbr cB cA csdm wbr df-3or
    sylibr $.
    $( [1-Oct-2004] $) $( [4-Jan-2004] $)

  $( Trichotomy of dominance and strict dominance. $)
  entri2 $p |- ( ( A e. C /\ B e. D ) -> ( A ~<_ B \/ B ~< A ) ) $=
    cA cC wcel cB cD wcel wa cA cB csdm wbr cA cB cen wbr cB cA csdm wbr w3o cA
    cB cdom wbr cB cA csdm wbr wo cA cB cC cD entric cA cB cdom wbr cB cA csdm
    wbr wo cA cB csdm wbr cA cB cen wbr wo cB cA csdm wbr wo cA cB csdm wbr cA
    cB cen wbr cB cA csdm wbr w3o cA cB cdom wbr cA cB csdm wbr cA cB cen wbr
    wo cB cA csdm wbr cA cB brdom2 orbi1i cA cB csdm wbr cA cB cen wbr cB cA
    csdm wbr df-3or bitr4i sylibr $.
    $( [1-Oct-2004] $) $( [4-Jan-2004] $)

  $( Trichotomy of dominance.  This theorem is equivalent to the Axiom of
     Choice.  Part of Proposition 4.42(d) of [Mendelson] p. 275. $)
  entri3 $p |- ( ( A e. C /\ B e. D ) -> ( A ~<_ B \/ B ~<_ A ) ) $=
    cA cC wcel cB cD wcel wa cA cB cdom wbr cB cA csdm wbr wo cA cB cdom wbr cB
    cA cdom wbr wo cA cB cC cD entri2 cB cA csdm wbr cB cA cdom wbr cA cB cdom
    wbr cB cA sdomdom orim2i syl $.
    $( [13-Nov-2004] $) $( [4-Jan-2004] $)

  $( The cardinality of the successor of an infinite ordinal. $)
  cardsucinf $p |- ( ( A e. On /\ om C_ A )
         -> ( card ` suc A ) = ( card ` A ) ) $=
    cA con0 wcel com cA wss wa cA ccrd cfv cA csuc ccrd cfv cA con0 wcel com cA
    wss wa cA ccrd cfv cA csuc ccrd cfv wceq cA cA csuc cen wbr cA infensuc cA
    con0 wcel cA ccrd cfv cA csuc ccrd cfv wceq cA cA csuc cen wbr wb com cA
    wss cA con0 wcel cA csuc con0 wcel cA ccrd cfv cA csuc ccrd cfv wceq cA cA
    csuc cen wbr wb cA suceloni cA cA csuc con0 con0 carden mpdan adantr mpbird
    eqcomd $.
    $( [16-Nov-2008] $) $( [15-Nov-2008] $)

  $( Strict dominance of a set over a natural number is the same as dominance
     over its successor.  The proof uses AC and Infinity.  It is unclear if a
     proof without using these is possible, unlike the weaker versions
     ~ omsucdom , ~ sucdomi , and ~ finsucdom . $)
  sucdom $p |- ( ( A e. om /\ B e. C ) ->
                   ( A ~< B <-> suc A ~<_ B ) ) $=
    cA com wcel cB cC wcel wa com cB cdom wbr cB com csdm wbr wo cA cB csdm wbr
    cA csuc cB cdom wbr wb cB cC wcel com cB cdom wbr cB com csdm wbr wo cA com
    wcel com cvv wcel cB cC wcel com cB cdom wbr cB com csdm wbr wo omex com cB
    cvv cC entri2 mpan adantl cA com wcel cB cC wcel wa com cB cdom wbr cA cB
    csdm wbr cA csuc cB cdom wbr wb cB com csdm wbr cA com wcel cB cC wcel wa
    com cB cdom wbr cA cB csdm wbr cA csuc cB cdom wbr wa cA cB csdm wbr cA
    csuc cB cdom wbr wb cA com wcel cB cC wcel wa com cB cdom wbr cA cB csdm
    wbr cA csuc cB cdom wbr cB cC wcel cA com wcel com cB cdom wbr cA cB csdm
    wbr wi cB cC wcel cA com csdm wbr com cB cdom wbr cA cB csdm wbr wi cA com
    wcel cB cC wcel cA com csdm wbr com cB cdom wbr cA cB csdm wbr cA com cB cC
    sdomdomtr expdimp cA nnsdom sylan2 ancoms cA com wcel com cB cdom wbr cA
    csuc cB cdom wbr wi cB cC wcel cA com wcel cA csuc com csdm wbr cA csuc com
    cdom wbr com cB cdom wbr cA csuc cB cdom wbr wi cA com wcel cA csuc com
    wcel cA csuc com csdm wbr cA peano2b cA csuc nnsdom sylbi cA csuc com
    sdomdom cA csuc com cdom wbr com cB cdom wbr cA csuc cB cdom wbr cA csuc
    com cB domtr ex 3syl adantr jcad cA cB csdm wbr cA csuc cB cdom wbr pm5.1
    syl6 cA com wcel cB com csdm wbr cA cB csdm wbr cA csuc cB cdom wbr wb wi
    cB cC wcel cA com wcel cB cfn wcel cA cB csdm wbr cA csuc cB cdom wbr wb cB
    com csdm wbr cA com wcel cB cfn wcel cA cB csdm wbr cA csuc cB cdom wbr wb
    cA cB finsucdom ex cB isfinite2 syl5 adantr jaod mpd $.
    $( [13-Sep-2008] $) $( [26-Jul-2004] $)

  ${
    $d x y z w v u t f A $.  $d x y z w v u t f B $.
    unxpdomlem.1 $e |- A e. _V $.
    unxpdomlem.2 $e |- B e. _V $.
    $( Lemma for ~ unxpdom . $)
    unxpdomlem $p |- ( ( 1o ~< A /\ 1o ~< B ) -> ( A u. B ) ~<_ ( A X. B ) ) $=
      vu cv vw cv wceq wn vw cA wrex vu cA wrex vt cv vv cv wceq wn vv cB wrex
      vt cB wrex cA cB cun cA cB cxp cdom wbr c1o cA csdm wbr c1o cB csdm wbr
      vu cv vw cv wceq wn vw cA wrex vu cA wrex vt cv vv cv wceq wn vv cB wrex
      vt cB wrex cA cB cun cA cB cxp cdom wbr vu cv vw cv wceq wn vw cA wrex vu
      cA wrex vt cv vv cv wceq wn cA cB cun cA cB cxp cdom wbr vt vv cB cB vu
      cv vw cv wceq wn vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn cA cB
      cun cA cB cxp cdom wbr wi wi vu vw cA cA vu cv cA wcel vw cv cA wcel wa
      vu cv vw cv wceq wn vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn cA
      cB cun cA cB cxp cdom wbr vu cv cA wcel vw cv cA wcel wa vu cv vw cv wceq
      wn wa vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn wa wa cA cB cun
      vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw
      cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2
      crn wss cA cB cun vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq
      vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif
      wceq wa vx vy vz copab2 crn cdom wbr cA cB cun cA cB cxp cdom wbr vu cv
      cA wcel vw cv cA wcel wa vu cv vw cv wceq wn wa vt cv cB wcel vv cv cB
      wcel wa vt cv vv cv wceq wn wa wa vf cA cB cun vx cv cA wcel vy cv cB
      wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 crn vu cv cA wcel vw
      cv cA wcel wa vu cv vw cv wceq wn wa vt cv cB wcel vv cv cB wcel wa vt cv
      vv cv wceq wn wa wa vf cv cA cB cun wcel vx cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy
      cB wrex vx cA wrex vf cv vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif
      cif wceq wa vx vy vz copab2 crn wcel vu cv cA wcel vw cv cA wcel wa vu cv
      vw cv wceq wn wa vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn wa wa
      vf cv cA wcel vf cv cB wcel wo vx cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA
      wrex vf cv cA cB cun wcel vu cv cA wcel vw cv cA wcel wa vu cv vw cv wceq
      wn wa vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn wa wa vf cv cA
      wcel vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq
      vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vf cv cB wcel vt cv
      cB wcel vv cv cB wcel wa vt cv vv cv wceq wn wa vf cv cA wcel vx cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif
      cif vf cv wceq vy cB wrex vx cA wrex wi vu cv cA wcel vw cv cA wcel wa vu
      cv vw cv wceq wn wa vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn wa
      vf cv vw cv wceq vf cv cA wcel vx cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA
      wrex wi vv cv cB wcel vf cv vw cv wceq vf cv cA wcel vx cv vw cv wceq vy
      cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv
      wceq vy cB wrex vx cA wrex wi wi vt cv cB wcel vt cv vv cv wceq wn vf cv
      cA wcel vv cv cB wcel vf cv vw cv wceq vx cv vw cv wceq vy cv vv cv wceq
      vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB
      wrex vx cA wrex vf cv cA wcel vv cv cB wcel vf cv vw cv wceq vx cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif
      cif vf cv wceq vy cB wrex vx cA wrex vf cv cA wcel vv cv cB wcel vf cv vw
      cv wceq vv cv vv cv wceq vw cv vv cv cif vv cv vv cv wceq vv cv vf cv cif
      cif vf cv wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vf cv vw cv
      wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq
      vv cv vx cv cif cif vf cv wceq vf cv vw cv wceq vv cv vv cv wceq vw cv vv
      cv cif vv cv vv cv wceq vv cv vf cv cif cif vf cv wceq vf cv vw cv wceq
      vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vf cv cif cif vf
      cv wceq vx vy vf cv vv cv cA cB vx cv vf cv wceq vx cv vw cv wceq vy cv
      vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv vw
      cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vf cv cif
      cif vf cv vx cv vf cv wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv
      cif vy cv vv cv wceq vv cv vx cv cif cif vf cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vf cv cif
      cif vx cv vf cv wceq vx cv vw cv wceq vf cv vw cv wceq vy cv vv cv wceq
      vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif vx cv vf cv vw cv eqeq1
      ifbid vx cv vf cv wceq vf cv vw cv wceq vy cv vv cv wceq vv cv vx cv cif
      vy cv vv cv wceq vv cv vf cv cif vy cv vv cv wceq vw cv vy cv cif vy cv
      vv cv wceq vx cv vf cv vv cv ifeq2 ifeq2d eqtrd eqeq1d vy cv vv cv wceq
      vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv
      vf cv cif cif vf cv vw cv wceq vv cv vv cv wceq vw cv vv cv cif vv cv vv
      cv wceq vv cv vf cv cif cif vf cv vy cv vv cv wceq vw cv vy cv cif vv cv
      vv cv wceq vw cv vv cv cif wceq vy cv vv cv wceq vv cv vf cv cif vv cv vv
      cv wceq vv cv vf cv cif wceq vf cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vf cv cif cif vf cv vw cv wceq vv cv vv cv
      wceq vw cv vv cv cif vv cv vv cv wceq vv cv vf cv cif cif wceq vy cv vv
      cv wceq vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vv cv vv cv
      wceq vw cv vv cv cif vy cv vv cv wceq vv cv vf cv cif vv cv vv cv wceq vv
      cv vf cv cif ifeq12 vy cv vv cv wceq vy cv vv cv wceq vw cv vy cv cif vv
      cv vv cv wceq vw cv vy cv cif vv cv vv cv wceq vw cv vv cv cif vy cv vv
      cv wceq vy cv vv cv wceq vv cv vv cv wceq vw cv vy cv vy cv vv cv vv cv
      eqeq1 ifbid vv cv vv cv wceq vy cv vv cv vw cv ifeq2 eqtrd vy cv vv cv
      wceq vy cv vv cv wceq vv cv vv cv wceq vv cv vf cv vy cv vv cv vv cv
      eqeq1 ifbid sylanc eqeq1d rcla42ev vf cv vw cv wceq vv cv vv cv wceq vw
      cv vv cv cif vw cv vf cv vw cv wceq vv cv vv cv wceq vw cv vv cv cif vv
      cv vv cv wceq vv cv vf cv cif cif vf cv vv cv vv cv wceq vv cv vv cv wceq
      vw cv vv cv cif vw cv wceq vv cv eqid vv cv vv cv wceq vw cv vv cv iftrue
      ax-mp vf cv vw cv wceq vv cv vv cv wceq vw cv vv cv cif vv cv vv cv wceq
      vv cv vf cv cif iftrue vf cv vw cv wceq id 3eqtr4a syl3an3 3exp com3l
      ad2antlr vt cv cB wcel vt cv vv cv wceq wn vf cv vw cv wceq wn vf cv cA
      wcel vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq
      vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex wi wi vv cv cB wcel
      vf cv cA wcel vt cv cB wcel vt cv vv cv wceq wn wa vf cv vw cv wceq wn vx
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx
      cv cif cif vf cv wceq vy cB wrex vx cA wrex vf cv cA wcel vt cv cB wcel
      vt cv vv cv wceq wn vf cv vw cv wceq wn vx cv vw cv wceq vy cv vv cv wceq
      vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB
      wrex vx cA wrex wi vf cv cA wcel vt cv cB wcel vt cv vv cv wceq wn vf cv
      vw cv wceq wn vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vf cv cA
      wcel vt cv cB wcel vt cv vv cv wceq wn vf cv vw cv wceq wn wa vx cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif
      cif vf cv wceq vy cB wrex vx cA wrex vf cv cA wcel vt cv cB wcel vf cv vw
      cv wceq vt cv vv cv wceq vw cv vt cv cif vt cv vv cv wceq vv cv vf cv cif
      cif vf cv wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vt cv vv cv
      wceq wn vf cv vw cv wceq wn wa vx cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vf cv vw cv wceq
      vt cv vv cv wceq vw cv vt cv cif vt cv vv cv wceq vv cv vf cv cif cif vf
      cv wceq vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv
      wceq vv cv vf cv cif cif vf cv wceq vx vy vf cv vt cv cA cB vx cv vf cv
      wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq
      vv cv vx cv cif cif vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy
      cv vv cv wceq vv cv vf cv cif cif vf cv vx cv vf cv wceq vx cv vw cv wceq
      vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx
      cv cif cif vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv
      wceq vv cv vf cv cif cif vx cv vf cv wceq vx cv vw cv wceq vf cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif vx
      cv vf cv vw cv eqeq1 ifbid vx cv vf cv wceq vf cv vw cv wceq vy cv vv cv
      wceq vv cv vx cv cif vy cv vv cv wceq vv cv vf cv cif vy cv vv cv wceq vw
      cv vy cv cif vy cv vv cv wceq vx cv vf cv vv cv ifeq2 ifeq2d eqtrd eqeq1d
      vy cv vt cv wceq vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv
      vv cv wceq vv cv vf cv cif cif vf cv vw cv wceq vt cv vv cv wceq vw cv vt
      cv cif vt cv vv cv wceq vv cv vf cv cif cif vf cv vy cv vv cv wceq vw cv
      vy cv cif vt cv vv cv wceq vw cv vt cv cif wceq vy cv vv cv wceq vv cv vf
      cv cif vt cv vv cv wceq vv cv vf cv cif wceq vf cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vf cv cif cif vf cv vw cv
      wceq vt cv vv cv wceq vw cv vt cv cif vt cv vv cv wceq vv cv vf cv cif
      cif wceq vy cv vt cv wceq vf cv vw cv wceq vy cv vv cv wceq vw cv vy cv
      cif vt cv vv cv wceq vw cv vt cv cif vy cv vv cv wceq vv cv vf cv cif vt
      cv vv cv wceq vv cv vf cv cif ifeq12 vy cv vt cv wceq vy cv vv cv wceq vw
      cv vy cv cif vt cv vv cv wceq vw cv vy cv cif vt cv vv cv wceq vw cv vt
      cv cif vy cv vt cv wceq vy cv vv cv wceq vt cv vv cv wceq vw cv vy cv vy
      cv vt cv vv cv eqeq1 ifbid vt cv vv cv wceq vy cv vt cv vw cv ifeq2 eqtrd
      vy cv vt cv wceq vy cv vv cv wceq vt cv vv cv wceq vv cv vf cv vy cv vt
      cv vv cv eqeq1 ifbid sylanc eqeq1d rcla42ev vf cv vw cv wceq wn vt cv vv
      cv wceq wn vf cv vw cv wceq vt cv vv cv wceq vw cv vt cv cif vt cv vv cv
      wceq vv cv vf cv cif cif vt cv vv cv wceq vv cv vf cv cif vf cv vf cv vw
      cv wceq vt cv vv cv wceq vw cv vt cv cif vt cv vv cv wceq vv cv vf cv cif
      iffalse vt cv vv cv wceq vv cv vf cv iffalse sylan9eqr syl3an3 3exp exp4a
      imp3a com3l adantlr pm2.61d adantl vu cv cA wcel vw cv cA wcel wa vu cv
      vw cv wceq wn wa vf cv cB wcel vx cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA
      wrex wi vt cv cB wcel vv cv cB wcel wa vt cv vv cv wceq wn wa vu cv cA
      wcel vw cv cA wcel wa vu cv vw cv wceq wn wa vf cv vv cv wceq vf cv cB
      wcel vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq
      vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex wi vu cv cA wcel vu
      cv vw cv wceq wn vf cv vv cv wceq vf cv cB wcel vx cv vw cv wceq vy cv vv
      cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq
      vy cB wrex vx cA wrex wi wi vw cv cA wcel vu cv cA wcel vu cv vw cv wceq
      wn vf cv vv cv wceq vf cv cB wcel vx cv vw cv wceq vy cv vv cv wceq vw cv
      vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx
      cA wrex wi wi vu cv cA wcel vf cv cB wcel vf cv vv cv wceq vu cv vw cv
      wceq wn vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv
      wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vu cv cA wcel
      vf cv cB wcel vf cv vv cv wceq vu cv vw cv wceq wn vx cv vw cv wceq vy cv
      vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv
      wceq vy cB wrex vx cA wrex vu cv cA wcel vf cv cB wcel vf cv vv cv wceq
      vu cv vw cv wceq wn wa vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif
      vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vu
      cv cA wcel vf cv cB wcel vu cv vw cv wceq vf cv vv cv wceq vw cv vf cv
      cif vf cv vv cv wceq vv cv vu cv cif cif vf cv wceq vx cv vw cv wceq vy
      cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv
      wceq vy cB wrex vx cA wrex vf cv vv cv wceq vu cv vw cv wceq wn wa vx cv
      vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv
      cif cif vf cv wceq vu cv vw cv wceq vf cv vv cv wceq vw cv vf cv cif vf
      cv vv cv wceq vv cv vu cv cif cif vf cv wceq vu cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vu cv cif cif vf cv wceq vx
      vy vu cv vf cv cA cB vx cv vu cv wceq vx cv vw cv wceq vy cv vv cv wceq
      vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vu cv vw cv wceq vy
      cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vu cv cif cif vf cv
      vx cv vu cv wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv
      vv cv wceq vv cv vx cv cif cif vu cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vx cv cif cif vu cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vu cv cif cif vx cv vu cv
      wceq vx cv vw cv wceq vu cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif
      vy cv vv cv wceq vv cv vx cv cif vx cv vu cv vw cv eqeq1 ifbid vx cv vu
      cv wceq vu cv vw cv wceq vy cv vv cv wceq vv cv vx cv cif vy cv vv cv
      wceq vv cv vu cv cif vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vx
      cv vu cv vv cv ifeq2 ifeq2d eqtrd eqeq1d vy cv vf cv wceq vu cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vu cv cif
      cif vu cv vw cv wceq vf cv vv cv wceq vw cv vf cv cif vf cv vv cv wceq vv
      cv vu cv cif cif vf cv vy cv vv cv wceq vw cv vy cv cif vf cv vv cv wceq
      vw cv vf cv cif wceq vy cv vv cv wceq vv cv vu cv cif vf cv vv cv wceq vv
      cv vu cv cif wceq vu cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv
      vv cv wceq vv cv vu cv cif cif vu cv vw cv wceq vf cv vv cv wceq vw cv vf
      cv cif vf cv vv cv wceq vv cv vu cv cif cif wceq vy cv vf cv wceq vu cv
      vw cv wceq vy cv vv cv wceq vw cv vy cv cif vf cv vv cv wceq vw cv vf cv
      cif vy cv vv cv wceq vv cv vu cv cif vf cv vv cv wceq vv cv vu cv cif
      ifeq12 vy cv vf cv wceq vy cv vv cv wceq vw cv vy cv cif vf cv vv cv wceq
      vw cv vy cv cif vf cv vv cv wceq vw cv vf cv cif vy cv vf cv wceq vy cv
      vv cv wceq vf cv vv cv wceq vw cv vy cv vy cv vf cv vv cv eqeq1 ifbid vf
      cv vv cv wceq vy cv vf cv vw cv ifeq2 eqtrd vy cv vf cv wceq vy cv vv cv
      wceq vf cv vv cv wceq vv cv vu cv vy cv vf cv vv cv eqeq1 ifbid sylanc
      eqeq1d rcla42ev vu cv vw cv wceq wn vf cv vv cv wceq vu cv vw cv wceq vf
      cv vv cv wceq vw cv vf cv cif vf cv vv cv wceq vv cv vu cv cif cif vf cv
      vv cv wceq vv cv vu cv cif vf cv vu cv vw cv wceq vf cv vv cv wceq vw cv
      vf cv cif vf cv vv cv wceq vv cv vu cv cif iffalse vf cv vv cv wceq vf cv
      vv cv wceq vv cv vu cv cif vv cv vf cv vf cv vv cv wceq vv cv vu cv
      iftrue vf vv equcomi eqtrd sylan9eqr syl3an3 3exp exp4a com24 imp adantlr
      vw cv cA wcel vf cv vv cv wceq wn vf cv cB wcel vx cv vw cv wceq vy cv vv
      cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq
      vy cB wrex vx cA wrex wi wi vu cv cA wcel vu cv vw cv wceq wn vw cv cA
      wcel vf cv cB wcel vf cv vv cv wceq wn vx cv vw cv wceq vy cv vv cv wceq
      vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy cB
      wrex vx cA wrex vw cv cA wcel vf cv cB wcel vf cv vv cv wceq wn vx cv vw
      cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif
      cif vf cv wceq vy cB wrex vx cA wrex vw cv cA wcel vf cv cB wcel vw cv vw
      cv wceq vf cv vv cv wceq vw cv vf cv cif vf cv vv cv wceq vv cv vw cv cif
      cif vf cv wceq vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif vf cv wceq vy cB wrex vx cA wrex vf cv vv cv
      wceq wn vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv
      wceq vv cv vx cv cif cif vf cv wceq vw cv vw cv wceq vf cv vv cv wceq vw
      cv vf cv cif vf cv vv cv wceq vv cv vw cv cif cif vf cv wceq vw cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vw cv cif
      cif vf cv wceq vx vy vw cv vf cv cA cB vx cv vw cv wceq vx cv vw cv wceq
      vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vw
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vw
      cv cif cif vf cv vx cv vw cv wceq vx cv vw cv wceq vy cv vv cv wceq vw cv
      vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vw cv vw cv wceq vy cv vv
      cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vw cv vw cv
      wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vw cv cif
      cif vx cv vw cv wceq vx cv vw cv wceq vw cv vw cv wceq vy cv vv cv wceq
      vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif vx cv vw cv vw cv eqeq1
      ifbid vx cv vw cv wceq vw cv vw cv wceq vy cv vv cv wceq vv cv vx cv cif
      vy cv vv cv wceq vv cv vw cv cif vy cv vv cv wceq vw cv vy cv cif vy cv
      vv cv wceq vx cv vw cv vv cv ifeq2 ifeq2d eqtrd eqeq1d vy cv vf cv wceq
      vw cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv
      vw cv cif cif vw cv vw cv wceq vf cv vv cv wceq vw cv vf cv cif vf cv vv
      cv wceq vv cv vw cv cif cif vf cv vy cv vv cv wceq vw cv vy cv cif vf cv
      vv cv wceq vw cv vf cv cif wceq vy cv vv cv wceq vv cv vw cv cif vf cv vv
      cv wceq vv cv vw cv cif wceq vw cv vw cv wceq vy cv vv cv wceq vw cv vy
      cv cif vy cv vv cv wceq vv cv vw cv cif cif vw cv vw cv wceq vf cv vv cv
      wceq vw cv vf cv cif vf cv vv cv wceq vv cv vw cv cif cif wceq vy cv vf
      cv wceq vw cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vf cv vv cv
      wceq vw cv vf cv cif vy cv vv cv wceq vv cv vw cv cif vf cv vv cv wceq vv
      cv vw cv cif ifeq12 vy cv vf cv wceq vy cv vv cv wceq vw cv vy cv cif vf
      cv vv cv wceq vw cv vy cv cif vf cv vv cv wceq vw cv vf cv cif vy cv vf
      cv wceq vy cv vv cv wceq vf cv vv cv wceq vw cv vy cv vy cv vf cv vv cv
      eqeq1 ifbid vf cv vv cv wceq vy cv vf cv vw cv ifeq2 eqtrd vy cv vf cv
      wceq vy cv vv cv wceq vf cv vv cv wceq vv cv vw cv vy cv vf cv vv cv
      eqeq1 ifbid sylanc eqeq1d rcla42ev vf cv vv cv wceq wn vf cv vv cv wceq
      vw cv vf cv cif vf cv vw cv vw cv wceq vf cv vv cv wceq vw cv vf cv cif
      vf cv vv cv wceq vv cv vw cv cif cif vf cv vv cv wceq vw cv vf cv iffalse
      vw cv vw cv wceq vw cv vw cv wceq vf cv vv cv wceq vw cv vf cv cif vf cv
      vv cv wceq vv cv vw cv cif cif vf cv vv cv wceq vw cv vf cv cif wceq vw
      cv eqid vw cv vw cv wceq vf cv vv cv wceq vw cv vf cv cif vf cv vv cv
      wceq vv cv vw cv cif iftrue ax-mp syl5eq syl3an3 3exp com23 ad2antlr
      pm2.61d adantr jaod vf cv cA cB elun syl5ib vx cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv wceq vy
      cB wrex vx cA wrex vf cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv
      cif vy cv vv cv wceq vv cv vx cv cif cif wceq vy cB wrex vx cA wrex vf cv
      vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw
      cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2
      crn wcel vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv
      wceq vv cv vx cv cif cif vf cv wceq vf cv vx cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq vx vy cA
      cB vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv
      cv vx cv cif cif vf cv eqcom 2rexbii vx vy vz cA cB vx cv vw cv wceq vy
      cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vf cv
      vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw
      cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2
      vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv
      vx cv cif vy cv vv cv wceq vw cv vy cv vw visset vy visset ifex vy cv vv
      cv wceq vv cv vx cv vv visset vx visset ifex ifex vx cv cA wcel vy cv cB
      wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 eqid elrnoprab bitr4i
      syl6ib ssrdv cA cB cun cvv wcel cA cB cun vx cv cA wcel vy cv cB wcel wa
      vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq
      vv cv vx cv cif cif wceq wa vx vy vz copab2 crn wss cA cB cun vx cv cA
      wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv
      cif vy cv vv cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 crn cdom
      wbr wi cA cB unxpdomlem.1 unxpdomlem.2 unex cA cB cun vx cv cA wcel vy cv
      cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv
      vv cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 crn cvv ssdomg
      ax-mp cA cB cun vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy
      cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq
      wa vx vy vz copab2 crn cdom wbr vx cv cA wcel vy cv cB wcel wa vz cv vx
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx
      cv cif cif wceq wa vx vy vz copab2 crn cA cB cxp cdom wbr cA cB cun cA cB
      cxp cdom wbr cA cB cxp cvv wcel vx cv cA wcel vy cv cB wcel wa vz cv vx
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx
      cv cif cif wceq wa vx vy vz copab2 cA cB cxp wfn vx cv cA wcel vy cv cB
      wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 crn cA cB cxp cdom
      wbr cA cB unxpdomlem.1 unxpdomlem.2 xpex vx vy vz cA cB vx cv vw cv wceq
      vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif vx
      cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv
      vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 vx
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx
      cv cif vy cv vv cv wceq vw cv vy cv vw visset vy visset ifex vy cv vv cv
      wceq vv cv vx cv vv visset vx visset ifex ifex vx cv cA wcel vy cv cB
      wcel wa vz cv vx cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv
      cv wceq vv cv vx cv cif cif wceq wa vx vy vz copab2 eqid fnoprab2 cA cB
      cxp cvv vx cv cA wcel vy cv cB wcel wa vz cv vx cv vw cv wceq vy cv vv cv
      wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx cv cif cif wceq wa vx vy
      vz copab2 fnrndomg mp2 cA cB cun vx cv cA wcel vy cv cB wcel wa vz cv vx
      cv vw cv wceq vy cv vv cv wceq vw cv vy cv cif vy cv vv cv wceq vv cv vx
      cv cif cif wceq wa vx vy vz copab2 crn cA cB cxp domtr mpan2 3syl exp43
      r19.23aivv r19.23advv imp c1o cA csdm wbr c2o cA cdom wbr vu cv vw cv
      wceq wn vw cA wrex vu cA wrex c1o cA csdm wbr c1o csuc cA cdom wbr c2o cA
      cdom wbr c1o com wcel cA cvv wcel c1o cA csdm wbr c1o csuc cA cdom wbr wb
      1onn unxpdomlem.1 c1o cA cvv sucdom mp2an c2o c1o csuc cA cdom df-2o
      breq1i bitr4i vu vw cA unxpdomlem.1 2dom sylbi c1o cB csdm wbr c2o cB
      cdom wbr vt cv vv cv wceq wn vv cB wrex vt cB wrex c1o cB csdm wbr c1o
      csuc cB cdom wbr c2o cB cdom wbr c1o com wcel cB cvv wcel c1o cB csdm wbr
      c1o csuc cB cdom wbr wb 1onn unxpdomlem.2 c1o cB cvv sucdom mp2an c2o c1o
      csuc cB cdom df-2o breq1i bitr4i vt vv cB unxpdomlem.2 2dom sylbi syl2an
      $.
      $( [1-Oct-2004] $) $( [2-Sep-2004] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( Cross product dominates union for sets with cardinality greater than 1.
       Proposition 10.36 of [TakeutiZaring] p. 93. $)
    unxpdom $p |- ( ( 1o ~< A /\ 1o ~< B ) -> ( A u. B ) ~<_ ( A X. B ) ) $=
      cA cvv wcel cB cvv wcel wa c1o cA csdm wbr c1o cB csdm wbr wa cA cB cun
      cA cB cxp cdom wbr c1o cA csdm wbr cA cvv wcel c1o cB csdm wbr cB cvv
      wcel c1o cA csdm wbr c1o cvv wcel cA cvv wcel c1o cA sdomex pm3.27d c1o
      cB csdm wbr c1o cvv wcel cB cvv wcel c1o cB sdomex pm3.27d anim12i c1o vx
      cv csdm wbr c1o vy cv csdm wbr wa vx cv vy cv cun vx cv vy cv cxp cdom
      wbr wi c1o cA csdm wbr c1o vy cv csdm wbr wa cA vy cv cun cA vy cv cxp
      cdom wbr wi c1o cA csdm wbr c1o cB csdm wbr wa cA cB cun cA cB cxp cdom
      wbr wi vx vy cA cB cvv cvv vx cv cA wceq c1o vx cv csdm wbr c1o vy cv
      csdm wbr wa c1o cA csdm wbr c1o vy cv csdm wbr wa vx cv vy cv cun vx cv
      vy cv cxp cdom wbr cA vy cv cun cA vy cv cxp cdom wbr vx cv cA wceq c1o
      vx cv csdm wbr c1o cA csdm wbr c1o vy cv csdm wbr vx cv cA c1o csdm breq2
      anbi1d vx cv cA wceq vx cv vy cv cun cA vy cv cun vx cv vy cv cxp cA vy
      cv cxp cdom vx cv cA vy cv uneq1 vx cv cA vy cv xpeq1 breq12d imbi12d vy
      cv cB wceq c1o cA csdm wbr c1o vy cv csdm wbr wa c1o cA csdm wbr c1o cB
      csdm wbr wa cA vy cv cun cA vy cv cxp cdom wbr cA cB cun cA cB cxp cdom
      wbr vy cv cB wceq c1o vy cv csdm wbr c1o cB csdm wbr c1o cA csdm wbr vy
      cv cB c1o csdm breq2 anbi2d vy cv cB wceq cA vy cv cun cA cB cun cA vy cv
      cxp cA cB cxp cdom vy cv cB cA uneq2 vy cv cB cA xpeq2 breq12d imbi12d vx
      cv vy cv vx visset vy visset unxpdomlem vtocl2g mpcom $.
      $( [1-Oct-2004] $) $( [15-Sep-2004] $)
  $}

  ${
    unxpdom2.1 $e |- A e. _V $.
    unxpdom2.2 $e |- B e. _V $.
    $( Corollary of ~ unxpdom . $)
    unxpdom2 $p |- ( ( 1o ~< A /\ B ~<_ A ) -> ( A u. B ) ~<_ ( A X. A ) ) $=
      cB cA cdom wbr c1o cA csdm wbr cA cB cun cA cA cxp cdom wbr cA cB cun cA
      c1o csn cxp cA c0 csn cxp cun cdom wbr cA c1o csn cxp cA c0 csn cxp cun
      cA cA cxp cdom wbr cA cB cun cA cA cxp cdom wbr cB cA cdom wbr c1o cA
      csdm wbr cA cB cun cA c1o csn cxp cA c0 csn cxp cun cA cA cxp domtr cA cA
      c1o csn cxp cdom wbr cB cA c0 csn cxp cdom wbr cA cB cun cA c1o csn cxp
      cA c0 csn cxp cun cdom wbr cB cA cdom wbr cA cA c1o csn cxp cdom wbr cB
      cA c0 csn cxp cdom wbr wa cA c1o csn cxp cA c0 csn cxp cin c0 wceq cA cB
      cun cA c1o csn cxp cA c0 csn cxp cun cdom wbr c1o c0 wne cA c1o csn cxp
      cA c0 csn cxp cin c0 wceq 1n0 cA c1o cA c0 xpsndisj ax-mp cA cA c1o csn
      cxp cB cA c0 csn cxp cA c1o csn unxpdom2.1 c1o snex xpex unxpdom2.2 cA c0
      csn unxpdom2.1 p0ex xpex undom mpan2 cA cA c1o csn cxp cen wbr cA cA c1o
      csn cxp cdom wbr cA c1o csn cxp cA unxpdom2.1 cA c1o unxpdom2.1 c1o com
      1onn elisseti xpsnen ensymi cA cA c1o csn cxp endom ax-mp cB cA cdom wbr
      cA cA c0 csn cxp cen wbr cB cA c0 csn cxp cdom wbr cA c0 csn cxp cA
      unxpdom2.1 cA c0 unxpdom2.1 0ex xpsnen ensymi cB cA cA c0 csn cxp domentr
      mpan2 sylancr cA c1o csn cxp cA c0 csn cxp cun cA c1o csn cxp cA c0 csn
      cxp cxp cdom wbr cA c1o csn cxp cA c0 csn cxp cxp cA cA cxp cen wbr cA
      c1o csn cxp cA c0 csn cxp cun cA cA cxp cdom wbr c1o cA csdm wbr cA c1o
      csn cxp cA c0 csn cxp cun cA c1o csn cxp cA c0 csn cxp cxp cA cA cxp
      domentr c1o cA c1o csn cxp csdm wbr c1o cA c0 csn cxp csdm wbr cA c1o csn
      cxp cA c0 csn cxp cun cA c1o csn cxp cA c0 csn cxp cxp cdom wbr c1o cA
      csdm wbr cA c1o csn cxp cA c0 csn cxp unxpdom c1o cA csdm wbr cA cA c1o
      csn cxp cen wbr c1o cA c1o csn cxp csdm wbr cA c1o csn cxp cA unxpdom2.1
      cA c1o unxpdom2.1 c1o com 1onn elisseti xpsnen ensymi cA c1o csn cxp cvv
      wcel c1o cA csdm wbr cA cA c1o csn cxp cen wbr wa c1o cA c1o csn cxp csdm
      wbr wi cA c1o csn unxpdom2.1 c1o snex xpex c1o cA cA c1o csn cxp cvv
      sdomentr ax-mp mpan2 c1o cA csdm wbr cA cA c0 csn cxp cen wbr c1o cA c0
      csn cxp csdm wbr cA c0 csn cxp cA unxpdom2.1 cA c0 unxpdom2.1 0ex xpsnen
      ensymi cA c0 csn cxp cvv wcel c1o cA csdm wbr cA cA c0 csn cxp cen wbr wa
      c1o cA c0 csn cxp csdm wbr wi cA c0 csn unxpdom2.1 p0ex xpex c1o cA cA c0
      csn cxp cvv sdomentr ax-mp mpan2 sylanc cA c1o csn cxp cA cen wbr cA c0
      csn cxp cA cen wbr cA c1o csn cxp cA c0 csn cxp cxp cA cA cxp cen wbr cA
      c1o unxpdom2.1 c1o com 1onn elisseti xpsnen cA c0 unxpdom2.1 0ex xpsnen
      cA c1o csn cxp cA cA c0 csn cxp cA cA c1o csn unxpdom2.1 c1o snex xpex
      unxpdom2.1 cA c0 csn unxpdom2.1 p0ex xpex unxpdom2.1 xpen mp2an sylancl
      syl2an ancoms $.
      $( [24-Jul-2006] $) $( [16-Sep-2004] $)
  $}

  ${
    $d x A $.
    $( Cross product dominates successor for set with cardinality greater
       than 1.  Proposition 10.38 of [TakeutiZaring] p. 93 (but generalized
       to arbitrary sets, not just ordinals, with a proof using AC). $)
    sucxpdom $p |- ( 1o ~< A -> suc A ~<_ ( A X. A ) ) $=
      cA cvv wcel c1o cA csdm wbr cA csuc cA cA cxp cdom wbr c1o cA csdm wbr
      c1o cvv wcel cA cvv wcel c1o cA sdomex pm3.27d c1o vx cv csdm wbr vx cv
      csuc vx cv vx cv cxp cdom wbr wi c1o cA csdm wbr cA csuc cA cA cxp cdom
      wbr wi vx cA cvv vx cv cA wceq c1o vx cv csdm wbr c1o cA csdm wbr vx cv
      csuc vx cv vx cv cxp cdom wbr cA csuc cA cA cxp cdom wbr vx cv cA c1o
      csdm breq2 vx cv cA wceq vx cv csuc cA csuc vx cv vx cv cxp cA cA cxp
      cdom vx cv cA suceq vx cv cA wceq vx cv vx cv cxp cA vx cv cxp cA cA cxp
      vx cv cA vx cv xpeq1 vx cv cA cA xpeq2 eqtrd breq12d imbi12d c1o vx cv
      csdm wbr vx cv vx cv csn cun vx cv vx cv cxp vx cv csuc cdom c1o vx cv
      csdm wbr vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0 csn cxp cun cdom
      wbr vx cv c1o csn cxp vx cv c0 csn cxp cun vx cv c1o csn cxp vx cv c0 csn
      cxp cxp cdom wbr wa vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0 csn
      cxp cxp cdom wbr vx cv vx cv csn cun vx cv vx cv cxp cdom wbr c1o vx cv
      csdm wbr vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0 csn cxp cun cdom
      wbr vx cv c1o csn cxp vx cv c0 csn cxp cun vx cv c1o csn cxp vx cv c0 csn
      cxp cxp cdom wbr vx cv vx cv c1o csn cxp cdom wbr vx cv csn vx cv c0 csn
      cxp cdom wbr vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0 csn cxp cun
      cdom wbr c1o vx cv csdm wbr vx cv vx cv c1o csn cxp cdom wbr vx cv csn vx
      cv c0 csn cxp cdom wbr wa vx cv c1o csn cxp vx cv c0 csn cxp cin c0 wceq
      vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0 csn cxp cun cdom wbr c1o
      c0 wne vx cv c1o csn cxp vx cv c0 csn cxp cin c0 wceq 1n0 vx cv c1o vx cv
      c0 xpsndisj ax-mp vx cv vx cv c1o csn cxp vx cv csn vx cv c0 csn cxp vx
      cv c1o csn vx visset c1o snex xpex vx cv snex vx cv c0 csn vx visset p0ex
      xpex undom mpan2 vx cv vx cv c1o csn cxp cdom wbr vx cv vx cv cdom wbr vx
      cv cvv wcel vx cv vx cv cdom wbr vx visset vx cv cvv domrefg ax-mp vx cv
      cvv wcel vx cv c1o csn cxp vx cv cen wbr vx cv vx cv c1o csn cxp cdom wbr
      vx cv vx cv cdom wbr wb vx visset vx cv c1o vx visset c1o con0 1on
      elisseti xpsnen vx cv c1o csn cxp vx cv vx cv cvv domen2 mp2an mpbir c1o
      vx cv csdm wbr vx cv csn vx cv c0 csn cxp csdm wbr vx cv csn vx cv c0 csn
      cxp cdom wbr vx cv csn vx cv c0 csn cxp csdm wbr vx cv csn vx cv csdm wbr
      c1o vx cv csdm wbr vx cv cvv wcel vx cv c0 csn cxp vx cv cen wbr vx cv
      csn vx cv c0 csn cxp csdm wbr vx cv csn vx cv csdm wbr wb vx visset vx cv
      c0 vx visset 0ex xpsnen vx cv c0 csn cxp vx cv vx cv csn cvv sdomen2
      mp2an c1o cvv wcel vx cv csn c1o cen wbr vx cv csn vx cv csdm wbr c1o vx
      cv csdm wbr wb c1o con0 1on elisseti vx cv vx visset ensn1 vx cv csn c1o
      vx cv cvv sdomen1 mp2an bitri vx cv csn vx cv c0 csn cxp sdomdom sylbir
      sylancr c1o vx cv c1o csn cxp csdm wbr c1o vx cv c0 csn cxp csdm wbr vx
      cv c1o csn cxp vx cv c0 csn cxp cun vx cv c1o csn cxp vx cv c0 csn cxp
      cxp cdom wbr c1o vx cv csdm wbr vx cv c1o csn cxp vx cv c0 csn cxp
      unxpdom vx cv cvv wcel vx cv c1o csn cxp vx cv cen wbr c1o vx cv c1o csn
      cxp csdm wbr c1o vx cv csdm wbr wb vx visset vx cv c1o vx visset c1o con0
      1on elisseti xpsnen vx cv c1o csn cxp vx cv c1o cvv sdomen2 mp2an vx cv
      cvv wcel vx cv c0 csn cxp vx cv cen wbr c1o vx cv c0 csn cxp csdm wbr c1o
      vx cv csdm wbr wb vx visset vx cv c0 vx visset 0ex xpsnen vx cv c0 csn
      cxp vx cv c1o cvv sdomen2 mp2an sylancbr jca vx cv vx cv csn cun vx cv
      c1o csn cxp vx cv c0 csn cxp cun vx cv c1o csn cxp vx cv c0 csn cxp cxp
      domtr vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0 csn cxp cxp cdom wbr
      vx cv c1o csn cxp vx cv c0 csn cxp cxp vx cv vx cv cxp cen wbr vx cv vx
      cv csn cun vx cv vx cv cxp cdom wbr vx cv c1o csn cxp vx cv cen wbr vx cv
      c0 csn cxp vx cv cen wbr vx cv c1o csn cxp vx cv c0 csn cxp cxp vx cv vx
      cv cxp cen wbr vx cv c1o vx visset c1o con0 1on elisseti xpsnen vx cv c0
      vx visset 0ex xpsnen vx cv c1o csn cxp vx cv vx cv c0 csn cxp vx cv vx cv
      c1o csn vx visset c1o snex xpex vx visset vx cv c0 csn vx visset p0ex
      xpex vx visset xpen mp2an vx cv vx cv csn cun vx cv c1o csn cxp vx cv c0
      csn cxp cxp vx cv vx cv cxp domentr mpan2 3syl vx cv df-suc syl5eqbr
      vtoclg mpcom $.
      $( [24-Jul-2006] $) $( [3-Sep-2004] $)
  $}

  $( Strict dominance implies ordinal membership. $)
  sdomel $p |- ( ( A e. On /\ B e. On ) -> ( A ~< B -> A e. B ) ) $=
    cB con0 wcel cA con0 wcel cA cB csdm wbr cA cB wcel wi cB con0 wcel cA con0
    wcel wa cA cB wcel cA cB csdm wbr cB con0 wcel cA con0 wcel wa cB cA wss cB
    cA cdom wbr cA cB wcel wn cA cB csdm wbr wn cB con0 wcel cB cA wss cB cA
    cdom wbr wi cA con0 wcel cB cA con0 ssdomg adantr cB cA ontri1 cB cA con0
    con0 domtri 3imtr3d con4d ancoms $.
    $( [21-Nov-2004] $) $( [4-Nov-2003] $)

  $( A set strictly dominates iff its cardinal strictly dominates. $)
  sdomsdomcard $p |- ( A ~< B <-> A ~< ( card ` B ) ) $=
    cA cB csdm wbr cB cvv wcel cA cB ccrd cfv csdm wbr cA cB csdm wbr cA cvv
    wcel cB cvv wcel cA cB sdomex pm3.27d cB cvv wcel cA cB ccrd cfv csdm wbr
    cB cvv wcel wn cA cB ccrd cfv csdm wbr cA c0 csdm wbr cA sdom0 cB cvv wcel
    wn cB ccrd cfv c0 cA csdm cB ccrd fvprc breq2d mtbiri con4i cB cvv wcel cA
    cB csdm wbr cA cB ccrd cfv csdm wbr cA cB csdm wbr cB cB ccrd cfv cen wbr
    cA cB ccrd cfv csdm wbr cB cvv wcel cA cB csdm wbr cB cB ccrd cfv cen wbr
    cA cB ccrd cfv csdm wbr cB ccrd cfv cvv wcel cA cB csdm wbr cB cB ccrd cfv
    cen wbr wa cA cB ccrd cfv csdm wbr wi cB ccrd fvex cA cB cB ccrd cfv cvv
    sdomentr ax-mp ex cB cvv wcel cB ccrd cfv cB cen wbr cB cB ccrd cfv cen wbr
    cB cardid cB ccrd cfv cB cvv ensymg mpi syl5com cB cvv wcel cA cB ccrd cfv
    csdm wbr cB ccrd cfv cB cen wbr cA cB csdm wbr cB cardid cA cB ccrd cfv cB
    cvv sdomentr mpan2i impbid pm5.21nii $.
    $( [12-Jan-2004] $) $( [30-Oct-2003] $)

  $( The cardinality function is idempotent.  Proposition 10.11 of
     [TakeutiZaring] p. 85. $)
  cardidm $p |- ( card ` ( card ` A ) ) = ( card ` A ) $=
    cA cvv wcel cA ccrd cfv ccrd cfv cA ccrd cfv wceq cA cvv wcel cA ccrd cfv
    ccrd cfv cA ccrd cfv wceq cA ccrd cfv cA cen wbr cA cardid cA ccrd cfv cvv
    wcel cA cvv wcel cA ccrd cfv ccrd cfv cA ccrd cfv wceq cA ccrd cfv cA cen
    wbr wb cA ccrd fvex cA ccrd cfv cA cvv cvv carden mpan mpbiri cA cvv wcel
    wn c0 ccrd cfv c0 cA ccrd cfv ccrd cfv cA ccrd cfv card0 cA cvv wcel wn cA
    ccrd cfv c0 ccrd cA ccrd fvprc fveq2d cA ccrd fvprc 3eqtr4a pm2.61i $.
    $( [19-Dec-2003] $) $( [30-Oct-2003] $)

  $( Cantor's theorem in terms of cardinals.  This theorem tells us that no
     matter how largei a cardinal number is, there is a still larger cardinal
     number.  Theorem 18.12 of [Monk1] p. 133. $)
  canth3 $p |- ( A e. B -> ( card ` A ) e. ( card ` ~P A ) ) $=
    cA cB wcel cA ccrd cfv cA cpw ccrd cfv wcel cA cA cpw csdm wbr cA cB
    canth2g cA cB wcel cA cpw cvv wcel cA ccrd cfv cA cpw ccrd cfv wcel cA cA
    cpw csdm wbr wb cA cB pwexg cA cA cpw cB cvv cardsdom mpdan mpbird $.
    $( [11-Jul-2004] $) $( [5-Nov-2003] $)

  ${
    $d x A $.
    $( An infinite cardinal is a limit ordinal.  Equivalent to Exercise 4 of
       [TakeutiZaring] p. 91. $)
    cardlim $p |- ( om C_ ( card ` A ) <-> Lim ( card ` A ) ) $=
      com cA ccrd cfv wss cA ccrd cfv wlim com cA ccrd cfv wss cA ccrd cfv vx
      cv csuc wceq vx con0 wrex wn cA ccrd cfv wlim com cA ccrd cfv wss cA ccrd
      cfv vx cv csuc wceq vx con0 com cA ccrd cfv wss vx cv con0 wcel wa cA
      ccrd cfv vx cv csuc wceq vx cv cA ccrd cfv cen wbr com cA ccrd cfv wss vx
      cv con0 wcel cA ccrd cfv vx cv csuc wceq vx cv cA ccrd cfv cen wbr wi vx
      cv con0 wcel cA ccrd cfv vx cv csuc wceq com cA ccrd cfv wss vx cv cA
      ccrd cfv cen wbr vx cv con0 wcel cA ccrd cfv vx cv csuc wceq com cA ccrd
      cfv wss vx cv cA ccrd cfv cen wbr wi vx cv con0 wcel cA ccrd cfv vx cv
      csuc wceq wa com cA ccrd cfv wss vx cv vx cv csuc cen wbr vx cv cA ccrd
      cfv cen wbr cA ccrd cfv vx cv csuc wceq com cA ccrd cfv wss com vx cv
      csuc wss vx cv con0 wcel vx cv vx cv csuc cen wbr cA ccrd cfv vx cv csuc
      wceq com cA ccrd cfv wss com vx cv csuc wss cA ccrd cfv vx cv csuc com
      sseq2 biimpd vx cv con0 wcel com vx cv wss vx cv vx cv csuc cen wbr com
      vx cv csuc wss vx cv con0 wcel com vx cv wss vx cv vx cv csuc cen wbr vx
      cv infensuc ex com wlim com vx cv wss com vx cv csuc wss wb limom com vx
      cv limsssuc ax-mp syl5ibr sylan9r cA ccrd cfv vx cv csuc wceq vx cv cA
      ccrd cfv cen wbr vx cv vx cv csuc cen wbr wb vx cv con0 wcel cA ccrd cfv
      vx cv csuc vx cv cen breq2 adantl sylibrd ex com3r imp cA ccrd cfv vx cv
      csuc wceq vx cv cA ccrd cfv cen wbr wn wi com cA ccrd cfv wss vx cv con0
      wcel wa cA ccrd cfv vx cv csuc wceq vx cv cA ccrd cfv ccrd cfv wcel vx cv
      cA ccrd cfv cen wbr wn cA ccrd cfv vx cv csuc wceq vx cv cA ccrd cfv cA
      ccrd cfv ccrd cfv cA ccrd cfv vx cv csuc wceq vx cv cA ccrd cfv wcel vx
      cv vx cv csuc wcel vx cv vx visset sucid cA ccrd cfv vx cv csuc vx cv
      eleq2 mpbiri cA cardidm syl6eleqr vx cv cA ccrd cfv cardne syl a1i
      pm2.65d nrexdv com cA ccrd cfv wss cA ccrd cfv vx cv csuc wceq vx con0
      wrex cA ccrd cfv wlim com cA ccrd cfv wss c0 cA ccrd cfv wcel cA ccrd cfv
      c0 wceq wn cA ccrd cfv vx cv csuc wceq vx con0 wrex cA ccrd cfv wlim wo
      com cA ccrd cfv wss c0 com wcel c0 cA ccrd cfv wcel peano1 com cA ccrd
      cfv c0 ssel mpi cA ccrd cfv c0 n0i cA ccrd cfv c0 wceq cA ccrd cfv vx cv
      csuc wceq vx con0 wrex cA ccrd cfv wlim wo cA ccrd cfv c0 wceq cA ccrd
      cfv vx cv csuc wceq vx con0 wrex cA ccrd cfv wlim w3o cA ccrd cfv c0 wceq
      cA ccrd cfv vx cv csuc wceq vx con0 wrex cA ccrd cfv wlim wo wo cA ccrd
      cfv word cA ccrd cfv c0 wceq cA ccrd cfv vx cv csuc wceq vx con0 wrex cA
      ccrd cfv wlim w3o cA ccrd cfv cA cardon onordi vx cA ccrd cfv ordzsl mpbi
      cA ccrd cfv c0 wceq cA ccrd cfv vx cv csuc wceq vx con0 wrex cA ccrd cfv
      wlim 3orass mpbi ori 3syl ord mpd cA ccrd cfv limomss impbii $.
      $( [3-Jun-2004] $) $( [30-Oct-2003] $)
  $}

  $( A cardinal strictly dominates its members.  Equivalent to Proposition
     10.37 of [TakeutiZaring] p. 93 (use ~ cardsdom to obtain the exact
     proposition from this one). $)
  cardsdomel $p |- ( A e. On -> ( A ~< B <-> A e. ( card ` B ) ) ) $=
    cA con0 wcel cA cB ccrd cfv csdm wbr cA cB ccrd cfv wcel cA cB csdm wbr cA
    con0 wcel cA cB ccrd cfv csdm wbr cA cB ccrd cfv wcel cA con0 wcel cA cB
    ccrd cfv wcel cA cB ccrd cfv csdm wbr cA con0 wcel cB ccrd cfv cA wss cB
    ccrd cfv cA cdom wbr cA cB ccrd cfv wcel wn cA cB ccrd cfv csdm wbr wn cB
    ccrd cfv cA con0 ssdom2g cB ccrd cfv con0 wcel cA con0 wcel cB ccrd cfv cA
    wss cA cB ccrd cfv wcel wn wb cB cardon cB ccrd cfv cA ontri1 mpan cB ccrd
    cfv con0 wcel cA con0 wcel cB ccrd cfv cA cdom wbr cA cB ccrd cfv csdm wbr
    wn wb cB cardon cB ccrd cfv cA con0 con0 domtri mpan 3imtr3d con4d cA cB
    ccrd cfv csdm wbr cA cB ccrd cfv cdom wbr cA cB ccrd cfv cen wbr wn cA cB
    ccrd cfv wcel cA cB ccrd cfv brsdom cA cB ccrd cfv wcel cA cB ccrd cfv wss
    cA cB ccrd cfv cdom wbr cB ccrd cfv cA cB cardon onelssi cB ccrd cfv con0
    wcel cA cB ccrd cfv wss cA cB ccrd cfv cdom wbr wi cB cardon cA cB ccrd cfv
    con0 ssdom2g ax-mp syl cA cB ccrd cfv wcel cA cB ccrd cfv ccrd cfv wcel cA
    cB ccrd cfv cen wbr wn cB ccrd cfv ccrd cfv cB ccrd cfv cA cB cardidm
    eleq2i cA cB ccrd cfv cardne sylbir sylanbrc impbid1 cA cB sdomsdomcard
    syl5bb $.
    $( [13-Jan-2004] $) $( [2-Nov-2003] $)

  ${
    $d x A $.
    $( Two ways to express the property of being a cardinal number. $)
    iscard $p |- ( ( card ` A ) = A <-> ( A e. On /\ A. x e. A x ~< A ) ) $=
      cA ccrd cfv cA wceq cA con0 wcel cA ccrd cfv cA wceq wa cA con0 wcel vx
      cv cA csdm wbr vx cA wral wa cA ccrd cfv cA wceq cA con0 wcel cA ccrd cfv
      cA wceq cA ccrd cfv con0 wcel cA con0 wcel cA cardon cA ccrd cfv cA con0
      eleq1 mpbii pm4.71ri cA con0 wcel cA ccrd cfv cA wceq vx cv cA csdm wbr
      vx cA wral cA con0 wcel cA cA ccrd cfv wss cA ccrd cfv cA wceq vx cv cA
      csdm wbr vx cA wral cA con0 wcel cA ccrd cfv cA wss cA cA ccrd cfv wss cA
      ccrd cfv cA wceq wb cA cardonle cA ccrd cfv cA wceq cA ccrd cfv cA wss cA
      cA ccrd cfv wss cA ccrd cfv cA eqss baibr syl cA con0 wcel vx cv cA csdm
      wbr vx cA wral vx cv cA ccrd cfv wcel vx cA wral cA cA ccrd cfv wss cA
      con0 wcel vx cv cA csdm wbr vx cv cA ccrd cfv wcel vx cA cA con0 wcel vx
      cv cA wcel wa vx cv con0 wcel vx cv cA csdm wbr vx cv cA ccrd cfv wcel wb
      cA vx cv onelon vx cv cA cardsdomel syl ralbidva vx cA cA ccrd cfv dfss3
      syl6rbbr bitr3d pm5.32i bitri $.
      $( [14-Jan-2004] $) $( [2-Nov-2003] $)
  $}

  ${
    $d x y A $.
    $( Two ways to express the property of being a cardinal number.
       Definition 8 of [Suppes] p. 225. $)
    iscard2 $p |- ( ( card ` A ) = A <->
                  ( A e. On /\ A. x e. On ( A ~~ x -> A C_ x ) ) ) $=
      cA ccrd cfv cA wceq cA con0 wcel cA ccrd cfv cA wceq wa cA con0 wcel cA
      vx cv cen wbr cA vx cv wss wi vx con0 wral wa cA ccrd cfv cA wceq cA con0
      wcel cA ccrd cfv cA wceq cA ccrd cfv con0 wcel cA con0 wcel cA cardon cA
      ccrd cfv cA con0 eleq1 mpbii pm4.71ri cA con0 wcel cA ccrd cfv cA wceq cA
      vx cv cen wbr cA vx cv wss wi vx con0 wral cA con0 wcel cA ccrd cfv cA
      wceq cA cA ccrd cfv wss cA vx cv cen wbr cA vx cv wss wi vx con0 wral cA
      con0 wcel cA cA ccrd cfv wss cA ccrd cfv cA wss cA cA ccrd cfv wss wa cA
      ccrd cfv cA wceq cA con0 wcel cA ccrd cfv cA wss cA cA ccrd cfv wss cA
      cardonle biantrurd cA ccrd cfv cA eqss syl6rbbr cA con0 wcel cA vy cv cA
      cen wbr vy con0 crab cint wss cA vx cv cen wbr cA vx cv wss wi vx con0
      wral cA cA ccrd cfv wss cA con0 wcel cA vx cv wss vx vy cv cA cen wbr vy
      con0 crab wral cA vx cv cen wbr cA vx cv wss wi vx con0 wral cA vy cv cA
      cen wbr vy con0 crab cint wss cA con0 wcel cA vx cv wss cA vx cv cen wbr
      cA vx cv wss wi vx vy cv cA cen wbr vy con0 crab con0 cA con0 wcel vx cv
      vy cv cA cen wbr vy con0 crab wcel cA vx cv wss wi vx cv con0 wcel cA vx
      cv cen wbr wa cA vx cv wss wi vx cv con0 wcel cA vx cv cen wbr cA vx cv
      wss wi wi cA con0 wcel vx cv vy cv cA cen wbr vy con0 crab wcel vx cv
      con0 wcel cA vx cv cen wbr wa cA vx cv wss cA con0 wcel vx cv con0 wcel
      vx cv cA cen wbr wa vx cv con0 wcel cA vx cv cen wbr wa vx cv vy cv cA
      cen wbr vy con0 crab wcel cA con0 wcel vx cv cA cen wbr cA vx cv cen wbr
      vx cv con0 wcel cA con0 wcel vx cv cA cen wbr cA vx cv cen wbr vx cv cA
      con0 ensymg cA vx cv vx visset ensym impbid1 anbi2d vy cv cA cen wbr vx
      cv cA cen wbr vy vx cv con0 vy cv vx cv cA cen breq1 elrab syl5bb imbi1d
      vx cv con0 wcel cA vx cv cen wbr cA vx cv wss impexp syl6bb ralbidv2 vx
      cA vy cv cA cen wbr vy con0 crab ssint syl5bb cA ccrd cfv vy cv cA cen
      wbr vy con0 crab cint cA vy cA cardval sseq2i syl5bb bitrd pm5.32i bitri
      $.
      $( [27-Nov-2004] $) $( [7-Nov-2003] $)
  $}

  ${
    $d x A $.
    $( An alternate version of the value of the cardinal number of a set.
       Compare ~ cardval .  This theorem could be used to give us a simpler
       definition of ` card ` in place of ~ df-card .  It apparently does not
       occur in the literature. $)
    cardval2 $p |- ( card ` A ) = { x e. On | x ~< A } $=
      vx cv cA csdm wbr vx con0 crab vx cv con0 wcel vx cv cA csdm wbr wa vx
      cab vx cv cA ccrd cfv wcel vx cab cA ccrd cfv vx cv cA csdm wbr vx con0
      df-rab vx cv cA ccrd cfv wcel vx cv con0 wcel vx cv cA csdm wbr wa vx vx
      cv cA ccrd cfv wcel vx cv con0 wcel vx cv cA ccrd cfv wcel wa vx cv con0
      wcel vx cv cA csdm wbr wa vx cv cA ccrd cfv wcel vx cv con0 wcel cA ccrd
      cfv vx cv cA cardon oneli pm4.71ri vx cv con0 wcel vx cv cA csdm wbr vx
      cv cA ccrd cfv wcel vx cv cA cardsdomel pm5.32i bitr4i abbii vx cA ccrd
      cfv abid2 3eqtr2ri $.
      $( [12-Feb-2004] $) $( [7-Nov-2003] $)
  $}

  ${
    $d x y z A $.
    $( The collection of ordinal numbers dominated by a set is an ordinal
       number.  (In general, not all collections of ordinal numbers are
       ordinal.)  Theorem 56 of [Suppes] p. 227. $)
    ondomon $p |- ( A e. B -> { x e. On | x ~<_ A } e. On ) $=
      cA cB wcel vx cv cA cdom wbr vx con0 crab con0 wcel vx cv cA cdom wbr vx
      con0 crab word vx cv cA cdom wbr vx con0 crab wtr vx cv cA cdom wbr vx
      con0 crab con0 wss con0 word vx cv cA cdom wbr vx con0 crab word vx cv cA
      cdom wbr vx con0 crab wtr vy cv vz cv wcel vz cv vx cv cA cdom wbr vx
      con0 crab wcel wa vy cv vx cv cA cdom wbr vx con0 crab wcel wi vz wal vy
      wal vy cv vz cv wcel vz cv vx cv cA cdom wbr vx con0 crab wcel wa vy cv
      vx cv cA cdom wbr vx con0 crab wcel wi vy vz vy cv vz cv wcel vz cv vx cv
      cA cdom wbr vx con0 crab wcel vy cv vx cv cA cdom wbr vx con0 crab wcel
      vy cv vz cv wcel vz cv con0 wcel vz cv cA cdom wbr wa vy cv con0 wcel vy
      cv cA cdom wbr wa vz cv vx cv cA cdom wbr vx con0 crab wcel vy cv vx cv
      cA cdom wbr vx con0 crab wcel vy cv vz cv wcel vz cv con0 wcel vz cv cA
      cdom wbr vy cv con0 wcel vy cv cA cdom wbr wa vz cv con0 wcel vy cv vz cv
      wcel vz cv cA cdom wbr vy cv con0 wcel vy cv cA cdom wbr wa wi vz cv con0
      wcel vy cv vz cv wcel vz cv cA cdom wbr vy cv con0 wcel vy cv cA cdom wbr
      wa vy cv con0 wcel vy cv vz cv cdom wbr wa vz cv cA cdom wbr vy cv con0
      wcel vy cv cA cdom wbr wa vz cv con0 wcel vy cv vz cv wcel wa vy cv con0
      wcel vy cv vz cv cdom wbr vz cv cA cdom wbr vy cv con0 wcel vy cv cA cdom
      wbr wa vy cv vz cv cdom wbr vz cv cA cdom wbr wa vy cv cA cdom wbr vy cv
      con0 wcel vy cv vz cv cA domtr anim2i anassrs vz cv con0 wcel vy cv vz cv
      wcel wa vy cv con0 wcel vy cv vz cv cdom wbr vz cv vy cv onelon vz cv
      con0 wcel vy cv vz cv wcel wa vy cv vz cv wss vy cv vz cv cdom wbr vz cv
      con0 wcel vy cv vz cv wcel vy cv vz cv wss vz cv vy cv onelss imp vy cv
      cvv wcel vy cv vz cv wss vy cv vz cv cdom wbr wi vy visset vy cv vz cv
      cvv ssdomg ax-mp syl jca sylan exp31 com12 imp3a vx cv cA cdom wbr vz cv
      cA cdom wbr vx vz cv con0 vx cv vz cv cA cdom breq1 elrab vx cv cA cdom
      wbr vy cv cA cdom wbr vx vy cv con0 vx cv vy cv cA cdom breq1 elrab
      3imtr4g imp gen2 vy vz vx cv cA cdom wbr vx con0 crab dftr2 mpbir vx cv
      cA cdom wbr vx con0 ssrab2 ordon vx cv cA cdom wbr vx con0 crab con0
      trssord mp3an cA cB wcel vx cv cA cdom wbr vx con0 crab vx cv cA cpw csdm
      wbr vx con0 crab wss vx cv cA cdom wbr vx con0 crab cvv wcel vx cv cA
      cdom wbr vx con0 crab con0 wcel vx cv cA cdom wbr vx con0 crab word wb cA
      cB wcel vx cv cA cdom wbr vx cv cA cpw csdm wbr wi vx con0 wral vx cv cA
      cdom wbr vx con0 crab vx cv cA cpw csdm wbr vx con0 crab wss cA cB wcel
      cA cvv wcel vx cv cA cdom wbr vx cv cA cpw csdm wbr wi vx con0 wral cA cB
      elisset cA cvv wcel vx cv cA cdom wbr vx cv cA cpw csdm wbr wi vx con0 cA
      cvv wcel vx cv cA cdom wbr vx cv cA cpw csdm wbr wi vx cv con0 wcel vx cv
      cA cdom wbr cA cvv wcel vx cv cA cpw csdm wbr vx cv cA cdom wbr cA cA cpw
      csdm wbr vx cv cA cpw csdm wbr cA cvv wcel vx cv cA cA cpw domsdomtr cA
      cvv canth2g sylan2 expcom a1d r19.21aiv syl vx cv cA cdom wbr vx cv cA
      cpw csdm wbr vx con0 ss2rab sylibr vx cv cA cdom wbr vx con0 crab vx cv
      cA cpw csdm wbr vx con0 crab cA cpw ccrd cfv vx cv cA cpw csdm wbr vx
      con0 crab cvv vx cA cpw cardval2 cA cpw ccrd fvex eqeltrri ssex vx cv cA
      cdom wbr vx con0 crab cvv elong 3syl mpbiri $.
      $( [27-Nov-2004] $) $( [7-Nov-2003] $)
  $}

  ${
    $d x y z A $.
    $( The class of ordinal numbers dominated by a set is a cardinal number.
       Theorem 59 of [Suppes] p. 228. $)
    ondomcard $p |- ( A e. B ->
                 ( card ` { x e. On | x ~<_ A } ) = { x e. On | x ~<_ A } ) $=
      cA cB wcel cA cvv wcel vx cv cA cdom wbr vx con0 crab ccrd cfv vx cv cA
      cdom wbr vx con0 crab wceq cA cB elisset vx cv cA cdom wbr vx con0 crab
      ccrd cfv vx cv cA cdom wbr vx con0 crab wceq vx cv cA cdom wbr vx con0
      crab con0 wcel vx cv cA cdom wbr vx con0 crab vy cv cen wbr vx cv cA cdom
      wbr vx con0 crab vy cv wss wi vy con0 wral cA cvv wcel vy vx cv cA cdom
      wbr vx con0 crab iscard2 vx cA cvv ondomon cA cvv wcel vx cv cA cdom wbr
      vx con0 crab vy cv cen wbr vx cv cA cdom wbr vx con0 crab vy cv wss wi vy
      con0 cA cvv wcel vy cv con0 wcel wa vx cv cA cdom wbr vx con0 crab vy cv
      cen wbr vy cv vx cv cA cdom wbr vx con0 crab wcel wn vx cv cA cdom wbr vx
      con0 crab vy cv wss cA cvv wcel vx cv cA cdom wbr vx con0 crab vy cv cen
      wbr vy cv vx cv cA cdom wbr vx con0 crab wcel wn wi vy cv con0 wcel cA
      cvv wcel vy cv vx cv cA cdom wbr vx con0 crab cen wbr vy cv vx cv cA cdom
      wbr vx con0 crab wcel wn vx cv cA cdom wbr vx con0 crab vy cv cen wbr cA
      cvv wcel vy cv vx cv cA cdom wbr vx con0 crab wcel vy cv vx cv cA cdom
      wbr vx con0 crab cen wbr vy cv vx cv cA cdom wbr vx con0 crab wcel cA cvv
      wcel vy cv vx cv cA cdom wbr vx con0 crab cen wbr wn vy cv vx cv cA cdom
      wbr vx con0 crab wcel cA cvv wcel wa vy cv vx cv cA cdom wbr vx con0 crab
      csdm wbr vy cv vx cv cA cdom wbr vx con0 crab cen wbr wn vy cv cA cdom
      wbr cA vx cv cA cdom wbr vx con0 crab csdm wbr vy cv vx cv cA cdom wbr vx
      con0 crab csdm wbr vy cv vx cv cA cdom wbr vx con0 crab wcel cA cvv wcel
      vy cv cA vx cv cA cdom wbr vx con0 crab domsdomtr vy cv vx cv cA cdom wbr
      vx con0 crab wcel vy cv con0 wcel vy cv cA cdom wbr vx cv cA cdom wbr vy
      cv cA cdom wbr vx vy cv con0 vx cv vy cv cA cdom breq1 elrab pm3.27bi cA
      cvv wcel cA vx cv cA cdom wbr vx con0 crab csdm wbr vx cv cA cdom wbr vx
      con0 crab cA cdom wbr wn cA cvv wcel vx cv cA cdom wbr vx con0 crab con0
      wcel vx cv cA cdom wbr vx con0 crab cA cdom wbr wn vx cA cvv ondomon vx
      cv cA cdom wbr vx con0 crab con0 wcel vx cv cA cdom wbr vx con0 crab cA
      cdom wbr vx cv cA cdom wbr vx con0 crab vx cv cA cdom wbr vx con0 crab
      wcel vx cv cA cdom wbr vx con0 crab con0 wcel vx cv cA cdom wbr vx con0
      crab word vx cv cA cdom wbr vx con0 crab vx cv cA cdom wbr vx con0 crab
      wcel wn vx cv cA cdom wbr vx con0 crab eloni vx cv cA cdom wbr vx con0
      crab ordirr syl vx cv cA cdom wbr vx con0 crab con0 wcel vx cv cA cdom
      wbr vx con0 crab cA cdom wbr vx cv cA cdom wbr vx con0 crab vx cv cA cdom
      wbr vx con0 crab wcel vx cv cA cdom wbr vx con0 crab vx cv cA cdom wbr vx
      con0 crab wcel vx cv cA cdom wbr vx con0 crab con0 wcel vx cv cA cdom wbr
      vx con0 crab cA cdom wbr wa vx cv cA cdom wbr vx cv cA cdom wbr vx con0
      crab cA cdom wbr vx vy vx cv cA cdom wbr vx con0 crab con0 vx cv cA cdom
      wbr vx vy con0 hbrab1 vy cv con0 wcel vx ax-17 vx vy vx cv cA cdom wbr vx
      con0 crab cA cdom vx cv cA cdom wbr vx vy con0 hbrab1 vy cv cdom wcel vx
      ax-17 vy cv cA wcel vx ax-17 hbbr vx cv vx cv cA cdom wbr vx con0 crab cA
      cdom breq1 elrabf biimpri ex mtod syl vx cv cA cdom wbr vx con0 crab con0
      wcel cA cvv wcel cA vx cv cA cdom wbr vx con0 crab csdm wbr vx cv cA cdom
      wbr vx con0 crab cA cdom wbr wn wb vx cA cvv ondomon vx cv cA cdom wbr vx
      con0 crab con0 wcel cA cvv wcel wa vx cv cA cdom wbr vx con0 crab cA cdom
      wbr cA vx cv cA cdom wbr vx con0 crab csdm wbr vx cv cA cdom wbr vx con0
      crab cA con0 cvv domtri con2bid mpancom mpbird syl2an vy cv vx cv cA cdom
      wbr vx con0 crab sdomnen syl expcom con2d vx cv cA cdom wbr vx con0 crab
      vy cv vy visset ensym syl5 adantr vx cv cA cdom wbr vx con0 crab con0
      wcel vy cv con0 wcel vx cv cA cdom wbr vx con0 crab vy cv wss vy cv vx cv
      cA cdom wbr vx con0 crab wcel wn wb cA cvv wcel vx cv cA cdom wbr vx con0
      crab vy cv ontri1 vx cA cvv ondomon sylan sylibrd r19.21aiva sylanbrc syl
      $.
      $( [2-Dec-2004] $) $( [7-Nov-2003] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( The union of a set of cardinals is a cardinal.  Theorem 18.14 of [Monk1]
       p. 133. $)
    carduni $p |- ( A e. B ->
                  ( A. x e. A ( card ` x ) = x -> ( card ` U. A ) = U. A ) ) $=
      cA cB wcel vx cv ccrd cfv vx cv wceq vx cA wral cA cuni ccrd cfv cA cuni
      wceq cA cB wcel vx cv ccrd cfv vx cv wceq vx cA wral wa cA cuni ccrd cfv
      cA cuni wceq cA cuni ccrd cfv cA cuni wss cA cuni ccrd cfv cA cuni wcel
      wn wa cA cB wcel vx cv ccrd cfv vx cv wceq vx cA wral wa cA cuni ccrd cfv
      cA cuni wss cA cuni ccrd cfv cA cuni wcel wn cA cB wcel vx cv ccrd cfv vx
      cv wceq vx cA wral wa cA cuni con0 wcel cA cuni ccrd cfv cA cuni wss cA
      cB wcel vx cv ccrd cfv vx cv wceq vx cA wral cA cuni con0 wcel cA cB wcel
      cA con0 wss cA cuni con0 wcel vx cv ccrd cfv vx cv wceq vx cA wral cA cB
      ssonuni vx cv ccrd cfv vx cv wceq vx cA wral vy cA con0 vy cv cA wcel vx
      cv ccrd cfv vx cv wceq vx cA wral vy cv ccrd cfv vy cv wceq vy cv con0
      wcel vx cv ccrd cfv vx cv wceq vy cv ccrd cfv vy cv wceq vx vy cv cA vx
      cv vy cv wceq vx cv ccrd cfv vy cv ccrd cfv vx cv vy cv vx cv vy cv ccrd
      fveq2 vx cv vy cv wceq id eqeq12d rcla4v vy cv ccrd cfv vy cv wceq vy cv
      ccrd cfv con0 wcel vy cv con0 wcel vy cv cardon vy cv ccrd cfv vy cv con0
      eleq1 mpbii syl6com ssrdv syl5 imp cA cuni cardonle syl cA cB wcel vx cv
      ccrd cfv vx cv wceq vx cA wral wa cA cuni ccrd cfv cA cuni wcel cA cuni
      ccrd cfv cA cuni ccrd cfv wcel cA cuni ccrd cfv elirr cA cB wcel vx cv
      ccrd cfv vx cv wceq vx cA wral cA cuni ccrd cfv cA cuni wcel cA cuni ccrd
      cfv cA cuni ccrd cfv wcel wi cA cuni ccrd cfv cA cuni wcel vx cv ccrd cfv
      vx cv wceq vx cA wral cA cB wcel cA cuni ccrd cfv cA cuni ccrd cfv wcel
      cA cuni ccrd cfv cA cuni wcel cA cuni ccrd cfv vy cv wcel vy cv cA wcel
      wa vy wex vx cv ccrd cfv vx cv wceq vx cA wral cA cB wcel cA cuni ccrd
      cfv cA cuni ccrd cfv wcel wi wi vy cA cuni ccrd cfv cA eluni cA cuni ccrd
      cfv vy cv wcel vy cv cA wcel wa vx cv ccrd cfv vx cv wceq vx cA wral cA
      cB wcel cA cuni ccrd cfv cA cuni ccrd cfv wcel wi wi vy cA cuni ccrd cfv
      vy cv wcel vy cv cA wcel vx cv ccrd cfv vx cv wceq vx cA wral cA cB wcel
      cA cuni ccrd cfv cA cuni ccrd cfv wcel wi wi vy cv cA wcel vx cv ccrd cfv
      vx cv wceq vx cA wral cA cB wcel cA cuni ccrd cfv vy cv wcel cA cuni ccrd
      cfv cA cuni ccrd cfv wcel vy cv cA wcel vx cv ccrd cfv vx cv wceq vx cA
      wral vy cv ccrd cfv vy cv wceq cA cB wcel cA cuni ccrd cfv vy cv wcel cA
      cuni ccrd cfv cA cuni ccrd cfv wcel wi wi vx cv ccrd cfv vx cv wceq vy cv
      ccrd cfv vy cv wceq vx vy cv cA vx cv vy cv wceq vx cv ccrd cfv vy cv
      ccrd cfv vx cv vy cv vx cv vy cv ccrd fveq2 vx cv vy cv wceq id eqeq12d
      rcla4v cA cB wcel vy cv ccrd cfv vy cv wceq vy cv cA wcel cA cuni ccrd
      cfv vy cv wcel cA cuni ccrd cfv cA cuni ccrd cfv wcel wi cA cB wcel vy cv
      ccrd cfv vy cv wceq vy cv cA wcel cA cuni ccrd cfv vy cv wcel cA cuni
      ccrd cfv cA cuni ccrd cfv wcel wi wi cA cB wcel vy cv ccrd cfv vy cv wceq
      wa vy cv cA wcel vy cv cA cuni ccrd cfv wss cA cuni ccrd cfv vy cv wcel
      cA cuni ccrd cfv cA cuni ccrd cfv wcel wi cA cB wcel vy cv ccrd cfv vy cv
      wceq wa vy cv cA cuni cdom wbr vy cv cA cuni ccrd cfv wss vy cv cA wcel
      cA cB wcel vy cv cA cuni cdom wbr vy cv ccrd cfv cA cuni ccrd cfv wss vy
      cv ccrd cfv vy cv wceq vy cv cA cuni ccrd cfv wss cA cB wcel cA cuni cvv
      wcel vy cv cA cuni cdom wbr vy cv ccrd cfv cA cuni ccrd cfv wss wb cA cB
      uniexg cA cuni cvv wcel vy cv ccrd cfv cA cuni ccrd cfv wss vy cv cA cuni
      cdom wbr vy cv cvv wcel cA cuni cvv wcel vy cv ccrd cfv cA cuni ccrd cfv
      wss vy cv cA cuni cdom wbr wb vy visset vy cv cA cuni cvv cvv carddom
      mpan bicomd syl vy cv ccrd cfv vy cv cA cuni ccrd cfv sseq1 sylan9bb vy
      cv cA wcel vy cv cA cuni wss vy cv cA cuni cdom wbr vy cv cA elssuni vy
      cv cvv wcel vy cv cA cuni wss vy cv cA cuni cdom wbr wi vy visset vy cv
      cA cuni cvv ssdomg ax-mp syl syl5bi vy cv cA cuni ccrd cfv cA cuni ccrd
      cfv ssel syl6 ex com13 syld com4r imp 19.23aiv sylbi com13 imp mtoi jca
      cA cB wcel vx cv ccrd cfv vx cv wceq vx cA wral wa cA cuni con0 wcel cA
      cuni word cA cuni ccrd cfv cA cuni wceq cA cuni ccrd cfv cA cuni wss cA
      cuni ccrd cfv cA cuni wcel wn wa wb cA cB wcel vx cv ccrd cfv vx cv wceq
      vx cA wral cA cuni con0 wcel cA cB wcel cA con0 wss cA cuni con0 wcel vx
      cv ccrd cfv vx cv wceq vx cA wral cA cB ssonuni vx cv ccrd cfv vx cv wceq
      vx cA wral vy cA con0 vy cv cA wcel vx cv ccrd cfv vx cv wceq vx cA wral
      vy cv ccrd cfv vy cv wceq vy cv con0 wcel vx cv ccrd cfv vx cv wceq vy cv
      ccrd cfv vy cv wceq vx vy cv cA vx cv vy cv wceq vx cv ccrd cfv vy cv
      ccrd cfv vx cv vy cv vx cv vy cv ccrd fveq2 vx cv vy cv wceq id eqeq12d
      rcla4v vy cv ccrd cfv vy cv wceq vy cv ccrd cfv con0 wcel vy cv con0 wcel
      vy cv cardon vy cv ccrd cfv vy cv con0 eleq1 mpbii syl6com ssrdv syl5 imp
      cA cuni eloni cA cuni ccrd cfv word cA cuni word cA cuni ccrd cfv cA cuni
      wceq cA cuni ccrd cfv cA cuni wss cA cuni ccrd cfv cA cuni wcel wn wa wb
      cA cuni ccrd cfv cA cuni cardon onordi cA cuni ccrd cfv cA cuni ordtri4
      mpan 3syl mpbird ex $.
      $( [19-Jan-2004] $) $( [1-Nov-2003] $)
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( The indexed union of a set of cardinals is a cardinal. $)
    cardiun $p |- ( A e. C -> ( A. x e. A ( card ` B ) = B ->
                  ( card ` U_ x e. A B ) = U_ x e. A B ) ) $=
      cA cC wcel cB ccrd cfv cB wceq vx cA wral vx cA cB ciun ccrd cfv vx cA cB
      ciun wceq cA cC wcel cB ccrd cfv cB wceq vx cA wral wa vx cA cB ccrd cfv
      ciun ccrd cfv vx cA cB ccrd cfv ciun vx cA cB ciun ccrd cfv vx cA cB ciun
      cA cC wcel vx cA cB ccrd cfv ciun ccrd cfv vx cA cB ccrd cfv ciun wceq cB
      ccrd cfv cB wceq vx cA wral cA cC wcel vz cv cB ccrd cfv wceq vx cA wrex
      vz cab cuni ccrd cfv vz cv cB ccrd cfv wceq vx cA wrex vz cab cuni vx cA
      cB ccrd cfv ciun ccrd cfv vx cA cB ccrd cfv ciun cA cC wcel vz cv cB ccrd
      cfv wceq vx cA wrex vz cab cvv wcel vz cv cB ccrd cfv wceq vx cA wrex vz
      cab cuni ccrd cfv vz cv cB ccrd cfv wceq vx cA wrex vz cab cuni wceq vx
      vz cA cB ccrd cfv cC abrexexg vz cv cB ccrd cfv wceq vx cA wrex vz cab
      cvv wcel vy cv ccrd cfv vy cv wceq vy vz cv cB ccrd cfv wceq vx cA wrex
      vz cab wral vz cv cB ccrd cfv wceq vx cA wrex vz cab cuni ccrd cfv vz cv
      cB ccrd cfv wceq vx cA wrex vz cab cuni wceq vy cv ccrd cfv vy cv wceq vy
      vz cv cB ccrd cfv wceq vx cA wrex vz cab vy cv vz cv cB ccrd cfv wceq vx
      cA wrex vz cab wcel vy cv cB ccrd cfv wceq vx cA wrex vy cv ccrd cfv vy
      cv wceq vz cv cB ccrd cfv wceq vx cA wrex vy cv cB ccrd cfv wceq vx cA
      wrex vz vy cv vy visset vz cv vy cv wceq vz cv cB ccrd cfv wceq vy cv cB
      ccrd cfv wceq vx cA vz cv vy cv cB ccrd cfv eqeq1 rexbidv elab vy cv cB
      ccrd cfv wceq vy cv ccrd cfv vy cv wceq vx cA vy cv cB ccrd cfv wceq vy
      cv ccrd cfv vy cv wceq wi vx cv cA wcel vy cv cB ccrd cfv wceq cB ccrd
      cfv ccrd cfv cB ccrd cfv vy cv ccrd cfv vy cv cB cardidm vy cv cB ccrd
      cfv ccrd fveq2 vy cv cB ccrd cfv wceq id 3eqtr4a a1i r19.23aiv sylbi rgen
      vy vz cv cB ccrd cfv wceq vx cA wrex vz cab cvv carduni mpi syl vx cA cB
      ccrd cfv ciun vz cv cB ccrd cfv wceq vx cA wrex vz cab cuni ccrd vx vz cA
      cB ccrd cfv cB ccrd fvex dfiun2 fveq2i vx vz cA cB ccrd cfv cB ccrd fvex
      dfiun2 3eqtr4g adantr cA cC wcel cB ccrd cfv cB wceq vx cA wral wa vx cA
      cB ccrd cfv ciun vx cA cB ciun ccrd cB ccrd cfv cB wceq vx cA wral vx cA
      cB ccrd cfv ciun vx cA cB ciun wceq cA cC wcel vx cA cB ccrd cfv cB
      iuneq2 adantl fveq2d cB ccrd cfv cB wceq vx cA wral vx cA cB ccrd cfv
      ciun vx cA cB ciun wceq cA cC wcel vx cA cB ccrd cfv cB iuneq2 adantl
      3eqtr3d ex $.
      $( [21-Jan-2004] $) $( [3-Nov-2003] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( The smallest ordinal that strictly dominates a set is a
       cardinal. $)
    cardmin $p |- ( A e. B -> ( card ` |^| { x e. On | A ~< x } ) =
                      |^| { x e. On | A ~< x } ) $=
      cA vx cv csdm wbr vx con0 crab cint ccrd cfv cA vx cv csdm wbr vx con0
      crab cint wceq cA vx cv csdm wbr vx con0 crab cint con0 wcel vy cv cA vx
      cv csdm wbr vx con0 crab cint csdm wbr vy cA vx cv csdm wbr vx con0 crab
      cint wral cA cB wcel vy cA vx cv csdm wbr vx con0 crab cint iscard cA cB
      wcel cA vx cv csdm wbr vx con0 wrex cA vx cv csdm wbr vx con0 crab cint
      con0 wcel vx cA cB numthcor cA vx cv csdm wbr vx onintrab2 sylib cA cB
      wcel vy cv cA vx cv csdm wbr vx con0 crab cint csdm wbr vy cA vx cv csdm
      wbr vx con0 crab cint cA cB wcel vy cv cA vx cv csdm wbr vx con0 crab
      cint wcel vy cv cA cdom wbr cA cA vx cv csdm wbr vx con0 crab cint csdm
      wbr wa vy cv cA vx cv csdm wbr vx con0 crab cint csdm wbr cA cB wcel vy
      cv cA vx cv csdm wbr vx con0 crab cint wcel vy cv cA cdom wbr cA cA vx cv
      csdm wbr vx con0 crab cint csdm wbr cA cB wcel vy cv cA vx cv csdm wbr vx
      con0 crab cint wcel cA vy cv csdm wbr wn vy cv cA cdom wbr vy cv cA vx cv
      csdm wbr vx con0 crab cint wcel cA cB wcel vy cv con0 wcel cA vy cv csdm
      wbr wn cA cB wcel cA vx cv csdm wbr vx con0 crab cint con0 wcel vy cv cA
      vx cv csdm wbr vx con0 crab cint wcel vy cv con0 wcel wi cA cB wcel cA vx
      cv csdm wbr vx con0 wrex cA vx cv csdm wbr vx con0 crab cint con0 wcel vx
      cA cB numthcor cA vx cv csdm wbr vx onintrab2 sylib cA vx cv csdm wbr vx
      con0 crab cint con0 wcel vy cv cA vx cv csdm wbr vx con0 crab cint wcel
      vy cv con0 wcel cA vx cv csdm wbr vx con0 crab cint vy cv onelon ex syl
      vy cv con0 wcel cA vy cv csdm wbr vy cv cA vx cv csdm wbr vx con0 crab
      cint wcel vy cv con0 wcel cA vy cv csdm wbr vy cv cA vx cv csdm wbr vx
      con0 crab cint wcel wn vy cv con0 wcel cA vy cv csdm wbr wa vy cv cA vx
      cv csdm wbr vx con0 crab wcel vy cv cA vx cv csdm wbr vx con0 crab cint
      wcel wn cA vx cv csdm wbr cA vy cv csdm wbr vx vy cv con0 vx cv vy cv cA
      csdm breq2 elrab cA vx cv csdm wbr vx con0 crab con0 wss vy cv cA vx cv
      csdm wbr vx con0 crab wcel vy cv cA vx cv csdm wbr vx con0 crab cint wcel
      wn cA vx cv csdm wbr vx con0 ssrab2 cA vx cv csdm wbr vx con0 crab vy cv
      onnmin mpan sylbir ex con2d syli vy cv cvv wcel cA cB wcel vy cv cA cdom
      wbr cA vy cv csdm wbr wn wb vy visset vy cv cA cvv cB domtri mpan sylibrd
      cA cB wcel cA vx cv csdm wbr vx con0 wrex cA cA vx cv csdm wbr vx con0
      crab cint csdm wbr vx cA cB numthcor cA vx cv csdm wbr cA cA vx cv csdm
      wbr vx con0 crab cint csdm wbr vx vx vy cA cA vx cv csdm wbr vx con0 crab
      cint csdm vy cv cA wcel vx ax-17 vy cv csdm wcel vx ax-17 vx vy cA vx cv
      csdm wbr vx con0 crab cA vx cv csdm wbr vx vy con0 hbrab1 hbint hbbr vx
      cv cA vx cv csdm wbr vx con0 crab cint cA csdm breq2 onminsb syl jctird
      vy cv cA cA vx cv csdm wbr vx con0 crab cint domsdomtr syl6 r19.21aiv
      sylanbrc $.
      $( [15-Jan-2004] $) $( [28-Oct-2003] $)
  $}

  ${
    $d x y $.
    $( The class of all cardinal numbers is not a set (i.e. is a proper class).
       Theorem 19.8 of [Eisenberg] p. 310. $)
    cardprc $p |- -. { x | ( card ` x ) = x } e. _V $=
      vx cv ccrd cfv vx cv wceq vx cab cvv wcel vx cv ccrd cfv vx cv wceq vx
      cab cuni cvv wcel vx cv ccrd cfv vx cv wceq vx cab cuni cvv wcel vx cv
      ccrd cfv vx cv wceq vx cab cuni ccrd cfv vx cv ccrd cfv vx cv wceq vx cab
      cuni cpw ccrd cfv wcel vx cv ccrd cfv vx cv wceq vx cab cuni cvv canth3
      vx cv ccrd cfv vx cv wceq vx cab cuni cvv wcel vx cv ccrd cfv vx cv wceq
      vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni ccrd cfv
      wss vx cv ccrd cfv vx cv wceq vx cab cuni ccrd cfv vx cv ccrd cfv vx cv
      wceq vx cab cuni cpw ccrd cfv wcel wn vx cv ccrd cfv vx cv wceq vx cab
      cuni cvv wcel vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd cfv
      vx cv ccrd cfv vx cv wceq vx cab cuni ccrd cfv vx cv ccrd cfv vx cv wceq
      vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni cvv wcel
      vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd cfv vx cv ccrd
      cfv vx cv wceq vx cab cuni ccrd cfv wss vx cv ccrd cfv vx cv wceq vx cab
      cuni cpw ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni cdom wbr vx cv
      ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv cvv wcel vx cv ccrd cfv vx
      cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni
      wss vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx
      cv wceq vx cab cuni cdom wbr vx cv ccrd cfv vx cv wceq vx cab cuni cpw
      ccrd fvex vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd
      cfv vx cv wceq vx cab wcel vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd
      cfv vx cv ccrd cfv vx cv wceq vx cab cuni wss vx cv ccrd cfv vx cv wceq
      vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv wceq vx cab wcel vx cv ccrd
      cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd cfv vx cv ccrd cfv vx cv
      wceq vx cab cuni cpw ccrd cfv wceq vx cv ccrd cfv vx cv wceq vx cab cuni
      cpw cardidm vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv cvv wcel
      vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv
      wceq vx cab wcel vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd
      cfv vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv wceq wb vx cv ccrd
      cfv vx cv wceq vx cab cuni cpw ccrd fvex vx cv ccrd cfv vx cv wceq vx cv
      ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd cfv vx cv ccrd cfv vx
      cv wceq vx cab cuni cpw ccrd cfv wceq vx vy vx cv ccrd cfv vx cv wceq vx
      cab cuni cpw ccrd cfv cvv vx vy vx cv ccrd cfv vx cv wceq vx cab cuni cpw
      ccrd vy cv ccrd wcel vx ax-17 vx vy vx cv ccrd cfv vx cv wceq vx cab cuni
      vx vy vx cv ccrd cfv vx cv wceq vx cab vx cv ccrd cfv vx cv wceq vx vy
      hbab1 hbuni hbpw hbfv vx vy vy vx cv ccrd cfv vx cv wceq vx cab cuni cpw
      ccrd cfv ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx
      vy vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd vy cv ccrd
      wcel vx ax-17 vx vy vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd vy cv
      ccrd wcel vx ax-17 vx vy vx cv ccrd cfv vx cv wceq vx cab cuni vx vy vx
      cv ccrd cfv vx cv wceq vx cab vx cv ccrd cfv vx cv wceq vx vy hbab1 hbuni
      hbpw hbfv hbfv vx vy vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd vy cv
      ccrd wcel vx ax-17 vx vy vx cv ccrd cfv vx cv wceq vx cab cuni vx vy vx
      cv ccrd cfv vx cv wceq vx cab vx cv ccrd cfv vx cv wceq vx vy hbab1 hbuni
      hbpw hbfv hbeq vx cv vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv
      wceq vx cv ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv
      ccrd cfv vx cv vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv
      vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv ccrd fveq2 vx cv vx cv
      ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv wceq id eqeq12d elabgf ax-mp
      mpbir vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv
      vx cv wceq vx cab elssuni ax-mp vx cv ccrd cfv vx cv wceq vx cab cuni cpw
      ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni cvv ssdomg mp2 vx cv ccrd
      cfv vx cv wceq vx cab cuni cpw ccrd cfv cvv wcel vx cv ccrd cfv vx cv
      wceq vx cab cuni cvv wcel vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd
      cfv ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni ccrd cfv wss vx cv
      ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv wceq vx
      cab cuni cdom wbr wb vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd fvex
      vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx cv
      wceq vx cab cuni cvv cvv carddom mpan mpbiri vx cv ccrd cfv vx cv wceq vx
      cab cuni cpw cardidm syl5ssr vx cv ccrd cfv vx cv wceq vx cab cuni cpw
      ccrd cfv con0 wcel vx cv ccrd cfv vx cv wceq vx cab cuni ccrd cfv con0
      wcel vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx cv ccrd cfv vx
      cv wceq vx cab cuni ccrd cfv wss vx cv ccrd cfv vx cv wceq vx cab cuni
      ccrd cfv vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv wcel wn wb vx
      cv ccrd cfv vx cv wceq vx cab cuni cpw cardon vx cv ccrd cfv vx cv wceq
      vx cab cuni cardon vx cv ccrd cfv vx cv wceq vx cab cuni cpw ccrd cfv vx
      cv ccrd cfv vx cv wceq vx cab cuni ccrd cfv ontri1 mp2an sylib pm2.65i vx
      cv ccrd cfv vx cv wceq vx cab cvv uniexg mto $.
      $( [31-Oct-2004] $) $( [28-Oct-2003] $)
  $}

  ${
    $d x y z $.
    $( The aleph function is a function on the class of ordinal numbers. $)
    alephfnon $p |- aleph Fn On $=
      cale con0 wfn vy cv vx cv vz cv csdm wbr vz con0 crab cint wceq vx vy
      copab com crdg con0 wfn com vy cv vx cv vz cv csdm wbr vz con0 crab cint
      wceq vx vy copab rdgfnon cale vy cv vx cv vz cv csdm wbr vz con0 crab
      cint wceq vx vy copab com crdg wceq cale con0 wfn vy cv vx cv vz cv csdm
      wbr vz con0 crab cint wceq vx vy copab com crdg con0 wfn wb vx vy vz
      df-aleph con0 cale vy cv vx cv vz cv csdm wbr vz con0 crab cint wceq vx
      vy copab com crdg fneq1 ax-mp mpbir $.
      $( [22-Oct-2003] $) $( [21-Oct-2003] $)

    $( The first infinite cardinal number, discovered by Georg Cantor in 1873,
       has the same size as the set of natural numbers ` om ` (and under our
       particular definition is also equal to it).  In the literature, the
       argument of the aleph function is often written as a subscript, and the
       first aleph is written ` aleph `_0.  Exercise 3 of [TakeutiZaring]
       p. 91.  Also Definition 12(i) of [Suppes] p. 228.  From Mosh&eacute
       Machover, _Set Theory, Logic, and Their Limitations_, p. 95:
       "Aleph...the first letter in the Hebrew alphabet...is also the first
       letter of the Hebrew word...(_einsoph_, meaning infinity), which is a
       cabbalistic appellation of the deity.  The notation is due to Cantor,
       who was deeply interested in mysticism." $)
    aleph0 $p |- ( aleph ` (/) ) = om $=
      c0 cale cfv c0 vy cv vx cv vz cv csdm wbr vz con0 crab cint wceq vx vy
      copab com crdg cfv com c0 cale vy cv vx cv vz cv csdm wbr vz con0 crab
      cint wceq vx vy copab com crdg vx vy vz df-aleph fveq1i com vy cv vx cv
      vz cv csdm wbr vz con0 crab cint wceq vx vy copab omex rdg0 eqtri $.
      $( [21-Oct-2003] $) $( [21-Oct-2003] $)
  $}

  ${
    $d x y z w A $.
    $( Value of the aleph function at a limit ordinal.  Definition 12(iii) of
       [Suppes] p. 91. $)
    alephlim $p |- ( ( A e. B /\ Lim A ) -> ( aleph ` A ) =
                   U_ x e. A ( aleph ` x ) ) $=
      cA cB wcel cA wlim wa cA vz cv vy cv vw cv csdm wbr vw con0 crab cint
      wceq vy vz copab com crdg cfv vx cA vx cv vz cv vy cv vw cv csdm wbr vw
      con0 crab cint wceq vy vz copab com crdg cfv ciun cA cale cfv vx cA vx cv
      cale cfv ciun vx com cA cB vz cv vy cv vw cv csdm wbr vw con0 crab cint
      wceq vy vz copab rdglim2a cA cale vz cv vy cv vw cv csdm wbr vw con0 crab
      cint wceq vy vz copab com crdg vy vz vw df-aleph fveq1i vx cA vx cv cale
      cfv vx cv vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab
      com crdg cfv vx cv cale cfv vx cv vz cv vy cv vw cv csdm wbr vw con0 crab
      cint wceq vy vz copab com crdg cfv wceq vx cv cA wcel vx cv cale vz cv vy
      cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab com crdg vy vz vw
      df-aleph fveq1i a1i iuneq2i 3eqtr4g $.
      $( [22-Oct-2003] $) $( [21-Oct-2003] $)

    $( An aleph is an ordinal number. $)
    alephon $p |- ( aleph ` A ) e. On $=
      cA con0 wcel cA cale cfv con0 wcel vx cv cale cfv con0 wcel c0 cale cfv
      con0 wcel vy cv cale cfv con0 wcel vy cv csuc cale cfv con0 wcel cA cale
      cfv con0 wcel vx vy cA vx cv c0 wceq vx cv cale cfv c0 cale cfv con0 vx
      cv c0 cale fveq2 eleq1d vx cv vy cv wceq vx cv cale cfv vy cv cale cfv
      con0 vx cv vy cv cale fveq2 eleq1d vx cv vy cv csuc wceq vx cv cale cfv
      vy cv csuc cale cfv con0 vx cv vy cv csuc cale fveq2 eleq1d vx cv cA wceq
      vx cv cale cfv cA cale cfv con0 vx cv cA cale fveq2 eleq1d c0 cale cfv
      com con0 aleph0 omelon eqeltri vy cv con0 wcel vy cv csuc cale cfv con0
      wcel vy cv cale cfv con0 wcel vy cv con0 wcel vy cv cale cfv vx cv csdm
      wbr vx con0 crab cint cvv wcel vy cv csuc cale cfv con0 wcel vy cv con0
      wcel vy cv cale cfv vx cv csdm wbr vx con0 crab cint cvv wcel vy cv csuc
      cale cfv con0 wcel vy cv con0 wcel vy cv cale cfv vx cv csdm wbr vx con0
      crab cint cvv wcel vy cv cale cfv vx cv csdm wbr vx con0 crab cint cvv
      wcel vy cv csuc cale cfv con0 wcel wb vy cv con0 wcel vy cv cale cfv vx
      cv csdm wbr vx con0 crab cint cvv wcel wa vy cv csuc cale cfv con0 wcel
      vy cv cale cfv vx cv csdm wbr vx con0 crab cint con0 wcel vy cv cale cfv
      vx cv csdm wbr vx con0 crab cint cvv wcel vy cv con0 wcel vy cv cale cfv
      vx cv csdm wbr vx con0 crab cint cvv wcel wa vy cv csuc cale cfv vy cv
      cale cfv vx cv csdm wbr vx con0 crab cint con0 vz vy vw com vy cv vz cv
      vx cv csdm wbr vx con0 crab cint vy cv cale cfv vx cv csdm wbr vx con0
      crab cint cvv cale vw cv com wcel vz ax-17 vw cv vy cv wcel vz ax-17 vw
      cv vy cv cale cfv vx cv csdm wbr vx con0 crab cint wcel vz ax-17 vz vy vx
      df-aleph vz cv vy cv cale cfv wceq vz cv vx cv csdm wbr vx con0 crab vy
      cv cale cfv vx cv csdm wbr vx con0 crab vz cv vy cv cale cfv wceq vz cv
      vx cv csdm wbr vy cv cale cfv vx cv csdm wbr vx con0 vz cv vy cv cale cfv
      vx cv csdm breq1 rabbisdv inteqd rdgsucopab eleq1d vy cv cale cfv vx cv
      csdm wbr vx onintrab syl6rbbr ex ibd vy cv cale cfv vx cv csdm wbr vx
      con0 crab cint cvv wcel wn vy cv csuc cale cfv c0 con0 vz vy vw com vy cv
      vz cv vx cv csdm wbr vx con0 crab cint vy cv cale cfv vx cv csdm wbr vx
      con0 crab cint cale vw cv com wcel vz ax-17 vw cv vy cv wcel vz ax-17 vw
      cv vy cv cale cfv vx cv csdm wbr vx con0 crab cint wcel vz ax-17 vz vy vx
      df-aleph vz cv vy cv cale cfv wceq vz cv vx cv csdm wbr vx con0 crab vy
      cv cale cfv vx cv csdm wbr vx con0 crab vz cv vy cv cale cfv wceq vz cv
      vx cv csdm wbr vy cv cale cfv vx cv csdm wbr vx con0 vz cv vy cv cale cfv
      vx cv csdm breq1 rabbisdv inteqd rdgsucopabn 0elon syl6eqel pm2.61d1 a1d
      vx cv wlim vx cv cale cfv con0 wcel vy vx cv vy cv cale cfv ciun con0
      wcel vy cv cale cfv con0 wcel vy vx cv wral vx cv wlim vx cv cale cfv vy
      vx cv vy cv cale cfv ciun con0 vx cv cvv wcel vx cv wlim vx cv cale cfv
      vy vx cv vy cv cale cfv ciun wceq vx visset vy vx cv cvv alephlim mpan
      eleq1d vy vx cv vy cv cale cfv vx visset vy cv cale fvex iunon syl5bir
      tfinds cA con0 wcel wn cA cale cfv c0 con0 cA con0 wcel wn cA cale cdm
      wcel wn cA cale cfv c0 wceq cA cale cdm wcel cA con0 wcel cale cdm con0
      cA cale con0 wfn cale cdm con0 wceq alephfnon con0 cale fndm ax-mp eleq2i
      notbii cA cale ndmfv sylbir 0elon syl6eqel pm2.61i $.
      $( [10-Dec-2003] $) $( [10-Nov-2003] $)

    $( Value of the aleph function at a successor ordinal.  Definition 12(ii)
       of [Suppes] p. 91. $)
    alephsuc $p |- ( A e. On -> ( aleph ` suc A ) =
                    |^| { x e. On | ( aleph ` A ) ~< x } ) $=
      cA con0 wcel cA cale cfv vx cv csdm wbr vx con0 crab cint cvv wcel cA
      csuc cale cfv cA cale cfv vx cv csdm wbr vx con0 crab cint wceq cA cale
      cfv vx cv csdm wbr vx con0 wrex cA cale cfv vx cv csdm wbr vx con0 crab
      cint cvv wcel cA cale cfv cvv wcel cA cale cfv vx cv csdm wbr vx con0
      wrex cA cale fvex vx cA cale cfv cvv numthcor ax-mp cA cale cfv vx cv
      csdm wbr vx con0 intexrab mpbi vy vz vw com cA vy cv vx cv csdm wbr vx
      con0 crab cint cA cale cfv vx cv csdm wbr vx con0 crab cint cvv cale vw
      cv com wcel vy ax-17 vw cv cA wcel vy ax-17 vw cv cA cale cfv vx cv csdm
      wbr vx con0 crab cint wcel vy ax-17 vy vz vx df-aleph vy cv cA cale cfv
      wceq vy cv vx cv csdm wbr vx con0 crab cA cale cfv vx cv csdm wbr vx con0
      crab vy cv cA cale cfv wceq vy cv vx cv csdm wbr cA cale cfv vx cv csdm
      wbr vx con0 vy cv cA cale cfv vx cv csdm breq1 rabbisdv inteqd rdgsucopab
      mpan2 $.
      $( [11-Nov-2003] $) $( [22-Oct-2003] $)
  $}

  ${
    $d x y A $.  $d y B $.
    $( Every aleph is a cardinal number.  Theorem 65 of [Suppes] p. 229. $)
    alephcard $p |- ( card ` ( aleph ` A ) ) = ( aleph ` A ) $=
      cA con0 wcel cA cale cfv ccrd cfv cA cale cfv wceq vx cv cale cfv ccrd
      cfv vx cv cale cfv wceq c0 cale cfv ccrd cfv c0 cale cfv wceq vy cv cale
      cfv ccrd cfv vy cv cale cfv wceq vy cv csuc cale cfv ccrd cfv vy cv csuc
      cale cfv wceq cA cale cfv ccrd cfv cA cale cfv wceq vx vy cA vx cv c0
      wceq vx cv cale cfv ccrd cfv c0 cale cfv ccrd cfv vx cv cale cfv c0 cale
      cfv vx cv c0 wceq vx cv cale cfv c0 cale cfv ccrd vx cv c0 cale fveq2
      fveq2d vx cv c0 cale fveq2 eqeq12d vx cv vy cv wceq vx cv cale cfv ccrd
      cfv vy cv cale cfv ccrd cfv vx cv cale cfv vy cv cale cfv vx cv vy cv
      wceq vx cv cale cfv vy cv cale cfv ccrd vx cv vy cv cale fveq2 fveq2d vx
      cv vy cv cale fveq2 eqeq12d vx cv vy cv csuc wceq vx cv cale cfv ccrd cfv
      vy cv csuc cale cfv ccrd cfv vx cv cale cfv vy cv csuc cale cfv vx cv vy
      cv csuc wceq vx cv cale cfv vy cv csuc cale cfv ccrd vx cv vy cv csuc
      cale fveq2 fveq2d vx cv vy cv csuc cale fveq2 eqeq12d vx cv cA wceq vx cv
      cale cfv ccrd cfv cA cale cfv ccrd cfv vx cv cale cfv cA cale cfv vx cv
      cA wceq vx cv cale cfv cA cale cfv ccrd vx cv cA cale fveq2 fveq2d vx cv
      cA cale fveq2 eqeq12d com ccrd cfv com c0 cale cfv ccrd cfv c0 cale cfv
      cardom c0 cale cfv com ccrd aleph0 fveq2i aleph0 3eqtr4i vy cv con0 wcel
      vy cv csuc cale cfv ccrd cfv vy cv csuc cale cfv wceq vy cv cale cfv ccrd
      cfv vy cv cale cfv wceq vy cv con0 wcel vy cv cale cfv vx cv csdm wbr vx
      con0 crab cint ccrd cfv vy cv cale cfv vx cv csdm wbr vx con0 crab cint
      vy cv csuc cale cfv ccrd cfv vy cv csuc cale cfv vy cv cale cfv cvv wcel
      vy cv cale cfv vx cv csdm wbr vx con0 crab cint ccrd cfv vy cv cale cfv
      vx cv csdm wbr vx con0 crab cint wceq vy cv cale fvex vx vy cv cale cfv
      cvv cardmin ax-mp vy cv con0 wcel vy cv csuc cale cfv vy cv cale cfv vx
      cv csdm wbr vx con0 crab cint ccrd vx vy cv alephsuc fveq2d vx vy cv
      alephsuc 3eqtr4a a1d vx cv wlim vy cv cale cfv ccrd cfv vy cv cale cfv
      wceq vy vx cv wral vx cv cale cfv ccrd cfv vx cv cale cfv wceq vx cv wlim
      vy cv cale cfv ccrd cfv vy cv cale cfv wceq vy vx cv wral wa vy vx cv vy
      cv cale cfv ciun ccrd cfv vy vx cv vy cv cale cfv ciun vx cv cale cfv
      ccrd cfv vx cv cale cfv vy cv cale cfv ccrd cfv vy cv cale cfv wceq vy vx
      cv wral vy vx cv vy cv cale cfv ciun ccrd cfv vy vx cv vy cv cale cfv
      ciun wceq vx cv wlim vx cv cvv wcel vy cv cale cfv ccrd cfv vy cv cale
      cfv wceq vy vx cv wral vy vx cv vy cv cale cfv ciun ccrd cfv vy vx cv vy
      cv cale cfv ciun wceq wi vx visset vy vx cv vy cv cale cfv cvv cardiun
      ax-mp adantl vx cv wlim vy cv cale cfv ccrd cfv vy cv cale cfv wceq vy vx
      cv wral wa vx cv cale cfv vy vx cv vy cv cale cfv ciun ccrd vx cv wlim vx
      cv cale cfv vy vx cv vy cv cale cfv ciun wceq vy cv cale cfv ccrd cfv vy
      cv cale cfv wceq vy vx cv wral vx cv cvv wcel vx cv wlim vx cv cale cfv
      vy vx cv vy cv cale cfv ciun wceq vx visset vy vx cv cvv alephlim mpan
      adantr fveq2d vx cv wlim vx cv cale cfv vy vx cv vy cv cale cfv ciun wceq
      vy cv cale cfv ccrd cfv vy cv cale cfv wceq vy vx cv wral vx cv cvv wcel
      vx cv wlim vx cv cale cfv vy vx cv vy cv cale cfv ciun wceq vx visset vy
      vx cv cvv alephlim mpan adantr 3eqtr4d ex tfinds cA con0 wcel wn c0 ccrd
      cfv c0 cA cale cfv ccrd cfv cA cale cfv card0 cA con0 wcel wn cA cale cfv
      c0 ccrd cA con0 wcel wn cA cale cdm wcel wn cA cale cfv c0 wceq cA cale
      cdm wcel cA con0 wcel cale cdm con0 cA cale con0 wfn cale cdm con0 wceq
      alephfnon con0 cale fndm ax-mp eleq2i notbii cA cale ndmfv sylbir fveq2d
      cA con0 wcel wn cA cale cdm wcel wn cA cale cfv c0 wceq cA cale cdm wcel
      cA con0 wcel cale cdm con0 cA cale con0 wfn cale cdm con0 wceq alephfnon
      con0 cale fndm ax-mp eleq2i notbii cA cale ndmfv sylbir 3eqtr4a pm2.61i
      $.
      $( [22-Jan-2004] $) $( [25-Oct-2003] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( No cardinal can be sandwiched between an aleph and its successor aleph.
       Theorem 67 of [Suppes] p. 229. $)
    alephnbtwn $p |- ( ( card ` B ) = B ->
                   -. ( ( aleph ` A ) e. B /\ B e. ( aleph ` suc A ) ) ) $=
      cA con0 wcel cB ccrd cfv cB wceq cA cale cfv cB wcel cB cA csuc cale cfv
      wcel wa wn wi cA con0 wcel cB ccrd cfv cB wceq cA cale cfv cB wcel cB cA
      csuc cale cfv wcel wa wn cA con0 wcel cB ccrd cfv cB wceq wa cA cale cfv
      cB wcel cB cA csuc cale cfv wcel wn wi cA cale cfv cB wcel cB cA csuc
      cale cfv wcel wa wn cA con0 wcel cB ccrd cfv cB wceq wa cA cale cfv cB
      wcel cA cale cfv cB csdm wbr cB cA csuc cale cfv wcel wn cB ccrd cfv cB
      wceq cA cale cfv cB csdm wbr cA cale cfv cB wcel wb cA con0 wcel cB ccrd
      cfv cB wceq cA cale cfv cB ccrd cfv wcel cA cale cfv cB wcel cA cale cfv
      cB csdm wbr cB ccrd cfv cB cA cale cfv eleq2 cA cale cfv con0 wcel cA
      cale cfv cB csdm wbr cA cale cfv cB ccrd cfv wcel wb cA alephon cA cale
      cfv cB cardsdomel ax-mp syl5bb adantl cA con0 wcel cB con0 wcel cA cale
      cfv cB csdm wbr cB cA csuc cale cfv wcel wn wi cB ccrd cfv cB wceq cA
      con0 wcel cB con0 wcel wa cB cA csuc cale cfv wcel cA cale cfv cB csdm
      wbr cA con0 wcel cB cA csuc cale cfv wcel cB cA cale cfv vx cv csdm wbr
      vx con0 crab cint wcel cB con0 wcel cA cale cfv cB csdm wbr wn cA con0
      wcel cB cA csuc cale cfv wcel cB cA cale cfv vx cv csdm wbr vx con0 crab
      cint wcel cA con0 wcel cA csuc cale cfv cA cale cfv vx cv csdm wbr vx
      con0 crab cint cB vx cA alephsuc eleq2d biimpd cA cale cfv vx cv csdm wbr
      cA cale cfv cB csdm wbr vx cB vx cv cB cA cale cfv csdm breq2 onnminsb
      sylan9 con2d cB ccrd cfv cB wceq cB ccrd cfv con0 wcel cB con0 wcel cB
      cardon cB ccrd cfv cB con0 eleq1 mpbii sylan2 sylbird cA cale cfv cB wcel
      cB cA csuc cale cfv wcel imnan sylib ex cA con0 wcel wn cA cale cfv cB
      wcel cB cA csuc cale cfv wcel wa wn cB ccrd cfv cB wceq cA cale cfv cB
      wcel cB cA csuc cale cfv wcel wa cA con0 wcel cB cA csuc cale cfv wcel cA
      con0 wcel cA cale cfv cB wcel cB cA csuc cale cfv wcel cA csuc con0 wcel
      cA con0 wcel cB cA csuc cale cfv wcel cA csuc cale cfv c0 wceq cA csuc
      con0 wcel cA csuc cale cfv cB n0i cA csuc con0 wcel wn cA csuc cale cdm
      wcel wn cA csuc cale cfv c0 wceq cA csuc cale cdm wcel cA csuc con0 wcel
      cale cdm con0 cA csuc cale con0 wfn cale cdm con0 wceq alephfnon con0
      cale fndm ax-mp eleq2i notbii cA csuc cale ndmfv sylbir nsyl2 cA sucelon
      sylibr adantl con3i a1d pm2.61i $.
      $( [25-Jan-2004] $) $( [10-Nov-2003] $)
  $}

  $( No set has equinumerosity between an aleph and its successor aleph. $)
  alephnbtwn2 $p |- -. ( ( aleph ` A ) ~< B /\ B ~< ( aleph ` suc A ) ) $=
    cB cvv wcel cA cale cfv cB csdm wbr cB cA csuc cale cfv csdm wbr wa wn cB
    cvv wcel cA cale cfv cB csdm wbr cB cA csuc cale cfv csdm wbr wa cA cale
    cfv cB ccrd cfv wcel cB ccrd cfv cA csuc cale cfv wcel wa cB ccrd cfv ccrd
    cfv cB ccrd cfv wceq cA cale cfv cB ccrd cfv wcel cB ccrd cfv cA csuc cale
    cfv wcel wa wn cB cardidm cA cB ccrd cfv alephnbtwn ax-mp cB cvv wcel cA
    cale cfv cB csdm wbr cA cale cfv cB ccrd cfv wcel cB cA csuc cale cfv csdm
    wbr cB ccrd cfv cA csuc cale cfv wcel cA cale cfv cB csdm wbr cA cale cfv
    cB ccrd cfv wcel wb cB cvv wcel cA cale cfv con0 wcel cA cale cfv cB csdm
    wbr cA cale cfv cB ccrd cfv wcel wb cA alephon cA cale cfv cB cardsdomel
    ax-mp a1i cB cvv wcel cB ccrd cfv cA csuc cale cfv ccrd cfv wcel cB cA csuc
    cale cfv csdm wbr cB ccrd cfv cA csuc cale cfv wcel cB cvv wcel cA csuc
    cale cfv con0 wcel cB ccrd cfv cA csuc cale cfv ccrd cfv wcel cB cA csuc
    cale cfv csdm wbr wb cA csuc alephon cB cA csuc cale cfv cvv con0 cardsdom
    mpan2 cA csuc cale cfv ccrd cfv cA csuc cale cfv cB ccrd cfv cA csuc
    alephcard eleq2i syl5rbbr anbi12d mtbiri cA cale cfv cB csdm wbr cB cA csuc
    cale cfv csdm wbr wa cB cvv wcel cB cA csuc cale cfv csdm wbr cB cvv wcel
    cA cale cfv cB csdm wbr cB cA csuc cale cfv csdm relsdom brrelexi adantl
    con3i pm2.61i $.
    $( [8-Feb-2004] $) $( [3-Nov-2003] $)

  $( The power set of an aleph dominates the successor aleph.  (The
     Generalized Continuum Hypothesis says they are equinumerous.) $)
  alephsucpw $p |- ( aleph ` suc A ) ~<_ ~P ( aleph ` A ) $=
    cA csuc cale cfv cA cale cfv cpw cdom wbr cA cale cfv cpw cA csuc cale cfv
    csdm wbr wn cA cale cfv cA cale cfv cpw csdm wbr cA cale cfv cpw cA csuc
    cale cfv csdm wbr wn cA cale cfv cA cale fvex canth2 cA cale cfv cA cale
    cfv cpw csdm wbr cA cale cfv cpw cA csuc cale cfv csdm wbr wn wi cA cale
    cfv cA cale cfv cpw csdm wbr cA cale cfv cpw cA csuc cale cfv csdm wbr wa
    wn cA cA cale cfv cpw alephnbtwn2 cA cale cfv cA cale cfv cpw csdm wbr cA
    cale cfv cpw cA csuc cale cfv csdm wbr imnan mpbir ax-mp cA csuc cale cfv
    cvv wcel cA cale cfv cpw cvv wcel cA csuc cale cfv cA cale cfv cpw cdom wbr
    cA cale cfv cpw cA csuc cale cfv csdm wbr wn wb cA csuc cale fvex cA cale
    cfv cA cale fvex pwex cA csuc cale cfv cA cale cfv cpw cvv cvv domtri mp2an
    mpbir $.
    $( [29-Aug-2005] $) $( [27-Aug-2005] $)

  $( The set exponentiation of 2 to the aleph-zero has cardinality of at least
     aleph-one.  (If we were to assume the Continuum Hypothesis, their
     cardinalities would be the same.) $)
  aleph1 $p |- ( aleph ` 1o ) ~<_ ( 2o ^m ( aleph ` (/) ) ) $=
    c1o cale cfv c0 csuc cale cfv c2o c0 cale cfv cm co cdom c1o c0 csuc cale
    df-1o fveq2i c0 csuc cale cfv c0 cale cfv cpw cdom wbr c0 csuc cale cfv c2o
    c0 cale cfv cm co cdom wbr c0 alephsucpw c2o c0 cale cfv cm co cvv wcel c0
    cale cfv cpw c2o c0 cale cfv cm co cen wbr c0 csuc cale cfv c0 cale cfv cpw
    cdom wbr c0 csuc cale cfv c2o c0 cale cfv cm co cdom wbr wb c2o c0 cale cfv
    cm oprex c0 cale cfv c0 cale fvex pw2en c0 cale cfv cpw c2o c0 cale cfv cm
    co c0 csuc cale cfv cvv domen2 mp2an mpbi eqbrtri $.
    $( [8-Jul-2004] $) $( [7-Jul-2004] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( Lemma for ~ alephordi . $)
    alephordlem1 $p |- ( A e. On -> ( aleph ` A ) ~< ( aleph ` suc A ) ) $=
      cA con0 wcel cA cale cfv vx cv csdm wbr vx con0 crab cint cA csuc cale
      cfv cA cale cfv csdm vx cA alephsuc cA cale cfv vx cv csdm wbr vx con0
      wrex cA cale cfv cA cale cfv vx cv csdm wbr vx con0 crab cint csdm wbr cA
      cale cfv con0 wcel cA cale cfv vx cv csdm wbr vx con0 wrex cA alephon vx
      cA cale cfv con0 numthcor ax-mp cA cale cfv vx cv csdm wbr cA cale cfv cA
      cale cfv vx cv csdm wbr vx con0 crab cint csdm wbr vx vx vy cA cale cfv
      cA cale cfv vx cv csdm wbr vx con0 crab cint csdm vy cv cA cale cfv wcel
      vx ax-17 vy cv csdm wcel vx ax-17 vx vy cA cale cfv vx cv csdm wbr vx
      con0 crab cA cale cfv vx cv csdm wbr vx vy con0 hbrab1 hbint hbbr vx cv
      cA cale cfv vx cv csdm wbr vx con0 crab cint cA cale cfv csdm breq2
      onminsb ax-mp syl5breqr $.
      $( [9-Feb-2004] $) $( [26-Oct-2003] $)

    $( Lemma for ~ alephordi . $)
    alephordlem2 $p |- ( ( B e. _V /\ Lim B ) ->
                       ( A e. B -> ( aleph ` A ) ~<_ ( aleph ` B ) ) ) $=
      cB cvv wcel cB wlim wa cA cB wcel cA cale cfv cB cale cfv wss cA cale cfv
      cB cale cfv cdom wbr cB cvv wcel cB wlim wa cA cale cfv cB cale cfv wss
      cA cale cfv vx cB vx cv cale cfv ciun wss cA cB wcel cB cvv wcel cB wlim
      wa cB cale cfv vx cB vx cv cale cfv ciun cA cale cfv vx cB cvv alephlim
      sseq2d vx cB vx cv cale cfv cA cA cale cfv vx cv cA cale fveq2 ssiun2s
      syl5bir cA cale cfv con0 wcel cA cale cfv cB cale cfv wss cA cale cfv cB
      cale cfv cdom wbr wi cA alephon cA cale cfv cB cale cfv con0 ssdomg ax-mp
      syl6 $.
      $( [9-Feb-2004] $) $( [26-Oct-2003] $)

    $( Strict ordering property of the aleph function. $)
    alephordi $p |- ( B e. On ->
                    ( A e. B -> ( aleph ` A ) ~< ( aleph ` B ) ) ) $=
      cA vx cv wcel cA cale cfv vx cv cale cfv csdm wbr wi cA c0 wcel cA cale
      cfv c0 cale cfv csdm wbr wi cA vy cv wcel cA cale cfv vy cv cale cfv csdm
      wbr wi cA vy cv csuc wcel cA cale cfv vy cv csuc cale cfv csdm wbr wi cA
      cB wcel cA cale cfv cB cale cfv csdm wbr wi vx vy cB vx cv c0 wceq cA vx
      cv wcel cA c0 wcel cA cale cfv vx cv cale cfv csdm wbr cA cale cfv c0
      cale cfv csdm wbr vx cv c0 cA eleq2 vx cv c0 wceq vx cv cale cfv c0 cale
      cfv cA cale cfv csdm vx cv c0 cale fveq2 breq2d imbi12d vx cv vy cv wceq
      cA vx cv wcel cA vy cv wcel cA cale cfv vx cv cale cfv csdm wbr cA cale
      cfv vy cv cale cfv csdm wbr vx cv vy cv cA eleq2 vx cv vy cv wceq vx cv
      cale cfv vy cv cale cfv cA cale cfv csdm vx cv vy cv cale fveq2 breq2d
      imbi12d vx cv vy cv csuc wceq cA vx cv wcel cA vy cv csuc wcel cA cale
      cfv vx cv cale cfv csdm wbr cA cale cfv vy cv csuc cale cfv csdm wbr vx
      cv vy cv csuc cA eleq2 vx cv vy cv csuc wceq vx cv cale cfv vy cv csuc
      cale cfv cA cale cfv csdm vx cv vy cv csuc cale fveq2 breq2d imbi12d vx
      cv cB wceq cA vx cv wcel cA cB wcel cA cale cfv vx cv cale cfv csdm wbr
      cA cale cfv cB cale cfv csdm wbr vx cv cB cA eleq2 vx cv cB wceq vx cv
      cale cfv cB cale cfv cA cale cfv csdm vx cv cB cale fveq2 breq2d imbi12d
      cA c0 wcel cA cale cfv c0 cale cfv csdm wbr cA noel pm2.21i vy cv con0
      wcel cA vy cv csuc wcel cA vy cv wcel cA cale cfv vy cv cale cfv csdm wbr
      wi cA cale cfv vy cv csuc cale cfv csdm wbr vy cv con0 wcel cA vy cv wcel
      cA vy cv wceq wo cA vy cv wcel cA cale cfv vy cv cale cfv csdm wbr wi cA
      cale cfv vy cv csuc cale cfv csdm wbr wi cA vy cv csuc wcel vy cv con0
      wcel cA vy cv wcel cA vy cv wcel cA cale cfv vy cv cale cfv csdm wbr wi
      cA cale cfv vy cv csuc cale cfv csdm wbr wi cA vy cv wceq vy cv con0 wcel
      cA vy cv wcel cA cale cfv vy cv cale cfv csdm wbr wi cA vy cv wcel cA
      cale cfv vy cv csuc cale cfv csdm wbr vy cv con0 wcel cA cale cfv vy cv
      cale cfv csdm wbr cA cale cfv vy cv csuc cale cfv csdm wbr cA vy cv wcel
      cA cale cfv vy cv cale cfv csdm wbr vy cv con0 wcel cA cale cfv vy cv
      csuc cale cfv csdm wbr cA cale cfv vy cv cale cfv csdm wbr vy cv cale cfv
      vy cv csuc cale cfv csdm wbr cA cale cfv vy cv csuc cale cfv csdm wbr vy
      cv con0 wcel cA cale cfv vy cv cale cfv vy cv csuc cale cfv sdomtr vy cv
      alephordlem1 sylan2 expcom imim2d com23 cA vy cv wceq cA vy cv wcel cA
      cale cfv vy cv cale cfv csdm wbr wi vy cv con0 wcel cA cale cfv vy cv
      csuc cale cfv csdm wbr cA vy cv wceq vy cv con0 wcel cA cale cfv vy cv
      csuc cale cfv csdm wbr wi cA vy cv wcel cA cale cfv vy cv cale cfv csdm
      wbr wi cA vy cv wceq cA cale cfv vy cv csuc cale cfv csdm wbr vy cv cale
      cfv vy cv csuc cale cfv csdm wbr vy cv con0 wcel cA vy cv wceq cA cale
      cfv vy cv cale cfv vy cv csuc cale cfv csdm cA vy cv cale fveq2 breq1d vy
      cv alephordlem1 syl5bir a1d com3r jaod vy cv cA vy visset elsuc2 syl5ib
      com23 vx cv wlim cA vx cv wcel cA cale cfv vx cv cale cfv csdm wbr wi cA
      vy cv wcel cA cale cfv vy cv cale cfv csdm wbr wi vy vx cv wral vx cv
      wlim cA vx cv wcel cA cale cfv vx cv cale cfv cdom wbr cA cale cfv vx cv
      cale cfv cen wbr wn wa cA cale cfv vx cv cale cfv csdm wbr vx cv wlim cA
      vx cv wcel cA cale cfv vx cv cale cfv cdom wbr cA cale cfv vx cv cale cfv
      cen wbr wn vx cv wlim cA vx cv wcel cA cale cfv vx cv cale cfv wss cA
      cale cfv vx cv cale cfv cdom wbr vx cv wlim cA cale cfv vx cv cale cfv
      wss cA cale cfv vy vx cv vy cv cale cfv ciun wss cA vx cv wcel vx cv wlim
      vx cv cale cfv vy vx cv vy cv cale cfv ciun cA cale cfv vx cv cvv wcel vx
      cv wlim vx cv cale cfv vy vx cv vy cv cale cfv ciun wceq vx visset vy vx
      cv cvv alephlim mpan sseq2d vy vx cv vy cv cale cfv cA cA cale cfv vy cv
      cA cale fveq2 ssiun2s syl5bir cA cale cfv con0 wcel cA cale cfv vx cv
      cale cfv wss cA cale cfv vx cv cale cfv cdom wbr wi cA alephon cA cale
      cfv vx cv cale cfv con0 ssdomg ax-mp syl6 vx cv wlim cA vx cv wcel cA
      cale cfv vx cv cale cfv cen wbr wn vx cv wlim cA vx cv wcel wa cA cale
      cfv vx cv cale cfv cen wbr vx cv cale cfv cA csuc cale cfv csdm wbr vx cv
      wlim cA vx cv wcel wa cA csuc cale cfv vx cv cale cfv cdom wbr vx cv cale
      cfv cA csuc cale cfv csdm wbr wn vx cv wlim cA vx cv wcel cA csuc cale
      cfv vx cv cale cfv cdom wbr vx cv wlim cA vx cv wcel cA csuc vx cv wcel
      cA csuc cale cfv vx cv cale cfv cdom wbr vx cv cA limsuc vx cv cvv wcel
      vx cv wlim cA csuc vx cv wcel cA csuc cale cfv vx cv cale cfv cdom wbr wi
      vx visset cA csuc vx cv alephordlem2 mpan sylbid imp cA csuc cale cfv vx
      cv cale cfv domnsym syl cA cale cfv vx cv cale cfv cen wbr cA con0 wcel
      vx cv cale cfv cA csuc cale cfv csdm wbr vx cv wlim cA vx cv wcel wa cA
      cale cfv vx cv cale cfv cen wbr cA cale cfv cA csuc cale cfv csdm wbr vx
      cv cale cfv cA csuc cale cfv csdm wbr cA con0 wcel cA cale cfv vx cv cale
      cfv cen wbr vx cv cale cfv cA cale cfv cen wbr cA cale cfv cA csuc cale
      cfv csdm wbr vx cv cale cfv cA csuc cale cfv csdm wbr wi cA cale cfv vx
      cv cale cfv vx cv cale fvex ensym vx cv cale cfv cA cale cfv cen wbr cA
      cale cfv cA csuc cale cfv csdm wbr vx cv cale cfv cA csuc cale cfv csdm
      wbr vx cv cale cfv cA cale cfv cA csuc cale cfv ensdomtr ex syl cA
      alephordlem1 syl5 vx cv con0 wcel cA vx cv wcel cA con0 wcel vx cv wlim
      vx cv cA onelon vx cv cvv wcel vx cv wlim vx cv con0 wcel vx visset vx cv
      cvv limelon mpan sylan syl5com mtod ex jcad cA cale cfv vx cv cale cfv
      brsdom syl6ibr a1d tfinds $.
      $( [9-Feb-2004] $) $( [26-Oct-2003] $)
  $}

  $( Ordering property of the aleph function. $)
  alephord $p |- ( ( A e. On /\ B e. On ) ->
                 ( A e. B <-> ( aleph ` A ) ~< ( aleph ` B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale cfv csdm wbr cB
    con0 wcel cA cB wcel cA cale cfv cB cale cfv csdm wbr wi cA con0 wcel cA cB
    alephordi adantl cA con0 wcel cB con0 wcel wa cA cale cfv cB cale cfv cdom
    wbr cA cale cfv cB cale cfv cen wbr wn wa cA cB wcel cA cale cfv cB cale
    cfv csdm wbr cA con0 wcel cB con0 wcel wa cA cale cfv cB cale cfv cdom wbr
    cA cale cfv cB cale cfv cen wbr wn wa cA cB wss cA cB wne wa cA cB wcel cA
    con0 wcel cB con0 wcel wa cA cale cfv cB cale cfv cdom wbr cA cB wss cA
    cale cfv cB cale cfv cen wbr wn cA cB wne cA con0 wcel cB con0 wcel wa cA
    cale cfv cB cale cfv cdom wbr cB cA wcel wn cA cB wss cA con0 wcel cA cale
    cfv cB cale cfv cdom wbr cB cA wcel wn wi cB con0 wcel cA con0 wcel cB cale
    cfv cA cale cfv csdm wbr wn cB cA wcel wn cA cale cfv cB cale cfv cdom wbr
    cA con0 wcel cB cA wcel cB cale cfv cA cale cfv csdm wbr cB cA alephordi
    con3d cA cale cfv con0 wcel cB cale cfv con0 wcel cA cale cfv cB cale cfv
    cdom wbr cB cale cfv cA cale cfv csdm wbr wn wb cA alephon cB alephon cA
    cale cfv cB cale cfv con0 con0 domtri mp2an syl5ib adantr cA cB ontri1
    sylibrd cA cale cfv cB cale cfv cen wbr wn cA cB wne wi cA con0 wcel cB
    con0 wcel wa cA cale cfv cB cale cfv cen wbr cA cB cA cB wceq cA cale cfv
    cB cale cfv wceq cA cale cfv cB cale cfv cen wbr cA cB cale fveq2 cA cale
    cfv con0 wcel cA cale cfv cB cale cfv wceq cA cale cfv cB cale cfv cen wbr
    wi cA alephon cA cale cfv cB cale cfv con0 eqeng ax-mp syl necon3bi a1i
    anim12d cA cB onelpss sylibrd cA cale cfv cB cale cfv brsdom syl5ib impbid
    $.
    $( [10-Feb-2004] $) $( [26-Oct-2003] $)

  $( Ordering property of the aleph function.  Theorem 8A(a) of [Enderton]
     p. 213 and its converse. $)
  alephord2 $p |- ( ( A e. On /\ B e. On ) ->
                  ( A e. B <-> ( aleph ` A ) e. ( aleph ` B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale cfv csdm wbr cA
    cale cfv cB cale cfv wcel cA cB alephord cA cale cfv cB cale cfv csdm wbr
    cA cale cfv cB cale cfv ccrd cfv wcel cA cale cfv cB cale cfv wcel cA cale
    cfv con0 wcel cA cale cfv cB cale cfv csdm wbr cA cale cfv cB cale cfv ccrd
    cfv wcel wb cA alephon cA cale cfv cB cale cfv cardsdomel ax-mp cB cale cfv
    ccrd cfv cB cale cfv cA cale cfv cB alephcard eleq2i bitri syl6bb $.
    $( [11-Feb-2004] $) $( [3-Nov-2003] $)

  $( Ordering property of the aleph function.  Theorem 66 of [Suppes]
     p. 229. $)
  alephord2i $p |- ( B e. On ->
                   ( A e. B -> ( aleph ` A ) e. ( aleph ` B ) ) ) $=
    cB con0 wcel cA cB wcel cA cale cfv cB cale cfv wcel cA con0 wcel cB con0
    wcel cA cB wcel wa cA cale cfv cB cale cfv wcel cB cA onelon cA con0 wcel
    cB con0 wcel cA cB wcel cA cale cfv cB cale cfv wcel cA con0 wcel cB con0
    wcel wa cA cB wcel cA cale cfv cB cale cfv wcel cA cB alephord2 biimpd
    expimpd mpcom ex $.
    $( [26-Feb-2004] $) $( [25-Oct-2003] $)

  $( Ordering property of the aleph function. $)
  alephord3 $p |- ( ( A e. On /\ B e. On ) ->
                  ( A C_ B <-> ( aleph ` A ) C_ ( aleph ` B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cB cA wcel wn cB cale cfv cA cale cfv wcel wn
    cA cB wss cA cale cfv cB cale cfv wss cA con0 wcel cB con0 wcel wa cB cA
    wcel cB cale cfv cA cale cfv wcel cB con0 wcel cA con0 wcel cB cA wcel cB
    cale cfv cA cale cfv wcel wb cB cA alephord2 ancoms notbid cA cB ontri1 cA
    cale cfv cB cale cfv wss cB cale cfv cA cale cfv wcel wn wb cA con0 wcel cB
    con0 wcel wa cA cale cfv con0 wcel cB cale cfv con0 wcel cA cale cfv cB
    cale cfv wss cB cale cfv cA cale cfv wcel wn wb cA alephon cB alephon cA
    cale cfv cB cale cfv ontri1 mp2an a1i 3bitr4d $.
    $( [12-Feb-2004] $) $( [11-Nov-2003] $)

  $( The aleph function is one-to-one. $)
  aleph11 $p |- ( ( A e. On /\ B e. On ) ->
                ( ( aleph ` A ) = ( aleph ` B ) <-> A = B ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB wceq cA cale cfv cB cale cfv wceq cA
    con0 wcel cB con0 wcel wa cA cB wss cB cA wss wa cA cale cfv cB cale cfv
    wss cB cale cfv cA cale cfv wss wa cA cB wceq cA cale cfv cB cale cfv wceq
    cA con0 wcel cB con0 wcel wa cA cB wss cA cale cfv cB cale cfv wss cB cA
    wss cB cale cfv cA cale cfv wss cA cB alephord3 cB con0 wcel cA con0 wcel
    cB cA wss cB cale cfv cA cale cfv wss wb cB cA alephord3 ancoms anbi12d cA
    cB eqss cA cale cfv cB cale cfv eqss 3bitr4g bicomd $.
    $( [29-Aug-2004] $) $( [3-Aug-2004] $)

  $( A set dominated by an aleph is strictly dominated by its successor
     aleph and vice-versa. $)
  alephsucdom $p |- ( B e. On ->
                    ( A ~<_ ( aleph ` B ) <-> A ~< ( aleph ` suc B ) ) ) $=
    cA cvv wcel cB con0 wcel cA cB cale cfv cdom wbr cA cB csuc cale cfv csdm
    wbr wb wi cA cvv wcel cB con0 wcel cA cB cale cfv cdom wbr cA cB csuc cale
    cfv csdm wbr wb cA cvv wcel cB con0 wcel wa cA cB cale cfv cdom wbr cA cB
    csuc cale cfv csdm wbr cB con0 wcel cA cB cale cfv cdom wbr cA cB csuc cale
    cfv csdm wbr wi cA cvv wcel cA cB cale cfv cdom wbr cB cale cfv cB csuc
    cale cfv csdm wbr cA cB csuc cale cfv csdm wbr cB con0 wcel cA cB cale cfv
    cdom wbr cB cale cfv cB csuc cale cfv csdm wbr cA cB csuc cale cfv csdm wbr
    cA cB cale cfv cB csuc cale cfv domsdomtr ex cB alephordlem1 syl5com adantl
    cA cvv wcel cA cB csuc cale cfv csdm wbr cA cB cale cfv cdom wbr wi cB con0
    wcel cA cvv wcel cA cB cale cfv cdom wbr cB cale cfv cA csdm wbr wn cA cB
    csuc cale cfv csdm wbr cA cvv wcel cB cale cfv cvv wcel cA cB cale cfv cdom
    wbr cB cale cfv cA csdm wbr wn wb cB cale fvex cA cB cale cfv cvv cvv
    domtri mpan2 cB cale cfv cA csdm wbr cA cB csuc cale cfv csdm wbr cB cale
    cfv cA csdm wbr cA cB csuc cale cfv csdm wbr wn wi cB cale cfv cA csdm wbr
    cA cB csuc cale cfv csdm wbr wa wn cB cA alephnbtwn2 cB cale cfv cA csdm
    wbr cA cB csuc cale cfv csdm wbr imnan mpbir con2i syl5bir adantr impbid ex
    cA cvv wcel wn cA cB cale cfv cdom wbr cA cB csuc cale cfv csdm wbr wb cB
    con0 wcel cA cB cale cfv cdom wbr cA cvv wcel cA cB csuc cale cfv csdm wbr
    cA cB cale cfv cdom reldom brrelexi cA cB csuc cale cfv csdm relsdom
    brrelexi pm5.21ni a1d pm2.61i $.
    $( [11-Feb-2004] $) $( [3-Nov-2003] $)

  ${
    $d x A $.
    $( An alternate representation of a successor aleph.  Using this theorem
       we could define the aleph function with ` { z e. On | z ~<_ x } `
       in place of ` |^| { z e. On | x ~< z } ` in ~ df-aleph . $)
    alephsuc2 $p |- ( A e. On ->
                ( aleph ` suc A ) = { x e. On | x ~<_ ( aleph ` A ) } ) $=
      cA con0 wcel vx cv cA cale cfv cdom wbr vx con0 crab vx cv cA csuc cale
      cfv csdm wbr vx con0 crab cA csuc cale cfv cA con0 wcel vx cv cA cale cfv
      cdom wbr vx cv cA csuc cale cfv csdm wbr vx con0 vx cv cA alephsucdom
      rabbisdv cA csuc cale cfv ccrd cfv cA csuc cale cfv vx cv cA csuc cale
      cfv csdm wbr vx con0 crab cA csuc alephcard vx cA csuc cale cfv cardval2
      eqtr3i syl6reqr $.
      $( [13-Feb-2004] $) $( [3-Nov-2003] $)
  $}

  $( Every aleph is greater than or equal to the set of natural numbers. $)
  alephgeom $p |- ( A e. On <-> om C_ ( aleph ` A ) ) $=
    cA con0 wcel com cA cale cfv wss cA con0 wcel c0 cale cfv cA cale cfv com
    cA con0 wcel c0 cA wss c0 cale cfv cA cale cfv wss cA 0ss c0 con0 wcel cA
    con0 wcel c0 cA wss c0 cale cfv cA cale cfv wss wb 0elon c0 cA alephord3
    mpan mpbii aleph0 syl5ssr com cA cale cfv wss cA cale cdm con0 cA cale cdm
    wcel com cA cale cfv wss cA cale cdm wcel wn com cA cale cfv wss com c0 wss
    c0 com wcel com c0 wss wn peano1 com c0 wss c0 com wcel com word c0 word
    com c0 wss c0 com wcel wn wb ordom ord0 com c0 ordtri1 mp2an con2bii mpbi
    cA cale cdm wcel wn cA cale cfv c0 com cA cale ndmfv sseq2d mtbiri con4i
    cale con0 wfn cale cdm con0 wceq alephfnon con0 cale fndm ax-mp syl6eleq
    impbii $.
    $( [18-Feb-2004] $) $( [11-Nov-2003] $)

  $( Every aleph is a limit ordinal. $)
  alephislim $p |- ( A e. On <-> Lim ( aleph ` A ) ) $=
    cA con0 wcel com cA cale cfv wss cA cale cfv wlim cA alephgeom com cA cale
    cfv ccrd cfv wss cA cale cfv ccrd cfv wlim com cA cale cfv wss cA cale cfv
    wlim cA cale cfv cardlim cA cale cfv ccrd cfv cA cale cfv com cA alephcard
    sseq2i cA cale cfv ccrd cfv cA cale cfv wceq cA cale cfv ccrd cfv wlim cA
    cale cfv wlim wb cA alephcard cA cale cfv ccrd cfv cA cale cfv limeq ax-mp
    3bitr3i bitri $.
    $( [4-Jun-2004] $) $( [11-Nov-2003] $)

  ${
    $d x y A $.
    $( The argument of the aleph function is less than or equal to its value.
       Exercise 2 of [TakeutiZaring] p. 91.  (Later, in ~ alephfp2 , we will
       that equality can sometimes hold.) $)
    alephle $p |- ( A e. On -> A C_ ( aleph ` A ) ) $=
      vx cv vx cv cale cfv wss vy cv vy cv cale cfv wss cA cA cale cfv wss vx
      vy cA vx cv vy cv wceq vx cv vy cv vx cv cale cfv vy cv cale cfv vx cv vy
      cv wceq id vx cv vy cv cale fveq2 sseq12d vx cv cA wceq vx cv cA vx cv
      cale cfv cA cale cfv vx cv cA wceq id vx cv cA cale fveq2 sseq12d vx cv
      con0 wcel vy cv vy cv cale cfv wss vy vx cv wral vy cv vx cv cale cfv
      wcel vy vx cv wral vx cv vx cv cale cfv wss vx cv con0 wcel vy cv vy cv
      cale cfv wss vy cv vx cv cale cfv wcel vy vx cv vx cv con0 wcel vy cv vx
      cv wcel wa vy cv vy cv cale cfv wss vy cv cale cfv vx cv cale cfv wcel vy
      cv vx cv cale cfv wcel vx cv con0 wcel vy cv vx cv wcel vy cv cale cfv vx
      cv cale cfv wcel vy cv vx cv alephord2i imp vy cv con0 wcel vx cv cale
      cfv con0 wcel vy cv vy cv cale cfv wss vy cv cale cfv vx cv cale cfv wcel
      wa vy cv vx cv cale cfv wcel wi vx cv con0 wcel vy cv vx cv wcel wa vy cv
      vy cv cale cfv vx cv cale cfv ontr2 vx cv vy cv onelon vx cv alephon
      sylancl mpan2d r19.20dva vx cv con0 wcel vx cv vx cv cale cfv wss vx cv
      cale cfv vx cv wcel wn vy cv vx cv cale cfv wcel vy vx cv wral vx cv con0
      wcel vx cv cale cfv con0 wcel vx cv vx cv cale cfv wss vx cv cale cfv vx
      cv wcel wn wb vx cv alephon vx cv vx cv cale cfv ontri1 mpan2 vy cv vx cv
      cale cfv wcel vy vx cv wral vx cv cale cfv vx cv wcel vx cv cale cfv vx
      cv cale cfv wcel vx cv cale cfv elirr vy cv vx cv cale cfv wcel vx cv
      cale cfv vx cv cale cfv wcel vy vx cv cale cfv vx cv vy cv vx cv cale cfv
      vx cv cale cfv eleq1 rcla4cv mtoi syl5bir syld tfis3 $.
      $( [26-Feb-2004] $) $( [9-Nov-2003] $)

    $( Given any transfinite cardinal number ` A ` , there is exactly one aleph
       that is equal to it.  Here we compute that aleph _explicitly_. $)
    cardaleph $p |- ( ( om C_ A /\ ( card ` A ) = A ) ->
                  A = ( aleph ` |^| { x e. On | A C_ ( aleph ` x ) } ) ) $=
      com cA wss cA ccrd cfv cA wceq wa cA vx cv cale cfv wss vx con0 crab cint
      c0 wceq cA vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq vy con0
      wrex cA vx cv cale cfv wss vx con0 crab cint wlim wo wo cA cA vx cv cale
      cfv wss vx con0 crab cint cale cfv wceq cA ccrd cfv cA wceq cA vx cv cale
      cfv wss vx con0 crab cint c0 wceq cA vx cv cale cfv wss vx con0 crab cint
      vy cv csuc wceq vy con0 wrex cA vx cv cale cfv wss vx con0 crab cint wlim
      wo wo com cA wss cA ccrd cfv cA wceq cA con0 wcel cA vx cv cale cfv wss
      vx con0 crab cint con0 wcel cA vx cv cale cfv wss vx con0 crab cint c0
      wceq cA vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq vy con0 wrex
      cA vx cv cale cfv wss vx con0 crab cint wlim wo wo cA ccrd cfv cA wceq cA
      ccrd cfv con0 wcel cA con0 wcel cA cardon cA ccrd cfv cA con0 eleq1 mpbii
      cA con0 wcel cA vx cv cale cfv wss vx con0 wrex cA vx cv cale cfv wss vx
      con0 crab cint con0 wcel cA con0 wcel cA cA cale cfv wss cA vx cv cale
      cfv wss vx con0 wrex cA alephle cA vx cv cale cfv wss cA cA cale cfv wss
      vx cA con0 vx cv cA wceq vx cv cale cfv cA cale cfv cA vx cv cA cale
      fveq2 sseq2d rcla4ev mpdan cA vx cv cale cfv wss vx onintrab2 sylib cA vx
      cv cale cfv wss vx con0 crab cint con0 wcel cA vx cv cale cfv wss vx con0
      crab cint word cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA vx cv
      cale cfv wss vx con0 crab cint vy cv csuc wceq vy con0 wrex cA vx cv cale
      cfv wss vx con0 crab cint wlim wo wo cA vx cv cale cfv wss vx con0 crab
      cint eloni cA vx cv cale cfv wss vx con0 crab cint word cA vx cv cale cfv
      wss vx con0 crab cint c0 wceq cA vx cv cale cfv wss vx con0 crab cint vy
      cv csuc wceq vy con0 wrex cA vx cv cale cfv wss vx con0 crab cint wlim
      w3o cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA vx cv cale cfv wss
      vx con0 crab cint vy cv csuc wceq vy con0 wrex cA vx cv cale cfv wss vx
      con0 crab cint wlim wo wo vy cA vx cv cale cfv wss vx con0 crab cint
      ordzsl cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA vx cv cale cfv
      wss vx con0 crab cint vy cv csuc wceq vy con0 wrex cA vx cv cale cfv wss
      vx con0 crab cint wlim 3orass bitri sylib 3syl adantl com cA wss cA ccrd
      cfv cA wceq wa cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA cA vx
      cv cale cfv wss vx con0 crab cint cale cfv wceq cA vx cv cale cfv wss vx
      con0 crab cint vy cv csuc wceq vy con0 wrex cA vx cv cale cfv wss vx con0
      crab cint wlim wo cA ccrd cfv cA wceq com cA wss cA vx cv cale cfv wss vx
      con0 crab cint c0 wceq cA cA vx cv cale cfv wss vx con0 crab cint cale
      cfv wceq wi cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA ccrd cfv
      cA wceq com cA wss wa cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wceq cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA ccrd cfv cA wceq
      com cA wss wa cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wss cA
      vx cv cale cfv wss vx con0 crab cint cale cfv cA wss wa cA cA vx cv cale
      cfv wss vx con0 crab cint cale cfv wceq cA vx cv cale cfv wss vx con0
      crab cint c0 wceq cA ccrd cfv cA wceq cA cA vx cv cale cfv wss vx con0
      crab cint cale cfv wss com cA wss cA vx cv cale cfv wss vx con0 crab cint
      cale cfv cA wss cA ccrd cfv cA wceq cA cA vx cv cale cfv wss vx con0 crab
      cint cale cfv wss wi cA vx cv cale cfv wss vx con0 crab cint c0 wceq cA
      ccrd cfv cA wceq cA con0 wcel cA vx cv cale cfv wss vx con0 wrex cA cA vx
      cv cale cfv wss vx con0 crab cint cale cfv wss cA ccrd cfv cA wceq cA
      ccrd cfv con0 wcel cA con0 wcel cA cardon cA ccrd cfv cA con0 eleq1 mpbii
      cA con0 wcel cA cA cale cfv wss cA vx cv cale cfv wss vx con0 wrex cA
      alephle cA vx cv cale cfv wss cA cA cale cfv wss vx cA con0 vx cv cA wceq
      vx cv cale cfv cA cale cfv cA vx cv cA cale fveq2 sseq2d rcla4ev mpdan cA
      vx cv cale cfv wss cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wss vx vx vy cA cA vx cv cale cfv wss vx con0 crab cint cale cfv vy cv cA
      wcel vx ax-17 vx vy cA vx cv cale cfv wss vx con0 crab cint cale vy cv
      cale wcel vx ax-17 vx vy cA vx cv cale cfv wss vx con0 crab cA vx cv cale
      cfv wss vx vy con0 hbrab1 hbint hbfv hbss vx cv cA vx cv cale cfv wss vx
      con0 crab cint wceq vx cv cale cfv cA vx cv cale cfv wss vx con0 crab
      cint cale cfv cA vx cv cA vx cv cale cfv wss vx con0 crab cint cale fveq2
      sseq2d onminsb 3syl a1i cA vx cv cale cfv wss vx con0 crab cint c0 wceq
      cA vx cv cale cfv wss vx con0 crab cint cale cfv cA wss com cA wss cA vx
      cv cale cfv wss vx con0 crab cint c0 wceq cA vx cv cale cfv wss vx con0
      crab cint cale cfv com cA cA vx cv cale cfv wss vx con0 crab cint c0 wceq
      cA vx cv cale cfv wss vx con0 crab cint cale cfv c0 cale cfv com cA vx cv
      cale cfv wss vx con0 crab cint c0 cale fveq2 aleph0 syl6eq sseq1d biimprd
      anim12d cA cA vx cv cale cfv wss vx con0 crab cint cale cfv eqss syl6ibr
      com12 ancoms cA ccrd cfv cA wceq cA vx cv cale cfv wss vx con0 crab cint
      vy cv csuc wceq vy con0 wrex cA vx cv cale cfv wss vx con0 crab cint wlim
      wo cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wceq wi com cA wss
      cA ccrd cfv cA wceq cA vx cv cale cfv wss vx con0 crab cint vy cv csuc
      wceq vy con0 wrex cA vx cv cale cfv wss vx con0 crab cint wlim wo cA cA
      vx cv cale cfv wss vx con0 crab cint cale cfv wcel wn cA cA vx cv cale
      cfv wss vx con0 crab cint cale cfv wceq cA ccrd cfv cA wceq cA vx cv cale
      cfv wss vx con0 crab cint vy cv csuc wceq vy con0 wrex cA cA vx cv cale
      cfv wss vx con0 crab cint cale cfv wcel wn cA vx cv cale cfv wss vx con0
      crab cint wlim cA ccrd cfv cA wceq cA vx cv cale cfv wss vx con0 crab
      cint vy cv csuc wceq cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wcel wn vy con0 cA ccrd cfv cA wceq vy cv con0 wcel cA vx cv cale cfv wss
      vx con0 crab cint vy cv csuc wceq cA cA vx cv cale cfv wss vx con0 crab
      cint cale cfv wcel wn cA ccrd cfv cA wceq vy cv con0 wcel cA vx cv cale
      cfv wss vx con0 crab cint vy cv csuc wceq wa wa cA cA vx cv cale cfv wss
      vx con0 crab cint cale cfv wcel cA vy cv cale cfv wss vy cv con0 wcel cA
      vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq wa cA vy cv cale cfv
      wss wn cA ccrd cfv cA wceq vy cv con0 wcel cA vx cv cale cfv wss vx con0
      crab cint vy cv csuc wceq cA vy cv cale cfv wss wn vy cv con0 wcel vy cv
      cA vx cv cale cfv wss vx con0 crab cint wcel cA vy cv cale cfv wss wn cA
      vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq cA vx cv cale cfv
      wss cA vy cv cale cfv wss vx vy cv vx cv vy cv wceq vx cv cale cfv vy cv
      cale cfv cA vx cv vy cv cale fveq2 sseq2d onnminsb cA vx cv cale cfv wss
      vx con0 crab cint vy cv csuc wceq vy cv cA vx cv cale cfv wss vx con0
      crab cint wcel vy cv vy cv csuc wcel vy cv vy visset sucid cA vx cv cale
      cfv wss vx con0 crab cint vy cv csuc vy cv eleq2 mpbiri syl5 imp adantl
      vy cv con0 wcel cA vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq
      wa cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wcel cA vy cv cale
      cfv vx cv csdm wbr vx con0 crab cint wcel cA ccrd cfv cA wceq cA vy cv
      cale cfv wss vy cv con0 wcel cA vx cv cale cfv wss vx con0 crab cint vy
      cv csuc wceq wa cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wcel
      cA vy cv cale cfv vx cv csdm wbr vx con0 crab cint wcel vy cv con0 wcel
      cA vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq wa cA vx cv cale
      cfv wss vx con0 crab cint cale cfv vy cv cale cfv vx cv csdm wbr vx con0
      crab cint cA cA vx cv cale cfv wss vx con0 crab cint vy cv csuc wceq vy
      cv con0 wcel cA vx cv cale cfv wss vx con0 crab cint cale cfv vy cv csuc
      cale cfv vy cv cale cfv vx cv csdm wbr vx con0 crab cint cA vx cv cale
      cfv wss vx con0 crab cint vy cv csuc cale fveq2 vx vy cv alephsuc
      sylan9eqr eleq2d biimpd cA ccrd cfv cA wceq cA vy cv cale cfv vx cv csdm
      wbr vx con0 crab cint wcel cA ccrd cfv vy cv cale cfv ccrd cfv wss cA vy
      cv cale cfv wss cA ccrd cfv cA wceq cA con0 wcel cA vy cv cale cfv vx cv
      csdm wbr vx con0 crab cint wcel cA ccrd cfv vy cv cale cfv ccrd cfv wss
      wi cA ccrd cfv cA wceq cA ccrd cfv con0 wcel cA con0 wcel cA cardon cA
      ccrd cfv cA con0 eleq1 mpbii cA con0 wcel cA vy cv cale cfv vx cv csdm
      wbr vx con0 crab cint wcel cA vy cv cale cfv cdom wbr cA ccrd cfv vy cv
      cale cfv ccrd cfv wss cA con0 wcel cA vy cv cale cfv vx cv csdm wbr vx
      con0 crab cint wcel vy cv cale cfv cA csdm wbr wn cA vy cv cale cfv cdom
      wbr vy cv cale cfv vx cv csdm wbr vy cv cale cfv cA csdm wbr vx cA vx cv
      cA vy cv cale cfv csdm breq2 onnminsb cA con0 wcel vy cv cale cfv cvv
      wcel cA vy cv cale cfv cdom wbr vy cv cale cfv cA csdm wbr wn wb vy cv
      cale fvex cA vy cv cale cfv con0 cvv domtri mpan2 sylibrd cA con0 wcel vy
      cv cale cfv cvv wcel cA ccrd cfv vy cv cale cfv ccrd cfv wss cA vy cv
      cale cfv cdom wbr wb vy cv cale fvex cA vy cv cale cfv con0 cvv carddom
      mpan2 sylibrd syl cA ccrd cfv cA wceq cA ccrd cfv vy cv cale cfv ccrd cfv
      wss cA vy cv cale cfv ccrd cfv wss cA vy cv cale cfv wss cA ccrd cfv cA
      vy cv cale cfv ccrd cfv sseq1 vy cv cale cfv ccrd cfv vy cv cale cfv cA
      vy cv alephcard sseq2i syl6bb sylibd sylan9r mtod exp32 r19.23adv cA ccrd
      cfv cA wceq cA con0 wcel cA vx cv cale cfv wss vx con0 crab cint wlim cA
      cA vx cv cale cfv wss vx con0 crab cint cale cfv wcel wn wi cA ccrd cfv
      cA wceq cA ccrd cfv con0 wcel cA con0 wcel cA cardon cA ccrd cfv cA con0
      eleq1 mpbii cA con0 wcel cA vx cv cale cfv wss vx con0 crab cint wlim cA
      cA vx cv cale cfv wss vx con0 crab cint cale cfv wcel wn cA con0 wcel cA
      vx cv cale cfv wss vx con0 crab cint wlim wa cA cA vx cv cale cfv wss vx
      con0 crab cint cale cfv wcel cA vy cv cale cfv wcel vy cA vx cv cale cfv
      wss vx con0 crab cint wrex cA con0 wcel cA vy cv cale cfv wcel vy cA vx
      cv cale cfv wss vx con0 crab cint wrex wn cA vx cv cale cfv wss vx con0
      crab cint wlim cA con0 wcel cA vy cv cale cfv wcel vy cA vx cv cale cfv
      wss vx con0 crab cint cA con0 wcel vy cv cA vx cv cale cfv wss vx con0
      crab cint wcel wa cA vy cv cale cfv wss cA vy cv cale cfv wcel vy cv con0
      wcel cA con0 wcel vy cv cA vx cv cale cfv wss vx con0 crab cint wcel wa
      cA vy cv cale cfv wss wn cA vx cv cale cfv wss vx con0 crab cint con0
      wcel vy cv cA vx cv cale cfv wss vx con0 crab cint wcel vy cv con0 wcel
      cA con0 wcel cA vx cv cale cfv wss vx con0 crab cint vy cv onelon cA con0
      wcel cA vx cv cale cfv wss vx con0 wrex cA vx cv cale cfv wss vx con0
      crab cint con0 wcel cA con0 wcel cA cA cale cfv wss cA vx cv cale cfv wss
      vx con0 wrex cA alephle cA vx cv cale cfv wss cA cA cale cfv wss vx cA
      con0 vx cv cA wceq vx cv cale cfv cA cale cfv cA vx cv cA cale fveq2
      sseq2d rcla4ev mpdan cA vx cv cale cfv wss vx onintrab2 sylib sylan vy cv
      con0 wcel vy cv cA vx cv cale cfv wss vx con0 crab cint wcel cA vy cv
      cale cfv wss wn cA con0 wcel cA vx cv cale cfv wss cA vy cv cale cfv wss
      vx vy cv vx cv vy cv wceq vx cv cale cfv vy cv cale cfv cA vx cv vy cv
      cale fveq2 sseq2d onnminsb adantld mpcom vy cv cale cfv cA vy cv alephon
      onelssi nsyl nrexdv adantr cA con0 wcel cA vx cv cale cfv wss vx con0
      crab cint wlim wa cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wcel cA vy cA vx cv cale cfv wss vx con0 crab cint vy cv cale cfv ciun
      wcel cA vy cv cale cfv wcel vy cA vx cv cale cfv wss vx con0 crab cint
      wrex cA con0 wcel cA vx cv cale cfv wss vx con0 crab cint wlim wa cA vx
      cv cale cfv wss vx con0 crab cint cale cfv vy cA vx cv cale cfv wss vx
      con0 crab cint vy cv cale cfv ciun cA cA vx cv cale cfv wss vx con0 crab
      cint con0 wcel cA vx cv cale cfv wss vx con0 crab cint wlim cA vx cv cale
      cfv wss vx con0 crab cint cale cfv vy cA vx cv cale cfv wss vx con0 crab
      cint vy cv cale cfv ciun wceq cA con0 wcel vy cA vx cv cale cfv wss vx
      con0 crab cint con0 alephlim cA con0 wcel cA vx cv cale cfv wss vx con0
      wrex cA vx cv cale cfv wss vx con0 crab cint con0 wcel cA con0 wcel cA cA
      cale cfv wss cA vx cv cale cfv wss vx con0 wrex cA alephle cA vx cv cale
      cfv wss cA cA cale cfv wss vx cA con0 vx cv cA wceq vx cv cale cfv cA
      cale cfv cA vx cv cA cale fveq2 sseq2d rcla4ev mpdan cA vx cv cale cfv
      wss vx onintrab2 sylib sylan eleq2d vy cA cA vx cv cale cfv wss vx con0
      crab cint vy cv cale cfv eliun syl6bb mtbird ex syl jaod cA ccrd cfv cA
      wceq cA con0 wcel cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wcel wn cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wceq wi cA
      ccrd cfv cA wceq cA ccrd cfv con0 wcel cA con0 wcel cA cardon cA ccrd cfv
      cA con0 eleq1 mpbii cA con0 wcel cA cA vx cv cale cfv wss vx con0 crab
      cint cale cfv wcel cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wceq cA con0 wcel cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wss
      cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wcel cA cA vx cv cale
      cfv wss vx con0 crab cint cale cfv wceq wo cA con0 wcel cA vx cv cale cfv
      wss vx con0 wrex cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wss
      cA con0 wcel cA cA cale cfv wss cA vx cv cale cfv wss vx con0 wrex cA
      alephle cA vx cv cale cfv wss cA cA cale cfv wss vx cA con0 vx cv cA wceq
      vx cv cale cfv cA cale cfv cA vx cv cA cale fveq2 sseq2d rcla4ev mpdan cA
      vx cv cale cfv wss cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wss vx vx vy cA cA vx cv cale cfv wss vx con0 crab cint cale cfv vy cv cA
      wcel vx ax-17 vx vy cA vx cv cale cfv wss vx con0 crab cint cale vy cv
      cale wcel vx ax-17 vx vy cA vx cv cale cfv wss vx con0 crab cA vx cv cale
      cfv wss vx vy con0 hbrab1 hbint hbfv hbss vx cv cA vx cv cale cfv wss vx
      con0 crab cint wceq vx cv cale cfv cA vx cv cale cfv wss vx con0 crab
      cint cale cfv cA vx cv cA vx cv cale cfv wss vx con0 crab cint cale fveq2
      sseq2d onminsb syl cA con0 wcel cA vx cv cale cfv wss vx con0 crab cint
      cale cfv con0 wcel cA cA vx cv cale cfv wss vx con0 crab cint cale cfv
      wss cA cA vx cv cale cfv wss vx con0 crab cint cale cfv wcel cA cA vx cv
      cale cfv wss vx con0 crab cint cale cfv wceq wo wb cA vx cv cale cfv wss
      vx con0 crab cint alephon cA cA vx cv cale cfv wss vx con0 crab cint cale
      cfv onsseleq mpan2 mpbid ord syl syld adantl jaod mpd $.
      $( [27-Feb-2004] $) $( [9-Nov-2003] $)

    $( Every transfinite cardinal is an aleph and vice-versa.  Theorem 8A(b) of
       [Enderton] p. 213 and its converse. $)
    cardalephex $p |- ( om C_ A ->
                   ( ( card ` A ) = A <-> E. x e. On A = ( aleph ` x ) ) ) $=
      com cA wss cA ccrd cfv cA wceq cA vx cv cale cfv wceq vx con0 wrex com cA
      wss cA ccrd cfv cA wceq cA vx cv cale cfv wceq vx con0 wrex cA vy cv cale
      cfv wss vy con0 crab cint con0 wcel cA cA vy cv cale cfv wss vy con0 crab
      cint cale cfv wceq cA vx cv cale cfv wceq vx con0 wrex com cA wss cA ccrd
      cfv cA wceq wa cA vx cv cale cfv wceq cA cA vy cv cale cfv wss vy con0
      crab cint cale cfv wceq vx cA vy cv cale cfv wss vy con0 crab cint con0
      vx cv cA vy cv cale cfv wss vy con0 crab cint wceq vx cv cale cfv cA vy
      cv cale cfv wss vy con0 crab cint cale cfv cA vx cv cA vy cv cale cfv wss
      vy con0 crab cint cale fveq2 eqeq2d rcla4ev com cA wss cA ccrd cfv cA
      wceq wa com cA wss cA vy cv cale cfv wss vy con0 crab cint con0 wcel com
      cA wss cA ccrd cfv cA wceq pm3.26 com cA wss cA ccrd cfv cA wceq wa com
      cA wss com cA vy cv cale cfv wss vy con0 crab cint cale cfv wss cA vy cv
      cale cfv wss vy con0 crab cint con0 wcel com cA wss cA ccrd cfv cA wceq
      wa cA cA vy cv cale cfv wss vy con0 crab cint cale cfv com vy cA
      cardaleph sseq2d cA vy cv cale cfv wss vy con0 crab cint alephgeom
      syl6bbr mpbid vy cA cardaleph sylanc ex cA vx cv cale cfv wceq cA ccrd
      cfv cA wceq vx con0 cA vx cv cale cfv wceq cA ccrd cfv cA wceq wi vx cv
      con0 wcel cA vx cv cale cfv wceq vx cv cale cfv ccrd cfv vx cv cale cfv
      cA ccrd cfv cA vx cv alephcard cA vx cv cale cfv ccrd fveq2 cA vx cv cale
      cfv wceq id 3eqtr4a a1i r19.23aiv impbid1 $.
      $( [6-Nov-2004] $) $( [5-Nov-2003] $)
  $}

  ${
    $d x A $.
    $( Two ways to express the property of being a transfinite cardinal. $)
    isinfcard $p |- ( ( om C_ A /\ ( card ` A ) = A ) <-> A e. ran aleph ) $=
      vx cv cale cfv cA wceq vx con0 wrex cA vx cv cale cfv wceq vx con0 wrex
      cA cale crn wcel com cA wss cA ccrd cfv cA wceq wa vx cv cale cfv cA wceq
      cA vx cv cale cfv wceq vx con0 vx cv cale cfv cA eqcom rexbii cale con0
      wfn cA cale crn wcel vx cv cale cfv cA wceq vx con0 wrex wb alephfnon vx
      con0 cA cale fvelrnb ax-mp com cA wss cA ccrd cfv cA wceq wa com cA wss
      cA vx cv cale cfv wceq vx con0 wrex wa cA vx cv cale cfv wceq vx con0
      wrex com cA wss cA ccrd cfv cA wceq cA vx cv cale cfv wceq vx con0 wrex
      vx cA cardalephex pm5.32i cA vx cv cale cfv wceq vx con0 wrex com cA wss
      cA vx cv cale cfv wceq com cA wss vx con0 cA vx cv cale cfv wceq com cA
      wss com vx cv cale cfv wss vx cv con0 wcel cA vx cv cale cfv com sseq2 vx
      cv con0 wcel com vx cv cale cfv wss vx cv alephgeom biimpi syl5cbir
      r19.23aiv pm4.71ri bitr4i 3bitr4ri $.
      $( [18-Nov-2004] $) $( [9-Nov-2003] $)
  $}

  $( Two ways to express the property of being a cardinal number. $)
  iscard3 $p |- ( ( card ` A ) = A <-> A e. ( om u. ran aleph ) ) $=
    cA ccrd cfv cA wceq cA com wcel cA cale crn wcel wo cA com cale crn cun
    wcel cA ccrd cfv cA wceq cA com wcel cA cale crn wcel wo cA ccrd cfv cA
    wceq cA com wcel cA cale crn wcel cA ccrd cfv cA wceq cA com wcel wn com cA
    wss cA cale crn wcel cA ccrd cfv cA wceq cA com wcel com cA wss cA ccrd cfv
    cA wceq cA con0 wcel cA word cA com wcel com cA wss wo cA ccrd cfv cA wceq
    cA ccrd cfv con0 wcel cA con0 wcel cA cardon cA ccrd cfv cA con0 eleq1
    mpbii cA eloni cA word com word cA com wcel com cA wss wo ordom cA com
    ordtri2or mpan2 3syl ord com cA wss cA ccrd cfv cA wceq cA cale crn wcel
    com cA wss cA ccrd cfv cA wceq wa cA cale crn wcel cA isinfcard biimpi
    expcom syld orrd cA com wcel cA ccrd cfv cA wceq cA cale crn wcel cA cardnn
    cA cale crn wcel com cA wss cA ccrd cfv cA wceq com cA wss cA ccrd cfv cA
    wceq wa cA cale crn wcel cA isinfcard bicomi pm3.27bi jaoi impbii cA com
    cale crn elun bitr4i $.
    $( [19-Nov-2004] $) $( [9-Nov-2003] $)

  $( Two ways to express the class of all cardinal numbers, which consists
     of the finite ordinals in ` om ` plus the transfinite alephs. $)
  cardnum $p |- { x | ( card ` x ) = x } = ( om u. ran aleph ) $=
    com cale crn cun vx cv ccrd cfv vx cv wceq vx cab vx cv ccrd cfv vx cv wceq
    vx com cale crn cun vx cv ccrd cfv vx cv wceq vx cv com cale crn cun wcel
    vx cv iscard3 bicomi abbi2i eqcomi $.
    $( [25-Nov-2004] $) $( [10-Sep-2004] $)

  ${
    $d x F $.  $d x A $.
    $( The union of the image of a mapping to cardinals is a cardinal.
       Proposition 11.16 of [TakeutiZaring] p. 104. $)
    carduniima $p |- ( A e. B -> ( F : A --> ( om u. ran aleph ) ->
                     U. ( F " A ) e. ( om u. ran aleph ) ) ) $=
      cA cB wcel cA com cale crn cun cF wf cF cA cima cuni ccrd cfv cF cA cima
      cuni wceq cF cA cima cuni com cale crn cun wcel cA com cale crn cun cF wf
      cA cB wcel cF cA cima cvv wcel cF cA cima cuni ccrd cfv cF cA cima cuni
      wceq cA com cale crn cun cF wf cA cB wcel cF cA cima cvv wcel cF wfun cA
      cB wcel cF cA cima cvv wcel cA com cale crn cun cF wf cF cA cB funimaexg
      cA com cale crn cun cF ffun sylan expcom cF cA cima cvv wcel vx cv ccrd
      cfv vx cv wceq vx cF cA cima wral cF cA cima cuni ccrd cfv cF cA cima
      cuni wceq cA com cale crn cun cF wf vx cF cA cima cvv carduni cA com cale
      crn cun cF wf vx cv ccrd cfv vx cv wceq vx cF cA cima cA com cale crn cun
      cF wf vx cv cF cA cima wcel vx cv com cale crn cun wcel vx cv ccrd cfv vx
      cv wceq cA com cale crn cun cF wf cF cA cima com cale crn cun vx cv cA
      com cale crn cun cF wf cF cA cima cF crn com cale crn cun cA com cale crn
      cun cF wf cF cA wfn cF cA cima cF crn wceq cA com cale crn cun cF ffn cA
      cF fnima syl cA com cale crn cun cF frn eqsstrd sseld vx cv iscard3
      syl6ibr r19.21aiv syl5 syli cF cA cima cuni iscard3 syl6ib $.
      $( [5-Dec-2004] $) $( [4-Nov-2004] $)

    $( If a mapping to cardinals has an infinite value, then the union of its
       image is an infinite cardinal.  Corollary 11.17 of [TakeutiZaring]
       p. 104. $)
    cardinfima $p |- ( A e. B -> ( ( F : A --> ( om u. ran aleph ) /\
         E. x e. A ( F ` x ) e. ran aleph ) -> U. ( F " A ) e. ran aleph ) ) $=
      cA cB wcel cA cvv wcel cA com cale crn cun cF wf vx cv cF cfv cale crn
      wcel vx cA wrex wa cF cA cima cuni cale crn wcel wi cA cB elisset cA cvv
      wcel cA com cale crn cun cF wf vx cv cF cfv cale crn wcel vx cA wrex cF
      cA cima cuni cale crn wcel cA cvv wcel cA com cale crn cun cF wf wa vx cv
      cF cfv cale crn wcel cF cA cima cuni cale crn wcel vx cA cA cvv wcel cA
      com cale crn cun cF wf vx cv cA wcel vx cv cF cfv cale crn wcel cF cA
      cima cuni cale crn wcel wi wi cA cvv wcel cA com cale crn cun cF wf vx cv
      cA wcel vx cv cF cfv cale crn wcel cF cA cima cuni cale crn wcel cA cvv
      wcel cA com cale crn cun cF wf vx cv cA wcel vx cv cF cfv cale crn wcel
      wa wa com cF cA cima cuni wss cF cA cima cuni ccrd cfv cF cA cima cuni
      wceq wa cF cA cima cuni cale crn wcel cA cvv wcel cA com cale crn cun cF
      wf vx cv cA wcel vx cv cF cfv cale crn wcel wa wa com cF cA cima cuni wss
      cF cA cima cuni ccrd cfv cF cA cima cuni wceq cA com cale crn cun cF wf
      vx cv cA wcel vx cv cF cfv cale crn wcel wa wa com cF cA cima cuni wss wi
      cA cvv wcel cA com cale crn cun cF wf vx cv cA wcel vx cv cF cfv cale crn
      wcel com cF cA cima cuni wss vx cv cF cfv cale crn wcel cA com cale crn
      cun cF wf vx cv cA wcel wa com vx cv cF cfv cF cA cima cuni vx cv cF cfv
      cale crn wcel com vx cv cF cfv wss vx cv cF cfv ccrd cfv vx cv cF cfv
      wceq com vx cv cF cfv wss vx cv cF cfv ccrd cfv vx cv cF cfv wceq wa vx
      cv cF cfv cale crn wcel vx cv cF cfv isinfcard bicomi pm3.26bi cF cA wfn
      vx cv cA wcel vx cv cF cfv cF cA cima cuni wss cA com cale crn cun cF wf
      cF cA wfn vx cv cA wcel vx cv cF cfv cF cA cima cuni wss cF cA wfn vx cv
      cA wcel vx cv cF cfv cF cA cima wcel vx cv cF cfv cF cA cima cuni wss cF
      cA wfn vx cv cA wcel vx cv cF cfv cF crn wcel vx cv cF cfv cF cA cima
      wcel cF cA wfn vx cv cA wcel vx cv cF cfv cF crn wcel cA vx cv cF
      fnfvelrn ex cF cA wfn cF cA cima cF crn vx cv cF cfv cA cF fnima eleq2d
      sylibrd vx cv cF cfv cF cA cima elssuni syl6 imp cA com cale crn cun cF
      ffn sylan sylan9ssr anasss a1i cA cvv wcel cA com cale crn cun cF wf cF
      cA cima cuni ccrd cfv cF cA cima cuni wceq vx cv cA wcel vx cv cF cfv
      cale crn wcel wa cA cvv wcel cA com cale crn cun cF wf cF cA cima cuni
      com cale crn cun wcel cF cA cima cuni ccrd cfv cF cA cima cuni wceq cA
      cvv cF carduniima cF cA cima cuni iscard3 syl6ibr adantrd jcad cF cA cima
      cuni isinfcard syl6ib exp4d imp r19.23adv expimpd syl $.
      $( [26-Dec-2004] $) $( [4-Nov-2004] $)
  $}

  ${
    $d x y z $.
    $( Aleph is an order isomorphism of the class of ordinal numbers onto the
       class of infinite cardinals.  Definition 10.27 of [TakeutiZaring]
       p. 90. $)
    alephiso $p |- aleph Isom _E , _E ( On ,
                   { x | ( om C_ x /\ ( card ` x ) = x ) } ) $=
      con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab cep cep cale wiso
      con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab cale wf1o vy cv vz
      cv cep wbr vy cv cale cfv vz cv cale cfv cep wbr wb vz con0 wral vy con0
      wral vy vz con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab cep cep
      cale df-iso con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab cale
      wf1o con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab cale wf1 con0
      com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab cale wfo con0 com vx cv
      wss vx cv ccrd cfv vx cv wceq wa vx cab cale df-f1o con0 com vx cv wss vx
      cv ccrd cfv vx cv wceq wa vx cab cale wf1 con0 com vx cv wss vx cv ccrd
      cfv vx cv wceq wa vx cab cale wf vy cv cale cfv vz cv cale cfv wceq vy cv
      vz cv wceq wi vz con0 wral vy con0 wral vy vz con0 com vx cv wss vx cv
      ccrd cfv vx cv wceq wa vx cab cale dff13 con0 com vx cv wss vx cv ccrd
      cfv vx cv wceq wa vx cab cale wfo con0 com vx cv wss vx cv ccrd cfv vx cv
      wceq wa vx cab cale wf con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx
      cab cale wfo cale con0 wfn cale crn com vx cv wss vx cv ccrd cfv vx cv
      wceq wa vx cab wceq con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx
      cab cale df-fo alephfnon com vx cv wss vx cv ccrd cfv vx cv wceq wa vx
      cale crn com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cv cale crn wcel
      vx cv isinfcard bicomi abbi2i mpbir2an con0 com vx cv wss vx cv ccrd cfv
      vx cv wceq wa vx cab cale fof ax-mp vy cv cale cfv vz cv cale cfv wceq vy
      cv vz cv wceq wi vy vz con0 vy cv con0 wcel vz cv con0 wcel wa vy cv cale
      cfv vz cv cale cfv wceq vy cv vz cv wceq vy cv vz cv aleph11 biimpd
      rgen2a mpbir2an con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab
      cale wfo cale con0 wfn cale crn com vx cv wss vx cv ccrd cfv vx cv wceq
      wa vx cab wceq con0 com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cab
      cale df-fo alephfnon com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cale
      crn com vx cv wss vx cv ccrd cfv vx cv wceq wa vx cv cale crn wcel vx cv
      isinfcard bicomi abbi2i mpbir2an mpbir2an vy cv vz cv cep wbr vy cv cale
      cfv vz cv cale cfv cep wbr wb vy vz con0 vy cv con0 wcel vz cv con0 wcel
      wa vy cv vz cv wcel vy cv cale cfv vz cv cale cfv wcel vy cv vz cv cep
      wbr vy cv cale cfv vz cv cale cfv cep wbr vy cv vz cv alephord2 vy vz
      epel vy cv cale cfv vz cv cale cfv vy cv cale fvex vz cv cale fvex epelc
      3bitr4g rgen2a mpbir2an $.
      $( [28-Dec-2004] $) $( [3-Aug-2004] $)
  $}

  $( The class of all transfinite cardinal numbers (the range of the aleph
     function) is a proper class.  Proposition 10.26 of [TakeutiZaring]
     p. 90. $)
  alephprc $p |- -. ran aleph e. _V $=
    cale crn cvv wcel com cale crn cun cvv wcel vx cv ccrd cfv vx cv wceq vx
    cab cvv wcel com cale crn cun cvv wcel vx cardprc vx cv ccrd cfv vx cv wceq
    vx cab com cale crn cun cvv vx cardnum eleq1i mtbi com cvv wcel cale crn
    cvv wcel com cale crn cun cvv wcel omex com cale crn cvv cvv unexg mpan mto
    $.
    $( [11-Dec-2004] $) $( [11-Nov-2003] $)

  $( The class of transfinite cardinals (the range of the aleph function) is a
     subclass of the class of ordinal numbers. $)
  alephsson $p |- ran aleph C_ On $=
    vx cale crn con0 vx cv cale crn wcel com vx cv wss vx cv ccrd cfv vx cv
    wceq wa vx cv con0 wcel vx cv isinfcard vx cv ccrd cfv vx cv wceq vx cv
    con0 wcel com vx cv wss vx cv ccrd cfv vx cv wceq vx cv ccrd cfv con0 wcel
    vx cv con0 wcel vx cv cardon vx cv ccrd cfv vx cv con0 eleq1 mpbii adantl
    sylbir ssriv $.
    $( [30-Dec-2004] $) $( [11-Nov-2003] $)

  $( The union of the class of transfinite cardinals (the range of the aleph
     function) is the class of ordinal numbers. $)
  unialeph $p |- U. ran aleph = On $=
    cale crn cuni con0 wcel wn cale crn cuni con0 wceq cale crn cuni con0 wcel
    cale crn cuni cvv wcel cale crn cvv wcel cale crn cuni cvv wcel alephprc
    cale crn uniexb mtbi cale crn cuni con0 elisset mto cale crn cuni con0 wcel
    cale crn cuni con0 wceq cale crn cuni word cale crn cuni con0 wcel cale crn
    cuni con0 wceq wo cale crn con0 wss cale crn cuni word alephsson cale crn
    ssorduni ax-mp cale crn cuni ordeleqon mpbi ori ax-mp $.
    $( [23-Jan-2005] $) $( [11-Nov-2003] $)

  ${
    $d x y z w v $.  $d z w v H $.
    alephfplem.1 $e |- H = ( rec ( { <. x , y >. | y = ( aleph ` x ) } ,
                       ( aleph ` (/) ) ) |` om ) $.
    $( Lemma for ~ alephfp . $)
    alephfplem1 $p |- ( H ` (/) ) e. ran aleph $=
      c0 cH cfv c0 cale cfv cale crn c0 cH cfv c0 vy cv vx cv cale cfv wceq vx
      vy copab c0 cale cfv crdg com cres cfv c0 cale cfv c0 cH vy cv vx cv cale
      cfv wceq vx vy copab c0 cale cfv crdg com cres alephfplem.1 fveq1i c0
      cale cfv cvv wcel c0 vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv
      crdg com cres cfv c0 cale cfv wceq c0 cale fvex c0 cale cfv cvv vy cv vx
      cv cale cfv wceq vx vy copab fr0g ax-mp eqtri cale con0 wfn c0 con0 wcel
      c0 cale cfv cale crn wcel alephfnon 0elon con0 c0 cale fnfvelrn mp2an
      eqeltri $.
      $( [20-Jan-2005] $) $( [6-Nov-2004] $)

    $( Lemma for ~ alephfp . $)
    alephfplem2 $p |- ( w e. om -> ( H ` suc w ) = ( aleph ` ( H ` w ) ) ) $=
      vw cv com wcel vw cv cH cfv cale cfv cvv wcel vw cv csuc cH cfv vw cv cH
      cfv cale cfv wceq vw cv cH cfv cale fvex vx vy vz c0 cale cfv vw cv vx cv
      cale cfv vw cv cH cfv cale cfv cvv cH vz cv c0 cale cfv wcel vx ax-17 vz
      cv vw cv wcel vx ax-17 vx vz vw cv cH cfv cale vz cv cale wcel vx ax-17
      vx vz vw cv cH vx vz cH vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv
      crdg com cres alephfplem.1 vx vz vy cv vx cv cale cfv wceq vx vy copab c0
      cale cfv crdg com vx vz c0 cale cfv vy cv vx cv cale cfv wceq vx vy copab
      vy cv vx cv cale cfv wceq vx vy vz hbopab1 vz cv c0 cale cfv wcel vx
      ax-17 hbrdg vz cv com wcel vx ax-17 hbres hbxfr vz cv vw cv wcel vx ax-17
      hbfv hbfv alephfplem.1 vx cv vw cv cH cfv cale fveq2 frsucopab mpan2 $.
      $( [20-Jan-2005] $) $( [6-Nov-2004] $)

    $( Lemma for ~ alephfp . $)
    alephfplem3 $p |- ( v e. om -> ( H ` v ) e. ran aleph ) $=
      vv cv com wcel vy cv vy cv wceq vv cv cH cfv cale crn wcel vy equid vv cv
      cH cfv cale crn wcel c0 cH cfv cale crn wcel vw cv cH cfv cale crn wcel
      vw cv csuc cH cfv cale crn wcel vy cv vy cv wceq vv vw vv cv c0 wceq vv
      cv cH cfv c0 cH cfv cale crn vv cv c0 cH fveq2 eleq1d vv cv vw cv wceq vv
      cv cH cfv vw cv cH cfv cale crn vv cv vw cv cH fveq2 eleq1d vv cv vw cv
      csuc wceq vv cv cH cfv vw cv csuc cH cfv cale crn vv cv vw cv csuc cH
      fveq2 eleq1d c0 cH cfv cale crn wcel vy cv vy cv wceq vx vy cH
      alephfplem.1 alephfplem1 a1i vw cv com wcel vw cv cH cfv cale crn wcel vw
      cv csuc cH cfv cale crn wcel wi vy cv vy cv wceq vw cv com wcel vw cv
      csuc cH cfv cale crn wcel vw cv cH cfv cale cfv cale crn wcel vw cv cH
      cfv cale crn wcel vw cv com wcel vw cv csuc cH cfv vw cv cH cfv cale cfv
      cale crn vx vy vw cH alephfplem.1 alephfplem2 eleq1d cale con0 wfn vw cv
      cH cfv con0 wcel vw cv cH cfv cale cfv cale crn wcel vw cv cH cfv cale
      crn wcel con0 vw cv cH cfv cale fnfvelrn alephfnon cale crn con0 vw cv cH
      cfv alephsson sseli sylancr syl5bir a1d finds2 mpi $.
      $( [20-Jan-2005] $) $( [6-Nov-2004] $)

    $( Lemma for ~ alephfp . $)
    alephfplem4 $p |- U. ( H " om ) e. ran aleph $=
      com com cale crn cun cH wf vz cv cH cfv cale crn wcel vz com wrex cH com
      cima cuni cale crn wcel com cale crn cH wf cale crn com cale crn cun wss
      com com cale crn cun cH wf com cale crn cH wf cH com wfn vz cv cH cfv
      cale crn wcel vz com wral vz com cale crn cH ffnfv cH com wfn vy cv vx cv
      cale cfv wceq vx vy copab c0 cale cfv crdg com cres com wfn c0 cale cfv
      vy cv vx cv cale cfv wceq vx vy copab frfnom cH vy cv vx cv cale cfv wceq
      vx vy copab c0 cale cfv crdg com cres wceq cH com wfn vy cv vx cv cale
      cfv wceq vx vy copab c0 cale cfv crdg com cres com wfn wb alephfplem.1
      com cH vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv crdg com cres
      fneq1 ax-mp mpbir vz cv cH cfv cale crn wcel vz com vx vy vz cH
      alephfplem.1 alephfplem3 rgen mpbir2an cale crn com ssun2 com cale crn
      com cale crn cun cH fss mp2an c0 com wcel c0 cH cfv cale crn wcel vz cv
      cH cfv cale crn wcel vz com wrex peano1 vx vy cH alephfplem.1 alephfplem1
      vz cv cH cfv cale crn wcel c0 cH cfv cale crn wcel vz c0 com vz cv c0
      wceq vz cv cH cfv c0 cH cfv cale crn vz cv c0 cH fveq2 eleq1d rcla4ev
      mp2an com cvv wcel com com cale crn cun cH wf vz cv cH cfv cale crn wcel
      vz com wrex wa cH com cima cuni cale crn wcel wi omex vz com cvv cH
      cardinfima ax-mp mp2an $.
      $( [20-Jan-2005] $) $( [5-Nov-2004] $)

    $( The aleph function has a fixed point.  Similar to Proposition 11.18 of
       [TakeutiZaring] p. 104, except that we construct an actual example of a
       fixed point rather than just showing its existence.  See ~ alephfp2
       for an abbreviated version just showing existence. $)
    alephfp $p |- ( aleph ` U. ( H " om ) ) = U. ( H " om ) $=
      cH com cima cuni vz cv cale cfv wceq vz con0 wrex cH com cima cuni cale
      cfv cH com cima cuni wceq cH com cima cuni cale crn wcel cH com cima cuni
      vz cv cale cfv wceq vz con0 wrex vx vy cH alephfplem.1 alephfplem4 cH com
      cima cuni cale crn wcel com cH com cima cuni wss cH com cima cuni ccrd
      cfv cH com cima cuni wceq wa cH com cima cuni vz cv cale cfv wceq vz con0
      wrex cH com cima cuni isinfcard com cH com cima cuni wss cH com cima cuni
      ccrd cfv cH com cima cuni wceq cH com cima cuni vz cv cale cfv wceq vz
      con0 wrex vz cH com cima cuni cardalephex biimpa sylbir ax-mp cH com cima
      cuni vz cv cale cfv wceq cH com cima cuni cale cfv cH com cima cuni wceq
      vz con0 vz cv con0 wcel cH com cima cuni vz cv cale cfv wceq wa cH com
      cima cuni cale cfv cH com cima cuni wceq cH com cima cuni cale cfv vz cv
      cale cfv wceq vz cv con0 wcel cH com cima cuni vz cv cale cfv wceq wa cH
      com cima cuni vz cv cale vz cv con0 wcel cH com cima cuni vz cv cale cfv
      wceq wa vz cv cH com cima cuni vz cv con0 wcel cH com cima cuni vz cv
      cale cfv wceq wa vz cv cH com cima cuni wceq vz cv vz cv cale cfv wceq vz
      cv con0 wcel cH com cima cuni vz cv cale cfv wceq wa vz cv vz cv cale cfv
      wceq vz cv vz cv cale cfv wss vz cv vz cv cale cfv wcel wn wa vz cv con0
      wcel vz cv vz cv cale cfv wss cH com cima cuni vz cv cale cfv wceq vz cv
      vz cv cale cfv wcel wn vz cv alephle cH com cima cuni vz cv cale cfv wceq
      vz cv vz cv cale cfv wcel vz cv cale cfv vz cv cale cfv wcel vz cv cale
      cfv elirr cH com cima cuni vz cv cale cfv wceq vz cv cH com cima cuni
      wcel vz cv cale cfv cH com cima cuni wcel wi vz cv vz cv cale cfv wcel vz
      cv cale cfv vz cv cale cfv wcel wi vz cv cH com cima cuni wcel vz cv vv
      cv cH cfv wcel vv com wrex vz cv cale cfv cH com cima cuni wcel cH wfun
      vz cv cH com cima cuni wcel vz cv vv cv cH cfv wcel vv com wrex wb cH com
      wfn cH wfun cH com wfn vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv
      crdg com cres com wfn c0 cale cfv vy cv vx cv cale cfv wceq vx vy copab
      frfnom cH vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv crdg com cres
      wceq cH com wfn vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv crdg
      com cres com wfn wb alephfplem.1 com cH vy cv vx cv cale cfv wceq vx vy
      copab c0 cale cfv crdg com cres fneq1 ax-mp mpbir com cH fnfun ax-mp vv
      com vz cv cH eluniima ax-mp vz cv vv cv cH cfv wcel vz cv cale cfv cH com
      cima cuni wcel vv com vv cv com wcel vz cv vv cv cH cfv wcel vz cv cale
      cfv vv cv cH cfv cale cfv wcel vz cv cale cfv cH com cima cuni wcel vv cv
      com wcel vv cv cH cfv cale crn wcel vv cv cH cfv con0 wcel vz cv vv cv cH
      cfv wcel vz cv cale cfv vv cv cH cfv cale cfv wcel wi vx vy vv cH
      alephfplem.1 alephfplem3 cale crn con0 vv cv cH cfv alephsson sseli vz cv
      vv cv cH cfv alephord2i 3syl vv cv com wcel vv cv cH cfv cale cfv cH com
      cima cuni vz cv cale cfv vv cv com wcel vv cv cH cfv cale cfv cH com cima
      wcel vv cv cH cfv cale cfv cH com cima cuni wss vv cv com wcel vv cv csuc
      cH cfv vv cv cH cfv cale cfv cH com cima vx vy vv cH alephfplem.1
      alephfplem2 vv cv com wcel vv cv csuc com wcel vv cv csuc cH cfv cH com
      cima wcel vv cv peano2 vv cv csuc com wcel vv cv csuc cH cfv cH crn cH
      com cima cH com wfn vv cv csuc com wcel vv cv csuc cH cfv cH crn wcel cH
      com wfn vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv crdg com cres
      com wfn c0 cale cfv vy cv vx cv cale cfv wceq vx vy copab frfnom cH vy cv
      vx cv cale cfv wceq vx vy copab c0 cale cfv crdg com cres wceq cH com wfn
      vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv crdg com cres com wfn
      wb alephfplem.1 com cH vy cv vx cv cale cfv wceq vx vy copab c0 cale cfv
      crdg com cres fneq1 ax-mp mpbir com vv cv csuc cH fnfvelrn mpan cH com
      wfn cH com cima cH crn wceq cH com wfn vy cv vx cv cale cfv wceq vx vy
      copab c0 cale cfv crdg com cres com wfn c0 cale cfv vy cv vx cv cale cfv
      wceq vx vy copab frfnom cH vy cv vx cv cale cfv wceq vx vy copab c0 cale
      cfv crdg com cres wceq cH com wfn vy cv vx cv cale cfv wceq vx vy copab
      c0 cale cfv crdg com cres com wfn wb alephfplem.1 com cH vy cv vx cv cale
      cfv wceq vx vy copab c0 cale cfv crdg com cres fneq1 ax-mp mpbir com cH
      fnima ax-mp syl6eleqr syl eqeltrrd vv cv cH cfv cale cfv cH com cima
      elssuni syl sseld syld r19.23aiv sylbi cH com cima cuni vz cv cale cfv
      wceq vz cv cH com cima cuni wcel vz cv vz cv cale cfv wcel vz cv cale cfv
      cH com cima cuni wcel vz cv cale cfv vz cv cale cfv wcel cH com cima cuni
      vz cv cale cfv vz cv eleq2 cH com cima cuni vz cv cale cfv vz cv cale cfv
      eleq2 imbi12d mpbii mtoi anim12i vz cv con0 wcel vz cv vz cv cale cfv
      wceq vz cv vz cv cale cfv wss vz cv vz cv cale cfv wcel wn wa wb cH com
      cima cuni vz cv cale cfv wceq vz cv word vz cv cale cfv word vz cv vz cv
      cale cfv wceq vz cv vz cv cale cfv wss vz cv vz cv cale cfv wcel wn wa wb
      vz cv con0 wcel vz cv vz cv cale cfv ordtri4 vz cv eloni vz cv cale cfv
      vz cv alephon onordi sylancl adantr mpbird cH com cima cuni vz cv cale
      cfv wceq vz cv cH com cima cuni wceq vz cv vz cv cale cfv wceq wb vz cv
      con0 wcel cH com cima cuni vz cv cale cfv vz cv eqeq2 adantl mpbird
      eqcomd fveq2d cH com cima cuni vz cv cale cfv wceq cH com cima cuni cale
      cfv cH com cima cuni wceq cH com cima cuni cale cfv vz cv cale cfv wceq
      wb vz cv con0 wcel cH com cima cuni vz cv cale cfv cH com cima cuni cale
      cfv eqeq2 adantl mpbird r19.23aiva ax-mp $.
      $( [20-Jan-2005] $) $( [6-Nov-2004] $)
  $}

  ${
    $d x y z $.
    $( The aleph function has at least one fixed point.  Proposition 11.18 of
       [TakeutiZaring] p. 104.  See ~ alephfp for an actual example of a
       fixed point.  Compare the inequality ~ alephle that holds in
       general.  Note that if ` x ` is a fixed point, then
       ` aleph `` aleph `` aleph `` ` ... ` aleph `` x = x ` . $)
    alephfp2 $p |- E. x e. On ( aleph ` x ) = x $=
      vz cv vy cv cale cfv wceq vy vz copab c0 cale cfv crdg com cres com cima
      cuni con0 wcel vz cv vy cv cale cfv wceq vy vz copab c0 cale cfv crdg com
      cres com cima cuni cale cfv vz cv vy cv cale cfv wceq vy vz copab c0 cale
      cfv crdg com cres com cima cuni wceq vx cv cale cfv vx cv wceq vx con0
      wrex cale crn con0 vz cv vy cv cale cfv wceq vy vz copab c0 cale cfv crdg
      com cres com cima cuni alephsson vy vz vz cv vy cv cale cfv wceq vy vz
      copab c0 cale cfv crdg com cres vz cv vy cv cale cfv wceq vy vz copab c0
      cale cfv crdg com cres eqid alephfplem4 sselii vy vz vz cv vy cv cale cfv
      wceq vy vz copab c0 cale cfv crdg com cres vz cv vy cv cale cfv wceq vy
      vz copab c0 cale cfv crdg com cres eqid alephfp vx cv cale cfv vx cv wceq
      vz cv vy cv cale cfv wceq vy vz copab c0 cale cfv crdg com cres com cima
      cuni cale cfv vz cv vy cv cale cfv wceq vy vz copab c0 cale cfv crdg com
      cres com cima cuni wceq vx vz cv vy cv cale cfv wceq vy vz copab c0 cale
      cfv crdg com cres com cima cuni con0 vx cv vz cv vy cv cale cfv wceq vy
      vz copab c0 cale cfv crdg com cres com cima cuni wceq vx cv cale cfv vz
      cv vy cv cale cfv wceq vy vz copab c0 cale cfv crdg com cres com cima
      cuni cale cfv vx cv vz cv vy cv cale cfv wceq vy vz copab c0 cale cfv
      crdg com cres com cima cuni vx cv vz cv vy cv cale cfv wceq vy vz copab
      c0 cale cfv crdg com cres com cima cuni cale fveq2 vx cv vz cv vy cv cale
      cfv wceq vy vz copab c0 cale cfv crdg com cres com cima cuni wceq id
      eqeq12d rcla4ev mp2an $.
      $( [21-Jan-2005] $) $( [6-Nov-2004] $)
  $}

  ${
    $d x y z w A $.
    $( An alternate way to express the value of the aleph function for
       nonzero arguments.  Theorem 64 of [Suppes] p. 229. $)
    alephval2 $p |- ( ( A e. On /\ (/) e. A ) -> ( aleph ` A ) =
                    |^| { x e. On | A. y e. A ( aleph ` y ) ~< x } ) $=
      cA cale cfv vy cv cale cfv vx cv csdm wbr vy cA wral vx con0 crab wcel vz
      cv vy cv cale cfv vx cv csdm wbr vy cA wral vx con0 crab wcel wn vz cA
      cale cfv wral cA cale cfv vy cv cale cfv vx cv csdm wbr vy cA wral vx
      con0 crab cint wceq cA con0 wcel c0 cA wcel wa vy cv cale cfv vx cv csdm
      wbr vy cA wral vx con0 crab con0 wss cA cale cfv vy cv cale cfv vx cv
      csdm wbr vy cA wral vx con0 crab wcel vz cv vy cv cale cfv vx cv csdm wbr
      vy cA wral vx con0 crab wcel wn vz cA cale cfv wral wa cA cale cfv vy cv
      cale cfv vx cv csdm wbr vy cA wral vx con0 crab cint wceq wi vy cv cale
      cfv vx cv csdm wbr vy cA wral vx con0 ssrab2 vz cA cale cfv vy cv cale
      cfv vx cv csdm wbr vy cA wral vx con0 crab oneqmini ax-mp cA con0 wcel cA
      cale cfv vy cv cale cfv vx cv csdm wbr vy cA wral vx con0 crab wcel c0 cA
      wcel cA con0 wcel cA cale cfv con0 wcel vy cv cale cfv cA cale cfv csdm
      wbr vy cA wral wa cA cale cfv vy cv cale cfv vx cv csdm wbr vy cA wral vx
      con0 crab wcel cA con0 wcel vy cv cale cfv cA cale cfv csdm wbr vy cA
      wral cA cale cfv con0 wcel cA con0 wcel vy cv cale cfv cA cale cfv csdm
      wbr vy cA vy cv cA alephordi r19.21aiv cA alephon jctil vy cv cale cfv vx
      cv csdm wbr vy cA wral vy cv cale cfv cA cale cfv csdm wbr vy cA wral vx
      cA cale cfv con0 vx cv cA cale cfv wceq vy cv cale cfv vx cv csdm wbr vy
      cv cale cfv cA cale cfv csdm wbr vy cA vx cv cA cale cfv vy cv cale cfv
      csdm breq2 ralbidv elrab sylibr adantr cA con0 wcel c0 cA wcel wa vz cv
      vy cv cale cfv vx cv csdm wbr vy cA wral vx con0 crab wcel wn vz cA cale
      cfv cA con0 wcel c0 cA wcel wa vz cv cA cale cfv wcel vy cv cale cfv vz
      cv csdm wbr vy cA wral wn vz cv vy cv cale cfv vx cv csdm wbr vy cA wral
      vx con0 crab wcel wn cA con0 wcel c0 cA wcel wa vz cv cA cale cfv csdm
      wbr vy cv cale cfv vz cv csdm wbr vy cA wral wn vz cv cA cale cfv wcel cA
      con0 wcel c0 cA wcel wa com vz cv cdom wbr vz cv com cdom wbr wo vz cv cA
      cale cfv csdm wbr vy cv cale cfv vz cv csdm wbr vy cA wral wn wi com cvv
      wcel vz cv cvv wcel com vz cv cdom wbr vz cv com cdom wbr wo omex vz
      visset com vz cv cvv cvv entri3 mp2an cA con0 wcel c0 cA wcel wa com vz
      cv cdom wbr vz cv cA cale cfv csdm wbr vy cv cale cfv vz cv csdm wbr vy
      cA wral wn wi vz cv com cdom wbr cA con0 wcel com vz cv cdom wbr vz cv cA
      cale cfv csdm wbr vy cv cale cfv vz cv csdm wbr vy cA wral wn wi wi c0 cA
      wcel cA con0 wcel com vz cv ccrd cfv wss vz cv cA cale cfv csdm wbr vy cv
      cale cfv vz cv csdm wbr vy cA wral wn wi com vz cv cdom wbr cA con0 wcel
      vz cv ccrd cfv vx cv cale cfv wceq vx con0 wrex vz cv cA cale cfv csdm
      wbr vy cv cale cfv vz cv csdm wbr vy cA wral wn wi com vz cv ccrd cfv wss
      cA con0 wcel vz cv ccrd cfv vx cv cale cfv wceq vz cv cA cale cfv csdm
      wbr vy cv cale cfv vz cv csdm wbr vy cA wral wn wi vx con0 cA con0 wcel
      vx cv con0 wcel vz cv ccrd cfv vx cv cale cfv wceq vz cv cA cale cfv csdm
      wbr vy cv cale cfv vz cv csdm wbr vy cA wral wn wi cA con0 wcel vx cv
      con0 wcel wa vz cv ccrd cfv vx cv cale cfv wceq wa vz cv cA cale cfv csdm
      wbr vx cv cA wcel vy cv cale cfv vz cv csdm wbr vy cA wral wn cA con0
      wcel vx cv con0 wcel wa vx cv cA wcel vx cv cale cfv cA cale cfv csdm wbr
      vz cv ccrd cfv vx cv cale cfv wceq vz cv cA cale cfv csdm wbr vx cv con0
      wcel cA con0 wcel vx cv cA wcel vx cv cale cfv cA cale cfv csdm wbr wb vx
      cv cA alephord ancoms vz cv ccrd cfv vx cv cale cfv wceq vz cv ccrd cfv
      cA cale cfv csdm wbr vx cv cale cfv cA cale cfv csdm wbr vz cv cA cale
      cfv csdm wbr vz cv ccrd cfv vx cv cale cfv cA cale cfv csdm breq1 vz cv
      cvv wcel vz cv ccrd cfv vz cv cen wbr vz cv ccrd cfv cA cale cfv csdm wbr
      vz cv cA cale cfv csdm wbr wb vz visset vz cv cardid vz cv ccrd cfv vz cv
      cA cale cfv cvv sdomen1 mp2an syl5rbbr sylan9bb vz cv ccrd cfv vx cv cale
      cfv wceq vx cv cA wcel vy cv cale cfv vz cv csdm wbr vy cA wral wn wi cA
      con0 wcel vx cv con0 wcel wa vx cv cA wcel vz cv ccrd cfv vx cv cale cfv
      wceq vy cv cale cfv vz cv csdm wbr vy cA wral wn vx cv cA wcel vy cv cale
      cfv vz cv csdm wbr vy cA wral vx cv cale cfv vz cv csdm wbr vz cv ccrd
      cfv vx cv cale cfv wceq vy cv cale cfv vz cv csdm wbr vx cv cale cfv vz
      cv csdm wbr vy vx cv cA vy cv vx cv wceq vy cv cale cfv vx cv cale cfv vz
      cv csdm vy cv vx cv cale fveq2 breq1d rcla4v vz cv ccrd cfv vx cv cale
      cfv wceq vx cv cale cfv vz cv csdm wbr vx cv cale cfv vx cv cale cfv csdm
      wbr vx cv cale cfv sdomirr vz cv ccrd cfv vx cv cale cfv wceq vx cv cale
      cfv vz cv ccrd cfv csdm wbr vx cv cale cfv vx cv cale cfv csdm wbr vx cv
      cale cfv vz cv csdm wbr vz cv ccrd cfv vx cv cale cfv vx cv cale cfv csdm
      breq2 vz cv cvv wcel vz cv ccrd cfv vz cv cen wbr vx cv cale cfv vz cv
      ccrd cfv csdm wbr vx cv cale cfv vz cv csdm wbr wb vz visset vz cv cardid
      vz cv ccrd cfv vz cv vx cv cale cfv cvv sdomen2 mp2an syl5bbr mtbiri
      nsyli com12 adantl sylbird exp31 r19.23adv com vz cv ccrd cfv wss vz cv
      ccrd cfv ccrd cfv vz cv ccrd cfv wceq vz cv ccrd cfv vx cv cale cfv wceq
      vx con0 wrex vz cv cardidm vx vz cv ccrd cfv cardalephex mpbii syl5 com
      vz cv cdom wbr com ccrd cfv vz cv ccrd cfv wss com vz cv ccrd cfv wss com
      cvv wcel vz cv cvv wcel com ccrd cfv vz cv ccrd cfv wss com vz cv cdom
      wbr wb omex vz visset com vz cv cvv cvv carddom mp2an com ccrd cfv com vz
      cv ccrd cfv cardom sseq1i bitr3i syl5ib adantr vz cv com cdom wbr vz cv
      cA cale cfv csdm wbr cA con0 wcel c0 cA wcel wa vy cv cale cfv vz cv csdm
      wbr vy cA wral wn vz cv com cdom wbr cA con0 wcel c0 cA wcel wa vy cv
      cale cfv vz cv csdm wbr vy cA wral wn wi vz cv cA cale cfv csdm wbr vz cv
      com cdom wbr cA con0 wcel c0 cA wcel vy cv cale cfv vz cv csdm wbr vy cA
      wral wn c0 cA wcel vz cv com cdom wbr cA con0 wcel wa vy cv cale cfv vz
      cv csdm wbr vy cA wral wn c0 cA wcel vz cv com cdom wbr cA con0 wcel wa
      vy cv cale cfv vz cv csdm wbr wn vy cA wrex vy cv cale cfv vz cv csdm wbr
      vy cA wral wn c0 cA wcel cA c0 wne vz cv com cdom wbr cA con0 wcel wa vy
      cv cale cfv vz cv csdm wbr wn vy cA wrex wi cA c0 ne0i cA c0 wne vy cv
      cale cfv vz cv csdm wbr wn vy cA wral vy cv cale cfv vz cv csdm wbr wn vy
      cA wrex vz cv com cdom wbr cA con0 wcel wa cA c0 wne vy cv cale cfv vz cv
      csdm wbr wn vy cA wral vy cv cale cfv vz cv csdm wbr wn vy cA wrex vy cv
      cale cfv vz cv csdm wbr wn vy cA r19.2z ex vz cv com cdom wbr cA con0
      wcel wa vy cv cale cfv vz cv csdm wbr wn vy cA vz cv com cdom wbr cA con0
      wcel vy cv cA wcel vy cv cale cfv vz cv csdm wbr wn wi vz cv com cdom wbr
      cA con0 wcel vy cv cA wcel vy cv cale cfv vz cv csdm wbr wn vz cv com
      cdom wbr vy cv con0 wcel vy cv cale cfv vz cv csdm wbr wn cA con0 wcel vy
      cv cA wcel wa vz cv com cdom wbr vy cv con0 wcel wa vz cv vy cv cale cfv
      cdom wbr vy cv cale cfv vz cv csdm wbr wn vz cv com cdom wbr com vy cv
      cale cfv cdom wbr vz cv vy cv cale cfv cdom wbr vy cv con0 wcel vz cv com
      vy cv cale cfv domtr vy cv con0 wcel com vy cv cale cfv wss com vy cv
      cale cfv cdom wbr vy cv alephgeom com cvv wcel com vy cv cale cfv wss com
      vy cv cale cfv cdom wbr wi omex com vy cv cale cfv cvv ssdomg ax-mp sylbi
      sylan2 vz cv vy cv cale cfv domnsym syl cA vy cv onelon sylan2 exp32 imp
      r19.21aiv syl5 syl vy cv cale cfv vz cv csdm wbr vy cA rexnal syl6ib
      com12 expimpd a1d com3r jaod mpi vz cv cA cale cfv wcel vz cv cA cale cfv
      csdm wbr vz cv cA cale cfv wcel vz cv con0 wcel vz cv cA cale cfv wcel vz
      cv cA cale cfv csdm wbr wb cA cale cfv vz cv cA alephon oneli vz cv con0
      wcel vz cv cA cale cfv csdm wbr vz cv cA cale cfv ccrd cfv wcel vz cv cA
      cale cfv wcel vz cv cA cale cfv cardsdomel cA cale cfv ccrd cfv cA cale
      cfv vz cv cA alephcard eleq2i syl6rbb syl ibi syl5 vz cv vy cv cale cfv
      vx cv csdm wbr vy cA wral vx con0 crab wcel vy cv cale cfv vz cv csdm wbr
      vy cA wral vz cv vy cv cale cfv vx cv csdm wbr vy cA wral vx con0 crab
      wcel vz cv con0 wcel vy cv cale cfv vz cv csdm wbr vy cA wral vy cv cale
      cfv vx cv csdm wbr vy cA wral vy cv cale cfv vz cv csdm wbr vy cA wral vx
      vz cv con0 vx cv vz cv wceq vy cv cale cfv vx cv csdm wbr vy cv cale cfv
      vz cv csdm wbr vy cA vx cv vz cv vy cv cale cfv csdm breq2 ralbidv elrab
      pm3.27bi con3i syl6 r19.21aiv sylanc $.
      $( [28-Jan-2005] $) $( [15-Nov-2003] $)
  $}

  ${
    $d x y z w A $.
    $( An alternate way to express the value of the aleph function: it is
       the least infinite cardinal different from all values at smaller
       arguments.  Definition of aleph in [Enderton] p. 212 and definition
       of aleph in [BellMachover] p. 490 . $)
    alephval3 $p |- ( A e. On -> ( aleph ` A ) = |^| { x | ( ( card ` x ) = x
                   /\ om C_ x /\ A. y e. A -. x = ( aleph ` y ) ) } ) $=
      cA cale cfv vx cv ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv
      wceq wn vy cA wral w3a vx cab wcel vz cv vx cv ccrd cfv vx cv wceq com vx
      cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a vx cab wcel wn vz cA
      cale cfv wral cA cale cfv vx cv ccrd cfv vx cv wceq com vx cv wss vx cv
      vy cv cale cfv wceq wn vy cA wral w3a vx cab cint wceq cA con0 wcel vx cv
      ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral
      w3a vx cab con0 wss cA cale cfv vx cv ccrd cfv vx cv wceq com vx cv wss
      vx cv vy cv cale cfv wceq wn vy cA wral w3a vx cab wcel vz cv vx cv ccrd
      cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a
      vx cab wcel wn vz cA cale cfv wral wa cA cale cfv vx cv ccrd cfv vx cv
      wceq com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a vx cab
      cint wceq wi vx cv ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv
      wceq wn vy cA wral w3a vx con0 vx cv ccrd cfv vx cv wceq com vx cv wss vx
      cv con0 wcel vx cv vy cv cale cfv wceq wn vy cA wral vx cv ccrd cfv vx cv
      wceq vx cv ccrd cfv con0 wcel vx cv con0 wcel vx cv cardon vx cv ccrd cfv
      vx cv con0 eleq1 mpbii 3ad2ant1 abssi vz cA cale cfv vx cv ccrd cfv vx cv
      wceq com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a vx cab
      oneqmini ax-mp cA con0 wcel cA cale cfv ccrd cfv cA cale cfv wceq com cA
      cale cfv wss cA cale cfv vy cv cale cfv wceq wn vy cA wral w3a cA cale
      cfv vx cv ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv wceq wn
      vy cA wral w3a vx cab wcel cA con0 wcel cA cale cfv ccrd cfv cA cale cfv
      wceq com cA cale cfv wss cA cale cfv vy cv cale cfv wceq wn vy cA wral cA
      cale cfv ccrd cfv cA cale cfv wceq cA con0 wcel cA alephcard a1i cA con0
      wcel com cA cale cfv wss cA alephgeom biimpi cA con0 wcel cA cale cfv vy
      cv cale cfv wceq wn vy cA cA con0 wcel vy cv cA wcel vy cv cale cfv cA
      cale cfv wcel cA cale cfv vy cv cale cfv wceq wn vy cv cA alephord2i cA
      cale cfv vy cv cale cfv wceq vy cv cale cfv cA cale cfv wcel cA cale cfv
      vy cv cale cfv wceq vy cv cale cfv cA cale cfv wcel vy cv cale cfv vy cv
      cale cfv wcel vy cv cale cfv elirr cA cale cfv vy cv cale cfv vy cv cale
      cfv eleq2 mtbiri con2i syl6 r19.21aiv 3jca vx cv ccrd cfv vx cv wceq com
      vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a cA cale cfv ccrd
      cfv cA cale cfv wceq com cA cale cfv wss cA cale cfv vy cv cale cfv wceq
      wn vy cA wral w3a vx cA cale cfv cA cale fvex vx cv cA cale cfv wceq vx
      cv ccrd cfv vx cv wceq cA cale cfv ccrd cfv cA cale cfv wceq com vx cv
      wss com cA cale cfv wss vx cv vy cv cale cfv wceq wn vy cA wral cA cale
      cfv vy cv cale cfv wceq wn vy cA wral vx cv cA cale cfv wceq vx cv ccrd
      cfv cA cale cfv ccrd cfv vx cv cA cale cfv vx cv cA cale cfv ccrd fveq2
      vx cv cA cale cfv wceq id eqeq12d vx cv cA cale cfv com sseq2 vx cv cA
      cale cfv wceq vx cv vy cv cale cfv wceq wn cA cale cfv vy cv cale cfv
      wceq wn vy cA vx cv cA cale cfv wceq vx cv vy cv cale cfv wceq cA cale
      cfv vy cv cale cfv wceq vx cv cA cale cfv vy cv cale cfv eqeq1 notbid
      ralbidv 3anbi123d elab sylibr cA con0 wcel vz cv vx cv ccrd cfv vx cv
      wceq com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a vx cab
      wcel wn vz cA cale cfv cA con0 wcel vz cv cA cale cfv wcel vz cv ccrd cfv
      vz cv wceq com vz cv wss wa vz cv vy cv cale cfv wceq wn vy cA wral wa wn
      vz cv vx cv ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv wceq
      wn vy cA wral w3a vx cab wcel wn cA con0 wcel vz cv cA cale cfv wcel vz
      cv ccrd cfv vz cv wceq com vz cv wss wa vz cv vy cv cale cfv wceq wn vy
      cA wral wa wn cA con0 wcel vz cv cA cale cfv wcel wa vz cv ccrd cfv vz cv
      wceq com vz cv wss wa vz cv vy cv cale cfv wceq wn vy cA wral wa wn wi cA
      con0 wcel vz cv cA cale cfv wcel wa vz cv ccrd cfv vz cv wceq com vz cv
      wss wa wa vz cv vy cv cale cfv wceq wn vy cA wral wn wi cA con0 wcel vz
      cv cA cale cfv wcel wa vz cv ccrd cfv vz cv wceq com vz cv wss wa wa vz
      cv vy cv cale cfv wceq vy cA wrex vz cv vy cv cale cfv wceq wn vy cA wral
      wn cA con0 wcel vz cv cA cale cfv wcel wa vz cv ccrd cfv vz cv wceq com
      vz cv wss wa vz cv vy cv cale cfv wceq vy cA wrex cA con0 wcel vz cv cA
      cale cfv wcel wa vz cv vy cv cale cfv wceq vy con0 wrex vz cv vy cv cale
      cfv wceq vy cA wrex vz cv ccrd cfv vz cv wceq com vz cv wss wa cA con0
      wcel vz cv cA cale cfv wcel wa vz cv vy cv cale cfv wceq vz cv vy cv cale
      cfv wceq vy con0 cA cA con0 wcel vz cv cA cale cfv wcel vy cv con0 wcel
      vz cv vy cv cale cfv wceq vy cv cA wcel vz cv vy cv cale cfv wceq wa vz
      cv cA cale cfv wcel vy cv con0 wcel cA con0 wcel vz cv vy cv cale cfv
      wceq vy cv cA wcel vz cv vy cv cale cfv wceq wa wi vz cv cA cale cfv wcel
      vy cv con0 wcel cA con0 wcel vz cv vy cv cale cfv wceq vy cv cA wcel vz
      cv vy cv cale cfv wceq wa vz cv cA cale cfv wcel vy cv con0 wcel cA con0
      wcel wa vz cv vy cv cale cfv wceq wa vy cv cA wcel vz cv vy cv cale cfv
      wceq vy cv con0 wcel cA con0 wcel wa vz cv vy cv cale cfv wceq wa vz cv
      cA cale cfv wcel vy cv cA wcel vz cv vy cv cale cfv wceq vz cv cA cale
      cfv wcel vy cv cale cfv cA cale cfv wcel vy cv con0 wcel cA con0 wcel wa
      vy cv cA wcel vz cv vy cv cale cfv cA cale cfv eleq1 vy cv con0 wcel cA
      con0 wcel wa vy cv cA wcel vy cv cale cfv cA cale cfv wcel vy cv cA
      alephord2 bicomd sylan9bbr biimpcd vy cv con0 wcel cA con0 wcel wa vz cv
      vy cv cale cfv wceq wa vz cv vy cv cale cfv wceq wi vz cv cA cale cfv
      wcel vy cv con0 wcel cA con0 wcel wa vz cv vy cv cale cfv wceq pm3.27 a1i
      jcad exp4c com3r imp4b r19.22dv2 com vz cv wss vz cv ccrd cfv vz cv wceq
      vz cv vy cv cale cfv wceq vy con0 wrex vy vz cv cardalephex biimpac syl5
      imp vz cv vy cv cale cfv wceq vy cA dfrex2 sylib cA con0 wcel vz cv cA
      cale cfv wcel wa vz cv ccrd cfv vz cv wceq com vz cv wss wa vz cv vy cv
      cale cfv wceq wn vy cA wral nan mpbir ex vz cv vx cv ccrd cfv vx cv wceq
      com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral w3a vx cab wcel vz
      cv ccrd cfv vz cv wceq com vz cv wss wa vz cv vy cv cale cfv wceq wn vy
      cA wral wa vz cv vx cv ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale
      cfv wceq wn vy cA wral w3a vx cab wcel vz cv ccrd cfv vz cv wceq com vz
      cv wss vz cv vy cv cale cfv wceq wn vy cA wral w3a vz cv ccrd cfv vz cv
      wceq com vz cv wss wa vz cv vy cv cale cfv wceq wn vy cA wral wa vx cv
      ccrd cfv vx cv wceq com vx cv wss vx cv vy cv cale cfv wceq wn vy cA wral
      w3a vz cv ccrd cfv vz cv wceq com vz cv wss vz cv vy cv cale cfv wceq wn
      vy cA wral w3a vx vz cv vz visset vx cv vz cv wceq vx cv ccrd cfv vx cv
      wceq vz cv ccrd cfv vz cv wceq com vx cv wss com vz cv wss vx cv vy cv
      cale cfv wceq wn vy cA wral vz cv vy cv cale cfv wceq wn vy cA wral vx cv
      vz cv wceq vx cv ccrd cfv vz cv ccrd cfv vx cv vz cv vx cv vz cv ccrd
      fveq2 vx cv vz cv wceq id eqeq12d vx cv vz cv com sseq2 vx cv vz cv wceq
      vx cv vy cv cale cfv wceq wn vz cv vy cv cale cfv wceq wn vy cA vx cv vz
      cv wceq vx cv vy cv cale cfv wceq vz cv vy cv cale cfv wceq vx cv vz cv
      vy cv cale cfv eqeq1 notbid ralbidv 3anbi123d elab vz cv ccrd cfv vz cv
      wceq com vz cv wss vz cv vy cv cale cfv wceq wn vy cA wral df-3an bitri
      notbii syl6ibr r19.21aiv sylanc $.
      $( [1-Mar-2005] $) $( [16-Nov-2003] $)
  $}

  ${
    $d x y z w A $.
    dominf.1 $e |- A e. _V $.
    $( A nonempty set that is a subset of its union is infinite. $)
    dominf $p |- ( ( A =/= (/) /\ A C_ U. A ) -> om ~<_ A ) $=
      vx cv c0 wne vx cv vx cv cuni wss wa com vx cv cdom wbr wi cA c0 wne cA
      cA cuni wss wa com cA cdom wbr wi vx cA dominf.1 vx cv cA wceq vx cv c0
      wne vx cv vx cv cuni wss wa cA c0 wne cA cA cuni wss wa com vx cv cdom
      wbr com cA cdom wbr vx cv cA wceq vx cv c0 wne cA c0 wne vx cv vx cv cuni
      wss cA cA cuni wss vx cv cA c0 neeq1 vx cv cA wceq vx cv cA vx cv cuni cA
      cuni vx cv cA wceq id vx cv cA unieq sseq12d anbi12d vx cv cA com cdom
      breq2 imbi12d vx cv c0 wne vx cv vx cv cuni wss wa com vx cv cpw vz cv vw
      cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres
      wf1 com vx cv cpw cdom wbr com vx cv cdom wbr vx vy vz vw cA cA vz cv vw
      cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres vz
      cv vw cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab vz cv vw cv
      vx cv cin vy cv wss vw vx cv crab wceq vy vz copab eqid vz cv vw cv vx cv
      cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres eqid
      dominf.1 dominf.1 inf3lem6 vx cv cpw cvv wcel com vx cv cpw vz cv vw cv
      vx cv cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres wf1
      com vx cv cpw cdom wbr wi vx cv vx visset pwex com vx cv cpw cvv vz cv vw
      cv vx cv cin vy cv wss vw vx cv crab wceq vy vz copab c0 crdg com cres
      f1dom2g ax-mp vx cv cpw com csdm wbr wn vx cv com csdm wbr wn com vx cv
      cpw cdom wbr com vx cv cdom wbr vx cv com csdm wbr vx cv cpw com csdm wbr
      vx cv cfn wcel vx cv cpw cfn wcel vx cv com csdm wbr vx cv cpw com csdm
      wbr vx cv cfn wcel vx cv cpw cfn wcel vx cv pwfi biimpi vx cv isfinite vx
      cv cpw isfinite 3imtr4i con3i com cvv wcel vx cv cpw cvv wcel com vx cv
      cpw cdom wbr vx cv cpw com csdm wbr wn wb omex vx cv vx visset pwex com
      vx cv cpw cvv cvv domtri mp2an com cvv wcel vx cv cvv wcel com vx cv cdom
      wbr vx cv com csdm wbr wn wb omex vx visset com vx cv cvv cvv domtri
      mp2an 3imtr4i 3syl vtocl $.
      $( [22-Sep-2008] $) $( [25-Mar-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Cofinality
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u A $.
    $( A lemma used to simplify cofinality computations, showing the existence
       of the cardinal of an unbounded subset of a set ` A ` . $)
    cflem $p |- ( A e. B -> E. x E. y ( x = ( card ` y )
                  /\ ( y C_ A /\ A. z e. A E. w e. y z C_ w ) ) ) $=
      cA cB wcel vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa vy
      wex vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex
      vz cA wral wa wa vy wex vx wex cA cB wcel cA cA wss vz cv vw cv wss vw cA
      wrex vz cA wral vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      vy wex cA ssid vz cv vw cv wss vw cA wrex vz cA vz cv cA wcel vz cv vz cv
      wss vz cv vw cv wss vw cA wrex vz cv ssid vz cv vw cv wss vz cv vz cv wss
      vw vz cv cA vw cv vz cv vz cv sseq2 rcla4ev mpan2 rgen vy cv cA wss vz cv
      vw cv wss vw vy cv wrex vz cA wral wa cA cA wss vz cv vw cv wss vw cA
      wrex vz cA wral wa vy cA cB vy cv cA wceq vy cv cA wss cA cA wss vz cv vw
      cv wss vw vy cv wrex vz cA wral vz cv vw cv wss vw cA wrex vz cA wral vy
      cv cA cA sseq1 vy cv cA wceq vz cv vw cv wss vw vy cv wrex vz cv vw cv
      wss vw cA wrex vz cA vz cv vw cv wss vw vy cv cA rexeq1 ralbidv anbi12d
      cla4egv mp2ani vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vx wex vy wex vx cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx wex vx cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vx wex vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa vy vx
      cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA
      wral wa wa vx wex vx cv vy cv ccrd cfv wceq vx wex vy cv cA wss vz cv vw
      cv wss vw vy cv wrex vz cA wral wa vx cv vy cv ccrd cfv wceq vy cv cA wss
      vz cv vw cv wss vw vy cv wrex vz cA wral wa vx 19.41v vx vy cv ccrd cfv
      vy cv ccrd fvex isseti mpbiran exbii vx cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy vx excom bitr3i
      sylib $.
      $( [2-May-2004] $) $( [24-Apr-2004] $)

    $( Value of the cofinality function.  Definition B of Saharon Shelah,
       _Cardinal Arithmetic_ (1994), p. xxx (Roman numeral 30).  The cofinality
       of an ordinal number ` A ` is the cardinality (size) of the smallest
       unbounded subset ` y ` of the ordinal number.  Unbounded means that for
       every member of ` A ` , there is a member of ` y ` that is at least as
       large.  Cofinality is a measure of how "reachable from below" an ordinal
       is. $)
    cfval $p |- ( A e. On -> ( cf ` A ) = |^| { x | E. y ( x = ( card ` y ) /\
                 ( y C_ A /\ A. z e. A E. w e. y z C_ w ) ) } ) $=
      cA con0 wcel vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy
      cv wrex vz cA wral wa wa vy wex vx cab cint cvv wcel cA ccf cfv vx cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vy wex vx cab cint wceq cA con0 wcel vx cv vy cv ccrd cfv wceq vy cv
      cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx wex vx cv
      vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral
      wa wa vy wex vx cab cint cvv wcel vx vy vz vw cA con0 cflem vx cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy wex vx intexab sylib vv vu cA vx cv vy cv ccrd cfv wceq vy cv vv cv
      wss vz cv vw cv wss vw vy cv wrex vz vv cv wral wa wa vy wex vx cab cint
      vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz
      cA wral wa wa vy wex vx cab cint con0 cvv ccf vv cv cA wceq vx cv vy cv
      ccrd cfv wceq vy cv vv cv wss vz cv vw cv wss vw vy cv wrex vz vv cv wral
      wa wa vy wex vx cab vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa wa vy wex vx cab vv cv cA wceq vx cv vy
      cv ccrd cfv wceq vy cv vv cv wss vz cv vw cv wss vw vy cv wrex vz vv cv
      wral wa wa vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss
      vw vy cv wrex vz cA wral wa wa vy wex vx vv cv cA wceq vx cv vy cv ccrd
      cfv wceq vy cv vv cv wss vz cv vw cv wss vw vy cv wrex vz vv cv wral wa
      wa vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex
      vz cA wral wa wa vy vv cv cA wceq vy cv vv cv wss vz cv vw cv wss vw vy
      cv wrex vz vv cv wral wa vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA
      wral wa vx cv vy cv ccrd cfv wceq vv cv cA wceq vy cv vv cv wss vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz vv cv wral vz cv vw cv wss vw vy cv
      wrex vz cA wral vv cv cA vy cv sseq2 vz cv vw cv wss vw vy cv wrex vz vv
      cv cA raleq1 anbi12d anbi2d exbidv abbidv inteqd vv vu vx vy vz vw df-cf
      fvopab4g mpdan $.
      $( [2-May-2004] $) $( [1-Apr-2004] $)
  $}

  ${
    $d x y z w v u $.
    $( Cofinality is a function on the class of ordinal numbers. $)
    cffnon $p |- cf Fn On $=
      vv vu con0 vx cv vy cv ccrd cfv wceq vy cv vv cv wss vz cv vw cv wss vw
      vy cv wrex vz vv cv wral wa wa vy wex vx cab cint ccf vx cv vy cv ccrd
      cfv wceq vy cv vv cv wss vz cv vw cv wss vw vy cv wrex vz vv cv wral wa
      wa vy wex vx wex vx cv vy cv ccrd cfv wceq vy cv vv cv wss vz cv vw cv
      wss vw vy cv wrex vz vv cv wral wa wa vy wex vx cab cint cvv wcel vv cv
      cvv wcel vx cv vy cv ccrd cfv wceq vy cv vv cv wss vz cv vw cv wss vw vy
      cv wrex vz vv cv wral wa wa vy wex vx wex vv visset vx vy vz vw vv cv cvv
      cflem ax-mp vx cv vy cv ccrd cfv wceq vy cv vv cv wss vz cv vw cv wss vw
      vy cv wrex vz vv cv wral wa wa vy wex vx intexab mpbi vv vu vx vy vz vw
      df-cf fnopab2 $.
      $( [25-Aug-2004] $) $( [24-Apr-2004] $)
  $}

  ${
    $d x y z w v A $.
    $( An upper bound on cofinality. $)
    cfub $p |- ( cf ` A ) C_
            |^| { x | E. y ( x = ( card ` y ) /\ ( y C_ A /\ A C_ U. y ) ) } $=
      cA con0 wcel cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv
      cuni wss wa wa vy wex vx cab cint wss cA con0 wcel cA ccf cfv vx cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy wex vx cab cint vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni
      wss wa wa vy wex vx cab cint vx vy vz vw cA cfval cA con0 wcel vx cv vy
      cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx cab vx cv
      vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral
      wa wa vy wex vx cab wss vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw
      cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab cint vx cv vy cv ccrd
      cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx cab cint wss cA
      con0 wcel vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa
      vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vy wex wi vx wal vx cv vy cv ccrd cfv wceq vy cv cA
      wss cA vy cv cuni wss wa wa vy wex vx cab vx cv vy cv ccrd cfv wceq vy cv
      cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab wss
      cA con0 wcel vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa
      wa vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vy wex wi vx cA con0 wcel vx cv vy cv ccrd cfv wceq
      vy cv cA wss cA vy cv cuni wss wa wa vx cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy cA con0 wcel vy cv
      cA wss cA vy cv cuni wss wa vy cv cA wss vz cv vw cv wss vw vy cv wrex vz
      cA wral wa vx cv vy cv ccrd cfv wceq cA con0 wcel vy cv cA wss cA vy cv
      cuni wss vz cv vw cv wss vw vy cv wrex vz cA wral cA con0 wcel vy cv cA
      wss cA vy cv cuni wss vz cv vw cv wss vw vy cv wrex vz cA wral wi cA con0
      wcel vy cv cA wss wa vz cv vy cv cuni wcel vz cA wral vz cv vw cv wss vw
      vy cv wrex vz cA wral cA vy cv cuni wss cA con0 wcel vy cv cA wss wa vz
      cv vy cv cuni wcel vz cv vw cv wss vw vy cv wrex vz cA cA con0 wcel vy cv
      cA wss wa vz cv vw cv wcel vw cv vy cv wcel wa vw wex vw cv vy cv wcel vz
      cv vw cv wss wa vw wex vz cv vy cv cuni wcel vz cv vw cv wss vw vy cv
      wrex cA con0 wcel vy cv cA wss wa vz cv vw cv wcel vw cv vy cv wcel wa vw
      cv vy cv wcel vz cv vw cv wss wa vw cA con0 wcel vy cv cA wss wa vw cv vy
      cv wcel vz cv vw cv wcel vw cv vy cv wcel vz cv vw cv wss wa cA con0 wcel
      vy cv cA wss wa vw cv vy cv wcel vz cv vw cv wcel vz cv vw cv wss cA con0
      wcel vy cv cA wss wa vw cv vy cv wcel vw cv con0 wcel vz cv vw cv wcel vz
      cv vw cv wss wi vy cv cA wss vw cv vy cv wcel vw cv cA wcel cA con0 wcel
      vw cv con0 wcel vy cv cA vw cv ssel cA con0 wcel vw cv cA wcel vw cv con0
      wcel cA vw cv onelon ex sylan9r vw cv vz cv onelss syl6 imdistand ancomsd
      19.22dv vw vz cv vy cv eluni vz cv vw cv wss vw vy cv df-rex 3imtr4g
      r19.20sdv vz cA vy cv cuni dfss3 syl5ib ex imdistand anim2d 19.22dv
      19.21aiv vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa
      vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vy wex vx ss2ab sylibr vx cv vy cv ccrd cfv wceq vy
      cv cA wss cA vy cv cuni wss wa wa vy wex vx cab vx cv vy cv ccrd cfv wceq
      vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab
      intss syl eqsstrd cA con0 wcel wn cA ccf cfv vx cv vy cv ccrd cfv wceq vy
      cv cA wss cA vy cv cuni wss wa wa vy wex vx cab cint wss c0 vx cv vy cv
      ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx cab cint wss
      vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx
      cab cint 0ss cA con0 wcel wn cA ccf cfv c0 vx cv vy cv ccrd cfv wceq vy
      cv cA wss cA vy cv cuni wss wa wa vy wex vx cab cint cA con0 wcel wn cA
      ccf cdm wcel wn cA ccf cfv c0 wceq cA ccf cdm wcel cA con0 wcel ccf cdm
      con0 cA ccf con0 wfn ccf cdm con0 wceq cffnon con0 ccf fndm ax-mp eleq2i
      notbii cA ccf ndmfv sylbir sseq1d mpbiri pm2.61i $.
      $( [29-Aug-2004] $) $( [25-Apr-2004] $)

    $( Value of the cofinality function at a limit ordinal.  Part of Definition
       of cofinality of [Enderton] p. 257. $)
    cflim $p |- ( ( A e. B /\ Lim A ) -> ( cf ` A ) =
           |^| { x | E. y ( x = ( card ` y ) /\ ( y C_ A /\ A = U. y ) ) } ) $=
      cA cvv wcel cA wlim cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss cA
      vy cv cuni wceq wa wa vy wex vx cab cint wceq cA cB wcel cA cvv wcel cA
      wlim wa cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni
      wceq wa wa vy wex vx cab cint wss vx cv vy cv ccrd cfv wceq vy cv cA wss
      cA vy cv cuni wceq wa wa vy wex vx cab cint cA ccf cfv wss wa cA ccf cfv
      vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex vx
      cab cint wceq cA cvv wcel cA wlim wa vx cv vy cv ccrd cfv wceq vy cv cA
      wss cA vy cv cuni wceq wa wa vy wex vx cab cint cA ccf cfv wss cA ccf cfv
      vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex vx
      cab cint wss cA cvv wcel cA wlim wa vx cv vy cv ccrd cfv wceq vy cv cA
      wss cA vy cv cuni wceq wa wa vy wex vx cab cint vx cv vy cv ccrd cfv wceq
      vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab
      cint cA ccf cfv cA wlim vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv
      cuni wceq wa wa vy wex vx cab cint vx cv vy cv ccrd cfv wceq vy cv cA wss
      vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab cint wss cA
      cvv wcel cA wlim vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss
      vw vy cv wrex vz cA wral wa wa vy wex vx cab vx cv vy cv ccrd cfv wceq vy
      cv cA wss cA vy cv cuni wceq wa wa vy wex vx cab wss vx cv vy cv ccrd cfv
      wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex vx cab cint vx cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy wex vx cab cint wss cA wlim vx cv vy cv ccrd cfv wceq vy cv cA wss vz
      cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cv vy cv ccrd cfv
      wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex wi vx wal vx cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy wex vx cab vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq
      wa wa vy wex vx cab wss cA wlim vx cv vy cv ccrd cfv wceq vy cv cA wss vz
      cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cv vy cv ccrd cfv
      wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex wi vx cA wlim vx cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa wa vy cA
      wlim vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa vy cv cA
      wss cA vy cv cuni wceq wa vx cv vy cv ccrd cfv wceq cA wlim vy cv cA wss
      vz cv vw cv wss vw vy cv wrex vz cA wral cA vy cv cuni wceq cA wlim vy cv
      cA wss vz cv vw cv wss vw vy cv wrex vz cA wral cA vy cv cuni wceq wi cA
      wlim vy cv cA wss wa vz cv vw cv wss vw vy cv wrex vz cA wral cA vy cv
      cuni wss vy cv cuni cA wss wa cA vy cv cuni wceq cA wlim vy cv cA wss wa
      vz cv vw cv wss vw vy cv wrex vz cA wral cA vy cv cuni wss vy cv cuni cA
      wss cA wlim vz cv vw cv wss vw vy cv wrex vz cA wral cA vy cv cuni wss wi
      vy cv cA wss cA wlim vz cv vw cv wss vw vy cv wrex vz cA wral vv cv vy cv
      cuni wcel vv cA wral cA vy cv cuni wss cA wlim vz cv vw cv wss vw vy cv
      wrex vz cA wral vv cv vy cv cuni wcel vv cA cA wlim vv cv cA wcel vv cv
      csuc cA wcel vz cv vw cv wss vw vy cv wrex vz cA wral vv cv vy cv cuni
      wcel cA wlim vv cv cA wcel vv cv csuc cA wcel cA vv cv limsuc biimpd vv
      cv csuc cA wcel vz cv vw cv wss vw vy cv wrex vz cA wral vv cv csuc vw cv
      wss vw vy cv wrex vv cv vy cv cuni wcel vz cv vw cv wss vw vy cv wrex vv
      cv csuc vw cv wss vw vy cv wrex vz vv cv csuc cA vz cv vv cv csuc wceq vz
      cv vw cv wss vv cv csuc vw cv wss vw vy cv vz cv vv cv csuc vw cv sseq1
      rexbidv rcla4v vv cv csuc vw cv wss vw vy cv wrex vv cv vw cv wcel vw vy
      cv wrex vv cv vy cv cuni wcel vv cv csuc vw cv wss vv cv vw cv wcel vw vy
      cv vv cv cvv wcel vv cv csuc vw cv wss vv cv vw cv wcel wi vv visset vv
      cv vw cv cvv sucssel ax-mp r19.22si vw vv cv vy cv eluni2 sylibr syl6com
      syl9 r19.21adv vv cA vy cv cuni dfss3 syl6ibr adantr cA wlim vy cv cA wss
      vy cv cuni cA wss cA wlim vy cv cuni cA wss vy cv cuni cA cuni wss vy cv
      cA wss cA wlim cA cA cuni vy cv cuni cA limuni sseq2d vy cv cA uniss
      syl5bir imp jctird cA vy cv cuni eqss syl6ibr ex imdistand anim2d 19.22dv
      19.21aiv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy
      cv cuni wceq wa wa vy wex vx ss2ab sylibr vx cv vy cv ccrd cfv wceq vy cv
      cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab vx cv
      vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex vx cab
      intss syl adantl cA cvv wcel cA wlim wa cA con0 wcel cA ccf cfv vx cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vy wex vx cab cint wceq cA cvv limelon vx vy vz vw cA cfval syl
      sseqtr4d cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni
      wss wa wa vy wex vx cab cint vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy
      cv cuni wceq wa wa vy wex vx cab cint vx vy cA cfub vx cv vy cv ccrd cfv
      wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex vx cab vx cv vy cv ccrd
      cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx cab wss vx cv vy
      cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx cab cint
      vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa wa vy wex vx
      cab cint wss vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa
      wa vy wex vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa
      vy wex vx vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wceq wa wa
      vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni wss wa wa vy vy cv
      cA wss cA vy cv cuni wceq wa vy cv cA wss cA vy cv cuni wss wa vx cv vy
      cv ccrd cfv wceq cA vy cv cuni wceq cA vy cv cuni wss vy cv cA wss cA vy
      cv cuni eqimss anim2i anim2i 19.22i ss2abi vx cv vy cv ccrd cfv wceq vy
      cv cA wss cA vy cv cuni wceq wa wa vy wex vx cab vx cv vy cv ccrd cfv
      wceq vy cv cA wss cA vy cv cuni wss wa wa vy wex vx cab intss ax-mp sstri
      jctil cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss cA vy cv cuni
      wceq wa wa vy wex vx cab cint eqss sylibr cA cB elisset sylan $.
      $( [1-Sep-2004] $) $( [26-Apr-2004] $)
  $}

  ${
    $d x y $.
    $( Value of the cofinality function at 0.  Exercise 2 of [TakeutiZaring]
       p. 102. $)
    cf0 $p |- ( cf ` (/) ) = (/) $=
      c0 ccf cfv c0 wss c0 ccf cfv c0 wceq c0 ccf cfv vx cv vy cv ccrd cfv wceq
      vy cv c0 wss c0 vy cv cuni wss wa wa vy wex vx cab cint c0 vx vy c0 cfub
      vx cv vy cv ccrd cfv wceq vy cv c0 wss c0 vy cv cuni wss wa wa vy wex vx
      cab cint c0 csn cint c0 vx cv vy cv ccrd cfv wceq vy cv c0 wss c0 vy cv
      cuni wss wa wa vy wex vx cab c0 csn vx cv vy cv ccrd cfv wceq vy cv c0
      wss c0 vy cv cuni wss wa wa vy wex vx cab vx cv c0 wceq vx cab c0 csn vx
      cv vy cv ccrd cfv wceq vy cv c0 wss c0 vy cv cuni wss wa wa vy wex vx cv
      c0 wceq vx vx cv vy cv ccrd cfv wceq vy cv c0 wss c0 vy cv cuni wss wa wa
      vy wex vy cv c0 wceq vx cv vy cv ccrd cfv wceq wa vy wex vx cv c0 ccrd
      cfv wceq vx cv c0 wceq vx cv vy cv ccrd cfv wceq vy cv c0 wss c0 vy cv
      cuni wss wa wa vy cv c0 wceq vx cv vy cv ccrd cfv wceq wa vy vx cv vy cv
      ccrd cfv wceq vy cv c0 wss c0 vy cv cuni wss wa wa vx cv vy cv ccrd cfv
      wceq vy cv c0 wceq wa vy cv c0 wceq vx cv vy cv ccrd cfv wceq wa vy cv c0
      wss c0 vy cv cuni wss wa vy cv c0 wceq vx cv vy cv ccrd cfv wceq vy cv c0
      wss c0 vy cv cuni wss wa vy cv c0 wss vy cv c0 wceq c0 vy cv cuni wss vy
      cv c0 wss vy cv cuni 0ss biantru vy cv ss0b bitr3i anbi2i vx cv vy cv
      ccrd cfv wceq vy cv c0 wceq ancom bitri exbii vx cv vy cv ccrd cfv wceq
      vx cv c0 ccrd cfv wceq vy c0 0ex vy cv c0 wceq vy cv ccrd cfv c0 ccrd cfv
      vx cv vy cv c0 ccrd fveq2 eqeq2d ceqsexv c0 ccrd cfv c0 vx cv card0
      eqeq2i 3bitri abbii vx c0 df-sn eqtr4i inteqi c0 0ex intsn eqtri sseqtri
      c0 ccf cfv ss0b mpbi $.
      $( [30-Aug-2004] $) $( [16-Apr-2004] $)
  $}

  ${
    $d x y z w v u A $.
    $( Cofinality is a cardinal number.  Proposition 11.11 of [TakeutiZaring]
       p. 103. $)
    cardcf $p |- ( card ` ( cf ` A ) ) = ( cf ` A ) $=
      cA con0 wcel cA ccf cfv ccrd cfv cA ccf cfv wceq cA con0 wcel cA ccf cfv
      vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz
      cA wral wa wa vy wex vx cab wcel cA ccf cfv ccrd cfv cA ccf cfv wceq cA
      con0 wcel cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa wa vy wex vx cab cint vx cv vy cv ccrd
      cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy
      wex vx cab vx vy vz vw cA cfval vx cv vy cv ccrd cfv wceq vy cv cA wss vz
      cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab con0 wss vx cv
      vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral
      wa wa vy wex vx cab c0 wne vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv
      vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab cint vx cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy wex vx cab wcel cA con0 wcel vx cv vy cv ccrd cfv wceq vy cv cA wss vz
      cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab onint vv vx cv
      vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral
      wa wa vy wex vx cab con0 vv cv vx cv vy cv ccrd cfv wceq vy cv cA wss vz
      cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab wcel vv cv vv
      cv ccrd cfv con0 vv cv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa wa vy wex vx cab wcel vv cv vy cv ccrd
      cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy
      wex vv cv ccrd cfv vv cv wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz
      cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vv cv vy cv ccrd cfv
      wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex
      vx vv cv vv visset vx cv vv cv wceq vx cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vv cv vy cv ccrd cfv
      wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy vx cv
      vv cv wceq vx cv vy cv ccrd cfv wceq vv cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa vx cv vv cv vy cv ccrd
      cfv eqeq1 anbi1d exbidv elab vv cv vy cv ccrd cfv wceq vy cv cA wss vz cv
      vw cv wss vw vy cv wrex vz cA wral wa wa vv cv ccrd cfv vv cv wceq vy vv
      cv vy cv ccrd cfv wceq vv cv ccrd cfv vv cv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa vv cv vy cv ccrd cfv wceq vv cv ccrd cfv
      vv cv wceq vv cv ccrd cfv vy cv ccrd cfv wceq vv cv vy cv ccrd cfv wceq
      vv cv ccrd cfv vy cv ccrd cfv ccrd cfv vy cv ccrd cfv vv cv vy cv ccrd
      cfv ccrd fveq2 vy cv cardidm syl6eq vv cv vy cv ccrd cfv vv cv ccrd cfv
      eqeq2 mpbird adantr 19.23aiv sylbi vv cv cardon syl6eqelr ssriv cA con0
      wcel vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex
      vz cA wral wa wa vy wex vx cab cint cvv wcel vx cv vy cv ccrd cfv wceq vy
      cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab c0
      wne cA con0 wcel vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss
      vw vy cv wrex vz cA wral wa wa vy wex vx cab cint cA ccf cfv cvv vx vy vz
      vw cA cfval cA ccf fvex syl6eqelr vx cv vy cv ccrd cfv wceq vy cv cA wss
      vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab intex sylibr
      sylancr eqeltrd vv cv ccrd cfv vv cv wceq cA ccf cfv ccrd cfv cA ccf cfv
      wceq vv cA ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss
      vw vy cv wrex vz cA wral wa wa vy wex vx cab vv cv cA ccf cfv wceq vv cv
      ccrd cfv cA ccf cfv ccrd cfv vv cv cA ccf cfv vv cv cA ccf cfv ccrd fveq2
      vv cv cA ccf cfv wceq id eqeq12d vv cv vx cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab wcel vv
      cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA
      wral wa wa vy wex vv cv ccrd cfv vv cv wceq vx cv vy cv ccrd cfv wceq vy
      cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vv cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vy wex vx vv cv vv visset vx cv vv cv wceq vx cv vy cv ccrd cfv wceq
      vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vv cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy vx cv vv cv wceq vx cv vy cv ccrd cfv wceq vv cv vy cv ccrd cfv wceq
      vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa vx cv vv cv vy
      cv ccrd cfv eqeq1 anbi1d exbidv elab vv cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vv cv ccrd cfv vv cv
      wceq vy vv cv vy cv ccrd cfv wceq vv cv ccrd cfv vv cv wceq vy cv cA wss
      vz cv vw cv wss vw vy cv wrex vz cA wral wa vv cv vy cv ccrd cfv wceq vv
      cv ccrd cfv vv cv wceq vv cv ccrd cfv vy cv ccrd cfv wceq vv cv vy cv
      ccrd cfv wceq vv cv ccrd cfv vy cv ccrd cfv ccrd cfv vy cv ccrd cfv vv cv
      vy cv ccrd cfv ccrd fveq2 vy cv cardidm syl6eq vv cv vy cv ccrd cfv vv cv
      ccrd cfv eqeq2 mpbird adantr 19.23aiv sylbi vtoclga syl cA con0 wcel wn
      cA ccf cfv c0 wceq cA ccf cfv ccrd cfv cA ccf cfv wceq cA con0 wcel wn cA
      ccf cdm wcel wn cA ccf cfv c0 wceq cA ccf cdm wcel cA con0 wcel ccf cdm
      con0 cA ccf con0 wfn ccf cdm con0 wceq cffnon con0 ccf fndm ax-mp eleq2i
      notbii cA ccf ndmfv sylbir cA ccf cfv c0 wceq c0 ccrd cfv c0 cA ccf cfv
      ccrd cfv cA ccf cfv card0 cA ccf cfv c0 ccrd fveq2 cA ccf cfv c0 wceq id
      3eqtr4a syl pm2.61i $.
      $( [3-Sep-2004] $) $( [24-Apr-2004] $)

    $( Cofinality is bounded by the cardinality of its argument. $)
    cflecard $p |- ( cf ` A ) C_ ( card ` A ) $=
      cA con0 wcel cA ccf cfv cA ccrd cfv wss cA con0 wcel cA ccf cfv vx cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vy wex vx cab cint cA ccrd cfv vx vy vz vw cA cfval cA con0 wcel vx cv
      vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral
      wa wa vy wex vx cab cint cA ccrd cfv csn cint cA ccrd cfv cA con0 wcel cA
      ccrd cfv csn vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy
      cv wrex vz cA wral wa wa vy wex vx cab wss vx cv vy cv ccrd cfv wceq vy
      cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab
      cint cA ccrd cfv csn cint wss cA con0 wcel vx cv cA ccrd cfv wceq vx cab
      vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz
      cA wral wa wa vy wex vx cab cA ccrd cfv csn cA con0 wcel vx cv cA ccrd
      cfv wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vy wex wi vx wal vx cv cA ccrd cfv wceq vx cab vx
      cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA
      wral wa wa vy wex vx cab wss cA con0 wcel vx cv cA ccrd cfv wceq vx cv vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa vy wex wi vx cA con0 wcel vx cv cA ccrd cfv wceq cA cA wss vz cv vw cv
      wss vw cA wrex vz cA wral wa vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv
      vw cv wss vw vy cv wrex vz cA wral wa wa vy wex cA cA wss vz cv vw cv wss
      vw cA wrex vz cA wral cA ssid vz cv vw cv wss vw cA wrex vz cA vz cv cA
      wcel vz cv vz cv wss vz cv vw cv wss vw cA wrex vz cv ssid vz cv vw cv
      wss vz cv vz cv wss vw vz cv cA vw cv vz cv vz cv sseq2 rcla4ev mpan2
      rgen pm3.2i vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy
      cv wrex vz cA wral wa wa vx cv cA ccrd cfv wceq cA cA wss vz cv vw cv wss
      vw cA wrex vz cA wral wa wa vy cA con0 vy cv cA wceq vx cv vy cv ccrd cfv
      wceq vx cv cA ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz
      cA wral wa cA cA wss vz cv vw cv wss vw cA wrex vz cA wral wa vy cv cA
      wceq vy cv ccrd cfv cA ccrd cfv vx cv vy cv cA ccrd fveq2 eqeq2d vy cv cA
      wceq vy cv cA wss cA cA wss vz cv vw cv wss vw vy cv wrex vz cA wral vz
      cv vw cv wss vw cA wrex vz cA wral vy cv cA cA sseq1 vy cv cA wceq vz cv
      vw cv wss vw vy cv wrex vz cv vw cv wss vw cA wrex vz cA vz cv vw cv wss
      vw vy cv cA rexeq1 ralbidv anbi12d anbi12d cla4egv mpan2i 19.21aiv vx cv
      cA ccrd cfv wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss
      vw vy cv wrex vz cA wral wa wa vy wex vx ss2ab sylibr vx cA ccrd cfv
      df-sn syl5ss cA ccrd cfv csn vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv
      vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab intss syl cA ccrd
      cfv cA ccrd fvex intsn syl6ss eqsstrd cA con0 wcel wn cA ccf cfv cA ccrd
      cfv wss c0 cA ccrd cfv wss cA ccrd cfv 0ss cA con0 wcel wn cA ccf cfv c0
      cA ccrd cfv cA con0 wcel wn cA ccf cdm wcel wn cA ccf cfv c0 wceq cA ccf
      cdm wcel cA con0 wcel ccf cdm con0 cA ccf con0 wfn ccf cdm con0 wceq
      cffnon con0 ccf fndm ax-mp eleq2i notbii cA ccf ndmfv sylbir sseq1d
      mpbiri pm2.61i $.
      $( [23-Oct-2004] $) $( [24-Apr-2004] $)

    $( Cofinality is bounded by its argument.  Exercise 1 of [TakeutiZaring]
       p. 102. $)
    cfle $p |- ( cf ` A ) C_ A $=
      cA con0 wcel cA ccf cfv cA wss cA con0 wcel cA ccrd cfv cA wss cA ccf cfv
      cA wss cA cardonle cA ccf cfv cA ccrd cfv wss cA ccrd cfv cA wss cA ccf
      cfv cA wss wi cA cflecard cA ccf cfv cA ccrd cfv cA sstr2 ax-mp syl cA
      con0 wcel wn cA ccf cfv cA wss c0 cA wss cA 0ss cA con0 wcel wn cA ccf
      cfv c0 cA cA con0 wcel wn cA ccf cdm wcel wn cA ccf cfv c0 wceq cA ccf
      cdm wcel cA con0 wcel ccf cdm con0 cA ccf con0 wfn ccf cdm con0 wceq
      cffnon con0 ccf fndm ax-mp eleq2i notbii cA ccf ndmfv sylbir sseq1d
      mpbiri pm2.61i $.
      $( [23-Oct-2004] $) $( [26-Apr-2004] $)

    $( Only the ordinal zero has cofinality zero. $)
    cfeq0 $p |- ( A e. On -> ( ( cf ` A ) = (/) <-> A = (/) ) ) $=
      cA con0 wcel cA ccf cfv c0 wceq cA c0 wceq cA con0 wcel cA ccf cfv c0
      wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex
      vz cA wral wa wa vy wex vx cab cint c0 wceq cA c0 wceq cA con0 wcel cA
      ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa wa vy wex vx cab cint c0 vx vy vz vw cA cfval eqeq1d
      vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz
      cA wral wa wa vy wex vx cab cint c0 wceq c0 vx cv vy cv ccrd cfv wceq vy
      cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab
      wcel cA c0 wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw
      vy cv wrex vz cA wral wa wa vy wex vx cab con0 wss vx cv vy cv ccrd cfv
      wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex
      vx cab cint c0 wceq c0 vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa wa vy wex vx cab wcel wb vv vx cv vy cv
      ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa
      vy wex vx cab con0 vv cv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw
      cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab wcel vv cv vv cv ccrd
      cfv con0 vv cv vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw
      vy cv wrex vz cA wral wa wa vy wex vx cab wcel vv cv vy cv ccrd cfv wceq
      vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vv cv
      ccrd cfv vv cv wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa wa vy wex vv cv vy cv ccrd cfv wceq vy cv
      cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx vv cv vv
      visset vx cv vv cv wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw
      cv wss vw vy cv wrex vz cA wral wa wa vv cv vy cv ccrd cfv wceq vy cv cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy vx cv vv cv wceq vx
      cv vy cv ccrd cfv wceq vv cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa vx cv vv cv vy cv ccrd cfv eqeq1 anbi1d
      exbidv elab vv cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy
      cv wrex vz cA wral wa wa vv cv ccrd cfv vv cv wceq vy vv cv vy cv ccrd
      cfv wceq vv cv ccrd cfv vv cv wceq vy cv cA wss vz cv vw cv wss vw vy cv
      wrex vz cA wral wa vv cv vy cv ccrd cfv wceq vv cv ccrd cfv vv cv wceq vv
      cv ccrd cfv vy cv ccrd cfv wceq vv cv vy cv ccrd cfv wceq vv cv ccrd cfv
      vy cv ccrd cfv ccrd cfv vy cv ccrd cfv vv cv vy cv ccrd cfv ccrd fveq2 vy
      cv cardidm syl6eq vv cv vy cv ccrd cfv vv cv ccrd cfv eqeq2 mpbird adantr
      19.23aiv sylbi vv cv cardon syl6eqelr ssriv vx cv vy cv ccrd cfv wceq vy
      cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex vx cab
      onint0 ax-mp c0 vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw
      vy cv wrex vz cA wral wa wa vy wex vx cab wcel c0 vy cv ccrd cfv wceq vy
      cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa vy wex cA c0
      wceq vx cv vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex
      vz cA wral wa wa vy wex c0 vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv
      wss vw vy cv wrex vz cA wral wa wa vy wex vx c0 0ex vx cv c0 wceq vx cv
      vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral
      wa wa c0 vy cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex
      vz cA wral wa wa vy vx cv c0 wceq vx cv vy cv ccrd cfv wceq c0 vy cv ccrd
      cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa vx cv
      c0 vy cv ccrd cfv eqeq1 anbi1d exbidv elab c0 vy cv ccrd cfv wceq vy cv
      cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa wa cA c0 wceq vy c0 vy
      cv ccrd cfv wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa
      wa c0 cA wss vz cv vw cv wss vw c0 wrex vz cA wral wa cA c0 wceq vy cv c0
      wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa c0 cA wss
      vz cv vw cv wss vw c0 wrex vz cA wral wa c0 vy cv ccrd cfv wceq vy cv c0
      wceq vy cv cA wss vz cv vw cv wss vw vy cv wrex vz cA wral wa c0 cA wss
      vz cv vw cv wss vw c0 wrex vz cA wral wa vy cv c0 wceq vy cv cA wss c0 cA
      wss vz cv vw cv wss vw vy cv wrex vz cA wral vz cv vw cv wss vw c0 wrex
      vz cA wral vy cv c0 cA sseq1 vy cv c0 wceq vz cv vw cv wss vw vy cv wrex
      vz cv vw cv wss vw c0 wrex vz cA vz cv vw cv wss vw vy cv c0 rexeq1
      ralbidv anbi12d biimpa c0 vy cv ccrd cfv wceq vy cv ccrd cfv c0 wceq vy
      cv c0 wceq c0 vy cv ccrd cfv eqcom vy cv cvv wcel vy cv ccrd cfv c0 wceq
      vy cv c0 wceq wb vy visset vy cv cvv cardeq0 ax-mp bitri sylanb vz cv vw
      cv wss vw c0 wrex vz cA wral cA c0 wceq c0 cA wss vz cv vw cv wss vw c0
      wrex vz cA wral cA c0 cA c0 wne vz cv vw cv wss vw c0 wrex wn vz cA wrex
      vz cv vw cv wss vw c0 wrex vz cA wral wn cA c0 wne vz cv vw cv wss vw c0
      wrex wn vz cA wral vz cv vw cv wss vw c0 wrex wn vz cA wrex vz cv vw cv
      wss vw c0 wrex wn vz cA vz cv vw cv wss vw c0 wrex wn vz cv cA wcel vz cv
      vw cv wss vw rex0 a1i rgen vz cv vw cv wss vw c0 wrex wn vz cA r19.2z
      mpan2 vz cv vw cv wss vw c0 wrex vz cA rexnal sylib necon4ai adantl syl
      19.23aiv sylbi sylbi syl6bi cA c0 wceq cA ccf cfv c0 ccf cfv c0 cA c0 ccf
      fveq2 cf0 syl6eq impbid1 $.
      $( [2-Feb-2005] $) $( [24-Apr-2004] $)
  $}

  ${
    $d x y z w v A $.
    $( Value of the cofinality function at a successor ordinal.  Exercise 3 of
       [TakeutiZaring] p. 102. $)
    cfsuc $p |- ( A e. On -> ( cf ` suc A ) = 1o ) $=
      cA con0 wcel cA csuc ccf cfv vx cv vy cv ccrd cfv wceq vy cv cA csuc wss
      vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx cab cint
      c1o cA con0 wcel cA csuc con0 wcel cA csuc ccf cfv vx cv vy cv ccrd cfv
      wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa
      wa vy wex vx cab cint wceq cA sucelon vx vy vz vw cA csuc cfval sylbi c1o
      vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex
      vz cA csuc wral wa wa vy wex vx cab wcel vv cv vx cv vy cv ccrd cfv wceq
      vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy
      wex vx cab wcel wn vv c1o wral c1o vx cv vy cv ccrd cfv wceq vy cv cA
      csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx
      cab cint wceq cA con0 wcel vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz
      cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx cab con0 wss
      c1o vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv
      wrex vz cA csuc wral wa wa vy wex vx cab wcel vv cv vx cv vy cv ccrd cfv
      wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa
      wa vy wex vx cab wcel wn vv c1o wral wa c1o vx cv vy cv ccrd cfv wceq vy
      cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex
      vx cab cint wceq wi vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw
      cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx con0 vx cv vy cv
      ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc
      wral wa wa vx cv con0 wcel vy vx cv vy cv ccrd cfv wceq vx cv con0 wcel
      vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa vx cv
      vy cv ccrd cfv wceq vx cv con0 wcel vy cv ccrd cfv con0 wcel vy cv cardon
      vx cv vy cv ccrd cfv con0 eleq1 mpbiri adantr 19.23aiv abssi vv c1o vx cv
      vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA
      csuc wral wa wa vy wex vx cab oneqmini ax-mp cA con0 wcel c1o vy cv ccrd
      cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral
      wa wa vy wex c1o vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv
      wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx cab wcel c1o cA csn
      ccrd cfv wceq cA csn cA csuc wss vz cv vw cv wss vw cA csn wrex vz cA
      csuc wral wa c1o vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw
      vy cv wrex vz cA csuc wral wa wa vy wex cA con0 wcel c1o vy cv ccrd cfv
      wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa
      wa c1o cA csn ccrd cfv wceq cA csn cA csuc wss vz cv vw cv wss vw cA csn
      wrex vz cA csuc wral wa wa vy cA csn cA snex vy cv cA csn wceq c1o vy cv
      ccrd cfv wceq c1o cA csn ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss
      vw vy cv wrex vz cA csuc wral wa cA csn cA csuc wss vz cv vw cv wss vw cA
      csn wrex vz cA csuc wral wa vy cv cA csn wceq vy cv ccrd cfv cA csn ccrd
      cfv c1o vy cv cA csn ccrd fveq2 eqeq2d vy cv cA csn wceq vy cv cA csuc
      wss cA csn cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral vz
      cv vw cv wss vw cA csn wrex vz cA csuc wral vy cv cA csn cA csuc sseq1 vy
      cv cA csn wceq vz cv vw cv wss vw vy cv wrex vz cv vw cv wss vw cA csn
      wrex vz cA csuc vz cv vw cv wss vw vy cv cA csn rexeq1 ralbidv anbi12d
      anbi12d cla4ev cA con0 wcel cA csn ccrd cfv c1o cA con0 cardsn eqcomd cA
      con0 wcel vz cv vw cv wss vw cA csn wrex vz cA csuc wral cA csn cA csuc
      wss cA con0 wcel vz cv vw cv wss vw cA csn wrex vz cA csuc cA con0 wcel
      vz cv cA csuc wcel cA cA csn wcel vz cv cA wss wa vz cv vw cv wss vw cA
      csn wrex cA con0 wcel vz cv cA csuc wcel vz cv cA wss cA cA csn wcel cA
      con0 wcel vz cv cA wcel vz cv cA wceq wo vz cv cA wss vz cv cA csuc wcel
      cA con0 wcel vz cv cA wcel vz cv cA wss vz cv cA wceq cA vz cv onelss vz
      cv cA wceq vz cv cA wss wi cA con0 wcel vz cv cA eqimss a1i jaod vz cv cA
      elsuci syl5 cA con0 snidg jctild vz cv vw cv wss vz cv cA wss vw cA cA
      csn vw cv cA vz cv sseq2 rcla4ev syl6 r19.21aiv cA csn cA cA csn cun cA
      csuc cA csn cA ssun2 cA df-suc sseqtr4i jctil sylanc vx cv vy cv ccrd cfv
      wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa
      wa vy wex c1o vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy
      cv wrex vz cA csuc wral wa wa vy wex vx c1o c1o con0 1on elisseti vx cv
      c1o wceq vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw
      vy cv wrex vz cA csuc wral wa wa c1o vy cv ccrd cfv wceq vy cv cA csuc
      wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy vx cv c1o wceq
      vx cv vy cv ccrd cfv wceq c1o vy cv ccrd cfv wceq vy cv cA csuc wss vz cv
      vw cv wss vw vy cv wrex vz cA csuc wral wa vx cv c1o vy cv ccrd cfv eqeq1
      anbi1d exbidv elab sylibr vv cv vx cv vy cv ccrd cfv wceq vy cv cA csuc
      wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx cab
      wcel wn vv c1o vv cv c1o wcel vv cv c0 wceq vv cv vx cv vy cv ccrd cfv
      wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa
      wa vy wex vx cab wcel wn vv cv el1o vv cv c0 wceq vv cv vx cv vy cv ccrd
      cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral
      wa wa vy wex vx cab wcel c0 vx cv vy cv ccrd cfv wceq vy cv cA csuc wss
      vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex vx cab wcel c0
      vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex
      vz cA csuc wral wa wa vy wex vx cab wcel c0 vy cv ccrd cfv wceq vy cv cA
      csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa vy wex c0 vy
      cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA
      csuc wral wa wa vy c0 vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv
      wss vw vy cv wrex vz cA csuc wral wa wn wi c0 vy cv ccrd cfv wceq vy cv
      cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa wa wn c0 vy
      cv ccrd cfv wceq vz cv vw cv wss vw vy cv wrex vz cA csuc wral vy cv cA
      csuc wss c0 vy cv ccrd cfv wceq vy cv c0 wceq vz cv vw cv wss vw vy cv
      wrex vz cA csuc wral wn c0 vy cv ccrd cfv wceq vy cv ccrd cfv c0 wceq vy
      cv c0 wceq c0 vy cv ccrd cfv eqcom vy cv cvv wcel vy cv ccrd cfv c0 wceq
      vy cv c0 wceq wb vy visset vy cv cvv cardeq0 ax-mp bitri vy cv c0 wceq vz
      cv vw cv wss vw vy cv wrex vz cA csuc wral vz cv vw cv wss vw c0 wrex vz
      cA csuc wral vz cv vw cv wss vw c0 wrex vz cA csuc wral vz cv vw cv wss
      vw c0 wrex vz cA csuc wrex vz cv vw cv wss vw c0 wrex vz cA csuc vz cv vw
      cv wss vw c0 wrex wn vz cv cA csuc wcel vz cv vw cv wss vw rex0 a1i nrex
      cA csuc c0 wne vz cv vw cv wss vw c0 wrex vz cA csuc wral vz cv vw cv wss
      vw c0 wrex vz cA csuc wrex cA nsuceq0 vz cv vw cv wss vw c0 wrex vz cA
      csuc r19.2z mpan mto vy cv c0 wceq vz cv vw cv wss vw vy cv wrex vz cv vw
      cv wss vw c0 wrex vz cA csuc vz cv vw cv wss vw vy cv c0 rexeq1 ralbidv
      mtbiri sylbi intnand c0 vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv
      wss vw vy cv wrex vz cA csuc wral wa imnan mpbi nex vx cv vy cv ccrd cfv
      wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc wral wa
      wa vy wex c0 vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy
      cv wrex vz cA csuc wral wa wa vy wex vx c0 0ex vx cv c0 wceq vx cv vy cv
      ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz cA csuc
      wral wa wa c0 vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy
      cv wrex vz cA csuc wral wa wa vy vx cv c0 wceq vx cv vy cv ccrd cfv wceq
      c0 vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy cv wrex vz
      cA csuc wral wa vx cv c0 vy cv ccrd cfv eqeq1 anbi1d exbidv elab mtbir vv
      cv c0 vx cv vy cv ccrd cfv wceq vy cv cA csuc wss vz cv vw cv wss vw vy
      cv wrex vz cA csuc wral wa wa vy wex vx cab eleq1 mtbiri sylbi rgen
      sylancl eqtr4d $.
      $( [31-Oct-2004] $) $( [23-Apr-2004] $)
  $}

  ${
    $d x y z w $.
    $( Value of the cofinality function at omega (the set of natural numbers).
       Exercise 4 of [TakeutiZaring] p. 102. $)
    cfom $p |- ( cf ` om ) = om $=
      com ccf cfv com com cfle com com csn cint com ccf cfv com omex intsn com
      csn cint vx cv vy cv ccrd cfv wceq vy cv com wss vz cv vw cv wss vw vy cv
      wrex vz com wral wa wa vy wex vx cab cint com ccf cfv vx cv vy cv ccrd
      cfv wceq vy cv com wss vz cv vw cv wss vw vy cv wrex vz com wral wa wa vy
      wex vx cab com csn wss com csn cint vx cv vy cv ccrd cfv wceq vy cv com
      wss vz cv vw cv wss vw vy cv wrex vz com wral wa wa vy wex vx cab cint
      wss vx cv vy cv ccrd cfv wceq vy cv com wss vz cv vw cv wss vw vy cv wrex
      vz com wral wa wa vy wex vx cab vx cv com wceq vx cab com csn vx cv vy cv
      ccrd cfv wceq vy cv com wss vz cv vw cv wss vw vy cv wrex vz com wral wa
      wa vy wex vx cv com wceq vx vx cv vy cv ccrd cfv wceq vy cv com wss vz cv
      vw cv wss vw vy cv wrex vz com wral wa wa vx cv com wceq vy vx cv vy cv
      ccrd cfv wceq vy cv ccrd cfv com wceq vx cv com wceq vy cv com wss vz cv
      vw cv wss vw vy cv wrex vz com wral wa vx cv vy cv ccrd cfv com eqtr vy
      cv com wss vz cv vw cv wss vw vy cv wrex vz com wral wa vy cv ccrd cfv
      com ccrd cfv com vy cv com wss vz cv vw cv wss vw vy cv wrex vz com wral
      wa vy cv com cen wbr vy cv ccrd cfv com ccrd cfv wceq vz vw vy cv vy
      visset unbnn2 vy cv cvv wcel com cvv wcel vy cv ccrd cfv com ccrd cfv
      wceq vy cv com cen wbr wb vy visset omex vy cv com cvv cvv carden mp2an
      sylibr cardom syl6eq sylan2 19.23aiv ss2abi vx com df-sn sseqtr4i vx cv
      vy cv ccrd cfv wceq vy cv com wss vz cv vw cv wss vw vy cv wrex vz com
      wral wa wa vy wex vx cab com csn intss ax-mp com con0 wcel com ccf cfv vx
      cv vy cv ccrd cfv wceq vy cv com wss vz cv vw cv wss vw vy cv wrex vz com
      wral wa wa vy wex vx cab cint wceq omelon vx vy vz vw com cfval ax-mp
      sseqtr4i eqsstr3i eqssi $.
      $( [27-Oct-2004] $) $( [23-Apr-2004] $)
  $}


$( I decided to comment out the Card class for now.  We have too many
   definitions, and this one doesn't really buy us much. $)

$(
  @c Card @. @( Class of all cardinal numbers @)

  @( Extend class definition to include the class of all cardinal numbers. @)
  ccdn @a class Card @.

  @( Define the class of all cardinal numbers.  The notation "Card" is used
     in Exercise 5(G) of [JustWeese] p. 174.  It should not be confused with
     the lower-case "card" for the cardinal number function ~ df-card .  @)
  df-cardn @a |- Card = ( om u. ran aleph ) @.

  @( Membership in the class of cardinal numbers. @)
  elcard @p |- ( A e. Card <-> ( card ` A ) = A ) @=
    ( ccdn wcel com cale crn cun ccrd cfv wceq df-cardn eleq2i iscard3 bitr4i )
    ABCADEFGZCAHIAJBOAKLAMN @.
    @( [31-Dec-2004] @) @( [23-Sep-2004] @)

  @( The cardinality of a set is a cardinal number. @)
  cardel @p |- ( card ` A ) e. Card @=
    ( ccrd cfv ccdn wcel wceq cardidm elcard mpbir ) ABCZDEJBCJFAGJHI @.
    @( [16-Jan-2005] @) @( [23-Sep-2004] @)

  @( A natural number is a cardinal number. @)
  nncard @p |- ( A e. om -> A e. Card ) @=
    ( com wcel ccrd cfv wceq ccdn cardnn elcard sylibr ) ABCADEAFAGCAHAIJ @.
    @( [16-Jan-2005] @) @( [23-Sep-2004] @)

  @( An alternate definition of the class of all cardinal numbers. @)
  cardnum2 @p |- Card = { x | ( card ` x ) = x } @=
    ( ccdn com cale crn cun cv ccrd cfv wceq cab df-cardn wcel iscard3 bicomi
    abbi2i eqcomi eqtr4i ) BCDEFZAGZHITJZAKZLSUBUAASUATSMTNOPQR @.
    @( [25-Jan-2005] @) @( [23-Sep-2004] @)

  @( The class of cardinal numbers is a proper class.  Exercise 5(G)(b) of
     [JustWeese] p. 174. @)
  cardnprc @p |- -. Card e. _V @=
    ( vx ccdn cvv wcel cv ccrd cfv wceq cab cardprc cardnum2 eleq1i mtbir ) BCD
    AEZFGNHAIZCDAJBOCAKLM @.
    @( [25-Jan-2005] @) @( [23-Sep-2004] @)

  @( The class of transfinite cardinals (the range of the aleph function) is a
     proper class. @)
  alephprc2 @p |- -. ran aleph e. _V @=
    ( cale crn cvv wcel com cun ccdn cardnprc df-cardn eleq1i mtbi omex wa
    unexb biimpi mpan mto ) ABZCDZERFZCDZGCDUAHGTCIJKECDZSUALUBSMUAERNOPQ @.
    @( [19-Feb-2005] @) @( [23-Sep-2004] @)
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Cardinal number arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c +c $. $( Cardinal number addition $)

  $( Extend class definition to include cardinal number addition. $)
  ccda $a class +c $.

  ${
    $d x y z $.
    $( Define cardinal number addition.  Definition of cardinal sum in
       [Mendelson] p. 258.  See ~ cdavali for its value and a description. $)
    df-cda $a |- +c = { <. <. x , y >. , z >. |
                   z = ( ( x X. { (/) } ) u. ( y X. { 1o } ) ) } $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Value of cardinal addition.  Definition of cardinal sum in [Mendelson]
       p. 258. $)
    cdaval $p |- ( ( A e. C /\ B e. D ) ->  ( A +c B ) =
                    ( ( A X. { (/) } ) u. ( B X. { 1o } ) ) ) $=
      cA cvv wcel cB cvv wcel cA cB ccda co cA c0 csn cxp cB c1o csn cxp cun
      wceq cA cC wcel cB cD wcel cA cvv wcel cB cvv wcel cA c0 csn cxp cB c1o
      csn cxp cun cvv wcel cA cB ccda co cA c0 csn cxp cB c1o csn cxp cun wceq
      cA cvv wcel cB cvv wcel wa cA c0 csn cxp cvv wcel cB c1o csn cxp cvv wcel
      wa cA c0 csn cxp cB c1o csn cxp cun cvv wcel cA cvv wcel cA c0 csn cxp
      cvv wcel cB cvv wcel cB c1o csn cxp cvv wcel cA cvv wcel c0 csn cvv wcel
      cA c0 csn cxp cvv wcel p0ex cA c0 csn cvv cvv xpexg mpan2 cB cvv wcel c1o
      csn cvv wcel cB c1o csn cxp cvv wcel c1o snex cB c1o csn cvv cvv xpexg
      mpan2 anim12i cA c0 csn cxp cB c1o csn cxp unexb sylib vx vy vz cA cB cvv
      cvv vx cv c0 csn cxp vy cv c1o csn cxp cun cA c0 csn cxp cB c1o csn cxp
      cun ccda cA c0 csn cxp vy cv c1o csn cxp cun cvv vx cv cA wceq vx cv c0
      csn cxp cA c0 csn cxp vy cv c1o csn cxp vx cv cA c0 csn xpeq1 uneq1d vy
      cv cB wceq vy cv c1o csn cxp cB c1o csn cxp cA c0 csn cxp vy cv cB c1o
      csn xpeq1 uneq2d ccda vz cv vx cv c0 csn cxp vy cv c1o csn cxp cun wceq
      vx vy vz copab2 vx cv cvv wcel vy cv cvv wcel wa vz cv vx cv c0 csn cxp
      vy cv c1o csn cxp cun wceq wa vx vy vz copab2 vx vy vz df-cda vz cv vx cv
      c0 csn cxp vy cv c1o csn cxp cun wceq vx cv cvv wcel vy cv cvv wcel wa vz
      cv vx cv c0 csn cxp vy cv c1o csn cxp cun wceq wa vx vy vz vx cv cvv wcel
      vy cv cvv wcel wa vz cv vx cv c0 csn cxp vy cv c1o csn cxp cun wceq vx cv
      cvv wcel vy cv cvv wcel vx visset vy visset pm3.2i biantrur oprabbii
      eqtri oprabval2g mpd3an3 cA cC elisset cB cD elisset syl2an $.
      $( [28-Sep-2004] $) $( [24-Sep-2004] $)
  $}

  ${
    cdaval.1 $e |- A e. _V $.
    cdaval.2 $e |- B e. _V $.
    $( Value of cardinal addition.  Definition of cardinal sum in [Mendelson]
       p. 258.  For cardinal arithmetic, we follow Mendelson.  Rather than
       defining operations restricted to cardinal numbers, we use this disjoint
       union operation for addition, while cross product and set exponentiation
       stand in for cardinal multiplication and exponentiation.  Equinumerosity
       and dominance serve the roles of equality and ordering.  If we wanted
       to, we could easily convert our theorems to actual cardinal number
       operations via ~ carden , ~ carddom , and ~ cardsdom .  The advantage of
       Mendelson's approach is that we can directly use many equinumerosity
       theorems that we already have available. $)
    cdavali $p |- ( A +c B ) = ( ( A X. { (/) } ) u. ( B X. { 1o } ) ) $=
      cA cvv wcel cB cvv wcel cA cB ccda co cA c0 csn cxp cB c1o csn cxp cun
      wceq cdaval.1 cdaval.2 cA cB cvv cvv cdaval mp2an $.
      $( [28-Sep-2004] $) $( [27-Sep-2004] $)

    $( Cardinal addition dominates union. $)
    uncdadom $p |- ( A u. B ) ~<_ ( A +c B ) $=
      cA cB cun cA c0 csn cxp cB c1o csn cxp cun cA cB ccda co cdom cA cA c0
      csn cxp cdom wbr cB cB c1o csn cxp cdom wbr wa cA c0 csn cxp cB c1o csn
      cxp cin c0 wceq cA cB cun cA c0 csn cxp cB c1o csn cxp cun cdom wbr cA cA
      c0 csn cxp cdom wbr cB cB c1o csn cxp cdom wbr cA cA c0 csn cxp cen wbr
      cA cA c0 csn cxp cdom wbr cA c0 csn cxp cA cdaval.1 cA c0 cdaval.1 0ex
      xpsnen ensymi cA cA c0 csn cxp endom ax-mp cB cB c1o csn cxp cen wbr cB
      cB c1o csn cxp cdom wbr cB c1o csn cxp cB cdaval.2 cB c1o cdaval.2 c1o
      con0 1on elisseti xpsnen ensymi cB cB c1o csn cxp endom ax-mp pm3.2i cA
      cB xp01disj cA cA c0 csn cxp cB cB c1o csn cxp cA c0 csn cdaval.1 p0ex
      xpex cdaval.2 cB c1o csn cdaval.2 c1o snex xpex undom mp2an cA cB
      cdaval.1 cdaval.2 cdavali breqtrri $.
      $( [24-Jul-2006] $) $( [28-Sep-2004] $)

    $( Cardinal addition is equinumerous to union for disjoint sets. $)
    cdaun $p |- ( ( A i^i B ) = (/) -> ( A +c B ) ~~ ( A u. B ) ) $=
      cA cB cin c0 wceq cA c0 csn cxp cB c1o csn cxp cun cA cB cun cA cB ccda
      co cen cA c0 csn cxp cB c1o csn cxp cin c0 wceq cA cB cin c0 wceq cA c0
      csn cxp cB c1o csn cxp cun cA cB cun cen wbr cA cB xp01disj cA c0 csn cxp
      cA cen wbr cB c1o csn cxp cB cen wbr cA c0 csn cxp cB c1o csn cxp cin c0
      wceq cA cB cin c0 wceq wa cA c0 csn cxp cB c1o csn cxp cun cA cB cun cen
      wbr cA c0 cdaval.1 0ex xpsnen cB c1o cdaval.2 c1o con0 1on elisseti
      xpsnen cA c0 csn cxp cA cB c1o csn cxp cB unen mpanl12 mpan cA cB
      cdaval.1 cdaval.2 cdavali syl5eqbr $.
      $( [12-Jul-2007] $) $( [5-Apr-2007] $)
  $}

  ${
    $d A x y $.  $d B y $.
    $( Cardinal addition is equinumerous to union for disjoint sets.
       (Contributed by Paul Chapman, 5-Jun-2009.) $)
    cdaung $p |- ( ( A e. C /\ B e. D /\ ( A i^i B ) = (/) ) ->
                   ( A +c B ) ~~ ( A u. B ) ) $=
      cA cC wcel cB cD wcel cA cB cin c0 wceq cA cB ccda co cA cB cun cen wbr
      vx cv vy cv cin c0 wceq vx cv vy cv ccda co vx cv vy cv cun cen wbr wi cA
      vy cv cin c0 wceq cA vy cv ccda co cA vy cv cun cen wbr wi cA cB cin c0
      wceq cA cB ccda co cA cB cun cen wbr wi vx vy cA cB cC cD vx cv cA wceq
      vx cv vy cv cin c0 wceq cA vy cv cin c0 wceq vx cv vy cv ccda co vx cv vy
      cv cun cen wbr cA vy cv ccda co cA vy cv cun cen wbr vx cv cA wceq vx cv
      vy cv cin cA vy cv cin c0 vx cv cA vy cv ineq1 eqeq1d vx cv cA wceq vx cv
      vy cv ccda co cA vy cv ccda co vx cv vy cv cun cA vy cv cun cen vx cv cA
      vy cv ccda opreq1 vx cv cA vy cv uneq1 breq12d imbi12d vy cv cB wceq cA
      vy cv cin c0 wceq cA cB cin c0 wceq cA vy cv ccda co cA vy cv cun cen wbr
      cA cB ccda co cA cB cun cen wbr vy cv cB wceq cA vy cv cin cA cB cin c0
      vy cv cB cA ineq2 eqeq1d vy cv cB wceq cA vy cv ccda co cA cB ccda co cA
      vy cv cun cA cB cun cen vy cv cB cA ccda opreq2 vy cv cB cA uneq2 breq12d
      imbi12d vx cv vy cv vx visset vy visset cdaun vtocl2g 3impia $.
      $( [5-Jun-2009] $) $( [5-Jun-2009] $)
  $}

  $( 1+1=2 for cardinal number addition.  Theorem *110.643 of _Principia
     Mathematica_, vol. II, p. 86, which adds the remark, "The above
     proposition is occasionally useful."  Unlike us, Whitehead and Russell
     define cardinal addition on collections of all sets equinumerous to 1 and
     2 (which for us are proper classes unless we restrict them as in
     ~ karden ), but after applying definitions, our theorem is equivalent.
     See also the comment for ~ pm54.43 .  The comment for ~ cdavali explains
     why we use ` ~~ ` instead of =. $)
  pm110.643 $p |- ( 1o +c 1o ) ~~ 2o $=
    c1o c1o ccda co c1o c0 csn cxp c1o c1o csn cxp cun c2o cen c1o c1o c1o con0
    1on elisseti c1o con0 1on elisseti cdavali c1o c0 csn cxp c1o c1o csn cxp
    cin c0 wceq c1o c0 csn cxp c1o c1o csn cxp cun c2o cen wbr c1o c1o xp01disj
    c1o c0 csn cxp c1o cen wbr c1o c1o csn cxp c1o cen wbr c1o c0 csn cxp c1o
    c1o csn cxp cin c0 wceq c1o c0 csn cxp c1o c1o csn cxp cun c2o cen wbr wb
    c1o c0 c1o con0 1on elisseti 0ex xpsnen c1o c1o c1o con0 1on elisseti c1o
    con0 1on elisseti xpsnen c1o c0 csn cxp c1o c1o csn cxp pm54.43 mp2an mpbi
    eqbrtri $.
    $( [5-Apr-2007] $) $( [5-Apr-2007] $)

  ${
    cdaen.1 $e |- A e. _V $.
    cdaen.2 $e |- B e. _V $.
    cdaen.3 $e |- C e. _V $.
    cdaen.4 $e |- D e. _V $.
    $( Cardinal addition of equinumerous sets.  Exercise 4.56(b) of
       [Mendelson] p. 258. $)
    cdaen $p |- ( ( A ~~ B /\ C ~~ D ) -> ( A +c C ) ~~ ( B +c D ) ) $=
      cA cB cen wbr cC cD cen wbr wa cA c0 csn cxp cC c1o csn cxp cun cB c0 csn
      cxp cD c1o csn cxp cun cA cC ccda co cB cD ccda co cen cA c0 csn cxp cB
      c0 csn cxp cen wbr cC c1o csn cxp cD c1o csn cxp cen wbr cA c0 csn cxp cC
      c1o csn cxp cun cB c0 csn cxp cD c1o csn cxp cun cen wbr cA cB cen wbr cC
      cD cen wbr cA c0 csn cxp cB c0 csn cxp cen wbr cC c1o csn cxp cD c1o csn
      cxp cen wbr wa cA c0 csn cxp cC c1o csn cxp cin c0 wceq cB c0 csn cxp cD
      c1o csn cxp cin c0 wceq cA c0 csn cxp cC c1o csn cxp cun cB c0 csn cxp cD
      c1o csn cxp cun cen wbr cA cC xp01disj cB cD xp01disj cA c0 csn cxp cB c0
      csn cxp cC c1o csn cxp cD c1o csn cxp unen mpanr12 cA c0 csn cxp cB c0
      csn cxp cen wbr cA cB c0 csn cxp cen wbr cA cB cen wbr cA cvv wcel cA c0
      csn cxp cA cen wbr cA c0 csn cxp cB c0 csn cxp cen wbr cA cB c0 csn cxp
      cen wbr wb cdaen.1 cA c0 cdaen.1 0ex xpsnen cA c0 csn cxp cA cB c0 csn
      cxp cvv enen1 mp2an cB cvv wcel cB c0 csn cxp cB cen wbr cA cB c0 csn cxp
      cen wbr cA cB cen wbr wb cdaen.2 cB c0 cdaen.2 0ex xpsnen cB c0 csn cxp
      cB cA cvv enen2 mp2an bitri cC c1o csn cxp cD c1o csn cxp cen wbr cC cD
      c1o csn cxp cen wbr cC cD cen wbr cC cvv wcel cC c1o csn cxp cC cen wbr
      cC c1o csn cxp cD c1o csn cxp cen wbr cC cD c1o csn cxp cen wbr wb
      cdaen.3 cC c1o cdaen.3 c1o con0 1on elisseti xpsnen cC c1o csn cxp cC cD
      c1o csn cxp cvv enen1 mp2an cD cvv wcel cD c1o csn cxp cD cen wbr cC cD
      c1o csn cxp cen wbr cC cD cen wbr wb cdaen.4 cD c1o cdaen.4 c1o con0 1on
      elisseti xpsnen cD c1o csn cxp cD cC cvv enen2 mp2an bitri syl2anbr cA cC
      cdaen.1 cdaen.3 cdavali cB cD cdaen.2 cdaen.4 cdavali 3brtr4g $.
      $( [24-Jul-2006] $) $( [28-Sep-2004] $)
  $}

  ${
    $d A w x y z $.  $d B w y z $.  $d C w z $.  $d D w $.  $d W w z $.
    $d X w z $.
    $( Cardinal addition of equinumerous sets.  Exercise 4.56(b) of
       [Mendelson] p. 258. (Contributed by Paul Chapman, 5-Jun-2009.) $)
    cdaeng $p |- ( ( ( A e. W /\ B e. X ) /\ ( C e. Y /\ D e. Z ) /\
                     ( A ~~ B /\ C ~~ D ) ) -> ( A +c C ) ~~ ( B +c D ) ) $=
      cA cW wcel cB cX wcel wa cC cY wcel cD cZ wcel wa cA cB cen wbr cC cD cen
      wbr wa cA cC ccda co cB cD ccda co cen wbr cC cY wcel cD cZ wcel wa cA cW
      wcel cB cX wcel wa cA cB cen wbr cC cD cen wbr wa cA cC ccda co cB cD
      ccda co cen wbr wi cA cW wcel cB cX wcel wa cA cB cen wbr vz cv vw cv cen
      wbr wa cA vz cv ccda co cB vw cv ccda co cen wbr wi wi cA cW wcel cB cX
      wcel wa cA cB cen wbr cC vw cv cen wbr wa cA cC ccda co cB vw cv ccda co
      cen wbr wi wi cA cW wcel cB cX wcel wa cA cB cen wbr cC cD cen wbr wa cA
      cC ccda co cB cD ccda co cen wbr wi wi vz vw cC cD cY cZ vz cv cC wceq cA
      cB cen wbr vz cv vw cv cen wbr wa cA vz cv ccda co cB vw cv ccda co cen
      wbr wi cA cB cen wbr cC vw cv cen wbr wa cA cC ccda co cB vw cv ccda co
      cen wbr wi cA cW wcel cB cX wcel wa vz cv cC wceq cA cB cen wbr vz cv vw
      cv cen wbr wa cA cB cen wbr cC vw cv cen wbr wa cA vz cv ccda co cB vw cv
      ccda co cen wbr cA cC ccda co cB vw cv ccda co cen wbr vz cv cC wceq vz
      cv vw cv cen wbr cC vw cv cen wbr cA cB cen wbr vz cv cC vw cv cen breq1
      anbi2d vz cv cC wceq cA vz cv ccda co cA cC ccda co cB vw cv ccda co cen
      vz cv cC cA ccda opreq2 breq1d imbi12d imbi2d vw cv cD wceq cA cB cen wbr
      cC vw cv cen wbr wa cA cC ccda co cB vw cv ccda co cen wbr wi cA cB cen
      wbr cC cD cen wbr wa cA cC ccda co cB cD ccda co cen wbr wi cA cW wcel cB
      cX wcel wa vw cv cD wceq cA cB cen wbr cC vw cv cen wbr wa cA cB cen wbr
      cC cD cen wbr wa cA cC ccda co cB vw cv ccda co cen wbr cA cC ccda co cB
      cD ccda co cen wbr vw cv cD wceq cC vw cv cen wbr cC cD cen wbr cA cB cen
      wbr vw cv cD cC cen breq2 anbi2d vw cv cD wceq cB vw cv ccda co cB cD
      ccda co cA cC ccda co cen vw cv cD cB ccda opreq2 breq2d imbi12d imbi2d
      vx cv vy cv cen wbr vz cv vw cv cen wbr wa vx cv vz cv ccda co vy cv vw
      cv ccda co cen wbr wi cA vy cv cen wbr vz cv vw cv cen wbr wa cA vz cv
      ccda co vy cv vw cv ccda co cen wbr wi cA cB cen wbr vz cv vw cv cen wbr
      wa cA vz cv ccda co cB vw cv ccda co cen wbr wi vx vy cA cB cW cX vx cv
      cA wceq vx cv vy cv cen wbr vz cv vw cv cen wbr wa cA vy cv cen wbr vz cv
      vw cv cen wbr wa vx cv vz cv ccda co vy cv vw cv ccda co cen wbr cA vz cv
      ccda co vy cv vw cv ccda co cen wbr vx cv cA wceq vx cv vy cv cen wbr cA
      vy cv cen wbr vz cv vw cv cen wbr vx cv cA vy cv cen breq1 anbi1d vx cv
      cA wceq vx cv vz cv ccda co cA vz cv ccda co vy cv vw cv ccda co cen vx
      cv cA vz cv ccda opreq1 breq1d imbi12d vy cv cB wceq cA vy cv cen wbr vz
      cv vw cv cen wbr wa cA cB cen wbr vz cv vw cv cen wbr wa cA vz cv ccda co
      vy cv vw cv ccda co cen wbr cA vz cv ccda co cB vw cv ccda co cen wbr vy
      cv cB wceq cA vy cv cen wbr cA cB cen wbr vz cv vw cv cen wbr vy cv cB cA
      cen breq2 anbi1d vy cv cB wceq vy cv vw cv ccda co cB vw cv ccda co cA vz
      cv ccda co cen vy cv cB vw cv ccda opreq1 breq2d imbi12d vx cv vy cv vz
      cv vw cv vx visset vy visset vz visset vw visset cdaen vtocl2g vtocl2g
      impcom 3impia $.
      $( [6-Jun-2009] $) $( [5-Jun-2009] $)
  $}

  ${
    cda0en.1 $e |- A e. _V $.
    $( Cardinal addition with cardinal zero (the empty set).  Part (a1) of
       proof of Theorem 6J of [Enderton] p. 143. $)
    cda0en $p |- ( A +c (/) ) ~~ A $=
      cA c0 ccda co cA c0 csn cxp cA cen cA c0 ccda co cA c0 csn cxp c0 c1o csn
      cxp cun cA c0 csn cxp c0 cun cA c0 csn cxp cA c0 cda0en.1 0ex cdavali c0
      c1o csn cxp c0 cA c0 csn cxp c1o csn xp0r uneq2i cA c0 csn cxp un0 3eqtri
      cA c0 cda0en.1 0ex xpsnen eqbrtri $.
      $( [29-Sep-2004] $) $( [27-Sep-2004] $)

    $( Cardinal addition with cardinal one (which is the same as ordinal one).
       Used in proof of Theorem 6J of [Enderton] p. 143. $)
    cda1en $p |- ( A +c 1o ) ~~ suc ( card ` A ) $=
      cA c0 csn cxp c1o c1o csn cxp cun cA ccrd cfv cA ccrd cfv csn cun cA c1o
      ccda co cA ccrd cfv csuc cen cA c0 csn cxp cA ccrd cfv cen wbr c1o c1o
      csn cxp cA ccrd cfv csn cen wbr wa cA c0 csn cxp c1o c1o csn cxp cin c0
      wceq cA ccrd cfv cA ccrd cfv csn cin c0 wceq wa cA c0 csn cxp c1o c1o csn
      cxp cun cA ccrd cfv cA ccrd cfv csn cun cen wbr cA c0 csn cxp cA ccrd cfv
      cen wbr c1o c1o csn cxp cA ccrd cfv csn cen wbr cA c0 csn cxp cA cA ccrd
      cfv cda0en.1 cA c0 cda0en.1 0ex xpsnen cA cardid entr4i c1o c1o csn cxp
      c1o cA ccrd cfv csn c1o con0 1on elisseti c1o c1o c1o con0 1on elisseti
      c1o con0 1on elisseti xpsnen cA ccrd cfv cA ccrd fvex ensn1 entr4i pm3.2i
      cA c0 csn cxp c1o c1o csn cxp cin c0 wceq cA ccrd cfv cA ccrd cfv csn cin
      c0 wceq cA c1o xp01disj cA ccrd cfv word cA ccrd cfv cA ccrd cfv csn cin
      c0 wceq cA ccrd cfv cA cardon onordi cA ccrd cfv orddisj ax-mp pm3.2i cA
      c0 csn cxp cA ccrd cfv c1o c1o csn cxp cA ccrd cfv csn unen mp2an cA c1o
      cda0en.1 c1o con0 1on elisseti cdavali cA ccrd cfv df-suc 3brtr4i $.
      $( [24-Jul-2006] $) $( [28-Sep-2004] $)

    $( One times a cardinal number. $)
    xp1en $p |- ( A X. 1o ) ~~ A $=
      cA c1o cxp cA c0 csn cxp cA cen c1o c0 csn cA df1o2 xpeq2i cA c0 cda0en.1
      0ex xpsnen eqbrtri $.
      $( [29-Sep-2004] $) $( [27-Sep-2004] $)

    $( Two times a cardinal number.  Exercise 4.56(g) of [Mendelson] p. 258. $)
    xp2cda $p |- ( A X. 2o ) = ( A +c A ) $=
      cA c0 csn c1o csn cun cxp cA c0 csn cxp cA c1o csn cxp cun cA c2o cxp cA
      cA ccda co cA c0 csn c1o csn xpundi c2o c0 csn c1o csn cun cA c0 c0 csn
      cpr c0 csn c0 csn csn cun c2o c0 csn c1o csn cun c0 c0 csn df-pr df2o2
      c1o csn c0 csn csn c0 csn c1o c0 csn df1o2 sneqi uneq2i 3eqtr4i xpeq2i cA
      cA cda0en.1 cda0en.1 cdavali 3eqtr4i $.
      $( [29-Sep-2004] $) $( [27-Sep-2004] $)
  $}

  ${
    cdacomen.1 $e |- A e. _V $.
    cdacomen.2 $e |- B e. _V $.
    $( Commutative law for cardinal addition.  Exercise 4.56(c) of [Mendelson]
       p. 258. $)
    cdacomen $p |- ( A +c B ) ~~ ( B +c A ) $=
      cA c0 csn cxp cB c1o csn cxp cun cB c0 csn cxp cA c1o csn cxp cun cA cB
      ccda co cB cA ccda co cen cA c0 csn cxp cB c1o csn cxp cun cA c1o csn cxp
      cB c0 csn cxp cun cB c0 csn cxp cA c1o csn cxp cun cen cA c0 csn cxp cB
      c1o csn cxp cin c0 wceq cA c1o csn cxp cB c0 csn cxp cin c0 wceq cA c0
      csn cxp cB c1o csn cxp cun cA c1o csn cxp cB c0 csn cxp cun cen wbr cA cB
      xp01disj c1o c0 wne cA c1o csn cxp cB c0 csn cxp cin c0 wceq 1n0 cA c1o
      cB c0 xpsndisj ax-mp cA c0 csn cxp cA c1o csn cxp cen wbr cB c1o csn cxp
      cB c0 csn cxp cen wbr cA c0 csn cxp cB c1o csn cxp cin c0 wceq cA c1o csn
      cxp cB c0 csn cxp cin c0 wceq wa cA c0 csn cxp cB c1o csn cxp cun cA c1o
      csn cxp cB c0 csn cxp cun cen wbr cA c0 csn cxp cA cA c1o csn cxp
      cdacomen.1 cA c0 cdacomen.1 0ex xpsnen cA c1o cdacomen.1 c1o con0 1on
      elisseti xpsnen entr4i cB c1o csn cxp cB cB c0 csn cxp cdacomen.2 cB c1o
      cdacomen.2 c1o con0 1on elisseti xpsnen cB c0 cdacomen.2 0ex xpsnen
      entr4i cA c0 csn cxp cA c1o csn cxp cB c1o csn cxp cB c0 csn cxp unen
      mpanl12 mp2an cA c1o csn cxp cB c0 csn cxp uncom breqtri cA cB cdacomen.1
      cdacomen.2 cdavali cB cA cdacomen.2 cdacomen.1 cdavali 3brtr4i $.
      $( [24-Jul-2006] $) $( [24-Sep-2004] $)

    ${
      cdaassen.3 $e |- C e. _V $.
      $( Associative law for cardinal addition.  Exercise 4.56(c) of
         [Mendelson] p. 258. $)
      cdaassen $p |- ( ( A +c B ) +c C ) ~~ ( A +c ( B +c C ) ) $=
        cA c0 csn cxp cB c1o csn cxp cun c0 csn cxp cC c1o csn cxp cun cA c0
        csn cxp cB c0 csn cxp cC c1o csn cxp cun c1o csn cxp cun cA cB ccda co
        cC ccda co cA cB cC ccda co ccda co cen cA c0 csn cxp cB c1o csn cxp
        cun c0 csn cxp cC c1o csn cxp cun cA c0 csn cxp c0 csn cxp cB c1o csn
        cxp c0 csn cxp cun cC c1o csn cxp c1o csn cxp cun cA c0 csn cxp cB c0
        csn cxp cC c1o csn cxp cun c1o csn cxp cun cA c0 csn cxp cB c1o csn cxp
        cun c0 csn cxp cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun
        cen wbr cC c1o csn cxp cC c1o csn cxp c1o csn cxp cen wbr wa cA c0 csn
        cxp cB c1o csn cxp cun c0 csn cxp cC c1o csn cxp cin c0 wceq cA c0 csn
        cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cC c1o csn cxp c1o csn cxp
        cin c0 wceq wa cA c0 csn cxp cB c1o csn cxp cun c0 csn cxp cC c1o csn
        cxp cun cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cC c1o
        csn cxp c1o csn cxp cun cen wbr cA c0 csn cxp cB c1o csn cxp cun c0 csn
        cxp cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cen wbr cC
        c1o csn cxp cC c1o csn cxp c1o csn cxp cen wbr cA c0 csn cxp cB c1o csn
        cxp cun c0 csn cxp cvv wcel cA c0 csn cxp cB c1o csn cxp cun c0 csn cxp
        cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun wceq cA c0 csn
        cxp cB c1o csn cxp cun c0 csn cxp cA c0 csn cxp c0 csn cxp cB c1o csn
        cxp c0 csn cxp cun cen wbr cA c0 csn cxp cB c1o csn cxp cun c0 csn cA
        c0 csn cxp cB c1o csn cxp cA c0 csn cdacomen.1 p0ex xpex cB c1o csn
        cdacomen.2 c1o snex xpex unex p0ex xpex cA c0 csn cxp cB c1o csn cxp c0
        csn xpundir cA c0 csn cxp cB c1o csn cxp cun c0 csn cxp cA c0 csn cxp
        c0 csn cxp cB c1o csn cxp c0 csn cxp cun cvv eqeng mp2 cC c1o csn cxp
        c1o csn cxp cC c1o csn cxp cC c1o csn cdaassen.3 c1o snex xpex cC c1o
        csn cxp c1o cC c1o csn cdaassen.3 c1o snex xpex c1o con0 1on elisseti
        xpsnen ensymi pm3.2i cA c0 csn cxp cB c1o csn cxp cun c0 csn cxp cC c1o
        csn cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp
        cun cC c1o csn cxp c1o csn cxp cin c0 wceq cA c0 csn cxp cB c1o csn cxp
        cun cC xp01disj cA c0 csn cxp c0 csn cxp cC c1o csn cxp c1o csn cxp cin
        c0 wceq cB c1o csn cxp c0 csn cxp cC c1o csn cxp c1o csn cxp cin c0
        wceq wa cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cC c1o
        csn cxp c1o csn cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cC c1o csn cxp
        c1o csn cxp cin c0 wceq cB c1o csn cxp c0 csn cxp cC c1o csn cxp c1o
        csn cxp cin c0 wceq cA c0 csn cxp cC c1o csn cxp xp01disj cB c1o csn
        cxp cC c1o csn cxp xp01disj pm3.2i cA c0 csn cxp c0 csn cxp cB c1o csn
        cxp c0 csn cxp cC c1o csn cxp c1o csn cxp undisj1 mpbi pm3.2i cA c0 csn
        cxp cB c1o csn cxp cun c0 csn cxp cA c0 csn cxp c0 csn cxp cB c1o csn
        cxp c0 csn cxp cun cC c1o csn cxp cC c1o csn cxp c1o csn cxp unen mp2an
        cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cC c1o csn cxp
        c1o csn cxp cun cA c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp cC
        c1o csn cxp c1o csn cxp cun cun cA c0 csn cxp cB c0 csn cxp cC c1o csn
        cxp cun c1o csn cxp cun cA c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn
        cxp cC c1o csn cxp c1o csn cxp cun cA c0 csn cxp c0 csn cA c0 csn
        cdacomen.1 p0ex xpex p0ex xpex cB c0 csn cxp c1o csn cxp cC c1o csn cxp
        c1o csn cxp cB c0 csn cxp c1o csn cB c0 csn cdacomen.2 p0ex xpex c1o
        snex xpex cC c1o csn cxp c1o csn cC c1o csn cdaassen.3 c1o snex xpex
        c1o snex xpex unex unex cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn
        cxp cun cC c1o csn cxp c1o csn cxp cun cA c0 csn cxp c0 csn cxp cB c0
        csn cxp c1o csn cxp cun cC c1o csn cxp c1o csn cxp cun cA c0 csn cxp c0
        csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp cun cun
        cen cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cA c0 csn
        cxp c0 csn cxp cB c0 csn cxp c1o csn cxp cun cen wbr cC c1o csn cxp c1o
        csn cxp cC c1o csn cxp c1o csn cxp cen wbr wa cA c0 csn cxp c0 csn cxp
        cB c1o csn cxp c0 csn cxp cun cC c1o csn cxp c1o csn cxp cin c0 wceq cA
        c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp cun cC c1o csn cxp c1o
        csn cxp cin c0 wceq wa cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn
        cxp cun cC c1o csn cxp c1o csn cxp cun cA c0 csn cxp c0 csn cxp cB c0
        csn cxp c1o csn cxp cun cC c1o csn cxp c1o csn cxp cun cen wbr cA c0
        csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cA c0 csn cxp c0 csn
        cxp cB c0 csn cxp c1o csn cxp cun cen wbr cC c1o csn cxp c1o csn cxp cC
        c1o csn cxp c1o csn cxp cen wbr cA c0 csn cxp c0 csn cxp cA c0 csn cxp
        c0 csn cxp cen wbr cB c1o csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp
        cen wbr wa cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cin c0
        wceq cA c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp cin c0 wceq wa
        cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cA c0 csn cxp c0
        csn cxp cB c0 csn cxp c1o csn cxp cun cen wbr cA c0 csn cxp c0 csn cxp
        cA c0 csn cxp c0 csn cxp cen wbr cB c1o csn cxp c0 csn cxp cB c0 csn
        cxp c1o csn cxp cen wbr cA c0 csn cxp c0 csn cxp cA c0 csn cxp c0 csn
        cA c0 csn cdacomen.1 p0ex xpex p0ex xpex enref cB c1o csn cxp c0 csn
        cxp cB c1o csn c0 csn cxp cxp cB c0 csn cxp c1o csn cxp cB c1o csn c0
        csn cdacomen.2 c1o snex p0ex xpassen cB c1o csn c0 csn cxp cxp cB c0
        csn c1o csn cxp cxp cB c0 csn cxp c1o csn cxp cB c0 csn c1o csn cxp
        cdacomen.2 c0 csn c1o csn p0ex c1o snex xpex xpex cB cB cen wbr c1o csn
        c0 csn cxp c0 csn c1o csn cxp cen wbr cB c1o csn c0 csn cxp cxp cB c0
        csn c1o csn cxp cxp cen wbr cB cdacomen.2 enref c1o csn c0 csn c1o snex
        p0ex xpcomen cB cB c1o csn c0 csn cxp c0 csn c1o csn cxp cdacomen.2
        cdacomen.2 c1o csn c0 csn c1o snex p0ex xpex c0 csn c1o csn p0ex c1o
        snex xpex xpen mp2an cB c0 csn c1o csn cdacomen.2 p0ex c1o snex xpassen
        entr4i entri pm3.2i cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp
        cin c0 wceq cA c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp cin c0
        wceq cA c0 csn cxp cB c1o csn cxp cin c0 csn cxp c0 c0 csn cxp cA c0
        csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cin c0 cA c0 csn cxp cB
        c1o csn cxp cin c0 c0 csn cA cB xp01disj xpeq1i cA c0 csn cxp cB c1o
        csn cxp c0 csn xpindir c0 csn xp0r 3eqtr3i cA c0 csn cxp cB c0 csn cxp
        xp01disj pm3.2i cA c0 csn cxp c0 csn cxp cA c0 csn cxp c0 csn cxp cB
        c1o csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp unen mp2an cC c1o csn
        cxp c1o csn cxp cC c1o csn cxp c1o csn cC c1o csn cdaassen.3 c1o snex
        xpex c1o snex xpex enref pm3.2i cA c0 csn cxp c0 csn cxp cB c1o csn cxp
        c0 csn cxp cun cC c1o csn cxp c1o csn cxp cin c0 wceq cA c0 csn cxp c0
        csn cxp cB c0 csn cxp c1o csn cxp cun cC c1o csn cxp c1o csn cxp cin c0
        wceq cA c0 csn cxp c0 csn cxp cC c1o csn cxp c1o csn cxp cin c0 wceq cB
        c1o csn cxp c0 csn cxp cC c1o csn cxp c1o csn cxp cin c0 wceq wa cA c0
        csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cC c1o csn cxp c1o csn
        cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cC c1o csn cxp c1o csn cxp cin
        c0 wceq cB c1o csn cxp c0 csn cxp cC c1o csn cxp c1o csn cxp cin c0
        wceq cA c0 csn cxp cC c1o csn cxp xp01disj cB c1o csn cxp cC c1o csn
        cxp xp01disj pm3.2i cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp
        cC c1o csn cxp c1o csn cxp undisj1 mpbi cA c0 csn cxp c0 csn cxp cC c1o
        csn cxp c1o csn cxp cin c0 wceq cB c0 csn cxp c1o csn cxp cC c1o csn
        cxp c1o csn cxp cin c0 wceq wa cA c0 csn cxp c0 csn cxp cB c0 csn cxp
        c1o csn cxp cun cC c1o csn cxp c1o csn cxp cin c0 wceq cA c0 csn cxp c0
        csn cxp cC c1o csn cxp c1o csn cxp cin c0 wceq cB c0 csn cxp c1o csn
        cxp cC c1o csn cxp c1o csn cxp cin c0 wceq cA c0 csn cxp cC c1o csn cxp
        xp01disj cB c0 csn cxp cC c1o csn cxp cin c1o csn cxp c0 c1o csn cxp cB
        c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp cin c0 cB c0 csn cxp
        cC c1o csn cxp cin c0 c1o csn cB cC xp01disj xpeq1i cB c0 csn cxp cC
        c1o csn cxp c1o csn xpindir c1o csn xp0r 3eqtr3i pm3.2i cA c0 csn cxp
        c0 csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp undisj1
        mpbi pm3.2i cA c0 csn cxp c0 csn cxp cB c1o csn cxp c0 csn cxp cun cA
        c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp cun cC c1o csn cxp c1o
        csn cxp cC c1o csn cxp c1o csn cxp unen mp2an cA c0 csn cxp c0 csn cxp
        cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp unass breqtri cA
        c0 csn cxp cA c0 csn cxp c0 csn cxp cen wbr cB c0 csn cxp cC c1o csn
        cxp cun c1o csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn
        cxp cun cen wbr wa cA c0 csn cxp cB c0 csn cxp cC c1o csn cxp cun c1o
        csn cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp
        cC c1o csn cxp c1o csn cxp cun cin c0 wceq wa cA c0 csn cxp cB c0 csn
        cxp cC c1o csn cxp cun c1o csn cxp cun cA c0 csn cxp c0 csn cxp cB c0
        csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp cun cun cen wbr cA c0
        csn cxp cA c0 csn cxp c0 csn cxp cen wbr cB c0 csn cxp cC c1o csn cxp
        cun c1o csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp
        cun cen wbr cA c0 csn cxp c0 csn cxp cA c0 csn cxp cA c0 csn cdacomen.1
        p0ex xpex cA c0 csn cxp c0 cA c0 csn cdacomen.1 p0ex xpex 0ex xpsnen
        ensymi cB c0 csn cxp cC c1o csn cxp cun c1o csn cxp cvv wcel cB c0 csn
        cxp cC c1o csn cxp cun c1o csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn
        cxp c1o csn cxp cun wceq cB c0 csn cxp cC c1o csn cxp cun c1o csn cxp
        cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp cun cen wbr cB c0
        csn cxp cC c1o csn cxp cun c1o csn cB c0 csn cxp cC c1o csn cxp cB c0
        csn cdacomen.2 p0ex xpex cC c1o csn cdaassen.3 c1o snex xpex unex c1o
        snex xpex cB c0 csn cxp cC c1o csn cxp c1o csn xpundir cB c0 csn cxp cC
        c1o csn cxp cun c1o csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn cxp
        c1o csn cxp cun cvv eqeng mp2 pm3.2i cA c0 csn cxp cB c0 csn cxp cC c1o
        csn cxp cun c1o csn cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cB c0 csn
        cxp c1o csn cxp cC c1o csn cxp c1o csn cxp cun cin c0 wceq cA cB c0 csn
        cxp cC c1o csn cxp cun xp01disj cA c0 csn cxp c0 csn cxp cB c0 csn cxp
        c1o csn cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cC c1o csn cxp c1o csn
        cxp cin c0 wceq wa cA c0 csn cxp c0 csn cxp cB c0 csn cxp c1o csn cxp
        cC c1o csn cxp c1o csn cxp cun cin c0 wceq cA c0 csn cxp c0 csn cxp cB
        c0 csn cxp c1o csn cxp cin c0 wceq cA c0 csn cxp c0 csn cxp cC c1o csn
        cxp c1o csn cxp cin c0 wceq cA c0 csn cxp cB c0 csn cxp xp01disj cA c0
        csn cxp cC c1o csn cxp xp01disj pm3.2i cA c0 csn cxp c0 csn cxp cB c0
        csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp undisj2 mpbi pm3.2i cA
        c0 csn cxp cA c0 csn cxp c0 csn cxp cB c0 csn cxp cC c1o csn cxp cun
        c1o csn cxp cB c0 csn cxp c1o csn cxp cC c1o csn cxp c1o csn cxp cun
        unen mp2an entr4i entri cA cB ccda co cC ccda co cA c0 csn cxp cB c1o
        csn cxp cun cC ccda co cA c0 csn cxp cB c1o csn cxp cun c0 csn cxp cC
        c1o csn cxp cun cA cB ccda co cA c0 csn cxp cB c1o csn cxp cun cC ccda
        cA cB cdacomen.1 cdacomen.2 cdavali opreq1i cA c0 csn cxp cB c1o csn
        cxp cun cC cA c0 csn cxp cB c1o csn cxp cA c0 csn cdacomen.1 p0ex xpex
        cB c1o csn cdacomen.2 c1o snex xpex unex cdaassen.3 cdavali eqtri cA cB
        cC ccda co ccda co cA cB c0 csn cxp cC c1o csn cxp cun ccda co cA c0
        csn cxp cB c0 csn cxp cC c1o csn cxp cun c1o csn cxp cun cB cC ccda co
        cB c0 csn cxp cC c1o csn cxp cun cA ccda cB cC cdacomen.2 cdaassen.3
        cdavali opreq2i cA cB c0 csn cxp cC c1o csn cxp cun cdacomen.1 cB c0
        csn cxp cC c1o csn cxp cB c0 csn cdacomen.2 p0ex xpex cC c1o csn
        cdaassen.3 c1o snex xpex unex cdavali eqtri 3brtr4i $.
        $( [24-Jul-2006] $) $( [26-Sep-2004] $)

      $( Cardinal multiplication distributes over cardinal addition.  Theorem
         6I(3) of [Enderton] p. 142. $)
      xpcdaen $p |- ( A X. ( B +c C ) ) ~~ ( ( A X. B ) +c ( A X. C ) ) $=
        cA cB c0 csn cxp cC c1o csn cxp cun cxp cA cB cxp c0 csn cxp cA cC cxp
        c1o csn cxp cun cA cB cC ccda co cxp cA cB cxp cA cC cxp ccda co cen cA
        cB cxp c0 csn cxp cA cC cxp c1o csn cxp cun cA cB c0 csn cxp cC c1o csn
        cxp cun cxp cA cB c0 csn cxp cC c1o csn cxp cun cdacomen.1 cB c0 csn
        cxp cC c1o csn cxp cB c0 csn cdacomen.2 p0ex xpex cC c1o csn cdaassen.3
        c1o snex xpex unex xpex cA cB cxp c0 csn cxp cA cC cxp c1o csn cxp cun
        cA cB c0 csn cxp cxp cA cC c1o csn cxp cxp cun cA cB c0 csn cxp cC c1o
        csn cxp cun cxp cen cA cB cxp c0 csn cxp cA cB c0 csn cxp cxp cen wbr
        cA cC cxp c1o csn cxp cA cC c1o csn cxp cxp cen wbr wa cA cB cxp c0 csn
        cxp cA cC cxp c1o csn cxp cin c0 wceq cA cB c0 csn cxp cxp cA cC c1o
        csn cxp cxp cin c0 wceq wa cA cB cxp c0 csn cxp cA cC cxp c1o csn cxp
        cun cA cB c0 csn cxp cxp cA cC c1o csn cxp cxp cun cen wbr cA cB cxp c0
        csn cxp cA cB c0 csn cxp cxp cen wbr cA cC cxp c1o csn cxp cA cC c1o
        csn cxp cxp cen wbr cA cB c0 csn cdacomen.1 cdacomen.2 p0ex xpassen cA
        cC c1o csn cdacomen.1 cdaassen.3 c1o snex xpassen pm3.2i cA cB cxp c0
        csn cxp cA cC cxp c1o csn cxp cin c0 wceq cA cB c0 csn cxp cxp cA cC
        c1o csn cxp cxp cin c0 wceq cA cB cxp cA cC cxp xp01disj cA cB c0 csn
        cxp cC c1o csn cxp cin cxp cA c0 cxp cA cB c0 csn cxp cxp cA cC c1o csn
        cxp cxp cin c0 cB c0 csn cxp cC c1o csn cxp cin c0 cA cB cC xp01disj
        xpeq2i cA cB c0 csn cxp cC c1o csn cxp xpindi cA xp0 3eqtr3i pm3.2i cA
        cB cxp c0 csn cxp cA cB c0 csn cxp cxp cA cC cxp c1o csn cxp cA cC c1o
        csn cxp cxp unen mp2an cA cB c0 csn cxp cC c1o csn cxp xpundi breqtrri
        ensymi cB cC ccda co cB c0 csn cxp cC c1o csn cxp cun cA cB cC
        cdacomen.2 cdaassen.3 cdavali xpeq2i cA cB cxp cA cC cxp cA cB
        cdacomen.1 cdacomen.2 xpex cA cC cdacomen.1 cdaassen.3 xpex cdavali
        3brtr4i $.
        $( [24-Jul-2006] $) $( [26-Sep-2004] $)

      $( Sum of exponents law for cardinal arithmetic.  Theorem 6I(4) of
         [Enderton] p. 142. $)
      mapcdaen $p |- ( A ^m ( B +c C ) ) ~~ ( ( A ^m B ) X. ( A ^m C ) ) $=
        cA cB cC ccda co cm co cA cB c0 csn cxp cC c1o csn cxp cun cm co cA cB
        cm co cA cC cm co cxp cen cB cC ccda co cB c0 csn cxp cC c1o csn cxp
        cun cA cm cB cC cdacomen.2 cdaassen.3 cdavali opreq2i cA cB c0 csn cxp
        cC c1o csn cxp cun cm co cA cB c0 csn cxp cm co cA cC c1o csn cxp cm co
        cxp cA cB cm co cA cC cm co cxp cB c0 csn cxp cC c1o csn cxp cin c0
        wceq cA cB c0 csn cxp cC c1o csn cxp cun cm co cA cB c0 csn cxp cm co
        cA cC c1o csn cxp cm co cxp cen wbr cB cC xp01disj cB c0 csn cxp cC c1o
        csn cxp cA cB c0 csn cdacomen.2 p0ex xpex cC c1o csn cdaassen.3 c1o
        snex xpex cdacomen.1 mapunen ax-mp cA cB c0 csn cxp cm co cA cB cm co
        cen wbr cA cC c1o csn cxp cm co cA cC cm co cen wbr cA cB c0 csn cxp cm
        co cA cC c1o csn cxp cm co cxp cA cB cm co cA cC cm co cxp cen wbr cA
        cA cen wbr cB c0 csn cxp cB cen wbr cA cB c0 csn cxp cm co cA cB cm co
        cen wbr cA cdacomen.1 enref cB c0 cdacomen.2 0ex xpsnen cA cA cB c0 csn
        cxp cB cdacomen.1 cdacomen.1 cB c0 csn cdacomen.2 p0ex xpex cdacomen.2
        mapen mp2an cA cA cen wbr cC c1o csn cxp cC cen wbr cA cC c1o csn cxp
        cm co cA cC cm co cen wbr cA cdacomen.1 enref cC c1o cdaassen.3 c1o
        con0 1on elisseti xpsnen cA cA cC c1o csn cxp cC cdacomen.1 cdacomen.1
        cC c1o csn cdaassen.3 c1o snex xpex cdaassen.3 mapen mp2an cA cB c0 csn
        cxp cm co cA cB cm co cA cC c1o csn cxp cm co cA cC cm co cA cB c0 csn
        cxp cm oprex cA cB cm oprex cA cC c1o csn cxp cm oprex cA cC cm oprex
        xpen mp2an entri eqbrtri $.
        $( [24-Jul-2006] $) $( [27-Sep-2004] $)

      $( Ordering law for cardinal addition.  Exercise 4.56(f) of [Mendelson]
         p. 258. $)
      cdadom1 $p |- ( A ~<_ B -> ( A +c C ) ~<_ ( B +c C ) ) $=
        cA cB cdom wbr cA c0 csn cxp cC c1o csn cxp cun cB c0 csn cxp cC c1o
        csn cxp cun cA cC ccda co cB cC ccda co cdom cA cB cdom wbr cA c0 csn
        cxp cB c0 csn cxp cdom wbr cA c0 csn cxp cC c1o csn cxp cun cB c0 csn
        cxp cC c1o csn cxp cun cdom wbr cA c0 csn cxp cB c0 csn cxp cdom wbr cA
        cB c0 csn cxp cdom wbr cA cB cdom wbr cA cvv wcel cA c0 csn cxp cA cen
        wbr cA c0 csn cxp cB c0 csn cxp cdom wbr cA cB c0 csn cxp cdom wbr wb
        cdacomen.1 cA c0 cdacomen.1 0ex xpsnen cA c0 csn cxp cA cB c0 csn cxp
        cvv domen1 mp2an cB cvv wcel cB c0 csn cxp cB cen wbr cA cB c0 csn cxp
        cdom wbr cA cB cdom wbr wb cdacomen.2 cB c0 cdacomen.2 0ex xpsnen cB c0
        csn cxp cB cA cvv domen2 mp2an bitri cA c0 csn cxp cB c0 csn cxp cdom
        wbr cC c1o csn cxp cC c1o csn cxp cdom wbr cA c0 csn cxp cC c1o csn cxp
        cun cB c0 csn cxp cC c1o csn cxp cun cdom wbr cC c1o csn cxp cvv wcel
        cC c1o csn cxp cC c1o csn cxp cdom wbr cC c1o csn cdaassen.3 c1o snex
        xpex cC c1o csn cxp cvv domrefg ax-mp cA c0 csn cxp cB c0 csn cxp cdom
        wbr cC c1o csn cxp cC c1o csn cxp cdom wbr wa cB c0 csn cxp cC c1o csn
        cxp cin c0 wceq cA c0 csn cxp cC c1o csn cxp cun cB c0 csn cxp cC c1o
        csn cxp cun cdom wbr cB cC xp01disj cA c0 csn cxp cB c0 csn cxp cC c1o
        csn cxp cC c1o csn cxp cB c0 csn cdacomen.2 p0ex xpex cC c1o csn
        cdaassen.3 c1o snex xpex cC c1o csn cdaassen.3 c1o snex xpex undom
        mpan2 mpan2 sylbir cA cC cdacomen.1 cdaassen.3 cdavali cB cC cdacomen.2
        cdaassen.3 cdavali 3brtr4g $.
        $( [24-Jul-2006] $) $( [28-Sep-2004] $)

      $( Ordering law for cardinal addition.  Theorem 6L(a) of [Enderton]
         p. 149. $)
      cdadom2 $p |- ( A ~<_ B -> ( C +c A ) ~<_ ( C +c B ) ) $=
        cA cB cdom wbr cA cC ccda co cB cC ccda co cdom wbr cC cA ccda co cB cC
        ccda co cdom wbr cC cA ccda co cC cB ccda co cdom wbr cA cB cC
        cdacomen.1 cdacomen.2 cdaassen.3 cdadom1 cC cA ccda co cA cC ccda co
        cen wbr cA cC ccda co cB cC ccda co cdom wbr cC cA ccda co cB cC ccda
        co cdom wbr cC cA cdaassen.3 cdacomen.1 cdacomen cC cA ccda co cA cC
        ccda co cB cC ccda co endomtr mpan cC cA ccda co cB cC ccda co cdom wbr
        cB cC ccda co cC cB ccda co cen wbr cC cA ccda co cC cB ccda co cdom
        wbr cB cC cdacomen.2 cdaassen.3 cdacomen cC cA ccda co cB cC ccda co cC
        cB ccda co domentr mpan2 3syl $.
        $( [7-Oct-2004] $) $( [28-Sep-2004] $)
    $}

    $( A set is dominated by its cardinal sum with another. $)
    cdadom3 $p |- A ~<_ ( A +c B ) $=
      cA cA cB cun cdom wbr cA cB cun cA cB ccda co cdom wbr cA cA cB ccda co
      cdom wbr cA cvv wcel cA cA cB cun wss cA cA cB cun cdom wbr cdacomen.1 cA
      cB ssun1 cA cA cB cun cvv ssdomg mp2 cA cB cdacomen.1 cdacomen.2 uncdadom
      cA cA cB cun cA cB ccda co domtr mp2an $.
      $( [7-Oct-2004] $) $( [28-Sep-2004] $)
  $}

  $( The cardinal sum of two finite sets is finite. $)
  cdafi $p |- ( ( A ~< om /\ B ~< om ) -> ( A +c B ) ~< om ) $=
    cA com csdm wbr cB com csdm wbr wa cA cB ccda co cA c0 csn cxp cB c1o csn
    cxp cun com csdm cA cvv wcel cB cvv wcel cA cB ccda co cA c0 csn cxp cB c1o
    csn cxp cun wceq cA com csdm wbr cB com csdm wbr cA cB cvv cvv cdaval cA
    com csdm wbr cA cvv wcel com cvv wcel cA com sdomex pm3.26d cB com csdm wbr
    cB cvv wcel com cvv wcel cB com sdomex pm3.26d syl2an cA c0 csn cxp com
    csdm wbr cB c1o csn cxp com csdm wbr cA c0 csn cxp cB c1o csn cxp cun com
    csdm wbr cA com csdm wbr cB com csdm wbr cA c0 csn cxp cB c1o csn cxp unfi2
    cA com csdm wbr cA c0 csn cxp com csdm wbr cA cvv wcel cA c0 csn cxp cA cen
    wbr cA c0 csn cxp com csdm wbr cA com csdm wbr wb cA com csdm wbr cA c0 csn
    cxp cA com cvv sdomen1 cA com csdm wbr cA cvv wcel com cvv wcel cA com
    sdomex pm3.26d cA cvv wcel c0 con0 wcel cA c0 csn cxp cA cen wbr cA com
    csdm wbr cA c0 cvv con0 xpsneng cA com csdm wbr cA cvv wcel com cvv wcel cA
    com sdomex pm3.26d 0elon sylancl sylanc ibir cB com csdm wbr cB c1o csn cxp
    com csdm wbr cB cvv wcel cB c1o csn cxp cB cen wbr cB c1o csn cxp com csdm
    wbr cB com csdm wbr wb cB com csdm wbr cB c1o csn cxp cB com cvv sdomen1 cB
    com csdm wbr cB cvv wcel com cvv wcel cB com sdomex pm3.26d cB cvv wcel c1o
    con0 wcel cB c1o csn cxp cB cen wbr cB com csdm wbr cB c1o cvv con0 xpsneng
    cB com csdm wbr cB cvv wcel com cvv wcel cB com sdomex pm3.26d 1on sylancl
    sylanc ibir syl2an eqbrtrd $.
    $( [23-Oct-2004] $) $( [22-Oct-2004] $)

  ${
    cdainf.1 $e |- A e. _V $.
    $( A set is infinite iff the cardinal sum with itself is infinite. $)
    cdainf $p |- ( om ~<_ A <-> om ~<_ ( A +c A ) ) $=
      com cA cdom wbr com cA cA ccda co cdom wbr com cA cdom wbr cA cA cA ccda
      co cdom wbr com cA cA ccda co cdom wbr cA cA cdainf.1 cdainf.1 cdadom3
      com cA cA cA ccda co domtr mpan2 cA cA ccda co com csdm wbr wn cA com
      csdm wbr wn com cA cA ccda co cdom wbr com cA cdom wbr cA com csdm wbr cA
      cA ccda co com csdm wbr cA com csdm wbr cA cA ccda co com csdm wbr cA cA
      cdafi anidms con3i com cvv wcel cA cA ccda co cvv wcel com cA cA ccda co
      cdom wbr cA cA ccda co com csdm wbr wn wb omex cA cA ccda oprex com cA cA
      ccda co cvv cvv domtri mp2an com cvv wcel cA cvv wcel com cA cdom wbr cA
      com csdm wbr wn wb omex cdainf.1 com cA cvv cvv domtri mp2an 3imtr4i
      impbii $.
      $( [23-Oct-2004] $) $( [22-Oct-2004] $)
  $}

  ${
    $d A x y $.  $d B x y $.  $d x y z $.
    $( The cardinal and ordinal sums of finite ordinals are equal. (Contributed
       by Paul Chapman, 11-Apr-2009.) $)
    nnacda $p |- ( ( A e. om /\ B e. om ) ->
                   ( card ` ( A +c B ) ) = ( A +o B ) ) $=
      cA com wcel cB com wcel wa vx cv vy cv ccda co ccrd cfv vx cv vy cv coa
      co wceq vy com wral vx com wral cA cB ccda co ccrd cfv cA cB coa co wceq
      vx cv vy cv ccda co ccrd cfv vx cv vy cv coa co wceq vx vy com vy cv com
      wcel vx cv com wcel vx cv vy cv ccda co ccrd cfv vx cv vy cv coa co wceq
      vx cv vy cv ccda co ccrd cfv vx cv vy cv coa co wceq vx cv c0 ccda co
      ccrd cfv vx cv c0 coa co wceq vx cv vz cv ccda co ccrd cfv vx cv vz cv
      coa co wceq vx cv vz cv csuc ccda co ccrd cfv vx cv vz cv csuc coa co
      wceq vx cv com wcel vy vz vy cv c0 wceq vx cv vy cv ccda co ccrd cfv vx
      cv c0 ccda co ccrd cfv vx cv vy cv coa co vx cv c0 coa co vy cv c0 wceq
      vx cv vy cv ccda co vx cv c0 ccda co ccrd vy cv c0 vx cv ccda opreq2
      fveq2d vy cv c0 vx cv coa opreq2 eqeq12d vy cv vz cv wceq vx cv vy cv
      ccda co ccrd cfv vx cv vz cv ccda co ccrd cfv vx cv vy cv coa co vx cv vz
      cv coa co vy cv vz cv wceq vx cv vy cv ccda co vx cv vz cv ccda co ccrd
      vy cv vz cv vx cv ccda opreq2 fveq2d vy cv vz cv vx cv coa opreq2 eqeq12d
      vy cv vz cv csuc wceq vx cv vy cv ccda co ccrd cfv vx cv vz cv csuc ccda
      co ccrd cfv vx cv vy cv coa co vx cv vz cv csuc coa co vy cv vz cv csuc
      wceq vx cv vy cv ccda co vx cv vz cv csuc ccda co ccrd vy cv vz cv csuc
      vx cv ccda opreq2 fveq2d vy cv vz cv csuc vx cv coa opreq2 eqeq12d vx cv
      com wcel vx cv c0 ccda co ccrd cfv vx cv vx cv c0 coa co vx cv com wcel
      vx cv ccrd cfv vx cv vx cv c0 ccda co ccrd cfv vx cv cardnn vx cv c0 ccda
      co ccrd cfv vx cv ccrd cfv wceq vx cv c0 ccda co vx cv cen wbr vx cv vx
      visset cda0en vx cv c0 ccda co cvv wcel vx cv cvv wcel vx cv c0 ccda co
      ccrd cfv vx cv ccrd cfv wceq vx cv c0 ccda co vx cv cen wbr wb vx cv c0
      ccda oprex vx visset vx cv c0 ccda co vx cv cvv cvv carden mp2an mpbir
      syl5eq vx cv nna0 eqtr4d vx cv com wcel vz cv com wcel vx cv vz cv ccda
      co ccrd cfv vx cv vz cv coa co wceq vx cv vz cv csuc ccda co ccrd cfv vx
      cv vz cv csuc coa co wceq wi vx cv com wcel vz cv com wcel vx cv vz cv
      ccda co ccrd cfv vx cv vz cv coa co wceq vx cv vz cv csuc ccda co ccrd
      cfv vx cv vz cv csuc coa co wceq vx cv com wcel vz cv com wcel vx cv vz
      cv ccda co ccrd cfv vx cv vz cv coa co wceq w3a vx cv vz cv csuc ccda co
      ccrd cfv vx cv vz cv csuc coa co ccrd cfv vx cv vz cv csuc coa co vx cv
      com wcel vz cv com wcel vx cv vz cv ccda co ccrd cfv vx cv vz cv coa co
      wceq w3a vx cv vz cv csuc ccda co vx cv vz cv csuc coa co cen wbr vx cv
      vz cv csuc ccda co ccrd cfv vx cv vz cv csuc coa co ccrd cfv wceq vx cv
      com wcel vz cv com wcel vx cv vz cv ccda co ccrd cfv vx cv vz cv coa co
      wceq w3a vx cv vz cv csuc ccda co vx cv vz cv ccda co ccrd cfv csuc cen
      wbr vx cv vz cv csuc ccda co vx cv vz cv csuc coa co cen wbr vz cv com
      wcel vx cv com wcel vx cv vz cv csuc ccda co vx cv vz cv ccda co ccrd cfv
      csuc cen wbr vx cv vz cv ccda co ccrd cfv vx cv vz cv coa co wceq vz cv
      com wcel vx cv vz cv ccda co c1o ccda co vx cv vz cv csuc ccda co cen wbr
      vx cv vz cv csuc ccda co vx cv vz cv ccda co c1o ccda co cen wbr vx cv vz
      cv csuc ccda co vx cv vz cv ccda co ccrd cfv csuc cen wbr vz cv com wcel
      vz cv c1o ccda co vz cv csuc cen wbr vx cv vz cv c1o ccda co ccda co vx
      cv vz cv csuc ccda co cen wbr vx cv vz cv ccda co c1o ccda co vx cv vz cv
      csuc ccda co cen wbr vz cv com wcel vz cv c1o ccda co vz cv ccrd cfv csuc
      cen wbr vz cv c1o ccda co vz cv csuc cen wbr vz cv vz visset cda1en vz cv
      com wcel vz cv ccrd cfv csuc vz cv csuc vz cv c1o ccda co cen vz cv com
      wcel vz cv ccrd cfv vz cv wceq vz cv ccrd cfv csuc vz cv csuc wceq vz cv
      cardnn vz cv ccrd cfv vz cv suceq syl breq2d mpbii vx cv vx cv cen wbr vz
      cv c1o ccda co vz cv csuc cen wbr vx cv vz cv c1o ccda co ccda co vx cv
      vz cv csuc ccda co cen wbr vx cv vx visset enref vx cv vx cv vz cv c1o
      ccda co vz cv csuc vx visset vx visset vz cv c1o ccda oprex vz cv vz
      visset sucex cdaen mpan vx cv vz cv ccda co c1o ccda co vx cv vz cv c1o
      ccda co ccda co cen wbr vx cv vz cv c1o ccda co ccda co vx cv vz cv csuc
      ccda co cen wbr vx cv vz cv ccda co c1o ccda co vx cv vz cv csuc ccda co
      cen wbr vx cv vz cv c1o vx visset vz visset c1o com 1onn elisseti
      cdaassen vx cv vz cv ccda co c1o ccda co vx cv vz cv c1o ccda co ccda co
      vx cv vz cv csuc ccda co entr mpan 3syl vx cv vz cv ccda co c1o ccda co
      vx cv vz cv csuc ccda co vx cv vz cv csuc ccda oprex ensym vx cv vz cv
      csuc ccda co vx cv vz cv ccda co c1o ccda co cen wbr vx cv vz cv ccda co
      c1o ccda co vx cv vz cv ccda co ccrd cfv csuc cen wbr vx cv vz cv csuc
      ccda co vx cv vz cv ccda co ccrd cfv csuc cen wbr vx cv vz cv ccda co vx
      cv vz cv ccda oprex cda1en vx cv vz cv csuc ccda co vx cv vz cv ccda co
      c1o ccda co vx cv vz cv ccda co ccrd cfv csuc entr mpan2 3syl 3ad2ant2 vx
      cv com wcel vz cv com wcel vx cv vz cv ccda co ccrd cfv vx cv vz cv coa
      co wceq w3a vx cv vz cv ccda co ccrd cfv csuc vx cv vz cv csuc coa co vx
      cv vz cv csuc ccda co cen vx cv com wcel vz cv com wcel vx cv vz cv ccda
      co ccrd cfv vx cv vz cv coa co wceq w3a vx cv vz cv ccda co ccrd cfv csuc
      vx cv vz cv coa co csuc vx cv vz cv csuc coa co vx cv vz cv ccda co ccrd
      cfv vx cv vz cv coa co wceq vx cv com wcel vx cv vz cv ccda co ccrd cfv
      csuc vx cv vz cv coa co csuc wceq vz cv com wcel vx cv vz cv ccda co ccrd
      cfv vx cv vz cv coa co suceq 3ad2ant3 vx cv com wcel vz cv com wcel vx cv
      vz cv csuc coa co vx cv vz cv coa co csuc wceq vx cv vz cv ccda co ccrd
      cfv vx cv vz cv coa co wceq vx cv vz cv nnasuc 3adant3 eqtr4d breq2d
      mpbid vx cv vz cv csuc ccda co cvv wcel vx cv vz cv csuc coa co cvv wcel
      vx cv vz cv csuc ccda co ccrd cfv vx cv vz cv csuc coa co ccrd cfv wceq
      vx cv vz cv csuc ccda co vx cv vz cv csuc coa co cen wbr wb vx cv vz cv
      csuc ccda oprex vx cv vz cv csuc coa oprex vx cv vz cv csuc ccda co vx cv
      vz cv csuc coa co cvv cvv carden mp2an sylibr vx cv com wcel vz cv com
      wcel vx cv vz cv csuc coa co ccrd cfv vx cv vz cv csuc coa co wceq vx cv
      vz cv ccda co ccrd cfv vx cv vz cv coa co wceq vx cv com wcel vz cv com
      wcel wa vx cv vz cv csuc coa co com wcel vx cv vz cv csuc coa co ccrd cfv
      vx cv vz cv csuc coa co wceq vx cv com wcel vz cv csuc com wcel vx cv vz
      cv csuc coa co com wcel vz cv com wcel vx cv vz cv csuc nnacl vz cv
      peano2b sylan2b vx cv vz cv csuc coa co cardnn syl 3adant3 eqtrd 3expia
      expcom finds2 impcom rgen2a vx cv vy cv ccda co ccrd cfv vx cv vy cv coa
      co wceq cA cB ccda co ccrd cfv cA cB coa co wceq cA vy cv ccda co ccrd
      cfv cA vy cv coa co wceq vx vy cA cB com com vx cv cA wceq vx cv vy cv
      ccda co ccrd cfv cA vy cv ccda co ccrd cfv vx cv vy cv coa co cA vy cv
      coa co vx cv cA wceq vx cv vy cv ccda co cA vy cv ccda co ccrd vx cv cA
      vy cv ccda opreq1 fveq2d vx cv cA vy cv coa opreq1 eqeq12d vy cv cB wceq
      cA vy cv ccda co ccrd cfv cA cB ccda co ccrd cfv cA vy cv coa co cA cB
      coa co vy cv cB wceq cA vy cv ccda co cA cB ccda co ccrd vy cv cB cA ccda
      opreq2 fveq2d vy cv cB cA coa opreq2 eqeq12d rcla42v mpi $.
      $( [14-Apr-2009] $) $( [11-Apr-2009] $)
  $}

  $( The cardinality of the union of disjoint, finite sets is the ordinal sum
     of their cardinalities. (Contributed by Paul Chapman, 5-Jun-2009.) $)
  nnaun $p |- ( ( A e. Fin /\ B e. Fin /\ ( A i^i B ) = (/) ) ->
                 ( card ` ( A u. B ) ) = ( ( card ` A ) +o ( card ` B ) ) ) $=
    cA cfn wcel cB cfn wcel cA cB cin c0 wceq w3a cA ccrd cfv cB ccrd cfv coa
    co ccrd cfv cA cB cun ccrd cfv cA ccrd cfv cB ccrd cfv coa co cA cfn wcel
    cB cfn wcel cA cB cin c0 wceq w3a cA ccrd cfv cB ccrd cfv coa co ccrd cfv
    cA cB cun ccrd cfv wceq cA ccrd cfv cB ccrd cfv coa co cA cB cun cen wbr cA
    cfn wcel cB cfn wcel cA cB cin c0 wceq w3a cA ccrd cfv cB ccrd cfv ccda co
    ccrd cfv cA cB cun cen wbr cA ccrd cfv cB ccrd cfv coa co cA cB cun cen wbr
    cA ccrd cfv cB ccrd cfv ccda co ccrd cfv cA ccrd cfv cB ccrd cfv ccda co
    cen wbr cA ccrd cfv cB ccrd cfv ccda co cA cB cun cen wbr cA ccrd cfv cB
    ccrd cfv ccda co ccrd cfv cA cB cun cen wbr cA cfn wcel cB cfn wcel cA cB
    cin c0 wceq w3a cA ccrd cfv cB ccrd cfv ccda co ccrd cfv cA ccrd cfv cB
    ccrd cfv ccda co cA cB cun entr cA ccrd cfv cB ccrd cfv ccda co cardid cA
    ccrd cfv cB ccrd cfv ccda co cA cB ccda co cen wbr cA cB ccda co cA cB cun
    cen wbr cA ccrd cfv cB ccrd cfv ccda co cA cB cun cen wbr cA cfn wcel cB
    cfn wcel cA cB cin c0 wceq w3a cA ccrd cfv cB ccrd cfv ccda co cA cB ccda
    co cA cB cun entr cA cfn wcel cB cfn wcel cA ccrd cfv cB ccrd cfv ccda co
    cA cB ccda co cen wbr cA cB cin c0 wceq cA ccrd cfv cvv wcel cB ccrd cfv
    cvv wcel wa cA cfn wcel cB cfn wcel wa cA ccrd cfv cB ccrd cfv ccda co cA
    cB ccda co cen wbr cA ccrd cfv cvv wcel cB ccrd cfv cvv wcel cA ccrd fvex
    cB ccrd fvex pm3.2i cA ccrd cfv cvv wcel cB ccrd cfv cvv wcel wa cA cfn
    wcel cB cfn wcel wa wa cA ccrd cfv cvv wcel cA cfn wcel wa cB ccrd cfv cvv
    wcel cB cfn wcel wa wa cA ccrd cfv cB ccrd cfv ccda co cA cB ccda co cen
    wbr cA ccrd cfv cvv wcel cB ccrd cfv cvv wcel cA cfn wcel cB cfn wcel an4
    cA ccrd cfv cvv wcel cA cfn wcel wa cB ccrd cfv cvv wcel cB cfn wcel wa cA
    ccrd cfv cA cen wbr cB ccrd cfv cB cen wbr wa cA ccrd cfv cB ccrd cfv ccda
    co cA cB ccda co cen wbr cA ccrd cfv cA cen wbr cB ccrd cfv cB cen wbr cA
    cardid cB cardid pm3.2i cA ccrd cfv cA cB ccrd cfv cB cvv cfn cvv cfn
    cdaeng mp3an3 sylbi mpan 3adant3 cA cB cfn cfn cdaung sylanc sylancr cA cfn
    wcel cB cfn wcel cA ccrd cfv cB ccrd cfv ccda co ccrd cfv cA cB cun cen wbr
    cA ccrd cfv cB ccrd cfv coa co cA cB cun cen wbr wb cA cB cin c0 wceq cA
    cfn wcel cB cfn wcel wa cA ccrd cfv cB ccrd cfv ccda co ccrd cfv cA ccrd
    cfv cB ccrd cfv coa co cA cB cun cen cA ccrd cfv com wcel cB ccrd cfv com
    wcel cA ccrd cfv cB ccrd cfv ccda co ccrd cfv cA ccrd cfv cB ccrd cfv coa
    co wceq cA cfn wcel cB cfn wcel cA ccrd cfv cB ccrd cfv nnacda cA ficardom
    cB ficardom syl2an breq1d 3adant3 mpbid cA cfn wcel cB cfn wcel cA ccrd cfv
    cB ccrd cfv coa co ccrd cfv cA cB cun ccrd cfv wceq cA ccrd cfv cB ccrd cfv
    coa co cA cB cun cen wbr wb cA cB cin c0 wceq cA ccrd cfv cB ccrd cfv coa
    co cvv wcel cA cB cun cfn wcel cA ccrd cfv cB ccrd cfv coa co ccrd cfv cA
    cB cun ccrd cfv wceq cA ccrd cfv cB ccrd cfv coa co cA cB cun cen wbr wb cA
    cfn wcel cB cfn wcel wa cA ccrd cfv cB ccrd cfv coa co cA cB cun cvv cfn
    carden cA ccrd cfv cB ccrd cfv coa oprex cA cB unfi sylancr 3adant3 mpbird
    cA cfn wcel cB cfn wcel cA ccrd cfv cB ccrd cfv coa co ccrd cfv cA ccrd cfv
    cB ccrd cfv coa co wceq cA cB cin c0 wceq cA ccrd cfv com wcel cB ccrd cfv
    com wcel cA ccrd cfv cB ccrd cfv coa co ccrd cfv cA ccrd cfv cB ccrd cfv
    coa co wceq cA cfn wcel cB cfn wcel cA ccrd cfv com wcel cB ccrd cfv com
    wcel wa cA ccrd cfv cB ccrd cfv coa co com wcel cA ccrd cfv cB ccrd cfv coa
    co ccrd cfv cA ccrd cfv cB ccrd cfv coa co wceq cA ccrd cfv cB ccrd cfv
    nnacl cA ccrd cfv cB ccrd cfv coa co cardnn syl cA ficardom cB ficardom
    syl2an 3adant3 eqtr3d $.
    $( [6-Jun-2009] $) $( [5-Jun-2009] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         ZFC Axioms with no distinct variable requirements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A lemma for proving conditionless ZFC axioms. $)
  nd1 $p |- ( A. x x = y -> -. A. x y e. z ) $=
    vx cv vy cv wceq vx wal vy cv vz cv wcel vx wal vy cv vz cv wcel vy wal vy
    cv vz cv wcel vy wal vz cv vz cv wcel vz elirrv vy cv vz cv wcel vy wal vy
    cv vz cv wcel vy vz cv wsbc vz cv vz cv wcel vy cv vz cv wcel vy vz stdpc4
    vy cv vz cv wcel vz cv vz cv wcel vy vz vz cv vz cv wcel vz cv vz cv wcel
    vy wal vz elirrv pm2.21i vy vz vz elequ1 sbie sylib mto vy cv vz cv wcel vx
    vy ax-10o mtoi $.
    $( [1-Jan-2002] $)

  $( A lemma for proving conditionless ZFC axioms. $)
  nd2 $p |- ( A. x x = y -> -. A. x z e. y ) $=
    vx cv vy cv wceq vx wal vz cv vy cv wcel vx wal vz cv vy cv wcel vy wal vz
    cv vy cv wcel vy wal vz cv vz cv wcel vz elirrv vz cv vy cv wcel vy wal vz
    cv vy cv wcel vy vz cv wsbc vz cv vz cv wcel vz cv vy cv wcel vy vz stdpc4
    vz cv vy cv wcel vz cv vz cv wcel vy vz vz cv vz cv wcel vz cv vz cv wcel
    vy wal vz elirrv pm2.21i vy vz vz elequ2 sbie sylib mto vz cv vy cv wcel vx
    vy ax-10o mtoi $.
    $( [1-Jan-2002] $)

  $( A lemma for proving conditionless ZFC axioms. $)
  nd3 $p |- ( A. x x = y -> -. A. z x e. y ) $=
    vx cv vy cv wceq vx wal vx cv vy cv wceq vx cv vy cv wcel wn vx cv vy cv
    wcel vz wal wn vx cv vy cv wceq vx ax-4 vx cv vy cv wceq vx cv vx cv wcel
    vx cv vy cv wcel vx elirrv vx vy vx elequ2 mtbii vx cv vy cv wcel vz wal vx
    cv vy cv wcel vx cv vy cv wcel vz ax-4 con3i 3syl $.
    $( [2-Jan-2002] $)

  $( A lemma for proving conditionless ZFC axioms. $)
  nd4 $p |- ( A. x x = y -> -. A. z y e. x ) $=
    vy cv vx cv wcel vz wal wn vy vx vy vx vz nd3 alequcoms $.
    $( [2-Jan-2002] $)

  ${
    $d z x $.
    $( A lemma for proving conditionless ZFC axioms. $)
    nd5 $p |- ( -. A. y y = x -> ( z = y -> A. x z = y ) ) $=
      vz cv vy cv wceq vz cv vy cv wceq vx wal wi vx vy vx vy vz dveeq2
      nalequcoms $.
      $( [8-Jan-2002] $)
  $}

  ${
    $d x v w $.  $d y v w $.  $d z v w $.
    $( A version of the Axiom of Extensionality with no distinct variable
       conditions. $)
    axextnd $p |- E. x ( ( x e. y <-> x e. z ) -> y = z ) $=
      vx cv vy cv wcel vx cv vz cv wcel wb vy cv vz cv wceq vx vx cv vy cv wceq
      vx wal vx cv vz cv wceq vx wal vx cv vy cv wcel vx cv vz cv wcel wb vx
      wal vy cv vz cv wceq vx wex wi vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn vx cv vy cv wcel vx cv vz cv wcel wb vx wal vy cv vz cv
      wceq vx wex wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa
      vx cv vy cv wcel vx cv vz cv wcel wb vx wal vy cv vz cv wceq vy cv vz cv
      wceq vx wex vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vx
      cv vy cv wcel vx cv vz cv wcel wb vx wal vw cv vy cv wcel vw cv vz cv
      wcel wb vw wal vy cv vz cv wceq vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vy cv wcel vw cv vz cv wcel wb vx cv vy cv wcel
      vx cv vz cv wcel wb vw vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vw cv vz cv wcel vx vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz
      vx hbnae hban vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr vx cv vz
      cv wceq vx wal wn vw cv vz cv wcel vw cv vz cv wcel vx wal wi vx cv vy cv
      wceq vx wal wn vx vz vw dveel2 adantl hbbid vw cv vx cv wceq vw cv vy cv
      wcel vw cv vz cv wcel wb vx cv vy cv wcel vx cv vz cv wcel wb wb wi vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vw cv
      vy cv wcel vx cv vy cv wcel vw cv vz cv wcel vx cv vz cv wcel vw vx vy
      elequ1 vw vx vz elequ1 bibi12d a1i cbvald vy vz vw axext3 syl6bir vy cv
      vz cv wceq vx 19.8a syl6 ex vx cv vy cv wceq vx wal vy cv vz cv wceq vx
      wex vx cv vy cv wcel vx cv vz cv wcel wb vx wal vx cv vy cv wceq vx wal
      vx cv vz cv wceq vx wex vy cv vz cv wceq vx wex vx vz a9e vx cv vy cv
      wceq vx wal vx cv vz cv wceq vy cv vz cv wceq vx vx vy vx hbae vx cv vy
      cv wceq vx cv vz cv wceq vy cv vz cv wceq wi vx vx vy vz ax-8 a4s 19.22d
      mpi a1d vx cv vz cv wceq vx wal vy cv vz cv wceq vx wex vx cv vy cv wcel
      vx cv vz cv wcel wb vx wal vx cv vz cv wceq vx wal vx cv vy cv wceq vx
      wex vy cv vz cv wceq vx wex vx vy a9e vx cv vz cv wceq vx wal vx cv vy cv
      wceq vy cv vz cv wceq vx vx vz vx hbae vx cv vz cv wceq vx cv vy cv wceq
      vy cv vz cv wceq wi vx vx cv vz cv wceq vx cv vy cv wceq vz cv vy cv wceq
      vy cv vz cv wceq vx vz vy ax-8 vz vy equcomi syl6 a4s 19.22d mpi a1d
      pm2.61ii 19.35ri $.
      $( [14-Aug-2003] $)
  $}

  ${
    $d x z w v $.  $d x y w v $.  $d w ph $.
    $( Lemma for the Axiom of Replacement with no distinct variable
       conditions. $)
    axrepndlem1 $p |- ( -. A. y y = z -> E. x ( E. y A. z ( ph -> z = y ) ->
                 A. z ( z e. x <-> E. x ( x e. y /\ A. y ph ) ) ) ) $=
      vy cv vz cv wceq vy wal wn wph vz vw cv wsbc vw cv vy cv wceq wi vw wal
      vy wex vw cv vx cv wcel vx cv vy cv wcel wph vz vw cv wsbc vy wal wa vx
      wex wb vw wal wi vx wex wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv
      wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi vx wex wph vz vw
      cv wsbc vx vy vw axrep2 vy cv vz cv wceq vy wal wn wph vz vw cv wsbc vw
      cv vy cv wceq wi vw wal vy wex vw cv vx cv wcel vx cv vy cv wcel wph vz
      vw cv wsbc vy wal wa vx wex wb vw wal wi wph vz cv vy cv wceq wi vz wal
      vy wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal
      wi vx vy vz vx hbnae vy cv vz cv wceq vy wal wn wph vz vw cv wsbc vw cv
      vy cv wceq wi vw wal vy wex wph vz cv vy cv wceq wi vz wal vy wex vw cv
      vx cv wcel vx cv vy cv wcel wph vz vw cv wsbc vy wal wa vx wex wb vw wal
      vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal vy cv vz
      cv wceq vy wal wn wph vz vw cv wsbc vw cv vy cv wceq wi vw wal wph vz cv
      vy cv wceq wi vz wal vy vy vz vy hbnae vy cv vz cv wceq vy wal wn wph vz
      vw cv wsbc vw cv vy cv wceq wi wph vz cv vy cv wceq wi vw vz vy vz vz
      hbnae vy cv vz cv wceq vy wal wn wph vz vw cv wsbc vw cv vy cv wceq vz vy
      vz vz hbnae wph vz vw cv wsbc wph vz vw cv wsbc vz wal wi vy cv vz cv
      wceq vy wal wn wph vz vw wph vw ax-17 hbsb3 a1i vz vy vw nd5 hbimd vw cv
      vz cv wceq wph vz vw cv wsbc vw cv vy cv wceq wi wph vz cv vy cv wceq wi
      wb wi vy cv vz cv wceq vy wal wn vw cv vz cv wceq wph vz vw cv wsbc wph
      vw cv vy cv wceq vz cv vy cv wceq wph vw vz sbequ12r vw vz vy equequ1
      imbi12d a1i cbvald exbid vy cv vz cv wceq vy wal wn vw cv vx cv wcel vx
      cv vy cv wcel wph vz vw cv wsbc vy wal wa vx wex wb vz cv vx cv wcel vx
      cv vy cv wcel wph vy wal wa vx wex wb vw vz vy vz vz hbnae vy cv vz cv
      wceq vy wal wn vw cv vx cv wcel vx cv vy cv wcel wph vz vw cv wsbc vy wal
      wa vx wex vz vy vz vz hbnae vw cv vx cv wcel vw cv vx cv wcel vz wal wi
      vy cv vz cv wceq vy wal wn vw cv vx cv wcel vz ax-17 a1i vy cv vz cv wceq
      vy wal wn vx cv vy cv wcel wph vz vw cv wsbc vy wal wa vz vx vy vz vx
      hbnae vy cv vz cv wceq vy wal wn vx cv vy cv wcel wph vz vw cv wsbc vy
      wal vz vx cv vy cv wcel vx cv vy cv wcel vz wal wi vz vy vz vy vx dveel2
      nalequcoms wph vz vw cv wsbc vy wal wph vz vw cv wsbc vy wal vz wal wi vy
      cv vz cv wceq vy wal wn wph vz vw cv wsbc vz vy wph vz vw wph vw ax-17
      hbsb3 hbal a1i hband hbexd hbbid vy cv vz cv wceq vy wal wn vw cv vz cv
      wceq vw cv vx cv wcel vx cv vy cv wcel wph vz vw cv wsbc vy wal wa vx wex
      wb vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb wb vy cv vz
      cv wceq vy wal wn vw cv vz cv wceq wa vw cv vx cv wcel vz cv vx cv wcel
      vx cv vy cv wcel wph vz vw cv wsbc vy wal wa vx wex vx cv vy cv wcel wph
      vy wal wa vx wex vw cv vz cv wceq vw cv vx cv wcel vz cv vx cv wcel wb vy
      cv vz cv wceq vy wal wn vw vz vx elequ1 adantl vy cv vz cv wceq vy wal wn
      vw cv vz cv wceq wa vx cv vy cv wcel wph vz vw cv wsbc vy wal wa vx cv vy
      cv wcel wph vy wal wa vx vy cv vz cv wceq vy wal wn vw cv vz cv wceq wa
      wph vz vw cv wsbc vy wal wph vy wal vx cv vy cv wcel vy cv vz cv wceq vy
      wal wn vw cv vz cv wceq wa vw cv vz cv wceq vy wal wph vz vw cv wsbc vy
      wal wph vy wal wb vy cv vz cv wceq vy wal wn vw cv vz cv wceq vw cv vz cv
      wceq vy wal vy vz vw dveeq2 imp vw cv vz cv wceq vy wal wph vz vw cv wsbc
      wph vy vw cv vz cv wceq vy hba1 vw cv vz cv wceq wph vz vw cv wsbc wph wb
      vy wph vw vz sbequ12r a4s albid syl anbi2d exbidv bibi12d ex cbvald
      imbi12d exbid mpbii $.
      $( [2-Jan-2002] $)
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.  $d w ph $.
    $( Lemma for the Axiom of Replacement with no distinct variable
       conditions. $)
    axrepndlem2 $p |- ( ( ( -. A. x x = y /\ -. A. x x = z ) /\ -. A. y y = z )
                 -> E. x ( E. y A. z ( ph -> z = y ) ->
                     A. z ( z e. x <-> E. x ( x e. y /\ A. y ph ) ) ) ) $=
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vz cv wceq
      vy wal wn wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy
      cv wcel wph vy wal wa vx wex wb vz wal wi vx wex vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa wph vx vw cv wsbc vz cv vy cv wceq wi vz
      wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc vy wal wa
      vw wex wb vz wal wi vw wex wph vz cv vy cv wceq wi vz wal vy wex vz cv vx
      cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi vx wex vy cv
      vz cv wceq vy wal wn vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn wa wph vx vw cv wsbc vz cv vy cv wceq wi vz wal vy wex vz cv vw cv
      wcel vw cv vy cv wcel wph vx vw cv wsbc vy wal wa vw wex wb vz wal wi wph
      vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vx cv vy cv wcel wph
      vy wal wa vx wex wb vz wal wi vw vx vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn wa wph vx vw cv wsbc vz cv vy cv
      wceq wi vz wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc
      vy wal wa vw wex wb vz wal vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa wph vx vw cv wsbc vz cv vy cv wceq wi vz
      wal vx vy vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy
      vy hbnae vx vz vy hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa wph vx vw cv wsbc vz cv vy cv wceq wi vx vz vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx vz vz hbnae
      hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa wph vx vw
      cv wsbc vz cv vy cv wceq vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban wph vx vw cv wsbc wph vx
      vw cv wsbc vx wal wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn wa wph vx vw wph vw ax-17 hbsb3 a1i vx cv vz cv wceq vx wal wn vx cv
      vy cv wceq vx wal wn vz cv vy cv wceq vz cv vy cv wceq vx wal wi vz vy vx
      ax-12 impcom hbimd hbald hbexd vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc vy
      wal wa vw wex wb vx vz vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn vz vx vy vz hbnae vx vz vz hbnae hban vx cv vy cv wceq vx wal wn vx cv
      vz cv wceq vx wal wn wa vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv
      wsbc vy wal wa vw wex vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vz cv wceq vx wal wn
      vz cv vw cv wcel vz cv vw cv wcel vx wal wi vx cv vy cv wceq vx wal wn vx
      vz vw dveel1 adantl vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      wa vw cv vy cv wcel wph vx vw cv wsbc vy wal wa vx vw vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw ax-17 vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel wph vx vw cv wsbc vy wal
      vx vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv wcel vx wal wi
      vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa wph vx vw cv wsbc vx vy vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy hbnae vx vz vy hbnae
      hban wph vx vw cv wsbc wph vx vw cv wsbc vx wal wi vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa wph vx vw wph vw ax-17 hbsb3 a1i
      hbald hband hbexd hbbid hbald hbimd vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vw cv vx cv wceq wph vx vw cv wsbc vz cv vy cv wceq
      wi vz wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc vy
      wal wa vw wex wb vz wal wi wph vz cv vy cv wceq wi vz wal vy wex vz cv vx
      cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi wb vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq wa wph vx
      vw cv wsbc vz cv vy cv wceq wi vz wal vy wex wph vz cv vy cv wceq wi vz
      wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc vy wal wa
      vw wex wb vz wal vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex
      wb vz wal vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv
      vx cv wceq wa vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw
      cv vx cv wceq vy wal wa wph vx vw cv wsbc vz cv vy cv wceq wi vz wal vy
      wex wph vz cv vy cv wceq wi vz wal vy wex wb vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vw cv vx cv wceq vy wal vx
      cv vy cv wceq vx wal wn vw cv vx cv wceq vw cv vx cv wceq vy wal wi vx cv
      vz cv wceq vx wal wn vy vx vw nd5 adantr imdistani vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy wal wa wph vx vw
      cv wsbc vz cv vy cv wceq wi vz wal wph vz cv vy cv wceq wi vz wal vy vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy
      wal vy vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy
      hbnae vx vz vy hbnae hban vw cv vx cv wceq vy hba1 hban vx cv vz cv wceq
      vx wal wn vw cv vx cv wceq wph vx vw cv wsbc vz cv vy cv wceq wi vz wal
      wph vz cv vy cv wceq wi vz wal wb vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq vy wal vx cv vz cv wceq vx wal wn vw
      cv vx cv wceq wa vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz wal wa
      wph vx vw cv wsbc vz cv vy cv wceq wi vz wal wph vz cv vy cv wceq wi vz
      wal wb vx cv vz cv wceq vx wal wn vw cv vx cv wceq vw cv vx cv wceq vz
      wal vz vx vw nd5 imdistani vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz
      wal wa wph vx vw cv wsbc vz cv vy cv wceq wi wph vz cv vy cv wceq wi vz
      vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz wal vz vx vz vz hbnae vw
      cv vx cv wceq vz hba1 hban vw cv vx cv wceq vz wal wph vx vw cv wsbc vz
      cv vy cv wceq wi wph vz cv vy cv wceq wi wb vx cv vz cv wceq vx wal wn vw
      cv vx cv wceq wph vx vw cv wsbc vz cv vy cv wceq wi wph vz cv vy cv wceq
      wi wb vz vw cv vx cv wceq wph vx vw cv wsbc wph vz cv vy cv wceq wph vw
      vx sbequ12r imbi1d a4s adantl albid syl vx cv vy cv wceq vx wal wn vx cv
      vz cv wceq vx wal wn pm3.27 vw cv vx cv wceq vy ax-4 syl2an exbid syl vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq wa
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq
      vz wal wa vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc vy wal wa
      vw wex wb vz wal vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex
      wb vz wal wb vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw
      cv vx cv wceq vw cv vx cv wceq vz wal vx cv vz cv wceq vx wal wn vw cv vx
      cv wceq vw cv vx cv wceq vz wal wi vx cv vy cv wceq vx wal wn vz vx vw
      nd5 adantl imdistani vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn wa vw cv vx cv wceq vz wal wa vz cv vw cv wcel vw cv vy cv wcel wph vx
      vw cv wsbc vy wal wa vw wex wb vz cv vx cv wcel vx cv vy cv wcel wph vy
      wal wa vx wex wb vz vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      wa vw cv vx cv wceq vz wal vz vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn vz vx vy vz hbnae vx vz vz hbnae hban vw cv vx cv wceq vz hba1
      hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv
      wceq vz cv vw cv wcel vw cv vy cv wcel wph vx vw cv wsbc vy wal wa vw wex
      wb vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb wb vw cv vx
      cv wceq vz wal vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa
      vw cv vx cv wceq wa vz cv vw cv wcel vz cv vx cv wcel vw cv vy cv wcel
      wph vx vw cv wsbc vy wal wa vw wex vx cv vy cv wcel wph vy wal wa vx wex
      vw cv vx cv wceq vz cv vw cv wcel vz cv vx cv wcel wb vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw vx vz elequ2 adantl vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel wph vx vw
      cv wsbc vy wal wa vw wex vx cv vy cv wcel wph vy wal wa vx wex wb vw cv
      vx cv wceq vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv
      vy cv wcel wph vx vw cv wsbc vy wal wa vx cv vy cv wcel wph vy wal wa vw
      vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx
      hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn wa vw cv vy cv wcel wph vx vw cv wsbc vy wal vx vx cv vy cv wceq
      vx wal wn vw cv vy cv wcel vw cv vy cv wcel vx wal wi vx cv vz cv wceq vx
      wal wn vx vy vw dveel2 adantr vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa wph vx vw cv wsbc vx vy vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn vy vx vy vy hbnae vx vz vy hbnae hban wph vx vw cv wsbc
      wph vx vw cv wsbc vx wal wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa wph vx vw wph vw ax-17 hbsb3 a1i hbald hband vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vw cv vy cv
      wcel wph vx vw cv wsbc vy wal wa vx cv vy cv wcel wph vy wal wa wb vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq wa vw
      cv vy cv wcel vx cv vy cv wcel wph vx vw cv wsbc vy wal wph vy wal vw cv
      vx cv wceq vw cv vy cv wcel vx cv vy cv wcel wb vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa vw vx vy elequ1 adantl vx cv vy cv wceq
      vx wal wn vw cv vx cv wceq wph vx vw cv wsbc vy wal wph vy wal wb vx cv
      vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn wph vx vw cv wsbc vy wal
      wph vy wal vx vw cv wsbc vw cv vx cv wceq wph vy wal vx cv vy cv wceq vx
      wal wn wph vy wal vx vw cv wsbc wph vx vw cv wsbc vy wal wph vy wal vx vw
      cv wsbc wph vx vw cv wsbc vy wal wb vy vx wph vy vx vw sbal2 nalequcoms
      bicomd wph vy wal vw vx sbequ12r sylan9bb adantlr anbi12d ex cbvexd
      adantr bibi12d vw cv vx cv wceq vz ax-4 sylan2 albid syl imbi12d ex
      cbvexd wph vx vw cv wsbc vw vy vz axrepndlem1 syl5bi imp $.
      $( [2-Jan-2002] $)
  $}

  $( A version of the Axiom of Replacement with no distinct variable
     conditions. $)
  axrepnd $p |- E. x ( E. y A. z ( ph -> z = y ) ->
               A. z ( A. y z e. x <-> E. x ( A. z x e. y /\ A. y ph ) ) ) $=
    vx cv vy cv wceq vx wal vx cv vz cv wceq vx wal vy cv vz cv wceq vy wal wph
    vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy cv wcel
    vz wal wph vy wal wa vx wex wb vz wal wi vx wex vx cv vy cv wceq vx wal wn
    vx cv vz cv wceq vx wal wn vy cv vz cv wceq vy wal wn wph vz cv vy cv wceq
    wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal
    wa vx wex wb vz wal wi vx wex vx cv vy cv wceq vx wal wn vx cv vz cv wceq
    vx wal wn wa vy cv vz cv wceq vy wal wn wa wph vz cv vy cv wceq wi vz wal
    vy wex vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi
    vx wex wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx cv
    vy cv wcel vz wal wph vy wal wa vx wex wb vz wal wi vx wex wph vx vy vz
    axrepndlem2 vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv
    vz cv wceq vy wal wn wa wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv
    wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz wal wi wph vz cv vy cv
    wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph
    vy wal wa vx wex wb vz wal wi vx vx cv vy cv wceq vx wal wn vx cv vz cv
    wceq vx wal wn wa vy cv vz cv wceq vy wal wn vx vx cv vy cv wceq vx wal wn
    vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vy vz vx
    hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv
    vz cv wceq vy wal wn wa vz cv vx cv wcel vx cv vy cv wcel wph vy wal wa vx
    wex wb vz wal vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa
    vx wex wb vz wal wph vz cv vy cv wceq wi vz wal vy wex vx cv vy cv wceq vx
    wal wn vx cv vz cv wceq vx wal wn wa vy cv vz cv wceq vy wal wn wa vz cv vx
    cv wcel vx cv vy cv wcel wph vy wal wa vx wex wb vz cv vx cv wcel vy wal vx
    cv vy cv wcel vz wal wph vy wal wa vx wex wb vz vx cv vy cv wceq vx wal wn
    vx cv vz cv wceq vx wal wn wa vy cv vz cv wceq vy wal wn vz vx cv vy cv
    wceq vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx vz vz hbnae
    hban vy vz vz hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
    wn wa vy cv vz cv wceq vy wal wn wa vz cv vx cv wcel vz cv vx cv wcel vy
    wal vx cv vy cv wcel wph vy wal wa vx wex vx cv vy cv wcel vz wal wph vy
    wal wa vx wex vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy
    cv vz cv wceq vy wal wn wa vz cv vx cv wcel vz cv vx cv wcel vy wal vx cv
    vy cv wceq vx wal wn vy cv vz cv wceq vy wal wn vz cv vx cv wcel vz cv vx
    cv wcel vy wal wi vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vy
    cv vz cv wceq vy wal wn vz cv vx cv wcel vz cv vx cv wcel vy wal wi vy cv
    vz cv wceq vy wal wn vz cv vx cv wcel vz cv vx cv wcel vy wal wi wi vy vx
    vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vz cv vx cv wcel vz
    cv vx cv wcel vy wal wi vz vx vy ax-15 com12 nalequcoms imp adantlr vz cv
    vx cv wcel vy ax-4 impbid1 vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
    wal wn wa vy cv vz cv wceq vy wal wn wa vx cv vy cv wcel wph vy wal wa vx
    cv vy cv wcel vz wal wph vy wal wa vx vx cv vy cv wceq vx wal wn vx cv vz
    cv wceq vx wal wn wa vy cv vz cv wceq vy wal wn vx vx cv vy cv wceq vx wal
    wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vy vz
    vx hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy
    cv vz cv wceq vy wal wn wa vx cv vy cv wcel vx cv vy cv wcel vz wal wph vy
    wal vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vz cv
    wceq vy wal wn wa vx cv vy cv wcel vx cv vy cv wcel vz wal vx cv vz cv wceq
    vx wal wn vy cv vz cv wceq vy wal wn vx cv vy cv wcel vx cv vy cv wcel vz
    wal wi vx cv vy cv wceq vx wal wn vz cv vx cv wceq vz wal wn vz cv vy cv
    wceq vz wal wn vx cv vy cv wcel vx cv vy cv wcel vz wal wi vx cv vz cv wceq
    vx wal wn vy cv vz cv wceq vy wal wn vz cv vx cv wceq vz wal wn vz cv vy cv
    wceq vz wal wn vx cv vy cv wcel vx cv vy cv wcel vz wal wi vx vy vz ax-15
    imp vz cv vx cv wceq vz wal vx cv vz cv wceq vx wal vz vx alequcom con3i vz
    cv vy cv wceq vz wal vy cv vz cv wceq vy wal vz vy alequcom con3i syl2an
    adantll vx cv vy cv wcel vz ax-4 impbid1 anbi1d exbid bibi12d albid imbi2d
    exbid mpbid exp31 vx cv vy cv wceq vx wal wph vz cv vy cv wceq wi vz wal vy
    wex vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb
    vz wal wi wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx
    cv vy cv wcel vz wal wph vy wal wa vx wex wb vz wal wi vx wex vx cv vy cv
    wceq vx wal vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa
    vx wex wb vz wal wph vz cv vy cv wceq wi vz wal vy wex vx cv vy cv wceq vx
    wal vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb
    vz vx vy vz hbae vz cv vx cv wcel vy wal wn vx cv vy cv wcel vz wal wph vy
    wal wa vx wex wn vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal
    wa vx wex wb vx cv vy cv wceq vx wal vz cv vx cv wcel vy wal vx cv vy cv
    wcel vz wal wph vy wal wa vx wex pm5.21 vz cv vx cv wcel vy wal wn vy vx vy
    vx vz nd2 alequcoms vx cv vy cv wceq vx wal vx cv vy cv wcel vz wal wph vy
    wal wa vx vx vy vx hbae vx cv vy cv wceq vx wal vx cv vy cv wcel vz wal wph
    vy wal vx vy vz nd3 intnanrd nexd sylanc 19.21ai a1d wph vz cv vy cv wceq
    wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal
    wa vx wex wb vz wal wi vx 19.8a syl vx cv vz cv wceq vx wal wph vz cv vy cv
    wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph
    vy wal wa vx wex wb vz wal wi wph vz cv vy cv wceq wi vz wal vy wex vz cv
    vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb vz wal wi
    vx wex vx cv vz cv wceq vx wal vz cv vx cv wcel vy wal vx cv vy cv wcel vz
    wal wph vy wal wa vx wex wb vz wal wph vz cv vy cv wceq wi vz wal vy wex vx
    cv vz cv wceq vx wal vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy
    wal wa vx wex wb vz vx vz vz hbae vz cv vx cv wcel vy wal wn vx cv vy cv
    wcel vz wal wph vy wal wa vx wex wn vz cv vx cv wcel vy wal vx cv vy cv
    wcel vz wal wph vy wal wa vx wex wb vx cv vz cv wceq vx wal vz cv vx cv
    wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex pm5.21 vx vz vy
    nd4 vx cv vz cv wceq vx wal vx cv vy cv wcel vz wal wph vy wal wa vx vx vz
    vx hbae vx cv vz cv wceq vx wal vx cv vy cv wcel vz wal wph vy wal vx cv vy
    cv wcel vz wal wn vz vx vz vx vy nd1 alequcoms intnanrd nexd sylanc 19.21ai
    a1d wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy
    cv wcel vz wal wph vy wal wa vx wex wb vz wal wi vx 19.8a syl vy cv vz cv
    wceq vy wal wph vz cv vy cv wceq wi vz wal vy wex vz cv vx cv wcel vy wal
    vx cv vy cv wcel vz wal wph vy wal wa vx wex wb vz wal wi wph vz cv vy cv
    wceq wi vz wal vy wex vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph
    vy wal wa vx wex wb vz wal wi vx wex vy cv vz cv wceq vy wal vz cv vx cv
    wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb vz wal wph vz
    cv vy cv wceq wi vz wal vy wex vy cv vz cv wceq vy wal vz cv vx cv wcel vy
    wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb vz vy vz vz hbae vz cv
    vx cv wcel vy wal wn vx cv vy cv wcel vz wal wph vy wal wa vx wex wn vz cv
    vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb vy cv vz
    cv wceq vy wal vz cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal
    wa vx wex pm5.21 vy vz vx nd1 vy cv vz cv wceq vy wal vx cv vy cv wcel vz
    wal wph vy wal wa vx vy vz vx hbae vy cv vz cv wceq vy wal vx cv vy cv wcel
    vz wal wph vy wal vx cv vy cv wcel vz wal wn vz vy vz vy vx nd2 alequcoms
    intnanrd nexd sylanc 19.21ai a1d wph vz cv vy cv wceq wi vz wal vy wex vz
    cv vx cv wcel vy wal vx cv vy cv wcel vz wal wph vy wal wa vx wex wb vz wal
    wi vx 19.8a syl pm2.61iii $.
    $( [2-Jan-2002] $)

  ${
    $d x y w $.  $d x z w $.
    $( Lemma for the Axiom of Union with no distinct variable
       conditions. $)
    axunndlem1 $p |- E. x A. y ( E. x ( y e. x /\ x e. z ) -> y e. x ) $=
      vy cv vz cv wceq vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv
      vx cv wcel wi vy wal vx wex vy cv vz cv wceq vy wal vy cv vx cv wcel vx
      cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy wal vy cv vx cv wcel vx cv
      vz cv wcel wa vx wex vy cv vx cv wcel wi vy wal vx wex vy cv vz cv wceq
      vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy vy cv
      vz cv wceq vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv
      wcel vy cv vz cv wceq vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx vy
      vz vx hbae vy cv vz cv wceq vy cv vx cv wcel vx cv vz cv wcel wa wn vy vy
      cv vz cv wceq vy cv vx cv wcel vx cv vy cv wcel wa vy cv vx cv wcel vx cv
      vz cv wcel wa vy cv vx cv en2lp vy cv vz cv wceq vx cv vy cv wcel vx cv
      vz cv wcel vy cv vx cv wcel vy vz vx elequ2 anbi2d mtbii a4s nexd pm2.21d
      a5i vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy
      wal vx 19.8a syl vy cv vz cv wceq vy wal wn vw cv vx cv wcel vx cv vz cv
      wcel wa vx wex vw cv vx cv wcel wi vw wal vx wex vy cv vx cv wcel vx cv
      vz cv wcel wa vx wex vy cv vx cv wcel wi vy wal vx wex vx vw vz zfun vy
      cv vz cv wceq vy wal wn vw cv vx cv wcel vx cv vz cv wcel wa vx wex vw cv
      vx cv wcel wi vw wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx
      cv wcel wi vy wal vx vy vz vx hbnae vy cv vz cv wceq vy wal wn vw cv vx
      cv wcel vx cv vz cv wcel wa vx wex vw cv vx cv wcel wi vy cv vx cv wcel
      vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vw vy vy vz vy hbnae vy cv
      vz cv wceq vy wal wn vw cv vx cv wcel vx cv vz cv wcel wa vx wex vw cv vx
      cv wcel vy vy vz vy hbnae vy cv vz cv wceq vy wal wn vw cv vx cv wcel vx
      cv vz cv wcel wa vy vx vy vz vx hbnae vy cv vz cv wceq vy wal wn vw cv vx
      cv wcel vx cv vz cv wcel vy vw cv vx cv wcel vw cv vx cv wcel vy wal wi
      vy cv vz cv wceq vy wal wn vw cv vx cv wcel vy ax-17 a1i vy vz vx dveel2
      hband hbexd vw cv vx cv wcel vw cv vx cv wcel vy wal wi vy cv vz cv wceq
      vy wal wn vw cv vx cv wcel vy ax-17 a1i hbimd vw cv vy cv wceq vw cv vx
      cv wcel vx cv vz cv wcel wa vx wex vw cv vx cv wcel wi vy cv vx cv wcel
      vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi wb wi vy cv vz cv wceq vy
      wal wn vw cv vy cv wceq vw cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv
      vx cv wcel vx cv vz cv wcel wa vx wex vw cv vx cv wcel vy cv vx cv wcel
      vw cv vy cv wceq vw cv vx cv wcel vx cv vz cv wcel wa vy cv vx cv wcel vx
      cv vz cv wcel wa vx vw cv vy cv wceq vw cv vx cv wcel vy cv vx cv wcel vx
      cv vz cv wcel vw vy vx elequ1 anbi1d exbidv vw vy vx elequ1 imbi12d a1i
      cbvald exbid mpbii pm2.61i $.
      $( [2-Jan-2002] $)
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A version of the Axiom of Union with no distinct variable conditions. $)
    axunnd $p |- E. x A. y ( E. x ( y e. x /\ x e. z ) -> y e. x ) $=
      vx cv vy cv wceq vx wal vx cv vz cv wceq vx wal vy cv vx cv wcel vx cv vz
      cv wcel wa vx wex vy cv vx cv wcel wi vy wal vx wex vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn vy cv vx cv wcel vx cv vz cv wcel wa vx
      wex vy cv vx cv wcel wi vy wal vx wex vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv wcel wa vw wex vy cv vw
      cv wcel wi vy wal vw wex vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy
      cv vx cv wcel wi vy wal vx wex vw vy vz axunndlem1 vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv wcel wa
      vw wex vy cv vw cv wcel wi vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx
      wex vy cv vx cv wcel wi vy wal vw vx vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv wcel
      wa vw wex vy cv vw cv wcel wi vx vy vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn vy vx vy vy hbnae vx vz vy hbnae hban vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv wcel
      wa vw wex vy cv vw cv wcel vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv wcel wa vx
      vw vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw ax-17 vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw
      cv vz cv wcel vx vx cv vy cv wceq vx wal wn vy cv vw cv wcel vy cv vw cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel1 adantr vx cv vz
      cv wceq vx wal wn vw cv vz cv wcel vw cv vz cv wcel vx wal wi vx cv vy cv
      wceq vx wal wn vx vz vw dveel2 adantl hband hbexd vx cv vy cv wceq vx wal
      wn vy cv vw cv wcel vy cv vw cv wcel vx wal wi vx cv vz cv wceq vx wal wn
      vx vy vw dveel1 adantr hbimd hbald vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq vy cv vw cv wcel vw cv vz cv wcel wa
      vw wex vy cv vw cv wcel wi vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx
      wex vy cv vx cv wcel wi vy wal wb vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq wa vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vw cv vx cv wceq vy wal wa vy cv vw cv wcel vw cv vz
      cv wcel wa vw wex vy cv vw cv wcel wi vy wal vy cv vx cv wcel vx cv vz cv
      wcel wa vx wex vy cv vx cv wcel wi vy wal wb vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vw cv vx cv wceq vy wal vx
      cv vy cv wceq vx wal wn vw cv vx cv wceq vw cv vx cv wceq vy wal wi vx cv
      vz cv wceq vx wal wn vy vx vw nd5 adantr imdistani vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy wal wa vy cv vw
      cv wcel vw cv vz cv wcel wa vw wex vy cv vw cv wcel wi vy cv vx cv wcel
      vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy wal vy vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy hbnae vx vz vy
      hbnae hban vw cv vx cv wceq vy hba1 hban vx cv vy cv wceq vx wal wn vx cv
      vz cv wceq vx wal wn wa vw cv vx cv wceq vy wal wa vy cv vw cv wcel vw cv
      vz cv wcel wa vw wex vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vw
      cv wcel vy cv vx cv wcel vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn wa vy cv vw cv wcel vw cv vz cv wcel wa vw wex vy cv vx cv wcel vx
      cv vz cv wcel wa vx wex wb vw cv vx cv wceq vy wal vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv wcel wa
      vy cv vx cv wcel vx cv vz cv wcel wa vw vx vx cv vy cv wceq vx wal wn vx
      cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vw cv vz cv
      wcel vx vx cv vy cv wceq vx wal wn vy cv vw cv wcel vy cv vw cv wcel vx
      wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel1 adantr vx cv vz cv wceq
      vx wal wn vw cv vz cv wcel vw cv vz cv wcel vx wal wi vx cv vy cv wceq vx
      wal wn vx vz vw dveel2 adantl hband vw cv vx cv wceq vy cv vw cv wcel vw
      cv vz cv wcel wa vy cv vx cv wcel vx cv vz cv wcel wa wb wi vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy cv vw cv
      wcel vy cv vx cv wcel vw cv vz cv wcel vx cv vz cv wcel vw vx vy elequ2
      vw vx vz elequ1 anbi12d a1i cbvexd adantr vw cv vx cv wceq vy wal vy cv
      vw cv wcel vy cv vx cv wcel wb vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq vy cv vw cv wcel vy cv vx cv wcel wb
      vy vw vx vy elequ2 a4s adantl imbi12d albid syl ex cbvexd mpbii ex vx cv
      vy cv wceq vx wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv
      wcel wi vy wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv
      wcel wi vy wal vx wex vx cv vy cv wceq vx wal vy cv vx cv wcel vx cv vz
      cv wcel wa vx wex vy cv vx cv wcel wi vy vx vy vy hbae vx cv vy cv wceq
      vx wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv wcel vx cv
      vy cv wceq vx wal vy cv vx cv wcel vx cv vz cv wcel wa vx vx vy vx hbae
      vx cv vy cv wceq vy cv vx cv wcel vx cv vz cv wcel wa wn vx vx cv vy cv
      wceq vy cv vx cv wcel vx cv vz cv wcel wa vy cv vy cv wcel vy elirrv vx
      cv vy cv wceq vy cv vx cv wcel vy cv vy cv wcel vy cv vx cv wcel vx cv vz
      cv wcel wa vx vy vy elequ2 vy cv vx cv wcel vx cv vz cv wcel pm3.26
      syl5bi mtoi a4s nexd pm2.21d 19.21ai vy cv vx cv wcel vx cv vz cv wcel wa
      vx wex vy cv vx cv wcel wi vy wal vx 19.8a syl vx cv vz cv wceq vx wal vy
      cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy wal vy cv
      vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv wcel wi vy wal vx wex
      vx cv vz cv wceq vx wal vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv
      vx cv wcel wi vy vx vz vy hbae vx cv vz cv wceq vx wal vy cv vx cv wcel
      vx cv vz cv wcel wa vx wex vy cv vx cv wcel vx cv vz cv wceq vx wal vy cv
      vx cv wcel vx cv vz cv wcel wa vx vx vz vx hbae vx cv vz cv wceq vy cv vx
      cv wcel vx cv vz cv wcel wa wn vx vx cv vz cv wceq vy cv vx cv wcel vx cv
      vz cv wcel wa vz cv vz cv wcel vz elirrv vx cv vz cv wceq vx cv vz cv
      wcel vz cv vz cv wcel vy cv vx cv wcel vx cv vz cv wcel wa vx vz vz
      elequ1 vy cv vx cv wcel vx cv vz cv wcel pm3.27 syl5bi mtoi a4s nexd
      pm2.21d 19.21ai vy cv vx cv wcel vx cv vz cv wcel wa vx wex vy cv vx cv
      wcel wi vy wal vx 19.8a syl pm2.61ii $.
      $( [2-Jan-2002] $)
  $}

  $( Lemma for the Axiom of Power Sets with no distinct variable
     conditions. $)
  axpowndlem1 $p |- ( A. x x = y -> ( -. x = y ->
             E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) $=
    vx cv vy cv wceq vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv
    wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vx vx cv vy cv
    wceq vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv
    wcel wi vy wal vx wex pm2.24 a4s $.
    $( [4-Jan-2002] $)

  ${
    $d x w $.  $d z y w $.
    $( Lemma for the Axiom of Power Sets with no distinct variable
       conditions. $)
    axpowndlem2 $p |- ( -. A. x x = y -> ( -. A. x x = z -> ( -. x = y ->
         E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) ) $=
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx cv vy cv wceq wn
      vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv
      wcel wi vy wal vx wex wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn wa vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv wcel vy
      wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vx vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wceq wn vw cv vy cv wcel
      vz wex vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vw
      wex wi vw wal vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv
      wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vx wal vw cv
      vy cv wceq wn vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal
      vy cv vw cv wcel wi vy wal vw wex wi vw vw cv vy cv wcel vz wex vw cv vz
      cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vw wex vw cv vy cv
      wceq wn vw cv vy cv wcel vw cv vz cv wcel wi vw wal vy cv vw cv wcel wi
      vy wal vw wex vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal
      vy cv vw cv wcel wi vy wal vw wex vw vy vz zfpow vw cv vy cv wcel vw cv
      vz cv wcel wi vw wal vy cv vw cv wcel wi vy wal vw cv vy cv wcel vz wex
      vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vw vw cv vy
      cv wcel vw cv vz cv wcel wi vw wal vy cv vw cv wcel wi vw cv vy cv wcel
      vz wex vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy vw cv vy
      cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal vw cv vy cv wcel vw cv
      vz cv wcel wi vw wal vy cv vw cv wcel vw cv vy cv wcel vz wex vw cv vz cv
      wcel vy wal wi vw cv vy cv wcel vw cv vz cv wcel wi vw vw cv vy cv wcel
      vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal vw cv vz cv wcel vw cv vy
      cv wcel vz 19.8a vw cv vz cv wcel vy ax-4 imim12i 19.20i imim1i 19.20i
      19.22i ax-mp a1i ax-gen vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn wa vw cv vy cv wceq wn vw cv vy cv wcel vz wex vw cv vz cv wcel vy
      wal wi vw wal vy cv vw cv wcel wi vy wal vw wex wi vx cv vy cv wceq wn vx
      cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel
      wi vy wal vx wex wi vw vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vw cv vy cv wceq wn vw cv vy cv wcel vz wex
      vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vw wex vx vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx
      vz vx hbnae hban vx cv vy cv wceq vx wal wn vw cv vy cv wceq wn vw cv vy
      cv wceq wn vx wal wi vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal
      wn vw cv vy cv wceq vx vx vy vx hbnae vx vy vw dveeq2 hbnd adantr vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vz
      wex vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vx vw vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw ax-17 vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vz wex
      vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vx vy vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy hbnae vx vz vy
      hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv
      vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel vx
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae
      vx vz vx hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      wa vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vx vw vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn vw vx vy vw hbnae vx vz vw
      hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv
      vy cv wcel vz wex vw cv vz cv wcel vy wal vx vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vx vz vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx
      vz vz hbnae hban vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr hbexd vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vz cv wcel vx
      vy vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy
      hbnae vx vz vy hbnae hban vx cv vz cv wceq vx wal wn vw cv vz cv wcel vw
      cv vz cv wcel vx wal wi vx cv vy cv wceq vx wal wn vx vz vw dveel2 adantl
      hbald hbimd hbald vx cv vy cv wceq vx wal wn vy cv vw cv wcel vy cv vw cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel1 adantr hbimd
      hbald hbexd hbimd vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      wa vw cv vx cv wceq vw cv vy cv wceq wn vw cv vy cv wcel vz wex vw cv vz
      cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vw wex wi vx cv vy cv
      wceq wn vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv
      vx cv wcel wi vy wal vx wex wi wb vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq wa vw cv vy cv wceq wn vx cv vy cv
      wceq wn vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal vy cv
      vw cv wcel wi vy wal vw wex vx cv vy cv wcel vz wex vx cv vz cv wcel vy
      wal wi vx wal vy cv vx cv wcel wi vy wal vx wex vw cv vx cv wceq vw cv vy
      cv wceq wn vx cv vy cv wceq wn wb vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq vw cv vy cv wceq vx cv vy cv wceq vw
      vx vy equequ1 notbid adantl vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal vy
      cv vw cv wcel wi vy wal vw wex vx cv vy cv wcel vz wex vx cv vz cv wcel
      vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wb vw cv vx cv wceq vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vz
      wex vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vx cv vy
      cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy
      wal vw vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy
      vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal vy
      cv vw cv wcel wi vx vy vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn vy vx vy vy hbnae vx vz vy hbnae hban vx cv vy cv wceq vx wal wn vx cv
      vz cv wceq vx wal wn wa vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal
      wi vw wal vy cv vw cv wcel vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx wal
      wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vz wex vw cv vz cv wcel
      vy wal wi vx vw vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa
      vw ax-17 vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv
      vy cv wcel vz wex vw cv vz cv wcel vy wal vx vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vx vz vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx
      vz vz hbnae hban vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr hbexd vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vz cv wcel vx
      vy vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy
      hbnae vx vz vy hbnae hban vx cv vz cv wceq vx wal wn vw cv vz cv wcel vw
      cv vz cv wcel vx wal wi vx cv vy cv wceq vx wal wn vx vz vw dveel2 adantl
      hbald hbimd hbald vx cv vy cv wceq vx wal wn vy cv vw cv wcel vy cv vw cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel1 adantr hbimd
      hbald vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx
      cv wceq vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vw wal vy cv
      vw cv wcel wi vy wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi
      vx wal vy cv vx cv wcel wi vy wal wb vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vw cv vx cv wceq wa vx cv vy cv wceq vx wal wn vx cv
      vz cv wceq vx wal wn wa vw cv vx cv wceq vy wal wa vw cv vy cv wcel vz
      wex vw cv vz cv wcel vy wal wi vw wal vy cv vw cv wcel wi vy wal vx cv vy
      cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy
      wal wb vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx
      cv wceq vw cv vx cv wceq vy wal vx cv vy cv wceq vx wal wn vw cv vx cv
      wceq vw cv vx cv wceq vy wal wi vx cv vz cv wceq vx wal wn vy vx vw nd5
      adantr imdistani vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa
      vw cv vx cv wceq vy wal wa vw cv vy cv wcel vz wex vw cv vz cv wcel vy
      wal wi vw wal vy cv vw cv wcel wi vx cv vy cv wcel vz wex vx cv vz cv
      wcel vy wal wi vx wal vy cv vx cv wcel wi vy vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy wal vy vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy hbnae vx vz vy hbnae
      hban vw cv vx cv wceq vy hba1 hban vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vx cv wceq vy wal wa vw cv vy cv wcel vz wex vw
      cv vz cv wcel vy wal wi vw wal vx cv vy cv wcel vz wex vx cv vz cv wcel
      vy wal wi vx wal vy cv vw cv wcel vy cv vx cv wcel vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vz wex vw cv vz cv
      wcel vy wal wi vw wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi
      vx wal wb vw cv vx cv wceq vy wal vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn wa vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vx
      cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vw vx vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel
      vz wex vw cv vz cv wcel vy wal vx vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vx vz vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx vz vz
      hbnae hban vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv wcel
      vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr hbexd vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vz cv wcel vx vy
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vy vx vy vy hbnae
      vx vz vy hbnae hban vx cv vz cv wceq vx wal wn vw cv vz cv wcel vw cv vz
      cv wcel vx wal wi vx cv vy cv wceq vx wal wn vx vz vw dveel2 adantl hbald
      hbimd vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx
      cv wceq vw cv vy cv wcel vz wex vw cv vz cv wcel vy wal wi vx cv vy cv
      wcel vz wex vx cv vz cv wcel vy wal wi wb vx cv vy cv wceq vx wal wn vx
      cv vz cv wceq vx wal wn wa vw cv vx cv wceq wa vw cv vy cv wcel vz wex vx
      cv vy cv wcel vz wex vw cv vz cv wcel vy wal vx cv vz cv wcel vy wal vx
      cv vz cv wceq vx wal wn vw cv vx cv wceq vw cv vy cv wcel vz wex vx cv vy
      cv wcel vz wex wb vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      vw cv vx cv wceq wa vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz wal wa
      vw cv vy cv wcel vz wex vx cv vy cv wcel vz wex wb vx cv vz cv wceq vx
      wal wn vw cv vx cv wceq vw cv vx cv wceq vz wal vz vx vw nd5 imdistani vw
      cv vx cv wceq vz wal vw cv vy cv wcel vz wex vx cv vy cv wcel vz wex wb
      vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz wal vw cv vy cv wcel vx cv
      vy cv wcel vz vw cv vx cv wceq vz hba1 vw cv vx cv wceq vw cv vy cv wcel
      vx cv vy cv wcel wb vz vw vx vy elequ1 a4s exbid adantl syl adantll vx cv
      vy cv wceq vx wal wn vw cv vx cv wceq vw cv vz cv wcel vy wal vx cv vz cv
      wcel vy wal wb vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vw
      cv vx cv wceq wa vx cv vy cv wceq vx wal wn vw cv vx cv wceq vy wal wa vw
      cv vz cv wcel vy wal vx cv vz cv wcel vy wal wb vx cv vy cv wceq vx wal
      wn vw cv vx cv wceq vw cv vx cv wceq vy wal vy vx vw nd5 imdistani vw cv
      vx cv wceq vy wal vw cv vz cv wcel vy wal vx cv vz cv wcel vy wal wb vx
      cv vy cv wceq vx wal wn vw cv vx cv wceq vy wal vw cv vz cv wcel vx cv vz
      cv wcel vy vw cv vx cv wceq vy hba1 vw cv vx cv wceq vw cv vz cv wcel vx
      cv vz cv wcel wb vy vw vx vz elequ1 a4s albid adantl syl adantlr imbi12d
      ex cbvald adantr vw cv vx cv wceq vy wal vy cv vw cv wcel vy cv vx cv
      wcel wb vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx
      cv wceq vy cv vw cv wcel vy cv vx cv wcel wb vy vw vx vy elequ2 a4s
      adantl imbi12d albid syl ex cbvexd adantr imbi12d ex cbvald mpbii 19.21bi
      ex $.
      $( [4-Jan-2002] $)
  $}


  ${
    $d x w $.  $d y z w $.
    $( Lemma for the Axiom of Power Sets with no distinct variable
       conditions. $)
    axpowndlem3 $p |- ( -. x = y ->
               E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) $=
      vx cv vy cv wceq vx wal vx cv vz cv wceq vx wal vx cv vy cv wceq wn vx cv
      vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi
      vy wal vx wex wi vx vy vz axpowndlem2 vx vy vz axpowndlem1 vx cv vz cv
      wceq vx wal vx cv vy cv wceq vx wal vx cv vy cv wceq wn vx cv vy cv wcel
      vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx
      wex wi vx cv vz cv wceq vx wal vx cv vy cv wceq vx wal wn vx cv vy cv
      wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal
      vx wex vx cv vy cv wceq wn vx cv vz cv wceq vx wal vx cv vy cv wcel vx
      wex wn vy cv vx cv wcel wi vy wal vx wex vx cv vy cv wcel vz wex vx cv vz
      cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal vx cv vy cv wcel vx wex wn vy cv
      vx cv wcel wi vy wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi
      vx wal vy cv vx cv wcel wi vy wal vx vx vz vx hbae vx cv vz cv wceq vx
      wal vx cv vy cv wcel vx wex wn vy cv vx cv wcel wi vx cv vy cv wcel vz
      wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy vx vz vy
      hbae vx cv vz cv wceq vx wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy
      wal wi vx wal vx cv vy cv wcel vx wex wn vy cv vx cv wcel vx cv vz cv
      wceq vx wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx cv vy
      cv wcel vx wex wn vx vx cv vz cv wceq vx wal vx cv vy cv wcel vz wex vx
      cv vz cv wcel vy wal wi vx cv vy cv wcel vz wex wn vx cv vy cv wcel vx
      wex wn vx cv vz cv wceq vx wal vx cv vz cv wcel vy wal wn vx cv vy cv
      wcel vz wex wn vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi wb vx
      vz vy nd3 vx cv vz cv wcel vy wal vx cv vy cv wcel vz wex mtt syl vx cv
      vz cv wceq vx wal vx cv vy cv wcel wn vz wal vx cv vy cv wcel wn vx wal
      vx cv vy cv wcel vz wex wn vx cv vy cv wcel vx wex wn vx cv vy cv wcel wn
      vz wal vx cv vy cv wcel wn vx wal wi vz vx vx cv vy cv wcel wn vz vx
      ax-10o alequcoms vx cv vy cv wcel vz alnex vx cv vy cv wcel vx alnex
      3imtr3g sylbird a4sd imim1d 19.20d 19.22d vx cv vy cv wceq vx wal wn vx
      cv vw cv wcel vx wex wn vw cv vx cv wcel wi vw wal vx wex vx cv vy cv
      wcel vx wex wn vy cv vx cv wcel wi vy wal vx wex vx cv vw cv wcel vx wex
      wn vw cv vx cv wcel wi vw wal vx wex vw cv c0 wceq vw cv vx cv wcel wi vw
      wal vx wex vw cv c0 wceq vw cv c0 csn wcel wi vw cv c0 wceq vw cv vx cv
      wcel wi vw wal vx wex vw vw cv c0 wceq vw cv vx cv wcel wi vw wal vw cv
      c0 wceq vw cv c0 csn wcel wi vw wal vx c0 csn p0ex vx cv c0 csn wceq vw
      cv c0 wceq vw cv vx cv wcel wi vw cv c0 wceq vw cv c0 csn wcel wi vw vx
      cv c0 csn wceq vw cv vx cv wcel vw cv c0 csn wcel vw cv c0 wceq vx cv c0
      csn vw cv eleq2 imbi2d albidv cla4ev vw cv c0 wceq vw cv c0 csn wcel c0
      c0 csn wcel c0 0ex snid vw cv c0 c0 csn eleq1 mpbiri mpg vx cv vw cv wcel
      vx wex wn vw cv vx cv wcel wi vw wal vw cv c0 wceq vw cv vx cv wcel wi vw
      wal vx vx cv vw cv wcel vx wex wn vw cv vx cv wcel wi vw cv c0 wceq vw cv
      vx cv wcel wi vw vx cv vw cv wcel vx wex wn vw cv c0 wceq vw cv vx cv
      wcel vw cv c0 wceq vx cv vw cv wcel vx wex vx vw cv neq0 con1bii imbi1i
      albii exbii mpbir vx cv vy cv wceq vx wal wn vx cv vw cv wcel vx wex wn
      vw cv vx cv wcel wi vw wal vx cv vy cv wcel vx wex wn vy cv vx cv wcel wi
      vy wal vx vx vy vx hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wcel vx
      wex wn vw cv vx cv wcel wi vx cv vy cv wcel vx wex wn vy cv vx cv wcel wi
      vw vy vx vy vy hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wcel vx wex
      wn vw cv vx cv wcel vy vx vy vy hbnae vx cv vy cv wceq vx wal wn vx cv vw
      cv wcel vx wex vy vx vy vy hbnae vx cv vy cv wceq vx wal wn vx cv vw cv
      wcel vy vx vx vy vx hbnae vx cv vw cv wcel vx cv vw cv wcel vy wal wi vy
      vx vy vx vw dveel1 nalequcoms hbexd hbnd vw cv vx cv wcel vw cv vx cv
      wcel vy wal wi vy vx vy vx vw dveel2 nalequcoms hbimd vx cv vy cv wceq vx
      wal wn vw cv vy cv wceq vx cv vw cv wcel vx wex wn vw cv vx cv wcel wi vx
      cv vy cv wcel vx wex wn vy cv vx cv wcel wi wb vx cv vy cv wceq vx wal wn
      vw cv vy cv wceq wa vx cv vw cv wcel vx wex wn vx cv vy cv wcel vx wex wn
      vw cv vx cv wcel vy cv vx cv wcel vx cv vy cv wceq vx wal wn vw cv vy cv
      wceq wa vx cv vw cv wcel vx wex vx cv vy cv wcel vx wex vx cv vy cv wceq
      vx wal wn vw cv vy cv wceq wa vx cv vy cv wceq vx wal wn vw cv vy cv wceq
      vx wal wa vx cv vw cv wcel vx wex vx cv vy cv wcel vx wex wb vx cv vy cv
      wceq vx wal wn vw cv vy cv wceq vw cv vy cv wceq vx wal vx vy vw dveeq2
      imdistani vw cv vy cv wceq vx wal vx cv vw cv wcel vx wex vx cv vy cv
      wcel vx wex wb vx cv vy cv wceq vx wal wn vw cv vy cv wceq vx wal vx cv
      vw cv wcel vx cv vy cv wcel vx vw cv vy cv wceq vx hba1 vw cv vy cv wceq
      vx cv vw cv wcel vx cv vy cv wcel wb vx vw vy vx elequ2 a4s exbid adantl
      syl notbid vw cv vy cv wceq vw cv vx cv wcel vy cv vx cv wcel wb vx cv vy
      cv wceq vx wal wn vw vy vx elequ1 adantl imbi12d ex cbvald exbid mpbii
      syl5 a1dd vx vy vz axpowndlem1 pm2.61d2 pm2.61ii $.
      $( [4-Jan-2002] $)
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( Lemma for the Axiom of Power Sets with no distinct variable
       conditions. $)
    axpowndlem4 $p |- ( -. A. y y = x -> ( -. A. y y = z -> ( -. x = y
      -> E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) ) $=
      vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vx cv vy cv wceq wn
      vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv
      wcel wi vy wal vx wex wi vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy
      wal wn wa vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv wcel vy
      wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vy vy cv vx cv wceq vy
      wal wn vy cv vz cv wceq vy wal wn wa vx cv vw cv wceq wn vx cv vw cv wcel
      vz wex vx cv vz cv wcel vw wal wi vx wal vw cv vx cv wcel wi vw wal vx
      wex wi vw wal vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv
      wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vy wal vx cv
      vw cv wceq wn vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx wal
      vw cv vx cv wcel wi vw wal vx wex wi vw vx vw vz axpowndlem3 ax-gen vy cv
      vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx cv vw cv wceq wn vx
      cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx wal vw cv vx cv wcel
      wi vw wal vx wex wi vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz
      cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vw vy vy cv
      vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy vy vx vy hbnae vy vz
      vy hbnae hban vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx
      cv vw cv wceq wn vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx
      wal vw cv vx cv wcel wi vw wal vx wex vy vy cv vx cv wceq vy wal wn vy cv
      vz cv wceq vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv
      wceq vy wal wn vx cv vw cv wceq wn vx cv vw cv wceq wn vy wal wi vy cv vz
      cv wceq vy wal wn vy cv vx cv wceq vy wal wn vx cv vw cv wceq vy vy vx vy
      hbnae vy vx vw dveeq1 hbnd adantr vy cv vx cv wceq vy wal wn vy cv vz cv
      wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx
      wal vw cv vx cv wcel wi vw wal vy vx vy cv vx cv wceq vy wal wn vy cv vz
      cv wceq vy wal wn vx vy vx vx hbnae vy vz vx hbnae hban vy cv vx cv wceq
      vy wal wn vy cv vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz
      cv wcel vw wal wi vx wal vw cv vx cv wcel wi vy vw vy cv vx cv wceq vy
      wal wn vy cv vz cv wceq vy wal wn wa vw ax-17 vy cv vx cv wceq vy wal wn
      vy cv vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw
      wal wi vx wal vw cv vx cv wcel vy vy cv vx cv wceq vy wal wn vy cv vz cv
      wceq vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv wceq vy
      wal wn vy cv vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv
      wcel vw wal wi vy vx vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal
      wn vx vy vx vx hbnae vy vz vx hbnae hban vy cv vx cv wceq vy wal wn vy cv
      vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal
      vy vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy vy vx vy
      hbnae vy vz vy hbnae hban vy cv vx cv wceq vy wal wn vx cv vw cv wcel vz
      wex vx cv vw cv wcel vz wex vy wal wi vy cv vz cv wceq vy wal wn vy cv vx
      cv wceq vy wal wn vx cv vw cv wcel vy vz vy vx vz hbnae vy vx vw dveel1
      hbexd adantr vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx
      cv vz cv wcel vy vw vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn
      wa vw ax-17 vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vx cv
      vz cv wcel vx cv vz cv wcel vy wal wi vx vz vy ax-15 imp hbald hbimd
      hbald vy cv vx cv wceq vy wal wn vw cv vx cv wcel vw cv vx cv wcel vy wal
      wi vy cv vz cv wceq vy wal wn vy vx vw dveel2 adantr hbimd hbald hbexd
      hbimd vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy
      cv wceq vx cv vw cv wceq wn vx cv vw cv wcel vz wex vx cv vz cv wcel vw
      wal wi vx wal vw cv vx cv wcel wi vw wal vx wex wi vx cv vy cv wceq wn vx
      cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel
      wi vy wal vx wex wi wb vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal
      wn wa vw cv vy cv wceq wa vx cv vw cv wceq wn vx cv vy cv wceq wn vx cv
      vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx wal vw cv vx cv wcel wi
      vw wal vx wex vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal
      vy cv vx cv wcel wi vy wal vx wex vw cv vy cv wceq vx cv vw cv wceq wn vx
      cv vy cv wceq wn wb vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn
      wa vw cv vy cv wceq vx cv vw cv wceq vx cv vy cv wceq vw vy vx equequ2
      notbid adantl vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx
      cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx wal vw cv vx cv wcel
      wi vw wal vx wex vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx
      wal vy cv vx cv wcel wi vy wal vx wex wb vw cv vy cv wceq vy cv vx cv
      wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx
      cv vz cv wcel vw wal wi vx wal vw cv vx cv wcel wi vw wal vx cv vy cv
      wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal
      vx vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vx vy vx vx
      hbnae vy vz vx hbnae hban vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy
      wal wn wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx wal vw cv
      vx cv wcel wi vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal
      vy cv vx cv wcel wi vw vy vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy
      wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv wceq vy wal wn
      vy cv vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw
      wal wi vx wal vw cv vx cv wcel vy vy cv vx cv wceq vy wal wn vy cv vz cv
      wceq vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv wceq vy
      wal wn vy cv vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv
      wcel vw wal wi vy vx vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal
      wn vx vy vx vx hbnae vy vz vx hbnae hban vy cv vx cv wceq vy wal wn vy cv
      vz cv wceq vy wal wn wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal
      vy vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy vy vx vy
      hbnae vy vz vy hbnae hban vy cv vx cv wceq vy wal wn vx cv vw cv wcel vz
      wex vx cv vw cv wcel vz wex vy wal wi vy cv vz cv wceq vy wal wn vy cv vx
      cv wceq vy wal wn vx cv vw cv wcel vy vz vy vx vz hbnae vy vx vw dveel1
      hbexd adantr vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx
      cv vz cv wcel vy vw vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn
      wa vw ax-17 vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vx cv
      vz cv wcel vx cv vz cv wcel vy wal wi vx vz vy ax-15 imp hbald hbimd
      hbald vy cv vx cv wceq vy wal wn vw cv vx cv wcel vw cv vx cv wcel vy wal
      wi vy cv vz cv wceq vy wal wn vy vx vw dveel2 adantr hbimd vy cv vx cv
      wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq vx cv vw cv
      wcel vz wex vx cv vz cv wcel vw wal wi vx wal vw cv vx cv wcel wi vx cv
      vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi
      wb vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv
      wceq wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi vx wal vx cv
      vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vw cv vx cv wcel vy
      cv vx cv wcel vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw
      cv vy cv wceq wa vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa
      vw cv vy cv wceq vx wal wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw
      wal wi vx wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal
      wb vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv
      wceq vw cv vy cv wceq vx wal vy cv vx cv wceq vy wal wn vw cv vy cv wceq
      vw cv vy cv wceq vx wal wi vy cv vz cv wceq vy wal wn vx vy vw nd5 adantr
      imdistani vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv
      vy cv wceq vx wal wa vx cv vw cv wcel vz wex vx cv vz cv wcel vw wal wi
      vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx vy cv vx cv wceq vy
      wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq vx wal vx vy cv vx
      cv wceq vy wal wn vy cv vz cv wceq vy wal wn vx vy vx vx hbnae vy vz vx
      hbnae hban vw cv vy cv wceq vx hba1 hban vy cv vx cv wceq vy wal wn vy cv
      vz cv wceq vy wal wn wa vw cv vy cv wceq vx wal wa vx cv vw cv wcel vz
      wex vx cv vy cv wcel vz wex vx cv vz cv wcel vw wal vx cv vz cv wcel vy
      wal vy cv vz cv wceq vy wal wn vw cv vy cv wceq vx wal vx cv vw cv wcel
      vz wex vx cv vy cv wcel vz wex wb vy cv vx cv wceq vy wal wn vy cv vz cv
      wceq vy wal wn vw cv vy cv wceq vx cv vw cv wcel vz wex vx cv vy cv wcel
      vz wex wb vw cv vy cv wceq vx wal vy cv vz cv wceq vy wal wn vw cv vy cv
      wceq wa vy cv vz cv wceq vy wal wn vw cv vy cv wceq vz wal wa vx cv vw cv
      wcel vz wex vx cv vy cv wcel vz wex wb vy cv vz cv wceq vy wal wn vw cv
      vy cv wceq vw cv vy cv wceq vz wal vz vy vw nd5 imdistani vw cv vy cv
      wceq vz wal vx cv vw cv wcel vz wex vx cv vy cv wcel vz wex wb vy cv vz
      cv wceq vy wal wn vw cv vy cv wceq vz wal vx cv vw cv wcel vx cv vy cv
      wcel vz vw cv vy cv wceq vz hba1 vw cv vy cv wceq vx cv vw cv wcel vx cv
      vy cv wcel wb vz vw vy vx elequ2 a4s exbid adantl syl vw cv vy cv wceq vx
      ax-4 sylan2 adantll vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn
      wa vx cv vz cv wcel vw wal vx cv vz cv wcel vy wal wb vw cv vy cv wceq vx
      wal vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vx cv vz cv
      wcel vx cv vz cv wcel vw vy vy cv vx cv wceq vy wal wn vy cv vz cv wceq
      vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv wceq vy wal
      wn vy cv vz cv wceq vy wal wn vx cv vz cv wcel vx cv vz cv wcel vy wal wi
      vx vz vy ax-15 imp vw cv vy cv wceq vx cv vz cv wcel vx cv vz cv wcel wb
      wi vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv
      wceq vx cv vz cv wcel biidd a1i cbvald adantr imbi12d albid syl vw cv vy
      cv wceq vw cv vx cv wcel vy cv vx cv wcel wb vy cv vx cv wceq vy wal wn
      vy cv vz cv wceq vy wal wn wa vw vy vx elequ1 adantl imbi12d ex cbvald
      exbid adantr imbi12d ex cbvald mpbii 19.21bi ex $.
      $( [4-Jan-2002] $)
  $}


  ${
    $d x w $.  $d y w $.
    $( A version of the Axiom of Power Sets with no distinct variable
       conditions. $)
    axpownd $p |- ( -. x = y ->
               E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) $=
      vy cv vx cv wceq vy wal vy cv vz cv wceq vy wal vx cv vy cv wceq wn vx cv
      vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi
      vy wal vx wex wi vx vy vz axpowndlem4 vx cv vy cv wceq wn vx cv vy cv
      wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal
      vx wex wi vx vy vx vy vz axpowndlem1 alequcoms vx cv vy cv wceq vx wal vy
      cv vz cv wceq vy wal vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz
      cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi wi vx cv vy
      cv wceq vx wal vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv
      wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vy cv vz cv
      wceq vy wal vx vy vz axpowndlem1 a1d vx cv vy cv wceq vx wal wn vy cv vz
      cv wceq vy wal vx cv vy cv wceq wn vx cv vy cv wcel vz wex vx cv vz cv
      wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex wi vx cv vy cv
      wceq vx wal wn vy cv vz cv wceq vy wal wa vx cv vy cv wcel vz wex vx cv
      vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal vx wex vx cv vy cv
      wceq wn vx cv vy cv wceq vx wal wn vy cv vz cv wceq vy wal wa vx cv vy cv
      wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv wcel wi vy wal
      vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv
      wcel wi vy wal vx wex vx cv vy cv wceq vx wal wn vy cv vz cv wceq vy wal
      wa vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx cv
      wcel wi vy vx cv vy cv wceq vx wal wn vy cv vz cv wceq vy wal vy vx vy vy
      hbnae vy vz vy hbae hban vx cv vy cv wceq vx wal wn vy cv vz cv wceq vy
      wal wa vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vx wal vy cv vx
      cv wcel vx cv vy cv wceq vx wal wn vy cv vz cv wceq vy wal wa vx cv vy cv
      wcel vy wex wn vx wal vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi
      vx wal vx cv vy cv wceq vx wal wn vx cv vy cv wcel vy wex wn vx wal wn vy
      cv vz cv wceq vy wal vx cv vy cv wceq vx wal wn vx cv vy cv wcel vy wex
      vx wex vx cv vy cv wcel vy wex wn vx wal wn vx cv vy cv wceq vx wal wn vx
      cv vy cv wcel vy wex vx cv vy cv wcel vy wex vx wex vx cv vy cv wceq vx
      wal wn vx cv vw cv wcel vw wex vx cv vy cv wcel vy wex vx vw el vx cv vy
      cv wceq vx wal wn vx cv vw cv wcel vx cv vy cv wcel vw vy vx vy vy hbnae
      vx cv vw cv wcel vx cv vw cv wcel vy wal wi vy vx vy vx vw dveel1
      nalequcoms vw cv vy cv wceq vx cv vw cv wcel vx cv vy cv wcel wb wi vx cv
      vy cv wceq vx wal wn vw vy vx elequ2 a1i cbvexd mpbii vx cv vy cv wcel vy
      wex vx 19.8a syl vx cv vy cv wcel vy wex vx df-ex sylib adantr vy cv vz
      cv wceq vy wal vx cv vy cv wcel vy wex wn vx wal vx cv vy cv wcel vz wex
      vx cv vz cv wcel vy wal wi vx wal wb vx cv vy cv wceq vx wal wn vx cv vy
      cv wcel vy wex wn vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vy
      vz vx vy cv vz cv wceq vy wal vx cv vy cv wcel vy wex wn vx cv vy cv wcel
      vz wex wn vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi vy cv vz cv
      wceq vy wal vx cv vy cv wcel wn vy wal vx cv vy cv wcel wn vz wal vx cv
      vy cv wcel vy wex wn vx cv vy cv wcel vz wex wn vx cv vy cv wcel wn vx cv
      vy cv wcel wn vy vz vy cv vz cv wceq vy wal vx cv vy cv wcel wn biidd
      dral1 vx cv vy cv wcel vy alnex vx cv vy cv wcel vz alnex 3bitr3g vy cv
      vz cv wceq vy wal vx cv vz cv wcel vy wal wn vx cv vy cv wcel vz wex wn
      vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi wb vy vz vx nd2 vx cv
      vz cv wcel vy wal vx cv vy cv wcel vz wex mtt syl bitrd dral2 adantl
      mtbid pm2.21d 19.21ai vx cv vy cv wcel vz wex vx cv vz cv wcel vy wal wi
      vx wal vy cv vx cv wcel wi vy wal vx 19.8a syl a1d ex pm2.61i pm2.61ii $.
      $( [4-Jan-2002] $)
  $}

$(
  @{
    @d x z @.  @d y z @.
    axpowndNEWlem1 @p  |- ( A. x x = y ->
        ( ( A. x x = y -> E. z A. x ( E. z z e. y -> x e. z ) )
         -> E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) @=
      ( weq wal wel wex wi cv csn c0 wceq wn wcel wa en2lp visset snid biantru
      mtbir snnzOLD a1bi mtbi neq0 imbi1i albii bicomi snex eqeq1 notbid eleq1
     imbi12d cla4v sylbi mto hbae wb elequ2 a4s exbidv imbi1d albid mtbii nexdv
     pm2.21d a2i com12 ) ABDZAEZCBFZCGZACFZHZAEZCGZHVIABFCGVLBEHAEBAFHBEAGZVIVO
      VPVIVOVPVIVNCVICAFZCGZVLHZAEZVNVTCIZJZKLZMZWBWANZHZWEWFWEWEWAWBNZOWBWAPWG
      WEWACQZRSTWDWEWAWHUAUBUCVTAIZKLZMZVLHZAEZWFWMVTWLVSAWKVRVLCWIUDUEUFUGWLWF
      AWBWAUHWIWBLZWKWDVLWEWNWJWCWIWBKUIUJWIWBWAUKULUMUNUOVIVSVMAABAUPVIVRVKVLV
      IVQVJCVHVQVJUQAABCURUSUTVAVBVCVDVEVFVG @.
  @}

  @{
    @d x w @.  @d y w @.
   axpowndNEW @p  |- ( ( A. x x = y -> E. z A. x ( E. z z e. y -> x e. z ) ) ->
               E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) @=
?@.
  @}
$)

  $( Lemma for the Axiom of Regularity with no distinct variable
     conditions. $)
  axregndlem1 $p |- ( A. x x = z -> ( x e. y ->
               E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) ) $=
    vx cv vz cv wceq vx wal vx cv vy cv wcel vx wex vx cv vy cv wcel vz cv vx
    cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex vx cv vy cv wcel vx cv vz
    cv wceq vx wal vx cv vy cv wcel vx cv vy cv wcel vz cv vx cv wcel vz cv vy
    cv wcel wn wi vz wal wa vx vx vz vx hbae vx cv vy cv wcel vx cv vz cv wceq
    vx wal vx cv vy cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa
    vx cv vz cv wceq vx wal vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal vx
    cv vy cv wcel vx cv vz cv wceq vx wal vz cv vx cv wcel vz cv vy cv wcel wn
    wi vz vx vz vz hbae vx cv vz cv wceq vx wal vz cv vx cv wcel vz cv vy cv
    wcel wn vx cv vz cv wceq vz cv vx cv wcel wn vx vx cv vz cv wceq vx cv vx
    cv wcel vz cv vx cv wcel vx elirrv vx vz vx elequ1 mtbii a4s pm2.21d
    19.21ai anim2i expcom 19.22d vx cv vy cv wcel vx 19.8a syl5 $.
    $( [3-Jan-2002] $)

  ${
    $d x w $.  $d z y w $.
    $( Lemma for the Axiom of Regularity with no distinct variable
       conditions. $)
    axregndlem2 $p |- ( x e. y ->
                 E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) $=
      vx cv vy cv wceq vx wal vx cv vz cv wceq vx wal vx cv vy cv wcel vx cv vy
      cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wi vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx cv vy cv wcel vx cv vy
      cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wi vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vx cv vy cv wcel vx cv
      vy cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wi vx
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel
      vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal wa vw wex
      wi vw wal vx cv vy cv wcel vx cv vy cv wcel vz cv vx cv wcel vz cv vy cv
      wcel wn wi vz wal wa vx wex wi vx wal vw cv vy cv wcel vw cv vy cv wcel
      vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal wa vw wex wi vw vw vy vz
      axreg ax-gen vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw
      cv vy cv wcel vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz
      wal wa vw wex wi vx cv vy cv wcel vx cv vy cv wcel vz cv vx cv wcel vz cv
      vy cv wcel wn wi vz wal wa vx wex wi vw vx vx cv vy cv wceq vx wal wn vx
      cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vw cv vy cv
      wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal wa vw wex vx vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx
      hbnae hban vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv wcel
      vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vy cv wcel vz cv vw cv
      wcel vz cv vy cv wcel wn wi vz wal wa vx vw vx cv vy cv wceq vx wal wn vx
      cv vz cv wceq vx wal wn wa vw ax-17 vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel
      wn wi vz wal vx vx cv vy cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel2 adantr vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vz cv vw cv wcel vz cv vy
      cv wcel wn wi vx vz vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      vz vx vy vz hbnae vx vz vz hbnae hban vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vz cv vw cv wcel vz cv vy cv wcel wn vx vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx
      hbnae hban vx cv vz cv wceq vx wal wn vz cv vw cv wcel vz cv vw cv wcel
      vx wal wi vx cv vy cv wceq vx wal wn vx vz vw dveel1 adantl vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vz cv vy cv wcel vx vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz vx
      hbnae hban vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vz cv vy
      cv wcel vz cv vy cv wcel vx wal wi vz vy vx ax-15 impcom hbnd hbimd hbald
      hband hbexd hbimd vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn
      wa vw cv vx cv wceq vw cv vy cv wcel vw cv vy cv wcel vz cv vw cv wcel vz
      cv vy cv wcel wn wi vz wal wa vw wex wi vx cv vy cv wcel vx cv vy cv wcel
      vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wi wb vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq wa vw cv
      vy cv wcel vx cv vy cv wcel vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv
      wcel wn wi vz wal wa vw wex vx cv vy cv wcel vz cv vx cv wcel vz cv vy cv
      wcel wn wi vz wal wa vx wex vw cv vx cv wceq vw cv vy cv wcel vx cv vy cv
      wcel wb vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw vx vy
      elequ1 adantl vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw
      cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal wa vw wex vx
      cv vy cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wb
      vw cv vx cv wceq vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa
      vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal wa vx cv
      vy cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vw vx vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx vz
      vx hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw
      cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal vx vx cv vy
      cv wceq vx wal wn vw cv vy cv wcel vw cv vy cv wcel vx wal wi vx cv vz cv
      wceq vx wal wn vx vy vw dveel2 adantr vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vz cv vw cv wcel vz cv vy cv wcel wn wi vx vz vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx vz
      vz hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vz
      cv vw cv wcel vz cv vy cv wcel wn vx vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vz cv wceq
      vx wal wn vz cv vw cv wcel vz cv vw cv wcel vx wal wi vx cv vy cv wceq vx
      wal wn vx vz vw dveel1 adantl vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa vz cv vy cv wcel vx vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vz cv wceq vx
      wal wn vx cv vy cv wceq vx wal wn vz cv vy cv wcel vz cv vy cv wcel vx
      wal wi vz vy vx ax-15 impcom hbnd hbimd hbald hband vx cv vz cv wceq vx
      wal wn vw cv vx cv wceq vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv
      wcel wn wi vz wal wa vx cv vy cv wcel vz cv vx cv wcel vz cv vy cv wcel
      wn wi vz wal wa wb wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn vw cv vx cv wceq vw cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn
      wi vz wal wa vx cv vy cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz
      wal wa wb vx cv vz cv wceq vx wal wn vw cv vx cv wceq wa vw cv vy cv wcel
      vx cv vy cv wcel vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal vz cv vx
      cv wcel vz cv vy cv wcel wn wi vz wal vw cv vx cv wceq vw cv vy cv wcel
      vx cv vy cv wcel wb vx cv vz cv wceq vx wal wn vw vx vy elequ1 adantl vx
      cv vz cv wceq vx wal wn vw cv vx cv wceq wa vx cv vz cv wceq vx wal wn vw
      cv vx cv wceq vz wal wa vz cv vw cv wcel vz cv vy cv wcel wn wi vz wal vz
      cv vx cv wcel vz cv vy cv wcel wn wi vz wal wb vx cv vz cv wceq vx wal wn
      vw cv vx cv wceq vw cv vx cv wceq vz wal vz vx vw nd5 imdistani vx cv vz
      cv wceq vx wal wn vw cv vx cv wceq vz wal wa vz cv vw cv wcel vz cv vy cv
      wcel wn wi vz cv vx cv wcel vz cv vy cv wcel wn wi vz vx cv vz cv wceq vx
      wal wn vw cv vx cv wceq vz wal vz vx vz vz hbnae vw cv vx cv wceq vz hba1
      hban vw cv vx cv wceq vz wal vz cv vw cv wcel vz cv vy cv wcel wn wi vz
      cv vx cv wcel vz cv vy cv wcel wn wi wb vx cv vz cv wceq vx wal wn vw cv
      vx cv wceq vz cv vw cv wcel vz cv vy cv wcel wn wi vz cv vx cv wcel vz cv
      vy cv wcel wn wi wb vz vw cv vx cv wceq vz cv vw cv wcel vz cv vx cv wcel
      vz cv vy cv wcel wn vw vx vz elequ2 imbi1d a4s adantl albid syl anbi12d
      ex adantl cbvexd adantr imbi12d ex cbvald mpbii 19.21bi ex vx cv vy cv
      wceq vx wal vx cv vy cv wcel vx cv vy cv wcel vz cv vx cv wcel vz cv vy
      cv wcel wn wi vz wal wa vx wex vx cv vy cv wceq vx cv vy cv wcel wn vx vx
      cv vy cv wceq vx cv vx cv wcel vx cv vy cv wcel vx elirrv vx vy vx elequ2
      mtbii a4s pm2.21d vx vy vz axregndlem1 pm2.61ii $.
      $( [3-Jan-2002] $)
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A version of the Axiom of Regularity with no distinct variable
       conditions. $)
    axregnd $p |- ( x e. y ->
                 E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) $=
      vz cv vx cv wceq vz wal vz cv vy cv wceq vz wal vx cv vy cv wcel vx cv vy
      cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wi vz cv
      vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vx cv vy cv wcel vx cv vy
      cv wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex wi vz cv
      vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn wa vx cv vy cv wcel vw cv
      vx cv wcel vw cv vy cv wcel wn wi vw wal wa vx wex vx cv vy cv wcel vz cv
      vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex vx cv vy cv wcel vz cv
      vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn wa vx cv vy cv wcel vw cv
      vx cv wcel vw cv vy cv wcel wn wi vw wal wa vx cv vy cv wcel vz cv vx cv
      wcel vz cv vy cv wcel wn wi vz wal wa vx vz cv vx cv wceq vz wal wn vz cv
      vy cv wceq vz wal wn vx vz vx vx hbnae vz vy vx hbnae hban vz cv vx cv
      wceq vz wal wn vz cv vy cv wceq vz wal wn wa vw cv vx cv wcel vw cv vy cv
      wcel wn wi vw wal vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal vx cv vy
      cv wcel vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn wa vw cv vx
      cv wcel vw cv vy cv wcel wn wi vz cv vx cv wcel vz cv vy cv wcel wn wi vw
      vz vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz vz vx vz
      hbnae vz vy vz hbnae hban vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz
      wal wn wa vw cv vx cv wcel vw cv vy cv wcel wn vz vz cv vx cv wceq vz wal
      wn vz cv vy cv wceq vz wal wn vz vz vx vz hbnae vz vy vz hbnae hban vz cv
      vx cv wceq vz wal wn vw cv vx cv wcel vw cv vx cv wcel vz wal wi vz cv vy
      cv wceq vz wal wn vz vx vw dveel2 adantr vz cv vx cv wceq vz wal wn vz cv
      vy cv wceq vz wal wn wa vw cv vy cv wcel vz vz cv vx cv wceq vz wal wn vz
      cv vy cv wceq vz wal wn vz vz vx vz hbnae vz vy vz hbnae hban vz cv vy cv
      wceq vz wal wn vw cv vy cv wcel vw cv vy cv wcel vz wal wi vz cv vx cv
      wceq vz wal wn vz vy vw dveel2 adantl hbnd hbimd vw cv vz cv wceq vw cv
      vx cv wcel vw cv vy cv wcel wn wi vz cv vx cv wcel vz cv vy cv wcel wn wi
      wb wi vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn wa vw cv vz
      cv wceq vw cv vx cv wcel vz cv vx cv wcel vw cv vy cv wcel wn vz cv vy cv
      wcel wn vw vz vx elequ1 vw cv vz cv wceq vw cv vy cv wcel vz cv vy cv
      wcel vw vz vy elequ1 notbid imbi12d a1i cbvald anbi2d exbid vx vy vw
      axregndlem2 syl5bi ex vx cv vy cv wcel vx cv vy cv wcel vz cv vx cv wcel
      vz cv vy cv wcel wn wi vz wal wa vx wex wi vx vz vx vy vz axregndlem1
      alequcoms vz cv vy cv wceq vz wal vx cv vy cv wcel vx wex vx cv vy cv
      wcel vz cv vx cv wcel vz cv vy cv wcel wn wi vz wal wa vx wex vx cv vy cv
      wcel vz cv vy cv wceq vz wal vx cv vy cv wcel vx cv vy cv wcel vz cv vx
      cv wcel vz cv vy cv wcel wn wi vz wal wa vx vz vy vx hbae vx cv vy cv
      wcel vz cv vy cv wceq vz wal vx cv vy cv wcel vz cv vx cv wcel vz cv vy
      cv wcel wn wi vz wal wa vz cv vy cv wceq vz wal vz cv vx cv wcel vz cv vy
      cv wcel wn wi vz wal vx cv vy cv wcel vz cv vy cv wceq vz cv vx cv wcel
      vz cv vy cv wcel wn wi vz vz cv vy cv wceq vz wal vz cv vy cv wcel wn vz
      cv vx cv wcel vz cv vy cv wceq vz cv vy cv wcel wn vz vz cv vy cv wceq vz
      cv vz cv wcel vz cv vy cv wcel vz elirrv vz vy vz elequ2 mtbii a4s a1d
      a5i anim2i expcom 19.22d vx cv vy cv wcel vx 19.8a syl5 pm2.61ii $.
      $( [3-Jan-2002] $)
  $}

  ${
    $d x w $.  $d z y w $.
    $( Lemma for the Axiom of Infinity with no distinct variable
       conditions. $)
    axinfndlem1 $p |- ( A. x y e. z -> E. x ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) ) $=
      vx cv vy cv wceq vx wal vx cv vz cv wceq vx wal vy cv vz cv wcel vx wal
      vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vy wal wa vx wex wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn vy cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv vz
      cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex wi vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vz cv wcel vw wal vy
      cv vw cv wcel vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz
      wex wi vy wal wa vw wex wi vy cv vz cv wcel vx wal vy cv vx cv wcel vy cv
      vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx
      wex wi vy cv vw cv wcel vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv
      wcel wa vz wex wi vy wal wa vw wex vy cv vz cv wcel vw wal vw vy vz zfinf
      a1i vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vz cv
      wcel vw wal vy cv vz cv wcel vx wal vy cv vw cv wcel vy cv vw cv wcel vy
      cv vz cv wcel vz cv vw cv wcel wa vz wex wi vy wal wa vw wex vy cv vx cv
      wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy
      wal wa vx wex vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy
      cv vz cv wcel vy cv vz cv wcel vw vx vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn vy cv vz cv wcel vy cv vz cv wcel vx
      wal wi vy vz vx ax-15 imp vw cv vx cv wceq vy cv vz cv wcel vy cv vz cv
      wcel wb wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv
      vx cv wceq vy cv vz cv wcel biidd a1i cbvald vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vy cv vw cv wcel vy cv vz
      cv wcel vz cv vw cv wcel wa vz wex wi vy wal wa vy cv vx cv wcel vy cv vx
      cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vw vx vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vx vx vy vx hbnae vx
      vz vx hbnae hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa
      vy cv vw cv wcel vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz
      wex wi vy wal vx vx cv vy cv wceq vx wal wn vy cv vw cv wcel vy cv vw cv
      wcel vx wal wi vx cv vz cv wceq vx wal wn vx vy vw dveel1 adantr vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vy cv vz
      cv wcel vz cv vw cv wcel wa vz wex wi vx vy vx cv vy cv wceq vx wal wn vx
      cv vz cv wceq vx wal wn vy vx vy vy hbnae vx vz vy hbnae hban vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vw cv wcel vy cv vz cv
      wcel vz cv vw cv wcel wa vz wex vx vx cv vy cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn vx vx vy vx hbnae vx vz vx hbnae hban vx cv vy cv wceq vx
      wal wn vy cv vw cv wcel vy cv vw cv wcel vx wal wi vx cv vz cv wceq vx
      wal wn vx vy vw dveel1 adantr vx cv vy cv wceq vx wal wn vx cv vz cv wceq
      vx wal wn wa vy cv vz cv wcel vz cv vw cv wcel wa vx vz vx cv vy cv wceq
      vx wal wn vx cv vz cv wceq vx wal wn vz vx vy vz hbnae vx vz vz hbnae
      hban vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vy cv vz cv
      wcel vz cv vw cv wcel vx vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx
      wal wn vy cv vz cv wcel vy cv vz cv wcel vx wal wi vy vz vx ax-15 imp vx
      cv vz cv wceq vx wal wn vz cv vw cv wcel vz cv vw cv wcel vx wal wi vx cv
      vy cv wceq vx wal wn vx vz vw dveel1 adantl hband hbexd hbimd hbald hband
      vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq
      vy cv vw cv wcel vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz
      wex wi vy wal wa vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv
      vx cv wcel wa vz wex wi vy wal wa wb vx cv vy cv wceq vx wal wn vx cv vz
      cv wceq vx wal wn wa vw cv vx cv wceq wa vy cv vw cv wcel vy cv vx cv
      wcel vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz wex wi vy
      wal vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy
      wal vw cv vx cv wceq vy cv vw cv wcel vy cv vx cv wcel wb vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw vx vy elequ2 adantl vx cv
      vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq wa vx
      cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx cv wceq vy
      wal wa vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz wex wi vy
      wal vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy
      wal wb vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn wa vw cv vx
      cv wceq vw cv vx cv wceq vy wal vx cv vy cv wceq vx wal wn vw cv vx cv
      wceq vw cv vx cv wceq vy wal wi vx cv vz cv wceq vx wal wn vy vx vw nd5
      adantr imdistani vx cv vz cv wceq vx wal wn vw cv vx cv wceq vy wal vy cv
      vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz wex wi vy wal vy cv vx
      cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wb vx cv vy
      cv wceq vx wal wn vx cv vz cv wceq vx wal wn vw cv vx cv wceq vy wal wa
      vy cv vw cv wcel vy cv vz cv wcel vz cv vw cv wcel wa vz wex wi vy cv vx
      cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy vx cv vz cv
      wceq vx wal wn vw cv vx cv wceq vy wal vy vx vz vy hbnae vw cv vx cv wceq
      vy hba1 hban vx cv vz cv wceq vx wal wn vw cv vx cv wceq vy cv vw cv wcel
      vy cv vz cv wcel vz cv vw cv wcel wa vz wex wi vy cv vx cv wcel vy cv vz
      cv wcel vz cv vx cv wcel wa vz wex wi wb vw cv vx cv wceq vy wal vx cv vz
      cv wceq vx wal wn vw cv vx cv wceq wa vy cv vw cv wcel vy cv vx cv wcel
      vy cv vz cv wcel vz cv vw cv wcel wa vz wex vy cv vz cv wcel vz cv vx cv
      wcel wa vz wex vw cv vx cv wceq vy cv vw cv wcel vy cv vx cv wcel wb vx
      cv vz cv wceq vx wal wn vw vx vy elequ2 adantl vx cv vz cv wceq vx wal wn
      vw cv vx cv wceq wa vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz wal wa
      vy cv vz cv wcel vz cv vw cv wcel wa vz wex vy cv vz cv wcel vz cv vx cv
      wcel wa vz wex wb vx cv vz cv wceq vx wal wn vw cv vx cv wceq vw cv vx cv
      wceq vz wal vz vx vw nd5 imdistani vw cv vx cv wceq vz wal vy cv vz cv
      wcel vz cv vw cv wcel wa vz wex vy cv vz cv wcel vz cv vx cv wcel wa vz
      wex wb vx cv vz cv wceq vx wal wn vw cv vx cv wceq vz wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vz cv wcel vz cv vx cv wcel wa vz vw cv vx
      cv wceq vz hba1 vw cv vx cv wceq vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vz cv wcel vz cv vx cv wcel wa wb vz vw cv vx cv wceq vz cv vw cv wcel
      vz cv vx cv wcel vy cv vz cv wcel vw vx vz elequ2 anbi2d a4s exbid adantl
      syl imbi12d vw cv vx cv wceq vy ax-4 sylan2 albid adantll syl anbi12d ex
      cbvexd imbi12d mpbii ex vx cv vy cv wceq vx wal vy cv vz cv wcel vx wal
      vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vy wal wa vx wex vx vy vz nd1 pm2.21d vx cv vz cv wceq vx wal vy
      cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel
      vz cv vx cv wcel wa vz wex wi vy wal wa vx wex vx vz vy nd2 pm2.21d
      pm2.61ii $.
      $( [5-Jan-2002] $)
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A version of the Axiom of Infinity with no distinct variable
       conditions. $)
    axinfnd $p |- E. x ( y e. z -> ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) ) $=
      vy cv vz cv wcel vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv
      vx cv wcel wa vz wex wi vy wal wa vx vy cv vx cv wceq vy wal vy cv vz cv
      wceq vy wal vy cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy
      cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex wi vy cv vx
      cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy cv vz cv wcel vx wal vy
      cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vy wal wa vx wex wi vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy
      wal wn wa vy cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv
      vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex wi vy vy cv vx
      cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vz cv wcel vx wal
      vw cv vx cv wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz
      wex wi vw wal wa vx wex wi vw wal vy cv vz cv wcel vx wal vy cv vx cv
      wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy
      wal wa vx wex wi vy wal vw cv vz cv wcel vx wal vw cv vx cv wcel vw cv vx
      cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vw wal wa vx wex
      wi vw vx vw vz axinfndlem1 ax-gen vy cv vx cv wceq vy wal wn vy cv vz cv
      wceq vy wal wn wa vw cv vz cv wcel vx wal vw cv vx cv wcel vw cv vx cv
      wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vw wal wa vx wex wi
      vy cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv
      wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex wi vw vy vy cv vx cv
      wceq vy wal wn vy cv vz cv wceq vy wal wn vy vy vx vy hbnae vy vz vy
      hbnae hban vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv
      vz cv wcel vx wal vw cv vx cv wcel vw cv vx cv wcel vw cv vz cv wcel vz
      cv vx cv wcel wa vz wex wi vw wal wa vx wex vy vy cv vx cv wceq vy wal wn
      vy cv vz cv wceq vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vz
      cv wceq vy wal wn vw cv vz cv wcel vx wal vw cv vz cv wcel vx wal vy wal
      wi vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vw cv vz cv wcel
      vy vx vy vz vx hbnae vy vz vw dveel2 hbald adantl vy cv vx cv wceq vy wal
      wn vy cv vz cv wceq vy wal wn wa vw cv vx cv wcel vw cv vx cv wcel vw cv
      vz cv wcel vz cv vx cv wcel wa vz wex wi vw wal wa vy vx vy cv vx cv wceq
      vy wal wn vy cv vz cv wceq vy wal wn vx vy vx vx hbnae vy vz vx hbnae
      hban vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vx cv
      wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vw
      wal vy vy cv vx cv wceq vy wal wn vw cv vx cv wcel vw cv vx cv wcel vy
      wal wi vy cv vz cv wceq vy wal wn vy vx vw dveel2 adantr vy cv vx cv wceq
      vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vx cv wcel vw cv vz cv wcel
      vz cv vx cv wcel wa vz wex wi vy vw vy cv vx cv wceq vy wal wn vy cv vz
      cv wceq vy wal wn wa vw ax-17 vy cv vx cv wceq vy wal wn vy cv vz cv wceq
      vy wal wn wa vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex
      vy vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy vy vx vy
      hbnae vy vz vy hbnae hban vy cv vx cv wceq vy wal wn vw cv vx cv wcel vw
      cv vx cv wcel vy wal wi vy cv vz cv wceq vy wal wn vy vx vw dveel2 adantr
      vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vz cv wcel
      vz cv vx cv wcel wa vy vz vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy
      wal wn vz vy vx vz hbnae vy vz vz hbnae hban vy cv vx cv wceq vy wal wn
      vy cv vz cv wceq vy wal wn wa vw cv vz cv wcel vz cv vx cv wcel vy vy cv
      vz cv wceq vy wal wn vw cv vz cv wcel vw cv vz cv wcel vy wal wi vy cv vx
      cv wceq vy wal wn vy vz vw dveel2 adantl vy cv vz cv wceq vy wal wn vy cv
      vx cv wceq vy wal wn vz cv vx cv wcel vz cv vx cv wcel vy wal wi vz vx vy
      ax-15 impcom hband hbexd hbimd hbald hband hbexd hbimd vy cv vx cv wceq
      vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq vw cv vz cv wcel
      vx wal vw cv vx cv wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv
      wcel wa vz wex wi vw wal wa vx wex wi vy cv vz cv wcel vx wal vy cv vx cv
      wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy
      wal wa vx wex wi wb vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn
      wa vw cv vy cv wceq wa vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal
      wn wa vw cv vy cv wceq vx wal wa vw cv vz cv wcel vx wal vw cv vx cv wcel
      vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vw wal wa
      vx wex wi vy cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv
      vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal wa vx wex wi wb vy cv vx
      cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq vw cv vy
      cv wceq vx wal vy cv vx cv wceq vy wal wn vw cv vy cv wceq vw cv vy cv
      wceq vx wal wi vy cv vz cv wceq vy wal wn vx vy vw nd5 adantr imdistani
      vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq
      vx wal wa vw cv vz cv wcel vx wal vy cv vz cv wcel vx wal vw cv vx cv
      wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vw
      wal wa vx wex vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx
      cv wcel wa vz wex wi vy wal wa vx wex vw cv vy cv wceq vx wal vw cv vz cv
      wcel vx wal vy cv vz cv wcel vx wal wb vy cv vx cv wceq vy wal wn vy cv
      vz cv wceq vy wal wn wa vw cv vy cv wceq vx wal vw cv vz cv wcel vy cv vz
      cv wcel vx vw cv vy cv wceq vx hba1 vw cv vy cv wceq vw cv vz cv wcel vy
      cv vz cv wcel wb vx vw vy vz elequ1 a4s albid adantl vy cv vx cv wceq vy
      wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq vx wal wa vw cv vx
      cv wcel vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi
      vw wal wa vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv
      wcel wa vz wex wi vy wal wa vx vy cv vx cv wceq vy wal wn vy cv vz cv
      wceq vy wal wn wa vw cv vy cv wceq vx wal vx vy cv vx cv wceq vy wal wn
      vy cv vz cv wceq vy wal wn vx vy vx vx hbnae vy vz vx hbnae hban vw cv vy
      cv wceq vx hba1 hban vw cv vy cv wceq vx wal vw cv vx cv wcel vy cv vx cv
      wcel vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vx cv
      wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vw wal vy cv vx cv
      wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy wal vw cv vy cv
      wceq vw cv vx cv wcel vy cv vx cv wcel wb vx vw vy vx elequ1 a4s vy cv vx
      cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vx cv wcel vw cv vz
      cv wcel vz cv vx cv wcel wa vz wex wi vy cv vx cv wcel vy cv vz cv wcel
      vz cv vx cv wcel wa vz wex wi vw vy vy cv vx cv wceq vy wal wn vy cv vz
      cv wceq vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv wceq
      vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vx cv wcel vw cv vz cv wcel
      vz cv vx cv wcel wa vz wex vy vy cv vx cv wceq vy wal wn vy cv vz cv wceq
      vy wal wn vy vy vx vy hbnae vy vz vy hbnae hban vy cv vx cv wceq vy wal
      wn vw cv vx cv wcel vw cv vx cv wcel vy wal wi vy cv vz cv wceq vy wal wn
      vy vx vw dveel2 adantr vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal
      wn wa vw cv vz cv wcel vz cv vx cv wcel wa vy vz vy cv vx cv wceq vy wal
      wn vy cv vz cv wceq vy wal wn vz vy vx vz hbnae vy vz vz hbnae hban vy cv
      vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vz cv wcel vz cv
      vx cv wcel vy vy cv vz cv wceq vy wal wn vw cv vz cv wcel vw cv vz cv
      wcel vy wal wi vy cv vx cv wceq vy wal wn vy vz vw dveel2 adantl vy cv vz
      cv wceq vy wal wn vy cv vx cv wceq vy wal wn vz cv vx cv wcel vz cv vx cv
      wcel vy wal wi vz vx vy ax-15 impcom hband hbexd hbimd vy cv vx cv wceq
      vy wal wn vy cv vz cv wceq vy wal wn wa vw cv vy cv wceq vw cv vx cv wcel
      vw cv vz cv wcel vz cv vx cv wcel wa vz wex wi vy cv vx cv wcel vy cv vz
      cv wcel vz cv vx cv wcel wa vz wex wi wb vy cv vz cv wceq vy wal wn vw cv
      vy cv wceq vw cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz wex
      wi vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wcel wa vz wex wi wb vy
      cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vw cv vy cv wceq wa vw
      cv vx cv wcel vy cv vx cv wcel vw cv vz cv wcel vz cv vx cv wcel wa vz
      wex vy cv vz cv wcel vz cv vx cv wcel wa vz wex vw cv vy cv wceq vw cv vx
      cv wcel vy cv vx cv wcel wb vy cv vz cv wceq vy wal wn vw vy vx elequ1
      adantl vy cv vz cv wceq vy wal wn vw cv vy cv wceq wa vy cv vz cv wceq vy
      wal wn vw cv vy cv wceq vz wal wa vw cv vz cv wcel vz cv vx cv wcel wa vz
      wex vy cv vz cv wcel vz cv vx cv wcel wa vz wex wb vy cv vz cv wceq vy
      wal wn vw cv vy cv wceq vw cv vy cv wceq vz wal vz vy vw nd5 imdistani vw
      cv vy cv wceq vz wal vw cv vz cv wcel vz cv vx cv wcel wa vz wex vy cv vz
      cv wcel vz cv vx cv wcel wa vz wex wb vy cv vz cv wceq vy wal wn vw cv vy
      cv wceq vz wal vw cv vz cv wcel vz cv vx cv wcel wa vy cv vz cv wcel vz
      cv vx cv wcel wa vz vw cv vy cv wceq vz hba1 vw cv vy cv wceq vw cv vz cv
      wcel vz cv vx cv wcel wa vy cv vz cv wcel vz cv vx cv wcel wa wb vz vw cv
      vy cv wceq vw cv vz cv wcel vy cv vz cv wcel vz cv vx cv wcel vw vy vz
      elequ1 anbi1d a4s exbid adantl syl imbi12d adantll ex cbvald bi2anan9r
      exbid imbi12d syl ex cbvald mpbii 19.21bi ex vy cv vx cv wceq vy wal vy
      cv vz cv wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel
      vz cv vx cv wcel wa vz wex wi vy wal wa vx wex vy cv vz cv wcel vx wal wn
      vx vy vx vy vz nd1 alequcoms pm2.21d vy cv vz cv wceq vy wal vy cv vz cv
      wcel vx wal vy cv vx cv wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx
      cv wcel wa vz wex wi vy wal wa vx wex vy vz vx nd3 pm2.21d pm2.61ii
      19.35ri $.
      $( [5-Jan-2002] $)
  $}

  $( Lemma for the Axiom of Choice with no distinct variable conditions. $)
  axacndlem1 $p |- ( A. x x = y ->
            E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y ( E. w
          ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) ) $=
    vx cv vy cv wceq vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv
    vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
    wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vy cv vz cv wcel vz
    cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
    wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz
    wal vy wal vx wex vx cv vy cv wceq vx wal vy cv vz cv wcel vz cv vw cv wcel
    wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
    wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy vx vy vy
    hbae vx cv vy cv wceq vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy
    cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa
    vw wex vy cv vw cv wceq wb vy wal vw wex wi vz vx vy vz hbae vx cv vy cv
    wceq vx wal vy cv vz cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy
    cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
    wex vy cv vz cv wcel vz cv vw cv wcel wa vx wal vx cv vy cv wceq vx wal vy
    cv vz cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
    vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vx vy vz
    nd1 pm2.21d vy cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vx vy cv
    vz cv wcel vz cv vw cv wcel pm3.26 19.20i syl5 19.21ai 19.21ai vy cv vz cv
    wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv
    vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex
    wi vz wal vy wal vx 19.8a syl $.
    $( [3-Jan-2002] $)

  $( Lemma for the Axiom of Choice with no distinct variable conditions. $)
  axacndlem2 $p |- ( A. x x = z ->
            E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y ( E. w
          ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) ) $=
    vx cv vz cv wceq vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv
    vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
    wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vy cv vz cv wcel vz
    cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
    wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz
    wal vy wal vx wex vx cv vz cv wceq vx wal vy cv vz cv wcel vz cv vw cv wcel
    wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
    wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy vx vz vy
    hbae vx cv vz cv wceq vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy
    cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa
    vw wex vy cv vw cv wceq wb vy wal vw wex wi vz vx vz vz hbae vx cv vz cv
    wceq vx wal vz cv vw cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy
    cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
    wex vy cv vz cv wcel vz cv vw cv wcel wa vx wal vx cv vz cv wceq vx wal vz
    cv vw cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
    vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vx vz vw
    nd1 pm2.21d vy cv vz cv wcel vz cv vw cv wcel wa vz cv vw cv wcel vx vy cv
    vz cv wcel vz cv vw cv wcel pm3.27 19.20i syl5 19.21ai 19.21ai vy cv vz cv
    wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv
    vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex
    wi vz wal vy wal vx 19.8a syl $.
    $( [3-Jan-2002] $)

  $( Lemma for the Axiom of Choice with no distinct variable conditions. $)
  axacndlem3 $p |- ( A. y y = z ->
            E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y ( E. w
          ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) ) $=
    vy cv vz cv wceq vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv
    vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
    wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vy cv vz cv wcel vz
    cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
    wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz
    wal vy wal vx wex vy cv vz cv wceq vy cv vz cv wcel vz cv vw cv wcel wa vx
    wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel
    wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy vy cv vz cv
    wceq vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz
    cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
    wceq wb vy wal vw wex wi vz vy vz vz hbae vy cv vz cv wceq vy wal vy cv vz
    cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv
    vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv wcel
    vz cv vw cv wcel wa vx wal vy cv vz cv wceq vy wal vy cv vz cv wcel vx wal
    vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
    wa vw wex vy cv vw cv wceq wb vy wal vw wex vy vz vx nd3 pm2.21d vy cv vz
    cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vx vy cv vz cv wcel vz cv vw
    cv wcel pm3.26 19.20i syl5 19.21ai a5i vy cv vz cv wcel vz cv vw cv wcel wa
    vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
    wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vx
    19.8a syl $.
    $( [3-Jan-2002] $)

  ${
    $d x v $.  $d y z w v $.
    $( Lemma for the Axiom of Choice with no distinct variable conditions. $)
    axacndlem4 $p |- E. x A. y A. z ( A. x ( y e. z /\ z e. w ) ->
              E. w A. y ( E. w ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) )
                     <-> y = w ) ) $=
      vx cv vz cv wceq vx wal vx cv vy cv wceq vx wal vx cv vw cv wceq vx wal
      vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz wal vy wal vx wex vx cv vz cv wceq vx wal wn vx cv
      vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn vy cv vz cv wcel vz cv vw
      cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal
      vy wal vx wex vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv
      vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel wa vv wal vy
      cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa
      vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vv wex vy cv vz
      cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal
      vw wex wi vz wal vy wal vx wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv
      vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw
      wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vv wex vy cv vz cv
      wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vz wal vy wal vv wex vv vy vz vw zfac vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vy
      cv vz cv wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz wal vy wal vv vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa
      wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vy cv vz cv wcel vz cv vw
      cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vy vz
      vy cv vz cv wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv wcel vz
      cv vw cv wcel wa vv ax-4 imim1i 19.20i2 19.22i ax-mp vx cv vz cv wceq vx
      wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv
      vz cv wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel
      wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy
      wal vw wex wi vz wal vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vv vx vx cv
      vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal
      wn wa vx vx vz vx hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx
      wal wn vx vx vy vx hbnae vx vw vx hbnae hban hban vx cv vz cv wceq vx wal
      wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz
      cv wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal
      vw wex wi vz wal vx vy vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal
      wn vx cv vw cv wceq vx wal wn wa vy vx vz vy hbnae vx cv vy cv wceq vx
      wal wn vx cv vw cv wceq vx wal wn vy vx vy vy hbnae vx vw vy hbnae hban
      hban vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv
      wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel wa vv wal vy cv vz
      cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw
      wex vy cv vw cv wceq wb vy wal vw wex wi vx vz vx cv vz cv wceq vx wal wn
      vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa vz vx vz vz
      hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn vz vx vy vz
      hbnae vx vw vz hbnae hban hban vx cv vz cv wceq vx wal wn vx cv vy cv
      wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw
      cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vx vx cv
      vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal
      wn wa vx vx vz vx hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx
      wal wn vx vx vy vx hbnae vx vw vx hbnae hban hban vx cv vz cv wceq vx wal
      wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz
      cv wcel vz cv vw cv wcel wa vx vv vx cv vz cv wceq vx wal wn vx cv vy cv
      wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vv ax-17 vx cv vz cv wceq
      vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy
      cv vz cv wcel vz cv vw cv wcel vx vx cv vz cv wceq vx wal wn vx cv vy cv
      wceq vx wal wn vy cv vz cv wcel vy cv vz cv wcel vx wal wi vx cv vw cv
      wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal wn vy
      cv vz cv wcel vy cv vz cv wcel vx wal wi vy vz vx ax-15 impcom adantrr vx
      cv vz cv wceq vx wal wn vx cv vw cv wceq vx wal wn vz cv vw cv wcel vz cv
      vw cv wcel vx wal wi vx cv vy cv wceq vx wal wn vx cv vz cv wceq vx wal
      wn vx cv vw cv wceq vx wal wn vz cv vw cv wcel vz cv vw cv wcel vx wal wi
      vz vw vx ax-15 imp adantrl hband hbald vx cv vz cv wceq vx wal wn vx cv
      vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz
      cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw
      cv wceq wb vy wal vx vw vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx
      wal wn vx cv vw cv wceq vx wal wn wa vw vx vz vw hbnae vx cv vy cv wceq
      vx wal wn vx cv vw cv wceq vx wal wn vw vx vy vw hbnae vx vw vw hbnae
      hban hban vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw
      cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vx vy vx cv vz cv
      wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa
      vy vx vz vy hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn
      vy vx vy vy hbnae vx vw vy hbnae hban hban vx cv vz cv wceq vx wal wn vx
      cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv
      vw cv wceq vx vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv
      vw cv wceq vx wal wn wa vx vx vz vx hbnae vx cv vy cv wceq vx wal wn vx
      cv vw cv wceq vx wal wn vx vx vy vx hbnae vx vw vx hbnae hban hban vx cv
      vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal
      wn wa wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv
      cv wcel wa wa vx vw vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn
      vx cv vw cv wceq vx wal wn wa vw vx vz vw hbnae vx cv vy cv wceq vx wal
      wn vx cv vw cv wceq vx wal wn vw vx vy vw hbnae vx vw vw hbnae hban hban
      vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx
      wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv
      vv cv wcel wa vx vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx
      cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel vx vx cv
      vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vy cv vz cv wcel vy cv vz
      cv wcel vx wal wi vx cv vw cv wceq vx wal wn vx cv vy cv wceq vx wal wn
      vx cv vz cv wceq vx wal wn vy cv vz cv wcel vy cv vz cv wcel vx wal wi vy
      vz vx ax-15 impcom adantrr vx cv vz cv wceq vx wal wn vx cv vw cv wceq vx
      wal wn vz cv vw cv wcel vz cv vw cv wcel vx wal wi vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn vx cv vw cv wceq vx wal wn vz cv vw cv
      wcel vz cv vw cv wcel vx wal wi vz vw vx ax-15 imp adantrl hband vx cv vy
      cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa vy cv vw cv wcel vw cv vv
      cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa vx wal wi vx cv vz cv
      wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa
      vy cv vw cv wcel vw cv vv cv wcel vx vx cv vy cv wceq vx wal wn vx cv vw
      cv wceq vx wal wn vy cv vw cv wcel vy cv vw cv wcel vx wal wi vy vw vx
      ax-15 imp vx cv vw cv wceq vx wal wn vw cv vv cv wcel vw cv vv cv wcel vx
      wal wi vx cv vy cv wceq vx wal wn vx vw vv dveel1 adantl hband adantl
      hband hbexd vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa vy
      cv vw cv wceq vy cv vw cv wceq vx wal wi vx cv vz cv wceq vx wal wn vx cv
      vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn vy cv vw cv wceq vy cv vw
      cv wceq vx wal wi vy vw vx ax-12 imp adantl hbbid hbald hbexd hbimd hbald
      hbald vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv
      wceq vx wal wn wa wa vv cv vx cv wceq vv cv vx cv wceq vz wal vy wal vy
      cv vz cv wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz wal vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx
      wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal wb
      vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vv cv vx cv wceq vv
      cv vx cv wceq vz wal vy wal wi vx cv vw cv wceq vx wal wn vx cv vz cv
      wceq vx wal wn vv cv vx cv wceq vv cv vx cv wceq vz wal vx cv vy cv wceq
      vx wal wn vv cv vx cv wceq vz wal vy wal vz vx vv nd5 vx cv vy cv wceq vx
      wal wn vv cv vx cv wceq vy vz vx vy vz hbnae vy vx vv nd5 hbald sylan9
      adantrr vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv
      wceq vx wal wn wa wa vv cv vx cv wceq vz wal vy wal vy cv vz cv wcel vz
      cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi
      vz wal vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal wb vx cv vz cv wceq vx
      wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vv cv
      vx cv wceq vz wal vy wal wa vy cv vz cv wcel vz cv vw cv wcel wa vv wal
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa
      wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy cv vz cv wcel vz
      cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi
      vz wal vy vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw
      cv wceq vx wal wn wa wa vv cv vx cv wceq vz wal vy wal vy vx cv vz cv
      wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa
      vy vx vz vy hbnae vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn
      vy vx vy vy hbnae vx vw vy hbnae hban hban vv cv vx cv wceq vz wal vy
      hba1 hban vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw
      cv wceq vx wal wn wa wa vv cv vx cv wceq vz wal vy wal wa vy cv vz cv
      wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv
      vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex wi vz vx cv vz cv wceq vx wal wn vx cv vy cv wceq
      vx wal wn vx cv vw cv wceq vx wal wn wa wa vv cv vx cv wceq vz wal vy wal
      vz vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq
      vx wal wn wa vz vx vz vz hbnae vx cv vy cv wceq vx wal wn vx cv vw cv
      wceq vx wal wn vz vx vy vz hbnae vx vw vz hbnae hban hban vv cv vx cv
      wceq vz vy hba2 hban vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal
      wn vx cv vw cv wceq vx wal wn wa wa vv cv vx cv wceq vz wal vy wal wa vy
      cv vz cv wcel vz cv vw cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv
      wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw
      cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex vx cv vz cv wceq vx wal wn vx cv vy cv
      wceq vx wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw
      cv wcel wa vv wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal wb vv cv vx
      cv wceq vz wal vy wal vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal
      wn vx cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vz cv wcel vz cv vw cv wcel wa vv vx vx cv vz cv wceq vx wal wn vx
      cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa vx vx vz vx hbnae
      vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn vx vx vy vx hbnae
      vx vw vx hbnae hban hban vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx
      wal wn vx cv vw cv wceq vx wal wn wa wa vy cv vz cv wcel vz cv vw cv wcel
      vx vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vy cv vz cv wcel
      vy cv vz cv wcel vx wal wi vx cv vw cv wceq vx wal wn vx cv vy cv wceq vx
      wal wn vx cv vz cv wceq vx wal wn vy cv vz cv wcel vy cv vz cv wcel vx
      wal wi vy vz vx ax-15 impcom adantrr vx cv vz cv wceq vx wal wn vx cv vw
      cv wceq vx wal wn vz cv vw cv wcel vz cv vw cv wcel vx wal wi vx cv vy cv
      wceq vx wal wn vx cv vz cv wceq vx wal wn vx cv vw cv wceq vx wal wn vz
      cv vw cv wcel vz cv vw cv wcel vx wal wi vz vw vx ax-15 imp adantrl hband
      vv cv vx cv wceq vy cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vz
      cv vw cv wcel wa wb wi vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal
      wn vx cv vw cv wceq vx wal wn wa wa vv cv vx cv wceq vy cv vz cv wcel vz
      cv vw cv wcel wa biidd a1i cbvald adantr vx cv vy cv wceq vx wal wn vx cv
      vw cv wceq vx wal wn wa vv cv vx cv wceq vz wal vy wal vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv
      vw cv wceq wb vy wal vw wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw
      cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex
      wb vx cv vz cv wceq vx wal wn vx cv vy cv wceq vx wal wn vx cv vw cv wceq
      vx wal wn wa vv cv vx cv wceq vz wal vy wal wa vx cv vy cv wceq vx wal wn
      vx cv vw cv wceq vx wal wn wa vv cv vx cv wceq vw wal vy wal wa vy cv vz
      cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw
      wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv wcel vz cv vw cv wcel
      wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy
      wal vw wex wb vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn wa vv
      cv vx cv wceq vz wal vy wal vv cv vx cv wceq vw wal vy wal vx cv vw cv
      wceq vx wal wn vv cv vx cv wceq vz wal vy wal vv cv vx cv wceq vw wal vy
      wal wi vx cv vy cv wceq vx wal wn vx cv vw cv wceq vx wal wn vv cv vx cv
      wceq vy wal vv cv vx cv wceq vw wal vy wal vv cv vx cv wceq vz wal vy wal
      vx cv vw cv wceq vx wal wn vv cv vx cv wceq vv cv vx cv wceq vw wal vy vx
      vw vy hbnae vw vx vv nd5 19.20d vv cv vx cv wceq vz wal vv cv vx cv wceq
      vy vv cv vx cv wceq vz ax-4 19.20i syl5 adantl imdistani vv cv vx cv wceq
      vw wal vy wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv
      vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wb vx cv vy cv wceq vx wal wn vx cv vw
      cv wceq vx wal wn wa vv cv vx cv wceq vw wal vy wal vy cv vz cv wcel vz
      cv vw cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw
      cv wceq wb vy wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw vv cv vx cv
      wceq vw vy hba2 vv cv vx cv wceq vw wal vy wal vy cv vz cv wcel vz cv vw
      cv wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy vv cv vx cv wceq vw wal vy hba1
      vv cv vx cv wceq vw wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vv cv wcel wa wa vw wex vy cv vw cv wceq wb vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv
      vw cv wceq wb wb vy vv cv vx cv wceq vw wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vv cv wcel wa wa vw wex vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv
      vw cv wceq vv cv vx cv wceq vw wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vv cv wcel wa wa vy cv vz cv wcel vz cv vw cv wcel
      wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw vv cv vx cv wceq vw hba1 vv
      cv vx cv wceq vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv
      vv cv wcel wa wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw
      cv vx cv wcel wa wa wb vw vv cv vx cv wceq vy cv vw cv wcel vw cv vv cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa vy cv vz cv wcel vz cv vw cv
      wcel wa vv cv vx cv wceq vw cv vv cv wcel vw cv vx cv wcel vy cv vw cv
      wcel vv vx vw elequ2 anbi2d anbi2d a4s exbid bibi1d a4s albid exbid
      adantl syl adantll imbi12d albid albid ex syld cbvexd mpbii exp32 vx vy
      vz vw axacndlem2 vx vy vz vw axacndlem1 vx cv vw cv wceq vx wal vy cv vz
      cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal
      vw wex wi vz wal vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv
      vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vx wex vx cv vw cv
      wceq vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv
      vw cv wceq wb vy wal vw wex wi vz wal vy vx vw vy hbae vx cv vw cv wceq
      vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv
      vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex wi vz vx vw vz hbae vx cv vw cv wceq vx wal vz cv
      vw cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz
      cv wcel vz cv vw cv wcel wa vx wal vx cv vw cv wceq vx wal vz cv vw cv
      wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv
      vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vx vw vz nd2
      pm2.21d vy cv vz cv wcel vz cv vw cv wcel wa vz cv vw cv wcel vx vy cv vz
      cv wcel vz cv vw cv wcel pm3.27 19.20i syl5 19.21ai 19.21ai vy cv vz cv
      wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vz wal vy wal vx 19.8a syl pm2.61iii $.
      $( [8-Jan-2002] $)
  $}

  ${
    $d x v $.  $d y v $.  $d z w v $.
    $( Lemma for the Axiom of Choice with no distinct variable conditions. $)
    axacndlem5 $p |- E. x A. y A. z ( A. x ( y e. z /\ z e. w ) ->
              E. w A. y ( E. w ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) )
                     <-> y = w ) ) $=
      vy cv vz cv wceq vy wal vy cv vx cv wceq vy wal vy cv vw cv wceq vy wal
      vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz wal vy wal vx wex vy cv vz cv wceq vy wal wn vy cv
      vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn vy cv vz cv wcel vz cv vw
      cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal
      vy wal vx wex vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv
      vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa vx wal vv
      cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa
      vw wex vv cv vw cv wceq wb vv wal vw wex wi vz wal vv wal vx wex vy cv vz
      cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal
      vw wex wi vz wal vy wal vx wex vx vv vz vw axacndlem4 vy cv vz cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv
      vz cv wcel vz cv vw cv wcel wa vx wal vv cv vz cv wcel vz cv vw cv wcel
      wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv
      wal vw wex wi vz wal vv wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vx vy cv vz
      cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn
      wa vx vy vz vx hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn vx vy vx vx hbnae vy vw vx hbnae hban hban vy cv vz cv wceq vy wal wn
      vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv
      wcel vz cv vw cv wcel wa vx wal vv cv vz cv wcel vz cv vw cv wcel wa vv
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv wal vw
      wex wi vz wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wi vz wal vv vy vy cv vz cv wceq vy wal
      wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vy vy vz vy
      hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn vy vy vx vy
      hbnae vy vw vy hbnae hban hban vy cv vz cv wceq vy wal wn vy cv vx cv
      wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw
      cv wcel wa vx wal vv cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv wal vw wex wi vy vz
      vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy
      wal wn wa vz vy vz vz hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq
      vy wal wn vz vy vx vz hbnae vy vw vz hbnae hban hban vy cv vz cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv
      vz cv wcel vz cv vw cv wcel wa vx wal vv cv vz cv wcel vz cv vw cv wcel
      wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv
      wal vw wex vy vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv
      vw cv wceq vy wal wn wa vy vy vz vy hbnae vy cv vx cv wceq vy wal wn vy
      cv vw cv wceq vy wal wn vy vy vx vy hbnae vy vw vy hbnae hban hban vy cv
      vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa vy vx vy cv vz cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vx vy vz
      vx hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn vx vy vx
      vx hbnae vy vw vx hbnae hban hban vy cv vz cv wceq vy wal wn vy cv vx cv
      wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw
      cv wcel vy vy cv vz cv wceq vy wal wn vv cv vz cv wcel vv cv vz cv wcel
      vy wal wi vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vy vz
      vv dveel2 adantr vy cv vz cv wceq vy wal wn vy cv vw cv wceq vy wal wn vz
      cv vw cv wcel vz cv vw cv wcel vy wal wi vy cv vx cv wceq vy wal wn vy cv
      vz cv wceq vy wal wn vy cv vw cv wceq vy wal wn vz cv vw cv wcel vz cv vw
      cv wcel vy wal wi vz vw vy ax-15 imp adantrl hband hbald vy cv vz cv wceq
      vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv
      cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa
      vw wex vv cv vw cv wceq wb vv wal vy vw vy cv vz cv wceq vy wal wn vy cv
      vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vw vy vz vw hbnae vy
      cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn vw vy vx vw hbnae vy
      vw vw hbnae hban hban vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal
      wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa
      vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vy vv
      vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy
      wal wn wa wa vv ax-17 vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal
      wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa
      vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq vy vy cv
      vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn wa vy vy vz vy hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy
      wal wn vy vy vx vy hbnae vy vw vy hbnae hban hban vy cv vz cv wceq vy wal
      wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz
      cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vy vw
      vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy
      wal wn wa vw vy vz vw hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq
      vy wal wn vw vy vx vw hbnae vy vw vw hbnae hban hban vy cv vz cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv
      vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa vy vy
      cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy
      wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel vy vy cv vz cv wceq vy wal
      wn vv cv vz cv wcel vv cv vz cv wcel vy wal wi vy cv vx cv wceq vy wal wn
      vy cv vw cv wceq vy wal wn wa vy vz vv dveel2 adantr vy cv vz cv wceq vy
      wal wn vy cv vw cv wceq vy wal wn vz cv vw cv wcel vz cv vw cv wcel vy
      wal wi vy cv vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy cv vw cv
      wceq vy wal wn vz cv vw cv wcel vz cv vw cv wcel vy wal wi vz vw vy ax-15
      imp adantrl hband vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn
      vy cv vw cv wceq vy wal wn wa wa vv cv vw cv wcel vw cv vx cv wcel vy vy
      cv vw cv wceq vy wal wn vv cv vw cv wcel vv cv vw cv wcel vy wal wi vy cv
      vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy vw vv dveel2 ad2antll
      vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vw cv vx cv wcel
      vw cv vx cv wcel vy wal wi vy cv vz cv wceq vy wal wn vy cv vw cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vw cv vx cv wcel vw cv vx cv wcel vy
      wal wi vw vx vy ax-15 impcom adantl hband hband hbexd vy cv vw cv wceq vy
      wal wn vv cv vw cv wceq vv cv vw cv wceq vy wal wi vy cv vz cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vy vw vv dveeq2 ad2antll hbbid hbald
      hbexd hbimd hbald vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn
      vy cv vw cv wceq vy wal wn wa wa vv cv vy cv wceq vv cv vz cv wcel vz cv
      vw cv wcel wa vx wal vv cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv wal vw wex wi
      vz wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv
      vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex wi vz wal wb vy cv vz cv wceq vy wal wn vy cv vx cv
      wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vy cv wceq wa vy cv
      vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn wa wa vv cv vy cv wceq vz wal wa vv cv vz cv wcel vz cv vw cv wcel wa
      vx wal vv cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vv cv vw cv wceq wb vv wal vw wex wi vz wal vy cv vz cv
      wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vz wal wb vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy
      cv vw cv wceq vy wal wn wa wa vv cv vy cv wceq vv cv vy cv wceq vz wal vy
      cv vz cv wceq vy wal wn vv cv vy cv wceq vv cv vy cv wceq vz wal wi vy cv
      vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vz vy vv nd5 adantr
      imdistani vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw
      cv wceq vy wal wn wa wa vv cv vy cv wceq vz wal wa vv cv vz cv wcel vz cv
      vw cv wcel wa vx wal vv cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv wal vw wex wi
      vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal
      wn vy cv vw cv wceq vy wal wn wa wa vv cv vy cv wceq vz wal vz vy cv vz
      cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn
      wa vz vy vz vz hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn vz vy vx vz hbnae vy vw vz hbnae hban hban vv cv vy cv wceq vz hba1
      hban vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv
      wceq vy wal wn wa wa vv cv vy cv wceq vz wal wa vv cv vz cv wcel vz cv vw
      cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vv cv vz cv
      wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vv cv vw cv wceq wb vv wal vw wex vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vv cv vy cv
      wceq vz wal vv cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel
      vz cv vw cv wcel wa vx wal wb vy cv vz cv wceq vy wal wn vy cv vx cv wceq
      vy wal wn vv cv vy cv wceq vz wal vv cv vz cv wcel vz cv vw cv wcel wa vx
      wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal wb vy cv vw cv wceq vy
      wal wn vy cv vx cv wceq vy wal wn vv cv vy cv wceq vv cv vz cv wcel vz cv
      vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal wb vv cv
      vy cv wceq vz wal vy cv vx cv wceq vy wal wn vv cv vy cv wceq wa vy cv vx
      cv wceq vy wal wn vv cv vy cv wceq vx wal wa vv cv vz cv wcel vz cv vw cv
      wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal wb vy cv vx cv
      wceq vy wal wn vv cv vy cv wceq vv cv vy cv wceq vx wal vx vy vv nd5
      imdistani vv cv vy cv wceq vx wal vv cv vz cv wcel vz cv vw cv wcel wa vx
      wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal wb vy cv vx cv wceq vy
      wal wn vv cv vy cv wceq vx wal vv cv vz cv wcel vz cv vw cv wcel wa vy cv
      vz cv wcel vz cv vw cv wcel wa vx vv cv vy cv wceq vx hba1 vv cv vy cv
      wceq vv cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vz cv vw cv
      wcel wa wb vx vv cv vy cv wceq vv cv vz cv wcel vy cv vz cv wcel vz cv vw
      cv wcel vv vy vz elequ1 anbi1d a4s albid adantl syl vv cv vy cv wceq vz
      ax-4 sylan2 adantlr adantll vy cv vz cv wceq vy wal wn vy cv vx cv wceq
      vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv
      wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq
      wb vv wal vw wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw
      cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wb vv cv vy
      cv wceq vz wal vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy
      cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa vv cv
      vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vv wal vy cv
      vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vy cv vw cv wceq wb vy wal vw vy cv vz cv wceq vy wal wn vy cv vx cv
      wceq vy wal wn vy cv vw cv wceq vy wal wn wa vw vy vz vw hbnae vy cv vx
      cv wceq vy wal wn vy cv vw cv wceq vy wal wn vw vy vx vw hbnae vy vw vw
      hbnae hban hban vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy
      cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa vv cv
      vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq wb vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vv vy vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy
      wal wn vy cv vw cv wceq vy wal wn wa vy vy vz vy hbnae vy cv vx cv wceq
      vy wal wn vy cv vw cv wceq vy wal wn vy vy vx vy hbnae vy vw vy hbnae
      hban hban vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw
      cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vv cv vw cv wceq vy vy cv vz cv wceq
      vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vy vy
      vz vy hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn vy vy
      vx vy hbnae vy vw vy hbnae hban hban vy cv vz cv wceq vy wal wn vy cv vx
      cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel vz cv
      vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vy vw vy cv vz cv
      wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa
      vw vy vz vw hbnae vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn
      vw vy vx vw hbnae vy vw vw hbnae hban hban vy cv vz cv wceq vy wal wn vy
      cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv cv vz cv wcel
      vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa vy vy cv vz cv
      wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa
      wa vv cv vz cv wcel vz cv vw cv wcel vy vy cv vz cv wceq vy wal wn vv cv
      vz cv wcel vv cv vz cv wcel vy wal wi vy cv vx cv wceq vy wal wn vy cv vw
      cv wceq vy wal wn wa vy vz vv dveel2 adantr vy cv vz cv wceq vy wal wn vy
      cv vw cv wceq vy wal wn vz cv vw cv wcel vz cv vw cv wcel vy wal wi vy cv
      vx cv wceq vy wal wn vy cv vz cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn vz cv vw cv wcel vz cv vw cv wcel vy wal wi vz vw vy ax-15 imp adantrl
      hband vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv
      wceq vy wal wn wa wa vv cv vw cv wcel vw cv vx cv wcel vy vy cv vw cv
      wceq vy wal wn vv cv vw cv wcel vv cv vw cv wcel vy wal wi vy cv vz cv
      wceq vy wal wn vy cv vx cv wceq vy wal wn vy vw vv dveel2 ad2antll vy cv
      vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa vw cv vx cv wcel vw cv
      vx cv wcel vy wal wi vy cv vz cv wceq vy wal wn vy cv vw cv wceq vy wal
      wn vy cv vx cv wceq vy wal wn vw cv vx cv wcel vw cv vx cv wcel vy wal wi
      vw vx vy ax-15 impcom adantl hband hband hbexd vy cv vw cv wceq vy wal wn
      vv cv vw cv wceq vv cv vw cv wceq vy wal wi vy cv vz cv wceq vy wal wn vy
      cv vx cv wceq vy wal wn vy vw vv dveeq2 ad2antll hbbid vy cv vz cv wceq
      vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa wa vv
      cv vy cv wceq vv cv vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv
      vx cv wcel wa wa vw wex vv cv vw cv wceq wb vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb wb vy cv vz cv wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv
      wceq vy wal wn wa wa vv cv vy cv wceq wa vv cv vz cv wcel vz cv vw cv
      wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vv cv
      vw cv wceq vy cv vw cv wceq vy cv vx cv wceq vy wal wn vy cv vw cv wceq
      vy wal wn wa vv cv vy cv wceq vv cv vz cv wcel vz cv vw cv wcel wa vv cv
      vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex wb vy cv vz cv
      wceq vy wal wn vy cv vw cv wceq vy wal wn vv cv vy cv wceq vv cv vz cv
      wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      wa vw wex wb vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn vv cv
      vy cv wceq wa vy cv vw cv wceq vy wal wn vv cv vy cv wceq vw wal wa vv cv
      vz cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex wb vy cv vw cv wceq vy wal wn vv cv vy cv wceq vv cv vy
      cv wceq vw wal vw vy vv nd5 imdistani vv cv vy cv wceq vw wal vv cv vz cv
      wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      wa vw wex wb vy cv vw cv wceq vy wal wn vv cv vy cv wceq vw wal vv cv vz
      cv wcel vz cv vw cv wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vy cv
      vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
      vv cv vy cv wceq vw hba1 vv cv vy cv wceq vv cv vz cv wcel vz cv vw cv
      wcel wa vv cv vw cv wcel vw cv vx cv wcel wa wa vy cv vz cv wcel vz cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa wb vw vv cv vy cv wceq
      vv cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vz cv vw cv wcel wa
      vv cv vw cv wcel vw cv vx cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      vv cv vy cv wceq vv cv vz cv wcel vy cv vz cv wcel vz cv vw cv wcel vv vy
      vz elequ1 anbi1d vv cv vy cv wceq vv cv vw cv wcel vy cv vw cv wcel vw cv
      vx cv wcel vv vy vw elequ1 anbi1d anbi12d a4s exbid adantl syl adantll
      adantll vv cv vy cv wceq vv cv vw cv wceq vy cv vw cv wceq wb vy cv vz cv
      wceq vy wal wn vy cv vx cv wceq vy wal wn vy cv vw cv wceq vy wal wn wa
      wa vv vy vw equequ1 adantl bibi12d ex cbvald exbid adantr imbi12d albid
      syl ex cbvald exbid mpbii exp32 vx vy vz vw axacndlem3 vy cv vz cv wcel
      vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw
      cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex
      wi vz wal vy wal vx wex vx vy vx vy vz vw axacndlem1 alequcoms vy cv vw
      cv wceq vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vy cv vz cv wcel vz cv
      vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi
      vz wal vy wal vx wex vy cv vw cv wceq vy cv vz cv wcel vz cv vw cv wcel
      wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx
      cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy vy cv
      vw cv wceq vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wi vz vy vw vz hbae vy cv vw cv wceq vy
      wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex vx vy cv vw cv wceq vy wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vw cv wceq vy
      cv vz cv wcel vz cv vw cv wcel wa wn vy vy cv vw cv wceq vy cv vz cv wcel
      vz cv vy cv wcel wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vz cv
      en2lp vy cv vw cv wceq vz cv vy cv wcel vz cv vw cv wcel vy cv vz cv wcel
      vy vw vz elequ2 anbi2d mtbii a4s pm2.21d a4sd 19.21ai a5i vy cv vz cv
      wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vz wal vy wal vx 19.8a syl pm2.61iii $.
      $( [3-Jan-2002] $)
  $}

  ${
    $d x v $.  $d y v $.  $d z v $.  $d w v $.
    $( A version of the Axiom of Choice with no distinct variable
       conditions. $)
    axacnd $p |- E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y
       ( E. w ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) $=
      vz cv vx cv wceq vz wal vz cv vy cv wceq vz wal vz cv vw cv wceq vz wal
      vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz wal vy wal vx wex vz cv vx cv wceq vz wal wn vz cv
      vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn vy cv vz cv wcel vz cv vw
      cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal
      vy wal vx wex vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv
      vw cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw cv wcel wa vx wal vy
      cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa
      vw wex vy cv vw cv wceq wb vy wal vw wex wi vv wal vy wal vx wex vy cv vz
      cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal
      vw wex wi vz wal vy wal vx wex vx vy vv vw axacndlem5 vz cv vx cv wceq vz
      wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv
      vv cv wcel vv cv vw cv wcel wa vx wal vy cv vv cv wcel vv cv vw cv wcel
      wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy
      wal vw wex wi vv wal vy wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal
      vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vx vz cv vx
      cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn
      wa vx vz vx vx hbnae vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal
      wn vx vz vy vx hbnae vz vw vx hbnae hban hban vz cv vx cv wceq vz wal wn
      vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv vv cv
      wcel vv cv vw cv wcel wa vx wal vy cv vv cv wcel vv cv vw cv wcel wa vy
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vv wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wi vz wal vy vz cv vx cv wceq vz wal wn
      vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa vy vz vx vy
      hbnae vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn vy vz vy vy
      hbnae vz vw vy hbnae hban hban vz cv vx cv wceq vz wal wn vz cv vy cv
      wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw
      cv wcel wa vx wal vy cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vy cv
      vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel
      wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy
      wal vw wex wi vv vz vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn
      vz cv vw cv wceq vz wal wn wa vz vz vx vz hbnae vz cv vy cv wceq vz wal
      wn vz cv vw cv wceq vz wal wn vz vz vy vz hbnae vz vw vz hbnae hban hban
      vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz
      wal wn wa wa vy cv vv cv wcel vv cv vw cv wcel wa vx wal vy cv vv cv wcel
      vv cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv
      vw cv wceq wb vy wal vw wex vz vz cv vx cv wceq vz wal wn vz cv vy cv
      wceq vz wal wn vz cv vw cv wceq vz wal wn wa vz vz vx vz hbnae vz cv vy
      cv wceq vz wal wn vz cv vw cv wceq vz wal wn vz vz vy vz hbnae vz vw vz
      hbnae hban hban vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz
      cv vw cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw cv wcel wa vz vx
      vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz
      wal wn wa vx vz vx vx hbnae vz cv vy cv wceq vz wal wn vz cv vw cv wceq
      vz wal wn vx vz vy vx hbnae vz vw vx hbnae hban hban vz cv vx cv wceq vz
      wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv
      vv cv wcel vv cv vw cv wcel vz vz cv vy cv wceq vz wal wn vy cv vv cv
      wcel vy cv vv cv wcel vz wal wi vz cv vx cv wceq vz wal wn vz cv vw cv
      wceq vz wal wn vz vy vv dveel1 ad2antrl vz cv vw cv wceq vz wal wn vv cv
      vw cv wcel vv cv vw cv wcel vz wal wi vz cv vx cv wceq vz wal wn vz cv vy
      cv wceq vz wal wn vz vw vv dveel2 ad2antll hband hbald vz cv vx cv wceq
      vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy
      cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa
      vw wex vy cv vw cv wceq wb vy wal vz vw vz cv vx cv wceq vz wal wn vz cv
      vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa vw vz vx vw hbnae vz
      cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn vw vz vy vw hbnae vz
      vw vw hbnae hban hban vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal
      wn vz cv vw cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw cv wcel wa
      vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vz vy
      vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz
      wal wn wa vy vz vx vy hbnae vz cv vy cv wceq vz wal wn vz cv vw cv wceq
      vz wal wn vy vz vy vy hbnae vz vw vy hbnae hban hban vz cv vx cv wceq vz
      wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv
      vv cv wcel vv cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw
      wex vy cv vw cv wceq vz vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz
      wal wn vz cv vw cv wceq vz wal wn wa vz vz vx vz hbnae vz cv vy cv wceq
      vz wal wn vz cv vw cv wceq vz wal wn vz vz vy vz hbnae vz vw vz hbnae
      hban hban vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw
      cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vz vw vz cv vx cv wceq vz wal wn vz cv vy cv
      wceq vz wal wn vz cv vw cv wceq vz wal wn wa vw vz vx vw hbnae vz cv vy
      cv wceq vz wal wn vz cv vw cv wceq vz wal wn vw vz vy vw hbnae vz vw vw
      hbnae hban hban vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz
      cv vw cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw cv wcel wa vy cv
      vw cv wcel vw cv vx cv wcel wa vz vz cv vx cv wceq vz wal wn vz cv vy cv
      wceq vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv vv cv wcel vv cv vw
      cv wcel vz vz cv vy cv wceq vz wal wn vy cv vv cv wcel vy cv vv cv wcel
      vz wal wi vz cv vx cv wceq vz wal wn vz cv vw cv wceq vz wal wn vz vy vv
      dveel1 ad2antrl vz cv vw cv wceq vz wal wn vv cv vw cv wcel vv cv vw cv
      wcel vz wal wi vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz
      vw vv dveel2 ad2antll hband vz cv vx cv wceq vz wal wn vz cv vy cv wceq
      vz wal wn vz cv vw cv wceq vz wal wn wa wa vy cv vw cv wcel vw cv vx cv
      wcel vz vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa vy cv vw
      cv wcel vy cv vw cv wcel vz wal wi vz cv vx cv wceq vz wal wn vz cv vy cv
      wceq vz wal wn vz cv vw cv wceq vz wal wn vy cv vw cv wcel vy cv vw cv
      wcel vz wal wi vy vw vz ax-15 imp adantl vz cv vx cv wceq vz wal wn vz cv
      vw cv wceq vz wal wn vw cv vx cv wcel vw cv vx cv wcel vz wal wi vz cv vy
      cv wceq vz wal wn vz cv vw cv wceq vz wal wn vz cv vx cv wceq vz wal wn
      vw cv vx cv wcel vw cv vx cv wcel vz wal wi vw vx vz ax-15 impcom adantrl
      hband hband hbexd vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn
      wa vy cv vw cv wceq vy cv vw cv wceq vz wal wi vz cv vx cv wceq vz wal wn
      vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn vy cv vw cv wceq vy
      cv vw cv wceq vz wal wi vy vw vz ax-12 imp adantl hbbid hbald hbexd hbimd
      vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz
      wal wn wa wa vv cv vz cv wceq vy cv vv cv wcel vv cv vw cv wcel wa vx wal
      vy cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa
      wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vy cv vz cv wcel vz cv vw
      cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel
      vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi wb vz
      cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz
      wal wn wa wa vv cv vz cv wceq wa vy cv vv cv wcel vv cv vw cv wcel wa vx
      wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vv cv wcel vv cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vz
      cv vx cv wceq vz wal wn vv cv vz cv wceq vy cv vv cv wcel vv cv vw cv
      wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal wb vz cv vy cv
      wceq vz wal wn vz cv vw cv wceq vz wal wn wa vz cv vx cv wceq vz wal wn
      vv cv vz cv wceq wa vz cv vx cv wceq vz wal wn vv cv vz cv wceq vx wal wa
      vy cv vv cv wcel vv cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv
      wcel wa vx wal wb vz cv vx cv wceq vz wal wn vv cv vz cv wceq vv cv vz cv
      wceq vx wal vx vz vv nd5 imdistani vv cv vz cv wceq vx wal vy cv vv cv
      wcel vv cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vx
      wal wb vz cv vx cv wceq vz wal wn vv cv vz cv wceq vx wal vy cv vv cv
      wcel vv cv vw cv wcel wa vy cv vz cv wcel vz cv vw cv wcel wa vx vv cv vz
      cv wceq vx hba1 vv cv vz cv wceq vy cv vv cv wcel vv cv vw cv wcel wa vy
      cv vz cv wcel vz cv vw cv wcel wa wb vx vv cv vz cv wceq vy cv vv cv wcel
      vy cv vz cv wcel vv cv vw cv wcel vz cv vw cv wcel vv vz vy elequ2 vv vz
      vw elequ1 anbi12d a4s albid adantl syl adantlr vz cv vy cv wceq vz wal wn
      vz cv vw cv wceq vz wal wn wa vv cv vz cv wceq vy cv vv cv wcel vv cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wb
      vz cv vx cv wceq vz wal wn vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz
      wal wn wa vv cv vz cv wceq wa vz cv vy cv wceq vz wal wn vz cv vw cv wceq
      vz wal wn wa vv cv vz cv wceq vy wal vw wal wa vy cv vv cv wcel vv cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vw wex vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wb
      vz cv vy cv wceq vz wal wn vz cv vw cv wceq vz wal wn wa vv cv vz cv wceq
      vv cv vz cv wceq vy wal vw wal vz cv vy cv wceq vz wal wn vv cv vz cv
      wceq vv cv vz cv wceq vy wal vz cv vw cv wceq vz wal wn vv cv vz cv wceq
      vy wal vw wal vy vz vv nd5 vz cv vw cv wceq vz wal wn vv cv vz cv wceq vw
      vy vz vw vy hbnae vw vz vv nd5 hbald sylan9 imdistani vv cv vz cv wceq vy
      wal vw wal vy cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv wcel vw cv vx
      cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex vy cv vz cv wcel
      vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv
      vw cv wceq wb vy wal vw wex wb vz cv vy cv wceq vz wal wn vz cv vw cv
      wceq vz wal wn wa vv cv vz cv wceq vy wal vw wal vy cv vv cv wcel vv cv
      vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw
      cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw vv cv vz cv wceq
      vy wal vw hba1 vv cv vz cv wceq vy wal vw wal vy cv vv cv wcel vv cv vw
      cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv
      wceq wb vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy vv cv vz cv wceq vy vw hba2 vv
      cv vz cv wceq vy wal vw wal vy cv vv cv wcel vv cv vw cv wcel wa vy cv vw
      cv wcel vw cv vx cv wcel wa wa vw wex vy cv vz cv wcel vz cv vw cv wcel
      wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq vv cv
      vz cv wceq vy wal vw wal vy cv vv cv wcel vv cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw
      cv wcel vw cv vx cv wcel wa wa vw vv cv vz cv wceq vy wal vw hba1 vv cv
      vz cv wceq vy wal vw wal vy cv vv cv wcel vv cv vw cv wcel wa vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa vv cv vz cv
      wceq vy wal vy cv vv cv wcel vv cv vw cv wcel wa vy cv vz cv wcel vz cv
      vw cv wcel wa wb vw vv cv vz cv wceq vy cv vv cv wcel vv cv vw cv wcel wa
      vy cv vz cv wcel vz cv vw cv wcel wa wb vy vv cv vz cv wceq vy cv vv cv
      wcel vy cv vz cv wcel vv cv vw cv wcel vz cv vw cv wcel vv vz vy elequ2
      vv vz vw elequ1 anbi12d a4s a4s anbi1d exbid bibi1d albid exbid adantl
      syl adantll imbi12d ex cbvald albid exbid mpbii exp32 vy cv vz cv wcel vz
      cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi
      vz wal vy wal vx wex vx vz vx vy vz vw axacndlem2 alequcoms vy cv vz cv
      wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy
      cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw
      wex wi vz wal vy wal vx wex vy vz vx vy vz vw axacndlem3 alequcoms vz cv
      vw cv wceq vz wal vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv
      wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex
      vy cv vw cv wceq wb vy wal vw wex wi vz wal vy wal vy cv vz cv wcel vz cv
      vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv
      wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi
      vz wal vy wal vx wex vz cv vw cv wceq vz wal vy cv vz cv wcel vz cv vw cv
      wcel wa vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw
      cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz wal vy
      vz vw vy hbae vz cv vw cv wceq vy cv vz cv wcel vz cv vw cv wcel wa vx
      wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw cv wcel vw cv vx cv
      wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex wi vz vz cv vw cv
      wceq vz wal vz cv vw cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa
      vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal
      vw wex vy cv vz cv wcel vz cv vw cv wcel wa vx wal vz cv vw cv wceq vz
      wal vz cv vw cv wcel vx wal vy cv vz cv wcel vz cv vw cv wcel wa vy cv vw
      cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq wb vy wal vw wex
      vz vw vx nd3 pm2.21d vy cv vz cv wcel vz cv vw cv wcel wa vz cv vw cv
      wcel vx vy cv vz cv wcel vz cv vw cv wcel pm3.27 19.20i syl5 a5i 19.21ai
      vy cv vz cv wcel vz cv vw cv wcel wa vx wal vy cv vz cv wcel vz cv vw cv
      wcel wa vy cv vw cv wcel vw cv vx cv wcel wa wa vw wex vy cv vw cv wceq
      wb vy wal vw wex wi vz wal vy wal vx 19.8a syl pm2.61iii $.
      $( [3-Jan-2002] $)
  $}

  ${
    $d x y z w v u t $.
    $( Axiom of Extensionality ~ ax-ext , reproved from conditionless ZFC
       version and predicate calculus. $)
    zfcndext $p |- ( A. z ( z e. x <-> z e. y ) -> x = y ) $=
      vz cv vx cv wcel vz cv vy cv wcel wb vz wal vx cv vy cv wceq vz wex vx cv
      vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb vx cv vy cv wceq vz vz vx
      vy axextnd 19.35i vx cv vy cv wceq vz 19.9v sylib $.
      $( [15-Aug-2003] $)

    $( Axiom of Replacement ~ ax-rep , reproved from conditionless ZFC
       axioms. $)
    zfcndrep $p |- ( A. w E. y A. z ( A. y ph -> z = y ) ->
                     E. y A. z ( z e. y <-> E. w ( w e. x /\ A. y ph ) ) ) $=
      wph vy wal vz cv vy cv wceq wi vz wal vy wex vw wal vz cv vw cv wcel vw
      cv vx cv wcel wph vy wal vy wal wa vw wex wb vz wal vw wex vz cv vy cv
      wcel vw cv vx cv wcel wph vy wal wa vw wex wb vz wal vy wex wph vy wal vz
      cv vy cv wceq wi vz wal vy wex vz cv vw cv wcel vw cv vx cv wcel wph vy
      wal vy wal wa vw wex wb vz wal vw wph vy wal vz cv vy cv wceq wi vz wal
      vy wex vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal wa vw wex wb
      vz wal wi vw wex wph vy wal vz cv vy cv wceq wi vz wal vy wex vz cv vw cv
      wcel vw cv vx cv wcel wph vy wal vy wal wa vw wex wb vz wal wi vw wex vy
      vx wph vy wal vz cv vy cv wceq wi vz wal vy wex vz cv vw cv wcel vw cv vx
      cv wcel wph vy wal vy wal wa vw wex wb vz wal wi vy vw wph vy wal vz cv
      vy cv wceq wi vz wal vy wex vz cv vw cv wcel vw cv vx cv wcel wph vy wal
      vy wal wa vw wex wb vz wal vy wph vy wal vz cv vy cv wceq wi vz wal vy
      hbe1 vz cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa vw wex wb vy
      vz vz cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa vw wex vy vz cv
      vw cv wcel vy ax-17 vw cv vx cv wcel wph vy wal vy wal wa vy vw vw cv vx
      cv wcel wph vy wal vy wal vy vw cv vx cv wcel vy ax-17 wph vy wal vy hba1
      hban hbex hbbi hbal hbim hbex vy cv vx cv wceq wph vy wal vz cv vy cv
      wceq wi vz wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal
      wa vw wex wb vz wal wi wph vy wal vz cv vy cv wceq wi vz wal vy wex vz cv
      vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa vw wex wb vz wal wi vw
      vy cv vx cv wceq vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal wa
      vw wex wb vz wal vz cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa
      vw wex wb vz wal wph vy wal vz cv vy cv wceq wi vz wal vy wex vy cv vx cv
      wceq vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal wa vw wex wb vz
      cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa vw wex wb vz vy cv vx
      cv wceq vw cv vy cv wcel wph vy wal vy wal wa vw wex vw cv vx cv wcel wph
      vy wal vy wal wa vw wex vz cv vw cv wcel vy cv vx cv wceq vw cv vy cv
      wcel wph vy wal vy wal wa vw cv vx cv wcel wph vy wal vy wal wa vw vy cv
      vx cv wceq vw cv vy cv wcel vw cv vx cv wcel wph vy wal vy wal vy vx vw
      elequ2 anbi1d exbidv bibi2d albidv imbi2d exbidv wph vy wal vz cv vy cv
      wceq wi vz wal vy wex vz cv vw cv wcel vy wal vw cv vy cv wcel vz wal wph
      vy wal vy wal wa vw wex wb vz wal wi vw wex wph vy wal vz cv vy cv wceq
      wi vz wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal wa
      vw wex wb vz wal wi vw wex wph vy wal vw vy vz axrepnd wph vy wal vz cv
      vy cv wceq wi vz wal vy wex vz cv vw cv wcel vy wal vw cv vy cv wcel vz
      wal wph vy wal vy wal wa vw wex wb vz wal wi wph vy wal vz cv vy cv wceq
      wi vz wal vy wex vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal wa
      vw wex wb vz wal wi vw vz cv vw cv wcel vy wal vw cv vy cv wcel vz wal
      wph vy wal vy wal wa vw wex wb vz wal vz cv vw cv wcel vw cv vy cv wcel
      wph vy wal vy wal wa vw wex wb vz wal wph vy wal vz cv vy cv wceq wi vz
      wal vy wex vz cv vw cv wcel vy wal vw cv vy cv wcel vz wal wph vy wal vy
      wal wa vw wex wb vz cv vw cv wcel vw cv vy cv wcel wph vy wal vy wal wa
      vw wex wb vz vz cv vw cv wcel vy wal vz cv vw cv wcel vw cv vy cv wcel vz
      wal wph vy wal vy wal wa vw wex vw cv vy cv wcel wph vy wal vy wal wa vw
      wex vz cv vw cv wcel vy vz cv vw cv wcel vy ax-17 19.3 vw cv vy cv wcel
      vz wal wph vy wal vy wal wa vw cv vy cv wcel wph vy wal vy wal wa vw vw
      cv vy cv wcel vz wal vw cv vy cv wcel wph vy wal vy wal vw cv vy cv wcel
      vz vw cv vy cv wcel vz ax-17 19.3 anbi1i exbii bibi12i albii imbi2i exbii
      mpbi chvar 19.35i vz cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa
      vw wex wb vz wal vz cv vy cv wcel vw cv vx cv wcel wph vy wal wa vw wex
      wb vz wal vw vy vz cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa vw
      wex wb vy vz vz cv vw cv wcel vw cv vx cv wcel wph vy wal vy wal wa vw
      wex vy vz cv vw cv wcel vy ax-17 vw cv vx cv wcel wph vy wal vy wal wa vy
      vw vw cv vx cv wcel wph vy wal vy wal vy vw cv vx cv wcel vy ax-17 wph vy
      wal vy hba1 hban hbex hbbi hbal vz cv vy cv wcel vw cv vx cv wcel wph vy
      wal wa vw wex wb vw vz vz cv vy cv wcel vw cv vx cv wcel wph vy wal wa vw
      wex vw vz cv vy cv wcel vw ax-17 vw cv vx cv wcel wph vy wal wa vw hbe1
      hbbi hbal vw cv vy cv wceq vz cv vw cv wcel vw cv vx cv wcel wph vy wal
      vy wal wa vw wex wb vz cv vy cv wcel vw cv vx cv wcel wph vy wal wa vw
      wex wb vz vw cv vy cv wceq vz cv vw cv wcel vz cv vy cv wcel vw cv vx cv
      wcel wph vy wal vy wal wa vw wex vw cv vx cv wcel wph vy wal wa vw wex vw
      vy vz elequ2 vw cv vx cv wcel wph vy wal vy wal wa vw wex vw cv vx cv
      wcel wph vy wal wa vw wex wb vw cv vy cv wceq vw cv vx cv wcel wph vy wal
      vy wal wa vw cv vx cv wcel wph vy wal wa vw wph vy wal vy wal wph vy wal
      vw cv vx cv wcel wph vy wal vy wph vy hba1 19.3 anbi2i exbii a1i bibi12d
      albidv cbvex sylib $.
      $( [15-Aug-2003] $)

    $( Axiom of Union ~ ax-un , reproved from conditionless ZFC axioms. $)
    zfcndun $p |- E. y A. z ( E. w ( z e. w /\ w e. x ) -> z e. y ) $=
      vz cv vw cv wcel vw cv vx cv wcel wa vw wex vz cv vy cv wcel wi vz wal vy
      wex vz cv vy cv wcel vy cv vx cv wcel wa vy wex vz cv vy cv wcel wi vz
      wal vy wex vy vz vx axunnd vz cv vw cv wcel vw cv vx cv wcel wa vw wex vz
      cv vy cv wcel wi vz wal vz cv vy cv wcel vy cv vx cv wcel wa vy wex vz cv
      vy cv wcel wi vz wal vy vz cv vw cv wcel vw cv vx cv wcel wa vw wex vz cv
      vy cv wcel wi vz cv vy cv wcel vy cv vx cv wcel wa vy wex vz cv vy cv
      wcel wi vz vz cv vw cv wcel vw cv vx cv wcel wa vw wex vz cv vy cv wcel
      vy cv vx cv wcel wa vy wex vz cv vy cv wcel vz cv vw cv wcel vw cv vx cv
      wcel wa vz cv vy cv wcel vy cv vx cv wcel wa vw vy vw cv vy cv wceq vz cv
      vw cv wcel vz cv vy cv wcel vw cv vx cv wcel vy cv vx cv wcel vw vy vz
      elequ2 vw vy vx elequ1 anbi12d cbvexv imbi1i albii exbii mpbir $.
      $( [15-Aug-2003] $)

    $( Axiom of Power Sets ~ ax-pow , reproved from conditionless ZFC axioms.
       The proof uses the "Axiom of Twoness," ~ dtru . $)
    zfcndpow $p |- E. y A. z ( A. w ( w e. z -> w e. x ) -> z e. y ) $=
      vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy cv wcel wi vz wal vy
      wex vy cv vz cv wcel vy cv vx cv wcel wi vy wal vz cv vy cv wcel wi vz
      wal vy wex vy cv vz cv wcel vx wex vy cv vx cv wcel vz wal wi vy wal vz
      cv vy cv wcel wi vz wal vy wex vy cv vz cv wcel vy cv vx cv wcel wi vy
      wal vz cv vy cv wcel wi vz wal vy wex vy cv vz cv wceq wn vy wex vy cv vz
      cv wcel vx wex vy cv vx cv wcel vz wal wi vy wal vz cv vy cv wcel wi vz
      wal vy wex vy cv vz cv wceq wn vy wex vy cv vz cv wceq vy wal wn vy vz
      dtru vy cv vz cv wceq vy exnal mpbir vy cv vz cv wceq wn vy cv vz cv wcel
      vx wex vy cv vx cv wcel vz wal wi vy wal vz cv vy cv wcel wi vz wal vy
      wex vy vy cv vz cv wcel vx wex vy cv vx cv wcel vz wal wi vy wal vz cv vy
      cv wcel wi vz wal vy hbe1 vy vz vx axpownd 19.23ai ax-mp vy cv vz cv wcel
      vx wex vy cv vx cv wcel vz wal wi vy wal vz cv vy cv wcel wi vz wal vy cv
      vz cv wcel vy cv vx cv wcel wi vy wal vz cv vy cv wcel wi vz wal vy vy cv
      vz cv wcel vx wex vy cv vx cv wcel vz wal wi vy wal vz cv vy cv wcel wi
      vy cv vz cv wcel vy cv vx cv wcel wi vy wal vz cv vy cv wcel wi vz vy cv
      vz cv wcel vx wex vy cv vx cv wcel vz wal wi vy wal vy cv vz cv wcel vy
      cv vx cv wcel wi vy wal vz cv vy cv wcel vy cv vz cv wcel vx wex vy cv vx
      cv wcel vz wal wi vy cv vz cv wcel vy cv vx cv wcel wi vy vy cv vz cv
      wcel vx wex vy cv vz cv wcel vy cv vx cv wcel vz wal vy cv vx cv wcel vy
      cv vz cv wcel vx 19.9v vy cv vx cv wcel vz vy cv vx cv wcel vz ax-17 19.3
      imbi12i albii imbi1i albii exbii mpbi vw cv vz cv wcel vw cv vx cv wcel
      wi vw wal vz cv vy cv wcel wi vz wal vy cv vz cv wcel vy cv vx cv wcel wi
      vy wal vz cv vy cv wcel wi vz wal vy vw cv vz cv wcel vw cv vx cv wcel wi
      vw wal vz cv vy cv wcel wi vy cv vz cv wcel vy cv vx cv wcel wi vy wal vz
      cv vy cv wcel wi vz vw cv vz cv wcel vw cv vx cv wcel wi vw wal vy cv vz
      cv wcel vy cv vx cv wcel wi vy wal vz cv vy cv wcel vw cv vz cv wcel vw
      cv vx cv wcel wi vy cv vz cv wcel vy cv vx cv wcel wi vw vy vw cv vy cv
      wceq vw cv vz cv wcel vy cv vz cv wcel vw cv vx cv wcel vy cv vx cv wcel
      vw vy vz elequ1 vw vy vx elequ1 imbi12d cbvalv imbi1i albii exbii mpbir
      $.
      $( [15-Aug-2003] $)

    $( Axiom of Regularity ~ ax-reg , reproved from conditionless ZFC
       axioms. $)
    zfcndreg $p |- ( E. y y e. x ->
                 E. y ( y e. x /\ A. z ( z e. y -> -. z e. x ) ) ) $=
      vy cv vx cv wcel vy cv vx cv wcel vz cv vy cv wcel vz cv vx cv wcel wn wi
      vz wal wa vy wex vy vy cv vx cv wcel vz cv vy cv wcel vz cv vx cv wcel wn
      wi vz wal wa vy hbe1 vy vx vz axregnd 19.23ai $.
      $( [15-Aug-2003] $)

    $( Axiom of Infinity ~ ax-inf , reproved from conditionless ZFC axioms.
       Since we have already reproved Extensionality, Replacement, and Power
       Sets above, we are justified in referencing theorem ~ el in the
       proof. $)
    zfcndinf $p |- E. y ( x e. y /\
                 A. z ( z e. y -> E. w ( z e. w /\ w e. y ) ) ) $=
      vx cv vy cv wcel vz cv vy cv wcel vz cv vw cv wcel vw cv vy cv wcel wa vw
      wex wi vz wal wa vy wex vx cv vy cv wcel vx cv vy cv wcel vx cv vw cv
      wcel vw cv vy cv wcel wa vw wex wi vx wal wa vy wex vx cv vw cv wcel vw
      wex vx cv vy cv wcel vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel
      wa vw wex wi vx wal wa vy wex vx vw el vx cv vw cv wcel vx cv vy cv wcel
      vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vx wal wa
      vy wex vw vx cv vy cv wcel vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv
      wcel wa vw wex wi vx wal wa vw vy vx cv vy cv wcel vx cv vy cv wcel vx cv
      vw cv wcel vw cv vy cv wcel wa vw wex wi vx wal vw vx cv vy cv wcel vw
      ax-17 vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vw
      vx vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex vw vx cv
      vy cv wcel vw ax-17 vx cv vw cv wcel vw cv vy cv wcel wa vw hbe1 hbim
      hbal hban hbex vx cv vw cv wcel vx cv vw cv wcel vy wal vx cv vy cv wcel
      vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vx wal wa
      vy wex vx cv vw cv wcel vy ax-17 vx cv vw cv wcel vx cv vy cv wcel vx cv
      vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vx wal wa vy vy
      vx vw axinfnd 19.35i syl 19.23ai ax-mp vx cv vy cv wcel vz cv vy cv wcel
      vz cv vw cv wcel vw cv vy cv wcel wa vw wex wi vz wal wa vx cv vy cv wcel
      vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vx wal wa
      vy vz cv vy cv wcel vz cv vw cv wcel vw cv vy cv wcel wa vw wex wi vz wal
      vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vx wal vx
      cv vy cv wcel vz cv vy cv wcel vz cv vw cv wcel vw cv vy cv wcel wa vw
      wex wi vx cv vy cv wcel vx cv vw cv wcel vw cv vy cv wcel wa vw wex wi vz
      vx vz cv vx cv wceq vz cv vy cv wcel vx cv vy cv wcel vz cv vw cv wcel vw
      cv vy cv wcel wa vw wex vx cv vw cv wcel vw cv vy cv wcel wa vw wex vz vx
      vy elequ1 vz cv vx cv wceq vz cv vw cv wcel vw cv vy cv wcel wa vx cv vw
      cv wcel vw cv vy cv wcel wa vw vz cv vx cv wceq vz cv vw cv wcel vx cv vw
      cv wcel vw cv vy cv wcel vz vx vw elequ1 anbi1d exbidv imbi12d cbvalv
      anbi2i exbii mpbir $.
      $( [15-Aug-2003] $)

    $( Axiom of Choice ~ ax-ac , reproved from conditionless ZFC axioms. $)
    zfcndac $p |- E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u ( E. t
              ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) $=
      vz cv vw cv wcel vw cv vx cv wcel wa vu cv vw cv wcel vw cv vt cv wcel wa
      vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal
      vv wex wi vw wal vz wal vy wex vz cv vw cv wcel vw cv vx cv wcel wa vz cv
      vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex wi vw wal vz wal vy wex vz cv vw cv
      wcel vw cv vx cv wcel wa vy wal vz cv vw cv wcel vw cv vx cv wcel wa vz
      cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx
      wex wi vw wal vz wal vy wex vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw
      cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx
      wex vz cv vx cv wceq wb vz wal vx wex wi vw wal vz wal vy wex vy vz vw vx
      axacnd vz cv vw cv wcel vw cv vx cv wcel wa vy wal vz cv vw cv wcel vw cv
      vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv
      wceq wb vz wal vx wex wi vw wal vz wal vz cv vw cv wcel vw cv vx cv wcel
      wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel
      wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vw wal vz wal vy vz cv
      vw cv wcel vw cv vx cv wcel wa vy wal vz cv vw cv wcel vw cv vx cv wcel
      wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz
      wal vx wex wi vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv
      vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv
      wceq wb vz wal vx wex wi vz vw vz cv vw cv wcel vw cv vx cv wcel wa vy
      wal vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv
      wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq
      wb vz wal vx wex vz cv vw cv wcel vw cv vx cv wcel wa vy vz cv vw cv wcel
      vw cv vx cv wcel wa vy ax-17 19.3 imbi1i 2albii exbii mpbi vz cv vw cv
      wcel vw cv vx cv wcel wa vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv
      wcel vt cv vy cv wcel wa wa vt wex vu cv vv cv wceq wb vu wal vv wex wi
      vw wal vz wal vz cv vw cv wcel vw cv vx cv wcel wa vz cv vw cv wcel vw cv
      vx cv wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv
      wceq wb vz wal vx wex wi vw wal vz wal vy vz cv vw cv wcel vw cv vx cv
      wcel wa vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv
      wcel wa wa vt wex vu cv vv cv wceq wb vu wal vv wex wi vz cv vw cv wcel
      vw cv vx cv wcel wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel
      vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vx wex wi vz vw
      vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa
      wa vt wex vu cv vv cv wceq wb vu wal vv wex vz cv vw cv wcel vw cv vx cv
      wcel wa vz cv vx cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq
      wb vz wal vx wex vz cv vw cv wcel vw cv vx cv wcel wa vu cv vw cv wcel vw
      cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vv
      cv wceq wb vu wal vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel
      vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vv vx vv cv vx
      cv wceq vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv
      wcel wa wa vt wex vu cv vv cv wceq wb vu wal vu cv vw cv wcel vw cv vx cv
      wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq
      wb vu wal vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy
      cv wcel wa wa vx wex vz cv vx cv wceq wb vz wal vv cv vx cv wceq vu cv vw
      cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt
      wex vu cv vv cv wceq wb vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv
      wcel vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq wb vu vv cv vx cv
      wceq vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv
      wcel wa wa vt wex vu cv vv cv wceq wb vu cv vw cv wcel vw cv vt cv wcel
      wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vx cv wceq wb vu
      cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa
      vx wex vu cv vx cv wceq wb vv cv vx cv wceq vu cv vv cv wceq vu cv vx cv
      wceq vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy cv
      wcel wa wa vt wex vv vx vu equequ2 bibi2d vu cv vw cv wcel vw cv vt cv
      wcel wa vu cv vt cv wcel vt cv vy cv wcel wa wa vt wex vu cv vw cv wcel
      vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa vx wex vu cv
      vx cv wceq vu cv vw cv wcel vw cv vt cv wcel wa vu cv vt cv wcel vt cv vy
      cv wcel wa wa vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv
      vy cv wcel wa wa vt vx vt cv vx cv wceq vu cv vw cv wcel vw cv vt cv wcel
      wa vu cv vw cv wcel vw cv vx cv wcel wa vu cv vt cv wcel vt cv vy cv wcel
      wa vu cv vx cv wcel vx cv vy cv wcel wa vt cv vx cv wceq vw cv vt cv wcel
      vw cv vx cv wcel vu cv vw cv wcel vt vx vw elequ2 anbi2d vt cv vx cv wceq
      vu cv vt cv wcel vu cv vx cv wcel vt cv vy cv wcel vx cv vy cv wcel vt vx
      vu elequ2 vt vx vy elequ1 anbi12d anbi12d cbvexv bibi1i syl6bb albidv vu
      cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa wa
      vx wex vu cv vx cv wceq wb vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx
      cv wcel vx cv vy cv wcel wa wa vx wex vz cv vx cv wceq wb vu vz vu cv vz
      cv wceq vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv
      wcel wa wa vx wex vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel
      vx cv vy cv wcel wa wa vx wex vu cv vx cv wceq vz cv vx cv wceq vu cv vz
      cv wceq vu cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv
      wcel wa wa vz cv vw cv wcel vw cv vx cv wcel wa vz cv vx cv wcel vx cv vy
      cv wcel wa wa vx vu cv vz cv wceq vu cv vw cv wcel vw cv vx cv wcel wa vz
      cv vw cv wcel vw cv vx cv wcel wa vu cv vx cv wcel vx cv vy cv wcel wa vz
      cv vx cv wcel vx cv vy cv wcel wa vu cv vz cv wceq vu cv vw cv wcel vz cv
      vw cv wcel vw cv vx cv wcel vu vz vw elequ1 anbi1d vu cv vz cv wceq vu cv
      vx cv wcel vz cv vx cv wcel vx cv vy cv wcel vu vz vx elequ1 anbi1d
      anbi12d exbidv vu vz vx equequ1 bibi12d cbvalv syl6bb cbvexv imbi2i
      2albii exbii mpbir $.
      $( [15-Aug-2003] $)
  $}

$(
  @{
    @d x y z w @.
    zfcndpowNEW @p  |- E. x A. y ( A. x ( x e. y -> x e. z ) -> y e. x ) @=
     ( wel wi wal wex weq wa wb zfcndrep hbae 19.9rOLD equid a1bi albii exbii
       bitri
      imbi1i mpbir 19.37 mpbi ax-gen biantru bibi2i bicomi bi2 sylbi 19.20i
      19.22i syl axpowndNEW ax-mp 19.9rvOLD ax-17 19.3rOLD imbi12i )
      ABDZACDZEZAFZBADZE
      ZBFZAGURCGZUSBFZEZAFZVBEZBFZAGZABHZAFZCBDZCGZUSEZAFZCGZEVKVMUSVNAAHZBFZIZ
      CGZJZAFZCGZVRVMWDEZCGZVMWEEWGVSVLEZAFZBGZWDEZCGVSCBAKWFWKCVMWJWDVMVMBGWJV
      MBABBLMVMWIBVLWHAVSVLANZOPQRSQTVMWDCABCLUAUBWDVQCWCVPAWCUSVOJZVPWMWCVOWBU
      SVNWACVTVNVSBWLUCUDQUEUFUSVOUGUHUIUJUKABCULUMVDVJAVCVIBVAVHVBUTVGAURVEUSV
      FURCUNUSBUSBUOUPUQPSPQT @.
  @}
$)

$( End of set.mm $)

$( The work below may eventually be broken off as a separate
   module, dedekind.mm. $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                       Real and complex numbers
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Dedekind-cut construction of real and complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)

  $c N. $. $( Set of positive integers $)

  $c +N $. $( Positive integer addition $)
  $c .N $. $( Positive integer multiplication $)
  $c <N $. $( Positive integer ordering relation $)

  $c +pQ $. $( Positive fraction pre-addition $)
  $c .pQ $. $( Positive fraction pre-multiplication $)

  $c ~Q $. $( Equivalence relation to construct positive fractions $)
  $c Q. $. $( Set of positive fractions $)
  $c 1Q $. $( Positive fraction constant 1 $)
  $c +Q $. $( Positive fraction addition $)
  $c .Q $. $( Positive fraction multiplication $)
  $c *Q $. $( Positive fraction reciprocal $)
  $c <Q $. $( Positive fraction ordering relation $)

  $c P. $. $( Set of positive reals $)
  $c 1P $. $( Positive real constant 1 $)
  $c +P. $. $( Positive real addition $)
  $c .P. $. $( Positive real multiplication $)
  $c <P $. $( Positive real ordering relation $)

  $c +pR $. $( Signed real pre-addition $)
  $c .pR $. $( Signed real pre-multiplication $)

  $c ~R $. $( Equivalence relation to construct signed reals $)
  $c R. $. $( Set of signed reals $)
  $c 0R $. $( Signed real constant 0 $)
  $c 1R $. $( Signed real constant 1 $)
  $c -1R $. $( Signed real constant minus 1 $)
  $c +R $. $( Signed real addition $)
  $c .R $. $( Signed real multiplication $)
  $c <R $. $( Signed real ordering relation $)
  $c <RR $. $( 'Less than' relation (restricted to non-extended reals) $)

  $c CC $. $( The set of complex numbers (blackboard bold C) $)
  $c RR $. $( The set of real numbers (blackboard bold R) $)
  $c 0 $. $( The real number 0 base 10. $)
  $c 1 $. $( The real number 1 base 10. $)
  $c _i $. $( Letter i (the imaginary unit = square root of -1) $)
  $c + $. $( Plus (addition) symbol $)
  $c x. $. $( Multiplication symbol (center dot) $)

  $( Extend class notation with new sets (constants) used for positive
     integers: $)

  $( The set of positive integers, which is the set of natural numbers
     ` om ` with 0 removed.

     _Note:  This is the start of the Dedekind-cut construction of real and_
     _complex numbers.  The last lemma of the construction is_
     ~ mulcnsrec .  _The actual set of Dedekind cuts is defined by_
     ~ df-np . $)
  cnpi $a class N. $.
  $( Positive integer addition. $)
  cpli $a class +N $.
  $( Positive integer multiplication. $)
  cmi $a class .N $.
  $( Positive integer ordering relation. $)
  clti $a class <N $.

  $( Extend class notation with new sets (constants) used in construction of
    positive fractions: $)

  $( Positive fraction pre-addition. $)
  cplpq $a class +pQ $.
  $( Positive fraction pre-multiplication. $)
  cmpq $a class .pQ $.
  $( Equivalence class used to construct positive fractions. $)
  ceq $a class ~Q $.
  $( Set of positive fractions. $)
  cnq $a class Q. $.
  $( The positive fraction constant 1. $)
  c1q $a class 1Q $.
  $( Positive fraction addition. $)
  cplq $a class +Q $.
  $( Positive fraction multiplication. $)
  cmq $a class .Q $.
  $( Positive fraction reciprocal operation. $)
  crq $a class *Q $.
  $( Positive fraction ordering relation. $)
  cltq $a class <Q $.

  $( Extend class notation with new sets (constants) used in construction of
    positive real numbers: $)

  $( Set of positive reals. $)
  cnp $a class P. $.
  $( Positive real constant 1. $)
  c1p $a class 1P $.
  $( Positive real addition. $)
  cpp $a class +P. $.
  $( Positive real multiplication. $)
  cmp $a class .P. $.
  $( Positive real ordering relation. $)
  cltp $a class <P $.

  $( Extend class notation with new sets (constants) used in construction of
    signed real numbers: $)

  $( Signed real pre-addition. $)
  cplpr $a class +pR $.
  $( Signed real pre-multiplication. $)
  cmpr $a class .pR $.
  $( Equivalence class used to construct signed reals. $)
  cer $a class ~R $.
  $( Set of signed reals. $)
  cnr $a class R. $.
  $( The signed real constant 0. $)
  c0r $a class 0R $.
  $( The signed real constant 1. $)
  c1r $a class 1R $.
  $( The signed real constant -1. $)
  cm1r $a class -1R $.
  $( Signed real addition. $)
  cplr $a class +R $.
  $( Signed real multiplication. $)
  cmr $a class .R $.
  $( Signed real ordering relation. $)
  cltr $a class <R $.

  $( Define the class of positive integers.  This is a "temporary" set used
     in the construction of complex numbers ~ df-c , and is intended to be
     used only by the construction. $)
  df-ni $a |- N. = ( om \ { (/) } ) $.

  $( Define addition on positive integers.  This is a "temporary" set
     used in the construction of complex numbers ~ df-c , and is intended to
     be used only by the construction. $)
  df-pli $a |- +N = ( +o |` ( N. X. N. ) ) $.

  $( Define multiplication on positive integers.  This is a "temporary" set
     used in the construction of complex numbers ~ df-c , and is intended to
     be used only by the construction. $)
  df-mi $a |- .N = ( .o |` ( N. X. N. ) ) $.

  $( Define 'less than' on positive integers.  This is a "temporary" set
     used in the construction of complex numbers ~ df-c , and is intended to
     be used only by the construction. $)
  df-lti $a |- <N = ( _E i^i ( N. X. N. ) ) $.

  $( Membership in the class of positive integers. $)
  elni $p |- ( A e. N. <-> ( A e. om /\ A =/= (/) ) ) $=
    cA cnpi wcel cA com c0 csn cdif wcel cA com wcel cA c0 wne wa cnpi com c0
    csn cdif cA df-ni eleq2i cA com c0 eldifsn bitri $.
    $( [15-Apr-2007] $) $( [15-Aug-1995] $)

  $( Membership in the class of positive integers. $)
  elni2 $p |- ( A e. N. <-> ( A e. om /\ (/) e. A ) ) $=
    cA cnpi wcel cA com wcel cA c0 wne wa cA com wcel c0 cA wcel wa cA elni cA
    com wcel c0 cA wcel cA c0 wne cA com wcel cA word c0 cA wcel cA c0 wne wb
    cA nnord cA ord0eln0 syl pm5.32i bitr4i $.
    $( [27-Nov-1995] $)

  $( A positive integer is a natural number. $)
  pinn $p |- ( A e. N. -> A e. om ) $=
    cnpi com cA cnpi com c0 csn cdif com df-ni com c0 csn difss eqsstri sseli
    $.
    $( [15-Aug-1995] $)

  $( A positive integer is an ordinal number. $)
  pion $p |- ( A e. N. -> A e. On ) $=
    cA cnpi wcel cA com wcel cA con0 wcel cA pinn cA nnon syl $.
    $( [23-Mar-1996] $)

  $( A positive integer is ordinal. $)
  piord $p |- ( A e. N. -> Ord A ) $=
    cA cnpi wcel cA com wcel cA word cA pinn cA nnord syl $.
    $( [29-Jan-1996] $)

  $( The class of positive integers is a set. $)
  niex $p |- N. e. _V $=
    cnpi com omex cnpi com c0 csn cdif com df-ni com c0 csn difss eqsstri ssexi
    $.
    $( [15-Aug-1995] $)

  $( The empty set is not a positive integer. $)
  0npi $p |- -. (/) e. N. $=
    c0 c0 wceq c0 cnpi wcel wn c0 eqid c0 cnpi wcel c0 c0 c0 cnpi wcel c0 com
    wcel c0 c0 wne c0 elni pm3.27bi necon2bi ax-mp $.
    $( [26-Aug-1995] $)

  $( Ordinal 'one' is a positive integer. $)
  1pi $p |- 1o e. N. $=
    c1o cnpi wcel c1o com wcel c1o c0 wne c1o elni 1onn 1n0 mpbir2an $.
    $( [29-Oct-1995] $)

  $( Positive integer addition in terms of ordinal addition. $)
  addpiord $p |- ( ( A e. N. /\ B e. N. ) -> ( A +N B ) = ( A +o B ) ) $=
    cA cnpi wcel cB cnpi wcel wa cA cB cop cnpi cnpi cxp wcel cA cB cpli co cA
    cB coa co wceq cA cB cnpi cnpi opelxpi cA cB cop cnpi cnpi cxp wcel cA cB
    cop coa cnpi cnpi cxp cres cfv cA cB cop coa cfv cA cB cpli co cA cB coa co
    cA cB cop cnpi cnpi cxp coa fvres cA cB cpli co cA cB cop cpli cfv cA cB
    cop coa cnpi cnpi cxp cres cfv cA cB cpli df-opr cA cB cop cpli coa cnpi
    cnpi cxp cres df-pli fveq1i eqtri cA cB coa df-opr 3eqtr4g syl $.
    $( [27-Aug-1995] $)

  $( Positive integer multiplication in terms of ordinal multiplication. $)
  mulpiord $p |- ( ( A e. N. /\ B e. N. ) -> ( A .N B ) = ( A .o B ) ) $=
    cA cnpi wcel cB cnpi wcel wa cA cB cop cnpi cnpi cxp wcel cA cB cmi co cA
    cB comu co wceq cA cB cnpi cnpi opelxpi cA cB cop cnpi cnpi cxp wcel cA cB
    cop comu cnpi cnpi cxp cres cfv cA cB cop comu cfv cA cB cmi co cA cB comu
    co cA cB cop cnpi cnpi cxp comu fvres cA cB cmi co cA cB cop cmi cfv cA cB
    cop comu cnpi cnpi cxp cres cfv cA cB cmi df-opr cA cB cop cmi comu cnpi
    cnpi cxp cres df-mi fveq1i eqtri cA cB comu df-opr 3eqtr4g syl $.
    $( [27-Aug-1995] $)

  $( 1 is an identity element for multiplication on positive integers. $)
  mulidpi $p |- ( A e. N. -> ( A .N 1o ) = A ) $=
    cA cnpi wcel cA c1o cmi co cA c1o comu co cA cA cnpi wcel c1o cnpi wcel cA
    c1o cmi co cA c1o comu co wceq 1pi cA c1o mulpiord mpan2 cA cnpi wcel cA
    com wcel cA con0 wcel cA c1o comu co cA wceq cA pinn cA nnon cA om1 3syl
    eqtrd $.
    $( [4-Mar-1996] $)

  ${
    $d x y A $.  $d x y B $.
    $( Positive integer 'less than' in terms of ordinal membership. $)
    ltpiord $p |- ( ( A e. N. /\ B e. N. ) -> ( A <N B <-> A e. B ) ) $=
      vx cv vy cv clti wbr vx cv vy cv wcel wb cA vy cv clti wbr cA vy cv wcel
      wb cA cB clti wbr cA cB wcel wb vx vy cA cB cnpi cnpi vx cv cA wceq vx cv
      vy cv clti wbr cA vy cv clti wbr vx cv vy cv wcel cA vy cv wcel vx cv cA
      vy cv clti breq1 vx cv cA vy cv eleq1 bibi12d vy cv cB wceq cA vy cv clti
      wbr cA cB clti wbr cA vy cv wcel cA cB wcel vy cv cB cA clti breq2 vy cv
      cB cA eleq2 bibi12d vx cv cnpi wcel vy cv cnpi wcel wa vx cv vy cv cop
      cnpi cnpi cxp wcel vx cv vy cv clti wbr vx cv vy cv wcel wb vx cv vy cv
      cnpi cnpi vy visset opelxp vx cv vy cv cop cnpi cnpi cxp wcel vx cv vy cv
      wcel vx cv vy cv cop cep wcel vx cv vy cv cop cnpi cnpi cxp wcel wa vx cv
      vy cv clti wbr vx cv vy cv cop cnpi cnpi cxp wcel vx cv vy cv cop cep
      wcel vx cv vy cv cop cep wcel vx cv vy cv cop cnpi cnpi cxp wcel wa vx cv
      vy cv wcel vx cv vy cv cop cnpi cnpi cxp wcel vx cv vy cv cop cep wcel
      iba vx cv vy cv cop cep wcel vx cv vy cv cep wbr vx cv vy cv wcel vx cv
      vy cv cep df-br vx vy epel bitr3i syl5bbr vx cv vy cv clti wbr vx cv vy
      cv cop clti wcel vx cv vy cv cop cep cnpi cnpi cxp cin wcel vx cv vy cv
      cop cep wcel vx cv vy cv cop cnpi cnpi cxp wcel wa vx cv vy cv clti df-br
      clti cep cnpi cnpi cxp cin vx cv vy cv cop df-lti eleq2i vx cv vy cv cop
      cep cnpi cnpi cxp elin 3bitri syl6rbbr sylbir vtocl2ga $.
      $( [6-Feb-1996] $)
  $}

  ${
    $d x y z $.
    $( Positive integer 'less than' is a strict ordering. $)
    ltsopi $p |- <N Or N. $=
      vx vy vz cnpi clti vx cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel w3a vx
      cv vy cv clti wbr vx cv vy cv wceq vy cv vx cv clti wbr wo wn wb vx cv vy
      cv clti wbr vy cv vz cv clti wbr wa vx cv vz cv clti wbr wi vx cv cnpi
      wcel vy cv cnpi wcel vx cv vy cv clti wbr vx cv vy cv wceq vy cv vx cv
      clti wbr wo wn wb vz cv cnpi wcel vx cv cnpi wcel vy cv cnpi wcel wa vx
      cv vy cv wcel vx cv vy cv wceq vy cv vx cv wcel wo wn vx cv vy cv clti
      wbr vx cv vy cv wceq vy cv vx cv clti wbr wo wn vx cv word vy cv word vx
      cv vy cv wcel vx cv vy cv wceq vy cv vx cv wcel wo wn wb vx cv cnpi wcel
      vy cv cnpi wcel vx cv vy cv ordtri2 vx cv piord vy cv piord syl2an vx cv
      vy cv ltpiord vx cv cnpi wcel vy cv cnpi wcel wa vx cv vy cv wceq vy cv
      vx cv clti wbr wo vx cv vy cv wceq vy cv vx cv wcel wo vx cv cnpi wcel vy
      cv cnpi wcel wa vy cv vx cv clti wbr vy cv vx cv wcel vx cv vy cv wceq vy
      cv cnpi wcel vx cv cnpi wcel vy cv vx cv clti wbr vy cv vx cv wcel wb vy
      cv vx cv ltpiord ancoms orbi2d notbid 3bitr4d 3adant3 vx cv cnpi wcel vy
      cv cnpi wcel vz cv cnpi wcel w3a vx cv vy cv wcel vy cv vz cv wcel wa vx
      cv vz cv wcel vx cv vy cv clti wbr vy cv vz cv clti wbr wa vx cv vz cv
      clti wbr vx cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel w3a vz cv cnpi
      wcel vz cv con0 wcel vx cv vy cv wcel vy cv vz cv wcel wa vx cv vz cv
      wcel wi vx cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel 3simp3 vz cv pion
      vx cv vy cv vz cv ontr1 3syl vx cv cnpi wcel vy cv cnpi wcel vz cv cnpi
      wcel w3a vx cv vy cv clti wbr vx cv vy cv wcel vy cv vz cv clti wbr vy cv
      vz cv wcel vx cv cnpi wcel vy cv cnpi wcel vx cv vy cv clti wbr vx cv vy
      cv wcel wb vz cv cnpi wcel vx cv vy cv ltpiord 3adant3 vy cv cnpi wcel vz
      cv cnpi wcel vy cv vz cv clti wbr vy cv vz cv wcel wb vx cv cnpi wcel vy
      cv vz cv ltpiord 3adant1 anbi12d vx cv cnpi wcel vz cv cnpi wcel vx cv vz
      cv clti wbr vx cv vz cv wcel wb vy cv cnpi wcel vx cv vz cv ltpiord
      3adant2 3imtr4d jca so $.
      $( [8-Feb-1996] $)
  $}

  $( Positive integer 'less than' is a relation on positive integers. $)
  ltrelpi $p |- <N C_ ( N. X. N. ) $=
    clti cep cnpi cnpi cxp cin cnpi cnpi cxp df-lti cep cnpi cnpi cxp inss2
    eqsstri $.
    $( [8-Feb-1996] $)

  $( Domain of addition on positive integers. $)
  dmaddpi $p |- dom +N = ( N. X. N. ) $=
    coa cnpi cnpi cxp cres cdm cnpi cnpi cxp con0 con0 cxp cin cpli cdm cnpi
    cnpi cxp coa cnpi cnpi cxp cres cdm cnpi cnpi cxp coa cdm cin cnpi cnpi cxp
    con0 con0 cxp cin coa cnpi cnpi cxp dmres coa cdm con0 con0 cxp cnpi cnpi
    cxp coa con0 con0 cxp wfn coa cdm con0 con0 cxp wceq fnoa con0 con0 cxp coa
    fndm ax-mp ineq2i eqtri cpli coa cnpi cnpi cxp cres df-pli dmeqi cnpi cnpi
    cxp con0 con0 cxp wss cnpi cnpi cxp cnpi cnpi cxp con0 con0 cxp cin wceq
    cnpi con0 wss cnpi con0 wss wa cnpi cnpi cxp con0 con0 cxp wss cnpi con0
    wss cnpi con0 wss wa cnpi con0 wss cnpi com con0 cnpi com c0 csn cdif com
    df-ni com c0 csn difss eqsstri omsson sstri cnpi con0 wss anidm mpbir cnpi
    con0 cnpi con0 ssxp ax-mp cnpi cnpi cxp con0 con0 cxp dfss mpbi 3eqtr4i $.
    $( [26-Aug-1995] $)

  $( Domain of multiplication on positive integers. $)
  dmmulpi $p |- dom .N = ( N. X. N. ) $=
    comu cnpi cnpi cxp cres cdm cnpi cnpi cxp con0 con0 cxp cin cmi cdm cnpi
    cnpi cxp comu cnpi cnpi cxp cres cdm cnpi cnpi cxp comu cdm cin cnpi cnpi
    cxp con0 con0 cxp cin comu cnpi cnpi cxp dmres comu cdm con0 con0 cxp cnpi
    cnpi cxp comu con0 con0 cxp wfn comu cdm con0 con0 cxp wceq fnom con0 con0
    cxp comu fndm ax-mp ineq2i eqtri cmi comu cnpi cnpi cxp cres df-mi dmeqi
    cnpi cnpi cxp con0 con0 cxp wss cnpi cnpi cxp cnpi cnpi cxp con0 con0 cxp
    cin wceq cnpi con0 wss cnpi con0 wss wa cnpi cnpi cxp con0 con0 cxp wss
    cnpi con0 wss cnpi con0 wss wa cnpi con0 wss cnpi com con0 cnpi com c0 csn
    cdif com df-ni com c0 csn difss eqsstri omsson sstri cnpi con0 wss anidm
    mpbir cnpi con0 cnpi con0 ssxp ax-mp cnpi cnpi cxp con0 con0 cxp dfss mpbi
    3eqtr4i $.
    $( [26-Aug-1995] $)

  $( Closure of addition of positive integers. $)
  addclpi $p |- ( ( A e. N. /\ B e. N. ) -> ( A +N B ) e. N. ) $=
    cA cnpi wcel cB cnpi wcel wa cA cB cpli co cA cB coa co cnpi cA cB addpiord
    cA com wcel cB cnpi wcel cA cB coa co cnpi wcel cA cnpi wcel cA cB coa co
    cnpi wcel cA cB coa co com wcel cA cB coa co c0 wne cA com wcel cB cnpi
    wcel wa cA cB coa co elni cA com wcel cB com wcel cA cB coa co com wcel cB
    cnpi wcel cA cB nnacl cB pinn sylan2 cA com wcel cB com wcel c0 cB wcel wa
    cA cB coa co c0 wne cB cnpi wcel cA com wcel cB com wcel c0 cB wcel cA cB
    coa co c0 wne cB com wcel cA com wcel c0 cB wcel cA cB coa co c0 wne wi cB
    com wcel cA com wcel wa c0 cB wcel cA c0 coa co cA cB coa co wcel cA cB coa
    co c0 wne c0 cB cA nnaordi cA cB coa co cA c0 coa co ne0i syl6 expcom imp32
    cB elni2 sylan2b sylanbrc cA pinn sylan eqeltrd $.
    $( [18-Oct-1995] $)

  $( Closure of multiplication of positive integers. $)
  mulclpi $p |- ( ( A e. N. /\ B e. N. ) -> ( A .N B ) e. N. ) $=
    cA cnpi wcel cB cnpi wcel wa cA cB cmi co cA cB comu co cnpi cA cB mulpiord
    cA cB comu co cnpi wcel cA cB comu co com wcel cA cB comu co c0 wne cA cnpi
    wcel cB cnpi wcel wa cA cB comu co elni cA com wcel cB com wcel cA cB comu
    co com wcel cA cnpi wcel cB cnpi wcel cA cB nnmcl cA pinn cB pinn syl2an cA
    cnpi wcel cB cnpi wcel wa cA c0 comu co cA cB comu co wcel cA cB comu co c0
    wne cB cnpi wcel cA cnpi wcel cA c0 comu co cA cB comu co wcel cB com wcel
    c0 cB wcel wa cA com wcel c0 cA wcel wa cA c0 comu co cA cB comu co wcel cB
    cnpi wcel cA cnpi wcel cB com wcel cA com wcel c0 cB wcel c0 cA wcel cA c0
    comu co cA cB comu co wcel cB com wcel cA com wcel wa c0 cB wcel c0 cA wcel
    wa cA c0 comu co cA cB comu co wcel c0 com wcel cB com wcel cA com wcel c0
    cB wcel c0 cA wcel wa cA c0 comu co cA cB comu co wcel wi peano1 c0 cB cA
    nnmordi mp3an1 imp an4s cB elni2 cA elni2 syl2anb ancoms cA cB comu co cA
    c0 comu co ne0i syl sylanbrc eqeltrd $.
    $( [18-Oct-1995] $)

  ${
    addcompi.1 $e |- A e. _V $.
    addcompi.2 $e |- B e. _V $.
    $( Addition of positive integers is commutative. $)
    addcompi $p |- ( A +N B ) = ( B +N A ) $=
      cA cnpi wcel cB cnpi wcel wa cA cB cpli co cB cA cpli co wceq cA cnpi
      wcel cB cnpi wcel wa cA cB coa co cB cA coa co cA cB cpli co cB cA cpli
      co cA com wcel cB com wcel cA cB coa co cB cA coa co wceq cA cnpi wcel cB
      cnpi wcel cA cB nnacom cA pinn cB pinn syl2an cA cB addpiord cB cnpi wcel
      cA cnpi wcel cB cA cpli co cB cA coa co wceq cB cA addpiord ancoms
      3eqtr4d cA cB cnpi cpli addcompi.2 dmaddpi addcompi.1 ndmoprcom pm2.61i
      $.
      $( [27-Aug-1995] $)
  $}

  ${
    addasspi.1 $e |- B e. _V $.
    addasspi.2 $e |- C e. _V $.
    $( Addition of positive integers is associative. $)
    addasspi $p |- ( ( A +N B ) +N C ) = ( A +N ( B +N C ) ) $=
      cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB cpli co cC cpli co cA cB
      cC cpli co cpli co wceq cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB
      coa co cC coa co cA cB cC coa co coa co cA cB cpli co cC cpli co cA cB cC
      cpli co cpli co cA com wcel cB com wcel cC com wcel cA cB coa co cC coa
      co cA cB cC coa co coa co wceq cA cnpi wcel cB cnpi wcel cC cnpi wcel cA
      cB cC nnaass cA pinn cB pinn cC pinn syl3an cA cnpi wcel cB cnpi wcel cC
      cnpi wcel cA cB cpli co cC cpli co cA cB coa co cC coa co wceq cA cnpi
      wcel cB cnpi wcel wa cC cnpi wcel wa cA cB cpli co cC cpli co cA cB cpli
      co cC coa co cA cB coa co cC coa co cA cB cpli co cnpi wcel cC cnpi wcel
      cA cB cpli co cC cpli co cA cB cpli co cC coa co wceq cA cnpi wcel cB
      cnpi wcel wa cA cB cpli co cC addpiord cA cB addclpi sylan cA cnpi wcel
      cB cnpi wcel wa cA cB cpli co cC coa co cA cB coa co cC coa co wceq cC
      cnpi wcel cA cnpi wcel cB cnpi wcel wa cA cB cpli co cA cB coa co cC coa
      cA cB addpiord opreq1d adantr eqtrd 3impa cA cnpi wcel cB cnpi wcel cC
      cnpi wcel cA cB cC cpli co cpli co cA cB cC coa co coa co wceq cA cnpi
      wcel cB cnpi wcel cC cnpi wcel wa wa cA cB cC cpli co cpli co cA cB cC
      cpli co coa co cA cB cC coa co coa co cA cnpi wcel cB cC cpli co cnpi
      wcel cA cB cC cpli co cpli co cA cB cC cpli co coa co wceq cB cnpi wcel
      cC cnpi wcel wa cA cB cC cpli co addpiord cB cC addclpi sylan2 cB cnpi
      wcel cC cnpi wcel wa cA cB cC cpli co coa co cA cB cC coa co coa co wceq
      cA cnpi wcel cB cnpi wcel cC cnpi wcel wa cB cC cpli co cB cC coa co cA
      coa cB cC addpiord opreq2d adantl eqtrd 3impb 3eqtr4d cA cB cC cnpi cpli
      addasspi.1 dmaddpi addasspi.2 0npi ndmoprass pm2.61i $.
      $( [27-Aug-1995] $)
  $}

  ${
    mulcompi.1 $e |- A e. _V $.
    mulcompi.2 $e |- B e. _V $.
    $( Multiplication of positive integers is commutative. $)
    mulcompi $p |- ( A .N B ) = ( B .N A ) $=
      cA cnpi wcel cB cnpi wcel wa cA cB cmi co cB cA cmi co wceq cA cnpi wcel
      cB cnpi wcel wa cA cB comu co cB cA comu co cA cB cmi co cB cA cmi co cA
      com wcel cB com wcel cA cB comu co cB cA comu co wceq cA cnpi wcel cB
      cnpi wcel cA cB nnmcom cA pinn cB pinn syl2an cA cB mulpiord cB cnpi wcel
      cA cnpi wcel cB cA cmi co cB cA comu co wceq cB cA mulpiord ancoms
      3eqtr4d cA cB cnpi cmi mulcompi.2 dmmulpi mulcompi.1 ndmoprcom pm2.61i $.
      $( [21-Sep-1995] $)
  $}

  ${
    mulasspi.1 $e |- B e. _V $.
    mulasspi.2 $e |- C e. _V $.
    $( Multiplication of positive integers is associative. $)
    mulasspi $p |- ( ( A .N B ) .N C ) = ( A .N ( B .N C ) ) $=
      cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB cmi co cC cmi co cA cB
      cC cmi co cmi co wceq cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB
      comu co cC comu co cA cB cC comu co comu co cA cB cmi co cC cmi co cA cB
      cC cmi co cmi co cA com wcel cB com wcel cC com wcel cA cB comu co cC
      comu co cA cB cC comu co comu co wceq cA cnpi wcel cB cnpi wcel cC cnpi
      wcel cA cB cC nnmass cA pinn cB pinn cC pinn syl3an cA cnpi wcel cB cnpi
      wcel cC cnpi wcel cA cB cmi co cC cmi co cA cB comu co cC comu co wceq cA
      cnpi wcel cB cnpi wcel wa cC cnpi wcel wa cA cB cmi co cC cmi co cA cB
      cmi co cC comu co cA cB comu co cC comu co cA cB cmi co cnpi wcel cC cnpi
      wcel cA cB cmi co cC cmi co cA cB cmi co cC comu co wceq cA cnpi wcel cB
      cnpi wcel wa cA cB cmi co cC mulpiord cA cB mulclpi sylan cA cnpi wcel cB
      cnpi wcel wa cA cB cmi co cC comu co cA cB comu co cC comu co wceq cC
      cnpi wcel cA cnpi wcel cB cnpi wcel wa cA cB cmi co cA cB comu co cC comu
      cA cB mulpiord opreq1d adantr eqtrd 3impa cA cnpi wcel cB cnpi wcel cC
      cnpi wcel cA cB cC cmi co cmi co cA cB cC comu co comu co wceq cA cnpi
      wcel cB cnpi wcel cC cnpi wcel wa wa cA cB cC cmi co cmi co cA cB cC cmi
      co comu co cA cB cC comu co comu co cA cnpi wcel cB cC cmi co cnpi wcel
      cA cB cC cmi co cmi co cA cB cC cmi co comu co wceq cB cnpi wcel cC cnpi
      wcel wa cA cB cC cmi co mulpiord cB cC mulclpi sylan2 cB cnpi wcel cC
      cnpi wcel wa cA cB cC cmi co comu co cA cB cC comu co comu co wceq cA
      cnpi wcel cB cnpi wcel cC cnpi wcel wa cB cC cmi co cB cC comu co cA comu
      cB cC mulpiord opreq2d adantl eqtrd 3impb 3eqtr4d cA cB cC cnpi cmi
      mulasspi.1 dmmulpi mulasspi.2 0npi ndmoprass pm2.61i $.
      $( [21-Sep-1995] $)
  $}

  ${
    distrpi.1 $e |- B e. _V $.
    distrpi.2 $e |- C e. _V $.
    $( Multiplication of positive integers is distributive. $)
    distrpi $p |- ( A .N ( B +N C ) ) = ( ( A .N B ) +N ( A .N C ) ) $=
      cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB cC cpli co cmi co cA cB
      cmi co cA cC cmi co cpli co wceq cA cnpi wcel cB cnpi wcel cC cnpi wcel
      w3a cA cB cC coa co comu co cA cB comu co cA cC comu co coa co cA cB cC
      cpli co cmi co cA cB cmi co cA cC cmi co cpli co cA com wcel cB com wcel
      cC com wcel cA cB cC coa co comu co cA cB comu co cA cC comu co coa co
      wceq cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cB cC nndi cA pinn cB pinn
      cC pinn syl3an cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cB cC cpli co
      cmi co cA cB cC coa co comu co wceq cA cnpi wcel cB cnpi wcel cC cnpi
      wcel wa wa cA cB cC cpli co cmi co cA cB cC cpli co comu co cA cB cC coa
      co comu co cA cnpi wcel cB cC cpli co cnpi wcel cA cB cC cpli co cmi co
      cA cB cC cpli co comu co wceq cB cnpi wcel cC cnpi wcel wa cA cB cC cpli
      co mulpiord cB cC addclpi sylan2 cB cnpi wcel cC cnpi wcel wa cA cB cC
      cpli co comu co cA cB cC coa co comu co wceq cA cnpi wcel cB cnpi wcel cC
      cnpi wcel wa cB cC cpli co cB cC coa co cA comu cB cC addpiord opreq2d
      adantl eqtrd 3impb cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cB cmi co cA
      cC cmi co cpli co cA cB comu co cA cC comu co coa co wceq cA cnpi wcel cB
      cnpi wcel wa cA cnpi wcel cC cnpi wcel wa wa cA cB cmi co cA cC cmi co
      cpli co cA cB cmi co cA cC cmi co coa co cA cB comu co cA cC comu co coa
      co cA cB cmi co cnpi wcel cA cC cmi co cnpi wcel cA cB cmi co cA cC cmi
      co cpli co cA cB cmi co cA cC cmi co coa co wceq cA cnpi wcel cB cnpi
      wcel wa cA cnpi wcel cC cnpi wcel wa cA cB cmi co cA cC cmi co addpiord
      cA cB mulclpi cA cC mulclpi syl2an cA cnpi wcel cB cnpi wcel wa cA cnpi
      wcel cC cnpi wcel wa cA cB cmi co cA cB comu co cA cC cmi co cA cC comu
      co coa cA cB mulpiord cA cC mulpiord opreqan12d eqtrd 3impdi 3eqtr4d cA
      cB cC cnpi cpli cmi distrpi.1 dmaddpi distrpi.2 0npi dmmulpi ndmoprdistr
      pm2.61i $.
      $( [21-Sep-1995] $)
  $}

  ${
    mulcanpi.1 $e |- C e. _V $.
    $( Multiplication cancellation law for positive integers. $)
    mulcanpi $p |- ( ( A e. N. /\ B e. N. ) ->
                   ( ( A .N B ) = ( A .N C ) -> B = C ) ) $=
      cA cnpi wcel cB cnpi wcel wa cA cB cmi co cA cC cmi co wceq cB cC wceq cA
      cnpi wcel cB cnpi wcel wa cA cB cmi co cA cC cmi co wceq wa cB cC wceq cA
      cnpi wcel cB cnpi wcel wa cA cB cmi co cA cC cmi co wceq cA cnpi wcel cB
      cnpi wcel wa cA cB cmi co cA cC cmi co wceq cB cC wceq cA cnpi wcel cB
      cnpi wcel wa cA cB cmi co cA cC cmi co wceq cA cnpi wcel cB cnpi wcel wa
      cA cB cmi co cA cC cmi co wceq cB cC wceq wi cA cnpi wcel cB cnpi wcel wa
      cC cnpi wcel cA cB cmi co cA cC cmi co wceq cB cC wceq wi cA cB cmi co cA
      cC cmi co wceq cA cnpi wcel cB cnpi wcel wa wa cA cnpi wcel cB cnpi wcel
      wa cC cnpi wcel wa cA cB cmi co cA cC cmi co wceq cA cB comu co cA cC
      comu co wceq cB cC wceq cA cnpi wcel cB cnpi wcel wa cC cnpi wcel wa cA
      cB cmi co cA cB comu co cA cC cmi co cA cC comu co cA cnpi wcel cB cnpi
      wcel wa cA cB cmi co cA cB comu co wceq cC cnpi wcel cA cB mulpiord
      adantr cA cnpi wcel cC cnpi wcel cA cC cmi co cA cC comu co wceq cB cnpi
      wcel cA cC mulpiord adantlr eqeq12d cA cnpi wcel cB cnpi wcel cC cnpi
      wcel cA cB comu co cA cC comu co wceq cB cC wceq wi cA cnpi wcel cB cnpi
      wcel cC cnpi wcel cA cB comu co cA cC comu co wceq cB cC wceq wi wi wi cA
      cnpi wcel cB cnpi wcel cC cnpi wcel cA cnpi wcel cA cB comu co cA cC comu
      co wceq cB cC wceq wi cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cnpi wcel
      cA cB comu co cA cC comu co wceq cB cC wceq wi wi cA com wcel cB com wcel
      cC com wcel cA cnpi wcel cA cB comu co cA cC comu co wceq cB cC wceq wi
      wi cA cnpi wcel cB cnpi wcel cC cnpi wcel cA com wcel cB com wcel cC com
      wcel w3a cA cnpi wcel cA cB comu co cA cC comu co wceq cB cC wceq wi cA
      com wcel cB com wcel cC com wcel w3a c0 cA wcel cA cB comu co cA cC comu
      co wceq cB cC wceq wi cA cnpi wcel cA com wcel cB com wcel cC com wcel
      w3a c0 cA wcel wa cA cB comu co cA cC comu co wceq cB cC wceq cA cB cC
      nnmcan biimpd cA cnpi wcel cA com wcel c0 cA wcel cA elni2 pm3.27bi
      sylan2 ex cA pinn cB pinn cC pinn syl3an 3exp com4r pm2.43i imp31 sylbid
      cA cB cmi co cA cC cmi co wceq cA cnpi wcel cB cnpi wcel wa wa cA cC cmi
      co cnpi wcel cA cnpi wcel cC cnpi wcel wa cC cnpi wcel cA cB cmi co cA cC
      cmi co wceq cA cnpi wcel cB cnpi wcel wa cA cC cmi co cnpi wcel cA cB cmi
      co cA cC cmi co wceq cA cB cmi co cnpi wcel cA cC cmi co cnpi wcel cA
      cnpi wcel cB cnpi wcel wa cA cB cmi co cA cC cmi co cnpi eleq1 cA cB
      mulclpi syl5bi imp cA cC cnpi cmi mulcanpi.1 dmmulpi 0npi ndmoprrcl cA
      cnpi wcel cC cnpi wcel pm3.27 3syl sylan2 exp32 imp4b pm2.43i ex $.
      $( [4-Feb-1996] $)
  $}

  ${
    addnidpi.1 $e |- B e. _V $.
    $( There is no identity element for addition on positive integers. $)
    addnidpi $p |- ( A e. N. -> -. ( A +N B ) = A ) $=
      cA cnpi wcel cB cnpi wcel wa cA cnpi wcel cA cB cpli co cA wceq wn wi cA
      cnpi wcel cB cnpi wcel wa cA cB cpli co cA wceq wn cA cnpi wcel cA cnpi
      wcel cB cnpi wcel wa cA cB cpli co cA wceq cA cB coa co cA wceq cA com
      wcel cB cnpi wcel cA cB coa co cA wceq wn cA cnpi wcel cA com wcel cB com
      wcel c0 cB wcel wa cA cB coa co cA wceq wn cB cnpi wcel cA com wcel cB
      com wcel c0 cB wcel cA cB coa co cA wceq wn cB com wcel cA com wcel c0 cB
      wcel cA cB coa co cA wceq wn wi cB com wcel cA com wcel wa c0 cB wcel cA
      c0 coa co cA cB coa co wcel cA cB coa co cA wceq wn c0 cB cA nnaordi cA
      com wcel cA c0 coa co cA cB coa co wcel cA cB coa co cA wceq wn wi cB com
      wcel cA com wcel cA c0 coa co cA cB coa co wcel cA cA cB coa co wcel cA
      cB coa co cA wceq wn cA com wcel cA c0 coa co cA cA cB coa co cA nna0
      eleq1d cA com wcel cA cB coa co cA wceq cA cA cB coa co wcel cA cB coa co
      cA wceq cA cA cB coa co wcel wn cA cA wcel wn cA com wcel cA cB coa co cA
      wceq cA cA cB coa co wcel cA cA wcel cA cB coa co cA cA eleq2 notbid cA
      com wcel cA word cA cA wcel wn cA nnord cA ordirr syl syl5cbir con2d
      sylbid adantl syld expcom imp32 cB elni2 sylan2b cA pinn sylan cA cnpi
      wcel cB cnpi wcel wa cA cB cpli co cA cB coa co cA cA cB addpiord eqeq1d
      mtbird a1d cA cnpi wcel cB cnpi wcel wa wn cA cB cpli co cA wceq cA cnpi
      wcel cA cnpi wcel cB cnpi wcel wa wn cA cB cpli co cA wceq c0 cA wceq cA
      cnpi wcel wn cA cnpi wcel cB cnpi wcel wa wn cA cB cpli co c0 cA cA cB
      cnpi cpli addnidpi.1 dmaddpi ndmopr eqeq1d c0 cA wceq c0 cnpi wcel cA
      cnpi wcel 0npi c0 cA cnpi eleq1 mtbii syl6bi con2d pm2.61i $.
      $( [28-Nov-1995] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( Ordering on positive integers in terms of existence of sum. $)
    ltexpi $p |- ( ( A e. N. /\ B e. N. ) ->
               ( A <N B <-> E. x ( x e. N. /\ ( A +N x ) = B ) ) ) $=
      cA cnpi wcel cB cnpi wcel wa cA cB wcel vx cv com wcel c0 vx cv wcel cA
      vx cv coa co cB wceq wa wa vx wex cA cB clti wbr vx cv cnpi wcel cA vx cv
      cpli co cB wceq wa vx wex cA com wcel cB com wcel cA cB wcel vx cv com
      wcel c0 vx cv wcel cA vx cv coa co cB wceq wa wa vx wex wb cA cnpi wcel
      cB cnpi wcel cA com wcel cB com wcel wa cA cB wcel c0 vx cv wcel cA vx cv
      coa co cB wceq wa vx com wrex vx cv com wcel c0 vx cv wcel cA vx cv coa
      co cB wceq wa wa vx wex vx cA cB nnaordex c0 vx cv wcel cA vx cv coa co
      cB wceq wa vx com df-rex syl6bb cA pinn cB pinn syl2an cA cB ltpiord cA
      cnpi wcel vx cv cnpi wcel cA vx cv cpli co cB wceq wa vx wex vx cv com
      wcel c0 vx cv wcel cA vx cv coa co cB wceq wa wa vx wex wb cB cnpi wcel
      cA cnpi wcel vx cv cnpi wcel cA vx cv cpli co cB wceq wa vx cv com wcel
      c0 vx cv wcel cA vx cv coa co cB wceq wa wa vx cA cnpi wcel vx cv cnpi
      wcel cA vx cv cpli co cB wceq wa vx cv cnpi wcel cA vx cv coa co cB wceq
      wa vx cv com wcel c0 vx cv wcel cA vx cv coa co cB wceq wa wa cA cnpi
      wcel vx cv cnpi wcel cA vx cv cpli co cB wceq cA vx cv coa co cB wceq cA
      cnpi wcel vx cv cnpi wcel wa cA vx cv cpli co cA vx cv coa co cB cA vx cv
      addpiord eqeq1d pm5.32da vx cv cnpi wcel cA vx cv coa co cB wceq wa vx cv
      com wcel c0 vx cv wcel wa cA vx cv coa co cB wceq wa vx cv com wcel c0 vx
      cv wcel cA vx cv coa co cB wceq wa wa vx cv cnpi wcel vx cv com wcel c0
      vx cv wcel wa cA vx cv coa co cB wceq vx cv elni2 anbi1i vx cv com wcel
      c0 vx cv wcel cA vx cv coa co cB wceq anass bitri syl6bb exbidv adantr
      3bitr4d $.
      $( [15-Mar-1996] $)
  $}

  ${
    ltapi.1 $e |- A e. _V $.
    ltapi.2 $e |- B e. _V $.
    $( Ordering property of addition for positive integers. $)
    ltapi $p |- ( C e. N. -> ( A <N B <-> ( C +N A ) <N ( C +N B ) ) ) $=
      cA cB cC clti cnpi cpli ltapi.2 dmaddpi ltapi.1 ltrelpi 0npi cA cnpi wcel
      cB cnpi wcel cC cnpi wcel cA cB clti wbr cC cA cpli co cC cB cpli co clti
      wbr wb cA cnpi wcel cB cnpi wcel wa cC cnpi wcel wa cA cB wcel cC cA coa
      co cC cB coa co wcel cA cB clti wbr cC cA cpli co cC cB cpli co clti wbr
      cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cB wcel cC cA coa co cC cB coa
      co wcel wb cA com wcel cB com wcel cC com wcel cA cB wcel cC cA coa co cC
      cB coa co wcel wb cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cB cC nnaord
      cA pinn cB pinn cC pinn syl3an 3expa cA cnpi wcel cB cnpi wcel wa cA cB
      clti wbr cA cB wcel wb cC cnpi wcel cA cB ltpiord adantr cC cnpi wcel cA
      cnpi wcel cB cnpi wcel wa cC cA cpli co cC cB cpli co clti wbr cC cA coa
      co cC cB coa co wcel wb cC cnpi wcel cA cnpi wcel cB cnpi wcel cC cA cpli
      co cC cB cpli co clti wbr cC cA coa co cC cB coa co wcel wb cC cnpi wcel
      cA cnpi wcel wa cC cnpi wcel cB cnpi wcel wa wa cC cA cpli co cC cB cpli
      co clti wbr cC cA cpli co cC cB cpli co wcel cC cA coa co cC cB coa co
      wcel cC cA cpli co cnpi wcel cC cB cpli co cnpi wcel cC cA cpli co cC cB
      cpli co clti wbr cC cA cpli co cC cB cpli co wcel wb cC cnpi wcel cA cnpi
      wcel wa cC cnpi wcel cB cnpi wcel wa cC cA cpli co cC cB cpli co ltpiord
      cC cA addclpi cC cB addclpi syl2an cC cnpi wcel cA cnpi wcel wa cC cnpi
      wcel cB cnpi wcel wa wa cC cA cpli co cC cA coa co cC cB cpli co cC cB
      coa co cC cnpi wcel cA cnpi wcel wa cC cA cpli co cC cA coa co wceq cC
      cnpi wcel cB cnpi wcel wa cC cA addpiord adantr cC cnpi wcel cB cnpi wcel
      wa cC cB cpli co cC cB coa co wceq cC cnpi wcel cA cnpi wcel wa cC cB
      addpiord adantl eleq12d bitrd anandis ancoms 3bitr4d 3impa ndmord $.
      $( [7-Mar-1996] $)
  $}

  ${
    ltmpi.1 $e |- A e. _V $.
    ltmpi.2 $e |- B e. _V $.
    $( Ordering property of multiplication for positive integers. $)
    ltmpi $p |- ( C e. N. -> ( A <N B <-> ( C .N A ) <N ( C .N B ) ) ) $=
      cA cB cC clti cnpi cmi ltmpi.2 dmmulpi ltmpi.1 ltrelpi 0npi cA cnpi wcel
      cB cnpi wcel cC cnpi wcel cA cB clti wbr cC cA cmi co cC cB cmi co clti
      wbr wb cA cnpi wcel cB cnpi wcel wa cC cnpi wcel wa cA cB wcel cC cA comu
      co cC cB comu co wcel cA cB clti wbr cC cA cmi co cC cB cmi co clti wbr
      cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cA cB wcel cC cA comu co cC cB
      comu co wcel wb cA com wcel cB com wcel cC cnpi wcel cA cB wcel cC cA
      comu co cC cB comu co wcel wb wi cA cnpi wcel cB cnpi wcel cA com wcel cB
      com wcel wa cC com wcel c0 cC wcel wa cA cB wcel cC cA comu co cC cB comu
      co wcel wb cC cnpi wcel cA com wcel cB com wcel cC com wcel c0 cC wcel cA
      cB wcel cC cA comu co cC cB comu co wcel wb cA com wcel cB com wcel cC
      com wcel c0 cC wcel cA cB wcel cC cA comu co cC cB comu co wcel wb c0 cC
      wcel cA cB wcel cA cB wcel c0 cC wcel wa cA com wcel cB com wcel cC com
      wcel w3a cC cA comu co cC cB comu co wcel c0 cC wcel cA cB wcel iba cA cB
      cC nnmord sylan9bbr 3exp1 imp4b cC elni2 syl5ib cA pinn cB pinn syl2an
      imp cA cnpi wcel cB cnpi wcel wa cA cB clti wbr cA cB wcel wb cC cnpi
      wcel cA cB ltpiord adantr cC cnpi wcel cA cnpi wcel cB cnpi wcel wa cC cA
      cmi co cC cB cmi co clti wbr cC cA comu co cC cB comu co wcel wb cC cnpi
      wcel cA cnpi wcel cB cnpi wcel cC cA cmi co cC cB cmi co clti wbr cC cA
      comu co cC cB comu co wcel wb cC cnpi wcel cA cnpi wcel wa cC cnpi wcel
      cB cnpi wcel wa wa cC cA cmi co cC cB cmi co clti wbr cC cA cmi co cC cB
      cmi co wcel cC cA comu co cC cB comu co wcel cC cA cmi co cnpi wcel cC cB
      cmi co cnpi wcel cC cA cmi co cC cB cmi co clti wbr cC cA cmi co cC cB
      cmi co wcel wb cC cnpi wcel cA cnpi wcel wa cC cnpi wcel cB cnpi wcel wa
      cC cA cmi co cC cB cmi co ltpiord cC cA mulclpi cC cB mulclpi syl2an cC
      cnpi wcel cA cnpi wcel wa cC cnpi wcel cB cnpi wcel wa wa cC cA cmi co cC
      cA comu co cC cB cmi co cC cB comu co cC cnpi wcel cA cnpi wcel wa cC cA
      cmi co cC cA comu co wceq cC cnpi wcel cB cnpi wcel wa cC cA mulpiord
      adantr cC cnpi wcel cB cnpi wcel wa cC cB cmi co cC cB comu co wceq cC
      cnpi wcel cA cnpi wcel wa cC cB mulpiord adantl eleq12d bitrd anandis
      ancoms 3bitr4d 3impa ndmord $.
      $( [8-Feb-1996] $)
  $}

  $( One is less than two (one plus one). $)
  1lt2pi $p |- 1o <N ( 1o +N 1o ) $=
    c1o c1o c1o cpli co clti wbr c1o c1o c1o cpli co wcel c1o c1o c1o coa co
    c1o c1o cpli co c1o c0 coa co c1o c1o c1o coa co c1o com wcel c1o c0 coa co
    c1o wceq 1onn c1o nna0 ax-mp c0 c1o wcel c1o c0 coa co c1o c1o coa co wcel
    0lt1o c0 com wcel c1o com wcel c1o com wcel c0 c1o wcel c1o c0 coa co c1o
    c1o coa co wcel wb peano1 1onn 1onn c0 c1o c1o nnaord mp3an mpbi eqeltrri
    c1o cnpi wcel c1o cnpi wcel c1o c1o cpli co c1o c1o coa co wceq 1pi 1pi c1o
    c1o addpiord mp2an eleqtrri c1o cnpi wcel c1o c1o cpli co cnpi wcel c1o c1o
    c1o cpli co clti wbr c1o c1o c1o cpli co wcel wb 1pi c1o cnpi wcel c1o cnpi
    wcel c1o c1o cpli co cnpi wcel 1pi 1pi c1o c1o addclpi mp2an c1o c1o c1o
    cpli co ltpiord mp2an mpbir $.
    $( [13-Mar-1996] $)

  $( No positive integer is less than one. $)
  nlt1pi $p |- -. A <N 1o $=
    cA cnpi wcel cA c1o clti wbr wn cA cnpi wcel cA c0 wne cA c1o clti wbr wn
    cA cnpi wcel cA com wcel cA c0 wne cA elni pm3.27bi cA cnpi wcel cA c1o
    clti wbr cA c0 cA cnpi wcel cA c1o clti wbr cA c0 wceq cA cnpi wcel cA c1o
    clti wbr wa cA c0 wcel wn cA c0 wceq cA noel cA cnpi wcel cA c1o clti wbr
    wa cA c0 wcel cA c0 wceq cA cnpi wcel cA c1o clti wbr cA c0 wcel cA c0 wceq
    wo cA cnpi wcel cA c1o clti wbr cA c1o wcel cA c0 wcel cA c0 wceq wo cA
    cnpi wcel c1o cnpi wcel cA c1o clti wbr cA c1o wcel wb 1pi cA c1o ltpiord
    mpan2 cA cnpi wcel cA c0 csuc wcel cA c0 wcel cA c0 wceq wo cA c1o wcel cA
    c0 cnpi elsucg c1o c0 csuc cA df-1o eleq2i syl5bb bitrd biimpa ord mpi ex
    necon3ad mpd cA c1o clti wbr cA cnpi wcel cA c1o clti wbr cA cnpi wcel c1o
    cnpi wcel cA c1o cnpi cnpi clti c1o cnpi 1pi elisseti ltrelpi brel pm3.26d
    con3i pm2.61i $.
    $( [23-Mar-1996] $)

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    indpi.1 $e |- ( x = 1o -> ( ph <-> ps ) ) $.
    indpi.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    indpi.3 $e |- ( x = ( y +N 1o ) -> ( ph <-> th ) ) $.
    indpi.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    indpi.5 $e |- ps $.
    $( Induction hypothesis. $)
    indpi.6 $e |- ( y e. N. -> ( ch -> th ) ) $.
    $( Principle of Finite Induction on positive integers. $)
    indpi $p |- ( A e. N. -> ta ) $=
      cA cnpi wcel cA c1o wceq c1o cA clti wbr wo wta cA cnpi wcel cA c1o wceq
      c1o cA clti wbr wo wn wn cA c1o wceq c1o cA clti wbr wo cA cnpi wcel cA
      c1o clti wbr cA c1o wceq c1o cA clti wbr wo wn cA nlt1pi cA cnpi wcel c1o
      cnpi wcel cA c1o clti wbr cA c1o wceq c1o cA clti wbr wo wn wb 1pi cnpi
      clti wor cA cnpi wcel c1o cnpi wcel wa cA c1o clti wbr cA c1o wceq c1o cA
      clti wbr wo wn wb ltsopi cnpi cA c1o clti sotric mpan mpan2 mtbii cA c1o
      wceq c1o cA clti wbr wo notnot2 syl cA cnpi wcel cA c1o wceq wta c1o cA
      clti wbr cA c1o wceq wta wi cA cnpi wcel wta c1o cA wph wta vx cv c1o
      wceq c1o cA wceq vx vx cv cA vx c1o cA c1o cnpi 1pi elisseti eqvinc
      indpi.4 vx cv c1o wceq wph wps indpi.5 indpi.1 mpbiri gencl eqcoms a1i cA
      cnpi wcel c1o cA clti wbr wta wi cA cnpi wcel cA cnpi wcel c1o cA clti
      wbr wta cA com wcel c1o cA wss cA cnpi wcel c1o cA clti wbr wa wta wi cA
      cnpi wcel cA com wcel c1o com wcel c1o cA wss cA cnpi wcel c1o cA clti
      wbr wa wta wi 1onn vx cv cnpi wcel c1o vx cv clti wbr wa wph wi c1o cnpi
      wcel c1o c1o clti wbr wa wps wi vy cv cnpi wcel c1o vy cv clti wbr wa wch
      wi vy cv cnpi wcel c1o vy cv csuc clti wbr wa wth wi cA cnpi wcel c1o cA
      clti wbr wa wta wi vx vy cA c1o vx cv c1o wceq vx cv cnpi wcel c1o vx cv
      clti wbr wa c1o cnpi wcel c1o c1o clti wbr wa wph wps vx cv c1o wceq vx
      cv cnpi wcel c1o cnpi wcel c1o vx cv clti wbr c1o c1o clti wbr vx cv c1o
      cnpi eleq1 vx cv c1o c1o clti breq2 anbi12d indpi.1 imbi12d vx cv vy cv
      wceq vx cv cnpi wcel c1o vx cv clti wbr wa vy cv cnpi wcel c1o vy cv clti
      wbr wa wph wch vx cv vy cv wceq vx cv cnpi wcel vy cv cnpi wcel c1o vx cv
      clti wbr c1o vy cv clti wbr vx cv vy cv cnpi eleq1 vx cv vy cv c1o clti
      breq2 anbi12d indpi.2 imbi12d vx cv vy cv csuc wceq vx cv cnpi wcel c1o
      vx cv clti wbr wa wph wi vy cv cnpi wcel c1o vy cv csuc clti wbr wa wph
      wi vy cv cnpi wcel c1o vy cv csuc clti wbr wa wth wi vx cv vy cv csuc
      wceq vx cv cnpi wcel c1o vx cv clti wbr wa vy cv cnpi wcel c1o vy cv csuc
      clti wbr wa wph vx cv vy cv csuc wceq vx cv cnpi wcel c1o vx cv clti wbr
      wa vy cv cnpi wcel c1o vy cv csuc clti wbr wa vx cv vy cv csuc wceq vx cv
      cnpi wcel c1o vx cv clti wbr wa vy cv cnpi wcel c1o vy cv csuc clti wbr
      vx cv vy cv csuc wceq vx cv cnpi wcel c1o vx cv clti wbr wa vy cv com
      wcel vy cv c0 wne wa vy cv cnpi wcel vx cv vy cv csuc wceq vx cv cnpi
      wcel c1o vx cv clti wbr wa vy cv com wcel vy cv c0 wne vx cv vy cv csuc
      wceq vx cv cnpi wcel vy cv com wcel c1o vx cv clti wbr vx cv vy cv csuc
      wceq vx cv com wcel vy cv com wcel vx cv cnpi wcel vx cv vy cv csuc wceq
      vx cv com wcel vy cv csuc com wcel vy cv com wcel vx cv vy cv csuc com
      eleq1 vy cv peano2b syl6bbr vx cv pinn syl5bi adantrd vx cv vy cv csuc
      wceq c1o vx cv wcel vy cv c0 wne vx cv cnpi wcel c1o vx cv clti wbr wa vx
      cv vy cv csuc wceq c1o vx cv wcel c1o vy cv csuc wcel vy cv c0 wne vx cv
      vy cv csuc c1o eleq2 c1o vy cv csuc wcel c1o vy cv wcel c1o vy cv wceq wo
      vy cv c0 wne c1o vy cv elsuci c1o vy cv wcel vy cv c0 wne c1o vy cv wceq
      vy cv c1o ne0i c1o vy cv wceq c0 vy cv wcel vy cv c0 wne c1o vy cv wceq
      c0 c1o wcel c0 vy cv wcel 0lt1o c1o vy cv c0 eleq2 mpbii vy cv c0 ne0i
      syl jaoi syl syl6bi vx cv cnpi wcel c1o vx cv clti wbr c1o vx cv wcel c1o
      cnpi wcel vx cv cnpi wcel c1o vx cv clti wbr c1o vx cv wcel wb 1pi c1o vx
      cv ltpiord mpan biimpa syl5 jcad vy cv elni syl6ibr vx cv vy cv csuc wceq
      c1o vx cv clti wbr c1o vy cv csuc clti wbr vx cv cnpi wcel c1o vx cv clti
      wbr wa vx cv vy cv csuc c1o clti breq2 vx cv cnpi wcel c1o vx cv clti wbr
      pm3.27 syl5bi jcad vx cv vy cv csuc wceq vy cv cnpi wcel vx cv cnpi wcel
      c1o vy cv csuc clti wbr c1o vx cv clti wbr vx cv vy cv csuc wceq vy cv
      cnpi wcel vx cv cnpi wcel vx cv vy cv csuc wceq vy cv cnpi wcel vy cv
      cnpi wcel vx cv cnpi wcel wi vx cv vy cv csuc wceq vy cv cnpi wcel wa vx
      cv cnpi wcel vy cv c1o cpli co cnpi wcel vy cv cnpi wcel vx cv vy cv csuc
      wceq vy cv cnpi wcel wa vx cv vy cv c1o cpli co cnpi vy cv cnpi wcel vx
      cv vy cv c1o cpli co wceq vx cv vy cv csuc wceq vy cv cnpi wcel vy cv c1o
      cpli co vy cv csuc vx cv vy cv cnpi wcel vy cv c1o cpli co vy cv c1o coa
      co vy cv csuc vy cv cnpi wcel c1o cnpi wcel vy cv c1o cpli co vy cv c1o
      coa co wceq 1pi vy cv c1o addpiord mpan2 vy cv cnpi wcel vy cv con0 wcel
      vy cv c1o coa co vy cv csuc wceq vy cv pion vy cv oa1suc syl eqtrd eqeq2d
      biimparc eleq1d vy cv cnpi wcel c1o cnpi wcel vy cv c1o cpli co cnpi wcel
      1pi vy cv c1o addclpi mpan2 syl5bir ex pm2.43d vx cv vy cv csuc wceq c1o
      vx cv clti wbr c1o vy cv csuc clti wbr vx cv vy cv csuc c1o clti breq2
      biimprd anim12d impbid imbi1d vx cv vy cv csuc wceq vy cv cnpi wcel c1o
      vy cv csuc clti wbr wa wph wth vy cv cnpi wcel c1o vy cv csuc clti wbr wa
      vx cv vy cv csuc wceq wph wth wb vy cv cnpi wcel vx cv vy cv csuc wceq
      wph wth wb wi c1o vy cv csuc clti wbr vy cv cnpi wcel vx cv vy cv csuc
      wceq vx cv vy cv c1o cpli co wceq wph wth wb vy cv cnpi wcel vy cv c1o
      cpli co vy cv csuc vx cv vy cv cnpi wcel vy cv c1o cpli co vy cv c1o coa
      co vy cv csuc vy cv cnpi wcel c1o cnpi wcel vy cv c1o cpli co vy cv c1o
      coa co wceq 1pi vy cv c1o addpiord mpan2 vy cv cnpi wcel vy cv con0 wcel
      vy cv c1o coa co vy cv csuc wceq vy cv pion vy cv oa1suc syl eqtrd eqeq2d
      indpi.3 syl6bir adantr com12 pm5.74d bitrd vx cv cA wceq vx cv cnpi wcel
      c1o vx cv clti wbr wa cA cnpi wcel c1o cA clti wbr wa wph wta vx cv cA
      wceq vx cv cnpi wcel cA cnpi wcel c1o vx cv clti wbr c1o cA clti wbr vx
      cv cA cnpi eleq1 vx cv cA c1o clti breq2 anbi12d indpi.4 imbi12d c1o com
      wcel c1o cnpi wcel c1o c1o clti wbr wa wps indpi.5 a1i12 vy cv com wcel
      c1o vy cv wss vy cv cnpi wcel c1o vy cv clti wbr wa wch wi vy cv cnpi
      wcel c1o vy cv csuc clti wbr wa wth wi wi c1o com wcel vy cv cnpi wcel
      c1o vy cv clti wbr wa wch wi vy cv cnpi wcel c1o vy cv csuc clti wbr wa
      wch vy cv com wcel c1o vy cv wss wa wth vy cv cnpi wcel c1o vy cv clti
      wbr wa wch wi vy cv cnpi wcel c1o vy cv csuc clti wbr wch vy cv cnpi wcel
      vy cv cnpi wcel c1o vy cv clti wbr wa wch wi c1o vy cv wcel wch wi c1o vy
      cv csuc clti wbr wch wi vy cv cnpi wcel c1o vy cv wcel vy cv cnpi wcel
      c1o vy cv clti wbr wa wch vy cv cnpi wcel c1o vy cv wcel vy cv cnpi wcel
      c1o vy cv wcel wa vy cv cnpi wcel c1o vy cv clti wbr wa vy cv cnpi wcel
      c1o vy cv wcel pm3.2 vy cv cnpi wcel c1o vy cv clti wbr c1o vy cv wcel
      c1o cnpi wcel vy cv cnpi wcel c1o vy cv clti wbr c1o vy cv wcel wb 1pi
      c1o vy cv ltpiord mpan pm5.32i syl6ibr imim1d c1o vy cv wcel wch wi c1o
      vy cv csuc wcel wch c1o vy cv csuc clti wbr c1o vy cv wcel wch wi c1o vy
      cv wcel c1o vy cv wceq wo wch c1o vy cv csuc wcel c1o vy cv wcel wch wi
      c1o vy cv wceq wch wi c1o vy cv wcel c1o vy cv wceq wo wch wi wph wch vx
      cv c1o wceq c1o vy cv wceq vx vx cv vy cv vx c1o vy cv c1o cnpi 1pi
      elisseti eqvinc indpi.2 vx cv c1o wceq wph wps indpi.5 indpi.1 mpbiri
      gencl c1o vy cv wcel wch c1o vy cv wceq jao mpi c1o vy cv elsuci syl5 c1o
      vy cv csuc clti wbr c1o vy cv csuc wcel c1o vy cv csuc clti wbr c1o cnpi
      wcel vy cv csuc cnpi wcel wa c1o vy cv csuc clti wbr c1o vy cv csuc wcel
      wb c1o vy cv csuc cnpi cnpi clti vy cv vy visset sucex ltrelpi brel c1o
      vy cv csuc ltpiord syl ibi syl5 syl6com imp3a vy cv com wcel c0 vy cv
      wcel wch wth wi c1o vy cv wss vy cv com wcel c0 vy cv wcel wa vy cv cnpi
      wcel wch wth wi vy cv elni2 indpi.6 sylbir c1o vy cv wss c0 csuc vy cv
      wss c0 vy cv wcel c1o c0 csuc vy cv df-1o sseq1i c0 cvv wcel c0 csuc vy
      cv wss c0 vy cv wcel wi 0ex c0 vy cv cvv sucssel ax-mp sylbi sylan2 syl9r
      adantlr findsg mpanl2 cA pinn cA cnpi wcel cA com wcel c0 cA wcel wa c1o
      cA wss cA elni2 cA com wcel c0 cA wcel c1o cA wss cA com wcel c0 cA wcel
      c0 csuc cA wss c1o cA wss cA com wcel cA word c0 cA wcel c0 csuc cA wss
      wi cA nnord c0 cA ordsucss syl c1o c0 csuc cA df-1o sseq1i syl6ibr imp
      sylbi sylanc exp3a pm2.43i jaod mpd $.
      $( [23-Mar-1996] $)
  $}

  ${
    $d x y z w v u f $.

    $( Define pre-addition on positive fractions.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended to
       be used only by the construction.  This "pre-addition" operation works
       works directly with ordered pairs of integers.  The actual positive
       fraction addition ` +Q ` ( ~ df-plq ) works with the equivalence classes
       of these ordered pairs determined by the equivalence relation ` ~Q `
       ( ~ df-enq ).  (Analogous remarks apply to the other "pre-" operations
       in the complex number construction that follows.)  From Proposition
       9-2.3 of [Gleason] p. 117. $)
    df-plpq $a |- +pQ = { <. <. x , y >. , z >. | ( ( x e. ( N. X. N. ) /\
         y e. ( N. X. N. ) ) /\ E. w E. v E. u E. f ( ( x = <. w , v >. /\
         y = <. u , f >. ) /\ z = <. ( ( w .N f ) +N ( v .N u ) ) ,
           ( v .N f ) >. ) ) } $.

    $( Define pre-multiplication on positive fractions.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-2.4 of
       [Gleason] p. 119. $)
    df-mpq $a |- .pQ = { <. <. x , y >. , z >. | ( ( x e. ( N. X. N. ) /\
         y e. ( N. X. N. ) ) /\ E. w E. v E. u E. f ( ( x = <. w , v >. /\
         y = <. u , f >. ) /\ z = <. ( w .N u ) , ( v .N f ) >. ) ) } $.

    $( Define equivalence relation for positive fractions.  This is a
       "temporary" set used in the construction of complex numbers ~ df-c ,
       and is intended to be used only by the construction.  From Proposition
       9-2.1 of [Gleason] p. 117. $)
    df-enq $a |- ~Q = { <. x , y >. | ( ( x e. ( N. X. N. ) /\
                   y e. ( N. X. N. ) ) /\ E. z E. w E. v E. u
                   ( ( x = <. z , w >. /\ y = <. v , u >. ) /\
                   ( z .N u ) = ( w .N v ) ) ) } $.

    $( Define class of positive fractions.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-2.2 of
       [Gleason] p. 117. $)
    df-nq $a |- Q. = ( ( N. X. N. ) /. ~Q ) $.

    $( Define addition on positive fractions.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-2.3
       of [Gleason] p. 117. $)
    df-plq $a |- +Q = { <. <. x , y >. , z >. | ( ( x e. Q. /\ y e. Q. ) /\
      E. w E. v E. u E. f (
         ( x = [ <. w , v >. ] ~Q /\ y = [ <. u , f >. ] ~Q ) /\
               z = [ ( <. w , v >. +pQ <. u , f >. ) ] ~Q ) ) } $.

    $( Define multiplication on positive fractions.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-2.4
       of [Gleason] p. 119. $)
    df-mq $a |- .Q = { <. <. x , y >. , z >. | ( ( x e. Q. /\ y e. Q. ) /\
      E. w E. v E. u E. f (
         ( x = [ <. w , v >. ] ~Q /\ y = [ <. u , f >. ] ~Q ) /\
               z = [ ( <. w , v >. .pQ <. u , f >. ) ] ~Q ) ) } $.

    $( Define reciprocal on positive fractions.  It means the same thing as
       one divided by the argument (although we don't define full division
       since we will never need it).  This is a "temporary" set used in the
       construction of complex numbers ~ df-c , and is intended to be used only
       by the construction.  From Proposition 9-2.5 of [Gleason] p. 119, who
       uses an asterisk to denote this unary operation. $)
    df-rq $a |- *Q = { <. x , y >. | ( x e. Q. /\ ( x .Q y ) = 1Q ) } $.

    $( Define ordering relation on positive fractions.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  Similar to Definition 5 of
       [Suppes] p. 162. $)
    df-ltq $a |- <Q = { <. x , y >. | ( ( x e. Q. /\ y e. Q. ) /\
       E. z E. w E. v E. u
       ( ( x = [ <. z , w >. ] ~Q /\ y = [ <. v , u >. ] ~Q ) /\
                ( z .N u ) <N ( w .N v ) ) ) } $.

    $( Define positive fraction constant 1.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-2.2 of
       [Gleason] p. 117. $)
    df-1q $a |- 1Q = [ <. 1o , 1o >. ] ~Q $.

  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.
    $( Equivalence relation for positive fractions in terms of positive
       integers. $)
    enqbreq $p |- ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. ) ) ->
          ( <. A , B >. ~Q <. C , D >. <-> ( A .N D ) = ( B .N C ) ) ) $=
      vx vy vz vw vv vu cA cB cC cD ceq cnpi cmi vx vy vz vw vv vu df-enq
      ecopopreq $.
      $( [27-Aug-1995] $)
  $}

  ${
    $d x y z w v u $.
    $( Domain of equivalence relation for positive fractions. $)
    dmenq $p |- dom ~Q = ( N. X. N. ) $=
      vx vy vz vw vv vu ceq cnpi cmi vx vy vz vw vv vu df-enq vx cv vy cv vx
      visset vy visset mulcompi ecopoprdm $.
      $( [27-Aug-1995] $)
  $}

  ${
    $d x y z w v u $.
    $( The equivalence relation for positive fractions is an equivalence
       relation.  Proposition 9-2.1 of [Gleason] p. 117. $)
    enqer $p |- Er ~Q $=
      vx vy vz vw vv vu ceq cnpi cmi vx vy vz vw vv vu df-enq vx cv vy cv vx
      visset vy visset mulcompi vx cv vy cv mulclpi vx cv vy cv vz cv vy visset
      vz visset mulasspi vx cv vy cv vz cv vz visset mulcanpi ecopoprer $.
      $( [27-Aug-1995] $)
  $}

  $( Equivalence class equality of positive fractions in terms of positive
     integers. $)
  enqeceq $p |- ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. ) ) ->
                ( [ <. A , B >. ] ~Q = [ <. C , D >. ] ~Q <->
                ( A .N D ) = ( B .N C ) ) ) $=
    cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa cA cB cop ceq
    cec cC cD cop ceq cec wceq cA cB cop cC cD cop ceq wbr cA cD cmi co cB cC
    cmi co wceq cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa cA
    cnpi wcel cB cnpi wcel wa cA cB cop ceq cdm wcel cA cB cop ceq cec cC cD
    cop ceq cec wceq cA cB cop cC cD cop ceq wbr wb cA cnpi wcel cB cnpi wcel
    wa cC cnpi wcel cD cnpi wcel wa pm3.26 cA cnpi wcel cB cnpi wcel wa cA cB
    cop cnpi cnpi cxp ceq cdm cA cB cnpi cnpi opelxpi dmenq syl6eleqr cA cB cop
    cC cD cop ceq cC cD opex enqer erthdm 3syl cA cB cC cD enqbreq bitrd $.
    $( [29-Nov-1995] $)

  ${
    $d x y z w v u $.
    $( The equivalence relation for positive fractions exists. $)
    enqex $p |- ~Q e. _V $=
      ceq cnpi cnpi cxp cnpi cnpi cxp cxp cnpi cnpi cxp cnpi cnpi cxp cnpi cnpi
      niex niex xpex cnpi cnpi niex niex xpex xpex ceq vx cv cnpi cnpi cxp wcel
      vy cv cnpi cnpi cxp wcel wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv
      cop wceq wa vz cv vu cv cmi co vw cv vv cv cmi co wceq wa vu wex vv wex
      vw wex vz wex wa vx vy copab cnpi cnpi cxp cnpi cnpi cxp cxp vx vy vz vw
      vv vu df-enq vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz
      cv vu cv cmi co vw cv vv cv cmi co wceq wa vu wex vv wex vw wex vz wex vx
      vy cnpi cnpi cxp cnpi cnpi cxp opabssxp eqsstri ssexi $.
      $( [3-Sep-1995] $)
  $}

  $( The class of positive fractions exists. $)
  nqex $p |- Q. e. _V $=
    cnq cnpi cnpi cxp ceq cqs cvv df-nq cnpi cnpi cxp ceq cnpi cnpi niex niex
    xpex qsex eqeltri $.
    $( [16-Aug-1995] $)

  $( The empty set is not a positive fraction. $)
  0npq $p |- -. (/) e. Q. $=
    c0 cnq wcel c0 cnpi cnpi cxp ceq cqs wcel cnpi cnpi cxp ceq dmenq 0nelqs
    cnq cnpi cnpi cxp ceq cqs c0 df-nq eleq2i mtbir $.
    $( [24-Aug-1995] $)

  ${
    $d x y z w v u $.
    $( Positive fraction 'less than' is a relation on positive fractions. $)
    ltrelpq $p |- <Q C_ ( Q. X. Q. ) $=
      cltq vx cv cnq wcel vy cv cnq wcel wa vx cv vz cv vw cv cop ceq cec wceq
      vy cv vv cv vu cv cop ceq cec wceq wa vz cv vu cv cmi co vw cv vv cv cmi
      co clti wbr wa vu wex vv wex vw wex vz wex wa vx vy copab cnq cnq cxp vx
      vy vz vw vv vu df-ltq vx cv vz cv vw cv cop ceq cec wceq vy cv vv cv vu
      cv cop ceq cec wceq wa vz cv vu cv cmi co vw cv vv cv cmi co clti wbr wa
      vu wex vv wex vw wex vz wex vx vy cnq cnq opabssxp eqsstri $.
      $( [14-Feb-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d x y z F $.
    $d x y z G $.  $d x y z R $.  $d x y z S $.

    $( (We do not bother to eliminate these redundant hypotheses.) $)
    cmpblnq.1 $e |- A e. _V $.
    cmpblnq.2 $e |- B e. _V $.
    cmpblnq.3 $e |- C e. _V $.
    cmpblnq.4 $e |- D e. _V $.
    cmpblnq.5 $e |- F e. _V $.
    cmpblnq.6 $e |- G e. _V $.
    cmpblnq.7 $e |- R e. _V $.
    cmpblnq.8 $e |- S e. _V $.

    $( Lemma showing compatibility of addition. $)
    addcmpblnq $p |- ( ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. )
             ) /\ ( ( F e. N. /\ G e. N. ) /\ ( R e. N. /\ S e. N. ) ) ) ->
                ( ( ( A .N D ) = ( B .N C ) /\ ( F .N S ) = ( G .N R ) ) ->
                 <. ( ( A .N G ) +N ( B .N F ) ) , ( B .N G ) >. ~Q
                 <. ( ( C .N S ) +N ( D .N R ) ) , ( D .N S ) >. ) ) $=
      cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa cF cnpi wcel
      cG cnpi wcel wa cR cnpi wcel cS cnpi wcel wa wa wa cA cG cmi co cB cF cmi
      co cpli co cB cG cmi co cop cC cS cmi co cD cR cmi co cpli co cD cS cmi
      co cop ceq wbr cA cG cmi co cB cF cmi co cpli co cD cS cmi co cmi co cB
      cG cmi co cC cS cmi co cD cR cmi co cpli co cmi co wceq cA cD cmi co cB
      cC cmi co wceq cF cS cmi co cG cR cmi co wceq wa cA cnpi wcel cB cnpi
      wcel wa cC cnpi wcel cD cnpi wcel wa wa cF cnpi wcel cG cnpi wcel wa cR
      cnpi wcel cS cnpi wcel wa wa wa cA cG cmi co cB cF cmi co cpli co cnpi
      wcel cB cG cmi co cnpi wcel wa cC cS cmi co cD cR cmi co cpli co cnpi
      wcel cD cS cmi co cnpi wcel wa wa cA cG cmi co cB cF cmi co cpli co cB cG
      cmi co cop cC cS cmi co cD cR cmi co cpli co cD cS cmi co cop ceq wbr cA
      cG cmi co cB cF cmi co cpli co cD cS cmi co cmi co cB cG cmi co cC cS cmi
      co cD cR cmi co cpli co cmi co wceq wb cA cnpi wcel cB cnpi wcel wa cF
      cnpi wcel cG cnpi wcel wa cC cnpi wcel cD cnpi wcel wa cR cnpi wcel cS
      cnpi wcel wa cA cG cmi co cB cF cmi co cpli co cnpi wcel cB cG cmi co
      cnpi wcel wa cC cS cmi co cD cR cmi co cpli co cnpi wcel cD cS cmi co
      cnpi wcel wa wa cA cnpi wcel cB cnpi wcel wa cF cnpi wcel cG cnpi wcel wa
      wa cA cG cmi co cB cF cmi co cpli co cnpi wcel cB cG cmi co cnpi wcel wa
      cC cnpi wcel cD cnpi wcel wa cR cnpi wcel cS cnpi wcel wa wa cC cS cmi co
      cD cR cmi co cpli co cnpi wcel cD cS cmi co cnpi wcel wa cA cnpi wcel cB
      cnpi wcel wa cF cnpi wcel cG cnpi wcel wa wa cA cG cmi co cB cF cmi co
      cpli co cnpi wcel cB cG cmi co cnpi wcel cA cnpi wcel cG cnpi wcel cB
      cnpi wcel cF cnpi wcel cA cG cmi co cB cF cmi co cpli co cnpi wcel cA cG
      cmi co cnpi wcel cB cF cmi co cnpi wcel cA cG cmi co cB cF cmi co cpli co
      cnpi wcel cA cnpi wcel cG cnpi wcel wa cB cnpi wcel cF cnpi wcel wa cA cG
      cmi co cB cF cmi co addclpi cA cG mulclpi cB cF mulclpi syl2an an42s cB
      cnpi wcel cG cnpi wcel cB cG cmi co cnpi wcel cA cnpi wcel cF cnpi wcel
      cB cG mulclpi ad2ant2l jca cC cnpi wcel cD cnpi wcel wa cR cnpi wcel cS
      cnpi wcel wa wa cC cS cmi co cD cR cmi co cpli co cnpi wcel cD cS cmi co
      cnpi wcel cC cnpi wcel cS cnpi wcel cD cnpi wcel cR cnpi wcel cC cS cmi
      co cD cR cmi co cpli co cnpi wcel cC cS cmi co cnpi wcel cD cR cmi co
      cnpi wcel cC cS cmi co cD cR cmi co cpli co cnpi wcel cC cnpi wcel cS
      cnpi wcel wa cD cnpi wcel cR cnpi wcel wa cC cS cmi co cD cR cmi co
      addclpi cC cS mulclpi cD cR mulclpi syl2an an42s cD cnpi wcel cS cnpi
      wcel cD cS cmi co cnpi wcel cC cnpi wcel cR cnpi wcel cD cS mulclpi
      ad2ant2l jca anim12i an4s cA cG cmi co cB cF cmi co cpli co cB cG cmi co
      cC cS cmi co cD cR cmi co cpli co cD cS cmi co enqbreq syl cA cD cmi co
      cB cC cmi co wceq cF cS cmi co cG cR cmi co wceq wa cA cD cmi co cG cS
      cmi co cmi co cB cD cmi co cF cS cmi co cmi co cpli co cB cC cmi co cG cS
      cmi co cmi co cB cD cmi co cG cR cmi co cmi co cpli co cA cG cmi co cB cF
      cmi co cpli co cD cS cmi co cmi co cB cG cmi co cC cS cmi co cD cR cmi co
      cpli co cmi co cA cD cmi co cB cC cmi co wceq cF cS cmi co cG cR cmi co
      wceq cA cD cmi co cG cS cmi co cmi co cB cC cmi co cG cS cmi co cmi co cB
      cD cmi co cF cS cmi co cmi co cB cD cmi co cG cR cmi co cmi co cpli cA cD
      cmi co cB cC cmi co cG cS cmi co cmi opreq1 cF cS cmi co cG cR cmi co cB
      cD cmi co cmi opreq2 opreqan12d cA cG cmi co cB cF cmi co cpli co cD cS
      cmi co cmi co cA cG cmi co cD cS cmi co cmi co cB cF cmi co cD cS cmi co
      cmi co cpli co cA cD cmi co cG cS cmi co cmi co cB cD cmi co cF cS cmi co
      cmi co cpli co vx vy vz cA cG cmi co cB cF cmi co cD cS cmi co cpli cmi
      cA cG cmi oprex cB cF cmi oprex cD cS cmi oprex vx cv vy cv vx visset vy
      visset mulcompi vx cv vy cv vz cv vy visset vz visset distrpi caoprdistrr
      cA cG cmi co cD cS cmi co cmi co cA cD cmi co cG cS cmi co cmi co cB cF
      cmi co cD cS cmi co cmi co cB cD cmi co cF cS cmi co cmi co cpli vx vy vz
      cA cG cD cS cmi cmpblnq.1 cmpblnq.6 cmpblnq.4 vx cv vy cv vx visset vy
      visset mulcompi vx cv vy cv vz cv vy visset vz visset mulasspi cmpblnq.8
      caopr4 vx vy vz cB cF cD cS cmi cmpblnq.2 cmpblnq.5 cmpblnq.4 vx cv vy cv
      vx visset vy visset mulcompi vx cv vy cv vz cv vy visset vz visset
      mulasspi cmpblnq.8 caopr4 opreq12i eqtri cB cG cmi co cC cS cmi co cD cR
      cmi co cpli co cmi co cB cG cmi co cC cS cmi co cmi co cB cG cmi co cD cR
      cmi co cmi co cpli co cB cC cmi co cG cS cmi co cmi co cB cD cmi co cG cR
      cmi co cmi co cpli co cB cG cmi co cC cS cmi co cD cR cmi co cC cS cmi
      oprex cD cR cmi oprex distrpi cB cG cmi co cC cS cmi co cmi co cB cC cmi
      co cG cS cmi co cmi co cB cG cmi co cD cR cmi co cmi co cB cD cmi co cG
      cR cmi co cmi co cpli vx vy vz cB cG cC cS cmi cmpblnq.2 cmpblnq.6
      cmpblnq.3 vx cv vy cv vx visset vy visset mulcompi vx cv vy cv vz cv vy
      visset vz visset mulasspi cmpblnq.8 caopr4 vx vy vz cB cG cD cR cmi
      cmpblnq.2 cmpblnq.6 cmpblnq.4 vx cv vy cv vx visset vy visset mulcompi vx
      cv vy cv vz cv vy visset vz visset mulasspi cmpblnq.7 caopr4 opreq12i
      eqtri 3eqtr4g syl5bir $.
      $( [27-Aug-1995] $)

    $( Lemma showing compatibility of multiplication. $)
    mulcmpblnq $p |- ( ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. )
             ) /\ ( ( F e. N. /\ G e. N. ) /\ ( R e. N. /\ S e. N. ) ) ) ->
                ( ( ( A .N D ) = ( B .N C ) /\ ( F .N S ) = ( G .N R ) ) ->
     <. ( A .N F ) , ( B .N G ) >. ~Q <. ( C .N R ) , ( D .N S ) >. ) ) $=
      cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa cF cnpi wcel
      cG cnpi wcel wa cR cnpi wcel cS cnpi wcel wa wa wa cA cF cmi co cB cG cmi
      co cop cC cR cmi co cD cS cmi co cop ceq wbr cA cD cmi co cF cS cmi co
      cmi co cB cC cmi co cG cR cmi co cmi co wceq cA cD cmi co cB cC cmi co
      wceq cF cS cmi co cG cR cmi co wceq wa cA cnpi wcel cB cnpi wcel wa cC
      cnpi wcel cD cnpi wcel wa wa cF cnpi wcel cG cnpi wcel wa cR cnpi wcel cS
      cnpi wcel wa wa wa cA cF cmi co cB cG cmi co cop cC cR cmi co cD cS cmi
      co cop ceq wbr cA cF cmi co cD cS cmi co cmi co cB cG cmi co cC cR cmi co
      cmi co wceq cA cD cmi co cF cS cmi co cmi co cB cC cmi co cG cR cmi co
      cmi co wceq cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa
      cF cnpi wcel cG cnpi wcel wa cR cnpi wcel cS cnpi wcel wa wa wa cA cF cmi
      co cnpi wcel cB cG cmi co cnpi wcel wa cC cR cmi co cnpi wcel cD cS cmi
      co cnpi wcel wa wa cA cF cmi co cB cG cmi co cop cC cR cmi co cD cS cmi
      co cop ceq wbr cA cF cmi co cD cS cmi co cmi co cB cG cmi co cC cR cmi co
      cmi co wceq wb cA cnpi wcel cB cnpi wcel wa cF cnpi wcel cG cnpi wcel wa
      cC cnpi wcel cD cnpi wcel wa cR cnpi wcel cS cnpi wcel wa cA cF cmi co
      cnpi wcel cB cG cmi co cnpi wcel wa cC cR cmi co cnpi wcel cD cS cmi co
      cnpi wcel wa wa cA cnpi wcel cB cnpi wcel wa cF cnpi wcel cG cnpi wcel wa
      wa cA cF cmi co cnpi wcel cB cG cmi co cnpi wcel wa cC cnpi wcel cD cnpi
      wcel wa cR cnpi wcel cS cnpi wcel wa wa cC cR cmi co cnpi wcel cD cS cmi
      co cnpi wcel wa cA cnpi wcel cF cnpi wcel cB cnpi wcel cG cnpi wcel cA cF
      cmi co cnpi wcel cB cG cmi co cnpi wcel wa cA cnpi wcel cF cnpi wcel wa
      cA cF cmi co cnpi wcel cB cnpi wcel cG cnpi wcel wa cB cG cmi co cnpi
      wcel cA cF mulclpi cB cG mulclpi anim12i an4s cC cnpi wcel cR cnpi wcel
      cD cnpi wcel cS cnpi wcel cC cR cmi co cnpi wcel cD cS cmi co cnpi wcel
      wa cC cnpi wcel cR cnpi wcel wa cC cR cmi co cnpi wcel cD cnpi wcel cS
      cnpi wcel wa cD cS cmi co cnpi wcel cC cR mulclpi cD cS mulclpi anim12i
      an4s anim12i an4s cA cF cmi co cB cG cmi co cC cR cmi co cD cS cmi co
      enqbreq syl cA cF cmi co cD cS cmi co cmi co cA cD cmi co cF cS cmi co
      cmi co cB cG cmi co cC cR cmi co cmi co cB cC cmi co cG cR cmi co cmi co
      vx vy vz cA cF cD cS cmi cmpblnq.1 cmpblnq.5 cmpblnq.4 vx cv vy cv vx
      visset vy visset mulcompi vx cv vy cv vz cv vy visset vz visset mulasspi
      cmpblnq.8 caopr4 vx vy vz cB cG cC cR cmi cmpblnq.2 cmpblnq.6 cmpblnq.3
      vx cv vy cv vx visset vy visset mulcompi vx cv vy cv vz cv vy visset vz
      visset mulasspi cmpblnq.7 caopr4 eqeq12i syl6bb cA cD cmi co cB cC cmi co
      cF cS cmi co cG cR cmi co cmi opreq12 syl5bir $.
      $( [27-Aug-1995] $)
  $}

  ${
    $d x y z w v u t s f g h a b c d A $.
    $d x y z w v u t s f g h a b c d B $.
    $d x y z w v u t s f g h a b c d C $.
    $d x y z w v u t s f g h a b c d D $.
    $( Addition of positive fractions in terms of positive integers. $)
    addpipq $p |- ( ( ( A e. N. /\ B e. N. ) /\
                     ( C e. N. /\ D e. N. ) ) ->
                ( [ <. A , B >. ] ~Q +Q [ <. C , D >. ] ~Q ) =
                   [ <. ( ( A .N D ) +N ( B .N C ) ) ,
                              ( B .N D ) >. ] ~Q ) $=
      vz cv vu cv cmi co vw cv vv cv cmi co wceq va cv vd cv cmi co vb cv vc cv
      cmi co wceq vg cv vs cv cmi co vh cv vt cv cmi co wceq vx vy vz vw vv vu
      vt cA cB cC cD cnq ceq cnpi vf vg vh cplq cplpq cA cD cmi co cB cC cmi co
      cpli co cB cD cmi co cop vw cv vf cv cmi co vv cv vu cv cmi co cpli co vv
      cv vf cv cmi co cop va cv vh cv cmi co vb cv vg cv cmi co cpli co vb cv
      vh cv cmi co cop vc cv vs cv cmi co vd cv vt cv cmi co cpli co vd cv vs
      cv cmi co cop vs va vb vc vd cA cD cmi co cB cC cmi co cpli co cB cD cmi
      co opex va cv vh cv cmi co vb cv vg cv cmi co cpli co vb cv vh cv cmi co
      opex vc cv vs cv cmi co vd cv vt cv cmi co cpli co vd cv vs cv cmi co
      opex enqex enqer dmenq vx vy vz vw vv vu df-enq vz cv va cv wceq vu cv vd
      cv wceq vw cv vb cv wceq vv cv vc cv wceq vz cv vu cv cmi co vw cv vv cv
      cmi co wceq va cv vd cv cmi co vb cv vc cv cmi co wceq wb vz cv va cv
      wceq vu cv vd cv wceq wa vw cv vb cv wceq vv cv vc cv wceq wa vz cv vu cv
      cmi co va cv vd cv cmi co vw cv vv cv cmi co vb cv vc cv cmi co vz cv va
      cv vu cv vd cv cmi opreq12 vw cv vb cv vv cv vc cv cmi opreq12 eqeqan12d
      an42s vz cv vg cv wceq vu cv vs cv wceq vw cv vh cv wceq vv cv vt cv wceq
      vz cv vu cv cmi co vw cv vv cv cmi co wceq vg cv vs cv cmi co vh cv vt cv
      cmi co wceq wb vz cv vg cv wceq vu cv vs cv wceq wa vw cv vh cv wceq vv
      cv vt cv wceq wa vz cv vu cv cmi co vg cv vs cv cmi co vw cv vv cv cmi co
      vh cv vt cv cmi co vz cv vg cv vu cv vs cv cmi opreq12 vw cv vh cv vv cv
      vt cv cmi opreq12 eqeqan12d an42s vx vy vz vw vv vu vf df-plpq vw cv va
      cv wceq vv cv vb cv wceq wa vu cv vg cv wceq vf cv vh cv wceq wa wa vw cv
      vf cv cmi co vv cv vu cv cmi co cpli co va cv vh cv cmi co vb cv vg cv
      cmi co cpli co vv cv vf cv cmi co vb cv vh cv cmi co vw cv va cv wceq vf
      cv vh cv wceq vv cv vb cv wceq vu cv vg cv wceq vw cv vf cv cmi co vv cv
      vu cv cmi co cpli co va cv vh cv cmi co vb cv vg cv cmi co cpli co wceq
      vw cv va cv wceq vf cv vh cv wceq wa vv cv vb cv wceq vu cv vg cv wceq wa
      vw cv vf cv cmi co va cv vh cv cmi co vv cv vu cv cmi co vb cv vg cv cmi
      co cpli vw cv va cv vf cv vh cv cmi opreq12 vv cv vb cv vu cv vg cv cmi
      opreq12 opreqan12d an42s vv cv vb cv wceq vf cv vh cv wceq vv cv vf cv
      cmi co vb cv vh cv cmi co wceq vw cv va cv wceq vu cv vg cv wceq vv cv vb
      cv vf cv vh cv cmi opreq12 ad2ant2l opeq12d vw cv vc cv wceq vv cv vd cv
      wceq wa vu cv vt cv wceq vf cv vs cv wceq wa wa vw cv vf cv cmi co vv cv
      vu cv cmi co cpli co vc cv vs cv cmi co vd cv vt cv cmi co cpli co vv cv
      vf cv cmi co vd cv vs cv cmi co vw cv vc cv wceq vf cv vs cv wceq vv cv
      vd cv wceq vu cv vt cv wceq vw cv vf cv cmi co vv cv vu cv cmi co cpli co
      vc cv vs cv cmi co vd cv vt cv cmi co cpli co wceq vw cv vc cv wceq vf cv
      vs cv wceq wa vv cv vd cv wceq vu cv vt cv wceq wa vw cv vf cv cmi co vc
      cv vs cv cmi co vv cv vu cv cmi co vd cv vt cv cmi co cpli vw cv vc cv vf
      cv vs cv cmi opreq12 vv cv vd cv vu cv vt cv cmi opreq12 opreqan12d an42s
      vv cv vd cv wceq vf cv vs cv wceq vv cv vf cv cmi co vd cv vs cv cmi co
      wceq vw cv vc cv wceq vu cv vt cv wceq vv cv vd cv vf cv vs cv cmi
      opreq12 ad2ant2l opeq12d vw cv cA wceq vv cv cB wceq wa vu cv cC wceq vf
      cv cD wceq wa wa vw cv vf cv cmi co vv cv vu cv cmi co cpli co cA cD cmi
      co cB cC cmi co cpli co vv cv vf cv cmi co cB cD cmi co vw cv cA wceq vf
      cv cD wceq vv cv cB wceq vu cv cC wceq vw cv vf cv cmi co vv cv vu cv cmi
      co cpli co cA cD cmi co cB cC cmi co cpli co wceq vw cv cA wceq vf cv cD
      wceq wa vv cv cB wceq vu cv cC wceq wa vw cv vf cv cmi co cA cD cmi co vv
      cv vu cv cmi co cB cC cmi co cpli vw cv cA vf cv cD cmi opreq12 vv cv cB
      vu cv cC cmi opreq12 opreqan12d an42s vv cv cB wceq vf cv cD wceq vv cv
      vf cv cmi co cB cD cmi co wceq vw cv cA wceq vu cv cC wceq vv cv cB vf cv
      cD cmi opreq12 ad2ant2l opeq12d vx vy vz va vb vc vd df-plq df-nq va cv
      vb cv vc cv vd cv vt cv vs cv vg cv vh cv va visset vb visset vc visset
      vd visset vg visset vh visset vt visset vs visset addcmpblnq oprec $.
      $( [28-Aug-1995] $)

    $( Multiplication of positive fractions in terms of positive integers. $)
    mulpipq $p |- ( ( ( A e. N. /\ B e. N. ) /\
                     ( C e. N. /\ D e. N. ) ) ->
                ( [ <. A , B >. ] ~Q .Q [ <. C , D >. ] ~Q ) =
                   [ <. ( A .N C ) , ( B .N D ) >. ] ~Q ) $=
      vz cv vu cv cmi co vw cv vv cv cmi co wceq va cv vd cv cmi co vb cv vc cv
      cmi co wceq vg cv vs cv cmi co vh cv vt cv cmi co wceq vx vy vz vw vv vu
      vt cA cB cC cD cnq ceq cnpi vf vg vh cmq cmpq cA cC cmi co cB cD cmi co
      cop vw cv vu cv cmi co vv cv vf cv cmi co cop va cv vg cv cmi co vb cv vh
      cv cmi co cop vc cv vt cv cmi co vd cv vs cv cmi co cop vs va vb vc vd cA
      cC cmi co cB cD cmi co opex va cv vg cv cmi co vb cv vh cv cmi co opex vc
      cv vt cv cmi co vd cv vs cv cmi co opex enqex enqer dmenq vx vy vz vw vv
      vu df-enq vz cv va cv wceq vu cv vd cv wceq vw cv vb cv wceq vv cv vc cv
      wceq vz cv vu cv cmi co vw cv vv cv cmi co wceq va cv vd cv cmi co vb cv
      vc cv cmi co wceq wb vz cv va cv wceq vu cv vd cv wceq wa vw cv vb cv
      wceq vv cv vc cv wceq wa vz cv vu cv cmi co va cv vd cv cmi co vw cv vv
      cv cmi co vb cv vc cv cmi co vz cv va cv vu cv vd cv cmi opreq12 vw cv vb
      cv vv cv vc cv cmi opreq12 eqeqan12d an42s vz cv vg cv wceq vu cv vs cv
      wceq vw cv vh cv wceq vv cv vt cv wceq vz cv vu cv cmi co vw cv vv cv cmi
      co wceq vg cv vs cv cmi co vh cv vt cv cmi co wceq wb vz cv vg cv wceq vu
      cv vs cv wceq wa vw cv vh cv wceq vv cv vt cv wceq wa vz cv vu cv cmi co
      vg cv vs cv cmi co vw cv vv cv cmi co vh cv vt cv cmi co vz cv vg cv vu
      cv vs cv cmi opreq12 vw cv vh cv vv cv vt cv cmi opreq12 eqeqan12d an42s
      vx vy vz vw vv vu vf df-mpq vw cv va cv wceq vu cv vg cv wceq vv cv vb cv
      wceq vf cv vh cv wceq vw cv vu cv cmi co vv cv vf cv cmi co cop va cv vg
      cv cmi co vb cv vh cv cmi co cop wceq vw cv vu cv cmi co va cv vg cv cmi
      co wceq vv cv vf cv cmi co vb cv vh cv cmi co wceq vw cv vu cv cmi co vv
      cv vf cv cmi co cop va cv vg cv cmi co vb cv vh cv cmi co cop wceq vw cv
      va cv wceq vu cv vg cv wceq wa vv cv vb cv wceq vf cv vh cv wceq wa vw cv
      vu cv cmi co vv cv vf cv cmi co va cv vg cv cmi co vb cv vh cv cmi co
      opeq12 vw cv va cv vu cv vg cv cmi opreq12 vv cv vb cv vf cv vh cv cmi
      opreq12 syl2an an4s vw cv vc cv wceq vu cv vt cv wceq vv cv vd cv wceq vf
      cv vs cv wceq vw cv vu cv cmi co vv cv vf cv cmi co cop vc cv vt cv cmi
      co vd cv vs cv cmi co cop wceq vw cv vu cv cmi co vc cv vt cv cmi co wceq
      vv cv vf cv cmi co vd cv vs cv cmi co wceq vw cv vu cv cmi co vv cv vf cv
      cmi co cop vc cv vt cv cmi co vd cv vs cv cmi co cop wceq vw cv vc cv
      wceq vu cv vt cv wceq wa vv cv vd cv wceq vf cv vs cv wceq wa vw cv vu cv
      cmi co vv cv vf cv cmi co vc cv vt cv cmi co vd cv vs cv cmi co opeq12 vw
      cv vc cv vu cv vt cv cmi opreq12 vv cv vd cv vf cv vs cv cmi opreq12
      syl2an an4s vw cv cA wceq vu cv cC wceq vv cv cB wceq vf cv cD wceq vw cv
      vu cv cmi co vv cv vf cv cmi co cop cA cC cmi co cB cD cmi co cop wceq vw
      cv vu cv cmi co cA cC cmi co wceq vv cv vf cv cmi co cB cD cmi co wceq vw
      cv vu cv cmi co vv cv vf cv cmi co cop cA cC cmi co cB cD cmi co cop wceq
      vw cv cA wceq vu cv cC wceq wa vv cv cB wceq vf cv cD wceq wa vw cv vu cv
      cmi co vv cv vf cv cmi co cA cC cmi co cB cD cmi co opeq12 vw cv cA vu cv
      cC cmi opreq12 vv cv cB vf cv cD cmi opreq12 syl2an an4s vx vy vz va vb
      vc vd df-mq df-nq va cv vb cv vc cv vd cv vt cv vs cv vg cv vh cv va
      visset vb visset vc visset vd visset vg visset vh visset vt visset vs
      visset mulcmpblnq oprec $.
      $( [28-Aug-1995] $)

  $}

  ${
    $d A x y z w v u f $.  $d B x y z w v u f $.  $d C x y z w v u f $.
    $d D x y z w v u f $.
    ordpipq.1 $e |- A e. _V $.
    ordpipq.2 $e |- B e. _V $.
    ordpipq.3 $e |- C e. _V $.
    ordpipq.4 $e |- D e. _V $.
    $( Ordering of positive fractions in terms of  positive integers. $)
    ordpipq $p |- ( [ <. A , B >. ] ~Q <Q [ <. C , D >. ] ~Q <->
                          ( A .N D ) <N ( B .N C ) ) $=
      cA cB cC cD clti cltq ceq cmi cnpi cnq enqex ordpipq.2 ordpipq.3
      ordpipq.4 dmenq df-nq ltrelpq ltrelpi 0npi dmmulpi vz cv vu cv cmi co vw
      cv vv cv cmi co clti wbr cA cD cmi co cB cC cmi co clti wbr vx vy vz vw
      vv vu cA cB cC cD cltq ceq cnpi cnq enqex enqer dmenq df-nq vx vy vz vw
      vv vu df-ltq vz cv cnpi wcel vw cv cnpi wcel wa cA cnpi wcel cB cnpi wcel
      wa wa vv cv cnpi wcel vu cv cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa
      wa vz cv vw cv cop ceq cec cA cB cop ceq cec wceq vv cv vu cv cop ceq cec
      cC cD cop ceq cec wceq wa vz cv vu cv cmi co cB cC cmi co cmi co vw cv vv
      cv cmi co cA cD cmi co cmi co wceq vz cv vu cv cmi co vw cv vv cv cmi co
      clti wbr cA cD cmi co cB cC cmi co clti wbr wb vz cv cnpi wcel vw cv cnpi
      wcel wa cA cnpi wcel cB cnpi wcel wa wa vv cv cnpi wcel vu cv cnpi wcel
      wa cC cnpi wcel cD cnpi wcel wa wa wa vz cv vw cv cop ceq cec cA cB cop
      ceq cec wceq vv cv vu cv cop ceq cec cC cD cop ceq cec wceq wa vz cv cB
      cmi co vw cv cA cmi co wceq vu cv cC cmi co vv cv cD cmi co wceq wa vz cv
      vu cv cmi co cB cC cmi co cmi co vw cv vv cv cmi co cA cD cmi co cmi co
      wceq vz cv cnpi wcel vw cv cnpi wcel wa cA cnpi wcel cB cnpi wcel wa wa
      vz cv vw cv cop ceq cec cA cB cop ceq cec wceq vz cv cB cmi co vw cv cA
      cmi co wceq vv cv cnpi wcel vu cv cnpi wcel wa cC cnpi wcel cD cnpi wcel
      wa wa vv cv vu cv cop ceq cec cC cD cop ceq cec wceq vu cv cC cmi co vv
      cv cD cmi co wceq vz cv vw cv cA cB enqeceq vv cv cnpi wcel vu cv cnpi
      wcel wa cC cnpi wcel cD cnpi wcel wa wa vv cv vu cv cop ceq cec cC cD cop
      ceq cec wceq vv cv cD cmi co vu cv cC cmi co wceq vu cv cC cmi co vv cv
      cD cmi co wceq vv cv vu cv cC cD enqeceq vv cv cD cmi co vu cv cC cmi co
      eqcom syl6bb bi2anan9 vz cv cB cmi co vw cv cA cmi co wceq vu cv cC cmi
      co vv cv cD cmi co wceq wa vz cv cB cmi co vu cv cC cmi co cmi co vw cv
      cA cmi co vv cv cD cmi co cmi co vz cv vu cv cmi co cB cC cmi co cmi co
      vw cv vv cv cmi co cA cD cmi co cmi co vz cv cB cmi co vw cv cA cmi co vu
      cv cC cmi co vv cv cD cmi co cmi opreq12 vx vy vf vz cv vu cv cB cC cmi
      vz visset vu visset ordpipq.2 vx cv vy cv vx visset vy visset mulcompi vx
      cv vy cv vf cv vy visset vf visset mulasspi ordpipq.3 caopr4 vx vy vf vw
      cv vv cv cA cD cmi vw visset vv visset ordpipq.1 vx cv vy cv vx visset vy
      visset mulcompi vx cv vy cv vf cv vy visset vf visset mulasspi ordpipq.4
      caopr4 3eqtr4g syl6bi vz cv cnpi wcel vw cv cnpi wcel wa cA cnpi wcel cB
      cnpi wcel wa wa vv cv cnpi wcel vu cv cnpi wcel wa cC cnpi wcel cD cnpi
      wcel wa wa wa cB cC cmi co cnpi wcel vw cv vv cv cmi co cnpi wcel wa vz
      cv vu cv cmi co cB cC cmi co cmi co vw cv vv cv cmi co cA cD cmi co cmi
      co wceq vz cv vu cv cmi co vw cv vv cv cmi co clti wbr cA cD cmi co cB cC
      cmi co clti wbr wb wi vz cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel
      vu cv cnpi wcel wa cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD cnpi wcel
      wa cB cC cmi co cnpi wcel vw cv vv cv cmi co cnpi wcel wa cA cnpi wcel cB
      cnpi wcel wa cC cnpi wcel cD cnpi wcel wa wa vz cv cnpi wcel vw cv cnpi
      wcel wa vv cv cnpi wcel vu cv cnpi wcel wa wa cB cC cmi co cnpi wcel vw
      cv vv cv cmi co cnpi wcel wa cA cnpi wcel cB cnpi wcel wa cC cnpi wcel cD
      cnpi wcel wa wa cB cC cmi co cnpi wcel vz cv cnpi wcel vw cv cnpi wcel wa
      vv cv cnpi wcel vu cv cnpi wcel wa wa vw cv vv cv cmi co cnpi wcel cB
      cnpi wcel cC cnpi wcel cB cC cmi co cnpi wcel cA cnpi wcel cD cnpi wcel
      cB cC mulclpi ad2ant2lr vw cv cnpi wcel vv cv cnpi wcel vw cv vv cv cmi
      co cnpi wcel vz cv cnpi wcel vu cv cnpi wcel vw cv vv cv mulclpi
      ad2ant2lr anim12i ancoms an4s cB cC cmi co cnpi wcel vw cv vv cv cmi co
      cnpi wcel wa vz cv vu cv cmi co cB cC cmi co cmi co vw cv vv cv cmi co cA
      cD cmi co cmi co wceq vz cv vu cv cmi co vw cv vv cv cmi co clti wbr cA
      cD cmi co cB cC cmi co clti wbr wb vx vy vf vz cv vu cv cmi co cB cC cmi
      co vw cv vv cv cmi co cA cD cmi co clti cnpi cmi vz cv vu cv cmi oprex cB
      cC cmi oprex vx cv vy cv vf cv vx visset vy visset ltmpi vw cv vv cv cmi
      oprex vx cv vy cv vx visset vy visset mulcompi cA cD cmi oprex caoprord3
      ex syl syld brecop brecop2 $.
      $( [13-Feb-1996] $)
  $}

  $( The positive fraction 'one'. $)
  1q $p |- 1Q e. Q. $=
    c1q cnq wcel c1o c1o cop ceq cec cnpi cnpi cxp ceq cqs wcel c1o c1o cop
    cnpi cnpi cxp wcel c1o c1o cop ceq cec cnpi cnpi cxp ceq cqs wcel c1o cnpi
    wcel c1o cnpi wcel c1o c1o cop cnpi cnpi cxp wcel 1pi 1pi c1o c1o cnpi cnpi
    opelxpi mp2an cnpi cnpi cxp c1o c1o cop ceq enqex ecelqsi ax-mp c1q c1o c1o
    cop ceq cec cnq cnpi cnpi cxp ceq cqs df-1q df-nq eleq12i mpbir $.
    $( [29-Oct-1995] $)

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Closure of addition on positive fractions. $)
    addclpq $p |- ( ( A e. Q. /\ B e. Q. ) -> ( A +Q B ) e. Q. ) $=
      cA cnq wcel cB cnq wcel wa cA cB cplq co cnpi cnpi cxp ceq cqs cnq vx cv
      vy cv cop ceq cec vz cv vw cv cop ceq cec cplq co cnpi cnpi cxp ceq cqs
      wcel cA vz cv vw cv cop ceq cec cplq co cnpi cnpi cxp ceq cqs wcel cA cB
      cplq co cnpi cnpi cxp ceq cqs wcel vx vy vz vw cA cB cnpi cnpi ceq cnq
      df-nq vx cv vy cv cop ceq cec cA wceq vx cv vy cv cop ceq cec vz cv vw cv
      cop ceq cec cplq co cA vz cv vw cv cop ceq cec cplq co cnpi cnpi cxp ceq
      cqs vx cv vy cv cop ceq cec cA vz cv vw cv cop ceq cec cplq opreq1 eleq1d
      vz cv vw cv cop ceq cec cB wceq cA vz cv vw cv cop ceq cec cplq co cA cB
      cplq co cnpi cnpi cxp ceq cqs vz cv vw cv cop ceq cec cB cA cplq opreq2
      eleq1d vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel
      wa wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cplq co vx cv vw cv
      cmi co vy cv vz cv cmi co cpli co vy cv vw cv cmi co cop ceq cec cnpi
      cnpi cxp ceq cqs vx cv vy cv vz cv vw cv addpipq vx cv cnpi wcel vy cv
      cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa vx cv vw cv cmi co vy
      cv vz cv cmi co cpli co cnpi wcel vy cv vw cv cmi co cnpi wcel wa vx cv
      vw cv cmi co vy cv vz cv cmi co cpli co vy cv vw cv cmi co cop cnpi cnpi
      cxp wcel vx cv vw cv cmi co vy cv vz cv cmi co cpli co vy cv vw cv cmi co
      cop ceq cec cnpi cnpi cxp ceq cqs wcel vx cv cnpi wcel vy cv cnpi wcel wa
      vz cv cnpi wcel vw cv cnpi wcel wa wa vx cv vw cv cmi co vy cv vz cv cmi
      co cpli co cnpi wcel vy cv vw cv cmi co cnpi wcel vx cv cnpi wcel vw cv
      cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vx cv vw cv cmi co vy cv vz cv
      cmi co cpli co cnpi wcel vx cv vw cv cmi co cnpi wcel vy cv vz cv cmi co
      cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co cpli co cnpi wcel vx cv
      cnpi wcel vw cv cnpi wcel wa vy cv cnpi wcel vz cv cnpi wcel wa vx cv vw
      cv cmi co vy cv vz cv cmi co addclpi vx cv vw cv mulclpi vy cv vz cv
      mulclpi syl2an an42s vy cv cnpi wcel vw cv cnpi wcel vy cv vw cv cmi co
      cnpi wcel vx cv cnpi wcel vz cv cnpi wcel vy cv vw cv mulclpi ad2ant2l
      jca vx cv vw cv cmi co vy cv vz cv cmi co cpli co vy cv vw cv cmi co cnpi
      cnpi opelxpi cnpi cnpi cxp vx cv vw cv cmi co vy cv vz cv cmi co cpli co
      vy cv vw cv cmi co cop ceq enqex ecelqsi 3syl eqeltrd 2ecoptocl df-nq
      syl6eleqr $.
      $( [29-Aug-1995] $)
  $}

  ${
    $d x y z w v u f $.
    $( Domain of addition on positive fractions. $)
    dmaddpq $p |- dom +Q = ( Q. X. Q. ) $=
      cplq cdm cnq cnq cxp cplq cdm vx cv cnq wcel vy cv cnq wcel wa vx cv vw
      cv vv cv cop ceq cec wceq vy cv vu cv vf cv cop ceq cec wceq wa vz cv vw
      cv vv cv cop vu cv vf cv cop cplpq co ceq cec wceq wa vf wex vu wex vv
      wex vw wex wa vx vy vz copab2 cdm cnq cnq cxp cplq vx cv cnq wcel vy cv
      cnq wcel wa vx cv vw cv vv cv cop ceq cec wceq vy cv vu cv vf cv cop ceq
      cec wceq wa vz cv vw cv vv cv cop vu cv vf cv cop cplpq co ceq cec wceq
      wa vf wex vu wex vv wex vw wex wa vx vy vz copab2 vx vy vz vw vv vu vf
      df-plq dmeqi vx cv vw cv vv cv cop ceq cec wceq vy cv vu cv vf cv cop ceq
      cec wceq wa vz cv vw cv vv cv cop vu cv vf cv cop cplpq co ceq cec wceq
      wa vf wex vu wex vv wex vw wex vx vy vz cnq cnq dmoprabss eqsstri vx vy
      cnq cplq 0npq vx cv vy cv addclpq oprssdm eqssi $.
      $( [24-Aug-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Closure of multiplication on positive fractions. $)
    mulclpq $p |- ( ( A e. Q. /\ B e. Q. ) -> ( A .Q B ) e. Q. ) $=
      cA cnq wcel cB cnq wcel wa cA cB cmq co cnpi cnpi cxp ceq cqs cnq vx cv
      vy cv cop ceq cec vz cv vw cv cop ceq cec cmq co cnpi cnpi cxp ceq cqs
      wcel cA vz cv vw cv cop ceq cec cmq co cnpi cnpi cxp ceq cqs wcel cA cB
      cmq co cnpi cnpi cxp ceq cqs wcel vx vy vz vw cA cB cnpi cnpi ceq cnq
      df-nq vx cv vy cv cop ceq cec cA wceq vx cv vy cv cop ceq cec vz cv vw cv
      cop ceq cec cmq co cA vz cv vw cv cop ceq cec cmq co cnpi cnpi cxp ceq
      cqs vx cv vy cv cop ceq cec cA vz cv vw cv cop ceq cec cmq opreq1 eleq1d
      vz cv vw cv cop ceq cec cB wceq cA vz cv vw cv cop ceq cec cmq co cA cB
      cmq co cnpi cnpi cxp ceq cqs vz cv vw cv cop ceq cec cB cA cmq opreq2
      eleq1d vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel
      wa wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cmq co vx cv vz cv
      cmi co vy cv vw cv cmi co cop ceq cec cnpi cnpi cxp ceq cqs vx cv vy cv
      vz cv vw cv mulpipq vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw
      cv cnpi wcel wa wa vx cv vz cv cmi co cnpi wcel vy cv vw cv cmi co cnpi
      wcel wa vx cv vz cv cmi co vy cv vw cv cmi co cop cnpi cnpi cxp wcel vx
      cv vz cv cmi co vy cv vw cv cmi co cop ceq cec cnpi cnpi cxp ceq cqs wcel
      vx cv cnpi wcel vz cv cnpi wcel vy cv cnpi wcel vw cv cnpi wcel vx cv vz
      cv cmi co cnpi wcel vy cv vw cv cmi co cnpi wcel wa vx cv cnpi wcel vz cv
      cnpi wcel wa vx cv vz cv cmi co cnpi wcel vy cv cnpi wcel vw cv cnpi wcel
      wa vy cv vw cv cmi co cnpi wcel vx cv vz cv mulclpi vy cv vw cv mulclpi
      anim12i an4s vx cv vz cv cmi co vy cv vw cv cmi co cnpi cnpi opelxpi cnpi
      cnpi cxp vx cv vz cv cmi co vy cv vw cv cmi co cop ceq enqex ecelqsi 3syl
      eqeltrd 2ecoptocl df-nq syl6eleqr $.
      $( [29-Aug-1995] $)
  $}

  ${
    $d x y z w v u f $.
    $( Domain of multiplication on positive fractions. $)
    dmmulpq $p |- dom .Q = ( Q. X. Q. ) $=
      cmq cdm cnq cnq cxp cmq cdm vx cv cnq wcel vy cv cnq wcel wa vx cv vw cv
      vv cv cop ceq cec wceq vy cv vu cv vf cv cop ceq cec wceq wa vz cv vw cv
      vv cv cop vu cv vf cv cop cmpq co ceq cec wceq wa vf wex vu wex vv wex vw
      wex wa vx vy vz copab2 cdm cnq cnq cxp cmq vx cv cnq wcel vy cv cnq wcel
      wa vx cv vw cv vv cv cop ceq cec wceq vy cv vu cv vf cv cop ceq cec wceq
      wa vz cv vw cv vv cv cop vu cv vf cv cop cmpq co ceq cec wceq wa vf wex
      vu wex vv wex vw wex wa vx vy vz copab2 vx vy vz vw vv vu vf df-mq dmeqi
      vx cv vw cv vv cv cop ceq cec wceq vy cv vu cv vf cv cop ceq cec wceq wa
      vz cv vw cv vv cv cop vu cv vf cv cop cmpq co ceq cec wceq wa vf wex vu
      wex vv wex vw wex vx vy vz cnq cnq dmoprabss eqsstri vx vy cnq cmq 0npq
      vx cv vy cv mulclpq oprssdm eqssi $.
      $( [24-Aug-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    addcompq.1 $e |- A e. _V $.
    addcompq.2 $e |- B e. _V $.
    $( Addition of positive fractions is commutative. $)
    addcompq $p |- ( A +Q B ) = ( B +Q A ) $=
      cA cnq wcel cB cnq wcel wa cA cB cplq co cB cA cplq co wceq vx vy vz vw
      cA cB cnq vx cv vw cv cmi co vy cv vz cv cmi co cpli co ceq cnpi cplq vy
      cv vw cv cmi co vz cv vy cv cmi co vw cv vx cv cmi co cpli co vw cv vy cv
      cmi co df-nq vx cv vy cv vz cv vw cv addpipq vz cv vw cv vx cv vy cv
      addpipq vx cv vw cv cmi co vy cv vz cv cmi co cpli co vw cv vx cv cmi co
      vz cv vy cv cmi co cpli co vz cv vy cv cmi co vw cv vx cv cmi co cpli co
      vx cv vw cv cmi co vw cv vx cv cmi co vy cv vz cv cmi co vz cv vy cv cmi
      co cpli vx cv vw cv vx visset vw visset mulcompi vy cv vz cv vy visset vz
      visset mulcompi opreq12i vw cv vx cv cmi co vz cv vy cv cmi co vw cv vx
      cv cmi oprex vz cv vy cv cmi oprex addcompi eqtri vy cv vw cv vy visset
      vw visset mulcompi ecoprcom cA cB cnq cplq addcompq.2 dmaddpq addcompq.1
      ndmoprcom pm2.61i $.
      $( [30-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    addasspq.1 $e |- B e. _V $.
    addasspq.2 $e |- C e. _V $.
  $( Addition of positive fractions is associative. $)
    addasspq $p |- ( ( A +Q B ) +Q C ) = ( A +Q ( B +Q C ) ) $=
      cA cnq wcel cB cnq wcel cC cnq wcel w3a cA cB cplq co cC cplq co cA cB cC
      cplq co cplq co wceq vx vy vz vw vv vu cA cB cC cnq vw cv vu cv cmi co
      ceq cnpi cplq vx cv vw cv cmi co vy cv vz cv cmi co cpli co vy cv vw cv
      cmi co vx cv vw cv cmi co vy cv vz cv cmi co cpli co vu cv cmi co vy cv
      vw cv cmi co vv cv cmi co cpli co vy cv vw cv cmi co vu cv cmi co vx cv
      vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co vw cv vv cv cmi co
      cpli co cmi co cpli co vy cv vw cv vu cv cmi co cmi co vz cv vu cv cmi co
      vw cv vv cv cmi co cpli co df-nq vx cv vy cv vz cv vw cv addpipq vz cv vw
      cv vv cv vu cv addpipq vx cv vw cv cmi co vy cv vz cv cmi co cpli co vy
      cv vw cv cmi co vv cv vu cv addpipq vx cv vy cv vz cv vu cv cmi co vw cv
      vv cv cmi co cpli co vw cv vu cv cmi co addpipq vx cv cnpi wcel vy cv
      cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa vx cv vw cv cmi co vy
      cv vz cv cmi co cpli co cnpi wcel vy cv vw cv cmi co cnpi wcel vx cv cnpi
      wcel vw cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vx cv vw cv cmi co
      vy cv vz cv cmi co cpli co cnpi wcel vx cv vw cv cmi co cnpi wcel vy cv
      vz cv cmi co cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co cpli co cnpi
      wcel vx cv cnpi wcel vw cv cnpi wcel wa vy cv cnpi wcel vz cv cnpi wcel
      wa vx cv vw cv cmi co vy cv vz cv cmi co addclpi vx cv vw cv mulclpi vy
      cv vz cv mulclpi syl2an an42s vy cv cnpi wcel vw cv cnpi wcel vy cv vw cv
      cmi co cnpi wcel vx cv cnpi wcel vz cv cnpi wcel vy cv vw cv mulclpi
      ad2ant2l jca vz cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vu cv
      cnpi wcel wa wa vz cv vu cv cmi co vw cv vv cv cmi co cpli co cnpi wcel
      vw cv vu cv cmi co cnpi wcel vz cv cnpi wcel vu cv cnpi wcel vw cv cnpi
      wcel vv cv cnpi wcel vz cv vu cv cmi co vw cv vv cv cmi co cpli co cnpi
      wcel vz cv vu cv cmi co cnpi wcel vw cv vv cv cmi co cnpi wcel vz cv vu
      cv cmi co vw cv vv cv cmi co cpli co cnpi wcel vz cv cnpi wcel vu cv cnpi
      wcel wa vw cv cnpi wcel vv cv cnpi wcel wa vz cv vu cv cmi co vw cv vv cv
      cmi co addclpi vz cv vu cv mulclpi vw cv vv cv mulclpi syl2an an42s vw cv
      cnpi wcel vu cv cnpi wcel vw cv vu cv cmi co cnpi wcel vz cv cnpi wcel vv
      cv cnpi wcel vw cv vu cv mulclpi ad2ant2l jca vx cv vw cv vu cv cmi co
      cmi co vy cv vz cv vu cv cmi co cmi co cpli co vy cv vw cv vv cv cmi co
      cmi co cpli co vx cv vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co
      cmi co vy cv vw cv vv cv cmi co cmi co cpli co cpli co vx cv vw cv cmi co
      vy cv vz cv cmi co cpli co vu cv cmi co vy cv vw cv cmi co vv cv cmi co
      cpli co vx cv vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co vw cv vv
      cv cmi co cpli co cmi co cpli co vx cv vw cv vu cv cmi co cmi co vy cv vz
      cv vu cv cmi co cmi co vy cv vw cv vv cv cmi co cmi co vy cv vz cv vu cv
      cmi co cmi oprex vy cv vw cv vv cv cmi co cmi oprex addasspi vx cv vw cv
      cmi co vy cv vz cv cmi co cpli co vu cv cmi co vx cv vw cv vu cv cmi co
      cmi co vy cv vz cv vu cv cmi co cmi co cpli co vy cv vw cv cmi co vv cv
      cmi co vy cv vw cv vv cv cmi co cmi co cpli vf vg vh vx cv vy cv vw cv vz
      cv cpli cmi vu cv vx visset vy visset vw visset vf cv vg cv vf visset vg
      visset mulcompi vf cv vg cv vh cv vg visset vh visset distrpi vz visset
      vu visset vf cv vg cv vh cv vg visset vh visset mulasspi caoprdilem vy cv
      vw cv vv cv vw visset vv visset mulasspi opreq12i vy cv vz cv vu cv cmi
      co vw cv vv cv cmi co cpli co cmi co vy cv vz cv vu cv cmi co cmi co vy
      cv vw cv vv cv cmi co cmi co cpli co vx cv vw cv vu cv cmi co cmi co cpli
      vy cv vz cv vu cv cmi co vw cv vv cv cmi co vz cv vu cv cmi oprex vw cv
      vv cv cmi oprex distrpi opreq2i 3eqtr4i vy cv vw cv vu cv vw visset vu
      visset mulasspi ecoprass cA cB cC cnq cplq addasspq.1 dmaddpq addasspq.2
      0npq ndmoprass pm2.61i $.
      $( [2-Sep-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    mulcompq.1 $e |- A e. _V $.
    mulcompq.2 $e |- B e. _V $.
    $( Multiplication of positive fractions is commutative. $)
    mulcompq $p |- ( A .Q B ) = ( B .Q A ) $=
      cA cnq wcel cB cnq wcel wa cA cB cmq co cB cA cmq co wceq vx vy vz vw cA
      cB cnq vx cv vz cv cmi co ceq cnpi cmq vy cv vw cv cmi co vz cv vx cv cmi
      co vw cv vy cv cmi co df-nq vx cv vy cv vz cv vw cv mulpipq vz cv vw cv
      vx cv vy cv mulpipq vx cv vz cv vx visset vz visset mulcompi vy cv vw cv
      vy visset vw visset mulcompi ecoprcom cA cB cnq cmq mulcompq.2 dmmulpq
      mulcompq.1 ndmoprcom pm2.61i $.
      $( [31-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    mulasspq.1 $e |- B e. _V $.
    mulasspq.2 $e |- C e. _V $.
    $( Multiplication of positive fractions is associative. $)
    mulasspq $p |- ( ( A .Q B ) .Q C ) = ( A .Q ( B .Q C ) ) $=
      cA cnq wcel cB cnq wcel cC cnq wcel w3a cA cB cmq co cC cmq co cA cB cC
      cmq co cmq co wceq vx vy vz vw vv vu cA cB cC cnq vw cv vu cv cmi co ceq
      cnpi cmq vx cv vz cv cmi co vy cv vw cv cmi co vx cv vz cv cmi co vv cv
      cmi co vy cv vw cv cmi co vu cv cmi co vx cv vz cv vv cv cmi co cmi co vy
      cv vw cv vu cv cmi co cmi co vz cv vv cv cmi co df-nq vx cv vy cv vz cv
      vw cv mulpipq vz cv vw cv vv cv vu cv mulpipq vx cv vz cv cmi co vy cv vw
      cv cmi co vv cv vu cv mulpipq vx cv vy cv vz cv vv cv cmi co vw cv vu cv
      cmi co mulpipq vx cv cnpi wcel vz cv cnpi wcel vy cv cnpi wcel vw cv cnpi
      wcel vx cv vz cv cmi co cnpi wcel vy cv vw cv cmi co cnpi wcel wa vx cv
      cnpi wcel vz cv cnpi wcel wa vx cv vz cv cmi co cnpi wcel vy cv cnpi wcel
      vw cv cnpi wcel wa vy cv vw cv cmi co cnpi wcel vx cv vz cv mulclpi vy cv
      vw cv mulclpi anim12i an4s vz cv cnpi wcel vv cv cnpi wcel vw cv cnpi
      wcel vu cv cnpi wcel vz cv vv cv cmi co cnpi wcel vw cv vu cv cmi co cnpi
      wcel wa vz cv cnpi wcel vv cv cnpi wcel wa vz cv vv cv cmi co cnpi wcel
      vw cv cnpi wcel vu cv cnpi wcel wa vw cv vu cv cmi co cnpi wcel vz cv vv
      cv mulclpi vw cv vu cv mulclpi anim12i an4s vx cv vz cv vv cv vz visset
      vv visset mulasspi vy cv vw cv vu cv vw visset vu visset mulasspi
      ecoprass cA cB cC cnq cmq mulasspq.1 dmmulpq mulasspq.2 0npq ndmoprass
      pm2.61i $.
      $( [1-Sep-1995] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    distrpqlem.1 $e |- A e. _V $.
    distrpqlem.2 $e |- B e. _V $.
    distrpqlem.3 $e |- C e. _V $.
    $( Lemma for distributive law:  cancellation of common factor. $)
    distrpqlem $p |- ( ( A e. N. /\ B e. N. /\ C e. N. ) ->
     [ <. ( A .N B ) , ( A .N C ) >. ] ~Q = [ <. B , C >. ] ~Q ) $=
      cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB cmi co cA cC cmi co cop
      cB cC cop ceq wbr cA cB cmi co cA cC cmi co cop ceq cec cB cC cop ceq cec
      wceq cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB cmi co cA cC cmi co
      cop cB cC cop ceq wbr cA cB cmi co cC cmi co cA cC cmi co cB cmi co wceq
      vx vy vz cA cB cC cmi distrpqlem.1 distrpqlem.2 distrpqlem.3 vx cv vy cv
      vx visset vy visset mulcompi vx cv vy cv vz cv vy visset vz visset
      mulasspi caopr32 cA cnpi wcel cB cnpi wcel cC cnpi wcel w3a cA cB cmi co
      cnpi wcel cA cC cmi co cnpi wcel wa cB cnpi wcel cC cnpi wcel wa wa cA cB
      cmi co cA cC cmi co cop cB cC cop ceq wbr cA cB cmi co cC cmi co cA cC
      cmi co cB cmi co wceq wb cA cnpi wcel cB cnpi wcel cC cnpi wcel cA cB cmi
      co cnpi wcel cA cC cmi co cnpi wcel wa cB cnpi wcel cC cnpi wcel wa wa cA
      cnpi wcel cB cnpi wcel wa cA cnpi wcel cC cnpi wcel wa wa cA cB cmi co
      cnpi wcel cA cC cmi co cnpi wcel wa cB cnpi wcel cC cnpi wcel wa cA cnpi
      wcel cB cnpi wcel wa cA cB cmi co cnpi wcel cA cnpi wcel cC cnpi wcel wa
      cA cC cmi co cnpi wcel cA cB mulclpi cA cC mulclpi anim12i cA cnpi wcel
      cA cnpi wcel cB cnpi wcel cC cnpi wcel cB cnpi wcel cC cnpi wcel wa cA
      cnpi wcel cA cnpi wcel wa cB cnpi wcel cC cnpi wcel wa pm3.27 an4s jca
      3impdi cA cB cmi co cA cC cmi co cB cC enqbreq syl mpbiri cA cB cmi co cA
      cC cmi co cop cB cC cop ceq cA cB cmi co cA cC cmi co opex cB cC opex
      enqer erthi syl $.
      $( [2-Sep-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    distrpq.1 $e |- B e. _V $.
    distrpq.2 $e |- C e. _V $.
    $( Multiplication of positive fractions is distributive. $)
    distrpq $p |- ( A .Q ( B +Q C ) ) = ( ( A .Q B ) +Q ( A .Q C ) ) $=
      cA cnq wcel cB cnq wcel cC cnq wcel w3a cA cB cC cplq co cmq co cA cB cmq
      co cA cC cmq co cplq co wceq vx vy vz vw vv vu cA cB cC cnq ceq cnpi cplq
      cmq vy cv vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co cmi co cmi
      co vy cv vy cv vw cv vu cv cmi co cmi co cmi co vx cv vz cv cmi co vy cv
      vu cv cmi co cmi co vy cv vw cv cmi co vx cv vv cv cmi co cmi co cpli co
      vy cv vw cv cmi co vy cv vu cv cmi co cmi co vz cv vu cv cmi co vw cv vv
      cv cmi co cpli co vw cv vu cv cmi co vx cv vz cv cmi co vy cv vw cv cmi
      co vx cv vv cv cmi co vy cv vu cv cmi co df-nq vz cv vw cv vv cv vu cv
      addpipq vx cv cnpi wcel vy cv cnpi wcel wa vz cv vu cv cmi co vw cv vv cv
      cmi co cpli co cnpi wcel vw cv vu cv cmi co cnpi wcel wa wa vx cv vy cv
      cop ceq cec vz cv vu cv cmi co vw cv vv cv cmi co cpli co vw cv vu cv cmi
      co cop ceq cec cmq co vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co
      cmi co vy cv vw cv vu cv cmi co cmi co cop ceq cec vy cv vx cv vz cv vu
      cv cmi co vw cv vv cv cmi co cpli co cmi co cmi co vy cv vy cv vw cv vu
      cv cmi co cmi co cmi co cop ceq cec vx cv vy cv vz cv vu cv cmi co vw cv
      vv cv cmi co cpli co vw cv vu cv cmi co mulpipq vx cv cnpi wcel vy cv
      cnpi wcel wa vz cv vu cv cmi co vw cv vv cv cmi co cpli co cnpi wcel vw
      cv vu cv cmi co cnpi wcel wa wa vy cv cnpi wcel vx cv vz cv vu cv cmi co
      vw cv vv cv cmi co cpli co cmi co cnpi wcel vy cv vw cv vu cv cmi co cmi
      co cnpi wcel w3a vy cv vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli
      co cmi co cmi co vy cv vy cv vw cv vu cv cmi co cmi co cmi co cop ceq cec
      vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co cmi co vy cv vw cv vu
      cv cmi co cmi co cop ceq cec wceq vx cv cnpi wcel vz cv vu cv cmi co vw
      cv vv cv cmi co cpli co cnpi wcel vy cv cnpi wcel vw cv vu cv cmi co cnpi
      wcel vy cv cnpi wcel vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co
      cmi co cnpi wcel vy cv vw cv vu cv cmi co cmi co cnpi wcel w3a vx cv cnpi
      wcel vz cv vu cv cmi co vw cv vv cv cmi co cpli co cnpi wcel wa vy cv
      cnpi wcel vw cv vu cv cmi co cnpi wcel wa wa vx cv vz cv vu cv cmi co vw
      cv vv cv cmi co cpli co cmi co cnpi wcel vy cv cnpi wcel vy cv vw cv vu
      cv cmi co cmi co cnpi wcel wa wa vy cv cnpi wcel vx cv vz cv vu cv cmi co
      vw cv vv cv cmi co cpli co cmi co cnpi wcel vy cv vw cv vu cv cmi co cmi
      co cnpi wcel w3a vx cv cnpi wcel vz cv vu cv cmi co vw cv vv cv cmi co
      cpli co cnpi wcel wa vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co
      cmi co cnpi wcel vy cv cnpi wcel vw cv vu cv cmi co cnpi wcel wa vy cv
      cnpi wcel vy cv vw cv vu cv cmi co cmi co cnpi wcel wa vx cv vz cv vu cv
      cmi co vw cv vv cv cmi co cpli co mulclpi vy cv cnpi wcel vw cv vu cv cmi
      co cnpi wcel wa vy cv cnpi wcel vy cv vw cv vu cv cmi co cmi co cnpi wcel
      vy cv cnpi wcel vw cv vu cv cmi co cnpi wcel pm3.26 vy cv vw cv vu cv cmi
      co mulclpi jca anim12i vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli
      co cmi co cnpi wcel vy cv cnpi wcel vy cv vw cv vu cv cmi co cmi co cnpi
      wcel wa wa vy cv cnpi wcel vx cv vz cv vu cv cmi co vw cv vv cv cmi co
      cpli co cmi co cnpi wcel vy cv vw cv vu cv cmi co cmi co cnpi wcel wa wa
      vy cv cnpi wcel vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co cmi
      co cnpi wcel vy cv vw cv vu cv cmi co cmi co cnpi wcel w3a vx cv vz cv vu
      cv cmi co vw cv vv cv cmi co cpli co cmi co cnpi wcel vy cv cnpi wcel vy
      cv vw cv vu cv cmi co cmi co cnpi wcel an12 vy cv cnpi wcel vx cv vz cv
      vu cv cmi co vw cv vv cv cmi co cpli co cmi co cnpi wcel vy cv vw cv vu
      cv cmi co cmi co cnpi wcel 3anass bitr4i sylib an4s vy cv vx cv vz cv vu
      cv cmi co vw cv vv cv cmi co cpli co cmi co vy cv vw cv vu cv cmi co cmi
      co vy visset vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co cmi
      oprex vy cv vw cv vu cv cmi co cmi oprex distrpqlem syl eqtr4d vx cv vy
      cv vz cv vw cv mulpipq vx cv vy cv vv cv vu cv mulpipq vx cv vz cv cmi co
      vy cv vw cv cmi co vx cv vv cv cmi co vy cv vu cv cmi co addpipq vz cv
      cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vu cv cnpi wcel wa wa vz cv
      vu cv cmi co vw cv vv cv cmi co cpli co cnpi wcel vw cv vu cv cmi co cnpi
      wcel vz cv cnpi wcel vu cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel vz
      cv vu cv cmi co vw cv vv cv cmi co cpli co cnpi wcel vz cv vu cv cmi co
      cnpi wcel vw cv vv cv cmi co cnpi wcel vz cv vu cv cmi co vw cv vv cv cmi
      co cpli co cnpi wcel vz cv cnpi wcel vu cv cnpi wcel wa vw cv cnpi wcel
      vv cv cnpi wcel wa vz cv vu cv cmi co vw cv vv cv cmi co addclpi vz cv vu
      cv mulclpi vw cv vv cv mulclpi syl2an an42s vw cv cnpi wcel vu cv cnpi
      wcel vw cv vu cv cmi co cnpi wcel vz cv cnpi wcel vv cv cnpi wcel vw cv
      vu cv mulclpi ad2ant2l jca vx cv cnpi wcel vz cv cnpi wcel vy cv cnpi
      wcel vw cv cnpi wcel vx cv vz cv cmi co cnpi wcel vy cv vw cv cmi co cnpi
      wcel wa vx cv cnpi wcel vz cv cnpi wcel wa vx cv vz cv cmi co cnpi wcel
      vy cv cnpi wcel vw cv cnpi wcel wa vy cv vw cv cmi co cnpi wcel vx cv vz
      cv mulclpi vy cv vw cv mulclpi anim12i an4s vx cv cnpi wcel vv cv cnpi
      wcel vy cv cnpi wcel vu cv cnpi wcel vx cv vv cv cmi co cnpi wcel vy cv
      vu cv cmi co cnpi wcel wa vx cv cnpi wcel vv cv cnpi wcel wa vx cv vv cv
      cmi co cnpi wcel vy cv cnpi wcel vu cv cnpi wcel wa vy cv vu cv cmi co
      cnpi wcel vx cv vv cv mulclpi vy cv vu cv mulclpi anim12i an4s vy cv vx
      cv cmi co vz cv vu cv cmi co vw cv vv cv cmi co cpli co cmi co vy cv vx
      cv cmi co vz cv vu cv cmi co cmi co vy cv vx cv cmi co vw cv vv cv cmi co
      cmi co cpli co vy cv vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co
      cmi co cmi co vx cv vz cv cmi co vy cv vu cv cmi co cmi co vy cv vw cv
      cmi co vx cv vv cv cmi co cmi co cpli co vy cv vx cv cmi co vz cv vu cv
      cmi co vw cv vv cv cmi co vz cv vu cv cmi oprex vw cv vv cv cmi oprex
      distrpi vy cv vx cv vz cv vu cv cmi co vw cv vv cv cmi co cpli co vx
      visset vz cv vu cv cmi co vw cv vv cv cmi co cpli oprex mulasspi vy cv vx
      cv cmi co vz cv vu cv cmi co cmi co vx cv vz cv cmi co vy cv vu cv cmi co
      cmi co vy cv vx cv cmi co vw cv vv cv cmi co cmi co vy cv vw cv cmi co vx
      cv vv cv cmi co cmi co cpli vx cv vy cv cmi co vz cv vu cv cmi co cmi co
      vy cv vx cv cmi co vz cv vu cv cmi co cmi co vx cv vz cv cmi co vy cv vu
      cv cmi co cmi co vx cv vy cv cmi co vy cv vx cv cmi co vz cv vu cv cmi co
      cmi vx cv vy cv vx visset vy visset mulcompi opreq1i vf vg vh vx cv vy cv
      vz cv vu cv cmi vx visset vy visset vz visset vf cv vg cv vf visset vg
      visset mulcompi vf cv vg cv vh cv vg visset vh visset mulasspi vu visset
      caopr4 eqtr3i vf vg vh vy cv vx cv vw cv vv cv cmi vy visset vx visset vw
      visset vf cv vg cv vf visset vg visset mulcompi vf cv vg cv vh cv vg
      visset vh visset mulasspi vv visset caopr4 opreq12i 3eqtr3i vy cv vy cv
      cmi co vw cv vu cv cmi co cmi co vy cv vy cv vw cv vu cv cmi co cmi co
      cmi co vy cv vw cv cmi co vy cv vu cv cmi co cmi co vy cv vy cv vw cv vu
      cv cmi co vy visset vw cv vu cv cmi oprex mulasspi vf vg vh vy cv vy cv
      vw cv vu cv cmi vy visset vy visset vw visset vf cv vg cv vf visset vg
      visset mulcompi vf cv vg cv vh cv vg visset vh visset mulasspi vu visset
      caopr4 eqtr3i ecoprdi cA cB cC cnq cplq cmq distrpq.1 dmaddpq distrpq.2
      0npq dmmulpq ndmoprdistr pm2.61i $.
      $( [2-Sep-1995] $)
  $}

  ${
    1qec.1 $e |- A e. _V $.
    $( The equivalence class of ratio 1. $)
    1qec $p |- ( A e. N. -> 1Q = [ <. A , A >. ] ~Q ) $=
      cA cnpi wcel c1o c1o cop ceq cec cA cA cop ceq cec c1q cA cnpi wcel cA
      c1o cmi co cA c1o cmi co cop ceq cec c1o c1o cop ceq cec cA cA cop ceq
      cec cA cnpi wcel c1o cnpi wcel c1o cnpi wcel cA c1o cmi co cA c1o cmi co
      cop ceq cec c1o c1o cop ceq cec wceq 1pi 1pi cA c1o c1o 1qec.1 c1o cnpi
      1pi elisseti c1o cnpi 1pi elisseti distrpqlem mp3an23 cA cnpi wcel cA c1o
      cmi co cA wceq cA c1o cmi co cA wceq wa cA c1o cmi co cA c1o cmi co cop
      cA cA cop wceq cA c1o cmi co cA c1o cmi co cop ceq cec cA cA cop ceq cec
      wceq cA cnpi wcel cA c1o cmi co cA wceq cA c1o cmi co cA wceq cA mulidpi
      cA mulidpi jca cA c1o cmi co cA c1o cmi co cA cA opeq12 cA c1o cmi co cA
      c1o cmi co cop cA cA cop ceq eceq2 3syl eqtr3d df-1q syl5eq $.
      $( [4-Mar-1996] $)
  $}

  ${
    $d x y A $.
    $( Multiplication identity element for positive fractions. $)
    mulidpq $p |- ( A e. Q. -> ( A .Q 1Q ) = A ) $=
      vx cv vy cv cop ceq cec c1q cmq co vx cv vy cv cop ceq cec wceq cA c1q
      cmq co cA wceq vx vy cA cnpi cnpi ceq cnq df-nq vx cv vy cv cop ceq cec
      cA wceq vx cv vy cv cop ceq cec c1q cmq co cA c1q cmq co vx cv vy cv cop
      ceq cec cA vx cv vy cv cop ceq cec cA c1q cmq opreq1 vx cv vy cv cop ceq
      cec cA wceq id eqeq12d vx cv cnpi wcel vy cv cnpi wcel wa vx cv vy cv cop
      ceq cec c1q cmq co c1o vx cv cmi co c1o vy cv cmi co cop ceq cec vx cv vy
      cv cop ceq cec vx cv cnpi wcel vy cv cnpi wcel wa vx cv vy cv cop ceq cec
      c1o c1o cop ceq cec cmq co vx cv c1o cmi co vy cv c1o cmi co cop ceq cec
      vx cv vy cv cop ceq cec c1q cmq co c1o vx cv cmi co c1o vy cv cmi co cop
      ceq cec vx cv cnpi wcel vy cv cnpi wcel wa c1o cnpi wcel c1o cnpi wcel vx
      cv vy cv cop ceq cec c1o c1o cop ceq cec cmq co vx cv c1o cmi co vy cv
      c1o cmi co cop ceq cec wceq 1pi 1pi vx cv vy cv c1o c1o mulpipq mpanr12
      c1q c1o c1o cop ceq cec vx cv vy cv cop ceq cec cmq df-1q opreq2i c1o vx
      cv cmi co c1o vy cv cmi co cop vx cv c1o cmi co vy cv c1o cmi co cop wceq
      c1o vx cv cmi co c1o vy cv cmi co cop ceq cec vx cv c1o cmi co vy cv c1o
      cmi co cop ceq cec wceq c1o vx cv cmi co vx cv c1o cmi co c1o vy cv cmi
      co vy cv c1o cmi co c1o vx cv c1o cnpi 1pi elisseti vx visset mulcompi
      c1o vy cv c1o cnpi 1pi elisseti vy visset mulcompi opeq12i c1o vx cv cmi
      co c1o vy cv cmi co cop vx cv c1o cmi co vy cv c1o cmi co cop ceq eceq2
      ax-mp 3eqtr4g c1o cnpi wcel vx cv cnpi wcel vy cv cnpi wcel c1o vx cv cmi
      co c1o vy cv cmi co cop ceq cec vx cv vy cv cop ceq cec wceq 1pi c1o vx
      cv vy cv c1o cnpi 1pi elisseti vx visset vy visset distrpqlem mp3an1
      eqtrd ecoptocl $.
      $( [3-Mar-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y z w v $.

    recmulpq.1 $e |- B e. _V $.
    $( Relationship between reciprocal and multiplication on positive
       fractions. $)
    recmulpq $p |- ( A e. Q. -> ( ( *Q ` A ) = B <-> ( A .Q B ) = 1Q ) ) $=
      vx cv vy cv cmq co c1q wceq cA vy cv cmq co c1q wceq cA cB cmq co c1q
      wceq vx vy cA cB cnq crq recmulpq.1 vx cv cA wceq vx cv vy cv cmq co cA
      vy cv cmq co c1q vx cv cA vy cv cmq opreq1 eqeq1d vy cv cB wceq cA vy cv
      cmq co cA cB cmq co c1q vy cv cB cA cmq opreq2 eqeq1d vx cv cnq wcel vx
      cv vy cv cmq co c1q wceq vy wex vx cv vy cv cmq co c1q wceq vy weu vz cv
      vw cv cop ceq cec vy cv cmq co c1q wceq vy wex vx cv vy cv cmq co c1q
      wceq vy wex vz vw vx cv cnpi cnpi ceq cnq df-nq vz cv vw cv cop ceq cec
      vx cv wceq vz cv vw cv cop ceq cec vy cv cmq co c1q wceq vx cv vy cv cmq
      co c1q wceq vy vz cv vw cv cop ceq cec vx cv wceq vz cv vw cv cop ceq cec
      vy cv cmq co vx cv vy cv cmq co c1q vz cv vw cv cop ceq cec vx cv vy cv
      cmq opreq1 eqeq1d exbidv vz cv cnpi wcel vw cv cnpi wcel wa vz cv vw cv
      cop ceq cec vw cv vz cv cop ceq cec cmq co c1q wceq vz cv vw cv cop ceq
      cec vy cv cmq co c1q wceq vy wex vz cv cnpi wcel vw cv cnpi wcel wa vz cv
      vw cv cop ceq cec vw cv vz cv cop ceq cec cmq co vz cv vw cv cmi co vw cv
      vz cv cmi co cop ceq cec c1q vz cv cnpi wcel vw cv cnpi wcel wa vz cv vw
      cv cop ceq cec vw cv vz cv cop ceq cec cmq co vz cv vw cv cmi co vw cv vz
      cv cmi co cop ceq cec wceq vz cv cnpi wcel vw cv cnpi wcel vw cv cnpi
      wcel vz cv cnpi wcel vz cv vw cv cop ceq cec vw cv vz cv cop ceq cec cmq
      co vz cv vw cv cmi co vw cv vz cv cmi co cop ceq cec wceq vz cv vw cv vw
      cv vz cv mulpipq an42s anidms vz cv cnpi wcel vw cv cnpi wcel wa vz cv vw
      cv cmi co cnpi wcel c1q vz cv vw cv cmi co vw cv vz cv cmi co cop ceq cec
      wceq vz cv vw cv mulclpi vz cv vw cv cmi co cnpi wcel c1q vz cv vw cv cmi
      co vz cv vw cv cmi co cop ceq cec vz cv vw cv cmi co vw cv vz cv cmi co
      cop ceq cec vz cv vw cv cmi co vz cv vw cv cmi oprex 1qec vz cv vw cv cmi
      co vz cv vw cv cmi co cop vz cv vw cv cmi co vw cv vz cv cmi co cop wceq
      vz cv vw cv cmi co vz cv vw cv cmi co cop ceq cec vz cv vw cv cmi co vw
      cv vz cv cmi co cop ceq cec wceq vz cv vw cv cmi co vw cv vz cv cmi co vz
      cv vw cv cmi co vz cv vw cv vz visset vw visset mulcompi opeq2i vz cv vw
      cv cmi co vz cv vw cv cmi co cop vz cv vw cv cmi co vw cv vz cv cmi co
      cop ceq eceq2 ax-mp syl6eq syl eqtr4d vz cv vw cv cop ceq cec vy cv cmq
      co c1q wceq vz cv vw cv cop ceq cec vw cv vz cv cop ceq cec cmq co c1q
      wceq vy vw cv vz cv cop ceq cec ceq cvv wcel vw cv vz cv cop ceq cec cvv
      wcel enqex vw cv vz cv cop cvv ceq ecexg ax-mp vy cv vw cv vz cv cop ceq
      cec wceq vz cv vw cv cop ceq cec vy cv cmq co vz cv vw cv cop ceq cec vw
      cv vz cv cop ceq cec cmq co c1q vy cv vw cv vz cv cop ceq cec vz cv vw cv
      cop ceq cec cmq opreq2 eqeq1d cla4ev syl ecoptocl vx cv vy cv cmq co c1q
      wceq vy weu vx cv vy cv cmq co c1q wceq vy wex vx cv vy cv cmq co c1q
      wceq vy wmo vx cv vy cv cmq co c1q wceq vy eu5 vz vw vv vy vx cv c1q cnq
      cmq vx visset 1q dmmulpq 0npq vz cv vw cv vz visset vw visset mulcompq vz
      cv vw cv vv cv vw visset vv visset mulasspq vz cv mulidpq caoprmo
      mpbiran2 sylibr vx vy df-rq fvopab3 $.
      $( [6-Mar-1996] $)
  $}

  $( A positive fraction times its reciprocal is 1. $)
  recidpq $p |- ( A e. Q. -> ( A .Q ( *Q ` A ) ) = 1Q ) $=
    cA cnq wcel cA crq cfv cA crq cfv wceq cA cA crq cfv cmq co c1q wceq cA crq
    cfv eqid cA cA crq cfv cA crq fvex recmulpq mpbii $.
    $( [6-Mar-1996] $)

  $( Closure law for positive fraction reciprocal. $)
  recclpq $p |- ( A e. Q. -> ( *Q ` A ) e. Q. ) $=
    cA cnq wcel cA cA crq cfv cmq co cnq wcel cA crq cfv cnq wcel cA cnq wcel
    cA cA crq cfv cmq co c1q cnq cA recidpq 1q syl6eqel cA cA crq cfv cmq co
    cnq wcel cA cnq wcel cA crq cfv cnq wcel cA cA crq cfv cnq cmq cA crq fvex
    dmmulpq 0npq ndmoprrcl pm3.27d syl $.
    $( [6-Mar-1996] $)

  ${
    recrecpq.1 $e |- A e. _V $.
    $( Reciprocal of reciprocal of positive fraction. $)
    recrecpq $p |- ( A e. Q. -> ( *Q ` ( *Q ` A ) ) = A ) $=
      cA cnq wcel cA crq cfv crq cfv cA wceq cA crq cfv cA cmq co c1q wceq cA
      cnq wcel cA cA crq cfv cmq co c1q cA crq cfv cA cmq co cA recidpq cA crq
      cfv cA cA crq fvex recrecpq.1 mulcompq syl5eq cA cnq wcel cA crq cfv cnq
      wcel cA crq cfv crq cfv cA wceq cA crq cfv cA cmq co c1q wceq wb cA
      recclpq cA crq cfv cA recrecpq.1 recmulpq syl mpbird $.
      $( [26-Apr-1996] $)
  $}

  ${
    $d x y $.
    $( Domain of reciprocal on positive fractions. $)
    dmrecpq $p |- dom *Q = Q. $=
      crq cdm vx cv cnq wcel vx cv vy cv cmq co c1q wceq wa vx vy copab cdm cnq
      crq vx cv cnq wcel vx cv vy cv cmq co c1q wceq wa vx vy copab vx vy df-rq
      dmeqi vx cv vy cv cmq co c1q wceq vy wex vx cnq wral vx cv cnq wcel vx cv
      vy cv cmq co c1q wceq wa vx vy copab cdm cnq wceq vx cv vy cv cmq co c1q
      wceq vy wex vx cnq vx cv cnq wcel vx cv vx cv crq cfv cmq co c1q wceq vx
      cv vy cv cmq co c1q wceq vy wex vx cv recidpq vx cv vy cv cmq co c1q wceq
      vx cv vx cv crq cfv cmq co c1q wceq vy vx cv crq cfv vx cv crq fvex vy cv
      vx cv crq cfv wceq vx cv vy cv cmq co vx cv vx cv crq cfv cmq co c1q vy
      cv vx cv crq cfv vx cv cmq opreq2 eqeq1d cla4ev syl rgen vx cv vy cv cmq
      co c1q wceq vx vy cnq dmopab3 mpbi eqtri $.
      $( [6-Mar-1996] $)
  $}

  ${
    $d x y z w v u f g h $.
    $( 'Less than' is a strict ordering on positive fractions. $)
    ltsopq $p |- <Q Or Q. $=
      vf vg vh cnq cltq vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq
      wbr vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec wceq vz cv vw cv cop
      ceq cec vx cv vy cv cop ceq cec cltq wbr wo wn wb vx cv vy cv cop ceq cec
      vz cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv vu cv cop
      ceq cec cltq wbr wa vx cv vy cv cop ceq cec vv cv vu cv cop ceq cec cltq
      wbr wi wa vf cv vz cv vw cv cop ceq cec cltq wbr vf cv vz cv vw cv cop
      ceq cec wceq vz cv vw cv cop ceq cec vf cv cltq wbr wo wn wb vf cv vz cv
      vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv vu cv cop ceq
      cec cltq wbr wa vf cv vv cv vu cv cop ceq cec cltq wbr wi wa vf cv vg cv
      cltq wbr vf cv vg cv wceq vg cv vf cv cltq wbr wo wn wb vf cv vg cv cltq
      wbr vg cv vv cv vu cv cop ceq cec cltq wbr wa vf cv vv cv vu cv cop ceq
      cec cltq wbr wi wa vf cv vg cv cltq wbr vf cv vg cv wceq vg cv vf cv cltq
      wbr wo wn wb vf cv vg cv cltq wbr vg cv vh cv cltq wbr wa vf cv vh cv
      cltq wbr wi wa vx vy vz vw vv vu vf cv vg cv vh cv cnpi ceq cnq df-nq vx
      cv vy cv cop ceq cec vf cv wceq vx cv vy cv cop ceq cec vz cv vw cv cop
      ceq cec cltq wbr vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec wceq vz
      cv vw cv cop ceq cec vx cv vy cv cop ceq cec cltq wbr wo wn wb vf cv vz
      cv vw cv cop ceq cec cltq wbr vf cv vz cv vw cv cop ceq cec wceq vz cv vw
      cv cop ceq cec vf cv cltq wbr wo wn wb vx cv vy cv cop ceq cec vz cv vw
      cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv vu cv cop ceq cec
      cltq wbr wa vx cv vy cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr wi
      vf cv vz cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv vu
      cv cop ceq cec cltq wbr wa vf cv vv cv vu cv cop ceq cec cltq wbr wi vx
      cv vy cv cop ceq cec vf cv wceq vx cv vy cv cop ceq cec vz cv vw cv cop
      ceq cec cltq wbr vf cv vz cv vw cv cop ceq cec cltq wbr vx cv vy cv cop
      ceq cec vz cv vw cv cop ceq cec wceq vz cv vw cv cop ceq cec vx cv vy cv
      cop ceq cec cltq wbr wo wn vf cv vz cv vw cv cop ceq cec wceq vz cv vw cv
      cop ceq cec vf cv cltq wbr wo wn vx cv vy cv cop ceq cec vf cv vz cv vw
      cv cop ceq cec cltq breq1 vx cv vy cv cop ceq cec vf cv wceq vx cv vy cv
      cop ceq cec vz cv vw cv cop ceq cec wceq vz cv vw cv cop ceq cec vx cv vy
      cv cop ceq cec cltq wbr wo vf cv vz cv vw cv cop ceq cec wceq vz cv vw cv
      cop ceq cec vf cv cltq wbr wo vx cv vy cv cop ceq cec vf cv wceq vx cv vy
      cv cop ceq cec vz cv vw cv cop ceq cec wceq vf cv vz cv vw cv cop ceq cec
      wceq vz cv vw cv cop ceq cec vx cv vy cv cop ceq cec cltq wbr vz cv vw cv
      cop ceq cec vf cv cltq wbr vx cv vy cv cop ceq cec vf cv vz cv vw cv cop
      ceq cec eqeq1 vx cv vy cv cop ceq cec vf cv vz cv vw cv cop ceq cec cltq
      breq2 orbi12d notbid bibi12d vx cv vy cv cop ceq cec vf cv wceq vx cv vy
      cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec
      vv cv vu cv cop ceq cec cltq wbr wa vf cv vz cv vw cv cop ceq cec cltq
      wbr vz cv vw cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr wa vx cv vy
      cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr vf cv vv cv vu cv cop ceq
      cec cltq wbr vx cv vy cv cop ceq cec vf cv wceq vx cv vy cv cop ceq cec
      vz cv vw cv cop ceq cec cltq wbr vf cv vz cv vw cv cop ceq cec cltq wbr
      vz cv vw cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr vx cv vy cv cop
      ceq cec vf cv vz cv vw cv cop ceq cec cltq breq1 anbi1d vx cv vy cv cop
      ceq cec vf cv vv cv vu cv cop ceq cec cltq breq1 imbi12d anbi12d vz cv vw
      cv cop ceq cec vg cv wceq vf cv vz cv vw cv cop ceq cec cltq wbr vf cv vz
      cv vw cv cop ceq cec wceq vz cv vw cv cop ceq cec vf cv cltq wbr wo wn wb
      vf cv vg cv cltq wbr vf cv vg cv wceq vg cv vf cv cltq wbr wo wn wb vf cv
      vz cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv vu cv cop
      ceq cec cltq wbr wa vf cv vv cv vu cv cop ceq cec cltq wbr wi vf cv vg cv
      cltq wbr vg cv vv cv vu cv cop ceq cec cltq wbr wa vf cv vv cv vu cv cop
      ceq cec cltq wbr wi vz cv vw cv cop ceq cec vg cv wceq vf cv vz cv vw cv
      cop ceq cec cltq wbr vf cv vg cv cltq wbr vf cv vz cv vw cv cop ceq cec
      wceq vz cv vw cv cop ceq cec vf cv cltq wbr wo wn vf cv vg cv wceq vg cv
      vf cv cltq wbr wo wn vz cv vw cv cop ceq cec vg cv vf cv cltq breq2 vz cv
      vw cv cop ceq cec vg cv wceq vf cv vz cv vw cv cop ceq cec wceq vz cv vw
      cv cop ceq cec vf cv cltq wbr wo vf cv vg cv wceq vg cv vf cv cltq wbr wo
      vz cv vw cv cop ceq cec vg cv wceq vf cv vz cv vw cv cop ceq cec wceq vf
      cv vg cv wceq vz cv vw cv cop ceq cec vf cv cltq wbr vg cv vf cv cltq wbr
      vz cv vw cv cop ceq cec vg cv vf cv eqeq2 vz cv vw cv cop ceq cec vg cv
      vf cv cltq breq1 orbi12d notbid bibi12d vz cv vw cv cop ceq cec vg cv
      wceq vf cv vz cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv
      vu cv cop ceq cec cltq wbr wa vf cv vg cv cltq wbr vg cv vv cv vu cv cop
      ceq cec cltq wbr wa vf cv vv cv vu cv cop ceq cec cltq wbr vz cv vw cv
      cop ceq cec vg cv wceq vf cv vz cv vw cv cop ceq cec cltq wbr vf cv vg cv
      cltq wbr vz cv vw cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr vg cv
      vv cv vu cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vg cv vf cv cltq
      breq2 vz cv vw cv cop ceq cec vg cv vv cv vu cv cop ceq cec cltq breq1
      anbi12d imbi1d anbi12d vv cv vu cv cop ceq cec vh cv wceq vf cv vg cv
      cltq wbr vg cv vv cv vu cv cop ceq cec cltq wbr wa vf cv vv cv vu cv cop
      ceq cec cltq wbr wi vf cv vg cv cltq wbr vg cv vh cv cltq wbr wa vf cv vh
      cv cltq wbr wi vf cv vg cv cltq wbr vf cv vg cv wceq vg cv vf cv cltq wbr
      wo wn wb vv cv vu cv cop ceq cec vh cv wceq vf cv vg cv cltq wbr vg cv vv
      cv vu cv cop ceq cec cltq wbr wa vf cv vg cv cltq wbr vg cv vh cv cltq
      wbr wa vf cv vv cv vu cv cop ceq cec cltq wbr vf cv vh cv cltq wbr vv cv
      vu cv cop ceq cec vh cv wceq vg cv vv cv vu cv cop ceq cec cltq wbr vg cv
      vh cv cltq wbr vf cv vg cv cltq wbr vv cv vu cv cop ceq cec vh cv vg cv
      cltq breq2 anbi2d vv cv vu cv cop ceq cec vh cv vf cv cltq breq2 imbi12d
      anbi2d vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel
      wa vv cv cnpi wcel vu cv cnpi wcel wa w3a vx cv vy cv cop ceq cec vz cv
      vw cv cop ceq cec cltq wbr vx cv vy cv cop ceq cec vz cv vw cv cop ceq
      cec wceq vz cv vw cv cop ceq cec vx cv vy cv cop ceq cec cltq wbr wo wn
      wb vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vz cv vw cv
      cop ceq cec vv cv vu cv cop ceq cec cltq wbr wa vx cv vy cv cop ceq cec
      vv cv vu cv cop ceq cec cltq wbr wi vx cv cnpi wcel vy cv cnpi wcel wa vz
      cv cnpi wcel vw cv cnpi wcel wa vx cv vy cv cop ceq cec vz cv vw cv cop
      ceq cec cltq wbr vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec wceq vz
      cv vw cv cop ceq cec vx cv vy cv cop ceq cec cltq wbr wo wn wb vv cv cnpi
      wcel vu cv cnpi wcel wa vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi
      wcel vw cv cnpi wcel wa wa vx cv vw cv cmi co vy cv vz cv cmi co clti wbr
      vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec wceq vz cv vw cv cop ceq
      cec vx cv vy cv cop ceq cec cltq wbr wo wn vx cv vy cv cop ceq cec vz cv
      vw cv cop ceq cec cltq wbr vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi
      wcel vw cv cnpi wcel wa wa vx cv vw cv cmi co vy cv vz cv cmi co clti wbr
      vx cv vw cv cmi co vy cv vz cv cmi co wceq vy cv vz cv cmi co vx cv vw cv
      cmi co clti wbr wo wn vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec
      wceq vz cv vw cv cop ceq cec vx cv vy cv cop ceq cec cltq wbr wo wn vx cv
      cnpi wcel vw cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vx cv vw cv cmi
      co vy cv vz cv cmi co clti wbr vx cv vw cv cmi co vy cv vz cv cmi co wceq
      vy cv vz cv cmi co vx cv vw cv cmi co clti wbr wo wn wb vx cv vw cv cmi
      co cnpi wcel vy cv vz cv cmi co cnpi wcel vx cv vw cv cmi co vy cv vz cv
      cmi co clti wbr vx cv vw cv cmi co vy cv vz cv cmi co wceq vy cv vz cv
      cmi co vx cv vw cv cmi co clti wbr wo wn wb vx cv cnpi wcel vw cv cnpi
      wcel wa vy cv cnpi wcel vz cv cnpi wcel wa cnpi clti wor vx cv vw cv cmi
      co cnpi wcel vy cv vz cv cmi co cnpi wcel wa vx cv vw cv cmi co vy cv vz
      cv cmi co clti wbr vx cv vw cv cmi co vy cv vz cv cmi co wceq vy cv vz cv
      cmi co vx cv vw cv cmi co clti wbr wo wn wb ltsopi cnpi vx cv vw cv cmi
      co vy cv vz cv cmi co clti sotric mpan vx cv vw cv mulclpi vy cv vz cv
      mulclpi syl2an an42s vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel
      vw cv cnpi wcel wa wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec
      wceq vz cv vw cv cop ceq cec vx cv vy cv cop ceq cec cltq wbr wo vx cv vw
      cv cmi co vy cv vz cv cmi co wceq vy cv vz cv cmi co vx cv vw cv cmi co
      clti wbr wo vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi
      wcel wa wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec wceq vx cv vw
      cv cmi co vy cv vz cv cmi co wceq vz cv vw cv cop ceq cec vx cv vy cv cop
      ceq cec cltq wbr vy cv vz cv cmi co vx cv vw cv cmi co clti wbr vx cv vy
      cv vz cv vw cv enqeceq vz cv vw cv cop ceq cec vx cv vy cv cop ceq cec
      cltq wbr vy cv vz cv cmi co vx cv vw cv cmi co clti wbr wb vx cv cnpi
      wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa vz cv vw cv
      cop ceq cec vx cv vy cv cop ceq cec cltq wbr vz cv vy cv cmi co vw cv vx
      cv cmi co clti wbr vy cv vz cv cmi co vx cv vw cv cmi co clti wbr vz cv
      vw cv vx cv vy cv vz visset vw visset vx visset vy visset ordpipq vz cv
      vy cv cmi co vy cv vz cv cmi co vw cv vx cv cmi co vx cv vw cv cmi co
      clti vz cv vy cv vz visset vy visset mulcompi vw cv vx cv vw visset vx
      visset mulcompi breq12i bitri a1i orbi12d notbid bitr4d vx cv vy cv vz cv
      vw cv vx visset vy visset vz visset vw visset ordpipq syl5bb 3adant3 vx
      cv cnpi wcel vy cv cnpi wcel wa vv cv cnpi wcel vu cv cnpi wcel wa vx cv
      vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq
      cec vv cv vu cv cop ceq cec cltq wbr wa vx cv vy cv cop ceq cec vv cv vu
      cv cop ceq cec cltq wbr wi vz cv cnpi wcel vw cv cnpi wcel wa vy cv cnpi
      wcel vu cv cnpi wcel vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq
      wbr vz cv vw cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr wa vx cv vy
      cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr wi vx cv cnpi wcel vv cv
      cnpi wcel vy cv cnpi wcel vu cv cnpi wcel wa vx cv vy cv cop ceq cec vz
      cv vw cv cop ceq cec cltq wbr vz cv vw cv cop ceq cec vv cv vu cv cop ceq
      cec cltq wbr wa vx cv vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co
      cmi co clti wbr vy cv vz cv vu cv cmi co cmi co vy cv vw cv vv cv cmi co
      cmi co clti wbr wa vx cv vy cv cop ceq cec vv cv vu cv cop ceq cec cltq
      wbr vu cv cnpi wcel vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq
      wbr vx cv vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co cmi co clti
      wbr vy cv cnpi wcel vz cv vw cv cop ceq cec vv cv vu cv cop ceq cec cltq
      wbr vy cv vz cv vu cv cmi co cmi co vy cv vw cv vv cv cmi co cmi co clti
      wbr vu cv cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co clti wbr vx cv
      vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co cmi co clti wbr vx cv
      vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vu cv cnpi wcel vx cv
      vw cv cmi co vy cv vz cv cmi co clti wbr vx cv vw cv cmi co vu cv cmi co
      vy cv vz cv cmi co vu cv cmi co clti wbr vx cv vw cv vu cv cmi co cmi co
      vy cv vz cv vu cv cmi co cmi co clti wbr vf vg vh vx cv vw cv cmi co vy
      cv vz cv cmi co vu cv clti cnpi cmi vx cv vw cv cmi oprex vy cv vz cv cmi
      oprex vf cv vg cv vh cv vf visset vg visset ltmpi vu visset vf cv vg cv
      vf visset vg visset mulcompi caoprord2 vx cv vw cv cmi co vu cv cmi co vx
      cv vw cv vu cv cmi co cmi co vy cv vz cv cmi co vu cv cmi co vy cv vz cv
      vu cv cmi co cmi co clti vx cv vw cv vu cv vw visset vu visset mulasspi
      vy cv vz cv vu cv vz visset vu visset mulasspi breq12i syl6bb vx cv vy cv
      vz cv vw cv vx visset vy visset vz visset vw visset ordpipq syl5bb vy cv
      cnpi wcel vz cv vu cv cmi co vw cv vv cv cmi co clti wbr vy cv vz cv vu
      cv cmi co cmi co vy cv vw cv vv cv cmi co cmi co clti wbr vz cv vw cv cop
      ceq cec vv cv vu cv cop ceq cec cltq wbr vz cv vu cv cmi co vw cv vv cv
      cmi co vy cv vz cv vu cv cmi oprex vw cv vv cv cmi oprex ltmpi vz cv vw
      cv vv cv vu cv vz visset vw visset vv visset vu visset ordpipq syl5bb
      bi2anan9r vx cv vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co cmi co
      clti wbr vy cv vz cv vu cv cmi co cmi co vy cv vw cv vv cv cmi co cmi co
      clti wbr wa vx cv vw cv vu cv cmi co cmi co vy cv vw cv vv cv cmi co cmi
      co clti wbr vx cv vy cv cop ceq cec vv cv vu cv cop ceq cec cltq wbr vx
      cv vw cv vu cv cmi co cmi co vy cv vz cv vu cv cmi co cmi co vy cv vw cv
      vv cv cmi co cmi co clti cnpi vx cv vw cv vu cv cmi co cmi oprex ltsopi
      ltrelpi vy cv vz cv vu cv cmi co cmi oprex vy cv vw cv vv cv cmi co cmi
      oprex sotri vw cv vx cv vu cv cmi co cmi co vw cv vy cv vv cv cmi co cmi
      co clti wbr vx cv vu cv cmi co vy cv vv cv cmi co clti wbr vx cv vw cv vu
      cv cmi co cmi co vy cv vw cv vv cv cmi co cmi co clti wbr vx cv vy cv cop
      ceq cec vv cv vu cv cop ceq cec cltq wbr vx cv vu cv cmi co vy cv vv cv
      cmi co vw cv clti cnpi cmi vx cv vu cv cmi oprex dmmulpi ltrelpi 0npi vx
      cv vu cv cmi co vy cv vv cv cmi co vw cv vx cv vu cv cmi oprex vy cv vv
      cv cmi oprex ltmpi ndmordi vx cv vw cv vu cv cmi co cmi co vw cv vx cv vu
      cv cmi co cmi co vy cv vw cv vv cv cmi co cmi co vw cv vy cv vv cv cmi co
      cmi co clti vf vg vh vx cv vw cv vu cv cmi vx visset vw visset vu visset
      vf cv vg cv vf visset vg visset mulcompi vf cv vg cv vh cv vg visset vh
      visset mulasspi caopr12 vf vg vh vy cv vw cv vv cv cmi vy visset vw
      visset vv visset vf cv vg cv vf visset vg visset mulcompi vf cv vg cv vh
      cv vg visset vh visset mulasspi caopr12 breq12i vx cv vy cv vv cv vu cv
      vx visset vy visset vv visset vu visset ordpipq 3imtr4i syl syl6bi
      ad2ant2l 3adant2 jca 3ecoptocl so $.
      $( [19-Feb-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    ltapq.1 $e |- A e. _V $.
    ltapq.2 $e |- B e. _V $.
    $( Ordering property of addition for positive fractions.  Proposition
       9-2.6(ii) of [Gleason] p. 120. $)
    ltapq $p |- ( C e. Q. -> ( A <Q B <-> ( C +Q A ) <Q ( C +Q B ) ) ) $=
      cA cB cC cltq cnq cplq ltapq.2 dmaddpq ltapq.1 ltrelpq 0npq vx cv vy cv
      cop ceq cec vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop ceq cec vx
      cv vy cv cop ceq cec cplq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq
      cec cplq co cltq wbr wb cA vz cv vw cv cop ceq cec cltq wbr vv cv vu cv
      cop ceq cec cA cplq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec
      cplq co cltq wbr wb cA cB cltq wbr vv cv vu cv cop ceq cec cA cplq co vv
      cv vu cv cop ceq cec cB cplq co cltq wbr wb cA cB cltq wbr cC cA cplq co
      cC cB cplq co cltq wbr wb vx vy vz vw vv vu cA cB cC cnpi ceq cnq df-nq
      vx cv vy cv cop ceq cec cA wceq vx cv vy cv cop ceq cec vz cv vw cv cop
      ceq cec cltq wbr cA vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop ceq
      cec vx cv vy cv cop ceq cec cplq co vv cv vu cv cop ceq cec vz cv vw cv
      cop ceq cec cplq co cltq wbr vv cv vu cv cop ceq cec cA cplq co vv cv vu
      cv cop ceq cec vz cv vw cv cop ceq cec cplq co cltq wbr vx cv vy cv cop
      ceq cec cA vz cv vw cv cop ceq cec cltq breq1 vx cv vy cv cop ceq cec cA
      wceq vv cv vu cv cop ceq cec vx cv vy cv cop ceq cec cplq co vv cv vu cv
      cop ceq cec cA cplq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec
      cplq co cltq vx cv vy cv cop ceq cec cA vv cv vu cv cop ceq cec cplq
      opreq2 breq1d bibi12d vz cv vw cv cop ceq cec cB wceq cA vz cv vw cv cop
      ceq cec cltq wbr cA cB cltq wbr vv cv vu cv cop ceq cec cA cplq co vv cv
      vu cv cop ceq cec vz cv vw cv cop ceq cec cplq co cltq wbr vv cv vu cv
      cop ceq cec cA cplq co vv cv vu cv cop ceq cec cB cplq co cltq wbr vz cv
      vw cv cop ceq cec cB cA cltq breq2 vz cv vw cv cop ceq cec cB wceq vv cv
      vu cv cop ceq cec vz cv vw cv cop ceq cec cplq co vv cv vu cv cop ceq cec
      cB cplq co vv cv vu cv cop ceq cec cA cplq co cltq vz cv vw cv cop ceq
      cec cB vv cv vu cv cop ceq cec cplq opreq2 breq2d bibi12d vv cv vu cv cop
      ceq cec cC wceq vv cv vu cv cop ceq cec cA cplq co vv cv vu cv cop ceq
      cec cB cplq co cltq wbr cC cA cplq co cC cB cplq co cltq wbr cA cB cltq
      wbr vv cv vu cv cop ceq cec cC wceq vv cv vu cv cop ceq cec cA cplq co cC
      cA cplq co vv cv vu cv cop ceq cec cB cplq co cC cB cplq co cltq vv cv vu
      cv cop ceq cec cC cA cplq opreq1 vv cv vu cv cop ceq cec cC cB cplq
      opreq1 breq12d bibi2d vv cv cnpi wcel vu cv cnpi wcel wa vx cv cnpi wcel
      vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa vx cv vy cv cop ceq
      cec vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop ceq cec vx cv vy cv
      cop ceq cec cplq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec cplq
      co cltq wbr wb vv cv cnpi wcel vu cv cnpi wcel wa vx cv cnpi wcel vy cv
      cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa vx cv vy cv cop ceq cec
      vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop ceq cec vx cv vy cv cop
      ceq cec cplq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec cplq co
      cltq wbr wb vv cv cnpi wcel vu cv cnpi wcel wa vx cv cnpi wcel vy cv cnpi
      wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa wa vx cv vy cv cop ceq cec
      vz cv vw cv cop ceq cec cltq wbr vv cv vy cv cmi co vu cv vx cv cmi co
      cpli co vu cv vy cv cmi co cop ceq cec vv cv vw cv cmi co vu cv vz cv cmi
      co cpli co vu cv vw cv cmi co cop ceq cec cltq wbr vv cv vu cv cop ceq
      cec vx cv vy cv cop ceq cec cplq co vv cv vu cv cop ceq cec vz cv vw cv
      cop ceq cec cplq co cltq wbr vv cv cnpi wcel vu cv cnpi wcel wa vy cv
      cnpi wcel vw cv cnpi wcel wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq
      cec cltq wbr vv cv vy cv cmi co vu cv vx cv cmi co cpli co vu cv vy cv
      cmi co cop ceq cec vv cv vw cv cmi co vu cv vz cv cmi co cpli co vu cv vw
      cv cmi co cop ceq cec cltq wbr wb vx cv cnpi wcel vy cv cnpi wcel wa vz
      cv cnpi wcel vw cv cnpi wcel wa wa vv cv cnpi wcel vy cv cnpi wcel vu cv
      cnpi wcel vw cv cnpi wcel vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec
      cltq wbr vv cv vy cv cmi co vu cv vx cv cmi co cpli co vu cv vy cv cmi co
      cop ceq cec vv cv vw cv cmi co vu cv vz cv cmi co cpli co vu cv vw cv cmi
      co cop ceq cec cltq wbr wb vv cv cnpi wcel vy cv cnpi wcel wa vu cv cnpi
      wcel vw cv cnpi wcel wa wa vx cv vw cv cmi co vy cv vz cv cmi co clti wbr
      vv cv vy cv cmi co vu cv vx cv cmi co cpli co vu cv vw cv cmi co cmi co
      vu cv vy cv cmi co vv cv vw cv cmi co vu cv vz cv cmi co cpli co cmi co
      clti wbr vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vv cv
      vy cv cmi co vu cv vx cv cmi co cpli co vu cv vy cv cmi co cop ceq cec vv
      cv vw cv cmi co vu cv vz cv cmi co cpli co vu cv vw cv cmi co cop ceq cec
      cltq wbr vv cv cnpi wcel vy cv cnpi wcel wa vu cv cnpi wcel vw cv cnpi
      wcel wa wa vx cv vw cv cmi co vy cv vz cv cmi co clti wbr vu cv vu cv cmi
      co vx cv vw cv cmi co cmi co vu cv vu cv cmi co vy cv vz cv cmi co cmi co
      clti wbr vv cv vy cv cmi co vu cv vx cv cmi co cpli co vu cv vw cv cmi co
      cmi co vu cv vy cv cmi co vv cv vw cv cmi co vu cv vz cv cmi co cpli co
      cmi co clti wbr vu cv cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co
      clti wbr vu cv vu cv cmi co vx cv vw cv cmi co cmi co vu cv vu cv cmi co
      vy cv vz cv cmi co cmi co clti wbr wb vv cv cnpi wcel vy cv cnpi wcel wa
      vw cv cnpi wcel vu cv cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co
      clti wbr vu cv vu cv cmi co vx cv vw cv cmi co cmi co vu cv vu cv cmi co
      vy cv vz cv cmi co cmi co clti wbr wb vu cv cnpi wcel vu cv cnpi wcel wa
      vu cv vu cv cmi co cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co clti
      wbr vu cv vu cv cmi co vx cv vw cv cmi co cmi co vu cv vu cv cmi co vy cv
      vz cv cmi co cmi co clti wbr wb vu cv vu cv mulclpi vx cv vw cv cmi co vy
      cv vz cv cmi co vu cv vu cv cmi co vx cv vw cv cmi oprex vy cv vz cv cmi
      oprex ltmpi syl anidms ad2antrl vv cv cnpi wcel vy cv cnpi wcel wa vu cv
      cnpi wcel vw cv cnpi wcel wa wa vu cv vx cv cmi co vu cv vw cv cmi co cmi
      co vu cv vy cv cmi co vu cv vz cv cmi co cmi co clti wbr vv cv vy cv cmi
      co vu cv vw cv cmi co cmi co vu cv vx cv cmi co vu cv vw cv cmi co cmi co
      cpli co vv cv vy cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co
      vu cv vz cv cmi co cmi co cpli co clti wbr vu cv vu cv cmi co vx cv vw cv
      cmi co cmi co vu cv vu cv cmi co vy cv vz cv cmi co cmi co clti wbr vv cv
      vy cv cmi co vu cv vx cv cmi co cpli co vu cv vw cv cmi co cmi co vu cv
      vy cv cmi co vv cv vw cv cmi co vu cv vz cv cmi co cpli co cmi co clti
      wbr vv cv cnpi wcel vy cv cnpi wcel wa vu cv cnpi wcel vw cv cnpi wcel wa
      wa vv cv vy cv cmi co cnpi wcel vu cv vw cv cmi co cnpi wcel wa vv cv vy
      cv cmi co vu cv vw cv cmi co cmi co cnpi wcel vu cv vx cv cmi co vu cv vw
      cv cmi co cmi co vu cv vy cv cmi co vu cv vz cv cmi co cmi co clti wbr vv
      cv vy cv cmi co vu cv vw cv cmi co cmi co vu cv vx cv cmi co vu cv vw cv
      cmi co cmi co cpli co vv cv vy cv cmi co vu cv vw cv cmi co cmi co vu cv
      vy cv cmi co vu cv vz cv cmi co cmi co cpli co clti wbr wb vv cv cnpi
      wcel vy cv cnpi wcel wa vv cv vy cv cmi co cnpi wcel vu cv cnpi wcel vw
      cv cnpi wcel wa vu cv vw cv cmi co cnpi wcel vv cv vy cv mulclpi vu cv vw
      cv mulclpi anim12i vv cv vy cv cmi co vu cv vw cv cmi co mulclpi vu cv vx
      cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co vu cv vz cv cmi co
      cmi co vv cv vy cv cmi co vu cv vw cv cmi co cmi co vu cv vx cv cmi co vu
      cv vw cv cmi co cmi oprex vu cv vy cv cmi co vu cv vz cv cmi co cmi oprex
      ltapi 3syl vu cv vu cv cmi co vx cv vw cv cmi co cmi co vu cv vx cv cmi
      co vu cv vw cv cmi co cmi co vu cv vu cv cmi co vy cv vz cv cmi co cmi co
      vu cv vy cv cmi co vu cv vz cv cmi co cmi co clti vf vg vh vu cv vu cv vx
      cv vw cv cmi vu visset vu visset vx visset vf cv vg cv vf visset vg
      visset mulcompi vf cv vg cv vh cv vg visset vh visset mulasspi vw visset
      caopr4 vf vg vh vu cv vu cv vy cv vz cv cmi vu visset vu visset vy visset
      vf cv vg cv vf visset vg visset mulcompi vf cv vg cv vh cv vg visset vh
      visset mulasspi vz visset caopr4 breq12i vv cv vy cv cmi co vu cv vx cv
      cmi co cpli co vu cv vw cv cmi co cmi co vv cv vy cv cmi co vu cv vw cv
      cmi co cmi co vu cv vx cv cmi co vu cv vw cv cmi co cmi co cpli co vu cv
      vy cv cmi co vv cv vw cv cmi co vu cv vz cv cmi co cpli co cmi co vv cv
      vy cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co vu cv vz cv cmi
      co cmi co cpli co clti vf vg vh vv cv vy cv cmi co vu cv vx cv cmi co vu
      cv vw cv cmi co cpli cmi vv cv vy cv cmi oprex vu cv vx cv cmi oprex vu
      cv vw cv cmi oprex vf cv vg cv vf visset vg visset mulcompi vf cv vg cv
      vh cv vg visset vh visset distrpi caoprdistrr vu cv vy cv cmi co vv cv vw
      cv cmi co vu cv vz cv cmi co cpli co cmi co vu cv vy cv cmi co vv cv vw
      cv cmi co cmi co vu cv vy cv cmi co vu cv vz cv cmi co cmi co cpli co vv
      cv vy cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co vu cv vz cv
      cmi co cmi co cpli co vu cv vy cv cmi co vv cv vw cv cmi co vu cv vz cv
      cmi co vv cv vw cv cmi oprex vu cv vz cv cmi oprex distrpi vu cv vy cv
      cmi co vv cv vw cv cmi co cmi co vv cv vy cv cmi co vu cv vw cv cmi co
      cmi co vu cv vy cv cmi co vu cv vz cv cmi co cmi co cpli vf vg vh vu cv
      vy cv vv cv vw cv cmi vu visset vy visset vv visset vf cv vg cv vf visset
      vg visset mulcompi vf cv vg cv vh cv vg visset vh visset mulasspi vw
      visset caopr411 opreq1i eqtri breq12i 3bitr4g bitrd vx cv vy cv vz cv vw
      cv vx visset vy visset vz visset vw visset ordpipq vv cv vy cv cmi co vu
      cv vx cv cmi co cpli co vu cv vy cv cmi co vv cv vw cv cmi co vu cv vz cv
      cmi co cpli co vu cv vw cv cmi co vv cv vy cv cmi co vu cv vx cv cmi co
      cpli oprex vu cv vy cv cmi oprex vv cv vw cv cmi co vu cv vz cv cmi co
      cpli oprex vu cv vw cv cmi oprex ordpipq 3bitr4g an4s vx cv cnpi wcel vy
      cv cnpi wcel wa vy cv cnpi wcel vz cv cnpi wcel vw cv cnpi wcel wa vw cv
      cnpi wcel vx cv cnpi wcel vy cv cnpi wcel pm3.27 vz cv cnpi wcel vw cv
      cnpi wcel pm3.27 anim12i sylan2 vv cv cnpi wcel vu cv cnpi wcel wa vx cv
      cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa wa vv
      cv vu cv cop ceq cec vx cv vy cv cop ceq cec cplq co vv cv vy cv cmi co
      vu cv vx cv cmi co cpli co vu cv vy cv cmi co cop ceq cec vv cv vu cv cop
      ceq cec vz cv vw cv cop ceq cec cplq co vv cv vw cv cmi co vu cv vz cv
      cmi co cpli co vu cv vw cv cmi co cop ceq cec cltq vv cv cnpi wcel vu cv
      cnpi wcel wa vx cv cnpi wcel vy cv cnpi wcel wa vv cv vu cv cop ceq cec
      vx cv vy cv cop ceq cec cplq co vv cv vy cv cmi co vu cv vx cv cmi co
      cpli co vu cv vy cv cmi co cop ceq cec wceq vz cv cnpi wcel vw cv cnpi
      wcel wa vv cv vu cv vx cv vy cv addpipq adantrr vv cv cnpi wcel vu cv
      cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa vv cv vu cv cop ceq cec
      vz cv vw cv cop ceq cec cplq co vv cv vw cv cmi co vu cv vz cv cmi co
      cpli co vu cv vw cv cmi co cop ceq cec wceq vx cv cnpi wcel vy cv cnpi
      wcel wa vv cv vu cv vz cv vw cv addpipq adantrl breq12d bitr4d 3impb
      3coml 3ecoptocl ndmord $.
      $( [6-Mar-1996] $)

    $( Ordering property of multiplication for positive fractions.  Proposition
       9-2.6(iii) of [Gleason] p. 120. $)
    ltmpq $p |- ( C e. Q. -> ( A <Q B <-> ( C .Q A ) <Q ( C .Q B ) ) ) $=
      cA cB cC cltq cnq cmq ltapq.2 dmmulpq ltapq.1 ltrelpq 0npq vx cv vy cv
      cop ceq cec vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop ceq cec vx
      cv vy cv cop ceq cec cmq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq
      cec cmq co cltq wbr wb cA vz cv vw cv cop ceq cec cltq wbr vv cv vu cv
      cop ceq cec cA cmq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec cmq
      co cltq wbr wb cA cB cltq wbr vv cv vu cv cop ceq cec cA cmq co vv cv vu
      cv cop ceq cec cB cmq co cltq wbr wb cA cB cltq wbr cC cA cmq co cC cB
      cmq co cltq wbr wb vx vy vz vw vv vu cA cB cC cnpi ceq cnq df-nq vx cv vy
      cv cop ceq cec cA wceq vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec
      cltq wbr cA vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop ceq cec vx
      cv vy cv cop ceq cec cmq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq
      cec cmq co cltq wbr vv cv vu cv cop ceq cec cA cmq co vv cv vu cv cop ceq
      cec vz cv vw cv cop ceq cec cmq co cltq wbr vx cv vy cv cop ceq cec cA vz
      cv vw cv cop ceq cec cltq breq1 vx cv vy cv cop ceq cec cA wceq vv cv vu
      cv cop ceq cec vx cv vy cv cop ceq cec cmq co vv cv vu cv cop ceq cec cA
      cmq co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec cmq co cltq vx cv
      vy cv cop ceq cec cA vv cv vu cv cop ceq cec cmq opreq2 breq1d bibi12d vz
      cv vw cv cop ceq cec cB wceq cA vz cv vw cv cop ceq cec cltq wbr cA cB
      cltq wbr vv cv vu cv cop ceq cec cA cmq co vv cv vu cv cop ceq cec vz cv
      vw cv cop ceq cec cmq co cltq wbr vv cv vu cv cop ceq cec cA cmq co vv cv
      vu cv cop ceq cec cB cmq co cltq wbr vz cv vw cv cop ceq cec cB cA cltq
      breq2 vz cv vw cv cop ceq cec cB wceq vv cv vu cv cop ceq cec vz cv vw cv
      cop ceq cec cmq co vv cv vu cv cop ceq cec cB cmq co vv cv vu cv cop ceq
      cec cA cmq co cltq vz cv vw cv cop ceq cec cB vv cv vu cv cop ceq cec cmq
      opreq2 breq2d bibi12d vv cv vu cv cop ceq cec cC wceq vv cv vu cv cop ceq
      cec cA cmq co vv cv vu cv cop ceq cec cB cmq co cltq wbr cC cA cmq co cC
      cB cmq co cltq wbr cA cB cltq wbr vv cv vu cv cop ceq cec cC wceq vv cv
      vu cv cop ceq cec cA cmq co cC cA cmq co vv cv vu cv cop ceq cec cB cmq
      co cC cB cmq co cltq vv cv vu cv cop ceq cec cC cA cmq opreq1 vv cv vu cv
      cop ceq cec cC cB cmq opreq1 breq12d bibi2d vv cv cnpi wcel vu cv cnpi
      wcel wa vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi
      wcel wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vv cv vu
      cv cop ceq cec vx cv vy cv cop ceq cec cmq co vv cv vu cv cop ceq cec vz
      cv vw cv cop ceq cec cmq co cltq wbr wb vv cv cnpi wcel vu cv cnpi wcel
      wa vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa
      vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vv cv vu cv cop
      ceq cec vx cv vy cv cop ceq cec cmq co vv cv vu cv cop ceq cec vz cv vw
      cv cop ceq cec cmq co cltq wbr wb vv cv cnpi wcel vu cv cnpi wcel wa vx
      cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa wa
      vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr vv cv vx cv cmi
      co vu cv vy cv cmi co cop ceq cec vv cv vz cv cmi co vu cv vw cv cmi co
      cop ceq cec cltq wbr vv cv vu cv cop ceq cec vx cv vy cv cop ceq cec cmq
      co vv cv vu cv cop ceq cec vz cv vw cv cop ceq cec cmq co cltq wbr vv cv
      cnpi wcel vu cv cnpi wcel wa vx cv vy cv cop ceq cec vz cv vw cv cop ceq
      cec cltq wbr vv cv vx cv cmi co vu cv vy cv cmi co cop ceq cec vv cv vz
      cv cmi co vu cv vw cv cmi co cop ceq cec cltq wbr wb vx cv cnpi wcel vy
      cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa wa vv cv cnpi wcel vu
      cv cnpi wcel wa vx cv vw cv cmi co vy cv vz cv cmi co clti wbr vv cv vx
      cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co vv cv vz cv cmi co
      cmi co clti wbr vx cv vy cv cop ceq cec vz cv vw cv cop ceq cec cltq wbr
      vv cv vx cv cmi co vu cv vy cv cmi co cop ceq cec vv cv vz cv cmi co vu
      cv vw cv cmi co cop ceq cec cltq wbr vv cv cnpi wcel vu cv cnpi wcel wa
      vv cv vu cv cmi co cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co clti
      wbr vv cv vx cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co vv cv
      vz cv cmi co cmi co clti wbr wb vv cv vu cv mulclpi vv cv vu cv cmi co
      cnpi wcel vx cv vw cv cmi co vy cv vz cv cmi co clti wbr vv cv vu cv cmi
      co vx cv vw cv cmi co cmi co vv cv vu cv cmi co vy cv vz cv cmi co cmi co
      clti wbr vv cv vx cv cmi co vu cv vw cv cmi co cmi co vu cv vy cv cmi co
      vv cv vz cv cmi co cmi co clti wbr vx cv vw cv cmi co vy cv vz cv cmi co
      vv cv vu cv cmi co vx cv vw cv cmi oprex vy cv vz cv cmi oprex ltmpi vv
      cv vx cv cmi co vu cv vw cv cmi co cmi co vv cv vu cv cmi co vx cv vw cv
      cmi co cmi co vu cv vy cv cmi co vv cv vz cv cmi co cmi co vv cv vu cv
      cmi co vy cv vz cv cmi co cmi co clti vf vg vh vv cv vx cv vu cv vw cv
      cmi vv visset vx visset vu visset vf cv vg cv vf visset vg visset
      mulcompi vf cv vg cv vh cv vg visset vh visset mulasspi vw visset caopr4
      vu cv vy cv cmi co vv cv vz cv cmi co cmi co vu cv vv cv cmi co vy cv vz
      cv cmi co cmi co vv cv vu cv cmi co vy cv vz cv cmi co cmi co vf vg vh vu
      cv vy cv vv cv vz cv cmi vu visset vy visset vv visset vf cv vg cv vf
      visset vg visset mulcompi vf cv vg cv vh cv vg visset vh visset mulasspi
      vz visset caopr4 vu cv vv cv cmi co vv cv vu cv cmi co vy cv vz cv cmi co
      cmi vu cv vv cv vu visset vv visset mulcompi opreq1i eqtri breq12i
      syl6bbr syl vx cv vy cv vz cv vw cv vx visset vy visset vz visset vw
      visset ordpipq vv cv vx cv cmi co vu cv vy cv cmi co vv cv vz cv cmi co
      vu cv vw cv cmi co vv cv vx cv cmi oprex vu cv vy cv cmi oprex vv cv vz
      cv cmi oprex vu cv vw cv cmi oprex ordpipq 3bitr4g adantr vv cv cnpi wcel
      vu cv cnpi wcel wa vx cv cnpi wcel vy cv cnpi wcel wa vz cv cnpi wcel vw
      cv cnpi wcel wa wa wa vv cv vu cv cop ceq cec vx cv vy cv cop ceq cec cmq
      co vv cv vx cv cmi co vu cv vy cv cmi co cop ceq cec vv cv vu cv cop ceq
      cec vz cv vw cv cop ceq cec cmq co vv cv vz cv cmi co vu cv vw cv cmi co
      cop ceq cec cltq vv cv cnpi wcel vu cv cnpi wcel wa vx cv cnpi wcel vy cv
      cnpi wcel wa vv cv vu cv cop ceq cec vx cv vy cv cop ceq cec cmq co vv cv
      vx cv cmi co vu cv vy cv cmi co cop ceq cec wceq vz cv cnpi wcel vw cv
      cnpi wcel wa vv cv vu cv vx cv vy cv mulpipq adantrr vv cv cnpi wcel vu
      cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel wa vv cv vu cv cop ceq
      cec vz cv vw cv cop ceq cec cmq co vv cv vz cv cmi co vu cv vw cv cmi co
      cop ceq cec wceq vx cv cnpi wcel vy cv cnpi wcel wa vv cv vu cv vz cv vw
      cv mulpipq adantrl breq12d bitr4d 3impb 3coml 3ecoptocl ndmord $.
      $( [6-Mar-1996] $)
  $}

  $( One is less than two (one plus one). $)
  1lt2pq $p |- 1Q <Q ( 1Q +Q 1Q ) $=
    c1o c1o cop ceq cec c1o c1o cmi co c1o c1o cmi co cpli co c1o c1o cmi co
    cop ceq cec c1q c1q c1q cplq co cltq c1o c1o cop ceq cec c1o c1o cmi co c1o
    c1o cmi co cpli co c1o c1o cmi co cop ceq cec cltq wbr c1o c1o c1o cmi co
    cmi co c1o c1o c1o cmi co c1o c1o cmi co cpli co cmi co clti wbr c1o c1o
    cmi co c1o c1o cmi co c1o c1o cmi co cpli co clti wbr c1o c1o c1o cmi co
    cmi co c1o c1o c1o cmi co c1o c1o cmi co cpli co cmi co clti wbr c1o c1o
    c1o cpli co c1o c1o cmi co c1o c1o cmi co c1o c1o cmi co cpli co clti
    1lt2pi c1o cnpi wcel c1o c1o cmi co c1o wceq 1pi c1o mulidpi ax-mp c1o c1o
    cmi co c1o c1o c1o cmi co c1o cpli c1o cnpi wcel c1o c1o cmi co c1o wceq
    1pi c1o mulidpi ax-mp c1o cnpi wcel c1o c1o cmi co c1o wceq 1pi c1o mulidpi
    ax-mp opreq12i 3brtr4i c1o cnpi wcel c1o c1o cmi co c1o c1o cmi co c1o c1o
    cmi co cpli co clti wbr c1o c1o c1o cmi co cmi co c1o c1o c1o cmi co c1o
    c1o cmi co cpli co cmi co clti wbr wb 1pi c1o c1o cmi co c1o c1o cmi co c1o
    c1o cmi co cpli co c1o c1o c1o cmi oprex c1o c1o cmi co c1o c1o cmi co cpli
    oprex ltmpi ax-mp mpbi c1o c1o c1o c1o cmi co c1o c1o cmi co cpli co c1o
    c1o cmi co c1o cnpi 1pi elisseti c1o cnpi 1pi elisseti c1o c1o cmi co c1o
    c1o cmi co cpli oprex c1o c1o cmi oprex ordpipq mpbir df-1q c1q c1q cplq co
    c1o c1o cop ceq cec c1o c1o cop ceq cec cplq co c1o c1o cmi co c1o c1o cmi
    co cpli co c1o c1o cmi co cop ceq cec c1q c1o c1o cop ceq cec c1q c1o c1o
    cop ceq cec cplq df-1q df-1q opreq12i c1o cnpi wcel c1o cnpi wcel wa c1o
    cnpi wcel c1o cnpi wcel wa c1o c1o cop ceq cec c1o c1o cop ceq cec cplq co
    c1o c1o cmi co c1o c1o cmi co cpli co c1o c1o cmi co cop ceq cec wceq c1o
    cnpi wcel c1o cnpi wcel 1pi 1pi pm3.2i c1o cnpi wcel c1o cnpi wcel 1pi 1pi
    pm3.2i c1o c1o c1o c1o addpipq mp2an eqtri 3brtr4i $.
    $( [13-Mar-1996] $)

  ${
    ltaddpq.1 $e |- A e. _V $.
    ltaddpq.2 $e |- B e. _V $.
    $( The sum of two fractions is greater than one of them. $)
    ltaddpq $p |- ( ( A e. Q. /\ B e. Q. ) -> A <Q ( A +Q B ) ) $=
      cA cnq wcel cB cnq wcel wa cA cA cB cplq co cltq wbr cB cA cplq co cB cA
      cB cplq co cplq co cltq wbr cA cnq wcel cB cnq wcel cB cA cplq co cB cA
      cB cplq co cplq co cltq wbr cA cnq wcel cB cnq wcel cA cB cplq co cA cB
      cB cplq co cplq co cltq wbr cB cA cplq co cB cA cB cplq co cplq co cltq
      wbr cA cnq wcel cB cB cB cplq co cltq wbr cA cB cplq co cA cB cB cplq co
      cplq co cltq wbr cB cnq wcel cB cB cB cplq co cA ltaddpq.2 cB cB cplq
      oprex ltapq cB cnq wcel cB c1q cmq co cB c1q c1q cplq co cmq co cB cB cB
      cplq co cltq cB cnq wcel c1q c1q c1q cplq co cltq wbr cB c1q cmq co cB
      c1q c1q cplq co cmq co cltq wbr 1lt2pq c1q c1q c1q cplq co cB c1q cnq 1q
      elisseti c1q c1q cplq oprex ltmpq mpbii cB mulidpq cB cnq wcel cB c1q cmq
      co cB c1q cmq co cplq co cB cB cplq co cB c1q c1q cplq co cmq co cB cnq
      wcel cB c1q cmq co cB cB c1q cmq co cB cplq cB mulidpq cB mulidpq
      opreq12d cB c1q c1q c1q cnq 1q elisseti c1q cnq 1q elisseti distrpq
      syl5eq 3brtr3d syl5bi cB cA cplq co cA cB cplq co cB cA cB cplq co cplq
      co cA cB cB cplq co cplq co cltq cB cA ltaddpq.2 ltaddpq.1 addcompq cB cA
      cB cplq co cplq co cA cB cplq co cB cplq co cA cB cB cplq co cplq co cB
      cA cB cplq co ltaddpq.2 cA cB cplq oprex addcompq cA cB cB ltaddpq.2
      ltaddpq.2 addasspq eqtri breq12i syl6ibr imp cB cnq wcel cA cA cB cplq co
      cltq wbr cB cA cplq co cB cA cB cplq co cplq co cltq wbr wb cA cnq wcel
      cA cA cB cplq co cB ltaddpq.1 cA cB cplq oprex ltapq adantl mpbird $.
      $( [14-Mar-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    ltexpq.1 $e |- A e. _V $.
    $( Ordering on positive fractions in terms of existence of sum.  Definition
       in Proposition 9-2.6 of [Gleason] p. 119. $)
    ltexpq $p |- ( ( A e. Q. /\ B e. Q. ) ->
               ( A <Q B <-> E. x ( A +Q x ) = B ) ) $=
      cA cnq wcel cB cnq wcel wa cA cB cltq wbr cA vx cv cplq co cB wceq vx wex
      vy cv vz cv cop ceq cec vw cv vv cv cop ceq cec cltq wbr vy cv vz cv cop
      ceq cec vx cv cplq co vw cv vv cv cop ceq cec wceq vx wex wi cA vw cv vv
      cv cop ceq cec cltq wbr cA vx cv cplq co vw cv vv cv cop ceq cec wceq vx
      wex wi cA cB cltq wbr cA vx cv cplq co cB wceq vx wex wi vy vz vw vv cA
      cB cnpi cnpi ceq cnq df-nq vy cv vz cv cop ceq cec cA wceq vy cv vz cv
      cop ceq cec vw cv vv cv cop ceq cec cltq wbr cA vw cv vv cv cop ceq cec
      cltq wbr vy cv vz cv cop ceq cec vx cv cplq co vw cv vv cv cop ceq cec
      wceq vx wex cA vx cv cplq co vw cv vv cv cop ceq cec wceq vx wex vy cv vz
      cv cop ceq cec cA vw cv vv cv cop ceq cec cltq breq1 vy cv vz cv cop ceq
      cec cA wceq vy cv vz cv cop ceq cec vx cv cplq co vw cv vv cv cop ceq cec
      wceq cA vx cv cplq co vw cv vv cv cop ceq cec wceq vx vy cv vz cv cop ceq
      cec cA wceq vy cv vz cv cop ceq cec vx cv cplq co cA vx cv cplq co vw cv
      vv cv cop ceq cec vy cv vz cv cop ceq cec cA vx cv cplq opreq1 eqeq1d
      exbidv imbi12d vw cv vv cv cop ceq cec cB wceq cA vw cv vv cv cop ceq cec
      cltq wbr cA cB cltq wbr cA vx cv cplq co vw cv vv cv cop ceq cec wceq vx
      wex cA vx cv cplq co cB wceq vx wex vw cv vv cv cop ceq cec cB cA cltq
      breq2 vw cv vv cv cop ceq cec cB wceq cA vx cv cplq co vw cv vv cv cop
      ceq cec wceq cA vx cv cplq co cB wceq vx vw cv vv cv cop ceq cec cB cA vx
      cv cplq co eqeq2 exbidv imbi12d vy cv cnpi wcel vz cv cnpi wcel wa vw cv
      cnpi wcel vv cv cnpi wcel wa wa vy cv vv cv cmi co vz cv vw cv cmi co
      clti wbr vy cv vz cv cop ceq cec vx cv cplq co vw cv vv cv cop ceq cec
      wceq vx wex vy cv vz cv cop ceq cec vw cv vv cv cop ceq cec cltq wbr vy
      cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vy
      cv vv cv cmi co vz cv vw cv cmi co clti wbr vu cv cnpi wcel vy cv vv cv
      cmi co vu cv cpli co vz cv vw cv cmi co wceq wa vu wex vy cv vz cv cop
      ceq cec vx cv cplq co vw cv vv cv cop ceq cec wceq vx wex vy cv cnpi wcel
      vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vy cv vv cv cmi
      co cnpi wcel vz cv vw cv cmi co cnpi wcel wa vy cv vv cv cmi co vz cv vw
      cv cmi co clti wbr vu cv cnpi wcel vy cv vv cv cmi co vu cv cpli co vz cv
      vw cv cmi co wceq wa vu wex wb vy cv cnpi wcel vv cv cnpi wcel vz cv cnpi
      wcel vw cv cnpi wcel vy cv vv cv cmi co cnpi wcel vz cv vw cv cmi co cnpi
      wcel wa vy cv cnpi wcel vv cv cnpi wcel wa vy cv vv cv cmi co cnpi wcel
      vz cv cnpi wcel vw cv cnpi wcel wa vz cv vw cv cmi co cnpi wcel vy cv vv
      cv mulclpi vz cv vw cv mulclpi anim12i an42s vu vy cv vv cv cmi co vz cv
      vw cv cmi co ltexpi syl vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi
      wcel vv cv cnpi wcel wa wa vu cv cnpi wcel vy cv vv cv cmi co vu cv cpli
      co vz cv vw cv cmi co wceq wa vy cv vz cv cop ceq cec vx cv cplq co vw cv
      vv cv cop ceq cec wceq vx wex vu vy cv cnpi wcel vz cv cnpi wcel wa vw cv
      cnpi wcel vv cv cnpi wcel wa wa vu cv cnpi wcel vy cv vv cv cmi co vu cv
      cpli co vz cv vw cv cmi co wceq wa vy cv vz cv cop ceq cec vx cv cplq co
      vw cv vv cv cop ceq cec wceq vx wex vy cv cnpi wcel vz cv cnpi wcel wa vw
      cv cnpi wcel vv cv cnpi wcel wa wa vu cv cnpi wcel vy cv vv cv cmi co vu
      cv cpli co vz cv vw cv cmi co wceq wa wa vy cv vz cv cop ceq cec vu cv vz
      cv vv cv cmi co cop ceq cec cplq co vw cv vv cv cop ceq cec wceq vy cv vz
      cv cop ceq cec vx cv cplq co vw cv vv cv cop ceq cec wceq vx wex vy cv
      cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vu cv
      cnpi wcel vy cv vv cv cmi co vu cv cpli co vz cv vw cv cmi co wceq wa wa
      vy cv vz cv cop ceq cec vu cv vz cv vv cv cmi co cop ceq cec cplq co vy
      cv vz cv vv cv cmi co cmi co vz cv vu cv cmi co cpli co vz cv vz cv vv cv
      cmi co cmi co cop ceq cec vy cv vv cv cmi co vu cv cpli co vz cv vv cv
      cmi co cop ceq cec vw cv vv cv cop ceq cec vy cv cnpi wcel vz cv cnpi
      wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vu cv cnpi wcel vy cv vv cv
      cmi co vu cv cpli co vz cv vw cv cmi co wceq wa wa vy cv cnpi wcel vz cv
      cnpi wcel wa vu cv cnpi wcel vz cv vv cv cmi co cnpi wcel wa wa vy cv vz
      cv cop ceq cec vu cv vz cv vv cv cmi co cop ceq cec cplq co vy cv vz cv
      vv cv cmi co cmi co vz cv vu cv cmi co cpli co vz cv vz cv vv cv cmi co
      cmi co cop ceq cec wceq vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi
      wcel vv cv cnpi wcel wa wa vu cv cnpi wcel vy cv cnpi wcel vz cv cnpi
      wcel wa vu cv cnpi wcel vz cv vv cv cmi co cnpi wcel wa wa vy cv vv cv
      cmi co vu cv cpli co vz cv vw cv cmi co wceq vy cv cnpi wcel vz cv cnpi
      wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vu cv cnpi wcel wa vy cv
      cnpi wcel vz cv cnpi wcel wa vu cv cnpi wcel vz cv vv cv cmi co cnpi wcel
      vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa vu
      cv cnpi wcel simpll vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv
      cv cnpi wcel wa wa vu cv cnpi wcel pm3.27 vy cv cnpi wcel vz cv cnpi wcel
      wa vw cv cnpi wcel vv cv cnpi wcel wa wa vu cv cnpi wcel wa vz cv cnpi
      wcel vv cv cnpi wcel wa vz cv vv cv cmi co cnpi wcel vy cv cnpi wcel vz
      cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vz cv cnpi wcel vv
      cv cnpi wcel wa vu cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel wa vz cv
      cnpi wcel vw cv cnpi wcel vv cv cnpi wcel wa vv cv cnpi wcel vy cv cnpi
      wcel vz cv cnpi wcel pm3.27 vw cv cnpi wcel vv cv cnpi wcel pm3.27
      anim12i adantr vz cv vv cv mulclpi syl jca32 adantrr vy cv vz cv vu cv vz
      cv vv cv cmi co addpipq syl vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi
      wcel vv cv cnpi wcel wa wa vu cv cnpi wcel vy cv vv cv cmi co vu cv cpli
      co vz cv vw cv cmi co wceq wa wa vz cv cnpi wcel vy cv vv cv cmi co vu cv
      cpli co cnpi wcel vz cv vv cv cmi co cnpi wcel w3a vy cv vz cv vv cv cmi
      co cmi co vz cv vu cv cmi co cpli co vz cv vz cv vv cv cmi co cmi co cop
      ceq cec vy cv vv cv cmi co vu cv cpli co vz cv vv cv cmi co cop ceq cec
      wceq vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel
      wa wa vu cv cnpi wcel vz cv cnpi wcel vy cv vv cv cmi co vu cv cpli co
      cnpi wcel vz cv vv cv cmi co cnpi wcel w3a vy cv vv cv cmi co vu cv cpli
      co vz cv vw cv cmi co wceq vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi
      wcel vv cv cnpi wcel wa wa vu cv cnpi wcel wa vz cv cnpi wcel vy cv vv cv
      cmi co vu cv cpli co cnpi wcel vz cv vv cv cmi co cnpi wcel vy cv cnpi
      wcel vz cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel wa vu cv cnpi wcel
      simpllr vy cv vv cv cmi co cnpi wcel vu cv cnpi wcel vy cv vv cv cmi co
      vu cv cpli co cnpi wcel vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi
      wcel vv cv cnpi wcel wa wa vy cv vv cv cmi co vu cv addclpi vy cv cnpi
      wcel vv cv cnpi wcel vy cv vv cv cmi co cnpi wcel vz cv cnpi wcel vw cv
      cnpi wcel vy cv vv cv mulclpi ad2ant2rl sylan vy cv cnpi wcel vz cv cnpi
      wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vu cv cnpi wcel wa vz cv
      cnpi wcel vv cv cnpi wcel wa vz cv vv cv cmi co cnpi wcel vy cv cnpi wcel
      vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vz cv cnpi wcel
      vv cv cnpi wcel wa vu cv cnpi wcel vy cv cnpi wcel vz cv cnpi wcel wa vz
      cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel wa vv cv cnpi wcel vy cv
      cnpi wcel vz cv cnpi wcel pm3.27 vw cv cnpi wcel vv cv cnpi wcel pm3.27
      anim12i adantr vz cv vv cv mulclpi syl 3jca adantrr vz cv cnpi wcel vy cv
      vv cv cmi co vu cv cpli co cnpi wcel vz cv vv cv cmi co cnpi wcel w3a vz
      cv vy cv vv cv cmi co vu cv cpli co cmi co vz cv vz cv vv cv cmi co cmi
      co cop ceq cec vy cv vv cv cmi co vu cv cpli co vz cv vv cv cmi co cop
      ceq cec vy cv vz cv vv cv cmi co cmi co vz cv vu cv cmi co cpli co vz cv
      vz cv vv cv cmi co cmi co cop ceq cec vz cv vy cv vv cv cmi co vu cv cpli
      co vz cv vv cv cmi co vz visset vy cv vv cv cmi co vu cv cpli oprex vz cv
      vv cv cmi oprex distrpqlem vy cv vz cv vv cv cmi co cmi co vz cv vu cv
      cmi co cpli co vz cv vz cv vv cv cmi co cmi co cop vz cv vy cv vv cv cmi
      co vu cv cpli co cmi co vz cv vz cv vv cv cmi co cmi co cop wceq vy cv vz
      cv vv cv cmi co cmi co vz cv vu cv cmi co cpli co vz cv vz cv vv cv cmi
      co cmi co cop ceq cec vz cv vy cv vv cv cmi co vu cv cpli co cmi co vz cv
      vz cv vv cv cmi co cmi co cop ceq cec wceq vy cv vz cv vv cv cmi co cmi
      co vz cv vu cv cmi co cpli co vz cv vy cv vv cv cmi co vu cv cpli co cmi
      co vz cv vz cv vv cv cmi co cmi co vy cv vz cv vv cv cmi co cmi co vz cv
      vu cv cmi co cpli co vz cv vy cv vv cv cmi co cmi co vz cv vu cv cmi co
      cpli co vz cv vy cv vv cv cmi co vu cv cpli co cmi co vy cv vz cv vv cv
      cmi co cmi co vz cv vy cv vv cv cmi co cmi co vz cv vu cv cmi co cpli vx
      vw vu vy cv vz cv vv cv cmi vy visset vz visset vv visset vx cv vw cv vx
      visset vw visset mulcompi vx cv vw cv vu cv vw visset vu visset mulasspi
      caopr12 opreq1i vz cv vy cv vv cv cmi co vu cv vy cv vv cv cmi oprex vu
      visset distrpi eqtr4i opeq1i vy cv vz cv vv cv cmi co cmi co vz cv vu cv
      cmi co cpli co vz cv vz cv vv cv cmi co cmi co cop vz cv vy cv vv cv cmi
      co vu cv cpli co cmi co vz cv vz cv vv cv cmi co cmi co cop ceq eceq2
      ax-mp syl5eq syl vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv cv
      cnpi wcel wa wa vu cv cnpi wcel vy cv vv cv cmi co vu cv cpli co vz cv vw
      cv cmi co wceq wa wa vz cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel w3a
      vy cv vv cv cmi co vu cv cpli co vz cv vw cv cmi co wceq wa vy cv vv cv
      cmi co vu cv cpli co vz cv vv cv cmi co cop ceq cec vw cv vv cv cop ceq
      cec wceq vy cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel vv cv cnpi
      wcel wa wa vy cv vv cv cmi co vu cv cpli co vz cv vw cv cmi co wceq vz cv
      cnpi wcel vw cv cnpi wcel vv cv cnpi wcel w3a vy cv vv cv cmi co vu cv
      cpli co vz cv vw cv cmi co wceq wa vu cv cnpi wcel vy cv cnpi wcel vz cv
      cnpi wcel wa vw cv cnpi wcel vv cv cnpi wcel wa wa vz cv cnpi wcel vw cv
      cnpi wcel vv cv cnpi wcel w3a vy cv vv cv cmi co vu cv cpli co vz cv vw
      cv cmi co wceq vz cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel wa vz cv
      cnpi wcel vw cv cnpi wcel vv cv cnpi wcel w3a vy cv cnpi wcel vz cv cnpi
      wcel vw cv cnpi wcel vv cv cnpi wcel w3a vz cv cnpi wcel vw cv cnpi wcel
      vv cv cnpi wcel wa wa vz cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel
      3anass biimpri adantll anim1i adantrl vy cv vv cv cmi co vu cv cpli co vz
      cv vw cv cmi co wceq vz cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel w3a
      vy cv vv cv cmi co vu cv cpli co vz cv vv cv cmi co cop ceq cec vz cv vw
      cv cmi co vz cv vv cv cmi co cop ceq cec vw cv vv cv cop ceq cec vy cv vv
      cv cmi co vu cv cpli co vz cv vw cv cmi co wceq vy cv vv cv cmi co vu cv
      cpli co vz cv vv cv cmi co cop vz cv vw cv cmi co vz cv vv cv cmi co cop
      wceq vy cv vv cv cmi co vu cv cpli co vz cv vv cv cmi co cop ceq cec vz
      cv vw cv cmi co vz cv vv cv cmi co cop ceq cec wceq vy cv vv cv cmi co vu
      cv cpli co vz cv vw cv cmi co vz cv vv cv cmi co opeq1 vy cv vv cv cmi co
      vu cv cpli co vz cv vv cv cmi co cop vz cv vw cv cmi co vz cv vv cv cmi
      co cop ceq eceq2 syl vz cv vw cv vv cv vz visset vw visset vv visset
      distrpqlem sylan9eqr syl 3eqtrd vy cv vz cv cop ceq cec vx cv cplq co vw
      cv vv cv cop ceq cec wceq vy cv vz cv cop ceq cec vu cv vz cv vv cv cmi
      co cop ceq cec cplq co vw cv vv cv cop ceq cec wceq vx vu cv vz cv vv cv
      cmi co cop ceq cec ceq cvv wcel vu cv vz cv vv cv cmi co cop ceq cec cvv
      wcel enqex vu cv vz cv vv cv cmi co cop cvv ceq ecexg ax-mp vx cv vu cv
      vz cv vv cv cmi co cop ceq cec wceq vy cv vz cv cop ceq cec vx cv cplq co
      vy cv vz cv cop ceq cec vu cv vz cv vv cv cmi co cop ceq cec cplq co vw
      cv vv cv cop ceq cec vx cv vu cv vz cv vv cv cmi co cop ceq cec vy cv vz
      cv cop ceq cec cplq opreq2 eqeq1d cla4ev syl ex 19.23adv sylbid vy cv vz
      cv vw cv vv cv vy visset vz visset vw visset vv visset ordpipq syl5ib
      2ecoptocl cA cnq wcel cB cnq wcel wa cA vx cv cplq co cB wceq cA cB cltq
      wbr vx cA vx cv cplq co cB wceq cA cnq wcel cB cnq wcel wa cA cB cltq wbr
      cA vx cv cplq co cB wceq cA cnq wcel cB cnq wcel wa cA cA vx cv cplq co
      cltq wbr cA cB cltq wbr cA vx cv cplq co cB wceq cA cnq wcel cB cnq wcel
      cA cA vx cv cplq co cltq wbr cA vx cv cplq co cB wceq cB cnq wcel vx cv
      cnq wcel cA cnq wcel cA cA vx cv cplq co cltq wbr cA vx cv cplq co cB
      wceq cB cnq wcel cA vx cv cplq co cnq wcel vx cv cnq wcel cA vx cv cplq
      co cB cnq eleq1 cA vx cv cplq co cnq wcel cA cnq wcel vx cv cnq wcel cA
      vx cv cnq cplq vx visset dmaddpq 0npq ndmoprrcl pm3.27d syl6bir cA cnq
      wcel vx cv cnq wcel cA cA vx cv cplq co cltq wbr cA vx cv ltexpq.1 vx
      visset ltaddpq ex syl9 imp3a cA vx cv cplq co cB cA cltq breq2 sylibd
      com12 19.23adv impbid $.
      $( [15-Mar-1996] $)
  $}

  ${
    $d x A $.  $d x B $.
    ltexpq2.1 $e |- A e. _V $.
    $( Ordering on positive fractions in terms of existence of sum.  Definition
       in Proposition 9-2.6 of [Gleason] p. 119. $)
    ltexpq2 $p |- ( ( A e. Q. /\ B e. Q. ) ->
               ( A <Q B <-> E. x ( x e. Q. /\ ( A +Q x ) = B ) ) ) $=
      cA cnq wcel cB cnq wcel wa cA cB cltq wbr cA vx cv cplq co cB wceq vx wex
      vx cv cnq wcel cA vx cv cplq co cB wceq wa vx wex vx cA cB ltexpq2.1
      ltexpq cA cnq wcel cB cnq wcel wa vx cv cnq wcel cA vx cv cplq co cB wceq
      wa cA vx cv cplq co cB wceq vx cA cnq wcel cB cnq wcel wa vx cv cnq wcel
      cA vx cv cplq co cB wceq wa cA vx cv cplq co cB wceq vx cv cnq wcel cA vx
      cv cplq co cB wceq pm3.27 cB cnq wcel cA vx cv cplq co cB wceq vx cv cnq
      wcel cA vx cv cplq co cB wceq wa wi cA cnq wcel cB cnq wcel cA vx cv cplq
      co cB wceq vx cv cnq wcel cA vx cv cplq co cB wceq cB cnq wcel vx cv cnq
      wcel cA vx cv cplq co cB wceq cB cnq wcel cA vx cv cplq co cnq wcel vx cv
      cnq wcel cA vx cv cplq co cB cnq eleq1 cA vx cv cplq co cnq wcel cA cnq
      wcel vx cv cnq wcel cA vx cv cnq cplq vx visset dmaddpq 0npq ndmoprrcl
      pm3.27d syl6bir com12 ancrd adantl impbid2 exbidv bitr4d $.
      $( [24-Apr-1996] $)
  $}

  ${
    $d x y z A $.
    $( One-half of any positive fraction exists.  Lemma for Proposition
       9-2.6(i) of [Gleason] p. 120. $)
    halfpq $p |- ( A e. Q. -> E. x ( x +Q x ) = A ) $=
      vx cv vx cv cplq co vy cv vz cv cop ceq cec wceq vx wex vx cv vx cv cplq
      co cA wceq vx wex vy vz cA cnpi cnpi ceq cnq df-nq vy cv vz cv cop ceq
      cec cA wceq vx cv vx cv cplq co vy cv vz cv cop ceq cec wceq vx cv vx cv
      cplq co cA wceq vx vy cv vz cv cop ceq cec cA vx cv vx cv cplq co eqeq2
      exbidv vy cv cnpi wcel vz cv cnpi wcel wa vy cv vz cv vz cv cpli co cop
      ceq cec vy cv vz cv vz cv cpli co cop ceq cec cplq co vy cv vz cv cop ceq
      cec wceq vx cv vx cv cplq co vy cv vz cv cop ceq cec wceq vx wex vy cv
      cnpi wcel vz cv cnpi wcel wa vy cv vz cv vz cv cpli co cop ceq cec vy cv
      vz cv vz cv cpli co cop ceq cec cplq co vz cv vz cv cpli co vy cv vy cv
      cpli co cmi co vz cv vz cv cpli co vz cv vz cv cpli co cmi co cop ceq cec
      vy cv vy cv cpli co vz cv vz cv cpli co cop ceq cec vy cv vz cv cop ceq
      cec vy cv cnpi wcel vz cv vz cv cpli co cnpi wcel wa vy cv cnpi wcel vz
      cv vz cv cpli co cnpi wcel wa vy cv vz cv vz cv cpli co cop ceq cec vy cv
      vz cv vz cv cpli co cop ceq cec cplq co vz cv vz cv cpli co vy cv vy cv
      cpli co cmi co vz cv vz cv cpli co vz cv vz cv cpli co cmi co cop ceq cec
      wceq vy cv cnpi wcel vz cv cnpi wcel wa vy cv cnpi wcel vz cv vz cv cpli
      co cnpi wcel wa vy cv cnpi wcel vz cv vz cv cpli co cnpi wcel wa wa vy cv
      vz cv vz cv cpli co cop ceq cec vy cv vz cv vz cv cpli co cop ceq cec
      cplq co vy cv vz cv vz cv cpli co cmi co vz cv vz cv cpli co vy cv cmi co
      cpli co vz cv vz cv cpli co vz cv vz cv cpli co cmi co cop ceq cec vz cv
      vz cv cpli co vy cv vy cv cpli co cmi co vz cv vz cv cpli co vz cv vz cv
      cpli co cmi co cop ceq cec vy cv vz cv vz cv cpli co vy cv vz cv vz cv
      cpli co addpipq vz cv vz cv cpli co vy cv vy cv cpli co cmi co vz cv vz
      cv cpli co vz cv vz cv cpli co cmi co cop vy cv vz cv vz cv cpli co cmi
      co vz cv vz cv cpli co vy cv cmi co cpli co vz cv vz cv cpli co vz cv vz
      cv cpli co cmi co cop wceq vz cv vz cv cpli co vy cv vy cv cpli co cmi co
      vz cv vz cv cpli co vz cv vz cv cpli co cmi co cop ceq cec vy cv vz cv vz
      cv cpli co cmi co vz cv vz cv cpli co vy cv cmi co cpli co vz cv vz cv
      cpli co vz cv vz cv cpli co cmi co cop ceq cec wceq vz cv vz cv cpli co
      vy cv vy cv cpli co cmi co vy cv vz cv vz cv cpli co cmi co vz cv vz cv
      cpli co vy cv cmi co cpli co vz cv vz cv cpli co vz cv vz cv cpli co cmi
      co vz cv vz cv cpli co vy cv vy cv cpli co cmi co vz cv vz cv cpli co vy
      cv cmi co vz cv vz cv cpli co vy cv cmi co cpli co vy cv vz cv vz cv cpli
      co cmi co vz cv vz cv cpli co vy cv cmi co cpli co vz cv vz cv cpli co vy
      cv vy cv vy visset vy visset distrpi vy cv vz cv vz cv cpli co cmi co vz
      cv vz cv cpli co vy cv cmi co vz cv vz cv cpli co vy cv cmi co cpli vy cv
      vz cv vz cv cpli co vy visset vz cv vz cv cpli oprex mulcompi opreq1i
      eqtr4i opeq1i vz cv vz cv cpli co vy cv vy cv cpli co cmi co vz cv vz cv
      cpli co vz cv vz cv cpli co cmi co cop vy cv vz cv vz cv cpli co cmi co
      vz cv vz cv cpli co vy cv cmi co cpli co vz cv vz cv cpli co vz cv vz cv
      cpli co cmi co cop ceq eceq2 ax-mp syl6eqr vz cv cnpi wcel vz cv vz cv
      cpli co cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vz cv vz cv cpli co
      cnpi wcel vz cv vz cv addclpi anidms anim2i vz cv cnpi wcel vz cv vz cv
      cpli co cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vz cv vz cv cpli co
      cnpi wcel vz cv vz cv addclpi anidms anim2i sylanc vz cv vz cv cpli co
      cnpi wcel vy cv vy cv cpli co cnpi wcel vz cv vz cv cpli co cnpi wcel vz
      cv vz cv cpli co vy cv vy cv cpli co cmi co vz cv vz cv cpli co vz cv vz
      cv cpli co cmi co cop ceq cec vy cv vy cv cpli co vz cv vz cv cpli co cop
      ceq cec wceq vy cv cnpi wcel vz cv cnpi wcel wa vz cv vz cv cpli co vy cv
      vy cv cpli co vz cv vz cv cpli co vz cv vz cv cpli oprex vy cv vy cv cpli
      oprex vz cv vz cv cpli oprex distrpqlem vz cv cnpi wcel vz cv vz cv cpli
      co cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vz cv vz cv cpli co cnpi
      wcel vz cv vz cv addclpi anidms adantl vy cv cnpi wcel vy cv vy cv cpli
      co cnpi wcel vz cv cnpi wcel vy cv cnpi wcel vy cv vy cv cpli co cnpi
      wcel vy cv vy cv addclpi anidms adantr vz cv cnpi wcel vz cv vz cv cpli
      co cnpi wcel vy cv cnpi wcel vz cv cnpi wcel vz cv vz cv cpli co cnpi
      wcel vz cv vz cv addclpi anidms adantl syl3anc vy cv cnpi wcel vz cv cnpi
      wcel wa c1o c1o cpli co vy cv cmi co c1o c1o cpli co vz cv cmi co cop ceq
      cec vy cv vy cv cpli co vz cv vz cv cpli co cop ceq cec vy cv vz cv cop
      ceq cec vy cv cnpi wcel vz cv cnpi wcel wa c1o c1o cpli co vy cv cmi co
      vy cv vy cv cpli co wceq c1o c1o cpli co vz cv cmi co vz cv vz cv cpli co
      wceq wa c1o c1o cpli co vy cv cmi co c1o c1o cpli co vz cv cmi co cop vy
      cv vy cv cpli co vz cv vz cv cpli co cop wceq c1o c1o cpli co vy cv cmi
      co c1o c1o cpli co vz cv cmi co cop ceq cec vy cv vy cv cpli co vz cv vz
      cv cpli co cop ceq cec wceq vy cv cnpi wcel c1o c1o cpli co vy cv cmi co
      vy cv vy cv cpli co wceq vz cv cnpi wcel c1o c1o cpli co vz cv cmi co vz
      cv vz cv cpli co wceq vy cv cnpi wcel vy cv c1o cmi co vy cv c1o cmi co
      cpli co vy cv vy cv cpli co c1o c1o cpli co vy cv cmi co vy cv cnpi wcel
      vy cv c1o cmi co vy cv vy cv c1o cmi co vy cv cpli vy cv mulidpi vy cv
      mulidpi opreq12d vy cv c1o c1o cpli co cmi co c1o c1o cpli co vy cv cmi
      co vy cv c1o cmi co vy cv c1o cmi co cpli co vy cv c1o c1o cpli co vy
      visset c1o c1o cpli oprex mulcompi vy cv c1o c1o c1o cnpi 1pi elisseti
      c1o cnpi 1pi elisseti distrpi eqtr3i syl5eq vz cv cnpi wcel vz cv c1o cmi
      co vz cv c1o cmi co cpli co vz cv vz cv cpli co c1o c1o cpli co vz cv cmi
      co vz cv cnpi wcel vz cv c1o cmi co vz cv vz cv c1o cmi co vz cv cpli vz
      cv mulidpi vz cv mulidpi opreq12d vz cv c1o c1o cpli co cmi co c1o c1o
      cpli co vz cv cmi co vz cv c1o cmi co vz cv c1o cmi co cpli co vz cv c1o
      c1o cpli co vz visset c1o c1o cpli oprex mulcompi vz cv c1o c1o c1o cnpi
      1pi elisseti c1o cnpi 1pi elisseti distrpi eqtr3i syl5eq anim12i c1o c1o
      cpli co vy cv cmi co c1o c1o cpli co vz cv cmi co vy cv vy cv cpli co vz
      cv vz cv cpli co opeq12 c1o c1o cpli co vy cv cmi co c1o c1o cpli co vz
      cv cmi co cop vy cv vy cv cpli co vz cv vz cv cpli co cop ceq eceq2 3syl
      c1o c1o cpli co cnpi wcel vy cv cnpi wcel vz cv cnpi wcel c1o c1o cpli co
      vy cv cmi co c1o c1o cpli co vz cv cmi co cop ceq cec vy cv vz cv cop ceq
      cec wceq c1o cnpi wcel c1o cnpi wcel c1o c1o cpli co cnpi wcel 1pi 1pi
      c1o c1o addclpi mp2an c1o c1o cpli co vy cv vz cv c1o c1o cpli oprex vy
      visset vz visset distrpqlem mp3an1 eqtr3d 3eqtrd vx cv vx cv cplq co vy
      cv vz cv cop ceq cec wceq vy cv vz cv vz cv cpli co cop ceq cec vy cv vz
      cv vz cv cpli co cop ceq cec cplq co vy cv vz cv cop ceq cec wceq vx vy
      cv vz cv vz cv cpli co cop ceq cec ceq cvv wcel vy cv vz cv vz cv cpli co
      cop ceq cec cvv wcel enqex vy cv vz cv vz cv cpli co cop cvv ceq ecexg
      ax-mp vx cv vy cv vz cv vz cv cpli co cop ceq cec wceq vx cv vx cv cplq
      co vy cv vz cv vz cv cpli co cop ceq cec vy cv vz cv vz cv cpli co cop
      ceq cec cplq co vy cv vz cv cop ceq cec vx cv vy cv vz cv vz cv cpli co
      cop ceq cec wceq vx cv vx cv cplq co vy cv vz cv vz cv cpli co cop ceq
      cec vy cv vz cv vz cv cpli co cop ceq cec cplq co wceq vx cv vy cv vz cv
      vz cv cpli co cop ceq cec vx cv vy cv vz cv vz cv cpli co cop ceq cec
      cplq opreq12 anidms eqeq1d cla4ev syl ecoptocl $.
      $( [16-Mar-1996] $)
  $}

  ${
    $d x A $.
    $( The is no smallest positive fraction. $)
    nsmallpq $p |- ( A e. Q. -> E. x x <Q A ) $=
      cA cnq wcel vx cv vx cv cplq co cA wceq vx wex vx cv cA cltq wbr vx wex
      vx cA halfpq cA cnq wcel vx cv vx cv cplq co cA wceq vx cv cA cltq wbr vx
      cA cnq wcel vx cv vx cv cplq co cA wceq vx cv cnq wcel vx cv cnq wcel wa
      vx cv cA cltq wbr vx cv vx cv cplq co cA wceq cA cnq wcel vx cv cnq wcel
      vx cv cnq wcel wa vx cv vx cv cplq co cA wceq cA cnq wcel vx cv vx cv
      cplq co cnq wcel vx cv cnq wcel vx cv cnq wcel wa vx cv vx cv cplq co cA
      cnq eleq1 vx cv vx cv cnq cplq vx visset dmaddpq 0npq ndmoprrcl syl6bir
      com12 vx cv vx cv cplq co cA wceq vx cv vx cv vx cv cplq co cltq wbr vx
      cv cA cltq wbr vx cv cnq wcel vx cv cnq wcel wa vx cv vx cv cplq co cA vx
      cv cltq breq2 vx cv vx cv vx visset vx visset ltaddpq syl5bi sylcom
      19.22dv mpd $.
      $( [26-Apr-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    ltbtwnpq.1 $e |- A e. _V $.
    ltbtwnpq.2 $e |- B e. _V $.
    $( There exists a number between any two positive fractions.  Proposition
       9-2.6(i) of [Gleason] p. 120. $)
    ltbtwnpq $p |- ( A <Q B -> E. x ( A <Q x /\ x <Q B ) ) $=
      cA cnq wcel cB cnq wcel wa cA cB cltq wbr cA vx cv cltq wbr vx cv cB cltq
      wbr wa vx wex cA cB cnq cnq cltq ltbtwnpq.2 ltrelpq brel cA cnq wcel cB
      cnq wcel wa cA cB cltq wbr cA vy cv cplq co cB wceq vy wex cA vx cv cltq
      wbr vx cv cB cltq wbr wa vx wex vy cA cB ltbtwnpq.1 ltexpq cA cnq wcel cB
      cnq wcel wa cA vy cv cplq co cB wceq cA vx cv cltq wbr vx cv cB cltq wbr
      wa vx wex vy cB cnq wcel cA vy cv cplq co cB wceq cA vx cv cltq wbr vx cv
      cB cltq wbr wa vx wex wi cA cnq wcel cA vy cv cplq co cB wceq cB cnq wcel
      cA vx cv cltq wbr vx cv cB cltq wbr wa vx wex cA vy cv cplq co cB wceq cB
      cnq wcel cA cnq wcel vy cv cnq wcel wa cA vx cv cltq wbr vx cv cB cltq
      wbr wa vx wex cA vy cv cplq co cB wceq cB cnq wcel cA vy cv cplq co cnq
      wcel cA cnq wcel vy cv cnq wcel wa cA vy cv cplq co cB cnq eleq1 cA vy cv
      cnq cplq vy visset dmaddpq 0npq ndmoprrcl syl6bir cA cnq wcel vy cv cnq
      wcel wa cA vy cv cplq co cB wceq cA vx cv cltq wbr vx cv cB cltq wbr wa
      vx wex vz cv vz cv cplq co vy cv wceq vz wex cA cnq wcel vy cv cnq wcel
      wa cA vy cv cplq co cB wceq cA vx cv cltq wbr vx cv cB cltq wbr wa vx wex
      wi vy cv cnq wcel vz cv vz cv cplq co vy cv wceq vz wex cA cnq wcel vz vy
      cv halfpq adantl vz cv vz cv cplq co vy cv wceq cA cnq wcel vy cv cnq
      wcel wa cA vy cv cplq co cB wceq cA vx cv cltq wbr vx cv cB cltq wbr wa
      vx wex wi wi vz vz cv vz cv cplq co vy cv wceq cA cnq wcel vz cv cnq wcel
      cA vy cv cplq co cB wceq cA vx cv cltq wbr vx cv cB cltq wbr wa vx wex wi
      vy cv cnq wcel vz cv vz cv cplq co vy cv wceq cA vy cv cplq co cB wceq cA
      cnq wcel vz cv cnq wcel wa cA vx cv cltq wbr vx cv cB cltq wbr wa vx wex
      vz cv vz cv cplq co vy cv wceq cA vy cv cplq co cB wceq cA cnq wcel vz cv
      cnq wcel wa cA cA vz cv cplq co cltq wbr cA vz cv cplq co cB cltq wbr wa
      cA vx cv cltq wbr vx cv cB cltq wbr wa vx wex vz cv vz cv cplq co vy cv
      wceq cA vy cv cplq co cB wceq cA cnq wcel vz cv cnq wcel wa cA vz cv cplq
      co cB cltq wbr wi cA cnq wcel vz cv cnq wcel wa cA cA vz cv cplq co cltq
      wbr cA vz cv cplq co cB cltq wbr wa wi vz cv vz cv cplq co vy cv wceq cA
      vy cv cplq co cB wceq cA vz cv cplq co cnq wcel vz cv cnq wcel wa cA vz
      cv cplq co cB cltq wbr cA cnq wcel vz cv cnq wcel wa vz cv vz cv cplq co
      vy cv wceq cA vy cv cplq co cB wceq cA vz cv vz cv cplq co cplq co cB
      wceq cA vz cv cplq co cnq wcel vz cv cnq wcel wa cA vz cv cplq co cB cltq
      wbr wi vz cv vz cv cplq co vy cv wceq cA vz cv vz cv cplq co cplq co cA
      vy cv cplq co cB vz cv vz cv cplq co vy cv cA cplq opreq2 eqeq1d cA vz cv
      vz cv cplq co cplq co cB wceq cA vz cv cplq co cA vz cv vz cv cplq co
      cplq co cltq wbr cA vz cv cplq co cB cltq wbr cA vz cv cplq co cnq wcel
      vz cv cnq wcel wa cA vz cv vz cv cplq co cplq co cB cA vz cv cplq co cltq
      breq2 cA vz cv cplq co cnq wcel vz cv cnq wcel wa cA vz cv cplq co cA vz
      cv cplq co vz cv cplq co cA vz cv vz cv cplq co cplq co cltq cA vz cv
      cplq co vz cv cA vz cv cplq oprex vz visset ltaddpq cA vz cv vz cv vz
      visset vz visset addasspq syl6breq syl5bi syl6bir cA cnq wcel vz cv cnq
      wcel wa cA vz cv cplq co cnq wcel vz cv cnq wcel cA vz cv addclpq cA cnq
      wcel vz cv cnq wcel pm3.27 jca syl7 cA cnq wcel vz cv cnq wcel wa cA cA
      vz cv cplq co cltq wbr wi cA cnq wcel vz cv cnq wcel wa cA vz cv cplq co
      cB cltq wbr wi cA cnq wcel vz cv cnq wcel wa cA cA vz cv cplq co cltq wbr
      cA vz cv cplq co cB cltq wbr wa wi wi cA vz cv ltbtwnpq.1 vz visset
      ltaddpq cA cnq wcel vz cv cnq wcel wa cA cA vz cv cplq co cltq wbr cA vz
      cv cplq co cB cltq wbr pm3.43i ax-mp syl6 cA vx cv cltq wbr vx cv cB cltq
      wbr wa cA cA vz cv cplq co cltq wbr cA vz cv cplq co cB cltq wbr wa vx cA
      vz cv cplq co cA vz cv cplq oprex vx cv cA vz cv cplq co wceq cA vx cv
      cltq wbr cA cA vz cv cplq co cltq wbr vx cv cB cltq wbr cA vz cv cplq co
      cB cltq wbr vx cv cA vz cv cplq co cA cltq breq2 vx cv cA vz cv cplq co
      cB cltq breq1 anbi12d cla4ev syl8 com23 vz cv vz cv cplq co vy cv wceq vy
      cv cnq wcel vz cv vz cv cplq co cnq wcel vz cv cnq wcel vz cv vz cv cplq
      co vy cv cnq eleq1 vz cv vz cv cplq co cnq wcel vz cv cnq wcel vz cv cnq
      wcel vz cv vz cv cnq cplq vz visset dmaddpq 0npq ndmoprrcl pm3.26d
      syl6bir sylan2d 19.23aiv mpcom com12 syld com12 adantl 19.23adv sylbid
      mpcom $.
      $( [17-Mar-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    ltrpq.1 $e |- A e. _V $.
    ltrpq.2 $e |- B e. _V $.
    $( Ordering property of reciprocal for positive fractions.  Proposition
      9-2.6(iv) of [Gleason] p. 120. $)
    ltrpq $p |- ( A <Q B -> ( *Q ` B ) <Q ( *Q ` A ) ) $=
      cA cnq wcel cB cnq wcel wa cA cB cltq wbr cB crq cfv cA crq cfv cltq wbr
      cA cB cnq cnq cltq ltrpq.2 ltrelpq brel cB cnq wcel cA cnq wcel cA cB
      cltq wbr cB crq cfv cA crq cfv cltq wbr wi cB cnq wcel cA cnq wcel wa cA
      cB cltq wbr cB crq cfv cA crq cfv wceq cA crq cfv cB crq cfv cltq wbr wo
      wn cB crq cfv cA crq cfv cltq wbr cA cB cltq wbr cB cnq wcel cA cnq wcel
      wa cB crq cfv cA crq cfv wceq cA crq cfv cB crq cfv cltq wbr wo wn cA cB
      cltq wbr cB cnq wcel cA cnq wcel cB crq cfv cA crq cfv wceq cA crq cfv cB
      crq cfv cltq wbr wo wn cA cB cltq wbr cB cnq wcel cA cnq wcel cB crq cfv
      cA crq cfv wceq cA crq cfv cB crq cfv cltq wbr wo wn cA cB cltq wbr cB
      cnq wcel wa cA cnq wcel wa cB crq cfv cA crq cfv wceq cA crq cfv cB crq
      cfv cltq wbr wo cA cA crq cfv cmq co cB cB crq cfv cmq co cltq wbr cB cnq
      wcel cA cnq wcel cA cA crq cfv cmq co cB cB crq cfv cmq co cltq wbr wn cA
      cB cltq wbr cB cnq wcel cA cnq wcel wa cA cA crq cfv cmq co cB cB crq cfv
      cmq co cltq wbr c1q c1q cltq wbr c1q cltq cnq c1q cnq 1q elisseti ltsopq
      ltrelpq soirri cA cnq wcel cB cnq wcel cA cA crq cfv cmq co c1q cB cB crq
      cfv cmq co c1q cltq cA recidpq cB recidpq breqan12rd mtbiri adantll cA cB
      cltq wbr cB cnq wcel wa cA cnq wcel wa cA cA crq cfv cmq co cB cA crq cfv
      cmq co cltq wbr cB cnq wcel wa cB crq cfv cA crq cfv wceq cA crq cfv cB
      crq cfv cltq wbr wo cA cA crq cfv cmq co cB cB crq cfv cmq co cltq wbr wi
      cA cnq wcel cA cB cltq wbr cB cnq wcel wa cA cA crq cfv cmq co cB cA crq
      cfv cmq co cltq wbr cB cnq wcel wa cA cnq wcel cA cB cltq wbr cA cA crq
      cfv cmq co cB cA crq cfv cmq co cltq wbr cB cnq wcel cA cnq wcel cA crq
      cfv cnq wcel cA cB cltq wbr cA cA crq cfv cmq co cB cA crq cfv cmq co
      cltq wbr wb cA recclpq vy vz vx cA cB cA crq cfv cltq cnq cmq ltrpq.1
      ltrpq.2 vy cv vz cv vx cv vy visset vz visset ltmpq cA crq fvex vy cv vz
      cv vy visset vz visset mulcompq caoprord2 syl anbi1d biimpac cA cA crq
      cfv cmq co cB cA crq cfv cmq co cltq wbr cB cnq wcel wa cB crq cfv cA crq
      cfv wceq cA cA crq cfv cmq co cB cB crq cfv cmq co cltq wbr cA crq cfv cB
      crq cfv cltq wbr cA cA crq cfv cmq co cB cA crq cfv cmq co cltq wbr cB
      crq cfv cA crq cfv wceq cA cA crq cfv cmq co cB cB crq cfv cmq co cltq
      wbr wi cB cnq wcel cA cA crq cfv cmq co cB cA crq cfv cmq co cltq wbr cB
      cB crq cfv cmq co cB cA crq cfv cmq co wceq cA cA crq cfv cmq co cB cB
      crq cfv cmq co cltq wbr cB crq cfv cA crq cfv wceq cB cB crq cfv cmq co
      cB cA crq cfv cmq co wceq cA cA crq cfv cmq co cB cB crq cfv cmq co cltq
      wbr cA cA crq cfv cmq co cB cA crq cfv cmq co cltq wbr cB cB crq cfv cmq
      co cB cA crq cfv cmq co cA cA crq cfv cmq co cltq breq2 biimprcd cB crq
      cfv cA crq cfv cB cmq opreq2 syl5 adantr cA cA crq cfv cmq co cB cA crq
      cfv cmq co cltq wbr cB cnq wcel cA crq cfv cB crq cfv cltq wbr cA cA crq
      cfv cmq co cB cB crq cfv cmq co cltq wbr wi cA cA crq cfv cmq co cB cA
      crq cfv cmq co cltq wbr cB cnq wcel cA crq cfv cB crq cfv cltq wbr cA cA
      crq cfv cmq co cB cB crq cfv cmq co cltq wbr cA cA crq cfv cmq co cB cA
      crq cfv cmq co cltq wbr cB cA crq cfv cmq co cB cB crq cfv cmq co cltq
      wbr cA cA crq cfv cmq co cB cB crq cfv cmq co cltq wbr cB cnq wcel cA crq
      cfv cB crq cfv cltq wbr wa cA cA crq cfv cmq co cB cA crq cfv cmq co cB
      cB crq cfv cmq co cltq cnq cA cA crq cfv cmq oprex ltsopq ltrelpq cB cA
      crq cfv cmq oprex cB cB crq cfv cmq oprex sotri cB cnq wcel cA crq cfv cB
      crq cfv cltq wbr cB cA crq cfv cmq co cB cB crq cfv cmq co cltq wbr cA
      crq cfv cB crq cfv cB cA crq fvex cB crq fvex ltmpq biimpa sylan2 exp32
      imp jaod syl mtod exp31 imp3a com12 cB crq cfv cnq wcel cA crq cfv cnq
      wcel cB crq cfv cA crq cfv cltq wbr cB crq cfv cA crq cfv wceq cA crq cfv
      cB crq cfv cltq wbr wo wn wb cB cnq wcel cA cnq wcel cnq cltq wor cB crq
      cfv cnq wcel cA crq cfv cnq wcel wa cB crq cfv cA crq cfv cltq wbr cB crq
      cfv cA crq cfv wceq cA crq cfv cB crq cfv cltq wbr wo wn wb ltsopq cnq cB
      crq cfv cA crq cfv cltq sotric mpan cB recclpq cA recclpq syl2an sylibrd
      ancoms mpcom $.
      $( [9-Mar-1996] $)
  $}

  ${
    $d x y z $.
    $( Define the set of positive reals.  A "Dedekind cut" is a partition of
       the positive rational numbers into two classes such that all the numbers
       of one class are less than all the numbers of the other.  A positive
       real is defined as the lower class of a Dedekind cut.  Definition 9-3.1
       of [Gleason] p. 121.  (Note:  This is a "temporary" definition used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.) $)
    df-np $a |- P. = { x | ( ( (/) C. x /\ x C. Q. ) /\
         A. y e. x ( A. z ( z <Q y -> z e. x ) /\ E. z e. x y <Q z ) ) } $.
  $}

  $( Define the positive real constant 1.  This is a "temporary"
     set used in the construction of complex numbers ~ df-c , and is intended
     to be used only by the construction.  Definition of [Gleason] p. 122. $)
  df-1p $a |- 1P = { x | x <Q 1Q } $.

  ${
    $d x y z w v u $.
    $( Define addition on positive reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-3.5 of
       [Gleason] p. 123. $)
    df-plp $a |- +P. = { <. <. x , y >. , z >. | ( ( x e. P. /\ y e. P. ) /\
                 z = { w | E. v e. x E. u e. y w = ( v +Q u ) } ) } $.

    $( Define multiplication on positive reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-3.7 of
       [Gleason] p. 124. $)
    df-mp $a |- .P. = { <. <. x , y >. , z >. | ( ( x e. P. /\ y e. P. ) /\
                 z = { w | E. v e. x E. u e. y w = ( v .Q u ) } ) } $.

    $( Define ordering on positive reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-3.2 of
       [Gleason] p. 122. $)
    df-ltp $a |- <P = { <. x , y >. | ( ( x e. P. /\ y e. P. ) /\
                 x C. y ) } $.
  $}

  ${
    $d x y z $.
    $( The class of positive reals is a set. $)
    npex $p |- P. e. _V $=
      cnp cnq cpw cnq nqex pwex c0 vx cv wpss vx cv cnq wpss wa vz cv vy cv
      cltq wbr vz cv vx cv wcel wi vz wal vy cv vz cv cltq wbr vz vx cv wrex wa
      vy vx cv wral wa vx cab vx cv cnq wss vx cab cnp cnq cpw c0 vx cv wpss vx
      cv cnq wpss wa vz cv vy cv cltq wbr vz cv vx cv wcel wi vz wal vy cv vz
      cv cltq wbr vz vx cv wrex wa vy vx cv wral wa vx cv cnq wss vx vx cv cnq
      wpss vx cv cnq wss c0 vx cv wpss vz cv vy cv cltq wbr vz cv vx cv wcel wi
      vz wal vy cv vz cv cltq wbr vz vx cv wrex wa vy vx cv wral vx cv cnq
      pssss ad2antlr ss2abi vx vy vz df-np vx cnq df-pw 3sstr4i ssexi $.
      $( [31-Oct-1995] $)

  $}

  ${
    $d x y z A $.
    $( Membership in positive reals. $)
    elnp $p |- ( A e. P. <-> ( ( (/) C. A /\ A C. Q. ) /\
       A. x e. A ( A. y ( y <Q x -> y e. A ) /\ E. y e. A x <Q y ) ) ) $=
      cA cnp wcel cA cvv wcel c0 cA wpss cA cnq wpss wa vy cv vx cv cltq wbr vy
      cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex wa vx cA wral wa cA
      cnp elisset cA cnq wpss cA cvv wcel c0 cA wpss vy cv vx cv cltq wbr vy cv
      cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex wa vx cA wral cA cnq
      wpss cA cnq wss cA cvv wcel cA cnq pssss cA cnq nqex ssex syl ad2antlr c0
      vz cv wpss vz cv cnq wpss wa vy cv vx cv cltq wbr vy cv vz cv wcel wi vy
      wal vx cv vy cv cltq wbr vy vz cv wrex wa vx vz cv wral wa c0 cA wpss cA
      cnq wpss wa vy cv vx cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq
      wbr vy cA wrex wa vx cA wral wa vz cA cnp cvv vz cv cA wceq c0 vz cv wpss
      vz cv cnq wpss wa c0 cA wpss cA cnq wpss wa vy cv vx cv cltq wbr vy cv vz
      cv wcel wi vy wal vx cv vy cv cltq wbr vy vz cv wrex wa vx vz cv wral vy
      cv vx cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex
      wa vx cA wral vz cv cA wceq c0 vz cv wpss c0 cA wpss vz cv cnq wpss cA
      cnq wpss vz cv cA c0 psseq2 vz cv cA cnq psseq1 anbi12d vy cv vx cv cltq
      wbr vy cv vz cv wcel wi vy wal vx cv vy cv cltq wbr vy vz cv wrex wa vy
      cv vx cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex
      wa vx vz cv cA vz cv cA wceq vy cv vx cv cltq wbr vy cv vz cv wcel wi vy
      wal vy cv vx cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq wbr vy
      vz cv wrex vx cv vy cv cltq wbr vy cA wrex vz cv cA wceq vy cv vx cv cltq
      wbr vy cv vz cv wcel wi vy cv vx cv cltq wbr vy cv cA wcel wi vy vz cv cA
      wceq vy cv vz cv wcel vy cv cA wcel vy cv vx cv cltq wbr vz cv cA vy cv
      eleq2 imbi2d albidv vx cv vy cv cltq wbr vy vz cv cA rexeq1 anbi12d
      raleqd anbi12d vz vx vy df-np elab2g pm5.21nii $.
      $( [16-Feb-1996] $)
  $}

  ${
    $d x y A $.
    $( A positive real is not empty. $)
    prn0 $p |- ( A e. P. -> A =/= (/) ) $=
      cA cnp wcel c0 cA wpss cA c0 wne cA cnp wcel c0 cA wpss cA cnq wpss wa vy
      cv vx cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex
      wa vx cA wral wa c0 cA wpss vx vy cA elnp c0 cA wpss cA cnq wpss vy cv vx
      cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex wa vx
      cA wral simpll sylbi cA 0pss sylib $.
      $( [17-Apr-2007] $) $( [15-May-1996] $)

    $( A positive real is a subset of the positive fractions. $)
    prpssnq $p |- ( A e. P. -> A C. Q. ) $=
      cA cnp wcel c0 cA wpss cA cnq wpss wa vy cv vx cv cltq wbr vy cv cA wcel
      wi vy wal vx cv vy cv cltq wbr vy cA wrex wa vx cA wral wa cA cnq wpss vx
      vy cA elnp c0 cA wpss cA cnq wpss vy cv vx cv cltq wbr vy cv cA wcel wi
      vy wal vx cv vy cv cltq wbr vy cA wrex wa vx cA wral simplr sylbi $.
      $( [29-Feb-1996] $)
  $}

  $( A positive real is a set of positive fractions. $)
  elprpq $p |- ( ( A e. P. /\ B e. A ) -> B e. Q. ) $=
    cA cnp wcel cB cA wcel cB cnq wcel cA cnp wcel cA cnq cB cA cnp wcel cA cnq
    cA prpssnq pssssd sseld imp $.
    $( [13-Mar-1996] $)

  $( The empty set is not a positive real. $)
  0npr $p |- -. (/) e. P. $=
    c0 c0 wceq c0 cnp wcel wn c0 eqid c0 cnp wcel c0 c0 c0 prn0 necon2bi ax-mp
    $.
    $( [15-Nov-1995] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( A positive real is closed downwards under the positive fractions.
       Definition 9-3.1 (ii) of [Gleason] p. 121. $)
    prcdpq $p |- ( ( A e. P. /\ B e. A ) -> ( C <Q B -> C e. A ) ) $=
      cA cnp wcel cB cA wcel wa cC cB cltq wbr cC cA wcel cA cnp wcel cB cA
      wcel wa cC cB cltq wbr wa cC cA wcel cB cA wcel cC cB cltq wbr cA cnp
      wcel cB cA wcel wa cC cB cltq wbr wa cC cA wcel wi cA cnp wcel cB cA wcel
      cC cvv wcel cA cnp wcel cB cA wcel wa cC cB cltq wbr wa cC cA wcel wi cC
      cB cltq wbr cA cnp wcel vx cv cA wcel wa vy cv vx cv cltq wbr wa vy cv cA
      wcel wi cA cnp wcel cB cA wcel wa vy cv cB cltq wbr wa vy cv cA wcel wi
      cA cnp wcel cB cA wcel wa cC cB cltq wbr wa cC cA wcel wi vx vy cB cC cA
      cvv vx cv cB wceq cA cnp wcel vx cv cA wcel wa vy cv vx cv cltq wbr wa cA
      cnp wcel cB cA wcel wa vy cv cB cltq wbr wa vy cv cA wcel vx cv cB wceq
      cA cnp wcel vx cv cA wcel wa cA cnp wcel cB cA wcel wa vy cv vx cv cltq
      wbr vy cv cB cltq wbr vx cv cB wceq vx cv cA wcel cB cA wcel cA cnp wcel
      vx cv cB cA eleq1 anbi2d vx cv cB vy cv cltq breq2 anbi12d imbi1d vy cv
      cC wceq cA cnp wcel cB cA wcel wa vy cv cB cltq wbr wa cA cnp wcel cB cA
      wcel wa cC cB cltq wbr wa vy cv cA wcel cC cA wcel vy cv cC wceq vy cv cB
      cltq wbr cC cB cltq wbr cA cnp wcel cB cA wcel wa vy cv cC cB cltq breq1
      anbi2d vy cv cC cA eleq1 imbi12d cA cnp wcel vx cv cA wcel wa vy cv vx cv
      cltq wbr vy cv cA wcel cA cnp wcel vx cv cA wcel wa vy cv vx cv cltq wbr
      vy cv cA wcel wi vy cA cnp wcel vx cv cA wcel wa vy cv vx cv cltq wbr vy
      cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex cA cnp wcel vy cv vx
      cv cltq wbr vy cv cA wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex wa vx
      cA cA cnp wcel c0 cA wpss cA cnq wpss wa vy cv vx cv cltq wbr vy cv cA
      wcel wi vy wal vx cv vy cv cltq wbr vy cA wrex wa vx cA wral vx vy cA
      elnp pm3.27bi r19.21bi pm3.26d 19.21bi imp vtocl2g cC cB cltq cltq cnq
      cnq cxp wss cnq cnq cxp wrel cltq wrel ltrelpq cnq cnq relxp cltq cnq cnq
      cxp relss mp2 brrelexi sylan2 adantll pm2.43i ex $.
      $( [25-Feb-1996] $)
  $}

  $( A positive fraction not in a positive real is an upper bound.  Remark (1)
     of [Gleason] p. 122. $)
  prub $p |- ( ( ( A e. P. /\ B e. A ) /\ C e. Q. ) ->
             ( -. C e. A -> B <Q C ) ) $=
    cA cnp wcel cB cA wcel wa cC cnq wcel wa cC cA wcel wn cB cC wceq cC cB
    cltq wbr wo wn cB cC cltq wbr cA cnp wcel cB cA wcel wa cC cA wcel wn cB cC
    wceq cC cB cltq wbr wo wn wi cC cnq wcel cA cnp wcel cB cA wcel wa cB cC
    wceq cC cB cltq wbr wo cC cA wcel cA cnp wcel cB cA wcel wa cB cC wceq cC
    cA wcel cC cB cltq wbr cB cA wcel cB cC wceq cC cA wcel wi cA cnp wcel cB
    cC wceq cB cA wcel cC cA wcel cB cC cA eleq1 biimpcd adantl cA cB cC prcdpq
    jaod con3d adantr cB cnq wcel cC cnq wcel cB cC cltq wbr cB cC wceq cC cB
    cltq wbr wo wn wb cA cnp wcel cB cA wcel wa cnq cltq wor cB cnq wcel cC cnq
    wcel wa cB cC cltq wbr cB cC wceq cC cB cltq wbr wo wn wb ltsopq cnq cB cC
    cltq sotric mpan cA cB elprpq sylan sylibrd $.
    $( [25-Feb-1996] $)

  ${
    $d x y A $.  $d x y B $.
    $( A positive real has no largest member.  Definition 9-3.1(iii) of
       [Gleason] p. 121. $)
    prnmax $p |- ( ( A e. P. /\ B e. A ) -> E. x ( x e. A /\ B <Q x ) ) $=
      cA cnp wcel cB cA wcel wa cB vx cv cltq wbr vx cA wrex vx cv cA wcel cB
      vx cv cltq wbr wa vx wex cA cnp wcel cB cA wcel cB vx cv cltq wbr vx cA
      wrex cA cnp wcel vy cv cA wcel wa vy cv vx cv cltq wbr vx cA wrex wi cA
      cnp wcel cB cA wcel wa cB vx cv cltq wbr vx cA wrex wi vy cB cA vy cv cB
      wceq cA cnp wcel vy cv cA wcel wa cA cnp wcel cB cA wcel wa vy cv vx cv
      cltq wbr vx cA wrex cB vx cv cltq wbr vx cA wrex vy cv cB wceq vy cv cA
      wcel cB cA wcel cA cnp wcel vy cv cB cA eleq1 anbi2d vy cv cB wceq vy cv
      vx cv cltq wbr cB vx cv cltq wbr vx cA vy cv cB vx cv cltq breq1 rexbidv
      imbi12d cA cnp wcel vy cv cA wcel wa vx cv vy cv cltq wbr vx cv cA wcel
      wi vx wal vy cv vx cv cltq wbr vx cA wrex cA cnp wcel vx cv vy cv cltq
      wbr vx cv cA wcel wi vx wal vy cv vx cv cltq wbr vx cA wrex wa vy cA cA
      cnp wcel c0 cA wpss cA cnq wpss wa vx cv vy cv cltq wbr vx cv cA wcel wi
      vx wal vy cv vx cv cltq wbr vx cA wrex wa vy cA wral vy vx cA elnp
      pm3.27bi r19.21bi pm3.27d vtoclg anabsi7 cB vx cv cltq wbr vx cA df-rex
      sylib $.
      $( [9-Mar-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    prnmadd.1 $e |- B e. _V $.
    $( A positive real has no largest member.  Addition version. $)
    prnmadd $p |- ( ( A e. P. /\ B e. A ) -> E. x ( B +Q x ) e. A ) $=
      cA cnp wcel cB cA wcel wa vy cv cB vx cv cplq co wceq vy cv cA wcel wa vy
      wex vx wex cB vx cv cplq co cA wcel vx wex cA cnp wcel cB cA wcel wa vy
      cv cA wcel cB vy cv cltq wbr wa vy wex vy cv cB vx cv cplq co wceq vy cv
      cA wcel wa vx wex vy wex vy cv cB vx cv cplq co wceq vy cv cA wcel wa vy
      wex vx wex vy cA cB prnmax vy cv cA wcel cB vy cv cltq wbr wa vy cv cB vx
      cv cplq co wceq vy cv cA wcel wa vx wex vy cB vy cv cltq wbr vy cv cA
      wcel vy cv cB vx cv cplq co wceq vy cv cA wcel wa vx wex cB vy cv cltq
      wbr vy cv cA wcel wa vy cv cB vx cv cplq co wceq vx wex vy cv cA wcel wa
      vy cv cB vx cv cplq co wceq vy cv cA wcel wa vx wex cB vy cv cltq wbr vy
      cv cB vx cv cplq co wceq vx wex vy cv cA wcel cB vy cv cltq wbr cB vx cv
      cplq co vy cv wceq vx wex vy cv cB vx cv cplq co wceq vx wex cB vy cv
      cltq wbr cB cnq wcel vy cv cnq wcel wa cB vx cv cplq co vy cv wceq vx wex
      cB vy cv cnq cnq cltq vy visset ltrelpq brel cB cnq wcel vy cv cnq wcel
      wa cB vy cv cltq wbr cB vx cv cplq co vy cv wceq vx wex vx cB vy cv
      prnmadd.1 ltexpq biimpcd mpd vy cv cB vx cv cplq co wceq cB vx cv cplq co
      vy cv wceq vx vy cv cB vx cv cplq co eqcom exbii sylibr anim1i vy cv cB
      vx cv cplq co wceq vy cv cA wcel vx 19.41v sylibr ancoms 19.22i vy cv cB
      vx cv cplq co wceq vy cv cA wcel wa vy vx excomim 3syl cB vx cv cplq co
      cA wcel vy cv cB vx cv cplq co wceq vy cv cA wcel wa vy wex vx vy cB vx
      cv cplq co cA df-clel exbii sylibr $.
      $( [7-Apr-1996] $)
  $}

  ${
    $d x y $.
    $( Positive real 'less than' is a relation on positive reals. $)
    ltrelpr $p |- <P C_ ( P. X. P. ) $=
      cltp vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv wpss wa vx vy copab cnp
      cnp cxp vx vy df-ltp vx cv vy cv wpss vx vy cnp cnp opabssxp eqsstri $.
      $( [14-Feb-1996] $)
  $}

  ${
    $d x y z f g h A $.  $d x y z f g h B $.  $d x y z w v u f g h G $.
    $d f g F $.
    genp.1 $e |- F = { <. <. w , v >. , u >. | ( ( w e. P. /\ v e. P. ) /\
                  u = { x | E. y e. w E. z e. v x = ( y G z ) } ) } $.

    $( Value of general operation (addition or multiplication) on positive
       reals. $)
    genpv $p |- ( ( A e. P. /\ B e. P. ) -> ( A F B ) =
               { f | E. g E. h ( ( g e. A /\ h e. B ) /\ f = ( g G h ) ) } ) $=
      cA cnp wcel cB cnp wcel wa cA cB cF co vx cv vy cv vz cv cG co wceq vz cB
      wrex vy cA wrex vx cab vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv
      cG co wceq wa vh wex vg wex vf cab vf cv vg cv cF co vx cv vy cv vz cv cG
      co wceq vz vg cv wrex vy vf cv wrex vx cab wceq cA vg cv cF co vx cv vy
      cv vz cv cG co wceq vz vg cv wrex vy cA wrex vx cab wceq cA cB cF co vx
      cv vy cv vz cv cG co wceq vz cB wrex vy cA wrex vx cab wceq vf vg cA cB
      cnp cnp vf cv cA wceq vf cv vg cv cF co cA vg cv cF co vx cv vy cv vz cv
      cG co wceq vz vg cv wrex vy vf cv wrex vx cab vx cv vy cv vz cv cG co
      wceq vz vg cv wrex vy cA wrex vx cab vf cv cA vg cv cF opreq1 vf cv cA
      wceq vx cv vy cv vz cv cG co wceq vz vg cv wrex vy vf cv wrex vx cv vy cv
      vz cv cG co wceq vz vg cv wrex vy cA wrex vx vx cv vy cv vz cv cG co wceq
      vz vg cv wrex vy vf cv cA rexeq1 abbidv eqeq12d vg cv cB wceq cA vg cv cF
      co cA cB cF co vx cv vy cv vz cv cG co wceq vz vg cv wrex vy cA wrex vx
      cab vx cv vy cv vz cv cG co wceq vz cB wrex vy cA wrex vx cab vg cv cB cA
      cF opreq2 vg cv cB wceq vx cv vy cv vz cv cG co wceq vz vg cv wrex vy cA
      wrex vx cv vy cv vz cv cG co wceq vz cB wrex vy cA wrex vx vg cv cB wceq
      vx cv vy cv vz cv cG co wceq vz vg cv wrex vx cv vy cv vz cv cG co wceq
      vz cB wrex vy cA vx cv vy cv vz cv cG co wceq vz vg cv cB rexeq1 rexbidv
      abbidv eqeq12d vw vv vu vf cv vg cv cnp cnp vx cv vy cv vz cv cG co wceq
      vz vv cv wrex vy vw cv wrex vx cab vx cv vy cv vz cv cG co wceq vz vg cv
      wrex vy vf cv wrex vx cab cF vx cv vy cv vz cv cG co wceq vz vv cv wrex
      vy vf cv wrex vx cab vy vz vx vf cv vg cv cG vf visset vg visset oprvex
      vw cv vf cv wceq vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vw cv wrex
      vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vf cv wrex vx vx cv vy cv
      vz cv cG co wceq vz vv cv wrex vy vw cv vf cv rexeq1 abbidv vv cv vg cv
      wceq vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vf cv wrex vx cv vy cv
      vz cv cG co wceq vz vg cv wrex vy vf cv wrex vx vv cv vg cv wceq vx cv vy
      cv vz cv cG co wceq vz vv cv wrex vx cv vy cv vz cv cG co wceq vz vg cv
      wrex vy vf cv vx cv vy cv vz cv cG co wceq vz vv cv vg cv rexeq1 rexbidv
      abbidv genp.1 oprabval2 vtocl2ga vx cv vy cv vz cv cG co wceq vz cB wrex
      vy cA wrex vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa
      vh wex vg wex vx vf vx cv vf cv wceq vg cv cA wcel vh cv cB wcel wa vx cv
      vg cv vh cv cG co wceq wa vh wex vg wex vg cv cA wcel vh cv cB wcel wa vf
      cv vg cv vh cv cG co wceq wa vh wex vg wex vx cv vy cv vz cv cG co wceq
      vz cB wrex vy cA wrex vx cv vf cv wceq vg cv cA wcel vh cv cB wcel wa vx
      cv vg cv vh cv cG co wceq wa vg cv cA wcel vh cv cB wcel wa vf cv vg cv
      vh cv cG co wceq wa vg vh vx cv vf cv wceq vx cv vg cv vh cv cG co wceq
      vf cv vg cv vh cv cG co wceq vg cv cA wcel vh cv cB wcel wa vx cv vf cv
      vg cv vh cv cG co eqeq1 anbi2d 2exbidv vx cv vy cv vz cv cG co wceq vz cB
      wrex vy cA wrex vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cG co
      wceq wa vz wex vy wex vg cv cA wcel vh cv cB wcel wa vx cv vg cv vh cv cG
      co wceq wa vh wex vg wex vx cv vy cv vz cv cG co wceq vy vz cA cB r2ex vy
      cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cG co wceq wa vg cv cA wcel
      vh cv cB wcel wa vx cv vg cv vh cv cG co wceq wa vy vz vg vh vy cv vg cv
      wceq vz cv vh cv wceq wa vy cv cA wcel vz cv cB wcel wa vg cv cA wcel vh
      cv cB wcel wa vx cv vy cv vz cv cG co wceq vx cv vg cv vh cv cG co wceq
      vy cv vg cv wceq vy cv cA wcel vg cv cA wcel vz cv vh cv wceq vz cv cB
      wcel vh cv cB wcel vy cv vg cv cA eleq1 vz cv vh cv cB eleq1 bi2anan9 vy
      cv vg cv wceq vz cv vh cv wceq wa vy cv vz cv cG co vg cv vh cv cG co vx
      cv vy cv vg cv vz cv vh cv cG opreq12 eqeq2d anbi12d cbvex2v bitri syl5bb
      cbvabv syl6eq $.
      $( [10-Mar-1996] $)

    ${
      $d f g h C $.  $d h F $.
      genpelv.2 $e |- C e. _V $.
      $( Membership in value of general operation (addition or multiplication)
         on positive reals. $)
      genpelv $p |- ( ( A e. P. /\ B e. P. ) -> ( C e. ( A F B ) <->
                 E. f E. g ( ( f e. A /\ g e. B ) /\ C = ( f G g ) ) ) ) $=
        cA cnp wcel cB cnp wcel wa cC cA cB cF co wcel cC vf cv cA wcel vg cv
        cB wcel wa vh cv vf cv vg cv cG co wceq wa vg wex vf wex vh cab wcel vf
        cv cA wcel vg cv cB wcel wa cC vf cv vg cv cG co wceq wa vg wex vf wex
        cA cnp wcel cB cnp wcel wa cA cB cF co vf cv cA wcel vg cv cB wcel wa
        vh cv vf cv vg cv cG co wceq wa vg wex vf wex vh cab cC vx vy vz vw vv
        vu cA cB vh vf vg cF cG genp.1 genpv eleq2d vf cv cA wcel vg cv cB wcel
        wa vh cv vf cv vg cv cG co wceq wa vg wex vf wex vf cv cA wcel vg cv cB
        wcel wa cC vf cv vg cv cG co wceq wa vg wex vf wex vh cC genpelv.2 vh
        cv cC wceq vf cv cA wcel vg cv cB wcel wa vh cv vf cv vg cv cG co wceq
        wa vf cv cA wcel vg cv cB wcel wa cC vf cv vg cv cG co wceq wa vf vg vh
        cv cC wceq vh cv vf cv vg cv cG co wceq cC vf cv vg cv cG co wceq vf cv
        cA wcel vg cv cB wcel wa vh cv cC vf cv vg cv cG co eqeq1 anbi2d
        2exbidv elab syl6bb $.
        $( [13-Mar-1996] $)
    $}

    ${
      $d f g h C $.  $d f g h D $.
      $( Pre-closure law for general operation on positive reals. $)
      genpprecl $p |- ( ( A e. P. /\ B e. P. ) -> ( ( C e. A /\ D e. B ) ->
                    ( C G D ) e. ( A F B ) ) ) $=
        cA cnp wcel cB cnp wcel wa cC cA wcel cD cB wcel wa cC cD cG co cC cD
        cG co wceq cC cD cG co cA cB cF co wcel cC cD cG co eqid cA cnp wcel cB
        cnp wcel wa cC cD cG co cA cB cF co wcel vg cv cA wcel vh cv cB wcel wa
        cC cD cG co vg cv vh cv cG co wceq wa vh wex vg wex cC cA wcel cD cB
        wcel wa cC cD cG co cC cD cG co wceq wa cA cnp wcel cB cnp wcel wa cC
        cD cG co cA cB cF co wcel cC cD cG co vg cv cA wcel vh cv cB wcel wa vf
        cv vg cv vh cv cG co wceq wa vh wex vg wex vf cab wcel vg cv cA wcel vh
        cv cB wcel wa cC cD cG co vg cv vh cv cG co wceq wa vh wex vg wex cA
        cnp wcel cB cnp wcel wa cA cB cF co vg cv cA wcel vh cv cB wcel wa vf
        cv vg cv vh cv cG co wceq wa vh wex vg wex vf cab cC cD cG co vx vy vz
        vw vv vu cA cB vf vg vh cF cG genp.1 genpv eleq2d vg cv cA wcel vh cv
        cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex vg cv cA wcel
        vh cv cB wcel wa cC cD cG co vg cv vh cv cG co wceq wa vh wex vg wex vf
        cC cD cG co cC cD cG oprex vf cv cC cD cG co wceq vg cv cA wcel vh cv
        cB wcel wa vf cv vg cv vh cv cG co wceq wa vg cv cA wcel vh cv cB wcel
        wa cC cD cG co vg cv vh cv cG co wceq wa vg vh vf cv cC cD cG co wceq
        vf cv vg cv vh cv cG co wceq cC cD cG co vg cv vh cv cG co wceq vg cv
        cA wcel vh cv cB wcel wa vf cv cC cD cG co vg cv vh cv cG co eqeq1
        anbi2d 2exbidv elab syl6bb cC cA wcel cD cB wcel wa cC cD cG co cC cD
        cG co wceq vg cv cA wcel vh cv cB wcel wa cC cD cG co vg cv vh cv cG co
        wceq wa vh wex vg wex vg cv cA wcel vh cv cB wcel wa cC cD cG co vg cv
        vh cv cG co wceq wa cC cA wcel cD cB wcel wa cC cD cG co cC cD cG co
        wceq wa vg vh cC cD cA cB vg cv cC wceq vh cv cD wceq wa vg cv cA wcel
        vh cv cB wcel wa cC cA wcel cD cB wcel wa cC cD cG co vg cv vh cv cG co
        wceq cC cD cG co cC cD cG co wceq vg cv cC wceq vg cv cA wcel cC cA
        wcel vh cv cD wceq vh cv cB wcel cD cB wcel vg cv cC cA eleq1 vh cv cD
        cB eleq1 bi2anan9 vg cv cC wceq vh cv cD wceq wa vg cv vh cv cG co cC
        cD cG co cC cD cG co vg cv cC vh cv cD cG opreq12 eqeq2d anbi12d
        cla42egv anabsi5 syl5bir mpan2i $.
        $( [10-Mar-1996] $)
    $}

    $( Domain of general operation on positive reals. $)
    genpdm $p |- dom F = ( P. X. P. ) $=
      vw cv cnp wcel vv cv cnp wcel wa vu cv vx cv vy cv vz cv cG co wceq vz vv
      cv wrex vy vw cv wrex vx cab wceq wa vw vv vu copab2 cdm vw cv cnp wcel
      vv cv cnp wcel wa vu cv vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vw
      cv wrex vx cab wceq wa vu wex vw vv copab cF cdm cnp cnp cxp vw cv cnp
      wcel vv cv cnp wcel wa vu cv vx cv vy cv vz cv cG co wceq vz vv cv wrex
      vy vw cv wrex vx cab wceq wa vw vv vu dmoprab cF vw cv cnp wcel vv cv cnp
      wcel wa vu cv vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vw cv wrex vx
      cab wceq wa vw vv vu copab2 genp.1 dmeqi cnp cnp cxp vw cv cnp wcel vv cv
      cnp wcel wa vw vv copab vw cv cnp wcel vv cv cnp wcel wa vu cv vx cv vy
      cv vz cv cG co wceq vz vv cv wrex vy vw cv wrex vx cab wceq wa vu wex vw
      vv copab vw vv cnp cnp df-xp vw cv cnp wcel vv cv cnp wcel wa vu cv vx cv
      vy cv vz cv cG co wceq vz vv cv wrex vy vw cv wrex vx cab wceq wa vu wex
      vw cv cnp wcel vv cv cnp wcel wa vw vv vw cv cnp wcel vv cv cnp wcel wa
      vu cv vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vw cv wrex vx cab
      wceq wa vu wex vw cv cnp wcel vv cv cnp wcel wa vu cv vx cv vy cv vz cv
      cG co wceq vz vv cv wrex vy vw cv wrex vx cab wceq vu wex vw cv cnp wcel
      vv cv cnp wcel wa vu cv vx cv vy cv vz cv cG co wceq vz vv cv wrex vy vw
      cv wrex vx cab wceq vu 19.42v vu vx cv vy cv vz cv cG co wceq vz vv cv
      wrex vy vw cv wrex vx cab vy vz vx vw cv vv cv cG vw visset vv visset
      oprvex isseti mpbiran2 opabbii eqtr4i 3eqtr4i $.
      $( [18-Nov-1995] $)

    $( The result of an operation on positive reals is not empty. $)
    genpn0 $p |- ( ( A e. P. /\ B e. P. ) -> (/) C. ( A F B ) ) $=
      cA cnp wcel cB cnp wcel wa vf cv cA cB cF co wcel vf wex c0 cA cB cF co
      wpss cA cnp wcel cB cnp wcel wa vf cv cA cB cF co wcel vf wex vg cv cA
      wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex vf
      wex cA cnp wcel cB cnp wcel wa vg cv cA wcel vg wex vh cv cB wcel vh wex
      wa vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex
      vg wex vf wex cA cnp wcel vg cv cA wcel vg wex cB cnp wcel vh cv cB wcel
      vh wex cA cnp wcel cA c0 wne vg cv cA wcel vg wex cA prn0 vg cA n0 sylib
      cB cnp wcel cB c0 wne vh cv cB wcel vh wex cB prn0 vh cB n0 sylib anim12i
      vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg
      wex vf wex vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa
      vf wex vh wex vg wex vg cv cA wcel vh cv cB wcel wa vh wex vg wex vg cv
      cA wcel vg wex vh cv cB wcel vh wex wa vg cv cA wcel vh cv cB wcel wa vf
      cv vg cv vh cv cG co wceq wa vf vg vh exrot3 vg cv cA wcel vh cv cB wcel
      wa vf cv vg cv vh cv cG co wceq wa vf wex vg cv cA wcel vh cv cB wcel wa
      vg vh vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vf
      wex vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq vf wex vg
      cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq vf 19.42v vf vg
      cv vh cv cG co vg cv vh cv cG oprex isseti mpbiran2 2exbii vg cv cA wcel
      vh cv cB wcel vg vh eeanv 3bitri sylibr cA cnp wcel cB cnp wcel wa vf cv
      cA cB cF co wcel vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co
      wceq wa vh wex vg wex vf cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv
      cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex vf cA cB cF co
      vx vy vz vw vv vu cA cB vf vg vh cF cG genp.1 genpv abeq2d exbidv mpbird
      c0 cA cB cF co wpss cA cB cF co c0 wne vf cv cA cB cF co wcel vf wex cA
      cB cF co 0pss vf cA cB cF co n0 bitri sylibr $.
      $( [28-Feb-1996] $)

    ${
      genpss.2 $e |- ( ( g e. Q. /\ h e. Q. ) -> ( g G h ) e. Q. ) $.
      $( The result of an operation on positive reals is a subset of the
         positive fractions. $)
      genpss $p |- ( ( A e. P. /\ B e. P. ) -> ( A F B ) C_ Q. ) $=
        cA cnp wcel cB cnp wcel wa vf cA cB cF co cnq cA cnp wcel cB cnp wcel
        wa vf cv cA cB cF co wcel vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh
        cv cG co wceq wa vh wex vg wex vf cv cnq wcel cA cnp wcel cB cnp wcel
        wa vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vh
        wex vg wex vf cA cB cF co vx vy vz vw vv vu cA cB vf vg vh cF cG genp.1
        genpv abeq2d cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel wa
        vf cv vg cv vh cv cG co wceq wa vf cv cnq wcel vg vh cA cnp wcel cB cnp
        wcel wa vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq vf
        cv cnq wcel cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel wa
        vg cv vh cv cG co cnq wcel vf cv vg cv vh cv cG co wceq vf cv cnq wcel
        wi cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel wa vg cv cnq
        wcel vh cv cnq wcel wa vg cv vh cv cG co cnq wcel cA cnp wcel vg cv cA
        wcel vg cv cnq wcel cB cnp wcel vh cv cB wcel vh cv cnq wcel cA cnp
        wcel cA cnq vg cv cA cnp wcel cA cnq cA prpssnq pssssd sseld cB cnp
        wcel cB cnq vh cv cB cnp wcel cB cnq cB prpssnq pssssd sseld im2anan9
        genpss.2 syl6 vg cv vh cv cG co cnq vf cv eleq1a syl6 imp3a 19.23advv
        sylbid ssrdv $.
        $( [18-Nov-1995] $)
    $}

    ${
      $d w v A $.  $d w v B $.  $d w v F $.
      genpnnp.2 $e |- ( ( w e. Q. /\ v e. Q. ) -> ( w G v ) e. Q. ) $.
      genpnnp.3 $e |- ( z e. Q. ->
                      ( x <Q y <-> ( z G x ) <Q ( z G y ) ) ) $.
      genpnnp.4 $e |- ( x G y ) = ( y G x ) $.
      $( The result of an operation on positive reals is different from
         the set of positive fractions. $)
      genpnnp $p |- ( ( A e. P. /\ B e. P. ) -> -. ( A F B ) = Q. ) $=
        cA cnp wcel cB cnp wcel wa vw cv cnq wcel vw cv cA wcel wn wa vv cv cnq
        wcel vv cv cB wcel wn wa wa vv wex vw wex cA cB cF co cnq wceq wn cA
        cnp wcel cB cnp wcel wa vw cv cnq wcel vw cv cA wcel wn wa vw wex vv cv
        cnq wcel vv cv cB wcel wn wa vv wex wa vw cv cnq wcel vw cv cA wcel wn
        wa vv cv cnq wcel vv cv cB wcel wn wa wa vv wex vw wex cA cnp wcel vw
        cv cnq wcel vw cv cA wcel wn wa vw wex cB cnp wcel vv cv cnq wcel vv cv
        cB wcel wn wa vv wex cA cnp wcel cA cnq wpss vw cv cnq wcel vw cv cA
        wcel wn wa vw wex cA prpssnq vw cA cnq pssnel syl cB cnp wcel cB cnq
        wpss vv cv cnq wcel vv cv cB wcel wn wa vv wex cB prpssnq vv cB cnq
        pssnel syl anim12i vw cv cnq wcel vw cv cA wcel wn wa vv cv cnq wcel vv
        cv cB wcel wn wa vw vv eeanv sylibr cA cnp wcel cB cnp wcel wa vw cv
        cnq wcel vw cv cA wcel wn wa vv cv cnq wcel vv cv cB wcel wn wa wa cA
        cB cF co cnq wceq wn vw vv vw cv cnq wcel vw cv cA wcel wn wa vv cv cnq
        wcel vv cv cB wcel wn wa wa cA cnp wcel cB cnp wcel wa cA cB cF co cnq
        wceq wn vw cv cnq wcel vw cv cA wcel wn wa vv cv cnq wcel vv cv cB wcel
        wn wa wa cA cnp wcel cB cnp wcel wa vw cv vv cv cG co cA cB cF co wcel
        wn cA cB cF co cnq wceq wn vw cv cnq wcel vv cv cnq wcel vw cv cA wcel
        wn vv cv cB wcel wn cA cnp wcel cB cnp wcel wa vw cv vv cv cG co cA cB
        cF co wcel wn wi vw cv cA wcel wn vv cv cB wcel wn wa vw cv cnq wcel vv
        cv cnq wcel wa cA cnp wcel cB cnp wcel wa vw cv vv cv cG co cA cB cF co
        wcel wn wi cA cnp wcel cB cnp wcel wa vw cv cA wcel wn vv cv cB wcel wn
        wa vw cv cnq wcel vv cv cnq wcel wa wa vw cv vv cv cG co cA cB cF co
        wcel wn cA cnp wcel cB cnp wcel wa vw cv cA wcel wn vv cv cB wcel wn wa
        vw cv cnq wcel vv cv cnq wcel wa wa vg cv cA wcel vh cv cB wcel wa vw
        cv vv cv cG co vg cv vh cv cG co wceq wa vh wex vg wex wn vw cv vv cv
        cG co cA cB cF co wcel wn cA cnp wcel cB cnp wcel wa vw cv cA wcel wn
        vv cv cB wcel wn wa vw cv cnq wcel vv cv cnq wcel wa wa vg cv cA wcel
        vh cv cB wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq wa vh wex vg
        wex wn cA cnp wcel cB cnp wcel wa vw cv cA wcel wn vv cv cB wcel wn wa
        vw cv cnq wcel vv cv cnq wcel wa wa wa vg cv cA wcel vh cv cB wcel wa
        vw cv vv cv cG co vg cv vh cv cG co wceq wa vh wex vg cA cnp wcel cB
        cnp wcel wa vw cv cA wcel wn vv cv cB wcel wn wa vw cv cnq wcel vv cv
        cnq wcel wa wa wa vg cv cA wcel vh cv cB wcel wa vw cv vv cv cG co vg
        cv vh cv cG co wceq wa vh cA cnp wcel cB cnp wcel wa vw cv cA wcel wn
        vv cv cB wcel wn wa vw cv cnq wcel vv cv cnq wcel wa wa wa vg cv cA
        wcel vh cv cB wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq wn wi vg
        cv cA wcel vh cv cB wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq wa
        wn cA cnp wcel cB cnp wcel wa vw cv cA wcel wn vv cv cB wcel wn wa vw
        cv cnq wcel vv cv cnq wcel wa vg cv cA wcel vh cv cB wcel wa vw cv vv
        cv cG co vg cv vh cv cG co wceq wn wi cA cnp wcel cB cnp wcel wa vg cv
        cA wcel vh cv cB wcel wa vw cv cnq wcel vv cv cnq wcel wa vw cv cA wcel
        wn vv cv cB wcel wn wa vw cv vv cv cG co vg cv vh cv cG co wceq wn cA
        cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel wa vw cv cnq wcel
        vv cv cnq wcel wa vw cv cA wcel wn vv cv cB wcel wn wa vw cv vv cv cG
        co vg cv vh cv cG co wceq wn wi wi cA cnp wcel vg cv cA wcel cB cnp
        wcel vh cv cB wcel vw cv cnq wcel vv cv cnq wcel wa vw cv cA wcel wn vv
        cv cB wcel wn wa vw cv vv cv cG co vg cv vh cv cG co wceq wn wi wi cA
        cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vw cv cnq
        wcel vv cv cnq wcel wa vw cv cA wcel wn vv cv cB wcel wn wa vw cv vv cv
        cG co vg cv vh cv cG co wceq wn wi cA cnp wcel vg cv cA wcel wa vw cv
        cnq wcel cB cnp wcel vh cv cB wcel wa vv cv cnq wcel vw cv cA wcel wn
        vv cv cB wcel wn wa vw cv vv cv cG co vg cv vh cv cG co wceq wn wi cA
        cnp wcel vg cv cA wcel wa vw cv cnq wcel wa cB cnp wcel vh cv cB wcel
        wa vv cv cnq wcel wa wa vw cv cA wcel wn vv cv cB wcel wn wa vg cv vw
        cv cltq wbr vh cv vv cv cltq wbr wa vw cv vv cv cG co vg cv vh cv cG co
        wceq wn cA cnp wcel vg cv cA wcel wa vw cv cnq wcel wa vw cv cA wcel wn
        vg cv vw cv cltq wbr cB cnp wcel vh cv cB wcel wa vv cv cnq wcel wa vv
        cv cB wcel wn vh cv vv cv cltq wbr cA vg cv vw cv prub cB vh cv vv cv
        prub im2anan9 vg cv cnq wcel vw cv cnq wcel wa vh cv cnq wcel vv cv cnq
        wcel wa vg cv vw cv cltq wbr vh cv vv cv cltq wbr wa vw cv vv cv cG co
        vg cv vh cv cG co wceq wn wi cA cnp wcel vg cv cA wcel wa vw cv cnq
        wcel wa cB cnp wcel vh cv cB wcel wa vv cv cnq wcel wa vg cv cnq wcel
        vw cv cnq wcel wa vh cv cnq wcel vv cv cnq wcel wa wa vw cv vv cv cG co
        vg cv vh cv cG co wceq vg cv vw cv cltq wbr vh cv vv cv cltq wbr wa vg
        cv cnq wcel vw cv cnq wcel wa vh cv cnq wcel vv cv cnq wcel wa wa vw cv
        vv cv cG co vg cv vh cv cG co wceq vg cv vw cv cltq wbr vh cv vv cv
        cltq wbr wa wn vg cv cnq wcel vw cv cnq wcel wa vh cv cnq wcel vv cv
        cnq wcel wa wa vw cv vv cv cG co vg cv vh cv cG co wceq wa vg cv vw cv
        cltq wbr vw cv vg cv cltq wbr wa vg cv vw cv cltq wbr vh cv vv cv cltq
        wbr wa vg cv cnq wcel vw cv cnq wcel wa vg cv vw cv cltq wbr vw cv vg
        cv cltq wbr wa wn vh cv cnq wcel vv cv cnq wcel wa vw cv vv cv cG co vg
        cv vh cv cG co wceq cnq cltq wor vg cv cnq wcel vw cv cnq wcel wa vg cv
        vw cv cltq wbr vw cv vg cv cltq wbr wa wn ltsopq cnq vg cv vw cv cltq
        so2nr mpan ad2antrr vv cv cnq wcel vg cv cnq wcel wa vw cv vv cv cG co
        vg cv vh cv cG co wceq vg cv vw cv cltq wbr vw cv vg cv cltq wbr wa vg
        cv vw cv cltq wbr vh cv vv cv cltq wbr wa wb vg cv cnq wcel vw cv cnq
        wcel wa vh cv cnq wcel vv cv cnq wcel wa wa vv cv cnq wcel vg cv cnq
        wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq wa vw cv vg cv cltq
        wbr vh cv vv cv cltq wbr vg cv vw cv cltq wbr vx vy vz vw cv vv cv vg
        cv vh cv cltq cnq cG vw visset vv visset genpnnp.3 vg visset genpnnp.4
        vh visset caoprord3 anbi2d vh cv cnq wcel vv cv cnq wcel wa vg cv cnq
        wcel vw cv cnq wcel wa vv cv cnq wcel vg cv cnq wcel wa vh cv cnq wcel
        vv cv cnq wcel wa vv cv cnq wcel vg cv cnq wcel vw cv cnq wcel wa vg cv
        cnq wcel vh cv cnq wcel vv cv cnq wcel pm3.27 vg cv cnq wcel vw cv cnq
        wcel pm3.26 anim12i ancoms sylan mtbid ex con2d cA cnp wcel vg cv cA
        wcel wa vg cv cnq wcel vw cv cnq wcel cA vg cv elprpq anim1i cB cnp
        wcel vh cv cB wcel wa vh cv cnq wcel vv cv cnq wcel cB vh cv elprpq
        anim1i syl2an syld an4s ex an4s ex com24 imp32 vg cv cA wcel vh cv cB
        wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq imnan sylib nexdv
        nexdv ex cA cnp wcel cB cnp wcel wa vw cv vv cv cG co cA cB cF co wcel
        vg cv cA wcel vh cv cB wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq
        wa vh wex vg wex cA cnp wcel cB cnp wcel wa vw cv vv cv cG co cA cB cF
        co wcel vw cv vv cv cG co vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh
        cv cG co wceq wa vh wex vg wex vf cab wcel vg cv cA wcel vh cv cB wcel
        wa vw cv vv cv cG co vg cv vh cv cG co wceq wa vh wex vg wex cA cnp
        wcel cB cnp wcel wa cA cB cF co vg cv cA wcel vh cv cB wcel wa vf cv vg
        cv vh cv cG co wceq wa vh wex vg wex vf cab vw cv vv cv cG co vx vy vz
        vw vv vu cA cB vf vg vh cF cG genp.1 genpv eleq2d vg cv cA wcel vh cv
        cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex vg cv cA wcel
        vh cv cB wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq wa vh wex vg
        wex vf vw cv vv cv cG co vw cv vv cv cG oprex vf cv vw cv vv cv cG co
        wceq vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vg
        cv cA wcel vh cv cB wcel wa vw cv vv cv cG co vg cv vh cv cG co wceq wa
        vg vh vf cv vw cv vv cv cG co wceq vf cv vg cv vh cv cG co wceq vw cv
        vv cv cG co vg cv vh cv cG co wceq vg cv cA wcel vh cv cB wcel wa vf cv
        vw cv vv cv cG co vg cv vh cv cG co eqeq1 anbi2d 2exbidv elab syl6bb
        notbid sylibrd com12 ancoms an4s vw cv cnq wcel vv cv cnq wcel vw cv vv
        cv cG co cA cB cF co wcel wn cA cB cF co cnq wceq wn wi vw cv cA wcel
        wn vv cv cB wcel wn vw cv cnq wcel vv cv cnq wcel wa vw cv vv cv cG co
        cnq wcel vw cv vv cv cG co cA cB cF co wcel wn cA cB cF co cnq wceq wn
        wi genpnnp.2 vw cv vv cv cG co cnq wcel cA cB cF co cnq wceq vw cv vv
        cv cG co cA cB cF co wcel cA cB cF co cnq wceq vw cv vv cv cG co cA cB
        cF co wcel vw cv vv cv cG co cnq wcel cA cB cF co cnq vw cv vv cv cG co
        eleq2 biimprcd con3d syl ad2ant2r syld com12 19.23advv mpd $.
        $( [29-Feb-1996] $)
    $}

    ${
      $d F h $.
      genpcd.2 $e |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g G h ) -> x e. ( A F B ) ) ) $.
      $( Downward closure of an operation on positive reals. $)
      genpcd $p |- ( ( A e. P. /\ B e. P. ) -> ( f e. ( A F B ) ->
                   ( x <Q f -> x e. ( A F B ) ) ) ) $=
        cA cnp wcel cB cnp wcel wa vx cv vf cv cltq wbr vf cv cA cB cF co wcel
        vx cv cA cB cF co wcel cA cnp wcel cB cnp wcel wa vx cv vf cv cltq wbr
        vf cv cA cB cF co wcel vx cv cA cB cF co wcel wi cA cnp wcel cB cnp
        wcel wa vx cv vf cv cltq wbr vf cv cA cB cF co wcel vx cv vf cv cltq
        wbr vx cv cA cB cF co wcel cA cnp wcel cB cnp wcel wa vx cv cnq wcel vf
        cv cA cB cF co wcel vx cv vf cv cltq wbr vx cv cA cB cF co wcel wi wi
        vx cv vf cv cltq wbr cA cnp wcel cB cnp wcel wa vx cv cnq wcel vf cv cA
        cB cF co wcel vx cv vf cv cltq wbr vx cv cA cB cF co wcel wi wi cA cnp
        wcel cB cnp wcel wa vx cv cnq wcel wa vf cv cA cB cF co wcel vg cv cA
        wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex vx
        cv vf cv cltq wbr vx cv cA cB cF co wcel wi cA cnp wcel cB cnp wcel wa
        vf cv cA cB cF co wcel vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh cv
        cG co wceq wa vh wex vg wex wb vx cv cnq wcel vx vy vz vw vv vu cA cB
        vf cv vg vh cF cG genp.1 vf visset genpelv adantr cA cnp wcel cB cnp
        wcel wa vx cv cnq wcel wa vg cv cA wcel vh cv cB wcel wa vf cv vg cv vh
        cv cG co wceq wa vx cv vf cv cltq wbr vx cv cA cB cF co wcel wi vg vh
        cA cnp wcel cB cnp wcel wa vx cv cnq wcel vg cv cA wcel vh cv cB wcel
        wa vf cv vg cv vh cv cG co wceq vx cv vf cv cltq wbr vx cv cA cB cF co
        wcel wi cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel wa vx cv
        cnq wcel vf cv vg cv vh cv cG co wceq vx cv vf cv cltq wbr vx cv cA cB
        cF co wcel wi wi cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel
        wa vx cv cnq wcel vf cv vg cv vh cv cG co wceq vx cv vf cv cltq wbr vx
        cv cA cB cF co wcel wi wi wi cA cnp wcel vg cv cA wcel cB cnp wcel vh
        cv cB wcel vx cv cnq wcel vf cv vg cv vh cv cG co wceq vx cv vf cv cltq
        wbr vx cv cA cB cF co wcel wi wi wi cA cnp wcel vg cv cA wcel wa cB cnp
        wcel vh cv cB wcel wa wa vx cv cnq wcel vf cv vg cv vh cv cG co wceq vx
        cv vf cv cltq wbr vx cv cA cB cF co wcel wi vf cv vg cv vh cv cG co
        wceq vx cv vf cv cltq wbr vx cv vg cv vh cv cG co cltq wbr cA cnp wcel
        vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq wcel wa vx
        cv cA cB cF co wcel vf cv vg cv vh cv cG co wceq vx cv vf cv cltq wbr
        vx cv vg cv vh cv cG co cltq wbr vf cv vg cv vh cv cG co vx cv cltq
        breq2 biimpd genpcd.2 sylan9r exp31 an4s ex com23 imp4b 19.23advv
        sylbid ex vx cv vf cv cltq wbr vx cv cnq wcel vf cv cnq wcel vx cv vf
        cv cnq cnq cltq vf visset ltrelpq brel pm3.26d syl5 com34 pm2.43d com23
        $.
        $( [13-Mar-1996] $)
    $}

    ${
      $d x y h F $.
      genpnmax.2 $e |- ( v e. Q. ->
                       ( z <Q w <-> ( v G z ) <Q ( v G w ) ) ) $.
      genpnmax.3 $e |- ( z G w ) = ( w G z ) $.
      $( An operation on positive reals has no largest member. $)
      genpnmax $p |- ( ( A e. P. /\ B e. P. ) -> ( f e. ( A F B ) ->
                     E. x ( x e. ( A F B ) /\ f <Q x ) ) ) $=
        cA cnp wcel cB cnp wcel wa vf cv cA cB cF co wcel vg cv cA wcel vh cv
        cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex vx cv cA cB cF
        co wcel vf cv vx cv cltq wbr wa vx wex cA cnp wcel cB cnp wcel wa vg cv
        cA wcel vh cv cB wcel wa vf cv vg cv vh cv cG co wceq wa vh wex vg wex
        vf cA cB cF co vx vy vz vw vv vu cA cB vf vg vh cF cG genp.1 genpv
        abeq2d cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel wa vf cv
        vg cv vh cv cG co wceq wa vx cv cA cB cF co wcel vf cv vx cv cltq wbr
        wa vx wex vg vh cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB wcel
        wa vf cv vg cv vh cv cG co wceq vx cv cA cB cF co wcel vf cv vx cv cltq
        wbr wa vx wex vf cv vg cv vh cv cG co wceq cA cnp wcel cB cnp wcel wa
        vg cv cA wcel vh cv cB wcel wa vx cv cA cB cF co wcel vf cv vx cv cltq
        wbr wa vx wex vf cv vg cv vh cv cG co wceq cA cnp wcel cB cnp wcel wa
        vg cv cA wcel vh cv cB wcel wa vx cv cA cB cF co wcel vf cv vx cv cltq
        wbr wa vx wex vf cv vg cv vh cv cG co wceq vx cv cA cB cF co wcel vf cv
        vx cv cltq wbr wa vx wex vx cv cA cB cF co wcel vg cv vh cv cG co vx cv
        cltq wbr wa vx wex cA cnp wcel cB cnp wcel wa vg cv cA wcel vh cv cB
        wcel wa wa vf cv vg cv vh cv cG co wceq vx cv cA cB cF co wcel vf cv vx
        cv cltq wbr wa vx cv cA cB cF co wcel vg cv vh cv cG co vx cv cltq wbr
        wa vx vf cv vg cv vh cv cG co wceq vf cv vx cv cltq wbr vg cv vh cv cG
        co vx cv cltq wbr vx cv cA cB cF co wcel vf cv vg cv vh cv cG co vx cv
        cltq breq1 anbi2d exbidv cA cnp wcel vg cv cA wcel cB cnp wcel vh cv cB
        wcel vx cv cA cB cF co wcel vg cv vh cv cG co vx cv cltq wbr wa vx wex
        cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vy cv cA
        wcel vg cv vy cv cltq wbr wa vy wex vx cv cA cB cF co wcel vg cv vh cv
        cG co vx cv cltq wbr wa vx wex cA cnp wcel vg cv cA wcel wa vy cv cA
        wcel vg cv vy cv cltq wbr wa vy wex cB cnp wcel vh cv cB wcel wa vy cA
        vg cv prnmax adantr cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB
        wcel wa wa vy cv cA wcel vg cv vy cv cltq wbr wa vx cv cA cB cF co wcel
        vg cv vh cv cG co vx cv cltq wbr wa vx wex vy cA cnp wcel cB cnp wcel
        vh cv cB wcel wa vy cv cA wcel vg cv vy cv cltq wbr wa vx cv cA cB cF
        co wcel vg cv vh cv cG co vx cv cltq wbr wa vx wex wi vg cv cA wcel cA
        cnp wcel cB cnp wcel vh cv cB wcel wa wa vy cv cA wcel vg cv vy cv cltq
        wbr wa vy cv vh cv cG co cA cB cF co wcel vg cv vh cv cG co vy cv vh cv
        cG co cltq wbr wa vx cv cA cB cF co wcel vg cv vh cv cG co vx cv cltq
        wbr wa vx wex cA cnp wcel cB cnp wcel vh cv cB wcel wa wa vy cv cA wcel
        vy cv vh cv cG co cA cB cF co wcel vg cv vy cv cltq wbr vg cv vh cv cG
        co vy cv vh cv cG co cltq wbr cA cnp wcel cB cnp wcel vh cv cB wcel vy
        cv cA wcel vy cv vh cv cG co cA cB cF co wcel wi cA cnp wcel cB cnp
        wcel vy cv cA wcel vh cv cB wcel vy cv vh cv cG co cA cB cF co wcel cA
        cnp wcel cB cnp wcel vy cv cA wcel vh cv cB wcel vy cv vh cv cG co cA
        cB cF co wcel vx vy vz vw vv vu cA cB vy cv vh cv cF cG genp.1
        genpprecl exp4b com34 imp32 cB cnp wcel vh cv cB wcel wa vg cv vy cv
        cltq wbr vg cv vh cv cG co vy cv vh cv cG co cltq wbr wi cA cnp wcel cB
        cnp wcel vh cv cB wcel wa vh cv cnq wcel vg cv vy cv cltq wbr vg cv vh
        cv cG co vy cv vh cv cG co cltq wbr wi cB vh cv elprpq vh cv cnq wcel
        vg cv vy cv cltq wbr vg cv vh cv cG co vy cv vh cv cG co cltq wbr vz vw
        vv vg cv vy cv vh cv cltq cnq cG vg visset vy visset genpnmax.2 vh
        visset genpnmax.3 caoprord2 biimpd syl adantl anim12d vx cv cA cB cF co
        wcel vg cv vh cv cG co vx cv cltq wbr wa vy cv vh cv cG co cA cB cF co
        wcel vg cv vh cv cG co vy cv vh cv cG co cltq wbr wa vx vy cv vh cv cG
        co vy cv vh cv cG oprex vx cv vy cv vh cv cG co wceq vx cv cA cB cF co
        wcel vy cv vh cv cG co cA cB cF co wcel vg cv vh cv cG co vx cv cltq
        wbr vg cv vh cv cG co vy cv vh cv cG co cltq wbr vx cv vy cv vh cv cG
        co cA cB cF co eleq1 vx cv vy cv vh cv cG co vg cv vh cv cG co cltq
        breq2 anbi12d cla4ev syl6 adantlr 19.23adv mpd an4s syl5bir exp3a com3l
        imp3a 19.23advv sylbid $.
        $( [10-Mar-1996] $)
    $}

    ${
      $d w v A $.  $d w v B $.  $d x y w v h F $.
      genpcl.2 $e |- ( ( x e. Q. /\ y e. Q. ) -> ( x G y ) e. Q. ) $.
      genpcl.3 $e |- ( h e. Q. ->
                      ( f <Q g <-> ( h G f ) <Q ( h G g ) ) ) $.
      genpcl.4 $e |- ( x G y ) = ( y G x ) $.
      genpcl.5 $e |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g G h ) -> x e. ( A F B ) ) ) $.
      $( Closure of an operation on reals. $)
      genpcl $p |- ( ( A e. P. /\ B e. P. ) -> ( A F B ) e. P. ) $=
        cA cnp wcel cB cnp wcel wa c0 cA cB cF co wpss cA cB cF co cnq wpss wa
        vx cv vf cv cltq wbr vx cv cA cB cF co wcel wi vx wal vf cv vx cv cltq
        wbr vx cA cB cF co wrex wa vf cA cB cF co wral wa cA cB cF co cnp wcel
        cA cnp wcel cB cnp wcel wa c0 cA cB cF co wpss cA cB cF co cnq wpss vx
        cv vf cv cltq wbr vx cv cA cB cF co wcel wi vx wal vf cv vx cv cltq wbr
        vx cA cB cF co wrex wa vf cA cB cF co wral vx vy vz vw vv vu cA cB cF
        cG genp.1 genpn0 cA cB cF co cnq wpss cA cB cF co cnq wss cA cB cF co
        cnq wceq wn cA cnp wcel cB cnp wcel wa cA cB cF co cnq dfpss2 vx vy vz
        vw vv vu cA cB vg vh cF cG genp.1 vx vy vg cv vh cv cnq cG genpcl.2
        caoprcl genpss vx vy vz vw vv vu cA cB cF cG genp.1 vx vy vw cv vv cv
        cnq cG genpcl.2 caoprcl vf vg vh vx cv vy cv vz cv cltq cnq cG vx
        visset vy visset genpcl.3 caoprord genpcl.4 genpnnp sylanbrc cA cnp
        wcel cB cnp wcel wa vx cv vf cv cltq wbr vx cv cA cB cF co wcel wi vx
        wal vf cv vx cv cltq wbr vx cA cB cF co wrex wa vf cA cB cF co cA cnp
        wcel cB cnp wcel wa vf cv cA cB cF co wcel vx cv vf cv cltq wbr vx cv
        cA cB cF co wcel wi vx wal vf cv vx cv cltq wbr vx cA cB cF co wrex cA
        cnp wcel cB cnp wcel wa vf cv cA cB cF co wcel vx cv vf cv cltq wbr vx
        cv cA cB cF co wcel wi vx vx vy vz vw vv vu cA cB vf vg vh cF cG genp.1
        genpcl.5 genpcd 19.21adv cA cnp wcel cB cnp wcel wa vf cv cA cB cF co
        wcel vx cv cA cB cF co wcel vf cv vx cv cltq wbr wa vx wex vf cv vx cv
        cltq wbr vx cA cB cF co wrex vx vy vz vw vv vu cA cB vf cF cG genp.1 vf
        vg vh vz cv vw cv vv cv cltq cnq cG vz visset vw visset genpcl.3
        caoprord vx vy vz cv vw cv cG vz visset vw visset genpcl.4 caoprcom
        genpnmax vf cv vx cv cltq wbr vx cA cB cF co df-rex syl6ibr jcad
        r19.21aiv jca31 vf vx cA cB cF co elnp sylibr $.
        $( [13-Mar-1996] $)
    $}

    ${
      $d x y z w v u f g h t $.
      $d x f g h t A $.  $d x f g h t B $.  $d x y z f g h t C $.
      $d x y z h t F $.  $d t G $.
      genpass.2 $e |- B e. _V $.
      genpass.3 $e |- C e. _V $.
      genpass.4 $e |- dom F = ( P. X. P. ) $.
      genpass.5 $e |- ( ( f e. P. /\ g e. P. ) -> ( f F g ) e. P. ) $.
      genpass.6 $e |- ( ( f G g ) G h ) = ( f G ( g G h ) ) $.
      $( Associativity of an operation on reals. $)
      genpass $p |- ( ( A F B ) F C ) = ( A F ( B F C ) ) $=
        cA cnp wcel cB cnp wcel cC cnp wcel w3a cA cB cF co cC cF co cA cB cC
        cF co cF co wceq cA cnp wcel cB cnp wcel cC cnp wcel w3a vx cA cB cF co
        cC cF co cA cB cC cF co cF co cA cnp wcel cB cnp wcel cC cnp wcel w3a
        vf cv cA wcel vt cv cB cC cF co wcel wa vx cv vf cv vt cv cG co wceq wa
        vt wex vf wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf
        cv vg cv vh cv cG co cG co wceq wa vh wex vg wex vf wex vx cv cA cB cC
        cF co cF co wcel vx cv cA cB cF co cC cF co wcel cA cnp wcel cB cnp
        wcel cC cnp wcel w3a vf cv cA wcel vt cv cB cC cF co wcel wa vx cv vf
        cv vt cv cG co wceq wa vt wex vf wex vg cv cB wcel vh cv cC wcel wa vt
        cv vg cv vh cv cG co wceq wa vf cv cA wcel vx cv vf cv vt cv cG co wceq
        wa wa vh wex vg wex vt wex vf wex vf cv cA wcel vg cv cB wcel vh cv cC
        wcel wa wa vx cv vf cv vg cv vh cv cG co cG co wceq wa vh wex vg wex vf
        wex cA cnp wcel cB cnp wcel cC cnp wcel w3a vf cv cA wcel vt cv cB cC
        cF co wcel wa vx cv vf cv vt cv cG co wceq wa vg cv cB wcel vh cv cC
        wcel wa vt cv vg cv vh cv cG co wceq wa vf cv cA wcel vx cv vf cv vt cv
        cG co wceq wa wa vh wex vg wex vf vt cA cnp wcel cB cnp wcel cC cnp
        wcel w3a vt cv cB cC cF co wcel vf cv cA wcel vx cv vf cv vt cv cG co
        wceq wa wa vg cv cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq
        wa vh wex vg wex vf cv cA wcel vx cv vf cv vt cv cG co wceq wa wa vf cv
        cA wcel vt cv cB cC cF co wcel wa vx cv vf cv vt cv cG co wceq wa vg cv
        cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vf cv cA wcel
        vx cv vf cv vt cv cG co wceq wa wa vh wex vg wex cA cnp wcel cB cnp
        wcel cC cnp wcel w3a vt cv cB cC cF co wcel vg cv cB wcel vh cv cC wcel
        wa vt cv vg cv vh cv cG co wceq wa vh wex vg wex vf cv cA wcel vx cv vf
        cv vt cv cG co wceq wa cB cnp wcel cC cnp wcel vt cv cB cC cF co wcel
        vg cv cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vh wex
        vg wex wb cA cnp wcel vx vy vz vw vv vu cB cC vt cv vg vh cF cG genp.1
        vt visset genpelv 3adant1 anbi1d vf cv cA wcel vt cv cB cC cF co wcel
        wa vx cv vf cv vt cv cG co wceq wa vf cv cA wcel vt cv cB cC cF co wcel
        vx cv vf cv vt cv cG co wceq wa wa vt cv cB cC cF co wcel vf cv cA wcel
        vx cv vf cv vt cv cG co wceq wa wa vf cv cA wcel vt cv cB cC cF co wcel
        vx cv vf cv vt cv cG co wceq anass vf cv cA wcel vt cv cB cC cF co wcel
        vx cv vf cv vt cv cG co wceq an12 bitri vg cv cB wcel vh cv cC wcel wa
        vt cv vg cv vh cv cG co wceq wa vf cv cA wcel vx cv vf cv vt cv cG co
        wceq wa vg vh 19.41vv 3bitr4g 2exbidv vg cv cB wcel vh cv cC wcel wa vt
        cv vg cv vh cv cG co wceq wa vf cv cA wcel vx cv vf cv vt cv cG co wceq
        wa wa vh wex vg wex vt wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa
        wa vx cv vf cv vg cv vh cv cG co cG co wceq wa vh wex vg wex vf vg cv
        cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vf cv cA wcel
        vx cv vf cv vt cv cG co wceq wa wa vh wex vg wex vt wex vg cv cB wcel
        vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vf cv cA wcel vx cv vf
        cv vt cv cG co wceq wa wa vt wex vh wex vg wex vf cv cA wcel vg cv cB
        wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG co wceq wa vh
        wex vg wex vg cv cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq
        wa vf cv cA wcel vx cv vf cv vt cv cG co wceq wa wa vt vg vh exrot3 vg
        cv cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vf cv cA
        wcel vx cv vf cv vt cv cG co wceq wa wa vt wex vf cv cA wcel vg cv cB
        wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG co wceq wa vg
        vh vg cv cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vf cv
        cA wcel vx cv vf cv vt cv cG co wceq wa wa vt wex vt cv vg cv vh cv cG
        co wceq vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg
        cv vh cv cG co cG co wceq wa wa vt wex vf cv cA wcel vg cv cB wcel vh
        cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG co wceq wa vg cv cB
        wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq wa vf cv cA wcel vx
        cv vf cv vt cv cG co wceq wa wa vt cv vg cv vh cv cG co wceq vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG
        co wceq wa wa vt vg cv cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co
        wceq wa vf cv cA wcel vx cv vf cv vt cv cG co wceq wa wa vg cv cB wcel
        vh cv cC wcel wa vf cv cA wcel wa vt cv vg cv vh cv cG co wceq vx cv vf
        cv vt cv cG co wceq wa wa vf cv cA wcel vg cv cB wcel vh cv cC wcel wa
        wa vt cv vg cv vh cv cG co wceq vx cv vf cv vg cv vh cv cG co cG co
        wceq wa wa vt cv vg cv vh cv cG co wceq vf cv cA wcel vg cv cB wcel vh
        cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG co wceq wa wa vg cv
        cB wcel vh cv cC wcel wa vt cv vg cv vh cv cG co wceq vf cv cA wcel vx
        cv vf cv vt cv cG co wceq an4 vg cv cB wcel vh cv cC wcel wa vf cv cA
        wcel wa vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vt cv vg cv vh
        cv cG co wceq vx cv vf cv vt cv cG co wceq wa vt cv vg cv vh cv cG co
        wceq vx cv vf cv vg cv vh cv cG co cG co wceq wa vg cv cB wcel vh cv cC
        wcel wa vf cv cA wcel ancom vt cv vg cv vh cv cG co wceq vx cv vf cv vt
        cv cG co wceq vx cv vf cv vg cv vh cv cG co cG co wceq vt cv vg cv vh
        cv cG co wceq vf cv vt cv cG co vf cv vg cv vh cv cG co cG co vx cv vt
        cv vg cv vh cv cG co vf cv cG opreq2 eqeq2d pm5.32i anbi12i vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vt cv vg cv vh cv cG co wceq vx
        cv vf cv vg cv vh cv cG co cG co wceq an12 3bitri exbii vt cv vg cv vh
        cv cG co wceq vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf
        cv vg cv vh cv cG co cG co wceq wa wa vt wex vt cv vg cv vh cv cG co
        wceq vt wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv
        vg cv vh cv cG co cG co wceq wa vt cv vg cv vh cv cG co wceq vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG
        co wceq wa vt 19.41v vt vg cv vh cv cG co vg cv vh cv cG oprex isseti
        mpbiran bitri 2exbii bitri exbii syl6bb cA cnp wcel cB cnp wcel cC cnp
        wcel vx cv cA cB cC cF co cF co wcel vf cv cA wcel vt cv cB cC cF co
        wcel wa vx cv vf cv vt cv cG co wceq wa vt wex vf wex wb cA cnp wcel cB
        cC cF co cnp wcel vx cv cA cB cC cF co cF co wcel vf cv cA wcel vt cv
        cB cC cF co wcel wa vx cv vf cv vt cv cG co wceq wa vt wex vf wex wb cB
        cnp wcel cC cnp wcel wa vx vy vz vw vv vu cA cB cC cF co vx cv vf vt cF
        cG genp.1 vx visset genpelv vf vg cB cC cnp cF genpass.5 caoprcl sylan2
        3impb cA cnp wcel cB cnp wcel cC cnp wcel w3a vx cv cA cB cF co cC cF
        co wcel vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq wa
        vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vg wex vf wex vh wex
        vt wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg
        cv vh cv cG co cG co wceq wa vh wex vg wex vf wex cA cnp wcel cB cnp
        wcel cC cnp wcel w3a vx cv cA cB cF co cC cF co wcel vt cv cA cB cF co
        wcel vh cv cC wcel wa vx cv vt cv vh cv cG co wceq wa vh wex vt wex vf
        cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq wa vh cv cC
        wcel vx cv vt cv vh cv cG co wceq wa wa vg wex vf wex vh wex vt wex cA
        cnp wcel cB cnp wcel cC cnp wcel vx cv cA cB cF co cC cF co wcel vt cv
        cA cB cF co wcel vh cv cC wcel wa vx cv vt cv vh cv cG co wceq wa vh
        wex vt wex wb cA cB cF co cnp wcel cC cnp wcel vx cv cA cB cF co cC cF
        co wcel vt cv cA cB cF co wcel vh cv cC wcel wa vx cv vt cv vh cv cG co
        wceq wa vh wex vt wex wb cA cnp wcel cB cnp wcel wa vx vy vz vw vv vu
        cA cB cF co cC vx cv vt vh cF cG genp.1 vx visset genpelv vf vg cA cB
        cnp cF genpass.5 caoprcl sylan 3impa cA cnp wcel cB cnp wcel cC cnp
        wcel w3a vt cv cA cB cF co wcel vh cv cC wcel wa vx cv vt cv vh cv cG
        co wceq wa vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq
        wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vg wex vf wex vt vh
        cA cnp wcel cB cnp wcel cC cnp wcel w3a vt cv cA cB cF co wcel vh cv cC
        wcel vx cv vt cv vh cv cG co wceq wa wa vf cv cA wcel vg cv cB wcel wa
        vt cv vf cv vg cv cG co wceq wa vg wex vf wex vh cv cC wcel vx cv vt cv
        vh cv cG co wceq wa wa vt cv cA cB cF co wcel vh cv cC wcel wa vx cv vt
        cv vh cv cG co wceq wa vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv
        cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vg wex
        vf wex cA cnp wcel cB cnp wcel cC cnp wcel w3a vt cv cA cB cF co wcel
        vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq wa vg wex
        vf wex vh cv cC wcel vx cv vt cv vh cv cG co wceq wa cA cnp wcel cB cnp
        wcel vt cv cA cB cF co wcel vf cv cA wcel vg cv cB wcel wa vt cv vf cv
        vg cv cG co wceq wa vg wex vf wex wb cC cnp wcel vx vy vz vw vv vu cA
        cB vt cv vf vg cF cG genp.1 vt visset genpelv 3adant3 anbi1d vt cv cA
        cB cF co wcel vh cv cC wcel vx cv vt cv vh cv cG co wceq anass vf cv cA
        wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq wa vh cv cC wcel vx
        cv vt cv vh cv cG co wceq wa vf vg 19.41vv 3bitr4g 2exbidv bitrd vf cv
        cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq wa vh cv cC wcel
        vx cv vt cv vh cv cG co wceq wa wa vg wex vf wex vh wex vt wex vf cv cA
        wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq wa vh cv cC wcel vx
        cv vt cv vh cv cG co wceq wa wa vh wex vt wex vg wex vf wex vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG
        co wceq wa vh wex vg wex vf wex vf cv cA wcel vg cv cB wcel wa vt cv vf
        cv vg cv cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa
        vt vh vf vg exrot4 vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG
        co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vh wex vt
        wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv
        vh cv cG co cG co wceq wa vh wex vf vg vf cv cA wcel vg cv cB wcel wa
        vt cv vf cv vg cv cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co
        wceq wa wa vh wex vt wex vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg
        cv cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vt
        wex vh wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv
        vg cv vh cv cG co cG co wceq wa vh wex vf cv cA wcel vg cv cB wcel wa
        vt cv vf cv vg cv cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co
        wceq wa wa vt vh excom vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv
        cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vt wex
        vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv
        cG co cG co wceq wa vh vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv
        cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vt wex
        vt cv vf cv vg cv cG co wceq vf cv cA wcel vg cv cB wcel vh cv cC wcel
        wa wa vx cv vf cv vg cv vh cv cG co cG co wceq wa wa vt wex vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG
        co wceq wa vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq
        wa vh cv cC wcel vx cv vt cv vh cv cG co wceq wa wa vt cv vf cv vg cv
        cG co wceq vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv
        vg cv vh cv cG co cG co wceq wa wa vt vf cv cA wcel vg cv cB wcel wa vt
        cv vf cv vg cv cG co wceq wa vh cv cC wcel vx cv vt cv vh cv cG co wceq
        wa wa vf cv cA wcel vg cv cB wcel wa vh cv cC wcel wa vt cv vf cv vg cv
        cG co wceq vx cv vt cv vh cv cG co wceq wa wa vf cv cA wcel vg cv cB
        wcel vh cv cC wcel wa wa vt cv vf cv vg cv cG co wceq vx cv vf cv vg cv
        vh cv cG co cG co wceq wa wa vt cv vf cv vg cv cG co wceq vf cv cA wcel
        vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG co
        wceq wa wa vf cv cA wcel vg cv cB wcel wa vt cv vf cv vg cv cG co wceq
        vh cv cC wcel vx cv vt cv vh cv cG co wceq an4 vf cv cA wcel vg cv cB
        wcel wa vh cv cC wcel wa vf cv cA wcel vg cv cB wcel vh cv cC wcel wa
        wa vt cv vf cv vg cv cG co wceq vx cv vt cv vh cv cG co wceq wa vt cv
        vf cv vg cv cG co wceq vx cv vf cv vg cv vh cv cG co cG co wceq wa vf
        cv cA wcel vg cv cB wcel vh cv cC wcel anass vt cv vf cv vg cv cG co
        wceq vx cv vt cv vh cv cG co wceq vx cv vf cv vg cv vh cv cG co cG co
        wceq vt cv vf cv vg cv cG co wceq vt cv vh cv cG co vf cv vg cv vh cv
        cG co cG co vx cv vt cv vf cv vg cv cG co wceq vt cv vh cv cG co vf cv
        vg cv cG co vh cv cG co vf cv vg cv vh cv cG co cG co vt cv vf cv vg cv
        cG co vh cv cG opreq1 genpass.6 syl6eq eqeq2d pm5.32i anbi12i vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vt cv vf cv vg cv cG co wceq vx
        cv vf cv vg cv vh cv cG co cG co wceq an12 3bitri exbii vt cv vf cv vg
        cv cG co wceq vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf
        cv vg cv vh cv cG co cG co wceq wa wa vt wex vt cv vf cv vg cv cG co
        wceq vt wex vf cv cA wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv
        vg cv vh cv cG co cG co wceq wa vt cv vf cv vg cv cG co wceq vf cv cA
        wcel vg cv cB wcel vh cv cC wcel wa wa vx cv vf cv vg cv vh cv cG co cG
        co wceq wa vt 19.41v vt vf cv vg cv cG co vf cv vg cv cG oprex isseti
        mpbiran bitri exbii bitri 2exbii bitri syl6bb 3bitr4rd eqrdv cA cB cC
        cnp cF genpass.2 genpass.4 genpass.3 0npr ndmoprass pm2.61i $.
        $( [18-Mar-1996] $)
    $}

  $}

  ${
    $d x y z f g h A $.  $d x y z f g h B $.  $d x y z w v u f g h $.
    $( Value of addition on positive reals. $)
    plpv $p |- ( ( A e. P. /\ B e. P. ) -> ( A +P. B ) =
             { x | E. y E. z ( ( y e. A /\ z e. B ) /\ x = ( y +Q z ) ) } ) $=
      vf vg vh vw vv vu cA cB vx vy vz cpp cplq vw vv vu vf vg vh df-plp genpv
      $.
      $( [28-Feb-1996] $)

    $( Value of multiplication on positive reals. $)
    mpv $p |- ( ( A e. P. /\ B e. P. ) -> ( A .P. B ) =
             { x | E. y E. z ( ( y e. A /\ z e. B ) /\ x = ( y .Q z ) ) } ) $=
      vf vg vh vw vv vu cA cB vx vy vz cmp cmq vw vv vu vf vg vh df-mp genpv $.
      $( [28-Feb-1996] $)

    $( Domain of addition on positive reals. $)
    dmplp $p |- dom +P. = ( P. X. P. ) $=
      vw vv vu vx vy vz cpp cplq vx vy vz vw vv vu df-plp genpdm $.
      $( [18-Nov-1995] $)

    $( Domain of multiplication on positive reals. $)
    dmmp $p |- dom .P. = ( P. X. P. ) $=
      vw vv vu vx vy vz cmp cmq vx vy vz vw vv vu df-mp genpdm $.
      $( [18-Nov-1995] $)

  $}

  ${
    $d x y $.
    $( The positive real number 'one'. $)
    1pr $p |- 1P e. P. $=
      c1p cnp wcel c0 c1p wpss c1p cnq wpss wa vy cv vx cv cltq wbr vy cv c1p
      wcel wi vy wal vx cv vy cv cltq wbr vy c1p wrex wa vx c1p wral vx vy c1p
      elnp c0 c1p wpss c1p cnq wpss c0 c1p wpss c1p c0 wne c1q c1q cplq co crq
      cfv c1p wcel c1p c0 wne c1q c1q cplq co crq cfv c1p wcel c1q c1q cplq co
      crq cfv c1q cltq wbr c1q c1q c1q cplq co cltq wbr c1q c1q cplq co crq cfv
      c1q cltq wbr 1lt2pq c1q c1q c1q cplq co cltq wbr c1q c1q cplq co crq cfv
      c1q crq cfv c1q cltq c1q c1q c1q cplq co c1q cnq 1q elisseti c1q c1q cplq
      oprex ltrpq c1q crq cfv c1q cmq co c1q c1q crq cfv cmq co c1q crq cfv c1q
      c1q crq cfv c1q c1q crq fvex c1q cnq 1q elisseti mulcompq c1q crq cfv cnq
      wcel c1q crq cfv c1q cmq co c1q crq cfv wceq c1q cnq wcel c1q crq cfv cnq
      wcel 1q c1q recclpq ax-mp c1q crq cfv mulidpq ax-mp c1q cnq wcel c1q c1q
      crq cfv cmq co c1q wceq 1q c1q recidpq ax-mp 3eqtr3i syl6breq ax-mp vx cv
      c1q cltq wbr c1q c1q cplq co crq cfv c1q cltq wbr vx c1q c1q cplq co crq
      cfv c1p c1q c1q cplq co crq fvex vx cv c1q c1q cplq co crq cfv c1q cltq
      breq1 vx df-1p elab2 mpbir c1p c1q c1q cplq co crq cfv ne0i ax-mp c1p
      0pss mpbir c1p cnq wpss c1p cnq wss c1p cnq wceq wn c1p cnq dfpss2 vx c1p
      cnq vx cv c1p wcel vx cv c1q cltq wbr vx cv cnq wcel vx cv c1q cltq wbr
      vx c1p vx df-1p abeq2i vx cv c1q cltq wbr vx cv cnq wcel c1q cnq wcel vx
      cv c1q cnq cnq cltq c1q cnq 1q elisseti ltrelpq brel pm3.26d sylbi ssriv
      c1p cnq wceq c1q c1p wcel c1q c1p wcel c1q c1q cltq wbr c1q cltq cnq c1q
      cnq 1q elisseti ltsopq ltrelpq soirri vx cv c1q cltq wbr c1q c1q cltq wbr
      vx c1q c1p c1q cnq 1q elisseti vx cv c1q c1q cltq breq1 vx df-1p elab2
      mtbir c1p cnq wceq c1q c1p wcel c1q cnq wcel 1q c1p cnq c1q eleq2 mpbiri
      mto mpbir2an pm3.2i vy cv vx cv cltq wbr vy cv c1p wcel wi vy wal vx cv
      vy cv cltq wbr vy c1p wrex wa vx c1p vx cv c1p wcel vy cv vx cv cltq wbr
      vy cv c1p wcel wi vy wal vx cv vy cv cltq wbr vy c1p wrex vx cv c1p wcel
      vy cv vx cv cltq wbr vy cv c1p wcel wi vy vy cv vx cv cltq wbr vx cv c1p
      wcel vy cv c1p wcel vy cv vx cv cltq wbr vx cv c1q cltq wbr vy cv c1q
      cltq wbr vx cv c1p wcel vy cv c1p wcel vy cv vx cv cltq wbr vx cv c1q
      cltq wbr vy cv c1q cltq wbr vy cv vx cv c1q cltq cnq vy visset ltsopq
      ltrelpq vx visset c1q cnq 1q elisseti sotri ex vx cv c1q cltq wbr vx c1p
      vx df-1p abeq2i vy cv c1q cltq wbr vy c1p vy df-1p abeq2i 3imtr4g com12
      19.21aiv vx cv c1p wcel vy cv c1p wcel vx cv vy cv cltq wbr wa vy wex vx
      cv vy cv cltq wbr vy c1p wrex vx cv c1q cltq wbr vx cv vy cv cltq wbr vy
      cv c1q cltq wbr wa vy wex vx cv c1p wcel vy cv c1p wcel vx cv vy cv cltq
      wbr wa vy wex vy vx cv c1q vx visset c1q cnq 1q elisseti ltbtwnpq vx cv
      c1q cltq wbr vx c1p vx df-1p abeq2i vy cv c1p wcel vx cv vy cv cltq wbr
      wa vx cv vy cv cltq wbr vy cv c1q cltq wbr wa vy vy cv c1p wcel vx cv vy
      cv cltq wbr wa vy cv c1q cltq wbr vx cv vy cv cltq wbr wa vx cv vy cv
      cltq wbr vy cv c1q cltq wbr wa vy cv c1p wcel vy cv c1q cltq wbr vx cv vy
      cv cltq wbr vy cv c1q cltq wbr vy c1p vy df-1p abeq2i anbi1i vy cv c1q
      cltq wbr vx cv vy cv cltq wbr ancom bitri exbii 3imtr4i vx cv vy cv cltq
      wbr vy c1p df-rex sylibr jca rgen mpbir2an $.
      $( [13-Mar-1996] $)
  $}

  ${
    $d x y z w $.  $d y z w g $.  $d y z w h $.
    $( Lemma to prove downward closure in positive real addition.  Part of
       proof of Proposition 9-3.5 of [Gleason] p. 123. $)
    addclprlem1 $p |- ( ( ( A e. P. /\ g e. A ) /\ x e. Q. ) ->
   ( x <Q ( g +Q h ) -> ( ( x .Q ( *Q ` ( g +Q h ) ) ) .Q g ) e. A ) ) $=
      cA cnp wcel vg cv cA wcel wa vx cv cnq wcel wa vx cv vg cv vh cv cplq co
      cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co vg cv cmq co vg cv cltq
      wbr vx cv vg cv vh cv cplq co crq cfv cmq co vg cv cmq co cA wcel vg cv
      cnq wcel vx cv cnq wcel vx cv vg cv vh cv cplq co cltq wbr vx cv vg cv vh
      cv cplq co crq cfv cmq co vg cv cmq co vg cv cltq wbr wi cA cnp wcel vg
      cv cA wcel wa vg cv cnq wcel vx cv cnq wcel wa vx cv vg cv vh cv cplq co
      cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co vg cv cmq co vx cv vx
      cv crq cfv cmq co vg cv cmq co cltq wbr vx cv vg cv vh cv cplq co crq cfv
      cmq co vg cv cmq co vg cv cltq wbr vg cv cnq wcel vx cv cnq wcel wa vg cv
      vh cv cplq co crq cfv vx cv crq cfv cltq wbr vx cv vg cv vh cv cplq co
      crq cfv cmq co vg cv cmq co vx cv vx cv crq cfv cmq co vg cv cmq co cltq
      wbr vx cv vg cv vh cv cplq co cltq wbr vx cv cnq wcel vg cv vh cv cplq co
      crq cfv vx cv crq cfv cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co
      vx cv vx cv crq cfv cmq co cltq wbr vg cv cnq wcel vx cv vg cv vh cv cplq
      co crq cfv cmq co vg cv cmq co vx cv vx cv crq cfv cmq co vg cv cmq co
      cltq wbr vg cv vh cv cplq co crq cfv vx cv crq cfv vx cv vg cv vh cv cplq
      co crq fvex vx cv crq fvex ltmpq vy vz vw vx cv vg cv vh cv cplq co crq
      cfv cmq co vx cv vx cv crq cfv cmq co vg cv cltq cnq cmq vx cv vg cv vh
      cv cplq co crq cfv cmq oprex vx cv vx cv crq cfv cmq oprex vy cv vz cv vw
      cv vy visset vz visset ltmpq vg visset vy cv vz cv vy visset vz visset
      mulcompq caoprord2 sylan9bbr vx cv vg cv vh cv cplq co vx visset vg cv vh
      cv cplq oprex ltrpq syl5bi vg cv cnq wcel vx cv cnq wcel wa vx cv vx cv
      crq cfv cmq co vg cv cmq co vg cv vx cv vg cv vh cv cplq co crq cfv cmq
      co vg cv cmq co cltq vx cv cnq wcel vg cv cnq wcel vx cv vx cv crq cfv
      cmq co vg cv cmq co c1q vg cv cmq co vg cv vx cv cnq wcel vx cv vx cv crq
      cfv cmq co c1q vg cv cmq vx cv recidpq opreq1d vg cv cnq wcel vg cv c1q
      cmq co vg cv c1q vg cv cmq co vg cv mulidpq c1q vg cv c1q cnq 1q elisseti
      vg visset mulcompq syl5eq sylan9eqr breq2d sylibd cA vg cv elprpq sylan
      cA cnp wcel vg cv cA wcel wa vx cv vg cv vh cv cplq co crq cfv cmq co vg
      cv cmq co vg cv cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co vg cv
      cmq co cA wcel wi vx cv cnq wcel cA vg cv vx cv vg cv vh cv cplq co crq
      cfv cmq co vg cv cmq co prcdpq adantr syld $.
      $( [13-Mar-1996] $)
  $}

  ${
    $d x y z w v u g h $.
    $d x y z A $.  $d x y z B $.
    $( Lemma to prove downward closure in positive real addition.  Part of
       proof of Proposition 9-3.5 of [Gleason] p. 123. $)
    addclprlem2 $p |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g +Q h ) -> x e. ( A +P. B ) ) ) $=
      cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq
      wcel wa vx cv vg cv vh cv cplq co cltq wbr vx cv vg cv vh cv cplq co crq
      cfv cmq co vg cv cmq co vx cv vg cv vh cv cplq co crq cfv cmq co vh cv
      cmq co cplq co cA cB cpp co wcel vx cv cA cB cpp co wcel cA cnp wcel vg
      cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq wcel wa vx cv vg
      cv vh cv cplq co cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co vg cv
      cmq co cA wcel vx cv vg cv vh cv cplq co crq cfv cmq co vh cv cmq co cB
      wcel wa vx cv vg cv vh cv cplq co crq cfv cmq co vg cv cmq co vx cv vg cv
      vh cv cplq co crq cfv cmq co vh cv cmq co cplq co cA cB cpp co wcel cA
      cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq wcel
      wa vx cv vg cv vh cv cplq co cltq wbr vx cv vg cv vh cv cplq co crq cfv
      cmq co vg cv cmq co cA wcel vx cv vg cv vh cv cplq co crq cfv cmq co vh
      cv cmq co cB wcel cA cnp wcel vg cv cA wcel wa vx cv cnq wcel vx cv vg cv
      vh cv cplq co cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co vg cv cmq
      co cA wcel wi cB cnp wcel vh cv cB wcel wa vx cA vg vh addclprlem1
      adantlr cB cnp wcel vh cv cB wcel wa vx cv cnq wcel vx cv vg cv vh cv
      cplq co cltq wbr vx cv vg cv vh cv cplq co crq cfv cmq co vh cv cmq co cB
      wcel wi cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa vx cv
      cnq wcel wa vx cv vh cv vg cv cplq co cltq wbr vx cv vh cv vg cv cplq co
      crq cfv cmq co vh cv cmq co cB wcel vx cv vg cv vh cv cplq co cltq wbr vx
      cv vg cv vh cv cplq co crq cfv cmq co vh cv cmq co cB wcel vx cB vh vg
      addclprlem1 vg cv vh cv cplq co vh cv vg cv cplq co vx cv cltq vg cv vh
      cv vg visset vh visset addcompq breq2i vx cv vg cv vh cv cplq co crq cfv
      cmq co vh cv cmq co vx cv vh cv vg cv cplq co crq cfv cmq co vh cv cmq co
      cB vx cv vg cv vh cv cplq co crq cfv cmq co vx cv vh cv vg cv cplq co crq
      cfv cmq co vh cv cmq vg cv vh cv cplq co crq cfv vh cv vg cv cplq co crq
      cfv vx cv cmq vg cv vh cv cplq co vh cv vg cv cplq co crq vg cv vh cv vg
      visset vh visset addcompq fveq2i opreq2i opreq1i eleq1i 3imtr4g adantll
      jcad cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv
      cnq wcel wa cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa
      cA cnp wcel cB cnp wcel wa vx cv vg cv vh cv cplq co crq cfv cmq co vg cv
      cmq co cA wcel vx cv vg cv vh cv cplq co crq cfv cmq co vh cv cmq co cB
      wcel wa vx cv vg cv vh cv cplq co crq cfv cmq co vg cv cmq co vx cv vg cv
      vh cv cplq co crq cfv cmq co vh cv cmq co cplq co cA cB cpp co wcel wi cA
      cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq wcel
      pm3.26 cA cnp wcel vg cv cA wcel wa cA cnp wcel cB cnp wcel vh cv cB wcel
      wa cB cnp wcel cA cnp wcel vg cv cA wcel pm3.26 cB cnp wcel vh cv cB wcel
      pm3.26 anim12i vx vy vz vw vv vu cA cB vx cv vg cv vh cv cplq co crq cfv
      cmq co vg cv cmq co vx cv vg cv vh cv cplq co crq cfv cmq co vh cv cmq co
      cpp cplq vw vv vu vx vy vz df-plp genpprecl 3syl syld cA cnp wcel vg cv
      cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq wcel wa vx cv vg cv
      vh cv cplq co crq cfv cmq co vg cv cmq co vx cv vg cv vh cv cplq co crq
      cfv cmq co vh cv cmq co cplq co vx cv cA cB cpp co cA cnp wcel vg cv cA
      wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq wcel wa vx cv vg cv vh
      cv cplq co crq cfv vg cv vh cv cplq co cmq co cmq co vx cv vx cv vg cv vh
      cv cplq co crq cfv cmq co vg cv cmq co vx cv vg cv vh cv cplq co crq cfv
      cmq co vh cv cmq co cplq co cA cnp wcel vg cv cA wcel wa cB cnp wcel vh
      cv cB wcel wa wa vx cv cnq wcel vx cv vg cv vh cv cplq co crq cfv vg cv
      vh cv cplq co cmq co cmq co vx cv c1q cmq co vx cv cA cnp wcel vg cv cA
      wcel wa cB cnp wcel vh cv cB wcel wa wa vg cv vh cv cplq co crq cfv vg cv
      vh cv cplq co cmq co c1q vx cv cmq cA cnp wcel vg cv cA wcel wa cB cnp
      wcel vh cv cB wcel wa wa vg cv vh cv cplq co vg cv vh cv cplq co crq cfv
      cmq co c1q vg cv vh cv cplq co crq cfv vg cv vh cv cplq co cmq co cA cnp
      wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vg cv cnq wcel vh
      cv cnq wcel wa vg cv vh cv cplq co cnq wcel vg cv vh cv cplq co vg cv vh
      cv cplq co crq cfv cmq co c1q wceq cA cnp wcel vg cv cA wcel wa vg cv cnq
      wcel cB cnp wcel vh cv cB wcel wa vh cv cnq wcel cA vg cv elprpq cB vh cv
      elprpq anim12i vg cv vh cv addclpq vg cv vh cv cplq co recidpq 3syl vg cv
      vh cv cplq co crq cfv vg cv vh cv cplq co vg cv vh cv cplq co crq fvex vg
      cv vh cv cplq oprex mulcompq syl5eq opreq2d vx cv mulidpq sylan9eq vx cv
      vg cv vh cv cplq co crq cfv cmq co vg cv vh cv cplq co cmq co vx cv vg cv
      vh cv cplq co crq cfv cmq co vg cv cmq co vx cv vg cv vh cv cplq co crq
      cfv cmq co vh cv cmq co cplq co vx cv vg cv vh cv cplq co crq cfv vg cv
      vh cv cplq co cmq co cmq co vx cv vg cv vh cv cplq co crq cfv cmq co vg
      cv vh cv vg visset vh visset distrpq vx cv vg cv vh cv cplq co crq cfv vg
      cv vh cv cplq co vg cv vh cv cplq co crq fvex vg cv vh cv cplq oprex
      mulasspq eqtr3i syl5eq eleq1d sylibd $.
      $( [13-Mar-1996] $)
  $}

  ${
    $d x y z w v u f g h $.
    $d x y z w v f g h A $.  $d x y z w v f g h B $.
    $( Closure of addition on positive reals.  First statement of
       Proposition 9-3.5 of [Gleason] p. 123. $)
    addclpr $p |- ( ( A e. P. /\ B e. P. ) -> ( A +P. B ) e. P. ) $=
      vx vy vz vw vv vu cA cB vf vg vh cpp cplq vw vv vu vx vy vz df-plp vx cv
      vy cv addclpq vf cv vg cv vh cv vf visset vg visset ltapq vx cv vy cv vx
      visset vy visset addcompq vx cA cB vg vh addclprlem2 genpcl $.
      $( [13-Mar-1996] $)
  $}

  ${
    $d x y z w v u g h $.
    $d x y z A $.  $d x y z B $.
    $( Lemma to prove downward closure in positive real multiplication.  Part
       of proof of Proposition 9-3.7 of [Gleason] p. 124. $)
    mulclprlem $p |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g .Q h ) -> x e. ( A .P. B ) ) ) $=
      cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv cnq
      wcel wa vx cv vg cv vh cv cmq co cltq wbr vx cv vh cv crq cfv cmq co vh
      cv cmq co cA cB cmp co wcel vx cv cA cB cmp co wcel cA cnp wcel vg cv cA
      wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv vg cv vh cv cmq co cltq wbr
      vx cv vh cv crq cfv cmq co vh cv cmq co cA cB cmp co wcel wi vx cv cnq
      wcel cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv
      vg cv vh cv cmq co cltq wbr vx cv vh cv crq cfv cmq co cA wcel vx cv vh
      cv crq cfv cmq co vh cv cmq co cA cB cmp co wcel cA cnp wcel vg cv cA
      wcel wa cB cnp wcel vh cv cB wcel wa wa vx cv vg cv vh cv cmq co cltq wbr
      vx cv vh cv crq cfv cmq co vg cv cltq wbr vx cv vh cv crq cfv cmq co cA
      wcel vg cv cnq wcel vh cv cnq wcel vx cv vg cv vh cv cmq co cltq wbr vx
      cv vh cv crq cfv cmq co vg cv cltq wbr wb cA cnp wcel vg cv cA wcel wa cB
      cnp wcel vh cv cB wcel wa vg cv cnq wcel vh cv cnq wcel wa vx cv vg cv vh
      cv cmq co cltq wbr vx cv vh cv crq cfv cmq co vg cv vh cv cmq co vh cv
      crq cfv cmq co cltq wbr vx cv vh cv crq cfv cmq co vg cv cltq wbr vg cv
      cnq wcel vh cv cnq wcel wa vh cv crq cfv cnq wcel vx cv vg cv vh cv cmq
      co cltq wbr vx cv vh cv crq cfv cmq co vg cv vh cv cmq co vh cv crq cfv
      cmq co cltq wbr wb vh cv cnq wcel vh cv crq cfv cnq wcel vg cv cnq wcel
      vh cv recclpq adantl vy vz vw vx cv vg cv vh cv cmq co vh cv crq cfv cltq
      cnq cmq vx visset vg cv vh cv cmq oprex vy cv vz cv vw cv vy visset vz
      visset ltmpq vh cv crq fvex vy cv vz cv vy visset vz visset mulcompq
      caoprord2 syl vg cv cnq wcel vh cv cnq wcel wa vg cv vh cv cmq co vh cv
      crq cfv cmq co vg cv vx cv vh cv crq cfv cmq co cltq vh cv cnq wcel vg cv
      cnq wcel vg cv vh cv cmq co vh cv crq cfv cmq co vg cv c1q cmq co vg cv
      vh cv cnq wcel vg cv vh cv vh cv crq cfv cmq co cmq co vg cv c1q cmq co
      vg cv vh cv cmq co vh cv crq cfv cmq co vh cv cnq wcel vh cv vh cv crq
      cfv cmq co c1q vg cv cmq vh cv recidpq opreq2d vg cv vh cv vh cv crq cfv
      vh visset vh cv crq fvex mulasspq syl5eq vg cv mulidpq sylan9eqr breq2d
      bitrd cA vg cv elprpq cB vh cv elprpq syl2an cA cnp wcel vg cv cA wcel wa
      vx cv vh cv crq cfv cmq co vg cv cltq wbr vx cv vh cv crq cfv cmq co cA
      wcel wi cB cnp wcel vh cv cB wcel wa cA vg cv vx cv vh cv crq cfv cmq co
      prcdpq adantr sylbid cA cnp wcel cB cnp wcel vh cv cB wcel wa vx cv vh cv
      crq cfv cmq co cA wcel vx cv vh cv crq cfv cmq co vh cv cmq co cA cB cmp
      co wcel wi vg cv cA wcel cA cnp wcel cB cnp wcel vh cv cB wcel vx cv vh
      cv crq cfv cmq co cA wcel vx cv vh cv crq cfv cmq co vh cv cmq co cA cB
      cmp co wcel wi cA cnp wcel cB cnp wcel vx cv vh cv crq cfv cmq co cA wcel
      vh cv cB wcel vx cv vh cv crq cfv cmq co vh cv cmq co cA cB cmp co wcel
      cA cnp wcel cB cnp wcel vx cv vh cv crq cfv cmq co cA wcel vh cv cB wcel
      vx cv vh cv crq cfv cmq co vh cv cmq co cA cB cmp co wcel vx vy vz vw vv
      vu cA cB vx cv vh cv crq cfv cmq co vh cv cmp cmq vw vv vu vx vy vz df-mp
      genpprecl exp4b com34 imp32 adantlr syld adantr vh cv cnq wcel vx cv cnq
      wcel vx cv vh cv crq cfv cmq co vh cv cmq co cA cB cmp co wcel vx cv cA
      cB cmp co wcel wb cA cnp wcel vg cv cA wcel wa cB cnp wcel vh cv cB wcel
      wa wa vh cv cnq wcel vx cv cnq wcel wa vx cv vh cv crq cfv cmq co vh cv
      cmq co vx cv cA cB cmp co vh cv cnq wcel vx cv cnq wcel vx cv vh cv crq
      cfv cmq co vh cv cmq co vx cv c1q cmq co vx cv vh cv cnq wcel vx cv vh cv
      crq cfv vh cv cmq co cmq co vx cv c1q cmq co vx cv vh cv crq cfv cmq co
      vh cv cmq co vh cv cnq wcel vh cv crq cfv vh cv cmq co c1q vx cv cmq vh
      cv cnq wcel vh cv vh cv crq cfv cmq co c1q vh cv crq cfv vh cv cmq co vh
      cv recidpq vh cv crq cfv vh cv vh cv crq fvex vh visset mulcompq syl5eq
      opreq2d vx cv vh cv crq cfv vh cv vh cv crq fvex vh visset mulasspq
      syl5eq vx cv mulidpq sylan9eq eleq1d cB cnp wcel vh cv cB wcel wa vh cv
      cnq wcel cA cnp wcel vg cv cA wcel wa cB vh cv elprpq adantl sylan sylibd
      $.
      $( [14-Mar-1996] $)
  $}

  ${
    $d x y z w v u f g h $.
    $d x y z w v f g h A $.  $d x y z w v f g h B $.
    $d x y z w A $.  $d x y z w B $.
    $( Closure of multiplication on positive reals.  First statement of
       Proposition 9-3.7 of [Gleason] p. 124. $)
    mulclpr $p |- ( ( A e. P. /\ B e. P. ) -> ( A .P. B ) e. P. ) $=
      vx vy vz vw vv vu cA cB vf vg vh cmp cmq vw vv vu vx vy vz df-mp vx cv vy
      cv mulclpq vf cv vg cv vh cv vf visset vg visset ltmpq vx cv vy cv vx
      visset vy visset mulcompq vx cA cB vg vh mulclprlem genpcl $.
      $( [13-Mar-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    addcompr.1 $e |- A e. _V $.
    addcompr.2 $e |- B e. _V $.
    $( Addition of positive reals is commutative.  Proposition 9-3.5(ii) of
       [Gleason] p. 123. $)
    addcompr $p |- ( A +P. B ) = ( B +P. A ) $=
      cA cnp wcel cB cnp wcel wa cA cB cpp co cB cA cpp co wceq cA cnp wcel cB
      cnp wcel wa cA cB cpp co vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv
      cplq co wceq wa vz wex vy wex vx cab cB cA cpp co vx vy vz cA cB plpv cB
      cnp wcel cA cnp wcel cB cA cpp co vy cv cA wcel vz cv cB wcel wa vx cv vy
      cv vz cv cplq co wceq wa vz wex vy wex vx cab wceq cB cnp wcel cA cnp
      wcel wa cB cA cpp co vz cv cB wcel vy cv cA wcel wa vx cv vz cv vy cv
      cplq co wceq wa vy wex vz wex vx cab vy cv cA wcel vz cv cB wcel wa vx cv
      vy cv vz cv cplq co wceq wa vz wex vy wex vx cab vx vz vy cB cA plpv vz
      cv cB wcel vy cv cA wcel wa vx cv vz cv vy cv cplq co wceq wa vy wex vz
      wex vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cplq co wceq wa vz
      wex vy wex vx vz cv cB wcel vy cv cA wcel wa vx cv vz cv vy cv cplq co
      wceq wa vy wex vz wex vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv
      cplq co wceq wa vy wex vz wex vy cv cA wcel vz cv cB wcel wa vx cv vy cv
      vz cv cplq co wceq wa vz wex vy wex vz cv cB wcel vy cv cA wcel wa vx cv
      vz cv vy cv cplq co wceq wa vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz
      cv cplq co wceq wa vz vy vz cv cB wcel vy cv cA wcel wa vy cv cA wcel vz
      cv cB wcel wa vx cv vz cv vy cv cplq co wceq vx cv vy cv vz cv cplq co
      wceq vz cv cB wcel vy cv cA wcel ancom vz cv vy cv cplq co vy cv vz cv
      cplq co vx cv vz cv vy cv vz visset vy visset addcompq eqeq2i anbi12i
      2exbii vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cplq co wceq wa
      vz vy excom bitri abbii syl6eq ancoms eqtr4d cA cB cnp cpp addcompr.2
      dmplp addcompr.1 ndmoprcom pm2.61i $.
      $( [19-Nov-1995] $)
  $}

  ${
    $d x y z w v u f g h A $.  $d x y z w v u f g h B $.
    $d x y z w v u f g h C $.
    addasspr.1 $e |- B e. _V $.
    addasspr.2 $e |- C e. _V $.
    $( Addition of positive reals is associative.  Proposition 9-3.5(i) of
       [Gleason] p. 123. $)
    addasspr $p |- ( ( A +P. B ) +P. C ) = ( A +P. ( B +P. C ) ) $=
      vx vy vz vw vv vu cA cB cC vf vg vh cpp cplq vw vv vu vx vy vz df-plp
      addasspr.1 addasspr.2 dmplp vf cv vg cv addclpr vf cv vg cv vh cv vg
      visset vh visset addasspq genpass $.
      $( [18-Mar-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    mulcompr.1 $e |- A e. _V $.
    mulcompr.2 $e |- B e. _V $.
    $( Multiplication of positive reals is commutative.  Proposition
       9-3.7(ii) of [Gleason] p. 124. $)
    mulcompr $p |- ( A .P. B ) = ( B .P. A ) $=
      cA cnp wcel cB cnp wcel wa cA cB cmp co cB cA cmp co wceq cA cnp wcel cB
      cnp wcel wa cA cB cmp co vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv
      cmq co wceq wa vz wex vy wex vx cab cB cA cmp co vx vy vz cA cB mpv cB
      cnp wcel cA cnp wcel cB cA cmp co vy cv cA wcel vz cv cB wcel wa vx cv vy
      cv vz cv cmq co wceq wa vz wex vy wex vx cab wceq cB cnp wcel cA cnp wcel
      wa cB cA cmp co vz cv cB wcel vy cv cA wcel wa vx cv vz cv vy cv cmq co
      wceq wa vy wex vz wex vx cab vy cv cA wcel vz cv cB wcel wa vx cv vy cv
      vz cv cmq co wceq wa vz wex vy wex vx cab vx vz vy cB cA mpv vz cv cB
      wcel vy cv cA wcel wa vx cv vz cv vy cv cmq co wceq wa vy wex vz wex vy
      cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cmq co wceq wa vz wex vy
      wex vx vz cv cB wcel vy cv cA wcel wa vx cv vz cv vy cv cmq co wceq wa vy
      wex vz wex vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cmq co wceq
      wa vy wex vz wex vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cmq co
      wceq wa vz wex vy wex vz cv cB wcel vy cv cA wcel wa vx cv vz cv vy cv
      cmq co wceq wa vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cmq co
      wceq wa vz vy vz cv cB wcel vy cv cA wcel wa vy cv cA wcel vz cv cB wcel
      wa vx cv vz cv vy cv cmq co wceq vx cv vy cv vz cv cmq co wceq vz cv cB
      wcel vy cv cA wcel ancom vz cv vy cv cmq co vy cv vz cv cmq co vx cv vz
      cv vy cv vz visset vy visset mulcompq eqeq2i anbi12i 2exbii vy cv cA wcel
      vz cv cB wcel wa vx cv vy cv vz cv cmq co wceq wa vz vy excom bitri abbii
      syl6eq ancoms eqtr4d cA cB cnp cmp mulcompr.2 dmmp mulcompr.1 ndmoprcom
      pm2.61i $.
      $( [19-Nov-1995] $)
  $}

  ${
    $d x y z w v u f g h A $.  $d x y z w v u f g h B $.
    $d x y z w v u f g h C $.
    mulasspr.1 $e |- B e. _V $.
    mulasspr.2 $e |- C e. _V $.
    $( Multiplication of positive reals is associative.  Proposition 9-3.7(i)
       of [Gleason] p. 124. $)
    mulasspr $p |- ( ( A .P. B ) .P. C ) = ( A .P. ( B .P. C ) ) $=
      vx vy vz vw vv vu cA cB cC vf vg vh cmp cmq vw vv vu vx vy vz df-mp
      mulasspr.1 mulasspr.2 dmmp vf cv vg cv mulclpr vf cv vg cv vh cv vg
      visset vh visset mulasspq genpass $.
      $( [18-Mar-1996] $)
  $}

  ${
    $d x y z w v u f g h A $.  $d x y z w v u f g h B $.
    $d x y z w v u f g h C $.
    $( Lemma for distributive law for positive reals. $)
    distrlem1pr $p |- ( ( A e. P. /\ ( B e. P. /\ C e. P. ) ) ->
       ( A .P. ( B +P. C ) ) C_ ( ( A .P. B ) +P. ( A .P. C ) ) ) $=
      cA cnp wcel cB cnp wcel cC cnp wcel wa wa vw cA cB cC cpp co cmp co cA cB
      cmp co cA cC cmp co cpp co cA cnp wcel cB cnp wcel cC cnp wcel wa wa vw
      cv cA cB cC cpp co cmp co wcel vx cv cA wcel vy cv cB wcel vz cv cC wcel
      wa wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa vx wex vz wex vy wex
      vw cv cA cB cmp co cA cC cmp co cpp co wcel cA cnp wcel cB cnp wcel cC
      cnp wcel wa wa vw cv cA cB cC cpp co cmp co wcel vx cv cA wcel vy cv cB
      wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv
      cmq co wceq wa wa vz wex vy wex vv wex vx wex vx cv cA wcel vy cv cB wcel
      vz cv cC wcel wa wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa vx wex
      vz wex vy wex cA cnp wcel cB cnp wcel cC cnp wcel wa wa vw cv cA cB cC
      cpp co cmp co wcel vx cv cA wcel vv cv cB cC cpp co wcel wa vw cv vx cv
      vv cv cmq co wceq wa vv wex vx wex vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq
      wa wa vz wex vy wex vv wex vx wex cA cnp wcel cB cC cpp co cnp wcel vw cv
      cA cB cC cpp co cmp co wcel vx cv cA wcel vv cv cB cC cpp co wcel wa vw
      cv vx cv vv cv cmq co wceq wa vv wex vx wex wb cB cnp wcel cC cnp wcel wa
      vf vg vh vy vz vu cA cB cC cpp co vw cv vx vv cmp cmq vy vz vu vf vg vh
      df-mp vw visset genpelv cB cC addclpr sylan2 cA cnp wcel cB cnp wcel cC
      cnp wcel wa wa vx cv cA wcel vv cv cB cC cpp co wcel wa vw cv vx cv vv cv
      cmq co wceq wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vv cv vy cv
      vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq wa wa vz wex vy wex
      vx vv cB cnp wcel cC cnp wcel wa vx cv cA wcel vv cv cB cC cpp co wcel wa
      vw cv vx cv vv cv cmq co wceq wa vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq
      wa wa vz wex vy wex wb cA cnp wcel cB cnp wcel cC cnp wcel wa vx cv cA
      wcel vv cv cB cC cpp co wcel vw cv vx cv vv cv cmq co wceq wa wa vx cv cA
      wcel vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vz
      wex vy wex vw cv vx cv vv cv cmq co wceq wa wa vx cv cA wcel vv cv cB cC
      cpp co wcel wa vw cv vx cv vv cv cmq co wceq wa vx cv cA wcel vy cv cB
      wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv
      cmq co wceq wa wa vz wex vy wex cB cnp wcel cC cnp wcel wa vv cv cB cC
      cpp co wcel vw cv vx cv vv cv cmq co wceq wa vy cv cB wcel vz cv cC wcel
      wa vv cv vy cv vz cv cplq co wceq wa vz wex vy wex vw cv vx cv vv cv cmq
      co wceq wa vx cv cA wcel cB cnp wcel cC cnp wcel wa vv cv cB cC cpp co
      wcel vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vz
      wex vy wex vw cv vx cv vv cv cmq co wceq vf vg vh vx vw vu cB cC vv cv vy
      vz cpp cplq vx vw vu vf vg vh df-plp vv visset genpelv anbi1d anbi2d vx
      cv cA wcel vv cv cB cC cpp co wcel vw cv vx cv vv cv cmq co wceq anass vx
      cv cA wcel vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq
      wa vw cv vx cv vv cv cmq co wceq wa wa vz wex vy wex vx cv cA wcel vy cv
      cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv
      cv cmq co wceq wa vz wex vy wex wa vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa vv cv vy cv vz cv cplq co wceq wa vz wex vy wex vw cv vx cv vv cv
      cmq co wceq wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vv cv vy
      cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq wa vy vz 19.42vv
      vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx
      cv vv cv cmq co wceq wa vz wex vy wex vy cv cB wcel vz cv cC wcel wa vv
      cv vy cv vz cv cplq co wceq wa vz wex vy wex vw cv vx cv vv cv cmq co
      wceq wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv
      cplq co wceq wa vw cv vx cv vv cv cmq co wceq vy vz 19.41vv anbi2i bitri
      3bitr4g adantl 2exbidv bitrd vx cv cA wcel vy cv cB wcel vz cv cC wcel wa
      vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq wa wa vz
      wex vy wex vv wex vx wex vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vv
      cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq wa wa vv wex
      vx wex vz wex vy wex vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa vw
      cv vx cv vy cv vz cv cplq co cmq co wceq wa vx wex vz wex vy wex vx cv cA
      wcel vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw
      cv vx cv vv cv cmq co wceq wa wa vx vv vy vz exrot4 vx cv cA wcel vy cv
      cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv
      cv cmq co wceq wa wa vv wex vx cv cA wcel vy cv cB wcel vz cv cC wcel wa
      wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa vy vz vx vx cv cA wcel
      vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx
      cv vv cv cmq co wceq wa vv wex wa vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa wa vx cv cA wcel
      vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx
      cv vv cv cmq co wceq wa wa vv wex vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa vy cv cB wcel
      vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq
      co wceq wa vv wex vy cv cB wcel vz cv cC wcel wa vw cv vx cv vy cv vz cv
      cplq co cmq co wceq wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vv cv
      vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq wa vv wex vy cv
      cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq vw cv vx cv vv cv
      cmq co wceq wa wa vv wex vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv
      cplq co wceq vw cv vx cv vv cv cmq co wceq wa vv wex wa vy cv cB wcel vz
      cv cC wcel wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa vy cv cB
      wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv
      cmq co wceq wa vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co
      wceq vw cv vx cv vv cv cmq co wceq wa wa vv vy cv cB wcel vz cv cC wcel
      wa vv cv vy cv vz cv cplq co wceq vw cv vx cv vv cv cmq co wceq anass
      exbii vy cv cB wcel vz cv cC wcel wa vv cv vy cv vz cv cplq co wceq vw cv
      vx cv vv cv cmq co wceq wa vv 19.42v vv cv vy cv vz cv cplq co wceq vw cv
      vx cv vv cv cmq co wceq wa vv wex vw cv vx cv vy cv vz cv cplq co cmq co
      wceq vy cv cB wcel vz cv cC wcel wa vw cv vx cv vv cv cmq co wceq vw cv
      vx cv vy cv vz cv cplq co cmq co wceq vv vy cv vz cv cplq co vy cv vz cv
      cplq oprex vv cv vy cv vz cv cplq co wceq vx cv vv cv cmq co vx cv vy cv
      vz cv cplq co cmq co vw cv vv cv vy cv vz cv cplq co vx cv cmq opreq2
      eqeq2d ceqsexv anbi2i 3bitri anbi2i vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa vv cv vy cv vz cv cplq co wceq wa vw cv vx cv vv cv cmq co wceq
      wa vv 19.42v vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vw cv vx cv vy
      cv vz cv cplq co cmq co wceq anass 3bitr4i 3exbii bitri syl6bb cA cnp
      wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa wa vw cv vx cv vy cv vz cv cplq co cmq co wceq wa vx wex vz wex
      vw cv cA cB cmp co cA cC cmp co cpp co wcel vy cA cnp wcel cB cnp wcel cC
      cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa vw cv vx
      cv vy cv vz cv cplq co cmq co wceq wa vw cv cA cB cmp co cA cC cmp co cpp
      co wcel vz vx cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vy
      cv cB wcel vz cv cC wcel wa wa vw cv vx cv vy cv vz cv cplq co cmq co
      wceq vw cv cA cB cmp co cA cC cmp co cpp co wcel cA cnp wcel cB cnp wcel
      cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa vx cv
      vy cv vz cv cplq co cmq co cA cB cmp co cA cC cmp co cpp co wcel vw cv vx
      cv vy cv vz cv cplq co cmq co wceq vw cv cA cB cmp co cA cC cmp co cpp co
      wcel wi cA cnp wcel cB cnp wcel cC cnp wcel vx cv cA wcel vy cv cB wcel
      vz cv cC wcel wa wa vx cv vy cv vz cv cplq co cmq co cA cB cmp co cA cC
      cmp co cpp co wcel wi cA cnp wcel cB cnp wcel wa cA cnp wcel cC cnp wcel
      wa wa vx cv cA wcel vy cv cB wcel wa vx cv cA wcel vz cv cC wcel wa wa vx
      cv vy cv cmq co vx cv vz cv cmq co cplq co cA cB cmp co cA cC cmp co cpp
      co wcel vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa vx cv vy cv vz cv
      cplq co cmq co cA cB cmp co cA cC cmp co cpp co wcel cA cnp wcel cB cnp
      wcel wa cA cnp wcel cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel wa vx
      cv cA wcel vz cv cC wcel wa wa vx cv vy cv cmq co cA cB cmp co wcel vx cv
      vz cv cmq co cA cC cmp co wcel wa vx cv vy cv cmq co vx cv vz cv cmq co
      cplq co cA cB cmp co cA cC cmp co cpp co wcel cA cnp wcel cB cnp wcel wa
      vx cv cA wcel vy cv cB wcel wa vx cv vy cv cmq co cA cB cmp co wcel cA
      cnp wcel cC cnp wcel wa vx cv cA wcel vz cv cC wcel wa vx cv vz cv cmq co
      cA cC cmp co wcel vf vg vh vw vv vu cA cB vx cv vy cv cmp cmq vw vv vu vf
      vg vh df-mp genpprecl vf vg vh vw vv vu cA cC vx cv vz cv cmp cmq vw vv
      vu vf vg vh df-mp genpprecl im2anan9 cA cB cmp co cnp wcel cA cC cmp co
      cnp wcel vx cv vy cv cmq co cA cB cmp co wcel vx cv vz cv cmq co cA cC
      cmp co wcel wa vx cv vy cv cmq co vx cv vz cv cmq co cplq co cA cB cmp co
      cA cC cmp co cpp co wcel wi cA cnp wcel cB cnp wcel wa cA cnp wcel cC cnp
      wcel wa vf vg vh vw vv vu cA cB cmp co cA cC cmp co vx cv vy cv cmq co vx
      cv vz cv cmq co cpp cplq vw vv vu vf vg vh df-plp genpprecl cA cB mulclpr
      cA cC mulclpr syl2an syld vx cv cA wcel vy cv cB wcel vz cv cC wcel
      anandi vx cv vy cv vz cv cplq co cmq co vx cv vy cv cmq co vx cv vz cv
      cmq co cplq co cA cB cmp co cA cC cmp co cpp co vx cv vy cv vz cv vy
      visset vz visset distrpq eleq1i 3imtr4g anandis vx cv vy cv vz cv cplq co
      cmq co cA cB cmp co cA cC cmp co cpp co vw cv eleq1a syl6 imp3a 19.23advv
      19.23adv sylbid ssrdv $.
      $( [1-May-1996] $)

    $( Lemma for distributive law for positive reals. $)
    distrlem2pr $p |- ( ( A e. P. /\ ( B e. P. /\ C e. P. ) ) ->
         ( ( x e. A /\ ( y e. B /\ z e. C ) ) ->
         ( ( x .Q y ) +Q ( x .Q z ) ) e. ( A .P. ( B +P. C ) ) ) ) $=
      cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz
      cv cC wcel wa wa vx cv vy cv vz cv cplq co cmq co cA cB cC cpp co cmp co
      wcel vx cv vy cv cmq co vx cv vz cv cmq co cplq co cA cB cC cpp co cmp co
      wcel cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vy cv cB
      wcel vz cv cC wcel wa wa vx cv cA wcel vy cv vz cv cplq co cB cC cpp co
      wcel wa vx cv vy cv vz cv cplq co cmq co cA cB cC cpp co cmp co wcel cB
      cnp wcel cC cnp wcel wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa
      vx cv cA wcel vy cv vz cv cplq co cB cC cpp co wcel wa wi cA cnp wcel cB
      cnp wcel cC cnp wcel wa vy cv cB wcel vz cv cC wcel wa vy cv vz cv cplq
      co cB cC cpp co wcel vx cv cA wcel vf vg vh vw vv vu cB cC vy cv vz cv
      cpp cplq vw vv vu vf vg vh df-plp genpprecl anim2d adantl cA cnp wcel cB
      cC cpp co cnp wcel vx cv cA wcel vy cv vz cv cplq co cB cC cpp co wcel wa
      vx cv vy cv vz cv cplq co cmq co cA cB cC cpp co cmp co wcel wi cB cnp
      wcel cC cnp wcel wa vf vg vh vw vv vu cA cB cC cpp co vx cv vy cv vz cv
      cplq co cmp cmq vw vv vu vf vg vh df-mp genpprecl cB cC addclpr sylan2
      syld vx cv vy cv vz cv cplq co cmq co vx cv vy cv cmq co vx cv vz cv cmq
      co cplq co cA cB cC cpp co cmp co vx cv vy cv vz cv vy visset vz visset
      distrpq eleq1i syl6ib $.
      $( [2-May-1996] $)

    $( Lemma for distributive law for positive reals. $)
    distrlem3pr $p |- ( ( ( A e. P. /\ ( B e. P. /\ C e. P. ) ) /\
         ( x e. A /\ ( y e. B /\ z e. C ) ) ) ->
         ( x e. Q. /\ ( y e. Q. /\ z e. Q. ) ) ) $=
      cA cnp wcel cB cnp wcel cC cnp wcel w3a vx cv cA wcel vy cv cB wcel vz cv
      cC wcel w3a wa vx cv cnq wcel vy cv cnq wcel vz cv cnq wcel w3a cA cnp
      wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC
      wcel wa wa wa vx cv cnq wcel vy cv cnq wcel vz cv cnq wcel wa wa cA cnp
      wcel cB cnp wcel cC cnp wcel w3a vx cv cA wcel vy cv cB wcel vz cv cC
      wcel w3a wa cA cnp wcel vx cv cA wcel wa cB cnp wcel vy cv cB wcel wa cC
      cnp wcel vz cv cC wcel wa w3a vx cv cnq wcel vy cv cnq wcel vz cv cnq
      wcel w3a cA cnp wcel cB cnp wcel cC cnp wcel vx cv cA wcel vy cv cB wcel
      vz cv cC wcel an6 cA cnp wcel vx cv cA wcel wa vx cv cnq wcel cB cnp wcel
      vy cv cB wcel wa vy cv cnq wcel cC cnp wcel vz cv cC wcel wa vz cv cnq
      wcel cA vx cv elprpq cB vy cv elprpq cC vz cv elprpq 3anim123i sylbi cA
      cnp wcel cB cnp wcel cC cnp wcel w3a cA cnp wcel cB cnp wcel cC cnp wcel
      wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel w3a vx cv cA wcel vy cv
      cB wcel vz cv cC wcel wa wa cA cnp wcel cB cnp wcel cC cnp wcel 3anass vx
      cv cA wcel vy cv cB wcel vz cv cC wcel 3anass anbi12i vx cv cnq wcel vy
      cv cnq wcel vz cv cnq wcel 3anass 3imtr3i $.
      $( [2-May-1996] $)

    $( Lemma for distributive law for positive reals. $)
    distrlem4pr $p |- ( ( ( A e. P. /\ ( B e. P. /\ C e. P. ) ) /\
         ( ( x e. A /\ f e. A ) /\ ( y e. B /\ z e. C ) ) ) ->
         ( ( x .Q y ) +Q ( f .Q z ) ) e. ( A .P. ( B +P. C ) ) ) $=
      cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vf cv cA wcel wa
      vy cv cB wcel vz cv cC wcel wa wa wa vx cv vf cv cltq wbr vf cv vx cv
      cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co
      cmp co wcel cA cnp wcel cB cnp wcel cC cnp wcel wa wa vf cv cA wcel vy cv
      cB wcel vz cv cC wcel wa vx cv vf cv cltq wbr vx cv vy cv cmq co vf cv vz
      cv cmq co cplq co cA cB cC cpp co cmp co wcel wi vx cv cA wcel cA cnp
      wcel cB cnp wcel cC cnp wcel wa wa vf cv cA wcel vy cv cB wcel vz cv cC
      wcel wa wa wa vx cv vf cv cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co
      cplq co vf cv vy cv cmq co vf cv vz cv cmq co cplq co cltq wbr vx cv vy
      cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel cA cnp
      wcel cB cnp wcel cC cnp wcel wa wa vf cv cA wcel vy cv cB wcel vz cv cC
      wcel wa wa wa vf cv cnq wcel vy cv cnq wcel vz cv cnq wcel wa wa vx cv vf
      cv cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co vf cv vy cv cmq
      co vf cv vz cv cmq co cplq co cltq wbr wb vf vy vz cA cB cC distrlem3pr
      vy cv cnq wcel vf cv cnq wcel vz cv cnq wcel vx cv vf cv cltq wbr vx cv
      vy cv cmq co vf cv vz cv cmq co cplq co vf cv vy cv cmq co vf cv vz cv
      cmq co cplq co cltq wbr wb vy cv cnq wcel vx cv vf cv cltq wbr vx cv vy
      cv cmq co vf cv vy cv cmq co cltq wbr vf cv cnq wcel vz cv cnq wcel wa vx
      cv vy cv cmq co vf cv vz cv cmq co cplq co vf cv vy cv cmq co vf cv vz cv
      cmq co cplq co cltq wbr vw vv vu vx cv vf cv vy cv cltq cnq cmq vx visset
      vf visset vw cv vv cv vu cv vw visset vv visset ltmpq vy visset vw cv vv
      cv vw visset vv visset mulcompq caoprord2 vf cv cnq wcel vz cv cnq wcel
      wa vf cv vz cv cmq co cnq wcel vx cv vy cv cmq co vf cv vy cv cmq co cltq
      wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co vf cv vy cv cmq co vf
      cv vz cv cmq co cplq co cltq wbr wb vf cv vz cv mulclpq vw vv vu vx cv vy
      cv cmq co vf cv vy cv cmq co vf cv vz cv cmq co cltq cnq cplq vx cv vy cv
      cmq oprex vf cv vy cv cmq oprex vw cv vv cv vu cv vw visset vv visset
      ltapq vf cv vz cv cmq oprex vw cv vv cv vw visset vv visset addcompq
      caoprord2 syl sylan9bb an1s syl cA cnp wcel cB cnp wcel cC cnp wcel wa wa
      vf cv cA wcel vy cv cB wcel vz cv cC wcel wa wa vx cv vy cv cmq co vf cv
      vz cv cmq co cplq co vf cv vy cv cmq co vf cv vz cv cmq co cplq co cltq
      wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co
      wcel wi cA cnp wcel cB cnp wcel cC cnp wcel wa wa vf cv cA wcel vy cv cB
      wcel vz cv cC wcel wa wa vf cv vy cv cmq co vf cv vz cv cmq co cplq co cA
      cB cC cpp co cmp co wcel vx cv vy cv cmq co vf cv vz cv cmq co cplq co vf
      cv vy cv cmq co vf cv vz cv cmq co cplq co cltq wbr vx cv vy cv cmq co vf
      cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel wi vf vy vz cA cB cC
      distrlem2pr cA cnp wcel cB cnp wcel cC cnp wcel wa wa cA cB cC cpp co cmp
      co cnp wcel vf cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co
      cmp co wcel vx cv vy cv cmq co vf cv vz cv cmq co cplq co vf cv vy cv cmq
      co vf cv vz cv cmq co cplq co cltq wbr vx cv vy cv cmq co vf cv vz cv cmq
      co cplq co cA cB cC cpp co cmp co wcel wi wi cA cnp wcel cB cC cpp co cnp
      wcel cA cB cC cpp co cmp co cnp wcel cB cnp wcel cC cnp wcel wa cA cB cC
      cpp co mulclpr cB cC addclpr sylan2 cA cB cC cpp co cmp co cnp wcel vf cv
      vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel vx cv
      vy cv cmq co vf cv vz cv cmq co cplq co vf cv vy cv cmq co vf cv vz cv
      cmq co cplq co cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA
      cB cC cpp co cmp co wcel wi cA cB cC cpp co cmp co vf cv vy cv cmq co vf
      cv vz cv cmq co cplq co vx cv vy cv cmq co vf cv vz cv cmq co cplq co
      prcdpq ex syl syld imp sylbid adantrll cA cnp wcel cB cnp wcel cC cnp
      wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vf cv vx cv cltq
      wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co
      wcel wi vf cv cA wcel cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA
      wcel vy cv cB wcel vz cv cC wcel wa wa wa vf cv vx cv cltq wbr vx cv vy
      cv cmq co vf cv vz cv cmq co cplq co vx cv vy cv cmq co vx cv vz cv cmq
      co cplq co cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB
      cC cpp co cmp co wcel cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA
      wcel vy cv cB wcel vz cv cC wcel wa wa wa vx cv cnq wcel vy cv cnq wcel
      vz cv cnq wcel wa wa vf cv vx cv cltq wbr vx cv vy cv cmq co vf cv vz cv
      cmq co cplq co vx cv vy cv cmq co vx cv vz cv cmq co cplq co cltq wbr wb
      vx vy vz cA cB cC distrlem3pr vx cv cnq wcel vy cv cnq wcel vz cv cnq
      wcel vf cv vx cv cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co
      vx cv vy cv cmq co vx cv vz cv cmq co cplq co cltq wbr wb vz cv cnq wcel
      vf cv vx cv cltq wbr vf cv vz cv cmq co vx cv vz cv cmq co cltq wbr vx cv
      cnq wcel vy cv cnq wcel wa vx cv vy cv cmq co vf cv vz cv cmq co cplq co
      vx cv vy cv cmq co vx cv vz cv cmq co cplq co cltq wbr vw vv vu vf cv vx
      cv vz cv cltq cnq cmq vf visset vx visset vw cv vv cv vu cv vw visset vv
      visset ltmpq vz visset vw cv vv cv vw visset vv visset mulcompq caoprord2
      vx cv cnq wcel vy cv cnq wcel wa vx cv vy cv cmq co cnq wcel vf cv vz cv
      cmq co vx cv vz cv cmq co cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co
      cplq co vx cv vy cv cmq co vx cv vz cv cmq co cplq co cltq wbr wb vx cv
      vy cv mulclpq vf cv vz cv cmq co vx cv vz cv cmq co vx cv vy cv cmq co vf
      cv vz cv cmq oprex vx cv vz cv cmq oprex ltapq syl sylan9bbr anasss syl
      cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz
      cv cC wcel wa wa vx cv vy cv cmq co vf cv vz cv cmq co cplq co vx cv vy
      cv cmq co vx cv vz cv cmq co cplq co cltq wbr vx cv vy cv cmq co vf cv vz
      cv cmq co cplq co cA cB cC cpp co cmp co wcel wi cA cnp wcel cB cnp wcel
      cC cnp wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa wa vx cv
      vy cv cmq co vx cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel vx cv
      vy cv cmq co vf cv vz cv cmq co cplq co vx cv vy cv cmq co vx cv vz cv
      cmq co cplq co cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA
      cB cC cpp co cmp co wcel wi vx vy vz cA cB cC distrlem2pr cA cnp wcel cB
      cnp wcel cC cnp wcel wa wa cA cB cC cpp co cmp co cnp wcel vx cv vy cv
      cmq co vx cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel vx cv vy cv
      cmq co vf cv vz cv cmq co cplq co vx cv vy cv cmq co vx cv vz cv cmq co
      cplq co cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC
      cpp co cmp co wcel wi wi cA cnp wcel cB cC cpp co cnp wcel cA cB cC cpp
      co cmp co cnp wcel cB cnp wcel cC cnp wcel wa cA cB cC cpp co mulclpr cB
      cC addclpr sylan2 cA cB cC cpp co cmp co cnp wcel vx cv vy cv cmq co vx
      cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel vx cv vy cv cmq co vf
      cv vz cv cmq co cplq co vx cv vy cv cmq co vx cv vz cv cmq co cplq co
      cltq wbr vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co
      cmp co wcel wi cA cB cC cpp co cmp co vx cv vy cv cmq co vx cv vz cv cmq
      co cplq co vx cv vy cv cmq co vf cv vz cv cmq co cplq co prcdpq ex syl
      syld imp sylbid adantrlr cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv
      cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa wa vx cv vf cv
      cltq wbr vf cv vx cv cltq wbr wo wn vx cv vf cv wceq vx cv vy cv cmq co
      vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel cA cnp wcel vx cv
      cA wcel vf cv cA wcel wa vx cv vf cv wceq vx cv vf cv cltq wbr vf cv vx
      cv cltq wbr wo wn wb cB cnp wcel cC cnp wcel wa vy cv cB wcel vz cv cC
      wcel wa cnq cltq wor vx cv cnq wcel vf cv cnq wcel wa vx cv vf cv wceq vx
      cv vf cv cltq wbr vf cv vx cv cltq wbr wo wn wb cA cnp wcel vx cv cA wcel
      vf cv cA wcel wa wa cnq vx cv vf cv cltq sotrieq ltsopq cA cnp wcel vx cv
      cA wcel vf cv cA wcel vx cv cnq wcel vf cv cnq wcel wa cA cnp wcel vx cv
      cA wcel wa vx cv cnq wcel cA cnp wcel vf cv cA wcel wa vf cv cnq wcel cA
      vx cv elprpq cA vf cv elprpq anim12i anandis sylancr ad2ant2r vx cv vf cv
      wceq vx cv vy cv cmq co vx cv vz cv cmq co cplq co cA cB cC cpp co cmp co
      wcel vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co
      wcel cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vf cv cA
      wcel wa vy cv cB wcel vz cv cC wcel wa wa wa vx cv vf cv wceq vx cv vy cv
      cmq co vx cv vz cv cmq co cplq co vx cv vy cv cmq co vf cv vz cv cmq co
      cplq co cA cB cC cpp co cmp co vx cv vf cv wceq vx cv vz cv cmq co vf cv
      vz cv cmq co vx cv vy cv cmq co cplq vx cv vf cv vz cv cmq opreq1 opreq2d
      eleq1d cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA wcel vf cv cA
      wcel wa vy cv cB wcel vz cv cC wcel wa wa vx cv vy cv cmq co vx cv vz cv
      cmq co cplq co cA cB cC cpp co cmp co wcel cA cnp wcel cB cnp wcel cC cnp
      wcel wa wa vx cv cA wcel vy cv cB wcel vz cv cC wcel wa vx cv vy cv cmq
      co vx cv vz cv cmq co cplq co cA cB cC cpp co cmp co wcel vx cv cA wcel
      vf cv cA wcel wa vx vy vz cA cB cC distrlem2pr vx cv cA wcel vf cv cA
      wcel pm3.26 sylani imp syl5cbi sylbird ecase3d $.
      $( [2-May-1996] $)


    $( Lemma for distributive law for positive reals. $)
    distrlem5pr $p |- ( ( A e. P. /\ ( B e. P. /\ C e. P. ) ) ->
       ( ( A .P. B ) +P. ( A .P. C ) ) C_ ( A .P. ( B +P. C ) ) ) $=
      cA cnp wcel cB cnp wcel cC cnp wcel wa wa vw cA cB cmp co cA cC cmp co
      cpp co cA cB cC cpp co cmp co cA cnp wcel cB cnp wcel cC cnp wcel wa wa
      vw cv cA cB cmp co cA cC cmp co cpp co wcel vx cv cA wcel vf cv cA wcel
      wa vy cv cB wcel vz cv cC wcel wa wa vw cv vx cv vy cv cmq co vf cv vz cv
      cmq co cplq co wceq wa vz wex vf wex vy wex vx wex vw cv cA cB cC cpp co
      cmp co wcel cA cnp wcel cB cnp wcel cC cnp wcel vw cv cA cB cmp co cA cC
      cmp co cpp co wcel vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC
      wcel wa wa vw cv vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vz
      wex vf wex vy wex vx wex wb cA cnp wcel cB cnp wcel wa cA cnp wcel cC cnp
      wcel wa wa vw cv cA cB cmp co cA cC cmp co cpp co wcel vv cv cA cB cmp co
      wcel vu cv cA cC cmp co wcel wa vw cv vv cv vu cv cplq co wceq wa vu wex
      vv wex vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa
      vw cv vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vz wex vf wex
      vy wex vx wex cA cB cmp co cnp wcel cA cC cmp co cnp wcel vw cv cA cB cmp
      co cA cC cmp co cpp co wcel vv cv cA cB cmp co wcel vu cv cA cC cmp co
      wcel wa vw cv vv cv vu cv cplq co wceq wa vu wex vv wex wb cA cnp wcel cB
      cnp wcel wa cA cnp wcel cC cnp wcel wa vf vg vh vx vy vz cA cB cmp co cA
      cC cmp co vw cv vv vu cpp cplq vx vy vz vf vg vh df-plp vw visset genpelv
      cA cB mulclpr cA cC mulclpr syl2an cA cnp wcel cB cnp wcel wa cA cnp wcel
      cC cnp wcel wa wa vv cv cA cB cmp co wcel vu cv cA cC cmp co wcel wa vw
      cv vv cv vu cv cplq co wceq wa vu wex vv wex vx cv cA wcel vy cv cB wcel
      wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv
      vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co wceq wa vz wex vf
      wex vy wex vx wex vu wex vv wex vx cv cA wcel vf cv cA wcel wa vy cv cB
      wcel vz cv cC wcel wa wa vw cv vx cv vy cv cmq co vf cv vz cv cmq co cplq
      co wceq wa vz wex vf wex vy wex vx wex cA cnp wcel cB cnp wcel wa cA cnp
      wcel cC cnp wcel wa wa vv cv cA cB cmp co wcel vu cv cA cC cmp co wcel wa
      vw cv vv cv vu cv cplq co wceq wa vx cv cA wcel vy cv cB wcel wa vv cv vx
      cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv
      cmq co wceq wa wa vw cv vv cv vu cv cplq co wceq wa vz wex vf wex vy wex
      vx wex vv vu cA cnp wcel cB cnp wcel wa cA cnp wcel cC cnp wcel wa wa vv
      cv cA cB cmp co wcel vu cv cA cC cmp co wcel wa vw cv vv cv vu cv cplq co
      wceq wa vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa
      vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa wa vz wex
      vf wex vy wex vx wex vw cv vv cv vu cv cplq co wceq wa vx cv cA wcel vy
      cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC
      wcel wa vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co
      wceq wa vz wex vf wex vy wex vx wex cA cnp wcel cB cnp wcel wa cA cnp
      wcel cC cnp wcel wa wa vv cv cA cB cmp co wcel vu cv cA cC cmp co wcel wa
      vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA
      wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa wa vz wex vf wex
      vy wex vx wex vw cv vv cv vu cv cplq co wceq cA cnp wcel cB cnp wcel wa
      cA cnp wcel cC cnp wcel wa wa vv cv cA cB cmp co wcel vu cv cA cC cmp co
      wcel wa vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa
      vy wex vx wex vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co
      wceq wa vz wex vf wex wa vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv
      cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co
      wceq wa wa vz wex vf wex vy wex vx wex cA cnp wcel cB cnp wcel wa vv cv
      cA cB cmp co wcel vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co
      wceq wa vy wex vx wex cA cnp wcel cC cnp wcel wa vu cv cA cC cmp co wcel
      vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa vz wex vf
      wex vf vg vh vw vv vu cA cB vv cv vx vy cmp cmq vw vv vu vf vg vh df-mp
      vv visset genpelv vx vg vh vw vv vu cA cC vu cv vf vz cmp cmq vw vv vu vx
      vg vh df-mp vu visset genpelv bi2anan9 vx cv cA wcel vy cv cB wcel wa vv
      cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv
      vz cv cmq co wceq wa vx vy vf vz ee4anv syl6bbr anbi1d vx cv cA wcel vy
      cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC
      wcel wa vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co
      wceq wa vz wex vf wex vy wex vx wex vx cv cA wcel vy cv cB wcel wa vv cv
      vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz
      cv cmq co wceq wa wa vz wex vf wex vw cv vv cv vu cv cplq co wceq wa vy
      wex vx wex vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq
      wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa wa vz
      wex vf wex vy wex vx wex vw cv vv cv vu cv cplq co wceq wa vx cv cA wcel
      vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC
      wcel wa vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co
      wceq wa vz wex vf wex vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv
      cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co
      wceq wa wa vz wex vf wex vw cv vv cv vu cv cplq co wceq wa vx vy vx cv cA
      wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz
      cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq
      co wceq vf vz 19.41vv 2exbii vx cv cA wcel vy cv cB wcel wa vv cv vx cv
      vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq
      co wceq wa wa vz wex vf wex vw cv vv cv vu cv cplq co wceq vx vy 19.41vv
      bitri syl6bbr 2exbidv vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv
      cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co
      wceq wa wa vw cv vv cv vu cv cplq co wceq wa vz wex vf wex vy wex vx wex
      vu wex vv wex vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co
      wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa
      wa vw cv vv cv vu cv cplq co wceq wa vz wex vf wex vu wex vv wex vy wex
      vx wex vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa
      vw cv vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vz wex vf wex
      vy wex vx wex vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co
      wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa
      wa vw cv vv cv vu cv cplq co wceq wa vz wex vf wex vv vu vx vy exrot4 vx
      cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA
      wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu
      cv cplq co wceq wa vz wex vf wex vu wex vv wex vx cv cA wcel vf cv cA
      wcel wa vy cv cB wcel vz cv cC wcel wa wa vw cv vx cv vy cv cmq co vf cv
      vz cv cmq co cplq co wceq wa vz wex vf wex vx vy vx cv cA wcel vy cv cB
      wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa
      vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co wceq wa vz
      wex vf wex vu wex vv wex vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv
      cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co
      wceq wa wa vw cv vv cv vu cv cplq co wceq wa vu wex vv wex vz wex vf wex
      vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vw cv vx
      cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vz wex vf wex vx cv cA
      wcel vy cv cB wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz
      cv cC wcel wa vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq
      co wceq wa vv vu vf vz exrot4 vx cv cA wcel vy cv cB wcel wa vv cv vx cv
      vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq
      co wceq wa wa vw cv vv cv vu cv cplq co wceq wa vu wex vv wex vx cv cA
      wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vw cv vx cv vy cv
      cmq co vf cv vz cv cmq co cplq co wceq wa vf vz vx cv cA wcel vf cv cA
      wcel wa vy cv cB wcel vz cv cC wcel wa wa vv cv vx cv vy cv cmq co wceq
      vu cv vf cv vz cv cmq co wceq wa vw cv vv cv vu cv cplq co wceq wa wa vu
      wex vv wex vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa
      wa vv cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa vw cv
      vv cv vu cv cplq co wceq wa vu wex vv wex wa vx cv cA wcel vy cv cB wcel
      wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv
      vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co wceq wa vu wex vv
      wex vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vw
      cv vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vx cv cA wcel vf
      cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vv cv vx cv vy cv cmq co
      wceq vu cv vf cv vz cv cmq co wceq wa vw cv vv cv vu cv cplq co wceq wa
      vv vu 19.42vv vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel
      wa wa vv cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa vw
      cv vv cv vu cv cplq co wceq wa wa vx cv cA wcel vy cv cB wcel wa vv cv vx
      cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv
      cmq co wceq wa wa vw cv vv cv vu cv cplq co wceq wa vv vu vx cv cA wcel
      vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vv cv vx cv vy cv cmq
      co wceq vu cv vf cv vz cv cmq co wceq wa vw cv vv cv vu cv cplq co wceq
      wa wa vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vv
      cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa wa vw cv vv
      cv vu cv cplq co wceq wa vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv
      cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz cv cmq co
      wceq wa wa vw cv vv cv vu cv cplq co wceq wa vx cv cA wcel vf cv cA wcel
      wa vy cv cB wcel vz cv cC wcel wa wa vv cv vx cv vy cv cmq co wceq vu cv
      vf cv vz cv cmq co wceq wa vw cv vv cv vu cv cplq co wceq anass vx cv cA
      wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vv cv vx cv vy cv
      cmq co wceq vu cv vf cv vz cv cmq co wceq wa wa vx cv cA wcel vy cv cB
      wcel wa vv cv vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa
      vu cv vf cv vz cv cmq co wceq wa wa vw cv vv cv vu cv cplq co wceq vx cv
      cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vv cv vx cv vy
      cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa wa vx cv cA wcel vy cv cB
      wcel wa vf cv cA wcel vz cv cC wcel wa wa vv cv vx cv vy cv cmq co wceq
      vu cv vf cv vz cv cmq co wceq wa wa vx cv cA wcel vy cv cB wcel wa vv cv
      vx cv vy cv cmq co wceq wa vf cv cA wcel vz cv cC wcel wa vu cv vf cv vz
      cv cmq co wceq wa wa vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv
      cC wcel wa wa vx cv cA wcel vy cv cB wcel wa vf cv cA wcel vz cv cC wcel
      wa wa vv cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa vx
      cv cA wcel vf cv cA wcel vy cv cB wcel vz cv cC wcel an4 anbi1i vx cv cA
      wcel vy cv cB wcel wa vf cv cA wcel vz cv cC wcel wa vv cv vx cv vy cv
      cmq co wceq vu cv vf cv vz cv cmq co wceq an4 bitri anbi1i bitr3i 2exbii
      vv cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa vw cv vv
      cv vu cv cplq co wceq wa vu wex vv wex vw cv vx cv vy cv cmq co vf cv vz
      cv cmq co cplq co wceq vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv
      cC wcel wa wa vx cv vy cv cmq co cvv wcel vf cv vz cv cmq co cvv wcel vv
      cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa vw cv vv cv
      vu cv cplq co wceq wa vu wex vv wex vw cv vx cv vy cv cmq co vf cv vz cv
      cmq co cplq co wceq wb vx cv vy cv cmq oprex vf cv vz cv cmq oprex vw cv
      vv cv vu cv cplq co wceq vw cv vx cv vy cv cmq co vf cv vz cv cmq co cplq
      co wceq vv cv vx cv vy cv cmq co wceq vu cv vf cv vz cv cmq co wceq wa vv
      vu vx cv vy cv cmq co vf cv vz cv cmq co cvv cvv vv cv vx cv vy cv cmq co
      wceq vu cv vf cv vz cv cmq co wceq wa id vv cv vx cv vy cv cmq co wceq vu
      cv vf cv vz cv cmq co wceq wa vv cv vu cv cplq co vx cv vy cv cmq co vf
      cv vz cv cmq co cplq co vw cv vv cv vx cv vy cv cmq co vu cv vf cv vz cv
      cmq co cplq opreq12 eqeq2d cgsex2g mp2an anbi2i 3bitr3i 2exbii bitri
      2exbii bitri syl6bb bitrd anandis cA cnp wcel cB cnp wcel cC cnp wcel wa
      wa vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vw cv
      vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vz wex vf wex vw cv
      cA cB cC cpp co cmp co wcel vx vy cA cnp wcel cB cnp wcel cC cnp wcel wa
      wa vx cv cA wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vw cv
      vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq wa vw cv cA cB cC cpp
      co cmp co wcel vf vz cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA
      wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa vw cv vx cv vy cv
      cmq co vf cv vz cv cmq co cplq co wceq vw cv cA cB cC cpp co cmp co wcel
      vw cv vx cv vy cv cmq co vf cv vz cv cmq co cplq co wceq vw cv cA cB cC
      cpp co cmp co wcel vx cv vy cv cmq co vf cv vz cv cmq co cplq co cA cB cC
      cpp co cmp co wcel cA cnp wcel cB cnp wcel cC cnp wcel wa wa vx cv cA
      wcel vf cv cA wcel wa vy cv cB wcel vz cv cC wcel wa wa wa vw cv vx cv vy
      cv cmq co vf cv vz cv cmq co cplq co cA cB cC cpp co cmp co eleq1 vx vy
      vz cA cB cC vf distrlem4pr syl5cbir expimpd 19.23advv 19.23advv sylbid
      ssrdv $.
      $( [2-May-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    distrpr.1 $e |- B e. _V $.
    distrpr.2 $e |- C e. _V $.
    $( Multiplication of positive reals is distributive.  Proposition
       9-3.7(iii) of [Gleason] p. 124. $)
    distrpr $p |- ( A .P. ( B +P. C ) ) = ( ( A .P. B ) +P. ( A .P. C ) ) $=
      cA cnp wcel cB cnp wcel cC cnp wcel w3a cA cB cC cpp co cmp co cA cB cmp
      co cA cC cmp co cpp co wceq cA cnp wcel cB cnp wcel cC cnp wcel cA cB cC
      cpp co cmp co cA cB cmp co cA cC cmp co cpp co wceq cA cnp wcel cB cnp
      wcel cC cnp wcel wa wa cA cB cC cpp co cmp co cA cB cmp co cA cC cmp co
      cpp co cA cB cC distrlem1pr cA cB cC distrlem5pr eqssd 3impb cA cB cC cnp
      cpp cmp distrpr.1 dmplp distrpr.2 0npr dmmp ndmoprdistr pm2.61i $.
      $( [2-May-1996] $)
  $}

  ${
    $d x y z w v u f g A $.
    $( 1 is an identity element for positive real multiplication.  Theorem
       9-3.7(iv) of [Gleason] p. 124. $)
    1idpr $p |- ( A e. P. -> ( A .P. 1P ) = A ) $=
      cA cnp wcel vx cA c1p cmp co cA cA cnp wcel vf cv cA wcel vg cv c1p wcel
      wa vx cv vf cv vg cv cmq co wceq wa vg wex vf wex vf cv cA wcel vx cv vf
      cv cltq wbr wa vx cv vf cv vg cv cmq co wceq vg wex wa vf wex vx cv cA
      c1p cmp co wcel vx cv cA wcel cA cnp wcel vf cv cA wcel vg cv c1p wcel wa
      vx cv vf cv vg cv cmq co wceq wa vg wex vf cv cA wcel vx cv vf cv cltq
      wbr wa vx cv vf cv vg cv cmq co wceq vg wex wa vf cA cnp wcel vf cv cA
      wcel vx cv vf cv cltq wbr wa vx cv vf cv vg cv cmq co wceq wa vg wex vf
      cv cA wcel vg cv c1p wcel wa vx cv vf cv vg cv cmq co wceq wa vg wex vf
      cv cA wcel vx cv vf cv cltq wbr wa vx cv vf cv vg cv cmq co wceq vg wex
      wa cA cnp wcel vf cv cA wcel vx cv vf cv cltq wbr wa vx cv vf cv vg cv
      cmq co wceq wa vf cv cA wcel vg cv c1p wcel wa vx cv vf cv vg cv cmq co
      wceq wa vg cA cnp wcel vf cv cA wcel vx cv vf cv vg cv cmq co wceq wa vx
      cv vf cv cltq wbr wa vf cv cA wcel vx cv vf cv vg cv cmq co wceq wa vg cv
      c1p wcel wa vf cv cA wcel vx cv vf cv cltq wbr wa vx cv vf cv vg cv cmq
      co wceq wa vf cv cA wcel vg cv c1p wcel wa vx cv vf cv vg cv cmq co wceq
      wa cA cnp wcel vf cv cA wcel vx cv vf cv vg cv cmq co wceq wa vx cv vf cv
      cltq wbr vg cv c1p wcel cA cnp wcel vf cv cA wcel vx cv vf cv vg cv cmq
      co wceq vx cv vf cv cltq wbr vg cv c1p wcel wb cA cnp wcel vf cv cA wcel
      vx cv vf cv vg cv cmq co wceq vx cv vf cv cltq wbr vg cv c1p wcel wb vf
      cv cnq wcel vx cv vf cv vg cv cmq co wceq vx cv vf cv cltq wbr vg cv c1p
      wcel wb cA cnp wcel vf cv cA wcel wa vx cv vf cv vg cv cmq co wceq vx cv
      vf cv cltq wbr vf cv vg cv cmq co vf cv cltq wbr vf cv cnq wcel vg cv c1p
      wcel vx cv vf cv vg cv cmq co vf cv cltq breq1 vf cv cnq wcel vg cv c1q
      cltq wbr vf cv vg cv cmq co vf cv cltq wbr vg cv c1p wcel vf cv cnq wcel
      vg cv c1q cltq wbr vf cv vg cv cmq co vf cv c1q cmq co cltq wbr vf cv vg
      cv cmq co vf cv cltq wbr vg cv c1q vf cv vg visset c1q cnq 1q elisseti
      ltmpq vf cv cnq wcel vf cv c1q cmq co vf cv vf cv vg cv cmq co cltq vf cv
      mulidpq breq2d bitrd vg cv c1q cltq wbr vg c1p vg df-1p abeq2i syl5rbb
      sylan9bbr cA vf cv elprpq sylan exp31 imp3a pm5.32d vf cv cA wcel vx cv
      vf cv cltq wbr vx cv vf cv vg cv cmq co wceq an23 vf cv cA wcel vg cv c1p
      wcel vx cv vf cv vg cv cmq co wceq an23 3bitr4g exbidv vf cv cA wcel vx
      cv vf cv cltq wbr wa vx cv vf cv vg cv cmq co wceq vg 19.42v syl5rbbr
      exbidv cA cnp wcel c1p cnp wcel vx cv cA c1p cmp co wcel vf cv cA wcel vg
      cv c1p wcel wa vx cv vf cv vg cv cmq co wceq wa vg wex vf wex wb 1pr vx
      vy vz vw vv vu cA c1p vx cv vf vg cmp cmq vw vv vu vx vy vz df-mp vx
      visset genpelv mpan2 cA cnp wcel vx cv cA wcel vf cv cA wcel vx cv vf cv
      cltq wbr wa vx cv vf cv vg cv cmq co wceq vg wex wa vf wex cA cnp wcel vx
      cv cA wcel vf cv cA wcel vx cv vf cv cltq wbr wa vx cv vf cv vg cv cmq co
      wceq vg wex wa vf wex cA cnp wcel vx cv cA wcel wa vf cv cA wcel vx cv vf
      cv cltq wbr wa vf wex vf cv cA wcel vx cv vf cv cltq wbr wa vx cv vf cv
      vg cv cmq co wceq vg wex wa vf wex vf cA vx cv prnmax vf cv cA wcel vx cv
      vf cv cltq wbr wa vf cv cA wcel vx cv vf cv cltq wbr wa vx cv vf cv vg cv
      cmq co wceq vg wex wa vf vf cv cA wcel vx cv vf cv cltq wbr wa vx cv vf
      cv vg cv cmq co wceq vg wex vx cv vf cv cltq wbr vx cv vf cv vg cv cmq co
      wceq vg wex vf cv cA wcel vx cv vf cv cltq wbr vx cv cnq wcel vf cv cnq
      wcel wa vx cv vf cv vx cv vf cv crq cfv cmq co cmq co wceq vx cv vf cv vg
      cv cmq co wceq vg wex vx cv vf cv cnq cnq cltq vf visset ltrelpq brel vx
      cv cnq wcel vf cv cnq wcel wa vf cv vx cv vf cv crq cfv cmq co cmq co vx
      cv vf cv cnq wcel vx cv cnq wcel vf cv vx cv vf cv crq cfv cmq co cmq co
      vx cv c1q cmq co vx cv vf cv cnq wcel vx cv vf cv vf cv crq cfv cmq co
      cmq co vx cv c1q cmq co vf cv vx cv vf cv crq cfv cmq co cmq co vf cv cnq
      wcel vf cv vf cv crq cfv cmq co c1q vx cv cmq vf cv recidpq opreq2d vy vz
      vw vf cv vx cv vf cv crq cfv cmq vf visset vx visset vf cv crq fvex vy cv
      vz cv vy visset vz visset mulcompq vy cv vz cv vw cv vz visset vw visset
      mulasspq caopr12 syl5eq vx cv mulidpq sylan9eqr eqcomd vx cv vf cv vg cv
      cmq co wceq vx cv vf cv vx cv vf cv crq cfv cmq co cmq co wceq vg vx cv
      vf cv crq cfv cmq co vx cv vf cv crq cfv cmq oprex vg cv vx cv vf cv crq
      cfv cmq co wceq vf cv vg cv cmq co vf cv vx cv vf cv crq cfv cmq co cmq
      co vx cv vg cv vx cv vf cv crq cfv cmq co vf cv cmq opreq2 eqeq2d cla4ev
      3syl adantl ancli 19.22i syl ex cA cnp wcel vf cv cA wcel vx cv vf cv
      cltq wbr wa vx cv vf cv vg cv cmq co wceq vg wex wa vx cv cA wcel vf cA
      cnp wcel vf cv cA wcel vx cv vf cv cltq wbr wa vx cv cA wcel vx cv vf cv
      vg cv cmq co wceq vg wex cA cnp wcel vf cv cA wcel vx cv vf cv cltq wbr
      vx cv cA wcel cA vf cv vx cv prcdpq expimpd adantrd 19.23adv impbid
      3bitr4d eqrdv $.
      $( [2-Apr-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Positive real 'less than' in terms of proper subset. $)
    ltprord $p |- ( ( A e. P. /\ B e. P. ) -> ( A <P B <-> A C. B ) ) $=
      cA cnp wcel cB cnp wcel wa cA cB cltp wbr cA cB wpss vx cv cnp wcel vy cv
      cnp wcel wa vx cv vy cv wpss wa cA cnp wcel vy cv cnp wcel wa cA vy cv
      wpss wa cA cnp wcel cB cnp wcel wa cA cB wpss wa vx vy cA cB cnp cnp cltp
      vx cv cA wceq vx cv cnp wcel vy cv cnp wcel wa cA cnp wcel vy cv cnp wcel
      wa vx cv vy cv wpss cA vy cv wpss vx cv cA wceq vx cv cnp wcel cA cnp
      wcel vy cv cnp wcel vx cv cA cnp eleq1 anbi1d vx cv cA vy cv psseq1
      anbi12d vy cv cB wceq cA cnp wcel vy cv cnp wcel wa cA cnp wcel cB cnp
      wcel wa cA vy cv wpss cA cB wpss vy cv cB wceq vy cv cnp wcel cB cnp wcel
      cA cnp wcel vy cv cB cnp eleq1 anbi2d vy cv cB cA psseq2 anbi12d vx vy
      df-ltp brabg bianabs $.
      $( [20-Feb-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Proper subset is a linear ordering on positive reals.  Part of
       Proposition 9-3.3 of [Gleason] p. 122. $)
    psslinpr $p |- ( ( A e. P. /\ B e. P. ) ->
                ( A C. B \/ A = B \/ B C. A ) ) $=
      cA cnp wcel cB cnp wcel wa cA cB wpss cA cB wceq wo cB cA wpss cB cA wceq
      wo wo cA cB wpss cA cB wceq cB cA wpss w3o cA cnp wcel cB cnp wcel wa cA
      cB wpss cA cB wceq wo cB cA wpss cB cA wceq wo cA cnp wcel cB cnp wcel wa
      vx cv cA wcel vx cv cB wcel wn wa vx wex vy cv cB wcel vy cv cA wcel wi
      vy wal cA cB wpss cA cB wceq wo wn cB cA wpss cB cA wceq wo cA cnp wcel
      cB cnp wcel wa vx cv cA wcel vx cv cB wcel wn wa vy cv cB wcel vy cv cA
      wcel wi vy wal vx cA cnp wcel cB cnp wcel wa vx cv cA wcel vx cv cB wcel
      wn wa vy cv cB wcel vy cv cA wcel wi vy cA cnp wcel cB cnp wcel wa vy cv
      cB wcel vx cv cA wcel vx cv cB wcel wn wa vy cv cA wcel cA cnp wcel cB
      cnp wcel wa vy cv cB wcel vx cv cA wcel vx cv cB wcel wn vy cv cA wcel cA
      cnp wcel cB cnp wcel vy cv cB wcel vx cv cA wcel vx cv cB wcel wn vy cv
      cA wcel wi wi wi cB cnp wcel vy cv cB wcel cA cnp wcel vx cv cA wcel vx
      cv cB wcel wn vy cv cA wcel wi wi cB cnp wcel vy cv cB wcel cA cnp wcel
      vx cv cA wcel vx cv cB wcel wn vy cv cA wcel wi cB cnp wcel vy cv cB wcel
      wa cA cnp wcel vx cv cA wcel wa wa vx cv cB wcel wn vy cv vx cv cltq wbr
      vy cv cA wcel cB cnp wcel vy cv cB wcel wa vx cv cnq wcel vx cv cB wcel
      wn vy cv vx cv cltq wbr wi cA cnp wcel vx cv cA wcel wa cB vy cv vx cv
      prub cA vx cv elprpq sylan2 cA cnp wcel vx cv cA wcel wa vy cv vx cv cltq
      wbr vy cv cA wcel wi cB cnp wcel vy cv cB wcel wa cA vx cv vy cv prcdpq
      adantl syld exp43 com3r imp imp4a com23 19.21adv 19.23adv cA cB wpss cA
      cB wceq wo wn cA cB wss wn vx cv cA wcel vx cv cB wcel wn wa vx wex cA cB
      wss cA cB wpss cA cB wceq wo cA cB sspss notbii vx cA cB nss bitr3i cB cA
      wpss cB cA wceq wo cB cA wss vy cv cB wcel vy cv cA wcel wi vy wal cB cA
      sspss vy cB cA dfss2 bitr3i 3imtr4g orrd cA cB wpss cA cB wceq cB cA wpss
      w3o cA cB wpss cA cB wceq wo cB cA wpss wo cA cB wpss cB cA wpss wo cA cB
      wceq wo cA cB wpss cA cB wceq wo cB cA wpss cB cA wceq wo wo cA cB wpss
      cA cB wceq cB cA wpss df-3or cA cB wpss cA cB wceq cB cA wpss or23 cA cB
      wpss cB cA wpss wo cA cB wceq wo cA cB wpss cA cB wceq wo cB cA wpss cA
      cB wceq wo wo cA cB wpss cA cB wceq wo cB cA wpss cB cA wceq wo wo cA cB
      wpss cB cA wpss cA cB wceq orordir cB cA wpss cB cA wceq wo cB cA wpss cA
      cB wceq wo cA cB wpss cA cB wceq wo cB cA wceq cA cB wceq cB cA wpss cB
      cA eqcom orbi2i orbi2i bitr4i 3bitri sylibr $.
      $( [25-Feb-1996] $)
  $}

  ${
    $d x y z $.
    $( Positive real 'less than' is a strict ordering.  Part of Proposition
       9-3.3 of [Gleason] p. 122. $)
    ltsopr $p |- <P Or P. $=
      vx vy vz cnp cltp vx cv cnp wcel vx cv vx cv cltp wbr wn vx cv cnp wcel
      vx cv cnp wcel wa vx cv vx cv cltp wbr vx cv vx cv wpss vx cv pssirr vx
      cv vx cv ltprord mtbiri anidms vx cv cnp wcel vy cv cnp wcel vz cv cnp
      wcel w3a vx cv vy cv cltp wbr vy cv vz cv cltp wbr wa vx cv vz cv cltp
      wbr wi vx cv vy cv wpss vy cv vz cv wpss wa vx cv vz cv wpss wi vx cv vy
      cv vz cv psstr vx cv cnp wcel vy cv cnp wcel vz cv cnp wcel w3a vx cv vy
      cv cltp wbr vy cv vz cv cltp wbr wa vx cv vy cv wpss vy cv vz cv wpss wa
      vx cv vz cv cltp wbr vx cv vz cv wpss vx cv cnp wcel vy cv cnp wcel vz cv
      cnp wcel w3a vx cv vy cv cltp wbr vx cv vy cv wpss vy cv vz cv cltp wbr
      vy cv vz cv wpss vx cv cnp wcel vy cv cnp wcel vx cv vy cv cltp wbr vx cv
      vy cv wpss wb vz cv cnp wcel vx cv vy cv ltprord 3adant3 vy cv cnp wcel
      vz cv cnp wcel vy cv vz cv cltp wbr vy cv vz cv wpss wb vx cv cnp wcel vy
      cv vz cv ltprord 3adant1 anbi12d vx cv cnp wcel vz cv cnp wcel vx cv vz
      cv cltp wbr vx cv vz cv wpss wb vy cv cnp wcel vx cv vz cv ltprord
      3adant2 imbi12d mpbiri vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv cltp
      wbr vx cv vy cv wceq vy cv vx cv cltp wbr w3o vx cv vy cv wpss vx cv vy
      cv wceq vy cv vx cv wpss w3o vx cv vy cv psslinpr vx cv cnp wcel vy cv
      cnp wcel wa vx cv vy cv cltp wbr vx cv vy cv wpss vx cv vy cv wceq vx cv
      vy cv wceq vy cv vx cv cltp wbr vy cv vx cv wpss vx cv vy cv ltprord vx
      cv cnp wcel vy cv cnp wcel wa vx cv vy cv wceq biidd vy cv cnp wcel vx cv
      cnp wcel vy cv vx cv cltp wbr vy cv vx cv wpss wb vy cv vx cv ltprord
      ancoms 3orbi123d mpbird itlso $.
      $( [25-Feb-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u f B $.  $d z w v u f g h $.

    ${
      $d x y w C $.
      prlem934a.1 $e |- B e. _V $.
      $( Sublemma for Lemma 9-3.4 of [Gleason] p. 122. $)
      prlem934a $p |- ( C e. N. ->
        ( ( ( B e. Q. /\ A. x ( x e. A -> ( x +Q B ) e. A ) ) /\ y e. A ) ->
        ( y +Q ( [ <. C , 1o >. ] ~Q .Q B ) ) e. A ) ) $=
        cB cnq wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv
        cA wcel wa vy cv vw cv c1o cop ceq cec cB cmq co cplq co cA wcel wi cB
        cnq wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA
        wcel wa vy cv c1o c1o cop ceq cec cB cmq co cplq co cA wcel wi cB cnq
        wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA wcel
        wa vy cv vz cv c1o cop ceq cec cB cmq co cplq co cA wcel wi cB cnq wcel
        vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA wcel wa vy
        cv vz cv c1o cpli co c1o cop ceq cec cB cmq co cplq co cA wcel wi cB
        cnq wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA
        wcel wa vy cv cC c1o cop ceq cec cB cmq co cplq co cA wcel wi vw vz cC
        vw cv c1o wceq vy cv vw cv c1o cop ceq cec cB cmq co cplq co cA wcel vy
        cv c1o c1o cop ceq cec cB cmq co cplq co cA wcel cB cnq wcel vx cv cA
        wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA wcel wa vw cv c1o
        wceq vy cv vw cv c1o cop ceq cec cB cmq co cplq co vy cv c1o c1o cop
        ceq cec cB cmq co cplq co cA vw cv c1o wceq vw cv c1o cop ceq cec cB
        cmq co c1o c1o cop ceq cec cB cmq co vy cv cplq vw cv c1o wceq vw cv
        c1o cop ceq cec c1o c1o cop ceq cec cB cmq vw cv c1o wceq vw cv c1o cop
        c1o c1o cop wceq vw cv c1o cop ceq cec c1o c1o cop ceq cec wceq vw cv
        c1o c1o opeq1 vw cv c1o cop c1o c1o cop ceq eceq2 syl opreq1d opreq2d
        eleq1d imbi2d vw cv vz cv wceq vy cv vw cv c1o cop ceq cec cB cmq co
        cplq co cA wcel vy cv vz cv c1o cop ceq cec cB cmq co cplq co cA wcel
        cB cnq wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv
        cA wcel wa vw cv vz cv wceq vy cv vw cv c1o cop ceq cec cB cmq co cplq
        co vy cv vz cv c1o cop ceq cec cB cmq co cplq co cA vw cv vz cv wceq vw
        cv c1o cop ceq cec cB cmq co vz cv c1o cop ceq cec cB cmq co vy cv cplq
        vw cv vz cv wceq vw cv c1o cop ceq cec vz cv c1o cop ceq cec cB cmq vw
        cv vz cv wceq vw cv c1o cop vz cv c1o cop wceq vw cv c1o cop ceq cec vz
        cv c1o cop ceq cec wceq vw cv vz cv c1o opeq1 vw cv c1o cop vz cv c1o
        cop ceq eceq2 syl opreq1d opreq2d eleq1d imbi2d vw cv vz cv c1o cpli co
        wceq vy cv vw cv c1o cop ceq cec cB cmq co cplq co cA wcel vy cv vz cv
        c1o cpli co c1o cop ceq cec cB cmq co cplq co cA wcel cB cnq wcel vx cv
        cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA wcel wa vw cv vz
        cv c1o cpli co wceq vy cv vw cv c1o cop ceq cec cB cmq co cplq co vy cv
        vz cv c1o cpli co c1o cop ceq cec cB cmq co cplq co cA vw cv vz cv c1o
        cpli co wceq vw cv c1o cop ceq cec cB cmq co vz cv c1o cpli co c1o cop
        ceq cec cB cmq co vy cv cplq vw cv vz cv c1o cpli co wceq vw cv c1o cop
        ceq cec vz cv c1o cpli co c1o cop ceq cec cB cmq vw cv vz cv c1o cpli
        co wceq vw cv c1o cop vz cv c1o cpli co c1o cop wceq vw cv c1o cop ceq
        cec vz cv c1o cpli co c1o cop ceq cec wceq vw cv vz cv c1o cpli co c1o
        opeq1 vw cv c1o cop vz cv c1o cpli co c1o cop ceq eceq2 syl opreq1d
        opreq2d eleq1d imbi2d vw cv cC wceq vy cv vw cv c1o cop ceq cec cB cmq
        co cplq co cA wcel vy cv cC c1o cop ceq cec cB cmq co cplq co cA wcel
        cB cnq wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv
        cA wcel wa vw cv cC wceq vy cv vw cv c1o cop ceq cec cB cmq co cplq co
        vy cv cC c1o cop ceq cec cB cmq co cplq co cA vw cv cC wceq vw cv c1o
        cop ceq cec cB cmq co cC c1o cop ceq cec cB cmq co vy cv cplq vw cv cC
        wceq vw cv c1o cop ceq cec cC c1o cop ceq cec cB cmq vw cv cC wceq vw
        cv c1o cop cC c1o cop wceq vw cv c1o cop ceq cec cC c1o cop ceq cec
        wceq vw cv cC c1o opeq1 vw cv c1o cop cC c1o cop ceq eceq2 syl opreq1d
        opreq2d eleq1d imbi2d cB cnq wcel vx cv cA wcel vx cv cB cplq co cA
        wcel wi vx wal wa vy cv cA wcel vy cv c1o c1o cop ceq cec cB cmq co
        cplq co cA wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal vy cv
        cA wcel vy cv cB cplq co cA wcel cB cnq wcel vy cv c1o c1o cop ceq cec
        cB cmq co cplq co cA wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vy
        cv cA wcel vy cv cB cplq co cA wcel wi vx vy vx cv vy cv wceq vx cv cA
        wcel vy cv cA wcel vx cv cB cplq co cA wcel vy cv cB cplq co cA wcel vx
        cv vy cv cA eleq1 vx cv vy cv wceq vx cv cB cplq co vy cv cB cplq co cA
        vx cv vy cv cB cplq opreq1 eleq1d imbi12d a4v cB cnq wcel vy cv c1o c1o
        cop ceq cec cB cmq co cplq co cA wcel vy cv cB cplq co cA wcel cB cnq
        wcel vy cv c1o c1o cop ceq cec cB cmq co cplq co vy cv cB cplq co cA cB
        cnq wcel c1o c1o cop ceq cec cB cmq co cB vy cv cplq cB cnq wcel c1q cB
        cmq co cB c1o c1o cop ceq cec cB cmq co cB cnq wcel cB c1q cmq co cB
        c1q cB cmq co cB mulidpq cB c1q prlem934a.1 c1q cnq 1q elisseti
        mulcompq syl5eqr c1q c1o c1o cop ceq cec cB cmq df-1q opreq1i syl5eqr
        opreq2d eleq1d biimprd sylan9r imp vz cv cnpi wcel cB cnq wcel vx cv cA
        wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv cA wcel wa vy cv vz cv
        c1o cop ceq cec cB cmq co cplq co cA wcel vy cv vz cv c1o cpli co c1o
        cop ceq cec cB cmq co cplq co cA wcel vz cv cnpi wcel cB cnq wcel vx cv
        cA wcel vx cv cB cplq co cA wcel wi vx wal wa vy cv vz cv c1o cop ceq
        cec cB cmq co cplq co cA wcel vy cv vz cv c1o cpli co c1o cop ceq cec
        cB cmq co cplq co cA wcel wi vy cv cA wcel vz cv cnpi wcel cB cnq wcel
        vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal vy cv vz cv c1o cop
        ceq cec cB cmq co cplq co cA wcel vy cv vz cv c1o cpli co c1o cop ceq
        cec cB cmq co cplq co cA wcel wi vz cv cnpi wcel cB cnq wcel vx cv cA
        wcel vx cv cB cplq co cA wcel wi vx wal vy cv vz cv c1o cop ceq cec cB
        cmq co cplq co cA wcel vy cv vz cv c1o cpli co c1o cop ceq cec cB cmq
        co cplq co cA wcel wi vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal
        vy cv vz cv c1o cop ceq cec cB cmq co cplq co cA wcel vy cv vz cv c1o
        cop ceq cec cB cmq co cplq co cB cplq co cA wcel vz cv cnpi wcel cB cnq
        wcel wa vy cv vz cv c1o cpli co c1o cop ceq cec cB cmq co cplq co cA
        wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vy cv vz cv c1o cop ceq
        cec cB cmq co cplq co cA wcel vy cv vz cv c1o cop ceq cec cB cmq co
        cplq co cB cplq co cA wcel wi vx vy cv vz cv c1o cop ceq cec cB cmq co
        cplq co vy cv vz cv c1o cop ceq cec cB cmq co cplq oprex vx cv vy cv vz
        cv c1o cop ceq cec cB cmq co cplq co wceq vx cv cA wcel vy cv vz cv c1o
        cop ceq cec cB cmq co cplq co cA wcel vx cv cB cplq co cA wcel vy cv vz
        cv c1o cop ceq cec cB cmq co cplq co cB cplq co cA wcel vx cv vy cv vz
        cv c1o cop ceq cec cB cmq co cplq co cA eleq1 vx cv vy cv vz cv c1o cop
        ceq cec cB cmq co cplq co wceq vx cv cB cplq co vy cv vz cv c1o cop ceq
        cec cB cmq co cplq co cB cplq co cA vx cv vy cv vz cv c1o cop ceq cec
        cB cmq co cplq co cB cplq opreq1 eleq1d imbi12d cla4v vz cv cnpi wcel
        cB cnq wcel wa vy cv vz cv c1o cop ceq cec cB cmq co cplq co cB cplq co
        cA wcel vy cv vz cv c1o cpli co c1o cop ceq cec cB cmq co cplq co cA
        wcel vz cv cnpi wcel cB cnq wcel wa vy cv vz cv c1o cop ceq cec cB cmq
        co cplq co cB cplq co vy cv vz cv c1o cpli co c1o cop ceq cec cB cmq co
        cplq co cA vz cv cnpi wcel cB cnq wcel wa vy cv vz cv c1o cop ceq cec
        cB cmq co cB cplq co cplq co vy cv vz cv c1o cpli co c1o cop ceq cec cB
        cmq co cplq co vy cv vz cv c1o cop ceq cec cB cmq co cplq co cB cplq co
        vz cv cnpi wcel cB cnq wcel wa vz cv c1o cop ceq cec cB cmq co cB cplq
        co vz cv c1o cpli co c1o cop ceq cec cB cmq co vy cv cplq cB cnq wcel
        vz cv cnpi wcel vz cv c1o cop ceq cec cB cmq co cB cplq co vz cv c1o
        cop ceq cec c1q cplq co cB cmq co vz cv c1o cpli co c1o cop ceq cec cB
        cmq co cB cnq wcel vz cv c1o cop ceq cec cB cmq co cB cplq co vz cv c1o
        cop ceq cec cB cmq co c1q cB cmq co cplq co vz cv c1o cop ceq cec c1q
        cplq co cB cmq co cB cnq wcel cB c1q cB cmq co vz cv c1o cop ceq cec cB
        cmq co cplq cB cnq wcel cB c1q cmq co cB c1q cB cmq co cB mulidpq cB
        c1q prlem934a.1 c1q cnq 1q elisseti mulcompq syl5reqr opreq2d vv vu vf
        vz cv c1o cop ceq cec c1q cB cplq cmq ceq cvv wcel vz cv c1o cop ceq
        cec cvv wcel enqex vz cv c1o cop cvv ceq ecexg ax-mp c1q cnq 1q
        elisseti prlem934a.1 vv cv vu cv vv visset vu visset mulcompq vv cv vu
        cv vf cv vu visset vf visset distrpq caoprdistrr syl6eqr vz cv cnpi
        wcel vz cv c1o cop ceq cec c1q cplq co vz cv c1o cpli co c1o cop ceq
        cec cB cmq vz cv cnpi wcel vz cv c1o cop ceq cec c1q cplq co vz cv c1o
        cmi co c1o c1o cmi co cpli co c1o c1o cmi co cop ceq cec vz cv c1o cpli
        co c1o cop ceq cec vz cv cnpi wcel vz cv c1o cop ceq cec c1o c1o cop
        ceq cec cplq co vz cv c1o cmi co c1o c1o cmi co cpli co c1o c1o cmi co
        cop ceq cec vz cv c1o cop ceq cec c1q cplq co vz cv cnpi wcel c1o cnpi
        wcel vz cv c1o cop ceq cec c1o c1o cop ceq cec cplq co vz cv c1o cmi co
        c1o c1o cmi co cpli co c1o c1o cmi co cop ceq cec wceq 1pi vz cv cnpi
        wcel c1o cnpi wcel wa c1o cnpi wcel c1o cnpi wcel vz cv c1o cop ceq cec
        c1o c1o cop ceq cec cplq co vz cv c1o cmi co c1o c1o cmi co cpli co c1o
        c1o cmi co cop ceq cec wceq 1pi 1pi vz cv c1o c1o c1o addpipq mpanr12
        mpan2 c1q c1o c1o cop ceq cec vz cv c1o cop ceq cec cplq df-1q opreq2i
        syl5eq vz cv cnpi wcel vz cv c1o cmi co c1o c1o cmi co cpli co vz cv
        c1o cpli co wceq c1o c1o cmi co c1o wceq wa vz cv c1o cmi co c1o c1o
        cmi co cpli co c1o c1o cmi co cop vz cv c1o cpli co c1o cop wceq vz cv
        c1o cmi co c1o c1o cmi co cpli co c1o c1o cmi co cop ceq cec vz cv c1o
        cpli co c1o cop ceq cec wceq vz cv cnpi wcel vz cv c1o cmi co c1o c1o
        cmi co cpli co vz cv c1o cpli co wceq c1o c1o cmi co c1o wceq vz cv
        cnpi wcel vz cv c1o cmi co vz cv c1o c1o cmi co c1o cpli vz cv mulidpi
        c1o c1o cmi co c1o wceq vz cv cnpi wcel c1o cnpi wcel c1o c1o cmi co
        c1o wceq 1pi c1o mulidpi ax-mp a1i opreq12d c1o cnpi wcel c1o c1o cmi
        co c1o wceq 1pi c1o mulidpi ax-mp jctir vz cv c1o cmi co c1o c1o cmi co
        cpli co c1o c1o cmi co vz cv c1o cpli co c1o opeq12 vz cv c1o cmi co
        c1o c1o cmi co cpli co c1o c1o cmi co cop vz cv c1o cpli co c1o cop ceq
        eceq2 3syl eqtrd opreq1d sylan9eqr opreq2d vy cv vz cv c1o cop ceq cec
        cB cmq co cB vz cv c1o cop ceq cec cB cmq oprex prlem934a.1 addasspq
        syl5eq eleq1d biimpd sylan9r exp31 imp3a adantrd a2d indpi $.
        $( [25-Mar-1996] $)
    $}

    $( Sublemma for Lemma 9-3.4 of [Gleason] p. 122. $)
    prlem934b $p |- ( ( ( u e. N. /\ w e. N. ) /\ ( v e. N. /\ z e. N. ) )
     -> ( ( [ <. ( w .N v ) , 1o >. ] ~Q .Q [ <. z , w >. ] ~Q ) =
          [ <. v , u >. ] ~Q \/
          [ <. v , u >. ] ~Q <Q
     ( [ <. ( w .N v ) , 1o >. ] ~Q .Q [ <. z , w >. ] ~Q ) ) ) $=
      vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa
      vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv
      vu cv cop ceq cec wceq vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop
      ceq cec vz cv vw cv cop ceq cec cmq co cltq wbr wo vv cv vz cv cmi co c1o
      cop ceq cec vv cv vu cv cop ceq cec wceq vv cv vu cv cop ceq cec vv cv vz
      cv cmi co c1o cop ceq cec cltq wbr wo vu cv cnpi wcel vv cv cnpi wcel vz
      cv cnpi wcel wa vv cv vz cv cmi co c1o cop ceq cec vv cv vu cv cop ceq
      cec wceq vv cv vu cv cop ceq cec vv cv vz cv cmi co c1o cop ceq cec cltq
      wbr wo vw cv cnpi wcel vv cv cnpi wcel vu cv cnpi wcel vz cv cnpi wcel vv
      cv vz cv cmi co c1o cop ceq cec vv cv vu cv cop ceq cec wceq vv cv vu cv
      cop ceq cec vv cv vz cv cmi co c1o cop ceq cec cltq wbr wo vv cv cnpi
      wcel vu cv cnpi wcel vz cv cnpi wcel wa wa vu cv vz cv cmi co c1o wceq
      c1o vu cv vz cv cmi co clti wbr wo vv cv vz cv cmi co c1o cop ceq cec vv
      cv vu cv cop ceq cec wceq vv cv vu cv cop ceq cec vv cv vz cv cmi co c1o
      cop ceq cec cltq wbr wo vu cv cnpi wcel vz cv cnpi wcel wa vu cv vz cv
      cmi co c1o wceq c1o vu cv vz cv cmi co clti wbr wo vv cv cnpi wcel vu cv
      cnpi wcel vz cv cnpi wcel wa vu cv vz cv cmi co cnpi wcel vu cv vz cv cmi
      co c1o wceq c1o vu cv vz cv cmi co clti wbr wo vu cv vz cv mulclpi vu cv
      vz cv cmi co cnpi wcel vu cv vz cv cmi co c1o wceq c1o vu cv vz cv cmi co
      clti wbr wo vu cv vz cv cmi co c1o clti wbr wn vu cv vz cv cmi co nlt1pi
      vu cv vz cv cmi co cnpi wcel vu cv vz cv cmi co c1o clti wbr vu cv vz cv
      cmi co c1o wceq c1o vu cv vz cv cmi co clti wbr wo vu cv vz cv cmi co
      cnpi wcel c1o cnpi wcel vu cv vz cv cmi co c1o clti wbr vu cv vz cv cmi
      co c1o wceq c1o vu cv vz cv cmi co clti wbr wo wn wb 1pi cnpi clti wor vu
      cv vz cv cmi co cnpi wcel c1o cnpi wcel wa vu cv vz cv cmi co c1o clti
      wbr vu cv vz cv cmi co c1o wceq c1o vu cv vz cv cmi co clti wbr wo wn wb
      ltsopi cnpi vu cv vz cv cmi co c1o clti sotric mpan mpan2 con2bid mpbiri
      syl adantl vv cv cnpi wcel vu cv cnpi wcel vz cv cnpi wcel wa wa vu cv vz
      cv cmi co c1o wceq vv cv vz cv cmi co c1o cop ceq cec vv cv vu cv cop ceq
      cec wceq c1o vu cv vz cv cmi co clti wbr vv cv vu cv cop ceq cec vv cv vz
      cv cmi co c1o cop ceq cec cltq wbr vv cv cnpi wcel vu cv cnpi wcel vz cv
      cnpi wcel wa wa vv cv vz cv cmi co c1o cop ceq cec vv cv vu cv cop ceq
      cec wceq vv cv vz cv cmi co vu cv cmi co c1o vv cv cmi co wceq vu cv vz
      cv cmi co c1o wceq vv cv cnpi wcel vu cv cnpi wcel vz cv cnpi wcel vv cv
      vz cv cmi co c1o cop ceq cec vv cv vu cv cop ceq cec wceq vv cv vz cv cmi
      co vu cv cmi co c1o vv cv cmi co wceq wb vv cv cnpi wcel vu cv cnpi wcel
      wa vv cv vz cv cmi co cnpi wcel vv cv vz cv cmi co c1o cop ceq cec vv cv
      vu cv cop ceq cec wceq vv cv vz cv cmi co vu cv cmi co c1o vv cv cmi co
      wceq wb vv cv cnpi wcel vz cv cnpi wcel wa vv cv cnpi wcel vu cv cnpi
      wcel wa vv cv vz cv cmi co cnpi wcel c1o cnpi wcel vv cv vz cv cmi co c1o
      cop ceq cec vv cv vu cv cop ceq cec wceq vv cv vz cv cmi co vu cv cmi co
      c1o vv cv cmi co wceq wb 1pi vv cv vz cv cmi co cnpi wcel c1o cnpi wcel
      wa vv cv cnpi wcel vu cv cnpi wcel wa vv cv vz cv cmi co c1o cop ceq cec
      vv cv vu cv cop ceq cec wceq vv cv vz cv cmi co vu cv cmi co c1o vv cv
      cmi co wceq wb vv cv vz cv cmi co c1o vv cv vu cv enqeceq ancoms mpanr2
      vv cv vz cv mulclpi sylan2 anandis vu cv vz cv cmi co c1o wceq vu cv vz
      cv cmi co vv cv cmi co c1o vv cv cmi co vv cv vz cv cmi co vu cv cmi co
      vu cv vz cv cmi co c1o vv cv cmi opreq1 vf vg vh vv cv vz cv vu cv cmi vv
      visset vz visset vu visset vf cv vg cv vf visset vg visset mulcompi vf cv
      vg cv vh cv vg visset vh visset mulasspi caopr31 syl5eq syl5bir vv cv
      cnpi wcel c1o vu cv vz cv cmi co clti wbr vv cv vu cv cop ceq cec vv cv
      vz cv cmi co c1o cop ceq cec cltq wbr wi vu cv cnpi wcel vz cv cnpi wcel
      wa vv cv cnpi wcel c1o vu cv vz cv cmi co clti wbr vv cv vu cv cop ceq
      cec vv cv vz cv cmi co c1o cop ceq cec cltq wbr vv cv cnpi wcel c1o vu cv
      vz cv cmi co clti wbr vv cv c1o cmi co vv cv vu cv vz cv cmi co cmi co
      clti wbr vv cv vu cv cop ceq cec vv cv vz cv cmi co c1o cop ceq cec cltq
      wbr c1o vu cv vz cv cmi co vv cv c1o cnpi 1pi elisseti vu cv vz cv cmi
      oprex ltmpi vv cv vu cv cop ceq cec vv cv vz cv cmi co c1o cop ceq cec
      cltq wbr vv cv c1o cmi co vu cv vv cv vz cv cmi co cmi co clti wbr vv cv
      c1o cmi co vv cv vu cv vz cv cmi co cmi co clti wbr vv cv vu cv vv cv vz
      cv cmi co c1o vv visset vu visset vv cv vz cv cmi oprex c1o cnpi 1pi
      elisseti ordpipq vu cv vv cv vz cv cmi co cmi co vv cv vu cv vz cv cmi co
      cmi co vv cv c1o cmi co clti vf vg vh vu cv vv cv vz cv cmi vu visset vv
      visset vz visset vf cv vg cv vf visset vg visset mulcompi vf cv vg cv vh
      cv vg visset vh visset mulasspi caopr12 breq2i bitri syl6bbr biimpd
      adantr orim12d mpd an1s adantlr vu cv cnpi wcel vw cv cnpi wcel wa vv cv
      cnpi wcel vz cv cnpi wcel wa wa vw cv vv cv cmi co c1o cop ceq cec vz cv
      vw cv cop ceq cec cmq co vv cv vz cv cmi co c1o cop ceq cec wceq vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv vu cv cop
      ceq cec wceq vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq co cltq wbr wo vv cv vz cv cmi co c1o cop ceq
      cec vv cv vu cv cop ceq cec wceq vv cv vu cv cop ceq cec vv cv vz cv cmi
      co c1o cop ceq cec cltq wbr wo wb vw cv cnpi wcel vv cv cnpi wcel vz cv
      cnpi wcel wa vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec
      cmq co vv cv vz cv cmi co c1o cop ceq cec wceq vu cv cnpi wcel vw cv cnpi
      wcel vv cv cnpi wcel vz cv cnpi wcel wa wa vw cv vv cv cmi co c1o cop ceq
      cec vz cv vw cv cop ceq cec cmq co vw cv vv cv cmi co vz cv cmi co c1o vw
      cv cmi co cop ceq cec vv cv vz cv cmi co c1o cop ceq cec vw cv cnpi wcel
      vv cv cnpi wcel vz cv cnpi wcel wa vw cv vv cv cmi co c1o cop ceq cec vz
      cv vw cv cop ceq cec cmq co vw cv vv cv cmi co vz cv cmi co c1o vw cv cmi
      co cop ceq cec wceq vw cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz
      cv cnpi wcel wa wa vw cv cnpi wcel vv cv cnpi wcel wa vz cv cnpi wcel vw
      cv cnpi wcel wa wa vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq
      cec cmq co vw cv vv cv cmi co vz cv cmi co c1o vw cv cmi co cop ceq cec
      wceq vw cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel vz cv cnpi wcel an42
      vw cv vv cv cmi co cnpi wcel vz cv cnpi wcel vw cv cnpi wcel wa vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw cv vv cv cmi
      co vz cv cmi co c1o vw cv cmi co cop ceq cec wceq vw cv cnpi wcel vv cv
      cnpi wcel wa vw cv vv cv cmi co cnpi wcel c1o cnpi wcel vz cv cnpi wcel
      vw cv cnpi wcel wa vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq
      cec cmq co vw cv vv cv cmi co vz cv cmi co c1o vw cv cmi co cop ceq cec
      wceq 1pi vw cv vv cv cmi co c1o vz cv vw cv mulpipq mpanl2 vw cv vv cv
      mulclpi sylan sylbi anabsan vw cv cnpi wcel vv cv cnpi wcel vz cv cnpi
      wcel wa wa vw cv vv cv vz cv cmi co cmi co vw cv c1o cmi co cop ceq cec
      vv cv vz cv cmi co c1o cop ceq cec vw cv vv cv cmi co vz cv cmi co c1o vw
      cv cmi co cop ceq cec vw cv cnpi wcel vv cv vz cv cmi co cnpi wcel vw cv
      vv cv vz cv cmi co cmi co vw cv c1o cmi co cop ceq cec vv cv vz cv cmi co
      c1o cop ceq cec wceq vv cv cnpi wcel vz cv cnpi wcel wa vw cv cnpi wcel
      vv cv vz cv cmi co cnpi wcel c1o cnpi wcel vw cv vv cv vz cv cmi co cmi
      co vw cv c1o cmi co cop ceq cec vv cv vz cv cmi co c1o cop ceq cec wceq
      1pi vw cv vv cv vz cv cmi co c1o vw visset vv cv vz cv cmi oprex c1o cnpi
      1pi elisseti distrpqlem mp3an3 vv cv vz cv mulclpi sylan2 vw cv vv cv cmi
      co vz cv cmi co c1o vw cv cmi co cop vw cv vv cv vz cv cmi co cmi co vw
      cv c1o cmi co cop wceq vw cv vv cv cmi co vz cv cmi co c1o vw cv cmi co
      cop ceq cec vw cv vv cv vz cv cmi co cmi co vw cv c1o cmi co cop ceq cec
      wceq vw cv vv cv cmi co vz cv cmi co vw cv vv cv vz cv cmi co cmi co c1o
      vw cv cmi co vw cv c1o cmi co vw cv vv cv vz cv vv visset vz visset
      mulasspi c1o vw cv c1o cnpi 1pi elisseti vw visset mulcompi opeq12i vw cv
      vv cv cmi co vz cv cmi co c1o vw cv cmi co cop vw cv vv cv vz cv cmi co
      cmi co vw cv c1o cmi co cop ceq eceq2 ax-mp syl5eq eqtrd adantll vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv vz cv cmi
      co c1o cop ceq cec wceq vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv
      cop ceq cec cmq co vv cv vu cv cop ceq cec wceq vv cv vz cv cmi co c1o
      cop ceq cec vv cv vu cv cop ceq cec wceq vv cv vu cv cop ceq cec vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cltq wbr vv cv
      vu cv cop ceq cec vv cv vz cv cmi co c1o cop ceq cec cltq wbr vw cv vv cv
      cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv vz cv cmi co
      c1o cop ceq cec vv cv vu cv cop ceq cec eqeq1 vw cv vv cv cmi co c1o cop
      ceq cec vz cv vw cv cop ceq cec cmq co vv cv vz cv cmi co c1o cop ceq cec
      vv cv vu cv cop ceq cec cltq breq2 orbi12d syl mpbird $.
      $( [25-Mar-1996] $)

    $( Lemma 9-3.4 of [Gleason] p. 122. $)
    prlem934 $p |- ( ( A e. P. /\ B e. Q. ) ->
                   E. x ( x e. A /\ -. ( x +Q B ) e. A ) ) $=
      cB cnq wcel cA cnp wcel vx cv cA wcel vx cv cB cplq co cA wcel wn wa vx
      wex cB cnq wcel cA cnp wcel wa vx cv cA wcel vx cv cB cplq co cA wcel wi
      vx wal wn vx cv cA wcel vx cv cB cplq co cA wcel wn wa vx wex cB cnq wcel
      cA cnp wcel wa vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal cnq cA
      wss cA cnp wcel cnq cA wss wn cB cnq wcel cA cnp wcel cA cnq wss cnq cA
      wss wn cA cnp wcel cA cnq wpss cA cnq wss cnq cA wss wn wa cA prpssnq cA
      cnq dfpss3 sylib pm3.27d adantl cB cnq wcel cA cnp wcel wa vx cv cA wcel
      vx cv cB cplq co cA wcel wi vx wal vy cv cnq wcel vy cv cA wcel wi vy wal
      cnq cA wss cB cnq wcel cA cnp wcel wa vx cv cA wcel vx cv cB cplq co cA
      wcel wi vx wal vy cv cnq wcel vy cv cA wcel wi vy cB cnq wcel cA cnp wcel
      vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal vy cv cnq wcel vy cv cA
      wcel wi wi vy cv cnq wcel cB cnq wcel cA cnp wcel vx cv cA wcel vx cv cB
      cplq co cA wcel wi vx wal vy cv cA wcel vy cv cnq wcel cB cnq wcel cA cnp
      wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal vy cv cA wcel wi wi
      cA cnp wcel vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel
      wi vx wal vv cv vu cv cop ceq cec cA wcel wi wi cA cnp wcel vx cv cA wcel
      vx cv vz cv vw cv cop ceq cec cplq co cA wcel wi vx wal vy cv cA wcel wi
      wi cA cnp wcel vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal vy cv cA
      wcel wi wi vv vu vz vw vy cv cB cnpi cnpi ceq cnq df-nq vv cv vu cv cop
      ceq cec vy cv wceq vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA
      wcel wi vx wal vv cv vu cv cop ceq cec cA wcel wi vx cv cA wcel vx cv vz
      cv vw cv cop ceq cec cplq co cA wcel wi vx wal vy cv cA wcel wi cA cnp
      wcel vv cv vu cv cop ceq cec vy cv wceq vv cv vu cv cop ceq cec cA wcel
      vy cv cA wcel vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel
      wi vx wal vv cv vu cv cop ceq cec vy cv cA eleq1 imbi2d imbi2d vz cv vw
      cv cop ceq cec cB wceq vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq
      co cA wcel wi vx wal vy cv cA wcel wi vx cv cA wcel vx cv cB cplq co cA
      wcel wi vx wal vy cv cA wcel wi cA cnp wcel vz cv vw cv cop ceq cec cB
      wceq vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel wi vx
      wal vx cv cA wcel vx cv cB cplq co cA wcel wi vx wal vy cv cA wcel vz cv
      vw cv cop ceq cec cB wceq vx cv cA wcel vx cv vz cv vw cv cop ceq cec
      cplq co cA wcel wi vx cv cA wcel vx cv cB cplq co cA wcel wi vx vz cv vw
      cv cop ceq cec cB wceq vx cv vz cv vw cv cop ceq cec cplq co cA wcel vx
      cv cB cplq co cA wcel vx cv cA wcel vz cv vw cv cop ceq cec cB wceq vx cv
      vz cv vw cv cop ceq cec cplq co vx cv cB cplq co cA vz cv vw cv cop ceq
      cec cB vx cv cplq opreq2 eleq1d imbi2d albidv imbi1d imbi2d vv cv cnpi
      wcel vz cv cnpi wcel vu cv cnpi wcel vw cv cnpi wcel cA cnp wcel vx cv cA
      wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel wi vx wal vv cv vu cv
      cop ceq cec cA wcel wi wi vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi
      wcel vz cv cnpi wcel wa cA cnp wcel vx cv cA wcel vx cv vz cv vw cv cop
      ceq cec cplq co cA wcel wi vx wal vv cv vu cv cop ceq cec cA wcel wi wi
      vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa
      cA cnp wcel vy cv cA wcel wa vy wex vx cv cA wcel vx cv vz cv vw cv cop
      ceq cec cplq co cA wcel wi vx wal vv cv vu cv cop ceq cec cA wcel wi cA
      cnp wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi
      wcel wa wa cA cnp wcel vy cv cA wcel wa vx cv cA wcel vx cv vz cv vw cv
      cop ceq cec cplq co cA wcel wi vx wal vv cv vu cv cop ceq cec cA wcel wi
      vy vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa
      wa cA cnp wcel vy cv cA wcel wa vx cv cA wcel vx cv vz cv vw cv cop ceq
      cec cplq co cA wcel wi vx wal vy cv vw cv vv cv cmi co c1o cop ceq cec vz
      cv vw cv cop ceq cec cmq co cplq co cA wcel vv cv vu cv cop ceq cec cA
      wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel
      wa wa vy cv cA wcel vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co
      cA wcel wi vx wal vy cv vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv
      cop ceq cec cmq co cplq co cA wcel wi cA cnp wcel vu cv cnpi wcel vw cv
      cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa vx cv cA wcel vx cv vz
      cv vw cv cop ceq cec cplq co cA wcel wi vx wal vy cv cA wcel vy cv vw cv
      vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA
      wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel
      wa wa vw cv cnpi wcel vv cv cnpi wcel wa vz cv cnpi wcel vw cv cnpi wcel
      wa wa vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel wi vx
      wal vy cv cA wcel vy cv vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv
      cop ceq cec cmq co cplq co cA wcel wi wi vu cv cnpi wcel vw cv cnpi wcel
      wa vv cv cnpi wcel vz cv cnpi wcel wa wa vw cv cnpi wcel vw cv cnpi wcel
      wa vv cv cnpi wcel vz cv cnpi wcel wa wa vw cv cnpi wcel vv cv cnpi wcel
      wa vz cv cnpi wcel vw cv cnpi wcel wa wa vu cv cnpi wcel vw cv cnpi wcel
      wa vw cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa
      vu cv cnpi wcel vw cv cnpi wcel wa vw cv cnpi wcel vw cv cnpi wcel vu cv
      cnpi wcel vw cv cnpi wcel pm3.27 vu cv cnpi wcel vw cv cnpi wcel pm3.27
      jca anim1i vw cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel vz cv cnpi
      wcel an42 sylib vw cv cnpi wcel vv cv cnpi wcel wa vz cv cnpi wcel vw cv
      cnpi wcel wa vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel
      wi vx wal vy cv cA wcel vy cv vw cv vv cv cmi co c1o cop ceq cec vz cv vw
      cv cop ceq cec cmq co cplq co cA wcel wi wi vw cv cnpi wcel vv cv cnpi
      wcel wa vw cv vv cv cmi co cnpi wcel vz cv cnpi wcel vw cv cnpi wcel wa
      vx cv cA wcel vx cv vz cv vw cv cop ceq cec cplq co cA wcel wi vx wal vy
      cv cA wcel vy cv vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq
      cec cmq co cplq co cA wcel wi wi wi vw cv vv cv mulclpi vw cv vv cv cmi
      co cnpi wcel vz cv vw cv cop ceq cec cnq wcel vx cv cA wcel vx cv vz cv
      vw cv cop ceq cec cplq co cA wcel wi vx wal vy cv cA wcel vy cv vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA wcel
      wi wi vz cv cnpi wcel vw cv cnpi wcel wa vw cv vv cv cmi co cnpi wcel vz
      cv vw cv cop ceq cec cnq wcel vx cv cA wcel vx cv vz cv vw cv cop ceq cec
      cplq co cA wcel wi vx wal vy cv cA wcel vy cv vw cv vv cv cmi co c1o cop
      ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA wcel vx vy cA vz cv vw
      cv cop ceq cec vw cv vv cv cmi co ceq cvv wcel vz cv vw cv cop ceq cec
      cvv wcel enqex vz cv vw cv cop cvv ceq ecexg ax-mp prlem934a exp4c cnpi
      vz cv vw cv ceq cnq enqex df-nq ecopqsi syl5 syl imp syl com23 adantld cA
      cnp wcel vy cv cA wcel wa vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi
      wcel vz cv cnpi wcel wa wa vy cv vw cv vv cv cmi co c1o cop ceq cec vz cv
      vw cv cop ceq cec cmq co cplq co cA wcel vv cv vu cv cop ceq cec cA wcel
      wi cA cnp wcel vy cv cA wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv
      cnpi wcel vz cv cnpi wcel wa wa vy cv vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq co cplq co cA wcel vv cv vu cv cop ceq cec cA
      wcel wi wi cA cnp wcel vy cv cnq wcel vu cv cnpi wcel vw cv cnpi wcel wa
      vv cv cnpi wcel vz cv cnpi wcel wa wa vy cv vw cv vv cv cmi co c1o cop
      ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA wcel vv cv vu cv cop
      ceq cec cA wcel wi wi cA cnp wcel vy cv cA wcel wa cA cnp wcel vy cv vw
      cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA
      wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel
      wa wa vy cv cnq wcel vv cv vu cv cop ceq cec cA wcel cA cnp wcel vy cv vw
      cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA
      wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel
      wa wa vy cv cnq wcel vv cv vu cv cop ceq cec cA wcel cA cnp wcel vy cv vw
      cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cplq co cA
      wcel wa vv cv vu cv cop ceq cec vy cv vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq co cplq co cltq wbr vv cv vu cv cop ceq cec
      cA wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi
      wcel wa wa vy cv cnq wcel wa cA vy cv vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq co cplq co vv cv vu cv cop ceq cec prcdpq vu
      cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa vy
      cv cnq wcel wa vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq co vy cv cplq co vy cv vw cv vv cv cmi co c1o
      cop ceq cec vz cv vw cv cop ceq cec cmq co cplq co cltq vu cv cnpi wcel
      vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa vy cv cnq wcel
      wa vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw
      cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq
      co cltq wbr vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec vz
      cv vw cv cop ceq cec cmq co vy cv cplq co cltq wbr vw cv vv cv cmi co c1o
      cop ceq cec vz cv vw cv cop ceq cec cmq co cnq wcel vy cv cnq wcel vw cv
      vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw cv vv cv
      cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq co cltq
      wbr vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa
      wa vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy
      cv vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq oprex
      vy visset ltaddpq vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi wcel vz
      cv cnpi wcel wa wa vw cv cnpi wcel vv cv cnpi wcel wa vz cv cnpi wcel vw
      cv cnpi wcel wa wa vw cv vv cv cmi co c1o cop ceq cec cnq wcel vz cv vw
      cv cop ceq cec cnq wcel wa vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv
      cop ceq cec cmq co cnq wcel vu cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi
      wcel vz cv cnpi wcel wa wa vw cv cnpi wcel vw cv cnpi wcel wa vv cv cnpi
      wcel vz cv cnpi wcel wa wa vw cv cnpi wcel vv cv cnpi wcel wa vz cv cnpi
      wcel vw cv cnpi wcel wa wa vu cv cnpi wcel vw cv cnpi wcel wa vw cv cnpi
      wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa vu cv cnpi
      wcel vw cv cnpi wcel wa vw cv cnpi wcel vw cv cnpi wcel vu cv cnpi wcel
      vw cv cnpi wcel pm3.27 vu cv cnpi wcel vw cv cnpi wcel pm3.27 jca anim1i
      vw cv cnpi wcel vw cv cnpi wcel vv cv cnpi wcel vz cv cnpi wcel an42
      sylib vw cv cnpi wcel vv cv cnpi wcel wa vw cv vv cv cmi co c1o cop ceq
      cec cnq wcel vz cv cnpi wcel vw cv cnpi wcel wa vz cv vw cv cop ceq cec
      cnq wcel vw cv vv cv cmi co cnpi wcel c1o cnpi wcel vw cv vv cv cmi co
      c1o cop ceq cec cnq wcel vw cv cnpi wcel vv cv cnpi wcel wa cnpi vw cv vv
      cv cmi co c1o ceq cnq enqex df-nq ecopqsi vw cv vv cv mulclpi 1pi sylancl
      cnpi vz cv vw cv ceq cnq enqex df-nq ecopqsi anim12i vw cv vv cv cmi co
      c1o cop ceq cec vz cv vw cv cop ceq cec mulclpq 3syl sylan vu cv cnpi
      wcel vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa vw cv vv cv
      cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw cv vv cv cmi co
      c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq co cltq wbr vv
      cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop
      ceq cec cmq co vy cv cplq co cltq wbr wi vy cv cnq wcel vu cv cnpi wcel
      vw cv cnpi wcel wa vv cv cnpi wcel vz cv cnpi wcel wa wa vw cv vv cv cmi
      co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv vu cv cop ceq cec
      wceq vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec vz cv vw
      cv cop ceq cec cmq co cltq wbr wo vw cv vv cv cmi co c1o cop ceq cec vz
      cv vw cv cop ceq cec cmq co vw cv vv cv cmi co c1o cop ceq cec vz cv vw
      cv cop ceq cec cmq co vy cv cplq co cltq wbr vv cv vu cv cop ceq cec vw
      cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq
      co cltq wbr wi vz vw vv vu prlem934b vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq co vv cv vu cv cop ceq cec wceq vw cv vv cv
      cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw cv vv cv cmi co
      c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq co cltq wbr vv
      cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop
      ceq cec cmq co vy cv cplq co cltq wbr wi vv cv vu cv cop ceq cec vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cltq wbr vw cv
      vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv vu cv
      cop ceq cec wceq vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq
      cec cmq co vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq
      co vy cv cplq co cltq wbr vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o
      cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq co cltq wbr vw cv
      vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vv cv vu cv
      cop ceq cec vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec
      cmq co vy cv cplq co cltq breq1 biimpd vv cv vu cv cop ceq cec vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co cltq wbr vw cv
      vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw cv vv cv
      cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq co cltq
      wbr vv cv vu cv cop ceq cec vw cv vv cv cmi co c1o cop ceq cec vz cv vw
      cv cop ceq cec cmq co vy cv cplq co cltq wbr vv cv vu cv cop ceq cec vw
      cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vw cv vv
      cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv cplq co
      cltq cnq ceq cvv wcel vv cv vu cv cop ceq cec cvv wcel enqex vv cv vu cv
      cop cvv ceq ecexg ax-mp ltsopq ltrelpq vw cv vv cv cmi co c1o cop ceq cec
      vz cv vw cv cop ceq cec cmq oprex vw cv vv cv cmi co c1o cop ceq cec vz
      cv vw cv cop ceq cec cmq co vy cv cplq oprex sotri ex jaoi syl adantr mpd
      vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq co vy cv
      vw cv vv cv cmi co c1o cop ceq cec vz cv vw cv cop ceq cec cmq oprex vy
      visset addcompq syl6breq syl5 exp4b com24 cA vy cv elprpq syl5 anabsi5
      com12 syldd 19.23adv cA cnp wcel cA cnp wcel vy cv cA wcel vy wex wa cA
      cnp wcel vy cv cA wcel wa vy wex cA cnp wcel vy cv cA wcel vy wex cA cnp
      wcel cA c0 wne vy cv cA wcel vy wex cA prn0 vy cA n0 sylib ancli cA cnp
      wcel vy cv cA wcel vy 19.42v sylibr syl5 ancoms an4s 2ecoptocl ex com4l
      imp 19.21adv vy cnq cA dfss2 syl6ibr mtod vx cv cA wcel vx cv cB cplq co
      cA wcel vx exanali sylibr ancoms $.
      $( [25-Mar-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    $( The sum of two positive reals is greater than one of them.  Proposition
       9-3.5(iii) of [Gleason] p. 123. $)
    ltaddpr $p |- ( ( A e. P. /\ B e. P. ) -> A <P ( A +P. B ) ) $=
      cA cnp wcel cB cnp wcel wa cA cA cB cpp co cltp wbr cA cA cB cpp co wpss
      cA cnp wcel cB cnp wcel wa vy cv cB wcel vy wex cA cA cB cpp co wpss cB
      cnp wcel vy cv cB wcel vy wex cA cnp wcel cB cnp wcel cB c0 wne vy cv cB
      wcel vy wex cB prn0 vy cB n0 sylib adantl cA cnp wcel cB cnp wcel wa vy
      cv cB wcel cA cA cB cpp co wpss vy cA cnp wcel cB cnp wcel wa vy cv cB
      wcel cA cA cB cpp co wss cA cA cB cpp co wceq wn wa cA cA cB cpp co wpss
      cA cnp wcel cB cnp wcel wa vy cv cB wcel cA cA cB cpp co wss cA cA cB cpp
      co wceq wn cA cnp wcel cB cnp wcel wa vy cv cB wcel vx cv cA wcel vx cv
      cA cB cpp co wcel wi vx wal cA cA cB cpp co wss cA cnp wcel cB cnp wcel
      wa vy cv cB wcel vx cv cA wcel vx cv cA cB cpp co wcel wi vx cA cnp wcel
      cB cnp wcel wa vx cv cA wcel vy cv cB wcel vx cv cA cB cpp co wcel cA cnp
      wcel cB cnp wcel wa vx cv cA wcel vy cv cB wcel vx cv cA cB cpp co wcel
      cA cB cpp co cnp wcel vx cv vy cv cplq co cA cB cpp co wcel vx cv cA cB
      cpp co wcel cA cnp wcel cB cnp wcel wa vx cv cA wcel vy cv cB wcel wa wa
      cA cB cpp co cnp wcel vx cv vy cv cplq co cA cB cpp co wcel wa vx cv vx
      cv vy cv cplq co cltq wbr vx cv cA cB cpp co wcel cA cB cpp co cnp wcel
      vx cv vy cv cplq co cA cB cpp co wcel wa vx cv vy cv cplq co cnq wcel vx
      cv cnq wcel vy cv cnq wcel wa vx cv vx cv vy cv cplq co cltq wbr cA cB
      cpp co vx cv vy cv cplq co elprpq vx cv vy cv cnq cplq vy visset dmaddpq
      0npq ndmoprrcl vx cv vy cv vx visset vy visset ltaddpq 3syl cA cB cpp co
      vx cv vy cv cplq co vx cv prcdpq mpd cA cnp wcel cB cnp wcel wa cA cB cpp
      co cnp wcel vx cv cA wcel vy cv cB wcel wa cA cB addclpr adantr cA cnp
      wcel cB cnp wcel wa vx cv cA wcel vy cv cB wcel wa vx cv vy cv cplq co cA
      cB cpp co wcel vx vy vz vw vv vu cA cB vx cv vy cv cpp cplq vw vv vu vx
      vy vz df-plp genpprecl imp sylanc exp32 com23 19.21adv vx cA cA cB cpp co
      dfss2 syl6ibr cA cnp wcel cB cnp wcel wa vy cv cB wcel cA cA cB cpp co
      wceq wn cA cnp wcel cB cnp wcel wa vy cv cB wcel vy cv cB wcel cA cA cB
      cpp co wceq wn wi wi cA cnp wcel cB cnp wcel wa cA cnp wcel cB cnp wcel
      vy cv cB wcel vy cv cB wcel cA cA cB cpp co wceq wn wi wi cA cnp wcel cB
      cnp wcel wa cA cnp wcel cB cnp wcel vy cv cB wcel vy cv cB wcel cA cA cB
      cpp co wceq wn wi cA cnp wcel cB cnp wcel wa cA cnp wcel vy cv cnq wcel
      vy cv cB wcel cA cA cB cpp co wceq wn wi cB cnp wcel vy cv cB wcel wa cA
      cnp wcel cB cnp wcel wa vx cv cA wcel vx cv vy cv cplq co cA wcel wn wa
      vx wex vy cv cB wcel cA cA cB cpp co wceq wn wi cA cnp wcel vy cv cnq
      wcel wa cA cnp wcel cB cnp wcel wa vx cv cA wcel vx cv vy cv cplq co cA
      wcel wn wa vy cv cB wcel cA cA cB cpp co wceq wn wi vx cA cnp wcel cB cnp
      wcel wa vx cv cA wcel vx cv vy cv cplq co cA wcel wn vy cv cB wcel cA cA
      cB cpp co wceq wn wi cA cnp wcel cB cnp wcel wa vx cv cA wcel vy cv cB
      wcel vx cv vy cv cplq co cA wcel wn cA cA cB cpp co wceq wn cA cnp wcel
      cB cnp wcel wa vx cv cA wcel vy cv cB wcel vx cv vy cv cplq co cA wcel wn
      cA cA cB cpp co wceq wn wi cA cnp wcel cB cnp wcel wa vx cv cA wcel vy cv
      cB wcel wa vx cv vy cv cplq co cA cB cpp co wcel vx cv vy cv cplq co cA
      wcel wn cA cA cB cpp co wceq wn wi vx vy vz vw vv vu cA cB vx cv vy cv
      cpp cplq vw vv vu vx vy vz df-plp genpprecl vx cv vy cv cplq co cA cB cpp
      co wcel cA cA cB cpp co wceq vx cv vy cv cplq co cA wcel cA cA cB cpp co
      wceq vx cv vy cv cplq co cA wcel vx cv vy cv cplq co cA cB cpp co wcel cA
      cA cB cpp co vx cv vy cv cplq co eleq2 biimprcd con3d syl6 exp3a com34
      imp3a 19.23adv vx cA vy cv prlem934 syl5 cB vy cv elprpq sylan2i exp4d
      imp3a pm2.43i pm2.43d jcad cA cA cB cpp co dfpss2 syl6ibr 19.23adv mpd cA
      cnp wcel cB cnp wcel cA cB cpp co cnp wcel cA cA cB cpp co cltp wbr cA cA
      cB cpp co wpss wb cA cB addclpr cA cA cB cpp co ltprord syldan mpbird $.
      $( [26-Mar-1996] $)
  $}

  ${
    ltaddpr2.1 $e |- B e. _V $.
    $( The sum of two positive reals is greater than one of them. $)
    ltaddpr2 $p |- ( C e. P. -> ( ( A +P. B ) = C -> A <P C ) ) $=
      cA cB cpp co cC wceq cC cnp wcel cA cC cltp wbr cA cB cpp co cC wceq cC
      cnp wcel cA cnp wcel cB cnp wcel wa cA cC cltp wbr cA cB cpp co cC wceq
      cC cnp wcel cA cB cpp co cnp wcel cA cnp wcel cB cnp wcel wa cA cB cpp co
      cC cnp eleq1 cA cB cnp cpp ltaddpr2.1 dmplp 0npr ndmoprrcl syl6bir cA cB
      cpp co cC wceq cA cA cB cpp co cltp wbr cA cC cltp wbr cA cnp wcel cB cnp
      wcel wa cA cB cpp co cC cA cltp breq2 cA cB ltaddpr syl5bi syld com12 $.
      $( [13-May-1996] $)
  $}

  ${
    $d x y z w v f g h A $.  $d x y z w v B $.  $d x z w v f g h C $.
    $d x y z w v u f g h $.
    ltexprlem.1 $e |- C = { x | E. y ( -. y e. A /\ ( y +Q x ) e. B ) } $.
    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem1 $p |- ( B e. P. -> ( A C. B -> C =/= (/) ) ) $=
      cB cnp wcel cA cB wpss vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vx
      wex vy wex cC c0 wne cB cnp wcel vy cv cB wcel vy cv cA wcel wn wa vy wex
      vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vx wex vy wex cA cB wpss
      cB cnp wcel vy cv cB wcel vy cv cA wcel wn wa vy cv cA wcel wn vy cv vx
      cv cplq co cB wcel wa vx wex vy cB cnp wcel vy cv cB wcel vy cv cA wcel
      wn vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vx wex vy cv cA wcel
      wn cB cnp wcel vy cv cB wcel vy cv cA wcel wn vy cv vx cv cplq co cB wcel
      wa vx wex vy cv cA wcel wn cB cnp wcel vy cv cB wcel vy cv cA wcel wn vy
      cv vx cv cplq co cB wcel wa vx wex vy cv cA wcel wn cB cnp wcel vy cv cB
      wcel wa wa vy cv cA wcel wn vy cv vx cv cplq co cB wcel vx wex wa vy cv
      cA wcel wn vy cv vx cv cplq co cB wcel wa vx wex cB cnp wcel vy cv cB
      wcel wa vy cv vx cv cplq co cB wcel vx wex vy cv cA wcel wn vx cB vy cv
      vy visset prnmadd anim2i vy cv cA wcel wn vy cv vx cv cplq co cB wcel vx
      19.42v sylibr exp32 com3l imp3a 19.22dv vy cA cB pssnel syl5 vx cv cC
      wcel vx wex vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vx wex
      cC c0 wne vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vx wex vy wex
      vx cv cC wcel vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vx
      vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vx cC ltexprlem.1
      abeq2i exbii vx cC n0 vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy
      vx excom 3bitr4i syl6ibr $.
      $( [18-Apr-2007] $) $( [3-Apr-1996] $)

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem2 $p |- ( B e. P. -> C C. Q. ) $=
      cC cB wss cB cnq wpss cC cnq wpss cB cnp wcel cC cB cnq sspsstr cB cnp
      wcel vx cC cB cB cnp wcel vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa
      vy wex vx cv cB wcel vx cv cC wcel cB cnp wcel vy cv cA wcel wn vy cv vx
      cv cplq co cB wcel wa vx cv cB wcel vy cB cnp wcel vy cv vx cv cplq co cB
      wcel vx cv cB wcel vy cv cA wcel wn cB cnp wcel vy cv vx cv cplq co cB
      wcel vx cv cB wcel cB cnp wcel vy cv vx cv cplq co cB wcel wa vy cv cnq
      wcel vx cv cnq wcel wa vx cv cB wcel cB cnp wcel vy cv vx cv cplq co cB
      wcel wa vy cv vx cv cplq co cnq wcel vy cv cnq wcel vx cv cnq wcel wa cB
      vy cv vx cv cplq co elprpq vy cv vx cv cnq cplq vx visset dmaddpq 0npq
      ndmoprrcl syl cB cnp wcel vy cv vx cv cplq co cB wcel wa vx cv vy cv vx
      cv cplq co cltq wbr vx cv cB wcel vy cv cnq wcel vx cv cnq wcel wa cB vy
      cv vx cv cplq co vx cv prcdpq vy cv cnq wcel vx cv cnq wcel wa vx cv vx
      cv vy cv cplq co vy cv vx cv cplq co cltq vx cv cnq wcel vy cv cnq wcel
      vx cv vx cv vy cv cplq co cltq wbr vx cv vy cv vx visset vy visset
      ltaddpq ancoms vx cv vy cv vx visset vy visset addcompq syl6breq syl5 mpd
      ex adantld 19.23adv vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy
      wex vx cC ltexprlem.1 abeq2i syl5ib ssrdv cB prpssnq sylanc $.
      $( [3-Apr-1996] $)

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem3 $p |- ( B e. P. ->
                  ( x e. C -> A. z ( z <Q x -> z e. C ) ) ) $=
      cB cnp wcel vx cv cC wcel vz cv vx cv cltq wbr vz cv cC wcel wi vz cB cnp
      wcel vz cv vx cv cltq wbr vx cv cC wcel vz cv cC wcel cB cnp wcel vz cv
      vx cv cltq wbr vx cv cC wcel vz cv cC wcel wi cB cnp wcel vz cv vx cv
      cltq wbr wa vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vy cv
      cA wcel wn vy cv vz cv cplq co cB wcel wa vy wex vx cv cC wcel vz cv cC
      wcel cB cnp wcel vz cv vx cv cltq wbr wa vy cv cA wcel wn vy cv vx cv
      cplq co cB wcel wa vy cv cA wcel wn vy cv vz cv cplq co cB wcel wa vy cB
      cnp wcel vz cv vx cv cltq wbr wa vy cv vx cv cplq co cB wcel vy cv vz cv
      cplq co cB wcel vy cv cA wcel wn cB cnp wcel vz cv vx cv cltq wbr vy cv
      vx cv cplq co cB wcel vy cv vz cv cplq co cB wcel wi cB cnp wcel vy cv vx
      cv cplq co cB wcel vz cv vx cv cltq wbr vy cv vz cv cplq co cB wcel cB
      cnp wcel vy cv vx cv cplq co cB wcel vz cv vx cv cltq wbr vy cv vz cv
      cplq co cB wcel wi cB cnp wcel vy cv vx cv cplq co cB wcel wa vz cv vx cv
      cltq wbr vy cv vz cv cplq co vy cv vx cv cplq co cltq wbr vy cv vz cv
      cplq co cB wcel cB cnp wcel vy cv vx cv cplq co cB wcel wa vy cv vx cv
      cplq co cnq wcel vy cv cnq wcel vz cv vx cv cltq wbr vy cv vz cv cplq co
      vy cv vx cv cplq co cltq wbr wb cB vy cv vx cv cplq co elprpq vy cv vx cv
      cplq co cnq wcel vy cv cnq wcel vx cv cnq wcel vy cv vx cv cnq cplq vx
      visset dmaddpq 0npq ndmoprrcl pm3.26d vz cv vx cv vy cv vz visset vx
      visset ltapq 3syl cB vy cv vx cv cplq co vy cv vz cv cplq co prcdpq
      sylbid ex com23 imp anim2d 19.22dv vy cv cA wcel wn vy cv vx cv cplq co
      cB wcel wa vy wex vx cC ltexprlem.1 abeq2i vy cv cA wcel wn vy cv vx cv
      cplq co cB wcel wa vy wex vy cv cA wcel wn vy cv vz cv cplq co cB wcel wa
      vy wex vx vz cv cC vz visset vx cv vz cv wceq vy cv cA wcel wn vy cv vx
      cv cplq co cB wcel wa vy cv cA wcel wn vy cv vz cv cplq co cB wcel wa vy
      vx cv vz cv wceq vy cv vx cv cplq co cB wcel vy cv vz cv cplq co cB wcel
      vy cv cA wcel wn vx cv vz cv wceq vy cv vx cv cplq co vy cv vz cv cplq co
      cB vx cv vz cv vy cv cplq opreq2 eleq1d anbi2d exbidv ltexprlem.1 elab2
      3imtr4g ex com23 19.21adv $.
      $( [6-Apr-1996] $)

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem4 $p |- ( B e. P. ->
                  ( x e. C -> E. z ( z e. C /\ x <Q z ) ) ) $=
      cB cnp wcel vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vy cv
      cA wcel wn vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vz wex
      vy wex vx cv cC wcel vz cv cC wcel vx cv vz cv cltq wbr wa vz wex cB cnp
      wcel vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy cv cA wcel wn vy
      cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vz wex vy cB cnp wcel
      vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy cv cA wcel wn vy cv vz
      cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vz wex cB cnp wcel vy cv cA
      wcel wn vy cv vx cv cplq co cB wcel wa wa vy cv cA wcel wn vy cv vz cv
      cplq co cB wcel vx cv vz cv cltq wbr wa vz wex wa vy cv cA wcel wn vy cv
      vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vz wex vy cv cA wcel wn
      cB cnp wcel vy cv vx cv cplq co cB wcel vy cv cA wcel wn vy cv vz cv cplq
      co cB wcel vx cv vz cv cltq wbr wa vz wex wa cB cnp wcel vy cv vx cv cplq
      co cB wcel wa vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa vz wex
      vy cv cA wcel wn cB cnp wcel vy cv vx cv cplq co cB wcel wa vw cv cB wcel
      vy cv vx cv cplq co vw cv cltq wbr wa vw wex vw cv vy cv vz cv cplq co
      wceq vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa wa vw wex vz wex
      vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa vz wex vw cB vy cv vx
      cv cplq co prnmax vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa vw
      wex vw cv vy cv vz cv cplq co wceq vw cv cB wcel vy cv vx cv cplq co vw
      cv cltq wbr wa wa vz wex vw wex vw cv vy cv vz cv cplq co wceq vw cv cB
      wcel vy cv vx cv cplq co vw cv cltq wbr wa wa vw wex vz wex vw cv cB wcel
      vy cv vx cv cplq co vw cv cltq wbr wa vw cv vy cv vz cv cplq co wceq vw
      cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa wa vz wex vw vw cv cB
      wcel vy cv vx cv cplq co vw cv cltq wbr wa vw cv vy cv vz cv cplq co wceq
      vz wex vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa wa vw cv vy cv
      vz cv cplq co wceq vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa wa
      vz wex vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa vw cv cB wcel
      vw cv vy cv vz cv cplq co wceq vz wex vy cv vx cv cplq co vw cv cltq wbr
      wa wa vw cv vy cv vz cv cplq co wceq vz wex vw cv cB wcel vy cv vx cv
      cplq co vw cv cltq wbr wa wa vy cv vx cv cplq co vw cv cltq wbr vw cv vy
      cv vz cv cplq co wceq vz wex vy cv vx cv cplq co vw cv cltq wbr wa vw cv
      cB wcel vy cv vx cv cplq co vw cv cltq wbr vw cv vy cv vz cv cplq co wceq
      vz wex vy cv vx cv cplq co vw cv cltq wbr vy cv vz cv cplq co vw cv wceq
      vz wex vw cv vy cv vz cv cplq co wceq vz wex vy cv vx cv cplq co vw cv
      cltq wbr vy cv vw cv cltq wbr vy cv vz cv cplq co vw cv wceq vz wex vy cv
      cnq wcel vx cv cnq wcel wa vy cv vx cv cplq co vw cv cltq wbr vy cv vw cv
      cltq wbr vy cv vx cv cplq co vw cv cltq wbr vy cv vx cv cplq co cnq wcel
      vy cv cnq wcel vx cv cnq wcel wa vy cv vx cv cplq co vw cv cltq wbr vy cv
      vx cv cplq co cnq wcel vw cv cnq wcel vy cv vx cv cplq co vw cv cnq cnq
      cltq vw visset ltrelpq brel pm3.26d vy cv vx cv cnq cplq vx visset
      dmaddpq 0npq ndmoprrcl syl vy cv vy cv vx cv cplq co cltq wbr vy cv vx cv
      cplq co vw cv cltq wbr vy cv vw cv cltq wbr vy cv cnq wcel vx cv cnq wcel
      wa vy cv vy cv vx cv cplq co vw cv cltq cnq vy visset ltsopq ltrelpq vy
      cv vx cv cplq oprex vw visset sotri vy cv vx cv vy visset vx visset
      ltaddpq sylan mpancom vy cv cnq wcel vw cv cnq wcel wa vy cv vw cv cltq
      wbr vy cv vz cv cplq co vw cv wceq vz wex vy cv vw cv cnq cnq cltq vw
      visset ltrelpq brel vy cv cnq wcel vw cv cnq wcel wa vy cv vw cv cltq wbr
      vy cv vz cv cplq co vw cv wceq vz wex vz vy cv vw cv vy visset ltexpq
      biimpd mpcom syl vw cv vy cv vz cv cplq co wceq vy cv vz cv cplq co vw cv
      wceq vz vw cv vy cv vz cv cplq co eqcom exbii sylibr ancri anim2i vw cv
      vy cv vz cv cplq co wceq vz wex vw cv cB wcel vy cv vx cv cplq co vw cv
      cltq wbr an12 sylibr vw cv vy cv vz cv cplq co wceq vw cv cB wcel vy cv
      vx cv cplq co vw cv cltq wbr wa vz 19.41v sylibr 19.22i vw cv vy cv vz cv
      cplq co wceq vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr wa wa vz vw
      excom sylibr vw cv vy cv vz cv cplq co wceq vw cv cB wcel vy cv vx cv
      cplq co vw cv cltq wbr wa wa vw wex vy cv vz cv cplq co cB wcel vx cv vz
      cv cltq wbr wa vz vw cv vy cv vz cv cplq co wceq vw cv cB wcel vy cv vx
      cv cplq co vw cv cltq wbr wa wa vw wex vy cv vz cv cplq co cB wcel vy cv
      vx cv cplq co vy cv vz cv cplq co cltq wbr wa vy cv vz cv cplq co cB wcel
      vx cv vz cv cltq wbr wa vw cv cB wcel vy cv vx cv cplq co vw cv cltq wbr
      wa vy cv vz cv cplq co cB wcel vy cv vx cv cplq co vy cv vz cv cplq co
      cltq wbr wa vw vy cv vz cv cplq co vy cv vz cv cplq oprex vw cv vy cv vz
      cv cplq co wceq vw cv cB wcel vy cv vz cv cplq co cB wcel vy cv vx cv
      cplq co vw cv cltq wbr vy cv vx cv cplq co vy cv vz cv cplq co cltq wbr
      vw cv vy cv vz cv cplq co cB eleq1 vw cv vy cv vz cv cplq co vy cv vx cv
      cplq co cltq breq2 anbi12d ceqsexv vy cv vx cv cplq co vy cv vz cv cplq
      co cltq wbr vx cv vz cv cltq wbr vy cv vz cv cplq co cB wcel vx cv vz cv
      vy cv cltq cnq cplq vx visset dmaddpq ltrelpq 0npq vx cv vz cv vy cv vx
      visset vz visset ltapq ndmordi anim2i sylbi 19.22i 3syl anim2i an1s vy cv
      cA wcel wn vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa vz 19.42v
      sylibr ex 19.22dv vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex
      vx cC ltexprlem.1 abeq2i vz cv cC wcel vx cv vz cv cltq wbr wa vz wex vy
      cv cA wcel wn vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vy
      wex vz wex vy cv cA wcel wn vy cv vz cv cplq co cB wcel vx cv vz cv cltq
      wbr wa wa vz wex vy wex vz cv cC wcel vx cv vz cv cltq wbr wa vy cv cA
      wcel wn vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vy wex vz
      vz cv cC wcel vx cv vz cv cltq wbr wa vy cv cA wcel wn vy cv vz cv cplq
      co cB wcel wa vy wex vx cv vz cv cltq wbr wa vy cv cA wcel wn vy cv vz cv
      cplq co cB wcel wa vx cv vz cv cltq wbr wa vy wex vy cv cA wcel wn vy cv
      vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vy wex vz cv cC wcel vy
      cv cA wcel wn vy cv vz cv cplq co cB wcel wa vy wex vx cv vz cv cltq wbr
      vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vy cv cA wcel wn
      vy cv vz cv cplq co cB wcel wa vy wex vx vz cv cC vz visset vx cv vz cv
      wceq vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy cv cA wcel wn vy
      cv vz cv cplq co cB wcel wa vy vx cv vz cv wceq vy cv vx cv cplq co cB
      wcel vy cv vz cv cplq co cB wcel vy cv cA wcel wn vx cv vz cv wceq vy cv
      vx cv cplq co vy cv vz cv cplq co cB vx cv vz cv vy cv cplq opreq2 eleq1d
      anbi2d exbidv ltexprlem.1 elab2 anbi1i vy cv cA wcel wn vy cv vz cv cplq
      co cB wcel wa vx cv vz cv cltq wbr vy 19.41v vy cv cA wcel wn vy cv vz cv
      cplq co cB wcel wa vx cv vz cv cltq wbr wa vy cv cA wcel wn vy cv vz cv
      cplq co cB wcel vx cv vz cv cltq wbr wa wa vy vy cv cA wcel wn vy cv vz
      cv cplq co cB wcel vx cv vz cv cltq wbr anass exbii 3bitr2i exbii vy cv
      cA wcel wn vy cv vz cv cplq co cB wcel vx cv vz cv cltq wbr wa wa vy vz
      excom bitr4i 3imtr4g $.
      $( [6-Apr-1996] $)

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem5 $p |- ( ( B e. P. /\ A C. B ) -> C e. P. ) $=
      cB cnp wcel cA cB wpss wa c0 cC wpss cC cnq wpss wa vz cv vx cv cltq wbr
      vz cv cC wcel wi vz wal vx cv vz cv cltq wbr vz cC wrex wa vx cC wral wa
      cC cnp wcel cB cnp wcel cA cB wpss wa c0 cC wpss cC cnq wpss vz cv vx cv
      cltq wbr vz cv cC wcel wi vz wal vx cv vz cv cltq wbr vz cC wrex wa vx cC
      wral cB cnp wcel cA cB wpss c0 cC wpss cB cnp wcel cA cB wpss cC c0 wne
      c0 cC wpss vx vy cA cB cC ltexprlem.1 ltexprlem1 cC 0pss syl6ibr imp cB
      cnp wcel cC cnq wpss cA cB wpss vx vy cA cB cC ltexprlem.1 ltexprlem2
      adantr cB cnp wcel vz cv vx cv cltq wbr vz cv cC wcel wi vz wal vx cv vz
      cv cltq wbr vz cC wrex wa vx cC wral cA cB wpss cB cnp wcel vz cv vx cv
      cltq wbr vz cv cC wcel wi vz wal vx cv vz cv cltq wbr vz cC wrex wa vx cC
      cB cnp wcel vx cv cC wcel vz cv vx cv cltq wbr vz cv cC wcel wi vz wal vx
      cv vz cv cltq wbr vz cC wrex vx vy vz cA cB cC ltexprlem.1 ltexprlem3 cB
      cnp wcel vx cv cC wcel vz cv cC wcel vx cv vz cv cltq wbr wa vz wex vx cv
      vz cv cltq wbr vz cC wrex vx vy vz cA cB cC ltexprlem.1 ltexprlem4 vx cv
      vz cv cltq wbr vz cC df-rex syl6ibr jcad r19.21aiv adantr jca31 vx vz cC
      elnp sylibr $.
      $( [6-Apr-1996] $)

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem6 $p |- ( ( ( A e. P. /\ B e. P. ) /\ A C. B ) ->
                     ( A +P. C ) C_ B ) $=
      cA cnp wcel cB cnp wcel cA cB wpss cA cC cpp co cB wss cA cnp wcel cB cnp
      wcel cA cB wpss wa wa vz cA cC cpp co cB cA cnp wcel cB cnp wcel cA cB
      wpss wa wa vz cv cA cC cpp co wcel vw cv cA wcel vx cv cC wcel wa vz cv
      vw cv vx cv cplq co wceq wa vx wex vw wex vz cv cB wcel cA cnp wcel cC
      cnp wcel vz cv cA cC cpp co wcel vw cv cA wcel vx cv cC wcel wa vz cv vw
      cv vx cv cplq co wceq wa vx wex vw wex wb cB cnp wcel cA cB wpss wa vf vg
      vh vz vv vu cA cC vz cv vw vx cpp cplq vz vv vu vf vg vh df-plp vz visset
      genpelv vx vy cA cB cC ltexprlem.1 ltexprlem5 sylan2 cA cnp wcel cB cnp
      wcel vw cv cA wcel vx cv cC wcel wa vz cv vw cv vx cv cplq co wceq wa vx
      wex vw wex vz cv cB wcel wi cA cB wpss cA cnp wcel cB cnp wcel wa vw cv
      cA wcel vx cv cC wcel wa vz cv vw cv vx cv cplq co wceq wa vz cv cB wcel
      vw vx cA cnp wcel cB cnp wcel wa vw cv cA wcel vx cv cC wcel wa vz cv vw
      cv vx cv cplq co wceq vz cv cB wcel cA cnp wcel cB cnp wcel wa vw cv cA
      wcel vx cv cC wcel wa vz cv vw cv vx cv cplq co wceq vz cv cB wcel vw cv
      vx cv cplq co cB wcel vz cv vw cv vx cv cplq co wceq vz cv cB wcel cA cnp
      wcel cB cnp wcel wa vw cv cA wcel vx cv cC wcel wa wa vz cv vw cv vx cv
      cplq co wceq vz cv cB wcel vw cv vx cv cplq co cB wcel vz cv vw cv vx cv
      cplq co cB eleq1 biimparc cA cnp wcel cB cnp wcel vw cv cA wcel vx cv cC
      wcel vw cv vx cv cplq co cB wcel cA cnp wcel vw cv cA wcel cB cnp wcel vx
      cv cC wcel vw cv vx cv cplq co cB wcel wi cA cnp wcel vw cv cA wcel cB
      cnp wcel vx cv cC wcel vw cv vx cv cplq co cB wcel wi cA cnp wcel vw cv
      cA wcel wa cB cnp wcel wa vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa
      vy wex vw cv vx cv cplq co cB wcel vx cv cC wcel cA cnp wcel vw cv cA
      wcel wa cB cnp wcel wa vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vw
      cv vx cv cplq co cB wcel vy cA cnp wcel vw cv cA wcel wa cB cnp wcel vy
      cv cA wcel wn vy cv vx cv cplq co cB wcel vw cv vx cv cplq co cB wcel cA
      cnp wcel vw cv cA wcel wa cB cnp wcel vy cv vx cv cplq co cB wcel vy cv
      cA wcel wn vw cv vx cv cplq co cB wcel cA cnp wcel vw cv cA wcel wa cB
      cnp wcel vy cv vx cv cplq co cB wcel vy cv cA wcel wn vw cv vx cv cplq co
      cB wcel wi cA cnp wcel vw cv cA wcel wa cB cnp wcel vy cv vx cv cplq co
      cB wcel wa wa vy cv cA wcel wn vw cv vy cv cltq wbr vw cv vx cv cplq co
      cB wcel cA cnp wcel vw cv cA wcel wa vy cv cnq wcel vy cv cA wcel wn vw
      cv vy cv cltq wbr wi cB cnp wcel vy cv vx cv cplq co cB wcel wa cA vw cv
      vy cv prub cB cnp wcel vy cv vx cv cplq co cB wcel wa vy cv vx cv cplq co
      cnq wcel vy cv cnq wcel cB vy cv vx cv cplq co elprpq vy cv vx cv cplq co
      cnq wcel vy cv cnq wcel vx cv cnq wcel vy cv vx cv cnq cplq vx visset
      dmaddpq 0npq ndmoprrcl pm3.26d syl sylan2 cB cnp wcel vy cv vx cv cplq co
      cB wcel wa vw cv vy cv cltq wbr vw cv vx cv cplq co cB wcel wi cA cnp
      wcel vw cv cA wcel wa cB cnp wcel vy cv vx cv cplq co cB wcel wa vw cv vy
      cv cltq wbr vw cv vx cv cplq co vy cv vx cv cplq co cltq wbr vw cv vx cv
      cplq co cB wcel cB cnp wcel vy cv vx cv cplq co cB wcel wa vy cv vx cv
      cplq co cnq wcel vx cv cnq wcel vw cv vy cv cltq wbr vw cv vx cv cplq co
      vy cv vx cv cplq co cltq wbr wb cB vy cv vx cv cplq co elprpq vy cv vx cv
      cplq co cnq wcel vy cv cnq wcel vx cv cnq wcel vy cv vx cv cnq cplq vx
      visset dmaddpq 0npq ndmoprrcl pm3.27d vz vv vu vw cv vy cv vx cv cltq cnq
      cplq vw visset vy visset vz cv vv cv vu cv vz visset vv visset ltapq vx
      visset vz cv vv cv vz visset vv visset addcompq caoprord2 3syl cB vy cv
      vx cv cplq co vw cv vx cv cplq co prcdpq sylbid adantl syld exp32 com34
      imp4b 19.23adv vy cv cA wcel wn vy cv vx cv cplq co cB wcel wa vy wex vx
      cC ltexprlem.1 abeq2i syl5ib exp31 com23 imp43 sylan exp31 imp3a
      19.23advv adantrr sylbid ssrdv anassrs $.
      $( [8-Apr-1996] $)

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexprlem7 $p |- ( ( ( A e. P. /\ B e. P. ) /\ A C. B ) ->
                     B C_ ( A +P. C ) ) $=
      cA cnp wcel cB cnp wcel wa cA cB wpss wa vw cB cA cC cpp co cA cnp wcel
      cB cnp wcel cA cB wpss vw cv cB wcel vw cv cA cC cpp co wcel wi cA cnp
      wcel cB cnp wcel cA cB wpss vw cv cB wcel vw cv cA cC cpp co wcel wi wi
      cA cnp wcel cB cnp wcel cA cB wpss cB cnp wcel vw cv cB wcel vw cv cA cC
      cpp co wcel wi cA cnp wcel cB cnp wcel cA cB wpss cB cnp wcel vw cv cB
      wcel vw cv cA cC cpp co wcel wi wi cA cnp wcel cC cnp wcel cB cnp wcel vw
      cv cB wcel vw cv cA cC cpp co wcel wi wi cB cnp wcel cA cB wpss wa vw cv
      cA wcel cA cnp wcel cC cnp wcel cB cnp wcel vw cv cB wcel vw cv cA cC cpp
      co wcel wi wi wi wi vw cv cA wcel cA cnp wcel cC cnp wcel cB cnp wcel vw
      cv cB wcel vw cv cA cC cpp co wcel wi wi cA cnp wcel cC cnp wcel wa cB
      cnp wcel vw cv cB wcel vw cv cA wcel vw cv cA cC cpp co wcel cA cnp wcel
      cC cnp wcel wa vw cv cB wcel vw cv cA wcel vw cv cA cC cpp co wcel wi wi
      cB cnp wcel cA cnp wcel cC cnp wcel wa vw cv cA wcel vw cv cA cC cpp co
      wcel wi vw cv cB wcel cA cnp wcel cC cnp wcel wa cA cA cC cpp co vw cv cA
      cnp wcel cC cnp wcel wa cA cA cC cpp co cA cnp wcel cC cnp wcel wa cA cA
      cC cpp co cltp wbr cA cA cC cpp co wpss cA cC ltaddpr cA cnp wcel cC cnp
      wcel cA cC cpp co cnp wcel cA cA cC cpp co cltp wbr cA cA cC cpp co wpss
      wb cA cC addclpr cA cA cC cpp co ltprord syldan mpbid pssssd sseld a1d
      a1d com4r exp3a vw cv cA wcel wn cA cnp wcel cC cnp wcel cB cnp wcel vw
      cv cB wcel vw cv cA cC cpp co wcel wi wi wi cB cnp wcel vw cv cB wcel vw
      cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv cA cC cpp co wcel cB cnp
      wcel vw cv cB wcel vw cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv cA
      cC cpp co wcel wi wi cB cnp wcel vw cv cB wcel wa vw cv vv cv cplq co cB
      wcel vv wex vw cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv cA cC cpp
      co wcel wi wi vv cB vw cv vw visset prnmadd cB cnp wcel vw cv vv cv cplq
      co cB wcel vv wex vw cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv cA cC
      cpp co wcel wi wi wi vw cv cB wcel cB cnp wcel vw cv vv cv cplq co cB
      wcel vw cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv cA cC cpp co wcel
      wi wi vv cB cnp wcel vw cv vv cv cplq co cB wcel vw cv cA wcel wn cA cnp
      wcel wa cC cnp wcel vw cv cA cC cpp co wcel wi wi vw cv cnq wcel vv cv
      cnq wcel wa cB cnp wcel vw cv vv cv cplq co cB wcel wa vw cv cA wcel wn
      cA cnp wcel wa cC cnp wcel vw cv cA cC cpp co wcel wi wi cB cnp wcel vw
      cv vv cv cplq co cB wcel wa vw cv vv cv cplq co cnq wcel vw cv cnq wcel
      vv cv cnq wcel wa cB vw cv vv cv cplq co elprpq vw cv vv cv cnq cplq vv
      visset dmaddpq 0npq ndmoprrcl syl vw cv cnq wcel vv cv cnq wcel wa vw cv
      vv cv cplq co cB wcel vw cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv
      cA cC cpp co wcel wi wi cB cnp wcel vw cv vv cv cplq co cB wcel vw cv cnq
      wcel vv cv cnq wcel wa vw cv cA wcel wn cA cnp wcel wa cC cnp wcel vw cv
      cA cC cpp co wcel wi wi vw cv cnq wcel vv cv cnq wcel wa vw cv cA wcel wn
      cA cnp wcel wa cC cnp wcel vw cv vv cv cplq co cB wcel vw cv cA cC cpp co
      wcel vw cv cnq wcel vv cv cnq wcel vw cv cA wcel wn cA cnp wcel cC cnp
      wcel vw cv vv cv cplq co cB wcel vw cv cA cC cpp co wcel wi wi cA cnp
      wcel vv cv cnq wcel vw cv cA wcel wn vw cv cnq wcel cC cnp wcel vw cv vv
      cv cplq co cB wcel vw cv cA cC cpp co wcel wi wi cA cnp wcel vv cv cnq
      wcel vw cv cA wcel wn vw cv cnq wcel cC cnp wcel vw cv vv cv cplq co cB
      wcel vw cv cA cC cpp co wcel wi wi wi wi cA cnp wcel vv cv cnq wcel wa cC
      cnp wcel vw cv cnq wcel vw cv cA wcel wn vw cv vv cv cplq co cB wcel vw
      cv cA cC cpp co wcel wi cA cnp wcel vv cv cnq wcel wa vz cv cA wcel vz cv
      vv cv cplq co cA wcel wn wa vz wex cC cnp wcel vw cv cnq wcel vw cv cA
      wcel wn vw cv vv cv cplq co cB wcel vw cv cA cC cpp co wcel wi wi wi wi
      vz cA vv cv prlem934 cA cnp wcel vz cv cA wcel vz cv vv cv cplq co cA
      wcel wn wa vz wex cC cnp wcel vw cv cnq wcel vw cv cA wcel wn vw cv vv cv
      cplq co cB wcel vw cv cA cC cpp co wcel wi wi wi wi wi vv cv cnq wcel cA
      cnp wcel vz cv cA wcel vz cv vv cv cplq co cA wcel wn wa cC cnp wcel vw
      cv cnq wcel vw cv cA wcel wn vw cv vv cv cplq co cB wcel vw cv cA cC cpp
      co wcel wi wi wi wi vz cA cnp wcel cC cnp wcel vz cv cA wcel vz cv vv cv
      cplq co cA wcel wn wa vw cv cnq wcel vw cv cA wcel wn vw cv vv cv cplq co
      cB wcel vw cv cA cC cpp co wcel wi wi wi cA cnp wcel cC cnp wcel vz cv cA
      wcel vz cv vv cv cplq co cA wcel wn wa vw cv cnq wcel vw cv cA wcel wn vw
      cv vv cv cplq co cB wcel vw cv cA cC cpp co wcel wi wi wi cA cnp wcel cC
      cnp wcel wa vz cv cA wcel vz cv vv cv cplq co cA wcel wn wa wa vw cv cnq
      wcel vw cv cA wcel wn vz cv vx cv cplq co vw cv wceq vx wex vw cv vv cv
      cplq co cB wcel vw cv cA cC cpp co wcel wi cA cnp wcel vz cv cA wcel vw
      cv cnq wcel vw cv cA wcel wn vz cv vx cv cplq co vw cv wceq vx wex wi wi
      cC cnp wcel vz cv vv cv cplq co cA wcel wn cA cnp wcel vz cv cA wcel wa
      vw cv cnq wcel vw cv cA wcel wn vz cv vx cv cplq co vw cv wceq vx wex wi
      cA cnp wcel vz cv cA wcel wa vw cv cnq wcel wa vw cv cA wcel wn vz cv vw
      cv cltq wbr vz cv vx cv cplq co vw cv wceq vx wex cA vz cv vw cv prub vz
      cv cnq wcel vw cv cnq wcel vz cv vw cv cltq wbr vz cv vx cv cplq co vw cv
      wceq vx wex wb cA cnp wcel vz cv cA wcel wa vx vz cv vw cv vz visset
      ltexpq cA vz cv elprpq sylan sylibd ex ad2ant2r cA cnp wcel cC cnp wcel
      wa vz cv cA wcel vz cv vv cv cplq co cA wcel wn wa wa vz cv vx cv cplq co
      vw cv wceq vw cv vv cv cplq co cB wcel vw cv cA cC cpp co wcel wi vx cA
      cnp wcel cC cnp wcel wa vz cv cA wcel vz cv vv cv cplq co cA wcel wn wa
      wa vz cv vx cv cplq co vw cv wceq vw cv vv cv cplq co cB wcel vw cv cA cC
      cpp co wcel cA cnp wcel cC cnp wcel wa vz cv cA wcel vz cv vv cv cplq co
      cA wcel wn wa wa vz cv vx cv cplq co vw cv wceq vw cv vv cv cplq co cB
      wcel wa wa vz cv vx cv cplq co cA cC cpp co wcel vw cv cA cC cpp co wcel
      cA cnp wcel cC cnp wcel wa vz cv cA wcel vz cv vv cv cplq co cA wcel wn
      vz cv vx cv cplq co vw cv wceq vw cv vv cv cplq co cB wcel wa vz cv vx cv
      cplq co cA cC cpp co wcel cA cnp wcel cC cnp wcel wa vz cv cA wcel vz cv
      vv cv cplq co cA wcel wn vz cv vx cv cplq co vw cv wceq vw cv vv cv cplq
      co cB wcel wa vz cv vx cv cplq co cA cC cpp co wcel cA cnp wcel cC cnp
      wcel wa vz cv cA wcel vx cv cC wcel vz cv vx cv cplq co cA cC cpp co wcel
      vz cv vv cv cplq co cA wcel wn vz cv vx cv cplq co vw cv wceq vw cv vv cv
      cplq co cB wcel wa wa vf vg vh vz vv vu cA cC vz cv vx cv cpp cplq vz vv
      vu vf vg vh df-plp genpprecl vz cv vv cv cplq co cA wcel wn vz cv vv cv
      cplq co vx cv cplq co cB wcel vx cv cC wcel vz cv vx cv cplq co vw cv
      wceq vw cv vv cv cplq co cB wcel wa vz cv vv cv cplq co cA wcel wn vz cv
      vv cv cplq co vx cv cplq co cB wcel wa vy cv cA wcel wn vy cv vx cv cplq
      co cB wcel wa vy wex vx cv cC wcel vy cv cA wcel wn vy cv vx cv cplq co
      cB wcel wa vz cv vv cv cplq co cA wcel wn vz cv vv cv cplq co vx cv cplq
      co cB wcel wa vy vz cv vv cv cplq co vz cv vv cv cplq oprex vy cv vz cv
      vv cv cplq co wceq vy cv cA wcel wn vz cv vv cv cplq co cA wcel wn vy cv
      vx cv cplq co cB wcel vz cv vv cv cplq co vx cv cplq co cB wcel vy cv vz
      cv vv cv cplq co wceq vy cv cA wcel vz cv vv cv cplq co cA wcel vy cv vz
      cv vv cv cplq co cA eleq1 notbid vy cv vz cv vv cv cplq co wceq vy cv vx
      cv cplq co vz cv vv cv cplq co vx cv cplq co cB vy cv vz cv vv cv cplq co
      vx cv cplq opreq1 eleq1d anbi12d cla4ev vy cv cA wcel wn vy cv vx cv cplq
      co cB wcel wa vy wex vx cC ltexprlem.1 abeq2i sylibr vz cv vx cv cplq co
      vw cv wceq vz cv vv cv cplq co vx cv cplq co cB wcel vw cv vv cv cplq co
      cB wcel vz cv vx cv cplq co vw cv wceq vz cv vv cv cplq co vx cv cplq co
      vw cv vv cv cplq co cB vz cv vx cv cplq co vw cv wceq vz cv vx cv cplq co
      vv cv cplq co vw cv vv cv cplq co vz cv vv cv cplq co vx cv cplq co vz cv
      vx cv cplq co vw cv vv cv cplq opreq1 vf vg vh vz cv vv cv vx cv cplq vz
      visset vv visset vx visset vf cv vg cv vf visset vg visset addcompq vf cv
      vg cv vh cv vg visset vh visset addasspq caopr32 syl5eq eleq1d biimpar
      sylan2 sylan2i exp4d imp42 vz cv vx cv cplq co vw cv wceq vz cv vx cv
      cplq co cA cC cpp co wcel vw cv cA cC cpp co wcel wb cA cnp wcel cC cnp
      wcel wa vz cv cA wcel vz cv vv cv cplq co cA wcel wn wa wa vw cv vv cv
      cplq co cB wcel vz cv vx cv cplq co vw cv cA cC cpp co eleq1 ad2antrl
      mpbid exp32 19.23adv syl6d exp31 com23 19.23adv adantr mpd com24 ex com14
      imp4b com4r com12 adantld mpcom ex 19.23adv adantr mpd ex com4t ex
      pm2.61i vx vy cA cB cC ltexprlem.1 ltexprlem5 syl5 exp3a com34 pm2.43d
      imp31 ssrdv $.
      $( [8-Apr-1996] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    ltexpri.1 $e |- B e. _V $.
    $( Proposition 9-3.5(iv) of [Gleason] p. 123. $)
    ltexpri $p |- ( A <P B -> E. x ( x e. P. /\ ( A +P. x ) = B ) ) $=
      cA cnp wcel cB cnp wcel wa cA cB cltp wbr vx cv cnp wcel cA vx cv cpp co
      cB wceq wa vx wex cA cB cnp cnp cltp ltexpri.1 ltrelpr brel cA cnp wcel
      cB cnp wcel wa cA cB cltp wbr cA vx cv cpp co cB wceq vx wex vx cv cnp
      wcel cA vx cv cpp co cB wceq wa vx wex cA cnp wcel cB cnp wcel wa cA cB
      cltp wbr cA cB wpss cA vx cv cpp co cB wceq vx wex cA cB ltprord cA cnp
      wcel cB cnp wcel wa cA cB wpss cA vx cv cpp co cB wceq vx wex vw cv cA
      wcel wn vw cv vy cv cplq co cB wcel wa vw wex vy cab cnp wcel cA vw cv cA
      wcel wn vw cv vy cv cplq co cB wcel wa vw wex vy cab cpp co cB wceq cA vx
      cv cpp co cB wceq vx wex cA cnp wcel cB cnp wcel wa cA cB wpss wa cA vx
      cv cpp co cB wceq cA vw cv cA wcel wn vw cv vy cv cplq co cB wcel wa vw
      wex vy cab cpp co cB wceq vx vw cv cA wcel wn vw cv vy cv cplq co cB wcel
      wa vw wex vy cab cnp vx cv vw cv cA wcel wn vw cv vy cv cplq co cB wcel
      wa vw wex vy cab wceq cA vx cv cpp co cA vw cv cA wcel wn vw cv vy cv
      cplq co cB wcel wa vw wex vy cab cpp co cB vx cv vw cv cA wcel wn vw cv
      vy cv cplq co cB wcel wa vw wex vy cab cA cpp opreq2 eqeq1d cla4egv cB
      cnp wcel cA cB wpss vw cv cA wcel wn vw cv vy cv cplq co cB wcel wa vw
      wex vy cab cnp wcel cA cnp wcel vz vw cA cB vw cv cA wcel wn vw cv vy cv
      cplq co cB wcel wa vw wex vy cab vw cv cA wcel wn vw cv vy cv cplq co cB
      wcel wa vw wex vw cv cA wcel wn vw cv vz cv cplq co cB wcel wa vw wex vy
      vz vy cv vz cv wceq vw cv cA wcel wn vw cv vy cv cplq co cB wcel wa vw cv
      cA wcel wn vw cv vz cv cplq co cB wcel wa vw vy cv vz cv wceq vw cv vy cv
      cplq co cB wcel vw cv vz cv cplq co cB wcel vw cv cA wcel wn vy cv vz cv
      wceq vw cv vy cv cplq co vw cv vz cv cplq co cB vy cv vz cv vw cv cplq
      opreq2 eleq1d anbi2d exbidv cbvabv ltexprlem5 adantll cA cnp wcel cB cnp
      wcel wa cA cB wpss wa cA vw cv cA wcel wn vw cv vy cv cplq co cB wcel wa
      vw wex vy cab cpp co cB vz vw cA cB vw cv cA wcel wn vw cv vy cv cplq co
      cB wcel wa vw wex vy cab vw cv cA wcel wn vw cv vy cv cplq co cB wcel wa
      vw wex vw cv cA wcel wn vw cv vz cv cplq co cB wcel wa vw wex vy vz vy cv
      vz cv wceq vw cv cA wcel wn vw cv vy cv cplq co cB wcel wa vw cv cA wcel
      wn vw cv vz cv cplq co cB wcel wa vw vy cv vz cv wceq vw cv vy cv cplq co
      cB wcel vw cv vz cv cplq co cB wcel vw cv cA wcel wn vy cv vz cv wceq vw
      cv vy cv cplq co vw cv vz cv cplq co cB vy cv vz cv vw cv cplq opreq2
      eleq1d anbi2d exbidv cbvabv ltexprlem6 vz vw cA cB vw cv cA wcel wn vw cv
      vy cv cplq co cB wcel wa vw wex vy cab vw cv cA wcel wn vw cv vy cv cplq
      co cB wcel wa vw wex vw cv cA wcel wn vw cv vz cv cplq co cB wcel wa vw
      wex vy vz vy cv vz cv wceq vw cv cA wcel wn vw cv vy cv cplq co cB wcel
      wa vw cv cA wcel wn vw cv vz cv cplq co cB wcel wa vw vy cv vz cv wceq vw
      cv vy cv cplq co cB wcel vw cv vz cv cplq co cB wcel vw cv cA wcel wn vy
      cv vz cv wceq vw cv vy cv cplq co vw cv vz cv cplq co cB vy cv vz cv vw
      cv cplq opreq2 eleq1d anbi2d exbidv cbvabv ltexprlem7 eqssd sylc ex
      sylbid cA cnp wcel cB cnp wcel wa cA vx cv cpp co cB wceq vx cv cnp wcel
      cA vx cv cpp co cB wceq wa vx cA cnp wcel cB cnp wcel wa cA vx cv cpp co
      cB wceq vx cv cnp wcel cB cnp wcel cA vx cv cpp co cB wceq vx cv cnp wcel
      wi cA cnp wcel cA vx cv cpp co cB wceq cB cnp wcel vx cv cnp wcel cA vx
      cv cpp co cB wceq cB cnp wcel cA vx cv cpp co cnp wcel vx cv cnp wcel cA
      vx cv cpp co cB cnp eleq1 cA vx cv cpp co cnp wcel cA cnp wcel vx cv cnp
      wcel cA vx cv cnp cpp vx visset dmplp 0npr ndmoprrcl pm3.27d syl6bir
      com12 adantl ancrd 19.22dv syld mpcom $.
      $( [13-May-1996] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    ltaprlem.1 $e |- A e. _V $.
    ltaprlem.2 $e |- B e. _V $.
    $( Lemma for Proposition 9-3.5(v) of [Gleason] p. 123. $)
    ltaprlem $p |- ( C e. P. -> ( A <P B ->
                    ( C +P. A ) <P ( C +P. B ) ) ) $=
      cC cnp wcel cA cB cltp wbr cC cA cpp co cC cB cpp co cltp wbr cA cB cltp
      wbr cC cnp wcel cA cB cltp wbr cC cA cpp co cC cB cpp co cltp wbr cA cB
      cltp wbr cC cnp wcel cA cnp wcel cC cA cpp co cC cB cpp co cltp wbr cA cB
      cltp wbr cA cB cltp wbr vx cv cnp wcel cA vx cv cpp co cB wceq wa vx wex
      cC cnp wcel cA cnp wcel wa cC cA cpp co cC cB cpp co cltp wbr wi vx cA cB
      ltaprlem.2 ltexpri vx cv cnp wcel cA vx cv cpp co cB wceq wa cC cnp wcel
      cA cnp wcel wa cC cA cpp co cC cB cpp co cltp wbr wi vx vx cv cnp wcel cA
      vx cv cpp co cB wceq cC cnp wcel cA cnp wcel wa cC cA cpp co cC cB cpp co
      cltp wbr wi cA vx cv cpp co cB wceq cC cnp wcel cA cnp wcel wa vx cv cnp
      wcel cC cA cpp co cC cB cpp co cltp wbr cA vx cv cpp co cB wceq cC cA cpp
      co cnp wcel vx cv cnp wcel cC cA cpp co cC cB cpp co cltp wbr wi cC cnp
      wcel cA cnp wcel wa cA vx cv cpp co cB wceq cC cA cpp co cnp wcel vx cv
      cnp wcel cC cA cpp co cC cB cpp co cltp wbr cA vx cv cpp co cB wceq cC cA
      cpp co cC cA cpp co vx cv cpp co cltp wbr cC cA cpp co cC cB cpp co cltp
      wbr cC cA cpp co cnp wcel vx cv cnp wcel wa cA vx cv cpp co cB wceq cC cA
      cpp co vx cv cpp co cC cB cpp co cC cA cpp co cltp cA vx cv cpp co cB
      wceq cC cA vx cv cpp co cpp co cC cB cpp co cC cA cpp co vx cv cpp co cA
      vx cv cpp co cB cC cpp opreq2 cC cA vx cv ltaprlem.1 vx visset addasspr
      syl5eq breq2d cC cA cpp co vx cv ltaddpr syl5bi exp3a cC cA addclpr syl5
      com3r imp 19.23aiv syl cA cB cltp wbr cA cnp wcel cB cnp wcel cA cB cnp
      cnp cltp ltaprlem.2 ltrelpr brel pm3.26d sylan2i exp3a pm2.43b $.
      $( [8-Apr-1996] $)
  $}

  ${
    ltapr.1 $e |- A e. _V $.
    ltapr.2 $e |- B e. _V $.
    $( Ordering property of addition.  Proposition 9-3.5(v) of [Gleason]
       p. 123. $)
    ltapr $p |- ( C e. P. -> ( A <P B <-> ( C +P. A ) <P ( C +P. B ) ) ) $=
      cA cB cC cltp cnp cpp ltapr.2 dmplp ltapr.1 ltrelpr 0npr cC cnp wcel cB
      cnp wcel cA cnp wcel cA cB cltp wbr cC cA cpp co cC cB cpp co cltp wbr wb
      cC cnp wcel cB cnp wcel cA cnp wcel cA cB cltp wbr cC cA cpp co cC cB cpp
      co cltp wbr wb cC cnp wcel cB cnp wcel cA cnp wcel wa wa cA cB cltp wbr
      cC cA cpp co cC cB cpp co cltp wbr cC cnp wcel cA cB cltp wbr cC cA cpp
      co cC cB cpp co cltp wbr wi cB cnp wcel cA cnp wcel wa cA cB cC ltapr.1
      ltapr.2 ltaprlem adantr cC cnp wcel cB cnp wcel cA cnp wcel wa wa cB cA
      wceq cC cA cpp co cC cB cpp co cltp wbr cA cB cltp wbr wi cC cnp wcel cB
      cnp wcel cA cnp wcel wa wa cC cA cpp co cC cB cpp co cltp wbr cB cA wceq
      wn cA cB cltp wbr cC cnp wcel cB cnp wcel cA cnp wcel wa wa cC cA cpp co
      cC cB cpp co cltp wbr cB cA wceq cA cB cltp wbr wo cB cA wceq wn cA cB
      cltp wbr wi cC cnp wcel cB cnp wcel cA cnp wcel wa wa cC cB cpp co cC cA
      cpp co wceq cC cA cpp co cC cB cpp co cltp wbr wo cB cA wceq cA cB cltp
      wbr wo cC cA cpp co cC cB cpp co cltp wbr cC cnp wcel cB cnp wcel cA cnp
      wcel wa wa cB cA wceq cA cB cltp wbr wo cC cB cpp co cC cA cpp co wceq cC
      cA cpp co cC cB cpp co cltp wbr wo cC cnp wcel cB cnp wcel cA cnp wcel wa
      wa cB cA cltp wbr cC cB cpp co cC cA cpp co cltp wbr cB cA wceq cA cB
      cltp wbr wo wn cC cB cpp co cC cA cpp co wceq cC cA cpp co cC cB cpp co
      cltp wbr wo wn cC cnp wcel cB cA cltp wbr cC cB cpp co cC cA cpp co cltp
      wbr wi cB cnp wcel cA cnp wcel wa cB cA cC ltapr.2 ltapr.1 ltaprlem
      adantr cB cnp wcel cA cnp wcel wa cB cA cltp wbr cB cA wceq cA cB cltp
      wbr wo wn wb cC cnp wcel cnp cltp wor cB cnp wcel cA cnp wcel wa cB cA
      cltp wbr cB cA wceq cA cB cltp wbr wo wn wb ltsopr cnp cB cA cltp sotric
      mpan adantl cnp cltp wor cC cB cpp co cnp wcel cC cA cpp co cnp wcel wa
      cC cB cpp co cC cA cpp co cltp wbr cC cB cpp co cC cA cpp co wceq cC cA
      cpp co cC cB cpp co cltp wbr wo wn wb cC cnp wcel cB cnp wcel cA cnp wcel
      wa wa cnp cC cB cpp co cC cA cpp co cltp sotric ltsopr cC cnp wcel cB cnp
      wcel cA cnp wcel cC cB cpp co cnp wcel cC cA cpp co cnp wcel wa cC cnp
      wcel cB cnp wcel wa cC cB cpp co cnp wcel cC cnp wcel cA cnp wcel wa cC
      cA cpp co cnp wcel cC cB addclpr cC cA addclpr anim12i anandis sylancr
      3imtr3d con4d cC cA cpp co cC cB cpp co cltp wbr cC cB cpp co cC cA cpp
      co wceq olc syl5 cB cA wceq cA cB cltp wbr df-or syl6ib com23 cB cA wceq
      cC cA cpp co cC cB cpp co cltp wbr cA cB cltp wbr cB cA wceq cC cA cpp co
      cC cB cpp co cltp wbr cC cA cpp co cC cA cpp co cltp wbr cC cA cpp co
      cltp cnp cC cA cpp oprex ltsopr ltrelpr soirri cB cA wceq cC cB cpp co cC
      cA cpp co cC cA cpp co cltp cB cA cC cpp opreq2 breq2d mtbiri pm2.21d
      pm2.61d2 impbid 3impb 3com13 ndmord $.
      $( [8-Apr-1996] $)
  $}

  ${
    addcanpr.1 $e |- B e. _V $.
    addcanpr.2 $e |- C e. _V $.
    $( Addition cancellation law for positive reals.  Proposition 9-3.5(vi)
       of [Gleason] p. 123. $)
    addcanpr $p |- ( ( A e. P. /\ B e. P. ) ->
                   ( ( A +P. B ) = ( A +P. C ) -> B = C ) ) $=
      cA cnp wcel cB cnp wcel wa cA cB cpp co cA cC cpp co wceq cB cC wceq cA
      cnp wcel cB cnp wcel wa cA cB cpp co cA cC cpp co wceq cA cnp wcel cC cnp
      wcel wa cA cB cpp co cA cC cpp co wceq cB cC wceq wi cA cB cpp co cA cC
      cpp co wceq cA cB cpp co cnp wcel cA cnp wcel cC cnp wcel wa cA cnp wcel
      cB cnp wcel wa cA cB cpp co cA cC cpp co wceq cA cB cpp co cnp wcel cA cC
      cpp co cnp wcel cA cnp wcel cC cnp wcel wa cA cB cpp co cA cC cpp co cnp
      eleq1 cA cC cnp cpp addcanpr.2 dmplp 0npr ndmoprrcl syl6bi cA cB addclpr
      syl5com cA cnp wcel cB cnp wcel wa cA cnp wcel cC cnp wcel wa cA cB cpp
      co cA cC cpp co wceq cB cC wceq wi cA cnp wcel cB cnp wcel wa cA cnp wcel
      cC cnp wcel wa wa cB cC wceq cA cB cpp co cA cC cpp co wceq cA cnp wcel
      cB cnp wcel wa cA cnp wcel cC cnp wcel wa wa cB cC cltp wbr cC cB cltp
      wbr wo wn cA cB cpp co cA cC cpp co cltp wbr cA cC cpp co cA cB cpp co
      cltp wbr wo wn cB cC wceq cA cB cpp co cA cC cpp co wceq cA cnp wcel cB
      cC cltp wbr cC cB cltp wbr wo wn cA cB cpp co cA cC cpp co cltp wbr cA cC
      cpp co cA cB cpp co cltp wbr wo wn wb cB cnp wcel cA cnp wcel cC cnp wcel
      wa cA cnp wcel cB cC cltp wbr cC cB cltp wbr wo cA cB cpp co cA cC cpp co
      cltp wbr cA cC cpp co cA cB cpp co cltp wbr wo cA cnp wcel cB cC cltp wbr
      cA cB cpp co cA cC cpp co cltp wbr cC cB cltp wbr cA cC cpp co cA cB cpp
      co cltp wbr cB cC cA addcanpr.1 addcanpr.2 ltapr cC cB cA addcanpr.2
      addcanpr.1 ltapr orbi12d notbid ad2antrr cB cnp wcel cC cnp wcel cB cC
      wceq cB cC cltp wbr cC cB cltp wbr wo wn wb cA cnp wcel cA cnp wcel cnp
      cltp wor cB cnp wcel cC cnp wcel wa cB cC wceq cB cC cltp wbr cC cB cltp
      wbr wo wn wb ltsopr cnp cB cC cltp sotrieq mpan ad2ant2l cA cB cpp co cnp
      wcel cA cC cpp co cnp wcel cA cB cpp co cA cC cpp co wceq cA cB cpp co cA
      cC cpp co cltp wbr cA cC cpp co cA cB cpp co cltp wbr wo wn wb cA cnp
      wcel cB cnp wcel wa cA cnp wcel cC cnp wcel wa cnp cltp wor cA cB cpp co
      cnp wcel cA cC cpp co cnp wcel wa cA cB cpp co cA cC cpp co wceq cA cB
      cpp co cA cC cpp co cltp wbr cA cC cpp co cA cB cpp co cltp wbr wo wn wb
      ltsopr cnp cA cB cpp co cA cC cpp co cltp sotrieq mpan cA cB addclpr cA
      cC addclpr syl2an 3bitr4d biimprd ex syld pm2.43d $.
      $( [9-Apr-1996] $)
  $}

  ${
    $d x w v u $.  $d y w v u $.  $d z w v u $.
    $( Sublemma for Lemma 9-3.6 of [Gleason] p. 124.  This is a property of
       positive fractions. $)
    prlem936a $p |- ( ( x e. Q. /\ ( z e. Q. /\ y e. Q. ) ) ->
              ( ( y +Q z ) <Q ( x +Q z ) <->
              ( x +Q z ) <Q ( ( x .Q ( *Q ` y ) ) .Q ( y +Q z ) ) ) ) $=
      vx cv cnq wcel vz cv cnq wcel vy cv cnq wcel wa wa vy cv vz cv cplq co vx
      cv vz cv cplq co cltq wbr vx cv vz cv cplq co vx cv vz cv vy cv crq cfv
      cmq co vx cv cmq co cplq co cltq wbr vx cv vz cv cplq co vx cv vy cv crq
      cfv cmq co vy cv vz cv cplq co cmq co cltq wbr vz cv cnq wcel vy cv cnq
      wcel wa vy cv vz cv cplq co vx cv vz cv cplq co cltq wbr vz cv vz cv vy
      cv crq cfv cmq co vx cv cmq co cltq wbr vx cv cnq wcel vx cv vz cv cplq
      co vx cv vz cv vy cv crq cfv cmq co vx cv cmq co cplq co cltq wbr vz cv
      cnq wcel vy cv cnq wcel wa vy cv vx cv cltq wbr vz cv vy cv crq cfv cmq
      co vy cv cmq co vz cv vy cv crq cfv cmq co vx cv cmq co cltq wbr vy cv vz
      cv cplq co vx cv vz cv cplq co cltq wbr vz cv vz cv vy cv crq cfv cmq co
      vx cv cmq co cltq wbr vz cv cnq wcel vy cv cnq wcel wa vz cv cnq wcel vy
      cv crq cfv cnq wcel wa vz cv vy cv crq cfv cmq co cnq wcel vy cv vx cv
      cltq wbr vz cv vy cv crq cfv cmq co vy cv cmq co vz cv vy cv crq cfv cmq
      co vx cv cmq co cltq wbr wb vy cv cnq wcel vy cv crq cfv cnq wcel vz cv
      cnq wcel vy cv recclpq anim2i vz cv vy cv crq cfv mulclpq vy cv vx cv vz
      cv vy cv crq cfv cmq co vy visset vx visset ltmpq 3syl vz cv cnq wcel vy
      cv vx cv cltq wbr vy cv vz cv cplq co vx cv vz cv cplq co cltq wbr wb vy
      cv cnq wcel vz cv cnq wcel vy cv vx cv cltq wbr vz cv vy cv cplq co vz cv
      vx cv cplq co cltq wbr vy cv vz cv cplq co vx cv vz cv cplq co cltq wbr
      vy cv vx cv vz cv vy visset vx visset ltapq vz cv vy cv cplq co vy cv vz
      cv cplq co vz cv vx cv cplq co vx cv vz cv cplq co cltq vz cv vy cv vz
      visset vy visset addcompq vz cv vx cv vz visset vx visset addcompq
      breq12i syl6bb adantr vz cv cnq wcel vy cv cnq wcel wa vz cv vy cv crq
      cfv cmq co vy cv cmq co vz cv vz cv vy cv crq cfv cmq co vx cv cmq co
      cltq vz cv cnq wcel vy cv cnq wcel wa vz cv vy cv vy cv crq cfv cmq co
      cmq co vz cv vz cv vy cv crq cfv cmq co vy cv cmq co vy cv cnq wcel vz cv
      cnq wcel vz cv vy cv vy cv crq cfv cmq co cmq co vz cv c1q cmq co vz cv
      vy cv cnq wcel vy cv vy cv crq cfv cmq co c1q vz cv cmq vy cv recidpq
      opreq2d vz cv mulidpq sylan9eqr vz cv vy cv crq cfv cmq co vy cv cmq co
      vz cv vy cv crq cfv vy cv cmq co cmq co vz cv vy cv vy cv crq cfv cmq co
      cmq co vz cv vy cv crq cfv vy cv vy cv crq fvex vy visset mulasspq vy cv
      vy cv crq cfv cmq co vy cv crq cfv vy cv cmq co vz cv cmq vy cv vy cv crq
      cfv vy visset vy cv crq fvex mulcompq opreq2i eqtr4i syl5eq breq1d
      3bitr3d vz cv vz cv vy cv crq cfv cmq co vx cv cmq co vx cv vz visset vz
      cv vy cv crq cfv cmq co vx cv cmq oprex ltapq sylan9bbr vx cv cnq wcel vz
      cv cnq wcel vy cv cnq wcel wa wa vx cv vy cv crq cfv cmq co vy cv vz cv
      cplq co cmq co vx cv vz cv vy cv crq cfv cmq co vx cv cmq co cplq co vx
      cv vz cv cplq co cltq vx cv cnq wcel vy cv cnq wcel vx cv vy cv crq cfv
      cmq co vy cv vz cv cplq co cmq co vx cv vz cv vy cv crq cfv cmq co vx cv
      cmq co cplq co wceq vz cv cnq wcel vx cv cnq wcel vy cv cnq wcel wa vx cv
      vy cv crq cfv cmq co vy cv cmq co vx cv vy cv crq cfv cmq co vz cv cmq co
      cplq co vx cv vz cv vy cv crq cfv cmq co vx cv cmq co cplq co vx cv vy cv
      crq cfv cmq co vy cv vz cv cplq co cmq co vx cv cnq wcel vy cv cnq wcel
      wa vx cv vy cv crq cfv cmq co vy cv cmq co vx cv vx cv vy cv crq cfv cmq
      co vz cv cmq co vz cv vy cv crq cfv cmq co vx cv cmq co cplq vy cv cnq
      wcel vx cv cnq wcel vx cv vy cv crq cfv cmq co vy cv cmq co vx cv c1q cmq
      co vx cv vy cv cnq wcel vx cv vy cv crq cfv vy cv cmq co cmq co vx cv c1q
      cmq co vx cv vy cv crq cfv cmq co vy cv cmq co vy cv cnq wcel vy cv crq
      cfv vy cv cmq co c1q vx cv cmq vy cv cnq wcel vy cv vy cv crq cfv cmq co
      c1q vy cv crq cfv vy cv cmq co vy cv recidpq vy cv crq cfv vy cv vy cv
      crq fvex vy visset mulcompq syl5eq opreq2d vx cv vy cv crq cfv vy cv vy
      cv crq fvex vy visset mulasspq syl5eq vx cv mulidpq sylan9eqr vx cv vy cv
      crq cfv cmq co vz cv cmq co vz cv vy cv crq cfv cmq co vx cv cmq co wceq
      vx cv cnq wcel vy cv cnq wcel wa vw vv vu vx cv vy cv crq cfv vz cv cmq
      vx visset vy cv crq fvex vz visset vw cv vv cv vw visset vv visset
      mulcompq vw cv vv cv vu cv vv visset vu visset mulasspq caopr31 a1i
      opreq12d vx cv vy cv crq cfv cmq co vy cv vz cv vy visset vz visset
      distrpq syl5eq adantrl breq2d bitr4d $.
      $( [25-Apr-1996] $)
  $}

  ${
    prlem936b.1 $e |- ( ( ( y .Q B ) e. A /\ ph ) -> ( y +Q z ) e. A ) $.
    prlem936b.2 $e |- ( ( ( A e. P. /\ ( y +Q z ) e. A ) /\
       ( x e. Q. /\ z e. Q. ) ) -> ( ps -> ch ) ) $.
    prlem936b.3 $e |- ( ( x e. Q. /\ ( z e. Q. /\ y e. Q. ) ) ->
       ( ch <-> th ) ) $.
    prlem936b.4 $e |- ( ( ( ( 1Q <Q B /\ x e. Q. ) /\ y e. Q. ) /\ ph ) ->
       ( th <-> ta ) ) $.
    prlem936b.5 $e |- ( ( A e. P. /\ ta ) ->
       ( ps -> -. ( x .Q B ) e. A ) ) $.
    $( Sublemma for Lemma 9-3.6 of [Gleason] p. 124. $)
    prlem936b $p |- ( ( ( A e. P. /\ z e. Q. ) /\ ( ( ph /\ y e. Q. ) /\
       ( 1Q <Q B /\ ( y .Q B ) e. A ) ) ) -> ( ( x e. A /\ ps ) ->
       ( x e. A /\ -. ( x .Q B ) e. A ) ) ) $=
      cA cnp wcel vz cv cnq wcel wa wph vy cv cnq wcel wa c1q cB cltq wbr vy cv
      cB cmq co cA wcel wa wa wa vx cv cA wcel wps vx cv cB cmq co cA wcel wn
      cA cnp wcel vz cv cnq wcel wa wph vy cv cnq wcel wa c1q cB cltq wbr vy cv
      cB cmq co cA wcel vx cv cA wcel wps vx cv cB cmq co cA wcel wn wi wi cA
      cnp wcel vz cv cnq wcel wa wph vy cv cnq wcel wa c1q cB cltq wbr vy cv cB
      cmq co cA wcel vx cv cA wcel wps vx cv cB cmq co cA wcel wn wi wi wi wi
      cA cnp wcel vz cv cnq wcel wa wph vy cv cnq wcel wa wa c1q cB cltq wbr vx
      cv cA wcel vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi cA
      cnp wcel vz cv cnq wcel wa wph vy cv cnq wcel wa wa c1q cB cltq wbr vx cv
      cA wcel vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi cA
      cnp wcel vz cv cnq wcel wph vy cv cnq wcel c1q cB cltq wbr vx cv cA wcel
      wa vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi wi cA cnp
      wcel wph vz cv cnq wcel vy cv cnq wcel c1q cB cltq wbr vx cv cA wcel wa
      vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi wi wi cA cnp
      wcel wph vz cv cnq wcel vy cv cnq wcel c1q cB cltq wbr vx cv cA wcel wa
      vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi wi cA cnp
      wcel c1q cB cltq wbr vx cv cA wcel wa vz cv cnq wcel vy cv cnq wcel wa
      wph vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi cA cnp
      wcel c1q cB cltq wbr vx cv cA wcel vz cv cnq wcel vy cv cnq wcel wa wph
      vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi wi wi c1q cB
      cltq wbr cA cnp wcel vx cv cA wcel vz cv cnq wcel vy cv cnq wcel wa wph
      vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi wi wi wi wi cA
      cnp wcel c1q cB cltq wbr cA cnp wcel vx cv cA wcel vz cv cnq wcel vy cv
      cnq wcel wa wph vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi
      wi wi wi cA cnp wcel c1q cB cltq wbr vx cv cnq wcel vz cv cnq wcel vy cv
      cnq wcel wa wph vy cv cB cmq co cA wcel wps vx cv cB cmq co cA wcel wn wi
      wi wi wi cA cnp wcel vx cv cA wcel wa cA cnp wcel c1q cB cltq wbr vx cv
      cnq wcel wa vz cv cnq wcel vy cv cnq wcel wa wph vy cv cB cmq co cA wcel
      wps vx cv cB cmq co cA wcel wn wi wi c1q cB cltq wbr vx cv cnq wcel wa vz
      cv cnq wcel vy cv cnq wcel wa wa wph wa vy cv cB cmq co cA wcel cA cnp
      wcel wps vx cv cB cmq co cA wcel wn wi c1q cB cltq wbr vx cv cnq wcel wa
      vz cv cnq wcel vy cv cnq wcel wa wa wph wa vy cv cB cmq co cA wcel cA cnp
      wcel wps vx cv cB cmq co cA wcel wn wta c1q cB cltq wbr vx cv cnq wcel wa
      vz cv cnq wcel vy cv cnq wcel wa wa wph wa vy cv cB cmq co cA wcel wa cA
      cnp wcel wps wa wa vx cv cB cmq co cA wcel wn c1q cB cltq wbr vx cv cnq
      wcel wa vz cv cnq wcel vy cv cnq wcel wa wa wph wa vy cv cB cmq co cA
      wcel wa cA cnp wcel wps wta c1q cB cltq wbr vx cv cnq wcel wa vz cv cnq
      wcel vy cv cnq wcel wa wa wph wa vy cv cB cmq co cA wcel wa cA cnp wcel
      wps wta wi c1q cB cltq wbr vx cv cnq wcel wa vz cv cnq wcel vy cv cnq
      wcel wa wa wph wa vy cv cB cmq co cA wcel wa cA cnp wcel wa wps wch wta
      c1q cB cltq wbr vx cv cnq wcel wa vz cv cnq wcel vy cv cnq wcel wa wa wph
      vy cv cB cmq co cA wcel cA cnp wcel wps wch wi c1q cB cltq wbr vx cv cnq
      wcel wa vz cv cnq wcel vy cv cnq wcel wa wa cA cnp wcel vy cv cB cmq co
      cA wcel wph wps wch wi c1q cB cltq wbr vx cv cnq wcel wa vz cv cnq wcel
      vy cv cnq wcel wa wa cA cnp wcel vy cv cB cmq co cA wcel wph wps wch wi
      vx cv cnq wcel vz cv cnq wcel cA cnp wcel vy cv cB cmq co cA wcel wph wa
      wa wps wch wi wi c1q cB cltq wbr vy cv cnq wcel cA cnp wcel vy cv cB cmq
      co cA wcel wph wa wa vx cv cnq wcel vz cv cnq wcel wa wps wch wi cA cnp
      wcel vy cv vz cv cplq co cA wcel vx cv cnq wcel vz cv cnq wcel wa wps wch
      wi wi vy cv cB cmq co cA wcel wph wa cA cnp wcel vy cv vz cv cplq co cA
      wcel wa vx cv cnq wcel vz cv cnq wcel wa wps wch wi prlem936b.2 ex
      prlem936b.1 sylan2 com12 ad2ant2lr exp4d com24 imp41 c1q cB cltq wbr vx
      cv cnq wcel wa vz cv cnq wcel vy cv cnq wcel wa wa wph wa wch wta wb vy
      cv cB cmq co cA wcel cA cnp wcel c1q cB cltq wbr vx cv cnq wcel wa vz cv
      cnq wcel vy cv cnq wcel wa wa wph wa wch wth wta c1q cB cltq wbr vx cv
      cnq wcel wa vz cv cnq wcel vy cv cnq wcel wa wa wch wth wb wph vx cv cnq
      wcel vz cv cnq wcel vy cv cnq wcel wa wch wth wb c1q cB cltq wbr
      prlem936b.3 adantll adantr c1q cB cltq wbr vx cv cnq wcel wa vy cv cnq
      wcel wph wth wta wb vz cv cnq wcel prlem936b.4 adantlrl bitrd ad2antrr
      sylibd ex imp32 wta cA cnp wcel wps wa vx cv cB cmq co cA wcel wn c1q cB
      cltq wbr vx cv cnq wcel wa vz cv cnq wcel vy cv cnq wcel wa wa wph wa vy
      cv cB cmq co cA wcel wa wta cA cnp wcel wps vx cv cB cmq co cA wcel wn cA
      cnp wcel wta wps vx cv cB cmq co cA wcel wn wi prlem936b.5 expcom imp3a
      adantld mpcom exp43 com3r exp4c cA vx cv elprpq sylan2i exp4d pm2.43a
      imp3a com24 exp4a com23 imp43 exp3a com34 ex imp45 imdistand $.
      $( [26-Apr-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z w v B $.
    prlem936.1 $e |- B e. _V $.
    $( Lemma 9-3.6 of [Gleason] p. 124. $)
    prlem936 $p |- ( ( A e. P. /\ 1Q <Q B ) ->
                   E. x ( x e. A /\ -. ( x .Q B ) e. A ) ) $=
      cA cnp wcel c1q cB cltq wbr vx cv cA wcel vx cv cB cmq co cA wcel wn wa
      vx wex cA cnp wcel vy cv cA wcel vy wex c1q cB cltq wbr vx cv cA wcel vx
      cv cB cmq co cA wcel wn wa vx wex wi cA cnp wcel cA c0 wne vy cv cA wcel
      vy wex cA prn0 vy cA n0 sylib cA cnp wcel vy cv cA wcel c1q cB cltq wbr
      vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi vy cA cnp wcel vy
      cv cA wcel c1q cB cltq wbr vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx
      wex wi cA cnp wcel vy cv cA wcel wa vy cv cB cmq co cA wcel c1q cB cltq
      wbr vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi cA cnp wcel vy
      cv cA wcel wa c1q cB cltq wbr vy cv cB cmq co cA wcel vx cv cA wcel vx cv
      cB cmq co cA wcel wn wa vx wex cA cnp wcel vy cv cnq wcel c1q cB cltq wbr
      vy cv cB cmq co cA wcel vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx
      wex wi wi cA cnp wcel vy cv cA wcel wa cA cnp wcel vy cv cnq wcel c1q cB
      cltq wbr vy cv cB cmq co cA wcel vx cv cA wcel vx cv cB cmq co cA wcel wn
      wa vx wex wi cA cnp wcel vy cv cnq wcel c1q cB cltq wbr wa vy cv cB cmq
      co cA wcel vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi cA cnp
      wcel vy cv cnq wcel c1q cB cltq wbr wa vy cv cnq wcel c1q cB cltq wbr vy
      cv cB cmq co cA wcel vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex
      wi cA cnp wcel vz cv cnq wcel vy cv vz cv cplq co vy cv cB cmq co wceq wa
      vz wex vy cv cnq wcel c1q cB cltq wbr vy cv cB cmq co cA wcel vx cv cA
      wcel vx cv cB cmq co cA wcel wn wa vx wex wi wi wi vy cv cnq wcel c1q cB
      cltq wbr wa cA cnp wcel vz cv cnq wcel vy cv vz cv cplq co vy cv cB cmq
      co wceq wa vy cv cnq wcel c1q cB cltq wbr vy cv cB cmq co cA wcel vx cv
      cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi wi wi vz cA cnp wcel vz
      cv cnq wcel vy cv vz cv cplq co vy cv cB cmq co wceq vy cv cnq wcel c1q
      cB cltq wbr vy cv cB cmq co cA wcel vx cv cA wcel vx cv cB cmq co cA wcel
      wn wa vx wex wi wi wi cA cnp wcel vz cv cnq wcel vy cv vz cv cplq co vy
      cv cB cmq co wceq vy cv cnq wcel c1q cB cltq wbr vy cv cB cmq co cA wcel
      vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi wi cA cnp wcel vz
      cv cnq wcel wa vy cv vz cv cplq co vy cv cB cmq co wceq vy cv cnq wcel wa
      c1q cB cltq wbr vy cv cB cmq co cA wcel vx cv cA wcel vx cv cB cmq co cA
      wcel wn wa vx wex cA cnp wcel vz cv cnq wcel wa vy cv vz cv cplq co vy cv
      cB cmq co wceq vy cv cnq wcel wa c1q cB cltq wbr vy cv cB cmq co cA wcel
      wa wa vx cv cA wcel vx cv vz cv cplq co cA wcel wn wa vx wex vx cv cA
      wcel vx cv cB cmq co cA wcel wn wa vx wex vx cA vz cv prlem934 cA cnp
      wcel vz cv cnq wcel wa vy cv vz cv cplq co vy cv cB cmq co wceq vy cv cnq
      wcel wa c1q cB cltq wbr vy cv cB cmq co cA wcel wa wa vx cv cA wcel vx cv
      vz cv cplq co cA wcel wn wa vx wex vx cv cA wcel vx cv cB cmq co cA wcel
      wn wa vx wex wi cA cnp wcel vz cv cnq wcel wa vy cv vz cv cplq co vy cv
      cB cmq co wceq vy cv cnq wcel wa c1q cB cltq wbr vy cv cB cmq co cA wcel
      wa wa wa vx cv cA wcel vx cv vz cv cplq co cA wcel wn wa vx cv cA wcel vx
      cv cB cmq co cA wcel wn wa vx vy cv vz cv cplq co vy cv cB cmq co wceq vx
      cv vz cv cplq co cA wcel wn vy cv vz cv cplq co vx cv vz cv cplq co cltq
      wbr vx cv vz cv cplq co vx cv vy cv crq cfv cmq co vy cv vz cv cplq co
      cmq co cltq wbr vx cv vz cv cplq co vx cv cB cmq co cltq wbr vx vy vz cA
      cB vy cv vz cv cplq co vy cv cB cmq co wceq vy cv vz cv cplq co cA wcel
      vy cv cB cmq co cA wcel vy cv vz cv cplq co vy cv cB cmq co cA eleq1
      biimparc cA cnp wcel vy cv vz cv cplq co cA wcel wa vx cv vz cv cplq co
      cnq wcel vx cv vz cv cplq co cA wcel wn vy cv vz cv cplq co vx cv vz cv
      cplq co cltq wbr wi vx cv cnq wcel vz cv cnq wcel wa cA vy cv vz cv cplq
      co vx cv vz cv cplq co prub vx cv vz cv addclpq sylan2 vx vy vz prlem936a
      c1q cB cltq wbr vx cv cnq wcel wa vy cv cnq wcel wa vy cv vz cv cplq co
      vy cv cB cmq co wceq wa vx cv vy cv crq cfv cmq co vy cv vz cv cplq co
      cmq co vx cv cB cmq co vx cv vz cv cplq co cltq vy cv vz cv cplq co vy cv
      cB cmq co wceq c1q cB cltq wbr vx cv cnq wcel wa vy cv cnq wcel wa vx cv
      vy cv crq cfv cmq co vy cv vz cv cplq co cmq co cB vx cv cmq co vy cv vy
      cv crq cfv cmq co cmq co vx cv cB cmq co vy cv vz cv cplq co vy cv cB cmq
      co wceq vx cv vy cv crq cfv cmq co vy cv vz cv cplq co cmq co vx cv vy cv
      crq cfv cmq co vy cv cB cmq co cmq co cB vx cv cmq co vy cv vy cv crq cfv
      cmq co cmq co vy cv vz cv cplq co vy cv cB cmq co vx cv vy cv crq cfv cmq
      co cmq opreq2 vy cv vy cv crq cfv cmq co cB vx cv cmq co cmq co vy cv cB
      cmq co vx cv vy cv crq cfv cmq co cmq co cB vx cv cmq co vy cv vy cv crq
      cfv cmq co cmq co vx cv vy cv crq cfv cmq co vy cv cB cmq co cmq co vz vw
      vv vy cv vy cv crq cfv cB vx cv cmq vy visset vy cv crq fvex prlem936.1
      vz cv vw cv vz visset vw visset mulcompq vz cv vw cv vv cv vw visset vv
      visset mulasspq vx visset caopr42 cB vx cv cmq co vy cv vy cv crq cfv cmq
      co cB vx cv cmq oprex vy cv vy cv crq cfv cmq oprex mulcompq vx cv vy cv
      crq cfv cmq co vy cv cB cmq co vx cv vy cv crq cfv cmq oprex vy cv cB cmq
      oprex mulcompq 3eqtr4i syl6eqr vy cv cnq wcel c1q cB cltq wbr vx cv cnq
      wcel wa cB vx cv cmq co vy cv vy cv crq cfv cmq co cmq co cB vx cv cmq co
      c1q cmq co vx cv cB cmq co vy cv cnq wcel vy cv vy cv crq cfv cmq co c1q
      cB vx cv cmq co cmq vy cv recidpq opreq2d c1q cB cltq wbr vx cv cnq wcel
      wa cB cnq wcel vx cv cnq wcel wa cB vx cv cmq co cnq wcel cB vx cv cmq co
      c1q cmq co vx cv cB cmq co wceq c1q cB cltq wbr cB cnq wcel vx cv cnq
      wcel c1q cB cltq wbr c1q cnq wcel cB cnq wcel c1q cB cnq cnq cltq
      prlem936.1 ltrelpq brel pm3.27d anim1i cB vx cv mulclpq cB vx cv cmq co
      cnq wcel cB vx cv cmq co c1q cmq co cB vx cv cmq co vx cv cB cmq co cB vx
      cv cmq co mulidpq vx cv cB vx visset prlem936.1 mulcompq syl6eqr 3syl
      sylan9eqr sylan9eqr breq2d cA cnp wcel vx cv vz cv cplq co vx cv cB cmq
      co cltq wbr wa vx cv cB cmq co cA wcel vx cv vz cv cplq co cA wcel cA cnp
      wcel vx cv vz cv cplq co vx cv cB cmq co cltq wbr vx cv cB cmq co cA wcel
      vx cv vz cv cplq co cA wcel wi cA cnp wcel vx cv cB cmq co cA wcel vx cv
      vz cv cplq co vx cv cB cmq co cltq wbr vx cv vz cv cplq co cA wcel cA cnp
      wcel vx cv cB cmq co cA wcel vx cv vz cv cplq co vx cv cB cmq co cltq wbr
      vx cv vz cv cplq co cA wcel wi cA vx cv cB cmq co vx cv vz cv cplq co
      prcdpq ex com23 imp con3d prlem936b 19.22dv ex mpid exp4d exp4b imp3a
      19.23adv vy cv cnq wcel c1q cB cltq wbr vz cv cnq wcel vy cv vz cv cplq
      co vy cv cB cmq co wceq wa vz wex vy cv cnq wcel c1q cB cltq wbr vy cv vy
      cv cB cmq co cltq wbr vz cv cnq wcel vy cv vz cv cplq co vy cv cB cmq co
      wceq wa vz wex vy cv cnq wcel c1q cB cltq wbr vy cv c1q cmq co vy cv cB
      cmq co cltq wbr vy cv vy cv cB cmq co cltq wbr c1q cB vy cv c1q cnq 1q
      elisseti prlem936.1 ltmpq vy cv cnq wcel vy cv c1q cmq co vy cv vy cv cB
      cmq co cltq vy cv mulidpq breq1d bitrd vy cv vy cv cB cmq co cltq wbr vy
      cv cnq wcel vy cv cB cmq co cnq wcel wa vz cv cnq wcel vy cv vz cv cplq
      co vy cv cB cmq co wceq wa vz wex vy cv vy cv cB cmq co cnq cnq cltq vy
      cv cB cmq oprex ltrelpq brel vy cv cnq wcel vy cv cB cmq co cnq wcel wa
      vy cv vy cv cB cmq co cltq wbr vz cv cnq wcel vy cv vz cv cplq co vy cv
      cB cmq co wceq wa vz wex vz vy cv vy cv cB cmq co vy visset ltexpq2
      biimpcd mpd syl6bi imp syl5 imp4a pm2.43d exp3a cA cnp wcel vy cv cA wcel
      pm3.26 cA vy cv elprpq sylc com23 vy cv cA wcel vy cv cB cmq co cA wcel
      wn c1q cB cltq wbr vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi
      wi cA cnp wcel vy cv cA wcel vy cv cB cmq co cA wcel wn c1q cB cltq wbr
      vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx wex wi vy cv cA wcel vy cv
      cB cmq co cA wcel wn wa vx cv cA wcel vx cv cB cmq co cA wcel wn wa vx
      wex c1q cB cltq wbr vx cv cA wcel vx cv cB cmq co cA wcel wn wa vy cv cA
      wcel vy cv cB cmq co cA wcel wn wa vx vy cv vy visset vx cv vy cv wceq vx
      cv cA wcel vy cv cA wcel vx cv cB cmq co cA wcel wn vy cv cB cmq co cA
      wcel wn vx cv vy cv cA eleq1 vx cv vy cv wceq vx cv cB cmq co cA wcel vy
      cv cB cmq co cA wcel vx cv vy cv wceq vx cv cB cmq co vy cv cB cmq co cA
      vx cv vy cv cB cmq opreq1 eleq1d notbid anbi12d cla4ev a1d ex adantl
      pm2.61d ex 19.23adv mpd imp $.
      $( [26-Apr-1996] $)
  $}

  ${
    $d x y z w v u f g A $.  $d x z w v u f g B $.
    reclempr.1 $e |- B = { x | E. y ( x <Q y /\ -. ( *Q ` y ) e. A ) } $.
    $( Lemma for Proposition 9-3.7 of [Gleason] p. 124. $)
    reclem1pr $p |- ( A e. P. -> (/) C. B ) $=
      cA cnp wcel vx cv cB wcel vx wex c0 cB wpss cA cnp wcel vx cv vy cv cltq
      wbr vy cv crq cfv cA wcel wn wa vy wex vx wex vx cv cB wcel vx wex cA cnp
      wcel vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vx wex vy wex vx cv
      vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx wex cA cnp wcel vy
      cv cnq wcel vy cv crq cfv cA wcel wn wa vy wex vx cv vy cv cltq wbr vy cv
      crq cfv cA wcel wn wa vx wex vy wex cA cnp wcel cA cnq wpss vx cv cnq
      wcel vx cv cA wcel wn wa vx wex vy cv cnq wcel vy cv crq cfv cA wcel wn
      wa vy wex cA prpssnq vx cA cnq pssnel vx cv cnq wcel vx cv cA wcel wn wa
      vy cv cnq wcel vy cv crq cfv cA wcel wn wa vy wex vx vx cv cnq wcel vx cv
      cA wcel wn wa vx cv crq cfv cnq wcel vx cv crq cfv crq cfv cA wcel wn wa
      vy cv cnq wcel vy cv crq cfv cA wcel wn wa vy wex vx cv crq cfv cnq wcel
      vx cv crq cfv crq cfv cA wcel wn wa vx cv cnq wcel vx cv crq cfv crq cfv
      cA wcel wn wa vx cv cnq wcel vx cv cA wcel wn wa vx cv cnq wcel vx cv crq
      cfv cnq wcel vx cv crq cfv crq cfv cA wcel wn vx cv cnq wcel vx cv crq
      cfv cnq wcel vx cv recclpq vx cv cnq crq dmrecpq 0npq ndmfvrcl impbii
      anbi1i vx cv cnq wcel vx cv crq cfv crq cfv cA wcel wn vx cv cA wcel wn
      vx cv cnq wcel vx cv crq cfv crq cfv cA wcel vx cv cA wcel vx cv cnq wcel
      vx cv crq cfv crq cfv vx cv cA vx cv vx visset recrecpq eleq1d notbid
      pm5.32i bitr3i vy cv cnq wcel vy cv crq cfv cA wcel wn wa vx cv crq cfv
      cnq wcel vx cv crq cfv crq cfv cA wcel wn wa vy vx cv crq cfv vx cv crq
      fvex vy cv vx cv crq cfv wceq vy cv cnq wcel vx cv crq cfv cnq wcel vy cv
      crq cfv cA wcel wn vx cv crq cfv crq cfv cA wcel wn vy cv vx cv crq cfv
      cnq eleq1 vy cv vx cv crq cfv wceq vy cv crq cfv cA wcel vx cv crq cfv
      crq cfv cA wcel vy cv vx cv crq cfv wceq vy cv crq cfv vx cv crq cfv crq
      cfv cA vy cv vx cv crq cfv crq fveq2 eleq1d notbid anbi12d cla4ev sylbir
      19.23aiv 3syl vy cv cnq wcel vy cv crq cfv cA wcel wn wa vx cv vy cv cltq
      wbr vy cv crq cfv cA wcel wn wa vx wex vy vy cv cnq wcel vy cv crq cfv cA
      wcel wn wa vx cv vy cv cltq wbr vx wex vy cv crq cfv cA wcel wn wa vx cv
      vy cv cltq wbr vy cv crq cfv cA wcel wn wa vx wex vy cv cnq wcel vx cv vy
      cv cltq wbr vx wex vy cv crq cfv cA wcel wn vx vy cv nsmallpq anim1i vx
      cv vy cv cltq wbr vy cv crq cfv cA wcel wn vx 19.41v sylibr 19.22i syl vx
      cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vx vy excom sylibr vx cv cB
      wcel vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx vx cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cB reclempr.1 abeq2i
      exbii sylibr c0 cB wpss cB c0 wne vx cv cB wcel vx wex cB 0pss vx cB n0
      bitri sylibr $.
      $( [26-Apr-1996] $)

    $( Lemma for Proposition 9-3.7 of [Gleason] p. 124. $)
    reclem2pr $p |- ( A e. P. -> B e. P. ) $=
      cA cnp wcel c0 cB wpss cB cnq wpss wa vz cv vx cv cltq wbr vz cv cB wcel
      wi vz wal vx cv vz cv cltq wbr vz cB wrex wa vx cB wral wa cB cnp wcel cA
      cnp wcel c0 cB wpss cB cnq wpss wa vz cv vx cv cltq wbr vz cv cB wcel wi
      vz wal vx cv vz cv cltq wbr vz cB wrex wa vx cB wral cA cnp wcel c0 cB
      wpss cB cnq wpss vx vy cA cB reclempr.1 reclem1pr cA cnp wcel cB cnq wss
      cnq cB wss wn wa cB cnq wpss cA cnp wcel cnq cB wss wn cB cnq wss cA cnp
      wcel cA c0 wne cnq cB wss wn cA prn0 cA cnp wcel vz cv cA wcel vz wex vx
      cv cnq wcel vx cv cB wcel wn wa vx wex cA c0 wne cnq cB wss wn cA cnp
      wcel vz cv cA wcel vx cv cnq wcel vx cv cB wcel wn wa vx wex vz cA cnp
      wcel vz cv cA wcel vx cv cnq wcel vx cv cB wcel wn wa vx wex cA cnp wcel
      vz cv cA wcel wa cA cnp wcel vx cv crq cfv cA wcel wa vx wex vx cv cnq
      wcel vx cv cB wcel wn wa vx wex cA cnp wcel vz cv cA wcel wa cA cnp wcel
      vx cv crq cfv cA wcel wa vx wex cA cnp wcel vz cv cA wcel wa cA cnp wcel
      vz cv cA wcel wa cA cnp wcel vz cv crq cfv crq cfv cA wcel wa cA cnp wcel
      vx cv crq cfv cA wcel wa vx wex cA cnp wcel vz cv cA wcel wa vz cv cnq
      wcel cA cnp wcel vz cv crq cfv crq cfv cA wcel wa cA cnp wcel vz cv cA
      wcel wa wb cA vz cv elprpq vz cv cnq wcel vz cv crq cfv crq cfv cA wcel
      vz cv cA wcel cA cnp wcel vz cv cnq wcel vz cv crq cfv crq cfv vz cv cA
      vz cv vz visset recrecpq eleq1d anbi2d syl cA cnp wcel vx cv crq cfv cA
      wcel wa cA cnp wcel vz cv crq cfv crq cfv cA wcel wa vx vz cv crq cfv vz
      cv crq fvex vx cv vz cv crq cfv wceq vx cv crq cfv cA wcel vz cv crq cfv
      crq cfv cA wcel cA cnp wcel vx cv vz cv crq cfv wceq vx cv crq cfv vz cv
      crq cfv crq cfv cA vx cv vz cv crq cfv crq fveq2 eleq1d anbi2d cla4ev
      syl6bir pm2.43i cA cnp wcel vx cv crq cfv cA wcel wa vx cv cnq wcel vx cv
      cB wcel wn wa vx cA cnp wcel vx cv crq cfv cA wcel wa vx cv cnq wcel vx
      cv cB wcel wn cA cnp wcel vx cv crq cfv cA wcel wa vx cv crq cfv cnq wcel
      vx cv cnq wcel cA vx cv crq cfv elprpq vx cv cnq crq dmrecpq 0npq
      ndmfvrcl syl cA cnp wcel vx cv crq cfv cA wcel wa vx cv vy cv cltq wbr vy
      cv crq cfv cA wcel wi vy wal vx cv cB wcel wn cA cnp wcel vx cv crq cfv
      cA wcel wa vx cv vy cv cltq wbr vy cv crq cfv cA wcel wi vy cA cnp wcel
      vx cv crq cfv cA wcel wa vy cv crq cfv vx cv crq cfv cltq wbr vy cv crq
      cfv cA wcel vx cv vy cv cltq wbr cA vx cv crq cfv vy cv crq cfv prcdpq vx
      cv vy cv vx visset vy visset ltrpq syl5 19.21aiv vx cv cB wcel vx cv vy
      cv cltq wbr vy cv crq cfv cA wcel wi vy wal vx cv cB wcel vx cv vy cv
      cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cv vy cv cltq wbr vy cv
      crq cfv cA wcel wi vy wal wn vx cv vy cv cltq wbr vy cv crq cfv cA wcel
      wn wa vy wex vx cB reclempr.1 abeq2i vx cv vy cv cltq wbr vy cv crq cfv
      cA wcel vy exanali bitri con2bii sylib jca 19.22i syl ex 19.23adv vz cA
      n0 vx cnq cB nss 3imtr4g mpd vx cB cnq vx cv cB wcel vx cv vy cv cltq wbr
      vy cv crq cfv cA wcel wn wa vy wex vx cv cnq wcel vx cv vy cv cltq wbr vy
      cv crq cfv cA wcel wn wa vy wex vx cB reclempr.1 abeq2i vx cv vy cv cltq
      wbr vy cv crq cfv cA wcel wn wa vx cv cnq wcel vy vx cv vy cv cltq wbr vx
      cv cnq wcel vy cv crq cfv cA wcel wn vx cv vy cv cltq wbr vx cv cnq wcel
      vy cv cnq wcel vx cv vy cv cnq cnq cltq vy visset ltrelpq brel pm3.26d
      adantr 19.23aiv sylbi ssriv jctil cB cnq dfpss3 sylibr jca vz cv vx cv
      cltq wbr vz cv cB wcel wi vz wal vx cv vz cv cltq wbr vz cB wrex wa vx cB
      vx cv cB wcel vz cv vx cv cltq wbr vz cv cB wcel wi vz wal vx cv vz cv
      cltq wbr vz cB wrex vx cv cB wcel vz cv vx cv cltq wbr vz cv cB wcel wi
      vz vz cv vx cv cltq wbr vx cv cB wcel vz cv cB wcel vz cv vx cv cltq wbr
      vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vz cv vy cv cltq
      wbr vy cv crq cfv cA wcel wn wa vy wex vx cv cB wcel vz cv cB wcel vz cv
      vx cv cltq wbr vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vz cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy vz cv vx cv cltq wbr vx cv vy
      cv cltq wbr vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn vz cv vx cv
      cltq wbr vx cv vy cv cltq wbr vz cv vy cv cltq wbr vz cv vx cv vy cv cltq
      cnq vz visset ltsopq ltrelpq vx visset vy visset sotri ex anim1d 19.22dv
      vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cB reclempr.1
      abeq2i vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vz cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx vz cv cB vz visset vx
      cv vz cv wceq vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vz cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy vx cv vz cv wceq vx cv vy cv
      cltq wbr vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn vx cv vz cv vy cv
      cltq breq1 anbi1d exbidv reclempr.1 elab2 3imtr4g com12 19.21aiv vx cv cB
      wcel vz cv cB wcel vx cv vz cv cltq wbr wa vz wex vx cv vz cv cltq wbr vz
      cB wrex vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cv vz
      cv cltq wbr vz cv vy cv cltq wbr wa vy cv crq cfv cA wcel wn wa vz wex vy
      wex vx cv cB wcel vz cv cB wcel vx cv vz cv cltq wbr wa vz wex vx cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vx cv vz cv cltq wbr vz cv vy cv
      cltq wbr wa vy cv crq cfv cA wcel wn wa vz wex vy vx cv vy cv cltq wbr vy
      cv crq cfv cA wcel wn wa vx cv vz cv cltq wbr vz cv vy cv cltq wbr wa vz
      wex vy cv crq cfv cA wcel wn wa vx cv vz cv cltq wbr vz cv vy cv cltq wbr
      wa vy cv crq cfv cA wcel wn wa vz wex vx cv vy cv cltq wbr vx cv vz cv
      cltq wbr vz cv vy cv cltq wbr wa vz wex vy cv crq cfv cA wcel wn vz vx cv
      vy cv vx visset vy visset ltbtwnpq anim1i vx cv vz cv cltq wbr vz cv vy
      cv cltq wbr wa vy cv crq cfv cA wcel wn vz 19.41v sylibr 19.22i vx cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cB reclempr.1 abeq2i vz
      cv cB wcel vx cv vz cv cltq wbr wa vz wex vx cv vz cv cltq wbr vz cv vy
      cv cltq wbr wa vy cv crq cfv cA wcel wn wa vy wex vz wex vx cv vz cv cltq
      wbr vz cv vy cv cltq wbr wa vy cv crq cfv cA wcel wn wa vz wex vy wex vx
      cv vz cv cltq wbr vz cv vy cv cltq wbr wa vy cv crq cfv cA wcel wn wa vy
      wex vz cv cB wcel vx cv vz cv cltq wbr wa vz vz cv vy cv cltq wbr vy cv
      crq cfv cA wcel wn wa vx cv vz cv cltq wbr wa vy wex vz cv vy cv cltq wbr
      vy cv crq cfv cA wcel wn wa vy wex vx cv vz cv cltq wbr wa vx cv vz cv
      cltq wbr vz cv vy cv cltq wbr wa vy cv crq cfv cA wcel wn wa vy wex vz cv
      cB wcel vx cv vz cv cltq wbr wa vz cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn wa vx cv vz cv cltq wbr vy 19.41v vx cv vz cv cltq wbr vz cv vy
      cv cltq wbr wa vy cv crq cfv cA wcel wn wa vz cv vy cv cltq wbr vy cv crq
      cfv cA wcel wn wa vx cv vz cv cltq wbr wa vy vx cv vz cv cltq wbr vz cv
      vy cv cltq wbr wa vy cv crq cfv cA wcel wn wa vx cv vz cv cltq wbr vz cv
      vy cv cltq wbr vy cv crq cfv cA wcel wn wa wa vz cv vy cv cltq wbr vy cv
      crq cfv cA wcel wn wa vx cv vz cv cltq wbr wa vx cv vz cv cltq wbr vz cv
      vy cv cltq wbr vy cv crq cfv cA wcel wn anass vx cv vz cv cltq wbr vz cv
      vy cv cltq wbr vy cv crq cfv cA wcel wn wa ancom bitri exbii vz cv cB
      wcel vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cv vz cv
      cltq wbr vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vz cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx vz cv cB vz visset vx
      cv vz cv wceq vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vz cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy vx cv vz cv wceq vx cv vy cv
      cltq wbr vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn vx cv vz cv vy cv
      cltq breq1 anbi1d exbidv reclempr.1 elab2 anbi1i 3bitr4i exbii vx cv vz
      cv cltq wbr vz cv vy cv cltq wbr wa vy cv crq cfv cA wcel wn wa vz vy
      excom bitr3i 3imtr4i vx cv vz cv cltq wbr vz cB df-rex sylibr jca rgen
      jctir vx vz cB elnp sylibr $.
      $( [30-Apr-1996] $)

    $( Lemma for Proposition 9-3.7(v) of [Gleason] p. 124. $)
    reclem3pr $p |- ( A e. P. -> 1P C_ ( A .P. B ) ) $=
      cA cnp wcel vw c1p cA cB cmp co cA cnp wcel vw cv c1q cltq wbr vw cv cA
      cB cmp co wcel vw cv c1p wcel cA cnp wcel vw cv c1q cltq wbr vz cv cA
      wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co wceq wa vx wex vz wex vw
      cv cA cB cmp co wcel cA cnp wcel vw cv c1q cltq wbr vz cv cA wcel vx cv
      cB wcel wa vw cv vz cv vx cv cmq co wceq wa vx wex vz wex cA cnp wcel vw
      cv c1q cltq wbr wa vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq
      co wceq wa vx wex vz wex cA cnp wcel vw cv c1q cltq wbr wa cA cnp wcel vw
      cv cnq wcel vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co wceq
      wa vx wex vz wex vw cv c1q cltq wbr cA cnp wcel c1q vw cv crq cfv cltq
      wbr cA cnp wcel vw cv cnq wcel wa vz cv cA wcel vx cv cB wcel wa vw cv vz
      cv vx cv cmq co wceq wa vx wex vz wex wi vw cv c1q cltq wbr cA cnp wcel
      c1q vw cv crq cfv cltq wbr wa vv cv cA wcel vv cv vw cv crq cfv cmq co cA
      wcel wn wa vv wex cA cnp wcel vw cv cnq wcel wa vz cv cA wcel vx cv cB
      wcel wa vw cv vz cv vx cv cmq co wceq wa vx wex vz wex wi vv cA vw cv crq
      cfv vw cv crq fvex prlem936 vv cv cA wcel vv cv vw cv crq cfv cmq co cA
      wcel wn wa cA cnp wcel vw cv cnq wcel wa vz cv cA wcel vx cv cB wcel wa
      vw cv vz cv vx cv cmq co wceq wa vx wex vz wex wi vv vv cv cA wcel vv cv
      vw cv crq cfv cmq co cA wcel wn cA cnp wcel vw cv cnq wcel vz cv cA wcel
      vx cv cB wcel wa vw cv vz cv vx cv cmq co wceq wa vx wex vz wex vw cv cnq
      wcel vv cv vw cv crq cfv cmq co cA wcel wn cA cnp wcel vv cv cA wcel vz
      cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co wceq wa vx wex vz
      wex vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn cA cnp wcel vv
      cv cA wcel vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co wceq
      wa vx wex vz wex vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa
      vz cv cA wcel vv cv vz cv cltq wbr wa vz wex vz cv cA wcel vx cv cB wcel
      wa vw cv vz cv vx cv cmq co wceq wa vx wex vz wex cA cnp wcel vv cv cA
      wcel wa vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa vz cv cA
      wcel vv cv vz cv cltq wbr wa vz cv cA wcel vx cv cB wcel wa vw cv vz cv
      vx cv cmq co wceq wa vx wex vz vz cv cA wcel vv cv vz cv cltq wbr wa vw
      cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa vz cv cA wcel vx cv
      cB wcel wa vw cv vz cv vx cv cmq co wceq wa vx wex vz cv cA wcel vv cv vz
      cv cltq wbr wa vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa wa
      vx cv vz cv crq cfv vw cv cmq co wceq vx wex vz cv cA wcel vx cv cB wcel
      wa vw cv vz cv vx cv cmq co wceq wa vx wex vx vz cv crq cfv vw cv cmq co
      vz cv crq cfv vw cv cmq oprex isseti vz cv cA wcel vv cv vz cv cltq wbr
      wa vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa wa vx cv vz cv
      crq cfv vw cv cmq co wceq vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx
      cv cmq co wceq wa vx vz cv cA wcel vv cv vz cv cltq wbr vw cv cnq wcel vv
      cv vw cv crq cfv cmq co cA wcel wn wa vx cv vz cv crq cfv vw cv cmq co
      wceq vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co wceq wa wi
      vz cv cA wcel vv cv vz cv cltq wbr vw cv cnq wcel vv cv vw cv crq cfv cmq
      co cA wcel wn wa vx cv vz cv crq cfv vw cv cmq co wceq vz cv cA wcel vx
      cv cB wcel wa vw cv vz cv vx cv cmq co wceq wa vz cv cA wcel vv cv vz cv
      cltq wbr vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa wa vx cv
      vz cv crq cfv vw cv cmq co wceq wa wa vz cv cA wcel vx cv cB wcel wa vw
      cv vz cv vx cv cmq co wceq vv cv vz cv cltq wbr vw cv cnq wcel vv cv vw
      cv crq cfv cmq co cA wcel wn wa wa vx cv vz cv crq cfv vw cv cmq co wceq
      wa vx cv cB wcel vz cv cA wcel vv cv vz cv cltq wbr vw cv cnq wcel vv cv
      vw cv crq cfv cmq co cA wcel wn vx cv vz cv crq cfv vw cv cmq co wceq vx
      cv cB wcel vw cv cnq wcel vv cv vz cv cltq wbr vv cv vw cv crq cfv cmq co
      cA wcel wn vx cv vz cv crq cfv vw cv cmq co wceq vx cv cB wcel wi wi vv
      cv vz cv cltq wbr vw cv cnq wcel vv cv vz cv cltq wbr vv cv vw cv crq cfv
      cmq co cA wcel wn vx cv vz cv crq cfv vw cv cmq co wceq vx cv cB wcel wi
      vv cv cnq wcel vw cv cnq wcel vv cv vz cv cltq wbr vv cv vw cv crq cfv
      cmq co cA wcel wn wa vx cv vz cv crq cfv vw cv cmq co wceq vx cv cB wcel
      wi wi vv cv vz cv cltq wbr vv cv cnq wcel vw cv cnq wcel wa vv cv vz cv
      cltq wbr vv cv vw cv crq cfv cmq co cA wcel wn wa vx cv vz cv crq cfv vw
      cv cmq co wceq vx cv vv cv crq cfv vw cv cmq co cltq wbr vv cv crq cfv vw
      cv cmq co crq cfv cA wcel wn wa vx cv cB wcel vv cv cnq wcel vw cv cnq
      wcel wa vv cv vz cv cltq wbr vv cv vw cv crq cfv cmq co cA wcel wn wa vz
      cv crq cfv vw cv cmq co vv cv crq cfv vw cv cmq co cltq wbr vv cv crq cfv
      vw cv cmq co crq cfv cA wcel wn wa vx cv vz cv crq cfv vw cv cmq co wceq
      vx cv vv cv crq cfv vw cv cmq co cltq wbr vv cv crq cfv vw cv cmq co crq
      cfv cA wcel wn wa wi vv cv cnq wcel vw cv cnq wcel wa vv cv vz cv cltq
      wbr vz cv crq cfv vw cv cmq co vv cv crq cfv vw cv cmq co cltq wbr vv cv
      vw cv crq cfv cmq co cA wcel wn vv cv crq cfv vw cv cmq co crq cfv cA
      wcel wn vw cv cnq wcel vv cv vz cv cltq wbr vz cv crq cfv vw cv cmq co vv
      cv crq cfv vw cv cmq co cltq wbr wi vv cv cnq wcel vw cv cnq wcel vz cv
      crq cfv vv cv crq cfv cltq wbr vz cv crq cfv vw cv cmq co vv cv crq cfv
      vw cv cmq co cltq wbr vv cv vz cv cltq wbr vx vy vu vz cv crq cfv vv cv
      crq cfv vw cv cltq cnq cmq vz cv crq fvex vv cv crq fvex vx cv vy cv vu
      cv vx visset vy visset ltmpq vw visset vx cv vy cv vx visset vy visset
      mulcompq caoprord2 vv cv vz cv vv visset vz visset ltrpq syl5bi adantl vv
      cv cnq wcel vw cv cnq wcel wa vv cv crq cfv vw cv cmq co crq cfv cA wcel
      wn vv cv vw cv crq cfv cmq co cA wcel wn vv cv cnq wcel vw cv cnq wcel wa
      vv cv crq cfv vw cv cmq co crq cfv cA wcel vv cv vw cv crq cfv cmq co cA
      wcel vv cv cnq wcel vw cv cnq wcel wa vv cv crq cfv vw cv cmq co crq cfv
      vv cv vw cv crq cfv cmq co cA vv cv cnq wcel vw cv cnq wcel wa vv cv crq
      cfv vw cv cmq co crq cfv vv cv vw cv crq cfv cmq co wceq vv cv crq cfv vw
      cv cmq co vv cv vw cv crq cfv cmq co cmq co c1q wceq vv cv cnq wcel vw cv
      cnq wcel wa vv cv crq cfv vv cv cmq co vw cv vw cv crq cfv cmq co cmq co
      c1q c1q cmq co vv cv crq cfv vw cv cmq co vv cv vw cv crq cfv cmq co cmq
      co c1q vv cv cnq wcel vw cv cnq wcel vv cv crq cfv vv cv cmq co c1q vw cv
      vw cv crq cfv cmq co c1q cmq vv cv cnq wcel vv cv vv cv crq cfv cmq co
      c1q vv cv crq cfv vv cv cmq co vv cv recidpq vv cv vv cv crq cfv vv
      visset vv cv crq fvex mulcompq syl5eqr vw cv recidpq opreqan12d vx vy vu
      vv cv crq cfv vv cv vw cv vw cv crq cfv cmq vv cv crq fvex vv visset vw
      visset vx cv vy cv vx visset vy visset mulcompq vx cv vy cv vu cv vy
      visset vu visset mulasspq vw cv crq fvex caopr4 c1q cnq wcel c1q c1q cmq
      co c1q wceq 1q c1q mulidpq ax-mp 3eqtr3g vv cv cnq wcel vw cv cnq wcel wa
      vv cv crq cfv vw cv cmq co cnq wcel vv cv crq cfv vw cv cmq co crq cfv vv
      cv vw cv crq cfv cmq co wceq vv cv crq cfv vw cv cmq co vv cv vw cv crq
      cfv cmq co cmq co c1q wceq wb vv cv crq cfv cnq wcel vw cv cnq wcel vv cv
      crq cfv vw cv cmq co cnq wcel vv cv cnq wcel vv cv crq cfv vw cv mulclpq
      vv cv recclpq sylan vv cv crq cfv vw cv cmq co vv cv vw cv crq cfv cmq co
      vv cv vw cv crq cfv cmq oprex recmulpq syl mpbird eleq1d notbid biimprd
      anim12d vx cv vz cv crq cfv vw cv cmq co wceq vx cv vv cv crq cfv vw cv
      cmq co cltq wbr vv cv crq cfv vw cv cmq co crq cfv cA wcel wn wa vz cv
      crq cfv vw cv cmq co vv cv crq cfv vw cv cmq co cltq wbr vv cv crq cfv vw
      cv cmq co crq cfv cA wcel wn wa vx cv vz cv crq cfv vw cv cmq co wceq vx
      cv vv cv crq cfv vw cv cmq co cltq wbr vz cv crq cfv vw cv cmq co vv cv
      crq cfv vw cv cmq co cltq wbr vv cv crq cfv vw cv cmq co crq cfv cA wcel
      wn vx cv vz cv crq cfv vw cv cmq co vv cv crq cfv vw cv cmq co cltq breq1
      anbi1d biimprcd syl6 vx cv vv cv crq cfv vw cv cmq co cltq wbr vv cv crq
      cfv vw cv cmq co crq cfv cA wcel wn wa vx cv vy cv cltq wbr vy cv crq cfv
      cA wcel wn wa vy wex vx cv cB wcel vx cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn wa vx cv vv cv crq cfv vw cv cmq co cltq wbr vv cv crq cfv vw cv
      cmq co crq cfv cA wcel wn wa vy vv cv crq cfv vw cv cmq co vv cv crq cfv
      vw cv cmq oprex vy cv vv cv crq cfv vw cv cmq co wceq vx cv vy cv cltq
      wbr vx cv vv cv crq cfv vw cv cmq co cltq wbr vy cv crq cfv cA wcel wn vv
      cv crq cfv vw cv cmq co crq cfv cA wcel wn vy cv vv cv crq cfv vw cv cmq
      co vx cv cltq breq2 vy cv vv cv crq cfv vw cv cmq co wceq vy cv crq cfv
      cA wcel vv cv crq cfv vw cv cmq co crq cfv cA wcel vy cv vv cv crq cfv vw
      cv cmq co wceq vy cv crq cfv vv cv crq cfv vw cv cmq co crq cfv cA vy cv
      vv cv crq cfv vw cv cmq co crq fveq2 eleq1d notbid anbi12d cla4ev vx cv
      vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx cB reclempr.1 abeq2i
      sylibr syl8 vv cv vz cv cltq wbr vv cv cnq wcel vz cv cnq wcel vv cv vz
      cv cnq cnq cltq vz visset ltrelpq brel pm3.26d sylan exp4b pm2.43a imp42
      anim2i vv cv vz cv cltq wbr vw cv cnq wcel vv cv vw cv crq cfv cmq co cA
      wcel wn wa wa vx cv vz cv crq cfv vw cv cmq co wceq wa vw cv vz cv vx cv
      cmq co wceq vz cv cA wcel vv cv vz cv cltq wbr vw cv cnq wcel vv cv vw cv
      crq cfv cmq co cA wcel wn wa wa vx cv vz cv crq cfv vw cv cmq co wceq wa
      vz cv vx cv cmq co vw cv vx cv vz cv crq cfv vw cv cmq co wceq vv cv vz
      cv cltq wbr vw cv cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa wa vz
      cv vx cv cmq co vz cv vz cv crq cfv vw cv cmq co cmq co vw cv vx cv vz cv
      crq cfv vw cv cmq co vz cv cmq opreq2 vz cv cnq wcel vw cv cnq wcel vz cv
      vz cv crq cfv vw cv cmq co cmq co vw cv wceq vv cv vz cv cltq wbr vw cv
      cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn wa vz cv cnq wcel vw cv
      cnq wcel vz cv vz cv crq cfv vw cv cmq co cmq co c1q vw cv cmq co vw cv
      vz cv cnq wcel vz cv vz cv crq cfv cmq co vw cv cmq co c1q vw cv cmq co
      vz cv vz cv crq cfv vw cv cmq co cmq co vz cv cnq wcel vz cv vz cv crq
      cfv cmq co c1q vw cv cmq vz cv recidpq opreq1d vz cv vz cv crq cfv vw cv
      vz cv crq fvex vw visset mulasspq syl5eqr vw cv cnq wcel vw cv c1q cmq co
      vw cv c1q vw cv cmq co vw cv mulidpq vw cv c1q vw visset c1q cnq 1q
      elisseti mulcompq syl5eqr sylan9eq vv cv vz cv cltq wbr vv cv cnq wcel vz
      cv cnq wcel vv cv vz cv cnq cnq cltq vz visset ltrelpq brel pm3.27d vw cv
      cnq wcel vv cv vw cv crq cfv cmq co cA wcel wn pm3.26 syl2an sylan9eqr
      eqcomd adantl jca exp44 imp31 19.22dv mpi expcom 19.22dv vz cA vv cv
      prnmax syl5 exp4b com14 imp4b 19.23aiv syl vw cv c1q cltq wbr c1q crq cfv
      vw cv crq cfv c1q cltq vw cv c1q vw visset c1q cnq 1q elisseti ltrpq c1q
      crq cfv c1q cmq co c1q c1q crq cfv cmq co c1q crq cfv c1q c1q crq cfv c1q
      c1q crq fvex c1q cnq 1q elisseti mulcompq c1q crq cfv cnq wcel c1q crq
      cfv c1q cmq co c1q crq cfv wceq c1q cnq wcel c1q crq cfv cnq wcel 1q c1q
      recclpq ax-mp c1q crq cfv mulidpq ax-mp c1q cnq wcel c1q c1q crq cfv cmq
      co c1q wceq 1q c1q recidpq ax-mp 3eqtr3i syl5eqbrr sylan2 vw cv c1q cltq
      wbr vw cv cnq wcel c1q cnq wcel vw cv c1q cnq cnq cltq c1q cnq 1q
      elisseti ltrelpq brel pm3.26d sylan2i pm2.43i ex cA cnp wcel cB cnp wcel
      vw cv cA cB cmp co wcel vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv
      cmq co wceq wa vx wex vz wex wb vx vy cA cB reclempr.1 reclem2pr vu vf vg
      vy vw vv cA cB vw cv vz vx cmp cmq vy vw vv vu vf vg df-mp vw visset
      genpelv mpdan sylibrd vw cv c1q cltq wbr vw c1p vw df-1p abeq2i syl5ib
      ssrdv $.
      $( [30-Apr-1996] $)

    $( Lemma for Proposition 9-3.7(v) of [Gleason] p. 124. $)
    reclem4pr $p |- ( A e. P. -> ( A .P. B ) = 1P ) $=
      cA cnp wcel cA cB cmp co c1p cA cnp wcel vw cA cB cmp co c1p cA cnp wcel
      vw cv cA cB cmp co wcel vw cv c1q cltq wbr vw cv c1p wcel cA cnp wcel vw
      cv cA cB cmp co wcel vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq
      co wceq wa vx wex vz wex vw cv c1q cltq wbr cA cnp wcel cB cnp wcel vw cv
      cA cB cmp co wcel vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co
      wceq wa vx wex vz wex wb vx vy cA cB reclempr.1 reclem2pr vu vf vg vy vw
      vv cA cB vw cv vz vx cmp cmq vy vw vv vu vf vg df-mp vw visset genpelv
      mpdan cA cnp wcel vz cv cA wcel vx cv cB wcel wa vw cv vz cv vx cv cmq co
      wceq wa vw cv c1q cltq wbr vz vx cA cnp wcel vz cv cA wcel vx cv cB wcel
      vw cv vz cv vx cv cmq co wceq vw cv c1q cltq wbr cA cnp wcel vz cv cA
      wcel vx cv cB wcel vw cv vz cv vx cv cmq co wceq vw cv c1q cltq wbr wi wi
      cA cnp wcel vz cv cA wcel wa vx cv cB wcel vz cv vx cv cmq co c1q cltq
      wbr vw cv vz cv vx cv cmq co wceq vw cv c1q cltq wbr wi cA cnp wcel vz cv
      cA wcel wa vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vz cv
      vx cv cmq co c1q cltq wbr vx cv cB wcel cA cnp wcel vz cv cA wcel wa vx
      cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vz cv vx cv cmq co c1q cltq
      wbr vy cA cnp wcel vz cv cA wcel wa vx cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn vz cv vx cv cmq co c1q cltq wbr cA cnp wcel vz cv cA wcel wa vx
      cv vy cv cltq wbr vy cv crq cfv cA wcel wn vz cv vx cv cmq co c1q cltq
      wbr wi cA cnp wcel vz cv cA wcel wa vy cv cnq wcel vx cv vy cv cltq wbr
      vy cv crq cfv cA wcel wn vz cv vx cv cmq co c1q cltq wbr wi wi vx cv vy
      cv cltq wbr cA cnp wcel vz cv cA wcel wa vy cv cnq wcel vx cv vy cv cltq
      wbr vy cv crq cfv cA wcel wn vz cv vx cv cmq co c1q cltq wbr cA cnp wcel
      vz cv cA wcel wa vy cv cnq wcel wa vx cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn wa vz cv vx cv cmq co vz cv vy cv cmq co cltq wbr vz cv vy cv cmq
      co c1q cltq wbr wa vz cv vx cv cmq co c1q cltq wbr cA cnp wcel vz cv cA
      wcel wa vy cv cnq wcel wa vx cv vy cv cltq wbr vz cv vx cv cmq co vz cv
      vy cv cmq co cltq wbr vy cv crq cfv cA wcel wn vz cv vy cv cmq co c1q
      cltq wbr cA cnp wcel vz cv cA wcel wa vx cv vy cv cltq wbr vz cv vx cv
      cmq co vz cv vy cv cmq co cltq wbr wi vy cv cnq wcel cA cnp wcel vz cv cA
      wcel wa vx cv vy cv cltq wbr vz cv vx cv cmq co vz cv vy cv cmq co cltq
      wbr cA cnp wcel vz cv cA wcel wa vz cv cnq wcel vx cv vy cv cltq wbr vz
      cv vx cv cmq co vz cv vy cv cmq co cltq wbr wb cA vz cv elprpq vx cv vy
      cv vz cv vx visset vy visset ltmpq syl biimpd adantr cA cnp wcel vz cv cA
      wcel wa vy cv cnq wcel wa vy cv crq cfv cA wcel wn vz cv vy cv crq cfv
      cltq wbr vz cv vy cv cmq co c1q cltq wbr cA cnp wcel vz cv cA wcel wa vy
      cv crq cfv cnq wcel vy cv crq cfv cA wcel wn vz cv vy cv crq cfv cltq wbr
      wi vy cv cnq wcel cA vz cv vy cv crq cfv prub vy cv recclpq sylan2 vy cv
      cnq wcel vz cv vy cv crq cfv cltq wbr vz cv vy cv cmq co c1q cltq wbr wb
      cA cnp wcel vz cv cA wcel wa vy cv cnq wcel vz cv vy cv crq cfv cltq wbr
      vy cv vz cv cmq co vy cv vy cv crq cfv cmq co cltq wbr vz cv vy cv cmq co
      c1q cltq wbr vz cv vy cv crq cfv vy cv vz visset vy cv crq fvex ltmpq vy
      cv cnq wcel vy cv vz cv cmq co vz cv vy cv cmq co vy cv vy cv crq cfv cmq
      co c1q cltq vy cv vz cv cmq co vz cv vy cv cmq co wceq vy cv cnq wcel vy
      cv vz cv vy visset vz visset mulcompq a1i vy cv recidpq breq12d bitrd
      adantl sylibd anim12d vz cv vx cv cmq co vz cv vy cv cmq co c1q cltq cnq
      vz cv vx cv cmq oprex ltsopq ltrelpq vz cv vy cv cmq oprex c1q cnq 1q
      elisseti sotri syl6 exp4b vx cv vy cv cltq wbr vx cv cnq wcel vy cv cnq
      wcel vx cv vy cv cnq cnq cltq vy visset ltrelpq brel pm3.27d syl5 pm2.43d
      imp3a 19.23adv vx cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vx
      cB reclempr.1 abeq2i syl5ib vw cv vz cv vx cv cmq co wceq vw cv c1q cltq
      wbr vz cv vx cv cmq co c1q cltq wbr vw cv vz cv vx cv cmq co c1q cltq
      breq1 biimprcd syl6 ex imp4c 19.23advv sylbid vw cv c1q cltq wbr vw c1p
      vw df-1p abeq2i syl6ibr ssrdv vx vy cA cB reclempr.1 reclem3pr eqssd $.
      $( [30-Apr-1996] $)

  $}

  ${
    $d x y z w A $.
    $( The reciprocal of a positive real exists.  Part of Proposition
       9-3.7(v) of [Gleason] p. 124. $)
    recexpr $p |- ( A e. P. -> E. x ( x e. P. /\ ( A .P. x ) = 1P ) ) $=
      cA cnp wcel cA vx cv cmp co c1p wceq vx wex vx cv cnp wcel cA vx cv cmp
      co c1p wceq wa vx wex vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy
      wex vz cab cnp wcel cA vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa
      vy wex vz cab cmp co c1p wceq cA vx cv cmp co c1p wceq vx wex cA cnp wcel
      cA vx cv cmp co c1p wceq cA vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn
      wa vy wex vz cab cmp co c1p wceq vx vz cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn wa vy wex vz cab cnp vx cv vz cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn wa vy wex vz cab wceq cA vx cv cmp co cA vz cv vy cv cltq wbr vy
      cv crq cfv cA wcel wn wa vy wex vz cab cmp co c1p vx cv vz cv vy cv cltq
      wbr vy cv crq cfv cA wcel wn wa vy wex vz cab cA cmp opreq2 eqeq1d
      cla4egv vw vy cA vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex
      vz cab vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vw cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vz vw vz cv vw cv wceq vz
      cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vw cv vy cv cltq wbr vy cv
      crq cfv cA wcel wn wa vy vz cv vw cv wceq vz cv vy cv cltq wbr vw cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn vz cv vw cv vy cv cltq breq1 anbi1d
      exbidv cbvabv reclem2pr vw vy cA vz cv vy cv cltq wbr vy cv crq cfv cA
      wcel wn wa vy wex vz cab vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa
      vy wex vw cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vy wex vz vw vz
      cv vw cv wceq vz cv vy cv cltq wbr vy cv crq cfv cA wcel wn wa vw cv vy
      cv cltq wbr vy cv crq cfv cA wcel wn wa vy vz cv vw cv wceq vz cv vy cv
      cltq wbr vw cv vy cv cltq wbr vy cv crq cfv cA wcel wn vz cv vw cv vy cv
      cltq breq1 anbi1d exbidv cbvabv reclem4pr sylc cA vx cv cmp co c1p wceq
      vx cv cnp wcel cA vx cv cmp co c1p wceq wa vx cA vx cv cmp co c1p wceq vx
      cv cnp wcel cA vx cv cmp co c1p wceq cA cnp wcel vx cv cnp wcel cA vx cv
      cmp co c1p wceq cA vx cv cmp co cnp wcel cA cnp wcel vx cv cnp wcel wa cA
      vx cv cmp co c1p wceq cA vx cv cmp co cnp wcel c1p cnp wcel 1pr cA vx cv
      cmp co c1p cnp eleq1 mpbiri cA vx cv cnp cmp vx visset dmmp 0npr
      ndmoprrcl syl pm3.27d ancri 19.22i syl $.
      $( [15-May-1996] $)
  $}

  ${
    $d x y z A $.
    $( The union of a non-empty, bounded set of positive reals is a positive
       real.  Part of Proposition 9-3.3 of [Gleason] p. 122. $)
    suplem1pr $p |- ( ( ( A C_ P. /\ -. A = (/) ) /\ E. x ( x e. P. /\
       A. y ( y e. P. -> ( y e. A -> y <P x ) ) ) ) -> U. A e. P. ) $=
      cA cnp wss cA c0 wceq wn vx cv cnp wcel vy cv cnp wcel vy cv cA wcel vy
      cv vx cv cltp wbr wi wi vy wal wa vx wex cA cuni cnp wcel cA cnp wss cA
      c0 wceq wn vx cv cnp wcel vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp
      wbr wi wi vy wal wa vx wex cA cuni cnp wcel cA cnp wss cA c0 wceq wn vx
      cv cnp wcel vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy
      wal wa vx wex wa c0 cA cuni wpss cA cuni cnq wpss wa vy cv vx cv cltq wbr
      vy cv cA cuni wcel wi vy wal vx cv vy cv cltq wbr vy cA cuni wrex wa vx
      cA cuni wral wa cA cuni cnp wcel cA cnp wss cA c0 wceq wn vx cv cnp wcel
      vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy wal wa vx wex
      wa c0 cA cuni wpss cA cuni cnq wpss wa vy cv vx cv cltq wbr vy cv cA cuni
      wcel wi vy wal vx cv vy cv cltq wbr vy cA cuni wrex wa vx cA cuni wral cA
      cnp wss cA c0 wceq wn c0 cA cuni wpss vx cv cnp wcel vy cv cnp wcel vy cv
      cA wcel vy cv vx cv cltp wbr wi wi vy wal wa vx wex cA cuni cnq wpss cA
      cnp wss vz cv cA wcel vz wex vx cv vz cv wcel vz cv cA wcel wa vx wex vz
      wex cA c0 wceq wn c0 cA cuni wpss cA cnp wss vz cv cA wcel vx cv vz cv
      wcel vz cv cA wcel wa vx wex vz cA cnp wss vz cv cA wcel vx cv vz cv wcel
      vx wex vz cv cA wcel wa vx cv vz cv wcel vz cv cA wcel wa vx wex cA cnp
      wss vz cv cA wcel vx cv vz cv wcel vx wex cA cnp wss vz cv cA wcel vz cv
      cnp wcel vx cv vz cv wcel vx wex cA cnp vz cv ssel vz cv cnp wcel vz cv
      c0 wne vx cv vz cv wcel vx wex vz cv prn0 vx vz cv n0 sylib syl6 ancrd vx
      cv vz cv wcel vz cv cA wcel vx 19.41v syl6ibr 19.22dv vz cA neq0 c0 cA
      cuni wpss vx cv cA cuni wcel vx wex vx cv vz cv wcel vz cv cA wcel wa vz
      wex vx wex vx cv vz cv wcel vz cv cA wcel wa vx wex vz wex c0 cA cuni
      wpss cA cuni c0 wne vx cv cA cuni wcel vx wex cA cuni 0pss vx cA cuni n0
      bitri vx cv cA cuni wcel vx cv vz cv wcel vz cv cA wcel wa vz wex vx vz
      vx cv cA eluni exbii vx cv vz cv wcel vz cv cA wcel wa vx vz excom 3bitri
      3imtr4g cA cnp wss vx cv cnp wcel vy cv cnp wcel vy cv cA wcel vy cv vx
      cv cltp wbr wi wi vy wal wa cA cuni cnq wpss vx cA cnp wss vx cv cnp wcel
      vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy wal wa vx cv
      cnq wpss cA cuni vx cv wss wa cA cuni cnq wpss cA cnp wss vx cv cnp wcel
      vx cv cnq wpss vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy
      wal cA cuni vx cv wss vx cv cnp wcel vx cv cnq wpss wi cA cnp wss vx cv
      prpssnq a1i cA cnp wss vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr
      wi wi vy wal vy cv cA wcel vy cv vx cv wss wi vy wal cA cuni vx cv wss cA
      cnp wss vy cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy cv cA
      wcel vy cv vx cv wss wi vy cA cnp wss vy cv cnp wcel vy cv cA wcel vy cv
      vx cv cltp wbr wi wi vy cv cA wcel vy cv cA wcel vy cv vx cv cltp wbr wi
      wi vy cv cA wcel vy cv vx cv wss wi cA cnp wss vy cv cA wcel vy cv cnp
      wcel vy cv cA wcel vy cv vx cv cltp wbr wi cA cnp vy cv ssel imim1d vy cv
      cA wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy cv cA wcel vy cv vx
      cv cltp wbr vy cv vx cv wss vy cv cA wcel vy cv vx cv cltp wbr pm2.43 vy
      cv cnp wcel vx cv cnp wcel wa vy cv vx cv cltp wbr vy cv vx cv wss vy cv
      vx cv cnp cnp cltp vx visset ltrelpr brel vy cv cnp wcel vx cv cnp wcel
      wa vy cv vx cv cltp wbr vy cv vx cv wpss vy cv vx cv wss vy cv vx cv
      ltprord vy cv vx cv pssss syl6bi mpcom syl6 syl6 19.20dv cA cuni vx cv
      wss vy cv vx cv wss vy cA wral vy cv cA wcel vy cv vx cv wss wi vy wal vy
      cA vx cv unissb vy cv vx cv wss vy cA df-ral bitri syl6ibr anim12d cA
      cuni vx cv wss vx cv cnq wpss cA cuni cnq wpss cA cuni vx cv cnq sspsstr
      ancoms syl6 19.23adv anim12d cA cnp wss vy cv vx cv cltq wbr vy cv cA
      cuni wcel wi vy wal vx cv vy cv cltq wbr vy cA cuni wrex wa vx cA cuni cA
      cnp wss vx cv cA cuni wcel vy cv vx cv cltq wbr vy cv cA cuni wcel wi vy
      wal vx cv vy cv cltq wbr vy cA cuni wrex cA cnp wss vx cv cA cuni wcel vy
      cv vx cv cltq wbr vy cv cA cuni wcel wi vy cA cnp wss vy cv vx cv cltq
      wbr vx cv cA cuni wcel vy cv cA cuni wcel cA cnp wss vy cv vx cv cltq wbr
      vx cv cA cuni wcel vy cv cA cuni wcel wi cA cnp wss vy cv vx cv cltq wbr
      wa vx cv vz cv wcel vz cv cA wcel wa vz wex vy cv cA cuni wcel vx cv cA
      cuni wcel cA cnp wss vy cv vx cv cltq wbr wa vx cv vz cv wcel vz cv cA
      wcel wa vy cv cA cuni wcel vz cA cnp wss vy cv vx cv cltq wbr wa vx cv vz
      cv wcel vz cv cA wcel vy cv cA cuni wcel cA cnp wss vy cv vx cv cltq wbr
      wa vx cv vz cv wcel wa vz cv cA wcel vy cv vz cv wcel vz cv cA wcel wa vy
      cv cA cuni wcel cA cnp wss vy cv vx cv cltq wbr wa vx cv vz cv wcel wa vz
      cv cA wcel vy cv vz cv wcel cA cnp wss vy cv vx cv cltq wbr vx cv vz cv
      wcel vz cv cA wcel vy cv vz cv wcel wi cA cnp wss vz cv cA wcel vx cv vz
      cv wcel vy cv vx cv cltq wbr vy cv vz cv wcel cA cnp wss vz cv cA wcel vz
      cv cnp wcel vx cv vz cv wcel vy cv vx cv cltq wbr vy cv vz cv wcel wi wi
      cA cnp vz cv ssel vz cv cnp wcel vx cv vz cv wcel vy cv vx cv cltq wbr vy
      cv vz cv wcel wi vz cv vx cv vy cv prcdpq ex syl6 com24 imp31 ancrd vy cv
      vz cv cA elunii syl6 expimpd 19.23adv vz vx cv cA eluni syl5ib ex com23
      19.21adv cA cnp wss vx cv vz cv wcel vz cv cA wcel wa vz wex vy cv cA
      cuni wcel vx cv vy cv cltq wbr wa vy wex vx cv cA cuni wcel vx cv vy cv
      cltq wbr vy cA cuni wrex cA cnp wss vx cv vz cv wcel vz cv cA wcel wa vy
      cv cA cuni wcel vx cv vy cv cltq wbr wa vy wex vz cA cnp wss vx cv vz cv
      wcel vz cv cA wcel vy cv cA cuni wcel vx cv vy cv cltq wbr wa vy wex cA
      cnp wss vx cv vz cv wcel wa vz cv cA wcel vy cv vz cv wcel vx cv vy cv
      cltq wbr wa vy wex vz cv cA wcel wa vy cv cA cuni wcel vx cv vy cv cltq
      wbr wa vy wex cA cnp wss vx cv vz cv wcel wa vz cv cA wcel vy cv vz cv
      wcel vx cv vy cv cltq wbr wa vy wex cA cnp wss vx cv vz cv wcel vz cv cA
      wcel vy cv vz cv wcel vx cv vy cv cltq wbr wa vy wex wi cA cnp wss vz cv
      cA wcel vx cv vz cv wcel vy cv vz cv wcel vx cv vy cv cltq wbr wa vy wex
      cA cnp wss vz cv cA wcel vz cv cnp wcel vx cv vz cv wcel vy cv vz cv wcel
      vx cv vy cv cltq wbr wa vy wex wi cA cnp vz cv ssel vz cv cnp wcel vx cv
      vz cv wcel vy cv vz cv wcel vx cv vy cv cltq wbr wa vy wex vy vz cv vx cv
      prnmax ex syl6 com23 imp ancrd vy cv vz cv wcel vx cv vy cv cltq wbr wa
      vy wex vz cv cA wcel wa vy cv vz cv wcel vx cv vy cv cltq wbr wa vz cv cA
      wcel wa vy wex vy cv cA cuni wcel vx cv vy cv cltq wbr wa vy wex vy cv vz
      cv wcel vx cv vy cv cltq wbr wa vz cv cA wcel vy 19.41v vy cv vz cv wcel
      vx cv vy cv cltq wbr wa vz cv cA wcel wa vy cv cA cuni wcel vx cv vy cv
      cltq wbr wa vy vy cv vz cv wcel vz cv cA wcel vx cv vy cv cltq wbr vy cv
      cA cuni wcel vx cv vy cv cltq wbr wa vy cv vz cv wcel vz cv cA wcel wa vy
      cv cA cuni wcel vx cv vy cv cltq wbr vy cv vz cv cA elunii anim1i an1rs
      19.22i sylbir syl6 expimpd 19.23adv vz vx cv cA eluni vx cv vy cv cltq
      wbr vy cA cuni df-rex 3imtr4g jcad r19.21aiv jctird vx vy cA cuni elnp
      syl6ibr exp3a imp31 $.
      $( [19-May-1996] $)

    $( The union of a set of positive reals (if a positive real) is its
       supremum (least upper bound).  Part of Proposition 9-3.3 of [Gleason]
       p. 122. $)
    suplem2pr $p |- ( A C_ P. -> ( ( y e. A -> -. U. A <P y ) /\
           ( y <P U. A -> E. z ( z e. P. /\ ( z e. A /\ y <P z ) ) ) ) ) $=
      cA cnp wss vy cv cA cuni cltp wbr vz cv cnp wcel vz cv cA wcel vy cv vz
      cv cltp wbr wa wa vz wex wi vy cv cA wcel cA cuni vy cv cltp wbr wn wi cA
      cnp wss vy cv cA cuni cltp wbr vz cv cA wcel vy cv vz cv cltp wbr wa vz
      wex vz cv cnp wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex cA cnp
      wss vy cv cA cuni cltp wbr vz cv cA wcel vy cv vz cv cltp wbr wa vz wex
      cA cnp wss vy cv cA cuni cltp wbr vy cv cnp wcel vy cv cA cuni cltp wbr
      vz cv cA wcel vy cv vz cv cltp wbr wa vz wex wi cA cnp wss cA cvv wcel cA
      cuni cvv wcel vy cv cA cuni cltp wbr vy cv cnp wcel wi cA cnp npex ssex
      cA cvv uniexg cA cuni cvv wcel vy cv cA cuni cltp wbr vy cv cnp wcel cA
      cuni cnp wcel wa vy cv cnp wcel vy cv cA cuni cnp cnp cltp cvv ltrelpr
      brelg vy cv cnp wcel cA cuni cnp wcel pm3.26 syl6 3syl cA cnp wss vy cv
      cnp wcel vy cv cA cuni cltp wbr vz cv cA wcel vy cv vz cv cltp wbr wa vz
      wex wi cA cnp wss vy cv cnp wcel wa vz cv cA wcel vy cv vz cv cltp wbr wa
      vz wex vy cv cA cuni cltp wbr cA cnp wss vy cv cnp wcel wa vz cv cA wcel
      vy cv vz cv cltp wbr wa vz wex wn cA cuni vy cv wss vy cv cA cuni cltp
      wbr wn cA cnp wss vy cv cnp wcel wa vz cv cA wcel vy cv vz cv cltp wbr wn
      wi vz wal vz cv cA wcel vz cv vy cv wss wi vz wal vz cv cA wcel vy cv vz
      cv cltp wbr wa vz wex wn cA cuni vy cv wss cA cnp wss vy cv cnp wcel wa
      vz cv cA wcel vy cv vz cv cltp wbr wn wi vz cv cA wcel vz cv vy cv wss wi
      vz cA cnp wss vy cv cnp wcel wa vz cv cA wcel vy cv vz cv cltp wbr wn vz
      cv vy cv wss cA cnp wss vz cv cA wcel vy cv cnp wcel vy cv vz cv cltp wbr
      wn vz cv vy cv wss wb vz cv cnp wcel vy cv cnp wcel vy cv vz cv cltp wbr
      wn vz cv vy cv wss wb cA cnp wss vz cv cA wcel wa vz cv cnp wcel vy cv
      cnp wcel wa vy cv vz cv wceq vz cv vy cv cltp wbr wo vy cv vz cv cltp wbr
      wn vz cv vy cv wss vy cv cnp wcel vz cv cnp wcel vy cv vz cv wceq vz cv
      vy cv cltp wbr wo vy cv vz cv cltp wbr wn wb vy cv cnp wcel vz cv cnp
      wcel wa vy cv vz cv cltp wbr vy cv vz cv wceq vz cv vy cv cltp wbr wo cnp
      cltp wor vy cv cnp wcel vz cv cnp wcel wa vy cv vz cv cltp wbr vy cv vz
      cv wceq vz cv vy cv cltp wbr wo wn wb ltsopr cnp vy cv vz cv cltp sotric
      mpan con2bid ancoms vz cv cnp wcel vy cv cnp wcel wa vy cv vz cv wceq vz
      cv vy cv cltp wbr wo vy cv vz cv wceq vz cv vy cv wpss wo vz cv vy cv wss
      vz cv cnp wcel vy cv cnp wcel wa vz cv vy cv cltp wbr vz cv vy cv wpss vy
      cv vz cv wceq vz cv vy cv ltprord orbi2d vz cv vy cv wss vz cv vy cv wpss
      vz cv vy cv wceq wo vz cv vy cv wpss vy cv vz cv wceq wo vy cv vz cv wceq
      vz cv vy cv wpss wo vz cv vy cv sspss vz cv vy cv wceq vy cv vz cv wceq
      vz cv vy cv wpss vz cv vy cv eqcom orbi2i vz cv vy cv wpss vy cv vz cv
      wceq orcom 3bitri syl6bbr bitr3d cA cnp vz cv ssel2 sylan an1rs pm5.74da
      albidv vz cv cA wcel vy cv vz cv cltp wbr vz alinexa cA cuni vy cv wss vz
      cv vy cv wss vz cA wral vz cv cA wcel vz cv vy cv wss wi vz wal vz cA vy
      cv unissb vz cv vy cv wss vz cA df-ral bitr2i 3bitr3g cA cuni vy cv wss
      vy cv cA cuni cltp wbr vy cv cA cuni wpss cA cuni vy cv ssnpss cA cuni vy
      cv wss cA cuni cvv wcel vy cv cA cuni cltp wbr vy cv cA cuni wpss wi cA
      cuni vy cv vy visset ssex vy cv cA cuni cltp wbr cA cuni cvv wcel vy cv
      cnp wcel cA cuni cnp wcel wa vy cv cA cuni wpss vy cv cA cuni cnp cnp
      cltp cvv ltrelpr brelg vy cv cnp wcel cA cuni cnp wcel wa vy cv cA cuni
      cltp wbr vy cv cA cuni wpss vy cv cA cuni ltprord biimpd syli syl mtod
      syl6bi con4d ex syld pm2.43d vz cv cA wcel vy cv vz cv cltp wbr wa vz cv
      cnp wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz vz cv cA wcel vy cv
      vz cv cltp wbr wa vz cv cnp wcel vy cv vz cv cltp wbr vz cv cnp wcel vz
      cv cA wcel vy cv vz cv cltp wbr vy cv cnp wcel vz cv cnp wcel vy cv vz cv
      cnp cnp cltp vz visset ltrelpr brel pm3.27d adantl ancri 19.22i syl6 vy
      cv cA wcel cA cuni vy cv wpss cA cuni vy cv cltp wbr vy cv cA wcel vy cv
      cA cuni wss cA cuni vy cv wpss wn vy cv cA elssuni vy cv cA cuni ssnpss
      syl cA cuni cnp wcel vy cv cnp wcel wa cA cuni vy cv cltp wbr cA cuni vy
      cv wpss cA cuni vy cv cnp cnp cltp vy visset ltrelpr brel cA cuni cnp
      wcel vy cv cnp wcel wa cA cuni vy cv cltp wbr cA cuni vy cv wpss cA cuni
      vy cv ltprord biimpd mpcom nsyl jctil $.
      $( [19-May-1996] $)

    $( The union of a non-empty, bounded set of positive reals has a supremum.
       Part of Proposition 9-3.3 of [Gleason] p. 122. $)
    supexpr $p |- ( ( ( A C_ P. /\ -. A = (/) ) /\ E. x ( x e. P. /\
                     A. y ( y e. P. -> ( y e. A -> y <P x ) ) ) ) ->
       E. x ( x e. P. /\ A. y ( y e. P. -> ( ( y e. A -> -. x <P y ) /\
           ( y <P x -> E. z ( z e. P. /\ ( z e. A /\ y <P z ) ) ) ) ) ) ) $=
      cA cuni cnp wcel cA cuni cnp wcel vy cv cnp wcel vy cv cA wcel cA cuni vy
      cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp wcel vz cv cA wcel vy
      cv vz cv cltp wbr wa wa vz wex wi wa wi vy wal wa vx cv cnp wcel vy cv
      cnp wcel vy cv cA wcel vx cv vy cv cltp wbr wn wi vy cv vx cv cltp wbr vz
      cv cnp wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy
      wal wa vx wex cA cnp wss cA c0 wceq wn wa vx cv cnp wcel vy cv cnp wcel
      vy cv cA wcel vy cv vx cv cltp wbr wi wi vy wal wa vx wex wa vx cv cnp
      wcel vy cv cnp wcel vy cv cA wcel vx cv vy cv cltp wbr wn wi vy cv vx cv
      cltp wbr vz cv cnp wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex
      wi wa wi vy wal wa cA cuni cnp wcel vy cv cnp wcel vy cv cA wcel cA cuni
      vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp wcel vz cv cA wcel
      vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy wal wa vx cA cuni cnp vx cv
      cA cuni wceq vx cv cnp wcel cA cuni cnp wcel vy cv cnp wcel vy cv cA wcel
      vx cv vy cv cltp wbr wn wi vy cv vx cv cltp wbr vz cv cnp wcel vz cv cA
      wcel vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy wal vy cv cnp wcel vy
      cv cA wcel cA cuni vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp
      wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy wal vx
      cv cA cuni cnp eleq1 vx cv cA cuni wceq vy cv cnp wcel vy cv cA wcel vx
      cv vy cv cltp wbr wn wi vy cv vx cv cltp wbr vz cv cnp wcel vz cv cA wcel
      vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy cv cnp wcel vy cv cA wcel
      cA cuni vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp wcel vz cv
      cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy vx cv cA cuni wceq
      vy cv cA wcel vx cv vy cv cltp wbr wn wi vy cv vx cv cltp wbr vz cv cnp
      wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa vy cv cA wcel
      cA cuni vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp wcel vz cv
      cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa vy cv cnp wcel vx cv cA
      cuni wceq vy cv cA wcel vx cv vy cv cltp wbr wn wi vy cv cA wcel cA cuni
      vy cv cltp wbr wn wi vy cv vx cv cltp wbr vz cv cnp wcel vz cv cA wcel vy
      cv vz cv cltp wbr wa wa vz wex wi vy cv cA cuni cltp wbr vz cv cnp wcel
      vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex wi vx cv cA cuni wceq vx
      cv vy cv cltp wbr wn cA cuni vy cv cltp wbr wn vy cv cA wcel vx cv cA
      cuni wceq vx cv vy cv cltp wbr cA cuni vy cv cltp wbr vx cv cA cuni vy cv
      cltp breq1 notbid imbi2d vx cv cA cuni wceq vy cv vx cv cltp wbr vy cv cA
      cuni cltp wbr vz cv cnp wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz
      wex vx cv cA cuni vy cv cltp breq2 imbi1d anbi12d imbi2d albidv anbi12d
      cla4egv vx vy cA suplem1pr cA cnp wss cA c0 wceq wn wa vx cv cnp wcel vy
      cv cnp wcel vy cv cA wcel vy cv vx cv cltp wbr wi wi vy wal wa vx wex wa
      cA cuni cnp wcel vy cv cnp wcel vy cv cA wcel cA cuni vy cv cltp wbr wn
      wi vy cv cA cuni cltp wbr vz cv cnp wcel vz cv cA wcel vy cv vz cv cltp
      wbr wa wa vz wex wi wa wi vy wal vx vy cA suplem1pr cA cnp wss vy cv cnp
      wcel vy cv cA wcel cA cuni vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz
      cv cnp wcel vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy
      wal cA c0 wceq wn vx cv cnp wcel vy cv cnp wcel vy cv cA wcel vy cv vx cv
      cltp wbr wi wi vy wal wa vx wex cA cnp wss vy cv cnp wcel vy cv cA wcel
      cA cuni vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp wcel vz cv
      cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa wi vy cA cnp wss vy cv cA
      wcel cA cuni vy cv cltp wbr wn wi vy cv cA cuni cltp wbr vz cv cnp wcel
      vz cv cA wcel vy cv vz cv cltp wbr wa wa vz wex wi wa vy cv cnp wcel vy
      vz cA suplem2pr a1d 19.21aiv ad2antrr jca sylc $.
      $( [19-May-1996] $)
  $}

  ${
    $d x y z w v u f $.

    $( Define pre-addition on signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.1
       of [Gleason] p. 126. $)
    df-plpr $a |- +pR = { <. <. x , y >. , z >. | ( ( x e. ( P. X. P. ) /\
         y e. ( P. X. P. ) ) /\ E. w E. v E. u E. f ( ( x = <. w , v >. /\
         y = <. u , f >. ) /\ z = <. ( w +P. u ) , ( v +P. f ) >. ) ) } $.

    $( Define pre-multiplication on signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.1
       of [Gleason] p. 126. $)
    df-mpr $a |- .pR = { <. <. x , y >. , z >. | ( ( x e. ( P. X. P. ) /\
         y e. ( P. X. P. ) ) /\ E. w E. v E. u E. f ( ( x = <. w , v >. /\
         y = <. u , f >. ) /\ z = <. ( ( w .P. u ) +P. ( v .P. f ) ) ,
           ( ( w .P. f ) +P. ( v .P. u ) ) >. ) ) } $.

    $( Define equivalence relation for signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition
       9-4.1 of [Gleason] p. 126. $)
    df-enr $a |- ~R = { <. x , y >. | ( ( x e. ( P. X. P. ) /\
                   y e. ( P. X. P. ) ) /\ E. z E. w E. v E. u
                   ( ( x = <. z , w >. /\ y = <. v , u >. ) /\
                   ( z +P. u ) = ( w +P. v ) ) ) } $.

    $( Define class of signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.2 of
       [Gleason] p. 126. $)
    df-nr $a |- R. = ( ( P. X. P. ) /. ~R ) $.

    $( Define addition on signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.3
       of [Gleason] p. 126. $)
    df-plr $a |- +R = { <. <. x , y >. , z >. | ( ( x e. R. /\ y e. R. ) /\
      E. w E. v E. u E. f (
         ( x = [ <. w , v >. ] ~R /\ y = [ <. u , f >. ] ~R ) /\
               z = [ ( <. w , v >. +pR <. u , f >. ) ] ~R ) ) } $.

    $( Define multiplication on signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.3
       of [Gleason] p. 126. $)
    df-mr $a |- .R = { <. <. x , y >. , z >. | ( ( x e. R. /\ y e. R. ) /\
      E. w E. v E. u E. f (
         ( x = [ <. w , v >. ] ~R /\ y = [ <. u , f >. ] ~R ) /\
               z = [ ( <. w , v >. .pR <. u , f >. ) ] ~R ) ) } $.

    $( Define ordering relation on signed reals.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.4 of
       [Gleason] p. 127. $)
    df-ltr $a |- <R = { <. x , y >. | ( ( x e. R. /\ y e. R. ) /\
       E. z E. w E. v E. u
       ( ( x = [ <. z , w >. ] ~R /\ y = [ <. v , u >. ] ~R ) /\
                ( z +P. u ) <P ( w +P. v ) ) ) } $.

    $( Define signed real constant 0.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.2 of
       [Gleason] p. 126. $)
    df-0r $a |- 0R = [ <. 1P , 1P >. ] ~R $.

    $( Define signed real constant 1.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-4.2 of
       [Gleason] p. 126. $)
    df-1r $a |- 1R = [ <. ( 1P +P. 1P ) , 1P >. ] ~R $.

    $( Define signed real constant -1.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction. $)
    df-m1r $a |- -1R = [ <. 1P , ( 1P +P. 1P ) >. ] ~R $.

  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.
    $( Equivalence relation for signed reals in terms of positive reals. $)
    enrbreq $p |- ( ( ( A e. P. /\ B e. P. ) /\
                     ( C e. P. /\ D e. P. ) ) ->
          ( <. A , B >. ~R <. C , D >. <-> ( A +P. D ) = ( B +P. C ) ) ) $=
      vx vy vz vw vv vu cA cB cC cD cer cnp cpp vx vy vz vw vv vu df-enr
      ecopopreq $.
      $( [3-Sep-1995] $)
  $}

  ${
    $d x y z w v u $.
    $( Domain of equivalence relation for signed reals. $)
    dmenr $p |- dom ~R = ( P. X. P. ) $=
      vx vy vz vw vv vu cer cnp cpp vx vy vz vw vv vu df-enr vx cv vy cv vx
      visset vy visset addcompr ecopoprdm $.
      $( [3-Sep-1995] $)
  $}


  ${
    $d x y z w v u $.
    $( The equivalence relation for signed reals is an equivalence
       relation.  Proposition 9-4.1 of [Gleason] p. 126. $)
    enrer $p |- Er ~R $=
      vx vy vz vw vv vu cer cnp cpp vx vy vz vw vv vu df-enr vx cv vy cv vx
      visset vy visset addcompr vx cv vy cv addclpr vx cv vy cv vz cv vy visset
      vz visset addasspr vx cv vy cv vz cv vy visset vz visset addcanpr
      ecopoprer $.
      $( [3-Sep-1995] $)
  $}

  $( Equivalence class equality of positive fractions in terms of positive
     integers. $)
  enreceq $p |- ( ( ( A e. P. /\ B e. P. ) /\ ( C e. P. /\ D e. P. ) ) ->
                ( [ <. A , B >. ] ~R = [ <. C , D >. ] ~R <->
                ( A +P. D ) = ( B +P. C ) ) ) $=
    cA cnp wcel cB cnp wcel wa cC cnp wcel cD cnp wcel wa wa cA cB cop cer cec
    cC cD cop cer cec wceq cA cB cop cC cD cop cer wbr cA cD cpp co cB cC cpp
    co wceq cA cnp wcel cB cnp wcel wa cC cnp wcel cD cnp wcel wa wa cA cnp
    wcel cB cnp wcel wa cA cB cop cer cdm wcel cA cB cop cer cec cC cD cop cer
    cec wceq cA cB cop cC cD cop cer wbr wb cA cnp wcel cB cnp wcel wa cC cnp
    wcel cD cnp wcel wa pm3.26 cA cnp wcel cB cnp wcel wa cA cB cop cnp cnp cxp
    cer cdm cA cB cnp cnp opelxpi dmenr syl6eleqr cA cB cop cC cD cop cer cC cD
    opex enrer erthdm 3syl cA cB cC cD enrbreq bitrd $.
    $( [29-Nov-1995] $)

  ${
    $d x y z w v u $.
    $( The equivalence relation for signed reals exists. $)
    enrex $p |- ~R e. _V $=
      cer cnp cnp cxp cnp cnp cxp cxp cnp cnp cxp cnp cnp cxp cnp cnp npex npex
      xpex cnp cnp npex npex xpex xpex cer vx cv cnp cnp cxp wcel vy cv cnp cnp
      cxp wcel wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz
      cv vu cv cpp co vw cv vv cv cpp co wceq wa vu wex vv wex vw wex vz wex wa
      vx vy copab cnp cnp cxp cnp cnp cxp cxp vx vy vz vw vv vu df-enr vx cv vz
      cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vz cv vu cv cpp co vw cv
      vv cv cpp co wceq wa vu wex vv wex vw wex vz wex vx vy cnp cnp cxp cnp
      cnp cxp opabssxp eqsstri ssexi $.
      $( [25-Jul-1995] $)
  $}

  $( The class of signed reals is a set. $)
  srex $p |- R. e. _V $=
    cnr cnp cnp cxp cer cqs cvv df-nr cnp cnp cxp cer cnp cnp npex npex xpex
    qsex eqeltri $.
    $( [13-Aug-1995] $)

  ${
    $d x y z w v u $.
    $( Signed real 'less than' is a relation on signed reals. $)
    ltrelsr $p |- <R C_ ( R. X. R. ) $=
      cltr vx cv cnr wcel vy cv cnr wcel wa vx cv vz cv vw cv cop cer cec wceq
      vy cv vv cv vu cv cop cer cec wceq wa vz cv vu cv cpp co vw cv vv cv cpp
      co cltp wbr wa vu wex vv wex vw wex vz wex wa vx vy copab cnr cnr cxp vx
      vy vz vw vv vu df-ltr vx cv vz cv vw cv cop cer cec wceq vy cv vv cv vu
      cv cop cer cec wceq wa vz cv vu cv cpp co vw cv vv cv cpp co cltp wbr wa
      vu wex vv wex vw wex vz wex vx vy cnr cnr opabssxp eqsstri $.
      $( [14-Feb-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d x y z F $.
    $d x y z G $.  $d x y z R $.  $d x y z S $.

    $( (We do not bother to eliminate these redundant hypotheses.) $)
    cmpblnr.1 $e |- A e. _V $.
    cmpblnr.2 $e |- B e. _V $.
    cmpblnr.3 $e |- C e. _V $.
    cmpblnr.4 $e |- D e. _V $.
    cmpblnr.5 $e |- F e. _V $.
    cmpblnr.6 $e |- G e. _V $.
    cmpblnr.7 $e |- R e. _V $.
    cmpblnr.8 $e |- S e. _V $.

    $( Lemma showing compatibility of addition. $)
    addcmpblnr $p |- ( ( ( ( A e. P. /\ B e. P. ) /\ ( C e. P. /\ D e. P. ) )
               /\ ( ( F e. P. /\ G e. P. ) /\ ( R e. P. /\ S e. P. ) ) ) ->
                ( ( ( A +P. D ) = ( B +P. C ) /\ ( F +P. S ) = ( G +P. R ) ) ->
     <. ( A +P. F ) , ( B +P. G ) >. ~R <. ( C +P. R ) , ( D +P. S ) >. ) ) $=
      cA cnp wcel cB cnp wcel wa cC cnp wcel cD cnp wcel wa wa cF cnp wcel cG
      cnp wcel wa cR cnp wcel cS cnp wcel wa wa wa cA cF cpp co cB cG cpp co
      cop cC cR cpp co cD cS cpp co cop cer wbr cA cD cpp co cF cS cpp co cpp
      co cB cC cpp co cG cR cpp co cpp co wceq cA cD cpp co cB cC cpp co wceq
      cF cS cpp co cG cR cpp co wceq wa cA cnp wcel cB cnp wcel wa cC cnp wcel
      cD cnp wcel wa wa cF cnp wcel cG cnp wcel wa cR cnp wcel cS cnp wcel wa
      wa wa cA cF cpp co cB cG cpp co cop cC cR cpp co cD cS cpp co cop cer wbr
      cA cF cpp co cD cS cpp co cpp co cB cG cpp co cC cR cpp co cpp co wceq cA
      cD cpp co cF cS cpp co cpp co cB cC cpp co cG cR cpp co cpp co wceq cA
      cnp wcel cB cnp wcel wa cC cnp wcel cD cnp wcel wa wa cF cnp wcel cG cnp
      wcel wa cR cnp wcel cS cnp wcel wa wa wa cA cF cpp co cnp wcel cB cG cpp
      co cnp wcel wa cC cR cpp co cnp wcel cD cS cpp co cnp wcel wa wa cA cF
      cpp co cB cG cpp co cop cC cR cpp co cD cS cpp co cop cer wbr cA cF cpp
      co cD cS cpp co cpp co cB cG cpp co cC cR cpp co cpp co wceq wb cA cnp
      wcel cB cnp wcel wa cF cnp wcel cG cnp wcel wa cC cnp wcel cD cnp wcel wa
      cR cnp wcel cS cnp wcel wa cA cF cpp co cnp wcel cB cG cpp co cnp wcel wa
      cC cR cpp co cnp wcel cD cS cpp co cnp wcel wa wa cA cnp wcel cB cnp wcel
      wa cF cnp wcel cG cnp wcel wa wa cA cF cpp co cnp wcel cB cG cpp co cnp
      wcel wa cC cnp wcel cD cnp wcel wa cR cnp wcel cS cnp wcel wa wa cC cR
      cpp co cnp wcel cD cS cpp co cnp wcel wa cA cnp wcel cF cnp wcel cB cnp
      wcel cG cnp wcel cA cF cpp co cnp wcel cB cG cpp co cnp wcel wa cA cnp
      wcel cF cnp wcel wa cA cF cpp co cnp wcel cB cnp wcel cG cnp wcel wa cB
      cG cpp co cnp wcel cA cF addclpr cB cG addclpr anim12i an4s cC cnp wcel
      cR cnp wcel cD cnp wcel cS cnp wcel cC cR cpp co cnp wcel cD cS cpp co
      cnp wcel wa cC cnp wcel cR cnp wcel wa cC cR cpp co cnp wcel cD cnp wcel
      cS cnp wcel wa cD cS cpp co cnp wcel cC cR addclpr cD cS addclpr anim12i
      an4s anim12i an4s cA cF cpp co cB cG cpp co cC cR cpp co cD cS cpp co
      enrbreq syl cA cF cpp co cD cS cpp co cpp co cA cD cpp co cF cS cpp co
      cpp co cB cG cpp co cC cR cpp co cpp co cB cC cpp co cG cR cpp co cpp co
      vx vy vz cA cF cD cS cpp cmpblnr.1 cmpblnr.5 cmpblnr.4 vx cv vy cv vx
      visset vy visset addcompr vx cv vy cv vz cv vy visset vz visset addasspr
      cmpblnr.8 caopr4 vx vy vz cB cG cC cR cpp cmpblnr.2 cmpblnr.6 cmpblnr.3
      vx cv vy cv vx visset vy visset addcompr vx cv vy cv vz cv vy visset vz
      visset addasspr cmpblnr.7 caopr4 eqeq12i syl6bb cA cD cpp co cB cC cpp co
      cF cS cpp co cG cR cpp co cpp opreq12 syl5bir $.
      $( [3-Sep-1995] $)

    $( Lemma used in lemma showing compatibility of multiplication. $)
    mulcmpblnrlem $p |- ( ( ( A +P. D ) = ( B +P. C ) /\
                            ( F +P. S ) = ( G +P. R ) ) ->
                    ( ( D .P. F ) +P. ( ( ( A .P. F ) +P. ( B .P. G ) ) +P.
                            ( ( C .P. S ) +P. ( D .P. R ) ) ) ) =
                    ( ( D .P. F ) +P. ( ( ( A .P. G ) +P. ( B .P. F ) ) +P.
                            ( ( C .P. R ) +P. ( D .P. S ) ) ) ) ) $=
      cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cD cF
      cmp co cA cF cmp co cC cS cmp co cpp co cB cG cmp co cD cR cmp co cpp co
      cpp co cpp co cD cF cmp co cA cG cmp co cD cS cmp co cpp co cB cF cmp co
      cC cR cmp co cpp co cpp co cpp co cD cF cmp co cA cF cmp co cB cG cmp co
      cpp co cC cS cmp co cD cR cmp co cpp co cpp co cpp co cD cF cmp co cA cG
      cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co cpp co cpp co
      cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cB cG
      cmp co cD cR cmp co cpp co cA cF cmp co cC cS cmp co cpp co cD cF cmp co
      cpp co cpp co cD cF cmp co cA cG cmp co cD cS cmp co cpp co cpp co cB cF
      cmp co cC cR cmp co cpp co cpp co cD cF cmp co cA cF cmp co cC cS cmp co
      cpp co cB cG cmp co cD cR cmp co cpp co cpp co cpp co cD cF cmp co cA cG
      cmp co cD cS cmp co cpp co cB cF cmp co cC cR cmp co cpp co cpp co cpp co
      cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cB cG
      cmp co cD cR cmp co cpp co cA cF cmp co cC cS cmp co cpp co cD cF cmp co
      cpp co cpp co cB cG cmp co cD cR cmp co cpp co cC cG cmp co cB cF cmp co
      cC cR cmp co cpp co cpp co cpp co cD cF cmp co cA cG cmp co cD cS cmp co
      cpp co cpp co cB cF cmp co cC cR cmp co cpp co cpp co cA cD cpp co cB cC
      cpp co wceq cF cS cpp co cG cR cpp co wceq wa cA cF cmp co cC cS cmp co
      cpp co cD cF cmp co cpp co cC cG cmp co cB cF cmp co cC cR cmp co cpp co
      cpp co cB cG cmp co cD cR cmp co cpp co cpp cA cD cpp co cB cC cpp co
      wceq cF cS cpp co cG cR cpp co wceq wa cA cF cmp co cD cF cmp co cpp co
      cC cS cmp co cpp co cB cF cmp co cC cG cmp co cC cR cmp co cpp co cpp co
      cA cF cmp co cC cS cmp co cpp co cD cF cmp co cpp co cC cG cmp co cB cF
      cmp co cC cR cmp co cpp co cpp co cA cD cpp co cB cC cpp co wceq cF cS
      cpp co cG cR cpp co wceq cA cF cmp co cD cF cmp co cpp co cC cS cmp co
      cpp co cB cF cmp co cC cF cmp co cpp co cC cS cmp co cpp co cB cF cmp co
      cC cG cmp co cC cR cmp co cpp co cpp co cA cD cpp co cB cC cpp co wceq cA
      cF cmp co cD cF cmp co cpp co cB cF cmp co cC cF cmp co cpp co cC cS cmp
      co cpp cA cD cpp co cB cC cpp co wceq cA cD cpp co cF cmp co cB cC cpp co
      cF cmp co cA cF cmp co cD cF cmp co cpp co cB cF cmp co cC cF cmp co cpp
      co cA cD cpp co cB cC cpp co cF cmp opreq1 vx vy vz cA cD cF cpp cmp
      cmpblnr.1 cmpblnr.4 cmpblnr.5 vx cv vy cv vx visset vy visset mulcompr vx
      cv vy cv vz cv vy visset vz visset distrpr caoprdistrr vx vy vz cB cC cF
      cpp cmp cmpblnr.2 cmpblnr.3 cmpblnr.5 vx cv vy cv vx visset vy visset
      mulcompr vx cv vy cv vz cv vy visset vz visset distrpr caoprdistrr
      3eqtr3g opreq1d cF cS cpp co cG cR cpp co wceq cB cF cmp co cC cF cmp co
      cC cS cmp co cpp co cpp co cB cF cmp co cC cG cmp co cC cR cmp co cpp co
      cpp co cB cF cmp co cC cF cmp co cpp co cC cS cmp co cpp co cF cS cpp co
      cG cR cpp co wceq cC cF cmp co cC cS cmp co cpp co cC cG cmp co cC cR cmp
      co cpp co cB cF cmp co cpp cF cS cpp co cG cR cpp co wceq cC cF cS cpp co
      cmp co cC cG cR cpp co cmp co cC cF cmp co cC cS cmp co cpp co cC cG cmp
      co cC cR cmp co cpp co cF cS cpp co cG cR cpp co cC cmp opreq2 cC cF cS
      cmpblnr.5 cmpblnr.8 distrpr cC cG cR cmpblnr.6 cmpblnr.7 distrpr 3eqtr3g
      opreq2d cB cF cmp co cC cF cmp co cC cS cmp co cC cF cmp oprex cC cS cmp
      oprex addasspr syl5eq sylan9eq vx vy vz cA cF cmp co cD cF cmp co cC cS
      cmp co cpp cA cF cmp oprex cD cF cmp oprex cC cS cmp oprex vx cv vy cv vx
      visset vy visset addcompr vx cv vy cv vz cv vy visset vz visset addasspr
      caopr32 vx vy vz cB cF cmp co cC cG cmp co cC cR cmp co cpp cB cF cmp
      oprex cC cG cmp oprex cC cR cmp oprex vx cv vy cv vx visset vy visset
      addcompr vx cv vy cv vz cv vy visset vz visset addasspr caopr12 3eqtr3g
      opreq2d cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa
      cD cF cmp co cA cG cmp co cD cS cmp co cpp co cpp co cB cF cmp co cC cR
      cmp co cpp co cpp co cB cG cmp co cD cR cmp co cpp co cC cG cmp co cpp co
      cB cF cmp co cC cR cmp co cpp co cpp co cB cG cmp co cD cR cmp co cpp co
      cC cG cmp co cB cF cmp co cC cR cmp co cpp co cpp co cpp co cA cD cpp co
      cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cD cF cmp co cA cG
      cmp co cD cS cmp co cpp co cpp co cB cG cmp co cD cR cmp co cpp co cC cG
      cmp co cpp co cB cF cmp co cC cR cmp co cpp co cpp cA cD cpp co cB cC cpp
      co wceq cF cS cpp co cG cR cpp co wceq wa cA cG cmp co cD cF cmp co cD cS
      cmp co cpp co cpp co cB cG cmp co cC cG cmp co cpp co cD cR cmp co cpp co
      cD cF cmp co cA cG cmp co cD cS cmp co cpp co cpp co cB cG cmp co cD cR
      cmp co cpp co cC cG cmp co cpp co cF cS cpp co cG cR cpp co wceq cA cD
      cpp co cB cC cpp co wceq cA cG cmp co cD cF cmp co cD cS cmp co cpp co
      cpp co cA cG cmp co cD cG cmp co cpp co cD cR cmp co cpp co cB cG cmp co
      cC cG cmp co cpp co cD cR cmp co cpp co cF cS cpp co cG cR cpp co wceq cA
      cG cmp co cD cF cmp co cD cS cmp co cpp co cpp co cA cG cmp co cD cG cmp
      co cD cR cmp co cpp co cpp co cA cG cmp co cD cG cmp co cpp co cD cR cmp
      co cpp co cF cS cpp co cG cR cpp co wceq cD cF cmp co cD cS cmp co cpp co
      cD cG cmp co cD cR cmp co cpp co cA cG cmp co cpp cF cS cpp co cG cR cpp
      co wceq cD cF cS cpp co cmp co cD cG cR cpp co cmp co cD cF cmp co cD cS
      cmp co cpp co cD cG cmp co cD cR cmp co cpp co cF cS cpp co cG cR cpp co
      cD cmp opreq2 cD cF cS cmpblnr.5 cmpblnr.8 distrpr cD cG cR cmpblnr.6
      cmpblnr.7 distrpr 3eqtr3g opreq2d cA cG cmp co cD cG cmp co cD cR cmp co
      cD cG cmp oprex cD cR cmp oprex addasspr syl6eqr cA cD cpp co cB cC cpp
      co wceq cA cG cmp co cD cG cmp co cpp co cB cG cmp co cC cG cmp co cpp co
      cD cR cmp co cpp cA cD cpp co cB cC cpp co wceq cA cD cpp co cG cmp co cB
      cC cpp co cG cmp co cA cG cmp co cD cG cmp co cpp co cB cG cmp co cC cG
      cmp co cpp co cA cD cpp co cB cC cpp co cG cmp opreq1 vx vy vz cA cD cG
      cpp cmp cmpblnr.1 cmpblnr.4 cmpblnr.6 vx cv vy cv vx visset vy visset
      mulcompr vx cv vy cv vz cv vy visset vz visset distrpr caoprdistrr vx vy
      vz cB cC cG cpp cmp cmpblnr.2 cmpblnr.3 cmpblnr.6 vx cv vy cv vx visset
      vy visset mulcompr vx cv vy cv vz cv vy visset vz visset distrpr
      caoprdistrr 3eqtr3g opreq1d sylan9eqr vx vy vz cA cG cmp co cD cF cmp co
      cD cS cmp co cpp cA cG cmp oprex cD cF cmp oprex cD cS cmp oprex vx cv vy
      cv vx visset vy visset addcompr vx cv vy cv vz cv vy visset vz visset
      addasspr caopr12 vx vy vz cB cG cmp co cC cG cmp co cD cR cmp co cpp cB
      cG cmp oprex cC cG cmp oprex cD cR cmp oprex vx cv vy cv vx visset vy
      visset addcompr vx cv vy cv vz cv vy visset vz visset addasspr caopr32
      3eqtr3g opreq1d cB cG cmp co cD cR cmp co cpp co cC cG cmp co cB cF cmp
      co cC cR cmp co cpp co cC cG cmp oprex cB cF cmp co cC cR cmp co cpp
      oprex addasspr syl6eq eqtr4d vx vy vz cB cG cmp co cD cR cmp co cpp co cA
      cF cmp co cC cS cmp co cpp co cD cF cmp co cpp cB cG cmp co cD cR cmp co
      cpp oprex cA cF cmp co cC cS cmp co cpp oprex cD cF cmp oprex vx cv vy cv
      vx visset vy visset addcompr vx cv vy cv vz cv vy visset vz visset
      addasspr caopr13 cD cF cmp co cA cG cmp co cD cS cmp co cpp co cB cF cmp
      co cC cR cmp co cpp co cA cG cmp co cD cS cmp co cpp oprex cB cF cmp co
      cC cR cmp co cpp oprex addasspr 3eqtr3g cA cF cmp co cC cS cmp co cpp co
      cB cG cmp co cD cR cmp co cpp co cpp co cA cF cmp co cB cG cmp co cpp co
      cC cS cmp co cD cR cmp co cpp co cpp co cD cF cmp co cpp vx vy vz cA cF
      cmp co cC cS cmp co cB cG cmp co cD cR cmp co cpp cA cF cmp oprex cC cS
      cmp oprex cB cG cmp oprex vx cv vy cv vx visset vy visset addcompr vx cv
      vy cv vz cv vy visset vz visset addasspr cD cR cmp oprex caopr4 opreq2i
      cA cG cmp co cD cS cmp co cpp co cB cF cmp co cC cR cmp co cpp co cpp co
      cA cG cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co cpp co
      cD cF cmp co cpp vx vy vz cA cG cmp co cD cS cmp co cB cF cmp co cC cR
      cmp co cpp cA cG cmp oprex cD cS cmp oprex cB cF cmp oprex vx cv vy cv vx
      visset vy visset addcompr vx cv vy cv vz cv vy visset vz visset addasspr
      cC cR cmp oprex caopr42 opreq2i 3eqtr3g $.
      $( [4-Sep-1995] $)

    $( Lemma showing compatibility of multiplication. $)
    mulcmpblnr $p |- ( ( ( ( A e. P. /\ B e. P. ) /\ ( C e. P. /\ D e. P. ) )
               /\ ( ( F e. P. /\ G e. P. ) /\ ( R e. P. /\ S e. P. ) ) ) ->
                ( ( ( A +P. D ) = ( B +P. C ) /\ ( F +P. S ) = ( G +P. R ) ) ->
    <. ( ( A .P. F ) +P. ( B .P. G ) ) , ( ( A .P. G ) +P. ( B .P. F ) ) >. ~R
 <. ( ( C .P. R ) +P. ( D .P. S ) ) , ( ( C .P. S ) +P. ( D .P. R ) ) >. ) ) $=
      cA cnp wcel cB cnp wcel wa cR cnp wcel cS cnp wcel wa cC cnp wcel cD cnp
      wcel wa cF cnp wcel cG cnp wcel wa cA cD cpp co cB cC cpp co wceq cF cS
      cpp co cG cR cpp co wceq wa cA cF cmp co cB cG cmp co cpp co cA cG cmp co
      cB cF cmp co cpp co cop cC cR cmp co cD cS cmp co cpp co cC cS cmp co cD
      cR cmp co cpp co cop cer wbr wi cA cnp wcel cB cnp wcel wa cR cnp wcel cS
      cnp wcel wa wa cC cnp wcel cD cnp wcel wa cF cnp wcel cG cnp wcel wa wa
      cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cA cF
      cmp co cB cG cmp co cpp co cA cG cmp co cB cF cmp co cpp co cop cC cR cmp
      co cD cS cmp co cpp co cC cS cmp co cD cR cmp co cpp co cop cer wbr wi cA
      cnp wcel cB cnp wcel wa cR cnp wcel cS cnp wcel wa wa cC cnp wcel cD cnp
      wcel wa cF cnp wcel cG cnp wcel wa wa cD cF cmp co cnp wcel cA cD cpp co
      cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cA cF cmp co cB cG
      cmp co cpp co cA cG cmp co cB cF cmp co cpp co cop cC cR cmp co cD cS cmp
      co cpp co cC cS cmp co cD cR cmp co cpp co cop cer wbr wi cD cnp wcel cF
      cnp wcel cD cF cmp co cnp wcel cC cnp wcel cD cnp wcel wa cF cnp wcel cG
      cnp wcel wa cD cF mulclpr cC cnp wcel cD cnp wcel pm3.27 cF cnp wcel cG
      cnp wcel pm3.26 syl2an cA cnp wcel cB cnp wcel wa cR cnp wcel cS cnp wcel
      wa wa cC cnp wcel cD cnp wcel wa cF cnp wcel cG cnp wcel wa wa cD cF cmp
      co cnp wcel cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq
      wa cA cF cmp co cB cG cmp co cpp co cA cG cmp co cB cF cmp co cpp co cop
      cC cR cmp co cD cS cmp co cpp co cC cS cmp co cD cR cmp co cpp co cop cer
      wbr cA cnp wcel cB cnp wcel wa cC cnp wcel cD cnp wcel wa cR cnp wcel cS
      cnp wcel wa cF cnp wcel cG cnp wcel wa cD cF cmp co cnp wcel cA cD cpp co
      cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa wa cA cF cmp co cB cG
      cmp co cpp co cA cG cmp co cB cF cmp co cpp co cop cC cR cmp co cD cS cmp
      co cpp co cC cS cmp co cD cR cmp co cpp co cop cer wbr wi cA cnp wcel cB
      cnp wcel wa cF cnp wcel cG cnp wcel wa cC cnp wcel cD cnp wcel wa cR cnp
      wcel cS cnp wcel wa cD cF cmp co cnp wcel cA cD cpp co cB cC cpp co wceq
      cF cS cpp co cG cR cpp co wceq wa wa cA cF cmp co cB cG cmp co cpp co cA
      cG cmp co cB cF cmp co cpp co cop cC cR cmp co cD cS cmp co cpp co cC cS
      cmp co cD cR cmp co cpp co cop cer wbr wi cA cF cmp co cB cG cmp co cpp
      co cnp wcel cA cG cmp co cB cF cmp co cpp co cnp wcel wa cC cR cmp co cD
      cS cmp co cpp co cnp wcel cC cS cmp co cD cR cmp co cpp co cnp wcel wa cD
      cF cmp co cnp wcel cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp
      co wceq wa wa cA cF cmp co cB cG cmp co cpp co cA cG cmp co cB cF cmp co
      cpp co cop cC cR cmp co cD cS cmp co cpp co cC cS cmp co cD cR cmp co cpp
      co cop cer wbr wi cA cnp wcel cB cnp wcel wa cF cnp wcel cG cnp wcel wa
      wa cC cnp wcel cD cnp wcel wa cR cnp wcel cS cnp wcel wa wa cA cF cmp co
      cB cG cmp co cpp co cnp wcel cA cG cmp co cB cF cmp co cpp co cnp wcel wa
      cC cR cmp co cD cS cmp co cpp co cnp wcel cC cS cmp co cD cR cmp co cpp
      co cnp wcel wa wa cD cF cmp co cnp wcel cA cD cpp co cB cC cpp co wceq cF
      cS cpp co cG cR cpp co wceq wa wa cA cF cmp co cB cG cmp co cpp co cC cS
      cmp co cD cR cmp co cpp co cpp co cA cG cmp co cB cF cmp co cpp co cC cR
      cmp co cD cS cmp co cpp co cpp co wceq cA cF cmp co cB cG cmp co cpp co
      cA cG cmp co cB cF cmp co cpp co cop cC cR cmp co cD cS cmp co cpp co cC
      cS cmp co cD cR cmp co cpp co cop cer wbr cA cF cmp co cB cG cmp co cpp
      co cnp wcel cC cS cmp co cD cR cmp co cpp co cnp wcel cD cF cmp co cnp
      wcel cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa wa
      cA cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co cpp co
      cA cG cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co cpp co
      wceq wi cA cG cmp co cB cF cmp co cpp co cnp wcel cC cR cmp co cD cS cmp
      co cpp co cnp wcel cA cF cmp co cB cG cmp co cpp co cnp wcel cC cS cmp co
      cD cR cmp co cpp co cnp wcel wa cA cF cmp co cB cG cmp co cpp co cC cS
      cmp co cD cR cmp co cpp co cpp co cnp wcel cD cF cmp co cnp wcel cA cD
      cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa wa cA cF cmp
      co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co cpp co cA cG cmp
      co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co cpp co wceq wi cA
      cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co addclpr cA
      cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co cpp co cnp
      wcel cD cF cmp co cnp wcel cA cD cpp co cB cC cpp co wceq cF cS cpp co cG
      cR cpp co wceq wa cA cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp
      co cpp co cpp co cA cG cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp
      co cpp co cpp co wceq cD cF cmp co cnp wcel cA cF cmp co cB cG cmp co cpp
      co cC cS cmp co cD cR cmp co cpp co cpp co cnp wcel cA cD cpp co cB cC
      cpp co wceq cF cS cpp co cG cR cpp co wceq wa cA cF cmp co cB cG cmp co
      cpp co cC cS cmp co cD cR cmp co cpp co cpp co cA cG cmp co cB cF cmp co
      cpp co cC cR cmp co cD cS cmp co cpp co cpp co wceq wi cD cF cmp co cnp
      wcel cA cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co
      cpp co cnp wcel wa cD cF cmp co cA cF cmp co cB cG cmp co cpp co cC cS
      cmp co cD cR cmp co cpp co cpp co cpp co cD cF cmp co cA cG cmp co cB cF
      cmp co cpp co cC cR cmp co cD cS cmp co cpp co cpp co cpp co wceq cA cF
      cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co cpp co cA cG
      cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co cpp co wceq
      cA cD cpp co cB cC cpp co wceq cF cS cpp co cG cR cpp co wceq wa cD cF
      cmp co cA cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co
      cpp co cA cG cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co
      cpp co cA cF cmp co cB cG cmp co cpp co cC cS cmp co cD cR cmp co cpp co
      cpp oprex cA cG cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp
      co cpp oprex addcanpr cA cB cC cD cR cS cF cG cmpblnr.1 cmpblnr.2
      cmpblnr.3 cmpblnr.4 cmpblnr.5 cmpblnr.6 cmpblnr.7 cmpblnr.8 mulcmpblnrlem
      syl5 expcom imp3a syl ad2ant2rl cA cF cmp co cB cG cmp co cpp co cA cG
      cmp co cB cF cmp co cpp co cC cR cmp co cD cS cmp co cpp co cC cS cmp co
      cD cR cmp co cpp co enrbreq sylibrd cA cnp wcel cB cnp wcel wa cF cnp
      wcel cG cnp wcel wa wa cA cnp wcel cF cnp wcel wa cB cnp wcel cG cnp wcel
      wa wa cA cnp wcel cG cnp wcel wa cB cnp wcel cF cnp wcel wa wa wa cA cF
      cmp co cB cG cmp co cpp co cnp wcel cA cG cmp co cB cF cmp co cpp co cnp
      wcel wa cA cnp wcel cB cnp wcel cF cnp wcel cG cnp wcel rnlem cA cnp wcel
      cF cnp wcel wa cB cnp wcel cG cnp wcel wa wa cA cF cmp co cB cG cmp co
      cpp co cnp wcel cA cnp wcel cG cnp wcel wa cB cnp wcel cF cnp wcel wa wa
      cA cG cmp co cB cF cmp co cpp co cnp wcel cA cF cmp co cnp wcel cB cG cmp
      co cnp wcel cA cF cmp co cB cG cmp co cpp co cnp wcel cA cnp wcel cF cnp
      wcel wa cB cnp wcel cG cnp wcel wa cA cF cmp co cB cG cmp co addclpr cA
      cF mulclpr cB cG mulclpr syl2an cA cG cmp co cnp wcel cB cF cmp co cnp
      wcel cA cG cmp co cB cF cmp co cpp co cnp wcel cA cnp wcel cG cnp wcel wa
      cB cnp wcel cF cnp wcel wa cA cG cmp co cB cF cmp co addclpr cA cG
      mulclpr cB cF mulclpr syl2an anim12i sylbi cC cnp wcel cD cnp wcel wa cR
      cnp wcel cS cnp wcel wa wa cC cnp wcel cR cnp wcel wa cD cnp wcel cS cnp
      wcel wa wa cC cnp wcel cS cnp wcel wa cD cnp wcel cR cnp wcel wa wa wa cC
      cR cmp co cD cS cmp co cpp co cnp wcel cC cS cmp co cD cR cmp co cpp co
      cnp wcel wa cC cnp wcel cD cnp wcel cR cnp wcel cS cnp wcel rnlem cC cnp
      wcel cR cnp wcel wa cD cnp wcel cS cnp wcel wa wa cC cR cmp co cD cS cmp
      co cpp co cnp wcel cC cnp wcel cS cnp wcel wa cD cnp wcel cR cnp wcel wa
      wa cC cS cmp co cD cR cmp co cpp co cnp wcel cC cR cmp co cnp wcel cD cS
      cmp co cnp wcel cC cR cmp co cD cS cmp co cpp co cnp wcel cC cnp wcel cR
      cnp wcel wa cD cnp wcel cS cnp wcel wa cC cR cmp co cD cS cmp co addclpr
      cC cR mulclpr cD cS mulclpr syl2an cC cS cmp co cnp wcel cD cR cmp co cnp
      wcel cC cS cmp co cD cR cmp co cpp co cnp wcel cC cnp wcel cS cnp wcel wa
      cD cnp wcel cR cnp wcel wa cC cS cmp co cD cR cmp co addclpr cC cS
      mulclpr cD cR mulclpr syl2an anim12i sylbi syl2an an42s an4s exp4b mpdi
      imp an42s $.
      $( [5-Sep-1995] $)
  $}

  ${
    $d x y z w v u t s f g h a b c d A $.
    $d x y z w v u t s f g h a b c d B $.
    $d x y z w v u t s f g h a b c d C $.
    $d x y z w v u t s f g h a b c d D $.
    $( Addition of signed reals in terms of positive reals. $)
    addsrpr $p |- ( ( ( A e. P. /\ B e. P. ) /\
                     ( C e. P. /\ D e. P. ) ) ->
                ( [ <. A , B >. ] ~R +R [ <. C , D >. ] ~R ) =
                   [ <. ( A +P. C ) , ( B +P. D ) >. ] ~R ) $=
      vz cv vu cv cpp co vw cv vv cv cpp co wceq va cv vd cv cpp co vb cv vc cv
      cpp co wceq vg cv vs cv cpp co vh cv vt cv cpp co wceq vx vy vz vw vv vu
      vt cA cB cC cD cnr cer cnp vf vg vh cplr cplpr cA cC cpp co cB cD cpp co
      cop vw cv vu cv cpp co vv cv vf cv cpp co cop va cv vg cv cpp co vb cv vh
      cv cpp co cop vc cv vt cv cpp co vd cv vs cv cpp co cop vs va vb vc vd cA
      cC cpp co cB cD cpp co opex va cv vg cv cpp co vb cv vh cv cpp co opex vc
      cv vt cv cpp co vd cv vs cv cpp co opex enrex enrer dmenr vx vy vz vw vv
      vu df-enr vz cv va cv wceq vu cv vd cv wceq vw cv vb cv wceq vv cv vc cv
      wceq vz cv vu cv cpp co vw cv vv cv cpp co wceq va cv vd cv cpp co vb cv
      vc cv cpp co wceq wb vz cv va cv wceq vu cv vd cv wceq wa vw cv vb cv
      wceq vv cv vc cv wceq wa vz cv vu cv cpp co va cv vd cv cpp co vw cv vv
      cv cpp co vb cv vc cv cpp co vz cv va cv vu cv vd cv cpp opreq12 vw cv vb
      cv vv cv vc cv cpp opreq12 eqeqan12d an42s vz cv vg cv wceq vu cv vs cv
      wceq vw cv vh cv wceq vv cv vt cv wceq vz cv vu cv cpp co vw cv vv cv cpp
      co wceq vg cv vs cv cpp co vh cv vt cv cpp co wceq wb vz cv vg cv wceq vu
      cv vs cv wceq wa vw cv vh cv wceq vv cv vt cv wceq wa vz cv vu cv cpp co
      vg cv vs cv cpp co vw cv vv cv cpp co vh cv vt cv cpp co vz cv vg cv vu
      cv vs cv cpp opreq12 vw cv vh cv vv cv vt cv cpp opreq12 eqeqan12d an42s
      vx vy vz vw vv vu vf df-plpr vw cv va cv wceq vu cv vg cv wceq vv cv vb
      cv wceq vf cv vh cv wceq vw cv vu cv cpp co vv cv vf cv cpp co cop va cv
      vg cv cpp co vb cv vh cv cpp co cop wceq vw cv vu cv cpp co va cv vg cv
      cpp co wceq vv cv vf cv cpp co vb cv vh cv cpp co wceq vw cv vu cv cpp co
      vv cv vf cv cpp co cop va cv vg cv cpp co vb cv vh cv cpp co cop wceq vw
      cv va cv wceq vu cv vg cv wceq wa vv cv vb cv wceq vf cv vh cv wceq wa vw
      cv vu cv cpp co vv cv vf cv cpp co va cv vg cv cpp co vb cv vh cv cpp co
      opeq12 vw cv va cv vu cv vg cv cpp opreq12 vv cv vb cv vf cv vh cv cpp
      opreq12 syl2an an4s vw cv vc cv wceq vu cv vt cv wceq vv cv vd cv wceq vf
      cv vs cv wceq vw cv vu cv cpp co vv cv vf cv cpp co cop vc cv vt cv cpp
      co vd cv vs cv cpp co cop wceq vw cv vu cv cpp co vc cv vt cv cpp co wceq
      vv cv vf cv cpp co vd cv vs cv cpp co wceq vw cv vu cv cpp co vv cv vf cv
      cpp co cop vc cv vt cv cpp co vd cv vs cv cpp co cop wceq vw cv vc cv
      wceq vu cv vt cv wceq wa vv cv vd cv wceq vf cv vs cv wceq wa vw cv vu cv
      cpp co vv cv vf cv cpp co vc cv vt cv cpp co vd cv vs cv cpp co opeq12 vw
      cv vc cv vu cv vt cv cpp opreq12 vv cv vd cv vf cv vs cv cpp opreq12
      syl2an an4s vw cv cA wceq vu cv cC wceq vv cv cB wceq vf cv cD wceq vw cv
      vu cv cpp co vv cv vf cv cpp co cop cA cC cpp co cB cD cpp co cop wceq vw
      cv vu cv cpp co cA cC cpp co wceq vv cv vf cv cpp co cB cD cpp co wceq vw
      cv vu cv cpp co vv cv vf cv cpp co cop cA cC cpp co cB cD cpp co cop wceq
      vw cv cA wceq vu cv cC wceq wa vv cv cB wceq vf cv cD wceq wa vw cv vu cv
      cpp co vv cv vf cv cpp co cA cC cpp co cB cD cpp co opeq12 vw cv cA vu cv
      cC cpp opreq12 vv cv cB vf cv cD cpp opreq12 syl2an an4s vx vy vz va vb
      vc vd df-plr df-nr va cv vb cv vc cv vd cv vt cv vs cv vg cv vh cv va
      visset vb visset vc visset vd visset vg visset vh visset vt visset vs
      visset addcmpblnr oprec $.
      $( [3-Sep-1995] $)

    $( Multiplication of signed reals in terms of positive reals. $)
    mulsrpr $p |- ( ( ( A e. P. /\ B e. P. ) /\
                     ( C e. P. /\ D e. P. ) ) ->
                ( [ <. A , B >. ] ~R .R [ <. C , D >. ] ~R ) =
                   [ <. ( ( A .P. C ) +P. ( B .P. D ) ) ,
                              ( ( A .P. D ) +P. ( B .P. C ) ) >. ] ~R ) $=
      vz cv vu cv cpp co vw cv vv cv cpp co wceq va cv vd cv cpp co vb cv vc cv
      cpp co wceq vg cv vs cv cpp co vh cv vt cv cpp co wceq vx vy vz vw vv vu
      vt cA cB cC cD cnr cer cnp vf vg vh cmr cmpr cA cC cmp co cB cD cmp co
      cpp co cA cD cmp co cB cC cmp co cpp co cop vw cv vu cv cmp co vv cv vf
      cv cmp co cpp co vw cv vf cv cmp co vv cv vu cv cmp co cpp co cop va cv
      vg cv cmp co vb cv vh cv cmp co cpp co va cv vh cv cmp co vb cv vg cv cmp
      co cpp co cop vc cv vt cv cmp co vd cv vs cv cmp co cpp co vc cv vs cv
      cmp co vd cv vt cv cmp co cpp co cop vs va vb vc vd cA cC cmp co cB cD
      cmp co cpp co cA cD cmp co cB cC cmp co cpp co opex va cv vg cv cmp co vb
      cv vh cv cmp co cpp co va cv vh cv cmp co vb cv vg cv cmp co cpp co opex
      vc cv vt cv cmp co vd cv vs cv cmp co cpp co vc cv vs cv cmp co vd cv vt
      cv cmp co cpp co opex enrex enrer dmenr vx vy vz vw vv vu df-enr vz cv va
      cv wceq vu cv vd cv wceq vw cv vb cv wceq vv cv vc cv wceq vz cv vu cv
      cpp co vw cv vv cv cpp co wceq va cv vd cv cpp co vb cv vc cv cpp co wceq
      wb vz cv va cv wceq vu cv vd cv wceq wa vw cv vb cv wceq vv cv vc cv wceq
      wa vz cv vu cv cpp co va cv vd cv cpp co vw cv vv cv cpp co vb cv vc cv
      cpp co vz cv va cv vu cv vd cv cpp opreq12 vw cv vb cv vv cv vc cv cpp
      opreq12 eqeqan12d an42s vz cv vg cv wceq vu cv vs cv wceq vw cv vh cv
      wceq vv cv vt cv wceq vz cv vu cv cpp co vw cv vv cv cpp co wceq vg cv vs
      cv cpp co vh cv vt cv cpp co wceq wb vz cv vg cv wceq vu cv vs cv wceq wa
      vw cv vh cv wceq vv cv vt cv wceq wa vz cv vu cv cpp co vg cv vs cv cpp
      co vw cv vv cv cpp co vh cv vt cv cpp co vz cv vg cv vu cv vs cv cpp
      opreq12 vw cv vh cv vv cv vt cv cpp opreq12 eqeqan12d an42s vx vy vz vw
      vv vu vf df-mpr vw cv va cv wceq vv cv vb cv wceq wa vu cv vg cv wceq vf
      cv vh cv wceq wa wa vw cv vu cv cmp co vv cv vf cv cmp co cpp co va cv vg
      cv cmp co vb cv vh cv cmp co cpp co vw cv vf cv cmp co vv cv vu cv cmp co
      cpp co va cv vh cv cmp co vb cv vg cv cmp co cpp co vw cv va cv wceq vu
      cv vg cv wceq vv cv vb cv wceq vf cv vh cv wceq vw cv vu cv cmp co vv cv
      vf cv cmp co cpp co va cv vg cv cmp co vb cv vh cv cmp co cpp co wceq vw
      cv va cv wceq vu cv vg cv wceq wa vv cv vb cv wceq vf cv vh cv wceq wa vw
      cv vu cv cmp co va cv vg cv cmp co vv cv vf cv cmp co vb cv vh cv cmp co
      cpp vw cv va cv vu cv vg cv cmp opreq12 vv cv vb cv vf cv vh cv cmp
      opreq12 opreqan12d an4s vw cv va cv wceq vf cv vh cv wceq vv cv vb cv
      wceq vu cv vg cv wceq vw cv vf cv cmp co vv cv vu cv cmp co cpp co va cv
      vh cv cmp co vb cv vg cv cmp co cpp co wceq vw cv va cv wceq vf cv vh cv
      wceq wa vv cv vb cv wceq vu cv vg cv wceq wa vw cv vf cv cmp co va cv vh
      cv cmp co vv cv vu cv cmp co vb cv vg cv cmp co cpp vw cv va cv vf cv vh
      cv cmp opreq12 vv cv vb cv vu cv vg cv cmp opreq12 opreqan12d an42s
      opeq12d vw cv vc cv wceq vv cv vd cv wceq wa vu cv vt cv wceq vf cv vs cv
      wceq wa wa vw cv vu cv cmp co vv cv vf cv cmp co cpp co vc cv vt cv cmp
      co vd cv vs cv cmp co cpp co vw cv vf cv cmp co vv cv vu cv cmp co cpp co
      vc cv vs cv cmp co vd cv vt cv cmp co cpp co vw cv vc cv wceq vu cv vt cv
      wceq vv cv vd cv wceq vf cv vs cv wceq vw cv vu cv cmp co vv cv vf cv cmp
      co cpp co vc cv vt cv cmp co vd cv vs cv cmp co cpp co wceq vw cv vc cv
      wceq vu cv vt cv wceq wa vv cv vd cv wceq vf cv vs cv wceq wa vw cv vu cv
      cmp co vc cv vt cv cmp co vv cv vf cv cmp co vd cv vs cv cmp co cpp vw cv
      vc cv vu cv vt cv cmp opreq12 vv cv vd cv vf cv vs cv cmp opreq12
      opreqan12d an4s vw cv vc cv wceq vf cv vs cv wceq vv cv vd cv wceq vu cv
      vt cv wceq vw cv vf cv cmp co vv cv vu cv cmp co cpp co vc cv vs cv cmp
      co vd cv vt cv cmp co cpp co wceq vw cv vc cv wceq vf cv vs cv wceq wa vv
      cv vd cv wceq vu cv vt cv wceq wa vw cv vf cv cmp co vc cv vs cv cmp co
      vv cv vu cv cmp co vd cv vt cv cmp co cpp vw cv vc cv vf cv vs cv cmp
      opreq12 vv cv vd cv vu cv vt cv cmp opreq12 opreqan12d an42s opeq12d vw
      cv cA wceq vv cv cB wceq wa vu cv cC wceq vf cv cD wceq wa wa vw cv vu cv
      cmp co vv cv vf cv cmp co cpp co cA cC cmp co cB cD cmp co cpp co vw cv
      vf cv cmp co vv cv vu cv cmp co cpp co cA cD cmp co cB cC cmp co cpp co
      vw cv cA wceq vu cv cC wceq vv cv cB wceq vf cv cD wceq vw cv vu cv cmp
      co vv cv vf cv cmp co cpp co cA cC cmp co cB cD cmp co cpp co wceq vw cv
      cA wceq vu cv cC wceq wa vv cv cB wceq vf cv cD wceq wa vw cv vu cv cmp
      co cA cC cmp co vv cv vf cv cmp co cB cD cmp co cpp vw cv cA vu cv cC cmp
      opreq12 vv cv cB vf cv cD cmp opreq12 opreqan12d an4s vw cv cA wceq vf cv
      cD wceq vv cv cB wceq vu cv cC wceq vw cv vf cv cmp co vv cv vu cv cmp co
      cpp co cA cD cmp co cB cC cmp co cpp co wceq vw cv cA wceq vf cv cD wceq
      wa vv cv cB wceq vu cv cC wceq wa vw cv vf cv cmp co cA cD cmp co vv cv
      vu cv cmp co cB cC cmp co cpp vw cv cA vf cv cD cmp opreq12 vv cv cB vu
      cv cC cmp opreq12 opreqan12d an42s opeq12d vx vy vz va vb vc vd df-mr
      df-nr va cv vb cv vc cv vd cv vt cv vs cv vg cv vh cv va visset vb visset
      vc visset vd visset vg visset vh visset vt visset vs visset mulcmpblnr
      oprec $.
      $( [3-Sep-1995] $)
  $}

  ${
    $d A x y z w v u f $.  $d B x y z w v u f $.  $d C x y z w v u f $.
    $d D x y z w v u f $.
    ltsrpr.1 $e |- A e. _V $.
    ltsrpr.2 $e |- B e. _V $.
    ltsrpr.3 $e |- C e. _V $.
    ltsrpr.4 $e |- D e. _V $.
    $( Ordering of signed reals in terms of positive reals. $)
    ltsrpr $p |- ( [ <. A , B >. ] ~R <R [ <. C , D >. ] ~R <->
                          ( A +P. D ) <P ( B +P. C ) ) $=
      cA cB cC cD cltp cltr cer cpp cnp cnr enrex ltsrpr.2 ltsrpr.3 ltsrpr.4
      dmenr df-nr ltrelsr ltrelpr 0npr dmplp vz cv vu cv cpp co vw cv vv cv cpp
      co cltp wbr cA cD cpp co cB cC cpp co cltp wbr vx vy vz vw vv vu cA cB cC
      cD cltr cer cnp cnr enrex enrer dmenr df-nr vx vy vz vw vv vu df-ltr vz
      cv cnp wcel vw cv cnp wcel wa cA cnp wcel cB cnp wcel wa wa vv cv cnp
      wcel vu cv cnp wcel wa cC cnp wcel cD cnp wcel wa wa wa vz cv vw cv cop
      cer cec cA cB cop cer cec wceq vv cv vu cv cop cer cec cC cD cop cer cec
      wceq wa vz cv vu cv cpp co cB cC cpp co cpp co vw cv vv cv cpp co cA cD
      cpp co cpp co wceq vz cv vu cv cpp co vw cv vv cv cpp co cltp wbr cA cD
      cpp co cB cC cpp co cltp wbr wb vz cv cnp wcel vw cv cnp wcel wa cA cnp
      wcel cB cnp wcel wa wa vv cv cnp wcel vu cv cnp wcel wa cC cnp wcel cD
      cnp wcel wa wa wa vz cv vw cv cop cer cec cA cB cop cer cec wceq vv cv vu
      cv cop cer cec cC cD cop cer cec wceq wa vz cv cB cpp co vw cv cA cpp co
      wceq vu cv cC cpp co vv cv cD cpp co wceq wa vz cv vu cv cpp co cB cC cpp
      co cpp co vw cv vv cv cpp co cA cD cpp co cpp co wceq vz cv cnp wcel vw
      cv cnp wcel wa cA cnp wcel cB cnp wcel wa wa vz cv vw cv cop cer cec cA
      cB cop cer cec wceq vz cv cB cpp co vw cv cA cpp co wceq vv cv cnp wcel
      vu cv cnp wcel wa cC cnp wcel cD cnp wcel wa wa vv cv vu cv cop cer cec
      cC cD cop cer cec wceq vu cv cC cpp co vv cv cD cpp co wceq vz cv vw cv
      cA cB enreceq vv cv cnp wcel vu cv cnp wcel wa cC cnp wcel cD cnp wcel wa
      wa vv cv vu cv cop cer cec cC cD cop cer cec wceq vv cv cD cpp co vu cv
      cC cpp co wceq vu cv cC cpp co vv cv cD cpp co wceq vv cv vu cv cC cD
      enreceq vv cv cD cpp co vu cv cC cpp co eqcom syl6bb bi2anan9 vz cv cB
      cpp co vw cv cA cpp co wceq vu cv cC cpp co vv cv cD cpp co wceq wa vz cv
      cB cpp co vu cv cC cpp co cpp co vw cv cA cpp co vv cv cD cpp co cpp co
      vz cv vu cv cpp co cB cC cpp co cpp co vw cv vv cv cpp co cA cD cpp co
      cpp co vz cv cB cpp co vw cv cA cpp co vu cv cC cpp co vv cv cD cpp co
      cpp opreq12 vx vy vf vz cv vu cv cB cC cpp vz visset vu visset ltsrpr.2
      vx cv vy cv vx visset vy visset addcompr vx cv vy cv vf cv vy visset vf
      visset addasspr ltsrpr.3 caopr4 vx vy vf vw cv vv cv cA cD cpp vw visset
      vv visset ltsrpr.1 vx cv vy cv vx visset vy visset addcompr vx cv vy cv
      vf cv vy visset vf visset addasspr ltsrpr.4 caopr4 3eqtr4g syl6bi vz cv
      cnp wcel vw cv cnp wcel wa cA cnp wcel cB cnp wcel wa wa vv cv cnp wcel
      vu cv cnp wcel wa cC cnp wcel cD cnp wcel wa wa wa cB cC cpp co cnp wcel
      vw cv vv cv cpp co cnp wcel wa vz cv vu cv cpp co cB cC cpp co cpp co vw
      cv vv cv cpp co cA cD cpp co cpp co wceq vz cv vu cv cpp co vw cv vv cv
      cpp co cltp wbr cA cD cpp co cB cC cpp co cltp wbr wb wi vz cv cnp wcel
      vw cv cnp wcel wa vv cv cnp wcel vu cv cnp wcel wa cA cnp wcel cB cnp
      wcel wa cC cnp wcel cD cnp wcel wa cB cC cpp co cnp wcel vw cv vv cv cpp
      co cnp wcel wa cA cnp wcel cB cnp wcel wa cC cnp wcel cD cnp wcel wa wa
      vz cv cnp wcel vw cv cnp wcel wa vv cv cnp wcel vu cv cnp wcel wa wa cB
      cC cpp co cnp wcel vw cv vv cv cpp co cnp wcel wa cA cnp wcel cB cnp wcel
      wa cC cnp wcel cD cnp wcel wa wa cB cC cpp co cnp wcel vz cv cnp wcel vw
      cv cnp wcel wa vv cv cnp wcel vu cv cnp wcel wa wa vw cv vv cv cpp co cnp
      wcel cB cnp wcel cC cnp wcel cB cC cpp co cnp wcel cA cnp wcel cD cnp
      wcel cB cC addclpr ad2ant2lr vw cv cnp wcel vv cv cnp wcel vw cv vv cv
      cpp co cnp wcel vz cv cnp wcel vu cv cnp wcel vw cv vv cv addclpr
      ad2ant2lr anim12i ancoms an4s cB cC cpp co cnp wcel vw cv vv cv cpp co
      cnp wcel wa vz cv vu cv cpp co cB cC cpp co cpp co vw cv vv cv cpp co cA
      cD cpp co cpp co wceq vz cv vu cv cpp co vw cv vv cv cpp co cltp wbr cA
      cD cpp co cB cC cpp co cltp wbr wb vx vy vf vz cv vu cv cpp co cB cC cpp
      co vw cv vv cv cpp co cA cD cpp co cltp cnp cpp vz cv vu cv cpp oprex cB
      cC cpp oprex vx cv vy cv vf cv vx visset vy visset ltapr vw cv vv cv cpp
      oprex vx cv vy cv vx visset vy visset addcompr cA cD cpp oprex caoprord3
      ex syl syld brecop brecop2 $.
      $( [20-Feb-1996] $)
  $}

  ${
    gt0srpr.1 $e |- A e. _V $.
    gt0srpr.2 $e |- B e. _V $.
    $( Greater then zero in terms of positive reals. $)
    gt0srpr $p |- ( 0R <R [ <. A , B >. ] ~R <-> B <P A ) $=
      c1p c1p cop cer cec cA cB cop cer cec cltr wbr c1p cB cpp co c1p cA cpp
      co cltp wbr c0r cA cB cop cer cec cltr wbr cB cA cltp wbr c1p c1p cA cB
      c1p cnp 1pr elisseti c1p cnp 1pr elisseti gt0srpr.1 gt0srpr.2 ltsrpr c0r
      c1p c1p cop cer cec cA cB cop cer cec cltr df-0r breq1i c1p cnp wcel cB
      cA cltp wbr c1p cB cpp co c1p cA cpp co cltp wbr wb 1pr cB cA c1p
      gt0srpr.2 gt0srpr.1 ltapr ax-mp 3bitr4i $.
      $( [13-May-1996] $)
  $}

  $( The empty set is not a signed real. $)
  0nsr $p |- -. (/) e. R. $=
    c0 cnr wcel c0 cnp cnp cxp cer cqs wcel cnp cnp cxp cer dmenr 0nelqs cnr
    cnp cnp cxp cer cqs c0 df-nr eleq2i mtbir $.
    $( [25-Aug-1995] $)

  $( The constant ` 0R ` is a signed real. $)
  0r $p |- 0R e. R. $=
    c0r cnr wcel c1p c1p cop cer cec cnp cnp cxp cer cqs wcel c1p c1p cop cnp
    cnp cxp wcel c1p c1p cop cer cec cnp cnp cxp cer cqs wcel c1p cnp wcel c1p
    cnp wcel c1p c1p cop cnp cnp cxp wcel 1pr 1pr c1p c1p cnp cnp opelxpi mp2an
    cnp cnp cxp c1p c1p cop cer enrex ecelqsi ax-mp c0r c1p c1p cop cer cec cnr
    cnp cnp cxp cer cqs df-0r df-nr eleq12i mpbir $.
    $( [9-Aug-1995] $)

  $( The constant ` 1R ` is a signed real. $)
  1r $p |- 1R e. R. $=
    c1r cnr wcel c1p c1p cpp co c1p cop cer cec cnp cnp cxp cer cqs wcel c1p
    c1p cpp co c1p cop cnp cnp cxp wcel c1p c1p cpp co c1p cop cer cec cnp cnp
    cxp cer cqs wcel c1p c1p cpp co cnp wcel c1p cnp wcel c1p c1p cpp co c1p
    cop cnp cnp cxp wcel c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr
    1pr c1p c1p addclpr mp2an 1pr c1p c1p cpp co c1p cnp cnp opelxpi mp2an cnp
    cnp cxp c1p c1p cpp co c1p cop cer enrex ecelqsi ax-mp c1r c1p c1p cpp co
    c1p cop cer cec cnr cnp cnp cxp cer cqs df-1r df-nr eleq12i mpbir $.
    $( [9-Aug-1995] $)

  $( The constant ` -1R ` is a signed real. $)
  m1r $p |- -1R e. R. $=
    cm1r cnr wcel c1p c1p c1p cpp co cop cer cec cnp cnp cxp cer cqs wcel c1p
    c1p c1p cpp co cop cnp cnp cxp wcel c1p c1p c1p cpp co cop cer cec cnp cnp
    cxp cer cqs wcel c1p cnp wcel c1p c1p cpp co cnp wcel c1p c1p c1p cpp co
    cop cnp cnp cxp wcel 1pr c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel
    1pr 1pr c1p c1p addclpr mp2an c1p c1p c1p cpp co cnp cnp opelxpi mp2an cnp
    cnp cxp c1p c1p c1p cpp co cop cer enrex ecelqsi ax-mp cm1r c1p c1p c1p cpp
    co cop cer cec cnr cnp cnp cxp cer cqs df-m1r df-nr eleq12i mpbir $.
    $( [9-Aug-1995] $)

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Closure of addition on signed reals. $)
    addclsr $p |- ( ( A e. R. /\ B e. R. ) -> ( A +R B ) e. R. ) $=
      cA cnr wcel cB cnr wcel wa cA cB cplr co cnp cnp cxp cer cqs cnr vx cv vy
      cv cop cer cec vz cv vw cv cop cer cec cplr co cnp cnp cxp cer cqs wcel
      cA vz cv vw cv cop cer cec cplr co cnp cnp cxp cer cqs wcel cA cB cplr co
      cnp cnp cxp cer cqs wcel vx vy vz vw cA cB cnp cnp cer cnr df-nr vx cv vy
      cv cop cer cec cA wceq vx cv vy cv cop cer cec vz cv vw cv cop cer cec
      cplr co cA vz cv vw cv cop cer cec cplr co cnp cnp cxp cer cqs vx cv vy
      cv cop cer cec cA vz cv vw cv cop cer cec cplr opreq1 eleq1d vz cv vw cv
      cop cer cec cB wceq cA vz cv vw cv cop cer cec cplr co cA cB cplr co cnp
      cnp cxp cer cqs vz cv vw cv cop cer cec cB cA cplr opreq2 eleq1d vx cv
      cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa wa vx cv vy
      cv cop cer cec vz cv vw cv cop cer cec cplr co vx cv vz cv cpp co vy cv
      vw cv cpp co cop cer cec cnp cnp cxp cer cqs vx cv vy cv vz cv vw cv
      addsrpr vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa
      wa vx cv vz cv cpp co cnp wcel vy cv vw cv cpp co cnp wcel wa vx cv vz cv
      cpp co vy cv vw cv cpp co cop cnp cnp cxp wcel vx cv vz cv cpp co vy cv
      vw cv cpp co cop cer cec cnp cnp cxp cer cqs wcel vx cv cnp wcel vz cv
      cnp wcel vy cv cnp wcel vw cv cnp wcel vx cv vz cv cpp co cnp wcel vy cv
      vw cv cpp co cnp wcel wa vx cv cnp wcel vz cv cnp wcel wa vx cv vz cv cpp
      co cnp wcel vy cv cnp wcel vw cv cnp wcel wa vy cv vw cv cpp co cnp wcel
      vx cv vz cv addclpr vy cv vw cv addclpr anim12i an4s vx cv vz cv cpp co
      vy cv vw cv cpp co cnp cnp opelxpi cnp cnp cxp vx cv vz cv cpp co vy cv
      vw cv cpp co cop cer enrex ecelqsi 3syl eqeltrd 2ecoptocl df-nr syl6eleqr
      $.
      $( [25-Jul-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Closure of multiplication on signed reals. $)
    mulclsr $p |- ( ( A e. R. /\ B e. R. ) -> ( A .R B ) e. R. ) $=
      cA cnr wcel cB cnr wcel wa cA cB cmr co cnp cnp cxp cer cqs cnr vx cv vy
      cv cop cer cec vz cv vw cv cop cer cec cmr co cnp cnp cxp cer cqs wcel cA
      vz cv vw cv cop cer cec cmr co cnp cnp cxp cer cqs wcel cA cB cmr co cnp
      cnp cxp cer cqs wcel vx vy vz vw cA cB cnp cnp cer cnr df-nr vx cv vy cv
      cop cer cec cA wceq vx cv vy cv cop cer cec vz cv vw cv cop cer cec cmr
      co cA vz cv vw cv cop cer cec cmr co cnp cnp cxp cer cqs vx cv vy cv cop
      cer cec cA vz cv vw cv cop cer cec cmr opreq1 eleq1d vz cv vw cv cop cer
      cec cB wceq cA vz cv vw cv cop cer cec cmr co cA cB cmr co cnp cnp cxp
      cer cqs vz cv vw cv cop cer cec cB cA cmr opreq2 eleq1d vx cv cnp wcel vy
      cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa wa vx cv vy cv cop cer
      cec vz cv vw cv cop cer cec cmr co vx cv vz cv cmp co vy cv vw cv cmp co
      cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co cop cer cec cnp cnp
      cxp cer cqs vx cv vy cv vz cv vw cv mulsrpr vx cv cnp wcel vy cv cnp wcel
      wa vz cv cnp wcel vw cv cnp wcel wa wa vx cv vz cv cmp co vy cv vw cv cmp
      co cpp co cnp wcel vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp wcel
      wa vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp co vy cv
      vz cv cmp co cpp co cop cnp cnp cxp wcel vx cv vz cv cmp co vy cv vw cv
      cmp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co cop cer cec
      cnp cnp cxp cer cqs wcel vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel
      vw cv cnp wcel wa wa vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp
      wcel vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp wcel vx cv cnp wcel
      vz cv cnp wcel vy cv cnp wcel vw cv cnp wcel vx cv vz cv cmp co vy cv vw
      cv cmp co cpp co cnp wcel vx cv vz cv cmp co cnp wcel vy cv vw cv cmp co
      cnp wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vx cv cnp
      wcel vz cv cnp wcel wa vy cv cnp wcel vw cv cnp wcel wa vx cv vz cv cmp
      co vy cv vw cv cmp co addclpr vx cv vz cv mulclpr vy cv vw cv mulclpr
      syl2an an4s vx cv cnp wcel vw cv cnp wcel vy cv cnp wcel vz cv cnp wcel
      vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp wcel vx cv vw cv cmp co
      cnp wcel vy cv vz cv cmp co cnp wcel vx cv vw cv cmp co vy cv vz cv cmp
      co cpp co cnp wcel vx cv cnp wcel vw cv cnp wcel wa vy cv cnp wcel vz cv
      cnp wcel wa vx cv vw cv cmp co vy cv vz cv cmp co addclpr vx cv vw cv
      mulclpr vy cv vz cv mulclpr syl2an an42s jca vx cv vz cv cmp co vy cv vw
      cv cmp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp cnp
      opelxpi cnp cnp cxp vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw
      cv cmp co vy cv vz cv cmp co cpp co cop cer enrex ecelqsi 3syl eqeltrd
      2ecoptocl df-nr syl6eleqr $.
      $( [10-Aug-1995] $)
  $}

  ${
    $d x y z w v u f $.
    $( Domain of addition on signed reals. $)
    dmaddsr $p |- dom +R = ( R. X. R. ) $=
      cplr cdm cnr cnr cxp cplr cdm vx cv cnr wcel vy cv cnr wcel wa vx cv vw
      cv vv cv cop cer cec wceq vy cv vu cv vf cv cop cer cec wceq wa vz cv vw
      cv vv cv cop vu cv vf cv cop cplpr co cer cec wceq wa vf wex vu wex vv
      wex vw wex wa vx vy vz copab2 cdm cnr cnr cxp cplr vx cv cnr wcel vy cv
      cnr wcel wa vx cv vw cv vv cv cop cer cec wceq vy cv vu cv vf cv cop cer
      cec wceq wa vz cv vw cv vv cv cop vu cv vf cv cop cplpr co cer cec wceq
      wa vf wex vu wex vv wex vw wex wa vx vy vz copab2 vx vy vz vw vv vu vf
      df-plr dmeqi vx cv vw cv vv cv cop cer cec wceq vy cv vu cv vf cv cop cer
      cec wceq wa vz cv vw cv vv cv cop vu cv vf cv cop cplpr co cer cec wceq
      wa vf wex vu wex vv wex vw wex vx vy vz cnr cnr dmoprabss eqsstri vx vy
      cnr cplr 0nsr vx cv vy cv addclsr oprssdm eqssi $.
      $( [25-Aug-1995] $)
  $}

  ${
    $d x y z w v u f $.
    $( Domain of multiplication on signed reals. $)
    dmmulsr $p |- dom .R = ( R. X. R. ) $=
      cmr cdm cnr cnr cxp cmr cdm vx cv cnr wcel vy cv cnr wcel wa vx cv vw cv
      vv cv cop cer cec wceq vy cv vu cv vf cv cop cer cec wceq wa vz cv vw cv
      vv cv cop vu cv vf cv cop cmpr co cer cec wceq wa vf wex vu wex vv wex vw
      wex wa vx vy vz copab2 cdm cnr cnr cxp cmr vx cv cnr wcel vy cv cnr wcel
      wa vx cv vw cv vv cv cop cer cec wceq vy cv vu cv vf cv cop cer cec wceq
      wa vz cv vw cv vv cv cop vu cv vf cv cop cmpr co cer cec wceq wa vf wex
      vu wex vv wex vw wex wa vx vy vz copab2 vx vy vz vw vv vu vf df-mr dmeqi
      vx cv vw cv vv cv cop cer cec wceq vy cv vu cv vf cv cop cer cec wceq wa
      vz cv vw cv vv cv cop vu cv vf cv cop cmpr co cer cec wceq wa vf wex vu
      wex vv wex vw wex vx vy vz cnr cnr dmoprabss eqsstri vx vy cnr cmr 0nsr
      vx cv vy cv mulclsr oprssdm eqssi $.
      $( [25-Aug-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    addcomsr.1 $e |- A e. _V $.
    addcomsr.2 $e |- B e. _V $.
    $( Addition of signed reals is commutative. $)
    addcomsr $p |- ( A +R B ) = ( B +R A ) $=
      cA cnr wcel cB cnr wcel wa cA cB cplr co cB cA cplr co wceq vx vy vz vw
      cA cB cnr vx cv vz cv cpp co cer cnp cplr vy cv vw cv cpp co vz cv vx cv
      cpp co vw cv vy cv cpp co df-nr vx cv vy cv vz cv vw cv addsrpr vz cv vw
      cv vx cv vy cv addsrpr vx cv vz cv vx visset vz visset addcompr vy cv vw
      cv vy visset vw visset addcompr ecoprcom cA cB cnr cplr addcomsr.2
      dmaddsr addcomsr.1 ndmoprcom pm2.61i $.
      $( [31-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    addasssr.1 $e |- B e. _V $.
    addasssr.2 $e |- C e. _V $.
  $( Addition of signed reals is associative. $)
    addasssr $p |- ( ( A +R B ) +R C ) = ( A +R ( B +R C ) ) $=
      cA cnr wcel cB cnr wcel cC cnr wcel w3a cA cB cplr co cC cplr co cA cB cC
      cplr co cplr co wceq vx vy vz vw vv vu cA cB cC cnr vw cv vu cv cpp co
      cer cnp cplr vx cv vz cv cpp co vy cv vw cv cpp co vx cv vz cv cpp co vv
      cv cpp co vy cv vw cv cpp co vu cv cpp co vx cv vz cv vv cv cpp co cpp co
      vy cv vw cv vu cv cpp co cpp co vz cv vv cv cpp co df-nr vx cv vy cv vz
      cv vw cv addsrpr vz cv vw cv vv cv vu cv addsrpr vx cv vz cv cpp co vy cv
      vw cv cpp co vv cv vu cv addsrpr vx cv vy cv vz cv vv cv cpp co vw cv vu
      cv cpp co addsrpr vx cv cnp wcel vz cv cnp wcel vy cv cnp wcel vw cv cnp
      wcel vx cv vz cv cpp co cnp wcel vy cv vw cv cpp co cnp wcel wa vx cv cnp
      wcel vz cv cnp wcel wa vx cv vz cv cpp co cnp wcel vy cv cnp wcel vw cv
      cnp wcel wa vy cv vw cv cpp co cnp wcel vx cv vz cv addclpr vy cv vw cv
      addclpr anim12i an4s vz cv cnp wcel vv cv cnp wcel vw cv cnp wcel vu cv
      cnp wcel vz cv vv cv cpp co cnp wcel vw cv vu cv cpp co cnp wcel wa vz cv
      cnp wcel vv cv cnp wcel wa vz cv vv cv cpp co cnp wcel vw cv cnp wcel vu
      cv cnp wcel wa vw cv vu cv cpp co cnp wcel vz cv vv cv addclpr vw cv vu
      cv addclpr anim12i an4s vx cv vz cv vv cv vz visset vv visset addasspr vy
      cv vw cv vu cv vw visset vu visset addasspr ecoprass cA cB cC cnr cplr
      addasssr.1 dmaddsr addasssr.2 0nsr ndmoprass pm2.61i $.
      $( [2-Sep-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    mulcomsr.1 $e |- A e. _V $.
    mulcomsr.2 $e |- B e. _V $.
    $( Multiplication of signed reals is commutative. $)
    mulcomsr $p |- ( A .R B ) = ( B .R A ) $=
      cA cnr wcel cB cnr wcel wa cA cB cmr co cB cA cmr co wceq vx vy vz vw cA
      cB cnr vx cv vz cv cmp co vy cv vw cv cmp co cpp co cer cnp cmr vx cv vw
      cv cmp co vy cv vz cv cmp co cpp co vz cv vx cv cmp co vw cv vy cv cmp co
      cpp co vz cv vy cv cmp co vw cv vx cv cmp co cpp co df-nr vx cv vy cv vz
      cv vw cv mulsrpr vz cv vw cv vx cv vy cv mulsrpr vx cv vz cv cmp co vz cv
      vx cv cmp co vy cv vw cv cmp co vw cv vy cv cmp co cpp vx cv vz cv vx
      visset vz visset mulcompr vy cv vw cv vy visset vw visset mulcompr
      opreq12i vx cv vw cv cmp co vy cv vz cv cmp co cpp co vw cv vx cv cmp co
      vz cv vy cv cmp co cpp co vz cv vy cv cmp co vw cv vx cv cmp co cpp co vx
      cv vw cv cmp co vw cv vx cv cmp co vy cv vz cv cmp co vz cv vy cv cmp co
      cpp vx cv vw cv vx visset vw visset mulcompr vy cv vz cv vy visset vz
      visset mulcompr opreq12i vw cv vx cv cmp co vz cv vy cv cmp co vw cv vx
      cv cmp oprex vz cv vy cv cmp oprex addcompr eqtri ecoprcom cA cB cnr cmr
      mulcomsr.2 dmmulsr mulcomsr.1 ndmoprcom pm2.61i $.
      $( [31-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    mulasssr.1 $e |- B e. _V $.
    mulasssr.2 $e |- C e. _V $.
  $( Multiplication of signed reals is associative. $)
    mulasssr $p |- ( ( A .R B ) .R C ) = ( A .R ( B .R C ) ) $=
      cA cnr wcel cB cnr wcel cC cnr wcel w3a cA cB cmr co cC cmr co cA cB cC
      cmr co cmr co wceq vx vy vz vw vv vu cA cB cC cnr vz cv vu cv cmp co vw
      cv vv cv cmp co cpp co cer cnp cmr vx cv vz cv cmp co vy cv vw cv cmp co
      cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx cv vz cv cmp co vy
      cv vw cv cmp co cpp co vv cv cmp co vx cv vw cv cmp co vy cv vz cv cmp co
      cpp co vu cv cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co
      vu cv cmp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vv cv cmp co
      cpp co vx cv vz cv vv cv cmp co vw cv vu cv cmp co cpp co cmp co vy cv vz
      cv vu cv cmp co vw cv vv cv cmp co cpp co cmp co cpp co vx cv vz cv vu cv
      cmp co vw cv vv cv cmp co cpp co cmp co vy cv vz cv vv cv cmp co vw cv vu
      cv cmp co cpp co cmp co cpp co vz cv vv cv cmp co vw cv vu cv cmp co cpp
      co df-nr vx cv vy cv vz cv vw cv mulsrpr vz cv vw cv vv cv vu cv mulsrpr
      vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp co vy cv vz
      cv cmp co cpp co vv cv vu cv mulsrpr vx cv vy cv vz cv vv cv cmp co vw cv
      vu cv cmp co cpp co vz cv vu cv cmp co vw cv vv cv cmp co cpp co mulsrpr
      vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa wa vx
      cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vx cv vw cv cmp co vy
      cv vz cv cmp co cpp co cnp wcel vx cv cnp wcel vz cv cnp wcel vy cv cnp
      wcel vw cv cnp wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel
      vx cv vz cv cmp co cnp wcel vy cv vw cv cmp co cnp wcel vx cv vz cv cmp
      co vy cv vw cv cmp co cpp co cnp wcel vx cv cnp wcel vz cv cnp wcel wa vy
      cv cnp wcel vw cv cnp wcel wa vx cv vz cv cmp co vy cv vw cv cmp co
      addclpr vx cv vz cv mulclpr vy cv vw cv mulclpr syl2an an4s vx cv cnp
      wcel vw cv cnp wcel vy cv cnp wcel vz cv cnp wcel vx cv vw cv cmp co vy
      cv vz cv cmp co cpp co cnp wcel vx cv vw cv cmp co cnp wcel vy cv vz cv
      cmp co cnp wcel vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp wcel vx
      cv cnp wcel vw cv cnp wcel wa vy cv cnp wcel vz cv cnp wcel wa vx cv vw
      cv cmp co vy cv vz cv cmp co addclpr vx cv vw cv mulclpr vy cv vz cv
      mulclpr syl2an an42s jca vz cv cnp wcel vw cv cnp wcel wa vv cv cnp wcel
      vu cv cnp wcel wa wa vz cv vv cv cmp co vw cv vu cv cmp co cpp co cnp
      wcel vz cv vu cv cmp co vw cv vv cv cmp co cpp co cnp wcel vz cv cnp wcel
      vv cv cnp wcel vw cv cnp wcel vu cv cnp wcel vz cv vv cv cmp co vw cv vu
      cv cmp co cpp co cnp wcel vz cv vv cv cmp co cnp wcel vw cv vu cv cmp co
      cnp wcel vz cv vv cv cmp co vw cv vu cv cmp co cpp co cnp wcel vz cv cnp
      wcel vv cv cnp wcel wa vw cv cnp wcel vu cv cnp wcel wa vz cv vv cv cmp
      co vw cv vu cv cmp co addclpr vz cv vv cv mulclpr vw cv vu cv mulclpr
      syl2an an4s vz cv cnp wcel vu cv cnp wcel vw cv cnp wcel vv cv cnp wcel
      vz cv vu cv cmp co vw cv vv cv cmp co cpp co cnp wcel vz cv vu cv cmp co
      cnp wcel vw cv vv cv cmp co cnp wcel vz cv vu cv cmp co vw cv vv cv cmp
      co cpp co cnp wcel vz cv cnp wcel vu cv cnp wcel wa vw cv cnp wcel vv cv
      cnp wcel wa vz cv vu cv cmp co vw cv vv cv cmp co addclpr vz cv vu cv
      mulclpr vw cv vv cv mulclpr syl2an an42s jca vf vg vh vx cv vy cv vz cv
      vw cv vu cv cpp cmp vv cv vx visset vy visset vz visset vf cv vg cv vf
      visset vg visset mulcompr vf cv vg cv vh cv vg visset vh visset distrpr
      vw visset vv visset vf cv vg cv vh cv vg visset vh visset mulasspr vu
      visset vf cv vg cv vf visset vg visset addcompr vf cv vg cv vh cv vg
      visset vh visset addasspr caoprlem2 vf vg vh vx cv vy cv vz cv vw cv vv
      cv cpp cmp vu cv vx visset vy visset vz visset vf cv vg cv vf visset vg
      visset mulcompr vf cv vg cv vh cv vg visset vh visset distrpr vw visset
      vu visset vf cv vg cv vh cv vg visset vh visset mulasspr vv visset vf cv
      vg cv vf visset vg visset addcompr vf cv vg cv vh cv vg visset vh visset
      addasspr caoprlem2 ecoprass cA cB cC cnr cmr mulasssr.1 dmmulsr
      mulasssr.2 0nsr ndmoprass pm2.61i $.
      $( [2-Sep-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    distrsr.1 $e |- B e. _V $.
    distrsr.2 $e |- C e. _V $.
    $( Multiplication of signed reals is distributive. $)
    distrsr $p |- ( A .R ( B +R C ) ) = ( ( A .R B ) +R ( A .R C ) ) $=
      cA cnr wcel cB cnr wcel cC cnr wcel w3a cA cB cC cplr co cmr co cA cB cmr
      co cA cC cmr co cplr co wceq vx vy vz vw vv vu cA cB cC cnr cer cnp cplr
      cmr vx cv vz cv vv cv cpp co cmp co vy cv vw cv vu cv cpp co cmp co cpp
      co vx cv vw cv vu cv cpp co cmp co vy cv vz cv vv cv cpp co cmp co cpp co
      vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vv cv cmp co vy cv vu
      cv cmp co cpp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx
      cv vu cv cmp co vy cv vv cv cmp co cpp co cpp co vz cv vv cv cpp co vw cv
      vu cv cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp
      co vy cv vz cv cmp co cpp co vx cv vv cv cmp co vy cv vu cv cmp co cpp co
      vx cv vu cv cmp co vy cv vv cv cmp co cpp co df-nr vz cv vw cv vv cv vu
      cv addsrpr vx cv vy cv vz cv vv cv cpp co vw cv vu cv cpp co mulsrpr vx
      cv vy cv vz cv vw cv mulsrpr vx cv vy cv vv cv vu cv mulsrpr vx cv vz cv
      cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co
      cpp co vx cv vv cv cmp co vy cv vu cv cmp co cpp co vx cv vu cv cmp co vy
      cv vv cv cmp co cpp co addsrpr vz cv cnp wcel vv cv cnp wcel vw cv cnp
      wcel vu cv cnp wcel vz cv vv cv cpp co cnp wcel vw cv vu cv cpp co cnp
      wcel wa vz cv cnp wcel vv cv cnp wcel wa vz cv vv cv cpp co cnp wcel vw
      cv cnp wcel vu cv cnp wcel wa vw cv vu cv cpp co cnp wcel vz cv vv cv
      addclpr vw cv vu cv addclpr anim12i an4s vx cv cnp wcel vy cv cnp wcel wa
      vz cv cnp wcel vw cv cnp wcel wa wa vx cv vz cv cmp co vy cv vw cv cmp co
      cpp co cnp wcel vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp wcel vx
      cv cnp wcel vz cv cnp wcel vy cv cnp wcel vw cv cnp wcel vx cv vz cv cmp
      co vy cv vw cv cmp co cpp co cnp wcel vx cv vz cv cmp co cnp wcel vy cv
      vw cv cmp co cnp wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp
      wcel vx cv cnp wcel vz cv cnp wcel wa vy cv cnp wcel vw cv cnp wcel wa vx
      cv vz cv cmp co vy cv vw cv cmp co addclpr vx cv vz cv mulclpr vy cv vw
      cv mulclpr syl2an an4s vx cv cnp wcel vw cv cnp wcel vy cv cnp wcel vz cv
      cnp wcel vx cv vw cv cmp co vy cv vz cv cmp co cpp co cnp wcel vx cv vw
      cv cmp co cnp wcel vy cv vz cv cmp co cnp wcel vx cv vw cv cmp co vy cv
      vz cv cmp co cpp co cnp wcel vx cv cnp wcel vw cv cnp wcel wa vy cv cnp
      wcel vz cv cnp wcel wa vx cv vw cv cmp co vy cv vz cv cmp co addclpr vx
      cv vw cv mulclpr vy cv vz cv mulclpr syl2an an42s jca vx cv cnp wcel vy
      cv cnp wcel wa vv cv cnp wcel vu cv cnp wcel wa wa vx cv vv cv cmp co vy
      cv vu cv cmp co cpp co cnp wcel vx cv vu cv cmp co vy cv vv cv cmp co cpp
      co cnp wcel vx cv cnp wcel vv cv cnp wcel vy cv cnp wcel vu cv cnp wcel
      vx cv vv cv cmp co vy cv vu cv cmp co cpp co cnp wcel vx cv vv cv cmp co
      cnp wcel vy cv vu cv cmp co cnp wcel vx cv vv cv cmp co vy cv vu cv cmp
      co cpp co cnp wcel vx cv cnp wcel vv cv cnp wcel wa vy cv cnp wcel vu cv
      cnp wcel wa vx cv vv cv cmp co vy cv vu cv cmp co addclpr vx cv vv cv
      mulclpr vy cv vu cv mulclpr syl2an an4s vx cv cnp wcel vu cv cnp wcel vy
      cv cnp wcel vv cv cnp wcel vx cv vu cv cmp co vy cv vv cv cmp co cpp co
      cnp wcel vx cv vu cv cmp co cnp wcel vy cv vv cv cmp co cnp wcel vx cv vu
      cv cmp co vy cv vv cv cmp co cpp co cnp wcel vx cv cnp wcel vu cv cnp
      wcel wa vy cv cnp wcel vv cv cnp wcel wa vx cv vu cv cmp co vy cv vv cv
      cmp co addclpr vx cv vu cv mulclpr vy cv vv cv mulclpr syl2an an42s jca
      vx cv vz cv vv cv cpp co cmp co vy cv vw cv vu cv cpp co cmp co cpp co vx
      cv vz cv cmp co vx cv vv cv cmp co cpp co vy cv vw cv cmp co vy cv vu cv
      cmp co cpp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv
      vv cv cmp co vy cv vu cv cmp co cpp co cpp co vx cv vz cv vv cv cpp co
      cmp co vx cv vz cv cmp co vx cv vv cv cmp co cpp co vy cv vw cv vu cv cpp
      co cmp co vy cv vw cv cmp co vy cv vu cv cmp co cpp co cpp vx cv vz cv vv
      cv vz visset vv visset distrpr vy cv vw cv vu cv vw visset vu visset
      distrpr opreq12i vf vg vh vx cv vz cv cmp co vx cv vv cv cmp co vy cv vw
      cv cmp co vy cv vu cv cmp co cpp vx cv vz cv cmp oprex vx cv vv cv cmp
      oprex vy cv vw cv cmp oprex vf cv vg cv vf visset vg visset addcompr vf
      cv vg cv vh cv vg visset vh visset addasspr vy cv vu cv cmp oprex caopr4
      eqtri vx cv vw cv vu cv cpp co cmp co vy cv vz cv vv cv cpp co cmp co cpp
      co vx cv vw cv cmp co vx cv vu cv cmp co cpp co vy cv vz cv cmp co vy cv
      vv cv cmp co cpp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co
      vx cv vu cv cmp co vy cv vv cv cmp co cpp co cpp co vx cv vw cv vu cv cpp
      co cmp co vx cv vw cv cmp co vx cv vu cv cmp co cpp co vy cv vz cv vv cv
      cpp co cmp co vy cv vz cv cmp co vy cv vv cv cmp co cpp co cpp vx cv vw
      cv vu cv vw visset vu visset distrpr vy cv vz cv vv cv vz visset vv
      visset distrpr opreq12i vf vg vh vx cv vw cv cmp co vx cv vu cv cmp co vy
      cv vz cv cmp co vy cv vv cv cmp co cpp vx cv vw cv cmp oprex vx cv vu cv
      cmp oprex vy cv vz cv cmp oprex vf cv vg cv vf visset vg visset addcompr
      vf cv vg cv vh cv vg visset vh visset addasspr vy cv vv cv cmp oprex
      caopr4 eqtri ecoprdi cA cB cC cnr cplr cmr distrsr.1 dmaddsr distrsr.2
      0nsr dmmulsr ndmoprdistr pm2.61i $.
      $( [2-Sep-1995] $)
  $}

  $( Minus one plus one is zero for signed reals. $)
  m1p1sr $p |- ( -1R +R 1R ) = 0R $=
    c1p c1p c1p cpp co cop cer cec c1p c1p cpp co c1p cop cer cec cplr co c1p
    c1p cop cer cec cm1r c1r cplr co c0r c1p c1p c1p cpp co cop cer cec c1p c1p
    cpp co c1p cop cer cec cplr co c1p c1p c1p cpp co cpp co c1p c1p cpp co c1p
    cpp co cop cer cec c1p c1p cop cer cec c1p cnp wcel c1p c1p cpp co cnp wcel
    wa c1p c1p cpp co cnp wcel c1p cnp wcel wa c1p c1p c1p cpp co cop cer cec
    c1p c1p cpp co c1p cop cer cec cplr co c1p c1p c1p cpp co cpp co c1p c1p
    cpp co c1p cpp co cop cer cec wceq c1p cnp wcel c1p c1p cpp co cnp wcel 1pr
    c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr
    mp2an pm3.2i c1p c1p cpp co cnp wcel c1p cnp wcel c1p cnp wcel c1p cnp wcel
    c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an 1pr pm3.2i c1p c1p
    c1p cpp co c1p c1p cpp co c1p addsrpr mp2an c1p c1p cop cer cec c1p c1p c1p
    cpp co cpp co c1p c1p cpp co c1p cpp co cop cer cec wceq c1p c1p c1p cpp co
    c1p cpp co cpp co c1p c1p c1p c1p cpp co cpp co cpp co wceq c1p c1p cpp co
    c1p cpp co c1p c1p c1p cpp co cpp co c1p cpp c1p c1p c1p c1p cnp 1pr
    elisseti c1p cnp 1pr elisseti addasspr opreq2i c1p cnp wcel c1p cnp wcel wa
    c1p c1p c1p cpp co cpp co cnp wcel c1p c1p cpp co c1p cpp co cnp wcel wa
    c1p c1p cop cer cec c1p c1p c1p cpp co cpp co c1p c1p cpp co c1p cpp co cop
    cer cec wceq c1p c1p c1p cpp co c1p cpp co cpp co c1p c1p c1p c1p cpp co
    cpp co cpp co wceq wb c1p cnp wcel c1p cnp wcel 1pr 1pr pm3.2i c1p c1p c1p
    cpp co cpp co cnp wcel c1p c1p cpp co c1p cpp co cnp wcel c1p cnp wcel c1p
    c1p cpp co cnp wcel c1p c1p c1p cpp co cpp co cnp wcel 1pr c1p cnp wcel c1p
    cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an c1p c1p c1p
    cpp co addclpr mp2an c1p c1p cpp co cnp wcel c1p cnp wcel c1p c1p cpp co
    c1p cpp co cnp wcel c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr
    1pr c1p c1p addclpr mp2an 1pr c1p c1p cpp co c1p addclpr mp2an pm3.2i c1p
    c1p c1p c1p c1p cpp co cpp co c1p c1p cpp co c1p cpp co enreceq mp2an mpbir
    eqtr4i cm1r c1p c1p c1p cpp co cop cer cec c1r c1p c1p cpp co c1p cop cer
    cec cplr df-m1r df-1r opreq12i df-0r 3eqtr4i $.
    $( [5-May-1996] $)

  $( Minus one times minus one is plus one for signed reals. $)
  m1m1sr $p |- ( -1R .R -1R ) = 1R $=
    c1p c1p c1p cpp co cop cer cec c1p c1p c1p cpp co cop cer cec cmr co c1p
    c1p cpp co c1p cop cer cec cm1r cm1r cmr co c1r c1p c1p c1p cpp co cop cer
    cec c1p c1p c1p cpp co cop cer cec cmr co c1p c1p cmp co c1p c1p cpp co c1p
    c1p cpp co cmp co cpp co c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp
    co cpp co cop cer cec c1p c1p cpp co c1p cop cer cec c1p cnp wcel c1p c1p
    cpp co cnp wcel wa c1p cnp wcel c1p c1p cpp co cnp wcel wa c1p c1p c1p cpp
    co cop cer cec c1p c1p c1p cpp co cop cer cec cmr co c1p c1p cmp co c1p c1p
    cpp co c1p c1p cpp co cmp co cpp co c1p c1p c1p cpp co cmp co c1p c1p cpp
    co c1p cmp co cpp co cop cer cec wceq c1p cnp wcel c1p c1p cpp co cnp wcel
    1pr c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p
    addclpr mp2an pm3.2i c1p cnp wcel c1p c1p cpp co cnp wcel 1pr c1p cnp wcel
    c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an pm3.2i
    c1p c1p c1p cpp co c1p c1p c1p cpp co mulsrpr mp2an c1p c1p cpp co c1p cop
    cer cec c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co cpp co c1p c1p
    c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co cop cer cec wceq c1p c1p
    cpp co c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co cpp co
    c1p c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co cpp co cpp co wceq
    c1p c1p cpp co c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co
    cpp co c1p c1p c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co
    cpp co cpp co c1p c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co cpp
    co cpp co c1p c1p c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp
    co c1p cnp 1pr elisseti c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co
    cpp oprex addasspr c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co cpp
    co c1p c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co cpp co
    c1p cpp c1p c1p cmp co c1p c1p c1p cpp co c1p c1p cpp co cmp co c1p c1p c1p
    cpp co cmp co c1p c1p cpp co c1p cmp co cpp co cpp c1p cnp wcel c1p c1p cmp
    co c1p wceq 1pr c1p 1idpr ax-mp c1p c1p cpp co c1p c1p cpp co cmp co c1p
    c1p cpp co c1p cmp co c1p c1p cpp co c1p cmp co cpp co c1p c1p c1p cpp co
    cmp co c1p c1p cpp co c1p cmp co cpp co c1p c1p cpp co c1p c1p c1p cnp 1pr
    elisseti c1p cnp 1pr elisseti distrpr c1p c1p c1p cpp co cmp co c1p c1p cpp
    co c1p cmp co c1p c1p cpp co c1p cmp co cpp c1p c1p c1p cpp co c1p cnp 1pr
    elisseti c1p c1p cpp oprex mulcompr opreq1i eqtr4i opreq12i opreq2i eqtr4i
    c1p c1p cpp co cnp wcel c1p cnp wcel wa c1p c1p cmp co c1p c1p cpp co c1p
    c1p cpp co cmp co cpp co cnp wcel c1p c1p c1p cpp co cmp co c1p c1p cpp co
    c1p cmp co cpp co cnp wcel wa c1p c1p cpp co c1p cop cer cec c1p c1p cmp co
    c1p c1p cpp co c1p c1p cpp co cmp co cpp co c1p c1p c1p cpp co cmp co c1p
    c1p cpp co c1p cmp co cpp co cop cer cec wceq c1p c1p cpp co c1p c1p c1p
    cpp co cmp co c1p c1p cpp co c1p cmp co cpp co cpp co c1p c1p c1p cmp co
    c1p c1p cpp co c1p c1p cpp co cmp co cpp co cpp co wceq wb c1p c1p cpp co
    cnp wcel c1p cnp wcel c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr
    1pr c1p c1p addclpr mp2an 1pr pm3.2i c1p c1p cmp co c1p c1p cpp co c1p c1p
    cpp co cmp co cpp co cnp wcel c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p
    cmp co cpp co cnp wcel c1p c1p cmp co cnp wcel c1p c1p cpp co c1p c1p cpp
    co cmp co cnp wcel c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co cpp
    co cnp wcel c1p cnp wcel c1p cnp wcel c1p c1p cmp co cnp wcel 1pr 1pr c1p
    c1p mulclpr mp2an c1p c1p cpp co cnp wcel c1p c1p cpp co cnp wcel c1p c1p
    cpp co c1p c1p cpp co cmp co cnp wcel c1p cnp wcel c1p cnp wcel c1p c1p cpp
    co cnp wcel 1pr 1pr c1p c1p addclpr mp2an c1p cnp wcel c1p cnp wcel c1p c1p
    cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an c1p c1p cpp co c1p c1p cpp co
    mulclpr mp2an c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co addclpr
    mp2an c1p c1p c1p cpp co cmp co cnp wcel c1p c1p cpp co c1p cmp co cnp wcel
    c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co cnp wcel c1p cnp
    wcel c1p c1p cpp co cnp wcel c1p c1p c1p cpp co cmp co cnp wcel 1pr c1p cnp
    wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an c1p
    c1p c1p cpp co mulclpr mp2an c1p c1p cpp co cnp wcel c1p cnp wcel c1p c1p
    cpp co c1p cmp co cnp wcel c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp
    wcel 1pr 1pr c1p c1p addclpr mp2an 1pr c1p c1p cpp co c1p mulclpr mp2an c1p
    c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co addclpr mp2an pm3.2i c1p
    c1p cpp co c1p c1p c1p cmp co c1p c1p cpp co c1p c1p cpp co cmp co cpp co
    c1p c1p c1p cpp co cmp co c1p c1p cpp co c1p cmp co cpp co enreceq mp2an
    mpbir eqtr4i cm1r c1p c1p c1p cpp co cop cer cec cm1r c1p c1p c1p cpp co
    cop cer cec cmr df-m1r df-m1r opreq12i df-1r 3eqtr4i $.
    $( [14-May-1996] $)

  ${
    $d x y z w v u f g h $.
    $( Signed real 'less than' is a strict ordering. $)
    ltsosr $p |- <R Or R. $=
      vf vg vh cnr cltr vx cv vy cv cop cer cec vz cv vw cv cop cer cec cltr
      wbr vx cv vy cv cop cer cec vz cv vw cv cop cer cec wceq vz cv vw cv cop
      cer cec vx cv vy cv cop cer cec cltr wbr wo wn wb vx cv vy cv cop cer cec
      vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv vu cv cop
      cer cec cltr wbr wa vx cv vy cv cop cer cec vv cv vu cv cop cer cec cltr
      wbr wi wa vf cv vz cv vw cv cop cer cec cltr wbr vf cv vz cv vw cv cop
      cer cec wceq vz cv vw cv cop cer cec vf cv cltr wbr wo wn wb vf cv vz cv
      vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv vu cv cop cer
      cec cltr wbr wa vf cv vv cv vu cv cop cer cec cltr wbr wi wa vf cv vg cv
      cltr wbr vf cv vg cv wceq vg cv vf cv cltr wbr wo wn wb vf cv vg cv cltr
      wbr vg cv vv cv vu cv cop cer cec cltr wbr wa vf cv vv cv vu cv cop cer
      cec cltr wbr wi wa vf cv vg cv cltr wbr vf cv vg cv wceq vg cv vf cv cltr
      wbr wo wn wb vf cv vg cv cltr wbr vg cv vh cv cltr wbr wa vf cv vh cv
      cltr wbr wi wa vx vy vz vw vv vu vf cv vg cv vh cv cnp cer cnr df-nr vx
      cv vy cv cop cer cec vf cv wceq vx cv vy cv cop cer cec vz cv vw cv cop
      cer cec cltr wbr vx cv vy cv cop cer cec vz cv vw cv cop cer cec wceq vz
      cv vw cv cop cer cec vx cv vy cv cop cer cec cltr wbr wo wn wb vf cv vz
      cv vw cv cop cer cec cltr wbr vf cv vz cv vw cv cop cer cec wceq vz cv vw
      cv cop cer cec vf cv cltr wbr wo wn wb vx cv vy cv cop cer cec vz cv vw
      cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv vu cv cop cer cec
      cltr wbr wa vx cv vy cv cop cer cec vv cv vu cv cop cer cec cltr wbr wi
      vf cv vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv vu
      cv cop cer cec cltr wbr wa vf cv vv cv vu cv cop cer cec cltr wbr wi vx
      cv vy cv cop cer cec vf cv wceq vx cv vy cv cop cer cec vz cv vw cv cop
      cer cec cltr wbr vf cv vz cv vw cv cop cer cec cltr wbr vx cv vy cv cop
      cer cec vz cv vw cv cop cer cec wceq vz cv vw cv cop cer cec vx cv vy cv
      cop cer cec cltr wbr wo wn vf cv vz cv vw cv cop cer cec wceq vz cv vw cv
      cop cer cec vf cv cltr wbr wo wn vx cv vy cv cop cer cec vf cv vz cv vw
      cv cop cer cec cltr breq1 vx cv vy cv cop cer cec vf cv wceq vx cv vy cv
      cop cer cec vz cv vw cv cop cer cec wceq vz cv vw cv cop cer cec vx cv vy
      cv cop cer cec cltr wbr wo vf cv vz cv vw cv cop cer cec wceq vz cv vw cv
      cop cer cec vf cv cltr wbr wo vx cv vy cv cop cer cec vf cv wceq vx cv vy
      cv cop cer cec vz cv vw cv cop cer cec wceq vf cv vz cv vw cv cop cer cec
      wceq vz cv vw cv cop cer cec vx cv vy cv cop cer cec cltr wbr vz cv vw cv
      cop cer cec vf cv cltr wbr vx cv vy cv cop cer cec vf cv vz cv vw cv cop
      cer cec eqeq1 vx cv vy cv cop cer cec vf cv vz cv vw cv cop cer cec cltr
      breq2 orbi12d notbid bibi12d vx cv vy cv cop cer cec vf cv wceq vx cv vy
      cv cop cer cec vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec
      vv cv vu cv cop cer cec cltr wbr wa vf cv vz cv vw cv cop cer cec cltr
      wbr vz cv vw cv cop cer cec vv cv vu cv cop cer cec cltr wbr wa vx cv vy
      cv cop cer cec vv cv vu cv cop cer cec cltr wbr vf cv vv cv vu cv cop cer
      cec cltr wbr vx cv vy cv cop cer cec vf cv wceq vx cv vy cv cop cer cec
      vz cv vw cv cop cer cec cltr wbr vf cv vz cv vw cv cop cer cec cltr wbr
      vz cv vw cv cop cer cec vv cv vu cv cop cer cec cltr wbr vx cv vy cv cop
      cer cec vf cv vz cv vw cv cop cer cec cltr breq1 anbi1d vx cv vy cv cop
      cer cec vf cv vv cv vu cv cop cer cec cltr breq1 imbi12d anbi12d vz cv vw
      cv cop cer cec vg cv wceq vf cv vz cv vw cv cop cer cec cltr wbr vf cv vz
      cv vw cv cop cer cec wceq vz cv vw cv cop cer cec vf cv cltr wbr wo wn wb
      vf cv vg cv cltr wbr vf cv vg cv wceq vg cv vf cv cltr wbr wo wn wb vf cv
      vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv vu cv cop
      cer cec cltr wbr wa vf cv vv cv vu cv cop cer cec cltr wbr wi vf cv vg cv
      cltr wbr vg cv vv cv vu cv cop cer cec cltr wbr wa vf cv vv cv vu cv cop
      cer cec cltr wbr wi vz cv vw cv cop cer cec vg cv wceq vf cv vz cv vw cv
      cop cer cec cltr wbr vf cv vg cv cltr wbr vf cv vz cv vw cv cop cer cec
      wceq vz cv vw cv cop cer cec vf cv cltr wbr wo wn vf cv vg cv wceq vg cv
      vf cv cltr wbr wo wn vz cv vw cv cop cer cec vg cv vf cv cltr breq2 vz cv
      vw cv cop cer cec vg cv wceq vf cv vz cv vw cv cop cer cec wceq vz cv vw
      cv cop cer cec vf cv cltr wbr wo vf cv vg cv wceq vg cv vf cv cltr wbr wo
      vz cv vw cv cop cer cec vg cv wceq vf cv vz cv vw cv cop cer cec wceq vf
      cv vg cv wceq vz cv vw cv cop cer cec vf cv cltr wbr vg cv vf cv cltr wbr
      vz cv vw cv cop cer cec vg cv vf cv eqeq2 vz cv vw cv cop cer cec vg cv
      vf cv cltr breq1 orbi12d notbid bibi12d vz cv vw cv cop cer cec vg cv
      wceq vf cv vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv
      vu cv cop cer cec cltr wbr wa vf cv vg cv cltr wbr vg cv vv cv vu cv cop
      cer cec cltr wbr wa vf cv vv cv vu cv cop cer cec cltr wbr vz cv vw cv
      cop cer cec vg cv wceq vf cv vz cv vw cv cop cer cec cltr wbr vf cv vg cv
      cltr wbr vz cv vw cv cop cer cec vv cv vu cv cop cer cec cltr wbr vg cv
      vv cv vu cv cop cer cec cltr wbr vz cv vw cv cop cer cec vg cv vf cv cltr
      breq2 vz cv vw cv cop cer cec vg cv vv cv vu cv cop cer cec cltr breq1
      anbi12d imbi1d anbi12d vv cv vu cv cop cer cec vh cv wceq vf cv vg cv
      cltr wbr vg cv vv cv vu cv cop cer cec cltr wbr wa vf cv vv cv vu cv cop
      cer cec cltr wbr wi vf cv vg cv cltr wbr vg cv vh cv cltr wbr wa vf cv vh
      cv cltr wbr wi vf cv vg cv cltr wbr vf cv vg cv wceq vg cv vf cv cltr wbr
      wo wn wb vv cv vu cv cop cer cec vh cv wceq vf cv vg cv cltr wbr vg cv vv
      cv vu cv cop cer cec cltr wbr wa vf cv vg cv cltr wbr vg cv vh cv cltr
      wbr wa vf cv vv cv vu cv cop cer cec cltr wbr vf cv vh cv cltr wbr vv cv
      vu cv cop cer cec vh cv wceq vg cv vv cv vu cv cop cer cec cltr wbr vg cv
      vh cv cltr wbr vf cv vg cv cltr wbr vv cv vu cv cop cer cec vh cv vg cv
      cltr breq2 anbi2d vv cv vu cv cop cer cec vh cv vf cv cltr breq2 imbi12d
      anbi2d vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa
      vv cv cnp wcel vu cv cnp wcel wa w3a vx cv vy cv cop cer cec vz cv vw cv
      cop cer cec cltr wbr vx cv vy cv cop cer cec vz cv vw cv cop cer cec wceq
      vz cv vw cv cop cer cec vx cv vy cv cop cer cec cltr wbr wo wn wb vx cv
      vy cv cop cer cec vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer
      cec vv cv vu cv cop cer cec cltr wbr wa vx cv vy cv cop cer cec vv cv vu
      cv cop cer cec cltr wbr wi vx cv cnp wcel vy cv cnp wcel wa vz cv cnp
      wcel vw cv cnp wcel wa vx cv vy cv cop cer cec vz cv vw cv cop cer cec
      cltr wbr vx cv vy cv cop cer cec vz cv vw cv cop cer cec wceq vz cv vw cv
      cop cer cec vx cv vy cv cop cer cec cltr wbr wo wn wb vv cv cnp wcel vu
      cv cnp wcel wa vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp
      wcel wa wa vx cv vw cv cpp co vy cv vz cv cpp co cltp wbr vx cv vy cv cop
      cer cec vz cv vw cv cop cer cec wceq vz cv vw cv cop cer cec vx cv vy cv
      cop cer cec cltr wbr wo wn vx cv vy cv cop cer cec vz cv vw cv cop cer
      cec cltr wbr vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp
      wcel wa wa vx cv vw cv cpp co vy cv vz cv cpp co cltp wbr vx cv vw cv cpp
      co vy cv vz cv cpp co wceq vy cv vz cv cpp co vx cv vw cv cpp co cltp wbr
      wo wn vx cv vy cv cop cer cec vz cv vw cv cop cer cec wceq vz cv vw cv
      cop cer cec vx cv vy cv cop cer cec cltr wbr wo wn vx cv cnp wcel vw cv
      cnp wcel vy cv cnp wcel vz cv cnp wcel vx cv vw cv cpp co vy cv vz cv cpp
      co cltp wbr vx cv vw cv cpp co vy cv vz cv cpp co wceq vy cv vz cv cpp co
      vx cv vw cv cpp co cltp wbr wo wn wb vx cv vw cv cpp co cnp wcel vy cv vz
      cv cpp co cnp wcel vx cv vw cv cpp co vy cv vz cv cpp co cltp wbr vx cv
      vw cv cpp co vy cv vz cv cpp co wceq vy cv vz cv cpp co vx cv vw cv cpp
      co cltp wbr wo wn wb vx cv cnp wcel vw cv cnp wcel wa vy cv cnp wcel vz
      cv cnp wcel wa cnp cltp wor vx cv vw cv cpp co cnp wcel vy cv vz cv cpp
      co cnp wcel wa vx cv vw cv cpp co vy cv vz cv cpp co cltp wbr vx cv vw cv
      cpp co vy cv vz cv cpp co wceq vy cv vz cv cpp co vx cv vw cv cpp co cltp
      wbr wo wn wb ltsopr cnp vx cv vw cv cpp co vy cv vz cv cpp co cltp sotric
      mpan vx cv vw cv addclpr vy cv vz cv addclpr syl2an an42s vx cv cnp wcel
      vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa wa vx cv vy cv cop cer
      cec vz cv vw cv cop cer cec wceq vz cv vw cv cop cer cec vx cv vy cv cop
      cer cec cltr wbr wo vx cv vw cv cpp co vy cv vz cv cpp co wceq vy cv vz
      cv cpp co vx cv vw cv cpp co cltp wbr wo vx cv cnp wcel vy cv cnp wcel wa
      vz cv cnp wcel vw cv cnp wcel wa wa vx cv vy cv cop cer cec vz cv vw cv
      cop cer cec wceq vx cv vw cv cpp co vy cv vz cv cpp co wceq vz cv vw cv
      cop cer cec vx cv vy cv cop cer cec cltr wbr vy cv vz cv cpp co vx cv vw
      cv cpp co cltp wbr vx cv vy cv vz cv vw cv enreceq vz cv vw cv cop cer
      cec vx cv vy cv cop cer cec cltr wbr vy cv vz cv cpp co vx cv vw cv cpp
      co cltp wbr wb vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp
      wcel wa wa vz cv vw cv cop cer cec vx cv vy cv cop cer cec cltr wbr vz cv
      vy cv cpp co vw cv vx cv cpp co cltp wbr vy cv vz cv cpp co vx cv vw cv
      cpp co cltp wbr vz cv vw cv vx cv vy cv vz visset vw visset vx visset vy
      visset ltsrpr vz cv vy cv cpp co vy cv vz cv cpp co vw cv vx cv cpp co vx
      cv vw cv cpp co cltp vz cv vy cv vz visset vy visset addcompr vw cv vx cv
      vw visset vx visset addcompr breq12i bitri a1i orbi12d notbid bitr4d vx
      cv vy cv vz cv vw cv vx visset vy visset vz visset vw visset ltsrpr
      syl5bb 3adant3 vx cv cnp wcel vy cv cnp wcel wa vv cv cnp wcel vu cv cnp
      wcel wa vx cv vy cv cop cer cec vz cv vw cv cop cer cec cltr wbr vz cv vw
      cv cop cer cec vv cv vu cv cop cer cec cltr wbr wa vx cv vy cv cop cer
      cec vv cv vu cv cop cer cec cltr wbr wi vz cv cnp wcel vw cv cnp wcel wa
      vy cv cnp wcel vu cv cnp wcel vx cv vy cv cop cer cec vz cv vw cv cop cer
      cec cltr wbr vz cv vw cv cop cer cec vv cv vu cv cop cer cec cltr wbr wa
      vx cv vy cv cop cer cec vv cv vu cv cop cer cec cltr wbr wi vx cv cnp
      wcel vv cv cnp wcel vy cv cnp wcel vu cv cnp wcel wa vx cv vy cv cop cer
      cec vz cv vw cv cop cer cec cltr wbr vz cv vw cv cop cer cec vv cv vu cv
      cop cer cec cltr wbr wa vx cv vw cv vu cv cpp co cpp co vy cv vz cv vu cv
      cpp co cpp co cltp wbr vy cv vz cv vu cv cpp co cpp co vy cv vw cv vv cv
      cpp co cpp co cltp wbr wa vx cv vy cv cop cer cec vv cv vu cv cop cer cec
      cltr wbr vu cv cnp wcel vx cv vy cv cop cer cec vz cv vw cv cop cer cec
      cltr wbr vx cv vw cv vu cv cpp co cpp co vy cv vz cv vu cv cpp co cpp co
      cltp wbr vy cv cnp wcel vz cv vw cv cop cer cec vv cv vu cv cop cer cec
      cltr wbr vy cv vz cv vu cv cpp co cpp co vy cv vw cv vv cv cpp co cpp co
      cltp wbr vu cv cnp wcel vx cv vw cv cpp co vy cv vz cv cpp co cltp wbr vx
      cv vw cv vu cv cpp co cpp co vy cv vz cv vu cv cpp co cpp co cltp wbr vx
      cv vy cv cop cer cec vz cv vw cv cop cer cec cltr wbr vu cv cnp wcel vx
      cv vw cv cpp co vy cv vz cv cpp co cltp wbr vx cv vw cv cpp co vu cv cpp
      co vy cv vz cv cpp co vu cv cpp co cltp wbr vx cv vw cv vu cv cpp co cpp
      co vy cv vz cv vu cv cpp co cpp co cltp wbr vf vg vh vx cv vw cv cpp co
      vy cv vz cv cpp co vu cv cltp cnp cpp vx cv vw cv cpp oprex vy cv vz cv
      cpp oprex vf cv vg cv vh cv vf visset vg visset ltapr vu visset vf cv vg
      cv vf visset vg visset addcompr caoprord2 vx cv vw cv cpp co vu cv cpp co
      vx cv vw cv vu cv cpp co cpp co vy cv vz cv cpp co vu cv cpp co vy cv vz
      cv vu cv cpp co cpp co cltp vx cv vw cv vu cv vw visset vu visset
      addasspr vy cv vz cv vu cv vz visset vu visset addasspr breq12i syl6bb vx
      cv vy cv vz cv vw cv vx visset vy visset vz visset vw visset ltsrpr
      syl5bb vy cv cnp wcel vz cv vu cv cpp co vw cv vv cv cpp co cltp wbr vy
      cv vz cv vu cv cpp co cpp co vy cv vw cv vv cv cpp co cpp co cltp wbr vz
      cv vw cv cop cer cec vv cv vu cv cop cer cec cltr wbr vz cv vu cv cpp co
      vw cv vv cv cpp co vy cv vz cv vu cv cpp oprex vw cv vv cv cpp oprex
      ltapr vz cv vw cv vv cv vu cv vz visset vw visset vv visset vu visset
      ltsrpr syl5bb bi2anan9r vx cv vw cv vu cv cpp co cpp co vy cv vz cv vu cv
      cpp co cpp co cltp wbr vy cv vz cv vu cv cpp co cpp co vy cv vw cv vv cv
      cpp co cpp co cltp wbr wa vx cv vw cv vu cv cpp co cpp co vy cv vw cv vv
      cv cpp co cpp co cltp wbr vx cv vy cv cop cer cec vv cv vu cv cop cer cec
      cltr wbr vx cv vw cv vu cv cpp co cpp co vy cv vz cv vu cv cpp co cpp co
      vy cv vw cv vv cv cpp co cpp co cltp cnp vx cv vw cv vu cv cpp co cpp
      oprex ltsopr ltrelpr vy cv vz cv vu cv cpp co cpp oprex vy cv vw cv vv cv
      cpp co cpp oprex sotri vw cv vx cv vu cv cpp co cpp co vw cv vy cv vv cv
      cpp co cpp co cltp wbr vx cv vu cv cpp co vy cv vv cv cpp co cltp wbr vx
      cv vw cv vu cv cpp co cpp co vy cv vw cv vv cv cpp co cpp co cltp wbr vx
      cv vy cv cop cer cec vv cv vu cv cop cer cec cltr wbr vx cv vu cv cpp co
      vy cv vv cv cpp co vw cv cltp cnp cpp vx cv vu cv cpp oprex dmplp ltrelpr
      0npr vx cv vu cv cpp co vy cv vv cv cpp co vw cv vx cv vu cv cpp oprex vy
      cv vv cv cpp oprex ltapr ndmordi vx cv vw cv vu cv cpp co cpp co vw cv vx
      cv vu cv cpp co cpp co vy cv vw cv vv cv cpp co cpp co vw cv vy cv vv cv
      cpp co cpp co cltp vf vg vh vx cv vw cv vu cv cpp vx visset vw visset vu
      visset vf cv vg cv vf visset vg visset addcompr vf cv vg cv vh cv vg
      visset vh visset addasspr caopr12 vf vg vh vy cv vw cv vv cv cpp vy
      visset vw visset vv visset vf cv vg cv vf visset vg visset addcompr vf cv
      vg cv vh cv vg visset vh visset addasspr caopr12 breq12i vx cv vy cv vv
      cv vu cv vx visset vy visset vv visset vu visset ltsrpr 3imtr4i syl
      syl6bi ad2ant2l 3adant2 jca 3ecoptocl so $.
      $( [19-Feb-1996] $)
  $}

  $( 0 is less than 1 for signed reals. $)
  0lt1sr $p |- 0R <R 1R $=
    c1p c1p cop cer cec c1p c1p cpp co c1p cop cer cec c0r c1r cltr c1p c1p cop
    cer cec c1p c1p cpp co c1p cop cer cec cltr wbr c1p c1p cpp co c1p c1p c1p
    cpp co cpp co cltp wbr c1p c1p cpp co c1p c1p cpp co c1p cpp co c1p c1p c1p
    cpp co cpp co cltp c1p c1p cpp co cnp wcel c1p cnp wcel c1p c1p cpp co c1p
    c1p cpp co c1p cpp co cltp wbr c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp
    wcel 1pr 1pr c1p c1p addclpr mp2an 1pr c1p c1p cpp co c1p ltaddpr mp2an c1p
    c1p c1p cpp co c1p cnp 1pr elisseti c1p c1p cpp oprex addcompr breqtrri c1p
    c1p c1p c1p cpp co c1p c1p cnp 1pr elisseti c1p cnp 1pr elisseti c1p c1p
    cpp oprex c1p cnp 1pr elisseti ltsrpr mpbir df-0r df-1r 3brtr4i $.
    $( [26-Mar-1996] $)

  $( 1 and 0 are distinct for signed reals. $)
  1ne0sr $p |- -. 1R = 0R $=
    c1r c0r wceq c1r c1r cltr wbr cnr cltr wor c1r cnr wcel c1r c1r cltr wbr wn
    ltsosr 1r cnr c1r cltr sonr mp2an c1r c0r wceq c1r c1r cltr wbr c0r c1r
    cltr wbr 0lt1sr c1r c0r c1r cltr breq1 mpbiri mto $.
    $( [26-Mar-1996] $)

  ${
    $d x y z w v $.  $d x y A $.
    $( The signed real number 0 is an identity element for addition of
       signed reals. $)
    0idsr $p |- ( A e. R. -> ( A +R 0R ) = A ) $=
      vx cv vy cv cop cer cec c0r cplr co vx cv vy cv cop cer cec wceq cA c0r
      cplr co cA wceq vx vy cA cnp cnp cer cnr df-nr vx cv vy cv cop cer cec cA
      wceq vx cv vy cv cop cer cec c0r cplr co cA c0r cplr co vx cv vy cv cop
      cer cec cA vx cv vy cv cop cer cec cA c0r cplr opreq1 vx cv vy cv cop cer
      cec cA wceq id eqeq12d vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv cop
      cer cec c1p c1p cop cer cec cplr co vx cv vy cv cop cer cec vx cv vy cv
      cop cer cec c0r cplr co vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv cop
      cer cec c1p c1p cop cer cec cplr co vx cv c1p cpp co vy cv c1p cpp co cop
      cer cec vx cv vy cv cop cer cec vx cv cnp wcel vy cv cnp wcel wa c1p cnp
      wcel c1p cnp wcel vx cv vy cv cop cer cec c1p c1p cop cer cec cplr co vx
      cv c1p cpp co vy cv c1p cpp co cop cer cec wceq 1pr 1pr vx cv vy cv c1p
      c1p addsrpr mpanr12 vx cv cnp wcel vy cv cnp wcel wa vx cv c1p cpp co cnp
      wcel vy cv c1p cpp co cnp wcel wa vx cv vy cv cop cer cec vx cv c1p cpp
      co vy cv c1p cpp co cop cer cec wceq vx cv cnp wcel vx cv c1p cpp co cnp
      wcel vy cv cnp wcel vy cv c1p cpp co cnp wcel vx cv cnp wcel c1p cnp wcel
      vx cv c1p cpp co cnp wcel 1pr vx cv c1p addclpr mpan2 vy cv cnp wcel c1p
      cnp wcel vy cv c1p cpp co cnp wcel 1pr vy cv c1p addclpr mpan2 anim12i vx
      cv cnp wcel vy cv cnp wcel wa vx cv c1p cpp co cnp wcel vy cv c1p cpp co
      cnp wcel wa wa vx cv vy cv cop cer cec vx cv c1p cpp co vy cv c1p cpp co
      cop cer cec wceq vx cv vy cv c1p cpp co cpp co vy cv vx cv c1p cpp co cpp
      co wceq vz vw vv vx cv vy cv c1p cpp vx visset vy visset c1p cnp 1pr
      elisseti vz cv vw cv vz visset vw visset addcompr vz cv vw cv vv cv vw
      visset vv visset addasspr caopr12 vx cv vy cv vx cv c1p cpp co vy cv c1p
      cpp co enreceq mpbiri mpdan eqtr4d c0r c1p c1p cop cer cec vx cv vy cv
      cop cer cec cplr df-0r opreq2i syl5eq ecoptocl $.
      $( [10-Apr-1996] $)
  $}

  ${
    $d x y A $.  $d x y z w v $.
    $( 1 is an identity element for multiplication. $)
    1idsr $p |- ( A e. R. -> ( A .R 1R ) = A ) $=
      vx cv vy cv cop cer cec c1r cmr co vx cv vy cv cop cer cec wceq cA c1r
      cmr co cA wceq vx vy cA cnp cnp cer cnr df-nr vx cv vy cv cop cer cec cA
      wceq vx cv vy cv cop cer cec c1r cmr co cA c1r cmr co vx cv vy cv cop cer
      cec cA vx cv vy cv cop cer cec cA c1r cmr opreq1 vx cv vy cv cop cer cec
      cA wceq id eqeq12d vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv cop cer
      cec c1p c1p cpp co c1p cop cer cec cmr co vx cv vy cv cop cer cec vx cv
      vy cv cop cer cec c1r cmr co vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv
      cop cer cec c1p c1p cpp co c1p cop cer cec cmr co vx cv c1p c1p cpp co
      cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p c1p cpp co cmp
      co cpp co cop cer cec vx cv vy cv cop cer cec vx cv cnp wcel vy cv cnp
      wcel wa c1p c1p cpp co cnp wcel c1p cnp wcel vx cv vy cv cop cer cec c1p
      c1p cpp co c1p cop cer cec cmr co vx cv c1p c1p cpp co cmp co vy cv c1p
      cmp co cpp co vx cv c1p cmp co vy cv c1p c1p cpp co cmp co cpp co cop cer
      cec wceq c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p
      c1p addclpr mp2an 1pr vx cv vy cv c1p c1p cpp co c1p mulsrpr mpanr12 vx
      cv cnp wcel vy cv cnp wcel wa vx cv vy cv cop cer cec vx cv c1p c1p cpp
      co cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p c1p cpp co
      cmp co cpp co cop cer cec wceq vx cv vx cv c1p cmp co vy cv c1p c1p cpp
      co cmp co cpp co cpp co vy cv vx cv c1p c1p cpp co cmp co vy cv c1p cmp
      co cpp co cpp co wceq vx cv cnp wcel vy cv cnp wcel wa vx cv vx cv c1p
      cmp co cpp co vy cv c1p c1p cpp co cmp co cpp co vx cv c1p c1p cpp co cmp
      co vy cv vy cv c1p cmp co cpp co cpp co vx cv vx cv c1p cmp co vy cv c1p
      c1p cpp co cmp co cpp co cpp co vy cv vx cv c1p c1p cpp co cmp co vy cv
      c1p cmp co cpp co cpp co vx cv cnp wcel vy cv cnp wcel vx cv vx cv c1p
      cmp co cpp co vx cv c1p c1p cpp co cmp co vy cv c1p c1p cpp co cmp co vy
      cv vy cv c1p cmp co cpp co cpp vx cv cnp wcel vx cv c1p cmp co vx cv c1p
      cmp co cpp co vx cv vx cv c1p cmp co cpp co vx cv c1p c1p cpp co cmp co
      vx cv cnp wcel vx cv c1p cmp co vx cv vx cv c1p cmp co cpp vx cv 1idpr
      opreq1d vx cv c1p c1p c1p cnp 1pr elisseti c1p cnp 1pr elisseti distrpr
      syl5req vy cv cnp wcel vy cv c1p cmp co vy cv c1p cmp co cpp co vy cv vy
      cv c1p cmp co cpp co vy cv c1p c1p cpp co cmp co vy cv cnp wcel vy cv c1p
      cmp co vy cv vy cv c1p cmp co cpp vy cv 1idpr opreq1d vy cv c1p c1p c1p
      cnp 1pr elisseti c1p cnp 1pr elisseti distrpr syl5eq opreqan12d vx cv vx
      cv c1p cmp co vy cv c1p c1p cpp co cmp co vx cv c1p cmp oprex vy cv c1p
      c1p cpp co cmp oprex addasspr vz vw vv vx cv c1p c1p cpp co cmp co vy cv
      vy cv c1p cmp co cpp vx cv c1p c1p cpp co cmp oprex vy visset vy cv c1p
      cmp oprex vz cv vw cv vz visset vw visset addcompr vz cv vw cv vv cv vw
      visset vv visset addasspr caopr12 3eqtr3g vx cv cnp wcel vy cv cnp wcel
      wa vx cv vy cv cop cer cec vx cv c1p c1p cpp co cmp co vy cv c1p cmp co
      cpp co vx cv c1p cmp co vy cv c1p c1p cpp co cmp co cpp co cop cer cec
      wceq vx cv vx cv c1p cmp co vy cv c1p c1p cpp co cmp co cpp co cpp co vy
      cv vx cv c1p c1p cpp co cmp co vy cv c1p cmp co cpp co cpp co wceq wb vx
      cv cnp wcel vy cv cnp wcel wa vx cv cnp wcel vy cv cnp wcel wa vx cv c1p
      c1p cpp co cmp co vy cv c1p cmp co cpp co cnp wcel vx cv c1p cmp co vy cv
      c1p c1p cpp co cmp co cpp co cnp wcel wa vx cv vy cv cop cer cec vx cv
      c1p c1p cpp co cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p
      c1p cpp co cmp co cpp co cop cer cec wceq vx cv vx cv c1p cmp co vy cv
      c1p c1p cpp co cmp co cpp co cpp co vy cv vx cv c1p c1p cpp co cmp co vy
      cv c1p cmp co cpp co cpp co wceq wb vx cv cnp wcel vy cv cnp wcel wa vx
      cv c1p c1p cpp co cmp co vy cv c1p cmp co cpp co cnp wcel vx cv cnp wcel
      vy cv cnp wcel wa vx cv c1p cmp co vy cv c1p c1p cpp co cmp co cpp co cnp
      wcel vx cv c1p c1p cpp co cmp co cnp wcel vy cv c1p cmp co cnp wcel vx cv
      c1p c1p cpp co cmp co vy cv c1p cmp co cpp co cnp wcel vx cv cnp wcel vy
      cv cnp wcel vx cv c1p c1p cpp co cmp co vy cv c1p cmp co addclpr vx cv
      cnp wcel c1p c1p cpp co cnp wcel vx cv c1p c1p cpp co cmp co cnp wcel c1p
      cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr
      mp2an vx cv c1p c1p cpp co mulclpr mpan2 vy cv cnp wcel c1p cnp wcel vy
      cv c1p cmp co cnp wcel 1pr vy cv c1p mulclpr mpan2 syl2an vx cv c1p cmp
      co cnp wcel vy cv c1p c1p cpp co cmp co cnp wcel vx cv c1p cmp co vy cv
      c1p c1p cpp co cmp co cpp co cnp wcel vx cv cnp wcel vy cv cnp wcel vx cv
      c1p cmp co vy cv c1p c1p cpp co cmp co addclpr vx cv cnp wcel c1p cnp
      wcel vx cv c1p cmp co cnp wcel 1pr vx cv c1p mulclpr mpan2 vy cv cnp wcel
      c1p c1p cpp co cnp wcel vy cv c1p c1p cpp co cmp co cnp wcel c1p cnp wcel
      c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an vy cv
      c1p c1p cpp co mulclpr mpan2 syl2an anim12i vx cv vy cv vx cv c1p c1p cpp
      co cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p c1p cpp co
      cmp co cpp co enreceq syldan anidms mpbird eqtr4d c1r c1p c1p cpp co c1p
      cop cer cec vx cv vy cv cop cer cec cmr df-1r opreq2i syl5eq ecoptocl $.
      $( [2-May-1996] $)
  $}

  ${
    $d x y A $.
    $( A signed real times 0 is 0. $)
    00sr $p |- ( A e. R. -> ( A .R 0R ) = 0R ) $=
      vx cv vy cv cop cer cec c0r cmr co c0r wceq cA c0r cmr co c0r wceq vx vy
      cA cnp cnp cer cnr df-nr vx cv vy cv cop cer cec cA wceq vx cv vy cv cop
      cer cec c0r cmr co cA c0r cmr co c0r vx cv vy cv cop cer cec cA c0r cmr
      opreq1 eqeq1d vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv cop cer cec
      c1p c1p cop cer cec cmr co c1p c1p cop cer cec vx cv vy cv cop cer cec
      c0r cmr co c0r vx cv cnp wcel vy cv cnp wcel wa vx cv vy cv cop cer cec
      c1p c1p cop cer cec cmr co vx cv c1p cmp co vy cv c1p cmp co cpp co vx cv
      c1p cmp co vy cv c1p cmp co cpp co cop cer cec c1p c1p cop cer cec vx cv
      cnp wcel vy cv cnp wcel wa c1p cnp wcel c1p cnp wcel vx cv vy cv cop cer
      cec c1p c1p cop cer cec cmr co vx cv c1p cmp co vy cv c1p cmp co cpp co
      vx cv c1p cmp co vy cv c1p cmp co cpp co cop cer cec wceq 1pr 1pr vx cv
      vy cv c1p c1p mulsrpr mpanr12 vx cv cnp wcel vy cv cnp wcel wa vx cv c1p
      cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p cmp co cpp co
      cop cer cec c1p c1p cop cer cec wceq vx cv cnp wcel vy cv cnp wcel wa vx
      cv cnp wcel vy cv cnp wcel wa wa c1p cnp wcel c1p cnp wcel vx cv c1p cmp
      co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p cmp co cpp co cop
      cer cec c1p c1p cop cer cec wceq 1pr 1pr vx cv c1p cmp co vy cv c1p cmp
      co cpp co cnp wcel vx cv c1p cmp co vy cv c1p cmp co cpp co cnp wcel wa
      c1p cnp wcel c1p cnp wcel wa vx cv c1p cmp co vy cv c1p cmp co cpp co vx
      cv c1p cmp co vy cv c1p cmp co cpp co cop cer cec c1p c1p cop cer cec
      wceq vx cv cnp wcel vy cv cnp wcel wa vx cv cnp wcel vy cv cnp wcel wa wa
      vx cv c1p cmp co vy cv c1p cmp co cpp co cnp wcel vx cv c1p cmp co vy cv
      c1p cmp co cpp co cnp wcel wa c1p cnp wcel c1p cnp wcel wa wa vx cv c1p
      cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p cmp co cpp co
      cop cer cec c1p c1p cop cer cec wceq vx cv c1p cmp co vy cv c1p cmp co
      cpp co c1p cpp co vx cv c1p cmp co vy cv c1p cmp co cpp co c1p cpp co
      wceq vx cv c1p cmp co vy cv c1p cmp co cpp co c1p cpp co eqid vx cv c1p
      cmp co vy cv c1p cmp co cpp co vx cv c1p cmp co vy cv c1p cmp co cpp co
      c1p c1p enreceq mpbiri vx cv cnp wcel vy cv cnp wcel wa vx cv c1p cmp co
      vy cv c1p cmp co cpp co cnp wcel vx cv cnp wcel vy cv cnp wcel wa vx cv
      c1p cmp co vy cv c1p cmp co cpp co cnp wcel vx cv c1p cmp co cnp wcel vy
      cv c1p cmp co cnp wcel vx cv c1p cmp co vy cv c1p cmp co cpp co cnp wcel
      vx cv cnp wcel vy cv cnp wcel vx cv c1p cmp co vy cv c1p cmp co addclpr
      vx cv cnp wcel c1p cnp wcel vx cv c1p cmp co cnp wcel 1pr vx cv c1p
      mulclpr mpan2 vy cv cnp wcel c1p cnp wcel vy cv c1p cmp co cnp wcel 1pr
      vy cv c1p mulclpr mpan2 syl2an vx cv c1p cmp co cnp wcel vy cv c1p cmp co
      cnp wcel vx cv c1p cmp co vy cv c1p cmp co cpp co cnp wcel vx cv cnp wcel
      vy cv cnp wcel vx cv c1p cmp co vy cv c1p cmp co addclpr vx cv cnp wcel
      c1p cnp wcel vx cv c1p cmp co cnp wcel 1pr vx cv c1p mulclpr mpan2 vy cv
      cnp wcel c1p cnp wcel vy cv c1p cmp co cnp wcel 1pr vy cv c1p mulclpr
      mpan2 syl2an anim12i sylan mpanr12 anidms eqtrd c0r c1p c1p cop cer cec
      vx cv vy cv cop cer cec cmr df-0r opreq2i df-0r 3eqtr4g ecoptocl $.
      $( [10-Apr-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f $.
    ltasr.1 $e |- A e. _V $.
    ltasr.2 $e |- B e. _V $.
    $( Ordering property of addition. $)
    ltasr $p |- ( C e. R. -> ( A <R B <-> ( C +R A ) <R ( C +R B ) ) ) $=
      cA cB cC cltr cnr cplr ltasr.2 dmaddsr ltasr.1 ltrelsr 0nsr cC cnr wcel
      cA cnr wcel cB cnr wcel cA cB cltr wbr cC cA cplr co cC cB cplr co cltr
      wbr wb vx cv vy cv cop cer cec vz cv vw cv cop cer cec cltr wbr vv cv vu
      cv cop cer cec vx cv vy cv cop cer cec cplr co vv cv vu cv cop cer cec vz
      cv vw cv cop cer cec cplr co cltr wbr wb vx cv vy cv cop cer cec vz cv vw
      cv cop cer cec cltr wbr cC vx cv vy cv cop cer cec cplr co cC vz cv vw cv
      cop cer cec cplr co cltr wbr wb cA vz cv vw cv cop cer cec cltr wbr cC cA
      cplr co cC vz cv vw cv cop cer cec cplr co cltr wbr wb cA cB cltr wbr cC
      cA cplr co cC cB cplr co cltr wbr wb vv vu vx vy vz vw cC cA cB cnp cer
      cnr df-nr vv cv vu cv cop cer cec cC wceq vv cv vu cv cop cer cec vx cv
      vy cv cop cer cec cplr co vv cv vu cv cop cer cec vz cv vw cv cop cer cec
      cplr co cltr wbr cC vx cv vy cv cop cer cec cplr co cC vz cv vw cv cop
      cer cec cplr co cltr wbr vx cv vy cv cop cer cec vz cv vw cv cop cer cec
      cltr wbr vv cv vu cv cop cer cec cC wceq vv cv vu cv cop cer cec vx cv vy
      cv cop cer cec cplr co cC vx cv vy cv cop cer cec cplr co vv cv vu cv cop
      cer cec vz cv vw cv cop cer cec cplr co cC vz cv vw cv cop cer cec cplr
      co cltr vv cv vu cv cop cer cec cC vx cv vy cv cop cer cec cplr opreq1 vv
      cv vu cv cop cer cec cC vz cv vw cv cop cer cec cplr opreq1 breq12d
      bibi2d vx cv vy cv cop cer cec cA wceq vx cv vy cv cop cer cec vz cv vw
      cv cop cer cec cltr wbr cA vz cv vw cv cop cer cec cltr wbr cC vx cv vy
      cv cop cer cec cplr co cC vz cv vw cv cop cer cec cplr co cltr wbr cC cA
      cplr co cC vz cv vw cv cop cer cec cplr co cltr wbr vx cv vy cv cop cer
      cec cA vz cv vw cv cop cer cec cltr breq1 vx cv vy cv cop cer cec cA wceq
      cC vx cv vy cv cop cer cec cplr co cC cA cplr co cC vz cv vw cv cop cer
      cec cplr co cltr vx cv vy cv cop cer cec cA cC cplr opreq2 breq1d bibi12d
      vz cv vw cv cop cer cec cB wceq cA vz cv vw cv cop cer cec cltr wbr cA cB
      cltr wbr cC cA cplr co cC vz cv vw cv cop cer cec cplr co cltr wbr cC cA
      cplr co cC cB cplr co cltr wbr vz cv vw cv cop cer cec cB cA cltr breq2
      vz cv vw cv cop cer cec cB wceq cC vz cv vw cv cop cer cec cplr co cC cB
      cplr co cC cA cplr co cltr vz cv vw cv cop cer cec cB cC cplr opreq2
      breq2d bibi12d vv cv cnp wcel vu cv cnp wcel wa vx cv cnp wcel vy cv cnp
      wcel wa vz cv cnp wcel vw cv cnp wcel wa w3a vx cv vy cv cop cer cec vz
      cv vw cv cop cer cec cltr wbr vv cv vx cv cpp co vu cv vy cv cpp co cop
      cer cec vv cv vz cv cpp co vu cv vw cv cpp co cop cer cec cltr wbr vv cv
      vu cv cop cer cec vx cv vy cv cop cer cec cplr co vv cv vu cv cop cer cec
      vz cv vw cv cop cer cec cplr co cltr wbr vv cv cnp wcel vu cv cnp wcel wa
      vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa w3a vv
      cv vu cv cpp co cnp wcel vx cv vy cv cop cer cec vz cv vw cv cop cer cec
      cltr wbr vv cv vx cv cpp co vu cv vy cv cpp co cop cer cec vv cv vz cv
      cpp co vu cv vw cv cpp co cop cer cec cltr wbr wb vv cv cnp wcel vu cv
      cnp wcel wa vx cv cnp wcel vy cv cnp wcel wa vv cv vu cv cpp co cnp wcel
      vz cv cnp wcel vw cv cnp wcel wa vv cv vu cv addclpr 3ad2ant1 vv cv vu cv
      cpp co cnp wcel vx cv vw cv cpp co vy cv vz cv cpp co cltp wbr vv cv vu
      cv cpp co vx cv vw cv cpp co cpp co vv cv vu cv cpp co vy cv vz cv cpp co
      cpp co cltp wbr vx cv vy cv cop cer cec vz cv vw cv cop cer cec cltr wbr
      vv cv vx cv cpp co vu cv vy cv cpp co cop cer cec vv cv vz cv cpp co vu
      cv vw cv cpp co cop cer cec cltr wbr vx cv vw cv cpp co vy cv vz cv cpp
      co vv cv vu cv cpp co vx cv vw cv cpp oprex vy cv vz cv cpp oprex ltapr
      vx cv vy cv vz cv vw cv vx visset vy visset vz visset vw visset ltsrpr vv
      cv vx cv cpp co vu cv vy cv cpp co cop cer cec vv cv vz cv cpp co vu cv
      vw cv cpp co cop cer cec cltr wbr vv cv vx cv cpp co vu cv vw cv cpp co
      cpp co vu cv vy cv cpp co vv cv vz cv cpp co cpp co cltp wbr vv cv vu cv
      cpp co vx cv vw cv cpp co cpp co vv cv vu cv cpp co vy cv vz cv cpp co
      cpp co cltp wbr vv cv vx cv cpp co vu cv vy cv cpp co vv cv vz cv cpp co
      vu cv vw cv cpp co vv cv vx cv cpp oprex vu cv vy cv cpp oprex vv cv vz
      cv cpp oprex vu cv vw cv cpp oprex ltsrpr vv cv vx cv cpp co vu cv vw cv
      cpp co cpp co vv cv vu cv cpp co vx cv vw cv cpp co cpp co vu cv vy cv
      cpp co vv cv vz cv cpp co cpp co vv cv vu cv cpp co vy cv vz cv cpp co
      cpp co cltp vy vz vf vv cv vx cv vu cv vw cv cpp vv visset vx visset vu
      visset vy cv vz cv vy visset vz visset addcompr vy cv vz cv vf cv vz
      visset vf visset addasspr vw visset caopr4 vu cv vy cv cpp co vv cv vz cv
      cpp co cpp co vv cv vz cv cpp co vu cv vy cv cpp co cpp co vv cv vu cv
      cpp co vy cv vz cv cpp co cpp co vu cv vy cv cpp co vv cv vz cv cpp co vu
      cv vy cv cpp oprex vv cv vz cv cpp oprex addcompr vx vw vf vv cv vz cv vu
      cv vy cv cpp vv visset vz visset vu visset vx cv vw cv vx visset vw
      visset addcompr vx cv vw cv vf cv vw visset vf visset addasspr vy visset
      caopr42 eqtri breq12i bitri 3bitr4g syl vv cv cnp wcel vu cv cnp wcel wa
      vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa w3a vv
      cv vu cv cop cer cec vx cv vy cv cop cer cec cplr co vv cv vx cv cpp co
      vu cv vy cv cpp co cop cer cec vv cv vu cv cop cer cec vz cv vw cv cop
      cer cec cplr co vv cv vz cv cpp co vu cv vw cv cpp co cop cer cec cltr vv
      cv cnp wcel vu cv cnp wcel wa vx cv cnp wcel vy cv cnp wcel wa vv cv vu
      cv cop cer cec vx cv vy cv cop cer cec cplr co vv cv vx cv cpp co vu cv
      vy cv cpp co cop cer cec wceq vz cv cnp wcel vw cv cnp wcel wa vv cv vu
      cv vx cv vy cv addsrpr 3adant3 vv cv cnp wcel vu cv cnp wcel wa vz cv cnp
      wcel vw cv cnp wcel wa vv cv vu cv cop cer cec vz cv vw cv cop cer cec
      cplr co vv cv vz cv cpp co vu cv vw cv cpp co cop cer cec wceq vx cv cnp
      wcel vy cv cnp wcel wa vv cv vu cv vz cv vw cv addsrpr 3adant2 breq12d
      bitr4d 3ecoptocl 3coml ndmord $.
      $( [10-May-1996] $)
  $}

  $( A signed real plus its negative is zero. $)
  pn0sr $p |- ( A e. R. -> ( A +R ( A .R -1R ) ) = 0R ) $=
    cA cnr wcel cA c1r cmr co cA cm1r cmr co cplr co cA cA cm1r cmr co cplr co
    c0r cA cnr wcel cA c1r cmr co cA cA cm1r cmr co cplr cA 1idsr opreq1d cA
    cnr wcel cA c0r cmr co c0r cA c1r cmr co cA cm1r cmr co cplr co cA 00sr cA
    cm1r c1r cplr co cmr co cA cm1r cmr co cA c1r cmr co cplr co cA c0r cmr co
    cA c1r cmr co cA cm1r cmr co cplr co cA cm1r c1r cm1r cnr m1r elisseti c1r
    cnr 1r elisseti distrsr cm1r c1r cplr co c0r cA cmr m1p1sr opreq2i cA cm1r
    cmr co cA c1r cmr co cA cm1r cmr oprex cA c1r cmr oprex addcomsr 3eqtr3i
    syl5eqr eqtr3d $.
    $( [14-May-1996] $)

  ${
    $d x A $.
    $( Existence of negative signed real.  Part of Proposition 9-4.3 of
       [Gleason] p. 126. $)
    negexsr $p |- ( A e. R. -> E. x ( x e. R. /\ ( A +R x ) = 0R ) ) $=
      cA cm1r cmr co cnr wcel cA cA cm1r cmr co cplr co c0r wceq vx cv cnr wcel
      cA vx cv cplr co c0r wceq wa vx wex cA cnr wcel vx cv cnr wcel cA vx cv
      cplr co c0r wceq wa cA cm1r cmr co cnr wcel cA cA cm1r cmr co cplr co c0r
      wceq wa vx cA cm1r cmr co cA cm1r cmr oprex vx cv cA cm1r cmr co wceq vx
      cv cnr wcel cA cm1r cmr co cnr wcel cA vx cv cplr co c0r wceq cA cA cm1r
      cmr co cplr co c0r wceq vx cv cA cm1r cmr co cnr eleq1 vx cv cA cm1r cmr
      co wceq cA vx cv cplr co cA cA cm1r cmr co cplr co c0r vx cv cA cm1r cmr
      co cA cplr opreq2 eqeq1d anbi12d cla4ev cA cnr wcel cm1r cnr wcel cA cm1r
      cmr co cnr wcel m1r cA cm1r mulclsr mpan2 cA pn0sr sylanc $.
      $( [2-May-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z w v u f $.
    recexsrlem.1 $e |- A e. _V $.
    $( The reciprocal of a positive signed real exists.  Part of Proposition
       9-4.3 of [Gleason] p. 126. $)
    recexsrlem $p |- ( 0R <R A -> E. x ( x e. R. /\ ( A .R x ) = 1R ) ) $=
      c0r cA cltr wbr cA vx cv cmr co c1r wceq vx wex vx cv cnr wcel cA vx cv
      cmr co c1r wceq wa vx wex cA cnr wcel c0r cA cltr wbr cA vx cv cmr co c1r
      wceq vx wex c0r cA cltr wbr c0r cnr wcel cA cnr wcel c0r cA cnr cnr cltr
      recexsrlem.1 ltrelsr brel pm3.27d c0r vy cv vz cv cop cer cec cltr wbr vy
      cv vz cv cop cer cec vx cv cmr co c1r wceq vx wex wi c0r cA cltr wbr cA
      vx cv cmr co c1r wceq vx wex wi vy vz cA cnp cnp cer cnr df-nr vy cv vz
      cv cop cer cec cA wceq c0r vy cv vz cv cop cer cec cltr wbr c0r cA cltr
      wbr vy cv vz cv cop cer cec vx cv cmr co c1r wceq vx wex cA vx cv cmr co
      c1r wceq vx wex vy cv vz cv cop cer cec cA c0r cltr breq2 vy cv vz cv cop
      cer cec cA wceq vy cv vz cv cop cer cec vx cv cmr co c1r wceq cA vx cv
      cmr co c1r wceq vx vy cv vz cv cop cer cec cA wceq vy cv vz cv cop cer
      cec vx cv cmr co cA vx cv cmr co c1r vy cv vz cv cop cer cec cA vx cv cmr
      opreq1 eqeq1d exbidv imbi12d vy cv cnp wcel vz cv cnp wcel wa vw cv cnp
      wcel vz cv vw cv cpp co vy cv wceq wa vw wex vy cv vz cv cop cer cec vx
      cv cmr co c1r wceq vx wex c0r vy cv vz cv cop cer cec cltr wbr vy cv cnp
      wcel vz cv cnp wcel wa vw cv cnp wcel vz cv vw cv cpp co vy cv wceq wa vy
      cv vz cv cop cer cec vx cv cmr co c1r wceq vx wex vw vy cv cnp wcel vz cv
      cnp wcel wa vw cv cnp wcel vz cv vw cv cpp co vy cv wceq vy cv vz cv cop
      cer cec vx cv cmr co c1r wceq vx wex vy cv cnp wcel vz cv cnp wcel wa vv
      cv cnp wcel vw cv vv cv cmp co c1p wceq wa vv wex vz cv vw cv cpp co vy
      cv wceq vy cv vz cv cop cer cec vx cv cmr co c1r wceq vx wex wi vw cv cnp
      wcel vy cv cnp wcel vz cv cnp wcel wa vv cv cnp wcel vw cv vv cv cmp co
      c1p wceq wa vz cv vw cv cpp co vy cv wceq vy cv vz cv cop cer cec vx cv
      cmr co c1r wceq vx wex wi vv vy cv cnp wcel vz cv cnp wcel wa vv cv cnp
      wcel vw cv vv cv cmp co c1p wceq vz cv vw cv cpp co vy cv wceq vy cv vz
      cv cop cer cec vx cv cmr co c1r wceq vx wex wi vy cv cnp wcel vz cv cnp
      wcel wa vv cv cnp wcel vw cv vv cv cmp co c1p wceq vz cv vw cv cpp co vy
      cv wceq vy cv vz cv cop cer cec vx cv cmr co c1r wceq vx wex vy cv cnp
      wcel vz cv cnp wcel wa vv cv cnp wcel wa vw cv vv cv cmp co c1p wceq vz
      cv vw cv cpp co vy cv wceq wa wa vy cv vz cv cop cer cec vv cv c1p cpp co
      c1p cop cer cec cmr co c1r wceq vy cv vz cv cop cer cec vx cv cmr co c1r
      wceq vx wex vy cv cnp wcel vz cv cnp wcel wa vv cv cnp wcel wa vw cv vv
      cv cmp co c1p wceq vz cv vw cv cpp co vy cv wceq wa wa vy cv vz cv cop
      cer cec vv cv c1p cpp co c1p cop cer cec cmr co c1p c1p cpp co c1p cop
      cer cec c1r vy cv cnp wcel vz cv cnp wcel wa vv cv cnp wcel wa vw cv vv
      cv cmp co c1p wceq vz cv vw cv cpp co vy cv wceq wa wa vy cv vz cv cop
      cer cec vv cv c1p cpp co c1p cop cer cec cmr co vy cv vv cv c1p cpp co
      cmp co vz cv c1p cmp co cpp co vy cv c1p cmp co vz cv vv cv c1p cpp co
      cmp co cpp co cop cer cec c1p c1p cpp co c1p cop cer cec vy cv cnp wcel
      vz cv cnp wcel wa vv cv cnp wcel wa vw cv vv cv cmp co c1p wceq vz cv vw
      cv cpp co vy cv wceq wa wa vy cv cnp wcel vz cv cnp wcel wa vv cv c1p cpp
      co cnp wcel c1p cnp wcel wa wa vy cv vz cv cop cer cec vv cv c1p cpp co
      c1p cop cer cec cmr co vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp
      co vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co cop cer cec wceq
      vy cv cnp wcel vz cv cnp wcel wa vv cv cnp wcel wa vy cv cnp wcel vz cv
      cnp wcel wa vv cv c1p cpp co cnp wcel c1p cnp wcel wa wa vw cv vv cv cmp
      co c1p wceq vz cv vw cv cpp co vy cv wceq wa vv cv cnp wcel vv cv c1p cpp
      co cnp wcel c1p cnp wcel wa vy cv cnp wcel vz cv cnp wcel wa vv cv cnp
      wcel vv cv c1p cpp co cnp wcel c1p cnp wcel vv cv cnp wcel c1p cnp wcel
      vv cv c1p cpp co cnp wcel 1pr vv cv c1p addclpr mpan2 1pr jctir anim2i
      adantr vy cv vz cv vv cv c1p cpp co c1p mulsrpr syl vy cv cnp wcel vz cv
      cnp wcel wa vv cv cnp wcel wa vw cv vv cv cmp co c1p wceq vz cv vw cv cpp
      co vy cv wceq wa vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp co vy
      cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co cop cer cec c1p c1p
      cpp co c1p cop cer cec wceq vy cv cnp wcel vz cv cnp wcel wa vv cv cnp
      wcel wa vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp co vy cv c1p
      cmp co vz cv vv cv c1p cpp co cmp co cpp co cop cer cec c1p c1p cpp co
      c1p cop cer cec wceq vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp
      co c1p cpp co vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co c1p
      c1p cpp co cpp co wceq vw cv vv cv cmp co c1p wceq vz cv vw cv cpp co vy
      cv wceq wa vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp co cnp wcel
      vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co cnp wcel wa c1p c1p
      cpp co cnp wcel c1p cnp wcel wa vy cv vv cv c1p cpp co cmp co vz cv c1p
      cmp co cpp co vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co cop
      cer cec c1p c1p cpp co c1p cop cer cec wceq vy cv vv cv c1p cpp co cmp co
      vz cv c1p cmp co cpp co c1p cpp co vy cv c1p cmp co vz cv vv cv c1p cpp
      co cmp co cpp co c1p c1p cpp co cpp co wceq wb vy cv cnp wcel vz cv cnp
      wcel wa vv cv cnp wcel wa vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co
      cpp co vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co c1p c1p cpp
      co c1p enreceq vy cv cnp wcel vz cv cnp wcel wa vv cv cnp wcel wa vy cv
      vv cv c1p cpp co cmp co vz cv c1p cmp co cpp co cnp wcel vy cv c1p cmp co
      vz cv vv cv c1p cpp co cmp co cpp co cnp wcel vy cv cnp wcel vv cv cnp
      wcel vz cv cnp wcel vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp co
      cnp wcel vy cv vv cv c1p cpp co cmp co cnp wcel vz cv c1p cmp co cnp wcel
      vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp co cnp wcel vy cv cnp
      wcel vv cv cnp wcel wa vz cv cnp wcel vy cv vv cv c1p cpp co cmp co vz cv
      c1p cmp co addclpr vy cv cnp wcel vv cv c1p cpp co cnp wcel vy cv vv cv
      c1p cpp co cmp co cnp wcel vv cv cnp wcel vy cv vv cv c1p cpp co mulclpr
      vv cv cnp wcel c1p cnp wcel vv cv c1p cpp co cnp wcel 1pr vv cv c1p
      addclpr mpan2 sylan2 vz cv cnp wcel c1p cnp wcel vz cv c1p cmp co cnp
      wcel 1pr vz cv c1p mulclpr mpan2 syl2an an1rs vy cv cnp wcel vz cv cnp
      wcel vv cv cnp wcel vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co
      cnp wcel vy cv c1p cmp co cnp wcel vz cv vv cv c1p cpp co cmp co cnp wcel
      vy cv c1p cmp co vz cv vv cv c1p cpp co cmp co cpp co cnp wcel vy cv cnp
      wcel vz cv cnp wcel vv cv cnp wcel wa vy cv c1p cmp co vz cv vv cv c1p
      cpp co cmp co addclpr vy cv cnp wcel c1p cnp wcel vy cv c1p cmp co cnp
      wcel 1pr vy cv c1p mulclpr mpan2 vz cv cnp wcel vv cv c1p cpp co cnp wcel
      vz cv vv cv c1p cpp co cmp co cnp wcel vv cv cnp wcel vz cv vv cv c1p cpp
      co mulclpr vv cv cnp wcel c1p cnp wcel vv cv c1p cpp co cnp wcel 1pr vv
      cv c1p addclpr mpan2 sylan2 syl2an anassrs jca c1p c1p cpp co cnp wcel
      c1p cnp wcel c1p cnp wcel c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr
      c1p c1p addclpr mp2an 1pr pm3.2i sylancl vw cv vv cv cmp co c1p wceq vz
      cv vw cv cpp co vy cv wceq wa vy cv vv cv cmp co vy cv c1p cmp co vz cv
      c1p cmp co cpp co cpp co c1p cpp co vz cv vv cv cmp co vy cv c1p cmp co
      vz cv c1p cmp co cpp co cpp co c1p c1p cpp co cpp co vy cv vv cv c1p cpp
      co cmp co vz cv c1p cmp co cpp co c1p cpp co vy cv c1p cmp co vz cv vv cv
      c1p cpp co cmp co cpp co c1p c1p cpp co cpp co vw cv vv cv cmp co c1p
      wceq vz cv vw cv cpp co vy cv wceq wa vy cv vv cv cmp co vy cv c1p cmp co
      vz cv c1p cmp co cpp co cpp co c1p cpp co vz cv vv cv cmp co vy cv c1p
      cmp co vz cv c1p cmp co cpp co cpp co c1p cpp co c1p cpp co vz cv vv cv
      cmp co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co c1p c1p cpp co cpp
      co vw cv vv cv cmp co c1p wceq vz cv vw cv cpp co vy cv wceq wa vy cv vv
      cv cmp co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co vz cv vv cv cmp
      co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co c1p cpp co c1p cpp vw
      cv vv cv cmp co c1p wceq vz cv vw cv cpp co vy cv wceq wa vy cv vv cv cmp
      co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co vz cv vv cv cmp co c1p
      cpp co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co vz cv vv cv cmp co
      vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co c1p cpp co vw cv vv cv
      cmp co c1p wceq vz cv vw cv cpp co vy cv wceq wa vy cv vv cv cmp co vz cv
      vv cv cmp co c1p cpp co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp vz
      cv vw cv cpp co vy cv wceq vw cv vv cv cmp co c1p wceq vy cv vv cv cmp co
      vz cv vw cv cpp co vv cv cmp co vz cv vv cv cmp co c1p cpp co vz cv vw cv
      cpp co vy cv wceq vz cv vw cv cpp co vv cv cmp co vy cv vv cv cmp co vz
      cv vw cv cpp co vy cv vv cv cmp opreq1 eqcomd vw cv vv cv cmp co c1p wceq
      vz cv vv cv cmp co vw cv vv cv cmp co cpp co vz cv vv cv cmp co c1p cpp
      co vz cv vw cv cpp co vv cv cmp co vw cv vv cv cmp co c1p vz cv vv cv cmp
      co cpp opreq2 vu vf vx vz cv vw cv vv cv cpp cmp vz visset vw visset vv
      visset vu cv vf cv vu visset vf visset mulcompr vu cv vf cv vx cv vf
      visset vx visset distrpr caoprdistrr syl5eq sylan9eqr opreq1d vu vf vx vz
      cv vv cv cmp co c1p vy cv c1p cmp co vz cv c1p cmp co cpp co cpp vz cv vv
      cv cmp oprex c1p cnp 1pr elisseti vy cv c1p cmp co vz cv c1p cmp co cpp
      oprex vu cv vf cv vu visset vf visset addcompr vu cv vf cv vx cv vf
      visset vx visset addasspr caopr32 syl6eq opreq1d vz cv vv cv cmp co vy cv
      c1p cmp co vz cv c1p cmp co cpp co cpp co c1p c1p c1p cnp 1pr elisseti
      c1p cnp 1pr elisseti addasspr syl6eq vy cv vv cv c1p cpp co cmp co vz cv
      c1p cmp co cpp co vy cv vv cv cmp co vy cv c1p cmp co vz cv c1p cmp co
      cpp co cpp co c1p cpp vy cv vv cv c1p cpp co cmp co vz cv c1p cmp co cpp
      co vy cv vv cv cmp co vy cv c1p cmp co cpp co vz cv c1p cmp co cpp co vy
      cv vv cv cmp co vy cv c1p cmp co vz cv c1p cmp co cpp co cpp co vy cv vv
      cv c1p cpp co cmp co vy cv vv cv cmp co vy cv c1p cmp co cpp co vz cv c1p
      cmp co cpp vy cv vv cv c1p vv visset c1p cnp 1pr elisseti distrpr opreq1i
      vy cv vv cv cmp co vy cv c1p cmp co vz cv c1p cmp co vy cv c1p cmp oprex
      vz cv c1p cmp oprex addasspr eqtri opreq1i vy cv c1p cmp co vz cv vv cv
      c1p cpp co cmp co cpp co vz cv vv cv cmp co vy cv c1p cmp co vz cv c1p
      cmp co cpp co cpp co c1p c1p cpp co cpp vy cv c1p cmp co vz cv vv cv c1p
      cpp co cmp co cpp co vy cv c1p cmp co vz cv vv cv cmp co vz cv c1p cmp co
      cpp co cpp co vz cv vv cv cmp co vy cv c1p cmp co vz cv c1p cmp co cpp co
      cpp co vz cv vv cv c1p cpp co cmp co vz cv vv cv cmp co vz cv c1p cmp co
      cpp co vy cv c1p cmp co cpp vz cv vv cv c1p vv visset c1p cnp 1pr
      elisseti distrpr opreq2i vu vf vx vy cv c1p cmp co vz cv vv cv cmp co vz
      cv c1p cmp co cpp vy cv c1p cmp oprex vz cv vv cv cmp oprex vz cv c1p cmp
      oprex vu cv vf cv vu visset vf visset addcompr vu cv vf cv vx cv vf
      visset vx visset addasspr caopr12 eqtri opreq1i 3eqtr4g syl5bir imp eqtrd
      df-1r syl6eqr vy cv vz cv cop cer cec vx cv cmr co c1r wceq vy cv vz cv
      cop cer cec vv cv c1p cpp co c1p cop cer cec cmr co c1r wceq vx vv cv c1p
      cpp co c1p cop cer cec cer cvv wcel vv cv c1p cpp co c1p cop cer cec cvv
      wcel enrex vv cv c1p cpp co c1p cop cvv cer ecexg ax-mp vx cv vv cv c1p
      cpp co c1p cop cer cec wceq vy cv vz cv cop cer cec vx cv cmr co vy cv vz
      cv cop cer cec vv cv c1p cpp co c1p cop cer cec cmr co c1r vx cv vv cv
      c1p cpp co c1p cop cer cec vy cv vz cv cop cer cec cmr opreq2 eqeq1d
      cla4ev syl exp43 imp3a 19.23adv vv vw cv recexpr syl5 imp3a 19.23adv c0r
      vy cv vz cv cop cer cec cltr wbr vz cv vy cv cltp wbr vw cv cnp wcel vz
      cv vw cv cpp co vy cv wceq wa vw wex vy cv vz cv vy visset vz visset
      gt0srpr vw vz cv vy cv vy visset ltexpri sylbi syl5 ecoptocl mpcom cA vx
      cv cmr co c1r wceq vx cv cnr wcel cA vx cv cmr co c1r wceq wa vx cA vx cv
      cmr co c1r wceq vx cv cnr wcel cA vx cv cmr co c1r wceq cA cnr wcel vx cv
      cnr wcel cA vx cv cmr co c1r wceq cA vx cv cmr co cnr wcel cA cnr wcel vx
      cv cnr wcel wa cA vx cv cmr co c1r wceq cA vx cv cmr co cnr wcel c1r cnr
      wcel 1r cA vx cv cmr co c1r cnr eleq1 mpbiri cA vx cv cnr cmr vx visset
      dmmulsr 0nsr ndmoprrcl syl pm3.27d ancri 19.22i syl $.
      $( [15-May-1996] $)
  $}

  ${
    addgt0sr.1 $e |- A e. _V $.
    addgt0sr.2 $e |- B e. _V $.
    $( The sum of two positive signed reals is positive. $)
    addgt0sr $p |- ( ( 0R <R A /\ 0R <R B ) -> 0R <R ( A +R B ) ) $=
      c0r cA cltr wbr c0r cB cltr wbr cA cA cB cplr co cltr wbr c0r cA cB cplr
      co cltr wbr c0r cA cltr wbr c0r cB cltr wbr cA cA cB cplr co cltr wbr c0r
      cA cltr wbr cA cnr wcel c0r cB cltr wbr cA cA cB cplr co cltr wbr wb c0r
      cA cltr wbr c0r cnr wcel cA cnr wcel c0r cA cnr cnr cltr addgt0sr.1
      ltrelsr brel pm3.27d cA cnr wcel c0r cB cltr wbr cA c0r cplr co cA cB
      cplr co cltr wbr cA cA cB cplr co cltr wbr c0r cB cA c0r cnr 0r elisseti
      addgt0sr.2 ltasr cA cnr wcel cA c0r cplr co cA cA cB cplr co cltr cA
      0idsr breq1d bitrd syl biimpa c0r cA cA cB cplr co cltr cnr c0r cnr 0r
      elisseti ltsosr ltrelsr addgt0sr.1 cA cB cplr oprex sotri syldan $.
      $( [14-May-1996] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w v u f g h $.
    mulgt0sr.1 $e |- A e. _V $.
    mulgt0sr.2 $e |- B e. _V $.
    $( The product of two positive signed reals is positive. $)
    mulgt0sr $p |- ( ( 0R <R A /\ 0R <R B ) -> 0R <R ( A .R B ) ) $=
      cA cnr wcel cB cnr wcel wa c0r cA cltr wbr c0r cB cltr wbr wa c0r cA cB
      cmr co cltr wbr c0r cA cltr wbr cA cnr wcel c0r cB cltr wbr cB cnr wcel
      c0r cA cltr wbr c0r cnr wcel cA cnr wcel c0r cA cnr cnr cltr mulgt0sr.1
      ltrelsr brel pm3.27d c0r cB cltr wbr c0r cnr wcel cB cnr wcel c0r cB cnr
      cnr cltr mulgt0sr.2 ltrelsr brel pm3.27d anim12i c0r vx cv vy cv cop cer
      cec cltr wbr c0r vz cv vw cv cop cer cec cltr wbr wa c0r vx cv vy cv cop
      cer cec vz cv vw cv cop cer cec cmr co cltr wbr wi c0r cA cltr wbr c0r vz
      cv vw cv cop cer cec cltr wbr wa c0r cA vz cv vw cv cop cer cec cmr co
      cltr wbr wi c0r cA cltr wbr c0r cB cltr wbr wa c0r cA cB cmr co cltr wbr
      wi vx vy vz vw cA cB cnp cnp cer cnr df-nr vx cv vy cv cop cer cec cA
      wceq c0r vx cv vy cv cop cer cec cltr wbr c0r vz cv vw cv cop cer cec
      cltr wbr wa c0r cA cltr wbr c0r vz cv vw cv cop cer cec cltr wbr wa c0r
      vx cv vy cv cop cer cec vz cv vw cv cop cer cec cmr co cltr wbr c0r cA vz
      cv vw cv cop cer cec cmr co cltr wbr vx cv vy cv cop cer cec cA wceq c0r
      vx cv vy cv cop cer cec cltr wbr c0r cA cltr wbr c0r vz cv vw cv cop cer
      cec cltr wbr vx cv vy cv cop cer cec cA c0r cltr breq2 anbi1d vx cv vy cv
      cop cer cec cA wceq vx cv vy cv cop cer cec vz cv vw cv cop cer cec cmr
      co cA vz cv vw cv cop cer cec cmr co c0r cltr vx cv vy cv cop cer cec cA
      vz cv vw cv cop cer cec cmr opreq1 breq2d imbi12d vz cv vw cv cop cer cec
      cB wceq c0r cA cltr wbr c0r vz cv vw cv cop cer cec cltr wbr wa c0r cA
      cltr wbr c0r cB cltr wbr wa c0r cA vz cv vw cv cop cer cec cmr co cltr
      wbr c0r cA cB cmr co cltr wbr vz cv vw cv cop cer cec cB wceq c0r vz cv
      vw cv cop cer cec cltr wbr c0r cB cltr wbr c0r cA cltr wbr vz cv vw cv
      cop cer cec cB c0r cltr breq2 anbi2d vz cv vw cv cop cer cec cB wceq cA
      vz cv vw cv cop cer cec cmr co cA cB cmr co c0r cltr vz cv vw cv cop cer
      cec cB cA cmr opreq2 breq2d imbi12d vx cv cnp wcel vy cv cnp wcel wa vz
      cv cnp wcel vw cv cnp wcel wa wa vy cv vx cv cltp wbr vw cv vz cv cltp
      wbr wa c0r vx cv vy cv cop cer cec vz cv vw cv cop cer cec cmr co cltr
      wbr c0r vx cv vy cv cop cer cec cltr wbr c0r vz cv vw cv cop cer cec cltr
      wbr wa vx cv cnp wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa
      wa vy cv vx cv cltp wbr vw cv vz cv cltp wbr wa vx cv vw cv cmp co vy cv
      vz cv cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr
      c0r vx cv vy cv cop cer cec vz cv vw cv cop cer cec cmr co cltr wbr vx cv
      vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vw cv cnp wcel vy cv vx
      cv cltp wbr vw cv vz cv cltp wbr wa vx cv vw cv cmp co vy cv vz cv cmp co
      cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr wi vx cv cnp
      wcel vy cv cnp wcel wa vz cv cnp wcel vw cv cnp wcel wa wa vx cv vz cv
      cmp co vy cv vw cv cmp co cpp co cnp wcel vw cv cnp wcel wa vv cv cnp
      wcel vy cv vv cv cpp co vx cv wceq wa vu cv cnp wcel vw cv vu cv cpp co
      vz cv wceq wa wa vu wex vv wex vx cv vw cv cmp co vy cv vz cv cmp co cpp
      co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr vy cv vx cv cltp
      wbr vw cv vz cv cltp wbr wa vx cv vz cv cmp co vy cv vw cv cmp co cpp co
      cnp wcel vw cv cnp wcel wa vv cv cnp wcel vy cv vv cv cpp co vx cv wceq
      wa vu cv cnp wcel vw cv vu cv cpp co vz cv wceq wa wa vx cv vw cv cmp co
      vy cv vz cv cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co
      cltp wbr vv vu vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vw
      cv cnp wcel wa vv cv cnp wcel vu cv cnp wcel wa vy cv vv cv cpp co vx cv
      wceq vw cv vu cv cpp co vz cv wceq wa wa vx cv vw cv cmp co vy cv vz cv
      cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr vv cv
      cnp wcel vy cv vv cv cpp co vx cv wceq wa vu cv cnp wcel vw cv vu cv cpp
      co vz cv wceq wa wa vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel
      vw cv cnp wcel wa vv cv cnp wcel vu cv cnp wcel vy cv vv cv cpp co vx cv
      wceq vw cv vu cv cpp co vz cv wceq wa vx cv vw cv cmp co vy cv vz cv cmp
      co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr vx cv vz
      cv cmp co vy cv vw cv cmp co cpp co cnp wcel vw cv cnp wcel vv cv cnp
      wcel vu cv cnp wcel vy cv vv cv cpp co vx cv wceq vw cv vu cv cpp co vz
      cv wceq wa vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx cv vz cv cmp
      co vy cv vw cv cmp co cpp co cltp wbr wi wi wi vv cv cnp wcel vw cv cnp
      wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vu cv cnp wcel
      vy cv vv cv cpp co vx cv wceq vw cv vu cv cpp co vz cv wceq wa vx cv vw
      cv cmp co vy cv vz cv cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co
      cpp co cltp wbr wi wi vv cv cnp wcel vw cv cnp wcel vx cv vz cv cmp co vy
      cv vw cv cmp co cpp co cnp wcel vu cv cnp wcel vy cv vv cv cpp co vx cv
      wceq vw cv vu cv cpp co vz cv wceq wa vx cv vw cv cmp co vy cv vz cv cmp
      co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr wi wi vv
      cv cnp wcel vw cv cnp wcel wa vx cv vz cv cmp co vy cv vw cv cmp co cpp
      co cnp wcel wa vy cv vv cv cpp co vx cv wceq vw cv vu cv cpp co vz cv
      wceq wa vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx cv vz cv cmp co
      vy cv vw cv cmp co cpp co cltp wbr wi vu cv cnp wcel vv cv vw cv cmp co
      cnp wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vy cv vv
      cv cpp co vx cv wceq vw cv vu cv cpp co vz cv wceq wa vx cv vw cv cmp co
      vy cv vz cv cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co
      cltp wbr wi vv cv cnp wcel vw cv cnp wcel wa vv cv vw cv cmp co cnp wcel
      vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel wa vy cv vv cv cpp
      co vx cv wceq vw cv vu cv cpp co vz cv wceq wa vx cv vz cv cmp co vy cv
      vw cv cmp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vv cv vu
      cv cmp co cpp co wceq vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx cv
      vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr vv cv vw cv cmp co cnp
      wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel wa vv cv vw cv
      cmp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cpp co vv cv vw cv
      cmp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vv cv vu cv cmp co
      cpp co cpp co wceq vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw
      cv cmp co vy cv vz cv cmp co cpp co vv cv vu cv cmp co cpp co wceq vy cv
      vv cv cpp co vx cv wceq vw cv vu cv cpp co vz cv wceq wa vv cv vw cv cmp
      co vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp co vy cv
      vz cv cmp co cpp co vv cv vu cv cmp co cpp co vx cv vz cv cmp co vy cv vw
      cv cmp co cpp oprex vx cv vw cv cmp co vy cv vz cv cmp co cpp co vv cv vu
      cv cmp co cpp oprex addcanpr vy cv vv cv cpp co vx cv wceq vw cv vu cv
      cpp co vz cv wceq wa vx cv vz cv cmp co vy cv vw cv cmp co vv cv vw cv
      cmp co cpp co cpp co vv cv vw cv cmp co vy cv vz cv cmp co vv cv vu cv
      cmp co cpp co cpp co vx cv vw cv cmp co cpp co vv cv vw cv cmp co vx cv
      vz cv cmp co vy cv vw cv cmp co cpp co cpp co vv cv vw cv cmp co vx cv vw
      cv cmp co vy cv vz cv cmp co cpp co vv cv vu cv cmp co cpp co cpp co vy
      cv vv cv cpp co vx cv wceq vw cv vu cv cpp co vz cv wceq wa vy cv vv cv
      cpp co vw cv vu cv cpp co cmp co vy cv vw cv cmp co vv cv vw cv cmp co
      cpp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co vv cv vw cv cmp co
      cpp co cpp co vv cv vw cv cmp co vy cv vz cv cmp co vv cv vu cv cmp co
      cpp co cpp co vx cv vw cv cmp co cpp co vy cv vv cv cpp co vx cv wceq vw
      cv vu cv cpp co vz cv wceq wa vy cv vv cv cpp co vw cv vu cv cpp co cmp
      co vx cv vz cv cmp co vy cv vw cv cmp co vv cv vw cv cmp co cpp co cpp vy
      cv vv cv cpp co vx cv vw cv vu cv cpp co vz cv cmp opreq12 opreq1d vw cv
      vu cv cpp co vz cv wceq vy cv vv cv cpp co vx cv wceq vy cv vv cv cpp co
      vw cv vu cv cpp co cmp co vv cv vw cv cmp co vy cv vz cv cmp co vv cv vu
      cv cmp co cpp co cpp co vy cv vw cv cmp co vv cv vw cv cmp co cpp co vx
      cv vw cv cmp co cpp vw cv vu cv cpp co vz cv wceq vy cv vw cv cmp co vy
      cv vu cv cmp co cpp co vv cv vw cv cmp co vv cv vu cv cmp co cpp co cpp
      co vy cv vz cv cmp co vv cv vw cv cmp co vv cv vu cv cmp co cpp co cpp co
      vy cv vv cv cpp co vw cv vu cv cpp co cmp co vv cv vw cv cmp co vy cv vz
      cv cmp co vv cv vu cv cmp co cpp co cpp co vw cv vu cv cpp co vz cv wceq
      vy cv vw cv cmp co vy cv vu cv cmp co cpp co vy cv vz cv cmp co vv cv vw
      cv cmp co vv cv vu cv cmp co cpp co cpp vw cv vu cv cpp co vz cv wceq vy
      cv vw cv vu cv cpp co cmp co vy cv vz cv cmp co vy cv vw cv cmp co vy cv
      vu cv cmp co cpp co vw cv vu cv cpp co vz cv vy cv cmp opreq2 vy cv vw cv
      vu cv vw visset vu visset distrpr syl5eqr opreq1d vy cv vv cv cpp co vw
      cv cmp co vy cv vv cv cpp co vu cv cmp co cpp co vy cv vw cv cmp co vv cv
      vw cv cmp co cpp co vy cv vu cv cmp co vv cv vu cv cmp co cpp co cpp co
      vy cv vv cv cpp co vw cv vu cv cpp co cmp co vy cv vw cv cmp co vy cv vu
      cv cmp co cpp co vv cv vw cv cmp co vv cv vu cv cmp co cpp co cpp co vy
      cv vv cv cpp co vw cv cmp co vy cv vw cv cmp co vv cv vw cv cmp co cpp co
      vy cv vv cv cpp co vu cv cmp co vy cv vu cv cmp co vv cv vu cv cmp co cpp
      co cpp vf vg vh vy cv vv cv vw cv cpp cmp vy visset vv visset vw visset
      vf cv vg cv vf visset vg visset mulcompr vf cv vg cv vh cv vg visset vh
      visset distrpr caoprdistrr vf vg vh vy cv vv cv vu cv cpp cmp vy visset
      vv visset vu visset vf cv vg cv vf visset vg visset mulcompr vf cv vg cv
      vh cv vg visset vh visset distrpr caoprdistrr opreq12i vy cv vv cv cpp co
      vw cv vu cv vw visset vu visset distrpr vf vg vh vy cv vw cv cmp co vy cv
      vu cv cmp co vv cv vw cv cmp co vv cv vu cv cmp co cpp vy cv vw cv cmp
      oprex vy cv vu cv cmp oprex vv cv vw cv cmp oprex vf cv vg cv vf visset
      vg visset addcompr vf cv vg cv vh cv vg visset vh visset addasspr vv cv
      vu cv cmp oprex caopr4 3eqtr4i vf vg vh vv cv vw cv cmp co vy cv vz cv
      cmp co vv cv vu cv cmp co cpp vv cv vw cv cmp oprex vy cv vz cv cmp oprex
      vv cv vu cv cmp oprex vf cv vg cv vf visset vg visset addcompr vf cv vg
      cv vh cv vg visset vh visset addasspr caopr12 3eqtr4g vy cv vv cv cpp co
      vx cv wceq vy cv vv cv cpp co vw cv cmp co vx cv vw cv cmp co vy cv vw cv
      cmp co vv cv vw cv cmp co cpp co vy cv vv cv cpp co vx cv vw cv cmp
      opreq1 vf vg vh vy cv vv cv vw cv cpp cmp vy visset vv visset vw visset
      vf cv vg cv vf visset vg visset mulcompr vf cv vg cv vh cv vg visset vh
      visset distrpr caoprdistrr syl5eqr opreqan12rd eqtr3d vx cv vz cv cmp co
      vy cv vw cv cmp co cpp co vv cv vw cv cmp co cpp co vx cv vz cv cmp co vy
      cv vw cv cmp co vv cv vw cv cmp co cpp co cpp co vv cv vw cv cmp co vx cv
      vz cv cmp co vy cv vw cv cmp co cpp co cpp co vx cv vz cv cmp co vy cv vw
      cv cmp co vv cv vw cv cmp co vy cv vw cv cmp oprex vv cv vw cv cmp oprex
      addasspr vx cv vz cv cmp co vy cv vw cv cmp co cpp co vv cv vw cv cmp co
      vx cv vz cv cmp co vy cv vw cv cmp co cpp oprex vv cv vw cv cmp oprex
      addcompr eqtr3i vv cv vw cv cmp co vx cv vw cv cmp co cpp co vy cv vz cv
      cmp co vv cv vu cv cmp co cpp co cpp co vv cv vw cv cmp co vx cv vw cv
      cmp co vy cv vz cv cmp co vv cv vu cv cmp co cpp co cpp co cpp co vv cv
      vw cv cmp co vy cv vz cv cmp co vv cv vu cv cmp co cpp co cpp co vx cv vw
      cv cmp co cpp co vv cv vw cv cmp co vx cv vw cv cmp co vy cv vz cv cmp co
      cpp co vv cv vu cv cmp co cpp co cpp co vv cv vw cv cmp co vx cv vw cv
      cmp co vy cv vz cv cmp co vv cv vu cv cmp co cpp co vx cv vw cv cmp oprex
      vy cv vz cv cmp co vv cv vu cv cmp co cpp oprex addasspr vf vg vh vv cv
      vw cv cmp co vy cv vz cv cmp co vv cv vu cv cmp co cpp co vx cv vw cv cmp
      co cpp vv cv vw cv cmp oprex vy cv vz cv cmp co vv cv vu cv cmp co cpp
      oprex vx cv vw cv cmp oprex vf cv vg cv vf visset vg visset addcompr vf
      cv vg cv vh cv vg visset vh visset addasspr caopr32 vx cv vw cv cmp co vy
      cv vz cv cmp co cpp co vv cv vu cv cmp co cpp co vx cv vw cv cmp co vy cv
      vz cv cmp co vv cv vu cv cmp co cpp co cpp co vv cv vw cv cmp co cpp vx
      cv vw cv cmp co vy cv vz cv cmp co vv cv vu cv cmp co vy cv vz cv cmp
      oprex vv cv vu cv cmp oprex addasspr opreq2i 3eqtr4i 3eqtr3g syl5 vx cv
      vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vx cv vz cv cmp co vy cv
      vw cv cmp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vv cv vu
      cv cmp co cpp co wceq vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx cv
      vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr wi vv cv vw cv cmp co cnp
      wcel vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vx cv vw cv
      cmp co vy cv vz cv cmp co cpp co vv cv vu cv cmp co cpp co vx cv vz cv
      cmp co vy cv vw cv cmp co cpp co wceq vx cv vw cv cmp co vy cv vz cv cmp
      co cpp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co cltp wbr vx cv vz
      cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp co vy cv vz cv cmp co
      cpp co vv cv vu cv cmp co cpp co wceq vx cv vw cv cmp co vy cv vz cv cmp
      co cpp co vv cv vu cv cmp co vx cv vz cv cmp co vy cv vw cv cmp co cpp co
      vv cv vu cv cmp oprex ltaddpr2 vx cv vz cv cmp co vy cv vw cv cmp co cpp
      co vx cv vw cv cmp co vy cv vz cv cmp co cpp co vv cv vu cv cmp co cpp co
      eqcom syl5ib adantl syld vv cv vw cv mulclpr sylan a1d exp31 com13 imp
      imp4c vv cv cnp wcel vy cv vv cv cpp co vx cv wceq vu cv cnp wcel vw cv
      vu cv cpp co vz cv wceq an4 syl5ib 19.23advv vy cv vx cv cltp wbr vw cv
      vz cv cltp wbr wa vv cv cnp wcel vy cv vv cv cpp co vx cv wceq wa vv wex
      vu cv cnp wcel vw cv vu cv cpp co vz cv wceq wa vu wex wa vv cv cnp wcel
      vy cv vv cv cpp co vx cv wceq wa vu cv cnp wcel vw cv vu cv cpp co vz cv
      wceq wa wa vu wex vv wex vy cv vx cv cltp wbr vv cv cnp wcel vy cv vv cv
      cpp co vx cv wceq wa vv wex vw cv vz cv cltp wbr vu cv cnp wcel vw cv vu
      cv cpp co vz cv wceq wa vu wex vv vy cv vx cv vx visset ltexpri vu vw cv
      vz cv vz visset ltexpri anim12i vv cv cnp wcel vy cv vv cv cpp co vx cv
      wceq wa vu cv cnp wcel vw cv vu cv cpp co vz cv wceq wa vv vu eeanv
      sylibr syl5 vx cv cnp wcel vz cv cnp wcel vy cv cnp wcel vw cv cnp wcel
      vx cv vz cv cmp co vy cv vw cv cmp co cpp co cnp wcel vx cv vz cv cmp co
      cnp wcel vy cv vw cv cmp co cnp wcel vx cv vz cv cmp co vy cv vw cv cmp
      co cpp co cnp wcel vx cv cnp wcel vz cv cnp wcel wa vy cv cnp wcel vw cv
      cnp wcel wa vx cv vz cv cmp co vy cv vw cv cmp co addclpr vx cv vz cv
      mulclpr vy cv vw cv mulclpr syl2an an4s vx cv cnp wcel vy cv cnp wcel wa
      vz cv cnp wcel vw cv cnp wcel simprr sylanc vx cv cnp wcel vy cv cnp wcel
      wa vz cv cnp wcel vw cv cnp wcel wa wa c0r vx cv vy cv cop cer cec vz cv
      vw cv cop cer cec cmr co cltr wbr c0r vx cv vz cv cmp co vy cv vw cv cmp
      co cpp co vx cv vw cv cmp co vy cv vz cv cmp co cpp co cop cer cec cltr
      wbr vx cv vw cv cmp co vy cv vz cv cmp co cpp co vx cv vz cv cmp co vy cv
      vw cv cmp co cpp co cltp wbr vx cv cnp wcel vy cv cnp wcel wa vz cv cnp
      wcel vw cv cnp wcel wa wa vx cv vy cv cop cer cec vz cv vw cv cop cer cec
      cmr co vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv cmp co vy
      cv vz cv cmp co cpp co cop cer cec c0r cltr vx cv vy cv vz cv vw cv
      mulsrpr breq2d vx cv vz cv cmp co vy cv vw cv cmp co cpp co vx cv vw cv
      cmp co vy cv vz cv cmp co cpp co vx cv vz cv cmp co vy cv vw cv cmp co
      cpp oprex vx cv vw cv cmp co vy cv vz cv cmp co cpp oprex gt0srpr syl6bb
      sylibrd c0r vx cv vy cv cop cer cec cltr wbr vy cv vx cv cltp wbr c0r vz
      cv vw cv cop cer cec cltr wbr vw cv vz cv cltp wbr vx cv vy cv vx visset
      vy visset gt0srpr vz cv vw cv vz visset vw visset gt0srpr anbi12i syl5ib
      2ecoptocl mpcom $.
      $( [13-May-1996] $)
  $}

  ${
    $d x y z A $.
    sqgt0sr.1 $e |- A e. _V $.
    $( The square of a nonzero signed real is positive. $)
    sqgt0sr $p |- ( A e. R. -> ( -. A = 0R -> 0R <R ( A .R A ) ) ) $=
      cA cnr wcel cA c0r wceq wn cA c0r cltr wbr c0r cA cltr wbr wo c0r cA cA
      cmr co cltr wbr cA cnr wcel cA c0r wceq cA c0r cltr wbr c0r cA cltr wbr
      wo cA cnr wcel c0r cnr wcel cA c0r wceq cA c0r cltr wbr c0r cA cltr wbr
      wo wn wb 0r cnr cltr wor cA cnr wcel c0r cnr wcel wa cA c0r wceq cA c0r
      cltr wbr c0r cA cltr wbr wo wn wb ltsosr cnr cA c0r cltr sotrieq mpan
      mpan2 con2bid cA cnr wcel cA c0r cltr wbr c0r cA cA cmr co cltr wbr c0r
      cA cltr wbr cA cnr wcel cA c0r cltr wbr c0r cA cm1r cmr co cA cm1r cmr co
      cmr co cltr wbr c0r cA cA cmr co cltr wbr cA cnr wcel cA c0r cltr wbr c0r
      cA cm1r cmr co cltr wbr c0r cA cm1r cmr co cA cm1r cmr co cmr co cltr wbr
      cA cnr wcel cA c0r cltr wbr cA cm1r cmr co cA cplr co cA cm1r cmr co c0r
      cplr co cltr wbr c0r cA cm1r cmr co cltr wbr cA cnr wcel cA cm1r cmr co
      cnr wcel cA c0r cltr wbr cA cm1r cmr co cA cplr co cA cm1r cmr co c0r
      cplr co cltr wbr wb cA cnr wcel cm1r cnr wcel cA cm1r cmr co cnr wcel m1r
      cA cm1r mulclsr mpan2 cA c0r cA cm1r cmr co sqgt0sr.1 c0r cnr 0r elisseti
      ltasr syl cA cnr wcel cA cm1r cmr co cA cplr co c0r cA cm1r cmr co c0r
      cplr co cA cm1r cmr co cltr cA cnr wcel cA cA cm1r cmr co cplr co c0r cA
      cm1r cmr co cA cplr co cA pn0sr cA cm1r cmr co cA cA cm1r cmr oprex
      sqgt0sr.1 addcomsr syl5eq cA cnr wcel cA cm1r cmr co cnr wcel cA cm1r cmr
      co c0r cplr co cA cm1r cmr co wceq cA cnr wcel cm1r cnr wcel cA cm1r cmr
      co cnr wcel m1r cA cm1r mulclsr mpan2 cA cm1r cmr co 0idsr syl breq12d
      bitrd c0r cA cm1r cmr co cltr wbr c0r cA cm1r cmr co cA cm1r cmr co cmr
      co cltr wbr cA cm1r cmr co cA cm1r cmr co cA cm1r cmr oprex cA cm1r cmr
      oprex mulgt0sr anidms syl6bi cA cnr wcel cA cm1r cmr co cA cm1r cmr co
      cmr co cA cA cmr co c0r cltr cA cnr wcel cA cA cmr co c1r cmr co cA cA
      cmr co cA cm1r cmr co cA cm1r cmr co cmr co cA cnr wcel cA cA cmr co c1r
      cmr co cA cA cmr co wceq cA cnr wcel cA cnr wcel wa cA cA cmr co cnr wcel
      cA cA cmr co c1r cmr co cA cA cmr co wceq cA cA mulclsr cA cA cmr co
      1idsr syl anidms cA cm1r cmr co cA cm1r cmr co cmr co cA cA cmr co cm1r
      cm1r cmr co cmr co cA cA cmr co c1r cmr co vx vy vz cA cm1r cA cm1r cmr
      sqgt0sr.1 cm1r cnr m1r elisseti sqgt0sr.1 vx cv vy cv vx visset vy visset
      mulcomsr vx cv vy cv vz cv vy visset vz visset mulasssr cm1r cnr m1r
      elisseti caopr4 cm1r cm1r cmr co c1r cA cA cmr co cmr m1m1sr opreq2i
      eqtri syl5eq breq2d sylibd c0r cA cltr wbr c0r cA cA cmr co cltr wbr wi
      cA cnr wcel c0r cA cltr wbr c0r cA cA cmr co cltr wbr cA cA sqgt0sr.1
      sqgt0sr.1 mulgt0sr anidms a1i jaod sylbird $.
      $( [14-May-1996] $)
  $}

  ${
    $d x y A $.
    recexsr.1 $e |- A e. _V $.
    $( The reciprocal of a nonzero signed real exists.  Part of Proposition
       9-4.3 of [Gleason] p. 126. $)
    recexsr $p |- ( A e. R. -> ( -. A = 0R ->
                  E. x ( x e. R. /\ ( A .R x ) = 1R ) ) ) $=
      cA cnr wcel cA c0r wceq wn c0r cA cA cmr co cltr wbr vx cv cnr wcel cA vx
      cv cmr co c1r wceq wa vx wex cA recexsr.1 sqgt0sr cA cnr wcel vy cv cnr
      wcel cA cA cmr co vy cv cmr co c1r wceq wa vy wex vx cv cnr wcel cA vx cv
      cmr co c1r wceq wa vx wex c0r cA cA cmr co cltr wbr cA cnr wcel vy cv cnr
      wcel cA cA cmr co vy cv cmr co c1r wceq wa vx cv cnr wcel cA vx cv cmr co
      c1r wceq wa vx wex vy cA cnr wcel vy cv cnr wcel cA cA cmr co vy cv cmr
      co c1r wceq vx cv cnr wcel cA vx cv cmr co c1r wceq wa vx wex cA cnr wcel
      vy cv cnr wcel cA cA cmr co vy cv cmr co c1r wceq vx cv cnr wcel cA vx cv
      cmr co c1r wceq wa vx wex cA vy cv cmr co cnr wcel cA cA cmr co vy cv cmr
      co c1r wceq vx cv cnr wcel cA vx cv cmr co c1r wceq wa vx wex cA cnr wcel
      vy cv cnr wcel wa cA vy cv cmr co cnr wcel cA cA vy cv cmr co cmr co c1r
      wceq vx cv cnr wcel cA vx cv cmr co c1r wceq wa vx wex cA cA cmr co vy cv
      cmr co c1r wceq vx cv cnr wcel cA vx cv cmr co c1r wceq wa cA vy cv cmr
      co cnr wcel cA cA vy cv cmr co cmr co c1r wceq wa vx cA vy cv cmr co cA
      vy cv cmr oprex vx cv cA vy cv cmr co wceq vx cv cnr wcel cA vy cv cmr co
      cnr wcel cA vx cv cmr co c1r wceq cA cA vy cv cmr co cmr co c1r wceq vx
      cv cA vy cv cmr co cnr eleq1 vx cv cA vy cv cmr co wceq cA vx cv cmr co
      cA cA vy cv cmr co cmr co c1r vx cv cA vy cv cmr co cA cmr opreq2 eqeq1d
      anbi12d cla4ev cA cA cmr co vy cv cmr co cA cA vy cv cmr co cmr co c1r cA
      cA vy cv recexsr.1 vy visset mulasssr eqeq1i sylan2b cA vy cv mulclsr
      sylan exp31 imp3a 19.23adv vy cA cA cmr co cA cA cmr oprex recexsrlem
      syl5 syld $.
      $( [15-May-1996] $)
  $}

  ${
    ssgt0sr.1 $e |- A e. _V $.
    ssgt0sr.2 $e |- B e. _V $.
    $( The sum of squares of signed reals is positive if one is nonzero. $)
    ssgt0sr $p |- ( ( A e. R. /\ B e. R. ) -> ( -. ( A = 0R /\ B = 0R )
             -> 0R <R ( ( A .R A ) +R ( B .R B ) ) ) ) $=
      cA cnr wcel cB cnr wcel wa cA c0r wceq wn cB c0r wceq wn wo c0r cA cA cmr
      co cB cB cmr co cplr co cltr wbr cA c0r wceq cB c0r wceq wa wn cA cnr
      wcel cB cnr wcel wa cA c0r wceq wn c0r cA cA cmr co cB cB cmr co cplr co
      cltr wbr cB c0r wceq wn cA c0r wceq wn cA cnr wcel cB cnr wcel wa c0r cA
      cA cmr co cB cB cmr co cplr co cltr wbr cA c0r wceq wn cB c0r wceq cA cnr
      wcel cB cnr wcel wa c0r cA cA cmr co cB cB cmr co cplr co cltr wbr wi cA
      c0r wceq wn cB c0r wceq cA cnr wcel cB cnr wcel wa c0r cA cA cmr co cB cB
      cmr co cplr co cltr wbr cA cnr wcel cB cnr wcel wa cA c0r wceq wn cB c0r
      wceq wa c0r cA cA cmr co cB cB cmr co cplr co cltr wbr cA cnr wcel cA c0r
      wceq wn cB c0r wceq wa c0r cA cA cmr co cB cB cmr co cplr co cltr wbr cB
      cnr wcel cA cnr wcel cA c0r wceq wn cB c0r wceq wa wa c0r cA cA cmr co cB
      cB cmr co cplr co cltr wbr c0r cA cA cmr co cltr wbr cA cnr wcel cA c0r
      wceq wn c0r cA cA cmr co cltr wbr cB c0r wceq cA cnr wcel cA c0r wceq wn
      c0r cA cA cmr co cltr wbr cA ssgt0sr.1 sqgt0sr imp adantrr cA cnr wcel cB
      c0r wceq c0r cA cA cmr co cB cB cmr co cplr co cltr wbr c0r cA cA cmr co
      cltr wbr wb cA c0r wceq wn cA cnr wcel cB c0r wceq wa cA cA cmr co cB cB
      cmr co cplr co cA cA cmr co c0r cltr cB c0r wceq cA cnr wcel cA cA cmr co
      cB cB cmr co cplr co cA cA cmr co c0r cplr co cA cA cmr co cB c0r wceq cB
      cB cmr co c0r cA cA cmr co cplr cB c0r wceq cB cB cmr co c0r c0r cmr co
      c0r cB c0r wceq cB cB cmr co c0r c0r cmr co wceq cB c0r cB c0r cmr
      opreq12 anidms c0r cnr wcel c0r c0r cmr co c0r wceq 0r c0r 00sr ax-mp
      syl6eq opreq2d cA cnr wcel cA cA cmr co cnr wcel cA cA cmr co c0r cplr co
      cA cA cmr co wceq cA cnr wcel cA cA cmr co cnr wcel cA cA mulclsr anidms
      cA cA cmr co 0idsr syl sylan9eqr breq2d adantrl mpbird adantlr ancoms
      exp31 cA cnr wcel cB cnr wcel wa cA c0r wceq wn cB c0r wceq wn c0r cA cA
      cmr co cB cB cmr co cplr co cltr wbr cA cnr wcel cB cnr wcel wa cA c0r
      wceq wn cB c0r wceq wn c0r cA cA cmr co cB cB cmr co cplr co cltr wbr cA
      cnr wcel cB cnr wcel wa cA c0r wceq wn cB c0r wceq wn wa c0r cA cA cmr co
      cltr wbr c0r cB cB cmr co cltr wbr wa c0r cA cA cmr co cB cB cmr co cplr
      co cltr wbr cA cnr wcel cA c0r wceq wn c0r cA cA cmr co cltr wbr cB cnr
      wcel cB c0r wceq wn c0r cB cB cmr co cltr wbr cA ssgt0sr.1 sqgt0sr cB
      ssgt0sr.2 sqgt0sr im2anan9 cA cA cmr co cB cB cmr co cA cA cmr oprex cB
      cB cmr oprex addgt0sr syl6 exp3a com3l pm2.61d com12 cA cnr wcel cB cnr
      wcel wa cA c0r wceq cB c0r wceq wn c0r cA cA cmr co cB cB cmr co cplr co
      cltr wbr wi cA cnr wcel cB cnr wcel wa cA c0r wceq cB c0r wceq wn c0r cA
      cA cmr co cB cB cmr co cplr co cltr wbr cB cnr wcel cA c0r wceq cB c0r
      wceq wn wa c0r cA cA cmr co cB cB cmr co cplr co cltr wbr cA cnr wcel cB
      cnr wcel cA c0r wceq cB c0r wceq wn wa wa c0r cA cA cmr co cB cB cmr co
      cplr co cltr wbr c0r cB cB cmr co cltr wbr cB cnr wcel cB c0r wceq wn c0r
      cB cB cmr co cltr wbr cA c0r wceq cB cnr wcel cB c0r wceq wn c0r cB cB
      cmr co cltr wbr cB ssgt0sr.2 sqgt0sr imp adantrl cB cnr wcel cA c0r wceq
      c0r cA cA cmr co cB cB cmr co cplr co cltr wbr c0r cB cB cmr co cltr wbr
      wb cB c0r wceq wn cB cnr wcel cA c0r wceq wa cA cA cmr co cB cB cmr co
      cplr co cB cB cmr co c0r cltr cA c0r wceq cB cnr wcel cA cA cmr co cB cB
      cmr co cplr co c0r cB cB cmr co cplr co cB cB cmr co cA c0r wceq cA cA
      cmr co c0r cB cB cmr co cplr cA c0r wceq cA cA cmr co c0r c0r cmr co c0r
      cA c0r wceq cA cA cmr co c0r c0r cmr co wceq cA c0r cA c0r cmr opreq12
      anidms c0r cnr wcel c0r c0r cmr co c0r wceq 0r c0r 00sr ax-mp syl6eq
      opreq1d cB cnr wcel cB cB cmr co cnr wcel c0r cB cB cmr co cplr co cB cB
      cmr co wceq cB cnr wcel cB cB cmr co cnr wcel cB cB mulclsr anidms cB cB
      cmr co cnr wcel cB cB cmr co c0r cplr co cB cB cmr co c0r cB cB cmr co
      cplr co cB cB cmr co 0idsr c0r cB cB cmr co c0r cnr 0r elisseti cB cB cmr
      oprex addcomsr syl5eq syl sylan9eqr breq2d adantrr mpbird adantll exp32
      cA cnr wcel cB cnr wcel wa cA c0r wceq wn cB c0r wceq wn c0r cA cA cmr co
      cB cB cmr co cplr co cltr wbr cA cnr wcel cB cnr wcel wa cA c0r wceq wn
      cB c0r wceq wn wa c0r cA cA cmr co cltr wbr c0r cB cB cmr co cltr wbr wa
      c0r cA cA cmr co cB cB cmr co cplr co cltr wbr cA cnr wcel cA c0r wceq wn
      c0r cA cA cmr co cltr wbr cB cnr wcel cB c0r wceq wn c0r cB cB cmr co
      cltr wbr cA ssgt0sr.1 sqgt0sr cB ssgt0sr.2 sqgt0sr im2anan9 cA cA cmr co
      cB cB cmr co cA cA cmr oprex cB cB cmr oprex addgt0sr syl6 exp3a pm2.61d
      jaod cA c0r wceq cB c0r wceq ianor syl5ib $.
      $( [14-May-1996] $)
  $}

  ${
    mappsrpr.1 $e |- A e. _V $.
    $( Mapping from positive signed reals to positive reals. $)
    mappsrpr $p |- ( 0R <R [ <. ( A +P. 1P ) , 1P >. ] ~R <->
                     A e. P. ) $=
      c0r cA c1p cpp co c1p cop cer cec cltr wbr c1p c1p cop cer cec cA c1p cpp
      co c1p cop cer cec cltr wbr c1p c1p cpp co c1p cA c1p cpp co cpp co cltp
      wbr cA cnp wcel c0r c1p c1p cop cer cec cA c1p cpp co c1p cop cer cec
      cltr df-0r breq1i c1p c1p cA c1p cpp co c1p c1p cnp 1pr elisseti c1p cnp
      1pr elisseti cA c1p cpp oprex c1p cnp 1pr elisseti ltsrpr c1p c1p cpp co
      c1p cA c1p cpp co cpp co cltp wbr c1p c1p cpp co c1p c1p cpp co cA cpp co
      cltp wbr cA cnp wcel c1p cA c1p cpp co cpp co c1p c1p cpp co cA cpp co
      c1p c1p cpp co cltp c1p cA c1p cpp co cpp co c1p c1p cA cpp co cpp co c1p
      c1p cpp co cA cpp co cA c1p cpp co c1p cA cpp co c1p cpp cA c1p
      mappsrpr.1 c1p cnp 1pr elisseti addcompr opreq2i c1p c1p cA c1p cnp 1pr
      elisseti mappsrpr.1 addasspr eqtr4i breq2i c1p c1p cpp co c1p c1p cpp co
      cA cpp co cltp wbr cA cnp wcel c1p c1p cpp co c1p c1p cpp co cA cpp co
      cltp wbr c1p c1p cpp co cA cpp co cnp wcel cA cnp wcel c1p c1p cpp co c1p
      c1p cpp co cA cpp co cltp wbr c1p c1p cpp co cnp wcel c1p c1p cpp co cA
      cpp co cnp wcel c1p c1p cpp co c1p c1p cpp co cA cpp co cnp cnp cltp c1p
      c1p cpp co cA cpp oprex ltrelpr brel pm3.27d c1p c1p cpp co cA cpp co cnp
      wcel c1p c1p cpp co cnp wcel cA cnp wcel c1p c1p cpp co cA cnp cpp
      mappsrpr.1 dmplp 0npr ndmoprrcl pm3.27d syl c1p c1p cpp co cnp wcel cA
      cnp wcel c1p c1p cpp co c1p c1p cpp co cA cpp co cltp wbr c1p cnp wcel
      c1p cnp wcel c1p c1p cpp co cnp wcel 1pr 1pr c1p c1p addclpr mp2an c1p
      c1p cpp co cA ltaddpr mpan impbii bitri 3bitri $.
      $( [17-May-1996] $)
  $}

  ${
    ltpsrpr.1 $e |- A e. _V $.
    ltpsrpr.2 $e |- B e. _V $.
    $( Mapping of order from positive signed reals to positive reals. $)
    ltpsrpr $p |- ( [ <. ( A +P. 1P ) , 1P >. ] ~R <R
           [ <. ( B +P. 1P ) , 1P >. ] ~R <-> A <P B ) $=
      cA c1p cpp co cB c1p cpp co cltp wbr c1p cA cpp co c1p cB cpp co cltp wbr
      cA c1p cpp co c1p cop cer cec cB c1p cpp co c1p cop cer cec cltr wbr cA
      cB cltp wbr cA c1p cpp co c1p cA cpp co cB c1p cpp co c1p cB cpp co cltp
      cA c1p ltpsrpr.1 c1p cnp 1pr elisseti addcompr cB c1p ltpsrpr.2 c1p cnp
      1pr elisseti addcompr breq12i cA c1p cpp co c1p cpp co c1p cB c1p cpp co
      cpp co cltp wbr c1p cA c1p cpp co cpp co c1p cB c1p cpp co cpp co cltp
      wbr cA c1p cpp co c1p cop cer cec cB c1p cpp co c1p cop cer cec cltr wbr
      cA c1p cpp co cB c1p cpp co cltp wbr cA c1p cpp co c1p cpp co c1p cA c1p
      cpp co cpp co c1p cB c1p cpp co cpp co cltp cA c1p cpp co c1p cA c1p cpp
      oprex c1p cnp 1pr elisseti addcompr breq1i cA c1p cpp co c1p cB c1p cpp
      co c1p cA c1p cpp oprex c1p cnp 1pr elisseti cB c1p cpp oprex c1p cnp 1pr
      elisseti ltsrpr c1p cnp wcel cA c1p cpp co cB c1p cpp co cltp wbr c1p cA
      c1p cpp co cpp co c1p cB c1p cpp co cpp co cltp wbr wb 1pr cA c1p cpp co
      cB c1p cpp co c1p cA c1p cpp oprex cB c1p cpp oprex ltapr ax-mp 3bitr4i
      c1p cnp wcel cA cB cltp wbr c1p cA cpp co c1p cB cpp co cltp wbr wb 1pr
      cA cB c1p ltpsrpr.1 ltpsrpr.2 ltapr ax-mp 3bitr4i $.
      $( [17-May-1996] $)
  $}

  ${
    $d x y z A $.
    map2psrpr.1 $e |- A e. _V $.
    $( Equivalence for positive signed real. $)
    map2psrpr $p |- ( 0R <R A <->
            E. x ( x e. P. /\ [ <. ( x +P. 1P ) , 1P >. ] ~R = A ) ) $=
      c0r cA cltr wbr vx cv cnp wcel vx cv c1p cpp co c1p cop cer cec cA wceq
      wa vx wex cA cnr wcel c0r cA cltr wbr vx cv cnp wcel vx cv c1p cpp co c1p
      cop cer cec cA wceq wa vx wex c0r cA cltr wbr c0r cnr wcel cA cnr wcel
      c0r cA cnr cnr cltr map2psrpr.1 ltrelsr brel pm3.27d c0r vy cv vz cv cop
      cer cec cltr wbr vx cv cnp wcel vx cv c1p cpp co c1p cop cer cec vy cv vz
      cv cop cer cec wceq wa vx wex wi c0r cA cltr wbr vx cv cnp wcel vx cv c1p
      cpp co c1p cop cer cec cA wceq wa vx wex wi vy vz cA cnp cnp cer cnr
      df-nr vy cv vz cv cop cer cec cA wceq c0r vy cv vz cv cop cer cec cltr
      wbr c0r cA cltr wbr vx cv cnp wcel vx cv c1p cpp co c1p cop cer cec vy cv
      vz cv cop cer cec wceq wa vx wex vx cv cnp wcel vx cv c1p cpp co c1p cop
      cer cec cA wceq wa vx wex vy cv vz cv cop cer cec cA c0r cltr breq2 vy cv
      vz cv cop cer cec cA wceq vx cv cnp wcel vx cv c1p cpp co c1p cop cer cec
      vy cv vz cv cop cer cec wceq wa vx cv cnp wcel vx cv c1p cpp co c1p cop
      cer cec cA wceq wa vx vy cv vz cv cop cer cec cA wceq vx cv c1p cpp co
      c1p cop cer cec vy cv vz cv cop cer cec wceq vx cv c1p cpp co c1p cop cer
      cec cA wceq vx cv cnp wcel vy cv vz cv cop cer cec cA vx cv c1p cpp co
      c1p cop cer cec eqeq2 anbi2d exbidv imbi12d vy cv cnp wcel vz cv cnp wcel
      wa vx cv cnp wcel vx cv c1p cpp co c1p cop cer cec vy cv vz cv cop cer
      cec wceq wa vx wex vx cv cnp wcel c1p vz cv cpp co vx cv cpp co c1p vy cv
      cpp co wceq wa vx wex c0r vy cv vz cv cop cer cec cltr wbr vy cv cnp wcel
      vz cv cnp wcel wa vx cv cnp wcel vx cv c1p cpp co c1p cop cer cec vy cv
      vz cv cop cer cec wceq wa vx cv cnp wcel c1p vz cv cpp co vx cv cpp co
      c1p vy cv cpp co wceq wa vx vy cv cnp wcel vz cv cnp wcel wa vx cv cnp
      wcel vx cv c1p cpp co c1p cop cer cec vy cv vz cv cop cer cec wceq c1p vz
      cv cpp co vx cv cpp co c1p vy cv cpp co wceq vx cv cnp wcel vy cv cnp
      wcel vz cv cnp wcel wa vx cv c1p cpp co c1p cop cer cec vy cv vz cv cop
      cer cec wceq c1p vz cv cpp co vx cv cpp co c1p vy cv cpp co wceq wb vx cv
      cnp wcel vy cv cnp wcel vz cv cnp wcel wa wa vx cv c1p cpp co c1p cop cer
      cec vy cv vz cv cop cer cec wceq vx cv c1p cpp co vz cv cpp co c1p vy cv
      cpp co wceq c1p vz cv cpp co vx cv cpp co c1p vy cv cpp co wceq vx cv c1p
      cpp co cnp wcel c1p cnp wcel wa vy cv cnp wcel vz cv cnp wcel wa vx cv
      c1p cpp co c1p cop cer cec vy cv vz cv cop cer cec wceq vx cv c1p cpp co
      vz cv cpp co c1p vy cv cpp co wceq wb vx cv cnp wcel vx cv c1p cpp co c1p
      vy cv vz cv enreceq vx cv cnp wcel vx cv c1p cpp co cnp wcel c1p cnp wcel
      vx cv cnp wcel c1p cnp wcel vx cv c1p cpp co cnp wcel 1pr vx cv c1p
      addclpr mpan2 1pr jctir sylan vx cv c1p cpp co vz cv cpp co c1p vz cv cpp
      co vx cv cpp co c1p vy cv cpp co vx cv c1p cpp co vz cv cpp co vx cv c1p
      vz cv cpp co cpp co c1p vz cv cpp co vx cv cpp co vx cv c1p vz cv c1p cnp
      1pr elisseti vz visset addasspr vx cv c1p vz cv cpp co vx visset c1p vz
      cv cpp oprex addcompr eqtri eqeq1i syl6bb expcom pm5.32d exbidv c0r vy cv
      vz cv cop cer cec cltr wbr c1p vz cv cpp co c1p vy cv cpp co cltp wbr vx
      cv cnp wcel c1p vz cv cpp co vx cv cpp co c1p vy cv cpp co wceq wa vx wex
      c0r vy cv vz cv cop cer cec cltr wbr c1p c1p cop cer cec vy cv vz cv cop
      cer cec cltr wbr c1p vz cv cpp co c1p vy cv cpp co cltp wbr c0r c1p c1p
      cop cer cec vy cv vz cv cop cer cec cltr df-0r breq1i c1p c1p vy cv vz cv
      c1p cnp 1pr elisseti c1p cnp 1pr elisseti vy visset vz visset ltsrpr
      bitri vx c1p vz cv cpp co c1p vy cv cpp co c1p vy cv cpp oprex ltexpri
      sylbi syl5bir ecoptocl mpcom vx cv cnp wcel vx cv c1p cpp co c1p cop cer
      cec cA wceq wa c0r cA cltr wbr vx vx cv c1p cpp co c1p cop cer cec cA
      wceq vx cv cnp wcel c0r cA cltr wbr vx cv c1p cpp co c1p cop cer cec cA
      wceq c0r vx cv c1p cpp co c1p cop cer cec cltr wbr c0r cA cltr wbr vx cv
      cnp wcel vx cv c1p cpp co c1p cop cer cec cA c0r cltr breq2 vx cv vx
      visset mappsrpr syl5bbr biimpac 19.23aiv impbii $.
      $( [17-May-1996] $)
  $}

  ${
    $d x w v u A $.  $d x y z w v u B $.
    suppsr.1 $e |- B = { w | [ <. ( w +P. 1P ) , 1P >. ] ~R e. A } $.
    $( Mapping of non-empty subset from positive reals to positive signed
       reals. $)
    suppsrlem $p |- ( ( A. x ( x e. A -> 0R <R x ) /\ -. A = (/) ) ->
                    ( B C_ P. /\ -. B = (/) ) ) $=
      vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa cB cnp wss cB
      c0 wceq wn vx cv cA wcel c0r vx cv cltr wbr wi vx wal cB cnp wss cA c0
      wceq wn vx cv cA wcel c0r vx cv cltr wbr wi vx wal vw cB cnp vx cv cA
      wcel c0r vx cv cltr wbr wi vx wal vw cv cB wcel c0r vw cv c1p cpp co c1p
      cop cer cec cltr wbr vw cv cnp wcel vx cv cA wcel c0r vx cv cltr wbr wi
      vx wal vw cv c1p cpp co c1p cop cer cec cA wcel c0r vw cv c1p cpp co c1p
      cop cer cec cltr wbr vw cv cB wcel vx cv cA wcel c0r vx cv cltr wbr wi vw
      cv c1p cpp co c1p cop cer cec cA wcel c0r vw cv c1p cpp co c1p cop cer
      cec cltr wbr wi vx vw cv c1p cpp co c1p cop cer cec cer cvv wcel vw cv
      c1p cpp co c1p cop cer cec cvv wcel enrex vw cv c1p cpp co c1p cop cvv
      cer ecexg ax-mp vx cv vw cv c1p cpp co c1p cop cer cec wceq vx cv cA wcel
      vw cv c1p cpp co c1p cop cer cec cA wcel c0r vx cv cltr wbr c0r vw cv c1p
      cpp co c1p cop cer cec cltr wbr vx cv vw cv c1p cpp co c1p cop cer cec cA
      eleq1 vx cv vw cv c1p cpp co c1p cop cer cec c0r cltr breq2 imbi12d cla4v
      vw cv c1p cpp co c1p cop cer cec cA wcel vw cB suppsr.1 abeq2i syl5ib vw
      cv vw visset mappsrpr syl6ib ssrdv adantr vx cv cA wcel c0r vx cv cltr
      wbr wi vx wal cA c0 wceq wn cB c0 wceq wn vx cv cA wcel c0r vx cv cltr
      wbr wi vx wal vx cv cA wcel vx wex cB c0 wceq wn cA c0 wceq wn vx cv cA
      wcel vx wex vx cv cA wcel c0r vx cv cltr wbr wi vx wal cB c0 wceq wn vx
      cv cA wcel vx cv cA wcel c0r vx cv cltr wbr wi vx wal cB c0 wceq wn wi vx
      vx cv cA wcel c0r vx cv cltr wbr wi vx wal cB c0 wceq wn vx vx cv cA wcel
      c0r vx cv cltr wbr wi vx hba1 cB c0 wceq wn vx ax-17 hbim vx cv cA wcel
      vx cv cA wcel c0r vx cv cltr wbr wi vx wal c0r vx cv cltr wbr cB c0 wceq
      wn vx cv cA wcel c0r vx cv cltr wbr wi vx wal vx cv cA wcel c0r vx cv
      cltr wbr vx cv cA wcel c0r vx cv cltr wbr wi vx ax-4 com12 vx cv cA wcel
      vw cv cnp wcel vw cv c1p cpp co c1p cop cer cec vx cv wceq wa vw wex cB
      c0 wceq wn c0r vx cv cltr wbr vx cv cA wcel vw cv cnp wcel vw cv c1p cpp
      co c1p cop cer cec vx cv wceq wa cB c0 wceq wn vw vx cv cA wcel vw cv c1p
      cpp co c1p cop cer cec vx cv wceq cB c0 wceq wn vw cv cnp wcel vx cv cA
      wcel vw cv c1p cpp co c1p cop cer cec vx cv wceq vw cv cB wcel cB c0 wceq
      wn vw cv c1p cpp co c1p cop cer cec vx cv wceq vw cv cB wcel vx cv cA
      wcel vw cv c1p cpp co c1p cop cer cec vx cv wceq vw cv c1p cpp co c1p cop
      cer cec cA wcel vx cv cA wcel vw cv cB wcel vw cv c1p cpp co c1p cop cer
      cec vx cv cA eleq1 vw cv c1p cpp co c1p cop cer cec cA wcel vw cB
      suppsr.1 abeq2i syl5bb biimprcd cB vw cv n0i syl6 adantld 19.23adv vw vx
      cv vx visset map2psrpr syl5ib syld 19.23ai com12 vx cA neq0 syl5ib imp
      jca $.
      $( [18-May-1996] $)

    $( A non-empty, bounded set of positive signed reals has a supremum. $)
    suppsr $p |- ( ( ( A. x ( x e. A -> 0R <R x ) /\ -. A = (/) ) /\
         E. x ( 0R <R x /\ A. y ( 0R <R y -> ( y e. A -> y <R x ) ) ) ) ->
       E. x ( 0R <R x /\ A. y ( 0R <R y -> ( ( y e. A -> -. x <R y ) /\
           ( y <R x -> E. z ( 0R <R z /\ ( z e. A /\ y <R z ) ) ) ) ) ) ) $=
      cB cnp wss cB c0 wceq wn wa c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv
      cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex c0r vx cv cltr wbr
      c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv
      cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal wa vx wex vx cv cA wcel c0r vx cv cltr wbr wi vx wal
      cA c0 wceq wn wa cB cnp wss cB c0 wceq wn wa vw cv cnp wcel vv cv cnp
      wcel vv cv cB wcel vv cv vw cv cltp wbr wi wi vv wal wa vw wex c0r vx cv
      cltr wbr c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi vy
      cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr
      wa wa vz wex wi wa wi vy wal wa vx wex c0r vx cv cltr wbr c0r vy cv cltr
      wbr vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex cB cnp wss
      cB c0 wceq wn wa vw cv cnp wcel vv cv cnp wcel vv cv cB wcel vv cv vw cv
      cltp wbr wi wi vv wal wa vw wex wa vw cv cnp wcel vv cv cnp wcel vv cv cB
      wcel vw cv vv cv cltp wbr wn wi vv cv vw cv cltp wbr vu cv cnp wcel vu cv
      cB wcel vv cv vu cv cltp wbr wa wa vu wex wi wa wi vv wal wa vw wex c0r
      vx cv cltr wbr c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn
      wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr
      wbr wa wa vz wex wi wa wi vy wal wa vx wex vw vv vu cB supexpr vv cv cnp
      wcel vv cv cB wcel vw cv vv cv cltp wbr wn wi vv cv vw cv cltp wbr vu cv
      cnp wcel vu cv cB wcel vv cv vu cv cltp wbr wa wa vu wex wi wa wi vv wal
      c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv
      cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal vw cv cnp wcel c0r vx cv cltr wbr vw vx vw cv c1p cpp
      co c1p cop cer cec cer cvv wcel vw cv c1p cpp co c1p cop cer cec cvv wcel
      enrex vw cv c1p cpp co c1p cop cvv cer ecexg ax-mp vw cv c1p cpp co c1p
      cop cer cec vx cv wceq c0r vy cv cltr wbr vy cv cA wcel vw cv c1p cpp co
      c1p cop cer cec vy cv cltr wbr wn wi vy cv vw cv c1p cpp co c1p cop cer
      cec cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa
      vz wex wi wa wi vy wal c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr
      wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz
      cv cltr wbr wa wa vz wex wi wa wi vy wal vv cv cnp wcel vv cv cB wcel vw
      cv vv cv cltp wbr wn wi vv cv vw cv cltp wbr vu cv cnp wcel vu cv cB wcel
      vv cv vu cv cltp wbr wa wa vu wex wi wa wi vv wal vw cv c1p cpp co c1p
      cop cer cec vx cv wceq c0r vy cv cltr wbr vy cv cA wcel vw cv c1p cpp co
      c1p cop cer cec vy cv cltr wbr wn wi vy cv vw cv c1p cpp co c1p cop cer
      cec cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa
      vz wex wi wa wi c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn
      wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr
      wbr wa wa vz wex wi wa wi vy vw cv c1p cpp co c1p cop cer cec vx cv wceq
      vy cv cA wcel vw cv c1p cpp co c1p cop cer cec vy cv cltr wbr wn wi vy cv
      vw cv c1p cpp co c1p cop cer cec cltr wbr c0r vz cv cltr wbr vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex wi wa vy cv cA wcel vx cv vy cv
      cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy
      cv vz cv cltr wbr wa wa vz wex wi wa c0r vy cv cltr wbr vw cv c1p cpp co
      c1p cop cer cec vx cv wceq vy cv cA wcel vw cv c1p cpp co c1p cop cer cec
      vy cv cltr wbr wn wi vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vw cv
      c1p cpp co c1p cop cer cec cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy
      cv vz cv cltr wbr wa wa vz wex wi vy cv vx cv cltr wbr c0r vz cv cltr wbr
      vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi vw cv c1p cpp co c1p
      cop cer cec vx cv wceq vw cv c1p cpp co c1p cop cer cec vy cv cltr wbr wn
      vx cv vy cv cltr wbr wn vy cv cA wcel vw cv c1p cpp co c1p cop cer cec vx
      cv wceq vw cv c1p cpp co c1p cop cer cec vy cv cltr wbr vx cv vy cv cltr
      wbr vw cv c1p cpp co c1p cop cer cec vx cv vy cv cltr breq1 notbid imbi2d
      vw cv c1p cpp co c1p cop cer cec vx cv wceq vy cv vw cv c1p cpp co c1p
      cop cer cec cltr wbr vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex vw cv c1p cpp co c1p cop cer cec
      vx cv vy cv cltr breq2 imbi1d anbi12d imbi2d albidv vv cv cB wcel vw cv
      vv cv cltp wbr wn wi vv cv vw cv cltp wbr vu cv cnp wcel vu cv cB wcel vv
      cv vu cv cltp wbr wa wa vu wex wi wa vy cv cA wcel vw cv c1p cpp co c1p
      cop cer cec vy cv cltr wbr wn wi vy cv vw cv c1p cpp co c1p cop cer cec
      cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa vv cv cnp wcel c0r vy cv cltr wbr vv vy vv cv c1p cpp co c1p
      cop cer cec cer cvv wcel vv cv c1p cpp co c1p cop cer cec cvv wcel enrex
      vv cv c1p cpp co c1p cop cvv cer ecexg ax-mp vv cv c1p cpp co c1p cop cer
      cec vy cv wceq vv cv cB wcel vw cv vv cv cltp wbr wn wi vy cv cA wcel vw
      cv c1p cpp co c1p cop cer cec vy cv cltr wbr wn wi vv cv vw cv cltp wbr
      vu cv cnp wcel vu cv cB wcel vv cv vu cv cltp wbr wa wa vu wex wi vy cv
      vw cv c1p cpp co c1p cop cer cec cltr wbr c0r vz cv cltr wbr vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex wi vv cv c1p cpp co c1p cop cer
      cec vy cv wceq vv cv cB wcel vy cv cA wcel vw cv vv cv cltp wbr wn vw cv
      c1p cpp co c1p cop cer cec vy cv cltr wbr wn vv cv c1p cpp co c1p cop cer
      cec vy cv wceq vv cv c1p cpp co c1p cop cer cec cA wcel vy cv cA wcel vv
      cv cB wcel vv cv c1p cpp co c1p cop cer cec vy cv cA eleq1 vw cv c1p cpp
      co c1p cop cer cec cA wcel vv cv c1p cpp co c1p cop cer cec cA wcel vw vv
      cv cB vv visset vw cv vv cv wceq vw cv c1p cpp co c1p cop cer cec vv cv
      c1p cpp co c1p cop cer cec cA vw cv vv cv wceq vw cv c1p cpp co vv cv c1p
      cpp co wceq vw cv c1p cpp co c1p cop vv cv c1p cpp co c1p cop wceq vw cv
      c1p cpp co c1p cop cer cec vv cv c1p cpp co c1p cop cer cec wceq vw cv vv
      cv c1p cpp opreq1 vw cv c1p cpp co vv cv c1p cpp co c1p opeq1 vw cv c1p
      cpp co c1p cop vv cv c1p cpp co c1p cop cer eceq2 3syl eleq1d suppsr.1
      elab2 syl5bb vv cv c1p cpp co c1p cop cer cec vy cv wceq vw cv vv cv cltp
      wbr vw cv c1p cpp co c1p cop cer cec vy cv cltr wbr vv cv c1p cpp co c1p
      cop cer cec vy cv wceq vw cv c1p cpp co c1p cop cer cec vv cv c1p cpp co
      c1p cop cer cec cltr wbr vw cv c1p cpp co c1p cop cer cec vy cv cltr wbr
      vw cv vv cv cltp wbr vv cv c1p cpp co c1p cop cer cec vy cv vw cv c1p cpp
      co c1p cop cer cec cltr breq2 vw cv vv cv vw visset vv visset ltpsrpr
      syl5bbr notbid imbi12d vv cv c1p cpp co c1p cop cer cec vy cv wceq vv cv
      vw cv cltp wbr vy cv vw cv c1p cpp co c1p cop cer cec cltr wbr vu cv cnp
      wcel vu cv cB wcel vv cv vu cv cltp wbr wa wa vu wex c0r vz cv cltr wbr
      vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex vv cv c1p cpp co c1p cop
      cer cec vy cv wceq vv cv c1p cpp co c1p cop cer cec vw cv c1p cpp co c1p
      cop cer cec cltr wbr vy cv vw cv c1p cpp co c1p cop cer cec cltr wbr vv
      cv vw cv cltp wbr vv cv c1p cpp co c1p cop cer cec vy cv vw cv c1p cpp co
      c1p cop cer cec cltr breq1 vv cv vw cv vv visset vw visset ltpsrpr
      syl5bbr vv cv c1p cpp co c1p cop cer cec vy cv wceq c0r vz cv cltr wbr vz
      cv cA wcel vv cv c1p cpp co c1p cop cer cec vz cv cltr wbr wa wa vz wex
      c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex vu cv
      cnp wcel vu cv cB wcel vv cv vu cv cltp wbr wa wa vu wex vv cv c1p cpp co
      c1p cop cer cec vy cv wceq c0r vz cv cltr wbr vz cv cA wcel vv cv c1p cpp
      co c1p cop cer cec vz cv cltr wbr wa wa c0r vz cv cltr wbr vz cv cA wcel
      vy cv vz cv cltr wbr wa wa vz vv cv c1p cpp co c1p cop cer cec vy cv wceq
      vz cv cA wcel vv cv c1p cpp co c1p cop cer cec vz cv cltr wbr wa vz cv cA
      wcel vy cv vz cv cltr wbr wa c0r vz cv cltr wbr vv cv c1p cpp co c1p cop
      cer cec vy cv wceq vv cv c1p cpp co c1p cop cer cec vz cv cltr wbr vy cv
      vz cv cltr wbr vz cv cA wcel vv cv c1p cpp co c1p cop cer cec vy cv vz cv
      cltr breq1 anbi2d anbi2d exbidv vu cv cB wcel vv cv vu cv cltp wbr wa vz
      cv cA wcel vv cv c1p cpp co c1p cop cer cec vz cv cltr wbr wa vu cv cnp
      wcel c0r vz cv cltr wbr vu vz vu cv c1p cpp co c1p cop cer cec cer cvv
      wcel vu cv c1p cpp co c1p cop cer cec cvv wcel enrex vu cv c1p cpp co c1p
      cop cvv cer ecexg ax-mp vu cv c1p cpp co c1p cop cer cec vz cv wceq vu cv
      cB wcel vz cv cA wcel vv cv vu cv cltp wbr vv cv c1p cpp co c1p cop cer
      cec vz cv cltr wbr vu cv c1p cpp co c1p cop cer cec vz cv wceq vu cv c1p
      cpp co c1p cop cer cec cA wcel vz cv cA wcel vu cv cB wcel vu cv c1p cpp
      co c1p cop cer cec vz cv cA eleq1 vw cv c1p cpp co c1p cop cer cec cA
      wcel vu cv c1p cpp co c1p cop cer cec cA wcel vw vu cv cB vu visset vw cv
      vu cv wceq vw cv c1p cpp co c1p cop cer cec vu cv c1p cpp co c1p cop cer
      cec cA vw cv vu cv wceq vw cv c1p cpp co vu cv c1p cpp co wceq vw cv c1p
      cpp co c1p cop vu cv c1p cpp co c1p cop wceq vw cv c1p cpp co c1p cop cer
      cec vu cv c1p cpp co c1p cop cer cec wceq vw cv vu cv c1p cpp opreq1 vw
      cv c1p cpp co vu cv c1p cpp co c1p opeq1 vw cv c1p cpp co c1p cop vu cv
      c1p cpp co c1p cop cer eceq2 3syl eleq1d suppsr.1 elab2 syl5bb vu cv c1p
      cpp co c1p cop cer cec vz cv wceq vv cv c1p cpp co c1p cop cer cec vu cv
      c1p cpp co c1p cop cer cec cltr wbr vv cv c1p cpp co c1p cop cer cec vz
      cv cltr wbr vv cv vu cv cltp wbr vu cv c1p cpp co c1p cop cer cec vz cv
      vv cv c1p cpp co c1p cop cer cec cltr breq2 vv cv vu cv vv visset vu
      visset ltpsrpr syl5bbr anbi12d vu cv c1p cpp co c1p cop cer cec vz cv
      wceq c0r vu cv c1p cpp co c1p cop cer cec cltr wbr c0r vz cv cltr wbr vu
      cv cnp wcel vu cv c1p cpp co c1p cop cer cec vz cv c0r cltr breq2 vu cv
      vu visset mappsrpr syl5bbr vu vz cv vz visset map2psrpr gencbvex syl5bb
      imbi12d anbi12d vv cv c1p cpp co c1p cop cer cec vy cv wceq c0r vv cv c1p
      cpp co c1p cop cer cec cltr wbr c0r vy cv cltr wbr vv cv cnp wcel vv cv
      c1p cpp co c1p cop cer cec vy cv c0r cltr breq2 vv cv vv visset mappsrpr
      syl5bbr vv vy cv vy visset map2psrpr gencbval syl5bb vw cv c1p cpp co c1p
      cop cer cec vx cv wceq c0r vw cv c1p cpp co c1p cop cer cec cltr wbr c0r
      vx cv cltr wbr vw cv cnp wcel vw cv c1p cpp co c1p cop cer cec vx cv c0r
      cltr breq2 vw cv vw visset mappsrpr syl5bbr vw vx cv vx visset map2psrpr
      gencbvex sylib vv cv cnp wcel vv cv cB wcel vv cv vw cv cltp wbr wi wi vv
      wal c0r vy cv cltr wbr vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal vw
      cv cnp wcel c0r vx cv cltr wbr vw vx vw cv c1p cpp co c1p cop cer cec cer
      cvv wcel vw cv c1p cpp co c1p cop cer cec cvv wcel enrex vw cv c1p cpp co
      c1p cop cvv cer ecexg ax-mp vw cv c1p cpp co c1p cop cer cec vx cv wceq
      c0r vy cv cltr wbr vy cv cA wcel vy cv vw cv c1p cpp co c1p cop cer cec
      cltr wbr wi wi vy wal c0r vy cv cltr wbr vy cv cA wcel vy cv vx cv cltr
      wbr wi wi vy wal vv cv cnp wcel vv cv cB wcel vv cv vw cv cltp wbr wi wi
      vv wal vw cv c1p cpp co c1p cop cer cec vx cv wceq c0r vy cv cltr wbr vy
      cv cA wcel vy cv vw cv c1p cpp co c1p cop cer cec cltr wbr wi wi c0r vy
      cv cltr wbr vy cv cA wcel vy cv vx cv cltr wbr wi wi vy vw cv c1p cpp co
      c1p cop cer cec vx cv wceq vy cv cA wcel vy cv vw cv c1p cpp co c1p cop
      cer cec cltr wbr wi vy cv cA wcel vy cv vx cv cltr wbr wi c0r vy cv cltr
      wbr vw cv c1p cpp co c1p cop cer cec vx cv wceq vy cv vw cv c1p cpp co
      c1p cop cer cec cltr wbr vy cv vx cv cltr wbr vy cv cA wcel vw cv c1p cpp
      co c1p cop cer cec vx cv vy cv cltr breq2 imbi2d imbi2d albidv vv cv cB
      wcel vv cv vw cv cltp wbr wi vy cv cA wcel vy cv vw cv c1p cpp co c1p cop
      cer cec cltr wbr wi vv cv cnp wcel c0r vy cv cltr wbr vv vy vv cv c1p cpp
      co c1p cop cer cec cer cvv wcel vv cv c1p cpp co c1p cop cer cec cvv wcel
      enrex vv cv c1p cpp co c1p cop cvv cer ecexg ax-mp vv cv c1p cpp co c1p
      cop cer cec vy cv wceq vv cv cB wcel vy cv cA wcel vv cv vw cv cltp wbr
      vy cv vw cv c1p cpp co c1p cop cer cec cltr wbr vv cv c1p cpp co c1p cop
      cer cec vy cv wceq vv cv c1p cpp co c1p cop cer cec cA wcel vy cv cA wcel
      vv cv cB wcel vv cv c1p cpp co c1p cop cer cec vy cv cA eleq1 vw cv c1p
      cpp co c1p cop cer cec cA wcel vv cv c1p cpp co c1p cop cer cec cA wcel
      vw vv cv cB vv visset vw cv vv cv wceq vw cv c1p cpp co c1p cop cer cec
      vv cv c1p cpp co c1p cop cer cec cA vw cv vv cv wceq vw cv c1p cpp co vv
      cv c1p cpp co wceq vw cv c1p cpp co c1p cop vv cv c1p cpp co c1p cop wceq
      vw cv c1p cpp co c1p cop cer cec vv cv c1p cpp co c1p cop cer cec wceq vw
      cv vv cv c1p cpp opreq1 vw cv c1p cpp co vv cv c1p cpp co c1p opeq1 vw cv
      c1p cpp co c1p cop vv cv c1p cpp co c1p cop cer eceq2 3syl eleq1d
      suppsr.1 elab2 syl5bb vv cv c1p cpp co c1p cop cer cec vy cv wceq vv cv
      c1p cpp co c1p cop cer cec vw cv c1p cpp co c1p cop cer cec cltr wbr vy
      cv vw cv c1p cpp co c1p cop cer cec cltr wbr vv cv vw cv cltp wbr vv cv
      c1p cpp co c1p cop cer cec vy cv vw cv c1p cpp co c1p cop cer cec cltr
      breq1 vv cv vw cv vv visset vw visset ltpsrpr syl5bbr imbi12d vv cv c1p
      cpp co c1p cop cer cec vy cv wceq c0r vv cv c1p cpp co c1p cop cer cec
      cltr wbr c0r vy cv cltr wbr vv cv cnp wcel vv cv c1p cpp co c1p cop cer
      cec vy cv c0r cltr breq2 vv cv vv visset mappsrpr syl5bbr vv vy cv vy
      visset map2psrpr gencbval syl5bb vw cv c1p cpp co c1p cop cer cec vx cv
      wceq c0r vw cv c1p cpp co c1p cop cer cec cltr wbr c0r vx cv cltr wbr vw
      cv cnp wcel vw cv c1p cpp co c1p cop cer cec vx cv c0r cltr breq2 vw cv
      vw visset mappsrpr syl5bbr vw vx cv vx visset map2psrpr gencbvex sylan2br
      vx vw cA cB suppsr.1 suppsrlem sylan $.
      $( [18-May-1996] $)
  $}

  ${
    $d x y z w v A $.
    $( A non-empty, bounded set of positive signed reals has a supremum.
      (Converts quantifier restrictions to all reals.) $)
    suppsr2 $p |- ( ( ( A. x ( x e. A -> 0R <R x ) /\ -. A = (/) ) /\
         E. x ( x e. R. /\ A. y ( y e. R. -> ( y e. A -> y <R x ) ) ) ) ->
       E. x ( x e. R. /\ A. y ( y e. R. -> ( ( y e. A -> -. x <R y ) /\
           ( y <R x -> E. z ( z e. R. /\ ( z e. A /\ y <R z ) ) ) ) ) ) ) $=
      vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa vx cv cnr
      wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx
      wex wa c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv
      cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy
      cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex vx cv cnr wcel
      vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr
      wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa
      wi vy wal wa vx wex vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq
      wn wa vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi
      wi vy wal wa vx wex wa vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0
      wceq wn wa c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv cA wcel vy cv vx
      cv cltr wbr wi wi vy wal wa vx wex wa c0r vx cv cltr wbr c0r vy cv cltr
      wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr c0r vz
      cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy
      wal wa vx wex vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa
      vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy
      wal wa vx wex c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv cA wcel vy cv
      vx cv cltr wbr wi wi vy wal wa vx wex vx cv cA wcel c0r vx cv cltr wbr wi
      vx wal cA c0 wceq wn wa vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv
      vx cv cltr wbr wi wi vy wal wa c0r vx cv cltr wbr c0r vy cv cltr wbr vy
      cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx vx cv cA wcel c0r vx
      cv cltr wbr wi vx wal cA c0 wceq wn vx vx cv cA wcel c0r vx cv cltr wbr
      wi vx hba1 cA c0 wceq wn vx ax-17 hban vx cv cA wcel c0r vx cv cltr wbr
      wi vx wal cA c0 wceq wn wa vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr
      wbr wi wi vy wal c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv cA wcel vy
      cv vx cv cltr wbr wi wi vy wal wa vx cv cnr wcel vx cv cA wcel c0r vx cv
      cltr wbr wi vx wal cA c0 wceq wn wa vy cv cnr wcel vy cv cA wcel vy cv vx
      cv cltr wbr wi wi vy wal c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv cA
      wcel vy cv vx cv cltr wbr wi wi vy wal vx cv cA wcel c0r vx cv cltr wbr
      wi vx wal cA c0 wceq wn vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr
      wi wi vy wal c0r vx cv cltr wbr wi vx cv cA wcel c0r vx cv cltr wbr wi vx
      wal vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal cA c0
      wceq wn c0r vx cv cltr wbr vx cv cA wcel c0r vx cv cltr wbr wi vx wal vy
      cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal cA c0 wceq wn
      c0r vx cv cltr wbr wi vx cv cA wcel c0r vx cv cltr wbr wi vx wal vy cv
      cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vz cv cA wcel
      vz wex c0r vx cv cltr wbr cA c0 wceq wn vx cv cA wcel c0r vx cv cltr wbr
      wi vx wal vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal
      wa vz cv cA wcel c0r vx cv cltr wbr vz vx cv cA wcel c0r vx cv cltr wbr
      wi vx wal vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal
      wa vz cv cA wcel c0r vx cv cltr wbr vx cv cA wcel c0r vx cv cltr wbr wi
      vx wal vz cv cA wcel c0r vz cv cltr wbr vy cv cnr wcel vy cv cA wcel vy
      cv vx cv cltr wbr wi wi vy wal vz cv cA wcel c0r vx cv cltr wbr wi vx cv
      cA wcel c0r vx cv cltr wbr wi vz cv cA wcel c0r vz cv cltr wbr wi vx vz
      vx cv vz cv wceq vx cv cA wcel vz cv cA wcel c0r vx cv cltr wbr c0r vz cv
      cltr wbr vx cv vz cv cA eleq1 vx cv vz cv c0r cltr breq2 imbi12d a4v vy
      cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal c0r vz cv
      cltr wbr vz cv cA wcel c0r vz cv cltr wbr vz cv vx cv cltr wbr wa c0r vx
      cv cltr wbr vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy
      wal c0r vz cv cltr wbr vz cv cA wcel vz cv vx cv cltr wbr wi wi c0r vz cv
      cltr wbr vz cv cA wcel c0r vz cv cltr wbr vz cv vx cv cltr wbr wa wi wi
      vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal vz cv cnr
      wcel vz cv cA wcel vz cv vx cv cltr wbr wi c0r vz cv cltr wbr vy cv cnr
      wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vz cv cnr wcel vz cv cA
      wcel vz cv vx cv cltr wbr wi wi vy vz vy cv vz cv wceq vy cv cnr wcel vz
      cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi vz cv cA wcel vz cv vx
      cv cltr wbr wi vy cv vz cv cnr eleq1 vy cv vz cv wceq vy cv cA wcel vz cv
      cA wcel vy cv vx cv cltr wbr vz cv vx cv cltr wbr vy cv vz cv cA eleq1 vy
      cv vz cv vx cv cltr breq1 imbi12d imbi12d a4v c0r vz cv cltr wbr c0r cnr
      wcel vz cv cnr wcel c0r vz cv cnr cnr cltr vz visset ltrelsr brel pm3.27d
      syl5 c0r vz cv cltr wbr vz cv cA wcel vz cv vx cv cltr wbr anc2l syl c0r
      vz cv vx cv cltr cnr c0r cnr 0r elisseti ltsosr ltrelsr vz visset vx
      visset sotri syl8 sylan9 pm2.43d 19.23adv vz cA neq0 syl5ib ex com23 imp
      vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal c0r vy cv
      cltr wbr vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wi vx cv cA wcel
      c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa vy cv cnr wcel vy cv cA
      wcel vy cv vx cv cltr wbr wi wi c0r vy cv cltr wbr vy cv cA wcel vy cv vx
      cv cltr wbr wi wi vy c0r vy cv cltr wbr vy cv cnr wcel vy cv cA wcel vy
      cv vx cv cltr wbr wi c0r vy cv cltr wbr c0r cnr wcel vy cv cnr wcel c0r
      vy cv cnr cnr cltr vy visset ltrelsr brel pm3.27d imim1i 19.20i a1i jcad
      adantld 19.22d imdistani vx vy vz vw cA vv cv c1p cpp co c1p cop cer cec
      cA wcel vv cab vv cv c1p cpp co c1p cop cer cec cA wcel vw cv c1p cpp co
      c1p cop cer cec cA wcel vv vw vv cv vw cv wceq vv cv c1p cpp co c1p cop
      cer cec vw cv c1p cpp co c1p cop cer cec cA vv cv vw cv wceq vv cv c1p
      cpp co vw cv c1p cpp co wceq vv cv c1p cpp co c1p cop vw cv c1p cpp co
      c1p cop wceq vv cv c1p cpp co c1p cop cer cec vw cv c1p cpp co c1p cop
      cer cec wceq vv cv vw cv c1p cpp opreq1 vv cv c1p cpp co vw cv c1p cpp co
      c1p opeq1 vv cv c1p cpp co c1p cop vw cv c1p cpp co c1p cop cer eceq2
      3syl eleq1d cbvabv suppsr syl vx cv cA wcel c0r vx cv cltr wbr wi vx wal
      cA c0 wceq wn wa c0r vx cv cltr wbr c0r vy cv cltr wbr vy cv cA wcel vx
      cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex vx cv
      cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx
      cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal wa vx wex wi vx cv cnr wcel vy cv cnr wcel vy cv cA
      wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv cA wcel c0r vx cv
      cltr wbr wi vx wal cA c0 wceq wn wa c0r vx cv cltr wbr c0r vy cv cltr wbr
      vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv
      cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal
      wa vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi
      vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa
      wa vz wex wi wa wi vy wal wa vx vx cv cA wcel c0r vx cv cltr wbr wi vx
      wal cA c0 wceq wn vx vx cv cA wcel c0r vx cv cltr wbr wi vx hba1 cA c0
      wceq wn vx ax-17 hban vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0
      wceq wn wa c0r vx cv cltr wbr vx cv cnr wcel c0r vy cv cltr wbr vy cv cA
      wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr
      vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal vy cv cnr
      wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal
      c0r vx cv cltr wbr vx cv cnr wcel wi vx cv cA wcel c0r vx cv cltr wbr wi
      vx wal cA c0 wceq wn wa c0r vx cv cltr wbr c0r cnr wcel vx cv cnr wcel
      c0r vx cv cnr cnr cltr vx visset ltrelsr brel pm3.27d a1i vx cv cA wcel
      c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa c0r vy cv cltr wbr vy cv cA
      wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr
      vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy cv cnr wcel
      vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr
      wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy vx cv cA
      wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa c0r vy cv cltr wbr vy
      cv cA wcel vx cv vy cv cltr wbr wn wi wi c0r vy cv cltr wbr vy cv vx cv
      cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wi wa vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi wi
      vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz
      cv cltr wbr wa wa vz wex wi wi wa c0r vy cv cltr wbr vy cv cA wcel vx cv
      vy cv cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy cv cnr wcel vy cv cA
      wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv
      cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vx cv cA wcel c0r vx
      cv cltr wbr wi vx wal cA c0 wceq wn wa c0r vy cv cltr wbr vy cv cA wcel
      vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv cA wcel vx cv vy cv
      cltr wbr wn wi wi c0r vy cv cltr wbr vy cv vx cv cltr wbr c0r vz cv cltr
      wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi vy cv cnr wcel
      vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa
      wa vz wex wi wi vx cv cA wcel c0r vx cv cltr wbr wi vx wal c0r vy cv cltr
      wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv cA
      wcel vx cv vy cv cltr wbr wn wi wi wi cA c0 wceq wn vx cv cA wcel c0r vx
      cv cltr wbr wi vx wal vy cv cA wcel c0r vy cv cltr wbr wi c0r vy cv cltr
      wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv cA
      wcel vx cv vy cv cltr wbr wn wi wi wi vx cv cA wcel c0r vx cv cltr wbr wi
      vy cv cA wcel c0r vy cv cltr wbr wi vx vy vx cv vy cv wceq vx cv cA wcel
      vy cv cA wcel c0r vx cv cltr wbr c0r vy cv cltr wbr vx cv vy cv cA eleq1
      vx cv vy cv c0r cltr breq2 imbi12d a4v vy cv cA wcel c0r vy cv cltr wbr
      wi c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi wi vy cv
      cA wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv
      cA wcel vx cv vy cv cltr wbr wn wi wi vy cv cA wcel c0r vy cv cltr wbr vy
      cv cA wcel vx cv vy cv cltr wbr wn wi imim1 vy cv cA wcel vx cv vy cv
      cltr wbr wn vy cv cnr wcel merlem10 syl6 syl adantr vx cv cA wcel c0r vx
      cv cltr wbr wi vx wal cA c0 wceq wn wa c0r vy cv cltr wbr vy cv vx cv
      cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wi vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex wi vx cv cA wcel c0r vx cv cltr
      wbr wi vx wal cA c0 wceq wn wa c0r vy cv cltr wbr vy cv vx cv cltr wbr
      c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi
      wa vy cv cnr wcel wa vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz wex vz cv cnr wcel vz cv cA wcel vy cv
      vz cv cltr wbr wa wa vz wex vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA
      c0 wceq wn wa vy cv cnr wcel c0r vy cv cltr wbr vy cv vx cv cltr wbr c0r
      vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi vy
      cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr
      wa wa vz wex wi vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn
      wa vy cv cnr wcel wa c0r vy cv cltr wbr vy cv vx cv cltr wbr c0r vz cv
      cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi wa c0r vy
      cv cltr wbr vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv
      vz cv cltr wbr wa wa vz wex wi vx cv cA wcel c0r vx cv cltr wbr wi vx wal
      cA c0 wceq wn wa vy cv cnr wcel wa c0r vy cv cltr wbr vy cv vx cv cltr
      wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi
      wi pm3.27 vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn wa vy
      cv cnr wcel wa c0r vy cv cltr wbr wn vy cv vx cv cltr wbr c0r vz cv cltr
      wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi c0r vy cv cltr
      wbr vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv
      cltr wbr wa wa vz wex wi wi vx cv cA wcel c0r vx cv cltr wbr wi vx wal cA
      c0 wceq wn wa vy cv cnr wcel wa c0r vy cv cltr wbr wn c0r vz cv cltr wbr
      vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex vy cv vx cv cltr wbr vx
      cv cA wcel c0r vx cv cltr wbr wi vx wal cA c0 wceq wn vy cv cnr wcel c0r
      vy cv cltr wbr wn c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr
      wa wa vz wex wi vx cv cA wcel c0r vx cv cltr wbr wi vx wal c0r vy cv cltr
      wbr wn vy cv cnr wcel cA c0 wceq wn c0r vz cv cltr wbr vz cv cA wcel vy
      cv vz cv cltr wbr wa wa vz wex vx cv cA wcel c0r vx cv cltr wbr wi vx wal
      c0r vy cv cltr wbr wn vy cv cnr wcel cA c0 wceq wn c0r vz cv cltr wbr vz
      cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi vx cv cA wcel c0r vx cv
      cltr wbr wi vx wal c0r vy cv cltr wbr wn vy cv cnr wcel wa wa vz cv cA
      wcel vz wex c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa
      vz wex cA c0 wceq wn vx cv cA wcel c0r vx cv cltr wbr wi vx wal c0r vy cv
      cltr wbr wn vy cv cnr wcel wa wa vz cv cA wcel c0r vz cv cltr wbr vz cv
      cA wcel vy cv vz cv cltr wbr wa wa vz vx cv cA wcel c0r vx cv cltr wbr wi
      vx wal vz cv cA wcel vz cv cA wcel c0r vz cv cltr wbr wa c0r vy cv cltr
      wbr wn vy cv cnr wcel wa c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv
      cltr wbr wa wa vx cv cA wcel c0r vx cv cltr wbr wi vx wal vz cv cA wcel
      c0r vz cv cltr wbr vx cv cA wcel c0r vx cv cltr wbr wi vz cv cA wcel c0r
      vz cv cltr wbr wi vx vz vx cv vz cv wceq vx cv cA wcel vz cv cA wcel c0r
      vx cv cltr wbr c0r vz cv cltr wbr vx cv vz cv cA eleq1 vx cv vz cv c0r
      cltr breq2 imbi12d a4v ancld c0r vy cv cltr wbr wn vy cv cnr wcel wa vz
      cv cA wcel c0r vz cv cltr wbr wa vz cv cA wcel c0r vz cv cltr wbr vy cv
      vz cv cltr wbr wa wa c0r vz cv cltr wbr vz cv cA wcel vy cv vz cv cltr
      wbr wa wa c0r vy cv cltr wbr wn vy cv cnr wcel wa c0r vz cv cltr wbr c0r
      vz cv cltr wbr vy cv vz cv cltr wbr wa vz cv cA wcel c0r vy cv cltr wbr
      wn vy cv cnr wcel wa c0r vz cv cltr wbr vy cv vz cv cltr wbr vy cv cnr
      wcel c0r vy cv cltr wbr wn c0r vz cv cltr wbr vy cv vz cv cltr wbr wi vy
      cv cnr wcel c0r vy cv cltr wbr wn c0r vy cv wceq vy cv c0r cltr wbr wo
      c0r vz cv cltr wbr vy cv vz cv cltr wbr wi vy cv cnr wcel c0r vy cv cltr
      wbr c0r vy cv wceq vy cv c0r cltr wbr wo c0r cnr wcel vy cv cnr wcel c0r
      vy cv cltr wbr c0r vy cv wceq vy cv c0r cltr wbr wo wn wb 0r cnr cltr wor
      c0r cnr wcel vy cv cnr wcel wa c0r vy cv cltr wbr c0r vy cv wceq vy cv
      c0r cltr wbr wo wn wb ltsosr cnr c0r vy cv cltr sotric mpan mpan con2bid
      c0r vy cv wceq c0r vz cv cltr wbr vy cv vz cv cltr wbr wi vy cv c0r cltr
      wbr c0r vy cv wceq c0r vz cv cltr wbr vy cv vz cv cltr wbr c0r vy cv vz
      cv cltr breq1 biimpd vy cv c0r cltr wbr c0r vz cv cltr wbr vy cv vz cv
      cltr wbr vy cv c0r vz cv cltr cnr vy visset ltsosr ltrelsr c0r cnr 0r
      elisseti vz visset sotri ex jaoi syl6bir impcom ancld anim2d vz cv cA
      wcel c0r vz cv cltr wbr vy cv vz cv cltr wbr an12 syl6ib sylan9 19.22dv
      vz cA neq0 syl5ib exp32 com24 imp31 a1dd adantr pm2.61d an1rs c0r vz cv
      cltr wbr vz cv cA wcel vy cv vz cv cltr wbr wa wa vz cv cnr wcel vz cv cA
      wcel vy cv vz cv cltr wbr wa wa vz c0r vz cv cltr wbr vz cv cnr wcel vz
      cv cA wcel vy cv vz cv cltr wbr wa c0r vz cv cltr wbr c0r cnr wcel vz cv
      cnr wcel c0r vz cv cnr cnr cltr vz visset ltrelsr brel pm3.27d anim1i
      19.22i syl6 exp31 anim12d c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv
      cltr wbr wn wi vy cv vx cv cltr wbr c0r vz cv cltr wbr vz cv cA wcel vy
      cv vz cv cltr wbr wa wa vz wex wi jcab vy cv cnr wcel vy cv cA wcel vx cv
      vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy
      cv vz cv cltr wbr wa wa vz wex wi jcab 3imtr4g 19.20dv anim12d 19.22d
      adantr mpd $.
      $( [20-May-1996] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    suppsr3.1 $e |- B = { y | ( y e. A /\ 0R <R y ) } $.
    $( A non-empty, bounded set with at least one positive real has a
       supremum. $)
    suppsr3 $p |- ( ( E. y ( y e. A /\ 0R <R y ) /\
         E. x ( x e. R. /\ A. y ( y e. R. -> ( y e. A -> y <R x ) ) ) ) ->
       E. x ( x e. R. /\ A. y ( y e. R. -> ( ( y e. A -> -. x <R y ) /\
           ( y <R x -> E. z ( z e. R. /\ ( z e. A /\ y <R z ) ) ) ) ) ) ) $=
      vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel vy cv cnr wcel
      vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex wa vx cv cnr
      wcel vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv vx cv
      cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex
      wi wa wi vy wal wa vx wex vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vx
      cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel
      vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex cB c0 wceq wn
      vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vy cv vx cv cltr wbr wi wi vy
      wal wa vx wex vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vx cv vy cv
      cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz
      cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex vy cv cA wcel c0r vy
      cv cltr wbr wa vy wex vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv
      vx cv cltr wbr wi wi vy wal wa vx wex vx cv cB wcel c0r vx cv cltr wbr wi
      vx wal cB c0 wceq wn vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vy cv vx
      cv cltr wbr wi wi vy wal wa vx wex vx cv cnr wcel vy cv cnr wcel vy cv cB
      wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv
      cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex vx cv
      cB wcel c0r vx cv cltr wbr wi vx vx cv cB wcel vx cv cA wcel c0r vx cv
      cltr wbr vy cv cA wcel c0r vy cv cltr wbr wa vx cv cA wcel c0r vx cv cltr
      wbr wa vy vx cv cB vx visset vy cv vx cv wceq vy cv cA wcel vx cv cA wcel
      c0r vy cv cltr wbr c0r vx cv cltr wbr vy cv vx cv cA eleq1 vy cv vx cv
      c0r cltr breq2 anbi12d suppsr3.1 elab2 pm3.27bi ax-gen vx vy vz cB
      suppsr2 mpanl1 cB c0 wceq wn vy cv cA wcel c0r vy cv cltr wbr wa vy wex
      cB c0 wceq wn vy cv cB wcel vy wex vy cv cA wcel c0r vy cv cltr wbr wa vy
      wex vy cB neq0 vy cv cB wcel vy cv cA wcel c0r vy cv cltr wbr wa vy vy cv
      cA wcel c0r vy cv cltr wbr wa vy cB suppsr3.1 abeq2i exbii bitri biimpri
      vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy
      wal wa vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vy cv vx cv cltr wbr
      wi wi vy wal wa vx vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi
      wi vy wal vy cv cnr wcel vy cv cB wcel vy cv vx cv cltr wbr wi wi vy wal
      vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy
      cv cnr wcel vy cv cB wcel vy cv vx cv cltr wbr wi wi vy vy cv cA wcel vy
      cv vx cv cltr wbr wi vy cv cB wcel vy cv vx cv cltr wbr wi vy cv cnr wcel
      vy cv cB wcel vy cv cA wcel vy cv vx cv cltr wbr vy cv cB wcel vy cv cA
      wcel c0r vy cv cltr wbr vy cv cA wcel c0r vy cv cltr wbr wa vy cB
      suppsr3.1 abeq2i pm3.26bi imim1i imim2i 19.20i anim2i 19.22i syl2an vy cv
      cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel vy cv cnr wcel vy cv
      cB wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz
      cv cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex vx
      cv cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal wa vx wex wi vx cv cnr wcel vy cv cnr wcel vy cv cA
      wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vy cv cA wcel c0r vy cv
      cltr wbr wa vy wex vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vx cv vy
      cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv
      vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx cv cnr wcel vy cv cnr
      wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal
      wa vx vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel vy cv cnr
      wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal
      vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr
      wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa
      wi vy wal vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel vy cv
      cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz
      cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy
      wal vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv
      cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex
      wi wa wi vy wal vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel
      wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv vx cv
      cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex
      wi wa wi vy wal wa vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn
      wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr
      wa wa vz wex wi wa wi vy vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv
      cnr wcel wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal vy vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv
      cnr wcel vy vy cv cA wcel c0r vy cv cltr wbr wa vy hbe1 vx cv cnr wcel vy
      ax-17 hban vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy hba1 hban vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx
      cv cnr wcel wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy
      cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa
      vz wex wi wa wi vy wal vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr
      wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr
      wbr wa wa vz wex wi wa wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx
      cv cnr wcel wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi
      vy wal vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel
      vy cv vz cv cltr wbr wa wa vz wex wi wi vy wal wa vy cv cnr wcel vy cv cA
      wcel vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv vx cv cltr wbr vz
      cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi wa vy
      cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr
      vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi
      vy wal vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx
      cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel wa
      vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy wal vy cv
      cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wi vy wal vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv
      cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi vy cv cA wcel c0r vy cv
      cltr wbr wa vy wex vx cv cnr wcel wa vy cv cnr wcel vy cv cB wcel vx cv
      vy cv cltr wbr wn wi wi vy wal vy cv cnr wcel vy cv cA wcel vx cv vy cv
      cltr wbr wn wi wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr
      wcel wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy wal
      wa c0r vy cv cltr wbr vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr
      wn wi wi vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy
      wal c0r vy cv cltr wbr vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr
      wn wi wi wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel wa
      vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi c0r vy cv cltr
      wbr vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi wi wi vy vy
      cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel
      c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv cB wcel
      vx cv vy cv cltr wbr wn wi c0r vy cv cltr wbr vy cv cA wcel vx cv vy cv
      cltr wbr wn wi wi vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi
      vy cv cA wcel c0r vy cv cltr wbr vx cv vy cv cltr wbr wn wi wi c0r vy cv
      cltr wbr vy cv cA wcel vx cv vy cv cltr wbr wn wi wi vy cv cB wcel vx cv
      vy cv cltr wbr wn wi vy cv cA wcel c0r vy cv cltr wbr wa vx cv vy cv cltr
      wbr wn wi vy cv cA wcel c0r vy cv cltr wbr vx cv vy cv cltr wbr wn wi wi
      vy cv cB wcel vy cv cA wcel c0r vy cv cltr wbr wa vx cv vy cv cltr wbr wn
      vy cv cA wcel c0r vy cv cltr wbr wa vy cB suppsr3.1 abeq2i imbi1i vy cv
      cA wcel c0r vy cv cltr wbr vx cv vy cv cltr wbr wn impexp bitri vy cv cA
      wcel c0r vy cv cltr wbr vx cv vy cv cltr wbr wn pm2.04 sylbi imim2i com23
      a4s adantl vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel wa
      vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy wal wa c0r
      vy cv cltr wbr wn vx cv vy cv cltr wbr wn vy cv cnr wcel vy cv cA wcel vx
      cv vy cv cltr wbr wn wi wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx
      cv cnr wcel wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi
      vy wal wa c0r vx cv cltr wbr c0r vy cv cltr wbr wn vx cv vy cv cltr wbr
      wn wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel vy cv cnr
      wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy wal c0r vx cv cltr
      wbr vy cv cA wcel c0r vy cv cltr wbr wa vx cv cnr wcel vy cv cnr wcel vy
      cv cB wcel vx cv vy cv cltr wbr wn wi wi vy wal c0r vx cv cltr wbr wi wi
      vy vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi
      wi vy wal c0r vx cv cltr wbr wi vy vx cv cnr wcel vy ax-17 vy cv cnr wcel
      vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy wal c0r vx cv cltr wbr vy
      vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi vy hba1 c0r vx
      cv cltr wbr vy ax-17 hbim hbim vx cv cnr wcel vy cv cnr wcel vy cv cB
      wcel vx cv vy cv cltr wbr wn wi wi vy wal vy cv cA wcel c0r vy cv cltr
      wbr wa c0r vx cv cltr wbr vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vx
      cv vy cv cltr wbr wn wi wi vy cv cA wcel c0r vy cv cltr wbr wa c0r vx cv
      cltr wbr wi vy vx cv cnr wcel vy cv cnr wcel vy cv cB wcel vx cv vy cv
      cltr wbr wn wi wi vy cv cnr wcel vy cv cA wcel c0r vy cv cltr wbr wa c0r
      vx cv cltr wbr wi wi vy cv cA wcel c0r vy cv cltr wbr wa c0r vx cv cltr
      wbr wi vx cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv cA
      wcel c0r vy cv cltr wbr wa c0r vx cv cltr wbr wi vy cv cnr wcel vx cv cnr
      wcel vy cv cA wcel c0r vy cv cltr wbr wa vx cv vy cv cltr wbr wn wi vy cv
      cA wcel c0r vy cv cltr wbr wa c0r vx cv cltr wbr wi vy cv cB wcel vx cv
      vy cv cltr wbr wn wi vx cv cnr wcel vy cv cA wcel c0r vy cv cltr wbr wa
      vx cv vy cv cltr wbr wn c0r vx cv cltr wbr vx cv cnr wcel c0r vy cv cltr
      wbr vx cv vy cv cltr wbr wn c0r vx cv cltr wbr wi vy cv cA wcel vx cv cnr
      wcel c0r vy cv cltr wbr vx cv vy cv cltr wbr wn c0r vx cv cltr wbr wi vx
      cv cnr wcel c0r vy cv cltr wbr wa vx cv vy cv cltr wbr wn vx cv vy cv
      wceq vy cv vx cv cltr wbr wo c0r vx cv cltr wbr vx cv cnr wcel vy cv cnr
      wcel vx cv vy cv wceq vy cv vx cv cltr wbr wo vx cv vy cv cltr wbr wn wb
      c0r vy cv cltr wbr vx cv cnr wcel vy cv cnr wcel wa vx cv vy cv cltr wbr
      vx cv vy cv wceq vy cv vx cv cltr wbr wo cnr cltr wor vx cv cnr wcel vy
      cv cnr wcel wa vx cv vy cv cltr wbr vx cv vy cv wceq vy cv vx cv cltr wbr
      wo wn wb ltsosr cnr vx cv vy cv cltr sotric mpan con2bid c0r vy cv cltr
      wbr c0r cnr wcel vy cv cnr wcel c0r vy cv cnr cnr cltr vy visset ltrelsr
      brel pm3.27d sylan2 c0r vy cv cltr wbr vx cv vy cv wceq vy cv vx cv cltr
      wbr wo c0r vx cv cltr wbr wi vx cv cnr wcel c0r vy cv cltr wbr vx cv vy
      cv wceq c0r vx cv cltr wbr vy cv vx cv cltr wbr vx cv vy cv wceq c0r vx
      cv cltr wbr c0r vy cv cltr wbr vx cv vy cv c0r cltr breq2 biimprcd c0r vy
      cv cltr wbr vy cv vx cv cltr wbr c0r vx cv cltr wbr c0r vy cv vx cv cltr
      cnr c0r cnr 0r elisseti ltsosr ltrelsr vy visset vx visset sotri ex jaod
      adantl sylbird ex adantld a2d vy cv cB wcel vy cv cA wcel c0r vy cv cltr
      wbr wa vx cv vy cv cltr wbr wn vy cv cA wcel c0r vy cv cltr wbr wa vy cB
      suppsr3.1 abeq2i imbi1i syl5ib imim2d vy cv cnr wcel vy cv cA wcel c0r vy
      cv cltr wbr wa c0r vx cv cltr wbr wi wi c0r vy cv cltr wbr vy cv cA wcel
      c0r vy cv cltr wbr wa c0r vx cv cltr wbr wi wi vy cv cA wcel c0r vy cv
      cltr wbr wa c0r vx cv cltr wbr wi c0r vy cv cltr wbr vy cv cnr wcel vy cv
      cA wcel c0r vy cv cltr wbr wa c0r vx cv cltr wbr wi c0r vy cv cltr wbr
      c0r cnr wcel vy cv cnr wcel c0r vy cv cnr cnr cltr vy visset ltrelsr brel
      pm3.27d imim1i vy cv cA wcel c0r vy cv cltr wbr wa c0r vx cv cltr wbr wi
      c0r vy cv cltr wbr vy cv cA wcel c0r vy cv cltr wbr wa wa c0r vx cv cltr
      wbr wi c0r vy cv cltr wbr vy cv cA wcel c0r vy cv cltr wbr wa c0r vx cv
      cltr wbr wi wi c0r vy cv cltr wbr vy cv cA wcel c0r vy cv cltr wbr wa wa
      vy cv cA wcel c0r vy cv cltr wbr wa c0r vx cv cltr wbr vy cv cA wcel c0r
      vy cv cltr wbr anabs7 imbi1i c0r vy cv cltr wbr vy cv cA wcel c0r vy cv
      cltr wbr wa c0r vx cv cltr wbr impexp bitr3i sylibr syl6 a4sd com3r
      19.23ai imp31 c0r vx cv cltr wbr vx cv vy cv cltr wbr c0r vy cv cltr wbr
      c0r vx cv cltr wbr vx cv vy cv cltr wbr c0r vy cv cltr wbr c0r vx cv vy
      cv cltr cnr c0r cnr 0r elisseti ltsosr ltrelsr vx visset vy visset sotri
      ex con3d syl vx cv vy cv cltr wbr wn vy cv cA wcel vx cv vy cv cltr wbr
      wn wi vy cv cnr wcel vx cv vy cv cltr wbr wn vy cv cA wcel ax-1 a1d syl6
      pm2.61d ex vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB
      wcel vy cv vz cv cltr wbr wa wa vz wex wi wi vy wal vy cv cnr wcel vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wi wi vy cv cA wcel c0r vy cv cltr wbr wa vy wex vx cv cnr wcel wa
      vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz
      cv cltr wbr wa wa vz wex wi wi vy cv cnr wcel vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wi vy vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz
      wex wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr
      wbr wa wa vz wex wi vy cv cnr wcel vz cv cnr wcel vz cv cB wcel vy cv vz
      cv cltr wbr wa wa vz wex vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr
      wbr wa wa vz wex vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv
      vz cv cltr wbr wa wa vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa
      wa vz vz cv cB wcel vy cv vz cv cltr wbr wa vz cv cA wcel vy cv vz cv
      cltr wbr wa vz cv cnr wcel vz cv cB wcel vz cv cA wcel vy cv vz cv cltr
      wbr vz cv cB wcel vz cv cA wcel c0r vz cv cltr wbr vy cv cA wcel c0r vy
      cv cltr wbr wa vz cv cA wcel c0r vz cv cltr wbr wa vy vz cv cB vz visset
      vy cv vz cv wceq vy cv cA wcel vz cv cA wcel c0r vy cv cltr wbr c0r vz cv
      cltr wbr vy cv vz cv cA eleq1 vy cv vz cv c0r cltr breq2 anbi12d
      suppsr3.1 elab2 pm3.26bi anim1i anim2i 19.22i imim2i imim2i a4s a1i
      anim12d vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv vx
      cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn
      wi wi vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy
      cv vz cv cltr wbr wa wa vz wex wi wi wa vy wal vy cv cnr wcel vy cv cB
      wcel vx cv vy cv cltr wbr wn wi wi vy wal vy cv cnr wcel vy cv vx cv cltr
      wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wi
      vy wal wa vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi vy cv
      vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy cv cnr wcel vy cv cB wcel vx cv vy cv cltr wbr wn wi wi
      vy cv cnr wcel vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy cv vz
      cv cltr wbr wa wa vz wex wi wi wa vy vy cv cnr wcel vy cv cB wcel vx cv
      vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cB wcel vy
      cv vz cv cltr wbr wa wa vz wex wi jcab albii vy cv cnr wcel vy cv cB wcel
      vx cv vy cv cltr wbr wn wi wi vy cv cnr wcel vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cB wcel vy cv vz cv cltr wbr wa wa vz wex wi wi vy 19.26
      bitri vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv
      cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex
      wi jcab 3imtr4g imp 19.21ai exp31 imdistand 19.22dv adantr mpd $.
      $( [20-May-1996] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    supsrlem.1 $e |- C e. R. $.

    $( Lemma for supremum theorem. $)
    supsrlem1 $p |- ( ( C +R ( A +R -1R ) ) e. R. <-> A e. R. ) $=
      cC cA cm1r cplr co cplr co cnr wcel cA cnr wcel cC cA cm1r cplr co cplr
      co cnr wcel cA cm1r cplr co cnr wcel cA cnr wcel cC cA cm1r cplr co cplr
      co cnr wcel cC cnr wcel cA cm1r cplr co cnr wcel cC cA cm1r cplr co cnr
      cplr cA cm1r cplr oprex dmaddsr 0nsr ndmoprrcl pm3.27d cA cm1r cplr co
      cnr wcel cA cnr wcel cm1r cnr wcel cA cm1r cnr cplr cm1r cnr m1r elisseti
      dmaddsr 0nsr ndmoprrcl pm3.26d syl cC cnr wcel cA cm1r cplr co cnr wcel
      cC cA cm1r cplr co cplr co cnr wcel cA cnr wcel cC cA cm1r cplr co
      addclsr supsrlem.1 cA cnr wcel cm1r cnr wcel cA cm1r cplr co cnr wcel m1r
      cA cm1r addclsr mpan2 sylancr impbii $.
      $( [20-May-1996] $)

    $( Lemma for supremum theorem. $)
    supsrlem2 $p |- ( A e. R. <->
                    E. x ( x e. R. /\ ( C +R ( x +R -1R ) ) = A ) ) $=
      cA cnr wcel vx cv cnr wcel cC vx cv cm1r cplr co cplr co cA wceq wa vx
      wex cA cnr wcel vx cv cnr wcel cA cm1r cmr co cC cplr co cm1r cplr co vx
      cv cplr co c0r wceq wa vx wex vx cv cnr wcel cC vx cv cm1r cplr co cplr
      co cA wceq wa vx wex cA cnr wcel cA cm1r cmr co cC cplr co cnr wcel cA
      cm1r cmr co cC cplr co cm1r cplr co cnr wcel vx cv cnr wcel cA cm1r cmr
      co cC cplr co cm1r cplr co vx cv cplr co c0r wceq wa vx wex cA cm1r cmr
      co cnr wcel cC cnr wcel cA cm1r cmr co cC cplr co cnr wcel cA cnr wcel cA
      cm1r cmr co cC addclsr cA cnr wcel cm1r cnr wcel cA cm1r cmr co cnr wcel
      m1r cA cm1r mulclsr mpan2 supsrlem.1 sylancl cA cm1r cmr co cC cplr co
      cnr wcel cm1r cnr wcel cA cm1r cmr co cC cplr co cm1r cplr co cnr wcel
      m1r cA cm1r cmr co cC cplr co cm1r addclsr mpan2 vx cA cm1r cmr co cC
      cplr co cm1r cplr co negexsr 3syl cA cnr wcel vx cv cnr wcel cA cm1r cmr
      co cC cplr co cm1r cplr co vx cv cplr co c0r wceq wa vx cv cnr wcel cC vx
      cv cm1r cplr co cplr co cA wceq wa vx cA cnr wcel vx cv cnr wcel cA cm1r
      cmr co cC cplr co cm1r cplr co vx cv cplr co c0r wceq cC vx cv cm1r cplr
      co cplr co cA wceq cA cnr wcel vx cv cnr wcel cA cm1r cmr co cC cplr co
      cm1r cplr co vx cv cplr co c0r wceq cC vx cv cm1r cplr co cplr co cA wceq
      wi cA cnr wcel vx cv cnr wcel wa cA cA cm1r cmr co cC vx cv cm1r cplr co
      cplr co cplr co cplr co cA c0r cplr co wceq cC vx cv cm1r cplr co cplr co
      cA wceq cA cm1r cmr co cC cplr co cm1r cplr co vx cv cplr co c0r wceq cA
      cnr wcel vx cv cnr wcel wa cA cA cm1r cmr co cC vx cv cm1r cplr co cplr
      co cplr co cplr co cC vx cv cm1r cplr co cplr co cA c0r cplr co cA cA cnr
      wcel vx cv cnr wcel wa cA cA cm1r cmr co cplr co cC vx cv cm1r cplr co
      cplr co cplr co cC vx cv cm1r cplr co cplr co cA cA cm1r cmr co cC vx cv
      cm1r cplr co cplr co cplr co cplr co cA cnr wcel vx cv cnr wcel cA cA
      cm1r cmr co cplr co cC vx cv cm1r cplr co cplr co cplr co c0r cC vx cv
      cm1r cplr co cplr co cplr co cC vx cv cm1r cplr co cplr co cA cnr wcel cA
      cA cm1r cmr co cplr co c0r cC vx cv cm1r cplr co cplr co cplr cA pn0sr
      opreq1d vx cv cnr wcel cC vx cv cm1r cplr co cplr co c0r cplr co cC vx cv
      cm1r cplr co cplr co c0r cC vx cv cm1r cplr co cplr co cplr co vx cv cnr
      wcel cC cnr wcel vx cv cm1r cplr co cnr wcel wa cC vx cv cm1r cplr co
      cplr co cnr wcel cC vx cv cm1r cplr co cplr co c0r cplr co cC vx cv cm1r
      cplr co cplr co wceq vx cv cnr wcel vx cv cm1r cplr co cnr wcel cC cnr
      wcel vx cv cnr wcel cm1r cnr wcel vx cv cm1r cplr co cnr wcel m1r vx cv
      cm1r addclsr mpan2 supsrlem.1 jctil cC vx cv cm1r cplr co addclsr cC vx
      cv cm1r cplr co cplr co 0idsr 3syl cC vx cv cm1r cplr co cplr co c0r cC
      vx cv cm1r cplr co cplr oprex c0r cnr 0r elisseti addcomsr syl5eqr
      sylan9eq cA cA cm1r cmr co cC vx cv cm1r cplr co cplr co cA cm1r cmr
      oprex cC vx cv cm1r cplr co cplr oprex addasssr syl5eqr cA cnr wcel cA
      c0r cplr co cA wceq vx cv cnr wcel cA 0idsr adantr eqeq12d cA cm1r cmr co
      cC cplr co cm1r cplr co vx cv cplr co c0r wceq cA cm1r cmr co cC vx cv
      cm1r cplr co cplr co cplr co c0r wceq cA cA cm1r cmr co cC vx cv cm1r
      cplr co cplr co cplr co cplr co cA c0r cplr co wceq cA cm1r cmr co cC
      cplr co cm1r cplr co vx cv cplr co cA cm1r cmr co cC vx cv cm1r cplr co
      cplr co cplr co c0r cA cm1r cmr co cC cplr co cm1r cplr co vx cv cplr co
      cA cm1r cmr co cC cplr co cm1r vx cv cplr co cplr co cA cm1r cmr co cC
      cplr co vx cv cm1r cplr co cplr co cA cm1r cmr co cC vx cv cm1r cplr co
      cplr co cplr co cA cm1r cmr co cC cplr co cm1r vx cv cm1r cnr m1r
      elisseti vx visset addasssr cm1r vx cv cplr co vx cv cm1r cplr co cA cm1r
      cmr co cC cplr co cplr cm1r vx cv cm1r cnr m1r elisseti vx visset
      addcomsr opreq2i cA cm1r cmr co cC vx cv cm1r cplr co cC cnr supsrlem.1
      elisseti vx cv cm1r cplr oprex addasssr 3eqtri eqeq1i cA cm1r cmr co cC
      vx cv cm1r cplr co cplr co cplr co c0r cA cplr opreq2 sylbi syl5bi ex
      imdistand 19.22dv mpd vx cv cnr wcel cC vx cv cm1r cplr co cplr co cA
      wceq wa cA cnr wcel vx cC vx cv cm1r cplr co cplr co cA wceq vx cv cnr
      wcel cA cnr wcel cC vx cv cm1r cplr co cplr co cA wceq cC vx cv cm1r cplr
      co cplr co cnr wcel cA cnr wcel vx cv cnr wcel cC vx cv cm1r cplr co cplr
      co cA cnr eleq1 cC cnr wcel vx cv cm1r cplr co cnr wcel cC vx cv cm1r
      cplr co cplr co cnr wcel vx cv cnr wcel cC vx cv cm1r cplr co addclsr
      supsrlem.1 vx cv cnr wcel cm1r cnr wcel vx cv cm1r cplr co cnr wcel m1r
      vx cv cm1r addclsr mpan2 sylancr syl5bi impcom 19.23aiv impbii $.
      $( [21-May-1996] $)

    ${
      supsrlem3.2 $e |- A e. _V $.
      supsrlem3.3 $e |- B e. _V $.
      $( Lemma for supremum theorem. $)
      supsrlem3 $p |- ( ( C +R ( A +R -1R ) ) <R ( C +R ( B +R -1R ) )
                      <-> A <R B ) $=
        cA cB cltr wbr cA cm1r cplr co cB cm1r cplr co cltr wbr cC cA cm1r cplr
        co cplr co cC cB cm1r cplr co cplr co cltr wbr cm1r cnr wcel cA cB cltr
        wbr cA cm1r cplr co cB cm1r cplr co cltr wbr wb m1r vx vy vz cA cB cm1r
        cltr cnr cplr supsrlem3.2 supsrlem3.3 vx cv vy cv vz cv vx visset vy
        visset ltasr cm1r cnr m1r elisseti vx cv vy cv vx visset vy visset
        addcomsr caoprord2 ax-mp cC cnr wcel cA cm1r cplr co cB cm1r cplr co
        cltr wbr cC cA cm1r cplr co cplr co cC cB cm1r cplr co cplr co cltr wbr
        wb supsrlem.1 cA cm1r cplr co cB cm1r cplr co cC cA cm1r cplr oprex cB
        cm1r cplr oprex ltasr ax-mp bitr2i $.
        $( [21-May-1996] $)
    $}

    ${
      supsrlem.2 $e |- B = { w | ( C +R ( w +R -1R ) ) e. A } $.
      ${
        $d x D $.
        supsrlem4.1 $e |- D e. _V $.
        $( Lemma for supremum theorem. $)
        supsrlem4 $p |- ( D e. B <-> ( C +R ( D +R -1R ) ) e. A ) $=
          cC vx cv cm1r cplr co cplr co cA wcel cC cD cm1r cplr co cplr co cA
          wcel vx cD cB supsrlem4.1 vx cv cD wceq cC vx cv cm1r cplr co cplr co
          cC cD cm1r cplr co cplr co cA vx cv cD wceq vx cv cm1r cplr co cD
          cm1r cplr co cC cplr vx cv cD cm1r cplr opreq1 opreq2d eleq1d cB cC
          vw cv cm1r cplr co cplr co cA wcel vw cab cC vx cv cm1r cplr co cplr
          co cA wcel vx cab supsrlem.2 cC vw cv cm1r cplr co cplr co cA wcel cC
          vx cv cm1r cplr co cplr co cA wcel vw vx vw cv vx cv wceq cC vw cv
          cm1r cplr co cplr co cC vx cv cm1r cplr co cplr co cA vw cv vx cv
          wceq vw cv cm1r cplr co vx cv cm1r cplr co cC cplr vw cv vx cv cm1r
          cplr opreq1 opreq2d eleq1d cbvabv eqtri elab2 $.
          $( [21-May-1996] $)
      $}

      $( Lemma for supremum theorem. $)
      supsrlem5 $p |- ( C e. A -> E. y ( y e. B /\ 0R <R y ) ) $=
        cC cA wcel c1r cB wcel c0r c1r cltr wbr wa vy cv cB wcel c0r vy cv cltr
        wbr wa vy wex c1r cB wcel cC c1r cm1r cplr co cplr co cA wcel c1r cB
        wcel c0r c1r cltr wbr wa cC cA wcel vw cA cB cC c1r supsrlem.1
        supsrlem.2 c1r cnr 1r elisseti supsrlem4 c0r c1r cltr wbr c1r cB wcel
        0lt1sr biantru cC c1r cm1r cplr co cplr co cC cA cC c1r cm1r cplr co
        cplr co cC c0r cplr co cC c1r cm1r cplr co c0r cC cplr c1r cm1r cplr co
        cm1r c1r cplr co c0r c1r cm1r c1r cnr 1r elisseti cm1r cnr m1r elisseti
        addcomsr m1p1sr eqtri opreq2i cC cnr wcel cC c0r cplr co cC wceq
        supsrlem.1 cC 0idsr ax-mp eqtri eleq1i 3bitr3i vy cv cB wcel c0r vy cv
        cltr wbr wa c1r cB wcel c0r c1r cltr wbr wa vy c1r c1r cnr 1r elisseti
        vy cv c1r wceq vy cv cB wcel c1r cB wcel c0r vy cv cltr wbr c0r c1r
        cltr wbr vy cv c1r cB eleq1 vy cv c1r c0r cltr breq2 anbi12d cla4ev
        sylbir $.
        $( [21-May-1996] $)

      $( Lemma for supremum theorem. $)
      supsrlem6 $p |- ( ( C e. A /\
         E. x ( x e. R. /\ A. y ( y e. R. -> ( y e. A -> y <R x ) ) ) ) ->
       E. x ( x e. R. /\ A. y ( y e. R. -> ( ( y e. A -> -. x <R y ) /\
           ( y <R x -> E. z ( z e. R. /\ ( z e. A /\ y <R z ) ) ) ) ) ) ) $=
        vv cv cB wcel c0r vv cv cltr wbr wa vv wex vx cv cnr wcel vy cv cnr
        wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv
        cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv
        vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa
        vz wex wi wa wi vy wal wa vx wex cC cA wcel vv cv cB wcel c0r vv cv
        cltr wbr wa vv wex vw cv cnr wcel vv cv cnr wcel vv cv cB wcel vv cv vw
        cv cltr wbr wi wi vv wal wa vw wex vx cv cnr wcel vy cv cnr wcel vy cv
        cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel
        vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx
        wex vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi
        wi vy wal wa vx wex vv cv cB wcel c0r vv cv cltr wbr wa vv wex vw cv
        cnr wcel vv cv cnr wcel vv cv cB wcel vv cv vw cv cltr wbr wi wi vv wal
        wa vw wex wa vw cv cnr wcel vv cv cnr wcel vv cv cB wcel vw cv vv cv
        cltr wbr wn wi vv cv vw cv cltr wbr vu cv cnr wcel vu cv cB wcel vv cv
        vu cv cltr wbr wa wa vu wex wi wa wi vv wal wa vw wex vx cv cnr wcel vy
        cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr
        wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi
        wa wi vy wal wa vx wex vw vv vu cB vx cv cB wcel c0r vx cv cltr wbr wa
        vx cab vx cv cB wcel c0r vx cv cltr wbr wa vv cv cB wcel c0r vv cv cltr
        wbr wa vx vv vx cv vv cv wceq vx cv cB wcel vv cv cB wcel c0r vx cv
        cltr wbr c0r vv cv cltr wbr vx cv vv cv cB eleq1 vx cv vv cv c0r cltr
        breq2 anbi12d cbvabv suppsr3 vv cv cnr wcel vv cv cB wcel vw cv vv cv
        cltr wbr wn wi vv cv vw cv cltr wbr vu cv cnr wcel vu cv cB wcel vv cv
        vu cv cltr wbr wa wa vu wex wi wa wi vv wal vy cv cnr wcel vy cv cA
        wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz
        cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal vw cv cnr
        wcel vx cv cnr wcel vw vx cC vw cv cm1r cplr co cplr co cC vw cv cm1r
        cplr co cplr oprex cC vw cv cm1r cplr co cplr co vx cv wceq vy cv cnr
        wcel vy cv cA wcel cC vw cv cm1r cplr co cplr co vy cv cltr wbr wn wi
        vy cv cC vw cv cm1r cplr co cplr co cltr wbr vz cv cnr wcel vz cv cA
        wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal vy cv cnr wcel
        vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr
        wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal vv
        cv cnr wcel vv cv cB wcel vw cv vv cv cltr wbr wn wi vv cv vw cv cltr
        wbr vu cv cnr wcel vu cv cB wcel vv cv vu cv cltr wbr wa wa vu wex wi
        wa wi vv wal cC vw cv cm1r cplr co cplr co vx cv wceq vy cv cnr wcel vy
        cv cA wcel cC vw cv cm1r cplr co cplr co vy cv cltr wbr wn wi vy cv cC
        vw cv cm1r cplr co cplr co cltr wbr vz cv cnr wcel vz cv cA wcel vy cv
        vz cv cltr wbr wa wa vz wex wi wa wi vy cv cnr wcel vy cv cA wcel vx cv
        vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel
        vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy cC vw cv cm1r cplr co
        cplr co vx cv wceq vy cv cA wcel cC vw cv cm1r cplr co cplr co vy cv
        cltr wbr wn wi vy cv cC vw cv cm1r cplr co cplr co cltr wbr vz cv cnr
        wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa vy cv cA
        wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz
        cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa vy cv cnr wcel cC vw
        cv cm1r cplr co cplr co vx cv wceq vy cv cA wcel cC vw cv cm1r cplr co
        cplr co vy cv cltr wbr wn wi vy cv cA wcel vx cv vy cv cltr wbr wn wi
        vy cv cC vw cv cm1r cplr co cplr co cltr wbr vz cv cnr wcel vz cv cA
        wcel vy cv vz cv cltr wbr wa wa vz wex wi vy cv vx cv cltr wbr vz cv
        cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi cC vw cv
        cm1r cplr co cplr co vx cv wceq cC vw cv cm1r cplr co cplr co vy cv
        cltr wbr wn vx cv vy cv cltr wbr wn vy cv cA wcel cC vw cv cm1r cplr co
        cplr co vx cv wceq cC vw cv cm1r cplr co cplr co vy cv cltr wbr vx cv
        vy cv cltr wbr cC vw cv cm1r cplr co cplr co vx cv vy cv cltr breq1
        notbid imbi2d cC vw cv cm1r cplr co cplr co vx cv wceq vy cv cC vw cv
        cm1r cplr co cplr co cltr wbr vy cv vx cv cltr wbr vz cv cnr wcel vz cv
        cA wcel vy cv vz cv cltr wbr wa wa vz wex cC vw cv cm1r cplr co cplr co
        vx cv vy cv cltr breq2 imbi1d anbi12d imbi2d albidv vv cv cB wcel vw cv
        vv cv cltr wbr wn wi vv cv vw cv cltr wbr vu cv cnr wcel vu cv cB wcel
        vv cv vu cv cltr wbr wa wa vu wex wi wa vy cv cA wcel cC vw cv cm1r
        cplr co cplr co vy cv cltr wbr wn wi vy cv cC vw cv cm1r cplr co cplr
        co cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
        wex wi wa vv cv cnr wcel vy cv cnr wcel vv vy cC vv cv cm1r cplr co
        cplr co cC vv cv cm1r cplr co cplr oprex cC vv cv cm1r cplr co cplr co
        vy cv wceq vv cv cB wcel vw cv vv cv cltr wbr wn wi vy cv cA wcel cC vw
        cv cm1r cplr co cplr co vy cv cltr wbr wn wi vv cv vw cv cltr wbr vu cv
        cnr wcel vu cv cB wcel vv cv vu cv cltr wbr wa wa vu wex wi vy cv cC vw
        cv cm1r cplr co cplr co cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz
        cv cltr wbr wa wa vz wex wi cC vv cv cm1r cplr co cplr co vy cv wceq vv
        cv cB wcel vy cv cA wcel vw cv vv cv cltr wbr wn cC vw cv cm1r cplr co
        cplr co vy cv cltr wbr wn cC vv cv cm1r cplr co cplr co vy cv wceq cC
        vv cv cm1r cplr co cplr co cA wcel vy cv cA wcel vv cv cB wcel cC vv cv
        cm1r cplr co cplr co vy cv cA eleq1 vw cA cB cC vv cv supsrlem.1
        supsrlem.2 vv visset supsrlem4 syl5bb cC vv cv cm1r cplr co cplr co vy
        cv wceq vw cv vv cv cltr wbr cC vw cv cm1r cplr co cplr co vy cv cltr
        wbr cC vv cv cm1r cplr co cplr co vy cv wceq cC vw cv cm1r cplr co cplr
        co cC vv cv cm1r cplr co cplr co cltr wbr cC vw cv cm1r cplr co cplr co
        vy cv cltr wbr vw cv vv cv cltr wbr cC vv cv cm1r cplr co cplr co vy cv
        cC vw cv cm1r cplr co cplr co cltr breq2 vw cv vv cv cC supsrlem.1 vw
        visset vv visset supsrlem3 syl5bbr notbid imbi12d cC vv cv cm1r cplr co
        cplr co vy cv wceq vv cv vw cv cltr wbr vy cv cC vw cv cm1r cplr co
        cplr co cltr wbr vu cv cnr wcel vu cv cB wcel vv cv vu cv cltr wbr wa
        wa vu wex vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
        wex cC vv cv cm1r cplr co cplr co vy cv wceq cC vv cv cm1r cplr co cplr
        co cC vw cv cm1r cplr co cplr co cltr wbr vy cv cC vw cv cm1r cplr co
        cplr co cltr wbr vv cv vw cv cltr wbr cC vv cv cm1r cplr co cplr co vy
        cv cC vw cv cm1r cplr co cplr co cltr breq1 vv cv vw cv cC supsrlem.1
        vv visset vw visset supsrlem3 syl5bbr cC vv cv cm1r cplr co cplr co vy
        cv wceq vz cv cnr wcel vz cv cA wcel cC vv cv cm1r cplr co cplr co vz
        cv cltr wbr wa wa vz wex vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr
        wbr wa wa vz wex vu cv cnr wcel vu cv cB wcel vv cv vu cv cltr wbr wa
        wa vu wex cC vv cv cm1r cplr co cplr co vy cv wceq vz cv cnr wcel vz cv
        cA wcel cC vv cv cm1r cplr co cplr co vz cv cltr wbr wa wa vz cv cnr
        wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz cC vv cv cm1r cplr co
        cplr co vy cv wceq vz cv cA wcel cC vv cv cm1r cplr co cplr co vz cv
        cltr wbr wa vz cv cA wcel vy cv vz cv cltr wbr wa vz cv cnr wcel cC vv
        cv cm1r cplr co cplr co vy cv wceq cC vv cv cm1r cplr co cplr co vz cv
        cltr wbr vy cv vz cv cltr wbr vz cv cA wcel cC vv cv cm1r cplr co cplr
        co vy cv vz cv cltr breq1 anbi2d anbi2d exbidv vu cv cB wcel vv cv vu
        cv cltr wbr wa vz cv cA wcel cC vv cv cm1r cplr co cplr co vz cv cltr
        wbr wa vu cv cnr wcel vz cv cnr wcel vu vz cC vu cv cm1r cplr co cplr
        co cC vu cv cm1r cplr co cplr oprex cC vu cv cm1r cplr co cplr co vz cv
        wceq vu cv cB wcel vz cv cA wcel vv cv vu cv cltr wbr cC vv cv cm1r
        cplr co cplr co vz cv cltr wbr cC vu cv cm1r cplr co cplr co vz cv wceq
        cC vu cv cm1r cplr co cplr co cA wcel vz cv cA wcel vu cv cB wcel cC vu
        cv cm1r cplr co cplr co vz cv cA eleq1 vw cA cB cC vu cv supsrlem.1
        supsrlem.2 vu visset supsrlem4 syl5bb cC vu cv cm1r cplr co cplr co vz
        cv wceq cC vv cv cm1r cplr co cplr co cC vu cv cm1r cplr co cplr co
        cltr wbr cC vv cv cm1r cplr co cplr co vz cv cltr wbr vv cv vu cv cltr
        wbr cC vu cv cm1r cplr co cplr co vz cv cC vv cv cm1r cplr co cplr co
        cltr breq2 vv cv vu cv cC supsrlem.1 vv visset vu visset supsrlem3
        syl5bbr anbi12d cC vu cv cm1r cplr co cplr co vz cv wceq cC vu cv cm1r
        cplr co cplr co cnr wcel vz cv cnr wcel vu cv cnr wcel cC vu cv cm1r
        cplr co cplr co vz cv cnr eleq1 vu cv cC supsrlem.1 supsrlem1 syl5bbr
        vu vz cv cC supsrlem.1 supsrlem2 gencbvex syl5bb imbi12d anbi12d cC vv
        cv cm1r cplr co cplr co vy cv wceq cC vv cv cm1r cplr co cplr co cnr
        wcel vy cv cnr wcel vv cv cnr wcel cC vv cv cm1r cplr co cplr co vy cv
        cnr eleq1 vv cv cC supsrlem.1 supsrlem1 syl5bbr vv vy cv cC supsrlem.1
        supsrlem2 gencbval syl5bb cC vw cv cm1r cplr co cplr co vx cv wceq cC
        vw cv cm1r cplr co cplr co cnr wcel vx cv cnr wcel vw cv cnr wcel cC vw
        cv cm1r cplr co cplr co vx cv cnr eleq1 vw cv cC supsrlem.1 supsrlem1
        syl5bbr vw vx cv cC supsrlem.1 supsrlem2 gencbvex sylib vv cv cnr wcel
        vv cv cB wcel vv cv vw cv cltr wbr wi wi vv wal vy cv cnr wcel vy cv cA
        wcel vy cv vx cv cltr wbr wi wi vy wal vw cv cnr wcel vx cv cnr wcel vw
        vx cC vw cv cm1r cplr co cplr co cC vw cv cm1r cplr co cplr oprex cC vw
        cv cm1r cplr co cplr co vx cv wceq vy cv cnr wcel vy cv cA wcel vy cv
        cC vw cv cm1r cplr co cplr co cltr wbr wi wi vy wal vy cv cnr wcel vy
        cv cA wcel vy cv vx cv cltr wbr wi wi vy wal vv cv cnr wcel vv cv cB
        wcel vv cv vw cv cltr wbr wi wi vv wal cC vw cv cm1r cplr co cplr co vx
        cv wceq vy cv cnr wcel vy cv cA wcel vy cv cC vw cv cm1r cplr co cplr
        co cltr wbr wi wi vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi
        wi vy cC vw cv cm1r cplr co cplr co vx cv wceq vy cv cA wcel vy cv cC
        vw cv cm1r cplr co cplr co cltr wbr wi vy cv cA wcel vy cv vx cv cltr
        wbr wi vy cv cnr wcel cC vw cv cm1r cplr co cplr co vx cv wceq vy cv cC
        vw cv cm1r cplr co cplr co cltr wbr vy cv vx cv cltr wbr vy cv cA wcel
        cC vw cv cm1r cplr co cplr co vx cv vy cv cltr breq2 imbi2d imbi2d
        albidv vv cv cB wcel vv cv vw cv cltr wbr wi vy cv cA wcel vy cv cC vw
        cv cm1r cplr co cplr co cltr wbr wi vv cv cnr wcel vy cv cnr wcel vv vy
        cC vv cv cm1r cplr co cplr co cC vv cv cm1r cplr co cplr oprex cC vv cv
        cm1r cplr co cplr co vy cv wceq vv cv cB wcel vy cv cA wcel vv cv vw cv
        cltr wbr vy cv cC vw cv cm1r cplr co cplr co cltr wbr cC vv cv cm1r
        cplr co cplr co vy cv wceq cC vv cv cm1r cplr co cplr co cA wcel vy cv
        cA wcel vv cv cB wcel cC vv cv cm1r cplr co cplr co vy cv cA eleq1 vw
        cA cB cC vv cv supsrlem.1 supsrlem.2 vv visset supsrlem4 syl5bb cC vv
        cv cm1r cplr co cplr co vy cv wceq cC vv cv cm1r cplr co cplr co cC vw
        cv cm1r cplr co cplr co cltr wbr vy cv cC vw cv cm1r cplr co cplr co
        cltr wbr vv cv vw cv cltr wbr cC vv cv cm1r cplr co cplr co vy cv cC vw
        cv cm1r cplr co cplr co cltr breq1 vv cv vw cv cC supsrlem.1 vv visset
        vw visset supsrlem3 syl5bbr imbi12d cC vv cv cm1r cplr co cplr co vy cv
        wceq cC vv cv cm1r cplr co cplr co cnr wcel vy cv cnr wcel vv cv cnr
        wcel cC vv cv cm1r cplr co cplr co vy cv cnr eleq1 vv cv cC supsrlem.1
        supsrlem1 syl5bbr vv vy cv cC supsrlem.1 supsrlem2 gencbval syl5bb cC
        vw cv cm1r cplr co cplr co vx cv wceq cC vw cv cm1r cplr co cplr co cnr
        wcel vx cv cnr wcel vw cv cnr wcel cC vw cv cm1r cplr co cplr co vx cv
        cnr eleq1 vw cv cC supsrlem.1 supsrlem1 syl5bbr vw vx cv cC supsrlem.1
        supsrlem2 gencbvex sylan2br vv vw cA cB cC supsrlem.1 supsrlem.2
        supsrlem5 sylan $.
        $( [21-May-1996] $)
    $}
  $}

  ${
    $d x y z w v u A $.
    $( A non-empty, bounded set of signed reals has a supremum. $)
    supsr $p |- ( ( ( A C_ R. /\ -. A = (/) ) /\ E. x ( x e. R. /\
                     A. y ( y e. R. -> ( y e. A -> y <R x ) ) ) ) ->
       E. x ( x e. R. /\ A. y ( y e. R. -> ( ( y e. A -> -. x <R y ) /\
           ( y <R x -> E. z ( z e. R. /\ ( z e. A /\ y <R z ) ) ) ) ) ) ) $=
      cA cnr wss cA c0 wceq wn vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy
      cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv cnr wcel vy cv cnr wcel vy
      cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel
      vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex
      cA cnr wss vw cv cA wcel vw wex vx cv cnr wcel vy cv cnr wcel vy cv cA
      wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv cnr wcel vy cv cnr
      wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal
      wa vx wex wi cA c0 wceq wn cA cnr wss vw cv cA wcel vx cv cnr wcel vy cv
      cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv
      cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx
      cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal wa vx wex wi vw vw cv cA wcel cA cnr wss vw cv cnr
      wcel vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi
      wi vy wal wa vx wex vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy
      cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv
      vz cv cltr wbr wa wa vz wex wi wa wi vy wal wa vx wex wi cA cnr vw cv
      ssel vw cv cnr wcel vw cv cA wcel vx cv cnr wcel vy cv cnr wcel vy cv cA
      wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv cnr wcel vy cv cnr
      wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx cv cltr wbr vz cv
      cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz wex wi wa wi vy wal
      wa vx wex wi wi vw cv cnr wcel vw cv c0r cif cA wcel vx cv cnr wcel vy cv
      cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex vx cv
      cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy cv vx
      cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa vz
      wex wi wa wi vy wal wa vx wex wi wi vw cv c0r vw cv vw cv cnr wcel vw cv
      c0r cif wceq vw cv cA wcel vw cv cnr wcel vw cv c0r cif cA wcel vx cv cnr
      wcel vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx
      wex vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn
      wi vy cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr
      wa wa vz wex wi wa wi vy wal wa vx wex wi vw cv vw cv cnr wcel vw cv c0r
      cif cA eleq1 imbi1d vw cv cnr wcel vw cv c0r cif cA wcel vx cv cnr wcel
      vy cv cnr wcel vy cv cA wcel vy cv vx cv cltr wbr wi wi vy wal wa vx wex
      vx cv cnr wcel vy cv cnr wcel vy cv cA wcel vx cv vy cv cltr wbr wn wi vy
      cv vx cv cltr wbr vz cv cnr wcel vz cv cA wcel vy cv vz cv cltr wbr wa wa
      vz wex wi wa wi vy wal wa vx wex vx vy vz vu cA vw cv cnr wcel vw cv c0r
      cif vv cv cm1r cplr co cplr co cA wcel vv cab vw cv cnr wcel vw cv c0r
      cif vw cv c0r cnr 0r elimel vw cv cnr wcel vw cv c0r cif vv cv cm1r cplr
      co cplr co cA wcel vw cv cnr wcel vw cv c0r cif vu cv cm1r cplr co cplr
      co cA wcel vv vu vv cv vu cv wceq vw cv cnr wcel vw cv c0r cif vv cv cm1r
      cplr co cplr co vw cv cnr wcel vw cv c0r cif vu cv cm1r cplr co cplr co
      cA vv cv vu cv wceq vv cv cm1r cplr co vu cv cm1r cplr co vw cv cnr wcel
      vw cv c0r cif cplr vv cv vu cv cm1r cplr opreq1 opreq2d eleq1d cbvabv
      supsrlem6 ex dedth syli 19.23adv vw cA neq0 syl5ib imp31 $.
      $( [21-May-1996] $)
  $}


  $(
  Digit strings will usually be unambigous without whitespace (for better
  readability) although we will separate digits, at least initially in our
  development, to emphasize that they are separate Metamath tokens.
  $)

  $( Class of complex numbers. $)
  cc $a class CC $.
  $( Class of real numbers. $)
  cr $a class RR $.
  $( Extend class notation to include the complex number 0. $)
  cc0 $a class 0 $.
  $( Extend class notation to include the complex number 1. $)
  c1 $a class 1 $.
  $( Extend class notation to include the complex number i. $)
  ci $a class _i $.
  $( Addition on complex numbers. $)
  caddc $a class + $.
  $( 'Less than' predicate (defined over real subset of complex numbers). $)
  cltrr $a class <RR $.
  $( Multiplication on complex numbers.  The token ` x. ` is a center dot. $)
  cmul $a class x. $.

  $( Define the set of complex numbers.  The 25 axioms for complex numbers
     start at ~ axcnex . $)
  df-c $a |- CC = ( R. X. R. ) $.

  $( Define the complex number 0 (base 10). $)
  df-0 $a |- 0 = <. 0R , 0R >. $.

  $( Define the complex number 1 (base 10). $)
  df-1 $a |- 1 = <. 1R , 0R >. $.

  $( Define the complex number ` _i ` (the imaginary unit). $)
  df-i $a |- _i = <. 0R , 1R >. $.

  ${
    $d x y $.
    $( Define the set of real numbers. $)
    df-r $a |- RR = ( R. X. { 0R } ) $.
  $}

  ${
    $d x y z w v u f $.

    $( Define addition over complex numbers. $)
    df-plus $a |- + = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. CC ) /\
                  E. w E. v E. u E. f ( ( x = <. w , v >. /\ y = <. u , f >. )
                  /\ z = <. ( w +R u ) , ( v +R f ) >. ) ) } $.

    $( Define multiplication over complex numbers. $)
    df-mul $a |- x. = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. CC ) /\
               E. w E. v E. u E. f ( ( x = <. w , v >. /\ y = <. u , f >. )
                  /\ z = <. ( ( w .R u ) +R ( -1R .R ( v .R f ) ) ) ,
                  ( ( v .R u ) +R ( w .R f ) ) >. ) ) } $.

    $( Define 'less than' on the real subset of complex numbers. $)
    df-lt $a |- <RR = { <. x , y >. | ( ( x e. RR /\ y e. RR ) /\
     E. z E. w ( ( x = <. z , 0R >. /\ y = <. w , 0R >. ) /\ z <R w ) ) } $.
  $}

  ${
    opelcn.1 $e |- B e. _V $.
    $( Ordered pair membership in the class of complex numbers. $)
    opelcn $p |- ( <. A , B >. e. CC <-> ( A e. R. /\ B e. R. ) ) $=
      cA cB cop cc wcel cA cB cop cnr cnr cxp wcel cA cnr wcel cB cnr wcel wa
      cc cnr cnr cxp cA cB cop df-c eleq2i cA cB cnr cnr opelcn.1 opelxp bitri
      $.
      $( [14-May-1996] $)
  $}

  $( Ordered pair membership in class of real subset of complex numbers. $)
  opelreal $p |- ( <. A , 0R >. e. RR <-> A e. R. ) $=
    cA c0r cop cr wcel cA cnr wcel c0r c0r wceq cA c0r cop cr wcel cA c0r cop
    cnr c0r csn cxp wcel cA cnr wcel c0r c0r csn wcel wa cA cnr wcel c0r c0r
    wceq wa cr cnr c0r csn cxp cA c0r cop df-r eleq2i cA c0r cnr c0r csn c0r
    cnr 0r elisseti opelxp c0r c0r csn wcel c0r c0r wceq cA cnr wcel c0r c0r
    c0r cnr 0r elisseti elsnc anbi2i 3bitri c0r eqid mpbiran2 $.
    $( [22-Feb-1996] $)

  ${
    $d x y A $.
    $( Membership in class of real numbers. $)
    elreal $p |- ( A e. RR <-> E. x ( x e. R. /\ <. x , 0R >. = A ) ) $=
      cA cr wcel cA cnr c0r csn cxp wcel cA vx cv vy cv cop wceq vx cv cnr wcel
      vy cv c0r csn wcel wa wa vy wex vx wex vx cv cnr wcel vx cv c0r cop cA
      wceq wa vx wex cr cnr c0r csn cxp cA df-r eleq2i vx vy cA cnr c0r csn
      elxp cA vx cv vy cv cop wceq vx cv cnr wcel vy cv c0r csn wcel wa wa vy
      wex vx cv cnr wcel vx cv c0r cop cA wceq wa vx cA vx cv vy cv cop wceq vx
      cv cnr wcel vy cv c0r csn wcel wa wa vy wex vy cv c0r wceq vy wex vx cv
      cnr wcel vx cv c0r cop cA wceq wa cA vx cv vy cv cop wceq vx cv cnr wcel
      vy cv c0r csn wcel wa wa vy wex vy cv c0r wceq vx cv cnr wcel vx cv c0r
      cop cA wceq wa wa vy wex vy cv c0r wceq vy wex vx cv cnr wcel vx cv c0r
      cop cA wceq wa wa cA vx cv vy cv cop wceq vx cv cnr wcel vy cv c0r csn
      wcel wa wa vy cv c0r wceq vx cv cnr wcel vx cv c0r cop cA wceq wa wa vy
      cA vx cv vy cv cop wceq vx cv cnr wcel vy cv c0r csn wcel wa wa vx cv cnr
      wcel vy cv c0r csn wcel wa cA vx cv vy cv cop wceq wa vy cv c0r wceq vx
      cv cnr wcel vx cv c0r cop cA wceq wa wa cA vx cv vy cv cop wceq vx cv cnr
      wcel vy cv c0r csn wcel wa ancom vx cv cnr wcel vy cv c0r csn wcel wa cA
      vx cv vy cv cop wceq wa vx cv cnr wcel vy cv c0r csn wcel cA vx cv vy cv
      cop wceq wa wa vx cv cnr wcel vy cv c0r wceq vx cv c0r cop cA wceq wa wa
      vy cv c0r wceq vx cv cnr wcel vx cv c0r cop cA wceq wa wa vx cv cnr wcel
      vy cv c0r csn wcel cA vx cv vy cv cop wceq anass vy cv c0r csn wcel cA vx
      cv vy cv cop wceq wa vy cv c0r wceq vx cv c0r cop cA wceq wa vx cv cnr
      wcel vy cv c0r csn wcel cA vx cv vy cv cop wceq wa vy cv c0r wceq vx cv
      vy cv cop cA wceq wa vy cv c0r wceq vx cv c0r cop cA wceq wa vy cv c0r
      csn wcel vy cv c0r wceq cA vx cv vy cv cop wceq vx cv vy cv cop cA wceq
      vy c0r elsn cA vx cv vy cv cop eqcom anbi12i vy cv c0r wceq vx cv vy cv
      cop cA wceq vx cv c0r cop cA wceq vy cv c0r wceq vx cv vy cv cop vx cv
      c0r cop cA vy cv c0r vx cv opeq2 eqeq1d pm5.32i bitri anbi2i vx cv cnr
      wcel vy cv c0r wceq vx cv c0r cop cA wceq an12 3bitri bitri exbii vy cv
      c0r wceq vx cv cnr wcel vx cv c0r cop cA wceq wa vy 19.41v bitri vy c0r
      c0r cnr 0r elisseti isseti mpbiran exbii 3bitri $.
      $( [31-Mar-1996] $)
  $}

  $( The empty set is not a complex number.  Note: do not use this after the
     real number axioms are developed, since it is a construction-dependent
     property. $)
  0ncn $p |- -. (/) e. CC $=
    c0 cc wcel c0 cnr cnr cxp wcel cnr cnr 0nelxp cc cnr cnr cxp c0 df-c eleq2i
    mtbir $.
    $( [2-May-1996] $)

  ${
    $d x y z w $.
    $( 'Less than' is a relation on real numbers. $)
    ltrelre $p |- <RR C_ ( RR X. RR ) $=
      cltrr vx cv cr wcel vy cv cr wcel wa vx cv vz cv c0r cop wceq vy cv vw cv
      c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz wex wa vx vy copab cr
      cr cxp vx vy vz vw df-lt vx cv vz cv c0r cop wceq vy cv vw cv c0r cop
      wceq wa vz cv vw cv cltr wbr wa vw wex vz wex vx vy cr cr opabssxp
      eqsstri $.
      $( [22-Feb-1996] $)
  $}

  ${
    $d x y z w v u f A $.  $d x y z w v u f B $.  $d x y z w v u f C $.
    $d x y z w v u f D $.
    $( Addition of complex numbers in terms of signed reals. $)
    addcnsr $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
           ( <. A , B >. + <. C , D >. ) = <. ( A +R C ) , ( B +R D ) >. ) $=
      vx vy vz vw vv vu cA cB cC cD vw cv vu cv cplr co vv cv vf cv cplr co cop
      cA cC cplr co cB cD cplr co cop vf caddc cnr cA cC cplr co cB cD cplr co
      opex vw cv cA wceq vv cv cB wceq wa vu cv cC wceq vf cv cD wceq wa vw cv
      vu cv cplr co vv cv vf cv cplr co cop cA vu cv cplr co cB vf cv cplr co
      cop cA cC cplr co cB cD cplr co cop vw cv vu cv cplr co cA vu cv cplr co
      wceq vv cv vf cv cplr co cB vf cv cplr co wceq vw cv vu cv cplr co vv cv
      vf cv cplr co cop cA vu cv cplr co cB vf cv cplr co cop wceq vw cv cA
      wceq vv cv cB wceq vw cv vu cv cplr co vv cv vf cv cplr co cA vu cv cplr
      co cB vf cv cplr co opeq12 vw cv cA vu cv cplr opreq1 vv cv cB vf cv cplr
      opreq1 syl2an cA vu cv cplr co cA cC cplr co wceq cB vf cv cplr co cB cD
      cplr co wceq cA vu cv cplr co cB vf cv cplr co cop cA cC cplr co cB cD
      cplr co cop wceq vu cv cC wceq vf cv cD wceq cA vu cv cplr co cB vf cv
      cplr co cA cC cplr co cB cD cplr co opeq12 vu cv cC cA cplr opreq2 vf cv
      cD cB cplr opreq2 syl2an sylan9eq caddc vx cv cc wcel vy cv cc wcel wa vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv
      cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx
      vy vz copab2 vx cv cnr cnr cxp wcel vy cv cnr cnr cxp wcel wa vx cv vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cplr co vv
      cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz
      copab2 vx vy vz vw vv vu vf df-plus vx cv cc wcel vy cv cc wcel wa vx cv
      vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cplr
      co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx cv
      cnr cnr cxp wcel vy cv cnr cnr cxp wcel wa vx cv vw cv vv cv cop wceq vy
      cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co
      cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz vx cv cc wcel vy cv
      cc wcel wa vx cv cnr cnr cxp wcel vy cv cnr cnr cxp wcel wa vx cv vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cplr co vv
      cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex vx cv cc wcel vx
      cv cnr cnr cxp wcel vy cv cc wcel vy cv cnr cnr cxp wcel cc cnr cnr cxp
      vx cv df-c eleq2i cc cnr cnr cxp vy cv df-c eleq2i anbi12i anbi1i
      oprabbii eqtri oprabval3 $.
      $( [28-May-1995] $)

    $( Multiplication of complex numbers in terms of signed reals. $)
    mulcnsr $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
               ( <. A , B >. x. <. C , D >. ) =
                   <. ( ( A .R C ) +R ( -1R .R ( B .R D ) ) ) ,
                          ( ( B .R C ) +R ( A .R D ) ) >. ) $=
      vx vy vz vw vv vu cA cB cC cD vw cv vu cv cmr co cm1r vv cv vf cv cmr co
      cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop cA cC
      cmr co cm1r cB cD cmr co cmr co cplr co cB cC cmr co cA cD cmr co cplr co
      cop vf cmul cnr cA cC cmr co cm1r cB cD cmr co cmr co cplr co cB cC cmr
      co cA cD cmr co cplr co opex vw cv cA wceq vv cv cB wceq wa vu cv cC wceq
      vf cv cD wceq wa vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr
      co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop cA vu cv cmr co cm1r
      cB vf cv cmr co cmr co cplr co cB vu cv cmr co cA vf cv cmr co cplr co
      cop cA cC cmr co cm1r cB cD cmr co cmr co cplr co cB cC cmr co cA cD cmr
      co cplr co cop vw cv cA wceq vv cv cB wceq wa vw cv vu cv cmr co cm1r vv
      cv vf cv cmr co cmr co cplr co cA vu cv cmr co cm1r cB vf cv cmr co cmr
      co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cB vu cv cmr co
      cA vf cv cmr co cplr co vw cv cA wceq vv cv cB wceq vw cv vu cv cmr co cA
      vu cv cmr co cm1r vv cv vf cv cmr co cmr co cm1r cB vf cv cmr co cmr co
      cplr vw cv cA vu cv cmr opreq1 vv cv cB wceq vv cv vf cv cmr co cB vf cv
      cmr co cm1r cmr vv cv cB vf cv cmr opreq1 opreq2d opreqan12d vv cv cB
      wceq vw cv cA wceq vv cv vu cv cmr co cB vu cv cmr co vw cv vf cv cmr co
      cA vf cv cmr co cplr vv cv cB vu cv cmr opreq1 vw cv cA vf cv cmr opreq1
      opreqan12rd opeq12d vu cv cC wceq vf cv cD wceq wa cA vu cv cmr co cm1r
      cB vf cv cmr co cmr co cplr co cA cC cmr co cm1r cB cD cmr co cmr co cplr
      co cB vu cv cmr co cA vf cv cmr co cplr co cB cC cmr co cA cD cmr co cplr
      co vu cv cC wceq vf cv cD wceq cA vu cv cmr co cA cC cmr co cm1r cB vf cv
      cmr co cmr co cm1r cB cD cmr co cmr co cplr vu cv cC cA cmr opreq2 vf cv
      cD wceq cB vf cv cmr co cB cD cmr co cm1r cmr vf cv cD cB cmr opreq2
      opreq2d opreqan12d vu cv cC wceq vf cv cD wceq cB vu cv cmr co cB cC cmr
      co cA vf cv cmr co cA cD cmr co cplr vu cv cC cB cmr opreq2 vf cv cD cA
      cmr opreq2 opreqan12d opeq12d sylan9eq cmul vx cv cc wcel vy cv cc wcel
      wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv
      vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw
      cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy
      vz copab2 vx cv cnr cnr cxp wcel vy cv cnr cnr cxp wcel wa vx cv vw cv vv
      cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r
      vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co
      cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz copab2 vx vy
      vz vw vv vu vf df-mul vx cv cc wcel vy cv cc wcel wa vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r vv
      cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr
      co cop wceq wa vf wex vu wex vv wex vw wex wa vx cv cnr cnr cxp wcel vy
      cv cnr cnr cxp wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq wa vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co
      vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex
      vv wex vw wex wa vx vy vz vx cv cc wcel vy cv cc wcel wa vx cv cnr cnr
      cxp wcel vy cv cnr cnr cxp wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv
      vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co
      cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex
      vu wex vv wex vw wex vx cv cc wcel vx cv cnr cnr cxp wcel vy cv cc wcel
      vy cv cnr cnr cxp wcel cc cnr cnr cxp vx cv df-c eleq2i cc cnr cnr cxp vy
      cv df-c eleq2i anbi12i anbi1i oprabbii eqtri oprabval3 $.
      $( [9-Aug-1995] $)

  $}

  ${
    eqresr.1 $e |- A e. _V $.
    $( Equality of real numbers in terms of intermediate signed reals. $)
    eqresr $p |- ( <. A , 0R >. = <. B , 0R >. <-> A = B ) $=
      cA c0r cop cB c0r cop wceq cA cB wceq c0r c0r wceq cA c0r cB c0r eqresr.1
      c0r cnr 0r elisseti c0r cnr 0r elisseti opth c0r eqid mpbiran2 $.
      $( [10-May-1996] $)
  $}

  $( Addition of real numbers in terms of intermediate signed reals. $)
  addresr $p |- ( ( A e. R. /\ B e. R. ) ->
           ( <. A , 0R >. + <. B , 0R >. ) = <. ( A +R B ) , 0R >. ) $=
    cA cnr wcel cB cnr wcel wa cA c0r cop cB c0r cop caddc co cA cB cplr co c0r
    c0r cplr co cop cA cB cplr co c0r cop cA cnr wcel cB cnr wcel wa c0r cnr
    wcel c0r cnr wcel cA c0r cop cB c0r cop caddc co cA cB cplr co c0r c0r cplr
    co cop wceq 0r 0r cA cnr wcel c0r cnr wcel cB cnr wcel c0r cnr wcel cA c0r
    cop cB c0r cop caddc co cA cB cplr co c0r c0r cplr co cop wceq cA c0r cB
    c0r addcnsr an4s mpanr12 c0r c0r cplr co c0r cA cB cplr co c0r cnr wcel c0r
    c0r cplr co c0r wceq 0r c0r 0idsr ax-mp opeq2i syl6eq $.
    $( [10-May-1996] $)

  ${
    $( (We don't bother to eliminate the redundant hypothesis.) $)
    mulresr.1 $e |- B e. _V $.
    $( Multiplication of real numbers in terms of intermediate signed reals. $)
    mulresr $p |- ( ( A e. R. /\ B e. R. ) ->
           ( <. A , 0R >. x. <. B , 0R >. ) = <. ( A .R B ) , 0R >. ) $=
      cA cnr wcel cB cnr wcel wa cA c0r cop cB c0r cop cmul co cA cB cmr co
      cm1r c0r c0r cmr co cmr co cplr co c0r cB cmr co cA c0r cmr co cplr co
      cop cA cB cmr co c0r cop cA cnr wcel cB cnr wcel wa c0r cnr wcel c0r cnr
      wcel cA c0r cop cB c0r cop cmul co cA cB cmr co cm1r c0r c0r cmr co cmr
      co cplr co c0r cB cmr co cA c0r cmr co cplr co cop wceq 0r 0r cA cnr wcel
      c0r cnr wcel cB cnr wcel c0r cnr wcel cA c0r cop cB c0r cop cmul co cA cB
      cmr co cm1r c0r c0r cmr co cmr co cplr co c0r cB cmr co cA c0r cmr co
      cplr co cop wceq cA c0r cB c0r mulcnsr an4s mpanr12 cA cnr wcel cB cnr
      wcel wa cA cB cmr co cm1r c0r c0r cmr co cmr co cplr co cA cB cmr co c0r
      cB cmr co cA c0r cmr co cplr co c0r cA cnr wcel cB cnr wcel wa cA cB cmr
      co c0r cplr co cA cB cmr co cA cB cmr co cm1r c0r c0r cmr co cmr co cplr
      co cA cnr wcel cB cnr wcel wa cA cB cmr co cnr wcel cA cB cmr co c0r cplr
      co cA cB cmr co wceq cA cB mulclsr cA cB cmr co 0idsr syl cm1r c0r c0r
      cmr co cmr co c0r cA cB cmr co cplr cm1r c0r c0r cmr co cmr co cm1r c0r
      cmr co c0r c0r c0r cmr co c0r cm1r cmr c0r cnr wcel c0r c0r cmr co c0r
      wceq 0r c0r 00sr ax-mp opreq2i cm1r cnr wcel cm1r c0r cmr co c0r wceq m1r
      cm1r 00sr ax-mp eqtri opreq2i syl5eq cA cnr wcel cB cnr wcel wa c0r cB
      cmr co cA c0r cmr co cplr co c0r c0r cplr co c0r cB cnr wcel cA cnr wcel
      c0r cB cmr co c0r cA c0r cmr co c0r cplr cB cnr wcel cB c0r cmr co c0r
      c0r cB cmr co cB 00sr c0r cB c0r cnr 0r elisseti mulresr.1 mulcomsr
      syl5eq cA 00sr opreqan12rd c0r cnr wcel c0r c0r cplr co c0r wceq 0r c0r
      0idsr ax-mp syl6eq opeq12d eqtrd $.
      $( [10-May-1996] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    ltresr.1 $e |- A e. _V $.
    ltresr.2 $e |- B e. _V $.
    $( Ordering of real subset of complex numbers in terms of signed reals. $)
    ltresr $p |- ( <. A , 0R >. <RR <. B , 0R >. <-> A <R B ) $=
      cA c0r cop cB c0r cop cltrr wbr cA cnr wcel cB cnr wcel wa cA cB cltr wbr
      cA c0r cop cB c0r cop cltrr wbr cA c0r cop cr wcel cB c0r cop cr wcel wa
      cA cnr wcel cB cnr wcel wa cA c0r cop cB c0r cop cr cr cltrr cB c0r opex
      ltrelre brel cA c0r cop cr wcel cA cnr wcel cB c0r cop cr wcel cB cnr
      wcel cA opelreal cB opelreal anbi12i sylib cA cB cnr cnr cltr ltresr.2
      ltrelsr brel cA cnr wcel cB cnr wcel wa cA c0r cop cB c0r cop cltrr wbr
      cA cB cop vz cv vw cv cop wceq vz cv vw cv cltr wbr wa vw wex vz wex cA
      cB cltr wbr cA c0r cop cr wcel cB c0r cop cr wcel cA c0r cop cB c0r cop
      cltrr wbr cA cB cop vz cv vw cv cop wceq vz cv vw cv cltr wbr wa vw wex
      vz wex wb cA cnr wcel cB cnr wcel cA c0r cop cr wcel cB c0r cop cr wcel
      wa cA c0r cop cB c0r cop cltrr wbr cA c0r cop vz cv c0r cop wceq cB c0r
      cop vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz wex cA cB cop
      vz cv vw cv cop wceq vz cv vw cv cltr wbr wa vw wex vz wex cA c0r cop cB
      c0r cop cltrr wbr cA c0r cop cr wcel cB c0r cop cr wcel wa cA c0r cop vz
      cv c0r cop wceq cB c0r cop vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa
      vw wex vz wex vx cv cr wcel vy cv cr wcel wa vx cv vz cv c0r cop wceq vy
      cv vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz wex wa cA c0r
      cop cr wcel vy cv cr wcel wa cA c0r cop vz cv c0r cop wceq vy cv vw cv
      c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz wex wa cA c0r cop cr
      wcel cB c0r cop cr wcel wa cA c0r cop vz cv c0r cop wceq cB c0r cop vw cv
      c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz wex wa vx vy cA c0r cop
      cB c0r cop cltrr cA c0r opex cB c0r opex vx cv cA c0r cop wceq vx cv cr
      wcel vy cv cr wcel wa cA c0r cop cr wcel vy cv cr wcel wa vx cv vz cv c0r
      cop wceq vy cv vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz
      wex cA c0r cop vz cv c0r cop wceq vy cv vw cv c0r cop wceq wa vz cv vw cv
      cltr wbr wa vw wex vz wex vx cv cA c0r cop wceq vx cv cr wcel cA c0r cop
      cr wcel vy cv cr wcel vx cv cA c0r cop cr eleq1 anbi1d vx cv cA c0r cop
      wceq vx cv vz cv c0r cop wceq vy cv vw cv c0r cop wceq wa vz cv vw cv
      cltr wbr wa cA c0r cop vz cv c0r cop wceq vy cv vw cv c0r cop wceq wa vz
      cv vw cv cltr wbr wa vz vw vx cv cA c0r cop wceq vx cv vz cv c0r cop wceq
      vy cv vw cv c0r cop wceq wa cA c0r cop vz cv c0r cop wceq vy cv vw cv c0r
      cop wceq wa vz cv vw cv cltr wbr vx cv cA c0r cop wceq vx cv vz cv c0r
      cop wceq cA c0r cop vz cv c0r cop wceq vy cv vw cv c0r cop wceq vx cv cA
      c0r cop vz cv c0r cop eqeq1 anbi1d anbi1d 2exbidv anbi12d vy cv cB c0r
      cop wceq cA c0r cop cr wcel vy cv cr wcel wa cA c0r cop cr wcel cB c0r
      cop cr wcel wa cA c0r cop vz cv c0r cop wceq vy cv vw cv c0r cop wceq wa
      vz cv vw cv cltr wbr wa vw wex vz wex cA c0r cop vz cv c0r cop wceq cB
      c0r cop vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa vw wex vz wex vy cv
      cB c0r cop wceq vy cv cr wcel cB c0r cop cr wcel cA c0r cop cr wcel vy cv
      cB c0r cop cr eleq1 anbi2d vy cv cB c0r cop wceq cA c0r cop vz cv c0r cop
      wceq vy cv vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa cA c0r cop vz cv
      c0r cop wceq cB c0r cop vw cv c0r cop wceq wa vz cv vw cv cltr wbr wa vz
      vw vy cv cB c0r cop wceq cA c0r cop vz cv c0r cop wceq vy cv vw cv c0r
      cop wceq wa cA c0r cop vz cv c0r cop wceq cB c0r cop vw cv c0r cop wceq
      wa vz cv vw cv cltr wbr vy cv cB c0r cop wceq vy cv vw cv c0r cop wceq cB
      c0r cop vw cv c0r cop wceq cA c0r cop vz cv c0r cop wceq vy cv cB c0r cop
      vw cv c0r cop eqeq1 anbi2d anbi1d 2exbidv anbi12d vx vy vz vw df-lt brab
      baib cA c0r cop vz cv c0r cop wceq cB c0r cop vw cv c0r cop wceq wa vz cv
      vw cv cltr wbr wa cA cB cop vz cv vw cv cop wceq vz cv vw cv cltr wbr wa
      vz vw cA c0r cop vz cv c0r cop wceq cB c0r cop vw cv c0r cop wceq wa cA
      cB cop vz cv vw cv cop wceq vz cv vw cv cltr wbr cA c0r cop vz cv c0r cop
      wceq cB c0r cop vw cv c0r cop wceq wa cA vz cv wceq cB vw cv wceq wa cA
      cB cop vz cv vw cv cop wceq cA c0r cop vz cv c0r cop wceq cA vz cv wceq
      cB c0r cop vw cv c0r cop wceq cB vw cv wceq cA vz cv ltresr.1 eqresr cB
      vw cv ltresr.2 eqresr anbi12i cA cB vz cv vw cv ltresr.1 ltresr.2 vw
      visset opth bitr4i anbi1i 2exbii syl6bb cA opelreal cB opelreal syl2anbr
      vz cv vw cv cltr wbr cA cB cltr wbr vz vw cA cB cnr cnr vz cv cA vw cv cB
      cltr breq12 copsex2g bitrd pm5.21nii $.
      $( [22-Feb-1996] $)
  $}

  ${
    $d x w v u A $.  $d x y z w v u B $.
    supre.1 $e |- B = { w | <. w , 0R >. e. A } $.
    $( Mapping of non-empty subset from signed reals to reals. $)
    suprelem $p |- ( ( A C_ RR /\ -. A = (/) ) ->
                    ( B C_ R. /\ -. B = (/) ) ) $=
      cA cr wss cA c0 wceq wn wa cB cnr wss cB c0 wceq wn cA cr wss cB cnr wss
      cA c0 wceq wn cA cr wss vw cB cnr cA cr wss vw cv cB wcel vw cv c0r cop
      cr wcel vw cv cnr wcel cA cr wss vw cv c0r cop cA wcel vw cv c0r cop cr
      wcel vw cv cB wcel cA cr vw cv c0r cop ssel vw cv c0r cop cA wcel vw cB
      supre.1 abeq2i syl5ib vw cv opelreal syl6ib ssrdv adantr cA cr wss cA c0
      wceq wn cB c0 wceq wn cA cr wss vx cv cA wcel vx wex cB c0 wceq wn cA c0
      wceq wn vx cv cA wcel vx wex cA cr wss cB c0 wceq wn vx cv cA wcel cA cr
      wss cB c0 wceq wn wi vx vx cv cA wcel cA cr wss vx cv cr wcel cB c0 wceq
      wn cA cr wss vx cv cA wcel vx cv cr wcel cA cr vx cv ssel com12 vx cv cA
      wcel vw cv cnr wcel vw cv c0r cop vx cv wceq wa vw wex cB c0 wceq wn vx
      cv cr wcel vx cv cA wcel vw cv cnr wcel vw cv c0r cop vx cv wceq wa cB c0
      wceq wn vw vx cv cA wcel vw cv c0r cop vx cv wceq cB c0 wceq wn vw cv cnr
      wcel vx cv cA wcel vw cv c0r cop vx cv wceq vw cv cB wcel cB c0 wceq wn
      vw cv c0r cop vx cv wceq vw cv cB wcel vx cv cA wcel vw cv c0r cop vx cv
      wceq vw cv c0r cop cA wcel vx cv cA wcel vw cv cB wcel vw cv c0r cop vx
      cv cA eleq1 vw cv c0r cop cA wcel vw cB supre.1 abeq2i syl5bb biimprcd cB
      vw cv n0i syl6 adantld 19.23adv vw vx cv elreal syl5ib syld 19.23aiv
      com12 vx cA neq0 syl5ib imp jca $.
      $( [19-May-1996] $)

    $( A non-empty, bounded-above set of reals has a supremum. $)
    supre $p |- ( ( ( A C_ RR /\ -. A = (/) ) /\ E. x ( x e. RR /\
                     A. y ( y e. RR -> ( y e. A -> y <RR x ) ) ) ) ->
       E. x ( x e. RR /\ A. y ( y e. RR -> ( ( y e. A -> -. x <RR y ) /\
           ( y <RR x -> E. z ( z e. RR /\ ( z e. A /\ y <RR z ) ) ) ) ) ) ) $=
      cB cnr wss cB c0 wceq wn wa vx cv cr wcel vy cv cr wcel vy cv cA wcel vy
      cv vx cv cltrr wbr wi wi vy wal wa vx wex vx cv cr wcel vy cv cr wcel vy
      cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr
      wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy wal wa
      vx wex cA cr wss cA c0 wceq wn wa cB cnr wss cB c0 wceq wn wa vw cv cnr
      wcel vv cv cnr wcel vv cv cB wcel vv cv vw cv cltr wbr wi wi vv wal wa vw
      wex vx cv cr wcel vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi
      vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr
      wa wa vz wex wi wa wi vy wal wa vx wex vx cv cr wcel vy cv cr wcel vy cv
      cA wcel vy cv vx cv cltrr wbr wi wi vy wal wa vx wex cB cnr wss cB c0
      wceq wn wa vw cv cnr wcel vv cv cnr wcel vv cv cB wcel vv cv vw cv cltr
      wbr wi wi vv wal wa vw wex wa vw cv cnr wcel vv cv cnr wcel vv cv cB wcel
      vw cv vv cv cltr wbr wn wi vv cv vw cv cltr wbr vu cv cnr wcel vu cv cB
      wcel vv cv vu cv cltr wbr wa wa vu wex wi wa wi vv wal wa vw wex vx cv cr
      wcel vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv
      cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex
      wi wa wi vy wal wa vx wex vw vv vu cB supsr vv cv cnr wcel vv cv cB wcel
      vw cv vv cv cltr wbr wn wi vv cv vw cv cltr wbr vu cv cnr wcel vu cv cB
      wcel vv cv vu cv cltr wbr wa wa vu wex wi wa wi vv wal vy cv cr wcel vy
      cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr
      wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy wal vw
      cv cnr wcel vx cv cr wcel vw vx vw cv c0r cop vw cv c0r opex vw cv c0r
      cop vx cv wceq vy cv cr wcel vy cv cA wcel vw cv c0r cop vy cv cltrr wbr
      wn wi vy cv vw cv c0r cop cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz
      cv cltrr wbr wa wa vz wex wi wa wi vy wal vy cv cr wcel vy cv cA wcel vx
      cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA
      wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy wal vv cv cnr wcel vv
      cv cB wcel vw cv vv cv cltr wbr wn wi vv cv vw cv cltr wbr vu cv cnr wcel
      vu cv cB wcel vv cv vu cv cltr wbr wa wa vu wex wi wa wi vv wal vw cv c0r
      cop vx cv wceq vy cv cr wcel vy cv cA wcel vw cv c0r cop vy cv cltrr wbr
      wn wi vy cv vw cv c0r cop cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz
      cv cltrr wbr wa wa vz wex wi wa wi vy cv cr wcel vy cv cA wcel vx cv vy
      cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy
      cv vz cv cltrr wbr wa wa vz wex wi wa wi vy vw cv c0r cop vx cv wceq vy
      cv cA wcel vw cv c0r cop vy cv cltrr wbr wn wi vy cv vw cv c0r cop cltrr
      wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa
      vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr
      wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa vy cv cr wcel
      vw cv c0r cop vx cv wceq vy cv cA wcel vw cv c0r cop vy cv cltrr wbr wn
      wi vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vw cv c0r cop cltrr
      wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi vy
      cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa
      wa vz wex wi vw cv c0r cop vx cv wceq vw cv c0r cop vy cv cltrr wbr wn vx
      cv vy cv cltrr wbr wn vy cv cA wcel vw cv c0r cop vx cv wceq vw cv c0r
      cop vy cv cltrr wbr vx cv vy cv cltrr wbr vw cv c0r cop vx cv vy cv cltrr
      breq1 notbid imbi2d vw cv c0r cop vx cv wceq vy cv vw cv c0r cop cltrr
      wbr vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr
      wbr wa wa vz wex vw cv c0r cop vx cv vy cv cltrr breq2 imbi1d anbi12d
      imbi2d albidv vv cv cB wcel vw cv vv cv cltr wbr wn wi vv cv vw cv cltr
      wbr vu cv cnr wcel vu cv cB wcel vv cv vu cv cltr wbr wa wa vu wex wi wa
      vy cv cA wcel vw cv c0r cop vy cv cltrr wbr wn wi vy cv vw cv c0r cop
      cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex
      wi wa vv cv cnr wcel vy cv cr wcel vv vy vv cv c0r cop vv cv c0r opex vv
      cv c0r cop vy cv wceq vv cv cB wcel vw cv vv cv cltr wbr wn wi vy cv cA
      wcel vw cv c0r cop vy cv cltrr wbr wn wi vv cv vw cv cltr wbr vu cv cnr
      wcel vu cv cB wcel vv cv vu cv cltr wbr wa wa vu wex wi vy cv vw cv c0r
      cop cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz
      wex wi vv cv c0r cop vy cv wceq vv cv cB wcel vy cv cA wcel vw cv vv cv
      cltr wbr wn vw cv c0r cop vy cv cltrr wbr wn vv cv c0r cop vy cv wceq vv
      cv c0r cop cA wcel vy cv cA wcel vv cv cB wcel vv cv c0r cop vy cv cA
      eleq1 vw cv c0r cop cA wcel vv cv c0r cop cA wcel vw vv cv cB vv visset
      vw cv vv cv wceq vw cv c0r cop vv cv c0r cop cA vw cv vv cv c0r opeq1
      eleq1d supre.1 elab2 syl5bb vv cv c0r cop vy cv wceq vw cv vv cv cltr wbr
      vw cv c0r cop vy cv cltrr wbr vv cv c0r cop vy cv wceq vw cv c0r cop vv
      cv c0r cop cltrr wbr vw cv c0r cop vy cv cltrr wbr vw cv vv cv cltr wbr
      vv cv c0r cop vy cv vw cv c0r cop cltrr breq2 vw cv vv cv vw visset vv
      visset ltresr syl5bbr notbid imbi12d vv cv c0r cop vy cv wceq vv cv vw cv
      cltr wbr vy cv vw cv c0r cop cltrr wbr vu cv cnr wcel vu cv cB wcel vv cv
      vu cv cltr wbr wa wa vu wex vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr
      wbr wa wa vz wex vv cv c0r cop vy cv wceq vv cv c0r cop vw cv c0r cop
      cltrr wbr vy cv vw cv c0r cop cltrr wbr vv cv vw cv cltr wbr vv cv c0r
      cop vy cv vw cv c0r cop cltrr breq1 vv cv vw cv vv visset vw visset
      ltresr syl5bbr vv cv c0r cop vy cv wceq vz cv cr wcel vz cv cA wcel vv cv
      c0r cop vz cv cltrr wbr wa wa vz wex vz cv cr wcel vz cv cA wcel vy cv vz
      cv cltrr wbr wa wa vz wex vu cv cnr wcel vu cv cB wcel vv cv vu cv cltr
      wbr wa wa vu wex vv cv c0r cop vy cv wceq vz cv cr wcel vz cv cA wcel vv
      cv c0r cop vz cv cltrr wbr wa wa vz cv cr wcel vz cv cA wcel vy cv vz cv
      cltrr wbr wa wa vz vv cv c0r cop vy cv wceq vz cv cA wcel vv cv c0r cop
      vz cv cltrr wbr wa vz cv cA wcel vy cv vz cv cltrr wbr wa vz cv cr wcel
      vv cv c0r cop vy cv wceq vv cv c0r cop vz cv cltrr wbr vy cv vz cv cltrr
      wbr vz cv cA wcel vv cv c0r cop vy cv vz cv cltrr breq1 anbi2d anbi2d
      exbidv vu cv cB wcel vv cv vu cv cltr wbr wa vz cv cA wcel vv cv c0r cop
      vz cv cltrr wbr wa vu cv cnr wcel vz cv cr wcel vu vz vu cv c0r cop vu cv
      c0r opex vu cv c0r cop vz cv wceq vu cv cB wcel vz cv cA wcel vv cv vu cv
      cltr wbr vv cv c0r cop vz cv cltrr wbr vu cv c0r cop vz cv wceq vu cv c0r
      cop cA wcel vz cv cA wcel vu cv cB wcel vu cv c0r cop vz cv cA eleq1 vw
      cv c0r cop cA wcel vu cv c0r cop cA wcel vw vu cv cB vu visset vw cv vu
      cv wceq vw cv c0r cop vu cv c0r cop cA vw cv vu cv c0r opeq1 eleq1d
      supre.1 elab2 syl5bb vu cv c0r cop vz cv wceq vv cv c0r cop vu cv c0r cop
      cltrr wbr vv cv c0r cop vz cv cltrr wbr vv cv vu cv cltr wbr vu cv c0r
      cop vz cv vv cv c0r cop cltrr breq2 vv cv vu cv vv visset vu visset
      ltresr syl5bbr anbi12d vu cv c0r cop vz cv wceq vu cv c0r cop cr wcel vz
      cv cr wcel vu cv cnr wcel vu cv c0r cop vz cv cr eleq1 vu cv opelreal
      syl5bbr vu vz cv elreal gencbvex syl5bb imbi12d anbi12d vv cv c0r cop vy
      cv wceq vv cv c0r cop cr wcel vy cv cr wcel vv cv cnr wcel vv cv c0r cop
      vy cv cr eleq1 vv cv opelreal syl5bbr vv vy cv elreal gencbval syl5bb vw
      cv c0r cop vx cv wceq vw cv c0r cop cr wcel vx cv cr wcel vw cv cnr wcel
      vw cv c0r cop vx cv cr eleq1 vw cv opelreal syl5bbr vw vx cv elreal
      gencbvex sylib vv cv cnr wcel vv cv cB wcel vv cv vw cv cltr wbr wi wi vv
      wal vy cv cr wcel vy cv cA wcel vy cv vx cv cltrr wbr wi wi vy wal vw cv
      cnr wcel vx cv cr wcel vw vx vw cv c0r cop vw cv c0r opex vw cv c0r cop
      vx cv wceq vy cv cr wcel vy cv cA wcel vy cv vw cv c0r cop cltrr wbr wi
      wi vy wal vy cv cr wcel vy cv cA wcel vy cv vx cv cltrr wbr wi wi vy wal
      vv cv cnr wcel vv cv cB wcel vv cv vw cv cltr wbr wi wi vv wal vw cv c0r
      cop vx cv wceq vy cv cr wcel vy cv cA wcel vy cv vw cv c0r cop cltrr wbr
      wi wi vy cv cr wcel vy cv cA wcel vy cv vx cv cltrr wbr wi wi vy vw cv
      c0r cop vx cv wceq vy cv cA wcel vy cv vw cv c0r cop cltrr wbr wi vy cv
      cA wcel vy cv vx cv cltrr wbr wi vy cv cr wcel vw cv c0r cop vx cv wceq
      vy cv vw cv c0r cop cltrr wbr vy cv vx cv cltrr wbr vy cv cA wcel vw cv
      c0r cop vx cv vy cv cltrr breq2 imbi2d imbi2d albidv vv cv cB wcel vv cv
      vw cv cltr wbr wi vy cv cA wcel vy cv vw cv c0r cop cltrr wbr wi vv cv
      cnr wcel vy cv cr wcel vv vy vv cv c0r cop vv cv c0r opex vv cv c0r cop
      vy cv wceq vv cv cB wcel vy cv cA wcel vv cv vw cv cltr wbr vy cv vw cv
      c0r cop cltrr wbr vv cv c0r cop vy cv wceq vv cv c0r cop cA wcel vy cv cA
      wcel vv cv cB wcel vv cv c0r cop vy cv cA eleq1 vw cv c0r cop cA wcel vv
      cv c0r cop cA wcel vw vv cv cB vv visset vw cv vv cv wceq vw cv c0r cop
      vv cv c0r cop cA vw cv vv cv c0r opeq1 eleq1d supre.1 elab2 syl5bb vv cv
      c0r cop vy cv wceq vv cv c0r cop vw cv c0r cop cltrr wbr vy cv vw cv c0r
      cop cltrr wbr vv cv vw cv cltr wbr vv cv c0r cop vy cv vw cv c0r cop
      cltrr breq1 vv cv vw cv vv visset vw visset ltresr syl5bbr imbi12d vv cv
      c0r cop vy cv wceq vv cv c0r cop cr wcel vy cv cr wcel vv cv cnr wcel vv
      cv c0r cop vy cv cr eleq1 vv cv opelreal syl5bbr vv vy cv elreal gencbval
      syl5bb vw cv c0r cop vx cv wceq vw cv c0r cop cr wcel vx cv cr wcel vw cv
      cnr wcel vw cv c0r cop vx cv cr eleq1 vw cv opelreal syl5bbr vw vx cv
      elreal gencbvex sylan2br vw cA cB supre.1 suprelem sylan $.
      $( [19-May-1996] $)
  $}

  ${
    $d x y z w v u $.
    $( 'Less than' is a strict ordering on real subset of complex numbers.
       Note: use ~ ltso and not this one after the complex number postulates
       are derived, in order to maintain a "clean" derivation of complex
       number theorems directly from postulates.  The artificial right
       conjunct is intended to help discourage its accidental use in place
       of ~ ltso . $)
    ltsor $p |- ( <RR Or RR /\ RR = RR ) $=
      cr cltrr wor cr cr wceq vx vy vz cr cltrr vw cv c0r cop vv cv c0r cop
      cltrr wbr vw cv c0r cop vv cv c0r cop wceq vv cv c0r cop vw cv c0r cop
      cltrr wbr wo wn wb vw cv c0r cop vv cv c0r cop cltrr wbr vv cv c0r cop vu
      cv c0r cop cltrr wbr wa vw cv c0r cop vu cv c0r cop cltrr wbr wi wa vx cv
      vv cv c0r cop cltrr wbr vx cv vv cv c0r cop wceq vv cv c0r cop vx cv
      cltrr wbr wo wn wb vx cv vv cv c0r cop cltrr wbr vv cv c0r cop vu cv c0r
      cop cltrr wbr wa vx cv vu cv c0r cop cltrr wbr wi wa vx cv vy cv cltrr
      wbr vx cv vy cv wceq vy cv vx cv cltrr wbr wo wn wb vx cv vy cv cltrr wbr
      vy cv vu cv c0r cop cltrr wbr wa vx cv vu cv c0r cop cltrr wbr wi wa vx
      cv vy cv cltrr wbr vx cv vy cv wceq vy cv vx cv cltrr wbr wo wn wb vx cv
      vy cv cltrr wbr vy cv vz cv cltrr wbr wa vx cv vz cv cltrr wbr wi wa vw
      vv vu vw cv c0r cop vv cv c0r cop vu cv c0r cop vx cv cnr cr vy cv vz cv
      vw vx cv elreal vv vy cv elreal vu vz cv elreal vw cv c0r cop vx cv wceq
      vw cv c0r cop vv cv c0r cop cltrr wbr vw cv c0r cop vv cv c0r cop wceq vv
      cv c0r cop vw cv c0r cop cltrr wbr wo wn wb vx cv vv cv c0r cop cltrr wbr
      vx cv vv cv c0r cop wceq vv cv c0r cop vx cv cltrr wbr wo wn wb vw cv c0r
      cop vv cv c0r cop cltrr wbr vv cv c0r cop vu cv c0r cop cltrr wbr wa vw
      cv c0r cop vu cv c0r cop cltrr wbr wi vx cv vv cv c0r cop cltrr wbr vv cv
      c0r cop vu cv c0r cop cltrr wbr wa vx cv vu cv c0r cop cltrr wbr wi vw cv
      c0r cop vx cv wceq vw cv c0r cop vv cv c0r cop cltrr wbr vx cv vv cv c0r
      cop cltrr wbr vw cv c0r cop vv cv c0r cop wceq vv cv c0r cop vw cv c0r
      cop cltrr wbr wo wn vx cv vv cv c0r cop wceq vv cv c0r cop vx cv cltrr
      wbr wo wn vw cv c0r cop vx cv vv cv c0r cop cltrr breq1 vw cv c0r cop vx
      cv wceq vw cv c0r cop vv cv c0r cop wceq vv cv c0r cop vw cv c0r cop
      cltrr wbr wo vx cv vv cv c0r cop wceq vv cv c0r cop vx cv cltrr wbr wo vw
      cv c0r cop vx cv wceq vw cv c0r cop vv cv c0r cop wceq vx cv vv cv c0r
      cop wceq vv cv c0r cop vw cv c0r cop cltrr wbr vv cv c0r cop vx cv cltrr
      wbr vw cv c0r cop vx cv vv cv c0r cop eqeq1 vw cv c0r cop vx cv vv cv c0r
      cop cltrr breq2 orbi12d notbid bibi12d vw cv c0r cop vx cv wceq vw cv c0r
      cop vv cv c0r cop cltrr wbr vv cv c0r cop vu cv c0r cop cltrr wbr wa vx
      cv vv cv c0r cop cltrr wbr vv cv c0r cop vu cv c0r cop cltrr wbr wa vw cv
      c0r cop vu cv c0r cop cltrr wbr vx cv vu cv c0r cop cltrr wbr vw cv c0r
      cop vx cv wceq vw cv c0r cop vv cv c0r cop cltrr wbr vx cv vv cv c0r cop
      cltrr wbr vv cv c0r cop vu cv c0r cop cltrr wbr vw cv c0r cop vx cv vv cv
      c0r cop cltrr breq1 anbi1d vw cv c0r cop vx cv vu cv c0r cop cltrr breq1
      imbi12d anbi12d vv cv c0r cop vy cv wceq vx cv vv cv c0r cop cltrr wbr vx
      cv vv cv c0r cop wceq vv cv c0r cop vx cv cltrr wbr wo wn wb vx cv vy cv
      cltrr wbr vx cv vy cv wceq vy cv vx cv cltrr wbr wo wn wb vx cv vv cv c0r
      cop cltrr wbr vv cv c0r cop vu cv c0r cop cltrr wbr wa vx cv vu cv c0r
      cop cltrr wbr wi vx cv vy cv cltrr wbr vy cv vu cv c0r cop cltrr wbr wa
      vx cv vu cv c0r cop cltrr wbr wi vv cv c0r cop vy cv wceq vx cv vv cv c0r
      cop cltrr wbr vx cv vy cv cltrr wbr vx cv vv cv c0r cop wceq vv cv c0r
      cop vx cv cltrr wbr wo wn vx cv vy cv wceq vy cv vx cv cltrr wbr wo wn vv
      cv c0r cop vy cv vx cv cltrr breq2 vv cv c0r cop vy cv wceq vx cv vv cv
      c0r cop wceq vv cv c0r cop vx cv cltrr wbr wo vx cv vy cv wceq vy cv vx
      cv cltrr wbr wo vv cv c0r cop vy cv wceq vx cv vv cv c0r cop wceq vx cv
      vy cv wceq vv cv c0r cop vx cv cltrr wbr vy cv vx cv cltrr wbr vv cv c0r
      cop vy cv vx cv eqeq2 vv cv c0r cop vy cv vx cv cltrr breq1 orbi12d
      notbid bibi12d vv cv c0r cop vy cv wceq vx cv vv cv c0r cop cltrr wbr vv
      cv c0r cop vu cv c0r cop cltrr wbr wa vx cv vy cv cltrr wbr vy cv vu cv
      c0r cop cltrr wbr wa vx cv vu cv c0r cop cltrr wbr vv cv c0r cop vy cv
      wceq vx cv vv cv c0r cop cltrr wbr vx cv vy cv cltrr wbr vv cv c0r cop vu
      cv c0r cop cltrr wbr vy cv vu cv c0r cop cltrr wbr vv cv c0r cop vy cv vx
      cv cltrr breq2 vv cv c0r cop vy cv vu cv c0r cop cltrr breq1 anbi12d
      imbi1d anbi12d vu cv c0r cop vz cv wceq vx cv vy cv cltrr wbr vy cv vu cv
      c0r cop cltrr wbr wa vx cv vu cv c0r cop cltrr wbr wi vx cv vy cv cltrr
      wbr vy cv vz cv cltrr wbr wa vx cv vz cv cltrr wbr wi vx cv vy cv cltrr
      wbr vx cv vy cv wceq vy cv vx cv cltrr wbr wo wn wb vu cv c0r cop vz cv
      wceq vx cv vy cv cltrr wbr vy cv vu cv c0r cop cltrr wbr wa vx cv vy cv
      cltrr wbr vy cv vz cv cltrr wbr wa vx cv vu cv c0r cop cltrr wbr vx cv vz
      cv cltrr wbr vu cv c0r cop vz cv wceq vy cv vu cv c0r cop cltrr wbr vy cv
      vz cv cltrr wbr vx cv vy cv cltrr wbr vu cv c0r cop vz cv vy cv cltrr
      breq2 anbi2d vu cv c0r cop vz cv vx cv cltrr breq2 imbi12d anbi2d vw cv
      cnr wcel vv cv cnr wcel vu cv cnr wcel w3a vw cv c0r cop vv cv c0r cop
      cltrr wbr vw cv c0r cop vv cv c0r cop wceq vv cv c0r cop vw cv c0r cop
      cltrr wbr wo wn wb vw cv c0r cop vv cv c0r cop cltrr wbr vv cv c0r cop vu
      cv c0r cop cltrr wbr wa vw cv c0r cop vu cv c0r cop cltrr wbr wi vw cv
      cnr wcel vv cv cnr wcel vw cv c0r cop vv cv c0r cop cltrr wbr vw cv c0r
      cop vv cv c0r cop wceq vv cv c0r cop vw cv c0r cop cltrr wbr wo wn wb vu
      cv cnr wcel vw cv cnr wcel vv cv cnr wcel wa vw cv vv cv cltr wbr vw cv
      vv cv wceq vv cv vw cv cltr wbr wo wn vw cv c0r cop vv cv c0r cop cltrr
      wbr vw cv c0r cop vv cv c0r cop wceq vv cv c0r cop vw cv c0r cop cltrr
      wbr wo wn cnr cltr wor vw cv cnr wcel vv cv cnr wcel wa vw cv vv cv cltr
      wbr vw cv vv cv wceq vv cv vw cv cltr wbr wo wn wb ltsosr cnr vw cv vv cv
      cltr sotric mpan vw cv vv cv vw visset vv visset ltresr vw cv c0r cop vv
      cv c0r cop wceq vv cv c0r cop vw cv c0r cop cltrr wbr wo vw cv vv cv wceq
      vv cv vw cv cltr wbr wo vw cv c0r cop vv cv c0r cop wceq vw cv vv cv wceq
      vv cv c0r cop vw cv c0r cop cltrr wbr vv cv vw cv cltr wbr vw cv vv cv vw
      visset eqresr vv cv vw cv vv visset vw visset ltresr orbi12i notbii
      3bitr4g 3adant3 vw cv vv cv cltr wbr vv cv vu cv cltr wbr wa vw cv vu cv
      cltr wbr vw cv c0r cop vv cv c0r cop cltrr wbr vv cv c0r cop vu cv c0r
      cop cltrr wbr wa vw cv c0r cop vu cv c0r cop cltrr wbr vw cv vv cv vu cv
      cltr cnr vw visset ltsosr ltrelsr vv visset vu visset sotri vw cv c0r cop
      vv cv c0r cop cltrr wbr vw cv vv cv cltr wbr vv cv c0r cop vu cv c0r cop
      cltrr wbr vv cv vu cv cltr wbr vw cv vv cv vw visset vv visset ltresr vv
      cv vu cv vv visset vu visset ltresr anbi12i vw cv vu cv vw visset vu
      visset ltresr 3imtr4i jctir 3gencl so cr eqid pm3.2i $.
      $( [9-Mar-2005] $) $( [31-Mar-1996] $)
  $}

  $( Technical trick to permit reuse of previous lemmas to prove arithmetic
     operation laws in ` CC ` from those in ` R. ` .  The trick involves
     ~ qsid , which shows that the coset of the converse epsilon relation
     (which is not an equivalence relation) acts as an identity divisor for
     the quotient set operation.  This lets us "pretend" that ` CC ` is a
     quotient set, even though it is not (compare ~ df-c ), and allows us to
     reuse some of the equivalence class lemmas we developed for the transition
     from positive reals to signed reals, etc. $)
  dfcnqs $p |- CC = ( ( R. X. R. ) /. `' _E ) $=
    cc cnr cnr cxp cnr cnr cxp cep ccnv cqs df-c cnr cnr cxp qsid eqtr4i $.
    $( [13-Aug-1995] $)

  $( Technical trick to permit re-use of some equivalence class lemmas for
     operation laws.  See ~ dfcnqs and ~ mulcnsrec . $)
  addcnsrec $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
                 ( [ <. A , B >. ] `' _E + [ <. C , D >. ] `' _E ) =
                   [ <. ( A +R C ) , ( B +R D ) >. ] `' _E ) $=
    cA cnr wcel cB cnr wcel wa cC cnr wcel cD cnr wcel wa wa cA cB cop cC cD
    cop caddc co cA cC cplr co cB cD cplr co cop cA cB cop cep ccnv cec cC cD
    cop cep ccnv cec caddc co cA cC cplr co cB cD cplr co cop cep ccnv cec cA
    cB cC cD addcnsr cA cB cop cep ccnv cec cA cB cop cC cD cop cep ccnv cec cC
    cD cop caddc cA cB cop cA cB opex ecid cC cD cop cC cD opex ecid opreq12i
    cA cC cplr co cB cD cplr co cop cA cC cplr co cB cD cplr co opex ecid
    3eqtr4g $.
    $( [13-Aug-1995] $)

  $( Technical trick to permit re-use of some equivalence class lemmas for
     operation laws.  The trick involves ~ ecid , which shows that the coset
     of the converse epsilon relation (which is not an equivalence relation)
     leaves a set unchanged.  See also ~ dfcnqs .

     _Note:  This is the last lemma (from which the axioms will be derived) in_
     _the construction of real and complex numbers.  The construction starts_
     _at_ ~ cnpi . $)
  mulcnsrec $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
               ( [ <. A , B >. ] `' _E x. [ <. C , D >. ] `' _E ) =
                    [ <. ( ( A .R C ) +R ( -1R .R ( B .R D ) ) ) ,
                          ( ( B .R C ) +R ( A .R D ) ) >. ] `' _E ) $=
    cA cnr wcel cB cnr wcel wa cC cnr wcel cD cnr wcel wa wa cA cB cop cC cD
    cop cmul co cA cC cmr co cm1r cB cD cmr co cmr co cplr co cB cC cmr co cA
    cD cmr co cplr co cop cA cB cop cep ccnv cec cC cD cop cep ccnv cec cmul co
    cA cC cmr co cm1r cB cD cmr co cmr co cplr co cB cC cmr co cA cD cmr co
    cplr co cop cep ccnv cec cA cB cC cD mulcnsr cA cB cop cep ccnv cec cA cB
    cop cC cD cop cep ccnv cec cC cD cop cmul cA cB cop cA cB opex ecid cC cD
    cop cC cD opex ecid opreq12i cA cC cmr co cm1r cB cD cmr co cmr co cplr co
    cB cC cmr co cA cD cmr co cplr co cop cA cC cmr co cm1r cB cD cmr co cmr co
    cplr co cB cC cmr co cA cD cmr co cplr co opex ecid 3eqtr4g $.
    $( [13-Aug-1995] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Real and complex number postulates
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u f $.
    $( Addition is an operation on the complex numbers.  This theorem can be
       used as an alternate axiom for complex numbers in place of the less
       specific ~ axaddcl . $)
    axaddopr $p |- + : ( CC X. CC ) --> CC $=
      cc cc cxp cc caddc wf caddc cc cc cxp wfn vx cv vy cv caddc co cc wcel vy
      cc wral vx cc wral vx vy cc cc cc caddc ffnoprv caddc cc cc cxp wfn caddc
      wfun caddc cdm cc cc cxp wceq caddc cc cc cxp df-fn caddc wfun vx cv cc
      wcel vy cv cc wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex
      vu wex vv wex vw wex wa vx vy vz copab2 wfun vx cv cc wcel vy cv cc wcel
      wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv
      vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex
      wa vx vy vz vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz
      cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv
      wex vw wex vx cv cc wcel vy cv cc wcel wa vz vx cv vw cv vv cv cop wceq
      vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr
      co cop wceq wa vf wex vu wex vv wex vw wex vz wmo vx cv vw cv vv cv cop
      wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu cv cplr co vv cv vf cv
      cplr co cop wceq wa vf wex vu wex wa vv wex vw wex vz wmo vy cv vu cv vf
      cv cop wceq vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf
      wex vu wex vz vw vv vx cv vz cv vw cv vu cv cplr co vv cv vf cv cplr co
      cop wceq vz vu vf vy cv vz vw cv vu cv cplr co vv cv vf cv cplr co cop
      moeq mosubop mosubop vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex
      vu wex vv wex vw wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex vu
      wex wa vv wex vw wex vz vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex
      vu wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv
      vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex wa vw vv vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv
      cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu cv cplr co vv cv vf cv
      cplr co cop wceq wa wa vf wex vu wex vx cv vw cv vv cv cop wceq vy cv vu
      cv vf cv cop wceq vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq
      wa vf wex vu wex wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq
      wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vx cv vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu cv cplr co vv cv
      vf cv cplr co cop wceq wa wa vu vf vx cv vw cv vv cv cop wceq vy cv vu cv
      vf cv cop wceq vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq
      anass 2exbii vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv
      vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vu vf 19.42vv bitri
      2exbii mobii mpbir moani funoprab caddc vx cv cc wcel vy cv cc wcel wa vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv
      cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx
      vy vz copab2 wceq caddc wfun vx cv cc wcel vy cv cc wcel wa vx cv vw cv
      vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cplr co vv
      cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz
      copab2 wfun wb vx vy vz vw vv vu vf df-plus caddc vx cv cc wcel vy cv cc
      wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw
      cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw
      wex wa vx vy vz copab2 funeq ax-mp mpbir caddc cdm cc cc cxp caddc cdm vx
      cv cc wcel vy cv cc wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv
      cop wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf
      wex vu wex vv wex vw wex wa vx vy vz copab2 cdm cc cc cxp caddc vx cv cc
      wcel vy cv cc wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop
      wceq wa vz cv vw cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex
      vu wex vv wex vw wex wa vx vy vz copab2 vx vy vz vw vv vu vf df-plus
      dmeqi vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw
      cv vu cv cplr co vv cv vf cv cplr co cop wceq wa vf wex vu wex vv wex vw
      wex vx vy vz cc cc dmoprabss eqsstri vx vy cc caddc 0ncn vx cv cc wcel vy
      cv cc wcel wa vx cv vy cv caddc co cnr cnr cxp cc vz cv vw cv cop vv cv
      vu cv cop caddc co cnr cnr cxp wcel vx cv vv cv vu cv cop caddc co cnr
      cnr cxp wcel vx cv vy cv caddc co cnr cnr cxp wcel vz vw vv vu vx cv vy
      cv cnr cnr cc df-c vz cv vw cv cop vx cv wceq vz cv vw cv cop vv cv vu cv
      cop caddc co vx cv vv cv vu cv cop caddc co cnr cnr cxp vz cv vw cv cop
      vx cv vv cv vu cv cop caddc opreq1 eleq1d vv cv vu cv cop vy cv wceq vx
      cv vv cv vu cv cop caddc co vx cv vy cv caddc co cnr cnr cxp vv cv vu cv
      cop vy cv vx cv caddc opreq2 eleq1d vz cv cnr wcel vw cv cnr wcel wa vv
      cv cnr wcel vu cv cnr wcel wa wa vz cv vw cv cop vv cv vu cv cop caddc co
      vz cv vv cv cplr co vw cv vu cv cplr co cop cnr cnr cxp vz cv vw cv vv cv
      vu cv addcnsr vz cv cnr wcel vw cv cnr wcel wa vv cv cnr wcel vu cv cnr
      wcel wa wa vz cv vv cv cplr co cnr wcel vw cv vu cv cplr co cnr wcel wa
      vz cv vv cv cplr co vw cv vu cv cplr co cop cnr cnr cxp wcel vz cv cnr
      wcel vv cv cnr wcel vw cv cnr wcel vu cv cnr wcel vz cv vv cv cplr co cnr
      wcel vw cv vu cv cplr co cnr wcel wa vz cv cnr wcel vv cv cnr wcel wa vz
      cv vv cv cplr co cnr wcel vw cv cnr wcel vu cv cnr wcel wa vw cv vu cv
      cplr co cnr wcel vz cv vv cv addclsr vw cv vu cv addclsr anim12i an4s vz
      cv vv cv cplr co vw cv vu cv cplr co cnr cnr opelxpi syl eqeltrd 2optocl
      df-c syl6eleqr oprssdm eqssi mpbir2an vx cv vy cv caddc co cc wcel vx vy
      cc vx cv cc wcel vy cv cc wcel wa vx cv vy cv caddc co cnr cnr cxp cc vz
      cv vw cv cop vv cv vu cv cop caddc co cnr cnr cxp wcel vx cv vv cv vu cv
      cop caddc co cnr cnr cxp wcel vx cv vy cv caddc co cnr cnr cxp wcel vz vw
      vv vu vx cv vy cv cnr cnr cc df-c vz cv vw cv cop vx cv wceq vz cv vw cv
      cop vv cv vu cv cop caddc co vx cv vv cv vu cv cop caddc co cnr cnr cxp
      vz cv vw cv cop vx cv vv cv vu cv cop caddc opreq1 eleq1d vv cv vu cv cop
      vy cv wceq vx cv vv cv vu cv cop caddc co vx cv vy cv caddc co cnr cnr
      cxp vv cv vu cv cop vy cv vx cv caddc opreq2 eleq1d vz cv cnr wcel vw cv
      cnr wcel wa vv cv cnr wcel vu cv cnr wcel wa wa vz cv vw cv cop vv cv vu
      cv cop caddc co vz cv vv cv cplr co vw cv vu cv cplr co cop cnr cnr cxp
      vz cv vw cv vv cv vu cv addcnsr vz cv cnr wcel vw cv cnr wcel wa vv cv
      cnr wcel vu cv cnr wcel wa wa vz cv vv cv cplr co cnr wcel vw cv vu cv
      cplr co cnr wcel wa vz cv vv cv cplr co vw cv vu cv cplr co cop cnr cnr
      cxp wcel vz cv cnr wcel vv cv cnr wcel vw cv cnr wcel vu cv cnr wcel vz
      cv vv cv cplr co cnr wcel vw cv vu cv cplr co cnr wcel wa vz cv cnr wcel
      vv cv cnr wcel wa vz cv vv cv cplr co cnr wcel vw cv cnr wcel vu cv cnr
      wcel wa vw cv vu cv cplr co cnr wcel vz cv vv cv addclsr vw cv vu cv
      addclsr anim12i an4s vz cv vv cv cplr co vw cv vu cv cplr co cnr cnr
      opelxpi syl eqeltrd 2optocl df-c syl6eleqr rgen2a mpbir2an $.
      $( [9-Feb-2005] $) $( [8-Feb-2005] $)

    $( Multiplication is an operation on the complex numbers.  This theorem can
       be used as an alternate axiom for complex numbers in place of the less
       specific ~ axmulcl . $)
    axmulopr $p |- x. : ( CC X. CC ) --> CC $=
      cc cc cxp cc cmul wf cmul cc cc cxp wfn vx cv vy cv cmul co cc wcel vy cc
      wral vx cc wral vx vy cc cc cc cmul ffnoprv cmul cc cc cxp wfn cmul wfun
      cmul cdm cc cc cxp wceq cmul cc cc cxp df-fn cmul wfun vx cv cc wcel vy
      cv cc wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz
      cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv
      cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex
      wa vx vy vz copab2 wfun vx cv cc wcel vy cv cc wcel wa vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r vv
      cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr
      co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r vv
      cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr
      co cop wceq wa vf wex vu wex vv wex vw wex vx cv cc wcel vy cv cc wcel wa
      vz vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv
      vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw
      cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex vz wmo vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu cv cmr
      co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv
      cmr co cplr co cop wceq wa vf wex vu wex wa vv wex vw wex vz wmo vy cv vu
      cv vf cv cop wceq vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co
      cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex
      vu wex vz vw vv vx cv vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co
      cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq vz
      vu vf vy cv vz vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co
      vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop moeq mosubop mosubop vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv
      cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf
      cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex vx cv vw cv vv
      cv cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu cv cmr co cm1r vv
      cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr
      co cop wceq wa vf wex vu wex wa vv wex vw wex vz vx cv vw cv vv cv cop
      wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r vv cv vf
      cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co
      cop wceq wa vf wex vu wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv
      cop wceq vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co
      vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex
      wa vw vv vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv
      vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr
      co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vx cv vw cv vv cv
      cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu cv cmr co cm1r vv cv
      vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co
      cop wceq wa wa vf wex vu wex vx cv vw cv vv cv cop wceq vy cv vu cv vf cv
      cop wceq vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co
      vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex
      wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv
      vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw
      cv vf cv cmr co cplr co cop wceq wa vx cv vw cv vv cv cop wceq vy cv vu
      cv vf cv cop wceq vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co
      cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa wa vu
      vf vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq vz cv vw cv vu
      cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv
      vf cv cmr co cplr co cop wceq anass 2exbii vx cv vw cv vv cv cop wceq vy
      cv vu cv vf cv cop wceq vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co
      cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa
      vu vf 19.42vv bitri 2exbii mobii mpbir moani funoprab cmul vx cv cc wcel
      vy cv cc wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa
      vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu
      cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw
      wex wa vx vy vz copab2 wceq cmul wfun vx cv cc wcel vy cv cc wcel wa vx
      cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu cv
      cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv vf
      cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz
      copab2 wfun wb vx vy vz vw vv vu vf df-mul cmul vx cv cc wcel vy cv cc
      wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw
      cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co
      vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx
      vy vz copab2 funeq ax-mp mpbir cmul cdm cc cc cxp cmul cdm vx cv cc wcel
      vy cv cc wcel wa vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa
      vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu
      cv cmr co vw cv vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw
      wex wa vx vy vz copab2 cdm cc cc cxp cmul vx cv cc wcel vy cv cc wcel wa
      vx cv vw cv vv cv cop wceq vy cv vu cv vf cv cop wceq wa vz cv vw cv vu
      cv cmr co cm1r vv cv vf cv cmr co cmr co cplr co vv cv vu cv cmr co vw cv
      vf cv cmr co cplr co cop wceq wa vf wex vu wex vv wex vw wex wa vx vy vz
      copab2 vx vy vz vw vv vu vf df-mul dmeqi vx cv vw cv vv cv cop wceq vy cv
      vu cv vf cv cop wceq wa vz cv vw cv vu cv cmr co cm1r vv cv vf cv cmr co
      cmr co cplr co vv cv vu cv cmr co vw cv vf cv cmr co cplr co cop wceq wa
      vf wex vu wex vv wex vw wex vx vy vz cc cc dmoprabss eqsstri vx vy cc
      cmul 0ncn vx cv cc wcel vy cv cc wcel wa vx cv vy cv cmul co cnr cnr cxp
      cc vz cv vw cv cop vv cv vu cv cop cmul co cnr cnr cxp wcel vx cv vv cv
      vu cv cop cmul co cnr cnr cxp wcel vx cv vy cv cmul co cnr cnr cxp wcel
      vz vw vv vu vx cv vy cv cnr cnr cc df-c vz cv vw cv cop vx cv wceq vz cv
      vw cv cop vv cv vu cv cop cmul co vx cv vv cv vu cv cop cmul co cnr cnr
      cxp vz cv vw cv cop vx cv vv cv vu cv cop cmul opreq1 eleq1d vv cv vu cv
      cop vy cv wceq vx cv vv cv vu cv cop cmul co vx cv vy cv cmul co cnr cnr
      cxp vv cv vu cv cop vy cv vx cv cmul opreq2 eleq1d vz cv cnr wcel vw cv
      cnr wcel wa vv cv cnr wcel vu cv cnr wcel wa wa vz cv vw cv cop vv cv vu
      cv cop cmul co vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co
      vw cv vv cv cmr co vz cv vu cv cmr co cplr co cop cnr cnr cxp vz cv vw cv
      vv cv vu cv mulcnsr vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co
      cplr co cnr wcel vw cv vv cv cmr co vz cv vu cv cmr co cplr co cnr wcel
      vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co vw cv vv cv cmr
      co vz cv vu cv cmr co cplr co cop cnr cnr cxp wcel vz cv cnr wcel vw cv
      cnr wcel wa vv cv cnr wcel vu cv cnr wcel wa wa vz cv vv cv cmr co cm1r
      vw cv vu cv cmr co cmr co cplr co vw cv vv cv cmr co vz cv vu cv cmr co
      cplr co cnr cnr opelxpi vz cv cnr wcel vv cv cnr wcel vw cv cnr wcel vu
      cv cnr wcel vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co cnr
      wcel vz cv vv cv cmr co cnr wcel cm1r vw cv vu cv cmr co cmr co cnr wcel
      vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co cnr wcel vz cv
      cnr wcel vv cv cnr wcel wa vw cv cnr wcel vu cv cnr wcel wa vz cv vv cv
      cmr co cm1r vw cv vu cv cmr co cmr co addclsr vz cv vv cv mulclsr cm1r
      cnr wcel vw cv vu cv cmr co cnr wcel cm1r vw cv vu cv cmr co cmr co cnr
      wcel vw cv cnr wcel vu cv cnr wcel wa cm1r vw cv vu cv cmr co mulclsr m1r
      vw cv vu cv mulclsr sylancr syl2an an4s vz cv cnr wcel vu cv cnr wcel vw
      cv cnr wcel vv cv cnr wcel vw cv vv cv cmr co vz cv vu cv cmr co cplr co
      cnr wcel vw cv cnr wcel vv cv cnr wcel wa vz cv cnr wcel vu cv cnr wcel
      wa vw cv vv cv cmr co vz cv vu cv cmr co cplr co cnr wcel vw cv vv cv cmr
      co cnr wcel vz cv vu cv cmr co cnr wcel vw cv vv cv cmr co vz cv vu cv
      cmr co cplr co cnr wcel vw cv cnr wcel vv cv cnr wcel wa vz cv cnr wcel
      vu cv cnr wcel wa vw cv vv cv cmr co vz cv vu cv cmr co addclsr vw cv vv
      cv mulclsr vz cv vu cv mulclsr syl2an ancoms an42s sylanc eqeltrd 2optocl
      df-c syl6eleqr oprssdm eqssi mpbir2an vx cv vy cv cmul co cc wcel vx vy
      cc vx cv cc wcel vy cv cc wcel wa vx cv vy cv cmul co cnr cnr cxp cc vz
      cv vw cv cop vv cv vu cv cop cmul co cnr cnr cxp wcel vx cv vv cv vu cv
      cop cmul co cnr cnr cxp wcel vx cv vy cv cmul co cnr cnr cxp wcel vz vw
      vv vu vx cv vy cv cnr cnr cc df-c vz cv vw cv cop vx cv wceq vz cv vw cv
      cop vv cv vu cv cop cmul co vx cv vv cv vu cv cop cmul co cnr cnr cxp vz
      cv vw cv cop vx cv vv cv vu cv cop cmul opreq1 eleq1d vv cv vu cv cop vy
      cv wceq vx cv vv cv vu cv cop cmul co vx cv vy cv cmul co cnr cnr cxp vv
      cv vu cv cop vy cv vx cv cmul opreq2 eleq1d vz cv cnr wcel vw cv cnr wcel
      wa vv cv cnr wcel vu cv cnr wcel wa wa vz cv vw cv cop vv cv vu cv cop
      cmul co vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co vw cv
      vv cv cmr co vz cv vu cv cmr co cplr co cop cnr cnr cxp vz cv vw cv vv cv
      vu cv mulcnsr vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co
      cnr wcel vw cv vv cv cmr co vz cv vu cv cmr co cplr co cnr wcel vz cv vv
      cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co vw cv vv cv cmr co vz cv
      vu cv cmr co cplr co cop cnr cnr cxp wcel vz cv cnr wcel vw cv cnr wcel
      wa vv cv cnr wcel vu cv cnr wcel wa wa vz cv vv cv cmr co cm1r vw cv vu
      cv cmr co cmr co cplr co vw cv vv cv cmr co vz cv vu cv cmr co cplr co
      cnr cnr opelxpi vz cv cnr wcel vv cv cnr wcel vw cv cnr wcel vu cv cnr
      wcel vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co cnr wcel
      vz cv vv cv cmr co cnr wcel cm1r vw cv vu cv cmr co cmr co cnr wcel vz cv
      vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co cnr wcel vz cv cnr
      wcel vv cv cnr wcel wa vw cv cnr wcel vu cv cnr wcel wa vz cv vv cv cmr
      co cm1r vw cv vu cv cmr co cmr co addclsr vz cv vv cv mulclsr cm1r cnr
      wcel vw cv vu cv cmr co cnr wcel cm1r vw cv vu cv cmr co cmr co cnr wcel
      vw cv cnr wcel vu cv cnr wcel wa cm1r vw cv vu cv cmr co mulclsr m1r vw
      cv vu cv mulclsr sylancr syl2an an4s vz cv cnr wcel vu cv cnr wcel vw cv
      cnr wcel vv cv cnr wcel vw cv vv cv cmr co vz cv vu cv cmr co cplr co cnr
      wcel vw cv cnr wcel vv cv cnr wcel wa vz cv cnr wcel vu cv cnr wcel wa vw
      cv vv cv cmr co vz cv vu cv cmr co cplr co cnr wcel vw cv vv cv cmr co
      cnr wcel vz cv vu cv cmr co cnr wcel vw cv vv cv cmr co vz cv vu cv cmr
      co cplr co cnr wcel vw cv cnr wcel vv cv cnr wcel wa vz cv cnr wcel vu cv
      cnr wcel wa vw cv vv cv cmr co vz cv vu cv cmr co addclsr vw cv vv cv
      mulclsr vz cv vu cv mulclsr syl2an ancoms an42s sylanc eqeltrd 2optocl
      df-c syl6eleqr rgen2a mpbir2an $.
      $( [9-Feb-2005] $) $( [8-Feb-2005] $)
  $}

  $( The class of complex numbers is a set, i.e. it is a member of the universe
     of sets ` _V ` (see ~ isset ).  Axiom 1 of 25 for real and complex
     numbers, derived from ZF set theory. $)
  axcnex $p |- CC e. _V $=
    cc cnr cnr cxp cvv df-c cnr cnr srex srex xpex eqeltri $.
    $( [13-Aug-1995] $)

  $( The real numbers are a subset of the complex numbers.  Axiom 2 of 25
     for real and complex numbers, derived from ZF set theory. $)
  axresscn $p |- RR C_ CC $=
    cnr c0r csn cxp cnr cnr cxp cr cc cnr cnr wss c0r csn cnr wss cnr c0r csn
    cxp cnr cnr cxp wss cnr ssid c0r cnr wcel c0r csn cnr wss 0r c0r cnr snssi
    ax-mp cnr cnr c0r csn cnr ssxp mp2an df-r df-c 3sstr4i $.
    $( [1-Mar-1995] $)

  $( 1 is a complex number.  Axiom 3 of 25 for real and complex numbers,
     derived from ZF set theory. $)
  ax1cn $p |- 1 e. CC $=
    cr cc c1 axresscn c1 c1r c0r cop cr df-1 c1r c0r cop cr wcel c1r cnr wcel
    1r c1r opelreal mpbir eqeltri sselii $.
    $( [12-Apr-2007] $) $( [12-Apr-2007] $)

  $( ` _i ` is a complex number.  Axiom 4 of 25 for real and complex
     numbers, derived from ZF set theory. $)
  axicn $p |- _i e. CC $=
    ci cc wcel c0r cnr wcel c1r cnr wcel ci cc wcel c0r c1r cop cc wcel c0r cnr
    wcel c1r cnr wcel wa ci c0r c1r cop cc df-i eleq1i c0r c1r c1r cnr 1r
    elisseti opelcn bitri 0r 1r mpbir2an $.
    $( [23-Feb-1996] $)

  ${
    $d x y A $.  $d x y B $.
    $( Closure law for addition of complex numbers.  Axiom 5 of 25 for
       real and complex numbers, derived from ZF set theory. $)
    axaddcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) e. CC ) $=
      cA cB cc cc cc caddc axaddopr foprcl $.
      $( [14-Jun-1995] $)

    $( Closure law for addition in the real subfield of complex numbers.  Axiom
       6 of 25 for real and complex numbers, derived from ZF set
       theory. $)
    axaddrcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A + B ) e. RR ) $=
      vx cv c0r cop vy cv c0r cop caddc co cr wcel cA vy cv c0r cop caddc co cr
      wcel cA cB caddc co cr wcel vx vy vx cv c0r cop vy cv c0r cop cA cB cnr
      cr vx cA elreal vy cB elreal vx cv c0r cop cA wceq vx cv c0r cop vy cv
      c0r cop caddc co cA vy cv c0r cop caddc co cr vx cv c0r cop cA vy cv c0r
      cop caddc opreq1 eleq1d vy cv c0r cop cB wceq cA vy cv c0r cop caddc co
      cA cB caddc co cr vy cv c0r cop cB cA caddc opreq2 eleq1d vx cv cnr wcel
      vy cv cnr wcel wa vx cv c0r cop vy cv c0r cop caddc co vx cv vy cv cplr
      co c0r cop cr vx cv vy cv addresr vx cv cnr wcel vy cv cnr wcel wa vx cv
      vy cv cplr co cnr wcel vx cv vy cv cplr co c0r cop cr wcel vx cv vy cv
      addclsr vx cv vy cv cplr co opelreal sylibr eqeltrd 2gencl $.
      $( [31-Mar-1996] $)

    $( Closure law for multiplication of complex numbers.  Axiom 7 of 25
       for real and complex numbers, derived from ZF set theory. $)
    axmulcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) e. CC ) $=
      cA cB cc cc cc cmul axmulopr foprcl $.
      $( [10-Aug-1995] $)

    $( Closure law for multiplication in the real subfield of complex numbers.
       Axiom 8 of 25 for real and complex numbers, derived from ZF set
       theory. $)
    axmulrcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A x. B ) e. RR ) $=
      vx cv c0r cop vy cv c0r cop cmul co cr wcel cA vy cv c0r cop cmul co cr
      wcel cA cB cmul co cr wcel vx vy vx cv c0r cop vy cv c0r cop cA cB cnr cr
      vx cA elreal vy cB elreal vx cv c0r cop cA wceq vx cv c0r cop vy cv c0r
      cop cmul co cA vy cv c0r cop cmul co cr vx cv c0r cop cA vy cv c0r cop
      cmul opreq1 eleq1d vy cv c0r cop cB wceq cA vy cv c0r cop cmul co cA cB
      cmul co cr vy cv c0r cop cB cA cmul opreq2 eleq1d vx cv cnr wcel vy cv
      cnr wcel wa vx cv c0r cop vy cv c0r cop cmul co vx cv vy cv cmr co c0r
      cop cr vx cv vy cv vy visset mulresr vx cv cnr wcel vy cv cnr wcel wa vx
      cv vy cv cmr co cnr wcel vx cv vy cv cmr co c0r cop cr wcel vx cv vy cv
      mulclsr vx cv vy cv cmr co opelreal sylibr eqeltrd 2gencl $.
      $( [31-Mar-1996] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Addition of complex numbers is commutative.  Axiom 9 of 25 for
       real and complex numbers, derived from ZF set theory. $)
    axaddcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) = ( B + A ) ) $=
      vx vy vz vw cA cB cc vx cv vz cv cplr co cep ccnv cnr caddc vy cv vw cv
      cplr co vz cv vx cv cplr co vw cv vy cv cplr co dfcnqs vx cv vy cv vz cv
      vw cv addcnsrec vz cv vw cv vx cv vy cv addcnsrec vx cv vz cv vx visset
      vz visset addcomsr vy cv vw cv vy visset vw visset addcomsr ecoprcom $.
      $( [31-Aug-1995] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Multiplication of complex numbers is commutative.  Axiom 10 of 25
       for real and complex numbers, derived from ZF set theory. $)
    axmulcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) = ( B x. A ) ) $=
      vx vy vz vw cA cB cc vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co
      cplr co cep ccnv cnr cmul vy cv vz cv cmr co vx cv vw cv cmr co cplr co
      vz cv vx cv cmr co cm1r vw cv vy cv cmr co cmr co cplr co vw cv vx cv cmr
      co vz cv vy cv cmr co cplr co dfcnqs vx cv vy cv vz cv vw cv mulcnsrec vz
      cv vw cv vx cv vy cv mulcnsrec vx cv vz cv cmr co vz cv vx cv cmr co cm1r
      vy cv vw cv cmr co cmr co cm1r vw cv vy cv cmr co cmr co cplr vx cv vz cv
      vx visset vz visset mulcomsr vy cv vw cv cmr co vw cv vy cv cmr co cm1r
      cmr vy cv vw cv vy visset vw visset mulcomsr opreq2i opreq12i vy cv vz cv
      cmr co vx cv vw cv cmr co cplr co vz cv vy cv cmr co vw cv vx cv cmr co
      cplr co vw cv vx cv cmr co vz cv vy cv cmr co cplr co vy cv vz cv cmr co
      vz cv vy cv cmr co vx cv vw cv cmr co vw cv vx cv cmr co cplr vy cv vz cv
      vy visset vz visset mulcomsr vx cv vw cv vx visset vw visset mulcomsr
      opreq12i vz cv vy cv cmr co vw cv vx cv cmr co vz cv vy cv cmr oprex vw
      cv vx cv cmr oprex addcomsr eqtri ecoprcom $.
      $( [31-Aug-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.

    $( Addition of complex numbers is associative.  This theorem transfers the
       associative laws for the real and imaginary signed real components of
       complex number pairs, to complex number addition itself.  Axiom 11 of
       25 for real and complex numbers, derived from ZF set theory. $)
    axaddass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A + B ) + C ) = ( A + ( B + C ) ) ) $=
      vx vy vz vw vv vu cA cB cC cc vw cv vu cv cplr co cep ccnv cnr caddc vx
      cv vz cv cplr co vy cv vw cv cplr co vx cv vz cv cplr co vv cv cplr co vy
      cv vw cv cplr co vu cv cplr co vx cv vz cv vv cv cplr co cplr co vy cv vw
      cv vu cv cplr co cplr co vz cv vv cv cplr co dfcnqs vx cv vy cv vz cv vw
      cv addcnsrec vz cv vw cv vv cv vu cv addcnsrec vx cv vz cv cplr co vy cv
      vw cv cplr co vv cv vu cv addcnsrec vx cv vy cv vz cv vv cv cplr co vw cv
      vu cv cplr co addcnsrec vx cv cnr wcel vz cv cnr wcel vy cv cnr wcel vw
      cv cnr wcel vx cv vz cv cplr co cnr wcel vy cv vw cv cplr co cnr wcel wa
      vx cv cnr wcel vz cv cnr wcel wa vx cv vz cv cplr co cnr wcel vy cv cnr
      wcel vw cv cnr wcel wa vy cv vw cv cplr co cnr wcel vx cv vz cv addclsr
      vy cv vw cv addclsr anim12i an4s vz cv cnr wcel vv cv cnr wcel vw cv cnr
      wcel vu cv cnr wcel vz cv vv cv cplr co cnr wcel vw cv vu cv cplr co cnr
      wcel wa vz cv cnr wcel vv cv cnr wcel wa vz cv vv cv cplr co cnr wcel vw
      cv cnr wcel vu cv cnr wcel wa vw cv vu cv cplr co cnr wcel vz cv vv cv
      addclsr vw cv vu cv addclsr anim12i an4s vx cv vz cv vv cv vz visset vv
      visset addasssr vy cv vw cv vu cv vw visset vu visset addasssr ecoprass
      $.
      $( [2-Sep-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    $( Multiplication of complex numbers is associative.  Axiom 12 of 25
       for real and complex numbers, derived from ZF set theory. $)
    axmulass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) ) $=
      vx vy vz vw vv vu cA cB cC cc vw cv vv cv cmr co vz cv vu cv cmr co cplr
      co cep ccnv cnr cmul vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co
      cplr co vy cv vz cv cmr co vx cv vw cv cmr co cplr co vx cv vz cv cmr co
      cm1r vy cv vw cv cmr co cmr co cplr co vv cv cmr co cm1r vy cv vz cv cmr
      co vx cv vw cv cmr co cplr co vu cv cmr co cmr co cplr co vy cv vz cv cmr
      co vx cv vw cv cmr co cplr co vv cv cmr co vx cv vz cv cmr co cm1r vy cv
      vw cv cmr co cmr co cplr co vu cv cmr co cplr co vx cv vz cv vv cv cmr co
      cm1r vw cv vu cv cmr co cmr co cplr co cmr co cm1r vy cv vw cv vv cv cmr
      co vz cv vu cv cmr co cplr co cmr co cmr co cplr co vy cv vz cv vv cv cmr
      co cm1r vw cv vu cv cmr co cmr co cplr co cmr co vx cv vw cv vv cv cmr co
      vz cv vu cv cmr co cplr co cmr co cplr co vz cv vv cv cmr co cm1r vw cv
      vu cv cmr co cmr co cplr co dfcnqs vx cv vy cv vz cv vw cv mulcnsrec vz
      cv vw cv vv cv vu cv mulcnsrec vx cv vz cv cmr co cm1r vy cv vw cv cmr co
      cmr co cplr co vy cv vz cv cmr co vx cv vw cv cmr co cplr co vv cv vu cv
      mulcnsrec vx cv vy cv vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co
      cplr co vw cv vv cv cmr co vz cv vu cv cmr co cplr co mulcnsrec vx cv cnr
      wcel vy cv cnr wcel wa vz cv cnr wcel vw cv cnr wcel wa wa vx cv vz cv
      cmr co cm1r vy cv vw cv cmr co cmr co cplr co cnr wcel vy cv vz cv cmr co
      vx cv vw cv cmr co cplr co cnr wcel vx cv cnr wcel vz cv cnr wcel vy cv
      cnr wcel vw cv cnr wcel vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co
      cplr co cnr wcel vx cv vz cv cmr co cnr wcel cm1r vy cv vw cv cmr co cmr
      co cnr wcel vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co cplr co cnr
      wcel vx cv cnr wcel vz cv cnr wcel wa vy cv cnr wcel vw cv cnr wcel wa vx
      cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co addclsr vx cv vz cv
      mulclsr cm1r cnr wcel vy cv vw cv cmr co cnr wcel cm1r vy cv vw cv cmr co
      cmr co cnr wcel vy cv cnr wcel vw cv cnr wcel wa cm1r vy cv vw cv cmr co
      mulclsr m1r vy cv vw cv mulclsr sylancr syl2an an4s vx cv cnr wcel vw cv
      cnr wcel vy cv cnr wcel vz cv cnr wcel vy cv vz cv cmr co vx cv vw cv cmr
      co cplr co cnr wcel vy cv cnr wcel vz cv cnr wcel wa vx cv cnr wcel vw cv
      cnr wcel wa vy cv vz cv cmr co vx cv vw cv cmr co cplr co cnr wcel vy cv
      vz cv cmr co cnr wcel vx cv vw cv cmr co cnr wcel vy cv vz cv cmr co vx
      cv vw cv cmr co cplr co cnr wcel vy cv cnr wcel vz cv cnr wcel wa vx cv
      cnr wcel vw cv cnr wcel wa vy cv vz cv cmr co vx cv vw cv cmr co addclsr
      vy cv vz cv mulclsr vx cv vw cv mulclsr syl2an ancoms an42s jca vz cv cnr
      wcel vw cv cnr wcel wa vv cv cnr wcel vu cv cnr wcel wa wa vz cv vv cv
      cmr co cm1r vw cv vu cv cmr co cmr co cplr co cnr wcel vw cv vv cv cmr co
      vz cv vu cv cmr co cplr co cnr wcel vz cv cnr wcel vv cv cnr wcel vw cv
      cnr wcel vu cv cnr wcel vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co
      cplr co cnr wcel vz cv vv cv cmr co cnr wcel cm1r vw cv vu cv cmr co cmr
      co cnr wcel vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co cnr
      wcel vz cv cnr wcel vv cv cnr wcel wa vw cv cnr wcel vu cv cnr wcel wa vz
      cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co addclsr vz cv vv cv
      mulclsr cm1r cnr wcel vw cv vu cv cmr co cnr wcel cm1r vw cv vu cv cmr co
      cmr co cnr wcel vw cv cnr wcel vu cv cnr wcel wa cm1r vw cv vu cv cmr co
      mulclsr m1r vw cv vu cv mulclsr sylancr syl2an an4s vz cv cnr wcel vu cv
      cnr wcel vw cv cnr wcel vv cv cnr wcel vw cv vv cv cmr co vz cv vu cv cmr
      co cplr co cnr wcel vw cv cnr wcel vv cv cnr wcel wa vz cv cnr wcel vu cv
      cnr wcel wa vw cv vv cv cmr co vz cv vu cv cmr co cplr co cnr wcel vw cv
      vv cv cmr co cnr wcel vz cv vu cv cmr co cnr wcel vw cv vv cv cmr co vz
      cv vu cv cmr co cplr co cnr wcel vw cv cnr wcel vv cv cnr wcel wa vz cv
      cnr wcel vu cv cnr wcel wa vw cv vv cv cmr co vz cv vu cv cmr co addclsr
      vw cv vv cv mulclsr vz cv vu cv mulclsr syl2an ancoms an42s jca vx cv vz
      cv vv cv cmr co cmr co vx cv cm1r vw cv vu cv cmr co cmr co cmr co cplr
      co cm1r vy cv vw cv vv cv cmr co cmr co cmr co cm1r vy cv vz cv vu cv cmr
      co cmr co cmr co cplr co cplr co vx cv vz cv vv cv cmr co cmr co cm1r vy
      cv vw cv vv cv cmr co cmr co cmr co cplr co cm1r vy cv vz cv vu cv cmr co
      cmr co cmr co vx cv cm1r vw cv vu cv cmr co cmr co cmr co cplr co cplr co
      vx cv vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co cmr co
      cm1r vy cv vw cv vv cv cmr co vz cv vu cv cmr co cplr co cmr co cmr co
      cplr co vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co cplr co vv cv
      cmr co cm1r vy cv vz cv cmr co vx cv vw cv cmr co cplr co vu cv cmr co
      cmr co cplr co vf vg vh vx cv vz cv vv cv cmr co cmr co vx cv cm1r vw cv
      vu cv cmr co cmr co cmr co cm1r vy cv vw cv vv cv cmr co cmr co cmr co
      cm1r vy cv vz cv vu cv cmr co cmr co cmr co cplr vx cv vz cv vv cv cmr co
      cmr oprex vx cv cm1r vw cv vu cv cmr co cmr co cmr oprex cm1r vy cv vw cv
      vv cv cmr co cmr co cmr oprex vf cv vg cv vf visset vg visset addcomsr vf
      cv vg cv vh cv vg visset vh visset addasssr cm1r vy cv vz cv vu cv cmr co
      cmr co cmr oprex caopr42 vx cv vz cv vv cv cmr co cm1r vw cv vu cv cmr co
      cmr co cplr co cmr co vx cv vz cv vv cv cmr co cmr co vx cv cm1r vw cv vu
      cv cmr co cmr co cmr co cplr co cm1r vy cv vw cv vv cv cmr co vz cv vu cv
      cmr co cplr co cmr co cmr co cm1r vy cv vw cv vv cv cmr co cmr co cmr co
      cm1r vy cv vz cv vu cv cmr co cmr co cmr co cplr co cplr vx cv vz cv vv
      cv cmr co cm1r vw cv vu cv cmr co cmr co vz cv vv cv cmr oprex cm1r vw cv
      vu cv cmr co cmr oprex distrsr cm1r vy cv vw cv vv cv cmr co vz cv vu cv
      cmr co cplr co cmr co cmr co cm1r vy cv vw cv vv cv cmr co cmr co vy cv
      vz cv vu cv cmr co cmr co cplr co cmr co cm1r vy cv vw cv vv cv cmr co
      cmr co cmr co cm1r vy cv vz cv vu cv cmr co cmr co cmr co cplr co vy cv
      vw cv vv cv cmr co vz cv vu cv cmr co cplr co cmr co vy cv vw cv vv cv
      cmr co cmr co vy cv vz cv vu cv cmr co cmr co cplr co cm1r cmr vy cv vw
      cv vv cv cmr co vz cv vu cv cmr co vw cv vv cv cmr oprex vz cv vu cv cmr
      oprex distrsr opreq2i cm1r vy cv vw cv vv cv cmr co cmr co vy cv vz cv vu
      cv cmr co cmr co vy cv vw cv vv cv cmr co cmr oprex vy cv vz cv vu cv cmr
      co cmr oprex distrsr eqtri opreq12i vx cv vz cv cmr co cm1r vy cv vw cv
      cmr co cmr co cplr co vv cv cmr co vx cv vz cv vv cv cmr co cmr co cm1r
      vy cv vw cv vv cv cmr co cmr co cmr co cplr co cm1r vy cv vz cv cmr co vx
      cv vw cv cmr co cplr co vu cv cmr co cmr co cm1r vy cv vz cv vu cv cmr co
      cmr co cmr co vx cv cm1r vw cv vu cv cmr co cmr co cmr co cplr co cplr vx
      cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co cplr co vv cv cmr co vx cv
      vz cv vv cv cmr co cmr co cm1r vy cv vw cv cmr co vv cv cmr co cmr co
      cplr co vx cv vz cv vv cv cmr co cmr co cm1r vy cv vw cv vv cv cmr co cmr
      co cmr co cplr co vf vg vh vx cv cm1r vz cv vy cv vw cv cmr co cplr cmr
      vv cv vx visset cm1r cnr m1r elisseti vz visset vf cv vg cv vf visset vg
      visset mulcomsr vf cv vg cv vh cv vg visset vh visset distrsr vy cv vw cv
      cmr oprex vv visset vf cv vg cv vh cv vg visset vh visset mulasssr
      caoprdilem cm1r vy cv vw cv cmr co vv cv cmr co cmr co cm1r vy cv vw cv
      vv cv cmr co cmr co cmr co vx cv vz cv vv cv cmr co cmr co cplr vy cv vw
      cv cmr co vv cv cmr co vy cv vw cv vv cv cmr co cmr co cm1r cmr vy cv vw
      cv vv cv vw visset vv visset mulasssr opreq2i opreq2i eqtri cm1r vy cv vz
      cv cmr co vx cv vw cv cmr co cplr co vu cv cmr co cmr co cm1r vy cv vz cv
      vu cv cmr co cmr co vx cv vw cv vu cv cmr co cmr co cplr co cmr co cm1r
      vy cv vz cv vu cv cmr co cmr co cmr co cm1r vx cv vw cv vu cv cmr co cmr
      co cmr co cplr co cm1r vy cv vz cv vu cv cmr co cmr co cmr co vx cv cm1r
      vw cv vu cv cmr co cmr co cmr co cplr co vy cv vz cv cmr co vx cv vw cv
      cmr co cplr co vu cv cmr co vy cv vz cv vu cv cmr co cmr co vx cv vw cv
      vu cv cmr co cmr co cplr co cm1r cmr vf vg vh vy cv vx cv vz cv vw cv
      cplr cmr vu cv vy visset vx visset vz visset vf cv vg cv vf visset vg
      visset mulcomsr vf cv vg cv vh cv vg visset vh visset distrsr vw visset
      vu visset vf cv vg cv vh cv vg visset vh visset mulasssr caoprdilem
      opreq2i cm1r vy cv vz cv vu cv cmr co cmr co vx cv vw cv vu cv cmr co cmr
      co vy cv vz cv vu cv cmr co cmr oprex vx cv vw cv vu cv cmr co cmr oprex
      distrsr cm1r vx cv vw cv vu cv cmr co cmr co cmr co vx cv cm1r vw cv vu
      cv cmr co cmr co cmr co cm1r vy cv vz cv vu cv cmr co cmr co cmr co cplr
      vf vg vh cm1r vx cv vw cv vu cv cmr co cmr cm1r cnr m1r elisseti vx
      visset vw cv vu cv cmr oprex vf cv vg cv vf visset vg visset mulcomsr vf
      cv vg cv vh cv vg visset vh visset mulasssr caopr12 opreq2i 3eqtri
      opreq12i 3eqtr4ri vy cv vz cv vv cv cmr co cmr co vy cv cm1r vw cv vu cv
      cmr co cmr co cmr co cplr co vx cv vw cv vv cv cmr co cmr co vx cv vz cv
      vu cv cmr co cmr co cplr co cplr co vy cv vz cv vv cv cmr co cmr co vx cv
      vw cv vv cv cmr co cmr co cplr co vx cv vz cv vu cv cmr co cmr co vy cv
      cm1r vw cv vu cv cmr co cmr co cmr co cplr co cplr co vy cv vz cv vv cv
      cmr co cm1r vw cv vu cv cmr co cmr co cplr co cmr co vx cv vw cv vv cv
      cmr co vz cv vu cv cmr co cplr co cmr co cplr co vy cv vz cv cmr co vx cv
      vw cv cmr co cplr co vv cv cmr co vx cv vz cv cmr co cm1r vy cv vw cv cmr
      co cmr co cplr co vu cv cmr co cplr co vf vg vh vy cv vz cv vv cv cmr co
      cmr co vy cv cm1r vw cv vu cv cmr co cmr co cmr co vx cv vw cv vv cv cmr
      co cmr co vx cv vz cv vu cv cmr co cmr co cplr vy cv vz cv vv cv cmr co
      cmr oprex vy cv cm1r vw cv vu cv cmr co cmr co cmr oprex vx cv vw cv vv
      cv cmr co cmr oprex vf cv vg cv vf visset vg visset addcomsr vf cv vg cv
      vh cv vg visset vh visset addasssr vx cv vz cv vu cv cmr co cmr oprex
      caopr42 vy cv vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co cplr co
      cmr co vy cv vz cv vv cv cmr co cmr co vy cv cm1r vw cv vu cv cmr co cmr
      co cmr co cplr co vx cv vw cv vv cv cmr co vz cv vu cv cmr co cplr co cmr
      co vx cv vw cv vv cv cmr co cmr co vx cv vz cv vu cv cmr co cmr co cplr
      co cplr vy cv vz cv vv cv cmr co cm1r vw cv vu cv cmr co cmr co vz cv vv
      cv cmr oprex cm1r vw cv vu cv cmr co cmr oprex distrsr vx cv vw cv vv cv
      cmr co vz cv vu cv cmr co vw cv vv cv cmr oprex vz cv vu cv cmr oprex
      distrsr opreq12i vy cv vz cv cmr co vx cv vw cv cmr co cplr co vv cv cmr
      co vy cv vz cv vv cv cmr co cmr co vx cv vw cv vv cv cmr co cmr co cplr
      co vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co cplr co vu cv cmr co
      vx cv vz cv vu cv cmr co cmr co vy cv cm1r vw cv vu cv cmr co cmr co cmr
      co cplr co cplr vf vg vh vy cv vx cv vz cv vw cv cplr cmr vv cv vy visset
      vx visset vz visset vf cv vg cv vf visset vg visset mulcomsr vf cv vg cv
      vh cv vg visset vh visset distrsr vw visset vv visset vf cv vg cv vh cv
      vg visset vh visset mulasssr caoprdilem vx cv vz cv cmr co cm1r vy cv vw
      cv cmr co cmr co cplr co vu cv cmr co vx cv vz cv vu cv cmr co cmr co
      cm1r vy cv vw cv cmr co vu cv cmr co cmr co cplr co vx cv vz cv vu cv cmr
      co cmr co vy cv cm1r vw cv vu cv cmr co cmr co cmr co cplr co vf vg vh vx
      cv cm1r vz cv vy cv vw cv cmr co cplr cmr vu cv vx visset cm1r cnr m1r
      elisseti vz visset vf cv vg cv vf visset vg visset mulcomsr vf cv vg cv
      vh cv vg visset vh visset distrsr vy cv vw cv cmr oprex vu visset vf cv
      vg cv vh cv vg visset vh visset mulasssr caoprdilem cm1r vy cv vw cv cmr
      co vu cv cmr co cmr co vy cv cm1r vw cv vu cv cmr co cmr co cmr co vx cv
      vz cv vu cv cmr co cmr co cplr cm1r vy cv vw cv cmr co vu cv cmr co cmr
      co cm1r vy cv vw cv vu cv cmr co cmr co cmr co vy cv cm1r vw cv vu cv cmr
      co cmr co cmr co vy cv vw cv cmr co vu cv cmr co vy cv vw cv vu cv cmr co
      cmr co cm1r cmr vy cv vw cv vu cv vw visset vu visset mulasssr opreq2i vf
      vg vh cm1r vy cv vw cv vu cv cmr co cmr cm1r cnr m1r elisseti vy visset
      vw cv vu cv cmr oprex vf cv vg cv vf visset vg visset mulcomsr vf cv vg
      cv vh cv vg visset vh visset mulasssr caopr12 eqtri opreq2i eqtri
      opreq12i 3eqtr4ri ecoprass $.
      $( [3-Sep-1995] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    $( Distributive law for complex numbers.  Axiom 13 of 25 for real and
       complex numbers, derived from ZF set theory. $)
    axdistr $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) ) $=
      vx vy vz vw vv vu cA cB cC cc cep ccnv cnr caddc cmul vx cv vz cv vv cv
      cplr co cmr co cm1r vy cv vw cv vu cv cplr co cmr co cmr co cplr co vy cv
      vz cv vv cv cplr co cmr co vx cv vw cv vu cv cplr co cmr co cplr co vx cv
      vz cv cmr co cm1r vy cv vw cv cmr co cmr co cplr co vx cv vv cv cmr co
      cm1r vy cv vu cv cmr co cmr co cplr co cplr co vy cv vz cv cmr co vx cv
      vw cv cmr co cplr co vy cv vv cv cmr co vx cv vu cv cmr co cplr co cplr
      co vz cv vv cv cplr co vw cv vu cv cplr co vx cv vz cv cmr co cm1r vy cv
      vw cv cmr co cmr co cplr co vy cv vz cv cmr co vx cv vw cv cmr co cplr co
      vx cv vv cv cmr co cm1r vy cv vu cv cmr co cmr co cplr co vy cv vv cv cmr
      co vx cv vu cv cmr co cplr co dfcnqs vz cv vw cv vv cv vu cv addcnsrec vx
      cv vy cv vz cv vv cv cplr co vw cv vu cv cplr co mulcnsrec vx cv vy cv vz
      cv vw cv mulcnsrec vx cv vy cv vv cv vu cv mulcnsrec vx cv vz cv cmr co
      cm1r vy cv vw cv cmr co cmr co cplr co vy cv vz cv cmr co vx cv vw cv cmr
      co cplr co vx cv vv cv cmr co cm1r vy cv vu cv cmr co cmr co cplr co vy
      cv vv cv cmr co vx cv vu cv cmr co cplr co addcnsrec vz cv cnr wcel vv cv
      cnr wcel vw cv cnr wcel vu cv cnr wcel vz cv vv cv cplr co cnr wcel vw cv
      vu cv cplr co cnr wcel wa vz cv cnr wcel vv cv cnr wcel wa vz cv vv cv
      cplr co cnr wcel vw cv cnr wcel vu cv cnr wcel wa vw cv vu cv cplr co cnr
      wcel vz cv vv cv addclsr vw cv vu cv addclsr anim12i an4s vx cv cnr wcel
      vy cv cnr wcel wa vz cv cnr wcel vw cv cnr wcel wa wa vx cv vz cv cmr co
      cm1r vy cv vw cv cmr co cmr co cplr co cnr wcel vy cv vz cv cmr co vx cv
      vw cv cmr co cplr co cnr wcel vx cv cnr wcel vz cv cnr wcel vy cv cnr
      wcel vw cv cnr wcel vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co
      cplr co cnr wcel vx cv vz cv cmr co cnr wcel cm1r vy cv vw cv cmr co cmr
      co cnr wcel vx cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co cplr co cnr
      wcel vx cv cnr wcel vz cv cnr wcel wa vy cv cnr wcel vw cv cnr wcel wa vx
      cv vz cv cmr co cm1r vy cv vw cv cmr co cmr co addclsr vx cv vz cv
      mulclsr cm1r cnr wcel vy cv vw cv cmr co cnr wcel cm1r vy cv vw cv cmr co
      cmr co cnr wcel vy cv cnr wcel vw cv cnr wcel wa cm1r vy cv vw cv cmr co
      mulclsr m1r vy cv vw cv mulclsr sylancr syl2an an4s vx cv cnr wcel vw cv
      cnr wcel vy cv cnr wcel vz cv cnr wcel vy cv vz cv cmr co vx cv vw cv cmr
      co cplr co cnr wcel vy cv cnr wcel vz cv cnr wcel wa vx cv cnr wcel vw cv
      cnr wcel wa vy cv vz cv cmr co vx cv vw cv cmr co cplr co cnr wcel vy cv
      vz cv cmr co cnr wcel vx cv vw cv cmr co cnr wcel vy cv vz cv cmr co vx
      cv vw cv cmr co cplr co cnr wcel vy cv cnr wcel vz cv cnr wcel wa vx cv
      cnr wcel vw cv cnr wcel wa vy cv vz cv cmr co vx cv vw cv cmr co addclsr
      vy cv vz cv mulclsr vx cv vw cv mulclsr syl2an ancoms an42s jca vx cv cnr
      wcel vy cv cnr wcel wa vv cv cnr wcel vu cv cnr wcel wa wa vx cv vv cv
      cmr co cm1r vy cv vu cv cmr co cmr co cplr co cnr wcel vy cv vv cv cmr co
      vx cv vu cv cmr co cplr co cnr wcel vx cv cnr wcel vv cv cnr wcel vy cv
      cnr wcel vu cv cnr wcel vx cv vv cv cmr co cm1r vy cv vu cv cmr co cmr co
      cplr co cnr wcel vx cv vv cv cmr co cnr wcel cm1r vy cv vu cv cmr co cmr
      co cnr wcel vx cv vv cv cmr co cm1r vy cv vu cv cmr co cmr co cplr co cnr
      wcel vx cv cnr wcel vv cv cnr wcel wa vy cv cnr wcel vu cv cnr wcel wa vx
      cv vv cv cmr co cm1r vy cv vu cv cmr co cmr co addclsr vx cv vv cv
      mulclsr cm1r cnr wcel vy cv vu cv cmr co cnr wcel cm1r vy cv vu cv cmr co
      cmr co cnr wcel vy cv cnr wcel vu cv cnr wcel wa cm1r vy cv vu cv cmr co
      mulclsr m1r vy cv vu cv mulclsr sylancr syl2an an4s vx cv cnr wcel vu cv
      cnr wcel vy cv cnr wcel vv cv cnr wcel vy cv vv cv cmr co vx cv vu cv cmr
      co cplr co cnr wcel vy cv cnr wcel vv cv cnr wcel wa vx cv cnr wcel vu cv
      cnr wcel wa vy cv vv cv cmr co vx cv vu cv cmr co cplr co cnr wcel vy cv
      vv cv cmr co cnr wcel vx cv vu cv cmr co cnr wcel vy cv vv cv cmr co vx
      cv vu cv cmr co cplr co cnr wcel vy cv cnr wcel vv cv cnr wcel wa vx cv
      cnr wcel vu cv cnr wcel wa vy cv vv cv cmr co vx cv vu cv cmr co addclsr
      vy cv vv cv mulclsr vx cv vu cv mulclsr syl2an ancoms an42s jca vx cv vz
      cv vv cv cplr co cmr co cm1r vy cv vw cv vu cv cplr co cmr co cmr co cplr
      co vx cv vz cv cmr co vx cv vv cv cmr co cplr co cm1r vy cv vw cv cmr co
      cmr co cm1r vy cv vu cv cmr co cmr co cplr co cplr co vx cv vz cv cmr co
      cm1r vy cv vw cv cmr co cmr co cplr co vx cv vv cv cmr co cm1r vy cv vu
      cv cmr co cmr co cplr co cplr co vx cv vz cv vv cv cplr co cmr co vx cv
      vz cv cmr co vx cv vv cv cmr co cplr co cm1r vy cv vw cv vu cv cplr co
      cmr co cmr co cm1r vy cv vw cv cmr co cmr co cm1r vy cv vu cv cmr co cmr
      co cplr co cplr vx cv vz cv vv cv vz visset vv visset distrsr cm1r vy cv
      vw cv vu cv cplr co cmr co cmr co cm1r vy cv vw cv cmr co vy cv vu cv cmr
      co cplr co cmr co cm1r vy cv vw cv cmr co cmr co cm1r vy cv vu cv cmr co
      cmr co cplr co vy cv vw cv vu cv cplr co cmr co vy cv vw cv cmr co vy cv
      vu cv cmr co cplr co cm1r cmr vy cv vw cv vu cv vw visset vu visset
      distrsr opreq2i cm1r vy cv vw cv cmr co vy cv vu cv cmr co vy cv vw cv
      cmr oprex vy cv vu cv cmr oprex distrsr eqtri opreq12i vf vg vh vx cv vz
      cv cmr co vx cv vv cv cmr co cm1r vy cv vw cv cmr co cmr co cm1r vy cv vu
      cv cmr co cmr co cplr vx cv vz cv cmr oprex vx cv vv cv cmr oprex cm1r vy
      cv vw cv cmr co cmr oprex vf cv vg cv vf visset vg visset addcomsr vf cv
      vg cv vh cv vg visset vh visset addasssr cm1r vy cv vu cv cmr co cmr
      oprex caopr4 eqtri vy cv vz cv vv cv cplr co cmr co vx cv vw cv vu cv
      cplr co cmr co cplr co vy cv vz cv cmr co vy cv vv cv cmr co cplr co vx
      cv vw cv cmr co vx cv vu cv cmr co cplr co cplr co vy cv vz cv cmr co vx
      cv vw cv cmr co cplr co vy cv vv cv cmr co vx cv vu cv cmr co cplr co
      cplr co vy cv vz cv vv cv cplr co cmr co vy cv vz cv cmr co vy cv vv cv
      cmr co cplr co vx cv vw cv vu cv cplr co cmr co vx cv vw cv cmr co vx cv
      vu cv cmr co cplr co cplr vy cv vz cv vv cv vz visset vv visset distrsr
      vx cv vw cv vu cv vw visset vu visset distrsr opreq12i vf vg vh vy cv vz
      cv cmr co vy cv vv cv cmr co vx cv vw cv cmr co vx cv vu cv cmr co cplr
      vy cv vz cv cmr oprex vy cv vv cv cmr oprex vx cv vw cv cmr oprex vf cv
      vg cv vf visset vg visset addcomsr vf cv vg cv vh cv vg visset vh visset
      addasssr vx cv vu cv cmr oprex caopr4 eqtri ecoprdi $.
      $( [2-Sep-1995] $)
  $}

  $( 1 and 0 are distinct.  Axiom 14 of 25 for real and complex numbers,
     derived from ZF set theory. $)
  ax1ne0 $p |- 1 =/= 0 $=
    c1 cc0 wne c1 cc0 wceq wn c1 cc0 wceq c1r c0r cop c0r c0r cop wceq c1r c0r
    cop c0r c0r cop wceq c1r c0r wceq 1ne0sr c1r c0r c1r cnr 1r elisseti eqresr
    mtbir c1 c1r c0r cop cc0 c0r c0r cop df-1 df-0 eqeq12i mtbir c1 cc0 df-ne
    mpbir $.
    $( [19-Mar-1996] $)

  ${
    $d x y A $.
    $( 0 is an identity element for addition.  Axiom 15 of 25 for real
       and complex numbers, derived from ZF set theory. $)
    ax0id $p |- ( A e. CC -> ( A + 0 ) = A ) $=
      vx cv vy cv cop cc0 caddc co vx cv vy cv cop wceq cA cc0 caddc co cA wceq
      vx vy cA cnr cnr cc df-c vx cv vy cv cop cA wceq vx cv vy cv cop cc0
      caddc co cA cc0 caddc co vx cv vy cv cop cA vx cv vy cv cop cA cc0 caddc
      opreq1 vx cv vy cv cop cA wceq id eqeq12d vx cv cnr wcel vy cv cnr wcel
      wa vx cv vy cv cop c0r c0r cop caddc co vx cv vy cv cop vx cv vy cv cop
      cc0 caddc co vx cv cnr wcel vy cv cnr wcel wa vx cv vy cv cop c0r c0r cop
      caddc co vx cv c0r cplr co vy cv c0r cplr co cop vx cv vy cv cop vx cv
      cnr wcel vy cv cnr wcel wa c0r cnr wcel c0r cnr wcel vx cv vy cv cop c0r
      c0r cop caddc co vx cv c0r cplr co vy cv c0r cplr co cop wceq 0r 0r vx cv
      vy cv c0r c0r addcnsr mpanr12 vx cv c0r cplr co vx cv wceq vy cv c0r cplr
      co vy cv wceq vx cv c0r cplr co vy cv c0r cplr co cop vx cv vy cv cop
      wceq vx cv cnr wcel vy cv cnr wcel vx cv c0r cplr co vy cv c0r cplr co vx
      cv vy cv opeq12 vx cv 0idsr vy cv 0idsr syl2an eqtrd cc0 c0r c0r cop vx
      cv vy cv cop caddc df-0 opreq2i syl5eq optocl $.
      $( [31-Mar-1996] $)
  $}

  ${
    $d x y A $.
    $( 1 is an identity element for multiplication.  Axiom 16 of 25 for
       real and complex numbers, derived from ZF set theory. $)
    ax1id $p |- ( A e. CC -> ( A x. 1 ) = A ) $=
      vx cv vy cv cop c1 cmul co vx cv vy cv cop wceq cA c1 cmul co cA wceq vx
      vy cA cnr cnr cc df-c vx cv vy cv cop cA wceq vx cv vy cv cop c1 cmul co
      cA c1 cmul co vx cv vy cv cop cA vx cv vy cv cop cA c1 cmul opreq1 vx cv
      vy cv cop cA wceq id eqeq12d vx cv cnr wcel vy cv cnr wcel wa vx cv vy cv
      cop c1r c0r cop cmul co vx cv vy cv cop vx cv vy cv cop c1 cmul co vx cv
      cnr wcel vy cv cnr wcel wa vx cv vy cv cop c1r c0r cop cmul co vx cv c1r
      cmr co cm1r vy cv c0r cmr co cmr co cplr co vy cv c1r cmr co vx cv c0r
      cmr co cplr co cop vx cv vy cv cop vx cv cnr wcel vy cv cnr wcel wa c1r
      cnr wcel c0r cnr wcel vx cv vy cv cop c1r c0r cop cmul co vx cv c1r cmr
      co cm1r vy cv c0r cmr co cmr co cplr co vy cv c1r cmr co vx cv c0r cmr co
      cplr co cop wceq 1r 0r vx cv vy cv c1r c0r mulcnsr mpanr12 vx cv cnr wcel
      vy cv cnr wcel wa vx cv c1r cmr co cm1r vy cv c0r cmr co cmr co cplr co
      vx cv vy cv c1r cmr co vx cv c0r cmr co cplr co vy cv vy cv cnr wcel vx
      cv cnr wcel vx cv c1r cmr co cm1r vy cv c0r cmr co cmr co cplr co vx cv
      c1r cmr co c0r cplr co vx cv vy cv cnr wcel cm1r vy cv c0r cmr co cmr co
      c0r vx cv c1r cmr co cplr vy cv cnr wcel cm1r vy cv c0r cmr co cmr co
      cm1r c0r cmr co c0r vy cv cnr wcel vy cv c0r cmr co c0r cm1r cmr vy cv
      00sr opreq2d cm1r cnr wcel cm1r c0r cmr co c0r wceq m1r cm1r 00sr ax-mp
      syl6eq opreq2d vx cv cnr wcel vx cv c1r cmr co c0r cplr co vx cv c0r cplr
      co vx cv vx cv cnr wcel vx cv c1r cmr co vx cv c0r cplr vx cv 1idsr
      opreq1d vx cv 0idsr eqtrd sylan9eqr vx cv cnr wcel vy cv cnr wcel vy cv
      c1r cmr co vx cv c0r cmr co cplr co vy cv c1r cmr co c0r cplr co vy cv vx
      cv cnr wcel vx cv c0r cmr co c0r vy cv c1r cmr co cplr vx cv 00sr opreq2d
      vy cv cnr wcel vy cv c1r cmr co c0r cplr co vy cv c0r cplr co vy cv vy cv
      cnr wcel vy cv c1r cmr co vy cv c0r cplr vy cv 1idsr opreq1d vy cv 0idsr
      eqtrd sylan9eq opeq12d eqtrd c1 c1r c0r cop vx cv vy cv cop cmul df-1
      opreq2i syl5eq optocl $.
      $( [31-Mar-1996] $)
  $}

  ${
    $d x y A $.  $d x y z $.
    $( Existence of negative of real number.  Axiom 17 of 25 for real and
       complex numbers, derived from ZF set theory. $)
    axrnegex $p |- ( A e. RR -> E. x e. RR ( A + x ) = 0 ) $=
      vy cv c0r cop vx cv caddc co cc0 wceq vx cr wrex cA vx cv caddc co cc0
      wceq vx cr wrex vy cv cnr wcel cA cr wcel vy vy cv c0r cop cA vy cA
      elreal vy cv c0r cop cA wceq vy cv c0r cop vx cv caddc co cc0 wceq cA vx
      cv caddc co cc0 wceq vx cr vy cv c0r cop cA wceq vy cv c0r cop vx cv
      caddc co cA vx cv caddc co cc0 vy cv c0r cop cA vx cv caddc opreq1 eqeq1d
      rexbidv vy cv cnr wcel vz cv cnr wcel vy cv vz cv cplr co c0r wceq wa vz
      wex vy cv c0r cop vx cv caddc co cc0 wceq vx cr wrex vz vy cv negexsr vy
      cv cnr wcel vz cv cnr wcel vy cv vz cv cplr co c0r wceq wa vy cv c0r cop
      vx cv caddc co cc0 wceq vx cr wrex vz vy cv cnr wcel vz cv cnr wcel vy cv
      vz cv cplr co c0r wceq wa vz cv cnr wcel vy cv c0r cop vz cv c0r cop
      caddc co cc0 wceq wa vy cv c0r cop vx cv caddc co cc0 wceq vx cr wrex vy
      cv cnr wcel vz cv cnr wcel vy cv c0r cop vz cv c0r cop caddc co cc0 wceq
      vy cv vz cv cplr co c0r wceq vy cv cnr wcel vz cv cnr wcel wa vy cv c0r
      cop vz cv c0r cop caddc co cc0 wceq vy cv vz cv cplr co c0r cop cc0 wceq
      vy cv vz cv cplr co c0r wceq vy cv cnr wcel vz cv cnr wcel wa vy cv c0r
      cop vz cv c0r cop caddc co vy cv vz cv cplr co c0r cop cc0 vy cv vz cv
      addresr eqeq1d vy cv vz cv cplr co c0r cop cc0 wceq vy cv vz cv cplr co
      c0r cop c0r c0r cop wceq vy cv vz cv cplr co c0r wceq cc0 c0r c0r cop vy
      cv vz cv cplr co c0r cop df-0 eqeq2i vy cv vz cv cplr co c0r vy cv vz cv
      cplr oprex eqresr bitri syl6bb pm5.32da vz cv cnr wcel vy cv c0r cop vz
      cv c0r cop caddc co cc0 wceq wa vx cv cr wcel vy cv c0r cop vx cv caddc
      co cc0 wceq wa vx wex vy cv c0r cop vx cv caddc co cc0 wceq vx cr wrex vz
      cv c0r cop cr wcel vy cv c0r cop vz cv c0r cop caddc co cc0 wceq vx cv cr
      wcel vy cv c0r cop vx cv caddc co cc0 wceq wa vx wex vz cv cnr wcel vx cv
      cr wcel vy cv c0r cop vx cv caddc co cc0 wceq wa vz cv c0r cop cr wcel vy
      cv c0r cop vz cv c0r cop caddc co cc0 wceq wa vx vz cv c0r cop vz cv c0r
      opex vx cv vz cv c0r cop wceq vx cv cr wcel vz cv c0r cop cr wcel vy cv
      c0r cop vx cv caddc co cc0 wceq vy cv c0r cop vz cv c0r cop caddc co cc0
      wceq vx cv vz cv c0r cop cr eleq1 vx cv vz cv c0r cop wceq vy cv c0r cop
      vx cv caddc co vy cv c0r cop vz cv c0r cop caddc co cc0 vx cv vz cv c0r
      cop vy cv c0r cop caddc opreq2 eqeq1d anbi12d cla4ev vz cv opelreal
      sylanbr vy cv c0r cop vx cv caddc co cc0 wceq vx cr df-rex sylibr syl6bir
      19.23adv mpd gencl $.
      $( [15-May-1996] $)
  $}

  ${
    $d x y A $.  $d x y z $.
    $( Existence of reciprocal of nonzero real number.  Axiom 18 of 25
       for real and complex numbers, derived from ZF set theory. $)
    axrrecex $p |- ( ( A e. RR /\ A =/= 0 ) -> E. x e. RR ( A x. x ) = 1 ) $=
      cA cr wcel cA cc0 wne cA vx cv cmul co c1 wceq vx cr wrex vy cv c0r cop
      cc0 wne vy cv c0r cop vx cv cmul co c1 wceq vx cr wrex wi cA cc0 wne cA
      vx cv cmul co c1 wceq vx cr wrex wi vy cv cnr wcel cA cr wcel vy vy cv
      c0r cop cA vy cA elreal vy cv c0r cop cA wceq vy cv c0r cop cc0 wne cA
      cc0 wne vy cv c0r cop vx cv cmul co c1 wceq vx cr wrex cA vx cv cmul co
      c1 wceq vx cr wrex vy cv c0r cop cA cc0 neeq1 vy cv c0r cop cA wceq vy cv
      c0r cop vx cv cmul co c1 wceq cA vx cv cmul co c1 wceq vx cr vy cv c0r
      cop cA wceq vy cv c0r cop vx cv cmul co cA vx cv cmul co c1 vy cv c0r cop
      cA vx cv cmul opreq1 eqeq1d rexbidv imbi12d vy cv cnr wcel vy cv c0r cop
      cc0 wceq wn vx cv cr wcel vy cv c0r cop vx cv cmul co c1 wceq wa vx wex
      vy cv c0r cop cc0 wne vy cv c0r cop vx cv cmul co c1 wceq vx cr wrex vy
      cv cnr wcel vy cv c0r wceq wn vx cv cr wcel vy cv c0r cop vx cv cmul co
      c1 wceq wa vx wex vy cv c0r cop cc0 wceq wn vy cv cnr wcel vy cv c0r wceq
      wn vz cv cnr wcel vy cv vz cv cmr co c1r wceq wa vz wex vx cv cr wcel vy
      cv c0r cop vx cv cmul co c1 wceq wa vx wex vz vy cv vy visset recexsr vy
      cv cnr wcel vz cv cnr wcel vy cv vz cv cmr co c1r wceq wa vx cv cr wcel
      vy cv c0r cop vx cv cmul co c1 wceq wa vx wex vz vy cv cnr wcel vz cv cnr
      wcel vy cv vz cv cmr co c1r wceq wa vz cv c0r cop cr wcel vy cv c0r cop
      vz cv c0r cop cmul co c1 wceq wa vx cv cr wcel vy cv c0r cop vx cv cmul
      co c1 wceq wa vx wex vy cv cnr wcel vz cv cnr wcel vy cv c0r cop vz cv
      c0r cop cmul co c1 wceq wa vz cv cnr wcel vy cv vz cv cmr co c1r wceq wa
      vz cv c0r cop cr wcel vy cv c0r cop vz cv c0r cop cmul co c1 wceq wa vy
      cv cnr wcel vz cv cnr wcel vy cv c0r cop vz cv c0r cop cmul co c1 wceq vy
      cv vz cv cmr co c1r wceq vy cv cnr wcel vz cv cnr wcel wa vy cv c0r cop
      vz cv c0r cop cmul co c1 wceq vy cv vz cv cmr co c0r cop c1 wceq vy cv vz
      cv cmr co c1r wceq vy cv cnr wcel vz cv cnr wcel wa vy cv c0r cop vz cv
      c0r cop cmul co vy cv vz cv cmr co c0r cop c1 vy cv vz cv vz visset
      mulresr eqeq1d vy cv vz cv cmr co c0r cop c1 wceq vy cv vz cv cmr co c0r
      cop c1r c0r cop wceq vy cv vz cv cmr co c1r wceq c1 c1r c0r cop vy cv vz
      cv cmr co c0r cop df-1 eqeq2i vy cv vz cv cmr co c1r vy cv vz cv cmr
      oprex eqresr bitri syl6bb pm5.32da vz cv c0r cop cr wcel vz cv cnr wcel
      vy cv c0r cop vz cv c0r cop cmul co c1 wceq vz cv opelreal anbi1i syl5bb
      vx cv cr wcel vy cv c0r cop vx cv cmul co c1 wceq wa vz cv c0r cop cr
      wcel vy cv c0r cop vz cv c0r cop cmul co c1 wceq wa vx vz cv c0r cop vz
      cv c0r opex vx cv vz cv c0r cop wceq vx cv cr wcel vz cv c0r cop cr wcel
      vy cv c0r cop vx cv cmul co c1 wceq vy cv c0r cop vz cv c0r cop cmul co
      c1 wceq vx cv vz cv c0r cop cr eleq1 vx cv vz cv c0r cop wceq vy cv c0r
      cop vx cv cmul co vy cv c0r cop vz cv c0r cop cmul co c1 vx cv vz cv c0r
      cop vy cv c0r cop cmul opreq2 eqeq1d anbi12d cla4ev syl6bir 19.23adv syld
      vy cv c0r cop cc0 wceq vy cv c0r wceq vy cv c0r cop cc0 wceq vy cv c0r
      cop c0r c0r cop wceq vy cv c0r wceq cc0 c0r c0r cop vy cv c0r cop df-0
      eqeq2i vy cv c0r vy visset eqresr bitri notbii syl5ib vy cv c0r cop cc0
      df-ne vy cv c0r cop vx cv cmul co c1 wceq vx cr df-rex 3imtr4g gencl imp
      $.
      $( [15-May-1996] $)
  $}

  $( i-squared equals -1 (expressed as i-squared plus 1 is 0).  Axiom 19 of 25
     for real and complex numbers, derived from ZF set theory. $)
  axi2m1 $p |- ( ( _i x. _i ) + 1 ) = 0 $=
    c0r c1r cop c0r c1r cop cmul co c1r c0r cop caddc co c0r c0r cop ci ci cmul
    co c1 caddc co cc0 c0r c1r cop c0r c1r cop cmul co c1r c0r cop caddc co
    cm1r c0r cop c1r c0r cop caddc co cm1r c1r cplr co c0r cop c0r c0r cop c0r
    c1r cop c0r c1r cop cmul co cm1r c0r cop c1r c0r cop caddc c0r c1r cop c0r
    c1r cop cmul co c0r c0r cmr co cm1r c1r c1r cmr co cmr co cplr co c1r c0r
    cmr co c0r c1r cmr co cplr co cop cm1r c0r cop c0r cnr wcel c1r cnr wcel wa
    c0r cnr wcel c1r cnr wcel wa c0r c1r cop c0r c1r cop cmul co c0r c0r cmr co
    cm1r c1r c1r cmr co cmr co cplr co c1r c0r cmr co c0r c1r cmr co cplr co
    cop wceq c0r cnr wcel c1r cnr wcel 0r 1r pm3.2i c0r cnr wcel c1r cnr wcel
    0r 1r pm3.2i c0r c1r c0r c1r mulcnsr mp2an c0r c0r cmr co cm1r c1r c1r cmr
    co cmr co cplr co cm1r c1r c0r cmr co c0r c1r cmr co cplr co c0r c0r c0r
    cmr co cm1r c1r c1r cmr co cmr co cplr co c0r cm1r cplr co cm1r c0r cplr co
    cm1r c0r c0r cmr co c0r cm1r c1r c1r cmr co cmr co cm1r cplr c0r cnr wcel
    c0r c0r cmr co c0r wceq 0r c0r 00sr ax-mp cm1r c1r c1r cmr co cmr co cm1r
    c1r cmr co cm1r c1r c1r cmr co c1r cm1r cmr c1r cnr wcel c1r c1r cmr co c1r
    wceq 1r c1r 1idsr ax-mp opreq2i cm1r cnr wcel cm1r c1r cmr co cm1r wceq m1r
    cm1r 1idsr ax-mp eqtri opreq12i c0r cm1r c0r cnr 0r elisseti cm1r cnr m1r
    elisseti addcomsr cm1r cnr wcel cm1r c0r cplr co cm1r wceq m1r cm1r 0idsr
    ax-mp 3eqtri c1r c0r cmr co c0r c1r cmr co cplr co c0r c0r cplr co c0r c1r
    c0r cmr co c0r c0r c1r cmr co c0r cplr c1r cnr wcel c1r c0r cmr co c0r wceq
    1r c1r 00sr ax-mp c0r cnr wcel c0r c1r cmr co c0r wceq 0r c0r 1idsr ax-mp
    opreq12i c0r cnr wcel c0r c0r cplr co c0r wceq 0r c0r 0idsr ax-mp eqtri
    opeq12i eqtri opreq1i cm1r cnr wcel c1r cnr wcel cm1r c0r cop c1r c0r cop
    caddc co cm1r c1r cplr co c0r cop wceq m1r 1r cm1r c1r addresr mp2an cm1r
    c1r cplr co c0r c0r m1p1sr opeq1i 3eqtri ci ci cmul co c0r c1r cop c0r c1r
    cop cmul co c1 c1r c0r cop caddc ci c0r c1r cop ci c0r c1r cop cmul df-i
    df-i opreq12i df-1 opreq12i df-0 3eqtr4i $.
    $( [5-May-1996] $)

  ${
    $d x y z w A $.
    $( A complex number can be expressed in terms of two reals.  Definition
       10-1.1(v) of [Gleason] p. 130.  Axiom 20 of 25 for real and
       complex numbers, derived from ZF set theory. $)
    axcnre $p |- ( A e. CC ->
                      E. x e. RR E. y e. RR A = ( x + ( _i x. y ) ) ) $=
      vz cv vw cv cop vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr
      wrex cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex vz vw
      cA cnr cnr cc df-c vz cv vw cv cop cA wceq vz cv vw cv cop vx cv ci vy cv
      cmul co caddc co wceq cA vx cv ci vy cv cmul co caddc co wceq vx vy cr cr
      vz cv vw cv cop cA vx cv ci vy cv cmul co caddc co eqeq1 2rexbidv vz cv
      cnr wcel vw cv cnr wcel wa vx cv cr wcel vy cv cr wcel wa vz cv vw cv cop
      vx cv ci vy cv cmul co caddc co wceq wa vy wex vx wex vz cv vw cv cop vx
      cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex vz cv c0r cop cr
      wcel vw cv c0r cop cr wcel wa vz cv vw cv cop vz cv c0r cop ci vw cv c0r
      cop cmul co caddc co wceq vx cv cr wcel vy cv cr wcel wa vz cv vw cv cop
      vx cv ci vy cv cmul co caddc co wceq wa vy wex vx wex vz cv cnr wcel vw
      cv cnr wcel wa vx cv cr wcel vy cv cr wcel wa vz cv vw cv cop vx cv ci vy
      cv cmul co caddc co wceq wa vz cv c0r cop cr wcel vw cv c0r cop cr wcel
      wa vz cv vw cv cop vz cv c0r cop ci vw cv c0r cop cmul co caddc co wceq
      wa vx vy vz cv c0r cop vw cv c0r cop vz cv c0r opex vw cv c0r opex vx cv
      vz cv c0r cop wceq vy cv vw cv c0r cop wceq wa vx cv cr wcel vy cv cr
      wcel wa vz cv c0r cop cr wcel vw cv c0r cop cr wcel wa vz cv vw cv cop vx
      cv ci vy cv cmul co caddc co wceq vz cv vw cv cop vz cv c0r cop ci vw cv
      c0r cop cmul co caddc co wceq vx cv vz cv c0r cop wceq vx cv cr wcel vz
      cv c0r cop cr wcel vy cv vw cv c0r cop wceq vy cv cr wcel vw cv c0r cop
      cr wcel vx cv vz cv c0r cop cr eleq1 vy cv vw cv c0r cop cr eleq1
      bi2anan9 vx cv vz cv c0r cop wceq vy cv vw cv c0r cop wceq wa vx cv ci vy
      cv cmul co caddc co vz cv c0r cop ci vw cv c0r cop cmul co caddc co vz cv
      vw cv cop vx cv vz cv c0r cop wceq vy cv vw cv c0r cop wceq vx cv ci vy
      cv cmul co caddc co vz cv c0r cop ci vy cv cmul co caddc co vz cv c0r cop
      ci vw cv c0r cop cmul co caddc co vx cv vz cv c0r cop ci vy cv cmul co
      caddc opreq1 vy cv vw cv c0r cop wceq ci vy cv cmul co ci vw cv c0r cop
      cmul co vz cv c0r cop caddc vy cv vw cv c0r cop ci cmul opreq2 opreq2d
      sylan9eq eqeq2d anbi12d cla42ev vz cv c0r cop cr wcel vw cv c0r cop cr
      wcel wa vz cv cnr wcel vw cv cnr wcel wa vz cv c0r cop cr wcel vz cv cnr
      wcel vw cv c0r cop cr wcel vw cv cnr wcel vz cv opelreal vw cv opelreal
      anbi12i biimpri vz cv cnr wcel vw cv cnr wcel wa vz cv c0r cop ci vw cv
      c0r cop cmul co caddc co vz cv c0r cop c0r vw cv cop caddc co vz cv c0r
      cplr co c0r vw cv cplr co cop vz cv vw cv cop vw cv cnr wcel vz cv c0r
      cop ci vw cv c0r cop cmul co caddc co vz cv c0r cop c0r vw cv cop caddc
      co wceq vz cv cnr wcel vw cv cnr wcel ci vw cv c0r cop cmul co c0r vw cv
      cop vz cv c0r cop caddc vw cv cnr wcel c0r c1r cop vw cv c0r cop cmul co
      c0r vw cv cop ci vw cv c0r cop cmul co vw cv cnr wcel c0r c1r cop vw cv
      c0r cop cmul co c0r vw cv cmr co cm1r c1r c0r cmr co cmr co cplr co c1r
      vw cv cmr co c0r c0r cmr co cplr co cop c0r vw cv cop vw cv cnr wcel c0r
      cnr wcel c0r c1r cop vw cv c0r cop cmul co c0r vw cv cmr co cm1r c1r c0r
      cmr co cmr co cplr co c1r vw cv cmr co c0r c0r cmr co cplr co cop wceq 0r
      c0r cnr wcel c1r cnr wcel wa vw cv cnr wcel c0r cnr wcel wa c0r c1r cop
      vw cv c0r cop cmul co c0r vw cv cmr co cm1r c1r c0r cmr co cmr co cplr co
      c1r vw cv cmr co c0r c0r cmr co cplr co cop wceq c0r cnr wcel c1r cnr
      wcel 0r 1r pm3.2i c0r c1r vw cv c0r mulcnsr mpan mpan2 vw cv cnr wcel c0r
      vw cv cmr co cm1r c1r c0r cmr co cmr co cplr co c0r c1r vw cv cmr co c0r
      c0r cmr co cplr co vw cv vw cv cnr wcel c0r vw cv cmr co cm1r c1r c0r cmr
      co cmr co cplr co c0r cm1r c1r c0r cmr co cmr co cplr co c0r vw cv cnr
      wcel c0r vw cv cmr co c0r cm1r c1r c0r cmr co cmr co cplr vw cv cnr wcel
      vw cv c0r cmr co c0r c0r vw cv cmr co vw cv 00sr c0r vw cv c0r cnr 0r
      elisseti vw visset mulcomsr syl5eq opreq1d c0r cm1r c1r c0r cmr co cmr co
      cplr co c0r c0r cplr co c0r cm1r c1r c0r cmr co cmr co c0r c0r cplr cm1r
      c1r c0r cmr co cmr co cm1r c0r cmr co c0r c1r c0r cmr co c0r cm1r cmr c1r
      cnr wcel c1r c0r cmr co c0r wceq 1r c1r 00sr ax-mp opreq2i cm1r cnr wcel
      cm1r c0r cmr co c0r wceq m1r cm1r 00sr ax-mp eqtri opreq2i c0r cnr wcel
      c0r c0r cplr co c0r wceq 0r c0r 0idsr ax-mp eqtri syl6eq vw cv cnr wcel
      c1r vw cv cmr co c0r c0r cmr co cplr co vw cv c0r c0r cmr co cplr co vw
      cv vw cv cnr wcel c1r vw cv cmr co vw cv c0r c0r cmr co cplr vw cv cnr
      wcel vw cv c1r cmr co vw cv c1r vw cv cmr co vw cv 1idsr c1r vw cv c1r
      cnr 1r elisseti vw visset mulcomsr syl5eq opreq1d vw cv cnr wcel vw cv
      c0r cplr co vw cv vw cv c0r c0r cmr co cplr co vw cv 0idsr c0r c0r cmr co
      c0r vw cv cplr c0r cnr wcel c0r c0r cmr co c0r wceq 0r c0r 00sr ax-mp
      opreq2i syl5eq eqtrd opeq12d eqtrd ci c0r c1r cop vw cv c0r cop cmul df-i
      opreq1i syl5eq opreq2d adantl vz cv cnr wcel c0r cnr wcel vw cv cnr wcel
      vz cv c0r cop c0r vw cv cop caddc co vz cv c0r cplr co c0r vw cv cplr co
      cop wceq 0r vz cv cnr wcel c0r cnr wcel c0r cnr wcel vw cv cnr wcel wa vz
      cv c0r cop c0r vw cv cop caddc co vz cv c0r cplr co c0r vw cv cplr co cop
      wceq 0r vz cv c0r c0r vw cv addcnsr mpanl2 mpanr1 vz cv c0r cplr co vz cv
      wceq c0r vw cv cplr co vw cv wceq vz cv c0r cplr co c0r vw cv cplr co cop
      vz cv vw cv cop wceq vz cv cnr wcel vw cv cnr wcel vz cv c0r cplr co c0r
      vw cv cplr co vz cv vw cv opeq12 vz cv 0idsr vw cv cnr wcel vw cv c0r
      cplr co vw cv c0r vw cv cplr co vw cv 0idsr c0r vw cv c0r cnr 0r elisseti
      vw visset addcomsr syl5eq syl2an 3eqtrrd sylanc vz cv vw cv cop vx cv ci
      vy cv cmul co caddc co wceq vx vy cr cr r2ex sylibr optocl $.
      $( [11-Mar-2008] $) $( [13-May-1996] $)
  $}

  $( Ordering on reals satisfies strict trichotomy.  Axiom 21 of 25 for
     real and complex numbers, derived from ZF set theory.  Note:  The more
     general version for extended reals is ~ axlttri . $)
  pre-axlttri $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A <RR B <-> -. ( A = B \/ B <RR A ) ) ) $=
    cr cltrr wor cA cr wcel cB cr wcel wa cA cB cltrr wbr cA cB wceq cB cA
    cltrr wbr wo wn wb cr cltrr wor cr cr wceq ltsor pm3.26i cr cA cB cltrr
    sotric mpan $.
    $( [19-May-1996] $)

  $( Ordering on reals is transitive.  Axiom 22 of 25 for real and
     complex numbers, derived from ZF set theory.  Note:  The more general
     version for extended reals is ~ axlttrn . $)
  pre-axlttrn $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A <RR B /\ B <RR C ) -> A <RR C ) ) $=
    cr cltrr wor cA cr wcel cB cr wcel cC cr wcel w3a cA cB cltrr wbr cB cC
    cltrr wbr wa cA cC cltrr wbr wi cr cltrr wor cr cr wceq ltsor pm3.26i cr cA
    cB cC cltrr sotr mpan $.
    $( [19-May-1996] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Ordering property of addition on reals.  Axiom 23 of 25 for real
       and complex numbers, derived from ZF set theory.  Note:  The more
       general version for extended reals is ~ axltadd . $)
    pre-axltadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( A <RR B -> ( C + A ) <RR ( C + B ) ) ) $=
      cA cr wcel cB cr wcel cC cr wcel w3a cA cB cltrr wbr cC cA caddc co cC cB
      caddc co cltrr wbr vx cv c0r cop vy cv c0r cop cltrr wbr vz cv c0r cop vx
      cv c0r cop caddc co vz cv c0r cop vy cv c0r cop caddc co cltrr wbr wb cA
      vy cv c0r cop cltrr wbr vz cv c0r cop cA caddc co vz cv c0r cop vy cv c0r
      cop caddc co cltrr wbr wb cA cB cltrr wbr vz cv c0r cop cA caddc co vz cv
      c0r cop cB caddc co cltrr wbr wb cA cB cltrr wbr cC cA caddc co cC cB
      caddc co cltrr wbr wb vx vy vz vx cv c0r cop vy cv c0r cop vz cv c0r cop
      cA cnr cr cB cC vx cA elreal vy cB elreal vz cC elreal vx cv c0r cop cA
      wceq vx cv c0r cop vy cv c0r cop cltrr wbr cA vy cv c0r cop cltrr wbr vz
      cv c0r cop vx cv c0r cop caddc co vz cv c0r cop vy cv c0r cop caddc co
      cltrr wbr vz cv c0r cop cA caddc co vz cv c0r cop vy cv c0r cop caddc co
      cltrr wbr vx cv c0r cop cA vy cv c0r cop cltrr breq1 vx cv c0r cop cA
      wceq vz cv c0r cop vx cv c0r cop caddc co vz cv c0r cop cA caddc co vz cv
      c0r cop vy cv c0r cop caddc co cltrr vx cv c0r cop cA vz cv c0r cop caddc
      opreq2 breq1d bibi12d vy cv c0r cop cB wceq cA vy cv c0r cop cltrr wbr cA
      cB cltrr wbr vz cv c0r cop cA caddc co vz cv c0r cop vy cv c0r cop caddc
      co cltrr wbr vz cv c0r cop cA caddc co vz cv c0r cop cB caddc co cltrr
      wbr vy cv c0r cop cB cA cltrr breq2 vy cv c0r cop cB wceq vz cv c0r cop
      vy cv c0r cop caddc co vz cv c0r cop cB caddc co vz cv c0r cop cA caddc
      co cltrr vy cv c0r cop cB vz cv c0r cop caddc opreq2 breq2d bibi12d vz cv
      c0r cop cC wceq vz cv c0r cop cA caddc co vz cv c0r cop cB caddc co cltrr
      wbr cC cA caddc co cC cB caddc co cltrr wbr cA cB cltrr wbr vz cv c0r cop
      cC wceq vz cv c0r cop cA caddc co cC cA caddc co vz cv c0r cop cB caddc
      co cC cB caddc co cltrr vz cv c0r cop cC cA caddc opreq1 vz cv c0r cop cC
      cB caddc opreq1 breq12d bibi2d vx cv cnr wcel vy cv cnr wcel vz cv cnr
      wcel vx cv c0r cop vy cv c0r cop cltrr wbr vz cv c0r cop vx cv c0r cop
      caddc co vz cv c0r cop vy cv c0r cop caddc co cltrr wbr wb vz cv cnr wcel
      vx cv cnr wcel vy cv cnr wcel wa vx cv c0r cop vy cv c0r cop cltrr wbr vz
      cv c0r cop vx cv c0r cop caddc co vz cv c0r cop vy cv c0r cop caddc co
      cltrr wbr wb vz cv cnr wcel vx cv cnr wcel vy cv cnr wcel wa wa vx cv vy
      cv cltr wbr vz cv vx cv cplr co vz cv vy cv cplr co cltr wbr vx cv c0r
      cop vy cv c0r cop cltrr wbr vz cv c0r cop vx cv c0r cop caddc co vz cv
      c0r cop vy cv c0r cop caddc co cltrr wbr vz cv cnr wcel vx cv vy cv cltr
      wbr vz cv vx cv cplr co vz cv vy cv cplr co cltr wbr wb vx cv cnr wcel vy
      cv cnr wcel wa vx cv vy cv vz cv vx visset vy visset ltasr adantr vx cv
      c0r cop vy cv c0r cop cltrr wbr vx cv vy cv cltr wbr wb vz cv cnr wcel vx
      cv cnr wcel vy cv cnr wcel wa wa vx cv vy cv vx visset vy visset ltresr
      a1i vz cv cnr wcel vx cv cnr wcel vy cv cnr wcel wa wa vz cv c0r cop vx
      cv c0r cop caddc co vz cv c0r cop vy cv c0r cop caddc co cltrr wbr vz cv
      vx cv cplr co c0r cop vz cv vy cv cplr co c0r cop cltrr wbr vz cv vx cv
      cplr co vz cv vy cv cplr co cltr wbr vz cv cnr wcel vx cv cnr wcel vy cv
      cnr wcel vz cv c0r cop vx cv c0r cop caddc co vz cv c0r cop vy cv c0r cop
      caddc co cltrr wbr vz cv vx cv cplr co c0r cop vz cv vy cv cplr co c0r
      cop cltrr wbr wb vz cv cnr wcel vx cv cnr wcel wa vz cv cnr wcel vy cv
      cnr wcel wa vz cv c0r cop vx cv c0r cop caddc co vz cv vx cv cplr co c0r
      cop vz cv c0r cop vy cv c0r cop caddc co vz cv vy cv cplr co c0r cop
      cltrr vz cv vx cv addresr vz cv vy cv addresr breqan12d anandis vz cv vx
      cv cplr co vz cv vy cv cplr co vz cv vx cv cplr oprex vz cv vy cv cplr
      oprex ltresr syl6bb 3bitr4d ancoms 3impa 3gencl biimpd $.
      $( [11-May-1996] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The product of two positive reals is positive.  Axiom 24 of 25 for
       real and complex numbers, derived from ZF set theory.  Note:  The more
       general version for extended reals is ~ axmulgt0 . $)
    pre-axmulgt0 $p |- ( ( A e. RR /\ B e. RR ) ->
                  ( ( 0 <RR A /\ 0 <RR B ) -> 0 <RR ( A x. B ) ) ) $=
      cc0 vx cv c0r cop cltrr wbr cc0 vy cv c0r cop cltrr wbr wa cc0 vx cv c0r
      cop vy cv c0r cop cmul co cltrr wbr wi cc0 cA cltrr wbr cc0 vy cv c0r cop
      cltrr wbr wa cc0 cA vy cv c0r cop cmul co cltrr wbr wi cc0 cA cltrr wbr
      cc0 cB cltrr wbr wa cc0 cA cB cmul co cltrr wbr wi vx vy vx cv c0r cop vy
      cv c0r cop cA cB cnr cr vx cA elreal vy cB elreal vx cv c0r cop cA wceq
      cc0 vx cv c0r cop cltrr wbr cc0 vy cv c0r cop cltrr wbr wa cc0 cA cltrr
      wbr cc0 vy cv c0r cop cltrr wbr wa cc0 vx cv c0r cop vy cv c0r cop cmul
      co cltrr wbr cc0 cA vy cv c0r cop cmul co cltrr wbr vx cv c0r cop cA wceq
      cc0 vx cv c0r cop cltrr wbr cc0 cA cltrr wbr cc0 vy cv c0r cop cltrr wbr
      vx cv c0r cop cA cc0 cltrr breq2 anbi1d vx cv c0r cop cA wceq vx cv c0r
      cop vy cv c0r cop cmul co cA vy cv c0r cop cmul co cc0 cltrr vx cv c0r
      cop cA vy cv c0r cop cmul opreq1 breq2d imbi12d vy cv c0r cop cB wceq cc0
      cA cltrr wbr cc0 vy cv c0r cop cltrr wbr wa cc0 cA cltrr wbr cc0 cB cltrr
      wbr wa cc0 cA vy cv c0r cop cmul co cltrr wbr cc0 cA cB cmul co cltrr wbr
      vy cv c0r cop cB wceq cc0 vy cv c0r cop cltrr wbr cc0 cB cltrr wbr cc0 cA
      cltrr wbr vy cv c0r cop cB cc0 cltrr breq2 anbi2d vy cv c0r cop cB wceq
      cA vy cv c0r cop cmul co cA cB cmul co cc0 cltrr vy cv c0r cop cB cA cmul
      opreq2 breq2d imbi12d vx cv cnr wcel vy cv cnr wcel wa cc0 vx cv c0r cop
      vy cv c0r cop cmul co cltrr wbr c0r vx cv vy cv cmr co cltr wbr cc0 vx cv
      c0r cop cltrr wbr cc0 vy cv c0r cop cltrr wbr wa vx cv cnr wcel vy cv cnr
      wcel wa cc0 vx cv c0r cop vy cv c0r cop cmul co cltrr wbr c0r c0r cop vx
      cv vy cv cmr co c0r cop cltrr wbr c0r vx cv vy cv cmr co cltr wbr vx cv
      cnr wcel vy cv cnr wcel wa cc0 c0r c0r cop vx cv c0r cop vy cv c0r cop
      cmul co vx cv vy cv cmr co c0r cop cltrr cc0 c0r c0r cop wceq vx cv cnr
      wcel vy cv cnr wcel wa df-0 a1i vx cv vy cv vy visset mulresr breq12d c0r
      vx cv vy cv cmr co c0r cnr 0r elisseti vx cv vy cv cmr oprex ltresr
      syl6bb c0r vx cv cltr wbr c0r vy cv cltr wbr c0r vx cv vy cv cmr co cltr
      wbr cc0 vx cv c0r cop cltrr wbr cc0 vy cv c0r cop cltrr wbr vx cv vy cv
      vx visset vy visset mulgt0sr cc0 vx cv c0r cop cltrr wbr c0r c0r cop vx
      cv c0r cop cltrr wbr c0r vx cv cltr wbr cc0 c0r c0r cop vx cv c0r cop
      cltrr df-0 breq1i c0r vx cv c0r cnr 0r elisseti vx visset ltresr bitri
      cc0 vy cv c0r cop cltrr wbr c0r c0r cop vy cv c0r cop cltrr wbr c0r vy cv
      cltr wbr cc0 c0r c0r cop vy cv c0r cop cltrr df-0 breq1i c0r vy cv c0r
      cnr 0r elisseti vy visset ltresr bitri syl2anb syl5bir 2gencl $.
      $( [13-May-1996] $)
  $}

  ${
    $d x y z w v A $.
    $( A non-empty, bounded-above set of reals has a supremum.  Axiom 25 of 25
       for real and complex numbers, derived from ZF set theory.  Note:  The
       more general version with ordering on extended reals is ~ axsup . $)
    pre-axsup $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR
                    A. y e. A y <RR x ) -> E. x e. RR ( A. y e. A -. x <RR y /\
                    A. y e. RR ( y <RR x -> E. z e. A y <RR z ) ) ) $=
      cA cr wss cA c0 wne vy cv vx cv cltrr wbr vy cA wral vx cr wrex vx cv vy
      cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz
      cA wrex wi vy cr wral wa vx cr wrex cA cr wss cA c0 wceq wn wa vy cv vx
      cv cltrr wbr vy cA wral vx cr wrex vx cv vy cv cltrr wbr wn vy cA wral vy
      cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral wa vx
      cr wrex cA cr wss cA c0 wne wa cA cr wss cA c0 wceq wn wa vx cv cr wcel
      vy cv cr wcel vy cv cA wcel vy cv vx cv cltrr wbr wi wi vy wal wa vx wex
      vx cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv
      cltrr wbr vz cA wrex wi vy cr wral wa vx cr wrex vy cv vx cv cltrr wbr vy
      cA wral vx cr wrex cA cr wss cA c0 wceq wn wa vx cv cr wcel vy cv cr wcel
      vy cv cA wcel vy cv vx cv cltrr wbr wi wi vy wal wa vx wex vx cv vy cv
      cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA
      wrex wi vy cr wral wa vx cr wrex cA cr wss cA c0 wceq wn wa vx cv cr wcel
      vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr
      wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa
      wi vy wal wa vx wex vx cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr
      wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral wa vx cr wrex cA cr
      wss cA c0 wceq wn wa vx cv cr wcel vy cv cr wcel vy cv cA wcel vy cv vx
      cv cltrr wbr wi wi vy wal wa vx wex wa cA cr wss vx cv cr wcel vy cv cr
      wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz
      cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy
      wal wa vx wex vx cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr
      vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral wa vx cr wrex wi cA c0
      wceq wn cA cr wss vx cv cr wcel vy cv cr wcel vy cv cA wcel vx cv vy cv
      cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv
      vz cv cltrr wbr wa wa vz wex wi wa wi vy wal wa vx wex vx cv cr wcel vx
      cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr
      wbr vz cA wrex wi vy cr wral wa wa vx wex vx cv vy cv cltrr wbr wn vy cA
      wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral
      wa vx cr wrex cA cr wss vx cv cr wcel vy cv cr wcel vy cv cA wcel vx cv
      vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel
      vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy wal wa vx cv cr wcel vx cv
      vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr
      vz cA wrex wi vy cr wral wa wa vx cA cr wss vy cv cr wcel vy cv cA wcel
      vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA
      wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy wal vx cv vy cv cltrr
      wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex
      wi vy cr wral wa vx cv cr wcel cA cr wss vy cv cr wcel vy cv cA wcel vx
      cv vy cv cltrr wbr wn wi wi vy wal vy cv cr wcel vy cv vx cv cltrr wbr vz
      cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wi vy wal
      wa vx cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv
      cltrr wbr vz cA wrex wi vy cr wral wa vy cv cr wcel vy cv cA wcel vx cv
      vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel
      vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy wal cA cr wss vy cv cr
      wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi wi vy wal vx cv vy cv
      cltrr wbr wn vy cA wral vy cv cr wcel vy cv vx cv cltrr wbr vz cv cr wcel
      vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wi vy wal vy cv vx cv
      cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral cA cr wss vy cv
      cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi wi vy wal vy cv cA wcel
      vx cv vy cv cltrr wbr wn wi vy wal vx cv vy cv cltrr wbr wn vy cA wral cA
      cr wss vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi wi vy cv
      cA wcel vx cv vy cv cltrr wbr wn wi vy cA cr wss vy cv cr wcel vy cv cA
      wcel vx cv vy cv cltrr wbr wn wi wi vy cv cA wcel vy cv cA wcel vx cv vy
      cv cltrr wbr wn wi wi vy cv cA wcel vx cv vy cv cltrr wbr wn wi cA cr wss
      vy cv cA wcel vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi cA
      cr vy cv ssel imim1d vy cv cA wcel vx cv vy cv cltrr wbr wn pm2.43 syl6
      19.20dv vx cv vy cv cltrr wbr wn vy cA df-ral syl6ibr vy cv cr wcel vy cv
      vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa
      vz wex wi wi vy wal vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA
      wrex wi vy cr wral wi cA cr wss vy cv cr wcel vy cv vx cv cltrr wbr vz cv
      cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wi vy wal vy
      cv cr wcel vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi wi
      vy wal vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr
      wral vy cv cr wcel vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy
      cv vz cv cltrr wbr wa wa vz wex wi wi vy cv cr wcel vy cv vx cv cltrr wbr
      vy cv vz cv cltrr wbr vz cA wrex wi wi vy vy cv vx cv cltrr wbr vz cv cr
      wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi vy cv vx cv
      cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cv cr wcel vz cv cr wcel
      vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex vy cv vz cv cltrr wbr vz
      cA wrex vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv
      cltrr wbr wa wa vz wex vz cv cA wcel vy cv vz cv cltrr wbr wa vz wex vy
      cv vz cv cltrr wbr vz cA wrex vz cv cr wcel vz cv cA wcel vy cv vz cv
      cltrr wbr wa wa vz cv cA wcel vy cv vz cv cltrr wbr wa vz vz cv cr wcel
      vz cv cA wcel vy cv vz cv cltrr wbr wa pm3.27 19.22i vy cv vz cv cltrr
      wbr vz cA df-rex sylibr imim2i imim2i 19.20i vy cv vx cv cltrr wbr vy cv
      vz cv cltrr wbr vz cA wrex wi vy cr df-ral sylibr a1i anim12d vy cv cr
      wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr wbr vz
      cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa wi vy
      wal vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi wi vy cv cr
      wcel vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr
      wbr wa wa vz wex wi wi wa vy wal vy cv cr wcel vy cv cA wcel vx cv vy cv
      cltrr wbr wn wi wi vy wal vy cv cr wcel vy cv vx cv cltrr wbr vz cv cr
      wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wi vy wal wa vy
      cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi vy cv vx cv cltrr
      wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wa
      wi vy cv cr wcel vy cv cA wcel vx cv vy cv cltrr wbr wn wi wi vy cv cr
      wcel vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv vz cv cltrr
      wbr wa wa vz wex wi wi wa vy vy cv cr wcel vy cv cA wcel vx cv vy cv
      cltrr wbr wn wi vy cv vx cv cltrr wbr vz cv cr wcel vz cv cA wcel vy cv
      vz cv cltrr wbr wa wa vz wex wi jcab albii vy cv cr wcel vy cv cA wcel vx
      cv vy cv cltrr wbr wn wi wi vy cv cr wcel vy cv vx cv cltrr wbr vz cv cr
      wcel vz cv cA wcel vy cv vz cv cltrr wbr wa wa vz wex wi wi vy 19.26
      bitri syl5ib anim2d 19.22dv vx cv vy cv cltrr wbr wn vy cA wral vy cv vx
      cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral wa vx cr
      df-rex syl6ibr adantr vx vy vz vw cA vv cv c0r cop cA wcel vv cab vv cv
      c0r cop cA wcel vw cv c0r cop cA wcel vv vw vv cv vw cv wceq vv cv c0r
      cop vw cv c0r cop cA vv cv vw cv c0r opeq1 eleq1d cbvabv supre syl5
      anabsi5 vy cv vx cv cltrr wbr vy cA wral vx cr wrex vx cv cr wcel vy cv
      vx cv cltrr wbr vy cA wral wa vx wex vx cv cr wcel vy cv cr wcel vy cv cA
      wcel vy cv vx cv cltrr wbr wi wi vy wal wa vx wex vy cv vx cv cltrr wbr
      vy cA wral vx cr df-rex vx cv cr wcel vy cv vx cv cltrr wbr vy cA wral wa
      vx cv cr wcel vy cv cr wcel vy cv cA wcel vy cv vx cv cltrr wbr wi wi vy
      wal wa vx vy cv vx cv cltrr wbr vy cA wral vy cv cr wcel vy cv cA wcel vy
      cv vx cv cltrr wbr wi wi vy wal vx cv cr wcel vy cv vx cv cltrr wbr vy cA
      wral vy cv cA wcel vy cv vx cv cltrr wbr wi vy wal vy cv cr wcel vy cv cA
      wcel vy cv vx cv cltrr wbr wi wi vy wal vy cv vx cv cltrr wbr vy cA
      df-ral vy cv cA wcel vy cv vx cv cltrr wbr wi vy cv cr wcel vy cv cA wcel
      vy cv vx cv cltrr wbr wi wi vy vy cv cA wcel vy cv vx cv cltrr wbr wi vy
      cv cr wcel ax-1 19.20i sylbi anim2i 19.22i sylbi sylan2 cA c0 wne cA c0
      wceq wn cA cr wss cA c0 df-ne anbi2i sylanb 3impa $.
      $( [19-May-1996] $)
  $}

$( --old location
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                       Real and complex numbers
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$( Use set.mm as our foundation. $)
$( $[ set.mm $] $)

$( Include your favorite construction of reals here. $)
$( $[ dedekind.mm $] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Real and complex numbers - basic operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare symbols needed for some defined terms. $)
  $c - $. $( Subtraction (binary minus. $)
  $c -u $. $( Unary minus sign. $)
  $c <_ $. $( 'Less than or equal to' relation. $)
  $c NN $. $( The set of positive integers (blackboard bold N). $)
  $c NN0 $. $( The set of nonnegative integers (blackboard bold N_0). $)
  $c ZZ $. $( The set of integers (blackboard bold Z). $)
  $c QQ $. $( The set of rational numbers (blackboard bold Q). $)
  $c RR+ $. $( The set of positive reals (blackboard bold R^+). $)

  $( Introduce some defined terms for our axiom system. $)

  $( Extend class notation to include subtraction. $)
  cmin $a class - $.
  $( Extend class notation to include unary minus.  The symbol ` -u ` is
     not a class by itself but part of a compound class definition.  We
     do this rather than making it a formal function since it is so
     commonly used.  Note: We use different symbols for unary minus
     ( ` -u ` ) and subtraction ~ cmin ( ` - ` ) to prevent syntax ambiguity.
     For example, looking at the syntax definition ~ co , if we used the same
     symbol then " ` ( - A - B ) ` " could mean either " ` - A ` " minus
     " ` B ` ", or it could represent the (meaningless) operation of classes
     " ` - ` " and " ` - B ` " connected with "operation" " ` A ` ".  On the
     other hand, " ` ( -u A - B ) ` " is unambiguous. $)
  cneg $a class -u A $.
  $( Extend class notation to include division. $)
  cdiv $a class / $.

  $( Extend wff notation to include the 'less than or equal to' relation. $)
  cle $a class <_ $.
  $( Extend class notation to include the class of positive integers. $)
  cn $a class NN $.
  $( Extend class notation to include the class of nonnegative integers. $)
  cn0 $a class NN0 $.
  $( Extend class notation to include the class of integers. $)
  cz $a class ZZ $.
  $( Extend class notation to include the class of rationals. $)
  cq $a class QQ $.
  $( Extend class notation to include the class of positive reals. $)
  crp $a class RR+ $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Some deductions from the field axioms for complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Alias for ~ axaddcl , for naming consistency with ~ addcli . $)
  addcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) e. CC ) $=
    cA cB axaddcl $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axaddrcl , for naming consistency with ~ readdcli . $)
  readdcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A + B ) e. RR ) $=
    cA cB axaddrcl $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axmulcl , for naming consistency with ~ mulcli . $)
  mulcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) e. CC ) $=
    cA cB axmulcl $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axmulrcl , for naming consistency with ~ remulcli . $)
  remulcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A x. B ) e. RR ) $=
    cA cB axmulrcl $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axaddcom , for naming consistency with ~ addcomi . $)
  addcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) = ( B + A ) ) $=
    cA cB axaddcom $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axmulcom , for naming consistency with ~ mulcomi . $)
  mulcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) = ( B x. A ) ) $=
    cA cB axmulcom $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axaddass , for naming consistency with ~ addassi . $)
  addass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A + B ) + C ) = ( A + ( B + C ) ) ) $=
    cA cB cC axaddass $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axmulass , for naming consistency with ~ mulassi . $)
  mulass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) ) $=
    cA cB cC axmulass $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ axdistr , for naming consistency with ~ adddii . $)
  adddi $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) ) $=
    cA cB cC axdistr $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ ax0id , for naming consistency with ~ addid1i . $)
  addid1 $p |- ( A e. CC -> ( A + 0 ) = A ) $=
    cA ax0id $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( Alias for ~ ax1id , for naming consistency with ~ mulid1i . $)
  mulid1 $p |- ( A e. CC -> ( A x. 1 ) = A ) $=
    cA ax1id $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( The set of real numbers exists. $)
  reex $p |- RR e. _V $=
    cr cc axcnex axresscn ssexi $.
    $( [25-Sep-2004] $) $( [30-Jul-2004] $)

  $( A real number is a complex number. $)
  recn $p |- ( A e. RR -> A e. CC ) $=
    cr cc cA axresscn sseli $.
    $( [10-Aug-1999] $)

  ${
    recni.1 $e |- A e. RR $.
    $( A real number is a complex number. $)
    recni $p |- A e. CC $=
      cr cc cA axresscn recni.1 sselii $.
      $( [1-Mar-1995] $)
  $}

  ${
    recnd.1 $e |- ( ph -> A e. RR ) $.
    $( Deduction from real number to complex number. $)
    recnd $p |- ( ph -> A e. CC ) $=
      wph cA cr wcel cA cc wcel recnd.1 cA recn syl $.
      $( [26-Oct-1999] $)
  $}

  $( Hypothesis for weak deduction theorem to eliminate ` A =/= 0 ` . $)
    elimne0 $p |- if ( A =/= 0 , A , 1 ) =/= 0 $=
      cA cc0 wne cA cc0 wne cA c1 cif cc0 wne c1 cc0 wne cA c1 cA cA cc0 wne cA
      c1 cif cc0 neeq1 c1 cA cc0 wne cA c1 cif cc0 neeq1 ax1ne0 elimhyp $.
      $( [15-May-1999] $)

  $( The addition operation is a set. $)
  addex $p |- + e. _V $=
    cc cc cxp cc caddc wf cc cc cxp cvv wcel caddc cvv wcel axaddopr cc cc
    axcnex axcnex xpex cc cc cxp cc cvv caddc fex mp2an $.
    $( [29-Nov-2004] $) $( [19-Oct-2004] $)

  $( The multiplication operation is a set. $)
  mulex $p |- x. e. _V $=
    cc cc cxp cc cmul wf cc cc cxp cvv wcel cmul cvv wcel axmulopr cc cc axcnex
    axcnex xpex cc cc cxp cc cvv cmul fex mp2an $.
    $( [22-Oct-2004] $) $( [19-Oct-2004] $)

  $( Distributive law for complex numbers. $)
  adddir $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
              ( ( A + B ) x. C ) = ( ( A x. C ) + ( B x. C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cC cA cB caddc co cmul co cC cA cmul
    co cC cB cmul co caddc co cA cB caddc co cC cmul co cA cC cmul co cB cC
    cmul co caddc co cC cc wcel cA cc wcel cB cc wcel cC cA cB caddc co cmul co
    cC cA cmul co cC cB cmul co caddc co wceq cC cA cB adddi 3coml cA cc wcel
    cB cc wcel cC cc wcel cA cB caddc co cC cmul co cC cA cB caddc co cmul co
    wceq cA cB caddc co cc wcel cC cc wcel cA cB caddc co cC cmul co cC cA cB
    caddc co cmul co wceq cA cc wcel cB cc wcel wa cA cB caddc co cC mulcom cA
    cB addcl sylan 3impa cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmul co cC
    cA cmul co cB cC cmul co cC cB cmul co caddc cA cc wcel cC cc wcel cA cC
    cmul co cC cA cmul co wceq cB cc wcel cA cC mulcom 3adant2 cB cc wcel cC cc
    wcel cB cC cmul co cC cB cmul co wceq cA cc wcel cB cC mulcom 3adant1
    opreq12d 3eqtr4d $.
    $( [11-Oct-2004] $) $( [10-Oct-2004] $)

  ${
    axi.1 $e |- A e. CC $.
    axi.2 $e |- B e. CC $.
    $( Closure law for addition. $)
    addcli $p |- ( A + B ) e. CC $=
      cA cc wcel cB cc wcel cA cB caddc co cc wcel axi.1 axi.2 cA cB addcl
      mp2an $.
      $( [23-Nov-1994] $)

    $( Closure law for multiplication. $)
    mulcli $p |- ( A x. B ) e. CC $=
      cA cc wcel cB cc wcel cA cB cmul co cc wcel axi.1 axi.2 cA cB mulcl mp2an
      $.
      $( [23-Nov-1994] $)

    $( Commutative law for addition. $)
    addcomi $p |- ( A + B ) = ( B + A ) $=
      cA cc wcel cB cc wcel cA cB caddc co cB cA caddc co wceq axi.1 axi.2 cA
      cB addcom mp2an $.
      $( [23-Nov-1994] $)

    $( Commutative law for multiplication. $)
    mulcomi $p |- ( A x. B ) = ( B x. A ) $=
      cA cc wcel cB cc wcel cA cB cmul co cB cA cmul co wceq axi.1 axi.2 cA cB
      mulcom mp2an $.
      $( [23-Nov-1994] $)

    ${
      axi.3 $e |- C e. CC $.
      $( Associative law for addition. $)
      addassi $p |- ( ( A + B ) + C ) = ( A + ( B + C ) ) $=
        cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC caddc co cA cB cC
        caddc co caddc co wceq axi.1 axi.2 axi.3 cA cB cC addass mp3an $.
        $( [23-Nov-1994] $)

      $( Associative law for multiplication. $)
      mulassi $p |- ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) $=
        cA cc wcel cB cc wcel cC cc wcel cA cB cmul co cC cmul co cA cB cC cmul
        co cmul co wceq axi.1 axi.2 axi.3 cA cB cC mulass mp3an $.
        $( [23-Nov-1994] $)

      $( Distributive law. $)
      adddii $p |- ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) $=
        cA cc wcel cB cc wcel cC cc wcel cA cB cC caddc co cmul co cA cB cmul
        co cA cC cmul co caddc co wceq axi.1 axi.2 axi.3 cA cB cC adddi mp3an
        $.
        $( [23-Nov-1994] $)

      $( Distributive law. $)
      adddiri $p |- ( ( A + B ) x. C ) = ( ( A x. C ) + ( B x. C ) ) $=
        cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC cmul co cA cC cmul
        co cB cC cmul co caddc co wceq axi.1 axi.2 axi.3 cA cB cC adddir mp3an
        $.
        $( [16-Feb-1995] $)

    $}
  $}

  $( 0 is a complex number. $)
  0cn $p |- 0 e. CC $=
    ci ci cmul co c1 caddc co cc0 cc axi2m1 ci ci cmul co c1 ci ci axicn axicn
    mulcli ax1cn addcli eqeltrri $.
    $( [20-Feb-2005] $) $( [19-Feb-2005] $)

  $( Identity law for addition. $)
  addid2 $p |- ( A e. CC -> ( 0 + A ) = A ) $=
    cA cc wcel cc0 cA caddc co cA cc0 caddc co cA cc0 cc wcel cA cc wcel cc0 cA
    caddc co cA cc0 caddc co wceq 0cn cc0 cA addcom mpan cA addid1 eqtrd $.
    $( [10-Aug-1999] $)

  ${
    addid1.1 $e |- A e. CC $.
    $( Identity law for addition. $)
    addid1i $p |- ( A + 0 ) = A $=
      cA cc wcel cA cc0 caddc co cA wceq addid1.1 cA addid1 ax-mp $.
      $( [23-Nov-1994] $)

    $( Identity law for addition. $)
    addid2i $p |- ( 0 + A ) = A $=
      cA cc wcel cc0 cA caddc co cA wceq addid1.1 cA addid2 ax-mp $.
      $( [23-Nov-1994] $)

    $( Identity law for multiplication. $)
    mulid1i $p |- ( A x. 1 ) = A $=
      cA cc wcel cA c1 cmul co cA wceq addid1.1 cA ax1id ax-mp $.
      $( [14-Feb-1995] $)

    $( Identity law for multiplication. $)
    mulid2i $p |- ( 1 x. A ) = A $=
      c1 cA cmul co cA c1 cmul co cA c1 cA ax1cn addid1.1 mulcomi cA addid1.1
      mulid1i eqtri $.
      $( [14-Feb-1995] $)
  $}

  ${
    axri.1 $e |- A e. RR $.
    axri.2 $e |- B e. RR $.

    $( Closure law for addition of reals. $)
    readdcli $p |- ( A + B ) e. RR $=
      cA cr wcel cB cr wcel cA cB caddc co cr wcel axri.1 axri.2 cA cB readdcl
      mp2an $.
      $( [17-Jan-1997] $)

    $( Closure law for multiplication of reals. $)
    remulcli $p |- ( A x. B ) e. RR $=
      cA cr wcel cB cr wcel cA cB cmul co cr wcel axri.1 axri.2 cA cB remulcl
      mp2an $.
      $( [17-Jan-1997] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Addition
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Commutative/associative law that swaps the first two terms in a triple
     sum. $)
  add12 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A + ( B + C ) ) = ( B + ( A + C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cC caddc co cB cA caddc
    co cC caddc co cA cB cC caddc co caddc co cB cA cC caddc co caddc co cA cc
    wcel cB cc wcel cA cB caddc co cC caddc co cB cA caddc co cC caddc co wceq
    cC cc wcel cA cc wcel cB cc wcel wa cA cB caddc co cB cA caddc co cC caddc
    cA cB addcom opreq1d 3adant3 cA cB cC addass cB cc wcel cA cc wcel cC cc
    wcel cB cA caddc co cC caddc co cB cA cC caddc co caddc co wceq cB cA cC
    addass 3com12 3eqtr3d $.
    $( [13-May-2004] $) $( [11-May-2004] $)

  $( Commutative/associative law that swaps the last two terms in a triple
     sum. $)
  add23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A + B ) + C ) = ( ( A + C ) + B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC caddc co caddc co cA cC cB
    caddc co caddc co cA cB caddc co cC caddc co cA cC caddc co cB caddc co cB
    cc wcel cC cc wcel cA cB cC caddc co caddc co cA cC cB caddc co caddc co
    wceq cA cc wcel cB cc wcel cC cc wcel wa cB cC caddc co cC cB caddc co cA
    caddc cB cC addcom opreq2d 3adant1 cA cB cC addass cA cc wcel cC cc wcel cB
    cc wcel cA cC caddc co cB caddc co cA cC cB caddc co caddc co wceq cA cC cB
    addass 3com23 3eqtr4d $.
    $( [13-Nov-1999] $)

  $( Rearrangement of 4 terms in a sum. $)
  add4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( B + D ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB caddc co cC
    caddc co cD caddc co cA cC caddc co cB caddc co cD caddc co cA cB caddc co
    cC cD caddc co caddc co cA cC caddc co cB cD caddc co caddc co cA cc wcel
    cB cc wcel wa cC cc wcel cA cB caddc co cC caddc co cD caddc co cA cC caddc
    co cB caddc co cD caddc co wceq cD cc wcel cA cc wcel cB cc wcel cC cc wcel
    cA cB caddc co cC caddc co cD caddc co cA cC caddc co cB caddc co cD caddc
    co wceq cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cC caddc co cA
    cC caddc co cB caddc co cD caddc cA cB cC add23 opreq1d 3expa adantrr cA cB
    caddc co cc wcel cC cc wcel cD cc wcel wa cA cB caddc co cC caddc co cD
    caddc co cA cB caddc co cC cD caddc co caddc co wceq cA cc wcel cB cc wcel
    wa cA cB caddc co cc wcel cC cc wcel cD cc wcel cA cB caddc co cC caddc co
    cD caddc co cA cB caddc co cC cD caddc co caddc co wceq cA cB caddc co cC
    cD addass 3expb cA cB addcl sylan cA cc wcel cC cc wcel cB cc wcel cD cc
    wcel cA cC caddc co cB caddc co cD caddc co cA cC caddc co cB cD caddc co
    caddc co wceq cA cC caddc co cc wcel cB cc wcel cD cc wcel wa cA cC caddc
    co cB caddc co cD caddc co cA cC caddc co cB cD caddc co caddc co wceq cA
    cc wcel cC cc wcel wa cA cC caddc co cc wcel cB cc wcel cD cc wcel cA cC
    caddc co cB caddc co cD caddc co cA cC caddc co cB cD caddc co caddc co
    wceq cA cC caddc co cB cD addass 3expb cA cC addcl sylan an4s 3eqtr3d $.
    $( [13-Nov-1999] $)

  $( Rearrangement of 4 terms in a sum. $)
  add42 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( D + B ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB caddc co cC cD
    caddc co caddc co cA cC caddc co cB cD caddc co caddc co cA cC caddc co cD
    cB caddc co caddc co cA cB cC cD add4 cA cc wcel cB cc wcel wa cC cc wcel
    cD cc wcel wa wa cB cD caddc co cD cB caddc co cA cC caddc co caddc cB cc
    wcel cD cc wcel cB cD caddc co cD cB caddc co wceq cA cc wcel cC cc wcel cB
    cD addcom ad2ant2l opreq2d eqtrd $.
    $( [15-May-2005] $) $( [12-May-2005] $)

  ${
    add.1 $e |- A e. CC $.
    add.2 $e |- B e. CC $.
    add.3 $e |- C e. CC $.
    $( Commutative/associative law that swaps the first two terms in a triple
       sum. $)
    add12i $p |- ( A + ( B + C ) ) = ( B + ( A + C ) ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB cC caddc co caddc co cB cA cC
      caddc co caddc co wceq add.1 add.2 add.3 cA cB cC add12 mp3an $.
      $( [21-Jan-1997] $)

    $( Commutative/associative law that swaps the last two terms in a triple
       sum. $)
    add23i $p |- ( ( A + B ) + C ) = ( ( A + C ) + B ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC caddc co cA cC caddc
      co cB caddc co wceq add.1 add.2 add.3 cA cB cC add23 mp3an $.
      $( [21-Jan-1997] $)
  $}

  ${
    add4.1 $e |- A e. CC $.
    add4.2 $e |- B e. CC $.
    add4.3 $e |- C e. CC $.
    add4.4 $e |- D e. CC $.
    $( Rearrangement of 4 terms in a sum. $)
    add4i $p |- ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( B + D ) ) $=
      cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa cA cB caddc co cC cD
      caddc co caddc co cA cC caddc co cB cD caddc co caddc co wceq cA cc wcel
      cB cc wcel add4.1 add4.2 pm3.2i cC cc wcel cD cc wcel add4.3 add4.4
      pm3.2i cA cB cC cD add4 mp2an $.
      $( [9-May-1999] $)

    $( Rearrangement of 4 terms in a sum. $)
    add42i $p |- ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( D + B ) ) $=
      cA cB caddc co cC cD caddc co caddc co cA cC caddc co cB cD caddc co
      caddc co cA cC caddc co cD cB caddc co caddc co cA cB cC cD add4.1 add4.2
      add4.3 add4.4 add4i cB cD caddc co cD cB caddc co cA cC caddc co caddc cB
      cD add4.2 add4.4 addcomi opreq2i eqtri $.
      $( [22-Aug-1999] $)
  $}

  $( A theorem for complex numbers analogous the second Peano postulate
     ~ peano2nn . $)
  peano2cn $p |- ( A e. CC -> ( A + 1 ) e. CC ) $=
    cA cc wcel c1 cc wcel cA c1 caddc co cc wcel ax1cn cA c1 addcl mpan2 $.
    $( [18-Aug-2005] $) $( [17-Aug-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Subtraction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d x y z A $.  $d x B $.  $d x C $.
    $( Lemma for ~ cnegex . $)
    cnegexlem1 $p |- ( ( A e. RR /\ B e. CC /\ C e. CC ) ->
                  ( ( A + B ) = ( A + C ) <-> B = C ) ) $=
      cA cr wcel cB cc wcel cC cc wcel w3a cA cB caddc co cA cC caddc co wceq
      cB cC wceq cA cr wcel cB cc wcel cC cc wcel w3a cA vx cv caddc co cc0
      wceq vx cr wrex cA cB caddc co cA cC caddc co wceq cB cC wceq wi cA cr
      wcel cB cc wcel cA vx cv caddc co cc0 wceq vx cr wrex cC cc wcel vx cA
      axrnegex 3ad2ant1 cA cc wcel cB cc wcel cC cc wcel cA vx cv caddc co cc0
      wceq vx cr wrex cA cB caddc co cA cC caddc co wceq cB cC wceq wi wi cA cr
      wcel cA cc wcel cB cc wcel cC cc wcel cA vx cv caddc co cc0 wceq vx cr
      wrex cA cB caddc co cA cC caddc co wceq cB cC wceq wi wi cA cc wcel cB cc
      wcel cC cc wcel wa wa cA vx cv caddc co cc0 wceq cA cB caddc co cA cC
      caddc co wceq cB cC wceq wi vx cr cA cc wcel cB cc wcel cC cc wcel wa wa
      vx cv cc wcel cA vx cv caddc co cc0 wceq cA cB caddc co cA cC caddc co
      wceq cB cC wceq wi wi vx cv cr wcel cA cc wcel cB cc wcel cC cc wcel wa
      wa vx cv cc wcel wa cA vx cv caddc co cc0 wceq cA cB caddc co cA cC caddc
      co wceq cB cC wceq wi cA cc wcel cB cc wcel cC cc wcel wa wa vx cv cc
      wcel wa cA vx cv caddc co cc0 wceq wa cA cB caddc co cA cC caddc co wceq
      vx cv cA caddc co cB caddc co vx cv cA caddc co cC caddc co wceq cB cC
      wceq cA cc wcel cB cc wcel cC cc wcel wa wa vx cv cc wcel wa cA cB caddc
      co cA cC caddc co wceq vx cv cA caddc co cB caddc co vx cv cA caddc co cC
      caddc co wceq wi cA vx cv caddc co cc0 wceq cA cc wcel cB cc wcel cC cc
      wcel wa wa vx cv cc wcel wa vx cv cA caddc co cB caddc co vx cv cA caddc
      co cC caddc co wceq vx cv cA cB caddc co caddc co vx cv cA cC caddc co
      caddc co wceq cA cB caddc co cA cC caddc co wceq cA cc wcel cB cc wcel cC
      cc wcel wa wa vx cv cc wcel wa vx cv cA caddc co cB caddc co vx cv cA cB
      caddc co caddc co vx cv cA caddc co cC caddc co vx cv cA cC caddc co
      caddc co vx cv cc wcel cA cc wcel cB cc wcel vx cv cA caddc co cB caddc
      co vx cv cA cB caddc co caddc co wceq cA cc wcel cB cc wcel cC cc wcel wa
      wa vx cv cc wcel wa vx cv cA cB addass cA cc wcel cB cc wcel cC cc wcel
      wa wa vx cv cc wcel pm3.27 cA cc wcel cB cc wcel cC cc wcel wa vx cv cc
      wcel simpll cA cc wcel cB cc wcel cC cc wcel vx cv cc wcel simplrl
      syl3anc vx cv cc wcel cA cc wcel cC cc wcel vx cv cA caddc co cC caddc co
      vx cv cA cC caddc co caddc co wceq cA cc wcel cB cc wcel cC cc wcel wa wa
      vx cv cc wcel wa vx cv cA cC addass cA cc wcel cB cc wcel cC cc wcel wa
      wa vx cv cc wcel pm3.27 cA cc wcel cB cc wcel cC cc wcel wa vx cv cc wcel
      simpll cA cc wcel cB cc wcel cC cc wcel vx cv cc wcel simplrr syl3anc
      eqeq12d cA cB caddc co cA cC caddc co vx cv caddc opreq2 syl5bir adantr
      cA cc wcel cB cc wcel cC cc wcel wa wa vx cv cc wcel wa cA vx cv caddc co
      cc0 wceq vx cv cA caddc co cB caddc co vx cv cA caddc co cC caddc co wceq
      cB cC wceq wb cA cc wcel cB cc wcel cC cc wcel wa wa vx cv cc wcel wa cA
      vx cv caddc co cc0 wceq vx cv cA caddc co cc0 wceq vx cv cA caddc co cB
      caddc co vx cv cA caddc co cC caddc co wceq cB cC wceq wb cA cc wcel vx
      cv cc wcel cA vx cv caddc co cc0 wceq vx cv cA caddc co cc0 wceq wb cB cc
      wcel cC cc wcel wa cA cc wcel vx cv cc wcel wa cA vx cv caddc co vx cv cA
      caddc co cc0 cA vx cv addcom eqeq1d adantlr cA cc wcel cB cc wcel cC cc
      wcel wa wa vx cv cc wcel wa vx cv cA caddc co cc0 wceq vx cv cA caddc co
      cB caddc co vx cv cA caddc co cC caddc co wceq cB cC wceq wb cA cc wcel
      cB cc wcel cC cc wcel wa wa vx cv cc wcel wa vx cv cA caddc co cc0 wceq
      wa vx cv cA caddc co cB caddc co vx cv cA caddc co cC caddc co wceq cc0
      cB caddc co cc0 cC caddc co wceq cB cC wceq vx cv cA caddc co cc0 wceq vx
      cv cA caddc co cB caddc co vx cv cA caddc co cC caddc co wceq cc0 cB
      caddc co cc0 cC caddc co wceq wb cA cc wcel cB cc wcel cC cc wcel wa wa
      vx cv cc wcel wa vx cv cA caddc co cc0 wceq vx cv cA caddc co cB caddc co
      cc0 cB caddc co vx cv cA caddc co cC caddc co cc0 cC caddc co vx cv cA
      caddc co cc0 cB caddc opreq1 vx cv cA caddc co cc0 cC caddc opreq1
      eqeq12d adantl cA cc wcel cB cc wcel cC cc wcel wa wa cc0 cB caddc co cc0
      cC caddc co wceq cB cC wceq wb vx cv cc wcel vx cv cA caddc co cc0 wceq
      cB cc wcel cC cc wcel wa cc0 cB caddc co cc0 cC caddc co wceq cB cC wceq
      wb cA cc wcel cB cc wcel cC cc wcel cc0 cB caddc co cB cc0 cC caddc co cC
      cB addid2 cC addid2 eqeqan12d adantl ad2antrr bitrd ex sylbid imp sylibd
      ex vx cv recn sylan2 r19.23adva 3impb cA recn syl3an1 mpd cB cC cA caddc
      opreq2 impbid1 $.
      $( [22-May-2007] $) $( [22-May-2007] $)

    $( Lemma for ~ cnegex . $)
    cnegexlem2 $p |- E. y e. RR ( _i x. y ) e. RR $=
      cc0 vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex ci vy cv
      cmul co cr wcel vy cr wrex cc0 cc wcel cc0 vx cv ci vy cv cmul co caddc
      co wceq vy cr wrex vx cr wrex 0cn vx vy cc0 axcnre ax-mp cc0 vx cv ci vy
      cv cmul co caddc co wceq vy cr wrex ci vy cv cmul co cr wcel vy cr wrex
      vx cr vx cv cr wcel cc0 vx cv ci vy cv cmul co caddc co wceq ci vy cv
      cmul co cr wcel vy cr vx cv cr wcel vy cv cr wcel wa vx cv vz cv caddc co
      cc0 wceq vz cr wrex cc0 vx cv ci vy cv cmul co caddc co wceq ci vy cv
      cmul co cr wcel wi vx cv cr wcel vx cv vz cv caddc co cc0 wceq vz cr wrex
      vy cv cr wcel vz vx cv axrnegex adantr vx cv cr wcel vy cv cr wcel wa vx
      cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq ci vy
      cv cmul co cr wcel wi vz cr vx cv cr wcel vy cv cr wcel wa vz cv cr wcel
      wa vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq
      ci vy cv cmul co cr wcel vx cv cr wcel vy cv cr wcel wa vz cv cr wcel wa
      vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq wa
      wa vz cv ci vy cv cmul co cr vx cv cr wcel vy cv cr wcel wa vz cv cr wcel
      wa vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq
      wa vz cv ci vy cv cmul co wceq vx cv cr wcel vy cv cr wcel vz cv cr wcel
      vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq wa
      vz cv ci vy cv cmul co wceq wi vx cv cc wcel ci vy cv cmul co cc wcel vz
      cv cc wcel vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc
      co wceq wa vz cv ci vy cv cmul co wceq wi vx cv cr wcel vy cv cr wcel vz
      cv cr wcel vx cv cc wcel ci vy cv cmul co cc wcel vz cv cc wcel w3a vx cv
      vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq wa vz cv
      ci vy cv cmul co wceq vx cv cc wcel ci vy cv cmul co cc wcel vz cv cc
      wcel w3a vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc
      co wceq wa wa cc0 vz cv caddc co vz cv ci vy cv cmul co vx cv cc wcel ci
      vy cv cmul co cc wcel vz cv cc wcel w3a cc0 vz cv caddc co vz cv wceq vx
      cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq wa vz
      cv cc wcel vx cv cc wcel cc0 vz cv caddc co vz cv wceq ci vy cv cmul co
      cc wcel vz cv addid2 3ad2ant3 adantr vx cv cc wcel ci vy cv cmul co cc
      wcel vz cv cc wcel w3a vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv
      cmul co caddc co wceq wa wa vx cv vz cv caddc co ci vy cv cmul co caddc
      co cc0 ci vy cv cmul co caddc co cc0 vz cv caddc co ci vy cv cmul co vx
      cv vz cv caddc co cc0 wceq vx cv vz cv caddc co ci vy cv cmul co caddc co
      cc0 ci vy cv cmul co caddc co wceq vx cv cc wcel ci vy cv cmul co cc wcel
      vz cv cc wcel w3a cc0 vx cv ci vy cv cmul co caddc co wceq vx cv vz cv
      caddc co cc0 ci vy cv cmul co caddc opreq1 ad2antrl vx cv cc wcel ci vy
      cv cmul co cc wcel vz cv cc wcel w3a cc0 vx cv ci vy cv cmul co caddc co
      wceq vx cv vz cv caddc co ci vy cv cmul co caddc co cc0 vz cv caddc co
      wceq vx cv vz cv caddc co cc0 wceq vx cv cc wcel ci vy cv cmul co cc wcel
      vz cv cc wcel w3a cc0 vx cv ci vy cv cmul co caddc co wceq vx cv vz cv
      caddc co ci vy cv cmul co caddc co vx cv ci vy cv cmul co caddc co vz cv
      caddc co cc0 vz cv caddc co vx cv cc wcel vz cv cc wcel ci vy cv cmul co
      cc wcel vx cv vz cv caddc co ci vy cv cmul co caddc co vx cv ci vy cv
      cmul co caddc co vz cv caddc co wceq vx cv vz cv ci vy cv cmul co add23
      3com23 cc0 vx cv ci vy cv cmul co caddc co wceq cc0 vz cv caddc co vx cv
      ci vy cv cmul co caddc co vz cv caddc co cc0 vx cv ci vy cv cmul co caddc
      co vz cv caddc opreq1 eqcomd sylan9eq adantrl vx cv cc wcel ci vy cv cmul
      co cc wcel vz cv cc wcel w3a cc0 ci vy cv cmul co caddc co ci vy cv cmul
      co wceq vx cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co
      wceq wa ci vy cv cmul co cc wcel vx cv cc wcel cc0 ci vy cv cmul co caddc
      co ci vy cv cmul co wceq vz cv cc wcel ci vy cv cmul co addid2 3ad2ant2
      adantr 3eqtr3d eqtr3d ex vx cv recn ci cc wcel vy cv cc wcel ci vy cv
      cmul co cc wcel vy cv cr wcel ci vy cv mulcl axicn vy cv recn sylancr vz
      cv recn syl3an 3expa imp vx cv cr wcel vy cv cr wcel wa vz cv cr wcel vx
      cv vz cv caddc co cc0 wceq cc0 vx cv ci vy cv cmul co caddc co wceq wa
      simplr eqeltrrd exp32 r19.23adva mpd r19.22dva r19.23aiv ax-mp $.
      $( [11-Mar-2008] $) $( [22-May-2007] $)

    $( Lemma for ~ cnegex . $)
    cnegexlem3 $p |- ( ( b e. RR /\ y e. RR ) -> E. c e. RR ( b + c ) = y ) $=
      vb cv cr wcel vy cv cr wcel wa vy cv vx cv caddc co cc0 wceq vx cr wrex
      vb cv vc cv caddc co vy cv wceq vc cr wrex vy cv cr wcel vy cv vx cv
      caddc co cc0 wceq vx cr wrex vb cv cr wcel vx vy cv axrnegex adantl vb cv
      cr wcel vy cv cr wcel wa vy cv vx cv caddc co cc0 wceq vb cv vc cv caddc
      co vy cv wceq vc cr wrex vx cr vb cv cr wcel vy cv cr wcel wa vx cv cr
      wcel wa vy cv vx cv caddc co cc0 wceq vb cv vc cv caddc co vy cv wceq vc
      cr wrex vb cv cr wcel vy cv cr wcel wa vx cv cr wcel wa vy cv vx cv caddc
      co cc0 wceq wa vb cv vx cv caddc co vc cv caddc co cc0 wceq vc cr wrex vb
      cv vc cv caddc co vy cv wceq vc cr wrex vb cv cr wcel vy cv cr wcel wa vx
      cv cr wcel wa vb cv vx cv caddc co vc cv caddc co cc0 wceq vc cr wrex vy
      cv vx cv caddc co cc0 wceq vb cv cr wcel vx cv cr wcel vb cv vx cv caddc
      co vc cv caddc co cc0 wceq vc cr wrex vy cv cr wcel vb cv cr wcel vx cv
      cr wcel wa vb cv vx cv caddc co cr wcel vb cv vx cv caddc co vc cv caddc
      co cc0 wceq vc cr wrex vb cv vx cv readdcl vc vb cv vx cv caddc co
      axrnegex syl adantlr adantr vb cv cr wcel vy cv cr wcel wa vx cv cr wcel
      wa vy cv vx cv caddc co cc0 wceq wa vb cv vx cv caddc co vc cv caddc co
      cc0 wceq vb cv vc cv caddc co vy cv wceq vc cr vb cv cc wcel vy cv cc
      wcel wa vx cv cr wcel wa vy cv vx cv caddc co cc0 wceq wa vc cv cc wcel
      vb cv vx cv caddc co vc cv caddc co cc0 wceq vb cv vc cv caddc co vy cv
      wceq wb vb cv cr wcel vy cv cr wcel wa vx cv cr wcel wa vy cv vx cv caddc
      co cc0 wceq wa vc cv cr wcel vb cv cc wcel vy cv cc wcel wa vx cv cr wcel
      wa vy cv vx cv caddc co cc0 wceq wa vc cv cc wcel wa vx cv vb cv vc cv
      caddc co caddc co vx cv vy cv caddc co wceq vb cv vx cv caddc co vc cv
      caddc co cc0 wceq vb cv vc cv caddc co vy cv wceq vb cv cc wcel vy cv cc
      wcel wa vx cv cr wcel wa vy cv vx cv caddc co cc0 wceq wa vc cv cc wcel
      wa vx cv vb cv vc cv caddc co caddc co vb cv vx cv caddc co vc cv caddc
      co vx cv vy cv caddc co cc0 vb cv cc wcel vy cv cc wcel wa vx cv cr wcel
      wa vc cv cc wcel vx cv vb cv vc cv caddc co caddc co vb cv vx cv caddc co
      vc cv caddc co wceq vy cv vx cv caddc co cc0 wceq vb cv cc wcel vx cv cr
      wcel vc cv cc wcel vx cv vb cv vc cv caddc co caddc co vb cv vx cv caddc
      co vc cv caddc co wceq vy cv cc wcel vb cv cc wcel vx cv cc wcel vc cv cc
      wcel vx cv vb cv vc cv caddc co caddc co vb cv vx cv caddc co vc cv caddc
      co wceq vx cv cr wcel vb cv cc wcel vx cv cc wcel wa vc cv cc wcel wa vb
      cv vx cv caddc co vc cv caddc co vb cv vc cv caddc co vx cv caddc co vx
      cv vb cv vc cv caddc co caddc co vb cv cc wcel vx cv cc wcel vc cv cc
      wcel vb cv vx cv caddc co vc cv caddc co vb cv vc cv caddc co vx cv caddc
      co wceq vb cv vx cv vc cv add23 3expa vb cv cc wcel vc cv cc wcel vx cv
      cc wcel vb cv vc cv caddc co vx cv caddc co vx cv vb cv vc cv caddc co
      caddc co wceq vb cv vc cv caddc co cc wcel vx cv cc wcel vb cv vc cv
      caddc co vx cv caddc co vx cv vb cv vc cv caddc co caddc co wceq vb cv cc
      wcel vc cv cc wcel wa vb cv vc cv caddc co vx cv addcom vb cv vc cv addcl
      sylan an1rs eqtr2d vx cv recn sylanl2 adantllr adantlr vb cv cc wcel vy
      cv cc wcel wa vx cv cr wcel wa vy cv vx cv caddc co cc0 wceq wa vx cv vy
      cv caddc co cc0 wceq vc cv cc wcel vy cv cc wcel vx cv cr wcel vy cv vx
      cv caddc co cc0 wceq vx cv vy cv caddc co cc0 wceq vb cv cc wcel vy cv cc
      wcel vx cv cr wcel wa vy cv vx cv caddc co cc0 wceq vx cv vy cv caddc co
      vy cv vx cv caddc co cc0 vy cv cc wcel vx cv cc wcel vx cv vy cv caddc co
      vy cv vx cv caddc co wceq vx cv cr wcel vx cv cc wcel vy cv cc wcel vx cv
      vy cv caddc co vy cv vx cv caddc co wceq vx cv vy cv addcom ancoms vx cv
      recn sylan2 vy cv vx cv caddc co cc0 wceq id sylan9eq adantlll adantr
      eqeq12d vb cv cc wcel vy cv cc wcel wa vx cv cr wcel wa vc cv cc wcel vx
      cv vb cv vc cv caddc co caddc co vx cv vy cv caddc co wceq vb cv vc cv
      caddc co vy cv wceq wb vy cv vx cv caddc co cc0 wceq vx cv cr wcel vb cv
      vc cv caddc co cc wcel vy cv cc wcel vx cv vb cv vc cv caddc co caddc co
      vx cv vy cv caddc co wceq vb cv vc cv caddc co vy cv wceq wb vb cv cc
      wcel vy cv cc wcel wa vx cv cr wcel wa vc cv cc wcel wa vx cv vb cv vc cv
      caddc co vy cv cnegexlem1 vb cv cc wcel vy cv cc wcel wa vx cv cr wcel vc
      cv cc wcel simplr vb cv cc wcel vy cv cc wcel wa vc cv cc wcel vb cv vc
      cv caddc co cc wcel vx cv cr wcel vb cv cc wcel vc cv cc wcel vb cv vc cv
      caddc co cc wcel vy cv cc wcel vb cv vc cv addcl adantlr adantlr vb cv cc
      wcel vy cv cc wcel vx cv cr wcel vc cv cc wcel simpllr syl3anc adantlr
      bitr3d vb cv cr wcel vy cv cr wcel wa vx cv cr wcel wa vb cv cc wcel vy
      cv cc wcel wa vx cv cr wcel wa vy cv vx cv caddc co cc0 wceq vb cv cr
      wcel vy cv cr wcel wa vb cv cc wcel vy cv cc wcel wa vx cv cr wcel vb cv
      cr wcel vb cv cc wcel vy cv cr wcel vy cv cc wcel vb cv recn vy cv recn
      anim12i anim1i anim1i vc cv recn syl2an rexbidva mpbid ex r19.23adva mpd
      $.
      $( [22-May-2007] $) $( [22-May-2007] $)

    $( Existence of the negative of a complex number.  (Contributed by Eric
       Schmidt, 21-May-2007.) $)
    cnegex $p |- ( A e. CC -> E. x e. CC ( A + x ) = 0 ) $=
      cA cc wcel cA va cv ci vb cv cmul co caddc co wceq vb cr wrex va cr wrex
      cA vx cv caddc co cc0 wceq vx cc wrex va vb cA axcnre cA va cv ci vb cv
      cmul co caddc co wceq cA vx cv caddc co cc0 wceq vx cc wrex va vb cr cr
      cA va cv ci vb cv cmul co caddc co wceq cA vx cv caddc co cc0 wceq vx cc
      wrex va cv ci vb cv cmul co caddc co vx cv caddc co cc0 wceq vx cc wrex
      va cv cr wcel vb cv cr wcel wa cA va cv ci vb cv cmul co caddc co wceq cA
      vx cv caddc co cc0 wceq va cv ci vb cv cmul co caddc co vx cv caddc co
      cc0 wceq vx cc cA va cv ci vb cv cmul co caddc co wceq cA vx cv caddc co
      va cv ci vb cv cmul co caddc co vx cv caddc co cc0 cA va cv ci vb cv cmul
      co caddc co vx cv caddc opreq1 eqeq1d rexbidv va cv cr wcel vb cv cr wcel
      wa ci vy cv cmul co cr wcel vy cr wrex va cv ci vb cv cmul co caddc co vx
      cv caddc co cc0 wceq vx cc wrex vy cnegexlem2 va cv cr wcel vb cv cr wcel
      wa ci vy cv cmul co cr wcel va cv ci vb cv cmul co caddc co vx cv caddc
      co cc0 wceq vx cc wrex vy cr va cv cr wcel vb cv cr wcel wa vy cv cr wcel
      ci vy cv cmul co cr wcel va cv ci vb cv cmul co caddc co vx cv caddc co
      cc0 wceq vx cc wrex va cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv
      cmul co cr wcel wa wa vb cv vc cv caddc co vy cv wceq vc cr wrex va cv ci
      vb cv cmul co caddc co vx cv caddc co cc0 wceq vx cc wrex vb cv cr wcel
      vy cv cr wcel vb cv vc cv caddc co vy cv wceq vc cr wrex va cv cr wcel ci
      vy cv cmul co cr wcel vy vb vc cnegexlem3 ad2ant2lr va cv cr wcel vb cv
      cr wcel wa vy cv cr wcel ci vy cv cmul co cr wcel wa wa vb cv vc cv caddc
      co vy cv wceq va cv ci vb cv cmul co caddc co vx cv caddc co cc0 wceq vx
      cc wrex vc cr va cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv cmul
      co cr wcel wa wa vc cv cr wcel vb cv vc cv caddc co vy cv wceq va cv ci
      vb cv cmul co caddc co vx cv caddc co cc0 wceq vx cc wrex va cv cr wcel
      vb cv cr wcel wa vy cv cr wcel ci vy cv cmul co cr wcel wa wa vc cv cr
      wcel vb cv vc cv caddc co vy cv wceq wa wa va cv ci vy cv cmul co caddc
      co vd cv caddc co cc0 wceq vd cr wrex va cv ci vb cv cmul co caddc co vx
      cv caddc co cc0 wceq vx cc wrex va cv cr wcel vb cv cr wcel wa vy cv cr
      wcel ci vy cv cmul co cr wcel wa wa va cv ci vy cv cmul co caddc co vd cv
      caddc co cc0 wceq vd cr wrex vc cv cr wcel vb cv vc cv caddc co vy cv
      wceq wa va cv cr wcel ci vy cv cmul co cr wcel va cv ci vy cv cmul co
      caddc co vd cv caddc co cc0 wceq vd cr wrex vb cv cr wcel vy cv cr wcel
      va cv cr wcel ci vy cv cmul co cr wcel wa va cv ci vy cv cmul co caddc co
      cr wcel va cv ci vy cv cmul co caddc co vd cv caddc co cc0 wceq vd cr
      wrex va cv ci vy cv cmul co readdcl vd va cv ci vy cv cmul co caddc co
      axrnegex syl ad2ant2rl adantr va cv cr wcel vb cv cr wcel wa vy cv cr
      wcel ci vy cv cmul co cr wcel wa wa vc cv cr wcel vb cv vc cv caddc co vy
      cv wceq wa wa va cv ci vy cv cmul co caddc co vd cv caddc co cc0 wceq va
      cv ci vb cv cmul co caddc co vx cv caddc co cc0 wceq vx cc wrex vd cr va
      cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv cmul co cr wcel wa wa
      vc cv cr wcel vb cv vc cv caddc co vy cv wceq wa wa vd cv cr wcel va cv
      ci vy cv cmul co caddc co vd cv caddc co cc0 wceq va cv ci vb cv cmul co
      caddc co vx cv caddc co cc0 wceq vx cc wrex ci vc cv cmul co vd cv caddc
      co cc wcel va cv ci vb cv cmul co caddc co ci vc cv cmul co vd cv caddc
      co caddc co cc0 wceq va cv ci vb cv cmul co caddc co vx cv caddc co cc0
      wceq vx cc wrex va cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv
      cmul co cr wcel wa wa vc cv cr wcel vb cv vc cv caddc co vy cv wceq wa wa
      vd cv cr wcel wa va cv ci vy cv cmul co caddc co vd cv caddc co cc0 wceq
      wa va cv ci vb cv cmul co caddc co vx cv caddc co cc0 wceq va cv ci vb cv
      cmul co caddc co ci vc cv cmul co vd cv caddc co caddc co cc0 wceq vx ci
      vc cv cmul co vd cv caddc co cc vx cv ci vc cv cmul co vd cv caddc co
      wceq va cv ci vb cv cmul co caddc co vx cv caddc co va cv ci vb cv cmul
      co caddc co ci vc cv cmul co vd cv caddc co caddc co cc0 vx cv ci vc cv
      cmul co vd cv caddc co va cv ci vb cv cmul co caddc co caddc opreq2
      eqeq1d rcla4ev va cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv cmul
      co cr wcel wa wa vc cv cr wcel vb cv vc cv caddc co vy cv wceq wa wa vd
      cv cr wcel wa ci vc cv cmul co vd cv caddc co cc wcel va cv ci vy cv cmul
      co caddc co vd cv caddc co cc0 wceq vc cv cr wcel vb cv vc cv caddc co vy
      cv wceq wa vd cv cr wcel ci vc cv cmul co vd cv caddc co cc wcel va cv cr
      wcel vb cv cr wcel wa vy cv cr wcel ci vy cv cmul co cr wcel wa wa vc cv
      cr wcel vd cv cr wcel ci vc cv cmul co vd cv caddc co cc wcel vb cv vc cv
      caddc co vy cv wceq ci vc cv cmul co cc wcel vd cv cc wcel ci vc cv cmul
      co vd cv caddc co cc wcel vc cv cr wcel vd cv cr wcel ci vc cv cmul co vd
      cv addcl ci cc wcel vc cv cc wcel ci vc cv cmul co cc wcel vc cv cr wcel
      ci vc cv mulcl axicn vc cv recn sylancr vd cv recn syl2an adantlr adantll
      adantr va cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv cmul co cr
      wcel wa wa vc cv cr wcel vb cv vc cv caddc co vy cv wceq wa wa vd cv cr
      wcel wa va cv ci vy cv cmul co caddc co vd cv caddc co cc0 wceq va cv ci
      vb cv cmul co caddc co ci vc cv cmul co vd cv caddc co caddc co cc0 wceq
      va cv cr wcel vb cv cr wcel wa vy cv cr wcel ci vy cv cmul co cr wcel wa
      wa vc cv cr wcel vb cv vc cv caddc co vy cv wceq wa wa vd cv cr wcel wa
      va cv ci vy cv cmul co caddc co vd cv caddc co va cv ci vb cv cmul co
      caddc co ci vc cv cmul co vd cv caddc co caddc co cc0 va cv cr wcel vb cv
      cr wcel wa vc cv cr wcel vb cv vc cv caddc co vy cv wceq wa vd cv cr wcel
      va cv ci vy cv cmul co caddc co vd cv caddc co va cv ci vb cv cmul co
      caddc co ci vc cv cmul co vd cv caddc co caddc co wceq vy cv cr wcel ci
      vy cv cmul co cr wcel wa va cv cr wcel vb cv cr wcel wa vc cv cr wcel vb
      cv vc cv caddc co vy cv wceq wa wa vd cv cr wcel wa va cv ci vb cv cmul
      co caddc co ci vc cv cmul co vd cv caddc co caddc co va cv ci vb cv vc cv
      caddc co cmul co caddc co vd cv caddc co va cv ci vy cv cmul co caddc co
      vd cv caddc co va cv cr wcel vb cv cr wcel wa vc cv cr wcel vd cv cr wcel
      va cv ci vb cv cmul co caddc co ci vc cv cmul co vd cv caddc co caddc co
      va cv ci vb cv vc cv caddc co cmul co caddc co vd cv caddc co wceq vb cv
      vc cv caddc co vy cv wceq va cv cc wcel vb cv cc wcel wa vc cv cc wcel wa
      vd cv cc wcel va cv ci vb cv cmul co caddc co ci vc cv cmul co vd cv
      caddc co caddc co va cv ci vb cv vc cv caddc co cmul co caddc co vd cv
      caddc co wceq va cv cr wcel vb cv cr wcel wa vc cv cr wcel wa vd cv cr
      wcel va cv cc wcel vb cv cc wcel wa vc cv cc wcel wa vd cv cc wcel wa va
      cv ci vb cv cmul co caddc co ci vc cv cmul co caddc co vd cv caddc co va
      cv ci vb cv cmul co caddc co ci vc cv cmul co vd cv caddc co caddc co va
      cv ci vb cv vc cv caddc co cmul co caddc co vd cv caddc co va cv ci vb cv
      cmul co caddc co cc wcel ci vc cv cmul co cc wcel vd cv cc wcel va cv ci
      vb cv cmul co caddc co ci vc cv cmul co caddc co vd cv caddc co va cv ci
      vb cv cmul co caddc co ci vc cv cmul co vd cv caddc co caddc co wceq va
      cv cc wcel vb cv cc wcel wa vc cv cc wcel wa vd cv cc wcel wa va cv ci vb
      cv cmul co caddc co ci vc cv cmul co vd cv addass va cv cc wcel vb cv cc
      wcel wa va cv ci vb cv cmul co caddc co cc wcel vc cv cc wcel vd cv cc
      wcel va cv cc wcel ci vb cv cmul co cc wcel va cv ci vb cv cmul co caddc
      co cc wcel vb cv cc wcel va cv ci vb cv cmul co addcl ci cc wcel vb cv cc
      wcel ci vb cv cmul co cc wcel axicn ci vb cv mulcl mpan sylan2 ad2antrr
      vc cv cc wcel ci vc cv cmul co cc wcel va cv cc wcel vb cv cc wcel wa vd
      cv cc wcel ci cc wcel vc cv cc wcel ci vc cv cmul co cc wcel axicn ci vc
      cv mulcl mpan ad2antlr va cv cc wcel vb cv cc wcel wa vc cv cc wcel wa vd
      cv cc wcel pm3.27 syl3anc va cv cc wcel vb cv cc wcel wa vc cv cc wcel wa
      vd cv cc wcel wa va cv ci vb cv cmul co caddc co ci vc cv cmul co caddc
      co va cv ci vb cv vc cv caddc co cmul co caddc co vd cv caddc va cv cc
      wcel vb cv cc wcel wa vc cv cc wcel wa va cv ci vb cv cmul co caddc co ci
      vc cv cmul co caddc co va cv ci vb cv vc cv caddc co cmul co caddc co
      wceq vd cv cc wcel va cv cc wcel vb cv cc wcel wa vc cv cc wcel wa va cv
      ci vb cv cmul co caddc co ci vc cv cmul co caddc co va cv ci vb cv cmul
      co ci vc cv cmul co caddc co caddc co va cv ci vb cv vc cv caddc co cmul
      co caddc co va cv cc wcel ci vb cv cmul co cc wcel ci vc cv cmul co cc
      wcel va cv ci vb cv cmul co caddc co ci vc cv cmul co caddc co va cv ci
      vb cv cmul co ci vc cv cmul co caddc co caddc co wceq va cv cc wcel vb cv
      cc wcel wa vc cv cc wcel wa va cv ci vb cv cmul co ci vc cv cmul co
      addass va cv cc wcel vb cv cc wcel vc cv cc wcel simpll vb cv cc wcel ci
      vb cv cmul co cc wcel va cv cc wcel vc cv cc wcel ci cc wcel vb cv cc
      wcel ci vb cv cmul co cc wcel axicn ci vb cv mulcl mpan ad2antlr vc cv cc
      wcel ci vc cv cmul co cc wcel va cv cc wcel vb cv cc wcel wa ci cc wcel
      vc cv cc wcel ci vc cv cmul co cc wcel axicn ci vc cv mulcl mpan adantl
      syl3anc va cv cc wcel vb cv cc wcel wa vc cv cc wcel wa ci vb cv vc cv
      caddc co cmul co ci vb cv cmul co ci vc cv cmul co caddc co va cv caddc
      vb cv cc wcel vc cv cc wcel ci vb cv vc cv caddc co cmul co ci vb cv cmul
      co ci vc cv cmul co caddc co wceq va cv cc wcel ci cc wcel vb cv cc wcel
      vc cv cc wcel ci vb cv vc cv caddc co cmul co ci vb cv cmul co ci vc cv
      cmul co caddc co wceq axicn ci vb cv vc cv adddi mp3an1 adantll opreq2d
      eqtr4d adantr opreq1d eqtr3d va cv cr wcel vb cv cr wcel wa va cv cc wcel
      vb cv cc wcel wa vc cv cr wcel vc cv cc wcel va cv cr wcel va cv cc wcel
      vb cv cr wcel vb cv cc wcel va cv recn vb cv recn anim12i vc cv recn
      anim12i vd cv recn syl2an adantlrr vc cv cr wcel vb cv vc cv caddc co vy
      cv wceq wa va cv ci vb cv vc cv caddc co cmul co caddc co vd cv caddc co
      va cv ci vy cv cmul co caddc co vd cv caddc co wceq va cv cr wcel vb cv
      cr wcel wa vd cv cr wcel vb cv vc cv caddc co vy cv wceq va cv ci vb cv
      vc cv caddc co cmul co caddc co vd cv caddc co va cv ci vy cv cmul co
      caddc co vd cv caddc co wceq vc cv cr wcel vb cv vc cv caddc co vy cv
      wceq va cv ci vb cv vc cv caddc co cmul co caddc co va cv ci vy cv cmul
      co caddc co vd cv caddc vb cv vc cv caddc co vy cv wceq ci vb cv vc cv
      caddc co cmul co ci vy cv cmul co va cv caddc vb cv vc cv caddc co vy cv
      ci cmul opreq2 opreq2d opreq1d adantl ad2antlr eqtr2d adantllr eqeq1d
      biimpa sylanc exp31 r19.23adv mpd exp32 r19.23adv mpd exp32 r19.23adv mpi
      syl5cbir r19.23aivv syl $.
      $( [11-Mar-2008] $) $( [22-May-2007] $)
  $}

  ${
    $d x A $.
    negex.1 $e |- A e. CC $.
    $( Existence of negatives. $)
    cnegexi $p |- E. x e. CC ( A + x ) = 0 $=
      cA cc wcel cA vx cv caddc co cc0 wceq vx cc wrex negex.1 vx cA cnegex
      ax-mp $.
      $( [23-Nov-1994] $)
  $}

  $( 0 is a complex number.  (Proved without referencing ~ ax1cn by Eric
     Schmidt, 11-Apr-2007.  Compare ~ 0cn .) $)
  0cnALT $p |- 0 e. CC $=
    ci vx cv caddc co cc0 wceq vx cc wrex cc0 cc wcel ci cc wcel ci vx cv caddc
    co cc0 wceq vx cc wrex axicn vx ci cnegex ax-mp ci vx cv caddc co cc0 wceq
    cc0 cc wcel vx cc vx cv cc wcel ci vx cv caddc co cc0 wceq wa ci vx cv
    caddc co cc wcel cc0 cc wcel vx cv cc wcel ci vx cv caddc co cc wcel ci vx
    cv caddc co cc0 wceq ci cc wcel vx cv cc wcel ci vx cv caddc co cc wcel
    axicn ci vx cv addcl mpan adantr ci vx cv caddc co cc0 wceq ci vx cv caddc
    co cc wcel cc0 cc wcel wb vx cv cc wcel ci vx cv caddc co cc0 cc eleq1
    adantl mpbid r19.23aiva ax-mp $.
    $( [12-Apr-2007] $) $( [19-Feb-2005] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    addcan.1 $e |- A e. CC $.
    addcan.2 $e |- B e. CC $.
    addcan.3 $e |- C e. CC $.
    $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18. $)
    addcani $p |- ( ( A + B ) = ( A + C ) <-> B = C ) $=
      cA cB caddc co cA cC caddc co wceq cB cC wceq cA vx cv caddc co cc0 wceq
      vx cc wrex cA cB caddc co cA cC caddc co wceq cB cC wceq wi vx cA
      addcan.1 cnegexi cA vx cv caddc co cc0 wceq cA cB caddc co cA cC caddc co
      wceq cB cC wceq wi vx cc vx cv cc wcel cA vx cv caddc co cc0 wceq wa cA
      cB caddc co cA cC caddc co wceq vx cv cA caddc co cB caddc co vx cv cA
      caddc co cC caddc co wceq cB cC wceq vx cv cc wcel cA cB caddc co cA cC
      caddc co wceq vx cv cA caddc co cB caddc co vx cv cA caddc co cC caddc co
      wceq wi cA vx cv caddc co cc0 wceq vx cv cc wcel vx cv cA caddc co cB
      caddc co vx cv cA caddc co cC caddc co wceq vx cv cA cB caddc co caddc co
      vx cv cA cC caddc co caddc co wceq cA cB caddc co cA cC caddc co wceq vx
      cv cc wcel cA cc wcel vx cv cA caddc co cB caddc co vx cv cA caddc co cC
      caddc co wceq vx cv cA cB caddc co caddc co vx cv cA cC caddc co caddc co
      wceq wb addcan.1 vx cv cc wcel cA cc wcel wa vx cv cA caddc co cB caddc
      co vx cv cA cB caddc co caddc co vx cv cA caddc co cC caddc co vx cv cA
      cC caddc co caddc co vx cv cc wcel cA cc wcel cB cc wcel vx cv cA caddc
      co cB caddc co vx cv cA cB caddc co caddc co wceq addcan.2 vx cv cA cB
      addass mp3an3 vx cv cc wcel cA cc wcel cC cc wcel vx cv cA caddc co cC
      caddc co vx cv cA cC caddc co caddc co wceq addcan.3 vx cv cA cC addass
      mp3an3 eqeq12d mpan2 cA cB caddc co cA cC caddc co vx cv caddc opreq2
      syl5bir adantr vx cv cc wcel cA vx cv caddc co cc0 wceq vx cv cA caddc co
      cB caddc co vx cv cA caddc co cC caddc co wceq cB cC wceq wb vx cv cc
      wcel cA vx cv caddc co cc0 wceq vx cv cA caddc co cc0 wceq vx cv cA caddc
      co cB caddc co vx cv cA caddc co cC caddc co wceq cB cC wceq wb vx cv cc
      wcel cA vx cv caddc co vx cv cA caddc co cc0 cA cc wcel vx cv cc wcel cA
      vx cv caddc co vx cv cA caddc co wceq addcan.1 cA vx cv addcom mpan
      eqeq1d vx cv cA caddc co cc0 wceq vx cv cA caddc co cB caddc co cB vx cv
      cA caddc co cC caddc co cC vx cv cA caddc co cc0 wceq vx cv cA caddc co
      cB caddc co cc0 cB caddc co cB vx cv cA caddc co cc0 cB caddc opreq1 cB
      addcan.2 addid2i syl6eq vx cv cA caddc co cc0 wceq vx cv cA caddc co cC
      caddc co cc0 cC caddc co cC vx cv cA caddc co cc0 cC caddc opreq1 cC
      addcan.3 addid2i syl6eq eqeq12d syl6bi imp sylibd r19.23aiva ax-mp cB cC
      cA caddc opreq2 impbii $.
      $( [27-Oct-1999] $)
  $}

  $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18.  This
     proof illustrates how ~ dedth3h can be used to convert
     the assumptions of ~ addcani into antecedents.  This general
     method can be used to convert deductions into theorems as needed. $)
  addcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) = ( A + C ) <-> B = C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cA cC caddc co wceq cB cC
    wceq wb cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif cC caddc co
    wceq cB cC wceq wb cA cB cC cc0 cc0 cc0 cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif caddc co cA cc wcel cA cc0 cif cC caddc co wceq cB cc wcel cB cc0
    cif cC wceq wb cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cA cc
    wcel cA cc0 cif cC cc wcel cC cc0 cif caddc co wceq cB cc wcel cB cc0 cif
    cC cc wcel cC cc0 cif wceq wb cA cA cc wcel cA cc0 cif wceq cA cB caddc co
    cA cC caddc co wceq cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif
    cC caddc co wceq cB cC wceq cA cA cc wcel cA cc0 cif wceq cA cB caddc co cA
    cc wcel cA cc0 cif cB caddc co cA cC caddc co cA cc wcel cA cc0 cif cC
    caddc co cA cA cc wcel cA cc0 cif cB caddc opreq1 cA cA cc wcel cA cc0 cif
    cC caddc opreq1 eqeq12d bibi1d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA
    cc0 cif cB caddc co cA cc wcel cA cc0 cif cC caddc co wceq cA cc wcel cA
    cc0 cif cB cc wcel cB cc0 cif caddc co cA cc wcel cA cc0 cif cC caddc co
    wceq cB cC wceq cB cc wcel cB cc0 cif cC wceq cB cB cc wcel cB cc0 cif wceq
    cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif caddc co cA cc wcel cA cc0 cif cC caddc co cB cB cc wcel cB cc0 cif cA
    cc wcel cA cc0 cif caddc opreq2 eqeq1d cB cB cc wcel cB cc0 cif cC eqeq1
    bibi12d cC cC cc wcel cC cc0 cif wceq cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif caddc co cA cc wcel cA cc0 cif cC caddc co wceq cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif caddc co cA cc wcel cA cc0 cif cC cc wcel cC cc0
    cif caddc co wceq cB cc wcel cB cc0 cif cC wceq cB cc wcel cB cc0 cif cC cc
    wcel cC cc0 cif wceq cC cC cc wcel cC cc0 cif wceq cA cc wcel cA cc0 cif cC
    caddc co cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif caddc co cA cc wcel cA
    cc0 cif cB cc wcel cB cc0 cif caddc co cC cC cc wcel cC cc0 cif cA cc wcel
    cA cc0 cif caddc opreq2 eqeq2d cC cC cc wcel cC cc0 cif cB cc wcel cB cc0
    cif eqeq2 bibi12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cC cc wcel cC
    cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel cC cc0 cc 0cn elimel
    addcani dedth3h $.
    $( [22-Nov-1994] $)

  $( Cancellation law for addition. $)
  addcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + C ) = ( B + C ) <-> A = B ) ) $=
    cC cc wcel cA cc wcel cB cc wcel cA cC caddc co cB cC caddc co wceq cA cB
    wceq wb cC cc wcel cA cc wcel cB cc wcel w3a cC cA caddc co cC cB caddc co
    wceq cA cC caddc co cB cC caddc co wceq cA cB wceq cC cc wcel cA cc wcel cB
    cc wcel w3a cC cA caddc co cA cC caddc co cC cB caddc co cB cC caddc co cC
    cc wcel cA cc wcel cC cA caddc co cA cC caddc co wceq cB cc wcel cC cA
    addcom 3adant3 cC cc wcel cB cc wcel cC cB caddc co cB cC caddc co wceq cA
    cc wcel cC cB addcom 3adant2 eqeq12d cC cA cB addcan bitr3d 3coml $.
    $( [23-Aug-2004] $) $( [30-Jul-2004] $)

  ${
    addcan2.1 $e |- A e. CC $.
    addcan2.2 $e |- B e. CC $.
    addcan2.3 $e |- C e. CC $.
    $( Cancellation law for addition. $)
    addcan2i $p |- ( ( A + C ) = ( B + C ) <-> A = B ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cC caddc co cB cC caddc co wceq cA cB
      wceq wb addcan2.1 addcan2.2 addcan2.3 cA cB cC addcan2 mp3an $.
      $( [14-May-2003] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    negeu.1 $e |- A e. CC $.
    negeu.2 $e |- B e. CC $.
    $( Existential uniqueness of negatives.  Theorem I.2 of [Apostol]
       p. 18. $)
    negeui $p |- E! x e. CC ( A + x ) = B $=
      cA vx cv caddc co cB wceq vx cc wreu cA vx cv caddc co cB wceq vx cc wrex
      cA vx cv caddc co cB wceq cA vy cv caddc co cB wceq wa vx cv vy cv wceq
      wi vy cc wral vx cc wral cA vx cv caddc co cB wceq cA vy cv caddc co cB
      wceq vx vy cc vx cv vy cv wceq cA vx cv caddc co cA vy cv caddc co cB vx
      cv vy cv cA caddc opreq2 eqeq1d reu4 cA vy cv caddc co cc0 wceq vy cc
      wrex cA vx cv caddc co cB wceq vx cc wrex vy cA negeu.1 cnegexi cA vy cv
      caddc co cc0 wceq cA vx cv caddc co cB wceq vx cc wrex vy cc vy cv cc
      wcel cA vy cv caddc co cc0 wceq vx cv vy cv cB caddc co wceq vx cc wrex
      cA vx cv caddc co cB wceq vx cc wrex vy cv cc wcel vy cv cB caddc co cc
      wcel vx cv vy cv cB caddc co wceq vx cc wrex vy cv cc wcel cB cc wcel vy
      cv cB caddc co cc wcel negeu.2 vy cv cB addcl mpan2 vx vy cv cB caddc co
      cc risset sylib vy cv cc wcel cA vy cv caddc co cc0 wceq vx cv vy cv cB
      caddc co wceq cA vx cv caddc co cB wceq wi vx cc wral vx cv vy cv cB
      caddc co wceq vx cc wrex cA vx cv caddc co cB wceq vx cc wrex wi vy cv cc
      wcel cA vy cv caddc co cc0 wceq vx cv vy cv cB caddc co wceq cA vx cv
      caddc co cB wceq wi vx cc wral vy cv cc wcel cA vy cv caddc co cc0 wceq
      wa vx cv vy cv cB caddc co wceq cA vx cv caddc co cB wceq wi vx cc vy cv
      cc wcel cA vy cv caddc co cc0 wceq wa vx cv vy cv cB caddc co wceq cA vx
      cv caddc co cB wceq wi vx cv cc wcel cA vy cv caddc co cc0 wceq vy cv cc
      wcel vx cv vy cv cB caddc co wceq cA vx cv caddc co cB wceq wi cA vy cv
      caddc co cc0 wceq vy cv cc wcel vx cv vy cv cB caddc co wceq cA vx cv
      caddc co cB wceq vy cv cc wcel vx cv vy cv cB caddc co wceq wa cA vy cv
      caddc co cc0 wceq cA vx cv caddc co cA vy cv caddc co cB caddc co cB vx
      cv vy cv cB caddc co wceq vy cv cc wcel cA vx cv caddc co cA vy cv cB
      caddc co caddc co cA vy cv caddc co cB caddc co vx cv vy cv cB caddc co
      cA caddc opreq2 vy cv cc wcel cA vy cv caddc co cB caddc co cA vy cv cB
      caddc co caddc co cA cc wcel vy cv cc wcel cB cc wcel cA vy cv caddc co
      cB caddc co cA vy cv cB caddc co caddc co wceq negeu.1 negeu.2 cA vy cv
      cB addass mp3an13 eqcomd sylan9eqr cA vy cv caddc co cc0 wceq cA vy cv
      caddc co cB caddc co cc0 cB caddc co cB cA vy cv caddc co cc0 cB caddc
      opreq1 cB negeu.2 addid2i syl6eq sylan9eqr exp32 impcom a1d r19.21aiv ex
      vx cv vy cv cB caddc co wceq cA vx cv caddc co cB wceq vx cc r19.22 syl6
      mpid r19.23aiv ax-mp cA vx cv caddc co cB wceq cA vy cv caddc co cB wceq
      wa vx cv vy cv wceq wi vx vy cc cA cc wcel vx cv cc wcel vy cv cc wcel cA
      vx cv caddc co cB wceq cA vy cv caddc co cB wceq wa vx cv vy cv wceq wi
      negeu.1 cA cc wcel vx cv cc wcel vy cv cc wcel w3a cA vx cv caddc co cA
      vy cv caddc co wceq vx cv vy cv wceq cA vx cv caddc co cB wceq cA vy cv
      caddc co cB wceq wa cA vx cv vy cv addcan cA vx cv caddc co cA vy cv
      caddc co cB eqtr3 syl5bi mp3an1 rgen2a mpbir2an $.
      $( [22-Nov-1994] $)
  $}

  ${
    $d x y z w $.
    $( Define subtraction.  Theorem ~ subval shows it value (and describes how
       this definition works), theorem ~ subaddi relates it to addition, and
       theorems ~ subcli and ~ resubcli prove its closure laws. $)
    df-sub $a |- - = { <. <. x , y >. , z >. |
                   ( ( x e. CC /\ y e. CC ) /\
                   z = U. { w e. CC | ( y + w ) = x } ) } $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Value of subtraction, which is the (unique) element ` x ` such that
       ` B + x = A ` .  The notation ` U. { x e. CC | ( B + x ) = A } `
       may at first seem cryptic but is actually a way of saying
       "the element ` x ` such that ` B + x = A `" (see Theorem 8.17 of
       [Quine] p. 56);  this works because there is only one such ` x ` as
       shown by ~ negeui , allowing us to exploit ~ euabsn and ~ unisn (which
       you will find if you trace back the proof of ~ subcli ). $)
    subval $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( A - B ) = U. { x e. CC | ( B + x ) = A } ) $=
      vy vz vw cA cB cc cc vz cv vx cv caddc co vy cv wceq vx cc crab cuni cB
      vx cv caddc co cA wceq vx cc crab cuni cmin vz cv vx cv caddc co cA wceq
      vx cc crab cuni cB vx cv caddc co cA wceq vx cc crab cB vx cv caddc co cA
      wceq vx cc axcnex rabex uniex vy cv cA wceq vz cv vx cv caddc co vy cv
      wceq vx cc crab vz cv vx cv caddc co cA wceq vx cc crab vy cv cA wceq vz
      cv vx cv caddc co vy cv wceq vz cv vx cv caddc co cA wceq vx cc vy cv cA
      vz cv vx cv caddc co eqeq2 rabbisdv unieqd vz cv cB wceq vz cv vx cv
      caddc co cA wceq vx cc crab cB vx cv caddc co cA wceq vx cc crab vz cv cB
      wceq vz cv vx cv caddc co cA wceq cB vx cv caddc co cA wceq vx cc vz cv
      cB wceq vz cv vx cv caddc co cB vx cv caddc co cA vz cv cB vx cv caddc
      opreq1 eqeq1d rabbisdv unieqd vy vz vw vx df-sub oprabval2 $.
      $( [4-Aug-2007] $) $( [4-Aug-2007] $)
  $}

  $( Define the negative of a number (unary minus).  We use different symbols
     for unary minus ( ` -u ` ) and subtraction ( ` - ` ) to prevent syntax
     ambiguity.  See ~ cneg for a discussion of this. $)
  df-neg $a |- -u A = ( 0 - A ) $.

  $( Equality theorem for negatives. $)
  negeq $p |- ( A = B -> -u A = -u B ) $=
    cA cB wceq cc0 cA cmin co cc0 cB cmin co cA cneg cB cneg cA cB cc0 cmin
    opreq2 cA df-neg cB df-neg 3eqtr4g $.
    $( [10-Feb-1995] $)

  ${
    negeqi.1 $e |- A = B $.
    $( Equality inference for negatives. $)
    negeqi $p |- -u A = -u B $=
      cA cB wceq cA cneg cB cneg wceq negeqi.1 cA cB negeq ax-mp $.
      $( [14-Feb-1995] $)
  $}

  ${
    negeqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for negatives. $)
    negeqd $p |- ( ph -> -u A = -u B ) $=
      wph cA cB wceq cA cneg cB cneg wceq negeqd.1 cA cB negeq syl $.
      $( [14-May-1999] $)
  $}

  ${
    $d y A $.  $d x y $.
    hbneg.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Bound-variable hypothesis builder for the negative of a complex
       number. $)
    hbneg $p |- ( y e. -u A -> A. x y e. -u A ) $=
      vx vy cA cneg cc0 cA cmin co cA df-neg vx vy cc0 cA cmin vy cv cc0 wcel
      vx ax-17 vy cv cmin wcel vx ax-17 hbneg.1 hbopr hbxfr $.
      $( [12-Jun-2005] $) $( [12-Jun-2005] $)
  $}

  ${
    $d y z A $.  $d y ph $.  $d x y z $.
    hbnegd.1 $e |- ( ph -> A. x ph ) $.
    hbnegd.2 $e |- ( ph -> ( y e. A -> A. x y e. A ) ) $.
    $( Deduction version of ~ hbneg . $)
    hbnegd $p |- ( ph -> ( y e. -u A -> A. x y e. -u A ) ) $=
      wph vy cv vz cv cA wcel vx wal vz cab cneg wcel vy cv vz cv cA wcel vx
      wal vz cab cneg wcel vx wal vy cv cA cneg wcel vy cv cA cneg wcel vx wal
      vy cv vz cv cA wcel vx wal vz cab cneg wcel vy cv vz cv cA wcel vx wal vz
      cab cneg wcel vx wal wi wph vx vy vz cv cA wcel vx wal vz cab vz cv cA
      wcel vx wal vx vz vy vz cv cA wcel vx hba1 hbab hbneg a1i wph vz cv cA
      wcel vx wal vz cab cneg cA cneg vy cv wph vz cv cA wcel vx wal vz cab cA
      wph vy cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz
      cab cA wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy hbnegd.2
      19.21aiv vx vy vz cA abidhb syl negeqd eleq2d wph vy cv vz cv cA wcel vx
      wal vz cab cneg wcel vy cv cA cneg wcel vx hbnegd.1 wph vz cv cA wcel vx
      wal vz cab cneg cA cneg vy cv wph vz cv cA wcel vx wal vz cab cA wph vy
      cv cA wcel vy cv cA wcel vx wal wi vy wal vz cv cA wcel vx wal vz cab cA
      wceq wph vy cv cA wcel vy cv cA wcel vx wal wi vy hbnegd.2 19.21aiv vx vy
      vz cA abidhb syl negeqd eleq2d albid 3imtr3d $.
      $( [2-Mar-2008] $) $( [29-Feb-2008] $)
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d x y z $.
    $( Move class substitution in and out of the negative of a number. $)
    csbnegg $p |- ( A e. C -> [_ A / x ]_ -u B = -u [_ A / x ]_ B ) $=
      cA cC wcel vy cA vx vy cv cB cneg csb csb vy cA vx vy cv cB csb csb cneg
      vx cA cB cneg csb vx cA cB csb cneg vy vz cA vx vy cv cB cneg csb vy cA
      vx vy cv cB csb csb cneg cC cA cC wcel vy vz vy cA vx vy cv cB csb csb cA
      cC wcel vy ax-17 vy vz cA vx vy cv cB csb cC vz cv cA wcel vy ax-17
      hbcsb1g hbnegd vy cv cA wceq vx vy cv cB csb cneg vy cA vx vy cv cB csb
      csb cneg vx vy cv cB cneg csb vy cv cA wceq vx vy cv cB csb vy cA vx vy
      cv cB csb csb vy cA vx vy cv cB csb csbeq1a negeqd vx cv vy cv wceq vx
      wex vx vy cv cB cneg csb vx vy cv cB csb cneg wceq vx vy a9e vx cv vy cv
      wceq vx vy cv cB cneg csb vx vy cv cB csb cneg wceq vx vx vz vz vx vy cv
      cB cneg csb vx vy cv cB csb cneg vx vz vy cv cB cneg vy visset vz cv vy
      cv wcel vx ax-17 hbcsb1 vx vz vx vy cv cB csb vx vz vy cv cB vy visset vz
      cv vy cv wcel vx ax-17 hbcsb1 hbneg hbeq vx cv vy cv wceq cB cneg vx vy
      cv cB cneg csb vx vy cv cB csb cneg vx vy cv cB cneg csbeq1a vx cv vy cv
      wceq cB vx vy cv cB csb vx vy cv cB csbeq1a negeqd eqtr3d 19.23ai ax-mp
      syl5eq csbiegf vx vy cA cB cneg cC csbcog cA cC wcel vy cA vx vy cv cB
      csb csb vx cA cB csb vx vy cA cB cC csbcog negeqd 3eqtr3d $.
      $( [23-Mar-2008] $) $( [1-Mar-2008] $)
  $}

  $( A negative is a set. $)
  negex $p |- -u A e. _V $=
    cA cneg cc0 cA cmin co cvv cA df-neg cc0 cA cmin oprex eqeltri $.
    $( [27-May-2005] $) $( [4-Apr-2005] $)

  ${
    $d x A $.  $d x B $.
    subcl.1 $e |- A e. CC $.
    subcl.2 $e |- B e. CC $.
    $( Closure law for subtraction. $)
    subcli $p |- ( A - B ) e. CC $=
      cA cB cmin co cB vx cv caddc co cA wceq vx cc crab cuni cc cA cc wcel cB
      cc wcel cA cB cmin co cB vx cv caddc co cA wceq vx cc crab cuni wceq
      subcl.1 subcl.2 vx cA cB subval mp2an cB vx cv caddc co cA wceq vx cc
      wreu cB vx cv caddc co cA wceq vx cc crab cuni cc wcel vx cB cA subcl.2
      subcl.1 negeui cB vx cv caddc co cA wceq vx cc reucl ax-mp eqeltri $.
      $( [26-Nov-1994] $)
  $}

  $( Closure law for subtraction. $)
  subcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A - B ) e. CC ) $=
    cA cc wcel cB cc wcel cA cB cmin co cc wcel cA cc wcel cA cc0 cif cB cmin
    co cc wcel cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cc wcel cA
    cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB cmin co cA cc wcel cA cc0
    cif cB cmin co cc cA cA cc wcel cA cc0 cif cB cmin opreq1 eleq1d cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin co cA cc wcel cA cc0 cif
    cB cc wcel cB cc0 cif cmin co cc cB cB cc wcel cB cc0 cif cA cc wcel cA cc0
    cif cmin opreq2 eleq1d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0
    cc 0cn elimel cB cc0 cc 0cn elimel subcli dedth2h $.
    $( [10-May-1999] $)

  $( Closure law for negative. $)
  negcl $p |- ( A e. CC -> -u A e. CC ) $=
    cA cc wcel cc0 cA cmin co cc cA cneg cc0 cc wcel cA cc wcel cc0 cA cmin co
    cc wcel 0cn cc0 cA subcl mpan cA df-neg syl5eqel $.
    $( [6-Aug-2003] $)

  ${
    negcl.1 $e |- A e. CC $.
    $( Closure law for negative. $)
    negcli $p |- -u A e. CC $=
      cA cc wcel cA cneg cc wcel negcl.1 cA negcl ax-mp $.
      $( [26-Nov-1994] $)
  $}

  ${
    $d w x y z $.
    $( Subtraction is an operation on the complex numbers. $)
    subopr $p |- - : ( CC X. CC ) --> CC $=
      vx vy vz cc cc vy cv vw cv caddc co vx cv wceq vw cc crab cuni cc cmin vx
      vy vz vw df-sub vx cv cc wcel vy cv cc wcel wa vx cv vy cv cmin co vy cv
      vw cv caddc co vx cv wceq vw cc crab cuni cc vw vx cv vy cv subval vx cv
      vy cv subcl eqeltrrd foprab $.
      $( [9-Aug-2007] $) $( [4-Aug-2007] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    subadd.1 $e |- A e. CC $.
    subadd.2 $e |- B e. CC $.
    subadd.3 $e |- C e. CC $.
    $( Relationship between subtraction and addition. $)
    subaddi $p |- ( ( A - B ) = C <-> ( B + C ) = A ) $=
      cC cc wcel cA cB cmin co cC wceq cB cC caddc co cA wceq wb subadd.3 cA cB
      cmin co vx cv wceq cB vx cv caddc co cA wceq wb cA cB cmin co cC wceq cB
      cC caddc co cA wceq wb vx cC cc vx cv cC wceq cA cB cmin co vx cv wceq cA
      cB cmin co cC wceq cB vx cv caddc co cA wceq cB cC caddc co cA wceq vx cv
      cC cA cB cmin co eqeq2 vx cv cC wceq cB vx cv caddc co cB cC caddc co cA
      vx cv cC cB caddc opreq2 eqeq1d bibi12d vx cv cc wcel cB vx cv caddc co
      cA wceq cB vx cv caddc co cA wceq vx cc crab cuni vx cv wceq cA cB cmin
      co vx cv wceq vx cv cc wcel cB vx cv caddc co cA wceq vx cc wreu cB vx cv
      caddc co cA wceq cB vx cv caddc co cA wceq vx cc crab cuni vx cv wceq wb
      vx cB cA subadd.2 subadd.1 negeui cB vx cv caddc co cA wceq vx cc reuuni1
      mpan2 cA cB cmin co cB vx cv caddc co cA wceq vx cc crab cuni vx cv cA cc
      wcel cB cc wcel cA cB cmin co cB vx cv caddc co cA wceq vx cc crab cuni
      wceq subadd.1 subadd.2 vx cA cB subval mp2an eqeq1i syl6rbbr vtoclga
      ax-mp $.
      $( [26-Nov-1994] $)

    ${
      subaddri.4 $e |- ( B + C ) = A $.
      $( Relationship between subtraction and addition. $)
      subaddrii $p |- ( A - B ) = C $=
        cA cB cmin co cC wceq cB cC caddc co cA wceq subaddri.4 cA cB cC
        subadd.1 subadd.2 subadd.3 subaddi mpbir $.
        $( [19-Dec-2006] $) $( [16-Dec-2006] $)
    $}

    $( Relationship between subtraction and addition. $)
    subadd2i $p |- ( ( A - B ) = C <-> ( C + B ) = A ) $=
      cA cB cmin co cC wceq cB cC caddc co cA wceq cC cB caddc co cA wceq cA cB
      cC subadd.1 subadd.2 subadd.3 subaddi cB cC caddc co cC cB caddc co cA cB
      cC subadd.2 subadd.3 addcomi eqeq1i bitri $.
      $( [15-Dec-2006] $) $( [15-Dec-2006] $)

    $( Swap subtrahend and result of subtraction. $)
    subsub23i $p |- ( ( A - B ) = C <-> ( A - C ) = B ) $=
      cB cC caddc co cA wceq cC cB caddc co cA wceq cA cB cmin co cC wceq cA cC
      cmin co cB wceq cB cC caddc co cC cB caddc co cA cB cC subadd.2 subadd.3
      addcomi eqeq1i cA cB cC subadd.1 subadd.2 subadd.3 subaddi cA cC cB
      subadd.1 subadd.3 subadd.2 subaddi 3bitr4i $.
      $( [7-Oct-1999] $)
  $}

  $( Relationship between subtraction and addition. $)
  subadd $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) = C <-> ( B + C ) = A ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cA cB cmin co cC wceq cB cC caddc co cA
    wceq wb cA cc wcel cA cc0 cif cB cmin co cC wceq cB cC caddc co cA cc wcel
    cA cc0 cif wceq wb cA cB cC cc0 cc0 cc0 cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cmin co cC wceq cB cc wcel cB cc0 cif cC caddc co cA cc wcel cA cc0
    cif wceq wb cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cC cc wcel
    cC cc0 cif wceq cB cc wcel cB cc0 cif cC cc wcel cC cc0 cif caddc co cA cc
    wcel cA cc0 cif wceq wb cA cA cc wcel cA cc0 cif wceq cA cB cmin co cC wceq
    cA cc wcel cA cc0 cif cB cmin co cC wceq cB cC caddc co cA wceq cB cC caddc
    co cA cc wcel cA cc0 cif wceq cA cA cc wcel cA cc0 cif wceq cA cB cmin co
    cA cc wcel cA cc0 cif cB cmin co cC cA cA cc wcel cA cc0 cif cB cmin opreq1
    eqeq1d cA cA cc wcel cA cc0 cif cB cC caddc co eqeq2 bibi12d cB cB cc wcel
    cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin co cC wceq cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmin co cC wceq cB cC caddc co cA cc wcel cA cc0
    cif wceq cB cc wcel cB cc0 cif cC caddc co cA cc wcel cA cc0 cif wceq cB cB
    cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin co cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmin co cC cB cB cc wcel cB cc0 cif cA cc wcel cA
    cc0 cif cmin opreq2 eqeq1d cB cB cc wcel cB cc0 cif wceq cB cC caddc co cB
    cc wcel cB cc0 cif cC caddc co cA cc wcel cA cc0 cif cB cB cc wcel cB cc0
    cif cC caddc opreq1 eqeq1d bibi12d cC cC cc wcel cC cc0 cif wceq cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif cmin co cC wceq cA cc wcel cA cc0 cif cB
    cc wcel cB cc0 cif cmin co cC cc wcel cC cc0 cif wceq cB cc wcel cB cc0 cif
    cC caddc co cA cc wcel cA cc0 cif wceq cB cc wcel cB cc0 cif cC cc wcel cC
    cc0 cif caddc co cA cc wcel cA cc0 cif wceq cC cC cc wcel cC cc0 cif cA cc
    wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co eqeq2 cC cC cc wcel cC cc0
    cif wceq cB cc wcel cB cc0 cif cC caddc co cB cc wcel cB cc0 cif cC cc wcel
    cC cc0 cif caddc co cA cc wcel cA cc0 cif cC cC cc wcel cC cc0 cif cB cc
    wcel cB cc0 cif caddc opreq2 eqeq1d bibi12d cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif cC cc wcel cC cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel cC cc0 cc 0cn elimel subaddi dedth3h $.
    $( [20-Jan-1997] $)

  $( Swap subtrahend and result of subtraction. $)
  subsub23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) = C <-> ( A - C ) = B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cB cC caddc co cA wceq cC cB caddc co
    cA wceq cA cB cmin co cC wceq cA cC cmin co cB wceq cA cc wcel cB cc wcel
    cC cc wcel w3a cB cC caddc co cC cB caddc co cA cB cc wcel cC cc wcel cB cC
    caddc co cC cB caddc co wceq cA cc wcel cB cC addcom 3adant1 eqeq1d cA cB
    cC subadd cA cc wcel cC cc wcel cB cc wcel cA cC cmin co cB wceq cC cB
    caddc co cA wceq wb cA cC cB subadd 3com23 3bitr4d $.
    $( [14-Dec-2007] $) $( [14-Dec-2007] $)

  $( Subtraction and addition of equals. $)
  pncan3 $p |- ( ( A e. CC /\ B e. CC ) -> ( A + ( B - A ) ) = B ) $=
    cA cc wcel cB cc wcel wa cB cA cmin co cB cA cmin co wceq cA cB cA cmin co
    caddc co cB wceq cB cA cmin co eqid cB cc wcel cA cc wcel cB cA cmin co cc
    wcel cB cA cmin co cB cA cmin co wceq cA cB cA cmin co caddc co cB wceq wb
    cA cc wcel cB cc wcel wa cB cA cB cA cmin co subadd cA cc wcel cB cc wcel
    pm3.27 cA cc wcel cB cc wcel pm3.26 cB cc wcel cA cc wcel cB cA cmin co cc
    wcel cB cA subcl ancoms syl3anc mpbii $.
    $( [15-Mar-2005] $) $( [14-Mar-2005] $)

  ${
    pncan3.1 $e |- A e. CC $.
    pncan3.2 $e |- B e. CC $.
    $( Subtraction and addition of equals. $)
    pncan3i $p |- ( A + ( B - A ) ) = B $=
      cA cc wcel cB cc wcel cA cB cA cmin co caddc co cB wceq pncan3.1 pncan3.2
      cA cB pncan3 mp2an $.
      $( [26-Nov-1994] $)
  $}

  $( Addition of a number and its negative. $)
  negid $p |- ( A e. CC -> ( A + -u A ) = 0 ) $=
    cA cc wcel cA cc0 cA cmin co caddc co cc0 cA cA cneg caddc co cA cc wcel
    cc0 cc wcel cA cc0 cA cmin co caddc co cc0 wceq 0cn cA cc0 pncan3 mpan2 cA
    cneg cc0 cA cmin co cA caddc cA df-neg opreq2i syl5eq $.
    $( [15-Mar-2005] $) $( [14-Mar-2005] $)

  ${
    negid.1 $e |- A e. CC $.
    $( Addition of a number and its negative. $)
    negidi $p |- ( A + -u A ) = 0 $=
      cA cc wcel cA cA cneg caddc co cc0 wceq negid.1 cA negid ax-mp $.
      $( [26-Nov-1994] $)
  $}

  ${
    negsub.1 $e |- A e. CC $.
    negsub.2 $e |- B e. CC $.
    $( Relationship between subtraction and negative.  Theorem I.3 of
       [Apostol] p. 18. $)
    negsubi $p |- ( A + -u B ) = ( A - B ) $=
      cA cB cmin co cA cB cneg caddc co cA cB cA cB cneg caddc co negsub.1
      negsub.2 cA cB cneg negsub.1 cB negsub.2 negcli addcli cB cA cB cneg
      caddc co caddc co cA cB cneg caddc co cB caddc co cA cB cA cB cneg caddc
      co negsub.2 cA cB cneg negsub.1 cB negsub.2 negcli addcli addcomi cA cB
      cneg caddc co cB caddc co cA cB cneg cB caddc co caddc co cA cc0 caddc co
      cA cA cB cneg cB negsub.1 cB negsub.2 negcli negsub.2 addassi cB cneg cB
      caddc co cc0 cA caddc cB cneg cB caddc co cB cB cneg caddc co cc0 cB cneg
      cB cB negsub.2 negcli negsub.2 addcomi cB negsub.2 negidi eqtri opreq2i
      cA negsub.1 addid1i 3eqtri eqtri subaddrii eqcomi $.
      $( [3-Dec-2005] $) $( [26-Nov-1994] $)
  $}

  $( Relationship between subtraction and negative.  Theorem I.3 of
     [Apostol] p. 18. $)
  negsub $p |- ( ( A e. CC /\ B e. CC ) -> ( A + -u B ) = ( A - B ) ) $=
    cA cc wcel cB cc wcel cA cB cneg caddc co cA cB cmin co wceq cA cc wcel cA
    cc0 cif cB cneg caddc co cA cc wcel cA cc0 cif cB cmin co wceq cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif cneg caddc co cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif cmin co wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA
    cB cneg caddc co cA cc wcel cA cc0 cif cB cneg caddc co cA cB cmin co cA cc
    wcel cA cc0 cif cB cmin co cA cA cc wcel cA cc0 cif cB cneg caddc opreq1 cA
    cA cc wcel cA cc0 cif cB cmin opreq1 eqeq12d cB cB cc wcel cB cc0 cif wceq
    cA cc wcel cA cc0 cif cB cneg caddc co cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cneg caddc co cA cc wcel cA cc0 cif cB cmin co cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmin co cB cB cc wcel cB cc0 cif wceq cB cneg cB
    cc wcel cB cc0 cif cneg cA cc wcel cA cc0 cif caddc cB cB cc wcel cB cc0
    cif negeq opreq2d cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmin
    opreq2 eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn
    elimel cB cc0 cc 0cn elimel negsubi dedth2h $.
    $( [3-Dec-2005] $) $( [21-Jan-1997] $)

  $( Associative-type law for addition and subtraction. $)
  addsubass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                   ( ( A + B ) - C ) = ( A + ( B - C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cC cneg caddc co cA cB
    cC cneg caddc co caddc co cA cB caddc co cC cmin co cA cB cC cmin co caddc
    co cA cc wcel cB cc wcel cC cneg cc wcel cA cB caddc co cC cneg caddc co cA
    cB cC cneg caddc co caddc co wceq cC cc wcel cA cB cC cneg addass cC negcl
    syl3an3 cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC cneg caddc co cA
    cB caddc co cC cmin co wceq cA cB caddc co cc wcel cC cc wcel cA cB caddc
    co cC cneg caddc co cA cB caddc co cC cmin co wceq cA cc wcel cB cc wcel wa
    cA cB caddc co cC negsub cA cB addcl sylan 3impa cA cc wcel cB cc wcel cC
    cc wcel w3a cB cC cneg caddc co cB cC cmin co cA caddc cB cc wcel cC cc
    wcel cB cC cneg caddc co cB cC cmin co wceq cA cc wcel cB cC negsub 3adant1
    opreq2d 3eqtr3d $.
    $( [1-Aug-2006] $) $( [6-Aug-2003] $)

  $( Law for addition and subtraction. $)
  addsub $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A + B ) - C ) = ( ( A - C ) + B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cC cmin co cB cA caddc
    co cC cmin co cB cA cC cmin co caddc co cA cC cmin co cB caddc co cA cc
    wcel cB cc wcel cA cB caddc co cC cmin co cB cA caddc co cC cmin co wceq cC
    cc wcel cA cc wcel cB cc wcel wa cA cB caddc co cB cA caddc co cC cmin cA
    cB addcom opreq1d 3adant3 cB cc wcel cA cc wcel cC cc wcel cB cA caddc co
    cC cmin co cB cA cC cmin co caddc co wceq cB cA cC addsubass 3com12 cA cc
    wcel cB cc wcel cC cc wcel cB cA cC cmin co caddc co cA cC cmin co cB caddc
    co wceq cB cc wcel cA cc wcel cC cc wcel cB cA cC cmin co caddc co cA cC
    cmin co cB caddc co wceq wi cB cc wcel cA cc wcel cC cc wcel cB cA cC cmin
    co caddc co cA cC cmin co cB caddc co wceq cB cc wcel cA cC cmin co cc wcel
    cB cA cC cmin co caddc co cA cC cmin co cB caddc co wceq cA cc wcel cC cc
    wcel wa cB cc wcel cA cC cmin co cc wcel cB cA cC cmin co caddc co cA cC
    cmin co cB caddc co wceq cB cA cC cmin co addcom ex cA cC subcl syl5 exp3a
    com12 3imp 3eqtrd $.
    $( [19-Aug-2001] $)

  $( Commutative/associative law for addition and subtraction. $)
  subadd23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A - B ) + C ) = ( A + ( C - B ) ) ) $=
    cA cc wcel cC cc wcel cB cc wcel cA cB cmin co cC caddc co cA cC cB cmin co
    caddc co wceq cA cc wcel cC cc wcel cB cc wcel w3a cA cC caddc co cB cmin
    co cA cB cmin co cC caddc co cA cC cB cmin co caddc co cA cC cB addsub cA
    cC cB addsubass eqtr3d 3com23 $.
    $( [1-Feb-2007] $) $( [1-Feb-2007] $)

  $( Commutative/associative law for addition and subtraction. $)
  addsub12 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A + ( B - C ) ) = ( B + ( A - C ) ) ) $=
    cA cc wcel cC cc wcel cB cc wcel cA cB cC cmin co caddc co cB cA cC cmin co
    caddc co wceq cA cc wcel cC cc wcel cB cc wcel w3a cA cC cmin co cB caddc
    co cA cB cC cmin co caddc co cB cA cC cmin co caddc co cA cC cB subadd23 cA
    cc wcel cC cc wcel cB cc wcel cA cC cmin co cB caddc co cB cA cC cmin co
    caddc co wceq cA cC cmin co cc wcel cB cc wcel cA cC cmin co cB caddc co cB
    cA cC cmin co caddc co wceq cA cc wcel cC cc wcel wa cA cC cmin co cB
    addcom cA cC subcl sylan 3impa eqtr3d 3com23 $.
    $( [1-Mar-2005] $) $( [8-Feb-2005] $)

  ${
    addsubass.1 $e |- A e. CC $.
    addsubass.2 $e |- B e. CC $.
    addsubass.3 $e |- C e. CC $.
    $( Associative-type law for subtraction and addition. $)
    addsubassi $p |- ( ( A + B ) - C ) = ( A + ( B - C ) ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC cmin co cA cB cC cmin
      co caddc co wceq addsubass.1 addsubass.2 addsubass.3 cA cB cC addsubass
      mp3an $.
      $( [16-Sep-1999] $)

    $( Law for subtraction and addition. $)
    addsubi $p |- ( ( A + B ) - C ) = ( ( A - C ) + B ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC cmin co cA cC cmin co
      cB caddc co wceq addsubass.1 addsubass.2 addsubass.3 cA cB cC addsub
      mp3an $.
      $( [6-Aug-2003] $)
  $}

  $( Law for subtraction and addition. $)
  2addsub $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
                 ( ( ( A + B ) + C ) - D ) = ( ( ( A + C ) - D ) + B ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB caddc co cC
    caddc co cD cmin co cA cC caddc co cB caddc co cD cmin co cA cC caddc co cD
    cmin co cB caddc co cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA
    cB caddc co cC caddc co cA cC caddc co cB caddc co cD cmin cA cc wcel cB cc
    wcel wa cC cc wcel cA cB caddc co cC caddc co cA cC caddc co cB caddc co
    wceq cD cc wcel cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC caddc co
    cA cC caddc co cB caddc co wceq cA cB cC add23 3expa adantrr opreq1d cA cc
    wcel cC cc wcel cB cc wcel cD cc wcel cA cC caddc co cB caddc co cD cmin co
    cA cC caddc co cD cmin co cB caddc co wceq cA cC caddc co cc wcel cB cc
    wcel cD cc wcel wa cA cC caddc co cB caddc co cD cmin co cA cC caddc co cD
    cmin co cB caddc co wceq cA cc wcel cC cc wcel wa cA cC caddc co cc wcel cB
    cc wcel cD cc wcel cA cC caddc co cB caddc co cD cmin co cA cC caddc co cD
    cmin co cB caddc co wceq cA cC caddc co cB cD addsub 3expb cA cC addcl
    sylan an4s eqtrd $.
    $( [8-Dec-2005] $) $( [20-Nov-2005] $)

  ${
    negneg.1 $e |- A e. CC $.
    $( A number is equal to the negative of its negative.  Theorem I.4 of
       [Apostol] p. 18. $)
    negnegi $p |- -u -u A = A $=
      cA cA cneg cA cneg cneg caddc co caddc co cA cc0 caddc co cA cneg cneg cA
      cA cneg cA cneg cneg caddc co cc0 cA caddc cA cneg cA negneg.1 negcli
      negidi opreq2i cA cA cneg caddc co cA cneg cneg caddc co cc0 cA cneg cneg
      caddc co cA cA cneg cA cneg cneg caddc co caddc co cA cneg cneg cA cA
      cneg caddc co cc0 cA cneg cneg caddc cA negneg.1 negidi opreq1i cA cA
      cneg cA cneg cneg negneg.1 cA negneg.1 negcli cA cneg cA negneg.1 negcli
      negcli addassi cA cneg cneg cA cneg cA negneg.1 negcli negcli addid2i
      3eqtr3i cA negneg.1 addid1i 3eqtr3i $.
      $( [8-Feb-1995] $)

    $( Subtraction of a number from itself. $)
    subidi $p |- ( A - A ) = 0 $=
      cA cA cneg caddc co cA cA cmin co cc0 cA cA negneg.1 negneg.1 negsubi cA
      negneg.1 negidi eqtr3i $.
      $( [26-Nov-1994] $)

    $( Identity law for subtraction. $)
    subid1i $p |- ( A - 0 ) = A $=
      cA cc0 cA negneg.1 0cn negneg.1 cA negneg.1 addid2i subaddrii $.
      $( [29-May-1999] $)

  $}

  $( A number is equal to the negative of its negative.  Theorem I.4 of
     [Apostol] p. 18. $)
  negneg $p |- ( A e. CC -> -u -u A = A ) $=
    cA cc wcel cA cneg cneg cA wceq cA cc wcel cA cc0 cif cneg cneg cA cc wcel
    cA cc0 cif wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA cneg cneg cA cc
    wcel cA cc0 cif cneg cneg cA cA cc wcel cA cc0 cif cA cA cc wcel cA cc0 cif
    wceq cA cneg cA cc wcel cA cc0 cif cneg cA cA cc wcel cA cc0 cif negeq
    negeqd cA cA cc wcel cA cc0 cif wceq id eqeq12d cA cc wcel cA cc0 cif cA
    cc0 cc 0cn elimel negnegi dedth $.
    $( [12-Jan-2002] $)

  $( Relationship between subtraction and negative. $)
  subneg $p |- ( ( A e. CC /\ B e. CC ) -> ( A - -u B ) = ( A + B ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg cneg caddc co cA cB cneg cmin co cA cB
    caddc co cA cc wcel cB cneg cc wcel cA cB cneg cneg caddc co cA cB cneg
    cmin co wceq cB cc wcel cA cB cneg negsub cB negcl sylan2 cB cc wcel cA cB
    cneg cneg caddc co cA cB caddc co wceq cA cc wcel cB cc wcel cB cneg cneg
    cB cA caddc cB negneg opreq2d adantl eqtr3d $.
    $( [4-Jun-2004] $) $( [10-May-2004] $)

  $( Subtraction of a number from itself. $)
  subid $p |- ( A e. CC -> ( A - A ) = 0 ) $=
    cA cc wcel cA cA cmin co cc0 wceq cA cc wcel cA cc0 cif cA cc wcel cA cc0
    cif cmin co cc0 wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA cA cmin co cA
    cc wcel cA cc0 cif cA cc wcel cA cc0 cif cmin co cc0 cA cA cc wcel cA cc0
    cif wceq cA cA cmin co cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif cmin co
    wceq cA cA cc wcel cA cc0 cif cA cA cc wcel cA cc0 cif cmin opreq12 anidms
    eqeq1d cA cc wcel cA cc0 cif cA cc0 cc 0cn elimel subidi dedth $.
    $( [8-Oct-1999] $)

  $( Identity law for subtraction. $)
  subid1 $p |- ( A e. CC -> ( A - 0 ) = A ) $=
    cA cc wcel cA cc0 cmin co cA wceq cA cc wcel cA cc0 cif cc0 cmin co cA cc
    wcel cA cc0 cif wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA cc0 cmin co cA
    cc wcel cA cc0 cif cc0 cmin co cA cA cc wcel cA cc0 cif cA cA cc wcel cA
    cc0 cif cc0 cmin opreq1 cA cA cc wcel cA cc0 cif wceq id eqeq12d cA cc wcel
    cA cc0 cif cA cc0 cc 0cn elimel subid1i dedth $.
    $( [5-Jun-2004] $) $( [9-May-2004] $)

  $( Cancellation law for subtraction. $)
  pncan $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) - B ) = A ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co cB cmin co cA cB cB cmin co caddc
    co cA cA cc wcel cB cc wcel cA cB caddc co cB cmin co cA cB cB cmin co
    caddc co wceq cA cB cB addsubass 3anidm23 cB cc wcel cA cc wcel cA cB cB
    cmin co caddc co cA cc0 caddc co cA cB cc wcel cB cB cmin co cc0 cA caddc
    cB subid opreq2d cA addid1 sylan9eqr eqtrd $.
    $( [23-May-2004] $) $( [10-May-2004] $)

  $( Cancellation law for subtraction. $)
  pncan2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) - A ) = B ) $=
    cB cc wcel cA cc wcel cA cB caddc co cA cmin co cB wceq cB cc wcel cA cc
    wcel wa cB cA caddc co cA cmin co cA cB caddc co cA cmin co cB cB cc wcel
    cA cc wcel wa cB cA caddc co cA cB caddc co cA cmin cB cA addcom opreq1d cB
    cA pncan eqtr3d ancoms $.
    $( [20-Apr-2005] $) $( [17-Apr-2005] $)

  $( Cancellation law for subtraction. $)
  npcan $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A - B ) + B ) = A ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co cB cmin co cA cB cmin co cB caddc
    co cA cA cc wcel cB cc wcel cA cB caddc co cB cmin co cA cB cmin co cB
    caddc co wceq cA cB cB addsub 3anidm23 cA cB pncan eqtr3d $.
    $( [23-May-2004] $) $( [10-May-2004] $)

  $( Cancellation law for subtraction. $)
  npncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) + ( B - C ) ) = ( A - C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmin co cB caddc co cC cmin co
    cA cB cmin co cB cC cmin co caddc co cA cC cmin co cA cB cmin co cc wcel cB
    cc wcel cC cc wcel cA cB cmin co cB caddc co cC cmin co cA cB cmin co cB cC
    cmin co caddc co wceq cA cc wcel cA cB cmin co cB cC addsubass cA cc wcel
    cB cc wcel cA cB cmin co cc wcel cC cc wcel cA cB subcl 3adant3 syld3an1 cA
    cc wcel cB cc wcel cA cB cmin co cB caddc co cC cmin co cA cC cmin co wceq
    cC cc wcel cA cc wcel cB cc wcel wa cA cB cmin co cB caddc co cA cC cmin cA
    cB npcan opreq1d 3adant3 eqtr3d $.
    $( [19-Feb-2005] $) $( [8-Feb-2005] $)

  $( Cancellation law for subtraction. $)
  nppcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( ( A - B ) + C ) + B ) = ( A + C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmin co cC caddc co cB caddc co
    cA cB cmin co cB caddc co cC caddc co cA cC caddc co cA cB cmin co cc wcel
    cC cc wcel cB cc wcel cA cB cmin co cC caddc co cB caddc co cA cB cmin co
    cB caddc co cC caddc co wceq cA cc wcel cB cc wcel cC cc wcel w3a cA cB
    cmin co cC cB add23 cA cc wcel cB cc wcel cA cB cmin co cc wcel cC cc wcel
    cA cB subcl 3adant3 cA cc wcel cB cc wcel cC cc wcel 3simp3 cA cc wcel cB
    cc wcel cC cc wcel 3simp2 syl3anc cA cc wcel cB cc wcel cA cB cmin co cB
    caddc co cC caddc co cA cC caddc co wceq cC cc wcel cA cc wcel cB cc wcel
    wa cA cB cmin co cB caddc co cA cC caddc cA cB npcan opreq1d 3adant3 eqtrd
    $.
    $( [8-Sep-2005] $) $( [1-Sep-2005] $)

  $( Cancellation law for subtraction. $)
  subcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - C ) = ( B - C ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cC cneg caddc co cB cC cneg caddc
    co wceq cA cC cmin co cB cC cmin co wceq cA cB wceq cA cc wcel cB cc wcel
    cC cc wcel w3a cA cC cneg caddc co cA cC cmin co cB cC cneg caddc co cB cC
    cmin co cA cc wcel cC cc wcel cA cC cneg caddc co cA cC cmin co wceq cB cc
    wcel cA cC negsub 3adant2 cB cc wcel cC cc wcel cB cC cneg caddc co cB cC
    cmin co wceq cA cc wcel cB cC negsub 3adant1 eqeq12d cA cc wcel cB cc wcel
    cC cneg cc wcel cA cC cneg caddc co cB cC cneg caddc co wceq cA cB wceq wb
    cC cc wcel cA cB cC cneg addcan2 cC negcl syl3an3 bitr3d $.
    $( [2-Mar-2005] $) $( [8-Feb-2005] $)

  $( If the difference between two numbers is zero, they are equal. $)
  subeq0 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A - B ) = 0 <-> A = B ) ) $=
    cA cc wcel cB cc wcel wa cA cB cmin co cB cB cmin co wceq cA cB cmin co cc0
    wceq cA cB wceq cA cc wcel cB cc wcel wa cB cB cmin co cc0 cA cB cmin co cB
    cc wcel cB cB cmin co cc0 wceq cA cc wcel cB subid adantl eqeq2d cA cc wcel
    cB cc wcel cA cB cmin co cB cB cmin co wceq cA cB wceq wb cA cB cB subcan2
    3anidm23 bitr3d $.
    $( [16-Nov-1999] $)

  ${
    subneg.1 $e |- A e. CC $.
    subneg.2 $e |- B e. CC $.
    $( Relationship between subtraction and negative. $)
    subnegi $p |- ( A - -u B ) = ( A + B ) $=
      cA cc wcel cB cc wcel cA cB cneg cmin co cA cB caddc co wceq subneg.1
      subneg.2 cA cB subneg mp2an $.
      $( [3-Dec-2005] $) $( [1-Dec-2005] $)

    $( If the difference between two numbers is zero, they are equal. $)
    subeq0i $p |- ( ( A - B ) = 0 <-> A = B ) $=
      cA cc wcel cB cc wcel cA cB cmin co cc0 wceq cA cB wceq wb subneg.1
      subneg.2 cA cB subeq0 mp2an $.
      $( [8-May-1999] $)

    $( Negative is one-to-one. $)
    neg11i $p |- ( -u A = -u B <-> A = B ) $=
      cA cneg cB cneg wceq cc0 cA cmin co cc0 cB cmin co wceq cA cc0 cB cmin co
      caddc co cc0 wceq cA cB wceq cA cneg cc0 cA cmin co cB cneg cc0 cB cmin
      co cA df-neg cB df-neg eqeq12i cc0 cA cc0 cB cmin co 0cn subneg.1 cc0 cB
      0cn subneg.2 subcli subaddi cA cc0 cB cmin co caddc co cc0 wceq cA cB
      cmin co cc0 wceq cA cB wceq cA cc0 cB cmin co caddc co cA cB cmin co cc0
      cA cB cneg caddc co cA cc0 cB cmin co caddc co cA cB cmin co cB cneg cc0
      cB cmin co cA caddc cB df-neg opreq2i cA cB subneg.1 subneg.2 negsubi
      eqtr3i eqeq1i cA cB subneg.1 subneg.2 subeq0i bitri 3bitri $.
      $( [1-Aug-1999] $)

    $( Negative contraposition law. $)
    negcon1i $p |- ( -u A = B <-> -u B = A ) $=
      cA cneg cneg cB cneg wceq cA cB cneg wceq cA cneg cB wceq cB cneg cA wceq
      cA cneg cneg cA cB cneg cA subneg.1 negnegi eqeq1i cA cneg cB cA subneg.1
      negcli subneg.2 neg11i cA cB cneg eqcom 3bitr3i $.
      $( [25-Aug-1999] $)

    $( Negative contraposition law. $)
    negcon2i $p |- ( A = -u B <-> B = -u A ) $=
      cB cneg cA wceq cA cneg cB wceq cA cB cneg wceq cB cA cneg wceq cB cA
      subneg.2 subneg.1 negcon1i cA cB cneg eqcom cB cA cneg eqcom 3bitr4i $.
      $( [25-Aug-1999] $)
  $}

  $( Negative is one-to-one. $)
  neg11 $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A = -u B <-> A = B ) ) $=
    cA cc wcel cB cc wcel cA cneg cB cneg wceq cA cB wceq wb cA cc wcel cA cc0
    cif cneg cB cneg wceq cA cc wcel cA cc0 cif cB wceq wb cA cc wcel cA cc0
    cif cneg cB cc wcel cB cc0 cif cneg wceq cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif wceq wb cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cneg cB
    cneg wceq cA cc wcel cA cc0 cif cneg cB cneg wceq cA cB wceq cA cc wcel cA
    cc0 cif cB wceq cA cA cc wcel cA cc0 cif wceq cA cneg cA cc wcel cA cc0 cif
    cneg cB cneg cA cA cc wcel cA cc0 cif negeq eqeq1d cA cA cc wcel cA cc0 cif
    cB eqeq1 bibi12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cneg
    cB cneg wceq cA cc wcel cA cc0 cif cneg cB cc wcel cB cc0 cif cneg wceq cA
    cc wcel cA cc0 cif cB wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif wceq
    cB cB cc wcel cB cc0 cif wceq cB cneg cB cc wcel cB cc0 cif cneg cA cc wcel
    cA cc0 cif cneg cB cB cc wcel cB cc0 cif negeq eqeq2d cB cB cc wcel cB cc0
    cif cA cc wcel cA cc0 cif eqeq2 bibi12d cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel neg11i dedth2h $.
    $( [10-Feb-2005] $) $( [8-Feb-2005] $)

  $( Negative contraposition law. $)
  negcon1 $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A = B <-> -u B = A ) ) $=
    cA cc wcel cB cc wcel wa cA cneg cB wceq cA cB cneg wceq cB cneg cA wceq cA
    cc wcel cB cc wcel wa cA cneg cneg cB cneg wceq cA cneg cB wceq cA cB cneg
    wceq cA cneg cc wcel cB cc wcel cA cneg cneg cB cneg wceq cA cneg cB wceq
    wb cA cc wcel cA cneg cB neg11 cA negcl sylan cA cc wcel cB cc wcel wa cA
    cneg cneg cA cB cneg cA cc wcel cA cneg cneg cA wceq cB cc wcel cA negneg
    adantr eqeq1d bitr3d cA cB cneg eqcom syl6bb $.
    $( [5-Jun-2004] $) $( [9-May-2004] $)

  $( Negative contraposition law. $)
  negcon2 $p |- ( ( A e. CC /\ B e. CC ) -> ( A = -u B <-> B = -u A ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg wceq cA cneg cB wceq cB cA cneg wceq cA
    cc wcel cB cc wcel wa cA cneg cB wceq cB cneg cA wceq cA cB cneg wceq cA cB
    negcon1 cA cB cneg eqcom syl6rbbr cA cneg cB eqcom syl6bb $.
    $( [17-Nov-2004] $) $( [14-Nov-2004] $)

  $( Cancellation law for subtraction. $)
  subcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) = ( A - C ) <-> B = C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cneg caddc co cA cC cneg caddc
    co wceq cB cneg cC cneg wceq cA cB cmin co cA cC cmin co wceq cB cC wceq cA
    cc wcel cB cneg cc wcel cC cc wcel cA cB cneg caddc co cA cC cneg caddc co
    wceq cB cneg cC cneg wceq wb cB cc wcel cA cc wcel cB cneg cc wcel cC cneg
    cc wcel cA cB cneg caddc co cA cC cneg caddc co wceq cB cneg cC cneg wceq
    wb cC cc wcel cA cB cneg cC cneg addcan cC negcl syl3an3 cB negcl syl3an2
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cneg caddc co cA cB cmin co cA
    cC cneg caddc co cA cC cmin co cA cc wcel cB cc wcel cA cB cneg caddc co cA
    cB cmin co wceq cC cc wcel cA cB negsub 3adant3 cA cc wcel cC cc wcel cA cC
    cneg caddc co cA cC cmin co wceq cB cc wcel cA cC negsub 3adant2 eqeq12d cB
    cc wcel cC cc wcel cB cneg cC cneg wceq cB cC wceq wb cA cc wcel cB cC
    neg11 3adant1 3bitr3d $.
    $( [2-Aug-2006] $) $( [8-Feb-2005] $)

  ${
    subcan.1 $e |- A e. CC $.
    subcan.2 $e |- B e. CC $.
    subcan.3 $e |- C e. CC $.
    $( Cancellation law for subtraction. $)
    subcani $p |- ( ( A - B ) = ( A - C ) <-> B = C ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB cmin co cA cC cmin co wceq cB cC
      wceq wb subcan.1 subcan.2 subcan.3 cA cB cC subcan mp3an $.
      $( [11-Apr-2005] $) $( [8-Feb-2005] $)

    $( Cancellation law for subtraction. $)
    subcan2i $p |- ( ( A - C ) = ( B - C ) <-> A = B ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cC cmin co cB cC cmin co wceq cA cB
      wceq wb subcan.1 subcan.2 subcan.3 cA cB cC subcan2 mp3an $.
      $( [11-Mar-2005] $) $( [8-Feb-2005] $)
  $}

  $( Minus 0 equals 0. $)
  neg0 $p |- -u 0 = 0 $=
    cc0 cneg cc0 cc0 cmin co cc0 cc0 df-neg cc0 0cn subidi eqtri $.
    $( [17-Jan-1997] $)

  ${
    $d x A $.
    renegcl.1 $e |- A e. RR $.
    $( Closure law for negative of reals. $)
    renegcli $p |- -u A e. RR $=
      vx cv cr wcel cA vx cv caddc co cc0 wceq wa vx wex cA cneg cr wcel cA vx
      cv caddc co cc0 wceq vx cr wrex vx cv cr wcel cA vx cv caddc co cc0 wceq
      wa vx wex cA cr wcel cA vx cv caddc co cc0 wceq vx cr wrex renegcl.1 vx
      cA axrnegex ax-mp cA vx cv caddc co cc0 wceq vx cr df-rex mpbi vx cv cr
      wcel cA vx cv caddc co cc0 wceq wa cA cneg cr wcel vx vx cv cr wcel cA vx
      cv caddc co cc0 wceq cA cneg cr wcel vx cv cr wcel cA vx cv caddc co cc0
      wceq cA cneg vx cv wceq cA cneg cr wcel vx cv cr wcel cc0 cA cmin co vx
      cv wceq cA vx cv caddc co cc0 wceq cA cneg vx cv wceq vx cv cr wcel vx cv
      cc wcel cc0 cA cmin co vx cv wceq cA vx cv caddc co cc0 wceq wb vx cv
      recn cc0 cc wcel cA cc wcel vx cv cc wcel cc0 cA cmin co vx cv wceq cA vx
      cv caddc co cc0 wceq wb 0cn cA renegcl.1 recni cc0 cA vx cv subadd
      mp3an12 syl cA cneg cc0 cA cmin co vx cv cA df-neg eqeq1i syl5bb vx cv cr
      cA cneg eleq1a sylbird imp 19.23aiv ax-mp $.
      $( [17-Jan-1997] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Multiplication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Identity law for multiplication.  Note:  see ~ ax1id for commuted
     version. $)
  mulid2 $p |- ( A e. CC -> ( 1 x. A ) = A ) $=
    cA cc wcel c1 cA cmul co cA c1 cmul co cA c1 cc wcel cA cc wcel c1 cA cmul
    co cA c1 cmul co wceq ax1cn c1 cA mulcom mpan cA ax1id eqtrd $.
    $( [8-Oct-1999] $)

  $( Commutative/associative law for multiplication. $)
  mul12 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A x. ( B x. C ) ) = ( B x. ( A x. C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmul co cC cmul co cB cA cmul co
    cC cmul co cA cB cC cmul co cmul co cB cA cC cmul co cmul co cA cc wcel cB
    cc wcel cA cB cmul co cC cmul co cB cA cmul co cC cmul co wceq cC cc wcel
    cA cc wcel cB cc wcel wa cA cB cmul co cB cA cmul co cC cmul cA cB mulcom
    opreq1d 3adant3 cA cB cC mulass cB cc wcel cA cc wcel cC cc wcel cB cA cmul
    co cC cmul co cB cA cC cmul co cmul co wceq cB cA cC mulass 3com12 3eqtr3d
    $.
    $( [29-May-2005] $) $( [30-Apr-2005] $)

  $( Commutative/associative law. $)
  mul23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A x. B ) x. C ) = ( ( A x. C ) x. B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cmul co cmul co cA cC cB cmul
    co cmul co cA cB cmul co cC cmul co cA cC cmul co cB cmul co cB cc wcel cC
    cc wcel cA cB cC cmul co cmul co cA cC cB cmul co cmul co wceq cA cc wcel
    cB cc wcel cC cc wcel wa cB cC cmul co cC cB cmul co cA cmul cB cC mulcom
    opreq2d 3adant1 cA cB cC mulass cA cc wcel cC cc wcel cB cc wcel cA cC cmul
    co cB cmul co cA cC cB cmul co cmul co wceq cA cC cB mulass 3com23 3eqtr4d
    $.
    $( [8-Oct-1999] $)

  $( Rearrangement of 4 factors. $)
  mul4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A  x. B )  x. ( C  x. D ) ) =
                 ( ( A  x. C )  x. ( B  x. D ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB cmul co cC cmul
    co cD cmul co cA cC cmul co cB cmul co cD cmul co cA cB cmul co cC cD cmul
    co cmul co cA cC cmul co cB cD cmul co cmul co cA cc wcel cB cc wcel wa cC
    cc wcel cA cB cmul co cC cmul co cD cmul co cA cC cmul co cB cmul co cD
    cmul co wceq cD cc wcel cA cc wcel cB cc wcel cC cc wcel cA cB cmul co cC
    cmul co cD cmul co cA cC cmul co cB cmul co cD cmul co wceq cA cc wcel cB
    cc wcel cC cc wcel w3a cA cB cmul co cC cmul co cA cC cmul co cB cmul co cD
    cmul cA cB cC mul23 opreq1d 3expa adantrr cA cB cmul co cc wcel cC cc wcel
    cD cc wcel wa cA cB cmul co cC cmul co cD cmul co cA cB cmul co cC cD cmul
    co cmul co wceq cA cc wcel cB cc wcel wa cA cB cmul co cc wcel cC cc wcel
    cD cc wcel cA cB cmul co cC cmul co cD cmul co cA cB cmul co cC cD cmul co
    cmul co wceq cA cB cmul co cC cD mulass 3expb cA cB mulcl sylan cA cc wcel
    cC cc wcel cB cc wcel cD cc wcel cA cC cmul co cB cmul co cD cmul co cA cC
    cmul co cB cD cmul co cmul co wceq cA cC cmul co cc wcel cB cc wcel cD cc
    wcel wa cA cC cmul co cB cmul co cD cmul co cA cC cmul co cB cD cmul co
    cmul co wceq cA cc wcel cC cc wcel wa cA cC cmul co cc wcel cB cc wcel cD
    cc wcel cA cC cmul co cB cmul co cD cmul co cA cC cmul co cB cD cmul co
    cmul co wceq cA cC cmul co cB cD mulass 3expb cA cC mulcl sylan an4s
    3eqtr3d $.
    $( [8-Oct-1999] $)

  $( Product of two sums. $)
  muladd $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
               ( ( A + B ) x. ( C + D ) ) =
       ( ( ( A x. C ) + ( D x. B ) ) + ( ( A x. D ) + ( C x. B ) ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB caddc co cC cD
    caddc co cmul co cA cB caddc co cC cmul co cA cB caddc co cD cmul co caddc
    co cA cC cmul co cB cC cmul co caddc co cA cD cmul co cB cD cmul co caddc
    co caddc co cA cC cmul co cD cB cmul co caddc co cA cD cmul co cC cB cmul
    co caddc co caddc co cA cB caddc co cc wcel cC cc wcel cD cc wcel cA cB
    caddc co cC cD caddc co cmul co cA cB caddc co cC cmul co cA cB caddc co cD
    cmul co caddc co wceq cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa
    cA cB caddc co cC cD adddi cA cc wcel cB cc wcel wa cA cB caddc co cc wcel
    cC cc wcel cD cc wcel wa cA cB addcl adantr cA cc wcel cB cc wcel wa cC cc
    wcel cD cc wcel simprl cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel
    simprr syl3anc cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB
    caddc co cC cmul co cA cC cmul co cB cC cmul co caddc co cA cB caddc co cD
    cmul co cA cD cmul co cB cD cmul co caddc co caddc cA cc wcel cB cc wcel wa
    cC cc wcel cA cB caddc co cC cmul co cA cC cmul co cB cC cmul co caddc co
    wceq cD cc wcel cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cC cmul co
    cA cC cmul co cB cC cmul co caddc co wceq cA cB cC adddir 3expa adantrr cA
    cc wcel cB cc wcel wa cD cc wcel cA cB caddc co cD cmul co cA cD cmul co cB
    cD cmul co caddc co wceq cC cc wcel cA cc wcel cB cc wcel cD cc wcel cA cB
    caddc co cD cmul co cA cD cmul co cB cD cmul co caddc co wceq cA cB cD
    adddir 3expa adantrl opreq12d cA cc wcel cB cc wcel wa cC cc wcel cD cc
    wcel wa wa cA cC cmul co cB cC cmul co caddc co cA cD cmul co cB cD cmul co
    caddc co caddc co cA cC cmul co cA cD cmul co cB cD cmul co caddc co caddc
    co cB cC cmul co caddc co cA cC cmul co cD cB cmul co caddc co cA cD cmul
    co caddc co cC cB cmul co caddc co cA cC cmul co cD cB cmul co caddc co cA
    cD cmul co cC cB cmul co caddc co caddc co cA cC cmul co cc wcel cB cC cmul
    co cc wcel cA cD cmul co cB cD cmul co caddc co cc wcel cA cC cmul co cB cC
    cmul co caddc co cA cD cmul co cB cD cmul co caddc co caddc co cA cC cmul
    co cA cD cmul co cB cD cmul co caddc co caddc co cB cC cmul co caddc co
    wceq cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cC cmul co cB
    cC cmul co cA cD cmul co cB cD cmul co caddc co add23 cA cc wcel cC cc wcel
    cA cC cmul co cc wcel cB cc wcel cD cc wcel cA cC mulcl ad2ant2r cB cc wcel
    cC cc wcel cB cC cmul co cc wcel cA cc wcel cD cc wcel cB cC mulcl
    ad2ant2lr cA cc wcel cB cc wcel wa cD cc wcel cA cD cmul co cB cD cmul co
    caddc co cc wcel cC cc wcel cA cc wcel cB cc wcel cD cc wcel cA cD cmul co
    cB cD cmul co caddc co cc wcel cA cD cmul co cc wcel cB cD cmul co cc wcel
    cA cD cmul co cB cD cmul co caddc co cc wcel cA cc wcel cD cc wcel wa cB cc
    wcel cD cc wcel wa cA cD cmul co cB cD cmul co addcl cA cD mulcl cB cD
    mulcl syl2an anandirs adantrl syl3anc cA cc wcel cB cc wcel wa cC cc wcel
    cD cc wcel wa wa cA cC cmul co cA cD cmul co cB cD cmul co caddc co caddc
    co cA cC cmul co cD cB cmul co caddc co cA cD cmul co caddc co cB cC cmul
    co cC cB cmul co caddc cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa
    cA cC cmul co cA cD cmul co caddc co cB cD cmul co caddc co cA cC cmul co
    cA cD cmul co caddc co cD cB cmul co caddc co cA cC cmul co cA cD cmul co
    cB cD cmul co caddc co caddc co cA cC cmul co cD cB cmul co caddc co cA cD
    cmul co caddc co cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cB cD
    cmul co cD cB cmul co cA cC cmul co cA cD cmul co caddc co caddc cB cc wcel
    cD cc wcel cB cD cmul co cD cB cmul co wceq cA cc wcel cC cc wcel cB cD
    mulcom ad2ant2l opreq2d cA cC cmul co cc wcel cA cD cmul co cc wcel cB cD
    cmul co cc wcel cA cC cmul co cA cD cmul co caddc co cB cD cmul co caddc co
    cA cC cmul co cA cD cmul co cB cD cmul co caddc co caddc co wceq cA cc wcel
    cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cC cmul co cA cD cmul co cB cD
    cmul co addass cA cc wcel cC cc wcel cA cC cmul co cc wcel cB cc wcel cD cc
    wcel cA cC mulcl ad2ant2r cA cc wcel cD cc wcel cA cD cmul co cc wcel cB cc
    wcel cC cc wcel cA cD mulcl ad2ant2rl cB cc wcel cD cc wcel cB cD cmul co
    cc wcel cA cc wcel cC cc wcel cB cD mulcl ad2ant2l syl3anc cA cC cmul co cc
    wcel cA cD cmul co cc wcel cD cB cmul co cc wcel cA cC cmul co cA cD cmul
    co caddc co cD cB cmul co caddc co cA cC cmul co cD cB cmul co caddc co cA
    cD cmul co caddc co wceq cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa
    wa cA cC cmul co cA cD cmul co cD cB cmul co add23 cA cc wcel cC cc wcel cA
    cC cmul co cc wcel cB cc wcel cD cc wcel cA cC mulcl ad2ant2r cA cc wcel cD
    cc wcel cA cD cmul co cc wcel cB cc wcel cC cc wcel cA cD mulcl ad2ant2rl
    cB cc wcel cD cc wcel cD cB cmul co cc wcel cA cc wcel cC cc wcel cD cc
    wcel cB cc wcel cD cB cmul co cc wcel cD cB mulcl ancoms ad2ant2l syl3anc
    3eqtr3d cB cc wcel cC cc wcel cB cC cmul co cC cB cmul co wceq cA cc wcel
    cD cc wcel cB cC mulcom ad2ant2lr opreq12d cA cC cmul co cD cB cmul co
    caddc co cc wcel cA cD cmul co cc wcel cC cB cmul co cc wcel cA cC cmul co
    cD cB cmul co caddc co cA cD cmul co caddc co cC cB cmul co caddc co cA cC
    cmul co cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc co caddc
    co wceq cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cC cmul co
    cD cB cmul co caddc co cA cD cmul co cC cB cmul co addass cA cc wcel cC cc
    wcel cB cc wcel cD cc wcel cA cC cmul co cD cB cmul co caddc co cc wcel cA
    cC cmul co cc wcel cD cB cmul co cc wcel cA cC cmul co cD cB cmul co caddc
    co cc wcel cA cc wcel cC cc wcel wa cB cc wcel cD cc wcel wa cA cC cmul co
    cD cB cmul co addcl cA cC mulcl cD cc wcel cB cc wcel cD cB cmul co cc wcel
    cD cB mulcl ancoms syl2an an4s cA cc wcel cD cc wcel cA cD cmul co cc wcel
    cB cc wcel cC cc wcel cA cD mulcl ad2ant2rl cB cc wcel cC cc wcel cC cB
    cmul co cc wcel cA cc wcel cD cc wcel cC cc wcel cB cc wcel cC cB cmul co
    cc wcel cC cB mulcl ancoms ad2ant2lr syl3anc 3eqtrd 3eqtrd $.
    $( [15-Jan-2006] $) $( [14-Jan-2006] $)

  $( A simple product of sums expansion. $)
  muladd11 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( 1 + A ) x. ( 1 + B ) ) =
                 ( ( 1 + A ) + ( B + ( A x. B ) ) ) ) $=
    cA cc wcel cB cc wcel wa c1 cA caddc co c1 cB caddc co cmul co c1 cA caddc
    co c1 cmul co c1 cA caddc co cB cmul co caddc co c1 cA caddc co cB cA cB
    cmul co caddc co caddc co c1 cA caddc co cc wcel cB cc wcel c1 cA caddc co
    c1 cB caddc co cmul co c1 cA caddc co c1 cmul co c1 cA caddc co cB cmul co
    caddc co wceq cA cc wcel c1 cA caddc co cc wcel c1 cc wcel cB cc wcel c1 cA
    caddc co c1 cB caddc co cmul co c1 cA caddc co c1 cmul co c1 cA caddc co cB
    cmul co caddc co wceq ax1cn c1 cA caddc co c1 cB adddi mp3an2 c1 cc wcel cA
    cc wcel c1 cA caddc co cc wcel ax1cn c1 cA addcl mpan sylan cA cc wcel cB
    cc wcel wa c1 cA caddc co c1 cmul co c1 cA caddc co c1 cA caddc co cB cmul
    co cB cA cB cmul co caddc co caddc cA cc wcel c1 cA caddc co c1 cmul co c1
    cA caddc co wceq cB cc wcel cA cc wcel c1 cA caddc co cc wcel c1 cA caddc
    co c1 cmul co c1 cA caddc co wceq c1 cc wcel cA cc wcel c1 cA caddc co cc
    wcel ax1cn c1 cA addcl mpan c1 cA caddc co ax1id syl adantr cA cc wcel cB
    cc wcel wa c1 cA caddc co cB cmul co c1 cB cmul co cA cB cmul co caddc co
    cB cA cB cmul co caddc co c1 cc wcel cA cc wcel cB cc wcel c1 cA caddc co
    cB cmul co c1 cB cmul co cA cB cmul co caddc co wceq ax1cn c1 cA cB adddir
    mp3an1 cA cc wcel cB cc wcel wa c1 cB cmul co cB cA cB cmul co caddc cB cc
    wcel c1 cB cmul co cB wceq cA cc wcel cB mulid2 adantl opreq1d eqtrd
    opreq12d eqtrd $.
    $( [9-Mar-2005] $) $( [21-Feb-2005] $)

  ${
    mul.1 $e |- A e. CC $.
    mul.2 $e |- B e. CC $.
    mul.3 $e |- C e. CC $.
    $( Commutative/associative law that swaps the first two factors in a triple
       product. $)
    mul12i $p |- ( A x. ( B x. C ) ) = ( B x. ( A x. C ) ) $=
      cA cB cmul co cC cmul co cB cA cmul co cC cmul co cA cB cC cmul co cmul
      co cB cA cC cmul co cmul co cA cB cmul co cB cA cmul co cC cmul cA cB
      mul.1 mul.2 mulcomi opreq1i cA cB cC mul.1 mul.2 mul.3 mulassi cB cA cC
      mul.2 mul.1 mul.3 mulassi 3eqtr3i $.
      $( [11-May-1999] $)

    $( Commutative/associative law that swaps the last two factors in a triple
       product. $)
    mul23i $p |- ( ( A x. B ) x. C ) = ( ( A x. C ) x. B ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB cmul co cC cmul co cA cC cmul co
      cB cmul co wceq mul.1 mul.2 mul.3 cA cB cC mul23 mp3an $.
      $( [11-May-1999] $)
  $}

  ${
    mul4.1 $e |- A e. CC $.
    mul4.2 $e |- B e. CC $.
    mul4.3 $e |- C e. CC $.
    mul4.4 $e |- D e. CC $.
    $( Rearrangement of 4 factors. $)
    mul4i $p |- ( ( A  x. B )  x. ( C  x. D ) ) =
               ( ( A  x. C )  x. ( B  x. D ) ) $=
      cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa cA cB cmul co cC cD
      cmul co cmul co cA cC cmul co cB cD cmul co cmul co wceq cA cc wcel cB cc
      wcel mul4.1 mul4.2 pm3.2i cC cc wcel cD cc wcel mul4.3 mul4.4 pm3.2i cA
      cB cC cD mul4 mp2an $.
      $( [16-Feb-1995] $)

    $( Product of two sums. $)
    muladdi $p |- ( ( A + B ) x. ( C + D ) ) =
        ( ( ( A x. C ) + ( D x. B ) ) + ( ( A x. D ) + ( C x. B ) ) ) $=
      cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa cA cB caddc co cC cD
      caddc co cmul co cA cC cmul co cD cB cmul co caddc co cA cD cmul co cC cB
      cmul co caddc co caddc co wceq cA cc wcel cB cc wcel mul4.1 mul4.2 pm3.2i
      cC cc wcel cD cc wcel mul4.3 mul4.4 pm3.2i cA cB cC cD muladd mp2an $.
      $( [17-May-1999] $)
  $}

  $( Distribution of multiplication over subtraction.  Theorem I.5 of
     [Apostol] p. 18. $)
  subdi $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A x. ( B - C ) ) = ( ( A x. B ) - ( A x. C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmul co cA cC cmul co cmin co cA
    cB cC cmin co cmul co cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmul co cA
    cC cmul co cmin co cA cB cC cmin co cmul co wceq cA cC cmul co cA cB cC
    cmin co cmul co caddc co cA cB cmul co wceq cA cc wcel cB cc wcel cC cc
    wcel w3a cA cC cB cC cmin co caddc co cmul co cA cC cmul co cA cB cC cmin
    co cmul co caddc co cA cB cmul co cA cc wcel cC cc wcel cB cC cmin co cc
    wcel cA cC cB cC cmin co caddc co cmul co cA cC cmul co cA cB cC cmin co
    cmul co caddc co wceq cA cc wcel cB cc wcel cC cc wcel w3a cA cC cB cC cmin
    co adddi cA cc wcel cB cc wcel cC cc wcel 3simp1 cA cc wcel cB cc wcel cC
    cc wcel 3simp3 cB cc wcel cC cc wcel cB cC cmin co cc wcel cA cc wcel cB cC
    subcl 3adant1 syl3anc cA cc wcel cB cc wcel cC cc wcel w3a cC cB cC cmin co
    caddc co cB cA cmul cB cc wcel cC cc wcel cC cB cC cmin co caddc co cB wceq
    cA cc wcel cC cc wcel cB cc wcel cC cB cC cmin co caddc co cB wceq cC cB
    pncan3 ancoms 3adant1 opreq2d eqtr3d cA cB cmul co cc wcel cA cC cmul co cc
    wcel cA cB cC cmin co cmul co cc wcel cA cB cmul co cA cC cmul co cmin co
    cA cB cC cmin co cmul co wceq cA cC cmul co cA cB cC cmin co cmul co caddc
    co cA cB cmul co wceq wb cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmul co
    cA cC cmul co cA cB cC cmin co cmul co subadd cA cc wcel cB cc wcel cA cB
    cmul co cc wcel cC cc wcel cA cB mulcl 3adant3 cA cc wcel cC cc wcel cA cC
    cmul co cc wcel cB cc wcel cA cC mulcl 3adant2 cA cc wcel cB cc wcel cC cc
    wcel cA cB cC cmin co cmul co cc wcel cA cc wcel cB cC cmin co cc wcel cA
    cB cC cmin co cmul co cc wcel cB cc wcel cC cc wcel wa cA cB cC cmin co
    mulcl cB cC subcl sylan2 3impb syl3anc mpbird eqcomd $.
    $( [22-Nov-2004] $) $( [18-Nov-2004] $)

  $( Distribution of multiplication over subtraction.  Theorem I.5 of
     [Apostol] p. 18. $)
  subdir $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A - B ) x. C ) = ( ( A x. C ) - ( B x. C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cC cA cB cmin co cmul co cC cA cmul co
    cC cB cmul co cmin co cA cB cmin co cC cmul co cA cC cmul co cB cC cmul co
    cmin co cC cc wcel cA cc wcel cB cc wcel cC cA cB cmin co cmul co cC cA
    cmul co cC cB cmul co cmin co wceq cC cA cB subdi 3coml cA cc wcel cB cc
    wcel cC cc wcel cA cB cmin co cC cmul co cC cA cB cmin co cmul co wceq cA
    cB cmin co cc wcel cC cc wcel cA cB cmin co cC cmul co cC cA cB cmin co
    cmul co wceq cA cc wcel cB cc wcel wa cA cB cmin co cC mulcom cA cB subcl
    sylan 3impa cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmul co cC cA cmul
    co cB cC cmul co cC cB cmul co cmin cA cc wcel cC cc wcel cA cC cmul co cC
    cA cmul co wceq cB cc wcel cA cC mulcom 3adant2 cB cc wcel cC cc wcel cB cC
    cmul co cC cB cmul co wceq cA cc wcel cB cC mulcom 3adant1 opreq12d 3eqtr4d
    $.
    $( [31-Dec-2005] $) $( [30-Dec-2005] $)

  ${
    subdi.1 $e |- A e. CC $.
    subdi.2 $e |- B e. CC $.
    subdi.3 $e |- C e. CC $.
    $( Distribution of multiplication over subtraction.  Theorem I.5 of
       [Apostol] p. 18. $)
    subdii $p |- ( A x. ( B - C ) ) = ( ( A x. B ) - ( A x. C ) ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB cC cmin co cmul co cA cB cmul co
      cA cC cmul co cmin co wceq subdi.1 subdi.2 subdi.3 cA cB cC subdi mp3an
      $.
      $( [26-Nov-1994] $)

    $( Distribution of multiplication over subtraction.  Theorem I.5 of
       [Apostol] p. 18. $)
    subdiri $p |- ( ( A - B ) x. C ) = ( ( A x. C ) - ( B x. C ) ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB cmin co cC cmul co cA cC cmul co
      cB cC cmul co cmin co wceq subdi.1 subdi.2 subdi.3 cA cB cC subdir mp3an
      $.
      $( [8-May-1999] $)
  $}

  ${
    mulzer.1 $e |- A e. CC $.

    $( Multiplication by 0.  Theorem I.6 of [Apostol] p. 18. $)
    mul01i $p |- ( A x. 0 ) = 0 $=
      cA cc0 cc0 cmin co cmul co cA cc0 cmul co cA cc0 cmul co cmin co cA cc0
      cmul co cc0 cA cc0 cc0 mulzer.1 0cn 0cn subdii cc0 cc0 cmin co cc0 cA
      cmul cc0 0cn subidi opreq2i cA cc0 cmul co cA cc0 mulzer.1 0cn mulcli
      subidi 3eqtr3i $.
      $( [23-Nov-1994] $)

    $( Multiplication by 0.  Theorem I.6 of [Apostol] p. 18. $)
    mul02i $p |- ( 0 x. A ) = 0 $=
      cc0 cA cmul co cA cc0 cmul co cc0 cc0 cA 0cn mulzer.1 mulcomi cA mulzer.1
      mul01i eqtri $.
      $( [23-Nov-1994] $)

    $( Two times a number. $)
    1p1timesi $p |- ( ( 1 + 1 ) x. A ) = ( A + A ) $=
      c1 c1 caddc co cA cmul co c1 cA cmul co c1 cA cmul co caddc co cA cA
      caddc co c1 c1 cA ax1cn ax1cn mulzer.1 adddiri c1 cA cmul co cA c1 cA
      cmul co cA caddc cA mulzer.1 mulid2i cA mulzer.1 mulid2i opreq12i eqtri
      $.
      $( [18-May-1999] $)
  $}

  $( The imaginary unit ` _i ` is not zero. $)
  ine0 $p |- _i =/= 0 $=
    ci cc0 wne ci cc0 wceq wn ci cc0 wceq c1 cc0 wceq c1 cc0 wne c1 cc0 wceq wn
    ax1ne0 c1 cc0 df-ne mpbi ci cc0 wceq cc0 c1 caddc co ci ci cmul co c1 caddc
    co c1 cc0 ci cc0 wceq cc0 ci ci cmul co c1 caddc ci cc0 wceq ci ci cmul co
    ci cc0 cmul co cc0 ci cc0 ci cmul opreq2 ci axicn mul01i syl6req opreq1d c1
    ax1cn addid2i axi2m1 3eqtr3g mto ci cc0 df-ne mpbir $.
    $( [29-Apr-2005] $) $( [6-May-1999] $)

  ${
    $d x y z $.
    $( 1 is a real number.  This used to be one of our postulates for complex
       numbers, but Eric Schmidt discovered that it could be derived from a
       weaker postulate, ~ ax1cn , by exploiting properties of the imaginary
       unit ` _i ` .  (Contributed by Eric Schmidt, 11-Apr-2007.) $)
    1re $p |- 1 e. RR $=
      vz cv cc0 wne vz cr wrex c1 cr wcel ci vx cv ci vy cv cmul co caddc co
      wceq vy cr wrex vx cr wrex vz cv cc0 wne vz cr wrex ci cc wcel ci vx cv
      ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex axicn vx vy ci
      axcnre ax-mp ci vx cv ci vy cv cmul co caddc co wceq vz cv cc0 wne vz cr
      wrex vx vy cr cr vx cv cr wcel vy cv cr wcel wa vx cv cc0 wne vy cv cc0
      wne wo vz cv cc0 wne vz cr wrex ci vx cv ci vy cv cmul co caddc co wceq
      vx cv cr wcel vy cv cr wcel wa vx cv cc0 wne vy cv cc0 wne wo vz cv cc0
      wne vz cr wrex vx cv cr wcel vy cv cr wcel wa vx cv cc0 wne vz cv cc0 wne
      vz cr wrex vy cv cc0 wne vx cv cr wcel vx cv cc0 wne vz cv cc0 wne vz cr
      wrex vy cv cr wcel vz cv cc0 wne vx cv cc0 wne vz vx cv cr vz cv vx cv
      cc0 neeq1 rcla4ev adantlr vy cv cr wcel vy cv cc0 wne vz cv cc0 wne vz cr
      wrex vx cv cr wcel vz cv cc0 wne vy cv cc0 wne vz vy cv cr vz cv vy cv
      cc0 neeq1 rcla4ev adantll jaodan ex ci vx cv ci vy cv cmul co caddc co
      wceq vx cv ci vy cv cmul co caddc co cc0 wne vx cv cc0 wne vy cv cc0 wne
      wo ci vx cv ci vy cv cmul co caddc co wceq ci cc0 wne vx cv ci vy cv cmul
      co caddc co cc0 wne ine0 ci vx cv ci vy cv cmul co caddc co cc0 neeq1
      mpbii vx cv cc0 wne vy cv cc0 wne wo vx cv ci vy cv cmul co caddc co cc0
      vx cv cc0 wne vy cv cc0 wne wo wn vx cv cc0 wceq vy cv cc0 wceq wa vx cv
      ci vy cv cmul co caddc co cc0 wceq vx cv cc0 wne vy cv cc0 wne wo wn vx
      cv cc0 wne wn vy cv cc0 wne wn wa vx cv cc0 wceq vy cv cc0 wceq wa vx cv
      cc0 wne vy cv cc0 wne ioran vx cv cc0 wne wn vx cv cc0 wceq vy cv cc0 wne
      wn vy cv cc0 wceq vx cv cc0 nne vy cv cc0 nne anbi12i bitri vx cv cc0
      wceq vy cv cc0 wceq wa vx cv ci vy cv cmul co caddc co cc0 cc0 caddc co
      cc0 vx cv cc0 wceq ci vy cv cmul co cc0 wceq vx cv ci vy cv cmul co caddc
      co cc0 cc0 caddc co wceq vy cv cc0 wceq vx cv cc0 ci vy cv cmul co cc0
      caddc opreq12 vy cv cc0 wceq ci vy cv cmul co ci cc0 cmul co cc0 vy cv
      cc0 ci cmul opreq2 ci axicn mul01i syl6eq sylan2 cc0 0cn addid1i syl6eq
      sylbi necon1ai syl syl5 r19.23aivv ax-mp vz cv cc0 wne c1 cr wcel vz cr
      vz cv cr wcel vz cv cc0 wne wa vz cv vx cv cmul co c1 wceq vx cr wrex c1
      cr wcel vx vz cv axrrecex vz cv cr wcel vz cv vx cv cmul co c1 wceq vx cr
      wrex c1 cr wcel wi vz cv cc0 wne vz cv cr wcel vz cv vx cv cmul co c1
      wceq c1 cr wcel vx cr vz cv vx cv cmul co c1 wceq vz cv vx cv cmul co cr
      wcel c1 cr wcel vz cv cr wcel vx cv cr wcel wa vz cv vx cv cmul co c1 cr
      eleq1 vz cv vx cv remulcl syl5cbi r19.23adva adantr mpd r19.23aiva ax-mp
      $.
      $( [12-Apr-2007] $) $( [11-Apr-2007] $)
  $}

  $( A theorem for reals analogous the second Peano postulate ~ peano2nn . $)
  peano2re $p |- ( A e. RR -> ( A + 1 ) e. RR ) $=
    cA cr wcel c1 cr wcel cA c1 caddc co cr wcel 1re cA c1 readdcl mpan2 $.
    $( [6-Jul-2005] $) $( [5-Jul-2005] $)

  $( Closure law for negative of reals.  The weak deduction theorem ~ dedth is
     used to convert hypothesis of the inference (deduction) form of this
     theorem, ~ renegcli , to an antecedent. $)
  renegcl $p |- ( A e. RR -> -u A e. RR ) $=
    cA cr wcel cA cneg cr wcel cA cr wcel cA c1 cif cneg cr wcel cA c1 cA cA cr
    wcel cA c1 cif wceq cA cneg cA cr wcel cA c1 cif cneg cr cA cA cr wcel cA
    c1 cif negeq eleq1d cA cr wcel cA c1 cif cA c1 cr 1re elimel renegcli dedth
    $.
    $( [20-Jan-1997] $)

  $( Closure law for subtraction of reals. $)
  resubcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A - B ) e. RR ) $=
    cA cr wcel cB cr wcel wa cA cB cneg caddc co cA cB cmin co cr cA cc wcel cB
    cc wcel cA cB cneg caddc co cA cB cmin co wceq cA cr wcel cB cr wcel cA cB
    negsub cA recn cB recn syl2an cA cr wcel cB cneg cr wcel cA cB cneg caddc
    co cr wcel cB cr wcel cA cB cneg readdcl cB renegcl sylan2 eqeltrrd $.
    $( [2-Aug-2006] $) $( [20-Jan-1997] $)

  ${
    resubcl.1 $e |- A e. RR $.
    resubcl.2 $e |- B e. RR $.
    $( Closure law for subtraction of reals. $)
    resubcli $p |- ( A - B ) e. RR $=
      cA cr wcel cB cr wcel cA cB cmin co cr wcel resubcl.1 resubcl.2 cA cB
      resubcl mp2an $.
      $( [17-Jan-1997] $)
  $}

  ${
    $d x y $.
    $( 0 is a real number.  Proved without referencing ~ 1re .  (Contributed
       by Eric Schmidt, 21-May-2007.) $)
    0re $p |- 0 e. RR $=
      vx cv cr wcel vx wex cc0 cr wcel cc0 vx cv ci vy cv cmul co caddc co wceq
      vy cr wrex vx cr wrex vx cv cr wcel vx wex cc0 cc wcel cc0 vx cv ci vy cv
      cmul co caddc co wceq vy cr wrex vx cr wrex 0cn vx vy cc0 axcnre ax-mp
      cc0 vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex vx cv cr
      wcel cc0 vx cv ci vy cv cmul co caddc co wceq vy cr wrex wa vx wex vx cv
      cr wcel vx wex cc0 vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr
      df-rex vx cv cr wcel cc0 vx cv ci vy cv cmul co caddc co wceq vy cr wrex
      wa vx cv cr wcel vx vx cv cr wcel cc0 vx cv ci vy cv cmul co caddc co
      wceq vy cr wrex pm3.26 19.22i sylbi ax-mp vx cv cr wcel cc0 cr wcel vx vx
      cv cr wcel vx cv vy cv caddc co cc0 wceq vy cr wrex cc0 cr wcel vy vx cv
      axrnegex vx cv cr wcel vx cv vy cv caddc co cc0 wceq cc0 cr wcel vy cr vx
      cv cr wcel vy cv cr wcel wa vx cv vy cv caddc co cc0 wceq cc0 cr wcel vx
      cv cr wcel vy cv cr wcel wa vx cv vy cv caddc co cc0 wceq wa vx cv vy cv
      caddc co cc0 cr vx cv cr wcel vy cv cr wcel wa vx cv vy cv caddc co cc0
      wceq pm3.27 vx cv cr wcel vy cv cr wcel wa vx cv vy cv caddc co cr wcel
      vx cv vy cv caddc co cc0 wceq vx cv vy cv readdcl adantr eqeltrrd ex
      r19.23adva mpd 19.23aiv ax-mp $.
      $( [22-May-2007] $) $( [22-May-2007] $)
  $}

  $( 0 is a real number. $)
  0reALT $p |- 0 e. RR $=
    c1 c1 cmin co cc0 cr c1 ax1cn subidi c1 c1 1re 1re resubcli eqeltrri $.
    $( [20-Feb-2005] $) $( [19-Feb-2005] $)

  $( "Reverse" second Peano postulate analog for reals. $)
  peano2rem $p |- ( N e. RR -> ( N - 1 ) e. RR ) $=
    cN cr wcel c1 cr wcel cN c1 cmin co cr wcel 1re cN c1 resubcl mpan2 $.
    $( [7-Feb-2007] $) $( [6-Feb-2007] $)

  $( Multiplication by 0.  Theorem I.6 of [Apostol] p. 18. $)
  mul01 $p |- ( A e. CC -> ( A x. 0 ) = 0 ) $=
    cA cc wcel cA cc0 cmul co cc0 wceq cA cc wcel cA cc0 cif cc0 cmul co cc0
    wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA cc0 cmul co cA cc wcel cA cc0
    cif cc0 cmul co cc0 cA cA cc wcel cA cc0 cif cc0 cmul opreq1 eqeq1d cA cc
    wcel cA cc0 cif cA cc0 cc 0cn elimel mul01i dedth $.
    $( [15-May-1999] $)

  $( Multiplication by 0.  Theorem I.6 of [Apostol] p. 18. $)
  mul02 $p |- ( A e. CC -> ( 0 x. A ) = 0 ) $=
    cA cc wcel cc0 cA cmul co cA cc0 cmul co cc0 cc0 cc wcel cA cc wcel cc0 cA
    cmul co cA cc0 cmul co wceq 0cn cc0 cA mulcom mpan cA mul01 eqtrd $.
    $( [10-Aug-1999] $)

  ${
    mulneg.1 $e |- A e. CC $.
    mulneg.2 $e |- B e. CC $.

    $( Product with negative is negative of product.  Theorem I.12 of [Apostol]
       p. 18. $)
    mulneg1i $p |- ( -u A x. B ) = -u ( A x. B ) $=
      cB cc0 cmul co cB cA cmul co cmin co cc0 cA cB cmul co cmin co cA cneg cB
      cmul co cA cB cmul co cneg cB cc0 cmul co cc0 cB cA cmul co cA cB cmul co
      cmin cB mulneg.2 mul01i cB cA mulneg.2 mulneg.1 mulcomi opreq12i cA cneg
      cB cmul co cc0 cA cmin co cB cmul co cB cc0 cA cmin co cmul co cB cc0
      cmul co cB cA cmul co cmin co cA cneg cc0 cA cmin co cB cmul cA df-neg
      opreq1i cc0 cA cmin co cB cc0 cA 0cn mulneg.1 subcli mulneg.2 mulcomi cB
      cc0 cA mulneg.2 0cn mulneg.1 subdii 3eqtri cA cB cmul co df-neg 3eqtr4i
      $.
      $( [10-Feb-1995] $)

    $( Product with negative is negative of product. $)
    mulneg2i $p |- ( A x. -u B ) = -u ( A x. B ) $=
      cA cB cneg cmul co cB cneg cA cmul co cB cA cmul co cneg cA cB cmul co
      cneg cA cB cneg mulneg.1 cB mulneg.2 negcli mulcomi cB cA mulneg.2
      mulneg.1 mulneg1i cB cA cmul co cA cB cmul co cB cA mulneg.2 mulneg.1
      mulcomi negeqi 3eqtri $.
      $( [31-Jul-1999] $)

    $( Product of two negatives.  Theorem I.12 of [Apostol] p. 18. $)
    mul2negi $p |- ( -u A x. -u B ) = ( A x. B ) $=
      cA cneg cB cneg cmul co cB cA cmul co cA cB cmul co cA cneg cB cneg cmul
      co cA cB cneg cmul co cneg cB cA cmul co cneg cneg cB cA cmul co cA cB
      cneg mulneg.1 cB mulneg.2 negcli mulneg1i cA cB cneg cmul co cB cA cmul
      co cneg cA cB cneg cmul co cB cneg cA cmul co cB cA cmul co cneg cA cB
      cneg mulneg.1 cB mulneg.2 negcli mulcomi cB cA mulneg.2 mulneg.1 mulneg1i
      eqtri negeqi cB cA cmul co cB cA mulneg.2 mulneg.1 mulcli negnegi 3eqtri
      cB cA mulneg.2 mulneg.1 mulcomi eqtri $.
      $( [14-Feb-1995] $)

    $( Distribution of negative over addition. $)
    negdii $p |- -u ( A + B ) = ( -u A + -u B ) $=
      c1 cA cB caddc co cmul co cneg cA cB caddc co cneg cA cneg cB cneg caddc
      co c1 cA cB caddc co cmul co cA cB caddc co cA cB caddc co cA cB mulneg.1
      mulneg.2 addcli mulid2i negeqi c1 cneg cA cB caddc co cmul co c1 cneg cA
      cmul co c1 cneg cB cmul co caddc co c1 cA cB caddc co cmul co cneg cA
      cneg cB cneg caddc co c1 cneg cA cB c1 ax1cn negcli mulneg.1 mulneg.2
      adddii c1 cA cB caddc co ax1cn cA cB mulneg.1 mulneg.2 addcli mulneg1i c1
      cneg cA cmul co cA cneg c1 cneg cB cmul co cB cneg caddc c1 cneg cA cmul
      co c1 cA cmul co cneg cA cneg c1 cA ax1cn mulneg.1 mulneg1i c1 cA cmul co
      cA cA mulneg.1 mulid2i negeqi eqtri c1 cneg cB cmul co c1 cB cmul co cneg
      cB cneg c1 cB ax1cn mulneg.2 mulneg1i c1 cB cmul co cB cB mulneg.2
      mulid2i negeqi eqtri opreq12i 3eqtr3i eqtr3i $.
      $( [28-Jul-1999] $)

    $( Distribution of negative over subtraction. $)
    negsubdii $p |- -u ( A - B ) = ( -u A + B ) $=
      cA cB cneg caddc co cneg cA cneg cB cneg cneg caddc co cA cB cmin co cneg
      cA cneg cB caddc co cA cB cneg mulneg.1 cB mulneg.2 negcli negdii cA cB
      cneg caddc co cA cB cmin co cA cB mulneg.1 mulneg.2 negsubi negeqi cB
      cneg cneg cB cA cneg caddc cB mulneg.2 negnegi opreq2i 3eqtr3i $.
      $( [6-Aug-1999] $)

    $( Distribution of negative over subtraction. $)
    negsubdi2i $p |- -u ( A - B ) = ( B - A ) $=
      cA cB cmin co cneg cA cneg cB caddc co cB cA cneg caddc co cB cA cmin co
      cA cB mulneg.1 mulneg.2 negsubdii cA cneg cB cA mulneg.1 negcli mulneg.2
      addcomi cB cA mulneg.2 mulneg.1 negsubi 3eqtri $.
      $( [1-Oct-1999] $)
  $}

  $( Product with negative is negative of product.  Theorem I.12 of [Apostol]
     p. 18. $)
  mulneg1 $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( -u A x. B ) = -u ( A x. B ) ) $=
    cA cc wcel cB cc wcel cA cneg cB cmul co cA cB cmul co cneg wceq cA cc wcel
    cA cc0 cif cneg cB cmul co cA cc wcel cA cc0 cif cB cmul co cneg wceq cA cc
    wcel cA cc0 cif cneg cB cc wcel cB cc0 cif cmul co cA cc wcel cA cc0 cif cB
    cc wcel cB cc0 cif cmul co cneg wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif
    wceq cA cneg cB cmul co cA cc wcel cA cc0 cif cneg cB cmul co cA cB cmul co
    cneg cA cc wcel cA cc0 cif cB cmul co cneg cA cA cc wcel cA cc0 cif wceq cA
    cneg cA cc wcel cA cc0 cif cneg cB cmul cA cA cc wcel cA cc0 cif negeq
    opreq1d cA cA cc wcel cA cc0 cif wceq cA cB cmul co cA cc wcel cA cc0 cif
    cB cmul co cA cA cc wcel cA cc0 cif cB cmul opreq1 negeqd eqeq12d cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cneg cB cmul co cA cc wcel cA
    cc0 cif cneg cB cc wcel cB cc0 cif cmul co cA cc wcel cA cc0 cif cB cmul co
    cneg cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co cneg cB cB cc wcel
    cB cc0 cif cA cc wcel cA cc0 cif cneg cmul opreq2 cB cB cc wcel cB cc0 cif
    wceq cA cc wcel cA cc0 cif cB cmul co cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cmul co cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmul opreq2
    negeqd eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn
    elimel cB cc0 cc 0cn elimel mulneg1i dedth2h $.
    $( [14-May-1999] $)

  $( The product with a negative is the negative of the product. $)
  mulneg2 $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( A x. -u B ) = -u ( A x. B ) ) $=
    cA cc wcel cB cc wcel wa cB cneg cA cmul co cB cA cmul co cneg cA cB cneg
    cmul co cA cB cmul co cneg cB cc wcel cA cc wcel cB cneg cA cmul co cB cA
    cmul co cneg wceq cB cA mulneg1 ancoms cA cc wcel cB cneg cc wcel cA cB
    cneg cmul co cB cneg cA cmul co wceq cB cc wcel cA cB cneg mulcom cB negcl
    sylan2 cA cc wcel cB cc wcel wa cA cB cmul co cB cA cmul co cA cB mulcom
    negeqd 3eqtr4d $.
    $( [25-Aug-2004] $) $( [30-Jul-2004] $)

  $( Swap the negative sign in a product. $)
  mulneg12 $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( -u A x. B ) = ( A x. -u B ) ) $=
    cA cc wcel cB cc wcel wa cA cneg cB cmul co cA cB cmul co cneg cA cB cneg
    cmul co cA cB mulneg1 cA cB mulneg2 eqtr4d $.
    $( [2-Sep-2004] $) $( [30-Jul-2004] $)

  $( Product of two negatives.  Theorem I.12 of [Apostol] p. 18. $)
  mul2neg $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A x. -u B ) = ( A x. B ) ) $=
    cA cc wcel cB cc wcel cA cneg cB cneg cmul co cA cB cmul co wceq cA cc wcel
    cA cc0 cif cneg cB cneg cmul co cA cc wcel cA cc0 cif cB cmul co wceq cA cc
    wcel cA cc0 cif cneg cB cc wcel cB cc0 cif cneg cmul co cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmul co wceq cA cB cc0 cc0 cA cA cc wcel cA cc0
    cif wceq cA cneg cB cneg cmul co cA cc wcel cA cc0 cif cneg cB cneg cmul co
    cA cB cmul co cA cc wcel cA cc0 cif cB cmul co cA cA cc wcel cA cc0 cif
    wceq cA cneg cA cc wcel cA cc0 cif cneg cB cneg cmul cA cA cc wcel cA cc0
    cif negeq opreq1d cA cA cc wcel cA cc0 cif cB cmul opreq1 eqeq12d cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cneg cB cneg cmul co cA cc wcel
    cA cc0 cif cneg cB cc wcel cB cc0 cif cneg cmul co cA cc wcel cA cc0 cif cB
    cmul co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co cB cB cc wcel
    cB cc0 cif wceq cB cneg cB cc wcel cB cc0 cif cneg cA cc wcel cA cc0 cif
    cneg cmul cB cB cc wcel cB cc0 cif negeq opreq2d cB cB cc wcel cB cc0 cif
    cA cc wcel cA cc0 cif cmul opreq2 eqeq12d cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel mul2negi dedth2h $.
    $( [30-Aug-2004] $) $( [30-Jul-2004] $)

  $( Distribution of negative over addition. $)
  negdi $p |- ( ( A e. CC /\ B e. CC ) ->
                 -u ( A + B ) = ( -u A + -u B ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co cneg cA cneg cB cneg caddc co wceq cA
    cc wcel cA cc0 cif cB caddc co cneg cA cc wcel cA cc0 cif cneg cB cneg
    caddc co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cneg cA
    cc wcel cA cc0 cif cneg cB cc wcel cB cc0 cif cneg caddc co wceq cA cB cc0
    cc0 cA cA cc wcel cA cc0 cif wceq cA cB caddc co cneg cA cc wcel cA cc0 cif
    cB caddc co cneg cA cneg cB cneg caddc co cA cc wcel cA cc0 cif cneg cB
    cneg caddc co cA cA cc wcel cA cc0 cif wceq cA cB caddc co cA cc wcel cA
    cc0 cif cB caddc co cA cA cc wcel cA cc0 cif cB caddc opreq1 negeqd cA cA
    cc wcel cA cc0 cif wceq cA cneg cA cc wcel cA cc0 cif cneg cB cneg caddc cA
    cA cc wcel cA cc0 cif negeq opreq1d eqeq12d cB cB cc wcel cB cc0 cif wceq
    cA cc wcel cA cc0 cif cB caddc co cneg cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif caddc co cneg cA cc wcel cA cc0 cif cneg cB cneg caddc co cA cc
    wcel cA cc0 cif cneg cB cc wcel cB cc0 cif cneg caddc co cB cB cc wcel cB
    cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif caddc co cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif
    caddc opreq2 negeqd cB cB cc wcel cB cc0 cif wceq cB cneg cB cc wcel cB cc0
    cif cneg cA cc wcel cA cc0 cif cneg caddc cB cB cc wcel cB cc0 cif negeq
    opreq2d eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn
    elimel cB cc0 cc 0cn elimel negdii dedth2h $.
    $( [5-Jun-2004] $) $( [10-May-2004] $)

  $( Distribution of negative over addition. $)
  negdi2 $p |- ( ( A e. CC /\ B e. CC ) ->
                 -u ( A + B ) = ( -u A - B ) ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co cneg cA cneg cB cneg caddc co cA
    cneg cB cmin co cA cB negdi cA cneg cc wcel cB cc wcel cA cneg cB cneg
    caddc co cA cneg cB cmin co wceq cA cc wcel cA cneg cB negsub cA negcl
    sylan eqtrd $.
    $( [2-Jan-2006] $) $( [1-Jan-2006] $)

  $( Distribution of negative over subtraction. $)
  negsubdi $p |- ( ( A e. CC /\ B e. CC ) -> -u ( A - B ) = ( -u A + B ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg caddc co cneg cA cneg cB cneg cneg
    caddc co cA cB cmin co cneg cA cneg cB caddc co cA cc wcel cB cneg cc wcel
    cA cB cneg caddc co cneg cA cneg cB cneg cneg caddc co wceq cB cc wcel cA
    cB cneg negdi cB negcl sylan2 cA cc wcel cB cc wcel wa cA cB cneg caddc co
    cA cB cmin co cA cB negsub negeqd cA cc wcel cB cc wcel wa cB cneg cneg cB
    cA cneg caddc cB cc wcel cB cneg cneg cB wceq cA cc wcel cB negneg adantl
    opreq2d 3eqtr3d $.
    $( [1-Aug-2006] $) $( [15-Nov-2004] $)

  $( Distribution of negative over subtraction. $)
  negsubdi2 $p |- ( ( A e. CC /\ B e. CC ) -> -u ( A - B ) = ( B - A ) ) $=
    cA cc wcel cB cc wcel wa cA cB cmin co cneg cA cneg cB caddc co cB cA cneg
    caddc co cB cA cmin co cA cB negsubdi cA cneg cc wcel cB cc wcel cA cneg cB
    caddc co cB cA cneg caddc co wceq cA cc wcel cA cneg cB addcom cA negcl
    sylan cB cc wcel cA cc wcel cB cA cneg caddc co cB cA cmin co wceq cB cA
    negsub ancoms 3eqtrd $.
    $( [1-Aug-2006] $) $( [4-Oct-1999] $)

  $( Relationship between subtraction and negative.  (Contributed by Paul
     Chapman, 8-Oct-2007.) $)
  neg2sub $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A - -u B ) = ( B - A ) ) $=
    cA cc wcel cB cc wcel wa cA cneg cB cneg cmin co cA cneg cB caddc co cA cB
    cmin co cneg cB cA cmin co cA cneg cc wcel cB cc wcel cA cneg cB cneg cmin
    co cA cneg cB caddc co wceq cA cc wcel cA cneg cB subneg cA negcl sylan cA
    cB negsubdi cA cB negsubdi2 3eqtr2d $.
    $( [8-Oct-2007] $) $( [8-Oct-2007] $)

  $( Convert a subtraction to addition using multiplication by a negative. $)
  submul2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( A - ( B x. C ) ) = ( A + ( B x. -u C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cA cB cC cmul co cmin co cA cB cC cneg
    cmul co caddc co wceq cA cc wcel cB cc wcel cC cc wcel wa wa cA cB cC cneg
    cmul co caddc co cA cB cC cmul co cneg caddc co cA cB cC cmul co cmin co cA
    cc wcel cB cc wcel cC cc wcel wa wa cB cC cneg cmul co cB cC cmul co cneg
    cA caddc cB cc wcel cC cc wcel wa cB cC cneg cmul co cB cC cmul co cneg
    wceq cA cc wcel cB cC mulneg2 adantl opreq2d cA cc wcel cB cC cmul co cc
    wcel cA cB cC cmul co cneg caddc co cA cB cC cmul co cmin co wceq cB cc
    wcel cC cc wcel wa cA cB cC cmul co negsub cB cC mulcl sylan2 eqtr2d 3impb
    $.
    $( [9-Feb-2007] $) $( [2-Feb-2007] $)

  $( Law for double subtraction. $)
  subsub2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( A - ( B - C ) ) = ( A + ( C - B ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cmin co cneg caddc co cA cB
    cC cmin co cmin co cA cC cB cmin co caddc co cA cc wcel cB cc wcel cC cc
    wcel cA cB cC cmin co cneg caddc co cA cB cC cmin co cmin co wceq cA cc
    wcel cB cC cmin co cc wcel cA cB cC cmin co cneg caddc co cA cB cC cmin co
    cmin co wceq cB cc wcel cC cc wcel wa cA cB cC cmin co negsub cB cC subcl
    sylan2 3impb cB cc wcel cC cc wcel cA cB cC cmin co cneg caddc co cA cC cB
    cmin co caddc co wceq cA cc wcel cB cc wcel cC cc wcel wa cB cC cmin co
    cneg cC cB cmin co cA caddc cB cC negsubdi2 opreq2d 3adant1 eqtr3d $.
    $( [2-Aug-2006] $) $( [30-Jun-2005] $)

  $( Law for double subtraction. $)
  subsub $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( A - ( B - C ) ) = ( ( A - B ) + C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cmin co cmin co cA cC cB cmin
    co caddc co cA cB cmin co cC caddc co cA cB cC subsub2 cA cc wcel cC cc
    wcel cB cc wcel cA cC cB cmin co caddc co cA cB cmin co cC caddc co wceq cA
    cc wcel cC cc wcel cB cc wcel w3a cA cC caddc co cB cmin co cA cC cB cmin
    co caddc co cA cB cmin co cC caddc co cA cC cB addsubass cA cC cB addsub
    eqtr3d 3com23 eqtrd $.
    $( [6-Jun-2004] $) $( [13-May-2004] $)

  $( Law for double subtraction. $)
  subsub3 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( A - ( B - C ) ) = ( ( A + C ) - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cmin co cmin co cA cC cB cmin
    co caddc co cA cC caddc co cB cmin co cA cB cC subsub2 cA cc wcel cC cc
    wcel cB cc wcel cA cC caddc co cB cmin co cA cC cB cmin co caddc co wceq cA
    cC cB addsubass 3com23 eqtr4d $.
    $( [29-Jul-2005] $) $( [27-Jul-2005] $)

  $( Law for double subtraction. $)
  subsub4 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A - B ) - C ) = ( A - ( B + C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cneg cmin co cmin co cA cB
    cmin co cC cneg caddc co cA cB cC caddc co cmin co cA cB cmin co cC cmin co
    cA cc wcel cB cc wcel cC cneg cc wcel cA cB cC cneg cmin co cmin co cA cB
    cmin co cC cneg caddc co wceq cC cc wcel cA cB cC cneg subsub cC negcl
    syl3an3 cA cc wcel cB cc wcel cC cc wcel w3a cB cC cneg cmin co cB cC caddc
    co cA cmin cB cc wcel cC cc wcel cB cC cneg cmin co cB cC caddc co wceq cA
    cc wcel cB cC subneg 3adant1 opreq2d cA cc wcel cB cc wcel cC cc wcel cA cB
    cmin co cC cneg caddc co cA cB cmin co cC cmin co wceq cA cB cmin co cc
    wcel cC cc wcel cA cB cmin co cC cneg caddc co cA cB cmin co cC cmin co
    wceq cA cc wcel cB cc wcel wa cA cB cmin co cC negsub cA cB subcl sylan
    3impa 3eqtr3rd $.
    $( [2-Aug-2006] $) $( [19-Aug-2005] $)

  $( Swap the second and third terms in a double subtraction. $)
  sub23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A - B ) - C ) = ( ( A - C ) - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC caddc co cmin co cA cC cB
    caddc co cmin co cA cB cmin co cC cmin co cA cC cmin co cB cmin co cA cc
    wcel cB cc wcel cC cc wcel w3a cB cC caddc co cC cB caddc co cA cmin cB cc
    wcel cC cc wcel cB cC caddc co cC cB caddc co wceq cA cc wcel cB cC addcom
    3adant1 opreq2d cA cB cC subsub4 cA cc wcel cC cc wcel cB cc wcel cA cC
    cmin co cB cmin co cA cC cB caddc co cmin co wceq cA cC cB subsub4 3com23
    3eqtr4d $.
    $( [4-Sep-2005] $) $( [19-Aug-2005] $)

  $( Cancellation law for subtraction. $)
  nnncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - ( B - C ) ) - C ) = ( A - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cmin co cmin co cC cmin co cA
    cB cC cmin co cC caddc co cmin co cA cB cmin co cA cc wcel cB cC cmin co cc
    wcel cC cc wcel cA cB cC cmin co cmin co cC cmin co cA cB cC cmin co cC
    caddc co cmin co wceq cB cc wcel cA cB cC cmin co cC subsub4 cB cc wcel cC
    cc wcel cB cC cmin co cc wcel cA cc wcel cB cC subcl 3adant1 syld3an2 cB cc
    wcel cC cc wcel cA cB cC cmin co cC caddc co cmin co cA cB cmin co wceq cA
    cc wcel cB cc wcel cC cc wcel wa cB cC cmin co cC caddc co cB cA cmin cB cC
    npcan opreq2d 3adant1 eqtrd $.
    $( [16-Sep-2005] $) $( [4-Sep-2005] $)

  $( Cancellation law for subtraction. $)
  nnncan1 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) - ( A - C ) ) = ( C - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cmin co cA cC cmin co cmin co cA
    cC cmin co cneg cA cB cmin co caddc co cC cA cmin co cA cB cmin co caddc co
    cC cB cmin co cA cB cmin co cc wcel cA cC cmin co cc wcel cA cB cmin co cA
    cC cmin co cmin co cA cC cmin co cneg cA cB cmin co caddc co wceq cA cc
    wcel cB cc wcel cC cc wcel w3a cA cB cmin co cc wcel cA cC cmin co cc wcel
    wa cA cB cmin co cA cC cmin co cneg caddc co cA cB cmin co cA cC cmin co
    cmin co cA cC cmin co cneg cA cB cmin co caddc co cA cB cmin co cA cC cmin
    co negsub cA cB cmin co cc wcel cA cC cmin co cneg cc wcel cA cB cmin co cA
    cC cmin co cneg caddc co cA cC cmin co cneg cA cB cmin co caddc co wceq cA
    cC cmin co cc wcel cA cB cmin co cA cC cmin co cneg addcom cA cC cmin co
    negcl sylan2 eqtr3d cA cc wcel cB cc wcel cA cB cmin co cc wcel cC cc wcel
    cA cB subcl 3adant3 cA cc wcel cC cc wcel cA cC cmin co cc wcel cB cc wcel
    cA cC subcl 3adant2 sylanc cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmin
    co cneg cC cA cmin co cA cB cmin co caddc cA cc wcel cC cc wcel cA cC cmin
    co cneg cC cA cmin co wceq cB cc wcel cA cC negsubdi2 3adant2 opreq1d cC cc
    wcel cA cc wcel cB cc wcel cC cA cmin co cA cB cmin co caddc co cC cB cmin
    co wceq cC cA cB npncan 3coml 3eqtrd $.
    $( [1-Aug-2006] $) $( [8-Feb-2005] $)

  $( Cancellation law for subtraction. $)
  nnncan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - C ) - ( B - C ) ) = ( A - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC cmin co cmin co cC cmin co cA
    cC cmin co cB cC cmin co cmin co cA cB cmin co cA cc wcel cB cC cmin co cc
    wcel cC cc wcel cA cB cC cmin co cmin co cC cmin co cA cC cmin co cB cC
    cmin co cmin co wceq cB cc wcel cA cB cC cmin co cC sub23 cB cc wcel cC cc
    wcel cB cC cmin co cc wcel cA cc wcel cB cC subcl 3adant1 syld3an2 cA cB cC
    nnncan eqtr3d $.
    $( [3-Oct-2005] $) $( [1-Oct-2005] $)

  $( Cancellation law for subtraction. $)
  nncan $p |- ( ( A e. CC /\ B e. CC ) -> ( A - ( A - B ) ) = B ) $=
    cA cc wcel cB cc wcel wa cA cc0 cmin co cA cB cmin co cmin co cB cc0 cmin
    co cA cA cB cmin co cmin co cB cA cc wcel cc0 cc wcel cB cc wcel cA cc0
    cmin co cA cB cmin co cmin co cB cc0 cmin co wceq 0cn cA cc0 cB nnncan1
    mp3an2 cA cc wcel cB cc wcel wa cA cc0 cmin co cA cA cB cmin co cmin cA cc
    wcel cA cc0 cmin co cA wceq cB cc wcel cA subid1 adantr opreq1d cB cc wcel
    cB cc0 cmin co cB wceq cA cc wcel cB subid1 adantl 3eqtr3d $.
    $( [23-Jun-2005] $) $( [21-Jun-2005] $)

  $( Cancellation law for subtraction. $)
  nppcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - ( B + C ) ) + C ) = ( A - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC caddc co cC cmin co cmin co
    cA cB cC caddc co cmin co cC caddc co cA cB cmin co cA cc wcel cB cC caddc
    co cc wcel cC cc wcel cA cB cC caddc co cC cmin co cmin co cA cB cC caddc
    co cmin co cC caddc co wceq cB cc wcel cA cB cC caddc co cC subsub cB cc
    wcel cC cc wcel cB cC caddc co cc wcel cA cc wcel cB cC addcl 3adant1
    syld3an2 cA cc wcel cB cc wcel cC cc wcel w3a cB cC caddc co cC cmin co cB
    cA cmin cB cc wcel cC cc wcel cB cC caddc co cC cmin co cB wceq cA cc wcel
    cB cC pncan 3adant1 opreq2d eqtr3d $.
    $( [7-Oct-2005] $) $( [29-Sep-2005] $)

  $( Product with minus one is negative. $)
  mulm1 $p |- ( A e. CC -> ( -u 1 x. A ) = -u A ) $=
    cA cc wcel c1 cneg cA cmul co c1 cA cmul co cneg cA cneg c1 cc wcel cA cc
    wcel c1 cneg cA cmul co c1 cA cmul co cneg wceq ax1cn c1 cA mulneg1 mpan cA
    cc wcel c1 cA cmul co cA cA mulid2 negeqd eqtrd $.
    $( [16-Nov-1999] $)

  ${
    mulm1.1 $e |- A e. CC $.
    $( Product with minus one is negative. $)
    mulm1i $p |- ( -u 1 x. A ) = -u A $=
      cA cc wcel c1 cneg cA cmul co cA cneg wceq mulm1.1 cA mulm1 ax-mp $.
      $( [31-Jul-1999] $)
  $}

  $( Rearrangement of 4 terms in a mixed addition and subtraction. $)
  addsub4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A + B ) - ( C + D ) ) = ( ( A - C ) + ( B - D ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB caddc co cC cD
    caddc co cneg caddc co cA cC cneg caddc co cB cD cneg caddc co caddc co cA
    cB caddc co cC cD caddc co cmin co cA cC cmin co cB cD cmin co caddc co cA
    cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB caddc co cC cD
    caddc co cneg caddc co cA cB caddc co cC cneg cD cneg caddc co caddc co cA
    cC cneg caddc co cB cD cneg caddc co caddc co cA cc wcel cB cc wcel wa cC
    cc wcel cD cc wcel wa wa cC cD caddc co cneg cC cneg cD cneg caddc co cA cB
    caddc co caddc cC cc wcel cD cc wcel wa cC cD caddc co cneg cC cneg cD cneg
    caddc co wceq cA cc wcel cB cc wcel wa cC cD negdi adantl opreq2d cA cc
    wcel cB cc wcel wa cC cneg cc wcel cD cneg cc wcel wa cA cB caddc co cC
    cneg cD cneg caddc co caddc co cA cC cneg caddc co cB cD cneg caddc co
    caddc co wceq cC cc wcel cD cc wcel wa cA cB cC cneg cD cneg add4 cC cc
    wcel cC cneg cc wcel cD cc wcel cD cneg cc wcel cC negcl cD negcl anim12i
    sylan2 eqtrd cA cB caddc co cc wcel cC cD caddc co cc wcel cA cB caddc co
    cC cD caddc co cneg caddc co cA cB caddc co cC cD caddc co cmin co wceq cA
    cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa cA cB caddc co cC cD caddc
    co negsub cA cB addcl cC cD addcl syl2an cA cc wcel cC cc wcel cB cc wcel
    cD cc wcel cA cC cneg caddc co cB cD cneg caddc co caddc co cA cC cmin co
    cB cD cmin co caddc co wceq cA cc wcel cC cc wcel wa cB cc wcel cD cc wcel
    wa cA cC cneg caddc co cA cC cmin co cB cD cneg caddc co cB cD cmin co
    caddc cA cC negsub cB cD negsub opreqan12d an4s 3eqtr3d $.
    $( [6-Mar-2005] $) $( [4-Mar-2005] $)

  ${
    addsub4.1 $e |- A e. CC $.
    addsub4.2 $e |- B e. CC $.
    addsub4.3 $e |- C e. CC $.
    addsub4.4 $e |- D e. CC $.
    $( Rearrangement of 4 terms in a mixed addition and subtraction. $)
    addsub4i $p |- ( ( A + B ) - ( C + D ) ) =
                 ( ( A - C ) + ( B - D ) ) $=
      cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa cA cB caddc co cC cD
      caddc co cmin co cA cC cmin co cB cD cmin co caddc co wceq cA cc wcel cB
      cc wcel addsub4.1 addsub4.2 pm3.2i cC cc wcel cD cc wcel addsub4.3
      addsub4.4 pm3.2i cA cB cC cD addsub4 mp2an $.
      $( [17-Oct-1999] $)
  $}

  $( Rearrangement of 4 terms in a mixed addition and subtraction. $)
  subadd4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A - B ) - ( C - D ) ) = ( ( A + D ) - ( B + C ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB cmin co cC cD
    cmin co cmin co cA cB cmin co cD cC cmin co caddc co cA cD caddc co cB cC
    caddc co cmin co cA cB cmin co cc wcel cC cc wcel cD cc wcel wa cA cB cmin
    co cC cD cmin co cmin co cA cB cmin co cD cC cmin co caddc co wceq cA cc
    wcel cB cc wcel wa cA cB cmin co cc wcel cC cc wcel cD cc wcel cA cB cmin
    co cC cD cmin co cmin co cA cB cmin co cD cC cmin co caddc co wceq cA cB
    cmin co cC cD subsub2 3expb cA cB subcl sylan cA cc wcel cD cc wcel cB cc
    wcel cC cc wcel cA cD caddc co cB cC caddc co cmin co cA cB cmin co cD cC
    cmin co caddc co wceq cA cD cB cC addsub4 an42s eqtr4d $.
    $( [6-Jan-2007] $) $( [24-Aug-2006] $)

  $( Rearrangement of 4 terms in a subtraction. $)
  sub4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A - B ) - ( C - D ) ) = ( ( A - C ) - ( B - D ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cD caddc co cB cC
    caddc co cmin co cA cD caddc co cC cB caddc co cmin co cA cB cmin co cC cD
    cmin co cmin co cA cC cmin co cB cD cmin co cmin co cA cc wcel cB cc wcel
    wa cC cc wcel cD cc wcel wa wa cB cC caddc co cC cB caddc co cA cD caddc co
    cmin cB cc wcel cC cc wcel cB cC caddc co cC cB caddc co wceq cA cc wcel cD
    cc wcel cB cC addcom ad2ant2lr opreq2d cA cB cC cD subadd4 cA cc wcel cC cc
    wcel cB cc wcel cD cc wcel cA cC cmin co cB cD cmin co cmin co cA cD caddc
    co cC cB caddc co cmin co wceq cA cC cB cD subadd4 an4s 3eqtr4d $.
    $( [11-Dec-2007] $) $( [23-Nov-2007] $)

  $( Product of two differences. $)
  mulsub $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
               ( ( A - B ) x. ( C - D ) ) =
       ( ( ( A x. C ) + ( D x. B ) ) - ( ( A x. D ) + ( C x. B ) ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB cneg caddc co cC
    cD cneg caddc co cmul co cA cB cmin co cC cD cmin co cmul co cA cC cmul co
    cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc co cmin co cA cc
    wcel cB cc wcel wa cC cc wcel cD cc wcel wa cA cB cneg caddc co cA cB cmin
    co cC cD cneg caddc co cC cD cmin co cmul cA cB negsub cC cD negsub
    opreqan12d cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cB cneg
    caddc co cC cD cneg caddc co cmul co cA cC cmul co cD cneg cB cneg cmul co
    caddc co cA cD cneg cmul co cC cB cneg cmul co caddc co caddc co cA cC cmul
    co cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc co cneg caddc
    co cA cC cmul co cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc
    co cmin co cA cc wcel cB cneg cc wcel cC cc wcel cD cc wcel wa cA cB cneg
    caddc co cC cD cneg caddc co cmul co cA cC cmul co cD cneg cB cneg cmul co
    caddc co cA cD cneg cmul co cC cB cneg cmul co caddc co caddc co wceq cB cc
    wcel cA cc wcel cB cneg cc wcel wa cC cc wcel cD cneg cc wcel cA cB cneg
    caddc co cC cD cneg caddc co cmul co cA cC cmul co cD cneg cB cneg cmul co
    caddc co cA cD cneg cmul co cC cB cneg cmul co caddc co caddc co wceq cD cc
    wcel cA cB cneg cC cD cneg muladd cD negcl sylanr2 cB negcl sylanl2 cA cc
    wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cC cmul co cD cneg cB
    cneg cmul co caddc co cA cC cmul co cD cB cmul co caddc co cA cD cneg cmul
    co cC cB cneg cmul co caddc co cA cD cmul co cC cB cmul co caddc co cneg
    caddc cB cc wcel cD cc wcel cA cC cmul co cD cneg cB cneg cmul co caddc co
    cA cC cmul co cD cB cmul co caddc co wceq cA cc wcel cC cc wcel cB cc wcel
    cD cc wcel wa cD cneg cB cneg cmul co cD cB cmul co cA cC cmul co caddc cD
    cc wcel cB cc wcel cD cneg cB cneg cmul co cD cB cmul co wceq cD cB mul2neg
    ancoms opreq2d ad2ant2l cA cc wcel cD cc wcel cB cc wcel cC cc wcel cA cD
    cneg cmul co cC cB cneg cmul co caddc co cA cD cmul co cC cB cmul co caddc
    co cneg wceq cA cc wcel cD cc wcel wa cC cc wcel cB cc wcel cA cD cneg cmul
    co cC cB cneg cmul co caddc co cA cD cmul co cC cB cmul co caddc co cneg
    wceq cA cc wcel cD cc wcel wa cC cc wcel cB cc wcel wa wa cA cD cneg cmul
    co cC cB cneg cmul co caddc co cA cD cmul co cneg cC cB cmul co cneg caddc
    co cA cD cmul co cC cB cmul co caddc co cneg cA cc wcel cD cc wcel wa cC cc
    wcel cB cc wcel wa cA cD cneg cmul co cA cD cmul co cneg cC cB cneg cmul co
    cC cB cmul co cneg caddc cA cD mulneg2 cC cB mulneg2 opreqan12d cA cD cmul
    co cc wcel cC cB cmul co cc wcel cA cD cmul co cC cB cmul co caddc co cneg
    cA cD cmul co cneg cC cB cmul co cneg caddc co wceq cA cc wcel cD cc wcel
    wa cC cc wcel cB cc wcel wa cA cD cmul co cC cB cmul co negdi cA cD mulcl
    cC cB mulcl syl2an eqtr4d ancom2s an42s opreq12d cA cC cmul co cD cB cmul
    co caddc co cc wcel cA cD cmul co cC cB cmul co caddc co cc wcel cA cC cmul
    co cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc co cneg caddc
    co cA cC cmul co cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc
    co cmin co wceq cA cc wcel cB cc wcel wa cC cc wcel cD cc wcel wa wa cA cC
    cmul co cD cB cmul co caddc co cA cD cmul co cC cB cmul co caddc co negsub
    cA cc wcel cC cc wcel cB cc wcel cD cc wcel cA cC cmul co cD cB cmul co
    caddc co cc wcel cA cC cmul co cc wcel cD cB cmul co cc wcel cA cC cmul co
    cD cB cmul co caddc co cc wcel cA cc wcel cC cc wcel wa cB cc wcel cD cc
    wcel wa cA cC cmul co cD cB cmul co addcl cA cC mulcl cD cc wcel cB cc wcel
    cD cB cmul co cc wcel cD cB mulcl ancoms syl2an an4s cA cc wcel cD cc wcel
    cB cc wcel cC cc wcel cA cD cmul co cC cB cmul co caddc co cc wcel cA cD
    cmul co cc wcel cC cB cmul co cc wcel cA cD cmul co cC cB cmul co caddc co
    cc wcel cA cc wcel cD cc wcel wa cB cc wcel cC cc wcel wa cA cD cmul co cC
    cB cmul co addcl cA cD mulcl cC cc wcel cB cc wcel cC cB cmul co cc wcel cC
    cB mulcl ancoms syl2an an42s sylanc 3eqtrd eqtr3d $.
    $( [16-Jan-2006] $) $( [14-Jan-2006] $)

  $( Cancellation law for mixed addition and subtraction. $)
  pnpcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) - ( A + C ) ) = ( B - C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cA cC caddc co cmin co cB
    cC cmin co wceq cA cc wcel cB cc wcel cC cc wcel wa wa cA cB caddc co cA cC
    caddc co cmin co cA cA cmin co cB cC cmin co caddc co cB cC cmin co cA cc
    wcel cB cc wcel cC cc wcel cA cB caddc co cA cC caddc co cmin co cA cA cmin
    co cB cC cmin co caddc co wceq cA cB cA cC addsub4 anandis cA cc wcel cB cc
    wcel cC cc wcel wa cA cA cmin co cB cC cmin co caddc co cc0 cB cC cmin co
    caddc co cB cC cmin co cA cc wcel cA cA cmin co cc0 cB cC cmin co caddc cA
    subid opreq1d cB cc wcel cC cc wcel wa cB cC cmin co cc wcel cc0 cB cC cmin
    co caddc co cB cC cmin co wceq cB cC subcl cB cC cmin co addid2 syl
    sylan9eq eqtrd 3impb $.
    $( [13-Mar-2005] $) $( [4-Mar-2005] $)

  $( Cancellation law for mixed addition and subtraction.  (Contributed by
     Scott Fenton, 9-Jun-2006.) $)
  pnpcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A + C ) - ( B + C ) ) = ( A - B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cC caddc co cB cC caddc co cmin co
    cC cA caddc co cC cB caddc co cmin co cA cB cmin co cA cc wcel cB cc wcel
    cC cc wcel w3a cA cC caddc co cC cA caddc co cB cC caddc co cC cB caddc co
    cmin cA cc wcel cC cc wcel cA cC caddc co cC cA caddc co wceq cB cc wcel cA
    cC addcom 3adant2 cB cc wcel cC cc wcel cB cC caddc co cC cB caddc co wceq
    cA cc wcel cB cC addcom 3adant1 opreq12d cC cc wcel cA cc wcel cB cc wcel
    cC cA caddc co cC cB caddc co cmin co cA cB cmin co wceq cC cA cB pnpcan
    3coml eqtrd $.
    $( [10-Jun-2006] $) $( [9-Jun-2006] $)

  $( Cancellation law for mixed addition and subtraction. $)
  pnncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) - ( A - C ) ) = ( B + C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cA cC cneg caddc co
    cmin co cB cC cneg cmin co cA cB caddc co cA cC cmin co cmin co cB cC caddc
    co cA cc wcel cB cc wcel cC cneg cc wcel cA cB caddc co cA cC cneg caddc co
    cmin co cB cC cneg cmin co wceq cC cc wcel cA cB cC cneg pnpcan cC negcl
    syl3an3 cA cc wcel cB cc wcel cC cc wcel w3a cA cC cneg caddc co cA cC cmin
    co cA cB caddc co cmin cA cc wcel cC cc wcel cA cC cneg caddc co cA cC cmin
    co wceq cB cc wcel cA cC negsub 3adant2 opreq2d cB cc wcel cC cc wcel cB cC
    cneg cmin co cB cC caddc co wceq cA cc wcel cB cC subneg 3adant1 3eqtr3d $.
    $( [2-Aug-2006] $) $( [30-Jun-2005] $)

  $( Cancellation law for mixed addition and subtraction. $)
  ppncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) + ( C - B ) ) = ( A + C ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cB cC cmin co cmin co
    cB cA caddc co cB cC cmin co cmin co cA cB caddc co cC cB cmin co caddc co
    cA cC caddc co cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cB cA
    caddc co cB cC cmin co cmin cA cc wcel cB cc wcel cA cB caddc co cB cA
    caddc co wceq cC cc wcel cA cB addcom 3adant3 opreq1d cA cB caddc co cc
    wcel cB cc wcel cC cc wcel cA cB caddc co cB cC cmin co cmin co cA cB caddc
    co cC cB cmin co caddc co wceq cA cc wcel cA cB caddc co cB cC subsub2 cA
    cc wcel cB cc wcel cA cB caddc co cc wcel cC cc wcel cA cB addcl 3adant3
    syld3an1 cB cc wcel cA cc wcel cC cc wcel cB cA caddc co cB cC cmin co cmin
    co cA cC caddc co wceq cB cA cC pnncan 3com12 3eqtr3d $.
    $( [9-Jul-2005] $) $( [30-Jun-2005] $)

  ${
    pnncan.1 $e |- A e. CC $.
    pnncan.2 $e |- B e. CC $.
    pnncan.3 $e |- C e. CC $.
    $( Cancellation law for mixed addition and subtraction. $)
    pnncani $p |- ( ( A + B ) - ( A - C ) ) = ( B + C ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB caddc co cA cC cmin co cmin co cB
      cC caddc co wceq pnncan.1 pnncan.2 pnncan.3 cA cB cC pnncan mp3an $.
      $( [15-Jan-2006] $) $( [14-Jan-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Infinity and the extended real number system
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c +oo $. $( Plus infinity $)
  $c -oo $. $( Minus infinity $)
  $c RR* $. $( The set of extended reals $)
  $c < $. $( 'Less than' relation (over extended reals) $)

  $( Plus infinity. $)
  cpnf $a class +oo $.
  $( Minus infinity. $)
  cmnf $a class -oo $.
  $( The set of extended reals (includes plus and minus infinity). $)
  cxr $a class RR* $.
  $( 'Less than' predicate (extended to include the extended reals). $)
  clt $a class < $.

  $( Define plus infinity.  Note that the definition is arbitrary, requiring
     only that ` +oo ` be a set not in ` RR ` and different from ` -oo `
     ( ~ df-mnf ).  We use ` ~P U. CC ` to make it independent of the
     construction of ` CC ` , and Cantor's Theorem will show that it is
     different from any member of ` CC ` and therefore ` RR ` .  See ~ pnfnre ,
     ~ mnfnre , and ~ pnfnemnf .

     A simpler possibility is to define ` +oo ` as ` CC ` and ` -oo ` as
     ` { CC } ` , but that approach requires the Axiom of Regularity to show
     that ` +oo ` and ` -oo ` are different from each other and from all
     members of ` RR ` . $)
  df-pnf $a |- +oo = ~P U. CC $.

  $( Define minus infinity as the power set of plus infinity.  Note that the
     definition is arbitrary, requiring only that ` -oo ` be a set not in
     ` RR ` and different from ` +oo ` (see ~ mnfnre and ~ pnfnemnf ). $)
  df-mnf $a |- -oo = ~P +oo $.

  $( Define the set of extended reals that includes plus and minus infinity.
     Definition 12-3.1 of [Gleason] p. 173. $)
  df-xr $a |- RR* = ( RR u. { +oo , -oo } ) $.

  $( Define 'less than' on the set of extended reals.  Definition 12-3.1 of
     [Gleason] p. 173.  The clipping of ` <RR ` makes our definition
     independent of the complex number construction, since the postulates don't
     presuppose that ` <RR ` is a relation on ` RR ` . $)
  df-ltxr $a |- < = ( ( ( <RR i^i ( RR X. RR ) ) u. { <. -oo , +oo >. } ) u.
                ( ( RR X. { +oo } ) u. ( { -oo } X. RR ) ) ) $.

  $( Define 'less than or equal to' on the extended real subset of complex
     numbers.  Theorem ~ leloe relates it to 'less than' for reals. $)
  df-le $a |- <_ = ( ( RR* X. RR* ) \ `' < ) $.

  $( The set of extended reals exists. $)
  xrex $p |- RR* e. _V $=
    cxr cr cpnf cmnf cpr cun cvv df-xr cr cpnf cmnf cpr reex cpnf cmnf prex
    unex eqeltri $.
    $( [24-Dec-2006] $) $( [24-Dec-2006] $)

  $( Plus infinity belongs to the set of extended reals. $)
  pnfxr $p |- +oo e. RR* $=
    cpnf cr cpnf cmnf cpr cun cxr cpnf cr cpnf cmnf cpr cun wcel cpnf cr wcel
    cpnf cpnf cmnf cpr wcel wo cpnf cpnf cmnf cpr wcel cpnf cr wcel cpnf cmnf
    cpnf cc cuni cpw cvv df-pnf cc cuni cc axcnex uniex pwex eqeltri prid1 olci
    cpnf cr cpnf cmnf cpr elun mpbir df-xr eleqtrri $.
    $( [6-May-2008] $) $( [13-Oct-2005] $)

  $( Minus infinity belongs to the set of extended reals. $)
  mnfxr $p |- -oo e. RR* $=
    cmnf cr cpnf cmnf cpr cun cxr cmnf cr cpnf cmnf cpr cun wcel cmnf cr wcel
    cmnf cpnf cmnf cpr wcel wo cmnf cpnf cmnf cpr wcel cmnf cr wcel cpnf cmnf
    cmnf cpnf cpw cvv df-mnf cpnf cpnf cc cuni cpw cvv df-pnf cc cuni cc axcnex
    uniex pwex eqeltri pwex eqeltri prid2 olci cmnf cr cpnf cmnf cpr elun mpbir
    df-xr eleqtrri $.
    $( [6-May-2008] $) $( [13-Oct-2005] $)

  $( The 'less than' binary relation on the set of extended reals.  Definition
     12-3.1 of [Gleason] p. 173. $)
  ltxr $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B <->
            ( ( ( ( A e. RR /\ B e. RR ) /\ A <RR B ) \/
                 ( A = -oo /\ B = +oo ) ) \/ ( ( A e. RR /\ B = +oo )
                \/ ( A = -oo /\ B e. RR ) ) ) ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cop cltrr cr cr cxp cin cmnf cpnf cop csn
    cun wcel cA cB cop cr cpnf csn cxp cmnf csn cr cxp cun wcel wo cA cr wcel
    cB cr wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq wa wo cA cr wcel
    cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo cA cB clt wbr cA cxr wcel
    cB cxr wcel wa cA cB cop cltrr cr cr cxp cin cmnf cpnf cop csn cun wcel cA
    cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq wa wo cA
    cB cop cr cpnf csn cxp cmnf csn cr cxp cun wcel cA cr wcel cB cpnf wceq wa
    cA cmnf wceq cB cr wcel wa wo cA cxr wcel cB cxr wcel wa cA cB cop cltrr cr
    cr cxp cin wcel cA cB cop cmnf cpnf cop csn wcel wo cA cr wcel cB cr wcel
    wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq wa wo cA cB cop cltrr cr cr
    cxp cin cmnf cpnf cop csn cun wcel cA cxr wcel cB cxr wcel wa cA cB cop
    cltrr cr cr cxp cin wcel cA cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cB
    cop cmnf cpnf cop csn wcel cA cmnf wceq cB cpnf wceq wa cB cxr wcel cA cB
    cop cltrr cr cr cxp cin wcel cA cr wcel cB cr wcel wa cA cB cltrr wbr wa wb
    cA cxr wcel cB cxr wcel cA cB cop cltrr wcel cA cB cop cr cr cxp wcel wa cA
    cB cltrr wbr cA cr wcel cB cr wcel wa wa cA cB cop cltrr cr cr cxp cin wcel
    cA cr wcel cB cr wcel wa cA cB cltrr wbr wa cB cxr wcel cA cB cop cltrr
    wcel cA cB cltrr wbr cA cB cop cr cr cxp wcel cA cr wcel cB cr wcel wa cA
    cB cop cltrr wcel cA cB cltrr wbr wb cB cxr wcel cA cB cltrr wbr cA cB cop
    cltrr wcel cA cB cltrr df-br bicomi a1i cA cB cr cr cxr opelxpg anbi12d cA
    cB cop cltrr cr cr cxp elin cA cr wcel cB cr wcel wa cA cB cltrr wbr ancom
    3bitr4g adantl cA cxr wcel cB cxr wcel wa cA cB cop cmnf cpnf cop wceq cA
    cmnf wceq cB cpnf wceq wa cA cB cop cmnf cpnf cop csn wcel cA cxr wcel cB
    cxr wcel cpnf cxr wcel cA cB cop cmnf cpnf cop wceq cA cmnf wceq cB cpnf
    wceq wa wb pnfxr cA cB cmnf cpnf cxr cxr cxr opthgg mp3an3 cA cB cop cmnf
    cpnf cop cA cB opex elsnc syl5bb orbi12d cA cB cop cltrr cr cr cxp cin cmnf
    cpnf cop csn elun syl5bb cA cxr wcel cB cxr wcel wa cA cB cop cr cpnf csn
    cxp wcel cA cB cop cmnf csn cr cxp wcel wo cA cr wcel cB cpnf wceq wa cA
    cmnf wceq cB cr wcel wa wo cA cB cop cr cpnf csn cxp cmnf csn cr cxp cun
    wcel cA cxr wcel cB cxr wcel wa cA cB cop cr cpnf csn cxp wcel cA cr wcel
    cB cpnf wceq wa cA cB cop cmnf csn cr cxp wcel cA cmnf wceq cB cr wcel wa
    cB cxr wcel cA cB cop cr cpnf csn cxp wcel cA cr wcel cB cpnf wceq wa wb cA
    cxr wcel cB cxr wcel cA cB cop cr cpnf csn cxp wcel cA cr wcel cB cpnf csn
    wcel wa cA cr wcel cB cpnf wceq wa cA cB cr cpnf csn cxr opelxpg cB cxr
    wcel cB cpnf csn wcel cB cpnf wceq cA cr wcel cB cpnf cxr elsncg anbi2d
    bitrd adantl cB cxr wcel cA cB cop cmnf csn cr cxp wcel cA cmnf csn wcel cB
    cr wcel wa cA cxr wcel cA cmnf wceq cB cr wcel wa cA cB cmnf csn cr cxr
    opelxpg cA cxr wcel cA cmnf csn wcel cA cmnf wceq cB cr wcel cA cmnf cxr
    elsncg anbi1d sylan9bbr orbi12d cA cB cop cr cpnf csn cxp cmnf csn cr cxp
    elun syl5bb orbi12d cA cB clt wbr cA cB cop clt wcel cA cB cop cltrr cr cr
    cxp cin cmnf cpnf cop csn cun cr cpnf csn cxp cmnf csn cr cxp cun cun wcel
    cA cB cop cltrr cr cr cxp cin cmnf cpnf cop csn cun wcel cA cB cop cr cpnf
    csn cxp cmnf csn cr cxp cun wcel wo cA cB clt df-br clt cltrr cr cr cxp cin
    cmnf cpnf cop csn cun cr cpnf csn cxp cmnf csn cr cxp cun cun cA cB cop
    df-ltxr eleq2i cA cB cop cltrr cr cr cxp cin cmnf cpnf cop csn cun cr cpnf
    csn cxp cmnf csn cr cxp cun elun 3bitri syl5bb $.
    $( [15-Oct-2005] $) $( [14-Oct-2005] $)

  $( Plus infinity is not a real number. $)
  pnfnre $p |- +oo e/ RR $=
    cpnf cr wnel cpnf cr wcel wn cpnf cr wcel cpnf cc wcel cpnf cc wcel cc cuni
    cpw cc wcel cc pwuninel cpnf cc cuni cpw cc df-pnf eleq1i mtbir cpnf recn
    mto cpnf cr df-nel mpbir $.
    $( [6-May-2008] $) $( [13-Oct-2005] $)

  $( Minus infinity is not a real number. $)
  mnfnre $p |- -oo e/ RR $=
    cmnf cr wnel cmnf cr wcel wn cmnf cr wcel cmnf cc wcel cmnf cc wcel cc cuni
    cpw cpw cc wcel cc 2pwuninel cmnf cc cuni cpw cpw cc cmnf cpnf cpw cc cuni
    cpw cpw df-mnf cpnf cc cuni cpw wceq cpnf cpw cc cuni cpw cpw wceq df-pnf
    cpnf cc cuni cpw pweq ax-mp eqtri eleq1i mtbir cmnf recn mto cmnf cr df-nel
    mpbir $.
    $( [6-May-2008] $) $( [13-Oct-2005] $)

  $( The standard reals are a subset of the extended reals. $)
  ressxr $p |- RR C_ RR* $=
    cr cr cpnf cmnf cpr cun cxr cr cpnf cmnf cpr ssun1 df-xr sseqtr4i $.
    $( [14-Oct-2005] $) $( [14-Oct-2005] $)

  $( A standard real is an extended real. $)
  rexr $p |- ( A e. RR -> A e. RR* ) $=
    cr cxr cA ressxr sseli $.
    $( [15-Oct-2005] $) $( [14-Oct-2005] $)

  $( The standard less-than ` <RR ` and the extended real less-than ` < `
     are identical when restricted to the non-extended reals ` RR ` . $)
  ltxrlt $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> A <RR B ) ) $=
    cA cr wcel cB cr wcel wa cA cB clt wbr cA cr wcel cB cr wcel wa cA cB cltrr
    wbr wa cA cmnf wceq cB cpnf wceq wa wo cA cr wcel cB cpnf wceq wa cA cmnf
    wceq cB cr wcel wa wo wo cA cB cltrr wbr cA cxr wcel cB cxr wcel cA cB clt
    wbr cA cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq
    wa wo cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo wb cA cr
    wcel cB cr wcel cA cB ltxr cA rexr cB rexr syl2an cA cr wcel cB cr wcel wa
    cA cmnf wceq cB cpnf wceq wa cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr
    wcel wa wo wo cA cr wcel cB cr wcel wa cA cB cltrr wbr wa wo cA cB cltrr
    wbr cA cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq
    wa wo cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo cA cr
    wcel cB cr wcel wa cA cB cltrr wbr cA cr wcel cB cr wcel wa cA cB cltrr wbr
    wa cA cmnf wceq cB cpnf wceq wa cA cr wcel cB cpnf wceq wa cA cmnf wceq cB
    cr wcel wa wo wo cA cr wcel cB cr wcel wa cA cB cltrr wbr wa wo cA cr wcel
    cB cr wcel wa cA cB cltrr wbr ibar cA cr wcel cB cr wcel wa cA cmnf wceq cB
    cpnf wceq wa cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo wn
    cA cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq wa cA
    cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo cA cr wcel cB cr
    wcel wa cA cB cltrr wbr wa wo wb cA cmnf wceq cB cpnf wceq wa cA cr wcel cB
    cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo wn cA cmnf wceq cB cpnf wceq
    wa wn cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wn cA cr
    wcel cB cr wcel wa cA cmnf wceq cB cpnf wceq wa cA cr wcel cB cpnf wceq wa
    cA cmnf wceq cB cr wcel wa wo ioran cB cr wcel cA cmnf wceq cB cpnf wceq wa
    wn cA cr wcel cB cr wcel cB cpnf wceq cA cmnf wceq cB cpnf wceq cB cr wcel
    cB cpnf wceq cB cr wcel cpnf cr wcel cpnf cr wnel cpnf cr wcel wn pnfnre
    cpnf cr df-nel mpbi cB cpnf cr eleq1 mtbiri con2i intnand adantl cB cr wcel
    cA cr wcel cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wn cB
    cr wcel cA cr wcel wa cA cr wcel cB cpnf wceq wa wn cA cmnf wceq cB cr wcel
    wa wn wa cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wn cB cr
    wcel cA cr wcel cB cpnf wceq wa wn cA cr wcel cA cmnf wceq cB cr wcel wa wn
    cB cr wcel cB cpnf wceq cA cr wcel cB cpnf wceq cB cr wcel cB cpnf wceq cB
    cr wcel cpnf cr wcel cpnf cr wnel cpnf cr wcel wn pnfnre cpnf cr df-nel
    mpbi cB cpnf cr eleq1 mtbiri con2i intnand cA cr wcel cA cmnf wceq cB cr
    wcel cA cmnf wceq cA cr wcel cA cmnf wceq cA cr wcel cmnf cr wcel cmnf cr
    wnel cmnf cr wcel wn mnfnre cmnf cr df-nel mpbi cA cmnf cr eleq1 mtbiri
    con2i intnanrd anim12i cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel
    wa ioran sylibr ancoms sylanbrc cA cmnf wceq cB cpnf wceq wa cA cr wcel cB
    cpnf wceq wa cA cmnf wceq cB cr wcel wa wo wo cA cr wcel cB cr wcel wa cA
    cB cltrr wbr wa biorf syl bitr2d cA cr wcel cB cr wcel wa cA cB cltrr wbr
    wa cA cmnf wceq cB cpnf wceq wa wo cA cr wcel cB cpnf wceq wa cA cmnf wceq
    cB cr wcel wa wo wo cA cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cmnf
    wceq cB cpnf wceq wa cA cr wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa
    wo wo wo cA cmnf wceq cB cpnf wceq wa cA cr wcel cB cpnf wceq wa cA cmnf
    wceq cB cr wcel wa wo wo cA cr wcel cB cr wcel wa cA cB cltrr wbr wa wo cA
    cr wcel cB cr wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq wa cA cr
    wcel cB cpnf wceq wa cA cmnf wceq cB cr wcel wa wo orass cA cr wcel cB cr
    wcel wa cA cB cltrr wbr wa cA cmnf wceq cB cpnf wceq wa cA cr wcel cB cpnf
    wceq wa cA cmnf wceq cB cr wcel wa wo wo orcom bitri syl5bb bitrd $.
    $( [14-Oct-2005] $) $( [13-Oct-2005] $)

  $( 'Less than or equal to' expressed in terms of 'less than', for extended
     reals. $)
  xrlenlt $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A <_ B <-> -. B < A ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cle wbr cA cB cop clt ccnv wcel wn cB cA
    clt wbr wn cA cxr wcel cB cxr wcel wa cA cB cop cle wcel cA cB cop clt ccnv
    wcel wn cA cB cle wbr cA cxr wcel cB cxr wcel wa cA cB cop cxr cxr cxp wcel
    cA cB cop cle wcel cA cB cop clt ccnv wcel wn wb cA cB cxr cxr opelxpi cA
    cB cop cle wcel cA cB cop cxr cxr cxp wcel cA cB cop clt ccnv wcel wn cA cB
    cop cle wcel cA cB cop cxr cxr cxp clt ccnv cdif wcel cA cB cop cxr cxr cxp
    wcel cA cB cop clt ccnv wcel wn wa cle cxr cxr cxp clt ccnv cdif cA cB cop
    df-le eleq2i cA cB cop cxr cxr cxp clt ccnv eldif bitri baib syl cA cB cle
    df-br syl5bb cA cxr wcel cB cxr wcel wa cB cA clt wbr cA cB cop clt ccnv
    wcel cA cxr wcel cB cxr wcel wa cA cB cop clt ccnv wcel cB cA cop clt wcel
    cB cA clt wbr cA cB cxr cxr clt opelcnvg cB cA clt df-br syl6rbbr notbid
    bitr4d $.
    $( [15-Oct-2005] $) $( [14-Oct-2005] $)

  $( 'Less than' expressed in terms of 'less than or equal to', for extended
     reals. $)
  xrltnle $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B <-> -. B <_ A ) ) $=
    cB cxr wcel cA cxr wcel cA cB clt wbr cB cA cle wbr wn wb cB cxr wcel cA
    cxr wcel wa cB cA cle wbr cA cB clt wbr cB cA xrlenlt con2bid ancoms $.
    $( [6-Feb-2007] $) $( [6-Feb-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Restate the ordering postulates with extended real "less than"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Ordering on reals satisfies strict trichotomy.  Axiom 22 of 27 for
     real and complex numbers, derived from ZF set theory.  (This restates
     ~ pre-axlttri with ordering on the extended reals.) $)
  axlttri $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A < B <-> -. ( A = B \/ B < A ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB cltrr wbr cA cB wceq cB cA cltrr wbr wo wn
    cA cB clt wbr cA cB wceq cB cA clt wbr wo wn cA cB pre-axlttri cA cB ltxrlt
    cA cr wcel cB cr wcel wa cA cB wceq cB cA clt wbr wo cA cB wceq cB cA cltrr
    wbr wo cA cr wcel cB cr wcel wa cB cA clt wbr cB cA cltrr wbr cA cB wceq cB
    cr wcel cA cr wcel cB cA clt wbr cB cA cltrr wbr wb cB cA ltxrlt ancoms
    orbi2d notbid 3bitr4d $.
    $( [14-Oct-2005] $) $( [13-Oct-2005] $)

  $( Ordering on reals is transitive.  Axiom 23 of 27 for real and complex
     numbers, derived from ZF set theory.  (This restates ~ pre-axlttrn with
     ordering on the extended reals.) $)
  axlttrn $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A < B /\ B < C ) -> A < C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cltrr wbr cB cC cltrr wbr wa cA
    cC cltrr wbr cA cB clt wbr cB cC clt wbr wa cA cC clt wbr cA cB cC
    pre-axlttrn cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cA cB cltrr
    wbr cB cC clt wbr cB cC cltrr wbr cA cr wcel cB cr wcel cA cB clt wbr cA cB
    cltrr wbr wb cC cr wcel cA cB ltxrlt 3adant3 cB cr wcel cC cr wcel cB cC
    clt wbr cB cC cltrr wbr wb cA cr wcel cB cC ltxrlt 3adant1 anbi12d cA cr
    wcel cC cr wcel cA cC clt wbr cA cC cltrr wbr wb cB cr wcel cA cC ltxrlt
    3adant2 3imtr4d $.
    $( [14-Oct-2005] $) $( [13-Oct-2005] $)

  $( Ordering property of addition on reals.  Axiom 24 of 27 for real and
     complex numbers, derived from ZF set theory.  (This restates ~ pre-axltadd
     with ordering on the extended reals.) $)
  axltadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B -> ( C + A ) < ( C + B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cltrr wbr cC cA caddc co cC cB
    caddc co cltrr wbr cA cB clt wbr cC cA caddc co cC cB caddc co clt wbr cA
    cB cC pre-axltadd cA cr wcel cB cr wcel cA cB clt wbr cA cB cltrr wbr wb cC
    cr wcel cA cB ltxrlt 3adant3 cC cr wcel cA cr wcel cB cr wcel cC cA caddc
    co cC cB caddc co clt wbr cC cA caddc co cC cB caddc co cltrr wbr wb cC cr
    wcel cA cr wcel cB cr wcel cC cA caddc co cC cB caddc co clt wbr cC cA
    caddc co cC cB caddc co cltrr wbr wb cC cA caddc co cr wcel cC cB caddc co
    cr wcel cC cA caddc co cC cB caddc co clt wbr cC cA caddc co cC cB caddc co
    cltrr wbr wb cC cr wcel cA cr wcel wa cC cr wcel cB cr wcel wa cC cA caddc
    co cC cB caddc co ltxrlt cC cA readdcl cC cB readdcl syl2an 3impdi 3coml
    3imtr4d $.
    $( [14-Oct-2005] $) $( [13-Oct-2005] $)

  $( The product of two positive reals is positive.  Axiom 25 of 27 for real
     and complex numbers, derived from ZF set theory.  (This restates
     ~ pre-axmulgt0 with ordering on the extended reals.) $)
  axmulgt0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( ( 0 < A /\ 0 < B ) -> 0 < ( A x. B ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cltrr wbr cc0 cB cltrr wbr wa cc0 cA cB
    cmul co cltrr wbr cc0 cA clt wbr cc0 cB clt wbr wa cc0 cA cB cmul co clt
    wbr cA cB pre-axmulgt0 cA cr wcel cc0 cA clt wbr cc0 cA cltrr wbr cB cr
    wcel cc0 cB clt wbr cc0 cB cltrr wbr cc0 cr wcel cA cr wcel cc0 cA clt wbr
    cc0 cA cltrr wbr wb 0re cc0 cA ltxrlt mpan cc0 cr wcel cB cr wcel cc0 cB
    clt wbr cc0 cB cltrr wbr wb 0re cc0 cB ltxrlt mpan bi2anan9 cc0 cr wcel cA
    cB cmul co cr wcel cc0 cA cB cmul co clt wbr cc0 cA cB cmul co cltrr wbr wb
    cA cr wcel cB cr wcel wa cc0 cA cB cmul co ltxrlt 0re cA cB remulcl sylancr
    3imtr4d $.
    $( [14-Oct-2005] $) $( [13-Oct-2005] $)

  ${
    $d x y z A $.
    $( A non-empty, bounded-above set of reals has a supremum.  Axiom 27 of 27
       for real and complex numbers, derived from ZF set theory.  (This
       restates ~ pre-axsup with ordering on the extended reals.) $)
    axsup $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y < x ) ->
                E. x e. RR ( A. y e. A -. x < y /\
                A. y e. RR ( y < x -> E. z e. A y < z ) ) ) $=
      cA cr wss cA c0 wne vy cv vx cv clt wbr vy cA wral vx cr wrex vx cv vy cv
      clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex
      wi vy cr wral wa vx cr wrex cA cr wss cA c0 wne wa vy cv vx cv cltrr wbr
      vy cA wral vx cr wrex vx cv vy cv cltrr wbr wn vy cA wral vy cv vx cv
      cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral wa vx cr wrex vy
      cv vx cv clt wbr vy cA wral vx cr wrex vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr
      wrex cA cr wss cA c0 wne vy cv vx cv cltrr wbr vy cA wral vx cr wrex vx
      cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr
      wbr vz cA wrex wi vy cr wral wa vx cr wrex vx vy vz cA pre-axsup 3expia
      cA cr wss vy cv vx cv clt wbr vy cA wral vx cr wrex vy cv vx cv cltrr wbr
      vy cA wral vx cr wrex wb cA c0 wne cA cr wss vy cv vx cv clt wbr vy cA
      wral vy cv vx cv cltrr wbr vy cA wral vx cr cA cr wss vx cv cr wcel wa vy
      cv vx cv clt wbr vy cv vx cv cltrr wbr vy cA cA cr wss vy cv cA wcel vx
      cv cr wcel vy cv vx cv clt wbr vy cv vx cv cltrr wbr wb vy cv cr wcel vx
      cv cr wcel vy cv vx cv clt wbr vy cv vx cv cltrr wbr wb cA cr wss vy cv
      cA wcel wa vy cv vx cv ltxrlt cA cr vy cv ssel2 sylan an1rs ralbidva
      rexbidva adantr cA cr wss vx cv vy cv clt wbr wn vy cA wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr wrex vx cv
      vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr
      vz cA wrex wi vy cr wral wa vx cr wrex wb cA c0 wne cA cr wss vx cv vy cv
      clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex
      wi vy cr wral wa vx cv vy cv cltrr wbr wn vy cA wral vy cv vx cv cltrr
      wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral wa vx cr cA cr wss vx
      cv cr wcel wa vx cv vy cv clt wbr wn vy cA wral vx cv vy cv cltrr wbr wn
      vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr
      wral vy cv vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr wral
      cA cr wss vx cv cr wcel wa vx cv vy cv clt wbr wn vx cv vy cv cltrr wbr
      wn vy cA cA cr wss vx cv cr wcel wa vy cv cA wcel wa vx cv vy cv clt wbr
      vx cv vy cv cltrr wbr cA cr wss vy cv cA wcel vx cv cr wcel vx cv vy cv
      clt wbr vx cv vy cv cltrr wbr wb vy cv cr wcel vx cv cr wcel vx cv vy cv
      clt wbr vx cv vy cv cltrr wbr wb cA cr wss vy cv cA wcel wa vx cv cr wcel
      vy cv cr wcel vx cv vy cv clt wbr vx cv vy cv cltrr wbr wb vx cv vy cv
      ltxrlt ancoms cA cr vy cv ssel2 sylan an1rs notbid ralbidva cA cr wss vx
      cv cr wcel wa vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv
      vx cv cltrr wbr vy cv vz cv cltrr wbr vz cA wrex wi vy cr cA cr wss vx cv
      cr wcel wa vy cv cr wcel wa vy cv vx cv clt wbr vy cv vx cv cltrr wbr vy
      cv vz cv clt wbr vz cA wrex vy cv vz cv cltrr wbr vz cA wrex vx cv cr
      wcel vy cv cr wcel vy cv vx cv clt wbr vy cv vx cv cltrr wbr wb cA cr wss
      vy cv cr wcel vx cv cr wcel vy cv vx cv clt wbr vy cv vx cv cltrr wbr wb
      vy cv vx cv ltxrlt ancoms adantll cA cr wss vy cv cr wcel vy cv vz cv clt
      wbr vz cA wrex vy cv vz cv cltrr wbr vz cA wrex wb vx cv cr wcel cA cr
      wss vy cv cr wcel wa vy cv vz cv clt wbr vy cv vz cv cltrr wbr vz cA cA
      cr wss vz cv cA wcel vy cv cr wcel vy cv vz cv clt wbr vy cv vz cv cltrr
      wbr wb vz cv cr wcel vy cv cr wcel vy cv vz cv clt wbr vy cv vz cv cltrr
      wbr wb cA cr wss vz cv cA wcel wa vy cv cr wcel vz cv cr wcel vy cv vz cv
      clt wbr vy cv vz cv cltrr wbr wb vy cv vz cv ltxrlt ancoms cA cr vz cv
      ssel2 sylan an1rs rexbidva adantlr imbi12d ralbidva anbi12d rexbidva
      adantr 3imtr4d 3impia $.
      $( [14-Oct-2005] $) $( [13-Oct-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordering on reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Alias for ~ axlttrn , for naming consistency with ~ lttri . $)
  lttr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A < B /\ B < C ) -> A < C ) ) $=
    cA cB cC axlttrn $.
    $( [10-Mar-2008] $) $( [10-Mar-2008] $)

  $( The product of two positive numbers is positive. $)
  mulgt0 $p |- ( ( ( A e. RR /\ 0 < A ) /\
                ( B e. RR /\ 0 < B ) ) -> 0 < ( A x. B ) ) $=
    cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB cmul co clt
    wbr cA cr wcel cB cr wcel wa cc0 cA clt wbr cc0 cB clt wbr wa cc0 cA cB
    cmul co clt wbr cA cB axmulgt0 imp an4s $.
    $( [12-Jun-2009] $) $( [10-Mar-2008] $)

  $( 'Less than or equal to' expressed in terms of 'less than'. $)
  lenlt $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B <-> -. B < A ) ) $=
    cA cxr wcel cB cxr wcel cA cB cle wbr cB cA clt wbr wn wb cA cr wcel cB cr
    wcel cA cB xrlenlt cA rexr cB rexr syl2an $.
    $( [15-Oct-2005] $) $( [13-May-1999] $)

  $( 'Less than' expressed in terms of 'less than or equal to'. $)
  ltnle $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> -. B <_ A ) ) $=
    cA cr wcel cB cr wcel wa cB cA cle wbr cA cB clt wbr cB cr wcel cA cr wcel
    cB cA cle wbr cA cB clt wbr wn wb cB cA lenlt ancoms con2bid $.
    $( [12-Jul-2005] $) $( [11-Jul-2005] $)

  ${
    $d x y z $.
    $( 'Less than' is a strict ordering.  Note: do not shorten this with
       ~ ltsor , and do not use ~ ltsor in complex number proofs, in order
       to maintain a portable derivation of all complex number proofs directly
       from postulates. $)
    ltso $p |- < Or RR $=
      vx vy vz cr clt vx cv cr wcel vy cv cr wcel vz cv cr wcel w3a vx cv vy cv
      clt wbr vx cv vy cv wceq vy cv vx cv clt wbr wo wn wb vx cv vy cv clt wbr
      vy cv vz cv clt wbr wa vx cv vz cv clt wbr wi vx cv cr wcel vy cv cr wcel
      vx cv vy cv clt wbr vx cv vy cv wceq vy cv vx cv clt wbr wo wn wb vz cv
      cr wcel vx cv vy cv axlttri 3adant3 vx cv vy cv vz cv axlttrn jca so $.
      $( [19-Jan-1997] $)
  $}

  $( Consequence of trichotomy. $)
  lttri2 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A =/= B <-> ( A < B \/ B < A ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB clt wbr cB cA clt wbr wo cA cB cA cr wcel cB
    cr wcel wa cA cB wceq cA cB clt wbr cB cA clt wbr wo wn cr clt wor cA cr
    wcel cB cr wcel wa cA cB wceq cA cB clt wbr cB cA clt wbr wo wn wb ltso cr
    cA cB clt sotrieq mpan bicomd necon1abid $.
    $( [22-Aug-2007] $) $( [9-Oct-1999] $)

  $( Trichotomy law for 'less than'. $)
  lttri3 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A = B <-> ( -. A < B /\ -. B < A ) ) ) $=
    cr clt wor cA cr wcel cB cr wcel wa cA cB wceq cA cB clt wbr wn cB cA clt
    wbr wn wa wb ltso cr cA cB clt sotrieq2 mpan $.
    $( [5-May-1999] $)

  $( Trichotomy law for 'less than'. $)
  lttri4 $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B \/ A = B \/ B < A ) ) $=
    cA cr wcel cB cr wcel wa cA cB wceq cB cA clt wbr wo cA cB clt wbr wo cA cB
    clt wbr cA cB wceq cB cA clt wbr w3o cA cr wcel cB cr wcel wa cA cB wceq cB
    cA clt wbr wo cA cB clt wbr cA cr wcel cB cr wcel wa cA cB clt wbr cA cB
    wceq cB cA clt wbr wo wn cA cB axlttri biimprd orrd cA cB clt wbr cA cB
    wceq cB cA clt wbr w3o cA cB wceq cB cA clt wbr cA cB clt wbr w3o cA cB
    wceq cB cA clt wbr wo cA cB clt wbr wo cA cB clt wbr cA cB wceq cB cA clt
    wbr 3orrot cA cB wceq cB cA clt wbr cA cB clt wbr df-3or bitr2i sylib $.
    $( [21-Jan-2008] $) $( [20-Sep-2007] $)

  $( 'Less than' implies not equal. $)
  ltne $p |- ( ( A e. RR /\ B e. RR /\ A < B ) -> B =/= A ) $=
    cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cA cr wcel cB cr wcel cA cB
    clt wbr cA cB wne cA cr wcel cB cr wcel wa cA cB wne cA cB clt wbr cB cA
    clt wbr wo cA cB clt wbr cA cB lttri2 cA cB clt wbr cB cA clt wbr orc
    syl5bir 3impia necomd $.
    $( [6-Aug-2007] $) $( [9-Oct-1999] $)

  $( Trichotomy law. $)
  letri3 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A = B <-> ( A <_ B /\ B <_ A ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB wceq cB cA clt wbr wn cA cB clt wbr wn wa cA
    cB cle wbr cB cA cle wbr wa cA cr wcel cB cr wcel wa cA cB wceq cA cB clt
    wbr wn cB cA clt wbr wn wa cB cA clt wbr wn cA cB clt wbr wn wa cA cB
    lttri3 cB cA clt wbr wn cA cB clt wbr wn ancom syl6bbr cA cr wcel cB cr
    wcel wa cA cB cle wbr cB cA clt wbr wn cB cA cle wbr cA cB clt wbr wn cA cB
    lenlt cB cr wcel cA cr wcel cB cA cle wbr cA cB clt wbr wn wb cB cA lenlt
    ancoms anbi12d bitr4d $.
    $( [14-May-1999] $)

  $( 'Less than or equal to' expressed in terms of 'less than' or 'equals'. $)
  leloe $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A <_ B <-> ( A < B \/ A = B ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB cle wbr cB cA clt wbr wn cA cB clt wbr cA cB
    wceq wo cA cB lenlt cA cr wcel cB cr wcel wa cB cA wceq cA cB clt wbr wo cB
    cA clt wbr wn cA cB clt wbr cA cB wceq wo cA cr wcel cB cr wcel wa cB cA
    clt wbr cB cA wceq cA cB clt wbr wo cB cr wcel cA cr wcel cB cA clt wbr cB
    cA wceq cA cB clt wbr wo wn wb cB cA axlttri ancoms con2bid cB cA wceq cA
    cB clt wbr wo cA cB wceq cA cB clt wbr wo cA cB clt wbr cA cB wceq wo cB cA
    wceq cA cB wceq cA cB clt wbr cB cA eqcom orbi1i cA cB wceq cA cB clt wbr
    orcom bitri syl5rbbr bitrd $.
    $( [13-May-1999] $)

  $( Equality in terms of 'less than or equal to', 'less than'. $)
  eqlelt $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A = B <-> ( A <_ B /\ -. A < B ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB wceq cA cB cle wbr cB cA cle wbr wa cA cB
    cle wbr cA cB clt wbr wn wa cA cB letri3 cA cr wcel cB cr wcel wa cB cA cle
    wbr cA cB clt wbr wn cA cB cle wbr cB cr wcel cA cr wcel cB cA cle wbr cA
    cB clt wbr wn wb cB cA lenlt ancoms anbi2d bitrd $.
    $( [7-Apr-2001] $)

  $( 'Less than' implies 'less than or equal to'. $)
  ltle $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A < B -> A <_ B ) ) $=
    cA cr wcel cB cr wcel wa cA cB cle wbr cA cB clt wbr cA cB wceq wo cA cB
    clt wbr cA cB leloe cA cB clt wbr cA cB wceq orc syl5bir $.
    $( [25-Aug-1999] $)

  $( 'Less than or equal to' implies 'less than' is not 'equals'. $)
  leltne $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                ( A < B <-> B =/= A ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr cA cB clt wbr cB cA wne wb cA cr wcel
    cB cr wcel wa cA cB cle wbr wa cA cB clt wbr cA cB wne cB cA wne cA cr wcel
    cB cr wcel wa cA cB cle wbr wa cA cB clt wbr cA cB cA cr wcel cB cr wcel wa
    cA cB cle wbr wa cA cB wceq cA cB clt wbr wn cA cr wcel cB cr wcel wa cA cB
    wceq cA cB clt wbr wn wi cA cB cle wbr cA cr wcel cB cr wcel wa cA cB wceq
    cA cB clt wbr wn cB cA clt wbr wn wa cA cB clt wbr wn cA cB lttri3 cA cB
    clt wbr wn cB cA clt wbr wn pm3.26 syl6bi adantr cA cr wcel cB cr wcel wa
    cA cB cle wbr wa cA cB clt wbr cA cB wceq cA cr wcel cB cr wcel wa cA cB
    cle wbr cA cB clt wbr cA cB wceq wo cA cB leloe biimpa ord impbid
    necon2abid cB cA necom syl6bbr 3impa $.
    $( [18-Jul-2007] $) $( [27-Jul-1999] $)

  $( 'Less than' expressed in terms of 'less than or equal to'. $)
  ltlen $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A < B <-> ( A <_ B /\ B =/= A ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB clt wbr cA cB cle wbr cB cA wne wa cA cr
    wcel cB cr wcel wa cA cB clt wbr cA cB cle wbr cB cA wne cA cB ltle cA cr
    wcel cB cr wcel cA cB clt wbr cB cA wne cA cB ltne 3expia jcad cA cr wcel
    cB cr wcel wa cA cB cle wbr cB cA wne cA cB clt wbr cA cr wcel cB cr wcel
    wa cA cB cle wbr cA cB clt wbr cA cB wceq wo cB cA wne cA cB clt wbr wi cA
    cB leloe cA cB clt wbr cB cA wne cA cB clt wbr wi cA cB wceq cA cB clt wbr
    cB cA wne ax-1 cA cB wceq cB cA wceq wn cA cB clt wbr cB cA wne cB cA wceq
    wn cA cB clt wbr wi cB cA cB cA wceq cA cB clt wbr pm2.24 eqcoms cB cA
    df-ne syl5ib jaoi syl6bi imp3a impbid $.
    $( [7-Aug-2007] $) $( [27-Oct-1999] $)

  $( Transitive law. $)
  lelttr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A <_ B /\ B < C ) -> A < C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cC clt wbr cA cC clt
    wbr cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cA cB clt wbr cA cB
    wceq wo cB cC clt wbr cA cC clt wbr wi cA cr wcel cB cr wcel cA cB cle wbr
    cA cB clt wbr cA cB wceq wo wb cC cr wcel cA cB leloe 3adant3 cA cr wcel cB
    cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr cA cC clt wbr wi cA cB
    wceq cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr cA cC
    clt wbr cA cB cC axlttrn exp3a cA cB wceq cB cC clt wbr cA cC clt wbr wi wi
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB wceq cA cC clt wbr cB cC clt wbr
    cA cB cC clt breq1 biimprd a1i jaod sylbid imp3a $.
    $( [23-May-1999] $)

  $( Transitive law. $)
  ltletr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A < B /\ B <_ C ) -> A < C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC cle wbr cA cC clt
    wbr cA cr wcel cB cr wcel cC cr wcel w3a cB cC cle wbr cA cB clt wbr cA cC
    clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cB cC cle wbr cB cC clt wbr cB
    cC wceq wo cA cB clt wbr cA cC clt wbr wi cB cr wcel cC cr wcel cB cC cle
    wbr cB cC clt wbr cB cC wceq wo wb cA cr wcel cB cC leloe 3adant1 cA cr
    wcel cB cr wcel cC cr wcel w3a cB cC clt wbr cA cB clt wbr cA cC clt wbr wi
    cB cC wceq cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr
    cA cC clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt
    wbr cA cC clt wbr cA cB cC axlttrn exp3a com23 cB cC wceq cA cB clt wbr cA
    cC clt wbr wi wi cA cr wcel cB cr wcel cC cr wcel w3a cB cC wceq cA cB clt
    wbr cA cC clt wbr cB cC cA clt breq2 biimpd a1i jaod sylbid com23 imp3a $.
    $( [25-Aug-1999] $)

  $( Transitive law. $)
  letr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A <_ B /\ B <_ C ) -> A <_ C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cC cle wbr cA cC cle
    wbr cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr wa cB cC cle wbr cB
    cC clt wbr cB cC wceq wo cA cC cle wbr cA cr wcel cB cr wcel cC cr wcel w3a
    cB cC cle wbr cB cC clt wbr cB cC wceq wo wb cA cB cle wbr cB cr wcel cC cr
    wcel cB cC cle wbr cB cC clt wbr cB cC wceq wo wb cA cr wcel cB cC leloe
    3adant1 adantr cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr wa cB cC
    clt wbr cA cC cle wbr cB cC wceq cA cr wcel cB cr wcel cC cr wcel w3a cA cB
    cle wbr cB cC clt wbr cA cC cle wbr cA cr wcel cB cr wcel cC cr wcel w3a cA
    cB cle wbr cB cC clt wbr wa cA cC clt wbr cA cC cle wbr cA cB cC lelttr cA
    cr wcel cC cr wcel cA cC clt wbr cA cC cle wbr wi cB cr wcel cA cC ltle
    3adant2 syld expdimp cA cB cle wbr cB cC wceq cA cC cle wbr wi cA cr wcel
    cB cr wcel cC cr wcel w3a cB cC wceq cA cB cle wbr cA cC cle wbr cB cC cA
    cle breq2 biimpcd adantl jaod sylbid expimpd $.
    $( [12-Nov-1999] $)

  ${
    letrd.1 $e |- ( ph -> A e. RR ) $.
    letrd.2 $e |- ( ph -> B e. RR ) $.
    letrd.3 $e |- ( ph -> C e. RR ) $.
    ${
      letrd.4 $e |- ( ph -> A <_ B ) $.
      letrd.5 $e |- ( ph -> B <_ C ) $.
      $( Transitive law deduction for 'less than or equal to'. $)
      letrd $p |- ( ph -> A <_ C ) $=
        wph cA cB cle wbr cB cC cle wbr cA cC cle wbr letrd.4 letrd.5 cA cr
        wcel cB cr wcel cC cr wcel cA cB cle wbr cB cC cle wbr wa cA cC cle wbr
        wi wph cA cB cC letr letrd.1 letrd.2 letrd.3 syl3anc mp2and $.
        $( [22-May-2005] $) $( [20-May-2005] $)
    $}

    ${
      lelttrd.4 $e |- ( ph -> A <_ B ) $.
      lelttrd.5 $e |- ( ph -> B < C ) $.
      $( Transitive law deduction for 'less than or equal to', 'less than'. $)
      lelttrd $p |- ( ph -> A < C ) $=
        wph cA cB cle wbr cB cC clt wbr cA cC clt wbr lelttrd.4 lelttrd.5 cA cr
        wcel cB cr wcel cC cr wcel cA cB cle wbr cB cC clt wbr wa cA cC clt wbr
        wi wph cA cB cC lelttr letrd.1 letrd.2 letrd.3 syl3anc mp2and $.
        $( [23-Jan-2006] $) $( [8-Jan-2006] $)
    $}

    ${
      ltletrd.4 $e |- ( ph -> A < B ) $.
      ltletrd.5 $e |- ( ph -> B <_ C ) $.
      $( Transitive law deduction for 'less than', 'less than or equal to'. $)
      ltletrd $p |- ( ph -> A < C ) $=
        wph cA cB clt wbr cB cC cle wbr cA cC clt wbr ltletrd.4 ltletrd.5 cA cr
        wcel cB cr wcel cC cr wcel cA cB clt wbr cB cC cle wbr wa cA cC clt wbr
        wi wph cA cB cC ltletr letrd.1 letrd.2 letrd.3 syl3anc mp2and $.
        $( [11-Jan-2006] $) $( [9-Jan-2006] $)
    $}

    ${
      lttrd.4 $e |- ( ph -> A < B ) $.
      lttrd.5 $e |- ( ph -> B < C ) $.
      $( Transitive law deduction for 'less than'. $)
      lttrd $p |- ( ph -> A < C ) $=
        wph cA cB clt wbr cB cC clt wbr cA cC clt wbr lttrd.4 lttrd.5 cA cr
        wcel cB cr wcel cC cr wcel cA cB clt wbr cB cC clt wbr wa cA cC clt wbr
        wi wph cA cB cC axlttrn letrd.1 letrd.2 letrd.3 syl3anc mp2and $.
        $( [1-Feb-2006] $) $( [9-Jan-2006] $)
    $}
  $}

  $( 'Less than' is irreflexive. $)
  ltnr $p |- ( A e. RR -> -. A < A ) $=
    cr clt wor cA cr wcel cA cA clt wbr wn ltso cr cA clt sonr mpan $.
    $( [18-Aug-1999] $)

  $( 'Less than or equal to' is reflexive. $)
  leid $p |- ( A e. RR -> A <_ A ) $=
    cA cr wcel cA cA cle wbr cA cr wcel cA cr wcel wa cA cA cle wbr cA cA clt
    wbr cA cA wceq wo cA cA wceq cA cA clt wbr cA eqid olci cA cA leloe mpbiri
    anidms $.
    $( [18-Aug-1999] $)

  $( 'Less than' is not symmetric. $)
  ltnsym $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B -> -. B < A ) ) $=
    cA cr wcel cB cr wcel wa cA cB clt wbr cA cB wceq cB cA clt wbr wo wn cB cA
    clt wbr wn cA cB axlttri cA cB wceq cB cA clt wbr pm2.46 syl6bi $.
    $( [8-Jan-2002] $)

  $( 'Less than' is antisymmetric and irreflexive. $)
  ltnsym2 $p |- ( ( A e. RR /\ B e. RR ) -> -. ( A < B /\ B < A ) ) $=
    cA cr wcel cB cr wcel wa cA cB clt wbr cB cA clt wbr wn wi cA cB clt wbr cB
    cA clt wbr wa wn cA cB ltnsym cA cB clt wbr cB cA clt wbr imnan sylib $.
    $( [15-Aug-2005] $) $( [13-Aug-2005] $)

  ${
    pm2.61ltle.1 $e |- ( ( ph /\ A < B ) -> ps ) $.
    pm2.61ltle.2 $e |- ( ( ph /\ B <_ A ) -> ps ) $.
    pm2.61ltle.3 $e |- ( ph -> A e. RR ) $.
    pm2.61ltle.4 $e |- ( ph -> B e. RR ) $.
    $( Ordering elimination by cases. $)
    pm2.61ltlei $p |- ( ph -> ps ) $=
      wph cA cB clt wbr wps pm2.61ltle.1 wph cA cB clt wbr wn cB cA cle wbr wps
      wph cB cA cle wbr cA cB clt wbr wn cB cr wcel cA cr wcel cB cA cle wbr cA
      cB clt wbr wn wb wph cB cA lenlt pm2.61ltle.4 pm2.61ltle.3 sylanc biimpar
      pm2.61ltle.2 syldan pm2.61dan $.
      $( [4-Jul-2007] $) $( [1-Jul-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Ordering on the extended reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Membership in the set of extended reals. $)
  elxr $p |- ( A e. RR* <-> ( A e. RR \/ A = +oo \/ A = -oo ) ) $=
    cA cxr wcel cA cr cpnf cmnf cpr cun wcel cA cr wcel cA cpnf cmnf cpr wcel
    wo cA cr wcel cA cpnf wceq cA cmnf wceq w3o cxr cr cpnf cmnf cpr cun cA
    df-xr eleq2i cA cr cpnf cmnf cpr elun cA cr wcel cA cpnf cmnf cpr wcel wo
    cA cr wcel cA cpnf wceq cA cmnf wceq wo wo cA cr wcel cA cpnf wceq cA cmnf
    wceq w3o cA cpnf cmnf cpr wcel cA cpnf wceq cA cmnf wceq wo cA cr wcel cA
    cpnf cmnf cpnf cxr pnfxr elisseti cmnf cxr mnfxr elisseti elpr2 orbi2i cA
    cr wcel cA cpnf wceq cA cmnf wceq 3orass bitr4i 3bitri $.
    $( [17-Oct-2005] $) $( [14-Oct-2005] $)

  $( Plus and minus infinity are distinguished elements of ` RR* ` . $)
  pnfnemnf $p |- +oo =/= -oo $=
    cpnf cmnf wne cpnf cpnf cpw wne cpnf cpnf cpw wne cpnf cpw cpnf wne cpnf
    cxr wcel cpnf cpw cpnf wne pnfxr cpnf cxr pwne ax-mp cpnf cpnf cpw necom
    mpbir cmnf cpnf cpw cpnf df-mnf neeq2i mpbir $.
    $( [6-May-2008] $) $( [14-Oct-2005] $)

  $( No (finite) real equals plus infinity. $)
  renepnf $p |- ( A e. RR -> A =/= +oo ) $=
    cA cr wcel cA cpnf wceq wn cA cpnf wne cA cr wcel cpnf cr wcel wn cA cpnf
    wceq wn cpnf cr wnel cpnf cr wcel wn pnfnre cpnf cr df-nel mpbi cA cpnf cr
    nelneq mpan2 cA cpnf df-ne sylibr $.
    $( [16-Oct-2005] $) $( [14-Oct-2005] $)

  $( No real equals minus infinity. $)
  renemnf $p |- ( A e. RR -> A =/= -oo ) $=
    cA cr wcel cA cmnf wceq wn cA cmnf wne cA cr wcel cmnf cr wcel wn cA cmnf
    wceq wn cmnf cr wnel cmnf cr wcel wn mnfnre cmnf cr df-nel mpbi cA cmnf cr
    nelneq mpan2 cA cmnf df-ne sylibr $.
    $( [26-Oct-2005] $) $( [14-Oct-2005] $)

  $( The reals and the infinities are disjoint. $)
  renfdisj $p |- ( RR i^i { +oo , -oo } ) = (/) $=
    cr cpnf cmnf cpr cin cr cpnf csn cmnf csn cun cin c0 cpnf cmnf cpr cpnf csn
    cmnf csn cun cr cpnf cmnf df-pr ineq2i cr cpnf csn cin c0 wceq cr cmnf csn
    cin c0 wceq wa cr cpnf csn cmnf csn cun cin c0 wceq cr cpnf csn cin c0 wceq
    cr cmnf csn cin c0 wceq cr cpnf csn cin c0 wceq cpnf cr wcel wn cpnf cr
    wcel cpnf cpnf wceq cpnf eqid cpnf cr wcel cpnf cpnf wne cpnf cpnf wceq wn
    cpnf renepnf cpnf cpnf df-ne sylib mt2 cr cpnf disjsn mpbir cr cmnf csn cin
    c0 wceq cmnf cr wcel wn cmnf cr wcel cmnf cmnf wceq cmnf eqid cmnf cr wcel
    cmnf cmnf wne cmnf cmnf wceq wn cmnf renemnf cmnf cmnf df-ne sylib mt2 cr
    cmnf disjsn mpbir pm3.2i cr cpnf csn cmnf csn undisj2 mpbi eqtri $.
    $( [27-Oct-2005] $) $( [25-Oct-2005] $)

  ${
    $d x A $.
    $( The three (non-exclusive) possibilities implied by a subset of extended
       reals. $)
    ssxr $p |- ( A C_ RR* -> ( A C_ RR \/ +oo e. A \/ -oo e. A ) ) $=
      cA cxr wss cA cr wss cpnf cA wcel cmnf cA wcel wo wo cA cr wss cpnf cA
      wcel cmnf cA wcel w3o cA cxr wss cA cr wss cpnf cA wcel cmnf cA wcel wo
      cA cxr wss cA cr wss wn vx cv cpnf cmnf cpr wcel wn vx cA wral wn cpnf cA
      wcel cmnf cA wcel wo cA cxr wss vx cv cpnf cmnf cpr wcel wn vx cA wral cA
      cr wss cA cxr wss cA cpnf cmnf cpr cin c0 wceq cA cr wss vx cv cpnf cmnf
      cpr wcel wn vx cA wral cA cpnf cmnf cpr cin c0 wceq cA cxr wss cA cr wss
      cA cpnf cmnf cpr cin c0 wceq cA cpnf cmnf cpr cr cun wss cA cr wss cA cxr
      wss cA cpnf cmnf cpr cr disjssun cxr cpnf cmnf cpr cr cun cA cxr cr cpnf
      cmnf cpr cun cpnf cmnf cpr cr cun df-xr cr cpnf cmnf cpr uncom eqtri
      sseq2i syl5bb biimpcd vx cA cpnf cmnf cpr disj syl5ibr con3d vx cv cpnf
      cmnf cpr wcel wn vx cA wral wn vx cv cpnf wceq vx cv cmnf wceq wo vx cA
      wrex vx cv cpnf wceq vx cA wrex vx cv cmnf wceq vx cA wrex wo cpnf cA
      wcel cmnf cA wcel wo vx cv cpnf cmnf cpr wcel wn vx cA wral wn vx cv cpnf
      cmnf cpr wcel vx cA wrex vx cv cpnf wceq vx cv cmnf wceq wo vx cA wrex vx
      cv cpnf cmnf cpr wcel vx cA dfrex2 vx cv cpnf cmnf cpr wcel vx cv cpnf
      wceq vx cv cmnf wceq wo vx cA vx cv cpnf cmnf vx visset elpr rexbii
      bitr3i vx cv cpnf wceq vx cv cmnf wceq vx cA r19.43 vx cv cpnf wceq vx cA
      wrex cpnf cA wcel vx cv cmnf wceq vx cA wrex cmnf cA wcel vx cv cpnf wceq
      vx cA wrex vx cv cA wcel vx cv cpnf wceq wa vx wex vx cv cpnf wceq vx cv
      cA wcel wa vx wex cpnf cA wcel vx cv cpnf wceq vx cA df-rex vx cv cA wcel
      vx cv cpnf wceq vx exancom vx cv cA wcel cpnf cA wcel vx cpnf cpnf cxr
      pnfxr elisseti vx cv cpnf cA eleq1 ceqsexv 3bitri vx cv cmnf wceq vx cA
      wrex vx cv cA wcel vx cv cmnf wceq wa vx wex vx cv cmnf wceq vx cv cA
      wcel wa vx wex cmnf cA wcel vx cv cmnf wceq vx cA df-rex vx cv cA wcel vx
      cv cmnf wceq vx exancom vx cv cA wcel cmnf cA wcel vx cmnf cmnf cxr mnfxr
      elisseti vx cv cmnf cA eleq1 ceqsexv 3bitri orbi12i 3bitri syl6ib orrd cA
      cr wss cpnf cA wcel cmnf cA wcel 3orass sylibr $.
      $( [10-Nov-2005] $) $( [25-Oct-2005] $)
  $}

  $( The extended real 'less than' is irreflexive. $)
  xrltnr $p |- ( A e. RR* -> -. A < A ) $=
    cA cxr wcel cA cr wcel cA cpnf wceq cA cmnf wceq w3o cA cA clt wbr wn cA
    elxr cA cr wcel cA cA clt wbr wn cA cpnf wceq cA cmnf wceq cA ltnr cA cpnf
    wceq cA cA clt wbr cpnf cpnf clt wbr cpnf cpnf clt wbr cpnf cr wcel cpnf cr
    wcel wa cpnf cpnf cltrr wbr wa cpnf cmnf wceq cpnf cpnf wceq wa wo cpnf cr
    wcel cpnf cpnf wceq wa cpnf cmnf wceq cpnf cr wcel wa wo wo cpnf cr wcel
    cpnf cr wcel wa cpnf cpnf cltrr wbr wa cpnf cmnf wceq cpnf cpnf wceq wa wo
    cpnf cr wcel cpnf cpnf wceq wa cpnf cmnf wceq cpnf cr wcel wa wo cpnf cr
    wcel cpnf cr wcel wa cpnf cpnf cltrr wbr wa cpnf cmnf wceq cpnf cpnf wceq
    wa cpnf cr wcel cpnf cr wcel wa cpnf cpnf cltrr wbr cpnf cr wcel cpnf cr
    wcel cpnf cr wnel cpnf cr wcel wn pnfnre cpnf cr df-nel mpbi intnan intnanr
    cpnf cmnf wceq cpnf cpnf wceq cpnf cmnf wne cpnf cmnf wceq wn pnfnemnf cpnf
    cmnf df-ne mpbi intnanr pm3.2ni cpnf cr wcel cpnf cpnf wceq wa cpnf cmnf
    wceq cpnf cr wcel wa cpnf cr wcel cpnf cpnf wceq cpnf cr wnel cpnf cr wcel
    wn pnfnre cpnf cr df-nel mpbi intnanr cpnf cr wcel cpnf cmnf wceq cpnf cr
    wnel cpnf cr wcel wn pnfnre cpnf cr df-nel mpbi intnan pm3.2ni pm3.2ni cpnf
    cxr wcel cpnf cxr wcel cpnf cpnf clt wbr cpnf cr wcel cpnf cr wcel wa cpnf
    cpnf cltrr wbr wa cpnf cmnf wceq cpnf cpnf wceq wa wo cpnf cr wcel cpnf
    cpnf wceq wa cpnf cmnf wceq cpnf cr wcel wa wo wo wb pnfxr pnfxr cpnf cpnf
    ltxr mp2an mtbir cA cpnf wceq cA cA clt wbr cpnf cpnf clt wbr wb cA cpnf cA
    cpnf clt breq12 anidms mtbiri cA cmnf wceq cA cA clt wbr cmnf cmnf clt wbr
    cmnf cmnf clt wbr cmnf cr wcel cmnf cr wcel wa cmnf cmnf cltrr wbr wa cmnf
    cmnf wceq cmnf cpnf wceq wa wo cmnf cr wcel cmnf cpnf wceq wa cmnf cmnf
    wceq cmnf cr wcel wa wo wo cmnf cr wcel cmnf cr wcel wa cmnf cmnf cltrr wbr
    wa cmnf cmnf wceq cmnf cpnf wceq wa wo cmnf cr wcel cmnf cpnf wceq wa cmnf
    cmnf wceq cmnf cr wcel wa wo cmnf cr wcel cmnf cr wcel wa cmnf cmnf cltrr
    wbr wa cmnf cmnf wceq cmnf cpnf wceq wa cmnf cr wcel cmnf cr wcel wa cmnf
    cmnf cltrr wbr cmnf cr wcel cmnf cr wcel cmnf cr wnel cmnf cr wcel wn
    mnfnre cmnf cr df-nel mpbi intnan intnanr cmnf cpnf wceq cmnf cmnf wceq
    cmnf cpnf wne cmnf cpnf wceq wn cpnf cmnf wne cmnf cpnf wne pnfnemnf cpnf
    cmnf necom mpbi cmnf cpnf df-ne mpbi intnan pm3.2ni cmnf cr wcel cmnf cpnf
    wceq wa cmnf cmnf wceq cmnf cr wcel wa cmnf cr wcel cmnf cpnf wceq cmnf cr
    wnel cmnf cr wcel wn mnfnre cmnf cr df-nel mpbi intnanr cmnf cr wcel cmnf
    cmnf wceq cmnf cr wnel cmnf cr wcel wn mnfnre cmnf cr df-nel mpbi intnan
    pm3.2ni pm3.2ni cmnf cxr wcel cmnf cxr wcel cmnf cmnf clt wbr cmnf cr wcel
    cmnf cr wcel wa cmnf cmnf cltrr wbr wa cmnf cmnf wceq cmnf cpnf wceq wa wo
    cmnf cr wcel cmnf cpnf wceq wa cmnf cmnf wceq cmnf cr wcel wa wo wo wb
    mnfxr mnfxr cmnf cmnf ltxr mp2an mtbir cA cmnf wceq cA cA clt wbr cmnf cmnf
    clt wbr wb cA cmnf cA cmnf clt breq12 anidms mtbiri 3jaoi sylbi $.
    $( [18-Oct-2005] $) $( [14-Oct-2005] $)

  $( Any (finite) real is less than plus infinity. $)
  ltpnf $p |- ( A e. RR -> A < +oo ) $=
    cA cr wcel cA cpnf clt wbr cA cr wcel cpnf cr wcel wa cA cpnf cltrr wbr wa
    cA cmnf wceq cpnf cpnf wceq wa wo cA cr wcel cpnf cpnf wceq wa cA cmnf wceq
    cpnf cr wcel wa wo wo cA cr wcel cA cr wcel cpnf cpnf wceq wa cA cr wcel
    cpnf cpnf wceq wa cA cmnf wceq cpnf cr wcel wa wo cA cr wcel cpnf cr wcel
    wa cA cpnf cltrr wbr wa cA cmnf wceq cpnf cpnf wceq wa wo cA cr wcel cpnf
    cpnf wceq wa cA cmnf wceq cpnf cr wcel wa wo wo cA cr wcel cpnf cpnf wceq
    cpnf eqid jctr cA cr wcel cpnf cpnf wceq wa cA cmnf wceq cpnf cr wcel wa
    orc cA cr wcel cpnf cpnf wceq wa cA cmnf wceq cpnf cr wcel wa wo cA cr wcel
    cpnf cr wcel wa cA cpnf cltrr wbr wa cA cmnf wceq cpnf cpnf wceq wa wo olc
    3syl cA cxr wcel cpnf cxr wcel cA cpnf clt wbr cA cr wcel cpnf cr wcel wa
    cA cpnf cltrr wbr wa cA cmnf wceq cpnf cpnf wceq wa wo cA cr wcel cpnf cpnf
    wceq wa cA cmnf wceq cpnf cr wcel wa wo wo wb cA cr wcel cA cpnf ltxr cA
    rexr pnfxr sylancl mpbird $.
    $( [19-Oct-2005] $) $( [14-Oct-2005] $)

  $( Minus infinity is less than any (finite) real. $)
  mnflt $p |- ( A e. RR -> -oo < A ) $=
    cA cr wcel cmnf cA clt wbr cmnf cr wcel cA cr wcel wa cmnf cA cltrr wbr wa
    cmnf cmnf wceq cA cpnf wceq wa wo cmnf cr wcel cA cpnf wceq wa cmnf cmnf
    wceq cA cr wcel wa wo wo cA cr wcel cmnf cmnf wceq cA cr wcel wa cmnf cr
    wcel cA cpnf wceq wa cmnf cmnf wceq cA cr wcel wa wo cmnf cr wcel cA cr
    wcel wa cmnf cA cltrr wbr wa cmnf cmnf wceq cA cpnf wceq wa wo cmnf cr wcel
    cA cpnf wceq wa cmnf cmnf wceq cA cr wcel wa wo wo cA cr wcel cmnf cmnf
    wceq cmnf eqid jctl cmnf cmnf wceq cA cr wcel wa cmnf cr wcel cA cpnf wceq
    wa olc cmnf cr wcel cA cpnf wceq wa cmnf cmnf wceq cA cr wcel wa wo cmnf cr
    wcel cA cr wcel wa cmnf cA cltrr wbr wa cmnf cmnf wceq cA cpnf wceq wa wo
    olc 3syl cmnf cxr wcel cA cxr wcel cmnf cA clt wbr cmnf cr wcel cA cr wcel
    wa cmnf cA cltrr wbr wa cmnf cmnf wceq cA cpnf wceq wa wo cmnf cr wcel cA
    cpnf wceq wa cmnf cmnf wceq cA cr wcel wa wo wo wb cA cr wcel cmnf cA ltxr
    mnfxr cA rexr sylancr mpbird $.
    $( [17-Oct-2005] $) $( [14-Oct-2005] $)

  $( Minus infinity is less than plus infinity. $)
  mnfltpnf $p |- -oo < +oo $=
    cmnf cpnf clt wbr cmnf cr wcel cpnf cr wcel wa cmnf cpnf cltrr wbr wa cmnf
    cmnf wceq cpnf cpnf wceq wa wo cmnf cr wcel cpnf cpnf wceq wa cmnf cmnf
    wceq cpnf cr wcel wa wo wo cmnf cr wcel cpnf cr wcel wa cmnf cpnf cltrr wbr
    wa cmnf cmnf wceq cpnf cpnf wceq wa wo cmnf cr wcel cpnf cpnf wceq wa cmnf
    cmnf wceq cpnf cr wcel wa wo cmnf cmnf wceq cpnf cpnf wceq cmnf cr wcel
    cpnf cr wcel wa cmnf cpnf cltrr wbr wa cmnf cmnf wceq cpnf cpnf wceq wa wo
    cmnf eqid cpnf eqid cmnf cmnf wceq cpnf cpnf wceq wa cmnf cr wcel cpnf cr
    wcel wa cmnf cpnf cltrr wbr wa olc mp2an orci cmnf cxr wcel cpnf cxr wcel
    cmnf cpnf clt wbr cmnf cr wcel cpnf cr wcel wa cmnf cpnf cltrr wbr wa cmnf
    cmnf wceq cpnf cpnf wceq wa wo cmnf cr wcel cpnf cpnf wceq wa cmnf cmnf
    wceq cpnf cr wcel wa wo wo wb mnfxr pnfxr cmnf cpnf ltxr mp2an mpbir $.
    $( [19-Oct-2005] $) $( [14-Oct-2005] $)

  $( Minus infinity is less than an extended real that is either real or plus
     infinity. $)
  mnfltxr $p |- ( ( A e. RR \/ A = +oo ) -> -oo < A ) $=
    cA cr wcel cmnf cA clt wbr cA cpnf wceq cA mnflt cA cpnf wceq cmnf cA clt
    wbr cmnf cpnf clt wbr mnfltpnf cA cpnf cmnf clt breq2 mpbiri jaoi $.
    $( [26-Feb-2006] $) $( [2-Feb-2006] $)

  $( No extended real is greater than plus infinity. $)
  pnfnlt $p |- ( A e. RR* -> -. +oo < A ) $=
    cA cxr wcel cpnf cA clt wbr cpnf cr wcel cA cr wcel wa cpnf cA cltrr wbr wa
    cpnf cmnf wceq cA cpnf wceq wa wo cpnf cr wcel cA cpnf wceq wa cpnf cmnf
    wceq cA cr wcel wa wo wo cpnf cr wcel cA cr wcel wa cpnf cA cltrr wbr wa
    cpnf cmnf wceq cA cpnf wceq wa wo cpnf cr wcel cA cpnf wceq wa cpnf cmnf
    wceq cA cr wcel wa wo cpnf cr wcel cA cr wcel wa cpnf cA cltrr wbr wa cpnf
    cmnf wceq cA cpnf wceq wa cpnf cr wcel cA cr wcel wa cpnf cA cltrr wbr cpnf
    cr wcel cA cr wcel cpnf cr wnel cpnf cr wcel wn pnfnre cpnf cr df-nel mpbi
    intnanr intnanr cpnf cmnf wceq cA cpnf wceq cpnf cmnf wne cpnf cmnf wceq wn
    pnfnemnf cpnf cmnf df-ne mpbi intnanr pm3.2ni cpnf cr wcel cA cpnf wceq wa
    cpnf cmnf wceq cA cr wcel wa cpnf cr wcel cA cpnf wceq cpnf cr wnel cpnf cr
    wcel wn pnfnre cpnf cr df-nel mpbi intnanr cpnf cmnf wceq cA cr wcel cpnf
    cmnf wne cpnf cmnf wceq wn pnfnemnf cpnf cmnf df-ne mpbi intnanr pm3.2ni
    pm3.2ni cpnf cxr wcel cA cxr wcel cpnf cA clt wbr cpnf cr wcel cA cr wcel
    wa cpnf cA cltrr wbr wa cpnf cmnf wceq cA cpnf wceq wa wo cpnf cr wcel cA
    cpnf wceq wa cpnf cmnf wceq cA cr wcel wa wo wo wb pnfxr cpnf cA ltxr mpan
    mtbiri $.
    $( [19-Oct-2005] $) $( [15-Oct-2005] $)

  $( No extended real is less than minus infinity. $)
  nltmnf $p |- ( A e. RR* -> -. A < -oo ) $=
    cA cxr wcel cA cmnf clt wbr cA cr wcel cmnf cr wcel wa cA cmnf cltrr wbr wa
    cA cmnf wceq cmnf cpnf wceq wa wo cA cr wcel cmnf cpnf wceq wa cA cmnf wceq
    cmnf cr wcel wa wo wo cA cr wcel cmnf cr wcel wa cA cmnf cltrr wbr wa cA
    cmnf wceq cmnf cpnf wceq wa wo cA cr wcel cmnf cpnf wceq wa cA cmnf wceq
    cmnf cr wcel wa wo cA cr wcel cmnf cr wcel wa cA cmnf cltrr wbr wa cA cmnf
    wceq cmnf cpnf wceq wa cA cr wcel cmnf cr wcel wa cA cmnf cltrr wbr cmnf cr
    wcel cA cr wcel cmnf cr wnel cmnf cr wcel wn mnfnre cmnf cr df-nel mpbi
    intnan intnanr cmnf cpnf wceq cA cmnf wceq cmnf cpnf wne cmnf cpnf wceq wn
    cpnf cmnf wne cmnf cpnf wne pnfnemnf cpnf cmnf necom mpbi cmnf cpnf df-ne
    mpbi intnan pm3.2ni cA cr wcel cmnf cpnf wceq wa cA cmnf wceq cmnf cr wcel
    wa cmnf cpnf wceq cA cr wcel cmnf cpnf wne cmnf cpnf wceq wn cpnf cmnf wne
    cmnf cpnf wne pnfnemnf cpnf cmnf necom mpbi cmnf cpnf df-ne mpbi intnan
    cmnf cr wcel cA cmnf wceq cmnf cr wnel cmnf cr wcel wn mnfnre cmnf cr
    df-nel mpbi intnan pm3.2ni pm3.2ni cA cxr wcel cmnf cxr wcel cA cmnf clt
    wbr cA cr wcel cmnf cr wcel wa cA cmnf cltrr wbr wa cA cmnf wceq cmnf cpnf
    wceq wa wo cA cr wcel cmnf cpnf wceq wa cA cmnf wceq cmnf cr wcel wa wo wo
    wb mnfxr cA cmnf ltxr mpan2 mtbiri $.
    $( [20-Oct-2005] $) $( [15-Oct-2005] $)

  $( Plus infinity is an upper bound for extended reals. $)
  pnfge $p |- ( A e. RR* -> A <_ +oo ) $=
    cA cxr wcel cA cpnf cle wbr cpnf cA clt wbr wn cA pnfnlt cA cxr wcel cpnf
    cxr wcel cA cpnf cle wbr cpnf cA clt wbr wn wb pnfxr cA cpnf xrlenlt mpan2
    mpbird $.
    $( [18-Feb-2006] $) $( [30-Jan-2006] $)

  $( Minus infinity is less than or equal to any extended real. $)
  mnfle $p |- ( A e. RR* -> -oo <_ A ) $=
    cA cxr wcel cmnf cA cle wbr cA cmnf clt wbr wn cA nltmnf cmnf cxr wcel cA
    cxr wcel cmnf cA cle wbr cA cmnf clt wbr wn wb mnfxr cmnf cA xrlenlt mpan
    mpbird $.
    $( [25-Jan-2006] $) $( [19-Jan-2006] $)

  $( Ordering on the extended reals is not symmetric. $)
  xrltnsym $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A < B -> -. B < A ) ) $=
    cA cr wcel cA cpnf wceq cA cmnf wceq w3o cB cr wcel cB cpnf wceq cB cmnf
    wceq w3o cA cB clt wbr cB cA clt wbr wn wi cA cxr wcel cB cxr wcel cA cr
    wcel cB cr wcel cB cpnf wceq cB cmnf wceq w3o cA cB clt wbr cB cA clt wbr
    wn wi cA cpnf wceq cA cmnf wceq cA cr wcel cB cr wcel cA cB clt wbr cB cA
    clt wbr wn wi cB cpnf wceq cB cmnf wceq cA cB ltnsym cA cr wcel cB cpnf
    wceq wa cB cA clt wbr wn cA cB clt wbr cA cr wcel cB cpnf wceq wa cB cA clt
    wbr cpnf cA clt wbr cA cr wcel cpnf cA clt wbr wn cB cpnf wceq cA cr wcel
    cA cxr wcel cpnf cA clt wbr wn cA rexr cA pnfnlt syl adantr cB cpnf wceq cB
    cA clt wbr cpnf cA clt wbr wb cA cr wcel cB cpnf cA clt breq1 adantl mtbird
    a1d cA cr wcel cB cmnf wceq wa cA cB clt wbr cB cA clt wbr wn cA cr wcel cB
    cmnf wceq wa cA cB clt wbr cA cmnf clt wbr cA cr wcel cA cmnf clt wbr wn cB
    cmnf wceq cA cr wcel cA cxr wcel cA cmnf clt wbr wn cA rexr cA nltmnf syl
    adantr cB cmnf wceq cA cB clt wbr cA cmnf clt wbr wb cA cr wcel cB cmnf cA
    clt breq2 adantl mtbird pm2.21d 3jaodan cA cpnf wceq cB cxr wcel cA cB clt
    wbr cB cA clt wbr wn wi cB cr wcel cB cpnf wceq cB cmnf wceq w3o cA cpnf
    wceq cB cxr wcel wa cA cB clt wbr cB cA clt wbr wn cA cpnf wceq cB cxr wcel
    wa cA cB clt wbr cpnf cB clt wbr cB cxr wcel cpnf cB clt wbr wn cA cpnf
    wceq cB pnfnlt adantl cA cpnf wceq cA cB clt wbr cpnf cB clt wbr wb cB cxr
    wcel cA cpnf cB clt breq1 adantr mtbird pm2.21d cB elxr sylan2br cA cmnf
    wceq cB cr wcel cA cB clt wbr cB cA clt wbr wn wi cB cpnf wceq cB cmnf wceq
    cA cmnf wceq cB cr wcel wa cB cA clt wbr wn cA cB clt wbr cA cmnf wceq cB
    cr wcel wa cB cA clt wbr cB cmnf clt wbr cB cr wcel cB cmnf clt wbr wn cA
    cmnf wceq cB cr wcel cB cxr wcel cB cmnf clt wbr wn cB rexr cB nltmnf syl
    adantl cA cmnf wceq cB cA clt wbr cB cmnf clt wbr wb cB cr wcel cA cmnf cB
    clt breq2 adantr mtbird a1d cA cmnf wceq cB cpnf wceq wa cB cA clt wbr wn
    cA cB clt wbr cB cpnf wceq cA cmnf wceq cB cA clt wbr wn cB cpnf wceq cA
    cmnf wceq wa cB cA clt wbr cpnf cmnf clt wbr cmnf cxr wcel cpnf cmnf clt
    wbr wn mnfxr cmnf pnfnlt ax-mp cB cpnf cA cmnf clt breq12 mtbiri ancoms a1d
    cA cmnf wceq cB cmnf wceq wa cA cB clt wbr cB cA clt wbr wn cA cmnf wceq cB
    cmnf wceq wa cA cB clt wbr cmnf cmnf clt wbr cmnf cxr wcel cmnf cmnf clt
    wbr wn mnfxr cmnf xrltnr ax-mp cA cmnf cB cmnf clt breq12 mtbiri pm2.21d
    3jaodan 3jaoian cA elxr cB elxr syl2anb $.
    $( [21-Oct-2005] $) $( [15-Oct-2005] $)

  $( 'Less than' is antisymmetric and irreflexive for extended reals. $)
  xrltnsym2 $p |- ( ( A e. RR* /\ B e. RR* ) -> -. ( A < B /\ B < A ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB clt wbr cB cA clt wbr wn wi cA cB clt wbr
    cB cA clt wbr wa wn cA cB xrltnsym cA cB clt wbr cB cA clt wbr imnan sylib
    $.
    $( [8-Jun-2007] $) $( [6-Feb-2007] $)

  $( Ordering on the extended reals satisfies strict trichotomy. $)
  xrlttri $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A < B <-> -. ( A = B \/ B < A ) ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB wceq cB cA clt wbr wo cA cB clt wbr cA cxr
    wcel cB cxr wcel wa cA cB wceq cB cA clt wbr wo cA cB clt wbr wn cA cxr
    wcel cB cxr wcel wa cA cB wceq cA cB clt wbr wn cB cA clt wbr cA cxr wcel
    cA cB wceq cA cB clt wbr wn wi cB cxr wcel cA cxr wcel cA cB wceq cA cB clt
    wbr wn cA cxr wcel cA cB wceq wa cA cA clt wbr cA cB clt wbr cA cxr wcel cA
    cA clt wbr wn cA cB wceq cA xrltnr adantr cA cB wceq cA cA clt wbr cA cB
    clt wbr wb cA cxr wcel cA cB cA clt breq2 adantl mtbid ex adantr cB cxr
    wcel cA cxr wcel cB cA clt wbr cA cB clt wbr wn wi cB cA xrltnsym ancoms
    jaod cA cr wcel cA cpnf wceq cA cmnf wceq w3o cB cr wcel cB cpnf wceq cB
    cmnf wceq w3o cA cB clt wbr wn cA cB wceq cB cA clt wbr wo wi cA cxr wcel
    cB cxr wcel cA cr wcel cB cr wcel cB cpnf wceq cB cmnf wceq w3o cA cB clt
    wbr wn cA cB wceq cB cA clt wbr wo wi cA cpnf wceq cA cmnf wceq cA cr wcel
    cB cr wcel cA cB clt wbr wn cA cB wceq cB cA clt wbr wo wi cB cpnf wceq cB
    cmnf wceq cA cr wcel cB cr wcel wa cA cB wceq cB cA clt wbr wo cA cB clt
    wbr cA cr wcel cB cr wcel wa cA cB clt wbr cA cB wceq cB cA clt wbr wo wn
    cA cB axlttri biimprd con1d cA cr wcel cB cpnf wceq wa cA cB clt wbr cA cB
    wceq cB cA clt wbr wo cA cr wcel cB cpnf wceq wa cA cB clt wbr cA cpnf clt
    wbr cA cr wcel cA cpnf clt wbr cB cpnf wceq cA ltpnf adantr cB cpnf wceq cA
    cB clt wbr cA cpnf clt wbr wb cA cr wcel cB cpnf cA clt breq2 adantl mpbird
    pm2.24d cA cr wcel cB cmnf wceq wa cA cB wceq cB cA clt wbr wo cA cB clt
    wbr wn cA cr wcel cB cmnf wceq wa cB cA clt wbr cA cB wceq cA cr wcel cB
    cmnf wceq wa cB cA clt wbr cmnf cA clt wbr cA cr wcel cmnf cA clt wbr cB
    cmnf wceq cA mnflt adantr cB cmnf wceq cB cA clt wbr cmnf cA clt wbr wb cA
    cr wcel cB cmnf cA clt breq1 adantl mpbird olcd a1d 3jaodan cA cpnf wceq cB
    cr wcel cA cB clt wbr wn cA cB wceq cB cA clt wbr wo wi cB cpnf wceq cB
    cmnf wceq cA cpnf wceq cB cr wcel wa cA cB wceq cB cA clt wbr wo cA cB clt
    wbr wn cA cpnf wceq cB cr wcel wa cB cA clt wbr cA cB wceq cA cpnf wceq cB
    cr wcel wa cB cA clt wbr cB cpnf clt wbr cB cr wcel cB cpnf clt wbr cA cpnf
    wceq cB ltpnf adantl cA cpnf wceq cB cA clt wbr cB cpnf clt wbr wb cB cr
    wcel cA cpnf cB clt breq2 adantr mpbird olcd a1d cA cpnf wceq cB cpnf wceq
    wa cA cB wceq cB cA clt wbr wo cA cB clt wbr wn cA cpnf wceq cB cpnf wceq
    wa cA cB wceq cB cA clt wbr cA cB cpnf eqtr3 orcd a1d cA cpnf wceq cB cmnf
    wceq wa cA cB wceq cB cA clt wbr wo cA cB clt wbr wn cA cpnf wceq cB cmnf
    wceq wa cB cA clt wbr cA cB wceq cB cmnf wceq cA cpnf wceq cB cA clt wbr cB
    cmnf wceq cA cpnf wceq wa cB cA clt wbr cmnf cpnf clt wbr mnfltpnf cB cmnf
    cA cpnf clt breq12 mpbiri ancoms olcd a1d 3jaodan cA cmnf wceq cB cr wcel
    cA cB clt wbr wn cA cB wceq cB cA clt wbr wo wi cB cpnf wceq cB cmnf wceq
    cA cmnf wceq cB cr wcel wa cA cB clt wbr cA cB wceq cB cA clt wbr wo cA
    cmnf wceq cB cr wcel wa cA cB clt wbr cmnf cB clt wbr cB cr wcel cmnf cB
    clt wbr cA cmnf wceq cB mnflt adantl cA cmnf wceq cA cB clt wbr cmnf cB clt
    wbr wb cB cr wcel cA cmnf cB clt breq1 adantr mpbird pm2.24d cA cmnf wceq
    cB cpnf wceq wa cA cB clt wbr cA cB wceq cB cA clt wbr wo cA cmnf wceq cB
    cpnf wceq wa cA cB clt wbr cmnf cpnf clt wbr mnfltpnf cA cmnf cB cpnf clt
    breq12 mpbiri pm2.24d cA cmnf wceq cB cmnf wceq wa cA cB wceq cB cA clt wbr
    wo cA cB clt wbr wn cA cmnf wceq cB cmnf wceq wa cA cB wceq cB cA clt wbr
    cA cB cmnf eqtr3 orcd a1d 3jaodan 3jaoian cA elxr cB elxr syl2anb impbid
    con2bid $.
    $( [22-Oct-2005] $) $( [14-Oct-2005] $)

  $( Ordering on the extended reals is transitive. $)
  xrlttr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A < B /\ B < C ) -> A < C ) ) $=
    cA cr wcel cA cpnf wceq cA cmnf wceq w3o cB cxr wcel cC cxr wcel cA cB clt
    wbr cB cC clt wbr wa cA cC clt wbr wi cA cxr wcel cA cr wcel cA cpnf wceq
    cA cmnf wceq w3o cB cxr wcel cC cr wcel cC cpnf wceq cC cmnf wceq w3o cA cB
    clt wbr cB cC clt wbr wa cA cC clt wbr wi cC cxr wcel cA cr wcel cA cpnf
    wceq cA cmnf wceq w3o cB cxr wcel cC cr wcel cC cpnf wceq cC cmnf wceq w3o
    cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cA cr wcel cB cxr wcel cC
    cr wcel cC cpnf wceq cC cmnf wceq w3o wa cA cB clt wbr cB cC clt wbr wa cA
    cC clt wbr wi cA cpnf wceq cA cmnf wceq cA cr wcel cB cxr wcel cC cr wcel
    cC cpnf wceq cC cmnf wceq w3o cA cB clt wbr cB cC clt wbr wa cA cC clt wbr
    wi cA cr wcel cB cxr wcel wa cC cr wcel cA cB clt wbr cB cC clt wbr wa cA
    cC clt wbr wi cC cpnf wceq cC cmnf wceq cA cr wcel cC cr wcel cB cxr wcel
    cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cA cr wcel cC cr wcel wa cB
    cr wcel cB cpnf wceq cB cmnf wceq w3o cA cB clt wbr cB cC clt wbr wa cA cC
    clt wbr wi cB cxr wcel cA cr wcel cC cr wcel wa cB cr wcel cA cB clt wbr cB
    cC clt wbr wa cA cC clt wbr wi cB cpnf wceq cB cmnf wceq cA cr wcel cB cr
    wcel cC cr wcel cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cA cr wcel
    cB cr wcel cC cr wcel cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cA cB
    cC axlttrn 3expa an1rs cA cr wcel cC cr wcel wa cB cpnf wceq wa cB cC clt
    wbr cA cC clt wbr cA cB clt wbr cC cr wcel cB cpnf wceq cB cC clt wbr cA cC
    clt wbr wi cA cr wcel cC cr wcel cB cpnf wceq wa cB cC clt wbr cA cC clt
    wbr cC cr wcel cB cpnf wceq wa cB cC clt wbr cpnf cC clt wbr cC cr wcel
    cpnf cC clt wbr wn cB cpnf wceq cC cr wcel cC cxr wcel cpnf cC clt wbr wn
    cC rexr cC pnfnlt syl adantr cB cpnf wceq cB cC clt wbr cpnf cC clt wbr wb
    cC cr wcel cB cpnf cC clt breq1 adantl mtbird pm2.21d adantll adantld cA cr
    wcel cC cr wcel wa cB cmnf wceq wa cA cB clt wbr cA cC clt wbr cB cC clt
    wbr cA cr wcel cB cmnf wceq cA cB clt wbr cA cC clt wbr wi cC cr wcel cA cr
    wcel cB cmnf wceq wa cA cB clt wbr cA cC clt wbr cA cr wcel cB cmnf wceq wa
    cA cB clt wbr cA cmnf clt wbr cA cr wcel cA cmnf clt wbr wn cB cmnf wceq cA
    cr wcel cA cxr wcel cA cmnf clt wbr wn cA rexr cA nltmnf syl adantr cB cmnf
    wceq cA cB clt wbr cA cmnf clt wbr wb cA cr wcel cB cmnf cA clt breq2
    adantl mtbird pm2.21d adantlr adantrd 3jaodan cB elxr sylan2b an1rs cA cr
    wcel cB cxr wcel wa cC cpnf wceq wa cA cC clt wbr cA cB clt wbr cB cC clt
    wbr wa cA cr wcel cC cpnf wceq cA cC clt wbr cB cxr wcel cA cr wcel cC cpnf
    wceq wa cA cC clt wbr cA cpnf clt wbr cA cr wcel cA cpnf clt wbr cC cpnf
    wceq cA ltpnf adantr cC cpnf wceq cA cC clt wbr cA cpnf clt wbr wb cA cr
    wcel cC cpnf cA clt breq2 adantl mpbird adantlr a1d cB cxr wcel cC cmnf
    wceq cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cA cr wcel cB cxr wcel
    cC cmnf wceq wa cB cC clt wbr cA cC clt wbr cA cB clt wbr cB cxr wcel cC
    cmnf wceq wa cB cC clt wbr cA cC clt wbr cB cxr wcel cC cmnf wceq wa cB cC
    clt wbr cB cmnf clt wbr cB cxr wcel cB cmnf clt wbr wn cC cmnf wceq cB
    nltmnf adantr cC cmnf wceq cB cC clt wbr cB cmnf clt wbr wb cB cxr wcel cC
    cmnf cB clt breq2 adantl mtbird pm2.21d adantld adantll 3jaodan anasss cA
    cpnf wceq cB cxr wcel cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cC cr
    wcel cC cpnf wceq cC cmnf wceq w3o cA cpnf wceq cB cxr wcel wa cA cB clt
    wbr cA cC clt wbr cB cC clt wbr cA cpnf wceq cB cxr wcel wa cA cB clt wbr
    cA cC clt wbr cA cpnf wceq cB cxr wcel wa cA cB clt wbr cpnf cB clt wbr cB
    cxr wcel cpnf cB clt wbr wn cA cpnf wceq cB pnfnlt adantl cA cpnf wceq cA
    cB clt wbr cpnf cB clt wbr wb cB cxr wcel cA cpnf cB clt breq1 adantr
    mtbird pm2.21d adantrd adantrr cA cmnf wceq cB cxr wcel cC cr wcel cC cpnf
    wceq cC cmnf wceq w3o cA cB clt wbr cB cC clt wbr wa cA cC clt wbr wi cA
    cmnf wceq cB cxr wcel wa cC cr wcel cA cB clt wbr cB cC clt wbr wa cA cC
    clt wbr wi cC cpnf wceq cC cmnf wceq cA cmnf wceq cC cr wcel cA cB clt wbr
    cB cC clt wbr wa cA cC clt wbr wi cB cxr wcel cA cmnf wceq cC cr wcel wa cA
    cC clt wbr cA cB clt wbr cB cC clt wbr wa cA cmnf wceq cC cr wcel wa cA cC
    clt wbr cmnf cC clt wbr cC cr wcel cmnf cC clt wbr cA cmnf wceq cC mnflt
    adantl cA cmnf wceq cA cC clt wbr cmnf cC clt wbr wb cC cr wcel cA cmnf cC
    clt breq1 adantr mpbird a1d adantlr cA cmnf wceq cC cpnf wceq cA cB clt wbr
    cB cC clt wbr wa cA cC clt wbr wi cB cxr wcel cA cmnf wceq cC cpnf wceq wa
    cA cC clt wbr cA cB clt wbr cB cC clt wbr wa cA cmnf wceq cC cpnf wceq wa
    cA cC clt wbr cmnf cpnf clt wbr mnfltpnf cA cmnf cC cpnf clt breq12 mpbiri
    a1d adantlr cB cxr wcel cC cmnf wceq cA cB clt wbr cB cC clt wbr wa cA cC
    clt wbr wi cA cmnf wceq cB cxr wcel cC cmnf wceq wa cB cC clt wbr cA cC clt
    wbr cA cB clt wbr cB cxr wcel cC cmnf wceq wa cB cC clt wbr cA cC clt wbr
    cB cxr wcel cC cmnf wceq wa cB cC clt wbr cB cmnf clt wbr cB cxr wcel cB
    cmnf clt wbr wn cC cmnf wceq cB nltmnf adantr cC cmnf wceq cB cC clt wbr cB
    cmnf clt wbr wb cB cxr wcel cC cmnf cB clt breq2 adantl mtbird pm2.21d
    adantld adantll 3jaodan anasss 3jaoian 3impb cC elxr syl3an3b cA elxr
    syl3an1b $.
    $( [23-Oct-2005] $) $( [15-Oct-2005] $)

  ${
    $d x y z A $.
    $( 'Less than' is a strict ordering on the extended reals. $)
    xrltso $p |- < Or RR* $=
      vx vy vz cxr clt vx cv cxr wcel vy cv cxr wcel vz cv cxr wcel w3a vx cv
      vy cv clt wbr vx cv vy cv wceq vy cv vx cv clt wbr wo wn wb vx cv vy cv
      clt wbr vy cv vz cv clt wbr wa vx cv vz cv clt wbr wi vx cv cxr wcel vy
      cv cxr wcel vx cv vy cv clt wbr vx cv vy cv wceq vy cv vx cv clt wbr wo
      wn wb vz cv cxr wcel vx cv vy cv xrlttri 3adant3 vx cv vy cv vz cv xrlttr
      jca so $.
      $( [24-Oct-2005] $) $( [15-Oct-2005] $)
  $}

  $( Trichotomy law for 'less than' for extended reals. $)
  xrlttri2 $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A =/= B <-> ( A < B \/ B < A ) ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB clt wbr cB cA clt wbr wo cA cB cA cxr wcel
    cB cxr wcel wa cA cB wceq cA cB clt wbr cB cA clt wbr wo wn cxr clt wor cA
    cxr wcel cB cxr wcel wa cA cB wceq cA cB clt wbr cB cA clt wbr wo wn wb
    xrltso cxr cA cB clt sotrieq mpan bicomd necon1abid $.
    $( [2-Jan-2008] $) $( [10-Dec-2007] $)

  $( Trichotomy law for 'less than' for extended reals. $)
  xrlttri3 $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A = B <-> ( -. A < B /\ -. B < A ) ) ) $=
    cxr clt wor cA cxr wcel cB cxr wcel wa cA cB wceq cA cB clt wbr wn cB cA
    clt wbr wn wa wb xrltso cxr cA cB clt sotrieq2 mpan $.
    $( [9-Mar-2006] $) $( [9-Feb-2006] $)

  $( 'Less than or equal' expressed in terms of 'less than' or 'equals', for
     extended reals. $)
  xrleloe $p |- ( ( A e. RR* /\ B e. RR* ) ->
               ( A <_ B <-> ( A < B \/ A = B ) ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cle wbr cB cA clt wbr wn cA cB clt wbr cA
    cB wceq wo cA cB xrlenlt cA cxr wcel cB cxr wcel wa cB cA wceq cA cB clt
    wbr wo cB cA clt wbr wn cA cB clt wbr cA cB wceq wo cA cxr wcel cB cxr wcel
    wa cB cA clt wbr cB cA wceq cA cB clt wbr wo cB cxr wcel cA cxr wcel cB cA
    clt wbr cB cA wceq cA cB clt wbr wo wn wb cB cA xrlttri ancoms con2bid cB
    cA wceq cA cB clt wbr wo cA cB wceq cA cB clt wbr wo cA cB clt wbr cA cB
    wceq wo cB cA wceq cA cB wceq cA cB clt wbr cB cA eqcom orbi1i cA cB wceq
    cA cB clt wbr orcom bitri syl5rbbr bitrd $.
    $( [27-Jan-2006] $) $( [19-Jan-2006] $)

  $( 'Less than or equal to' implies 'less than' is not 'equals', for extended
     reals. $)
  xrleltne $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
                ( A < B <-> B =/= A ) ) $=
    cA cxr wcel cB cxr wcel cA cB cle wbr cA cB clt wbr cB cA wne wb cA cxr
    wcel cB cxr wcel wa cA cB cle wbr wa cA cB clt wbr cA cB wne cB cA wne cA
    cxr wcel cB cxr wcel wa cA cB cle wbr wa cA cB clt wbr cA cB cA cxr wcel cB
    cxr wcel wa cA cB cle wbr wa cA cB wceq cA cB clt wbr wn cA cxr wcel cB cxr
    wcel wa cA cB wceq cA cB clt wbr wn wi cA cB cle wbr cA cxr wcel cB cxr
    wcel wa cA cB wceq cA cB clt wbr wn cB cA clt wbr wn wa cA cB clt wbr wn cA
    cB xrlttri3 cA cB clt wbr wn cB cA clt wbr wn pm3.26 syl6bi adantr cA cxr
    wcel cB cxr wcel wa cA cB cle wbr wa cA cB clt wbr cA cB wceq cA cxr wcel
    cB cxr wcel wa cA cB cle wbr cA cB clt wbr cA cB wceq wo cA cB xrleloe
    biimpa ord impbid necon2abid cB cA necom syl6bbr 3impa $.
    $( [22-Jul-2007] $) $( [9-Feb-2006] $)

  $( 'Less than' implies 'less than or equal' for extended reals. $)
  xrltle $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B -> A <_ B ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cle wbr cA cB clt wbr cA cB wceq wo cA cB
    clt wbr cA cB xrleloe cA cB clt wbr cA cB wceq orc syl5bir $.
    $( [27-Feb-2006] $) $( [19-Jan-2006] $)

  $( 'Less than or equal to' is reflexive for extended reals. $)
  xrleid $p |- ( A e. RR* -> A <_ A ) $=
    cA cxr wcel cA cA cle wbr cA cxr wcel cA cxr wcel wa cA cA cle wbr cA cA
    clt wbr cA cA wceq wo cA cA wceq cA cA clt wbr cA eqid olci cA cA xrleloe
    mpbiri anidms $.
    $( [8-Feb-2007] $) $( [7-Feb-2007] $)

  $( Trichotomy law for extended reals. $)
  xrletri $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A <_ B \/ B <_ A ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cle wbr cB cA cle wbr cA cxr wcel cB cxr
    wcel wa cA cB cle wbr wn cB cA clt wbr cB cA cle wbr cB cxr wcel cA cxr
    wcel cB cA clt wbr cA cB cle wbr wn wb cB cA xrltnle ancoms cB cxr wcel cA
    cxr wcel cB cA clt wbr cB cA cle wbr wi cB cA xrltle ancoms sylbird orrd $.
    $( [8-Feb-2007] $) $( [7-Feb-2007] $)

  $( Transitive law for ordering on extended reals. $)
  xrlelttr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A <_ B /\ B < C ) -> A < C ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cle wbr cB cC clt wbr cA cC
    clt wbr cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cle wbr cA cB clt wbr
    cA cB wceq wo cB cC clt wbr cA cC clt wbr wi cA cxr wcel cB cxr wcel cA cB
    cle wbr cA cB clt wbr cA cB wceq wo wb cC cxr wcel cA cB xrleloe 3adant3 cA
    cxr wcel cB cxr wcel cC cxr wcel w3a cA cB clt wbr cB cC clt wbr cA cC clt
    wbr wi cA cB wceq cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB clt wbr cB
    cC clt wbr cA cC clt wbr cA cB cC xrlttr exp3a cA cB wceq cB cC clt wbr cA
    cC clt wbr wi wi cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB wceq cA cC
    clt wbr cB cC clt wbr cA cB cC clt breq1 biimprd a1i jaod sylbid imp3a $.
    $( [1-Mar-2006] $) $( [19-Jan-2006] $)

  $( Transitive law for ordering on extended reals. $)
  xrltletr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A < B /\ B <_ C ) -> A < C ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB clt wbr cB cC cle wbr cA cC
    clt wbr cA cxr wcel cB cxr wcel cC cxr wcel w3a cB cC cle wbr cA cB clt wbr
    cA cC clt wbr cA cxr wcel cB cxr wcel cC cxr wcel w3a cB cC cle wbr cB cC
    clt wbr cB cC wceq wo cA cB clt wbr cA cC clt wbr wi cB cxr wcel cC cxr
    wcel cB cC cle wbr cB cC clt wbr cB cC wceq wo wb cA cxr wcel cB cC xrleloe
    3adant1 cA cxr wcel cB cxr wcel cC cxr wcel w3a cB cC clt wbr cA cB clt wbr
    cA cC clt wbr wi cB cC wceq cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB
    clt wbr cB cC clt wbr cA cC clt wbr cA cxr wcel cB cxr wcel cC cxr wcel w3a
    cA cB clt wbr cB cC clt wbr cA cC clt wbr cA cB cC xrlttr exp3a com23 cB cC
    wceq cA cB clt wbr cA cC clt wbr wi wi cA cxr wcel cB cxr wcel cC cxr wcel
    w3a cB cC wceq cA cB clt wbr cA cC clt wbr cB cC cA clt breq2 biimpd a1i
    jaod sylbid com23 imp3a $.
    $( [21-Mar-2006] $) $( [19-Jan-2006] $)

  $( Transitive law for ordering on extended reals. $)
  xrletr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A <_ B /\ B <_ C ) -> A <_ C ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cle wbr cB cC cle wbr cA cC
    cle wbr cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cle wbr wa cB cC cle
    wbr cB cC clt wbr cB cC wceq wo cA cC cle wbr cA cxr wcel cB cxr wcel cC
    cxr wcel w3a cB cC cle wbr cB cC clt wbr cB cC wceq wo wb cA cB cle wbr cB
    cxr wcel cC cxr wcel cB cC cle wbr cB cC clt wbr cB cC wceq wo wb cA cxr
    wcel cB cC xrleloe 3adant1 adantr cA cxr wcel cB cxr wcel cC cxr wcel w3a
    cA cB cle wbr wa cB cC clt wbr cA cC cle wbr cB cC wceq cA cxr wcel cB cxr
    wcel cC cxr wcel w3a cA cB cle wbr cB cC clt wbr cA cC cle wbr cA cxr wcel
    cB cxr wcel cC cxr wcel w3a cA cB cle wbr cB cC clt wbr wa cA cC clt wbr cA
    cC cle wbr cA cB cC xrlelttr cA cxr wcel cC cxr wcel cA cC clt wbr cA cC
    cle wbr wi cB cxr wcel cA cC xrltle 3adant2 syld expdimp cA cB cle wbr cB
    cC wceq cA cC cle wbr wi cA cxr wcel cB cxr wcel cC cxr wcel w3a cB cC wceq
    cA cB cle wbr cA cC cle wbr cB cC cA cle breq2 biimpcd adantl jaod sylbid
    expimpd $.
    $( [3-Mar-2006] $) $( [9-Feb-2006] $)

  $( 'Less than' implies not equal for extended reals. $)
  xrltne $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) -> B =/= A ) $=
    cA cxr wcel cB cxr wcel cA cB clt wbr w3a cA cB cA cxr wcel cB cxr wcel cA
    cB clt wbr cA cB wne cA cxr wcel cB cxr wcel wa cA cB clt wbr cB cA clt wbr
    wo cA cB wne cA cB clt wbr cA cxr wcel cB cxr wcel wa cA cB clt wbr cB cA
    clt wbr wo cA cB cxr clt wor cA cxr wcel cB cxr wcel wa cA cB wceq cA cB
    clt wbr cB cA clt wbr wo wn wb xrltso cxr cA cB clt sotrieq mpan necon2abid
    cA cB clt wbr cB cA clt wbr orc syl5bi 3impia necomd $.
    $( [22-Aug-2007] $) $( [20-Jan-2006] $)

  $( An extended real is not less than plus infinity iff they are equal. $)
  nltpnft $p |- ( A e. RR* -> ( A = +oo <-> -. A < +oo ) ) $=
    cA cxr wcel cA cpnf wceq cA cpnf clt wbr wn cA cpnf wceq cA cpnf clt wbr
    cpnf cpnf clt wbr cpnf cxr wcel cpnf cpnf clt wbr wn pnfxr cpnf xrltnr
    ax-mp cA cpnf cpnf clt breq1 mtbiri cA cxr wcel cA cpnf clt wbr cA cpnf
    wceq cA cxr wcel cA cpnf cle wbr cA cpnf clt wbr cA cpnf wceq wo cA pnfge
    cA cxr wcel cpnf cxr wcel cA cpnf cle wbr cA cpnf clt wbr cA cpnf wceq wo
    wb pnfxr cA cpnf xrleloe mpan2 mpbid ord impbid2 $.
    $( [3-Mar-2006] $) $( [30-Jan-2006] $)

  $( An extended real is not greater than minus infinity iff they are equal. $)
  ngtmnft $p |- ( A e. RR* -> ( A = -oo <-> -. -oo < A ) ) $=
    cA cxr wcel cA cmnf wceq cmnf cA clt wbr wn cA cmnf wceq cmnf cA clt wbr
    cmnf cmnf clt wbr cmnf cxr wcel cmnf cmnf clt wbr wn mnfxr cmnf xrltnr
    ax-mp cA cmnf cmnf clt breq2 mtbiri cA cxr wcel cmnf cA clt wbr wn cmnf cA
    wceq cA cmnf wceq cA cxr wcel cmnf cA clt wbr cmnf cA wceq cA cxr wcel cmnf
    cA cle wbr cmnf cA clt wbr cmnf cA wceq wo cA mnfle cmnf cxr wcel cA cxr
    wcel cmnf cA cle wbr cmnf cA clt wbr cmnf cA wceq wo wb mnfxr cmnf cA
    xrleloe mpan mpbid ord cmnf cA eqcom syl6ib impbid2 $.
    $( [5-Mar-2006] $) $( [2-Feb-2006] $)

  $( An extended real is real iff it is strictly bounded by infinities. $)
  xrrebnd $p |- ( A e. RR* -> ( A e. RR <-> ( -oo < A /\ A < +oo ) ) ) $=
    cA cxr wcel cA cr wcel cmnf cA clt wbr cA cpnf clt wbr wa cA cr wcel cmnf
    cA clt wbr cA cpnf clt wbr cA mnflt cA ltpnf jca cA cxr wcel cmnf cA clt
    wbr cA cpnf clt wbr wa cA cpnf wceq cA cmnf wceq wo wn cA cr wcel cA cxr
    wcel cA cpnf wceq cA cmnf wceq wo cmnf cA clt wbr cA cpnf clt wbr wa cA cxr
    wcel cA cpnf wceq cA cmnf wceq wo cA cpnf clt wbr wn cmnf cA clt wbr wn wo
    cmnf cA clt wbr cA cpnf clt wbr wa wn cA cxr wcel cA cpnf wceq cA cpnf clt
    wbr wn cA cmnf wceq cmnf cA clt wbr wn cA nltpnft cA ngtmnft orbi12d cmnf
    cA clt wbr cA cpnf clt wbr wa wn cmnf cA clt wbr wn cA cpnf clt wbr wn wo
    cA cpnf clt wbr wn cmnf cA clt wbr wn wo cmnf cA clt wbr cA cpnf clt wbr
    ianor cmnf cA clt wbr wn cA cpnf clt wbr wn orcom bitr2i syl6bb con2bid cA
    cxr wcel cA cpnf wceq cA cmnf wceq wo cA cr wcel cA cxr wcel cA cr wcel cA
    cpnf wceq cA cmnf wceq w3o cA cpnf wceq cA cmnf wceq wo cA cr wcel wo cA
    cxr wcel cA cr wcel cA cpnf wceq cA cmnf wceq w3o cA elxr biimpi cA cr wcel
    cA cpnf wceq cA cmnf wceq w3o cA cr wcel cA cpnf wceq cA cmnf wceq wo wo cA
    cpnf wceq cA cmnf wceq wo cA cr wcel wo cA cr wcel cA cpnf wceq cA cmnf
    wceq 3orass cA cr wcel cA cpnf wceq cA cmnf wceq wo orcom bitri sylib ord
    sylbid impbid2 $.
    $( [5-Mar-2006] $) $( [2-Feb-2006] $)

  $( A way of proving that an extended real is real. $)
  xrre $p |- ( ( ( A e. RR* /\ B e. RR ) /\ ( -oo < A /\ A <_ B ) ) ->
              A e. RR ) $=
    cA cxr wcel cB cr wcel wa cmnf cA clt wbr cA cB cle wbr wa wa cA cr wcel
    cmnf cA clt wbr cA cpnf clt wbr wa cA cxr wcel cB cr wcel wa cmnf cA clt
    wbr cA cB cle wbr wa wa cmnf cA clt wbr cA cpnf clt wbr cA cxr wcel cB cr
    wcel wa cmnf cA clt wbr cA cB cle wbr simprl cA cxr wcel cB cr wcel wa cA
    cB cle wbr cA cpnf clt wbr cmnf cA clt wbr cA cxr wcel cB cr wcel wa cA cB
    cle wbr cA cpnf clt wbr cA cxr wcel cB cr wcel wa cA cB cle wbr cB cpnf clt
    wbr cA cpnf clt wbr cB cr wcel cB cpnf clt wbr cA cxr wcel cB ltpnf adantl
    cA cxr wcel cB cxr wcel cA cB cle wbr cB cpnf clt wbr wa cA cpnf clt wbr wi
    cB cr wcel cA cxr wcel cB cxr wcel cpnf cxr wcel cA cB cle wbr cB cpnf clt
    wbr wa cA cpnf clt wbr wi pnfxr cA cB cpnf xrlelttr mp3an3 cB rexr sylan2
    mpan2d imp adantrl jca cA cxr wcel cA cr wcel cmnf cA clt wbr cA cpnf clt
    wbr wa wb cB cr wcel cmnf cA clt wbr cA cB cle wbr wa cA xrrebnd ad2antrr
    mpbird $.
    $( [10-Mar-2005] $) $( [9-Mar-2006] $)

  $( An extended real between two others is real. $)
  xrre2 $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
              ( A < B /\ B < C ) ) -> B e. RR ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB clt wbr cB cC clt wbr wa cB
    cr wcel cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB clt wbr cB cC clt wbr
    wa cmnf cB clt wbr cB cpnf clt wbr wa cB cr wcel cA cxr wcel cB cxr wcel cC
    cxr wcel w3a cA cB clt wbr cmnf cB clt wbr cB cC clt wbr cB cpnf clt wbr cA
    cxr wcel cB cxr wcel cA cB clt wbr cmnf cB clt wbr wi cC cxr wcel cA cxr
    wcel cB cxr wcel wa cmnf cA cle wbr cA cB clt wbr cmnf cB clt wbr cA cxr
    wcel cmnf cA cle wbr cB cxr wcel cA mnfle adantr cmnf cxr wcel cA cxr wcel
    cB cxr wcel cmnf cA cle wbr cA cB clt wbr wa cmnf cB clt wbr wi mnfxr cmnf
    cA cB xrlelttr mp3an1 mpand 3adant3 cB cxr wcel cC cxr wcel cB cC clt wbr
    cB cpnf clt wbr wi cA cxr wcel cB cxr wcel cC cxr wcel wa cB cC clt wbr cC
    cpnf cle wbr cB cpnf clt wbr cC cxr wcel cC cpnf cle wbr cB cxr wcel cC
    pnfge adantl cB cxr wcel cC cxr wcel cpnf cxr wcel cB cC clt wbr cC cpnf
    cle wbr wa cB cpnf clt wbr wi pnfxr cB cC cpnf xrltletr mp3an3 mpan2d
    3adant1 anim12d cB cxr wcel cA cxr wcel cB cr wcel cmnf cB clt wbr cB cpnf
    clt wbr wa wb cC cxr wcel cB xrrebnd 3ad2ant2 sylibrd imp $.
    $( [6-Feb-2007] $) $( [6-Feb-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordering on reals (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Equality implies 'less than or equal to'. $)
  eqle $p |- ( ( A e. RR /\ A = B ) -> A <_ B ) $=
    cA cA cle wbr cA cB wceq cA cB cle wbr cA cr wcel cA cB wceq cA cA cle wbr
    cA cB cle wbr cA cB cA cle breq2 biimpac cA leid sylan $.
    $( [6-Apr-2005] $) $( [4-Apr-2005] $)

  ${
    lt.1 $e |- A e. RR $.

    ${
      lt.2 $e |- B e. RR $.
      $( Consequence of trichotomy. $)
      lttri2i $p |- ( A =/= B <-> ( A < B \/ B < A ) ) $=
        cA cr wcel cB cr wcel cA cB wne cA cB clt wbr cB cA clt wbr wo wb lt.1
        lt.2 cA cB lttri2 mp2an $.
        $( [22-Aug-2007] $) $( [19-Jan-1997] $)

      $( Consequence of trichotomy. $)
      lttri3i $p |- ( A = B <-> ( -. A < B /\ -. B < A ) ) $=
        cA cr wcel cB cr wcel cA cB wceq cA cB clt wbr wn cB cA clt wbr wn wa
        wb lt.1 lt.2 cA cB lttri3 mp2an $.
        $( [14-May-1999] $)

      $( Consequence of trichotomy. $)
      letri3i $p |- ( A = B <-> ( A <_ B /\ B <_ A ) ) $=
        cA cr wcel cB cr wcel cA cB wceq cA cB cle wbr cB cA cle wbr wa wb lt.1
        lt.2 cA cB letri3 mp2an $.
        $( [14-May-1999] $)

      $( 'Less than or equal to' in terms of 'less than'. $)
      leloei $p |- ( A <_ B <-> ( A < B \/ A = B ) ) $=
        cA cr wcel cB cr wcel cA cB cle wbr cA cB clt wbr cA cB wceq wo wb lt.1
        lt.2 cA cB leloe mp2an $.
        $( [14-May-1999] $)

      $( 'Less than' expressed in terms of 'less than or equal to'. $)
      ltleni $p |- ( A < B <-> ( A <_ B /\ B =/= A ) ) $=
        cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cB cA wne wa wb lt.1
        lt.2 cA cB ltlen mp2an $.
        $( [8-Aug-2007] $) $( [27-Oct-1999] $)

      $( 'Less than' is not symmetric. $)
      ltnsymi $p |- ( A < B -> -. B < A ) $=
        cA cr wcel cB cr wcel cA cB clt wbr cB cA clt wbr wn wi lt.1 lt.2 cA cB
        ltnsym mp2an $.
        $( [6-May-1999] $)

      $( 'Less than or equal to'  in terms of 'less than'. $)
      lenlti $p |- ( A <_ B <-> -. B < A ) $=
        cA cr wcel cB cr wcel cA cB cle wbr cB cA clt wbr wn wb lt.1 lt.2 cA cB
        lenlt mp2an $.
        $( [24-May-1999] $)

      $( 'Less than'  in terms of 'less than or equal to'. $)
      ltnlei $p |- ( A < B <-> -. B <_ A ) $=
        cB cA cle wbr cA cB clt wbr cB cA lt.2 lt.1 lenlti con2bii $.
        $( [12-Jul-2005] $) $( [11-Jul-2005] $)

      $( 'Less than' implies 'less than or equal to'. $)
      ltlei $p |- ( A < B -> A <_ B ) $=
        cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr wi lt.1 lt.2 cA cB
        ltle mp2an $.
        $( [14-May-1999] $)

      ${
        ltlei.1 $e |- A < B $.
        $( 'Less than' implies 'less than or equal to' (inference). $)
        ltleii $p |- A <_ B $=
          cA cB clt wbr cA cB cle wbr ltlei.1 cA cB lt.1 lt.2 ltlei ax-mp $.
          $( [22-Aug-1999] $)
      $}

      $( Equality implies 'less than or equal to'. $)
      eqlei $p |- ( A = B -> A <_ B ) $=
        cA cB wceq cA cB cle wbr cB cA cle wbr cA cB lt.1 lt.2 letri3i pm3.26bi
        $.
        $( [23-May-1999] $)

      $( 'Less than' implies not equal. $)
      ltnei $p |- ( A < B -> B =/= A ) $=
        cA cr wcel cB cr wcel cA cB clt wbr cB cA wne lt.1 lt.2 cA cB ltne
        mp3an12 $.
        $( [14-Aug-2007] $) $( [28-Jul-1999] $)

      $( Trichotomy law for 'less than or equal to'. $)
      letrii $p |- ( A <_ B \/ B <_ A ) $=
        cA cB cle wbr cB cA cle wbr cA cB cle wbr wn cB cA clt wbr cB cA cle
        wbr cB cA lt.2 lt.1 ltnlei cB cA lt.2 lt.1 ltlei sylbir orri $.
        $( [2-Aug-1999] $)

      ${
        lt.3 $e |- C e. RR $.
        $( 'Less than' is transitive.  Theorem I.17 of [Apostol] p. 20. $)
        lttri $p |- ( ( A < B /\ B < C ) -> A < C ) $=
          cA cr wcel cB cr wcel cC cr wcel cA cB clt wbr cB cC clt wbr wa cA cC
          clt wbr wi lt.1 lt.2 lt.3 cA cB cC axlttrn mp3an $.
          $( [14-May-1999] $)

        $( 'Less than or equal to', 'less than' transitive law. $)
        lelttri $p |- ( ( A <_ B /\ B < C ) -> A < C ) $=
          cA cr wcel cB cr wcel cC cr wcel cA cB cle wbr cB cC clt wbr wa cA cC
          clt wbr wi lt.1 lt.2 lt.3 cA cB cC lelttr mp3an $.
          $( [14-May-1999] $)

        $( 'Less than', 'less than or equal to' transitive law. $)
        ltletri $p |- ( ( A < B /\ B <_ C ) -> A < C ) $=
          cA cr wcel cB cr wcel cC cr wcel cA cB clt wbr cB cC cle wbr wa cA cC
          clt wbr wi lt.1 lt.2 lt.3 cA cB cC ltletr mp3an $.
          $( [14-May-1999] $)

        $( 'Less than or equal to' is transitive. $)
        letri $p |- ( ( A <_ B /\ B <_ C ) -> A <_ C ) $=
          cA cr wcel cB cr wcel cC cr wcel cA cB cle wbr cB cC cle wbr wa cA cC
          cle wbr wi lt.1 lt.2 lt.3 cA cB cC letr mp3an $.
          $( [14-May-1999] $)

        $( Extended trichotomy law for 'less than or equal to'. $)
        le2tri3i $p |- ( ( A <_ B /\ B <_ C /\ C <_ A ) <->
                        ( A = B /\ B = C /\ C = A ) ) $=
          cA cB cle wbr cB cC cle wbr cC cA cle wbr w3a cA cB wceq cB cC wceq
          cC cA wceq w3a cA cB cle wbr cB cC cle wbr cC cA cle wbr w3a cA cB
          wceq cB cC wceq cC cA wceq cA cB cle wbr cB cC cle wbr cC cA cle wbr
          cA cB wceq cA cB cle wbr cB cA cle wbr cA cB wceq cB cC cle wbr cC cA
          cle wbr wa cA cB wceq cA cB cle wbr cB cA cle wbr wa cA cB lt.1 lt.2
          letri3i biimpri cB cC cA lt.2 lt.3 lt.1 letri sylan2 3impb cB cC cle
          wbr cC cA cle wbr cA cB cle wbr cB cC wceq cB cC cle wbr cC cA cle
          wbr cA cB cle wbr cB cC wceq cB cC cle wbr cC cB cle wbr cB cC wceq
          cC cA cle wbr cA cB cle wbr wa cB cC wceq cB cC cle wbr cC cB cle wbr
          wa cB cC lt.2 lt.3 letri3i biimpri cC cA cB lt.3 lt.1 lt.2 letri
          sylan2 3impb 3comr cA cB cle wbr cB cC cle wbr cC cA cle wbr cC cA
          wceq cA cC cle wbr cC cA cle wbr cC cA wceq cA cB cle wbr cB cC cle
          wbr wa cA cC cle wbr cC cA cle wbr wa cA cC cA cC wceq cA cC cle wbr
          cC cA cle wbr wa cA cC lt.1 lt.3 letri3i biimpri eqcomd cA cB cC lt.1
          lt.2 lt.3 letri sylan 3impa 3jca cA cB wceq cA cB cle wbr cB cC wceq
          cB cC cle wbr cC cA wceq cC cA cle wbr cA cB lt.1 lt.2 eqlei cB cC
          lt.2 lt.3 eqlei cC cA lt.3 lt.1 eqlei 3anim123i impbii $.
          $( [14-Aug-2000] $)

        $( Addition to both sides of 'less than'.  (Proof shortened by Paul
           Chapman, 27-Jan-2008.) $)
        ltadd2i $p |- ( A < B <-> ( C + A ) < ( C + B ) ) $=
          cA cB clt wbr cC cA caddc co cC cB caddc co clt wbr cA cr wcel cB cr
          wcel cC cr wcel cA cB clt wbr cC cA caddc co cC cB caddc co clt wbr
          wi lt.1 lt.2 lt.3 cA cB cC axltadd mp3an cA cB clt wbr cC cA caddc co
          cC cB caddc co clt wbr cB cA cle wbr cC cB caddc co cC cA caddc co
          cle wbr cA cB clt wbr wn cC cA caddc co cC cB caddc co clt wbr wn cB
          cA clt wbr cB cA wceq wo cC cB caddc co cC cA caddc co clt wbr cC cB
          caddc co cC cA caddc co wceq wo cB cA cle wbr cC cB caddc co cC cA
          caddc co cle wbr cB cA clt wbr cC cB caddc co cC cA caddc co clt wbr
          cB cA wceq cC cB caddc co cC cA caddc co wceq cB cr wcel cA cr wcel
          cC cr wcel cB cA clt wbr cC cB caddc co cC cA caddc co clt wbr wi
          lt.2 lt.1 lt.3 cB cA cC axltadd mp3an cB cA cC caddc opreq2 orim12i
          cB cA lt.2 lt.1 leloei cC cB caddc co cC cA caddc co cC cB lt.3 lt.2
          readdcli cC cA lt.3 lt.1 readdcli leloei 3imtr4i cB cA lt.2 lt.1
          lenlti cC cB caddc co cC cA caddc co cC cB lt.3 lt.2 readdcli cC cA
          lt.3 lt.1 readdcli lenlti 3imtr3i con4i impbii $.
          $( [28-Jan-2008] $) $( [21-Jan-1997] $)

        $( Addition to both sides of 'less than'.  Theorem I.18 of [Apostol]
           p. 20. $)
        ltadd1i $p |- ( A < B <-> ( A + C ) < ( B + C ) ) $=
          cA cB clt wbr cC cA caddc co cC cB caddc co clt wbr cA cC caddc co cB
          cC caddc co clt wbr cA cB cC lt.1 lt.2 lt.3 ltadd2i cC cA caddc co cA
          cC caddc co cC cB caddc co cB cC caddc co clt cC cA cC lt.3 recni cA
          lt.1 recni addcomi cC cB cC lt.3 recni cB lt.2 recni addcomi breq12i
          bitri $.
          $( [21-Jan-1997] $)

        $( Addition to both sides of 'less than or equal to'. $)
        leadd1i $p |- ( A <_ B <-> ( A + C ) <_ ( B + C ) ) $=
          cB cA clt wbr wn cB cC caddc co cA cC caddc co clt wbr wn cA cB cle
          wbr cA cC caddc co cB cC caddc co cle wbr cB cA clt wbr cB cC caddc
          co cA cC caddc co clt wbr cB cA cC lt.2 lt.1 lt.3 ltadd1i notbii cA
          cB lt.1 lt.2 lenlti cA cC caddc co cB cC caddc co cA cC lt.1 lt.3
          readdcli cB cC lt.2 lt.3 readdcli lenlti 3bitr4i $.
          $( [11-Aug-1999] $)

        $( Addition to both sides of 'less than or equal to'. $)
        leadd2i $p |- ( A <_ B <-> ( C + A ) <_ ( C + B ) ) $=
          cA cB cle wbr cA cC caddc co cB cC caddc co cle wbr cC cA caddc co cC
          cB caddc co cle wbr cA cB cC lt.1 lt.2 lt.3 leadd1i cA cC caddc co cC
          cA caddc co cB cC caddc co cC cB caddc co cle cA cC cA lt.1 recni cC
          lt.3 recni addcomi cB cC cB lt.2 recni cC lt.3 recni addcomi breq12i
          bitri $.
          $( [11-Aug-1999] $)

        $( 'Less than' relationship between subtraction and addition. $)
        ltsubaddi $p |- ( ( A - B ) < C <-> A < ( C + B ) ) $=
          cA cB cneg caddc co cC clt wbr cA cB cneg caddc co cB caddc co cC cB
          caddc co clt wbr cA cB cmin co cC clt wbr cA cC cB caddc co clt wbr
          cA cB cneg caddc co cC cB cA cB cneg lt.1 cB lt.2 renegcli readdcli
          lt.3 lt.2 ltadd1i cA cB cneg caddc co cA cB cmin co cC clt cA cB cA
          lt.1 recni cB lt.2 recni negsubi breq1i cA cB cneg caddc co cB caddc
          co cA cC cB caddc co clt cA cB cneg caddc co cB caddc co cA cB cneg
          cB caddc co caddc co cA cc0 caddc co cA cA cB cneg cB cA lt.1 recni
          cB cneg cB lt.2 renegcli recni cB lt.2 recni addassi cB cneg cB caddc
          co cc0 cA caddc cB cneg cB caddc co cB cB cneg caddc co cc0 cB cneg
          cB cB cneg cB lt.2 renegcli recni cB lt.2 recni addcomi cB cB lt.2
          recni negidi eqtri opreq2i cA cA lt.1 recni addid1i 3eqtri breq1i
          3bitr3i $.
          $( [21-Jan-1997] $)

        $( 'Less than or equal to' relationship between subtraction and
           addition. $)
        lesubaddi $p |- ( ( A - B ) <_ C <-> A <_ ( C + B ) ) $=
          cA cB cmin co cC clt wbr cA cB cmin co cC wceq wo cA cC cB caddc co
          clt wbr cA cC cB caddc co wceq wo cA cB cmin co cC cle wbr cA cC cB
          caddc co cle wbr cA cB cmin co cC clt wbr cA cC cB caddc co clt wbr
          cA cB cmin co cC wceq cA cC cB caddc co wceq cA cB cC lt.1 lt.2 lt.3
          ltsubaddi cA cB cmin co cC wceq cB cC caddc co cA wceq cC cB caddc co
          cA wceq cA cC cB caddc co wceq cA cB cC cA lt.1 recni cB lt.2 recni
          cC lt.3 recni subaddi cB cC caddc co cC cB caddc co cA cB cC cB lt.2
          recni cC lt.3 recni addcomi eqeq1i cC cB caddc co cA eqcom 3bitri
          orbi12i cA cB cmin co cC cA cB lt.1 lt.2 resubcli lt.3 leloei cA cC
          cB caddc co lt.1 cC cB lt.3 lt.2 readdcli leloei 3bitr4i $.
          $( [30-Sep-1999] $)

        ${
          lt.4 $e |- D e. RR $.
          $( Adding both side of two inequalities.  Theorem I.25 of [Apostol]
             p. 20. $)
          lt2addi $p |- ( ( A < C /\ B < D ) -> ( A + B ) < ( C + D ) ) $=
            cA cB caddc co cC cB caddc co clt wbr cC cB caddc co cC cD caddc co
            clt wbr cA cB caddc co cC cD caddc co clt wbr cA cC clt wbr cB cD
            clt wbr cA cB caddc co cC cB caddc co cC cD caddc co cA cB lt.1
            lt.2 readdcli cC cB lt.3 lt.2 readdcli cC cD lt.3 lt.4 readdcli
            lttri cA cC cB lt.1 lt.3 lt.2 ltadd1i cB cD cC lt.2 lt.4 lt.3
            ltadd2i syl2anb $.
            $( [14-May-1999] $)

          $( Adding both side of two inequalities. $)
          le2addi $p |- ( ( A <_ C /\ B <_ D ) -> ( A + B ) <_ ( C + D ) ) $=
            cA cB caddc co cC cB caddc co cle wbr cC cB caddc co cC cD caddc co
            cle wbr cA cB caddc co cC cD caddc co cle wbr cA cC cle wbr cB cD
            cle wbr cA cB caddc co cC cB caddc co cC cD caddc co cA cB lt.1
            lt.2 readdcli cC cB lt.3 lt.2 readdcli cC cD lt.3 lt.4 readdcli
            letri cA cC cB lt.1 lt.3 lt.2 leadd1i cB cD cC lt.2 lt.4 lt.3
            leadd2i syl2anb $.
            $( [16-Sep-1999] $)
        $}
      $}

      $( Addition of 2 positive numbers is positive. $)
      addgt0i $p |- ( ( 0 < A /\ 0 < B ) -> 0 < ( A + B ) ) $=
        cc0 cA clt wbr cA cA cB caddc co clt wbr cc0 cA cB caddc co clt wbr cc0
        cB clt wbr cc0 cA cA cB caddc co 0re lt.1 cA cB lt.1 lt.2 readdcli
        lttri cc0 cB clt wbr cA cc0 caddc co cA cB caddc co clt wbr cA cA cB
        caddc co clt wbr cc0 cB cA 0re lt.2 lt.1 ltadd2i cA cc0 caddc co cA cA
        cB caddc co clt cA cA lt.1 recni addid1i breq1i bitri sylan2b $.
        $( [16-May-1999] $)

      $( Addition of 2 nonnegative numbers is nonnegative. $)
      addge0i $p |- ( ( 0 <_ A /\ 0 <_ B ) -> 0 <_ ( A + B ) ) $=
        cc0 cA clt wbr cc0 cA wceq wo cc0 cB clt wbr cc0 cB wceq wo cc0 cA cB
        caddc co cle wbr cc0 cA cle wbr cc0 cB cle wbr cc0 cA clt wbr cc0 cB
        clt wbr cc0 cA wceq cc0 cB wceq cc0 cA cB caddc co cle wbr cc0 cA clt
        wbr cc0 cB clt wbr wa cc0 cA cB caddc co clt wbr cc0 cA cB caddc co cle
        wbr cA cB lt.1 lt.2 addgt0i cc0 cA cB caddc co 0re cA cB lt.1 lt.2
        readdcli ltlei syl cc0 cA wceq cc0 cB clt wbr wa cc0 cA cB caddc co clt
        wbr cc0 cA cB caddc co cle wbr cc0 cA wceq cc0 cB clt wbr cc0 cA cB
        caddc co clt wbr cc0 cA wceq cB cA cB caddc co cc0 clt cc0 cA wceq cc0
        cB caddc co cA cB caddc co cB cc0 cA cB caddc opreq1 cB cB lt.2 recni
        addid2i syl5eqr breq2d biimpa cc0 cA cB caddc co 0re cA cB lt.1 lt.2
        readdcli ltlei syl cc0 cA clt wbr cc0 cB wceq wa cc0 cA cB caddc co clt
        wbr cc0 cA cB caddc co cle wbr cc0 cB wceq cc0 cA clt wbr cc0 cA cB
        caddc co clt wbr cc0 cB wceq cA cA cB caddc co cc0 clt cc0 cB wceq cA
        cc0 caddc co cA cB caddc co cA cc0 cB cA caddc opreq2 cA cA lt.1 recni
        addid1i syl5eqr breq2d biimpac cc0 cA cB caddc co 0re cA cB lt.1 lt.2
        readdcli ltlei syl cc0 cA wceq cc0 cB wceq wa cc0 cA cB caddc co wceq
        cc0 cA cB caddc co cle wbr cc0 cA wceq cc0 cB wceq wa cc0 cc0 caddc co
        cA cB caddc co cc0 cc0 cA cc0 cB caddc opreq12 cc0 0cn addid1i syl5eqr
        cc0 cA cB caddc co 0re cA cB lt.1 lt.2 readdcli eqlei syl ccase cc0 cA
        0re lt.1 leloei cc0 cB 0re lt.2 leloei syl2anb $.
        $( [28-May-1999] $)

      $( Addition of nonnegative and positive numbers is positive. $)
      addgegt0i $p |- ( ( 0 <_ A /\ 0 < B ) -> 0 < ( A + B ) ) $=
        cc0 cA cle wbr cc0 cB clt wbr cc0 cA cB caddc co clt wbr cc0 cA cle wbr
        cc0 cA clt wbr cc0 cA wceq wo cc0 cB clt wbr cc0 cA cB caddc co clt wbr
        wi cc0 cA 0re lt.1 leloei cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB caddc
        co clt wbr wi cc0 cA wceq cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB caddc
        co clt wbr cA cB lt.1 lt.2 addgt0i ex cc0 cA wceq cc0 cB clt wbr cc0 cA
        cB caddc co clt wbr cc0 cA wceq cB cA cB caddc co cc0 clt cc0 cA wceq
        cc0 cB caddc co cA cB caddc co cB cc0 cA cB caddc opreq1 cB cB lt.2
        recni addid2i syl5eqr breq2d biimpd jaoi sylbi imp $.
        $( [25-Sep-1999] $)

      ${
        addgt0i.3 $e |- 0 < A $.
        addgt0i.4 $e |- 0 < B $.
        $( Addition of 2 positive numbers is positive. $)
        addgt0ii $p |- 0 < ( A + B ) $=
          cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB caddc co clt wbr addgt0i.3
          addgt0i.4 cA cB lt.1 lt.2 addgt0i mp2an $.
          $( [18-May-1999] $)
      $}

      $( Two nonnegative numbers are zero iff their sum is zero. $)
      add20i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
        ( ( A + B ) = 0 <-> ( A = 0 /\ B = 0 ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA cB caddc co cc0 wceq cA cc0 wceq cB
        cc0 wceq wa cc0 cA clt wbr cc0 cA wceq wo cc0 cB clt wbr cc0 cB wceq wo
        cA cB caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa wi cc0 cA cle wbr
        cc0 cB cle wbr cc0 cA clt wbr cc0 cB clt wbr cc0 cA wceq cc0 cB wceq cA
        cB caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa wi cc0 cA clt wbr cc0
        cB clt wbr wa cA cB caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa cA cB
        caddc co cc0 wceq cc0 cA cB caddc co clt wbr cc0 cA clt wbr cc0 cB clt
        wbr wa cA cB caddc co cc0 wceq cA cB caddc co cc0 clt wbr wn cc0 cA cB
        caddc co clt wbr wn cA cB caddc co cc0 cA cB lt.1 lt.2 readdcli 0re
        lttri3i pm3.27bi cA cB lt.1 lt.2 addgt0i nsyl3 pm2.21d cc0 cA wceq cA
        cB caddc co cc0 wceq cB cc0 wceq cA cc0 wceq cc0 cA wceq cB cc0 wceq cA
        cB caddc co cc0 wceq cc0 cA wceq cB cA cB caddc co cc0 cc0 cA wceq cc0
        cB caddc co cA cB caddc co cB cc0 cA cB caddc opreq1 cB cB lt.2 recni
        addid2i syl5eqr eqeq1d biimprd cc0 cA wceq cA cc0 wceq cc0 cA eqcom
        biimpi jctild cc0 cB wceq cA cB caddc co cc0 wceq cA cc0 wceq cB cc0
        wceq cc0 cB wceq cA cc0 wceq cA cB caddc co cc0 wceq cc0 cB wceq cA cA
        cB caddc co cc0 cc0 cB wceq cA cc0 caddc co cA cB caddc co cA cc0 cB cA
        caddc opreq2 cA cA lt.1 recni addid1i syl5eqr eqeq1d biimprd cc0 cB
        wceq cB cc0 wceq cc0 cB eqcom biimpi jctird ccase2 cc0 cA 0re lt.1
        leloei cc0 cB 0re lt.2 leloei syl2anb cA cc0 wceq cB cc0 wceq cA cB
        caddc co cc0 cB caddc co cc0 cA cc0 cB caddc opreq1 cB cc0 wceq cc0 cB
        caddc co cc0 cc0 caddc co cc0 cB cc0 cc0 caddc opreq2 cc0 0cn addid1i
        syl6eq sylan9eq impbid1 $.
        $( [28-Jul-1999] $)

      $( Negative of both sides of 'less than'.  Theorem I.23 of [Apostol]
         p. 20. $)
      ltnegi $p |- ( A < B <-> -u B < -u A ) $=
        cA cB clt wbr cA cA cneg cB cneg caddc co caddc co cB cA cneg cB cneg
        caddc co caddc co clt wbr cB cneg cA cneg clt wbr cA cB cA cneg cB cneg
        caddc co lt.1 lt.2 cA cneg cB cneg cA lt.1 renegcli cB lt.2 renegcli
        readdcli ltadd1i cA cA cneg cB cneg caddc co caddc co cB cneg cB cA
        cneg cB cneg caddc co caddc co cA cneg clt cA cA cneg caddc co cB cneg
        caddc co cc0 cB cneg caddc co cA cA cneg cB cneg caddc co caddc co cB
        cneg cA cA cneg caddc co cc0 cB cneg caddc cA cA lt.1 recni negidi
        opreq1i cA cA cneg cB cneg cA lt.1 recni cA cneg cA lt.1 renegcli recni
        cB cneg cB lt.2 renegcli recni addassi cB cneg cB cneg cB lt.2 renegcli
        recni addid2i 3eqtr3i cB cA cneg cB cneg caddc co caddc co cA cneg cB
        cB cneg caddc co caddc co cA cneg cc0 caddc co cA cneg cB cA cneg cB
        cneg cB lt.2 recni cA cneg cA lt.1 renegcli recni cB cneg cB lt.2
        renegcli recni add12i cB cB cneg caddc co cc0 cA cneg caddc cB cB lt.2
        recni negidi opreq2i cA cneg cA cneg cA lt.1 renegcli recni addid1i
        3eqtri breq12i bitri $.
        $( [21-Jan-1997] $)

      $( Negative of both sides of 'less than or equal to'. $)
      lenegi $p |- ( A <_ B <-> -u B <_ -u A ) $=
        cA cB clt wbr cA cB wceq wo cB cneg cA cneg clt wbr cB cneg cA cneg
        wceq wo cA cB cle wbr cB cneg cA cneg cle wbr cA cB clt wbr cB cneg cA
        cneg clt wbr cA cB wceq cB cneg cA cneg wceq cA cB lt.1 lt.2 ltnegi cB
        cneg cA cneg wceq cB cA wceq cA cB wceq cB cA cB lt.2 recni cA lt.1
        recni neg11i cB cA eqcom bitr2i orbi12i cA cB lt.1 lt.2 leloei cB cneg
        cA cneg cB lt.2 renegcli cA lt.1 renegcli leloei 3bitr4i $.
        $( [1-Aug-1999] $)

      $( Contraposition of negative in 'less than'. $)
      ltnegcon2i $p |- ( A < -u B <-> B < -u A ) $=
        cA cB cneg clt wbr cB cneg cneg cA cneg clt wbr cB cA cneg clt wbr cA
        cB cneg lt.1 cB lt.2 renegcli ltnegi cB cneg cneg cB cA cneg clt cB cB
        lt.2 recni negnegi breq1i bitri $.
        $( [14-May-1999] $)

      $( The product of two positive numbers is positive. $)
      mulgt0i $p |- ( ( 0 < A /\ 0 < B ) -> 0 < ( A x. B ) ) $=
        cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr wa cc0 cA cB cmul
        co clt wbr wi lt.1 lt.2 cA cB axmulgt0 mp2an $.
        $( [16-May-1999] $)

      $( The product of two nonnegative numbers is nonnegative. $)
      mulge0i $p |- ( ( 0 <_ A /\ 0 <_ B ) -> 0 <_ ( A x. B ) ) $=
        cc0 cA clt wbr cc0 cA wceq wo cc0 cB clt wbr cc0 cB wceq wo cc0 cA cB
        cmul co cle wbr cc0 cA cle wbr cc0 cB cle wbr cc0 cA clt wbr cc0 cB clt
        wbr cc0 cA wceq cc0 cB wceq cc0 cA cB cmul co cle wbr cc0 cA clt wbr
        cc0 cB clt wbr wa cc0 cA cB cmul co clt wbr cc0 cA cB cmul co cle wbr
        cA cB lt.1 lt.2 mulgt0i cc0 cA cB cmul co 0re cA cB lt.1 lt.2 remulcli
        ltlei syl cc0 cA wceq cc0 cA cB cmul co wceq cc0 cA cB cmul co cle wbr
        cc0 cA wceq cc0 cB cmul co cA cB cmul co cc0 cc0 cA cB cmul opreq1 cB
        cB lt.2 recni mul02i syl5eqr cc0 cA cB cmul co 0re cA cB lt.1 lt.2
        remulcli eqlei syl cc0 cB wceq cc0 cA cB cmul co wceq cc0 cA cB cmul co
        cle wbr cc0 cB wceq cA cc0 cmul co cA cB cmul co cc0 cc0 cB cA cmul
        opreq2 cA cA lt.1 recni mul01i syl5eqr cc0 cA cB cmul co 0re cA cB lt.1
        lt.2 remulcli eqlei syl ccase2 cc0 cA 0re lt.1 leloei cc0 cB 0re lt.2
        leloei syl2anb $.
        $( [30-Jul-1999] $)

      ${
        mulgt0i.3 $e |- 0 < A $.
        mulgt0i.4 $e |- 0 < B $.
        $( The product of two positive numbers is positive. $)
        mulgt0ii $p |- 0 < ( A x. B ) $=
          cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB cmul co clt wbr mulgt0i.3
          mulgt0i.4 cA cB lt.1 lt.2 mulgt0i mp2an $.
          $( [18-May-1999] $)
      $}
    $}

    $( 'Less than' is irreflexive. $)
    ltnri $p |- -. A < A $=
      cA cr wcel cA cA clt wbr wn lt.1 cA ltnr ax-mp $.
      $( [18-Aug-1999] $)

    $( 'Less than or equal to' is reflexive. $)
    leidi $p |- A <_ A $=
      cA cr wcel cA cA cle wbr lt.1 cA leid ax-mp $.
      $( [18-Aug-1999] $)

    $( Positive means non-zero (useful for ordering theorems involving
       division). $)
    gt0ne0i $p |- ( 0 < A -> A =/= 0 ) $=
      cc0 cA 0re lt.1 ltnei $.
      $( [16-Sep-1999] $)

    ${
      lesub0.1 $e |- B e. RR $.
      $( Lemma to show a nonnegative number is zero. $)
      lesub0i $p |- ( ( 0 <_ A /\ B <_ ( B - A ) ) <-> A = 0 ) $=
        cB cB cA cmin co cle wbr cc0 cA cle wbr wa cA cc0 cle wbr cc0 cA cle
        wbr wa cc0 cA cle wbr cB cB cA cmin co cle wbr wa cA cc0 wceq cB cB cA
        cmin co cle wbr cA cc0 cle wbr cc0 cA cle wbr cc0 cA cneg cle wbr cB
        cc0 caddc co cB cA cneg caddc co cle wbr cA cc0 cle wbr cB cB cA cmin
        co cle wbr cc0 cA cneg cB 0re cA lt.1 renegcli lesub0.1 leadd2i cA cc0
        cle wbr cc0 cneg cA cneg cle wbr cc0 cA cneg cle wbr cA cc0 lt.1 0re
        lenegi cc0 cneg cc0 cA cneg cle neg0 breq1i bitr2i cB cc0 caddc co cB
        cB cA cneg caddc co cB cA cmin co cle cB cB lesub0.1 recni addid1i cB
        cA cB lesub0.1 recni cA lt.1 recni negsubi breq12i 3bitr3ri anbi1i cc0
        cA cle wbr cB cB cA cmin co cle wbr ancom cA cc0 lt.1 0re letri3i
        3bitr4i $.
        $( [8-Oct-1999] $)
    $}

    $( A non-zero square is positive.  Theorem I.20 of [Apostol] p. 20. $)
    msqgt0i $p |- ( A =/= 0 -> 0 < ( A x. A ) ) $=
      cA cc0 wne cA cc0 clt wbr cc0 cA clt wbr wo cc0 cA cA cmul co clt wbr cA
      cc0 lt.1 0re lttri2i cA cc0 clt wbr cc0 cA cA cmul co clt wbr cc0 cA clt
      wbr cA cc0 clt wbr cc0 cA cneg clt wbr cc0 cA cA cmul co clt wbr cA cc0
      clt wbr cc0 cneg cA cneg clt wbr cc0 cA cneg clt wbr cA cc0 lt.1 0re
      ltnegi cc0 cneg cc0 cA cneg clt neg0 breq1i bitri cc0 cA cneg clt wbr cc0
      cA cneg cA cneg cmul co cA cA cmul co clt cc0 cA cneg clt wbr cc0 cA cneg
      cA cneg cmul co clt wbr cA cneg cA cneg cA lt.1 renegcli cA lt.1 renegcli
      mulgt0i anidms cA cA cA lt.1 recni cA lt.1 recni mul2negi syl6breq sylbi
      cc0 cA clt wbr cc0 cA cA cmul co clt wbr cA cA lt.1 lt.1 mulgt0i anidms
      jaoi sylbi $.
      $( [23-May-2007] $) $( [17-Jan-1997] $)

    $( A square is nonnegative. $)
    msqge0i $p |- 0 <_ ( A x. A ) $=
      cc0 cA cA cmul co cle wbr cA cc0 cA cc0 wceq cc0 cA cA cmul co clt wbr
      cc0 cA cA cmul co wceq wo cc0 cA cA cmul co cle wbr cA cc0 wceq cc0 cA cA
      cmul co wceq cc0 cA cA cmul co clt wbr cA cc0 wceq cA cA cmul co cA cc0
      cmul co cc0 cA cc0 cA cmul opreq2 cA cA lt.1 recni mul01i syl6req olcd
      cc0 cA cA cmul co 0re cA cA lt.1 lt.1 remulcli leloei sylibr cA cc0 wne
      cc0 cA cA cmul co clt wbr cc0 cA cA cmul co cle wbr cA lt.1 msqgt0i cc0
      cA cA cmul co 0re cA cA lt.1 lt.1 remulcli ltlei syl pm2.61ine $.
      $( [14-May-1999] $)
  $}

  $( A non-zero square is positive.  Theorem I.20 of [Apostol] p. 20. $)
  msqgt0 $p |- ( ( A e. RR /\ A =/= 0 ) -> 0 < ( A x. A ) ) $=
    cA cr wcel cA cc0 wne cc0 cA cA cmul co clt wbr cA cr wcel cA cc0 wne cc0
    cA cA cmul co clt wbr wi cA cr wcel cA cc0 cif cc0 wne cc0 cA cr wcel cA
    cc0 cif cA cr wcel cA cc0 cif cmul co clt wbr wi cA cc0 cA cA cr wcel cA
    cc0 cif wceq cA cc0 wne cA cr wcel cA cc0 cif cc0 wne cc0 cA cA cmul co clt
    wbr cc0 cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co clt wbr cA cA
    cr wcel cA cc0 cif cc0 neeq1 cA cA cr wcel cA cc0 cif wceq cA cA cmul co cA
    cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cc0 clt cA cA cr wcel cA
    cc0 cif wceq cA cA cr wcel cA cc0 cif cA cA cr wcel cA cc0 cif cmul cA cA
    cr wcel cA cc0 cif wceq id cA cA cr wcel cA cc0 cif wceq id opreq12d breq2d
    imbi12d cA cr wcel cA cc0 cif cA cc0 cr 0re elimel msqgt0i dedth imp $.
    $( [24-May-2007] $) $( [6-May-1999] $)

  $( A square is nonnegative. $)
  msqge0 $p |- ( A e. RR -> 0 <_ ( A x. A ) ) $=
    cA cr wcel cc0 cA cA cmul co cle wbr cc0 cA cr wcel cA cc0 cif cA cr wcel
    cA cc0 cif cmul co cle wbr cA cc0 cA cA cr wcel cA cc0 cif wceq cA cA cmul
    co cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cc0 cle cA cA cr
    wcel cA cc0 cif wceq cA cA cr wcel cA cc0 cif cA cA cr wcel cA cc0 cif cmul
    cA cA cr wcel cA cc0 cif wceq id cA cA cr wcel cA cc0 cif wceq id opreq12d
    breq2d cA cr wcel cA cc0 cif cA cc0 cr 0re elimel msqge0i dedth $.
    $( [23-May-2007] $) $( [23-May-2007] $)

  ${
    gt0ne0i.1 $e |- A e. RR $.
    gt0ne0i.2 $e |- 0 < A $.
    $( Positive implies nonzero. $)
    gt0ne0ii $p |- A =/= 0 $=
      cc0 cA clt wbr cA cc0 wne gt0ne0i.2 cA gt0ne0i.1 gt0ne0i ax-mp $.
      $( [15-May-1999] $)
  $}

  $( Positive implies nonzero. $)
  gt0ne0 $p |- ( ( A e. RR /\ 0 < A ) -> A =/= 0 ) $=
    cA cr wcel cc0 cA clt wbr cA cc0 wne cA cr wcel cc0 cA clt wbr cA cc0 wne
    wi cc0 cA cr wcel cA cc0 cif clt wbr cA cr wcel cA cc0 cif cc0 wne wi cA
    cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA clt wbr cc0 cA cr wcel cA cc0 cif
    clt wbr cA cc0 wne cA cr wcel cA cc0 cif cc0 wne cA cA cr wcel cA cc0 cif
    cc0 clt breq2 cA cA cr wcel cA cc0 cif cc0 neeq1 imbi12d cA cr wcel cA cc0
    cif cA cc0 cr 0re elimel gt0ne0i dedth imp $.
    $( [25-Feb-2005] $) $( [3-Oct-1999] $)

  $( A nonzero nonnegative number is positive. $)
  ne0gt0 $p |- ( ( A e. RR /\ 0 <_ A ) -> ( A =/= 0 <-> 0 < A ) ) $=
    cA cr wcel cc0 cA cle wbr wa cA cc0 wne cA cc0 clt wbr cc0 cA clt wbr wo
    cc0 cA clt wbr cA cr wcel cA cc0 wne cA cc0 clt wbr cc0 cA clt wbr wo wb
    cc0 cA cle wbr cA cr wcel cc0 cr wcel cA cc0 wne cA cc0 clt wbr cc0 cA clt
    wbr wo wb 0re cA cc0 lttri2 mpan2 adantr cA cr wcel cc0 cA cle wbr wa cA
    cc0 clt wbr wn cc0 cA clt wbr cA cc0 clt wbr cc0 cA clt wbr wo wb cA cr
    wcel cc0 cA cle wbr cA cc0 clt wbr wn cc0 cr wcel cA cr wcel cc0 cA cle wbr
    cA cc0 clt wbr wn wb 0re cc0 cA lenlt mpan biimpa cA cc0 clt wbr cc0 cA clt
    wbr biorf syl bitr4d $.
    $( [9-Dec-2007] $) $( [20-Nov-2007] $)

  $( Trichotomy law. $)
  letric $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B \/ B <_ A ) ) $=
    cA cr wcel cB cr wcel wa cA cB cle wbr cB cA cle wbr cA cr wcel cB cr wcel
    wa cA cB cle wbr wn cB cA clt wbr cB cA cle wbr cB cr wcel cA cr wcel cB cA
    clt wbr cA cB cle wbr wn wb cB cA ltnle ancoms cB cr wcel cA cr wcel cB cA
    clt wbr cB cA cle wbr wi cB cA ltle ancoms sylbird orrd $.
    $( [18-Aug-1999] $)

  ${
    lecase.1 $e |- ( ph -> A e. RR ) $.
    lecase.2 $e |- ( ph -> B e. RR ) $.
    lecase.3 $e |- ( ( ph /\ A <_ B ) -> ps ) $.
    lecase.4 $e |- ( ( ph /\ B <_ A ) -> ps ) $.
    $( Ordering elimination by cases. $)
    lecasei $p |- ( ph -> ps ) $=
      wph cA cB cle wbr cB cA cle wbr wo wps cA cr wcel cB cr wcel cA cB cle
      wbr cB cA cle wbr wo wph cA cB letric lecase.1 lecase.2 sylanc wph cA cB
      cle wbr wps cB cA cle wbr lecase.3 lecase.4 jaodan mpdan $.
      $( [17-Jul-2007] $) $( [6-Jul-2007] $)
  $}

  $( Trichotomy law. $)
  lelttric $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B \/ B < A ) ) $=
    cA cr wcel cB cr wcel wa cA cB cle wbr cB cA clt wbr wo cB cA clt wbr wn cB
    cA clt wbr wo cB cA clt wbr pm2.1 cA cr wcel cB cr wcel wa cA cB cle wbr cB
    cA clt wbr wn cB cA clt wbr cA cB lenlt orbi1d mpbiri $.
    $( [26-Apr-2005] $) $( [4-Apr-2005] $)

  $( Addition to both sides of 'less than'. $)
  ltadd1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( A + C ) < ( B + C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cA cB clt wbr cA cC caddc co cB cC caddc
    co clt wbr wb cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC
    caddc co cB cC caddc co clt wbr wb cA cB cC cc0 cc0 cc0 cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC caddc co cB cr
    wcel cB cc0 cif cC caddc co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif caddc co cB cr
    wcel cB cc0 cif cC cr wcel cC cc0 cif caddc co clt wbr wb cA cA cr wcel cA
    cc0 cif wceq cA cB clt wbr cA cr wcel cA cc0 cif cB clt wbr cA cC caddc co
    cB cC caddc co clt wbr cA cr wcel cA cc0 cif cC caddc co cB cC caddc co clt
    wbr cA cA cr wcel cA cc0 cif cB clt breq1 cA cA cr wcel cA cc0 cif wceq cA
    cC caddc co cA cr wcel cA cc0 cif cC caddc co cB cC caddc co clt cA cA cr
    wcel cA cc0 cif cC caddc opreq1 breq1d bibi12d cB cB cr wcel cB cc0 cif
    wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cC caddc co cB cC caddc co clt wbr cA
    cr wcel cA cc0 cif cC caddc co cB cr wcel cB cc0 cif cC caddc co clt wbr cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif clt breq2 cB cB cr wcel cB cc0
    cif wceq cB cC caddc co cB cr wcel cB cc0 cif cC caddc co cA cr wcel cA cc0
    cif cC caddc co clt cB cB cr wcel cB cc0 cif cC caddc opreq1 breq2d bibi12d
    cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC caddc co cB cr wcel
    cB cc0 cif cC caddc co clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif
    caddc co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif caddc co clt wbr cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cC cC cr wcel cC cc0 cif wceq
    cA cr wcel cA cc0 cif cC caddc co cA cr wcel cA cc0 cif cC cr wcel cC cc0
    cif caddc co cB cr wcel cB cc0 cif cC caddc co cB cr wcel cB cc0 cif cC cr
    wcel cC cc0 cif caddc co clt cC cC cr wcel cC cc0 cif cA cr wcel cA cc0 cif
    caddc opreq2 cC cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif caddc opreq2
    breq12d bibi2d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC
    cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel
    ltadd1i dedth3h $.
    $( [12-Nov-1999] $)

  $( Addition to both sides of 'less than'. $)
  ltadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( C + A ) < ( C + B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cA cC caddc co cB cC
    caddc co clt wbr cC cA caddc co cC cB caddc co clt wbr cA cB cC ltadd1 cA
    cr wcel cB cr wcel cC cr wcel w3a cA cC caddc co cC cA caddc co cB cC caddc
    co cC cB caddc co clt cA cr wcel cC cr wcel cA cC caddc co cC cA caddc co
    wceq cB cr wcel cA cc wcel cC cc wcel cA cC caddc co cC cA caddc co wceq cA
    cr wcel cC cr wcel cA cC addcom cA recn cC recn syl2an 3adant2 cB cr wcel
    cC cr wcel cB cC caddc co cC cB caddc co wceq cA cr wcel cB cc wcel cC cc
    wcel cB cC caddc co cC cB caddc co wceq cB cr wcel cC cr wcel cB cC addcom
    cB recn cC recn syl2an 3adant1 breq12d bitrd $.
    $( [12-Nov-1999] $)

  $( Addition to both sides of 'less than or equal to'. $)
  leadd1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( A + C ) <_ ( B + C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cA cB cle wbr cA cC caddc co cB cC caddc
    co cle wbr wb cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cC
    caddc co cB cC caddc co cle wbr wb cA cB cC cc0 cc0 cc0 cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif cle wbr cA cr wcel cA cc0 cif cC caddc co cB cr
    wcel cB cc0 cif cC caddc co cle wbr wb cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cle wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif caddc co cB cr
    wcel cB cc0 cif cC cr wcel cC cc0 cif caddc co cle wbr wb cA cA cr wcel cA
    cc0 cif wceq cA cB cle wbr cA cr wcel cA cc0 cif cB cle wbr cA cC caddc co
    cB cC caddc co cle wbr cA cr wcel cA cc0 cif cC caddc co cB cC caddc co cle
    wbr cA cA cr wcel cA cc0 cif cB cle breq1 cA cA cr wcel cA cc0 cif wceq cA
    cC caddc co cA cr wcel cA cc0 cif cC caddc co cB cC caddc co cle cA cA cr
    wcel cA cc0 cif cC caddc opreq1 breq1d bibi12d cB cB cr wcel cB cc0 cif
    wceq cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cle wbr cA cr wcel cA cc0 cif cC caddc co cB cC caddc co cle wbr cA
    cr wcel cA cc0 cif cC caddc co cB cr wcel cB cc0 cif cC caddc co cle wbr cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cle breq2 cB cB cr wcel cB cc0
    cif wceq cB cC caddc co cB cr wcel cB cc0 cif cC caddc co cA cr wcel cA cc0
    cif cC caddc co cle cB cB cr wcel cB cc0 cif cC caddc opreq1 breq2d bibi12d
    cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC caddc co cB cr wcel
    cB cc0 cif cC caddc co cle wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif
    caddc co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif caddc co cle wbr cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cC cC cr wcel cC cc0 cif wceq
    cA cr wcel cA cc0 cif cC caddc co cA cr wcel cA cc0 cif cC cr wcel cC cc0
    cif caddc co cB cr wcel cB cc0 cif cC caddc co cB cr wcel cB cc0 cif cC cr
    wcel cC cc0 cif caddc co cle cC cC cr wcel cC cc0 cif cA cr wcel cA cc0 cif
    caddc opreq2 cC cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif caddc opreq2
    breq12d bibi2d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC
    cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel
    leadd1i dedth3h $.
    $( [18-Oct-1999] $)

  $( Addition to both sides of 'less than or equal to'. $)
  leadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( C + A ) <_ ( C + B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cA cC caddc co cB cC
    caddc co cle wbr cC cA caddc co cC cB caddc co cle wbr cA cB cC leadd1 cA
    cr wcel cB cr wcel cC cr wcel w3a cA cC caddc co cC cA caddc co cB cC caddc
    co cC cB caddc co cle cA cr wcel cC cr wcel cA cC caddc co cC cA caddc co
    wceq cB cr wcel cA cc wcel cC cc wcel cA cC caddc co cC cA caddc co wceq cA
    cr wcel cC cr wcel cA cC addcom cA recn cC recn syl2an 3adant2 cB cr wcel
    cC cr wcel cB cC caddc co cC cB caddc co wceq cA cr wcel cB cc wcel cC cc
    wcel cB cC caddc co cC cB caddc co wceq cB cr wcel cC cr wcel cB cC addcom
    cB recn cC recn syl2an 3adant1 breq12d bitrd $.
    $( [26-Oct-1999] $)

  $( 'Less than' relationship between subtraction and addition. $)
  ltsubadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( ( A - B ) < C <-> A < ( C + B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cA cB cmin co cC clt wbr cA cC cB caddc co
    clt wbr wb cA cr wcel cA cc0 cif cB cmin co cC clt wbr cA cr wcel cA cc0
    cif cC cB caddc co clt wbr wb cA cB cC cc0 cc0 cc0 cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmin co cC clt wbr cA cr wcel cA cc0 cif cC cB cr wcel
    cB cc0 cif caddc co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cmin co cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif cB cr wcel cB cc0 cif caddc co clt wbr wb cA cA cr wcel cA cc0 cif
    wceq cA cB cmin co cC clt wbr cA cr wcel cA cc0 cif cB cmin co cC clt wbr
    cA cC cB caddc co clt wbr cA cr wcel cA cc0 cif cC cB caddc co clt wbr cA
    cA cr wcel cA cc0 cif wceq cA cB cmin co cA cr wcel cA cc0 cif cB cmin co
    cC clt cA cA cr wcel cA cc0 cif cB cmin opreq1 breq1d cA cA cr wcel cA cc0
    cif cC cB caddc co clt breq1 bibi12d cB cB cr wcel cB cc0 cif wceq cA cr
    wcel cA cc0 cif cB cmin co cC clt wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cmin co cC clt wbr cA cr wcel cA cc0 cif cC cB caddc co clt wbr cA
    cr wcel cA cc0 cif cC cB cr wcel cB cc0 cif caddc co clt wbr cB cB cr wcel
    cB cc0 cif wceq cA cr wcel cA cc0 cif cB cmin co cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmin co cC clt cB cB cr wcel cB cc0 cif cA cr wcel cA
    cc0 cif cmin opreq2 breq1d cB cB cr wcel cB cc0 cif wceq cC cB caddc co cC
    cB cr wcel cB cc0 cif caddc co cA cr wcel cA cc0 cif clt cB cB cr wcel cB
    cc0 cif cC caddc opreq2 breq2d bibi12d cC cC cr wcel cC cc0 cif wceq cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cmin co cC clt wbr cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif cmin co cC cr wcel cC cc0 cif clt wbr cA cr wcel
    cA cc0 cif cC cB cr wcel cB cc0 cif caddc co clt wbr cA cr wcel cA cc0 cif
    cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif caddc co clt wbr cC cC cr wcel
    cC cc0 cif cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmin co clt breq2 cC
    cC cr wcel cC cc0 cif wceq cC cB cr wcel cB cc0 cif caddc co cC cr wcel cC
    cc0 cif cB cr wcel cB cc0 cif caddc co cA cr wcel cA cc0 cif clt cC cC cr
    wcel cC cc0 cif cB cr wcel cB cc0 cif caddc opreq1 breq2d bibi12d cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel ltsubaddi dedth3h $.
    $( [21-Jan-1997] $)

  $( 'Less than' relationship between subtraction and addition. $)
  ltsubadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) < C <-> A < ( B + C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cmin co cC clt wbr cA cC cB
    caddc co clt wbr cA cB cC caddc co clt wbr cA cB cC ltsubadd cA cr wcel cB
    cr wcel cC cr wcel w3a cB cC caddc co cC cB caddc co cA clt cB cr wcel cC
    cr wcel cB cC caddc co cC cB caddc co wceq cA cr wcel cB cc wcel cC cc wcel
    cB cC caddc co cC cB caddc co wceq cB cr wcel cC cr wcel cB cC addcom cB
    recn cC recn syl2an 3adant1 breq2d bitr4d $.
    $( [21-Jan-1997] $)

  $( 'Less than or equal to' relationship between subtraction and addition. $)
  lesubadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) <_ C <-> A <_ ( C + B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cA cB cmin co cC cle wbr cA cC cB caddc co
    cle wbr wb cA cr wcel cA cc0 cif cB cmin co cC cle wbr cA cr wcel cA cc0
    cif cC cB caddc co cle wbr wb cA cB cC cc0 cc0 cc0 cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmin co cC cle wbr cA cr wcel cA cc0 cif cC cB cr wcel
    cB cc0 cif caddc co cle wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cmin co cC cr wcel cC cc0 cif cle wbr cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif cB cr wcel cB cc0 cif caddc co cle wbr wb cA cA cr wcel cA cc0 cif
    wceq cA cB cmin co cC cle wbr cA cr wcel cA cc0 cif cB cmin co cC cle wbr
    cA cC cB caddc co cle wbr cA cr wcel cA cc0 cif cC cB caddc co cle wbr cA
    cA cr wcel cA cc0 cif wceq cA cB cmin co cA cr wcel cA cc0 cif cB cmin co
    cC cle cA cA cr wcel cA cc0 cif cB cmin opreq1 breq1d cA cA cr wcel cA cc0
    cif cC cB caddc co cle breq1 bibi12d cB cB cr wcel cB cc0 cif wceq cA cr
    wcel cA cc0 cif cB cmin co cC cle wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cmin co cC cle wbr cA cr wcel cA cc0 cif cC cB caddc co cle wbr cA
    cr wcel cA cc0 cif cC cB cr wcel cB cc0 cif caddc co cle wbr cB cB cr wcel
    cB cc0 cif wceq cA cr wcel cA cc0 cif cB cmin co cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmin co cC cle cB cB cr wcel cB cc0 cif cA cr wcel cA
    cc0 cif cmin opreq2 breq1d cB cB cr wcel cB cc0 cif wceq cC cB caddc co cC
    cB cr wcel cB cc0 cif caddc co cA cr wcel cA cc0 cif cle cB cB cr wcel cB
    cc0 cif cC caddc opreq2 breq2d bibi12d cC cC cr wcel cC cc0 cif wceq cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cmin co cC cle wbr cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif cmin co cC cr wcel cC cc0 cif cle wbr cA cr wcel
    cA cc0 cif cC cB cr wcel cB cc0 cif caddc co cle wbr cA cr wcel cA cc0 cif
    cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif caddc co cle wbr cC cC cr wcel
    cC cc0 cif cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmin co cle breq2 cC
    cC cr wcel cC cc0 cif wceq cC cB cr wcel cB cc0 cif caddc co cC cr wcel cC
    cc0 cif cB cr wcel cB cc0 cif caddc co cA cr wcel cA cc0 cif cle cC cC cr
    wcel cC cc0 cif cB cr wcel cB cc0 cif caddc opreq1 breq2d bibi12d cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel lesubaddi dedth3h $.
    $( [19-Nov-2004] $) $( [17-Nov-2004] $)

  $( 'Less than or equal to' relationship between subtraction and addition. $)
  lesubadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) <_ C <-> A <_ ( B + C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cmin co cC cle wbr cA cC cB
    caddc co cle wbr cA cB cC caddc co cle wbr cA cB cC lesubadd cA cr wcel cB
    cr wcel cC cr wcel w3a cB cC caddc co cC cB caddc co cA cle cB cr wcel cC
    cr wcel cB cC caddc co cC cB caddc co wceq cA cr wcel cB cc wcel cC cc wcel
    cB cC caddc co cC cB caddc co wceq cB cr wcel cC cr wcel cB cC addcom cB
    recn cC recn syl2an 3adant1 breq2d bitr4d $.
    $( [10-Aug-1999] $)

  $( 'Less than' relationship between addition and subtraction. $)
  ltaddsub $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) < C <-> A < ( C - B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB caddc co cC clt wbr cA cC cB
    cmin co clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cC cB cmin co cA cle
    wbr cC cA cB caddc co cle wbr cA cC cB cmin co clt wbr wn cA cB caddc co cC
    clt wbr wn cC cr wcel cB cr wcel cA cr wcel cC cB cmin co cA cle wbr cC cA
    cB caddc co cle wbr wb cC cB cA lesubadd 3com13 cC cr wcel cB cr wcel cA cr
    wcel cC cB cmin co cA cle wbr cA cC cB cmin co clt wbr wn wb cC cr wcel cB
    cr wcel cA cr wcel cC cB cmin co cA cle wbr cA cC cB cmin co clt wbr wn wb
    cC cB cmin co cr wcel cA cr wcel cC cB cmin co cA cle wbr cA cC cB cmin co
    clt wbr wn wb cC cr wcel cB cr wcel wa cC cB cmin co cA lenlt cC cB resubcl
    sylan 3impa 3com13 cC cr wcel cA cr wcel cB cr wcel cC cA cB caddc co cle
    wbr cA cB caddc co cC clt wbr wn wb cC cr wcel cA cr wcel cB cr wcel cC cA
    cB caddc co cle wbr cA cB caddc co cC clt wbr wn wb cC cr wcel cA cB caddc
    co cr wcel cC cA cB caddc co cle wbr cA cB caddc co cC clt wbr wn wb cA cr
    wcel cB cr wcel wa cC cA cB caddc co lenlt cA cB readdcl sylan2 3impb 3coml
    3bitr3rd con4bid $.
    $( [22-Nov-2004] $) $( [17-Nov-2004] $)

  $( 'Less than' relationship between addition and subtraction. $)
  ltaddsub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) < C <-> B < ( C - A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB caddc co cC clt wbr cB cA caddc
    co cC clt wbr cB cC cA cmin co clt wbr cA cr wcel cB cr wcel cC cr wcel w3a
    cA cB caddc co cB cA caddc co cC clt cA cr wcel cB cr wcel cA cB caddc co
    cB cA caddc co wceq cC cr wcel cA cc wcel cB cc wcel cA cB caddc co cB cA
    caddc co wceq cA cr wcel cB cr wcel cA cB addcom cA recn cB recn syl2an
    3adant3 breq1d cB cr wcel cA cr wcel cC cr wcel cB cA caddc co cC clt wbr
    cB cC cA cmin co clt wbr wb cB cA cC ltaddsub 3com12 bitrd $.
    $( [28-Nov-2004] $) $( [17-Nov-2004] $)

  $( 'Less than or equal to' relationship between addition and subtraction. $)
  leaddsub $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) <_ C <-> A <_ ( C - B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB caddc co cC cle wbr cA cC cB
    cmin co cle wbr cA cr wcel cB cr wcel cC cr wcel w3a cC cB cmin co cA clt
    wbr cC cA cB caddc co clt wbr cA cC cB cmin co cle wbr wn cA cB caddc co cC
    cle wbr wn cC cr wcel cB cr wcel cA cr wcel cC cB cmin co cA clt wbr cC cA
    cB caddc co clt wbr wb cC cB cA ltsubadd 3com13 cC cr wcel cB cr wcel cA cr
    wcel cC cB cmin co cA clt wbr cA cC cB cmin co cle wbr wn wb cC cr wcel cB
    cr wcel cA cr wcel cC cB cmin co cA clt wbr cA cC cB cmin co cle wbr wn wb
    cC cB cmin co cr wcel cA cr wcel cC cB cmin co cA clt wbr cA cC cB cmin co
    cle wbr wn wb cC cr wcel cB cr wcel wa cC cB cmin co cA ltnle cC cB resubcl
    sylan 3impa 3com13 cC cr wcel cA cr wcel cB cr wcel cC cA cB caddc co clt
    wbr cA cB caddc co cC cle wbr wn wb cC cr wcel cA cr wcel cB cr wcel cC cA
    cB caddc co clt wbr cA cB caddc co cC cle wbr wn wb cC cr wcel cA cB caddc
    co cr wcel cC cA cB caddc co clt wbr cA cB caddc co cC cle wbr wn wb cA cr
    wcel cB cr wcel wa cC cA cB caddc co ltnle cA cB readdcl sylan2 3impb 3coml
    3bitr3rd con4bid $.
    $( [23-Apr-2005] $) $( [6-Apr-2005] $)

  $( 'Less than or equal to' relationship between and addition and
     subtraction. $)
  leaddsub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) <_ C <-> B <_ ( C - A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB caddc co cC cle wbr cB cA caddc
    co cC cle wbr cB cC cA cmin co cle wbr cA cr wcel cB cr wcel cC cr wcel w3a
    cA cB caddc co cB cA caddc co cC cle cA cr wcel cB cr wcel cA cB caddc co
    cB cA caddc co wceq cC cr wcel cA cc wcel cB cc wcel cA cB caddc co cB cA
    caddc co wceq cA cr wcel cB cr wcel cA cB addcom cA recn cB recn syl2an
    3adant3 breq1d cB cr wcel cA cr wcel cC cr wcel cB cA caddc co cC cle wbr
    cB cC cA cmin co cle wbr wb cB cA cC leaddsub 3com12 bitrd $.
    $( [13-Jun-2005] $) $( [6-Apr-2005] $)

  $( Swap subtrahends in an inequality. $)
  suble $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) <_ C <-> ( A - C ) <_ B ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cmin co cC cle wbr cA cC cB
    caddc co cle wbr cA cC cmin co cB cle wbr cA cB cC lesubadd cA cr wcel cC
    cr wcel cB cr wcel cA cC cmin co cB cle wbr cA cC cB caddc co cle wbr wb cA
    cC cB lesubadd2 3com23 bitr4d $.
    $( [17-Oct-2005] $) $( [29-Sep-2005] $)

  $( Swap subtrahends in an inequality. $)
  lesub $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( A <_ ( B - C ) <-> C <_ ( B - A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cC caddc co cB cle wbr cA cB cC
    cmin co cle wbr cC cB cA cmin co cle wbr cA cr wcel cC cr wcel cB cr wcel
    cA cC caddc co cB cle wbr cA cB cC cmin co cle wbr wb cA cC cB leaddsub
    3com23 cA cr wcel cC cr wcel cB cr wcel cA cC caddc co cB cle wbr cC cB cA
    cmin co cle wbr wb cA cC cB leaddsub2 3com23 bitr3d $.
    $( [3-Nov-2005] $) $( [29-Sep-2005] $)

  ${
    ltsubadd.1 $e |- A e. RR $.
    ltsubadd.2 $e |- B e. RR $.
    ltsubadd.3 $e |- C e. RR $.
    $( 'Less than' relationship between subtraction and addition. $)
    ltsubadd2i $p |- ( ( A - B ) < C <-> A < ( B + C ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cA cB cmin co cC clt wbr cA cB cC caddc
      co clt wbr wb ltsubadd.1 ltsubadd.2 ltsubadd.3 cA cB cC ltsubadd2 mp3an
      $.
      $( [21-Jan-1997] $)

    $( 'Less than or equal to' relationship between subtraction and
       addition. $)
    lesubadd2i $p |- ( ( A - B ) <_ C <-> A <_ ( B + C ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cA cB cmin co cC cle wbr cA cB cC caddc
      co cle wbr wb ltsubadd.1 ltsubadd.2 ltsubadd.3 cA cB cC lesubadd2 mp3an
      $.
      $( [3-Aug-1999] $)

    $( 'Less than' relationship between subtraction and addition. $)
    ltaddsubi $p |- ( ( A + B ) < C <-> A < ( C - B ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cA cB caddc co cC clt wbr cA cC cB cmin
      co clt wbr wb ltsubadd.1 ltsubadd.2 ltsubadd.3 cA cB cC ltaddsub mp3an $.
      $( [14-May-1999] $)

    $( Multiplication of both sides of 'less than' by a positive
       number.  Theorem I.19 of [Apostol] p. 20. $)
    ltmullem $p |- ( 0 < C -> ( A < B -> ( A x. C ) < ( B x. C ) ) ) $=
      cc0 cC clt wbr cc0 cB cA cmin co clt wbr cc0 cB cA cmin co cC cmul co clt
      wbr cA cB clt wbr cA cC cmul co cB cC cmul co clt wbr cc0 cB cA cmin co
      clt wbr cc0 cC clt wbr cc0 cB cA cmin co cC cmul co clt wbr cB cA cmin co
      cC cB cA ltsubadd.2 ltsubadd.1 resubcli ltsubadd.3 mulgt0i expcom cA cB
      clt wbr cc0 cA caddc co cB clt wbr cc0 cB cA cmin co clt wbr cc0 cA caddc
      co cA cB clt cA cA ltsubadd.1 recni addid2i breq1i cc0 cA cB 0re
      ltsubadd.1 ltsubadd.2 ltaddsubi bitr3i cc0 cB cA cmin co cC cmul co clt
      wbr cc0 cB cC cmul co cA cC cmul co cmin co clt wbr cc0 cA cC cmul co
      caddc co cB cC cmul co clt wbr cA cC cmul co cB cC cmul co clt wbr cB cA
      cmin co cC cmul co cB cC cmul co cA cC cmul co cmin co cc0 clt cB cA cC
      cB ltsubadd.2 recni cA ltsubadd.1 recni cC ltsubadd.3 recni subdiri
      breq2i cc0 cA cC cmul co cB cC cmul co 0re cA cC ltsubadd.1 ltsubadd.3
      remulcli cB cC ltsubadd.2 ltsubadd.3 remulcli ltaddsubi cc0 cA cC cmul co
      caddc co cA cC cmul co cB cC cmul co clt cA cC cmul co cA cC cmul co cA
      cC ltsubadd.1 ltsubadd.3 remulcli recni addid2i breq1i 3bitr2ri 3imtr4g
      $.
      $( [15-May-1999] $)
  $}

  $( 'Less than' relationship between subtraction and addition. $)
  ltsub23 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) < C <-> ( A - C ) < B ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cmin co cC clt wbr cA cC cB
    caddc co clt wbr cA cC cmin co cB clt wbr cA cB cC ltsubadd cA cr wcel cC
    cr wcel cB cr wcel cA cC cmin co cB clt wbr cA cC cB caddc co clt wbr wb cA
    cC cB ltsubadd2 3com23 bitr4d $.
    $( [4-Oct-1999] $)

  $( 'Less than' relationship between subtraction and addition. $)
  ltsub13 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( A < ( B - C ) <-> C < ( B - A ) ) ) $=
    cA cr wcel cC cr wcel cB cr wcel cA cB cC cmin co clt wbr cC cB cA cmin co
    clt wbr wb cA cr wcel cC cr wcel cB cr wcel w3a cA cC caddc co cB clt wbr
    cA cB cC cmin co clt wbr cC cB cA cmin co clt wbr cA cC cB ltaddsub cA cC
    cB ltaddsub2 bitr3d 3com23 $.
    $( [28-Nov-2004] $) $( [17-Nov-2004] $)

  $( Adding both sides of two 'less than' relations.  Theorem I.25 of [Apostol]
     p. 20. $)
  lt2add $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A < C /\ B < D ) -> ( A + B ) < ( C + D ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cD cr wcel cA cC clt wbr cB cD clt wbr wa
    cA cB caddc co cC cD caddc co clt wbr wi cA cB cC cD cc0 cc0 cA cr wcel cA
    cc0 cif cC clt wbr cB cD clt wbr wa cA cr wcel cA cc0 cif cB caddc co cC cD
    caddc co clt wbr wi cA cr wcel cA cc0 cif cC clt wbr cB cr wcel cB cc0 cif
    cD clt wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cC cD
    caddc co clt wbr wi cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif clt wbr cB
    cr wcel cB cc0 cif cD clt wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0
    cif caddc co cC cr wcel cC cc0 cif cD caddc co clt wbr wi cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif clt wbr cB cr wcel cB cc0 cif cD cr wcel cD cc0
    cif clt wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cC cr
    wcel cC cc0 cif cD cr wcel cD cc0 cif caddc co clt wbr wi cc0 cc0 cA cA cr
    wcel cA cc0 cif wceq cA cC clt wbr cB cD clt wbr wa cA cr wcel cA cc0 cif
    cC clt wbr cB cD clt wbr wa cA cB caddc co cC cD caddc co clt wbr cA cr
    wcel cA cc0 cif cB caddc co cC cD caddc co clt wbr cA cA cr wcel cA cc0 cif
    wceq cA cC clt wbr cA cr wcel cA cc0 cif cC clt wbr cB cD clt wbr cA cA cr
    wcel cA cc0 cif cC clt breq1 anbi1d cA cA cr wcel cA cc0 cif wceq cA cB
    caddc co cA cr wcel cA cc0 cif cB caddc co cC cD caddc co clt cA cA cr wcel
    cA cc0 cif cB caddc opreq1 breq1d imbi12d cB cB cr wcel cB cc0 cif wceq cA
    cr wcel cA cc0 cif cC clt wbr cB cD clt wbr wa cA cr wcel cA cc0 cif cC clt
    wbr cB cr wcel cB cc0 cif cD clt wbr wa cA cr wcel cA cc0 cif cB caddc co
    cC cD caddc co clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co
    cC cD caddc co clt wbr cB cB cr wcel cB cc0 cif wceq cB cD clt wbr cB cr
    wcel cB cc0 cif cD clt wbr cA cr wcel cA cc0 cif cC clt wbr cB cB cr wcel
    cB cc0 cif cD clt breq1 anbi2d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA
    cc0 cif cB caddc co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cC
    cD caddc co clt cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif caddc opreq2
    breq1d imbi12d cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC clt
    wbr cB cr wcel cB cc0 cif cD clt wbr wa cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif clt wbr cB cr wcel cB cc0 cif cD clt wbr wa cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co cC cD caddc co clt wbr cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co cC cr wcel cC cc0 cif cD caddc co clt wbr cC
    cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC clt wbr cA cr wcel cA
    cc0 cif cC cr wcel cC cc0 cif clt wbr cB cr wcel cB cc0 cif cD clt wbr cC
    cC cr wcel cC cc0 cif cA cr wcel cA cc0 cif clt breq2 anbi1d cC cC cr wcel
    cC cc0 cif wceq cC cD caddc co cC cr wcel cC cc0 cif cD caddc co cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif caddc co clt cC cC cr wcel cC cc0 cif cD
    caddc opreq1 breq2d imbi12d cD cD cr wcel cD cc0 cif wceq cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif clt wbr cB cr wcel cB cc0 cif cD clt wbr wa cA cr
    wcel cA cc0 cif cC cr wcel cC cc0 cif clt wbr cB cr wcel cB cc0 cif cD cr
    wcel cD cc0 cif clt wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    caddc co cC cr wcel cC cc0 cif cD caddc co clt wbr cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif caddc co cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif
    caddc co clt wbr cD cD cr wcel cD cc0 cif wceq cB cr wcel cB cc0 cif cD clt
    wbr cB cr wcel cB cc0 cif cD cr wcel cD cc0 cif clt wbr cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif clt wbr cD cD cr wcel cD cc0 cif cB cr wcel cB
    cc0 cif clt breq2 anbi2d cD cD cr wcel cD cc0 cif wceq cC cr wcel cC cc0
    cif cD caddc co cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif caddc co cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co clt cD cD cr wcel cD cc0 cif
    cC cr wcel cC cc0 cif caddc opreq2 breq2d imbi12d cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif cA cc0 cr
    0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel cD cc0 cr 0re elimel
    lt2addi dedth4h $.
    $( [15-Aug-1999] $)

  $( Adding both sides of two 'less than or equal to' relations. $)
  le2add $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A <_ C /\ B <_ D ) -> ( A + B ) <_ ( C + D ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cD cr wcel cA cC cle wbr cB cD cle wbr wa
    cA cB caddc co cC cD caddc co cle wbr wi cA cB cC cD cc0 cc0 cA cr wcel cA
    cc0 cif cC cle wbr cB cD cle wbr wa cA cr wcel cA cc0 cif cB caddc co cC cD
    caddc co cle wbr wi cA cr wcel cA cc0 cif cC cle wbr cB cr wcel cB cc0 cif
    cD cle wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cC cD
    caddc co cle wbr wi cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cle wbr cB
    cr wcel cB cc0 cif cD cle wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0
    cif caddc co cC cr wcel cC cc0 cif cD caddc co cle wbr wi cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif cle wbr cB cr wcel cB cc0 cif cD cr wcel cD cc0
    cif cle wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cC cr
    wcel cC cc0 cif cD cr wcel cD cc0 cif caddc co cle wbr wi cc0 cc0 cA cA cr
    wcel cA cc0 cif wceq cA cC cle wbr cB cD cle wbr wa cA cr wcel cA cc0 cif
    cC cle wbr cB cD cle wbr wa cA cB caddc co cC cD caddc co cle wbr cA cr
    wcel cA cc0 cif cB caddc co cC cD caddc co cle wbr cA cA cr wcel cA cc0 cif
    wceq cA cC cle wbr cA cr wcel cA cc0 cif cC cle wbr cB cD cle wbr cA cA cr
    wcel cA cc0 cif cC cle breq1 anbi1d cA cA cr wcel cA cc0 cif wceq cA cB
    caddc co cA cr wcel cA cc0 cif cB caddc co cC cD caddc co cle cA cA cr wcel
    cA cc0 cif cB caddc opreq1 breq1d imbi12d cB cB cr wcel cB cc0 cif wceq cA
    cr wcel cA cc0 cif cC cle wbr cB cD cle wbr wa cA cr wcel cA cc0 cif cC cle
    wbr cB cr wcel cB cc0 cif cD cle wbr wa cA cr wcel cA cc0 cif cB caddc co
    cC cD caddc co cle wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co
    cC cD caddc co cle wbr cB cB cr wcel cB cc0 cif wceq cB cD cle wbr cB cr
    wcel cB cc0 cif cD cle wbr cA cr wcel cA cc0 cif cC cle wbr cB cB cr wcel
    cB cc0 cif cD cle breq1 anbi2d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA
    cc0 cif cB caddc co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cC
    cD caddc co cle cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif caddc opreq2
    breq1d imbi12d cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cle
    wbr cB cr wcel cB cc0 cif cD cle wbr wa cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif cle wbr cB cr wcel cB cc0 cif cD cle wbr wa cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co cC cD caddc co cle wbr cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co cC cr wcel cC cc0 cif cD caddc co cle wbr cC
    cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cle wbr cA cr wcel cA
    cc0 cif cC cr wcel cC cc0 cif cle wbr cB cr wcel cB cc0 cif cD cle wbr cC
    cC cr wcel cC cc0 cif cA cr wcel cA cc0 cif cle breq2 anbi1d cC cC cr wcel
    cC cc0 cif wceq cC cD caddc co cC cr wcel cC cc0 cif cD caddc co cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif caddc co cle cC cC cr wcel cC cc0 cif cD
    caddc opreq1 breq2d imbi12d cD cD cr wcel cD cc0 cif wceq cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif cle wbr cB cr wcel cB cc0 cif cD cle wbr wa cA cr
    wcel cA cc0 cif cC cr wcel cC cc0 cif cle wbr cB cr wcel cB cc0 cif cD cr
    wcel cD cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    caddc co cC cr wcel cC cc0 cif cD caddc co cle wbr cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif caddc co cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif
    caddc co cle wbr cD cD cr wcel cD cc0 cif wceq cB cr wcel cB cc0 cif cD cle
    wbr cB cr wcel cB cc0 cif cD cr wcel cD cc0 cif cle wbr cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif cle wbr cD cD cr wcel cD cc0 cif cB cr wcel cB
    cc0 cif cle breq2 anbi2d cD cD cr wcel cD cc0 cif wceq cC cr wcel cC cc0
    cif cD caddc co cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif caddc co cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cle cD cD cr wcel cD cc0 cif
    cC cr wcel cC cc0 cif caddc opreq2 breq2d imbi12d cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif cA cc0 cr
    0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel cD cc0 cr 0re elimel
    le2addi dedth4h $.
    $( [16-Jun-2005] $) $( [17-Apr-2005] $)

  $( Adding both sides of two orderings. $)
  ltleadd $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A < C /\ B <_ D ) -> ( A + B ) < ( C + D ) ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cA cC clt wbr cB cD
    cle wbr wa cA cB caddc co cC cB caddc co clt wbr cC cB caddc co cC cD caddc
    co cle wbr wa cA cB caddc co cC cD caddc co clt wbr cA cr wcel cB cr wcel
    wa cC cr wcel cD cr wcel wa wa cA cC clt wbr cA cB caddc co cC cB caddc co
    clt wbr cB cD cle wbr cC cB caddc co cC cD caddc co cle wbr cA cr wcel cB
    cr wcel wa cC cr wcel cA cC clt wbr cA cB caddc co cC cB caddc co clt wbr
    wb cD cr wcel cA cr wcel cB cr wcel cC cr wcel cA cC clt wbr cA cB caddc co
    cC cB caddc co clt wbr wb cA cr wcel cC cr wcel cB cr wcel cA cC clt wbr cA
    cB caddc co cC cB caddc co clt wbr wb cA cC cB ltadd1 3com23 3expa adantrr
    cB cr wcel cC cr wcel cD cr wcel wa cB cD cle wbr cC cB caddc co cC cD
    caddc co cle wbr wb cA cr wcel cB cr wcel cC cr wcel cD cr wcel cB cD cle
    wbr cC cB caddc co cC cD caddc co cle wbr wb cB cr wcel cD cr wcel cC cr
    wcel cB cD cle wbr cC cB caddc co cC cD caddc co cle wbr wb cB cD cC leadd2
    3com23 3expb adantll anbi12d cA cB caddc co cr wcel cC cB caddc co cr wcel
    cC cD caddc co cr wcel cA cB caddc co cC cB caddc co clt wbr cC cB caddc co
    cC cD caddc co cle wbr wa cA cB caddc co cC cD caddc co clt wbr wi cA cr
    wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cA cB caddc co cC cB caddc
    co cC cD caddc co ltletr cA cr wcel cB cr wcel wa cA cB caddc co cr wcel cC
    cr wcel cD cr wcel wa cA cB readdcl adantr cB cr wcel cC cr wcel cC cB
    caddc co cr wcel cA cr wcel cD cr wcel cC cr wcel cB cr wcel cC cB caddc co
    cr wcel cC cB readdcl ancoms ad2ant2lr cC cr wcel cD cr wcel wa cC cD caddc
    co cr wcel cA cr wcel cB cr wcel wa cC cD readdcl adantl syl3anc sylbid $.
    $( [24-Dec-2007] $) $( [23-Dec-2007] $)

  $( Adding both sides of two orderings. $)
  leltadd $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A <_ C /\ B < D ) -> ( A + B ) < ( C + D ) ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cA cC cle wbr cB cD
    clt wbr wa cB cA caddc co cD cC caddc co clt wbr cA cB caddc co cC cD caddc
    co clt wbr cB cr wcel cA cr wcel cC cr wcel cD cr wcel wa cA cC cle wbr cB
    cD clt wbr wa cB cA caddc co cD cC caddc co clt wbr wi cB cr wcel cA cr
    wcel wa cD cr wcel cC cr wcel cA cC cle wbr cB cD clt wbr wa cB cA caddc co
    cD cC caddc co clt wbr wi cB cr wcel cA cr wcel wa cD cr wcel cC cr wcel wa
    wa cB cD clt wbr cA cC cle wbr cB cA caddc co cD cC caddc co clt wbr cB cA
    cD cC ltleadd ancomsd ancom2s ancom1s cA cr wcel cB cr wcel wa cC cr wcel
    cD cr wcel wa cA cB caddc co cB cA caddc co cC cD caddc co cD cC caddc co
    clt cA cc wcel cB cc wcel cA cB caddc co cB cA caddc co wceq cA cr wcel cB
    cr wcel cA cB addcom cA recn cB recn syl2an cC cc wcel cD cc wcel cC cD
    caddc co cD cC caddc co wceq cC cr wcel cD cr wcel cC cD addcom cC recn cD
    recn syl2an breqan12d sylibrd $.
    $( [27-Aug-2008] $) $( [15-Aug-2008] $)

  $( The sum of 2 positive numbers is positive. $)
  addgt0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < A /\ 0 < B ) ) ->
                0 < ( A + B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA clt wbr cc0 cB clt wbr wa cc0 cA cB caddc
    co clt wbr cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr wa cc0 cA cB
    caddc co clt wbr wi cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB clt wbr wa cc0
    cA cr wcel cA cc0 cif cB caddc co clt wbr wi cc0 cA cr wcel cA cc0 cif clt
    wbr cc0 cB cr wcel cB cc0 cif clt wbr wa cc0 cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif caddc co clt wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA clt wbr cc0 cB clt wbr wa cc0 cA cr wcel cA cc0 cif clt wbr cc0
    cB clt wbr wa cc0 cA cB caddc co clt wbr cc0 cA cr wcel cA cc0 cif cB caddc
    co clt wbr cA cA cr wcel cA cc0 cif wceq cc0 cA clt wbr cc0 cA cr wcel cA
    cc0 cif clt wbr cc0 cB clt wbr cA cA cr wcel cA cc0 cif cc0 clt breq2
    anbi1d cA cA cr wcel cA cc0 cif wceq cA cB caddc co cA cr wcel cA cc0 cif
    cB caddc co cc0 clt cA cA cr wcel cA cc0 cif cB caddc opreq1 breq2d imbi12d
    cB cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB clt
    wbr wa cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB cr wcel cB cc0 cif clt wbr
    wa cc0 cA cr wcel cA cc0 cif cB caddc co clt wbr cc0 cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co clt wbr cB cB cr wcel cB cc0 cif wceq cc0 cB
    clt wbr cc0 cB cr wcel cB cc0 cif clt wbr cc0 cA cr wcel cA cc0 cif clt wbr
    cB cB cr wcel cB cc0 cif cc0 clt breq2 anbi2d cB cB cr wcel cB cc0 cif wceq
    cA cr wcel cA cc0 cif cB caddc co cA cr wcel cA cc0 cif cB cr wcel cB cc0
    cif caddc co cc0 clt cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif caddc
    opreq2 breq2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr
    0re elimel cB cc0 cr 0re elimel addgt0i dedth2h imp $.
    $( [7-Jun-2005] $) $( [1-Jun-2005] $)

  $( The sum of nonnegative and positive numbers is positive. $)
  addgegt0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 0 < B ) ) ->
                  0 < ( A + B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cB clt wbr wa cc0 cA cB caddc
    co clt wbr cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB clt wbr wa cc0 cA cB
    caddc co clt wbr wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB clt wbr wa cc0
    cA cr wcel cA cc0 cif cB caddc co clt wbr wi cc0 cA cr wcel cA cc0 cif cle
    wbr cc0 cB cr wcel cB cc0 cif clt wbr wa cc0 cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif caddc co clt wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA cle wbr cc0 cB clt wbr wa cc0 cA cr wcel cA cc0 cif cle wbr cc0
    cB clt wbr wa cc0 cA cB caddc co clt wbr cc0 cA cr wcel cA cc0 cif cB caddc
    co clt wbr cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA
    cc0 cif cle wbr cc0 cB clt wbr cA cA cr wcel cA cc0 cif cc0 cle breq2
    anbi1d cA cA cr wcel cA cc0 cif wceq cA cB caddc co cA cr wcel cA cc0 cif
    cB caddc co cc0 clt cA cA cr wcel cA cc0 cif cB caddc opreq1 breq2d imbi12d
    cB cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB clt
    wbr wa cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif clt wbr
    wa cc0 cA cr wcel cA cc0 cif cB caddc co clt wbr cc0 cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co clt wbr cB cB cr wcel cB cc0 cif wceq cc0 cB
    clt wbr cc0 cB cr wcel cB cc0 cif clt wbr cc0 cA cr wcel cA cc0 cif cle wbr
    cB cB cr wcel cB cc0 cif cc0 clt breq2 anbi2d cB cB cr wcel cB cc0 cif wceq
    cA cr wcel cA cc0 cif cB caddc co cA cr wcel cA cc0 cif cB cr wcel cB cc0
    cif caddc co cc0 clt cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif caddc
    opreq2 breq2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr
    0re elimel cB cc0 cr 0re elimel addgegt0i dedth2h imp $.
    $( [25-Jan-2006] $) $( [28-Dec-2005] $)

  $( The sum of nonnegative and positive numbers is positive. $)
  addgtge0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < A /\ 0 <_ B ) ) ->
                  0 < ( A + B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA clt wbr cc0 cB cle wbr wa wa cc0 cB cA
    caddc co cA cB caddc co clt cB cr wcel cA cr wcel wa cc0 cB cle wbr cc0 cA
    clt wbr wa cc0 cB cA caddc co clt wbr cA cr wcel cB cr wcel wa cc0 cA clt
    wbr cc0 cB cle wbr wa cB cA addgegt0 cA cr wcel cB cr wcel ancom cc0 cA clt
    wbr cc0 cB cle wbr ancom syl2anb cA cr wcel cB cr wcel wa cA cB caddc co cB
    cA caddc co wceq cc0 cA clt wbr cc0 cB cle wbr wa cA cc wcel cB cc wcel cA
    cB caddc co cB cA caddc co wceq cA cr wcel cB cr wcel cA cB addcom cA recn
    cB recn syl2an adantr breqtrrd $.
    $( [4-Feb-2006] $) $( [28-Dec-2005] $)

  $( The sum of 2 nonnegative numbers is nonnegative. $)
  addge0 $p |- ( ( ( A e. RR /\ B e. RR ) /\
               ( 0 <_ A /\ 0 <_ B ) ) -> 0 <_ ( A + B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cB caddc
    co cle wbr cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cB
    caddc co cle wbr wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cc0
    cA cr wcel cA cc0 cif cB caddc co cle wbr wi cc0 cA cr wcel cA cc0 cif cle
    wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cc0 cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif caddc co cle wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr cc0
    cB cle wbr wa cc0 cA cB caddc co cle wbr cc0 cA cr wcel cA cc0 cif cB caddc
    co cle wbr cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA
    cc0 cif cle wbr cc0 cB cle wbr cA cA cr wcel cA cc0 cif cc0 cle breq2
    anbi1d cA cA cr wcel cA cc0 cif wceq cA cB caddc co cA cr wcel cA cc0 cif
    cB caddc co cc0 cle cA cA cr wcel cA cc0 cif cB caddc opreq1 breq2d imbi12d
    cB cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle
    wbr wa cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr
    wa cc0 cA cr wcel cA cc0 cif cB caddc co cle wbr cc0 cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif caddc co cle wbr cB cB cr wcel cB cc0 cif wceq cc0 cB
    cle wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif cle wbr
    cB cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0 cif wceq
    cA cr wcel cA cc0 cif cB caddc co cA cr wcel cA cc0 cif cB cr wcel cB cc0
    cif caddc co cc0 cle cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif caddc
    opreq2 breq2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr
    0re elimel cB cc0 cr 0re elimel addge0i dedth2h imp $.
    $( [3-Apr-2005] $) $( [17-Mar-2005] $)

  $( Adding a positive number to another number increases it. $)
  ltaddpos $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 < A <-> B < ( B + A ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA clt wbr cB cc0 caddc co cB cA caddc co clt
    wbr cB cB cA caddc co clt wbr cc0 cr wcel cA cr wcel cB cr wcel cc0 cA clt
    wbr cB cc0 caddc co cB cA caddc co clt wbr wb 0re cc0 cA cB ltadd2 mp3an1
    cA cr wcel cB cr wcel wa cB cc0 caddc co cB cB cA caddc co clt cB cr wcel
    cB cc0 caddc co cB wceq cA cr wcel cB cr wcel cB cc wcel cB cc0 caddc co cB
    wceq cB recn cB addid1 syl adantl breq1d bitrd $.
    $( [29-Nov-2004] $) $( [17-Nov-2004] $)

  $( Adding a positive number to another number increases it. $)
  ltaddpos2 $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 < A <-> B < ( A + B ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA clt wbr cB cB cA caddc co clt wbr cB cA cB
    caddc co clt wbr cA cB ltaddpos cA cr wcel cB cr wcel wa cA cB caddc co cB
    cA caddc co cB clt cA cc wcel cB cc wcel cA cB caddc co cB cA caddc co wceq
    cA cr wcel cB cr wcel cA cB addcom cA recn cB recn syl2an breq2d bitr4d $.
    $( [3-May-2005] $) $( [8-Apr-2005] $)

  $( Subtracting a positive number from another number decreases it. $)
  ltsubpos $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 < A <-> ( B - A ) < B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA clt wbr cB cB cA caddc co clt wbr cB cA
    cmin co cB clt wbr cA cB ltaddpos cB cr wcel cA cr wcel cB cr wcel cB cA
    cmin co cB clt wbr cB cB cA caddc co clt wbr wb cA cr wcel cB cr wcel wa cB
    cA cB ltsubadd cA cr wcel cB cr wcel pm3.27 cA cr wcel cB cr wcel pm3.26 cA
    cr wcel cB cr wcel pm3.27 syl3anc bitr4d $.
    $( [29-Nov-2004] $) $( [17-Nov-2004] $)

  $( Comparison of two numbers whose difference is positive. $)
  posdif $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> 0 < ( B - A ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cB cA cmin co clt wbr cA cA cB cA cmin co
    caddc co clt wbr cA cB clt wbr cB cA cmin co cr wcel cA cr wcel cc0 cB cA
    cmin co clt wbr cA cA cB cA cmin co caddc co clt wbr wb cA cr wcel cB cr
    wcel wa cB cA cmin co cA ltaddpos cB cr wcel cA cr wcel cB cA cmin co cr
    wcel cB cA resubcl ancoms cA cr wcel cB cr wcel pm3.26 sylanc cA cr wcel cB
    cr wcel wa cA cB cA cmin co caddc co cB cA clt cA cc wcel cB cc wcel cA cB
    cA cmin co caddc co cB wceq cA cr wcel cB cr wcel cA cB pncan3 cA recn cB
    recn syl2an breq2d bitr2d $.
    $( [18-Dec-2004] $) $( [17-Nov-2004] $)

  $( Negative of both sides of 'less than'.  Theorem I.23 of [Apostol]
     p. 20. $)
  ltneg $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> -u B < -u A ) ) $=
    cA cr wcel cB cr wcel cA cB clt wbr cB cneg cA cneg clt wbr wb cA cr wcel
    cA cc0 cif cB clt wbr cB cneg cA cr wcel cA cc0 cif cneg clt wbr wb cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cB cr wcel cB cc0 cif cneg cA
    cr wcel cA cc0 cif cneg clt wbr wb cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cA cB clt wbr cA cr wcel cA cc0 cif cB clt wbr cB cneg cA cneg clt wbr
    cB cneg cA cr wcel cA cc0 cif cneg clt wbr cA cA cr wcel cA cc0 cif cB clt
    breq1 cA cA cr wcel cA cc0 cif wceq cA cneg cA cr wcel cA cc0 cif cneg cB
    cneg clt cA cA cr wcel cA cc0 cif negeq breq2d bibi12d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif clt wbr cB cneg cA cr wcel cA cc0 cif cneg clt wbr cB cr wcel cB
    cc0 cif cneg cA cr wcel cA cc0 cif cneg clt wbr cB cB cr wcel cB cc0 cif cA
    cr wcel cA cc0 cif clt breq2 cB cB cr wcel cB cc0 cif wceq cB cneg cB cr
    wcel cB cc0 cif cneg cA cr wcel cA cc0 cif cneg clt cB cB cr wcel cB cc0
    cif negeq breq1d bibi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0
    cr 0re elimel cB cc0 cr 0re elimel ltnegi dedth2h $.
    $( [27-Aug-1999] $)

  $( Contraposition of negative in 'less than'. $)
  ltnegcon1 $p |- ( ( A e. RR /\ B e. RR ) -> ( -u A < B <-> -u B < A ) ) $=
    cA cr wcel cB cr wcel wa cA cneg cB clt wbr cB cneg cA cneg cneg clt wbr cB
    cneg cA clt wbr cA cneg cr wcel cB cr wcel cA cneg cB clt wbr cB cneg cA
    cneg cneg clt wbr wb cA cr wcel cA cneg cB ltneg cA renegcl sylan cA cr
    wcel cB cneg cA cneg cneg clt wbr cB cneg cA clt wbr wb cB cr wcel cA cr
    wcel cA cneg cneg cA cB cneg clt cA cr wcel cA cc wcel cA cneg cneg cA wceq
    cA recn cA negneg syl breq2d adantr bitrd $.
    $( [12-Nov-2004] $) $( [8-Nov-2004] $)

  $( Negative of both sides of 'less than or equal to'. $)
  leneg $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B <-> -u B <_ -u A ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr cB cneg cA cneg cle wbr wb cA cr wcel
    cA cc0 cif cB cle wbr cB cneg cA cr wcel cA cc0 cif cneg cle wbr wb cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cB cr wcel cB cc0 cif cneg cA
    cr wcel cA cc0 cif cneg cle wbr wb cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cA cB cle wbr cA cr wcel cA cc0 cif cB cle wbr cB cneg cA cneg cle wbr
    cB cneg cA cr wcel cA cc0 cif cneg cle wbr cA cA cr wcel cA cc0 cif cB cle
    breq1 cA cA cr wcel cA cc0 cif wceq cA cneg cA cr wcel cA cc0 cif cneg cB
    cneg cle cA cA cr wcel cA cc0 cif negeq breq2d bibi12d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif cle wbr cB cneg cA cr wcel cA cc0 cif cneg cle wbr cB cr wcel cB
    cc0 cif cneg cA cr wcel cA cc0 cif cneg cle wbr cB cB cr wcel cB cc0 cif cA
    cr wcel cA cc0 cif cle breq2 cB cB cr wcel cB cc0 cif wceq cB cneg cB cr
    wcel cB cc0 cif cneg cA cr wcel cA cc0 cif cneg cle cB cB cr wcel cB cc0
    cif negeq breq1d bibi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0
    cr 0re elimel cB cc0 cr 0re elimel lenegi dedth2h $.
    $( [12-Sep-1999] $)

  $( Contraposition of negative in 'less than or equal to'. $)
  lenegcon1 $p |- ( ( A e. RR /\ B e. RR ) -> ( -u A <_ B <-> -u B <_ A ) ) $=
    cA cr wcel cB cr wcel wa cA cneg cB cle wbr cB cneg cA cneg cneg cle wbr cB
    cneg cA cle wbr cA cneg cr wcel cB cr wcel cA cneg cB cle wbr cB cneg cA
    cneg cneg cle wbr wb cA cr wcel cA cneg cB leneg cA renegcl sylan cA cr
    wcel cB cneg cA cneg cneg cle wbr cB cneg cA cle wbr wb cB cr wcel cA cr
    wcel cA cneg cneg cA cB cneg cle cA cr wcel cA cc wcel cA cneg cneg cA wceq
    cA recn cA negneg syl breq2d adantr bitrd $.
    $( [14-Jun-2004] $) $( [10-May-2004] $)

  $( Contraposition of negative in 'less than or equal to'. $)
  lenegcon2 $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ -u B <-> B <_ -u A ) ) $=
    cA cr wcel cB cr wcel wa cA cB cneg cle wbr cB cneg cneg cA cneg cle wbr cB
    cA cneg cle wbr cA cr wcel cB cneg cr wcel cA cB cneg cle wbr cB cneg cneg
    cA cneg cle wbr wb cB cr wcel cA cB cneg leneg cB renegcl sylan2 cA cr wcel
    cB cr wcel wa cB cneg cneg cB cA cneg cle cB cr wcel cB cneg cneg cB wceq
    cA cr wcel cB cr wcel cB cc wcel cB cneg cneg cB wceq cB recn cB negneg syl
    adantl breq1d bitrd $.
    $( [9-Oct-2005] $) $( [8-Oct-2005] $)

  $( Subtraction from both sides of 'less than or equal to'. $)
  lesub1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( A - C ) <_ ( B - C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cA cC cneg caddc co cB
    cC cneg caddc co cle wbr cA cC cmin co cB cC cmin co cle wbr cA cr wcel cB
    cr wcel cC cneg cr wcel cA cB cle wbr cA cC cneg caddc co cB cC cneg caddc
    co cle wbr wb cC cr wcel cA cB cC cneg leadd1 cC renegcl syl3an3 cA cc wcel
    cB cc wcel cC cc wcel cA cC cneg caddc co cB cC cneg caddc co cle wbr cA cC
    cmin co cB cC cmin co cle wbr wb cA cr wcel cB cr wcel cC cr wcel cA cc
    wcel cB cc wcel cC cc wcel w3a cA cC cneg caddc co cA cC cmin co cB cC cneg
    caddc co cB cC cmin co cle cA cc wcel cC cc wcel cA cC cneg caddc co cA cC
    cmin co wceq cB cc wcel cA cC negsub 3adant2 cB cc wcel cC cc wcel cB cC
    cneg caddc co cB cC cmin co wceq cA cc wcel cB cC negsub 3adant1 breq12d cA
    recn cB recn cC recn syl3an bitrd $.
    $( [1-Aug-2006] $) $( [13-May-2004] $)

  $( Subtraction of both sides of 'less than or equal to'. $)
  lesub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( C - B ) <_ ( C - A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cneg cA cneg cle wbr
    cC cB cneg caddc co cC cA cneg caddc co cle wbr cC cB cmin co cC cA cmin co
    cle wbr cA cr wcel cB cr wcel cA cB cle wbr cB cneg cA cneg cle wbr wb cC
    cr wcel cA cB leneg 3adant3 cB cr wcel cA cr wcel cC cr wcel cB cneg cA
    cneg cle wbr cC cB cneg caddc co cC cA cneg caddc co cle wbr wb cB cneg cr
    wcel cA cr wcel cC cr wcel cB cneg cA cneg cle wbr cC cB cneg caddc co cC
    cA cneg caddc co cle wbr wb cB cr wcel cB cneg cr wcel cA cneg cr wcel cC
    cr wcel cB cneg cA cneg cle wbr cC cB cneg caddc co cC cA cneg caddc co cle
    wbr wb cA cr wcel cB cneg cA cneg cC leadd2 cA renegcl syl3an2 cB renegcl
    syl3an1 3com12 cA cc wcel cB cc wcel cC cc wcel cC cB cneg caddc co cC cA
    cneg caddc co cle wbr cC cB cmin co cC cA cmin co cle wbr wb cA cr wcel cB
    cr wcel cC cr wcel cC cc wcel cA cc wcel cB cc wcel cC cB cneg caddc co cC
    cA cneg caddc co cle wbr cC cB cmin co cC cA cmin co cle wbr wb cC cc wcel
    cA cc wcel cB cc wcel w3a cC cB cneg caddc co cC cB cmin co cC cA cneg
    caddc co cC cA cmin co cle cC cc wcel cB cc wcel cC cB cneg caddc co cC cB
    cmin co wceq cA cc wcel cC cB negsub 3adant2 cC cc wcel cA cc wcel cC cA
    cneg caddc co cC cA cmin co wceq cB cc wcel cC cA negsub 3adant3 breq12d
    3coml cA recn cB recn cC recn syl3an 3bitrd $.
    $( [1-Aug-2006] $) $( [29-Sep-2005] $)

  $( Subtraction from both sides of 'less than'.  (Contributed by FL,
     3-Jan-2008.) $)
  ltsub1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( A - C ) < ( B - C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cA cC cneg caddc co cB
    cC cneg caddc co clt wbr cA cC cmin co cB cC cmin co clt wbr cA cr wcel cB
    cr wcel cC cneg cr wcel cA cB clt wbr cA cC cneg caddc co cB cC cneg caddc
    co clt wbr wb cC cr wcel cA cB cC cneg ltadd1 cC renegcl syl3an3 cA cc wcel
    cB cc wcel cC cc wcel cA cC cneg caddc co cB cC cneg caddc co clt wbr cA cC
    cmin co cB cC cmin co clt wbr wb cA cr wcel cB cr wcel cC cr wcel cA cc
    wcel cB cc wcel cC cc wcel w3a cA cC cneg caddc co cA cC cmin co cB cC cneg
    caddc co cB cC cmin co clt cA cc wcel cC cc wcel cA cC cneg caddc co cA cC
    cmin co wceq cB cc wcel cA cC negsub 3adant2 cB cc wcel cC cc wcel cB cC
    cneg caddc co cB cC cmin co wceq cA cc wcel cB cC negsub 3adant1 breq12d cA
    recn cB recn cC recn syl3an bitrd $.
    $( [3-Jan-2008] $) $( [3-Jan-2008] $)

  $( Subtraction of both sides of 'less than'. $)
  ltsub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( C - B ) < ( C - A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cneg cA cneg clt wbr
    cC cB cneg caddc co cC cA cneg caddc co clt wbr cC cB cmin co cC cA cmin co
    clt wbr cA cr wcel cB cr wcel cA cB clt wbr cB cneg cA cneg clt wbr wb cC
    cr wcel cA cB ltneg 3adant3 cB cr wcel cA cr wcel cC cr wcel cB cneg cA
    cneg clt wbr cC cB cneg caddc co cC cA cneg caddc co clt wbr wb cB cneg cr
    wcel cA cr wcel cC cr wcel cB cneg cA cneg clt wbr cC cB cneg caddc co cC
    cA cneg caddc co clt wbr wb cB cr wcel cB cneg cr wcel cA cneg cr wcel cC
    cr wcel cB cneg cA cneg clt wbr cC cB cneg caddc co cC cA cneg caddc co clt
    wbr wb cA cr wcel cB cneg cA cneg cC ltadd2 cA renegcl syl3an2 cB renegcl
    syl3an1 3com12 cA cc wcel cB cc wcel cC cc wcel cC cB cneg caddc co cC cA
    cneg caddc co clt wbr cC cB cmin co cC cA cmin co clt wbr wb cA cr wcel cB
    cr wcel cC cr wcel cC cc wcel cA cc wcel cB cc wcel cC cB cneg caddc co cC
    cA cneg caddc co clt wbr cC cB cmin co cC cA cmin co clt wbr wb cC cc wcel
    cA cc wcel cB cc wcel w3a cC cB cneg caddc co cC cB cmin co cC cA cneg
    caddc co cC cA cmin co clt cC cc wcel cB cc wcel cC cB cneg caddc co cC cB
    cmin co wceq cA cc wcel cC cB negsub 3adant2 cC cc wcel cA cc wcel cC cA
    cneg caddc co cC cA cmin co wceq cB cc wcel cC cA negsub 3adant3 breq12d
    3coml cA recn cB recn cC recn syl3an 3bitrd $.
    $( [1-Aug-2006] $) $( [29-Sep-2005] $)

  ${
    ltaddpos.1 $e |- A e. RR $.
    ltaddpos.2 $e |- B e. RR $.
    $( Adding a positive number to another number increases it. $)
    ltaddposi $p |- ( 0 < A <-> B < ( B + A ) ) $=
      cA cr wcel cB cr wcel cc0 cA clt wbr cB cB cA caddc co clt wbr wb
      ltaddpos.1 ltaddpos.2 cA cB ltaddpos mp2an $.
      $( [25-Aug-1999] $)

    $( Comparison of two numbers whose difference is positive. $)
    posdifi $p |- ( A < B <-> 0 < ( B - A ) ) $=
      cA cr wcel cB cr wcel cA cB clt wbr cc0 cB cA cmin co clt wbr wb
      ltaddpos.1 ltaddpos.2 cA cB posdif mp2an $.
      $( [17-Nov-2004] $) $( [19-Aug-2001] $)

    $( Contraposition of negative in 'less than'. $)
    ltnegcon1i $p |- ( -u A < B <-> -u B < A ) $=
      cA cr wcel cB cr wcel cA cneg cB clt wbr cB cneg cA clt wbr wb ltaddpos.1
      ltaddpos.2 cA cB ltnegcon1 mp2an $.
      $( [14-May-1999] $)

    $( Contraposition of negative in 'less than or equal to'. $)
    lenegcon1i $p |- ( -u A <_ B <-> -u B <_ A ) $=
      cA cr wcel cB cr wcel cA cneg cB cle wbr cB cneg cA cle wbr wb ltaddpos.1
      ltaddpos.2 cA cB lenegcon1 mp2an $.
      $( [3-May-2005] $) $( [6-Apr-2005] $)
  $}

  $( Comparison of a number and its negative to zero.  Theorem I.23 of
     [Apostol] p. 20. $)
  lt0neg1 $p |- ( A e. RR -> ( A < 0 <-> 0 < -u A ) ) $=
    cA cr wcel cA cc0 clt wbr cc0 cneg cA cneg clt wbr cc0 cA cneg clt wbr cA
    cr wcel cc0 cr wcel cA cc0 clt wbr cc0 cneg cA cneg clt wbr wb 0re cA cc0
    ltneg mpan2 cc0 cneg cc0 cA cneg clt neg0 breq1i syl6bb $.
    $( [14-May-1999] $)

  $( Comparison of a number and its negative to zero. $)
  lt0neg2 $p |- ( A e. RR -> ( 0 < A <-> -u A < 0 ) ) $=
    cA cr wcel cc0 cA clt wbr cA cneg cc0 cneg clt wbr cA cneg cc0 clt wbr cc0
    cr wcel cA cr wcel cc0 cA clt wbr cA cneg cc0 cneg clt wbr wb 0re cc0 cA
    ltneg mpan cc0 cneg cc0 cA cneg clt neg0 breq2i syl6bb $.
    $( [10-May-2004] $) $( [10-May-2004] $)

  $( Comparison of a number and its negative to zero. $)
  le0neg1 $p |- ( A e. RR -> ( A <_ 0 <-> 0 <_ -u A ) ) $=
    cA cr wcel cA cc0 cle wbr cc0 cneg cA cneg cle wbr cc0 cA cneg cle wbr cA
    cr wcel cc0 cr wcel cA cc0 cle wbr cc0 cneg cA cneg cle wbr wb 0re cA cc0
    leneg mpan2 cc0 cneg cc0 cA cneg cle neg0 breq1i syl6bb $.
    $( [15-Jun-2004] $) $( [10-May-2004] $)

  $( Comparison of a number and its negative to zero. $)
  le0neg2 $p |- ( A e. RR -> ( 0 <_ A <-> -u A <_ 0 ) ) $=
    cA cr wcel cc0 cA cle wbr cA cneg cc0 cneg cle wbr cA cneg cc0 cle wbr cc0
    cr wcel cA cr wcel cc0 cA cle wbr cA cneg cc0 cneg cle wbr wb 0re cc0 cA
    leneg mpan cc0 cneg cc0 cA cneg cle neg0 breq2i syl6bb $.
    $( [24-Aug-1999] $)

  $( A number is less than or equal to itself plus a nonnegative number. $)
  addge01 $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 <_ B <-> A <_ ( A + B ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cB cle wbr cA cc0 caddc co cA cB caddc co cle
    wbr cA cA cB caddc co cle wbr cB cr wcel cA cr wcel cc0 cB cle wbr cA cc0
    caddc co cA cB caddc co cle wbr wb cc0 cr wcel cB cr wcel cA cr wcel cc0 cB
    cle wbr cA cc0 caddc co cA cB caddc co cle wbr wb 0re cc0 cB cA leadd2
    mp3an1 ancoms cA cr wcel cB cr wcel wa cA cc0 caddc co cA cA cB caddc co
    cle cA cr wcel cA cc0 caddc co cA wceq cB cr wcel cA cr wcel cA cc wcel cA
    cc0 caddc co cA wceq cA recn cA addid1 syl adantr breq1d bitrd $.
    $( [28-Jul-2005] $) $( [21-Feb-2005] $)

  $( A number is less than or equal to itself plus a nonnegative number. $)
  addge02 $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 <_ B <-> A <_ ( B + A ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cB cle wbr cA cA cB caddc co cle wbr cA cB cA
    caddc co cle wbr cA cB addge01 cA cr wcel cB cr wcel wa cA cB caddc co cB
    cA caddc co cA cle cA cc wcel cB cc wcel cA cB caddc co cB cA caddc co wceq
    cA cr wcel cB cr wcel cA cB addcom cA recn cB recn syl2an breq2d bitrd $.
    $( [30-Jul-2005] $) $( [27-Jul-2005] $)

  $( Nonnegative subtraction. $)
  subge0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( 0 <_ ( A - B ) <-> B <_ A ) ) $=
    cA cr wcel cB cr wcel wa cB cA cle wbr cB cB cneg caddc co cA cB cneg caddc
    co cle wbr cc0 cA cB cmin co cle wbr cB cr wcel cA cr wcel cB cneg cr wcel
    cB cA cle wbr cB cB cneg caddc co cA cB cneg caddc co cle wbr wb cA cr wcel
    cB cr wcel wa cB cA cB cneg leadd1 cA cr wcel cB cr wcel pm3.27 cA cr wcel
    cB cr wcel pm3.26 cB cr wcel cB cneg cr wcel cA cr wcel cB renegcl adantl
    syl3anc cA cc wcel cB cc wcel cB cB cneg caddc co cA cB cneg caddc co cle
    wbr cc0 cA cB cmin co cle wbr wb cA cr wcel cB cr wcel cA cc wcel cB cc
    wcel wa cB cB cneg caddc co cc0 cA cB cneg caddc co cA cB cmin co cle cB cc
    wcel cB cB cneg caddc co cc0 wceq cA cc wcel cB negid adantl cA cB negsub
    breq12d cA recn cB recn syl2an bitr2d $.
    $( [15-Mar-2005] $) $( [14-Mar-2005] $)

  $( Nonpositive subtraction. $)
  suble0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( ( A - B ) <_ 0 <-> A <_ B ) ) $=
    cA cr wcel cB cr wcel wa cA cB cmin co cc0 cle wbr cc0 cA cB cmin co cneg
    cle wbr cc0 cB cA cmin co cle wbr cA cB cle wbr cA cr wcel cB cr wcel wa cA
    cB cmin co cr wcel cA cB cmin co cc0 cle wbr cc0 cA cB cmin co cneg cle wbr
    wb cA cB resubcl cA cB cmin co le0neg1 syl cA cr wcel cB cr wcel wa cA cB
    cmin co cneg cB cA cmin co cc0 cle cA cc wcel cB cc wcel cA cB cmin co cneg
    cB cA cmin co wceq cA cr wcel cB cr wcel cA cB negsubdi2 cA recn cB recn
    syl2an breq2d cB cr wcel cA cr wcel cc0 cB cA cmin co cle wbr cA cB cle wbr
    wb cB cA subge0 ancoms 3bitrd $.
    $( [24-Mar-2008] $) $( [20-Mar-2008] $)

  ${
    subge0.1 $e |- A e. RR $.
    subge0.2 $e |- B e. RR $.
    $( Nonnegative subtraction. $)
    subge0i $p |- ( 0 <_ ( A - B ) <-> B <_ A ) $=
      cA cr wcel cB cr wcel cc0 cA cB cmin co cle wbr cB cA cle wbr wb subge0.1
      subge0.2 cA cB subge0 mp2an $.
      $( [13-Aug-2000] $)
  $}

  $( Nonnegative subtraction. $)
  subge02 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( 0 <_ B <-> ( A - B ) <_ A ) ) $=
    cA cr wcel cB cr wcel wa cc0 cB cle wbr cA cA cB caddc co cle wbr cA cB
    cmin co cA cle wbr cA cB addge01 cA cr wcel cB cr wcel cA cB cmin co cA cle
    wbr cA cA cB caddc co cle wbr wb cA cB cA lesubadd 3anidm13 bitr4d $.
    $( [31-Jul-2005] $) $( [27-Jul-2005] $)

  $( Lemma to show a nonnegative number is zero. $)
  lesub0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( ( 0 <_ A /\ B <_ ( B - A ) ) <-> A = 0 ) ) $=
    cA cr wcel cB cr wcel cc0 cA cle wbr cB cB cA cmin co cle wbr wa cA cc0
    wceq wb cc0 cA cr wcel cA cc0 cif cle wbr cB cB cA cr wcel cA cc0 cif cmin
    co cle wbr wa cA cr wcel cA cc0 cif cc0 wceq wb cc0 cA cr wcel cA cc0 cif
    cle wbr cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif
    cmin co cle wbr wa cA cr wcel cA cc0 cif cc0 wceq wb cA cB cc0 cc0 cA cA cr
    wcel cA cc0 cif wceq cc0 cA cle wbr cB cB cA cmin co cle wbr wa cc0 cA cr
    wcel cA cc0 cif cle wbr cB cB cA cr wcel cA cc0 cif cmin co cle wbr wa cA
    cc0 wceq cA cr wcel cA cc0 cif cc0 wceq cA cA cr wcel cA cc0 cif wceq cc0
    cA cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cB cB cA cmin co cle wbr cB cB
    cA cr wcel cA cc0 cif cmin co cle wbr cA cA cr wcel cA cc0 cif cc0 cle
    breq2 cA cA cr wcel cA cc0 cif wceq cB cA cmin co cB cA cr wcel cA cc0 cif
    cmin co cB cle cA cA cr wcel cA cc0 cif cB cmin opreq2 breq2d anbi12d cA cA
    cr wcel cA cc0 cif cc0 eqeq1 bibi12d cB cB cr wcel cB cc0 cif wceq cc0 cA
    cr wcel cA cc0 cif cle wbr cB cB cA cr wcel cA cc0 cif cmin co cle wbr wa
    cc0 cA cr wcel cA cc0 cif cle wbr cB cr wcel cB cc0 cif cB cr wcel cB cc0
    cif cA cr wcel cA cc0 cif cmin co cle wbr wa cA cr wcel cA cc0 cif cc0 wceq
    cB cB cr wcel cB cc0 cif wceq cB cB cA cr wcel cA cc0 cif cmin co cle wbr
    cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cmin co
    cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cB cB cr wcel cB cc0 cif wceq cB
    cB cr wcel cB cc0 cif cB cA cr wcel cA cc0 cif cmin co cB cr wcel cB cc0
    cif cA cr wcel cA cc0 cif cmin co cle cB cB cr wcel cB cc0 cif wceq id cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cmin opreq1 breq12d anbi2d
    bibi1d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re elimel cB
    cc0 cr 0re elimel lesub0i dedth2h $.
    $( [8-Oct-1999] $)

  $( The product of two nonnegative numbers is nonnegative. $)
  mulge0 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\
                ( B e. RR /\ 0 <_ B ) ) -> 0 <_ ( A x. B ) ) $=
    cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr cc0 cA cB cmul co cle
    wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cB
    cmul co cle wbr cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr wa cc0
    cA cB cmul co cle wbr wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr
    wa cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr wi cc0 cA cr wcel cA cc0
    cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cc0 cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cmul co cle wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0
    cif wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr
    cc0 cB cle wbr wa cc0 cA cB cmul co cle wbr cc0 cA cr wcel cA cc0 cif cB
    cmul co cle wbr cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel
    cA cc0 cif cle wbr cc0 cB cle wbr cA cA cr wcel cA cc0 cif cc0 cle breq2
    anbi1d cA cA cr wcel cA cc0 cif wceq cA cB cmul co cA cr wcel cA cc0 cif cB
    cmul co cc0 cle cA cA cr wcel cA cc0 cif cB cmul opreq1 breq2d imbi12d cB
    cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr
    wa cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa
    cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr cc0 cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmul co cle wbr cB cB cr wcel cB cc0 cif wceq cc0 cB cle
    wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cB
    cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0 cif wceq cA
    cr wcel cA cc0 cif cB cmul co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cmul co cc0 cle cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cmul opreq2
    breq2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel mulge0i dedth2h imp an4s $.
    $( [16-Jun-2009] $) $( [8-Oct-1999] $)

  $( The product of two nonnegative numbers is nonnegative. $)
  mulge0OLD $p |- ( ( ( A e. RR /\ B e. RR ) /\
                ( 0 <_ A /\ 0 <_ B ) ) -> 0 <_ ( A x. B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cB cmul co
    cle wbr cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cB
    cmul co cle wbr wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cc0
    cA cr wcel cA cc0 cif cB cmul co cle wbr wi cc0 cA cr wcel cA cc0 cif cle
    wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cc0 cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif cmul co cle wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr cc0
    cB cle wbr wa cc0 cA cB cmul co cle wbr cc0 cA cr wcel cA cc0 cif cB cmul
    co cle wbr cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA
    cc0 cif cle wbr cc0 cB cle wbr cA cA cr wcel cA cc0 cif cc0 cle breq2
    anbi1d cA cA cr wcel cA cc0 cif wceq cA cB cmul co cA cr wcel cA cc0 cif cB
    cmul co cc0 cle cA cA cr wcel cA cc0 cif cB cmul opreq1 breq2d imbi12d cB
    cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr
    wa cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa
    cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr cc0 cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmul co cle wbr cB cB cr wcel cB cc0 cif wceq cc0 cB cle
    wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cB
    cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0 cif wceq cA
    cr wcel cA cc0 cif cB cmul co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cmul co cc0 cle cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cmul opreq2
    breq2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel mulge0i dedth2h imp $.
    $( [17-Jul-2005] $) $( [8-Oct-1999] $)

  $( The product of two negative numbers is positive.  (Contributed by Jeffrey
     Hankins, 8-Jun-2009.)  $)
  mullt0 $p |- ( ( ( A e. RR /\ A < 0 ) /\ ( B e. RR /\ B < 0 ) )
               -> 0 < ( A x. B ) ) $=
    cA cr wcel cA cc0 clt wbr wa cB cr wcel cB cc0 clt wbr wa wa cc0 cA cneg cB
    cneg cmul co cA cB cmul co clt cA cneg cr wcel cc0 cA cneg clt wbr wa cB
    cneg cr wcel cc0 cB cneg clt wbr wa cc0 cA cneg cB cneg cmul co clt wbr cA
    cr wcel cA cc0 clt wbr wa cB cr wcel cB cc0 clt wbr wa cA cneg cB cneg
    mulgt0 cA cr wcel cA cc0 clt wbr wa cA cneg cr wcel cc0 cA cneg clt wbr cA
    cr wcel cA cneg cr wcel cA cc0 clt wbr cA renegcl adantr cA cr wcel cA cc0
    clt wbr cc0 cA cneg clt wbr cA lt0neg1 biimpa jca cB cr wcel cB cc0 clt wbr
    wa cB cneg cr wcel cc0 cB cneg clt wbr cB cr wcel cB cneg cr wcel cB cc0
    clt wbr cB renegcl adantr cB cr wcel cB cc0 clt wbr cc0 cB cneg clt wbr cB
    lt0neg1 biimpa jca syl2an cA cr wcel cB cr wcel cA cneg cB cneg cmul co cA
    cB cmul co wceq cA cc0 clt wbr cB cc0 clt wbr cA cc wcel cB cc wcel cA cneg
    cB cneg cmul co cA cB cmul co wceq cA cr wcel cB cr wcel cA cB mul2neg cA
    recn cB recn syl2an ad2ant2r breqtrd $.
    $( [12-Jun-2009] $) $( [8-Jun-2009] $)

  $( 0 is less than 1.  Theorem I.21 of [Apostol] p. 20. $)
  lt01 $p |- 0 < 1 $=
    cc0 c1 c1 cmul co c1 clt c1 cc0 wne cc0 c1 c1 cmul co clt wbr ax1ne0 c1 1re
    msqgt0i ax-mp c1 ax1cn mulid1i breqtri $.
    $( [17-Jan-1997] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Reciprocals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( ` _i ` times itself is minus 1. $)
  ixi $p |- ( _i x. _i ) = -u 1 $=
    ci ci cmul co cc0 caddc co cc0 c1 cneg caddc co ci ci cmul co c1 cneg ci ci
    cmul co c1 caddc co c1 cneg caddc co ci ci cmul co c1 c1 cneg caddc co
    caddc co cc0 c1 cneg caddc co ci ci cmul co cc0 caddc co ci ci cmul co c1
    c1 cneg ci ci axicn axicn mulcli ax1cn c1 ax1cn negcli addassi ci ci cmul
    co c1 caddc co cc0 c1 cneg caddc axi2m1 opreq1i c1 c1 cneg caddc co cc0 ci
    ci cmul co caddc c1 ax1cn negidi opreq2i 3eqtr3ri ci ci cmul co ci ci axicn
    axicn mulcli addid1i c1 cneg c1 ax1cn negcli addid2i 3eqtr3i $.
    $( [6-May-1999] $)

  $( Lemma for ~ recex . $)
  recextlem1 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + ( _i x. B ) ) x.
      ( A - ( _i x. B ) ) ) = ( ( A x. A ) + ( B x. B ) ) ) $=
    cA cc wcel cB cc wcel wa cA ci cB cmul co caddc co cA ci cB cmul co cmin co
    cmul co cA cA ci cB cmul co cmin co cmul co ci cB cmul co cA ci cB cmul co
    cmin co cmul co caddc co cA cA cmul co cA ci cB cmul co cmul co cmin co cA
    ci cB cmul co cmul co cB cB cmul co cneg cmin co caddc co cA cA cmul co cB
    cB cmul co caddc co cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co cmin
    co cc wcel cA ci cB cmul co caddc co cA ci cB cmul co cmin co cmul co cA cA
    ci cB cmul co cmin co cmul co ci cB cmul co cA ci cB cmul co cmin co cmul
    co caddc co wceq cA cc wcel cB cc wcel wa cA ci cB cmul co cA ci cB cmul co
    cmin co adddir cA cc wcel cB cc wcel pm3.26 cB cc wcel ci cB cmul co cc
    wcel cA cc wcel ci cc wcel cB cc wcel ci cB cmul co cc wcel axicn ci cB
    mulcl mpan adantl cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co cmin co
    cc wcel cB cc wcel cA ci cB cmul co subcl ci cc wcel cB cc wcel ci cB cmul
    co cc wcel axicn ci cB mulcl mpan sylan2 syl3anc cA cc wcel cB cc wcel wa
    cA cA ci cB cmul co cmin co cmul co cA cA cmul co cA ci cB cmul co cmul co
    cmin co ci cB cmul co cA ci cB cmul co cmin co cmul co cA ci cB cmul co
    cmul co cB cB cmul co cneg cmin co caddc cA cc wcel cA cc wcel ci cB cmul
    co cc wcel cA cA ci cB cmul co cmin co cmul co cA cA cmul co cA ci cB cmul
    co cmul co cmin co wceq cA cc wcel cB cc wcel wa cA cA ci cB cmul co subdi
    cA cc wcel cB cc wcel pm3.26 cA cc wcel cB cc wcel pm3.26 cB cc wcel ci cB
    cmul co cc wcel cA cc wcel ci cc wcel cB cc wcel ci cB cmul co cc wcel
    axicn ci cB mulcl mpan adantl syl3anc cA cc wcel cB cc wcel wa ci cB cmul
    co cA ci cB cmul co cmin co cmul co ci cB cmul co cA cmul co ci cB cmul co
    ci cB cmul co cmul co cmin co cA ci cB cmul co cmul co cB cB cmul co cneg
    cmin co ci cB cmul co cc wcel cA cc wcel ci cB cmul co cc wcel ci cB cmul
    co cA ci cB cmul co cmin co cmul co ci cB cmul co cA cmul co ci cB cmul co
    ci cB cmul co cmul co cmin co wceq cA cc wcel cB cc wcel wa ci cB cmul co
    cA ci cB cmul co subdi cB cc wcel ci cB cmul co cc wcel cA cc wcel ci cc
    wcel cB cc wcel ci cB cmul co cc wcel axicn ci cB mulcl mpan adantl cA cc
    wcel cB cc wcel pm3.26 cB cc wcel ci cB cmul co cc wcel cA cc wcel ci cc
    wcel cB cc wcel ci cB cmul co cc wcel axicn ci cB mulcl mpan adantl syl3anc
    cA cc wcel cB cc wcel wa cA ci cB cmul co cmul co ci cB cmul co cA cmul co
    cB cB cmul co cneg ci cB cmul co ci cB cmul co cmul co cmin cA cc wcel ci
    cB cmul co cc wcel cA ci cB cmul co cmul co ci cB cmul co cA cmul co wceq
    cB cc wcel cA ci cB cmul co mulcom ci cc wcel cB cc wcel ci cB cmul co cc
    wcel axicn ci cB mulcl mpan sylan2 cB cc wcel cB cB cmul co cneg ci cB cmul
    co ci cB cmul co cmul co wceq cA cc wcel cB cc wcel cB cB cmul co cneg ci
    cB cmul co ci cB cmul co cmul co wceq cB cc wcel cB cc wcel wa cB cB cmul
    co cneg ci ci cmul co cB cB cmul co cmul co ci cB cmul co ci cB cmul co
    cmul co cB cc wcel cB cc wcel wa c1 cneg cB cB cmul co cmul co cB cB cmul
    co cneg ci ci cmul co cB cB cmul co cmul co cB cc wcel cB cc wcel wa cB cB
    cmul co cc wcel c1 cneg cB cB cmul co cmul co cB cB cmul co cneg wceq cB cB
    mulcl cB cB cmul co mulm1 syl ci ci cmul co c1 cneg cB cB cmul co cmul ixi
    opreq1i syl5req ci cc wcel ci cc wcel wa cB cc wcel cB cc wcel wa ci ci
    cmul co cB cB cmul co cmul co ci cB cmul co ci cB cmul co cmul co wceq ci
    cc wcel ci cc wcel axicn axicn pm3.2i ci ci cB cB mul4 mpan eqtrd anidms
    adantl opreq12d eqtr4d opreq12d cA cc wcel cB cc wcel wa cA cA cmul co cA
    ci cB cmul co cmul co cmin co cA ci cB cmul co cmul co cB cB cmul co cneg
    cmin co caddc co cA cA cmul co cB cB cmul co cneg cmin co cA cA cmul co cB
    cB cmul co caddc co cA cA cmul co cc wcel cA ci cB cmul co cmul co cc wcel
    cB cB cmul co cneg cc wcel cA cA cmul co cA ci cB cmul co cmul co cmin co
    cA ci cB cmul co cmul co cB cB cmul co cneg cmin co caddc co cA cA cmul co
    cB cB cmul co cneg cmin co wceq cA cc wcel cB cc wcel wa cA cA cmul co cA
    ci cB cmul co cmul co cB cB cmul co cneg npncan cA cc wcel cA cA cmul co cc
    wcel cB cc wcel cA cc wcel cA cA cmul co cc wcel cA cA mulcl anidms adantr
    cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co cmul co cc wcel cB cc
    wcel cA ci cB cmul co mulcl ci cc wcel cB cc wcel ci cB cmul co cc wcel
    axicn ci cB mulcl mpan sylan2 cB cc wcel cB cB cmul co cneg cc wcel cA cc
    wcel cB cc wcel cB cB cmul co cneg cc wcel cB cc wcel cB cc wcel wa cB cB
    cmul co cc wcel cB cB cmul co cneg cc wcel cB cB mulcl cB cB cmul co negcl
    syl anidms adantl syl3anc cA cA cmul co cc wcel cB cB cmul co cc wcel cA cA
    cmul co cB cB cmul co cneg cmin co cA cA cmul co cB cB cmul co caddc co
    wceq cA cc wcel cB cc wcel cA cA cmul co cB cB cmul co subneg cA cc wcel cA
    cA cmul co cc wcel cA cA mulcl anidms cB cc wcel cB cB cmul co cc wcel cB
    cB mulcl anidms syl2an eqtrd 3eqtrd $.
    $( [11-Mar-2008] $) $( [23-May-2007] $)

  $( Lemma for ~ recex . $)
  recextlem2 $p |- ( ( A e. RR /\ B e. RR /\ ( A + ( _i x. B ) ) =/= 0 ) ->
                        ( ( A x. A ) + ( B x. B ) ) =/= 0 ) $=
    cA cA cmul co cB cB cmul co caddc co cr wcel cc0 cA cA cmul co cB cB cmul
    co caddc co clt wbr cA cA cmul co cB cB cmul co caddc co cc0 wne cA cr wcel
    cB cr wcel cA ci cB cmul co caddc co cc0 wne w3a cA cA cmul co cB cB cmul
    co caddc co gt0ne0 cA cr wcel cB cr wcel cA cA cmul co cB cB cmul co caddc
    co cr wcel cA ci cB cmul co caddc co cc0 wne cA cA cmul co cr wcel cB cB
    cmul co cr wcel cA cA cmul co cB cB cmul co caddc co cr wcel cA cr wcel cB
    cr wcel cA cA cmul co cB cB cmul co readdcl cA cr wcel cA cA cmul co cr
    wcel cA cA remulcl anidms cB cr wcel cB cB cmul co cr wcel cB cB remulcl
    anidms syl2an 3adant3 cA cr wcel cB cr wcel cA ci cB cmul co caddc co cc0
    wne cc0 cA cA cmul co cB cB cmul co caddc co clt wbr cA cr wcel cB cr wcel
    wa cA cc0 wne cB cc0 wne wo cc0 cA cA cmul co cB cB cmul co caddc co clt
    wbr cA ci cB cmul co caddc co cc0 wne cA cr wcel cB cr wcel wa cA cc0 wne
    cc0 cA cA cmul co cB cB cmul co caddc co clt wbr cB cc0 wne cA cA cmul co
    cr wcel cB cB cmul co cr wcel wa cc0 cA cA cmul co clt wbr cc0 cB cB cmul
    co cle wbr wa cc0 cA cA cmul co cB cB cmul co caddc co clt wbr cA cr wcel
    cB cr wcel wa cA cc0 wne wa cA cA cmul co cB cB cmul co addgtge0 cA cr wcel
    cB cr wcel wa cA cA cmul co cr wcel cB cB cmul co cr wcel wa cA cc0 wne cA
    cr wcel cA cA cmul co cr wcel cB cr wcel cB cB cmul co cr wcel cA cr wcel
    cA cA cmul co cr wcel cA cA remulcl anidms cB cr wcel cB cB cmul co cr wcel
    cB cB remulcl anidms anim12i adantr cA cr wcel cA cc0 wne cB cr wcel cc0 cA
    cA cmul co clt wbr cc0 cB cB cmul co cle wbr wa cA cr wcel cA cc0 wne wa
    cc0 cA cA cmul co clt wbr cB cr wcel cc0 cB cB cmul co cle wbr cA msqgt0 cB
    msqge0 anim12i an1rs sylanc cA cA cmul co cr wcel cB cB cmul co cr wcel wa
    cc0 cA cA cmul co cle wbr cc0 cB cB cmul co clt wbr wa cc0 cA cA cmul co cB
    cB cmul co caddc co clt wbr cA cr wcel cB cr wcel wa cB cc0 wne wa cA cA
    cmul co cB cB cmul co addgegt0 cA cr wcel cB cr wcel wa cA cA cmul co cr
    wcel cB cB cmul co cr wcel wa cB cc0 wne cA cr wcel cA cA cmul co cr wcel
    cB cr wcel cB cB cmul co cr wcel cA cr wcel cA cA cmul co cr wcel cA cA
    remulcl anidms cB cr wcel cB cB cmul co cr wcel cB cB remulcl anidms
    anim12i adantr cA cr wcel cB cr wcel cB cc0 wne cc0 cA cA cmul co cle wbr
    cc0 cB cB cmul co clt wbr wa cA cr wcel cc0 cA cA cmul co cle wbr cB cr
    wcel cB cc0 wne wa cc0 cB cB cmul co clt wbr cA msqge0 cB msqgt0 anim12i
    anassrs sylanc jaodan cA ci cB cmul co caddc co cc0 wne cA cc0 wceq cB cc0
    wceq wa wn cA cc0 wne cB cc0 wne wo cA cc0 wceq cB cc0 wceq wa cA ci cB
    cmul co caddc co cc0 cA cc0 wceq cB cc0 wceq wa cA ci cB cmul co caddc co
    cc0 cc0 caddc co cc0 cA cc0 wceq ci cB cmul co cc0 wceq cA ci cB cmul co
    caddc co cc0 cc0 caddc co wceq cB cc0 wceq cA cc0 ci cB cmul co cc0 caddc
    opreq12 cB cc0 wceq ci cB cmul co ci cc0 cmul co cc0 cB cc0 ci cmul opreq2
    ci axicn mul01i syl6eq sylan2 cc0 0cn addid1i syl6eq necon3ai cA cc0 cB cc0
    neorian sylibr sylan2 3impa sylanc $.
    $( [11-Mar-2008] $) $( [23-May-2007] $)

  ${
    $d x y a b A $.
    $( Existence of reciprocal of nonzero complex number.  (Contributed by Eric
       Schmidt, 22-May-2007.) $)
    recex $p |- ( ( A e. CC /\ A =/= 0 ) -> E. x e. CC ( A x. x ) = 1 ) $=
      cA cc wcel cA cc0 wne cA vx cv cmul co c1 wceq vx cc wrex cA cc wcel cA
      va cv ci vb cv cmul co caddc co wceq vb cr wrex va cr wrex cA cc0 wne cA
      vx cv cmul co c1 wceq vx cc wrex wi va vb cA axcnre cA va cv ci vb cv
      cmul co caddc co wceq cA cc0 wne cA vx cv cmul co c1 wceq vx cc wrex wi
      va vb cr cr va cv cr wcel vb cv cr wcel wa cA va cv ci vb cv cmul co
      caddc co wceq cA cc0 wne cA vx cv cmul co c1 wceq vx cc wrex wi va cv cr
      wcel vb cv cr wcel wa cA va cv ci vb cv cmul co caddc co wceq wa va cv ci
      vb cv cmul co caddc co cc0 wne va cv ci vb cv cmul co caddc co vx cv cmul
      co c1 wceq vx cc wrex cA cc0 wne cA vx cv cmul co c1 wceq vx cc wrex va
      cv cr wcel vb cv cr wcel wa va cv ci vb cv cmul co caddc co cc0 wne va cv
      ci vb cv cmul co caddc co vx cv cmul co c1 wceq vx cc wrex wi cA va cv ci
      vb cv cmul co caddc co wceq va cv cr wcel vb cv cr wcel wa va cv ci vb cv
      cmul co caddc co cc0 wne va cv va cv cmul co vb cv vb cv cmul co caddc co
      cc0 wne va cv ci vb cv cmul co caddc co vx cv cmul co c1 wceq vx cc wrex
      va cv cr wcel vb cv cr wcel va cv ci vb cv cmul co caddc co cc0 wne va cv
      va cv cmul co vb cv vb cv cmul co caddc co cc0 wne va cv vb cv recextlem2
      3expia va cv cr wcel vb cv cr wcel wa va cv va cv cmul co vb cv vb cv
      cmul co caddc co cc0 wne va cv ci vb cv cmul co caddc co vx cv cmul co c1
      wceq vx cc wrex va cv cr wcel vb cv cr wcel wa va cv va cv cmul co vb cv
      vb cv cmul co caddc co cc0 wne wa va cv va cv cmul co vb cv vb cv cmul co
      caddc co vy cv cmul co c1 wceq vy cr wrex va cv ci vb cv cmul co caddc co
      vx cv cmul co c1 wceq vx cc wrex va cv va cv cmul co vb cv vb cv cmul co
      caddc co cr wcel va cv va cv cmul co vb cv vb cv cmul co caddc co cc0 wne
      va cv va cv cmul co vb cv vb cv cmul co caddc co vy cv cmul co c1 wceq vy
      cr wrex va cv cr wcel vb cv cr wcel wa vy va cv va cv cmul co vb cv vb cv
      cmul co caddc co axrrecex va cv va cv cmul co cr wcel vb cv vb cv cmul co
      cr wcel va cv va cv cmul co vb cv vb cv cmul co caddc co cr wcel va cv cr
      wcel vb cv cr wcel va cv va cv cmul co vb cv vb cv cmul co readdcl va cv
      cr wcel va cv va cv cmul co cr wcel va cv va cv remulcl anidms vb cv cr
      wcel vb cv vb cv cmul co cr wcel vb cv vb cv remulcl anidms syl2an sylan
      va cv cr wcel vb cv cr wcel wa va cv va cv cmul co vb cv vb cv cmul co
      caddc co vy cv cmul co c1 wceq vy cr wrex va cv ci vb cv cmul co caddc co
      vx cv cmul co c1 wceq vx cc wrex wi va cv va cv cmul co vb cv vb cv cmul
      co caddc co cc0 wne va cv cc wcel vb cv cc wcel va cv va cv cmul co vb cv
      vb cv cmul co caddc co vy cv cmul co c1 wceq vy cr wrex va cv ci vb cv
      cmul co caddc co vx cv cmul co c1 wceq vx cc wrex wi va cv cr wcel vb cv
      cr wcel va cv cc wcel vb cv cc wcel wa va cv va cv cmul co vb cv vb cv
      cmul co caddc co vy cv cmul co c1 wceq va cv ci vb cv cmul co caddc co vx
      cv cmul co c1 wceq vx cc wrex vy cr va cv cc wcel vb cv cc wcel wa vy cv
      cc wcel va cv va cv cmul co vb cv vb cv cmul co caddc co vy cv cmul co c1
      wceq va cv ci vb cv cmul co caddc co vx cv cmul co c1 wceq vx cc wrex wi
      vy cv cr wcel va cv cc wcel vb cv cc wcel wa vy cv cc wcel va cv va cv
      cmul co vb cv vb cv cmul co caddc co vy cv cmul co c1 wceq va cv ci vb cv
      cmul co caddc co vx cv cmul co c1 wceq vx cc wrex va cv ci vb cv cmul co
      cmin co vy cv cmul co cc wcel va cv ci vb cv cmul co caddc co va cv ci vb
      cv cmul co cmin co vy cv cmul co cmul co c1 wceq va cv ci vb cv cmul co
      caddc co vx cv cmul co c1 wceq vx cc wrex va cv cc wcel vb cv cc wcel wa
      vy cv cc wcel wa va cv va cv cmul co vb cv vb cv cmul co caddc co vy cv
      cmul co c1 wceq wa va cv ci vb cv cmul co caddc co vx cv cmul co c1 wceq
      va cv ci vb cv cmul co caddc co va cv ci vb cv cmul co cmin co vy cv cmul
      co cmul co c1 wceq vx va cv ci vb cv cmul co cmin co vy cv cmul co cc vx
      cv va cv ci vb cv cmul co cmin co vy cv cmul co wceq va cv ci vb cv cmul
      co caddc co vx cv cmul co va cv ci vb cv cmul co caddc co va cv ci vb cv
      cmul co cmin co vy cv cmul co cmul co c1 vx cv va cv ci vb cv cmul co
      cmin co vy cv cmul co va cv ci vb cv cmul co caddc co cmul opreq2 eqeq1d
      rcla4ev va cv cc wcel vb cv cc wcel wa vy cv cc wcel wa va cv ci vb cv
      cmul co cmin co vy cv cmul co cc wcel va cv va cv cmul co vb cv vb cv
      cmul co caddc co vy cv cmul co c1 wceq va cv ci vb cv cmul co cmin co cc
      wcel vy cv cc wcel va cv ci vb cv cmul co cmin co vy cv cmul co cc wcel
      va cv cc wcel vb cv cc wcel wa va cv ci vb cv cmul co cmin co vy cv mulcl
      va cv cc wcel ci vb cv cmul co cc wcel va cv ci vb cv cmul co cmin co cc
      wcel vb cv cc wcel va cv ci vb cv cmul co subcl ci cc wcel vb cv cc wcel
      ci vb cv cmul co cc wcel axicn ci vb cv mulcl mpan sylan2 sylan adantr va
      cv cc wcel vb cv cc wcel wa vy cv cc wcel wa va cv va cv cmul co vb cv vb
      cv cmul co caddc co vy cv cmul co c1 wceq va cv ci vb cv cmul co caddc co
      va cv ci vb cv cmul co cmin co vy cv cmul co cmul co va cv va cv cmul co
      vb cv vb cv cmul co caddc co vy cv cmul co c1 va cv cc wcel vb cv cc wcel
      wa vy cv cc wcel wa va cv ci vb cv cmul co caddc co va cv ci vb cv cmul
      co cmin co cmul co vy cv cmul co va cv ci vb cv cmul co caddc co va cv ci
      vb cv cmul co cmin co vy cv cmul co cmul co va cv va cv cmul co vb cv vb
      cv cmul co caddc co vy cv cmul co va cv ci vb cv cmul co caddc co cc wcel
      va cv ci vb cv cmul co cmin co cc wcel vy cv cc wcel va cv ci vb cv cmul
      co caddc co va cv ci vb cv cmul co cmin co cmul co vy cv cmul co va cv ci
      vb cv cmul co caddc co va cv ci vb cv cmul co cmin co vy cv cmul co cmul
      co wceq va cv cc wcel vb cv cc wcel wa vy cv cc wcel wa va cv ci vb cv
      cmul co caddc co va cv ci vb cv cmul co cmin co vy cv mulass va cv cc
      wcel vb cv cc wcel wa va cv ci vb cv cmul co caddc co cc wcel vy cv cc
      wcel va cv cc wcel ci vb cv cmul co cc wcel va cv ci vb cv cmul co caddc
      co cc wcel vb cv cc wcel va cv ci vb cv cmul co addcl ci cc wcel vb cv cc
      wcel ci vb cv cmul co cc wcel axicn ci vb cv mulcl mpan sylan2 adantr va
      cv cc wcel vb cv cc wcel wa va cv ci vb cv cmul co cmin co cc wcel vy cv
      cc wcel va cv cc wcel ci vb cv cmul co cc wcel va cv ci vb cv cmul co
      cmin co cc wcel vb cv cc wcel va cv ci vb cv cmul co subcl ci cc wcel vb
      cv cc wcel ci vb cv cmul co cc wcel axicn ci vb cv mulcl mpan sylan2
      adantr va cv cc wcel vb cv cc wcel wa vy cv cc wcel pm3.27 syl3anc va cv
      cc wcel vb cv cc wcel wa vy cv cc wcel wa va cv ci vb cv cmul co caddc co
      va cv ci vb cv cmul co cmin co cmul co va cv va cv cmul co vb cv vb cv
      cmul co caddc co vy cv cmul va cv cc wcel vb cv cc wcel wa va cv ci vb cv
      cmul co caddc co va cv ci vb cv cmul co cmin co cmul co va cv va cv cmul
      co vb cv vb cv cmul co caddc co wceq vy cv cc wcel va cv vb cv recextlem1
      adantr opreq1d eqtr3d va cv va cv cmul co vb cv vb cv cmul co caddc co vy
      cv cmul co c1 wceq id sylan9eq sylanc exp31 vy cv recn syl5 r19.23adv va
      cv recn vb cv recn syl2an adantr mpd ex syld adantr cA va cv ci vb cv
      cmul co caddc co wceq cA cc0 wne va cv ci vb cv cmul co caddc co cc0 wne
      wb va cv cr wcel vb cv cr wcel wa cA va cv ci vb cv cmul co caddc co cc0
      neeq1 adantl cA va cv ci vb cv cmul co caddc co wceq cA vx cv cmul co c1
      wceq vx cc wrex va cv ci vb cv cmul co caddc co vx cv cmul co c1 wceq vx
      cc wrex wb va cv cr wcel vb cv cr wcel wa cA va cv ci vb cv cmul co caddc
      co wceq cA vx cv cmul co c1 wceq va cv ci vb cv cmul co caddc co vx cv
      cmul co c1 wceq vx cc cA va cv ci vb cv cmul co caddc co wceq cA vx cv
      cmul co va cv ci vb cv cmul co caddc co vx cv cmul co c1 cA va cv ci vb
      cv cmul co caddc co vx cv cmul opreq1 eqeq1d rexbidv adantl 3imtr4d ex
      r19.23aivv syl imp $.
      $( [11-Mar-2008] $) $( [23-May-2007] $)
  $}

  ${
    $d x A $.
    recex.1 $e |- A e. CC $.
    recex.2 $e |- A =/= 0 $.
    $( Existence of reciprocals. $)
    recexi $p |- E. x e. CC ( A x. x ) = 1 $=
      cA cc wcel cA cc0 wne cA vx cv cmul co c1 wceq vx cc wrex recex.1 recex.2
      vx cA recex mp2an $.
      $( [26-Jan-1995] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    mulcan.1 $e |- A e. CC $.
    mulcan.2 $e |- B e. CC $.
    mulcan.3 $e |- C e. CC $.
    mulcan.4 $e |- C =/= 0 $.
    $( Cancellation law for multiplication.  Theorem I.7 of [Apostol]
       p. 18. $)
    mulcani $p |- ( ( C x. A ) = ( C x. B ) <-> A = B ) $=
      cC cA cmul co cC cB cmul co wceq cA cB wceq cC vx cv cmul co c1 wceq vx
      cc wrex cC cA cmul co cC cB cmul co wceq cA cB wceq wi vx cC mulcan.3
      mulcan.4 recexi cC vx cv cmul co c1 wceq cC cA cmul co cC cB cmul co wceq
      cA cB wceq wi vx cc vx cv cc wcel cC vx cv cmul co c1 wceq wa cC cA cmul
      co cC cB cmul co wceq vx cv cC cmul co cA cmul co vx cv cC cmul co cB
      cmul co wceq cA cB wceq vx cv cc wcel cC cA cmul co cC cB cmul co wceq vx
      cv cC cmul co cA cmul co vx cv cC cmul co cB cmul co wceq wi cC vx cv
      cmul co c1 wceq vx cv cc wcel vx cv cC cmul co cA cmul co vx cv cC cmul
      co cB cmul co wceq vx cv cC cA cmul co cmul co vx cv cC cB cmul co cmul
      co wceq cC cA cmul co cC cB cmul co wceq vx cv cc wcel cC cc wcel vx cv
      cC cmul co cA cmul co vx cv cC cmul co cB cmul co wceq vx cv cC cA cmul
      co cmul co vx cv cC cB cmul co cmul co wceq wb mulcan.3 vx cv cc wcel cC
      cc wcel wa vx cv cC cmul co cA cmul co vx cv cC cA cmul co cmul co vx cv
      cC cmul co cB cmul co vx cv cC cB cmul co cmul co vx cv cc wcel cC cc
      wcel cA cc wcel vx cv cC cmul co cA cmul co vx cv cC cA cmul co cmul co
      wceq mulcan.1 vx cv cC cA mulass mp3an3 vx cv cc wcel cC cc wcel cB cc
      wcel vx cv cC cmul co cB cmul co vx cv cC cB cmul co cmul co wceq
      mulcan.2 vx cv cC cB mulass mp3an3 eqeq12d mpan2 cC cA cmul co cC cB cmul
      co vx cv cmul opreq2 syl5bir adantr vx cv cc wcel cC vx cv cmul co c1
      wceq vx cv cC cmul co cA cmul co vx cv cC cmul co cB cmul co wceq cA cB
      wceq wb vx cv cc wcel cC vx cv cmul co c1 wceq vx cv cC cmul co c1 wceq
      vx cv cC cmul co cA cmul co vx cv cC cmul co cB cmul co wceq cA cB wceq
      wb vx cv cc wcel cC vx cv cmul co vx cv cC cmul co c1 cC cc wcel vx cv cc
      wcel cC vx cv cmul co vx cv cC cmul co wceq mulcan.3 cC vx cv mulcom mpan
      eqeq1d vx cv cC cmul co c1 wceq vx cv cC cmul co cA cmul co cA vx cv cC
      cmul co cB cmul co cB vx cv cC cmul co c1 wceq vx cv cC cmul co cA cmul
      co c1 cA cmul co cA vx cv cC cmul co c1 cA cmul opreq1 cA mulcan.1
      mulid2i syl6eq vx cv cC cmul co c1 wceq vx cv cC cmul co cB cmul co c1 cB
      cmul co cB vx cv cC cmul co c1 cB cmul opreq1 cB mulcan.2 mulid2i syl6eq
      eqeq12d syl6bi imp sylibd r19.23aiva ax-mp cA cB cC cmul opreq2 impbii $.
      $( [24-Aug-2008] $) $( [26-Jan-1995] $)
  $}

  ${
    mulcant2.1 $e |- C =/= 0 $.
    $( Cancellation law for multiplication.  Theorem I.7 of [Apostol] p. 18.
       Illustrates use of ~ keephyp . $)
    mulcant2i $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                   ( ( C x. A ) = ( C x. B ) <-> A = B ) ) $=
      cA cc wcel cB cc wcel cC cc wcel cC cA cmul co cC cB cmul co wceq cA cB
      wceq wb cC cA cc wcel cA c1 cif cmul co cC cB cmul co wceq cA cc wcel cA
      c1 cif cB wceq wb cA cB cC c1 c1 c1 cC cA cc wcel cA c1 cif cmul co cC cB
      cc wcel cB c1 cif cmul co wceq cA cc wcel cA c1 cif cB cc wcel cB c1 cif
      wceq wb cC cc wcel cC c1 cif cA cc wcel cA c1 cif cmul co cC cc wcel cC
      c1 cif cB cc wcel cB c1 cif cmul co wceq cA cc wcel cA c1 cif cB cc wcel
      cB c1 cif wceq wb cA cA cc wcel cA c1 cif wceq cC cA cmul co cC cB cmul
      co wceq cC cA cc wcel cA c1 cif cmul co cC cB cmul co wceq cA cB wceq cA
      cc wcel cA c1 cif cB wceq cA cA cc wcel cA c1 cif wceq cC cA cmul co cC
      cA cc wcel cA c1 cif cmul co cC cB cmul co cA cA cc wcel cA c1 cif cC
      cmul opreq2 eqeq1d cA cA cc wcel cA c1 cif cB eqeq1 bibi12d cB cB cc wcel
      cB c1 cif wceq cC cA cc wcel cA c1 cif cmul co cC cB cmul co wceq cC cA
      cc wcel cA c1 cif cmul co cC cB cc wcel cB c1 cif cmul co wceq cA cc wcel
      cA c1 cif cB wceq cA cc wcel cA c1 cif cB cc wcel cB c1 cif wceq cB cB cc
      wcel cB c1 cif wceq cC cB cmul co cC cB cc wcel cB c1 cif cmul co cC cA
      cc wcel cA c1 cif cmul co cB cB cc wcel cB c1 cif cC cmul opreq2 eqeq2d
      cB cB cc wcel cB c1 cif cA cc wcel cA c1 cif eqeq2 bibi12d cC cC cc wcel
      cC c1 cif wceq cC cA cc wcel cA c1 cif cmul co cC cB cc wcel cB c1 cif
      cmul co wceq cC cc wcel cC c1 cif cA cc wcel cA c1 cif cmul co cC cc wcel
      cC c1 cif cB cc wcel cB c1 cif cmul co wceq cA cc wcel cA c1 cif cB cc
      wcel cB c1 cif wceq cC cC cc wcel cC c1 cif wceq cC cA cc wcel cA c1 cif
      cmul co cC cc wcel cC c1 cif cA cc wcel cA c1 cif cmul co cC cB cc wcel
      cB c1 cif cmul co cC cc wcel cC c1 cif cB cc wcel cB c1 cif cmul co cC cC
      cc wcel cC c1 cif cA cc wcel cA c1 cif cmul opreq1 cC cC cc wcel cC c1
      cif cB cc wcel cB c1 cif cmul opreq1 eqeq12d bibi1d cA cc wcel cA c1 cif
      cB cc wcel cB c1 cif cC cc wcel cC c1 cif cA c1 cc ax1cn elimel cB c1 cc
      ax1cn elimel cC c1 cc ax1cn elimel cC cc wcel cC cc0 wne c1 cc0 wne cC cc
      wcel cC c1 cif cc0 wne cC c1 cC cC cc wcel cC c1 cif cc0 neeq1 c1 cC cc
      wcel cC c1 cif cc0 neeq1 mulcant2.1 ax1ne0 keephyp mulcani dedth3h $.
      $( [25-Aug-2008] $) $( [29-Jan-1995] $)
  $}

  $( Cancellation law for multiplication (full theorem form).  Theorem I.7
     of [Apostol] p. 18.  Illustrates use of ~ dedth and ~ elimne0 . $)
  mulcan $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
                 ( ( C x. A ) = ( C x. B ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cC cA cmul co cC cB cmul co
    wceq cA cB wceq wb cA cc wcel cB cc wcel cC cc wcel cC cc0 wne cC cA cmul
    co cC cB cmul co wceq cA cB wceq wb cC cc0 wne cA cc wcel cB cc wcel cC cc
    wcel cC cA cmul co cC cB cmul co wceq cA cB wceq wb cC cc0 wne cA cc wcel
    cB cc wcel cC cc wcel cC cA cmul co cC cB cmul co wceq cA cB wceq wb cC cc0
    wne cA cc wcel cB cc wcel cC cc wcel w3a cC cA cmul co cC cB cmul co wceq
    cA cB wceq wb wi cA cc wcel cB cc wcel cC cc0 wne cC c1 cif cc wcel w3a cC
    cc0 wne cC c1 cif cA cmul co cC cc0 wne cC c1 cif cB cmul co wceq cA cB
    wceq wb wi cC c1 cC cC cc0 wne cC c1 cif wceq cA cc wcel cB cc wcel cC cc
    wcel w3a cA cc wcel cB cc wcel cC cc0 wne cC c1 cif cc wcel w3a cC cA cmul
    co cC cB cmul co wceq cA cB wceq wb cC cc0 wne cC c1 cif cA cmul co cC cc0
    wne cC c1 cif cB cmul co wceq cA cB wceq wb cC cC cc0 wne cC c1 cif wceq cC
    cc wcel cC cc0 wne cC c1 cif cc wcel cA cc wcel cB cc wcel cC cC cc0 wne cC
    c1 cif cc eleq1 3anbi3d cC cC cc0 wne cC c1 cif wceq cC cA cmul co cC cB
    cmul co wceq cC cc0 wne cC c1 cif cA cmul co cC cc0 wne cC c1 cif cB cmul
    co wceq cA cB wceq cC cC cc0 wne cC c1 cif wceq cC cA cmul co cC cc0 wne cC
    c1 cif cA cmul co cC cB cmul co cC cc0 wne cC c1 cif cB cmul co cC cC cc0
    wne cC c1 cif cA cmul opreq1 cC cC cc0 wne cC c1 cif cB cmul opreq1 eqeq12d
    bibi1d imbi12d cA cB cC cc0 wne cC c1 cif cC elimne0 mulcant2i dedth 3expd
    com4l imp4a 3imp $.
    $( [26-Aug-2008] $) $( [29-Jan-1995] $)

  $( Cancellation law for multiplication. $)
  mulcan2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
                 ( ( A x. C ) = ( B x. C ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cC cmul co cB cC cmul
    co wceq cC cA cmul co cC cB cmul co wceq cA cB wceq cA cc wcel cB cc wcel
    cC cc wcel cA cC cmul co cB cC cmul co wceq cC cA cmul co cC cB cmul co
    wceq wb cC cc0 wne cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmul co cC cA
    cmul co cB cC cmul co cC cB cmul co cA cc wcel cC cc wcel cA cC cmul co cC
    cA cmul co wceq cB cc wcel cA cC mulcom 3adant2 cB cc wcel cC cc wcel cB cC
    cmul co cC cB cmul co wceq cA cc wcel cB cC mulcom 3adant1 eqeq12d 3adant3r
    cA cB cC mulcan bitrd $.
    $( [26-Aug-2008] $) $( [21-Jan-2005] $)

  ${
    mul0or.1 $e |- A e. CC $.
    ${
      mul0or.2 $e |- B e. CC $.
      $( If a product is zero, one of its factors must be zero.  Theorem I.11
         of [Apostol] p. 18. $)
      mul0ori $p |- ( ( A x. B ) = 0 <-> ( A = 0 \/ B = 0 ) ) $=
        cA cB cmul co cc0 wceq cA cc0 wceq cB cc0 wceq wo cA cB cmul co cc0
        wceq cA cc0 wceq cB cc0 wceq cA cc0 wceq wn cA cB cmul co cc0 wceq cB
        cc0 wceq cA cc0 wceq wn cA cc0 wne cA cB cmul co cc0 wceq cB cc0 wceq
        wi cA cc0 df-ne cA cc0 wne cA cB cmul co cc0 wceq cB cc0 wceq cA cc0
        wne cA cB cmul co cA cc0 cmul co wceq cB cc0 wceq cA cB cmul co cc0
        wceq cA cc wcel cA cc0 wne cA cB cmul co cA cc0 cmul co wceq cB cc0
        wceq wb mul0or.1 cB cc wcel cc0 cc wcel cA cc wcel cA cc0 wne wa cA cB
        cmul co cA cc0 cmul co wceq cB cc0 wceq wb mul0or.2 0cn cB cc0 cA
        mulcan mp3an12 mpan cA cc0 cmul co cc0 cA cB cmul co cA mul0or.1 mul01i
        eqeq2i syl5bbr biimpd sylbir com12 orrd cA cc0 wceq cA cB cmul co cc0
        wceq cB cc0 wceq cA cc0 wceq cA cB cmul co cc0 cB cmul co cc0 cA cc0 cB
        cmul opreq1 cB mul0or.2 mul02i syl6eq cB cc0 wceq cA cB cmul co cA cc0
        cmul co cc0 cB cc0 cA cmul opreq2 cA mul0or.1 mul01i syl6eq jaoi impbii
        $.
        $( [7-Oct-1999] $)
    $}

    $( A number is zero iff its square is zero (where square is represented
       using multiplication). $)
    msq0i $p |- ( ( A x. A ) = 0 <-> A = 0 ) $=
      cA cA cmul co cc0 wceq cA cc0 wceq cA cc0 wceq wo cA cc0 wceq cA cA
      mul0or.1 mul0or.1 mul0ori cA cc0 wceq oridm bitri $.
      $( [28-Jul-1999] $)
  $}

  $( If a product is zero, one of its factors must be zero.  Theorem I.11
     of [Apostol] p. 18. $)
  mul0or $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( ( A x. B ) = 0 <-> ( A = 0 \/ B = 0 ) ) ) $=
    cA cc wcel cB cc wcel cA cB cmul co cc0 wceq cA cc0 wceq cB cc0 wceq wo wb
    cA cc wcel cA cc0 cif cB cmul co cc0 wceq cA cc wcel cA cc0 cif cc0 wceq cB
    cc0 wceq wo wb cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co cc0 wceq
    cA cc wcel cA cc0 cif cc0 wceq cB cc wcel cB cc0 cif cc0 wceq wo wb cA cB
    cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB cmul co cc0 wceq cA cc wcel cA
    cc0 cif cB cmul co cc0 wceq cA cc0 wceq cB cc0 wceq wo cA cc wcel cA cc0
    cif cc0 wceq cB cc0 wceq wo cA cA cc wcel cA cc0 cif wceq cA cB cmul co cA
    cc wcel cA cc0 cif cB cmul co cc0 cA cA cc wcel cA cc0 cif cB cmul opreq1
    eqeq1d cA cA cc wcel cA cc0 cif wceq cA cc0 wceq cA cc wcel cA cc0 cif cc0
    wceq cB cc0 wceq cA cA cc wcel cA cc0 cif cc0 eqeq1 orbi1d bibi12d cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmul co cc0 wceq cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif cmul co cc0 wceq cA cc wcel cA cc0 cif cc0
    wceq cB cc0 wceq wo cA cc wcel cA cc0 cif cc0 wceq cB cc wcel cB cc0 cif
    cc0 wceq wo cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmul co
    cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co cc0 cB cB cc wcel cB
    cc0 cif cA cc wcel cA cc0 cif cmul opreq2 eqeq1d cB cB cc wcel cB cc0 cif
    wceq cB cc0 wceq cB cc wcel cB cc0 cif cc0 wceq cA cc wcel cA cc0 cif cc0
    wceq cB cB cc wcel cB cc0 cif cc0 eqeq1 orbi2d bibi12d cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel mul0ori
    dedth2h $.
    $( [9-Oct-1999] $)

  $( The product of two non-zero numbers is non-zero. $)
  muln0b $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A =/= 0 /\ B =/= 0 ) <->
               ( A x. B ) =/= 0 ) ) $=
    cA cc wcel cB cc wcel wa cA cc0 wceq cB cc0 wceq wo wn cA cB cmul co cc0
    wceq wn cA cc0 wne cB cc0 wne wa cA cB cmul co cc0 wne cA cc wcel cB cc
    wcel wa cA cB cmul co cc0 wceq wn cA cc0 wceq cB cc0 wceq wo wn cA cc wcel
    cB cc wcel wa cA cB cmul co cc0 wceq cA cc0 wceq cB cc0 wceq wo cA cB
    mul0or notbid bicomd cA cc0 cB cc0 neanior cA cB cmul co cc0 df-ne 3bitr4g
    $.
    $( [2-Aug-2004] $) $( [1-Aug-2004] $)

  $( The product of two non-zero numbers is non-zero. $)
  mulne0 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
               ( A x. B ) =/= 0 ) $=
    cA cc wcel cB cc wcel cA cc0 wne cB cc0 wne cA cB cmul co cc0 wne cA cc
    wcel cB cc wcel wa cA cc0 wne cB cc0 wne wa cA cB cmul co cc0 wne cA cB
    muln0b biimpa an4s $.
    $( [30-Dec-2007] $) $( [30-Dec-2007] $)

  ${
    muln0.1 $e |- A e. CC $.
    muln0.2 $e |- B e. CC $.
    muln0.3 $e |- A =/= 0 $.
    muln0.4 $e |- B =/= 0 $.
    $( The product of two non-zero numbers is non-zero. $)
    muln0i $p |- ( A x. B ) =/= 0 $=
      cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa cA cB cmul co cc0 wne
      cA cc wcel cA cc0 wne muln0.1 muln0.3 pm3.2i cB cc wcel cB cc0 wne
      muln0.2 muln0.4 pm3.2i cA cB mulne0 mp2an $.
      $( [15-Feb-1995] $)
  $}

  $( Property of numbers whose product equals their sum.  Equation 5 of
     [Kreyszig] p. 12. $)
  muleqadd $p |- ( ( A e. CC /\ B e. CC ) ->
             ( ( A x. B ) = ( A + B ) <-> ( ( A - 1 ) x. ( B - 1 ) ) = 1 ) ) $=
    cA cc wcel cB cc wcel wa cA c1 cmin co cB c1 cmin co cmul co c1 wceq cA cB
    cmul co cA cB caddc co cmin co c1 caddc co c1 wceq cA cB cmul co cA cB
    caddc co cmin co cc0 wceq cA cB cmul co cA cB caddc co wceq cA cc wcel cB
    cc wcel wa cA c1 cmin co cB c1 cmin co cmul co cA cB cmul co cA cB caddc co
    cmin co c1 caddc co c1 cA cc wcel cB cc wcel wa cA c1 cmin co cB c1 cmin co
    cmul co cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co cA cB cmul co c1 caddc co cA cB caddc co cmin co cA cB
    cmul co cA cB caddc co cmin co c1 caddc co cA cc wcel c1 cc wcel cB cc wcel
    cA c1 cmin co cB c1 cmin co cmul co cA cB cmul co c1 c1 cmul co caddc co cA
    c1 cmul co cB c1 cmul co caddc co cmin co wceq ax1cn cA cc wcel c1 cc wcel
    wa cB cc wcel c1 cc wcel cA c1 cmin co cB c1 cmin co cmul co cA cB cmul co
    c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co caddc co cmin co wceq
    ax1cn cA c1 cB c1 mulsub mpanr2 mpanl2 cA cc wcel cB cc wcel wa cA cB cmul
    co c1 c1 cmul co caddc co cA cB cmul co c1 caddc co cA c1 cmul co cB c1
    cmul co caddc co cA cB caddc co cmin cA cB cmul co c1 c1 cmul co caddc co
    cA cB cmul co c1 caddc co wceq cA cc wcel cB cc wcel wa c1 c1 cmul co c1 cA
    cB cmul co caddc c1 ax1cn mulid1i opreq2i a1i cA cc wcel cB cc wcel cA c1
    cmul co cA cB c1 cmul co cB caddc cA ax1id cB ax1id opreqan12d opreq12d cA
    cB cmul co cc wcel cA cB caddc co cc wcel cA cB cmul co c1 caddc co cA cB
    caddc co cmin co cA cB cmul co cA cB caddc co cmin co c1 caddc co wceq cA
    cc wcel cB cc wcel wa cA cB cmul co cc wcel c1 cc wcel cA cB caddc co cc
    wcel cA cB cmul co c1 caddc co cA cB caddc co cmin co cA cB cmul co cA cB
    caddc co cmin co c1 caddc co wceq ax1cn cA cB cmul co c1 cA cB caddc co
    addsub mp3an2 cA cB mulcl cA cB addcl sylanc 3eqtrd eqeq1d cA cc wcel cB cc
    wcel wa cA cB cmul co cA cB caddc co cmin co c1 caddc co cc0 c1 caddc co
    wceq cA cB cmul co cA cB caddc co cmin co cc0 wceq cA cB cmul co cA cB
    caddc co cmin co c1 caddc co c1 wceq cA cc wcel cB cc wcel wa cA cB cmul co
    cA cB caddc co cmin co cc wcel cA cB cmul co cA cB caddc co cmin co c1
    caddc co cc0 c1 caddc co wceq cA cB cmul co cA cB caddc co cmin co cc0 wceq
    wb cA cB cmul co cc wcel cA cB caddc co cc wcel cA cB cmul co cA cB caddc
    co cmin co cc wcel cA cc wcel cB cc wcel wa cA cB cmul co cA cB caddc co
    subcl cA cB mulcl cA cB addcl sylanc cA cB cmul co cA cB caddc co cmin co
    cc wcel cc0 cc wcel c1 cc wcel cA cB cmul co cA cB caddc co cmin co c1
    caddc co cc0 c1 caddc co wceq cA cB cmul co cA cB caddc co cmin co cc0 wceq
    wb 0cn ax1cn cA cB cmul co cA cB caddc co cmin co cc0 c1 addcan2 mp3an23
    syl cc0 c1 caddc co c1 cA cB cmul co cA cB caddc co cmin co c1 caddc co c1
    ax1cn addid2i eqeq2i syl5rbbr cA cB cmul co cc wcel cA cB caddc co cc wcel
    cA cB cmul co cA cB caddc co cmin co cc0 wceq cA cB cmul co cA cB caddc co
    wceq wb cA cc wcel cB cc wcel wa cA cB cmul co cA cB caddc co subeq0 cA cB
    mulcl cA cB addcl sylanc 3bitr2rd $.
    $( [13-Nov-2006] $) $( [13-Nov-2006] $)

  ${
    $d x y A $.  $d x y B $.
    receu.1 $e |- A e. CC $.
    receu.2 $e |- B e. CC $.
    receu.3 $e |- A =/= 0 $.
    $( Existential uniqueness of reciprocals.  Theorem I.8 of [Apostol]
       p. 18. $)
    receui $p |- E! x e. CC ( A x. x ) = B $=
      cA vx cv cmul co cB wceq vx cc wreu cA vx cv cmul co cB wceq vx cc wrex
      cA vx cv cmul co cB wceq cA vy cv cmul co cB wceq wa vx cv vy cv wceq wi
      vy cc wral vx cc wral cA vx cv cmul co cB wceq cA vy cv cmul co cB wceq
      vx vy cc vx cv vy cv wceq cA vx cv cmul co cA vy cv cmul co cB vx cv vy
      cv cA cmul opreq2 eqeq1d reu4 cA vy cv cmul co c1 wceq vy cc wrex cA vx
      cv cmul co cB wceq vx cc wrex vy cA receu.1 receu.3 recexi cA vy cv cmul
      co c1 wceq cA vx cv cmul co cB wceq vx cc wrex vy cc vy cv cc wcel cA vy
      cv cmul co c1 wceq vx cv vy cv cB cmul co wceq vx cc wrex cA vx cv cmul
      co cB wceq vx cc wrex vy cv cc wcel vy cv cB cmul co cc wcel vx cv vy cv
      cB cmul co wceq vx cc wrex vy cv cc wcel cB cc wcel vy cv cB cmul co cc
      wcel receu.2 vy cv cB mulcl mpan2 vx vy cv cB cmul co cc risset sylib vy
      cv cc wcel cA vy cv cmul co c1 wceq vx cv vy cv cB cmul co wceq cA vx cv
      cmul co cB wceq wi vx cc wral vx cv vy cv cB cmul co wceq vx cc wrex cA
      vx cv cmul co cB wceq vx cc wrex wi vy cv cc wcel cA vy cv cmul co c1
      wceq vx cv vy cv cB cmul co wceq cA vx cv cmul co cB wceq wi vx cc wral
      vy cv cc wcel cA vy cv cmul co c1 wceq wa vx cv vy cv cB cmul co wceq cA
      vx cv cmul co cB wceq wi vx cc vy cv cc wcel cA vy cv cmul co c1 wceq wa
      vx cv vy cv cB cmul co wceq cA vx cv cmul co cB wceq wi vx cv cc wcel cA
      vy cv cmul co c1 wceq vy cv cc wcel vx cv vy cv cB cmul co wceq cA vx cv
      cmul co cB wceq wi cA vy cv cmul co c1 wceq vy cv cc wcel vx cv vy cv cB
      cmul co wceq cA vx cv cmul co cB wceq vy cv cc wcel vx cv vy cv cB cmul
      co wceq wa cA vy cv cmul co c1 wceq cA vx cv cmul co cA vy cv cmul co cB
      cmul co cB vx cv vy cv cB cmul co wceq vy cv cc wcel cA vx cv cmul co cA
      vy cv cB cmul co cmul co cA vy cv cmul co cB cmul co vx cv vy cv cB cmul
      co cA cmul opreq2 vy cv cc wcel cA vy cv cmul co cB cmul co cA vy cv cB
      cmul co cmul co cA cc wcel vy cv cc wcel cB cc wcel cA vy cv cmul co cB
      cmul co cA vy cv cB cmul co cmul co wceq receu.1 receu.2 cA vy cv cB
      mulass mp3an13 eqcomd sylan9eqr cA vy cv cmul co c1 wceq cA vy cv cmul co
      cB cmul co c1 cB cmul co cB cA vy cv cmul co c1 cB cmul opreq1 cB receu.2
      mulid2i syl6eq sylan9eqr exp32 impcom a1d r19.21aiv ex vx cv vy cv cB
      cmul co wceq cA vx cv cmul co cB wceq vx cc r19.22 syl6 mpid r19.23aiv
      ax-mp cA vx cv cmul co cB wceq cA vy cv cmul co cB wceq wa vx cv vy cv
      wceq wi vx vy cc vx cv cc wcel vy cv cc wcel cA cc wcel cA vx cv cmul co
      cB wceq cA vy cv cmul co cB wceq wa vx cv vy cv wceq wi receu.1 vx cv cc
      wcel vy cv cc wcel cA cc wcel w3a cA vx cv cmul co cA vy cv cmul co wceq
      vx cv vy cv wceq cA vx cv cmul co cB wceq cA vy cv cmul co cB wceq wa vx
      cv vy cv cA receu.3 mulcant2i cA vx cv cmul co cA vy cv cmul co cB eqtr3
      syl5bi mp3an3 rgen2a mpbir2an $.
      $( [29-Jan-1995] $)
  $}

  ${
    $d x y $.
    $( Multiplication maps nonzero complex numbers to nonzero complex numbers.
      (Contributed by Steve Rodriguez, 23-Feb-2007.) $)
    mulnzcnopr $p |- ( x. |` ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) ) :
                             ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) -->
                             ( CC \ { 0 } ) $=
      cc cc0 csn cdif cc cc0 csn cdif cxp cc cc0 csn cdif cmul cc cc0 csn cdif
      cc cc0 csn cdif cxp cres wf cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      cc cc0 csn cdif cc cc0 csn cdif cxp wfn vx cv vy cv cmul cc cc0 csn cdif
      cc cc0 csn cdif cxp cres co cc cc0 csn cdif wcel vy cc cc0 csn cdif wral
      vx cc cc0 csn cdif wral vx vy cc cc0 csn cdif cc cc0 csn cdif cc cc0 csn
      cdif cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres ffnoprv cmul cc cc cxp
      wfn cc cc0 csn cdif cc cc0 csn cdif cxp cc cc cxp wss cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres cc cc0 csn cdif cc cc0 csn cdif cxp wfn
      cmul cc cc cxp wfn vx cv vy cv cmul co cc wcel vy cc wral vx cc wral cc
      cc cxp cc cmul wf cmul cc cc cxp wfn vx cv vy cv cmul co cc wcel vy cc
      wral vx cc wral wa axmulopr vx vy cc cc cc cmul ffnoprv mpbi pm3.26i cc
      cc0 csn cdif cc wss cc cc0 csn cdif cc wss cc cc0 csn cdif cc cc0 csn
      cdif cxp cc cc cxp wss cc cc0 csn difss cc cc0 csn difss cc cc0 csn cdif
      cc cc cc0 csn cdif cc ssxp mp2an cc cc cxp cc cc0 csn cdif cc cc0 csn
      cdif cxp cmul fnssres mp2an vx cv vy cv cmul cc cc0 csn cdif cc cc0 csn
      cdif cxp cres co cc cc0 csn cdif wcel vx vy cc cc0 csn cdif vx cv cc cc0
      csn cdif wcel vy cv cc cc0 csn cdif wcel wa vx cv vy cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv vy cv cmul co cc cc0 csn cdif vx
      cv vy cv cc cc0 csn cdif cc cc0 csn cdif cmul oprvres vx cv cc cc0 csn
      cdif wcel vy cv cc cc0 csn cdif wcel wa vx cv vy cv cmul co cc wcel vx cv
      vy cv cmul co cc0 wne wa vx cv vy cv cmul co cc cc0 csn cdif wcel vx cv
      cc wcel vx cv cc0 wne wa vy cv cc wcel vy cv cc0 wne wa vx cv vy cv cmul
      co cc wcel vx cv vy cv cmul co cc0 wne wa vx cv cc cc0 csn cdif wcel vy
      cv cc cc0 csn cdif wcel vx cv cc wcel vx cv cc0 wne wa vy cv cc wcel vy
      cv cc0 wne wa wa vx cv vy cv cmul co cc wcel vx cv vy cv cmul co cc0 wne
      vx cv cc wcel vy cv cc wcel vx cv vy cv cmul co cc wcel vx cv cc0 wne vy
      cv cc0 wne vx cv vy cv mulcl ad2ant2r vx cv vy cv mulne0 jca vx cv cc cc0
      eldifsn vy cv cc cc0 eldifsn syl2anb vx cv vy cv cmul co cc cc0 eldifsn
      sylibr eqeltrd rgen2a mpbir2an $.
      $( [24-Feb-2007] $) $( [17-Feb-2007] $)
 $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Division
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.
    $( Define division.  Theorem ~ divmuli relates it to multiplication, and
       ~ divcli and ~ redivcli prove its closure laws. $)
    df-div $a |- / = { <. <. x , y >. , z >. |
                   ( ( x e. CC /\ y e. ( CC \ { 0 } ) ) /\
                   z = U. { w e. CC | ( y x. w ) = x } ) } $.
    $(
    Future simpler alternative?
    df-div $a |- / = { <. <. x , y >. , z >. |
                ( ( y e. CC /\ z e. CC ) /\  x = ( y x. z ) ) } $.
    $)
  $}


  ${
    $d x y z w A $.  $d x y z w B $.
    divval.1 $e |- A e. CC $.
    divval.2 $e |- B e. CC $.
    divval.3 $e |- B =/= 0 $.
    $( Value of division: the (unique) element ` x ` such that
        ` ( B x. x ) = A ` .  This is meaningful only when ` B ` is nonzero. $)
    divvali $p |- ( A / B ) = U. { x e. CC | ( B x. x ) = A } $=
      cA cc wcel cB cc cc0 csn cdif wcel cA cB cdiv co cB vx cv cmul co cA wceq
      vx cc crab cuni wceq divval.1 cB cc cc0 csn cdif wcel cB cc wcel cB cc0
      wne cB cc cc0 eldifsn divval.2 divval.3 mpbir2an vy vz vw cA cB cc cc cc0
      csn cdif vz cv vx cv cmul co vy cv wceq vx cc crab cuni cB vx cv cmul co
      cA wceq vx cc crab cuni cdiv vz cv vx cv cmul co cA wceq vx cc crab cuni
      cB vx cv cmul co cA wceq vx cc crab cB vx cv cmul co cA wceq vx cc axcnex
      rabex uniex vy cv cA wceq vz cv vx cv cmul co vy cv wceq vx cc crab vz cv
      vx cv cmul co cA wceq vx cc crab vy cv cA wceq vz cv vx cv cmul co vy cv
      wceq vz cv vx cv cmul co cA wceq vx cc vy cv cA vz cv vx cv cmul co eqeq2
      rabbisdv unieqd vz cv cB wceq vz cv vx cv cmul co cA wceq vx cc crab cB
      vx cv cmul co cA wceq vx cc crab vz cv cB wceq vz cv vx cv cmul co cA
      wceq cB vx cv cmul co cA wceq vx cc vz cv cB wceq vz cv vx cv cmul co cB
      vx cv cmul co cA vz cv cB vx cv cmul opreq1 eqeq1d rabbisdv unieqd vy vz
      vw vx df-div oprabval2 mp2an $.
      $( [8-May-1999] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    divmul.1 $e |- A e. CC $.
    divmul.2 $e |- B e. CC $.
    divmul.3 $e |- C e. CC $.
    divmul.4 $e |- B =/= 0 $.
    $( Relationship between division and multiplication. $)
    divmuli $p |- ( ( A / B ) = C <-> ( B x. C ) = A ) $=
      cC cc wcel cA cB cdiv co cC wceq cB cC cmul co cA wceq wb divmul.3 cA cB
      cdiv co vx cv wceq cB vx cv cmul co cA wceq wb cA cB cdiv co cC wceq cB
      cC cmul co cA wceq wb vx cC cc vx cv cC wceq cA cB cdiv co vx cv wceq cA
      cB cdiv co cC wceq cB vx cv cmul co cA wceq cB cC cmul co cA wceq vx cv
      cC cA cB cdiv co eqeq2 vx cv cC wceq cB vx cv cmul co cB cC cmul co cA vx
      cv cC cB cmul opreq2 eqeq1d bibi12d vx cv cc wcel cB vx cv cmul co cA
      wceq cB vx cv cmul co cA wceq vx cc crab cuni vx cv wceq cA cB cdiv co vx
      cv wceq vx cv cc wcel cB vx cv cmul co cA wceq vx cc wreu cB vx cv cmul
      co cA wceq cB vx cv cmul co cA wceq vx cc crab cuni vx cv wceq wb vx cB
      cA divmul.2 divmul.1 divmul.4 receui cB vx cv cmul co cA wceq vx cc
      reuuni1 mpan2 cA cB cdiv co cB vx cv cmul co cA wceq vx cc crab cuni vx
      cv vx cA cB divmul.1 divmul.2 divmul.4 divvali eqeq1i syl6rbbr vtoclga
      ax-mp $.
      $( [2-Feb-1995] $)
  $}

  ${
    divmulz.1 $e |- A e. CC $.
    divmulz.2 $e |- B e. CC $.
    divmulz.3 $e |- C e. CC $.
    $( Relationship between division and multiplication. $)
    divmulzi $p |- ( B =/= 0 -> ( ( A / B ) = C <-> ( B x. C ) = A ) ) $=
      cB cc0 wne cA cB cdiv co cC wceq cB cC cmul co cA wceq wb cA cB cc0 wne
      cB c1 cif cdiv co cC wceq cB cc0 wne cB c1 cif cC cmul co cA wceq wb cB
      c1 cB cB cc0 wne cB c1 cif wceq cA cB cdiv co cC wceq cA cB cc0 wne cB c1
      cif cdiv co cC wceq cB cC cmul co cA wceq cB cc0 wne cB c1 cif cC cmul co
      cA wceq cB cB cc0 wne cB c1 cif wceq cA cB cdiv co cA cB cc0 wne cB c1
      cif cdiv co cC cB cB cc0 wne cB c1 cif cA cdiv opreq2 eqeq1d cB cB cc0
      wne cB c1 cif wceq cB cC cmul co cB cc0 wne cB c1 cif cC cmul co cA cB cB
      cc0 wne cB c1 cif cC cmul opreq1 eqeq1d bibi12d cA cB cc0 wne cB c1 cif
      cC divmulz.1 cB cc0 wne cB c1 cc divmulz.2 ax1cn keepel divmulz.3 cB
      elimne0 divmuli dedth $.
      $( [8-May-1999] $)
  $}

  $( Relationship between division and multiplication. $)
  divmul $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
               -> ( ( A / C ) = B <-> ( C x. B ) = A ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cA cC cdiv co cB wceq cC cB
    cmul co cA wceq wb cA cc wcel cB cc wcel cC cc wcel cC cc0 wne cA cC cdiv
    co cB wceq cC cB cmul co cA wceq wb cA cc wcel cC cc wcel cB cc wcel cC cc0
    wne cA cC cdiv co cB wceq cC cB cmul co cA wceq wb wi cA cc wcel cC cc wcel
    cB cc wcel cC cc0 wne cA cC cdiv co cB wceq cC cB cmul co cA wceq wb wi cA
    cc wcel cC cc wcel cB cc wcel cC cc0 wne cA cC cdiv co cB wceq cC cB cmul
    co cA wceq wb wi cC cc0 wne cA cc wcel cA cc0 cif cC cdiv co cB wceq cC cB
    cmul co cA cc wcel cA cc0 cif wceq wb wi cA cC cB cc0 cc0 cc0 cC cc wcel cC
    cc0 cif cc0 wne cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cdiv co cB wceq
    cC cc wcel cC cc0 cif cB cmul co cA cc wcel cA cc0 cif wceq wb wi cC cc
    wcel cC cc0 cif cc0 wne cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cdiv co
    cB cc wcel cB cc0 cif wceq cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif cmul
    co cA cc wcel cA cc0 cif wceq wb wi cA cA cc wcel cA cc0 cif wceq cA cC
    cdiv co cB wceq cC cB cmul co cA wceq wb cA cc wcel cA cc0 cif cC cdiv co
    cB wceq cC cB cmul co cA cc wcel cA cc0 cif wceq wb cC cc0 wne cA cA cc
    wcel cA cc0 cif wceq cA cC cdiv co cB wceq cA cc wcel cA cc0 cif cC cdiv co
    cB wceq cC cB cmul co cA wceq cC cB cmul co cA cc wcel cA cc0 cif wceq cA
    cA cc wcel cA cc0 cif wceq cA cC cdiv co cA cc wcel cA cc0 cif cC cdiv co
    cB cA cA cc wcel cA cc0 cif cC cdiv opreq1 eqeq1d cA cA cc wcel cA cc0 cif
    cC cB cmul co eqeq2 bibi12d imbi2d cC cC cc wcel cC cc0 cif wceq cC cc0 wne
    cC cc wcel cC cc0 cif cc0 wne cA cc wcel cA cc0 cif cC cdiv co cB wceq cC
    cB cmul co cA cc wcel cA cc0 cif wceq wb cA cc wcel cA cc0 cif cC cc wcel
    cC cc0 cif cdiv co cB wceq cC cc wcel cC cc0 cif cB cmul co cA cc wcel cA
    cc0 cif wceq wb cC cC cc wcel cC cc0 cif cc0 neeq1 cC cC cc wcel cC cc0 cif
    wceq cA cc wcel cA cc0 cif cC cdiv co cB wceq cA cc wcel cA cc0 cif cC cc
    wcel cC cc0 cif cdiv co cB wceq cC cB cmul co cA cc wcel cA cc0 cif wceq cC
    cc wcel cC cc0 cif cB cmul co cA cc wcel cA cc0 cif wceq cC cC cc wcel cC
    cc0 cif wceq cA cc wcel cA cc0 cif cC cdiv co cA cc wcel cA cc0 cif cC cc
    wcel cC cc0 cif cdiv co cB cC cC cc wcel cC cc0 cif cA cc wcel cA cc0 cif
    cdiv opreq2 eqeq1d cC cC cc wcel cC cc0 cif wceq cC cB cmul co cC cc wcel
    cC cc0 cif cB cmul co cA cc wcel cA cc0 cif cC cC cc wcel cC cc0 cif cB
    cmul opreq1 eqeq1d bibi12d imbi12d cB cB cc wcel cB cc0 cif wceq cA cc wcel
    cA cc0 cif cC cc wcel cC cc0 cif cdiv co cB wceq cC cc wcel cC cc0 cif cB
    cmul co cA cc wcel cA cc0 cif wceq wb cA cc wcel cA cc0 cif cC cc wcel cC
    cc0 cif cdiv co cB cc wcel cB cc0 cif wceq cC cc wcel cC cc0 cif cB cc wcel
    cB cc0 cif cmul co cA cc wcel cA cc0 cif wceq wb cC cc wcel cC cc0 cif cc0
    wne cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cC cc wcel cC cc0
    cif cdiv co cB wceq cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cdiv co cB
    cc wcel cB cc0 cif wceq cC cc wcel cC cc0 cif cB cmul co cA cc wcel cA cc0
    cif wceq cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif cmul co cA cc wcel cA
    cc0 cif wceq cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cC cc wcel cC
    cc0 cif cdiv co eqeq2 cB cB cc wcel cB cc0 cif wceq cC cc wcel cC cc0 cif
    cB cmul co cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif cmul co cA cc wcel
    cA cc0 cif cB cB cc wcel cB cc0 cif cC cc wcel cC cc0 cif cmul opreq2
    eqeq1d bibi12d imbi2d cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cB cc
    wcel cB cc0 cif cA cc0 cc 0cn elimel cC cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel divmulzi dedth3h 3exp com23 imp4a 3imp $.
    $( [15-Nov-2008] $) $( [2-Aug-2004] $)

  $( Relationship between division and multiplication. $)
  divmul2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
              -> ( ( A / C ) = B <-> A = ( C x. B ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cC cdiv co cB wceq cC
    cB cmul co cA wceq cA cC cB cmul co wceq cA cB cC divmul cC cB cmul co cA
    eqcom syl6bb $.
    $( [16-Nov-2008] $) $( [7-Feb-2006] $)

  $( Relationship between division and multiplication. $)
  divmul3 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
              -> ( ( A / C ) = B <-> A = ( B x. C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cC cdiv co cB wceq cA
    cC cB cmul co wceq cA cB cC cmul co wceq cA cB cC divmul2 cA cc wcel cB cc
    wcel cC cc wcel cC cc0 wne wa w3a cB cC cmul co cC cB cmul co cA cB cc wcel
    cC cc wcel cC cc0 wne wa cB cC cmul co cC cB cmul co wceq cA cc wcel cB cc
    wcel cC cc wcel cB cC cmul co cC cB cmul co wceq cC cc0 wne cB cC mulcom
    adantrr 3adant1 eqeq2d bitr4d $.
    $( [27-Nov-2008] $) $( [13-Feb-2006] $)

  ${
    $d x A $.  $d x B $.
    divcl.1 $e |- A e. CC $.
    divcl.2 $e |- B e. CC $.
    divcl.3 $e |- B =/= 0 $.
    $( Closure law for division. $)
    divcli $p |- ( A / B ) e. CC $=
      cA cB cdiv co cB vx cv cmul co cA wceq vx cc crab cuni cc vx cA cB
      divcl.1 divcl.2 divcl.3 divvali cB vx cv cmul co cA wceq vx cc wreu cB vx
      cv cmul co cA wceq vx cc crab cuni cc wcel vx cB cA divcl.2 divcl.1
      divcl.3 receui cB vx cv cmul co cA wceq vx cc reucl ax-mp eqeltri $.
      $( [2-Feb-1995] $)
  $}

  ${
    divclz.1 $e |- A e. CC $.
    divclz.2 $e |- B e. CC $.
    $( Closure law for division. $)
    divclzi $p |- ( B =/= 0 -> ( A / B ) e. CC ) $=
      cB cc0 wne cA cB cdiv co cc wcel cA cB cc0 wne cB c1 cif cdiv co cc wcel
      cB c1 cB cB cc0 wne cB c1 cif wceq cA cB cdiv co cA cB cc0 wne cB c1 cif
      cdiv co cc cB cB cc0 wne cB c1 cif cA cdiv opreq2 eleq1d cA cB cc0 wne cB
      c1 cif divclz.1 cB cc0 wne cB c1 cc divclz.2 ax1cn keepel cB elimne0
      divcli dedth $.
      $( [7-May-1999] $)
  $}

  $( Closure law for division. $)
  divcl $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) -> ( A / B ) e. CC ) $=
    cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cc wcel cA cc wcel cB cc
    wcel cB cc0 wne cA cB cdiv co cc wcel wi cB cc0 wne cA cc wcel cA cc0 cif
    cB cdiv co cc wcel wi cB cc wcel cB cc0 cif cc0 wne cA cc wcel cA cc0 cif
    cB cc wcel cB cc0 cif cdiv co cc wcel wi cA cB cc0 cc0 cA cA cc wcel cA cc0
    cif wceq cA cB cdiv co cc wcel cA cc wcel cA cc0 cif cB cdiv co cc wcel cB
    cc0 wne cA cA cc wcel cA cc0 cif wceq cA cB cdiv co cA cc wcel cA cc0 cif
    cB cdiv co cc cA cA cc wcel cA cc0 cif cB cdiv opreq1 eleq1d imbi2d cB cB
    cc wcel cB cc0 cif wceq cB cc0 wne cB cc wcel cB cc0 cif cc0 wne cA cc wcel
    cA cc0 cif cB cdiv co cc wcel cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cdiv co cc wcel cB cB cc wcel cB cc0 cif cc0 neeq1 cB cB cc wcel cB cc0 cif
    wceq cA cc wcel cA cc0 cif cB cdiv co cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cdiv co cc cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cdiv
    opreq2 eleq1d imbi12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc
    0cn elimel cB cc0 cc 0cn elimel divclzi dedth2h 3impia $.
    $( [4-May-2005] $) $( [21-Jul-2001] $)

  ${
    reccl.1 $e |- A e. CC $.
    reccl.2 $e |- A =/= 0 $.
    $( Closure law for reciprocal. $)
    reccli $p |- ( 1 / A ) e. CC $=
      c1 cA ax1cn reccl.1 reccl.2 divcli $.
      $( [2-May-2005] $) $( [30-Apr-2005] $)
  $}

  ${
    recclz.1 $e |- A e. CC $.
    $( Closure law for reciprocal. $)
    recclzi $p |- ( A =/= 0 -> ( 1 / A ) e. CC ) $=
      c1 cA ax1cn recclz.1 divclzi $.
      $( [2-May-2005] $) $( [30-Apr-2005] $)
  $}

  $( Closure law for reciprocal. $)
  reccl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 1 / A ) e. CC ) $=
    c1 cc wcel cA cc wcel cA cc0 wne c1 cA cdiv co cc wcel ax1cn c1 cA divcl
    mp3an1 $.
    $( [2-May-2005] $) $( [30-Apr-2005] $)

  ${
    divcan.1 $e |- A e. CC $.
    divcan.2 $e |- B e. CC $.
    ${
      divcan.3 $e |- B =/= 0 $.
      $( A cancellation law for division. $)
      divcan2i $p |- ( B x. ( A / B ) ) = A $=
        cA cB cdiv co cA cB cdiv co wceq cB cA cB cdiv co cmul co cA wceq cA cB
        cdiv co eqid cA cB cA cB cdiv co divcan.1 divcan.2 cA cB divcan.1
        divcan.2 divcan.3 divcli divcan.3 divmuli mpbi $.
        $( [18-Aug-2008] $) $( [9-Feb-1995] $)

      $( A cancellation law for division. $)
      divcan1i $p |- ( ( A / B ) x. B ) = A $=
        cA cB cdiv co cB cmul co cB cA cB cdiv co cmul co cA cA cB cdiv co cB
        cA cB divcan.1 divcan.2 divcan.3 divcli divcan.2 mulcomi cA cB divcan.1
        divcan.2 divcan.3 divcan2i eqtri $.
        $( [18-Aug-2008] $) $( [18-May-1999] $)
    $}

    $( A cancellation law for division. $)
    divcan1zi $p |- ( B =/= 0 -> ( ( A / B ) x. B ) = A ) $=
      cB cc0 wne cA cB cdiv co cB cmul co cA wceq cA cB cc0 wne cB c1 cif cdiv
      co cB cc0 wne cB c1 cif cmul co cA wceq cB c1 cB cB cc0 wne cB c1 cif
      wceq cA cB cdiv co cB cmul co cA cB cc0 wne cB c1 cif cdiv co cB cc0 wne
      cB c1 cif cmul co cA cB cB cc0 wne cB c1 cif wceq cA cB cdiv co cA cB cc0
      wne cB c1 cif cdiv co cB cB cc0 wne cB c1 cif cmul cB cB cc0 wne cB c1
      cif cA cdiv opreq2 cB cB cc0 wne cB c1 cif wceq id opreq12d eqeq1d cA cB
      cc0 wne cB c1 cif divcan.1 cB cc0 wne cB c1 cc divcan.2 ax1cn keepel cB
      elimne0 divcan1i dedth $.
      $( [18-Aug-2008] $) $( [2-Oct-1999] $)

    $( A cancellation law for division.  We eliminate the third hypothesis of
       ~ divcan2i using the weak deduction theorem ~ dedth and keep the other
       two.  Because the first hypothesis shares the class variable ` B `
       with the hypothesis we're eliminating, we need to use ~ keepel in order
       to keep the first hypothesis. $)
    divcan2zi $p |- ( B =/= 0 -> ( B x. ( A / B ) ) = A ) $=
      cB cc0 wne cB cA cB cdiv co cmul co cA wceq cB cc0 wne cB c1 cif cA cB
      cc0 wne cB c1 cif cdiv co cmul co cA wceq cB c1 cB cB cc0 wne cB c1 cif
      wceq cB cA cB cdiv co cmul co cB cc0 wne cB c1 cif cA cB cc0 wne cB c1
      cif cdiv co cmul co cA cB cB cc0 wne cB c1 cif wceq cB cB cc0 wne cB c1
      cif cA cB cdiv co cA cB cc0 wne cB c1 cif cdiv co cmul cB cB cc0 wne cB
      c1 cif wceq id cB cB cc0 wne cB c1 cif cA cdiv opreq2 opreq12d eqeq1d cA
      cB cc0 wne cB c1 cif divcan.1 cB cc0 wne cB c1 cc divcan.2 ax1cn keepel
      cB elimne0 divcan2i dedth $.
      $( [21-Aug-2008] $) $( [10-Aug-1999] $)
  $}

  $( A cancellation law for division. $)
  divcan1 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 )
        -> ( ( A / B ) x. B ) = A ) $=
    cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cB cmul co cA wceq cA cc
    wcel cB cc wcel cB cc0 wne cA cB cdiv co cB cmul co cA wceq wi cB cc0 wne
    cA cc wcel cA cc0 cif cB cdiv co cB cmul co cA cc wcel cA cc0 cif wceq wi
    cB cc wcel cB cc0 cif cc0 wne cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cdiv co cB cc wcel cB cc0 cif cmul co cA cc wcel cA cc0 cif wceq wi cA cB
    cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB cdiv co cB cmul co cA wceq cA
    cc wcel cA cc0 cif cB cdiv co cB cmul co cA cc wcel cA cc0 cif wceq cB cc0
    wne cA cA cc wcel cA cc0 cif wceq cA cB cdiv co cB cmul co cA cc wcel cA
    cc0 cif cB cdiv co cB cmul co cA cA cc wcel cA cc0 cif cA cA cc wcel cA cc0
    cif wceq cA cB cdiv co cA cc wcel cA cc0 cif cB cdiv co cB cmul cA cA cc
    wcel cA cc0 cif cB cdiv opreq1 opreq1d cA cA cc wcel cA cc0 cif wceq id
    eqeq12d imbi2d cB cB cc wcel cB cc0 cif wceq cB cc0 wne cB cc wcel cB cc0
    cif cc0 wne cA cc wcel cA cc0 cif cB cdiv co cB cmul co cA cc wcel cA cc0
    cif wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co cB cc wcel cB
    cc0 cif cmul co cA cc wcel cA cc0 cif wceq cB cB cc wcel cB cc0 cif cc0
    neeq1 cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cdiv co cB
    cmul co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co cB cc wcel cB
    cc0 cif cmul co cA cc wcel cA cc0 cif cB cB cc wcel cB cc0 cif wceq cA cc
    wcel cA cc0 cif cB cdiv co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv
    co cB cB cc wcel cB cc0 cif cmul cB cB cc wcel cB cc0 cif cA cc wcel cA cc0
    cif cdiv opreq2 cB cB cc wcel cB cc0 cif wceq id opreq12d eqeq1d imbi12d cA
    cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel divcan1zi dedth2h 3impia $.
    $( [18-Aug-2008] $) $( [5-Jun-2004] $)

  $( A cancellation law for division. $)
  divcan2 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                 ( B x. ( A / B ) ) = A ) $=
    cA cc wcel cB cc wcel cB cc0 wne w3a cB cA cB cdiv co cmul co cA cB cdiv co
    cB cmul co cA cB cc wcel cA cB cdiv co cc wcel cB cA cB cdiv co cmul co cA
    cB cdiv co cB cmul co wceq cA cc wcel cB cc wcel cB cc0 wne w3a cB cA cB
    cdiv co mulcom cA cc wcel cB cc wcel cB cc0 wne 3simp2 cA cB divcl sylanc
    cA cB divcan1 eqtrd $.
    $( [21-Aug-2008] $) $( [3-Feb-2004] $)

  $( The ratio of non-zero numbers is non-zero. $)
  divne0b $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                  ( A =/= 0 <-> ( A / B ) =/= 0 ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne w3a cA cc0 cA cB cdiv co cc0 cA cc wcel cB
    cc wcel cB cc0 wne w3a cA cc0 wceq cB cc0 cmul co cA wceq cA cB cdiv co cc0
    wceq cB cc wcel cA cc wcel cA cc0 wceq cB cc0 cmul co cA wceq wb cB cc0 wne
    cB cc wcel cB cc0 cmul co cA wceq cc0 cA wceq cA cc0 wceq cB cc wcel cB cc0
    cmul co cc0 cA cB mul01 eqeq1d cA cc0 eqcom syl6rbbr 3ad2ant2 cA cc wcel cB
    cc wcel cB cc0 wne cA cB cdiv co cc0 wceq cB cc0 cmul co cA wceq wb cA cc
    wcel cc0 cc wcel cB cc wcel cB cc0 wne wa cA cB cdiv co cc0 wceq cB cc0
    cmul co cA wceq wb 0cn cA cc0 cB divmul mp3an2 3impb bitr4d necon3bid $.
    $( [1-Jun-2005] $) $( [2-Aug-2004] $)

  $( The ratio of non-zero numbers is non-zero. $)
  divne0 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                  ( A / B ) =/= 0 ) $=
    cA cc wcel cA cc0 wne cB cc wcel cB cc0 wne cA cB cdiv co cc0 wne cA cc
    wcel cB cc0 wne cB cc wcel cA cc0 wne cA cB cdiv co cc0 wne cA cc wcel cB
    cc wcel cB cc0 wne cA cc0 wne cA cB cdiv co cc0 wne wi cA cc wcel cB cc
    wcel cB cc0 wne cA cc0 wne cA cB cdiv co cc0 wne wi cA cc wcel cB cc wcel
    cB cc0 wne w3a cA cc0 wne cA cB cdiv co cc0 wne cA cB divne0b biimpd 3exp
    com23 com24 imp43 $.
    $( [28-Dec-2007] $) $( [28-Dec-2007] $)

  ${
    divneq0.1 $e |- A e. CC $.
    divneq0.2 $e |- B e. CC $.
    divneq0.3 $e |- A =/= 0 $.
    divneq0.4 $e |- B =/= 0 $.
    $( The ratio of non-zero numbers is non-zero. $)
    divne0i $p |- ( A / B ) =/= 0 $=
      cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cc0 wne divneq0.1
      divneq0.2 divneq0.4 cA cc wcel cB cc wcel cB cc0 wne w3a cA cc0 wne cA cB
      cdiv co cc0 wne divneq0.3 cA cB divne0b mpbii mp3an $.
      $( [9-Feb-1995] $)
  $}

  ${
    recneq0z.1 $e |- A e. CC $.
    $( The reciprocal of a non-zero number is non-zero. $)
    recne0zi $p |- ( A =/= 0 -> ( 1 / A ) =/= 0 ) $=
      cA cc0 wne c1 cA cdiv co cc0 wne c1 cA cc0 wne cA c1 cif cdiv co cc0 wne
      cA c1 cA cA cc0 wne cA c1 cif wceq c1 cA cdiv co c1 cA cc0 wne cA c1 cif
      cdiv co cc0 cA cA cc0 wne cA c1 cif c1 cdiv opreq2 neeq1d c1 cA cc0 wne
      cA c1 cif ax1cn cA cc0 wne cA c1 cc recneq0z.1 ax1cn keepel ax1ne0 cA
      elimne0 divne0i dedth $.
      $( [14-May-1999] $)
  $}

  $( The reciprocal of a non-zero number is non-zero. $)
  recne0 $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 1 / A ) =/= 0 ) $=
    cA cc wcel cA cc0 wne c1 cA cdiv co cc0 wne cA cc wcel cA cc0 wne c1 cA
    cdiv co cc0 wne wi cA cc wcel cA cc0 cif cc0 wne c1 cA cc wcel cA cc0 cif
    cdiv co cc0 wne wi cA cc0 cA cA cc wcel cA cc0 cif wceq cA cc0 wne cA cc
    wcel cA cc0 cif cc0 wne c1 cA cdiv co cc0 wne c1 cA cc wcel cA cc0 cif cdiv
    co cc0 wne cA cA cc wcel cA cc0 cif cc0 neeq1 cA cA cc wcel cA cc0 cif wceq
    c1 cA cdiv co c1 cA cc wcel cA cc0 cif cdiv co cc0 cA cA cc wcel cA cc0 cif
    c1 cdiv opreq2 neeq1d imbi12d cA cc wcel cA cc0 cif cA cc0 cc 0cn elimel
    recne0zi dedth imp $.
    $( [9-Mar-2006] $) $( [9-Feb-2006] $)

  ${
    recid.1 $e |- A e. CC $.
    recid.2 $e |- A =/= 0 $.
    $( Multiplication of a number and its reciprocal. $)
    recidi $p |- ( A x. ( 1 / A ) ) = 1 $=
      c1 cA ax1cn recid.1 recid.2 divcan2i $.
      $( [9-Feb-1995] $)
  $}

  ${
    recidz.1 $e |- A e. CC $.
    $( Multiplication of a number and its reciprocal. $)
    recidzi $p |- ( A =/= 0 -> ( A x. ( 1 / A ) ) = 1 ) $=
      c1 cA ax1cn recidz.1 divcan2zi $.
      $( [14-May-1999] $)
  $}

  $( Multiplication of a number and its reciprocal. $)
  recid $p |- ( ( A e. CC /\ A =/= 0 ) -> ( A x. ( 1 / A ) ) = 1 ) $=
    cA cc wcel cA cc0 wne cA c1 cA cdiv co cmul co c1 wceq cA cc wcel cA cc0
    wne cA c1 cA cdiv co cmul co c1 wceq wi cA cc wcel cA cc0 cif cc0 wne cA cc
    wcel cA cc0 cif c1 cA cc wcel cA cc0 cif cdiv co cmul co c1 wceq wi cA cc0
    cA cA cc wcel cA cc0 cif wceq cA cc0 wne cA cc wcel cA cc0 cif cc0 wne cA
    c1 cA cdiv co cmul co c1 wceq cA cc wcel cA cc0 cif c1 cA cc wcel cA cc0
    cif cdiv co cmul co c1 wceq cA cA cc wcel cA cc0 cif cc0 neeq1 cA cA cc
    wcel cA cc0 cif wceq cA c1 cA cdiv co cmul co cA cc wcel cA cc0 cif c1 cA
    cc wcel cA cc0 cif cdiv co cmul co c1 cA cA cc wcel cA cc0 cif wceq cA cA
    cc wcel cA cc0 cif c1 cA cdiv co c1 cA cc wcel cA cc0 cif cdiv co cmul cA
    cA cc wcel cA cc0 cif wceq id cA cA cc wcel cA cc0 cif c1 cdiv opreq2
    opreq12d eqeq1d imbi12d cA cc wcel cA cc0 cif cA cc0 cc 0cn elimel recidzi
    dedth imp $.
    $( [25-Oct-1999] $)

  $( Multiplication of a number and its reciprocal. $)
  recid2 $p |- ( ( A e. CC /\ A =/= 0 ) -> ( ( 1 / A ) x. A ) = 1 ) $=
    cA cc wcel cA cc0 wne wa c1 cA cdiv co cA cmul co cA c1 cA cdiv co cmul co
    c1 c1 cA cdiv co cc wcel cA cc wcel c1 cA cdiv co cA cmul co cA c1 cA cdiv
    co cmul co wceq cA cc wcel cA cc0 wne wa c1 cA cdiv co cA mulcom cA reccl
    cA cc wcel cA cc0 wne pm3.26 sylanc cA recid eqtrd $.
    $( [22-Jun-2006] $) $( [22-Jun-2006] $)

  ${
    divrec.1 $e |- A e. CC $.
    divrec.2 $e |- B e. CC $.
    ${
      divrec.3 $e |- B =/= 0 $.
      $( Relationship between division and reciprocal.  Theorem I.9 of
         [Apostol] p. 18. $)
      divreci $p |- ( A / B ) = ( A x. ( 1 / B ) ) $=
        cA cB cdiv co cA c1 cB cdiv co cmul co wceq cB cA c1 cB cdiv co cmul co
        cmul co cA wceq cB cA c1 cB cdiv co cmul co cmul co cA c1 cB cdiv co
        cmul co cB cmul co cA c1 cB cdiv co cB cmul co cmul co cA cB cA c1 cB
        cdiv co cmul co divrec.2 cA c1 cB cdiv co divrec.1 cB divrec.2 divrec.3
        reccli mulcli mulcomi cA c1 cB cdiv co cB divrec.1 cB divrec.2 divrec.3
        reccli divrec.2 mulassi cA c1 cB cdiv co cB cmul co cmul co cA c1 cmul
        co cA c1 cB cdiv co cB cmul co c1 cA cmul c1 cB ax1cn divrec.2 divrec.3
        divcan1i opreq2i cA divrec.1 mulid1i eqtri 3eqtri cA cB cA c1 cB cdiv
        co cmul co divrec.1 divrec.2 cA c1 cB cdiv co divrec.1 cB divrec.2
        divrec.3 reccli mulcli divrec.3 divmuli mpbir $.
        $( [9-Feb-1995] $)
    $}

    $( Relationship between division and reciprocal.  Theorem I.9 of
       [Apostol] p. 18. $)
    divreczi $p |- ( B =/= 0 -> ( A / B ) = ( A x. ( 1 / B ) ) ) $=
      cB cc0 wne cA cB cdiv co cA c1 cB cdiv co cmul co wceq cA cB cc0 wne cB
      c1 cif cdiv co cA c1 cB cc0 wne cB c1 cif cdiv co cmul co wceq cB c1 cB
      cB cc0 wne cB c1 cif wceq cA cB cdiv co cA cB cc0 wne cB c1 cif cdiv co
      cA c1 cB cdiv co cmul co cA c1 cB cc0 wne cB c1 cif cdiv co cmul co cB cB
      cc0 wne cB c1 cif cA cdiv opreq2 cB cB cc0 wne cB c1 cif wceq c1 cB cdiv
      co c1 cB cc0 wne cB c1 cif cdiv co cA cmul cB cB cc0 wne cB c1 cif c1
      cdiv opreq2 opreq2d eqeq12d cA cB cc0 wne cB c1 cif divrec.1 cB cc0 wne
      cB c1 cc divrec.2 ax1cn keepel cB elimne0 divreci dedth $.
      $( [11-Oct-1999] $)
  $}

  $( Relationship between division and reciprocal.  Theorem I.9 of
     [Apostol] p. 18. $)
  divrec $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                ( A / B ) = ( A x. ( 1 / B ) ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cA c1 cB cdiv co cmul co
    wceq cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cA c1 cB cdiv co cmul
    co wceq wi cB cc0 wne cA cc wcel cA cc0 cif cB cdiv co cA cc wcel cA cc0
    cif c1 cB cdiv co cmul co wceq wi cB cc wcel cB cc0 cif cc0 wne cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif cdiv co cA cc wcel cA cc0 cif c1 cB cc
    wcel cB cc0 cif cdiv co cmul co wceq wi cA cB cc0 cc0 cA cA cc wcel cA cc0
    cif wceq cA cB cdiv co cA c1 cB cdiv co cmul co wceq cA cc wcel cA cc0 cif
    cB cdiv co cA cc wcel cA cc0 cif c1 cB cdiv co cmul co wceq cB cc0 wne cA
    cA cc wcel cA cc0 cif wceq cA cB cdiv co cA cc wcel cA cc0 cif cB cdiv co
    cA c1 cB cdiv co cmul co cA cc wcel cA cc0 cif c1 cB cdiv co cmul co cA cA
    cc wcel cA cc0 cif cB cdiv opreq1 cA cA cc wcel cA cc0 cif c1 cB cdiv co
    cmul opreq1 eqeq12d imbi2d cB cB cc wcel cB cc0 cif wceq cB cc0 wne cB cc
    wcel cB cc0 cif cc0 wne cA cc wcel cA cc0 cif cB cdiv co cA cc wcel cA cc0
    cif c1 cB cdiv co cmul co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cdiv co cA cc wcel cA cc0 cif c1 cB cc wcel cB cc0 cif cdiv co cmul co wceq
    cB cB cc wcel cB cc0 cif cc0 neeq1 cB cB cc wcel cB cc0 cif wceq cA cc wcel
    cA cc0 cif cB cdiv co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co
    cA cc wcel cA cc0 cif c1 cB cdiv co cmul co cA cc wcel cA cc0 cif c1 cB cc
    wcel cB cc0 cif cdiv co cmul co cB cB cc wcel cB cc0 cif cA cc wcel cA cc0
    cif cdiv opreq2 cB cB cc wcel cB cc0 cif wceq c1 cB cdiv co c1 cB cc wcel
    cB cc0 cif cdiv co cA cc wcel cA cc0 cif cmul cB cB cc wcel cB cc0 cif c1
    cdiv opreq2 opreq2d eqeq12d imbi12d cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel divreczi dedth2h 3impia $.
    $( [4-May-2005] $) $( [2-Aug-2004] $)

  $( Relationship between division and reciprocal. $)
  divrec2 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                ( A / B ) = ( ( 1 / B ) x. A ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne w3a cA cB cdiv co cA c1 cB cdiv co cmul co
    c1 cB cdiv co cA cmul co cA cB divrec cA cc wcel c1 cB cdiv co cc wcel cA
    c1 cB cdiv co cmul co c1 cB cdiv co cA cmul co wceq cA cc wcel cB cc wcel
    cB cc0 wne w3a cA c1 cB cdiv co mulcom cA cc wcel cB cc wcel cB cc0 wne
    3simp1 cB cc wcel cB cc0 wne c1 cB cdiv co cc wcel cA cc wcel cB reccl
    3adant1 sylanc eqtrd $.
    $( [1-Mar-2006] $) $( [7-Feb-2006] $)

  $( An associative law for division. $)
  divass $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
                ( ( A x. B ) / C ) = ( A x. ( B / C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cB cmul co c1 cC cdiv
    co cmul co cA cB c1 cC cdiv co cmul co cmul co cA cB cmul co cC cdiv co cA
    cB cC cdiv co cmul co cA cc wcel cB cc wcel c1 cC cdiv co cc wcel cA cB
    cmul co c1 cC cdiv co cmul co cA cB c1 cC cdiv co cmul co cmul co wceq cC
    cc wcel cC cc0 wne wa cA cB c1 cC cdiv co mulass cC reccl syl3an3 cA cB
    cmul co cc wcel cC cc wcel cC cc0 wne cA cB cmul co cC cdiv co cA cB cmul
    co c1 cC cdiv co cmul co wceq cA cc wcel cB cc wcel cC cc wcel cC cc0 wne
    wa w3a cA cB cmul co cC divrec cA cc wcel cB cc wcel cA cB cmul co cc wcel
    cC cc wcel cC cc0 wne wa cA cB mulcl 3adant3 cB cc wcel cC cc wcel cC cc0
    wne wa cC cc wcel cA cc wcel cB cc wcel cC cc wcel cC cc0 wne simprl
    3adant1 cB cc wcel cC cc wcel cC cc0 wne wa cC cc0 wne cA cc wcel cB cc
    wcel cC cc wcel cC cc0 wne simprr 3adant1 syl3anc cA cc wcel cB cc wcel cC
    cc wcel cC cc0 wne wa w3a cB cC cdiv co cB c1 cC cdiv co cmul co cA cmul cB
    cc wcel cC cc wcel cC cc0 wne cB cC cdiv co cB c1 cC cdiv co cmul co wceq
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cB cC divrec cA cc wcel
    cB cc wcel cC cc wcel cC cc0 wne wa 3simp2 cB cc wcel cC cc wcel cC cc0 wne
    wa cC cc wcel cA cc wcel cB cc wcel cC cc wcel cC cc0 wne simprl 3adant1 cB
    cc wcel cC cc wcel cC cc0 wne wa cC cc0 wne cA cc wcel cB cc wcel cC cc
    wcel cC cc0 wne simprr 3adant1 syl3anc opreq2d 3eqtr4d $.
    $( [12-Oct-2008] $) $( [2-Aug-2004] $)

  $( A commutative/associative law for division. $)
  div23 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
            -> ( ( A x. B ) / C ) = ( ( A / C ) x. B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cB cmul co cC cdiv co
    cB cA cmul co cC cdiv co cB cA cC cdiv co cmul co cA cC cdiv co cB cmul co
    cA cc wcel cB cc wcel cA cB cmul co cC cdiv co cB cA cmul co cC cdiv co
    wceq cC cc wcel cC cc0 wne wa cA cc wcel cB cc wcel wa cA cB cmul co cB cA
    cmul co cC cdiv cA cB axmulcom opreq1d 3adant3 cB cc wcel cA cc wcel cC cc
    wcel cC cc0 wne wa cB cA cmul co cC cdiv co cB cA cC cdiv co cmul co wceq
    cB cA cC divass 3com12 cB cc wcel cA cC cdiv co cc wcel cB cA cC cdiv co
    cmul co cA cC cdiv co cB cmul co wceq cA cc wcel cB cc wcel cC cc wcel cC
    cc0 wne wa w3a cB cA cC cdiv co mulcom cA cc wcel cB cc wcel cC cc wcel cC
    cc0 wne wa 3simp2 cA cc wcel cC cc wcel cC cc0 wne wa cA cC cdiv co cc wcel
    cB cc wcel cA cc wcel cC cc wcel cC cc0 wne cA cC cdiv co cc wcel cA cC
    divcl 3expb 3adant2 sylanc 3eqtrd $.
    $( [27-Dec-2008] $) $( [2-Aug-2004] $)

  $( A commutative/associative law for division. $)
  div13 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ C e. CC )
            -> ( ( A / B ) x. C ) = ( ( C / B ) x. A ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel w3a cA cC cmul co cB cdiv co
    cC cA cmul co cB cdiv co cA cB cdiv co cC cmul co cC cB cdiv co cA cmul co
    cA cc wcel cC cc wcel cA cC cmul co cB cdiv co cC cA cmul co cB cdiv co
    wceq cB cc wcel cB cc0 wne wa cA cc wcel cC cc wcel wa cA cC cmul co cC cA
    cmul co cB cdiv cA cC axmulcom opreq1d 3adant2 cA cc wcel cC cc wcel cB cc
    wcel cB cc0 wne wa cA cC cmul co cB cdiv co cA cB cdiv co cC cmul co wceq
    cA cC cB div23 3com23 cC cc wcel cA cc wcel cB cc wcel cB cc0 wne wa cC cA
    cmul co cB cdiv co cC cB cdiv co cA cmul co wceq cC cA cB div23 3coml
    3eqtr3d $.
    $( [28-Jan-2009] $) $( [22-Apr-2005] $)

  $( A commutative/associative law for division. $)
  div12 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
            -> ( A x. ( B / C ) ) = ( B x. ( A / C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cB cC cdiv co cmul co
    cB cC cdiv co cA cmul co cA cC cdiv co cB cmul co cB cA cC cdiv co cmul co
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cA cB cC cdiv co cmul co cB
    cC cdiv co cA cmul co wceq cA cc wcel cB cC cdiv co cc wcel cA cB cC cdiv
    co cmul co cB cC cdiv co cA cmul co wceq cB cc wcel cC cc wcel cC cc0 wne
    wa wa cA cB cC cdiv co mulcom cB cc wcel cC cc wcel cC cc0 wne cB cC cdiv
    co cc wcel cB cC divcl 3expb sylan2 3impb cB cc wcel cC cc wcel cC cc0 wne
    wa cA cc wcel cB cC cdiv co cA cmul co cA cC cdiv co cB cmul co wceq cB cC
    cA div13 3comr cA cc wcel cC cc wcel cC cc0 wne wa cB cc wcel cA cC cdiv co
    cB cmul co cB cA cC cdiv co cmul co wceq cA cc wcel cC cc wcel cC cc0 wne
    wa cB cc wcel cA cC cdiv co cB cmul co cB cA cC cdiv co cmul co wceq cA cC
    cdiv co cc wcel cB cc wcel cA cC cdiv co cB cmul co cB cA cC cdiv co cmul
    co wceq cA cc wcel cC cc wcel cC cc0 wne wa wa cA cC cdiv co cB mulcom cA
    cc wcel cC cc wcel cC cc0 wne cA cC cdiv co cc wcel cA cC divcl 3expb sylan
    3impa 3com23 3eqtrd $.
    $( [11-Feb-2009] $) $( [30-Apr-2005] $)

  ${
    divass.1 $e |- A e. CC $.
    divass.2 $e |- B e. CC $.
    divass.3 $e |- C e. CC $.
    $( An associative law for division. $)
    divasszi $p |- ( C =/= 0 -> ( ( A x. B ) / C ) = ( A x. ( B / C ) ) ) $=
      cC cc wcel cC cc0 wne cA cB cmul co cC cdiv co cA cB cC cdiv co cmul co
      wceq divass.3 cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cA cB cmul
      co cC cdiv co cA cB cC cdiv co cmul co wceq divass.1 divass.2 cA cB cC
      divass mp3an12 mpan $.
      $( [12-Aug-1999] $)

    ${
      divass.4 $e |- C =/= 0 $.
      $( An associative law for division. $)
      divassi $p |- ( ( A x. B ) / C ) = ( A x. ( B / C ) ) $=
        cC cc0 wne cA cB cmul co cC cdiv co cA cB cC cdiv co cmul co wceq
        divass.4 cA cB cC divass.1 divass.2 divass.3 divasszi ax-mp $.
        $( [15-Feb-1995] $)

      $( Distribution of division over addition. $)
      divdiri $p |- ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) $=
        cA cB caddc co c1 cC cdiv co cmul co cA c1 cC cdiv co cmul co cB c1 cC
        cdiv co cmul co caddc co cA cB caddc co cC cdiv co cA cC cdiv co cB cC
        cdiv co caddc co cA cB c1 cC cdiv co divass.1 divass.2 cC divass.3
        divass.4 reccli adddiri cA cB caddc co cC cA cB divass.1 divass.2
        addcli divass.3 divass.4 divreci cA cC cdiv co cA c1 cC cdiv co cmul co
        cB cC cdiv co cB c1 cC cdiv co cmul co caddc cA cC divass.1 divass.3
        divass.4 divreci cB cC divass.2 divass.3 divass.4 divreci opreq12i
        3eqtr4i $.
        $( [16-Feb-1995] $)

      $( A commutative/associative law for division. $)
      div23i $p |- ( ( A x. B ) / C ) = ( ( A / C ) x. B ) $=
        cA cB cmul co cC cdiv co cB cA cmul co cC cdiv co cB cA cC cdiv co cmul
        co cA cC cdiv co cB cmul co cA cB cmul co cB cA cmul co cC cdiv cA cB
        divass.1 divass.2 mulcomi opreq1i cB cA cC divass.2 divass.1 divass.3
        divass.4 divassi cB cA cC cdiv co divass.2 cA cC divass.1 divass.3
        divass.4 divcli mulcomi 3eqtri $.
        $( [3-Sep-1999] $)
    $}

    $( Distribution of division over addition. $)
    divdirzi $p |- ( C =/= 0 ->
                    ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) ) $=
      cC cc0 wne cA cB caddc co cC cdiv co cA cC cdiv co cB cC cdiv co caddc co
      wceq cA cB caddc co cC cc0 wne cC c1 cif cdiv co cA cC cc0 wne cC c1 cif
      cdiv co cB cC cc0 wne cC c1 cif cdiv co caddc co wceq cC c1 cC cC cc0 wne
      cC c1 cif wceq cA cB caddc co cC cdiv co cA cB caddc co cC cc0 wne cC c1
      cif cdiv co cA cC cdiv co cB cC cdiv co caddc co cA cC cc0 wne cC c1 cif
      cdiv co cB cC cc0 wne cC c1 cif cdiv co caddc co cC cC cc0 wne cC c1 cif
      cA cB caddc co cdiv opreq2 cC cC cc0 wne cC c1 cif wceq cA cC cdiv co cA
      cC cc0 wne cC c1 cif cdiv co cB cC cdiv co cB cC cc0 wne cC c1 cif cdiv
      co caddc cC cC cc0 wne cC c1 cif cA cdiv opreq2 cC cC cc0 wne cC c1 cif
      cB cdiv opreq2 opreq12d eqeq12d cA cB cC cc0 wne cC c1 cif divass.1
      divass.2 cC cc0 wne cC c1 cc divass.3 ax1cn keepel cC elimne0 divdiri
      dedth $.
      $( [2-Aug-2004] $) $( [31-Jul-2004] $)
  $}

  $( Distribution of division over addition. $)
  divdir $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
               -> ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cA cB caddc co cC cdiv co cA
    cC cdiv co cB cC cdiv co caddc co wceq cA cc wcel cB cc wcel cC cc wcel cC
    cc0 wne cA cB caddc co cC cdiv co cA cC cdiv co cB cC cdiv co caddc co wceq
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne cA cB caddc co cC cdiv co cA cC
    cdiv co cB cC cdiv co caddc co wceq wi cA cc wcel cB cc wcel cC cc wcel cC
    cc0 wne cA cB caddc co cC cdiv co cA cC cdiv co cB cC cdiv co caddc co wceq
    wi cC cc0 wne cA cc wcel cA cc0 cif cB caddc co cC cdiv co cA cc wcel cA
    cc0 cif cC cdiv co cB cC cdiv co caddc co wceq wi cA cB cC cc0 cc0 cc0 cC
    cc0 wne cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cC cdiv co cA
    cc wcel cA cc0 cif cC cdiv co cB cc wcel cB cc0 cif cC cdiv co caddc co
    wceq wi cC cc wcel cC cc0 cif cc0 wne cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif caddc co cC cc wcel cC cc0 cif cdiv co cA cc wcel cA cc0 cif cC cc
    wcel cC cc0 cif cdiv co cB cc wcel cB cc0 cif cC cc wcel cC cc0 cif cdiv co
    caddc co wceq wi cA cA cc wcel cA cc0 cif wceq cA cB caddc co cC cdiv co cA
    cC cdiv co cB cC cdiv co caddc co wceq cA cc wcel cA cc0 cif cB caddc co cC
    cdiv co cA cc wcel cA cc0 cif cC cdiv co cB cC cdiv co caddc co wceq cC cc0
    wne cA cA cc wcel cA cc0 cif wceq cA cB caddc co cC cdiv co cA cc wcel cA
    cc0 cif cB caddc co cC cdiv co cA cC cdiv co cB cC cdiv co caddc co cA cc
    wcel cA cc0 cif cC cdiv co cB cC cdiv co caddc co cA cA cc wcel cA cc0 cif
    wceq cA cB caddc co cA cc wcel cA cc0 cif cB caddc co cC cdiv cA cA cc wcel
    cA cc0 cif cB caddc opreq1 opreq1d cA cA cc wcel cA cc0 cif wceq cA cC cdiv
    co cA cc wcel cA cc0 cif cC cdiv co cB cC cdiv co caddc cA cA cc wcel cA
    cc0 cif cC cdiv opreq1 opreq1d eqeq12d imbi2d cB cB cc wcel cB cc0 cif wceq
    cA cc wcel cA cc0 cif cB caddc co cC cdiv co cA cc wcel cA cc0 cif cC cdiv
    co cB cC cdiv co caddc co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    caddc co cC cdiv co cA cc wcel cA cc0 cif cC cdiv co cB cc wcel cB cc0 cif
    cC cdiv co caddc co wceq cC cc0 wne cB cB cc wcel cB cc0 cif wceq cA cc
    wcel cA cc0 cif cB caddc co cC cdiv co cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif caddc co cC cdiv co cA cc wcel cA cc0 cif cC cdiv co cB cC cdiv co
    caddc co cA cc wcel cA cc0 cif cC cdiv co cB cc wcel cB cc0 cif cC cdiv co
    caddc co cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co cA
    cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cC cdiv cB cB cc wcel cB
    cc0 cif cA cc wcel cA cc0 cif caddc opreq2 opreq1d cB cB cc wcel cB cc0 cif
    wceq cB cC cdiv co cB cc wcel cB cc0 cif cC cdiv co cA cc wcel cA cc0 cif
    cC cdiv co caddc cB cB cc wcel cB cc0 cif cC cdiv opreq1 opreq2d eqeq12d
    imbi2d cC cC cc wcel cC cc0 cif wceq cC cc0 wne cC cc wcel cC cc0 cif cc0
    wne cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cC cdiv co cA cc
    wcel cA cc0 cif cC cdiv co cB cc wcel cB cc0 cif cC cdiv co caddc co wceq
    cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cC cc wcel cC cc0 cif
    cdiv co cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cdiv co cB cc wcel cB
    cc0 cif cC cc wcel cC cc0 cif cdiv co caddc co wceq cC cC cc wcel cC cc0
    cif cc0 neeq1 cC cC cc wcel cC cc0 cif wceq cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif caddc co cC cdiv co cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif caddc co cC cc wcel cC cc0 cif cdiv co cA cc wcel cA cc0 cif cC cdiv co
    cB cc wcel cB cc0 cif cC cdiv co caddc co cA cc wcel cA cc0 cif cC cc wcel
    cC cc0 cif cdiv co cB cc wcel cB cc0 cif cC cc wcel cC cc0 cif cdiv co
    caddc co cC cC cc wcel cC cc0 cif cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif caddc co cdiv opreq2 cC cC cc wcel cC cc0 cif wceq cA cc wcel cA cc0
    cif cC cdiv co cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cdiv co cB cc
    wcel cB cc0 cif cC cdiv co cB cc wcel cB cc0 cif cC cc wcel cC cc0 cif cdiv
    co caddc cC cC cc wcel cC cc0 cif cA cc wcel cA cc0 cif cdiv opreq2 cC cC
    cc wcel cC cc0 cif cB cc wcel cB cc0 cif cdiv opreq2 opreq12d eqeq12d
    imbi12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cC cc wcel cC cc0 cif
    cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel cC cc0 cc 0cn elimel divdirzi
    dedth3h 3exp imp4a 3imp $.
    $( [20-Aug-2008] $) $( [31-Jul-2004] $)

  ${
    divcan3.1 $e |- A e. CC $.
    divcan3.2 $e |- B e. CC $.
    ${
      divcan3.3 $e |- B =/= 0 $.
      $( A cancellation law for division. $)
      divcan3i $p |- ( ( B x. A ) / B ) = A $=
        cB cA cmul co cB cdiv co cB cA cB cdiv co cmul co cA cB cA cB divcan3.2
        divcan3.1 divcan3.2 divcan3.3 divassi cA cB divcan3.1 divcan3.2
        divcan3.3 divcan2i eqtri $.
        $( [22-Aug-2008] $) $( [16-Feb-1995] $)

      $( A cancellation law for division. $)
      divcan4i $p |- ( ( A x. B ) / B ) = A $=
        cA cB cmul co cB cdiv co cB cA cmul co cB cdiv co cA cA cB cmul co cB
        cA cmul co cB cdiv cA cB divcan3.1 divcan3.2 mulcomi opreq1i cA cB
        divcan3.1 divcan3.2 divcan3.3 divcan3i eqtri $.
        $( [22-Aug-2008] $) $( [18-May-1999] $)
    $}

    $( A cancellation law for division.  (Eliminates a hypothesis of
       ~ divcan3i with the weak deduction theorem.) $)
    divcan3zi $p |- ( B =/= 0 -> ( ( B x. A ) / B ) = A ) $=
      cB cc0 wne cB cA cmul co cB cdiv co cA wceq cB cc0 wne cB c1 cif cA cmul
      co cB cc0 wne cB c1 cif cdiv co cA wceq cB c1 cB cB cc0 wne cB c1 cif
      wceq cB cA cmul co cB cdiv co cB cc0 wne cB c1 cif cA cmul co cB cc0 wne
      cB c1 cif cdiv co cA cB cB cc0 wne cB c1 cif wceq cB cA cmul co cB cc0
      wne cB c1 cif cA cmul co cB cB cc0 wne cB c1 cif cdiv cB cB cc0 wne cB c1
      cif cA cmul opreq1 cB cB cc0 wne cB c1 cif wceq id opreq12d eqeq1d cA cB
      cc0 wne cB c1 cif divcan3.1 cB cc0 wne cB c1 cc divcan3.2 ax1cn keepel cB
      elimne0 divcan3i dedth $.
      $( [23-Aug-2008] $) $( [3-Feb-2004] $)

    $( A cancellation law for division. $)
    divcan4zi $p |- ( B =/= 0 -> ( ( A x. B ) / B ) = A ) $=
      cB cc0 wne cB cA cmul co cB cdiv co cA cA cB cmul co cB cdiv co cA cB
      divcan3.1 divcan3.2 divcan3zi cA cB cmul co cB cA cmul co cB cdiv cA cB
      divcan3.1 divcan3.2 mulcomi opreq1i syl5eq $.
      $( [23-Aug-2008] $) $( [12-Oct-1999] $)

  $}

  $( A cancellation law for division. $)
  divcan3 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                 ( ( B x. A ) / B ) = A ) $=
    cA cc wcel cB cc wcel cB cc0 wne cB cA cmul co cB cdiv co cA wceq cA cc
    wcel cB cc wcel cB cc0 wne cB cA cmul co cB cdiv co cA wceq wi cB cc0 wne
    cB cA cc wcel cA cc0 cif cmul co cB cdiv co cA cc wcel cA cc0 cif wceq wi
    cB cc wcel cB cc0 cif cc0 wne cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif
    cmul co cB cc wcel cB cc0 cif cdiv co cA cc wcel cA cc0 cif wceq wi cA cB
    cc0 cc0 cA cA cc wcel cA cc0 cif wceq cB cA cmul co cB cdiv co cA wceq cB
    cA cc wcel cA cc0 cif cmul co cB cdiv co cA cc wcel cA cc0 cif wceq cB cc0
    wne cA cA cc wcel cA cc0 cif wceq cB cA cmul co cB cdiv co cB cA cc wcel cA
    cc0 cif cmul co cB cdiv co cA cA cc wcel cA cc0 cif cA cA cc wcel cA cc0
    cif wceq cB cA cmul co cB cA cc wcel cA cc0 cif cmul co cB cdiv cA cA cc
    wcel cA cc0 cif cB cmul opreq2 opreq1d cA cA cc wcel cA cc0 cif wceq id
    eqeq12d imbi2d cB cB cc wcel cB cc0 cif wceq cB cc0 wne cB cc wcel cB cc0
    cif cc0 wne cB cA cc wcel cA cc0 cif cmul co cB cdiv co cA cc wcel cA cc0
    cif wceq cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmul co cB cc wcel cB
    cc0 cif cdiv co cA cc wcel cA cc0 cif wceq cB cB cc wcel cB cc0 cif cc0
    neeq1 cB cB cc wcel cB cc0 cif wceq cB cA cc wcel cA cc0 cif cmul co cB
    cdiv co cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmul co cB cc wcel cB
    cc0 cif cdiv co cA cc wcel cA cc0 cif cB cB cc wcel cB cc0 cif wceq cB cA
    cc wcel cA cc0 cif cmul co cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmul
    co cB cB cc wcel cB cc0 cif cdiv cB cB cc wcel cB cc0 cif cA cc wcel cA cc0
    cif cmul opreq1 cB cB cc wcel cB cc0 cif wceq id opreq12d eqeq1d imbi12d cA
    cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel divcan3zi dedth2h 3impia $.
    $( [23-Aug-2008] $) $( [3-Feb-2004] $)

  $( A cancellation law for division. $)
  divcan4 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                 ( ( A x. B ) / B ) = A ) $=
    cA cc wcel cB cc wcel cB cc0 wne w3a cA cB cmul co cB cdiv co cB cA cmul co
    cB cdiv co cA cA cc wcel cB cc wcel cB cc0 wne w3a cA cB cmul co cB cA cmul
    co cB cdiv cA cc wcel cB cc wcel cA cB cmul co cB cA cmul co wceq cB cc0
    wne cA cB mulcom 3adant3 opreq1d cA cB divcan3 eqtrd $.
    $( [23-Aug-2008] $) $( [8-Feb-2005] $)

  ${
    div11.1 $e |- A e. CC $.
    div11.2 $e |- B e. CC $.
    div11.3 $e |- C e. CC $.
    div11.4 $e |- C =/= 0 $.
    $( One-to-one relationship for division. $)
    div11i $p |- ( ( A / C ) = ( B / C ) <-> A = B ) $=
      cA cC cdiv co cB cC cdiv co wceq cC cA cC cdiv co cmul co cC cB cC cdiv
      co cmul co wceq cA cB wceq cA cC cdiv co cB cC cdiv co cC cA cC div11.1
      div11.3 div11.4 divcli cB cC div11.2 div11.3 div11.4 divcli div11.3
      div11.4 mulcani cC cA cC cdiv co cmul co cA cC cB cC cdiv co cmul co cB
      cA cC div11.1 div11.3 div11.4 divcan2i cB cC div11.2 div11.3 div11.4
      divcan2i eqeq12i bitr3i $.
      $( [20-Aug-2001] $)
  $}

  $( One-to-one relationship for division. $)
  div11 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
               ( ( A / C ) = ( B / C ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cA cC cdiv co cB cC cdiv co
    wceq cA cB wceq wb cA cc wcel cA c1 cif cC cdiv co cB cC cdiv co wceq cA cc
    wcel cA c1 cif cB wceq wb cA cB cC c1 c1 c1 cA cc wcel cA c1 cif cC cdiv co
    cB cc wcel cB c1 cif cC cdiv co wceq cA cc wcel cA c1 cif cB cc wcel cB c1
    cif wceq wb cA cc wcel cA c1 cif cC cc wcel cC cc0 wne wa cC c1 cif cdiv co
    cB cc wcel cB c1 cif cC cc wcel cC cc0 wne wa cC c1 cif cdiv co wceq cA cc
    wcel cA c1 cif cB cc wcel cB c1 cif wceq wb cA cA cc wcel cA c1 cif wceq cA
    cC cdiv co cB cC cdiv co wceq cA cc wcel cA c1 cif cC cdiv co cB cC cdiv co
    wceq cA cB wceq cA cc wcel cA c1 cif cB wceq cA cA cc wcel cA c1 cif wceq
    cA cC cdiv co cA cc wcel cA c1 cif cC cdiv co cB cC cdiv co cA cA cc wcel
    cA c1 cif cC cdiv opreq1 eqeq1d cA cA cc wcel cA c1 cif cB eqeq1 bibi12d cB
    cB cc wcel cB c1 cif wceq cA cc wcel cA c1 cif cC cdiv co cB cC cdiv co
    wceq cA cc wcel cA c1 cif cC cdiv co cB cc wcel cB c1 cif cC cdiv co wceq
    cA cc wcel cA c1 cif cB wceq cA cc wcel cA c1 cif cB cc wcel cB c1 cif wceq
    cB cB cc wcel cB c1 cif wceq cB cC cdiv co cB cc wcel cB c1 cif cC cdiv co
    cA cc wcel cA c1 cif cC cdiv co cB cB cc wcel cB c1 cif cC cdiv opreq1
    eqeq2d cB cB cc wcel cB c1 cif cA cc wcel cA c1 cif eqeq2 bibi12d cC cC cc
    wcel cC cc0 wne wa cC c1 cif wceq cA cc wcel cA c1 cif cC cdiv co cB cc
    wcel cB c1 cif cC cdiv co wceq cA cc wcel cA c1 cif cC cc wcel cC cc0 wne
    wa cC c1 cif cdiv co cB cc wcel cB c1 cif cC cc wcel cC cc0 wne wa cC c1
    cif cdiv co wceq cA cc wcel cA c1 cif cB cc wcel cB c1 cif wceq cC cC cc
    wcel cC cc0 wne wa cC c1 cif wceq cA cc wcel cA c1 cif cC cdiv co cA cc
    wcel cA c1 cif cC cc wcel cC cc0 wne wa cC c1 cif cdiv co cB cc wcel cB c1
    cif cC cdiv co cB cc wcel cB c1 cif cC cc wcel cC cc0 wne wa cC c1 cif cdiv
    co cC cC cc wcel cC cc0 wne wa cC c1 cif cA cc wcel cA c1 cif cdiv opreq2
    cC cC cc wcel cC cc0 wne wa cC c1 cif cB cc wcel cB c1 cif cdiv opreq2
    eqeq12d bibi1d cA cc wcel cA c1 cif cB cc wcel cB c1 cif cC cc wcel cC cc0
    wne wa cC c1 cif cA c1 cc ax1cn elimel cB c1 cc ax1cn elimel cC cc wcel cC
    cc0 wne wa cC c1 cif cc wcel cC cc wcel cC cc0 wne wa cC c1 cif cc0 wne cC
    cc wcel cC cc0 wne wa cC cc wcel cC cc0 wne wa cC c1 cif cc wcel cC cc wcel
    cC cc0 wne wa cC c1 cif cc0 wne wa c1 cc wcel c1 cc0 wne wa cC c1 cC cC cc
    wcel cC cc0 wne wa cC c1 cif wceq cC cc wcel cC cc wcel cC cc0 wne wa cC c1
    cif cc wcel cC cc0 wne cC cc wcel cC cc0 wne wa cC c1 cif cc0 wne cC cC cc
    wcel cC cc0 wne wa cC c1 cif cc eleq1 cC cC cc wcel cC cc0 wne wa cC c1 cif
    cc0 neeq1 anbi12d c1 cC cc wcel cC cc0 wne wa cC c1 cif wceq c1 cc wcel cC
    cc wcel cC cc0 wne wa cC c1 cif cc wcel c1 cc0 wne cC cc wcel cC cc0 wne wa
    cC c1 cif cc0 wne c1 cC cc wcel cC cc0 wne wa cC c1 cif cc eleq1 c1 cC cc
    wcel cC cc0 wne wa cC c1 cif cc0 neeq1 anbi12d c1 cc wcel c1 cc0 wne ax1cn
    ax1ne0 pm3.2i elimhyp pm3.26i cC cc wcel cC cc0 wne wa cC c1 cif cc wcel cC
    cc wcel cC cc0 wne wa cC c1 cif cc0 wne cC cc wcel cC cc0 wne wa cC cc wcel
    cC cc0 wne wa cC c1 cif cc wcel cC cc wcel cC cc0 wne wa cC c1 cif cc0 wne
    wa c1 cc wcel c1 cc0 wne wa cC c1 cC cC cc wcel cC cc0 wne wa cC c1 cif
    wceq cC cc wcel cC cc wcel cC cc0 wne wa cC c1 cif cc wcel cC cc0 wne cC cc
    wcel cC cc0 wne wa cC c1 cif cc0 wne cC cC cc wcel cC cc0 wne wa cC c1 cif
    cc eleq1 cC cC cc wcel cC cc0 wne wa cC c1 cif cc0 neeq1 anbi12d c1 cC cc
    wcel cC cc0 wne wa cC c1 cif wceq c1 cc wcel cC cc wcel cC cc0 wne wa cC c1
    cif cc wcel c1 cc0 wne cC cc wcel cC cc0 wne wa cC c1 cif cc0 wne c1 cC cc
    wcel cC cc0 wne wa cC c1 cif cc eleq1 c1 cC cc wcel cC cc0 wne wa cC c1 cif
    cc0 neeq1 anbi12d c1 cc wcel c1 cc0 wne ax1cn ax1ne0 pm3.2i elimhyp pm3.27i
    div11i dedth3h $.
    $( [1-May-2006] $) $( [20-Apr-2006] $)

  $( A number divided by itself is one. $)
  divid $p |- ( ( A e. CC /\ A =/= 0 ) -> ( A / A ) = 1 ) $=
    cA cc wcel cA cc0 wne wa cA cA cdiv co cA c1 cA cdiv co cmul co c1 cA cc
    wcel cA cc0 wne cA cA cdiv co cA c1 cA cdiv co cmul co wceq cA cA divrec
    3anidm12 cA recid eqtrd $.
    $( [2-Aug-2004] $) $( [1-Aug-2004] $)

  $( Division into zero is zero. $)
  div0 $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 0 / A ) = 0 ) $=
    cA cc wcel cA cc0 wne wa cc0 cA cdiv co cc0 c1 cA cdiv co cmul co cc0 cc0
    cc wcel cA cc wcel cA cc0 wne cc0 cA cdiv co cc0 c1 cA cdiv co cmul co wceq
    0cn cc0 cA divrec mp3an1 cA cc wcel cA cc0 wne wa c1 cA cdiv co cc wcel cc0
    c1 cA cdiv co cmul co cc0 wceq cA reccl c1 cA cdiv co mul02 syl eqtrd $.
    $( [16-Mar-2005] $) $( [14-Mar-2005] $)

  $( A ratio is zero iff the numerator is zero. $)
  diveq0 $p |- ( ( A e. CC /\ C e. CC /\ C =/= 0 ) ->
               ( ( A / C ) = 0 <-> A = 0 ) ) $=
    cA cc wcel cC cc wcel cC cc0 wne w3a cA cC cdiv co cc0 cC cdiv co wceq cA
    cC cdiv co cc0 wceq cA cc0 wceq cC cc wcel cC cc0 wne cA cC cdiv co cc0 cC
    cdiv co wceq cA cC cdiv co cc0 wceq wb cA cc wcel cC cc wcel cC cc0 wne wa
    cc0 cC cdiv co cc0 cA cC cdiv co cC div0 eqeq2d 3adant1 cA cc wcel cC cc
    wcel cC cc0 wne cA cC cdiv co cc0 cC cdiv co wceq cA cc0 wceq wb cA cc wcel
    cc0 cc wcel cC cc wcel cC cc0 wne wa cA cC cdiv co cc0 cC cdiv co wceq cA
    cc0 wceq wb 0cn cA cc0 cC div11 mp3an2 3impb bitr3d $.
    $( [15-May-2006] $) $( [20-Apr-2006] $)

  ${
    recrec.1 $e |- A e. CC $.
    recrec.2 $e |- A =/= 0 $.
    $( A number is equal to the reciprocal of its reciprocal.  Theorem I.10 of
       [Apostol] p. 18. $)
    recreci $p |- ( 1 / ( 1 / A ) ) = A $=
      cA c1 cA cdiv co c1 c1 cA cdiv co cdiv co cmul co cmul co cA c1 cmul co
      c1 c1 cA cdiv co cdiv co cA c1 cA cdiv co c1 c1 cA cdiv co cdiv co cmul
      co c1 cA cmul c1 cA cdiv co cA recrec.1 recrec.2 reccli c1 cA ax1cn
      recrec.1 ax1ne0 recrec.2 divne0i recidi opreq2i cA c1 cA cdiv co cmul co
      c1 c1 cA cdiv co cdiv co cmul co c1 c1 c1 cA cdiv co cdiv co cmul co cA
      c1 cA cdiv co c1 c1 cA cdiv co cdiv co cmul co cmul co c1 c1 cA cdiv co
      cdiv co cA c1 cA cdiv co cmul co c1 c1 c1 cA cdiv co cdiv co cmul cA
      recrec.1 recrec.2 recidi opreq1i cA c1 cA cdiv co c1 c1 cA cdiv co cdiv
      co recrec.1 cA recrec.1 recrec.2 reccli c1 cA cdiv co cA recrec.1
      recrec.2 reccli c1 cA ax1cn recrec.1 ax1ne0 recrec.2 divne0i reccli
      mulassi c1 c1 cA cdiv co cdiv co c1 cA cdiv co cA recrec.1 recrec.2
      reccli c1 cA ax1cn recrec.1 ax1ne0 recrec.2 divne0i reccli mulid2i
      3eqtr3i cA recrec.1 mulid1i 3eqtr3i $.
      $( [9-Feb-1995] $)

    $( A number divided by itself is one. $)
    dividi $p |- ( A / A ) = 1 $=
      cA cA cdiv co cA c1 cA cdiv co cmul co c1 cA cA recrec.1 recrec.1
      recrec.2 divreci cA recrec.1 recrec.2 recidi eqtri $.
      $( [9-Feb-1995] $)

    $( Division into zero is zero. $)
    div0i $p |- ( 0 / A ) = 0 $=
      cA cc wcel cA cc0 wne cc0 cA cdiv co cc0 wceq recrec.1 recrec.2 cA div0
      mp2an $.
      $( [12-Aug-1999] $)
  $}

  ${
    div1.1 $e |- A e. CC $.
    $( A number divided by 1 is itself. $)
    div1i $p |- ( A / 1 ) = A $=
      cA c1 cdiv co cA wceq c1 cA cmul co cA wceq cA div1.1 mulid2i cA c1 cA
      div1.1 ax1cn div1.1 ax1ne0 divmuli mpbir $.
      $( [9-Jan-2002] $)
  $}

  $( A number divided by 1 is itself. $)
  div1 $p |- ( A e. CC -> ( A / 1 ) = A ) $=
    cA cc wcel cA c1 cdiv co cA wceq cA cc wcel cA c1 cif c1 cdiv co cA cc wcel
    cA c1 cif wceq cA c1 cA cA cc wcel cA c1 cif wceq cA c1 cdiv co cA cc wcel
    cA c1 cif c1 cdiv co cA cA cc wcel cA c1 cif cA cA cc wcel cA c1 cif c1
    cdiv opreq1 cA cA cc wcel cA c1 cif wceq id eqeq12d cA cc wcel cA c1 cif cA
    c1 cc ax1cn elimel div1i dedth $.
    $( [9-Jan-2002] $)

  $( Move negative sign inside of a division. $)
  divneg $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                -u ( A / B ) = ( -u A / B ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne w3a cA cneg c1 cB cdiv co cmul co cA c1 cB
    cdiv co cmul co cneg cA cneg cB cdiv co cA cB cdiv co cneg cA cc wcel cB cc
    wcel cB cc0 wne cA cneg c1 cB cdiv co cmul co cA c1 cB cdiv co cmul co cneg
    wceq cA cc wcel c1 cB cdiv co cc wcel cA cneg c1 cB cdiv co cmul co cA c1
    cB cdiv co cmul co cneg wceq cB cc wcel cB cc0 wne wa cA c1 cB cdiv co
    mulneg1 cB reccl sylan2 3impb cA cneg cc wcel cB cc wcel cB cc0 wne cA cneg
    cB cdiv co cA cneg c1 cB cdiv co cmul co wceq cA cc wcel cA cneg cB divrec
    cA negcl syl3an1 cA cc wcel cB cc wcel cB cc0 wne w3a cA cB cdiv co cA c1
    cB cdiv co cmul co cA cB divrec negeqd 3eqtr4rd $.
    $( [3-Jun-2005] $) $( [17-Sep-2004] $)

  $( Distribution of division over subtraction. $)
  divsubdir $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
               -> ( ( A - B ) / C ) = ( ( A / C ) - ( B / C ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cB cneg caddc co cC
    cdiv co cA cC cdiv co cB cneg cC cdiv co caddc co cA cB cmin co cC cdiv co
    cA cC cdiv co cB cC cdiv co cmin co cA cc wcel cB cneg cc wcel cC cc wcel
    cC cc0 wne wa cA cB cneg caddc co cC cdiv co cA cC cdiv co cB cneg cC cdiv
    co caddc co wceq cB cc wcel cA cB cneg cC divdir cB negcl syl3an2 cA cc
    wcel cB cc wcel cA cB cneg caddc co cC cdiv co cA cB cmin co cC cdiv co
    wceq cC cc wcel cC cc0 wne wa cA cc wcel cB cc wcel wa cA cB cneg caddc co
    cA cB cmin co cC cdiv cA cB negsub opreq1d 3adant3 cA cc wcel cB cc wcel cC
    cc wcel cC cc0 wne wa w3a cA cC cdiv co cB cC cdiv co cneg caddc co cA cC
    cdiv co cB cneg cC cdiv co caddc co cA cC cdiv co cB cC cdiv co cmin co cA
    cc wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cB cC cdiv co cneg cB cneg
    cC cdiv co cA cC cdiv co caddc cB cc wcel cC cc wcel cC cc0 wne wa cB cC
    cdiv co cneg cB cneg cC cdiv co wceq cA cc wcel cB cc wcel cC cc wcel cC
    cc0 wne cB cC cdiv co cneg cB cneg cC cdiv co wceq cB cC divneg 3expb
    3adant1 opreq2d cA cC cdiv co cc wcel cB cC cdiv co cc wcel cA cC cdiv co
    cB cC cdiv co cneg caddc co cA cC cdiv co cB cC cdiv co cmin co wceq cA cc
    wcel cB cc wcel cC cc wcel cC cc0 wne wa w3a cA cC cdiv co cB cC cdiv co
    negsub cA cc wcel cC cc wcel cC cc0 wne wa cA cC cdiv co cc wcel cB cc wcel
    cA cc wcel cC cc wcel cC cc0 wne cA cC cdiv co cc wcel cA cC divcl 3expb
    3adant2 cB cc wcel cC cc wcel cC cc0 wne wa cB cC cdiv co cc wcel cA cc
    wcel cB cc wcel cC cc wcel cC cc0 wne cB cC cdiv co cc wcel cB cC divcl
    3expb 3adant1 sylanc eqtr3d 3eqtr3d $.
    $( [6-Sep-2008] $) $( [4-Mar-2005] $)

  $( A number is equal to the reciprocal of its reciprocal.  Theorem I.10 of
     [Apostol] p. 18. $)
  recrec $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 1 / ( 1 / A ) ) = A ) $=
    cA cc wcel cA cc0 wne wa c1 c1 cA cdiv co cdiv co cA wceq c1 c1 cA cc wcel
    cA cc0 wne wa cA c1 cif cdiv co cdiv co cA cc wcel cA cc0 wne wa cA c1 cif
    wceq cA c1 cA cA cc wcel cA cc0 wne wa cA c1 cif wceq c1 c1 cA cdiv co cdiv
    co c1 c1 cA cc wcel cA cc0 wne wa cA c1 cif cdiv co cdiv co cA cA cc wcel
    cA cc0 wne wa cA c1 cif cA cA cc wcel cA cc0 wne wa cA c1 cif wceq c1 cA
    cdiv co c1 cA cc wcel cA cc0 wne wa cA c1 cif cdiv co c1 cdiv cA cA cc wcel
    cA cc0 wne wa cA c1 cif c1 cdiv opreq2 opreq2d cA cA cc wcel cA cc0 wne wa
    cA c1 cif wceq id eqeq12d cA cc wcel cA cc0 wne wa cA c1 cif cA cc wcel cA
    cc0 wne wa cA c1 cif cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc0 wne cA
    cc wcel cA cc0 wne wa cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA cc wcel
    cA cc0 wne wa cA c1 cif cc0 wne wa c1 cc wcel c1 cc0 wne wa cA c1 cA cA cc
    wcel cA cc0 wne wa cA c1 cif wceq cA cc wcel cA cc wcel cA cc0 wne wa cA c1
    cif cc wcel cA cc0 wne cA cc wcel cA cc0 wne wa cA c1 cif cc0 wne cA cA cc
    wcel cA cc0 wne wa cA c1 cif cc eleq1 cA cA cc wcel cA cc0 wne wa cA c1 cif
    cc0 neeq1 anbi12d c1 cA cc wcel cA cc0 wne wa cA c1 cif wceq c1 cc wcel cA
    cc wcel cA cc0 wne wa cA c1 cif cc wcel c1 cc0 wne cA cc wcel cA cc0 wne wa
    cA c1 cif cc0 wne c1 cA cc wcel cA cc0 wne wa cA c1 cif cc eleq1 c1 cA cc
    wcel cA cc0 wne wa cA c1 cif cc0 neeq1 anbi12d c1 cc wcel c1 cc0 wne ax1cn
    ax1ne0 pm3.2i elimhyp pm3.26i cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA
    cc wcel cA cc0 wne wa cA c1 cif cc0 wne cA cc wcel cA cc0 wne wa cA cc wcel
    cA cc0 wne wa cA c1 cif cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc0 wne
    wa c1 cc wcel c1 cc0 wne wa cA c1 cA cA cc wcel cA cc0 wne wa cA c1 cif
    wceq cA cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA cc0 wne cA cc
    wcel cA cc0 wne wa cA c1 cif cc0 wne cA cA cc wcel cA cc0 wne wa cA c1 cif
    cc eleq1 cA cA cc wcel cA cc0 wne wa cA c1 cif cc0 neeq1 anbi12d c1 cA cc
    wcel cA cc0 wne wa cA c1 cif wceq c1 cc wcel cA cc wcel cA cc0 wne wa cA c1
    cif cc wcel c1 cc0 wne cA cc wcel cA cc0 wne wa cA c1 cif cc0 wne c1 cA cc
    wcel cA cc0 wne wa cA c1 cif cc eleq1 c1 cA cc wcel cA cc0 wne wa cA c1 cif
    cc0 neeq1 anbi12d c1 cc wcel c1 cc0 wne ax1cn ax1ne0 pm3.2i elimhyp pm3.27i
    recreci dedth $.
    $( [26-Sep-1999] $)

  ${
    rec11.1 $e |- A e. CC $.
    rec11.2 $e |- B e. CC $.
    ${
      rec11i.3 $e |- A =/= 0 $.
      rec11i.4 $e |- B =/= 0 $.
      $( Reciprocal is one-to-one. $)
      rec11ii $p |- ( ( 1 / A ) = ( 1 / B ) <-> A = B ) $=
        c1 cA cdiv co c1 cB cdiv co wceq cA cB wceq c1 cA cdiv co c1 cB cdiv co
        wceq cA cB cmul co c1 cA cdiv co cmul co cA cB cmul co c1 cB cdiv co
        cmul co wceq cA cB wceq c1 cA cdiv co c1 cB cdiv co cA cB cmul co cmul
        opreq2 cA cB cmul co c1 cA cdiv co cmul co cA cB cmul co c1 cB cdiv co
        cmul co wceq cB cA wceq cA cB wceq cA cB cmul co c1 cA cdiv co cmul co
        cB cA cB cmul co c1 cB cdiv co cmul co cA cA cB cmul co c1 cA cdiv co
        cmul co cA c1 cA cdiv co cmul co cB cmul co c1 cB cmul co cB cA cB c1
        cA cdiv co rec11.1 rec11.2 cA rec11.1 rec11i.3 reccli mul23i cA c1 cA
        cdiv co cmul co c1 cB cmul cA rec11.1 rec11i.3 recidi opreq1i cB
        rec11.2 mulid2i 3eqtri cA cB cmul co c1 cB cdiv co cmul co cA cB c1 cB
        cdiv co cmul co cmul co cA c1 cmul co cA cA cB c1 cB cdiv co rec11.1
        rec11.2 cB rec11.2 rec11i.4 reccli mulassi cB c1 cB cdiv co cmul co c1
        cA cmul cB rec11.2 rec11i.4 recidi opreq2i cA rec11.1 mulid1i 3eqtri
        eqeq12i cB cA eqcom bitri sylib cA cB c1 cdiv opreq2 impbii $.
        $( [16-Sep-1999] $)
    $}

    $( Reciprocal is one-to-one. $)
    rec11i $p |- ( ( A =/= 0 /\ B =/= 0 ) ->
               ( ( 1 / A ) = ( 1 / B ) <-> A = B ) ) $=
      cA cc0 wne cB cc0 wne c1 cA cdiv co c1 cB cdiv co wceq cA cB wceq wb c1
      cA cc0 wne cA c1 cif cdiv co c1 cB cdiv co wceq cA cc0 wne cA c1 cif cB
      wceq wb c1 cA cc0 wne cA c1 cif cdiv co c1 cB cc0 wne cB c1 cif cdiv co
      wceq cA cc0 wne cA c1 cif cB cc0 wne cB c1 cif wceq wb cA cB c1 c1 cA cA
      cc0 wne cA c1 cif wceq c1 cA cdiv co c1 cB cdiv co wceq c1 cA cc0 wne cA
      c1 cif cdiv co c1 cB cdiv co wceq cA cB wceq cA cc0 wne cA c1 cif cB wceq
      cA cA cc0 wne cA c1 cif wceq c1 cA cdiv co c1 cA cc0 wne cA c1 cif cdiv
      co c1 cB cdiv co cA cA cc0 wne cA c1 cif c1 cdiv opreq2 eqeq1d cA cA cc0
      wne cA c1 cif cB eqeq1 bibi12d cB cB cc0 wne cB c1 cif wceq c1 cA cc0 wne
      cA c1 cif cdiv co c1 cB cdiv co wceq c1 cA cc0 wne cA c1 cif cdiv co c1
      cB cc0 wne cB c1 cif cdiv co wceq cA cc0 wne cA c1 cif cB wceq cA cc0 wne
      cA c1 cif cB cc0 wne cB c1 cif wceq cB cB cc0 wne cB c1 cif wceq c1 cB
      cdiv co c1 cB cc0 wne cB c1 cif cdiv co c1 cA cc0 wne cA c1 cif cdiv co
      cB cB cc0 wne cB c1 cif c1 cdiv opreq2 eqeq2d cB cB cc0 wne cB c1 cif cA
      cc0 wne cA c1 cif eqeq2 bibi12d cA cc0 wne cA c1 cif cB cc0 wne cB c1 cif
      cA cc0 wne cA c1 cc rec11.1 ax1cn keepel cB cc0 wne cB c1 cc rec11.2
      ax1cn keepel cA elimne0 cB elimne0 rec11ii dedth2h $.
      $( [16-Sep-1999] $)
  $}

  $( Mutual reciprocals.  (Contributed by Paul Chapman, 18-Oct-2007.) $)
  rec11r $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) )
                  -> ( ( 1 / A ) = B <-> ( 1 / B ) = A ) ) $=
    cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa wa c1 cA cdiv co cB wceq
    cA cB cmul co c1 wceq c1 cB cdiv co cA wceq cA cc wcel cA cc0 wne wa cB cc
    wcel c1 cA cdiv co cB wceq cA cB cmul co c1 wceq wb cB cc0 wne cB cc wcel
    cA cc wcel cA cc0 wne wa c1 cA cdiv co cB wceq cA cB cmul co c1 wceq wb c1
    cc wcel cB cc wcel cA cc wcel cA cc0 wne wa c1 cA cdiv co cB wceq cA cB
    cmul co c1 wceq wb ax1cn c1 cB cA divmul mp3an1 ancoms adantrr cA cc wcel
    cB cc wcel cB cc0 wne wa c1 cB cdiv co cA wceq cA cB cmul co c1 wceq wb cA
    cc0 wne cA cc wcel cB cc wcel cB cc0 wne wa wa c1 cB cdiv co cA wceq cB cA
    cmul co c1 wceq cA cB cmul co c1 wceq c1 cc wcel cA cc wcel cB cc wcel cB
    cc0 wne wa c1 cB cdiv co cA wceq cB cA cmul co c1 wceq wb ax1cn c1 cA cB
    divmul mp3an1 cA cc wcel cB cc wcel cB cc0 wne wa wa cA cB cmul co cB cA
    cmul co c1 cA cc wcel cB cc wcel cA cB cmul co cB cA cmul co wceq cB cc0
    wne cA cB mulcom adantrr eqeq1d bitr4d adantlr bitr4d $.
    $( [27-Dec-2008] $) $( [18-Oct-2007] $)

  $( Multiplication of two ratios.  Theorem I.14 of [Apostol] p. 18. $)
  divmuldiv $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) )
               -> ( ( A / C ) x. ( B / D ) ) = ( ( A x. B ) / ( C x. D ) ) ) $=
    cA cc wcel cC cc wcel cC cc0 wne wa cB cc wcel cD cc wcel cD cc0 wne wa cA
    cC cdiv co cB cD cdiv co cmul co cA cB cmul co cC cD cmul co cdiv co wceq
    cA cc wcel cC cc wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD cc0 wne w3a
    cA cC cdiv co cB cD cdiv co cmul co cA cB cmul co cC cD cmul co cdiv co
    wceq cA cc wcel cC cc wcel cC cc0 wne wa wa cB cc wcel cD cc wcel cD cc0
    wne wa wa cA cc wcel cC cc wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD cc0
    wne w3a wa cC cD cmul co cA cC cdiv co cB cD cdiv co cmul co cmul co cC cD
    cmul co cdiv co cA cC cdiv co cB cD cdiv co cmul co cA cB cmul co cC cD
    cmul co cdiv co cA cC cdiv co cB cD cdiv co cmul co cc wcel cC cD cmul co
    cc wcel cC cD cmul co cc0 wne cC cD cmul co cA cC cdiv co cB cD cdiv co
    cmul co cmul co cC cD cmul co cdiv co cA cC cdiv co cB cD cdiv co cmul co
    wceq cA cc wcel cC cc wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD cc0 wne
    w3a wa cA cC cdiv co cB cD cdiv co cmul co cC cD cmul co divcan3 cA cC cdiv
    co cc wcel cB cD cdiv co cc wcel cA cC cdiv co cB cD cdiv co cmul co cc
    wcel cA cc wcel cC cc wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD cc0 wne
    w3a cA cC cdiv co cB cD cdiv co mulcl cA cC divcl cB cD divcl syl2an cC cc
    wcel cC cc0 wne cB cc wcel cD cc wcel cD cc0 wne w3a cC cD cmul co cc wcel
    cA cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne cC cD cmul co cc
    wcel cB cc wcel cC cc wcel cD cc wcel cC cD cmul co cc wcel cC cc0 wne cD
    cc0 wne cC cD axmulcl ad2ant2r 3adantr1 3adantl1 cC cc wcel cC cc0 wne cB
    cc wcel cD cc wcel cD cc0 wne w3a cC cD cmul co cc0 wne cA cc wcel cC cc
    wcel cC cc0 wne wa cD cc wcel cD cc0 wne cC cD cmul co cc0 wne cB cc wcel
    cC cD mulne0 3adantr1 3adantl1 syl3anc cA cc wcel cC cc wcel cC cc0 wne w3a
    cB cc wcel cD cc wcel cD cc0 wne w3a wa cC cD cmul co cA cC cdiv co cB cD
    cdiv co cmul co cmul co cA cB cmul co cC cD cmul co cdiv cA cc wcel cC cc
    wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD cc0 wne w3a wa cC cA cC cdiv
    co cmul co cD cB cD cdiv co cmul co cmul co cC cD cmul co cA cC cdiv co cB
    cD cdiv co cmul co cmul co cA cB cmul co cC cc wcel cA cC cdiv co cc wcel
    wa cD cc wcel cB cD cdiv co cc wcel wa cC cA cC cdiv co cmul co cD cB cD
    cdiv co cmul co cmul co cC cD cmul co cA cC cdiv co cB cD cdiv co cmul co
    cmul co wceq cA cc wcel cC cc wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD
    cc0 wne w3a cC cA cC cdiv co cD cB cD cdiv co mul4 cA cc wcel cC cc wcel cC
    cc0 wne w3a cC cc wcel cA cC cdiv co cc wcel cA cc wcel cC cc wcel cC cc0
    wne 3simp2 cA cC divcl jca cB cc wcel cD cc wcel cD cc0 wne w3a cD cc wcel
    cB cD cdiv co cc wcel cB cc wcel cD cc wcel cD cc0 wne 3simp2 cB cD divcl
    jca syl2an cA cc wcel cC cc wcel cC cc0 wne w3a cB cc wcel cD cc wcel cD
    cc0 wne w3a cC cA cC cdiv co cmul co cA cD cB cD cdiv co cmul co cB cmul cA
    cC divcan2 cB cD divcan2 opreqan12d eqtr3d opreq1d eqtr3d cA cc wcel cC cc
    wcel cC cc0 wne 3anass cB cc wcel cD cc wcel cD cc0 wne 3anass syl2anbr
    an4s $.
    $( [28-Dec-2008] $) $( [1-Aug-2004] $)

  $( Cancellation of common factor in a ratio. $)
  divcan5 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\
       ( C e. CC /\ C =/= 0 ) ) -> ( ( C x. A ) / ( C x. B ) ) = ( A / B ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa w3a cC cC cdiv
    co cA cB cdiv co cmul co c1 cA cB cdiv co cmul co cC cA cmul co cC cB cmul
    co cdiv co cA cB cdiv co cC cc wcel cC cc0 wne wa cA cc wcel cC cC cdiv co
    cA cB cdiv co cmul co c1 cA cB cdiv co cmul co wceq cB cc wcel cB cc0 wne
    wa cC cc wcel cC cc0 wne wa cC cC cdiv co c1 cA cB cdiv co cmul cC divid
    opreq1d 3ad2ant3 cC cc wcel cA cc wcel cC cc wcel cC cc0 wne wa cB cc wcel
    cB cc0 wne wa cC cC cdiv co cA cB cdiv co cmul co cC cA cmul co cC cB cmul
    co cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne
    wa w3a cC cA cC cB divmuldiv cC cc wcel cC cc0 wne wa cA cc wcel cC cc wcel
    cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne pm3.26 3ad2ant3 cA cc wcel
    cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa 3simp1 cA cc wcel cB cc
    wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa 3simp3 cA cc wcel cB cc wcel cB
    cc0 wne wa cC cc wcel cC cc0 wne wa 3simp2 syl2anc cA cc wcel cB cc wcel cB
    cc0 wne wa c1 cA cB cdiv co cmul co cA cB cdiv co wceq cC cc wcel cC cc0
    wne wa cA cc wcel cB cc wcel cB cc0 wne wa wa cA cB cdiv co cc wcel c1 cA
    cB cdiv co cmul co cA cB cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne cA
    cB cdiv co cc wcel cA cB divcl 3expb cA cB cdiv co mulid2 syl 3adant3
    3eqtr3d $.
    $( [13-Jan-2006] $) $( [9-Jan-2006] $)

  $( Swap the denominators in the product of two ratios. $)
  divmul13 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) )
                -> ( ( A / C ) x. ( B / D ) ) = ( ( B / C ) x. ( A / D ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa
    wa wa cA cB cmul co cC cD cmul co cdiv co cB cA cmul co cC cD cmul co cdiv
    co cA cC cdiv co cB cD cdiv co cmul co cB cC cdiv co cA cD cdiv co cmul co
    cA cc wcel cB cc wcel wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa
    wa wa cA cB cmul co cB cA cmul co cC cD cmul co cdiv cA cc wcel cB cc wcel
    wa cA cB cmul co cB cA cmul co wceq cC cc wcel cC cc0 wne wa cD cc wcel cD
    cc0 wne wa wa cA cB axmulcom adantr opreq1d cA cB cC cD divmuldiv cB cc
    wcel cA cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cB cC
    cdiv co cA cD cdiv co cmul co cB cA cmul co cC cD cmul co cdiv co wceq cB
    cA cC cD divmuldiv ancom1s 3eqtr4d $.
    $( [14-Feb-2009] $) $( [3-May-2005] $)

  $( Swap the numerators in the product of two ratios. $)
  divmul24 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) )
                -> ( ( A / C ) x. ( B / D ) ) = ( ( A / D ) x. ( B / C ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa
    wa wa cA cB cmul co cC cD cmul co cdiv co cA cB cmul co cD cC cmul co cdiv
    co cA cC cdiv co cB cD cdiv co cmul co cA cD cdiv co cB cC cdiv co cmul co
    cA cc wcel cB cc wcel wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa
    wa wa cC cD cmul co cD cC cmul co cA cB cmul co cdiv cC cc wcel cC cc0 wne
    wa cD cc wcel cD cc0 wne wa wa cC cD cmul co cD cC cmul co wceq cA cc wcel
    cB cc wcel wa cC cc wcel cD cc wcel cC cD cmul co cD cC cmul co wceq cC cc0
    wne cD cc0 wne cC cD axmulcom ad2ant2r adantl opreq2d cA cB cC cD divmuldiv
    cA cc wcel cB cc wcel wa cD cc wcel cD cc0 wne wa cC cc wcel cC cc0 wne wa
    cA cD cdiv co cB cC cdiv co cmul co cA cB cmul co cD cC cmul co cdiv co
    wceq cA cB cD cC divmuldiv ancom2s 3eqtr4d $.
    $( [18-Feb-2009] $) $( [3-May-2005] $)

  $( Addition of two ratios.  Theorem I.13 of [Apostol] p. 18. $)
  divadddiv $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) ) ->
  ( ( A / C ) + ( B / D ) ) = ( ( ( A x. D ) + ( C x. B ) ) / ( C x. D ) ) ) $=
    cA cc wcel cB cc wcel wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa
    wa wa cA cD cmul co cC cB cmul co caddc co cC cD cmul co cdiv co cA cD cmul
    co cC cD cmul co cdiv co cC cB cmul co cC cD cmul co cdiv co caddc co cA cC
    cdiv co cB cD cdiv co caddc co cA cD cmul co cc wcel cC cB cmul co cc wcel
    cC cD cmul co cc wcel cC cD cmul co cc0 wne wa cA cD cmul co cC cB cmul co
    caddc co cC cD cmul co cdiv co cA cD cmul co cC cD cmul co cdiv co cC cB
    cmul co cC cD cmul co cdiv co caddc co wceq cA cc wcel cB cc wcel wa cC cc
    wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cA cD cmul co cC cB cmul
    co cC cD cmul co divdir cA cc wcel cB cc wcel wa cD cc wcel cD cc0 wne wa
    cA cD cmul co cc wcel cC cc wcel cC cc0 wne wa cA cc wcel cD cc wcel cA cD
    cmul co cc wcel cB cc wcel cD cc0 wne cA cD axmulcl ad2ant2r adantrl cB cc
    wcel cC cc wcel cC cc0 wne wa cC cB cmul co cc wcel cA cc wcel cD cc wcel
    cD cc0 wne wa cB cc wcel cC cc wcel cC cB cmul co cc wcel cC cc0 wne cC cc
    wcel cB cc wcel cC cB cmul co cc wcel cC cB axmulcl ancoms adantrr
    ad2ant2lr cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cC cD cmul
    co cc wcel cC cD cmul co cc0 wne wa cA cc wcel cB cc wcel wa cC cc wcel cC
    cc0 wne wa cD cc wcel cD cc0 wne wa wa cC cD cmul co cc wcel cC cD cmul co
    cc0 wne cC cc wcel cD cc wcel cC cD cmul co cc wcel cC cc0 wne cD cc0 wne
    cC cD axmulcl ad2ant2r cC cD mulne0 jca adantl syl3anc cA cc wcel cB cc
    wcel wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cA cD cmul
    co cC cD cmul co cdiv co cA cC cdiv co cC cB cmul co cC cD cmul co cdiv co
    cB cD cdiv co caddc cA cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0
    wne wa wa cA cD cmul co cC cD cmul co cdiv co cA cC cdiv co wceq cB cc wcel
    cA cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cA cC
    cdiv co cD cD cdiv co cmul co cA cC cdiv co c1 cmul co cA cD cmul co cC cD
    cmul co cdiv co cA cC cdiv co cA cc wcel cC cc wcel cC cc0 wne wa cD cc
    wcel cD cc0 wne wa wa wa cD cD cdiv co c1 cA cC cdiv co cmul cD cc wcel cD
    cc0 wne wa cD cD cdiv co c1 wceq cA cc wcel cC cc wcel cC cc0 wne wa cD
    divid ad2antll opreq2d cA cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD
    cc0 wne wa wa cA cc wcel cD cc wcel wa cA cC cdiv co cD cD cdiv co cmul co
    cA cD cmul co cC cD cmul co cdiv co wceq cC cc wcel cC cc0 wne wa cD cc
    wcel cD cc0 wne wa wa cD cc wcel cA cc wcel cC cc wcel cC cc0 wne wa cD cc
    wcel cD cc0 wne simprl anim2i cA cD cC cD divmuldiv sylancom cA cc wcel cC
    cc wcel cC cc0 wne wa cA cC cdiv co c1 cmul co cA cC cdiv co wceq cD cc
    wcel cD cc0 wne wa cA cc wcel cC cc wcel cC cc0 wne cA cC cdiv co c1 cmul
    co cA cC cdiv co wceq cA cc wcel cC cc wcel cC cc0 wne w3a cA cC cdiv co cc
    wcel cA cC cdiv co c1 cmul co cA cC cdiv co wceq cA cC divcl cA cC cdiv co
    mulid1 syl 3expb adantrr 3eqtr3d adantlr cB cc wcel cC cc wcel cC cc0 wne
    wa cD cc wcel cD cc0 wne wa wa cC cB cmul co cC cD cmul co cdiv co cB cD
    cdiv co wceq cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD
    cc0 wne wa wa wa cC cC cdiv co cB cD cdiv co cmul co c1 cB cD cdiv co cmul
    co cC cB cmul co cC cD cmul co cdiv co cB cD cdiv co cB cc wcel cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cC cC cdiv co c1 cB cD cdiv co
    cmul cC cc wcel cC cc0 wne wa cC cC cdiv co c1 wceq cB cc wcel cD cc wcel
    cD cc0 wne wa cC divid ad2antrl opreq1d cB cc wcel cC cc wcel cC cc0 wne wa
    cD cc wcel cD cc0 wne wa wa cC cc wcel cB cc wcel wa cC cC cdiv co cB cD
    cdiv co cmul co cC cB cmul co cC cD cmul co cdiv co wceq cB cc wcel cC cc
    wcel cC cc0 wne wa cC cc wcel cB cc wcel wa cD cc wcel cD cc0 wne wa cB cc
    wcel cC cc wcel cC cc wcel cB cc wcel wa cC cc0 wne cB cc wcel cC cc wcel
    pm3.22 adantrr adantrr cC cB cC cD divmuldiv sylancom cB cc wcel cD cc wcel
    cD cc0 wne wa c1 cB cD cdiv co cmul co cB cD cdiv co wceq cC cc wcel cC cc0
    wne wa cB cc wcel cD cc wcel cD cc0 wne c1 cB cD cdiv co cmul co cB cD cdiv
    co wceq cB cc wcel cD cc wcel cD cc0 wne w3a cB cD cdiv co cc wcel c1 cB cD
    cdiv co cmul co cB cD cdiv co wceq cB cD divcl cB cD cdiv co mulid2 syl
    3expb adantrl 3eqtr3d adantll opreq12d eqtr2d $.
    $( [21-Feb-2009] $) $( [1-Aug-2004] $)

  $( Division of two ratios.  Theorem I.15 of [Apostol] p. 18. $)

  divdivdiv $p |- ( ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) ) /\
                  ( ( C e. CC /\ C =/= 0 ) /\ ( D e. CC /\ D =/= 0 ) ) )
                -> ( ( A / B ) / ( C / D ) ) = ( ( A x. D ) / ( B x. C ) ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel
    cD cc0 wne wa wa wa cA cB cdiv co cC cD cdiv co cdiv co cA cD cmul co cB cC
    cmul co cdiv co wceq cC cD cdiv co cA cD cmul co cB cC cmul co cdiv co cmul
    co cA cB cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC
    cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cC cD cdiv co cD cC cdiv co cA cB
    cdiv co cmul co cmul co cC cD cdiv co cA cD cmul co cB cC cmul co cdiv co
    cmul co cA cB cdiv co cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC
    cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cD cC cdiv co cA cB cdiv co cmul
    co cA cD cmul co cB cC cmul co cdiv co cC cD cdiv co cmul cA cc wcel cB cc
    wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa
    wa cD cC cdiv co cA cB cdiv co cmul co cA cB cdiv co cD cC cdiv co cmul co
    cA cD cmul co cB cC cmul co cdiv co cD cC cdiv co cc wcel cA cB cdiv co cc
    wcel cD cC cdiv co cA cB cdiv co cmul co cA cB cdiv co cD cC cdiv co cmul
    co wceq cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD
    cc wcel cD cc0 wne wa wa wa cD cC cdiv co cA cB cdiv co mulcom cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cD cC cdiv co cc wcel cA cc wcel
    cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel cD cC cdiv
    co cc wcel cD cc0 wne cD cc wcel cC cc wcel cC cc0 wne wa cD cC cdiv co cc
    wcel cD cc wcel cC cc wcel cC cc0 wne cD cC cdiv co cc wcel cD cC divcl
    3expb ancoms adantrr adantl cA cc wcel cB cc wcel cB cc0 wne wa wa cA cB
    cdiv co cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cA cc
    wcel cB cc wcel cB cc0 wne cA cB cdiv co cc wcel cA cB divcl 3expb adantr
    sylanc cA cc wcel cD cc wcel wa cB cc wcel cB cc0 wne wa cC cc wcel cC cc0
    wne wa wa cA cB cdiv co cD cC cdiv co cmul co cA cD cmul co cB cC cmul co
    cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne
    wa cD cc wcel cD cc0 wne wa wa wa cA cD cB cC divmuldiv cA cc wcel cB cc
    wcel cB cc0 wne wa wa cA cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0
    wne wa wa cD cc wcel cA cc wcel cB cc wcel cB cc0 wne wa pm3.26 cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne simprl anim12i cA cc wcel cB cc wcel cB
    cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cB cc
    wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa cA cc wcel cB cc wcel cB cc0
    wne wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa simplr cA cc
    wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0
    wne wa simprl jca sylanc eqtrd opreq2d cA cc wcel cB cc wcel cB cc0 wne wa
    wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cC cD cdiv co cD
    cC cdiv co cmul co cA cB cdiv co cmul co c1 cA cB cdiv co cmul co cC cD
    cdiv co cD cC cdiv co cA cB cdiv co cmul co cmul co cA cB cdiv co cA cc
    wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0
    wne wa wa wa cC cD cdiv co cD cC cdiv co cmul co c1 cA cB cdiv co cmul cC
    cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cC cD cdiv co cD cC cdiv
    co cmul co c1 wceq cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0
    wne wa cD cc wcel cD cc0 wne wa wa cC cD cdiv co cD cC cdiv co cmul co cC
    cD cmul co cD cC cmul co cdiv co cD cC cmul co cD cC cmul co cdiv co c1 cC
    cc wcel cD cc wcel wa cD cc wcel cD cc0 wne wa cC cc wcel cC cc0 wne wa wa
    cC cD cdiv co cD cC cdiv co cmul co cC cD cmul co cD cC cmul co cdiv co
    wceq cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cC cD cD cC
    divmuldiv cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cC cc wcel
    cD cc wcel cC cc wcel cC cc0 wne cD cc wcel cD cc0 wne wa simpll cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne simprl jca cC cc wcel cC cc0 wne wa cD
    cc wcel cD cc0 wne wa pm3.22 sylanc cC cc wcel cC cc0 wne wa cD cc wcel cD
    cc0 wne wa wa cC cD cmul co cD cC cmul co cD cC cmul co cdiv cC cc wcel cD
    cc wcel cC cD cmul co cD cC cmul co wceq cC cc0 wne cD cc0 wne cC cD mulcom
    ad2ant2r opreq1d cD cC cmul co cc wcel cD cC cmul co cc0 wne cD cC cmul co
    cD cC cmul co cdiv co c1 wceq cC cc wcel cC cc0 wne wa cD cc wcel cD cc0
    wne wa wa cD cC cmul co divid cC cc wcel cD cc wcel cD cC cmul co cc wcel
    cC cc0 wne cD cc0 wne cD cc wcel cC cc wcel cD cC cmul co cc wcel cD cC
    axmulcl ancoms ad2ant2r cD cc wcel cD cc0 wne wa cC cc wcel cC cc0 wne wa
    cD cC cmul co cc0 wne cD cC mulne0 ancoms sylanc 3eqtrd adantl opreq1d cC
    cD cdiv co cc wcel cD cC cdiv co cc wcel cA cB cdiv co cc wcel cC cD cdiv
    co cD cC cdiv co cmul co cA cB cdiv co cmul co cC cD cdiv co cD cC cdiv co
    cA cB cdiv co cmul co cmul co wceq cA cc wcel cB cc wcel cB cc0 wne wa wa
    cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cC cD cdiv co cD cC
    cdiv co cA cB cdiv co mulass cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne
    wa wa cC cD cdiv co cc wcel cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc
    wcel cD cc wcel cD cc0 wne wa cC cD cdiv co cc wcel cC cc0 wne cC cc wcel
    cD cc wcel cD cc0 wne cC cD cdiv co cc wcel cC cD divcl 3expb adantlr
    adantl cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cD cC cdiv co
    cc wcel cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD
    cc wcel cD cC cdiv co cc wcel cD cc0 wne cD cc wcel cC cc wcel cC cc0 wne
    wa cD cC cdiv co cc wcel cD cc wcel cC cc wcel cC cc0 wne cD cC cdiv co cc
    wcel cD cC divcl 3expb ancoms adantrr adantl cA cc wcel cB cc wcel cB cc0
    wne wa wa cA cB cdiv co cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0
    wne wa wa cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cc wcel cA cB
    divcl 3expb adantr syl3anc cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc
    wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cA cB cdiv co cc wcel c1
    cA cB cdiv co cmul co cA cB cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne
    wa wa cA cB cdiv co cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne
    wa wa cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cc wcel cA cB divcl
    3expb adantr cA cB cdiv co mulid2 syl 3eqtr3d eqtr3d cA cB cdiv co cc wcel
    cA cD cmul co cB cC cmul co cdiv co cc wcel cC cD cdiv co cc wcel cC cD
    cdiv co cc0 wne wa cA cB cdiv co cC cD cdiv co cdiv co cA cD cmul co cB cC
    cmul co cdiv co wceq cC cD cdiv co cA cD cmul co cB cC cmul co cdiv co cmul
    co cA cB cdiv co wceq wb cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cA cB cdiv co cA cD cmul co cB
    cC cmul co cdiv co cC cD cdiv co divmul cA cc wcel cB cc wcel cB cc0 wne wa
    wa cA cB cdiv co cc wcel cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa
    wa cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cc wcel cA cB divcl 3expb
    adantr cA cD cmul co cc wcel cB cC cmul co cc wcel cB cC cmul co cc0 wne cA
    cD cmul co cB cC cmul co cdiv co cc wcel cA cc wcel cB cc wcel cB cc0 wne
    wa wa cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa wa wa cA cD cmul co
    cB cC cmul co divcl cA cc wcel cB cc wcel cB cc0 wne wa wa cD cc wcel cD
    cc0 wne wa cA cD cmul co cc wcel cC cc wcel cC cc0 wne wa cA cc wcel cD cc
    wcel cA cD cmul co cc wcel cB cc wcel cB cc0 wne wa cD cc0 wne cA cD
    axmulcl ad2ant2r adantrl cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa
    cB cC cmul co cc wcel cA cc wcel cD cc wcel cD cc0 wne wa cB cc wcel cC cc
    wcel cB cC cmul co cc wcel cB cc0 wne cC cc0 wne cB cC axmulcl ad2ant2r
    ad2ant2lr cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa cB cC cmul co
    cc0 wne cA cc wcel cD cc wcel cD cc0 wne wa cB cC mulne0 ad2ant2lr syl3anc
    cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc wcel
    cD cc0 wne wa wa wa cC cD cdiv co cc wcel cC cD cdiv co cc0 wne cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne wa wa cC cD cdiv co cc wcel cA cc wcel
    cB cc wcel cB cc0 wne wa wa cC cc wcel cD cc wcel cD cc0 wne wa cC cD cdiv
    co cc wcel cC cc0 wne cC cc wcel cD cc wcel cD cc0 wne cC cD cdiv co cc
    wcel cC cD divcl 3expb adantlr adantl cC cc wcel cC cc0 wne wa cD cc wcel
    cD cc0 wne wa wa cC cD cdiv co cc0 wne cA cc wcel cB cc wcel cB cc0 wne wa
    wa cC cD divne0 adantl jca syl3anc mpbird $.
    $( [28-Dec-2008] $) $( [2-Aug-2004] $)

  ${
    divmuldiv.1 $e |- A e. CC $.
    divmuldiv.2 $e |- B e. CC $.
    divmuldiv.3 $e |- C e. CC $.
    divmuldiv.4 $e |- D e. CC $.
    divmuldiv.5 $e |- B =/= 0 $.
    divmuldiv.6 $e |- D =/= 0 $.
    $( Multiplication of two ratios.  Theorem I.14 of [Apostol] p. 18. $)
    divmuldivi $p |- ( ( A / B ) x. ( C / D ) ) =
                      ( ( A x. C ) / ( B x. D ) ) $=
      cA cc wcel cC cc wcel wa cB cc wcel cB cc0 wne wa cD cc wcel cD cc0 wne
      wa wa cA cB cdiv co cC cD cdiv co cmul co cA cC cmul co cB cD cmul co
      cdiv co wceq cA cc wcel cC cc wcel divmuldiv.1 divmuldiv.3 pm3.2i cB cc
      wcel cB cc0 wne wa cD cc wcel cD cc0 wne wa cB cc wcel cB cc0 wne
      divmuldiv.2 divmuldiv.5 pm3.2i cD cc wcel cD cc0 wne divmuldiv.4
      divmuldiv.6 pm3.2i pm3.2i cA cC cB cD divmuldiv mp2an $.
      $( [16-Feb-1995] $)

    $( Swap denominators of two ratios. $)
    divmul13i $p |- ( ( A / B ) x. ( C / D ) ) =
                   ( ( C / B ) x. ( A / D ) ) $=
      cC cA cmul co cB cD cmul co cdiv co cA cC cmul co cB cD cmul co cdiv co
      cC cB cdiv co cA cD cdiv co cmul co cA cB cdiv co cC cD cdiv co cmul co
      cC cA cmul co cA cC cmul co cB cD cmul co cdiv cC cA divmuldiv.3
      divmuldiv.1 mulcomi opreq1i cC cB cA cD divmuldiv.3 divmuldiv.2
      divmuldiv.1 divmuldiv.4 divmuldiv.5 divmuldiv.6 divmuldivi cA cB cC cD
      divmuldiv.1 divmuldiv.2 divmuldiv.3 divmuldiv.4 divmuldiv.5 divmuldiv.6
      divmuldivi 3eqtr4ri $.
      $( [6-Aug-1999] $)

    $( Addition of two ratios.  Theorem I.13 of [Apostol] p. 18. $)
    divadddivi $p |- ( ( A / B ) + ( C / D ) ) =
                      ( ( ( A x. D ) + ( B x. C ) ) / ( B x. D ) ) $=
      cD cc wcel cD cc0 wne cA cB cdiv co cC cD cdiv co caddc co cA cD cmul co
      cB cC cmul co caddc co cB cD cmul co cdiv co wceq divmuldiv.4 divmuldiv.6
      cB cc wcel cB cc0 wne cD cc wcel cD cc0 wne wa cA cB cdiv co cC cD cdiv
      co caddc co cA cD cmul co cB cC cmul co caddc co cB cD cmul co cdiv co
      wceq divmuldiv.2 divmuldiv.5 cA cc wcel cC cc wcel cB cc wcel cB cc0 wne
      wa cD cc wcel cD cc0 wne wa wa cA cB cdiv co cC cD cdiv co caddc co cA cD
      cmul co cB cC cmul co caddc co cB cD cmul co cdiv co wceq divmuldiv.1
      divmuldiv.3 cA cC cB cD divadddiv mpanl12 mpanl12 mp2an $.
      $( [21-Feb-1995] $)

    ${
      divdivdiv.7 $e |- C =/= 0 $.
      $( Division of two ratios.  Theorem I.15 of [Apostol] p. 18. $)
      divdivdivi $p |- ( ( A / B ) / ( C / D ) )
                        = ( ( A x. D ) / ( B x. C ) ) $=
        cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel cC cc0 wne wa cD cc
        wcel cD cc0 wne wa wa cA cB cdiv co cC cD cdiv co cdiv co cA cD cmul co
        cB cC cmul co cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne wa
        divmuldiv.1 cB cc wcel cB cc0 wne divmuldiv.2 divmuldiv.5 pm3.2i pm3.2i
        cC cc wcel cC cc0 wne wa cD cc wcel cD cc0 wne wa cC cc wcel cC cc0 wne
        divmuldiv.3 divdivdiv.7 pm3.2i cD cc wcel cD cc0 wne divmuldiv.4
        divmuldiv.6 pm3.2i pm3.2i cA cB cC cD divdivdiv mp2an $.
        $( [22-Feb-1995] $)
    $}
  $}

  $( The reciprocal of a ratio. $)
  recdiv $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                ( 1 / ( A / B ) ) = ( B / A ) ) $=
    cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa wa c1 cA cB cdiv co cdiv
    co c1 cB cmul co c1 cA cmul co cdiv co cB cA cdiv co cA cc wcel cA cc0 wne
    wa cB cc wcel cB cc0 wne wa wa c1 c1 cdiv co cA cB cdiv co cdiv co c1 cB
    cmul co c1 cA cmul co cdiv co c1 cA cB cdiv co cdiv co c1 cc wcel c1 cc
    wcel c1 cc0 wne wa cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa wa c1
    c1 cdiv co cA cB cdiv co cdiv co c1 cB cmul co c1 cA cmul co cdiv co wceq
    ax1cn c1 cc wcel c1 cc0 wne ax1cn ax1ne0 pm3.2i c1 c1 cA cB divdivdiv
    mpanl12 c1 c1 cdiv co c1 cA cB cdiv co cdiv c1 ax1cn div1i opreq1i syl5eqr
    cA cc wcel cB cc wcel c1 cB cmul co c1 cA cmul co cdiv co cB cA cdiv co
    wceq cA cc0 wne cB cc0 wne cB cc wcel cA cc wcel c1 cB cmul co cB c1 cA
    cmul co cA cdiv cB mulid2 cA mulid2 opreqan12rd ad2ant2r eqtrd $.
    $( [12-Aug-2007] $) $( [3-Aug-2004] $)

  $( Cancellation of inverted fractions. $)
  divcan6 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
         ( ( A / B ) x. ( B / A ) ) = 1 ) $=
    cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa wa cA cB cdiv co c1 cA cB
    cdiv co cdiv co cmul co cA cB cdiv co cB cA cdiv co cmul co c1 cA cc wcel
    cA cc0 wne wa cB cc wcel cB cc0 wne wa wa c1 cA cB cdiv co cdiv co cB cA
    cdiv co cA cB cdiv co cmul cA cB recdiv opreq2d cA cB cdiv co cc wcel cA cB
    cdiv co cc0 wne cA cB cdiv co c1 cA cB cdiv co cdiv co cmul co c1 wceq cA
    cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa wa cA cB cdiv co recid cA cc
    wcel cB cc wcel cB cc0 wne wa cA cB cdiv co cc wcel cA cc0 wne cA cc wcel
    cB cc wcel cB cc0 wne cA cB cdiv co cc wcel cA cB divcl 3expb adantlr cA cB
    divne0 sylanc eqtr3d $.
    $( [29-Dec-2007] $) $( [28-Dec-2007] $)

  $( Swap denominators in a division. $)
  divdiv23 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 )
      /\ ( C e. CC /\ C =/= 0 ) ) -> ( ( A / B ) / C ) = ( ( A / C ) / B ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa w3a cA c1 cB
    cdiv co cmul co cC cdiv co cA cC cdiv co c1 cB cdiv co cmul co cA cB cdiv
    co cC cdiv co cA cC cdiv co cB cdiv co cA cc wcel c1 cB cdiv co cc wcel cC
    cc wcel cC cc0 wne wa cA c1 cB cdiv co cmul co cC cdiv co cA cC cdiv co c1
    cB cdiv co cmul co wceq cB cc wcel cB cc0 wne wa cA c1 cB cdiv co cC div23
    cB reccl syl3an2 cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne
    wa w3a cA cB cdiv co cA c1 cB cdiv co cmul co cC cdiv cA cc wcel cB cc wcel
    cB cc0 wne wa cA cB cdiv co cA c1 cB cdiv co cmul co wceq cC cc wcel cC cc0
    wne wa cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cA c1 cB cdiv co cmul
    co wceq cA cB divrec 3expb 3adant3 opreq1d cA cc wcel cC cc wcel cC cc0 wne
    wa cB cc wcel cB cc0 wne wa cA cC cdiv co cB cdiv co cA cC cdiv co c1 cB
    cdiv co cmul co wceq cA cc wcel cC cc wcel cC cc0 wne wa cB cc wcel cB cc0
    wne wa cA cC cdiv co cB cdiv co cA cC cdiv co c1 cB cdiv co cmul co wceq cA
    cc wcel cC cc wcel cC cc0 wne wa wa cB cc wcel cB cc0 wne cA cC cdiv co cB
    cdiv co cA cC cdiv co c1 cB cdiv co cmul co wceq cA cC cdiv co cc wcel cB
    cc wcel cB cc0 wne cA cC cdiv co cB cdiv co cA cC cdiv co c1 cB cdiv co
    cmul co wceq cA cc wcel cC cc wcel cC cc0 wne wa wa cA cC cdiv co cB divrec
    cA cc wcel cC cc wcel cC cc0 wne cA cC cdiv co cc wcel cA cC divcl 3expb
    syl3an1 3expb 3impa 3com23 3eqtr4d $.
    $( [28-Dec-2008] $) $( [2-Aug-2004] $)

  ${
    divdiv23.1 $e |- A e. CC $.
    divdiv23.2 $e |- B e. CC $.
    divdiv23.3 $e |- C e. CC $.
    ${
      divdiv23.4 $e |- B =/= 0 $.
      divdiv23.5 $e |- C =/= 0 $.
      $( Swap denominators in a division. $)
      divdiv23i $p |- ( ( A / B ) / C ) = ( ( A / C ) / B ) $=
        cA c1 cB cdiv co cmul co cC cdiv co cA cC cdiv co c1 cB cdiv co cmul co
        cA cB cdiv co cC cdiv co cA cC cdiv co cB cdiv co cA c1 cB cdiv co cC
        divdiv23.1 cB divdiv23.2 divdiv23.4 reccli divdiv23.3 divdiv23.5 div23i
        cA cB cdiv co cA c1 cB cdiv co cmul co cC cdiv cA cB divdiv23.1
        divdiv23.2 divdiv23.4 divreci opreq1i cA cC cdiv co cB cA cC divdiv23.1
        divdiv23.3 divdiv23.5 divcli divdiv23.2 divdiv23.4 divreci 3eqtr4i $.
        $( [15-Sep-1999] $)
    $}
    $( Swap denominators in a division. $)
    divdiv23zi $p |- ( ( B =/= 0 /\ C =/= 0 ) ->
                ( ( A / B ) / C ) = ( ( A / C ) / B ) ) $=
      cB cc wcel cB cc0 wne cC cc0 wne cA cB cdiv co cC cdiv co cA cC cdiv co
      cB cdiv co wceq divdiv23.2 cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne
      cA cB cdiv co cC cdiv co cA cC cdiv co cB cdiv co wceq divdiv23.3 cA cc
      wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa cA cB cdiv co cC
      cdiv co cA cC cdiv co cB cdiv co wceq divdiv23.1 cA cB cC divdiv23 mp3an1
      mpanr1 mpanl1 $.
      $( [15-Sep-1999] $)
  $}

  $( Division into a fraction. $)
  divdiv1 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\
       ( C e. CC /\ C =/= 0 ) ) -> ( ( A / B ) / C ) = ( A / ( B x. C ) ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa w3a cA cB cdiv
    co cC c1 cdiv co cdiv co cA c1 cmul co cB cC cmul co cdiv co cA cB cdiv co
    cC cdiv co cA cB cC cmul co cdiv co cA cc wcel cB cc wcel cB cc0 wne wa cC
    cc wcel cC cc0 wne wa cA cB cdiv co cC c1 cdiv co cdiv co cA c1 cmul co cB
    cC cmul co cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne wa wa cC cc wcel
    cC cc0 wne wa c1 cc wcel c1 cc0 wne wa cA cB cdiv co cC c1 cdiv co cdiv co
    cA c1 cmul co cB cC cmul co cdiv co wceq c1 cc wcel c1 cc0 wne ax1cn ax1ne0
    pm3.2i cA cB cC c1 divdivdiv mpanr2 3impa cB cc wcel cB cc0 wne wa cC cc
    wcel cC cc0 wne wa cA cB cdiv co cC c1 cdiv co cdiv co cA cB cdiv co cC
    cdiv co wceq cA cc wcel cC cc wcel cA cB cdiv co cC c1 cdiv co cdiv co cA
    cB cdiv co cC cdiv co wceq cB cc wcel cB cc0 wne wa cC cc0 wne cC cc wcel
    cC c1 cdiv co cC cA cB cdiv co cdiv cC div1 opreq2d ad2antrl 3adant1 cA cc
    wcel cB cc wcel cB cc0 wne wa cA c1 cmul co cB cC cmul co cdiv co cA cB cC
    cmul co cdiv co wceq cC cc wcel cC cc0 wne wa cA cc wcel cA c1 cmul co cA
    cB cC cmul co cdiv cA ax1id opreq1d 3ad2ant1 3eqtr3d $.
    $( [31-Dec-2007] $) $( [31-Dec-2007] $)

  $( Division by a fraction. $)
  divdiv2 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ ( C e. CC /\ C =/= 0 )
              ) -> ( A / ( B / C ) ) = ( ( A x. C ) / B ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel cC cc0 wne wa w3a cA c1 cdiv
    co cB cC cdiv co cdiv co cA cC cmul co c1 cB cmul co cdiv co cA cB cC cdiv
    co cdiv co cA cC cmul co cB cdiv co cA cc wcel cB cc wcel cB cc0 wne wa cC
    cc wcel cC cc0 wne wa cA c1 cdiv co cB cC cdiv co cdiv co cA cC cmul co c1
    cB cmul co cdiv co wceq cA cc wcel c1 cc wcel c1 cc0 wne wa cB cc wcel cB
    cc0 wne wa cC cc wcel cC cc0 wne wa wa cA c1 cdiv co cB cC cdiv co cdiv co
    cA cC cmul co c1 cB cmul co cdiv co wceq c1 cc wcel c1 cc0 wne ax1cn ax1ne0
    pm3.2i cA c1 cB cC divdivdiv mpanl2 3impb cA cc wcel cB cc wcel cB cc0 wne
    wa cC cc wcel cC cc0 wne wa w3a cA c1 cdiv co cA cB cC cdiv co cdiv cA cc
    wcel cB cc wcel cB cc0 wne wa cA c1 cdiv co cA wceq cC cc wcel cC cc0 wne
    wa cA div1 3ad2ant1 opreq1d cA cc wcel cB cc wcel cB cc0 wne wa cC cc wcel
    cC cc0 wne wa w3a c1 cB cmul co cB cA cC cmul co cdiv cA cc wcel cB cc wcel
    cB cc0 wne wa c1 cB cmul co cB wceq cC cc wcel cC cc0 wne wa cB cc wcel c1
    cB cmul co cB wceq cA cc wcel cB cc0 wne cB mulid2 ad2antrl 3adant3 opreq2d
    3eqtr3d $.
    $( [24-Feb-2009] $) $( [27-Dec-2008] $)

  $( Division into a reciprocal. $)
  recdiv2 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                ( ( 1 / A ) / B ) = ( 1 / ( A x. B ) ) ) $=
    c1 cc wcel cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa c1 cA cdiv co
    cB cdiv co c1 cA cB cmul co cdiv co wceq ax1cn c1 cA cB divdiv1 mp3an1 $.
    $( [19-Oct-2007] $) $( [19-Oct-2007] $)

  $( Two numbers whose reciprocals sum to 1 are called "conjugates" and satisfy
     this relationship.  Equation 5 of [Kreyszig] p. 12. $)
  conjmul $p |- ( ( ( P e. CC /\ P =/= 0 ) /\ ( Q e. CC /\ Q =/= 0 ) ) ->
      ( ( ( 1 / P ) + ( 1 / Q ) ) = 1 <-> ( ( P - 1 ) x. ( Q - 1 ) ) = 1 ) ) $=
    cP cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ cmul co c1 cP
    cdiv co c1 cQ cdiv co caddc co cmul co cP cQ cmul co c1 cmul co wceq cP cQ
    caddc co cP cQ cmul co wceq c1 cP cdiv co c1 cQ cdiv co caddc co c1 wceq cP
    c1 cmin co cQ c1 cmin co cmul co c1 wceq cP cc wcel cP cc0 wne wa cQ cc
    wcel cQ cc0 wne wa wa cP cQ cmul co c1 cP cdiv co c1 cQ cdiv co caddc co
    cmul co cP cQ caddc co cP cQ cmul co c1 cmul co cP cQ cmul co cP cc wcel cP
    cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ cmul co c1 cP cdiv co cmul co
    cP cQ cmul co c1 cQ cdiv co cmul co caddc co cQ cP caddc co cP cQ cmul co
    c1 cP cdiv co c1 cQ cdiv co caddc co cmul co cP cQ caddc co cP cc wcel cP
    cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ cmul co c1 cP cdiv co cmul co
    cQ cP cQ cmul co c1 cQ cdiv co cmul co cP caddc cP cc wcel cP cc0 wne wa cQ
    cc wcel cQ cc0 wne wa wa cP cQ cmul co c1 cP cdiv co cmul co cP c1 cP cdiv
    co cmul co cQ cmul co c1 cQ cmul co cQ cP cc wcel cQ cc wcel c1 cP cdiv co
    cc wcel cP cQ cmul co c1 cP cdiv co cmul co cP c1 cP cdiv co cmul co cQ
    cmul co wceq cP cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ c1
    cP cdiv co mul23 cP cc wcel cP cc0 wne cQ cc wcel cQ cc0 wne wa simpll cP
    cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne simprl cP cc wcel cP cc0 wne wa
    c1 cP cdiv co cc wcel cQ cc wcel cQ cc0 wne wa cP reccl adantr syl3anc cP
    cc wcel cP cc0 wne wa cP c1 cP cdiv co cmul co cQ cmul co c1 cQ cmul co
    wceq cQ cc wcel cQ cc0 wne wa cP cc wcel cP cc0 wne wa cP c1 cP cdiv co
    cmul co c1 cQ cmul cP recid opreq1d adantr cQ cc wcel c1 cQ cmul co cQ wceq
    cP cc wcel cP cc0 wne wa cQ cc0 wne cQ mulid2 ad2antrl 3eqtrd cP cc wcel cP
    cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ cmul co c1 cQ cdiv co cmul co
    cP cQ c1 cQ cdiv co cmul co cmul co cP c1 cmul co cP cP cc wcel cQ cc wcel
    c1 cQ cdiv co cc wcel cP cQ cmul co c1 cQ cdiv co cmul co cP cQ c1 cQ cdiv
    co cmul co cmul co wceq cP cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne wa
    wa cP cQ c1 cQ cdiv co mulass cP cc wcel cP cc0 wne cQ cc wcel cQ cc0 wne
    wa simpll cP cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne simprl cQ cc wcel
    cQ cc0 wne wa c1 cQ cdiv co cc wcel cP cc wcel cP cc0 wne wa cQ reccl
    adantl syl3anc cQ cc wcel cQ cc0 wne wa cP cQ c1 cQ cdiv co cmul co cmul co
    cP c1 cmul co wceq cP cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne wa cQ c1
    cQ cdiv co cmul co c1 cP cmul cQ recid opreq2d adantl cP cc wcel cP c1 cmul
    co cP wceq cP cc0 wne cQ cc wcel cQ cc0 wne wa cP ax1id ad2antrr 3eqtrd
    opreq12d cP cQ cmul co cc wcel c1 cP cdiv co cc wcel c1 cQ cdiv co cc wcel
    cP cQ cmul co c1 cP cdiv co c1 cQ cdiv co caddc co cmul co cP cQ cmul co c1
    cP cdiv co cmul co cP cQ cmul co c1 cQ cdiv co cmul co caddc co wceq cP cc
    wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ cmul co c1 cP cdiv co
    c1 cQ cdiv co adddi cP cc wcel cQ cc wcel cP cQ cmul co cc wcel cP cc0 wne
    cQ cc0 wne cP cQ mulcl ad2ant2r cP cc wcel cP cc0 wne wa c1 cP cdiv co cc
    wcel cQ cc wcel cQ cc0 wne wa cP reccl adantr cQ cc wcel cQ cc0 wne wa c1
    cQ cdiv co cc wcel cP cc wcel cP cc0 wne wa cQ reccl adantl syl3anc cP cc
    wcel cQ cc wcel cP cQ caddc co cQ cP caddc co wceq cP cc0 wne cQ cc0 wne cP
    cQ addcom ad2ant2r 3eqtr4d cP cc wcel cQ cc wcel cP cQ cmul co c1 cmul co
    cP cQ cmul co wceq cP cc0 wne cQ cc0 wne cP cc wcel cQ cc wcel wa cP cQ
    cmul co cc wcel cP cQ cmul co c1 cmul co cP cQ cmul co wceq cP cQ mulcl cP
    cQ cmul co ax1id syl ad2ant2r eqeq12d c1 cP cdiv co c1 cQ cdiv co caddc co
    cc wcel cP cQ cmul co cc wcel cP cQ cmul co cc0 wne wa cP cQ cmul co c1 cP
    cdiv co c1 cQ cdiv co caddc co cmul co cP cQ cmul co c1 cmul co wceq c1 cP
    cdiv co c1 cQ cdiv co caddc co c1 wceq wb cP cc wcel cP cc0 wne wa cQ cc
    wcel cQ cc0 wne wa wa c1 cP cdiv co c1 cQ cdiv co caddc co cc wcel c1 cc
    wcel cP cQ cmul co cc wcel cP cQ cmul co cc0 wne wa cP cQ cmul co c1 cP
    cdiv co c1 cQ cdiv co caddc co cmul co cP cQ cmul co c1 cmul co wceq c1 cP
    cdiv co c1 cQ cdiv co caddc co c1 wceq wb ax1cn c1 cP cdiv co c1 cQ cdiv co
    caddc co c1 cP cQ cmul co mulcan mp3an2 c1 cP cdiv co cc wcel c1 cQ cdiv co
    cc wcel c1 cP cdiv co c1 cQ cdiv co caddc co cc wcel cP cc wcel cP cc0 wne
    wa cQ cc wcel cQ cc0 wne wa c1 cP cdiv co c1 cQ cdiv co addcl cP reccl cQ
    reccl syl2an cP cc wcel cP cc0 wne wa cQ cc wcel cQ cc0 wne wa wa cP cQ
    cmul co cc wcel cP cQ cmul co cc0 wne cP cc wcel cQ cc wcel cP cQ cmul co
    cc wcel cP cc0 wne cQ cc0 wne cP cQ mulcl ad2ant2r cP cQ mulne0 jca sylanc
    cP cc wcel cQ cc wcel cP cQ caddc co cP cQ cmul co wceq cP c1 cmin co cQ c1
    cmin co cmul co c1 wceq wb cP cc0 wne cQ cc0 wne cP cc wcel cQ cc wcel wa
    cP cQ cmul co cP cQ caddc co wceq cP c1 cmin co cQ c1 cmin co cmul co c1
    wceq cP cQ caddc co cP cQ cmul co wceq cP cQ muleqadd cP cQ caddc co cP cQ
    cmul co eqcom syl5bb ad2ant2r 3bitr3d $.
    $( [13-Mar-2007] $) $( [12-Nov-2006] $)

  ${
    $d x y B $.
    redivcl.1 $e |- A e. RR $.
    redivcl.2 $e |- B e. RR $.
    redivcl.3 $e |- B =/= 0 $.
    $( Closure law for division of reals. $)
    redivcli $p |- ( A / B ) e. RR $=
      cA cB cdiv co cA c1 cB cdiv co cmul co cr cA cB cA redivcl.1 recni cB
      redivcl.2 recni redivcl.3 divreci cA c1 cB cdiv co redivcl.1 cB vx cv
      cmul co c1 wceq vx cr wrex c1 cB cdiv co cr wcel cB cr wcel cB cc0 wne cB
      vx cv cmul co c1 wceq vx cr wrex redivcl.2 redivcl.3 vx cB axrrecex mp2an
      cB vx cv cmul co c1 wceq vx cr wrex vx cv cr wcel cB vx cv cmul co c1
      wceq wa vx wex c1 cB cdiv co cr wcel cB vx cv cmul co c1 wceq vx cr
      df-rex vx cv cr wcel cB vx cv cmul co c1 wceq wa c1 cB cdiv co cr wcel vx
      vx cv cr wcel cB vx cv cmul co c1 wceq c1 cB cdiv co cr wcel vx cv cr
      wcel cB vx cv cmul co c1 wceq c1 cB cdiv co vx cv wceq c1 cB cdiv co cr
      wcel vx cv cr wcel vx cv cc wcel c1 cB cdiv co vx cv wceq cB vx cv cmul
      co c1 wceq wb vx cv recn vx cv cc wcel c1 cB cdiv co vx cv wceq cB vx cv
      cmul co c1 wceq wb c1 cB cdiv co vx cv cc wcel vx cv c1 cif wceq cB vx cv
      cc wcel vx cv c1 cif cmul co c1 wceq wb vx cv c1 vx cv vx cv cc wcel vx
      cv c1 cif wceq c1 cB cdiv co vx cv wceq c1 cB cdiv co vx cv cc wcel vx cv
      c1 cif wceq cB vx cv cmul co c1 wceq cB vx cv cc wcel vx cv c1 cif cmul
      co c1 wceq vx cv vx cv cc wcel vx cv c1 cif c1 cB cdiv co eqeq2 vx cv vx
      cv cc wcel vx cv c1 cif wceq cB vx cv cmul co cB vx cv cc wcel vx cv c1
      cif cmul co c1 vx cv vx cv cc wcel vx cv c1 cif cB cmul opreq2 eqeq1d
      bibi12d c1 cB vx cv cc wcel vx cv c1 cif ax1cn cB redivcl.2 recni vx cv
      c1 cc ax1cn elimel redivcl.3 divmuli dedth syl vx cv cr c1 cB cdiv co
      eleq1a sylbird imp 19.23aiv sylbi ax-mp remulcli eqeltri $.
      $( [9-May-1999] $)
  $}

  ${
    redivclz.1 $e |- A e. RR $.
    redivclz.2 $e |- B e. RR $.
    $( Closure law for division of reals. $)
    redivclzi $p |- ( B =/= 0 -> ( A / B ) e. RR ) $=
      cB cc0 wne cA cB cdiv co cr wcel cA cB cc0 wne cB c1 cif cdiv co cr wcel
      cB c1 cB cB cc0 wne cB c1 cif wceq cA cB cdiv co cA cB cc0 wne cB c1 cif
      cdiv co cr cB cB cc0 wne cB c1 cif cA cdiv opreq2 eleq1d cA cB cc0 wne cB
      c1 cif redivclz.1 cB cc0 wne cB c1 cr redivclz.2 1re keepel cB elimne0
      redivcli dedth $.
      $( [9-May-1999] $)
  $}

  $( Closure law for division of reals. $)
  redivcl $p |- ( ( A e. RR /\ B e. RR /\ B =/= 0 ) -> ( A / B ) e. RR ) $=
    cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cr wcel cB cr
    wcel cB cc0 wne cA cB cdiv co cr wcel wi cB cc0 wne cA cr wcel cA cc0 cif
    cB cdiv co cr wcel wi cB cr wcel cB cc0 cif cc0 wne cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cdiv co cr wcel wi cA cB cc0 cc0 cA cA cr wcel cA cc0
    cif wceq cA cB cdiv co cr wcel cA cr wcel cA cc0 cif cB cdiv co cr wcel cB
    cc0 wne cA cA cr wcel cA cc0 cif wceq cA cB cdiv co cA cr wcel cA cc0 cif
    cB cdiv co cr cA cA cr wcel cA cc0 cif cB cdiv opreq1 eleq1d imbi2d cB cB
    cr wcel cB cc0 cif wceq cB cc0 wne cB cr wcel cB cc0 cif cc0 wne cA cr wcel
    cA cc0 cif cB cdiv co cr wcel cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cdiv co cr wcel cB cB cr wcel cB cc0 cif cc0 neeq1 cB cB cr wcel cB cc0 cif
    wceq cA cr wcel cA cc0 cif cB cdiv co cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cdiv co cr cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cdiv
    opreq2 eleq1d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr
    0re elimel cB cc0 cr 0re elimel redivclzi dedth2h 3impia $.
    $( [4-May-2005] $) $( [27-Sep-1999] $)

  ${
    rereccl.1 $e |- A e. RR $.
    rereccl.2 $e |- A =/= 0 $.
    $( Closure law for reciprocal. $)
    rereccli $p |- ( 1 / A ) e. RR $=
      c1 cA 1re rereccl.1 rereccl.2 redivcli $.
      $( [2-May-2005] $) $( [30-Apr-2005] $)
  $}

  ${
    rerecclz.1 $e |- A e. RR $.
    $( Closure law for reciprocal. $)
    rerecclzi $p |- ( A =/= 0 -> ( 1 / A ) e. RR ) $=
      c1 cA 1re rerecclz.1 redivclzi $.
      $( [2-May-2005] $) $( [30-Apr-2005] $)
  $}

  $( Closure law for reciprocal. $)
  rereccl $p |- ( ( A e. RR /\ A =/= 0 ) -> ( 1 / A ) e. RR ) $=
    c1 cr wcel cA cr wcel cA cc0 wne c1 cA cdiv co cr wcel 1re c1 cA redivcl
    mp3an1 $.
    $( [2-May-2005] $) $( [30-Apr-2005] $)

  ${
    eqneg.1 $e |- A e. CC $.
    $( A number equal to its negative is zero. $)
    eqnegi $p |- ( A = -u A <-> A = 0 ) $=
      cA cA cneg wceq cA cc0 wceq cA cA cneg wceq c1 c1 caddc co cc0 wceq wn cA
      cc0 wceq c1 c1 caddc co cc0 wne c1 c1 caddc co cc0 wceq wn c1 c1 caddc co
      c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii c1 c1
      caddc co cc0 df-ne mpbi cA cA cneg wceq c1 c1 caddc co cc0 wceq cA cc0
      wceq cA cA cneg wceq c1 c1 caddc co cA cmul co cc0 wceq c1 c1 caddc co
      cc0 wceq cA cc0 wceq wo cA cA cneg wceq cA cA caddc co cA cA cneg caddc
      co c1 c1 caddc co cA cmul co cc0 cA cA cneg cA caddc opreq2 cA eqneg.1
      1p1timesi cA cA cneg caddc co cc0 cA eqneg.1 negidi eqcomi 3eqtr4g c1 c1
      caddc co cA c1 c1 caddc co c1 c1 1re 1re readdcli recni eqneg.1 mul0ori
      sylib ord mpi cA cc0 wceq cc0 cc0 cneg cA cA cneg cc0 cneg cc0 cc0 cmin
      co cc0 cc0 df-neg cc0 0cn subidi eqtr2i cA cc0 wceq id cA cc0 negeq
      3eqtr4a impbii $.
      $( [29-May-1999] $)
  $}

  $( A number equal to its negative is zero. $)
  eqneg $p |- ( A e. CC -> ( A = -u A <-> A = 0 ) ) $=
    cA cc wcel cA cA cneg wceq cA cc0 wceq wb cA cc wcel cA cc0 cif cA cc wcel
    cA cc0 cif cneg wceq cA cc wcel cA cc0 cif cc0 wceq wb cA cc0 cA cA cc wcel
    cA cc0 cif wceq cA cA cneg wceq cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif
    cneg wceq cA cc0 wceq cA cc wcel cA cc0 cif cc0 wceq cA cA cc wcel cA cc0
    cif wceq cA cA cc wcel cA cc0 cif cA cneg cA cc wcel cA cc0 cif cneg cA cA
    cc wcel cA cc0 cif wceq id cA cA cc wcel cA cc0 cif negeq eqeq12d cA cA cc
    wcel cA cc0 cif cc0 eqeq1 bibi12d cA cc wcel cA cc0 cif cA cc0 cc 0cn
    elimel eqnegi dedth $.
    $( [13-Jul-2005] $) $( [12-Jul-2005] $)

  $( A number is zero iff its negative is zero. $)
  negeq0 $p |- ( A e. CC -> ( A = 0 <-> -u A = 0 ) ) $=
    cA cc wcel cA cA cneg wceq cA cneg cA cneg cneg wceq cA cc0 wceq cA cneg
    cc0 wceq cA cc wcel cA cneg cA cneg cneg wceq cA cneg cA wceq cA cA cneg
    wceq cA cc wcel cA cneg cneg cA cA cneg cA negneg eqeq2d cA cneg cA eqcom
    syl6rbb cA eqneg cA cc wcel cA cneg cc wcel cA cneg cA cneg cneg wceq cA
    cneg cc0 wceq wb cA negcl cA cneg eqneg syl 3bitr3d $.
    $( [14-Jul-2005] $) $( [12-Jul-2005] $)

  ${
    negne0.1 $e |- A e. CC $.
    $( A number is non-zero iff its negative is non-zero. $)
    negne0bi $p |- ( A =/= 0 <-> -u A =/= 0 ) $=
      cA cc0 cA cneg cc0 cA cc wcel cA cc0 wceq cA cneg cc0 wceq wb negne0.1 cA
      negeq0 ax-mp necon3bii $.
      $( [10-Aug-1999] $)
    ${
      negn0.2 $e |- A =/= 0 $.
      $( The negative of a non-zero number is non-zero. $)
      negne0i $p |- -u A =/= 0 $=
        cA cc0 wne cA cneg cc0 wne negn0.2 cA negne0.1 negne0bi mpbi $.
        $( [3-Sep-2004] $) $( [30-Jul-2004] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordering on reals (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Hypothesis for weak deduction theorem to eliminate ` 0 < A ` . $)
  elimgt0 $p |- 0 < if ( 0 < A , A , 1 ) $=
    cc0 cA clt wbr cc0 cc0 cA clt wbr cA c1 cif clt wbr cc0 c1 clt wbr cA c1 cA
    cc0 cA clt wbr cA c1 cif cc0 clt breq2 c1 cc0 cA clt wbr cA c1 cif cc0 clt
    breq2 lt01 elimhyp $.
    $( [15-May-1999] $)

  $( Hypothesis for weak deduction theorem to eliminate ` 0 <_ A ` . $)
  elimge0 $p |- 0 <_ if ( 0 <_ A , A , 0 ) $=
    cc0 cA cle wbr cc0 cc0 cA cle wbr cA cc0 cif cle wbr cc0 cc0 cle wbr cA cc0
    cA cc0 cA cle wbr cA cc0 cif cc0 cle breq2 cc0 cc0 cA cle wbr cA cc0 cif
    cc0 cle breq2 cc0 0re leidi elimhyp $.
    $( [30-Jul-1999] $)

  $( A number is less than itself plus 1. $)
  ltp1 $p |- ( A e. RR -> A < ( A + 1 ) ) $=
    c1 cr wcel cA cr wcel cA cA c1 caddc co clt wbr 1re c1 cr wcel cA cr wcel
    wa cc0 c1 clt wbr cA cA c1 caddc co clt wbr lt01 c1 cA ltaddpos mpbii mpan
    $.
    $( [20-Aug-2001] $)

  $( A number is less than or equal to itself plus 1. $)
  lep1 $p |- ( A e. RR -> A <_ ( A + 1 ) ) $=
    cA cr wcel cA cA c1 caddc co clt wbr cA cA c1 caddc co cle wbr cA ltp1 cA
    cr wcel cA c1 caddc co cr wcel cA cA c1 caddc co clt wbr cA cA c1 caddc co
    cle wbr wi cA peano2re cA cA c1 caddc co ltle mpdan mpd $.
    $( [6-Jan-2006] $) $( [5-Jan-2006] $)

  ${
    ltplus1.1 $e |- A e. RR $.
    $( A number is less than itself plus 1. $)
    ltp1i $p |- A < ( A + 1 ) $=
      cA cr wcel cA cA c1 caddc co clt wbr ltplus1.1 cA ltp1 ax-mp $.
      $( [20-Aug-2001] $)

    ${
      recgt0i.2 $e |- 0 < A $.
      $( The reciprocal of a positive number is positive.  Exercise 4 of
         [Apostol] p. 21. $)
      recgt0ii $p |- 0 < ( 1 / A ) $=
        cc0 c1 cA cdiv co clt wbr cc0 c1 cA cdiv co wceq c1 cA cdiv co cc0 clt
        wbr wo wn cc0 c1 cA cdiv co wceq c1 cA cdiv co cc0 clt wbr cc0 c1 cA
        cdiv co wne cc0 c1 cA cdiv co wceq wn c1 cA cdiv co cc0 wne cc0 c1 cA
        cdiv co wne c1 cA ax1cn cA ltplus1.1 recni ax1ne0 cA ltplus1.1
        recgt0i.2 gt0ne0ii divne0i c1 cA cdiv co cc0 necom mpbi cc0 c1 cA cdiv
        co df-ne mpbi c1 cA cdiv co cc0 clt wbr c1 cc0 clt wbr cc0 c1 clt wbr
        c1 cc0 clt wbr wn lt01 cc0 c1 0re 1re ltnsymi ax-mp cc0 c1 cA cdiv co
        cneg clt wbr cc0 c1 cneg clt wbr c1 cA cdiv co cc0 clt wbr c1 cc0 clt
        wbr cc0 c1 cA cdiv co cneg clt wbr cc0 c1 cA cdiv co cneg cA cmul co c1
        cneg clt cc0 c1 cA cdiv co cneg clt wbr cc0 cA clt wbr cc0 c1 cA cdiv
        co cneg cA cmul co clt wbr recgt0i.2 c1 cA cdiv co cneg cA c1 cA cdiv
        co cA ltplus1.1 cA ltplus1.1 recgt0i.2 gt0ne0ii rereccli renegcli
        ltplus1.1 mulgt0i mpan2 c1 cA cdiv co cneg cA cmul co c1 cA cdiv co cA
        cmul co cneg c1 cneg c1 cA cdiv co cA c1 cA cdiv co cA ltplus1.1 cA
        ltplus1.1 recgt0i.2 gt0ne0ii rereccli recni cA ltplus1.1 recni mulneg1i
        c1 cA cdiv co cA cmul co c1 c1 cA cdiv co cA cmul co cA c1 cA cdiv co
        cmul co c1 c1 cA cdiv co cA c1 cA cdiv co cA ltplus1.1 cA ltplus1.1
        recgt0i.2 gt0ne0ii rereccli recni cA ltplus1.1 recni mulcomi cA cA
        ltplus1.1 recni cA ltplus1.1 recgt0i.2 gt0ne0ii recidi eqtri negeqi
        eqtri syl6breq c1 cA cdiv co cr wcel c1 cA cdiv co cc0 clt wbr cc0 c1
        cA cdiv co cneg clt wbr wb cA ltplus1.1 cA ltplus1.1 recgt0i.2 gt0ne0ii
        rereccli c1 cA cdiv co lt0neg1 ax-mp c1 cr wcel c1 cc0 clt wbr cc0 c1
        cneg clt wbr wb 1re c1 lt0neg1 ax-mp 3imtr4i mto pm3.2ni cc0 cr wcel c1
        cA cdiv co cr wcel cc0 c1 cA cdiv co clt wbr cc0 c1 cA cdiv co wceq c1
        cA cdiv co cc0 clt wbr wo wn wb 0re cA ltplus1.1 cA ltplus1.1 recgt0i.2
        gt0ne0ii rereccli cc0 c1 cA cdiv co axlttri mp2an mpbir $.
        $( [15-May-1999] $)
    $}
  $}

  $( A number minus 1 is less than itself. $)
  ltm1 $p |- ( A e. RR -> ( A - 1 ) < A ) $=
    cA cr wcel cA c1 cmin co cA cc0 cmin co cA clt cA cr wcel cc0 c1 clt wbr cA
    c1 cmin co cA cc0 cmin co clt wbr lt01 cc0 cr wcel c1 cr wcel cA cr wcel
    cc0 c1 clt wbr cA c1 cmin co cA cc0 cmin co clt wbr wb 0re 1re cc0 c1 cA
    ltsub2 mp3an12 mpbii cA cr wcel cA cc wcel cA cc0 cmin co cA wceq cA recn
    cA subid1 syl breqtrd $.
    $( [10-Apr-2006] $) $( [9-Apr-2006] $)

  $( A transitive property of 'less than or equal' and plus 1. $)
  letrp1 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) -> A <_ ( B + 1 ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr w3a cA cB c1 caddc co clt wbr cA cB c1
    caddc co cle wbr cA cr wcel cB cr wcel cA cB cle wbr cA cB c1 caddc co clt
    wbr cA cr wcel cB cr wcel wa cA cB cle wbr cB cB c1 caddc co clt wbr cA cB
    c1 caddc co clt wbr cB cr wcel cB cB c1 caddc co clt wbr cA cr wcel cB ltp1
    adantl cA cr wcel cB cr wcel cB c1 caddc co cr wcel wa cA cB cle wbr cB cB
    c1 caddc co clt wbr wa cA cB c1 caddc co clt wbr wi cB cr wcel cA cr wcel
    cB cr wcel cB c1 caddc co cr wcel cA cB cle wbr cB cB c1 caddc co clt wbr
    wa cA cB c1 caddc co clt wbr wi cA cB cB c1 caddc co lelttr 3expb cB cr
    wcel cB c1 caddc co cr wcel cB peano2re ancli sylan2 mpan2d 3impia cA cr
    wcel cB cr wcel cA cB c1 caddc co clt wbr cA cB c1 caddc co cle wbr wi cA
    cB cle wbr cA cr wcel cB c1 caddc co cr wcel cA cB c1 caddc co clt wbr cA
    cB c1 caddc co cle wbr wi cB cr wcel cA cB c1 caddc co ltle cB peano2re
    sylan2 3adant3 mpd $.
    $( [12-Aug-2005] $) $( [5-Aug-2005] $)

  $( A transitive property of plus 1 and 'less than or equal'. $)
  p1le $p |- ( ( A e. RR /\ B e. RR /\ ( A + 1 ) <_ B ) -> A <_ B ) $=
    cA cr wcel cB cr wcel cA c1 caddc co cB cle wbr cA cB cle wbr cA cr wcel cB
    cr wcel wa cA cA c1 caddc co cle wbr cA c1 caddc co cB cle wbr cA cB cle
    wbr cA cr wcel cA cA c1 caddc co cle wbr cB cr wcel cA lep1 adantr cA cr
    wcel cA c1 caddc co cr wcel wa cB cr wcel cA cA c1 caddc co cle wbr cA c1
    caddc co cB cle wbr wa cA cB cle wbr wi cA cr wcel cA cr wcel cA c1 caddc
    co cr wcel cB cr wcel cA cA c1 caddc co cle wbr cA c1 caddc co cB cle wbr
    wa cA cB cle wbr wi cA cA c1 caddc co cB letr 3expa cA cr wcel cA c1 caddc
    co cr wcel cA peano2re ancli sylan mpand 3impia $.
    $( [2-Sep-2005] $) $( [16-Aug-2005] $)

  ${
    prodgt0.1 $e |- A e. RR $.
    prodgt0.2 $e |- B e. RR $.
    ${
      prodgt0i.3 $e |- 0 < A $.
      $( Lemma for ~ prodgt0i . $)
      prodgt0lem $p |- ( 0 < ( A x. B ) -> 0 < B ) $=
        cc0 cA cB cmul co clt wbr cc0 c1 cA cdiv co cmul co cA cB cmul co c1 cA
        cdiv co cmul co cc0 cB clt cc0 c1 cA cdiv co clt wbr cc0 cA cB cmul co
        clt wbr cc0 c1 cA cdiv co cmul co cA cB cmul co c1 cA cdiv co cmul co
        clt wbr wi cA prodgt0.1 prodgt0i.3 recgt0ii cc0 cA cB cmul co c1 cA
        cdiv co 0re cA cB prodgt0.1 prodgt0.2 remulcli cA prodgt0.1 cA
        prodgt0.1 prodgt0i.3 gt0ne0ii rereccli ltmullem ax-mp c1 cA cdiv co c1
        cA cdiv co cA prodgt0.1 cA prodgt0.1 prodgt0i.3 gt0ne0ii rereccli recni
        mul02i cA cB cmul co c1 cA cdiv co cmul co cA c1 cA cdiv co cmul co cB
        cmul co c1 cB cmul co cB cA cB c1 cA cdiv co cA prodgt0.1 recni cB
        prodgt0.2 recni c1 cA cdiv co cA prodgt0.1 cA prodgt0.1 prodgt0i.3
        gt0ne0ii rereccli recni mul23i cA c1 cA cdiv co cmul co c1 cB cmul cA
        cA prodgt0.1 recni cA prodgt0.1 prodgt0i.3 gt0ne0ii recidi opreq1i cB
        cB prodgt0.2 recni mulid2i 3eqtri 3brtr3g $.
        $( [15-May-1999] $)
    $}

  $( Infer that a multiplicand is positive from a nonnegative muliplier and
     positive product. $)
    prodgt0i $p |- ( ( 0 <_ A /\ 0 < ( A x. B ) ) -> 0 < B ) $=
      cc0 cA cle wbr cc0 cA cB cmul co clt wbr cc0 cB clt wbr cc0 cA cle wbr
      cc0 cA clt wbr cc0 cA wceq wo cc0 cA cB cmul co clt wbr cc0 cB clt wbr wi
      cc0 cA 0re prodgt0.1 leloei cc0 cA clt wbr cc0 cA cB cmul co clt wbr cc0
      cB clt wbr wi cc0 cA wceq cc0 cA clt wbr cc0 cA cB cmul co clt wbr cc0 cB
      clt wbr wi cc0 cc0 cA clt wbr cA c1 cif cB cmul co clt wbr cc0 cB clt wbr
      wi cA c1 cA cc0 cA clt wbr cA c1 cif wceq cc0 cA cB cmul co clt wbr cc0
      cc0 cA clt wbr cA c1 cif cB cmul co clt wbr cc0 cB clt wbr cA cc0 cA clt
      wbr cA c1 cif wceq cA cB cmul co cc0 cA clt wbr cA c1 cif cB cmul co cc0
      clt cA cc0 cA clt wbr cA c1 cif cB cmul opreq1 breq2d imbi1d cc0 cA clt
      wbr cA c1 cif cB cc0 cA clt wbr cA c1 cr prodgt0.1 1re keepel prodgt0.2
      cA elimgt0 prodgt0lem dedth cc0 cA wceq cc0 cA cB cmul co clt wbr cc0 cB
      clt wbr cc0 cA wceq cc0 cc0 clt wbr cc0 cA cB cmul co clt wbr cc0 0re
      ltnri cc0 cA wceq cc0 cA cB cmul co cc0 clt cc0 cA wceq cc0 cB cmul co cA
      cB cmul co cc0 cc0 cA cB cmul opreq1 cB cB prodgt0.2 recni mul02i syl5eqr
      breq2d mtbii pm2.21d jaoi sylbi imp $.
      $( [15-May-1999] $)

    $( Infer that a multiplicand is nonnegative from a positive muliplier and
       nonnegative product. $)
    prodge0i $p |- ( ( 0 < A /\ 0 <_ ( A x. B ) ) -> 0 <_ B ) $=
      cc0 cA clt wbr cc0 cA cB cmul co cle wbr cc0 cB cle wbr cc0 cA clt wbr cA
      cB cmul co cc0 clt wbr wn cB cc0 clt wbr wn cc0 cA cB cmul co cle wbr cc0
      cB cle wbr cc0 cA clt wbr cB cc0 clt wbr cA cB cmul co cc0 clt wbr cc0 cA
      clt wbr cc0 cB cneg clt wbr cc0 cA cB cneg cmul co clt wbr cB cc0 clt wbr
      cA cB cmul co cc0 clt wbr cc0 cA clt wbr cc0 cB cneg clt wbr cc0 cA cB
      cneg cmul co clt wbr cA cB cneg prodgt0.1 cB prodgt0.2 renegcli mulgt0i
      ex cB cr wcel cB cc0 clt wbr cc0 cB cneg clt wbr wb prodgt0.2 cB lt0neg1
      ax-mp cA cB cmul co cc0 clt wbr cc0 cA cB cmul co cneg clt wbr cc0 cA cB
      cneg cmul co clt wbr cA cB cmul co cr wcel cA cB cmul co cc0 clt wbr cc0
      cA cB cmul co cneg clt wbr wb cA cB prodgt0.1 prodgt0.2 remulcli cA cB
      cmul co lt0neg1 ax-mp cA cB cneg cmul co cA cB cmul co cneg cc0 clt cA cB
      cA prodgt0.1 recni cB prodgt0.2 recni mulneg2i breq2i bitr4i 3imtr4g
      con3d cc0 cA cB cmul co 0re cA cB prodgt0.1 prodgt0.2 remulcli lenlti cc0
      cB 0re prodgt0.2 lenlti 3imtr4g imp $.
      $( [4-Jul-2005] $) $( [2-Jul-2005] $)
  $}

  ${
    ltmul1.1 $e |- A e. RR $.
    ltmul1.2 $e |- B e. RR $.
    ltmul1.3 $e |- C e. RR $.
    ${
      ltmul1i.4 $e |- 0 < C $.
      $( Multiplication of both sides of 'less than' by a positive number.
         Theorem I.19 of [Apostol] p. 20.  (Proof shortened by Paul Chapman,
         25-Jan-2008.) $)
      ltmul1ii $p |- ( A < B <-> ( A x. C ) < ( B x. C ) ) $=
        cA cB clt wbr cA cC cmul co cB cC cmul co clt wbr cc0 cC clt wbr cA cB
        clt wbr cA cC cmul co cB cC cmul co clt wbr wi ltmul1i.4 cA cB cC
        ltmul1.1 ltmul1.2 ltmul1.3 ltmullem ax-mp cA cB clt wbr cA cC cmul co
        cB cC cmul co clt wbr cB cA cle wbr cB cC cmul co cA cC cmul co cle wbr
        cA cB clt wbr wn cA cC cmul co cB cC cmul co clt wbr wn cB cA clt wbr
        cB cA wceq wo cB cC cmul co cA cC cmul co clt wbr cB cC cmul co cA cC
        cmul co wceq wo cB cA cle wbr cB cC cmul co cA cC cmul co cle wbr cB cA
        clt wbr cB cC cmul co cA cC cmul co clt wbr cB cA wceq cB cC cmul co cA
        cC cmul co wceq cc0 cC clt wbr cB cA clt wbr cB cC cmul co cA cC cmul
        co clt wbr wi ltmul1i.4 cB cA cC ltmul1.2 ltmul1.1 ltmul1.3 ltmullem
        ax-mp cB cA cC cmul opreq1 orim12i cB cA ltmul1.2 ltmul1.1 leloei cB cC
        cmul co cA cC cmul co cB cC ltmul1.2 ltmul1.3 remulcli cA cC ltmul1.1
        ltmul1.3 remulcli leloei 3imtr4i cB cA ltmul1.2 ltmul1.1 lenlti cB cC
        cmul co cA cC cmul co cB cC ltmul1.2 ltmul1.3 remulcli cA cC ltmul1.1
        ltmul1.3 remulcli lenlti 3imtr3i con4i impbii $.
        $( [25-Jan-2008] $) $( [16-May-1999] $)
    $}

    $( Multiplication of both sides of 'less than' by a positive number.
       Theorem I.19 of [Apostol] p. 20. $)
    ltmul1i $p |- ( 0 < C -> ( A < B <-> ( A x. C ) < ( B x. C ) ) ) $=
      cc0 cC clt wbr cA cB clt wbr cA cC cmul co cB cC cmul co clt wbr wb cA cB
      clt wbr cA cc0 cC clt wbr cC c1 cif cmul co cB cc0 cC clt wbr cC c1 cif
      cmul co clt wbr wb cC c1 cC cc0 cC clt wbr cC c1 cif wceq cA cC cmul co
      cB cC cmul co clt wbr cA cc0 cC clt wbr cC c1 cif cmul co cB cc0 cC clt
      wbr cC c1 cif cmul co clt wbr cA cB clt wbr cC cc0 cC clt wbr cC c1 cif
      wceq cA cC cmul co cA cc0 cC clt wbr cC c1 cif cmul co cB cC cmul co cB
      cc0 cC clt wbr cC c1 cif cmul co clt cC cc0 cC clt wbr cC c1 cif cA cmul
      opreq2 cC cc0 cC clt wbr cC c1 cif cB cmul opreq2 breq12d bibi2d cA cB
      cc0 cC clt wbr cC c1 cif ltmul1.1 ltmul1.2 cc0 cC clt wbr cC c1 cr
      ltmul1.3 1re keepel cC elimgt0 ltmul1ii dedth $.
      $( [16-May-1999] $)

    ${
      ltdivi.4 $e |- 0 < C $.
      $( Division of both sides of 'less than' by a positive number. $)
      ltdiv1ii $p |- ( A < B <-> ( A / C ) < ( B / C ) ) $=
        cA cB clt wbr cA c1 cC cdiv co cmul co cB c1 cC cdiv co cmul co clt wbr
        cA cC cdiv co cB cC cdiv co clt wbr cA cB c1 cC cdiv co ltmul1.1
        ltmul1.2 cC ltmul1.3 cC ltmul1.3 ltdivi.4 gt0ne0ii rereccli cC ltmul1.3
        ltdivi.4 recgt0ii ltmul1ii cA cC cdiv co cA c1 cC cdiv co cmul co cB cC
        cdiv co cB c1 cC cdiv co cmul co clt cA cC cA ltmul1.1 recni cC
        ltmul1.3 recni cC ltmul1.3 ltdivi.4 gt0ne0ii divreci cB cC cB ltmul1.2
        recni cC ltmul1.3 recni cC ltmul1.3 ltdivi.4 gt0ne0ii divreci breq12i
        bitr4i $.
        $( [16-May-1999] $)
    $}

    $( Division of both sides of 'less than' by a positive number. $)
    ltdiv1i $p |- ( 0 < C -> ( A < B <-> ( A / C ) < ( B / C ) ) ) $=
      cc0 cC clt wbr cA cB clt wbr cA cC cdiv co cB cC cdiv co clt wbr wb cA cB
      clt wbr cA cc0 cC clt wbr cC c1 cif cdiv co cB cc0 cC clt wbr cC c1 cif
      cdiv co clt wbr wb cC c1 cC cc0 cC clt wbr cC c1 cif wceq cA cC cdiv co
      cB cC cdiv co clt wbr cA cc0 cC clt wbr cC c1 cif cdiv co cB cc0 cC clt
      wbr cC c1 cif cdiv co clt wbr cA cB clt wbr cC cc0 cC clt wbr cC c1 cif
      wceq cA cC cdiv co cA cc0 cC clt wbr cC c1 cif cdiv co cB cC cdiv co cB
      cc0 cC clt wbr cC c1 cif cdiv co clt cC cc0 cC clt wbr cC c1 cif cA cdiv
      opreq2 cC cc0 cC clt wbr cC c1 cif cB cdiv opreq2 breq12d bibi2d cA cB
      cc0 cC clt wbr cC c1 cif ltmul1.1 ltmul1.2 cc0 cC clt wbr cC c1 cr
      ltmul1.3 1re keepel cC elimgt0 ltdiv1ii dedth $.
      $( [16-May-1999] $)

    $( 'Less than' relationship between division and multiplication. $)
    ltmuldivi $p |- ( 0 < C -> ( ( A x. C ) < B <-> A < ( B / C ) ) ) $=
      cc0 cC clt wbr cA cC cmul co cB clt wbr cA cC cmul co cC cdiv co cB cC
      cdiv co clt wbr cA cB cC cdiv co clt wbr cA cC cmul co cB cC cA cC
      ltmul1.1 ltmul1.3 remulcli ltmul1.2 ltmul1.3 ltdiv1i cc0 cC clt wbr cA cC
      cmul co cC cdiv co cA cB cC cdiv co clt cc0 cC clt wbr cC cc0 wne cA cC
      cmul co cC cdiv co cA wceq cC ltmul1.3 gt0ne0i cA cC cA ltmul1.1 recni cC
      ltmul1.3 recni divcan4zi syl breq1d bitrd $.
      $( [19-Nov-2004] $) $( [12-Oct-1999] $)
  $}

  $( Infer that a multiplicand is positive from a nonnegative muliplier and
     positive product. $)
  prodgt0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 0 < ( A x. B ) ) )
                 -> 0 < B ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cA cB cmul co clt wbr wa cc0 cB
    clt wbr cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cA cB cmul co clt wbr wa
    cc0 cB clt wbr wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cA cr wcel cA cc0
    cif cB cmul co clt wbr wa cc0 cB clt wbr wi cc0 cA cr wcel cA cc0 cif cle
    wbr cc0 cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co clt wbr wa cc0
    cB cr wcel cB cc0 cif clt wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA cle wbr cc0 cA cB cmul co clt wbr wa cc0 cA cr wcel cA cc0 cif
    cle wbr cc0 cA cr wcel cA cc0 cif cB cmul co clt wbr wa cc0 cB clt wbr cA
    cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif cle wbr
    cc0 cA cB cmul co clt wbr cc0 cA cr wcel cA cc0 cif cB cmul co clt wbr cA
    cA cr wcel cA cc0 cif cc0 cle breq2 cA cA cr wcel cA cc0 cif wceq cA cB
    cmul co cA cr wcel cA cc0 cif cB cmul co cc0 clt cA cA cr wcel cA cc0 cif
    cB cmul opreq1 breq2d anbi12d imbi1d cB cB cr wcel cB cc0 cif wceq cc0 cA
    cr wcel cA cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif cB cmul co clt wbr wa
    cc0 cA cr wcel cA cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cmul co clt wbr wa cc0 cB clt wbr cc0 cB cr wcel cB cc0 cif clt wbr
    cB cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cB cmul co clt wbr
    cc0 cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co clt wbr cc0 cA cr
    wcel cA cc0 cif cle wbr cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif
    cB cmul co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cc0 clt cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cmul opreq2 breq2d anbi2d cB cB
    cr wcel cB cc0 cif cc0 clt breq2 imbi12d cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel prodgt0i dedth2h imp
    $.
    $( [3-May-2005] $) $( [24-Apr-2005] $)

  $( Infer that a multiplier is positive from a nonnegative muliplicand and
     positive product. $)
  prodgt02 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ B /\ 0 < ( A x. B ) ) )
                 -> 0 < A ) $=
    cA cr wcel cB cr wcel wa cc0 cB cle wbr cc0 cA cB cmul co clt wbr wa cc0 cA
    clt wbr cA cr wcel cB cr wcel wa cc0 cB cle wbr cc0 cB cA cmul co clt wbr
    cc0 cA clt wbr cc0 cA cB cmul co clt wbr cB cr wcel cA cr wcel cc0 cB cle
    wbr cc0 cB cA cmul co clt wbr wa cc0 cA clt wbr wi cB cr wcel cA cr wcel wa
    cc0 cB cle wbr cc0 cB cA cmul co clt wbr wa cc0 cA clt wbr cB cA prodgt0 ex
    ancoms cA cr wcel cB cr wcel wa cc0 cA cB cmul co clt wbr cc0 cB cA cmul co
    clt wbr cA cr wcel cB cr wcel wa cA cB cmul co cB cA cmul co cc0 clt cA cc
    wcel cB cc wcel cA cB cmul co cB cA cmul co wceq cA cr wcel cB cr wcel cA
    cB mulcom cA recn cB recn syl2an breq2d biimpd sylan2d imp $.
    $( [3-Jul-2005] $) $( [24-Apr-2005] $)

  $( Infer that a multiplicand is nonnegative from a positive muliplier and
     nonnegative product. $)
  prodge0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < A /\ 0 <_ ( A x. B ) ) )
                 -> 0 <_ B ) $=
    cA cr wcel cB cr wcel wa cc0 cA clt wbr cc0 cA cB cmul co cle wbr wa cc0 cB
    cle wbr cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cA cB cmul co cle wbr wa
    cc0 cB cle wbr wi cc0 cA cr wcel cA cc0 cif clt wbr cc0 cA cr wcel cA cc0
    cif cB cmul co cle wbr wa cc0 cB cle wbr wi cc0 cA cr wcel cA cc0 cif clt
    wbr cc0 cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cle wbr wa cc0
    cB cr wcel cB cc0 cif cle wbr wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA clt wbr cc0 cA cB cmul co cle wbr wa cc0 cA cr wcel cA cc0 cif
    clt wbr cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr wa cc0 cB cle wbr cA
    cA cr wcel cA cc0 cif wceq cc0 cA clt wbr cc0 cA cr wcel cA cc0 cif clt wbr
    cc0 cA cB cmul co cle wbr cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr cA
    cA cr wcel cA cc0 cif cc0 clt breq2 cA cA cr wcel cA cc0 cif wceq cA cB
    cmul co cA cr wcel cA cc0 cif cB cmul co cc0 cle cA cA cr wcel cA cc0 cif
    cB cmul opreq1 breq2d anbi12d imbi1d cB cB cr wcel cB cc0 cif wceq cc0 cA
    cr wcel cA cc0 cif clt wbr cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr wa
    cc0 cA cr wcel cA cc0 cif clt wbr cc0 cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cmul co cle wbr wa cc0 cB cle wbr cc0 cB cr wcel cB cc0 cif cle wbr
    cB cB cr wcel cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cB cmul co cle wbr
    cc0 cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cle wbr cc0 cA cr
    wcel cA cc0 cif clt wbr cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif
    cB cmul co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cc0 cle cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cmul opreq2 breq2d anbi2d cB cB
    cr wcel cB cc0 cif cc0 cle breq2 imbi12d cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel prodge0i dedth2h imp
    $.
    $( [9-Jul-2005] $) $( [2-Jul-2005] $)

  $( Infer that a multiplier is nonnegative from a positive muliplicand and
     nonnegative product. $)
  prodge02 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < B /\ 0 <_ ( A x. B ) ) )
                 -> 0 <_ A ) $=
    cA cr wcel cB cr wcel wa cc0 cB clt wbr cc0 cA cB cmul co cle wbr wa cc0 cA
    cle wbr cA cr wcel cB cr wcel wa cc0 cB clt wbr cc0 cB cA cmul co cle wbr
    cc0 cA cle wbr cc0 cA cB cmul co cle wbr cB cr wcel cA cr wcel cc0 cB clt
    wbr cc0 cB cA cmul co cle wbr wa cc0 cA cle wbr wi cB cr wcel cA cr wcel wa
    cc0 cB clt wbr cc0 cB cA cmul co cle wbr wa cc0 cA cle wbr cB cA prodge0 ex
    ancoms cA cr wcel cB cr wcel wa cc0 cA cB cmul co cle wbr cc0 cB cA cmul co
    cle wbr cA cr wcel cB cr wcel wa cA cB cmul co cB cA cmul co cc0 cle cA cc
    wcel cB cc wcel cA cB cmul co cB cA cmul co wceq cA cr wcel cB cr wcel cA
    cB mulcom cA recn cB recn syl2an breq2d biimpd sylan2d imp $.
    $( [14-Jul-2005] $) $( [2-Jul-2005] $)

  $( Multiplication of both sides of 'less than' by a positive number.  Theorem
     I.19 of [Apostol] p. 20. $)
  ltmul1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
               -> ( A < B <-> ( A x. C ) < ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cB clt wbr cA cC cmul
    co cB cC cmul co clt wbr wb cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr
    cA cB clt wbr cA cC cmul co cB cC cmul co clt wbr wb cA cr wcel cB cr wcel
    cC cr wcel cc0 cC clt wbr cA cB clt wbr cA cC cmul co cB cC cmul co clt wbr
    wb wi cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cA cB clt wbr cA cC
    cmul co cB cC cmul co clt wbr wb wi cc0 cC clt wbr cA cr wcel cA cc0 cif cB
    clt wbr cA cr wcel cA cc0 cif cC cmul co cB cC cmul co clt wbr wb wi cA cB
    cC cc0 cc0 cc0 cc0 cC clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    clt wbr cA cr wcel cA cc0 cif cC cmul co cB cr wcel cB cc0 cif cC cmul co
    clt wbr wb wi cc0 cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cmul co
    cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cmul co clt wbr wb wi cA cA cr
    wcel cA cc0 cif wceq cA cB clt wbr cA cC cmul co cB cC cmul co clt wbr wb
    cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC cmul co cB cC
    cmul co clt wbr wb cc0 cC clt wbr cA cA cr wcel cA cc0 cif wceq cA cB clt
    wbr cA cr wcel cA cc0 cif cB clt wbr cA cC cmul co cB cC cmul co clt wbr cA
    cr wcel cA cc0 cif cC cmul co cB cC cmul co clt wbr cA cA cr wcel cA cc0
    cif cB clt breq1 cA cA cr wcel cA cc0 cif wceq cA cC cmul co cA cr wcel cA
    cc0 cif cC cmul co cB cC cmul co clt cA cA cr wcel cA cc0 cif cC cmul
    opreq1 breq1d bibi12d imbi2d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA
    cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC cmul co cB cC cmul co clt wbr
    wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0
    cif cC cmul co cB cr wcel cB cc0 cif cC cmul co clt wbr wb cc0 cC clt wbr
    cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC cmul co
    cB cC cmul co clt wbr cA cr wcel cA cc0 cif cC cmul co cB cr wcel cB cc0
    cif cC cmul co clt wbr cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif clt
    breq2 cB cB cr wcel cB cc0 cif wceq cB cC cmul co cB cr wcel cB cc0 cif cC
    cmul co cA cr wcel cA cc0 cif cC cmul co clt cB cB cr wcel cB cc0 cif cC
    cmul opreq1 breq2d bibi12d imbi2d cC cC cr wcel cC cc0 cif wceq cc0 cC clt
    wbr cc0 cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cC cmul co cB cr wcel cB cc0 cif cC
    cmul co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA
    cr wcel cA cc0 cif cC cr wcel cC cc0 cif cmul co cB cr wcel cB cc0 cif cC
    cr wcel cC cc0 cif cmul co clt wbr wb cC cC cr wcel cC cc0 cif cc0 clt
    breq2 cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cmul co cB cr
    wcel cB cc0 cif cC cmul co clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0
    cif cmul co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cmul co clt wbr cA
    cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cC cC cr wcel cC cc0 cif
    wceq cA cr wcel cA cc0 cif cC cmul co cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif cmul co cB cr wcel cB cc0 cif cC cmul co cB cr wcel cB cc0 cif cC
    cr wcel cC cc0 cif cmul co clt cC cC cr wcel cC cc0 cif cA cr wcel cA cc0
    cif cmul opreq2 cC cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif cmul opreq2
    breq12d bibi2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr
    wcel cC cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re
    elimel ltmul1i dedth3h 3exp imp4a 3imp $.
    $( [3-Jan-2009] $) $( [13-Feb-2005] $)

  $( Multiplication of both sides of 'less than' by a positive number.  Theorem
     I.19 of [Apostol] p. 20. $)
  ltmul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cB clt wbr cA cC
    cmul co cB cC cmul co clt wbr cC cA cmul co cC cB cmul co clt wbr cA cB cC
    ltmul1 cA cr wcel cB cr wcel cC cr wcel cA cC cmul co cB cC cmul co clt wbr
    cC cA cmul co cC cB cmul co clt wbr wb cc0 cC clt wbr cA cr wcel cB cr wcel
    cC cc wcel cA cC cmul co cB cC cmul co clt wbr cC cA cmul co cC cB cmul co
    clt wbr wb cC cr wcel cA cr wcel cB cr wcel cC cc wcel w3a cA cC cmul co cC
    cA cmul co cB cC cmul co cC cB cmul co clt cA cr wcel cC cc wcel cA cC cmul
    co cC cA cmul co wceq cB cr wcel cA cc wcel cC cc wcel cA cC cmul co cC cA
    cmul co wceq cA cr wcel cA cC mulcom cA recn sylan 3adant2 cB cr wcel cC cc
    wcel cB cC cmul co cC cB cmul co wceq cA cr wcel cB cc wcel cC cc wcel cB
    cC cmul co cC cB cmul co wceq cB cr wcel cB cC mulcom cB recn sylan 3adant1
    breq12d cC recn syl3an3 3adant3r bitrd $.
    $( [1-Mar-2009] $) $( [13-Feb-2005] $)

  $( Multiplication of both sides of 'less than' by a positive number.  Theorem
     I.19 of [Apostol] p. 20. $)
  ltmul2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
                0 < C ) -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa cA cB clt wbr cA cC
    cmul co cB cC cmul co clt wbr cC cA cmul co cC cB cmul co clt wbr cA cr
    wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cB clt wbr cA cC cmul co cB
    cC cmul co clt wbr wb cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr
    wa cA cB cC ltmul1 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl1
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl2 cA cr wcel cB cr
    wcel cC cr wcel w3a cC cr wcel cc0 cC clt wbr cc0 cC clt wbr cA cr wcel cB
    cr wcel cC cr wcel 3simp3 cc0 cC clt wbr id anim12i syl3anc cA cr wcel cB
    cr wcel cC cr wcel w3a cA cC cmul co cB cC cmul co clt wbr cC cA cmul co cC
    cB cmul co clt wbr wb cc0 cC clt wbr cA cr wcel cB cr wcel cC cc wcel cA cC
    cmul co cB cC cmul co clt wbr cC cA cmul co cC cB cmul co clt wbr wb cC cr
    wcel cA cr wcel cB cr wcel cC cc wcel w3a cA cC cmul co cC cA cmul co cB cC
    cmul co cC cB cmul co clt cA cr wcel cC cc wcel cA cC cmul co cC cA cmul co
    wceq cB cr wcel cA cc wcel cC cc wcel cA cC cmul co cC cA cmul co wceq cA
    cr wcel cA cC mulcom cA recn sylan 3adant2 cB cr wcel cC cc wcel cB cC cmul
    co cC cB cmul co wceq cA cr wcel cB cc wcel cC cc wcel cB cC cmul co cC cB
    cmul co wceq cB cr wcel cB cC mulcom cB recn sylan 3adant1 breq12d cC recn
    syl3an3 adantr bitrd $.
    $( [22-Feb-2005] $) $( [13-Feb-2005] $)

  $( Multiplication of both sides of 'less than or equal to' by a positive
     number. $)
  lemul1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                -> ( A <_ B <-> ( A x. C ) <_ ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cB clt wbr cA cB
    wceq wo cA cC cmul co cB cC cmul co clt wbr cA cC cmul co cB cC cmul co
    wceq wo cA cB cle wbr cA cC cmul co cB cC cmul co cle wbr cA cr wcel cB cr
    wcel cC cr wcel cc0 cC clt wbr wa w3a cA cB clt wbr cA cC cmul co cB cC
    cmul co clt wbr cA cB wceq cA cC cmul co cB cC cmul co wceq cA cB cC ltmul1
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cmul co cB cC
    cmul co wceq cA cB wceq cA cc wcel cB cc wcel cC cc wcel cC cc0 wne wa cA
    cC cmul co cB cC cmul co wceq cA cB wceq wb cA cr wcel cB cr wcel cC cr
    wcel cc0 cC clt wbr wa cA cB cC mulcan2 cA recn cB recn cC cr wcel cc0 cC
    clt wbr wa cC cc wcel cC cc0 wne cC cr wcel cC cc wcel cc0 cC clt wbr cC
    recn adantr cC gt0ne0 jca syl3an bicomd orbi12d cA cr wcel cB cr wcel cC cr
    wcel cA cB cle wbr cA cB clt wbr cA cB wceq wo wb cc0 cC clt wbr cA cr wcel
    cB cr wcel cA cB cle wbr cA cB clt wbr cA cB wceq wo wb cC cr wcel cA cB
    leloe 3adant3 3adant3r cA cr wcel cB cr wcel cC cr wcel cA cC cmul co cB cC
    cmul co cle wbr cA cC cmul co cB cC cmul co clt wbr cA cC cmul co cB cC
    cmul co wceq wo wb cc0 cC clt wbr cA cC cmul co cr wcel cB cC cmul co cr
    wcel cA cC cmul co cB cC cmul co cle wbr cA cC cmul co cB cC cmul co clt
    wbr cA cC cmul co cB cC cmul co wceq wo wb cA cr wcel cB cr wcel cC cr wcel
    w3a cA cC cmul co cB cC cmul co leloe cA cr wcel cC cr wcel cA cC cmul co
    cr wcel cB cr wcel cA cC axmulrcl 3adant2 cB cr wcel cC cr wcel cB cC cmul
    co cr wcel cA cr wcel cB cC axmulrcl 3adant1 sylanc 3adant3r 3bitr4d $.
    $( [28-Feb-2009] $) $( [21-Feb-2005] $)

  $( Multiplication of both sides of 'less than or equal to' by a positive
     number. $)
  lemul1OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
                0 < C ) -> ( A <_ B <-> ( A x. C ) <_ ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa cA cB clt wbr cA cB
    wceq wo cA cC cmul co cB cC cmul co clt wbr cA cC cmul co cB cC cmul co
    wceq wo cA cB cle wbr cA cC cmul co cB cC cmul co cle wbr cA cr wcel cB cr
    wcel cC cr wcel w3a cc0 cC clt wbr wa cA cB clt wbr cA cC cmul co cB cC
    cmul co clt wbr cA cB wceq cA cC cmul co cB cC cmul co wceq cA cr wcel cB
    cr wcel cC cr wcel cc0 cC clt wbr wa cA cB clt wbr cA cC cmul co cB cC cmul
    co clt wbr wb cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa cA cB
    cC ltmul1 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl1 cA cr
    wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl2 cA cr wcel cB cr wcel cC
    cr wcel w3a cC cr wcel cc0 cC clt wbr cc0 cC clt wbr cA cr wcel cB cr wcel
    cC cr wcel 3simp3 cc0 cC clt wbr id anim12i syl3anc cA cr wcel cB cr wcel
    cC cr wcel w3a cc0 cC clt wbr wa cA cC cmul co cB cC cmul co wceq cA cB
    wceq cA cc wcel cB cc wcel cC cc wcel w3a cC cc0 wne cA cC cmul co cB cC
    cmul co wceq cA cB wceq wb cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt
    wbr wa cA cc wcel cB cc wcel cC cc wcel w3a cC cc0 wne cA cC cmul co cB cC
    cmul co wceq cA cB wceq wb cA cc wcel cB cc wcel cC cc wcel cC cc0 wne cA
    cC cmul co cB cC cmul co wceq cA cB wceq wb wi cA cc wcel cB cc wcel cC cc
    wcel cC cc0 wne cA cC cmul co cB cC cmul co wceq cA cB wceq wb cA cc wcel
    cB cc wcel cC cc wcel cC cc0 wne wa cA cC cmul co cB cC cmul co wceq cA cB
    wceq wb cA cB cC mulcan2 3exp exp4a 3imp imp cA cr wcel cB cr wcel cC cr
    wcel w3a cA cc wcel cB cc wcel cC cc wcel w3a cc0 cC clt wbr cA cr wcel cA
    cc wcel cB cr wcel cB cc wcel cC cr wcel cC cc wcel cA recn cB recn cC recn
    3anim123i adantr cC cr wcel cA cr wcel cc0 cC clt wbr cC cc0 wne cB cr wcel
    cC gt0ne0 3ad2antl3 sylanc bicomd orbi12d cA cr wcel cB cr wcel cC cr wcel
    w3a cA cB cle wbr cA cB clt wbr cA cB wceq wo wb cc0 cC clt wbr cA cr wcel
    cB cr wcel cA cB cle wbr cA cB clt wbr cA cB wceq wo wb cC cr wcel cA cB
    leloe 3adant3 adantr cA cr wcel cB cr wcel cC cr wcel w3a cA cC cmul co cB
    cC cmul co cle wbr cA cC cmul co cB cC cmul co clt wbr cA cC cmul co cB cC
    cmul co wceq wo wb cc0 cC clt wbr cA cC cmul co cr wcel cB cC cmul co cr
    wcel cA cC cmul co cB cC cmul co cle wbr cA cC cmul co cB cC cmul co clt
    wbr cA cC cmul co cB cC cmul co wceq wo wb cA cr wcel cB cr wcel cC cr wcel
    w3a cA cC cmul co cB cC cmul co leloe cA cr wcel cC cr wcel cA cC cmul co
    cr wcel cB cr wcel cA cC remulcl 3adant2 cB cr wcel cC cr wcel cB cC cmul
    co cr wcel cA cr wcel cB cC remulcl 3adant1 sylanc adantr 3bitr4d $.
    $( [23-Feb-2005] $) $( [21-Feb-2005] $)

  $( Multiplication of both sides of 'less than or equal to' by a positive
     number. $)
  lemul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
               -> ( A <_ B <-> ( C x. A ) <_ ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cB cle wbr cA cC
    cmul co cB cC cmul co cle wbr cC cA cmul co cC cB cmul co cle wbr cA cB cC
    lemul1 cA cr wcel cB cr wcel cC cr wcel cA cC cmul co cB cC cmul co cle wbr
    cC cA cmul co cC cB cmul co cle wbr wb cc0 cC clt wbr cA cr wcel cB cr wcel
    cC cr wcel w3a cA cC cmul co cC cA cmul co cB cC cmul co cC cB cmul co cle
    cA cr wcel cC cr wcel cA cC cmul co cC cA cmul co wceq cB cr wcel cA cc
    wcel cC cc wcel cA cC cmul co cC cA cmul co wceq cA cr wcel cC cr wcel cA
    cC mulcom cA recn cC recn syl2an 3adant2 cB cr wcel cC cr wcel cB cC cmul
    co cC cB cmul co wceq cA cr wcel cB cc wcel cC cc wcel cB cC cmul co cC cB
    cmul co wceq cB cr wcel cC cr wcel cB cC axmulcom cB recn cC recn syl2an
    3adant1 breq12d 3adant3r bitrd $.
    $( [4-Mar-2009] $) $( [16-Mar-2005] $)

  $( Multiplication of both sides of 'less than or equal to' by a positive
     number. $)
  lemul2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
                0 < C ) -> ( A <_ B <-> ( C x. A ) <_ ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa cA cB cle wbr cA cC
    cmul co cB cC cmul co cle wbr cC cA cmul co cC cB cmul co cle wbr cA cr
    wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cB cle wbr cA cC cmul co cB
    cC cmul co cle wbr wb cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr
    wa cA cB cC lemul1 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl1
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl2 cA cr wcel cB cr
    wcel cC cr wcel w3a cC cr wcel cc0 cC clt wbr cc0 cC clt wbr cA cr wcel cB
    cr wcel cC cr wcel 3simp3 cc0 cC clt wbr id anim12i syl3anc cA cr wcel cB
    cr wcel cC cr wcel w3a cA cC cmul co cB cC cmul co cle wbr cC cA cmul co cC
    cB cmul co cle wbr wb cc0 cC clt wbr cA cr wcel cB cr wcel cC cr wcel w3a
    cA cC cmul co cC cA cmul co cB cC cmul co cC cB cmul co cle cA cr wcel cC
    cr wcel cA cC cmul co cC cA cmul co wceq cB cr wcel cA cc wcel cC cc wcel
    cA cC cmul co cC cA cmul co wceq cA cr wcel cC cr wcel cA cC mulcom cA recn
    cC recn syl2an 3adant2 cB cr wcel cC cr wcel cB cC cmul co cC cB cmul co
    wceq cA cr wcel cB cc wcel cC cc wcel cB cC cmul co cC cB cmul co wceq cB
    cr wcel cC cr wcel cB cC mulcom cB recn cC recn syl2an 3adant1 breq12d
    adantr bitrd $.
    $( [17-Mar-2005] $) $( [16-Mar-2005] $)

  ${
    ltmul2.1 $e |- A e. RR $.
    ltmul2.2 $e |- B e. RR $.
    ltmul2.3 $e |- C e. RR $.
    $( Multiplication of both sides of 'less than' by a positive number.
       Theorem I.19 of [Apostol] p. 20. $)
    ltmul2i $p |- ( 0 < C -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
      cC cr wcel cc0 cC clt wbr cA cB clt wbr cC cA cmul co cC cB cmul co clt
      wbr wb ltmul2.3 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cB
      clt wbr cC cA cmul co cC cB cmul co clt wbr wb ltmul2.1 ltmul2.2 cA cB cC
      ltmul2 mp3an12 mpan $.
      $( [28-Jul-2009] $) $( [16-May-1999] $)

    $( Multiplication of both sides of 'less than' by a positive number.
       Theorem I.19 of [Apostol] p. 20. $)
    ltmul2iOLD $p |- ( 0 < C -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cA cB clt wbr cC cA cmul
      co cC cB cmul co clt wbr wb wi ltmul2.1 ltmul2.2 ltmul2.3 cA cr wcel cB
      cr wcel cC cr wcel w3a cc0 cC clt wbr cA cB clt wbr cC cA cmul co cC cB
      cmul co clt wbr wb cA cB cC ltmul2OLD ex mp3an $.
      $( [16-May-1999] $)

    $( Multiplication of both sides of 'less than or equal to' by a positive
       number. $)
    lemul1i $p |- ( 0 < C -> ( A <_ B <-> ( A x. C ) <_ ( B x. C ) ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cA cB cle wbr cA cC cmul
      co cB cC cmul co cle wbr wb wi ltmul2.1 ltmul2.2 ltmul2.3 cA cr wcel cB
      cr wcel cC cr wcel w3a cc0 cC clt wbr cA cB cle wbr cA cC cmul co cB cC
      cmul co cle wbr wb cA cB cC lemul1OLD ex mp3an $.
      $( [2-Aug-1999] $)

    $( Multiplication of both sides of 'less than or equal to' by a positive
       number. $)
    lemul2i $p |- ( 0 < C -> ( A <_ B <-> ( C x. A ) <_ ( C x. B ) ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cA cB cle wbr cC cA cmul
      co cC cB cmul co cle wbr wb wi ltmul2.1 ltmul2.2 ltmul2.3 cA cr wcel cB
      cr wcel cC cr wcel w3a cc0 cC clt wbr cA cB cle wbr cC cA cmul co cC cB
      cmul co cle wbr wb cA cB cC lemul2OLD ex mp3an $.
      $( [1-Aug-1999] $)
  $}

  $( Multiplication of both sides of 'less than or equal to' by a nonnegative
     number. $)
  lemul1a $p |- ( ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 <_ C ) ) /\
                 A <_ B ) -> ( A x. C ) <_ ( B x. C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa cA cB cle wbr cA cC cmul
    co cB cC cmul co cle wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr cA
    cB cle wbr cA cC cmul co cB cC cmul co cle wbr wi cA cr wcel cB cr wcel cC
    cr wcel cc0 cC cle wbr cA cB cle wbr cA cC cmul co cB cC cmul co cle wbr wi
    wi cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC cle wbr cc0 cC clt wbr cc0
    cC wceq wo cA cB cle wbr cA cC cmul co cB cC cmul co cle wbr wi cC cr wcel
    cA cr wcel cc0 cC cle wbr cc0 cC clt wbr cc0 cC wceq wo wb cB cr wcel cc0
    cr wcel cC cr wcel cc0 cC cle wbr cc0 cC clt wbr cc0 cC wceq wo wb 0re cc0
    cC leloe mpan 3ad2ant3 cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr
    cA cB cle wbr cA cC cmul co cB cC cmul co cle wbr wi cc0 cC wceq cA cr wcel
    cB cr wcel cC cr wcel w3a cc0 cC clt wbr cA cB cle wbr cA cC cmul co cB cC
    cmul co cle wbr wi cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa
    cA cB cle wbr cA cC cmul co cB cC cmul co cle wbr cA cB cC lemul1OLD biimpd
    ex cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC wceq cA cC cmul co cB cC
    cmul co cle wbr cA cB cle wbr cA cr wcel cB cr wcel cc0 cC wceq cA cC cmul
    co cB cC cmul co cle wbr wi cC cr wcel cc0 cC wceq cA cc0 cmul co cB cc0
    cmul co cle wbr cA cC cmul co cB cC cmul co cle wbr cA cr wcel cB cr wcel
    wa cc0 cC wceq cA cc0 cmul co cA cC cmul co cB cc0 cmul co cB cC cmul co
    cle cc0 cC cA cmul opreq2 cc0 cC cB cmul opreq2 breq12d cA cr wcel cB cr
    wcel wa cA cc0 cmul co cB cc0 cmul co cle wbr cc0 cc0 cle wbr cc0 0re leidi
    cA cc wcel cB cc wcel cA cc0 cmul co cB cc0 cmul co cle wbr cc0 cc0 cle wbr
    wb cA cr wcel cB cr wcel cA cc wcel cB cc wcel cA cc0 cmul co cc0 cB cc0
    cmul co cc0 cle cA mul01 cB mul01 breqan12d cA recn cB recn syl2an mpbiri
    syl5cbi 3adant3 a1dd jaod sylbid 3exp imp4a 3imp1 $.
    $( [8-Sep-2007] $) $( [21-Feb-2005] $)

  $( Multiplication of both sides of 'less than or equal to' by a nonnegative
     number. $)
  lemul1aOLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
               ( 0 <_ C /\ A <_ B ) ) -> ( A x. C ) <_ ( B x. C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC cle wbr cA cB cle wbr cA cC
    cmul co cB cC cmul co cle wbr cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC
    cle wbr cc0 cC clt wbr cc0 cC wceq wo cA cB cle wbr cA cC cmul co cB cC
    cmul co cle wbr wi cC cr wcel cA cr wcel cc0 cC cle wbr cc0 cC clt wbr cc0
    cC wceq wo wb cB cr wcel cc0 cr wcel cC cr wcel cc0 cC cle wbr cc0 cC clt
    wbr cc0 cC wceq wo wb 0re cc0 cC leloe mpan 3ad2ant3 cA cr wcel cB cr wcel
    cC cr wcel w3a cc0 cC clt wbr cA cB cle wbr cA cC cmul co cB cC cmul co cle
    wbr wi cc0 cC wceq cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr cA
    cB cle wbr cA cC cmul co cB cC cmul co cle wbr wi cA cr wcel cB cr wcel cC
    cr wcel w3a cc0 cC clt wbr wa cA cB cle wbr cA cC cmul co cB cC cmul co cle
    wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cB cle wbr cA cC
    cmul co cB cC cmul co cle wbr wb cA cr wcel cB cr wcel cC cr wcel w3a cc0
    cC clt wbr wa cA cB cC lemul1 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt
    wbr 3simpl1 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr 3simpl2 cA cr
    wcel cB cr wcel cC cr wcel w3a cC cr wcel cc0 cC clt wbr cc0 cC clt wbr cA
    cr wcel cB cr wcel cC cr wcel 3simp3 cc0 cC clt wbr id anim12i syl3anc
    biimpd ex cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC wceq cA cC cmul co cB
    cC cmul co cle wbr cA cB cle wbr cA cr wcel cB cr wcel cc0 cC wceq cA cC
    cmul co cB cC cmul co cle wbr wi cC cr wcel cc0 cC wceq cA cc0 cmul co cB
    cc0 cmul co cle wbr cA cC cmul co cB cC cmul co cle wbr cA cr wcel cB cr
    wcel wa cc0 cC wceq cA cc0 cmul co cA cC cmul co cB cc0 cmul co cB cC cmul
    co cle cc0 cC cA cmul opreq2 cc0 cC cB cmul opreq2 breq12d cA cr wcel cB cr
    wcel wa cA cc0 cmul co cB cc0 cmul co cle wbr cc0 cc0 cle wbr cc0 0re leidi
    cA cc wcel cB cc wcel cA cc0 cmul co cB cc0 cmul co cle wbr cc0 cc0 cle wbr
    wb cA cr wcel cB cr wcel cA cc wcel cB cc wcel cA cc0 cmul co cc0 cB cc0
    cmul co cc0 cle cA mul01 cB mul01 breqan12d cA recn cB recn syl2an mpbiri
    syl5cbi 3adant3 a1dd jaod sylbid imp32 $.
    $( [9-Mar-2005] $) $( [21-Feb-2005] $)

  $( Multiplication of both sides of 'less than or equal to' by a nonnegative
     number.  (Contributed by Paul Chapman, 7-Sep-2007.) $)
  lemul2a $p |- ( ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 <_ C ) ) /\
                      A <_ B ) -> ( C x. A ) <_ ( C x. B ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa w3a cA cB cle wbr wa cA
    cC cmul co cB cC cmul co cC cA cmul co cC cB cmul co cle cA cB cC lemul1a
    cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa w3a cA cC cmul co cC cA
    cmul co wceq cA cB cle wbr cA cr wcel cC cr wcel cc0 cC cle wbr wa cA cC
    cmul co cC cA cmul co wceq cB cr wcel cA cr wcel cC cr wcel cA cC cmul co
    cC cA cmul co wceq cc0 cC cle wbr cA cc wcel cC cc wcel cA cC cmul co cC cA
    cmul co wceq cA cr wcel cC cr wcel cA cC mulcom cA recn cC recn syl2an
    adantrr 3adant2 adantr cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa
    w3a cB cC cmul co cC cB cmul co wceq cA cB cle wbr cB cr wcel cC cr wcel
    cc0 cC cle wbr wa cB cC cmul co cC cB cmul co wceq cA cr wcel cB cr wcel cC
    cr wcel cB cC cmul co cC cB cmul co wceq cc0 cC cle wbr cB cc wcel cC cc
    wcel cB cC cmul co cC cB cmul co wceq cB cr wcel cC cr wcel cB cC mulcom cB
    recn cC recn syl2an adantrr 3adant1 adantr 3brtr3d $.
    $( [8-Sep-2007] $) $( [7-Sep-2007] $)

  $( Multiplication of both sides of 'less than or equal to' by a nonnegative
     number. $)
  lemul2aOLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
               ( 0 <_ C /\ A <_ B ) ) -> ( C x. A ) <_ ( C x. B ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC cle wbr cA cB cle wbr wa wa cA
    cC cmul co cB cC cmul co cC cA cmul co cC cB cmul co cle cA cr wcel cB cr
    wcel cC cr wcel cc0 cC cle wbr wa w3a cA cB cle wbr cA cC cmul co cB cC
    cmul co cle wbr cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC cle wbr cA cB
    cle wbr wa wa cA cB cC lemul1a cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC
    cle wbr cA cB cle wbr wa wa cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr
    wa cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr cA cB cle wbr wa 3simpl1
    cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr cA cB cle wbr wa 3simpl2 cA
    cr wcel cB cr wcel cC cr wcel w3a cC cr wcel cc0 cC cle wbr cA cB cle wbr
    wa cc0 cC cle wbr cA cr wcel cB cr wcel cC cr wcel 3simp3 cc0 cC cle wbr cA
    cB cle wbr pm3.26 anim12i 3jca cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC
    cle wbr cA cB cle wbr simprr sylanc cA cr wcel cB cr wcel cC cr wcel w3a cA
    cC cmul co cC cA cmul co wceq cc0 cC cle wbr cA cB cle wbr wa cA cr wcel cC
    cr wcel cA cC cmul co cC cA cmul co wceq cB cr wcel cA cc wcel cC cc wcel
    cA cC cmul co cC cA cmul co wceq cA cr wcel cC cr wcel cA cC mulcom cA recn
    cC recn syl2an 3adant2 adantr cA cr wcel cB cr wcel cC cr wcel w3a cB cC
    cmul co cC cB cmul co wceq cc0 cC cle wbr cA cB cle wbr wa cB cr wcel cC cr
    wcel cB cC cmul co cC cB cmul co wceq cA cr wcel cB cc wcel cC cc wcel cB
    cC cmul co cC cB cmul co wceq cB cr wcel cC cr wcel cB cC mulcom cB recn cC
    recn syl2an 3adant1 adantr 3brtr3d $.
    $( [18-Jun-2005] $) $( [16-Mar-2005] $)

  $( Comparison of product of two positive numbers. $)
  ltmul12a $p |- ( ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ A < B ) ) /\
               ( ( C e. RR /\ D e. RR ) /\ ( 0 <_ C /\ C < D ) ) ) ->
                 ( A x. C ) < ( B x. D ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cc0 cA cle wbr cA cB clt
    wbr wa cc0 cC cle wbr cC cD clt wbr wa cA cC cmul co cB cD cmul co clt wbr
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB
    clt wbr wa cc0 cC cle wbr cC cD clt wbr wa wa wa cA cC cmul co cB cC cmul
    co cle wbr cB cC cmul co cB cD cmul co clt wbr cA cC cmul co cB cD cmul co
    clt wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa w3a cA cB cle
    wbr cA cC cmul co cB cC cmul co cle wbr cA cr wcel cB cr wcel wa cC cr wcel
    cD cr wcel wa wa cc0 cA cle wbr cA cB clt wbr wa cc0 cC cle wbr cC cD clt
    wbr wa wa wa cA cB cC lemul1a cA cr wcel cB cr wcel wa cC cr wcel cD cr
    wcel wa wa cc0 cA cle wbr cA cB clt wbr wa cc0 cC cle wbr cC cD clt wbr wa
    wa wa cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa cA cr wcel cB cr
    wcel cC cr wcel cD cr wcel wa cc0 cA cle wbr cA cB clt wbr wa cc0 cC cle
    wbr cC cD clt wbr wa wa simplll cA cr wcel cB cr wcel cC cr wcel cD cr wcel
    wa cc0 cA cle wbr cA cB clt wbr wa cc0 cC cle wbr cC cD clt wbr wa wa
    simpllr cC cr wcel cD cr wcel wa cc0 cC cle wbr cC cD clt wbr wa cC cr wcel
    cc0 cC cle wbr wa cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB clt wbr wa
    cC cr wcel cD cr wcel wa cc0 cC cle wbr cC cD clt wbr wa wa cC cr wcel cc0
    cC cle wbr cC cr wcel cD cr wcel cc0 cC cle wbr cC cD clt wbr wa simpll cC
    cr wcel cD cr wcel wa cc0 cC cle wbr cC cD clt wbr simprl jca ad2ant2l 3jca
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB clt wbr wa cA cB cle wbr cC
    cr wcel cD cr wcel wa cc0 cC cle wbr cC cD clt wbr wa cA cr wcel cB cr wcel
    wa cA cB clt wbr cA cB cle wbr cc0 cA cle wbr cA cr wcel cB cr wcel wa cA
    cB clt wbr cA cB cle wbr cA cB ltle imp adantrl ad2ant2r sylanc cA cr wcel
    cB cr wcel wa cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB clt wbr wa
    cC cD clt wbr cB cC cmul co cB cD cmul co clt wbr cc0 cC cle wbr cA cr wcel
    cB cr wcel wa cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB clt wbr wa
    cC cD clt wbr cB cC cmul co cB cD cmul co clt wbr cA cr wcel cB cr wcel wa
    cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB clt wbr wa wa cC cD clt
    wbr cB cC cmul co cB cD cmul co clt wbr cC cr wcel cD cr wcel cB cr wcel
    w3a cc0 cB clt wbr cC cD clt wbr cB cC cmul co cB cD cmul co clt wbr wb cA
    cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB clt
    wbr wa wa cC cD cB ltmul2OLD cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel
    wa wa cC cr wcel cD cr wcel cB cr wcel w3a cc0 cA cle wbr cA cB clt wbr wa
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cC cr wcel cD cr wcel
    cB cr wcel cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel simprl cA cr wcel
    cB cr wcel wa cC cr wcel cD cr wcel simprr cA cr wcel cB cr wcel cC cr wcel
    cD cr wcel wa simplr 3jca adantr cA cr wcel cB cr wcel wa cc0 cA cle wbr cA
    cB clt wbr wa cc0 cB clt wbr cC cr wcel cD cr wcel wa cA cr wcel cB cr wcel
    wa cc0 cA cle wbr cA cB clt wbr wa cc0 cB clt wbr cc0 cr wcel cA cr wcel cB
    cr wcel cc0 cA cle wbr cA cB clt wbr wa cc0 cB clt wbr wi 0re cc0 cA cB
    lelttr mp3an1 imp adantlr sylanc biimpa anasss adantrrl cA cr wcel cB cr
    wcel wa cC cr wcel cD cr wcel wa wa cA cC cmul co cB cC cmul co cle wbr cB
    cC cmul co cB cD cmul co clt wbr wa cA cC cmul co cB cD cmul co clt wbr wi
    cc0 cA cle wbr cA cB clt wbr wa cc0 cC cle wbr cC cD clt wbr wa wa cA cC
    cmul co cr wcel cB cC cmul co cr wcel cB cD cmul co cr wcel cA cC cmul co
    cB cC cmul co cle wbr cB cC cmul co cB cD cmul co clt wbr wa cA cC cmul co
    cB cD cmul co clt wbr wi cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa
    wa cA cC cmul co cB cC cmul co cB cD cmul co lelttr cA cr wcel cC cr wcel
    cA cC cmul co cr wcel cB cr wcel cD cr wcel cA cC remulcl ad2ant2r cB cr
    wcel cC cr wcel cB cC cmul co cr wcel cA cr wcel cD cr wcel cB cC remulcl
    ad2ant2lr cB cr wcel cD cr wcel cB cD cmul co cr wcel cA cr wcel cC cr wcel
    cB cD remulcl ad2ant2l syl3anc adantr mp2and an4s $.
    $( [5-Feb-2006] $) $( [30-Dec-2005] $)

  $( Comparison of product of two nonnegative numbers. $)
  lemul12b $p |- ( ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR ) /\
       ( C e. RR /\ ( D e. RR /\ 0 <_ D ) ) ) -> ( ( A <_ B /\ C <_ D ) ->
                 ( A x. C ) <_ ( B x. D ) ) ) $=
    cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cD cr wcel cc0 cD cle
    wbr wa wa wa cA cB cle wbr cC cD cle wbr wa cA cC cmul co cA cD cmul co cle
    wbr cA cD cmul co cB cD cmul co cle wbr wa cA cC cmul co cB cD cmul co cle
    wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cD cr wcel cc0 cD
    cle wbr wa wa wa cC cD cle wbr cA cB cle wbr cA cC cmul co cA cD cmul co
    cle wbr cA cD cmul co cB cD cmul co cle wbr wa cA cr wcel cc0 cA cle wbr wa
    cB cr wcel wa cC cr wcel cD cr wcel cc0 cD cle wbr wa wa wa cC cD cle wbr
    cA cC cmul co cA cD cmul co cle wbr cA cB cle wbr cA cD cmul co cB cD cmul
    co cle wbr cA cr wcel cc0 cA cle wbr wa cC cr wcel cD cr wcel cc0 cD cle
    wbr wa wa cC cD cle wbr cA cC cmul co cA cD cmul co cle wbr wi cB cr wcel
    cA cr wcel cc0 cA cle wbr wa cC cr wcel cD cr wcel cC cD cle wbr cA cC cmul
    co cA cD cmul co cle wbr wi cc0 cD cle wbr cA cr wcel cc0 cA cle wbr wa cC
    cr wcel cD cr wcel cC cD cle wbr cA cC cmul co cA cD cmul co cle wbr wi cC
    cr wcel cD cr wcel cA cr wcel cc0 cA cle wbr wa cC cD cle wbr cA cC cmul co
    cA cD cmul co cle wbr wi cC cr wcel cD cr wcel cA cr wcel cc0 cA cle wbr wa
    w3a cC cD cle wbr cA cC cmul co cA cD cmul co cle wbr cC cD cA lemul2a ex
    3comr 3expb adantrrr adantlr cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cD
    cr wcel cc0 cD cle wbr wa cA cB cle wbr cA cD cmul co cB cD cmul co cle wbr
    wi cC cr wcel cA cr wcel cB cr wcel cD cr wcel cc0 cD cle wbr wa cA cB cle
    wbr cA cD cmul co cB cD cmul co cle wbr wi cc0 cA cle wbr cA cr wcel cB cr
    wcel cD cr wcel cc0 cD cle wbr wa cA cB cle wbr cA cD cmul co cB cD cmul co
    cle wbr wi cA cr wcel cB cr wcel cD cr wcel cc0 cD cle wbr wa w3a cA cB cle
    wbr cA cD cmul co cB cD cmul co cle wbr cA cB cD lemul1a ex 3expa adantllr
    adantrl anim12d ancomsd cA cC cmul co cr wcel cA cD cmul co cr wcel cB cD
    cmul co cr wcel cA cC cmul co cA cD cmul co cle wbr cA cD cmul co cB cD
    cmul co cle wbr wa cA cC cmul co cB cD cmul co cle wbr wi cA cr wcel cc0 cA
    cle wbr wa cB cr wcel wa cC cr wcel cD cr wcel cc0 cD cle wbr wa wa wa cA
    cC cmul co cA cD cmul co cB cD cmul co letr cA cr wcel cc0 cA cle wbr wa cC
    cr wcel cA cC cmul co cr wcel cB cr wcel cD cr wcel cc0 cD cle wbr wa cA cr
    wcel cC cr wcel cA cC cmul co cr wcel cc0 cA cle wbr cA cC remulcl adantlr
    ad2ant2r cA cr wcel cc0 cA cle wbr wa cD cr wcel cc0 cD cle wbr wa cA cD
    cmul co cr wcel cB cr wcel cC cr wcel cA cr wcel cD cr wcel cA cD cmul co
    cr wcel cc0 cA cle wbr cc0 cD cle wbr cA cD remulcl ad2ant2r ad2ant2rl cB
    cr wcel cD cr wcel cc0 cD cle wbr wa cB cD cmul co cr wcel cA cr wcel cc0
    cA cle wbr wa cC cr wcel cB cr wcel cD cr wcel cB cD cmul co cr wcel cc0 cD
    cle wbr cB cD remulcl adantrr ad2ant2l syl3anc syld $.
    $( [12-Mar-2008] $) $( [22-Feb-2008] $)

  $( Comparison of product of two nonnegative numbers. $)
  lemul12aOLD $p |- ( ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ A <_ B ) ) /\
               ( ( C e. RR /\ D e. RR ) /\ ( 0 <_ C /\ C <_ D ) ) ) ->
                 ( A x. C ) <_ ( B x. D ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cc0 cA cle wbr cA cB cle
    wbr wa cc0 cC cle wbr cC cD cle wbr wa cA cC cmul co cB cD cmul co cle wbr
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB
    cle wbr wa cc0 cC cle wbr cC cD cle wbr wa wa wa cA cC cmul co cA cD cmul
    co cB cD cmul co cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cA cC
    cmul co cr wcel cc0 cA cle wbr cA cB cle wbr wa cc0 cC cle wbr cC cD cle
    wbr wa wa cA cr wcel cC cr wcel cA cC cmul co cr wcel cB cr wcel cD cr wcel
    cA cC remulcl ad2ant2r adantr cA cr wcel cB cr wcel wa cC cr wcel cD cr
    wcel wa wa cA cD cmul co cr wcel cc0 cA cle wbr cA cB cle wbr wa cc0 cC cle
    wbr cC cD cle wbr wa wa cA cr wcel cD cr wcel cA cD cmul co cr wcel cB cr
    wcel cC cr wcel cA cD remulcl ad2ant2rl adantr cA cr wcel cB cr wcel wa cC
    cr wcel cD cr wcel wa wa cB cD cmul co cr wcel cc0 cA cle wbr cA cB cle wbr
    wa cc0 cC cle wbr cC cD cle wbr wa wa cB cr wcel cD cr wcel cB cD cmul co
    cr wcel cA cr wcel cC cr wcel cB cD remulcl ad2ant2l adantr cA cr wcel cB
    cr wcel wa cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB cle wbr wa cc0
    cC cle wbr cC cD cle wbr wa wa cA cC cmul co cA cD cmul co cle wbr cA cr
    wcel cC cr wcel cD cr wcel wa cc0 cA cle wbr cA cB cle wbr wa cc0 cC cle
    wbr cC cD cle wbr wa wa cA cC cmul co cA cD cmul co cle wbr wi cB cr wcel
    cA cr wcel cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cC cD cle wbr cA cC
    cmul co cA cD cmul co cle wbr cc0 cA cle wbr cA cB cle wbr wa cc0 cC cle
    wbr cC cD cle wbr wa cC cr wcel cD cr wcel wa cA cr wcel cc0 cA cle wbr cC
    cD cle wbr wa cA cC cmul co cA cD cmul co cle wbr wi cC cr wcel cD cr wcel
    cA cr wcel cc0 cA cle wbr cC cD cle wbr wa cA cC cmul co cA cD cmul co cle
    wbr wi cC cr wcel cD cr wcel cA cr wcel w3a cc0 cA cle wbr cC cD cle wbr wa
    cA cC cmul co cA cD cmul co cle wbr cC cr wcel cD cr wcel cA cr wcel cc0 cA
    cle wbr wa w3a cC cD cle wbr cA cC cmul co cA cD cmul co cle wbr cC cr wcel
    cD cr wcel cA cr wcel w3a cc0 cA cle wbr cC cD cle wbr wa wa cC cD cA
    lemul2a cC cr wcel cD cr wcel cA cr wcel w3a cc0 cA cle wbr cC cD cle wbr
    wa wa cC cr wcel cD cr wcel cA cr wcel cc0 cA cle wbr wa cC cr wcel cD cr
    wcel cA cr wcel cc0 cA cle wbr cC cD cle wbr wa 3simpl1 cC cr wcel cD cr
    wcel cA cr wcel cc0 cA cle wbr cC cD cle wbr wa 3simpl2 cC cr wcel cD cr
    wcel cA cr wcel w3a cA cr wcel cc0 cA cle wbr cC cD cle wbr wa cc0 cA cle
    wbr cC cr wcel cD cr wcel cA cr wcel 3simp3 cc0 cA cle wbr cC cD cle wbr
    pm3.26 anim12i 3jca cc0 cA cle wbr cC cD cle wbr wa cC cD cle wbr cC cr
    wcel cD cr wcel cA cr wcel w3a cc0 cA cle wbr cC cD cle wbr pm3.27 adantl
    sylanc ex 3expa ancoms cc0 cA cle wbr cA cB cle wbr pm3.26 cc0 cC cle wbr
    cC cD cle wbr pm3.27 syl2ani adantlr imp cA cr wcel cB cr wcel wa cC cr
    wcel cD cr wcel wa wa cc0 cA cle wbr cA cB cle wbr wa cc0 cC cle wbr cC cD
    cle wbr wa wa cA cD cmul co cB cD cmul co cle wbr cA cr wcel cB cr wcel wa
    cC cr wcel cD cr wcel wa wa cc0 cA cle wbr cA cB cle wbr wa cc0 cC cle wbr
    cC cD cle wbr wa wa cA cB cle wbr cc0 cD cle wbr wa cA cD cmul co cB cD
    cmul co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa cA
    cB cle wbr cC cr wcel cD cr wcel wa cc0 cC cle wbr cC cD cle wbr wa cc0 cD
    cle wbr cc0 cA cle wbr cA cB cle wbr wa cA cB cle wbr wi cA cr wcel cB cr
    wcel wa cc0 cA cle wbr cA cB cle wbr pm3.27 a1i cc0 cr wcel cC cr wcel cD
    cr wcel cc0 cC cle wbr cC cD cle wbr wa cc0 cD cle wbr wi 0re cc0 cC cD
    letr mp3an1 im2anan9 cA cr wcel cB cr wcel wa cD cr wcel cA cB cle wbr cc0
    cD cle wbr wa cA cD cmul co cB cD cmul co cle wbr wi cC cr wcel cA cr wcel
    cB cr wcel cD cr wcel cA cB cle wbr cc0 cD cle wbr wa cA cD cmul co cB cD
    cmul co cle wbr wi cA cr wcel cB cr wcel cD cr wcel w3a cc0 cD cle wbr cA
    cB cle wbr cA cD cmul co cB cD cmul co cle wbr cA cr wcel cB cr wcel cD cr
    wcel w3a cc0 cD cle wbr cA cB cle wbr wa cA cD cmul co cB cD cmul co cle
    wbr cA cr wcel cB cr wcel cD cr wcel cc0 cD cle wbr wa w3a cA cB cle wbr cA
    cD cmul co cB cD cmul co cle wbr cA cr wcel cB cr wcel cD cr wcel w3a cc0
    cD cle wbr cA cB cle wbr wa wa cA cB cD lemul1a cA cr wcel cB cr wcel cD cr
    wcel w3a cc0 cD cle wbr cA cB cle wbr wa wa cA cr wcel cB cr wcel cD cr
    wcel cc0 cD cle wbr wa cA cr wcel cB cr wcel cD cr wcel cc0 cD cle wbr cA
    cB cle wbr wa 3simpl1 cA cr wcel cB cr wcel cD cr wcel cc0 cD cle wbr cA cB
    cle wbr wa 3simpl2 cA cr wcel cB cr wcel cD cr wcel w3a cD cr wcel cc0 cD
    cle wbr cA cB cle wbr wa cc0 cD cle wbr cA cr wcel cB cr wcel cD cr wcel
    3simp3 cc0 cD cle wbr cA cB cle wbr pm3.26 anim12i 3jca cc0 cD cle wbr cA
    cB cle wbr wa cA cB cle wbr cA cr wcel cB cr wcel cD cr wcel w3a cc0 cD cle
    wbr cA cB cle wbr pm3.27 adantl sylanc ex ancomsd 3expa adantrl syld imp
    letrd an4s $.
    $( [18-Nov-2005] $) $( [13-Nov-2005] $)

  $( Comparison of product of two nonnegative numbers. $)
  lemul12a $p |- ( ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR ) /\
       ( ( C e. RR /\ 0 <_ C ) /\ D e. RR ) ) -> ( ( A <_ B /\ C <_ D ) ->
                 ( A x. C ) <_ ( B x. D ) ) ) $=
    cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cc0 cC cle wbr wa cD
    cr wcel wa wa cA cB cle wbr cC cD cle wbr wa cA cC cmul co cB cD cmul co
    cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cD cr wcel
    cc0 cD cle wbr wa wa wa cA cB cle wbr cC cD cle wbr wa cA cC cmul co cB cD
    cmul co cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cc0
    cC cle wbr wa cD cr wcel wa wa cA cB cle wbr cC cD cle wbr wa wa cA cB cC
    cD lemul12b cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cc0 cC
    cle wbr wa cD cr wcel wa wa cA cB cle wbr cC cD cle wbr wa wa cA cr wcel
    cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cD cr wcel cc0 cD cle wbr wa cA
    cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cc0 cC cle wbr wa cD cr
    wcel wa cA cB cle wbr cC cD cle wbr wa simpll cC cr wcel cc0 cC cle wbr wa
    cD cr wcel wa cC cr wcel cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cA cB
    cle wbr cC cD cle wbr wa cC cr wcel cc0 cC cle wbr cD cr wcel simpll
    ad2antlr cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cc0 cC cle
    wbr wa cD cr wcel wa wa cA cB cle wbr cC cD cle wbr wa wa cD cr wcel cc0 cD
    cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel cc0 cC cle
    wbr wa cD cr wcel cA cB cle wbr cC cD cle wbr wa simplrr cC cr wcel cc0 cC
    cle wbr wa cD cr wcel wa cC cD cle wbr cc0 cD cle wbr cA cr wcel cc0 cA cle
    wbr wa cB cr wcel wa cA cB cle wbr cC cr wcel cc0 cC cle wbr cD cr wcel cC
    cD cle wbr cc0 cD cle wbr cC cr wcel cD cr wcel cc0 cC cle wbr cC cD cle
    wbr cc0 cD cle wbr wi cC cr wcel cD cr wcel cc0 cC cle wbr cC cD cle wbr
    cc0 cD cle wbr cc0 cr wcel cC cr wcel cD cr wcel cc0 cC cle wbr cC cD cle
    wbr wa cc0 cD cle wbr wi 0re cc0 cC cD letr mp3an1 exp4b com23 imp41
    ad2ant2l jca jca32 cA cr wcel cc0 cA cle wbr wa cB cr wcel wa cC cr wcel
    cc0 cC cle wbr wa cD cr wcel wa wa cA cB cle wbr cC cD cle wbr wa pm3.27
    sylc ex $.
    $( [14-Apr-2008] $) $( [22-Feb-2008] $)

  $( The product of two numbers greater than 1 is greater than 1. $)
  mulgt1 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 1 < A /\ 1 < B ) ) ->
                1 < ( A x. B ) ) $=
    cA cr wcel cB cr wcel wa c1 cA clt wbr c1 cB clt wbr wa c1 cA cB cmul co
    clt wbr cA cr wcel cB cr wcel wa c1 cA clt wbr c1 cB clt wbr wa c1 cA clt
    wbr cA cA cB cmul co clt wbr wa c1 cA cB cmul co clt wbr cA cr wcel cB cr
    wcel wa c1 cA clt wbr c1 cB clt wbr wa c1 cA clt wbr cA cA cB cmul co clt
    wbr c1 cA clt wbr c1 cB clt wbr wa c1 cA clt wbr wi cA cr wcel cB cr wcel
    wa c1 cA clt wbr c1 cB clt wbr pm3.26 a1i cA cr wcel cB cr wcel wa c1 cA
    clt wbr c1 cB clt wbr wa cA c1 cmul co cA cB cmul co clt wbr cA cA cB cmul
    co clt wbr cA cr wcel cB cr wcel wa c1 cA clt wbr c1 cB clt wbr cA c1 cmul
    co cA cB cmul co clt wbr cA cr wcel cB cr wcel wa c1 cA clt wbr cc0 cA clt
    wbr c1 cB clt wbr cA c1 cmul co cA cB cmul co clt wbr wi cA cr wcel c1 cA
    clt wbr cc0 cA clt wbr wi cB cr wcel cA cr wcel cc0 c1 clt wbr c1 cA clt
    wbr cc0 cA clt wbr lt01 cc0 cr wcel c1 cr wcel cA cr wcel cc0 c1 clt wbr c1
    cA clt wbr wa cc0 cA clt wbr wi 0re 1re cc0 c1 cA axlttrn mp3an12 mpani
    adantr cB cr wcel cA cr wcel cc0 cA clt wbr c1 cB clt wbr cA c1 cmul co cA
    cB cmul co clt wbr wi wi c1 cr wcel cB cr wcel cA cr wcel cc0 cA clt wbr c1
    cB clt wbr cA c1 cmul co cA cB cmul co clt wbr wi wi 1re c1 cr wcel cB cr
    wcel cA cr wcel w3a cc0 cA clt wbr c1 cB clt wbr cA c1 cmul co cA cB cmul
    co clt wbr wi c1 cr wcel cB cr wcel cA cr wcel w3a cc0 cA clt wbr wa c1 cB
    clt wbr cA c1 cmul co cA cB cmul co clt wbr c1 cB cA ltmul2OLD biimpd ex
    mp3an1 ancoms syld imp3a cA cr wcel cB cr wcel wa cA c1 cmul co cA cA cB
    cmul co clt cA cr wcel cA c1 cmul co cA wceq cB cr wcel cA cr wcel cA cc
    wcel cA c1 cmul co cA wceq cA recn cA ax1id syl adantr breq1d sylibd jcad
    cA cr wcel cB cr wcel cA cB cmul co cr wcel c1 cA clt wbr cA cA cB cmul co
    clt wbr wa c1 cA cB cmul co clt wbr wi cA cB remulcl c1 cr wcel cA cr wcel
    cA cB cmul co cr wcel c1 cA clt wbr cA cA cB cmul co clt wbr wa c1 cA cB
    cmul co clt wbr wi 1re c1 cA cA cB cmul co axlttrn mp3an1 syldan syld imp
    $.
    $( [19-Apr-2005] $) $( [13-Feb-2005] $)

  $( Multiplication by a number greater than 1. $)
  ltmulgt11 $p |- ( ( A e. RR /\ B e. RR /\ 0 < A ) ->
                ( 1 < B <-> A < ( A x. B ) ) ) $=
    cA cr wcel cB cr wcel cc0 cA clt wbr w3a c1 cB clt wbr cA c1 cmul co cA cB
    cmul co clt wbr cA cA cB cmul co clt wbr cB cr wcel cA cr wcel cc0 cA clt
    wbr c1 cB clt wbr cA c1 cmul co cA cB cmul co clt wbr wb cB cr wcel cA cr
    wcel cc0 cA clt wbr c1 cB clt wbr cA c1 cmul co cA cB cmul co clt wbr wb c1
    cr wcel cB cr wcel cA cr wcel cc0 cA clt wbr c1 cB clt wbr cA c1 cmul co cA
    cB cmul co clt wbr wb 1re c1 cB cA ltmul2OLD mp3anl1 3impa 3com12 cA cr
    wcel cB cr wcel cc0 cA clt wbr w3a cA c1 cmul co cA cA cB cmul co clt cA cr
    wcel cB cr wcel cA c1 cmul co cA wceq cc0 cA clt wbr cA cr wcel cA cc wcel
    cA c1 cmul co cA wceq cA recn cA ax1id syl 3ad2ant1 breq1d bitrd $.
    $( [26-Dec-2005] $) $( [24-Dec-2005] $)

  $( Multiplication by a number greater than 1. $)
  ltmulgt12 $p |- ( ( A e. RR /\ B e. RR /\ 0 < A ) ->
                ( 1 < B <-> A < ( B x. A ) ) ) $=
    cA cr wcel cB cr wcel cc0 cA clt wbr w3a c1 cB clt wbr cA cA cB cmul co clt
    wbr cA cB cA cmul co clt wbr cA cB ltmulgt11 cA cr wcel cB cr wcel cc0 cA
    clt wbr w3a cA cB cmul co cB cA cmul co cA clt cA cr wcel cB cr wcel cA cB
    cmul co cB cA cmul co wceq cc0 cA clt wbr cA cc wcel cB cc wcel cA cB cmul
    co cB cA cmul co wceq cA cr wcel cB cr wcel cA cB mulcom cA recn cB recn
    syl2an 3adant3 breq2d bitrd $.
    $( [16-Feb-2006] $) $( [24-Dec-2005] $)

  $( Multiplication by a number greater than or equal to 1. $)
  lemulge11 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 1 <_ B ) ) ->
                A <_ ( A x. B ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr c1 cB cle wbr wa wa cA c1 cmul co
    cA cA cB cmul co cle cA cr wcel cA c1 cmul co cA wceq cB cr wcel cc0 cA cle
    wbr c1 cB cle wbr wa cA cr wcel cA cc wcel cA c1 cmul co cA wceq cA recn cA
    ax1id syl ad2antrr cA cr wcel cc0 cA cle wbr wa cA cr wcel wa c1 cr wcel
    cc0 c1 cle wbr wa cB cr wcel wa wa cA cA cle wbr c1 cB cle wbr wa cA c1
    cmul co cA cB cmul co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr c1 cB
    cle wbr wa wa cA cA c1 cB lemul12a cA cr wcel cB cr wcel wa cc0 cA cle wbr
    c1 cB cle wbr wa wa cA cr wcel cc0 cA cle wbr wa cA cr wcel c1 cr wcel cc0
    c1 cle wbr wa cB cr wcel wa cA cr wcel cB cr wcel wa cc0 cA cle wbr c1 cB
    cle wbr wa wa cA cr wcel cc0 cA cle wbr cA cr wcel cB cr wcel cc0 cA cle
    wbr c1 cB cle wbr wa simpll cA cr wcel cB cr wcel wa cc0 cA cle wbr c1 cB
    cle wbr simprl jca cA cr wcel cB cr wcel cc0 cA cle wbr c1 cB cle wbr wa
    simpll cA cr wcel cB cr wcel wa cc0 cA cle wbr c1 cB cle wbr wa wa cB cr
    wcel c1 cr wcel cc0 c1 cle wbr wa cA cr wcel cB cr wcel cc0 cA cle wbr c1
    cB cle wbr wa simplr c1 cr wcel cc0 c1 cle wbr 1re cc0 c1 0re 1re lt01
    ltleii pm3.2i jctil jca31 cA cr wcel cB cr wcel wa cc0 cA cle wbr c1 cB cle
    wbr wa wa cA cA cle wbr c1 cB cle wbr cA cr wcel cA cA cle wbr cB cr wcel
    cc0 cA cle wbr c1 cB cle wbr wa cA leid ad2antrr cA cr wcel cB cr wcel wa
    cc0 cA cle wbr c1 cB cle wbr simprr jca sylc eqbrtrrd $.
    $( [18-Dec-2005] $) $( [17-Dec-2005] $)

  $( Division of both sides of 'less than' by a positive number. $)
  ltdiv1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
               ( A < B <-> ( A / C ) < ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cB clt wbr cA cC cdiv
    co cB cC cdiv co clt wbr wb cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr
    cA cB clt wbr cA cC cdiv co cB cC cdiv co clt wbr wb cA cr wcel cB cr wcel
    cC cr wcel cc0 cC clt wbr cA cB clt wbr cA cC cdiv co cB cC cdiv co clt wbr
    wb wi cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cA cB clt wbr cA cC
    cdiv co cB cC cdiv co clt wbr wb wi cc0 cC clt wbr cA cr wcel cA cc0 cif cB
    clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cC cdiv co clt wbr wb wi cA cB
    cC cc0 cc0 cc0 cc0 cC clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cr wcel cB cc0 cif cC cdiv co
    clt wbr wb wi cc0 cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cdiv co
    cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cdiv co clt wbr wb wi cA cA cr
    wcel cA cc0 cif wceq cA cB clt wbr cA cC cdiv co cB cC cdiv co clt wbr wb
    cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cC
    cdiv co clt wbr wb cc0 cC clt wbr cA cA cr wcel cA cc0 cif wceq cA cB clt
    wbr cA cr wcel cA cc0 cif cB clt wbr cA cC cdiv co cB cC cdiv co clt wbr cA
    cr wcel cA cc0 cif cC cdiv co cB cC cdiv co clt wbr cA cA cr wcel cA cc0
    cif cB clt breq1 cA cA cr wcel cA cc0 cif wceq cA cC cdiv co cA cr wcel cA
    cc0 cif cC cdiv co cB cC cdiv co clt cA cA cr wcel cA cc0 cif cC cdiv
    opreq1 breq1d bibi12d imbi2d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA
    cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cC cdiv co clt wbr
    wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0
    cif cC cdiv co cB cr wcel cB cc0 cif cC cdiv co clt wbr wb cc0 cC clt wbr
    cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC cdiv co
    cB cC cdiv co clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cr wcel cB cc0
    cif cC cdiv co clt wbr cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif clt
    breq2 cB cB cr wcel cB cc0 cif wceq cB cC cdiv co cB cr wcel cB cc0 cif cC
    cdiv co cA cr wcel cA cc0 cif cC cdiv co clt cB cB cr wcel cB cc0 cif cC
    cdiv opreq1 breq2d bibi12d imbi2d cC cC cr wcel cC cc0 cif wceq cc0 cC clt
    wbr cc0 cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cr wcel cB cc0 cif cC
    cdiv co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA
    cr wcel cA cc0 cif cC cr wcel cC cc0 cif cdiv co cB cr wcel cB cc0 cif cC
    cr wcel cC cc0 cif cdiv co clt wbr wb cC cC cr wcel cC cc0 cif cc0 clt
    breq2 cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cdiv co cB cr
    wcel cB cc0 cif cC cdiv co clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0
    cif cdiv co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cdiv co clt wbr cA
    cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cC cC cr wcel cC cc0 cif
    wceq cA cr wcel cA cc0 cif cC cdiv co cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif cdiv co cB cr wcel cB cc0 cif cC cdiv co cB cr wcel cB cc0 cif cC
    cr wcel cC cc0 cif cdiv co clt cC cC cr wcel cC cc0 cif cA cr wcel cA cc0
    cif cdiv opreq2 cC cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif cdiv opreq2
    breq12d bibi2d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr
    wcel cC cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re
    elimel ltdiv1i dedth3h 3exp imp4a 3imp $.
    $( [14-Aug-2008] $) $( [10-Oct-2004] $)

  $( Division of both sides of 'less than' by a positive number. $)
  ltdiv1OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < C ) ->
               ( A < B <-> ( A / C ) < ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr cA cB clt wbr cA cC
    cdiv co cB cC cdiv co clt wbr wb cA cr wcel cB cr wcel cC cr wcel cc0 cC
    clt wbr cA cB clt wbr cA cC cdiv co cB cC cdiv co clt wbr wb wi cc0 cC clt
    wbr cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cC
    cdiv co clt wbr wb wi cA cB cC cc0 cc0 cc0 cc0 cC clt wbr cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cr
    wcel cB cc0 cif cC cdiv co clt wbr wb wi cc0 cC cr wcel cC cc0 cif clt wbr
    cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif
    cC cr wcel cC cc0 cif cdiv co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif
    cdiv co clt wbr wb wi cA cA cr wcel cA cc0 cif wceq cA cB clt wbr cA cC
    cdiv co cB cC cdiv co clt wbr wb cA cr wcel cA cc0 cif cB clt wbr cA cr
    wcel cA cc0 cif cC cdiv co cB cC cdiv co clt wbr wb cc0 cC clt wbr cA cA cr
    wcel cA cc0 cif wceq cA cB clt wbr cA cr wcel cA cc0 cif cB clt wbr cA cC
    cdiv co cB cC cdiv co clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cC cdiv
    co clt wbr cA cA cr wcel cA cc0 cif cB clt breq1 cA cA cr wcel cA cc0 cif
    wceq cA cC cdiv co cA cr wcel cA cc0 cif cC cdiv co cB cC cdiv co clt cA cA
    cr wcel cA cc0 cif cC cdiv opreq1 breq1d bibi12d imbi2d cB cB cr wcel cB
    cc0 cif wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cC cdiv
    co cB cC cdiv co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt
    wbr cA cr wcel cA cc0 cif cC cdiv co cB cr wcel cB cc0 cif cC cdiv co clt
    wbr wb cc0 cC clt wbr cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif
    cB clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel
    cA cc0 cif cC cdiv co cB cC cdiv co clt wbr cA cr wcel cA cc0 cif cC cdiv
    co cB cr wcel cB cc0 cif cC cdiv co clt wbr cB cB cr wcel cB cc0 cif cA cr
    wcel cA cc0 cif clt breq2 cB cB cr wcel cB cc0 cif wceq cB cC cdiv co cB cr
    wcel cB cc0 cif cC cdiv co cA cr wcel cA cc0 cif cC cdiv co clt cB cB cr
    wcel cB cc0 cif cC cdiv opreq1 breq2d bibi12d imbi2d cC cC cr wcel cC cc0
    cif wceq cc0 cC clt wbr cc0 cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cC cdiv co cB cr
    wcel cB cc0 cif cC cdiv co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cdiv co cB cr
    wcel cB cc0 cif cC cr wcel cC cc0 cif cdiv co clt wbr wb cC cC cr wcel cC
    cc0 cif cc0 clt breq2 cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif
    cC cdiv co cB cr wcel cB cc0 cif cC cdiv co clt wbr cA cr wcel cA cc0 cif
    cC cr wcel cC cc0 cif cdiv co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif
    cdiv co clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cC cC
    cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cdiv co cA cr wcel cA cc0
    cif cC cr wcel cC cc0 cif cdiv co cB cr wcel cB cc0 cif cC cdiv co cB cr
    wcel cB cc0 cif cC cr wcel cC cc0 cif cdiv co clt cC cC cr wcel cC cc0 cif
    cA cr wcel cA cc0 cif cdiv opreq2 cC cC cr wcel cC cc0 cif cB cr wcel cB
    cc0 cif cdiv opreq2 breq12d bibi2d imbi12d cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif cC cr wcel cC cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel
    cC cc0 cr 0re elimel ltdiv1i dedth3h imp $.
    $( [26-Feb-2005] $) $( [10-Oct-2004] $)

  $( Division of both sides of a less than or equal to relation by a positive
     number. $)
  lediv1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
               ( A <_ B <-> ( A / C ) <_ ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cB cA clt wbr wn cB
    cC cdiv co cA cC cdiv co clt wbr wn cA cB cle wbr cA cC cdiv co cB cC cdiv
    co cle wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cB cA clt
    wbr cB cC cdiv co cA cC cdiv co clt wbr cB cr wcel cA cr wcel cC cr wcel
    cc0 cC clt wbr wa cB cA clt wbr cB cC cdiv co cA cC cdiv co clt wbr wb cB
    cA cC ltdiv1 3com12 notbid cA cr wcel cB cr wcel cA cB cle wbr cB cA clt
    wbr wn wb cC cr wcel cc0 cC clt wbr wa cA cB lenlt 3adant3 cA cC cdiv co cr
    wcel cB cC cdiv co cr wcel cA cC cdiv co cB cC cdiv co cle wbr cB cC cdiv
    co cA cC cdiv co clt wbr wn wb cA cr wcel cB cr wcel cC cr wcel cc0 cC clt
    wbr wa w3a cA cC cdiv co cB cC cdiv co lenlt cA cr wcel cC cr wcel cc0 cC
    clt wbr wa cA cC cdiv co cr wcel cB cr wcel cA cr wcel cC cr wcel cc0 cC
    clt wbr cA cC cdiv co cr wcel cA cr wcel cC cr wcel cC cc0 wne cA cC cdiv
    co cr wcel cc0 cC clt wbr cA cC redivcl cC cr wcel cc0 cC clt wbr cC cc0
    wne cA cr wcel cC gt0ne0 3adant1 syld3an3 3expb 3adant2 cB cr wcel cC cr
    wcel cc0 cC clt wbr wa cB cC cdiv co cr wcel cA cr wcel cB cr wcel cC cr
    wcel cc0 cC clt wbr cB cC cdiv co cr wcel cB cr wcel cC cr wcel cC cc0 wne
    cB cC cdiv co cr wcel cc0 cC clt wbr cB cC redivcl cC cr wcel cc0 cC clt
    wbr cC cc0 wne cB cr wcel cC gt0ne0 3adant1 syld3an3 3expb 3adant1 sylanc
    3bitr4d $.
    $( [15-Aug-2008] $) $( [18-Nov-2004] $)

  $( Division of both sides of a less than or equal to relation by a positive
     number. $)
  lediv1OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < C ) ->
               ( A <_ B <-> ( A / C ) <_ ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa cB cA clt wbr wn cB
    cC cdiv co cA cC cdiv co clt wbr wn cA cB cle wbr cA cC cdiv co cB cC cdiv
    co cle wbr cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr wa cB cA clt
    wbr cB cC cdiv co cA cC cdiv co clt wbr cA cr wcel cB cr wcel cC cr wcel
    w3a cc0 cC clt wbr cB cA clt wbr cB cC cdiv co cA cC cdiv co clt wbr wb cB
    cr wcel cA cr wcel cC cr wcel cc0 cC clt wbr cB cA clt wbr cB cC cdiv co cA
    cC cdiv co clt wbr wb wi cB cr wcel cA cr wcel cC cr wcel w3a cc0 cC clt
    wbr cB cA clt wbr cB cC cdiv co cA cC cdiv co clt wbr wb cB cr wcel cA cr
    wcel cC cr wcel cc0 cC clt wbr wa cB cA clt wbr cB cC cdiv co cA cC cdiv co
    clt wbr wb cB cr wcel cA cr wcel cC cr wcel w3a cc0 cC clt wbr wa cB cA cC
    ltdiv1 cB cr wcel cA cr wcel cC cr wcel cc0 cC clt wbr 3simpl1 cB cr wcel
    cA cr wcel cC cr wcel cc0 cC clt wbr 3simpl2 cB cr wcel cA cr wcel cC cr
    wcel w3a cC cr wcel cc0 cC clt wbr cc0 cC clt wbr cB cr wcel cA cr wcel cC
    cr wcel 3simp3 cc0 cC clt wbr id anim12i syl3anc ex 3com12 imp notbid cA cr
    wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cA clt wbr wn wb cc0 cC clt
    wbr cA cr wcel cB cr wcel cA cB cle wbr cB cA clt wbr wn wb cC cr wcel cA
    cB lenlt 3adant3 adantr cA cr wcel cB cr wcel cC cr wcel w3a cc0 cC clt wbr
    wa cA cC cdiv co cr wcel cB cC cdiv co cr wcel wa cA cC cdiv co cB cC cdiv
    co cle wbr cB cC cdiv co cA cC cdiv co clt wbr wn wb cA cr wcel cB cr wcel
    cC cr wcel w3a cc0 cC clt wbr cC cc0 wne cA cC cdiv co cr wcel cB cC cdiv
    co cr wcel wa cC cr wcel cA cr wcel cc0 cC clt wbr cC cc0 wne cB cr wcel cC
    gt0ne0 3ad2antl3 cA cr wcel cB cr wcel cC cr wcel w3a cC cc0 wne wa cA cC
    cdiv co cr wcel cB cC cdiv co cr wcel cA cr wcel cC cr wcel cC cc0 wne cA
    cC cdiv co cr wcel cB cr wcel cA cr wcel cC cr wcel cC cc0 wne cA cC cdiv
    co cr wcel cA cC redivcl 3expa 3adantl2 cB cr wcel cC cr wcel cC cc0 wne cB
    cC cdiv co cr wcel cA cr wcel cB cr wcel cC cr wcel cC cc0 wne cB cC cdiv
    co cr wcel cB cC redivcl 3expa 3adantl1 jca syldan cA cC cdiv co cB cC cdiv
    co lenlt syl 3bitr4d $.
    $( [18-Mar-2005] $) $( [18-Nov-2004] $)

  $( Division of a positive number by a positive number. $)
  gt0div $p |- ( ( A e. RR /\ B e. RR /\ 0 < B ) ->
               ( 0 < A <-> 0 < ( A / B ) ) ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr w3a cc0 cA clt wbr cc0 cB cdiv co cA
    cB cdiv co clt wbr cc0 cA cB cdiv co clt wbr cA cr wcel cB cr wcel cc0 cB
    clt wbr cc0 cA clt wbr cc0 cB cdiv co cA cB cdiv co clt wbr wb cc0 cr wcel
    cA cr wcel cB cr wcel cc0 cB clt wbr cc0 cA clt wbr cc0 cB cdiv co cA cB
    cdiv co clt wbr wb 0re cc0 cA cB ltdiv1OLD mp3anl1 3impa cB cr wcel cc0 cB
    clt wbr cc0 cB cdiv co cA cB cdiv co clt wbr cc0 cA cB cdiv co clt wbr wb
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cc0 cB cdiv co cc0 cA cB cdiv co
    clt cB cr wcel cc0 cB clt wbr cB cc0 wne cc0 cB cdiv co cc0 wceq cB gt0ne0
    cB cc wcel cB cc0 wne cc0 cB cdiv co cc0 wceq cB cr wcel cB div0 cB recn
    sylan syldan breq1d 3adant1 bitrd $.
    $( [30-Sep-2005] $) $( [28-Sep-2005] $)

  $( Division of a nonnegative number by a positive number. $)
  ge0div $p |- ( ( A e. RR /\ B e. RR /\ 0 < B ) ->
               ( 0 <_ A <-> 0 <_ ( A / B ) ) ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr w3a cc0 cA cle wbr cc0 cB cdiv co cA
    cB cdiv co cle wbr cc0 cA cB cdiv co cle wbr cA cr wcel cB cr wcel cc0 cB
    clt wbr cc0 cA cle wbr cc0 cB cdiv co cA cB cdiv co cle wbr wb cc0 cr wcel
    cA cr wcel cB cr wcel cc0 cB clt wbr cc0 cA cle wbr cc0 cB cdiv co cA cB
    cdiv co cle wbr wb 0re cc0 cA cB lediv1OLD mp3anl1 3impa cB cr wcel cc0 cB
    clt wbr cc0 cB cdiv co cA cB cdiv co cle wbr cc0 cA cB cdiv co cle wbr wb
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cc0 cB cdiv co cc0 cA cB cdiv co
    cle cB cr wcel cc0 cB clt wbr cB cc0 wne cc0 cB cdiv co cc0 wceq cB gt0ne0
    cB cc wcel cB cc0 wne cc0 cB cdiv co cc0 wceq cB cr wcel cB div0 cB recn
    sylan syldan breq1d 3adant1 bitrd $.
    $( [10-Nov-2005] $) $( [28-Sep-2005] $)

  $( The ratio of two positive numbers is positive. $)
  divgt0 $p |- ( ( ( A e. RR /\ 0 < A ) /\
             ( B e. RR /\ 0 < B ) ) -> 0 < ( A / B ) ) $=
    cA cr wcel cc0 cA clt wbr cB cr wcel cc0 cB clt wbr cc0 cA cB cdiv co clt
    wbr cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB cdiv co
    clt wbr wi cA cr wcel cB cr wcel cc0 cB clt wbr cc0 cA clt wbr cc0 cA cB
    cdiv co clt wbr cA cr wcel cB cr wcel cc0 cB clt wbr cc0 cA clt wbr cc0 cA
    cB cdiv co clt wbr wi cA cr wcel cB cr wcel cc0 cB clt wbr w3a cc0 cA clt
    wbr cc0 cA cB cdiv co clt wbr cA cB gt0div biimpd 3exp com34 com23 imp43 $.
    $( [11-Aug-2007] $) $( [12-Oct-1999] $)

  $( The ratio of nonnegative and positive numbers is nonnegative. $)
  divge0 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\
             ( B e. RR /\ 0 < B ) ) -> 0 <_ ( A / B ) ) $=
    cA cr wcel cc0 cA cle wbr cB cr wcel cc0 cB clt wbr cc0 cA cB cdiv co cle
    wbr cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB clt wbr cc0 cA cB cdiv co
    cle wbr wi cA cr wcel cB cr wcel cc0 cB clt wbr cc0 cA cle wbr cc0 cA cB
    cdiv co cle wbr cA cr wcel cB cr wcel cc0 cB clt wbr cc0 cA cle wbr cc0 cA
    cB cdiv co cle wbr wi cA cr wcel cB cr wcel cc0 cB clt wbr w3a cc0 cA cle
    wbr cc0 cA cB cdiv co cle wbr cA cB ge0div biimpd 3exp com34 com23 imp43 $.
    $( [15-Aug-2007] $) $( [27-Sep-1999] $)

  ${
    divgt0.1 $e |- A e. RR $.
    divgt0.2 $e |- B e. RR $.
    $( The ratio of two positive numbers is positive. $)
    divgt0i $p |- ( ( 0 < A /\ 0 < B ) -> 0 < ( A / B ) ) $=
      cA cr wcel cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB cdiv co clt wbr
      divgt0.1 cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr cc0 cA cB
      cdiv co clt wbr divgt0.2 cA cB divgt0 mpanr1 mpanl1 $.
      $( [16-May-1999] $)

    $( The ratio of nonnegative and positive numbers is nonnegative. $)
    divge0i $p |- ( ( 0 <_ A /\ 0 < B ) -> 0 <_ ( A / B ) ) $=
      cA cr wcel cc0 cA cle wbr cc0 cB clt wbr cc0 cA cB cdiv co cle wbr
      divgt0.1 cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr cc0 cA cB
      cdiv co cle wbr divgt0.2 cA cB divge0 mpanr1 mpanl1 $.
      $( [12-Aug-1999] $)

    ${
      divgt0i2.3 $e |- 0 < B $.
      $( The ratio of two positive numbers is positive. $)
      divgt0i2i $p |- ( 0 < A -> 0 < ( A / B ) ) $=
        cc0 cA clt wbr cc0 cB clt wbr cc0 cA cB cdiv co clt wbr divgt0i2.3 cA
        cB divgt0.1 divgt0.2 divgt0i mpan2 $.
        $( [16-May-1999] $)
    $}

    ${
      divgt0i.3 $e |- 0 < A $.
      divgt0i.4 $e |- 0 < B $.
      $( The ratio of two positive numbers is positive. $)
      divgt0ii $p |- 0 < ( A / B ) $=
        cc0 cA clt wbr cc0 cA cB cdiv co clt wbr divgt0i.3 cA cB divgt0.1
        divgt0.2 divgt0i.4 divgt0i2i ax-mp $.
        $( [18-May-1999] $)
    $}
  $}

  $( The reciprocal of a positive number is positive.  Exercise 4 of [Apostol]
     p. 21. $)
  recgt0 $p |- ( ( A e. RR /\ 0 < A ) -> 0 < ( 1 / A ) ) $=
    c1 cr wcel cc0 c1 clt wbr cA cr wcel cc0 cA clt wbr wa cc0 c1 cA cdiv co
    clt wbr 1re lt01 c1 cA divgt0 mpanl12 $.
    $( [25-Feb-2005] $) $( [25-Aug-1999] $)

  ${
    recgt0.1 $e |- A e. RR $.
    $( The reciprocal of a positive number is positive.  Exercise 4 of
       [Apostol] p. 21. $)
    recgt0i $p |- ( 0 < A -> 0 < ( 1 / A ) ) $=
      cA cr wcel cc0 cA clt wbr cc0 c1 cA cdiv co clt wbr recgt0.1 cA recgt0
      mpan $.
      $( [15-May-1999] $)
  $}

  $( 'Less than' relationship between division and multiplication. $)
  ltmuldiv $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                -> ( ( A x. C ) < B <-> A < ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa cA cC cmul co cB clt wbr
    cA cB cC cdiv co clt wbr wb cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr
    cA cC cmul co cB clt wbr cA cB cC cdiv co clt wbr wb cA cr wcel cB cr wcel
    cC cr wcel cc0 cC clt wbr cA cC cmul co cB clt wbr cA cB cC cdiv co clt wbr
    wb wi cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cA cC cmul co cB clt
    wbr cA cB cC cdiv co clt wbr wb wi cc0 cC clt wbr cA cr wcel cA cc0 cif cC
    cmul co cB clt wbr cA cr wcel cA cc0 cif cB cC cdiv co clt wbr wb wi cA cB
    cC cc0 cc0 cc0 cc0 cC clt wbr cA cr wcel cA cc0 cif cC cmul co cB cr wcel
    cB cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cdiv co
    clt wbr wb wi cc0 cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr
    wcel cC cc0 cif cmul co cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cdiv co clt wbr wb wi cA cA cr
    wcel cA cc0 cif wceq cA cC cmul co cB clt wbr cA cB cC cdiv co clt wbr wb
    cA cr wcel cA cc0 cif cC cmul co cB clt wbr cA cr wcel cA cc0 cif cB cC
    cdiv co clt wbr wb cc0 cC clt wbr cA cA cr wcel cA cc0 cif wceq cA cC cmul
    co cB clt wbr cA cr wcel cA cc0 cif cC cmul co cB clt wbr cA cB cC cdiv co
    clt wbr cA cr wcel cA cc0 cif cB cC cdiv co clt wbr cA cA cr wcel cA cc0
    cif wceq cA cC cmul co cA cr wcel cA cc0 cif cC cmul co cB clt cA cA cr
    wcel cA cc0 cif cC cmul opreq1 breq1d cA cA cr wcel cA cc0 cif cB cC cdiv
    co clt breq1 bibi12d imbi2d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0
    cif cC cmul co cB clt wbr cA cr wcel cA cc0 cif cB cC cdiv co clt wbr wb cA
    cr wcel cA cc0 cif cC cmul co cB cr wcel cB cc0 cif clt wbr cA cr wcel cA
    cc0 cif cB cr wcel cB cc0 cif cC cdiv co clt wbr wb cc0 cC clt wbr cB cB cr
    wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cC cmul co cB clt wbr cA cr wcel
    cA cc0 cif cC cmul co cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif
    cB cC cdiv co clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cdiv
    co clt wbr cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cC cmul co clt
    breq2 cB cB cr wcel cB cc0 cif wceq cB cC cdiv co cB cr wcel cB cc0 cif cC
    cdiv co cA cr wcel cA cc0 cif clt cB cB cr wcel cB cc0 cif cC cdiv opreq1
    breq2d bibi12d imbi2d cC cC cr wcel cC cc0 cif wceq cc0 cC clt wbr cc0 cC
    cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cC cmul co cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cdiv co clt
    wbr wb cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cmul co cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC
    cc0 cif cdiv co clt wbr wb cC cC cr wcel cC cc0 cif cc0 clt breq2 cC cC cr
    wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cmul co cB cr wcel cB cc0 cif
    clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cmul co cB cr wcel cB
    cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cdiv co clt
    wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cdiv
    co clt wbr cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif cC cmul co
    cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cmul co cB cr wcel cB cc0 cif
    clt cC cC cr wcel cC cc0 cif cA cr wcel cA cc0 cif cmul opreq2 breq1d cC cC
    cr wcel cC cc0 cif wceq cB cr wcel cB cc0 cif cC cdiv co cB cr wcel cB cc0
    cif cC cr wcel cC cc0 cif cdiv co cA cr wcel cA cc0 cif clt cC cC cr wcel
    cC cc0 cif cB cr wcel cB cc0 cif cdiv opreq2 breq2d bibi12d imbi12d cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel cC cc0 cr 0re elimel ltmuldivi dedth3h 3exp
    imp4a 3imp $.
    $( [16-Aug-2008] $) $( [12-Oct-1999] $)

  $( 'Less than' relationship between division and multiplication. $)
  ltmuldivOLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < B ) ->
                  ( ( A x. B ) < C <-> A < ( C / B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr cA cB cmul co cC clt
    wbr cA cC cB cdiv co clt wbr wb cA cr wcel cB cr wcel cC cr wcel cc0 cB clt
    wbr cA cB cmul co cC clt wbr cA cC cB cdiv co clt wbr wb wi cc0 cB clt wbr
    cA cr wcel cA cc0 cif cB cmul co cC clt wbr cA cr wcel cA cc0 cif cC cB
    cdiv co clt wbr wb wi cA cB cC cc0 cc0 cc0 cc0 cB cr wcel cB cc0 cif clt
    wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cC clt wbr cA cr
    wcel cA cc0 cif cC cB cr wcel cB cc0 cif cdiv co clt wbr wb wi cc0 cB cr
    wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co
    cC cr wcel cC cc0 cif clt wbr cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif
    cB cr wcel cB cc0 cif cdiv co clt wbr wb wi cA cA cr wcel cA cc0 cif wceq
    cA cB cmul co cC clt wbr cA cC cB cdiv co clt wbr wb cA cr wcel cA cc0 cif
    cB cmul co cC clt wbr cA cr wcel cA cc0 cif cC cB cdiv co clt wbr wb cc0 cB
    clt wbr cA cA cr wcel cA cc0 cif wceq cA cB cmul co cC clt wbr cA cr wcel
    cA cc0 cif cB cmul co cC clt wbr cA cC cB cdiv co clt wbr cA cr wcel cA cc0
    cif cC cB cdiv co clt wbr cA cA cr wcel cA cc0 cif wceq cA cB cmul co cA cr
    wcel cA cc0 cif cB cmul co cC clt cA cA cr wcel cA cc0 cif cB cmul opreq1
    breq1d cA cA cr wcel cA cc0 cif cC cB cdiv co clt breq1 bibi12d imbi2d cB
    cB cr wcel cB cc0 cif wceq cc0 cB clt wbr cc0 cB cr wcel cB cc0 cif clt wbr
    cA cr wcel cA cc0 cif cB cmul co cC clt wbr cA cr wcel cA cc0 cif cC cB
    cdiv co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cC
    clt wbr cA cr wcel cA cc0 cif cC cB cr wcel cB cc0 cif cdiv co clt wbr wb
    cB cB cr wcel cB cc0 cif cc0 clt breq2 cB cB cr wcel cB cc0 cif wceq cA cr
    wcel cA cc0 cif cB cmul co cC clt wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cmul co cC clt wbr cA cr wcel cA cc0 cif cC cB cdiv co clt wbr cA
    cr wcel cA cc0 cif cC cB cr wcel cB cc0 cif cdiv co clt wbr cB cB cr wcel
    cB cc0 cif wceq cA cr wcel cA cc0 cif cB cmul co cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cmul co cC clt cB cB cr wcel cB cc0 cif cA cr wcel cA
    cc0 cif cmul opreq2 breq1d cB cB cr wcel cB cc0 cif wceq cC cB cdiv co cC
    cB cr wcel cB cc0 cif cdiv co cA cr wcel cA cc0 cif clt cB cB cr wcel cB
    cc0 cif cC cdiv opreq2 breq2d bibi12d imbi12d cC cC cr wcel cC cc0 cif wceq
    cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co cC clt wbr cA cr wcel
    cA cc0 cif cC cB cr wcel cB cc0 cif cdiv co clt wbr wb cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif cmul co cC cr wcel cC cc0 cif clt wbr cA cr wcel
    cA cc0 cif cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif cdiv co clt wbr wb
    cc0 cB cr wcel cB cc0 cif clt wbr cC cC cr wcel cC cc0 cif wceq cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif cmul co cC clt wbr cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cmul co cC cr wcel cC cc0 cif clt wbr cA cr wcel cA
    cc0 cif cC cB cr wcel cB cc0 cif cdiv co clt wbr cA cr wcel cA cc0 cif cC
    cr wcel cC cc0 cif cB cr wcel cB cc0 cif cdiv co clt wbr cC cC cr wcel cC
    cc0 cif cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cmul co clt breq2 cC cC
    cr wcel cC cc0 cif wceq cC cB cr wcel cB cc0 cif cdiv co cC cr wcel cC cc0
    cif cB cr wcel cB cc0 cif cdiv co cA cr wcel cA cc0 cif clt cC cC cr wcel
    cC cc0 cif cB cr wcel cB cc0 cif cdiv opreq1 breq2d bibi12d imbi2d cA cr
    wcel cA cc0 cif cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re
    elimel cC cc0 cr 0re elimel cB cc0 cr 0re elimel ltmuldivi dedth3h imp $.
    $( [26-Feb-2005] $) $( [12-Oct-1999] $)

  $( 'Less than' relationship between division and multiplication. $)
  ltmuldiv2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                   -> ( ( C x. A ) < B <-> A < ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cmul co cB clt
    wbr cC cA cmul co cB clt wbr cA cB cC cdiv co clt wbr cA cr wcel cB cr wcel
    cC cr wcel cc0 cC clt wbr wa w3a cA cC cmul co cC cA cmul co cB clt cA cr
    wcel cC cr wcel cc0 cC clt wbr wa cA cC cmul co cC cA cmul co wceq cB cr
    wcel cA cr wcel cC cr wcel cA cC cmul co cC cA cmul co wceq cc0 cC clt wbr
    cA cc wcel cC cc wcel cA cC cmul co cC cA cmul co wceq cA cr wcel cC cr
    wcel cA cC mulcom cA recn cC recn syl2an adantrr 3adant2 breq1d cA cB cC
    ltmuldiv bitr3d $.
    $( [17-Aug-2008] $) $( [18-Nov-2004] $)

  $( 'Less than' relationship between division and multiplication. $)
  ltmuldiv2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < A ) ->
                      ( ( A x. B ) < C <-> B < ( C / A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cA clt wbr cA cB cmul co cC clt
    wbr cB cC cA cdiv co clt wbr wb cB cr wcel cA cr wcel cC cr wcel cc0 cA clt
    wbr cA cB cmul co cC clt wbr cB cC cA cdiv co clt wbr wb wi cB cr wcel cA
    cr wcel cC cr wcel w3a cc0 cA clt wbr cA cB cmul co cC clt wbr cB cC cA
    cdiv co clt wbr wb cB cr wcel cA cr wcel cC cr wcel w3a cc0 cA clt wbr wa
    cB cA cmul co cC clt wbr cA cB cmul co cC clt wbr cB cC cA cdiv co clt wbr
    cB cr wcel cA cr wcel cC cr wcel w3a cc0 cA clt wbr wa cB cA cmul co cA cB
    cmul co cC clt cB cr wcel cA cr wcel cC cr wcel w3a cB cA cmul co cA cB
    cmul co wceq cc0 cA clt wbr cB cr wcel cA cr wcel cB cA cmul co cA cB cmul
    co wceq cC cr wcel cB cc wcel cA cc wcel cB cA cmul co cA cB cmul co wceq
    cB cr wcel cA cr wcel cB cA mulcom cB recn cA recn syl2an 3adant3 adantr
    breq1d cB cr wcel cC cr wcel cA cr wcel cc0 cA clt wbr wa cB cA cmul co cC
    clt wbr cB cC cA cdiv co clt wbr wb cB cr wcel cA cr wcel cC cr wcel w3a
    cc0 cA clt wbr wa cB cC cA ltmuldiv cB cr wcel cA cr wcel cC cr wcel cc0 cA
    clt wbr 3simpl1 cB cr wcel cA cr wcel cC cr wcel cc0 cA clt wbr 3simpl3 cB
    cr wcel cA cr wcel cC cr wcel w3a cA cr wcel cc0 cA clt wbr cc0 cA clt wbr
    cB cr wcel cA cr wcel cC cr wcel 3simp2 cc0 cA clt wbr id anim12i syl3anc
    bitr3d ex 3com12 imp $.
    $( [26-Feb-2005] $) $( [18-Nov-2004] $)

  $( 'Less than' relationship between division and multiplication. $)
  ltdivmul $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
              -> ( ( A / C ) < B <-> A < ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cB cmul co clt
    wbr cA cC cdiv co cC cB cmul co cC cdiv co clt wbr cA cC cdiv co cB clt wbr
    cA cr wcel cC cB cmul co cr wcel cC cr wcel cc0 cC clt wbr wa cA cC cB cmul
    co clt wbr cA cC cdiv co cC cB cmul co cC cdiv co clt wbr wb cB cr wcel cA
    cC cB cmul co cC ltdiv1 cB cr wcel cC cr wcel cc0 cC clt wbr wa cC cB cmul
    co cr wcel cA cr wcel cB cr wcel cC cr wcel cC cB cmul co cr wcel cc0 cC
    clt wbr cC cr wcel cB cr wcel cC cB cmul co cr wcel cC cB remulcl ancoms
    adantrr 3adant1 syld3an2 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa
    w3a cC cB cmul co cC cdiv co cB cA cC cdiv co clt cB cr wcel cC cr wcel cc0
    cC clt wbr wa cC cB cmul co cC cdiv co cB wceq cA cr wcel cB cc wcel cC cc
    wcel cC cc0 wne cC cB cmul co cC cdiv co cB wceq cB cr wcel cC cr wcel cc0
    cC clt wbr wa wa cB cC divcan3 cB cr wcel cB cc wcel cC cr wcel cc0 cC clt
    wbr wa cB recn adantr cC cr wcel cC cc wcel cB cr wcel cc0 cC clt wbr cC
    recn ad2antrl cC cr wcel cc0 cC clt wbr wa cC cc0 wne cB cr wcel cC gt0ne0
    adantl syl3anc 3adant1 breq2d bitr2d $.
    $( [17-Aug-2008] $) $( [18-Nov-2004] $)

  $( 'Less than' relationship between division and multiplication. $)
  ltdivmulOLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < B ) ->
                  ( ( A / B ) < C <-> A < ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr wa cA cB cC cmul co clt
    wbr cA cB cdiv co cB cC cmul co cB cdiv co clt wbr cA cB cdiv co cC clt wbr
    cA cr wcel cB cC cmul co cr wcel cB cr wcel w3a cc0 cB clt wbr cA cB cC
    cmul co clt wbr cA cB cdiv co cB cC cmul co cB cdiv co clt wbr wb cA cr
    wcel cB cr wcel cC cr wcel w3a cA cr wcel cB cC cmul co cr wcel cB cr wcel
    cc0 cB clt wbr wa cA cB cC cmul co clt wbr cA cB cdiv co cB cC cmul co cB
    cdiv co clt wbr wb cA cr wcel cB cC cmul co cr wcel cB cr wcel w3a cc0 cB
    clt wbr wa cA cB cC cmul co cB ltdiv1 cA cr wcel cB cC cmul co cr wcel cB
    cr wcel cc0 cB clt wbr 3simpl1 cA cr wcel cB cC cmul co cr wcel cB cr wcel
    cc0 cB clt wbr 3simpl2 cA cr wcel cB cC cmul co cr wcel cB cr wcel w3a cB
    cr wcel cc0 cB clt wbr cc0 cB clt wbr cA cr wcel cB cC cmul co cr wcel cB
    cr wcel 3simp3 cc0 cB clt wbr id anim12i syl3anc cA cr wcel cB cr wcel cC
    cr wcel w3a cA cr wcel cB cC cmul co cr wcel cB cr wcel cA cr wcel cB cr
    wcel cC cr wcel 3simp1 cB cr wcel cC cr wcel cB cC cmul co cr wcel cA cr
    wcel cB cC remulcl 3adant1 cA cr wcel cB cr wcel cC cr wcel 3simp2 3jca
    sylan cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr wa cB cC cmul co
    cB cdiv co cC cA cB cdiv co clt cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB
    clt wbr cB cC cmul co cB cdiv co cC wceq cB cr wcel cC cr wcel cc0 cB clt
    wbr cB cC cmul co cB cdiv co cC wceq wi cA cr wcel cB cr wcel cC cr wcel wa
    cc0 cB clt wbr cB cc0 wne cB cC cmul co cB cdiv co cC wceq cB cr wcel cc0
    cB clt wbr cB cc0 wne wi cC cr wcel cB cr wcel cc0 cB clt wbr cB cc0 wne cB
    gt0ne0 ex adantr cB cc wcel cC cc wcel cB cc0 wne cB cC cmul co cB cdiv co
    cC wceq wi cB cr wcel cC cr wcel cB cc wcel cC cc wcel cB cc0 wne cB cC
    cmul co cB cdiv co cC wceq cC cc wcel cB cc wcel cB cc0 wne cB cC cmul co
    cB cdiv co cC wceq cC cB divcan3 3com12 3expia cB recn cC recn syl2an syld
    3adant1 imp breq2d bitr2d $.
    $( [26-Feb-2005] $) $( [18-Nov-2004] $)

  $( 'Less than or equal to' relationship between division and
     multiplication. $)
  ledivmul $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                  ( ( A / C ) <_ B <-> A <_ ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cB cmul co cle
    wbr cA cC cdiv co cC cB cmul co cC cdiv co cle wbr cA cC cdiv co cB cle wbr
    cA cr wcel cC cB cmul co cr wcel cC cr wcel cc0 cC clt wbr wa cA cC cB cmul
    co cle wbr cA cC cdiv co cC cB cmul co cC cdiv co cle wbr wb cB cr wcel cA
    cC cB cmul co cC lediv1 cB cr wcel cC cr wcel cc0 cC clt wbr wa cC cB cmul
    co cr wcel cA cr wcel cB cr wcel cC cr wcel cC cB cmul co cr wcel cc0 cC
    clt wbr cC cr wcel cB cr wcel cC cB cmul co cr wcel cC cB remulcl ancoms
    adantrr 3adant1 syld3an2 cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa
    w3a cC cB cmul co cC cdiv co cB cA cC cdiv co cle cB cr wcel cC cr wcel cc0
    cC clt wbr wa cC cB cmul co cC cdiv co cB wceq cA cr wcel cB cc wcel cC cc
    wcel cC cc0 wne cC cB cmul co cC cdiv co cB wceq cB cr wcel cC cr wcel cc0
    cC clt wbr wa wa cB cC divcan3 cB cr wcel cB cc wcel cC cr wcel cc0 cC clt
    wbr wa cB recn adantr cC cr wcel cC cc wcel cB cr wcel cc0 cC clt wbr cC
    recn ad2antrl cC cr wcel cc0 cC clt wbr wa cC cc0 wne cB cr wcel cC gt0ne0
    adantl syl3anc 3adant1 breq2d bitr2d $.
    $( [16-Oct-2008] $) $( [9-Dec-2005] $)

  $( 'Less than or equal to' relationship between division and
     multiplication. $)
  ledivmulOLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < B ) ->
                  ( ( A / B ) <_ C <-> A <_ ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr wa cA cB cC cmul co cle
    wbr cA cB cdiv co cB cC cmul co cB cdiv co cle wbr cA cB cdiv co cC cle wbr
    cA cr wcel cB cC cmul co cr wcel cB cr wcel w3a cc0 cB clt wbr cA cB cC
    cmul co cle wbr cA cB cdiv co cB cC cmul co cB cdiv co cle wbr wb cA cr
    wcel cB cr wcel cC cr wcel w3a cA cr wcel cB cC cmul co cr wcel cB cr wcel
    cc0 cB clt wbr wa cA cB cC cmul co cle wbr cA cB cdiv co cB cC cmul co cB
    cdiv co cle wbr wb cA cr wcel cB cC cmul co cr wcel cB cr wcel w3a cc0 cB
    clt wbr wa cA cB cC cmul co cB lediv1 cA cr wcel cB cC cmul co cr wcel cB
    cr wcel cc0 cB clt wbr 3simpl1 cA cr wcel cB cC cmul co cr wcel cB cr wcel
    cc0 cB clt wbr 3simpl2 cA cr wcel cB cC cmul co cr wcel cB cr wcel w3a cB
    cr wcel cc0 cB clt wbr cc0 cB clt wbr cA cr wcel cB cC cmul co cr wcel cB
    cr wcel 3simp3 cc0 cB clt wbr id anim12i syl3anc cA cr wcel cB cr wcel cC
    cr wcel w3a cA cr wcel cB cC cmul co cr wcel cB cr wcel cA cr wcel cB cr
    wcel cC cr wcel 3simp1 cB cr wcel cC cr wcel cB cC cmul co cr wcel cA cr
    wcel cB cC remulcl 3adant1 cA cr wcel cB cr wcel cC cr wcel 3simp2 3jca
    sylan cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr wa cB cC cmul co
    cB cdiv co cC cA cB cdiv co cle cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB
    clt wbr cB cC cmul co cB cdiv co cC wceq cB cr wcel cC cr wcel cc0 cB clt
    wbr cB cC cmul co cB cdiv co cC wceq wi cA cr wcel cB cr wcel cC cr wcel wa
    cc0 cB clt wbr cB cc0 wne cB cC cmul co cB cdiv co cC wceq cB cr wcel cc0
    cB clt wbr cB cc0 wne wi cC cr wcel cB cr wcel cc0 cB clt wbr cB cc0 wne cB
    gt0ne0 ex adantr cB cc wcel cC cc wcel cB cc0 wne cB cC cmul co cB cdiv co
    cC wceq wi cB cr wcel cC cr wcel cB cc wcel cC cc wcel cB cc0 wne cB cC
    cmul co cB cdiv co cC wceq cC cc wcel cB cc wcel cB cc0 wne cB cC cmul co
    cB cdiv co cC wceq cC cB divcan3 3com12 3expia cB recn cC recn syl2an syld
    3adant1 imp breq2d bitr2d $.
    $( [18-Dec-2005] $) $( [9-Dec-2005] $)

  $( 'Less than' relationship between division and multiplication. $)
  ltdivmul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                 -> ( ( A / C ) < B <-> A < ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cdiv co cB clt
    wbr cA cC cB cmul co clt wbr cA cB cC cmul co clt wbr cA cB cC ltdivmul cA
    cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cB cC cmul co cC cB
    cmul co cA clt cB cr wcel cC cr wcel cc0 cC clt wbr wa cB cC cmul co cC cB
    cmul co wceq cA cr wcel cB cr wcel cC cr wcel cB cC cmul co cC cB cmul co
    wceq cc0 cC clt wbr cB cc wcel cC cc wcel cB cC cmul co cC cB cmul co wceq
    cB cr wcel cC cr wcel cB cC mulcom cB recn cC recn syl2an adantrr 3adant1
    breq2d bitr4d $.
    $( [17-Aug-2008] $) $( [24-Feb-2005] $)

  $( 'Less than' relationship between division and multiplication. $)
  lt2mul2div $p |- ( ( ( A e. RR /\ ( B e. RR /\ 0 < B ) )
                   /\ ( C e. RR /\ ( D e. RR /\ 0 < D ) ) ) ->
                    ( ( A x. B ) < ( C x. D ) <-> ( A / D ) < ( C / B ) ) ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr wa wa cC cr wcel cD cr wcel cc0 cD clt
    wbr wa wa wa cA cC cD cmul co cB cdiv co clt wbr cA cD cC cB cdiv co cmul
    co clt wbr cA cB cmul co cC cD cmul co clt wbr cA cD cdiv co cC cB cdiv co
    clt wbr cA cr wcel cB cr wcel cc0 cB clt wbr wa wa cC cr wcel cD cr wcel
    cc0 cD clt wbr wa wa wa cC cD cmul co cB cdiv co cD cC cB cdiv co cmul co
    cA clt cB cr wcel cc0 cB clt wbr wa cC cr wcel cD cr wcel cc0 cD clt wbr wa
    wa cC cD cmul co cB cdiv co cD cC cB cdiv co cmul co wceq cA cr wcel cB cr
    wcel cc0 cB clt wbr wa cC cr wcel cD cr wcel cC cD cmul co cB cdiv co cD cC
    cB cdiv co cmul co wceq cc0 cD clt wbr cB cr wcel cc0 cB clt wbr wa cC cr
    wcel cD cr wcel wa wa cC cD cmul co cB cdiv co cD cC cmul co cB cdiv co cD
    cC cB cdiv co cmul co cC cr wcel cD cr wcel wa cC cD cmul co cB cdiv co cD
    cC cmul co cB cdiv co wceq cB cr wcel cc0 cB clt wbr wa cC cr wcel cD cr
    wcel wa cC cD cmul co cD cC cmul co cB cdiv cC cc wcel cD cc wcel cC cD
    cmul co cD cC cmul co wceq cC cr wcel cD cr wcel cC cD mulcom cC recn cD
    recn syl2an opreq1d adantl cD cc wcel cC cc wcel cB cc wcel cB cc0 wne wa
    cD cC cmul co cB cdiv co cD cC cB cdiv co cmul co wceq cB cr wcel cc0 cB
    clt wbr wa cC cr wcel cD cr wcel wa wa cD cC cB divass cD cr wcel cD cc
    wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cD recn ad2antll cC cr wcel cC
    cc wcel cB cr wcel cc0 cB clt wbr wa cD cr wcel cC recn ad2antrl cB cr wcel
    cc0 cB clt wbr wa cB cc wcel cB cc0 wne wa cC cr wcel cD cr wcel wa cB cr
    wcel cc0 cB clt wbr wa cB cc wcel cB cc0 wne cB cr wcel cB cc wcel cc0 cB
    clt wbr cB recn adantr cB gt0ne0 jca adantr syl3anc eqtrd adantrrr adantll
    breq2d cA cr wcel cC cD cmul co cr wcel cB cr wcel cc0 cB clt wbr wa cA cB
    cmul co cC cD cmul co clt wbr cA cC cD cmul co cB cdiv co clt wbr wb cA cr
    wcel cB cr wcel cc0 cB clt wbr wa wa cC cr wcel cD cr wcel cc0 cD clt wbr
    wa wa wa cA cC cD cmul co cB ltmuldiv cA cr wcel cB cr wcel cc0 cB clt wbr
    wa cC cr wcel cD cr wcel cc0 cD clt wbr wa wa simpll cC cr wcel cD cr wcel
    cc0 cD clt wbr wa wa cC cD cmul co cr wcel cA cr wcel cB cr wcel cc0 cB clt
    wbr wa wa cC cr wcel cD cr wcel cC cD cmul co cr wcel cc0 cD clt wbr cC cD
    axmulrcl adantrr adantl cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel
    cD cr wcel cc0 cD clt wbr wa wa simplr syl3anc cA cr wcel cC cB cdiv co cr
    wcel cD cr wcel cc0 cD clt wbr wa cA cD cdiv co cC cB cdiv co clt wbr cA cD
    cC cB cdiv co cmul co clt wbr wb cA cr wcel cB cr wcel cc0 cB clt wbr wa wa
    cC cr wcel cD cr wcel cc0 cD clt wbr wa wa wa cA cC cB cdiv co cD ltdivmul
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cD cr wcel cc0 cD clt
    wbr wa wa simpll cB cr wcel cc0 cB clt wbr wa cC cr wcel cC cB cdiv co cr
    wcel cA cr wcel cD cr wcel cc0 cD clt wbr wa cC cr wcel cB cr wcel cc0 cB
    clt wbr wa cC cB cdiv co cr wcel cC cr wcel cB cr wcel cB cc0 wne wa cC cB
    cdiv co cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cB cr wcel cB cc0
    wne cC cB cdiv co cr wcel cC cB redivcl 3expb cB cr wcel cc0 cB clt wbr wa
    cB cr wcel cB cc0 wne cB cr wcel cc0 cB clt wbr pm3.26 cB gt0ne0 jca sylan2
    ancoms ad2ant2lr cA cr wcel cB cr wcel cc0 cB clt wbr wa wa cC cr wcel cD
    cr wcel cc0 cD clt wbr wa simprr syl3anc 3bitr4d $.
    $( [5-Mar-2009] $) $( [8-Jan-2006] $)

  $( 'Less than' relationship between division and multiplication. $)
  lt2mul2divOLD $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) /\
                    ( 0 < B /\ 0 < D ) ) ->
                    ( ( A x. B ) < ( C x. D ) <-> ( A / D ) < ( C / B ) ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cc0 cB clt wbr cc0 cD clt
    wbr wa w3a cA cC cD cmul co cB cdiv co clt wbr cA cD cC cB cdiv co cmul co
    clt wbr cA cB cmul co cC cD cmul co clt wbr cA cD cdiv co cC cB cdiv co clt
    wbr cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cc0 cB clt wbr cc0 cD
    clt wbr wa w3a cC cD cmul co cB cdiv co cD cC cB cdiv co cmul co cA clt cB
    cr wcel cC cr wcel cD cr wcel wa cc0 cB clt wbr cc0 cD clt wbr wa cC cD
    cmul co cB cdiv co cD cC cB cdiv co cmul co wceq cA cr wcel cB cr wcel cC
    cr wcel cD cr wcel wa cc0 cB clt wbr cC cD cmul co cB cdiv co cD cC cB cdiv
    co cmul co wceq cc0 cD clt wbr cB cr wcel cC cr wcel cD cr wcel wa cc0 cB
    clt wbr w3a cC cD cmul co cB cdiv co cD cC cmul co cB cdiv co cD cC cB cdiv
    co cmul co cC cr wcel cD cr wcel wa cB cr wcel cC cD cmul co cB cdiv co cD
    cC cmul co cB cdiv co wceq cc0 cB clt wbr cC cr wcel cD cr wcel wa cC cD
    cmul co cD cC cmul co cB cdiv cC cc wcel cD cc wcel cC cD cmul co cD cC
    cmul co wceq cC cr wcel cD cr wcel cC cD mulcom cC recn cD recn syl2an
    opreq1d 3ad2ant2 cD cc wcel cC cc wcel cB cc wcel w3a cB cc0 wne cD cC cmul
    co cB cdiv co cD cC cB cdiv co cmul co wceq cB cr wcel cC cr wcel cD cr
    wcel wa cc0 cB clt wbr w3a cD cc wcel cC cc wcel cB cc wcel cB cc0 wne wa
    cD cC cmul co cB cdiv co cD cC cB cdiv co cmul co wceq cD cc wcel cC cc
    wcel cB cc wcel w3a cB cc0 wne wa cD cC cB divass cD cc wcel cC cc wcel cB
    cc wcel cB cc0 wne 3simpl1 cD cc wcel cC cc wcel cB cc wcel cB cc0 wne
    3simpl2 cD cc wcel cC cc wcel cB cc wcel w3a cB cc wcel cB cc0 wne cB cc0
    wne cD cc wcel cC cc wcel cB cc wcel 3simp3 cB cc0 wne id anim12i syl3anc
    cB cr wcel cC cr wcel cD cr wcel wa cc0 cB clt wbr w3a cD cc wcel cC cc
    wcel cB cc wcel cC cr wcel cD cr wcel wa cc0 cB clt wbr cD cc wcel cB cr
    wcel cD cr wcel cD cc wcel cC cr wcel cc0 cB clt wbr cD recn ad2antlr
    3adant1 cB cr wcel cC cr wcel cD cr wcel wa cC cc wcel cc0 cB clt wbr cC cr
    wcel cC cc wcel cB cr wcel cD cr wcel cC recn ad2antrl 3adant3 cB cr wcel
    cC cr wcel cD cr wcel wa cB cc wcel cc0 cB clt wbr cB recn 3ad2ant1 3jca cB
    cr wcel cc0 cB clt wbr cB cc0 wne cC cr wcel cD cr wcel wa cB gt0ne0
    3adant2 sylanc eqtrd 3adant3r 3adant1l breq2d cA cr wcel cB cr wcel cC cD
    cmul co cr wcel w3a cc0 cB clt wbr cA cB cmul co cC cD cmul co clt wbr cA
    cC cD cmul co cB cdiv co clt wbr wb cA cr wcel cB cr wcel wa cC cr wcel cD
    cr wcel wa cc0 cB clt wbr cc0 cD clt wbr wa w3a cA cr wcel cC cD cmul co cr
    wcel cB cr wcel cc0 cB clt wbr wa cA cB cmul co cC cD cmul co clt wbr cA cC
    cD cmul co cB cdiv co clt wbr wb cA cr wcel cB cr wcel cC cD cmul co cr
    wcel w3a cc0 cB clt wbr wa cA cC cD cmul co cB ltmuldiv cA cr wcel cB cr
    wcel cC cD cmul co cr wcel cc0 cB clt wbr 3simpl1 cA cr wcel cB cr wcel cC
    cD cmul co cr wcel cc0 cB clt wbr 3simpl3 cA cr wcel cB cr wcel cC cD cmul
    co cr wcel w3a cB cr wcel cc0 cB clt wbr cc0 cB clt wbr cA cr wcel cB cr
    wcel cC cD cmul co cr wcel 3simp2 cc0 cB clt wbr id anim12i syl3anc cA cr
    wcel cB cr wcel wa cC cr wcel cD cr wcel wa cc0 cB clt wbr cc0 cD clt wbr
    wa w3a cA cr wcel cB cr wcel cC cD cmul co cr wcel cA cr wcel cB cr wcel wa
    cC cr wcel cD cr wcel wa cA cr wcel cc0 cB clt wbr cc0 cD clt wbr wa cA cr
    wcel cB cr wcel pm3.26 3ad2ant1 cA cr wcel cB cr wcel wa cC cr wcel cD cr
    wcel wa cB cr wcel cc0 cB clt wbr cc0 cD clt wbr wa cA cr wcel cB cr wcel
    pm3.27 3ad2ant1 cC cr wcel cD cr wcel wa cA cr wcel cB cr wcel wa cC cD
    cmul co cr wcel cc0 cB clt wbr cc0 cD clt wbr wa cC cD remulcl 3ad2ant2
    3jca cc0 cB clt wbr cc0 cD clt wbr wa cA cr wcel cB cr wcel wa cc0 cB clt
    wbr cC cr wcel cD cr wcel wa cc0 cB clt wbr cc0 cD clt wbr pm3.26 3ad2ant3
    sylanc cA cr wcel cD cr wcel cC cB cdiv co cr wcel w3a cc0 cD clt wbr cA cD
    cdiv co cC cB cdiv co clt wbr cA cD cC cB cdiv co cmul co clt wbr wb cA cr
    wcel cB cr wcel wa cC cr wcel cD cr wcel wa cc0 cB clt wbr cc0 cD clt wbr
    wa w3a cA cr wcel cC cB cdiv co cr wcel cD cr wcel cc0 cD clt wbr wa cA cD
    cdiv co cC cB cdiv co clt wbr cA cD cC cB cdiv co cmul co clt wbr wb cA cr
    wcel cD cr wcel cC cB cdiv co cr wcel w3a cc0 cD clt wbr wa cA cC cB cdiv
    co cD ltdivmul cA cr wcel cD cr wcel cC cB cdiv co cr wcel cc0 cD clt wbr
    3simpl1 cA cr wcel cD cr wcel cC cB cdiv co cr wcel cc0 cD clt wbr 3simpl3
    cA cr wcel cD cr wcel cC cB cdiv co cr wcel w3a cD cr wcel cc0 cD clt wbr
    cc0 cD clt wbr cA cr wcel cD cr wcel cC cB cdiv co cr wcel 3simp2 cc0 cD
    clt wbr id anim12i syl3anc cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel
    wa cc0 cB clt wbr cc0 cD clt wbr wa w3a cA cr wcel cD cr wcel cC cB cdiv co
    cr wcel cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cA cr wcel cc0 cB
    clt wbr cc0 cD clt wbr wa cA cr wcel cB cr wcel pm3.26 3ad2ant1 cC cr wcel
    cD cr wcel wa cA cr wcel cB cr wcel wa cD cr wcel cc0 cB clt wbr cc0 cD clt
    wbr wa cC cr wcel cD cr wcel pm3.27 3ad2ant2 cB cr wcel cC cr wcel cD cr
    wcel wa cc0 cB clt wbr cc0 cD clt wbr wa cC cB cdiv co cr wcel cA cr wcel
    cB cr wcel cC cr wcel cc0 cB clt wbr cc0 cD clt wbr wa cC cB cdiv co cr
    wcel cD cr wcel cB cr wcel cC cr wcel cc0 cB clt wbr cC cB cdiv co cr wcel
    cc0 cD clt wbr cC cr wcel cB cr wcel cc0 cB clt wbr cC cB cdiv co cr wcel
    cC cr wcel cB cr wcel cB cc0 wne cC cB cdiv co cr wcel cc0 cB clt wbr cC cB
    redivcl cB cr wcel cc0 cB clt wbr cB cc0 wne cC cr wcel cB gt0ne0 3adant1
    syld3an3 3com12 3adant3r 3adant2r 3adant1l 3jca cc0 cB clt wbr cc0 cD clt
    wbr wa cA cr wcel cB cr wcel wa cc0 cD clt wbr cC cr wcel cD cr wcel wa cc0
    cB clt wbr cc0 cD clt wbr pm3.27 3ad2ant3 sylanc 3bitr4d $.
    $( [27-Jan-2006] $) $( [8-Jan-2006] $)

  $( 'Less than or equal to' relationship between division and
     multiplication. $)
  ledivmul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                  ( ( A / C ) <_ B <-> A <_ ( B x. C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cdiv co cB cle
    wbr cA cC cB cmul co cle wbr cA cB cC cmul co cle wbr cA cB cC ledivmul cA
    cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cB cC cmul co cC cB
    cmul co cA cle cB cr wcel cC cr wcel cc0 cC clt wbr wa cB cC cmul co cC cB
    cmul co wceq cA cr wcel cB cr wcel cC cr wcel cB cC cmul co cC cB cmul co
    wceq cc0 cC clt wbr cB cc wcel cC cc wcel cB cC cmul co cC cB cmul co wceq
    cB cr wcel cC cr wcel cB cC mulcom cB recn cC recn syl2an adantrr 3adant1
    breq2d bitr4d $.
    $( [19-Oct-2008] $) $( [9-Dec-2005] $)

  $( 'Less than or equal to' relationship between division and
     multiplication. $)
  ledivmul2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < B ) ->
                  ( ( A / B ) <_ C <-> A <_ ( C x. B ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr wa cA cB cdiv co cC cle
    wbr cA cB cC cmul co cle wbr cA cC cB cmul co cle wbr cA cr wcel cC cr wcel
    cB cr wcel cc0 cB clt wbr wa cA cB cdiv co cC cle wbr cA cB cC cmul co cle
    wbr wb cA cr wcel cB cr wcel cC cr wcel w3a cc0 cB clt wbr wa cA cC cB
    ledivmul cA cr wcel cB cr wcel cC cr wcel cc0 cB clt wbr 3simpl1 cA cr wcel
    cB cr wcel cC cr wcel cc0 cB clt wbr 3simpl3 cA cr wcel cB cr wcel cC cr
    wcel w3a cB cr wcel cc0 cB clt wbr cc0 cB clt wbr cA cr wcel cB cr wcel cC
    cr wcel 3simp2 cc0 cB clt wbr id anim12i syl3anc cA cr wcel cB cr wcel cC
    cr wcel w3a cc0 cB clt wbr wa cB cC cmul co cC cB cmul co cA cle cA cr wcel
    cB cr wcel cC cr wcel w3a cB cC cmul co cC cB cmul co wceq cc0 cB clt wbr
    cB cr wcel cC cr wcel cB cC cmul co cC cB cmul co wceq cA cr wcel cB cc
    wcel cC cc wcel cB cC cmul co cC cB cmul co wceq cB cr wcel cC cr wcel cB
    cC mulcom cB recn cC recn syl2an 3adant1 adantr breq2d bitrd $.
    $( [23-Dec-2005] $) $( [9-Dec-2005] $)

  $( 'Less than or equal' relationship between division and multiplication. $)
  lemuldiv $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                  ( ( A x. C ) <_ B <-> A <_ ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cB cC cdiv co cA clt
    wbr wn cB cA cC cmul co clt wbr wn cA cB cC cdiv co cle wbr cA cC cmul co
    cB cle wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cB cC
    cdiv co cA clt wbr cB cA cC cmul co clt wbr cB cr wcel cA cr wcel cC cr
    wcel cc0 cC clt wbr wa cB cC cdiv co cA clt wbr cB cA cC cmul co clt wbr wb
    cB cA cC ltdivmul2 3com12 notbid cA cr wcel cB cC cdiv co cr wcel cA cB cC
    cdiv co cle wbr cB cC cdiv co cA clt wbr wn wb cA cr wcel cB cr wcel cC cr
    wcel cc0 cC clt wbr wa w3a cA cB cC cdiv co lenlt cA cr wcel cB cr wcel cC
    cr wcel cc0 cC clt wbr wa 3simp1 cB cr wcel cC cr wcel cc0 cC clt wbr wa cB
    cC cdiv co cr wcel cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr cB cC
    cdiv co cr wcel cB cr wcel cC cr wcel cC cc0 wne cB cC cdiv co cr wcel cc0
    cC clt wbr cB cC redivcl cC cr wcel cc0 cC clt wbr cC cc0 wne cB cr wcel cC
    gt0ne0 3adant1 syld3an3 3expb 3adant1 sylanc cA cr wcel cB cr wcel cC cr
    wcel cA cC cmul co cB cle wbr cB cA cC cmul co clt wbr wn wb cc0 cC clt wbr
    cA cC cmul co cr wcel cB cr wcel cA cC cmul co cB cle wbr cB cA cC cmul co
    clt wbr wn wb cA cr wcel cB cr wcel cC cr wcel w3a cA cC cmul co cB lenlt
    cA cr wcel cC cr wcel cA cC cmul co cr wcel cB cr wcel cA cC remulcl
    3adant2 cA cr wcel cB cr wcel cC cr wcel 3simp2 sylanc 3adant3r 3bitr4rd $.
    $( [19-Aug-2008] $) $( [10-Mar-2006] $)

  $( 'Less than or equal' relationship between division and multiplication. $)
  lemuldiv2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                      ( ( C x. A ) <_ B <-> A <_ ( B / C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cmul co cB cle
    wbr cC cA cmul co cB cle wbr cA cB cC cdiv co cle wbr cA cr wcel cB cr wcel
    cC cr wcel cc0 cC clt wbr wa w3a cA cC cmul co cC cA cmul co cB cle cA cr
    wcel cC cr wcel cc0 cC clt wbr wa cA cC cmul co cC cA cmul co wceq cB cr
    wcel cA cr wcel cC cr wcel cA cC cmul co cC cA cmul co wceq cc0 cC clt wbr
    cA cc wcel cC cc wcel cA cC cmul co cC cA cmul co wceq cA cr wcel cC cr
    wcel cA cC mulcom cA recn cC recn syl2an adantrr 3adant2 breq1d cA cB cC
    lemuldiv bitr3d $.
    $( [20-Aug-2008] $) $( [10-Mar-2006] $)

  $( 'Less than or equal' relationship between division and multiplication. $)
  lemuldiv2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < A ) ->
                      ( ( A x. B ) <_ C <-> B <_ ( C / A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cA clt wbr cA cB cmul co cC cle
    wbr cB cC cA cdiv co cle wbr wb cB cr wcel cA cr wcel cC cr wcel cc0 cA clt
    wbr cA cB cmul co cC cle wbr cB cC cA cdiv co cle wbr wb wi cB cr wcel cA
    cr wcel cC cr wcel w3a cc0 cA clt wbr cA cB cmul co cC cle wbr cB cC cA
    cdiv co cle wbr wb cB cr wcel cA cr wcel cC cr wcel w3a cc0 cA clt wbr wa
    cB cA cmul co cC cle wbr cA cB cmul co cC cle wbr cB cC cA cdiv co cle wbr
    cB cr wcel cA cr wcel cC cr wcel w3a cc0 cA clt wbr wa cB cA cmul co cA cB
    cmul co cC cle cB cr wcel cA cr wcel cC cr wcel w3a cB cA cmul co cA cB
    cmul co wceq cc0 cA clt wbr cB cr wcel cA cr wcel cB cA cmul co cA cB cmul
    co wceq cC cr wcel cB cc wcel cA cc wcel cB cA cmul co cA cB cmul co wceq
    cB cr wcel cA cr wcel cB cA mulcom cB recn cA recn syl2an 3adant3 adantr
    breq1d cB cr wcel cC cr wcel cA cr wcel cc0 cA clt wbr wa cB cA cmul co cC
    cle wbr cB cC cA cdiv co cle wbr wb cB cr wcel cA cr wcel cC cr wcel w3a
    cc0 cA clt wbr wa cB cC cA lemuldiv cB cr wcel cA cr wcel cC cr wcel cc0 cA
    clt wbr 3simpl1 cB cr wcel cA cr wcel cC cr wcel cc0 cA clt wbr 3simpl3 cB
    cr wcel cA cr wcel cC cr wcel w3a cA cr wcel cc0 cA clt wbr cc0 cA clt wbr
    cB cr wcel cA cr wcel cC cr wcel 3simp2 cc0 cA clt wbr id anim12i syl3anc
    bitr3d ex 3com12 imp $.
    $( [18-Mar-2006] $) $( [10-Mar-2006] $)

  ${
    ltrec.1 $e |- A e. RR $.
    ltrec.2 $e |- B e. RR $.
    ${
      ltreci.3 $e |- 0 < A $.
      ltreci.4 $e |- 0 < B $.
      $( The reciprocal of both sides of 'less than'. $)
      ltrecii $p |- ( A < B <-> ( 1 / B ) < ( 1 / A ) ) $=
        cA cA cdiv co cB cA cdiv co clt wbr cB c1 cB cdiv co cmul co cB c1 cA
        cdiv co cmul co clt wbr cA cB clt wbr c1 cB cdiv co c1 cA cdiv co clt
        wbr cA cA cdiv co cB c1 cB cdiv co cmul co cB cA cdiv co cB c1 cA cdiv
        co cmul co clt cA cA cdiv co c1 cB c1 cB cdiv co cmul co cA cA ltrec.1
        recni cA ltrec.1 ltreci.3 gt0ne0ii dividi cB cB ltrec.2 recni cB
        ltrec.2 ltreci.4 gt0ne0ii recidi eqtr4i cB cA cB ltrec.2 recni cA
        ltrec.1 recni cA ltrec.1 ltreci.3 gt0ne0ii divreci breq12i cA cB cA
        ltrec.1 ltrec.2 ltrec.1 ltreci.3 ltdiv1ii cc0 cB clt wbr c1 cB cdiv co
        c1 cA cdiv co clt wbr cB c1 cB cdiv co cmul co cB c1 cA cdiv co cmul co
        clt wbr wb ltreci.4 c1 cB cdiv co c1 cA cdiv co cB cB ltrec.2 cB
        ltrec.2 ltreci.4 gt0ne0ii rereccli cA ltrec.1 cA ltrec.1 ltreci.3
        gt0ne0ii rereccli ltrec.2 ltmul2i ax-mp 3bitr4i $.
        $( [15-Sep-1999] $)
    $}

    $( The reciprocal of both sides of 'less than'. $)
    ltreci $p |- ( ( 0 < A /\ 0 < B ) ->
                ( A < B <-> ( 1 / B ) < ( 1 / A ) ) ) $=
      cc0 cA clt wbr cc0 cB clt wbr cA cB clt wbr c1 cB cdiv co c1 cA cdiv co
      clt wbr wb cc0 cA clt wbr cA c1 cif cB clt wbr c1 cB cdiv co c1 cc0 cA
      clt wbr cA c1 cif cdiv co clt wbr wb cc0 cA clt wbr cA c1 cif cc0 cB clt
      wbr cB c1 cif clt wbr c1 cc0 cB clt wbr cB c1 cif cdiv co c1 cc0 cA clt
      wbr cA c1 cif cdiv co clt wbr wb cA cB c1 c1 cA cc0 cA clt wbr cA c1 cif
      wceq cA cB clt wbr cc0 cA clt wbr cA c1 cif cB clt wbr c1 cB cdiv co c1
      cA cdiv co clt wbr c1 cB cdiv co c1 cc0 cA clt wbr cA c1 cif cdiv co clt
      wbr cA cc0 cA clt wbr cA c1 cif cB clt breq1 cA cc0 cA clt wbr cA c1 cif
      wceq c1 cA cdiv co c1 cc0 cA clt wbr cA c1 cif cdiv co c1 cB cdiv co clt
      cA cc0 cA clt wbr cA c1 cif c1 cdiv opreq2 breq2d bibi12d cB cc0 cB clt
      wbr cB c1 cif wceq cc0 cA clt wbr cA c1 cif cB clt wbr cc0 cA clt wbr cA
      c1 cif cc0 cB clt wbr cB c1 cif clt wbr c1 cB cdiv co c1 cc0 cA clt wbr
      cA c1 cif cdiv co clt wbr c1 cc0 cB clt wbr cB c1 cif cdiv co c1 cc0 cA
      clt wbr cA c1 cif cdiv co clt wbr cB cc0 cB clt wbr cB c1 cif cc0 cA clt
      wbr cA c1 cif clt breq2 cB cc0 cB clt wbr cB c1 cif wceq c1 cB cdiv co c1
      cc0 cB clt wbr cB c1 cif cdiv co c1 cc0 cA clt wbr cA c1 cif cdiv co clt
      cB cc0 cB clt wbr cB c1 cif c1 cdiv opreq2 breq1d bibi12d cc0 cA clt wbr
      cA c1 cif cc0 cB clt wbr cB c1 cif cc0 cA clt wbr cA c1 cr ltrec.1 1re
      keepel cc0 cB clt wbr cB c1 cr ltrec.2 1re keepel cA elimgt0 cB elimgt0
      ltrecii dedth2h $.
      $( [15-Sep-1999] $)

    $( The reciprocal of both sides of 'less than or equal to'. $)
    lereci $p |- ( ( 0 < A /\ 0 < B ) ->
                ( A <_ B <-> ( 1 / B ) <_ ( 1 / A ) ) ) $=
      cc0 cA clt wbr cc0 cB clt wbr wa cA cB clt wbr cA cB wceq wo c1 cB cdiv
      co c1 cA cdiv co cle wbr cA cB cle wbr cc0 cA clt wbr cc0 cB clt wbr wa
      cA cB clt wbr cA cB wceq wo c1 cB cdiv co c1 cA cdiv co clt wbr c1 cB
      cdiv co c1 cA cdiv co wceq wo c1 cB cdiv co c1 cA cdiv co cle wbr cc0 cA
      clt wbr cc0 cB clt wbr wa cA cB clt wbr c1 cB cdiv co c1 cA cdiv co clt
      wbr cA cB wceq c1 cB cdiv co c1 cA cdiv co wceq cA cB ltrec.1 ltrec.2
      ltreci cc0 cA clt wbr cc0 cB clt wbr wa c1 cA cdiv co c1 cB cdiv co wceq
      cA cB wceq c1 cB cdiv co c1 cA cdiv co wceq cA cc0 wne cB cc0 wne c1 cA
      cdiv co c1 cB cdiv co wceq cA cB wceq wb cc0 cA clt wbr cc0 cB clt wbr cA
      cB cA ltrec.1 recni cB ltrec.2 recni rec11i cA ltrec.1 gt0ne0i cB ltrec.2
      gt0ne0i syl2an c1 cA cdiv co c1 cB cdiv co eqcom syl5rbbr orbi12d cc0 cA
      clt wbr cc0 cB clt wbr wa c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel wa
      c1 cB cdiv co c1 cA cdiv co cle wbr c1 cB cdiv co c1 cA cdiv co clt wbr
      c1 cB cdiv co c1 cA cdiv co wceq wo wb cc0 cB clt wbr cc0 cA clt wbr c1
      cB cdiv co cr wcel c1 cA cdiv co cr wcel wa cc0 cB clt wbr c1 cB cdiv co
      cr wcel cc0 cA clt wbr c1 cA cdiv co cr wcel cc0 cB clt wbr cB cc0 wne c1
      cB cdiv co cr wcel cB ltrec.2 gt0ne0i cB ltrec.2 rerecclzi syl cc0 cA clt
      wbr cA cc0 wne c1 cA cdiv co cr wcel cA ltrec.1 gt0ne0i cA ltrec.1
      rerecclzi syl anim12i ancoms c1 cB cdiv co c1 cA cdiv co leloe syl bitr4d
      cA cB ltrec.1 ltrec.2 leloei syl5bb $.
      $( [16-Sep-1999] $)

    $( The square function on nonnegative reals is strictly monotonic. $)
    lt2msqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( A < B <-> ( A x. A ) < ( B x. B ) ) ) $=
      cc0 cA clt wbr cc0 cA wceq wo cc0 cB clt wbr cc0 cB wceq wo cA cB clt wbr
      cA cA cmul co cB cB cmul co clt wbr wb cc0 cA cle wbr cc0 cB cle wbr cc0
      cA clt wbr cc0 cB clt wbr cc0 cA wceq cc0 cB wceq cA cB clt wbr cA cA
      cmul co cB cB cmul co clt wbr wb cc0 cA clt wbr cc0 cB clt wbr wa cA cB
      clt wbr cA cA cmul co cB cB cmul co clt wbr cc0 cA clt wbr cc0 cB clt wbr
      wa cA cB clt wbr cA cA cmul co cA cB cmul co clt wbr cA cB cmul co cB cB
      cmul co clt wbr wa cA cA cmul co cB cB cmul co clt wbr cc0 cA clt wbr cc0
      cB clt wbr wa cA cB clt wbr cA cB clt wbr wa cA cA cmul co cA cB cmul co
      clt wbr cA cB cmul co cB cB cmul co clt wbr wa cA cB clt wbr cc0 cA clt
      wbr cA cB clt wbr cA cA cmul co cA cB cmul co clt wbr cc0 cB clt wbr cA
      cB clt wbr cA cB cmul co cB cB cmul co clt wbr cA cB cA ltrec.1 ltrec.2
      ltrec.1 ltmul2i cA cB cB ltrec.1 ltrec.2 ltrec.2 ltmul1i bi2anan9 cA cB
      clt wbr anidm syl5bbr cA cA cmul co cA cB cmul co cB cB cmul co cA cA
      ltrec.1 ltrec.1 remulcli cA cB ltrec.1 ltrec.2 remulcli cB cB ltrec.2
      ltrec.2 remulcli lttri syl6bi cc0 cA clt wbr cc0 cB clt wbr wa cA cB clt
      wbr cA cA cmul co cB cB cmul co clt wbr cc0 cA clt wbr cc0 cB clt wbr wa
      cB cA cle wbr cB cB cmul co cA cA cmul co cle wbr cA cB clt wbr wn cA cA
      cmul co cB cB cmul co clt wbr wn cc0 cA clt wbr cc0 cB clt wbr wa cB cA
      cle wbr cB cB cmul co cB cA cmul co cle wbr cB cA cmul co cA cA cmul co
      cle wbr wa cB cB cmul co cA cA cmul co cle wbr cc0 cA clt wbr cc0 cB clt
      wbr wa cB cA cle wbr cB cA cle wbr wa cB cB cmul co cB cA cmul co cle wbr
      cB cA cmul co cA cA cmul co cle wbr wa cB cA cle wbr cc0 cB clt wbr cB cA
      cle wbr cB cB cmul co cB cA cmul co cle wbr cc0 cA clt wbr cB cA cle wbr
      cB cA cmul co cA cA cmul co cle wbr cB cA cB ltrec.2 ltrec.1 ltrec.2
      lemul2i cB cA cA ltrec.2 ltrec.1 ltrec.1 lemul1i bi2anan9r cB cA cle wbr
      anidm syl5bbr cB cB cmul co cB cA cmul co cA cA cmul co cB cB ltrec.2
      ltrec.2 remulcli cB cA ltrec.2 ltrec.1 remulcli cA cA ltrec.1 ltrec.1
      remulcli letri syl6bi cB cA ltrec.2 ltrec.1 lenlti cB cB cmul co cA cA
      cmul co cB cB ltrec.2 ltrec.2 remulcli cA cA ltrec.1 ltrec.1 remulcli
      lenlti 3imtr3g con4d impbid cc0 cA wceq cc0 cB clt wbr wa cc0 cB clt wbr
      cA cB clt wbr cA cA cmul co cB cB cmul co clt wbr cc0 cA wceq cc0 cB clt
      wbr cA cB clt wbr wb cc0 cB clt wbr cc0 cA cB clt breq1 adantr cc0 cB clt
      wbr cc0 cB clt wbr cB cc0 cmul co cB cB cmul co clt wbr cc0 cA wceq cA cA
      cmul co cB cB cmul co clt wbr cc0 cB cB 0re ltrec.2 ltrec.2 ltmul2i cc0
      cA wceq cA cc0 cmul co cB cB cmul co clt wbr cA cA cmul co cB cB cmul co
      clt wbr cB cc0 cmul co cB cB cmul co clt wbr cc0 cA wceq cA cc0 cmul co
      cA cA cmul co cB cB cmul co clt cc0 cA cA cmul opreq2 breq1d cB cc0 cmul
      co cA cc0 cmul co cB cB cmul co clt cB cc0 cmul co cc0 cA cc0 cmul co cB
      cB ltrec.2 recni mul01i cA cA ltrec.1 recni mul01i eqtr4i breq1i syl5bb
      sylan9bbr bitr3d cc0 cA clt wbr cc0 cB wceq wa cA cB clt wbr cA cA cmul
      co cB cB cmul co clt wbr cc0 cA clt wbr cc0 cB wceq wa cB cA cle wbr cB
      cB cmul co cA cA cmul co cle wbr cA cB clt wbr wn cA cA cmul co cB cB
      cmul co clt wbr wn cc0 cA clt wbr cc0 cB wceq wa cc0 cA cle wbr cB cA cle
      wbr cB cB cmul co cA cA cmul co cle wbr cc0 cB wceq cc0 cA cle wbr cB cA
      cle wbr wb cc0 cA clt wbr cc0 cB cA cle breq1 adantl cc0 cA clt wbr cc0
      cA cle wbr cA cc0 cmul co cA cA cmul co cle wbr cc0 cB wceq cB cB cmul co
      cA cA cmul co cle wbr cc0 cA cA 0re ltrec.1 ltrec.1 lemul2i cc0 cB wceq
      cB cc0 cmul co cA cA cmul co cle wbr cB cB cmul co cA cA cmul co cle wbr
      cA cc0 cmul co cA cA cmul co cle wbr cc0 cB wceq cB cc0 cmul co cB cB
      cmul co cA cA cmul co cle cc0 cB cB cmul opreq2 breq1d cA cc0 cmul co cB
      cc0 cmul co cA cA cmul co cle cA cc0 cmul co cc0 cB cc0 cmul co cA cA
      ltrec.1 recni mul01i cB cB ltrec.2 recni mul01i eqtr4i breq1i syl5bb
      sylan9bb bitr3d cB cA ltrec.2 ltrec.1 lenlti cB cB cmul co cA cA cmul co
      cB cB ltrec.2 ltrec.2 remulcli cA cA ltrec.1 ltrec.1 remulcli lenlti
      3bitr3g con4bid cA cB clt wbr wn cA cA cmul co cB cB cmul co clt wbr wn
      cA cB clt wbr cA cA cmul co cB cB cmul co clt wbr wb cc0 cA wceq cc0 cB
      wceq wa cA cB clt wbr cA cA cmul co cB cB cmul co clt wbr pm5.21 cc0 cA
      wceq cc0 cB wceq wa cB cB clt wbr cA cB clt wbr cB ltrec.2 ltnri cc0 cB
      wceq cB cB clt wbr cc0 cB clt wbr cc0 cA wceq cA cB clt wbr cc0 cB wceq
      cc0 cB clt wbr cB cB clt wbr cc0 cB cB clt breq1 bicomd cc0 cA cB clt
      breq1 sylan9bbr mtbii cc0 cA wceq cc0 cB wceq wa cB cB cmul co cB cB cmul
      co clt wbr cA cA cmul co cB cB cmul co clt wbr cB cB cmul co cB cB
      ltrec.2 ltrec.2 remulcli ltnri cc0 cB wceq cB cB cmul co cB cB cmul co
      clt wbr cB cc0 cmul co cB cB cmul co clt wbr cc0 cA wceq cA cA cmul co cB
      cB cmul co clt wbr cc0 cB wceq cB cc0 cmul co cB cB cmul co clt wbr cB cB
      cmul co cB cB cmul co clt wbr cc0 cB wceq cB cc0 cmul co cB cB cmul co cB
      cB cmul co clt cc0 cB cB cmul opreq2 breq1d bicomd cc0 cA wceq cA cc0
      cmul co cB cB cmul co clt wbr cA cA cmul co cB cB cmul co clt wbr cB cc0
      cmul co cB cB cmul co clt wbr cc0 cA wceq cA cc0 cmul co cA cA cmul co cB
      cB cmul co clt cc0 cA cA cmul opreq2 breq1d cB cc0 cmul co cA cc0 cmul co
      cB cB cmul co clt cB cc0 cmul co cc0 cA cc0 cmul co cB cB ltrec.2 recni
      mul01i cA cA ltrec.1 recni mul01i eqtr4i breq1i syl5bb sylan9bbr mtbii
      sylanc ccase cc0 cA 0re ltrec.1 leloei cc0 cB 0re ltrec.2 leloei syl2anb
      $.
      $( [3-Aug-1999] $)

    $( The square function on nonnegative reals is monotonic. $)
    le2msqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( A <_ B <-> ( A x. A ) <_ ( B x. B ) ) ) $=
      cc0 cB cle wbr cc0 cA cle wbr cA cB cle wbr cA cA cmul co cB cB cmul co
      cle wbr wb cc0 cB cle wbr cc0 cA cle wbr wa cB cA clt wbr wn cB cB cmul
      co cA cA cmul co clt wbr wn cA cB cle wbr cA cA cmul co cB cB cmul co cle
      wbr cc0 cB cle wbr cc0 cA cle wbr wa cB cA clt wbr cB cB cmul co cA cA
      cmul co clt wbr cB cA ltrec.2 ltrec.1 lt2msqi notbid cA cB ltrec.1
      ltrec.2 lenlti cA cA cmul co cB cB cmul co cA cA ltrec.1 ltrec.1 remulcli
      cB cB ltrec.2 ltrec.2 remulcli lenlti 3bitr4g ancoms $.
      $( [2-Aug-1999] $)

    $( The square of a nonnegative number is a one-to-one function. $)
    msq11i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( ( A x. A ) = ( B x. B ) <-> A = B ) ) $=
      cc0 cA cle wbr cc0 cB cle wbr wa cA cB wceq cA cA cmul co cB cB cmul co
      wceq cc0 cA cle wbr cc0 cB cle wbr wa cA cB cA cA cmul co cB cB cmul co
      cc0 cA cle wbr cc0 cB cle wbr wa cA cB clt wbr cB cA clt wbr wo cA cA
      cmul co cB cB cmul co clt wbr cB cB cmul co cA cA cmul co clt wbr wo cA
      cB wne cA cA cmul co cB cB cmul co wne cc0 cA cle wbr cc0 cB cle wbr wa
      cA cB clt wbr cA cA cmul co cB cB cmul co clt wbr cB cA clt wbr cB cB
      cmul co cA cA cmul co clt wbr cA cB ltrec.1 ltrec.2 lt2msqi cc0 cB cle
      wbr cc0 cA cle wbr cB cA clt wbr cB cB cmul co cA cA cmul co clt wbr wb
      cB cA ltrec.2 ltrec.1 lt2msqi ancoms orbi12d cA cB ltrec.1 ltrec.2
      lttri2i cA cA cmul co cB cB cmul co cA cA ltrec.1 ltrec.1 remulcli cB cB
      ltrec.2 ltrec.2 remulcli lttri2i 3bitr4g necon4bid bicomd $.
      $( [29-Jul-1999] $)
  $}

  $( The reciprocal of both sides of 'less than'. $)
  ltrec $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( A < B <-> ( 1 / B ) < ( 1 / A ) ) ) $=
    cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr cA cB clt wbr c1 cB
    cdiv co c1 cA cdiv co clt wbr wb cA cr wcel cB cr wcel wa cc0 cA clt wbr
    cc0 cB clt wbr wa cA cB clt wbr c1 cB cdiv co c1 cA cdiv co clt wbr wb cA
    cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr wa cA cB clt wbr c1 cB
    cdiv co c1 cA cdiv co clt wbr wb wi cc0 cA cr wcel cA cc0 cif clt wbr cc0
    cB clt wbr wa cA cr wcel cA cc0 cif cB clt wbr c1 cB cdiv co c1 cA cr wcel
    cA cc0 cif cdiv co clt wbr wb wi cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB
    cr wcel cB cc0 cif clt wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    clt wbr c1 cB cr wcel cB cc0 cif cdiv co c1 cA cr wcel cA cc0 cif cdiv co
    clt wbr wb wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA clt wbr
    cc0 cB clt wbr wa cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB clt wbr wa cA cB
    clt wbr c1 cB cdiv co c1 cA cdiv co clt wbr wb cA cr wcel cA cc0 cif cB clt
    wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co clt wbr wb cA cA cr wcel
    cA cc0 cif wceq cc0 cA clt wbr cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB clt
    wbr cA cA cr wcel cA cc0 cif cc0 clt breq2 anbi1d cA cA cr wcel cA cc0 cif
    wceq cA cB clt wbr cA cr wcel cA cc0 cif cB clt wbr c1 cB cdiv co c1 cA
    cdiv co clt wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co clt wbr cA
    cA cr wcel cA cc0 cif cB clt breq1 cA cA cr wcel cA cc0 cif wceq c1 cA cdiv
    co c1 cA cr wcel cA cc0 cif cdiv co c1 cB cdiv co clt cA cA cr wcel cA cc0
    cif c1 cdiv opreq2 breq2d bibi12d imbi12d cB cB cr wcel cB cc0 cif wceq cc0
    cA cr wcel cA cc0 cif clt wbr cc0 cB clt wbr wa cc0 cA cr wcel cA cc0 cif
    clt wbr cc0 cB cr wcel cB cc0 cif clt wbr wa cA cr wcel cA cc0 cif cB clt
    wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co clt wbr wb cA cr wcel cA
    cc0 cif cB cr wcel cB cc0 cif clt wbr c1 cB cr wcel cB cc0 cif cdiv co c1
    cA cr wcel cA cc0 cif cdiv co clt wbr wb cB cB cr wcel cB cc0 cif wceq cc0
    cB clt wbr cc0 cB cr wcel cB cc0 cif clt wbr cc0 cA cr wcel cA cc0 cif clt
    wbr cB cB cr wcel cB cc0 cif cc0 clt breq2 anbi2d cB cB cr wcel cB cc0 cif
    wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif clt wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co clt wbr c1
    cB cr wcel cB cc0 cif cdiv co c1 cA cr wcel cA cc0 cif cdiv co clt wbr cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif clt breq2 cB cB cr wcel cB cc0
    cif wceq c1 cB cdiv co c1 cB cr wcel cB cc0 cif cdiv co c1 cA cr wcel cA
    cc0 cif cdiv co clt cB cB cr wcel cB cc0 cif c1 cdiv opreq2 breq1d bibi12d
    imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re elimel cB
    cc0 cr 0re elimel ltreci dedth2h imp an4s $.
    $( [20-Mar-2006] $) $( [26-Sep-1999] $)

  $( The reciprocal of both sides of 'less than or equal to'. $)
  lerec $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( A <_ B <-> ( 1 / B ) <_ ( 1 / A ) ) ) $=
    cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr cA cB cle wbr c1 cB
    cdiv co c1 cA cdiv co cle wbr wb cA cr wcel cB cr wcel wa cc0 cA clt wbr
    cc0 cB clt wbr wa cA cB cle wbr c1 cB cdiv co c1 cA cdiv co cle wbr wb cA
    cr wcel cB cr wcel cc0 cA clt wbr cc0 cB clt wbr wa cA cB cle wbr c1 cB
    cdiv co c1 cA cdiv co cle wbr wb wi cc0 cA cr wcel cA cc0 cif clt wbr cc0
    cB clt wbr wa cA cr wcel cA cc0 cif cB cle wbr c1 cB cdiv co c1 cA cr wcel
    cA cc0 cif cdiv co cle wbr wb wi cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB
    cr wcel cB cc0 cif clt wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cle wbr c1 cB cr wcel cB cc0 cif cdiv co c1 cA cr wcel cA cc0 cif cdiv co
    cle wbr wb wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA clt wbr
    cc0 cB clt wbr wa cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB clt wbr wa cA cB
    cle wbr c1 cB cdiv co c1 cA cdiv co cle wbr wb cA cr wcel cA cc0 cif cB cle
    wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co cle wbr wb cA cA cr wcel
    cA cc0 cif wceq cc0 cA clt wbr cc0 cA cr wcel cA cc0 cif clt wbr cc0 cB clt
    wbr cA cA cr wcel cA cc0 cif cc0 clt breq2 anbi1d cA cA cr wcel cA cc0 cif
    wceq cA cB cle wbr cA cr wcel cA cc0 cif cB cle wbr c1 cB cdiv co c1 cA
    cdiv co cle wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co cle wbr cA
    cA cr wcel cA cc0 cif cB cle breq1 cA cA cr wcel cA cc0 cif wceq c1 cA cdiv
    co c1 cA cr wcel cA cc0 cif cdiv co c1 cB cdiv co cle cA cA cr wcel cA cc0
    cif c1 cdiv opreq2 breq2d bibi12d imbi12d cB cB cr wcel cB cc0 cif wceq cc0
    cA cr wcel cA cc0 cif clt wbr cc0 cB clt wbr wa cc0 cA cr wcel cA cc0 cif
    clt wbr cc0 cB cr wcel cB cc0 cif clt wbr wa cA cr wcel cA cc0 cif cB cle
    wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co cle wbr wb cA cr wcel cA
    cc0 cif cB cr wcel cB cc0 cif cle wbr c1 cB cr wcel cB cc0 cif cdiv co c1
    cA cr wcel cA cc0 cif cdiv co cle wbr wb cB cB cr wcel cB cc0 cif wceq cc0
    cB clt wbr cc0 cB cr wcel cB cc0 cif clt wbr cc0 cA cr wcel cA cc0 cif clt
    wbr cB cB cr wcel cB cc0 cif cc0 clt breq2 anbi2d cB cB cr wcel cB cc0 cif
    wceq cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cle wbr c1 cB cdiv co c1 cA cr wcel cA cc0 cif cdiv co cle wbr c1
    cB cr wcel cB cc0 cif cdiv co c1 cA cr wcel cA cc0 cif cdiv co cle wbr cB
    cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cle breq2 cB cB cr wcel cB cc0
    cif wceq c1 cB cdiv co c1 cB cr wcel cB cc0 cif cdiv co c1 cA cr wcel cA
    cc0 cif cdiv co cle cB cB cr wcel cB cc0 cif c1 cdiv opreq2 breq1d bibi12d
    imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re elimel cB
    cc0 cr 0re elimel lereci dedth2h imp an4s $.
    $( [6-Apr-2006] $) $( [3-Oct-1999] $)

  $( Two nonnegative numbers compare the same as their squares.  (Contributed
     by Roy F. Longton, 8-Aug-2005.) $)
  lt2msq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
                  ( A < B <-> ( A x. A ) < ( B x. B ) ) ) $=
    cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr cA cB clt wbr cA cA
    cmul co cB cB cmul co clt wbr wb cA cr wcel cB cr wcel wa cc0 cA cle wbr
    cc0 cB cle wbr wa cA cB clt wbr cA cA cmul co cB cB cmul co clt wbr wb cA
    cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr wa cA cB clt wbr cA cA
    cmul co cB cB cmul co clt wbr wb wi cc0 cA cr wcel cA cc0 cif cle wbr cc0
    cB cle wbr wa cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cA cr
    wcel cA cc0 cif cmul co cB cB cmul co clt wbr wb wi cc0 cA cr wcel cA cc0
    cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul
    co cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co clt wbr wb wi cA cB
    cc0 cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0
    cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cA cB clt wbr cA cA cmul co
    cB cB cmul co clt wbr wb cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0
    cif cA cr wcel cA cc0 cif cmul co cB cB cmul co clt wbr wb cA cA cr wcel cA
    cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle
    wbr cA cA cr wcel cA cc0 cif cc0 cle breq2 anbi1d cA cA cr wcel cA cc0 cif
    wceq cA cB clt wbr cA cr wcel cA cc0 cif cB clt wbr cA cA cmul co cB cB
    cmul co clt wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB cB
    cmul co clt wbr cA cA cr wcel cA cc0 cif cB clt breq1 cA cA cr wcel cA cc0
    cif wceq cA cA cmul co cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co
    cB cB cmul co clt cA cA cr wcel cA cc0 cif wceq cA cA cmul co cA cr wcel cA
    cc0 cif cA cr wcel cA cc0 cif cmul co wceq cA cA cr wcel cA cc0 cif cA cA
    cr wcel cA cc0 cif cmul opreq12 anidms breq1d bibi12d imbi12d cB cB cr wcel
    cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cc0 cA
    cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel
    cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co
    cB cB cmul co clt wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt
    wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB cr wcel cB cc0
    cif cB cr wcel cB cc0 cif cmul co clt wbr wb cB cB cr wcel cB cc0 cif wceq
    cc0 cB cle wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif
    cle wbr cB cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif clt wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB
    cB cmul co clt wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB
    cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co clt wbr cB cB cr wcel cB
    cc0 cif cA cr wcel cA cc0 cif clt breq2 cB cB cr wcel cB cc0 cif wceq cB cB
    cmul co cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co cA cr wcel cA
    cc0 cif cA cr wcel cA cc0 cif cmul co clt cB cB cr wcel cB cc0 cif wceq cB
    cB cmul co cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co wceq cB cB
    cr wcel cB cc0 cif cB cB cr wcel cB cc0 cif cmul opreq12 anidms breq2d
    bibi12d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel lt2msqi dedth2h imp an4s $.
    $( [8-Aug-2005] $) $( [8-Aug-2005] $)

  $( Division of a positive number by both sides of 'less than'. $)
  ltdiv2 $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
      ( 0 < A /\ 0 < B /\ 0 < C ) ) -> ( A < B <-> ( C / B ) < ( C / A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cc0 cA clt wbr cc0 cB clt wbr cc0 cC
    clt wbr w3a wa cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC
    cr wcel cc0 cC clt wbr wa w3a cA cB clt wbr cC cB cdiv co cC cA cdiv co clt
    wbr wb cA cr wcel cB cr wcel cC cr wcel cc0 cA clt wbr cc0 cB clt wbr cc0
    cC clt wbr an6 cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC
    cr wcel cc0 cC clt wbr wa w3a cA cB clt wbr c1 cB cdiv co c1 cA cdiv co clt
    wbr cC cB cdiv co cC cA cdiv co clt wbr cA cr wcel cc0 cA clt wbr wa cB cr
    wcel cc0 cB clt wbr wa cA cB clt wbr c1 cB cdiv co c1 cA cdiv co clt wbr wb
    cC cr wcel cc0 cC clt wbr wa cA cB ltrec 3adant3 cA cr wcel cA cc0 wne wa
    cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC clt wbr wa c1 cB cdiv co c1
    cA cdiv co clt wbr cC cB cdiv co cC cA cdiv co clt wbr wb cA cr wcel cc0 cA
    clt wbr wa cA cr wcel cA cc0 wne wa cB cr wcel cB cc0 wne wa cC cr wcel cc0
    cC clt wbr wa c1 cB cdiv co c1 cA cdiv co clt wbr cC cB cdiv co cC cA cdiv
    co clt wbr wb cB cr wcel cc0 cB clt wbr wa cA cr wcel cA cc0 wne wa cB cr
    wcel cB cc0 wne wa cC cr wcel cc0 cC clt wbr wa c1 cB cdiv co c1 cA cdiv co
    clt wbr cC cB cdiv co cC cA cdiv co clt wbr wb cA cr wcel cA cc0 wne wa cB
    cr wcel cB cc0 wne wa cC cr wcel cc0 cC clt wbr c1 cB cdiv co c1 cA cdiv co
    clt wbr cC cB cdiv co cC cA cdiv co clt wbr wb cA cr wcel cA cc0 wne wa cB
    cr wcel cB cc0 wne wa cC cr wcel cc0 cC clt wbr c1 cB cdiv co c1 cA cdiv co
    clt wbr cC cB cdiv co cC cA cdiv co clt wbr wb wi cB cr wcel cB cc0 wne wa
    cA cr wcel cA cc0 wne wa cC cr wcel cc0 cC clt wbr c1 cB cdiv co c1 cA cdiv
    co clt wbr cC cB cdiv co cC cA cdiv co clt wbr wb wi cB cr wcel cB cc0 wne
    wa cA cr wcel cA cc0 wne wa cC cr wcel w3a cc0 cC clt wbr c1 cB cdiv co c1
    cA cdiv co clt wbr cC cB cdiv co cC cA cdiv co clt wbr wb cB cr wcel cB cc0
    wne wa cA cr wcel cA cc0 wne wa cC cr wcel w3a cc0 cC clt wbr wa c1 cB cdiv
    co c1 cA cdiv co clt wbr cC c1 cB cdiv co cmul co cC c1 cA cdiv co cmul co
    clt wbr cC cB cdiv co cC cA cdiv co clt wbr c1 cB cdiv co cr wcel cA cr
    wcel cA cc0 wne wa cC cr wcel cc0 cC clt wbr c1 cB cdiv co c1 cA cdiv co
    clt wbr cC c1 cB cdiv co cmul co cC c1 cA cdiv co cmul co clt wbr wb cB cr
    wcel cB cc0 wne wa c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel cC cr wcel
    cc0 cC clt wbr c1 cB cdiv co c1 cA cdiv co clt wbr cC c1 cB cdiv co cmul co
    cC c1 cA cdiv co cmul co clt wbr wb cA cr wcel cA cc0 wne wa c1 cB cdiv co
    c1 cA cdiv co cC ltmul2OLD cA rereccl syl3anl2 cB rereccl syl3anl1 cB cr
    wcel cB cc0 wne wa cA cr wcel cA cc0 wne wa cC cr wcel w3a cC cB cdiv co cC
    cA cdiv co clt wbr cC c1 cB cdiv co cmul co cC c1 cA cdiv co cmul co clt
    wbr wb cc0 cC clt wbr cB cr wcel cB cc0 wne wa cA cr wcel cA cc0 wne wa cC
    cc wcel cC cB cdiv co cC cA cdiv co clt wbr cC c1 cB cdiv co cmul co cC c1
    cA cdiv co cmul co clt wbr wb cC cr wcel cC cc wcel cB cr wcel cB cc0 wne
    wa cA cr wcel cA cc0 wne wa cC cB cdiv co cC cA cdiv co clt wbr cC c1 cB
    cdiv co cmul co cC c1 cA cdiv co cmul co clt wbr wb cC cc wcel cB cr wcel
    cB cc0 wne wa cA cr wcel cA cc0 wne wa w3a cC cB cdiv co cC c1 cB cdiv co
    cmul co cC cA cdiv co cC c1 cA cdiv co cmul co clt cC cc wcel cB cr wcel cB
    cc0 wne wa cC cB cdiv co cC c1 cB cdiv co cmul co wceq cA cr wcel cA cc0
    wne wa cC cc wcel cB cr wcel cB cc0 wne cC cB cdiv co cC c1 cB cdiv co cmul
    co wceq cC cc wcel cB cc wcel cB cc0 wne cC cB cdiv co cC c1 cB cdiv co
    cmul co wceq cB cr wcel cC cB divrec cB recn syl3an2 3expb 3adant3 cC cc
    wcel cA cr wcel cA cc0 wne wa cC cA cdiv co cC c1 cA cdiv co cmul co wceq
    cB cr wcel cB cc0 wne wa cC cc wcel cA cr wcel cA cc0 wne cC cA cdiv co cC
    c1 cA cdiv co cmul co wceq cC cc wcel cA cc wcel cA cc0 wne cC cA cdiv co
    cC c1 cA cdiv co cmul co wceq cA cr wcel cC cA divrec cA recn syl3an2 3expb
    3adant2 breq12d 3coml cC recn syl3an3 adantr bitr4d ex 3com12 3exp imp4a
    3imp cB cr wcel cc0 cB clt wbr wa cB cr wcel cB cc0 wne cB cr wcel cc0 cB
    clt wbr pm3.26 cB gt0ne0 jca syl3an2 cA cr wcel cc0 cA clt wbr wa cA cr
    wcel cA cc0 wne cA cr wcel cc0 cA clt wbr pm3.26 cA gt0ne0 jca syl3an1
    bitrd sylbi $.
    $( [26-Jul-2006] $) $( [27-Apr-2005] $)

  $( Reciprocal swap in a 'less than' relation. $)
  ltrec1 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( ( 1 / A ) < B <-> ( 1 / B ) < A ) ) $=
    cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa c1 cA cdiv co
    cB clt wbr c1 cB cdiv co c1 c1 cA cdiv co cdiv co clt wbr c1 cB cdiv co cA
    clt wbr c1 cA cdiv co cr wcel cc0 c1 cA cdiv co clt wbr wa cB cr wcel cc0
    cB clt wbr wa c1 cA cdiv co cB clt wbr c1 cB cdiv co c1 c1 cA cdiv co cdiv
    co clt wbr wb cA cr wcel cc0 cA clt wbr wa c1 cA cdiv co cB ltrec cA cr
    wcel cc0 cA clt wbr wa c1 cA cdiv co cr wcel cc0 c1 cA cdiv co clt wbr cA
    cr wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA
    rereccl syldan cA recgt0 jca sylan cA cr wcel cc0 cA clt wbr wa cB cr wcel
    cc0 cB clt wbr wa wa c1 c1 cA cdiv co cdiv co cA c1 cB cdiv co clt cA cr
    wcel cc0 cA clt wbr wa c1 c1 cA cdiv co cdiv co cA wceq cB cr wcel cc0 cB
    clt wbr wa cA cr wcel cc0 cA clt wbr cA cc0 wne c1 c1 cA cdiv co cdiv co cA
    wceq cA gt0ne0 cA cc wcel cA cc0 wne c1 c1 cA cdiv co cdiv co cA wceq cA cr
    wcel cA recrec cA recn sylan syldan adantr breq2d bitrd $.
    $( [16-Jun-2007] $) $( [24-Feb-2005] $)

  $( Reciprocal swap in a 'less than or equal to' relation. $)
  lerec2 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( A <_ ( 1 / B ) <-> B <_ ( 1 / A ) ) ) $=
    cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa cA c1 cB cdiv
    co cle wbr c1 c1 cB cdiv co cdiv co c1 cA cdiv co cle wbr cB c1 cA cdiv co
    cle wbr cA cr wcel cc0 cA clt wbr wa c1 cB cdiv co cr wcel cc0 c1 cB cdiv
    co clt wbr wa cA c1 cB cdiv co cle wbr c1 c1 cB cdiv co cdiv co c1 cA cdiv
    co cle wbr wb cB cr wcel cc0 cB clt wbr wa cA c1 cB cdiv co lerec cB cr
    wcel cc0 cB clt wbr wa c1 cB cdiv co cr wcel cc0 c1 cB cdiv co clt wbr cB
    cr wcel cc0 cB clt wbr cB cc0 wne c1 cB cdiv co cr wcel cB gt0ne0 cB
    rereccl syldan cB recgt0 jca sylan2 cA cr wcel cc0 cA clt wbr wa cB cr wcel
    cc0 cB clt wbr wa wa c1 c1 cB cdiv co cdiv co cB c1 cA cdiv co cle cB cr
    wcel cc0 cB clt wbr wa c1 c1 cB cdiv co cdiv co cB wceq cA cr wcel cc0 cA
    clt wbr wa cB cr wcel cc0 cB clt wbr cB cc0 wne c1 c1 cB cdiv co cdiv co cB
    wceq cB gt0ne0 cB cc wcel cB cc0 wne c1 c1 cB cdiv co cdiv co cB wceq cB cr
    wcel cB recrec cB recn sylan syldan adantl breq1d bitrd $.
    $( [15-Jun-2007] $) $( [24-Feb-2005] $)

  $( Invert ratios of positive numbers and swap their ordering. $)
  ledivdiv $p |- ( ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) /\
                      ( ( C e. RR /\ 0 < C ) /\ ( D e. RR /\ 0 < D ) ) ) ->
                  ( ( A / B ) <_ ( C / D ) <-> ( D / C ) <_ ( B / A ) ) ) $=
    cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa cC cr wcel cc0
    cC clt wbr wa cD cr wcel cc0 cD clt wbr wa wa wa cA cB cdiv co cC cD cdiv
    co cle wbr c1 cC cD cdiv co cdiv co c1 cA cB cdiv co cdiv co cle wbr cD cC
    cdiv co cB cA cdiv co cle wbr cA cB cdiv co cr wcel cc0 cA cB cdiv co clt
    wbr wa cC cD cdiv co cr wcel cc0 cC cD cdiv co clt wbr wa cA cB cdiv co cC
    cD cdiv co cle wbr c1 cC cD cdiv co cdiv co c1 cA cB cdiv co cdiv co cle
    wbr wb cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa cC cr
    wcel cc0 cC clt wbr wa cD cr wcel cc0 cD clt wbr wa wa cA cB cdiv co cC cD
    cdiv co lerec cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa
    cA cB cdiv co cr wcel cc0 cA cB cdiv co clt wbr cA cr wcel cB cr wcel cc0
    cB clt wbr wa cA cB cdiv co cr wcel cc0 cA clt wbr cA cr wcel cB cr wcel cB
    cc0 wne wa cA cB cdiv co cr wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cB
    cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cB redivcl 3expb cB cr wcel cc0
    cB clt wbr wa cB cr wcel cB cc0 wne cB cr wcel cc0 cB clt wbr pm3.26 cB
    gt0ne0 jca sylan2 adantlr cA cB divgt0 jca cC cr wcel cc0 cC clt wbr wa cD
    cr wcel cc0 cD clt wbr wa wa cC cD cdiv co cr wcel cc0 cC cD cdiv co clt
    wbr cC cr wcel cD cr wcel cc0 cD clt wbr wa cC cD cdiv co cr wcel cc0 cC
    clt wbr cC cr wcel cD cr wcel cD cc0 wne wa cC cD cdiv co cr wcel cD cr
    wcel cc0 cD clt wbr wa cC cr wcel cD cr wcel cD cc0 wne cC cD cdiv co cr
    wcel cC cD redivcl 3expb cD cr wcel cc0 cD clt wbr wa cD cr wcel cD cc0 wne
    cD cr wcel cc0 cD clt wbr pm3.26 cD gt0ne0 jca sylan2 adantlr cC cD divgt0
    jca syl2an cC cr wcel cc0 cC clt wbr wa cD cr wcel cc0 cD clt wbr wa wa cA
    cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa c1 cC cD cdiv co
    cdiv co cD cC cdiv co c1 cA cB cdiv co cdiv co cB cA cdiv co cle cC cc wcel
    cC cc0 wne wa cD cc wcel cD cc0 wne wa c1 cC cD cdiv co cdiv co cD cC cdiv
    co wceq cC cr wcel cc0 cC clt wbr wa cD cr wcel cc0 cD clt wbr wa cC cD
    recdiv cC cr wcel cc0 cC clt wbr wa cC cc wcel cC cc0 wne cC cr wcel cC cc
    wcel cc0 cC clt wbr cC recn adantr cC gt0ne0 jca cD cr wcel cc0 cD clt wbr
    wa cD cc wcel cD cc0 wne cD cr wcel cD cc wcel cc0 cD clt wbr cD recn
    adantr cD gt0ne0 jca syl2an cA cc wcel cA cc0 wne wa cB cc wcel cB cc0 wne
    wa c1 cA cB cdiv co cdiv co cB cA cdiv co wceq cA cr wcel cc0 cA clt wbr wa
    cB cr wcel cc0 cB clt wbr wa cA cB recdiv cA cr wcel cc0 cA clt wbr wa cA
    cc wcel cA cc0 wne cA cr wcel cA cc wcel cc0 cA clt wbr cA recn adantr cA
    gt0ne0 jca cB cr wcel cc0 cB clt wbr wa cB cc wcel cB cc0 wne cB cr wcel cB
    cc wcel cc0 cB clt wbr cB recn adantr cB gt0ne0 jca syl2an breqan12rd bitrd
    $.
    $( [22-May-2006] $) $( [9-Jan-2006] $)

  $( Division of a positive number by both sides of 'less than or equal to'. $)
  lediv2 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
       ( C e. RR /\ 0 < C ) ) -> ( A <_ B <-> ( C / B ) <_ ( C / A ) ) ) $=
    cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC
    clt wbr wa w3a c1 cB cdiv co c1 cA cdiv co cle wbr cC c1 cB cdiv co cmul co
    cC c1 cA cdiv co cmul co cle wbr cA cB cle wbr cC cB cdiv co cC cA cdiv co
    cle wbr c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel cC cr wcel w3a cc0 cC
    clt wbr c1 cB cdiv co c1 cA cdiv co cle wbr cC c1 cB cdiv co cmul co cC c1
    cA cdiv co cmul co cle wbr wb cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0
    cB clt wbr wa cC cr wcel cc0 cC clt wbr wa w3a c1 cB cdiv co c1 cA cdiv co
    cC lemul2OLD cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC
    cr wcel cc0 cC clt wbr wa w3a c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel
    cC cr wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cc0 cA clt wbr wa c1 cB
    cdiv co cr wcel cC cr wcel cc0 cC clt wbr wa cB cr wcel cc0 cB clt wbr cB
    cc0 wne c1 cB cdiv co cr wcel cB gt0ne0 cB rereccl syldan 3ad2ant2 cA cr
    wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa c1 cA cdiv co cr wcel
    cC cr wcel cc0 cC clt wbr wa cA cr wcel cc0 cA clt wbr cA cc0 wne c1 cA
    cdiv co cr wcel cA gt0ne0 cA rereccl syldan 3ad2ant1 cC cr wcel cc0 cC clt
    wbr wa cA cr wcel cc0 cA clt wbr wa cC cr wcel cB cr wcel cc0 cB clt wbr wa
    cC cr wcel cc0 cC clt wbr pm3.26 3ad2ant3 3jca cC cr wcel cc0 cC clt wbr wa
    cA cr wcel cc0 cA clt wbr wa cc0 cC clt wbr cB cr wcel cc0 cB clt wbr wa cC
    cr wcel cc0 cC clt wbr pm3.27 3ad2ant3 sylanc cA cr wcel cc0 cA clt wbr wa
    cB cr wcel cc0 cB clt wbr wa cA cB cle wbr c1 cB cdiv co c1 cA cdiv co cle
    wbr wb cC cr wcel cc0 cC clt wbr wa cA cB lerec 3adant3 cA cr wcel cc0 cA
    clt wbr wa cB cr wcel cc0 cB clt wbr wa cC cr wcel cC cB cdiv co cC cA cdiv
    co cle wbr cC c1 cB cdiv co cmul co cC c1 cA cdiv co cmul co cle wbr wb cc0
    cC clt wbr cC cr wcel cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt
    wbr wa cC cB cdiv co cC cA cdiv co cle wbr cC c1 cB cdiv co cmul co cC c1
    cA cdiv co cmul co cle wbr wb cC cr wcel cA cr wcel cc0 cA clt wbr wa cB cr
    wcel cc0 cB clt wbr wa w3a cC cB cdiv co cC c1 cB cdiv co cmul co cC cA
    cdiv co cC c1 cA cdiv co cmul co cle cC cr wcel cB cr wcel cc0 cB clt wbr
    wa cC cB cdiv co cC c1 cB cdiv co cmul co wceq cA cr wcel cc0 cA clt wbr wa
    cC cc wcel cB cc wcel cB cc0 wne wa cC cB cdiv co cC c1 cB cdiv co cmul co
    wceq cC cr wcel cB cr wcel cc0 cB clt wbr wa cC cc wcel cB cc wcel cB cc0
    wne cC cB cdiv co cC c1 cB cdiv co cmul co wceq cC cB divrec 3expb cC recn
    cB cr wcel cc0 cB clt wbr wa cB cc wcel cB cc0 wne cB cr wcel cB cc wcel
    cc0 cB clt wbr cB recn adantr cB gt0ne0 jca syl2an 3adant2 cC cr wcel cA cr
    wcel cc0 cA clt wbr wa cC cA cdiv co cC c1 cA cdiv co cmul co wceq cB cr
    wcel cc0 cB clt wbr wa cC cc wcel cA cc wcel cA cc0 wne wa cC cA cdiv co cC
    c1 cA cdiv co cmul co wceq cC cr wcel cA cr wcel cc0 cA clt wbr wa cC cc
    wcel cA cc wcel cA cc0 wne cC cA cdiv co cC c1 cA cdiv co cmul co wceq cC
    cA divrec 3expb cC recn cA cr wcel cc0 cA clt wbr wa cA cc wcel cA cc0 wne
    cA cr wcel cA cc wcel cc0 cA clt wbr cA recn adantr cA gt0ne0 jca syl2an
    3adant3 breq12d 3coml 3adant3r 3bitr4d $.
    $( [7-Feb-2006] $) $( [10-Jan-2006] $)

  $( Swap denominator with other side of 'less than'. $)
  ltdiv23 $p |- ( ( A e. RR /\ ( B e. RR /\ 0 < B ) /\ ( C e. RR /\ 0 < C ) )
              -> ( ( A / B ) < C <-> ( A / C ) < B ) ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC clt wbr wa w3a cA
    cB cdiv co cC clt wbr cA cB cdiv co cB cmul co cC cB cmul co clt wbr cA cC
    cB cmul co clt wbr cA cC cdiv co cB clt wbr cA cr wcel cB cr wcel cc0 cB
    clt wbr wa cC cr wcel cA cB cdiv co cC clt wbr cA cB cdiv co cB cmul co cC
    cB cmul co clt wbr wb cc0 cC clt wbr cA cB cdiv co cr wcel cC cr wcel cB cr
    wcel cc0 cB clt wbr wa cA cB cdiv co cC clt wbr cA cB cdiv co cB cmul co cC
    cB cmul co clt wbr wb cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel
    w3a cA cB cdiv co cC cB ltmul1 cA cr wcel cB cr wcel cc0 cB clt wbr wa cA
    cB cdiv co cr wcel cC cr wcel cA cr wcel cB cr wcel cB cc0 wne wa cA cB
    cdiv co cr wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cB cr wcel cB cc0
    wne cA cB cdiv co cr wcel cA cB redivcl 3expb cB cr wcel cc0 cB clt wbr wa
    cB cr wcel cB cc0 wne cB cr wcel cc0 cB clt wbr pm3.26 cB gt0ne0 jca sylan2
    3adant3 cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel 3simp3 cA cr
    wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel 3simp2 syl3anc 3adant3r cA cr
    wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC clt wbr wa w3a cA cB
    cdiv co cB cmul co cA cC cB cmul co clt cA cr wcel cB cr wcel cc0 cB clt
    wbr wa cA cB cdiv co cB cmul co cA wceq cC cr wcel cc0 cC clt wbr wa cA cc
    wcel cB cc wcel cB cc0 wne cA cB cdiv co cB cmul co cA wceq cA cr wcel cB
    cr wcel cc0 cB clt wbr wa wa cA cB divcan1 cA cr wcel cA cc wcel cB cr wcel
    cc0 cB clt wbr wa cA recn adantr cB cr wcel cB cc wcel cA cr wcel cc0 cB
    clt wbr cB recn ad2antrl cB cr wcel cc0 cB clt wbr wa cB cc0 wne cA cr wcel
    cB gt0ne0 adantl syl3anc 3adant3 breq1d cA cr wcel cB cr wcel cC cr wcel
    cc0 cC clt wbr wa cA cC cB cmul co clt wbr cA cC cdiv co cB clt wbr wb cc0
    cB clt wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cB
    cmul co clt wbr cA cC cdiv co cC cB cmul co cC cdiv co clt wbr cA cC cdiv
    co cB clt wbr cA cr wcel cC cB cmul co cr wcel cC cr wcel cc0 cC clt wbr wa
    cA cC cB cmul co clt wbr cA cC cdiv co cC cB cmul co cC cdiv co clt wbr wb
    cB cr wcel cA cC cB cmul co cC ltdiv1 cB cr wcel cC cr wcel cc0 cC clt wbr
    wa cC cB cmul co cr wcel cA cr wcel cB cr wcel cC cr wcel cC cB cmul co cr
    wcel cc0 cC clt wbr cC cr wcel cB cr wcel cC cB cmul co cr wcel cC cB
    axmulrcl ancoms adantrr 3adant1 syld3an2 cA cr wcel cB cr wcel cC cr wcel
    cc0 cC clt wbr wa w3a cC cB cmul co cC cdiv co cB cA cC cdiv co clt cB cr
    wcel cC cr wcel cc0 cC clt wbr wa cC cB cmul co cC cdiv co cB wceq cA cr
    wcel cB cc wcel cC cc wcel cC cc0 wne wa cC cB cmul co cC cdiv co cB wceq
    cB cr wcel cC cr wcel cc0 cC clt wbr wa cB cc wcel cC cc wcel cC cc0 wne cC
    cB cmul co cC cdiv co cB wceq cB cC divcan3 3expb cB recn cC cr wcel cc0 cC
    clt wbr wa cC cc wcel cC cc0 wne cC cr wcel cC cc wcel cc0 cC clt wbr cC
    recn adantr cC gt0ne0 jca syl2an 3adant1 breq2d bitrd 3adant2r 3bitrd $.
    $( [1-Mar-2009] $) $( [3-Oct-1999] $)

  $( Swap denominator with other side of 'less than or equal to'. $)
  lediv23 $p |- ( ( A e. RR /\ ( B e. RR /\ 0 < B ) /\ ( C e. RR /\ 0 < C ) )
              -> ( ( A / B ) <_ C <-> ( A / C ) <_ B ) ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC clt wbr wa w3a cA
    cB cdiv co cC cle wbr cA cB cdiv co cB cmul co cC cB cmul co cle wbr cA cC
    cB cmul co cle wbr cA cC cdiv co cB cle wbr cA cr wcel cB cr wcel cc0 cB
    clt wbr wa cC cr wcel cA cB cdiv co cC cle wbr cA cB cdiv co cB cmul co cC
    cB cmul co cle wbr wb cc0 cC clt wbr cA cB cdiv co cr wcel cC cr wcel cB cr
    wcel cc0 cB clt wbr wa cA cB cdiv co cC cle wbr cA cB cdiv co cB cmul co cC
    cB cmul co cle wbr wb cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel
    w3a cA cB cdiv co cC cB lemul1 cA cr wcel cB cr wcel cc0 cB clt wbr wa cA
    cB cdiv co cr wcel cC cr wcel cA cr wcel cB cr wcel cB cc0 wne wa cA cB
    cdiv co cr wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cB cr wcel cB cc0
    wne cA cB cdiv co cr wcel cA cB redivcl 3expb cB cr wcel cc0 cB clt wbr wa
    cB cr wcel cB cc0 wne cB cr wcel cc0 cB clt wbr pm3.26 cB gt0ne0 jca sylan2
    3adant3 cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel 3simp3 cA cr
    wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel 3simp2 syl3anc 3adant3r cA cr
    wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC clt wbr wa w3a cA cB
    cdiv co cB cmul co cA cC cB cmul co cle cA cr wcel cB cr wcel cc0 cB clt
    wbr wa cA cB cdiv co cB cmul co cA wceq cC cr wcel cc0 cC clt wbr wa cA cc
    wcel cB cc wcel cB cc0 wne cA cB cdiv co cB cmul co cA wceq cA cr wcel cB
    cr wcel cc0 cB clt wbr wa wa cA cB divcan1 cA cr wcel cA cc wcel cB cr wcel
    cc0 cB clt wbr wa cA recn adantr cB cr wcel cB cc wcel cA cr wcel cc0 cB
    clt wbr cB recn ad2antrl cB cr wcel cc0 cB clt wbr wa cB cc0 wne cA cr wcel
    cB gt0ne0 adantl syl3anc 3adant3 breq1d cA cr wcel cB cr wcel cC cr wcel
    cc0 cC clt wbr wa cA cC cB cmul co cle wbr cA cC cdiv co cB cle wbr wb cc0
    cB clt wbr cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr wa w3a cA cC cB
    cmul co cle wbr cA cC cdiv co cC cB cmul co cC cdiv co cle wbr cA cC cdiv
    co cB cle wbr cA cr wcel cC cB cmul co cr wcel cC cr wcel cc0 cC clt wbr wa
    cA cC cB cmul co cle wbr cA cC cdiv co cC cB cmul co cC cdiv co cle wbr wb
    cB cr wcel cA cC cB cmul co cC lediv1 cB cr wcel cC cr wcel cc0 cC clt wbr
    wa cC cB cmul co cr wcel cA cr wcel cB cr wcel cC cr wcel cC cB cmul co cr
    wcel cc0 cC clt wbr cC cr wcel cB cr wcel cC cB cmul co cr wcel cC cB
    axmulrcl ancoms adantrr 3adant1 syld3an2 cA cr wcel cB cr wcel cC cr wcel
    cc0 cC clt wbr wa w3a cC cB cmul co cC cdiv co cB cA cC cdiv co cle cB cr
    wcel cC cr wcel cc0 cC clt wbr wa cC cB cmul co cC cdiv co cB wceq cA cr
    wcel cB cc wcel cC cc wcel cC cc0 wne wa cC cB cmul co cC cdiv co cB wceq
    cB cr wcel cC cr wcel cc0 cC clt wbr wa cB cc wcel cC cc wcel cC cc0 wne cC
    cB cmul co cC cdiv co cB wceq cB cC divcan3 3expb cB recn cC cr wcel cc0 cC
    clt wbr wa cC cc wcel cC cc0 wne cC cr wcel cC cc wcel cc0 cC clt wbr cC
    recn adantr cC gt0ne0 jca syl2an 3adant1 breq2d bitrd 3adant2r 3bitrd $.
    $( [11-Mar-2009] $) $( [30-May-2005] $)

  ${
    ltdiv23.1 $e |- A e. RR $.
    ltdiv23.2 $e |- B e. RR $.
    ltdiv23.3 $e |- C e. RR $.
    $( Swap denominator with other side of 'less than'. $)
    ltdiv23i $p |- ( ( 0 < B /\ 0 < C ) ->
                ( ( A / B ) < C <-> ( A / C ) < B ) ) $=
      cc0 cB clt wbr cC cr wcel cc0 cC clt wbr cA cB cdiv co cC clt wbr cA cC
      cdiv co cB clt wbr wb ltdiv23.3 cB cr wcel cc0 cB clt wbr cC cr wcel cc0
      cC clt wbr wa cA cB cdiv co cC clt wbr cA cC cdiv co cB clt wbr wb
      ltdiv23.2 cA cr wcel cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC clt
      wbr wa cA cB cdiv co cC clt wbr cA cC cdiv co cB clt wbr wb ltdiv23.1 cA
      cB cC ltdiv23 mp3an1 mpanl1 mpanr1 $.
      $( [26-Sep-1999] $)

    ${
      ltdiv23i.4 $e |- 0 < B $.
      ltdiv23i.5 $e |- 0 < C $.
      $( Swap denominator with other side of 'less than'. $)
      ltdiv23ii $p |- ( ( A / B ) < C <-> ( A / C ) < B ) $=
        cc0 cB clt wbr cc0 cC clt wbr cA cB cdiv co cC clt wbr cA cC cdiv co cB
        clt wbr wb ltdiv23i.4 ltdiv23i.5 cA cB cC ltdiv23.1 ltdiv23.2 ltdiv23.3
        ltdiv23i mp2an $.
        $( [26-Sep-1999] $)
    $}
  $}

  $( Comparison of ratio of two nonnegative numbers. $)
  lediv12a $p |- ( ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ A <_ B ) ) /\
               ( ( C e. RR /\ D e. RR ) /\ ( 0 < C /\ C <_ D ) ) ) ->
                 ( A / D ) <_ ( B / C ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa cC cr wcel cD
    cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa wa cA c1 cD cdiv co cmul co
    cB c1 cC cdiv co cmul co cA cD cdiv co cB cC cdiv co cle cA cr wcel cB cr
    wcel wa cc0 cA cle wbr cA cB cle wbr wa wa c1 cD cdiv co cr wcel c1 cC cdiv
    co cr wcel wa cc0 c1 cD cdiv co cle wbr c1 cD cdiv co c1 cC cdiv co cle wbr
    wa wa cA c1 cD cdiv co cmul co cB c1 cC cdiv co cmul co cle wbr cC cr wcel
    cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cA cB c1 cD cdiv co c1 cC
    cdiv co lemul12aOLD cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr
    wa wa c1 cD cdiv co cr wcel c1 cC cdiv co cr wcel cc0 c1 cD cdiv co cle wbr
    c1 cD cdiv co c1 cC cdiv co cle wbr wa cD cr wcel cD cc0 wne c1 cD cdiv co
    cr wcel cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cD
    rereccl cC cr wcel cD cr wcel cc0 cC clt wbr cC cD cle wbr wa simplr cD cr
    wcel cc0 cD clt wbr cD cc0 wne cC cr wcel cD cr wcel wa cc0 cC clt wbr cC
    cD cle wbr wa wa cD gt0ne0 cC cr wcel cD cr wcel cc0 cC clt wbr cC cD cle
    wbr wa simplr cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa cc0
    cD clt wbr cc0 cr wcel cC cr wcel cD cr wcel cc0 cC clt wbr cC cD cle wbr
    wa cc0 cD clt wbr wi 0re cc0 cC cD ltletr mp3an1 imp sylanc sylanc cC cr
    wcel cc0 cC clt wbr c1 cC cdiv co cr wcel cD cr wcel cC cD cle wbr cC cr
    wcel cc0 cC clt wbr cC cc0 wne c1 cC cdiv co cr wcel cC gt0ne0 cC rereccl
    syldan ad2ant2r cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa
    cc0 c1 cD cdiv co cle wbr c1 cD cdiv co c1 cC cdiv co cle wbr cC cr wcel cD
    cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cc0 c1 cD cdiv co clt wbr cc0
    c1 cD cdiv co cle wbr cD cr wcel cc0 cD clt wbr cc0 c1 cD cdiv co clt wbr
    cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cD recgt0 cC cr
    wcel cD cr wcel cc0 cC clt wbr cC cD cle wbr wa simplr cC cr wcel cD cr
    wcel wa cc0 cC clt wbr cC cD cle wbr wa cc0 cD clt wbr cc0 cr wcel cC cr
    wcel cD cr wcel cc0 cC clt wbr cC cD cle wbr wa cc0 cD clt wbr wi 0re cc0
    cC cD ltletr mp3an1 imp sylanc cc0 cr wcel c1 cD cdiv co cr wcel cc0 c1 cD
    cdiv co clt wbr cc0 c1 cD cdiv co cle wbr wi cC cr wcel cD cr wcel wa cc0
    cC clt wbr cC cD cle wbr wa wa cc0 c1 cD cdiv co ltle 0re cD cr wcel cD cc0
    wne c1 cD cdiv co cr wcel cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle
    wbr wa wa cD rereccl cC cr wcel cD cr wcel cc0 cC clt wbr cC cD cle wbr wa
    simplr cD cr wcel cc0 cD clt wbr cD cc0 wne cC cr wcel cD cr wcel wa cc0 cC
    clt wbr cC cD cle wbr wa wa cD gt0ne0 cC cr wcel cD cr wcel cc0 cC clt wbr
    cC cD cle wbr wa simplr cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle
    wbr wa cc0 cD clt wbr cc0 cr wcel cC cr wcel cD cr wcel cc0 cC clt wbr cC
    cD cle wbr wa cc0 cD clt wbr wi 0re cc0 cC cD ltletr mp3an1 imp sylanc
    sylanc sylancr mpd cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa
    wa cC cD cle wbr c1 cD cdiv co c1 cC cdiv co cle wbr cC cr wcel cD cr wcel
    wa cc0 cC clt wbr cC cD cle wbr simprr cC cr wcel cc0 cC clt wbr wa cD cr
    wcel cc0 cD clt wbr wa cC cD cle wbr c1 cD cdiv co c1 cC cdiv co cle wbr wb
    cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cC cD lerec cC
    cr wcel cc0 cC clt wbr cC cr wcel cc0 cC clt wbr wa cD cr wcel cC cD cle
    wbr cC cr wcel cc0 cC clt wbr wa id ad2ant2r cC cr wcel cD cr wcel wa cc0
    cC clt wbr cC cD cle wbr wa wa cD cr wcel cc0 cD clt wbr cC cr wcel cD cr
    wcel cc0 cC clt wbr cC cD cle wbr wa simplr cC cr wcel cD cr wcel wa cc0 cC
    clt wbr cC cD cle wbr wa cc0 cD clt wbr cc0 cr wcel cC cr wcel cD cr wcel
    cc0 cC clt wbr cC cD cle wbr wa cc0 cD clt wbr wi 0re cc0 cC cD ltletr
    mp3an1 imp jca sylanc mpbid jca jca31 sylan2 cA cr wcel cB cr wcel wa cC cr
    wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cA cD cdiv co cA c1
    cD cdiv co cmul co wceq cc0 cA cle wbr cA cB cle wbr wa cA cr wcel cC cr
    wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cA cD cdiv co cA c1
    cD cdiv co cmul co wceq cB cr wcel cA cc wcel cD cc wcel cD cc0 wne cA cD
    cdiv co cA c1 cD cdiv co cmul co wceq cA cr wcel cC cr wcel cD cr wcel wa
    cc0 cC clt wbr cC cD cle wbr wa wa wa cA cD divrec cA cr wcel cA cc wcel cC
    cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cA recn adantr cC
    cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cD cc wcel cA cr
    wcel cD cr wcel cD cc wcel cC cr wcel cc0 cC clt wbr cC cD cle wbr wa cD
    recn ad2antlr adantl cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr
    wa wa cD cc0 wne cA cr wcel cD cr wcel cc0 cD clt wbr cD cc0 wne cC cr wcel
    cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cD gt0ne0 cC cr wcel cD cr
    wcel cc0 cC clt wbr cC cD cle wbr wa simplr cC cr wcel cD cr wcel wa cc0 cC
    clt wbr cC cD cle wbr wa cc0 cD clt wbr cc0 cr wcel cC cr wcel cD cr wcel
    cc0 cC clt wbr cC cD cle wbr wa cc0 cD clt wbr wi 0re cc0 cC cD ltletr
    mp3an1 imp sylanc adantl syl3anc adantlr adantlr cA cr wcel cB cr wcel wa
    cC cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cB cC cdiv co
    cB c1 cC cdiv co cmul co wceq cc0 cA cle wbr cA cB cle wbr wa cB cr wcel cC
    cr wcel cD cr wcel wa cc0 cC clt wbr cC cD cle wbr wa wa cB cC cdiv co cB
    c1 cC cdiv co cmul co wceq cA cr wcel cB cr wcel cC cr wcel cc0 cC clt wbr
    cC cD cle wbr wa cB cC cdiv co cB c1 cC cdiv co cmul co wceq cD cr wcel cB
    cr wcel cC cr wcel cc0 cC clt wbr cB cC cdiv co cB c1 cC cdiv co cmul co
    wceq cC cD cle wbr cB cc wcel cC cc wcel cC cc0 wne cB cC cdiv co cB c1 cC
    cdiv co cmul co wceq cB cr wcel cC cr wcel cc0 cC clt wbr wa wa cB cC
    divrec cB cr wcel cB cc wcel cC cr wcel cc0 cC clt wbr wa cB recn adantr cC
    cr wcel cC cc wcel cB cr wcel cc0 cC clt wbr cC recn ad2antrl cC cr wcel
    cc0 cC clt wbr wa cC cc0 wne cB cr wcel cC gt0ne0 adantl syl3anc adantrrr
    adantrlr adantll adantlr 3brtr4d $.
    $( [15-Feb-2006] $) $( [31-Dec-2005] $)

  $( Division of both sides of 'less than or equal to' into a nonnegative
     number.  (Contributed by Paul Chapman, 7-Sep-2007.) $)
  lediv2a $p |- ( ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
                     ( C e. RR /\ 0 <_ C ) ) /\
                   A <_ B ) -> ( C / B ) <_ ( C / A ) ) $=
    cC cr wcel cC cr wcel wa cc0 cC cle wbr cC cC cle wbr wa wa cA cr wcel cB
    cr wcel wa cc0 cA clt wbr cA cB cle wbr wa wa cC cB cdiv co cC cA cdiv co
    cle wbr cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC cr
    wcel cc0 cC cle wbr wa w3a cA cB cle wbr wa cC cC cA cB lediv12a cA cr wcel
    cc0 cA clt wbr wa cC cr wcel cc0 cC cle wbr wa cA cB cle wbr cC cr wcel cC
    cr wcel wa cc0 cC cle wbr cC cC cle wbr wa wa cB cr wcel cc0 cB clt wbr wa
    cC cr wcel cc0 cC cle wbr wa cC cr wcel cC cr wcel wa cc0 cC cle wbr cC cC
    cle wbr wa wa cA cr wcel cc0 cA clt wbr wa cA cB cle wbr cC cr wcel cc0 cC
    cle wbr wa cC cr wcel cC cr wcel wa cc0 cC cle wbr cC cC cle wbr wa cC cr
    wcel cC cr wcel cC cr wcel wa cc0 cC cle wbr cC cr wcel cC cr wcel cC cr
    wcel wa cC cr wcel cC cr wcel pm3.2 pm2.43i adantr cc0 cC cle wbr cC cr
    wcel cc0 cC cle wbr cC cC cle wbr wa cC cr wcel cC cC cle wbr cc0 cC cle
    wbr cC leid anim2i ancoms jca ad2antlr 3adantl2 cA cr wcel cc0 cA clt wbr
    wa cB cr wcel cc0 cB clt wbr wa cA cB cle wbr cA cr wcel cB cr wcel wa cc0
    cA clt wbr cA cB cle wbr wa wa cC cr wcel cc0 cC cle wbr wa cA cr wcel cc0
    cA clt wbr wa cB cr wcel cc0 cB clt wbr wa wa cA cB cle wbr wa cA cr wcel
    cB cr wcel wa cc0 cA clt wbr cA cB cle wbr wa cA cr wcel cc0 cA clt wbr wa
    cB cr wcel cc0 cB clt wbr wa wa cA cr wcel cB cr wcel wa cA cB cle wbr cA
    cr wcel cB cr wcel cA cr wcel cB cr wcel wa cc0 cA clt wbr cc0 cB clt wbr
    cA cr wcel cB cr wcel wa id ad2ant2r adantr cA cr wcel cc0 cA clt wbr wa cB
    cr wcel cc0 cB clt wbr wa wa cc0 cA clt wbr cA cB cle wbr cA cr wcel cc0 cA
    clt wbr cB cr wcel cc0 cB clt wbr wa simplr anim1i jca 3adantl3 sylanc $.
    $( [8-Sep-2007] $) $( [7-Sep-2007] $)

  $( The reciprocal of a positive number less than 1 is greater than 1. $)
  reclt1 $p |- ( ( A e. RR /\ 0 < A ) -> ( A < 1 <-> 1 < ( 1 / A ) ) ) $=
    cA cr wcel cc0 cA clt wbr wa cA c1 clt wbr c1 c1 cdiv co c1 cA cdiv co clt
    wbr c1 c1 cA cdiv co clt wbr cA cr wcel cc0 cA clt wbr wa c1 cr wcel cc0 c1
    clt wbr cA c1 clt wbr c1 c1 cdiv co c1 cA cdiv co clt wbr wb 1re lt01 cA c1
    ltrec mpanr12 c1 c1 cdiv co c1 c1 cA cdiv co clt c1 ax1cn div1i breq1i
    syl6bb $.
    $( [26-Jul-2006] $) $( [23-Feb-2005] $)

  $( The reciprocal of a positive number greater than 1 is less than 1. $)
  recgt1 $p |- ( ( A e. RR /\ 0 < A ) -> ( 1 < A <-> ( 1 / A ) < 1 ) ) $=
    cA cr wcel cc0 cA clt wbr wa c1 cA clt wbr c1 cA cdiv co c1 c1 cdiv co clt
    wbr c1 cA cdiv co c1 clt wbr c1 cr wcel cc0 c1 clt wbr cA cr wcel cc0 cA
    clt wbr wa c1 cA clt wbr c1 cA cdiv co c1 c1 cdiv co clt wbr wb 1re lt01 c1
    cA ltrec mpanl12 c1 c1 cdiv co c1 c1 cA cdiv co clt c1 ax1cn div1i breq2i
    syl6bb $.
    $( [26-Jul-2006] $) $( [28-Dec-2005] $)

  $( The reciprocal of a number greater than 1 is positive and less than 1. $)
  recgt1i $p |- ( ( A e. RR /\ 1 < A ) ->
               ( 0 < ( 1 / A ) /\ ( 1 / A ) < 1 ) ) $=
    cA cr wcel c1 cA clt wbr wa cc0 c1 cA cdiv co clt wbr c1 cA cdiv co c1 clt
    wbr cA cr wcel c1 cA clt wbr wa cA cr wcel cc0 cA clt wbr wa cc0 c1 cA cdiv
    co clt wbr cA cr wcel c1 cA clt wbr cc0 cA clt wbr cA cr wcel cc0 c1 clt
    wbr c1 cA clt wbr cc0 cA clt wbr lt01 cc0 cr wcel c1 cr wcel cA cr wcel cc0
    c1 clt wbr c1 cA clt wbr wa cc0 cA clt wbr wi 0re 1re cc0 c1 cA axlttrn
    mp3an12 mpani imdistani cA recgt0 syl cA cr wcel c1 cA clt wbr cA cr wcel
    cc0 cA clt wbr wa c1 cA cdiv co c1 clt wbr cA cr wcel c1 cA clt wbr cc0 cA
    clt wbr cA cr wcel cc0 c1 clt wbr c1 cA clt wbr cc0 cA clt wbr lt01 cc0 cr
    wcel c1 cr wcel cA cr wcel cc0 c1 clt wbr c1 cA clt wbr wa cc0 cA clt wbr
    wi 0re 1re cc0 c1 cA axlttrn mp3an12 mpani imdistani cA cr wcel cc0 cA clt
    wbr wa c1 cA clt wbr c1 cA cdiv co c1 clt wbr cA recgt1 biimpa sylancom jca
    $.
    $( [4-May-2005] $) $( [23-Feb-2005] $)

  $( Construct a number less than 1 from any nonnegative number. $)
  recp1lt1 $p |- ( ( A e. RR /\ 0 <_ A ) -> ( A / ( 1 + A ) ) < 1 ) $=
    cA cr wcel cc0 cA cle wbr wa cA c1 cA caddc co cdiv co c1 clt wbr cA c1 cA
    caddc co cdiv co c1 cA caddc co cmul co c1 c1 cA caddc co cmul co clt wbr
    cA cr wcel cc0 cA cle wbr wa cA c1 cA caddc co cA c1 cA caddc co cdiv co c1
    cA caddc co cmul co c1 c1 cA caddc co cmul co clt cA cr wcel cA c1 cA caddc
    co clt wbr cc0 cA cle wbr cA cr wcel cA cA c1 caddc co c1 cA caddc co clt
    cA ltp1 cA cc wcel c1 cc wcel cA c1 caddc co c1 cA caddc co wceq cA cr wcel
    cA c1 addcom cA recn ax1cn sylancl breqtrd adantr cA cc wcel c1 cA caddc co
    cc wcel c1 cA caddc co cc0 wne cA c1 cA caddc co cdiv co c1 cA caddc co
    cmul co cA wceq cA cr wcel cc0 cA cle wbr wa cA c1 cA caddc co divcan1 cA
    cr wcel cA cc wcel cc0 cA cle wbr cA recn adantr cA cr wcel cc0 cA cle wbr
    wa c1 cA caddc co cA cr wcel c1 cA caddc co cr wcel cc0 cA cle wbr c1 cr
    wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA readdcl mpan adantr recnd
    c1 cA caddc co cr wcel cc0 c1 cA caddc co clt wbr c1 cA caddc co cc0 wne cA
    cr wcel cc0 cA cle wbr wa c1 cA caddc co gt0ne0 cA cr wcel c1 cA caddc co
    cr wcel cc0 cA cle wbr c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1
    cA readdcl mpan adantr c1 cr wcel cA cr wcel cc0 cA cle wbr cc0 c1 cA caddc
    co clt wbr 1re c1 cr wcel cA cr wcel wa cc0 c1 clt wbr cc0 cA cle wbr cc0
    c1 cA caddc co clt wbr lt01 c1 cA addgtge0 mpanr1 mpanl1 sylanc syl3anc cA
    cr wcel c1 c1 cA caddc co cmul co c1 cA caddc co wceq cc0 cA cle wbr cA cr
    wcel c1 cA caddc co cc wcel c1 c1 cA caddc co cmul co c1 cA caddc co wceq
    cA cr wcel c1 cA caddc co c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re
    c1 cA readdcl mpan recnd c1 cA caddc co mulid2 syl adantr 3brtr4d cA c1 cA
    caddc co cdiv co cr wcel c1 cA caddc co cr wcel cc0 c1 cA caddc co clt wbr
    wa cA c1 cA caddc co cdiv co c1 clt wbr cA c1 cA caddc co cdiv co c1 cA
    caddc co cmul co c1 c1 cA caddc co cmul co clt wbr wb cA cr wcel cc0 cA cle
    wbr wa cA c1 cA caddc co cdiv co cr wcel c1 cr wcel c1 cA caddc co cr wcel
    cc0 c1 cA caddc co clt wbr wa cA c1 cA caddc co cdiv co c1 clt wbr cA c1 cA
    caddc co cdiv co c1 cA caddc co cmul co c1 c1 cA caddc co cmul co clt wbr
    wb 1re cA c1 cA caddc co cdiv co c1 c1 cA caddc co ltmul1 mp3an2 cA cr wcel
    c1 cA caddc co cr wcel c1 cA caddc co cc0 wne cA c1 cA caddc co cdiv co cr
    wcel cA cr wcel cc0 cA cle wbr wa cA c1 cA caddc co redivcl cA cr wcel cc0
    cA cle wbr pm3.26 cA cr wcel c1 cA caddc co cr wcel cc0 cA cle wbr c1 cr
    wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA readdcl mpan adantr c1 cA
    caddc co cr wcel cc0 c1 cA caddc co clt wbr c1 cA caddc co cc0 wne cA cr
    wcel cc0 cA cle wbr wa c1 cA caddc co gt0ne0 cA cr wcel c1 cA caddc co cr
    wcel cc0 cA cle wbr c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA
    readdcl mpan adantr c1 cr wcel cA cr wcel cc0 cA cle wbr cc0 c1 cA caddc co
    clt wbr 1re c1 cr wcel cA cr wcel wa cc0 c1 clt wbr cc0 cA cle wbr cc0 c1
    cA caddc co clt wbr lt01 c1 cA addgtge0 mpanr1 mpanl1 sylanc syl3anc cA cr
    wcel cc0 cA cle wbr wa c1 cA caddc co cr wcel cc0 c1 cA caddc co clt wbr cA
    cr wcel c1 cA caddc co cr wcel cc0 cA cle wbr c1 cr wcel cA cr wcel c1 cA
    caddc co cr wcel 1re c1 cA readdcl mpan adantr c1 cr wcel cA cr wcel cc0 cA
    cle wbr cc0 c1 cA caddc co clt wbr 1re c1 cr wcel cA cr wcel wa cc0 c1 clt
    wbr cc0 cA cle wbr cc0 c1 cA caddc co clt wbr lt01 c1 cA addgtge0 mpanr1
    mpanl1 jca sylanc mpbird $.
    $( [10-Feb-2006] $) $( [30-Dec-2005] $)

  $( Given a positive number ` A ` , construct a new positive number less than
     both ` A ` and 1. $)
  recreclt $p |- ( ( A e. RR /\ 0 < A ) ->
        ( ( 1 / ( 1 + ( 1 / A ) ) ) < 1 /\ ( 1 / ( 1 + ( 1 / A ) ) ) < A ) ) $=
    cA cr wcel cc0 cA clt wbr wa c1 c1 c1 cA cdiv co caddc co cdiv co c1 clt
    wbr c1 c1 c1 cA cdiv co caddc co cdiv co cA clt wbr cA cr wcel cc0 cA clt
    wbr wa c1 c1 c1 cA cdiv co caddc co clt wbr c1 c1 c1 cA cdiv co caddc co
    cdiv co c1 clt wbr cA cr wcel cc0 cA clt wbr wa cc0 c1 cA cdiv co clt wbr
    c1 c1 c1 cA cdiv co caddc co clt wbr cA recgt0 c1 cA cdiv co cr wcel c1 cr
    wcel cc0 c1 cA cdiv co clt wbr c1 c1 c1 cA cdiv co caddc co clt wbr wb cA
    cr wcel cc0 cA clt wbr wa c1 cA cdiv co c1 ltaddpos cA cr wcel cc0 cA clt
    wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan 1re
    sylancl mpbid c1 c1 cA cdiv co caddc co cr wcel cc0 c1 c1 cA cdiv co caddc
    co clt wbr c1 c1 c1 cA cdiv co caddc co clt wbr c1 c1 c1 cA cdiv co caddc
    co cdiv co c1 clt wbr wb cA cr wcel cc0 cA clt wbr wa c1 c1 cA cdiv co
    caddc co recgt1 c1 cr wcel c1 cA cdiv co cr wcel c1 c1 cA cdiv co caddc co
    cr wcel cA cr wcel cc0 cA clt wbr wa c1 c1 cA cdiv co readdcl 1re cA cr
    wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl
    syldan sylancr cA cr wcel cc0 cA clt wbr wa c1 c1 c1 cA cdiv co caddc co
    clt wbr cc0 c1 c1 cA cdiv co caddc co clt wbr cA cr wcel cc0 cA clt wbr wa
    cc0 c1 cA cdiv co clt wbr c1 c1 c1 cA cdiv co caddc co clt wbr cA recgt0 c1
    cA cdiv co cr wcel c1 cr wcel cc0 c1 cA cdiv co clt wbr c1 c1 c1 cA cdiv co
    caddc co clt wbr wb cA cr wcel cc0 cA clt wbr wa c1 cA cdiv co c1 ltaddpos
    cA cr wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA
    rereccl syldan 1re sylancl mpbid cA cr wcel cc0 cA clt wbr wa cc0 c1 clt
    wbr c1 c1 c1 cA cdiv co caddc co clt wbr cc0 c1 c1 cA cdiv co caddc co clt
    wbr lt01 cA cr wcel cc0 cA clt wbr wa c1 c1 cA cdiv co caddc co cr wcel cc0
    c1 clt wbr c1 c1 c1 cA cdiv co caddc co clt wbr wa cc0 c1 c1 cA cdiv co
    caddc co clt wbr wi c1 cr wcel c1 cA cdiv co cr wcel c1 c1 cA cdiv co caddc
    co cr wcel cA cr wcel cc0 cA clt wbr wa c1 c1 cA cdiv co readdcl 1re cA cr
    wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl
    syldan sylancr cc0 cr wcel c1 cr wcel c1 c1 cA cdiv co caddc co cr wcel cc0
    c1 clt wbr c1 c1 c1 cA cdiv co caddc co clt wbr wa cc0 c1 c1 cA cdiv co
    caddc co clt wbr wi 0re 1re cc0 c1 c1 c1 cA cdiv co caddc co axlttrn
    mp3an12 syl mpani mpd sylanc mpbid cA cr wcel cc0 cA clt wbr wa c1 cA cdiv
    co c1 c1 cA cdiv co caddc co clt wbr c1 c1 c1 cA cdiv co caddc co cdiv co
    cA clt wbr cA cr wcel cc0 cA clt wbr wa c1 cA cdiv co c1 cA cdiv co c1
    caddc co c1 c1 cA cdiv co caddc co clt cA cr wcel cc0 cA clt wbr wa cc0 c1
    clt wbr c1 cA cdiv co c1 cA cdiv co c1 caddc co clt wbr lt01 c1 cr wcel c1
    cA cdiv co cr wcel cc0 c1 clt wbr c1 cA cdiv co c1 cA cdiv co c1 caddc co
    clt wbr wb cA cr wcel cc0 cA clt wbr wa c1 c1 cA cdiv co ltaddpos 1re cA cr
    wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl
    syldan sylancr mpbii c1 cA cdiv co cc wcel c1 cc wcel c1 cA cdiv co c1
    caddc co c1 c1 cA cdiv co caddc co wceq cA cr wcel cc0 cA clt wbr wa c1 cA
    cdiv co c1 addcom cA cr wcel cc0 cA clt wbr wa c1 cA cdiv co cA cr wcel cc0
    cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan
    recnd ax1cn sylancl breqtrd cA cr wcel cc0 cA clt wbr c1 c1 cA cdiv co
    caddc co cr wcel cc0 c1 c1 cA cdiv co caddc co clt wbr c1 cA cdiv co c1 c1
    cA cdiv co caddc co clt wbr c1 c1 c1 cA cdiv co caddc co cdiv co cA clt wbr
    wb cA cr wcel cc0 cA clt wbr wa cA c1 c1 cA cdiv co caddc co ltrec1 cA cr
    wcel cc0 cA clt wbr pm3.26 cA cr wcel cc0 cA clt wbr pm3.27 c1 cr wcel c1
    cA cdiv co cr wcel c1 c1 cA cdiv co caddc co cr wcel cA cr wcel cc0 cA clt
    wbr wa c1 c1 cA cdiv co readdcl 1re cA cr wcel cc0 cA clt wbr cA cc0 wne c1
    cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan sylancr cA cr wcel cc0 cA
    clt wbr wa c1 c1 c1 cA cdiv co caddc co clt wbr cc0 c1 c1 cA cdiv co caddc
    co clt wbr cA cr wcel cc0 cA clt wbr wa cc0 c1 cA cdiv co clt wbr c1 c1 c1
    cA cdiv co caddc co clt wbr cA recgt0 c1 cA cdiv co cr wcel c1 cr wcel cc0
    c1 cA cdiv co clt wbr c1 c1 c1 cA cdiv co caddc co clt wbr wb cA cr wcel
    cc0 cA clt wbr wa c1 cA cdiv co c1 ltaddpos cA cr wcel cc0 cA clt wbr cA
    cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan 1re sylancl mpbid
    cA cr wcel cc0 cA clt wbr wa cc0 c1 clt wbr c1 c1 c1 cA cdiv co caddc co
    clt wbr cc0 c1 c1 cA cdiv co caddc co clt wbr lt01 cA cr wcel cc0 cA clt
    wbr wa c1 c1 cA cdiv co caddc co cr wcel cc0 c1 clt wbr c1 c1 c1 cA cdiv co
    caddc co clt wbr wa cc0 c1 c1 cA cdiv co caddc co clt wbr wi c1 cr wcel c1
    cA cdiv co cr wcel c1 c1 cA cdiv co caddc co cr wcel cA cr wcel cc0 cA clt
    wbr wa c1 c1 cA cdiv co readdcl 1re cA cr wcel cc0 cA clt wbr cA cc0 wne c1
    cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan sylancr cc0 cr wcel c1 cr
    wcel c1 c1 cA cdiv co caddc co cr wcel cc0 c1 clt wbr c1 c1 c1 cA cdiv co
    caddc co clt wbr wa cc0 c1 c1 cA cdiv co caddc co clt wbr wi 0re 1re cc0 c1
    c1 c1 cA cdiv co caddc co axlttrn mp3an12 syl mpani mpd syl2anc mpbid jca
    $.
    $( [10-Feb-2006] $) $( [28-Dec-2005] $)

  $( The square function on nonnegative reals is monotonic. $)
  le2msq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( A <_ B <-> ( A x. A ) <_ ( B x. B ) ) ) $=
    cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr cA cB cle wbr cA cA
    cmul co cB cB cmul co cle wbr wb cA cr wcel cB cr wcel wa cc0 cA cle wbr
    cc0 cB cle wbr wa cA cB cle wbr cA cA cmul co cB cB cmul co cle wbr wb cA
    cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr wa cA cB cle wbr cA cA
    cmul co cB cB cmul co cle wbr wb wi cc0 cA cr wcel cA cc0 cif cle wbr cc0
    cB cle wbr wa cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cA cr
    wcel cA cc0 cif cmul co cB cB cmul co cle wbr wb wi cc0 cA cr wcel cA cc0
    cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB
    cr wcel cB cc0 cif cle wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul
    co cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co cle wbr wb wi cA cB
    cc0 cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0
    cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cA cB cle wbr cA cA cmul co
    cB cB cmul co cle wbr wb cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0
    cif cA cr wcel cA cc0 cif cmul co cB cB cmul co cle wbr wb cA cA cr wcel cA
    cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle
    wbr cA cA cr wcel cA cc0 cif cc0 cle breq2 anbi1d cA cA cr wcel cA cc0 cif
    wceq cA cB cle wbr cA cr wcel cA cc0 cif cB cle wbr cA cA cmul co cB cB
    cmul co cle wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB cB
    cmul co cle wbr cA cA cr wcel cA cc0 cif cB cle breq1 cA cA cr wcel cA cc0
    cif wceq cA cA cmul co cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co
    cB cB cmul co cle cA cA cr wcel cA cc0 cif wceq cA cA cmul co cA cr wcel cA
    cc0 cif cA cr wcel cA cc0 cif cmul co wceq cA cA cr wcel cA cc0 cif cA cA
    cr wcel cA cc0 cif cmul opreq12 anidms breq1d bibi12d imbi12d cB cB cr wcel
    cB cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cc0 cA
    cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel
    cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co
    cB cB cmul co cle wbr wb cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle
    wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB cr wcel cB cc0
    cif cB cr wcel cB cc0 cif cmul co cle wbr wb cB cB cr wcel cB cc0 cif wceq
    cc0 cB cle wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif
    cle wbr cB cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif cB cle wbr cA cr wcel cA cc0 cif cB cr wcel
    cB cc0 cif cle wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB
    cB cmul co cle wbr cA cr wcel cA cc0 cif cA cr wcel cA cc0 cif cmul co cB
    cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co cle wbr cB cB cr wcel cB
    cc0 cif cA cr wcel cA cc0 cif cle breq2 cB cB cr wcel cB cc0 cif wceq cB cB
    cmul co cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co cA cr wcel cA
    cc0 cif cA cr wcel cA cc0 cif cmul co cle cB cB cr wcel cB cc0 cif wceq cB
    cB cmul co cB cr wcel cB cc0 cif cB cr wcel cB cc0 cif cmul co wceq cB cB
    cr wcel cB cc0 cif cB cB cr wcel cB cc0 cif cmul opreq12 anidms breq2d
    bibi12d imbi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel le2msqi dedth2h imp an4s $.
    $( [21-Mar-2006] $) $( [3-Aug-1999] $)

  ${
    halfpos.1 $e |- A e. RR $.
    $( A positive number is greater than its half. $)
    halfposi $p |- ( 0 < A <-> ( A / ( 1 + 1 ) ) < A ) $=
      cc0 cA clt wbr cc0 cA caddc co cA cA caddc co clt wbr cA c1 c1 caddc co
      cdiv co c1 c1 caddc co cA cmul co c1 c1 caddc co cdiv co clt wbr cA c1 c1
      caddc co cdiv co cA clt wbr cc0 cA cA 0re halfpos.1 halfpos.1 ltadd1i cc0
      cA caddc co cA cA caddc co clt wbr cA c1 c1 caddc co cA cmul co clt wbr
      cA c1 c1 caddc co cdiv co c1 c1 caddc co cA cmul co c1 c1 caddc co cdiv
      co clt wbr cc0 cA caddc co cA cA cA caddc co c1 c1 caddc co cA cmul co
      clt cA cA halfpos.1 recni addid2i c1 c1 caddc co cA cmul co cA cA caddc
      co cA cA halfpos.1 recni 1p1timesi eqcomi breq12i cA c1 c1 caddc co cA
      cmul co c1 c1 caddc co halfpos.1 c1 c1 caddc co cA c1 c1 1re 1re readdcli
      halfpos.1 remulcli c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01
      addgt0ii ltdiv1ii bitri c1 c1 caddc co cA cmul co c1 c1 caddc co cdiv co
      cA cA c1 c1 caddc co cdiv co clt cA c1 c1 caddc co cA halfpos.1 recni c1
      c1 caddc co c1 c1 1re 1re readdcli recni c1 c1 caddc co c1 c1 1re 1re
      readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii divcan3i breq2i 3bitri
      $.
      $( [18-May-1999] $)
  $}

  $( Less-than-or-equal-to and division relation.  (Lemma for computing upper
     bounds of products.  The "+ 1" prevents division by zero.) $)
  ledivp1 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
                  ( ( A / ( B + 1 ) ) x. B ) <_  A ) $=
    cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa wa cA cB c1 caddc
    co cdiv co cB cmul co cA cB c1 caddc co cdiv co cB c1 caddc co cmul co cA
    cle cB cr wcel cB c1 caddc co cr wcel cA cB c1 caddc co cdiv co cr wcel w3a
    cc0 cA cB c1 caddc co cdiv co cle wbr cB cB c1 caddc co cle wbr wa cA cB c1
    caddc co cdiv co cB cmul co cA cB c1 caddc co cdiv co cB c1 caddc co cmul
    co cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa wa cB
    cB c1 caddc co cA cB c1 caddc co cdiv co lemul2aOLD cA cr wcel cc0 cA cle
    wbr wa cB cr wcel cc0 cB cle wbr wa wa cB cr wcel cB c1 caddc co cr wcel cA
    cB c1 caddc co cdiv co cr wcel cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0
    cB cle wbr simprl cB cr wcel cB c1 caddc co cr wcel cA cr wcel cc0 cA cle
    wbr wa cc0 cB cle wbr cB peano2re ad2antrl cA cr wcel cB cr wcel cc0 cB cle
    wbr wa cA cB c1 caddc co cdiv co cr wcel cc0 cA cle wbr cA cr wcel cB c1
    caddc co cr wcel cB c1 caddc co cc0 wne cA cB c1 caddc co cdiv co cr wcel
    cA cr wcel cB cr wcel cc0 cB cle wbr wa wa cA cB c1 caddc co redivcl cA cr
    wcel cB cr wcel cc0 cB cle wbr wa pm3.26 cB cr wcel cB c1 caddc co cr wcel
    cA cr wcel cc0 cB cle wbr cB peano2re ad2antrl cB cr wcel cc0 cB cle wbr wa
    cB c1 caddc co cc0 wne cA cr wcel cB c1 caddc co cr wcel cc0 cB c1 caddc co
    clt wbr cB c1 caddc co cc0 wne cB cr wcel cc0 cB cle wbr wa cB c1 caddc co
    gt0ne0 cB cr wcel cB c1 caddc co cr wcel cc0 cB cle wbr cB peano2re adantr
    cB cr wcel cc0 cB cle wbr cc0 cB c1 caddc co clt wbr cB cr wcel cc0 cB cle
    wbr cB cB c1 caddc co clt wbr cc0 cB c1 caddc co clt wbr cB ltp1 cB cr wcel
    cB c1 caddc co cr wcel cc0 cB cle wbr cB cB c1 caddc co clt wbr wa cc0 cB
    c1 caddc co clt wbr wi cB peano2re cc0 cr wcel cB cr wcel cB c1 caddc co cr
    wcel cc0 cB cle wbr cB cB c1 caddc co clt wbr wa cc0 cB c1 caddc co clt wbr
    wi 0re cc0 cB cB c1 caddc co lelttr mp3an1 mpdan mpan2d imp sylanc adantl
    syl3anc adantlr 3jca cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr
    wa wa cc0 cA cB c1 caddc co cdiv co cle wbr cB cB c1 caddc co cle wbr cA cr
    wcel cc0 cA cle wbr wa cB c1 caddc co cr wcel cc0 cB c1 caddc co clt wbr wa
    cc0 cA cB c1 caddc co cdiv co cle wbr cB cr wcel cc0 cB cle wbr wa cA cB c1
    caddc co divge0 cB cr wcel cc0 cB cle wbr wa cB c1 caddc co cr wcel cc0 cB
    c1 caddc co clt wbr cB cr wcel cB c1 caddc co cr wcel cc0 cB cle wbr cB
    peano2re adantr cB cr wcel cc0 cB cle wbr cc0 cB c1 caddc co clt wbr cB cr
    wcel cc0 cB cle wbr cB cB c1 caddc co clt wbr cc0 cB c1 caddc co clt wbr cB
    ltp1 cB cr wcel cB c1 caddc co cr wcel cc0 cB cle wbr cB cB c1 caddc co clt
    wbr wa cc0 cB c1 caddc co clt wbr wi cB peano2re cc0 cr wcel cB cr wcel cB
    c1 caddc co cr wcel cc0 cB cle wbr cB cB c1 caddc co clt wbr wa cc0 cB c1
    caddc co clt wbr wi 0re cc0 cB cB c1 caddc co lelttr mp3an1 mpdan mpan2d
    imp jca sylan2 cB cr wcel cc0 cB cle wbr wa cB cB c1 caddc co cle wbr cA cr
    wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa cB cB c1 caddc co clt
    wbr cB cB c1 caddc co cle wbr cB cr wcel cB cB c1 caddc co clt wbr cc0 cB
    cle wbr cB ltp1 adantr cB cr wcel cB cB c1 caddc co clt wbr cB cB c1 caddc
    co cle wbr wi cc0 cB cle wbr cB cr wcel cB c1 caddc co cr wcel cB cB c1
    caddc co clt wbr cB cB c1 caddc co cle wbr wi cB peano2re cB cB c1 caddc co
    ltle mpdan adantr mpd adantl jca sylanc cA cc wcel cB c1 caddc co cc wcel
    cB c1 caddc co cc0 wne cA cB c1 caddc co cdiv co cB c1 caddc co cmul co cA
    wceq cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa wa cA cB c1
    caddc co divcan1 cA cr wcel cA cc wcel cc0 cA cle wbr cB cr wcel cc0 cB cle
    wbr wa cA recn ad2antrr cB cr wcel cB c1 caddc co cc wcel cA cr wcel cc0 cA
    cle wbr wa cc0 cB cle wbr cB cr wcel cB c1 caddc co cB peano2re recnd
    ad2antrl cB cr wcel cc0 cB cle wbr wa cB c1 caddc co cc0 wne cA cr wcel cc0
    cA cle wbr wa cB c1 caddc co cr wcel cc0 cB c1 caddc co clt wbr cB c1 caddc
    co cc0 wne cB cr wcel cc0 cB cle wbr wa cB c1 caddc co gt0ne0 cB cr wcel cB
    c1 caddc co cr wcel cc0 cB cle wbr cB peano2re adantr cB cr wcel cc0 cB cle
    wbr cc0 cB c1 caddc co clt wbr cB cr wcel cc0 cB cle wbr cB cB c1 caddc co
    clt wbr cc0 cB c1 caddc co clt wbr cB ltp1 cB cr wcel cB c1 caddc co cr
    wcel cc0 cB cle wbr cB cB c1 caddc co clt wbr wa cc0 cB c1 caddc co clt wbr
    wi cB peano2re cc0 cr wcel cB cr wcel cB c1 caddc co cr wcel cc0 cB cle wbr
    cB cB c1 caddc co clt wbr wa cc0 cB c1 caddc co clt wbr wi 0re cc0 cB cB c1
    caddc co lelttr mp3an1 mpdan mpan2d imp sylanc adantl syl3anc breqtrd $.
    $( [1-Jun-2006] $) $( [28-Sep-2005] $)

  ${
    ledivp1.1 $e |- A e. RR $.
    ledivp1.2 $e |- B e. RR $.
    ledivp1.3 $e |- C e. RR $.
    $( Less-than-or-equal-to and division relation.  (Lemma for computing upper
       bounds of products.  The "+ 1" prevents division by zero.) $)
    ledivp1i $p |- ( ( 0 <_ A /\ 0 <_ C /\ A <_ ( B / ( C + 1 ) ) ) ->
                  ( A x. C ) <_ B ) $=
      cA cC cmul co cA cC c1 caddc co cmul co cle wbr cA cC c1 caddc co cmul co
      cB cle wbr cA cC cmul co cB cle wbr cc0 cA cle wbr cc0 cC cle wbr cA cB
      cC c1 caddc co cdiv co cle wbr w3a cA cC cmul co cA cC c1 caddc co cmul
      co cB cA cC ledivp1.1 ledivp1.3 remulcli cA cC c1 caddc co ledivp1.1 cC
      c1 ledivp1.3 1re readdcli remulcli ledivp1.2 letri cc0 cA cle wbr cc0 cC
      cle wbr cA cC cmul co cA cC c1 caddc co cmul co cle wbr cA cB cC c1 caddc
      co cdiv co cle wbr cc0 cA cle wbr cC cC c1 caddc co cle wbr cA cC cmul co
      cA cC c1 caddc co cmul co cle wbr cC cC c1 caddc co ledivp1.3 cC c1
      ledivp1.3 1re readdcli cC ledivp1.3 ltp1i ltleii cC cr wcel cC c1 caddc
      co cr wcel cA cr wcel cc0 cA cle wbr cC cC c1 caddc co cle wbr wa cA cC
      cmul co cA cC c1 caddc co cmul co cle wbr wi ledivp1.3 cC c1 ledivp1.3
      1re readdcli ledivp1.1 cC cr wcel cC c1 caddc co cr wcel cA cr wcel w3a
      cc0 cA cle wbr cC cC c1 caddc co cle wbr wa cA cC cmul co cA cC c1 caddc
      co cmul co cle wbr cC cC c1 caddc co cA lemul2aOLD ex mp3an mpan2
      3ad2ant1 cc0 cC cle wbr cA cB cC c1 caddc co cdiv co cle wbr cA cC c1
      caddc co cmul co cB cle wbr cc0 cA cle wbr cc0 cC cle wbr cA cB cC c1
      caddc co cdiv co cle wbr wa cA cC c1 caddc co cmul co cB cC c1 caddc co
      cdiv co cC c1 caddc co cmul co cB cle cc0 cC cle wbr cA cB cC c1 caddc co
      cdiv co cle wbr cA cC c1 caddc co cmul co cB cC c1 caddc co cdiv co cC c1
      caddc co cmul co cle wbr cc0 cC cle wbr cc0 cC c1 caddc co clt wbr cA cB
      cC c1 caddc co cdiv co cle wbr cA cC c1 caddc co cmul co cB cC c1 caddc
      co cdiv co cC c1 caddc co cmul co cle wbr wi cc0 cC cle wbr cC cC c1
      caddc co clt wbr cc0 cC c1 caddc co clt wbr cC ledivp1.3 ltp1i cc0 cC cC
      c1 caddc co 0re ledivp1.3 cC c1 ledivp1.3 1re readdcli lelttri mpan2 cc0
      cC c1 caddc co clt wbr cA cB cC c1 caddc co cdiv co cle wbr cA cC c1
      caddc co cmul co cB cC c1 caddc co cdiv co cC c1 caddc co cmul co cle wbr
      cB cC c1 caddc co cdiv co cr wcel cc0 cC c1 caddc co clt wbr cA cB cC c1
      caddc co cdiv co cle wbr cA cC c1 caddc co cmul co cB cC c1 caddc co cdiv
      co cC c1 caddc co cmul co cle wbr wb cc0 cC c1 caddc co clt wbr cC c1
      caddc co cc0 wne cB cC c1 caddc co cdiv co cr wcel cC c1 caddc co cC c1
      ledivp1.3 1re readdcli gt0ne0i cB cC c1 caddc co ledivp1.2 cC c1
      ledivp1.3 1re readdcli redivclzi syl cB cC c1 caddc co cdiv co cr wcel cC
      c1 caddc co cr wcel cc0 cC c1 caddc co clt wbr cA cB cC c1 caddc co cdiv
      co cle wbr cA cC c1 caddc co cmul co cB cC c1 caddc co cdiv co cC c1
      caddc co cmul co cle wbr wb cC c1 ledivp1.3 1re readdcli cA cr wcel cB cC
      c1 caddc co cdiv co cr wcel cC c1 caddc co cr wcel cc0 cC c1 caddc co clt
      wbr cA cB cC c1 caddc co cdiv co cle wbr cA cC c1 caddc co cmul co cB cC
      c1 caddc co cdiv co cC c1 caddc co cmul co cle wbr wb ledivp1.1 cA cB cC
      c1 caddc co cdiv co cC c1 caddc co lemul1OLD mp3anl1 mpanl2 mpancom
      biimpd syl imp cc0 cC cle wbr cB cC c1 caddc co cdiv co cC c1 caddc co
      cmul co cB wceq cA cB cC c1 caddc co cdiv co cle wbr cc0 cC cle wbr cc0
      cC c1 caddc co clt wbr cC c1 caddc co cc0 wne cB cC c1 caddc co cdiv co
      cC c1 caddc co cmul co cB wceq cc0 cC cle wbr cC cC c1 caddc co clt wbr
      cc0 cC c1 caddc co clt wbr cC ledivp1.3 ltp1i cc0 cC cC c1 caddc co 0re
      ledivp1.3 cC c1 ledivp1.3 1re readdcli lelttri mpan2 cC c1 caddc co cC c1
      ledivp1.3 1re readdcli gt0ne0i cB cC c1 caddc co cB ledivp1.2 recni cC c1
      caddc co cC c1 ledivp1.3 1re readdcli recni divcan1zi 3syl adantr breqtrd
      3adant1 sylanc $.
      $( [23-Sep-2005] $) $( [17-Sep-2005] $)

    $( Less-than and division relation.  (Lemma for computing upper bounds of
       products.  The "+ 1" prevents division by zero.) $)
    ltdivp1i $p |- ( ( 0 <_ A /\ 0 <_ C /\ A < ( B / ( C + 1 ) ) ) ->
                  ( A x. C ) < B ) $=
      cA cC cmul co cA cC c1 caddc co cmul co cle wbr cA cC c1 caddc co cmul co
      cB clt wbr cA cC cmul co cB clt wbr cc0 cA cle wbr cc0 cC cle wbr cA cB
      cC c1 caddc co cdiv co clt wbr w3a cA cC cmul co cA cC c1 caddc co cmul
      co cB cA cC ledivp1.1 ledivp1.3 remulcli cA cC c1 caddc co ledivp1.1 cC
      c1 ledivp1.3 1re readdcli remulcli ledivp1.2 lelttri cc0 cA cle wbr cc0
      cC cle wbr cA cC cmul co cA cC c1 caddc co cmul co cle wbr cA cB cC c1
      caddc co cdiv co clt wbr cA cr wcel cc0 cA cle wbr cA cC cmul co cA cC c1
      caddc co cmul co cle wbr ledivp1.1 cC cr wcel cC c1 caddc co cr wcel cA
      cr wcel cc0 cA cle wbr wa cA cC cmul co cA cC c1 caddc co cmul co cle wbr
      ledivp1.3 cC c1 ledivp1.3 1re readdcli cC cr wcel cC c1 caddc co cr wcel
      cA cr wcel cc0 cA cle wbr wa w3a cC cC c1 caddc co cle wbr cA cC cmul co
      cA cC c1 caddc co cmul co cle wbr cC cC c1 caddc co ledivp1.3 cC c1
      ledivp1.3 1re readdcli cC ledivp1.3 ltp1i ltleii cC cC c1 caddc co cA
      lemul2a mpan2 mp3an12 mpan 3ad2ant1 cc0 cC cle wbr cA cB cC c1 caddc co
      cdiv co clt wbr cA cC c1 caddc co cmul co cB clt wbr cc0 cA cle wbr cc0
      cC cle wbr cA cB cC c1 caddc co cdiv co clt wbr wa cA cC c1 caddc co cmul
      co cB cC c1 caddc co cdiv co cC c1 caddc co cmul co cB clt cc0 cC cle wbr
      cA cB cC c1 caddc co cdiv co clt wbr cA cC c1 caddc co cmul co cB cC c1
      caddc co cdiv co cC c1 caddc co cmul co clt wbr cc0 cC cle wbr cc0 cC c1
      caddc co clt wbr cA cB cC c1 caddc co cdiv co clt wbr cA cC c1 caddc co
      cmul co cB cC c1 caddc co cdiv co cC c1 caddc co cmul co clt wbr wi cc0
      cC cle wbr cC cC c1 caddc co clt wbr cc0 cC c1 caddc co clt wbr cC
      ledivp1.3 ltp1i cc0 cC cC c1 caddc co 0re ledivp1.3 cC c1 ledivp1.3 1re
      readdcli lelttri mpan2 cc0 cC c1 caddc co clt wbr cA cB cC c1 caddc co
      cdiv co clt wbr cA cC c1 caddc co cmul co cB cC c1 caddc co cdiv co cC c1
      caddc co cmul co clt wbr cB cC c1 caddc co cdiv co cr wcel cc0 cC c1
      caddc co clt wbr cA cB cC c1 caddc co cdiv co clt wbr cA cC c1 caddc co
      cmul co cB cC c1 caddc co cdiv co cC c1 caddc co cmul co clt wbr wb cc0
      cC c1 caddc co clt wbr cC c1 caddc co cc0 wne cB cC c1 caddc co cdiv co
      cr wcel cC c1 caddc co cC c1 ledivp1.3 1re readdcli gt0ne0i cB cC c1
      caddc co ledivp1.2 cC c1 ledivp1.3 1re readdcli redivclzi syl cB cC c1
      caddc co cdiv co cr wcel cC c1 caddc co cr wcel cc0 cC c1 caddc co clt
      wbr cA cB cC c1 caddc co cdiv co clt wbr cA cC c1 caddc co cmul co cB cC
      c1 caddc co cdiv co cC c1 caddc co cmul co clt wbr wb cC c1 ledivp1.3 1re
      readdcli cA cr wcel cB cC c1 caddc co cdiv co cr wcel cC c1 caddc co cr
      wcel cc0 cC c1 caddc co clt wbr wa cA cB cC c1 caddc co cdiv co clt wbr
      cA cC c1 caddc co cmul co cB cC c1 caddc co cdiv co cC c1 caddc co cmul
      co clt wbr wb ledivp1.1 cA cB cC c1 caddc co cdiv co cC c1 caddc co
      ltmul1 mp3an1 mpanr1 mpancom biimpd syl imp cc0 cC cle wbr cB cC c1 caddc
      co cdiv co cC c1 caddc co cmul co cB wceq cA cB cC c1 caddc co cdiv co
      clt wbr cc0 cC cle wbr cc0 cC c1 caddc co clt wbr cC c1 caddc co cc0 wne
      cB cC c1 caddc co cdiv co cC c1 caddc co cmul co cB wceq cc0 cC cle wbr
      cC cC c1 caddc co clt wbr cc0 cC c1 caddc co clt wbr cC ledivp1.3 ltp1i
      cc0 cC cC c1 caddc co 0re ledivp1.3 cC c1 ledivp1.3 1re readdcli lelttri
      mpan2 cC c1 caddc co cC c1 ledivp1.3 1re readdcli gt0ne0i cB cC c1 caddc
      co cB ledivp1.2 recni cC c1 caddc co cC c1 ledivp1.3 1re readdcli recni
      divcan1zi 3syl adantr breqtrd 3adant1 sylanc $.
      $( [29-Sep-2005] $) $( [17-Sep-2005] $)
  $}

  ${
    $d x A $.  $d x B $.
    posex.1 $e |- A e. RR $.
    posex.2 $e |- B e. RR $.
    posex.3 $e |- 0 < A $.
    posex.4 $e |- 0 < B $.
    $( There exists a positive number less than two others. $)
    posexi $p |- E. x e. RR ( 0 < x /\ ( x < A /\ x < B ) ) $=
      cA cB clt wbr cA cB wceq cB cA clt wbr wo wo cc0 vx cv clt wbr vx cv cA
      clt wbr vx cv cB clt wbr wa wa vx cr wrex cA cB wceq cA cB clt wbr cB cA
      clt wbr wo wo cA cB clt wbr cA cB wceq cB cA clt wbr wo wo cA cB wceq cA
      cB clt wbr cB cA clt wbr wo cA cB wceq wn cA cB clt wbr cB cA clt wbr wo
      cA cB wceq wn cA cB wne cA cB clt wbr cB cA clt wbr wo cA cB df-ne cA cB
      posex.1 posex.2 lttri2i bitr3i biimpi orri cA cB wceq cA cB clt wbr cB cA
      clt wbr or12 mpbi cA cB clt wbr cc0 vx cv clt wbr vx cv cA clt wbr vx cv
      cB clt wbr wa wa vx cr wrex cA cB wceq cB cA clt wbr wo cA c1 c1 caddc co
      cdiv co cr wcel cc0 cA c1 c1 caddc co cdiv co clt wbr cA c1 c1 caddc co
      cdiv co cA clt wbr cA c1 c1 caddc co cdiv co cB clt wbr wa wa cc0 vx cv
      clt wbr vx cv cA clt wbr vx cv cB clt wbr wa wa vx cr wrex cA cB clt wbr
      cc0 vx cv clt wbr vx cv cA clt wbr vx cv cB clt wbr wa wa cc0 cA c1 c1
      caddc co cdiv co clt wbr cA c1 c1 caddc co cdiv co cA clt wbr cA c1 c1
      caddc co cdiv co cB clt wbr wa wa vx cA c1 c1 caddc co cdiv co cr vx cv
      cA c1 c1 caddc co cdiv co wceq cc0 vx cv clt wbr cc0 cA c1 c1 caddc co
      cdiv co clt wbr vx cv cA clt wbr vx cv cB clt wbr wa cA c1 c1 caddc co
      cdiv co cA clt wbr cA c1 c1 caddc co cdiv co cB clt wbr wa vx cv cA c1 c1
      caddc co cdiv co cc0 clt breq2 vx cv cA c1 c1 caddc co cdiv co wceq vx cv
      cA clt wbr cA c1 c1 caddc co cdiv co cA clt wbr vx cv cB clt wbr cA c1 c1
      caddc co cdiv co cB clt wbr vx cv cA c1 c1 caddc co cdiv co cA clt breq1
      vx cv cA c1 c1 caddc co cdiv co cB clt breq1 anbi12d anbi12d rcla4ev cA
      c1 c1 caddc co posex.1 c1 c1 1re 1re readdcli c1 c1 caddc co c1 c1 1re
      1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii redivcli cA cB clt
      wbr cA c1 c1 caddc co cdiv co cA clt wbr cA c1 c1 caddc co cdiv co cB clt
      wbr wa cc0 cA c1 c1 caddc co cdiv co clt wbr cA cB clt wbr cA c1 c1 caddc
      co cdiv co cB clt wbr cA c1 c1 caddc co cdiv co cA clt wbr cA c1 c1 caddc
      co cdiv co cA clt wbr cA cB clt wbr cA c1 c1 caddc co cdiv co cB clt wbr
      cc0 cA clt wbr cA c1 c1 caddc co cdiv co cA clt wbr posex.3 cA posex.1
      halfposi mpbi cA c1 c1 caddc co cdiv co cA cB cA c1 c1 caddc co posex.1
      c1 c1 1re 1re readdcli c1 c1 caddc co c1 c1 1re 1re readdcli c1 c1 1re
      1re lt01 lt01 addgt0ii gt0ne0ii redivcli posex.1 posex.2 lttri mpan cc0
      cA clt wbr cA c1 c1 caddc co cdiv co cA clt wbr posex.3 cA posex.1
      halfposi mpbi jctil cA c1 c1 caddc co posex.1 c1 c1 1re 1re readdcli
      posex.3 c1 c1 1re 1re lt01 lt01 addgt0ii divgt0ii jctil sylancr cB c1 c1
      caddc co cdiv co cr wcel cc0 cB c1 c1 caddc co cdiv co clt wbr cB c1 c1
      caddc co cdiv co cA clt wbr cB c1 c1 caddc co cdiv co cB clt wbr wa wa
      cc0 vx cv clt wbr vx cv cA clt wbr vx cv cB clt wbr wa wa vx cr wrex cA
      cB wceq cB cA clt wbr wo cc0 vx cv clt wbr vx cv cA clt wbr vx cv cB clt
      wbr wa wa cc0 cB c1 c1 caddc co cdiv co clt wbr cB c1 c1 caddc co cdiv co
      cA clt wbr cB c1 c1 caddc co cdiv co cB clt wbr wa wa vx cB c1 c1 caddc
      co cdiv co cr vx cv cB c1 c1 caddc co cdiv co wceq cc0 vx cv clt wbr cc0
      cB c1 c1 caddc co cdiv co clt wbr vx cv cA clt wbr vx cv cB clt wbr wa cB
      c1 c1 caddc co cdiv co cA clt wbr cB c1 c1 caddc co cdiv co cB clt wbr wa
      vx cv cB c1 c1 caddc co cdiv co cc0 clt breq2 vx cv cB c1 c1 caddc co
      cdiv co wceq vx cv cA clt wbr cB c1 c1 caddc co cdiv co cA clt wbr vx cv
      cB clt wbr cB c1 c1 caddc co cdiv co cB clt wbr vx cv cB c1 c1 caddc co
      cdiv co cA clt breq1 vx cv cB c1 c1 caddc co cdiv co cB clt breq1 anbi12d
      anbi12d rcla4ev cB c1 c1 caddc co posex.2 c1 c1 1re 1re readdcli c1 c1
      caddc co c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii
      redivcli cA cB wceq cB cA clt wbr wo cB c1 c1 caddc co cdiv co cA clt wbr
      cB c1 c1 caddc co cdiv co cB clt wbr wa cc0 cB c1 c1 caddc co cdiv co clt
      wbr cA cB wceq cB cA clt wbr wo cB c1 c1 caddc co cdiv co cA clt wbr cB
      c1 c1 caddc co cdiv co cB clt wbr cA cB wceq cB c1 c1 caddc co cdiv co cA
      clt wbr cB cA clt wbr cA cB wceq cB c1 c1 caddc co cdiv co cA clt wbr cB
      c1 c1 caddc co cdiv co cB clt wbr cc0 cB clt wbr cB c1 c1 caddc co cdiv
      co cB clt wbr posex.4 cB posex.2 halfposi mpbi cA cB cB c1 c1 caddc co
      cdiv co clt breq2 mpbiri cB c1 c1 caddc co cdiv co cB clt wbr cB cA clt
      wbr cB c1 c1 caddc co cdiv co cA clt wbr cc0 cB clt wbr cB c1 c1 caddc co
      cdiv co cB clt wbr posex.4 cB posex.2 halfposi mpbi cB c1 c1 caddc co
      cdiv co cB cA cB c1 c1 caddc co posex.2 c1 c1 1re 1re readdcli c1 c1
      caddc co c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii
      redivcli posex.2 posex.1 lttri mpan jaoi cc0 cB clt wbr cB c1 c1 caddc co
      cdiv co cB clt wbr posex.4 cB posex.2 halfposi mpbi jctir cB c1 c1 caddc
      co posex.2 c1 c1 1re 1re readdcli posex.4 c1 c1 1re 1re lt01 lt01
      addgt0ii divgt0ii jctil sylancr jaoi ax-mp $.
      $( [18-May-1999] $)
  $}

  $( An extended real is less than or equal to the maximum of it and
     another. $)
  xrmax1 $p |- ( ( A e. RR* /\ B e. RR* ) -> A <_ if ( A <_ B , B , A ) ) $=
    cA cxr wcel cA cA cB cle wbr cB cA cif cle wbr cB cxr wcel cA cxr wcel cA
    cB cle wbr cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr wn cA cA cB cle
    wbr cB cA cif cle wbr cA cA cle wbr cA cxr wcel cA cB cle wbr wn cA cB cle
    wbr cB cA cif cA cA cle cA cB cle wbr cB cA iffalse breq2d cA xrleid
    syl5cbir cA cB cle wbr cA cB cA cB cle wbr cB cA cif cle cA cB cle wbr id
    cA cB cle wbr cB cA iftrue breqtrrd pm2.61d2 adantr $.
    $( [9-Feb-2007] $) $( [7-Feb-2007] $)

  $( An extended real is less than or equal to the maximum of it and
     another. $)
  xrmax2 $p |- ( ( A e. RR* /\ B e. RR* ) -> B <_ if ( A <_ B , B , A ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cle wbr cB cA cB cle wbr cB cA cif cle wbr
    cA cxr wcel cB cxr wcel wa cA cB cle wbr wa cB cB cA cB cle wbr cB cA cif
    cle cB cxr wcel cB cB cle wbr cA cxr wcel cA cB cle wbr cB xrleid ad2antlr
    cA cB cle wbr cA cB cle wbr cB cA cif cB wceq cA cxr wcel cB cxr wcel wa cA
    cB cle wbr cB cA iftrue adantl breqtrrd cA cxr wcel cB cxr wcel wa cA cB
    cle wbr wn wa cB cA cA cB cle wbr cB cA cif cle cA cxr wcel cB cxr wcel wa
    cA cB cle wbr cB cA cle wbr cA cB xrletri orcanai cA cB cle wbr wn cA cB
    cle wbr cB cA cif cA wceq cA cxr wcel cB cxr wcel wa cA cB cle wbr cB cA
    iffalse adantl breqtrrd pm2.61dan $.
    $( [10-Feb-2007] $) $( [7-Feb-2007] $)

  $( The minimum of two extended reals is less than or equal to one of them. $)
  xrmin1 $p |- ( ( A e. RR* /\ B e. RR* ) -> if ( A <_ B , A , B ) <_ A ) $=
    cA cxr wcel cB cxr wcel wa cA cB cle wbr cA cB cle wbr cA cB cif cA cle wbr
    cA cxr wcel cB cxr wcel wa cA cB cle wbr wa cA cB cle wbr cA cB cif cA cA
    cle cA cB cle wbr cA cB cle wbr cA cB cif cA wceq cA cxr wcel cB cxr wcel
    wa cA cB cle wbr cA cB iftrue adantl cA cxr wcel cA cA cle wbr cB cxr wcel
    cA cB cle wbr cA xrleid ad2antrr eqbrtrd cA cxr wcel cB cxr wcel wa cA cB
    cle wbr wn wa cA cB cle wbr cA cB cif cB cA cle cA cB cle wbr wn cA cB cle
    wbr cA cB cif cB wceq cA cxr wcel cB cxr wcel wa cA cB cle wbr cA cB
    iffalse adantl cA cxr wcel cB cxr wcel wa cA cB cle wbr cB cA cle wbr cA cB
    xrletri orcanai eqbrtrd pm2.61dan $.
    $( [11-Feb-2007] $) $( [7-Feb-2007] $)

  $( The minimum of two extended reals is less than or equal to one of them. $)
  xrmin2 $p |- ( ( A e. RR* /\ B e. RR* ) -> if ( A <_ B , A , B ) <_ B ) $=
    cB cxr wcel cA cB cle wbr cA cB cif cB cle wbr cA cxr wcel cB cxr wcel cA
    cB cle wbr cA cB cle wbr cA cB cif cB cle wbr cA cB cle wbr wn cA cB cle
    wbr cA cB cif cB cle wbr cB cB cle wbr cB cxr wcel cA cB cle wbr wn cA cB
    cle wbr cA cB cif cB cB cle cA cB cle wbr cA cB iffalse breq1d cB xrleid
    syl5cbir cA cB cle wbr cA cB cle wbr cA cB cif cA cB cle cA cB cle wbr cA
    cB iftrue cA cB cle wbr id eqbrtrd pm2.61d2 adantl $.
    $( [12-Feb-2007] $) $( [7-Feb-2007] $)

  $( Two ways of saying the maximum of two extended reals is less than a
     third. $)
  xrmaxlt $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
               ( if ( A <_ B , B , A ) < C <-> ( A < C /\ B < C ) ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cle wbr cB cA cif cC clt wbr
    cA cC clt wbr cB cC clt wbr wa cA cxr wcel cB cxr wcel cC cxr wcel w3a cA
    cB cle wbr cB cA cif cC clt wbr cA cC clt wbr cB cC clt wbr cA cxr wcel cB
    cxr wcel cC cxr wcel w3a cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr
    cB cA cif cC clt wbr cA cC clt wbr cA cxr wcel cB cxr wcel cA cA cB cle wbr
    cB cA cif cle wbr cC cxr wcel cA cB xrmax1 3adant3 cA cxr wcel cA cB cle
    wbr cB cA cif cxr wcel cC cxr wcel cA cA cB cle wbr cB cA cif cle wbr cA cB
    cle wbr cB cA cif cC clt wbr wa cA cC clt wbr wi cB cxr wcel cA cA cB cle
    wbr cB cA cif cC xrlelttr cA cxr wcel cB cxr wcel cA cB cle wbr cB cA cif
    cxr wcel cC cxr wcel cB cxr wcel cA cxr wcel cA cB cle wbr cB cA cif cxr
    wcel cA cB cle wbr cB cA cxr ifcl ancoms 3adant3 syld3an2 mpand cA cxr wcel
    cB cxr wcel cC cxr wcel w3a cB cA cB cle wbr cB cA cif cle wbr cA cB cle
    wbr cB cA cif cC clt wbr cB cC clt wbr cA cxr wcel cB cxr wcel cB cA cB cle
    wbr cB cA cif cle wbr cC cxr wcel cA cB xrmax2 3adant3 cB cxr wcel cA cB
    cle wbr cB cA cif cxr wcel cC cxr wcel cB cA cB cle wbr cB cA cif cle wbr
    cA cB cle wbr cB cA cif cC clt wbr wa cB cC clt wbr wi cA cxr wcel cB cxr
    wcel cC cxr wcel w3a cB cA cB cle wbr cB cA cif cC xrlelttr cA cxr wcel cB
    cxr wcel cC cxr wcel 3simp2 cA cxr wcel cB cxr wcel cA cB cle wbr cB cA cif
    cxr wcel cC cxr wcel cB cxr wcel cA cxr wcel cA cB cle wbr cB cA cif cxr
    wcel cA cB cle wbr cB cA cxr ifcl ancoms 3adant3 cA cxr wcel cB cxr wcel cC
    cxr wcel 3simp3 syl3anc mpand jcad cB cC clt wbr cA cC clt wbr cA cB cle
    wbr cB cA cif cC clt wbr cA cB cle wbr cB cC clt wbr cA cC clt wbr cA cB
    cle wbr cB cA cif cC clt wbr cB cA cB cA cB cle wbr cB cA cif cC clt breq1
    cA cA cB cle wbr cB cA cif cC clt breq1 ifboth ancoms impbid1 $.
    $( [12-Feb-2007] $) $( [7-Feb-2007] $)

  $( Two ways of saying an extended real is less than the minimum of two
     others. $)
  xrltmin $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
               ( A < if ( B <_ C , B , C ) <-> ( A < B /\ A < C ) ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cC cle wbr cB cC cif clt wbr
    cA cB clt wbr cA cC clt wbr wa cA cxr wcel cB cxr wcel cC cxr wcel w3a cA
    cB cC cle wbr cB cC cif clt wbr cA cB clt wbr cA cC clt wbr cA cxr wcel cB
    cxr wcel cC cxr wcel w3a cA cB cC cle wbr cB cC cif clt wbr cB cC cle wbr
    cB cC cif cB cle wbr cA cB clt wbr cB cxr wcel cC cxr wcel cB cC cle wbr cB
    cC cif cB cle wbr cA cxr wcel cB cC xrmin1 3adant1 cA cxr wcel cB cC cle
    wbr cB cC cif cxr wcel cB cxr wcel cA cB cC cle wbr cB cC cif clt wbr cB cC
    cle wbr cB cC cif cB cle wbr wa cA cB clt wbr wi cA cxr wcel cB cxr wcel cC
    cxr wcel w3a cA cB cC cle wbr cB cC cif cB xrltletr cA cxr wcel cB cxr wcel
    cC cxr wcel 3simp1 cB cxr wcel cC cxr wcel cB cC cle wbr cB cC cif cxr wcel
    cA cxr wcel cB cC cle wbr cB cC cxr ifcl 3adant1 cA cxr wcel cB cxr wcel cC
    cxr wcel 3simp2 syl3anc mpan2d cA cxr wcel cB cxr wcel cC cxr wcel w3a cA
    cB cC cle wbr cB cC cif clt wbr cB cC cle wbr cB cC cif cC cle wbr cA cC
    clt wbr cB cxr wcel cC cxr wcel cB cC cle wbr cB cC cif cC cle wbr cA cxr
    wcel cB cC xrmin2 3adant1 cA cxr wcel cB cC cle wbr cB cC cif cxr wcel cC
    cxr wcel cA cB cC cle wbr cB cC cif clt wbr cB cC cle wbr cB cC cif cC cle
    wbr wa cA cC clt wbr wi cB cxr wcel cA cB cC cle wbr cB cC cif cC xrltletr
    cB cxr wcel cC cxr wcel cB cC cle wbr cB cC cif cxr wcel cA cxr wcel cB cC
    cle wbr cB cC cxr ifcl 3adant1 syld3an2 mpan2d jcad cB cC cle wbr cA cB clt
    wbr cA cC clt wbr cA cB cC cle wbr cB cC cif clt wbr cB cC cB cB cC cle wbr
    cB cC cif cA clt breq2 cC cB cC cle wbr cB cC cif cA clt breq2 ifboth
    impbid1 $.
    $( [12-Feb-2007] $) $( [7-Feb-2007] $)

  $( A number is less than or equal to the maximum of it and another. $)
  max1 $p |- ( ( A e. RR /\ B e. RR ) -> A <_ if ( A <_ B , B , A ) ) $=
    cA cxr wcel cB cxr wcel cA cA cB cle wbr cB cA cif cle wbr cA cr wcel cB cr
    wcel cA cB xrmax1 cA rexr cB rexr syl2an $.
    $( [8-Jun-2005] $) $( [3-Apr-2005] $)

  $( A number is less than or equal to the maximum of it and another. $)
  max1ALT $p |- ( A e. RR -> A <_ if ( A <_ B , B , A ) ) $=
    cA cr wcel cA cB cle wbr cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr
    wn cA cA cB cle wbr cB cA cif cle wbr cA cA cle wbr cA cr wcel cA cB cle
    wbr wn cA cB cle wbr cB cA cif cA cA cle cA cB cle wbr cB cA iffalse breq2d
    cA leid syl5cbir cA cB cle wbr cA cB cA cB cle wbr cB cA cif cle cA cB cle
    wbr id cA cB cle wbr cB cA iftrue breqtrrd pm2.61d2 $.
    $( [22-Apr-2005] $) $( [3-Apr-2005] $)

  $( A number is less than or equal to the maximum of it and another. $)
  max2 $p |- ( ( A e. RR /\ B e. RR ) -> B <_ if ( A <_ B , B , A ) ) $=
    cA cxr wcel cB cxr wcel cB cA cB cle wbr cB cA cif cle wbr cA cr wcel cB cr
    wcel cA cB xrmax2 cA rexr cB rexr syl2an $.
    $( [22-Apr-2005] $) $( [3-Apr-2005] $)

  $( Two ways of saying the maximum of two numbers is less than or equal to a
     third. $)
  maxle $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( if ( A <_ B , B , A ) <_ C <-> ( A <_ C /\ B <_ C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cA cif cC cle wbr cA
    cC cle wbr cB cC cle wbr wa cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle
    wbr cB cA cif cC cle wbr cA cC cle wbr cB cC cle wbr cA cr wcel cB cr wcel
    cC cr wcel w3a cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif
    cC cle wbr cA cC cle wbr cA cr wcel cB cr wcel cA cA cB cle wbr cB cA cif
    cle wbr cC cr wcel cA cB max1 3adant3 cA cr wcel cA cB cle wbr cB cA cif cr
    wcel cC cr wcel cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif
    cC cle wbr wa cA cC cle wbr wi cB cr wcel cA cA cB cle wbr cB cA cif cC
    letr cA cr wcel cB cr wcel cA cB cle wbr cB cA cif cr wcel cC cr wcel cB cr
    wcel cA cr wcel cA cB cle wbr cB cA cif cr wcel cA cB cle wbr cB cA cr ifcl
    ancoms 3adant3 syld3an2 mpand cA cr wcel cB cr wcel cC cr wcel w3a cB cA cB
    cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif cC cle wbr cB cC cle wbr
    cA cr wcel cB cr wcel cB cA cB cle wbr cB cA cif cle wbr cC cr wcel cA cB
    max2 3adant3 cB cr wcel cA cB cle wbr cB cA cif cr wcel cC cr wcel cB cA cB
    cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif cC cle wbr wa cB cC cle
    wbr wi cA cr wcel cB cr wcel cC cr wcel w3a cB cA cB cle wbr cB cA cif cC
    letr cA cr wcel cB cr wcel cC cr wcel 3simp2 cA cr wcel cB cr wcel cA cB
    cle wbr cB cA cif cr wcel cC cr wcel cB cr wcel cA cr wcel cA cB cle wbr cB
    cA cif cr wcel cA cB cle wbr cB cA cr ifcl ancoms 3adant3 cA cr wcel cB cr
    wcel cC cr wcel 3simp3 syl3anc mpand jcad cB cC cle wbr cA cC cle wbr cA cB
    cle wbr cB cA cif cC cle wbr cA cB cle wbr cB cC cle wbr cA cC cle wbr cA
    cB cle wbr cB cA cif cC cle wbr cB cA cB cA cB cle wbr cB cA cif cC cle
    breq1 cA cA cB cle wbr cB cA cif cC cle breq1 ifboth ancoms impbid1 $.
    $( [27-Oct-2005] $) $( [29-Sep-2005] $)

  $( The minimum of two numbers is less than or equal to the first. $)
  min1 $p |- ( ( A e. RR /\ B e. RR ) -> if ( A <_ B , A , B ) <_ A ) $=
    cA cxr wcel cB cxr wcel cA cB cle wbr cA cB cif cA cle wbr cA cr wcel cB cr
    wcel cA cB xrmin1 cA rexr cB rexr syl2an $.
    $( [3-Aug-2007] $) $( [3-Aug-2007] $)

  $( The minimum of two numbers is less than or equal to the second. $)
  min2 $p |- ( ( A e. RR /\ B e. RR ) -> if ( A <_ B , A , B ) <_ B ) $=
    cA cxr wcel cB cxr wcel cA cB cle wbr cA cB cif cB cle wbr cA cr wcel cB cr
    wcel cA cB xrmin2 cA rexr cB rexr syl2an $.
    $( [10-Aug-2007] $) $( [3-Aug-2007] $)

  $( Two ways of saying a number is less than or equal to the minimum of two
     others. $)
  lemin $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( A <_ if ( B <_ C , B , C ) <-> ( A <_ B /\ A <_ C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cC cle wbr cB cC cif cle wbr cA
    cB cle wbr cA cC cle wbr wa cA cr wcel cB cr wcel cC cr wcel w3a cA cB cC
    cle wbr cB cC cif cle wbr cA cB cle wbr cA cC cle wbr cA cr wcel cB cr wcel
    cC cr wcel w3a cA cB cC cle wbr cB cC cif cle wbr cB cC cle wbr cB cC cif
    cB cle wbr cA cB cle wbr cB cr wcel cC cr wcel cB cC cle wbr cB cC cif cB
    cle wbr cA cr wcel cB cC min1 3adant1 cA cr wcel cB cC cle wbr cB cC cif cr
    wcel cB cr wcel cA cB cC cle wbr cB cC cif cle wbr cB cC cle wbr cB cC cif
    cB cle wbr wa cA cB cle wbr wi cA cr wcel cB cr wcel cC cr wcel w3a cA cB
    cC cle wbr cB cC cif cB letr cA cr wcel cB cr wcel cC cr wcel 3simp1 cB cr
    wcel cC cr wcel cB cC cle wbr cB cC cif cr wcel cA cr wcel cB cC cle wbr cB
    cC cr ifcl 3adant1 cA cr wcel cB cr wcel cC cr wcel 3simp2 syl3anc mpan2d
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cC cle wbr cB cC cif cle wbr cB
    cC cle wbr cB cC cif cC cle wbr cA cC cle wbr cB cr wcel cC cr wcel cB cC
    cle wbr cB cC cif cC cle wbr cA cr wcel cB cC min2 3adant1 cA cr wcel cB cC
    cle wbr cB cC cif cr wcel cC cr wcel cA cB cC cle wbr cB cC cif cle wbr cB
    cC cle wbr cB cC cif cC cle wbr wa cA cC cle wbr wi cB cr wcel cA cB cC cle
    wbr cB cC cif cC letr cB cr wcel cC cr wcel cB cC cle wbr cB cC cif cr wcel
    cA cr wcel cB cC cle wbr cB cC cr ifcl 3adant1 syld3an2 mpan2d jcad cB cC
    cle wbr cA cB cle wbr cA cC cle wbr cA cB cC cle wbr cB cC cif cle wbr cB
    cC cB cB cC cle wbr cB cC cif cA cle breq2 cC cB cC cle wbr cB cC cif cA
    cle breq2 ifboth impbid1 $.
    $( [18-Aug-2007] $) $( [3-Aug-2007] $)

  $( Two ways of saying the maximum of two numbers is less than a third. $)
  maxlt $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( if ( A <_ B , B , A ) < C <-> ( A < C /\ B < C ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cA cif cC clt wbr cA
    cC clt wbr cB cC clt wbr wa cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle
    wbr cB cA cif cC clt wbr cA cC clt wbr cB cC clt wbr cA cr wcel cB cr wcel
    cC cr wcel w3a cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif
    cC clt wbr cA cC clt wbr cA cr wcel cB cr wcel cA cA cB cle wbr cB cA cif
    cle wbr cC cr wcel cA cB max1 3adant3 cA cr wcel cA cB cle wbr cB cA cif cr
    wcel cC cr wcel cA cA cB cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif
    cC clt wbr wa cA cC clt wbr wi cB cr wcel cA cA cB cle wbr cB cA cif cC
    lelttr cA cr wcel cB cr wcel cA cB cle wbr cB cA cif cr wcel cC cr wcel cB
    cr wcel cA cr wcel cA cB cle wbr cB cA cif cr wcel cA cB cle wbr cB cA cr
    ifcl ancoms 3adant3 syld3an2 mpand cA cr wcel cB cr wcel cC cr wcel w3a cB
    cA cB cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif cC clt wbr cB cC
    clt wbr cA cr wcel cB cr wcel cB cA cB cle wbr cB cA cif cle wbr cC cr wcel
    cA cB max2 3adant3 cB cr wcel cA cB cle wbr cB cA cif cr wcel cC cr wcel cB
    cA cB cle wbr cB cA cif cle wbr cA cB cle wbr cB cA cif cC clt wbr wa cB cC
    clt wbr wi cA cr wcel cB cr wcel cC cr wcel w3a cB cA cB cle wbr cB cA cif
    cC lelttr cA cr wcel cB cr wcel cC cr wcel 3simp2 cA cr wcel cB cr wcel cA
    cB cle wbr cB cA cif cr wcel cC cr wcel cB cr wcel cA cr wcel cA cB cle wbr
    cB cA cif cr wcel cA cB cle wbr cB cA cr ifcl ancoms 3adant3 cA cr wcel cB
    cr wcel cC cr wcel 3simp3 syl3anc mpand jcad cB cC clt wbr cA cC clt wbr cA
    cB cle wbr cB cA cif cC clt wbr cA cB cle wbr cB cC clt wbr cA cC clt wbr
    cA cB cle wbr cB cA cif cC clt wbr cB cA cB cA cB cle wbr cB cA cif cC clt
    breq1 cA cA cB cle wbr cB cA cif cC clt breq1 ifboth ancoms impbid1 $.
    $( [21-Aug-2007] $) $( [3-Aug-2007] $)

  $( Two ways of saying a number is less than the minimum of two others. $)
  ltmin $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( A < if ( B <_ C , B , C ) <-> ( A < B /\ A < C ) ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel cA cB cC cle wbr cB cC cif clt wbr cA
    cB clt wbr cA cC clt wbr wa wb cA cr wcel cB cr wcel cC cr wcel cA cB cC
    xrltmin cA rexr cB rexr cC rexr syl3an $.
    $( [11-Sep-2006] $) $( [1-Sep-2006] $)

  ${
    $d x A $.
    $( If a nonnegative number is less than any positive number, it is zero. $)
    squeeze0 $p |- ( ( A e. RR /\ 0 <_ A /\ A. x e. RR ( 0 < x -> A < x ) ) ->
                   A = 0 ) $=
      cA cr wcel cc0 cA cle wbr cc0 vx cv clt wbr cA vx cv clt wbr wi vx cr
      wral cA cc0 wceq cA cr wcel cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo
      cc0 vx cv clt wbr cA vx cv clt wbr wi vx cr wral cA cc0 wceq wi cc0 cr
      wcel cA cr wcel cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo wb 0re cc0
      cA leloe mpan cA cr wcel cc0 cA clt wbr cc0 vx cv clt wbr cA vx cv clt
      wbr wi vx cr wral cA cc0 wceq wi cc0 cA wceq cA cr wcel cc0 cA clt wbr
      cc0 cA clt wbr cA cA clt wbr wi cA cc0 wceq cc0 vx cv clt wbr cA vx cv
      clt wbr wi vx cr wral cc0 cA clt wbr cA cA clt wbr wi cc0 cA clt wbr cA
      cr wcel cA cc0 wceq cA cA clt wbr cA cr wcel cA cc0 wceq wi cc0 cA clt
      wbr cA cr wcel cA cA clt wbr cA cc0 wceq cA cr wcel cA cA clt wbr cA cc0
      wceq cA ltnr pm2.21d com12 imim2i com13 cc0 vx cv clt wbr cA vx cv clt
      wbr wi cc0 cA clt wbr cA cA clt wbr wi vx cA cr vx cv cA wceq cc0 vx cv
      clt wbr cc0 cA clt wbr cA vx cv clt wbr cA cA clt wbr vx cv cA cc0 clt
      breq2 vx cv cA cA clt breq2 imbi12d rcla4v syl5d cc0 cA wceq cc0 vx cv
      clt wbr cA vx cv clt wbr wi vx cr wral cA cc0 wceq wi wi cA cr wcel cc0
      vx cv clt wbr cA vx cv clt wbr wi vx cr wral cA cc0 wceq wi cA cc0 cA cc0
      wceq cc0 vx cv clt wbr cA vx cv clt wbr wi vx cr wral ax-1 eqcoms a1i
      jaod sylbid 3imp $.
      $( [12-Feb-2006] $) $( [11-Feb-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Natural numbers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The natural numbers of analysis start at one (unlike the ordinal natural
       numbers, i.e. the members of the set ` om ` , ~ df-om , which start at
       zero).  This is the convention used by most analysis books, and it is
       often convenient in proofs because we don't have to worry about
       division by zero.  See ~ nnind for the principle of mathematical
       induction.  See ~ dfnn2 for a slight variant.  See ~ df-n0 for the set
       of nonnegative integers ` NN0 ` starting at zero.  See ~ dfn2 for ` NN `
       defined in terms of ` NN0 ` . $)
    df-n $a |- NN = |^| { x | ( 1 e. x /\ A. y e. x ( y + 1 ) e. x ) } $.
  $}

  ${
    $d x y A $.
    peano5nn.1 $e |- A e. _V $.
    $( Peano's inductive postulate.  Theorem I.36 (principle of mathematical
       induction) of [Apostol] p. 34. $)
    peano5nni $p |- ( ( 1 e. A /\ A. x e. A ( x + 1 ) e. A ) -> NN C_ A ) $=
      c1 cA wcel vx cv c1 caddc co cA wcel vx cA wral wa c1 vy cv wcel vx cv c1
      caddc co vy cv wcel vx vy cv wral wa vy cab cint cA cn c1 cA wcel vx cv
      c1 caddc co cA wcel vx cA wral wa cA c1 vy cv wcel vx cv c1 caddc co vy
      cv wcel vx vy cv wral wa vy cab wcel c1 vy cv wcel vx cv c1 caddc co vy
      cv wcel vx vy cv wral wa vy cab cint cA wss c1 vy cv wcel vx cv c1 caddc
      co vy cv wcel vx vy cv wral wa c1 cA wcel vx cv c1 caddc co cA wcel vx cA
      wral wa vy cA peano5nn.1 vy cv cA wceq c1 vy cv wcel c1 cA wcel vx cv c1
      caddc co vy cv wcel vx vy cv wral vx cv c1 caddc co cA wcel vx cA wral vy
      cv cA c1 eleq2 vx cv c1 caddc co vy cv wcel vx cv c1 caddc co cA wcel vx
      vy cv cA vy cv cA vx cv c1 caddc co eleq2 raleqd anbi12d elab cA c1 vy cv
      wcel vx cv c1 caddc co vy cv wcel vx vy cv wral wa vy cab intss1 sylbir
      vy vx df-n syl5ss $.
      $( [5-Jul-2005] $) $( [10-Jan-1997] $)
  $}


  $( The natural numbers are a subset of the reals. $)
  nnssre $p |- NN C_ RR $=
    c1 cr wcel vx cv c1 caddc co cr wcel vx cr wral cn cr wss 1re vx cv c1
    caddc co cr wcel vx cr vx cv peano2re rgen vx cr reex peano5nni mp2an $.
    $( [10-Jan-1997] $)

  $( The natural numbers are a subset of the complex numbers. $)
  nnsscn $p |- NN C_ CC $=
    cn cr cc nnssre axresscn sstri $.
    $( [17-Aug-2004] $) $( [2-Aug-2004] $)

  $( A natural number is a real number. $)
  nnre $p |- ( A e. NN -> A e. RR ) $=
    cn cr cA nnssre sseli $.
    $( [18-Aug-1999] $)

  $( A natural number is a complex number. $)
  nncn $p |- ( A e. NN -> A e. CC ) $=
    cn cc cA nnsscn sseli $.
    $( [18-Aug-1999] $)

  ${
    nnre.1 $e |- A e. NN $.
    $( A natural number is a real number. $)
    nnrei $p |- A e. RR $=
      cA cn wcel cA cr wcel nnre.1 cA nnre ax-mp $.
      $( [18-Aug-1999] $)

    $( A natural number is a complex number. $)
    nncni $p |- A e. CC $=
      cA cA nnre.1 nnrei recni $.
      $( [18-Aug-1999] $)
  $}

  $( The set of natural numbers exists. $)
  nnex $p |- NN e. _V $=
    cn cr reex nnssre ssexi $.
    $( [3-Oct-1999] $)

  ${
    $d x y z A $.
    $( Peano postulate: 1 is a natural number. $)
    1nn $p |- 1 e. NN $=
      c1 c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx cab
      cint cn c1 c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx
      cab cint wcel c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa
      c1 vx cv wcel wi vx c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv
      wral wa vx c1 c1 cc ax1cn elisseti elintab c1 vx cv wcel vy cv c1 caddc
      co vx cv wcel vy vx cv wral pm3.26 mpgbir vx vy df-n eleqtrri $.
      $( [11-Jan-1997] $)

    $( Peano postulate: a successor of a natural number is a natural number. $)
    peano2nn $p |- ( A e. NN -> ( A + 1 ) e. NN ) $=
      vz cv c1 caddc co cn wcel cA c1 caddc co cn wcel vz cA cn vz cv cA wceq
      vz cv c1 caddc co cA c1 caddc co cn vz cv cA c1 caddc opreq1 eleq1d vz cv
      c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx cab cint
      wcel vz cv c1 caddc co c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx
      cv wral wa vx cab cint wcel vz cv cn wcel vz cv c1 caddc co cn wcel c1 vx
      cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vz cv vx cv wcel wi
      vx wal c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vz cv
      c1 caddc co vx cv wcel wi vx wal vz cv c1 vx cv wcel vy cv c1 caddc co vx
      cv wcel vy vx cv wral wa vx cab cint wcel vz cv c1 caddc co c1 vx cv wcel
      vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx cab cint wcel c1 vx cv
      wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vz cv vx cv wcel wi c1
      vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vz cv c1 caddc
      co vx cv wcel wi vx c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv
      wral wa vz cv vx cv wcel vz cv c1 caddc co vx cv wcel vy cv c1 caddc co
      vx cv wcel vy vx cv wral vz cv vx cv wcel vz cv c1 caddc co vx cv wcel wi
      c1 vx cv wcel vy cv c1 caddc co vx cv wcel vz cv c1 caddc co vx cv wcel
      vy vz cv vx cv vy cv vz cv wceq vy cv c1 caddc co vz cv c1 caddc co vx cv
      vy cv vz cv c1 caddc opreq1 eleq1d rcla4cv adantl a2i 19.20i c1 vx cv
      wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx vz cv vz visset
      elintab c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx vz
      cv c1 caddc co vz cv c1 caddc oprex elintab 3imtr4i cn c1 vx cv wcel vy
      cv c1 caddc co vx cv wcel vy vx cv wral wa vx cab cint vz cv vx vy df-n
      eleq2i cn c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vx
      cab cint vz cv c1 caddc co vx vy df-n eleq2i 3imtr4i vtoclga $.
      $( [11-Jan-1997] $)

    $( Alternate definition of the set of natural numbers.  Definition of
       positive integers in [Apostol] p. 22. $)
    dfnn2 $p |- NN =
               |^| { x | ( x C_ RR /\ 1 e. x /\ A. y e. x ( y + 1 ) e. x ) } $=
      vx cv cr wss c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa
      wa vx cab cint c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral
      wa vx cab cint vx cv cr wss c1 vx cv wcel vy cv c1 caddc co vx cv wcel vy
      vx cv wral w3a vx cab cint cn c1 vx cv wcel vy cv c1 caddc co vx cv wcel
      vy vx cv wral wa c1 vz cv wcel vy cv c1 caddc co vz cv wcel vy vz cv wral
      wa c1 cn wcel vy cv c1 caddc co cn wcel vy cn wral wa vx vz cr vx cv vz
      cv wceq c1 vx cv wcel c1 vz cv wcel vy cv c1 caddc co vx cv wcel vy vx cv
      wral vy cv c1 caddc co vz cv wcel vy vz cv wral vx cv vz cv c1 eleq2 vy
      cv c1 caddc co vx cv wcel vy cv c1 caddc co vz cv wcel vy vx cv vz cv vx
      cv vz cv vy cv c1 caddc co eleq2 raleqd anbi12d vx cv c1 vz cv wcel vy cv
      c1 caddc co vz cv wcel vy vz cv wral wa vz cab cint wceq vx cv cn wceq c1
      vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa c1 cn wcel vy cv
      c1 caddc co cn wcel vy cn wral wa wb cn c1 vz cv wcel vy cv c1 caddc co
      vz cv wcel vy vz cv wral wa vz cab cint vx cv vz vy df-n eqeq2i vx cv cn
      wceq c1 vx cv wcel c1 cn wcel vy cv c1 caddc co vx cv wcel vy vx cv wral
      vy cv c1 caddc co cn wcel vy cn wral vx cv cn c1 eleq2 vy cv c1 caddc co
      vx cv wcel vy cv c1 caddc co cn wcel vy vx cv cn vx cv cn vy cv c1 caddc
      co eleq2 raleqd anbi12d sylbir c1 vz cv wcel vy cv c1 caddc co vz cv wcel
      vy vz cv wral wa vz cab cint cr wss c1 cn wcel vy cv c1 caddc co cn wcel
      vy cn wral wa c1 vz cv wcel vy cv c1 caddc co vz cv wcel vy vz cv wral wa
      vz cab cint cn cr vz vy df-n nnssre eqsstr3i c1 cn wcel vy cv c1 caddc co
      cn wcel vy cn wral 1nn vy cv c1 caddc co cn wcel vy cn vy cv peano2nn
      rgen pm3.2i pm3.2i intabs vx cv cr wss c1 vx cv wcel vy cv c1 caddc co vx
      cv wcel vy vx cv wral w3a vx cab vx cv cr wss c1 vx cv wcel vy cv c1
      caddc co vx cv wcel vy vx cv wral wa wa vx cab vx cv cr wss c1 vx cv wcel
      vy cv c1 caddc co vx cv wcel vy vx cv wral w3a vx cv cr wss c1 vx cv wcel
      vy cv c1 caddc co vx cv wcel vy vx cv wral wa wa vx vx cv cr wss c1 vx cv
      wcel vy cv c1 caddc co vx cv wcel vy vx cv wral 3anass abbii inteqi vx vy
      df-n 3eqtr4ri $.
      $( [10-Jul-2005] $) $( [3-Jul-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Principle of mathematical induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    nnind.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nnind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nnind.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nnind.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    nnind.5 $e |- ps $.
    $( Induction hypothesis. $)
    nnind.6 $e |- ( y e. NN -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction (inference schema).  The first
       four hypotheses give us the substitution instances we need; the last
       two are the basis and the induction hypothesis.  See ~ nnaddcl for
       an example of its use.  See ~ nn0ind for induction on nonnegative
       integers and ~ uzind , ~ uzind4 for induction on an arbitrary set of
       upper integers.  See ~ indstr for strong induction. $)
    nnind $p |- ( A e. NN -> ta ) $=
      cA cn wcel cA cn wcel wta cA cn wcel cA wph vx cn crab wcel cA cn wcel
      wta wa cn wph vx cn crab cA c1 wph vx cn crab wcel vy cv c1 caddc co wph
      vx cn crab wcel vy wph vx cn crab wral cn wph vx cn crab wss c1 wph vx cn
      crab wcel c1 cn wcel wps wph wps vx c1 cn nnind.1 elrab 1nn nnind.5
      mpbir2an vy cv c1 caddc co wph vx cn crab wcel vy wph vx cn crab vy cv cn
      wcel vy cv wph vx cn crab wcel vy cv c1 caddc co wph vx cn crab wcel wph
      vx cn crab cn vy cv wph vx cn ssrab2 sseli vy cv cn wcel vy cv cn wcel
      wch wa vy cv c1 caddc co cn wcel wth wa vy cv wph vx cn crab wcel vy cv
      c1 caddc co wph vx cn crab wcel vy cv cn wcel vy cv cn wcel vy cv c1
      caddc co cn wcel wch wth vy cv cn wcel vy cv c1 caddc co cn wcel vy cv cn
      wcel vy cv peano2nn a1d nnind.6 anim12d wph wch vx vy cv cn nnind.2 elrab
      wph wth vx vy cv c1 caddc co cn nnind.3 elrab 3imtr4g mpcom rgen vy wph
      vx cn crab wph vx cn nnex rabex peano5nni mp2an sseli wph wta vx cA cn
      nnind.4 elrab sylib pm3.27d $.
      $( [10-Jan-1997] $)
  $}

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Induction hypothesis. $)
    nnindALT.6 $e |- ( y e. NN -> ( ch -> th ) ) $.
    $( Basis. $)
    nnindALT.5 $e |- ps $.
    $( Substitutions. $)
    nnindALT.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nnindALT.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nnindALT.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nnindALT.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Principle of Mathematical Induction (inference schema).  The last
       four hypotheses give us the substitution instances we need; the first
       two are the induction hypothesis and the basis.  (This ALT version of
       ~ nnind is easier to use with the Proof Assistant since 'assign last'
       will be applied to the substitution instances first.  We may switch to
       it as the official version.) $)
    nnindALT $p |- ( A e. NN -> ta ) $=
      wph wps wch wth wta vx vy cA nnindALT.1 nnindALT.2 nnindALT.3 nnindALT.4
      nnindALT.5 nnindALT.6 nnind $.
      $( [19-Aug-2007] $) $( [7-Dec-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Natural numbers (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.  $d x y z A $.  $d x ps $.  $d x ch $.  $d x z th $.
    $d y z ph $.
    $( Substitutions. $)
    nn1suc.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nn1suc.3 $e |- ( x = ( y + 1 ) -> ( ph <-> ch ) ) $.
    nn1suc.4 $e |- ( x = A -> ( ph <-> th ) ) $.
    $( Hypothesis showing it holds for 1. $)
    nn1suc.5 $e |- ps $.
    $( Hypothesis showing it holds for a successor. $)
    nn1suc.6 $e |- ( y e. NN -> ch ) $.
    $( If a statement holds for 1 and also holds for a successor, it holds for
       all natural numbers.  The first three hypotheses give us the
       substitution instances we need; the last two show that it holds for 1
       and for a successor. $)
    nn1suc $p |- ( A e. NN -> th ) $=
      cA cn wcel wth cA cn wcel wph wi vx vz cv wsbc cA cn wcel wph wi vx c1
      wsbc cA cn wcel wph wi vx vy cv wsbc cA cn wcel wph wi vx vy cv c1 caddc
      co wsbc cA cn wcel wth wi vz vy cA cA cn wcel wph wi vx vz cv c1 dfsbcq
      cA cn wcel wph wi vz vy vx sbequ cA cn wcel wph wi vx vz cv vy cv c1
      caddc co dfsbcq vz cv cA wceq cA cn wcel wph vx vz cv wsbc wi cA cn wcel
      wth wi cA cn wcel wph wi vx vz cv wsbc vz cv cA wceq cA cn wcel wph vx vz
      cv wsbc wth cA cn wcel vz cv cA wceq wph vx vz cv wsbc wth wb vz cv cA
      wceq wph vx vz cv wsbc wph vx cA wsbc cA cn wcel wth wph vx vz cv cA
      dfsbcq cA cn wcel wph vx cA wsbc wth wb cA cn wcel cA cn wcel wph vx cA
      wsbc wth cA cn wcel vx cv cA wceq vx wex cA cn wcel wph vx cA wsbc wi cA
      cn wcel wth wi wb vx cA cn elex vx cv cA wceq cA cn wcel wph vx cA wsbc
      wi cA cn wcel wth wi wb vx cA cn wcel wph vx cA wsbc wi cA cn wcel wth wi
      vx wph vx vz cA cn vz cv cA wcel vx ax-17 hbsbc1 cA cn wcel wth wi vx
      ax-17 hbbi vx cv cA wceq wph vx cA wsbc wth cA cn wcel vx cv cA wceq wph
      wph vx cA wsbc wth wph vx cA sbceq1a nn1suc.4 bitr3d imbi2d 19.23ai syl
      pm5.74rd pm2.43i sylan9bbr expcom pm5.74d cA cn wcel wph vx vz cA cn wcel
      vx ax-17 sb19.21 syl5bb cA cn wcel wph wi vx c1 wsbc cA cn wcel wph vx c1
      wsbc wi wph vx c1 wsbc cA cn wcel vx cv c1 wceq vx wex wph vx c1 wsbc vx
      c1 c1 cn 1nn elisseti isseti vx cv c1 wceq wph vx c1 wsbc vx wph vx c1 c1
      cn 1nn elisseti hbsbc1v vx cv c1 wceq wph wph vx c1 wsbc vx cv c1 wceq
      wph wps nn1suc.5 nn1suc.1 mpbiri wph vx c1 sbceq1a mpbid 19.23ai ax-mp
      a1i c1 cvv wcel cA cn wcel wph wi vx c1 wsbc cA cn wcel wph vx c1 wsbc wi
      wb c1 cn 1nn elisseti cA cn wcel wph vx c1 cvv cA cn wcel vx ax-17
      sbc19.21g ax-mp mpbir vy cv cn wcel cA cn wcel wph wi vx vy cv c1 caddc
      co wsbc cA cn wcel wph wi vx vy cv wsbc vy cv cn wcel cA cn wcel wph vx
      vy cv c1 caddc co wsbc wi cA cn wcel wph wi vx vy cv c1 caddc co wsbc vy
      cv cn wcel wph vx vy cv c1 caddc co wsbc cA cn wcel vy cv cn wcel wch wph
      vx vy cv c1 caddc co wsbc nn1suc.6 vx cv vy cv c1 caddc co wceq vx wex
      wch wph vx vy cv c1 caddc co wsbc wb vx vy cv c1 caddc co vy cv c1 caddc
      oprex isseti vx cv vy cv c1 caddc co wceq wch wph vx vy cv c1 caddc co
      wsbc wb vx wch wph vx vy cv c1 caddc co wsbc vx wch vx ax-17 wph vx vy cv
      c1 caddc co vy cv c1 caddc oprex hbsbc1v hbbi vx cv vy cv c1 caddc co
      wceq wph wch wph vx vy cv c1 caddc co wsbc nn1suc.3 wph vx vy cv c1 caddc
      co sbceq1a bitr3d 19.23ai ax-mp sylib a1d vy cv c1 caddc co cvv wcel cA
      cn wcel wph wi vx vy cv c1 caddc co wsbc cA cn wcel wph vx vy cv c1 caddc
      co wsbc wi wb vy cv c1 caddc oprex cA cn wcel wph vx vy cv c1 caddc co
      cvv cA cn wcel vx ax-17 sbc19.21g ax-mp sylibr a1d nnind pm2.43i $.
      $( [17-Oct-2004] $) $( [11-Oct-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Closure of addition of natural numbers, proved by induction on the
       second addend. $)
    nnaddcl $p |- ( ( A e. NN /\ B e. NN ) -> ( A + B ) e. NN ) $=
      cB cn wcel cA cn wcel cA cB caddc co cn wcel cA cn wcel cA vx cv caddc co
      cn wcel wi cA cn wcel cA c1 caddc co cn wcel wi cA cn wcel cA vy cv caddc
      co cn wcel wi cA cn wcel cA vy cv c1 caddc co caddc co cn wcel wi cA cn
      wcel cA cB caddc co cn wcel wi vx vy cB vx cv c1 wceq cA vx cv caddc co
      cn wcel cA c1 caddc co cn wcel cA cn wcel vx cv c1 wceq cA vx cv caddc co
      cA c1 caddc co cn vx cv c1 cA caddc opreq2 eleq1d imbi2d vx cv vy cv wceq
      cA vx cv caddc co cn wcel cA vy cv caddc co cn wcel cA cn wcel vx cv vy
      cv wceq cA vx cv caddc co cA vy cv caddc co cn vx cv vy cv cA caddc
      opreq2 eleq1d imbi2d vx cv vy cv c1 caddc co wceq cA vx cv caddc co cn
      wcel cA vy cv c1 caddc co caddc co cn wcel cA cn wcel vx cv vy cv c1
      caddc co wceq cA vx cv caddc co cA vy cv c1 caddc co caddc co cn vx cv vy
      cv c1 caddc co cA caddc opreq2 eleq1d imbi2d vx cv cB wceq cA vx cv caddc
      co cn wcel cA cB caddc co cn wcel cA cn wcel vx cv cB wceq cA vx cv caddc
      co cA cB caddc co cn vx cv cB cA caddc opreq2 eleq1d imbi2d cA peano2nn
      vy cv cn wcel cA cn wcel cA vy cv caddc co cn wcel cA vy cv c1 caddc co
      caddc co cn wcel cA cn wcel vy cv cn wcel cA vy cv caddc co cn wcel cA vy
      cv c1 caddc co caddc co cn wcel wi cA cn wcel vy cv cn wcel wa cA vy cv
      caddc co c1 caddc co cn wcel cA vy cv c1 caddc co caddc co cn wcel cA vy
      cv caddc co cn wcel cA cn wcel vy cv cn wcel wa cA vy cv caddc co c1
      caddc co cA vy cv c1 caddc co caddc co cn cA cc wcel vy cv cc wcel cA vy
      cv caddc co c1 caddc co cA vy cv c1 caddc co caddc co wceq cA cn wcel vy
      cv cn wcel cA cc wcel vy cv cc wcel c1 cc wcel cA vy cv caddc co c1 caddc
      co cA vy cv c1 caddc co caddc co wceq ax1cn cA vy cv c1 addass mp3an3 cA
      nncn vy cv nncn syl2an eleq1d cA vy cv caddc co peano2nn syl5bi expcom
      a2d nnind impcom $.
      $( [12-Jan-1997] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Closure of multiplication of natural numbers. $)
    nnmulcl $p |- ( ( A e. NN /\ B e. NN ) -> ( A x. B ) e. NN ) $=
      cB cn wcel cA cn wcel cA cB cmul co cn wcel cA cn wcel cA vx cv cmul co
      cn wcel wi cA cn wcel cA c1 cmul co cn wcel wi cA cn wcel cA vy cv cmul
      co cn wcel wi cA cn wcel cA vy cv c1 caddc co cmul co cn wcel wi cA cn
      wcel cA cB cmul co cn wcel wi vx vy cB vx cv c1 wceq cA vx cv cmul co cn
      wcel cA c1 cmul co cn wcel cA cn wcel vx cv c1 wceq cA vx cv cmul co cA
      c1 cmul co cn vx cv c1 cA cmul opreq2 eleq1d imbi2d vx cv vy cv wceq cA
      vx cv cmul co cn wcel cA vy cv cmul co cn wcel cA cn wcel vx cv vy cv
      wceq cA vx cv cmul co cA vy cv cmul co cn vx cv vy cv cA cmul opreq2
      eleq1d imbi2d vx cv vy cv c1 caddc co wceq cA vx cv cmul co cn wcel cA vy
      cv c1 caddc co cmul co cn wcel cA cn wcel vx cv vy cv c1 caddc co wceq cA
      vx cv cmul co cA vy cv c1 caddc co cmul co cn vx cv vy cv c1 caddc co cA
      cmul opreq2 eleq1d imbi2d vx cv cB wceq cA vx cv cmul co cn wcel cA cB
      cmul co cn wcel cA cn wcel vx cv cB wceq cA vx cv cmul co cA cB cmul co
      cn vx cv cB cA cmul opreq2 eleq1d imbi2d cA cc wcel cA cn wcel cA c1 cmul
      co cn wcel cA nncn cA cc wcel cA c1 cmul co cn wcel cA cn wcel cA cc wcel
      cA c1 cmul co cA cn cA ax1id eleq1d biimprd mpcom vy cv cn wcel cA cn
      wcel cA vy cv cmul co cn wcel cA vy cv c1 caddc co cmul co cn wcel vy cv
      cn wcel cA cn wcel cA vy cv cmul co cn wcel cA vy cv c1 caddc co cmul co
      cn wcel wi cA cn wcel vy cv cn wcel cA cn wcel cA vy cv cmul co cn wcel
      cA vy cv c1 caddc co cmul co cn wcel cA cn wcel vy cv cn wcel wa cA vy cv
      c1 caddc co cmul co cn wcel cA vy cv cmul co cA caddc co cn wcel cA cn
      wcel cA vy cv cmul co cn wcel wa cA cn wcel vy cv cn wcel wa cA vy cv c1
      caddc co cmul co cA vy cv cmul co cA caddc co cn cA cc wcel vy cv cc wcel
      cA vy cv c1 caddc co cmul co cA vy cv cmul co cA caddc co wceq cA cn wcel
      vy cv cn wcel cA cc wcel vy cv cc wcel wa cA vy cv c1 caddc co cmul co cA
      vy cv cmul co cA c1 cmul co caddc co cA vy cv cmul co cA caddc co cA cc
      wcel vy cv cc wcel c1 cc wcel cA vy cv c1 caddc co cmul co cA vy cv cmul
      co cA c1 cmul co caddc co wceq ax1cn cA vy cv c1 adddi mp3an3 cA cc wcel
      cA vy cv cmul co cA c1 cmul co caddc co cA vy cv cmul co cA caddc co wceq
      vy cv cc wcel cA cc wcel cA c1 cmul co cA cA vy cv cmul co caddc cA ax1id
      opreq2d adantr eqtrd cA nncn vy cv nncn syl2an eleq1d cA vy cv cmul co cn
      wcel cA cn wcel cA vy cv cmul co cA caddc co cn wcel cA vy cv cmul co cA
      nnaddcl ancoms syl5bir exp4b pm2.43b a2d nnind impcom $.
      $( [12-Jan-1997] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( There exists a natural number greater than or equal to any two
       others. $)
    nn2ge $p |- ( ( A e. NN /\ B e. NN ) ->
                E. x e. NN ( A <_ x /\ B <_ x ) ) $=
      cA cn wcel cB cn wcel wa cA vx cv cle wbr cB vx cv cle wbr wa vx cn wrex
      cA cB cA cn wcel cA cr wcel cB cn wcel cA nnre adantr cB cn wcel cB cr
      wcel cA cn wcel cB nnre adantl cB cn wcel cA cB cle wbr cA vx cv cle wbr
      cB vx cv cle wbr wa vx cn wrex cA cn wcel cB cn wcel cA cB cle wbr cA cB
      cle wbr cB cB cle wbr wa cA vx cv cle wbr cB vx cv cle wbr wa vx cn wrex
      cB cr wcel cA cB cle wbr cA cB cle wbr cB cB cle wbr wa cB cn wcel cB cr
      wcel cA cB cle wbr cA cB cle wbr cB cB cle wbr wa cB cr wcel cB cB cle
      wbr cA cB cle wbr cB leid biantrud biimpa cB nnre sylan cA vx cv cle wbr
      cB vx cv cle wbr wa cA cB cle wbr cB cB cle wbr wa vx cB cn vx cv cB wceq
      cA vx cv cle wbr cA cB cle wbr cB vx cv cle wbr cB cB cle wbr vx cv cB cA
      cle breq2 vx cv cB cB cle breq2 anbi12d rcla4ev syldan adantll cA cn wcel
      cB cA cle wbr cA vx cv cle wbr cB vx cv cle wbr wa vx cn wrex cB cn wcel
      cA cn wcel cB cA cle wbr cA cA cle wbr cB cA cle wbr wa cA vx cv cle wbr
      cB vx cv cle wbr wa vx cn wrex cA cr wcel cB cA cle wbr cA cA cle wbr cB
      cA cle wbr wa cA cn wcel cA cr wcel cA cA cle wbr cB cA cle wbr cA leid
      anim1i cA nnre sylan cA vx cv cle wbr cB vx cv cle wbr wa cA cA cle wbr
      cB cA cle wbr wa vx cA cn vx cv cA wceq cA vx cv cle wbr cA cA cle wbr cB
      vx cv cle wbr cB cA cle wbr vx cv cA cA cle breq2 vx cv cA cB cle breq2
      anbi12d rcla4ev syldan adantlr lecasei $.
      $( [18-Aug-1999] $)
  $}

  ${
    $d x y A $.
    $( A natural number is one or greater. $)
    nnge1 $p |- ( A e. NN -> 1 <_ A ) $=
      c1 vx cv cle wbr c1 c1 cle wbr c1 vy cv cle wbr c1 vy cv c1 caddc co cle
      wbr c1 cA cle wbr vx vy cA vx cv c1 c1 cle breq2 vx cv vy cv c1 cle breq2
      vx cv vy cv c1 caddc co c1 cle breq2 vx cv cA c1 cle breq2 c1 1re leidi
      vy cv cn wcel vy cv cr wcel c1 vy cv cle wbr c1 vy cv c1 caddc co cle wbr
      wi vy cv nnre vy cv cr wcel c1 vy cv cle wbr c1 vy cv cc0 caddc co cle
      wbr c1 vy cv c1 caddc co cle wbr vy cv cr wcel vy cv cc0 caddc co vy cv
      c1 cle vy cv cr wcel vy cv cc wcel vy cv cc0 caddc co vy cv wceq vy cv
      recn vy cv addid1 syl breq2d vy cv cr wcel vy cv cc0 caddc co c1 clt wbr
      wn vy cv c1 caddc co c1 clt wbr wn c1 vy cv cc0 caddc co cle wbr c1 vy cv
      c1 caddc co cle wbr vy cv cr wcel vy cv c1 caddc co c1 clt wbr vy cv cc0
      caddc co c1 clt wbr vy cv cr wcel vy cv cc0 caddc co vy cv c1 caddc co
      clt wbr vy cv c1 caddc co c1 clt wbr vy cv cc0 caddc co c1 clt wbr vy cv
      cr wcel cc0 c1 clt wbr vy cv cc0 caddc co vy cv c1 caddc co clt wbr lt01
      cc0 cr wcel c1 cr wcel vy cv cr wcel cc0 c1 clt wbr vy cv cc0 caddc co vy
      cv c1 caddc co clt wbr wi 0re 1re cc0 c1 vy cv axltadd mp3an12 mpi vy cv
      cc0 caddc co cr wcel vy cv c1 caddc co cr wcel vy cv cc0 caddc co vy cv
      c1 caddc co clt wbr vy cv c1 caddc co c1 clt wbr wa vy cv cc0 caddc co c1
      clt wbr wi vy cv cr wcel vy cv cc0 caddc co cr wcel vy cv c1 caddc co cr
      wcel c1 cr wcel vy cv cc0 caddc co vy cv c1 caddc co clt wbr vy cv c1
      caddc co c1 clt wbr wa vy cv cc0 caddc co c1 clt wbr wi 1re vy cv cc0
      caddc co vy cv c1 caddc co c1 axlttrn mp3an3 vy cv cr wcel cc0 cr wcel vy
      cv cc0 caddc co cr wcel 0re vy cv cc0 readdcl mpan2 vy cv peano2re sylanc
      mpand con3d c1 cr wcel vy cv cc0 caddc co cr wcel c1 vy cv cc0 caddc co
      cle wbr vy cv cc0 caddc co c1 clt wbr wn wb vy cv cr wcel c1 vy cv cc0
      caddc co lenlt 1re vy cv cr wcel cc0 cr wcel vy cv cc0 caddc co cr wcel
      0re vy cv cc0 readdcl mpan2 sylancr c1 cr wcel vy cv c1 caddc co cr wcel
      c1 vy cv c1 caddc co cle wbr vy cv c1 caddc co c1 clt wbr wn wb vy cv cr
      wcel c1 vy cv c1 caddc co lenlt 1re vy cv peano2re sylancr 3imtr4d
      sylbird syl nnind $.
      $( [25-Aug-1999] $)
  $}

  $( A natural number is greater than one iff it is not equal to one. $)
  nngt1ne1 $p |- ( A e. NN -> ( 1 < A <-> A =/= 1 ) ) $=
    cA cr wcel c1 cA cle wbr c1 cA clt wbr cA c1 wne wb cA cn wcel c1 cr wcel
    cA cr wcel c1 cA cle wbr c1 cA clt wbr cA c1 wne wb 1re c1 cA leltne mp3an1
    cA nnre cA nnge1 sylanc $.
    $( [20-Jul-2007] $) $( [7-Oct-2004] $)

  $( A natural number is less than or equal to one iff it is equal to one. $)
  nnle1eq1 $p |- ( A e. NN -> ( A <_ 1 <-> A = 1 ) ) $=
    cA cn wcel cA c1 cle wbr cA c1 cle wbr c1 cA cle wbr wa cA c1 wceq cA cn
    wcel c1 cA cle wbr cA c1 cle wbr cA nnge1 biantrud cA cr wcel c1 cr wcel cA
    c1 wceq cA c1 cle wbr c1 cA cle wbr wa wb cA cn wcel cA c1 letri3 cA nnre
    1re sylancl bitr4d $.
    $( [22-Apr-2005] $) $( [3-Apr-2005] $)

  $( A natural number is positive. $)
  nngt0 $p |- ( A e. NN -> 0 < A ) $=
    cA cr wcel c1 cA cle wbr cc0 cA clt wbr cA cn wcel cA cr wcel cc0 c1 clt
    wbr c1 cA cle wbr cc0 cA clt wbr lt01 cc0 cr wcel c1 cr wcel cA cr wcel cc0
    c1 clt wbr c1 cA cle wbr wa cc0 cA clt wbr wi 0re 1re cc0 c1 cA ltletr
    mp3an12 mpani cA nnre cA nnge1 sylc $.
    $( [26-Sep-1999] $)

  $( A number less than one is not a natural number. $)
  lt1nnn $p |- ( ( A e. RR /\ A < 1 ) -> -. A e. NN ) $=
    cA cr wcel cA c1 clt wbr cA cn wcel wn cA cr wcel cA c1 clt wbr c1 cA cle
    wbr wn cA cn wcel wn cA cr wcel c1 cr wcel cA c1 clt wbr c1 cA cle wbr wn
    wb 1re cA c1 ltnle mpan2 cA cn wcel c1 cA cle wbr cA nnge1 con3i syl6bi imp
    $.
    $( [18-Jan-2004] $) $( [18-Jan-2004] $)

  $( Zero is not a natural number. $)
  0nnn $p |- -. 0 e. NN $=
    cc0 cr wcel cc0 c1 clt wbr cc0 cn wcel wn 0re lt01 cc0 lt1nnn mp2an $.
    $( [25-Aug-1999] $)

  $( A natural number is non-zero. $)
  nnne0 $p |- ( A e. NN -> A =/= 0 ) $=
    cA cn wcel cA cc0 cA cc0 wceq cA cn wcel cc0 cn wcel 0nnn cA cc0 cn eleq1
    mtbiri necon2ai $.
    $( [27-Sep-1999] $)

  ${
    nngt0.1 $e |- A e. NN $.
    $( A natural number is positive (inference version). $)
    nngt0i $p |- 0 < A $=
      cA cn wcel cc0 cA clt wbr nngt0.1 cA nngt0 ax-mp $.
      $( [17-Sep-1999] $)

    $( A natural number is non-zero (inference version). $)
    nnne0i $p |- A =/= 0 $=
      cA cA nngt0.1 nnrei cA nngt0.1 nngt0i gt0ne0ii $.
      $( [25-Aug-1999] $)
  $}

  $( The quotient of a real and a natural number is real. $)
  nndivre $p |- ( ( A e. RR /\ N e. NN ) -> ( A / N ) e. RR ) $=
    cA cr wcel cN cr wcel cN cc0 wne wa cA cN cdiv co cr wcel cN cn wcel cA cr
    wcel cN cr wcel cN cc0 wne cA cN cdiv co cr wcel cA cN redivcl 3expb cN cn
    wcel cN cr wcel cN cc0 wne cN nnre cN nnne0 jca sylan2 $.
    $( [1-Dec-2008] $) $( [28-Nov-2008] $)

  $( The reciprocal of a natural number is real. $)
  nnrecre $p |- ( N e. NN -> ( 1 / N ) e. RR ) $=
    c1 cr wcel cN cn wcel c1 cN cdiv co cr wcel 1re c1 cN nndivre mpan $.
    $( [16-Aug-2008] $) $( [8-Feb-2008] $)

  $( The reciprocal of a natural number is positive. $)
  nnrecgt0 $p |- ( A e. NN -> 0 < ( 1 / A ) ) $=
    cA cn wcel c1 cA cle wbr cc0 c1 cA cdiv co clt wbr cA nnge1 cA cn wcel cc0
    c1 clt wbr c1 cA cle wbr cc0 c1 cA cdiv co clt wbr lt01 cA cn wcel cA cr
    wcel cc0 c1 clt wbr c1 cA cle wbr wa cc0 c1 cA cdiv co clt wbr wi cA nnre
    cA cr wcel cc0 c1 clt wbr c1 cA cle wbr wa cc0 cA clt wbr cc0 c1 cA cdiv co
    clt wbr cc0 cr wcel c1 cr wcel cA cr wcel cc0 c1 clt wbr c1 cA cle wbr wa
    cc0 cA clt wbr wi 0re 1re cc0 c1 cA ltletr mp3an12 cA cr wcel cc0 cA clt
    wbr cc0 c1 cA cdiv co clt wbr cA recgt0 ex syld syl mpani mpd $.
    $( [25-Aug-1999] $)

  ${
    $d x y z w v A $.  $d x y z w v B $.
    $( Natural number ordering relation. $)
    nnleltp1 $p |- ( ( A e. NN /\ B e. NN ) ->
                  ( A <_ B <-> A < ( B + 1 ) ) ) $=
      cA cn wcel cB cn wcel wa cA cB cle wbr cA cB clt wbr cA cB wceq wo cA cB
      c1 caddc co clt wbr cA cr wcel cB cr wcel cA cB cle wbr cA cB clt wbr cA
      cB wceq wo wb cA cn wcel cB cn wcel cA cB leloe cA nnre cB nnre syl2an cA
      cn wcel cB cn wcel wa cA cB clt wbr cA cB wceq wo cA cB c1 caddc co clt
      wbr cA cr wcel cB cr wcel cA cB clt wbr cA cB wceq wo cA cB c1 caddc co
      clt wbr wi cA cn wcel cB cn wcel cA cr wcel cB cr wcel wa cA cB clt wbr
      cA cB c1 caddc co clt wbr cA cB wceq cA cr wcel cB cr wcel wa cA cB clt
      wbr cA cc0 caddc co cB c1 caddc co clt wbr cA cB c1 caddc co clt wbr cA
      cr wcel cB cr wcel wa cA cB clt wbr cc0 c1 clt wbr cA cc0 caddc co cB c1
      caddc co clt wbr lt01 cA cr wcel cB cr wcel wa cc0 cr wcel c1 cr wcel cA
      cB clt wbr cc0 c1 clt wbr wa cA cc0 caddc co cB c1 caddc co clt wbr wi
      0re 1re cA cr wcel cc0 cr wcel cB cr wcel c1 cr wcel cA cB clt wbr cc0 c1
      clt wbr wa cA cc0 caddc co cB c1 caddc co clt wbr wi cA cc0 cB c1 lt2add
      an4s mpanr12 mpan2i cA cr wcel cB cr wcel wa cA cc0 caddc co cA cB c1
      caddc co clt cA cr wcel cB cr wcel wa cA cr wcel cA cc wcel cA cc0 caddc
      co cA wceq cA cr wcel cB cr wcel pm3.26 cA recn cA addid1 3syl breq1d
      sylibd cB cr wcel cA cB wceq cA cB c1 caddc co clt wbr wi cA cr wcel cA
      cB wceq cA cB c1 caddc co clt wbr cB cB c1 caddc co clt wbr cB cr wcel cA
      cB cB c1 caddc co clt breq1 cB ltp1 syl5cbir adantl jaod cA nnre cB nnre
      syl2an cA cn wcel cB cn wcel cA cB c1 caddc co clt wbr cA cB clt wbr cA
      cB wceq wo wi cA cn wcel vz cv cB c1 caddc co clt wbr vz cv cB clt wbr vz
      cv cB wceq wo wi vz cn wral cA cB c1 caddc co clt wbr cA cB clt wbr cA cB
      wceq wo wi cB cn wcel vz cv cB c1 caddc co clt wbr vz cv cB clt wbr vz cv
      cB wceq wo wi cA cB c1 caddc co clt wbr cA cB clt wbr cA cB wceq wo wi vz
      cA cn vz cv cA wceq vz cv cB c1 caddc co clt wbr cA cB c1 caddc co clt
      wbr vz cv cB clt wbr vz cv cB wceq wo cA cB clt wbr cA cB wceq wo vz cv
      cA cB c1 caddc co clt breq1 vz cv cA wceq vz cv cB clt wbr cA cB clt wbr
      vz cv cB wceq cA cB wceq vz cv cA cB clt breq1 vz cv cA cB eqeq1 orbi12d
      imbi12d rcla4v vz cv vx cv c1 caddc co clt wbr vz cv vx cv clt wbr vz cv
      vx cv wceq wo wi vz cn wral vz cv c1 c1 caddc co clt wbr vz cv c1 clt wbr
      vz cv c1 wceq wo wi vz cn wral vz cv vy cv c1 caddc co clt wbr vz cv vy
      cv clt wbr vz cv vy cv wceq wo wi vz cn wral vz cv vy cv c1 caddc co c1
      caddc co clt wbr vz cv vy cv c1 caddc co clt wbr vz cv vy cv c1 caddc co
      wceq wo wi vz cn wral vz cv cB c1 caddc co clt wbr vz cv cB clt wbr vz cv
      cB wceq wo wi vz cn wral vx vy cB vx cv c1 wceq vz cv vx cv c1 caddc co
      clt wbr vz cv vx cv clt wbr vz cv vx cv wceq wo wi vz cv c1 c1 caddc co
      clt wbr vz cv c1 clt wbr vz cv c1 wceq wo wi vz cn vx cv c1 wceq vz cv vx
      cv c1 caddc co clt wbr vz cv c1 c1 caddc co clt wbr vz cv vx cv clt wbr
      vz cv vx cv wceq wo vz cv c1 clt wbr vz cv c1 wceq wo vx cv c1 wceq vx cv
      c1 caddc co c1 c1 caddc co vz cv clt vx cv c1 c1 caddc opreq1 breq2d vx
      cv c1 wceq vz cv vx cv clt wbr vz cv c1 clt wbr vz cv vx cv wceq vz cv c1
      wceq vx cv c1 vz cv clt breq2 vx cv c1 vz cv eqeq2 orbi12d imbi12d
      ralbidv vx cv vy cv wceq vz cv vx cv c1 caddc co clt wbr vz cv vx cv clt
      wbr vz cv vx cv wceq wo wi vz cv vy cv c1 caddc co clt wbr vz cv vy cv
      clt wbr vz cv vy cv wceq wo wi vz cn vx cv vy cv wceq vz cv vx cv c1
      caddc co clt wbr vz cv vy cv c1 caddc co clt wbr vz cv vx cv clt wbr vz
      cv vx cv wceq wo vz cv vy cv clt wbr vz cv vy cv wceq wo vx cv vy cv wceq
      vx cv c1 caddc co vy cv c1 caddc co vz cv clt vx cv vy cv c1 caddc opreq1
      breq2d vx cv vy cv wceq vz cv vx cv clt wbr vz cv vy cv clt wbr vz cv vx
      cv wceq vz cv vy cv wceq vx cv vy cv vz cv clt breq2 vx cv vy cv vz cv
      eqeq2 orbi12d imbi12d ralbidv vx cv vy cv c1 caddc co wceq vz cv vx cv c1
      caddc co clt wbr vz cv vx cv clt wbr vz cv vx cv wceq wo wi vz cv vy cv
      c1 caddc co c1 caddc co clt wbr vz cv vy cv c1 caddc co clt wbr vz cv vy
      cv c1 caddc co wceq wo wi vz cn vx cv vy cv c1 caddc co wceq vz cv vx cv
      c1 caddc co clt wbr vz cv vy cv c1 caddc co c1 caddc co clt wbr vz cv vx
      cv clt wbr vz cv vx cv wceq wo vz cv vy cv c1 caddc co clt wbr vz cv vy
      cv c1 caddc co wceq wo vx cv vy cv c1 caddc co wceq vx cv c1 caddc co vy
      cv c1 caddc co c1 caddc co vz cv clt vx cv vy cv c1 caddc co c1 caddc
      opreq1 breq2d vx cv vy cv c1 caddc co wceq vz cv vx cv clt wbr vz cv vy
      cv c1 caddc co clt wbr vz cv vx cv wceq vz cv vy cv c1 caddc co wceq vx
      cv vy cv c1 caddc co vz cv clt breq2 vx cv vy cv c1 caddc co vz cv eqeq2
      orbi12d imbi12d ralbidv vx cv cB wceq vz cv vx cv c1 caddc co clt wbr vz
      cv vx cv clt wbr vz cv vx cv wceq wo wi vz cv cB c1 caddc co clt wbr vz
      cv cB clt wbr vz cv cB wceq wo wi vz cn vx cv cB wceq vz cv vx cv c1
      caddc co clt wbr vz cv cB c1 caddc co clt wbr vz cv vx cv clt wbr vz cv
      vx cv wceq wo vz cv cB clt wbr vz cv cB wceq wo vx cv cB wceq vx cv c1
      caddc co cB c1 caddc co vz cv clt vx cv cB c1 caddc opreq1 breq2d vx cv
      cB wceq vz cv vx cv clt wbr vz cv cB clt wbr vz cv vx cv wceq vz cv cB
      wceq vx cv cB vz cv clt breq2 vx cv cB vz cv eqeq2 orbi12d imbi12d
      ralbidv vz cv c1 c1 caddc co clt wbr vz cv c1 clt wbr vz cv c1 wceq wo wi
      vz cn vx cv c1 c1 caddc co clt wbr vx cv c1 clt wbr vx cv c1 wceq wo wi
      c1 c1 c1 caddc co clt wbr c1 c1 clt wbr c1 c1 wceq wo wi vy cv c1 caddc
      co c1 c1 caddc co clt wbr vy cv c1 caddc co c1 clt wbr vy cv c1 caddc co
      c1 wceq wo wi vz cv c1 c1 caddc co clt wbr vz cv c1 clt wbr vz cv c1 wceq
      wo wi vx vy vz cv vx cv c1 wceq vx cv c1 c1 caddc co clt wbr c1 c1 c1
      caddc co clt wbr vx cv c1 clt wbr vx cv c1 wceq wo c1 c1 clt wbr c1 c1
      wceq wo vx cv c1 c1 c1 caddc co clt breq1 vx cv c1 wceq vx cv c1 clt wbr
      c1 c1 clt wbr vx cv c1 wceq c1 c1 wceq vx cv c1 c1 clt breq1 vx cv c1 c1
      eqeq1 orbi12d imbi12d vx cv vy cv c1 caddc co wceq vx cv c1 c1 caddc co
      clt wbr vy cv c1 caddc co c1 c1 caddc co clt wbr vx cv c1 clt wbr vx cv
      c1 wceq wo vy cv c1 caddc co c1 clt wbr vy cv c1 caddc co c1 wceq wo vx
      cv vy cv c1 caddc co c1 c1 caddc co clt breq1 vx cv vy cv c1 caddc co
      wceq vx cv c1 clt wbr vy cv c1 caddc co c1 clt wbr vx cv c1 wceq vy cv c1
      caddc co c1 wceq vx cv vy cv c1 caddc co c1 clt breq1 vx cv vy cv c1
      caddc co c1 eqeq1 orbi12d imbi12d vx cv vz cv wceq vx cv c1 c1 caddc co
      clt wbr vz cv c1 c1 caddc co clt wbr vx cv c1 clt wbr vx cv c1 wceq wo vz
      cv c1 clt wbr vz cv c1 wceq wo vx cv vz cv c1 c1 caddc co clt breq1 vx cv
      vz cv wceq vx cv c1 clt wbr vz cv c1 clt wbr vx cv c1 wceq vz cv c1 wceq
      vx cv vz cv c1 clt breq1 vx cv vz cv c1 eqeq1 orbi12d imbi12d c1 c1 clt
      wbr c1 c1 wceq wo c1 c1 c1 caddc co clt wbr c1 c1 wceq c1 c1 clt wbr c1
      eqid olci a1i vy cv cn wcel vy cv c1 caddc co c1 c1 caddc co clt wbr vy
      cv c1 clt wbr vy cv c1 caddc co c1 clt wbr vy cv c1 caddc co c1 wceq wo
      vy cv cn wcel vy cv cr wcel vy cv c1 clt wbr vy cv c1 caddc co c1 c1
      caddc co clt wbr wb vy cv nnre vy cv cr wcel c1 cr wcel c1 cr wcel vy cv
      c1 clt wbr vy cv c1 caddc co c1 c1 caddc co clt wbr wb 1re 1re vy cv c1
      c1 ltadd1 mp3an23 syl vy cv cn wcel vy cv c1 clt wbr vy cv c1 caddc co c1
      clt wbr vy cv c1 caddc co c1 wceq wo vy cv cn wcel c1 vy cv cle wbr vy cv
      c1 clt wbr wn vy cv nnge1 c1 cr wcel vy cv cr wcel c1 vy cv cle wbr vy cv
      c1 clt wbr wn wb vy cv cn wcel c1 vy cv lenlt 1re vy cv nnre sylancr
      mpbid pm2.21d sylbird nn1suc rgen vy cv cn wcel vw cv vy cv c1 caddc co
      clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn wral vz cv vy cv
      c1 caddc co c1 caddc co clt wbr vz cv vy cv c1 caddc co clt wbr vz cv vy
      cv c1 caddc co wceq wo wi vz cn wral vz cv vy cv c1 caddc co clt wbr vz
      cv vy cv clt wbr vz cv vy cv wceq wo wi vz cn wral vy cv cn wcel vw cv vy
      cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn
      wral vz cv vy cv c1 caddc co c1 caddc co clt wbr vz cv vy cv c1 caddc co
      clt wbr vz cv vy cv c1 caddc co wceq wo wi vz cn vz cv cn wcel vy cv cn
      wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq
      wo wi vw cn wral vz cv vy cv c1 caddc co c1 caddc co clt wbr vz cv vy cv
      c1 caddc co clt wbr vz cv vy cv c1 caddc co wceq wo wi vz cv cn wcel vy
      cv cn wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy
      cv wceq wo wi vw cn wral vz cv vy cv c1 caddc co c1 caddc co clt wbr vz
      cv vy cv c1 caddc co clt wbr vz cv vy cv c1 caddc co wceq wo wi vy cv cn
      wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq
      wo wi vw cn wral wa vx cv vy cv c1 caddc co c1 caddc co clt wbr vx cv vy
      cv c1 caddc co clt wbr vx cv vy cv c1 caddc co wceq wo wi wi vy cv cn
      wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq
      wo wi vw cn wral wa c1 vy cv c1 caddc co c1 caddc co clt wbr c1 vy cv c1
      caddc co clt wbr c1 vy cv c1 caddc co wceq wo wi wi vy cv cn wcel vw cv
      vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw
      cn wral wa vv cv c1 caddc co vy cv c1 caddc co c1 caddc co clt wbr vv cv
      c1 caddc co vy cv c1 caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc co
      wceq wo wi wi vy cv cn wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv
      clt wbr vw cv vy cv wceq wo wi vw cn wral wa vz cv vy cv c1 caddc co c1
      caddc co clt wbr vz cv vy cv c1 caddc co clt wbr vz cv vy cv c1 caddc co
      wceq wo wi wi vx vv vz cv vx cv c1 wceq vx cv vy cv c1 caddc co c1 caddc
      co clt wbr vx cv vy cv c1 caddc co clt wbr vx cv vy cv c1 caddc co wceq
      wo wi c1 vy cv c1 caddc co c1 caddc co clt wbr c1 vy cv c1 caddc co clt
      wbr c1 vy cv c1 caddc co wceq wo wi vy cv cn wcel vw cv vy cv c1 caddc co
      clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn wral wa vx cv c1
      wceq vx cv vy cv c1 caddc co c1 caddc co clt wbr c1 vy cv c1 caddc co c1
      caddc co clt wbr vx cv vy cv c1 caddc co clt wbr vx cv vy cv c1 caddc co
      wceq wo c1 vy cv c1 caddc co clt wbr c1 vy cv c1 caddc co wceq wo vx cv
      c1 vy cv c1 caddc co c1 caddc co clt breq1 vx cv c1 wceq vx cv vy cv c1
      caddc co clt wbr c1 vy cv c1 caddc co clt wbr vx cv vy cv c1 caddc co
      wceq c1 vy cv c1 caddc co wceq vx cv c1 vy cv c1 caddc co clt breq1 vx cv
      c1 vy cv c1 caddc co eqeq1 orbi12d imbi12d imbi2d vx cv vv cv c1 caddc co
      wceq vx cv vy cv c1 caddc co c1 caddc co clt wbr vx cv vy cv c1 caddc co
      clt wbr vx cv vy cv c1 caddc co wceq wo wi vv cv c1 caddc co vy cv c1
      caddc co c1 caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc co clt wbr
      vv cv c1 caddc co vy cv c1 caddc co wceq wo wi vy cv cn wcel vw cv vy cv
      c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn wral
      wa vx cv vv cv c1 caddc co wceq vx cv vy cv c1 caddc co c1 caddc co clt
      wbr vv cv c1 caddc co vy cv c1 caddc co c1 caddc co clt wbr vx cv vy cv
      c1 caddc co clt wbr vx cv vy cv c1 caddc co wceq wo vv cv c1 caddc co vy
      cv c1 caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc co wceq wo vx cv
      vv cv c1 caddc co vy cv c1 caddc co c1 caddc co clt breq1 vx cv vv cv c1
      caddc co wceq vx cv vy cv c1 caddc co clt wbr vv cv c1 caddc co vy cv c1
      caddc co clt wbr vx cv vy cv c1 caddc co wceq vv cv c1 caddc co vy cv c1
      caddc co wceq vx cv vv cv c1 caddc co vy cv c1 caddc co clt breq1 vx cv
      vv cv c1 caddc co vy cv c1 caddc co eqeq1 orbi12d imbi12d imbi2d vx cv vz
      cv wceq vx cv vy cv c1 caddc co c1 caddc co clt wbr vx cv vy cv c1 caddc
      co clt wbr vx cv vy cv c1 caddc co wceq wo wi vz cv vy cv c1 caddc co c1
      caddc co clt wbr vz cv vy cv c1 caddc co clt wbr vz cv vy cv c1 caddc co
      wceq wo wi vy cv cn wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt
      wbr vw cv vy cv wceq wo wi vw cn wral wa vx cv vz cv wceq vx cv vy cv c1
      caddc co c1 caddc co clt wbr vz cv vy cv c1 caddc co c1 caddc co clt wbr
      vx cv vy cv c1 caddc co clt wbr vx cv vy cv c1 caddc co wceq wo vz cv vy
      cv c1 caddc co clt wbr vz cv vy cv c1 caddc co wceq wo vx cv vz cv vy cv
      c1 caddc co c1 caddc co clt breq1 vx cv vz cv wceq vx cv vy cv c1 caddc
      co clt wbr vz cv vy cv c1 caddc co clt wbr vx cv vy cv c1 caddc co wceq
      vz cv vy cv c1 caddc co wceq vx cv vz cv vy cv c1 caddc co clt breq1 vx
      cv vz cv vy cv c1 caddc co eqeq1 orbi12d imbi12d imbi2d vy cv cn wcel c1
      vy cv c1 caddc co c1 caddc co clt wbr c1 vy cv c1 caddc co clt wbr c1 vy
      cv c1 caddc co wceq wo wi vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt
      wbr vw cv vy cv wceq wo wi vw cn wral vy cv cn wcel c1 vy cv c1 caddc co
      clt wbr c1 vy cv c1 caddc co wceq wo c1 vy cv c1 caddc co c1 caddc co clt
      wbr vy cv cn wcel c1 vy cv c1 caddc co clt wbr c1 vy cv c1 caddc co wceq
      vy cv cn wcel cc0 c1 caddc co vy cv c1 caddc co c1 clt vy cv cn wcel cc0
      vy cv clt wbr cc0 c1 caddc co vy cv c1 caddc co clt wbr vy cv nngt0 vy cv
      cn wcel vy cv cr wcel cc0 vy cv clt wbr cc0 c1 caddc co vy cv c1 caddc co
      clt wbr wb vy cv nnre cc0 cr wcel vy cv cr wcel c1 cr wcel cc0 vy cv clt
      wbr cc0 c1 caddc co vy cv c1 caddc co clt wbr wb 0re 1re cc0 vy cv c1
      ltadd1 mp3an13 syl mpbid c1 ax1cn addid2i syl5eqbrr orcd a1d adantr vv cv
      cn wcel vy cv cn wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv clt wbr
      vw cv vy cv wceq wo wi vw cn wral vv cv c1 caddc co vy cv c1 caddc co c1
      caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc co clt wbr vv cv c1
      caddc co vy cv c1 caddc co wceq wo wi vv cv cn wcel vy cv cn wcel vw cv
      vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw
      cn wral vv cv c1 caddc co vy cv c1 caddc co c1 caddc co clt wbr vv cv c1
      caddc co vy cv c1 caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc co
      wceq wo wi vv cv cn wcel vy cv cn wcel wa vw cv vy cv c1 caddc co clt wbr
      vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn wral wa vv cv vy cv c1
      caddc co clt wbr vv cv vy cv clt wbr vv cv vy cv wceq wo vv cv c1 caddc
      co vy cv c1 caddc co c1 caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc
      co clt wbr vv cv c1 caddc co vy cv c1 caddc co wceq wo vv cv cn wcel vw
      cv vy cv c1 caddc co clt wbr vw cv vy cv clt wbr vw cv vy cv wceq wo wi
      vw cn wral vv cv vy cv c1 caddc co clt wbr vv cv vy cv clt wbr vv cv vy
      cv wceq wo wi vy cv cn wcel vw cv vy cv c1 caddc co clt wbr vw cv vy cv
      clt wbr vw cv vy cv wceq wo wi vv cv vy cv c1 caddc co clt wbr vv cv vy
      cv clt wbr vv cv vy cv wceq wo wi vw vv cv cn vw cv vv cv wceq vw cv vy
      cv c1 caddc co clt wbr vv cv vy cv c1 caddc co clt wbr vw cv vy cv clt
      wbr vw cv vy cv wceq wo vv cv vy cv clt wbr vv cv vy cv wceq wo vw cv vv
      cv vy cv c1 caddc co clt breq1 vw cv vv cv wceq vw cv vy cv clt wbr vv cv
      vy cv clt wbr vw cv vy cv wceq vv cv vy cv wceq vw cv vv cv vy cv clt
      breq1 vw cv vv cv vy cv eqeq1 orbi12d imbi12d rcla4va adantlr vv cv cn
      wcel vy cv cn wcel wa vv cv vy cv c1 caddc co clt wbr vv cv c1 caddc co
      vy cv c1 caddc co c1 caddc co clt wbr wb vw cv vy cv c1 caddc co clt wbr
      vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn wral vv cv cr wcel vy cv
      c1 caddc co cr wcel vv cv vy cv c1 caddc co clt wbr vv cv c1 caddc co vy
      cv c1 caddc co c1 caddc co clt wbr wb vv cv cn wcel vy cv cn wcel vv cv
      cr wcel vy cv c1 caddc co cr wcel c1 cr wcel vv cv vy cv c1 caddc co clt
      wbr vv cv c1 caddc co vy cv c1 caddc co c1 caddc co clt wbr wb 1re vv cv
      vy cv c1 caddc co c1 ltadd1 mp3an3 vv cv nnre vy cv cn wcel vy cv c1
      caddc co cn wcel vy cv c1 caddc co cr wcel vy cv peano2nn vy cv c1 caddc
      co nnre syl syl2an adantr vv cv cn wcel vy cv cn wcel wa vv cv vy cv clt
      wbr vv cv vy cv wceq wo vv cv c1 caddc co vy cv c1 caddc co clt wbr vv cv
      c1 caddc co vy cv c1 caddc co wceq wo wb vw cv vy cv c1 caddc co clt wbr
      vw cv vy cv clt wbr vw cv vy cv wceq wo wi vw cn wral vv cv cr wcel vy cv
      cr wcel vv cv vy cv clt wbr vv cv vy cv wceq wo vv cv c1 caddc co vy cv
      c1 caddc co clt wbr vv cv c1 caddc co vy cv c1 caddc co wceq wo wb vv cv
      cn wcel vy cv cn wcel vv cv cr wcel vy cv cr wcel c1 cr wcel vv cv vy cv
      clt wbr vv cv vy cv wceq wo vv cv c1 caddc co vy cv c1 caddc co clt wbr
      vv cv c1 caddc co vy cv c1 caddc co wceq wo wb 1re vv cv cr wcel vy cv cr
      wcel c1 cr wcel w3a vv cv vy cv clt wbr vv cv c1 caddc co vy cv c1 caddc
      co clt wbr vv cv vy cv wceq vv cv c1 caddc co vy cv c1 caddc co wceq vv
      cv vy cv c1 ltadd1 vv cv cr wcel vy cv cr wcel c1 cr wcel w3a c1 cc wcel
      vv cv cc wcel vy cv cc wcel w3a vv cv vy cv wceq vv cv c1 caddc co vy cv
      c1 caddc co wceq wb vv cv cr wcel vy cv cr wcel c1 cr wcel w3a vv cv cc
      wcel vy cv cc wcel c1 cc wcel w3a c1 cc wcel vv cv cc wcel vy cv cc wcel
      w3a vv cv cr wcel vv cv cc wcel vy cv cr wcel vy cv cc wcel c1 cr wcel c1
      cc wcel vv cv recn vy cv recn c1 recn 3anim123i c1 cc wcel vv cv cc wcel
      vy cv cc wcel 3anrot sylibr c1 cc wcel vv cv cc wcel vy cv cc wcel w3a vv
      cv c1 caddc co vy cv c1 caddc co wceq c1 vv cv caddc co c1 vy cv caddc co
      wceq vv cv vy cv wceq c1 cc wcel vv cv cc wcel vy cv cc wcel w3a vv cv cc
      wcel c1 cc wcel wa vy cv cc wcel c1 cc wcel wa wa vv cv c1 caddc co vy cv
      c1 caddc co wceq c1 vv cv caddc co c1 vy cv caddc co wceq wb c1 cc wcel
      vv cv cc wcel vy cv cc wcel w3a vv cv cc wcel vy cv cc wcel wa c1 cc wcel
      wa vv cv cc wcel c1 cc wcel wa vy cv cc wcel c1 cc wcel wa wa c1 cc wcel
      vv cv cc wcel vy cv cc wcel w3a vv cv cc wcel vy cv cc wcel wa c1 cc wcel
      c1 cc wcel vv cv cc wcel vy cv cc wcel 3simpc c1 cc wcel vv cv cc wcel vy
      cv cc wcel 3simp1 jca vv cv cc wcel vy cv cc wcel c1 cc wcel anandir
      sylib vv cv cc wcel c1 cc wcel wa vy cv cc wcel c1 cc wcel wa vv cv c1
      caddc co c1 vv cv caddc co vy cv c1 caddc co c1 vy cv caddc co vv cv c1
      addcom vy cv c1 addcom eqeqan12d syl c1 vv cv vy cv addcan bitr2d syl
      orbi12d mp3an3 vv cv nnre vy cv nnre syl2an adantr 3imtr3d exp31 imp3a
      nn1suc exp3a com3l r19.21adv vz cv vy cv c1 caddc co clt wbr vz cv vy cv
      clt wbr vz cv vy cv wceq wo wi vw cv vy cv c1 caddc co clt wbr vw cv vy
      cv clt wbr vw cv vy cv wceq wo wi vz vw cn vz cv vw cv wceq vz cv vy cv
      c1 caddc co clt wbr vw cv vy cv c1 caddc co clt wbr vz cv vy cv clt wbr
      vz cv vy cv wceq wo vw cv vy cv clt wbr vw cv vy cv wceq wo vz cv vw cv
      vy cv c1 caddc co clt breq1 vz cv vw cv wceq vz cv vy cv clt wbr vw cv vy
      cv clt wbr vz cv vy cv wceq vw cv vy cv wceq vz cv vw cv vy cv clt breq1
      vz cv vw cv vy cv eqeq1 orbi12d imbi12d cbvralv syl5ib nnind syl5 imp
      impbid bitrd $.
      $( [13-Aug-2001] $)
  $}

  $( Natural number ordering relation. $)
  nnltp1le $p |- ( ( A e. NN /\ B e. NN ) ->
                ( A < B <-> ( A + 1 ) <_ B ) ) $=
    cA cn wcel cB cn wcel wa cA cB clt wbr cA c1 caddc co cB c1 caddc co clt
    wbr cA c1 caddc co cB cle wbr cA cr wcel cB cr wcel cA cB clt wbr cA c1
    caddc co cB c1 caddc co clt wbr wb cA cn wcel cB cn wcel cA cr wcel cB cr
    wcel c1 cr wcel cA cB clt wbr cA c1 caddc co cB c1 caddc co clt wbr wb 1re
    cA cB c1 ltadd1 mp3an3 cA nnre cB nnre syl2an cA c1 caddc co cn wcel cB cn
    wcel cA c1 caddc co cB cle wbr cA c1 caddc co cB c1 caddc co clt wbr wb cA
    cn wcel cA c1 caddc co cB nnleltp1 cA peano2nn sylan bitr4d $.
    $( [19-Aug-2001] $)

  ${
    $d x y A $.  $d x y B $.
    nnsub.1 $e |- A e. NN $.
    nnsub.2 $e |- B e. NN $.
    $( Subtraction of natural numbers. $)
    nnsubi $p |- ( A < B <-> ( B - A ) e. NN ) $=
      cA cB clt wbr cB cA cmin co cn wcel cB cn wcel cA cB clt wbr cB cA cmin
      co cn wcel wi nnsub.2 cA vx cv clt wbr vx cv cA cmin co cn wcel wi cA c1
      clt wbr c1 cA cmin co cn wcel wi cA vy cv clt wbr vy cv cA cmin co cn
      wcel wi cA vy cv c1 caddc co clt wbr vy cv c1 caddc co cA cmin co cn wcel
      wi cA cB clt wbr cB cA cmin co cn wcel wi vx vy cB vx cv c1 wceq cA vx cv
      clt wbr cA c1 clt wbr vx cv cA cmin co cn wcel c1 cA cmin co cn wcel vx
      cv c1 cA clt breq2 vx cv c1 wceq vx cv cA cmin co c1 cA cmin co cn vx cv
      c1 cA cmin opreq1 eleq1d imbi12d vx cv vy cv wceq cA vx cv clt wbr cA vy
      cv clt wbr vx cv cA cmin co cn wcel vy cv cA cmin co cn wcel vx cv vy cv
      cA clt breq2 vx cv vy cv wceq vx cv cA cmin co vy cv cA cmin co cn vx cv
      vy cv cA cmin opreq1 eleq1d imbi12d vx cv vy cv c1 caddc co wceq cA vx cv
      clt wbr cA vy cv c1 caddc co clt wbr vx cv cA cmin co cn wcel vy cv c1
      caddc co cA cmin co cn wcel vx cv vy cv c1 caddc co cA clt breq2 vx cv vy
      cv c1 caddc co wceq vx cv cA cmin co vy cv c1 caddc co cA cmin co cn vx
      cv vy cv c1 caddc co cA cmin opreq1 eleq1d imbi12d vx cv cB wceq cA vx cv
      clt wbr cA cB clt wbr vx cv cA cmin co cn wcel cB cA cmin co cn wcel vx
      cv cB cA clt breq2 vx cv cB wceq vx cv cA cmin co cB cA cmin co cn vx cv
      cB cA cmin opreq1 eleq1d imbi12d cA c1 clt wbr c1 cA cmin co cn wcel c1
      cA cle wbr cA c1 clt wbr wn cA cn wcel c1 cA cle wbr nnsub.1 cA nnge1
      ax-mp c1 cA 1re cA nnsub.1 nnrei lenlti mpbi pm2.21i vy cv cn wcel cA vy
      cv c1 caddc co clt wbr cA vy cv clt wbr vy cv cA cmin co cn wcel wi vy cv
      c1 caddc co cA cmin co cn wcel vy cv cn wcel cA vy cv c1 caddc co clt wbr
      cA vy cv clt wbr cA vy cv wceq wo cA vy cv clt wbr vy cv cA cmin co cn
      wcel wi vy cv c1 caddc co cA cmin co cn wcel wi vy cv cn wcel cA vy cv
      cle wbr cA vy cv clt wbr cA vy cv wceq wo cA vy cv c1 caddc co clt wbr cA
      cr wcel vy cv cr wcel cA vy cv cle wbr cA vy cv clt wbr cA vy cv wceq wo
      wb vy cv cn wcel cA vy cv leloe cA nnsub.1 nnrei vy cv nnre sylancr cA cn
      wcel vy cv cn wcel cA vy cv cle wbr cA vy cv c1 caddc co clt wbr wb
      nnsub.1 cA vy cv nnleltp1 mpan bitr3d vy cv cn wcel cA vy cv clt wbr cA
      vy cv clt wbr vy cv cA cmin co cn wcel wi vy cv c1 caddc co cA cmin co cn
      wcel wi cA vy cv wceq vy cv cn wcel cA vy cv clt wbr vy cv cA cmin co cn
      wcel wi cA vy cv clt wbr vy cv c1 caddc co cA cmin co cn wcel vy cv cn
      wcel vy cv cA cmin co cn wcel vy cv c1 caddc co cA cmin co cn wcel cA vy
      cv clt wbr vy cv cn wcel vy cv c1 caddc co cA cmin co cn wcel vy cv cA
      cmin co c1 caddc co cn wcel vy cv cA cmin co cn wcel vy cv cn wcel vy cv
      c1 caddc co cA cmin co vy cv cA cmin co c1 caddc co cn vy cv cc wcel cA
      cc wcel vy cv c1 caddc co cA cmin co vy cv cA cmin co c1 caddc co wceq vy
      cv cn wcel vy cv cc wcel c1 cc wcel cA cc wcel vy cv c1 caddc co cA cmin
      co vy cv cA cmin co c1 caddc co wceq ax1cn vy cv c1 cA addsub mp3an2 vy
      cv nncn cA nnsub.1 nncni sylancl eleq1d vy cv cA cmin co peano2nn syl5bir
      imim2d com23 cA vy cv wceq cA vy cv clt wbr vy cv cA cmin co cn wcel wi
      vy cv c1 caddc co cA cmin co cn wcel wi wi vy cv cn wcel cA vy cv wceq vy
      cv c1 caddc co cA cmin co cn wcel cA vy cv clt wbr vy cv cA cmin co cn
      wcel wi cA vy cv wceq vy cv c1 caddc co cA cmin co cA c1 caddc co cA cmin
      co cn cA vy cv wceq cA c1 caddc co vy cv c1 caddc co cA cmin cA vy cv c1
      caddc opreq1 opreq1d cA c1 caddc co cA cmin co c1 cn cA c1 caddc co cA
      cmin co cA cA cmin co c1 caddc co cc0 c1 caddc co c1 cA c1 cA cA nnsub.1
      nncni ax1cn cA nnsub.1 nncni addsubi cA cA cmin co cc0 c1 caddc cA cA
      nnsub.1 nncni subidi opreq1i c1 ax1cn addid2i 3eqtri 1nn eqeltri
      syl6eqelr a1d a1i jaod sylbird com23 nnind ax-mp cB cA cmin co cn wcel
      cc0 cB cA cmin co clt wbr cA cB clt wbr cB cA cmin co nngt0 cA cB cA
      nnsub.1 nnrei cB nnsub.2 nnrei posdifi sylibr impbii $.
      $( [19-Aug-2001] $)
  $}

  $( Subtraction of natural numbers. $)
  nnsub $p |- ( ( A e. NN /\ B e. NN ) -> ( A < B <-> ( B - A ) e. NN ) ) $=
    cA cn wcel cB cn wcel cA cB clt wbr cB cA cmin co cn wcel wb cA cn wcel cA
    c1 cif cB clt wbr cB cA cn wcel cA c1 cif cmin co cn wcel wb cA cn wcel cA
    c1 cif cB cn wcel cB c1 cif clt wbr cB cn wcel cB c1 cif cA cn wcel cA c1
    cif cmin co cn wcel wb cA cB c1 c1 cA cA cn wcel cA c1 cif wceq cA cB clt
    wbr cA cn wcel cA c1 cif cB clt wbr cB cA cmin co cn wcel cB cA cn wcel cA
    c1 cif cmin co cn wcel cA cA cn wcel cA c1 cif cB clt breq1 cA cA cn wcel
    cA c1 cif wceq cB cA cmin co cB cA cn wcel cA c1 cif cmin co cn cA cA cn
    wcel cA c1 cif cB cmin opreq2 eleq1d bibi12d cB cB cn wcel cB c1 cif wceq
    cA cn wcel cA c1 cif cB clt wbr cA cn wcel cA c1 cif cB cn wcel cB c1 cif
    clt wbr cB cA cn wcel cA c1 cif cmin co cn wcel cB cn wcel cB c1 cif cA cn
    wcel cA c1 cif cmin co cn wcel cB cB cn wcel cB c1 cif cA cn wcel cA c1 cif
    clt breq2 cB cB cn wcel cB c1 cif wceq cB cA cn wcel cA c1 cif cmin co cB
    cn wcel cB c1 cif cA cn wcel cA c1 cif cmin co cn cB cB cn wcel cB c1 cif
    cA cn wcel cA c1 cif cmin opreq1 eleq1d bibi12d cA cn wcel cA c1 cif cB cn
    wcel cB c1 cif cA c1 cn 1nn elimel cB c1 cn 1nn elimel nnsubi dedth2h $.
    $( [20-Aug-2001] $)

  $( Closure of addition of natural numbers minus one. $)
  nnaddm1cl $p |- ( ( A e. NN /\ B e. NN ) -> ( ( A + B ) - 1 ) e. NN ) $=
    cA cn wcel cB cn wcel wa c1 cA cB caddc co clt wbr cA cB caddc co c1 cmin
    co cn wcel cA cB caddc co cr wcel c1 c1 c1 caddc co clt wbr c1 c1 caddc co
    cA cB caddc co cle wbr wa c1 cA cB caddc co clt wbr cA cn wcel cB cn wcel
    wa c1 cr wcel c1 c1 caddc co cr wcel cA cB caddc co cr wcel c1 c1 c1 caddc
    co clt wbr c1 c1 caddc co cA cB caddc co cle wbr wa c1 cA cB caddc co clt
    wbr wi 1re c1 c1 1re 1re readdcli c1 c1 c1 caddc co cA cB caddc co ltletr
    mp3an12 cA cr wcel cB cr wcel cA cB caddc co cr wcel cA cn wcel cB cn wcel
    cA cB readdcl cA nnre cB nnre syl2an cA cn wcel cB cn wcel wa c1 c1 caddc
    co cA cB caddc co cle wbr c1 c1 c1 caddc co clt wbr cA cn wcel cB cn wcel
    wa c1 c1 caddc co c1 cB caddc co cA cB caddc co c1 c1 caddc co cr wcel cA
    cn wcel cB cn wcel wa c1 c1 1re 1re readdcli a1i cB cn wcel c1 cB caddc co
    cr wcel cA cn wcel c1 cr wcel cB cr wcel c1 cB caddc co cr wcel cB cn wcel
    c1 cB readdcl 1re cB nnre sylancr adantl cA cr wcel cB cr wcel cA cB caddc
    co cr wcel cA cn wcel cB cn wcel cA cB readdcl cA nnre cB nnre syl2an cB cn
    wcel c1 c1 caddc co c1 cB caddc co cle wbr cA cn wcel cB cn wcel c1 cB cle
    wbr c1 c1 caddc co c1 cB caddc co cle wbr cB nnge1 cB cn wcel cB cr wcel c1
    cB cle wbr c1 c1 caddc co c1 cB caddc co cle wbr wb cB nnre c1 cr wcel cB
    cr wcel c1 cr wcel c1 cB cle wbr c1 c1 caddc co c1 cB caddc co cle wbr wb
    1re 1re c1 cB c1 leadd2 mp3an13 syl mpbid adantl cA cn wcel cB cn wcel wa
    c1 cA cle wbr c1 cB caddc co cA cB caddc co cle wbr cA cn wcel c1 cA cle
    wbr cB cn wcel cA nnge1 adantr cA cr wcel cB cr wcel c1 cA cle wbr c1 cB
    caddc co cA cB caddc co cle wbr wb cA cn wcel cB cn wcel c1 cr wcel cA cr
    wcel cB cr wcel c1 cA cle wbr c1 cB caddc co cA cB caddc co cle wbr wb 1re
    c1 cA cB leadd1 mp3an1 cA nnre cB nnre syl2an mpbid letrd c1 1re ltp1i
    jctil sylc c1 cn wcel cA cB caddc co cn wcel c1 cA cB caddc co clt wbr cA
    cB caddc co c1 cmin co cn wcel wb cA cn wcel cB cn wcel wa c1 cA cB caddc
    co nnsub 1nn cA cB nnaddcl sylancr mpbid $.
    $( [6-Aug-2003] $)

  ${
    $d x A $.  $d x B $.
    $( Two ways to express " ` A ` divides ` B ` " for natural numbers. $)
    nndiv $p |- ( ( A e. NN /\ B e. NN ) ->
                ( E. x e. NN ( A x. x ) = B <-> ( B / A ) e. NN ) ) $=
      cA cn wcel cB cn wcel wa cA cc0 wne cA vx cv cmul co cB wceq vx cn wrex
      cB cA cdiv co cn wcel wb cA cn wcel cA cc0 wne cB cn wcel cA nnne0 adantr
      cA cc wcel cB cc wcel cA cc0 wne cA vx cv cmul co cB wceq vx cn wrex cB
      cA cdiv co cn wcel wb wi cA cn wcel cB cn wcel cA cc wcel cB cc wcel cA
      cc0 wne cA vx cv cmul co cB wceq vx cn wrex cB cA cdiv co cn wcel wb cA
      cc wcel cB cc wcel cA cc0 wne w3a cA vx cv cmul co cB wceq vx cn wrex cB
      cA cdiv co cn wcel cA cc wcel cB cc wcel cA cc0 wne w3a cA vx cv cmul co
      cB wceq cB cA cdiv co cn wcel vx cn cA cc wcel cB cc wcel cA cc0 wne w3a
      vx cv cn wcel cA vx cv cmul co cB wceq cB cA cdiv co cn wcel cA cc wcel
      cB cc wcel cA cc0 wne w3a vx cv cn wcel wa cA vx cv cmul co cB wceq wa vx
      cv cB cA cdiv co cn cA cc wcel cB cc wcel cA cc0 wne w3a vx cv cn wcel wa
      cA vx cv cmul co cB wceq vx cv cA vx cv cmul co cA cdiv co cB cA cdiv co
      cA cc wcel cA cc0 wne vx cv cn wcel cA vx cv cmul co cA cdiv co vx cv
      wceq cB cc wcel cA cc wcel cA cc0 wne wa vx cv cc wcel cA vx cv cmul co
      cA cdiv co vx cv wceq vx cv cn wcel cA cc wcel cA cc0 wne vx cv cc wcel
      cA vx cv cmul co cA cdiv co vx cv wceq vx cv cc wcel cA cc wcel cA cc0
      wne cA vx cv cmul co cA cdiv co vx cv wceq vx cv cA divcan3 3coml 3expa
      vx cv nncn sylan2 3adantl2 cA vx cv cmul co cB cA cdiv opreq1 sylan9req
      cA cc wcel cB cc wcel cA cc0 wne w3a vx cv cn wcel cA vx cv cmul co cB
      wceq simplr eqeltrrd exp31 r19.23adv cA cc wcel cB cc wcel cA cc0 wne w3a
      cA cB cA cdiv co cmul co cB wceq cB cA cdiv co cn wcel cA vx cv cmul co
      cB wceq vx cn wrex wi cB cc wcel cA cc wcel cA cc0 wne cA cB cA cdiv co
      cmul co cB wceq cB cA divcan2 3com12 cB cA cdiv co cn wcel cA cB cA cdiv
      co cmul co cB wceq cA vx cv cmul co cB wceq vx cn wrex cA vx cv cmul co
      cB wceq cA cB cA cdiv co cmul co cB wceq vx cB cA cdiv co cn vx cv cB cA
      cdiv co wceq cA vx cv cmul co cA cB cA cdiv co cmul co cB vx cv cB cA
      cdiv co cA cmul opreq2 eqeq1d rcla4ev expcom syl impbid 3expia cA nncn cB
      nncn syl2an mpd $.
      $( [20-Feb-2004] $) $( [3-Feb-2004] $)
  $}

  $( Transitive property of divisibility:  if ` A ` divides ` B ` and ` B `
     divides ` C ` , then ` A ` divides ` C ` .  Typically ` C ` would be an
     integer, although the theorem holds for complex ` C ` . $)
  nndivtr $p |- ( ( ( A e. NN /\ B e. NN /\ C e. CC ) /\
               ( ( B / A ) e. NN /\ ( C / B ) e. NN ) ) -> ( C / A ) e. NN ) $=
    cA cn wcel cB cn wcel cC cc wcel w3a cB cA cdiv co cn wcel cC cB cdiv co cn
    wcel wa cC cA cdiv co cn wcel cA cn wcel cB cn wcel cC cc wcel w3a cB cA
    cdiv co cC cB cdiv co cmul co cn wcel cC cA cdiv co cn wcel cB cA cdiv co
    cn wcel cC cB cdiv co cn wcel wa cA cn wcel cB cn wcel cC cc wcel w3a cB cA
    cdiv co cC cB cdiv co cmul co cC cA cdiv co cn cA cn wcel cB cn wcel cC cc
    wcel w3a cB cA cdiv co cC cB cdiv co cmul co cB cB cdiv co cC cA cdiv co
    cmul co c1 cC cA cdiv co cmul co cC cA cdiv co cB cc wcel cC cc wcel cA cc
    wcel cA cc0 wne wa cB cc wcel cB cc0 wne wa cB cA cdiv co cC cB cdiv co
    cmul co cB cB cdiv co cC cA cdiv co cmul co wceq cA cn wcel cB cn wcel cC
    cc wcel w3a cB cC cA cB divmul24 cB cn wcel cA cn wcel cB cc wcel cC cc
    wcel cB nncn 3ad2ant2 cA cn wcel cB cn wcel cC cc wcel 3simp3 cA cn wcel cB
    cn wcel cA cc wcel cA cc0 wne wa cC cc wcel cA cn wcel cA cc wcel cA cc0
    wne cA nncn cA nnne0 jca 3ad2ant1 cB cn wcel cA cn wcel cB cc wcel cB cc0
    wne wa cC cc wcel cB cn wcel cB cc wcel cB cc0 wne cB nncn cB nnne0 jca
    3ad2ant2 syl2anc cB cn wcel cA cn wcel cB cB cdiv co cC cA cdiv co cmul co
    c1 cC cA cdiv co cmul co wceq cC cc wcel cB cn wcel cB cB cdiv co c1 cC cA
    cdiv co cmul cB cc wcel cB cc0 wne cB cB cdiv co c1 wceq cB cn wcel cB
    divid cB nncn cB nnne0 sylanc opreq1d 3ad2ant2 cA cn wcel cC cc wcel c1 cC
    cA cdiv co cmul co cC cA cdiv co wceq cB cn wcel cA cn wcel cC cc wcel wa
    cC cA cdiv co cc wcel c1 cC cA cdiv co cmul co cC cA cdiv co wceq cC cc
    wcel cA cn wcel cC cA cdiv co cc wcel cC cc wcel cA cc wcel cA cc0 wne wa
    cC cA cdiv co cc wcel cA cn wcel cC cc wcel cA cc wcel cA cc0 wne cC cA
    cdiv co cc wcel cC cA divcl 3expb cA cn wcel cA cc wcel cA cc0 wne cA nncn
    cA nnne0 jca sylan2 ancoms cC cA cdiv co mulid2 syl 3adant2 3eqtrd eleq1d
    cB cA cdiv co cC cB cdiv co nnmulcl syl5bi imp $.
    $( [6-May-2005] $) $( [3-May-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Decimal representation of numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c 2 $. $( The decimal number 2 $)
  $c 3 $. $( The decimal number 3 $)
  $c 4 $. $( The decimal number 4 $)
  $c 5 $. $( The decimal number 5 $)
  $c 6 $. $( The decimal number 6 $)
  $c 7 $. $( The decimal number 7 $)
  $c 8 $. $( The decimal number 8 $)
  $c 9 $. $( The decimal number 9 $)
  $c 10 $. $( The decimal number 10 $)

  $( Extend class notation to include the number 2. $)
  c2 $a class 2 $.
  $( Extend class notation to include the number 3. $)
  c3 $a class 3 $.
  $( Extend class notation to include the number 4. $)
  c4 $a class 4 $.
  $( Extend class notation to include the number 5. $)
  c5 $a class 5 $.
  $( Extend class notation to include the number 6. $)
  c6 $a class 6 $.
  $( Extend class notation to include the number 7. $)
  c7 $a class 7 $.
  $( Extend class notation to include the number 8. $)
  c8 $a class 8 $.
  $( Extend class notation to include the number 9. $)
  c9 $a class 9 $.
  $( Extend class notation to include the number 10. $)
  c10 $a class 10 $.

  $( Define the number 2.

     Note that the numbers 0 and 1 are constants defined as primitives of the
     complex number axiom system (see ~ df-0 and ~ df-1 ).

     _Note_:  Only the digits 0 through 9 ( ~ df-0 through ~ df-9 ) and the
     number 10 ( ~ df-10 ) are explicitly defined.  Integers can be exhibited
     as sums of powers of 10 or as some other expression built from
     operations on the numbers 0 through 10.  For example, the prime number
     823541 can be expressed as ` ( 7 ^ 7 ) - 2 ` .  Decimals can be expressed
     as ratios of integers, as in ~ cos2bnd .  (Fortunately, most abstract math
     rarely requires numbers larger than 4.  Even in Wiles' proof of Fermat's
     Last Theorem, the largest number used appears to be 12.)

     A decimal representation of numbers may be added at some point in the
     future if it is deemed useful.  Ideas for a clean, eliminable definition
     are welcome.  (An awkward earlier definition was deleted from the
     database on 18-Sep-1999.) $)
  df-2 $a |- 2 = ( 1 + 1 ) $.

  $( Define the number 3. $)
  df-3 $a |- 3 = ( 2 + 1 ) $.
  $( Define the number 4. $)
  df-4 $a |- 4 = ( 3 + 1 ) $.
  $( Define the number 5. $)
  df-5 $a |- 5 = ( 4 + 1 ) $.
  $( Define the number 6. $)
  df-6 $a |- 6 = ( 5 + 1 ) $.
  $( Define the number 7. $)
  df-7 $a |- 7 = ( 6 + 1 ) $.
  $( Define the number 8. $)
  df-8 $a |- 8 = ( 7 + 1 ) $.
  $( Define the number 9. $)
  df-9 $a |- 9 = ( 8 + 1 ) $.
  $( Define the number 10.  See remarks under ~ df-2 . $)
  df-10 $a |- 10 = ( 9 + 1 ) $.

  $( The number 2 is real. $)
  2re $p |- 2 e. RR $=
    c2 c1 c1 caddc co cr df-2 c1 c1 1re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 2 is a complex number. $)
  2cn $p |- 2 e. CC $=
    c2 2re recni $.
    $( [31-Jul-2004] $) $( [30-Jul-2004] $)

  $( The number 3 is real. $)
  3re $p |- 3 e. RR $=
    c3 c2 c1 caddc co cr df-3 c2 c1 2re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 4 is real. $)
  4re $p |- 4 e. RR $=
    c4 c3 c1 caddc co cr df-4 c3 c1 3re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 5 is real. $)
  5re $p |- 5 e. RR $=
    c5 c4 c1 caddc co cr df-5 c4 c1 4re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 6 is real. $)
  6re $p |- 6 e. RR $=
    c6 c5 c1 caddc co cr df-6 c5 c1 5re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 7 is real. $)
  7re $p |- 7 e. RR $=
    c7 c6 c1 caddc co cr df-7 c6 c1 6re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 8 is real. $)
  8re $p |- 8 e. RR $=
    c8 c7 c1 caddc co cr df-8 c7 c1 7re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 9 is real. $)
  9re $p |- 9 e. RR $=
    c9 c8 c1 caddc co cr df-9 c8 c1 8re 1re readdcli eqeltri $.
    $( [27-May-1999] $)

  $( The number 10 is real. $)
  10re $p |- 10 e. RR $=
    c10 c9 c1 caddc co cr df-10 c9 c1 9re 1re readdcli eqeltri $.
    $( [6-Feb-2007] $) $( [5-Feb-2007] $)

  $( The number 2 is positive. $)
  2pos $p |- 0 < 2 $=
    cc0 c1 c1 caddc co c2 clt c1 c1 1re 1re lt01 lt01 addgt0ii df-2 breqtrri $.
    $( [27-May-1999] $)

  $( The number 2 is nonzero. $)
  2ne0 $p |- 2 =/= 0 $=
    c2 2re 2pos gt0ne0ii $.
    $( [9-Nov-2007] $) $( [9-Nov-2007] $)

  $( The number 3 is positive. $)
  3pos $p |- 0 < 3 $=
    cc0 c2 c1 caddc co c3 clt c2 c1 2re 1re 2pos lt01 addgt0ii df-3 breqtrri $.
    $( [27-May-1999] $)

  $( The number 4 is positive. $)
  4pos $p |- 0 < 4 $=
    cc0 c3 c1 caddc co c4 clt c3 c1 3re 1re 3pos lt01 addgt0ii df-4 breqtrri $.
    $( [27-May-1999] $)

  $( The number 5 is positive. $)
  5pos $p |- 0 < 5 $=
    cc0 c4 c1 caddc co c5 clt c4 c1 4re 1re 4pos lt01 addgt0ii df-5 breqtrri $.
    $( [27-May-1999] $)

  $( The number 6 is positive. $)
  6pos $p |- 0 < 6 $=
    cc0 c5 c1 caddc co c6 clt c5 c1 5re 1re 5pos lt01 addgt0ii df-6 breqtrri $.
    $( [27-May-1999] $)

  $( The number 7 is positive. $)
  7pos $p |- 0 < 7 $=
    cc0 c6 c1 caddc co c7 clt c6 c1 6re 1re 6pos lt01 addgt0ii df-7 breqtrri $.
    $( [27-May-1999] $)

  $( The number 8 is positive. $)
  8pos $p |- 0 < 8 $=
    cc0 c7 c1 caddc co c8 clt c7 c1 7re 1re 7pos lt01 addgt0ii df-8 breqtrri $.
    $( [27-May-1999] $)

  $( The number 9 is positive. $)
  9pos $p |- 0 < 9 $=
    cc0 c8 c1 caddc co c9 clt c8 c1 8re 1re 8pos lt01 addgt0ii df-9 breqtrri $.
    $( [27-May-1999] $)

  $( The number 10 is positive. $)
  10pos $p |- 0 < 10 $=
    cc0 c9 c1 caddc co c10 clt c9 c1 9re 1re 9pos lt01 addgt0ii df-10 breqtrri
    $.
    $( [6-Feb-2007] $) $( [5-Feb-2007] $)

  $( 2 is a natural number. $)
  2nn $p |- 2 e. NN $=
    c2 c1 c1 caddc co cn df-2 c1 cn wcel c1 cn wcel c1 c1 caddc co cn wcel 1nn
    1nn c1 c1 nnaddcl mp2an eqeltri $.
    $( [20-Aug-2001] $)

  $( 3 is a natural number. $)
  3nn $p |- 3 e. NN $=
    c3 c2 c1 caddc co cn df-3 c2 cn wcel c1 cn wcel c2 c1 caddc co cn wcel 2nn
    1nn c2 c1 nnaddcl mp2an eqeltri $.
    $( [1-Feb-2006] $) $( [8-Jan-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Some properties of specific numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Two plus two equals four.  For more information, see "2+2=4 Trivia" on
     the Metamath Proof Explorer Home Page:
     ~ http://us.metamath.org/mpegif/mmset.html#trivia . $)
  2p2e4 $p |- ( 2 + 2 ) = 4 $=
    c2 c2 caddc co c2 c1 c1 caddc co caddc co c4 c2 c1 c1 caddc co c2 caddc
    df-2 opreq2i c4 c3 c1 caddc co c2 c1 caddc co c1 caddc co c2 c1 c1 caddc co
    caddc co df-4 c3 c2 c1 caddc co c1 caddc df-3 opreq1i c2 c1 c1 2cn ax1cn
    ax1cn addassi 3eqtri eqtr4i $.
    $( [27-May-1999] $)

  $( 4 is a natural number. $)
  4nn $p |- 4 e. NN $=
    c2 c2 caddc co c4 cn 2p2e4 c2 cn wcel c2 cn wcel c2 c2 caddc co cn wcel 2nn
    2nn c2 c2 nnaddcl mp2an eqeltrri $.
    $( [16-Feb-2006] $) $( [8-Jan-2006] $)

  ${
    2times.1 $e |- A e. CC $.
    $( Two times a number. $)
    2timesi $p |- ( 2 x. A ) = ( A + A ) $=
      c2 cA cmul co c1 c1 caddc co cA cmul co cA cA caddc co c2 c1 c1 caddc co
      cA cmul df-2 opreq1i cA 2times.1 1p1timesi eqtri $.
      $( [1-Aug-1999] $)
  $}

  $( Two times a number. $)
  2times $p |- ( A e. CC -> ( 2 x. A ) = ( A + A ) ) $=
    cA cc wcel c2 cA cmul co cA cA caddc co wceq c2 cA cc wcel cA cc0 cif cmul
    co cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif caddc co wceq cA cc0 cA cA
    cc wcel cA cc0 cif wceq c2 cA cmul co c2 cA cc wcel cA cc0 cif cmul co cA
    cA caddc co cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif caddc co cA cA cc
    wcel cA cc0 cif c2 cmul opreq2 cA cA cc wcel cA cc0 cif wceq cA cA cc wcel
    cA cc0 cif cA cA cc wcel cA cc0 cif caddc cA cA cc wcel cA cc0 cif wceq id
    cA cA cc wcel cA cc0 cif wceq id opreq12d eqeq12d cA cc wcel cA cc0 cif cA
    cc0 cc 0cn elimel 2timesi dedth $.
    $( [1-Nov-2004] $) $( [10-Oct-2004] $)

  $( A number times 2. $)
  times2 $p |- ( A e. CC -> ( A x. 2 ) = ( A + A ) ) $=
    cA cc wcel cA c2 cmul co c2 cA cmul co cA cA caddc co cA cc wcel c2 cc wcel
    cA c2 cmul co c2 cA cmul co wceq 2cn cA c2 mulcom mpan2 cA 2times eqtrd $.
    $( [16-Oct-2007] $) $( [16-Oct-2007] $)

  ${
    times2.1 $e |- A e. CC $.
    $( A number times 2. $)
    times2i $p |- ( A x. 2 ) = ( A + A ) $=
      cA cc wcel cA c2 cmul co cA cA caddc co wceq times2.1 cA times2 ax-mp $.
      $( [12-May-2004] $) $( [11-May-2004] $)
  $}

  $( 3 + 2 = 5. $)
  3p2e5 $p |- ( 3 + 2 ) = 5 $=
    c4 c1 caddc co c3 c1 caddc co c1 caddc co c5 c3 c2 caddc co c4 c3 c1 caddc
    co c1 caddc df-4 opreq1i df-5 c3 c2 caddc co c3 c1 c1 caddc co caddc co c3
    c1 caddc co c1 caddc co c2 c1 c1 caddc co c3 caddc df-2 opreq2i c3 c1 c1 c3
    3re recni ax1cn ax1cn addassi eqtr4i 3eqtr4ri $.
    $( [12-May-2004] $) $( [11-May-2004] $)

  $( 3 + 3 = 6. $)
  3p3e6 $p |- ( 3 + 3 ) = 6 $=
    c3 c2 caddc co c1 caddc co c5 c1 caddc co c3 c3 caddc co c6 c3 c2 caddc co
    c5 c1 caddc 3p2e5 opreq1i c3 c3 caddc co c3 c2 c1 caddc co caddc co c3 c2
    caddc co c1 caddc co c3 c2 c1 caddc co c3 caddc df-3 opreq2i c3 c2 c1 c3
    3re recni 2cn ax1cn addassi eqtr4i df-6 3eqtr4i $.
    $( [12-May-2004] $) $( [11-May-2004] $)

  $( 4 + 2 = 6. $)
  4p2e6 $p |- ( 4 + 2 ) = 6 $=
    c5 c1 caddc co c4 c1 caddc co c1 caddc co c6 c4 c2 caddc co c5 c4 c1 caddc
    co c1 caddc df-5 opreq1i df-6 c4 c2 caddc co c4 c1 c1 caddc co caddc co c4
    c1 caddc co c1 caddc co c2 c1 c1 caddc co c4 caddc df-2 opreq2i c4 c1 c1 c4
    4re recni ax1cn ax1cn addassi eqtr4i 3eqtr4ri $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 4 + 3 = 7. $)
  4p3e7 $p |- ( 4 + 3 ) = 7 $=
    c4 c2 caddc co c1 caddc co c6 c1 caddc co c4 c3 caddc co c7 c4 c2 caddc co
    c6 c1 caddc 4p2e6 opreq1i c4 c3 caddc co c4 c2 c1 caddc co caddc co c4 c2
    caddc co c1 caddc co c3 c2 c1 caddc co c4 caddc df-3 opreq2i c4 c2 c1 c4
    4re recni 2cn ax1cn addassi eqtr4i df-7 3eqtr4i $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 4 + 4 = 8. $)
  4p4e8 $p |- ( 4 + 4 ) = 8 $=
    c4 c3 caddc co c1 caddc co c7 c1 caddc co c4 c4 caddc co c8 c4 c3 caddc co
    c7 c1 caddc 4p3e7 opreq1i c4 c4 caddc co c4 c3 c1 caddc co caddc co c4 c3
    caddc co c1 caddc co c4 c3 c1 caddc co c4 caddc df-4 opreq2i c4 c3 c1 c4
    4re recni c3 3re recni ax1cn addassi eqtr4i df-8 3eqtr4i $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 5 + 2 = 7. $)
  5p2e7 $p |- ( 5 + 2 ) = 7 $=
    c6 c1 caddc co c5 c1 caddc co c1 caddc co c7 c5 c2 caddc co c6 c5 c1 caddc
    co c1 caddc df-6 opreq1i df-7 c5 c2 caddc co c5 c1 c1 caddc co caddc co c5
    c1 caddc co c1 caddc co c2 c1 c1 caddc co c5 caddc df-2 opreq2i c5 c1 c1 c5
    5re recni ax1cn ax1cn addassi eqtr4i 3eqtr4ri $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 5 + 3 = 8. $)
  5p3e8 $p |- ( 5 + 3 ) = 8 $=
    c5 c2 caddc co c1 caddc co c7 c1 caddc co c5 c3 caddc co c8 c5 c2 caddc co
    c7 c1 caddc 5p2e7 opreq1i c5 c3 caddc co c5 c2 c1 caddc co caddc co c5 c2
    caddc co c1 caddc co c3 c2 c1 caddc co c5 caddc df-3 opreq2i c5 c2 c1 c5
    5re recni 2cn ax1cn addassi eqtr4i df-8 3eqtr4i $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 5 + 4 = 9. $)
  5p4e9 $p |- ( 5 + 4 ) = 9 $=
    c5 c3 caddc co c1 caddc co c8 c1 caddc co c5 c4 caddc co c9 c5 c3 caddc co
    c8 c1 caddc 5p3e8 opreq1i c5 c4 caddc co c5 c3 c1 caddc co caddc co c5 c3
    caddc co c1 caddc co c4 c3 c1 caddc co c5 caddc df-4 opreq2i c5 c3 c1 c5
    5re recni c3 3re recni ax1cn addassi eqtr4i df-9 3eqtr4i $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 5 + 5 = 10. $)
  5p5e10 $p |- ( 5 + 5 ) = 10 $=
    c5 c4 caddc co c1 caddc co c9 c1 caddc co c5 c5 caddc co c10 c5 c4 caddc co
    c9 c1 caddc 5p4e9 opreq1i c5 c5 caddc co c5 c4 c1 caddc co caddc co c5 c4
    caddc co c1 caddc co c5 c4 c1 caddc co c5 caddc df-5 opreq2i c5 c4 c1 c5
    5re recni c4 4re recni ax1cn addassi eqtr4i df-10 3eqtr4i $.
    $( [24-Feb-2007] $) $( [5-Feb-2007] $)

  $( 6 + 2 = 8. $)
  6p2e8 $p |- ( 6 + 2 ) = 8 $=
    c7 c1 caddc co c6 c1 caddc co c1 caddc co c8 c6 c2 caddc co c7 c6 c1 caddc
    co c1 caddc df-7 opreq1i df-8 c6 c2 caddc co c6 c1 c1 caddc co caddc co c6
    c1 caddc co c1 caddc co c2 c1 c1 caddc co c6 caddc df-2 opreq2i c6 c1 c1 c6
    6re recni ax1cn ax1cn addassi eqtr4i 3eqtr4ri $.
    $( [12-May-2004] $) $( [11-May-2004] $)

  $( 6 + 3 = 9. $)
  6p3e9 $p |- ( 6 + 3 ) = 9 $=
    c6 c2 caddc co c1 caddc co c8 c1 caddc co c6 c3 caddc co c9 c6 c2 caddc co
    c8 c1 caddc 6p2e8 opreq1i c6 c3 caddc co c6 c2 c1 caddc co caddc co c6 c2
    caddc co c1 caddc co c3 c2 c1 caddc co c6 caddc df-3 opreq2i c6 c2 c1 c6
    6re recni 2cn ax1cn addassi eqtr4i df-9 3eqtr4i $.
    $( [12-May-2004] $) $( [11-May-2004] $)

  $( 6 + 4 = 10. $)
  6p4e10 $p |- ( 6 + 4 ) = 10 $=
    c6 c3 caddc co c1 caddc co c9 c1 caddc co c6 c4 caddc co c10 c6 c3 caddc co
    c9 c1 caddc 6p3e9 opreq1i c6 c4 caddc co c6 c3 c1 caddc co caddc co c6 c3
    caddc co c1 caddc co c4 c3 c1 caddc co c6 caddc df-4 opreq2i c6 c3 c1 c6
    6re recni c3 3re recni ax1cn addassi eqtr4i df-10 3eqtr4i $.
    $( [19-Aug-2007] $) $( [5-Feb-2007] $)

  $( 7 + 2 = 9. $)
  7p2e9 $p |- ( 7 + 2 ) = 9 $=
    c8 c1 caddc co c7 c1 caddc co c1 caddc co c9 c7 c2 caddc co c8 c7 c1 caddc
    co c1 caddc df-8 opreq1i df-9 c7 c2 caddc co c7 c1 c1 caddc co caddc co c7
    c1 caddc co c1 caddc co c2 c1 c1 caddc co c7 caddc df-2 opreq2i c7 c1 c1 c7
    7re recni ax1cn ax1cn addassi eqtr4i 3eqtr4ri $.
    $( [20-Jun-2004] $) $( [11-May-2004] $)

  $( 7 + 3 = 10. $)
  7p3e10 $p |- ( 7 + 3 ) = 10 $=
    c7 c2 caddc co c1 caddc co c9 c1 caddc co c7 c3 caddc co c10 c7 c2 caddc co
    c9 c1 caddc 7p2e9 opreq1i c7 c3 caddc co c7 c2 c1 caddc co caddc co c7 c2
    caddc co c1 caddc co c3 c2 c1 caddc co c7 caddc df-3 opreq2i c7 c2 c1 c7
    7re recni 2cn ax1cn addassi eqtr4i df-10 3eqtr4i $.
    $( [5-Feb-2007] $) $( [5-Feb-2007] $)

  $( 8 + 2 = 10. $)
  8p2e10 $p |- ( 8 + 2 ) = 10 $=
    c9 c1 caddc co c8 c1 caddc co c1 caddc co c10 c8 c2 caddc co c9 c8 c1 caddc
    co c1 caddc df-9 opreq1i df-10 c8 c2 caddc co c8 c1 c1 caddc co caddc co c8
    c1 caddc co c1 caddc co c2 c1 c1 caddc co c8 caddc df-2 opreq2i c8 c1 c1 c8
    8re recni ax1cn ax1cn addassi eqtr4i 3eqtr4ri $.
    $( [20-Aug-2007] $) $( [5-Feb-2007] $)

  $( 2 times 2 equals 4. $)
  2t2e4 $p |- ( 2 x. 2 ) = 4 $=
    c2 c2 cmul co c2 c2 caddc co c4 c2 2cn 2timesi 2p2e4 eqtri $.
    $( [11-May-2004] $) $( [1-Aug-1999] $)

  $( 3 times 2 equals 6. $)
  3t2e6 $p |- ( 3 x. 2 ) = 6 $=
    c3 c2 cmul co c3 c3 caddc co c6 c3 c3 3re recni times2i 3p3e6 eqtri $.
    $( [3-Aug-2004] $) $( [2-Aug-2004] $)

  $( 3 times 3 equals 9. $)
  3t3e9 $p |- ( 3 x. 3 ) = 9 $=
    c3 c3 cmul co c3 c2 c1 caddc co cmul co c6 c3 caddc co c9 c3 c2 c1 caddc co
    c3 cmul df-3 opreq2i c3 c2 c1 caddc co cmul co c3 c2 cmul co c3 c1 cmul co
    caddc co c6 c3 caddc co c3 c2 c1 c3 3re recni 2cn ax1cn adddii c3 c2 cmul
    co c6 c3 c1 cmul co c3 caddc 3t2e6 c3 c3 3re recni mulid1i opreq12i eqtri
    6p3e9 3eqtri $.
    $( [12-May-2004] $) $( [11-May-2004] $)

  $( 4 times 2 equals 8. $)
  4t2e8 $p |- ( 4 x. 2 ) = 8 $=
    c4 c2 cmul co c4 c4 caddc co c8 c4 c4 4re recni times2i 4p4e8 eqtri $.
    $( [30-Aug-2004] $) $( [2-Aug-2004] $)

  $( 5 times 2 equals 10. $)
  5t2e10 $p |- ( 5 x. 2 ) = 10 $=
    c5 c2 cmul co c5 c5 caddc co c10 c5 c5 5re recni times2i 5p5e10 eqtri $.
    $( [7-Apr-2007] $) $( [5-Feb-2007] $)

  $( One half of four is two. $)
  4d2e2 $p |- ( 4 / 2 ) = 2 $=
    c4 c2 cdiv co c2 wceq c2 c2 cmul co c4 wceq 2t2e4 c4 c2 c2 c4 4re recni 2cn
    2cn 2ne0 divmuli mpbir $.
    $( [3-Sep-1999] $)

  $( 1 is less than 2. $)
  1lt2 $p |- 1 < 2 $=
    c1 c1 c1 caddc co c2 clt c1 1re ltp1i df-2 breqtrri $.
    $( [26-Feb-2005] $) $( [24-Feb-2005] $)

  $( 2 is less than 3. $)
  2lt3 $p |- 2 < 3 $=
    c2 c2 c1 caddc co c3 clt c2 2re ltp1i df-3 breqtrri $.
    $( [27-Sep-2010] $) $( [26-Sep-2010] $)

  $( 1 is less than 3. $)
  1lt3 $p |- 1 < 3 $=
    c1 c2 clt wbr c2 c3 clt wbr c1 c3 clt wbr 1lt2 2lt3 c1 c2 c3 1re 2re 3re
    lttri mp2an $.
    $( [27-Sep-2010] $) $( [26-Sep-2010] $)

  $( One-half is greater than zero. $)
  halfgt0 $p |- 0 < ( 1 / 2 ) $=
    c2 2re 2pos recgt0ii $.
    $( [26-Feb-2005] $) $( [24-Feb-2005] $)

  $( One-half is less than one. $)
  halflt1 $p |- ( 1 / 2 ) < 1 $=
    c1 c1 cdiv co c2 clt wbr c1 c2 cdiv co c1 clt wbr c1 c1 cdiv co c1 c2 clt
    c1 ax1cn div1i 1lt2 eqbrtri c1 c1 c2 1re 1re 2re lt01 2pos ltdiv23ii mpbi
    $.
    $( [26-Feb-2005] $) $( [24-Feb-2005] $)

  $( An eighth of four thirds is a sixth.  (Contributed by Paul Chapman,
     24-Nov-2007.) $)
  8th4div3 $p |- ( ( 1 / 8 ) x. ( 4 / 3 ) ) = ( 1 / 6 ) $=
    c1 c8 cdiv co c4 c3 cdiv co cmul co c4 c1 cmul co c4 c6 cmul co cdiv co c1
    c6 cdiv co c1 c8 cdiv co c4 c3 cdiv co cmul co c1 c4 cmul co c8 c3 cmul co
    cdiv co c4 c1 cmul co c8 c3 cmul co cdiv co c4 c1 cmul co c4 c6 cmul co
    cdiv co c1 c8 c4 c3 ax1cn c8 8re recni c4 4re recni c3 3re recni c8 8re
    8pos gt0ne0ii c3 3re 3pos gt0ne0ii divmuldivi c1 c4 cmul co c4 c1 cmul co
    c8 c3 cmul co cdiv c1 c4 ax1cn c4 4re recni mulcomi opreq1i c8 c3 cmul co
    c4 c6 cmul co c4 c1 cmul co cdiv c8 c3 cmul co c4 c3 c2 cmul co cmul co c4
    c6 cmul co c4 c2 cmul co c3 cmul co c4 c3 cmul co c2 cmul co c8 c3 cmul co
    c4 c3 c2 cmul co cmul co c4 c2 c3 c4 4re recni 2cn c3 3re recni mul23i c4
    c2 cmul co c8 c3 cmul 4t2e8 opreq1i c4 c3 c2 c4 4re recni c3 3re recni 2cn
    mulassi 3eqtr3i c3 c2 cmul co c6 c4 cmul 3t2e6 opreq2i eqtri opreq2i 3eqtri
    c4 cc wcel c4 cc0 wne c4 c1 cmul co c4 c6 cmul co cdiv co c1 c6 cdiv co
    wceq c4 4re recni c4 4re 4pos gt0ne0ii c6 cc wcel c6 cc0 wne c4 cc wcel c4
    cc0 wne wa c4 c1 cmul co c4 c6 cmul co cdiv co c1 c6 cdiv co wceq c6 6re
    recni c6 6re 6pos gt0ne0ii c1 cc wcel c6 cc wcel c6 cc0 wne wa c4 cc wcel
    c4 cc0 wne wa c4 c1 cmul co c4 c6 cmul co cdiv co c1 c6 cdiv co wceq ax1cn
    c1 c6 c4 divcan5 mp3an1 mpanl12 mp2an eqtri $.
    $( [25-Nov-2007] $) $( [24-Nov-2007] $)

  $( One half plus or minus one sixth.  (Contributed by Paul Chapman,
     17-Jan-2008.) $)
  halfpm6th $p |- ( ( ( 1 / 2 ) - ( 1 / 6 ) ) = ( 1 / 3 ) /\
                       ( ( 1 / 2 ) + ( 1 / 6 ) ) = ( 2 / 3 ) ) $=
    c1 c2 cdiv co c1 c6 cdiv co cmin co c1 c3 cdiv co wceq c1 c2 cdiv co c1 c6
    cdiv co caddc co c2 c3 cdiv co wceq c1 c2 cdiv co c1 c6 cdiv co cmin co c3
    c6 cdiv co c1 c6 cdiv co cmin co c3 c1 cmin co c6 cdiv co c1 c3 cdiv co c1
    c2 cdiv co c3 c6 cdiv co c1 c6 cdiv co cmin c3 c3 cdiv co c1 c2 cdiv co
    cmul co c3 c1 cmul co c3 c2 cmul co cdiv co c1 c2 cdiv co c3 c6 cdiv co c3
    c3 c1 c2 c3 3nn nncni c3 3nn nncni ax1cn 2cn c3 3nn nnne0i 2ne0 divmuldivi
    c3 c3 cdiv co c1 c2 cdiv co cmul co c1 c1 c2 cdiv co cmul co c1 c2 cdiv co
    c3 c3 cdiv co c1 c1 c2 cdiv co cmul c3 c3 3nn nncni c3 3nn nnne0i dividi
    opreq1i c1 c2 cdiv co c1 c2 cdiv co c2 2re 2ne0 rereccli recni mulid2i
    eqtri c3 c1 cmul co c3 c3 c2 cmul co c6 cdiv c3 c3 3nn nncni mulid1i 3t2e6
    opreq12i 3eqtr3i opreq1i c3 cc wcel c1 cc wcel c6 cc wcel c6 cc0 wne wa c3
    c1 cmin co c6 cdiv co c3 c6 cdiv co c1 c6 cdiv co cmin co wceq c3 3nn nncni
    ax1cn c6 cc wcel c6 cc0 wne c6 6re recni c6 6re 6pos gt0ne0ii pm3.2i c3 c1
    c6 divsubdir mp3an c3 c1 cmin co c6 cdiv co c2 c6 cdiv co c1 c2 cmul co c3
    c2 cmul co cdiv co c1 c3 cdiv co c3 c1 cmin co c2 c6 cdiv c3 c1 cmin co c2
    c1 caddc co c1 cmin co c2 c3 c2 c1 caddc co c1 cmin df-3 opreq1i c2 cc wcel
    c1 cc wcel c2 c1 caddc co c1 cmin co c2 wceq 2cn ax1cn c2 c1 pncan mp2an
    eqtri opreq1i c1 c2 cmul co c2 c3 c2 cmul co c6 cdiv c2 2cn mulid2i 3t2e6
    opreq12i c1 c3 cdiv co c2 c2 cdiv co cmul co c1 c3 cdiv co c1 cmul co c1 c2
    cmul co c3 c2 cmul co cdiv co c1 c3 cdiv co c2 c2 cdiv co c1 c1 c3 cdiv co
    cmul c2 2cn 2ne0 dividi opreq2i c1 c3 c2 c2 ax1cn c3 3nn nncni 2cn 2cn c3
    3nn nnne0i 2ne0 divmuldivi c1 c3 cdiv co c3 c3 3nn nncni c3 3nn nnne0i
    reccli mulid1i 3eqtr3i 3eqtr2i 3eqtr2i c1 c2 cdiv co c1 c6 cdiv co caddc co
    c4 c6 cdiv co c2 c2 cmul co c3 c2 cmul co cdiv co c2 c3 cdiv co c3 c1 caddc
    co c6 cdiv co c3 c6 cdiv co c1 c6 cdiv co caddc co c4 c6 cdiv co c1 c2 cdiv
    co c1 c6 cdiv co caddc co c3 c1 c6 c3 3nn nncni ax1cn c6 6re recni c6 6re
    6pos gt0ne0ii divdiri c4 c3 c1 caddc co c6 cdiv df-4 opreq1i c1 c2 cdiv co
    c3 c6 cdiv co c1 c6 cdiv co caddc c3 c3 cdiv co c1 c2 cdiv co cmul co c3 c1
    cmul co c3 c2 cmul co cdiv co c1 c2 cdiv co c3 c6 cdiv co c3 c3 c1 c2 c3
    3nn nncni c3 3nn nncni ax1cn 2cn c3 3nn nnne0i 2ne0 divmuldivi c3 c3 cdiv
    co c1 c2 cdiv co cmul co c1 c1 c2 cdiv co cmul co c1 c2 cdiv co c3 c3 cdiv
    co c1 c1 c2 cdiv co cmul c3 c3 3nn nncni c3 3nn nnne0i dividi opreq1i c1 c2
    cdiv co c1 c2 cdiv co c2 2re 2ne0 rereccli recni mulid2i eqtri c3 c1 cmul
    co c3 c3 c2 cmul co c6 cdiv c3 c3 3nn nncni mulid1i 3t2e6 opreq12i 3eqtr3i
    opreq1i 3eqtr4ri c2 c2 cmul co c4 c3 c2 cmul co c6 cdiv 2t2e4 3t2e6
    opreq12i c2 c3 cdiv co c2 c2 cdiv co cmul co c2 c3 cdiv co c1 cmul co c2 c2
    cmul co c3 c2 cmul co cdiv co c2 c3 cdiv co c2 c2 cdiv co c1 c2 c3 cdiv co
    cmul c2 2cn 2ne0 dividi opreq2i c2 c3 c2 c2 2cn c3 3nn nncni 2cn 2cn c3 3nn
    nnne0i 2ne0 divmuldivi c2 c3 cdiv co c2 c3 2cn c3 3nn nncni c3 3nn nnne0i
    divcli mulid1i 3eqtr3i 3eqtr2i pm3.2i $.
    $( [18-Jan-2008] $) $( [17-Jan-2008] $)

  $( Closure of half of a number (frequently used special case). $)
  halfcl $p |- ( A e. CC -> ( A / 2 ) e. CC ) $=
    cA cc wcel c2 cc wcel c2 cc0 wne cA c2 cdiv co cc wcel 2cn 2ne0 cA c2 divcl
    mp3an23 $.
    $( [1-Jan-2006] $) $( [1-Jan-2006] $)

  $( Real closure of half. $)
  rehalfcl $p |- ( A e. RR -> ( A / 2 ) e. RR ) $=
    cA cr wcel c2 cr wcel c2 cc0 wne cA c2 cdiv co cr wcel 2re 2ne0 cA c2
    redivcl mp3an23 $.
    $( [2-Jan-2006] $) $( [1-Jan-2006] $)

  $( Half of a number is zero iff the number is zero. $)
  half0 $p |- ( A e. CC -> ( ( A / 2 ) = 0 <-> A = 0 ) ) $=
    cA cc wcel c2 cc wcel c2 cc0 wne cA c2 cdiv co cc0 wceq cA cc0 wceq wb 2cn
    2ne0 cA c2 diveq0 mp3an23 $.
    $( [12-Jun-2006] $) $( [20-Apr-2006] $)

  $( A positive number is greater than its half. $)
  halfpos $p |- ( A e. RR -> ( 0 < A <-> ( A / 2 ) < A ) ) $=
    cA cr wcel cc0 cA clt wbr cA c1 c1 caddc co cdiv co cA clt wbr cA c2 cdiv
    co cA clt wbr cA cr wcel cc0 cA clt wbr cA c1 c1 caddc co cdiv co cA clt
    wbr wb cc0 cA cr wcel cA cc0 cif clt wbr cA cr wcel cA cc0 cif c1 c1 caddc
    co cdiv co cA cr wcel cA cc0 cif clt wbr wb cA cc0 cA cA cr wcel cA cc0 cif
    wceq cc0 cA clt wbr cc0 cA cr wcel cA cc0 cif clt wbr cA c1 c1 caddc co
    cdiv co cA clt wbr cA cr wcel cA cc0 cif c1 c1 caddc co cdiv co cA cr wcel
    cA cc0 cif clt wbr cA cA cr wcel cA cc0 cif cc0 clt breq2 cA cA cr wcel cA
    cc0 cif wceq cA c1 c1 caddc co cdiv co cA cr wcel cA cc0 cif c1 c1 caddc co
    cdiv co cA cA cr wcel cA cc0 cif clt cA cA cr wcel cA cc0 cif c1 c1 caddc
    co cdiv opreq1 cA cA cr wcel cA cc0 cif wceq id breq12d bibi12d cA cr wcel
    cA cc0 cif cA cc0 cr 0re elimel halfposi dedth cA c2 cdiv co cA c1 c1 caddc
    co cdiv co cA clt c2 c1 c1 caddc co cA cdiv df-2 opreq2i breq1i syl6bbr $.
    $( [29-Oct-2004] $) $( [28-Oct-2004] $)

  $( A number is positive iff its half is positive. $)
  halfpos2 $p |- ( A e. RR -> ( 0 < A <-> 0 < ( A / 2 ) ) ) $=
    cA cr wcel c2 cr wcel cc0 c2 clt wbr cc0 cA clt wbr cc0 cA c2 cdiv co clt
    wbr wb 2re 2pos cA c2 gt0div mp3an23 $.
    $( [3-May-2005] $) $( [10-Apr-2005] $)

  $( A number is nonnegative iff its half is nonnegative. $)
  halfnneg2 $p |- ( A e. RR -> ( 0 <_ A <-> 0 <_ ( A / 2 ) ) ) $=
    cA cr wcel c2 cr wcel cc0 c2 clt wbr cc0 cA cle wbr cc0 cA c2 cdiv co cle
    wbr wb 2re 2pos cA c2 ge0div mp3an23 $.
    $( [6-Feb-2006] $) $( [9-Dec-2005] $)

  $( Two halves make a whole. $)
  2halves $p |- ( A e. CC -> ( ( A / 2 ) + ( A / 2 ) ) = A ) $=
    cA cc wcel c2 cA cmul co c2 cdiv co cA cA caddc co c2 cdiv co cA cA c2 cdiv
    co cA c2 cdiv co caddc co cA cc wcel c2 cA cmul co cA cA caddc co c2 cdiv
    cA 2times opreq1d cA cc wcel c2 cc wcel c2 cc0 wne c2 cA cmul co c2 cdiv co
    cA wceq 2cn 2ne0 cA c2 divcan3 mp3an23 cA cc wcel cA cA caddc co c2 cdiv co
    cA c2 cdiv co cA c2 cdiv co caddc co wceq cA cc wcel cA cc wcel c2 cc wcel
    c2 cc0 wne wa cA cA caddc co c2 cdiv co cA c2 cdiv co cA c2 cdiv co caddc
    co wceq c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i cA cA c2 divdir mp3an3 anidms
    3eqtr3rd $.
    $( [29-Apr-2005] $) $( [11-Apr-2005] $)

  $( Closure of half-sum and half-difference.  (Contributed by Paul Chapman,
     12-Oct-2007.) $)
  halfaddsubcl $p |- ( ( A e. CC /\ B e. CC ) -> ( ( ( A + B ) / 2 ) e. CC /\
                         ( ( A - B ) / 2 ) e. CC ) ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2
    cdiv co cc wcel cA cc wcel cB cc wcel wa cA cB caddc co cc wcel cA cB caddc
    co c2 cdiv co cc wcel cA cB addcl cA cB caddc co halfcl syl cA cc wcel cB
    cc wcel wa cA cB cmin co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB
    subcl cA cB cmin co halfcl syl jca $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Sum and difference of half-sum and half-difference.  (Contributed by Paul
     Chapman, 12-Oct-2007.)  $)
  halfaddsub $p |- ( ( A e. CC /\ B e. CC ) ->
                      ( ( ( ( A + B ) / 2 ) + ( ( A - B ) / 2 ) ) = A /\
                        ( ( ( A + B ) / 2 ) - ( ( A - B ) / 2 ) ) = B ) ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    caddc co cA wceq cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co
    cB wceq cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co caddc co c2
    cdiv co c2 cA cmul co c2 cdiv co cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co caddc co cA cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co
    caddc co c2 cA cmul co c2 cdiv cA cc wcel cB cc wcel wa cA cB caddc co cA
    cB cmin co caddc co cA cA caddc co c2 cA cmul co cA cc wcel cB cc wcel cA
    cB caddc co cA cB cmin co caddc co cA cA caddc co wceq cA cB cA ppncan
    3anidm13 cA cc wcel c2 cA cmul co cA cA caddc co wceq cB cc wcel cA 2times
    adantr eqtr4d opreq1d cA cB caddc co cc wcel cA cB cmin co cc wcel cA cB
    caddc co cA cB cmin co caddc co c2 cdiv co cA cB caddc co c2 cdiv co cA cB
    cmin co c2 cdiv co caddc co wceq cA cc wcel cB cc wcel wa cA cB caddc co cc
    wcel cA cB cmin co cc wcel c2 cc wcel c2 cc0 wne wa cA cB caddc co cA cB
    cmin co caddc co c2 cdiv co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv
    co caddc co wceq c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i cA cB caddc co cA cB
    cmin co c2 divdir mp3an3 cA cB addcl cA cB subcl sylanc cA cc wcel c2 cA
    cmul co c2 cdiv co cA wceq cB cc wcel cA cc wcel c2 cc wcel c2 cc0 wne c2
    cA cmul co c2 cdiv co cA wceq 2cn 2ne0 cA c2 divcan3 mp3an23 adantr 3eqtr3d
    cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co cmin co c2 cdiv co c2
    cB cmul co c2 cdiv co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    cmin co cB cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co cmin co c2
    cB cmul co c2 cdiv cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co
    cmin co cB cB caddc co c2 cB cmul co cA cc wcel cB cc wcel cA cB caddc co
    cA cB cmin co cmin co cB cB caddc co wceq cA cB cB pnncan 3anidm23 cB cc
    wcel c2 cB cmul co cB cB caddc co wceq cA cc wcel cB 2times adantl eqtr4d
    opreq1d cA cB caddc co cc wcel cA cB cmin co cc wcel cA cB caddc co cA cB
    cmin co cmin co c2 cdiv co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv
    co cmin co wceq cA cc wcel cB cc wcel wa cA cB caddc co cc wcel cA cB cmin
    co cc wcel c2 cc wcel c2 cc0 wne wa cA cB caddc co cA cB cmin co cmin co c2
    cdiv co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co wceq c2
    cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i cA cB caddc co cA cB cmin co c2
    divsubdir mp3an3 cA cB addcl cA cB subcl sylanc cB cc wcel c2 cB cmul co c2
    cdiv co cB wceq cA cc wcel cB cc wcel c2 cc wcel c2 cc0 wne c2 cB cmul co
    c2 cdiv co cB wceq 2cn 2ne0 cB c2 divcan3 mp3an23 adantl 3eqtr3d jca $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( MAY BE REVISED - TODO - use this to reduce:
  Statement "lt2add" is directly referenced in the proofs of 9 statements:
    2climnn 2climnn0 climaddlem3 climmullem5 climcaui ser1f0i
  MM> sh us 2halves
  Statement "2halves" is directly referenced in the proofs of 10 statements:
    2climnn 2climnn0 climmullem5 climcaui caucvgi ser1f0i
  MM>
  $)
  $( A sum is less than the whole if each term is less than half. $)
  lt2halves $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( ( A < ( C / 2 ) /\ B < ( C / 2 ) ) -> ( A + B ) < C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cC c2 cdiv co clt wbr cB cC c2 cdiv
    co clt wbr wa cA cB caddc co cC c2 cdiv co cC c2 cdiv co caddc co clt wbr
    cA cB caddc co cC clt wbr cA cr wcel cB cr wcel wa cC c2 cdiv co cr wcel cC
    c2 cdiv co cr wcel wa cA cC c2 cdiv co clt wbr cB cC c2 cdiv co clt wbr wa
    cA cB caddc co cC c2 cdiv co cC c2 cdiv co caddc co clt wbr wi cA cr wcel
    cB cr wcel cC cr wcel w3a cA cB cC c2 cdiv co cC c2 cdiv co lt2add cA cr
    wcel cB cr wcel cC cr wcel 3simpa cC cr wcel cA cr wcel cC c2 cdiv co cr
    wcel cC c2 cdiv co cr wcel wa cB cr wcel cC cr wcel cC c2 cdiv co cr wcel
    cC c2 cdiv co cr wcel cC rehalfcl cC rehalfcl jca 3ad2ant3 sylanc cC cr
    wcel cA cr wcel cA cB caddc co cC c2 cdiv co cC c2 cdiv co caddc co clt wbr
    cA cB caddc co cC clt wbr wb cB cr wcel cC cr wcel cC c2 cdiv co cC c2 cdiv
    co caddc co cC cA cB caddc co clt cC cr wcel cC cc wcel cC c2 cdiv co cC c2
    cdiv co caddc co cC wceq cC recn cC 2halves syl breq2d 3ad2ant3 sylibd $.
    $( [13-Dec-2006] $) $( [13-Dec-2006] $)

  $( Sum is less than product for numbers greater than 2.  (Contributed by
     Stefan Allan, 24-Sep-2010.) $)
  addltmul $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 2 < A /\ 2 < B ) )
              -> ( A + B ) < ( A x. B ) ) $=
    cA cr wcel cB cr wcel wa c2 cA clt wbr c2 cB clt wbr wa cA cB caddc co cA
    cB cmul co clt wbr cA cr wcel cB cr wcel wa c2 cA clt wbr c2 cB clt wbr wa
    c1 cA c1 cmin co cB c1 cmin co cmul co clt wbr cA cB caddc co cA cB cmul co
    clt wbr cA cr wcel cB cr wcel wa c2 cA clt wbr c2 cB clt wbr wa c1 cA c1
    cmin co clt wbr c1 cB c1 cmin co clt wbr wa c1 cA c1 cmin co cB c1 cmin co
    cmul co clt wbr cA cr wcel c2 cA clt wbr c1 cA c1 cmin co clt wbr cB cr
    wcel c2 cB clt wbr c1 cB c1 cmin co clt wbr cA cr wcel c2 cA clt wbr c2 c1
    cmin co cA c1 cmin co clt wbr c1 cA c1 cmin co clt wbr c2 cr wcel cA cr
    wcel c1 cr wcel c2 cA clt wbr c2 c1 cmin co cA c1 cmin co clt wbr wb 2re
    1re c2 cA c1 ltsub1 mp3an13 c2 c1 cmin co c1 cA c1 cmin co clt c2 c1 c1 2cn
    ax1cn ax1cn c2 c1 c1 caddc co df-2 eqcomi subaddrii breq1i syl6bb cB cr
    wcel c2 cB clt wbr c2 c1 cmin co cB c1 cmin co clt wbr c1 cB c1 cmin co clt
    wbr c2 cr wcel cB cr wcel c1 cr wcel c2 cB clt wbr c2 c1 cmin co cB c1 cmin
    co clt wbr wb 2re 1re c2 cB c1 ltsub1 mp3an13 c2 c1 cmin co c1 cB c1 cmin
    co clt c2 c1 c1 2cn ax1cn ax1cn c2 c1 c1 caddc co df-2 eqcomi subaddrii
    breq1i syl6bb bi2anan9 cA c1 cmin co cr wcel cB c1 cmin co cr wcel c1 cA c1
    cmin co clt wbr c1 cB c1 cmin co clt wbr wa c1 cA c1 cmin co cB c1 cmin co
    cmul co clt wbr wi cA cr wcel cB cr wcel cA c1 cmin co cr wcel cB c1 cmin
    co cr wcel wa c1 cA c1 cmin co clt wbr c1 cB c1 cmin co clt wbr wa c1 cA c1
    cmin co cB c1 cmin co cmul co clt wbr cA c1 cmin co cB c1 cmin co mulgt1 ex
    cA peano2rem cB peano2rem syl2an sylbid cA cr wcel cB cr wcel wa c1 cA c1
    cmin co cB c1 cmin co cmul co clt wbr c1 cA cB cmul co c1 c1 cmul co caddc
    co cA c1 cmul co cB c1 cmul co caddc co cmin co clt wbr cA c1 cmul co cB c1
    cmul co caddc co c1 caddc co cA cB cmul co c1 caddc co clt wbr cA cB caddc
    co cA cB cmul co clt wbr cA cr wcel cB cr wcel wa cA c1 cmin co cB c1 cmin
    co cmul co cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co c1 clt cA cc wcel cB cc wcel cA c1 cmin co cB c1 cmin co
    cmul co cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co wceq cA cr wcel cB cr wcel cA cc wcel cB cc wcel c1 cc
    wcel cA c1 cmin co cB c1 cmin co cmul co cA cB cmul co c1 c1 cmul co caddc
    co cA c1 cmul co cB c1 cmul co caddc co cmin co wceq ax1cn cA cc wcel c1 cc
    wcel cB cc wcel c1 cc wcel wa cA c1 cmin co cB c1 cmin co cmul co cA cB
    cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co caddc co cmin co
    wceq ax1cn cA c1 cB c1 mulsub mpanl2 mpanr2 cA recn cB recn syl2an breq2d
    cA cr wcel cB cr wcel wa cA c1 cmul co cB c1 cmul co caddc co c1 caddc co
    cA cB cmul co c1 c1 cmul co caddc co clt wbr c1 cA cB cmul co c1 c1 cmul co
    caddc co cA c1 cmul co cB c1 cmul co caddc co cmin co clt wbr cA c1 cmul co
    cB c1 cmul co caddc co c1 caddc co cA cB cmul co c1 caddc co clt wbr cA c1
    cmul co cB c1 cmul co caddc co cr wcel cA cB cmul co c1 c1 cmul co caddc co
    cr wcel cA c1 cmul co cB c1 cmul co caddc co c1 caddc co cA cB cmul co c1
    c1 cmul co caddc co clt wbr c1 cA cB cmul co c1 c1 cmul co caddc co cA c1
    cmul co cB c1 cmul co caddc co cmin co clt wbr wb cA cr wcel cB cr wcel wa
    cA c1 cmul co cB c1 cmul co caddc co cr wcel c1 cr wcel cA cB cmul co c1 c1
    cmul co caddc co cr wcel cA c1 cmul co cB c1 cmul co caddc co c1 caddc co
    cA cB cmul co c1 c1 cmul co caddc co clt wbr c1 cA cB cmul co c1 c1 cmul co
    caddc co cA c1 cmul co cB c1 cmul co caddc co cmin co clt wbr wb 1re cA c1
    cmul co cB c1 cmul co caddc co c1 cA cB cmul co c1 c1 cmul co caddc co
    ltaddsub2 mp3an2 cA c1 cmul co cr wcel cB c1 cmul co cr wcel cA c1 cmul co
    cB c1 cmul co caddc co cr wcel cA cr wcel cB cr wcel cA c1 cmul co cB c1
    cmul co readdcl cA cr wcel c1 cr wcel cA c1 cmul co cr wcel 1re cA c1
    axmulrcl mpan2 cB cr wcel c1 cr wcel cB c1 cmul co cr wcel 1re cB c1
    axmulrcl mpan2 syl2an cA cB cmul co cr wcel c1 c1 cmul co cr wcel cA cB
    cmul co c1 c1 cmul co caddc co cr wcel cA cr wcel cB cr wcel wa cA cB cmul
    co c1 c1 cmul co readdcl cA cB axmulrcl c1 c1 1re 1re remulcli sylancl
    sylanc cA cB cmul co c1 c1 cmul co caddc co cA cB cmul co c1 caddc co cA c1
    cmul co cB c1 cmul co caddc co c1 caddc co clt c1 c1 cmul co c1 cA cB cmul
    co caddc c1 ax1cn mulid1i opreq2i breq2i syl5rbbr cA cr wcel cB cr wcel wa
    cA c1 cmul co cB c1 cmul co caddc co cA cB cmul co clt wbr cA c1 cmul co cB
    c1 cmul co caddc co c1 caddc co cA cB cmul co c1 caddc co clt wbr cA cB
    caddc co cA cB cmul co clt wbr cA c1 cmul co cB c1 cmul co caddc co cr wcel
    cA cB cmul co cr wcel cA c1 cmul co cB c1 cmul co caddc co cA cB cmul co
    clt wbr cA c1 cmul co cB c1 cmul co caddc co c1 caddc co cA cB cmul co c1
    caddc co clt wbr wb cA cr wcel cB cr wcel wa cA c1 cmul co cB c1 cmul co
    caddc co cr wcel cA cB cmul co cr wcel c1 cr wcel cA c1 cmul co cB c1 cmul
    co caddc co cA cB cmul co clt wbr cA c1 cmul co cB c1 cmul co caddc co c1
    caddc co cA cB cmul co c1 caddc co clt wbr wb 1re cA c1 cmul co cB c1 cmul
    co caddc co cA cB cmul co c1 ltadd1 mp3an3 cA c1 cmul co cr wcel cB c1 cmul
    co cr wcel cA c1 cmul co cB c1 cmul co caddc co cr wcel cA cr wcel cB cr
    wcel cA c1 cmul co cB c1 cmul co readdcl cA cr wcel c1 cr wcel cA c1 cmul
    co cr wcel 1re cA c1 axmulrcl mpan2 cB cr wcel c1 cr wcel cB c1 cmul co cr
    wcel 1re cB c1 axmulrcl mpan2 syl2an cA cB axmulrcl sylanc cA cr wcel cB cr
    wcel wa cA c1 cmul co cB c1 cmul co caddc co cA cB caddc co cA cB cmul co
    clt cA cr wcel cB cr wcel cA c1 cmul co cA cB c1 cmul co cB caddc cA cr
    wcel cA cc wcel cA c1 cmul co cA wceq cA recn cA mulid1 syl cB cr wcel cB
    cc wcel cB c1 cmul co cB wceq cB recn cB mulid1 syl opreqan12d breq1d
    bitr3d 3bitrd sylibd imp $.
    $( [25-Sep-2010] $) $( [24-Sep-2010] $)

  ${
    $d x y $.
    $( There is no smallest positive real number. $)
    nominpos $p |- -. E. x e. RR ( 0 < x /\
                   -. E. y e. RR ( 0 < y /\ y < x ) ) $=
      cc0 vx cv clt wbr cc0 vy cv clt wbr vy cv vx cv clt wbr wa vy cr wrex wn
      wa vx cr vx cv cr wcel cc0 vx cv clt wbr cc0 vy cv clt wbr vy cv vx cv
      clt wbr wa vy cr wrex wi cc0 vx cv clt wbr cc0 vy cv clt wbr vy cv vx cv
      clt wbr wa vy cr wrex wn wa wn vx cv cr wcel cc0 vx cv clt wbr vx cv c2
      cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr vx cv c2 cdiv co vx cv clt
      wbr wa wa cc0 vy cv clt wbr vy cv vx cv clt wbr wa vy cr wrex vx cv cr
      wcel cc0 vx cv clt wbr cc0 vx cv c2 cdiv co clt wbr vx cv c2 cdiv co vx
      cv clt wbr wa vx cv c2 cdiv co cr wcel vx cv cr wcel cc0 vx cv clt wbr
      cc0 vx cv c2 cdiv co clt wbr vx cv c2 cdiv co vx cv clt wbr vx cv cr wcel
      cc0 vx cv clt wbr cc0 vx cv c2 cdiv co clt wbr vx cv cr wcel cc0 vx cv
      clt wbr wa c2 cr wcel cc0 c2 clt wbr cc0 vx cv c2 cdiv co clt wbr 2re
      2pos vx cv c2 divgt0 mpanr12 ex vx cv cr wcel cc0 vx cv clt wbr vx cv c2
      cdiv co vx cv clt wbr vx cv halfpos biimpd jcad vx cv rehalfcl jctild cc0
      vy cv clt wbr vy cv vx cv clt wbr wa cc0 vx cv c2 cdiv co clt wbr vx cv
      c2 cdiv co vx cv clt wbr wa vy vx cv c2 cdiv co cr vy cv vx cv c2 cdiv co
      wceq cc0 vy cv clt wbr cc0 vx cv c2 cdiv co clt wbr vy cv vx cv clt wbr
      vx cv c2 cdiv co vx cv clt wbr vy cv vx cv c2 cdiv co cc0 clt breq2 vy cv
      vx cv c2 cdiv co vx cv clt breq1 anbi12d rcla4ev syl6 cc0 vx cv clt wbr
      cc0 vy cv clt wbr vy cv vx cv clt wbr wa vy cr wrex iman sylib nrex $.
      $( [29-Oct-2004] $) $( [28-Oct-2004] $)
  $}

  $( The average of two numbers is less than or equal to at least one of
     them. $)
  avgle $p |- ( ( A e. RR /\ B e. RR ) ->
               ( ( ( A + B ) / 2 ) <_ A \/ ( ( A + B ) / 2 ) <_ B ) ) $=
    cA cr wcel cB cr wcel wa cA cB caddc co c2 cdiv co cA cle wbr cA cB caddc
    co c2 cdiv co cB cle wbr wo cA cB caddc co c2 cA cmul co cle wbr cA cB
    caddc co c2 cB cmul co cle wbr wo cA cr wcel cB cr wcel wa cA cB caddc co
    c2 cA cmul co cle wbr cA cB caddc co c2 cB cmul co cle wbr cA cr wcel cB cr
    wcel wa cA cB caddc co c2 cA cmul co cle wbr wn c2 cA cmul co cA cB caddc
    co clt wbr cA cB caddc co c2 cB cmul co cle wbr c2 cA cmul co cr wcel cA cB
    caddc co cr wcel c2 cA cmul co cA cB caddc co clt wbr cA cB caddc co c2 cA
    cmul co cle wbr wn wb cA cr wcel cB cr wcel wa c2 cA cmul co cA cB caddc co
    ltnle cA cr wcel c2 cA cmul co cr wcel cB cr wcel c2 cr wcel cA cr wcel c2
    cA cmul co cr wcel 2re c2 cA remulcl mpan adantr cA cB readdcl sylanc cA cr
    wcel cB cr wcel wa c2 cA cmul co cA cB caddc co clt wbr cA cB caddc co c2
    cB cmul co clt wbr cA cB caddc co c2 cB cmul co cle wbr cA cr wcel cB cr
    wcel wa cA cA caddc co cA cB caddc co clt wbr cA cB caddc co cB cB caddc co
    clt wbr c2 cA cmul co cA cB caddc co clt wbr cA cB caddc co c2 cB cmul co
    clt wbr cA cr wcel cB cr wcel wa cA cB clt wbr cA cA caddc co cA cB caddc
    co clt wbr cA cB caddc co cB cB caddc co clt wbr cA cr wcel cB cr wcel cA
    cB clt wbr cA cA caddc co cA cB caddc co clt wbr wb cA cB cA ltadd2
    3anidm13 cA cr wcel cB cr wcel cA cB clt wbr cA cB caddc co cB cB caddc co
    clt wbr wb cA cB cB ltadd1 3anidm23 bitr3d cA cr wcel cB cr wcel wa c2 cA
    cmul co cA cA caddc co cA cB caddc co clt cA cr wcel c2 cA cmul co cA cA
    caddc co wceq cB cr wcel cA cr wcel cA cc wcel c2 cA cmul co cA cA caddc co
    wceq cA recn cA 2times syl adantr breq1d cA cr wcel cB cr wcel wa c2 cB
    cmul co cB cB caddc co cA cB caddc co clt cB cr wcel c2 cB cmul co cB cB
    caddc co wceq cA cr wcel cB cr wcel cB cc wcel c2 cB cmul co cB cB caddc co
    wceq cB recn cB 2times syl adantl breq2d 3bitr4d cA cB caddc co cr wcel c2
    cB cmul co cr wcel cA cB caddc co c2 cB cmul co clt wbr cA cB caddc co c2
    cB cmul co cle wbr wi cA cr wcel cB cr wcel wa cA cB caddc co c2 cB cmul co
    ltle cA cB readdcl cB cr wcel c2 cB cmul co cr wcel cA cr wcel c2 cr wcel
    cB cr wcel c2 cB cmul co cr wcel 2re c2 cB remulcl mpan adantl sylanc
    sylbid sylbird orrd cA cr wcel cB cr wcel wa cA cB caddc co c2 cdiv co cA
    cle wbr cA cB caddc co c2 cA cmul co cle wbr cA cB caddc co c2 cdiv co cB
    cle wbr cA cB caddc co c2 cB cmul co cle wbr cA cB caddc co cr wcel cA cr
    wcel cA cB caddc co c2 cdiv co cA cle wbr cA cB caddc co c2 cA cmul co cle
    wbr wb cA cr wcel cB cr wcel wa cA cB caddc co cr wcel c2 cr wcel cA cr
    wcel cA cB caddc co c2 cdiv co cA cle wbr cA cB caddc co c2 cA cmul co cle
    wbr wb 2re cA cB caddc co cr wcel c2 cr wcel cA cr wcel w3a cc0 c2 clt wbr
    cA cB caddc co c2 cdiv co cA cle wbr cA cB caddc co c2 cA cmul co cle wbr
    wb 2pos cA cB caddc co c2 cA ledivmulOLD mpan2 mp3an2 cA cB readdcl cA cr
    wcel cB cr wcel pm3.26 sylanc cA cr wcel cB cr wcel cA cB caddc co cr wcel
    cA cB caddc co c2 cdiv co cB cle wbr cA cB caddc co c2 cB cmul co cle wbr
    wb cA cB readdcl cA cB caddc co cr wcel c2 cr wcel cB cr wcel cA cB caddc
    co c2 cdiv co cB cle wbr cA cB caddc co c2 cB cmul co cle wbr wb 2re cA cB
    caddc co cr wcel c2 cr wcel cB cr wcel w3a cc0 c2 clt wbr cA cB caddc co c2
    cdiv co cB cle wbr cA cB caddc co c2 cB cmul co cle wbr wb 2pos cA cB caddc
    co c2 cB ledivmulOLD mpan2 mp3an2 sylancom orbi12d mpbird $.
    $( [1-Feb-2006] $) $( [9-Dec-2005] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Positive reals (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the set of positive reals.  Definition of positive numbers in
     [Apostol] p. 20. $)
  df-rp $a |- RR+ = { x e. RR | 0 < x } $.

  ${
    $d x A $.
    $( Membership in the set of positive reals. $)
    elrp $p |- ( A e. RR+ <-> ( A e. RR /\ 0 < A ) ) $=
      cc0 vx cv clt wbr cc0 cA clt wbr vx cA cr crp vx cv cA cc0 clt breq2 vx
      df-rp elrab2 $.
      $( [27-Oct-2007] $) $( [27-Oct-2007] $)
  $}

  ${
    elrpi.1 $e |- A e. RR $.
    elrpi.2 $e |- 0 < A $.
    $( Membership in the set of positive reals. $)
    elrpii $p |- A e. RR+ $=
      cA crp wcel cA cr wcel cc0 cA clt wbr cA elrp elrpi.1 elrpi.2 mpbir2an $.
      $( [24-Feb-2008] $) $( [23-Feb-2008] $)
  $}

  $( 1 is a positive real.  (Contributed by Jeffrey Hankins, 23-Nov-2008.) $)
  1rp $p |- 1 e. RR+ $=
    c1 1re lt01 elrpii $.
    $( [23-Nov-2008] $) $( [23-Nov-2008] $)

  $( A positive real is a real. $)
  rpre $p |- ( A e. RR+ -> A e. RR ) $=
    crp cr cA crp cc0 vx cv clt wbr vx cr crab cr vx df-rp cc0 vx cv clt wbr vx
    cr ssrab2 eqsstri sseli $.
    $( [27-Oct-2007] $) $( [27-Oct-2007] $)

  $( A positive real is a complex number. $)
  rpcn $p |- ( A e. RR+ -> A e. CC ) $=
    cA crp wcel cA cA rpre recnd $.
    $( [14-Nov-2008] $) $( [11-Nov-2008] $)

  $( A natural number is a positive real. $)
  nnrp $p |- ( A e. NN -> A e. RR+ ) $=
    cA crp wcel cA cr wcel cc0 cA clt wbr cA cn wcel cA elrp cA nnre cA nngt0
    sylanbrc $.
    $( [25-Dec-2008] $) $( [28-Nov-2008] $)

  $( The positive reals are a subset of the reals. $)
  rpssre $p |- RR+ C_ RR $=
    vx crp cr vx cv rpre ssriv $.
    $( [19-Mar-2008] $) $( [24-Feb-2008] $)

  $( A positive real is greater than zero.  (Contributed by FL,
     27-Dec-2007.) $)
  rpgt0 $p |- ( A e. RR+ -> 0 < A ) $=
    cA crp wcel cA cr wcel cc0 cA clt wbr cA elrp pm3.27bi $.
    $( [22-Jan-2008] $) $( [27-Dec-2007] $)

  $( A positive real is greater than or equal to zero. $)
  rpge0 $p |- ( A e. RR+ -> 0 <_ A ) $=
    cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cA crp wcel cc0 cr wcel cA cr wcel
    cc0 cA clt wbr cc0 cA cle wbr wi 0re cc0 cA ltle mpan cA rpre cA rpgt0 sylc
    $.
    $( [6-Mar-2008] $) $( [22-Feb-2008] $)

  $( A positive real is a positive real number. $)
  rpregt0 $p |- ( A e. RR+ -> ( A e. RR /\ 0 < A ) ) $=
    cA crp wcel cA cr wcel cc0 cA clt wbr cA rpre cA rpgt0 jca $.
    $( [13-Nov-2008] $) $( [11-Nov-2008] $)

  $( A positive real is nonzero. $)
  rpne0 $p |- ( A e. RR+ -> A =/= 0 ) $=
    cA crp wcel cA cr wcel cc0 cA clt wbr wa cA cc0 wne cA rpregt0 cA gt0ne0
    syl $.
    $( [18-Jul-2008] $) $( [18-Jul-2008] $)

  $( A positive real is a nonzero real number. $)
  rprene0 $p |- ( A e. RR+ -> ( A e. RR /\ A =/= 0 ) ) $=
    cA crp wcel cA cr wcel cA cc0 wne cA rpre cA rpne0 jca $.
    $( [14-Nov-2008] $) $( [11-Nov-2008] $)

  $( A positive real is a nonzero complex number. $)
  rpcnne0 $p |- ( A e. RR+ -> ( A e. CC /\ A =/= 0 ) ) $=
    cA crp wcel cA cc wcel cA cc0 wne cA rpcn cA rpne0 jca $.
    $( [14-Nov-2008] $) $( [11-Nov-2008] $)

  $( Quantification over positive reals. $)
  ralrp $p |- ( A. x e. RR+ ph <-> A. x e. RR ( 0 < x -> ph ) ) $=
    wph cc0 vx cv clt wbr wph wi vx crp cr vx cv crp wcel wph wi vx cv cr wcel
    cc0 vx cv clt wbr wa wph wi vx cv cr wcel cc0 vx cv clt wbr wph wi wi vx cv
    crp wcel vx cv cr wcel cc0 vx cv clt wbr wa wph vx cv elrp imbi1i vx cv cr
    wcel cc0 vx cv clt wbr wph impexp bitri ralbii2 $.
    $( [13-Feb-2008] $) $( [12-Feb-2008] $)

  $( Closure law for addition of positive reals.  Part of Axiom 7 of [Apostol]
     p. 20. $)
  rpaddcl $p |- ( ( A e. RR+ /\ B e. RR+ ) -> ( A + B ) e. RR+ ) $=
    cA cB caddc co crp wcel cA cB caddc co cr wcel cc0 cA cB caddc co clt wbr
    cA crp wcel cB crp wcel wa cA cB caddc co elrp cA cr wcel cB cr wcel cA cB
    caddc co cr wcel cA crp wcel cB crp wcel cA cB readdcl cA rpre cB rpre
    syl2an cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB
    caddc co clt wbr cA crp wcel cB crp wcel cA cr wcel cB cr wcel cc0 cA clt
    wbr cc0 cB clt wbr cc0 cA cB caddc co clt wbr cA cB addgt0 an4s cA elrp cB
    elrp syl2anb sylanbrc $.
    $( [27-Oct-2007] $) $( [27-Oct-2007] $)

  $( Closure law for multiplication of positive reals.  Part of Axiom 7 of
     [Apostol] p. 20. $)
  rpmulcl $p |- ( ( A e. RR+ /\ B e. RR+ ) -> ( A x. B ) e. RR+ ) $=
    cA cB cmul co crp wcel cA cB cmul co cr wcel cc0 cA cB cmul co clt wbr cA
    crp wcel cB crp wcel wa cA cB cmul co elrp cA cr wcel cB cr wcel cA cB cmul
    co cr wcel cA crp wcel cB crp wcel cA cB remulcl cA rpre cB rpre syl2an cA
    cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cmul co
    clt wbr cA crp wcel cB crp wcel cA cr wcel cB cr wcel cc0 cA clt wbr cc0 cB
    clt wbr cc0 cA cB cmul co clt wbr cA cr wcel cB cr wcel wa cc0 cA clt wbr
    cc0 cB clt wbr wa cc0 cA cB cmul co clt wbr cA cB axmulgt0 imp an4s cA elrp
    cB elrp syl2anb sylanbrc $.
    $( [27-Oct-2007] $) $( [27-Oct-2007] $)

  $( Closure law for division of positive reals.  (Contributed by FL,
     27-Dec-2007.) $)
  rpdivcl $p |- ( ( A e. RR+ /\ B e. RR+ ) -> ( A / B ) e. RR+ ) $=
    cA cB cdiv co crp wcel cA cB cdiv co cr wcel cc0 cA cB cdiv co clt wbr cA
    crp wcel cB crp wcel wa cA cB cdiv co elrp cA cr wcel cB cr wcel cB cc0 wne
    wa cA cB cdiv co cr wcel cA crp wcel cB crp wcel cA cr wcel cB cr wcel cB
    cc0 wne cA cB cdiv co cr wcel cA cB redivcl 3expb cA rpre cB rprene0 syl2an
    cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co
    clt wbr cA crp wcel cB crp wcel cA cB divgt0 cA elrp cB elrp syl2anb
    sylanbrc $.
    $( [22-Jan-2008] $) $( [27-Dec-2007] $)

  $( Closure law for reciprocation of positive reals.  (Contributed by Jeffrey
     Hankins, 23-Nov-2008.) $)
  rpreccl $p |- ( A e. RR+ -> ( 1 / A ) e. RR+ ) $=
    c1 crp wcel cA crp wcel c1 cA cdiv co crp wcel 1rp c1 cA rpdivcl mpan $.
    $( [23-Nov-2008] $) $( [23-Nov-2008] $)

  $( Closure law for division of a real by a positive real. $)
  rerpdivcl $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A / B ) e. RR ) $=
    cA cr wcel cB cr wcel cB cc0 wne wa cA cB cdiv co cr wcel cB crp wcel cA cr
    wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cB redivcl 3expb cB
    rprene0 sylan2 $.
    $( [18-Nov-2008] $) $( [10-Nov-2008] $)

  $( Either a nonzero real or its negation is a positive real, but not both.
     Axiom 8 of [Apostol] p. 20. $)
  rpneg $p |- ( ( A e. RR /\ A =/= 0 ) -> ( A e. RR+ <-> -. -u A e. RR+ ) ) $=
    cA cr wcel cA cc0 wne wa cA cr wcel cc0 cA clt wbr wa cA cneg cr wcel cc0
    cA cneg clt wbr wa wn cA crp wcel cA cneg crp wcel wn cA cr wcel cA cc0 wne
    wa cA cr wcel cc0 cA clt wbr wa cA cneg cr wcel wn cc0 cA cneg clt wbr wn
    wo cA cneg cr wcel cc0 cA cneg clt wbr wa wn cA cr wcel cA cc0 wne wa cA cr
    wcel cc0 cA clt wbr wa cA cneg cr wcel wn cc0 cA cle wbr wo cA cneg cr wcel
    wn cc0 cA cneg clt wbr wn wo cA cr wcel cA cc0 wne wa cA cr wcel cc0 cA clt
    wbr wa cA cneg cr wcel wn cc0 cA cle wbr wo cA cr wcel cc0 cA clt wbr wa
    cc0 cA cle wbr cA cneg cr wcel wn cA cr wcel cc0 cA clt wbr cc0 cA cle wbr
    cc0 cr wcel cA cr wcel cc0 cA clt wbr cc0 cA cle wbr wi 0re cc0 cA ltle
    mpan imp olcd cA cr wcel cA cc0 wne wa cA cneg cr wcel wn cc0 cA cle wbr wo
    cc0 cA clt wbr cA cr wcel cA cr wcel cA cc0 wne wa cA cneg cr wcel wn cc0
    cA clt wbr cc0 cA cle wbr cA cr wcel cA cneg cr wcel wn cc0 cA clt wbr wi
    cA cc0 wne cA cr wcel cA cneg cr wcel cc0 cA clt wbr cA renegcl pm2.24d
    adantr cA cr wcel cA cc0 wne cc0 cA cle wbr cc0 cA clt wbr wi cA cr wcel
    cc0 cA cle wbr cA cc0 wne cc0 cA clt wbr cA cr wcel cc0 cA cle wbr cA cc0
    wne cc0 cA clt wbr cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cA cc0 wne wa
    cc0 cr wcel cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cA cc0 wne wa wb 0re
    cc0 cA ltlen mpan biimprd exp3a com23 imp jaod cA cr wcel cA cc0 wne pm3.26
    jctild impbid2 cA cr wcel cA cc0 wne wa cc0 cA cle wbr cc0 cA cneg clt wbr
    wn cA cneg cr wcel wn cA cr wcel cc0 cA cle wbr cc0 cA cneg clt wbr wn wb
    cA cc0 wne cA cr wcel cc0 cA cle wbr cA cc0 clt wbr wn cc0 cA cneg clt wbr
    wn cc0 cr wcel cA cr wcel cc0 cA cle wbr cA cc0 clt wbr wn wb 0re cc0 cA
    lenlt mpan cA cr wcel cA cc0 clt wbr cc0 cA cneg clt wbr cA lt0neg1 notbid
    bitrd adantr orbi2d bitrd cA cneg cr wcel cc0 cA cneg clt wbr ianor syl6bbr
    cA elrp cA cneg crp wcel cA cneg cr wcel cc0 cA cneg clt wbr wa cA cneg
    elrp notbii 3bitr4g $.
    $( [20-Nov-2008] $) $( [7-Nov-2008] $)

  $( Zero is not a positive real.  Axiom 9 of [Apostol] p. 20. $)
  0nrp $p |- -. 0 e. RR+ $=
    cc0 crp wcel cc0 cc0 clt wbr cc0 0re ltnri cc0 crp wcel cc0 cr wcel cc0 cc0
    clt wbr cc0 elrp pm3.27bi mto $.
    $( [27-Oct-2007] $) $( [27-Oct-2007] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Completeness Axiom and Suprema
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z v S $.  $d w y A $.
    $( If a set of reals contains a lower bound, it contains a unique lower
       bound. $)
    lbreu $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                E! x e. S A. y e. S x <_ y ) $=
      cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv cle
      wbr vy cS wral vx cS wrex vx cv vy cv cle wbr vy cS wral vw cv vy cv cle
      wbr vy cS wral wa vx cv vw cv wceq wi vw cS wral vx cS wral wa vx cv vy
      cv cle wbr vy cS wral vx cS wreu vx cv vy cv cle wbr vy cS wral vx cS
      wrex cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex vx cv vy cv cle
      wbr vy cS wral vw cv vy cv cle wbr vy cS wral wa vx cv vw cv wceq wi vw
      cS wral vx cS wral wa cS cr wss vx cv vy cv cle wbr vy cS wral vw cv vy
      cv cle wbr vy cS wral wa vx cv vw cv wceq wi vw cS wral vx cS wral vx cv
      vy cv cle wbr vy cS wral vx cS wrex cS cr wss vx cv vy cv cle wbr vy cS
      wral vw cv vy cv cle wbr vy cS wral wa vx cv vw cv wceq wi vx vw cS cS vx
      cv cS wcel vw cv cS wcel wa vx cv vy cv cle wbr vy cS wral vw cv vy cv
      cle wbr vy cS wral wa cS cr wss vx cv vw cv wceq vx cv cS wcel vw cv cS
      wcel wa vx cv vy cv cle wbr vy cS wral vw cv vy cv cle wbr vy cS wral wa
      vx cv vw cv cle wbr vw cv vx cv cle wbr wa cS cr wss vx cv vw cv wceq wi
      vw cv cS wcel vx cv vy cv cle wbr vy cS wral vx cv vw cv cle wbr vx cv cS
      wcel vw cv vy cv cle wbr vy cS wral vw cv vx cv cle wbr vx cv vy cv cle
      wbr vx cv vw cv cle wbr vy vw cv cS vy cv vw cv vx cv cle breq2 rcla4v vw
      cv vy cv cle wbr vw cv vx cv cle wbr vy vx cv cS vy cv vx cv vw cv cle
      breq2 rcla4v im2anan9r vx cv cS wcel vw cv cS wcel wa cS cr wss vx cv vw
      cv cle wbr vw cv vx cv cle wbr wa vx cv vw cv wceq vx cv cS wcel vw cv cS
      wcel wa cS cr wss vx cv vw cv cle wbr vw cv vx cv cle wbr wa vx cv vw cv
      wceq wi vx cv cS wcel vw cv cS wcel wa cS cr wss wa vx cv vw cv wceq vx
      cv vw cv cle wbr vw cv vx cv cle wbr wa vx cv cS wcel vw cv cS wcel wa cS
      cr wss wa vx cv cr wcel vw cv cr wcel wa vx cv vw cv wceq vx cv vw cv cle
      wbr vw cv vx cv cle wbr wa wb cS cr wss vx cv cS wcel vw cv cS wcel wa vx
      cv cr wcel vw cv cr wcel wa cS cr wss vx cv cS wcel vx cv cr wcel vw cv
      cS wcel vw cv cr wcel cS cr vx cv ssel cS cr vw cv ssel anim12d impcom vx
      cv vw cv letri3 syl biimprd ex com23 syld com3r r19.21aivv anim2i ancoms
      vx cv vy cv cle wbr vy cS wral vw cv vy cv cle wbr vy cS wral vx vw cS vx
      cv vw cv wceq vx cv vy cv cle wbr vw cv vy cv cle wbr vy cS vx cv vw cv
      vy cv cle breq1 ralbidv reu4 sylibr $.
      $( [11-Oct-2005] $) $( [9-Oct-2005] $)

    $( If a set of reals contains a lower bound, it contains a unique lower
       bound that belongs to the set. $)
    lbcl $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                U. { x e. S | A. y e. S x <_ y } e. S ) $=
      cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv cle
      wbr vy cS wral vx cS wreu vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      vx cv vy cv cle wbr vy cS wral vx cS crab wcel vx cv vy cv cle wbr vy cS
      wral vx cS crab cuni cS wcel vx vy cS lbreu vx cv vy cv cle wbr vy cS
      wral vx cS reucl2 vx cv vy cv cle wbr vy cS wral vx cS crab cS vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni vx cv vy cv cle wbr vy cS wral vx
      cS ssrab2 sseli 3syl $.
      $( [12-Oct-2005] $) $( [9-Oct-2005] $)

    $( If a set of reals contains a lower bound, the lower bound is less than
       or equal to all members of the set. $)
    lble $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y /\ A e. S ) ->
                U. { x e. S | A. y e. S x <_ y } <_ A ) $=
      cA cS wcel cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni cA cle wbr cA cS wcel cS cr wss vx
      cv vy cv cle wbr vy cS wral vx cS wrex vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni cA cle wbr cA cS wcel vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vy cv cle wbr vy cS wral vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cA cle wbr cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex
      wa cA cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni vy cv cle
      wbr vy cS wral vx cv vy cv cle wbr vy cS wral vx cS crab cuni cA cle wbr
      vx cv vy cv cle wbr vy cS wral vx cS crab cuni vy cv cle wbr vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni cA cle wbr vy cA cS vy vw vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni cA cle vy vw vx cv vy cv cle wbr vy cS
      wral vx cS crab vx cv vy cv cle wbr vy cS wral vy vx vw cS vx cv vy cv
      cle wbr vy cS hbra1 vw cv cS wcel vy ax-17 hbrab hbuni vw cv cle wcel vy
      ax-17 vw cv cA wcel vy ax-17 hbbr vy cv cA vx cv vy cv cle wbr vy cS wral
      vx cS crab cuni cle breq2 rcla4 imp cS cr wss vx cv vy cv cle wbr vy cS
      wral vx cS wrex wa vw cv vy cv cle wbr vy cS wral vw cS wreu vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vy cv cle wbr vy cS wral cS cr wss vx
      cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv cle wbr vy cS wral
      vx cS wreu vw cv vy cv cle wbr vy cS wral vw cS wreu vx vy cS lbreu vx cv
      vy cv cle wbr vy cS wral vw cv vy cv cle wbr vy cS wral vx vw cS vx cv vw
      cv wceq vx cv vy cv cle wbr vw cv vy cv cle wbr vy cS vx cv vw cv vy cv
      cle breq1 ralbidv cbvreuv sylib vw cv vy cv cle wbr vy cS wral vx cv vy
      cv cle wbr vy cS wral vx cv vy cv cle wbr vy cS wral vx cS crab cuni vy
      cv cle wbr vy cS wral vw vx cS vw cv vx cv wceq vw cv vy cv cle wbr vx cv
      vy cv cle wbr vy cS vw cv vx cv vy cv cle breq1 ralbidv vw cv vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni wceq vw cv vy cv cle wbr vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vy cv cle wbr vy cS vy vw vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vy vw vx cv vy cv cle wbr vy cS wral
      vx cS crab vx cv vy cv cle wbr vy cS wral vy vx vw cS vx cv vy cv cle wbr
      vy cS hbra1 vw cv cS wcel vy ax-17 hbrab hbuni hbeleq vw cv vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vy cv cle breq1 ralbid reuuni3 syl
      sylan2 3impb 3coml $.
      $( [12-Oct-2005] $) $( [9-Oct-2005] $)

    $( If a set of reals contains a lower bound, the lower bound is its
       infimum. $)
    lbinfm $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                 sup ( S , RR , `' < ) = U. { x e. S | A. y e. S x <_ y } ) $=
      cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vv cv vz cv clt
      ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz cv vw cv clt ccnv wbr
      vw cS wrex wi vz cr wral wa vv cr crab cuni vx cv vy cv cle wbr vy cS
      wral vx cS crab cuni cS cr clt ccnv csup cS cr wss vx cv vy cv cle wbr vy
      cS wral vx cS wrex wa vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz
      cv clt ccnv wbr wn vz cS wral vz cv vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr wral
      wa vv cv vz cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz cv
      vw cv clt ccnv wbr vw cS wrex wi vz cr wral wa vv cr crab cuni vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni wceq cS cr wss vx cv vy cv cle wbr
      vy cS wral vx cS wrex wa vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      vz cv clt ccnv wbr wn vz cS wral vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr
      wral cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cS cS cr wss
      vx cv vy cv cle wbr vy cS wral vx cS wrex wa vz cv cS wcel wa vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cv vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni clt wbr wn cS cr wss vx cv vy cv
      cle wbr vy cS wral vx cS wrex wa vz cv cS wcel wa vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni vz cv cle wbr vz cv vx cv vy cv cle wbr vy cS
      wral vx cS crab cuni clt wbr wn cS cr wss vx cv vy cv cle wbr vy cS wral
      vx cS wrex vz cv cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      vz cv cle wbr vx vy vz cv cS lble 3expa vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni cr wcel vz cv cr wcel vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv cle wbr vz cv vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni clt wbr wn wb cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa
      vz cv cS wcel wa vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv
      lenlt cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni cr wcel vz cv cS wcel cS cr wss vx cv
      vy cv cle wbr vy cS wral vx cS wrex vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni cr wcel
      vx vy cS lbcl cS cr vx cv vy cv cle wbr vy cS wral vx cS crab cuni ssel2
      syldan adantr cS cr wss vz cv cS wcel vz cv cr wcel vx cv vy cv cle wbr
      vy cS wral vx cS wrex cS cr vz cv ssel2 adantlr sylanc mpbid cS cr wss vx
      cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cv
      vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt wbr wn wb vx cv vy cv
      cle wbr vy cS wral vx cS wrex vz cv cS wcel cS cr wss vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni vz cv clt ccnv wbr vz cv vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni clt wbr cS cr wss vx cv vy cv cle wbr vy cS
      wral vx cS crab cvv wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      cvv wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv
      wbr vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt wbr wb cS cr
      wss cS cvv wcel vx cv vy cv cle wbr vy cS wral vx cS crab cvv wcel cS cr
      reex ssex vx cv vy cv cle wbr vy cS wral vx cS cvv rabexg syl vx cv vy cv
      cle wbr vy cS wral vx cS crab cvv uniexg vx cv vy cv cle wbr vy cS wral
      vx cS crab cuni cvv wcel vz cv cvv wcel vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni vz cv clt ccnv wbr vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt wbr wb vz visset vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv cvv cvv clt brcnvg mpan2 3syl notbid ad2antrr mpbird
      r19.21aiva cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vz cv
      vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt ccnv wbr vz cv vw cv
      clt ccnv wbr vw cS wrex wi vz cr cS cr wss vx cv vy cv cle wbr vy cS wral
      vx cS wrex wa vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt
      ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cv cr wcel cS cr wss
      vx cv vy cv cle wbr vy cS wral vx cS wrex wa vz cv vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni clt ccnv wbr vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cS wcel vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      clt ccnv wbr wa vz cv vw cv clt ccnv wbr vw cS wrex cS cr wss vx cv vy cv
      cle wbr vy cS wral vx cS wrex wa vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt ccnv wbr vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      cS wcel cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni cS wcel vz cv vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni clt ccnv wbr vx vy cS lbcl a1d ancrd vz cv vw
      cv clt ccnv wbr vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt
      ccnv wbr vw vx cv vy cv cle wbr vy cS wral vx cS crab cuni cS vw cv vx cv
      vy cv cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv breq2 rcla4ev
      syl6 a1d r19.21aiv jca vx cv vy cv cle wbr vy cS wral vx cS crab cuni cr
      wcel vv cv vz cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz
      cv vw cv clt ccnv wbr vw cS wrex wi vz cr wral wa vv cr wreu vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cS wral vz cv
      vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt ccnv wbr vz cv vw cv
      clt ccnv wbr vw cS wrex wi vz cr wral wa vv cv vz cv clt ccnv wbr wn vz
      cS wral vz cv vv cv clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi
      vz cr wral wa vv cr crab cuni vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni wceq wb cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vv cv
      vz cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz cv vw cv clt
      ccnv wbr vw cS wrex wi vz cr wral wa vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv wbr wn vz cS wral vz cv vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex
      wi vz cr wral wa vv cr vx cv vy cv cle wbr vy cS wral vx cS crab cuni vv
      cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni wceq vv cv vz cv clt
      ccnv wbr wn vz cS wral vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz
      cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz cv vw cv clt
      ccnv wbr vw cS wrex wi vz cr wral vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr
      wral vv cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni wceq vv cv vz
      cv clt ccnv wbr wn vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv
      clt ccnv wbr wn vz cS vv cv vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni wceq vv cv vz cv clt ccnv wbr vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv wbr vv cv vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv breq1 notbid ralbidv vv cv vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni wceq vz cv vv cv clt ccnv wbr vz cv vw cv clt
      ccnv wbr vw cS wrex wi vz cv vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr vv cv vx
      cv vy cv cle wbr vy cS wral vx cS crab cuni wceq vz cv vv cv clt ccnv wbr
      vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt ccnv wbr vz cv
      vw cv clt ccnv wbr vw cS wrex vv cv vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv breq2 imbi1d ralbidv anbi12d reuuni2 cS cr wss
      vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv cle wbr vy cS
      wral vx cS crab cuni cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni cr wcel vx vy cS lbcl cS cr wss vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni cr wcel
      wi vx cv vy cv cle wbr vy cS wral vx cS wrex cS cr vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni ssel adantr mpd cS cr wss vx cv vy cv cle wbr vy
      cS wral vx cS wrex wa vv cv vz cv clt ccnv wbr wn vz cS wral vz cv vv cv
      clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr wral wa vv cr
      wrex vv cv vz cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz
      cv vw cv clt ccnv wbr vw cS wrex wi vz cr wral wa vv cr wreu vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni cr wcel vx cv vy cv cle wbr vy cS wral
      vx cS crab cuni vz cv clt ccnv wbr wn vz cS wral vz cv vx cv vy cv cle
      wbr vy cS wral vx cS crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw
      cS wrex wi vz cr wral wa vv cv vz cv clt ccnv wbr wn vz cS wral vz cv vv
      cv clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr wral wa vv
      cr wrex cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vv cv vz
      cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz cv vw cv clt
      ccnv wbr vw cS wrex wi vz cr wral wa vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv wbr wn vz cS wral vz cv vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex
      wi vz cr wral wa vv vx cv vy cv cle wbr vy cS wral vx cS crab cuni cr vv
      cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni wceq vv cv vz cv clt
      ccnv wbr wn vz cS wral vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz
      cv clt ccnv wbr wn vz cS wral vz cv vv cv clt ccnv wbr vz cv vw cv clt
      ccnv wbr vw cS wrex wi vz cr wral vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr
      wral vv cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni wceq vv cv vz
      cv clt ccnv wbr wn vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv
      clt ccnv wbr wn vz cS vv cv vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni wceq vv cv vz cv clt ccnv wbr vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv wbr vv cv vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv breq1 notbid ralbidv vv cv vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni wceq vz cv vv cv clt ccnv wbr vz cv vw cv clt
      ccnv wbr vw cS wrex wi vz cv vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr vv cv vx
      cv vy cv cle wbr vy cS wral vx cS crab cuni wceq vz cv vv cv clt ccnv wbr
      vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt ccnv wbr vz cv
      vw cv clt ccnv wbr vw cS wrex vv cv vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv clt ccnv breq2 imbi1d ralbidv anbi12d rcla4ev cS cr wss
      vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv cle wbr vy cS
      wral vx cS crab cuni cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni cr wcel vx vy cS lbcl cS cr wss vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni cr wcel
      wi vx cv vy cv cle wbr vy cS wral vx cS wrex cS cr vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni ssel adantr mpd cS cr wss vx cv vy cv cle wbr vy
      cS wral vx cS wrex wa vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz
      cv clt ccnv wbr wn vz cS wral vz cv vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni clt ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cr wral
      cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv cle
      wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cS cS cr wss vx
      cv vy cv cle wbr vy cS wral vx cS wrex wa vz cv cS wcel wa vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cv vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni clt wbr wn cS cr wss vx cv vy cv
      cle wbr vy cS wral vx cS wrex wa vz cv cS wcel wa vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni vz cv cle wbr vz cv vx cv vy cv cle wbr vy cS
      wral vx cS crab cuni clt wbr wn cS cr wss vx cv vy cv cle wbr vy cS wral
      vx cS wrex vz cv cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      vz cv cle wbr vx vy vz cv cS lble 3expa vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni cr wcel vz cv cr wcel vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv cle wbr vz cv vx cv vy cv cle wbr vy cS wral vx cS crab
      cuni clt wbr wn wb cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa
      vz cv cS wcel wa vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv
      lenlt cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy cv
      cle wbr vy cS wral vx cS crab cuni cr wcel vz cv cS wcel cS cr wss vx cv
      vy cv cle wbr vy cS wral vx cS wrex vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cS wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni cr wcel
      vx vy cS lbcl cS cr vx cv vy cv cle wbr vy cS wral vx cS crab cuni ssel2
      syldan adantr cS cr wss vz cv cS wcel vz cv cr wcel vx cv vy cv cle wbr
      vy cS wral vx cS wrex cS cr vz cv ssel2 adantlr sylanc mpbid cS cr wss vx
      cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv wbr wn vz cv
      vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt wbr wn wb vx cv vy cv
      cle wbr vy cS wral vx cS wrex vz cv cS wcel cS cr wss vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni vz cv clt ccnv wbr vz cv vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni clt wbr cS cr wss vx cv vy cv cle wbr vy cS
      wral vx cS crab cvv wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      cvv wcel vx cv vy cv cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv
      wbr vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt wbr wb cS cr
      wss cS cvv wcel vx cv vy cv cle wbr vy cS wral vx cS crab cvv wcel cS cr
      reex ssex vx cv vy cv cle wbr vy cS wral vx cS cvv rabexg syl vx cv vy cv
      cle wbr vy cS wral vx cS crab cvv uniexg vx cv vy cv cle wbr vy cS wral
      vx cS crab cuni cvv wcel vz cv cvv wcel vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni vz cv clt ccnv wbr vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt wbr wb vz visset vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni vz cv cvv cvv clt brcnvg mpan2 3syl notbid ad2antrr mpbird
      r19.21aiva cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vz cv
      vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt ccnv wbr vz cv vw cv
      clt ccnv wbr vw cS wrex wi vz cr cS cr wss vx cv vy cv cle wbr vy cS wral
      vx cS wrex wa vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt
      ccnv wbr vz cv vw cv clt ccnv wbr vw cS wrex wi vz cv cr wcel cS cr wss
      vx cv vy cv cle wbr vy cS wral vx cS wrex wa vz cv vx cv vy cv cle wbr vy
      cS wral vx cS crab cuni clt ccnv wbr vx cv vy cv cle wbr vy cS wral vx cS
      crab cuni cS wcel vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      clt ccnv wbr wa vz cv vw cv clt ccnv wbr vw cS wrex cS cr wss vx cv vy cv
      cle wbr vy cS wral vx cS wrex wa vz cv vx cv vy cv cle wbr vy cS wral vx
      cS crab cuni clt ccnv wbr vx cv vy cv cle wbr vy cS wral vx cS crab cuni
      cS wcel cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa vx cv vy
      cv cle wbr vy cS wral vx cS crab cuni cS wcel vz cv vx cv vy cv cle wbr
      vy cS wral vx cS crab cuni clt ccnv wbr vx vy cS lbcl a1d ancrd vz cv vw
      cv clt ccnv wbr vz cv vx cv vy cv cle wbr vy cS wral vx cS crab cuni clt
      ccnv wbr vw vx cv vy cv cle wbr vy cS wral vx cS crab cuni cS vw cv vx cv
      vy cv cle wbr vy cS wral vx cS crab cuni vz cv clt ccnv breq2 rcla4ev
      syl6 a1d r19.21aiv jca sylanc vv vz vw cr cS clt ccnv cr clt wor cr clt
      ccnv wor ltso cr clt cnvso mpbi supeu syl sylanc mpbid vv vz vw cr cS clt
      ccnv df-sup syl5eq $.
      $( [12-Oct-2005] $) $( [9-Oct-2005] $)

    $( If a set of reals contains a lower bound, it contains its infimum. $)
    lbinfmcl $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                 sup ( S , RR , `' < ) e. S ) $=
      cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex wa cS cr clt ccnv
      csup vx cv vy cv cle wbr vy cS wral vx cS crab cuni cS vx vy cS lbinfm vx
      vy cS lbcl eqeltrd $.
      $( [20-Oct-2005] $) $( [11-Oct-2005] $)

    $( If a set of reals contains a lower bound, its infmimum is less than
       or equal to all members of the set. $)
    lbinfmle $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y /\ A e. S ) ->
                sup ( S , RR , `' < ) <_ A ) $=
      cS cr wss vx cv vy cv cle wbr vy cS wral vx cS wrex cA cS wcel w3a cS cr
      clt ccnv csup vx cv vy cv cle wbr vy cS wral vx cS crab cuni cA cle cS cr
      wss vx cv vy cv cle wbr vy cS wral vx cS wrex cS cr clt ccnv csup vx cv
      vy cv cle wbr vy cS wral vx cS crab cuni wceq cA cS wcel vx vy cS lbinfm
      3adant3 vx vy cA cS lble eqbrtrd $.
      $( [25-Oct-2005] $) $( [11-Oct-2005] $)
  $}

  ${
    $d x y z w v u t A $.
    $( A non-empty, bounded-above set of reals has a supremum.  Stronger
       version of completeness axiom (it has a slightly weaker antecedent). $)
    sup2 $p |- ( ( A C_ RR /\ A =/= (/) /\
                  E. x e. RR A. y e. A ( y < x \/ y = x ) ) ->
               E. x e. RR ( A. y e. A -. x < y /\
                  A. y e. RR ( y < x -> E. z e. A y < z ) ) ) $=
      cA cr wss cA c0 wne vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx
      cr wrex w3a cA cr wss cA c0 wne vy cv vx cv clt wbr vy cA wral vx cr wrex
      w3a vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA wrex wi vy cr wral wa vx cr wrex cA cr wss cA c0 wne wa vy cv
      vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex wa cA cr wss cA
      c0 wne wa vy cv vx cv clt wbr vy cA wral vx cr wrex wa cA cr wss cA c0
      wne vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex w3a cA
      cr wss cA c0 wne vy cv vx cv clt wbr vy cA wral vx cr wrex w3a cA cr wss
      cA c0 wne wa vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr
      wrex vy cv vx cv clt wbr vy cA wral vx cr wrex cA cr wss vy cv vx cv clt
      wbr vy cv vx cv wceq wo vy cA wral vx cr wrex vy cv vx cv clt wbr vy cA
      wral vx cr wrex wi cA c0 wne cA cr wss vx cv cr wcel vy cv vx cv clt wbr
      vy cv vx cv wceq wo vy cA wral wa vx wex vx cv cr wcel vy cv vx cv clt
      wbr vy cA wral wa vx wex vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA
      wral vx cr wrex vy cv vx cv clt wbr vy cA wral vx cr wrex cA cr wss vx cv
      cr wcel vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral wa vx wex vz
      cv cr wcel vy cv vz cv clt wbr vy cA wral wa vz wex vx cv cr wcel vy cv
      vx cv clt wbr vy cA wral wa vx wex cA cr wss vx cv cr wcel vy cv vx cv
      clt wbr vy cv vx cv wceq wo vy cA wral wa vz cv cr wcel vy cv vz cv clt
      wbr vy cA wral wa vz wex vx cA cr wss vx cv cr wcel vy cv vx cv clt wbr
      vy cv vx cv wceq wo vy cA wral wa vx cv c1 caddc co cr wcel vy cv vx cv
      c1 caddc co clt wbr vy cA wral wa vz cv cr wcel vy cv vz cv clt wbr vy cA
      wral wa vz wex cA cr wss vx cv cr wcel vy cv vx cv clt wbr vy cv vx cv
      wceq wo vy cA wral wa vx cv c1 caddc co cr wcel vy cv vx cv c1 caddc co
      clt wbr vy cA wral vx cv cr wcel vy cv vx cv clt wbr vy cv vx cv wceq wo
      vy cA wral wa vx cv c1 caddc co cr wcel wi cA cr wss vx cv cr wcel vx cv
      c1 caddc co cr wcel vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx
      cv peano2re adantr a1i cA cr wss vx cv cr wcel vy cv vx cv clt wbr vy cv
      vx cv wceq wo vy cA wral vy cv vx cv c1 caddc co clt wbr vy cA wral cA cr
      wss vx cv cr wcel wa vy cv cA wcel vy cv vx cv clt wbr vy cv vx cv wceq
      wo wi vy wal vy cv cA wcel vy cv vx cv c1 caddc co clt wbr wi vy wal vy
      cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vy cv vx cv c1 caddc co
      clt wbr vy cA wral cA cr wss vx cv cr wcel wa vy cv cA wcel vy cv vx cv
      clt wbr vy cv vx cv wceq wo wi vy cv cA wcel vy cv vx cv c1 caddc co clt
      wbr wi vy cA cr wss vx cv cr wcel wa vy cv cA wcel vy cv vx cv clt wbr vy
      cv vx cv wceq wo vy cv vx cv c1 caddc co clt wbr cA cr wss vx cv cr wcel
      vy cv cA wcel vy cv vx cv clt wbr vy cv vx cv wceq wo vy cv vx cv c1
      caddc co clt wbr wi wi cA cr wss vy cv cA wcel vx cv cr wcel vy cv vx cv
      clt wbr vy cv vx cv wceq wo vy cv vx cv c1 caddc co clt wbr wi cA cr wss
      vy cv cA wcel vy cv cr wcel vx cv cr wcel vy cv vx cv clt wbr vy cv vx cv
      wceq wo vy cv vx cv c1 caddc co clt wbr wi wi cA cr vy cv ssel vy cv cr
      wcel vx cv cr wcel vy cv vx cv clt wbr vy cv vx cv wceq wo vy cv vx cv c1
      caddc co clt wbr wi vy cv cr wcel vx cv cr wcel wa vy cv vx cv clt wbr vy
      cv vx cv c1 caddc co clt wbr vy cv vx cv wceq vy cv cr wcel vx cv cr wcel
      vy cv vx cv clt wbr vy cv vx cv c1 caddc co clt wbr wi vy cv cr wcel vx
      cv cr wcel vy cv vx cv clt wbr vy cv vx cv c1 caddc co clt wbr wi vy cv
      cr wcel vx cv cr wcel vy cv vx cv clt wbr vx cv cr wcel vy cv vx cv c1
      caddc co clt wbr vy cv cr wcel vx cv cr wcel vy cv vx cv clt wbr vx cv cr
      wcel vy cv vx cv c1 caddc co clt wbr vy cv cr wcel vx cv cr wcel wa vy cv
      vx cv clt wbr vx cv vx cv c1 caddc co clt wbr vy cv vx cv c1 caddc co clt
      wbr vx cv cr wcel vy cv cr wcel vx cv cr wcel vx cv c1 caddc co cr wcel
      wa vy cv vx cv clt wbr vx cv vx cv c1 caddc co clt wbr wa vy cv vx cv c1
      caddc co clt wbr wi vx cv cr wcel vy cv cr wcel vx cv cr wcel vx cv c1
      caddc co cr wcel vy cv vx cv clt wbr vx cv vx cv c1 caddc co clt wbr wa
      vy cv vx cv c1 caddc co clt wbr wi vy cv vx cv vx cv c1 caddc co axlttrn
      3expb vx cv cr wcel vx cv c1 caddc co cr wcel vx cv peano2re ancli sylan2
      vx cv ltp1 sylan2i exp4b com34 pm2.43d imp vx cv cr wcel vy cv vx cv wceq
      vy cv vx cv c1 caddc co clt wbr wi vy cv cr wcel vy cv vx cv wceq vy cv
      vx cv c1 caddc co clt wbr vx cv vx cv c1 caddc co clt wbr vx cv cr wcel
      vy cv vx cv vx cv c1 caddc co clt breq1 vx cv ltp1 syl5cbir adantl jaod
      ex syl6 com23 imp a2d 19.20dv vy cv vx cv clt wbr vy cv vx cv wceq wo vy
      cA df-ral vy cv vx cv c1 caddc co clt wbr vy cA df-ral 3imtr4g expimpd
      jcad vz cv cr wcel vy cv vz cv clt wbr vy cA wral wa vx cv c1 caddc co cr
      wcel vy cv vx cv c1 caddc co clt wbr vy cA wral wa vz vx cv c1 caddc co
      vx cv c1 caddc oprex vz cv vx cv c1 caddc co wceq vz cv cr wcel vx cv c1
      caddc co cr wcel vy cv vz cv clt wbr vy cA wral vy cv vx cv c1 caddc co
      clt wbr vy cA wral vz cv vx cv c1 caddc co cr eleq1 vz cv vx cv c1 caddc
      co wceq vy cv vz cv clt wbr vy cv vx cv c1 caddc co clt wbr vy cA vz cv
      vx cv c1 caddc co vy cv clt breq2 ralbidv anbi12d cla4ev syl6 19.23adv vz
      cv cr wcel vy cv vz cv clt wbr vy cA wral wa vx cv cr wcel vy cv vx cv
      clt wbr vy cA wral wa vz vx vz cv vx cv wceq vz cv cr wcel vx cv cr wcel
      vy cv vz cv clt wbr vy cA wral vy cv vx cv clt wbr vy cA wral vz cv vx cv
      cr eleq1 vz cv vx cv wceq vy cv vz cv clt wbr vy cv vx cv clt wbr vy cA
      vz cv vx cv vy cv clt breq2 ralbidv anbi12d cbvexv syl6ib vy cv vx cv clt
      wbr vy cv vx cv wceq wo vy cA wral vx cr df-rex vy cv vx cv clt wbr vy cA
      wral vx cr df-rex 3imtr4g adantr imdistani cA cr wss cA c0 wne vy cv vx
      cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex df-3an cA cr wss cA
      c0 wne vy cv vx cv clt wbr vy cA wral vx cr wrex df-3an 3imtr4i vx vy vz
      cA axsup syl $.
      $( [19-Jan-1997] $)

    $( A version of the completeness axiom for reals. $)
    sup3 $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                  E. x e. RR ( A. y e. A -. x < y /\
                  A. y e. RR ( y < x -> E. z e. A y < z ) ) ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cA cr
      wss cA c0 wne vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr
      wrex w3a vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cr wral wa vx cr wrex cA cr wss cA c0 wne vy
      cv vx cv cle wbr vy cA wral vx cr wrex wa wa cA cr wss cA c0 wne vy cv vx
      cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex wa wa cA cr wss cA
      c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cA cr wss cA c0 wne
      vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex w3a cA cr
      wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex wa cA c0 wne vy
      cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex wa cA cr wss
      vy cv vx cv cle wbr vy cA wral vx cr wrex vy cv vx cv clt wbr vy cv vx cv
      wceq wo vy cA wral vx cr wrex cA c0 wne cA cr wss vy cv vx cv cle wbr vy
      cA wral vy cv vx cv clt wbr vy cv vx cv wceq wo vy cA wral vx cr cA cr
      wss vx cv cr wcel wa vy cv vx cv cle wbr vy cv vx cv clt wbr vy cv vx cv
      wceq wo vy cA cA cr wss vx cv cr wcel vy cv cA wcel vy cv vx cv cle wbr
      vy cv vx cv clt wbr vy cv vx cv wceq wo wb cA cr wss vy cv cA wcel vy cv
      cr wcel vx cv cr wcel vy cv vx cv cle wbr vy cv vx cv clt wbr vy cv vx cv
      wceq wo wb cA cr vy cv ssel vy cv cr wcel vx cv cr wcel vy cv vx cv cle
      wbr vy cv vx cv clt wbr vy cv vx cv wceq wo wb vy cv vx cv leloe expcom
      syl9 imp31 ralbidva rexbidva anbi2d pm5.32i cA cr wss cA c0 wne vy cv vx
      cv cle wbr vy cA wral vx cr wrex 3anass cA cr wss cA c0 wne vy cv vx cv
      clt wbr vy cv vx cv wceq wo vy cA wral vx cr wrex 3anass 3bitr4i vx vy vz
      cA sup2 sylbi $.
      $( [11-May-2007] $) $( [12-Oct-2004] $)

    $( Lemma for ~ infm3 . $)
    infm3lem $p |- ( x e. RR -> E. y e. RR x = -u y ) $=
      vx cv cneg cr wcel vx cv vx cv cneg cneg wceq vx cv vy cv cneg wceq vy cr
      wrex vx cv cr wcel vx cv vy cv cneg wceq vx cv vx cv cneg cneg wceq vy vx
      cv cneg cr vy cv vx cv cneg wceq vy cv cneg vx cv cneg cneg vx cv vy cv
      vx cv cneg negeq eqeq2d rcla4ev vx cv renegcl vx cv cr wcel vx cv cneg
      cneg vx cv vx cv cr wcel vx cv cc wcel vx cv cneg cneg vx cv wceq vx cv
      recn vx cv negneg syl eqcomd sylanc $.
      $( [29-Jun-2005] $) $( [14-Jun-2005] $)

    $( The completeness axiom for reals in terms of infimum:  a non-empty,
       bounded-below set of reals has a infimum.  (This theorem is the dual of
       ~ sup3 .) $)
    infm3 $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                  E. x e. RR ( A. y e. A -. y < x /\
                  A. y e. RR ( x < y -> E. z e. A z < y ) ) ) $=
      cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex vy cv vx cv
      clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex
      wi vy cr wral wa vx cr wrex cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA
      wral vx cr wrex wa vu cv vv cv clt wbr wn vv vw cv cneg cA wcel vw cr
      crab wral vv cv vu cv clt wbr vv cv vt cv clt wbr vt vw cv cneg cA wcel
      vw cr crab wrex wi vv cr wral wa vu cr wrex vy cv vx cv clt wbr wn vy cA
      wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral wa
      vx cr wrex cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex
      wa vw cv cneg cA wcel vw cr crab c0 wne vv cv vu cv cle wbr vv vw cv cneg
      cA wcel vw cr crab wral vu cr wrex wa vu cv vv cv clt wbr wn vv vw cv
      cneg cA wcel vw cr crab wral vv cv vu cv clt wbr vv cv vt cv clt wbr vt
      vw cv cneg cA wcel vw cr crab wrex wi vv cr wral wa vu cr wrex cA cr wss
      cA c0 wne vw cv cneg cA wcel vw cr crab c0 wne vx cv vy cv cle wbr vy cA
      wral vx cr wrex vv cv vu cv cle wbr vv vw cv cneg cA wcel vw cr crab wral
      vu cr wrex cA cr wss vv cv cA wcel vv wex vw cv cneg cA wcel vw cr wrex
      cA c0 wne vw cv cneg cA wcel vw cr crab c0 wne cA cr wss vv cv cA wcel vv
      wex vv cv cr wcel vv cv cA wcel wa vv wex vw cv cneg cA wcel vw cr wrex
      cA cr wss vv cv cA wcel vv cv cr wcel vv cv cA wcel wa vv cA cr wss vv cv
      cA wcel vv cv cr wcel cA cr vv cv ssel pm4.71rd exbidv vv cv cr wcel vv
      cv cA wcel wa vv wex vv cv cA wcel vv cr wrex vw cv cneg cA wcel vw cr
      wrex vv cv cA wcel vv cr df-rex vv cv cA wcel vw cv cneg cA wcel vv vw vw
      cv cneg cr vw cv renegcl vv vw infm3lem vv cv vw cv cneg cA eleq1 rexxfr
      bitr3i syl6bb vv cA n0 vw cv cneg cA wcel vw cr rabn0 3bitr4g cA cr wss
      vx cv vy cv cle wbr vy cA wral vx cr wrex vv cv cneg cA wcel vx cv vv cv
      cneg cle wbr wi vv cr wral vx cr wrex vv cv vu cv cle wbr vv vw cv cneg
      cA wcel vw cr crab wral vu cr wrex cA cr wss vx cv vy cv cle wbr vy cA
      wral vv cv cneg cA wcel vx cv vv cv cneg cle wbr wi vv cr wral vx cr cA
      cr wss vy cv cA wcel vx cv vy cv cle wbr wi vy wal vy cv cr wcel vy cv cA
      wcel vx cv vy cv cle wbr wi wi vy wal vx cv vy cv cle wbr vy cA wral vv
      cv cneg cA wcel vx cv vv cv cneg cle wbr wi vv cr wral cA cr wss vy cv cA
      wcel vx cv vy cv cle wbr wi vy cv cr wcel vy cv cA wcel vx cv vy cv cle
      wbr wi wi vy cA cr wss vy cv cA wcel vx cv vy cv cle wbr wi vy cv cr wcel
      vy cv cA wcel wa vx cv vy cv cle wbr wi vy cv cr wcel vy cv cA wcel vx cv
      vy cv cle wbr wi wi cA cr wss vy cv cA wcel vy cv cr wcel vy cv cA wcel
      wa vx cv vy cv cle wbr cA cr wss vy cv cA wcel vy cv cr wcel cA cr vy cv
      ssel pm4.71rd imbi1d vy cv cr wcel vy cv cA wcel vx cv vy cv cle wbr
      impexp syl6bb albidv vx cv vy cv cle wbr vy cA df-ral vv cv cneg cA wcel
      vx cv vv cv cneg cle wbr wi vv cr wral vy cv cA wcel vx cv vy cv cle wbr
      wi vy cr wral vy cv cr wcel vy cv cA wcel vx cv vy cv cle wbr wi wi vy
      wal vy cv cA wcel vx cv vy cv cle wbr wi vv cv cneg cA wcel vx cv vv cv
      cneg cle wbr wi vy vv vv cv cneg cr vv cv renegcl vy vv infm3lem vy cv vv
      cv cneg wceq vy cv cA wcel vv cv cneg cA wcel vx cv vy cv cle wbr vx cv
      vv cv cneg cle wbr vy cv vv cv cneg cA eleq1 vy cv vv cv cneg vx cv cle
      breq2 imbi12d ralxfr vy cv cA wcel vx cv vy cv cle wbr wi vy cr df-ral
      bitr3i 3bitr4g rexbidv vv cv cneg cA wcel vx cv vv cv cneg cle wbr wi vv
      cr wral vx cr wrex vv cv cneg cA wcel vu cv cneg vv cv cneg cle wbr wi vv
      cr wral vu cr wrex vv cv vu cv cle wbr vv vw cv cneg cA wcel vw cr crab
      wral vu cr wrex vv cv cneg cA wcel vx cv vv cv cneg cle wbr wi vv cr wral
      vv cv cneg cA wcel vu cv cneg vv cv cneg cle wbr wi vv cr wral vx vu vu
      cv cneg cr vu cv renegcl vx vu infm3lem vx cv vu cv cneg wceq vv cv cneg
      cA wcel vx cv vv cv cneg cle wbr wi vv cv cneg cA wcel vu cv cneg vv cv
      cneg cle wbr wi vv cr vx cv vu cv cneg wceq vx cv vv cv cneg cle wbr vu
      cv cneg vv cv cneg cle wbr vv cv cneg cA wcel vx cv vu cv cneg vv cv cneg
      cle breq1 imbi2d ralbidv rexxfr vv cv vu cv cle wbr vv vw cv cneg cA wcel
      vw cr crab wral vv cv cneg cA wcel vu cv cneg vv cv cneg cle wbr wi vv cr
      wral vu cr vu cv cr wcel vv cv cneg cA wcel vv cv vu cv cle wbr wi vv cr
      wral vv cv cneg cA wcel vu cv cneg vv cv cneg cle wbr wi vv cr wral vv cv
      vu cv cle wbr vv vw cv cneg cA wcel vw cr crab wral vu cv cr wcel vv cv
      cneg cA wcel vv cv vu cv cle wbr wi vv cv cneg cA wcel vu cv cneg vv cv
      cneg cle wbr wi vv cr vu cv cr wcel vv cv cr wcel wa vv cv vu cv cle wbr
      vu cv cneg vv cv cneg cle wbr vv cv cneg cA wcel vv cv cr wcel vu cv cr
      wcel vv cv vu cv cle wbr vu cv cneg vv cv cneg cle wbr wb vv cv vu cv
      leneg ancoms imbi2d ralbidva vv cv vw cv cneg cA wcel vw cr crab wcel vv
      cv vu cv cle wbr wi vv wal vv cv cr wcel vv cv cneg cA wcel vv cv vu cv
      cle wbr wi wi vv wal vv cv vu cv cle wbr vv vw cv cneg cA wcel vw cr crab
      wral vv cv cneg cA wcel vv cv vu cv cle wbr wi vv cr wral vv cv vw cv
      cneg cA wcel vw cr crab wcel vv cv vu cv cle wbr wi vv cv cr wcel vv cv
      cneg cA wcel vv cv vu cv cle wbr wi wi vv vv cv vw cv cneg cA wcel vw cr
      crab wcel vv cv vu cv cle wbr wi vv cv cr wcel vv cv cneg cA wcel wa vv
      cv vu cv cle wbr wi vv cv cr wcel vv cv cneg cA wcel vv cv vu cv cle wbr
      wi wi vv cv vw cv cneg cA wcel vw cr crab wcel vv cv cr wcel vv cv cneg
      cA wcel wa vv cv vu cv cle wbr vw cv cneg cA wcel vv cv cneg cA wcel vw
      vv cv cr vw cv vv cv wceq vw cv cneg vv cv cneg cA vw cv vv cv negeq
      eleq1d elrab imbi1i vv cv cr wcel vv cv cneg cA wcel vv cv vu cv cle wbr
      impexp bitri albii vv cv vu cv cle wbr vv vw cv cneg cA wcel vw cr crab
      df-ral vv cv cneg cA wcel vv cv vu cv cle wbr wi vv cr df-ral 3bitr4ri
      syl5bbr rexbiia bitr4i syl6bb anbi12d vw cv cneg cA wcel vw cr crab cr
      wss vw cv cneg cA wcel vw cr crab c0 wne vv cv vu cv cle wbr vv vw cv
      cneg cA wcel vw cr crab wral vu cr wrex vu cv vv cv clt wbr wn vv vw cv
      cneg cA wcel vw cr crab wral vv cv vu cv clt wbr vv cv vt cv clt wbr vt
      vw cv cneg cA wcel vw cr crab wrex wi vv cr wral wa vu cr wrex vw cv cneg
      cA wcel vw cr ssrab2 vu vv vt vw cv cneg cA wcel vw cr crab sup3 mp3an1
      syl6bi cA cr wss vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz
      cv vy cv clt wbr vz cA wrex wi vy cr wral wa vx cr wrex vv cv cneg cA
      wcel vv cv cneg vx cv clt wbr wn wi vv cr wral vx cv vv cv cneg clt wbr
      vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex wi vv cr
      wral wa vx cr wrex vu cv vv cv clt wbr wn vv vw cv cneg cA wcel vw cr
      crab wral vv cv vu cv clt wbr vv cv vt cv clt wbr vt vw cv cneg cA wcel
      vw cr crab wrex wi vv cr wral wa vu cr wrex cA cr wss vy cv vx cv clt wbr
      wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr
      wral wa vv cv cneg cA wcel vv cv cneg vx cv clt wbr wn wi vv cr wral vx
      cv vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa
      vt cr wrex wi vv cr wral wa vx cr cA cr wss vy cv vx cv clt wbr wn vy cA
      wral vv cv cneg cA wcel vv cv cneg vx cv clt wbr wn wi vv cr wral vx cv
      vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral vx cv vv cv
      cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr
      wrex wi vv cr wral cA cr wss vy cv cA wcel vy cv vx cv clt wbr wn wi vy
      wal vy cv cr wcel vy cv cA wcel vy cv vx cv clt wbr wn wi wi vy wal vy cv
      vx cv clt wbr wn vy cA wral vv cv cneg cA wcel vv cv cneg vx cv clt wbr
      wn wi vv cr wral cA cr wss vy cv cA wcel vy cv vx cv clt wbr wn wi vy cv
      cr wcel vy cv cA wcel vy cv vx cv clt wbr wn wi wi vy cA cr wss vy cv cA
      wcel vy cv vx cv clt wbr wn wi vy cv cr wcel vy cv cA wcel wa vy cv vx cv
      clt wbr wn wi vy cv cr wcel vy cv cA wcel vy cv vx cv clt wbr wn wi wi cA
      cr wss vy cv cA wcel vy cv cr wcel vy cv cA wcel wa vy cv vx cv clt wbr
      wn cA cr wss vy cv cA wcel vy cv cr wcel cA cr vy cv ssel pm4.71rd imbi1d
      vy cv cr wcel vy cv cA wcel vy cv vx cv clt wbr wn impexp syl6bb albidv
      vy cv vx cv clt wbr wn vy cA df-ral vv cv cneg cA wcel vv cv cneg vx cv
      clt wbr wn wi vv cr wral vy cv cA wcel vy cv vx cv clt wbr wn wi vy cr
      wral vy cv cr wcel vy cv cA wcel vy cv vx cv clt wbr wn wi wi vy wal vy
      cv cA wcel vy cv vx cv clt wbr wn wi vv cv cneg cA wcel vv cv cneg vx cv
      clt wbr wn wi vy vv vv cv cneg cr vv cv renegcl vy vv infm3lem vy cv vv
      cv cneg wceq vy cv cA wcel vv cv cneg cA wcel vy cv vx cv clt wbr wn vv
      cv cneg vx cv clt wbr wn vy cv vv cv cneg cA eleq1 vy cv vv cv cneg wceq
      vy cv vx cv clt wbr vv cv cneg vx cv clt wbr vy cv vv cv cneg vx cv clt
      breq1 notbid imbi12d ralxfr vy cv cA wcel vy cv vx cv clt wbr wn wi vy cr
      df-ral bitr3i 3bitr4g cA cr wss vx cv vv cv cneg clt wbr vz cv vv cv cneg
      clt wbr vz cA wrex wi vv cr wral vx cv vv cv cneg clt wbr vt cv cneg cA
      wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex wi vv cr wral vx cv vy
      cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral cA cr wss vx cv
      vv cv cneg clt wbr vz cv vv cv cneg clt wbr vz cA wrex wi vx cv vv cv
      cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr
      wrex wi vv cr cA cr wss vz cv vv cv cneg clt wbr vz cA wrex vt cv cneg cA
      wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex vx cv vv cv cneg clt wbr
      cA cr wss vz cv cA wcel vz cv vv cv cneg clt wbr wa vz wex vz cv cr wcel
      vz cv cA wcel vz cv vv cv cneg clt wbr wa wa vz wex vz cv vv cv cneg clt
      wbr vz cA wrex vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr
      wrex cA cr wss vz cv cA wcel vz cv vv cv cneg clt wbr wa vz cv cr wcel vz
      cv cA wcel vz cv vv cv cneg clt wbr wa wa vz cA cr wss vz cv cA wcel vz
      cv vv cv cneg clt wbr wa vz cv cr wcel cA cr wss vz cv cA wcel vz cv cr
      wcel vz cv vv cv cneg clt wbr cA cr vz cv ssel adantrd pm4.71rd exbidv vz
      cv vv cv cneg clt wbr vz cA df-rex vt cv cneg cA wcel vt cv cneg vv cv
      cneg clt wbr wa vt cr wrex vz cv cA wcel vz cv vv cv cneg clt wbr wa vz
      cr wrex vz cv cr wcel vz cv cA wcel vz cv vv cv cneg clt wbr wa wa vz wex
      vz cv cA wcel vz cv vv cv cneg clt wbr wa vt cv cneg cA wcel vt cv cneg
      vv cv cneg clt wbr wa vz vt vt cv cneg cr vt cv renegcl vz vt infm3lem vz
      cv vt cv cneg wceq vz cv cA wcel vt cv cneg cA wcel vz cv vv cv cneg clt
      wbr vt cv cneg vv cv cneg clt wbr vz cv vt cv cneg cA eleq1 vz cv vt cv
      cneg vv cv cneg clt breq1 anbi12d rexxfr vz cv cA wcel vz cv vv cv cneg
      clt wbr wa vz cr df-rex bitr3i 3bitr4g imbi2d ralbidv vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi vx cv vv cv cneg clt wbr vz cv vv cv
      cneg clt wbr vz cA wrex wi vy vv vv cv cneg cr vv cv renegcl vy vv
      infm3lem vy cv vv cv cneg wceq vx cv vy cv clt wbr vx cv vv cv cneg clt
      wbr vz cv vy cv clt wbr vz cA wrex vz cv vv cv cneg clt wbr vz cA wrex vy
      cv vv cv cneg vx cv clt breq2 vy cv vv cv cneg wceq vz cv vy cv clt wbr
      vz cv vv cv cneg clt wbr vz cA vy cv vv cv cneg vz cv clt breq2 rexbidv
      imbi12d ralxfr syl5bb anbi12d rexbidv vv cv cneg cA wcel vv cv cneg vx cv
      clt wbr wn wi vv cr wral vx cv vv cv cneg clt wbr vt cv cneg cA wcel vt
      cv cneg vv cv cneg clt wbr wa vt cr wrex wi vv cr wral wa vx cr wrex vv
      cv cneg cA wcel vv cv cneg vu cv cneg clt wbr wn wi vv cr wral vu cv cneg
      vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt
      cr wrex wi vv cr wral wa vu cr wrex vu cv vv cv clt wbr wn vv vw cv cneg
      cA wcel vw cr crab wral vv cv vu cv clt wbr vv cv vt cv clt wbr vt vw cv
      cneg cA wcel vw cr crab wrex wi vv cr wral wa vu cr wrex vv cv cneg cA
      wcel vv cv cneg vx cv clt wbr wn wi vv cr wral vx cv vv cv cneg clt wbr
      vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex wi vv cr
      wral wa vv cv cneg cA wcel vv cv cneg vu cv cneg clt wbr wn wi vv cr wral
      vu cv cneg vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg
      clt wbr wa vt cr wrex wi vv cr wral wa vx vu vu cv cneg cr vu cv renegcl
      vx vu infm3lem vx cv vu cv cneg wceq vv cv cneg cA wcel vv cv cneg vx cv
      clt wbr wn wi vv cr wral vv cv cneg cA wcel vv cv cneg vu cv cneg clt wbr
      wn wi vv cr wral vx cv vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg
      vv cv cneg clt wbr wa vt cr wrex wi vv cr wral vu cv cneg vv cv cneg clt
      wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex wi vv
      cr wral vx cv vu cv cneg wceq vv cv cneg cA wcel vv cv cneg vx cv clt wbr
      wn wi vv cv cneg cA wcel vv cv cneg vu cv cneg clt wbr wn wi vv cr vx cv
      vu cv cneg wceq vv cv cneg vx cv clt wbr wn vv cv cneg vu cv cneg clt wbr
      wn vv cv cneg cA wcel vx cv vu cv cneg wceq vv cv cneg vx cv clt wbr vv
      cv cneg vu cv cneg clt wbr vx cv vu cv cneg vv cv cneg clt breq2 notbid
      imbi2d ralbidv vx cv vu cv cneg wceq vx cv vv cv cneg clt wbr vt cv cneg
      cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex wi vu cv cneg vv cv
      cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr
      wrex wi vv cr vx cv vu cv cneg wceq vx cv vv cv cneg clt wbr vu cv cneg
      vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt
      cr wrex vx cv vu cv cneg vv cv cneg clt breq1 imbi1d ralbidv anbi12d
      rexxfr vu cv vv cv clt wbr wn vv vw cv cneg cA wcel vw cr crab wral vv cv
      vu cv clt wbr vv cv vt cv clt wbr vt vw cv cneg cA wcel vw cr crab wrex
      wi vv cr wral wa vv cv cneg cA wcel vv cv cneg vu cv cneg clt wbr wn wi
      vv cr wral vu cv cneg vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vv
      cv cneg clt wbr wa vt cr wrex wi vv cr wral wa vu cr vu cv cr wcel vu cv
      vv cv clt wbr wn vv vw cv cneg cA wcel vw cr crab wral vv cv cneg cA wcel
      vv cv cneg vu cv cneg clt wbr wn wi vv cr wral vv cv vu cv clt wbr vv cv
      vt cv clt wbr vt vw cv cneg cA wcel vw cr crab wrex wi vv cr wral vu cv
      cneg vv cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr
      wa vt cr wrex wi vv cr wral vu cv cr wcel vv cv cneg cA wcel vu cv vv cv
      clt wbr wn wi vv cr wral vv cv cneg cA wcel vv cv cneg vu cv cneg clt wbr
      wn wi vv cr wral vu cv vv cv clt wbr wn vv vw cv cneg cA wcel vw cr crab
      wral vu cv cr wcel vv cv cneg cA wcel vu cv vv cv clt wbr wn wi vv cv
      cneg cA wcel vv cv cneg vu cv cneg clt wbr wn wi vv cr vu cv cr wcel vv
      cv cr wcel wa vu cv vv cv clt wbr wn vv cv cneg vu cv cneg clt wbr wn vv
      cv cneg cA wcel vu cv cr wcel vv cv cr wcel wa vu cv vv cv clt wbr vv cv
      cneg vu cv cneg clt wbr vu cv vv cv ltneg notbid imbi2d ralbidva vv cv vw
      cv cneg cA wcel vw cr crab wcel vu cv vv cv clt wbr wn wi vv wal vv cv cr
      wcel vv cv cneg cA wcel vu cv vv cv clt wbr wn wi wi vv wal vu cv vv cv
      clt wbr wn vv vw cv cneg cA wcel vw cr crab wral vv cv cneg cA wcel vu cv
      vv cv clt wbr wn wi vv cr wral vv cv vw cv cneg cA wcel vw cr crab wcel
      vu cv vv cv clt wbr wn wi vv cv cr wcel vv cv cneg cA wcel vu cv vv cv
      clt wbr wn wi wi vv vv cv vw cv cneg cA wcel vw cr crab wcel vu cv vv cv
      clt wbr wn wi vv cv cr wcel vv cv cneg cA wcel wa vu cv vv cv clt wbr wn
      wi vv cv cr wcel vv cv cneg cA wcel vu cv vv cv clt wbr wn wi wi vv cv vw
      cv cneg cA wcel vw cr crab wcel vv cv cr wcel vv cv cneg cA wcel wa vu cv
      vv cv clt wbr wn vw cv cneg cA wcel vv cv cneg cA wcel vw vv cv cr vw cv
      vv cv wceq vw cv cneg vv cv cneg cA vw cv vv cv negeq eleq1d elrab imbi1i
      vv cv cr wcel vv cv cneg cA wcel vu cv vv cv clt wbr wn impexp bitri
      albii vu cv vv cv clt wbr wn vv vw cv cneg cA wcel vw cr crab df-ral vv
      cv cneg cA wcel vu cv vv cv clt wbr wn wi vv cr df-ral 3bitr4ri syl5bbr
      vu cv cr wcel vv cv vu cv clt wbr vv cv vt cv clt wbr vt vw cv cneg cA
      wcel vw cr crab wrex wi vu cv cneg vv cv cneg clt wbr vt cv cneg cA wcel
      vt cv cneg vv cv cneg clt wbr wa vt cr wrex wi vv cr vu cv cr wcel vv cv
      cr wcel wa vv cv vu cv clt wbr vu cv cneg vv cv cneg clt wbr vv cv vt cv
      clt wbr vt vw cv cneg cA wcel vw cr crab wrex vt cv cneg cA wcel vt cv
      cneg vv cv cneg clt wbr wa vt cr wrex vv cv cr wcel vu cv cr wcel vv cv
      vu cv clt wbr vu cv cneg vv cv cneg clt wbr wb vv cv vu cv ltneg ancoms
      vv cv cr wcel vv cv vt cv clt wbr vt vw cv cneg cA wcel vw cr crab wrex
      vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex wb vu cv
      cr wcel vv cv cr wcel vt cv cneg cA wcel vv cv vt cv clt wbr wa vt cr
      wrex vt cv cneg cA wcel vt cv cneg vv cv cneg clt wbr wa vt cr wrex vv cv
      vt cv clt wbr vt vw cv cneg cA wcel vw cr crab wrex vv cv cr wcel vt cv
      cneg cA wcel vv cv vt cv clt wbr wa vt cv cneg cA wcel vt cv cneg vv cv
      cneg clt wbr wa vt cr vv cv cr wcel vt cv cr wcel wa vv cv vt cv clt wbr
      vt cv cneg vv cv cneg clt wbr vt cv cneg cA wcel vv cv vt cv ltneg anbi2d
      rexbidva vv cv vt cv clt wbr vt cv cneg cA wcel vv cv vt cv clt wbr wa vt
      vw cv cneg cA wcel vw cr crab cr vt cv vw cv cneg cA wcel vw cr crab wcel
      vv cv vt cv clt wbr wa vt cv cr wcel vt cv cneg cA wcel wa vv cv vt cv
      clt wbr wa vt cv cr wcel vt cv cneg cA wcel vv cv vt cv clt wbr wa wa vt
      cv vw cv cneg cA wcel vw cr crab wcel vt cv cr wcel vt cv cneg cA wcel wa
      vv cv vt cv clt wbr vw cv cneg cA wcel vt cv cneg cA wcel vw vt cv cr vw
      cv vt cv wceq vw cv cneg vt cv cneg cA vw cv vt cv negeq eleq1d elrab
      anbi1i vt cv cr wcel vt cv cneg cA wcel vv cv vt cv clt wbr anass bitri
      rexbii2 syl5bb adantl imbi12d ralbidva anbi12d rexbiia bitr4i syl6bb
      sylibrd 3impib $.
      $( [11-May-2007] $) $( [14-Jun-2005] $)

    $( Closure of supremum of a non-empty bounded set of reals. $)
    suprcl $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                  sup ( A , RR , < ) e. RR ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv
      vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr wrex cA cr clt csup cr wcel vx vy vz cA sup3
      vx vy vz cr cA clt ltso supcl syl $.
      $( [13-May-2007] $) $( [12-Oct-2004] $)

    $( A member of a non-empty bounded set of reals is less than or equal
       to the set's upper bound. $)
    suprub $p |- ( ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x )
                 /\ B e. A ) -> B <_ sup ( A , RR , < ) ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cA
      wcel wa cB cA cr clt csup cle wbr cA cr clt csup cB clt wbr wn cA cr wss
      cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cA wcel cA cr
      clt csup cB clt wbr wn cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral
      vx cr wrex w3a vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy
      cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr wrex cB cA wcel cA cr
      clt csup cB clt wbr wn wi vx vy vz cA sup3 vx vy vz cr cA cB clt ltso
      supub syl imp cB cr wcel cA cr clt csup cr wcel cB cA cr clt csup cle wbr
      cA cr clt csup cB clt wbr wn wb cA cr wss cA c0 wne vy cv vx cv cle wbr
      vy cA wral vx cr wrex w3a cB cA wcel wa cB cA cr clt csup lenlt cA cr wss
      cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cA wcel cB cr
      wcel cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cA
      cr cB cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex
      3simp1 sseld imp cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr
      wrex w3a cA cr clt csup cr wcel cB cA wcel vx vy cA suprcl adantr sylanc
      mpbird $.
      $( [15-May-2007] $) $( [12-Oct-2004] $)

    ${
      $d z B $.
      $( The supremum of a non-empty bounded set of reals is the least upper
         bound. $)
      suprlub $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                      E. x e. RR A. y e. A y <_ x ) /\
                    ( B e. RR /\ B < sup ( A , RR , < ) ) ) ->
                    E. z e. A B < z ) $=
        cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr
        wcel cB cA cr clt csup clt wbr wa cB vz cv clt wbr vz cA wrex cA cr wss
        cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv vy cv clt
        wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
        vy cr wral wa vx cr wrex cB cr wcel cB cA cr clt csup clt wbr wa cB vz
        cv clt wbr vz cA wrex wi vx vy vz cA sup3 vx vy vz cr cA cB clt ltso
        suplub syl imp $.
        $( [29-May-2007] $) $( [15-Nov-2004] $)

      $( An upper bound is not less than the supremum of a non-empty bounded
         set of reals. $)
      suprnub $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                      E. x e. RR A. y e. A y <_ x ) /\
                    ( B e. RR /\ A. z e. A -. B < z ) ) ->
                    -. B < sup ( A , RR , < ) ) $=
        cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr
        wcel cB vz cv clt wbr wn vz cA wral wa cB cA cr clt csup clt wbr wn cA
        cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv vy
        cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
        wrex wi vy cr wral wa vx cr wrex cB cr wcel cB vz cv clt wbr wn vz cA
        wral wa cB cA cr clt csup clt wbr wn wi vx vy vz cA sup3 vx vy vz cr cA
        cB clt ltso supnub syl imp $.
        $( [21-May-2007] $) $( [15-Nov-2004] $)

      $( The supremum of a non-empty bounded set of reals is less than or equal
         to an upper bound. $)
      suprleub $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                      E. x e. RR A. y e. A y <_ x ) /\
                    ( B e. RR /\ A. z e. A z <_ B ) ) ->
                    sup ( A , RR , < ) <_ B ) $=
        cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr
        wcel vz cv cB cle wbr vz cA wral wa cA cr clt csup cB cle wbr cA cr wss
        cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr wcel vz
        cv cB cle wbr vz cA wral wa cB cr wcel cB vz cv clt wbr wn vz cA wral
        wa cA cr clt csup cB cle wbr cA cr wss cA c0 wne cB cr wcel vz cv cB
        cle wbr vz cA wral wa cB cr wcel cB vz cv clt wbr wn vz cA wral wa wb
        vy cv vx cv cle wbr vy cA wral vx cr wrex cA cr wss cB cr wcel vz cv cB
        cle wbr vz cA wral cB vz cv clt wbr wn vz cA wral cA cr wss cB cr wcel
        wa vz cv cB cle wbr cB vz cv clt wbr wn vz cA cA cr wss vz cv cA wcel
        cB cr wcel vz cv cB cle wbr cB vz cv clt wbr wn wb vz cv cr wcel cB cr
        wcel vz cv cB cle wbr cB vz cv clt wbr wn wb cA cr wss vz cv cA wcel wa
        vz cv cB lenlt cA cr vz cv ssel2 sylan an1rs ralbidva pm5.32da 3ad2ant1
        cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr
        wcel cB vz cv clt wbr wn vz cA wral wa cA cr clt csup cB cle wbr cA cr
        wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr wcel
        cB vz cv clt wbr wn vz cA wral wa wa cA cr clt csup cB cle wbr cB cA cr
        clt csup clt wbr wn vx vy vz cA cB suprnub cA cr wss cA c0 wne vy cv vx
        cv cle wbr vy cA wral vx cr wrex w3a cB cr wcel cA cr clt csup cB cle
        wbr cB cA cr clt csup clt wbr wn wb cB vz cv clt wbr wn vz cA wral cA
        cr clt csup cr wcel cB cr wcel cA cr clt csup cB cle wbr cB cA cr clt
        csup clt wbr wn wb cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral
        vx cr wrex w3a cA cr clt csup cB lenlt vx vy cA suprcl sylan adantrr
        mpbird ex sylbid imp $.
        $( [28-May-2007] $) $( [18-Mar-2005] $)
    $}
  $}

  ${
    $d x y z A $.
    sup3i.1 $e |- ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) $.
    $( A version of the completeness axiom for reals. $)
    sup3ii $p |- E. x e. RR ( A. y e. A -. x < y /\
                  A. y e. RR ( y < x -> E. z e. A y < z ) ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv
      vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr wrex sup3i.1 vx vy vz cA sup3 ax-mp $.
      $( [14-Mar-2007] $) $( [23-Aug-1999] $)

    $( Closure of supremum of a non-empty bounded set of reals. $)
    suprclii $p |- sup ( A , RR , < ) e. RR $=
      vx vy vz cr cA clt ltso vx vy vz cA sup3i.1 sup3ii supcli $.
      $( [15-May-2007] $) $( [12-Sep-1999] $)

    $( A member of a non-empty bounded set of reals is less than or equal
       to the set's upper bound. $)
    suprubii $p |- ( B e. A -> B <_ sup ( A , RR , < ) ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cA
      wcel cB cA cr clt csup cle wbr sup3i.1 vx vy cA cB suprub mpan $.
      $( [16-May-2007] $) $( [12-Sep-1999] $)

    ${
      $d z B $.
      $( The supremum of a non-empty bounded set of reals is the least upper
         bound. $)
      suprlubii $p |- ( ( B e. RR /\ B < sup ( A , RR , < ) ) ->
                    E. z e. A B < z ) $=
        vx vy vz cr cA cB clt ltso vx vy vz cA sup3i.1 sup3ii suplubi $.
        $( [16-May-2007] $) $( [15-Oct-2004] $)

      $( An upper bound is not less than the supremum of a non-empty bounded
         set of reals. $)
      suprnubii $p |- ( ( B e. RR /\ A. z e. A -. B < z ) ->
                   -. B < sup ( A , RR , < ) ) $=
        vx vy vz cr cA cB clt ltso vx vy vz cA sup3i.1 sup3ii supnubi $.
        $( [31-May-2007] $) $( [15-Oct-2004] $)

      $( The supremum of a non-empty bounded set of reals is less than or equal
         to an upper bound. $)
      suprleubii $p |- ( ( B e. RR /\ A. z e. A z <_ B ) ->
                   sup ( A , RR , < ) <_ B ) $=
        cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cB cr
        wcel vz cv cB cle wbr vz cA wral wa cA cr clt csup cB cle wbr sup3i.1
        vx vy vz cA cB suprleub mpan $.
        $( [1-Jun-2007] $) $( [18-Mar-2005] $)
    $}
  $}

  ${
    $d x y z $.  $d z A $.  $d y z ph $.  $d x z ps $.
    reuunineg.1 $e |- ( x = -u y -> ( ph <-> ps ) ) $.
    $( The negative of the unique real such that ` ph ` . $)
    reuuninegi $p |- ( E! x e. RR ph ->
                U. { x e. RR | ph } = -u U. { y e. RR | ps } ) $=
      wph wps vx vy vz cr vy cv cneg wps vy cr crab cuni cneg vy vz wps vy cr
      crab cuni vy vz wps vy cr crab wps vy vz cr hbrab1 hbuni hbneg vy cv
      renegcl wps vy cr crab cuni renegcl reuunineg.1 vy cv wps vy cr crab cuni
      negeq vx vy vy cv cneg vx cv cneg cr vx cv renegcl vx cv cc wcel vy cv cc
      wcel vx cv vy cv cneg wceq vy cv vx cv cneg wceq wb vx cv cr wcel vy cv
      cr wcel vx cv vy cv negcon2 vx cv recn vy cv recn syl2an reuhyp reuunixfr
      $.
      $( [26-Jun-2005] $) $( [13-Jun-2005] $)
  $}

  ${
    $d x y z w v u t A $.
    $( The infimum (expressed as supremum with converse 'less-than') of a set
       of reals ` A ` . $)
    dfinfmr $p |- ( A C_ RR -> sup ( A , RR , `' < ) = U. { x e. RR |
        ( A. y e. A  x <_ y /\ A. y e. RR ( x < y -> E. z e. A z < y ) ) } ) $=
      cA cr wss vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv wbr
      vy cv vz cv clt ccnv wbr vz cA wrex wi vy cr wral wa vx cr crab cuni vx
      cv vy cv cle wbr vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr crab cuni cA cr clt ccnv csup cA cr wss vx cv
      vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy cv vz cv clt
      ccnv wbr vz cA wrex wi vy cr wral wa vx cr crab vx cv vy cv cle wbr vy cA
      wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral wa
      vx cr crab cA cr wss vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv
      clt ccnv wbr vy cv vz cv clt ccnv wbr vz cA wrex wi vy cr wral wa vx cv
      vy cv cle wbr vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr cA cr wss vx cv cr wcel wa vx cv vy cv clt
      ccnv wbr wn vy cA wral vx cv vy cv cle wbr vy cA wral vy cv vx cv clt
      ccnv wbr vy cv vz cv clt ccnv wbr vz cA wrex wi vy cr wral vx cv vy cv
      clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral cA cr wss vx cv cr
      wcel wa vx cv vy cv clt ccnv wbr wn vx cv vy cv cle wbr vy cA cA cr wss
      vy cv cA wcel vx cv cr wcel vx cv vy cv clt ccnv wbr wn vx cv vy cv cle
      wbr wb vx cv cr wcel cA cr wss vy cv cA wcel wa vx cv vy cv clt ccnv wbr
      wn vx cv vy cv cle wbr wb vx cv cr wcel vy cv cr wcel vx cv vy cv clt
      ccnv wbr wn vx cv vy cv cle wbr wb cA cr wss vy cv cA wcel wa vx cv cr
      wcel vy cv cr wcel wa vx cv vy cv cle wbr vy cv vx cv clt wbr wn vx cv vy
      cv clt ccnv wbr wn vx cv vy cv lenlt vx cv vy cv clt ccnv wbr vy cv vx cv
      clt wbr vx cv vy cv clt vx visset vy visset brcnv notbii syl6rbbr cA cr
      vy cv ssel2 sylan2 ancoms an1rs ralbidva vy cv vx cv clt ccnv wbr vy cv
      vz cv clt ccnv wbr vz cA wrex wi vy cr wral vx cv vy cv clt wbr vz cv vy
      cv clt wbr vz cA wrex wi vy cr wral wb cA cr wss vx cv cr wcel wa vy cv
      vx cv clt ccnv wbr vy cv vz cv clt ccnv wbr vz cA wrex wi vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vy cr vy cv vx cv clt ccnv wbr vx
      cv vy cv clt wbr vy cv vz cv clt ccnv wbr vz cA wrex vz cv vy cv clt wbr
      vz cA wrex vy cv vx cv clt vy visset vx visset brcnv vy cv vz cv clt ccnv
      wbr vz cv vy cv clt wbr vz cA vy cv vz cv clt vy visset vz visset brcnv
      rexbii imbi12i ralbii a1i anbi12d rabbidv unieqd vx vy vz cr cA clt ccnv
      df-sup syl5eq $.
      $( [23-Dec-2005] $) $( [9-Oct-2005] $)

    $( The infimum (expressed as supremum with converse 'less-than') of a set
       of reals ` A ` is the negative of the supremum of the negatives of its
       elements.  The antecedent ensures that ` A ` is nonempty and has a
       lower bound. $)
    infmsup $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                   sup ( A , RR , `' < ) =
                 -u sup ( { z e. RR | -u z e. A } , RR , < ) ) $=
      cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex cA cr clt
      ccnv csup vz cv cneg cA wcel vz cr crab cr clt csup cneg wceq cA cr wss
      cA c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex vy cv vx cv clt wbr
      wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr
      wral wa vx cr wrex cA cr clt ccnv csup vz cv cneg cA wcel vz cr crab cr
      clt csup cneg wceq cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx
      cr wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv
      clt wbr vw cA wrex wi vy cr wral wa vx cr wrex vx vy vw cA infm3 3exp cA
      cr wss vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv
      clt wbr vw cA wrex wi vy cr wral wa vx cr wreu cA cr clt ccnv csup vz cv
      cneg cA wcel vz cr crab cr clt csup cneg wceq vy cv vx cv clt wbr wn vy
      cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral
      wa vx cr wrex cA cr wss vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral wa vx cr wreu cA cr clt
      ccnv csup vz cv cneg cA wcel vz cr crab cr clt csup cneg wceq vy cv vx cv
      clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex
      wi vy cr wral wa vx cr wreu cA cr wss cA cr clt ccnv csup vy cv vv cv
      cneg clt wbr wn vy cA wral vv cv cneg vy cv clt wbr vw cv vy cv clt wbr
      vw cA wrex wi vy cr wral wa vv cr crab cuni cneg vz cv cneg cA wcel vz cr
      crab cr clt csup cneg vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral wa vx cr wreu vy cv vx
      cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA
      wrex wi vy cr wral wa vx cr crab cuni vy cv vv cv cneg clt wbr wn vy cA
      wral vv cv cneg vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr
      wral wa vv cr crab cuni cneg cA cr clt ccnv csup vy cv vx cv clt wbr wn
      vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr
      wral wa vy cv vv cv cneg clt wbr wn vy cA wral vv cv cneg vy cv clt wbr
      vw cv vy cv clt wbr vw cA wrex wi vy cr wral wa vx vv vx cv vv cv cneg
      wceq vy cv vx cv clt wbr wn vy cA wral vy cv vv cv cneg clt wbr wn vy cA
      wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral vv
      cv cneg vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral vx cv
      vv cv cneg wceq vy cv vx cv clt wbr wn vy cv vv cv cneg clt wbr wn vy cA
      vx cv vv cv cneg wceq vy cv vx cv clt wbr vy cv vv cv cneg clt wbr vx cv
      vv cv cneg vy cv clt breq2 notbid ralbidv vx cv vv cv cneg wceq vx cv vy
      cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vv cv cneg vy cv clt wbr vw
      cv vy cv clt wbr vw cA wrex wi vy cr vx cv vv cv cneg wceq vx cv vy cv
      clt wbr vv cv cneg vy cv clt wbr vw cv vy cv clt wbr vw cA wrex vx cv vv
      cv cneg vy cv clt breq1 imbi1d ralbidv anbi12d reuuninegi cA cr clt ccnv
      csup vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy
      cv vw cv clt ccnv wbr vw cA wrex wi vy cr wral wa vx cr crab cuni vy cv
      vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA
      wrex wi vy cr wral wa vx cr crab cuni vx vy vw cr cA clt ccnv df-sup vx
      cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy cv vw cv
      clt ccnv wbr vw cA wrex wi vy cr wral wa vx cr crab vy cv vx cv clt wbr
      wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr
      wral wa vx cr crab vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt
      ccnv wbr vy cv vw cv clt ccnv wbr vw cA wrex wi vy cr wral wa vy cv vx cv
      clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA wrex
      wi vy cr wral wa vx cr vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv
      clt ccnv wbr vy cv vw cv clt ccnv wbr vw cA wrex wi vy cr wral wa vy cv
      vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr vw cA
      wrex wi vy cr wral wa wb vx cv cr wcel vx cv vy cv clt ccnv wbr wn vy cA
      wral vy cv vx cv clt wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy cv vw
      cv clt ccnv wbr vw cA wrex wi vy cr wral vx cv vy cv clt wbr vw cv vy cv
      clt wbr vw cA wrex wi vy cr wral vx cv vy cv clt ccnv wbr wn vy cv vx cv
      clt wbr wn vy cA vx cv vy cv clt ccnv wbr vy cv vx cv clt wbr vx cv vy cv
      clt vx visset vy visset brcnv notbii ralbii vy cv vx cv clt ccnv wbr vy
      cv vw cv clt ccnv wbr vw cA wrex wi vx cv vy cv clt wbr vw cv vy cv clt
      wbr vw cA wrex wi vy cr vy cv vx cv clt ccnv wbr vx cv vy cv clt wbr vy
      cv vw cv clt ccnv wbr vw cA wrex vw cv vy cv clt wbr vw cA wrex vy cv vx
      cv clt vy visset vx visset brcnv vy cv vw cv clt ccnv wbr vw cv vy cv clt
      wbr vw cA vy cv vw cv clt vy visset vw visset brcnv rexbii imbi12i ralbii
      anbi12i a1i rabbii unieqi eqtri syl5eq cA cr wss vz cv cneg cA wcel vz cr
      crab cr clt csup cneg vy cv vv cv cneg clt wbr wn vy cA wral vv cv cneg
      vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral wa vv cr crab
      cuni cneg cA cr wss vz cv cneg cA wcel vz cr crab cr clt csup vy cv vv cv
      cneg clt wbr wn vy cA wral vv cv cneg vy cv clt wbr vw cv vy cv clt wbr
      vw cA wrex wi vy cr wral wa vv cr crab cuni cA cr wss vv cv vu cv clt wbr
      wn vu vz cv cneg cA wcel vz cr crab wral vu cv vv cv clt wbr vu cv vt cv
      clt wbr vt vz cv cneg cA wcel vz cr crab wrex wi vu cr wral wa vv cr crab
      cuni vy cv vv cv cneg clt wbr wn vy cA wral vv cv cneg vy cv clt wbr vw
      cv vy cv clt wbr vw cA wrex wi vy cr wral wa vv cr crab cuni vz cv cneg
      cA wcel vz cr crab cr clt csup cA cr wss vv cv vu cv clt wbr wn vu vz cv
      cneg cA wcel vz cr crab wral vu cv vv cv clt wbr vu cv vt cv clt wbr vt
      vz cv cneg cA wcel vz cr crab wrex wi vu cr wral wa vv cr crab vy cv vv
      cv cneg clt wbr wn vy cA wral vv cv cneg vy cv clt wbr vw cv vy cv clt
      wbr vw cA wrex wi vy cr wral wa vv cr crab cA cr wss vv cv vu cv clt wbr
      wn vu vz cv cneg cA wcel vz cr crab wral vu cv vv cv clt wbr vu cv vt cv
      clt wbr vt vz cv cneg cA wcel vz cr crab wrex wi vu cr wral wa vy cv vv
      cv cneg clt wbr wn vy cA wral vv cv cneg vy cv clt wbr vw cv vy cv clt
      wbr vw cA wrex wi vy cr wral wa vv cr vv cv cr wcel vv cv vu cv clt wbr
      wn vu vz cv cneg cA wcel vz cr crab wral vu cv vv cv clt wbr vu cv vt cv
      clt wbr vt vz cv cneg cA wcel vz cr crab wrex wi vu cr wral wa vu cv cneg
      cA wcel vu cv cneg vv cv cneg clt wbr wn wi vu cr wral vv cv cneg vu cv
      cneg clt wbr vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr
      wrex wi vu cr wral wa cA cr wss vy cv vv cv cneg clt wbr wn vy cA wral vv
      cv cneg vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral wa vv
      cv cr wcel vv cv vu cv clt wbr wn vu vz cv cneg cA wcel vz cr crab wral
      vu cv cneg cA wcel vu cv cneg vv cv cneg clt wbr wn wi vu cr wral vu cv
      vv cv clt wbr vu cv vt cv clt wbr vt vz cv cneg cA wcel vz cr crab wrex
      wi vu cr wral vv cv cneg vu cv cneg clt wbr vt cv cneg cA wcel vt cv cneg
      vu cv cneg clt wbr wa vt cr wrex wi vu cr wral vv cv cr wcel vu cv cneg
      cA wcel vv cv vu cv clt wbr wn wi vu cr wral vu cv cneg cA wcel vu cv
      cneg vv cv cneg clt wbr wn wi vu cr wral vv cv vu cv clt wbr wn vu vz cv
      cneg cA wcel vz cr crab wral vv cv cr wcel vu cv cneg cA wcel vv cv vu cv
      clt wbr wn wi vu cv cneg cA wcel vu cv cneg vv cv cneg clt wbr wn wi vu
      cr vv cv cr wcel vu cv cr wcel wa vv cv vu cv clt wbr wn vu cv cneg vv cv
      cneg clt wbr wn vu cv cneg cA wcel vv cv cr wcel vu cv cr wcel wa vv cv
      vu cv clt wbr vu cv cneg vv cv cneg clt wbr vv cv vu cv ltneg notbid
      imbi2d ralbidva vu cv vz cv cneg cA wcel vz cr crab wcel vv cv vu cv clt
      wbr wn wi vu wal vu cv cr wcel vu cv cneg cA wcel vv cv vu cv clt wbr wn
      wi wi vu wal vv cv vu cv clt wbr wn vu vz cv cneg cA wcel vz cr crab wral
      vu cv cneg cA wcel vv cv vu cv clt wbr wn wi vu cr wral vu cv vz cv cneg
      cA wcel vz cr crab wcel vv cv vu cv clt wbr wn wi vu cv cr wcel vu cv
      cneg cA wcel vv cv vu cv clt wbr wn wi wi vu vu cv vz cv cneg cA wcel vz
      cr crab wcel vv cv vu cv clt wbr wn wi vu cv cr wcel vu cv cneg cA wcel
      wa vv cv vu cv clt wbr wn wi vu cv cr wcel vu cv cneg cA wcel vv cv vu cv
      clt wbr wn wi wi vu cv vz cv cneg cA wcel vz cr crab wcel vu cv cr wcel
      vu cv cneg cA wcel wa vv cv vu cv clt wbr wn vz cv cneg cA wcel vu cv
      cneg cA wcel vz vu cv cr vz cv vu cv wceq vz cv cneg vu cv cneg cA vz cv
      vu cv negeq eleq1d elrab imbi1i vu cv cr wcel vu cv cneg cA wcel vv cv vu
      cv clt wbr wn impexp bitri albii vv cv vu cv clt wbr wn vu vz cv cneg cA
      wcel vz cr crab df-ral vu cv cneg cA wcel vv cv vu cv clt wbr wn wi vu cr
      df-ral 3bitr4ri syl5bbr vv cv cr wcel vu cv vv cv clt wbr vu cv vt cv clt
      wbr vt vz cv cneg cA wcel vz cr crab wrex wi vv cv cneg vu cv cneg clt
      wbr vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr wrex wi vu
      cr vv cv cr wcel vu cv cr wcel wa vu cv vv cv clt wbr vv cv cneg vu cv
      cneg clt wbr vu cv vt cv clt wbr vt vz cv cneg cA wcel vz cr crab wrex vt
      cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr wrex vu cv cr wcel
      vv cv cr wcel vu cv vv cv clt wbr vv cv cneg vu cv cneg clt wbr wb vu cv
      vv cv ltneg ancoms vu cv cr wcel vu cv vt cv clt wbr vt vz cv cneg cA
      wcel vz cr crab wrex vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa
      vt cr wrex wb vv cv cr wcel vu cv cr wcel vt cv cneg cA wcel vu cv vt cv
      clt wbr wa vt cr wrex vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa
      vt cr wrex vu cv vt cv clt wbr vt vz cv cneg cA wcel vz cr crab wrex vu
      cv cr wcel vt cv cneg cA wcel vu cv vt cv clt wbr wa vt cv cneg cA wcel
      vt cv cneg vu cv cneg clt wbr wa vt cr vu cv cr wcel vt cv cr wcel wa vu
      cv vt cv clt wbr vt cv cneg vu cv cneg clt wbr vt cv cneg cA wcel vu cv
      vt cv ltneg anbi2d rexbidva vu cv vt cv clt wbr vt cv cneg cA wcel vu cv
      vt cv clt wbr wa vt vz cv cneg cA wcel vz cr crab cr vt cv vz cv cneg cA
      wcel vz cr crab wcel vu cv vt cv clt wbr wa vt cv cr wcel vt cv cneg cA
      wcel wa vu cv vt cv clt wbr wa vt cv cr wcel vt cv cneg cA wcel vu cv vt
      cv clt wbr wa wa vt cv vz cv cneg cA wcel vz cr crab wcel vt cv cr wcel
      vt cv cneg cA wcel wa vu cv vt cv clt wbr vz cv cneg cA wcel vt cv cneg
      cA wcel vz vt cv cr vz cv vt cv wceq vz cv cneg vt cv cneg cA vz cv vt cv
      negeq eleq1d elrab anbi1i vt cv cr wcel vt cv cneg cA wcel vu cv vt cv
      clt wbr anass bitri rexbii2 syl5bb adantl imbi12d ralbidva anbi12d cA cr
      wss vu cv cneg cA wcel vu cv cneg vv cv cneg clt wbr wn wi vu cr wral vy
      cv vv cv cneg clt wbr wn vy cA wral vv cv cneg vu cv cneg clt wbr vt cv
      cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr wrex wi vu cr wral vv
      cv cneg vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral cA cr
      wss vy cv cr wcel vy cv cA wcel vy cv vv cv cneg clt wbr wn wi wi vy wal
      vy cv cA wcel vy cv vv cv cneg clt wbr wn wi vy wal vu cv cneg cA wcel vu
      cv cneg vv cv cneg clt wbr wn wi vu cr wral vy cv vv cv cneg clt wbr wn
      vy cA wral cA cr wss vy cv cr wcel vy cv cA wcel vy cv vv cv cneg clt wbr
      wn wi wi vy cv cA wcel vy cv vv cv cneg clt wbr wn wi vy cA cr wss vy cv
      cA wcel vy cv vv cv cneg clt wbr wn wi vy cv cr wcel vy cv cA wcel wa vy
      cv vv cv cneg clt wbr wn wi vy cv cr wcel vy cv cA wcel vy cv vv cv cneg
      clt wbr wn wi wi cA cr wss vy cv cA wcel vy cv cr wcel vy cv cA wcel wa
      vy cv vv cv cneg clt wbr wn cA cr wss vy cv cA wcel vy cv cr wcel cA cr
      vy cv ssel pm4.71rd imbi1d vy cv cr wcel vy cv cA wcel vy cv vv cv cneg
      clt wbr wn impexp syl6rbb albidv vu cv cneg cA wcel vu cv cneg vv cv cneg
      clt wbr wn wi vu cr wral vy cv cA wcel vy cv vv cv cneg clt wbr wn wi vy
      cr wral vy cv cr wcel vy cv cA wcel vy cv vv cv cneg clt wbr wn wi wi vy
      wal vy cv cA wcel vy cv vv cv cneg clt wbr wn wi vu cv cneg cA wcel vu cv
      cneg vv cv cneg clt wbr wn wi vy vu vu cv cneg cr vu cv renegcl vy vu
      infm3lem vy cv vu cv cneg wceq vy cv cA wcel vu cv cneg cA wcel vy cv vv
      cv cneg clt wbr wn vu cv cneg vv cv cneg clt wbr wn vy cv vu cv cneg cA
      eleq1 vy cv vu cv cneg wceq vy cv vv cv cneg clt wbr vu cv cneg vv cv
      cneg clt wbr vy cv vu cv cneg vv cv cneg clt breq1 notbid imbi12d ralxfr
      vy cv cA wcel vy cv vv cv cneg clt wbr wn wi vy cr df-ral bitr3i vy cv vv
      cv cneg clt wbr wn vy cA df-ral 3bitr4g cA cr wss vv cv cneg vu cv cneg
      clt wbr vw cv vu cv cneg clt wbr vw cA wrex wi vu cr wral vv cv cneg vu
      cv cneg clt wbr vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr
      wrex wi vu cr wral vv cv cneg vy cv clt wbr vw cv vy cv clt wbr vw cA
      wrex wi vy cr wral cA cr wss vv cv cneg vu cv cneg clt wbr vw cv vu cv
      cneg clt wbr vw cA wrex wi vv cv cneg vu cv cneg clt wbr vt cv cneg cA
      wcel vt cv cneg vu cv cneg clt wbr wa vt cr wrex wi vu cr cA cr wss vw cv
      vu cv cneg clt wbr vw cA wrex vt cv cneg cA wcel vt cv cneg vu cv cneg
      clt wbr wa vt cr wrex vv cv cneg vu cv cneg clt wbr cA cr wss vw cv cA
      wcel vw cv vu cv cneg clt wbr wa vw wex vw cv cr wcel vw cv cA wcel vw cv
      vu cv cneg clt wbr wa wa vw wex vw cv vu cv cneg clt wbr vw cA wrex vt cv
      cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr wrex cA cr wss vw cv
      cA wcel vw cv vu cv cneg clt wbr wa vw cv cr wcel vw cv cA wcel vw cv vu
      cv cneg clt wbr wa wa vw cA cr wss vw cv cA wcel vw cv vu cv cneg clt wbr
      wa vw cv cr wcel cA cr wss vw cv cA wcel vw cv cr wcel vw cv vu cv cneg
      clt wbr cA cr vw cv ssel adantrd pm4.71rd exbidv vw cv vu cv cneg clt wbr
      vw cA df-rex vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa vt cr
      wrex vw cv cA wcel vw cv vu cv cneg clt wbr wa vw cr wrex vw cv cr wcel
      vw cv cA wcel vw cv vu cv cneg clt wbr wa wa vw wex vw cv cA wcel vw cv
      vu cv cneg clt wbr wa vt cv cneg cA wcel vt cv cneg vu cv cneg clt wbr wa
      vw vt vt cv cneg cr vt cv renegcl vw vt infm3lem vw cv vt cv cneg wceq vw
      cv cA wcel vt cv cneg cA wcel vw cv vu cv cneg clt wbr vt cv cneg vu cv
      cneg clt wbr vw cv vt cv cneg cA eleq1 vw cv vt cv cneg vu cv cneg clt
      breq1 anbi12d rexxfr vw cv cA wcel vw cv vu cv cneg clt wbr wa vw cr
      df-rex bitr3i 3bitr4g imbi2d ralbidv vv cv cneg vy cv clt wbr vw cv vy cv
      clt wbr vw cA wrex wi vv cv cneg vu cv cneg clt wbr vw cv vu cv cneg clt
      wbr vw cA wrex wi vy vu vu cv cneg cr vu cv renegcl vy vu infm3lem vy cv
      vu cv cneg wceq vv cv cneg vy cv clt wbr vv cv cneg vu cv cneg clt wbr vw
      cv vy cv clt wbr vw cA wrex vw cv vu cv cneg clt wbr vw cA wrex vy cv vu
      cv cneg vv cv cneg clt breq2 vy cv vu cv cneg wceq vw cv vy cv clt wbr vw
      cv vu cv cneg clt wbr vw cA vy cv vu cv cneg vw cv clt breq2 rexbidv
      imbi12d ralxfr syl5rbb anbi12d sylan9bbr rabbidv unieqd vv vu vt cr vz cv
      cneg cA wcel vz cr crab clt df-sup syl5eq negeqd eqcomd sylan9eqr ex vx
      cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy cv vw cv
      clt ccnv wbr vw cA wrex wi vy cr wral wa vx cr wrex vx cv vy cv clt ccnv
      wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy cv vw cv clt ccnv wbr vw cA
      wrex wi vy cr wral wa vx cr wreu vy cv vx cv clt wbr wn vy cA wral vx cv
      vy cv clt wbr vw cv vy cv clt wbr vw cA wrex wi vy cr wral wa vx cr wrex
      vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy cv clt wbr
      vw cA wrex wi vy cr wral wa vx cr wreu vx vy vw cr cA clt ccnv cr clt wor
      cr clt ccnv wor ltso cr clt cnvso mpbi supeu vx cv vy cv clt ccnv wbr wn
      vy cA wral vy cv vx cv clt ccnv wbr vy cv vw cv clt ccnv wbr vw cA wrex
      wi vy cr wral wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw
      cv vy cv clt wbr vw cA wrex wi vy cr wral wa vx cr vx cv vy cv clt ccnv
      wbr wn vy cA wral vy cv vx cv clt wbr wn vy cA wral vy cv vx cv clt ccnv
      wbr vy cv vw cv clt ccnv wbr vw cA wrex wi vy cr wral vx cv vy cv clt wbr
      vw cv vy cv clt wbr vw cA wrex wi vy cr wral vx cv vy cv clt ccnv wbr wn
      vy cv vx cv clt wbr wn vy cA vx cv vy cv clt ccnv wbr vy cv vx cv clt wbr
      vx cv vy cv clt vx visset vy visset brcnv notbii ralbii vy cv vx cv clt
      ccnv wbr vy cv vw cv clt ccnv wbr vw cA wrex wi vx cv vy cv clt wbr vw cv
      vy cv clt wbr vw cA wrex wi vy cr vy cv vx cv clt ccnv wbr vx cv vy cv
      clt wbr vy cv vw cv clt ccnv wbr vw cA wrex vw cv vy cv clt wbr vw cA
      wrex vy cv vx cv clt vy visset vx visset brcnv vy cv vw cv clt ccnv wbr
      vw cv vy cv clt wbr vw cA vy cv vw cv clt vy visset vw visset brcnv
      rexbii imbi12i ralbii anbi12i rexbii vx cv vy cv clt ccnv wbr wn vy cA
      wral vy cv vx cv clt ccnv wbr vy cv vw cv clt ccnv wbr vw cA wrex wi vy
      cr wral wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vw cv vy
      cv clt wbr vw cA wrex wi vy cr wral wa vx cr vx cv vy cv clt ccnv wbr wn
      vy cA wral vy cv vx cv clt wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy
      cv vw cv clt ccnv wbr vw cA wrex wi vy cr wral vx cv vy cv clt wbr vw cv
      vy cv clt wbr vw cA wrex wi vy cr wral vx cv vy cv clt ccnv wbr wn vy cv
      vx cv clt wbr wn vy cA vx cv vy cv clt ccnv wbr vy cv vx cv clt wbr vx cv
      vy cv clt vx visset vy visset brcnv notbii ralbii vy cv vx cv clt ccnv
      wbr vy cv vw cv clt ccnv wbr vw cA wrex wi vx cv vy cv clt wbr vw cv vy
      cv clt wbr vw cA wrex wi vy cr vy cv vx cv clt ccnv wbr vx cv vy cv clt
      wbr vy cv vw cv clt ccnv wbr vw cA wrex vw cv vy cv clt wbr vw cA wrex vy
      cv vx cv clt vy visset vx visset brcnv vy cv vw cv clt ccnv wbr vw cv vy
      cv clt wbr vw cA vy cv vw cv clt vy visset vw visset brcnv rexbii imbi12i
      ralbii anbi12i reubii 3imtr3i syl5 syl6d 3imp $.
      $( [13-May-2007] $) $( [14-Jun-2005] $)

    $( Closure of infimum of a non-empty bounded set of reals. $)
    infmrcl $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                  sup ( A , RR , `' < ) e. RR ) $=
      cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex w3a cA cr
      clt ccnv csup vv cv cneg cA wcel vv cr crab cr clt csup cneg cr vx vy vv
      cA infmsup cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex
      w3a vv cv cneg cA wcel vv cr crab cr clt csup cr wcel vv cv cneg cA wcel
      vv cr crab cr clt csup cneg cr wcel vv cv cneg cA wcel vv cr crab c0 wne
      vw cv vz cv cle wbr vw vv cv cneg cA wcel vv cr crab wral vz cr wrex vv
      cv cneg cA wcel vv cr crab cr clt csup cr wcel cA cr wss cA c0 wne vx cv
      vy cv cle wbr vy cA wral vx cr wrex w3a vv cv cneg cA wcel vv cr crab cr
      wss vv cv cneg cA wcel vv cr crab c0 wne vw cv vz cv cle wbr vw vv cv
      cneg cA wcel vv cr crab wral vz cr wrex vv cv cneg cA wcel vv cr crab cr
      clt csup cr wcel vv cv cneg cA wcel vv cr ssrab2 vz vw vv cv cneg cA wcel
      vv cr crab suprcl mp3an1 cA cr wss cA c0 wne vv cv cneg cA wcel vv cr
      crab c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex cA cr wss vz cv cA
      wcel vz wex vv cv cneg cA wcel vv cr crab c0 wne cA c0 wne cA cr wss vz
      cv cA wcel vz wex vv cv cneg cA wcel vv cr crab c0 wne cA cr wss vz cv cA
      wcel vv cv cneg cA wcel vv cr crab c0 wne vz cA cr wss vz cv cA wcel vz
      cv cneg cr wcel vz cv cneg cneg cA wcel wa vv cv cneg cA wcel vv cr crab
      c0 wne cA cr wss vz cv cA wcel vz cv cneg cr wcel vz cv cneg cneg cA wcel
      cA cr wss vz cv cA wcel vz cv cr wcel vz cv cneg cr wcel cA cr vz cv ssel
      vz cv renegcl syl6 cA cr wss vz cv cA wcel vz cv cneg cneg cA wcel cA cr
      wss vz cv cA wcel wa vz cv cneg cneg vz cv cA cA cr wss vz cv cA wcel wa
      vz cv cr wcel vz cv cc wcel vz cv cneg cneg vz cv wceq cA cr vz cv ssel2
      vz cv recn vz cv negneg 3syl cA cr wss vz cv cA wcel pm3.27 eqeltrd ex
      jcad vz cv cneg cr wcel vz cv cneg cneg cA wcel wa vz cv cneg vv cv cneg
      cA wcel vv cr crab wcel vv cv cneg cA wcel vv cr crab c0 wne vv cv cneg
      cA wcel vz cv cneg cneg cA wcel vv vz cv cneg cr vv cv vz cv cneg wceq vv
      cv cneg vz cv cneg cneg cA vv cv vz cv cneg negeq eleq1d elrab vv cv cneg
      cA wcel vv cr crab vz cv cneg ne0i sylbir syl6 19.23adv imp vz cA n0
      sylan2b 3adant3 vx cv vy cv cle wbr vy cA wral vx cr wrex cA cr wss vw cv
      vz cv cle wbr vw vv cv cneg cA wcel vv cr crab wral vz cr wrex cA c0 wne
      vx cv vy cv cle wbr vy cA wral vw cv vz cv cle wbr vw vv cv cneg cA wcel
      vv cr crab wral vz cr wrex vx cr vx cv cr wcel vx cv vy cv cle wbr vy cA
      wral vx cv cneg cr wcel vw cv vx cv cneg cle wbr vw vv cv cneg cA wcel vv
      cr crab wral wa vw cv vz cv cle wbr vw vv cv cneg cA wcel vv cr crab wral
      vz cr wrex vx cv cr wcel vx cv vy cv cle wbr vy cA wral vw cv vx cv cneg
      cle wbr vw vv cv cneg cA wcel vv cr crab wral vx cv cneg cr wcel vx cv cr
      wcel vx cv vy cv cle wbr vy cA wral vw cv vx cv cneg cle wbr vw vv cv
      cneg cA wcel vv cr crab vx cv cr wcel vw cv vv cv cneg cA wcel vv cr crab
      wcel vx cv vy cv cle wbr vy cA wral vw cv vx cv cneg cle wbr vx cv cr
      wcel vw cv cr wcel vw cv cneg cA wcel wa vx cv vy cv cle wbr vy cA wral
      vw cv vx cv cneg cle wbr wi vw cv vv cv cneg cA wcel vv cr crab wcel vx
      cv cr wcel vw cv cr wcel vw cv cneg cA wcel wa vx cv vy cv cle wbr vy cA
      wral vw cv vx cv cneg cle wbr vx cv cr wcel vw cv cr wcel vw cv cneg cA
      wcel wa wa vx cv vy cv cle wbr vy cA wral wa vx cv vw cv cneg cle wbr vw
      cv vx cv cneg cle wbr vw cv cr wcel vw cv cneg cA wcel wa vx cv vy cv cle
      wbr vy cA wral vx cv vw cv cneg cle wbr vx cv cr wcel vw cv cneg cA wcel
      vx cv vy cv cle wbr vy cA wral vx cv vw cv cneg cle wbr vw cv cr wcel vx
      cv vy cv cle wbr vx cv vw cv cneg cle wbr vy vw cv cneg cA vy cv vw cv
      cneg vx cv cle breq2 rcla4va adantll adantll vx cv cr wcel vw cv cr wcel
      vw cv cneg cA wcel wa wa vx cv vw cv cneg cle wbr vw cv vx cv cneg cle
      wbr wb vx cv vy cv cle wbr vy cA wral vx cv cr wcel vw cv cr wcel vx cv
      vw cv cneg cle wbr vw cv vx cv cneg cle wbr wb vw cv cneg cA wcel vx cv
      vw cv lenegcon2 adantrr adantr mpbid exp31 vv cv cneg cA wcel vw cv cneg
      cA wcel vv vw cv cr vv cv vw cv wceq vv cv cneg vw cv cneg cA vv cv vw cv
      negeq eleq1d elrab syl5ib com23 r19.21adv vx cv renegcl jctild vw cv vz
      cv cle wbr vw vv cv cneg cA wcel vv cr crab wral vw cv vx cv cneg cle wbr
      vw vv cv cneg cA wcel vv cr crab wral vz vx cv cneg cr vz cv vx cv cneg
      wceq vw cv vz cv cle wbr vw cv vx cv cneg cle wbr vw vv cv cneg cA wcel
      vv cr crab vz cv vx cv cneg vw cv cle breq2 ralbidv rcla4ev syl6
      r19.23aiv 3ad2ant3 sylanc vv cv cneg cA wcel vv cr crab cr clt csup
      renegcl syl eqeltrd $.
      $( [14-May-2007] $) $( [8-Oct-2005] $)
  $}

  ${
    $d x y z $.
    $( The set of natural numbers is unbounded above.  Theorem I.28 of
       [Apostol] p. 26. $)
    nnunb $p |- -. E. x e. RR A. y e. NN ( y < x \/ y = x ) $=
      vy cv vx cv clt wbr vy cv vx cv wceq wo vy cn wral vx cr wrex vx cv vy cv
      clt wbr wn vy cn wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex
      wi vy cr wral wa vx cr wrex vx cv vy cv clt wbr wn vy cn wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cn wrex wi vy cr wral wa vx cr vx cv cr
      wcel vx cv vy cv clt wbr wn vy cn wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cn wrex wi vy cr wral wa vx cv vy cv clt wbr wn vy cn wral vx
      cv vy cv clt wbr wn vy cn wral wn wa vx cv vy cv clt wbr wn vy cn wral
      pm3.24 vx cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex
      wi vy cr wral vx cv vy cv clt wbr wn vy cn wral wn vx cv vy cv clt wbr wn
      vy cn wral vx cv cr wcel vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cn wrex wi wi vy wal vy cv cn wcel vx cv vy cv clt wbr wa vy
      wex vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex wi vy cr wral vx
      cv vy cv clt wbr wn vy cn wral wn vx cv cr wcel vy cv cr wcel vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cn wrex wi wi vy wal vz cv cn wcel vx cv
      c1 cmin co vz cv clt wbr wa vz wex vy cv cn wcel vx cv vy cv clt wbr wa
      vy wex vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex
      wi wi vy wal vx cv cr wcel vz cv cn wcel vx cv c1 cmin co vz cv clt wbr
      wa vz wex vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn
      wrex wi wi vy wal vx cv cr wcel vx cv c1 cmin co vz cv clt wbr vz cn wrex
      vz cv cn wcel vx cv c1 cmin co vz cv clt wbr wa vz wex vy cv cr wcel vy
      cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex wi wi vy wal vx cv cr
      wcel vx cv c1 cmin co vz cv clt wbr vz cn wrex vy cv cr wcel vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cn wrex wi wi vy wal vx cv c1 cmin co cr
      wcel vx cv cr wcel vx cv c1 cmin co vz cv clt wbr vz cn wrex wi vx cv cr
      wcel vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex wi
      wi vy wal vx cv c1 cmin co cr wcel vx cv c1 cmin co vx cv clt wbr vx cv
      c1 cmin co vz cv clt wbr vz cn wrex vx cv cr wcel vy cv cr wcel vy cv vx
      cv clt wbr vy cv vz cv clt wbr vz cn wrex wi wi vx cv c1 cmin co cr wcel
      vx cv c1 cmin co vx cv clt wbr vx cv c1 cmin co vz cv clt wbr vz cn wrex
      wi wi vy vx cv c1 cmin co vx cv c1 cmin oprex vy cv vx cv c1 cmin co wceq
      vy cv cr wcel vx cv c1 cmin co cr wcel vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cn wrex wi vx cv c1 cmin co vx cv clt wbr vx cv c1 cmin co vz
      cv clt wbr vz cn wrex wi vy cv vx cv c1 cmin co cr eleq1 vy cv vx cv c1
      cmin co wceq vy cv vx cv clt wbr vx cv c1 cmin co vx cv clt wbr vy cv vz
      cv clt wbr vz cn wrex vx cv c1 cmin co vz cv clt wbr vz cn wrex vy cv vx
      cv c1 cmin co vx cv clt breq1 vy cv vx cv c1 cmin co wceq vy cv vz cv clt
      wbr vx cv c1 cmin co vz cv clt wbr vz cn vy cv vx cv c1 cmin co vz cv clt
      breq1 rexbidv imbi12d imbi12d cla4v vx cv ltm1 syl7 vx cv peano2rem syl5
      pm2.43d vx cv c1 cmin co vz cv clt wbr vz cn df-rex syl6ib com12 vx cv cr
      wcel vz cv cn wcel vx cv c1 cmin co vz cv clt wbr wa vz wex vz cv cn wcel
      vx cv vz cv c1 caddc co clt wbr wa vz wex vy cv cn wcel vx cv vy cv clt
      wbr wa vy wex vx cv cr wcel vz cv cn wcel vx cv c1 cmin co vz cv clt wbr
      wa vz cv cn wcel vx cv vz cv c1 caddc co clt wbr wa vz vx cv cr wcel vz
      cv cn wcel vx cv c1 cmin co vz cv clt wbr vx cv vz cv c1 caddc co clt wbr
      vx cv cr wcel vz cv cr wcel vx cv c1 cmin co vz cv clt wbr vx cv vz cv c1
      caddc co clt wbr wb vz cv cn wcel vx cv cr wcel c1 cr wcel vz cv cr wcel
      vx cv c1 cmin co vz cv clt wbr vx cv vz cv c1 caddc co clt wbr wb 1re vx
      cv c1 vz cv ltsubadd mp3an2 vz cv nnre sylan2 pm5.32da exbidv vz cv cn
      wcel vx cv vz cv c1 caddc co clt wbr wa vy cv cn wcel vx cv vy cv clt wbr
      wa vy wex vz vz cv c1 caddc co cn wcel vx cv vz cv c1 caddc co clt wbr vy
      cv cn wcel vx cv vy cv clt wbr wa vy wex vz cv cn wcel vy cv cn wcel vx
      cv vy cv clt wbr wa vz cv c1 caddc co cn wcel vx cv vz cv c1 caddc co clt
      wbr wa vy vz cv c1 caddc co vz cv c1 caddc oprex vy cv vz cv c1 caddc co
      wceq vy cv cn wcel vz cv c1 caddc co cn wcel vx cv vy cv clt wbr vx cv vz
      cv c1 caddc co clt wbr vy cv vz cv c1 caddc co cn eleq1 vy cv vz cv c1
      caddc co vx cv clt breq2 anbi12d cla4ev vz cv peano2nn sylan 19.23aiv
      syl6bi syld vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex wi vy cr
      df-ral vy cv cn wcel vx cv vy cv clt wbr wa vy wex vx cv vy cv clt wbr wn
      vy cn wral vx cv vy cv clt wbr wn vy cn wral vy cv cn wcel vx cv vy cv
      clt wbr wn wi vy wal vy cv cn wcel vx cv vy cv clt wbr wa vy wex wn vx cv
      vy cv clt wbr wn vy cn df-ral vy cv cn wcel vx cv vy cv clt wbr vy
      alinexa bitr2i con1bii 3imtr4g anim2d mtoi nrex cn cr wss cn c0 wne vy cv
      vx cv clt wbr vy cv vx cv wceq wo vy cn wral vx cr wrex vx cv vy cv clt
      wbr wn vy cn wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cn wrex wi
      vy cr wral wa vx cr wrex nnssre cn c0 wne cn c0 wceq wn c1 cn wcel cn c0
      wceq wn 1nn cn c1 n0i ax-mp cn c0 df-ne mpbir vx vy vz cn sup2 mp3an12
      mto $.
      $( [21-Jan-1997] $)
  $}

  ${
    $d n y A $.
    $( Archimedean property of real numbers.  For any real number, there is an
       integer greater than it.  Theorem I.29 of [Apostol]
       p. 26. $)
    arch $p |- ( A e. RR -> E. n e. NN A < n ) $=
      vy cv vn cv clt wbr vn cn wrex cA vn cv clt wbr vn cn wrex vy cA cr vy cv
      cA wceq vy cv vn cv clt wbr cA vn cv clt wbr vn cn vy cv cA vn cv clt
      breq1 rexbidv vn cv vy cv clt wbr vn cv vy cv wceq wo vn cn wral wn vy cr
      wral vy cv vn cv clt wbr vn cn wrex vy cr wral vn cv vy cv clt wbr vn cv
      vy cv wceq wo vn cn wral wn vy cr wral vn cv vy cv clt wbr vn cv vy cv
      wceq wo vn cn wral vy cr wrex wn vy vn nnunb vn cv vy cv clt wbr vn cv vy
      cv wceq wo vn cn wral vy cr ralnex mpbir vn cv vy cv clt wbr vn cv vy cv
      wceq wo vn cn wral wn vy cv vn cv clt wbr vn cn wrex vy cr vy cv cr wcel
      vn cv vy cv clt wbr vn cv vy cv wceq wo wn vn cn wrex vy cv vn cv clt wbr
      vn cn wrex vn cv vy cv clt wbr vn cv vy cv wceq wo vn cn wral wn vy cv cr
      wcel vn cv vy cv clt wbr vn cv vy cv wceq wo wn vy cv vn cv clt wbr vn cn
      vy cv cr wcel vn cv cn wcel wa vy cv vn cv clt wbr vn cv vy cv clt wbr vn
      cv vy cv wceq wo wn vy cv cr wcel vn cv cn wcel wa vy cv vn cv clt wbr vy
      cv vn cv wceq vn cv vy cv clt wbr wo wn vn cv vy cv clt wbr vn cv vy cv
      wceq wo wn vy cv cr wcel vn cv cr wcel vy cv vn cv clt wbr vy cv vn cv
      wceq vn cv vy cv clt wbr wo wn wb vn cv cn wcel vy cv vn cv axlttri vn cv
      nnre sylan2 vy cv vn cv wceq vn cv vy cv clt wbr wo vn cv vy cv clt wbr
      vn cv vy cv wceq wo vy cv vn cv wceq vn cv vy cv clt wbr wo vn cv vy cv
      wceq vn cv vy cv clt wbr wo vn cv vy cv clt wbr vn cv vy cv wceq wo vy cv
      vn cv wceq vn cv vy cv wceq vn cv vy cv clt wbr vy cv vn cv eqcom orbi1i
      vn cv vy cv wceq vn cv vy cv clt wbr orcom bitri notbii syl6bb biimprd
      r19.22dva vn cv vy cv clt wbr vn cv vy cv wceq wo vn cn rexnal syl5ibr
      r19.20i ax-mp vtoclri $.
      $( [9-Nov-2004] $) $( [21-Jan-1997] $)
  $}

  ${
    $d n A $.
    $( There exists a natural number whose reciprocal is less than a given
       positive real.  Exercise 3 of [Apostol] p. 28. $)
    nnrecl $p |- ( ( A e. RR /\ 0 < A ) -> E. n e. NN ( 1 / n ) < A ) $=
      cA cr wcel cc0 cA clt wbr wa c1 cA cdiv co vn cv clt wbr vn cn wrex c1 vn
      cv cdiv co cA clt wbr vn cn wrex cA cr wcel cc0 cA clt wbr wa c1 cA cdiv
      co cr wcel c1 cA cdiv co vn cv clt wbr vn cn wrex c1 cr wcel cA cr wcel
      wa cA cc0 wne c1 cA cdiv co cr wcel cA cr wcel cc0 cA clt wbr wa c1 cr
      wcel cA cr wcel cA cc0 wne c1 cA cdiv co cr wcel c1 cA redivcl 3expa cA
      cr wcel cc0 cA clt wbr wa cA cr wcel c1 cr wcel cA cr wcel cc0 cA clt wbr
      pm3.26 1re jctil cA gt0ne0 sylanc c1 cA cdiv co vn arch syl cA cr wcel
      cc0 cA clt wbr wa c1 cA cdiv co vn cv clt wbr c1 vn cv cdiv co cA clt wbr
      vn cn cA cr wcel cc0 cA clt wbr wa vn cv cn wcel wa c1 cA cdiv co vn cv
      clt wbr c1 vn cv cdiv co c1 c1 cA cdiv co cdiv co clt wbr c1 vn cv cdiv
      co cA clt wbr c1 cA cdiv co cr wcel cc0 c1 cA cdiv co clt wbr wa vn cv cr
      wcel cc0 vn cv clt wbr wa c1 cA cdiv co vn cv clt wbr c1 vn cv cdiv co c1
      c1 cA cdiv co cdiv co clt wbr wb cA cr wcel cc0 cA clt wbr wa vn cv cn
      wcel c1 cA cdiv co vn cv ltrec cA cr wcel cc0 cA clt wbr wa c1 cA cdiv co
      cr wcel cc0 c1 cA cdiv co clt wbr c1 cr wcel cA cr wcel wa cA cc0 wne c1
      cA cdiv co cr wcel cA cr wcel cc0 cA clt wbr wa c1 cr wcel cA cr wcel cA
      cc0 wne c1 cA cdiv co cr wcel c1 cA redivcl 3expa cA cr wcel cc0 cA clt
      wbr wa cA cr wcel c1 cr wcel cA cr wcel cc0 cA clt wbr pm3.26 1re jctil
      cA gt0ne0 sylanc cA recgt0 jca vn cv cn wcel vn cv cr wcel cc0 vn cv clt
      wbr vn cv nnre vn cv nngt0 jca syl2an cA cr wcel cc0 cA clt wbr wa c1 vn
      cv cdiv co c1 c1 cA cdiv co cdiv co clt wbr c1 vn cv cdiv co cA clt wbr
      wb vn cv cn wcel cA cr wcel cc0 cA clt wbr wa c1 c1 cA cdiv co cdiv co cA
      c1 vn cv cdiv co clt cA cc wcel cA cc0 wne c1 c1 cA cdiv co cdiv co cA
      wceq cA cr wcel cc0 cA clt wbr wa cA recrec cA cr wcel cA cc wcel cc0 cA
      clt wbr cA recn adantr cA gt0ne0 sylanc breq2d adantr bitrd rexbidva
      mpbid $.
      $( [26-Jul-2006] $) $( [8-Nov-2004] $)
  $}

  ${
    $d x A $.  $d x k $.
    $( A bounded real sequence ` A ( k ) ` is less than or equal to at least
       one of its indices. $)
    bndndx $p |- ( E. x e. RR A. k e. NN ( A e. RR /\ A <_ x ) ->
                  E. k e. NN A <_ k ) $=
      cA cr wcel cA vx cv cle wbr wa vk cn wral cA vk cv cle wbr vk cn wrex vx
      cr vx cv cr wcel cA cr wcel cA vx cv cle wbr wa cA vk cv cle wbr wi vk cn
      wrex cA cr wcel cA vx cv cle wbr wa vk cn wral cA vk cv cle wbr vk cn
      wrex wi vx cv cr wcel vx cv vk cv clt wbr vk cn wrex cA cr wcel cA vx cv
      cle wbr wa cA vk cv cle wbr wi vk cn wrex vx cv vk arch vx cv cr wcel vx
      cv vk cv clt wbr cA cr wcel cA vx cv cle wbr wa cA vk cv cle wbr wi vk cn
      vx cv cr wcel vk cv cr wcel vx cv vk cv clt wbr cA cr wcel cA vx cv cle
      wbr wa cA vk cv cle wbr wi wi vk cv cn wcel vx cv cr wcel vk cv cr wcel
      wa cA cr wcel cA vx cv cle wbr wa vx cv vk cv clt wbr cA vk cv cle wbr vx
      cv cr wcel vk cv cr wcel cA cr wcel cA vx cv cle wbr vx cv vk cv clt wbr
      cA vk cv cle wbr wi cA cr wcel vx cv cr wcel vk cv cr wcel cA vx cv cle
      wbr vx cv vk cv clt wbr cA vk cv cle wbr wi wi cA cr wcel vx cv cr wcel
      vk cv cr wcel cA vx cv cle wbr vx cv vk cv clt wbr cA vk cv cle wbr wi wi
      cA cr wcel vx cv cr wcel vk cv cr wcel w3a cA vx cv cle wbr vx cv vk cv
      clt wbr cA vk cv cle wbr cA cr wcel vx cv cr wcel vk cv cr wcel w3a cA vx
      cv cle wbr vx cv vk cv clt wbr wa cA vk cv clt wbr cA vk cv cle wbr cA vx
      cv vk cv lelttr cA cr wcel vk cv cr wcel cA vk cv clt wbr cA vk cv cle
      wbr wi vx cv cr wcel cA vk cv ltle 3adant2 syld exp3a 3exp com3l imp4b
      com23 vk cv nnre sylan2 r19.22dva mpd cA cr wcel cA vx cv cle wbr wa cA
      vk cv cle wbr vk cn r19.35 sylib r19.23aiv $.
      $( [22-Jan-2008] $) $( [18-Jan-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Supremum on the extended reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Adding minus infinity to a set does not affect the existence of its
       supremum. $)
    xrsupexmnf $p |- ( E. x e. RR* ( A. y e. A -. x < y /\
              A. y e. RR* ( y < x -> E. z e. A y < z ) ) ->
         E. x e. RR* ( A. y e. ( A u. { -oo } ) -. x < y /\
              A. y e. RR* ( y < x -> E. z e. ( A u. { -oo } ) y < z ) ) ) $=
      vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA wrex wi vy cxr wral wa vx cv vy cv clt wbr wn vy cA cmnf csn cun
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA cmnf csn cun wrex wi
      vy cxr wral wa vx cxr vx cv cxr wcel vx cv vy cv clt wbr wn vy cA wral vx
      cv vy cv clt wbr wn vy cA cmnf csn cun wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cxr wral vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA cmnf csn cun wrex wi vy cxr wral vx cv cxr wcel vx cv vy cv clt
      wbr wn vx cv vy cv clt wbr wn vy cA cA cmnf csn cun vx cv cxr wcel vy cv
      cA wcel vx cv vy cv clt wbr wn wi vy cv cA cmnf csn cun wcel vx cv vy cv
      clt wbr wn wi vx cv cxr wcel vy cv cA wcel vx cv vy cv clt wbr wn wi wa
      vy cv cA wcel vy cv cmnf csn wcel wo vx cv vy cv clt wbr wn vy cv cA cmnf
      csn cun wcel vx cv cxr wcel vy cv cA wcel vx cv vy cv clt wbr wn wi wa vy
      cv cA wcel vx cv vy cv clt wbr wn vy cv cmnf csn wcel vx cv cxr wcel vy
      cv cA wcel vx cv vy cv clt wbr wn wi pm3.27 vx cv cxr wcel vy cv cmnf csn
      wcel vx cv vy cv clt wbr wn wi vy cv cA wcel vx cv vy cv clt wbr wn wi vx
      cv cxr wcel vy cv cmnf wceq vx cv vy cv clt wbr wn vy cv cmnf csn wcel vy
      cv cmnf wceq vx cv vy cv clt wbr wn vx cv cmnf clt wbr wn vx cv cxr wcel
      vy cv cmnf wceq vx cv vy cv clt wbr vx cv cmnf clt wbr vy cv cmnf vx cv
      clt breq2 notbid vx cv nltmnf syl5cbir vy cmnf elsn syl5ib adantr jaod vy
      cv cA cmnf csn elun syl5ib ex r19.20dv2 vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA cmnf csn cun wrex wi vy cxr wral wi vx cv cxr wcel vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA wrex wi vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA cmnf csn cun wrex wi vy cxr vy cv vz cv clt wbr vz cA wrex vy
      cv vz cv clt wbr vz cA cmnf csn cun wrex vy cv vx cv clt wbr vy cv vz cv
      clt wbr vy cv vz cv clt wbr vz cA cA cmnf csn cun vz cv cA wcel vz cv cA
      cmnf csn cun wcel vy cv vz cv clt wbr vz cv cA cmnf csn elun1 anim1i
      r19.22i2 imim2i r19.20si a1i anim12d r19.22i $.
      $( [9-Dec-2005] $) $( [26-Oct-2005] $)

    $( Adding plus infinity to a set does not affect the existence of its
       infimum. $)
    xrinfmexpnf $p |- ( E. x e. RR* ( A. y e. A -. y < x /\
              A. y e. RR* ( x < y -> E. z e. A z < y ) ) ->
         E. x e. RR* ( A. y e. ( A u. { +oo } ) -. y < x /\
              A. y e. RR* ( x < y -> E. z e. ( A u. { +oo } ) z < y ) ) ) $=
      vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr
      vz cA wrex wi vy cxr wral wa vy cv vx cv clt wbr wn vy cA cpnf csn cun
      wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA cpnf csn cun wrex wi
      vy cxr wral wa vx cxr vx cv cxr wcel vy cv vx cv clt wbr wn vy cA wral vy
      cv vx cv clt wbr wn vy cA cpnf csn cun wral vx cv vy cv clt wbr vz cv vy
      cv clt wbr vz cA wrex wi vy cxr wral vx cv vy cv clt wbr vz cv vy cv clt
      wbr vz cA cpnf csn cun wrex wi vy cxr wral vx cv cxr wcel vy cv vx cv clt
      wbr wn vy cv vx cv clt wbr wn vy cA cA cpnf csn cun vx cv cxr wcel vy cv
      cA wcel vy cv vx cv clt wbr wn wi vy cv cA cpnf csn cun wcel vy cv vx cv
      clt wbr wn wi vx cv cxr wcel vy cv cA wcel vy cv vx cv clt wbr wn wi wa
      vy cv cA wcel vy cv cpnf csn wcel wo vy cv vx cv clt wbr wn vy cv cA cpnf
      csn cun wcel vx cv cxr wcel vy cv cA wcel vy cv vx cv clt wbr wn wi wa vy
      cv cA wcel vy cv vx cv clt wbr wn vy cv cpnf csn wcel vx cv cxr wcel vy
      cv cA wcel vy cv vx cv clt wbr wn wi pm3.27 vx cv cxr wcel vy cv cpnf csn
      wcel vy cv vx cv clt wbr wn wi vy cv cA wcel vy cv vx cv clt wbr wn wi vx
      cv cxr wcel vy cv cpnf wceq vy cv vx cv clt wbr wn vy cv cpnf csn wcel vy
      cv cpnf wceq vy cv vx cv clt wbr wn cpnf vx cv clt wbr wn vx cv cxr wcel
      vy cv cpnf wceq vy cv vx cv clt wbr cpnf vx cv clt wbr vy cv cpnf vx cv
      clt breq1 notbid vx cv pnfnlt syl5cbir vy cpnf elsn syl5ib adantr jaod vy
      cv cA cpnf csn elun syl5ib ex r19.20dv2 vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cxr wral vx cv vy cv clt wbr vz cv vy cv clt wbr
      vz cA cpnf csn cun wrex wi vy cxr wral wi vx cv cxr wcel vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vx cv vy cv clt wbr vz cv vy cv clt
      wbr vz cA cpnf csn cun wrex wi vy cxr vz cv vy cv clt wbr vz cA wrex vz
      cv vy cv clt wbr vz cA cpnf csn cun wrex vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cv vy cv clt wbr vz cA cA cpnf csn cun vz cv cA wcel vz cv cA
      cpnf csn cun wcel vz cv vy cv clt wbr vz cv cA cpnf csn elun1 anim1i
      r19.22i2 imim2i r19.20si a1i anim12d r19.22i $.
      $( [30-Jan-2006] $) $( [19-Jan-2006] $)

    $( Lemma for ~ xrsupss . $)
    xrsupsslem $p |- ( ( A C_ RR* /\ ( A C_ RR \/ +oo e. A ) ) -> E. x e. RR*
        ( A. y e. A -. x < y /\ A. y e. RR* ( y < x -> E. z e. A y < z ) ) ) $=
      cA cxr wss cA cr wss vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cpnf cA
      wcel cA cr wss vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy
      cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cxr wss cA
      cr wss vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex vx cv vy cv clt wbr wn
      vy c0 wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy cxr
      wral wa vx cxr wrex cA c0 cA c0 wceq vx cv vy cv clt wbr wn vy cA wral vy
      cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cv
      vy cv clt wbr wn vy c0 wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz c0
      wrex wi vy cxr wral wa vx cxr cA c0 wceq vx cv vy cv clt wbr wn vy cA
      wral vx cv vy cv clt wbr wn vy c0 wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz c0 wrex wi vy cxr wral vx cv vy cv clt wbr wn vy cA c0 raleq1 cA c0
      wceq vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy cxr cA c0 wceq vy cv vz cv
      clt wbr vz cA wrex vy cv vz cv clt wbr vz c0 wrex vy cv vx cv clt wbr vy
      cv vz cv clt wbr vz cA c0 rexeq1 imbi2d ralbidv anbi12d rexbidv cA cr wss
      cA c0 wne wa vy cv vx cv cle wbr vy cA wral vx cr wrex vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cxr wral wa vx cxr wrex cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA
      wral vx cr wrex vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy
      cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cr wss cA c0
      wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv vy cv clt wbr wn
      vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr
      wral wa vx cxr wrex vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cr wss cA
      c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv vy cv clt wbr
      wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr
      wral wa vx cr wrex vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cxr wrex vx vy vz cA
      sup3 vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cr wral wa vx cv vy cv clt wbr wn vy cA wral vy
      cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr
      cxr vx cv cr wcel vx cv cxr wcel vx cv vy cv clt wbr wn vy cA wral vy cv
      vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cv rexr
      anim1i r19.22i2 syl cA cr wss cA c0 wne vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx
      cxr wrex vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex wi vy cv vx cv cle
      wbr vy cA wral vx cr wrex cA cr wss cA c0 wne wa vx cv vy cv clt wbr wn
      vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr
      wral wa vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral wa vx cxr cA cr wss cA c0 wne wa vx cv
      cxr wcel wa vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral vx
      cv vy cv clt wbr wn vy cA wral cA cr wss cA c0 wne wa vx cv cxr wcel wa
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA wrex wi vy cr cxr cA cr wss cA c0 wne wa vx cv
      cxr wcel wa vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi wi vy cv cxr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi wi cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cr wcel vy cv
      vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi wa vy cv cr wcel vy cv
      cpnf wceq vy cv cmnf wceq w3o vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA wrex wi vy cv cxr wcel cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv
      cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi wa vy cv
      cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv cpnf
      wceq vy cv cmnf wceq cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cr
      wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi pm3.27 vx
      cv cxr wcel vy cv cpnf wceq vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi wi cA cr wss cA c0 wne wa vy cv cr wcel vy cv vx cv clt wbr vy cv
      vz cv clt wbr vz cA wrex wi wi vx cv cxr wcel vy cv cpnf wceq vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vx cv cxr wcel vy cv cpnf wceq
      wa vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex vx cv cxr wcel vy
      cv cpnf wceq wa vy cv vx cv clt wbr wn cpnf vx cv clt wbr wn vx cv cxr
      wcel cpnf vx cv clt wbr wn vy cv cpnf wceq vx cv pnfnlt adantr vy cv cpnf
      wceq vy cv vx cv clt wbr wn cpnf vx cv clt wbr wn wb vx cv cxr wcel vy cv
      cpnf wceq vy cv vx cv clt wbr cpnf vx cv clt wbr vy cv cpnf vx cv clt
      breq1 notbid adantl mpbird pm2.21d ex ad2antlr cA cr wss cA c0 wne wa vx
      cv cxr wcel wa vy cv cmnf wceq vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA wrex wi wi vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi wi cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cmnf wceq vy cv
      vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi cA cr wss cA c0 wne wa vx
      cv cxr wcel wa vy cv cmnf wceq wa vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA wrex wi cmnf vx cv clt wbr cmnf vz cv clt wbr vz cA wrex wi cA cr
      wss cA c0 wne wa cmnf vx cv clt wbr cmnf vz cv clt wbr vz cA wrex wi vx
      cv cxr wcel vy cv cmnf wceq cA cr wss cA c0 wne wa cmnf vz cv clt wbr vz
      cA wrex cmnf vx cv clt wbr cA cr wss cA c0 wne cmnf vz cv clt wbr vz cA
      wrex cA cr wss vz cv cA wcel vz wex vz cv cA wcel cmnf vz cv clt wbr wa
      vz wex cA c0 wne cmnf vz cv clt wbr vz cA wrex cA cr wss vz cv cA wcel vz
      cv cA wcel cmnf vz cv clt wbr wa vz cA cr wss vz cv cA wcel cmnf vz cv
      clt wbr cA cr wss vz cv cA wcel vz cv cr wcel cmnf vz cv clt wbr cA cr vz
      cv ssel vz cv mnflt syl6 ancld 19.22dv vz cA n0 cmnf vz cv clt wbr vz cA
      df-rex 3imtr4g imp a1d ad2antrr vy cv cmnf wceq vy cv vx cv clt wbr vy cv
      vz cv clt wbr vz cA wrex wi cmnf vx cv clt wbr cmnf vz cv clt wbr vz cA
      wrex wi wb cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cmnf wceq vy cv
      vx cv clt wbr cmnf vx cv clt wbr vy cv vz cv clt wbr vz cA wrex cmnf vz
      cv clt wbr vz cA wrex vy cv cmnf vx cv clt breq1 vy cv cmnf wceq vy cv vz
      cv clt wbr cmnf vz cv clt wbr vz cA vy cv cmnf vz cv clt breq1 rexbidv
      imbi12d adantl mpbird ex adantr 3jaod vy cv elxr syl5ib ex r19.20dv2
      anim2d r19.22dva 3adant3 mpd 3expa cA cr wss vy cv vx cv cle wbr vy cA
      wral vx cr wrex wn vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA c0 wne cA
      cr wss vy cv vx cv cle wbr vy cA wral vx cr wrex wn vx cv vz cv cle wbr
      vz cA wrex vx cr wral vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cr
      wss vy cv vx cv cle wbr vy cA wral vx cr wrex wn wa vx cv vy cv cle wbr
      vy cA wrex vx cr wral vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss
      vy cv vx cv cle wbr vy cA wral wn vx cr wral vx cv vy cv cle wbr vy cA
      wrex vx cr wral vy cv vx cv cle wbr vy cA wral vx cr wrex wn cA cr wss vy
      cv vx cv cle wbr vy cA wral wn vx cr wral vx cv vy cv cle wbr vy cA wrex
      vx cr wral cA cr wss vy cv vx cv cle wbr vy cA wral wn vx cv vy cv cle
      wbr vy cA wrex vx cr cA cr wss vx cv cr wcel wa vy cv vx cv cle wbr wn vy
      cA wrex vx cv vy cv cle wbr vy cA wrex vy cv vx cv cle wbr vy cA wral wn
      cA cr wss vx cv cr wcel wa vy cv vx cv cle wbr wn vx cv vy cv cle wbr vy
      cA cA cr wss vy cv cA wcel vx cv cr wcel vy cv vx cv cle wbr wn vx cv vy
      cv cle wbr wi vy cv cr wcel vx cv cr wcel vy cv vx cv cle wbr wn vx cv vy
      cv cle wbr wi cA cr wss vy cv cA wcel wa vy cv cr wcel vx cv cr wcel wa
      vy cv vx cv cle wbr vx cv vy cv cle wbr vy cv vx cv letric ord cA cr vy
      cv ssel2 sylan an1rs r19.22dva vy cv vx cv cle wbr vy cA rexnal syl5ibr
      r19.20dva imp vy cv vx cv cle wbr vy cA wral vx cr ralnex sylan2br vx cv
      vy cv cle wbr vy cA wrex vx cv vz cv cle wbr vz cA wrex vx cr vx cv vy cv
      cle wbr vx cv vz cv cle wbr vy vz cA vy cv vz cv vx cv cle breq2 cbvrexv
      ralbii sylib cpnf cxr wcel cpnf vy cv clt wbr wn vy cA wral vy cv cpnf
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cxr wral wa vx cxr wrex cA cr wss vx cv vz cv cle wbr vz cA wrex vx cr
      wral wa vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral wa cpnf vy cv clt wbr wn vy cA wral vy
      cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cpnf
      cxr vx cv cpnf wceq vx cv vy cv clt wbr wn vy cA wral cpnf vy cv clt wbr
      wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy
      cxr wral vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral
      vx cv cpnf wceq vx cv vy cv clt wbr wn cpnf vy cv clt wbr wn vy cA vx cv
      cpnf wceq vx cv vy cv clt wbr cpnf vy cv clt wbr vx cv cpnf vy cv clt
      breq1 notbid ralbidv vx cv cpnf wceq vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA wrex wi vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy
      cxr vx cv cpnf wceq vy cv vx cv clt wbr vy cv cpnf clt wbr vy cv vz cv
      clt wbr vz cA wrex vx cv cpnf vy cv clt breq2 imbi1d ralbidv anbi12d
      rcla4ev pnfxr cA cr wss vx cv vz cv cle wbr vz cA wrex vx cr wral wa cpnf
      vy cv clt wbr wn vy cA wral vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cxr wral cA cr wss cpnf vy cv clt wbr wn vy cA wral vx cv vz
      cv cle wbr vz cA wrex vx cr wral cA cr wss cpnf vy cv clt wbr wn vy cA cA
      cr wss vy cv cA wcel vy cv cr wcel cpnf vy cv clt wbr wn cA cr vy cv ssel
      vy cv cr wcel vy cv cxr wcel cpnf vy cv clt wbr wn vy cv rexr vy cv
      pnfnlt syl syl6 r19.21aiv adantr cA cr wss vx cv vz cv cle wbr vz cA wrex
      vx cr wral wa vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr
      cA cr wss vx cv vz cv cle wbr vz cA wrex vx cr wral vy cv cxr wcel vy cv
      cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi wi vy cv cxr wcel vx cv vz
      cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv cpnf clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cv cxr wcel vy cv cr wcel vy cv cpnf wceq vy cv
      cmnf wceq w3o vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv
      cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi wi wi vy cv elxr vy cv cr
      wcel vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv cpnf clt
      wbr vy cv vz cv clt wbr vz cA wrex wi wi wi vy cv cpnf wceq vy cv cmnf
      wceq vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv cpnf clt
      wbr vy cv cr wcel vy cv vz cv clt wbr vz cA wrex vx cv vz cv cle wbr vz
      cA wrex vx cr wral cA cr wss vy cv cr wcel vy cv vz cv clt wbr vz cA wrex
      wi vy cv cpnf clt wbr vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss
      vy cv cr wcel vy cv vz cv clt wbr vz cA wrex vx cv vz cv cle wbr vz cA
      wrex vx cr wral cA cr wss wa vy cv cr wcel wa vy cv c1 caddc co vz cv cle
      wbr vz cA wrex vy cv vz cv clt wbr vz cA wrex vx cv vz cv cle wbr vz cA
      wrex vx cr wral cA cr wss wa vy cv c1 caddc co cr wcel vy cv c1 caddc co
      vz cv cle wbr vz cA wrex vy cv cr wcel vy cv c1 caddc co cr wcel vx cv vz
      cv cle wbr vz cA wrex vx cr wral cA cr wss wa vy cv c1 caddc co vz cv cle
      wbr vz cA wrex vy cv c1 caddc co cr wcel vx cv vz cv cle wbr vz cA wrex
      vx cr wral vy cv c1 caddc co vz cv cle wbr vz cA wrex cA cr wss vx cv vz
      cv cle wbr vz cA wrex vy cv c1 caddc co vz cv cle wbr vz cA wrex vx vy cv
      c1 caddc co cr vx cv vy cv c1 caddc co wceq vx cv vz cv cle wbr vy cv c1
      caddc co vz cv cle wbr vz cA vx cv vy cv c1 caddc co vz cv cle breq1
      rexbidv rcla4va adantrr ancoms vy cv peano2re sylan2 cA cr wss vy cv cr
      wcel vy cv c1 caddc co vz cv cle wbr vz cA wrex vy cv vz cv clt wbr vz cA
      wrex wi vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv cr wcel
      wa vy cv c1 caddc co vz cv cle wbr vy cv vz cv clt wbr vz cA cA cr wss vz
      cv cA wcel vy cv cr wcel vy cv c1 caddc co vz cv cle wbr vy cv vz cv clt
      wbr wi vz cv cr wcel vy cv cr wcel vy cv c1 caddc co vz cv cle wbr vy cv
      vz cv clt wbr wi cA cr wss vz cv cA wcel wa vy cv cr wcel vz cv cr wcel
      vy cv c1 caddc co vz cv cle wbr vy cv vz cv clt wbr wi vy cv cr wcel vz
      cv cr wcel wa vy cv vy cv c1 caddc co clt wbr vy cv c1 caddc co vz cv cle
      wbr vy cv vz cv clt wbr vy cv cr wcel vy cv vy cv c1 caddc co clt wbr vz
      cv cr wcel vy cv ltp1 adantr vy cv cr wcel vy cv c1 caddc co cr wcel wa
      vz cv cr wcel vy cv vy cv c1 caddc co clt wbr vy cv c1 caddc co vz cv cle
      wbr wa vy cv vz cv clt wbr wi vy cv cr wcel vy cv cr wcel vy cv c1 caddc
      co cr wcel vz cv cr wcel vy cv vy cv c1 caddc co clt wbr vy cv c1 caddc
      co vz cv cle wbr wa vy cv vz cv clt wbr wi vy cv vy cv c1 caddc co vz cv
      ltletr 3expa vy cv cr wcel vy cv c1 caddc co cr wcel vy cv peano2re ancli
      sylan mpand ancoms cA cr vz cv ssel2 sylan an1rs r19.22dva adantll mpd
      exp31 a1dd com4r vy cv cpnf wceq cA cr wss vy cv cpnf clt wbr vy cv vz cv
      clt wbr vz cA wrex wi wi vx cv vz cv cle wbr vz cA wrex vx cr wral vy cv
      cpnf wceq vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi cA cr wss
      vy cv cpnf wceq vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex vy cv
      cpnf wceq vy cv cpnf clt wbr cpnf cpnf clt wbr cpnf cxr wcel cpnf cpnf
      clt wbr wn pnfxr cpnf xrltnr ax-mp vy cv cpnf cpnf clt breq1 mtbiri
      pm2.21d a1d a1d vy cv cmnf wceq vx cv vz cv cle wbr vz cA wrex vx cr wral
      cA cr wss vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv cmnf
      wceq vx cv vz cv cle wbr vz cA wrex vx cr wral cA cr wss wa vy cv vz cv
      clt wbr vz cA wrex vy cv cpnf clt wbr vy cv cmnf wceq vy cv vz cv clt wbr
      vz cA wrex cmnf vz cv clt wbr vz cA wrex vx cv vz cv cle wbr vz cA wrex
      vx cr wral cA cr wss wa vy cv cmnf wceq vy cv vz cv clt wbr cmnf vz cv
      clt wbr vz cA vy cv cmnf vz cv clt breq1 rexbidv cc0 vz cv cle wbr vz cA
      wrex cA cr wss cmnf vz cv clt wbr vz cA wrex vx cv vz cv cle wbr vz cA
      wrex vx cr wral cA cr wss cc0 vz cv cle wbr vz cA wrex cmnf vz cv clt wbr
      vz cA wrex cA cr wss cc0 vz cv cle wbr cmnf vz cv clt wbr vz cA cA cr wss
      vz cv cA wcel wa cmnf vz cv clt wbr cc0 vz cv cle wbr cA cr wss vz cv cA
      wcel wa vz cv cr wcel cmnf vz cv clt wbr cA cr vz cv ssel2 vz cv mnflt
      syl a1d r19.22dva impcom cc0 cr wcel vx cv vz cv cle wbr vz cA wrex vx cr
      wral cc0 vz cv cle wbr vz cA wrex 0re vx cv vz cv cle wbr vz cA wrex cc0
      vz cv cle wbr vz cA wrex vx cc0 cr vx cv cc0 wceq vx cv vz cv cle wbr cc0
      vz cv cle wbr vz cA vx cv cc0 vz cv cle breq1 rexbidv rcla4va mpan sylan
      syl5bir a1dd exp3a 3jaoi sylbi com13 imp r19.21aiv jca sylancr syldan
      adantlr pm2.61dan vx cv vy cv clt wbr wn vy c0 wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz c0 wrex wi vy cxr wral wa vx cxr wrex cA cr wss
      cmnf cxr wcel cmnf vy cv clt wbr wn vy c0 wral vy cv cmnf clt wbr vy cv
      vz cv clt wbr vz c0 wrex wi vy cxr wral wa vx cv vy cv clt wbr wn vy c0
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy cxr wral wa
      vx cxr wrex mnfxr cmnf vy cv clt wbr wn vy c0 wral vy cv cmnf clt wbr vy
      cv vz cv clt wbr vz c0 wrex wi vy cxr wral cmnf vy cv clt wbr wn vy ral0
      vy cv cmnf clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy cxr vy cv cxr
      wcel vy cv cmnf clt wbr vy cv vz cv clt wbr vz c0 wrex vy cv nltmnf
      pm2.21d rgen pm3.2i vx cv vy cv clt wbr wn vy c0 wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz c0 wrex wi vy cxr wral wa cmnf vy cv clt wbr wn vy
      c0 wral vy cv cmnf clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy cxr wral
      wa vx cmnf cxr vx cv cmnf wceq vx cv vy cv clt wbr wn vy c0 wral cmnf vy
      cv clt wbr wn vy c0 wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz c0
      wrex wi vy cxr wral vy cv cmnf clt wbr vy cv vz cv clt wbr vz c0 wrex wi
      vy cxr wral vx cv cmnf wceq vx cv vy cv clt wbr wn cmnf vy cv clt wbr wn
      vy c0 vx cv cmnf wceq vx cv vy cv clt wbr cmnf vy cv clt wbr vx cv cmnf
      vy cv clt breq1 notbid ralbidv vx cv cmnf wceq vy cv vx cv clt wbr vy cv
      vz cv clt wbr vz c0 wrex wi vy cv cmnf clt wbr vy cv vz cv clt wbr vz c0
      wrex wi vy cxr vx cv cmnf wceq vy cv vx cv clt wbr vy cv cmnf clt wbr vy
      cv vz cv clt wbr vz c0 wrex vx cv cmnf vy cv clt breq2 imbi1d ralbidv
      anbi12d rcla4ev mp2an a1i pm2.61ne adantl cpnf cxr wcel cpnf vy cv clt
      wbr wn vy cA wral vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy
      cxr wral wa vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv
      vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cxr wss cpnf cA
      wcel wa vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral wa cpnf vy cv clt wbr wn vy cA wral vy
      cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cpnf
      cxr vx cv cpnf wceq vx cv vy cv clt wbr wn vy cA wral cpnf vy cv clt wbr
      wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy
      cxr wral vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral
      vx cv cpnf wceq vx cv vy cv clt wbr wn cpnf vy cv clt wbr wn vy cA vx cv
      cpnf wceq vx cv vy cv clt wbr cpnf vy cv clt wbr vx cv cpnf vy cv clt
      breq1 notbid ralbidv vx cv cpnf wceq vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA wrex wi vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy
      cxr vx cv cpnf wceq vy cv vx cv clt wbr vy cv cpnf clt wbr vy cv vz cv
      clt wbr vz cA wrex vx cv cpnf vy cv clt breq2 imbi1d ralbidv anbi12d
      rcla4ev pnfxr cA cxr wss cpnf vy cv clt wbr wn vy cA wral cpnf cA wcel vy
      cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral cA cxr wss
      cpnf vy cv clt wbr wn vy cA cA cxr wss vy cv cA wcel vy cv cxr wcel cpnf
      vy cv clt wbr wn cA cxr vy cv ssel vy cv pnfnlt syl6 r19.21aiv cpnf cA
      wcel vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr cpnf cA
      wcel vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv cxr wcel
      cpnf cA wcel vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex vy cv vz
      cv clt wbr vy cv cpnf clt wbr vz cpnf cA vz cv cpnf vy cv clt breq2
      rcla4ev ex a1d r19.21aiv anim12i sylancr jaodan $.
      $( [19-Jan-2006] $) $( [25-Oct-2005] $)

    $( Lemma for ~ xrinfmss . $)
    xrinfmsslem $p |- ( ( A C_ RR* /\ ( A C_ RR \/ -oo e. A ) ) -> E. x e. RR*
        ( A. y e. A -. y < x /\ A. y e. RR* ( x < y -> E. z e. A z < y ) ) ) $=
      cA cxr wss cA cr wss vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cmnf cA
      wcel cA cr wss vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz
      cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cxr wss cA
      cr wss vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex vy cv vx cv clt wbr wn
      vy c0 wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz c0 wrex wi vy cxr
      wral wa vx cxr wrex cA c0 cA c0 wceq vy cv vx cv clt wbr wn vy cA wral vx
      cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vy cv
      vx cv clt wbr wn vy c0 wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz c0
      wrex wi vy cxr wral wa vx cxr cA c0 wceq vy cv vx cv clt wbr wn vy cA
      wral vy cv vx cv clt wbr wn vy c0 wral vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cxr wral vx cv vy cv clt wbr vz cv vy cv clt wbr
      vz c0 wrex wi vy cxr wral vy cv vx cv clt wbr wn vy cA c0 raleq1 cA c0
      wceq vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vx cv vy cv
      clt wbr vz cv vy cv clt wbr vz c0 wrex wi vy cxr cA c0 wceq vz cv vy cv
      clt wbr vz cA wrex vz cv vy cv clt wbr vz c0 wrex vx cv vy cv clt wbr vz
      cv vy cv clt wbr vz cA c0 rexeq1 imbi2d ralbidv anbi12d rexbidv cA cr wss
      cA c0 wne wa vx cv vy cv cle wbr vy cA wral vx cr wrex vy cv vx cv clt
      wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi
      vy cxr wral wa vx cxr wrex cA cr wss cA c0 wne vx cv vy cv cle wbr vy cA
      wral vx cr wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz
      cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cr wss cA c0
      wne vx cv vy cv cle wbr vy cA wral vx cr wrex w3a vy cv vx cv clt wbr wn
      vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr
      wral wa vx cxr wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cr wss cA
      c0 wne vx cv vy cv cle wbr vy cA wral vx cr wrex w3a vy cv vx cv clt wbr
      wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr
      wral wa vx cr wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi vy cr wral wa vx cxr wrex vx vy vz cA
      infm3 vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cr wral wa vy cv vx cv clt wbr wn vy cA wral vx
      cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral wa vx cr
      cxr vx cv cr wcel vx cv cxr wcel vy cv vx cv clt wbr wn vy cA wral vx cv
      vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral wa vx cv rexr
      anim1i r19.22i2 syl cA cr wss cA c0 wne vy cv vx cv clt wbr wn vy cA wral
      vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr wral wa vx
      cxr wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy
      cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex wi vx cv vy cv cle
      wbr vy cA wral vx cr wrex cA cr wss cA c0 wne wa vy cv vx cv clt wbr wn
      vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr
      wral wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cxr wral wa vx cxr cA cr wss cA c0 wne wa vx cv
      cxr wcel wa vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cr
      wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral vy
      cv vx cv clt wbr wn vy cA wral cA cr wss cA c0 wne wa vx cv cxr wcel wa
      vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi vy cr cxr cA cr wss cA c0 wne wa vx cv
      cxr wcel wa vy cv cr wcel vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi wi vy cv cxr wcel vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi wi cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cr wcel vx cv
      vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi wa vy cv cr wcel vy cv
      cpnf wceq vy cv cmnf wceq w3o vx cv vy cv clt wbr vz cv vy cv clt wbr vz
      cA wrex wi vy cv cxr wcel cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv
      cr wcel vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi wa vy cv
      cr wcel vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cv cpnf
      wceq vy cv cmnf wceq cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cr
      wcel vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi pm3.27 cA
      cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cpnf wceq vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi wi vy cv cr wcel vx cv vy cv clt wbr vz
      cv vy cv clt wbr vz cA wrex wi wi cA cr wss cA c0 wne wa vx cv cxr wcel
      wa vy cv cpnf wceq vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi
      cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cpnf wceq wa vx cv vy cv
      clt wbr vz cv vy cv clt wbr vz cA wrex wi vx cv cpnf clt wbr vz cv cpnf
      clt wbr vz cA wrex wi cA cr wss cA c0 wne wa vx cv cpnf clt wbr vz cv
      cpnf clt wbr vz cA wrex wi vx cv cxr wcel vy cv cpnf wceq cA cr wss cA c0
      wne wa vz cv cpnf clt wbr vz cA wrex vx cv cpnf clt wbr cA cr wss cA c0
      wne vz cv cpnf clt wbr vz cA wrex cA cr wss vz cv cA wcel vz wex vz cv cA
      wcel vz cv cpnf clt wbr wa vz wex cA c0 wne vz cv cpnf clt wbr vz cA wrex
      cA cr wss vz cv cA wcel vz cv cA wcel vz cv cpnf clt wbr wa vz cA cr wss
      vz cv cA wcel vz cv cpnf clt wbr cA cr wss vz cv cA wcel vz cv cr wcel vz
      cv cpnf clt wbr cA cr vz cv ssel vz cv ltpnf syl6 ancld 19.22dv vz cA n0
      vz cv cpnf clt wbr vz cA df-rex 3imtr4g imp a1d ad2antrr vy cv cpnf wceq
      vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vx cv cpnf clt wbr
      vz cv cpnf clt wbr vz cA wrex wi wb cA cr wss cA c0 wne wa vx cv cxr wcel
      wa vy cv cpnf wceq vx cv vy cv clt wbr vx cv cpnf clt wbr vz cv vy cv clt
      wbr vz cA wrex vz cv cpnf clt wbr vz cA wrex vy cv cpnf vx cv clt breq2
      vy cv cpnf wceq vz cv vy cv clt wbr vz cv cpnf clt wbr vz cA vy cv cpnf
      vz cv clt breq2 rexbidv imbi12d adantl mpbird ex adantr vx cv cxr wcel vy
      cv cmnf wceq vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi cA
      cr wss cA c0 wne wa vy cv cr wcel vx cv vy cv clt wbr vz cv vy cv clt wbr
      vz cA wrex wi wi vx cv cxr wcel vy cv cmnf wceq vx cv vy cv clt wbr vz cv
      vy cv clt wbr vz cA wrex wi vx cv cxr wcel vy cv cmnf wceq wa vx cv vy cv
      clt wbr vz cv vy cv clt wbr vz cA wrex vx cv cxr wcel vy cv cmnf wceq wa
      vx cv vy cv clt wbr wn vx cv cmnf clt wbr wn vx cv cxr wcel vx cv cmnf
      clt wbr wn vy cv cmnf wceq vx cv nltmnf adantr vy cv cmnf wceq vx cv vy
      cv clt wbr wn vx cv cmnf clt wbr wn wb vx cv cxr wcel vy cv cmnf wceq vx
      cv vy cv clt wbr vx cv cmnf clt wbr vy cv cmnf vx cv clt breq2 notbid
      adantl mpbird pm2.21d ex ad2antlr 3jaod vy cv elxr syl5ib ex r19.20dv2
      anim2d r19.22dva 3adant3 mpd 3expa cA cr wss vx cv vy cv cle wbr vy cA
      wral vx cr wrex wn vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA c0 wne cA
      cr wss vx cv vy cv cle wbr vy cA wral vx cr wrex wn vz cv vx cv cle wbr
      vz cA wrex vx cr wral vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cr
      wss vx cv vy cv cle wbr vy cA wral vx cr wrex wn wa vy cv vx cv cle wbr
      vy cA wrex vx cr wral vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss
      vx cv vy cv cle wbr vy cA wral wn vx cr wral vy cv vx cv cle wbr vy cA
      wrex vx cr wral vx cv vy cv cle wbr vy cA wral vx cr wrex wn cA cr wss vx
      cv vy cv cle wbr vy cA wral wn vx cr wral vy cv vx cv cle wbr vy cA wrex
      vx cr wral cA cr wss vx cv vy cv cle wbr vy cA wral wn vy cv vx cv cle
      wbr vy cA wrex vx cr cA cr wss vx cv cr wcel wa vx cv vy cv cle wbr wn vy
      cA wrex vy cv vx cv cle wbr vy cA wrex vx cv vy cv cle wbr vy cA wral wn
      cA cr wss vx cv cr wcel wa vx cv vy cv cle wbr wn vy cv vx cv cle wbr vy
      cA cA cr wss vy cv cA wcel vx cv cr wcel vx cv vy cv cle wbr wn vy cv vx
      cv cle wbr wi vy cv cr wcel vx cv cr wcel vx cv vy cv cle wbr wn vy cv vx
      cv cle wbr wi cA cr wss vy cv cA wcel wa vy cv cr wcel vx cv cr wcel wa
      vx cv vy cv cle wbr vy cv vx cv cle wbr vx cv cr wcel vy cv cr wcel vx cv
      vy cv cle wbr vy cv vx cv cle wbr wo vx cv vy cv letric ancoms ord cA cr
      vy cv ssel2 sylan an1rs r19.22dva vx cv vy cv cle wbr vy cA rexnal
      syl5ibr r19.20dva imp vx cv vy cv cle wbr vy cA wral vx cr ralnex
      sylan2br vy cv vx cv cle wbr vy cA wrex vz cv vx cv cle wbr vz cA wrex vx
      cr vy cv vx cv cle wbr vz cv vx cv cle wbr vy vz cA vy cv vz cv vx cv cle
      breq1 cbvrexv ralbii sylib cmnf cxr wcel vy cv cmnf clt wbr wn vy cA wral
      cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vy cv
      vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi vy cxr wral wa vx cxr wrex cA cr wss vz cv vx cv cle wbr vz cA
      wrex vx cr wral wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vy cv cmnf clt wbr wn vy
      cA wral cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral
      wa vx cmnf cxr vx cv cmnf wceq vy cv vx cv clt wbr wn vy cA wral vy cv
      cmnf clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi vy cxr wral cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi
      vy cxr wral vx cv cmnf wceq vy cv vx cv clt wbr wn vy cv cmnf clt wbr wn
      vy cA vx cv cmnf wceq vy cv vx cv clt wbr vy cv cmnf clt wbr vx cv cmnf
      vy cv clt breq2 notbid ralbidv vx cv cmnf wceq vx cv vy cv clt wbr vz cv
      vy cv clt wbr vz cA wrex wi cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi vy cxr vx cv cmnf wceq vx cv vy cv clt wbr cmnf vy cv clt wbr vz
      cv vy cv clt wbr vz cA wrex vx cv cmnf vy cv clt breq1 imbi1d ralbidv
      anbi12d rcla4ev mnfxr cA cr wss vz cv vx cv cle wbr vz cA wrex vx cr wral
      wa vy cv cmnf clt wbr wn vy cA wral cmnf vy cv clt wbr vz cv vy cv clt
      wbr vz cA wrex wi vy cxr wral cA cr wss vy cv cmnf clt wbr wn vy cA wral
      vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv cmnf clt wbr wn
      vy cA cA cr wss vy cv cA wcel vy cv cr wcel vy cv cmnf clt wbr wn cA cr
      vy cv ssel vy cv cr wcel vy cv cxr wcel vy cv cmnf clt wbr wn vy cv rexr
      vy cv nltmnf syl syl6 r19.21aiv adantr cA cr wss vz cv vx cv cle wbr vz
      cA wrex vx cr wral wa cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex
      wi vy cxr cA cr wss vz cv vx cv cle wbr vz cA wrex vx cr wral vy cv cxr
      wcel cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi vy cv cxr
      wcel vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss cmnf vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vy cv cxr wcel vy cv cr wcel vy cv
      cpnf wceq vy cv cmnf wceq w3o vz cv vx cv cle wbr vz cA wrex vx cr wral
      cA cr wss cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi wi vy
      cv elxr vy cv cr wcel vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss
      cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi wi wi vy cv cpnf
      wceq vy cv cmnf wceq vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss
      cmnf vy cv clt wbr vy cv cr wcel vz cv vy cv clt wbr vz cA wrex vz cv vx
      cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv cr wcel vz cv vy cv clt
      wbr vz cA wrex wi cmnf vy cv clt wbr vz cv vx cv cle wbr vz cA wrex vx cr
      wral cA cr wss vy cv cr wcel vz cv vy cv clt wbr vz cA wrex vz cv vx cv
      cle wbr vz cA wrex vx cr wral cA cr wss wa vy cv cr wcel wa vz cv vy cv
      c1 cmin co cle wbr vz cA wrex vz cv vy cv clt wbr vz cA wrex vz cv vx cv
      cle wbr vz cA wrex vx cr wral cA cr wss wa vy cv c1 cmin co cr wcel vz cv
      vy cv c1 cmin co cle wbr vz cA wrex vy cv cr wcel vy cv c1 cmin co cr
      wcel vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss wa vz cv vy cv
      c1 cmin co cle wbr vz cA wrex vy cv c1 cmin co cr wcel vz cv vx cv cle
      wbr vz cA wrex vx cr wral vz cv vy cv c1 cmin co cle wbr vz cA wrex cA cr
      wss vz cv vx cv cle wbr vz cA wrex vz cv vy cv c1 cmin co cle wbr vz cA
      wrex vx vy cv c1 cmin co cr vx cv vy cv c1 cmin co wceq vz cv vx cv cle
      wbr vz cv vy cv c1 cmin co cle wbr vz cA vx cv vy cv c1 cmin co vz cv cle
      breq2 rexbidv rcla4va adantrr ancoms vy cv peano2rem sylan2 cA cr wss vy
      cv cr wcel vz cv vy cv c1 cmin co cle wbr vz cA wrex vz cv vy cv clt wbr
      vz cA wrex wi vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss vy cv
      cr wcel wa vz cv vy cv c1 cmin co cle wbr vz cv vy cv clt wbr vz cA cA cr
      wss vz cv cA wcel vy cv cr wcel vz cv vy cv c1 cmin co cle wbr vz cv vy
      cv clt wbr wi vz cv cr wcel vy cv cr wcel vz cv vy cv c1 cmin co cle wbr
      vz cv vy cv clt wbr wi cA cr wss vz cv cA wcel wa vz cv cr wcel vy cv cr
      wcel wa vz cv vy cv c1 cmin co cle wbr vy cv c1 cmin co vy cv clt wbr vz
      cv vy cv clt wbr vy cv cr wcel vy cv c1 cmin co vy cv clt wbr vz cv cr
      wcel vy cv ltm1 adantl vz cv cr wcel vy cv c1 cmin co cr wcel vy cv cr
      wcel wa vz cv vy cv c1 cmin co cle wbr vy cv c1 cmin co vy cv clt wbr wa
      vz cv vy cv clt wbr wi vy cv cr wcel vz cv cr wcel vy cv c1 cmin co cr
      wcel vy cv cr wcel vz cv vy cv c1 cmin co cle wbr vy cv c1 cmin co vy cv
      clt wbr wa vz cv vy cv clt wbr wi vz cv vy cv c1 cmin co vy cv lelttr
      3expb vy cv cr wcel vy cv c1 cmin co cr wcel vy cv peano2rem ancri sylan2
      mpan2d cA cr vz cv ssel2 sylan an1rs r19.22dva adantll mpd exp31 a1dd
      com4r vy cv cpnf wceq vz cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss
      cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cv cpnf wceq vz
      cv vx cv cle wbr vz cA wrex vx cr wral cA cr wss wa vz cv vy cv clt wbr
      vz cA wrex cmnf vy cv clt wbr vy cv cpnf wceq vz cv vy cv clt wbr vz cA
      wrex vz cv cpnf clt wbr vz cA wrex vz cv vx cv cle wbr vz cA wrex vx cr
      wral cA cr wss wa vy cv cpnf wceq vz cv vy cv clt wbr vz cv cpnf clt wbr
      vz cA vy cv cpnf vz cv clt breq2 rexbidv vz cv cc0 cle wbr vz cA wrex cA
      cr wss vz cv cpnf clt wbr vz cA wrex vz cv vx cv cle wbr vz cA wrex vx cr
      wral cA cr wss vz cv cc0 cle wbr vz cA wrex vz cv cpnf clt wbr vz cA wrex
      cA cr wss vz cv cc0 cle wbr vz cv cpnf clt wbr vz cA cA cr wss vz cv cA
      wcel wa vz cv cpnf clt wbr vz cv cc0 cle wbr cA cr wss vz cv cA wcel wa
      vz cv cr wcel vz cv cpnf clt wbr cA cr vz cv ssel2 vz cv ltpnf syl a1d
      r19.22dva impcom cc0 cr wcel vz cv vx cv cle wbr vz cA wrex vx cr wral vz
      cv cc0 cle wbr vz cA wrex 0re vz cv vx cv cle wbr vz cA wrex vz cv cc0
      cle wbr vz cA wrex vx cc0 cr vx cv cc0 wceq vz cv vx cv cle wbr vz cv cc0
      cle wbr vz cA vx cv cc0 vz cv cle breq2 rexbidv rcla4va mpan sylan
      syl5bir a1dd exp3a vy cv cmnf wceq cA cr wss cmnf vy cv clt wbr vz cv vy
      cv clt wbr vz cA wrex wi wi vz cv vx cv cle wbr vz cA wrex vx cr wral vy
      cv cmnf wceq cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi cA cr
      wss vy cv cmnf wceq cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex vy
      cv cmnf wceq cmnf vy cv clt wbr cmnf cmnf clt wbr cmnf cxr wcel cmnf cmnf
      clt wbr wn mnfxr cmnf xrltnr ax-mp vy cv cmnf cmnf clt breq2 mtbiri
      pm2.21d a1d a1d 3jaoi sylbi com13 imp r19.21aiv jca sylancr syldan
      adantlr pm2.61dan vy cv vx cv clt wbr wn vy c0 wral vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz c0 wrex wi vy cxr wral wa vx cxr wrex cA cr wss
      cpnf cxr wcel vy cv cpnf clt wbr wn vy c0 wral cpnf vy cv clt wbr vz cv
      vy cv clt wbr vz c0 wrex wi vy cxr wral wa vy cv vx cv clt wbr wn vy c0
      wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz c0 wrex wi vy cxr wral wa
      vx cxr wrex pnfxr vy cv cpnf clt wbr wn vy c0 wral cpnf vy cv clt wbr vz
      cv vy cv clt wbr vz c0 wrex wi vy cxr wral vy cv cpnf clt wbr wn vy ral0
      cpnf vy cv clt wbr vz cv vy cv clt wbr vz c0 wrex wi vy cxr vy cv cxr
      wcel cpnf vy cv clt wbr vz cv vy cv clt wbr vz c0 wrex vy cv pnfnlt
      pm2.21d rgen pm3.2i vy cv vx cv clt wbr wn vy c0 wral vx cv vy cv clt wbr
      vz cv vy cv clt wbr vz c0 wrex wi vy cxr wral wa vy cv cpnf clt wbr wn vy
      c0 wral cpnf vy cv clt wbr vz cv vy cv clt wbr vz c0 wrex wi vy cxr wral
      wa vx cpnf cxr vx cv cpnf wceq vy cv vx cv clt wbr wn vy c0 wral vy cv
      cpnf clt wbr wn vy c0 wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz c0
      wrex wi vy cxr wral cpnf vy cv clt wbr vz cv vy cv clt wbr vz c0 wrex wi
      vy cxr wral vx cv cpnf wceq vy cv vx cv clt wbr wn vy cv cpnf clt wbr wn
      vy c0 vx cv cpnf wceq vy cv vx cv clt wbr vy cv cpnf clt wbr vx cv cpnf
      vy cv clt breq2 notbid ralbidv vx cv cpnf wceq vx cv vy cv clt wbr vz cv
      vy cv clt wbr vz c0 wrex wi cpnf vy cv clt wbr vz cv vy cv clt wbr vz c0
      wrex wi vy cxr vx cv cpnf wceq vx cv vy cv clt wbr cpnf vy cv clt wbr vz
      cv vy cv clt wbr vz c0 wrex vx cv cpnf vy cv clt breq1 imbi1d ralbidv
      anbi12d rcla4ev mp2an a1i pm2.61ne adantl cmnf cxr wcel vy cv cmnf clt
      wbr wn vy cA wral cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy
      cxr wral wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv
      vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cxr wss cmnf cA
      wcel wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cxr wral wa vy cv cmnf clt wbr wn vy cA wral
      cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx
      cmnf cxr vx cv cmnf wceq vy cv vx cv clt wbr wn vy cA wral vy cv cmnf clt
      wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi
      vy cxr wral cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr
      wral vx cv cmnf wceq vy cv vx cv clt wbr wn vy cv cmnf clt wbr wn vy cA
      vx cv cmnf wceq vy cv vx cv clt wbr vy cv cmnf clt wbr vx cv cmnf vy cv
      clt breq2 notbid ralbidv vx cv cmnf wceq vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex
      wi vy cxr vx cv cmnf wceq vx cv vy cv clt wbr cmnf vy cv clt wbr vz cv vy
      cv clt wbr vz cA wrex vx cv cmnf vy cv clt breq1 imbi1d ralbidv anbi12d
      rcla4ev mnfxr cA cxr wss vy cv cmnf clt wbr wn vy cA wral cmnf cA wcel
      cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral cA cxr
      wss vy cv cmnf clt wbr wn vy cA cA cxr wss vy cv cA wcel vy cv cxr wcel
      vy cv cmnf clt wbr wn cA cxr vy cv ssel vy cv nltmnf syl6 r19.21aiv cmnf
      cA wcel cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr cmnf
      cA wcel cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cv cxr
      wcel cmnf cA wcel cmnf vy cv clt wbr vz cv vy cv clt wbr vz cA wrex vz cv
      vy cv clt wbr cmnf vy cv clt wbr vz cmnf cA vz cv cmnf vy cv clt breq1
      rcla4ev ex a1d r19.21aiv anim12i sylancr jaodan $.
      $( [19-May-2006] $) $( [19-Jan-2006] $)

    $( Any subset of extended reals has a supremum. $)
    xrsupss $p |- ( A C_ RR* -> E. x e. RR* (
         A. y e. A -. x < y /\ A. y e. RR* ( y < x -> E. z e. A y < z ) ) ) $=
      cA cxr wss cA cr wss cpnf cA wcel wo cmnf cA wcel wo vx cv vy cv clt wbr
      wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy
      cxr wral wa vx cxr wrex cA cxr wss cA cr wss cpnf cA wcel cmnf cA wcel
      w3o cA cr wss cpnf cA wcel wo cmnf cA wcel wo cA ssxr cA cr wss cpnf cA
      wcel cmnf cA wcel df-3or sylib cA cxr wss cA cr wss cpnf cA wcel wo vx cv
      vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cxr wral wa vx cxr wrex cmnf cA wcel vx vy vz cA xrsupsslem cA
      cxr wss cmnf cA wcel wa vx cv vy cv clt wbr wn vy cA cmnf csn cdif wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA cmnf csn cdif wrex wi vy
      cxr wral wa vx cxr wrex vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cxr
      wss vx cv vy cv clt wbr wn vy cA cmnf csn cdif wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA cmnf csn cdif wrex wi vy cxr wral wa vx cxr
      wrex cmnf cA wcel cA cxr wss cA cmnf csn cdif cxr wss vx cv vy cv clt wbr
      wn vy cA cmnf csn cdif wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      cmnf csn cdif wrex wi vy cxr wral wa vx cxr wrex cA cxr cmnf csn ssdifss
      cA cmnf csn cdif cxr wss cA cmnf csn cdif cr wss cpnf cA cmnf csn cdif
      wcel wo vx cv vy cv clt wbr wn vy cA cmnf csn cdif wral vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA cmnf csn cdif wrex wi vy cxr wral wa vx cxr
      wrex cA cmnf csn cdif cxr wss cA cmnf csn cdif cr wss cpnf cA cmnf csn
      cdif wcel cmnf cA cmnf csn cdif wcel w3o cA cmnf csn cdif cr wss cpnf cA
      cmnf csn cdif wcel wo cA cmnf csn cdif ssxr cA cmnf csn cdif cr wss cpnf
      cA cmnf csn cdif wcel wo cmnf cA cmnf csn cdif wcel wo cmnf cA cmnf csn
      cdif wcel cA cmnf csn cdif cr wss cpnf cA cmnf csn cdif wcel wo wo cA
      cmnf csn cdif cr wss cpnf cA cmnf csn cdif wcel cmnf cA cmnf csn cdif
      wcel w3o cA cmnf csn cdif cr wss cpnf cA cmnf csn cdif wcel wo cA cmnf
      csn cdif cr wss cpnf cA cmnf csn cdif wcel wo cmnf cA cmnf csn cdif wcel
      orcom cA cmnf csn cdif cr wss cpnf cA cmnf csn cdif wcel cmnf cA cmnf csn
      cdif wcel df-3or cmnf cA cmnf csn cdif wcel wn cA cmnf csn cdif cr wss
      cpnf cA cmnf csn cdif wcel wo cmnf cA cmnf csn cdif wcel cA cmnf csn cdif
      cr wss cpnf cA cmnf csn cdif wcel wo wo wb cmnf cmnf csn wcel cmnf cA
      cmnf csn cdif wcel wn cmnf cmnf cxr mnfxr elisseti snid cmnf cmnf csn cA
      elndif ax-mp cmnf cA cmnf csn cdif wcel cA cmnf csn cdif cr wss cpnf cA
      cmnf csn cdif wcel wo biorf ax-mp 3bitr4i sylib vx vy vz cA cmnf csn cdif
      xrsupsslem mpdan syl adantr cmnf cA wcel vx cv vy cv clt wbr wn vy cA
      cmnf csn cdif wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA cmnf csn
      cdif wrex wi vy cxr wral wa vx cxr wrex vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx
      cxr wrex wi cA cxr wss cmnf cA wcel vx cv vy cv clt wbr wn vy cA cmnf csn
      cdif cmnf csn cun wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA cmnf
      csn cdif cmnf csn cun wrex wi vy cxr wral wa vx cxr wrex vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cxr wral wa vx cxr wrex vx cv vy cv clt wbr wn vy cA cmnf csn cdif
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA cmnf csn cdif wrex wi
      vy cxr wral wa vx cxr wrex cmnf cA wcel vx cv vy cv clt wbr wn vy cA cmnf
      csn cdif cmnf csn cun wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      cmnf csn cdif cmnf csn cun wrex wi vy cxr wral wa vx cv vy cv clt wbr wn
      vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr
      wral wa vx cxr cmnf cA wcel cA cmnf csn cdif cmnf csn cun cA wceq vx cv
      vy cv clt wbr wn vy cA cmnf csn cdif cmnf csn cun wral vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA cmnf csn cdif cmnf csn cun wrex wi vy cxr
      wral wa vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr wral wa wb cmnf cA wcel cmnf csn cA wss cmnf
      csn cA cmnf csn cdif cun cA wceq cA cmnf csn cdif cmnf csn cun cA wceq
      cmnf cA cmnf cxr mnfxr elisseti snss cmnf csn cA undif cmnf csn cA cmnf
      csn cdif cun cA cmnf csn cdif cmnf csn cun cA cmnf csn cA cmnf csn cdif
      uncom eqeq1i 3bitri cA cmnf csn cdif cmnf csn cun cA wceq vx cv vy cv clt
      wbr wn vy cA cmnf csn cdif cmnf csn cun wral vx cv vy cv clt wbr wn vy cA
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA cmnf csn cdif cmnf csn
      cun wrex wi vy cxr wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cxr wral vx cv vy cv clt wbr wn vy cA cmnf csn cdif cmnf csn
      cun cA raleq1 cA cmnf csn cdif cmnf csn cun cA wceq vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA cmnf csn cdif cmnf csn cun wrex wi vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr cA cmnf csn cdif cmnf
      csn cun cA wceq vy cv vz cv clt wbr vz cA cmnf csn cdif cmnf csn cun wrex
      vy cv vz cv clt wbr vz cA wrex vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA cmnf csn cdif cmnf csn cun cA rexeq1 imbi2d ralbidv anbi12d sylbi
      rexbidv vx vy vz cA cmnf csn cdif xrsupexmnf syl5bi adantl mpd jaodan
      mpdan $.
      $( [20-Jan-2006] $) $( [25-Oct-2005] $)

    $( Any subset of extended reals has an infimum. $)
    xrinfmss $p |- ( A C_ RR* -> E. x e. RR* (
         A. y e. A -. y < x /\ A. y e. RR* ( x < y -> E. z e. A z < y ) ) ) $=
      cA cxr wss cA cr wss cmnf cA wcel wo cpnf cA wcel wo vy cv vx cv clt wbr
      wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy
      cxr wral wa vx cxr wrex cA cxr wss cA cr wss cpnf cA wcel cmnf cA wcel
      w3o cA cr wss cmnf cA wcel wo cpnf cA wcel wo cA ssxr cA cr wss cpnf cA
      wcel cmnf cA wcel w3o cA cr wss cpnf cA wcel wo cmnf cA wcel wo cA cr wss
      cmnf cA wcel wo cpnf cA wcel wo cA cr wss cpnf cA wcel cmnf cA wcel
      df-3or cA cr wss cpnf cA wcel cmnf cA wcel or23 bitri sylib cA cxr wss cA
      cr wss cmnf cA wcel wo vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cpnf cA
      wcel vx vy vz cA xrinfmsslem cA cxr wss cpnf cA wcel wa vy cv vx cv clt
      wbr wn vy cA cpnf csn cdif wral vx cv vy cv clt wbr vz cv vy cv clt wbr
      vz cA cpnf csn cdif wrex wi vy cxr wral wa vx cxr wrex vy cv vx cv clt
      wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi
      vy cxr wral wa vx cxr wrex cA cxr wss vy cv vx cv clt wbr wn vy cA cpnf
      csn cdif wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA cpnf csn cdif
      wrex wi vy cxr wral wa vx cxr wrex cpnf cA wcel cA cxr wss cA cpnf csn
      cdif cxr wss vy cv vx cv clt wbr wn vy cA cpnf csn cdif wral vx cv vy cv
      clt wbr vz cv vy cv clt wbr vz cA cpnf csn cdif wrex wi vy cxr wral wa vx
      cxr wrex cA cxr cpnf csn ssdifss cA cpnf csn cdif cxr wss cA cpnf csn
      cdif cr wss cmnf cA cpnf csn cdif wcel wo vy cv vx cv clt wbr wn vy cA
      cpnf csn cdif wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA cpnf csn
      cdif wrex wi vy cxr wral wa vx cxr wrex cA cpnf csn cdif cxr wss cA cpnf
      csn cdif cr wss cpnf cA cpnf csn cdif wcel cmnf cA cpnf csn cdif wcel w3o
      cA cpnf csn cdif cr wss cmnf cA cpnf csn cdif wcel wo cA cpnf csn cdif
      ssxr cA cpnf csn cdif cr wss cpnf cA cpnf csn cdif wcel cmnf cA cpnf csn
      cdif wcel w3o cA cpnf csn cdif cr wss cpnf cA cpnf csn cdif wcel cmnf cA
      cpnf csn cdif wcel wo wo cA cpnf csn cdif cr wss cmnf cA cpnf csn cdif
      wcel wo cA cpnf csn cdif cr wss cpnf cA cpnf csn cdif wcel cmnf cA cpnf
      csn cdif wcel 3orass cmnf cA cpnf csn cdif wcel cpnf cA cpnf csn cdif
      wcel cmnf cA cpnf csn cdif wcel wo cA cpnf csn cdif cr wss cpnf cA cpnf
      csn cdif wcel wn cmnf cA cpnf csn cdif wcel cpnf cA cpnf csn cdif wcel
      cmnf cA cpnf csn cdif wcel wo wb cpnf cpnf csn wcel cpnf cA cpnf csn cdif
      wcel wn cpnf cpnf cxr pnfxr elisseti snid cpnf cpnf csn cA elndif ax-mp
      cpnf cA cpnf csn cdif wcel cmnf cA cpnf csn cdif wcel biorf ax-mp orbi2i
      bitr4i sylib vx vy vz cA cpnf csn cdif xrinfmsslem mpdan syl adantr cpnf
      cA wcel vy cv vx cv clt wbr wn vy cA cpnf csn cdif wral vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA cpnf csn cdif wrex wi vy cxr wral wa vx cxr
      wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv
      clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex wi cA cxr wss cpnf cA
      wcel vy cv vx cv clt wbr wn vy cA cpnf csn cdif cpnf csn cun wral vx cv
      vy cv clt wbr vz cv vy cv clt wbr vz cA cpnf csn cdif cpnf csn cun wrex
      wi vy cxr wral wa vx cxr wrex vy cv vx cv clt wbr wn vy cA wral vx cv vy
      cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex
      vy cv vx cv clt wbr wn vy cA cpnf csn cdif wral vx cv vy cv clt wbr vz cv
      vy cv clt wbr vz cA cpnf csn cdif wrex wi vy cxr wral wa vx cxr wrex cpnf
      cA wcel vy cv vx cv clt wbr wn vy cA cpnf csn cdif cpnf csn cun wral vx
      cv vy cv clt wbr vz cv vy cv clt wbr vz cA cpnf csn cdif cpnf csn cun
      wrex wi vy cxr wral wa vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr cpnf cA wcel
      cA cpnf csn cdif cpnf csn cun cA wceq vy cv vx cv clt wbr wn vy cA cpnf
      csn cdif cpnf csn cun wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      cpnf csn cdif cpnf csn cun wrex wi vy cxr wral wa vy cv vx cv clt wbr wn
      vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr
      wral wa wb cpnf cA wcel cpnf csn cA wss cpnf csn cA cpnf csn cdif cun cA
      wceq cA cpnf csn cdif cpnf csn cun cA wceq cpnf cA cpnf cxr pnfxr
      elisseti snss cpnf csn cA undif cpnf csn cA cpnf csn cdif cun cA cpnf csn
      cdif cpnf csn cun cA cpnf csn cA cpnf csn cdif uncom eqeq1i 3bitri cA
      cpnf csn cdif cpnf csn cun cA wceq vy cv vx cv clt wbr wn vy cA cpnf csn
      cdif cpnf csn cun wral vy cv vx cv clt wbr wn vy cA wral vx cv vy cv clt
      wbr vz cv vy cv clt wbr vz cA cpnf csn cdif cpnf csn cun wrex wi vy cxr
      wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral vy
      cv vx cv clt wbr wn vy cA cpnf csn cdif cpnf csn cun cA raleq1 cA cpnf
      csn cdif cpnf csn cun cA wceq vx cv vy cv clt wbr vz cv vy cv clt wbr vz
      cA cpnf csn cdif cpnf csn cun wrex wi vx cv vy cv clt wbr vz cv vy cv clt
      wbr vz cA wrex wi vy cxr cA cpnf csn cdif cpnf csn cun cA wceq vz cv vy
      cv clt wbr vz cA cpnf csn cdif cpnf csn cun wrex vz cv vy cv clt wbr vz
      cA wrex vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA cpnf csn cdif cpnf
      csn cun cA rexeq1 imbi2d ralbidv anbi12d sylbi rexbidv vx vy vz cA cpnf
      csn cdif xrinfmexpnf syl5bi adantl mpd jaodan mpdan $.
      $( [19-May-2006] $) $( [25-Oct-2005] $)

    $( By quantifying only over reals, we can specify any extended real upper
       bound for any set of extended reals. $)
    xrub $p |- ( ( A C_ RR* /\ B e. RR* ) -> ( A. x e. RR ( x < B ->
          E. y e. A x < y ) <-> A. x e. RR* ( x < B -> E. y e. A x < y ) ) ) $=
      cA cxr wss cB cxr wcel wa vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex
      wi vx cr wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr
      wral cA cxr wss cB cxr wcel wa vx cv cB clt wbr vx cv vy cv clt wbr vy cA
      wrex wi vx cr wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx
      cxr wral cA cxr wss cB cxr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr
      vy cA wrex wi vz cr wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex
      wi vx cr wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr
      wral wi vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr wral cA
      cxr wss cB cxr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi
      vz cr wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr wral
      vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral wi cA cxr
      wss cB cxr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi vz
      cr wral wa vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cv cB
      clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr cxr cA cxr wss cB cxr
      wcel wa vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral wa
      vx cv cxr wcel vx cv cr wcel vx cv cB clt wbr vx cv vy cv clt wbr vy cA
      wrex wi wi vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi cA cxr wss
      cB cxr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr
      wral wa vx cv cr wcel vx cv cpnf wceq vx cv cmnf wceq w3o vx cv cr wcel
      vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi wi vx cv cB clt wbr vx
      cv vy cv clt wbr vy cA wrex wi wi vx cv cxr wcel cA cxr wss cB cxr wcel
      wa vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral wa vx cv
      cr wcel vx cv cr wcel vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi
      wi vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi wi vx cv cpnf wceq
      vx cv cmnf wceq vx cv cr wcel vx cv cr wcel vx cv cB clt wbr vx cv vy cv
      clt wbr vy cA wrex wi wi vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex
      wi wi wi cA cxr wss cB cxr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr
      vy cA wrex wi vz cr wral wa vx cv cr wcel vx cv cB clt wbr vx cv vy cv
      clt wbr vy cA wrex wi pm2.27 a1i cA cxr wss cB cxr wcel wa vz cv cB clt
      wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral wa vx cv cpnf wceq vx cv
      cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cv cr wcel vx cv cB clt
      wbr vx cv vy cv clt wbr vy cA wrex wi wi cB cxr wcel vx cv cpnf wceq vx
      cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi wi cA cxr wss vz cv cB
      clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral vx cv cpnf wceq cB
      cxr wcel vx cv cB clt wbr wn vx cv cB clt wbr vx cv vy cv clt wbr vy cA
      wrex wi vx cv cpnf wceq vx cv cB clt wbr wn cpnf cB clt wbr wn cB cxr
      wcel vx cv cpnf wceq vx cv cB clt wbr cpnf cB clt wbr vx cv cpnf cB clt
      breq1 notbid cB pnfnlt syl5bir vx cv cB clt wbr vx cv vy cv clt wbr vy cA
      wrex pm2.21 syl6com ad2antlr a1dd cA cxr wss cB cxr wcel wa vz cv cB clt
      wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral wa vx cv cmnf wceq vx cv
      cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cv cr wcel vx cv cB clt
      wbr vx cv vy cv clt wbr vy cA wrex wi wi vx cv cmnf wceq vx cv cB clt wbr
      vx cv vy cv clt wbr vy cA wrex wi cmnf cB clt wbr cmnf vy cv clt wbr vy
      cA wrex wi cA cxr wss cB cxr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr
      vy cA wrex wi vz cr wral wa vx cv cmnf wceq vx cv cB clt wbr cmnf cB clt
      wbr vx cv vy cv clt wbr vy cA wrex cmnf vy cv clt wbr vy cA wrex vx cv
      cmnf cB clt breq1 vx cv cmnf wceq vx cv vy cv clt wbr cmnf vy cv clt wbr
      vy cA vx cv cmnf vy cv clt breq1 rexbidv imbi12d cA cxr wss cB cxr wcel
      wa vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral cmnf cB
      clt wbr cmnf vy cv clt wbr vy cA wrex wi cA cxr wss cB cr wcel cB cpnf
      wceq cB cmnf wceq w3o vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi
      vz cr wral cmnf cB clt wbr cmnf vy cv clt wbr vy cA wrex wi wi cB cxr
      wcel cA cxr wss cB cr wcel vz cv cB clt wbr vz cv vy cv clt wbr vy cA
      wrex wi vz cr wral cmnf cB clt wbr cmnf vy cv clt wbr vy cA wrex wi wi cB
      cpnf wceq cB cmnf wceq cA cxr wss cB cr wcel wa vz cv cB clt wbr vz cv vy
      cv clt wbr vy cA wrex wi vz cr wral cmnf vy cv clt wbr vy cA wrex cmnf cB
      clt wbr cA cxr wss cB cr wcel wa vz cv cB clt wbr vz cv vy cv clt wbr vy
      cA wrex wi vz cr wral cB c1 cmin co cB clt wbr cB c1 cmin co vy cv clt
      wbr vy cA wrex wi cB c1 cmin co vy cv clt wbr vy cA wrex cmnf vy cv clt
      wbr vy cA wrex cB cr wcel vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex
      wi vz cr wral cB c1 cmin co cB clt wbr cB c1 cmin co vy cv clt wbr vy cA
      wrex wi wi cA cxr wss cB cr wcel cB c1 cmin co cr wcel vz cv cB clt wbr
      vz cv vy cv clt wbr vy cA wrex wi vz cr wral cB c1 cmin co cB clt wbr cB
      c1 cmin co vy cv clt wbr vy cA wrex wi wi cB peano2rem vz cv cB clt wbr
      vz cv vy cv clt wbr vy cA wrex wi cB c1 cmin co cB clt wbr cB c1 cmin co
      vy cv clt wbr vy cA wrex wi vz cB c1 cmin co cr vz cv cB c1 cmin co wceq
      vz cv cB clt wbr cB c1 cmin co cB clt wbr vz cv vy cv clt wbr vy cA wrex
      cB c1 cmin co vy cv clt wbr vy cA wrex vz cv cB c1 cmin co cB clt breq1
      vz cv cB c1 cmin co wceq vz cv vy cv clt wbr cB c1 cmin co vy cv clt wbr
      vy cA vz cv cB c1 cmin co vy cv clt breq1 rexbidv imbi12d rcla4v syl
      adantl cB cr wcel cB c1 cmin co cB clt wbr cB c1 cmin co vy cv clt wbr vy
      cA wrex wi cB c1 cmin co vy cv clt wbr vy cA wrex wi cA cxr wss cB c1
      cmin co cB clt wbr cB c1 cmin co vy cv clt wbr vy cA wrex wi cB c1 cmin
      co cB clt wbr cB c1 cmin co vy cv clt wbr vy cA wrex cB cr wcel cB c1
      cmin co cB clt wbr cB c1 cmin co vy cv clt wbr vy cA wrex wi id cB ltm1
      syl5com adantl cA cxr wss cB cr wcel wa cB c1 cmin co vy cv clt wbr cmnf
      vy cv clt wbr vy cA cA cxr wss cB cr wcel wa vy cv cA wcel wa cmnf cB c1
      cmin co clt wbr cB c1 cmin co vy cv clt wbr cmnf vy cv clt wbr cA cxr wss
      cB cr wcel wa vy cv cA wcel wa cB c1 cmin co cr wcel cmnf cB c1 cmin co
      clt wbr cB cr wcel cB c1 cmin co cr wcel cA cxr wss vy cv cA wcel cB
      peano2rem ad2antlr cB c1 cmin co mnflt syl cB c1 cmin co cxr wcel vy cv
      cxr wcel cmnf cB c1 cmin co clt wbr cB c1 cmin co vy cv clt wbr wa cmnf
      vy cv clt wbr wi cA cxr wss cB cr wcel wa vy cv cA wcel wa cmnf cxr wcel
      cB c1 cmin co cxr wcel vy cv cxr wcel cmnf cB c1 cmin co clt wbr cB c1
      cmin co vy cv clt wbr wa cmnf vy cv clt wbr wi mnfxr cmnf cB c1 cmin co
      vy cv xrlttr mp3an1 cA cxr wss cB cr wcel wa vy cv cA wcel wa cB c1 cmin
      co cr wcel cB c1 cmin co cxr wcel cB cr wcel cB c1 cmin co cr wcel cA cxr
      wss vy cv cA wcel cB peano2rem ad2antlr cB c1 cmin co rexr syl cA cxr wss
      vy cv cA wcel vy cv cxr wcel cB cr wcel cA cxr vy cv ssel2 adantlr sylanc
      mpand r19.22dva 3syld a1dd cA cxr wss cB cpnf wceq wa vz cv cB clt wbr vz
      cv vy cv clt wbr vy cA wrex wi vz cr wral cmnf vy cv clt wbr vy cA wrex
      cmnf cB clt wbr cA cxr wss cB cpnf wceq wa c1 cB clt wbr c1 vy cv clt wbr
      vy cA wrex wi cmnf vy cv clt wbr vy cA wrex vz cv cB clt wbr vz cv vy cv
      clt wbr vy cA wrex wi vz cr wral cB cpnf wceq c1 cB clt wbr c1 vy cv clt
      wbr vy cA wrex wi c1 vy cv clt wbr vy cA wrex cA cxr wss cmnf vy cv clt
      wbr vy cA wrex c1 cB clt wbr c1 vy cv clt wbr vy cA wrex wi c1 cB clt wbr
      c1 vy cv clt wbr vy cA wrex cB cpnf wceq c1 cB clt wbr c1 vy cv clt wbr
      vy cA wrex wi id cB cpnf wceq c1 cB clt wbr c1 cpnf clt wbr c1 cr wcel c1
      cpnf clt wbr 1re c1 ltpnf ax-mp cB cpnf c1 clt breq2 mpbiri syl5com cA
      cxr wss c1 vy cv clt wbr cmnf vy cv clt wbr vy cA cA cxr wss vy cv cA
      wcel wa vy cv cxr wcel c1 vy cv clt wbr cmnf vy cv clt wbr wi cA cxr vy
      cv ssel2 vy cv cxr wcel cmnf c1 clt wbr c1 vy cv clt wbr cmnf vy cv clt
      wbr c1 cr wcel cmnf c1 clt wbr 1re c1 mnflt ax-mp cmnf cxr wcel c1 cxr
      wcel vy cv cxr wcel cmnf c1 clt wbr c1 vy cv clt wbr wa cmnf vy cv clt
      wbr wi mnfxr c1 cr wcel c1 cxr wcel 1re c1 rexr ax-mp cmnf c1 vy cv
      xrlttr mp3an12 mpani syl r19.22dva sylan9r c1 cr wcel vz cv cB clt wbr vz
      cv vy cv clt wbr vy cA wrex wi vz cr wral c1 cB clt wbr c1 vy cv clt wbr
      vy cA wrex wi wi 1re vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi
      c1 cB clt wbr c1 vy cv clt wbr vy cA wrex wi vz c1 cr vz cv c1 wceq vz cv
      cB clt wbr c1 cB clt wbr vz cv vy cv clt wbr vy cA wrex c1 vy cv clt wbr
      vy cA wrex vz cv c1 cB clt breq1 vz cv c1 wceq vz cv vy cv clt wbr c1 vy
      cv clt wbr vy cA vz cv c1 vy cv clt breq1 rexbidv imbi12d rcla4v ax-mp
      syl5 a1dd cA cxr wss cB cmnf wceq wa cmnf cB clt wbr cmnf vy cv clt wbr
      vy cA wrex wi vz cv cB clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr
      wral cA cxr wss cB cmnf wceq wa cmnf cB clt wbr cmnf vy cv clt wbr vy cA
      wrex cB cmnf wceq cmnf cB clt wbr wn cA cxr wss cB cmnf wceq cmnf cB clt
      wbr cmnf cmnf clt wbr cmnf cxr wcel cmnf cmnf clt wbr wn mnfxr cmnf
      xrltnr ax-mp cB cmnf cmnf clt breq2 mtbiri adantl pm2.21d a1d 3jaodan cB
      elxr sylan2b imp syl5cbir a1dd 3jaod vx cv elxr syl5ib com23 r19.20dv2 ex
      vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vz cv cB clt wbr vz cv
      vy cv clt wbr vy cA wrex wi vx vz cr vx cv vz cv wceq vx cv cB clt wbr vz
      cv cB clt wbr vx cv vy cv clt wbr vy cA wrex vz cv vy cv clt wbr vy cA
      wrex vx cv vz cv cB clt breq1 vx cv vz cv wceq vx cv vy cv clt wbr vz cv
      vy cv clt wbr vy cA vx cv vz cv vy cv clt breq1 rexbidv imbi12d cbvralv
      syl5ib pm2.43d vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cv
      cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr cr vx cv cr wcel vx
      cv cxr wcel vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cv rexr
      imim1i r19.20i2 impbid1 $.
      $( [10-Apr-2006] $) $( [9-Apr-2006] $)

    $( The supremum of a set of extended reals. $)
    supxr $p |- ( ( ( A C_ RR* /\ B e. RR* ) /\ ( A. x e. A -. B < x /\
    A. x e. RR ( x < B -> E. y e. A x < y ) ) ) -> sup ( A , RR* , < ) = B ) $=
      cA cxr wss cB cxr wcel wa cB vx cv clt wbr wn vx cA wral vx cv cB clt wbr
      vx cv vy cv clt wbr vy cA wrex wi vx cr wral wa cB vx cv clt wbr wn vx cA
      wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral wa cA
      cxr clt csup cB wceq cA cxr wss cB cxr wcel wa cB vx cv clt wbr wn vx cA
      wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr wral wa cB
      vx cv clt wbr wn vx cA wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA
      wrex wi vx cxr wral wa cA cxr wss cB cxr wcel wa vx cv cB clt wbr vx cv
      vy cv clt wbr vy cA wrex wi vx cr wral vx cv cB clt wbr vx cv vy cv clt
      wbr vy cA wrex wi vx cxr wral cB vx cv clt wbr wn vx cA wral cA cxr wss
      cB cxr wcel wa vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr
      wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral vx vy
      cA cB xrub biimpd anim2d imp cA cxr wss cB cxr wcel wa cB vx cv clt wbr
      wn vx cA wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr
      wral wa wa vz cv vx cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy
      cv clt wbr vy cA wrex wi vx cxr wral wa vz cxr crab cuni cB cA cxr clt
      csup cA cxr wss cB cxr wcel wa cB vx cv clt wbr wn vx cA wral vx cv cB
      clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral wa vz cv vx cv clt
      wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv clt wbr vy cA wrex wi
      vx cxr wral wa vz cxr crab cuni cB wceq cA cxr wss cB cxr wcel wa cB cxr
      wcel vz cv vx cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv
      clt wbr vy cA wrex wi vx cxr wral wa vz cxr wrex wa cB cxr wcel vz cv vx
      cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv clt wbr vy cA
      wrex wi vx cxr wral wa vz cxr wreu wa cB vx cv clt wbr wn vx cA wral vx
      cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral wa vz cv vx
      cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv clt wbr vy cA
      wrex wi vx cxr wral wa vz cxr crab cuni cB wceq wb cB cxr wcel cA cxr wss
      cB cxr wcel vz cv vx cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv
      vy cv clt wbr vy cA wrex wi vx cxr wral wa vz cxr wrex wa cA cxr wss vz
      cv vx cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv clt wbr vy
      cA wrex wi vx cxr wral wa vz cxr wrex cB cxr wcel vz vx vy cA xrsupss
      anim2i ancoms vz cv vx cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv
      vy cv clt wbr vy cA wrex wi vx cxr wral wa vz cxr wrex vz cv vx cv clt
      wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv clt wbr vy cA wrex wi
      vx cxr wral wa vz cxr wreu cB cxr wcel vz vx vy cxr cA clt xrltso supeu
      anim2i vz cv vx cv clt wbr wn vx cA wral vx cv vz cv clt wbr vx cv vy cv
      clt wbr vy cA wrex wi vx cxr wral wa cB vx cv clt wbr wn vx cA wral vx cv
      cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral wa vz cxr cB vz
      cv cB wceq vz cv vx cv clt wbr wn vx cA wral cB vx cv clt wbr wn vx cA
      wral vx cv vz cv clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral vx
      cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr wral vz cv cB wceq
      vz cv vx cv clt wbr wn cB vx cv clt wbr wn vx cA vz cv cB wceq vz cv vx
      cv clt wbr cB vx cv clt wbr vz cv cB vx cv clt breq1 notbid ralbidv vz cv
      cB wceq vx cv vz cv clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cv cB
      clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cxr vz cv cB wceq vx cv vz
      cv clt wbr vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex vz cv cB vx cv
      clt breq2 imbi1d ralbidv anbi12d reuuni2 3syl biimpa vz vx vy cxr cA clt
      df-sup syl5eq syldan $.
      $( [14-Apr-2006] $) $( [9-Apr-2006] $)

    $( The supremum of a set of extended reals. $)
    supxr2 $p |- ( ( ( A C_ RR* /\ B e. RR* ) /\ ( A. x e. A x <_ B /\
  A. x e. RR ( x < B -> E. y e. A x < y ) ) ) -> sup ( A , RR* , < ) = B ) $=
      cA cxr wss cB cxr wcel wa vx cv cB cle wbr vx cA wral vx cv cB clt wbr vx
      cv vy cv clt wbr vy cA wrex wi vx cr wral wa cB vx cv clt wbr wn vx cA
      wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr wral wa cA
      cxr clt csup cB wceq cA cxr wss cB cxr wcel wa vx cv cB cle wbr vx cA
      wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA wrex wi vx cr wral wa cB
      vx cv clt wbr wn vx cA wral vx cv cB clt wbr vx cv vy cv clt wbr vy cA
      wrex wi vx cr wral wa cA cxr wss cB cxr wcel wa vx cv cB cle wbr vx cA
      wral cB vx cv clt wbr wn vx cA wral vx cv cB clt wbr vx cv vy cv clt wbr
      vy cA wrex wi vx cr wral cA cxr wss cB cxr wcel wa vx cv cB cle wbr cB vx
      cv clt wbr wn vx cA cA cxr wss vx cv cA wcel cB cxr wcel vx cv cB cle wbr
      cB vx cv clt wbr wn wb vx cv cxr wcel cB cxr wcel vx cv cB cle wbr cB vx
      cv clt wbr wn wb cA cxr wss vx cv cA wcel wa vx cv cB xrlenlt cA cxr vx
      cv ssel2 sylan an1rs ralbidva anbi1d biimpa vx vy cA cB supxr syldan $.
      $( [20-Apr-2006] $) $( [9-Apr-2006] $)

    $( The real and extended real suprema match when the real supremum
       exists. $)
    supxrre $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                  sup ( A , RR* , < ) = sup ( A , RR , < ) ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a vx cv
      vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cxr wral wa vx cxr crab cuni vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr
      crab cuni cA cxr clt csup cA cr clt csup cA cr wss cA c0 wne vy cv vx cv
      cle wbr vy cA wral vx cr wrex w3a vx cv vy cv clt wbr wn vy cA wral vy cv
      vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr
      crab cuni vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cr wral wa vx cxr crab cuni vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cr wral wa vx cr crab cuni cA cr wss cA c0 wne vx cv vy cv clt wbr wn
      vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr
      wral wa vx cxr crab cuni vx cv vy cv clt wbr wn vy cA wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cxr crab cuni
      wceq vy cv vx cv cle wbr vy cA wral vx cr wrex cA cr wss cA c0 wne wa vx
      cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA wrex wi vy cxr wral wa vx cxr crab vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx
      cxr crab cA cr wss cA c0 wne wa vx cv vy cv clt wbr wn vy cA wral vy cv
      vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral wa vx cv vy
      cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cxr cA cr wss cA c0 wne wa vx cv cxr wcel wa vy
      cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cxr wral vy cv vx
      cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral vx cv vy cv clt
      wbr wn vy cA wral cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cxr cr cA cr wss cA c0 wne wa vx cv cxr wcel wa
      vy cv cxr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi
      vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi vy
      cv cr wcel vy cv cxr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cv rexr imim1i cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv
      cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi vy cv
      cxr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi cA cr
      wss cA c0 wne wa vx cv cxr wcel wa vy cv cr wcel vy cv vx cv clt wbr vy
      cv vz cv clt wbr vz cA wrex wi wi wa vy cv cr wcel vy cv cpnf wceq vy cv
      cmnf wceq w3o vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv
      cxr wcel cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cr wcel vy cv vx
      cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi wa vy cv cr wcel vy cv vx
      cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv cpnf wceq vy cv cmnf
      wceq cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cr wcel vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi wi pm3.27 vx cv cxr wcel vy cv
      cpnf wceq vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi cA cr
      wss cA c0 wne wa vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA wrex wi wi vx cv cxr wcel vy cv cpnf wceq vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vx cv cxr wcel vy cv cpnf wceq wa vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex vx cv cxr wcel vy cv cpnf wceq wa
      vy cv vx cv clt wbr wn cpnf vx cv clt wbr wn vx cv cxr wcel cpnf vx cv
      clt wbr wn vy cv cpnf wceq vx cv pnfnlt adantr vy cv cpnf wceq vy cv vx
      cv clt wbr wn cpnf vx cv clt wbr wn wb vx cv cxr wcel vy cv cpnf wceq vy
      cv vx cv clt wbr cpnf vx cv clt wbr vy cv cpnf vx cv clt breq1 notbid
      adantl mpbird pm2.21d ex ad2antlr cA cr wss cA c0 wne wa vx cv cxr wcel
      wa vy cv cmnf wceq vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      wi vy cv cr wcel vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi wi
      cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cmnf wceq vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA wrex wi cA cr wss cA c0 wne wa vx cv cxr
      wcel wa vy cv cmnf wceq wa vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi cmnf vx cv clt wbr cmnf vz cv clt wbr vz cA wrex wi cA cr wss cA
      c0 wne wa cmnf vx cv clt wbr cmnf vz cv clt wbr vz cA wrex wi vx cv cxr
      wcel vy cv cmnf wceq cA cr wss cA c0 wne wa cmnf vz cv clt wbr vz cA wrex
      cmnf vx cv clt wbr cA cr wss cA c0 wne cmnf vz cv clt wbr vz cA wrex cA
      cr wss vz cv cA wcel vz wex vz cv cA wcel cmnf vz cv clt wbr wa vz wex cA
      c0 wne cmnf vz cv clt wbr vz cA wrex cA cr wss vz cv cA wcel vz cv cA
      wcel cmnf vz cv clt wbr wa vz cA cr wss vz cv cA wcel cmnf vz cv clt wbr
      cA cr wss vz cv cA wcel vz cv cr wcel cmnf vz cv clt wbr cA cr vz cv ssel
      vz cv mnflt syl6 ancld 19.22dv vz cA n0 cmnf vz cv clt wbr vz cA df-rex
      3imtr4g imp a1d ad2antrr vy cv cmnf wceq vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi cmnf vx cv clt wbr cmnf vz cv clt wbr vz cA wrex wi
      wb cA cr wss cA c0 wne wa vx cv cxr wcel wa vy cv cmnf wceq vy cv vx cv
      clt wbr cmnf vx cv clt wbr vy cv vz cv clt wbr vz cA wrex cmnf vz cv clt
      wbr vz cA wrex vy cv cmnf vx cv clt breq1 vy cv cmnf wceq vy cv vz cv clt
      wbr cmnf vz cv clt wbr vz cA vy cv cmnf vz cv clt breq1 rexbidv imbi12d
      adantl mpbird ex adantr 3jaod vy cv elxr syl5ib ex impbid2 ralbidv2
      anbi2d rabbidv unieqd 3adant3 vx cv vy cv clt wbr wn vy cA wral vy cv vx
      cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr wrex vx
      cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA wrex wi vy cr wral wa vx cxr wreu vx cv vy cv clt wbr wn vy cA wral vy
      cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr
      crab cuni vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cr wral wa vx cxr crab cuni wceq cA cr wss cA
      c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex w3a cr cxr wss vx cv vy
      cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr wrex vx cv vy cv clt wbr wn vy cA wral vy cv
      vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cxr wreu
      vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA wrex wi vy cr wral wa vx cr crab cuni vx cv vy cv clt wbr wn vy cA
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa
      vx cxr crab cuni wceq ressxr vx cv vy cv clt wbr wn vy cA wral vy cv vx
      cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr cxr
      reuuniss mp3an1 vx vy vz cA sup3 cA cr wss cA c0 wne vy cv vx cv cle wbr
      vy cA wral vx cr wrex w3a vx cv vy cv clt wbr wn vy cA wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cxr wreu vx cv
      vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr wreu cA cr wss cA c0 wne vy cv vx cv cle wbr
      vy cA wral vx cr wrex w3a vx cv vy cv clt wbr wn vy cA wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr wrex vx cv
      vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cr wreu vx vy vz cA sup3 vx vy vz cr cA clt ltso
      supeu syl cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex
      vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA wrex wi vy cr wral wa vx cxr wreu vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cr
      wreu wb vy cv vx cv cle wbr vy cA wral vx cr wrex cA cr wss cA c0 wne vz
      cv vy cv cle wbr vz cA wral vy cr wrex w3a vx cv cxr wcel vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cr wral wa wa vx weu vx cv cr wcel vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa wa vx
      weu vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA wrex wi vy cr wral wa vx cxr wreu vx cv vy cv clt wbr wn vy cA
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa
      vx cr wreu cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex
      w3a vx cv cxr wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr
      vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa wa vx cv cr wcel vx cv vy
      cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa wa vx cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA
      wral vy cr wrex w3a vx cv cxr wcel vx cv vy cv clt wbr wn vy cA wral vy
      cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa wa vx cv
      cr wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cr wral wa wa cA cr wss cA c0 wne vz cv vy cv
      cle wbr vz cA wral vy cr wrex w3a vx cv cxr wcel vx cv vy cv clt wbr wn
      vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr
      wral wa wa vx cv cr wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa cA cr wss cA c0
      wne vz cv vy cv cle wbr vz cA wral vy cr wrex w3a vx cv cxr wcel vx cv vy
      cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA
      wrex wi vy cr wral wa vx cv cr wcel cA cr wss cA c0 wne vz cv vy cv cle
      wbr vz cA wral vy cr wrex w3a vx cv cr wcel vx cv cpnf wceq vx cv cmnf
      wceq w3o vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cr wral wa vx cv cr wcel wi vx cv cxr wcel cA
      cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex w3a vx cv cr
      wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cr wral wa vx cv cr wcel wi vx cv cpnf wceq vx
      cv cmnf wceq vx cv cr wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa vx cv cr wcel wi
      wi cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex w3a vx
      cv cr wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cr wral wa ax-1 a1i cA cr wss cA c0 wne vz cv
      vy cv cle wbr vz cA wral vy cr wrex w3a vx cv cpnf wceq vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cr wral wa vx cv cr wcel wi cA cr wss cA c0 wne vz cv vy cv cle wbr vz
      cA wral vy cr wrex w3a vx cv cpnf wceq wa vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cr wral vx cv cr wcel vx cv vy cv clt wbr wn vy
      cA wral cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex w3a
      vx cv cpnf wceq wa vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cr wral vx cv cr wcel cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA
      wral vy cr wrex w3a vx cv cpnf wceq wa vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wn wa vy cr wrex vy cv vx cv clt wbr vy cv vz cv clt
      wbr vz cA wrex wi vy cr wral wn cA cr wss cA c0 wne vz cv vy cv cle wbr
      vz cA wral vy cr wrex w3a vx cv cpnf wceq wa vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wn wa vy cr wrex vz cv vy cv cle wbr vz cA wral vy
      cr wrex cA cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex vx
      cv cpnf wceq 3simpl3 cA cr wss cA c0 wne vx cv cpnf wceq vy cv vx cv clt
      wbr vy cv vz cv clt wbr vz cA wrex wn wa vy cr wrex vz cv vy cv cle wbr
      vz cA wral vy cr wrex wb vz cv vy cv cle wbr vz cA wral vy cr wrex cA cr
      wss vx cv cpnf wceq wa vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex
      wn wa vz cv vy cv cle wbr vz cA wral vy cr cA cr wss vy cv cr wcel vx cv
      cpnf wceq vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wn wa vz cv
      vy cv cle wbr vz cA wral wb vx cv cpnf wceq vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wn wa vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA
      wrex wn wa cA cr wss vy cv cr wcel wa vz cv vy cv cle wbr vz cA wral vx
      cv cpnf wceq vy cv vx cv clt wbr vy cv cpnf clt wbr vy cv vz cv clt wbr
      vz cA wrex wn vx cv cpnf vy cv clt breq2 anbi1d cA cr wss vy cv cr wcel
      wa vy cv vz cv clt wbr vz cA wrex wn vy cv cpnf clt wbr vy cv vz cv clt
      wbr vz cA wrex wn wa vz cv vy cv cle wbr vz cA wral cA cr wss vy cv cr
      wcel wa vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wn vy cv cr
      wcel vy cv cpnf clt wbr cA cr wss vy cv ltpnf adantl biantrurd cA cr wss
      vy cv cr wcel wa vz cv vy cv cle wbr vz cA wral vy cv vz cv clt wbr wn vz
      cA wral vy cv vz cv clt wbr vz cA wrex wn cA cr wss vy cv cr wcel wa vz
      cv vy cv cle wbr vy cv vz cv clt wbr wn vz cA cA cr wss vz cv cA wcel vy
      cv cr wcel vz cv vy cv cle wbr vy cv vz cv clt wbr wn wb vz cv cr wcel vy
      cv cr wcel vz cv vy cv cle wbr vy cv vz cv clt wbr wn wb cA cr wss vz cv
      cA wcel wa vz cv vy cv lenlt cA cr vz cv ssel2 sylan an1rs ralbidva vy cv
      vz cv clt wbr vz cA ralnex syl6rbb bitr3d sylan9bbr an1rs rexbidva
      3ad2antl1 mpbird vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex vy cr
      rexanali sylib pm2.21d adantld ex cA cr wss cA c0 wne vx cv cmnf wceq vx
      cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz
      cA wrex wi vy cr wral wa vx cv cr wcel wi wi vz cv vy cv cle wbr vz cA
      wral vy cr wrex cA cr wss cA c0 wne wa vx cv cmnf wceq vx cv vy cv clt
      wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi
      vy cr wral wa vx cv cr wcel wi cA cr wss cA c0 wne wa vx cv cmnf wceq wa
      vx cv vy cv clt wbr wn vy cA wral vx cv cr wcel vy cv vx cv clt wbr vy cv
      vz cv clt wbr vz cA wrex wi vy cr wral cA cr wss cA c0 wne wa vx cv cmnf
      wceq wa vx cv vy cv clt wbr wn vy cA wral vx cv cr wcel cA cr wss cA c0
      wne wa vx cv cmnf wceq wa vy cv cA wcel vx cv vy cv clt wbr wa vy wex vx
      cv vy cv clt wbr wn vy cA wral wn cA cr wss vx cv cmnf wceq cA c0 wne vy
      cv cA wcel vx cv vy cv clt wbr wa vy wex cA cr wss vx cv cmnf wceq wa cA
      c0 wne vy cv cA wcel vx cv vy cv clt wbr wa vy wex cA cr wss vx cv cmnf
      wceq wa vy cv cA wcel vy wex vy cv cA wcel vx cv vy cv clt wbr wa vy wex
      cA c0 wne cA cr wss vx cv cmnf wceq wa vy cv cA wcel vy cv cA wcel vx cv
      vy cv clt wbr wa vy cA cr wss vx cv cmnf wceq wa vy cv cA wcel vx cv vy
      cv clt wbr cA cr wss vy cv cA wcel cmnf vy cv clt wbr vx cv cmnf wceq vx
      cv vy cv clt wbr cA cr wss vy cv cA wcel vy cv cr wcel cmnf vy cv clt wbr
      cA cr vy cv ssel vy cv mnflt syl6 vx cv cmnf wceq vx cv vy cv clt wbr
      cmnf vy cv clt wbr vx cv cmnf vy cv clt breq1 biimprd sylan9 ancld
      19.22dv vy cA n0 syl5ib imp an1rs vy cv cA wcel vx cv vy cv clt wbr wa vy
      wex vx cv vy cv clt wbr vy cA wrex vx cv vy cv clt wbr wn vy cA wral wn
      vx cv vy cv clt wbr vy cA df-rex vx cv vy cv clt wbr vy cA dfrex2 bitr3i
      sylib pm2.21d adantrd ex 3adant3 3jaod vx cv elxr syl5ib imp3a vx cv cxr
      wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cr wral wa wa vx cv vy cv clt wbr wn vy cA wral
      vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa wi cA
      cr wss cA c0 wne vz cv vy cv cle wbr vz cA wral vy cr wrex w3a vx cv cxr
      wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv
      clt wbr vz cA wrex wi vy cr wral wa pm3.27 a1i jcad vx cv cr wcel vx cv
      cxr wcel vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cr wral wa vx cv rexr anim1i impbid1 eubidv
      vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA wrex wi vy cr wral wa vx cxr df-reu vx cv vy cv clt wbr wn vy cA
      wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa
      vx cr df-reu 3bitr4g vy cv vx cv cle wbr vy cA wral vx cr wrex vz cv vx
      cv cle wbr vz cA wral vx cr wrex vz cv vy cv cle wbr vz cA wral vy cr
      wrex vy cv vx cv cle wbr vy cA wral vz cv vx cv cle wbr vz cA wral vx cr
      vy cv vx cv cle wbr vz cv vx cv cle wbr vy vz cA vy cv vz cv vx cv cle
      breq1 cbvralv rexbii vz cv vx cv cle wbr vz cA wral vz cv vy cv cle wbr
      vz cA wral vx vy cr vx cv vy cv wceq vz cv vx cv cle wbr vz cv vy cv cle
      wbr vz cA vx cv vy cv vz cv cle breq2 ralbidv cbvrexv bitri syl3an3b
      mpbird sylanc eqtr4d vx vy vz cxr cA clt df-sup vx vy vz cr cA clt df-sup
      3eqtr4g $.
      $( [13-May-2007] $) $( [18-Oct-2005] $)

    $( The supremum of an arbitrary set of extended reals is an extended
       real. $)
    supxrcl $p |- ( A C_ RR* -> sup ( A , RR* , < ) e. RR* ) $=
      cA cxr wss vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz
      cv clt wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA cxr clt csup cxr
      wcel vx vy vz cA xrsupss vx vy vz cxr cA clt xrltso supcl syl $.
      $( [20-Jan-2006] $) $( [24-Oct-2005] $)

    $( The supremum of the union of two sets of extended reals equals the
       largest of their suprema. $)
    supxrun $p |- ( ( A C_ RR* /\ B C_ RR* /\ sup ( A , RR* , < ) <_ sup
   ( B , RR* , < ) ) -> sup ( ( A u. B ) , RR* , < ) = sup ( B , RR* , < ) ) $=
      cA cB cun cxr wss cB cxr clt csup cxr wcel cB cxr clt csup vx cv clt wbr
      wn vx cA cB cun wral vx cv cB cxr clt csup clt wbr vx cv vy cv clt wbr vy
      cA cB cun wrex wi vx cr wral cA cB cun cxr clt csup cB cxr clt csup wceq
      cA cxr wss cB cxr wss cA cxr clt csup cB cxr clt csup cle wbr w3a vx vy
      cA cB cun cB cxr clt csup supxr cA cxr wss cB cxr wss cA cB cun cxr wss
      cA cxr clt csup cB cxr clt csup cle wbr cA cxr wss cB cxr wss wa cA cB
      cun cxr wss cA cB cxr unss biimpi 3adant3 cB cxr wss cA cxr wss cB cxr
      clt csup cxr wcel cA cxr clt csup cB cxr clt csup cle wbr cB supxrcl
      3ad2ant2 cA cxr wss cB cxr wss cA cxr clt csup cB cxr clt csup cle wbr
      w3a cB cxr clt csup vx cv clt wbr wn vx cA cB cun cA cxr wss cB cxr wss
      cA cxr clt csup cB cxr clt csup cle wbr w3a vx cv cA wcel vx cv cB wcel
      wo cB cxr clt csup vx cv clt wbr wn vx cv cA cB cun wcel cA cxr wss cB
      cxr wss cA cxr clt csup cB cxr clt csup cle wbr w3a vx cv cA wcel cB cxr
      clt csup vx cv clt wbr wn vx cv cB wcel cA cxr wss cB cxr wss cA cxr clt
      csup cB cxr clt csup cle wbr w3a vx cv cA wcel cA cxr clt csup vx cv clt
      wbr wn cB cxr clt csup vx cv clt wbr wn cA cxr wss cB cxr wss vx cv cA
      wcel cA cxr clt csup vx cv clt wbr wn wi cA cxr clt csup cB cxr clt csup
      cle wbr cA cxr wss vy cv vz cv clt wbr wn vz cA wral vz cv vy cv clt wbr
      vz cv vw cv clt wbr vw cA wrex wi vz cxr wral wa vy cxr wrex vx cv cA
      wcel cA cxr clt csup vx cv clt wbr wn wi vy vz vw cA xrsupss vy vz vw cxr
      cA vx cv clt xrltso supub syl 3ad2ant1 cA cxr wss cB cxr wss cA cxr clt
      csup cB cxr clt csup cle wbr vx cv cA wcel cA cxr clt csup vx cv clt wbr
      wn cB cxr clt csup vx cv clt wbr wn wi wi cA cxr wss cB cxr wss vx cv cA
      wcel cA cxr clt csup cB cxr clt csup cle wbr cA cxr clt csup vx cv clt
      wbr wn cB cxr clt csup vx cv clt wbr wn wi cA cxr wss cB cxr wss vx cv cA
      wcel cA cxr clt csup cB cxr clt csup cle wbr cA cxr clt csup vx cv clt
      wbr wn cB cxr clt csup vx cv clt wbr wn wi cA cxr wss cB cxr wss wa vx cv
      cA wcel wa cA cxr clt csup cB cxr clt csup cle wbr wa cB cxr clt csup vx
      cv clt wbr cA cxr clt csup vx cv clt wbr cA cxr wss cB cxr wss wa vx cv
      cA wcel wa cA cxr clt csup cB cxr clt csup cle wbr cB cxr clt csup vx cv
      clt wbr cA cxr clt csup vx cv clt wbr cA cxr clt csup cxr wcel cB cxr clt
      csup cxr wcel vx cv cxr wcel cA cxr clt csup cB cxr clt csup cle wbr cB
      cxr clt csup vx cv clt wbr wa cA cxr clt csup vx cv clt wbr wi cA cxr wss
      cB cxr wss wa vx cv cA wcel wa cA cxr clt csup cB cxr clt csup vx cv
      xrlelttr cA cxr wss cA cxr clt csup cxr wcel cB cxr wss vx cv cA wcel cA
      supxrcl ad2antrr cB cxr wss cB cxr clt csup cxr wcel cA cxr wss vx cv cA
      wcel cB supxrcl ad2antlr cA cxr wss vx cv cA wcel vx cv cxr wcel cB cxr
      wss cA cxr vx cv ssel2 adantlr syl3anc expdimp con3d exp41 com34 3imp
      mpdd cB cxr wss cA cxr wss vx cv cB wcel cB cxr clt csup vx cv clt wbr wn
      wi cA cxr clt csup cB cxr clt csup cle wbr cB cxr wss vy cv vz cv clt wbr
      wn vz cB wral vz cv vy cv clt wbr vz cv vw cv clt wbr vw cB wrex wi vz
      cxr wral wa vy cxr wrex vx cv cB wcel cB cxr clt csup vx cv clt wbr wn wi
      vy vz vw cB xrsupss vy vz vw cxr cB vx cv clt xrltso supub syl 3ad2ant2
      jaod vx cv cA cB elun syl5ib r19.21aiv cB cxr wss cA cxr wss vx cv cB cxr
      clt csup clt wbr vx cv vy cv clt wbr vy cA cB cun wrex wi vx cr wral cA
      cxr clt csup cB cxr clt csup cle wbr cB cxr wss vx cv cB cxr clt csup clt
      wbr vx cv vy cv clt wbr vy cA cB cun wrex wi vx cr cB cxr wss vx cv cr
      wcel vx cv cB cxr clt csup clt wbr vx cv vy cv clt wbr vy cA cB cun wrex
      cB cxr wss vx cv cr wcel vx cv cB cxr clt csup clt wbr wa vx cv vy cv clt
      wbr vy cB wrex vx cv vy cv clt wbr vy cA cB cun wrex cB cxr wss vx cv vz
      cv clt wbr wn vz cB wral vz cv vx cv clt wbr vz cv vy cv clt wbr vy cB
      wrex wi vz cxr wral wa vx cxr wrex vx cv cr wcel vx cv cB cxr clt csup
      clt wbr wa vx cv vy cv clt wbr vy cB wrex wi vx vz vy cB xrsupss vx cv vz
      cv clt wbr wn vz cB wral vz cv vx cv clt wbr vz cv vy cv clt wbr vy cB
      wrex wi vz cxr wral wa vx cxr wrex vx cv cxr wcel vx cv cB cxr clt csup
      clt wbr vx cv vy cv clt wbr vy cB wrex vx cv cr wcel vx vz vy cxr cB vx
      cv clt xrltso suplub vx cv rexr sylani syl vx cv vy cv clt wbr vx cv vy
      cv clt wbr vy cB cA cB cun vy cv cB wcel vy cv cA cB cun wcel vx cv vy cv
      clt wbr vy cv cB cA elun2 anim1i r19.22i2 syl6 exp3a r19.21aiv 3ad2ant2
      syl2anc $.
      $( [23-May-2006] $) $( [19-Jan-2006] $)

    $( The infimum of an arbitrary set of extended reals is an extended
       real. $)
    infmxrcl $p |- ( A C_ RR* -> sup ( A , RR* , `' < ) e. RR* ) $=
      cA cxr wss vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv
      wbr vy cv vz cv clt ccnv wbr vz cA wrex wi vy cxr wral wa vx cxr wrex cA
      cxr clt ccnv csup cxr wcel cA cxr wss vy cv vx cv clt wbr wn vy cA wral
      vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA wrex wi vy cxr wral wa vx
      cxr wrex vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt ccnv wbr
      vy cv vz cv clt ccnv wbr vz cA wrex wi vy cxr wral wa vx cxr wrex vx vy
      vz cA xrinfmss vx cv vy cv clt ccnv wbr wn vy cA wral vy cv vx cv clt
      ccnv wbr vy cv vz cv clt ccnv wbr vz cA wrex wi vy cxr wral wa vy cv vx
      cv clt wbr wn vy cA wral vx cv vy cv clt wbr vz cv vy cv clt wbr vz cA
      wrex wi vy cxr wral wa vx cxr vx cv vy cv clt ccnv wbr wn vy cA wral vy
      cv vx cv clt wbr wn vy cA wral vy cv vx cv clt ccnv wbr vy cv vz cv clt
      ccnv wbr vz cA wrex wi vy cxr wral vx cv vy cv clt wbr vz cv vy cv clt
      wbr vz cA wrex wi vy cxr wral vx cv vy cv clt ccnv wbr wn vy cv vx cv clt
      wbr wn vy cA vx cv vy cv clt ccnv wbr vy cv vx cv clt wbr vx cv vy cv clt
      vx visset vy visset brcnv notbii ralbii vy cv vx cv clt ccnv wbr vy cv vz
      cv clt ccnv wbr vz cA wrex wi vx cv vy cv clt wbr vz cv vy cv clt wbr vz
      cA wrex wi vy cxr vy cv vx cv clt ccnv wbr vx cv vy cv clt wbr vy cv vz
      cv clt ccnv wbr vz cA wrex vz cv vy cv clt wbr vz cA wrex vy cv vx cv clt
      vy visset vx visset brcnv vy cv vz cv clt ccnv wbr vz cv vy cv clt wbr vz
      cA vy cv vz cv clt vy visset vz visset brcnv rexbii imbi12i ralbii
      anbi12i rexbii sylibr vx vy vz cxr cA clt ccnv cxr clt wor cxr clt ccnv
      wor xrltso cxr clt cnvso mpbi supcl syl $.
      $( [26-May-2006] $) $( [19-Jan-2006] $)

    $( Adding minus infinity to a set does not affect its supremum. $)
    supxrmnf $p |- ( A C_ RR* ->
                 sup ( ( A u. { -oo } ) , RR* , < ) = sup ( A , RR* , < ) ) $=
      cA cxr wss cmnf csn cA cun cxr clt csup cA cxr clt csup cA cmnf csn cun
      cxr clt csup cmnf csn cxr wss cA cxr wss cmnf csn cxr clt csup cA cxr clt
      csup cle wbr cmnf csn cA cun cxr clt csup cA cxr clt csup wceq cA cxr wss
      cmnf csn cA supxrun cmnf csn cxr wss cA cxr wss cmnf cxr wcel cmnf csn
      cxr wss mnfxr cmnf cxr snssi ax-mp a1i cA cxr wss id cA cxr wss cmnf cA
      cxr clt csup cmnf csn cxr clt csup cle cA cxr wss cA cxr clt csup cxr
      wcel cmnf cA cxr clt csup cle wbr cA supxrcl cA cxr clt csup mnfle syl
      cmnf cxr wcel cmnf csn cxr clt csup cmnf wceq mnfxr cxr cmnf clt xrltso
      supsn ax-mp syl5eqbr syl3anc cA cmnf csn cun cmnf csn cA cun wceq cA cmnf
      csn cun cxr clt csup cmnf csn cA cun cxr clt csup wceq cA cmnf csn uncom
      cxr cA cmnf csn cun cmnf csn cA cun clt supeq1 ax-mp syl5eq $.
      $( [10-Jul-2006] $) $( [19-Jan-2006] $)

    $( The supremum of a set of extended reals containing plus infnity is plus
       infinity. $)
    supxrpnf $p |- ( ( A C_ RR* /\ +oo e. A ) -> sup ( A , RR* , < ) = +oo ) $=
      cA cxr wss cpnf cA wcel cpnf vy cv clt wbr wn vy cA wral vy cv cpnf clt
      wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral wa cA cxr clt csup cpnf
      wceq cA cxr wss cpnf vy cv clt wbr wn vy cA wral cpnf cA wcel vy cv cpnf
      clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral cA cxr wss cpnf vy
      cv clt wbr wn vy cA cA cxr wss vy cv cA wcel vy cv cxr wcel cpnf vy cv
      clt wbr wn cA cxr vy cv ssel vy cv pnfnlt syl6 r19.21aiv cpnf cA wcel vy
      cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr cpnf cA wcel vy
      cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cv cr wcel cpnf cA
      wcel vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex vy cv vz cv clt
      wbr vy cv cpnf clt wbr vz cpnf cA vz cv cpnf vy cv clt breq2 rcla4ev ex
      a1d r19.21aiv anim12i cA cxr wss cpnf cxr wcel cpnf vy cv clt wbr wn vy
      cA wral vy cv cpnf clt wbr vy cv vz cv clt wbr vz cA wrex wi vy cr wral
      wa cA cxr clt csup cpnf wceq pnfxr vy vz cA cpnf supxr mpanl2 syldan $.
      $( [14-Dec-2006] $) $( [15-Oct-2005] $)

    $( The supremum of an unbounded-above set of extended reals is plus
       infinity. $)
    supxrunb1 $p |- ( A C_ RR* -> ( A. x e. RR E. y e. A x <_ y <->
                    sup ( A , RR* , < ) = +oo ) ) $=
      cA cxr wss vx cv vy cv cle wbr vy cA wrex vx cr wral cA cxr clt csup cpnf
      wceq cA cxr wss vx cv vy cv cle wbr vy cA wrex vx cr wral cA cxr clt csup
      cpnf wceq cA cxr wss vx cv vy cv cle wbr vy cA wrex vx cr wral cpnf vz cv
      clt wbr wn vz cA wral vz cv cpnf clt wbr vz cv vy cv clt wbr vy cA wrex
      wi vz cr wral wa cA cxr clt csup cpnf wceq cA cxr wss vx cv vy cv cle wbr
      vy cA wrex vx cr wral wa cpnf vz cv clt wbr wn vz cA wral vz cv cpnf clt
      wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral cA cxr wss cpnf vz cv
      clt wbr wn vz cA wral vx cv vy cv cle wbr vy cA wrex vx cr wral cA cxr
      wss cpnf vz cv clt wbr wn vz cA cA cxr wss vz cv cA wcel vz cv cxr wcel
      cpnf vz cv clt wbr wn cA cxr vz cv ssel vz cv pnfnlt syl6 r19.21aiv
      adantr cA cxr wss vx cv vy cv cle wbr vy cA wrex vx cr wral wa vz cv cpnf
      clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr cA cxr wss vx cv vy cv
      cle wbr vy cA wrex vx cr wral vz cv cr wcel vz cv cpnf clt wbr vz cv vy
      cv clt wbr vy cA wrex wi wi vz cv cr wcel vx cv vy cv cle wbr vy cA wrex
      vx cr wral cA cxr wss vz cv cpnf clt wbr vz cv vy cv clt wbr vy cA wrex
      wi vx cv vy cv cle wbr vy cA wrex vx cr wral cA cxr wss vz cv cpnf clt
      wbr vz cv cr wcel vz cv vy cv clt wbr vy cA wrex vx cv vy cv cle wbr vy
      cA wrex vx cr wral cA cxr wss vz cv cr wcel vz cv vy cv clt wbr vy cA
      wrex wi vz cv cpnf clt wbr vx cv vy cv cle wbr vy cA wrex vx cr wral cA
      cxr wss vz cv cr wcel vz cv vy cv clt wbr vy cA wrex vx cv vy cv cle wbr
      vy cA wrex vx cr wral cA cxr wss wa vz cv cr wcel wa vz cv c1 caddc co vy
      cv cle wbr vy cA wrex vz cv vy cv clt wbr vy cA wrex vx cv vy cv cle wbr
      vy cA wrex vx cr wral cA cxr wss wa vz cv c1 caddc co cr wcel vz cv c1
      caddc co vy cv cle wbr vy cA wrex vz cv cr wcel vz cv c1 caddc co cr wcel
      vx cv vy cv cle wbr vy cA wrex vx cr wral cA cxr wss wa vz cv c1 caddc co
      vy cv cle wbr vy cA wrex vz cv c1 caddc co cr wcel vx cv vy cv cle wbr vy
      cA wrex vx cr wral vz cv c1 caddc co vy cv cle wbr vy cA wrex cA cxr wss
      vx cv vy cv cle wbr vy cA wrex vz cv c1 caddc co vy cv cle wbr vy cA wrex
      vx vz cv c1 caddc co cr vx cv vz cv c1 caddc co wceq vx cv vy cv cle wbr
      vz cv c1 caddc co vy cv cle wbr vy cA vx cv vz cv c1 caddc co vy cv cle
      breq1 rexbidv rcla4va adantrr ancoms vz cv peano2re sylan2 cA cxr wss vz
      cv cr wcel vz cv c1 caddc co vy cv cle wbr vy cA wrex vz cv vy cv clt wbr
      vy cA wrex wi vx cv vy cv cle wbr vy cA wrex vx cr wral cA cxr wss vz cv
      cr wcel wa vz cv c1 caddc co vy cv cle wbr vz cv vy cv clt wbr vy cA cA
      cxr wss vy cv cA wcel vz cv cr wcel vz cv c1 caddc co vy cv cle wbr vz cv
      vy cv clt wbr wi vy cv cxr wcel vz cv cr wcel vz cv c1 caddc co vy cv cle
      wbr vz cv vy cv clt wbr wi cA cxr wss vy cv cA wcel wa vz cv cr wcel vy
      cv cxr wcel vz cv c1 caddc co vy cv cle wbr vz cv vy cv clt wbr wi vz cv
      cr wcel vy cv cxr wcel wa vz cv vz cv c1 caddc co clt wbr vz cv c1 caddc
      co vy cv cle wbr vz cv vy cv clt wbr vz cv cr wcel vz cv vz cv c1 caddc
      co clt wbr vy cv cxr wcel vz cv ltp1 adantr vz cv cr wcel vz cv c1 caddc
      co cr wcel wa vy cv cxr wcel vz cv vz cv c1 caddc co clt wbr vz cv c1
      caddc co vy cv cle wbr wa vz cv vy cv clt wbr wi vz cv cr wcel vz cv cr
      wcel vz cv c1 caddc co cr wcel vy cv cxr wcel vz cv vz cv c1 caddc co clt
      wbr vz cv c1 caddc co vy cv cle wbr wa vz cv vy cv clt wbr wi vz cv cxr
      wcel vz cv c1 caddc co cr wcel vy cv cxr wcel vz cv vz cv c1 caddc co clt
      wbr vz cv c1 caddc co vy cv cle wbr wa vz cv vy cv clt wbr wi vz cv cr
      wcel vz cv cxr wcel vz cv c1 caddc co cxr wcel vy cv cxr wcel vz cv vz cv
      c1 caddc co clt wbr vz cv c1 caddc co vy cv cle wbr wa vz cv vy cv clt
      wbr wi vz cv c1 caddc co cr wcel vz cv vz cv c1 caddc co vy cv xrltletr
      vz cv c1 caddc co rexr syl3an2 vz cv rexr syl3an1 3expa vz cv cr wcel vz
      cv c1 caddc co cr wcel vz cv peano2re ancli sylan mpand ancoms cA cxr vy
      cv ssel2 sylan an1rs r19.22dva adantll mpd exp31 a1dd com4r com13 imp
      r19.21aiv jca cA cxr wss cpnf cxr wcel cpnf vz cv clt wbr wn vz cA wral
      vz cv cpnf clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral wa cA cxr
      clt csup cpnf wceq pnfxr vz vy cA cpnf supxr mpanl2 syldan ex cA cxr wss
      cA cxr clt csup cpnf wceq vx cv vy cv cle wbr vy cA wrex vx cr cA cxr wss
      vx cv cr wcel wa cA cxr clt csup cpnf wceq vx cv vy cv clt wbr vy cA wrex
      vx cv vy cv cle wbr vy cA wrex cA cxr wss vx cv cr wcel wa cA cxr clt
      csup cpnf wceq vx cv vy cv clt wbr vy cA wrex vz cv vw cv clt wbr wn vw
      cA wral vw cv vz cv clt wbr vw cv vy cv clt wbr vy cA wrex wi vw cxr wral
      wa vz cxr wrex vx cv cxr wcel vx cv cA cxr clt csup clt wbr wa vx cv vy
      cv clt wbr vy cA wrex cA cxr wss vx cv cr wcel wa cA cxr clt csup cpnf
      wceq wa vz vw vy cxr cA vx cv clt xrltso suplub cA cxr wss vz cv vw cv
      clt wbr wn vw cA wral vw cv vz cv clt wbr vw cv vy cv clt wbr vy cA wrex
      wi vw cxr wral wa vz cxr wrex vx cv cr wcel cA cxr clt csup cpnf wceq vz
      vw vy cA xrsupss ad2antrr cA cxr wss vx cv cr wcel wa cA cxr clt csup
      cpnf wceq wa vx cv cxr wcel vx cv cA cxr clt csup clt wbr vx cv cr wcel
      vx cv cxr wcel cA cxr wss cA cxr clt csup cpnf wceq vx cv rexr ad2antlr
      vx cv cr wcel cA cxr clt csup cpnf wceq vx cv cA cxr clt csup clt wbr cA
      cxr wss cA cxr clt csup cpnf wceq vx cv cr wcel vx cv cA cxr clt csup clt
      wbr cA cxr clt csup cpnf wceq vx cv cA cxr clt csup clt wbr vx cv cpnf
      clt wbr vx cv cr wcel cA cxr clt csup cpnf vx cv clt breq2 vx cv ltpnf
      syl5bir impcom adantll jca sylc ex cA cxr wss vx cv cr wcel wa vx cv vy
      cv clt wbr vx cv vy cv cle wbr vy cA vx cv cxr wcel vy cv cxr wcel vx cv
      vy cv clt wbr vx cv vy cv cle wbr wi cA cxr wss vx cv cr wcel wa vy cv cA
      wcel wa vx cv vy cv xrltle vx cv cr wcel vx cv cxr wcel cA cxr wss vy cv
      cA wcel vx cv rexr ad2antlr cA cxr wss vy cv cA wcel vy cv cxr wcel vx cv
      cr wcel cA cxr vy cv ssel2 adantlr sylanc r19.22dva syld r19.21adva
      impbid $.
      $( [23-Aug-2006] $) $( [19-Jan-2006] $)

    $( The supremum of an unbounded-above set of extended reals is plus
       infinity. $)
    supxrunb2 $p |- ( A C_ RR* -> ( A. x e. RR E. y e. A x < y <->
                    sup ( A , RR* , < ) = +oo ) ) $=
      cA cxr wss vx cv vy cv clt wbr vy cA wrex vx cr wral cA cxr clt csup cpnf
      wceq cA cxr wss vx cv vy cv clt wbr vy cA wrex vx cr wral cA cxr clt csup
      cpnf wceq cA cxr wss vx cv vy cv clt wbr vy cA wrex vx cr wral cpnf vz cv
      clt wbr wn vz cA wral vz cv cpnf clt wbr vz cv vy cv clt wbr vy cA wrex
      wi vz cr wral wa cA cxr clt csup cpnf wceq cA cxr wss vx cv vy cv clt wbr
      vy cA wrex vx cr wral wa cpnf vz cv clt wbr wn vz cA wral vz cv cpnf clt
      wbr vz cv vy cv clt wbr vy cA wrex wi vz cr wral cA cxr wss cpnf vz cv
      clt wbr wn vz cA wral vx cv vy cv clt wbr vy cA wrex vx cr wral cA cxr
      wss cpnf vz cv clt wbr wn vz cA cA cxr wss vz cv cA wcel vz cv cxr wcel
      cpnf vz cv clt wbr wn cA cxr vz cv ssel vz cv pnfnlt syl6 r19.21aiv
      adantr cA cxr wss vx cv vy cv clt wbr vy cA wrex vx cr wral wa vz cv cpnf
      clt wbr vz cv vy cv clt wbr vy cA wrex wi vz cr cA cxr wss vx cv vy cv
      clt wbr vy cA wrex vx cr wral vz cv cr wcel vz cv cpnf clt wbr vz cv vy
      cv clt wbr vy cA wrex wi wi vz cv cr wcel vx cv vy cv clt wbr vy cA wrex
      vx cr wral cA cxr wss vz cv cpnf clt wbr vz cv vy cv clt wbr vy cA wrex
      wi vx cv vy cv clt wbr vy cA wrex vx cr wral cA cxr wss vz cv cpnf clt
      wbr vz cv cr wcel vz cv vy cv clt wbr vy cA wrex vx cv vy cv clt wbr vy
      cA wrex vx cr wral cA cxr wss vz cv cr wcel vz cv vy cv clt wbr vy cA
      wrex wi vz cv cpnf clt wbr vx cv vy cv clt wbr vy cA wrex vx cr wral cA
      cxr wss vz cv cr wcel vz cv vy cv clt wbr vy cA wrex vz cv cr wcel vx cv
      vy cv clt wbr vy cA wrex vx cr wral cA cxr wss wa vz cv vy cv clt wbr vy
      cA wrex vz cv cr wcel vx cv vy cv clt wbr vy cA wrex vx cr wral vz cv vy
      cv clt wbr vy cA wrex cA cxr wss vx cv vy cv clt wbr vy cA wrex vz cv vy
      cv clt wbr vy cA wrex vx vz cv cr vx cv vz cv wceq vx cv vy cv clt wbr vz
      cv vy cv clt wbr vy cA vx cv vz cv vy cv clt breq1 rexbidv rcla4va
      adantrr ancoms exp31 a1dd com4r com13 imp r19.21aiv jca cA cxr wss cpnf
      cxr wcel cpnf vz cv clt wbr wn vz cA wral vz cv cpnf clt wbr vz cv vy cv
      clt wbr vy cA wrex wi vz cr wral wa cA cxr clt csup cpnf wceq pnfxr vz vy
      cA cpnf supxr mpanl2 syldan ex cA cxr wss cA cxr clt csup cpnf wceq vx cv
      vy cv clt wbr vy cA wrex vx cr cA cxr wss vx cv cr wcel cA cxr clt csup
      cpnf wceq vx cv vy cv clt wbr vy cA wrex cA cxr wss vx cv cr wcel cA cxr
      clt csup cpnf wceq vx cv vy cv clt wbr vy cA wrex vz cv vw cv clt wbr wn
      vw cA wral vw cv vz cv clt wbr vw cv vy cv clt wbr vy cA wrex wi vw cxr
      wral wa vz cxr wrex vx cv cxr wcel vx cv cA cxr clt csup clt wbr wa vx cv
      vy cv clt wbr vy cA wrex cA cxr wss vx cv cr wcel wa cA cxr clt csup cpnf
      wceq wa vz vw vy cxr cA vx cv clt xrltso suplub cA cxr wss vz cv vw cv
      clt wbr wn vw cA wral vw cv vz cv clt wbr vw cv vy cv clt wbr vy cA wrex
      wi vw cxr wral wa vz cxr wrex vx cv cr wcel cA cxr clt csup cpnf wceq vz
      vw vy cA xrsupss ad2antrr cA cxr wss vx cv cr wcel wa cA cxr clt csup
      cpnf wceq wa vx cv cxr wcel vx cv cA cxr clt csup clt wbr vx cv cr wcel
      vx cv cxr wcel cA cxr wss cA cxr clt csup cpnf wceq vx cv rexr ad2antlr
      vx cv cr wcel cA cxr clt csup cpnf wceq vx cv cA cxr clt csup clt wbr cA
      cxr wss cA cxr clt csup cpnf wceq vx cv cr wcel vx cv cA cxr clt csup clt
      wbr cA cxr clt csup cpnf wceq vx cv cA cxr clt csup clt wbr vx cv cpnf
      clt wbr vx cv cr wcel cA cxr clt csup cpnf vx cv clt breq2 vx cv ltpnf
      syl5bir impcom adantll jca sylc exp31 com23 r19.21adv impbid $.
      $( [26-Feb-2006] $) $( [19-Jan-2006] $)

    $( The supremum of a bounded-above nonempty set of reals is real. $)
    supxrbnd $p |- ( ( A C_ RR /\ A =/= (/) /\ sup ( A , RR* , < ) < +oo ) ->
                    sup ( A , RR* , < ) e. RR ) $=
      cA cr wss cA c0 wne vy cv vx cv cle wbr vy cA wral vx cr wrex cA cxr clt
      csup cr wcel cA cxr clt csup cpnf clt wbr cA cr wss cA c0 wne vy cv vx cv
      cle wbr vy cA wral vx cr wrex w3a cA cxr clt csup cA cr clt csup cr vx vy
      cA supxrre vx vy cA suprcl eqeltrd cA cr wss cA cxr clt csup cpnf clt wbr
      vy cv vx cv cle wbr vy cA wral vx cr wrex cA c0 wne cA cxr wss cA cxr clt
      csup cpnf clt wbr vy cv vx cv cle wbr vy cA wral vx cr wrex cA cr wss cA
      cxr wss cA cxr clt csup cpnf clt wbr vy cv vx cv cle wbr vy cA wral vx cr
      wrex cA cxr wss cA cxr clt csup cpnf clt wbr cA cxr clt csup cpnf wne vy
      cv vx cv cle wbr vy cA wral vx cr wrex cA cxr wss cA cxr clt csup cxr
      wcel cA cxr clt csup cpnf clt wbr cA cxr clt csup cpnf wne wi cA supxrcl
      cA cxr clt csup cxr wcel cA cxr clt csup cpnf clt wbr cA cxr clt csup
      cpnf wne cA cxr clt csup cxr wcel cA cxr clt csup cpnf clt wbr wa cpnf cA
      cxr clt csup cA cxr clt csup cxr wcel cpnf cxr wcel cA cxr clt csup cpnf
      clt wbr cpnf cA cxr clt csup wne pnfxr cA cxr clt csup cpnf xrltne mp3an2
      necomd ex syl cA cxr wss vy cv vx cv cle wbr vy cA wral vx cr wrex cA cxr
      clt csup cpnf cA cxr wss cA cxr clt csup cpnf wceq vy cv vx cv cle wbr vy
      cA wral wn vx cr wral vy cv vx cv cle wbr vy cA wral vx cr wrex wn cA cxr
      wss vx cv vy cv clt wbr vy cA wrex vx cr wral cA cxr clt csup cpnf wceq
      vy cv vx cv cle wbr vy cA wral wn vx cr wral vx vy cA supxrunb2 cA cxr
      wss vx cv vy cv clt wbr vy cA wrex vy cv vx cv cle wbr vy cA wral wn vx
      cr cA cxr wss vx cv cr wcel wa vx cv vy cv clt wbr vy cA wrex vy cv vx cv
      cle wbr wn vy cA wrex vy cv vx cv cle wbr vy cA wral wn cA cxr wss vx cv
      cr wcel wa vx cv vy cv clt wbr vy cv vx cv cle wbr wn vy cA vy cv cxr
      wcel vx cv cxr wcel vx cv vy cv clt wbr vy cv vx cv cle wbr wn wb cA cxr
      wss vx cv cr wcel wa vy cv cA wcel wa vy cv cxr wcel vx cv cxr wcel wa vy
      cv vx cv cle wbr vx cv vy cv clt wbr vy cv vx cv xrlenlt con2bid cA cxr
      wss vy cv cA wcel vy cv cxr wcel vx cv cr wcel cA cxr vy cv ssel2 adantlr
      vx cv cr wcel vx cv cxr wcel cA cxr wss vy cv cA wcel vx cv rexr ad2antlr
      sylanc rexbidva vy cv vx cv cle wbr vy cA rexnal syl6bb ralbidva bitr3d
      vy cv vx cv cle wbr vy cA wral vx cr ralnex syl6bb necon2abid sylibrd imp
      cA cr wss cr cxr wss cA cxr wss ressxr cA cr cxr sstr mpan2 sylan 3adant2
      syld3an3 $.
      $( [22-May-2007] $) $( [19-Jan-2006] $)

    $( The supremum of a nonempty set of reals is greater than minus
       infinity. $)
    supxrgtmnf $p |- ( ( A C_ RR /\ A =/= (/) ) ->
                     -oo < sup ( A , RR* , < ) ) $=
      cA cr wss cA c0 wne wa cA cxr clt csup cr wcel cA cxr clt csup cpnf wceq
      wo cmnf cA cxr clt csup clt wbr cA cr wss cA c0 wne wa cA cxr clt csup cr
      wcel cA cxr clt csup cpnf wceq cA cr wss cA c0 wne wa cA cxr clt csup cr
      wcel wn cA cxr clt csup cpnf clt wbr wn cA cxr clt csup cpnf wceq cA cr
      wss cA c0 wne wa cA cxr clt csup cpnf clt wbr cA cxr clt csup cr wcel cA
      cr wss cA c0 wne cA cxr clt csup cpnf clt wbr cA cxr clt csup cr wcel cA
      supxrbnd 3expia con3d cA cr wss cA c0 wne wa cA cxr clt csup cxr wcel cA
      cxr clt csup cpnf wceq cA cxr clt csup cpnf clt wbr wn wb cA cr wss cA
      cxr clt csup cxr wcel cA c0 wne cA cr wss cA cxr wss cA cxr clt csup cxr
      wcel cA cr wss cr cxr wss cA cxr wss ressxr cA cr cxr sstr mpan2 cA
      supxrcl syl adantr cA cxr clt csup nltpnft syl sylibrd orrd cA cxr clt
      csup mnfltxr syl $.
      $( [25-May-2007] $) $( [2-Feb-2006] $)

    $( The supremum of a nonempty set of reals is real iff it is less than
       plus infinity. $)
    supxrre1 $p |- ( ( A C_ RR /\ A =/= (/) ) ->
            ( sup ( A , RR* , < ) e. RR <-> sup ( A , RR* , < ) < +oo ) ) $=
      cA cr wss cA c0 wne wa cA cxr clt csup cr wcel cmnf cA cxr clt csup clt
      wbr cA cxr clt csup cpnf clt wbr wa cA cxr clt csup cpnf clt wbr cA cr
      wss cA cxr clt csup cr wcel cmnf cA cxr clt csup clt wbr cA cxr clt csup
      cpnf clt wbr wa wb cA c0 wne cA cr wss cA cxr wss cA cxr clt csup cxr
      wcel cA cxr clt csup cr wcel cmnf cA cxr clt csup clt wbr cA cxr clt csup
      cpnf clt wbr wa wb cA cr wss cr cxr wss cA cxr wss ressxr cA cr cxr sstr
      mpan2 cA supxrcl cA cxr clt csup xrrebnd 3syl adantr cA cr wss cA c0 wne
      wa cmnf cA cxr clt csup clt wbr cA cxr clt csup cpnf clt wbr cA
      supxrgtmnf biantrurd bitr4d $.
      $( [26-May-2007] $) $( [5-Feb-2006] $)

    $( The supremum of a nonempty set of reals is real iff it is not plus
       infinity. $)
    supxrre2 $p |- ( ( A C_ RR /\ A =/= (/) ) ->
            ( sup ( A , RR* , < ) e. RR <-> sup ( A , RR* , < ) =/= +oo ) ) $=
      cA cr wss cA c0 wne wa cA cxr clt csup cr wcel cA cxr clt csup cpnf clt
      wbr cA cxr clt csup cpnf wne cA supxrre1 cA cr wss cA cxr clt csup cpnf
      clt wbr cA cxr clt csup cpnf wne wb cA c0 wne cA cr wss cA cxr clt csup
      cpnf clt wbr cA cxr clt csup cpnf cA cr wss cA cxr wss cA cxr clt csup
      cxr wcel cA cxr clt csup cpnf wceq cA cxr clt csup cpnf clt wbr wn wb cA
      cr wss cr cxr wss cA cxr wss ressxr cA cr cxr sstr mpan2 cA supxrcl cA
      cxr clt csup nltpnft 3syl necon2abid adantr bitrd $.
      $( [8-Dec-2007] $) $( [5-Feb-2006] $)

    $( The supremum of a bounded-above set of extended reals is less than
       infinity. $)
    supxrbnd1 $p |- ( A C_ RR* -> ( E. x e. RR A. y e. A y < x <->
                    sup ( A , RR* , < ) < +oo ) ) $=
      cA cxr wss vy cv vx cv clt wbr vy cA wral vx cr wrex cA cxr clt csup cpnf
      clt wbr cA cxr wss vy cv vx cv clt wbr vy cA wral vx cr wrex wn vx cv vy
      cv cle wbr vy cA wrex vx cr wral cA cxr clt csup cpnf wceq cA cxr clt
      csup cpnf clt wbr wn cA cxr wss vy cv vx cv clt wbr vy cA wral wn vx cr
      wral vx cv vy cv cle wbr vy cA wrex vx cr wral vy cv vx cv clt wbr vy cA
      wral vx cr wrex wn cA cxr wss vy cv vx cv clt wbr vy cA wral wn vx cv vy
      cv cle wbr vy cA wrex vx cr cA cxr wss vx cv cr wcel wa vx cv vy cv cle
      wbr vy cA wrex vy cv vx cv clt wbr wn vy cA wrex vy cv vx cv clt wbr vy
      cA wral wn cA cxr wss vx cv cr wcel wa vx cv vy cv cle wbr vy cv vx cv
      clt wbr wn vy cA cA cxr wss vy cv cA wcel vx cv cr wcel vx cv vy cv cle
      wbr vy cv vx cv clt wbr wn wb vy cv cxr wcel vx cv cxr wcel vx cv vy cv
      cle wbr vy cv vx cv clt wbr wn wb cA cxr wss vy cv cA wcel wa vx cv cr
      wcel vx cv cxr wcel vy cv cxr wcel vx cv vy cv cle wbr vy cv vx cv clt
      wbr wn wb vx cv vy cv xrlenlt ancoms cA cxr vy cv ssel2 vx cv rexr syl2an
      an1rs rexbidva vy cv vx cv clt wbr vy cA rexnal syl6rbb ralbidva vy cv vx
      cv clt wbr vy cA wral vx cr ralnex syl5bbr vx vy cA supxrunb1 cA cxr wss
      cA cxr clt csup cxr wcel cA cxr clt csup cpnf wceq cA cxr clt csup cpnf
      clt wbr wn wb cA supxrcl cA cxr clt csup nltpnft syl 3bitrd con4bid $.
      $( [13-Nov-2006] $) $( [30-Jan-2006] $)

    $( The supremum of a bounded-above set of extended reals is less than
       infinity. $)
    supxrbnd2 $p |- ( A C_ RR* -> ( E. x e. RR A. y e. A y <_ x <->
                    sup ( A , RR* , < ) < +oo ) ) $=
      cA cxr wss vy cv vx cv cle wbr vy cA wral vx cr wrex cA cxr clt csup cpnf
      clt wbr cA cxr wss vy cv vx cv cle wbr vy cA wral vx cr wrex wn vx cv vy
      cv clt wbr vy cA wrex vx cr wral cA cxr clt csup cpnf wceq cA cxr clt
      csup cpnf clt wbr wn cA cxr wss vy cv vx cv cle wbr vy cA wral wn vx cr
      wral vx cv vy cv clt wbr vy cA wrex vx cr wral vy cv vx cv cle wbr vy cA
      wral vx cr wrex wn cA cxr wss vy cv vx cv cle wbr vy cA wral wn vx cv vy
      cv clt wbr vy cA wrex vx cr cA cxr wss vx cv cr wcel wa vx cv vy cv clt
      wbr vy cA wrex vy cv vx cv cle wbr wn vy cA wrex vy cv vx cv cle wbr vy
      cA wral wn cA cxr wss vx cv cr wcel wa vx cv vy cv clt wbr vy cv vx cv
      cle wbr wn vy cA cA cxr wss vy cv cA wcel vx cv cr wcel vx cv vy cv clt
      wbr vy cv vx cv cle wbr wn wb vy cv cxr wcel vx cv cxr wcel vx cv vy cv
      clt wbr vy cv vx cv cle wbr wn wb cA cxr wss vy cv cA wcel wa vx cv cr
      wcel vy cv cxr wcel vx cv cxr wcel wa vy cv vx cv cle wbr vx cv vy cv clt
      wbr vy cv vx cv xrlenlt con2bid cA cxr vy cv ssel2 vx cv rexr syl2an
      an1rs rexbidva vy cv vx cv cle wbr vy cA rexnal syl6rbb ralbidva vy cv vx
      cv cle wbr vy cA wral vx cr ralnex syl5bbr vx vy cA supxrunb2 cA cxr wss
      cA cxr clt csup cxr wcel cA cxr clt csup cpnf wceq cA cxr clt csup cpnf
      clt wbr wn wb cA supxrcl cA cxr clt csup nltpnft syl 3bitrd con4bid $.
      $( [26-Jun-2007] $) $( [30-Jan-2006] $)

    $( The supremum of an empty set under the extended reals is minus
       infinity. $)
    xrsup0 $p |- sup ( (/) , RR* , < ) = -oo $=
      c0 cxr wss cmnf cxr wcel wa cmnf vy cv clt wbr wn vy c0 wral vy cv cmnf
      clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy cr wral wa c0 cxr clt csup
      cmnf wceq c0 cxr wss cmnf cxr wcel cxr 0ss mnfxr pm3.2i cmnf vy cv clt
      wbr wn vy c0 wral vy cv cmnf clt wbr vy cv vz cv clt wbr vz c0 wrex wi vy
      cr wral cmnf vy cv clt wbr wn vy ral0 vy cv cmnf clt wbr vy cv vz cv clt
      wbr vz c0 wrex wi vy cr vy cv cr wcel vy cv cmnf clt wbr vy cv vz cv clt
      wbr vz c0 wrex vy cv cr wcel vy cv cxr wcel vy cv cmnf clt wbr wn vy cv
      rexr vy cv nltmnf syl pm2.21d rgen pm3.2i vy vz c0 cmnf supxr mp2an $.
      $( [12-Feb-2006] $) $( [15-Oct-2005] $)

    $( A member of a set of extended reals is less than or equal to the set's
       supremum. $)
    supxrub $p |- ( ( A C_ RR* /\ B e. A ) -> B <_ sup ( A , RR* , < ) ) $=
      cA cxr wss cB cA wcel wa cB cA cxr clt csup cle wbr cA cxr clt csup cB
      clt wbr wn cA cxr wss cB cA wcel cA cxr clt csup cB clt wbr wn cA cxr wss
      vx cv vy cv clt wbr wn vy cA wral vy cv vx cv clt wbr vy cv vz cv clt wbr
      vz cA wrex wi vy cxr wral wa vx cxr wrex cB cA wcel cA cxr clt csup cB
      clt wbr wn wi vx vy vz cA xrsupss vx vy vz cxr cA cB clt xrltso supub syl
      imp cB cxr wcel cA cxr clt csup cxr wcel cB cA cxr clt csup cle wbr cA
      cxr clt csup cB clt wbr wn wb cA cxr wss cB cA wcel wa cB cA cxr clt csup
      xrlenlt cA cxr cB ssel2 cA cxr wss cA cxr clt csup cxr wcel cB cA wcel cA
      supxrcl adantr sylanc mpbird $.
      $( [26-Feb-2006] $) $( [7-Feb-2006] $)

    $( The supremum of a set of extended reals is less than or equal to an
       upper bound. $)
    supxrleub $p |- ( ( A C_ RR* /\ B e. RR* /\ A. x e. A x <_ B ) ->
                  sup ( A , RR* , < ) <_ B ) $=
      cA cxr wss cB cxr wcel vx cv cB cle wbr vx cA wral cA cxr clt csup cB cle
      wbr cA cxr wss cB cxr wcel vx cv cB cle wbr vx cA wral wa cB cxr wcel cB
      vx cv clt wbr wn vx cA wral wa cA cxr clt csup cB cle wbr cA cxr wss cB
      cxr wcel vx cv cB cle wbr vx cA wral cB vx cv clt wbr wn vx cA wral cA
      cxr wss cB cxr wcel wa vx cv cB cle wbr cB vx cv clt wbr wn vx cA cA cxr
      wss vx cv cA wcel cB cxr wcel vx cv cB cle wbr cB vx cv clt wbr wn wb vx
      cv cxr wcel cB cxr wcel vx cv cB cle wbr cB vx cv clt wbr wn wb cA cxr
      wss vx cv cA wcel wa vx cv cB xrlenlt cA cxr vx cv ssel2 sylan an1rs
      ralbidva pm5.32da cA cxr wss cB cxr wcel cB vx cv clt wbr wn vx cA wral
      wa cA cxr clt csup cB cle wbr cA cxr wss cB cxr wcel cB vx cv clt wbr wn
      vx cA wral wa wa cA cxr clt csup cB cle wbr cB cA cxr clt csup clt wbr wn
      cA cxr wss cB cxr wcel cB vx cv clt wbr wn vx cA wral wa cB cA cxr clt
      csup clt wbr wn cA cxr wss vy cv vz cv clt wbr wn vz cA wral vz cv vy cv
      clt wbr vz cv vx cv clt wbr vx cA wrex wi vz cxr wral wa vy cxr wrex cB
      cxr wcel cB vx cv clt wbr wn vx cA wral wa cB cA cxr clt csup clt wbr wn
      wi vy vz vx cA xrsupss vy vz vx cxr cA cB clt xrltso supnub syl imp cA
      cxr wss cB cxr wcel cA cxr clt csup cB cle wbr cB cA cxr clt csup clt wbr
      wn wb cB vx cv clt wbr wn vx cA wral cA cxr clt csup cxr wcel cB cxr wcel
      cA cxr clt csup cB cle wbr cB cA cxr clt csup clt wbr wn wb cA cxr wss cA
      cxr clt csup cB xrlenlt cA supxrcl sylan adantrr mpbird ex sylbid 3impib
      $.
      $( [14-Mar-2006] $) $( [22-Feb-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Nonnegative integers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the set of nonnegative integers. $)
  df-n0 $a |- NN0 = ( NN u. { 0 } ) $.

  $( Nonnegative integers expressed in terms of naturals and zero.
     (Contributed by Raph Levien, 10-Dec-2002.) $)
  elnn0 $p |- ( A e. NN0 <-> ( A e. NN \/ A = 0 ) ) $=
    cA cn0 wcel cA cn cc0 csn cun wcel cA cn wcel cA cc0 csn wcel wo cA cn wcel
    cA cc0 wceq wo cn0 cn cc0 csn cun cA df-n0 eleq2i cA cn cc0 csn elun cA cc0
    csn wcel cA cc0 wceq cA cn wcel cA cc0 cc0 cc 0cn elisseti elsnc2 orbi2i
    3bitri $.
    $( [14-May-2003] $) $( [10-Dec-2002] $)

  $( Positive naturals are a subset of nonnegative integers.  (Contributed
     by Raph Levien, 10-Dec-2002.) $)
  nnssnn0 $p |- NN C_ NN0 $=
    cn cn cc0 csn cun cn0 cn cc0 csn ssun1 df-n0 sseqtr4i $.
    $( [14-May-2003] $) $( [10-Dec-2002] $)

  $( Nonnegative integers are a subset of the reals.  (Contributed by Raph
     Levien, 10-Dec-2002.) $)
  nn0ssre $p |- NN0 C_ RR $=
    cn0 cn cc0 csn cun cr df-n0 cn cc0 csn cr nnssre cc0 cr wcel cc0 csn cr wss
    0re cc0 cr snssi ax-mp unssi eqsstri $.
    $( [14-May-2003] $) $( [10-Dec-2002] $)

  $( Nonnegative integers are a subset of the complex numbers.) $)
  nn0sscn $p |- NN0 C_ CC $=
    cn0 cr cc nn0ssre axresscn sstri $.
    $( [25-Jun-2004] $) $( [9-May-2004] $)

  $( The set of nonnegative integers exists. $)
  nn0ex $p |- NN0 e. _V $=
    cn0 cc axcnex nn0sscn ssexi $.
    $( [24-Jul-2004] $) $( [18-Jul-2004] $)

  $( A natural number is a nonnegative integer. $)
  nnnn0 $p |- ( A e. NN -> A e. NN0 ) $=
    cn cn0 cA nnssnn0 sseli $.
    $( [10-May-2004] $) $( [9-May-2004] $)

  ${
    nnnn0.1 $e |- N e. NN $.
    $( A natural number is a nonnegative integer. $)
    nnnn0i $p |- N e. NN0 $=
      cN cn wcel cN cn0 wcel nnnn0.1 cN nnnn0 ax-mp $.
      $( [21-Jun-2005] $) $( [20-Jun-2005] $)
  $}

  $( A nonnegative integer is a real number. $)
  nn0re $p |- ( A e. NN0 -> A e. RR ) $=
    cn0 cr cA nn0ssre sseli $.
    $( [25-May-2004] $) $( [9-May-2004] $)

  $( A nonnegative integer is a complex number. $)
  nn0cn $p |- ( A e. NN0 -> A e. CC ) $=
    cn0 cc cA nn0sscn sseli $.
    $( [3-Jul-2004] $) $( [9-May-2004] $)

  ${
    nn0re.1 $e |- A e. NN0 $.
    $( A nonnegative integer is a real number. $)
    nn0rei $p |- A e. RR $=
      cn0 cr cA nn0ssre nn0re.1 sselii $.
      $( [14-May-2003] $)

    $( A nonnegative integer is a complex number. $)
    nn0cni $p |- A e. CC $=
      cA cA nn0re.1 nn0rei recni $.
      $( [14-May-2003] $)
  $}

  $( The set of natural numbers (positive integers) defined in terms of
     nonnegative integers. $)
  dfn2 $p |- NN = ( NN0 \ { 0 } ) $=
    vx cn cn0 cc0 csn cdif vx cv cn wcel vx cv cn0 wcel vx cv cc0 wne wa vx cv
    cn0 cc0 csn cdif wcel vx cv cn wcel vx cv cn0 wcel vx cv cc0 wne wa vx cv
    cn wcel vx cv cn0 wcel vx cv cc0 wne vx cv nnnn0 vx cv nnne0 jca vx cv cn0
    wcel vx cv cc0 wne vx cv cn wcel vx cv cn0 wcel vx cv cn wcel vx cv cc0 vx
    cv cn0 wcel vx cv cn wcel vx cv cc0 wceq vx cv cn0 wcel vx cv cn wcel vx cv
    cc0 wceq wo vx cv elnn0 biimpi ord necon1ad imp impbii vx cv cn0 cc0
    eldifsn bitr4i eqriv $.
    $( [23-Sep-2007] $) $( [23-Sep-2007] $)

  $( 0 is a nonnegative integer.  (Contributed by Raph Levien, 10-Dec-2002.) $)
  0nn0 $p |- 0 e. NN0 $=
    cc0 cc0 wceq cc0 cn0 wcel cc0 eqid cc0 cn wcel cc0 cc0 wceq cc0 cn0 wcel
    cc0 cn0 wcel cc0 cn wcel cc0 cc0 wceq wo cc0 elnn0 biimpri olcs ax-mp $.
    $( [21-Mar-2007] $) $( [10-Dec-2002] $)

  $( 1 is a nonnegative integer.  (Contributed by Raph Levien, 10-Dec-2002.) $)
  1nn0 $p |- 1 e. NN0 $=
    c1 1nn nnnn0i $.
    $( [10-Dec-2002] $)

  $( 2 is a nonnegative integer.  (Contributed by Raph Levien, 10-Dec-2002.) $)
  2nn0 $p |- 2 e. NN0 $=
    c2 2nn nnnn0i $.
    $( [10-Dec-2002] $)

  $( No number less than zero is a nonnegative integer. $)
  lt0nnn0 $p |- ( ( A e. RR /\ A < 0 ) -> -. A e. NN0 ) $=
    cA cr wcel cA cc0 clt wbr cA cn0 wcel wn cA cr wcel cA cn0 wcel cA cc0 clt
    wbr cA cr wcel cA cn wcel cA cc0 wceq wo cA cc0 clt wbr wn cA cn0 wcel cA
    cr wcel cA cn wcel cA cc0 clt wbr wn cA cc0 wceq cA cr wcel cA cc0 clt wbr
    cA cn wcel cA cr wcel cA cc0 clt wbr cA c1 clt wbr cA cn wcel wn cA cr wcel
    cA cc0 clt wbr cc0 c1 clt wbr cA c1 clt wbr lt01 cA cr wcel cc0 cr wcel c1
    cr wcel cA cc0 clt wbr cc0 c1 clt wbr wa cA c1 clt wbr wi 0re 1re cA cc0 c1
    axlttrn mp3an23 mpan2i cA cr wcel cA c1 clt wbr cA cn wcel wn cA lt1nnn ex
    syld con2d cA cc0 wceq cA cA clt wbr wn cA cc0 clt wbr wn cA cr wcel cA cc0
    wceq cA cA clt wbr cA cc0 clt wbr cA cc0 cA clt breq2 notbid cA ltnr
    syl5cbi jaod cA elnn0 syl5ib con2d imp $.
    $( [27-Jun-2004] $) $( [9-May-2004] $)

  $( A nonnegative integer is greater than or equal to zero. $)
  nn0ge0 $p |- ( N e. NN0 -> 0 <_ N ) $=
    cN cn0 wcel cc0 cN cle wbr cN cc0 clt wbr wn cN cr wcel cN cn0 wcel cN cc0
    clt wbr wn cN nn0re cN cr wcel cN cc0 clt wbr cN cn0 wcel cN cr wcel cN cc0
    clt wbr cN cn0 wcel wn cN lt0nnn0 ex con2d mpcom cc0 cr wcel cN cr wcel cc0
    cN cle wbr cN cc0 clt wbr wn wb cN cn0 wcel cc0 cN lenlt 0re cN nn0re
    sylancr mpbird $.
    $( [3-Jul-2004] $) $( [9-May-2004] $)

  ${
    nn0ge0.1 $e |- N e. NN0 $.
    $( Nonnegative integers are nonnegative.  (Contributed by Raph Levien,
       10-Dec-2002.) $)
    nn0ge0i $p |- 0 <_ N $=
      cN cn0 wcel cc0 cN cle wbr nn0ge0.1 cN nn0ge0 ax-mp $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  $( A nonnegative integer is less than or equal to zero iff it is equal to
     zero. $)
  nn0le0eq0 $p |- ( N e. NN0 -> ( N <_ 0 <-> N = 0 ) ) $=
    cN cn0 wcel cN cc0 cle wbr cN cc0 cle wbr cc0 cN cle wbr wa cN cc0 wceq cN
    cn0 wcel cc0 cN cle wbr cN cc0 cle wbr cN nn0ge0 biantrud cN cr wcel cc0 cr
    wcel cN cc0 wceq cN cc0 cle wbr cc0 cN cle wbr wa wb cN cn0 wcel cN cc0
    letri3 cN nn0re 0re sylancl bitr4d $.
    $( [30-Dec-2005] $) $( [9-Dec-2005] $)

  $( Closure of addition of nonnegative integers.  (Contributed by Raph Levien,
     10-Dec-2002.) $)
  nn0addcl $p |- ( ( M e. NN0 /\ N e. NN0 ) -> ( M + N ) e. NN0 ) $=
    cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq wo cM cN caddc co cn0 wcel
    cM cn0 wcel cN cn0 wcel cM cn wcel cN cn wcel cM cc0 wceq cN cc0 wceq cM cN
    caddc co cn0 wcel cM cn wcel cN cn wcel wa cM cN caddc co cn wcel cM cN
    caddc co cn0 wcel cM cN nnaddcl cM cN caddc co nnnn0 syl cM cc0 wceq cN cn
    wcel wa cM cN caddc co cN cn0 cM cc0 wceq cN cc wcel cM cN caddc co cN wceq
    cN cn wcel cM cc0 wceq cN cc wcel cM cN caddc co cc0 cN caddc co cN cM cc0
    cN caddc opreq1 cN addid2 sylan9eq cN nncn sylan2 cN cn wcel cN cn0 wcel cM
    cc0 wceq cN nnnn0 adantl eqeltrd cM cn wcel cN cc0 wceq wa cM cN caddc co
    cM cn0 cM cc wcel cN cc0 wceq cM cN caddc co cM wceq cM cn wcel cN cc0 wceq
    cM cc wcel cM cN caddc co cM cc0 caddc co cM cN cc0 cM caddc opreq2 cM
    addid1 sylan9eqr cM nncn sylan cM cn wcel cM cn0 wcel cN cc0 wceq cM nnnn0
    adantr eqeltrd cM cc0 wceq cN cc0 wceq wa cM cN caddc co cc0 cn0 cM cc0
    wceq cN cc0 wceq wa cM cN caddc co cc0 cc0 caddc co cc0 cM cc0 cN cc0 caddc
    opreq12 cc0 0cn addid1i syl6eq 0nn0 syl6eqel ccase cM elnn0 cN elnn0
    syl2anb $.
    $( [14-May-2003] $) $( [10-Dec-2002] $)

  ${
    nn0addcl.1 $e |- M e. NN0 $.
    nn0addcl.2 $e |- N e. NN0 $.
    $( Closure of addition of nonnegative integers, inference form.
      (Contributed  by Raph Levien, 10-Dec-2002.) $)
    nn0addcli $p |- ( M + N ) e. NN0 $=
      cM cn0 wcel cN cn0 wcel cM cN caddc co cn0 wcel nn0addcl.1 nn0addcl.2 cM
      cN nn0addcl mp2an $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)

    $( Closure of multiplication of nonnegative integers, inference form.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0mulcli $p |- ( M x. N ) e. NN0 $=
      cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq wo cM cN cmul co cn0
      wcel cM cn0 wcel cM cn wcel cM cc0 wceq wo nn0addcl.1 cM elnn0 mpbi cN
      cn0 wcel cN cn wcel cN cc0 wceq wo nn0addcl.2 cN elnn0 mpbi cM cn wcel cN
      cn wcel cM cc0 wceq cN cc0 wceq cM cN cmul co cn0 wcel cM cn wcel cN cn
      wcel wa cM cN cmul co cn wcel cM cN cmul co cn0 wcel cM cN nnmulcl cM cN
      cmul co nnnn0 syl cM cc0 wceq cM cN cmul co cc0 cn0 cM cc0 wceq cM cN
      cmul co cc0 cN cmul co cc0 cM cc0 cN cmul opreq1 cN cN nn0addcl.2 nn0cni
      mul02i syl6eq 0nn0 syl6eqel cN cc0 wceq cM cN cmul co cc0 cn0 cN cc0 wceq
      cM cN cmul co cM cc0 cmul co cc0 cN cc0 cM cmul opreq2 cM cM nn0addcl.1
      nn0cni mul01i syl6eq 0nn0 syl6eqel ccase2 mp2an $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  $( Closure of multiplication of nonnegative integers. $)
  nn0mulcl $p |- ( ( M e. NN0 /\ N e. NN0 ) -> ( M x. N ) e. NN0 ) $=
    cM cn0 wcel cN cn0 wcel cM cN cmul co cn0 wcel cM cn0 wcel cM cc0 cif cN
    cmul co cn0 wcel cM cn0 wcel cM cc0 cif cN cn0 wcel cN cc0 cif cmul co cn0
    wcel cM cN cc0 cc0 cM cM cn0 wcel cM cc0 cif wceq cM cN cmul co cM cn0 wcel
    cM cc0 cif cN cmul co cn0 cM cM cn0 wcel cM cc0 cif cN cmul opreq1 eleq1d
    cN cN cn0 wcel cN cc0 cif wceq cM cn0 wcel cM cc0 cif cN cmul co cM cn0
    wcel cM cc0 cif cN cn0 wcel cN cc0 cif cmul co cn0 cN cN cn0 wcel cN cc0
    cif cM cn0 wcel cM cc0 cif cmul opreq2 eleq1d cM cn0 wcel cM cc0 cif cN cn0
    wcel cN cc0 cif cM cc0 cn0 0nn0 elimel cN cc0 cn0 0nn0 elimel nn0mulcli
    dedth2h $.
    $( [30-Aug-2004] $) $( [22-Jul-2004] $)

  $( Second Peano postulate for nonnegative integers. $)
  peano2nn0 $p |- ( N e. NN0 -> ( N + 1 ) e. NN0 ) $=
    cN cn0 wcel c1 cn0 wcel cN c1 caddc co cn0 wcel 1nn0 cN c1 nn0addcl mpan2
    $.
    $( [24-May-2004] $) $( [9-May-2004] $)

  $( A natural number plus a nonnegative integer is a natural number. $)
  nnnn0addcl $p |- ( ( M e. NN /\ N e. NN0 ) -> ( M + N ) e. NN ) $=
    cM cn wcel cN cn0 wcel cM cN caddc co cn wcel cM cn wcel cN cn wcel cN cc0
    wceq wo cM cN caddc co cn wcel cN cn0 wcel cM cn wcel cN cn wcel cM cN
    caddc co cn wcel cN cc0 wceq cM cn wcel cN cn wcel cM cN caddc co cn wcel
    cM cN nnaddcl ex cN cc0 wceq cM cN caddc co cn wcel cM cc0 caddc co cn wcel
    cM cn wcel cN cc0 wceq cM cN caddc co cM cc0 caddc co cn cN cc0 cM caddc
    opreq2 eleq1d cM cn wcel cM cc0 caddc co cn wcel cM cn wcel cM cc0 caddc co
    cM cn cM cn wcel cM cc wcel cM cc0 caddc co cM wceq cM nncn cM addid1 syl
    eleq1d ibir syl5cbir jaod cN elnn0 syl5ib imp $.
    $( [23-Apr-2005] $) $( [20-Apr-2005] $)

  $( A nonnegative integer plus a natural number is a natural number. $)
  nn0nnaddcl $p |- ( ( M e. NN0 /\ N e. NN ) -> ( M + N ) e. NN ) $=
    cN cn wcel cM cn0 wcel cM cN caddc co cn wcel cN cn wcel cM cn0 wcel wa cN
    cM caddc co cM cN caddc co cn cN cc wcel cM cc wcel cN cM caddc co cM cN
    caddc co wceq cN cn wcel cM cn0 wcel cN cM addcom cN nncn cM nn0cn syl2an
    cN cM nnnn0addcl eqeltrrd ancoms $.
    $( [24-Jan-2006] $) $( [22-Dec-2005] $)

  $( Nonnegative integer ordering relation.  (Contributed by Raph Levien,
     10-Dec-2002.) $)
  nn0ltp1le $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M < N <-> ( M + 1 ) <_ N ) ) $=
    cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq wo cM cN clt wbr cM c1
    caddc co cN cle wbr wb cM cn0 wcel cN cn0 wcel cM cn wcel cN cn wcel cM cc0
    wceq cN cc0 wceq cM cN clt wbr cM c1 caddc co cN cle wbr wb cM cN nnltp1le
    cM cc0 wceq cN cn wcel wa cM cN clt wbr cc0 c1 caddc co cN cle wbr cM c1
    caddc co cN cle wbr cM cc0 wceq cM cN clt wbr cc0 cN clt wbr cN cn wcel cc0
    c1 caddc co cN cle wbr cM cc0 cN clt breq1 cN cn wcel cc0 cN clt wbr cc0 c1
    caddc co cN cle wbr cN cn wcel cc0 cN clt wbr wi cN cn wcel cc0 c1 caddc co
    cN cle wbr wi cN nngt0 cN cn wcel c1 cN cc0 c1 caddc co cle cN nnge1 c1
    ax1cn addid2i syl5eqbr 2th pm5.74ri sylan9bb cM cc0 wceq cM c1 caddc co cN
    cle wbr cc0 c1 caddc co cN cle wbr wb cN cn wcel cM cc0 wceq cM c1 caddc co
    cc0 c1 caddc co cN cle cM cc0 c1 caddc opreq1 breq1d adantr bitr4d cM cn
    wcel cN cc0 wceq wa cM cN clt wbr cM c1 caddc co cc0 cle wbr cM c1 caddc co
    cN cle wbr cN cc0 wceq cM cN clt wbr cM cc0 clt wbr cM cn wcel cM c1 caddc
    co cc0 cle wbr cN cc0 cM clt breq2 cM cc0 clt wbr wn cM c1 caddc co cc0 cle
    wbr wn cM cc0 clt wbr cM c1 caddc co cc0 cle wbr wb cM cn wcel cM cc0 clt
    wbr cM c1 caddc co cc0 cle wbr pm5.21 cM cn wcel cM cc0 clt wbr cc0 cM clt
    wbr cM nngt0 cM cr wcel cc0 cr wcel cM cc0 clt wbr cc0 cM clt wbr wn wi cM
    cn wcel cM cc0 ltnsym cM nnre 0re sylancl mt2d cM cn wcel cc0 cM c1 caddc
    co clt wbr cM c1 caddc co cc0 cle wbr wn cM cr wcel cM c1 caddc co cr wcel
    wa cc0 cM clt wbr cM cM c1 caddc co clt wbr wa cc0 cM c1 caddc co clt wbr
    cM cn wcel cc0 cr wcel cM cr wcel cM c1 caddc co cr wcel cc0 cM clt wbr cM
    cM c1 caddc co clt wbr wa cc0 cM c1 caddc co clt wbr wi 0re cc0 cM cM c1
    caddc co axlttrn mp3an1 cM cn wcel cM cr wcel cM c1 caddc co cr wcel cM
    nnre cM cn wcel cM cr wcel cM c1 caddc co cr wcel cM nnre cM peano2re syl
    jca cM cn wcel cc0 cM clt wbr cM cM c1 caddc co clt wbr cM nngt0 cM cn wcel
    cM cr wcel cM cM c1 caddc co clt wbr cM nnre cM ltp1 syl jca sylc cM cn
    wcel cM cr wcel cM c1 caddc co cr wcel cc0 cM c1 caddc co clt wbr cM c1
    caddc co cc0 cle wbr wn wb cM nnre cM peano2re cc0 cr wcel cM c1 caddc co
    cr wcel cc0 cM c1 caddc co clt wbr cM c1 caddc co cc0 cle wbr wn wb 0re cc0
    cM c1 caddc co ltnle mpan 3syl mpbid sylanc sylan9bbr cN cc0 wceq cM c1
    caddc co cN cle wbr cM c1 caddc co cc0 cle wbr wb cM cn wcel cN cc0 cM c1
    caddc co cle breq2 adantl bitr4d cM cc0 wceq cN cc0 wceq wa cM cN clt wbr
    cM c1 caddc co cc0 cle wbr cM c1 caddc co cN cle wbr cN cc0 wceq cM cN clt
    wbr cM cc0 clt wbr cM cc0 wceq cM c1 caddc co cc0 cle wbr cN cc0 cM clt
    breq2 cM cc0 wceq cM cc0 clt wbr cc0 c1 caddc co cc0 cle wbr cM c1 caddc co
    cc0 cle wbr cM cc0 wceq cM cc0 clt wbr cc0 cc0 clt wbr cc0 c1 caddc co cc0
    cle wbr cM cc0 cc0 clt breq1 cc0 cc0 clt wbr cc0 c1 caddc co cc0 cle wbr
    cc0 0re ltnri cc0 cc0 c1 caddc co clt wbr cc0 c1 caddc co cc0 cle wbr wn
    cc0 0re ltp1i cc0 cc0 c1 caddc co 0re cc0 c1 0re 1re readdcli ltnlei mpbi
    2false syl6bb cM cc0 wceq cM c1 caddc co cc0 c1 caddc co cc0 cle cM cc0 c1
    caddc opreq1 breq1d bitr4d sylan9bbr cN cc0 wceq cM c1 caddc co cN cle wbr
    cM c1 caddc co cc0 cle wbr wb cM cc0 wceq cN cc0 cM c1 caddc co cle breq2
    adantl bitr4d ccase cM elnn0 cN elnn0 syl2anb $.
    $( [14-May-2003] $) $( [10-Dec-2002] $)

  $( Nonnegative integer ordering relation.  (Contributed by Raph Levien,
     10-Apr-2004.) $)
  nn0leltp1 $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M <_ N <-> M < ( N + 1 ) ) ) $=
    cM cn0 wcel cN cn0 wcel wa cM cN cle wbr cM c1 caddc co cN c1 caddc co cle
    wbr cM cN c1 caddc co clt wbr cM cr wcel cN cr wcel cM cN cle wbr cM c1
    caddc co cN c1 caddc co cle wbr wb cM cn0 wcel cN cn0 wcel cM cr wcel cN cr
    wcel c1 cr wcel cM cN cle wbr cM c1 caddc co cN c1 caddc co cle wbr wb 1re
    cM cN c1 leadd1 mp3an3 cM nn0re cN nn0re syl2an cM cn0 wcel cN c1 caddc co
    cn0 wcel cM cN c1 caddc co clt wbr cM c1 caddc co cN c1 caddc co cle wbr wb
    cN cn0 wcel cM cN c1 caddc co nn0ltp1le cN peano2nn0 sylan2 bitr4d $.
    $( [25-May-2004] $) $( [10-Apr-2004] $)

  $( Nonnegative integer ordering relation. $)
  nn0ltlem1 $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M < N <-> M <_ ( N - 1 ) ) ) $=
    cM cn0 wcel cN cn0 wcel wa cM c1 caddc co cN c1 cmin co c1 caddc co cle wbr
    cM c1 caddc co cN cle wbr cM cN c1 cmin co cle wbr cM cN clt wbr cN cn0
    wcel cM c1 caddc co cN c1 cmin co c1 caddc co cle wbr cM c1 caddc co cN cle
    wbr wb cM cn0 wcel cN cn0 wcel cN c1 cmin co c1 caddc co cN cM c1 caddc co
    cle cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN cn0 wcel cN
    c1 npcan cN nn0cn ax1cn sylancl breq2d adantl cM cr wcel cN c1 cmin co cr
    wcel cM cN c1 cmin co cle wbr cM c1 caddc co cN c1 cmin co c1 caddc co cle
    wbr wb cM cn0 wcel cN cn0 wcel cM cr wcel cN c1 cmin co cr wcel c1 cr wcel
    cM cN c1 cmin co cle wbr cM c1 caddc co cN c1 cmin co c1 caddc co cle wbr
    wb 1re cM cN c1 cmin co c1 leadd1 mp3an3 cM nn0re cN cn0 wcel cN cr wcel cN
    c1 cmin co cr wcel cN nn0re cN peano2rem syl syl2an cM cN nn0ltp1le
    3bitr4rd $.
    $( [4-Jul-2004] $) $( [10-May-2004] $)

  $( A number is less than or equal to itself plus a nonnegative integer. $)
  nn0addge1 $p |- ( ( A e. RR /\ N e. NN0 ) -> A <_ ( A + N ) ) $=
    cA cr wcel cN cr wcel cc0 cN cle wbr wa cA cA cN caddc co cle wbr cN cn0
    wcel cA cr wcel cN cr wcel cc0 cN cle wbr cA cA cN caddc co cle wbr cA cr
    wcel cN cr wcel cc0 cN cle wbr cA cA cN caddc co cle wbr cA cN addge01
    biimp3a 3expb cN cn0 wcel cN cr wcel cc0 cN cle wbr cN nn0re cN nn0ge0 jca
    sylan2 $.
    $( [25-Jul-2006] $) $( [10-Mar-2005] $)

  $( A number is less than or equal to itself plus a nonnegative integer. $)
  nn0addge2 $p |- ( ( A e. RR /\ N e. NN0 ) -> A <_ ( N + A ) ) $=
    cA cr wcel cN cr wcel cc0 cN cle wbr wa cA cN cA caddc co cle wbr cN cn0
    wcel cA cr wcel cN cr wcel cc0 cN cle wbr cA cN cA caddc co cle wbr cA cr
    wcel cN cr wcel cc0 cN cle wbr cA cN cA caddc co cle wbr cA cN addge02
    biimp3a 3expb cN cn0 wcel cN cr wcel cc0 cN cle wbr cN nn0re cN nn0ge0 jca
    sylan2 $.
    $( [25-Jul-2006] $) $( [10-Mar-2005] $)

  ${
    nn0addge1.1 $e |- A e. RR $.
    nn0addge1.2 $e |- N e. NN0 $.
    $( A number is less than or equal to itself plus a nonnegative integer. $)
    nn0addge1i $p |- A <_ ( A + N ) $=
      cA cr wcel cN cn0 wcel cA cA cN caddc co cle wbr nn0addge1.1 nn0addge1.2
      cA cN nn0addge1 mp2an $.
      $( [13-Mar-2005] $) $( [10-Mar-2005] $)

    $( A number is less than or equal to itself plus a nonnegative integer. $)
    nn0addge2i $p |- A <_ ( N + A ) $=
      cA cr wcel cN cn0 wcel cA cN cA caddc co cle wbr nn0addge1.1 nn0addge1.2
      cA cN nn0addge2 mp2an $.
      $( [13-Mar-2005] $) $( [10-Mar-2005] $)
  $}

  ${
    nn0le2x.1 $e |- N e. NN0 $.
    $( A nonnegative integer is less than or equal to twice itself.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0le2xi $p |- N <_ ( 2 x. N ) $=
      cN cN cN caddc co c2 cN cmul co cle cN cN cN nn0le2x.1 nn0rei nn0le2x.1
      nn0addge1i cN cN nn0le2x.1 nn0cni 2timesi breqtrri $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  ${
    nn0lele2x.1 $e |- M e. NN0 $.
    nn0lele2x.2 $e |- N e. NN0 $.
    $( 'Less than or equal to' implies 'less than or equal to twice' for
       nonnegative integers.  (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0lele2xi $p |- ( N <_ M -> N <_ ( 2 x. M ) ) $=
      cN cM cle wbr cM c2 cM cmul co cle wbr cN c2 cM cmul co cle wbr cM
      nn0lele2x.1 nn0le2xi cN cM c2 cM cmul co cN nn0lele2x.2 nn0rei cM
      nn0lele2x.1 nn0rei c2 cM 2re cM nn0lele2x.1 nn0rei remulcli letri mpan2
      $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Integers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the set of integers.  Definition of integers in [Apostol] p. 22. $)
  df-z $a |- ZZ = { n e. RR | ( n = 0 \/ n e. NN \/ -u n e. NN ) } $.

  ${
    $d x N $.
    $( Membership in the set of integers. $)
    elz $p |- ( N e. ZZ <->
              ( N e. RR /\ ( N = 0 \/ N e. NN \/ -u N e. NN ) ) ) $=
      vx cv cc0 wceq vx cv cn wcel vx cv cneg cn wcel w3o cN cc0 wceq cN cn
      wcel cN cneg cn wcel w3o vx cN cr cz vx cv cN wceq vx cv cc0 wceq cN cc0
      wceq vx cv cn wcel cN cn wcel vx cv cneg cn wcel cN cneg cn wcel vx cv cN
      cc0 eqeq1 vx cv cN cn eleq1 vx cv cN wceq vx cv cneg cN cneg cn vx cv cN
      negeq eleq1d 3orbi123d vx df-z elrab2 $.
      $( [8-Jan-2002] $)
  $}

  $( The negative of a natural number is an integer. $)
  nnnegz $p |- ( N e. NN -> -u N e. ZZ ) $=
    cN cneg cz wcel cN cneg cr wcel cN cneg cc0 wceq cN cneg cn wcel cN cneg
    cneg cn wcel w3o cN cn wcel cN cneg elz cN cn wcel cN cr wcel cN cneg cr
    wcel cN nnre cN renegcl syl cN cn wcel cN cneg cc0 wceq cN cneg cn wcel wo
    cN cneg cneg cn wcel wo cN cneg cc0 wceq cN cneg cn wcel cN cneg cneg cn
    wcel w3o cN cn wcel cN cneg cneg cn wcel cN cneg cc0 wceq cN cneg cn wcel
    wo cN cc wcel cN cn wcel cN cneg cneg cn wcel cN nncn cN cc wcel cN cneg
    cneg cn wcel cN cn wcel cN cc wcel cN cneg cneg cN cn cN negneg eleq1d
    biimprd mpcom olcd cN cneg cc0 wceq cN cneg cn wcel cN cneg cneg cn wcel
    df-3or sylibr sylanbrc $.
    $( [12-Jan-2002] $)

  $( An integer is a real. $)
  zre $p |- ( N e. ZZ -> N e. RR ) $=
    cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o cN elz
    pm3.26bi $.
    $( [8-Jan-2002] $)

  $( An integer is a complex number. $)
  zcn $p |- ( N e. ZZ -> N e. CC ) $=
    cN cz wcel cN cN zre recnd $.
    $( [6-Jun-2004] $) $( [9-May-2004] $)

  ${
    zre.1 $e |- A e. ZZ $.
    $( An integer is a real number. $)
    zrei $p |- A e. RR $=
      cA cz wcel cA cr wcel zre.1 cA zre ax-mp $.
      $( [15-Jul-2005] $) $( [14-Jul-2005] $)
  $}

  $( The integers are a subset of the reals. $)
  zssre $p |- ZZ C_ RR $=
    vx cz cr vx cv zre ssriv $.
    $( [5-Sep-2004] $) $( [2-Aug-2004] $)

  $( The integers are a subset of the complex numbers. $)
  zsscn $p |- ZZ C_ CC $=
    vx cz cc vx cv zcn ssriv $.
    $( [10-Sep-2004] $) $( [2-Aug-2004] $)

  $( The set of integers exists. $)
  zex $p |- ZZ e. _V $=
    cz cc axcnex zsscn ssexi $.
    $( [25-Sep-2004] $) $( [30-Jul-2004] $)

  $( Natural number property expressed in terms of integers. $)
  elnnz $p |- ( N e. NN <-> ( N e. ZZ /\ 0 < N ) ) $=
    cN cn wcel cN cr wcel cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo wa cc0
    cN clt wbr wa cN cz wcel cc0 cN clt wbr wa cN cn wcel cN cr wcel cN cn wcel
    cN cneg cn wcel cN cc0 wceq wo wo wa cc0 cN clt wbr wa cN cn wcel cN cr
    wcel cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo cc0 cN clt wbr cN nnre cN
    cn wcel cN cneg cn wcel cN cc0 wceq wo orc cN nngt0 jca31 cN cr wcel cN cn
    wcel cN cneg cn wcel cN cc0 wceq wo wo cc0 cN clt wbr cN cn wcel cN cr wcel
    cc0 cN clt wbr cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo cN cn wcel cN
    cr wcel cc0 cN clt wbr cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo cN cn
    wcel wi cN cr wcel cc0 cN clt wbr wa cN cn wcel cN cn wcel cN cneg cn wcel
    cN cc0 wceq wo cN cr wcel cc0 cN clt wbr wa cN cn wcel idd cN cr wcel cc0
    cN clt wbr wa cN cneg cn wcel cN cc0 wceq wo cN cn wcel cN cneg cn wcel cN
    cc0 wceq wo wn cN cneg cn wcel wn cN cc0 wceq wn cN cr wcel cc0 cN clt wbr
    wa cN cneg cn wcel cN cc0 wceq ioran cN cr wcel cc0 cN clt wbr wa cc0 cN
    cneg clt wbr cN cneg cn wcel cN cr wcel cc0 cN clt wbr cc0 cN cneg clt wbr
    wn cN cr wcel cc0 cN clt wbr cN cneg cc0 clt wbr cc0 cN cneg clt wbr wn cN
    lt0neg2 cN cneg cr wcel cc0 cr wcel cN cneg cc0 clt wbr cc0 cN cneg clt wbr
    wn wi cN cr wcel cN cneg cc0 ltnsym cN renegcl 0re sylancl sylbid imp cN
    cneg nngt0 nsyl cN cr wcel cc0 cN clt wbr wa cN cc0 wne cN cc0 wceq wn cN
    gt0ne0 cN cc0 df-ne sylib sylanbrc pm2.21d jaod ex com23 imp31 impbii cN cz
    wcel cN cr wcel cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo wa cc0 cN clt
    wbr cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN
    cr wcel cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo wa cN elz cN cc0 wceq
    cN cn wcel cN cneg cn wcel w3o cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo
    cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o cN cn wcel cN cneg cn
    wcel cN cc0 wceq w3o cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo cN cc0
    wceq cN cn wcel cN cneg cn wcel 3orrot cN cn wcel cN cneg cn wcel cN cc0
    wceq 3orass bitri anbi2i bitri anbi1i bitr4i $.
    $( [8-Jan-2002] $)

  $( Zero is an integer. $)
  0z $p |- 0 e. ZZ $=
    cc0 cz wcel cc0 cr wcel cc0 cc0 wceq cc0 cn wcel cc0 cneg cn wcel w3o cc0
    elz 0re cc0 cc0 wceq cc0 cn wcel cc0 cneg cn wcel w3o cc0 cc0 wceq cc0 cn
    wcel cc0 cneg cn wcel wo wo cc0 cc0 wceq cc0 cn wcel cc0 cneg cn wcel wo
    cc0 eqid orci cc0 cc0 wceq cc0 cn wcel cc0 cneg cn wcel 3orass mpbir
    mpbir2an $.
    $( [12-Jan-2002] $)

  $( Nonnegative integer property expressed in terms of integers. $)
  elnn0z $p |- ( N e. NN0 <-> ( N e. ZZ /\ 0 <_ N ) ) $=
    cN cn0 wcel cN cn wcel cN cc0 wceq wo cN cz wcel cc0 cN clt wbr wa cc0 cN
    wceq wo cN cz wcel cc0 cN cle wbr wa cN elnn0 cN cn wcel cN cz wcel cc0 cN
    clt wbr wa cN cc0 wceq cc0 cN wceq cN elnnz cN cc0 eqcom orbi12i cN cz wcel
    cc0 cN wceq wo cc0 cN clt wbr cc0 cN wceq wo wa cN cz wcel cc0 cN clt wbr
    cc0 cN wceq wo wa cN cz wcel cc0 cN clt wbr wa cc0 cN wceq wo cN cz wcel
    cc0 cN cle wbr wa cN cz wcel cc0 cN wceq wo cN cz wcel cc0 cN clt wbr cc0
    cN wceq wo cN cz wcel cc0 cN wceq wo cN cz wcel cN cz wcel cN cz wcel cc0
    cN wceq cN cz wcel id cc0 cN wceq cc0 cz wcel cN cz wcel 0z cc0 cN cz eleq1
    mpbii jaoi cN cz wcel cc0 cN wceq orc impbii anbi1i cN cz wcel cc0 cN clt
    wbr cc0 cN wceq ordir cN cz wcel cc0 cN cle wbr cc0 cN clt wbr cc0 cN wceq
    wo cc0 cr wcel cN cr wcel cc0 cN cle wbr cc0 cN clt wbr cc0 cN wceq wo wb
    cN cz wcel cc0 cN leloe 0re cN zre sylancr pm5.32i 3bitr4i 3bitri $.
    $( [7-Jun-2004] $) $( [9-May-2004] $)

  $( Integer property expressed in terms nonnegative integers and natural
     numbers. $)
  elznn0nn $p |- ( N e. ZZ <-> ( N e. NN0 \/ ( N e. RR /\ -u N e. NN ) ) ) $=
    cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN cr
    wcel cN cc0 wceq cN cn wcel wo cN cneg cn wcel wo wa cN cn0 wcel cN cr wcel
    cN cneg cn wcel wa wo cN elz cN cc0 wceq cN cn wcel cN cneg cn wcel w3o cN
    cc0 wceq cN cn wcel wo cN cneg cn wcel wo cN cr wcel cN cc0 wceq cN cn wcel
    cN cneg cn wcel df-3or anbi2i cN cr wcel cN cc0 wceq cN cn wcel wo cN cneg
    cn wcel wo wa cN cr wcel cN cc0 wceq cN cn wcel wo wa cN cr wcel cN cneg cn
    wcel wa wo cN cn0 wcel cN cr wcel cN cneg cn wcel wa wo cN cr wcel cN cc0
    wceq cN cn wcel wo cN cneg cn wcel andi cN cn0 wcel cN cr wcel cN cc0 wceq
    cN cn wcel wo wa cN cr wcel cN cneg cn wcel wa cN cn0 wcel cN cr wcel cN
    cn0 wcel wa cN cr wcel cN cc0 wceq cN cn wcel wo wa cN cn0 wcel cN cr wcel
    cN nn0re pm4.71ri cN cn0 wcel cN cc0 wceq cN cn wcel wo cN cr wcel cN cn0
    wcel cN cn wcel cN cc0 wceq wo cN cc0 wceq cN cn wcel wo cN elnn0 cN cn
    wcel cN cc0 wceq orcom bitri anbi2i bitri orbi1i bitr4i 3bitri $.
    $( [4-Jul-2004] $) $( [10-May-2004] $)

  $( Integer property expressed in terms of nonnegative integers. $)
  elznn0 $p |- ( N e. ZZ <-> ( N e. RR /\ ( N e. NN0 \/ -u N e. NN0 ) ) ) $=
    cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN cr
    wcel cN cn0 wcel cN cneg cn0 wcel wo wa cN elz cN cr wcel cN cc0 wceq cN cn
    wcel cN cneg cn wcel w3o cN cn0 wcel cN cneg cn0 wcel wo cN cr wcel cN cn0
    wcel cN cneg cn0 wcel wo cN cn wcel cN cc0 wceq wo cN cneg cn wcel cN cc0
    wceq wo wo cN cc0 wceq cN cn wcel cN cneg cn wcel w3o cN cr wcel cN cn0
    wcel cN cn wcel cN cc0 wceq wo cN cneg cn0 wcel cN cneg cn wcel cN cc0 wceq
    wo cN cn0 wcel cN cn wcel cN cc0 wceq wo wb cN cr wcel cN elnn0 a1i cN cr
    wcel cN cneg cn wcel cN cneg cc0 wceq wo cN cneg cn wcel cN cc0 wceq wo cN
    cneg cn0 wcel cN cr wcel cN cneg cc0 wceq cN cc0 wceq cN cneg cn wcel cN cr
    wcel cN cneg cc0 wceq cc0 cneg cN wceq cN cc0 wceq cN cc wcel cc0 cc wcel
    cN cneg cc0 wceq cc0 cneg cN wceq wb cN cr wcel cN cc0 negcon1 cN recn 0cn
    sylancl cc0 cneg cN wceq cc0 cN wceq cN cc0 wceq cc0 cneg cc0 cN neg0
    eqeq1i cc0 cN eqcom bitri syl6bb orbi2d cN cneg elnn0 syl5bb orbi12d cN cc0
    wceq cN cn wcel cN cneg cn wcel w3o cN cc0 wceq cN cn wcel cN cneg cn wcel
    wo wo cN cn wcel cN cneg cn wcel wo cN cc0 wceq wo cN cn wcel cN cc0 wceq
    wo cN cneg cn wcel cN cc0 wceq wo wo cN cc0 wceq cN cn wcel cN cneg cn wcel
    3orass cN cc0 wceq cN cn wcel cN cneg cn wcel wo orcom cN cn wcel cN cneg
    cn wcel cN cc0 wceq orordir 3bitrri syl6rbb pm5.32i bitri $.
    $( [7-Jun-2004] $) $( [9-May-2004] $)

  $( Integer property expressed in terms natural numbers and nonnegative
     integers. $)
  elznn $p |- ( N e. ZZ <-> ( N e. RR /\ ( N e. NN \/ -u N e. NN0 ) ) ) $=
    cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN cr
    wcel cN cn wcel cN cneg cn0 wcel wo wa cN elz cN cr wcel cN cc0 wceq cN cn
    wcel cN cneg cn wcel w3o cN cn wcel cN cneg cn0 wcel wo cN cr wcel cN cn
    wcel cN cneg cn0 wcel wo cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo cN
    cc0 wceq cN cn wcel cN cneg cn wcel w3o cN cr wcel cN cneg cn0 wcel cN cneg
    cn wcel cN cc0 wceq wo cN cn wcel cN cr wcel cN cneg cn wcel cN cc0 wceq wo
    cN cneg cn wcel cN cneg cc0 wceq wo cN cneg cn0 wcel cN cr wcel cN cc0 wceq
    cN cneg cc0 wceq cN cneg cn wcel cN cr wcel cN cc wcel cN cc0 wceq cN cneg
    cc0 wceq wb cN recn cN negeq0 syl orbi2d cN cneg elnn0 syl6rbbr orbi2d cN
    cc0 wceq cN cn wcel cN cneg cn wcel w3o cN cn wcel cN cneg cn wcel cN cc0
    wceq w3o cN cn wcel cN cneg cn wcel cN cc0 wceq wo wo cN cc0 wceq cN cn
    wcel cN cneg cn wcel 3orrot cN cn wcel cN cneg cn wcel cN cc0 wceq 3orass
    bitri syl6rbbr pm5.32i bitri $.
    $( [18-Jul-2005] $) $( [12-Jul-2005] $)

  $( Natural numbers are a subset of integers. $)
  nnssz $p |- NN C_ ZZ $=
    vx cn cz vx cv cn wcel vx cv cz wcel cc0 vx cv clt wbr vx cv elnnz pm3.26bi
    ssriv $.
    $( [9-Jan-2002] $)

  $( Nonnegative integers are a subset of the integers. $)
  nn0ssz $p |- NN0 C_ ZZ $=
    cn0 cn cc0 csn cun cz df-n0 cn cc0 csn cz nnssz cc0 cz wcel cc0 csn cz wss
    0z cc0 cz cc0 cz 0z elisseti snss mpbi unssi eqsstri $.
    $( [5-Jul-2004] $) $( [9-May-2004] $)

  $( A natural number is an integer. $)
  nnz $p |- ( N e. NN -> N e. ZZ ) $=
    cn cz cN nnssz sseli $.
    $( [4-Jun-2004] $) $( [9-May-2004] $)

  $( A nonnegative integer is an integer. $)
  nn0z $p |- ( N e. NN0 -> N e. ZZ ) $=
    cn0 cz cN nn0ssz sseli $.
    $( [5-Jul-2004] $) $( [9-May-2004] $)

  $( Natural number property expressed in terms of integers. $)
  elnnz1 $p |- ( N e. NN <-> ( N e. ZZ /\ 1 <_ N ) ) $=
    cN cn wcel cN cz wcel c1 cN cle wbr wa cN cn wcel cN cz wcel c1 cN cle wbr
    cN nnz cN nnge1 jca cN cz wcel c1 cN cle wbr wa cN cneg cn wcel cN cc0 wceq
    wo wn cN cn wcel cN cneg cn wcel cN cc0 wceq wo wn cN cneg cn wcel wn cN
    cc0 wceq wn cN cz wcel c1 cN cle wbr wa cN cneg cn wcel cN cc0 wceq ioran
    cN cz wcel c1 cN cle wbr wa cc0 cN cneg clt wbr cN cneg cn wcel cN cr wcel
    c1 cN cle wbr cc0 cN cneg clt wbr wn cN cz wcel cN cr wcel c1 cN cle wbr wa
    cN cneg cc0 cle wbr cc0 cN cneg clt wbr wn cN cr wcel c1 cN cle wbr wa c1
    cneg cc0 clt wbr cN cneg cc0 cle wbr cc0 c1 clt wbr c1 cneg cc0 clt wbr
    lt01 c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr wb 1re c1 lt0neg2 ax-mp
    mpbi cN cr wcel c1 cN cle wbr c1 cneg cc0 clt wbr cN cneg cc0 cle wbr wi cN
    cr wcel c1 cN cle wbr cN cneg c1 cneg cle wbr c1 cneg cc0 clt wbr cN cneg
    cc0 cle wbr wi c1 cr wcel cN cr wcel c1 cN cle wbr cN cneg c1 cneg cle wbr
    wb 1re c1 cN leneg mpan cN cr wcel cN cneg c1 cneg cle wbr c1 cneg cc0 clt
    wbr cN cneg cc0 cle wbr cN cr wcel cN cneg cr wcel cN cneg c1 cneg cle wbr
    c1 cneg cc0 clt wbr wa cN cneg cc0 cle wbr wi cN renegcl cN cneg cr wcel cN
    cneg c1 cneg cle wbr c1 cneg cc0 clt wbr wa cN cneg cc0 clt wbr cN cneg cc0
    cle wbr cN cneg cr wcel c1 cneg cr wcel cc0 cr wcel cN cneg c1 cneg cle wbr
    c1 cneg cc0 clt wbr wa cN cneg cc0 clt wbr wi c1 1re renegcli 0re cN cneg
    c1 cneg cc0 lelttr mp3an23 cN cneg cr wcel cc0 cr wcel cN cneg cc0 clt wbr
    cN cneg cc0 cle wbr wi 0re cN cneg cc0 ltle mpan2 syld syl exp3a sylbid imp
    mpi cN cr wcel cN cneg cc0 cle wbr cc0 cN cneg clt wbr wn wb c1 cN cle wbr
    cN cneg cr wcel cc0 cr wcel cN cneg cc0 cle wbr cc0 cN cneg clt wbr wn wb
    cN cr wcel cN cneg cc0 lenlt cN renegcl 0re sylancl adantr mpbid cN zre
    sylan cN cneg nngt0 nsyl c1 cN cle wbr cN cc0 wceq wn cN cz wcel cN cc0
    wceq c1 cN cle wbr cN cc0 wceq cc0 c1 clt wbr c1 cN cle wbr wn lt01 cN cc0
    wceq c1 cN cle wbr cc0 c1 clt wbr cN cc0 wceq c1 cN cle wbr c1 cc0 cle wbr
    cc0 c1 clt wbr wn cN cc0 c1 cle breq2 c1 cc0 1re 0re lenlti syl6bb con2bid
    mpbii con2i adantl sylanbrc cN cz wcel cN cneg cn wcel cN cc0 wceq wo wn cN
    cn wcel wi c1 cN cle wbr cN cz wcel cN cneg cn wcel cN cc0 wceq wo cN cn
    wcel cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN
    cneg cn wcel cN cc0 wceq wo cN cn wcel wo cN elz cN cr wcel cN cc0 wceq cN
    cn wcel cN cneg cn wcel w3o wa cN cc0 wceq cN cn wcel cN cneg cn wcel w3o
    cN cneg cn wcel cN cc0 wceq wo cN cn wcel wo cN cr wcel cN cc0 wceq cN cn
    wcel cN cneg cn wcel w3o pm3.27 cN cc0 wceq cN cn wcel cN cneg cn wcel w3o
    cN cneg cn wcel cN cc0 wceq cN cn wcel w3o cN cneg cn wcel cN cc0 wceq wo
    cN cn wcel wo cN cneg cn wcel cN cc0 wceq cN cn wcel 3orrot cN cneg cn wcel
    cN cc0 wceq cN cn wcel df-3or bitr3i sylib sylbi ord adantr mpd impbii $.
    $( [9-Jun-2004] $) $( [10-May-2004] $)

  $( An integer is not a natural number iff it is less than one. $)
  znnnlt1 $p |- ( N e. ZZ -> ( -. N e. NN <-> N < 1 ) ) $=
    cN cz wcel cN cn wcel wn c1 cN cle wbr wn cN c1 clt wbr cN cz wcel cN cn
    wcel c1 cN cle wbr cN cn wcel cN cz wcel c1 cN cle wbr cN elnnz1 baib
    notbid cN cr wcel c1 cr wcel cN c1 clt wbr c1 cN cle wbr wn wb cN cz wcel
    cN c1 ltnle cN zre 1re sylancl bitr4d $.
    $( [20-Jul-2005] $) $( [13-Jul-2005] $)

  $( Natural numbers expressed as a subset of integers. $)
  nnzrab $p |- NN = { x e. ZZ | 1 <_ x } $=
    cn vx cv cz wcel c1 vx cv cle wbr wa vx cab c1 vx cv cle wbr vx cz crab vx
    cv cz wcel c1 vx cv cle wbr wa vx cn vx cv elnnz1 abbi2i c1 vx cv cle wbr
    vx cz df-rab eqtr4i $.
    $( [17-Oct-2004] $) $( [3-Oct-2004] $)

  $( Nonnegative integers expressed as a subset of integers. $)
  nn0zrab $p |- NN0 = { x e. ZZ | 0 <_ x } $=
    cn0 vx cv cz wcel cc0 vx cv cle wbr wa vx cab cc0 vx cv cle wbr vx cz crab
    vx cv cz wcel cc0 vx cv cle wbr wa vx cn0 vx cv elnn0z abbi2i cc0 vx cv cle
    wbr vx cz df-rab eqtr4i $.
    $( [21-Oct-2004] $) $( [3-Oct-2004] $)

  $( One is an integer. $)
  1z $p |- 1 e. ZZ $=
    c1 cn wcel c1 cz wcel 1nn c1 nnz ax-mp $.
    $( [4-Jun-2004] $) $( [10-May-2004] $)

  $( Two is an integer. $)
  2z $p |- 2 e. ZZ $=
    c2 cn wcel c2 cz wcel 2nn c2 nnz ax-mp $.
    $( [5-Jul-2004] $) $( [10-May-2004] $)

  $( Subtraction of nonnegative integers. $)
  nn0sub $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M <_ N <-> ( N - M ) e. NN0 ) ) $=
    cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq wo cM cN cle wbr cN cM
    cmin co cn0 wcel wb cM cn0 wcel cN cn0 wcel cM cn wcel cM cc0 wceq wo cN cn
    wcel cN cc0 wceq wo wa cM cN clt wbr cM cN wceq wo cN cM cmin co cn wcel cN
    cM cmin co cc0 wceq wo cM cN cle wbr cN cM cmin co cn0 wcel cM cn wcel cM
    cc0 wceq wo cN cn wcel cN cc0 wceq wo wa cM cN clt wbr cN cM cmin co cn
    wcel cM cN wceq cN cM cmin co cc0 wceq cM cn wcel cM cc0 wceq wo cN cn wcel
    cN cc0 wceq wo cM cN clt wbr cN cM cmin co cn wcel wb cM cn wcel cN cn wcel
    cN cc0 wceq wo cM cN clt wbr cN cM cmin co cn wcel wb wi cM cc0 wceq cM cn
    wcel cN cn wcel cM cN clt wbr cN cM cmin co cn wcel wb cN cc0 wceq cM cn
    wcel cN cn wcel cM cN clt wbr cN cM cmin co cn wcel wb cM cN nnsub ex cN
    cc0 wceq cM cN clt wbr cN cM cmin co cn wcel wb cM cc0 clt wbr cc0 cM cmin
    co cn wcel wb cM cn wcel cN cc0 wceq cM cN clt wbr cM cc0 clt wbr cN cM
    cmin co cn wcel cc0 cM cmin co cn wcel cN cc0 cM clt breq2 cN cc0 wceq cN
    cM cmin co cc0 cM cmin co cn cN cc0 cM cmin opreq1 eleq1d bibi12d cM cn
    wcel cM cc0 clt wbr cc0 cM cneg clt wbr cc0 cM cmin co cn wcel cM cn wcel
    cM cr wcel cM cc0 clt wbr cc0 cM cneg clt wbr wb cM nnre cM lt0neg1 syl cM
    cn wcel cM cneg cn wcel cc0 cM cneg clt wbr cc0 cM cmin co cn wcel cM cn
    wcel cM cneg cz wcel cM cneg cn wcel cc0 cM cneg clt wbr wb cM nnnegz cM
    cneg cn wcel cM cneg cz wcel cc0 cM cneg clt wbr cM cneg elnnz baib syl cM
    cneg cc0 cM cmin co cn cM df-neg eleq1i syl5rbbr bitrd syl5cbir jaod cM cc0
    wceq cN cn wcel cM cN clt wbr cN cM cmin co cn wcel wb cN cc0 wceq cM cc0
    wceq cM cN clt wbr cN cM cmin co cn wcel wb cc0 cN clt wbr cN cc0 cmin co
    cn wcel wb cN cn wcel cM cc0 wceq cM cN clt wbr cc0 cN clt wbr cN cM cmin
    co cn wcel cN cc0 cmin co cn wcel cM cc0 cN clt breq1 cM cc0 wceq cN cM
    cmin co cN cc0 cmin co cn cM cc0 cN cmin opreq2 eleq1d bibi12d cN cn wcel
    cN cz wcel cc0 cN clt wbr cN cc0 cmin co cn wcel wb cN nnz cN cz wcel cN
    cc0 cmin co cn wcel cN cn wcel cc0 cN clt wbr cN cz wcel cN cc wcel cN cc0
    cmin co cn wcel cN cn wcel wb cN zcn cN cc wcel cN cc0 cmin co cN cn cN
    subid1 eleq1d syl cN cn wcel cN cz wcel cc0 cN clt wbr cN elnnz baib bitr2d
    syl syl5bir cM cc0 wceq cM cN clt wbr cN cM cmin co cn wcel wb cc0 cN clt
    wbr cN cc0 cmin co cn wcel wb cN cc0 wceq cM cc0 wceq cM cN clt wbr cc0 cN
    clt wbr cN cM cmin co cn wcel cN cc0 cmin co cn wcel cM cc0 cN clt breq1 cM
    cc0 wceq cN cM cmin co cN cc0 cmin co cn cM cc0 cN cmin opreq2 eleq1d
    bibi12d cN cc0 wceq cc0 cN clt wbr cN cc0 cmin co cn wcel wb cc0 cc0 clt
    wbr cc0 cc0 cmin co cn wcel wb cc0 cc0 clt wbr cc0 cc0 cmin co cn wcel cc0
    0re ltnri cc0 cc0 cmin co cn wcel cc0 cn wcel 0nnn cc0 cc0 cmin co cc0 cn
    cc0 0cn subidi eleq1i mtbir 2false cN cc0 wceq cc0 cN clt wbr cc0 cc0 clt
    wbr cN cc0 cmin co cn wcel cc0 cc0 cmin co cn wcel cN cc0 cc0 clt breq2 cN
    cc0 wceq cN cc0 cmin co cc0 cc0 cmin co cn cN cc0 cc0 cmin opreq1 eleq1d
    bibi12d mpbiri syl5bir jaod jaoi imp cM cc wcel cN cc wcel cM cN wceq cN cM
    cmin co cc0 wceq wb cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq wo cN
    cc wcel cM cc wcel cM cN wceq cN cM cmin co cc0 wceq wb cN cc wcel cM cc
    wcel wa cN cM cmin co cc0 wceq cN cM wceq cM cN wceq cN cM subeq0 cM cN
    eqcom syl6rbbr ancoms cM cn wcel cM cc wcel cM cc0 wceq cM nncn cM cc0 wceq
    cM cc wcel cc0 cc wcel 0cn cM cc0 cc eleq1 mpbiri jaoi cN cn wcel cN cc
    wcel cN cc0 wceq cN nncn cN cc0 wceq cN cc wcel cc0 cc wcel 0cn cN cc0 cc
    eleq1 mpbiri jaoi syl2an orbi12d cM cr wcel cN cr wcel cM cN cle wbr cM cN
    clt wbr cM cN wceq wo wb cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq
    wo cM cN leloe cM cn wcel cM cr wcel cM cc0 wceq cM nnre cM cc0 wceq cM cr
    wcel cc0 cr wcel 0re cM cc0 cr eleq1 mpbiri jaoi cN cn wcel cN cr wcel cN
    cc0 wceq cN nnre cN cc0 wceq cN cr wcel cc0 cr wcel 0re cN cc0 cr eleq1
    mpbiri jaoi syl2an cN cM cmin co cn0 wcel cN cM cmin co cn wcel cN cM cmin
    co cc0 wceq wo wb cM cn wcel cM cc0 wceq wo cN cn wcel cN cc0 wceq wo wa cN
    cM cmin co elnn0 a1i 3bitr4d cM elnn0 cN elnn0 syl2anb $.
    $( [9-Jun-2004] $) $( [9-May-2004] $)

  $( Subtraction of nonnegative integers. $)
  nn0sub2 $p |- ( ( M e. NN0 /\ N e. NN0 /\ M <_ N ) -> ( N - M ) e. NN0 ) $=
    cM cn0 wcel cN cn0 wcel cM cN cle wbr cN cM cmin co cn0 wcel cM cN nn0sub
    biimp3a $.
    $( [4-Oct-2005] $) $( [4-Sep-2005] $)

  $( Closure law for negative integers. $)
  znegcl $p |- ( N e. ZZ -> -u N e. ZZ ) $=
    cN cz wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN cneg
    cz wcel cN elz cN cc0 wceq cN cn wcel cN cneg cn wcel w3o cN cneg cz wcel
    cN cr wcel cN cc0 wceq cN cneg cz wcel cN cn wcel cN cneg cn wcel cN cc0
    wceq cN cneg cc0 cz cN cc0 wceq cN cneg cc0 cneg cc0 cN cc0 negeq neg0
    syl6eq 0z syl6eqel cN nnnegz cN cneg nnz 3jaoi adantl sylbi $.
    $( [11-Jun-2004] $) $( [9-May-2004] $)

  $( The negative of a nonnegative integer is an integer. $)
  nn0negz $p |- ( N e. NN0 -> -u N e. ZZ ) $=
    cN cn0 wcel cN cz wcel cN cneg cz wcel cN nn0z cN znegcl syl $.
    $( [10-Sep-2004] $) $( [9-May-2004] $)

  $( Closure of addition of integers. $)
  zaddcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M + N ) e. ZZ ) $=
    cM cr wcel cM cn0 wcel cM cneg cn0 wcel wo wa cN cr wcel cN cn0 wcel cN
    cneg cn0 wcel wo wa cM cN caddc co cz wcel cM cz wcel cN cz wcel cM cr wcel
    cN cr wcel cM cn0 wcel cM cneg cn0 wcel wo cN cn0 wcel cN cneg cn0 wcel wo
    cM cN caddc co cz wcel cM cr wcel cN cr wcel wa cM cn0 wcel cM cneg cn0
    wcel wo cN cn0 wcel cN cneg cn0 wcel wo wa cM cN caddc co cz wcel cM cr
    wcel cN cr wcel wa cM cn0 wcel cM cneg cn0 wcel wo cN cn0 wcel cN cneg cn0
    wcel wo wa cM cN caddc co cr wcel cM cN caddc co cn0 wcel cM cN caddc co
    cneg cn0 wcel wo wa cM cN caddc co cz wcel cM cr wcel cN cr wcel wa cM cn0
    wcel cN cn0 wcel cM cneg cn0 wcel cN cneg cn0 wcel cM cN caddc co cr wcel
    cM cN caddc co cn0 wcel cM cN caddc co cneg cn0 wcel wo wa cM cr wcel cN cr
    wcel wa cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co
    cneg cn0 wcel wo cM cN caddc co cr wcel cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co cn0 wcel cM cN caddc co cneg cn0 wcel wo wi cM cr wcel cN cr wcel
    wa cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cneg
    cn0 wcel cM cN nn0addcl orcd a1i cM cN readdcl jctild cM cr wcel cN cr wcel
    wa cM cneg cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co
    cneg cn0 wcel wo cM cN caddc co cr wcel cM cr wcel cN cr wcel wa cM cneg
    cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cneg cn0
    wcel wo cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN cn0 wcel wa wa cM cneg
    cN cle wbr cN cM cneg cle wbr wo cM cN caddc co cn0 wcel cM cN caddc co
    cneg cn0 wcel wo cM cr wcel cN cr wcel wa cM cneg cN cle wbr cN cM cneg cle
    wbr wo cM cneg cn0 wcel cN cn0 wcel wa cM cneg cr wcel cN cr wcel cM cneg
    cN cle wbr cN cM cneg cle wbr wo cM cr wcel cM cneg cN letric cM renegcl
    sylan adantr cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN cn0 wcel wa wa cM
    cneg cN cle wbr cM cN caddc co cn0 wcel cN cM cneg cle wbr cM cN caddc co
    cneg cn0 wcel cM cneg cn0 wcel cN cn0 wcel wa cM cneg cN cle wbr cN cM cneg
    cmin co cn0 wcel cM cr wcel cN cr wcel wa cM cN caddc co cn0 wcel cM cneg
    cN nn0sub cM cr wcel cN cr wcel wa cN cM cneg cmin co cM cN caddc co cn0 cM
    cc wcel cN cc wcel cN cM cneg cmin co cM cN caddc co wceq cM cr wcel cN cr
    wcel cM cc wcel cN cc wcel wa cN cM cneg cmin co cN cM caddc co cM cN caddc
    co cN cc wcel cM cc wcel cN cM cneg cmin co cN cM caddc co wceq cN cM
    subneg ancoms cM cN addcom eqtr4d cM recn cN recn syl2an eleq1d sylan9bbr
    cM cneg cn0 wcel cN cn0 wcel wa cN cM cneg cle wbr cM cneg cN cmin co cn0
    wcel cM cr wcel cN cr wcel wa cM cN caddc co cneg cn0 wcel cN cn0 wcel cM
    cneg cn0 wcel cN cM cneg cle wbr cM cneg cN cmin co cn0 wcel wb cN cM cneg
    nn0sub ancoms cM cr wcel cN cr wcel wa cM cneg cN cmin co cM cN caddc co
    cneg cn0 cM cc wcel cN cc wcel cM cneg cN cmin co cM cN caddc co cneg wceq
    cM cr wcel cN cr wcel cM cc wcel cN cc wcel wa cM cN caddc co cneg cM cneg
    cN cneg caddc co cM cneg cN cmin co cM cN negdi cM cneg cc wcel cN cc wcel
    cM cneg cN cneg caddc co cM cneg cN cmin co wceq cM cc wcel cM cneg cN
    negsub cM negcl sylan eqtr2d cM recn cN recn syl2an eleq1d sylan9bbr
    orbi12d mpbid ex cM cN readdcl jctild cM cr wcel cN cr wcel wa cM cn0 wcel
    cN cneg cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cneg cn0 wcel wo
    cM cN caddc co cr wcel cM cr wcel cN cr wcel wa cM cn0 wcel cN cneg cn0
    wcel wa cM cN caddc co cn0 wcel cM cN caddc co cneg cn0 wcel wo cM cr wcel
    cN cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa wa cN cneg cM cle wbr cM cN
    cneg cle wbr wo cM cN caddc co cn0 wcel cM cN caddc co cneg cn0 wcel wo cM
    cr wcel cN cr wcel wa cN cneg cM cle wbr cM cN cneg cle wbr wo cM cn0 wcel
    cN cneg cn0 wcel wa cN cr wcel cM cr wcel cN cneg cM cle wbr cM cN cneg cle
    wbr wo cN cneg cr wcel cM cr wcel cN cneg cM cle wbr cM cN cneg cle wbr wo
    cN cr wcel cN cneg cM letric cN renegcl sylan ancoms adantr cM cr wcel cN
    cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa wa cN cneg cM cle wbr cM cN
    caddc co cn0 wcel cM cN cneg cle wbr cM cN caddc co cneg cn0 wcel cM cn0
    wcel cN cneg cn0 wcel wa cN cneg cM cle wbr cM cN cneg cmin co cn0 wcel cM
    cr wcel cN cr wcel wa cM cN caddc co cn0 wcel cN cneg cn0 wcel cM cn0 wcel
    cN cneg cM cle wbr cM cN cneg cmin co cn0 wcel wb cN cneg cM nn0sub ancoms
    cM cr wcel cN cr wcel wa cM cN cneg cmin co cM cN caddc co cn0 cM cc wcel
    cN cc wcel cM cN cneg cmin co cM cN caddc co wceq cM cr wcel cN cr wcel cM
    cN subneg cM recn cN recn syl2an eleq1d sylan9bbr cM cn0 wcel cN cneg cn0
    wcel wa cM cN cneg cle wbr cN cneg cM cmin co cn0 wcel cM cr wcel cN cr
    wcel wa cM cN caddc co cneg cn0 wcel cM cN cneg nn0sub cM cr wcel cN cr
    wcel wa cN cneg cM cmin co cM cN caddc co cneg cn0 cM cc wcel cN cc wcel cN
    cneg cM cmin co cM cN caddc co cneg wceq cM cr wcel cN cr wcel cM cc wcel
    cN cc wcel wa cN cneg cM cmin co cM cneg cN cneg caddc co cM cN caddc co
    cneg cM cc wcel cN cneg cc wcel cN cneg cM cmin co cM cneg cN cneg caddc co
    wceq cN cc wcel cM cc wcel cN cneg cc wcel wa cM cneg cN cneg caddc co cN
    cneg cM cneg caddc co cN cneg cM cmin co cM cneg cc wcel cN cneg cc wcel cM
    cneg cN cneg caddc co cN cneg cM cneg caddc co wceq cM cc wcel cM cneg cN
    cneg addcom cM negcl sylan cN cneg cc wcel cM cc wcel cN cneg cM cneg caddc
    co cN cneg cM cmin co wceq cN cneg cM negsub ancoms eqtr2d cN negcl sylan2
    cM cN negdi eqtr4d cM recn cN recn syl2an eleq1d sylan9bbr orbi12d mpbid ex
    cM cN readdcl jctild cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN cneg cn0
    wcel wa cM cN caddc co cn0 wcel cM cN caddc co cneg cn0 wcel wo cM cN caddc
    co cr wcel cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN cneg cn0 wcel wa cM
    cN caddc co cneg cn0 wcel cM cN caddc co cn0 wcel cM cN caddc co cneg cn0
    wcel wo cM cr wcel cN cr wcel wa cM cN caddc co cneg cn0 wcel cM cneg cN
    cneg caddc co cn0 wcel cM cneg cn0 wcel cN cneg cn0 wcel wa cM cr wcel cN
    cr wcel wa cM cN caddc co cneg cM cneg cN cneg caddc co cn0 cM cc wcel cN
    cc wcel cM cN caddc co cneg cM cneg cN cneg caddc co wceq cM cr wcel cN cr
    wcel cM cN negdi cM recn cN recn syl2an eleq1d cM cneg cN cneg nn0addcl
    syl5bir cM cN caddc co cneg cn0 wcel cM cN caddc co cn0 wcel olc syl6 cM cN
    readdcl jctild ccased cM cN caddc co elznn0 syl6ibr imp an4s cM elznn0 cN
    elznn0 syl2anb $.
    $( [2-Aug-2006] $) $( [9-May-2004] $)

  $( Second Peano postulate generalized to integers. $)
  peano2z $p |- ( N e. ZZ -> ( N + 1 ) e. ZZ ) $=
    cN cz wcel c1 cz wcel cN c1 caddc co cz wcel 1z cN c1 zaddcl mpan2 $.
    $( [14-Feb-2005] $) $( [13-Feb-2005] $)

  ${
    peano2zd.1 $e |- ( ph -> N e. ZZ ) $.
    $( Deduction from second Peano postulate generalized to integers. $)
    peano2zdi $p |- ( ph -> ( N + 1 ) e. ZZ ) $=
      wph cN cz wcel cN c1 caddc co cz wcel peano2zd.1 cN peano2z syl $.
      $( [26-Nov-2005] $) $( [26-Nov-2005] $)
  $}

  $( Closure of subtraction of integers. $)
  zsubcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M - N ) e. ZZ ) $=
    cM cz wcel cN cz wcel wa cM cN cneg caddc co cM cN cmin co cz cM cc wcel cN
    cc wcel cM cN cneg caddc co cM cN cmin co wceq cM cz wcel cN cz wcel cM cN
    negsub cM zcn cN zcn syl2an cM cz wcel cN cneg cz wcel cM cN cneg caddc co
    cz wcel cN cz wcel cM cN cneg zaddcl cN znegcl sylan2 eqeltrrd $.
    $( [2-Aug-2006] $) $( [11-May-2004] $)

  $( "Reverse" second Peano postulate for integers. $)
  peano2zm $p |- ( N e. ZZ -> ( N - 1 ) e. ZZ ) $=
    cN cz wcel c1 cz wcel cN c1 cmin co cz wcel 1z cN c1 zsubcl mpan2 $.
    $( [13-Sep-2005] $) $( [12-Sep-2005] $)

  $( Reverse closure law for addition of integers. $)
  zrevaddcl $p |- ( N e. ZZ ->
                   ( ( M e. CC /\ ( M + N ) e. ZZ ) <-> M e. ZZ ) ) $=
    cN cz wcel cM cc wcel cM cN caddc co cz wcel wa cM cc wcel cM cz wcel wa cM
    cz wcel cN cz wcel cM cc wcel cM cN caddc co cz wcel cM cz wcel cN cz wcel
    cM cc wcel wa cM cN caddc co cz wcel cM cz wcel cN cz wcel cM cc wcel wa cM
    cN caddc co cz wcel cM cz wcel cN cz wcel cM cc wcel wa cM cN caddc co cz
    wcel wa cM cN caddc co cN cmin co cM cz cN cz wcel cM cc wcel wa cM cN
    caddc co cN cmin co cM wceq cM cN caddc co cz wcel cM cc wcel cN cz wcel cM
    cN caddc co cN cmin co cM wceq cM cc wcel cN cc wcel cM cN caddc co cN cmin
    co cM wceq cN cz wcel cM cN pncan cN zcn sylan2 ancoms adantr cN cz wcel cM
    cN caddc co cz wcel cM cN caddc co cN cmin co cz wcel cM cc wcel cM cN
    caddc co cz wcel cN cz wcel cM cN caddc co cN cmin co cz wcel cM cN caddc
    co cN zsubcl ancoms adantlr eqeltrrd ex cN cz wcel cM cz wcel cM cN caddc
    co cz wcel wi cM cc wcel cM cz wcel cN cz wcel cM cN caddc co cz wcel cM cN
    zaddcl expcom adantr impbid pm5.32da cM cz wcel cM cc wcel cM zcn pm4.71ri
    syl6bbr $.
    $( [14-Jun-2004] $) $( [11-May-2004] $)

  $( The nonnegative integer property expressed in terms of natural numbers. $)
  elnn0nn $p |- ( N e. NN0 <-> ( N e. CC /\ ( N + 1 ) e. NN ) ) $=
    cN cr wcel cN cn0 wcel wa cN cr wcel cN c1 caddc co cn wcel wa cN cn0 wcel
    cN cc wcel cN c1 caddc co cn wcel wa cN cr wcel cN cn0 wcel cN c1 caddc co
    cn wcel cN cr wcel cN cn wcel cN cc0 wceq wo cN c1 caddc co cn wcel cN cn0
    wcel cN cr wcel cN cn wcel cN cc0 wceq wo cN c1 caddc co cn wcel cN cn wcel
    cN c1 caddc co cn wcel cN cc0 wceq cN peano2nn cN cc0 wceq cN c1 caddc co
    c1 cn cN cc0 wceq cN c1 caddc co cc0 c1 caddc co c1 cN cc0 c1 caddc opreq1
    c1 ax1cn addid2i syl6eq 1nn syl6eqel jaoi cN cr wcel cN c1 caddc co cz wcel
    c1 cN c1 caddc co cle wbr wa cN cn wcel cN cc0 wceq wo cN c1 caddc co cn
    wcel cN cr wcel cN c1 caddc co cz wcel c1 cN c1 caddc co cle wbr wa cN cz
    wcel cc0 cN clt wbr cc0 cN wceq wo wa cN cn wcel cN cc0 wceq wo cN cr wcel
    cN c1 caddc co cz wcel cN cz wcel c1 cN c1 caddc co cle wbr cc0 cN clt wbr
    cc0 cN wceq wo cN cr wcel cN cc wcel cN c1 caddc co cz wcel cN cz wcel wi
    cN recn cN cc wcel cN c1 caddc co cz wcel cN cz wcel cN cc wcel cN c1 caddc
    co cz wcel wa cN cz wcel c1 cz wcel cN cc wcel cN c1 caddc co cz wcel wa cN
    cz wcel wb 1z cN c1 zrevaddcl ax-mp biimpi ex syl cN cr wcel c1 cN c1 caddc
    co cle wbr cc0 cN clt wbr cc0 cN wceq wo cN cr wcel cc0 cN cle wbr c1 cN c1
    caddc co cle wbr cc0 cN clt wbr cc0 cN wceq wo cN cr wcel cc0 cN cle wbr
    cc0 c1 caddc co cN c1 caddc co cle wbr c1 cN c1 caddc co cle wbr cc0 cr
    wcel cN cr wcel c1 cr wcel cc0 cN cle wbr cc0 c1 caddc co cN c1 caddc co
    cle wbr wb 0re 1re cc0 cN c1 leadd1 mp3an13 cc0 c1 caddc co c1 cN c1 caddc
    co cle c1 ax1cn addid2i breq1i syl6bb cc0 cr wcel cN cr wcel cc0 cN cle wbr
    cc0 cN clt wbr cc0 cN wceq wo wb 0re cc0 cN leloe mpan bitr3d biimpd
    anim12d cN cz wcel cc0 cN clt wbr cc0 cN wceq wo wa cN cz wcel cc0 cN clt
    wbr wa cN cz wcel cc0 cN wceq wa wo cN cn wcel cN cc0 wceq wo cN cz wcel
    cc0 cN clt wbr cc0 cN wceq andi cN cn wcel cN cz wcel cc0 cN clt wbr wa cN
    cc0 wceq cN cz wcel cc0 cN wceq wa cN elnnz cN cc0 wceq cc0 cN wceq cN cz
    wcel cc0 cN wceq wa cN cc0 eqcom cc0 cN wceq cN cz wcel cc0 cN wceq cc0 cz
    wcel cN cz wcel 0z cc0 cN cz eleq1 mpbii pm4.71ri bitri orbi12i bitr4i
    syl6ib cN c1 caddc co elnnz1 syl5ib impbid2 cN elnn0 syl5bb pm5.32i cN cn0
    wcel cN cr wcel cN nn0re pm4.71ri cN cc wcel cN c1 caddc co cn wcel wa cN
    cr wcel cN c1 caddc co cn wcel wa cN cc wcel cN c1 caddc co cn wcel wa cN
    cr wcel cN c1 caddc co cn wcel cN cc wcel cN c1 caddc co cz wcel cN cr wcel
    cN c1 caddc co cn wcel cN cc wcel cN c1 caddc co cz wcel wa cN cz wcel cN
    cr wcel c1 cz wcel cN cc wcel cN c1 caddc co cz wcel wa cN cz wcel wb 1z cN
    c1 zrevaddcl ax-mp cN zre sylbi cN c1 caddc co nnz sylan2 cN cc wcel cN c1
    caddc co cn wcel pm3.27 jca cN cr wcel cN cc wcel cN c1 caddc co cn wcel cN
    recn anim1i impbii 3bitr4i $.
    $( [10-Sep-2004] $) $( [10-May-2004] $)

  $( The natural number property expressed in terms of nonnegative integers. $)
  elnnnn0 $p |- ( N e. NN <-> ( N e. CC /\ ( N - 1 ) e. NN0 ) ) $=
    cN cn wcel cN cc wcel cN cn wcel wa cN cc wcel cN c1 cmin co cn0 wcel wa cN
    cn wcel cN cc wcel cN nncn pm4.71ri cN cc wcel cN cn wcel cN c1 cmin co cn0
    wcel cN cc wcel cN cn wcel cN c1 cmin co cc wcel cN c1 cmin co c1 caddc co
    cn wcel wa cN c1 cmin co cn0 wcel cN cc wcel cN c1 cmin co c1 caddc co cn
    wcel cN cn wcel cN c1 cmin co cc wcel cN c1 cmin co c1 caddc co cn wcel wa
    cN cc wcel cN c1 cmin co c1 caddc co cN cn cN cc wcel c1 cc wcel cN c1 cmin
    co c1 caddc co cN wceq ax1cn cN c1 npcan mpan2 eleq1d cN cc wcel cN c1 cmin
    co cc wcel cN c1 cmin co c1 caddc co cn wcel cN cc wcel c1 cc wcel cN c1
    cmin co cc wcel ax1cn cN c1 subcl mpan2 biantrurd bitr3d cN c1 cmin co
    elnn0nn syl6bbr pm5.32i bitri $.
    $( [11-Sep-2004] $) $( [10-May-2004] $)

  $( The natural number property expressed in terms of nonnegative integers. $)
  elnnnn0b $p |- ( N e. NN <-> ( N e. NN0 /\ 0 < N ) ) $=
    cN cn wcel cN cn0 wcel cc0 cN clt wbr wa cN cn wcel cN cn0 wcel cc0 cN clt
    wbr cN nnnn0 cN nngt0 jca cN cz wcel cc0 cN clt wbr cN cn wcel cN cn0 wcel
    cN cn wcel cN cz wcel cc0 cN clt wbr wa cN elnnz biimpri cN nn0z sylan
    impbii $.
    $( [28-Sep-2005] $) $( [1-Sep-2005] $)

  $( The natural number property expressed in terms of nonnegative integers. $)
  elnnnn0c $p |- ( N e. NN <-> ( N e. NN0 /\ 1 <_ N ) ) $=
    cN cn wcel cN cn0 wcel c1 cN cle wbr wa cN cn wcel cN cn0 wcel c1 cN cle
    wbr cN nnnn0 cN nnge1 jca cN cz wcel c1 cN cle wbr cN cn wcel cN cn0 wcel
    cN cn wcel cN cz wcel c1 cN cle wbr wa cN elnnz1 biimpri cN nn0z sylan
    impbii $.
    $( [21-Feb-2006] $) $( [10-Jan-2006] $)

  $( A nonnegative integer plus 1 is a natural number.  (Contributed by Raph
     Levien, 30-Jun-2006.) $)
  nn0p1nn $p |- ( N e. NN0 -> ( N + 1 ) e. NN ) $=
    cN cn0 wcel cN cc wcel cN c1 caddc co cn wcel cN elnn0nn pm3.27bi $.
    $( [30-Jun-2006] $) $( [30-Jun-2006] $)

  $( A natural number minus 1 is a nonnegative integer.  (Contributed by Jason
     Orendorff, 24-Jan-2007.) $)
  nnm1nn0 $p |- ( N e. NN -> ( N - 1 ) e. NN0 ) $=
    cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel cN elnnnn0 pm3.27bi $.
    $( [24-Jan-2007] $) $( [24-Jan-2007] $)

  $( The positive difference of unequal integers is a natural number.
     (Generalization of ~ nnsub .) $)
  znnsub $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M < N <-> ( N - M ) e. NN ) ) $=
    cM cz wcel cN cz wcel wa cM cN clt wbr cN cM cmin co cz wcel cc0 cN cM cmin
    co clt wbr wa cN cM cmin co cn wcel cM cz wcel cN cz wcel wa cM cN clt wbr
    cc0 cN cM cmin co clt wbr cN cM cmin co cz wcel cc0 cN cM cmin co clt wbr
    wa cM cr wcel cN cr wcel cM cN clt wbr cc0 cN cM cmin co clt wbr wb cM cz
    wcel cN cz wcel cM cN posdif cM zre cN zre syl2an cM cz wcel cN cz wcel wa
    cN cM cmin co cz wcel cc0 cN cM cmin co clt wbr cN cz wcel cM cz wcel cN cM
    cmin co cz wcel cN cM zsubcl ancoms biantrurd bitrd cN cM cmin co elnnz
    syl6bbr $.
    $( [11-Sep-2004] $) $( [11-May-2004] $)

  $( The nonnegative difference of integers is a nonnegative integer.
     (Generalization of ~ nn0sub .) $)
  znn0sub $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                ( M <_ N <-> ( N - M ) e. NN0 ) ) $=
    cM cz wcel cN cz wcel wa cM cN cle wbr cN cM cmin co cz wcel cc0 cN cM cmin
    co cle wbr wa cN cM cmin co cn0 wcel cN cz wcel cM cz wcel cM cN cle wbr cN
    cM cmin co cz wcel cc0 cN cM cmin co cle wbr wa wb cN cz wcel cM cz wcel wa
    cc0 cN cM cmin co cle wbr cM cN cle wbr cN cM cmin co cz wcel cc0 cN cM
    cmin co cle wbr wa cN cr wcel cM cr wcel cc0 cN cM cmin co cle wbr cM cN
    cle wbr wb cN cz wcel cM cz wcel cN cM subge0 cN zre cM zre syl2an cN cz
    wcel cM cz wcel wa cN cM cmin co cz wcel cc0 cN cM cmin co cle wbr cN cM
    zsubcl biantrurd bitr3d ancoms cN cM cmin co elnn0z syl6bbr $.
    $( [23-Jul-2005] $) $( [14-Jul-2005] $)

  $( The nonnegative difference of integers is a nonnegative integer. $)
  znn0sub2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ M <_ N ) -> ( N - M ) e. NN0 ) $=
    cM cz wcel cN cz wcel cM cN cle wbr cN cM cmin co cn0 wcel cM cN znn0sub
    biimp3a $.
    $( [5-Sep-2005] $) $( [4-Sep-2005] $)

  $( Closure of multiplication of integers. $)
  zmulcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M x. N ) e. ZZ ) $=
    cM cr wcel cM cn0 wcel cM cneg cn0 wcel wo wa cN cr wcel cN cn0 wcel cN
    cneg cn0 wcel wo wa cM cN cmul co cz wcel cM cz wcel cN cz wcel cM cr wcel
    cN cr wcel cM cn0 wcel cM cneg cn0 wcel wo cN cn0 wcel cN cneg cn0 wcel wo
    cM cN cmul co cz wcel cM cr wcel cN cr wcel wa cM cn0 wcel cM cneg cn0 wcel
    wo cN cn0 wcel cN cneg cn0 wcel wo wa cM cN cmul co cz wcel cM cr wcel cN
    cr wcel wa cM cn0 wcel cM cneg cn0 wcel wo cN cn0 wcel cN cneg cn0 wcel wo
    wa cM cN cmul co cr wcel cM cN cmul co cn0 wcel cM cN cmul co cneg cn0 wcel
    wo wa cM cN cmul co cz wcel cM cr wcel cN cr wcel wa cM cn0 wcel cN cn0
    wcel cM cneg cn0 wcel cN cneg cn0 wcel cM cN cmul co cr wcel cM cN cmul co
    cn0 wcel cM cN cmul co cneg cn0 wcel wo wa cM cr wcel cN cr wcel wa cM cn0
    wcel cN cn0 wcel wa cM cN cmul co cn0 wcel cM cN cmul co cneg cn0 wcel wo
    cM cN cmul co cr wcel cM cn0 wcel cN cn0 wcel wa cM cN cmul co cn0 wcel cM
    cN cmul co cneg cn0 wcel wo wi cM cr wcel cN cr wcel wa cM cn0 wcel cN cn0
    wcel wa cM cN cmul co cn0 wcel cM cN cmul co cneg cn0 wcel cM cN nn0mulcl
    orcd a1i cM cN remulcl jctild cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN
    cn0 wcel wa cM cN cmul co cn0 wcel cM cN cmul co cneg cn0 wcel wo cM cN
    cmul co cr wcel cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN cn0 wcel wa cM
    cN cmul co cneg cn0 wcel cM cN cmul co cn0 wcel cM cN cmul co cneg cn0 wcel
    wo cM cr wcel cN cr wcel wa cM cneg cN cmul co cn0 wcel cM cN cmul co cneg
    cn0 wcel cM cneg cn0 wcel cN cn0 wcel wa cM cr wcel cN cr wcel wa cM cneg
    cN cmul co cM cN cmul co cneg cn0 cM cc wcel cN cc wcel cM cneg cN cmul co
    cM cN cmul co cneg wceq cM cr wcel cN cr wcel cM cN mulneg1 cM recn cN recn
    syl2an eleq1d cM cneg cN nn0mulcl syl5bi cM cN cmul co cneg cn0 wcel cM cN
    cmul co cn0 wcel olc syl6 cM cN remulcl jctild cM cr wcel cN cr wcel wa cM
    cn0 wcel cN cneg cn0 wcel wa cM cN cmul co cn0 wcel cM cN cmul co cneg cn0
    wcel wo cM cN cmul co cr wcel cM cr wcel cN cr wcel wa cM cn0 wcel cN cneg
    cn0 wcel wa cM cN cmul co cneg cn0 wcel cM cN cmul co cn0 wcel cM cN cmul
    co cneg cn0 wcel wo cM cr wcel cN cr wcel wa cM cN cneg cmul co cn0 wcel cM
    cN cmul co cneg cn0 wcel cM cn0 wcel cN cneg cn0 wcel wa cM cr wcel cN cr
    wcel wa cM cN cneg cmul co cM cN cmul co cneg cn0 cM cc wcel cN cc wcel cM
    cN cneg cmul co cM cN cmul co cneg wceq cM cr wcel cN cr wcel cM cN mulneg2
    cM recn cN recn syl2an eleq1d cM cN cneg nn0mulcl syl5bi cM cN cmul co cneg
    cn0 wcel cM cN cmul co cn0 wcel olc syl6 cM cN remulcl jctild cM cr wcel cN
    cr wcel wa cM cneg cn0 wcel cN cneg cn0 wcel wa cM cN cmul co cn0 wcel cM
    cN cmul co cneg cn0 wcel wo cM cN cmul co cr wcel cM cr wcel cN cr wcel wa
    cM cneg cn0 wcel cN cneg cn0 wcel wa cM cN cmul co cn0 wcel cM cN cmul co
    cn0 wcel cM cN cmul co cneg cn0 wcel wo cM cr wcel cN cr wcel wa cM cneg cN
    cneg cmul co cn0 wcel cM cN cmul co cn0 wcel cM cneg cn0 wcel cN cneg cn0
    wcel wa cM cr wcel cN cr wcel wa cM cneg cN cneg cmul co cM cN cmul co cn0
    cM cc wcel cN cc wcel cM cneg cN cneg cmul co cM cN cmul co wceq cM cr wcel
    cN cr wcel cM cN mul2neg cM recn cN recn syl2an eleq1d cM cneg cN cneg
    nn0mulcl syl5bi cM cN cmul co cn0 wcel cM cN cmul co cneg cn0 wcel orc syl6
    cM cN remulcl jctild ccased cM cN cmul co elznn0 syl6ibr imp an4s cM elznn0
    cN elznn0 syl2anb $.
    $( [8-Sep-2004] $) $( [30-Jul-2004] $)

  $( Integer ordering relation. $)
  zltp1le $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M < N <-> ( M + 1 ) <_ N ) ) $=
    cM cr wcel cM cn0 wcel cM cneg cn0 wcel wo wa cN cr wcel cN cn0 wcel cN
    cneg cn0 wcel wo wa cM cN clt wbr cM c1 caddc co cN cle wbr wb cM cz wcel
    cN cz wcel cM cr wcel cN cr wcel cM cn0 wcel cM cneg cn0 wcel wo cN cn0
    wcel cN cneg cn0 wcel wo cM cN clt wbr cM c1 caddc co cN cle wbr wb cM cr
    wcel cN cr wcel wa cM cn0 wcel cM cneg cn0 wcel wo cN cn0 wcel cN cneg cn0
    wcel wo wa cM cN clt wbr cM c1 caddc co cN cle wbr wb cM cr wcel cN cr wcel
    wa cM cn0 wcel cN cn0 wcel cM cneg cn0 wcel cN cneg cn0 wcel cM cN clt wbr
    cM c1 caddc co cN cle wbr wb cM cn0 wcel cN cn0 wcel wa cM cN clt wbr cM c1
    caddc co cN cle wbr wb wi cM cr wcel cN cr wcel wa cM cN nn0ltp1le a1i cM
    cr wcel cN cr wcel wa cM cneg cn0 wcel cN cn0 wcel wa cM cneg cn wcel cM
    cc0 wceq wo cN cn wcel cN cc0 wceq wo wa cM cN clt wbr cM c1 caddc co cN
    cle wbr wb cM cr wcel cM cneg cn0 wcel cN cn0 wcel wa cM cneg cn wcel cM
    cc0 wceq wo cN cn wcel cN cc0 wceq wo wa wb cN cr wcel cM cr wcel cM cneg
    cn0 wcel cM cneg cn wcel cM cc0 wceq wo cN cn0 wcel cN cn wcel cN cc0 wceq
    wo cM cr wcel cM cneg cn wcel cM cneg cc0 wceq wo cM cneg cn wcel cM cc0
    wceq wo cM cneg cn0 wcel cM cr wcel cM cneg cc0 wceq cM cc0 wceq cM cneg cn
    wcel cM cr wcel cM cc wcel cM cneg cc0 wceq cM cc0 wceq wb cM recn cM cc
    wcel cM cneg cc0 wceq cc0 cneg cM wceq cM cc0 wceq cM cc wcel cc0 cc wcel
    cM cneg cc0 wceq cc0 cneg cM wceq wb 0cn cM cc0 negcon1 mpan2 cc0 cneg cM
    wceq cc0 cM wceq cM cc0 wceq cc0 cneg cc0 cM neg0 eqeq1i cc0 cM eqcom bitri
    syl6bb syl orbi2d cM cneg elnn0 syl5bb cN cn0 wcel cN cn wcel cN cc0 wceq
    wo wb cM cr wcel cN elnn0 a1i anbi12d adantr cM cr wcel cN cr wcel wa cM
    cneg cn wcel cN cn wcel cM cc0 wceq cN cc0 wceq cM cN clt wbr cM c1 caddc
    co cN cle wbr wb cM cr wcel cM cneg cn wcel cN cn wcel wa cM cN clt wbr cM
    c1 caddc co cN cle wbr wb wi cN cr wcel cM cr wcel cM cneg cn wcel cN cn
    wcel wa cM cN clt wbr cM c1 caddc co cN cle wbr wa cM cN clt wbr cM c1
    caddc co cN cle wbr wb cM cr wcel cM cneg cn wcel cN cn wcel cM cN clt wbr
    cM c1 caddc co cN cle wbr wa cM cr wcel cM cneg cn wcel cN cn wcel cM cN
    clt wbr cM c1 caddc co cN cle wbr wa cM cr wcel cM cneg cn wcel wa cN cn
    wcel wa cM cN clt wbr cM c1 caddc co cN cle wbr cM cr wcel cM cneg cn wcel
    wa cN cn wcel wa cM cc0 clt wbr cc0 cN clt wbr wa cM cN clt wbr cM cr wcel
    cM cneg cn wcel wa cM cc0 clt wbr cN cn wcel cc0 cN clt wbr cM cr wcel cM
    cneg cn wcel cM cc0 clt wbr cM cr wcel cM cc0 clt wbr cc0 cM cneg clt wbr
    cM cneg cn wcel cM lt0neg1 cM cneg nngt0 syl5bir imp cN nngt0 anim12i cM cr
    wcel cN cn wcel cM cc0 clt wbr cc0 cN clt wbr wa cM cN clt wbr wi cM cneg
    cn wcel cM cr wcel cN cr wcel cM cc0 clt wbr cc0 cN clt wbr wa cM cN clt
    wbr wi cN cn wcel cM cr wcel cc0 cr wcel cN cr wcel cM cc0 clt wbr cc0 cN
    clt wbr wa cM cN clt wbr wi 0re cM cc0 cN axlttrn mp3an2 cN nnre sylan2
    adantlr mpd cM cr wcel cM cneg cn wcel wa cN cn wcel wa cM c1 caddc co c1
    cN cM cr wcel cM c1 caddc co cr wcel cM cneg cn wcel cN cn wcel cM peano2re
    ad2antrr c1 cr wcel cM cr wcel cM cneg cn wcel wa cN cn wcel wa 1re a1i cN
    cn wcel cN cr wcel cM cr wcel cM cneg cn wcel wa cN nnre adantl cM cr wcel
    cM cneg cn wcel wa cM c1 caddc co c1 cle wbr cN cn wcel cM cr wcel cM cneg
    cn wcel wa cM c1 caddc co cc0 c1 caddc co c1 cle cM cr wcel cM cneg cn wcel
    wa cM cc0 cle wbr cM c1 caddc co cc0 c1 caddc co cle wbr cM cr wcel cM cneg
    cn wcel wa cM cc0 clt wbr cM cc0 cle wbr cM cr wcel cM cneg cn wcel cM cc0
    clt wbr cM cr wcel cM cc0 clt wbr cc0 cM cneg clt wbr cM cneg cn wcel cM
    lt0neg1 cM cneg nngt0 syl5bir imp cM cr wcel cM cc0 clt wbr cM cc0 cle wbr
    wi cM cneg cn wcel cM cr wcel cc0 cr wcel cM cc0 clt wbr cM cc0 cle wbr wi
    0re cM cc0 ltle mpan2 adantr mpd cM cr wcel cM cc0 cle wbr cM c1 caddc co
    cc0 c1 caddc co cle wbr wb cM cneg cn wcel cM cr wcel cc0 cr wcel c1 cr
    wcel cM cc0 cle wbr cM c1 caddc co cc0 c1 caddc co cle wbr wb 0re 1re cM
    cc0 c1 leadd1 mp3an23 adantr mpbid c1 ax1cn addid2i syl6breq adantr cN cn
    wcel c1 cN cle wbr cM cr wcel cM cneg cn wcel wa cN nnge1 adantl letrd jca
    exp31 imp3a cM cN clt wbr cM c1 caddc co cN cle wbr pm5.1 syl6 adantr cM
    cc0 wceq cN cn wcel wa cM cN clt wbr cM c1 caddc co cN cle wbr wb wi cM cr
    wcel cN cr wcel wa cM cc0 wceq cN cn wcel cM cN clt wbr cM c1 caddc co cN
    cle wbr wb cM cc0 wceq cM cN clt wbr cM c1 caddc co cN cle wbr wb cc0 cN
    clt wbr c1 cN cle wbr wb cN cn wcel cM cc0 wceq cM cN clt wbr cc0 cN clt
    wbr cM c1 caddc co cN cle wbr c1 cN cle wbr cM cc0 cN clt breq1 cM cc0 wceq
    cM c1 caddc co c1 cN cle cM cc0 wceq cM c1 caddc co cc0 c1 caddc co c1 cM
    cc0 c1 caddc opreq1 c1 ax1cn addid2i syl6eq breq1d bibi12d cc0 cN clt wbr
    c1 cN cle wbr cc0 cN clt wbr c1 cN cle wbr wb cN cn wcel cc0 cN clt wbr c1
    cN cle wbr pm5.1 cN nngt0 cN nnge1 sylanc syl5bir imp a1i cM cr wcel cM
    cneg cn wcel cN cc0 wceq wa cM cN clt wbr cM c1 caddc co cN cle wbr wb wi
    cN cr wcel cM cr wcel cM cneg cn wcel cN cc0 wceq cM cN clt wbr cM c1 caddc
    co cN cle wbr wb cN cc0 wceq cM cN clt wbr cM c1 caddc co cN cle wbr wb cM
    cc0 clt wbr cM c1 caddc co cc0 cle wbr wb cM cr wcel cM cneg cn wcel wa cN
    cc0 wceq cM cN clt wbr cM cc0 clt wbr cM c1 caddc co cN cle wbr cM c1 caddc
    co cc0 cle wbr cN cc0 cM clt breq2 cN cc0 cM c1 caddc co cle breq2 bibi12d
    cM cr wcel cM cneg cn wcel wa cc0 cM cneg clt wbr cc0 cM cneg c1 cmin co
    cle wbr cM cc0 clt wbr cM c1 caddc co cc0 cle wbr cM cneg cn wcel cc0 cM
    cneg clt wbr cc0 cM cneg c1 cmin co cle wbr wb cM cr wcel cc0 cn0 wcel cM
    cneg cn0 wcel cc0 cM cneg clt wbr cc0 cM cneg c1 cmin co cle wbr wb cM cneg
    cn wcel cc0 cM cneg nn0ltlem1 0nn0 cM cneg nnnn0 sylancr adantl cM cr wcel
    cM cc0 clt wbr cc0 cM cneg clt wbr wb cM cneg cn wcel cM lt0neg1 adantr cM
    cr wcel cM c1 caddc co cc0 cle wbr cc0 cM cneg c1 cmin co cle wbr wb cM
    cneg cn wcel cM cr wcel cM c1 caddc co cc0 cle wbr cc0 cM c1 caddc co cneg
    cle wbr cc0 cM cneg c1 cmin co cle wbr cM cr wcel cM c1 caddc co cr wcel cM
    c1 caddc co cc0 cle wbr cc0 cM c1 caddc co cneg cle wbr wb cM peano2re cM
    c1 caddc co le0neg1 syl cM cr wcel cM c1 caddc co cneg cM cneg c1 cmin co
    cc0 cle cM cc wcel c1 cc wcel cM c1 caddc co cneg cM cneg c1 cmin co wceq
    cM cr wcel cM c1 negdi2 cM recn ax1cn sylancl breq2d bitrd adantr 3bitr4d
    syl5cbir expimpd adantr cM cc0 wceq cN cc0 wceq wa cM cN clt wbr cM c1
    caddc co cN cle wbr wb wi cM cr wcel cN cr wcel wa cM cc0 wceq cN cc0 wceq
    wa cM cN clt wbr cM c1 caddc co cN cle wbr wb cc0 cc0 clt wbr c1 cc0 cle
    wbr wb cc0 cc0 clt wbr c1 cc0 cle wbr cc0 0re ltnri cc0 c1 clt wbr c1 cc0
    cle wbr wn lt01 cc0 c1 0re 1re ltnlei mpbi 2false cM cc0 wceq cM cN clt wbr
    cM c1 caddc co cN cle wbr wb cc0 cN clt wbr c1 cN cle wbr wb cN cc0 wceq
    cc0 cc0 clt wbr c1 cc0 cle wbr wb cM cc0 wceq cM cN clt wbr cc0 cN clt wbr
    cM c1 caddc co cN cle wbr c1 cN cle wbr cM cc0 cN clt breq1 cM cc0 wceq cM
    c1 caddc co c1 cN cle cM cc0 wceq cM c1 caddc co cc0 c1 caddc co c1 cM cc0
    c1 caddc opreq1 c1 ax1cn addid2i syl6eq breq1d bibi12d cN cc0 wceq cc0 cN
    clt wbr cc0 cc0 clt wbr c1 cN cle wbr c1 cc0 cle wbr cN cc0 cc0 clt breq2
    cN cc0 c1 cle breq2 bibi12d sylan9bb mpbiri a1i ccased sylbid cM cr wcel cN
    cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa cM cN clt wbr wn cM c1 caddc co
    cN cle wbr wn wa cM cN clt wbr cM c1 caddc co cN cle wbr wb cM cr wcel cN
    cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa cM cN clt wbr wn cM c1 caddc co
    cN cle wbr wn wa cM cr wcel cN cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa
    wa cM cN clt wbr wn cM c1 caddc co cN cle wbr wn cM cr wcel cN cr wcel wa
    cM cn0 wcel cN cneg cn0 wcel wa wa cN cM cle wbr cM cN clt wbr wn cM cr
    wcel cN cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa wa cN cc0 cM cM cr wcel
    cN cr wcel cM cn0 wcel cN cneg cn0 wcel wa simplr cc0 cr wcel cM cr wcel cN
    cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa wa 0re a1i cM cr wcel cN cr wcel
    cM cn0 wcel cN cneg cn0 wcel wa simpll cN cr wcel cN cneg cn0 wcel cN cc0
    cle wbr cM cr wcel cM cn0 wcel cN cr wcel cN cneg cn0 wcel wa cN cc0 cle
    wbr cc0 cN cneg cle wbr cN cneg cn0 wcel cc0 cN cneg cle wbr cN cr wcel cN
    cneg nn0ge0 adantl cN cr wcel cN cc0 cle wbr cc0 cN cneg cle wbr wb cN cneg
    cn0 wcel cN le0neg1 adantr mpbird ad2ant2l cM cn0 wcel cc0 cM cle wbr cM cr
    wcel cN cr wcel wa cN cneg cn0 wcel cM nn0ge0 ad2antrl letrd cM cr wcel cN
    cr wcel wa cN cM cle wbr cM cN clt wbr wn wb cM cn0 wcel cN cneg cn0 wcel
    wa cN cr wcel cM cr wcel cN cM cle wbr cM cN clt wbr wn wb cN cM lenlt
    ancoms adantr mpbid cM cr wcel cN cr wcel wa cM cn0 wcel cN cneg cn0 wcel
    wa wa cN cM c1 caddc co clt wbr cM c1 caddc co cN cle wbr wn cM cr wcel cN
    cr wcel wa cM cn0 wcel cN cneg cn0 wcel wa wa cN cM cle wbr cM cM c1 caddc
    co clt wbr cN cM c1 caddc co clt wbr cM cr wcel cN cr wcel wa cM cn0 wcel
    cN cneg cn0 wcel wa wa cN cc0 cM cM cr wcel cN cr wcel cM cn0 wcel cN cneg
    cn0 wcel wa simplr cc0 cr wcel cM cr wcel cN cr wcel wa cM cn0 wcel cN cneg
    cn0 wcel wa wa 0re a1i cM cr wcel cN cr wcel cM cn0 wcel cN cneg cn0 wcel
    wa simpll cN cr wcel cN cneg cn0 wcel cN cc0 cle wbr cM cr wcel cM cn0 wcel
    cN cr wcel cN cneg cn0 wcel wa cN cc0 cle wbr cc0 cN cneg cle wbr cN cneg
    cn0 wcel cc0 cN cneg cle wbr cN cr wcel cN cneg nn0ge0 adantl cN cr wcel cN
    cc0 cle wbr cc0 cN cneg cle wbr wb cN cneg cn0 wcel cN le0neg1 adantr
    mpbird ad2ant2l cM cn0 wcel cc0 cM cle wbr cM cr wcel cN cr wcel wa cN cneg
    cn0 wcel cM nn0ge0 ad2antrl letrd cM cr wcel cM cM c1 caddc co clt wbr cN
    cr wcel cM cn0 wcel cN cneg cn0 wcel wa cM ltp1 ad2antrr cM cr wcel cN cr
    wcel wa cN cM cle wbr cM cM c1 caddc co clt wbr wa cN cM c1 caddc co clt
    wbr wi cM cn0 wcel cN cneg cn0 wcel wa cN cr wcel cM cr wcel cN cM cle wbr
    cM cM c1 caddc co clt wbr wa cN cM c1 caddc co clt wbr wi cN cr wcel cM cr
    wcel cM c1 caddc co cr wcel wa cN cM cle wbr cM cM c1 caddc co clt wbr wa
    cN cM c1 caddc co clt wbr wi cM cr wcel cN cr wcel cM cr wcel cM c1 caddc
    co cr wcel cN cM cle wbr cM cM c1 caddc co clt wbr wa cN cM c1 caddc co clt
    wbr wi cN cM cM c1 caddc co lelttr 3expb cM cr wcel cM c1 caddc co cr wcel
    cM peano2re ancli sylan2 ancoms adantr mp2and cM cr wcel cN cr wcel wa cN
    cM c1 caddc co clt wbr cM c1 caddc co cN cle wbr wn wb cM cn0 wcel cN cneg
    cn0 wcel wa cN cr wcel cM cr wcel cN cM c1 caddc co clt wbr cM c1 caddc co
    cN cle wbr wn wb cN cr wcel cM c1 caddc co cr wcel cN cM c1 caddc co clt
    wbr cM c1 caddc co cN cle wbr wn wb cM cr wcel cN cM c1 caddc co ltnle cM
    peano2re sylan2 ancoms adantr mpbid jca ex cM cN clt wbr cM c1 caddc co cN
    cle wbr pm5.21 syl6 cM cr wcel cN cr wcel wa cM cneg cn0 wcel cN cneg cn0
    wcel wa cM cN clt wbr cM c1 caddc co cN cle wbr wb cM cr wcel cN cr wcel wa
    cM cneg cn0 wcel cN cneg cn0 wcel wa wa cN cneg cM cneg clt wbr cN cneg cM
    cneg c1 cmin co cle wbr cM cN clt wbr cM c1 caddc co cN cle wbr cM cneg cn0
    wcel cN cneg cn0 wcel wa cN cneg cM cneg clt wbr cN cneg cM cneg c1 cmin co
    cle wbr wb cM cr wcel cN cr wcel wa cN cneg cn0 wcel cM cneg cn0 wcel cN
    cneg cM cneg clt wbr cN cneg cM cneg c1 cmin co cle wbr wb cN cneg cM cneg
    nn0ltlem1 ancoms adantl cM cr wcel cN cr wcel wa cM cN clt wbr cN cneg cM
    cneg clt wbr wb cM cneg cn0 wcel cN cneg cn0 wcel wa cM cN ltneg adantr cM
    cr wcel cN cr wcel wa cM c1 caddc co cN cle wbr cN cneg cM cneg c1 cmin co
    cle wbr wb cM cneg cn0 wcel cN cneg cn0 wcel wa cM cr wcel cN cr wcel wa cM
    c1 caddc co cN cle wbr cN cneg cM c1 caddc co cneg cle wbr cN cneg cM cneg
    c1 cmin co cle wbr cM c1 caddc co cr wcel cN cr wcel cM c1 caddc co cN cle
    wbr cN cneg cM c1 caddc co cneg cle wbr wb cM cr wcel cM c1 caddc co cN
    leneg cM peano2re sylan cM cr wcel cN cneg cM c1 caddc co cneg cle wbr cN
    cneg cM cneg c1 cmin co cle wbr wb cN cr wcel cM cr wcel cM c1 caddc co
    cneg cM cneg c1 cmin co cN cneg cle cM cr wcel cM cc wcel cM c1 caddc co
    cneg cM cneg c1 cmin co wceq cM recn cM cc wcel cM c1 caddc co cneg cM cneg
    c1 cneg caddc co cM cneg c1 cmin co cM cc wcel c1 cc wcel cM c1 caddc co
    cneg cM cneg c1 cneg caddc co wceq ax1cn cM c1 negdi mpan2 cM cneg cc wcel
    c1 cc wcel cM cneg c1 cneg caddc co cM cneg c1 cmin co wceq cM cc wcel cM
    cneg c1 negsub cM negcl ax1cn sylancl eqtrd syl breq2d adantr bitrd adantr
    3bitr4d ex ccased imp an4s cM elznn0 cN elznn0 syl2anb $.
    $( [2-Aug-2006] $) $( [10-May-2004] $)

  $( Integer ordering relation. $)
  zleltp1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M <_ N <-> M < ( N + 1 ) ) ) $=
    cM cz wcel cN cz wcel wa cM cN cle wbr cM c1 caddc co cN c1 caddc co cle
    wbr cM cN c1 caddc co clt wbr cM cr wcel cN cr wcel cM cN cle wbr cM c1
    caddc co cN c1 caddc co cle wbr wb cM cz wcel cN cz wcel cM cr wcel cN cr
    wcel c1 cr wcel cM cN cle wbr cM c1 caddc co cN c1 caddc co cle wbr wb 1re
    cM cN c1 leadd1 mp3an3 cM zre cN zre syl2an cM cz wcel cN c1 caddc co cz
    wcel cM cN c1 caddc co clt wbr cM c1 caddc co cN c1 caddc co cle wbr wb cN
    cz wcel cM cN c1 caddc co zltp1le cN peano2z sylan2 bitr4d $.
    $( [13-Sep-2004] $) $( [10-May-2004] $)

  $( Integer ordering relation. $)
  zlem1lt $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M <_ N <-> ( M - 1 ) < N ) ) $=
    cM cz wcel cN cz wcel wa cM c1 cmin co cN clt wbr cM c1 cmin co c1 caddc co
    cN cle wbr cM cN cle wbr cM c1 cmin co cz wcel cN cz wcel cM c1 cmin co cN
    clt wbr cM c1 cmin co c1 caddc co cN cle wbr wb cM cz wcel cM c1 cmin co cN
    zltp1le cM peano2zm sylan cM cz wcel cN cz wcel wa cM c1 cmin co c1 caddc
    co cM cN cle cM cz wcel cM c1 cmin co c1 caddc co cM wceq cN cz wcel cM cc
    wcel c1 cc wcel cM c1 cmin co c1 caddc co cM wceq cM cz wcel cM c1 npcan cM
    zcn ax1cn sylancl adantr breq1d bitr2d $.
    $( [2-Dec-2004] $) $( [13-Nov-2004] $)

  $( Integer ordering relation. $)
  zltlem1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M < N <-> M <_ ( N - 1 ) ) ) $=
    cM cz wcel cN cz wcel wa cM cN c1 cmin co cle wbr cM cN c1 cmin co c1 caddc
    co clt wbr cM cN clt wbr cM cz wcel cN c1 cmin co cz wcel cM cN c1 cmin co
    cle wbr cM cN c1 cmin co c1 caddc co clt wbr wb cN cz wcel cM cN c1 cmin co
    zleltp1 cN peano2zm sylan2 cM cz wcel cN cz wcel wa cN c1 cmin co c1 caddc
    co cN cM clt cN cz wcel cN c1 cmin co c1 caddc co cN wceq cM cz wcel cN cc
    wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN cz wcel cN c1 npcan cN
    zcn ax1cn sylancl adantl breq2d bitr2d $.
    $( [18-Jun-2005] $) $( [13-Nov-2004] $)

  $( Nonnegative integer ordering relation. $)
  nn0lem1lt $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                   ( M <_ N <-> ( M - 1 ) < N ) ) $=
    cM cz wcel cN cz wcel cM cN cle wbr cM c1 cmin co cN clt wbr wb cM cn0 wcel
    cN cn0 wcel cM cN zlem1lt cM nn0z cN nn0z syl2an $.
    $( [22-Jun-2005] $) $( [21-Jun-2005] $)

  $( Natural number ordering relation. $)
  nnlem1lt $p |- ( ( M e. NN /\ N e. NN ) -> ( M <_ N <-> ( M - 1 ) < N ) ) $=
    cM cz wcel cN cz wcel cM cN cle wbr cM c1 cmin co cN clt wbr wb cM cn wcel
    cN cn wcel cM cN zlem1lt cM nnz cN nnz syl2an $.
    $( [30-Jun-2005] $) $( [21-Jun-2005] $)

  $( Natural number ordering relation. $)
  nnltlem1 $p |- ( ( M e. NN /\ N e. NN ) -> ( M < N <-> M <_ ( N - 1 ) ) ) $=
    cM cz wcel cN cz wcel cM cN clt wbr cM cN c1 cmin co cle wbr wb cM cn wcel
    cN cn wcel cM cN zltlem1 cM nnz cN nnz syl2an $.
    $( [1-Aug-2005] $) $( [21-Jun-2005] $)

  ${
    $d k M $.  $d k N $.
    $( Two ways to express " ` M ` divides ` N ` . $)
    zdiv $p |- ( ( M e. NN /\ N e. ZZ )
                -> ( E. k e. ZZ ( M x. k ) = N <-> ( N / M ) e. ZZ ) ) $=
      cM cn wcel cN cz wcel wa cM cc0 wne cM vk cv cmul co cN wceq vk cz wrex
      cN cM cdiv co cz wcel wb cM cn wcel cM cc0 wne cN cz wcel cM nnne0 adantr
      cM cc wcel cN cc wcel cM cc0 wne cM vk cv cmul co cN wceq vk cz wrex cN
      cM cdiv co cz wcel wb wi cM cn wcel cN cz wcel cM cc wcel cN cc wcel cM
      cc0 wne cM vk cv cmul co cN wceq vk cz wrex cN cM cdiv co cz wcel wb cM
      cc wcel cN cc wcel cM cc0 wne w3a cM vk cv cmul co cN wceq vk cz wrex cN
      cM cdiv co cz wcel cM cc wcel cN cc wcel cM cc0 wne w3a cM vk cv cmul co
      cN wceq cN cM cdiv co cz wcel vk cz cM cc wcel cN cc wcel cM cc0 wne w3a
      vk cv cz wcel cM vk cv cmul co cN wceq cN cM cdiv co cz wcel cM cc wcel
      cN cc wcel cM cc0 wne w3a vk cv cz wcel wa cM vk cv cmul co cN wceq wa vk
      cv cN cM cdiv co cz cM cc wcel cN cc wcel cM cc0 wne w3a vk cv cz wcel wa
      cM vk cv cmul co cN wceq vk cv cM vk cv cmul co cM cdiv co cN cM cdiv co
      cM cc wcel cM cc0 wne vk cv cz wcel cM vk cv cmul co cM cdiv co vk cv
      wceq cN cc wcel cM cc wcel cM cc0 wne wa vk cv cc wcel cM vk cv cmul co
      cM cdiv co vk cv wceq vk cv cz wcel cM cc wcel cM cc0 wne vk cv cc wcel
      cM vk cv cmul co cM cdiv co vk cv wceq vk cv cc wcel cM cc wcel cM cc0
      wne cM vk cv cmul co cM cdiv co vk cv wceq vk cv cM divcan3 3coml 3expa
      vk cv zcn sylan2 3adantl2 cM vk cv cmul co cN cM cdiv opreq1 sylan9req cM
      cc wcel cN cc wcel cM cc0 wne w3a vk cv cz wcel cM vk cv cmul co cN wceq
      simplr eqeltrrd exp31 r19.23adv cM cc wcel cN cc wcel cM cc0 wne w3a cM
      cN cM cdiv co cmul co cN wceq cN cM cdiv co cz wcel cM vk cv cmul co cN
      wceq vk cz wrex wi cN cc wcel cM cc wcel cM cc0 wne cM cN cM cdiv co cmul
      co cN wceq cN cM divcan2 3com12 cN cM cdiv co cz wcel cM cN cM cdiv co
      cmul co cN wceq cM vk cv cmul co cN wceq vk cz wrex cM vk cv cmul co cN
      wceq cM cN cM cdiv co cmul co cN wceq vk cN cM cdiv co cz vk cv cN cM
      cdiv co wceq cM vk cv cmul co cM cN cM cdiv co cmul co cN vk cv cN cM
      cdiv co cM cmul opreq2 eqeq1d rcla4ev expcom syl impbid 3expia cM nncn cN
      zcn syl2an mpd $.
      $( [3-Oct-2008] $) $( [3-Oct-2008] $)
  $}

  $( Property of divisibility:  if ` D ` divides ` A ` and ` B ` then it
     divides ` A + B ` . $)
  zdivadd $p |- ( ( ( D e. NN /\ A e. ZZ /\ B e. ZZ ) /\
       ( ( A / D ) e. ZZ /\ ( B / D ) e. ZZ ) ) -> ( ( A + B ) / D ) e. ZZ ) $=
    cD cn wcel cA cz wcel cB cz wcel w3a cA cD cdiv co cz wcel cB cD cdiv co cz
    wcel wa wa cA cB caddc co cD cdiv co cA cD cdiv co cB cD cdiv co caddc co
    cz cD cn wcel cA cz wcel cB cz wcel w3a cA cB caddc co cD cdiv co cA cD
    cdiv co cB cD cdiv co caddc co wceq cA cD cdiv co cz wcel cB cD cdiv co cz
    wcel wa cA cz wcel cB cz wcel cD cn wcel cA cB caddc co cD cdiv co cA cD
    cdiv co cB cD cdiv co caddc co wceq cA cc wcel cB cc wcel cD cc wcel cD cc0
    wne wa cA cB caddc co cD cdiv co cA cD cdiv co cB cD cdiv co caddc co wceq
    cA cz wcel cB cz wcel cD cn wcel cA cB cD divdir cA zcn cB zcn cD cn wcel
    cD cc wcel cD cc0 wne cD nncn cD nnne0 jca syl3an 3comr adantr cA cD cdiv
    co cz wcel cB cD cdiv co cz wcel wa cA cD cdiv co cB cD cdiv co caddc co cz
    wcel cD cn wcel cA cz wcel cB cz wcel w3a cA cD cdiv co cB cD cdiv co
    zaddcl adantl eqeltrd $.
    $( [17-Oct-2008] $) $( [3-Oct-2008] $)

  $( Property of divisibility:  if ` D ` divides ` A ` then it divides
     ` B x. A ` . $)
  zdivmul $p |- ( ( ( D e. NN /\ A e. ZZ /\ B e. ZZ ) /\
       ( A / D ) e. ZZ ) -> ( ( B x. A ) / D ) e. ZZ ) $=
    cD cn wcel cA cz wcel cB cz wcel w3a cA cD cdiv co cz wcel wa cB cA cmul co
    cD cdiv co cB cA cD cdiv co cmul co cz cD cn wcel cA cz wcel cB cz wcel w3a
    cB cA cmul co cD cdiv co cB cA cD cdiv co cmul co wceq cA cD cdiv co cz
    wcel cA cz wcel cB cz wcel cD cn wcel cB cA cmul co cD cdiv co cB cA cD
    cdiv co cmul co wceq cB cc wcel cA cc wcel cD cc wcel cD cc0 wne wa cB cA
    cmul co cD cdiv co cB cA cD cdiv co cmul co wceq cA cz wcel cB cz wcel cD
    cn wcel w3a cB cA cD divass cB cz wcel cA cz wcel cB cc wcel cD cn wcel cB
    zcn 3ad2ant2 cA cz wcel cB cz wcel cA cc wcel cD cn wcel cA zcn 3ad2ant1 cD
    cn wcel cA cz wcel cD cc wcel cD cc0 wne wa cB cz wcel cD cn wcel cD cc
    wcel cD cc0 wne cD nncn cD nnne0 jca 3ad2ant3 syl3anc 3comr adantr cB cz
    wcel cD cn wcel cA cD cdiv co cz wcel cB cA cD cdiv co cmul co cz wcel cA
    cz wcel cB cA cD cdiv co zmulcl 3ad2antl3 eqeltrd $.
    $( [22-Oct-2008] $) $( [3-Oct-2008] $)

  ${
    $d k M $.  $d k N $.
    $( There exists an integer greater than or equal to any two others. $)
    z2ge $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                E. k e. ZZ ( M <_ k /\ N <_ k ) ) $=
      cM cN cle wbr cN cM cif cz wcel cM cM cN cle wbr cN cM cif cle wbr cN cM
      cN cle wbr cN cM cif cle wbr wa cM vk cv cle wbr cN vk cv cle wbr wa vk
      cz wrex cM cz wcel cN cz wcel wa cM vk cv cle wbr cN vk cv cle wbr wa cM
      cM cN cle wbr cN cM cif cle wbr cN cM cN cle wbr cN cM cif cle wbr wa vk
      cM cN cle wbr cN cM cif cz vk cv cM cN cle wbr cN cM cif wceq cM vk cv
      cle wbr cM cM cN cle wbr cN cM cif cle wbr cN vk cv cle wbr cN cM cN cle
      wbr cN cM cif cle wbr vk cv cM cN cle wbr cN cM cif cM cle breq2 vk cv cM
      cN cle wbr cN cM cif cN cle breq2 anbi12d rcla4ev cN cz wcel cM cz wcel
      cM cN cle wbr cN cM cif cz wcel cM cN cle wbr cN cM cz ifcl ancoms cM cr
      wcel cN cr wcel cM cM cN cle wbr cN cM cif cle wbr cN cM cN cle wbr cN cM
      cif cle wbr wa cM cz wcel cN cz wcel cM cr wcel cN cr wcel wa cM cM cN
      cle wbr cN cM cif cle wbr cN cM cN cle wbr cN cM cif cle wbr cM cN max1
      cM cN max2 jca cM zre cN zre syl2an sylanc $.
      $( [22-Sep-2005] $) $( [28-Aug-2005] $)

    $( An extensionality-like property for integer ordering. $)
    zextle $p |- ( ( M e. ZZ /\ N e. ZZ /\ A. k e. ZZ ( k <_ M <-> k <_ N ) )
                  -> M = N ) $=
      cM cz wcel cN cz wcel vk cv cM cle wbr vk cv cN cle wbr wb vk cz wral cM
      cN wceq cM cz wcel cN cz wcel wa vk cv cM cle wbr vk cv cN cle wbr wb vk
      cz wral cM cN cle wbr cN cM cle wbr wa cM cN wceq cM cz wcel cN cz wcel
      wa vk cv cM cle wbr vk cv cN cle wbr wb vk cz wral cM cN cle wbr cN cM
      cle wbr wa cM cz wcel cN cz wcel wa vk cv cM cle wbr vk cv cN cle wbr wb
      vk cz wral wa cM cN cle wbr cN cM cle wbr cM cz wcel vk cv cM cle wbr vk
      cv cN cle wbr wb vk cz wral cM cN cle wbr cN cz wcel cM cz wcel vk cv cM
      cle wbr vk cv cN cle wbr wb vk cz wral wa cM cM cle wbr cM cN cle wbr cM
      cz wcel cM cM cle wbr vk cv cM cle wbr vk cv cN cle wbr wb vk cz wral cM
      cz wcel cM cr wcel cM cM cle wbr cM zre cM leid syl adantr vk cv cM cle
      wbr vk cv cN cle wbr wb cM cM cle wbr cM cN cle wbr wb vk cM cz vk cv cM
      wceq vk cv cM cle wbr cM cM cle wbr vk cv cN cle wbr cM cN cle wbr vk cv
      cM cM cle breq1 vk cv cM cN cle breq1 bibi12d rcla4va mpbid adantlr cN cz
      wcel vk cv cM cle wbr vk cv cN cle wbr wb vk cz wral cN cM cle wbr cM cz
      wcel cN cz wcel vk cv cM cle wbr vk cv cN cle wbr wb vk cz wral wa cN cM
      cle wbr cN cN cle wbr cN cz wcel cN cN cle wbr vk cv cM cle wbr vk cv cN
      cle wbr wb vk cz wral cN cz wcel cN cr wcel cN cN cle wbr cN zre cN leid
      syl adantr vk cv cM cle wbr vk cv cN cle wbr wb cN cM cle wbr cN cN cle
      wbr wb vk cN cz vk cv cN wceq vk cv cM cle wbr cN cM cle wbr vk cv cN cle
      wbr cN cN cle wbr vk cv cN cM cle breq1 vk cv cN cN cle breq1 bibi12d
      rcla4va mpbird adantll jca ex cM cr wcel cN cr wcel cM cN wceq cM cN cle
      wbr cN cM cle wbr wa wb cM cz wcel cN cz wcel cM cN letri3 cM zre cN zre
      syl2an sylibrd 3impia $.
      $( [9-Dec-2005] $) $( [29-Oct-2005] $)

    $( An extensionality-like property for integer ordering. $)
    zextlt $p |- ( ( M e. ZZ /\ N e. ZZ /\ A. k e. ZZ ( k < M <-> k < N ) )
                  -> M = N ) $=
      cM cz wcel cN cz wcel vk cv cM clt wbr vk cv cN clt wbr wb vk cz wral cM
      cN wceq cM cz wcel cN cz wcel wa vk cv cM clt wbr vk cv cN clt wbr wb vk
      cz wral vk cv cM c1 cmin co cle wbr vk cv cN c1 cmin co cle wbr wb vk cz
      wral cM cN wceq cM cz wcel cN cz wcel wa vk cv cM clt wbr vk cv cN clt
      wbr wb vk cv cM c1 cmin co cle wbr vk cv cN c1 cmin co cle wbr wb vk cz
      vk cv cz wcel cM cz wcel cN cz wcel wa vk cv cM clt wbr vk cv cN clt wbr
      wb vk cv cM c1 cmin co cle wbr vk cv cN c1 cmin co cle wbr wb wb vk cv cz
      wcel cM cz wcel cN cz wcel wa wa vk cv cM clt wbr vk cv cM c1 cmin co cle
      wbr vk cv cN clt wbr vk cv cN c1 cmin co cle wbr vk cv cz wcel cM cz wcel
      vk cv cM clt wbr vk cv cM c1 cmin co cle wbr wb cN cz wcel vk cv cM
      zltlem1 adantrr vk cv cz wcel cN cz wcel vk cv cN clt wbr vk cv cN c1
      cmin co cle wbr wb cM cz wcel vk cv cN zltlem1 adantrl bibi12d ancoms
      ralbidva cM cz wcel cN cz wcel wa vk cv cM c1 cmin co cle wbr vk cv cN c1
      cmin co cle wbr wb vk cz wral cM c1 cmin co cN c1 cmin co wceq cM cN wceq
      cM c1 cmin co cz wcel cN c1 cmin co cz wcel vk cv cM c1 cmin co cle wbr
      vk cv cN c1 cmin co cle wbr wb vk cz wral cM c1 cmin co cN c1 cmin co
      wceq wi cM cz wcel cN cz wcel cM c1 cmin co cz wcel cN c1 cmin co cz wcel
      vk cv cM c1 cmin co cle wbr vk cv cN c1 cmin co cle wbr wb vk cz wral cM
      c1 cmin co cN c1 cmin co wceq vk cM c1 cmin co cN c1 cmin co zextle
      3expia cM peano2zm cN peano2zm syl2an cM cc wcel cN cc wcel cM c1 cmin co
      cN c1 cmin co wceq cM cN wceq wb cM cz wcel cN cz wcel cM cc wcel cN cc
      wcel c1 cc wcel cM c1 cmin co cN c1 cmin co wceq cM cN wceq wb ax1cn cM
      cN c1 subcan2 mp3an3 cM zcn cN zcn syl2an sylibd sylbid 3impia $.
      $( [7-Mar-2006] $) $( [29-Oct-2005] $)
  $}

  $( The reciprocal of a number greater than 1 is not an integer. $)
  recnz $p |- ( ( A e. RR /\ 1 < A ) -> -. ( 1 / A ) e. ZZ ) $=
    cA cr wcel c1 cA clt wbr wa c1 cA cdiv co cz wcel c1 cA cdiv co c1 clt wbr
    cA cr wcel c1 cA clt wbr wa cc0 c1 cA cdiv co clt wbr c1 cA cdiv co c1 clt
    wbr cA recgt1i pm3.27d cA cr wcel c1 cA clt wbr wa c1 cA cdiv co cz wcel c1
    c1 cA cdiv co cle wbr c1 cA cdiv co c1 clt wbr wn c1 cA cdiv co cz wcel cc0
    c1 cA cdiv co clt wbr c1 c1 cA cdiv co cle wbr cA cr wcel c1 cA clt wbr wa
    c1 cA cdiv co cz wcel cc0 c1 cA cdiv co clt wbr cc0 c1 caddc co c1 cA cdiv
    co cle wbr c1 c1 cA cdiv co cle wbr cc0 cz wcel c1 cA cdiv co cz wcel cc0
    c1 cA cdiv co clt wbr cc0 c1 caddc co c1 cA cdiv co cle wbr wb 0z cc0 c1 cA
    cdiv co zltp1le mpan cc0 c1 caddc co c1 c1 cA cdiv co cle c1 ax1cn addid2i
    breq1i syl6bb cA cr wcel c1 cA clt wbr wa cc0 c1 cA cdiv co clt wbr c1 cA
    cdiv co c1 clt wbr cA recgt1i pm3.26d syl5cbi c1 cr wcel c1 cA cdiv co cr
    wcel c1 c1 cA cdiv co cle wbr c1 cA cdiv co c1 clt wbr wn wb cA cr wcel c1
    cA clt wbr wa c1 c1 cA cdiv co lenlt 1re cA cr wcel c1 cA clt wbr cA cc0
    wne c1 cA cdiv co cr wcel cA cr wcel c1 cA clt wbr wa cA cr wcel cc0 cA clt
    wbr wa cA cc0 wne cA cr wcel c1 cA clt wbr cc0 cA clt wbr cA cr wcel cc0 c1
    clt wbr c1 cA clt wbr cc0 cA clt wbr lt01 cc0 cr wcel c1 cr wcel cA cr wcel
    cc0 c1 clt wbr c1 cA clt wbr wa cc0 cA clt wbr wi 0re 1re cc0 c1 cA axlttrn
    mp3an12 mpani imdistani cA gt0ne0 syl cA rereccl syldan sylancr sylibd mt2d
    $.
    $( [4-May-2005] $) $( [3-May-2005] $)

  $( A number between an integer and its successor is not an integer. $)
  btwnnz $p |- ( ( A e. ZZ /\ A < B /\ B < ( A + 1 ) ) -> -. B e. ZZ ) $=
    cA cz wcel cA cB clt wbr cB cA c1 caddc co clt wbr cB cz wcel wn cA cz wcel
    cA cB clt wbr wa cB cz wcel cB cA c1 caddc co clt wbr cA cz wcel cA cB clt
    wbr cB cz wcel cB cA c1 caddc co clt wbr wn wi cA cz wcel cB cz wcel cA cB
    clt wbr cB cA c1 caddc co clt wbr wn cA cz wcel cB cz wcel cA cB clt wbr cB
    cA c1 caddc co clt wbr wn wi cA cz wcel cB cz wcel wa cA cB clt wbr cB cA
    c1 caddc co clt wbr wn cA cz wcel cB cz wcel wa cA cB clt wbr cA c1 caddc
    co cB cle wbr cB cA c1 caddc co clt wbr wn cA cB zltp1le cA c1 caddc co cr
    wcel cB cr wcel cA c1 caddc co cB cle wbr cB cA c1 caddc co clt wbr wn wb
    cA cz wcel cB cz wcel cA c1 caddc co cB lenlt cA cz wcel cA c1 caddc co cz
    wcel cA c1 caddc co cr wcel cA peano2z cA c1 caddc co zre syl cB zre syl2an
    bitrd biimpd ex com23 imp con2d 3impia $.
    $( [7-May-2005] $) $( [3-May-2005] $)

  $( A larger number does not divide a smaller natural number. $)
  gtndiv $p |- ( ( A e. RR /\ B e. NN /\ B < A ) -> -. ( B / A ) e. ZZ ) $=
    cc0 cB cA cdiv co clt wbr cB cA cdiv co cc0 c1 caddc co clt wbr cB cA cdiv
    co cz wcel wn cA cr wcel cB cn wcel cB cA clt wbr w3a cc0 cz wcel cc0 cB cA
    cdiv co clt wbr cB cA cdiv co cc0 c1 caddc co clt wbr cB cA cdiv co cz wcel
    wn 0z cc0 cB cA cdiv co btwnnz mp3an1 cB cr wcel cc0 cB clt wbr cA cr wcel
    cc0 cA clt wbr cc0 cB cA cdiv co clt wbr cA cr wcel cB cn wcel cB cA clt
    wbr w3a cB cA divgt0 cB cn wcel cA cr wcel cB cr wcel cB cA clt wbr cB nnre
    3ad2ant2 cB cn wcel cA cr wcel cc0 cB clt wbr cB cA clt wbr cB nngt0
    3ad2ant2 cA cr wcel cB cn wcel cB cA clt wbr 3simp1 cA cr wcel cB cn wcel
    cB cA clt wbr cc0 cA clt wbr cA cr wcel cB cn wcel wa cc0 cB clt wbr cB cA
    clt wbr cc0 cA clt wbr cB cn wcel cc0 cB clt wbr cA cr wcel cB nngt0 adantl
    cB cn wcel cA cr wcel cc0 cB clt wbr cB cA clt wbr wa cc0 cA clt wbr wi cB
    cr wcel cA cr wcel cc0 cB clt wbr cB cA clt wbr wa cc0 cA clt wbr wi cB cn
    wcel cc0 cr wcel cB cr wcel cA cr wcel cc0 cB clt wbr cB cA clt wbr wa cc0
    cA clt wbr wi 0re cc0 cB cA axlttrn mp3an1 cB nnre sylan ancoms mpand
    3impia syl2anc cA cr wcel cB cn wcel cB cA clt wbr w3a cB cA cdiv co c1 cc0
    c1 caddc co clt cA cr wcel cB cn wcel cB cA clt wbr w3a cB cA cdiv co c1
    clt wbr cB cA clt wbr cA cr wcel cB cn wcel cB cA clt wbr 3simp3 cA cr wcel
    cB cn wcel cB cA clt wbr w3a cB cA cdiv co c1 clt wbr cB c1 cA cmul co clt
    wbr cB cA clt wbr cB cr wcel cA cr wcel cc0 cA clt wbr wa cB cA cdiv co c1
    clt wbr cB c1 cA cmul co clt wbr wb cA cr wcel cB cn wcel cB cA clt wbr w3a
    cB cr wcel c1 cr wcel cA cr wcel cc0 cA clt wbr wa cB cA cdiv co c1 clt wbr
    cB c1 cA cmul co clt wbr wb 1re cB c1 cA ltdivmul2 mp3an2 cB cn wcel cA cr
    wcel cB cr wcel cB cA clt wbr cB nnre 3ad2ant2 cA cr wcel cB cn wcel cB cA
    clt wbr w3a cA cr wcel cc0 cA clt wbr cA cr wcel cB cn wcel cB cA clt wbr
    3simp1 cA cr wcel cB cn wcel cB cA clt wbr cc0 cA clt wbr cA cr wcel cB cn
    wcel wa cc0 cB clt wbr cB cA clt wbr cc0 cA clt wbr cB cn wcel cc0 cB clt
    wbr cA cr wcel cB nngt0 adantl cB cn wcel cA cr wcel cc0 cB clt wbr cB cA
    clt wbr wa cc0 cA clt wbr wi cB cr wcel cA cr wcel cc0 cB clt wbr cB cA clt
    wbr wa cc0 cA clt wbr wi cB cn wcel cc0 cr wcel cB cr wcel cA cr wcel cc0
    cB clt wbr cB cA clt wbr wa cc0 cA clt wbr wi 0re cc0 cB cA axlttrn mp3an1
    cB nnre sylan ancoms mpand 3impia jca sylanc cA cr wcel cB cn wcel cB c1 cA
    cmul co clt wbr cB cA clt wbr wb cB cA clt wbr cA cr wcel c1 cA cmul co cA
    cB clt cA cr wcel cA cc wcel c1 cA cmul co cA wceq cA recn cA mulid2 syl
    breq2d 3ad2ant1 bitrd mpbird c1 ax1cn addid2i syl6breqr sylanc $.
    $( [7-May-2005] $) $( [3-May-2005] $)

  $( One-half is not an integer. $)
  halfnz $p |- -. ( 1 / 2 ) e. ZZ $=
    c2 cr wcel c1 c2 clt wbr c1 c2 cdiv co cz wcel wn 2re 1lt2 c2 recnz mp2an
    $.
    $( [1-Aug-2004] $) $( [31-Jul-2004] $)

  ${
    $d x A $.
    $( Two ways to express " ` A ` is a prime number (or 1)." $)
    prime $p |- ( A e. NN -> (
                 A. x e. NN ( ( A / x ) e. NN -> ( x = 1 \/ x = A ) ) <->
          A. x e. NN ( ( 1 < x /\ x <_ A /\ ( A / x ) e. NN ) -> x = A ) ) ) $=
      cA cn wcel cA vx cv cdiv co cn wcel vx cv c1 wceq vx cv cA wceq wo wi c1
      vx cv clt wbr vx cv cA cle wbr cA vx cv cdiv co cn wcel w3a vx cv cA wceq
      wi vx cn cA cn wcel vx cv cn wcel wa vx cv c1 wne cA vx cv cdiv co cn
      wcel wa vx cv cA wceq wi c1 vx cv clt wbr vx cv cA cle wbr cA vx cv cdiv
      co cn wcel w3a vx cv cA wceq wi cA vx cv cdiv co cn wcel vx cv c1 wceq vx
      cv cA wceq wo wi cA cn wcel vx cv cn wcel wa vx cv c1 wne cA vx cv cdiv
      co cn wcel wa c1 vx cv clt wbr vx cv cA cle wbr cA vx cv cdiv co cn wcel
      w3a vx cv cA wceq cA cn wcel vx cv cn wcel wa c1 vx cv clt wbr cA vx cv
      cdiv co cn wcel wa vx cv c1 wne cA vx cv cdiv co cn wcel wa c1 vx cv clt
      wbr vx cv cA cle wbr cA vx cv cdiv co cn wcel w3a cA cn wcel vx cv cn
      wcel wa c1 vx cv clt wbr vx cv c1 wne cA vx cv cdiv co cn wcel vx cv cn
      wcel c1 vx cv clt wbr vx cv c1 wne wb cA cn wcel vx cv nngt1ne1 adantl
      anbi1d cA cn wcel vx cv cn wcel wa c1 vx cv clt wbr cA vx cv cdiv co cn
      wcel wa c1 vx cv clt wbr vx cv cA cle wbr cA vx cv cdiv co cn wcel wa wa
      c1 vx cv clt wbr vx cv cA cle wbr cA vx cv cdiv co cn wcel w3a cA cn wcel
      vx cv cn wcel wa cA vx cv cdiv co cn wcel vx cv cA cle wbr cA vx cv cdiv
      co cn wcel wa c1 vx cv clt wbr cA cn wcel vx cv cn wcel wa cA vx cv cdiv
      co cn wcel vx cv cA cle wbr cA cn wcel vx cv cn wcel wa cA vx cv cdiv co
      cz wcel vx cv cA cle wbr cA vx cv cdiv co cn wcel vx cv cn wcel cA cn
      wcel cA vx cv cdiv co cz wcel vx cv cA cle wbr wi vx cv cn wcel cA cn
      wcel wa cA vx cv cdiv co cz wcel cA vx cv clt wbr wn vx cv cA cle wbr vx
      cv cn wcel cA cn wcel wa cA vx cv clt wbr cA vx cv cdiv co cz wcel vx cv
      cr wcel cA cn wcel cA vx cv clt wbr cA vx cv cdiv co cz wcel wn wi vx cv
      cn wcel vx cv cr wcel cA cn wcel cA vx cv clt wbr cA vx cv cdiv co cz
      wcel wn vx cv cA gtndiv 3expia vx cv nnre sylan con2d vx cv cr wcel cA cr
      wcel vx cv cA cle wbr cA vx cv clt wbr wn wb vx cv cn wcel cA cn wcel vx
      cv cA lenlt vx cv nnre cA nnre syl2an sylibrd ancoms cA vx cv cdiv co nnz
      syl5 pm4.71rd anbi2d c1 vx cv clt wbr vx cv cA cle wbr cA vx cv cdiv co
      cn wcel 3anass syl6bbr bitr3d imbi1d vx cv c1 wne cA vx cv cdiv co cn
      wcel vx cv cA wceq wi wi cA vx cv cdiv co cn wcel vx cv c1 wne vx cv cA
      wceq wi wi vx cv c1 wne cA vx cv cdiv co cn wcel wa vx cv cA wceq wi cA
      vx cv cdiv co cn wcel vx cv c1 wceq vx cv cA wceq wo wi vx cv c1 wne cA
      vx cv cdiv co cn wcel vx cv cA wceq bi2.04 vx cv c1 wne cA vx cv cdiv co
      cn wcel vx cv cA wceq impexp vx cv c1 wceq vx cv cA wceq wo vx cv c1 wne
      vx cv cA wceq wi cA vx cv cdiv co cn wcel vx cv cA wceq vx cv c1 neor
      imbi2i 3bitr4ri syl5bb ralbidva $.
      $( [7-May-2005] $) $( [4-May-2005] $)
  $}

  $( The square of a non-zero integer is a natural number. $)
  msqznn $p |- ( ( A e. ZZ /\ A =/= 0 ) -> ( A x. A ) e. NN ) $=
    cA cA cmul co cn wcel cA cA cmul co cz wcel cc0 cA cA cmul co clt wbr cA cz
    wcel cA cc0 wne wa cA cA cmul co elnnz cA cz wcel cA cA cmul co cz wcel cA
    cc0 wne cA cz wcel cA cA cmul co cz wcel cA cA zmulcl anidms adantr cA cr
    wcel cA cc0 wne cc0 cA cA cmul co clt wbr cA cz wcel cA msqgt0 cA zre sylan
    sylanbrc $.
    $( [13-Sep-2004] $) $( [2-Aug-2004] $)

  ${
    $d j k N $.
    nneo.1 $e |- N e. NN $.
    $( A natural number is even or odd but not both. $)
    nneoi $p |- ( ( N / 2 ) e. NN <-> -. ( ( N + 1 ) / 2 ) e. NN ) $=
      cN c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cn wcel wn cN c2 cdiv co
      cn wcel cN c1 caddc co c2 cdiv co cn wcel wn wi cN c2 cdiv co cn wcel cN
      c1 caddc co c2 cdiv co cn wcel wa wn cN c2 cdiv co cn wcel cN c1 caddc co
      c2 cdiv co cn wcel wa cN c2 cdiv co c1 caddc co cN c1 caddc co c2 cdiv co
      cle wbr cN c1 caddc co c2 cdiv co cN c2 cdiv co c1 caddc co clt wbr cN c2
      cdiv co c1 caddc co cN c1 caddc co c2 cdiv co cle wbr wn cN c1 caddc co
      c2 cdiv co cN c2 cdiv co c1 caddc co clt wbr c2 cN c1 caddc co c2 cdiv co
      cmul co c2 cN c2 cdiv co c1 caddc co cmul co clt wbr cN c1 caddc co cN c2
      caddc co c2 cN c1 caddc co c2 cdiv co cmul co c2 cN c2 cdiv co c1 caddc
      co cmul co clt c1 c2 clt wbr cN c1 caddc co cN c2 caddc co clt wbr 1lt2
      c1 c2 cN 1re 2re cN nneo.1 nnrei ltadd2i mpbi cN c1 caddc co c2 cN c1
      caddc co cN c1 cN nneo.1 nnrei 1re readdcli recni 2cn 2ne0 divcan2i c2 cN
      c2 cdiv co c1 caddc co cmul co c2 cN c2 cdiv co cmul co c2 c1 cmul co
      caddc co cN c2 caddc co c2 cN c2 cdiv co c1 2cn cN c2 cdiv co cN c2 cN
      nneo.1 nnrei 2re 2ne0 redivcli recni ax1cn adddii c2 cN c2 cdiv co cmul
      co cN c2 c1 cmul co c2 caddc cN c2 cN nneo.1 nncni 2cn 2ne0 divcan2i c2
      2cn mulid1i opreq12i eqtri 3brtr4i cc0 c2 clt wbr cN c1 caddc co c2 cdiv
      co cN c2 cdiv co c1 caddc co clt wbr c2 cN c1 caddc co c2 cdiv co cmul co
      c2 cN c2 cdiv co c1 caddc co cmul co clt wbr wb 2pos cN c1 caddc co c2
      cdiv co cN c2 cdiv co c1 caddc co c2 cN c1 caddc co c2 cN c1 cN nneo.1
      nnrei 1re readdcli 2re 2ne0 redivcli cN c2 cdiv co c1 cN c2 cN nneo.1
      nnrei 2re 2ne0 redivcli 1re readdcli 2re ltmul2i ax-mp mpbir cN c1 caddc
      co c2 cdiv co cN c2 cdiv co c1 caddc co cN c1 caddc co c2 cN c1 cN nneo.1
      nnrei 1re readdcli 2re 2ne0 redivcli cN c2 cdiv co c1 cN c2 cN nneo.1
      nnrei 2re 2ne0 redivcli 1re readdcli ltnlei mpbi cN c2 cdiv co cn wcel cN
      c1 caddc co c2 cdiv co cn wcel wa cN c2 cdiv co cN c1 caddc co c2 cdiv co
      clt wbr cN c2 cdiv co c1 caddc co cN c1 caddc co c2 cdiv co cle wbr cN cN
      c1 caddc co clt wbr cN c2 cdiv co cN c1 caddc co c2 cdiv co clt wbr cN cN
      nneo.1 nnrei ltp1i cN cN c1 caddc co c2 cN nneo.1 nnrei cN c1 cN nneo.1
      nnrei 1re readdcli 2re 2pos ltdiv1ii mpbi cN c2 cdiv co cN c1 caddc co c2
      cdiv co nnltp1le mpbii mto cN c2 cdiv co cn wcel cN c1 caddc co c2 cdiv
      co cn wcel imnan mpbir cN c1 caddc co c2 cdiv co cn wcel cN c2 cdiv co cn
      wcel cN cn wcel cN c1 caddc co c2 cdiv co cn wcel cN c2 cdiv co cn wcel
      wo nneo.1 vj cv c1 caddc co c2 cdiv co cn wcel vj cv c2 cdiv co cn wcel
      wo c1 c1 caddc co c2 cdiv co cn wcel c1 c2 cdiv co cn wcel wo vk cv c1
      caddc co c2 cdiv co cn wcel vk cv c2 cdiv co cn wcel wo vk cv c1 caddc co
      c1 caddc co c2 cdiv co cn wcel vk cv c1 caddc co c2 cdiv co cn wcel wo cN
      c1 caddc co c2 cdiv co cn wcel cN c2 cdiv co cn wcel wo vj vk cN vj cv c1
      wceq vj cv c1 caddc co c2 cdiv co cn wcel c1 c1 caddc co c2 cdiv co cn
      wcel vj cv c2 cdiv co cn wcel c1 c2 cdiv co cn wcel vj cv c1 wceq vj cv
      c1 caddc co c2 cdiv co c1 c1 caddc co c2 cdiv co cn vj cv c1 wceq vj cv
      c1 caddc co c1 c1 caddc co c2 cdiv vj cv c1 c1 caddc opreq1 opreq1d
      eleq1d vj cv c1 wceq vj cv c2 cdiv co c1 c2 cdiv co cn vj cv c1 c2 cdiv
      opreq1 eleq1d orbi12d vj cv vk cv wceq vj cv c1 caddc co c2 cdiv co cn
      wcel vk cv c1 caddc co c2 cdiv co cn wcel vj cv c2 cdiv co cn wcel vk cv
      c2 cdiv co cn wcel vj cv vk cv wceq vj cv c1 caddc co c2 cdiv co vk cv c1
      caddc co c2 cdiv co cn vj cv vk cv wceq vj cv c1 caddc co vk cv c1 caddc
      co c2 cdiv vj cv vk cv c1 caddc opreq1 opreq1d eleq1d vj cv vk cv wceq vj
      cv c2 cdiv co vk cv c2 cdiv co cn vj cv vk cv c2 cdiv opreq1 eleq1d
      orbi12d vj cv vk cv c1 caddc co wceq vj cv c1 caddc co c2 cdiv co cn wcel
      vk cv c1 caddc co c1 caddc co c2 cdiv co cn wcel vj cv c2 cdiv co cn wcel
      vk cv c1 caddc co c2 cdiv co cn wcel vj cv vk cv c1 caddc co wceq vj cv
      c1 caddc co c2 cdiv co vk cv c1 caddc co c1 caddc co c2 cdiv co cn vj cv
      vk cv c1 caddc co wceq vj cv c1 caddc co vk cv c1 caddc co c1 caddc co c2
      cdiv vj cv vk cv c1 caddc co c1 caddc opreq1 opreq1d eleq1d vj cv vk cv
      c1 caddc co wceq vj cv c2 cdiv co vk cv c1 caddc co c2 cdiv co cn vj cv
      vk cv c1 caddc co c2 cdiv opreq1 eleq1d orbi12d vj cv cN wceq vj cv c1
      caddc co c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cn wcel vj cv c2
      cdiv co cn wcel cN c2 cdiv co cn wcel vj cv cN wceq vj cv c1 caddc co c2
      cdiv co cN c1 caddc co c2 cdiv co cn vj cv cN wceq vj cv c1 caddc co cN
      c1 caddc co c2 cdiv vj cv cN c1 caddc opreq1 opreq1d eleq1d vj cv cN wceq
      vj cv c2 cdiv co cN c2 cdiv co cn vj cv cN c2 cdiv opreq1 eleq1d orbi12d
      c1 c1 caddc co c2 cdiv co cn wcel c1 c2 cdiv co cn wcel c1 c1 caddc co c2
      cdiv co c1 cn c2 c2 cdiv co c1 c1 caddc co c2 cdiv co c1 c2 c1 c1 caddc
      co c2 cdiv df-2 opreq1i c2 2cn 2ne0 dividi eqtr3i 1nn eqeltri orci vk cv
      cn wcel vk cv c1 caddc co c2 cdiv co cn wcel vk cv c2 cdiv co cn wcel wo
      vk cv c1 caddc co c2 cdiv co cn wcel vk cv c1 caddc co c1 caddc co c2
      cdiv co cn wcel wo vk cv c1 caddc co c1 caddc co c2 cdiv co cn wcel vk cv
      c1 caddc co c2 cdiv co cn wcel wo vk cv cn wcel vk cv c2 cdiv co cn wcel
      vk cv c1 caddc co c1 caddc co c2 cdiv co cn wcel vk cv c1 caddc co c2
      cdiv co cn wcel vk cv cn wcel vk cv c1 caddc co c1 caddc co c2 cdiv co cn
      wcel vk cv c2 cdiv co c1 caddc co cn wcel vk cv c2 cdiv co cn wcel vk cv
      cn wcel vk cv c1 caddc co c1 caddc co c2 cdiv co vk cv c2 cdiv co c1
      caddc co cn vk cv cn wcel vk cv cc wcel vk cv c1 caddc co c1 caddc co c2
      cdiv co vk cv c2 cdiv co c1 caddc co wceq vk cv nncn vk cv cc wcel vk cv
      c1 caddc co c1 caddc co c2 cdiv co vk cv c2 caddc co c2 cdiv co vk cv c2
      cdiv co c1 caddc co vk cv cc wcel vk cv c1 caddc co c1 caddc co vk cv c2
      caddc co c2 cdiv vk cv cc wcel vk cv c1 caddc co c1 caddc co vk cv c1 c1
      caddc co caddc co vk cv c2 caddc co vk cv cc wcel c1 cc wcel c1 cc wcel
      vk cv c1 caddc co c1 caddc co vk cv c1 c1 caddc co caddc co wceq ax1cn
      ax1cn vk cv c1 c1 addass mp3an23 c2 c1 c1 caddc co vk cv caddc df-2
      opreq2i syl6eqr opreq1d vk cv cc wcel vk cv c2 caddc co c2 cdiv co vk cv
      c2 cdiv co c2 c2 cdiv co caddc co vk cv c2 cdiv co c1 caddc co vk cv cc
      wcel c2 cc wcel c2 cc wcel c2 cc0 wne wa vk cv c2 caddc co c2 cdiv co vk
      cv c2 cdiv co c2 c2 cdiv co caddc co wceq 2cn c2 cc wcel c2 cc0 wne 2cn
      2ne0 pm3.2i vk cv c2 c2 divdir mp3an23 c2 c2 cdiv co c1 vk cv c2 cdiv co
      caddc c2 2cn 2ne0 dividi opreq2i syl6eq eqtrd syl eleq1d vk cv c2 cdiv co
      peano2nn syl5bir orim2d vk cv c1 caddc co c2 cdiv co cn wcel vk cv c1
      caddc co c1 caddc co c2 cdiv co cn wcel orcom syl6ib nnind ax-mp ori
      impbii $.
      $( [20-Aug-2001] $)
  $}

  $( A natural number is even or odd but not both. $)
  nneo $p |- ( N e. NN ->
              ( ( N / 2 ) e. NN <-> -. ( ( N + 1 ) / 2 ) e. NN ) ) $=
    cN cn wcel cN c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cn wcel wn wb cN
    cn wcel cN c1 cif c2 cdiv co cn wcel cN cn wcel cN c1 cif c1 caddc co c2
    cdiv co cn wcel wn wb cN c1 cN cN cn wcel cN c1 cif wceq cN c2 cdiv co cn
    wcel cN cn wcel cN c1 cif c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cn
    wcel wn cN cn wcel cN c1 cif c1 caddc co c2 cdiv co cn wcel wn cN cN cn
    wcel cN c1 cif wceq cN c2 cdiv co cN cn wcel cN c1 cif c2 cdiv co cn cN cN
    cn wcel cN c1 cif c2 cdiv opreq1 eleq1d cN cN cn wcel cN c1 cif wceq cN c1
    caddc co c2 cdiv co cn wcel cN cn wcel cN c1 cif c1 caddc co c2 cdiv co cn
    wcel cN cN cn wcel cN c1 cif wceq cN c1 caddc co c2 cdiv co cN cn wcel cN
    c1 cif c1 caddc co c2 cdiv co cn cN cN cn wcel cN c1 cif wceq cN c1 caddc
    co cN cn wcel cN c1 cif c1 caddc co c2 cdiv cN cN cn wcel cN c1 cif c1
    caddc opreq1 opreq1d eleq1d notbid bibi12d cN cn wcel cN c1 cif cN c1 cn
    1nn elimel nneoi dedth $.
    $( [2-Jan-2006] $) $( [1-Jan-2006] $)

  $( An integer is even or odd. $)
  zeo $p |- ( N e. ZZ -> ( ( N / 2 ) e. ZZ \/ ( ( N + 1 ) / 2 ) e. ZZ ) ) $=
    cN cz wcel cN c2 cdiv co cz wcel cN c1 caddc co c2 cdiv co cz wcel cN cz
    wcel cN cr wcel cN cc0 wceq cN cn wcel cN cneg cn wcel w3o wa cN c2 cdiv co
    cz wcel wn cN c1 caddc co c2 cdiv co cz wcel wi cN elz cN cr wcel cN cc0
    wceq cN c2 cdiv co cz wcel wn cN c1 caddc co c2 cdiv co cz wcel wi cN cn
    wcel cN cneg cn wcel cN cc0 wceq cN c2 cdiv co cz wcel wn cN c1 caddc co c2
    cdiv co cz wcel wi cN cr wcel cN cc0 wceq cN c2 cdiv co cz wcel cN c1 caddc
    co c2 cdiv co cz wcel cN cc0 wceq cN c2 cdiv co cc0 c2 cdiv co cz cN cc0 c2
    cdiv opreq1 cc0 c2 cdiv co cc0 cz c2 2cn 2ne0 div0i 0z eqeltri syl6eqel
    pm2.24d adantl cN cn wcel cN c2 cdiv co cz wcel wn cN c1 caddc co c2 cdiv
    co cz wcel wi cN cr wcel cN cn wcel cN c2 cdiv co cz wcel wn cN c1 caddc co
    c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cz wcel cN cn wcel cN c2 cdiv
    co cn wcel wn cN c1 caddc co c2 cdiv co cn wcel cN c2 cdiv co cz wcel wn cN
    cn wcel cN c1 caddc co c2 cdiv co cn wcel cN c2 cdiv co cn wcel cN cn wcel
    cN c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cn wcel wn cN nneo biimprd
    con1d cN c2 cdiv co cn wcel cN c2 cdiv co cz wcel cN c2 cdiv co nnz con3i
    syl5 cN c1 caddc co c2 cdiv co nnz syl6 adantl cN cr wcel cN cneg cn wcel
    wa cN c2 cdiv co cz wcel wn cN cneg c2 cdiv co cn wcel wn cN c1 caddc co c2
    cdiv co cz wcel cN cr wcel cN cneg cn wcel wa cN cneg c2 cdiv co cn wcel cN
    c2 cdiv co cz wcel cN cr wcel cN cneg c2 cdiv co cn wcel cN c2 cdiv co cz
    wcel wi cN cneg cn wcel cN cr wcel cN cneg c2 cdiv co cn wcel cN c2 cdiv co
    cneg cneg cz wcel cN c2 cdiv co cz wcel cN cr wcel cN cneg c2 cdiv co cn
    wcel cN c2 cdiv co cneg cn wcel cN c2 cdiv co cneg cneg cz wcel cN cr wcel
    cN c2 cdiv co cneg cN cneg c2 cdiv co cn cN cr wcel cN cc wcel cN c2 cdiv
    co cneg cN cneg c2 cdiv co wceq cN recn cN cc wcel c2 cc wcel c2 cc0 wne cN
    c2 cdiv co cneg cN cneg c2 cdiv co wceq 2cn 2ne0 cN c2 divneg mp3an23 syl
    eleq1d cN c2 cdiv co cneg nnnegz syl6bir cN cr wcel cN c2 cdiv co cneg cneg
    cN c2 cdiv co cz cN cr wcel cN cc wcel cN c2 cdiv co cc wcel cN c2 cdiv co
    cneg cneg cN c2 cdiv co wceq cN recn cN halfcl cN c2 cdiv co negneg 3syl
    eleq1d sylibd adantr con3d cN cneg cn wcel cN cneg c2 cdiv co cn wcel wn cN
    cneg c1 caddc co c2 cdiv co cn wcel cN cr wcel cN c1 caddc co c2 cdiv co cz
    wcel cN cneg cn wcel cN cneg c1 caddc co c2 cdiv co cn wcel cN cneg c2 cdiv
    co cn wcel cN cneg cn wcel cN cneg c2 cdiv co cn wcel cN cneg c1 caddc co
    c2 cdiv co cn wcel wn cN cneg nneo biimprd con1d cN cr wcel cN cneg c1
    caddc co c2 cdiv co cz wcel cN c1 caddc co c2 cdiv co cz wcel cN cneg c1
    caddc co c2 cdiv co cn wcel cN cr wcel cN cneg c1 caddc co c2 cdiv co cz
    wcel cN c1 caddc co c2 cdiv co cneg cneg cz wcel cN c1 caddc co c2 cdiv co
    cz wcel cN cr wcel cN cneg c1 caddc co c2 cdiv co cz wcel cN c1 caddc co c2
    cdiv co cneg cz wcel cN c1 caddc co c2 cdiv co cneg cneg cz wcel cN cr wcel
    cN cneg c1 caddc co c2 cdiv co c1 cmin co cz wcel cN c1 caddc co c2 cdiv co
    cneg cz wcel cN cneg c1 caddc co c2 cdiv co cz wcel cN cr wcel cN cneg c1
    caddc co c2 cdiv co c1 cmin co cN c1 caddc co c2 cdiv co cneg cz cN cr wcel
    cN cc wcel cN cneg c1 caddc co c2 cdiv co c1 cmin co cN c1 caddc co c2 cdiv
    co cneg wceq cN recn cN cc wcel cN cneg c1 caddc co c2 cmin co c2 cdiv co
    cN c1 caddc co cneg c2 cdiv co cN cneg c1 caddc co c2 cdiv co c1 cmin co cN
    c1 caddc co c2 cdiv co cneg cN cc wcel cN cneg c1 caddc co c2 cmin co cN c1
    caddc co cneg c2 cdiv cN cc wcel cN cneg c1 c2 cmin co caddc co cN cneg c1
    cneg caddc co cN cneg c1 caddc co c2 cmin co cN c1 caddc co cneg c1 c2 cmin
    co c1 cneg cN cneg caddc c1 c1 c2 cmin co cneg wceq c1 c2 cmin co c1 cneg
    wceq c1 c2 cmin co cneg c2 c1 cmin co c1 c1 c2 ax1cn 2cn negsubdi2i c2 c1
    c1 2cn ax1cn ax1cn c2 c1 c1 caddc co df-2 eqcomi subaddrii eqtr2i c1 c1 c2
    cmin co ax1cn c1 c2 ax1cn 2cn subcli negcon2i mpbi opreq2i cN cc wcel cN
    cneg cc wcel cN cneg c1 caddc co c2 cmin co cN cneg c1 c2 cmin co caddc co
    wceq cN negcl cN cneg cc wcel c1 cc wcel c2 cc wcel cN cneg c1 caddc co c2
    cmin co cN cneg c1 c2 cmin co caddc co wceq ax1cn 2cn cN cneg c1 c2
    addsubass mp3an23 syl cN cc wcel c1 cc wcel cN c1 caddc co cneg cN cneg c1
    cneg caddc co wceq ax1cn cN c1 negdi mpan2 3eqtr4a opreq1d cN cc wcel cN
    cneg c1 caddc co c2 cmin co c2 cdiv co cN cneg c1 caddc co c2 cdiv co c2 c2
    cdiv co cmin co cN cneg c1 caddc co c2 cdiv co c1 cmin co cN cc wcel cN
    cneg cc wcel cN cneg c1 caddc co cc wcel cN cneg c1 caddc co c2 cmin co c2
    cdiv co cN cneg c1 caddc co c2 cdiv co c2 c2 cdiv co cmin co wceq cN negcl
    cN cneg peano2cn cN cneg c1 caddc co cc wcel c2 cc wcel c2 cc wcel c2 cc0
    wne wa cN cneg c1 caddc co c2 cmin co c2 cdiv co cN cneg c1 caddc co c2
    cdiv co c2 c2 cdiv co cmin co wceq 2cn c2 cc wcel c2 cc0 wne 2cn 2ne0
    pm3.2i cN cneg c1 caddc co c2 c2 divsubdir mp3an23 3syl c1 c2 c2 cdiv co cN
    cneg c1 caddc co c2 cdiv co cmin c2 c2 cdiv co c1 c2 2cn 2ne0 dividi eqcomi
    opreq2i syl6reqr cN cc wcel cN c1 caddc co cc wcel cN c1 caddc co c2 cdiv
    co cneg cN c1 caddc co cneg c2 cdiv co wceq cN peano2cn cN c1 caddc co cc
    wcel c2 cc wcel c2 cc0 wne cN c1 caddc co c2 cdiv co cneg cN c1 caddc co
    cneg c2 cdiv co wceq 2cn 2ne0 cN c1 caddc co c2 divneg mp3an23 syl 3eqtr4d
    syl eleq1d cN cneg c1 caddc co c2 cdiv co peano2zm syl5bi cN c1 caddc co c2
    cdiv co cneg znegcl syl6 cN cr wcel cN c1 caddc co c2 cdiv co cneg cneg cN
    c1 caddc co c2 cdiv co cz cN cr wcel cN c1 caddc co cc wcel cN c1 caddc co
    c2 cdiv co cc wcel cN c1 caddc co c2 cdiv co cneg cneg cN c1 caddc co c2
    cdiv co wceq cN cr wcel cN c1 caddc co cN peano2re recnd cN c1 caddc co
    halfcl cN c1 caddc co c2 cdiv co negneg 3syl eleq1d sylibd cN cneg c1 caddc
    co c2 cdiv co nnz syl5 sylan9r syld 3jaodan sylbi orrd $.
    $( [5-Jan-2006] $) $( [1-Jan-2006] $)

  $( No even integer equals an odd integer (i.e. no integer can be both even
     and odd).  Exercise 10(a) of [Apostol] p. 28. $)
  zneo $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
             ( 2 x. A ) =/= ( ( 2 x. B ) + 1 ) ) $=
    cA cz wcel cB cz wcel wa cB c1 c2 cdiv co caddc co cz wcel wn c2 cA cmul co
    c2 cB cmul co c1 caddc co wne cB cz wcel cB c1 c2 cdiv co caddc co cz wcel
    wn cA cz wcel cB cz wcel cB c1 c2 cdiv co caddc co cz wcel cB c1 c2 cdiv co
    caddc co cB cmin co cz wcel cB cz wcel cB c1 c2 cdiv co caddc co cB cmin co
    cz wcel c1 c2 cdiv co cz wcel halfnz cB cz wcel cB c1 c2 cdiv co caddc co
    cB cmin co c1 c2 cdiv co cz cB cz wcel cB cc wcel cB c1 c2 cdiv co caddc co
    cB cmin co c1 c2 cdiv co wceq cB zcn cB cc wcel cB c1 c2 cdiv co caddc co
    cB cmin co c1 c2 cdiv co cB caddc co cB cmin co c1 c2 cdiv co cB cc wcel cB
    c1 c2 cdiv co caddc co c1 c2 cdiv co cB caddc co cB cmin cB cc wcel c1 c2
    cdiv co cc wcel cB c1 c2 cdiv co caddc co c1 c2 cdiv co cB caddc co wceq c2
    2cn 2ne0 reccli cB c1 c2 cdiv co addcom mpan2 opreq1d c1 c2 cdiv co cc wcel
    cB cc wcel c1 c2 cdiv co cB caddc co cB cmin co c1 c2 cdiv co wceq c2 2cn
    2ne0 reccli c1 c2 cdiv co cB pncan mpan eqtrd syl eleq1d mtbiri cB c1 c2
    cdiv co caddc co cz wcel cB cz wcel cB c1 c2 cdiv co caddc co cB cmin co cz
    wcel cB c1 c2 cdiv co caddc co cB zsubcl expcom mtod adantl cA cz wcel cB
    cz wcel wa cB c1 c2 cdiv co caddc co cz wcel c2 cA cmul co c2 cB cmul co c1
    caddc co cA cz wcel cB cz wcel c2 cA cmul co c2 cB cmul co c1 caddc co wceq
    cB c1 c2 cdiv co caddc co cz wcel wi cB cz wcel c2 cA cmul co c2 cB cmul co
    c1 caddc co wceq cA cz wcel cB c1 c2 cdiv co caddc co cz wcel cB cz wcel c2
    cA cmul co c2 cB cmul co c1 caddc co wceq cA cz wcel cA cz wcel cB c1 c2
    cdiv co caddc co cz wcel wb wi cA cz wcel cB c1 c2 cdiv co caddc co cz wcel
    wi cA cz wcel cB cz wcel c2 cA cmul co c2 cB cmul co c1 caddc co wceq cA cz
    wcel cB c1 c2 cdiv co caddc co cz wcel wb cA cz wcel cB cz wcel c2 cA cmul
    co c2 cB cmul co c1 caddc co wceq cA cz wcel cB c1 c2 cdiv co caddc co cz
    wcel wb cA cz wcel cB cz wcel wa c2 cA cmul co c2 cB cmul co c1 caddc co
    wceq wa cA cB c1 c2 cdiv co caddc co cz cA cz wcel cB cz wcel wa c2 cA cmul
    co c2 cB cmul co c1 caddc co wceq cA cB c1 c2 cdiv co caddc co wceq cA cc
    wcel cB cc wcel c2 cA cmul co c2 cB cmul co c1 caddc co wceq cA cB c1 c2
    cdiv co caddc co wceq wi cA cz wcel cB cz wcel cA cc wcel cB cc wcel wa c2
    cA cmul co c2 cdiv co c2 cB cmul co c1 caddc co c2 cdiv co wceq cA cB c1 c2
    cdiv co caddc co wceq c2 cA cmul co c2 cB cmul co c1 caddc co wceq cA cc
    wcel cB cc wcel c2 cA cmul co c2 cdiv co cA c2 cB cmul co c1 caddc co c2
    cdiv co cB c1 c2 cdiv co caddc co cA cc wcel c2 cc wcel c2 cc0 wne c2 cA
    cmul co c2 cdiv co cA wceq 2cn 2ne0 cA c2 divcan3 mp3an23 cB cc wcel c2 cB
    cmul co c1 caddc co c2 cdiv co c2 cB cmul co c2 cdiv co c1 c2 cdiv co caddc
    co cB c1 c2 cdiv co caddc co cB cc wcel c2 cB cmul co cc wcel c2 cB cmul co
    c1 caddc co c2 cdiv co c2 cB cmul co c2 cdiv co c1 c2 cdiv co caddc co wceq
    c2 cc wcel cB cc wcel c2 cB cmul co cc wcel 2cn c2 cB mulcl mpan c2 cB cmul
    co cc wcel c1 cc wcel c2 cc wcel c2 cc0 wne wa c2 cB cmul co c1 caddc co c2
    cdiv co c2 cB cmul co c2 cdiv co c1 c2 cdiv co caddc co wceq ax1cn c2 cc
    wcel c2 cc0 wne 2cn 2ne0 pm3.2i c2 cB cmul co c1 c2 divdir mp3an23 syl cB
    cc wcel c2 cB cmul co c2 cdiv co cB c1 c2 cdiv co caddc cB cc wcel c2 cc
    wcel c2 cc0 wne c2 cB cmul co c2 cdiv co cB wceq 2cn 2ne0 cB c2 divcan3
    mp3an23 opreq1d eqtrd eqeqan12d c2 cA cmul co c2 cB cmul co c1 caddc co c2
    cdiv opreq1 syl5bi cA zcn cB zcn syl2an imp eleq1d exp31 com3l cA cz wcel
    cB c1 c2 cdiv co caddc co cz wcel ibib syl6ibr com3r imp necon3bd mpd $.
    $( [11-Jan-2008] $) $( [31-Jul-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Second Peano postulate for upper integers. $)
    peano2uz2 $p |- ( ( A e. ZZ /\ B e. { x e. ZZ | A <_ x } ) ->
                             ( B + 1 ) e. { x e. ZZ | A <_ x } ) $=
      cA cz wcel cB cz wcel cA cB cle wbr wa wa cB c1 caddc co cz wcel cA cB c1
      caddc co cle wbr wa cA cz wcel cB cA vx cv cle wbr vx cz crab wcel wa cB
      c1 caddc co cA vx cv cle wbr vx cz crab wcel cA cz wcel cB cz wcel cA cB
      cle wbr wa wa cB c1 caddc co cz wcel cA cB c1 caddc co cle wbr cB cz wcel
      cB c1 caddc co cz wcel cA cz wcel cA cB cle wbr cB peano2z ad2antrl cA cz
      wcel cB cz wcel cA cB cle wbr cA cB c1 caddc co cle wbr cA cz wcel cB cz
      wcel cA cB cle wbr cA cB c1 caddc co cle wbr wi cA cr wcel cB cr wcel cA
      cB cle wbr cA cB c1 caddc co cle wbr wi cA cz wcel cB cz wcel cA cr wcel
      cB cr wcel wa cA cB cle wbr cB cB c1 caddc co cle wbr cA cB c1 caddc co
      cle wbr cB cr wcel cB cB c1 caddc co cle wbr cA cr wcel cB lep1 adantl cA
      cr wcel cB cr wcel cB c1 caddc co cr wcel wa cA cB cle wbr cB cB c1 caddc
      co cle wbr wa cA cB c1 caddc co cle wbr wi cB cr wcel cA cr wcel cB cr
      wcel cB c1 caddc co cr wcel cA cB cle wbr cB cB c1 caddc co cle wbr wa cA
      cB c1 caddc co cle wbr wi cA cB cB c1 caddc co letr 3expb cB cr wcel cB
      c1 caddc co cr wcel cB peano2re ancli sylan2 mpan2d cA zre cB zre syl2an
      ex imp32 jca cB cA vx cv cle wbr vx cz crab wcel cB cz wcel cA cB cle wbr
      wa cA cz wcel cA vx cv cle wbr cA cB cle wbr vx cB cz vx cv cB cA cle
      breq2 elrab anbi2i cA vx cv cle wbr cA cB c1 caddc co cle wbr vx cB c1
      caddc co cz vx cv cB c1 caddc co cA cle breq2 elrab 3imtr4i $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)
  $}

  ${
    $d x y z w v u m N $.
    dfuz.1 $e |- N e. ZZ $.
    $( An expression for the upper integers that start at ` N ` that is
       analogous to ~ df-n for natural numbers. _Warning:  The HTML proof page
       is 1/2 megabyte in size_. $)
    dfuzi $p |- { z e. ZZ | N <_ z } =
               |^| { x | ( N e. x /\ A. y e. x ( y + 1 ) e. x ) } $=
      vm cN vz cv cle wbr vz cz crab cN vx cv wcel vy cv c1 caddc co vx cv wcel
      vy vx cv wral wa vx cab cint vm cv cN vz cv cle wbr vz cz crab wcel vm cv
      cz wcel vm cv cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa
      vx cab cint wcel vm cv cN vz cv cle wbr vz cz crab wcel vm cv cz wcel cN
      vm cv cle wbr cN vz cv cle wbr cN vm cv cle wbr vz vm cv cz vz cv vm cv
      cN cle breq2 elrab pm3.26bi cN vx cv wcel vy cv c1 caddc co vx cv wcel vy
      vx cv wral wa vx cab cint cz vm cv cz cvv wcel cN vx cv wcel vy cv c1
      caddc co vx cv wcel vy vx cv wral wa vx cab cint cz wss zex cN vx cv wcel
      vy cv c1 caddc co vx cv wcel vy vx cv wral wa cN cz wcel vy cv c1 caddc
      co cz wcel vy cz wral wa vx cz cvv vx cv cz wceq cN vx cv wcel cN cz wcel
      vy cv c1 caddc co vx cv wcel vy vx cv wral vy cv c1 caddc co cz wcel vy
      cz wral vx cv cz cN eleq2 vy cv c1 caddc co vx cv wcel vy cv c1 caddc co
      cz wcel vy vx cv cz vx cv cz vy cv c1 caddc co eleq2 raleqd anbi12d cN cz
      wcel vy cv c1 caddc co cz wcel vy cz wral dfuz.1 vy cv c1 caddc co cz
      wcel vy cz vy cv peano2z rgen pm3.2i intmin3 ax-mp sseli vm cv cz wcel vm
      cv c1 cN cmin co caddc co c1 vv cv cle wbr vv cz crab wcel vm cv cN vz cv
      cle wbr vz cz crab wcel vm cv cN vx cv wcel vy cv c1 caddc co vx cv wcel
      vy vx cv wral wa vx cab cint wcel vm cv cz wcel vm cv c1 cN cmin co caddc
      co c1 vv cv cle wbr vv cz crab wcel vm cv c1 vz cv c1 cN cmin co caddc co
      cle wbr vz cz crab wcel vm cv cN vz cv cle wbr vz cz crab wcel c1 vv cv
      cle wbr c1 vz cv c1 cN cmin co caddc co cle wbr vv vz vu vz cv c1 cN cmin
      co caddc co vm cv vm cv c1 cN cmin co caddc co cz vu cv vm cv wcel vz
      ax-17 vu cv vm cv c1 cN cmin co caddc co wcel vz ax-17 vz cv cz wcel c1
      cN cmin co cz wcel vz cv c1 cN cmin co caddc co cz wcel c1 cz wcel cN cz
      wcel c1 cN cmin co cz wcel 1z dfuz.1 c1 cN zsubcl mp2an vz cv c1 cN cmin
      co zaddcl mpan2 vv cv vz cv c1 cN cmin co caddc co c1 cle breq2 vz cv vm
      cv c1 cN cmin co caddc opreq1 rabxfr cN vz cv cle wbr vz cz crab c1 vz cv
      c1 cN cmin co caddc co cle wbr vz cz crab vm cv cN vz cv cle wbr c1 vz cv
      c1 cN cmin co caddc co cle wbr vz cz vz cv cz wcel cN vz cv cle wbr cN c1
      cN cmin co caddc co vz cv c1 cN cmin co caddc co cle wbr c1 vz cv c1 cN
      cmin co caddc co cle wbr vz cv cz wcel vz cv cr wcel cN vz cv cle wbr cN
      c1 cN cmin co caddc co vz cv c1 cN cmin co caddc co cle wbr wb vz cv zre
      cN cr wcel vz cv cr wcel c1 cN cmin co cr wcel cN vz cv cle wbr cN c1 cN
      cmin co caddc co vz cv c1 cN cmin co caddc co cle wbr wb cN dfuz.1 zrei
      c1 cN 1re cN dfuz.1 zrei resubcli cN vz cv c1 cN cmin co leadd1 mp3an13
      syl cN c1 cN cmin co caddc co c1 vz cv c1 cN cmin co caddc co cle cN c1
      cN cN dfuz.1 zrei recni ax1cn pncan3i breq1i syl6bb rabbii eleq2i syl6bbr
      vm cv cz wcel vm cv cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv
      wral wa vx cab cint wcel vm cv c1 cN cmin co caddc co c1 vw cv wcel vv cv
      c1 caddc co vw cv wcel vv vw cv wral wa vw cab cint wcel vm cv c1 cN cmin
      co caddc co c1 vv cv cle wbr vv cz crab wcel vm cv cz wcel cN vx cv wcel
      vy cv c1 caddc co vx cv wcel vy vx cv wral wa vm cv vx cv wcel wi vx wal
      c1 vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral wa vm cv c1 cN
      cmin co caddc co vw cv wcel wi vw wal vm cv cN vx cv wcel vy cv c1 caddc
      co vx cv wcel vy vx cv wral wa vx cab cint wcel vm cv c1 cN cmin co caddc
      co c1 vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral wa vw cab
      cint wcel vm cv cz wcel cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx
      cv wral wa vm cv vx cv wcel wi vx wal c1 vw cv wcel vv cv c1 caddc co vw
      cv wcel vv vw cv wral wa vm cv c1 cN cmin co caddc co vw cv wcel wi vw
      wal vm cv cz wcel cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv
      wral wa vm cv vx cv wcel wi vx wal c1 vw cv wcel vv cv c1 caddc co vw cv
      wcel vv vw cv wral wa vm cv c1 cN cmin co caddc co vw cv wcel wi vw vm cv
      cz wcel c1 vw cv wcel vy cv cr wcel vy cv c1 cN cmin co caddc co vw cv
      wcel wa vy cv c1 caddc co cr wcel vy cv c1 caddc co c1 cN cmin co caddc
      co vw cv wcel wa wi vy wal wa vm cv cr wcel vm cv c1 cN cmin co caddc co
      vw cv wcel wa wi c1 vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral
      wa vm cv c1 cN cmin co caddc co vw cv wcel wi cN vx cv wcel vy cv c1
      caddc co vx cv wcel vy vx cv wral wa vm cv vx cv wcel wi vx wal c1 vw cv
      wcel vy cv cr wcel vy cv c1 cN cmin co caddc co vw cv wcel wa vy cv c1
      caddc co cr wcel vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel wa
      wi vy wal wa vm cv cr wcel vm cv c1 cN cmin co caddc co vw cv wcel wa wi
      c1 vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral wa vm cv c1 cN
      cmin co caddc co vw cv wcel wi wi vm cv cz wcel c1 vw cv wcel vv cv c1
      caddc co vw cv wcel vv vw cv wral wa c1 vw cv wcel vy cv cr wcel vy cv c1
      cN cmin co caddc co vw cv wcel wa vy cv c1 caddc co cr wcel vy cv c1
      caddc co c1 cN cmin co caddc co vw cv wcel wa wi vy wal wa vm cv cr wcel
      vm cv c1 cN cmin co caddc co vw cv wcel wa vm cv c1 cN cmin co caddc co
      vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral vy cv cr wcel vy cv
      c1 cN cmin co caddc co vw cv wcel wa vy cv c1 caddc co cr wcel vy cv c1
      caddc co c1 cN cmin co caddc co vw cv wcel wa wi vy wal c1 vw cv wcel vv
      cv c1 caddc co vw cv wcel vv vw cv wral vy cv cr wcel vy cv c1 cN cmin co
      caddc co vw cv wcel wa vy cv c1 caddc co cr wcel vy cv c1 caddc co c1 cN
      cmin co caddc co vw cv wcel wa wi vy vy cv cr wcel vy cv c1 cN cmin co
      caddc co vw cv wcel wa vv cv c1 caddc co vw cv wcel vv vw cv wral vy cv
      c1 caddc co cr wcel vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel
      wa vy cv c1 cN cmin co caddc co vw cv wcel vv cv c1 caddc co vw cv wcel
      vv vw cv wral vy cv c1 cN cmin co caddc co c1 caddc co vw cv wcel vy cv
      cr wcel vy cv c1 caddc co cr wcel vy cv c1 caddc co c1 cN cmin co caddc
      co vw cv wcel wa vv cv c1 caddc co vw cv wcel vy cv c1 cN cmin co caddc
      co c1 caddc co vw cv wcel vv vy cv c1 cN cmin co caddc co vw cv vv cv vy
      cv c1 cN cmin co caddc co wceq vv cv c1 caddc co vy cv c1 cN cmin co
      caddc co c1 caddc co vw cv vv cv vy cv c1 cN cmin co caddc co c1 caddc
      opreq1 eleq1d rcla4v vy cv cr wcel vy cv c1 cN cmin co caddc co c1 caddc
      co vw cv wcel vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel vy cv
      c1 caddc co cr wcel vy cv cr wcel vy cv c1 cN cmin co caddc co c1 caddc
      co vw cv wcel vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel vy cv
      cr wcel vy cv c1 cN cmin co caddc co c1 caddc co vy cv c1 caddc co c1 cN
      cmin co caddc co vw cv vy cv cr wcel vy cv cc wcel vy cv c1 cN cmin co
      caddc co c1 caddc co vy cv c1 caddc co c1 cN cmin co caddc co wceq vy cv
      recn vy cv cc wcel c1 cN cmin co cc wcel c1 cc wcel vy cv c1 cN cmin co
      caddc co c1 caddc co vy cv c1 caddc co c1 cN cmin co caddc co wceq c1 cN
      cmin co c1 cN 1re cN dfuz.1 zrei resubcli recni ax1cn vy cv c1 cN cmin co
      c1 add23 mp3an23 syl eleq1d biimpd vy cv peano2re jctild sylan9r com12
      19.21aiv anim2i vm cv cr wcel vm cv c1 cN cmin co caddc co vw cv wcel
      pm3.27 imim12i a1i cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv
      wral wa vm cv vx cv wcel wi c1 vw cv wcel vy cv cr wcel vy cv c1 cN cmin
      co caddc co vw cv wcel wa vy cv c1 caddc co cr wcel vy cv c1 caddc co c1
      cN cmin co caddc co vw cv wcel wa wi vy wal wa vm cv cr wcel vm cv c1 cN
      cmin co caddc co vw cv wcel wa wi vx vu cv c1 cN cmin co caddc co vw cv
      wcel vu cr crab vu cv c1 cN cmin co caddc co vw cv wcel vu cr reex rabex
      vx cv vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab wceq cN vx cv
      wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa c1 vw cv wcel vy cv cr
      wcel vy cv c1 cN cmin co caddc co vw cv wcel wa vy cv c1 caddc co cr wcel
      vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel wa wi vy wal wa vm cv
      vx cv wcel vm cv cr wcel vm cv c1 cN cmin co caddc co vw cv wcel wa vx cv
      vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab wceq cN vx cv wcel c1
      vw cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral vy cv cr wcel vy cv
      c1 cN cmin co caddc co vw cv wcel wa vy cv c1 caddc co cr wcel vy cv c1
      caddc co c1 cN cmin co caddc co vw cv wcel wa wi vy wal vx cv vu cv c1 cN
      cmin co caddc co vw cv wcel vu cr crab wceq cN vx cv wcel cN vu cv c1 cN
      cmin co caddc co vw cv wcel vu cr crab wcel c1 vw cv wcel vx cv vu cv c1
      cN cmin co caddc co vw cv wcel vu cr crab cN eleq2 cN vu cv c1 cN cmin co
      caddc co vw cv wcel vu cr crab wcel cN cr wcel c1 vw cv wcel vu cv c1 cN
      cmin co caddc co vw cv wcel c1 vw cv wcel vu cN cr vu cv cN wceq vu cv c1
      cN cmin co caddc co c1 vw cv vu cv cN wceq vu cv c1 cN cmin co caddc co
      cN c1 cN cmin co caddc co c1 vu cv cN c1 cN cmin co caddc opreq1 cN c1 cN
      cN dfuz.1 zrei recni ax1cn pncan3i syl6eq eleq1d elrab cN dfuz.1 zrei
      mpbiran syl6bb vx cv vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab
      wceq vy cv vx cv wcel vy cv c1 caddc co vx cv wcel wi vy wal vy cv cr
      wcel vy cv c1 cN cmin co caddc co vw cv wcel wa vy cv c1 caddc co cr wcel
      vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel wa wi vy wal vy cv c1
      caddc co vx cv wcel vy vx cv wral vx cv vu cv c1 cN cmin co caddc co vw
      cv wcel vu cr crab wceq vy cv vx cv wcel vy cv c1 caddc co vx cv wcel wi
      vy cv cr wcel vy cv c1 cN cmin co caddc co vw cv wcel wa vy cv c1 caddc
      co cr wcel vy cv c1 caddc co c1 cN cmin co caddc co vw cv wcel wa wi vy
      vx cv vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab wceq vy cv vx cv
      wcel vy cv cr wcel vy cv c1 cN cmin co caddc co vw cv wcel wa vy cv c1
      caddc co vx cv wcel vy cv c1 caddc co cr wcel vy cv c1 caddc co c1 cN
      cmin co caddc co vw cv wcel wa vx cv vu cv c1 cN cmin co caddc co vw cv
      wcel vu cr crab wceq vy cv vx cv wcel vy cv vu cv c1 cN cmin co caddc co
      vw cv wcel vu cr crab wcel vy cv cr wcel vy cv c1 cN cmin co caddc co vw
      cv wcel wa vx cv vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab vy cv
      eleq2 vu cv c1 cN cmin co caddc co vw cv wcel vy cv c1 cN cmin co caddc
      co vw cv wcel vu vy cv cr vu cv vy cv wceq vu cv c1 cN cmin co caddc co
      vy cv c1 cN cmin co caddc co vw cv vu cv vy cv c1 cN cmin co caddc opreq1
      eleq1d elrab syl6bb vx cv vu cv c1 cN cmin co caddc co vw cv wcel vu cr
      crab wceq vy cv c1 caddc co vx cv wcel vy cv c1 caddc co vu cv c1 cN cmin
      co caddc co vw cv wcel vu cr crab wcel vy cv c1 caddc co cr wcel vy cv c1
      caddc co c1 cN cmin co caddc co vw cv wcel wa vx cv vu cv c1 cN cmin co
      caddc co vw cv wcel vu cr crab vy cv c1 caddc co eleq2 vu cv c1 cN cmin
      co caddc co vw cv wcel vy cv c1 caddc co c1 cN cmin co caddc co vw cv
      wcel vu vy cv c1 caddc co cr vu cv vy cv c1 caddc co wceq vu cv c1 cN
      cmin co caddc co vy cv c1 caddc co c1 cN cmin co caddc co vw cv vu cv vy
      cv c1 caddc co c1 cN cmin co caddc opreq1 eleq1d elrab syl6bb imbi12d
      albidv vy cv c1 caddc co vx cv wcel vy vx cv df-ral syl5bb anbi12d vx cv
      vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab wceq vm cv vx cv wcel
      vm cv vu cv c1 cN cmin co caddc co vw cv wcel vu cr crab wcel vm cv cr
      wcel vm cv c1 cN cmin co caddc co vw cv wcel wa vx cv vu cv c1 cN cmin co
      caddc co vw cv wcel vu cr crab vm cv eleq2 vu cv c1 cN cmin co caddc co
      vw cv wcel vm cv c1 cN cmin co caddc co vw cv wcel vu vm cv cr vu cv vm
      cv wceq vu cv c1 cN cmin co caddc co vm cv c1 cN cmin co caddc co vw cv
      vu cv vm cv c1 cN cmin co caddc opreq1 eleq1d elrab syl6bb imbi12d cla4v
      syl5 19.21adv vm cv cz wcel c1 vw cv wcel vv cv c1 caddc co vw cv wcel vv
      vw cv wral wa vm cv c1 cN cmin co caddc co vw cv wcel wi vw wal cN vx cv
      wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vm cv vx cv wcel wi vx
      vm cv cz wcel cN vx cv wcel vv cv cr wcel vv cv c1 cN cmin co cmin co vx
      cv wcel wa vv cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin
      co vx cv wcel wa wi vv wal wa vm cv c1 cN cmin co caddc co cr wcel vm cv
      c1 cN cmin co caddc co c1 cN cmin co cmin co vx cv wcel wa wi cN vx cv
      wcel vy cv c1 caddc co vx cv wcel vy vx cv wral wa vm cv vx cv wcel wi c1
      vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral wa vm cv c1 cN cmin
      co caddc co vw cv wcel wi vw wal vm cv cz wcel cN vx cv wcel vy cv c1
      caddc co vx cv wcel vy vx cv wral wa cN vx cv wcel vv cv cr wcel vv cv c1
      cN cmin co cmin co vx cv wcel wa vv cv c1 caddc co cr wcel vv cv c1 caddc
      co c1 cN cmin co cmin co vx cv wcel wa wi vv wal wa vm cv c1 cN cmin co
      caddc co cr wcel vm cv c1 cN cmin co caddc co c1 cN cmin co cmin co vx cv
      wcel wa vm cv vx cv wcel cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx
      cv wral wa cN vx cv wcel vv cv cr wcel vv cv c1 cN cmin co cmin co vx cv
      wcel wa vv cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin co
      vx cv wcel wa wi vv wal wa wi vm cv cz wcel vy cv c1 caddc co vx cv wcel
      vy vx cv wral vv cv cr wcel vv cv c1 cN cmin co cmin co vx cv wcel wa vv
      cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv wcel
      wa wi vv wal cN vx cv wcel vy cv c1 caddc co vx cv wcel vy vx cv wral vv
      cv cr wcel vv cv c1 cN cmin co cmin co vx cv wcel wa vv cv c1 caddc co cr
      wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv wcel wa wi vv vv cv cr
      wcel vv cv c1 cN cmin co cmin co vx cv wcel wa vy cv c1 caddc co vx cv
      wcel vy vx cv wral vv cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin
      co cmin co vx cv wcel wa vv cv c1 cN cmin co cmin co vx cv wcel vy cv c1
      caddc co vx cv wcel vy vx cv wral vv cv c1 cN cmin co cmin co c1 caddc co
      vx cv wcel vv cv cr wcel vv cv c1 caddc co cr wcel vv cv c1 caddc co c1
      cN cmin co cmin co vx cv wcel wa vy cv c1 caddc co vx cv wcel vv cv c1 cN
      cmin co cmin co c1 caddc co vx cv wcel vy vv cv c1 cN cmin co cmin co vx
      cv vy cv vv cv c1 cN cmin co cmin co wceq vy cv c1 caddc co vv cv c1 cN
      cmin co cmin co c1 caddc co vx cv vy cv vv cv c1 cN cmin co cmin co c1
      caddc opreq1 eleq1d rcla4v vv cv cr wcel vv cv c1 cN cmin co cmin co c1
      caddc co vx cv wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv wcel vv
      cv c1 caddc co cr wcel vv cv cr wcel vv cv c1 caddc co c1 cN cmin co cmin
      co vx cv wcel vv cv c1 cN cmin co cmin co c1 caddc co vx cv wcel vv cv cr
      wcel vv cv c1 caddc co c1 cN cmin co cmin co vv cv c1 cN cmin co cmin co
      c1 caddc co vx cv vv cv cr wcel vv cv cc wcel vv cv c1 caddc co c1 cN
      cmin co cmin co vv cv c1 cN cmin co cmin co c1 caddc co wceq vv cv recn
      vv cv cc wcel c1 cc wcel c1 cN cmin co cc wcel vv cv c1 caddc co c1 cN
      cmin co cmin co vv cv c1 cN cmin co cmin co c1 caddc co wceq ax1cn c1 cN
      cmin co c1 cN 1re cN dfuz.1 zrei resubcli recni vv cv c1 c1 cN cmin co
      addsub mp3an23 syl eleq1d biimprd vv cv peano2re jctild sylan9r com12
      19.21aiv anim2i a1i vm cv cz wcel vm cv c1 cN cmin co caddc co c1 cN cmin
      co cmin co vx cv wcel vm cv vx cv wcel vm cv c1 cN cmin co caddc co cr
      wcel vm cv cz wcel vm cv c1 cN cmin co caddc co c1 cN cmin co cmin co vx
      cv wcel vm cv vx cv wcel vm cv cz wcel vm cv c1 cN cmin co caddc co c1 cN
      cmin co cmin co vm cv vx cv vm cv cc wcel c1 cN cmin co cc wcel vm cv c1
      cN cmin co caddc co c1 cN cmin co cmin co vm cv wceq vm cv cz wcel vm cv
      c1 cN cmin co pncan vm cv zcn c1 cN cmin co c1 cN 1re cN dfuz.1 zrei
      resubcli recni sylancl eleq1d biimpd adantld imim12d c1 vw cv wcel vv cv
      c1 caddc co vw cv wcel vv vw cv wral wa vm cv c1 cN cmin co caddc co vw
      cv wcel wi cN vx cv wcel vv cv cr wcel vv cv c1 cN cmin co cmin co vx cv
      wcel wa vv cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin co
      vx cv wcel wa wi vv wal wa vm cv c1 cN cmin co caddc co cr wcel vm cv c1
      cN cmin co caddc co c1 cN cmin co cmin co vx cv wcel wa wi vw vu cv c1 cN
      cmin co cmin co vx cv wcel vu cr crab vu cv c1 cN cmin co cmin co vx cv
      wcel vu cr reex rabex vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr
      crab wceq c1 vw cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral wa cN
      vx cv wcel vv cv cr wcel vv cv c1 cN cmin co cmin co vx cv wcel wa vv cv
      c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv wcel wa
      wi vv wal wa vm cv c1 cN cmin co caddc co vw cv wcel vm cv c1 cN cmin co
      caddc co cr wcel vm cv c1 cN cmin co caddc co c1 cN cmin co cmin co vx cv
      wcel wa vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wceq c1
      vw cv wcel cN vx cv wcel vv cv c1 caddc co vw cv wcel vv vw cv wral vv cv
      cr wcel vv cv c1 cN cmin co cmin co vx cv wcel wa vv cv c1 caddc co cr
      wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv wcel wa wi vv wal vw
      cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wceq c1 vw cv wcel
      c1 vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wcel cN vx cv wcel
      vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab c1 eleq2 c1 vu cv
      c1 cN cmin co cmin co vx cv wcel vu cr crab wcel c1 cr wcel cN vx cv wcel
      vu cv c1 cN cmin co cmin co vx cv wcel cN vx cv wcel vu c1 cr vu cv c1
      wceq vu cv c1 cN cmin co cmin co cN vx cv vu cv c1 wceq vu cv c1 cN cmin
      co cmin co c1 c1 cN cmin co cmin co cN vu cv c1 c1 cN cmin co cmin opreq1
      c1 cc wcel cN cc wcel c1 c1 cN cmin co cmin co cN wceq ax1cn cN cN dfuz.1
      zrei recni c1 cN nncan mp2an syl6eq eleq1d elrab 1re mpbiran syl6bb vw cv
      vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wceq vv cv vw cv wcel
      vv cv c1 caddc co vw cv wcel wi vv wal vv cv cr wcel vv cv c1 cN cmin co
      cmin co vx cv wcel wa vv cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN
      cmin co cmin co vx cv wcel wa wi vv wal vv cv c1 caddc co vw cv wcel vv
      vw cv wral vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wceq
      vv cv vw cv wcel vv cv c1 caddc co vw cv wcel wi vv cv cr wcel vv cv c1
      cN cmin co cmin co vx cv wcel wa vv cv c1 caddc co cr wcel vv cv c1 caddc
      co c1 cN cmin co cmin co vx cv wcel wa wi vv vw cv vu cv c1 cN cmin co
      cmin co vx cv wcel vu cr crab wceq vv cv vw cv wcel vv cv cr wcel vv cv
      c1 cN cmin co cmin co vx cv wcel wa vv cv c1 caddc co vw cv wcel vv cv c1
      caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv wcel wa vw
      cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wceq vv cv vw cv
      wcel vv cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wcel vv cv
      cr wcel vv cv c1 cN cmin co cmin co vx cv wcel wa vw cv vu cv c1 cN cmin
      co cmin co vx cv wcel vu cr crab vv cv eleq2 vu cv c1 cN cmin co cmin co
      vx cv wcel vv cv c1 cN cmin co cmin co vx cv wcel vu vv cv cr vu cv vv cv
      wceq vu cv c1 cN cmin co cmin co vv cv c1 cN cmin co cmin co vx cv vu cv
      vv cv c1 cN cmin co cmin opreq1 eleq1d elrab syl6bb vw cv vu cv c1 cN
      cmin co cmin co vx cv wcel vu cr crab wceq vv cv c1 caddc co vw cv wcel
      vv cv c1 caddc co vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wcel
      vv cv c1 caddc co cr wcel vv cv c1 caddc co c1 cN cmin co cmin co vx cv
      wcel wa vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab vv cv c1
      caddc co eleq2 vu cv c1 cN cmin co cmin co vx cv wcel vv cv c1 caddc co
      c1 cN cmin co cmin co vx cv wcel vu vv cv c1 caddc co cr vu cv vv cv c1
      caddc co wceq vu cv c1 cN cmin co cmin co vv cv c1 caddc co c1 cN cmin co
      cmin co vx cv vu cv vv cv c1 caddc co c1 cN cmin co cmin opreq1 eleq1d
      elrab syl6bb imbi12d albidv vv cv c1 caddc co vw cv wcel vv vw cv df-ral
      syl5bb anbi12d vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab
      wceq vm cv c1 cN cmin co caddc co vw cv wcel vm cv c1 cN cmin co caddc co
      vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab wcel vm cv c1 cN cmin
      co caddc co cr wcel vm cv c1 cN cmin co caddc co c1 cN cmin co cmin co vx
      cv wcel wa vw cv vu cv c1 cN cmin co cmin co vx cv wcel vu cr crab vm cv
      c1 cN cmin co caddc co eleq2 vu cv c1 cN cmin co cmin co vx cv wcel vm cv
      c1 cN cmin co caddc co c1 cN cmin co cmin co vx cv wcel vu vm cv c1 cN
      cmin co caddc co cr vu cv vm cv c1 cN cmin co caddc co wceq vu cv c1 cN
      cmin co cmin co vm cv c1 cN cmin co caddc co c1 cN cmin co cmin co vx cv
      vu cv vm cv c1 cN cmin co caddc co c1 cN cmin co cmin opreq1 eleq1d elrab
      syl6bb imbi12d cla4v syl5 19.21adv impbid cN vx cv wcel vy cv c1 caddc co
      vx cv wcel vy vx cv wral wa vx vm cv vm visset elintab c1 vw cv wcel vv
      cv c1 caddc co vw cv wcel vv vw cv wral wa vw vm cv c1 cN cmin co caddc
      co vm cv c1 cN cmin co caddc oprex elintab 3bitr4g c1 vw cv wcel vv cv c1
      caddc co vw cv wcel vv vw cv wral wa vw cab cint c1 vv cv cle wbr vv cz
      crab vm cv c1 cN cmin co caddc co cn c1 vw cv wcel vv cv c1 caddc co vw
      cv wcel vv vw cv wral wa vw cab cint c1 vv cv cle wbr vv cz crab vw vv
      df-n vv nnzrab eqtr3i eleq2i syl6rbb bitr3d pm5.21nii eqriv $.
      $( [12-Jul-2005] $) $( [6-Jul-2005] $)
  $}

  ${
    $d x y A $.  $d x y k N $.
    peano5uz.1 $e |- A e. _V $.
    ${
      peano5uz.2 $e |- N e. ZZ $.
      $( Peano's inductive postulate for upper integers. $)
      peano5uzi $p |- ( ( N e. A /\ A. x e. A ( x + 1 ) e. A ) ->
                    { k e. ZZ | N <_ k } C_ A ) $=
        cN cA wcel vx cv c1 caddc co cA wcel vx cA wral wa cN vy cv wcel vx cv
        c1 caddc co vy cv wcel vx vy cv wral wa vy cab cint cA cN vk cv cle wbr
        vk cz crab cN cA wcel vx cv c1 caddc co cA wcel vx cA wral wa cA cN vy
        cv wcel vx cv c1 caddc co vy cv wcel vx vy cv wral wa vy cab wcel cN vy
        cv wcel vx cv c1 caddc co vy cv wcel vx vy cv wral wa vy cab cint cA
        wss cN vy cv wcel vx cv c1 caddc co vy cv wcel vx vy cv wral wa cN cA
        wcel vx cv c1 caddc co cA wcel vx cA wral wa vy cA peano5uz.1 vy cv cA
        wceq cN vy cv wcel cN cA wcel vx cv c1 caddc co vy cv wcel vx vy cv
        wral vx cv c1 caddc co cA wcel vx cA wral vy cv cA cN eleq2 vx cv c1
        caddc co vy cv wcel vx cv c1 caddc co cA wcel vx vy cv cA vy cv cA vx
        cv c1 caddc co eleq2 raleqd anbi12d elab cA cN vy cv wcel vx cv c1
        caddc co vy cv wcel vx vy cv wral wa vy cab intss1 sylbir vy vx vk cN
        peano5uz.2 dfuzi syl5ss $.
        $( [14-Jul-2005] $) $( [6-Jul-2005] $)
    $}

    $( Peano's inductive postulate for upper integers. $)
    peano5uzti $p |- ( N e. ZZ -> ( ( N e. A /\ A. x e. A ( x + 1 ) e. A ) ->
                    { k e. ZZ | N <_ k } C_ A ) ) $=
      cN cz wcel cN cA wcel vx cv c1 caddc co cA wcel vx cA wral wa cN vk cv
      cle wbr vk cz crab cA wss wi cN cz wcel cN c1 cif cA wcel vx cv c1 caddc
      co cA wcel vx cA wral wa cN cz wcel cN c1 cif vk cv cle wbr vk cz crab cA
      wss wi cN c1 cN cN cz wcel cN c1 cif wceq cN cA wcel vx cv c1 caddc co cA
      wcel vx cA wral wa cN cz wcel cN c1 cif cA wcel vx cv c1 caddc co cA wcel
      vx cA wral wa cN vk cv cle wbr vk cz crab cA wss cN cz wcel cN c1 cif vk
      cv cle wbr vk cz crab cA wss cN cN cz wcel cN c1 cif wceq cN cA wcel cN
      cz wcel cN c1 cif cA wcel vx cv c1 caddc co cA wcel vx cA wral cN cN cz
      wcel cN c1 cif cA eleq1 anbi1d cN cN cz wcel cN c1 cif wceq cN vk cv cle
      wbr vk cz crab cN cz wcel cN c1 cif vk cv cle wbr vk cz crab cA cN cN cz
      wcel cN c1 cif wceq cN vk cv cle wbr cN cz wcel cN c1 cif vk cv cle wbr
      vk cz cN cN cz wcel cN c1 cif vk cv cle breq1 rabbisdv sseq1d imbi12d vx
      cA vk cN cz wcel cN c1 cif peano5uz.1 cN c1 cz 1z elimel peano5uzi dedth
      $.
      $( [18-Jul-2005] $) $( [6-Jul-2005] $)
  $}

  ${
    $d j z w N $.  $d j z ps $.  $d j z ch $.  $d j z th $.  $d j z ta $.
    $d k w ph $.  $d j k z w M $.
    $( Substitutions. $)
    uzind.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind.6 $e |- ( ( M e. ZZ /\ k e. ZZ /\ M <_ k ) -> ( ch -> th ) ) $.
    $( Induction on the upper integers that start at ` M ` .  The first four
       hypotheses give us the substitution instances we need; the last two are
       the basis and the induction hypothesis. $)
    uzind $p |- ( ( M e. ZZ /\ N e. ZZ /\ M <_ N ) -> ta ) $=
      cM cz wcel cN cz wcel cM cN cle wbr w3a cM cN cle wbr wta cM cz wcel cN
      cz wcel cM cN cle wbr w3a cN cz wcel cM cN cle wbr wta wa cM cz wcel cN
      cz wcel cM cN cle wbr cN cz wcel cM cN cle wbr wta wa wa cM cz wcel cN cM
      vw cv cle wbr vw cz crab wcel cN cM vj cv cle wbr wph wa vj cz crab wcel
      cN cz wcel cM cN cle wbr wa cN cz wcel cM cN cle wbr wta wa wa cM cz wcel
      cM vw cv cle wbr vw cz crab cM vj cv cle wbr wph wa vj cz crab cN cM cz
      wcel cM cM vj cv cle wbr wph wa vj cz crab wcel vk cv c1 caddc co cM vj
      cv cle wbr wph wa vj cz crab wcel vk cM vj cv cle wbr wph wa vj cz crab
      wral cM vw cv cle wbr vw cz crab cM vj cv cle wbr wph wa vj cz crab wss
      cM cz wcel cM cz wcel cM cM cle wbr wps wa wa cM cM vj cv cle wbr wph wa
      vj cz crab wcel cM cz wcel cM cM cle wbr wps wa cM cz wcel cM cM cle wbr
      wps cM cz wcel cM cr wcel cM cM cle wbr cM zre cM leid syl uzind.5 jca
      ancli cM vj cv cle wbr wph wa cM cM cle wbr wps wa vj cM cz vj cv cM wceq
      cM vj cv cle wbr cM cM cle wbr wph wps vj cv cM cM cle breq2 uzind.1
      anbi12d elrab sylibr cM cz wcel vk cv c1 caddc co cM vj cv cle wbr wph wa
      vj cz crab wcel vk cM vj cv cle wbr wph wa vj cz crab cM cz wcel vk cv cz
      wcel cM vk cv cle wbr wch wa wa vk cv c1 caddc co cz wcel cM vk cv c1
      caddc co cle wbr wth wa wa vk cv cM vj cv cle wbr wph wa vj cz crab wcel
      vk cv c1 caddc co cM vj cv cle wbr wph wa vj cz crab wcel cM cz wcel vk
      cv cz wcel cM vk cv cle wbr wch wa wa vk cv c1 caddc co cz wcel cM vk cv
      c1 caddc co cle wbr wth wa cM cz wcel vk cv cz wcel vk cv c1 caddc co cz
      wcel cM vk cv cle wbr wch wa vk cv cz wcel vk cv c1 caddc co cz wcel wi
      cM cz wcel vk cv peano2z a1i adantrd cM cz wcel vk cv cz wcel cM vk cv
      cle wbr wch wa wa cM vk cv c1 caddc co cle wbr wth cM cz wcel vk cv cz
      wcel cM vk cv cle wbr wch cM vk cv c1 caddc co cle wbr cM cz wcel vk cv
      cz wcel cM vk cv cle wbr wch cM vk cv c1 caddc co cle wbr cM cz wcel vk
      cv cz wcel wa cM vk cv cle wbr cM vk cv c1 caddc co cle wbr wch cM cr
      wcel vk cv cr wcel cM vk cv cle wbr cM vk cv c1 caddc co cle wbr wi cM cz
      wcel vk cv cz wcel cM cr wcel vk cv cr wcel wa cM vk cv cle wbr cM vk cv
      c1 caddc co clt wbr cM vk cv c1 caddc co cle wbr cM cr wcel vk cv cr wcel
      wa cM vk cv cle wbr vk cv vk cv c1 caddc co clt wbr cM vk cv c1 caddc co
      clt wbr vk cv cr wcel vk cv vk cv c1 caddc co clt wbr cM cr wcel vk cv
      ltp1 adantl cM cr wcel vk cv cr wcel vk cv c1 caddc co cr wcel wa cM vk
      cv cle wbr vk cv vk cv c1 caddc co clt wbr wa cM vk cv c1 caddc co clt
      wbr wi vk cv cr wcel cM cr wcel vk cv cr wcel vk cv c1 caddc co cr wcel
      cM vk cv cle wbr vk cv vk cv c1 caddc co clt wbr wa cM vk cv c1 caddc co
      clt wbr wi cM vk cv vk cv c1 caddc co lelttr 3expb vk cv cr wcel vk cv c1
      caddc co cr wcel vk cv peano2re ancli sylan2 mpan2d cM cr wcel vk cv c1
      caddc co cr wcel cM vk cv c1 caddc co clt wbr cM vk cv c1 caddc co cle
      wbr wi vk cv cr wcel cM vk cv c1 caddc co ltle vk cv peano2re sylan2 syld
      cM zre vk cv zre syl2an adantrd exp4b imp4d cM cz wcel vk cv cz wcel cM
      vk cv cle wbr wch wth cM cz wcel vk cv cz wcel cM vk cv cle wbr wch wth
      wi uzind.6 3exp imp4d jcad jcad cM vj cv cle wbr wph wa cM vk cv cle wbr
      wch wa vj vk cv cz vj cv vk cv wceq cM vj cv cle wbr cM vk cv cle wbr wph
      wch vj cv vk cv cM cle breq2 uzind.2 anbi12d elrab cM vj cv cle wbr wph
      wa cM vk cv c1 caddc co cle wbr wth wa vj vk cv c1 caddc co cz vj cv vk
      cv c1 caddc co wceq cM vj cv cle wbr cM vk cv c1 caddc co cle wbr wph wth
      vj cv vk cv c1 caddc co cM cle breq2 uzind.3 anbi12d elrab 3imtr4g
      r19.21aiv vk cM vj cv cle wbr wph wa vj cz crab vw cM cM vj cv cle wbr
      wph wa vj cz zex rabex peano5uzti mp2and sseld cM vw cv cle wbr cM cN cle
      wbr vw cN cz vw cv cN cM cle breq2 elrab cM vj cv cle wbr wph wa cM cN
      cle wbr wta wa vj cN cz vj cv cN wceq cM vj cv cle wbr cM cN cle wbr wph
      wta vj cv cN cM cle breq2 uzind.4 anbi12d elrab 3imtr3g 3impib pm3.27d
      pm3.27d $.
      $( [27-Jul-2005] $) $( [5-Jul-2005] $)
  $}

  ${
    $d j z w N $.  $d j z ps $.  $d j z ch $.  $d j z th $.  $d j z ta $.
    $d k w ph $.  $d j k z w M $.
    $( Substitutions. $)
    uzind2.1 $e |- ( j = ( M + 1 ) -> ( ph <-> ps ) ) $.
    uzind2.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind2.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind2.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind2.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind2.6 $e |- ( ( M e. ZZ /\ k e. ZZ /\ M < k ) -> ( ch -> th ) ) $.
    $( Induction on the upper integers that start _after_ an integer ` M ` .
       The first four hypotheses give us the substitution instances we need;
       the last two are the basis and the induction hypothesis. $)
    uzind2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ M < N ) -> ta ) $=
      cM cz wcel cN cz wcel cM cN clt wbr wta cM cz wcel cN cz wcel wa cM cN
      clt wbr cM c1 caddc co cN cle wbr wta cM cN zltp1le cM cz wcel cN cz wcel
      cM c1 caddc co cN cle wbr wta wi cN cz wcel cM cz wcel cM c1 caddc co cN
      cle wbr wta wi cM cz wcel cN cz wcel cM c1 caddc co cN cle wbr cM cz wcel
      wta cM cz wcel cM c1 caddc co cz wcel cN cz wcel cM c1 caddc co cN cle
      wbr cM cz wcel wta wi wi wi cM peano2z cM c1 caddc co cz wcel cN cz wcel
      cM c1 caddc co cN cle wbr cM cz wcel wta wi cM cz wcel wph wi cM cz wcel
      wps wi cM cz wcel wch wi cM cz wcel wth wi cM cz wcel wta wi vj vk cM c1
      caddc co cN vj cv cM c1 caddc co wceq wph wps cM cz wcel uzind2.1 imbi2d
      vj cv vk cv wceq wph wch cM cz wcel uzind2.2 imbi2d vj cv vk cv c1 caddc
      co wceq wph wth cM cz wcel uzind2.3 imbi2d vj cv cN wceq wph wta cM cz
      wcel uzind2.4 imbi2d cM cz wcel wps wi cM c1 caddc co cz wcel uzind2.5
      a1i cM c1 caddc co cz wcel vk cv cz wcel cM c1 caddc co vk cv cle wbr w3a
      cM cz wcel wch wth vk cv cz wcel cM c1 caddc co vk cv cle wbr cM cz wcel
      wch wth wi wi cM c1 caddc co cz wcel vk cv cz wcel cM c1 caddc co vk cv
      cle wbr cM cz wcel wch wth wi wi cM cz wcel vk cv cz wcel cM c1 caddc co
      vk cv cle wbr wch wth wi cM cz wcel vk cv cz wcel cM c1 caddc co vk cv
      cle wbr wch wth wi wi cM cz wcel vk cv cz wcel wa cM c1 caddc co vk cv
      cle wbr cM vk cv clt wbr wch wth wi cM vk cv zltp1le cM cz wcel vk cv cz
      wcel cM vk cv clt wbr wch wth wi uzind2.6 3expia sylbird ex com3l imp
      3adant1 a2d uzind 3exp syl com34 pm2.43a imp sylbid 3impia $.
      $( [28-Jul-2005] $) $( [25-Jul-2005] $)
  $}

  ${
    $d j k N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.
    $d m ph $.  $d j m k M $.
    $( Substitutions. $)
    uzind3.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind3.2 $e |- ( j = m -> ( ph <-> ch ) ) $.
    uzind3.3 $e |- ( j = ( m + 1 ) -> ( ph <-> th ) ) $.
    uzind3.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind3.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind3.6 $e |- ( ( M e. ZZ /\ m e. { k e. ZZ | M <_ k } ) ->
                   ( ch -> th ) ) $.
    $( Induction on the upper integers that start at an integer ` M ` .  The
       first four hypotheses give us the substitution instances we need, and
       the last two are the basis and the induction hypothesis. $)
    uzind3 $p |- ( ( M e. ZZ /\ N e. { k e. ZZ | M <_ k } ) -> ta ) $=
      cM cz wcel cN cz wcel cM cN cle wbr wa wta cN cM vk cv cle wbr vk cz crab
      wcel cM cz wcel cN cz wcel cM cN cle wbr wta wph wps wch wth wta vj vm cM
      cN uzind3.1 uzind3.2 uzind3.3 uzind3.4 uzind3.5 cM cz wcel vm cv cz wcel
      cM vm cv cle wbr wch wth wi cM cz wcel vm cv cM vk cv cle wbr vk cz crab
      wcel wch wth wi vm cv cz wcel cM vm cv cle wbr wa uzind3.6 cM vk cv cle
      wbr cM vm cv cle wbr vk vm cv cz vk cv vm cv cM cle breq2 elrab sylan2br
      3impb uzind 3expb cM vk cv cle wbr cM cN cle wbr vk cN cz vk cv cN cM cle
      breq2 elrab sylan2b $.
      $( [4-Aug-2005] $) $( [26-Jul-2005] $)
  $}

  ${
    $d x z w A $.  $d x z ps $.  $d x z ch $.  $d x z th $.  $d x z ta $.
    $d y w ph $.  $d x y z w B $.
    $( Substitutions. $)
    uzindOLD.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    uzindOLD.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    uzindOLD.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    uzindOLD.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzindOLD.5 $e |- ps $.
    $( Induction hypothesis. $)
    uzindOLD.6 $e |- ( ( ( y e. ZZ /\ B e. ZZ ) /\ B <_ y ) ->
                     ( ch -> th ) ) $.
    $( Induction on the upper integers that start at an integer
       ` B ` .  The first four hypotheses give us the substitution instances we
       need; the last two are the basis and the induction hypothesis.

       _Warning:  The HTML proof page is 3/4 megabyte in size.  An attempt
      to shorten it is on my to-do list_. $)
    uzindOLD $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ B <_ A ) -> ta ) $=
      cA cz wcel cB cz wcel wa cB cA cle wbr wta cA cz wcel cB cz wcel wa cB cA
      cle wbr c1 cA cB cmin co c1 caddc co cle wbr wta cA cr wcel cB cr wcel cB
      cA cle wbr c1 cA cB cmin co c1 caddc co cle wbr wb cA cz wcel cB cz wcel
      cA cr wcel cB cr wcel wa cc0 cA cB cmin co cle wbr cB cA cle wbr c1 cA cB
      cmin co c1 caddc co cle wbr cA cB subge0 cA cr wcel cB cr wcel wa cc0 cA
      cB cmin co cle wbr cc0 c1 caddc co cA cB cmin co c1 caddc co cle wbr c1
      cA cB cmin co c1 caddc co cle wbr cA cr wcel cB cr wcel wa cA cB cmin co
      cr wcel cc0 cA cB cmin co cle wbr cc0 c1 caddc co cA cB cmin co c1 caddc
      co cle wbr wb cA cB resubcl cc0 cr wcel cA cB cmin co cr wcel c1 cr wcel
      cc0 cA cB cmin co cle wbr cc0 c1 caddc co cA cB cmin co c1 caddc co cle
      wbr wb 0re 1re cc0 cA cB cmin co c1 leadd1 mp3an13 syl cc0 c1 caddc co c1
      cA cB cmin co c1 caddc co cle c1 ax1cn addid2i breq1i syl6bb bitr3d cA
      zre cB zre syl2an cA cB cmin co c1 caddc co cz wcel cA cz wcel cB cz wcel
      wa c1 cA cB cmin co c1 caddc co cle wbr wta wi cA cz wcel cB cz wcel wa
      cA cB cmin co cA cB zsubcl peano2zdi cA cB cmin co c1 caddc co cz wcel c1
      cA cB cmin co c1 caddc co cle wbr cA cz wcel cB cz wcel wa wta c1 cA cB
      cmin co c1 caddc co cle wbr cA cB cmin co c1 caddc co cz wcel cA cz wcel
      cB cz wcel wa wta wi cA cB cmin co c1 caddc co cz wcel c1 cA cB cmin co
      c1 caddc co cle wbr cA cB cmin co c1 caddc co cz wcel cA cz wcel cB cz
      wcel wa wta wi wi cA cB cmin co c1 caddc co cz wcel c1 cA cB cmin co c1
      caddc co cle wbr wa cA cB cmin co c1 caddc co cn wcel cA cB cmin co c1
      caddc co cz wcel cA cz wcel cB cz wcel wa wta wi wi cA cB cmin co c1
      caddc co elnnz1 vz cv cz wcel cA cz wcel cB cz wcel wa wph vx vz cv c1
      cmin co cB caddc co wsbc wi wi c1 cz wcel cA cz wcel cB cz wcel wa wps wi
      wi vw cv cz wcel cA cz wcel cB cz wcel wa wch vy vw cv c1 cmin co cB
      caddc co wsbc wi wi vw cv c1 caddc co cz wcel cA cz wcel cB cz wcel wa
      wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc wi wi cA
      cB cmin co c1 caddc co cz wcel cA cz wcel cB cz wcel wa wta wi wi vz vw
      cA cB cmin co c1 caddc co vz cv c1 wceq vz cv cz wcel c1 cz wcel cA cz
      wcel cB cz wcel wa wph vx vz cv c1 cmin co cB caddc co wsbc wi cA cz wcel
      cB cz wcel wa wps wi vz cv c1 cz eleq1 vz cv c1 wceq cA cz wcel cB cz
      wcel wa wph vx vz cv c1 cmin co cB caddc co wsbc wps vz cv c1 wceq cB cz
      wcel wph vx vz cv c1 cmin co cB caddc co wsbc wps wb cA cz wcel vz cv c1
      wceq cB cz wcel wph vx vz cv c1 cmin co cB caddc co wsbc wps wb vx cv vz
      cv c1 cmin co cB caddc co wceq vx wex vz cv c1 wceq cB cz wcel wa wph vx
      vz cv c1 cmin co cB caddc co wsbc wps wb wi vx vz cv c1 cmin co cB caddc
      co vz cv c1 cmin co cB caddc oprex isseti vx cv vz cv c1 cmin co cB caddc
      co wceq vz cv c1 wceq cB cz wcel wa wph vx vz cv c1 cmin co cB caddc co
      wsbc wps wb wi vx vz cv c1 wceq cB cz wcel wa wph vx vz cv c1 cmin co cB
      caddc co wsbc wps wb vx vz cv c1 wceq cB cz wcel wa vx ax-17 wph vx vz cv
      c1 cmin co cB caddc co wsbc wps vx wph vx vz cv c1 cmin co cB caddc co vz
      cv c1 cmin co cB caddc oprex hbsbc1v wps vx ax-17 hbbi hbim vx cv vz cv
      c1 cmin co cB caddc co wceq vz cv c1 wceq cB cz wcel wa wph vx vz cv c1
      cmin co cB caddc co wsbc wps wb vx cv vz cv c1 cmin co cB caddc co wceq
      vz cv c1 wceq cB cz wcel wa wa wph wph vx vz cv c1 cmin co cB caddc co
      wsbc wps vx cv vz cv c1 cmin co cB caddc co wceq wph wph vx vz cv c1 cmin
      co cB caddc co wsbc wb vz cv c1 wceq cB cz wcel wa wph vx vz cv c1 cmin
      co cB caddc co sbceq1a adantr vx cv vz cv c1 cmin co cB caddc co wceq vz
      cv c1 wceq cB cz wcel wa wa vx cv cB wceq wph wps wb vx cv vz cv c1 cmin
      co cB caddc co wceq vz cv c1 cmin co cB caddc co cB wceq vx cv cB wceq vz
      cv c1 wceq cB cz wcel wa vx cv vz cv c1 cmin co cB caddc co cB eqtr vz cv
      c1 wceq cB cz wcel vz cv c1 cmin co cB caddc co c1 c1 cmin co cB caddc co
      cB vz cv c1 wceq vz cv c1 cmin co c1 c1 cmin co cB caddc vz cv c1 c1 cmin
      opreq1 opreq1d cB cz wcel cc0 cB caddc co cB c1 c1 cmin co cB caddc co cB
      cz wcel cB cc wcel cc0 cB caddc co cB wceq cB zcn cB addid2 syl c1 c1
      cmin co cc0 cB caddc c1 ax1cn subidi opreq1i syl5eq sylan9eq sylan2
      uzindOLD.1 syl bitr3d ex 19.23ai ax-mp ex adantld pm5.74d imbi12d vz cv
      vw cv wceq vz cv cz wcel vw cv cz wcel cA cz wcel cB cz wcel wa wph vx vz
      cv c1 cmin co cB caddc co wsbc wi cA cz wcel cB cz wcel wa wch vy vw cv
      c1 cmin co cB caddc co wsbc wi vz cv vw cv cz eleq1 vz cv vw cv wceq wph
      vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co cB caddc co
      wsbc cA cz wcel cB cz wcel wa vx cv vz cv c1 cmin co cB caddc co wceq vx
      wex vy cv vw cv c1 cmin co cB caddc co wceq vy wex vz cv vw cv wceq wph
      vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co cB caddc co
      wsbc wb wi vx vz cv c1 cmin co cB caddc co vz cv c1 cmin co cB caddc
      oprex isseti vy vw cv c1 cmin co cB caddc co vw cv c1 cmin co cB caddc
      oprex isseti vx cv vz cv c1 cmin co cB caddc co wceq vx wex vy cv vw cv
      c1 cmin co cB caddc co wceq vy wex wa vx cv vz cv c1 cmin co cB caddc co
      wceq vy cv vw cv c1 cmin co cB caddc co wceq wa vy wex vx wex vz cv vw cv
      wceq wph vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co cB
      caddc co wsbc wb wi vx cv vz cv c1 cmin co cB caddc co wceq vy cv vw cv
      c1 cmin co cB caddc co wceq vx vy eeanv vx cv vz cv c1 cmin co cB caddc
      co wceq vy cv vw cv c1 cmin co cB caddc co wceq wa vy wex vz cv vw cv
      wceq wph vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co cB
      caddc co wsbc wb wi vx vz cv vw cv wceq wph vx vz cv c1 cmin co cB caddc
      co wsbc wch vy vw cv c1 cmin co cB caddc co wsbc wb vx vz cv vw cv wceq
      vx ax-17 wph vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co
      cB caddc co wsbc vx wph vx vz cv c1 cmin co cB caddc co vz cv c1 cmin co
      cB caddc oprex hbsbc1v wch vy vw cv c1 cmin co cB caddc co wsbc vx ax-17
      hbbi hbim vx cv vz cv c1 cmin co cB caddc co wceq vy cv vw cv c1 cmin co
      cB caddc co wceq wa vz cv vw cv wceq wph vx vz cv c1 cmin co cB caddc co
      wsbc wch vy vw cv c1 cmin co cB caddc co wsbc wb wi vy vz cv vw cv wceq
      wph vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co cB caddc
      co wsbc wb vy vz cv vw cv wceq vy ax-17 wph vx vz cv c1 cmin co cB caddc
      co wsbc wch vy vw cv c1 cmin co cB caddc co wsbc vy wph vx vz cv c1 cmin
      co cB caddc co wsbc vy ax-17 wch vy vw cv c1 cmin co cB caddc co vw cv c1
      cmin co cB caddc oprex hbsbc1v hbbi hbim vx cv vz cv c1 cmin co cB caddc
      co wceq vy cv vw cv c1 cmin co cB caddc co wceq wa vz cv vw cv wceq wph
      wch wb wph vx vz cv c1 cmin co cB caddc co wsbc wch vy vw cv c1 cmin co
      cB caddc co wsbc wb vx cv vz cv c1 cmin co cB caddc co wceq vy cv vw cv
      c1 cmin co cB caddc co wceq wa vz cv vw cv wceq vx cv vy cv wceq wph wch
      wb vx cv vz cv c1 cmin co cB caddc co wceq vy cv vw cv c1 cmin co cB
      caddc co wceq wa vx cv vy cv wceq vz cv c1 cmin co cB caddc co vw cv c1
      cmin co cB caddc co wceq vz cv vw cv wceq vx cv vz cv c1 cmin co cB caddc
      co vy cv vw cv c1 cmin co cB caddc co eqeq12 vz cv vw cv wceq vz cv c1
      cmin co vw cv c1 cmin co cB caddc vz cv vw cv c1 cmin opreq1 opreq1d
      syl5bir uzindOLD.2 syl6 vx cv vz cv c1 cmin co cB caddc co wceq wph wph
      vx vz cv c1 cmin co cB caddc co wsbc vy cv vw cv c1 cmin co cB caddc co
      wceq wch wch vy vw cv c1 cmin co cB caddc co wsbc wph vx vz cv c1 cmin co
      cB caddc co sbceq1a wch vy vw cv c1 cmin co cB caddc co sbceq1a bi2bian9
      sylibd 19.23ai 19.23ai sylbir mp2an imbi2d imbi12d vz cv vw cv c1 caddc
      co wceq vz cv cz wcel cA cz wcel cB cz wcel wa wph vx vz cv c1 cmin co cB
      caddc co c1 cmin co c1 caddc co wsbc wi wi vw cv c1 caddc co cz wcel cA
      cz wcel cB cz wcel wa wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1
      cmin co wsbc wi wi vz cv cz wcel cA cz wcel cB cz wcel wa wph vx vz cv c1
      cmin co cB caddc co wsbc wi wi vz cv vw cv c1 caddc co wceq vz cv cz wcel
      vw cv c1 caddc co cz wcel cA cz wcel cB cz wcel wa wph vx vz cv c1 cmin
      co cB caddc co c1 cmin co c1 caddc co wsbc wi cA cz wcel cB cz wcel wa
      wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc wi vz cv
      vw cv c1 caddc co cz eleq1 vz cv vw cv c1 caddc co wceq wph vx vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co wsbc wth vy vw cv c1 caddc co
      c1 cmin co cB caddc co c1 cmin co wsbc cA cz wcel cB cz wcel wa vx cv vz
      cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wceq vx wex vy cv vw cv
      c1 caddc co c1 cmin co cB caddc co c1 cmin co wceq vy wex vz cv vw cv c1
      caddc co wceq wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co
      wsbc wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc wb
      wi vx vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co vz cv c1 cmin
      co cB caddc co c1 cmin co c1 caddc oprex isseti vy vw cv c1 caddc co c1
      cmin co cB caddc co c1 cmin co vw cv c1 caddc co c1 cmin co cB caddc co
      c1 cmin oprex isseti vx cv vz cv c1 cmin co cB caddc co c1 cmin co c1
      caddc co wceq vx wex vy cv vw cv c1 caddc co c1 cmin co cB caddc co c1
      cmin co wceq vy wex wa vx cv vz cv c1 cmin co cB caddc co c1 cmin co c1
      caddc co wceq vy cv vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co
      wceq wa vy wex vx wex vz cv vw cv c1 caddc co wceq wph vx vz cv c1 cmin
      co cB caddc co c1 cmin co c1 caddc co wsbc wth vy vw cv c1 caddc co c1
      cmin co cB caddc co c1 cmin co wsbc wb wi vx cv vz cv c1 cmin co cB caddc
      co c1 cmin co c1 caddc co wceq vy cv vw cv c1 caddc co c1 cmin co cB
      caddc co c1 cmin co wceq vx vy eeanv vx cv vz cv c1 cmin co cB caddc co
      c1 cmin co c1 caddc co wceq vy cv vw cv c1 caddc co c1 cmin co cB caddc
      co c1 cmin co wceq wa vy wex vz cv vw cv c1 caddc co wceq wph vx vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co wsbc wth vy vw cv c1 caddc co
      c1 cmin co cB caddc co c1 cmin co wsbc wb wi vx vz cv vw cv c1 caddc co
      wceq wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wsbc wth
      vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc wb vx vz cv
      vw cv c1 caddc co wceq vx ax-17 wph vx vz cv c1 cmin co cB caddc co c1
      cmin co c1 caddc co wsbc wth vy vw cv c1 caddc co c1 cmin co cB caddc co
      c1 cmin co wsbc vx wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1
      caddc co vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc oprex hbsbc1v
      wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc vx ax-17
      hbbi hbim vx cv vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wceq
      vy cv vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wceq wa vz cv
      vw cv c1 caddc co wceq wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1
      caddc co wsbc wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co
      wsbc wb wi vy vz cv vw cv c1 caddc co wceq wph vx vz cv c1 cmin co cB
      caddc co c1 cmin co c1 caddc co wsbc wth vy vw cv c1 caddc co c1 cmin co
      cB caddc co c1 cmin co wsbc wb vy vz cv vw cv c1 caddc co wceq vy ax-17
      wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wsbc wth vy vw
      cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc vy wph vx vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co wsbc vy ax-17 wth vy vw cv c1
      caddc co c1 cmin co cB caddc co c1 cmin co vw cv c1 caddc co c1 cmin co
      cB caddc co c1 cmin oprex hbsbc1v hbbi hbim vx cv vz cv c1 cmin co cB
      caddc co c1 cmin co c1 caddc co wceq vy cv vw cv c1 caddc co c1 cmin co
      cB caddc co c1 cmin co wceq wa vz cv vw cv c1 caddc co wceq wph wth wb
      wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wsbc wth vy vw
      cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc wb vx cv vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co wceq vy cv vw cv c1 caddc co
      c1 cmin co cB caddc co c1 cmin co wceq wa vz cv vw cv c1 caddc co wceq vx
      cv vy cv c1 caddc co wceq wph wth wb vx cv vz cv c1 cmin co cB caddc co
      c1 cmin co c1 caddc co wceq vy cv vw cv c1 caddc co c1 cmin co cB caddc
      co c1 cmin co wceq wa vx cv vy cv c1 caddc co wceq vz cv c1 cmin co cB
      caddc co c1 cmin co c1 caddc co vw cv c1 caddc co c1 cmin co cB caddc co
      c1 cmin co c1 caddc co wceq vz cv vw cv c1 caddc co wceq vx cv vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co wceq vy cv c1 caddc co vw cv
      c1 caddc co c1 cmin co cB caddc co c1 cmin co c1 caddc co wceq vx cv vy
      cv c1 caddc co wceq vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co
      vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co c1 caddc co wceq wb
      vy cv vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wceq vx cv vz
      cv c1 cmin co cB caddc co c1 cmin co c1 caddc co vy cv c1 caddc co vw cv
      c1 caddc co c1 cmin co cB caddc co c1 cmin co c1 caddc co eqeq12 vy cv vw
      cv c1 caddc co c1 cmin co cB caddc co c1 cmin co c1 caddc opreq1 sylan2
      vz cv vw cv c1 caddc co wceq vz cv c1 cmin co cB caddc co c1 cmin co vw
      cv c1 caddc co c1 cmin co cB caddc co c1 cmin co c1 caddc vz cv vw cv c1
      caddc co wceq vz cv c1 cmin co cB caddc co vw cv c1 caddc co c1 cmin co
      cB caddc co c1 cmin vz cv vw cv c1 caddc co wceq vz cv c1 cmin co vw cv
      c1 caddc co c1 cmin co cB caddc vz cv vw cv c1 caddc co c1 cmin opreq1
      opreq1d opreq1d opreq1d syl5bir uzindOLD.3 syl6 vx cv vz cv c1 cmin co cB
      caddc co c1 cmin co c1 caddc co wceq wph wph vx vz cv c1 cmin co cB caddc
      co c1 cmin co c1 caddc co wsbc vy cv vw cv c1 caddc co c1 cmin co cB
      caddc co c1 cmin co wceq wth wth vy vw cv c1 caddc co c1 cmin co cB caddc
      co c1 cmin co wsbc wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1
      caddc co sbceq1a wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin
      co sbceq1a bi2bian9 sylibd 19.23ai 19.23ai sylbir mp2an imbi2d imbi12d vz
      cv cz wcel cA cz wcel cB cz wcel wa wph vx vz cv c1 cmin co cB caddc co
      c1 cmin co c1 caddc co wsbc wi cA cz wcel cB cz wcel wa wph vx vz cv c1
      cmin co cB caddc co wsbc wi vz cv cz wcel cA cz wcel cB cz wcel wa wph vx
      vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wsbc wph vx vz cv c1
      cmin co cB caddc co wsbc vz cv cz wcel cA cz wcel cB cz wcel wa vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co vz cv c1 cmin co cB caddc co
      wceq wph vx vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co wsbc wph
      vx vz cv c1 cmin co cB caddc co wsbc wb vz cv cz wcel cB cz wcel vz cv c1
      cmin co cB caddc co c1 cmin co c1 caddc co vz cv c1 cmin co cB caddc co
      wceq cA cz wcel vz cv cz wcel cB cz wcel vz cv c1 cmin co cB caddc co c1
      cmin co c1 caddc co vz cv c1 cmin co cB caddc co wceq vz cv cc wcel cB cc
      wcel vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co vz cv c1 cmin co
      cB caddc co wceq vz cv cz wcel cB cz wcel vz cv c1 cmin co cB caddc co cc
      wcel c1 cc wcel vz cv c1 cmin co cB caddc co c1 cmin co c1 caddc co vz cv
      c1 cmin co cB caddc co wceq vz cv cc wcel cB cc wcel wa vz cv c1 cmin co
      cB caddc co c1 npcan vz cv c1 cmin co cc wcel cB cc wcel vz cv c1 cmin co
      cB caddc co cc wcel vz cv cc wcel vz cv c1 cmin co cB addcl vz cv cc wcel
      c1 cc wcel vz cv c1 cmin co cc wcel ax1cn vz cv c1 subcl mpan2 sylan
      ax1cn sylancl vz cv zcn cB zcn syl2an ex adantld wph vx vz cv c1 cmin co
      cB caddc co c1 cmin co c1 caddc co vz cv c1 cmin co cB caddc co dfsbcq
      syl6 pm5.74d pm5.74i syl5bbr vz cv cA cB cmin co c1 caddc co wceq vz cv
      cz wcel cA cB cmin co c1 caddc co cz wcel cA cz wcel cB cz wcel wa wph vx
      vz cv c1 cmin co cB caddc co wsbc wi cA cz wcel cB cz wcel wa wta wi vz
      cv cA cB cmin co c1 caddc co cz eleq1 vz cv cA cB cmin co c1 caddc co
      wceq cA cz wcel cB cz wcel wa wph vx vz cv c1 cmin co cB caddc co wsbc
      wta vx cv vz cv c1 cmin co cB caddc co wceq vx wex vz cv cA cB cmin co c1
      caddc co wceq cA cz wcel cB cz wcel wa wa wph vx vz cv c1 cmin co cB
      caddc co wsbc wta wb wi vx vz cv c1 cmin co cB caddc co vz cv c1 cmin co
      cB caddc oprex isseti vx cv vz cv c1 cmin co cB caddc co wceq vz cv cA cB
      cmin co c1 caddc co wceq cA cz wcel cB cz wcel wa wa wph vx vz cv c1 cmin
      co cB caddc co wsbc wta wb wi vx vz cv cA cB cmin co c1 caddc co wceq cA
      cz wcel cB cz wcel wa wa wph vx vz cv c1 cmin co cB caddc co wsbc wta wb
      vx vz cv cA cB cmin co c1 caddc co wceq cA cz wcel cB cz wcel wa wa vx
      ax-17 wph vx vz cv c1 cmin co cB caddc co wsbc wta vx wph vx vz cv c1
      cmin co cB caddc co vz cv c1 cmin co cB caddc oprex hbsbc1v wta vx ax-17
      hbbi hbim vx cv vz cv c1 cmin co cB caddc co wceq vz cv cA cB cmin co c1
      caddc co wceq cA cz wcel cB cz wcel wa wa wph vx vz cv c1 cmin co cB
      caddc co wsbc wta wb vx cv vz cv c1 cmin co cB caddc co wceq vz cv cA cB
      cmin co c1 caddc co wceq cA cz wcel cB cz wcel wa wa wa wph wph vx vz cv
      c1 cmin co cB caddc co wsbc wta vx cv vz cv c1 cmin co cB caddc co wceq
      wph wph vx vz cv c1 cmin co cB caddc co wsbc wb vz cv cA cB cmin co c1
      caddc co wceq cA cz wcel cB cz wcel wa wa wph vx vz cv c1 cmin co cB
      caddc co sbceq1a adantr vx cv vz cv c1 cmin co cB caddc co wceq vz cv cA
      cB cmin co c1 caddc co wceq cA cz wcel cB cz wcel wa wa wa vx cv cA wceq
      wph wta wb vx cv vz cv c1 cmin co cB caddc co wceq vz cv cA cB cmin co c1
      caddc co wceq cA cz wcel cB cz wcel wa vx cv cA wceq vx cv vz cv c1 cmin
      co cB caddc co wceq vz cv cA cB cmin co c1 caddc co wceq wa cA cz wcel cB
      cz wcel wa vx cv cA cB cmin co c1 caddc co c1 cmin co cB caddc co cA vx
      cv vz cv c1 cmin co cB caddc co wceq vz cv c1 cmin co cB caddc co cA cB
      cmin co c1 caddc co c1 cmin co cB caddc co wceq vx cv cA cB cmin co c1
      caddc co c1 cmin co cB caddc co wceq vz cv cA cB cmin co c1 caddc co wceq
      vx cv vz cv c1 cmin co cB caddc co cA cB cmin co c1 caddc co c1 cmin co
      cB caddc co eqtr vz cv cA cB cmin co c1 caddc co wceq vz cv c1 cmin co cA
      cB cmin co c1 caddc co c1 cmin co cB caddc vz cv cA cB cmin co c1 caddc
      co c1 cmin opreq1 opreq1d sylan2 cA cc wcel cB cc wcel cA cB cmin co c1
      caddc co c1 cmin co cB caddc co cA wceq cA cz wcel cB cz wcel cA cc wcel
      cB cc wcel wa cA cB cmin co c1 caddc co cB caddc co c1 cmin co cA c1
      caddc co c1 cmin co cA cB cmin co c1 caddc co c1 cmin co cB caddc co cA
      cA cc wcel cB cc wcel wa cA cB cmin co c1 caddc co cB caddc co cA c1
      caddc co c1 cmin cA cc wcel cB cc wcel wa cA cB cmin co c1 caddc co cB
      caddc co cA cB cmin co cB caddc co c1 caddc co cA c1 caddc co cA cB cmin
      co cc wcel c1 cc wcel cB cc wcel cA cB cmin co c1 caddc co cB caddc co cA
      cB cmin co cB caddc co c1 caddc co wceq cA cc wcel cB cc wcel wa cA cB
      cmin co c1 cB add23 cA cB subcl c1 cc wcel cA cc wcel cB cc wcel wa ax1cn
      a1i cA cc wcel cB cc wcel pm3.27 syl3anc cA cc wcel cB cc wcel wa cA cB
      cmin co cB caddc co cA c1 caddc cA cB npcan opreq1d eqtrd opreq1d cA cB
      cmin co c1 caddc co cc wcel cB cc wcel c1 cc wcel cA cB cmin co c1 caddc
      co cB caddc co c1 cmin co cA cB cmin co c1 caddc co c1 cmin co cB caddc
      co wceq cA cc wcel cB cc wcel wa cA cB cmin co c1 caddc co cB c1 addsub
      cA cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cB cmin co c1 caddc co
      cc wcel cA cB subcl cA cB cmin co peano2cn syl cA cc wcel cB cc wcel
      pm3.27 c1 cc wcel cA cc wcel cB cc wcel wa ax1cn a1i syl3anc cA cc wcel
      cA c1 caddc co c1 cmin co cA wceq cB cc wcel cA cc wcel c1 cc wcel cA c1
      caddc co c1 cmin co cA wceq ax1cn cA c1 pncan mpan2 adantr 3eqtr3d cA zcn
      cB zcn syl2an sylan9eq anasss uzindOLD.4 syl bitr3d ex 19.23ai ax-mp
      pm5.74da imbi12d c1 cz wcel cA cz wcel cB cz wcel wa wps uzindOLD.5 a1i12
      vw cv cn wcel vw cv c1 caddc co cz wcel vw cv cz wcel cA cz wcel cB cz
      wcel wa wch vy vw cv c1 cmin co cB caddc co wsbc wi cA cz wcel cB cz wcel
      wa wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc wi vw
      cv cn wcel vw cv cz wcel vw cv c1 caddc co cz wcel vw cv nnz a1d vw cv cn
      wcel cA cz wcel cB cz wcel wa wch vy vw cv c1 cmin co cB caddc co wsbc
      wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co wsbc vw cv cn
      wcel cB cz wcel wch vy vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1
      caddc co c1 cmin co cB caddc co c1 cmin co wsbc wi cA cz wcel vw cv cn
      wcel cB cz wcel wch vy vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1
      caddc co c1 cmin co cB caddc co c1 cmin co wsbc wi vw cv cn wcel cB cz
      wcel wa wch vy vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1 cmin co
      cB caddc co wsbc wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin
      co wsbc vy cv vw cv c1 cmin co cB caddc co wceq vy wex vw cv cn wcel cB
      cz wcel wa wch vy vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1 cmin
      co cB caddc co wsbc wi wi vy vw cv c1 cmin co cB caddc co vw cv c1 cmin
      co cB caddc oprex isseti vy cv vw cv c1 cmin co cB caddc co wceq vw cv cn
      wcel cB cz wcel wa wch vy vw cv c1 cmin co cB caddc co wsbc wth vy vw cv
      c1 cmin co cB caddc co wsbc wi wi vy vw cv cn wcel cB cz wcel wa wch vy
      vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1 cmin co cB caddc co
      wsbc wi vy vw cv cn wcel cB cz wcel wa vy ax-17 wch vy vw cv c1 cmin co
      cB caddc co wsbc wth vy vw cv c1 cmin co cB caddc co wsbc vy wch vy vw cv
      c1 cmin co cB caddc co vw cv c1 cmin co cB caddc oprex hbsbc1v wth vy vw
      cv c1 cmin co cB caddc co vw cv c1 cmin co cB caddc oprex hbsbc1v hbim
      hbim vy cv vw cv c1 cmin co cB caddc co wceq vy cv cz wcel cB cz wcel wa
      cB vy cv cle wbr wa wch wth wi wi vw cv cn wcel cB cz wcel wa wch vy vw
      cv c1 cmin co cB caddc co wsbc wth vy vw cv c1 cmin co cB caddc co wsbc
      wi wi uzindOLD.6 vy cv vw cv c1 cmin co cB caddc co wceq vw cv cn wcel cB
      cz wcel wa vy cv cz wcel cB cz wcel wa cB vy cv cle wbr wa wch wth wi wch
      vy vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1 cmin co cB caddc co
      wsbc wi vy cv vw cv c1 cmin co cB caddc co wceq vy cv cz wcel cB cz wcel
      wa cB vy cv cle wbr wa vw cv c1 cmin co cB caddc co cz wcel cB cz wcel wa
      cB vw cv c1 cmin co cB caddc co cle wbr wa vw cv cn wcel cB cz wcel wa vy
      cv vw cv c1 cmin co cB caddc co wceq vy cv cz wcel cB cz wcel wa vw cv c1
      cmin co cB caddc co cz wcel cB cz wcel wa cB vy cv cle wbr cB vw cv c1
      cmin co cB caddc co cle wbr vy cv vw cv c1 cmin co cB caddc co wceq vy cv
      cz wcel vw cv c1 cmin co cB caddc co cz wcel cB cz wcel vy cv vw cv c1
      cmin co cB caddc co cz eleq1 anbi1d vy cv vw cv c1 cmin co cB caddc co cB
      cle breq2 anbi12d vw cv cn wcel cB cz wcel wa vw cv c1 cmin co cB caddc
      co cz wcel cB cz wcel cB vw cv c1 cmin co cB caddc co cle wbr vw cv cz
      wcel cB cz wcel vw cv c1 cmin co cB caddc co cz wcel vw cv cn wcel vw cv
      c1 cmin co cz wcel cB cz wcel vw cv c1 cmin co cB caddc co cz wcel vw cv
      cz wcel vw cv c1 cmin co cB zaddcl vw cv peano2zm sylan vw cv nnz sylan
      vw cv cn wcel cB cz wcel pm3.27 vw cv cz wcel c1 vw cv cle wbr wa cB cz
      wcel cB vw cv c1 cmin co cB caddc co cle wbr vw cv cn wcel vw cv cz wcel
      cB cz wcel c1 vw cv cle wbr cB vw cv c1 cmin co cB caddc co cle wbr vw cv
      cz wcel cB cz wcel wa cB vw cv c1 cmin co cB caddc co cle wbr c1 vw cv
      cle wbr vw cv cr wcel cB cr wcel cB vw cv c1 cmin co cB caddc co cle wbr
      c1 vw cv cle wbr wb vw cv cz wcel cB cz wcel vw cv cr wcel cB cr wcel wa
      cB vw cv c1 cmin co cB caddc co cle wbr cB cB c1 cmin co cmin co vw cv c1
      cmin co cB caddc co cB c1 cmin co cmin co cle wbr c1 vw cv cle wbr cB cr
      wcel vw cv c1 cmin co cB caddc co cr wcel cB c1 cmin co cr wcel cB vw cv
      c1 cmin co cB caddc co cle wbr cB cB c1 cmin co cmin co vw cv c1 cmin co
      cB caddc co cB c1 cmin co cmin co cle wbr wb vw cv cr wcel cB cr wcel wa
      cB vw cv c1 cmin co cB caddc co cB c1 cmin co lesub1 vw cv cr wcel cB cr
      wcel pm3.27 vw cv c1 cmin co cr wcel cB cr wcel vw cv c1 cmin co cB caddc
      co cr wcel vw cv cr wcel vw cv c1 cmin co cB readdcl vw cv peano2rem
      sylan cB cr wcel cB c1 cmin co cr wcel vw cv cr wcel cB peano2rem adantl
      syl3anc vw cv cc wcel cB cc wcel cB cB c1 cmin co cmin co vw cv c1 cmin
      co cB caddc co cB c1 cmin co cmin co cle wbr c1 vw cv cle wbr wb vw cv cr
      wcel cB cr wcel vw cv cc wcel cB cc wcel wa cB cB c1 cmin co cmin co c1
      vw cv c1 cmin co cB caddc co cB c1 cmin co cmin co vw cv cle cB cc wcel
      cB cB c1 cmin co cmin co c1 wceq vw cv cc wcel cB cc wcel cB cB c1 cmin
      co cmin co cB cB cmin co c1 caddc co c1 cB cc wcel cB cB c1 cmin co cmin
      co cB cB cmin co c1 caddc co wceq cB cc wcel cB cc wcel c1 cc wcel cB cB
      c1 cmin co cmin co cB cB cmin co c1 caddc co wceq ax1cn cB cB c1 subsub
      mp3an3 anidms cB cc wcel cB cB cmin co c1 caddc co cc0 c1 caddc co c1 cB
      cc wcel cB cB cmin co cc0 c1 caddc cB subid opreq1d c1 ax1cn addid2i
      syl6eq eqtrd adantl vw cv cc wcel cB cc wcel wa vw cv c1 cmin co cB caddc
      co cB c1 cmin co cmin co vw cv c1 cmin co cB caddc co cB cmin co c1 caddc
      co vw cv c1 cmin co c1 caddc co vw cv vw cv cc wcel cB cc wcel vw cv c1
      cmin co cB caddc co cc wcel vw cv c1 cmin co cB caddc co cB c1 cmin co
      cmin co vw cv c1 cmin co cB caddc co cB cmin co c1 caddc co wceq vw cv c1
      cmin co cc wcel cB cc wcel vw cv c1 cmin co cB caddc co cc wcel vw cv cc
      wcel vw cv c1 cmin co cB addcl vw cv cc wcel c1 cc wcel vw cv c1 cmin co
      cc wcel ax1cn vw cv c1 subcl mpan2 sylan vw cv c1 cmin co cB caddc co cc
      wcel cB cc wcel c1 cc wcel vw cv c1 cmin co cB caddc co cB c1 cmin co
      cmin co vw cv c1 cmin co cB caddc co cB cmin co c1 caddc co wceq ax1cn vw
      cv c1 cmin co cB caddc co cB c1 subsub mp3an3 sylancom vw cv cc wcel cB
      cc wcel wa vw cv c1 cmin co cB caddc co cB cmin co vw cv c1 cmin co c1
      caddc vw cv c1 cmin co cc wcel cB cc wcel vw cv c1 cmin co cB caddc co cB
      cmin co vw cv c1 cmin co wceq vw cv cc wcel vw cv c1 cmin co cB pncan vw
      cv cc wcel c1 cc wcel vw cv c1 cmin co cc wcel ax1cn vw cv c1 subcl mpan2
      sylan opreq1d vw cv cc wcel vw cv c1 cmin co c1 caddc co vw cv wceq cB cc
      wcel vw cv cc wcel c1 cc wcel vw cv c1 cmin co c1 caddc co vw cv wceq
      ax1cn vw cv c1 npcan mpan2 adantr 3eqtrd breq12d vw cv recn cB recn
      syl2an bitrd vw cv zre cB zre syl2an biimpar an1rs vw cv elnnz1 sylanb
      jca31 syl5bir vy cv vw cv c1 cmin co cB caddc co wceq wch wth wi wch vy
      vw cv c1 cmin co cB caddc co wsbc wth vy vw cv c1 cmin co cB caddc co
      wsbc wi vy cv vw cv c1 cmin co cB caddc co wceq wch wch vy vw cv c1 cmin
      co cB caddc co wsbc wth wth vy vw cv c1 cmin co cB caddc co wsbc wch vy
      vw cv c1 cmin co cB caddc co sbceq1a wth vy vw cv c1 cmin co cB caddc co
      sbceq1a imbi12d biimpd imim12d mpi 19.23ai ax-mp vw cv cn wcel cB cz wcel
      wa vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co vw cv c1 cmin co
      cB caddc co wceq wth vy vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin
      co wsbc wth vy vw cv c1 cmin co cB caddc co wsbc wb vw cv cc wcel cB cc
      wcel vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co vw cv c1 cmin co
      cB caddc co wceq vw cv cn wcel cB cz wcel vw cv cc wcel cB cc wcel wa vw
      cv c1 caddc co c1 cmin co cB caddc co c1 cmin co vw cv c1 caddc co c1
      cmin co c1 cmin co cB caddc co vw cv c1 cmin co cB caddc co vw cv c1
      caddc co c1 cmin co cc wcel cB cc wcel vw cv c1 caddc co c1 cmin co cB
      caddc co c1 cmin co vw cv c1 caddc co c1 cmin co c1 cmin co cB caddc co
      wceq vw cv cc wcel vw cv c1 caddc co c1 cmin co cc wcel cB cc wcel c1 cc
      wcel vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co vw cv c1 caddc
      co c1 cmin co c1 cmin co cB caddc co wceq ax1cn vw cv c1 caddc co c1 cmin
      co cB c1 addsub mp3an3 vw cv c1 caddc co cc wcel c1 cc wcel vw cv c1
      caddc co c1 cmin co cc wcel vw cv cc wcel vw cv c1 caddc co c1 subcl vw
      cv peano2cn ax1cn sylancl sylan vw cv cc wcel vw cv c1 caddc co c1 cmin
      co c1 cmin co cB caddc co vw cv c1 cmin co cB caddc co wceq cB cc wcel vw
      cv cc wcel vw cv c1 caddc co c1 cmin co c1 cmin co vw cv c1 cmin co cB
      caddc vw cv cc wcel vw cv c1 caddc co c1 cmin co vw cv c1 cmin vw cv cc
      wcel c1 cc wcel vw cv c1 caddc co c1 cmin co vw cv wceq ax1cn vw cv c1
      pncan mpan2 opreq1d opreq1d adantr eqtrd vw cv nncn cB zcn syl2an wth vy
      vw cv c1 caddc co c1 cmin co cB caddc co c1 cmin co vw cv c1 cmin co cB
      caddc co dfsbcq syl sylibrd ex adantld a2d imim12d nnind sylbir ex
      pm2.43a com23 mpcom sylbid imp $.
      $( [18-Jun-2004] $) $( [11-May-2004] $)
  $}

  ${
    $d x z A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.  $d x y z B $.
    $( Substitutions. $)
    uzind3OLD.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    uzind3OLD.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    uzind3OLD.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    uzind3OLD.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind3OLD.5 $e |- ps $.
    $( Induction hypothesis. $)
    uzind3OLD.6 $e |- ( ( B e. ZZ /\ y e. { z e. ZZ | B <_ z } ) ->
                   ( ch -> th ) ) $.
    $( Induction on the set of upper integers that starts at ` B ` .  The first
       four hypotheses give us the substitution instances we need, and the last
       two are the basis and the induction hypothesis. $)
    uzind3OLD $p |- ( ( B e. ZZ /\ A e. { z e. ZZ | B <_ z } ) -> ta ) $=
      cB cz wcel cA cz wcel cB cA cle wbr wa wta cA cB vz cv cle wbr vz cz crab
      wcel cA cz wcel cB cz wcel cB cA cle wbr wta cA cz wcel cB cz wcel cB cA
      cle wbr wta wph wps wch wth wta vx vy cA cB uzind3OLD.1 uzind3OLD.2
      uzind3OLD.3 uzind3OLD.4 uzind3OLD.5 vy cv cz wcel cB cz wcel cB vy cv cle
      wbr wch wth wi cB cz wcel vy cv cz wcel cB vy cv cle wbr wch wth wi cB cz
      wcel vy cv cB vz cv cle wbr vz cz crab wcel wch wth wi vy cv cz wcel cB
      vy cv cle wbr wa uzind3OLD.6 cB vz cv cle wbr cB vy cv cle wbr vz vy cv
      cz vz cv vy cv cB cle breq2 elrab sylan2br an1s anassrs uzindOLD anasss
      an1s cB vz cv cle wbr cB cA cle wbr vz cA cz vz cv cA cB cle breq2 elrab
      sylan2b $.
      $( [11-Nov-2004] $) $( [9-Nov-2004] $)
  $}

  ${
    $d x y w v u A $.  $d y z w v u B $.
    $( Well-ordering principle:  any non-empty subset of the upper integers
       has a least element. $)
    uzwo4OLD $p |- ( ( B e. ZZ /\ ( A C_ { z e. ZZ | B <_ z } /\ A =/= (/) ) )
            -> E. x e. A A. y e. A x <_ y ) $=
      cB cz wcel cA cB vz cv cle wbr vz cz crab wss cA c0 wne vx cv vy cv cle
      wbr vy cA wral vx cA wrex cB cz wcel cA cB vz cv cle wbr vz cz crab wss
      wa cA c0 wne vx cv vy cv cle wbr vy cA wral vx cA wrex cB cz wcel cA cB
      vz cv cle wbr vz cz crab wss wa vx cv vy cv cle wbr vy cA wral vx cA wrex
      cA c0 cB cz wcel cA cB vz cv cle wbr vz cz crab wss wa vx cv vy cv cle
      wbr vy cA wral vx cA wrex wn vw cv cA wcel wn vw wal cA c0 wceq cB cz
      wcel cA cB vz cv cle wbr vz cz crab wss wa vx cv vy cv cle wbr vy cA wral
      vx cA wrex wn vw cv cA wcel wn vw cB cz wcel cA cB vz cv cle wbr vz cz
      crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn vw cv cA wcel wn cB
      cz wcel vw cv cB vz cv cle wbr vz cz crab wcel cA cB vz cv cle wbr vz cz
      crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vw cv cA wcel wn
      wi cB cz wcel vw cv cB vz cv cle wbr vz cz crab wcel cA cB vz cv cle wbr
      vz cz crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vw cv cA
      wcel wn wi cB cz wcel vw cv cB vz cv cle wbr vz cz crab wcel wa cA cB vz
      cv cle wbr vz cz crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa
      vw cv vy cv cle wbr vy cA wral vw cv cA wcel wn cA cB vz cv cle wbr vz cz
      crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vv cv vy cv cle
      wbr vy cA wral wi cA cB vz cv cle wbr vz cz crab wss vx cv vy cv cle wbr
      vy cA wral vx cA wrex wn wa cB vy cv cle wbr vy cA wral wi cA cB vz cv
      cle wbr vz cz crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vu
      cv vy cv cle wbr vy cA wral wi cA cB vz cv cle wbr vz cz crab wss vx cv
      vy cv cle wbr vy cA wral vx cA wrex wn wa vu cv c1 caddc co vy cv cle wbr
      vy cA wral wi cA cB vz cv cle wbr vz cz crab wss vx cv vy cv cle wbr vy
      cA wral vx cA wrex wn wa vw cv vy cv cle wbr vy cA wral wi vv vu vz vw cv
      cB vv cv cB wceq vv cv vy cv cle wbr vy cA wral cB vy cv cle wbr vy cA
      wral cA cB vz cv cle wbr vz cz crab wss vx cv vy cv cle wbr vy cA wral vx
      cA wrex wn wa vv cv cB wceq vv cv vy cv cle wbr cB vy cv cle wbr vy cA vv
      cv cB vy cv cle breq1 ralbidv imbi2d vv cv vu cv wceq vv cv vy cv cle wbr
      vy cA wral vu cv vy cv cle wbr vy cA wral cA cB vz cv cle wbr vz cz crab
      wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vv cv vu cv wceq vv
      cv vy cv cle wbr vu cv vy cv cle wbr vy cA vv cv vu cv vy cv cle breq1
      ralbidv imbi2d vv cv vu cv c1 caddc co wceq vv cv vy cv cle wbr vy cA
      wral vu cv c1 caddc co vy cv cle wbr vy cA wral cA cB vz cv cle wbr vz cz
      crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vv cv vu cv c1
      caddc co wceq vv cv vy cv cle wbr vu cv c1 caddc co vy cv cle wbr vy cA
      vv cv vu cv c1 caddc co vy cv cle breq1 ralbidv imbi2d vv cv vw cv wceq
      vv cv vy cv cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral cA cB vz cv
      cle wbr vz cz crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vv
      cv vw cv wceq vv cv vy cv cle wbr vw cv vy cv cle wbr vy cA vv cv vw cv
      vy cv cle breq1 ralbidv imbi2d cA cB vz cv cle wbr vz cz crab wss cB vy
      cv cle wbr vy cA wral vx cv vy cv cle wbr vy cA wral vx cA wrex wn cA cB
      vz cv cle wbr vz cz crab wss cB vy cv cle wbr vy cA cA cB vz cv cle wbr
      vz cz crab wss vy cv cA wcel vy cv cB vz cv cle wbr vz cz crab wcel cB vy
      cv cle wbr cA cB vz cv cle wbr vz cz crab vy cv ssel vy cv cB vz cv cle
      wbr vz cz crab wcel vy cv cz wcel cB vy cv cle wbr cB vz cv cle wbr cB vy
      cv cle wbr vz vy cv cz vz cv vy cv cB cle breq2 elrab pm3.27bi syl6
      r19.21aiv adantr vu cv cB vz cv cle wbr vz cz crab wcel cA cB vz cv cle
      wbr vz cz crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa vu cv
      vy cv cle wbr vy cA wral wi cA cB vz cv cle wbr vz cz crab wss vx cv vy
      cv cle wbr vy cA wral vx cA wrex wn wa vu cv c1 caddc co vy cv cle wbr vy
      cA wral wi wi cB cz wcel vu cv cB vz cv cle wbr vz cz crab wcel cA cB vz
      cv cle wbr vz cz crab wss vx cv vy cv cle wbr vy cA wral vx cA wrex wn wa
      vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co vy cv cle wbr vy cA wral
      vu cv cB vz cv cle wbr vz cz crab wcel cA cz wss vx cv vy cv cle wbr vy
      cA wral vx cA wrex wn vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co vy
      cv cle wbr vy cA wral wi cA cB vz cv cle wbr vz cz crab wss vu cv cB vz
      cv cle wbr vz cz crab wcel vu cv cz wcel cA cz wss vx cv vy cv cle wbr vy
      cA wral vx cA wrex wn wa vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co
      vy cv cle wbr vy cA wral wi wi cB vz cv cle wbr vz cz crab cz vu cv cB vz
      cv cle wbr vz cz ssrab2 sseli vu cv cz wcel cA cz wss vx cv vy cv cle wbr
      vy cA wral vx cA wrex wn vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co
      vy cv cle wbr vy cA wral wi vu cv cz wcel cA cz wss vx cv vy cv cle wbr
      vy cA wral vx cA wrex wn vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co
      vy cv cle wbr vy cA wral wi vu cv cz wcel cA cz wss wa vx cv vy cv cle
      wbr vy cA wral vx cA wrex wn wa vu cv vy cv cle wbr vy cA wral vu cv c1
      caddc co vy cv cle wbr vy cA wral vx cv vy cv cle wbr vy cA wral vx cA
      wrex wn vu cv vy cv cle wbr vy cA wral vu cv cA wcel wn vu cv cz wcel cA
      cz wss wa vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co vy cv cle wbr
      vy cA wral wi vu cv vy cv cle wbr vy cA wral vx cv vy cv cle wbr vy cA
      wral vx cA wrex wn vu cv cA wcel wn vu cv vy cv cle wbr vy cA wral vu cv
      cA wcel vx cv vy cv cle wbr vy cA wral vx cA wrex vu cv cA wcel vu cv vy
      cv cle wbr vy cA wral vx cv vy cv cle wbr vy cA wral vx cA wrex vx cv vy
      cv cle wbr vy cA wral vu cv vy cv cle wbr vy cA wral vx vu cv cA vx cv vu
      cv wceq vx cv vy cv cle wbr vu cv vy cv cle wbr vy cA vx cv vu cv vy cv
      cle breq1 ralbidv rcla4ev expcom con3d com12 vu cv cz wcel cA cz wss wa
      vu cv cA wcel wn vu cv vy cv cle wbr vy cA wral vu cv c1 caddc co vy cv
      cle wbr vy cA wral wi vu cv cz wcel cA cz wss wa vu cv cA wcel wn wa vu
      cv vy cv cle wbr vu cv c1 caddc co vy cv cle wbr vy cA vu cv cz wcel cA
      cz wss vu cv cA wcel wn vy cv cA wcel vu cv vy cv cle wbr vu cv c1 caddc
      co vy cv cle wbr wi vu cv cz wcel cA cz wss vy cv cA wcel vu cv cA wcel
      wn vu cv vy cv cle wbr vu cv c1 caddc co vy cv cle wbr wi vu cv cz wcel
      cA cz wss vy cv cA wcel vu cv cA wcel wn vu cv vy cv cle wbr vu cv c1
      caddc co vy cv cle wbr wi wi vu cv cz wcel cA cz wss vy cv cA wcel wa wa
      vu cv vy cv cle wbr vu cv cA wcel wn vu cv c1 caddc co vy cv cle wbr vu
      cv cz wcel cA cz wss vy cv cA wcel wa wa vu cv vy cv cle wbr vu cv c1
      caddc co vy cv cle wbr wn vu cv cA wcel wi vu cv cA wcel wn vu cv c1
      caddc co vy cv cle wbr wi vu cv cz wcel cA cz wss vy cv cA wcel wa wa vu
      cv vy cv cle wbr vu cv c1 caddc co vy cv cle wbr wn vu cv cA wcel vu cv
      cz wcel cA cz wss vy cv cA wcel wa wa vu cv vy cv cle wbr vu cv c1 caddc
      co vy cv cle wbr wn wa vu cv vy cv wceq vu cv cA wcel vu cv cz wcel vy cv
      cz wcel vu cv vy cv wceq vu cv vy cv cle wbr vu cv c1 caddc co vy cv cle
      wbr wn wa wb cA cz wss vy cv cA wcel wa vu cv cz wcel vy cv cz wcel wa vu
      cv vy cv wceq vu cv vy cv cle wbr vy cv vu cv cle wbr wa vu cv vy cv cle
      wbr vu cv c1 caddc co vy cv cle wbr wn wa vu cv cr wcel vy cv cr wcel vu
      cv vy cv wceq vu cv vy cv cle wbr vy cv vu cv cle wbr wa wb vu cv cz wcel
      vy cv cz wcel vu cv vy cv letri3 vu cv zre vy cv zre syl2an vu cv cz wcel
      vy cv cz wcel wa vy cv vu cv cle wbr vu cv c1 caddc co vy cv cle wbr wn
      vu cv vy cv cle wbr vy cv cz wcel vu cv cz wcel vy cv vu cv cle wbr vu cv
      c1 caddc co vy cv cle wbr wn wb vy cv cz wcel vu cv cz wcel wa vy cv vu
      cv cle wbr vy cv vu cv c1 caddc co clt wbr vu cv c1 caddc co vy cv cle
      wbr wn vy cv vu cv zleltp1 vy cv cr wcel vu cv c1 caddc co cr wcel vy cv
      vu cv c1 caddc co clt wbr vu cv c1 caddc co vy cv cle wbr wn wb vy cv cz
      wcel vu cv cz wcel vy cv vu cv c1 caddc co ltnle vy cv zre vu cv cz wcel
      vu cv cr wcel vu cv c1 caddc co cr wcel vu cv zre vu cv peano2re syl
      syl2an bitrd ancoms anbi2d bitrd cA cz vy cv ssel2 sylan2 vy cv cA wcel
      vu cv vy cv wceq vu cv cA wcel wi vu cv cz wcel cA cz wss vy cv cA vu cv
      eleq1a ad2antll sylbird exp3a vu cv c1 caddc co vy cv cle wbr vu cv cA
      wcel con1 syl6 com23 exp32 com34 imp41 r19.20dva ex sylan9r pm2.43d exp31
      imp3a syl cA cB vz cv cle wbr vz cz crab wss cB vz cv cle wbr vz cz crab
      cz wss cA cz wss cB vz cv cle wbr vz cz ssrab2 cA cB vz cv cle wbr vz cz
      crab cz sstr mpan2 sylani a2d adantl uzind3OLD vx cv vy cv cle wbr vy cA
      wral vx cA wrex wn vw cv vy cv cle wbr vy cA wral vw cv cA wcel wn wi cA
      cB vz cv cle wbr vz cz crab wss vw cv vy cv cle wbr vy cA wral vx cv vy
      cv cle wbr vy cA wral vx cA wrex wn vw cv cA wcel wn vw cv vy cv cle wbr
      vy cA wral vw cv cA wcel vx cv vy cv cle wbr vy cA wral vx cA wrex vw cv
      cA wcel vw cv vy cv cle wbr vy cA wral vx cv vy cv cle wbr vy cA wral vx
      cA wrex vx cv vy cv cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral vx
      vw cv cA vx cv vw cv wceq vx cv vy cv cle wbr vw cv vy cv cle wbr vy cA
      vx cv vw cv vy cv cle breq1 ralbidv rcla4ev expcom con3d com12 adantl
      sylcom ex vw cv cB vz cv cle wbr vz cz crab wcel wn cA cB vz cv cle wbr
      vz cz crab wss vw cv cA wcel wn vx cv vy cv cle wbr vy cA wral vx cA wrex
      wn cA cB vz cv cle wbr vz cz crab wss vw cv cB vz cv cle wbr vz cz crab
      wcel wn vw cv cA wcel wn cA cB vz cv cle wbr vz cz crab wss vw cv cA wcel
      vw cv cB vz cv cle wbr vz cz crab wcel cA cB vz cv cle wbr vz cz crab vw
      cv ssel con3d com12 adantrd pm2.61d1 expdimp 19.21adv vw cA eq0 syl6ibr
      necon1ad imp anasss $.
      $( [11-Nov-2004] $) $( [9-Nov-2004] $)

    $( Well-ordering principle:  any non-empty subset of upper integers has a
       unique least element. $)
    uzwo5OLD $p |- ( ( B e. ZZ /\ ( A C_ { z e. ZZ | B <_ z } /\ A =/= (/) ) )
                  -> E! x e. A A. y e. A x <_ y ) $=
      vx cv vy cv cle wbr vy cA wral vx cA wreu vx cv vy cv cle wbr vy cA wral
      vx cA wrex vx cv vy cv cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral
      wa vx cv vw cv wceq wi vw cA wral vx cA wral cB cz wcel cA cB vz cv cle
      wbr vz cz crab wss cA c0 wne wa wa vx cv vy cv cle wbr vy cA wral vw cv
      vy cv cle wbr vy cA wral vx vw cA vx cv vw cv wceq vx cv vy cv cle wbr vw
      cv vy cv cle wbr vy cA vx cv vw cv vy cv cle breq1 ralbidv reu4 vx vy vz
      cA cB uzwo4OLD cA cB vz cv cle wbr vz cz crab wss vx cv vy cv cle wbr vy
      cA wral vw cv vy cv cle wbr vy cA wral wa vx cv vw cv wceq wi vw cA wral
      vx cA wral cB cz wcel cA c0 wne cA cB vz cv cle wbr vz cz crab wss cA cr
      wss vx cv vy cv cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral wa vx
      cv vw cv wceq wi vw cA wral vx cA wral cA cB vz cv cle wbr vz cz crab wss
      cB vz cv cle wbr vz cz crab cr wss cA cr wss cB vz cv cle wbr vz cz crab
      cz cr cB vz cv cle wbr vz cz ssrab2 zssre sstri cA cB vz cv cle wbr vz cz
      crab cr sstr mpan2 cA cr wss vx cv vy cv cle wbr vy cA wral vw cv vy cv
      cle wbr vy cA wral wa vx cv vw cv wceq wi vx vw cA cA vx cv cA wcel vw cv
      cA wcel wa vx cv vy cv cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral
      wa cA cr wss vx cv vw cv wceq vx cv cA wcel vw cv cA wcel wa vx cv vy cv
      cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral wa vx cv vw cv cle wbr
      vw cv vx cv cle wbr wa cA cr wss vx cv vw cv wceq wi vw cv cA wcel vx cv
      cA wcel vx cv vy cv cle wbr vy cA wral vw cv vy cv cle wbr vy cA wral wa
      vx cv vw cv cle wbr vw cv vx cv cle wbr wa wi vw cv cA wcel vx cv vy cv
      cle wbr vy cA wral vx cv vw cv cle wbr vx cv cA wcel vw cv vy cv cle wbr
      vy cA wral vw cv vx cv cle wbr vx cv vy cv cle wbr vx cv vw cv cle wbr vy
      vw cv cA vy cv vw cv vx cv cle breq2 rcla4v vw cv vy cv cle wbr vw cv vx
      cv cle wbr vy vx cv cA vy cv vx cv vw cv cle breq2 rcla4v im2anan9 ancoms
      vx cv cA wcel vw cv cA wcel wa cA cr wss vx cv vw cv cle wbr vw cv vx cv
      cle wbr wa vx cv vw cv wceq vx cv cA wcel vw cv cA wcel wa cA cr wss vx
      cv vw cv cle wbr vw cv vx cv cle wbr wa vx cv vw cv wceq wi vx cv cA wcel
      vw cv cA wcel wa cA cr wss wa vx cv vw cv wceq vx cv vw cv cle wbr vw cv
      vx cv cle wbr wa vx cv cA wcel vw cv cA wcel wa cA cr wss wa vx cv cr
      wcel vw cv cr wcel wa vx cv vw cv wceq vx cv vw cv cle wbr vw cv vx cv
      cle wbr wa wb cA cr wss vx cv cA wcel vw cv cA wcel wa vx cv cr wcel vw
      cv cr wcel wa cA cr wss vx cv cA wcel vx cv cr wcel vw cv cA wcel vw cv
      cr wcel cA cr vx cv ssel cA cr vw cv ssel anim12d impcom vx cv vw cv
      letri3 syl biimprd ex com23 syld com3r r19.21aivv syl ad2antrl sylanbrc
      $.
      $( [28-Nov-2004] $) $( [9-Nov-2004] $)
  $}

  ${
    $d x y $.  $d A x $.  $d ps x $.  $d ch x $.  $d th x $.  $d ta x $.
    $d ph y $.
    nn0ind.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    nn0ind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nn0ind.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nn0ind.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    nn0ind.5 $e |- ps $.
    nn0ind.6 $e |- ( y e. NN0 -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers.  The first four hypotheses give us the substitution instances
       we need; the last two are the basis and the induction hypothesis. $)
    nn0ind $p |- ( A e. NN0 -> ta ) $=
      cA cn0 wcel cA cz wcel cc0 cA cle wbr wa wta cA elnn0z cc0 cz wcel cA cz
      wcel cc0 cA cle wbr wta 0z wph wps wch wth wta vx vy cc0 cA nn0ind.1
      nn0ind.2 nn0ind.3 nn0ind.4 wps cc0 cz wcel nn0ind.5 a1i vy cv cz wcel cc0
      vy cv cle wbr wch wth wi cc0 cz wcel vy cv cz wcel cc0 vy cv cle wbr wa
      vy cv cn0 wcel wch wth wi vy cv elnn0z nn0ind.6 sylbir 3adant1 uzind
      mp3an1 sylbi $.
      $( [14-Feb-2005] $) $( [13-May-2004] $)
  $}

  ${
    $d x y $.  $d A x $.  $d ps x $.  $d ch x $.  $d th x $.  $d ta x $.
    $d ph y $.
    nn0indALT.6 $e |- ( y e. NN0 -> ( ch -> th ) ) $.
    nn0indALT.5 $e |- ps $.
    nn0indALT.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    nn0indALT.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nn0indALT.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nn0indALT.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers.  The first four hypotheses give us the substitution instances
       we need; the last two are the basis and the induction hypothesis. $)
    nn0indALT $p |- ( A e. NN0 -> ta ) $=
      wph wps wch wth wta vx vy cA nn0indALT.1 nn0indALT.2 nn0indALT.3
      nn0indALT.4 nn0indALT.5 nn0indALT.6 nn0ind $.
      $( [14-Feb-2005] $) $( [28-Nov-2005] $)
  $}

  ${
    $d x y z $.  $d A x z $.  $d ps x z $.  $d ch x z $.  $d th x z $.
    $d ta x z $.  $d ph y z $.
    nn0ind-raph.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    nn0ind-raph.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nn0ind-raph.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nn0ind-raph.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    nn0ind-raph.5 $e |- ps $.
    nn0ind-raph.6 $e |- ( y e. NN0 -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers.  The first four hypotheses give us the substitution instances
       we need; the last two are the basis and the induction hypothesis.
       (Contributed by Raph Levien, 10-Apr-2004.  Raph says: "This seems a bit
       painful.  I wonder if an explicit substitution version would be
       easier.") $)
    nn0ind-raph $p |- ( A e. NN0 -> ta ) $=
      cA cn0 wcel cA cn wcel cA cc0 wceq wo wta cA elnn0 cA cn wcel wta cA cc0
      wceq wph vx vz cv wsbc wph vx c1 wsbc wch wth wta vz vy cA wph vx vz cv
      c1 dfsbcq wph wch vx vz vy cv wch vx ax-17 nn0ind-raph.2 sbhypf wph wth
      vx vz vy cv c1 caddc co wth vx ax-17 nn0ind-raph.3 sbhypf wph wta vx vz
      cA wta vx ax-17 nn0ind-raph.4 sbhypf wph vx c1 wsbc vx c1 wph vx c1 c1 cr
      1re elisseti hbsbc1v c1 cr 1re elisseti vx cv c1 wceq wph wph vx c1 wsbc
      vx cv c1 wceq wph wi vy cc0 cc0 cn0 0nn0 elisseti vy cv cc0 wceq vx cv c1
      wceq wph vy cv cc0 wceq vx cv c1 wceq wa wph wth vy cv cc0 wceq wth vx cv
      c1 wceq vy cv cn0 wcel wch wth vy cv cc0 wceq nn0ind-raph.6 cc0 cn0 wcel
      vy cv cc0 wceq vy cv cn0 wcel wi 0nn0 cc0 cn0 vy cv eleq1a ax-mp vy cv
      cc0 wceq wch wi vx cc0 cc0 cn0 0nn0 elisseti vy cv cc0 wceq vx cv cc0
      wceq wch vy cv cc0 wceq vx cv cc0 wceq wph wi vx cv cc0 wceq wch wi vx cv
      cc0 wceq wph wps nn0ind-raph.5 nn0ind-raph.1 mpbiri vy cv cc0 wceq vx cv
      cc0 wceq wph wch vy cv cc0 wceq vx cv cc0 wceq vx cv vy cv wceq wph wch
      wb vy cv cc0 vx cv eqeq2 nn0ind-raph.2 syl6bir pm5.74d mpbii com12 vtocle
      sylc adantr vy cv cc0 wceq vx cv c1 wceq wph wth wb vy cv cc0 wceq vx cv
      c1 wceq vx cv vy cv c1 caddc co wceq wph wth wb vy cv cc0 wceq vy cv c1
      caddc co c1 vx cv vy cv cc0 wceq vy cv c1 caddc co cc0 c1 caddc co c1 vy
      cv cc0 c1 caddc opreq1 c1 ax1cn addid2i syl6eq eqeq2d nn0ind-raph.3
      syl6bir imp mpbird ex vtocle wph vx c1 sbceq1a mpbid vtoclef vy cv cn
      wcel vy cv cn0 wcel wch wth wi vy cv nnnn0 nn0ind-raph.6 syl nnind wta
      cc0 cA cc0 cA wceq wta wi vx cc0 cc0 cA wceq wta vx cc0 cA wceq vx ax-17
      wta vx ax-17 hbim cc0 cn0 0nn0 elisseti vx cv cc0 wceq cc0 cA wceq vx cv
      cA wceq wta vx cv cc0 cA eqeq1 vx cv cc0 wceq vx cv cA wceq wta vx cv cc0
      wceq vx cv cA wceq wa wps wta nn0ind-raph.5 vx cv cc0 wceq wps wph vx cv
      cA wceq wta vx cv cc0 wceq wph wps nn0ind-raph.1 bicomd nn0ind-raph.4
      sylan9bb mpbii ex sylbird vtoclef eqcoms jaoi sylbi $.
      $( [25-May-2004] $) $( [10-Apr-2004] $)
  $}

  ${
    $v et $.
    $v ze $.
    zindd.wet $f wff et $.
    zindd.wze $f wff ze $.
    $d A x $.  $d ch x $.  $d et x $.  $d ph y $.  $d ps x $.  $d ta x $.
    $d th x $.  $d x y ze $.
    zindd.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    zindd.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    zindd.3 $e |- ( x = ( y + 1 ) -> ( ph <-> ta ) ) $.
    zindd.4 $e |- ( x = -u y -> ( ph <-> th ) ) $.
    zindd.5 $e |- ( x = A -> ( ph <-> et ) ) $.
    zindd.6 $e |- ( ze -> ps ) $.
    zindd.7 $e |- ( ze -> ( y e. NN0 -> ( ch -> ta ) ) ) $.
    zindd.8 $e |- ( ze -> ( y e. NN -> ( ch -> th ) ) ) $.
    $( Principle of Mathematical Induction on all integers, deduction version.
       The first five hypotheses give the substitutions; the last three are the
       basis, the induction, and the extension to negative numbers.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    zindd $p |- ( ze -> ( A e. ZZ -> et ) ) $=
      cA cz wcel zindd.wze zindd.wet cA cz wcel zindd.wze wph wi vx cz wral
      zindd.wze zindd.wet wi zindd.wze wph wi vx cz vx cv cz wcel zindd.wze wth
      wi vy cz wral zindd.wze wph wi zindd.wze wth wi vy cz vy cv cz wcel vy cv
      cneg cn0 wcel vy cv cn wcel wo zindd.wze wth wi vy cv cz wcel vy cv cneg
      cn0 wcel vy cv cneg cneg cn wcel wo vy cv cneg cn0 wcel vy cv cn wcel wo
      vy cv cz wcel vy cv cneg cz wcel vy cv cneg cn0 wcel vy cv cneg cneg cn
      wcel wo vy cv znegcl vy cv cneg cz wcel vy cv cneg cn0 wcel vy cv cneg cr
      wcel vy cv cneg cneg cn wcel wa wo vy cv cneg cn0 wcel vy cv cneg cneg cn
      wcel wo vy cv cneg cz wcel vy cv cneg cn0 wcel vy cv cneg cr wcel vy cv
      cneg cneg cn wcel wa wo vy cv cneg elznn0nn biimpi vy cv cneg cr wcel vy
      cv cneg cneg cn wcel wa vy cv cneg cneg cn wcel vy cv cneg cn0 wcel vy cv
      cneg cr wcel vy cv cneg cneg cn wcel pm3.27 orim2i syl syl vy cv cz wcel
      vy cv cneg cneg cn wcel vy cv cn wcel vy cv cneg cn0 wcel vy cv cz wcel
      vy cv cneg cneg vy cv cn vy cv cz wcel vy cv cc wcel vy cv cneg cneg vy
      cv wceq vy cv zcn vy cv negneg syl eleq1d orbi2d mpbid vy cv cneg cn0
      wcel zindd.wze wth wi vy cv cn wcel vy cv cneg cn0 wcel zindd.wze wph wi
      vx cn0 wral zindd.wze wth wi zindd.wze wph wi vx cn0 wral zindd.wze wch
      wi vy cn0 wral zindd.wze wch wi vy cn0 zindd.wze wph wi zindd.wze wps wi
      zindd.wze wch wi zindd.wze wta wi zindd.wze wch wi vx vy vy cv vx cv cc0
      wceq wph wps zindd.wze zindd.1 imbi2d vx cv vy cv wceq wph wch zindd.wze
      zindd.2 imbi2d vx cv vy cv c1 caddc co wceq wph wta zindd.wze zindd.3
      imbi2d vx cv vy cv wceq wph wch zindd.wze zindd.2 imbi2d zindd.6 vy cv
      cn0 wcel zindd.wze wch wta zindd.wze vy cv cn0 wcel wch wta wi zindd.7
      com12 a2d nn0ind rgen zindd.wze wph wi zindd.wze wch wi vx vy cn0 vx cv
      vy cv wceq wph wch zindd.wze zindd.2 imbi2d cbvralv mpbir zindd.wze wph
      wi zindd.wze wth wi vx vy cv cneg cn0 vx cv vy cv cneg wceq wph wth
      zindd.wze zindd.4 imbi2d rcla4v mpi zindd.wze vy cv cn wcel wth zindd.wze
      vy cv cn wcel wch wth vy cv cn wcel zindd.wze wch vy cv cn wcel vy cv cn0
      wcel zindd.wze wch wi vy cv nnnn0 zindd.wze wph wi zindd.wze wps wi
      zindd.wze wch wi zindd.wze wta wi zindd.wze wch wi vx vy vy cv vx cv cc0
      wceq wph wps zindd.wze zindd.1 imbi2d vx cv vy cv wceq wph wch zindd.wze
      zindd.2 imbi2d vx cv vy cv c1 caddc co wceq wph wta zindd.wze zindd.3
      imbi2d vx cv vy cv wceq wph wch zindd.wze zindd.2 imbi2d zindd.6 vy cv
      cn0 wcel zindd.wze wch wta zindd.wze vy cv cn0 wcel wch wta wi zindd.7
      com12 a2d nn0ind syl com12 zindd.8 mpdd com12 jaoi syl rgen vx cv cc wcel
      vx cv cneg cz wcel zindd.wze wth wi vy cz wral zindd.wze wph wi wi vx cv
      cz wcel vx cv cc wcel zindd.wze wth wi zindd.wze wph wi vy vx cv cneg cz
      vx cv cc wcel vy cv vx cv cneg wceq wa zindd.wze wph wi zindd.wze wth wi
      vx cv cc wcel vy cv vx cv cneg wceq wa vy cv cc wcel zindd.wze wph wi
      zindd.wze wth wi wb vx cv cc wcel vy cv vx cv cneg wceq wa vy cv cc wcel
      vx cv cneg cc wcel vx cv cc wcel vx cv cneg cc wcel vy cv vx cv cneg wceq
      vx cv negcl adantr vy cv vx cv cneg wceq vy cv cc wcel vx cv cneg cc wcel
      wb vx cv cc wcel vy cv vx cv cneg cc eleq1 adantl mpbird vx cv cc wcel vy
      cv vx cv cneg wceq vy cv cc wcel zindd.wze wph wi zindd.wze wth wi wb wi
      vx cv cc wcel vy cv cc wcel vy cv vx cv cneg wceq zindd.wze wph wi
      zindd.wze wth wi wb vx cv cc wcel vy cv cc wcel vy cv vx cv cneg wceq
      zindd.wze wph wi zindd.wze wth wi wb wi vx cv cc wcel vy cv cc wcel wa vy
      cv vx cv cneg wceq vx cv vy cv cneg wceq zindd.wze wph wi zindd.wze wth
      wi wb vx cv vy cv negcon2 vx cv vy cv cneg wceq wph wth zindd.wze zindd.4
      imbi2d syl6bir ex com23 imp mpd bicomd rcla4dv vx cv zcn vx cv znegcl
      sylanc mpi rgen zindd.wze wph wi zindd.wze zindd.wet wi vx cA cz vx cv cA
      wceq wph zindd.wet zindd.wze zindd.5 imbi2d rcla4v mpi com12 $.
      $( [19-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d x z A $.  $d y A $.
    $( Any real number can be sandwiched between two integers.  Exercise 2 of
       [Apostol] p. 28. $)
    btwnz $p |- ( A e. RR -> ( E. x e. ZZ x < A /\ E. y e. ZZ A < y ) ) $=
      cA cr wcel vx cv cA clt wbr vx cz wrex cA vy cv clt wbr vy cz wrex cA cr
      wcel cA cneg vz cv clt wbr vz cn wrex vx cv cA clt wbr vx cz wrex cA cr
      wcel cA cneg cr wcel cA cneg vz cv clt wbr vz cn wrex cA renegcl cA cneg
      vz arch syl cA cr wcel cA cneg vz cv clt wbr vx cv cA clt wbr vx cz wrex
      vz cn cA cr wcel vz cv cn wcel cA cneg vz cv clt wbr vx cv cA clt wbr vx
      cz wrex cA cr wcel vz cv cn wcel cA cneg vz cv clt wbr wa vz cv cn wcel
      vz cv cneg cA clt wbr wa vx cv cA clt wbr vx cz wrex cA cr wcel vz cv cn
      wcel cA cneg vz cv clt wbr vz cv cneg cA clt wbr cA cr wcel vz cv cr wcel
      cA cneg vz cv clt wbr vz cv cneg cA clt wbr wb vz cv cn wcel cA cr wcel
      vz cv cr wcel cA cneg vz cv clt wbr vz cv cneg cA clt wbr wb cA vz cv
      ltnegcon1 ex vz cv nnre syl5 pm5.32d vz cv cneg cz wcel vz cv cneg cA clt
      wbr vx cv cA clt wbr vx cz wrex vz cv cn wcel vx cv cA clt wbr vz cv cneg
      cA clt wbr vx vz cv cneg cz vx cv vz cv cneg cA clt breq1 rcla4ev vz cv
      nnnegz sylan syl6bi exp3a r19.23adv mpd cA cr wcel cA vy cv clt wbr vy cn
      wrex cA vy cv clt wbr vy cz wrex cA vy arch cA vy cv clt wbr cA vy cv clt
      wbr vy cn cz vy cv cn wcel vy cv cz wcel cA vy cv clt wbr vy cv nnz
      anim1i r19.22i2 syl jca $.
      $( [29-Nov-2004] $) $( [10-Nov-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Well-ordering principle for bounded-below sets of integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d z v B $.  $d x y v R $.  $d y z $.
    uzwo3lem.1 $e |- R = { z e. ZZ | B <_ z } $.
    $( Lemma for ~ uzwo3 and ~ zmin . $)
    uzwo3lem1 $p |- ( B e. RR -> E! x e. R A. y e. R x <_ y ) $=
      cB cr wcel vv cv cB clt wbr vv cz wrex vx cv vy cv cle wbr vy cR wral vx
      cR wreu cB cr wcel vv cv cB clt wbr vv cz wrex cB vz cv clt wbr vz cz
      wrex vv vz cB btwnz pm3.26d cB cr wcel vv cv cB clt wbr vx cv vy cv cle
      wbr vy cR wral vx cR wreu vv cz vv cv cz wcel cB cr wcel vv cv cB clt wbr
      vx cv vy cv cle wbr vy cR wral vx cR wreu wi vv cv cz wcel cB cr wcel vv
      cv cB clt wbr vx cv vy cv cle wbr vy cR wral vx cR wreu vv cv cz wcel cB
      cr wcel vv cv cB clt wbr wa cR vv cv vz cv cle wbr vz cz crab wss cR c0
      wne wa vx cv vy cv cle wbr vy cR wral vx cR wreu vv cv cz wcel cB cr wcel
      vv cv cB clt wbr wa cR vv cv vz cv cle wbr vz cz crab wss cR c0 wne wa vv
      cv cz wcel cB cr wcel vv cv cB clt wbr wa wa cR vv cv vz cv cle wbr vz cz
      crab wss cR c0 wne vv cv cz wcel cB cr wcel vv cv cB clt wbr wa wa cB vz
      cv cle wbr vz cz crab vv cv vz cv cle wbr vz cz crab cR vv cv cz wcel cB
      cr wcel vv cv cB clt wbr wa wa cB vz cv cle wbr vv cv vz cv cle wbr wi vz
      cz wral cB vz cv cle wbr vz cz crab vv cv vz cv cle wbr vz cz crab wss vv
      cv cz wcel cB cr wcel vv cv cB clt wbr wa wa cB vz cv cle wbr vv cv vz cv
      cle wbr wi vz cz vv cv cz wcel cB cr wcel vv cv cB clt wbr vz cv cz wcel
      cB vz cv cle wbr vv cv vz cv cle wbr wi wi vv cv cz wcel cB cr wcel vz cv
      cz wcel vv cv cB clt wbr cB vz cv cle wbr vv cv vz cv cle wbr wi vv cv cz
      wcel cB cr wcel vz cv cz wcel vv cv cB clt wbr cB vz cv cle wbr vv cv vz
      cv cle wbr wi wi vv cv cz wcel cB cr wcel vz cv cz wcel w3a vv cv cB clt
      wbr cB vz cv cle wbr vv cv vz cv cle wbr vv cv cr wcel cB cr wcel vz cv
      cz wcel vv cv cB clt wbr cB vz cv cle wbr wa vv cv vz cv cle wbr wi vv cv
      cz wcel vv cv cr wcel cB cr wcel vz cv cr wcel vv cv cB clt wbr cB vz cv
      cle wbr wa vv cv vz cv cle wbr wi vz cv cz wcel vv cv cr wcel cB cr wcel
      vz cv cr wcel w3a vv cv cB clt wbr cB vz cv cle wbr wa vv cv vz cv clt
      wbr vv cv vz cv cle wbr vv cv cB vz cv ltletr vv cv cr wcel vz cv cr wcel
      vv cv vz cv clt wbr vv cv vz cv cle wbr wi cB cr wcel vv cv vz cv ltle
      3adant2 syld vz cv zre syl3an3 vv cv zre syl3an1 exp3a 3exp com34 imp32
      r19.21aiv cB vz cv cle wbr vv cv vz cv cle wbr vz cz ss2rab sylibr
      uzwo3lem.1 syl5ss cB cr wcel cR c0 wne vv cv cz wcel vv cv cB clt wbr cB
      cr wcel cB vz cv clt wbr vz cz wrex cR c0 wne cB cr wcel vv cv cB clt wbr
      vv cz wrex cB vz cv clt wbr vz cz wrex vv vz cB btwnz pm3.27d cB cr wcel
      cB vz cv clt wbr vz cz wrex cB vz cv cle wbr vz cz wrex cR c0 wne cB cr
      wcel cB vz cv clt wbr cB vz cv cle wbr vz cz cB cr wcel vz cv cr wcel cB
      vz cv clt wbr cB vz cv cle wbr wi vz cv cz wcel cB vz cv ltle vz cv zre
      sylan2 r19.22dva cR c0 wne cB vz cv cle wbr vz cz crab c0 wne cB vz cv
      cle wbr vz cz wrex cR cB vz cv cle wbr vz cz crab c0 uzwo3lem.1 neeq1i cB
      vz cv cle wbr vz cz rabn0 bitr2i syl6ib mpd ad2antrl jca ex vv cv cz wcel
      cR vv cv vz cv cle wbr vz cz crab wss cR c0 wne wa vx cv vy cv cle wbr vy
      cR wral vx cR wreu vx vy vz cR vv cv uzwo5OLD ex syld exp3a com12
      r19.23adv mpd $.
      $( [30-Nov-2004] $) $( [10-Nov-2004] $)

    ${
      $d x y z w v u t $.  $d x y A $.  $d t B $.  $d y t S $.  $d w R $.
      uzwo3lem.2 $e |- S = U. { w e. R | A. v e. R w <_ v } $.
      $( Lemma for ~ uzwo3 . $)
      uzwo3lem2 $p |- ( ( B e. RR /\ ( A C_ R /\ A =/= (/) ) )
                    -> E! x e. A A. y e. A x <_ y ) $=
        cB cr wcel cA cR wss cA c0 wne vx cv vy cv cle wbr vy cA wral vx cA
        wreu cB cr wcel cA cR wss cA cS vt cv cle wbr vt cz crab wss cA c0 wne
        vx cv vy cv cle wbr vy cA wral vx cA wreu wi cA cR wss cR cS vt cv cle
        wbr vt cz crab wss cA cS vt cv cle wbr vt cz crab wss cB cr wcel cA cR
        cS vt cv cle wbr vt cz crab sstr2 cB cr wcel cB vt cv cle wbr vt cz
        crab cS vt cv cle wbr vt cz crab cR cB cr wcel cB vt cv cle wbr cS vt
        cv cle wbr wi vt cz wral cB vt cv cle wbr vt cz crab cS vt cv cle wbr
        vt cz crab wss cB cr wcel cB vt cv cle wbr cS vt cv cle wbr wi vt cz cB
        cr wcel vt cv cz wcel cB vt cv cle wbr cS vt cv cle wbr cB cr wcel vt
        cv cR wcel cS vt cv cle wbr vt cv cz wcel cB vt cv cle wbr wa vt cv cR
        wcel cS vy cv cle wbr vy cR wral cS vt cv cle wbr cB cr wcel cS vy cv
        cle wbr cS vt cv cle wbr vy vt cv cR vy cv vt cv cS cle breq2 rcla4v cB
        cr wcel vx cv vy cv cle wbr vy cR wral vx cR wreu cS vy cv cle wbr vy
        cR wral vx vy vz cB cR uzwo3lem.1 uzwo3lem1 vx cv vy cv cle wbr vy cR
        wral vx cR wreu vw cv vv cv cle wbr vv cR wral vw cR crab cuni vy cv
        cle wbr vy cR wral cS vy cv cle wbr vy cR wral vx cv vy cv cle wbr vy
        cR wral vw cv vv cv cle wbr vv cR wral vw cv vv cv cle wbr vv cR wral
        vw cR crab cuni vy cv cle wbr vy cR wral vx vw cR vx cv vw cv wceq vx
        cv vy cv cle wbr vy cR wral vw cv vy cv cle wbr vy cR wral vw cv vv cv
        cle wbr vv cR wral vx cv vw cv wceq vx cv vy cv cle wbr vw cv vy cv cle
        wbr vy cR vx cv vw cv vy cv cle breq1 ralbidv vw cv vy cv cle wbr vw cv
        vv cv cle wbr vy vv cR vy cv vv cv vw cv cle breq2 cbvralv syl6bb vx cv
        vw cv vv cv cle wbr vv cR wral vw cR crab cuni wceq vx cv vy cv cle wbr
        vw cv vv cv cle wbr vv cR wral vw cR crab cuni vy cv cle wbr vy cR vx
        cv vw cv vv cv cle wbr vv cR wral vw cR crab cuni vy cv cle breq1
        ralbidv reuuni3 cS vy cv cle wbr vw cv vv cv cle wbr vv cR wral vw cR
        crab cuni vy cv cle wbr vy cR cS vw cv vv cv cle wbr vv cR wral vw cR
        crab cuni vy cv cle uzwo3lem.2 breq1i ralbii sylibr syl syl5com cB vz
        cv cle wbr cB vt cv cle wbr vz vt cv cz cR vz cv vt cv cB cle breq2
        uzwo3lem.1 elrab2 syl5ibr exp3a r19.21aiv cB vt cv cle wbr cS vt cv cle
        wbr vt cz ss2rab sylibr cR cB vz cv cle wbr vz cz crab cB vt cv cle wbr
        vt cz crab uzwo3lem.1 cB vz cv cle wbr cB vt cv cle wbr vz vt cz vz cv
        vt cv cB cle breq2 cbvrabv eqtri syl5ss syl5com cB cr wcel cS cR wcel
        cS cz wcel cA cS vt cv cle wbr vt cz crab wss cA c0 wne vx cv vy cv cle
        wbr vy cA wral vx cA wreu wi wi cB cr wcel vw cv vv cv cle wbr vv cR
        wral vw cR crab cuni cR cS cB cr wcel vw cv vv cv cle wbr vv cR wral vw
        cR wreu vw cv vv cv cle wbr vv cR wral vw cR crab cuni cR wcel vw vv vz
        cB cR uzwo3lem.1 uzwo3lem1 vw cv vv cv cle wbr vv cR wral vw cR reucl
        syl uzwo3lem.2 syl5eqel cS cR wcel cS cz wcel cB cS cle wbr cB vt cv
        cle wbr cB cS cle wbr vt cS cz cR vt cv cS cB cle breq2 cR cB vz cv cle
        wbr vz cz crab cB vt cv cle wbr vt cz crab uzwo3lem.1 cB vz cv cle wbr
        cB vt cv cle wbr vz vt cz vz cv vt cv cB cle breq2 cbvrabv eqtri elrab2
        pm3.26bi cS cz wcel cA cS vt cv cle wbr vt cz crab wss cA c0 wne vx cv
        vy cv cle wbr vy cA wral vx cA wreu vx vy vt cA cS uzwo5OLD exp32 3syl
        syld imp32 $.
        $( [30-Nov-2004] $) $( [12-Nov-2004] $)
    $}
  $}

  ${
    $d x y u t A $.  $d z w v u t B $.
    $( Well-ordering principle:  any non-empty subset of upper integers has a
       unique least element.  This generalization of ~ uzwo2 allows the
       lower bound ` B ` to be any real number.  See also ~ nnwo and
       ~ nnwos . $)
    uzwo3 $p |- ( ( B e. RR /\ ( A C_ { z e. ZZ | B <_ z } /\ A =/= (/) ) )
                  -> E! x e. A A. y e. A x <_ y ) $=
      cB cr wcel cA cB vz cv cle wbr vz cz crab wss cA c0 wne wa wa vu cv vt cv
      cle wbr vt cA wral vu cA wreu vx cv vy cv cle wbr vy cA wral vx cA wreu
      vu vt vz vw vv cA cB cB vz cv cle wbr vz cz crab vw cv vv cv cle wbr vv
      cB vz cv cle wbr vz cz crab wral vw cB vz cv cle wbr vz cz crab crab cuni
      cB vz cv cle wbr vz cz crab eqid vw cv vv cv cle wbr vv cB vz cv cle wbr
      vz cz crab wral vw cB vz cv cle wbr vz cz crab crab cuni eqid uzwo3lem2
      vu cv vt cv cle wbr vt cA wral vu cA wreu vu cv vy cv cle wbr vy cA wral
      vu cA wreu vx cv vy cv cle wbr vy cA wral vx cA wreu vu cv vt cv cle wbr
      vt cA wral vu cv vy cv cle wbr vy cA wral vu cA vu cv vt cv cle wbr vu cv
      vy cv cle wbr vt vy cA vt cv vy cv vu cv cle breq2 cbvralv reubii vu cv
      vy cv cle wbr vy cA wral vx cv vy cv cle wbr vy cA wral vu vx cA vu cv vx
      cv wceq vu cv vy cv cle wbr vx cv vy cv cle wbr vy cA vu cv vx cv vy cv
      cle breq1 ralbidv cbvreuv bitri sylib $.
      $( [30-Nov-2004] $) $( [12-Nov-2004] $)
  $}

  ${
    $d x y z A $.
    $( There is a unique smallest integer greater than or equal to a given real
       number. $)
    zmin $p |- ( A e. RR ->
               E! x e. ZZ ( A <_ x /\ A. y e. ZZ ( A <_ y -> x <_ y ) ) ) $=
      cA cr wcel vx cv vy cv cle wbr vy cA vz cv cle wbr vz cz crab wral vx cA
      vz cv cle wbr vz cz crab wreu cA vx cv cle wbr cA vy cv cle wbr vx cv vy
      cv cle wbr wi vy cz wral wa vx cz wreu vx vy vz cA cA vz cv cle wbr vz cz
      crab cA vz cv cle wbr vz cz crab eqid uzwo3lem1 vx cv cA vz cv cle wbr vz
      cz crab wcel vx cv vy cv cle wbr vy cA vz cv cle wbr vz cz crab wral wa
      vx weu vx cv cz wcel cA vx cv cle wbr cA vy cv cle wbr vx cv vy cv cle
      wbr wi vy cz wral wa wa vx weu vx cv vy cv cle wbr vy cA vz cv cle wbr vz
      cz crab wral vx cA vz cv cle wbr vz cz crab wreu cA vx cv cle wbr cA vy
      cv cle wbr vx cv vy cv cle wbr wi vy cz wral wa vx cz wreu vx cv cA vz cv
      cle wbr vz cz crab wcel vx cv vy cv cle wbr vy cA vz cv cle wbr vz cz
      crab wral wa vx cv cz wcel cA vx cv cle wbr cA vy cv cle wbr vx cv vy cv
      cle wbr wi vy cz wral wa wa vx vx cv cA vz cv cle wbr vz cz crab wcel vx
      cv vy cv cle wbr vy cA vz cv cle wbr vz cz crab wral wa vx cv cz wcel cA
      vx cv cle wbr wa cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz wral wa vx
      cv cz wcel cA vx cv cle wbr cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz
      wral wa wa vx cv cA vz cv cle wbr vz cz crab wcel vx cv cz wcel cA vx cv
      cle wbr wa vx cv vy cv cle wbr vy cA vz cv cle wbr vz cz crab wral cA vy
      cv cle wbr vx cv vy cv cle wbr wi vy cz wral cA vz cv cle wbr cA vx cv
      cle wbr vz vx cv cz vz cv vx cv cA cle breq2 elrab vx cv vy cv cle wbr cA
      vy cv cle wbr vx cv vy cv cle wbr wi vy cA vz cv cle wbr vz cz crab cz vy
      cv cA vz cv cle wbr vz cz crab wcel vx cv vy cv cle wbr wi vy cv cz wcel
      cA vy cv cle wbr wa vx cv vy cv cle wbr wi vy cv cz wcel cA vy cv cle wbr
      vx cv vy cv cle wbr wi wi vy cv cA vz cv cle wbr vz cz crab wcel vy cv cz
      wcel cA vy cv cle wbr wa vx cv vy cv cle wbr cA vz cv cle wbr cA vy cv
      cle wbr vz vy cv cz vz cv vy cv cA cle breq2 elrab imbi1i vy cv cz wcel
      cA vy cv cle wbr vx cv vy cv cle wbr impexp bitri ralbii2 anbi12i vx cv
      cz wcel cA vx cv cle wbr cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz
      wral anass bitri eubii vx cv vy cv cle wbr vy cA vz cv cle wbr vz cz crab
      wral vx cA vz cv cle wbr vz cz crab df-reu cA vx cv cle wbr cA vy cv cle
      wbr vx cv vy cv cle wbr wi vy cz wral wa vx cz df-reu 3bitr4ri sylibr $.
      $( [1-Dec-2004] $) $( [12-Nov-2004] $)
  $}

  ${
    $d x y z w A $.
    $( There is a unique largest integer less than or equal to a given real
       number. $)
    zmax $p |- ( A e. RR ->
               E! x e. ZZ ( x <_ A /\ A. y e. ZZ ( y <_ A -> y <_ x ) ) ) $=
      cA cr wcel cA cneg vz cv cle wbr cA cneg vw cv cle wbr vz cv vw cv cle
      wbr wi vw cz wral wa vz cz wreu vx cv cA cle wbr vy cv cA cle wbr vy cv
      vx cv cle wbr wi vy cz wral wa vx cz wreu cA cr wcel cA cneg cr wcel cA
      cneg vz cv cle wbr cA cneg vw cv cle wbr vz cv vw cv cle wbr wi vw cz
      wral wa vz cz wreu cA renegcl vz vw cA cneg zmin syl cA cr wcel vx cv cA
      cle wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral wa vx cz wreu
      cA cneg vx cv cneg cle wbr cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr
      wi vw cz wral wa vx cz wreu cA cneg vz cv cle wbr cA cneg vw cv cle wbr
      vz cv vw cv cle wbr wi vw cz wral wa vz cz wreu cA cr wcel vx cv cA cle
      wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral wa cA cneg vx cv
      cneg cle wbr cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz wral
      wa vx cz cA cr wcel vx cv cz wcel wa vx cv cA cle wbr cA cneg vx cv cneg
      cle wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral cA cneg vw cv
      cle wbr vx cv cneg vw cv cle wbr wi vw cz wral vx cv cz wcel cA cr wcel
      vx cv cA cle wbr cA cneg vx cv cneg cle wbr wb vx cv cr wcel cA cr wcel
      vx cv cA cle wbr cA cneg vx cv cneg cle wbr wb vx cv cz wcel vx cv cA
      leneg vx cv zre sylan ancoms cA cr wcel vx cv cz wcel wa vy cv cA cle wbr
      vy cv vx cv cle wbr wi vy cz wral cA cneg vw cv cle wbr vx cv cneg vw cv
      cle wbr wi vw cz wral cA cr wcel vx cv cz wcel wa vy cv cA cle wbr vy cv
      vx cv cle wbr wi vy cz wral cA cneg vw cv cle wbr vx cv cneg vw cv cle
      wbr wi vw cz vw cv cz wcel vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz
      wral cA cr wcel vx cv cz wcel wa cA cneg vw cv cle wbr vx cv cneg vw cv
      cle wbr wi vw cv cz wcel vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz
      wral vw cv cneg cA cle wbr vw cv cneg vx cv cle wbr wi cA cr wcel vx cv
      cz wcel wa cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi wi vw cv cz
      wcel vw cv cneg cz wcel vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz
      wral vw cv cneg cA cle wbr vw cv cneg vx cv cle wbr wi wi vw cv znegcl vy
      cv cA cle wbr vy cv vx cv cle wbr wi vw cv cneg cA cle wbr vw cv cneg vx
      cv cle wbr wi vy vw cv cneg cz vy cv vw cv cneg wceq vy cv cA cle wbr vw
      cv cneg cA cle wbr vy cv vx cv cle wbr vw cv cneg vx cv cle wbr vy cv vw
      cv cneg cA cle breq1 vy cv vw cv cneg vx cv cle breq1 imbi12d rcla4v syl
      vw cv cz wcel cA cr wcel vx cv cz wcel wa vw cv cneg cA cle wbr vw cv
      cneg vx cv cle wbr wi cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi
      vw cv cz wcel cA cr wcel vx cv cz wcel wa vw cv cneg cA cle wbr vw cv
      cneg vx cv cle wbr wi cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi
      wi vw cv cz wcel cA cr wcel vx cv cz wcel wa wa vw cv cneg cA cle wbr vw
      cv cneg vx cv cle wbr wi cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr
      wi vw cv cr wcel cA cr wcel vx cv cz wcel wa vw cv cneg cA cle wbr vw cv
      cneg vx cv cle wbr wi cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi
      wb vw cv cz wcel vw cv cr wcel cA cr wcel vx cv cz wcel wa wa vw cv cneg
      cA cle wbr cA cneg vw cv cle wbr vw cv cneg vx cv cle wbr vx cv cneg vw
      cv cle wbr vw cv cr wcel cA cr wcel vw cv cneg cA cle wbr cA cneg vw cv
      cle wbr wb vx cv cz wcel vw cv cA lenegcon1 adantrr vw cv cr wcel vx cv
      cz wcel vw cv cneg vx cv cle wbr vx cv cneg vw cv cle wbr wb cA cr wcel
      vw cv cr wcel vx cv cr wcel vw cv cneg vx cv cle wbr vx cv cneg vw cv cle
      wbr wb vx cv cz wcel vw cv vx cv lenegcon1 vx cv zre sylan2 adantrl
      imbi12d vw cv zre sylan biimpd ex com23 syld com13 r19.21adv cA cr wcel
      vx cv cz wcel wa cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz
      wral vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz vy cv cz wcel cA cneg
      vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz wral cA cr wcel vx cv cz
      wcel wa vy cv cA cle wbr vy cv vx cv cle wbr wi vy cv cz wcel cA cneg vw
      cv cle wbr vx cv cneg vw cv cle wbr wi vw cz wral cA cneg vy cv cneg cle
      wbr vx cv cneg vy cv cneg cle wbr wi cA cr wcel vx cv cz wcel wa vy cv cA
      cle wbr vy cv vx cv cle wbr wi wi vy cv cz wcel vy cv cneg cz wcel cA
      cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz wral cA cneg vy cv
      cneg cle wbr vx cv cneg vy cv cneg cle wbr wi wi vy cv znegcl cA cneg vw
      cv cle wbr vx cv cneg vw cv cle wbr wi cA cneg vy cv cneg cle wbr vx cv
      cneg vy cv cneg cle wbr wi vw vy cv cneg cz vw cv vy cv cneg wceq cA cneg
      vw cv cle wbr cA cneg vy cv cneg cle wbr vx cv cneg vw cv cle wbr vx cv
      cneg vy cv cneg cle wbr vw cv vy cv cneg cA cneg cle breq2 vw cv vy cv
      cneg vx cv cneg cle breq2 imbi12d rcla4v syl vy cv cz wcel cA cr wcel vx
      cv cz wcel wa cA cneg vy cv cneg cle wbr vx cv cneg vy cv cneg cle wbr wi
      vy cv cA cle wbr vy cv vx cv cle wbr wi vy cv cz wcel cA cr wcel vx cv cz
      wcel wa cA cneg vy cv cneg cle wbr vx cv cneg vy cv cneg cle wbr wi vy cv
      cA cle wbr vy cv vx cv cle wbr wi wi vy cv cz wcel cA cr wcel vx cv cz
      wcel wa wa vy cv cA cle wbr vy cv vx cv cle wbr wi cA cneg vy cv cneg cle
      wbr vx cv cneg vy cv cneg cle wbr wi vy cv cr wcel cA cr wcel vx cv cz
      wcel wa vy cv cA cle wbr vy cv vx cv cle wbr wi cA cneg vy cv cneg cle
      wbr vx cv cneg vy cv cneg cle wbr wi wb vy cv cz wcel vy cv cr wcel cA cr
      wcel vx cv cz wcel wa wa vy cv cA cle wbr cA cneg vy cv cneg cle wbr vy
      cv vx cv cle wbr vx cv cneg vy cv cneg cle wbr vy cv cr wcel cA cr wcel
      vy cv cA cle wbr cA cneg vy cv cneg cle wbr wb vx cv cz wcel vy cv cA
      leneg adantrr vy cv cr wcel vx cv cz wcel vy cv vx cv cle wbr vx cv cneg
      vy cv cneg cle wbr wb cA cr wcel vy cv cr wcel vx cv cr wcel vy cv vx cv
      cle wbr vx cv cneg vy cv cneg cle wbr wb vx cv cz wcel vy cv vx cv leneg
      vx cv zre sylan2 adantrl imbi12d vy cv zre sylan biimprd ex com23 syld
      com13 r19.21adv impbid anbi12d reubidva cA cneg vz cv cle wbr cA cneg vw
      cv cle wbr vz cv vw cv cle wbr wi vw cz wral wa cA cneg vx cv cneg cle
      wbr cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz wral wa vz vx
      vx cv cneg cz vx cv znegcl vz vx vx cv cneg vz cv cneg cz vz cv znegcl vz
      cv cc wcel vx cv cc wcel vz cv vx cv cneg wceq vx cv vz cv cneg wceq wb
      vz cv cz wcel vx cv cz wcel vz cv vx cv negcon2 vz cv zcn vx cv zcn
      syl2an reuhyp vz cv vx cv cneg wceq cA cneg vz cv cle wbr cA cneg vx cv
      cneg cle wbr cA cneg vw cv cle wbr vz cv vw cv cle wbr wi vw cz wral cA
      cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz wral vz cv vx cv
      cneg cA cneg cle breq2 vz cv vx cv cneg wceq cA cneg vw cv cle wbr vz cv
      vw cv cle wbr wi cA cneg vw cv cle wbr vx cv cneg vw cv cle wbr wi vw cz
      vz cv vx cv cneg wceq vz cv vw cv cle wbr vx cv cneg vw cv cle wbr cA
      cneg vw cv cle wbr vz cv vx cv cneg vw cv cle breq1 imbi2d ralbidv
      anbi12d reuxfr syl6rbbr mpbid $.
      $( [1-Dec-2004] $) $( [15-Nov-2004] $)
  $}

  ${
    $d x y z A $.
    $( There is a unique integer between a real number and the number plus
       one.  Exercise 5 of [Apostol] p. 28. $)
    zbtwnre $p |- ( A e. RR -> E! x e. ZZ ( A <_ x /\ x < ( A + 1 ) ) ) $=
      cA cr wcel cA vx cv cle wbr cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz
      wral wa vx cz wreu cA vx cv cle wbr vx cv cA c1 caddc co clt wbr wa vx cz
      wreu vx vy cA zmin cA cr wcel cA vx cv cle wbr cA vy cv cle wbr vx cv vy
      cv cle wbr wi vy cz wral wa cA vx cv cle wbr vx cv cA c1 caddc co clt wbr
      wa vx cz cA cr wcel vx cv cz wcel wa cA vy cv cle wbr vx cv vy cv cle wbr
      wi vy cz wral vx cv cA c1 caddc co clt wbr cA vx cv cle wbr vx cv cz wcel
      cA cr wcel cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz wral vx cv cA c1
      caddc co clt wbr wb vx cv cz wcel cA cr wcel wa vx cv c1 cmin co cA clt
      wbr cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz wral vx cv cA c1 caddc
      co clt wbr vx cv cz wcel cA cr wcel wa vx cv c1 cmin co cA clt wbr cA vy
      cv cle wbr vx cv vy cv cle wbr wi vy cz wral vx cv cz wcel cA cr wcel wa
      vx cv c1 cmin co cA clt wbr cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz
      vx cv cz wcel cA cr wcel wa vy cv cz wcel vx cv c1 cmin co cA clt wbr cA
      vy cv cle wbr vx cv vy cv cle wbr wi vx cv cz wcel cA cr wcel wa vy cv cz
      wcel vx cv c1 cmin co cA clt wbr cA vy cv cle wbr vx cv vy cv cle wbr vx
      cv cz wcel cA cr wcel wa vy cv cz wcel wa vx cv c1 cmin co cA clt wbr cA
      vy cv cle wbr wa vx cv c1 cmin co vy cv clt wbr vx cv vy cv cle wbr vx cv
      cz wcel cA cr wcel wa vy cv cr wcel vx cv c1 cmin co cA clt wbr cA vy cv
      cle wbr wa vx cv c1 cmin co vy cv clt wbr wi vy cv cz wcel vx cv cz wcel
      cA cr wcel vy cv cr wcel vx cv c1 cmin co cA clt wbr cA vy cv cle wbr wa
      vx cv c1 cmin co vy cv clt wbr wi vx cv c1 cmin co cr wcel cA cr wcel vy
      cv cr wcel vx cv c1 cmin co cA clt wbr cA vy cv cle wbr wa vx cv c1 cmin
      co vy cv clt wbr wi vx cv cz wcel vx cv c1 cmin co cA vy cv ltletr vx cv
      cz wcel vx cv cr wcel vx cv c1 cmin co cr wcel vx cv zre vx cv peano2rem
      syl syl3an1 3expa vy cv zre sylan2 vx cv cz wcel vy cv cz wcel vx cv vy
      cv cle wbr vx cv c1 cmin co vy cv clt wbr wb cA cr wcel vx cv vy cv
      zlem1lt adantlr sylibrd exp4b com23 r19.21adv vx cv cz wcel cA cr wcel wa
      cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz wral vx cv c1 cmin co cA
      clt wbr vx cv cz wcel cA cr wcel wa cA vy cv cle wbr vx cv vy cv cle wbr
      wi vy cz wral wa vx cv c1 cmin co cA clt wbr vx cv vx cv c1 cmin co cle
      wbr vx cv cz wcel vx cv vx cv c1 cmin co cle wbr wn cA cr wcel cA vy cv
      cle wbr vx cv vy cv cle wbr wi vy cz wral vx cv cz wcel vx cv vx cv c1
      cmin co cle wbr vx cv c1 cmin co vx cv c1 cmin co clt wbr vx cv cz wcel
      vx cv cr wcel vx cv c1 cmin co cr wcel vx cv c1 cmin co vx cv c1 cmin co
      clt wbr wn vx cv zre vx cv peano2rem vx cv c1 cmin co ltnr 3syl vx cv cz
      wcel vx cv c1 cmin co cz wcel vx cv vx cv c1 cmin co cle wbr vx cv c1
      cmin co vx cv c1 cmin co clt wbr wb vx cv peano2zm vx cv vx cv c1 cmin co
      zlem1lt mpdan mtbird ad2antrr vx cv cz wcel cA cr wcel wa cA vy cv cle
      wbr vx cv vy cv cle wbr wi vy cz wral wa vx cv c1 cmin co cA clt wbr wn
      cA vx cv c1 cmin co cle wbr vx cv vx cv c1 cmin co cle wbr vx cv cz wcel
      cA cr wcel wa cA vx cv c1 cmin co cle wbr vx cv c1 cmin co cA clt wbr wn
      wb cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz wral cA cr wcel vx cv cz
      wcel cA vx cv c1 cmin co cle wbr vx cv c1 cmin co cA clt wbr wn wb cA cr
      wcel vx cv c1 cmin co cr wcel cA vx cv c1 cmin co cle wbr vx cv c1 cmin
      co cA clt wbr wn wb vx cv cz wcel cA vx cv c1 cmin co lenlt vx cv cz wcel
      vx cv cr wcel vx cv c1 cmin co cr wcel vx cv zre vx cv peano2rem syl
      sylan2 ancoms adantr vx cv cz wcel cA vy cv cle wbr vx cv vy cv cle wbr
      wi vy cz wral cA vx cv c1 cmin co cle wbr vx cv vx cv c1 cmin co cle wbr
      wi cA cr wcel vx cv cz wcel cA vy cv cle wbr vx cv vy cv cle wbr wi vy cz
      wral cA vx cv c1 cmin co cle wbr vx cv vx cv c1 cmin co cle wbr wi vx cv
      cz wcel vx cv c1 cmin co cz wcel cA vy cv cle wbr vx cv vy cv cle wbr wi
      vy cz wral cA vx cv c1 cmin co cle wbr vx cv vx cv c1 cmin co cle wbr wi
      wi vx cv peano2zm cA vy cv cle wbr vx cv vy cv cle wbr wi cA vx cv c1
      cmin co cle wbr vx cv vx cv c1 cmin co cle wbr wi vy vx cv c1 cmin co cz
      vy cv vx cv c1 cmin co wceq cA vy cv cle wbr cA vx cv c1 cmin co cle wbr
      vx cv vy cv cle wbr vx cv vx cv c1 cmin co cle wbr vy cv vx cv c1 cmin co
      cA cle breq2 vy cv vx cv c1 cmin co vx cv cle breq2 imbi12d rcla4v syl
      imp adantlr sylbird mt3d ex impbid vx cv cr wcel cA cr wcel vx cv c1 cmin
      co cA clt wbr vx cv cA c1 caddc co clt wbr wb vx cv cz wcel vx cv cr wcel
      c1 cr wcel cA cr wcel vx cv c1 cmin co cA clt wbr vx cv cA c1 caddc co
      clt wbr wb 1re vx cv c1 cA ltsubadd mp3an2 vx cv zre sylan bitr3d ancoms
      anbi2d reubidva mpbid $.
      $( [4-Dec-2004] $) $( [13-Nov-2004] $)
  $}

  ${
    $d x y z A $.
    $( There is a unique greatest integer less than or equal to a real number.
       Exercise 4 of [Apostol] p. 28. $)
    rebtwnz $p |- ( A e. RR -> E! x e. ZZ ( x <_ A /\ A < ( x + 1 ) ) ) $=
      cA cr wcel cA cneg vy cv cle wbr vy cv cA cneg c1 caddc co clt wbr wa vy
      cz wreu vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz wreu cA cr
      wcel cA cneg cr wcel cA cneg vy cv cle wbr vy cv cA cneg c1 caddc co clt
      wbr wa vy cz wreu cA renegcl vy cA cneg zbtwnre syl cA cr wcel cA cneg vx
      cv cneg cle wbr vx cv cneg cA cneg c1 caddc co clt wbr wa vx cz wreu vx
      cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz wreu cA cneg vy cv
      cle wbr vy cv cA cneg c1 caddc co clt wbr wa vy cz wreu cA cr wcel cA
      cneg vx cv cneg cle wbr vx cv cneg cA cneg c1 caddc co clt wbr wa vx cv
      cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz cA cr wcel vx cv cz wcel
      wa vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa cA cneg vx cv cneg
      cle wbr vx cv cneg cA cneg c1 caddc co clt wbr wa cA cr wcel vx cv cr
      wcel vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa cA cneg vx cv cneg
      cle wbr vx cv cneg cA cneg c1 caddc co clt wbr wa wb vx cv cz wcel cA cr
      wcel vx cv cr wcel wa vx cv cA cle wbr cA cneg vx cv cneg cle wbr cA vx
      cv c1 caddc co clt wbr vx cv cneg cA cneg c1 caddc co clt wbr vx cv cr
      wcel cA cr wcel vx cv cA cle wbr cA cneg vx cv cneg cle wbr wb vx cv cA
      leneg ancoms cA cr wcel vx cv cr wcel wa cA c1 cmin co vx cv clt wbr vx
      cv cneg cA c1 cmin co cneg clt wbr cA vx cv c1 caddc co clt wbr vx cv
      cneg cA cneg c1 caddc co clt wbr cA c1 cmin co cr wcel vx cv cr wcel cA
      c1 cmin co vx cv clt wbr vx cv cneg cA c1 cmin co cneg clt wbr wb cA cr
      wcel cA c1 cmin co vx cv ltneg cA peano2rem sylan cA cr wcel c1 cr wcel
      vx cv cr wcel cA c1 cmin co vx cv clt wbr cA vx cv c1 caddc co clt wbr wb
      1re cA c1 vx cv ltsubadd mp3an2 cA cr wcel vx cv cr wcel wa cA c1 cmin co
      cneg cA cneg c1 caddc co vx cv cneg clt cA cr wcel cA c1 cmin co cneg cA
      cneg c1 caddc co wceq vx cv cr wcel cA cc wcel c1 cc wcel cA c1 cmin co
      cneg cA cneg c1 caddc co wceq cA cr wcel cA c1 negsubdi cA recn ax1cn
      sylancl adantr breq2d 3bitr3d anbi12d vx cv zre sylan2 bicomd reubidva cA
      cneg vy cv cle wbr vy cv cA cneg c1 caddc co clt wbr wa cA cneg vx cv
      cneg cle wbr vx cv cneg cA cneg c1 caddc co clt wbr wa vy vx vx cv cneg
      cz vx cv znegcl vy vx vx cv cneg vy cv cneg cz vy cv znegcl vy cv cc wcel
      vx cv cc wcel vy cv vx cv cneg wceq vx cv vy cv cneg wceq wb vy cv cz
      wcel vx cv cz wcel vy cv vx cv negcon2 vy cv zcn vx cv zcn syl2an reuhyp
      vy cv vx cv cneg wceq cA cneg vy cv cle wbr cA cneg vx cv cneg cle wbr vy
      cv cA cneg c1 caddc co clt wbr vx cv cneg cA cneg c1 caddc co clt wbr vy
      cv vx cv cneg cA cneg cle breq2 vy cv vx cv cneg cA cneg c1 caddc co clt
      breq1 anbi12d reuxfr syl5bb mpbid $.
      $( [6-Dec-2004] $) $( [15-Nov-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Rational numbers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d m n x $.
    $( Define the set of rational numbers.  Definition of rationals in
       [Apostol] p. 22. $)
    df-q $a |- QQ = { x | E. m e. ZZ E. n e. NN x = ( m / n ) } $.
  $}

  ${
    $d x y z A $.
    $( Membership in the set of rationals. $)
    elq $p |- ( A e. QQ <-> E. x e. ZZ E. y e. NN A = ( x / y ) ) $=
      cA cq wcel cA vz cv vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex vz cab
      wcel cA vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cq vz cv vx cv vy
      cv cdiv co wceq vy cn wrex vx cz wrex vz cab cA vz vx vy df-q eleq2i vz
      cv vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cA vx cv vy cv cdiv co
      wceq vy cn wrex vx cz wrex vz cA cA vx cv vy cv cdiv co wceq vy cn wrex
      cA cvv wcel vx cz cA vx cv vy cv cdiv co wceq vy cn wrex cA cvv wcel wi
      vx cv cz wcel cA vx cv vy cv cdiv co wceq cA cvv wcel vy cn cA vx cv vy
      cv cdiv co wceq cA cvv wcel wi vy cv cn wcel cA vx cv vy cv cdiv co wceq
      cA cvv wcel vx cv vy cv cdiv co cvv wcel vx cv vy cv cdiv oprex cA vx cv
      vy cv cdiv co cvv eleq1 mpbiri a1i r19.23aiv a1i r19.23aiv vz cv cA wceq
      vz cv vx cv vy cv cdiv co wceq cA vx cv vy cv cdiv co wceq vx vy cz cn vz
      cv cA vx cv vy cv cdiv co eqeq1 2rexbidv elab3 bitri $.
      $( [8-Jan-2002] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The ratio of an integer and a natural number is a rational number. $)
    znq $p |- ( ( A e. ZZ /\ B e. NN ) -> ( A / B ) e. QQ ) $=
      cA cz wcel cB cn wcel wa cA cB cdiv co vx cv vy cv cdiv co wceq vy cn
      wrex vx cz wrex cA cB cdiv co cq wcel cA cz wcel cB cn wcel cA cB cdiv co
      cA cB cdiv co wceq cA cB cdiv co vx cv vy cv cdiv co wceq vy cn wrex vx
      cz wrex cA cB cdiv co eqid vx vy cz cn cA cB cA cB cdiv co cdiv rcla4eopr
      mp3an3 vx vy cA cB cdiv co elq sylibr $.
      $( [12-Jan-2002] $)
  $}

  ${
    $d x y A $.
    $( A rational number is a real number. $)
    qre $p |- ( A e. QQ -> A e. RR ) $=
      cA cq wcel cA vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cA cr wcel
      vx vy cA elq cA vx cv vy cv cdiv co wceq cA cr wcel vx vy cz cn cA vx cv
      vy cv cdiv co wceq cA cr wcel vx cv vy cv cdiv co cr wcel vx cv cz wcel
      vy cv cn wcel wa cA vx cv vy cv cdiv co cr eleq1 vx cv cr wcel vy cv cr
      wcel vy cv cc0 wne wa vx cv vy cv cdiv co cr wcel vx cv cz wcel vy cv cn
      wcel vx cv cr wcel vy cv cr wcel vy cv cc0 wne vx cv vy cv cdiv co cr
      wcel vx cv vy cv redivcl 3expb vx cv zre vy cv cn wcel vy cv cr wcel vy
      cv cc0 wne vy cv nnre vy cv nnne0 jca syl2an syl5cbir r19.23aivv sylbi $.
      $( [14-Nov-2002] $)

    $( An integer is a rational number. $)
    zq $p |- ( A e. ZZ -> A e. QQ ) $=
      vx cv cA wceq vx cz wrex cA vx cv vy cv cdiv co wceq vy cn wrex vx cz
      wrex cA cz wcel cA cq wcel vx cv cA wceq cA vx cv vy cv cdiv co wceq vy
      cn wrex vx cz vx cv cz wcel vx cv cA wceq cA vx cv c1 cdiv co wceq cA vx
      cv vy cv cdiv co wceq vy cn wrex vx cv cz wcel cA vx cv c1 cdiv co wceq
      cA vx cv wceq vx cv cA wceq vx cv cz wcel vx cv c1 cdiv co vx cv cA vx cv
      cz wcel vx cv cr wcel vx cv cc wcel vx cv c1 cdiv co vx cv wceq vx cv zre
      vx cv recn vx cv div1 3syl eqeq2d vx cv cA eqcom syl6rbbr c1 cn wcel cA
      vx cv c1 cdiv co wceq cA vx cv vy cv cdiv co wceq vy cn wrex 1nn cA vx cv
      vy cv cdiv co wceq cA vx cv c1 cdiv co wceq vy c1 cn vy cv c1 wceq vx cv
      vy cv cdiv co vx cv c1 cdiv co cA vy cv c1 vx cv cdiv opreq2 eqeq2d
      rcla4ev mpan syl6bi r19.22i vx cA cz risset vx vy cA elq 3imtr4i $.
      $( [9-Jan-2002] $)
  $}

  $( The integers are a subset of the rationals. $)
  zssq $p |- ZZ C_ QQ $=
    vx cz cq vx cv zq ssriv $.
    $( [9-Jan-2002] $)

  $( The nonnegative integers are a subset of the rationals. $)
  nn0ssq $p |- NN0 C_ QQ $=
    cn0 cz cq nn0ssz zssq sstri $.
    $( [15-Sep-2004] $) $( [31-Jul-2004] $)

  $( The natural numbers are a subset of the rationals. $)
  nnssq $p |- NN C_ QQ $=
    cn cz cq nnssz zssq sstri $.
    $( [21-Sep-2004] $) $( [31-Jul-2004] $)

  $( The rationals are a subset of the reals. $)
  qssre $p |- QQ C_ RR $=
    vx cq cr vx cv qre ssriv $.
    $( [9-Jan-2002] $)

  $( The rationals are a subset of the complex numbers. $)
  qsscn $p |- QQ C_ CC $=
    cq cr cc qssre axresscn sstri $.
    $( [21-Sep-2004] $) $( [2-Aug-2004] $)

  $( A natural number is rational. $)
  nnq $p |- ( A e. NN -> A e. QQ ) $=
    cn cq cA nnssq sseli $.
    $( [10-Dec-2004] $) $( [17-Nov-2004] $)

  $( A rational number is a complex number. $)
  qcn $p |- ( A e. QQ -> A e. CC ) $=
    cq cc cA qsscn sseli $.
    $( [25-Sep-2004] $) $( [2-Aug-2004] $)

  $( The set of rational numbers exists. $)
  qex $p |- QQ e. _V $=
    cq cr reex qssre ssexi $.
    $( [25-Sep-2004] $) $( [30-Jul-2004] $)

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    $( Closure of addition of rationals. $)
    qaddcl $p |- ( ( A e. QQ /\ B e. QQ ) -> ( A + B ) e. QQ ) $=
      cA vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cB vz cv vw cv cdiv co
      wceq vw cn wrex vz cz wrex cA cB caddc co cq wcel cA cq wcel cB cq wcel
      cA vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cB vz cv vw cv cdiv co
      wceq vw cn wrex vz cz wrex cA cB caddc co cq wcel cA vx cv vy cv cdiv co
      wceq vy cn wrex vx cz wrex cB vz cv vw cv cdiv co wceq cA cB caddc co cq
      wcel vz vw cz cn cA vx cv vy cv cdiv co wceq vz cv cz wcel vw cv cn wcel
      wa cB vz cv vw cv cdiv co wceq cA cB caddc co cq wcel wi wi vx vy cz cn
      vx cv cz wcel vy cv cn wcel wa cA vx cv vy cv cdiv co wceq vz cv cz wcel
      vw cv cn wcel wa cB vz cv vw cv cdiv co wceq cA cB caddc co cq wcel vx cv
      cz wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa cA vx cv vy cv
      cdiv co wceq cB vz cv vw cv cdiv co wceq cA cB caddc co cq wcel vx cv vw
      cv cmul co vy cv vz cv cmul co caddc co cz wcel vy cv vw cv cmul co cn
      wcel cA cB caddc co vx cv vw cv cmul co vy cv vz cv cmul co caddc co vy
      cv vw cv cmul co cdiv co wceq cA cB caddc co cq wcel vx cv cz wcel vy cv
      cn wcel wa vz cv cz wcel vw cv cn wcel wa wa cA vx cv vy cv cdiv co wceq
      cB vz cv vw cv cdiv co wceq wa wa vx cv vw cv cmul co vy cv vz cv cmul co
      caddc co cz wcel vy cv vw cv cmul co cn wcel cA cB caddc co vx cv vw cv
      cmul co vy cv vz cv cmul co caddc co vy cv vw cv cmul co cdiv co wceq w3a
      cA cB caddc co vu cv vv cv cdiv co wceq vv cn wrex vu cz wrex cA cB caddc
      co cq wcel vu vv cz cn vx cv vw cv cmul co vy cv vz cv cmul co caddc co
      vy cv vw cv cmul co cA cB caddc co cdiv rcla4eopr vu vv cA cB caddc co
      elq sylibr vx cv cz wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa
      wa vx cv vw cv cmul co vy cv vz cv cmul co caddc co cz wcel cA vx cv vy
      cv cdiv co wceq cB vz cv vw cv cdiv co wceq wa vx cv vw cv cmul co cz
      wcel vy cv vz cv cmul co cz wcel vx cv vw cv cmul co vy cv vz cv cmul co
      caddc co cz wcel vx cv cz wcel vy cv cn wcel wa vz cv cz wcel vw cv cn
      wcel wa wa vx cv vw cv cmul co vy cv vz cv cmul co zaddcl vx cv cz wcel
      vw cv cn wcel vx cv vw cv cmul co cz wcel vy cv cn wcel vz cv cz wcel vx
      cv cz wcel vw cv cz wcel vx cv vw cv cmul co cz wcel vw cv cn wcel vx cv
      vw cv zmulcl vw cv nnz sylan2 ad2ant2rl vy cv cn wcel vz cv cz wcel vy cv
      vz cv cmul co cz wcel vx cv cz wcel vw cv cn wcel vy cv cz wcel vz cv cz
      wcel vy cv vz cv cmul co cz wcel vy cv cn wcel vy cv vz cv zmulcl vy cv
      nnz sylan ad2ant2lr sylanc adantr vx cv cz wcel vy cv cn wcel wa vz cv cz
      wcel vw cv cn wcel wa wa vy cv vw cv cmul co cn wcel cA vx cv vy cv cdiv
      co wceq cB vz cv vw cv cdiv co wceq wa vy cv cn wcel vw cv cn wcel vy cv
      vw cv cmul co cn wcel vx cv cz wcel vz cv cz wcel vy cv vw cv nnmulcl
      ad2ant2l adantr cA vx cv vy cv cdiv co wceq cB vz cv vw cv cdiv co wceq
      wa vx cv cz wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa wa cA cB
      caddc co vx cv vy cv cdiv co vz cv vw cv cdiv co caddc co vx cv vw cv
      cmul co vy cv vz cv cmul co caddc co vy cv vw cv cmul co cdiv co cA vx cv
      vy cv cdiv co cB vz cv vw cv cdiv co caddc opreq12 vx cv cz wcel vz cv cz
      wcel vy cv cn wcel vw cv cn wcel vx cv vy cv cdiv co vz cv vw cv cdiv co
      caddc co vx cv vw cv cmul co vy cv vz cv cmul co caddc co vy cv vw cv
      cmul co cdiv co wceq vx cv cc wcel vz cv cc wcel wa vy cv cc wcel vy cv
      cc0 wne wa vw cv cc wcel vw cv cc0 wne wa wa vx cv vy cv cdiv co vz cv vw
      cv cdiv co caddc co vx cv vw cv cmul co vy cv vz cv cmul co caddc co vy
      cv vw cv cmul co cdiv co wceq vx cv cz wcel vz cv cz wcel wa vy cv cn
      wcel vw cv cn wcel wa vx cv vz cv vy cv vw cv divadddiv vx cv cz wcel vx
      cv cc wcel vz cv cz wcel vz cv cc wcel vx cv zcn vz cv zcn anim12i vy cv
      cn wcel vy cv cc wcel vy cv cc0 wne wa vw cv cn wcel vw cv cc wcel vw cv
      cc0 wne wa vy cv cn wcel vy cv cc wcel vy cv cc0 wne vy cv nncn vy cv
      nnne0 jca vw cv cn wcel vw cv cc wcel vw cv cc0 wne vw cv nncn vw cv
      nnne0 jca anim12i syl2an an4s sylan9eqr syl3anc an4s exp43 r19.23aivv
      r19.23advv imp vx vy cA elq vz vw cB elq syl2anb $.
      $( [16-Sep-2004] $) $( [1-Aug-2004] $)

    $( Closure law for the negative of a rational. $)
    qnegcl $p |- ( A e. QQ -> -u A e. QQ ) $=
      cA cq wcel cA vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cA cneg cq
      wcel vx vy cA elq cA vx cv vy cv cdiv co wceq cA cneg cq wcel vx vy cz cn
      vx cv cz wcel vy cv cn wcel wa cA vx cv vy cv cdiv co wceq vx cv cneg cz
      wcel vy cv cn wcel wa cA cneg vx cv cneg vy cv cdiv co wceq wa cA cneg cq
      wcel vx cv cz wcel vy cv cn wcel wa cA vx cv vy cv cdiv co wceq cA cneg
      vx cv cneg vy cv cdiv co wceq vx cv cneg cz wcel vy cv cn wcel wa vx cv
      cz wcel vy cv cn wcel wa cA cneg vx cv vy cv cdiv co cneg wceq cA cneg vx
      cv cneg vy cv cdiv co wceq cA vx cv vy cv cdiv co wceq vx cv cz wcel vy
      cv cn wcel wa vx cv vy cv cdiv co cneg vx cv cneg vy cv cdiv co cA cneg
      vx cv cc wcel vy cv cc wcel vy cv cc0 wne wa vx cv vy cv cdiv co cneg vx
      cv cneg vy cv cdiv co wceq vx cv cz wcel vy cv cn wcel vx cv cc wcel vy
      cv cc wcel vy cv cc0 wne vx cv vy cv cdiv co cneg vx cv cneg vy cv cdiv
      co wceq vx cv vy cv divneg 3expb vx cv zcn vy cv cn wcel vy cv cc wcel vy
      cv cc0 wne vy cv nncn vy cv nnne0 jca syl2an eqeq2d cA vx cv vy cv cdiv
      co negeq syl5bi vx cv cz wcel vx cv cneg cz wcel vy cv cn wcel vx cv
      znegcl anim1i jctild vx cv cneg cz wcel vy cv cn wcel wa cA cneg vx cv
      cneg vy cv cdiv co wceq wa cA cneg vz cv vw cv cdiv co wceq vw cn wrex vz
      cz wrex cA cneg cq wcel vx cv cneg cz wcel vy cv cn wcel cA cneg vx cv
      cneg vy cv cdiv co wceq cA cneg vz cv vw cv cdiv co wceq vw cn wrex vz cz
      wrex vz vw cz cn vx cv cneg vy cv cA cneg cdiv rcla4eopr 3expa vz vw cA
      cneg elq sylibr syl6 r19.23aivv sylbi $.
      $( [17-Sep-2004] $) $( [2-Aug-2004] $)

    $( Closure of multiplication of rationals. $)
    qmulcl $p |- ( ( A e. QQ /\ B e. QQ ) -> ( A x. B ) e. QQ ) $=
      cA vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cB vz cv vw cv cdiv co
      wceq vw cn wrex vz cz wrex cA cB cmul co cq wcel cA cq wcel cB cq wcel cA
      vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex cB vz cv vw cv cdiv co
      wceq vw cn wrex vz cz wrex cA cB cmul co cq wcel cA vx cv vy cv cdiv co
      wceq vy cn wrex vx cz wrex cB vz cv vw cv cdiv co wceq cA cB cmul co cq
      wcel vz vw cz cn cA vx cv vy cv cdiv co wceq vz cv cz wcel vw cv cn wcel
      wa cB vz cv vw cv cdiv co wceq cA cB cmul co cq wcel wi wi vx vy cz cn vx
      cv cz wcel vy cv cn wcel wa cA vx cv vy cv cdiv co wceq vz cv cz wcel vw
      cv cn wcel wa cB vz cv vw cv cdiv co wceq cA cB cmul co cq wcel vx cv cz
      wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa cA vx cv vy cv cdiv
      co wceq cB vz cv vw cv cdiv co wceq cA cB cmul co cq wcel vx cv vz cv
      cmul co cz wcel vy cv vw cv cmul co cn wcel wa cA cB cmul co vx cv vz cv
      cmul co vy cv vw cv cmul co cdiv co wceq cA cB cmul co cq wcel vx cv cz
      wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa wa cA vx cv vy cv
      cdiv co wceq cB vz cv vw cv cdiv co wceq wa wa vx cv vz cv cmul co cz
      wcel vy cv vw cv cmul co cn wcel wa cA cB cmul co vx cv vz cv cmul co vy
      cv vw cv cmul co cdiv co wceq wa cA cB cmul co vv cv vu cv cdiv co wceq
      vu cn wrex vv cz wrex cA cB cmul co cq wcel vx cv vz cv cmul co cz wcel
      vy cv vw cv cmul co cn wcel cA cB cmul co vx cv vz cv cmul co vy cv vw cv
      cmul co cdiv co wceq cA cB cmul co vv cv vu cv cdiv co wceq vu cn wrex vv
      cz wrex vv vu cz cn vx cv vz cv cmul co vy cv vw cv cmul co cA cB cmul co
      cdiv rcla4eopr 3expa vv vu cA cB cmul co elq sylibr vx cv cz wcel vy cv
      cn wcel wa vz cv cz wcel vw cv cn wcel wa wa vx cv vz cv cmul co cz wcel
      vy cv vw cv cmul co cn wcel wa cA vx cv vy cv cdiv co wceq cB vz cv vw cv
      cdiv co wceq wa vx cv cz wcel vz cv cz wcel vy cv cn wcel vw cv cn wcel
      vx cv vz cv cmul co cz wcel vy cv vw cv cmul co cn wcel wa vx cv cz wcel
      vz cv cz wcel wa vx cv vz cv cmul co cz wcel vy cv cn wcel vw cv cn wcel
      wa vy cv vw cv cmul co cn wcel vx cv vz cv zmulcl vy cv vw cv nnmulcl
      anim12i an4s adantr cA vx cv vy cv cdiv co wceq cB vz cv vw cv cdiv co
      wceq wa vx cv cz wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa wa
      cA cB cmul co vx cv vy cv cdiv co vz cv vw cv cdiv co cmul co vx cv vz cv
      cmul co vy cv vw cv cmul co cdiv co cA vx cv vy cv cdiv co cB vz cv vw cv
      cdiv co cmul opreq12 vx cv cc wcel vz cv cc wcel wa vy cv cc wcel vy cv
      cc0 wne wa vw cv cc wcel vw cv cc0 wne wa wa vx cv vy cv cdiv co vz cv vw
      cv cdiv co cmul co vx cv vz cv cmul co vy cv vw cv cmul co cdiv co wceq
      vx cv cz wcel vy cv cn wcel wa vz cv cz wcel vw cv cn wcel wa wa vx cv vz
      cv vy cv vw cv divmuldiv vx cv cz wcel vz cv cz wcel vx cv cc wcel vz cv
      cc wcel wa vy cv cn wcel vw cv cn wcel vx cv cz wcel vx cv cc wcel vz cv
      cz wcel vz cv cc wcel vx cv zcn vz cv zcn anim12i ad2ant2r vy cv cn wcel
      vw cv cn wcel vy cv cc wcel vy cv cc0 wne wa vw cv cc wcel vw cv cc0 wne
      wa wa vx cv cz wcel vz cv cz wcel vy cv cn wcel vy cv cc wcel vy cv cc0
      wne wa vw cv cn wcel vw cv cc wcel vw cv cc0 wne wa vy cv cn wcel vy cv
      cc wcel vy cv cc0 wne vy cv nncn vy cv nnne0 jca vw cv cn wcel vw cv cc
      wcel vw cv cc0 wne vw cv nncn vw cv nnne0 jca anim12i ad2ant2l sylanc
      sylan9eqr sylanc an4s exp43 r19.23aivv r19.23advv imp vx vy cA elq vz vw
      cB elq syl2anb $.
      $( [25-Sep-2004] $) $( [1-Aug-2004] $)
  $}

  $( Closure of subtraction of rationals. $)
  qsubcl $p |- ( ( A e. QQ /\ B e. QQ ) -> ( A - B ) e. QQ ) $=
    cA cq wcel cB cq wcel wa cA cB cneg caddc co cA cB cmin co cq cA cc wcel cB
    cc wcel cA cB cneg caddc co cA cB cmin co wceq cA cq wcel cB cq wcel cA cB
    negsub cA qcn cB qcn syl2an cA cq wcel cB cneg cq wcel cA cB cneg caddc co
    cq wcel cB cq wcel cA cB cneg qaddcl cB qnegcl sylan2 eqeltrrd $.
    $( [2-Aug-2006] $) $( [2-Aug-2004] $)

  ${
    $d x y z w A $.
    $( Closure of reciprocal of rationals. $)
    qreccl $p |- ( ( A e. QQ /\ A =/= 0 ) -> ( 1 / A ) e. QQ ) $=
      cA cq wcel cA cc0 wne c1 cA cdiv co cq wcel cA cq wcel cA vx cv vy cv
      cdiv co wceq vy cn wrex vx cz wrex cA cc0 wne c1 cA cdiv co cq wcel wi vx
      vy cA elq cA vx cv vy cv cdiv co wceq cA cc0 wne c1 cA cdiv co cq wcel wi
      vx vy cz cn vx cv cz wcel vy cv cn wcel wa cA vx cv vy cv cdiv co wceq cA
      cc0 wne vx cv vy cv cmul co cz wcel vx cv vx cv cmul co cn wcel wa c1 cA
      cdiv co vx cv vy cv cmul co vx cv vx cv cmul co cdiv co wceq wa c1 cA
      cdiv co cq wcel vx cv cz wcel vy cv cn wcel vy cv cc0 wne wa cA vx cv vy
      cv cdiv co wceq cA cc0 wne vx cv vy cv cmul co cz wcel vx cv vx cv cmul
      co cn wcel wa c1 cA cdiv co vx cv vy cv cmul co vx cv vx cv cmul co cdiv
      co wceq wa wi wi vy cv cn wcel vx cv cz wcel vy cv cn wcel vy cv cc0 wne
      cA vx cv vy cv cdiv co wceq cA cc0 wne vx cv vy cv cmul co cz wcel vx cv
      vx cv cmul co cn wcel wa c1 cA cdiv co vx cv vy cv cmul co vx cv vx cv
      cmul co cdiv co wceq wa wi wi vx cv cz wcel vy cv cn wcel wa vy cv cc0
      wne wa cA vx cv vy cv cdiv co wceq cA cc0 wne vx cv vy cv cmul co cz wcel
      vx cv vx cv cmul co cn wcel wa c1 cA cdiv co vx cv vy cv cmul co vx cv vx
      cv cmul co cdiv co wceq wa wi vx cv cz wcel vy cv cn wcel wa vy cv cc0
      wne wa cA vx cv vy cv cdiv co wceq wa cA cc0 wne vx cv cc0 wne vx cv vy
      cv cmul co cz wcel vx cv vx cv cmul co cn wcel wa c1 cA cdiv co vx cv vy
      cv cmul co vx cv vx cv cmul co cdiv co wceq wa cA vx cv vy cv cdiv co
      wceq cA cc0 wne vx cv vy cv cdiv co cc0 wne vx cv cz wcel vy cv cn wcel
      wa vy cv cc0 wne wa vx cv cc0 wne cA vx cv vy cv cdiv co cc0 neeq1 vx cv
      cz wcel vy cv cn wcel wa vy cv cc0 wne wa vx cv cc0 wne vx cv vy cv cdiv
      co cc0 wne vx cv cc wcel vy cv cc wcel wa vy cv cc0 wne vx cv cc0 wne vx
      cv vy cv cdiv co cc0 wne wb vx cv cz wcel vy cv cn wcel wa vx cv cc wcel
      vy cv cc wcel vy cv cc0 wne vx cv cc0 wne vx cv vy cv cdiv co cc0 wne wb
      vx cv vy cv divne0b 3expa vx cv cz wcel vx cv cc wcel vy cv cn wcel vy cv
      cc wcel vx cv zcn vy cv nncn anim12i sylan bicomd sylan9bbr vx cv cz wcel
      vy cv cn wcel wa vy cv cc0 wne wa cA vx cv vy cv cdiv co wceq wa vx cv
      cc0 wne vx cv vy cv cmul co cz wcel vx cv vx cv cmul co cn wcel wa c1 cA
      cdiv co vx cv vy cv cmul co vx cv vx cv cmul co cdiv co wceq wa vx cv cz
      wcel vy cv cn wcel wa vy cv cc0 wne wa cA vx cv vy cv cdiv co wceq wa vx
      cv cc0 wne wa vx cv vy cv cmul co cz wcel vx cv vx cv cmul co cn wcel wa
      c1 cA cdiv co vx cv vy cv cmul co vx cv vx cv cmul co cdiv co wceq vx cv
      cz wcel vy cv cn wcel wa vy cv cc0 wne wa vx cv cc0 wne vx cv vy cv cmul
      co cz wcel vx cv vx cv cmul co cn wcel wa cA vx cv vy cv cdiv co wceq vx
      cv cz wcel vy cv cn wcel wa vx cv cc0 wne vx cv vy cv cmul co cz wcel vx
      cv vx cv cmul co cn wcel wa vy cv cc0 wne vx cv cz wcel vy cv cn wcel wa
      vx cv cc0 wne wa vx cv vy cv cmul co cz wcel vx cv vx cv cmul co cn wcel
      vx cv cz wcel vy cv cn wcel wa vx cv vy cv cmul co cz wcel vx cv cc0 wne
      vx cv cz wcel vy cv cz wcel vx cv vy cv cmul co cz wcel vy cv cn wcel vx
      cv vy cv zmulcl vy cv nnz sylan2 adantr vx cv cz wcel vx cv cc0 wne vx cv
      vx cv cmul co cn wcel vy cv cn wcel vx cv msqznn adantlr jca adantlr
      adantlr vx cv cz wcel vy cv cn wcel wa vy cv cc0 wne wa vx cv cc0 wne cA
      vx cv vy cv cdiv co wceq c1 cA cdiv co vx cv vy cv cmul co vx cv vx cv
      cmul co cdiv co wceq cA vx cv vy cv cdiv co wceq vx cv cz wcel vy cv cn
      wcel wa vy cv cc0 wne wa vx cv cc0 wne wa c1 cA cdiv co c1 vx cv vy cv
      cdiv co cdiv co vx cv vy cv cmul co vx cv vx cv cmul co cdiv co cA vx cv
      vy cv cdiv co c1 cdiv opreq2 vx cv cz wcel vy cv cn wcel wa vy cv cc0 wne
      vx cv cc0 wne c1 vx cv vy cv cdiv co cdiv co vx cv vy cv cmul co vx cv vx
      cv cmul co cdiv co wceq vx cv cz wcel vy cv cn wcel wa vx cv cc0 wne vy
      cv cc0 wne c1 vx cv vy cv cdiv co cdiv co vx cv vy cv cmul co vx cv vx cv
      cmul co cdiv co wceq vx cv cc wcel vy cv cc wcel wa vx cv cc0 wne vy cv
      cc0 wne wa c1 vx cv vy cv cdiv co cdiv co vx cv vy cv cmul co vx cv vx cv
      cmul co cdiv co wceq vx cv cz wcel vy cv cn wcel wa vx cv cc wcel vx cv
      cc0 wne vy cv cc wcel vy cv cc0 wne c1 vx cv vy cv cdiv co cdiv co vx cv
      vy cv cmul co vx cv vx cv cmul co cdiv co wceq vx cv cc wcel vx cv cc0
      wne wa vy cv cc wcel vy cv cc0 wne wa wa vx cv vx cv cdiv co vx cv vy cv
      cdiv co cdiv co c1 vx cv vy cv cdiv co cdiv co vx cv vy cv cmul co vx cv
      vx cv cmul co cdiv co vx cv cc wcel vx cv cc0 wne wa vy cv cc wcel vy cv
      cc0 wne wa wa vx cv vx cv cdiv co c1 vx cv vy cv cdiv co cdiv vx cv cc
      wcel vx cv cc0 wne wa vx cv vx cv cdiv co c1 wceq vy cv cc wcel vy cv cc0
      wne wa vx cv divid adantr opreq1d vx cv cc wcel vx cv cc wcel vx cv cc0
      wne wa vx cv cc wcel vx cv cc0 wne wa vy cv cc wcel vy cv cc0 wne wa vx
      cv vx cv cdiv co vx cv vy cv cdiv co cdiv co vx cv vy cv cmul co vx cv vx
      cv cmul co cdiv co wceq vx cv cc wcel vx cv cc0 wne wa vy cv cc wcel vy
      cv cc0 wne wa wa vx cv vx cv vx cv vy cv divdivdiv vx cv cc wcel vx cv
      cc0 wne vy cv cc wcel vy cv cc0 wne wa simpll vx cv cc wcel vx cv cc0 wne
      wa vy cv cc wcel vy cv cc0 wne wa pm3.26 vx cv cc wcel vx cv cc0 wne wa
      vy cv cc wcel vy cv cc0 wne wa pm3.26 vx cv cc wcel vx cv cc0 wne wa vy
      cv cc wcel vy cv cc0 wne wa pm3.27 syl2anc eqtr3d an4s vx cv cz wcel vx
      cv cc wcel vy cv cn wcel vy cv cc wcel vx cv zcn vy cv nncn anim12i sylan
      ancom2s anassrs sylan9eqr an1rs jca ex sylbid ex anasss vy cv cn wcel vy
      cv cc0 wne vy cv nnne0 ancli sylan2 vx cv vy cv cmul co cz wcel vx cv vx
      cv cmul co cn wcel wa c1 cA cdiv co vx cv vy cv cmul co vx cv vx cv cmul
      co cdiv co wceq wa c1 cA cdiv co vz cv vw cv cdiv co wceq vw cn wrex vz
      cz wrex c1 cA cdiv co cq wcel vx cv vy cv cmul co cz wcel vx cv vx cv
      cmul co cn wcel c1 cA cdiv co vx cv vy cv cmul co vx cv vx cv cmul co
      cdiv co wceq c1 cA cdiv co vz cv vw cv cdiv co wceq vw cn wrex vz cz wrex
      vz vw cz cn vx cv vy cv cmul co vx cv vx cv cmul co c1 cA cdiv co cdiv
      rcla4eopr 3expa vz vw c1 cA cdiv co elq sylibr syl8 r19.23aivv sylbi imp
      $.
      $( [27-Sep-2004] $) $( [3-Aug-2004] $)
  $}

  ${
    $d x y z w A $.
    $( Closure of division of rationals. $)
    qdivcl $p |- ( ( A e. QQ /\ B e. QQ /\ B =/= 0 ) -> ( A / B ) e. QQ ) $=
      cA cq wcel cB cq wcel cB cc0 wne w3a cA cB cdiv co cA c1 cB cdiv co cmul
      co cq cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cA c1 cB cdiv co
      cmul co wceq cA cq wcel cB cq wcel cB cc0 wne cA cB divrec cA qcn cB qcn
      cB cc0 wne id syl3an cA cq wcel cB cq wcel cB cc0 wne cA c1 cB cdiv co
      cmul co cq wcel cA cq wcel c1 cB cdiv co cq wcel cA c1 cB cdiv co cmul co
      cq wcel cB cq wcel cB cc0 wne wa cA c1 cB cdiv co qmulcl cB qreccl sylan2
      3impb eqeltrd $.
      $( [7-Nov-2008] $) $( [3-Aug-2004] $)
  $}

  $( Reverse closure law for addition of rationals. $)
  qrevaddcl $p |- ( B e. QQ ->
                   ( ( A e. CC /\ ( A + B ) e. QQ ) <-> A e. QQ ) ) $=
    cB cq wcel cA cc wcel cA cB caddc co cq wcel wa cA cc wcel cA cq wcel wa cA
    cq wcel cB cq wcel cA cc wcel cA cB caddc co cq wcel cA cq wcel cB cq wcel
    cA cc wcel wa cA cB caddc co cq wcel cA cq wcel cB cq wcel cA cc wcel wa cA
    cB caddc co cq wcel cA cq wcel cB cq wcel cA cc wcel wa cA cB caddc co cq
    wcel wa cA cB caddc co cB cmin co cA cq cB cq wcel cA cc wcel wa cA cB
    caddc co cB cmin co cA wceq cA cB caddc co cq wcel cA cc wcel cB cq wcel cA
    cB caddc co cB cmin co cA wceq cA cc wcel cB cc wcel cA cB caddc co cB cmin
    co cA wceq cB cq wcel cA cB pncan cB qcn sylan2 ancoms adantr cB cq wcel cA
    cB caddc co cq wcel cA cB caddc co cB cmin co cq wcel cA cc wcel cA cB
    caddc co cq wcel cB cq wcel cA cB caddc co cB cmin co cq wcel cA cB caddc
    co cB qsubcl ancoms adantlr eqeltrrd ex cB cq wcel cA cq wcel cA cB caddc
    co cq wcel wi cA cc wcel cA cq wcel cB cq wcel cA cB caddc co cq wcel cA cB
    qaddcl expcom adantr impbid pm5.32da cA cq wcel cA cc wcel cA qcn pm4.71ri
    syl6bbr $.
    $( [27-Sep-2004] $) $( [2-Aug-2004] $)

  $( The reciprocal of a natural number is rational. $)
  nnrecq $p |- ( A e. NN -> ( 1 / A ) e. QQ ) $=
    c1 cz wcel cA cn wcel c1 cA cdiv co cq wcel 1z c1 cA znq mpan $.
    $( [10-Dec-2004] $) $( [17-Nov-2004] $)

  $( The sum of an irrational number and a rational number is irrational. $)
  irradd $p |- ( ( A e. ( RR \ QQ ) /\ B e. QQ )
                -> ( A + B ) e. ( RR \ QQ ) ) $=
    cA cr wcel cA cq wcel wn wa cB cq wcel wa cA cB caddc co cr wcel cA cB
    caddc co cq wcel wn wa cA cr cq cdif wcel cB cq wcel wa cA cB caddc co cr
    cq cdif wcel cA cr wcel cA cq wcel wn wa cB cq wcel wa cA cB caddc co cr
    wcel cA cB caddc co cq wcel wn cA cr wcel cB cq wcel cA cB caddc co cr wcel
    cA cq wcel wn cA cr wcel cB cr wcel cA cB caddc co cr wcel cB cq wcel cA cB
    readdcl cB qre sylan2 adantlr cA cr wcel cA cq wcel wn cB cq wcel cA cB
    caddc co cq wcel wn cA cr wcel cB cq wcel cA cq wcel wn cA cB caddc co cq
    wcel wn cA cr wcel cB cq wcel cA cq wcel wn cA cB caddc co cq wcel wn wi cA
    cr wcel cB cq wcel wa cA cB caddc co cq wcel cA cq wcel cA cr wcel cB cq
    wcel wa cA cB caddc co cq wcel cA cB caddc co cB cmin co cq wcel cA cq wcel
    cB cq wcel cA cB caddc co cq wcel cA cB caddc co cB cmin co cq wcel wi cA
    cr wcel cA cB caddc co cq wcel cB cq wcel cA cB caddc co cB cmin co cq wcel
    cA cB caddc co cB qsubcl expcom adantl cA cr wcel cB cq wcel wa cA cB caddc
    co cB cmin co cA cq cA cc wcel cB cc wcel cA cB caddc co cB cmin co cA wceq
    cA cr wcel cB cq wcel cA cB pncan cA recn cB qcn syl2an eleq1d sylibd con3d
    ex com23 imp31 jca cA cr cq cdif wcel cA cr wcel cA cq wcel wn wa cB cq
    wcel cA cr cq eldif anbi1i cA cB caddc co cr cq eldif 3imtr4i $.
    $( [22-Nov-2008] $) $( [7-Nov-2008] $)

  $( The product of an irrational with a nonzero rational is irrational. $)
  irrmul $p |- ( ( A e. ( RR \ QQ ) /\ B e. QQ /\ B =/= 0 )
                -> ( A x. B ) e. ( RR \ QQ ) ) $=
    cA cr wcel cA cq wcel wn wa cB cq wcel cB cc0 wne w3a cA cB cmul co cr wcel
    cA cB cmul co cq wcel wn wa cA cr cq cdif wcel cB cq wcel cB cc0 wne w3a cA
    cB cmul co cr cq cdif wcel cA cr wcel cA cq wcel wn wa cB cq wcel cB cc0
    wne cA cB cmul co cr wcel cA cB cmul co cq wcel wn wa cA cr wcel cA cq wcel
    wn wa cB cq wcel cB cc0 wne wa wa cA cB cmul co cr wcel cA cB cmul co cq
    wcel wn cA cr wcel cB cq wcel cA cB cmul co cr wcel cA cq wcel wn cB cc0
    wne cA cr wcel cB cr wcel cA cB cmul co cr wcel cB cq wcel cA cB remulcl cB
    qre sylan2 ad2ant2r cA cr wcel cA cq wcel wn cB cq wcel cB cc0 wne wa cA cB
    cmul co cq wcel wn cA cr wcel cB cq wcel cB cc0 wne wa cA cq wcel wn cA cB
    cmul co cq wcel wn cA cr wcel cB cq wcel cB cc0 wne wa cA cq wcel wn cA cB
    cmul co cq wcel wn wi cA cr wcel cB cq wcel cB cc0 wne wa wa cA cB cmul co
    cq wcel cA cq wcel cA cr wcel cB cq wcel cB cc0 wne wa wa cA cB cmul co cq
    wcel cA cB cmul co cB cdiv co cq wcel cA cq wcel cB cq wcel cB cc0 wne wa
    cA cB cmul co cq wcel cA cB cmul co cB cdiv co cq wcel wi cA cr wcel cA cB
    cmul co cq wcel cB cq wcel cB cc0 wne wa cA cB cmul co cB cdiv co cq wcel
    cA cB cmul co cq wcel cB cq wcel cB cc0 wne cA cB cmul co cB cdiv co cq
    wcel cA cB cmul co cB qdivcl 3expb expcom adantl cA cr wcel cB cq wcel cB
    cc0 wne wa wa cA cB cmul co cB cdiv co cA cq cA cr wcel cB cq wcel cB cc0
    wne cA cB cmul co cB cdiv co cA wceq cA cr wcel cB cc wcel cB cc0 wne cA cB
    cmul co cB cdiv co cA wceq cB cq wcel cA cc wcel cB cc wcel cB cc0 wne cA
    cB cmul co cB cdiv co cA wceq cA cr wcel cA cB divcan4 cA recn syl3an1 cB
    qcn syl3an2 3expb eleq1d sylibd con3d ex com23 imp31 jca 3impb cA cr cq
    cdif wcel cA cr wcel cA cq wcel wn wa cB cq wcel cB cc0 wne cA cr cq eldif
    3anbi1i cA cB cmul co cr cq eldif 3imtr4i $.
    $( [9-Nov-2008] $) $( [7-Nov-2008] $)

  ${
    $d x y z A $.  $d x y z B $.
    $( The rational numbers are dense in ` RR ` : any two real numbers have a
       rational between them.  Exercise 6 of [Apostol] p. 28. $)
    qbtwnre $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
                  E. x e. QQ ( A < x /\ x < B ) ) $=
      cA cr wcel cB cr wcel cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa
      vx cq wrex cA cr wcel cB cr wcel wa cA cB clt wbr c1 vy cv cdiv co cB cA
      cmin co clt wbr vy cn wrex cA vx cv clt wbr vx cv cB clt wbr wa vx cq
      wrex cA cr wcel cB cr wcel wa cA cB clt wbr cc0 cB cA cmin co clt wbr c1
      vy cv cdiv co cB cA cmin co clt wbr vy cn wrex cA cB posdif cB cr wcel cA
      cr wcel cc0 cB cA cmin co clt wbr c1 vy cv cdiv co cB cA cmin co clt wbr
      vy cn wrex wi cB cr wcel cA cr wcel wa cc0 cB cA cmin co clt wbr c1 vy cv
      cdiv co cB cA cmin co clt wbr vy cn wrex cB cA cmin co cr wcel cc0 cB cA
      cmin co clt wbr c1 vy cv cdiv co cB cA cmin co clt wbr vy cn wrex cB cr
      wcel cA cr wcel wa cB cA cmin co vy nnrecl cB cA resubcl sylan ex ancoms
      sylbid cA cr wcel cB cr wcel wa c1 vy cv cdiv co cB cA cmin co clt wbr cA
      vx cv clt wbr vx cv cB clt wbr wa vx cq wrex vy cn vy cv cn wcel cA cr
      wcel cB cr wcel wa c1 vy cv cdiv co cB cA cmin co clt wbr cA vx cv clt
      wbr vx cv cB clt wbr wa vx cq wrex wi vy cv cn wcel cA cr wcel cB cr wcel
      wa wa vy cv cB cmul co c1 cmin co vz cv cle wbr vz cv vy cv cB cmul co c1
      cmin co c1 caddc co clt wbr wa vz cz wrex c1 vy cv cdiv co cB cA cmin co
      clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex wi vy cv cn wcel
      cA cr wcel cB cr wcel wa wa vy cv cB cmul co c1 cmin co cr wcel vy cv cB
      cmul co c1 cmin co vz cv cle wbr vz cv vy cv cB cmul co c1 cmin co c1
      caddc co clt wbr wa vz cz wreu vy cv cB cmul co c1 cmin co vz cv cle wbr
      vz cv vy cv cB cmul co c1 cmin co c1 caddc co clt wbr wa vz cz wrex vy cv
      cn wcel cB cr wcel vy cv cB cmul co c1 cmin co cr wcel cA cr wcel vy cv
      cn wcel cB cr wcel wa vy cv cB cmul co cr wcel vy cv cB cmul co c1 cmin
      co cr wcel vy cv cr wcel cB cr wcel vy cv cB cmul co cr wcel vy cv cn
      wcel vy cv cB remulcl vy cv nnre sylan vy cv cB cmul co peano2rem syl
      adantrl vz vy cv cB cmul co c1 cmin co zbtwnre vy cv cB cmul co c1 cmin
      co vz cv cle wbr vz cv vy cv cB cmul co c1 cmin co c1 caddc co clt wbr wa
      vz cz reurex 3syl vy cv cn wcel cA cr wcel cB cr wcel wa wa vy cv cB cmul
      co c1 cmin co vz cv cle wbr vz cv vy cv cB cmul co c1 cmin co c1 caddc co
      clt wbr wa c1 vy cv cdiv co cB cA cmin co clt wbr cA vx cv clt wbr vx cv
      cB clt wbr wa vx cq wrex wi vz cz vy cv cn wcel cA cr wcel cB cr wcel wa
      wa vz cv cz wcel c1 vy cv cdiv co cB cA cmin co clt wbr vy cv cB cmul co
      c1 cmin co vz cv cle wbr vz cv vy cv cB cmul co c1 cmin co c1 caddc co
      clt wbr wa cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex vy cv cn wcel
      cA cr wcel cB cr wcel wa wa vz cv cz wcel c1 vy cv cdiv co cB cA cmin co
      clt wbr vy cv cB cmul co c1 cmin co vz cv cle wbr vz cv vy cv cB cmul co
      c1 cmin co c1 caddc co clt wbr wa cA vx cv clt wbr vx cv cB clt wbr wa vx
      cq wrex vy cv cn wcel cA cr wcel cB cr wcel wa wa vz cv cz wcel wa c1 vy
      cv cdiv co cB cA cmin co clt wbr vy cv cB cmul co c1 cmin co vz cv cle
      wbr wa vz cv vy cv cB cmul co c1 cmin co c1 caddc co clt wbr wa cA vx cv
      clt wbr vx cv cB clt wbr wa vx cq wrex c1 vy cv cdiv co cB cA cmin co clt
      wbr vy cv cB cmul co c1 cmin co vz cv cle wbr vz cv vy cv cB cmul co c1
      cmin co c1 caddc co clt wbr wa wa vy cv cn wcel cA cr wcel cB cr wcel wa
      wa vz cv cz wcel wa c1 vy cv cdiv co cB cA cmin co clt wbr vy cv cB cmul
      co c1 cmin co vz cv cle wbr wa vz cv vy cv cB cmul co c1 cmin co c1 caddc
      co clt wbr wa vz cv vy cv cdiv co cq wcel cA vz cv vy cv cdiv co clt wbr
      vz cv vy cv cdiv co cB clt wbr wa wa cA vx cv clt wbr vx cv cB clt wbr wa
      vx cq wrex vy cv cn wcel cA cr wcel cB cr wcel wa wa vz cv cz wcel wa c1
      vy cv cdiv co cB cA cmin co clt wbr vy cv cB cmul co c1 cmin co vz cv cle
      wbr wa vz cv vy cv cB cmul co c1 cmin co c1 caddc co clt wbr wa cA vz cv
      vy cv cdiv co clt wbr vz cv vy cv cdiv co cB clt wbr wa vz cv vy cv cdiv
      co cq wcel vy cv cn wcel cA cr wcel cB cr wcel wa wa vz cv cr wcel c1 vy
      cv cdiv co cB cA cmin co clt wbr vy cv cB cmul co c1 cmin co vz cv cle
      wbr wa vz cv vy cv cB cmul co c1 cmin co c1 caddc co clt wbr wa cA vz cv
      vy cv cdiv co clt wbr vz cv vy cv cdiv co cB clt wbr wa wi vz cv cz wcel
      vy cv cn wcel cA cr wcel cB cr wcel wa wa vz cv cr wcel wa c1 vy cv cdiv
      co cB cA cmin co clt wbr vy cv cB cmul co c1 cmin co vz cv cle wbr wa cA
      vz cv vy cv cdiv co clt wbr vz cv vy cv cB cmul co c1 cmin co c1 caddc co
      clt wbr vz cv vy cv cdiv co cB clt wbr vy cv cn wcel cA cr wcel cB cr
      wcel wa wa vz cv cr wcel wa c1 vy cv cdiv co cB cA cmin co clt wbr vy cv
      cB cmul co c1 cmin co vz cv cle wbr wa vy cv cA cmul co vz cv clt wbr cA
      vz cv vy cv cdiv co clt wbr vy cv cn wcel cA cr wcel cB cr wcel wa wa vz
      cv cr wcel wa c1 vy cv cdiv co cB cA cmin co clt wbr vy cv cB cmul co c1
      cmin co vz cv cle wbr wa vy cv cA cmul co vy cv cB cmul co c1 cmin co clt
      wbr vy cv cB cmul co c1 cmin co vz cv cle wbr wa vy cv cA cmul co vz cv
      clt wbr vy cv cn wcel cA cr wcel cB cr wcel wa wa vz cv cr wcel wa c1 vy
      cv cdiv co cB cA cmin co clt wbr vy cv cA cmul co vy cv cB cmul co c1
      cmin co clt wbr vy cv cB cmul co c1 cmin co vz cv cle wbr vy cv cn wcel
      cA cr wcel cB cr wcel wa wa c1 vy cv cdiv co cB cA cmin co clt wbr vy cv
      cA cmul co vy cv cB cmul co c1 cmin co clt wbr wb vz cv cr wcel vy cv cn
      wcel cA cr wcel cB cr wcel wa wa c1 vy cv cB cA cmin co cmul co clt wbr
      c1 vy cv cB cmul co vy cv cA cmul co cmin co clt wbr c1 vy cv cdiv co cB
      cA cmin co clt wbr vy cv cA cmul co vy cv cB cmul co c1 cmin co clt wbr
      vy cv cn wcel cA cr wcel cB cr wcel wa wa vy cv cB cA cmin co cmul co vy
      cv cB cmul co vy cv cA cmul co cmin co c1 clt vy cv cn wcel cA cr wcel cB
      cr wcel vy cv cB cA cmin co cmul co vy cv cB cmul co vy cv cA cmul co
      cmin co wceq vy cv cn wcel cB cr wcel cA cr wcel vy cv cB cA cmin co cmul
      co vy cv cB cmul co vy cv cA cmul co cmin co wceq vy cv cc wcel cB cc
      wcel cA cc wcel vy cv cB cA cmin co cmul co vy cv cB cmul co vy cv cA
      cmul co cmin co wceq vy cv cn wcel cB cr wcel cA cr wcel vy cv cB cA
      subdi vy cv nncn cB recn cA recn syl3an 3com23 3expb breq2d vy cv cn wcel
      cA cr wcel cB cr wcel wa c1 vy cv cdiv co cB cA cmin co clt wbr c1 vy cv
      cB cA cmin co cmul co clt wbr wb vy cv cn wcel cB cA cmin co cr wcel c1
      vy cv cdiv co cB cA cmin co clt wbr c1 vy cv cB cA cmin co cmul co clt
      wbr wb cA cr wcel cB cr wcel wa vy cv cr wcel cc0 vy cv clt wbr cB cA
      cmin co cr wcel c1 vy cv cdiv co cB cA cmin co clt wbr c1 vy cv cB cA
      cmin co cmul co clt wbr wb wi vy cv cn wcel vy cv cr wcel cB cA cmin co
      cr wcel cc0 vy cv clt wbr c1 vy cv cdiv co cB cA cmin co clt wbr c1 vy cv
      cB cA cmin co cmul co clt wbr wb vy cv cr wcel cB cA cmin co cr wcel cc0
      vy cv clt wbr c1 vy cv cdiv co cB cA cmin co clt wbr c1 vy cv cB cA cmin
      co cmul co clt wbr wb c1 cr wcel vy cv cr wcel cB cA cmin co cr wcel cc0
      vy cv clt wbr c1 vy cv cdiv co cB cA cmin co clt wbr c1 vy cv cB cA cmin
      co cmul co clt wbr wb 1re c1 vy cv cB cA cmin co ltdivmulOLD mp3anl1
      exp31 com23 vy cv nnre vy cv nngt0 sylc cB cr wcel cA cr wcel cB cA cmin
      co cr wcel cB cA resubcl ancoms syl5 imp vy cv cr wcel cA cr wcel cB cr
      wcel wa vy cv cA cmul co vy cv cB cmul co c1 cmin co clt wbr c1 vy cv cB
      cmul co vy cv cA cmul co cmin co clt wbr wb vy cv cn wcel vy cv cr wcel
      cA cr wcel cB cr wcel vy cv cA cmul co vy cv cB cmul co c1 cmin co clt
      wbr c1 vy cv cB cmul co vy cv cA cmul co cmin co clt wbr wb vy cv cA cmul
      co cr wcel vy cv cB cmul co cr wcel vy cv cA cmul co vy cv cB cmul co c1
      cmin co clt wbr c1 vy cv cB cmul co vy cv cA cmul co cmin co clt wbr wb
      vy cv cr wcel cA cr wcel wa vy cv cr wcel cB cr wcel wa vy cv cA cmul co
      cr wcel vy cv cB cmul co cr wcel c1 cr wcel vy cv cA cmul co vy cv cB
      cmul co c1 cmin co clt wbr c1 vy cv cB cmul co vy cv cA cmul co cmin co
      clt wbr wb 1re vy cv cA cmul co vy cv cB cmul co c1 ltsub13 mp3an3 vy cv
      cA remulcl vy cv cB remulcl syl2an anandis vy cv nnre sylan 3bitr4d
      adantr anbi1d vy cv cA cmul co cr wcel vy cv cB cmul co c1 cmin co cr
      wcel wa vz cv cr wcel vy cv cA cmul co vy cv cB cmul co c1 cmin co clt
      wbr vy cv cB cmul co c1 cmin co vz cv cle wbr wa vy cv cA cmul co vz cv
      clt wbr wi vy cv cn wcel cA cr wcel cB cr wcel wa wa vy cv cA cmul co cr
      wcel vy cv cB cmul co c1 cmin co cr wcel vz cv cr wcel vy cv cA cmul co
      vy cv cB cmul co c1 cmin co clt wbr vy cv cB cmul co c1 cmin co vz cv cle
      wbr wa vy cv cA cmul co vz cv clt wbr wi vy cv cA cmul co vy cv cB cmul
      co c1 cmin co vz cv ltletr 3expa vy cv cn wcel cA cr wcel cB cr wcel wa
      wa vy cv cA cmul co cr wcel vy cv cB cmul co c1 cmin co cr wcel vy cv cn
      wcel cA cr wcel vy cv cA cmul co cr wcel cB cr wcel vy cv cr wcel cA cr
      wcel vy cv cA cmul co cr wcel vy cv cn wcel vy cv cA remulcl vy cv nnre
      sylan adantrr vy cv cn wcel cB cr wcel vy cv cB cmul co c1 cmin co cr
      wcel cA cr wcel vy cv cn wcel cB cr wcel wa vy cv cB cmul co cr wcel vy
      cv cB cmul co c1 cmin co cr wcel vy cv cr wcel cB cr wcel vy cv cB cmul
      co cr wcel vy cv cn wcel vy cv cB remulcl vy cv nnre sylan vy cv cB cmul
      co peano2rem syl adantrl jca sylan sylbid vy cv cn wcel cA cr wcel cB cr
      wcel wa vz cv cr wcel vy cv cA cmul co vz cv clt wbr cA vz cv vy cv cdiv
      co clt wbr wb vy cv cn wcel cA cr wcel vz cv cr wcel vy cv cA cmul co vz
      cv clt wbr cA vz cv vy cv cdiv co clt wbr wb wi cB cr wcel cc0 vy cv clt
      wbr vy cv cn wcel cA cr wcel vz cv cr wcel vy cv cA cmul co vz cv clt wbr
      cA vz cv vy cv cdiv co clt wbr wb wi wi vy cv nngt0 vy cv cn wcel cA cr
      wcel vz cv cr wcel cc0 vy cv clt wbr vy cv cA cmul co vz cv clt wbr cA vz
      cv vy cv cdiv co clt wbr wb vy cv cn wcel vy cv cr wcel cA cr wcel vz cv
      cr wcel cc0 vy cv clt wbr vy cv cA cmul co vz cv clt wbr cA vz cv vy cv
      cdiv co clt wbr wb wi wi wi vy cv nnre vy cv cr wcel cA cr wcel vz cv cr
      wcel cc0 vy cv clt wbr vy cv cA cmul co vz cv clt wbr cA vz cv vy cv cdiv
      co clt wbr wb vy cv cA vz cv ltmuldiv2OLD 3exp1 syl com4r mpcom adantrd
      imp31 sylibd vy cv cn wcel cB cr wcel vz cv cr wcel vz cv vy cv cB cmul
      co c1 cmin co c1 caddc co clt wbr vz cv vy cv cdiv co cB clt wbr wi cA cr
      wcel vy cv cn wcel cB cr wcel wa vz cv cr wcel wa vz cv vy cv cB cmul co
      c1 cmin co c1 caddc co clt wbr vz cv vy cv cdiv co cB clt wbr vy cv cn
      wcel cB cr wcel wa vz cv cr wcel wa vz cv vy cv cB cmul co c1 cmin co c1
      caddc co clt wbr vz cv vy cv cB cmul co clt wbr vz cv vy cv cdiv co cB
      clt wbr vy cv cn wcel cB cr wcel wa vz cv cr wcel wa vy cv cB cmul co c1
      cmin co c1 caddc co vy cv cB cmul co vz cv clt vy cv cn wcel cB cr wcel
      wa vy cv cB cmul co c1 cmin co c1 caddc co vy cv cB cmul co wceq vz cv cr
      wcel vy cv cB cmul co cc wcel c1 cc wcel vy cv cB cmul co c1 cmin co c1
      caddc co vy cv cB cmul co wceq vy cv cn wcel cB cr wcel wa vy cv cB cmul
      co c1 npcan vy cv cc wcel cB cc wcel vy cv cB cmul co cc wcel vy cv cn
      wcel cB cr wcel vy cv cB mulcl vy cv nncn cB recn syl2an ax1cn sylancl
      adantr breq2d vy cv cn wcel cB cr wcel vz cv cr wcel vz cv vy cv cdiv co
      cB clt wbr vz cv vy cv cB cmul co clt wbr wb vz cv cr wcel vy cv cn wcel
      cB cr wcel vz cv vy cv cdiv co cB clt wbr vz cv vy cv cB cmul co clt wbr
      wb vz cv cr wcel vy cv cn wcel cB cr wcel w3a cc0 vy cv clt wbr vz cv vy
      cv cdiv co cB clt wbr vz cv vy cv cB cmul co clt wbr wb vy cv cn wcel vz
      cv cr wcel cc0 vy cv clt wbr cB cr wcel vy cv nngt0 3ad2ant2 vz cv cr
      wcel vy cv cr wcel cB cr wcel cc0 vy cv clt wbr vz cv vy cv cdiv co cB
      clt wbr vz cv vy cv cB cmul co clt wbr wb vy cv cn wcel vz cv vy cv cB
      ltdivmulOLD vy cv nnre syl3anl2 mpdan 3coml 3expa bitr4d biimpd adantlrl
      anim12d vz cv zre sylan2 vy cv cn wcel vz cv cz wcel vz cv vy cv cdiv co
      cq wcel cA cr wcel cB cr wcel wa vz cv cz wcel vy cv cn wcel vz cv vy cv
      cdiv co cq wcel vz cv vy cv znq ancoms adantlr jctild cA vx cv clt wbr vx
      cv cB clt wbr wa cA vz cv vy cv cdiv co clt wbr vz cv vy cv cdiv co cB
      clt wbr wa vx vz cv vy cv cdiv co cq vx cv vz cv vy cv cdiv co wceq cA vx
      cv clt wbr cA vz cv vy cv cdiv co clt wbr vx cv cB clt wbr vz cv vy cv
      cdiv co cB clt wbr vx cv vz cv vy cv cdiv co cA clt breq2 vx cv vz cv vy
      cv cdiv co cB clt breq1 anbi12d rcla4ev syl6 c1 vy cv cdiv co cB cA cmin
      co clt wbr vy cv cB cmul co c1 cmin co vz cv cle wbr vz cv vy cv cB cmul
      co c1 cmin co c1 caddc co clt wbr anass syl5ibr exp4b com34 r19.23adv mpd
      expcom r19.23adv syld 3impia $.
      $( [15-Feb-2007] $) $( [18-Nov-2004] $)

    $( The rational numbers are dense in ` RR* ` : any two extended real
       numbers have a rational between them. $)
    qbtwnxr $p |- ( ( A e. RR* /\ B e. RR* /\ A < B )
                   -> E. x e. QQ ( A < x /\ x < B ) ) $=
      cA cxr wcel cB cxr wcel cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr
      wa vx cq wrex cA cr wcel cA cpnf wceq cA cmnf wceq w3o cB cxr wcel cA cB
      clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex wi cA cxr wcel cA
      cr wcel cB cxr wcel cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx
      cq wrex wi cA cpnf wceq cA cmnf wceq cA cr wcel cB cr wcel cB cpnf wceq
      cB cmnf wceq w3o cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq
      wrex wi cB cxr wcel cA cr wcel cB cr wcel cA cB clt wbr cA vx cv clt wbr
      vx cv cB clt wbr wa vx cq wrex wi cB cpnf wceq cB cmnf wceq cA cr wcel cB
      cr wcel cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex vx
      cA cB qbtwnre 3expia cA cr wcel cB cpnf wceq wa cA vx cv clt wbr vx cv cB
      clt wbr wa vx cq wrex cA cB clt wbr cA cr wcel cB cpnf wceq wa cA vx cv
      clt wbr vx cv cB clt wbr wa vx cq wrex cA vx cv clt wbr vx cv cpnf clt
      wbr wa vx cq wrex cA cr wcel cA vx cv clt wbr vx cv cpnf clt wbr wa vx cq
      wrex cB cpnf wceq cA cr wcel cA vx cv clt wbr vx cv cA c1 caddc co clt
      wbr wa vx cq wrex cA vx cv clt wbr vx cv cpnf clt wbr wa vx cq wrex cA cr
      wcel cA c1 caddc co cr wcel cA cA c1 caddc co clt wbr cA vx cv clt wbr vx
      cv cA c1 caddc co clt wbr wa vx cq wrex cA peano2re cA ltp1 vx cA cA c1
      caddc co qbtwnre mpd3an23 cA cr wcel cA vx cv clt wbr vx cv cA c1 caddc
      co clt wbr wa cA vx cv clt wbr vx cv cpnf clt wbr wa vx cq cA cr wcel vx
      cv cq wcel wa vx cv cA c1 caddc co clt wbr vx cv cpnf clt wbr cA vx cv
      clt wbr cA cr wcel vx cv cq wcel wa vx cv cA c1 caddc co clt wbr cA c1
      caddc co cpnf clt wbr vx cv cpnf clt wbr cA cr wcel cA c1 caddc co cpnf
      clt wbr vx cv cq wcel cA cr wcel cA c1 caddc co cr wcel cA c1 caddc co
      cpnf clt wbr cA peano2re cA c1 caddc co ltpnf syl adantr vx cv cxr wcel
      cA c1 caddc co cxr wcel vx cv cA c1 caddc co clt wbr cA c1 caddc co cpnf
      clt wbr wa vx cv cpnf clt wbr wi cA cr wcel vx cv cq wcel wa vx cv cxr
      wcel cA c1 caddc co cxr wcel cpnf cxr wcel vx cv cA c1 caddc co clt wbr
      cA c1 caddc co cpnf clt wbr wa vx cv cpnf clt wbr wi pnfxr vx cv cA c1
      caddc co cpnf xrlttr mp3an3 vx cv cq wcel vx cv cxr wcel cA cr wcel vx cv
      cq wcel vx cv cr wcel vx cv cxr wcel vx cv qre vx cv rexr syl adantl cA
      cr wcel cA c1 caddc co cxr wcel vx cv cq wcel cA cr wcel cA c1 caddc co
      cr wcel cA c1 caddc co cxr wcel cA peano2re cA c1 caddc co rexr syl
      adantr sylanc mpan2d anim2d r19.22dva mpd adantr cB cpnf wceq cA vx cv
      clt wbr vx cv cB clt wbr wa vx cq wrex cA vx cv clt wbr vx cv cpnf clt
      wbr wa vx cq wrex wb cA cr wcel cB cpnf wceq cA vx cv clt wbr vx cv cB
      clt wbr wa cA vx cv clt wbr vx cv cpnf clt wbr wa vx cq cB cpnf wceq vx
      cv cB clt wbr vx cv cpnf clt wbr cA vx cv clt wbr cB cpnf vx cv clt breq2
      anbi2d rexbidv adantl mpbird a1d cA cr wcel cB cmnf wceq wa cA cB clt wbr
      cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cA cr wcel cB cmnf wceq
      wa cA cB clt wbr wn cA cmnf clt wbr wn cA cr wcel cA cmnf clt wbr wn cB
      cmnf wceq cA cr wcel cA cxr wcel cA cmnf clt wbr wn cA rexr cA nltmnf syl
      adantr cB cmnf wceq cA cB clt wbr wn cA cmnf clt wbr wn wb cA cr wcel cB
      cmnf wceq cA cB clt wbr cA cmnf clt wbr cB cmnf cA clt breq2 notbid
      adantl mpbird pm2.21d 3jaodan cB elxr sylan2b cA cpnf wceq cB cxr wcel wa
      cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cA cpnf
      wceq cB cxr wcel wa cA cB clt wbr wn cpnf cB clt wbr wn cB cxr wcel cpnf
      cB clt wbr wn cA cpnf wceq cB pnfnlt adantl cA cpnf wceq cA cB clt wbr wn
      cpnf cB clt wbr wn wb cB cxr wcel cA cpnf wceq cA cB clt wbr cpnf cB clt
      wbr cA cpnf cB clt breq1 notbid adantr mpbird pm2.21d cA cmnf wceq cB cr
      wcel cB cpnf wceq cB cmnf wceq w3o cA cB clt wbr cA vx cv clt wbr vx cv
      cB clt wbr wa vx cq wrex wi cB cxr wcel cA cmnf wceq cB cr wcel cA cB clt
      wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex wi cB cpnf wceq cB
      cmnf wceq cA cmnf wceq cB cr wcel wa cA vx cv clt wbr vx cv cB clt wbr wa
      vx cq wrex cA cB clt wbr cA cmnf wceq cB cr wcel wa cA vx cv clt wbr vx
      cv cB clt wbr wa vx cq wrex cmnf vx cv clt wbr vx cv cB clt wbr wa vx cq
      wrex cB cr wcel cmnf vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cA cmnf
      wceq cB cr wcel cB c1 cmin co vx cv clt wbr vx cv cB clt wbr wa vx cq
      wrex cmnf vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cB c1 cmin co cr
      wcel cB cr wcel cB c1 cmin co cB clt wbr cB c1 cmin co vx cv clt wbr vx
      cv cB clt wbr wa vx cq wrex cB cr wcel vx cB c1 cmin co cB qbtwnre cB
      peano2rem cB cr wcel id cB ltm1 syl3anc cB cr wcel cB c1 cmin co vx cv
      clt wbr vx cv cB clt wbr wa cmnf vx cv clt wbr vx cv cB clt wbr wa vx cq
      cB cr wcel vx cv cq wcel wa cB c1 cmin co vx cv clt wbr cmnf vx cv clt
      wbr vx cv cB clt wbr cB cr wcel vx cv cq wcel wa cmnf cB c1 cmin co clt
      wbr cB c1 cmin co vx cv clt wbr cmnf vx cv clt wbr cB cr wcel cmnf cB c1
      cmin co clt wbr vx cv cq wcel cB cr wcel cB c1 cmin co cr wcel cmnf cB c1
      cmin co clt wbr cB peano2rem cB c1 cmin co mnflt syl adantr cB c1 cmin co
      cxr wcel vx cv cxr wcel cmnf cB c1 cmin co clt wbr cB c1 cmin co vx cv
      clt wbr wa cmnf vx cv clt wbr wi cB cr wcel vx cv cq wcel cmnf cxr wcel
      cB c1 cmin co cxr wcel vx cv cxr wcel cmnf cB c1 cmin co clt wbr cB c1
      cmin co vx cv clt wbr wa cmnf vx cv clt wbr wi mnfxr cmnf cB c1 cmin co
      vx cv xrlttr mp3an1 cB cr wcel cB c1 cmin co cr wcel cB c1 cmin co cxr
      wcel cB peano2rem cB c1 cmin co rexr syl vx cv cq wcel vx cv cr wcel vx
      cv cxr wcel vx cv qre vx cv rexr syl syl2an mpand anim1d r19.22dva mpd
      adantl cA cmnf wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cmnf
      vx cv clt wbr vx cv cB clt wbr wa vx cq wrex wb cB cr wcel cA cmnf wceq
      cA vx cv clt wbr vx cv cB clt wbr wa cmnf vx cv clt wbr vx cv cB clt wbr
      wa vx cq cA cmnf wceq cA vx cv clt wbr cmnf vx cv clt wbr vx cv cB clt
      wbr cA cmnf vx cv clt breq1 anbi1d rexbidv adantr mpbird a1d cA cmnf wceq
      cB cpnf wceq wa cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cA cB clt
      wbr cA c1 clt wbr c1 cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx
      cq wrex cA cmnf wceq cB cpnf wceq c1 cq wcel cA c1 clt wbr c1 cB clt wbr
      wa cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex c1 cz wcel c1 cq wcel
      1z c1 zq ax-mp cA vx cv clt wbr vx cv cB clt wbr wa cA c1 clt wbr c1 cB
      clt wbr wa vx c1 cq vx cv c1 wceq cA vx cv clt wbr cA c1 clt wbr vx cv cB
      clt wbr c1 cB clt wbr vx cv c1 cA clt breq2 vx cv c1 cB clt breq1 anbi12d
      rcla4ev mpan cA cmnf wceq cA c1 clt wbr cmnf c1 clt wbr c1 cr wcel cmnf
      c1 clt wbr 1re c1 mnflt ax-mp cA cmnf c1 clt breq1 mpbiri cB cpnf wceq c1
      cB clt wbr c1 cpnf clt wbr c1 cr wcel c1 cpnf clt wbr 1re c1 ltpnf ax-mp
      cB cpnf c1 clt breq2 mpbiri syl2an a1d cA cmnf wceq cB cmnf wceq wa cA cB
      clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cq wrex cA cmnf wceq cB
      cmnf wceq wa cA cB clt wbr cmnf cmnf clt wbr cmnf cxr wcel cmnf cmnf clt
      wbr wn mnfxr cmnf nltmnf ax-mp cA cmnf cB cmnf clt breq12 mtbiri pm2.21d
      3jaodan cB elxr sylan2b 3jaoian cA elxr sylanb 3impia $.
      $( [8-Feb-2007] $) $( [6-Feb-2007] $)
  $}

  ${
    $d x A $.
    $( If a nonnegative real is less than any positive rational, it is zero. $)
    qsqueeze $p |- ( ( A e. RR /\ 0 <_ A /\ A. x e. QQ ( 0 < x -> A < x ) ) ->
                   A = 0 ) $=
      cA cr wcel cc0 cA cle wbr cc0 vx cv clt wbr cA vx cv clt wbr wi vx cq
      wral w3a cA cc0 wceq cA cc0 cle wbr cA cr wcel cc0 vx cv clt wbr cA vx cv
      clt wbr wi vx cq wral cA cc0 cle wbr cc0 cA cle wbr cA cr wcel cc0 vx cv
      clt wbr cA vx cv clt wbr wi vx cq wral cA cc0 cle wbr cA cr wcel cA cc0
      cle wbr cc0 vx cv clt wbr cA vx cv clt wbr wi vx cq wral cA cr wcel cA
      cc0 cle wbr wn cc0 vx cv clt wbr cA vx cv clt wbr wn wa vx cq wrex cc0 vx
      cv clt wbr cA vx cv clt wbr wi vx cq wral wn cA cr wcel cA cc0 cle wbr wn
      cc0 cA clt wbr cc0 vx cv clt wbr cA vx cv clt wbr wn wa vx cq wrex cc0 cr
      wcel cA cr wcel cc0 cA clt wbr cA cc0 cle wbr wn wb 0re cc0 cA ltnle mpan
      cA cr wcel cc0 cA clt wbr cc0 vx cv clt wbr vx cv cA clt wbr wa vx cq
      wrex cc0 vx cv clt wbr cA vx cv clt wbr wn wa vx cq wrex cA cr wcel cc0
      cA clt wbr cc0 vx cv clt wbr vx cv cA clt wbr wa vx cq wrex cc0 cr wcel
      cA cr wcel cc0 cA clt wbr cc0 vx cv clt wbr vx cv cA clt wbr wa vx cq
      wrex 0re vx cc0 cA qbtwnre mp3an1 ex cA cr wcel cc0 vx cv clt wbr vx cv
      cA clt wbr wa cc0 vx cv clt wbr cA vx cv clt wbr wn wa vx cq cA cr wcel
      vx cv cq wcel wa vx cv cA clt wbr cA vx cv clt wbr wn cc0 vx cv clt wbr
      cA cr wcel vx cv cr wcel vx cv cA clt wbr cA vx cv clt wbr wn wi vx cv cq
      wcel cA cr wcel vx cv cr wcel wa cA vx cv clt wbr vx cv cA clt wbr cA vx
      cv ltnsym con2d vx cv qre sylan2 anim2d r19.22dva syld sylbird cc0 vx cv
      clt wbr cA vx cv clt wbr vx cq rexanali syl6ib con4d imp 3adant2 cA cr
      wcel cc0 cA cle wbr cA cc0 wceq cA cc0 cle wbr wb cc0 vx cv clt wbr cA vx
      cv clt wbr wi vx cq wral cA cr wcel cA cc0 wceq cA cc0 cle wbr cc0 cA cle
      wbr wa cc0 cA cle wbr cA cc0 cle wbr cA cr wcel cc0 cr wcel cA cc0 wceq
      cA cc0 cle wbr cc0 cA cle wbr wa wb 0re cA cc0 letri3 mpan2 cc0 cA cle
      wbr cA cc0 cle wbr cA cc0 cle wbr cc0 cA cle wbr wa cc0 cA cle wbr cA cc0
      cle wbr iba bicomd sylan9bb 3adant3 mpbird $.
      $( [6-Feb-2007] $) $( [6-Feb-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The floor (greatest integer) function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c |_ $.  $( Floor function. $)

  $( Extend class notation with floor (greatest integer) function. $)
  cfl $a class |_ $.

  ${
    $d x y z $.
    $( Define the floor (greatest integer) function.  See ~ flval for its
       value, ~ fllelt for its basic property, and ~ flcl for its closure.

       The term "floor" was coined by Ken Iverson.  He also invented a
       mathematical notation for floor, consisting of an L-shaped left bracket
       and its reflection as a right bracket.  In APL, the left-bracket alone
       is used, and we borrow this idea.  (Thanks to Paul Chapman for this
       information.) $)
    df-fl $a |- |_ = { <. x , y >. | ( x e. RR /\
                y = U. { z e. ZZ | ( z <_ x /\ x < ( z + 1 ) ) } ) } $.
  $}

  ${
    $d x y z A $.
    $( Value of the floor (greatest integer) function.  The floor of ` A ` is
       the (unique) integer less than or equal to ` A ` whose successor is
       strictly greater than ` A ` . $)
    flval $p |- ( A e. RR ->
              ( |_ ` A ) = U. { x e. ZZ | ( x <_ A /\ A < ( x + 1 ) ) } ) $=
      vy vz cA vx cv vy cv cle wbr vy cv vx cv c1 caddc co clt wbr wa vx cz
      crab cuni vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz crab
      cuni cr cfl vy cv cA wceq vx cv vy cv cle wbr vy cv vx cv c1 caddc co clt
      wbr wa vx cz crab vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz
      crab vy cv cA wceq vx cv vy cv cle wbr vy cv vx cv c1 caddc co clt wbr wa
      vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz vy cv cA wceq vx
      cv vy cv cle wbr vx cv cA cle wbr vy cv vx cv c1 caddc co clt wbr cA vx
      cv c1 caddc co clt wbr vy cv cA vx cv cle breq2 vy cv cA vx cv c1 caddc
      co clt breq1 anbi12d rabbisdv unieqd vy vz vx df-fl vx cv cA cle wbr cA
      vx cv c1 caddc co clt wbr wa vx cz crab vx cv cA cle wbr cA vx cv c1
      caddc co clt wbr wa vx cz zex rabex uniex fvopab4 $.
      $( [28-Sep-2007] $) $( [14-Nov-2004] $)

    $( The floor (greatest integer) function is an integer (closure law). $)
    flcl $p |- ( A e. RR -> ( |_ ` A ) e. ZZ ) $=
      cA cr wcel cA cfl cfv vz cv cA cle wbr cA vz cv c1 caddc co clt wbr wa vz
      cz crab cuni cz vz cA flval cA cr wcel vz cv cA cle wbr cA vz cv c1 caddc
      co clt wbr wa vz cz wreu vz cv cA cle wbr cA vz cv c1 caddc co clt wbr wa
      vz cz crab cuni cz wcel vz cA rebtwnz vz cv cA cle wbr cA vz cv c1 caddc
      co clt wbr wa vz cz reucl syl eqeltrd $.
      $( [10-Dec-2004] $) $( [15-Nov-2004] $)

    $( The floor (greatest integer) function is real. $)
    reflcl $p |- ( A e. RR -> ( |_ ` A ) e. RR ) $=
      cA cr wcel cA cfl cfv cz wcel cA cfl cfv cr wcel cA flcl cA cfl cfv zre
      syl $.
      $( [15-Jul-2008] $) $( [15-Jul-2008] $)

    $( A basic property of the floor (greatest integer) function. $)
    fllelt $p |- ( A e. RR ->
                  ( ( |_ ` A ) <_ A /\ A < ( ( |_ ` A ) + 1 ) ) ) $=
      cA cr wcel cA cfl cfv cA cle wbr cA cA cfl cfv c1 caddc co clt wbr wa vy
      cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni cA cle wbr
      cA vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni c1
      caddc co clt wbr wa cA cr wcel vx cv cA cle wbr cA vx cv c1 caddc co clt
      wbr wa vx cz wreu vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz
      crab cuni cA cle wbr cA vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa
      vy cz crab cuni c1 caddc co clt wbr wa vx cA rebtwnz vx cv cA cle wbr cA
      vx cv c1 caddc co clt wbr wa vy cv cA cle wbr cA vy cv c1 caddc co clt
      wbr wa vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni
      cA cle wbr cA vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab
      cuni c1 caddc co clt wbr wa vx vy cz vx cv vy cv wceq vx cv cA cle wbr vy
      cv cA cle wbr cA vx cv c1 caddc co clt wbr cA vy cv c1 caddc co clt wbr
      vx cv vy cv cA cle breq1 vx cv vy cv wceq vx cv c1 caddc co vy cv c1
      caddc co cA clt vx cv vy cv c1 caddc opreq1 breq2d anbi12d vx cv vy cv cA
      cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni wceq vx cv cA cle
      wbr vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni cA
      cle wbr cA vx cv c1 caddc co clt wbr cA vy cv cA cle wbr cA vy cv c1
      caddc co clt wbr wa vy cz crab cuni c1 caddc co clt wbr vx cv vy cv cA
      cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni cA cle breq1 vx
      cv vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni wceq
      vx cv c1 caddc co vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz
      crab cuni c1 caddc co cA clt vx cv vy cv cA cle wbr cA vy cv c1 caddc co
      clt wbr wa vy cz crab cuni c1 caddc opreq1 breq2d anbi12d reuuni3 syl cA
      cr wcel cA cfl cfv cA cle wbr vy cv cA cle wbr cA vy cv c1 caddc co clt
      wbr wa vy cz crab cuni cA cle wbr cA cA cfl cfv c1 caddc co clt wbr cA vy
      cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni c1 caddc co
      clt wbr cA cr wcel cA cfl cfv vy cv cA cle wbr cA vy cv c1 caddc co clt
      wbr wa vy cz crab cuni cA cle vy cA flval breq1d cA cr wcel cA cfl cfv c1
      caddc co vy cv cA cle wbr cA vy cv c1 caddc co clt wbr wa vy cz crab cuni
      c1 caddc co cA clt cA cr wcel cA cfl cfv vy cv cA cle wbr cA vy cv c1
      caddc co clt wbr wa vy cz crab cuni c1 caddc vy cA flval opreq1d breq2d
      anbi12d mpbird $.
      $( [9-Dec-2004] $) $( [15-Nov-2004] $)
  $}

  $( A basic property of the floor (greatest integer) function. $)
  flle $p |- ( A e. RR -> ( |_ ` A ) <_ A ) $=
    cA cr wcel cA cfl cfv cA cle wbr cA cA cfl cfv c1 caddc co clt wbr cA
    fllelt pm3.26d $.
    $( [27-Feb-2005] $) $( [24-Feb-2005] $)

  $( A basic property of the floor (greatest integer) function. $)
  flltp1 $p |- ( A e. RR -> A < ( ( |_ ` A ) + 1 ) ) $=
    cA cr wcel cA cfl cfv cA cle wbr cA cA cfl cfv c1 caddc co clt wbr cA
    fllelt pm3.27d $.
    $( [27-Feb-2005] $) $( [24-Feb-2005] $)

  $( The fractional part of a real number is less than one. $)
  fraclt1 $p |- ( A e. RR -> ( A - ( |_ ` A ) ) < 1 ) $=
    cA cr wcel cA cA cfl cfv cmin co c1 clt wbr cA cA cfl cfv c1 caddc co clt
    wbr cA flltp1 cA cr wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co c1 clt
    wbr cA cA cfl cfv c1 caddc co clt wbr wb cA reflcl cA cr wcel cA cfl cfv cr
    wcel c1 cr wcel cA cA cfl cfv cmin co c1 clt wbr cA cA cfl cfv c1 caddc co
    clt wbr wb 1re cA cA cfl cfv c1 ltsubadd2 mp3an3 mpdan mpbird $.
    $( [15-Jul-2008] $) $( [15-Jul-2008] $)

  $( The fractional part of a real number is nonnegative. $)
  fracge0 $p |- ( A e. RR -> 0 <_ ( A - ( |_ ` A ) ) ) $=
    cA cr wcel cc0 cA cA cfl cfv cmin co cle wbr cA cfl cfv cA cle wbr cA flle
    cA cr wcel cA cfl cfv cr wcel cc0 cA cA cfl cfv cmin co cle wbr cA cfl cfv
    cA cle wbr wb cA reflcl cA cA cfl cfv subge0 mpdan mpbird $.
    $( [26-Jul-2008] $) $( [17-Jul-2008] $)

  $( The floor function value is the greatest integer less than or equal to
     its argument. $)
  flge $p |- ( ( A e. RR /\ B e. ZZ ) -> ( B <_ A <-> B <_ ( |_ ` A ) ) ) $=
    cB cz wcel cA cr wcel cB cA cle wbr cB cA cfl cfv cle wbr wb cB cz wcel cA
    cr wcel wa cB cA cle wbr cB cA cfl cfv cle wbr cB cz wcel cA cr wcel wa cB
    cA cle wbr cB cA cfl cfv c1 caddc co clt wbr cB cA cfl cfv cle wbr cB cz
    wcel cA cr wcel wa cB cA cle wbr cA cA cfl cfv c1 caddc co clt wbr cB cA
    cfl cfv c1 caddc co clt wbr cA cr wcel cA cA cfl cfv c1 caddc co clt wbr cB
    cz wcel cA flltp1 adantl cB cr wcel cA cr wcel cA cfl cfv c1 caddc co cr
    wcel wa cB cA cle wbr cA cA cfl cfv c1 caddc co clt wbr wa cB cA cfl cfv c1
    caddc co clt wbr wi cB cz wcel cA cr wcel cB cr wcel cA cr wcel cA cfl cfv
    c1 caddc co cr wcel cB cA cle wbr cA cA cfl cfv c1 caddc co clt wbr wa cB
    cA cfl cfv c1 caddc co clt wbr wi cB cA cA cfl cfv c1 caddc co lelttr 3expb
    cB zre cA cr wcel cA cfl cfv c1 caddc co cr wcel cA cr wcel cA cfl cfv cr
    wcel cA cfl cfv c1 caddc co cr wcel cA reflcl cA cfl cfv peano2re syl ancli
    syl2an mpan2d cB cz wcel cA cfl cfv cz wcel cB cA cfl cfv cle wbr cB cA cfl
    cfv c1 caddc co clt wbr wb cA cr wcel cB cA cfl cfv zleltp1 cA flcl sylan2
    sylibrd cB cz wcel cA cr wcel wa cB cA cfl cfv cle wbr cA cfl cfv cA cle
    wbr cB cA cle wbr cA cr wcel cA cfl cfv cA cle wbr cB cz wcel cA flle
    adantl cB cr wcel cA cfl cfv cr wcel cA cr wcel wa cB cA cfl cfv cle wbr cA
    cfl cfv cA cle wbr wa cB cA cle wbr wi cB cz wcel cA cr wcel cB cr wcel cA
    cfl cfv cr wcel cA cr wcel cB cA cfl cfv cle wbr cA cfl cfv cA cle wbr wa
    cB cA cle wbr wi cB cA cfl cfv cA letr 3expb cB zre cA cr wcel cA cfl cfv
    cr wcel cA reflcl ancri syl2an mpan2d impbid ancoms $.
    $( [27-Dec-2004] $) $( [15-Nov-2004] $)

  $( The floor function value is less than the next integer. $)
  fllt $p |- ( ( A e. RR /\ B e. ZZ ) -> ( A < B <-> ( |_ ` A ) < B ) ) $=
    cA cr wcel cB cz wcel wa cA cB clt wbr cA cfl cfv cB clt wbr cA cr wcel cB
    cz wcel wa cB cA cle wbr cB cA cfl cfv cle wbr cA cB clt wbr wn cA cfl cfv
    cB clt wbr wn cA cB flge cB cz wcel cA cr wcel cB cA cle wbr cA cB clt wbr
    wn wb cB cr wcel cA cr wcel cB cA cle wbr cA cB clt wbr wn wb cB cz wcel cB
    cA lenlt cB zre sylan ancoms cB cz wcel cA cr wcel cB cA cfl cfv cle wbr cA
    cfl cfv cB clt wbr wn wb cB cr wcel cA cfl cfv cr wcel cB cA cfl cfv cle
    wbr cA cfl cfv cB clt wbr wn wb cB cz wcel cA cr wcel cB cA cfl cfv lenlt
    cB zre cA reflcl syl2an ancoms 3bitr3d con4bid $.
    $( [13-Mar-2005] $) $( [24-Feb-2005] $)

  $( An integer is its own floor. $)
  flid $p |- ( A e. ZZ -> ( |_ ` A ) = A ) $=
    cA cz wcel cA cfl cfv cA wceq cA cfl cfv cA cle wbr cA cA cfl cfv cle wbr
    wa cA cz wcel cA cfl cfv cA cle wbr cA cA cfl cfv cle wbr cA cz wcel cA cr
    wcel cA cfl cfv cA cle wbr cA zre cA flle syl cA cz wcel cA cA cle wbr cA
    cA cfl cfv cle wbr cA cz wcel cA cr wcel cA cA cle wbr cA zre cA leid syl
    cA cr wcel cA cz wcel cA cA cle wbr cA cA cfl cfv cle wbr wb cA zre cA cA
    flge mpancom mpbid jca cA cfl cfv cr wcel cA cr wcel cA cfl cfv cA wceq cA
    cfl cfv cA cle wbr cA cA cfl cfv cle wbr wa wb cA cz wcel cA cfl cfv cA
    letri3 cA cz wcel cA cr wcel cA cfl cfv cr wcel cA zre cA reflcl syl cA zre
    sylanc mpbird $.
    $( [27-Dec-2004] $) $( [15-Nov-2004] $)

  $( The floor function is idempotent. $)
  flidm $p |- ( A e. RR -> ( |_ ` ( |_ ` A ) ) = ( |_ ` A ) ) $=
    cA cr wcel cA cfl cfv cz wcel cA cfl cfv cfl cfv cA cfl cfv wceq cA flcl cA
    cfl cfv flid syl $.
    $( [25-Aug-2008] $) $( [17-Aug-2008] $)

  $( A real number equals its floor iff it is an integer. $)
  flidz $p |- ( A e. RR -> ( ( |_ ` A ) = A <-> A e. ZZ ) ) $=
    cA cr wcel cA cfl cfv cA wceq cA cz wcel cA cfl cfv cA wceq cA cfl cfv cz
    wcel cA cz wcel cA cr wcel cA cfl cfv cA cz eleq1 cA flcl syl5cbi cA flid
    impbid1 $.
    $( [27-Nov-2008] $) $( [11-Nov-2008] $)

  $( Ordering relationship for the greatest integer function. $)
  flwordi $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                 ( |_ ` A ) <_ ( |_ ` B ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr cA cfl cfv cB cfl cfv cle wbr cA cr
    wcel cB cr wcel wa cA cB cle wbr cA cfl cfv cB cle wbr cA cfl cfv cB cfl
    cfv cle wbr cA cr wcel cB cr wcel wa cA cfl cfv cA cle wbr cA cB cle wbr cA
    cfl cfv cB cle wbr cA cr wcel cA cfl cfv cA cle wbr cB cr wcel cA flle
    adantr cA cfl cfv cr wcel cA cr wcel cB cr wcel cA cfl cfv cA cle wbr cA cB
    cle wbr wa cA cfl cfv cB cle wbr wi cA cr wcel cB cr wcel wa cA cfl cfv cA
    cB letr cA cr wcel cA cfl cfv cr wcel cB cr wcel cA reflcl adantr cA cr
    wcel cB cr wcel pm3.26 cA cr wcel cB cr wcel pm3.27 syl3anc mpand cB cr
    wcel cA cr wcel cA cfl cfv cB cle wbr cA cfl cfv cB cfl cfv cle wbr wb cB
    cr wcel cA cfl cfv cz wcel cA cfl cfv cB cle wbr cA cfl cfv cB cfl cfv cle
    wbr wb cA cr wcel cB cA cfl cfv flge cA flcl sylan2 ancoms sylibd 3impia $.
    $( [2-Feb-2006] $) $( [31-Dec-2005] $)

  ${
    $d x y z w A $.  $d x B $.
    $( An alternate way to define the floor (greatest integer) function. $)
    flval2 $p |- ( A e. RR -> ( |_ ` A ) =
            U. { x e. ZZ | ( x <_ A /\ A. y e. ZZ ( y <_ A -> y <_ x ) ) } ) $=
      cA cr wcel vx cv cA cle wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz
      wral wa vx cz crab cuni cA cfl cfv cA cr wcel cA cfl cfv cA cle wbr vy cv
      cA cle wbr vy cv cA cfl cfv cle wbr wi vy cz wral wa vx cv cA cle wbr vy
      cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral wa vx cz crab cuni cA cfl
      cfv wceq cA cr wcel cA cfl cfv cA cle wbr vy cv cA cle wbr vy cv cA cfl
      cfv cle wbr wi vy cz wral cA flle cA cr wcel vy cv cA cle wbr vy cv cA
      cfl cfv cle wbr wi vy cz cA cr wcel vy cv cz wcel wa vy cv cA cle wbr vy
      cv cA cfl cfv cle wbr cA vy cv flge biimpd r19.21aiva jca cA cfl cfv cz
      wcel vx cv cA cle wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral
      wa vx cz wreu cA cfl cfv cA cle wbr vy cv cA cle wbr vy cv cA cfl cfv cle
      wbr wi vy cz wral wa vx cv cA cle wbr vy cv cA cle wbr vy cv vx cv cle
      wbr wi vy cz wral wa vx cz crab cuni cA cfl cfv wceq wb cA cr wcel vx cv
      cA cle wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral wa cA cfl
      cfv cA cle wbr vy cv cA cle wbr vy cv cA cfl cfv cle wbr wi vy cz wral wa
      vx cz cA cfl cfv vx cv cA cfl cfv wceq vx cv cA cle wbr cA cfl cfv cA cle
      wbr vy cv cA cle wbr vy cv vx cv cle wbr wi vy cz wral vy cv cA cle wbr
      vy cv cA cfl cfv cle wbr wi vy cz wral vx cv cA cfl cfv cA cle breq1 vx
      cv cA cfl cfv wceq vy cv cA cle wbr vy cv vx cv cle wbr wi vy cv cA cle
      wbr vy cv cA cfl cfv cle wbr wi vy cz vx cv cA cfl cfv wceq vy cv vx cv
      cle wbr vy cv cA cfl cfv cle wbr vy cv cA cle wbr vx cv cA cfl cfv vy cv
      cle breq2 imbi2d ralbidv anbi12d reuuni2 cA flcl vx vy cA zmax sylanc
      mpbid eqcomd $.
      $( [8-Feb-2005] $) $( [16-Nov-2004] $)

    $( An alternate way to define the floor (greatest integer) function, as the
       supremum of all integers less than or equal to its argument. $)
    flval3 $p |- ( A e. RR ->
                  ( |_ ` A ) = sup ( { x e. ZZ | x <_ A } , RR , < ) ) $=
      cA cr wcel cA cfl cfv vx cv cA cle wbr vx cz crab cr clt csup wceq cA cfl
      cfv vx cv cA cle wbr vx cz crab cr clt csup cle wbr cA cfl cfv vx cv cA
      cle wbr vx cz crab cr clt csup clt wbr wn wa cA cr wcel cA cfl cfv vx cv
      cA cle wbr vx cz crab cr clt csup cle wbr cA cfl cfv vx cv cA cle wbr vx
      cz crab cr clt csup clt wbr wn vx cv cA cle wbr vx cz crab cr wss vx cv
      cA cle wbr vx cz crab c0 wne vz cv vy cv cle wbr vz vx cv cA cle wbr vx
      cz crab wral vy cr wrex w3a cA cfl cfv vx cv cA cle wbr vx cz crab wcel
      cA cfl cfv vx cv cA cle wbr vx cz crab cr clt csup cle wbr cA cr wcel vy
      vz vx cv cA cle wbr vx cz crab cA cfl cfv suprub cA cr wcel vx cv cA cle
      wbr vx cz crab cr wss vx cv cA cle wbr vx cz crab c0 wne vz cv vy cv cle
      wbr vz vx cv cA cle wbr vx cz crab wral vy cr wrex vx cv cA cle wbr vx cz
      crab cr wss cA cr wcel vx cv cA cle wbr vx cz crab cz cr vx cv cA cle wbr
      vx cz ssrab2 zssre sstri a1i cA cr wcel cA cfl cfv vx cv cA cle wbr vx cz
      crab wcel vx cv cA cle wbr vx cz crab c0 wne cA cfl cfv vx cv cA cle wbr
      vx cz crab wcel cA cfl cfv cz wcel cA cfl cfv cA cle wbr cA cr wcel vx cv
      cA cle wbr cA cfl cfv cA cle wbr vx cA cfl cfv cz vx cv cA cfl cfv cA cle
      breq1 elrab cA flcl cA flle sylanbrc vx cv cA cle wbr vx cz crab cA cfl
      cfv ne0i syl cA cfl cfv cr wcel vz cv cA cfl cfv cle wbr vz vx cv cA cle
      wbr vx cz crab wral vz cv vy cv cle wbr vz vx cv cA cle wbr vx cz crab
      wral vy cr wrex cA cr wcel vz cv vy cv cle wbr vz vx cv cA cle wbr vx cz
      crab wral vz cv cA cfl cfv cle wbr vz vx cv cA cle wbr vx cz crab wral vy
      cA cfl cfv cr vy cv cA cfl cfv wceq vz cv vy cv cle wbr vz cv cA cfl cfv
      cle wbr vz vx cv cA cle wbr vx cz crab vy cv cA cfl cfv vz cv cle breq2
      ralbidv rcla4ev cA reflcl cA cr wcel vz cv cA cfl cfv cle wbr vz vx cv cA
      cle wbr vx cz crab cA cr wcel vz cv cz wcel vz cv cA cle wbr wa vz cv cA
      cfl cfv cle wbr vz cv vx cv cA cle wbr vx cz crab wcel cA cr wcel vz cv
      cz wcel vz cv cA cle wbr vz cv cA cfl cfv cle wbr cA cr wcel vz cv cz
      wcel wa vz cv cA cle wbr vz cv cA cfl cfv cle wbr cA vz cv flge biimpd
      expimpd vx cv cA cle wbr vz cv cA cle wbr vx vz cv cz vx cv vz cv cA cle
      breq1 elrab syl5ib r19.21aiv sylanc 3jca cA cfl cfv vx cv cA cle wbr vx
      cz crab wcel cA cfl cfv cz wcel cA cfl cfv cA cle wbr cA cr wcel vx cv cA
      cle wbr cA cfl cfv cA cle wbr vx cA cfl cfv cz vx cv cA cfl cfv cA cle
      breq1 elrab cA flcl cA flle sylanbrc sylanc vx cv cA cle wbr vx cz crab
      cr wss vx cv cA cle wbr vx cz crab c0 wne vz cv vy cv cle wbr vz vx cv cA
      cle wbr vx cz crab wral vy cr wrex w3a cA cfl cfv cr wcel cA cfl cfv vw
      cv clt wbr wn vw vx cv cA cle wbr vx cz crab wral wa cA cfl cfv vx cv cA
      cle wbr vx cz crab cr clt csup clt wbr wn cA cr wcel vy vz vw vx cv cA
      cle wbr vx cz crab cA cfl cfv suprnub cA cr wcel vx cv cA cle wbr vx cz
      crab cr wss vx cv cA cle wbr vx cz crab c0 wne vz cv vy cv cle wbr vz vx
      cv cA cle wbr vx cz crab wral vy cr wrex vx cv cA cle wbr vx cz crab cr
      wss cA cr wcel vx cv cA cle wbr vx cz crab cz cr vx cv cA cle wbr vx cz
      ssrab2 zssre sstri a1i cA cr wcel cA cfl cfv vx cv cA cle wbr vx cz crab
      wcel vx cv cA cle wbr vx cz crab c0 wne cA cfl cfv vx cv cA cle wbr vx cz
      crab wcel cA cfl cfv cz wcel cA cfl cfv cA cle wbr cA cr wcel vx cv cA
      cle wbr cA cfl cfv cA cle wbr vx cA cfl cfv cz vx cv cA cfl cfv cA cle
      breq1 elrab cA flcl cA flle sylanbrc vx cv cA cle wbr vx cz crab cA cfl
      cfv ne0i syl cA cfl cfv cr wcel vz cv cA cfl cfv cle wbr vz vx cv cA cle
      wbr vx cz crab wral vz cv vy cv cle wbr vz vx cv cA cle wbr vx cz crab
      wral vy cr wrex cA cr wcel vz cv vy cv cle wbr vz vx cv cA cle wbr vx cz
      crab wral vz cv cA cfl cfv cle wbr vz vx cv cA cle wbr vx cz crab wral vy
      cA cfl cfv cr vy cv cA cfl cfv wceq vz cv vy cv cle wbr vz cv cA cfl cfv
      cle wbr vz vx cv cA cle wbr vx cz crab vy cv cA cfl cfv vz cv cle breq2
      ralbidv rcla4ev cA reflcl cA cr wcel vz cv cA cfl cfv cle wbr vz vx cv cA
      cle wbr vx cz crab cA cr wcel vz cv cz wcel vz cv cA cle wbr wa vz cv cA
      cfl cfv cle wbr vz cv vx cv cA cle wbr vx cz crab wcel cA cr wcel vz cv
      cz wcel vz cv cA cle wbr vz cv cA cfl cfv cle wbr cA cr wcel vz cv cz
      wcel wa vz cv cA cle wbr vz cv cA cfl cfv cle wbr cA vz cv flge biimpd
      expimpd vx cv cA cle wbr vz cv cA cle wbr vx vz cv cz vx cv vz cv cA cle
      breq1 elrab syl5ib r19.21aiv sylanc 3jca cA cr wcel cA cfl cfv cr wcel cA
      cfl cfv vw cv clt wbr wn vw vx cv cA cle wbr vx cz crab wral cA reflcl cA
      cr wcel cA cfl cfv vw cv clt wbr wn vw vx cv cA cle wbr vx cz crab cA cr
      wcel vw cv cz wcel vw cv cA cle wbr wa cA cfl cfv vw cv clt wbr wn vw cv
      vx cv cA cle wbr vx cz crab wcel cA cr wcel vw cv cz wcel vw cv cA cle
      wbr cA cfl cfv vw cv clt wbr wn cA cr wcel vw cv cz wcel wa vw cv cA cle
      wbr cA cfl cfv vw cv clt wbr wn cA cr wcel vw cv cz wcel wa vw cv cA cle
      wbr vw cv cA cfl cfv cle wbr cA cfl cfv vw cv clt wbr wn cA vw cv flge vw
      cv cz wcel cA cr wcel vw cv cA cfl cfv cle wbr cA cfl cfv vw cv clt wbr
      wn wb vw cv cr wcel cA cfl cfv cr wcel vw cv cA cfl cfv cle wbr cA cfl
      cfv vw cv clt wbr wn wb vw cv cz wcel cA cr wcel vw cv cA cfl cfv lenlt
      vw cv zre cA reflcl syl2an ancoms bitrd biimpd expimpd vx cv cA cle wbr
      vw cv cA cle wbr vx vw cv cz vx cv vw cv cA cle breq1 elrab syl5ib
      r19.21aiv jca sylanc jca cA cfl cfv cr wcel vx cv cA cle wbr vx cz crab
      cr clt csup cr wcel cA cfl cfv vx cv cA cle wbr vx cz crab cr clt csup
      wceq cA cfl cfv vx cv cA cle wbr vx cz crab cr clt csup cle wbr cA cfl
      cfv vx cv cA cle wbr vx cz crab cr clt csup clt wbr wn wa wb cA cr wcel
      cA cfl cfv vx cv cA cle wbr vx cz crab cr clt csup eqlelt cA reflcl vx cv
      cA cle wbr vx cz crab cr wss vx cv cA cle wbr vx cz crab c0 wne vz cv vy
      cv cle wbr vz vx cv cA cle wbr vx cz crab wral vy cr wrex vx cv cA cle
      wbr vx cz crab cr clt csup cr wcel cA cr wcel vy vz vx cv cA cle wbr vx
      cz crab suprcl vx cv cA cle wbr vx cz crab cr wss cA cr wcel vx cv cA cle
      wbr vx cz crab cz cr vx cv cA cle wbr vx cz ssrab2 zssre sstri a1i cA cr
      wcel cA cfl cfv vx cv cA cle wbr vx cz crab wcel vx cv cA cle wbr vx cz
      crab c0 wne cA cfl cfv vx cv cA cle wbr vx cz crab wcel cA cfl cfv cz
      wcel cA cfl cfv cA cle wbr cA cr wcel vx cv cA cle wbr cA cfl cfv cA cle
      wbr vx cA cfl cfv cz vx cv cA cfl cfv cA cle breq1 elrab cA flcl cA flle
      sylanbrc vx cv cA cle wbr vx cz crab cA cfl cfv ne0i syl cA cfl cfv cr
      wcel vz cv cA cfl cfv cle wbr vz vx cv cA cle wbr vx cz crab wral vz cv
      vy cv cle wbr vz vx cv cA cle wbr vx cz crab wral vy cr wrex cA cr wcel
      vz cv vy cv cle wbr vz vx cv cA cle wbr vx cz crab wral vz cv cA cfl cfv
      cle wbr vz vx cv cA cle wbr vx cz crab wral vy cA cfl cfv cr vy cv cA cfl
      cfv wceq vz cv vy cv cle wbr vz cv cA cfl cfv cle wbr vz vx cv cA cle wbr
      vx cz crab vy cv cA cfl cfv vz cv cle breq2 ralbidv rcla4ev cA reflcl cA
      cr wcel vz cv cA cfl cfv cle wbr vz vx cv cA cle wbr vx cz crab cA cr
      wcel vz cv cz wcel vz cv cA cle wbr wa vz cv cA cfl cfv cle wbr vz cv vx
      cv cA cle wbr vx cz crab wcel cA cr wcel vz cv cz wcel vz cv cA cle wbr
      vz cv cA cfl cfv cle wbr cA cr wcel vz cv cz wcel wa vz cv cA cle wbr vz
      cv cA cfl cfv cle wbr cA vz cv flge biimpd expimpd vx cv cA cle wbr vz cv
      cA cle wbr vx vz cv cz vx cv vz cv cA cle breq1 elrab syl5ib r19.21aiv
      sylanc syl3anc sylanc mpbird $.
      $( [30-May-2005] $) $( [15-Nov-2004] $)

    $( A condition equivalent to floor. $)
    flbi $p |- ( ( A e. RR /\ B e. ZZ ) ->
                ( ( |_ ` A ) = B <-> ( B <_ A /\ A < ( B + 1 ) ) ) ) $=
      cA cr wcel cB cz wcel wa cA cfl cfv cB wceq vx cv cA cle wbr cA vx cv c1
      caddc co clt wbr wa vx cz crab cuni cB wceq cB cA cle wbr cA cB c1 caddc
      co clt wbr wa cA cr wcel cA cfl cfv cB wceq vx cv cA cle wbr cA vx cv c1
      caddc co clt wbr wa vx cz crab cuni cB wceq wb cB cz wcel cA cr wcel cA
      cfl cfv vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx cz crab cuni
      cB vx cA flval eqeq1d adantr cB cz wcel cA cr wcel cB cA cle wbr cA cB c1
      caddc co clt wbr wa vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa vx
      cz crab cuni cB wceq wb cB cz wcel vx cv cA cle wbr cA vx cv c1 caddc co
      clt wbr wa vx cz wreu cB cA cle wbr cA cB c1 caddc co clt wbr wa vx cv cA
      cle wbr cA vx cv c1 caddc co clt wbr wa vx cz crab cuni cB wceq wb cA cr
      wcel vx cv cA cle wbr cA vx cv c1 caddc co clt wbr wa cB cA cle wbr cA cB
      c1 caddc co clt wbr wa vx cz cB vx cv cB wceq vx cv cA cle wbr cB cA cle
      wbr cA vx cv c1 caddc co clt wbr cA cB c1 caddc co clt wbr vx cv cB cA
      cle breq1 vx cv cB wceq vx cv c1 caddc co cB c1 caddc co cA clt vx cv cB
      c1 caddc opreq1 breq2d anbi12d reuuni2 vx cA rebtwnz sylan2 ancoms bitr4d
      $.
      $( [28-Apr-2005] $) $( [11-Mar-2005] $)
  $}

  $( A condition equivalent to floor. $)
  flbi2 $p |- ( ( N e. ZZ /\ F e. RR ) ->
              ( ( |_ ` ( N + F ) ) = N <-> ( 0 <_ F /\ F < 1 ) ) ) $=
    cN cz wcel cF cr wcel wa cN cF caddc co cfl cfv cN wceq cN cN cF caddc co
    cle wbr cN cF caddc co cN c1 caddc co clt wbr wa cc0 cF cle wbr cF c1 clt
    wbr wa cN cF caddc co cr wcel cN cz wcel cN cF caddc co cfl cfv cN wceq cN
    cN cF caddc co cle wbr cN cF caddc co cN c1 caddc co clt wbr wa wb cN cz
    wcel cF cr wcel wa cN cF caddc co cN flbi cN cr wcel cF cr wcel cN cF caddc
    co cr wcel cN cz wcel cN cF readdcl cN zre sylan cN cz wcel cF cr wcel
    pm3.26 sylanc cN cr wcel cF cr wcel cc0 cF cle wbr cF c1 clt wbr wa cN cN
    cF caddc co cle wbr cN cF caddc co cN c1 caddc co clt wbr wa wb cN cz wcel
    cN cr wcel cF cr wcel wa cc0 cF cle wbr cN cN cF caddc co cle wbr cF c1 clt
    wbr cN cF caddc co cN c1 caddc co clt wbr cN cF addge01 cF cr wcel cN cr
    wcel cF c1 clt wbr cN cF caddc co cN c1 caddc co clt wbr wb cF cr wcel c1
    cr wcel cN cr wcel cF c1 clt wbr cN cF caddc co cN c1 caddc co clt wbr wb
    1re cF c1 cN ltadd2 mp3an2 ancoms anbi12d cN zre sylan bitr4d $.
    $( [15-Aug-2008] $) $( [15-Aug-2008] $)

  $( The floor of a number greater than or equal to 0 is a nonnegative
     integer. $)
  flge0nn0 $p |- ( ( A e. RR /\ 0 <_ A ) -> ( |_ ` A ) e. NN0 ) $=
    cA cfl cfv cn0 wcel cA cfl cfv cz wcel cc0 cA cfl cfv cle wbr cA cr wcel
    cc0 cA cle wbr wa cA cfl cfv elnn0z cA cr wcel cA cfl cfv cz wcel cc0 cA
    cle wbr cA flcl adantr cA cr wcel cc0 cA cle wbr cc0 cA cfl cfv cle wbr cA
    cr wcel cc0 cz wcel cc0 cA cle wbr cc0 cA cfl cfv cle wbr wb 0z cA cc0 flge
    mpan2 biimpa sylanbrc $.
    $( [2-May-2005] $) $( [26-Apr-2005] $)

  $( The floor of a number greater than or equal to 1 is a natural number. $)
  flge1nn $p |- ( ( A e. RR /\ 1 <_ A ) -> ( |_ ` A ) e. NN ) $=
    cA cfl cfv cn wcel cA cfl cfv cz wcel c1 cA cfl cfv cle wbr cA cr wcel c1
    cA cle wbr wa cA cfl cfv elnnz1 cA cr wcel cA cfl cfv cz wcel c1 cA cle wbr
    cA flcl adantr cA cr wcel c1 cA cle wbr c1 cA cfl cfv cle wbr cA cr wcel c1
    cz wcel c1 cA cle wbr c1 cA cfl cfv cle wbr wb 1z cA c1 flge mpan2 biimpa
    sylanbrc $.
    $( [24-Jun-2005] $) $( [26-Apr-2005] $)

  $( An integer can be moved in and out of the floor of a sum. $)
  fladdz $p |- ( ( A e. RR /\ N e. ZZ ) -> ( |_ ` ( A + N ) ) =
                ( ( |_ ` A ) + N ) ) $=
    cA cr wcel cN cz wcel wa cA cN caddc co cfl cfv cA cfl cfv cN caddc co wceq
    cA cfl cfv cN caddc co cA cN caddc co cle wbr cA cN caddc co cA cfl cfv cN
    caddc co c1 caddc co clt wbr wa cA cr wcel cN cz wcel wa cA cfl cfv cN
    caddc co cA cN caddc co cle wbr cA cN caddc co cA cfl cfv cN caddc co c1
    caddc co clt wbr cA cr wcel cN cz wcel wa cA cfl cfv cA cle wbr cA cfl cfv
    cN caddc co cA cN caddc co cle wbr cA cr wcel cA cfl cfv cA cle wbr cN cz
    wcel cA flle adantr cA cfl cfv cr wcel cA cr wcel wa cN cr wcel cA cfl cfv
    cA cle wbr cA cfl cfv cN caddc co cA cN caddc co cle wbr wb cA cr wcel cN
    cz wcel cA cfl cfv cr wcel cA cr wcel cN cr wcel cA cfl cfv cA cle wbr cA
    cfl cfv cN caddc co cA cN caddc co cle wbr wb cA cfl cfv cA cN leadd1 3expa
    cA cr wcel cA cfl cfv cr wcel cA reflcl ancri cN zre syl2an mpbid cA cr
    wcel cN cz wcel wa cA cN caddc co cA cfl cfv c1 caddc co cN caddc co cA cfl
    cfv cN caddc co c1 caddc co clt cA cr wcel cN cz wcel wa cA cA cfl cfv c1
    caddc co clt wbr cA cN caddc co cA cfl cfv c1 caddc co cN caddc co clt wbr
    cA cr wcel cA cA cfl cfv c1 caddc co clt wbr cN cz wcel cA flltp1 adantr cA
    cr wcel cA cfl cfv c1 caddc co cr wcel wa cN cr wcel cA cA cfl cfv c1 caddc
    co clt wbr cA cN caddc co cA cfl cfv c1 caddc co cN caddc co clt wbr wb cA
    cr wcel cN cz wcel cA cr wcel cA cfl cfv c1 caddc co cr wcel cN cr wcel cA
    cA cfl cfv c1 caddc co clt wbr cA cN caddc co cA cfl cfv c1 caddc co cN
    caddc co clt wbr wb cA cA cfl cfv c1 caddc co cN ltadd1 3expa cA cr wcel cA
    cfl cfv c1 caddc co cr wcel cA cr wcel cA cfl cfv cr wcel cA cfl cfv c1
    caddc co cr wcel cA reflcl cA cfl cfv peano2re syl ancli cN zre syl2an
    mpbid cA cfl cfv cc wcel cN cc wcel cA cfl cfv c1 caddc co cN caddc co cA
    cfl cfv cN caddc co c1 caddc co wceq cA cr wcel cN cz wcel cA cfl cfv cc
    wcel c1 cc wcel cN cc wcel cA cfl cfv c1 caddc co cN caddc co cA cfl cfv cN
    caddc co c1 caddc co wceq ax1cn cA cfl cfv c1 cN add23 mp3an2 cA cr wcel cA
    cfl cfv cA reflcl recnd cN zcn syl2an breqtrd jca cA cN caddc co cr wcel cA
    cfl cfv cN caddc co cz wcel cA cN caddc co cfl cfv cA cfl cfv cN caddc co
    wceq cA cfl cfv cN caddc co cA cN caddc co cle wbr cA cN caddc co cA cfl
    cfv cN caddc co c1 caddc co clt wbr wa wb cA cr wcel cN cz wcel wa cA cN
    caddc co cA cfl cfv cN caddc co flbi cA cr wcel cN cr wcel cA cN caddc co
    cr wcel cN cz wcel cA cN readdcl cN zre sylan2 cA cfl cfv cz wcel cN cz
    wcel cA cfl cfv cN caddc co cz wcel cA cr wcel cA cfl cfv cN zaddcl cA flcl
    sylan sylanc mpbird $.
    $( [13-Jun-2005] $) $( [27-Apr-2005] $)

  $( An integer can be moved in and out of the floor of a sum. $)
  flzadd $p |- ( ( N e. ZZ /\ A e. RR ) -> ( |_ ` ( N + A ) ) =
                ( N + ( |_ ` A ) ) ) $=
    cA cr wcel cN cz wcel cN cA caddc co cfl cfv cN cA cfl cfv caddc co wceq cA
    cr wcel cN cz wcel wa cA cN caddc co cfl cfv cA cfl cfv cN caddc co cN cA
    caddc co cfl cfv cN cA cfl cfv caddc co cA cN fladdz cA cr wcel cN cz wcel
    wa cA cN caddc co cN cA caddc co cfl cA cc wcel cN cc wcel cA cN caddc co
    cN cA caddc co wceq cA cr wcel cN cz wcel cA cN addcom cA recn cN zcn
    syl2an fveq2d cA cfl cfv cc wcel cN cc wcel cA cfl cfv cN caddc co cN cA
    cfl cfv caddc co wceq cA cr wcel cN cz wcel cA cfl cfv cN addcom cA cr wcel
    cA cfl cfv cA reflcl recnd cN zcn syl2an 3eqtr3d ancoms $.
    $( [12-Feb-2009] $) $( [2-Jan-2009] $)

  $( A real bounded between an integer and its successor is nonnegative iff
     the integer is nonnegative.  Second half of Lemma 13-4.1 of [Gleason]
     p. 217.  (For the first half see ~ rebtwnz .) $)
  btwnzge0 $p |- ( ( ( A e. RR /\ N e. ZZ ) /\ ( N <_ A /\ A < ( N + 1 ) ) )
                -> ( 0 <_ A <-> 0 <_ N ) ) $=
    cA cr wcel cN cz wcel wa cN cA cle wbr cA cN c1 caddc co clt wbr wa wa cc0
    cA cle wbr cc0 cA cfl cfv cle wbr cc0 cN cle wbr cA cr wcel cc0 cA cle wbr
    cc0 cA cfl cfv cle wbr wb cN cz wcel cN cA cle wbr cA cN c1 caddc co clt
    wbr wa cA cr wcel cc0 cz wcel cc0 cA cle wbr cc0 cA cfl cfv cle wbr wb 0z
    cA cc0 flge mpan2 ad2antrr cA cr wcel cN cz wcel wa cN cA cle wbr cA cN c1
    caddc co clt wbr wa wa cA cfl cfv cN cc0 cle cA cr wcel cN cz wcel wa cA
    cfl cfv cN wceq cN cA cle wbr cA cN c1 caddc co clt wbr wa cA cN flbi
    biimpar breq2d bitrd $.
    $( [28-Apr-2005] $) $( [12-Mar-2005] $)

  $( Ordering relation for the floor of half of an integer. $)
  flhalf $p |- ( N e. ZZ -> N <_ ( 2 x. ( |_ ` ( ( N + 1 ) / 2 ) ) ) ) $=
    cN cz wcel cN c2 cdiv co cz wcel cN c1 caddc co c2 cdiv co cz wcel wo cN c2
    cN c1 caddc co c2 cdiv co cfl cfv cmul co cle wbr cN zeo cN cz wcel cN c2
    cdiv co cz wcel cN c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co cle wbr cN
    c1 caddc co c2 cdiv co cz wcel cN cz wcel cN c2 cdiv co cz wcel wa c2 cN c2
    cdiv co cfl cfv cmul co cN c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co cle
    cN c2 cdiv co cz wcel cN cz wcel c2 cN c2 cdiv co cfl cfv cmul co c2 cN c2
    cdiv co cmul co cN cN c2 cdiv co cz wcel cN c2 cdiv co cfl cfv cN c2 cdiv
    co c2 cmul cN c2 cdiv co flid opreq2d cN cz wcel cN cc wcel c2 cN c2 cdiv
    co cmul co cN wceq cN zcn cN cc wcel c2 cc wcel c2 cc0 wne c2 cN c2 cdiv co
    cmul co cN wceq 2cn 2ne0 cN c2 divcan2 mp3an23 syl sylan9eqr cN cz wcel c2
    cN c2 cdiv co cfl cfv cmul co c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co
    cle wbr cN c2 cdiv co cz wcel cN c2 cdiv co cfl cfv cr wcel cN c1 caddc co
    c2 cdiv co cfl cfv cr wcel c2 cr wcel w3a cc0 c2 cle wbr cN c2 cdiv co cfl
    cfv cN c1 caddc co c2 cdiv co cfl cfv cle wbr wa c2 cN c2 cdiv co cfl cfv
    cmul co c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co cle wbr cN cz wcel cN
    c2 cdiv co cfl cfv cN c1 caddc co c2 cdiv co cfl cfv c2 lemul2aOLD cN cz
    wcel cN c2 cdiv co cfl cfv cr wcel cN c1 caddc co c2 cdiv co cfl cfv cr
    wcel c2 cr wcel cN cz wcel cN c2 cdiv co cr wcel cN c2 cdiv co cfl cfv cr
    wcel cN cz wcel cN cr wcel cN c2 cdiv co cr wcel cN zre cN rehalfcl syl cN
    c2 cdiv co reflcl syl cN cz wcel cN c1 caddc co c2 cdiv co cr wcel cN c1
    caddc co c2 cdiv co cfl cfv cz wcel cN c1 caddc co c2 cdiv co cfl cfv cr
    wcel cN cz wcel cN cr wcel cN c1 caddc co cr wcel cN c1 caddc co c2 cdiv co
    cr wcel cN zre cN peano2re cN c1 caddc co rehalfcl 3syl cN c1 caddc co c2
    cdiv co flcl cN c1 caddc co c2 cdiv co cfl cfv zre 3syl c2 cr wcel cN cz
    wcel 2re a1i 3jca cN cz wcel cN c2 cdiv co cfl cfv cN c1 caddc co c2 cdiv
    co cfl cfv cle wbr cc0 c2 cle wbr cN c2 cdiv co cr wcel cN c1 caddc co c2
    cdiv co cr wcel cN c2 cdiv co cN c1 caddc co c2 cdiv co cle wbr cN c2 cdiv
    co cfl cfv cN c1 caddc co c2 cdiv co cfl cfv cle wbr cN cz wcel cN c2 cdiv
    co cN c1 caddc co c2 cdiv co flwordi cN cz wcel cN cr wcel cN c2 cdiv co cr
    wcel cN zre cN rehalfcl syl cN cz wcel cN cr wcel cN c1 caddc co cr wcel cN
    c1 caddc co c2 cdiv co cr wcel cN zre cN peano2re cN c1 caddc co rehalfcl
    3syl cN cr wcel cN c1 caddc co cr wcel cN c2 cdiv co cN c1 caddc co c2 cdiv
    co cle wbr cN cz wcel cN cr wcel cN c1 caddc co cr wcel wa cN cN c1 caddc
    co cle wbr cN c2 cdiv co cN c1 caddc co c2 cdiv co cle wbr cN cr wcel cN cN
    c1 caddc co cle wbr cN c1 caddc co cr wcel cN lep1 adantr cN cr wcel cN c1
    caddc co cr wcel c2 cr wcel cN cN c1 caddc co cle wbr cN c2 cdiv co cN c1
    caddc co c2 cdiv co cle wbr wb 2re cN cr wcel cN c1 caddc co cr wcel c2 cr
    wcel w3a cc0 c2 clt wbr cN cN c1 caddc co cle wbr cN c2 cdiv co cN c1 caddc
    co c2 cdiv co cle wbr wb 2pos cN cN c1 caddc co c2 lediv1OLD mpan2 mp3an3
    mpbid cN zre cN cz wcel cN cr wcel cN c1 caddc co cr wcel cN zre cN
    peano2re syl sylanc syl3anc cc0 c2 0re 2re 2pos ltleii jctil sylanc adantr
    eqbrtrrd cN cz wcel cN c1 caddc co c2 cdiv co cz wcel wa cN cN c1 caddc co
    c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co cle cN cz wcel cN cN c1 caddc
    co cle wbr cN c1 caddc co c2 cdiv co cz wcel cN cz wcel cN cr wcel cN cN c1
    caddc co cle wbr cN zre cN lep1 syl adantr cN c1 caddc co c2 cdiv co cz
    wcel cN cz wcel c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co c2 cN c1 caddc
    co c2 cdiv co cmul co cN c1 caddc co cN c1 caddc co c2 cdiv co cz wcel cN
    c1 caddc co c2 cdiv co cfl cfv cN c1 caddc co c2 cdiv co c2 cmul cN c1
    caddc co c2 cdiv co flid opreq2d cN cz wcel cN cc wcel cN c1 caddc co cc
    wcel c2 cN c1 caddc co c2 cdiv co cmul co cN c1 caddc co wceq cN zcn cN
    peano2cn cN c1 caddc co cc wcel c2 cc wcel c2 cc0 wne c2 cN c1 caddc co c2
    cdiv co cmul co cN c1 caddc co wceq 2cn 2ne0 cN c1 caddc co c2 divcan2
    mp3an23 3syl sylan9eqr breqtrrd jaodan mpdan $.
    $( [7-Feb-2006] $) $( [1-Jan-2006] $)

  $( The ceiling function returns an integer (closure law).  (Contributed by
     Jeffrey Hankins, 10-Jun-2007.) $)
  ceicl $p |- ( A e. RR -> -u ( |_ ` -u A ) e. ZZ ) $=
    cA cr wcel cA cneg cr wcel cA cneg cfl cfv cz wcel cA cneg cfl cfv cneg cz
    wcel cA renegcl cA cneg flcl cA cneg cfl cfv znegcl 3syl $.
    $( [11-Jun-2007] $) $( [8-Jun-2007] $)

  $( The ceiling of a real number is greater than or equal to that number.
     (Contributed by Jeffrey Hankins, 10-Jun-2007.) $)
  ceige $p |- ( A e. RR -> A <_ -u ( |_ ` -u A ) ) $=
    cA cr wcel cA cneg cfl cfv cr wcel cA cA cneg cfl cfv cneg cle wbr cA cr
    wcel cA cneg cr wcel cA cneg cfl cfv cr wcel cA renegcl cA cneg reflcl syl
    cA cr wcel cA cneg cfl cfv cr wcel wa cA cA cneg cfl cfv cneg cle wbr cA
    cneg cfl cfv cA cneg cle wbr cA cr wcel cA cneg cfl cfv cA cneg cle wbr cA
    cneg cfl cfv cr wcel cA cr wcel cA cneg cr wcel cA cneg cfl cfv cA cneg cle
    wbr cA renegcl cA cneg flle syl adantr cA cA cneg cfl cfv lenegcon2 mpbird
    mpdan $.
    $( [11-Jun-2007] $) $( [9-Jun-2007] $)

  $( One less than the ceiling of a real number is strictly less than that
     number.  (Contributed by Jeffrey Hankins, 10-Jun-2007.) $)
  ceim1l $p |- ( A e. RR -> ( -u ( |_ ` -u A ) - 1 ) < A ) $=
    cA cr wcel cA cneg cfl cfv cneg c1 cmin co cA cneg cfl cfv c1 caddc co cneg
    cA clt cA cr wcel cA cneg cfl cfv c1 caddc co cneg cA cneg cfl cfv cneg c1
    cneg caddc co cA cneg cfl cfv cneg c1 cmin co cA cneg cfl cfv cc wcel c1 cc
    wcel cA cneg cfl cfv c1 caddc co cneg cA cneg cfl cfv cneg c1 cneg caddc co
    wceq cA cr wcel cA cneg cfl cfv c1 negdi cA cr wcel cA cneg cfl cfv cA cr
    wcel cA cneg cr wcel cA cneg cfl cfv cr wcel cA renegcl cA cneg reflcl syl
    recnd ax1cn sylancl cA cr wcel cA cneg cfl cfv cc wcel cA cneg cfl cfv cneg
    cc wcel cA cneg cfl cfv cneg c1 cneg caddc co cA cneg cfl cfv cneg c1 cmin
    co wceq cA cr wcel cA cneg cfl cfv cA cr wcel cA cneg cr wcel cA cneg cfl
    cfv cr wcel cA renegcl cA cneg reflcl syl recnd cA cneg cfl cfv negcl cA
    cneg cfl cfv cneg cc wcel c1 cc wcel cA cneg cfl cfv cneg c1 cneg caddc co
    cA cneg cfl cfv cneg c1 cmin co wceq ax1cn cA cneg cfl cfv cneg c1 negsub
    mpan2 3syl eqtr2d cA cr wcel cA cneg cfl cfv c1 caddc co cr wcel cA cneg
    cfl cfv c1 caddc co cneg cA clt wbr cA cr wcel cA cneg cfl cfv cr wcel cA
    cneg cfl cfv c1 caddc co cr wcel cA cr wcel cA cneg cr wcel cA cneg cfl cfv
    cr wcel cA renegcl cA cneg reflcl syl cA cneg cfl cfv peano2re syl cA cr
    wcel cA cneg cfl cfv c1 caddc co cr wcel wa cA cneg cA cneg cfl cfv c1
    caddc co clt wbr cA cneg cfl cfv c1 caddc co cneg cA clt wbr cA cr wcel cA
    cneg cA cneg cfl cfv c1 caddc co clt wbr cA cneg cfl cfv c1 caddc co cr
    wcel cA cr wcel cA cneg cr wcel cA cneg cA cneg cfl cfv c1 caddc co clt wbr
    cA renegcl cA cneg flltp1 syl adantr cA cA cneg cfl cfv c1 caddc co
    ltnegcon1 mpbid mpdan eqbrtrd $.
    $( [11-Jun-2007] $) $( [9-Jun-2007] $)

  $( The ceiling of a real number is the smallest integer greater than or equal
     to it.  (Contributed by Jeffrey Hankins, 10-Jun-2007.) $)
  ceile $p |- ( ( A e. RR /\ B e. ZZ /\ A <_ B ) -> -u ( |_ ` -u A ) <_ B ) $=
    cA cr wcel cB cz wcel cA cB cle wbr cA cneg cfl cfv cneg cB cle wbr cA cr
    wcel cB cz wcel wa cA cB cle wbr cA cneg cfl cfv cneg c1 cmin co cB clt wbr
    cA cneg cfl cfv cneg cB cle wbr cA cr wcel cB cz wcel wa cA cneg cfl cfv
    cneg c1 cmin co cA clt wbr cA cB cle wbr cA cneg cfl cfv cneg c1 cmin co cB
    clt wbr cA cr wcel cA cneg cfl cfv cneg c1 cmin co cA clt wbr cB cz wcel cA
    ceim1l adantr cA cneg cfl cfv cneg c1 cmin co cr wcel cA cr wcel cB cr wcel
    cA cneg cfl cfv cneg c1 cmin co cA clt wbr cA cB cle wbr wa cA cneg cfl cfv
    cneg c1 cmin co cB clt wbr wi cA cr wcel cB cz wcel wa cA cneg cfl cfv cneg
    c1 cmin co cA cB ltletr cA cr wcel cA cneg cfl cfv cneg c1 cmin co cr wcel
    cB cz wcel cA cr wcel cA cneg cfl cfv cneg cz wcel cA cneg cfl cfv cneg cr
    wcel cA cneg cfl cfv cneg c1 cmin co cr wcel cA ceicl cA cneg cfl cfv cneg
    zre cA cneg cfl cfv cneg peano2rem 3syl adantr cA cr wcel cB cz wcel pm3.26
    cB cz wcel cB cr wcel cA cr wcel cB zre adantl syl3anc mpand cA cneg cfl
    cfv cneg cz wcel cB cz wcel cA cneg cfl cfv cneg cB cle wbr cA cneg cfl cfv
    cneg c1 cmin co cB clt wbr wb cA cr wcel cA cneg cfl cfv cneg cB zlem1lt cA
    ceicl sylan sylibrd 3impia $.
    $( [11-Jun-2007] $) $( [10-Jun-2007] $)

  ${
    quorem.1 $e |- Q = ( |_ ` ( A / B ) ) $.
    quorem.2 $e |- R = ( A - ( B x. Q ) ) $.
    $( MAY BE REVISED - is this really needed for anything?  Should we use
       mod to simplify it? $)
    $( Quotient and remainder of an integer divided by a natural number. $)
    quoremz $p |- ( ( A e. ZZ /\ B e. NN ) -> ( ( Q e. ZZ /\ R e. NN0 )
          /\ ( R < B /\ A = ( ( B x. Q ) + R ) ) ) ) $=
      cA cz wcel cB cn wcel wa cQ cz wcel cR cn0 wcel cR cB clt wbr cA cB cQ
      cmul co cR caddc co wceq wa cA cz wcel cB cn wcel wa cA cB cdiv co cfl
      cfv cz cQ cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co
      cfl cfv cz wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA
      cz wcel cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA
      zre adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB
      cc0 wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flcl syl
      quorem.1 syl5eqel cA cz wcel cB cn wcel wa cA cB cQ cmul co cmin co cn0
      cR cB cQ cmul co cz wcel cA cz wcel cB cQ cmul co cA cle wbr cA cB cQ
      cmul co cmin co cn0 wcel cA cz wcel cB cn wcel wa cB cQ cmul co cA
      znn0sub2 cB cz wcel cQ cz wcel cB cQ cmul co cz wcel cA cz wcel cB cn
      wcel wa cB cQ zmulcl cB cn wcel cB cz wcel cA cz wcel cB nnz adantl cA cz
      wcel cB cn wcel wa cA cB cdiv co cfl cfv cz cQ cA cz wcel cB cn wcel wa
      cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cz wcel cA cr wcel cB cr wcel
      cB cc0 wne cA cB cdiv co cr wcel cA cz wcel cB cn wcel wa cA cB redivcl
      cA cz wcel cA cr wcel cB cn wcel cA zre adantr cB cn wcel cB cr wcel cA
      cz wcel cB nnre adantl cB cn wcel cB cc0 wne cA cz wcel cB nnne0 adantl
      syl3anc cA cB cdiv co flcl syl quorem.1 syl5eqel sylanc cA cz wcel cB cn
      wcel pm3.26 cA cz wcel cB cn wcel wa cB cQ cmul co cA cle wbr cB cQ cmul
      co cB cdiv co cA cB cdiv co cle wbr cA cz wcel cB cn wcel wa cB cQ cmul
      co cB cdiv co cQ cA cB cdiv co cle cQ cc wcel cB cc wcel cB cc0 wne cB cQ
      cmul co cB cdiv co cQ wceq cA cz wcel cB cn wcel wa cQ cB divcan3 cA cz
      wcel cB cn wcel wa cQ cz wcel cQ cc wcel cA cz wcel cB cn wcel wa cA cB
      cdiv co cfl cfv cz cQ cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel cA
      cB cdiv co cfl cfv cz wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co
      cr wcel cA cz wcel cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB
      cn wcel cA zre adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB
      cn wcel cB cc0 wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flcl
      syl quorem.1 syl5eqel cQ zcn syl cB cn wcel cB cc wcel cA cz wcel cB nncn
      adantl cB cn wcel cB cc0 wne cA cz wcel cB nnne0 adantl syl3anc cA cz
      wcel cB cn wcel wa cA cB cdiv co cfl cfv cA cB cdiv co cQ cle cA cz wcel
      cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cA cB cdiv co
      cle wbr cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel
      cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre
      adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0
      wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flle syl quorem.1
      syl5eqbr eqbrtrd cB cQ cmul co cr wcel cA cr wcel cB cr wcel cc0 cB clt
      wbr wa cB cQ cmul co cA cle wbr cB cQ cmul co cB cdiv co cA cB cdiv co
      cle wbr wb cA cz wcel cB cn wcel wa cB cQ cmul co cA cB lediv1 cA cz wcel
      cB cn wcel wa cB cQ cmul co cz wcel cB cQ cmul co cr wcel cB cz wcel cQ
      cz wcel cB cQ cmul co cz wcel cA cz wcel cB cn wcel wa cB cQ zmulcl cB cn
      wcel cB cz wcel cA cz wcel cB nnz adantl cA cz wcel cB cn wcel wa cA cB
      cdiv co cfl cfv cz cQ cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel cA
      cB cdiv co cfl cfv cz wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co
      cr wcel cA cz wcel cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB
      cn wcel cA zre adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB
      cn wcel cB cc0 wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flcl
      syl quorem.1 syl5eqel sylanc cB cQ cmul co zre syl cA cz wcel cA cr wcel
      cB cn wcel cA zre adantr cA cz wcel cB cn wcel wa cB cr wcel cc0 cB clt
      wbr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cc0 cB clt
      wbr cA cz wcel cB nngt0 adantl jca syl3anc mpbird syl3anc quorem.2
      syl5eqel cA cz wcel cB cn wcel wa cR cB clt wbr cA cB cQ cmul co cR caddc
      co wceq cA cz wcel cB cn wcel wa cR cB clt wbr cR cB cdiv co cB cB cdiv
      co clt wbr cA cz wcel cB cn wcel wa cA cB cdiv co cQ cmin co c1 cR cB
      cdiv co cB cB cdiv co clt cA cz wcel cB cn wcel wa cA cB cdiv co cA cB
      cdiv co cfl cfv cmin co c1 cA cB cdiv co cQ cmin co clt cA cz wcel cB cn
      wcel wa cA cB cdiv co cr wcel cA cB cdiv co cA cB cdiv co cfl cfv cmin co
      c1 clt wbr cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz
      wcel cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre
      adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0
      wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co fraclt1 syl cQ cA cB
      cdiv co cfl cfv cA cB cdiv co cmin quorem.1 opreq2i syl5eqbr cA cz wcel
      cB cn wcel wa cA cB cQ cmul co cmin co cB cdiv co cA cB cdiv co cQ cmin
      co cR cB cdiv co cA cz wcel cB cn wcel wa cA cB cQ cmul co cmin co cB
      cdiv co cA cB cdiv co cB cQ cmul co cB cdiv co cmin co cA cB cdiv co cQ
      cmin co cA cc wcel cB cQ cmul co cc wcel cB cc wcel cB cc0 wne wa cA cB
      cQ cmul co cmin co cB cdiv co cA cB cdiv co cB cQ cmul co cB cdiv co cmin
      co wceq cA cz wcel cB cn wcel wa cA cB cQ cmul co cB divsubdir cA cz wcel
      cA cc wcel cB cn wcel cA zcn adantr cA cz wcel cB cn wcel wa cB cQ cmul
      co cz wcel cB cQ cmul co cc wcel cB cz wcel cQ cz wcel cB cQ cmul co cz
      wcel cA cz wcel cB cn wcel wa cB cQ zmulcl cB cn wcel cB cz wcel cA cz
      wcel cB nnz adantl cA cz wcel cB cn wcel wa cA cB cdiv co cfl cfv cz cQ
      cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cz
      wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel cB
      cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre adantr
      cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0 wne cA
      cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flcl syl quorem.1 syl5eqel
      sylanc cB cQ cmul co zcn syl cB cn wcel cB cc wcel cB cc0 wne wa cA cz
      wcel cB cn wcel cB cc wcel cB cc0 wne cB nncn cB nnne0 jca adantl syl3anc
      cA cz wcel cB cn wcel wa cB cQ cmul co cB cdiv co cQ cA cB cdiv co cmin
      cQ cc wcel cB cc wcel cB cc0 wne cB cQ cmul co cB cdiv co cQ wceq cA cz
      wcel cB cn wcel wa cQ cB divcan3 cA cz wcel cB cn wcel wa cQ cz wcel cQ
      cc wcel cA cz wcel cB cn wcel wa cA cB cdiv co cfl cfv cz cQ cA cz wcel
      cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cz wcel cA cr
      wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel cB cn wcel wa
      cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre adantr cB cn wcel
      cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0 wne cA cz wcel cB
      nnne0 adantl syl3anc cA cB cdiv co flcl syl quorem.1 syl5eqel cQ zcn syl
      cB cn wcel cB cc wcel cA cz wcel cB nncn adantl cB cn wcel cB cc0 wne cA
      cz wcel cB nnne0 adantl syl3anc opreq2d eqtrd cR cA cB cQ cmul co cmin co
      cB cdiv quorem.2 opreq1i syl5eq cB cn wcel cB cB cdiv co c1 wceq cA cz
      wcel cB cc wcel cB cc0 wne cB cB cdiv co c1 wceq cB cn wcel cB divid cB
      nncn cB nnne0 sylanc adantl 3brtr4d cR cr wcel cB cr wcel cB cr wcel cc0
      cB clt wbr wa cR cB clt wbr cR cB cdiv co cB cB cdiv co clt wbr wb cA cz
      wcel cB cn wcel wa cR cB cB ltdiv1 cA cz wcel cB cn wcel wa cR cn0 wcel
      cR cr wcel cA cz wcel cB cn wcel wa cA cB cQ cmul co cmin co cn0 cR cB cQ
      cmul co cz wcel cA cz wcel cB cQ cmul co cA cle wbr cA cB cQ cmul co cmin
      co cn0 wcel cA cz wcel cB cn wcel wa cB cQ cmul co cA znn0sub2 cB cz wcel
      cQ cz wcel cB cQ cmul co cz wcel cA cz wcel cB cn wcel wa cB cQ zmulcl cB
      cn wcel cB cz wcel cA cz wcel cB nnz adantl cA cz wcel cB cn wcel wa cA
      cB cdiv co cfl cfv cz cQ cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel
      cA cB cdiv co cfl cfv cz wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv
      co cr wcel cA cz wcel cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel
      cB cn wcel cA zre adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl
      cB cn wcel cB cc0 wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co
      flcl syl quorem.1 syl5eqel sylanc cA cz wcel cB cn wcel pm3.26 cA cz wcel
      cB cn wcel wa cB cQ cmul co cA cle wbr cB cQ cmul co cB cdiv co cA cB
      cdiv co cle wbr cA cz wcel cB cn wcel wa cB cQ cmul co cB cdiv co cQ cA
      cB cdiv co cle cQ cc wcel cB cc wcel cB cc0 wne cB cQ cmul co cB cdiv co
      cQ wceq cA cz wcel cB cn wcel wa cQ cB divcan3 cA cz wcel cB cn wcel wa
      cQ cz wcel cQ cc wcel cA cz wcel cB cn wcel wa cA cB cdiv co cfl cfv cz
      cQ cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv
      cz wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel
      cB cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre
      adantr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0
      wne cA cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flcl syl quorem.1
      syl5eqel cQ zcn syl cB cn wcel cB cc wcel cA cz wcel cB nncn adantl cB cn
      wcel cB cc0 wne cA cz wcel cB nnne0 adantl syl3anc cA cz wcel cB cn wcel
      wa cA cB cdiv co cfl cfv cA cB cdiv co cQ cle cA cz wcel cB cn wcel wa cA
      cB cdiv co cr wcel cA cB cdiv co cfl cfv cA cB cdiv co cle wbr cA cr wcel
      cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel cB cn wcel wa cA
      cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre adantr cB cn wcel cB
      cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0 wne cA cz wcel cB
      nnne0 adantl syl3anc cA cB cdiv co flle syl quorem.1 syl5eqbr eqbrtrd cB
      cQ cmul co cr wcel cA cr wcel cB cr wcel cc0 cB clt wbr wa cB cQ cmul co
      cA cle wbr cB cQ cmul co cB cdiv co cA cB cdiv co cle wbr wb cA cz wcel
      cB cn wcel wa cB cQ cmul co cA cB lediv1 cA cz wcel cB cn wcel wa cB cQ
      cmul co cz wcel cB cQ cmul co cr wcel cB cz wcel cQ cz wcel cB cQ cmul co
      cz wcel cA cz wcel cB cn wcel wa cB cQ zmulcl cB cn wcel cB cz wcel cA cz
      wcel cB nnz adantl cA cz wcel cB cn wcel wa cA cB cdiv co cfl cfv cz cQ
      cA cz wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cz
      wcel cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel cB
      cn wcel wa cA cB redivcl cA cz wcel cA cr wcel cB cn wcel cA zre adantr
      cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0 wne cA
      cz wcel cB nnne0 adantl syl3anc cA cB cdiv co flcl syl quorem.1 syl5eqel
      sylanc cB cQ cmul co zre syl cA cz wcel cA cr wcel cB cn wcel cA zre
      adantr cA cz wcel cB cn wcel wa cB cr wcel cc0 cB clt wbr cB cn wcel cB
      cr wcel cA cz wcel cB nnre adantl cB cn wcel cc0 cB clt wbr cA cz wcel cB
      nngt0 adantl jca syl3anc mpbird syl3anc quorem.2 syl5eqel cR nn0re syl cB
      cn wcel cB cr wcel cA cz wcel cB nnre adantl cA cz wcel cB cn wcel wa cB
      cr wcel cc0 cB clt wbr cB cn wcel cB cr wcel cA cz wcel cB nnre adantl cB
      cn wcel cc0 cB clt wbr cA cz wcel cB nngt0 adantl jca syl3anc mpbird cA
      cz wcel cB cn wcel wa cB cQ cmul co cA cB cQ cmul co cmin co caddc co cA
      cB cQ cmul co cR caddc co cB cQ cmul co cc wcel cA cc wcel cB cQ cmul co
      cA cB cQ cmul co cmin co caddc co cA wceq cA cz wcel cB cn wcel wa cB cQ
      cmul co cA pncan3 cA cz wcel cB cn wcel wa cB cQ cmul co cz wcel cB cQ
      cmul co cc wcel cB cz wcel cQ cz wcel cB cQ cmul co cz wcel cA cz wcel cB
      cn wcel wa cB cQ zmulcl cB cn wcel cB cz wcel cA cz wcel cB nnz adantl cA
      cz wcel cB cn wcel wa cA cB cdiv co cfl cfv cz cQ cA cz wcel cB cn wcel
      wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cz wcel cA cr wcel cB cr
      wcel cB cc0 wne cA cB cdiv co cr wcel cA cz wcel cB cn wcel wa cA cB
      redivcl cA cz wcel cA cr wcel cB cn wcel cA zre adantr cB cn wcel cB cr
      wcel cA cz wcel cB nnre adantl cB cn wcel cB cc0 wne cA cz wcel cB nnne0
      adantl syl3anc cA cB cdiv co flcl syl quorem.1 syl5eqel sylanc cB cQ cmul
      co zcn syl cA cz wcel cA cc wcel cB cn wcel cA zcn adantr sylanc cR cA cB
      cQ cmul co cmin co cB cQ cmul co caddc quorem.2 opreq2i syl5req jca jca31
      $.
      $( [26-Aug-2008] $) $( [14-Aug-2008] $)

    $( Quotient and remainder of a nonnegative integer divided by a natural
       number. $)
    quoremnn0ALT $p |- ( ( A e. NN0 /\ B e. NN ) -> ( ( Q e. NN0 /\ R e. NN0 )
          /\ ( R < B /\ A = ( ( B x. Q ) + R ) ) ) ) $=
      cQ cn0 wcel cQ cz wcel cR cn0 wcel wa cR cB clt wbr cA cB cQ cmul co cR
      caddc co wceq wa wa cQ cn0 wcel cR cn0 wcel wa cR cB clt wbr cA cB cQ
      cmul co cR caddc co wceq wa wa cA cn0 wcel cB cn wcel wa cQ cn0 wcel cQ
      cz wcel cR cn0 wcel wa cR cB clt wbr cA cB cQ cmul co cR caddc co wceq wa
      cQ cn0 wcel cR cn0 wcel wa cR cB clt wbr cA cB cQ cmul co cR caddc co
      wceq wa wa cQ cn0 wcel cQ cz wcel cR cn0 wcel wa wa cQ cn0 wcel cR cn0
      wcel wa cR cB clt wbr cA cB cQ cmul co cR caddc co wceq wa cQ cn0 wcel cQ
      cz wcel cR cn0 wcel cQ cn0 wcel cR cn0 wcel wa cQ cn0 wcel cQ cz wcel wa
      cQ cn0 wcel cR cn0 wcel cQ cn0 wcel cQ cz wcel pm3.26 anim1i anasss
      anim1i anasss cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA
      cB cdiv co cr wcel cc0 cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0
      wcel cA cn0 wcel cB cn wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr
      wcel cB cc0 wne cA cB cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB
      redivcl cA cn0 wcel cA cr wcel cB cn wcel cA nn0re adantr cB cn wcel cB
      cr wcel cA cn0 wcel cB nnre adantl cB cn wcel cB cc0 wne cA cn0 wcel cB
      nnne0 adantl syl3anc cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt
      wbr wa cc0 cA cB cdiv co cle wbr cA cn0 wcel cB cn wcel cA cB divge0 cA
      cn0 wcel cA cr wcel cc0 cA cle wbr cA nn0re cA nn0ge0 jca cB cn wcel cB
      cr wcel cc0 cB clt wbr cB nnre cB nngt0 jca syl2an sylanc quorem.1
      syl5eqel cA cz wcel cB cn wcel cQ cz wcel cR cn0 wcel wa cR cB clt wbr cA
      cB cQ cmul co cR caddc co wceq wa wa cA cn0 wcel cA cB cQ cR quorem.1
      quorem.2 quoremz cA nn0z sylan sylanc $.
      $( [5-Nov-2008] $) $( [14-Aug-2008] $)

    $( MAY BE REVISED - keep either quoremnn0ALT or quoremnn0 (if we don't
       keep quoremz $)
    $( Quotient and remainder of a nonnegative integer divided by a natural
       number. $)
    quoremnn0 $p |- ( ( A e. NN0 /\ B e. NN ) -> ( ( Q e. NN0 /\ R e. NN0 )
          /\ ( R < B /\ A = ( ( B x. Q ) + R ) ) ) ) $=
      cA cn0 wcel cB cn wcel wa cQ cn0 wcel cR cn0 wcel cR cB clt wbr cA cB cQ
      cmul co cR caddc co wceq wa cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl
      cfv cn0 cQ cA cB cdiv co cr wcel cc0 cA cB cdiv co cle wbr cA cB cdiv co
      cfl cfv cn0 wcel cA cn0 wcel cB cn wcel wa cA cB cdiv co flge0nn0 cA cr
      wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cn0 wcel cB cn wcel
      wa cA cB redivcl cA cn0 wcel cA cr wcel cB cn wcel cA nn0re adantr cB cn
      wcel cB cr wcel cA cn0 wcel cB nnre adantl cB cn wcel cB cc0 wne cA cn0
      wcel cB nnne0 adantl syl3anc cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0
      cB clt wbr wa cc0 cA cB cdiv co cle wbr cA cn0 wcel cB cn wcel cA cB
      divge0 cA cn0 wcel cA cr wcel cc0 cA cle wbr cA nn0re cA nn0ge0 jca cB cn
      wcel cB cr wcel cc0 cB clt wbr cB nnre cB nngt0 jca syl2an sylanc
      quorem.1 syl5eqel cA cn0 wcel cB cn wcel wa cA cB cQ cmul co cmin co cn0
      cR cB cQ cmul co cn0 wcel cA cn0 wcel cB cQ cmul co cA cle wbr cA cB cQ
      cmul co cmin co cn0 wcel cA cn0 wcel cB cn wcel wa cB cQ cmul co cA
      nn0sub2 cB cn0 wcel cQ cn0 wcel cB cQ cmul co cn0 wcel cA cn0 wcel cB cn
      wcel wa cB cQ nn0mulcl cB cn wcel cB cn0 wcel cA cn0 wcel cB nnnn0 adantl
      cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv co cr
      wcel cc0 cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA cn0 wcel
      cB cn wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB cc0 wne cA
      cB cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA
      cr wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB
      nnre adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA
      cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co
      cle wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr wcel cc0 cA
      cle wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB clt wbr cB
      nnre cB nngt0 jca syl2an sylanc quorem.1 syl5eqel sylanc cA cn0 wcel cB
      cn wcel pm3.26 cA cn0 wcel cB cn wcel wa cB cQ cmul co cA cle wbr cB cQ
      cmul co cB cdiv co cA cB cdiv co cle wbr cA cn0 wcel cB cn wcel wa cB cQ
      cmul co cB cdiv co cQ cA cB cdiv co cle cQ cc wcel cB cc wcel cB cc0 wne
      cB cQ cmul co cB cdiv co cQ wceq cA cn0 wcel cB cn wcel wa cQ cB divcan3
      cA cn0 wcel cB cn wcel wa cQ cn0 wcel cQ cc wcel cA cn0 wcel cB cn wcel
      wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv co cr wcel cc0 cA cB cdiv co
      cle wbr cA cB cdiv co cfl cfv cn0 wcel cA cn0 wcel cB cn wcel wa cA cB
      cdiv co flge0nn0 cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel
      cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr wcel cB cn wcel
      cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre adantl cB cn
      wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cr wcel cc0 cA cle
      wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co cle wbr cA cn0 wcel
      cB cn wcel cA cB divge0 cA cn0 wcel cA cr wcel cc0 cA cle wbr cA nn0re cA
      nn0ge0 jca cB cn wcel cB cr wcel cc0 cB clt wbr cB nnre cB nngt0 jca
      syl2an sylanc quorem.1 syl5eqel cQ nn0cn syl cB cn wcel cB cc wcel cA cn0
      wcel cB nncn adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl
      syl3anc cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cA cB cdiv co cQ
      cle cA cn0 wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv
      cA cB cdiv co cle wbr cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr
      wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr wcel cB cn
      wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre adantl cB
      cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cB cdiv co flle
      syl quorem.1 syl5eqbr eqbrtrd cB cQ cmul co cr wcel cA cr wcel cB cr wcel
      cc0 cB clt wbr wa cB cQ cmul co cA cle wbr cB cQ cmul co cB cdiv co cA cB
      cdiv co cle wbr wb cA cn0 wcel cB cn wcel wa cB cQ cmul co cA cB lediv1
      cA cn0 wcel cB cn wcel wa cB cQ cmul co cn0 wcel cB cQ cmul co cr wcel cB
      cn0 wcel cQ cn0 wcel cB cQ cmul co cn0 wcel cA cn0 wcel cB cn wcel wa cB
      cQ nn0mulcl cB cn wcel cB cn0 wcel cA cn0 wcel cB nnnn0 adantl cA cn0
      wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv co cr wcel cc0
      cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA cn0 wcel cB cn
      wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB cc0 wne cA cB
      cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr
      wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre
      adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cr
      wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co cle
      wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr wcel cc0 cA cle
      wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB clt wbr cB nnre
      cB nngt0 jca syl2an sylanc quorem.1 syl5eqel sylanc cB cQ cmul co nn0re
      syl cA cn0 wcel cA cr wcel cB cn wcel cA nn0re adantr cA cn0 wcel cB cn
      wcel wa cB cr wcel cc0 cB clt wbr cB cn wcel cB cr wcel cA cn0 wcel cB
      nnre adantl cB cn wcel cc0 cB clt wbr cA cn0 wcel cB nngt0 adantl jca
      syl3anc mpbird syl3anc quorem.2 syl5eqel cA cn0 wcel cB cn wcel wa cR cB
      clt wbr cA cB cQ cmul co cR caddc co wceq cA cn0 wcel cB cn wcel wa cR cB
      clt wbr cR cB cdiv co cB cB cdiv co clt wbr cA cn0 wcel cB cn wcel wa cA
      cB cdiv co cQ cmin co c1 cR cB cdiv co cB cB cdiv co clt cA cn0 wcel cB
      cn wcel wa cA cB cdiv co cA cB cdiv co cfl cfv cmin co c1 cA cB cdiv co
      cQ cmin co clt cA cn0 wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv
      co cA cB cdiv co cfl cfv cmin co c1 clt wbr cA cr wcel cB cr wcel cB cc0
      wne cA cB cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0
      wcel cA cr wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0
      wcel cB nnre adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl
      syl3anc cA cB cdiv co fraclt1 syl cQ cA cB cdiv co cfl cfv cA cB cdiv co
      cmin quorem.1 opreq2i syl5eqbr cA cn0 wcel cB cn wcel wa cA cB cQ cmul co
      cmin co cB cdiv co cA cB cdiv co cQ cmin co cR cB cdiv co cA cn0 wcel cB
      cn wcel wa cA cB cQ cmul co cmin co cB cdiv co cA cB cdiv co cB cQ cmul
      co cB cdiv co cmin co cA cB cdiv co cQ cmin co cA cc wcel cB cQ cmul co
      cc wcel cB cc wcel cB cc0 wne wa cA cB cQ cmul co cmin co cB cdiv co cA
      cB cdiv co cB cQ cmul co cB cdiv co cmin co wceq cA cn0 wcel cB cn wcel
      wa cA cB cQ cmul co cB divsubdir cA cn0 wcel cA cc wcel cB cn wcel cA
      nn0cn adantr cA cn0 wcel cB cn wcel wa cB cQ cmul co cn0 wcel cB cQ cmul
      co cc wcel cB cn0 wcel cQ cn0 wcel cB cQ cmul co cn0 wcel cA cn0 wcel cB
      cn wcel wa cB cQ nn0mulcl cB cn wcel cB cn0 wcel cA cn0 wcel cB nnnn0
      adantl cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv
      co cr wcel cc0 cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA
      cn0 wcel cB cn wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB
      cc0 wne cA cB cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA
      cn0 wcel cA cr wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA
      cn0 wcel cB nnre adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl
      syl3anc cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA
      cB cdiv co cle wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr
      wcel cc0 cA cle wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB
      clt wbr cB nnre cB nngt0 jca syl2an sylanc quorem.1 syl5eqel sylanc cB cQ
      cmul co nn0cn syl cB cn wcel cB cc wcel cB cc0 wne wa cA cn0 wcel cB cn
      wcel cB cc wcel cB cc0 wne cB nncn cB nnne0 jca adantl syl3anc cA cn0
      wcel cB cn wcel wa cB cQ cmul co cB cdiv co cQ cA cB cdiv co cmin cQ cc
      wcel cB cc wcel cB cc0 wne cB cQ cmul co cB cdiv co cQ wceq cA cn0 wcel
      cB cn wcel wa cQ cB divcan3 cA cn0 wcel cB cn wcel wa cQ cn0 wcel cQ cc
      wcel cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv co
      cr wcel cc0 cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA cn0
      wcel cB cn wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB cc0
      wne cA cB cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0
      wcel cA cr wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0
      wcel cB nnre adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl
      syl3anc cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA
      cB cdiv co cle wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr
      wcel cc0 cA cle wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB
      clt wbr cB nnre cB nngt0 jca syl2an sylanc quorem.1 syl5eqel cQ nn0cn syl
      cB cn wcel cB cc wcel cA cn0 wcel cB nncn adantl cB cn wcel cB cc0 wne cA
      cn0 wcel cB nnne0 adantl syl3anc opreq2d eqtrd cR cA cB cQ cmul co cmin
      co cB cdiv quorem.2 opreq1i syl5eq cB cn wcel cB cB cdiv co c1 wceq cA
      cn0 wcel cB cc wcel cB cc0 wne cB cB cdiv co c1 wceq cB cn wcel cB divid
      cB nncn cB nnne0 sylanc adantl 3brtr4d cR cr wcel cB cr wcel cB cr wcel
      cc0 cB clt wbr wa cR cB clt wbr cR cB cdiv co cB cB cdiv co clt wbr wb cA
      cn0 wcel cB cn wcel wa cR cB cB ltdiv1 cA cn0 wcel cB cn wcel wa cR cn0
      wcel cR cr wcel cA cn0 wcel cB cn wcel wa cA cB cQ cmul co cmin co cn0 cR
      cB cQ cmul co cn0 wcel cA cn0 wcel cB cQ cmul co cA cle wbr cA cB cQ cmul
      co cmin co cn0 wcel cA cn0 wcel cB cn wcel wa cB cQ cmul co cA nn0sub2 cB
      cn0 wcel cQ cn0 wcel cB cQ cmul co cn0 wcel cA cn0 wcel cB cn wcel wa cB
      cQ nn0mulcl cB cn wcel cB cn0 wcel cA cn0 wcel cB nnnn0 adantl cA cn0
      wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv co cr wcel cc0
      cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA cn0 wcel cB cn
      wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB cc0 wne cA cB
      cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr
      wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre
      adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cr
      wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co cle
      wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr wcel cc0 cA cle
      wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB clt wbr cB nnre
      cB nngt0 jca syl2an sylanc quorem.1 syl5eqel sylanc cA cn0 wcel cB cn
      wcel pm3.26 cA cn0 wcel cB cn wcel wa cB cQ cmul co cA cle wbr cB cQ cmul
      co cB cdiv co cA cB cdiv co cle wbr cA cn0 wcel cB cn wcel wa cB cQ cmul
      co cB cdiv co cQ cA cB cdiv co cle cQ cc wcel cB cc wcel cB cc0 wne cB cQ
      cmul co cB cdiv co cQ wceq cA cn0 wcel cB cn wcel wa cQ cB divcan3 cA cn0
      wcel cB cn wcel wa cQ cn0 wcel cQ cc wcel cA cn0 wcel cB cn wcel wa cA cB
      cdiv co cfl cfv cn0 cQ cA cB cdiv co cr wcel cc0 cA cB cdiv co cle wbr cA
      cB cdiv co cfl cfv cn0 wcel cA cn0 wcel cB cn wcel wa cA cB cdiv co
      flge0nn0 cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr wcel cA cn0
      wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr wcel cB cn wcel cA
      nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre adantl cB cn wcel
      cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cr wcel cc0 cA cle wbr
      wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co cle wbr cA cn0 wcel cB
      cn wcel cA cB divge0 cA cn0 wcel cA cr wcel cc0 cA cle wbr cA nn0re cA
      nn0ge0 jca cB cn wcel cB cr wcel cc0 cB clt wbr cB nnre cB nngt0 jca
      syl2an sylanc quorem.1 syl5eqel cQ nn0cn syl cB cn wcel cB cc wcel cA cn0
      wcel cB nncn adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl
      syl3anc cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cA cB cdiv co cQ
      cle cA cn0 wcel cB cn wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv
      cA cB cdiv co cle wbr cA cr wcel cB cr wcel cB cc0 wne cA cB cdiv co cr
      wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr wcel cB cn
      wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre adantl cB
      cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cB cdiv co flle
      syl quorem.1 syl5eqbr eqbrtrd cB cQ cmul co cr wcel cA cr wcel cB cr wcel
      cc0 cB clt wbr wa cB cQ cmul co cA cle wbr cB cQ cmul co cB cdiv co cA cB
      cdiv co cle wbr wb cA cn0 wcel cB cn wcel wa cB cQ cmul co cA cB lediv1
      cA cn0 wcel cB cn wcel wa cB cQ cmul co cn0 wcel cB cQ cmul co cr wcel cB
      cn0 wcel cQ cn0 wcel cB cQ cmul co cn0 wcel cA cn0 wcel cB cn wcel wa cB
      cQ nn0mulcl cB cn wcel cB cn0 wcel cA cn0 wcel cB nnnn0 adantl cA cn0
      wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv co cr wcel cc0
      cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA cn0 wcel cB cn
      wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB cc0 wne cA cB
      cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA cn0 wcel cA cr
      wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA cn0 wcel cB nnre
      adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl syl3anc cA cr
      wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co cle
      wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr wcel cc0 cA cle
      wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB clt wbr cB nnre
      cB nngt0 jca syl2an sylanc quorem.1 syl5eqel sylanc cB cQ cmul co nn0re
      syl cA cn0 wcel cA cr wcel cB cn wcel cA nn0re adantr cA cn0 wcel cB cn
      wcel wa cB cr wcel cc0 cB clt wbr cB cn wcel cB cr wcel cA cn0 wcel cB
      nnre adantl cB cn wcel cc0 cB clt wbr cA cn0 wcel cB nngt0 adantl jca
      syl3anc mpbird syl3anc quorem.2 syl5eqel cR nn0re syl cB cn wcel cB cr
      wcel cA cn0 wcel cB nnre adantl cA cn0 wcel cB cn wcel wa cB cr wcel cc0
      cB clt wbr cB cn wcel cB cr wcel cA cn0 wcel cB nnre adantl cB cn wcel
      cc0 cB clt wbr cA cn0 wcel cB nngt0 adantl jca syl3anc mpbird cA cn0 wcel
      cB cn wcel wa cB cQ cmul co cA cB cQ cmul co cmin co caddc co cA cB cQ
      cmul co cR caddc co cB cQ cmul co cc wcel cA cc wcel cB cQ cmul co cA cB
      cQ cmul co cmin co caddc co cA wceq cA cn0 wcel cB cn wcel wa cB cQ cmul
      co cA pncan3 cA cn0 wcel cB cn wcel wa cB cQ cmul co cn0 wcel cB cQ cmul
      co cc wcel cB cn0 wcel cQ cn0 wcel cB cQ cmul co cn0 wcel cA cn0 wcel cB
      cn wcel wa cB cQ nn0mulcl cB cn wcel cB cn0 wcel cA cn0 wcel cB nnnn0
      adantl cA cn0 wcel cB cn wcel wa cA cB cdiv co cfl cfv cn0 cQ cA cB cdiv
      co cr wcel cc0 cA cB cdiv co cle wbr cA cB cdiv co cfl cfv cn0 wcel cA
      cn0 wcel cB cn wcel wa cA cB cdiv co flge0nn0 cA cr wcel cB cr wcel cB
      cc0 wne cA cB cdiv co cr wcel cA cn0 wcel cB cn wcel wa cA cB redivcl cA
      cn0 wcel cA cr wcel cB cn wcel cA nn0re adantr cB cn wcel cB cr wcel cA
      cn0 wcel cB nnre adantl cB cn wcel cB cc0 wne cA cn0 wcel cB nnne0 adantl
      syl3anc cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA
      cB cdiv co cle wbr cA cn0 wcel cB cn wcel cA cB divge0 cA cn0 wcel cA cr
      wcel cc0 cA cle wbr cA nn0re cA nn0ge0 jca cB cn wcel cB cr wcel cc0 cB
      clt wbr cB nnre cB nngt0 jca syl2an sylanc quorem.1 syl5eqel sylanc cB cQ
      cmul co nn0cn syl cA cn0 wcel cA cc wcel cB cn wcel cA nn0cn adantr
      sylanc cR cA cB cQ cmul co cmin co cB cQ cmul co caddc quorem.2 opreq2i
      syl5req jca jca31 $.
      $( [20-Oct-2008] $) $( [14-Aug-2008] $)
  $}

  ${
    intfrac2.1 $e |- Z = ( |_ ` A ) $.
    intfrac2.2 $e |- F = ( A - Z ) $.
    $( MAY BE REVISED - should we replace this with ~ intfrac ? $)
    $( Decompose a real into integer and fractional parts. $)
    intfrac2 $p |- ( A e. RR -> ( 0 <_ F /\ F < 1 /\ A = ( Z + F ) ) ) $=
      cA cr wcel cc0 cF cle wbr cF c1 clt wbr cA cZ cF caddc co wceq cA cr wcel
      cc0 cA cA cfl cfv cmin co cF cle cA fracge0 cF cA cZ cmin co cA cA cfl
      cfv cmin co intfrac2.2 cZ cA cfl cfv cA cmin intfrac2.1 opreq2i eqtri
      syl6breqr cA cr wcel cA cA cfl cfv cmin co c1 cF clt cA fraclt1 cF cA cZ
      cmin co cA cA cfl cfv cmin co intfrac2.2 cZ cA cfl cfv cA cmin intfrac2.1
      opreq2i eqtri syl5eqbr cA cr wcel cZ cA cZ cmin co caddc co cA cZ cF
      caddc co cZ cc wcel cA cc wcel cZ cA cZ cmin co caddc co cA wceq cA cr
      wcel cZ cA pncan3 cA cr wcel cZ cz wcel cZ cc wcel cA cr wcel cA cfl cfv
      cz cZ cA flcl intfrac2.1 syl5eqel cZ zcn syl cA recn sylanc cF cA cZ cmin
      co cZ caddc intfrac2.2 opreq2i syl5req 3jca $.
      $( [23-Aug-2008] $) $( [16-Aug-2008] $)
  $}

  ${
    intfracq.1 $e |- Z = ( |_ ` ( M / N ) ) $.
    intfracq.2 $e |- F = ( ( M / N ) - Z ) $.
    $( Decompose a rational number, expressed as a ratio, into integer and
       fractional parts.  The fractional part has a tighter bound than that of
       ~ intfrac2 . $)
    intfracq $p |- ( ( M e. ZZ /\ N e. NN )
         -> ( 0 <_ F /\ F <_ ( ( N - 1 ) / N ) /\ ( M / N ) = ( Z + F ) ) ) $=
      cM cz wcel cN cn wcel wa cc0 cF cle wbr cF cN c1 cmin co cN cdiv co cle
      wbr cM cN cdiv co cZ cF caddc co wceq cM cz wcel cN cn wcel wa cc0 cF cle
      wbr cF c1 clt wbr cM cN cdiv co cZ cF caddc co wceq cM cz wcel cN cn wcel
      wa cM cN cdiv co cr wcel cc0 cF cle wbr cF c1 clt wbr cM cN cdiv co cZ cF
      caddc co wceq w3a cM cr wcel cN cr wcel cN cc0 wne cM cN cdiv co cr wcel
      cM cz wcel cN cn wcel wa cM cN redivcl cM cz wcel cM cr wcel cN cn wcel
      cM zre adantr cN cn wcel cN cr wcel cM cz wcel cN nnre adantl cN cn wcel
      cN cc0 wne cM cz wcel cN nnne0 adantl syl3anc cM cN cdiv co cF cZ
      intfracq.1 intfracq.2 intfrac2 syl 3simp1d cM cz wcel cN cn wcel wa cN cF
      cmul co cN c1 cmin co cle wbr cF cN c1 cmin co cN cdiv co cle wbr cM cz
      wcel cN cn wcel wa cN cF cmul co cN clt wbr cN cF cmul co cN c1 cmin co
      cle wbr cM cz wcel cN cn wcel wa cN cF cmul co cN clt wbr cF cN cN cdiv
      co clt wbr cM cz wcel cN cn wcel wa cM cN cdiv co cM cN cdiv co cfl cfv
      cmin co c1 cF cN cN cdiv co clt cM cz wcel cN cn wcel wa cM cN cdiv co cr
      wcel cM cN cdiv co cM cN cdiv co cfl cfv cmin co c1 clt wbr cM cr wcel cN
      cr wcel cN cc0 wne cM cN cdiv co cr wcel cM cz wcel cN cn wcel wa cM cN
      redivcl cM cz wcel cM cr wcel cN cn wcel cM zre adantr cN cn wcel cN cr
      wcel cM cz wcel cN nnre adantl cN cn wcel cN cc0 wne cM cz wcel cN nnne0
      adantl syl3anc cM cN cdiv co fraclt1 syl cF cM cN cdiv co cM cN cdiv co
      cfl cfv cmin co wceq cM cz wcel cN cn wcel wa cF cM cN cdiv co cZ cmin co
      cM cN cdiv co cM cN cdiv co cfl cfv cmin co intfracq.2 cZ cM cN cdiv co
      cfl cfv cM cN cdiv co cmin intfracq.1 opreq2i eqtri a1i cN cn wcel cN cN
      cdiv co c1 wceq cM cz wcel cN cc wcel cN cc0 wne cN cN cdiv co c1 wceq cN
      cn wcel cN divid cN nncn cN nnne0 sylanc adantl 3brtr4d cF cr wcel cN cr
      wcel cN cr wcel cc0 cN clt wbr wa cN cF cmul co cN clt wbr cF cN cN cdiv
      co clt wbr wb cM cz wcel cN cn wcel wa cF cN cN ltmuldiv2 cM cz wcel cN
      cn wcel wa cM cN cdiv co cZ cmin co cr cF cM cN cdiv co cr wcel cZ cr
      wcel cM cN cdiv co cZ cmin co cr wcel cM cz wcel cN cn wcel wa cM cN cdiv
      co cZ resubcl cM cr wcel cN cr wcel cN cc0 wne cM cN cdiv co cr wcel cM
      cz wcel cN cn wcel wa cM cN redivcl cM cz wcel cM cr wcel cN cn wcel cM
      zre adantr cN cn wcel cN cr wcel cM cz wcel cN nnre adantl cN cn wcel cN
      cc0 wne cM cz wcel cN nnne0 adantl syl3anc cM cz wcel cN cn wcel wa cM cN
      cdiv co cfl cfv cr cZ cM cz wcel cN cn wcel wa cM cN cdiv co cr wcel cM
      cN cdiv co cfl cfv cr wcel cM cr wcel cN cr wcel cN cc0 wne cM cN cdiv co
      cr wcel cM cz wcel cN cn wcel wa cM cN redivcl cM cz wcel cM cr wcel cN
      cn wcel cM zre adantr cN cn wcel cN cr wcel cM cz wcel cN nnre adantl cN
      cn wcel cN cc0 wne cM cz wcel cN nnne0 adantl syl3anc cM cN cdiv co
      reflcl syl intfracq.1 syl5eqel sylanc intfracq.2 syl5eqel cN cn wcel cN
      cr wcel cM cz wcel cN nnre adantl cN cn wcel cN cr wcel cc0 cN clt wbr wa
      cM cz wcel cN cn wcel cN cr wcel cc0 cN clt wbr cN nnre cN nngt0 jca
      adantl syl3anc mpbird cN cF cmul co cz wcel cN cz wcel cN cF cmul co cN
      clt wbr cN cF cmul co cN c1 cmin co cle wbr wb cM cz wcel cN cn wcel wa
      cN cF cmul co cN zltlem1 cM cz wcel cN cn wcel wa cN cF cmul co cN cM cN
      cdiv co cmul co cN cZ cmul co cmin co cz cM cz wcel cN cn wcel wa cN cM
      cN cdiv co cZ cmin co cmul co cN cM cN cdiv co cmul co cN cZ cmul co cmin
      co cN cF cmul co cN cc wcel cM cN cdiv co cc wcel cZ cc wcel cN cM cN
      cdiv co cZ cmin co cmul co cN cM cN cdiv co cmul co cN cZ cmul co cmin co
      wceq cM cz wcel cN cn wcel wa cN cM cN cdiv co cZ subdi cN cn wcel cN cc
      wcel cM cz wcel cN nncn adantl cM cz wcel cN cn wcel wa cM cN cdiv co cM
      cr wcel cN cr wcel cN cc0 wne cM cN cdiv co cr wcel cM cz wcel cN cn wcel
      wa cM cN redivcl cM cz wcel cM cr wcel cN cn wcel cM zre adantr cN cn
      wcel cN cr wcel cM cz wcel cN nnre adantl cN cn wcel cN cc0 wne cM cz
      wcel cN nnne0 adantl syl3anc recnd cM cz wcel cN cn wcel wa cZ cz wcel cZ
      cc wcel cM cz wcel cN cn wcel wa cZ cM cN cdiv co cfl cfv cz cZ cM cN
      cdiv co cfl cfv wceq cM cz wcel cN cn wcel wa intfracq.1 a1i cM cz wcel
      cN cn wcel wa cM cN cdiv co cr wcel cM cN cdiv co cfl cfv cz wcel cM cr
      wcel cN cr wcel cN cc0 wne cM cN cdiv co cr wcel cM cz wcel cN cn wcel wa
      cM cN redivcl cM cz wcel cM cr wcel cN cn wcel cM zre adantr cN cn wcel
      cN cr wcel cM cz wcel cN nnre adantl cN cn wcel cN cc0 wne cM cz wcel cN
      nnne0 adantl syl3anc cM cN cdiv co flcl syl eqeltrd cZ zcn syl syl3anc cF
      cM cN cdiv co cZ cmin co cN cmul intfracq.2 opreq2i syl5eq cN cM cN cdiv
      co cmul co cz wcel cN cZ cmul co cz wcel cN cM cN cdiv co cmul co cN cZ
      cmul co cmin co cz wcel cM cz wcel cN cn wcel wa cN cM cN cdiv co cmul co
      cN cZ cmul co zsubcl cM cz wcel cN cn wcel wa cN cM cN cdiv co cmul co cM
      cz cM cc wcel cN cc wcel cN cc0 wne cN cM cN cdiv co cmul co cM wceq cM
      cz wcel cN cn wcel wa cM cN divcan2 cM cz wcel cM cc wcel cN cn wcel cM
      zcn adantr cN cn wcel cN cc wcel cM cz wcel cN nncn adantl cN cn wcel cN
      cc0 wne cM cz wcel cN nnne0 adantl syl3anc cM cz wcel cN cn wcel pm3.26
      eqeltrd cN cz wcel cZ cz wcel cN cZ cmul co cz wcel cM cz wcel cN cn wcel
      wa cN cZ zmulcl cN cn wcel cN cz wcel cM cz wcel cN nnz adantl cM cz wcel
      cN cn wcel wa cZ cM cN cdiv co cfl cfv cz cZ cM cN cdiv co cfl cfv wceq
      cM cz wcel cN cn wcel wa intfracq.1 a1i cM cz wcel cN cn wcel wa cM cN
      cdiv co cr wcel cM cN cdiv co cfl cfv cz wcel cM cr wcel cN cr wcel cN
      cc0 wne cM cN cdiv co cr wcel cM cz wcel cN cn wcel wa cM cN redivcl cM
      cz wcel cM cr wcel cN cn wcel cM zre adantr cN cn wcel cN cr wcel cM cz
      wcel cN nnre adantl cN cn wcel cN cc0 wne cM cz wcel cN nnne0 adantl
      syl3anc cM cN cdiv co flcl syl eqeltrd sylanc sylanc eqeltrd cN cn wcel
      cN cz wcel cM cz wcel cN nnz adantl sylanc mpbid cF cr wcel cN c1 cmin co
      cr wcel cN cr wcel cc0 cN clt wbr wa cN cF cmul co cN c1 cmin co cle wbr
      cF cN c1 cmin co cN cdiv co cle wbr wb cM cz wcel cN cn wcel wa cF cN c1
      cmin co cN lemuldiv2 cM cz wcel cN cn wcel wa cM cN cdiv co cZ cmin co cr
      cF cM cN cdiv co cr wcel cZ cr wcel cM cN cdiv co cZ cmin co cr wcel cM
      cz wcel cN cn wcel wa cM cN cdiv co cZ resubcl cM cr wcel cN cr wcel cN
      cc0 wne cM cN cdiv co cr wcel cM cz wcel cN cn wcel wa cM cN redivcl cM
      cz wcel cM cr wcel cN cn wcel cM zre adantr cN cn wcel cN cr wcel cM cz
      wcel cN nnre adantl cN cn wcel cN cc0 wne cM cz wcel cN nnne0 adantl
      syl3anc cM cz wcel cN cn wcel wa cM cN cdiv co cfl cfv cr cZ cM cz wcel
      cN cn wcel wa cM cN cdiv co cr wcel cM cN cdiv co cfl cfv cr wcel cM cr
      wcel cN cr wcel cN cc0 wne cM cN cdiv co cr wcel cM cz wcel cN cn wcel wa
      cM cN redivcl cM cz wcel cM cr wcel cN cn wcel cM zre adantr cN cn wcel
      cN cr wcel cM cz wcel cN nnre adantl cN cn wcel cN cc0 wne cM cz wcel cN
      nnne0 adantl syl3anc cM cN cdiv co reflcl syl intfracq.1 syl5eqel sylanc
      intfracq.2 syl5eqel cN cn wcel cN c1 cmin co cr wcel cM cz wcel cN cn
      wcel cN cr wcel cN c1 cmin co cr wcel cN nnre cN peano2rem syl adantl cN
      cn wcel cN cr wcel cc0 cN clt wbr wa cM cz wcel cN cn wcel cN cr wcel cc0
      cN clt wbr cN nnre cN nngt0 jca adantl syl3anc mpbid cM cz wcel cN cn
      wcel wa cc0 cF cle wbr cF c1 clt wbr cM cN cdiv co cZ cF caddc co wceq cM
      cz wcel cN cn wcel wa cM cN cdiv co cr wcel cc0 cF cle wbr cF c1 clt wbr
      cM cN cdiv co cZ cF caddc co wceq w3a cM cr wcel cN cr wcel cN cc0 wne cM
      cN cdiv co cr wcel cM cz wcel cN cn wcel wa cM cN redivcl cM cz wcel cM
      cr wcel cN cn wcel cM zre adantr cN cn wcel cN cr wcel cM cz wcel cN nnre
      adantl cN cn wcel cN cc0 wne cM cz wcel cN nnne0 adantl syl3anc cM cN
      cdiv co cF cZ intfracq.1 intfracq.2 intfrac2 syl 3simp3d 3jca $.
      $( [4-Sep-2008] $) $( [16-Aug-2008] $)
  $}

  $( Cancellation of the embedded floor of a real divided by an integer. $)
  fldiv $p |- ( ( A e. RR /\ N e. NN )
                  -> ( |_ ` ( ( |_ ` A ) / N ) ) = ( |_ ` ( A / N ) ) ) $=
    cA cr wcel cN cn wcel wa cA cN cdiv co cfl cfv cA cfl cfv cN cdiv co cfl
    cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl
    cfv cmin co cN cdiv co caddc co caddc co cfl cfv cA cfl cfv cN cdiv co cfl
    cfv cA cr wcel cN cn wcel wa cA cN cdiv co cA cfl cfv cN cdiv co cfl cfv cA
    cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin
    co cN cdiv co caddc co caddc co cfl cA cr wcel cN cn wcel wa cA cN cdiv co
    cA cfl cfv cN cdiv co cA cA cfl cfv cmin co cN cdiv co caddc co cA cfl cfv
    cN cdiv co cfl cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin
    co caddc co cA cA cfl cfv cmin co cN cdiv co caddc co cA cfl cfv cN cdiv co
    cfl cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA
    cfl cfv cmin co cN cdiv co caddc co caddc co cA cr wcel cN cn wcel wa cA cN
    cdiv co cA cfl cfv cA cA cfl cfv cmin co caddc co cN cdiv co cA cfl cfv cN
    cdiv co cA cA cfl cfv cmin co cN cdiv co caddc co cA cr wcel cN cn wcel wa
    cA cA cfl cfv cA cA cfl cfv cmin co caddc co cN cdiv cA cr wcel cA cA cfl
    cfv cA cA cfl cfv cmin co caddc co wceq cN cn wcel cA cr wcel cc0 cA cA cfl
    cfv cmin co cle wbr cA cA cfl cfv cmin co c1 clt wbr cA cA cfl cfv cA cA
    cfl cfv cmin co caddc co wceq cA cA cA cfl cfv cmin co cA cfl cfv cA cfl
    cfv eqid cA cA cfl cfv cmin co eqid intfrac2 3simp3d adantr opreq1d cA cfl
    cfv cc wcel cA cA cfl cfv cmin co cc wcel cN cc wcel cN cc0 wne wa cA cfl
    cfv cA cA cfl cfv cmin co caddc co cN cdiv co cA cfl cfv cN cdiv co cA cA
    cfl cfv cmin co cN cdiv co caddc co wceq cA cr wcel cN cn wcel wa cA cfl
    cfv cA cA cfl cfv cmin co cN divdir cA cr wcel cA cfl cfv cc wcel cN cn
    wcel cA cr wcel cA cfl cfv cA reflcl recnd adantr cA cr wcel cA cA cfl cfv
    cmin co cc wcel cN cn wcel cA cr wcel cA cA cfl cfv cmin co cA cr wcel cA
    cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl cfv
    resubcl mpdan recnd adantr cN cn wcel cN cc wcel cN cc0 wne wa cA cr wcel
    cN cn wcel cN cc wcel cN cc0 wne cN nncn cN nnne0 jca adantl syl3anc eqtrd
    cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl
    cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co caddc co cA
    cA cfl cfv cmin co cN cdiv co caddc cA cfl cfv cz wcel cN cn wcel cA cfl
    cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv co cA cfl
    cfv cN cdiv co cfl cfv cmin co caddc co wceq cA cr wcel cA cfl cfv cz wcel
    cN cn wcel wa cc0 cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin
    co cle wbr cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cN
    c1 cmin co cN cdiv co cle wbr cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co
    cfl cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co caddc
    co wceq cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cfl
    cfv cN cA cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv co cfl cfv eqid cA
    cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co eqid intfracq
    3simp3d cA flcl sylan opreq1d cA cfl cfv cN cdiv co cfl cfv cc wcel cA cfl
    cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cc wcel cA cA cfl cfv
    cmin co cN cdiv co cc wcel cA cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv
    co cA cfl cfv cN cdiv co cfl cfv cmin co caddc co cA cA cfl cfv cmin co cN
    cdiv co caddc co cA cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv co cA cfl
    cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co caddc co
    caddc co wceq cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cfl cfv cA cfl
    cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co
    cN cdiv co addass cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cfl cfv cA
    cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co
    cfl cfv cr wcel cA cfl cfv cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv
    co cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl
    cfv cr wcel cN cn wcel cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN
    nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cfl
    cfv cN cdiv co reflcl syl recnd cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv
    co cA cfl cfv cN cdiv co cfl cfv cmin co cA cfl cfv cN cdiv co cr wcel cA
    cfl cfv cN cdiv co cfl cfv cr wcel cA cfl cfv cN cdiv co cA cfl cfv cN cdiv
    co cfl cfv cmin co cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co
    cA cfl cfv cN cdiv co cfl cfv resubcl cA cfl cfv cr wcel cN cr wcel cN cc0
    wne cA cfl cfv cN cdiv co cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN
    redivcl cA cr wcel cA cfl cfv cr wcel cN cn wcel cA reflcl adantr cN cn
    wcel cN cr wcel cA cr wcel cN nnre adantl cN cn wcel cN cc0 wne cA cr wcel
    cN nnne0 adantl syl3anc cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cr
    wcel cA cfl cfv cN cdiv co cfl cfv cr wcel cA cfl cfv cr wcel cN cr wcel cN
    cc0 wne cA cfl cfv cN cdiv co cr wcel cA cr wcel cN cn wcel wa cA cfl cfv
    cN redivcl cA cr wcel cA cfl cfv cr wcel cN cn wcel cA reflcl adantr cN cn
    wcel cN cr wcel cA cr wcel cN nnre adantl cN cn wcel cN cc0 wne cA cr wcel
    cN nnne0 adantl syl3anc cA cfl cfv cN cdiv co reflcl syl sylanc recnd cA cr
    wcel cN cn wcel wa cA cA cfl cfv cmin co cN cdiv co cA cA cfl cfv cmin co
    cr wcel cN cr wcel cN cc0 wne cA cA cfl cfv cmin co cN cdiv co cr wcel cA
    cr wcel cN cn wcel wa cA cA cfl cfv cmin co cN redivcl cA cr wcel cA cA cfl
    cfv cmin co cr wcel cN cn wcel cA cr wcel cA cfl cfv cr wcel cA cA cfl cfv
    cmin co cr wcel cA reflcl cA cA cfl cfv resubcl mpdan adantr cN cn wcel cN
    cr wcel cA cr wcel cN nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0
    adantl syl3anc recnd syl3anc 3eqtrd fveq2d cA cr wcel cN cn wcel wa cA cfl
    cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv
    cmin co cA cA cfl cfv cmin co cN cdiv co caddc co caddc co cfl cfv cA cfl
    cfv cN cdiv co cfl cfv wceq cc0 cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co
    cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co caddc co cle wbr cA cfl
    cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co
    cN cdiv co caddc co c1 clt wbr wa cA cr wcel cN cn wcel wa cc0 cA cfl cfv
    cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN
    cdiv co caddc co cle wbr cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl
    cfv cmin co cA cA cfl cfv cmin co cN cdiv co caddc co c1 clt wbr cA cfl cfv
    cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cr wcel cA cA cfl cfv cmin
    co cN cdiv co cr wcel cc0 cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl
    cfv cmin co cle wbr cc0 cA cA cfl cfv cmin co cN cdiv co cle wbr cc0 cA cfl
    cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co
    cN cdiv co caddc co cle wbr cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co
    cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co
    addge0 cA cfl cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co cfl cfv cr wcel
    cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cr wcel cA cr
    wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv
    resubcl cA cfl cfv cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv co cr
    wcel cA cr wcel cN cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl cfv
    cr wcel cN cn wcel cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN
    nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cr
    wcel cN cn wcel wa cA cfl cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co cfl
    cfv cr wcel cA cfl cfv cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv co
    cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl
    cfv cr wcel cN cn wcel cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN
    nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cfl
    cfv cN cdiv co reflcl syl sylanc cA cA cfl cfv cmin co cr wcel cN cr wcel
    cN cc0 wne cA cA cfl cfv cmin co cN cdiv co cr wcel cA cr wcel cN cn wcel
    wa cA cA cfl cfv cmin co cN redivcl cA cr wcel cA cA cfl cfv cmin co cr
    wcel cN cn wcel cA cr wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel
    cA reflcl cA cA cfl cfv resubcl mpdan adantr cN cn wcel cN cr wcel cA cr
    wcel cN nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl
    syl3anc cA cfl cfv cz wcel cN cn wcel cc0 cA cfl cfv cN cdiv co cA cfl cfv
    cN cdiv co cfl cfv cmin co cle wbr cA cr wcel cA cfl cfv cz wcel cN cn wcel
    wa cc0 cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cle wbr
    cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cN c1 cmin co
    cN cdiv co cle wbr cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cA
    cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co caddc co wceq cA
    cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cfl cfv cN cA
    cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv co cfl cfv eqid cA cfl cfv cN
    cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co eqid intfracq 3simp1d cA flcl
    sylan cA cA cfl cfv cmin co cr wcel cc0 cA cA cfl cfv cmin co cle wbr wa cN
    cr wcel cc0 cN clt wbr wa cc0 cA cA cfl cfv cmin co cN cdiv co cle wbr cA
    cr wcel cN cn wcel cA cA cfl cfv cmin co cN divge0 cA cr wcel cA cA cfl cfv
    cmin co cr wcel cc0 cA cA cfl cfv cmin co cle wbr cA cr wcel cA cfl cfv cr
    wcel cA cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl cfv resubcl mpdan cA
    fracge0 jca cN cn wcel cN cr wcel cc0 cN clt wbr cN nnre cN nngt0 jca
    syl2an syl2anc cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN
    cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co caddc co cN c1
    cmin co cN cdiv co c1 cN cdiv co caddc co c1 clt cA cfl cfv cN cdiv co cA
    cfl cfv cN cdiv co cfl cfv cmin co cr wcel cA cA cfl cfv cmin co cN cdiv co
    cr wcel wa cN c1 cmin co cN cdiv co cr wcel c1 cN cdiv co cr wcel wa wa cA
    cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cN c1 cmin co cN
    cdiv co cle wbr cA cA cfl cfv cmin co cN cdiv co c1 cN cdiv co clt wbr wa
    cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv
    cmin co cN cdiv co caddc co cN c1 cmin co cN cdiv co c1 cN cdiv co caddc co
    clt wbr cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv
    co cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co cN c1 cmin co cN cdiv
    co c1 cN cdiv co leltadd cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cA
    cfl cfv cN cdiv co cfl cfv cmin co cr wcel cA cA cfl cfv cmin co cN cdiv co
    cr wcel cN c1 cmin co cN cdiv co cr wcel c1 cN cdiv co cr wcel wa cA cfl
    cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co cfl cfv cr wcel cA cfl cfv cN
    cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cr wcel cA cr wcel cN cn wcel
    wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv resubcl cA cfl cfv
    cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv co cr wcel cA cr wcel cN
    cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl cfv cr wcel cN cn wcel
    cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN nnre adantl cN cn wcel
    cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cr wcel cN cn wcel wa cA
    cfl cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co cfl cfv cr wcel cA cfl cfv
    cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv co cr wcel cA cr wcel cN
    cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl cfv cr wcel cN cn wcel
    cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN nnre adantl cN cn wcel
    cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cfl cfv cN cdiv co reflcl
    syl sylanc cA cA cfl cfv cmin co cr wcel cN cr wcel cN cc0 wne cA cA cfl
    cfv cmin co cN cdiv co cr wcel cA cr wcel cN cn wcel wa cA cA cfl cfv cmin
    co cN redivcl cA cr wcel cA cA cfl cfv cmin co cr wcel cN cn wcel cA cr
    wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl
    cfv resubcl mpdan adantr cN cn wcel cN cr wcel cA cr wcel cN nnre adantl cN
    cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cN cn wcel cN c1 cmin
    co cN cdiv co cr wcel c1 cN cdiv co cr wcel wa cA cr wcel cN cn wcel cN c1
    cmin co cN cdiv co cr wcel c1 cN cdiv co cr wcel cN c1 cmin co cr wcel cN
    cr wcel cN cc0 wne cN c1 cmin co cN cdiv co cr wcel cN cn wcel cN c1 cmin
    co cN redivcl cN cn wcel cN cr wcel cN c1 cmin co cr wcel cN nnre cN
    peano2rem syl cN nnre cN nnne0 syl3anc cN nnrecre jca adantl jca31 cA cr
    wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin
    co cN c1 cmin co cN cdiv co cle wbr cA cA cfl cfv cmin co cN cdiv co c1 cN
    cdiv co clt wbr cA cfl cfv cz wcel cN cn wcel cA cfl cfv cN cdiv co cA cfl
    cfv cN cdiv co cfl cfv cmin co cN c1 cmin co cN cdiv co cle wbr cA cr wcel
    cA cfl cfv cz wcel cN cn wcel wa cc0 cA cfl cfv cN cdiv co cA cfl cfv cN
    cdiv co cfl cfv cmin co cle wbr cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co
    cfl cfv cmin co cN c1 cmin co cN cdiv co cle wbr cA cfl cfv cN cdiv co cA
    cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl
    cfv cmin co caddc co wceq cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl
    cfv cmin co cA cfl cfv cN cA cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv
    co cfl cfv eqid cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co
    eqid intfracq 3simp2d cA flcl sylan cA cr wcel cN cn wcel wa cA cA cfl cfv
    cmin co c1 clt wbr cA cA cfl cfv cmin co cN cdiv co c1 cN cdiv co clt wbr
    cA cr wcel cA cA cfl cfv cmin co c1 clt wbr cN cn wcel cA fraclt1 adantr cA
    cA cfl cfv cmin co cr wcel cN cr wcel cc0 cN clt wbr wa cA cA cfl cfv cmin
    co c1 clt wbr cA cA cfl cfv cmin co cN cdiv co c1 cN cdiv co clt wbr wb cA
    cr wcel cN cn wcel cA cA cfl cfv cmin co cr wcel c1 cr wcel cN cr wcel cc0
    cN clt wbr wa cA cA cfl cfv cmin co c1 clt wbr cA cA cfl cfv cmin co cN
    cdiv co c1 cN cdiv co clt wbr wb 1re cA cA cfl cfv cmin co c1 cN ltdiv1
    mp3an2 cA cr wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel cA
    reflcl cA cA cfl cfv resubcl mpdan cN cn wcel cN cr wcel cc0 cN clt wbr cN
    nnre cN nngt0 jca syl2an mpbid jca sylc cN cn wcel cN c1 cmin co cN cdiv co
    c1 cN cdiv co caddc co c1 wceq cA cr wcel cN cn wcel cN c1 cmin co c1 caddc
    co cN cdiv co cN cN cdiv co cN c1 cmin co cN cdiv co c1 cN cdiv co caddc co
    c1 cN cn wcel cN c1 cmin co c1 caddc co cN cN cdiv cN cc wcel c1 cc wcel cN
    c1 cmin co c1 caddc co cN wceq cN cn wcel cN c1 npcan cN nncn ax1cn sylancl
    opreq1d cN c1 cmin co cc wcel cN cc wcel cN cc0 wne wa cN c1 cmin co c1
    caddc co cN cdiv co cN c1 cmin co cN cdiv co c1 cN cdiv co caddc co wceq cN
    cn wcel cN c1 cmin co cc wcel c1 cc wcel cN cc wcel cN cc0 wne wa cN c1
    cmin co c1 caddc co cN cdiv co cN c1 cmin co cN cdiv co c1 cN cdiv co caddc
    co wceq ax1cn cN c1 cmin co c1 cN divdir mp3an2 cN cn wcel cN c1 cmin co cN
    cn wcel cN cr wcel cN c1 cmin co cr wcel cN nnre cN peano2rem syl recnd cN
    cn wcel cN cc wcel cN cc0 wne cN nncn cN nnne0 jca sylanc cN cc wcel cN cc0
    wne cN cN cdiv co c1 wceq cN cn wcel cN divid cN nncn cN nnne0 sylanc
    3eqtr3d adantl breqtrd jca cA cfl cfv cN cdiv co cfl cfv cz wcel cA cfl cfv
    cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN
    cdiv co caddc co cr wcel cA cfl cfv cN cdiv co cfl cfv cA cfl cfv cN cdiv
    co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co
    caddc co caddc co cfl cfv cA cfl cfv cN cdiv co cfl cfv wceq cc0 cA cfl cfv
    cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN
    cdiv co caddc co cle wbr cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl
    cfv cmin co cA cA cfl cfv cmin co cN cdiv co caddc co c1 clt wbr wa wb cA
    cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv
    cmin co cA cA cfl cfv cmin co cN cdiv co caddc co cA cfl cfv cN cdiv co cfl
    cfv flbi2 cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv co cr wcel cA cfl cfv
    cN cdiv co cfl cfv cz wcel cA cfl cfv cr wcel cN cr wcel cN cc0 wne cA cfl
    cfv cN cdiv co cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN redivcl cA cr
    wcel cA cfl cfv cr wcel cN cn wcel cA reflcl adantr cN cn wcel cN cr wcel
    cA cr wcel cN nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl
    syl3anc cA cfl cfv cN cdiv co flcl syl cA cfl cfv cN cdiv co cA cfl cfv cN
    cdiv co cfl cfv cmin co cr wcel cA cA cfl cfv cmin co cN cdiv co cr wcel cA
    cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin
    co cN cdiv co caddc co cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN cdiv
    co cA cfl cfv cN cdiv co cfl cfv cmin co cA cA cfl cfv cmin co cN cdiv co
    readdcl cA cfl cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co cfl cfv cr wcel
    cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv cmin co cr wcel cA cr
    wcel cN cn wcel wa cA cfl cfv cN cdiv co cA cfl cfv cN cdiv co cfl cfv
    resubcl cA cfl cfv cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv co cr
    wcel cA cr wcel cN cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl cfv
    cr wcel cN cn wcel cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN
    nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cr
    wcel cN cn wcel wa cA cfl cfv cN cdiv co cr wcel cA cfl cfv cN cdiv co cfl
    cfv cr wcel cA cfl cfv cr wcel cN cr wcel cN cc0 wne cA cfl cfv cN cdiv co
    cr wcel cA cr wcel cN cn wcel wa cA cfl cfv cN redivcl cA cr wcel cA cfl
    cfv cr wcel cN cn wcel cA reflcl adantr cN cn wcel cN cr wcel cA cr wcel cN
    nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl syl3anc cA cfl
    cfv cN cdiv co reflcl syl sylanc cA cA cfl cfv cmin co cr wcel cN cr wcel
    cN cc0 wne cA cA cfl cfv cmin co cN cdiv co cr wcel cA cr wcel cN cn wcel
    wa cA cA cfl cfv cmin co cN redivcl cA cr wcel cA cA cfl cfv cmin co cr
    wcel cN cn wcel cA cr wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel
    cA reflcl cA cA cfl cfv resubcl mpdan adantr cN cn wcel cN cr wcel cA cr
    wcel cN nnre adantl cN cn wcel cN cc0 wne cA cr wcel cN nnne0 adantl
    syl3anc sylanc sylanc mpbird eqtr2d $.
    $( [5-Sep-2008] $) $( [16-Aug-2008] $)

  $( Cancellation of an embedded floor of a ratio.  Generalization of Equation
     2.4 in [CormenLeisersonRivest] p. 33 (where ` A ` must be an integer). $)
  fldiv2 $p |- ( ( A e. RR /\ M e. NN /\ N e. NN )
      -> ( |_ ` ( ( |_ ` ( A / M ) ) / N ) ) = ( |_ ` ( A / ( M x. N ) ) ) ) $=
    cA cr wcel cM cn wcel cN cn wcel w3a cA cM cdiv co cfl cfv cN cdiv co cfl
    cfv cA cM cdiv co cN cdiv co cfl cfv cA cM cN cmul co cdiv co cfl cfv cA cr
    wcel cM cn wcel cN cn wcel cA cM cdiv co cfl cfv cN cdiv co cfl cfv cA cM
    cdiv co cN cdiv co cfl cfv wceq cA cM cdiv co cr wcel cN cn wcel cA cM cdiv
    co cfl cfv cN cdiv co cfl cfv cA cM cdiv co cN cdiv co cfl cfv wceq cA cr
    wcel cM cn wcel wa cA cM cdiv co cN fldiv cA cr wcel cM cr wcel cM cc0 wne
    cA cM cdiv co cr wcel cA cr wcel cM cn wcel wa cA cM redivcl cA cr wcel cM
    cn wcel pm3.26 cM cn wcel cM cr wcel cA cr wcel cM nnre adantl cM cn wcel
    cM cc0 wne cA cr wcel cM nnne0 adantl syl3anc sylan 3impa cA cr wcel cM cn
    wcel cN cn wcel w3a cA cM cdiv co cN cdiv co cA cM cN cmul co cdiv co cfl
    cA cc wcel cM cc wcel cM cc0 wne wa cN cc wcel cN cc0 wne wa cA cM cdiv co
    cN cdiv co cA cM cN cmul co cdiv co wceq cA cr wcel cM cn wcel cN cn wcel
    cA cM cN divdiv1 cA recn cM cn wcel cM cc wcel cM cc0 wne cM nncn cM nnne0
    jca cN cn wcel cN cc wcel cN cc0 wne cN nncn cN nnne0 jca syl3an fveq2d
    eqtrd $.
    $( [12-Dec-2008] $) $( [9-Nov-2008] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The modulo (remainder) operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c mod $.  $( Modulo operation. $)
  $c == $.  $( Equivalence symbol (not used yet except in comments). $)

  $( Extend class notation with the modulo operation. $)
  cmo $a class mod $.

  ${
    $d x y z $.
    $( Define the modulo (remainder) operation.  See ~ modval for its
       value. $)
    df-mod $a |- mod = { <. <. x , y >. , z >. | ( ( x e. RR /\ y e. RR+ )
          /\ z = ( x - ( y x. ( |_ ` ( x / y ) ) ) ) ) } $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The value of the modulo operation.  The modulo congruence notation of
       number theory, ` J == K ( ` modulo ` N ) ` , can be expressed in our
       notation as ` ( J mod N ) = ( K mod N ) ` .  Definition 1 in Knuth, _The
       Art of Computer Programming_, Vol. I (1972), p. 38.  Knuth uses "mod"
       for the operation and "modulo" for the congruence.  Unlike Knuth, we
       restrict the second argument to positive reals to simplify certain
       theorems.  (This also gives us future flexibility to extend it to any
       one of several different conventions for a zero or negative second
       argument, should there be an advantage in doing so.) $)
    modval $p |- ( ( A e. RR /\ B e. RR+ )
           -> ( A mod B ) = ( A - ( B x. ( |_ ` ( A / B ) ) ) ) ) $=
      vx vy vz cA cB cr crp vx cv vy cv vx cv vy cv cdiv co cfl cfv cmul co
      cmin co cA cB cA cB cdiv co cfl cfv cmul co cmin co cmo cA vy cv cA vy cv
      cdiv co cfl cfv cmul co cmin co cA cB cA cB cdiv co cfl cfv cmul co cmin
      oprex vx cv cA wceq vx cv cA vy cv vx cv vy cv cdiv co cfl cfv cmul co vy
      cv cA vy cv cdiv co cfl cfv cmul co cmin vx cv cA wceq id vx cv cA wceq
      vx cv vy cv cdiv co cfl cfv cA vy cv cdiv co cfl cfv vy cv cmul vx cv cA
      wceq vx cv vy cv cdiv co cA vy cv cdiv co cfl vx cv cA vy cv cdiv opreq1
      fveq2d opreq2d opreq12d vy cv cB wceq vy cv cA vy cv cdiv co cfl cfv cmul
      co cB cA cB cdiv co cfl cfv cmul co cA cmin vy cv cB wceq vy cv cB cA vy
      cv cdiv co cfl cfv cA cB cdiv co cfl cfv cmul vy cv cB wceq id vy cv cB
      wceq cA vy cv cdiv co cA cB cdiv co cfl vy cv cB cA cdiv opreq2 fveq2d
      opreq12d opreq2d vx vy vz df-mod oprabval2 $.
      $( [10-Nov-2008] $) $( [10-Nov-2008] $)
  $}

  $( Closure law for the modulo operation. $)
  modcl $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A mod B ) e. RR ) $=
    cA cr wcel cB crp wcel wa cA cB cmo co cA cB cA cB cdiv co cfl cfv cmul co
    cmin co cr cA cB modval cA cr wcel cB crp wcel cB cA cB cdiv co cfl cfv
    cmul co cr wcel cA cB cA cB cdiv co cfl cfv cmul co cmin co cr wcel cB cr
    wcel cA cB cdiv co cfl cfv cr wcel cB cA cB cdiv co cfl cfv cmul co cr wcel
    cA cr wcel cB crp wcel wa cB cA cB cdiv co cfl cfv remulcl cB crp wcel cB
    cr wcel cA cr wcel cB rpre adantl cA cr wcel cB crp wcel wa cA cB cdiv co
    cr wcel cA cB cdiv co cfl cfv cr wcel cA cB rerpdivcl cA cB cdiv co reflcl
    syl sylanc cA cB cA cB cdiv co cfl cfv cmul co resubcl syldan eqeltrd $.
    $( [28-Nov-2008] $) $( [10-Nov-2008] $)

  $( The modulo operation is nonnegative. $)
  modge0 $p |- ( ( A e. RR /\ B e. RR+ ) -> 0 <_ ( A mod B ) ) $=
    cA cr wcel cB crp wcel wa cc0 cA cB cA cB cdiv co cfl cfv cmul co cmin co
    cA cB cmo co cle cA cr wcel cB crp wcel wa cc0 cA cB cA cB cdiv co cfl cfv
    cmul co cmin co cle wbr cB cA cB cdiv co cfl cfv cmul co cA cle wbr cA cr
    wcel cB crp wcel wa cB cA cB cdiv co cfl cfv cmul co cA cle wbr cA cB cdiv
    co cfl cfv cA cB cdiv co cle wbr cA cr wcel cB crp wcel wa cA cB cdiv co cr
    wcel cA cB cdiv co cfl cfv cA cB cdiv co cle wbr cA cB rerpdivcl cA cB cdiv
    co flle syl cA cB cdiv co cfl cfv cr wcel cA cr wcel cB cr wcel cc0 cB clt
    wbr wa cB cA cB cdiv co cfl cfv cmul co cA cle wbr cA cB cdiv co cfl cfv cA
    cB cdiv co cle wbr wb cA cr wcel cB crp wcel wa cA cB cdiv co cfl cfv cA cB
    lemuldiv2 cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl
    cfv cr wcel cA cB rerpdivcl cA cB cdiv co reflcl syl cA cr wcel cB crp wcel
    pm3.26 cB crp wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cB rpregt0
    adantl syl3anc mpbird cA cr wcel cB crp wcel cB cA cB cdiv co cfl cfv cmul
    co cr wcel cc0 cA cB cA cB cdiv co cfl cfv cmul co cmin co cle wbr cB cA cB
    cdiv co cfl cfv cmul co cA cle wbr wb cB cr wcel cA cB cdiv co cfl cfv cr
    wcel cB cA cB cdiv co cfl cfv cmul co cr wcel cA cr wcel cB crp wcel wa cB
    cA cB cdiv co cfl cfv remulcl cB crp wcel cB cr wcel cA cr wcel cB rpre
    adantl cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl
    cfv cr wcel cA cB rerpdivcl cA cB cdiv co reflcl syl sylanc cA cB cA cB
    cdiv co cfl cfv cmul co subge0 syldan mpbird cA cB modval breqtrrd $.
    $( [13-Dec-2008] $) $( [10-Nov-2008] $)

  $( The modulo operation is less than its second argument. $)
  modlt $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A mod B ) < B ) $=
    cA cr wcel cB crp wcel wa cA cB cmo co cB cA cB cdiv co cA cB cdiv co cfl
    cfv cmin co cmul co cB clt cA cr wcel cB crp wcel wa cB cA cB cdiv co cmul
    co cB cA cB cdiv co cfl cfv cmul co cmin co cA cB cA cB cdiv co cfl cfv
    cmul co cmin co cB cA cB cdiv co cA cB cdiv co cfl cfv cmin co cmul co cA
    cB cmo co cA cr wcel cB crp wcel wa cB cA cB cdiv co cmul co cA cB cA cB
    cdiv co cfl cfv cmul co cmin cA cc wcel cB cc wcel cB cc0 wne wa cB cA cB
    cdiv co cmul co cA wceq cA cr wcel cB crp wcel cA cc wcel cB cc wcel cB cc0
    wne cB cA cB cdiv co cmul co cA wceq cA cB divcan2 3expb cA recn cB rpcnne0
    syl2an opreq1d cB cc wcel cA cB cdiv co cc wcel cA cB cdiv co cfl cfv cc
    wcel cB cA cB cdiv co cA cB cdiv co cfl cfv cmin co cmul co cB cA cB cdiv
    co cmul co cB cA cB cdiv co cfl cfv cmul co cmin co wceq cA cr wcel cB crp
    wcel wa cB cA cB cdiv co cA cB cdiv co cfl cfv subdi cB crp wcel cB cc wcel
    cA cr wcel cB rpcn adantl cA cr wcel cB crp wcel wa cA cB cdiv co cA cB
    rerpdivcl recnd cA cr wcel cB crp wcel wa cA cB cdiv co cfl cfv cA cr wcel
    cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cr wcel cA cB
    rerpdivcl cA cB cdiv co reflcl syl recnd syl3anc cA cB modval 3eqtr4rd cA
    cr wcel cB crp wcel wa cB cA cB cdiv co cA cB cdiv co cfl cfv cmin co cmul
    co cB clt wbr cA cB cdiv co cA cB cdiv co cfl cfv cmin co cB cB cdiv co clt
    wbr cA cr wcel cB crp wcel wa cA cB cdiv co cA cB cdiv co cfl cfv cmin co
    c1 cB cB cdiv co clt cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB
    cdiv co cA cB cdiv co cfl cfv cmin co c1 clt wbr cA cB rerpdivcl cA cB cdiv
    co fraclt1 syl cB crp wcel cB cB cdiv co c1 wceq cA cr wcel cB crp wcel cB
    cc wcel cB cc0 wne wa cB cB cdiv co c1 wceq cB rpcnne0 cB divid syl adantl
    breqtrrd cA cB cdiv co cA cB cdiv co cfl cfv cmin co cr wcel cB cr wcel cB
    cr wcel cc0 cB clt wbr wa cB cA cB cdiv co cA cB cdiv co cfl cfv cmin co
    cmul co cB clt wbr cA cB cdiv co cA cB cdiv co cfl cfv cmin co cB cB cdiv
    co clt wbr wb cA cr wcel cB crp wcel wa cA cB cdiv co cA cB cdiv co cfl cfv
    cmin co cB cB ltmuldiv2 cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cr wcel
    cA cB cdiv co cA cB cdiv co cfl cfv cmin co cr wcel cA cr wcel cB crp wcel
    wa cA cB cdiv co cA cB cdiv co cfl cfv resubcl cA cB rerpdivcl cA cr wcel
    cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cr wcel cA cB
    rerpdivcl cA cB cdiv co reflcl syl sylanc cB crp wcel cB cr wcel cA cr wcel
    cB rpre adantl cB crp wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cB
    rpregt0 adantl syl3anc mpbird eqbrtrd $.
    $( [30-Dec-2008] $) $( [10-Nov-2008] $)

  $( The fractional part of a number is the number modulo 1. $)
  modfrac $p |- ( A e. RR -> ( A mod 1 ) = ( A - ( |_ ` A ) ) ) $=
    cA cr wcel cA c1 cmo co cA c1 cA c1 cdiv co cfl cfv cmul co cmin co cA cA
    cfl cfv cmin co cA cr wcel c1 crp wcel cA c1 cmo co cA c1 cA c1 cdiv co cfl
    cfv cmul co cmin co wceq 1rp cA c1 modval mpan2 cA cr wcel c1 cA c1 cdiv co
    cfl cfv cmul co cA cfl cfv cA cmin cA cr wcel c1 cA c1 cdiv co cfl cfv cmul
    co c1 cA cfl cfv cmul co cA cfl cfv cA cr wcel cA c1 cdiv co cfl cfv cA cfl
    cfv c1 cmul cA cr wcel cA c1 cdiv co cA cfl cA cr wcel cA cc wcel cA c1
    cdiv co cA wceq cA recn cA div1 syl fveq2d opreq2d cA cr wcel cA cfl cfv cc
    wcel c1 cA cfl cfv cmul co cA cfl cfv wceq cA cr wcel cA cfl cfv cA reflcl
    recnd cA cfl cfv mulid2 syl eqtrd opreq2d eqtrd $.
    $( [11-Nov-2008] $) $( [11-Nov-2008] $)

  $( The floor function expressed in terms of the modulo operation. $)
  flmod $p |- ( A e. RR -> ( |_ ` A ) = ( A - ( A mod 1 ) ) ) $=
    cA cr wcel cA cA c1 cmo co cmin co cA cA cA cfl cfv cmin co cmin co cA cfl
    cfv cA cr wcel cA c1 cmo co cA cA cfl cfv cmin co cA cmin cA modfrac
    opreq2d cA cc wcel cA cfl cfv cc wcel cA cA cA cfl cfv cmin co cmin co cA
    cfl cfv wceq cA cr wcel cA cA cfl cfv nncan cA recn cA cr wcel cA cfl cfv
    cA reflcl recnd sylanc eqtr2d $.
    $( [29-Dec-2008] $) $( [11-Nov-2008] $)

  $( Break a number into its integer part and its fractional part. $)
  intfrac $p |- ( A e. RR -> A = ( ( |_ ` A ) + ( A mod 1 ) ) ) $=
    cA cr wcel cA cfl cfv cA c1 cmo co caddc co cA cfl cfv cA cA cfl cfv cmin
    co caddc co cA cA cr wcel cA c1 cmo co cA cA cfl cfv cmin co cA cfl cfv
    caddc cA modfrac opreq2d cA cfl cfv cc wcel cA cc wcel cA cfl cfv cA cA cfl
    cfv cmin co caddc co cA wceq cA cr wcel cA cfl cfv cA pncan3 cA cr wcel cA
    cfl cfv cA reflcl recnd cA recn sylanc eqtr2d $.
    $( [31-Dec-2008] $) $( [31-Dec-2008] $)

  $( Move a nonnegative integer in and out of a floor. $)
  flmulnn0 $p |- ( ( N e. NN0 /\ A e. RR )
              -> ( N x. ( |_ ` A ) ) <_ ( |_ ` ( N x. A ) ) ) $=
    cN cn0 wcel cA cr wcel wa cN cA cfl cfv cmul co cN cA cfl cfv cmul co cN cA
    c1 cmo co cmul co cfl cfv caddc co cN cA cmul co cfl cfv cle cN cA cfl cfv
    cmul co cr wcel cN cA c1 cmo co cmul co cfl cfv cr wcel cc0 cN cA c1 cmo co
    cmul co cfl cfv cle wbr cN cA cfl cfv cmul co cN cA cfl cfv cmul co cN cA
    c1 cmo co cmul co cfl cfv caddc co cle wbr cN cn0 wcel cA cr wcel wa cN cA
    cfl cfv cmul co cr wcel cN cA c1 cmo co cmul co cfl cfv cr wcel cc0 cN cA
    c1 cmo co cmul co cfl cfv cle wbr cN cA cfl cfv cmul co cN cA cfl cfv cmul
    co cN cA c1 cmo co cmul co cfl cfv caddc co cle wbr cN cA cfl cfv cmul co
    cN cA c1 cmo co cmul co cfl cfv addge01 biimp3a cN cr wcel cA cfl cfv cr
    wcel cN cA cfl cfv cmul co cr wcel cN cn0 wcel cA cr wcel cN cA cfl cfv
    remulcl cN nn0re cA reflcl syl2an cN cn0 wcel cA cr wcel wa cN cA c1 cmo co
    cmul co cr wcel cN cA c1 cmo co cmul co cfl cfv cr wcel cN cr wcel cA c1
    cmo co cr wcel cN cA c1 cmo co cmul co cr wcel cN cn0 wcel cA cr wcel cN cA
    c1 cmo co remulcl cN nn0re cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp
    cA c1 modcl mpan2 syl2an cN cA c1 cmo co cmul co reflcl syl cN cA c1 cmo co
    cmul co cr wcel cc0 cN cA c1 cmo co cmul co cle wbr cc0 cN cA c1 cmo co
    cmul co cfl cfv cle wbr cN cn0 wcel cA cr wcel wa cN cA c1 cmo co cmul co
    cr wcel cc0 cN cA c1 cmo co cmul co cle wbr cc0 cN cA c1 cmo co cmul co cfl
    cfv cle wbr cN cA c1 cmo co cmul co cr wcel cc0 cz wcel cc0 cN cA c1 cmo co
    cmul co cle wbr cc0 cN cA c1 cmo co cmul co cfl cfv cle wbr wb 0z cN cA c1
    cmo co cmul co cc0 flge mpan2 biimpa cN cr wcel cA c1 cmo co cr wcel cN cA
    c1 cmo co cmul co cr wcel cN cn0 wcel cA cr wcel cN cA c1 cmo co remulcl cN
    nn0re cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp cA c1 modcl mpan2
    syl2an cN cr wcel cc0 cN cle wbr wa cA c1 cmo co cr wcel cc0 cA c1 cmo co
    cle wbr wa cc0 cN cA c1 cmo co cmul co cle wbr cN cn0 wcel cA cr wcel cN cA
    c1 cmo co mulge0 cN cn0 wcel cN cr wcel cc0 cN cle wbr cN nn0re cN nn0ge0
    jca cA cr wcel cA c1 cmo co cr wcel cc0 cA c1 cmo co cle wbr cA cr wcel c1
    crp wcel cA c1 cmo co cr wcel 1rp cA c1 modcl mpan2 cA cr wcel c1 crp wcel
    cc0 cA c1 cmo co cle wbr 1rp cA c1 modge0 mpan2 jca syl2an sylanc syl3anc
    cN cn0 wcel cA cr wcel wa cN cA cmul co cfl cfv cN cA cfl cfv cmul co cN cA
    c1 cmo co cmul co caddc co cfl cfv cN cA cfl cfv cmul co cN cA c1 cmo co
    cmul co cfl cfv caddc co cN cn0 wcel cA cr wcel wa cN cA cmul co cN cA cfl
    cfv cmul co cN cA c1 cmo co cmul co caddc co cfl cN cn0 wcel cA cr wcel wa
    cN cA cmul co cN cA cfl cfv cA c1 cmo co caddc co cmul co cN cA cfl cfv
    cmul co cN cA c1 cmo co cmul co caddc co cN cn0 wcel cA cr wcel wa cA cA
    cfl cfv cA c1 cmo co caddc co cN cmul cA cr wcel cA cA cfl cfv cA c1 cmo co
    caddc co wceq cN cn0 wcel cA intfrac adantl opreq2d cN cc wcel cA cfl cfv
    cc wcel cA c1 cmo co cc wcel wa cN cA cfl cfv cA c1 cmo co caddc co cmul co
    cN cA cfl cfv cmul co cN cA c1 cmo co cmul co caddc co wceq cN cn0 wcel cA
    cr wcel cN cc wcel cA cfl cfv cc wcel cA c1 cmo co cc wcel cN cA cfl cfv cA
    c1 cmo co caddc co cmul co cN cA cfl cfv cmul co cN cA c1 cmo co cmul co
    caddc co wceq cN cA cfl cfv cA c1 cmo co adddi 3expb cN nn0cn cA cr wcel cA
    cfl cfv cc wcel cA c1 cmo co cc wcel cA cr wcel cA cfl cfv cA reflcl recnd
    cA cr wcel cA c1 cmo co cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp cA
    c1 modcl mpan2 recnd jca syl2an eqtrd fveq2d cN cA cfl cfv cmul co cz wcel
    cN cA c1 cmo co cmul co cr wcel cN cA cfl cfv cmul co cN cA c1 cmo co cmul
    co caddc co cfl cfv cN cA cfl cfv cmul co cN cA c1 cmo co cmul co cfl cfv
    caddc co wceq cN cn0 wcel cA cr wcel wa cN cA c1 cmo co cmul co cN cA cfl
    cfv cmul co flzadd cN cz wcel cA cfl cfv cz wcel cN cA cfl cfv cmul co cz
    wcel cN cn0 wcel cA cr wcel cN cA cfl cfv zmulcl cN nn0z cA flcl syl2an cN
    cr wcel cA c1 cmo co cr wcel cN cA c1 cmo co cmul co cr wcel cN cn0 wcel cA
    cr wcel cN cA c1 cmo co remulcl cN nn0re cA cr wcel c1 crp wcel cA c1 cmo
    co cr wcel 1rp cA c1 modcl mpan2 syl2an sylanc eqtr2d breqtrd $.
    $( [24-Jul-2009] $) $( [2-Jan-2009] $)

  $( Move a nonnegative integer in and out of a floor. $)
  flmulnn0OLD $p |- ( ( N e. NN0 /\ A e. RR )
              -> ( N x. ( |_ ` A ) ) <_ ( |_ ` ( N x. A ) ) ) $=
    cN cn0 wcel cA cr wcel wa cN cA cfl cfv cmul co cN cA cfl cfv cmul co cN cA
    c1 cmo co cmul co cfl cfv caddc co cN cA cmul co cfl cfv cle cN cA cfl cfv
    cmul co cr wcel cN cA c1 cmo co cmul co cfl cfv cr wcel cc0 cN cA c1 cmo co
    cmul co cfl cfv cle wbr cN cA cfl cfv cmul co cN cA cfl cfv cmul co cN cA
    c1 cmo co cmul co cfl cfv caddc co cle wbr cN cn0 wcel cA cr wcel wa cN cA
    cfl cfv cmul co cr wcel cN cA c1 cmo co cmul co cfl cfv cr wcel cc0 cN cA
    c1 cmo co cmul co cfl cfv cle wbr cN cA cfl cfv cmul co cN cA cfl cfv cmul
    co cN cA c1 cmo co cmul co cfl cfv caddc co cle wbr cN cA cfl cfv cmul co
    cN cA c1 cmo co cmul co cfl cfv addge01 biimp3a cN cr wcel cA cfl cfv cr
    wcel cN cA cfl cfv cmul co cr wcel cN cn0 wcel cA cr wcel cN cA cfl cfv
    remulcl cN nn0re cA reflcl syl2an cN cn0 wcel cA cr wcel wa cN cA c1 cmo co
    cmul co cr wcel cN cA c1 cmo co cmul co cfl cfv cr wcel cN cr wcel cA c1
    cmo co cr wcel cN cA c1 cmo co cmul co cr wcel cN cn0 wcel cA cr wcel cN cA
    c1 cmo co remulcl cN nn0re cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp
    cA c1 modcl mpan2 syl2an cN cA c1 cmo co cmul co reflcl syl cN cA c1 cmo co
    cmul co cr wcel cc0 cN cA c1 cmo co cmul co cle wbr cc0 cN cA c1 cmo co
    cmul co cfl cfv cle wbr cN cn0 wcel cA cr wcel wa cN cA c1 cmo co cmul co
    cr wcel cc0 cN cA c1 cmo co cmul co cle wbr cc0 cN cA c1 cmo co cmul co cfl
    cfv cle wbr cN cA c1 cmo co cmul co cr wcel cc0 cz wcel cc0 cN cA c1 cmo co
    cmul co cle wbr cc0 cN cA c1 cmo co cmul co cfl cfv cle wbr wb 0z cN cA c1
    cmo co cmul co cc0 flge mpan2 biimpa cN cr wcel cA c1 cmo co cr wcel cN cA
    c1 cmo co cmul co cr wcel cN cn0 wcel cA cr wcel cN cA c1 cmo co remulcl cN
    nn0re cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp cA c1 modcl mpan2
    syl2an cN cr wcel cA c1 cmo co cr wcel wa cc0 cN cle wbr cc0 cA c1 cmo co
    cle wbr wa cc0 cN cA c1 cmo co cmul co cle wbr cN cn0 wcel cA cr wcel wa cN
    cA c1 cmo co mulge0OLD cN cn0 wcel cN cr wcel cA cr wcel cA c1 cmo co cr
    wcel cN nn0re cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp cA c1 modcl
    mpan2 anim12i cN cn0 wcel cc0 cN cle wbr cA cr wcel cc0 cA c1 cmo co cle
    wbr cN nn0ge0 cA cr wcel c1 crp wcel cc0 cA c1 cmo co cle wbr 1rp cA c1
    modge0 mpan2 anim12i sylanc sylanc syl3anc cN cn0 wcel cA cr wcel wa cN cA
    cmul co cfl cfv cN cA cfl cfv cmul co cN cA c1 cmo co cmul co caddc co cfl
    cfv cN cA cfl cfv cmul co cN cA c1 cmo co cmul co cfl cfv caddc co cN cn0
    wcel cA cr wcel wa cN cA cmul co cN cA cfl cfv cmul co cN cA c1 cmo co cmul
    co caddc co cfl cN cn0 wcel cA cr wcel wa cN cA cmul co cN cA cfl cfv cA c1
    cmo co caddc co cmul co cN cA cfl cfv cmul co cN cA c1 cmo co cmul co caddc
    co cN cn0 wcel cA cr wcel wa cA cA cfl cfv cA c1 cmo co caddc co cN cmul cA
    cr wcel cA cA cfl cfv cA c1 cmo co caddc co wceq cN cn0 wcel cA intfrac
    adantl opreq2d cN cc wcel cA cfl cfv cc wcel cA c1 cmo co cc wcel wa cN cA
    cfl cfv cA c1 cmo co caddc co cmul co cN cA cfl cfv cmul co cN cA c1 cmo co
    cmul co caddc co wceq cN cn0 wcel cA cr wcel cN cc wcel cA cfl cfv cc wcel
    cA c1 cmo co cc wcel cN cA cfl cfv cA c1 cmo co caddc co cmul co cN cA cfl
    cfv cmul co cN cA c1 cmo co cmul co caddc co wceq cN cA cfl cfv cA c1 cmo
    co adddi 3expb cN nn0cn cA cr wcel cA cfl cfv cc wcel cA c1 cmo co cc wcel
    cA cr wcel cA cfl cfv cA reflcl recnd cA cr wcel cA c1 cmo co cA cr wcel c1
    crp wcel cA c1 cmo co cr wcel 1rp cA c1 modcl mpan2 recnd jca syl2an eqtrd
    fveq2d cN cA cfl cfv cmul co cz wcel cN cA c1 cmo co cmul co cr wcel cN cA
    cfl cfv cmul co cN cA c1 cmo co cmul co caddc co cfl cfv cN cA cfl cfv cmul
    co cN cA c1 cmo co cmul co cfl cfv caddc co wceq cN cn0 wcel cA cr wcel wa
    cN cA c1 cmo co cmul co cN cA cfl cfv cmul co flzadd cN cz wcel cA cfl cfv
    cz wcel cN cA cfl cfv cmul co cz wcel cN cn0 wcel cA cr wcel cN cA cfl cfv
    zmulcl cN nn0z cA flcl syl2an cN cr wcel cA c1 cmo co cr wcel cN cA c1 cmo
    co cmul co cr wcel cN cn0 wcel cA cr wcel cN cA c1 cmo co remulcl cN nn0re
    cA cr wcel c1 crp wcel cA c1 cmo co cr wcel 1rp cA c1 modcl mpan2 syl2an
    sylanc eqtr2d breqtrd $.
    $( [16-Feb-2009] $) $( [2-Jan-2009] $)

  $( Move a natural number in and out of a floor in the first argument of
     a modulo operation. $)
  modmulnn $p |- ( ( N e. NN /\ A e. RR /\ M e. NN ) -> ( ( N x. ( |_ ` A ) )
           mod ( N x. M ) ) <_ ( ( |_ ` ( N x. A ) ) mod ( N x. M ) ) ) $=
    cN cn wcel cA cr wcel cM cn wcel w3a cN cA cfl cfv cmul co cN cM cmul co cN
    cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv cmul co cmin co cN cA cmul
    co cfl cfv cN cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl
    cfv cmul co cmin co cN cA cfl cfv cmul co cN cM cmul co cmo co cN cA cmul
    co cfl cfv cN cM cmul co cmo co cle cN cn wcel cA cr wcel cM cn wcel w3a cN
    cA cfl cfv cmul co cN cA cmul co cfl cfv cle wbr cN cA cfl cfv cmul co cN
    cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv cmul co cmin
    co cN cA cmul co cfl cfv cN cM cmul co cN cA cfl cfv cmul co cN cM cmul co
    cdiv co cfl cfv cmul co cmin co cle wbr cN cn wcel cA cr wcel cN cA cfl cfv
    cmul co cN cA cmul co cfl cfv cle wbr cM cn wcel cN cn0 wcel cA cr wcel cN
    cA cfl cfv cmul co cN cA cmul co cfl cfv cle wbr cN cn wcel cA cN flmulnn0
    cN nnnn0 sylan 3adant3 cN cA cfl cfv cmul co cr wcel cN cA cmul co cfl cfv
    cr wcel cN cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv
    cmul co cr wcel cN cA cfl cfv cmul co cN cA cmul co cfl cfv cle wbr cN cA
    cfl cfv cmul co cN cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co
    cfl cfv cmul co cmin co cN cA cmul co cfl cfv cN cM cmul co cN cA cfl cfv
    cmul co cN cM cmul co cdiv co cfl cfv cmul co cmin co cle wbr wb cN cn wcel
    cA cr wcel cM cn wcel w3a cN cA cfl cfv cmul co cN cA cmul co cfl cfv cN cM
    cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv cmul co lesub1
    cN cn wcel cA cr wcel cN cA cfl cfv cmul co cr wcel cM cn wcel cN cr wcel
    cA cfl cfv cr wcel cN cA cfl cfv cmul co cr wcel cN cn wcel cA cr wcel cN
    cA cfl cfv remulcl cN nnre cA reflcl syl2an 3adant3 cN cn wcel cA cr wcel
    cN cA cmul co cfl cfv cr wcel cM cn wcel cN cn wcel cA cr wcel wa cN cA
    cmul co cr wcel cN cA cmul co cfl cfv cr wcel cN cr wcel cA cr wcel cN cA
    cmul co cr wcel cN cn wcel cN cA remulcl cN nnre sylan cN cA cmul co reflcl
    syl 3adant3 cN cM cmul co cr wcel cN cA cfl cfv cmul co cN cM cmul co cdiv
    co cfl cfv cr wcel cN cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv
    co cfl cfv cmul co cr wcel cN cn wcel cA cr wcel cM cn wcel w3a cN cM cmul
    co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv remulcl cN cn wcel
    cM cn wcel cN cM cmul co cr wcel cA cr wcel cN cn wcel cM cn wcel wa cN cM
    cmul co crp wcel cN cM cmul co cr wcel cN cn wcel cM cn wcel wa cN cM cmul
    co cn wcel cN cM cmul co crp wcel cN cM nnmulcl cN cM cmul co nnrp syl cN
    cM cmul co rpre syl 3adant2 cN cn wcel cA cr wcel cM cn wcel w3a cN cA cfl
    cfv cmul co cN cM cmul co cdiv co cr wcel cN cA cfl cfv cmul co cN cM cmul
    co cdiv co cfl cfv cr wcel cN cA cfl cfv cmul co cr wcel cN cM cmul co cr
    wcel cN cM cmul co cc0 wne cN cA cfl cfv cmul co cN cM cmul co cdiv co cr
    wcel cN cn wcel cA cr wcel cM cn wcel w3a cN cA cfl cfv cmul co cN cM cmul
    co redivcl cN cn wcel cA cr wcel cN cA cfl cfv cmul co cr wcel cM cn wcel
    cN cr wcel cA cfl cfv cr wcel cN cA cfl cfv cmul co cr wcel cN cn wcel cA
    cr wcel cN cA cfl cfv remulcl cN nnre cA reflcl syl2an 3adant3 cN cn wcel
    cM cn wcel cN cM cmul co cr wcel cA cr wcel cN cn wcel cM cn wcel wa cN cM
    cmul co crp wcel cN cM cmul co cr wcel cN cn wcel cM cn wcel wa cN cM cmul
    co cn wcel cN cM cmul co crp wcel cN cM nnmulcl cN cM cmul co nnrp syl cN
    cM cmul co rpre syl 3adant2 cN cn wcel cM cn wcel cN cM cmul co cc0 wne cA
    cr wcel cN cc wcel cN cc0 wne wa cM cc wcel cM cc0 wne wa cN cM cmul co cc0
    wne cN cn wcel cM cn wcel cN cM mulne0 cN cn wcel cN cc wcel cN cc0 wne cN
    nncn cN nnne0 jca cM cn wcel cM cc wcel cM cc0 wne cM nncn cM nnne0 jca
    syl2an 3adant2 syl3anc cN cA cfl cfv cmul co cN cM cmul co cdiv co reflcl
    syl sylanc syl3anc mpbid cN cA cfl cfv cmul co cr wcel cN cM cmul co crp
    wcel cN cA cfl cfv cmul co cN cM cmul co cmo co cN cA cfl cfv cmul co cN cM
    cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv cmul co cmin co
    wceq cN cn wcel cA cr wcel cM cn wcel w3a cN cA cfl cfv cmul co cN cM cmul
    co modval cN cn wcel cA cr wcel cN cA cfl cfv cmul co cr wcel cM cn wcel cN
    cr wcel cA cfl cfv cr wcel cN cA cfl cfv cmul co cr wcel cN cn wcel cA cr
    wcel cN cA cfl cfv remulcl cN nnre cA reflcl syl2an 3adant3 cN cn wcel cM
    cn wcel cN cM cmul co crp wcel cA cr wcel cN cn wcel cM cn wcel wa cN cM
    cmul co cn wcel cN cM cmul co crp wcel cN cM nnmulcl cN cM cmul co nnrp syl
    3adant2 sylanc cN cn wcel cA cr wcel cM cn wcel w3a cN cA cmul co cfl cfv
    cN cM cmul co cmo co cN cA cmul co cfl cfv cN cM cmul co cN cA cmul co cfl
    cfv cN cM cmul co cdiv co cfl cfv cmul co cmin co cN cA cmul co cfl cfv cN
    cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv cmul co cmin
    co cN cA cmul co cfl cfv cr wcel cN cM cmul co crp wcel cN cA cmul co cfl
    cfv cN cM cmul co cmo co cN cA cmul co cfl cfv cN cM cmul co cN cA cmul co
    cfl cfv cN cM cmul co cdiv co cfl cfv cmul co cmin co wceq cN cn wcel cA cr
    wcel cM cn wcel w3a cN cA cmul co cfl cfv cN cM cmul co modval cN cn wcel
    cA cr wcel cN cA cmul co cfl cfv cr wcel cM cn wcel cN cn wcel cA cr wcel
    wa cN cA cmul co cr wcel cN cA cmul co cfl cfv cr wcel cN cr wcel cA cr
    wcel cN cA cmul co cr wcel cN cn wcel cN cA remulcl cN nnre sylan cN cA
    cmul co reflcl syl 3adant3 cN cn wcel cM cn wcel cN cM cmul co crp wcel cA
    cr wcel cN cn wcel cM cn wcel wa cN cM cmul co cn wcel cN cM cmul co crp
    wcel cN cM nnmulcl cN cM cmul co nnrp syl 3adant2 sylanc cN cn wcel cA cr
    wcel cM cn wcel w3a cN cM cmul co cN cA cmul co cfl cfv cN cM cmul co cdiv
    co cfl cfv cmul co cN cM cmul co cN cA cfl cfv cmul co cN cM cmul co cdiv
    co cfl cfv cmul co cN cA cmul co cfl cfv cmin cN cn wcel cA cr wcel cM cn
    wcel w3a cN cA cmul co cfl cfv cN cM cmul co cdiv co cfl cfv cN cA cfl cfv
    cmul co cN cM cmul co cdiv co cfl cfv cN cM cmul co cmul cN cn wcel cA cr
    wcel cM cn wcel w3a cN cA cmul co cfl cfv cN cM cmul co cdiv co cfl cfv cN
    cA cmul co cN cM cmul co cdiv co cfl cfv cN cA cfl cfv cmul co cN cM cmul
    co cdiv co cfl cfv cN cA cmul co cr wcel cN cM cmul co cn wcel cN cA cmul
    co cfl cfv cN cM cmul co cdiv co cfl cfv cN cA cmul co cN cM cmul co cdiv
    co cfl cfv wceq cN cn wcel cA cr wcel cM cn wcel w3a cN cA cmul co cN cM
    cmul co fldiv cN cn wcel cA cr wcel cN cA cmul co cr wcel cM cn wcel cN cr
    wcel cA cr wcel cN cA cmul co cr wcel cN cn wcel cN cA remulcl cN nnre
    sylan 3adant3 cN cn wcel cM cn wcel cN cM cmul co cn wcel cA cr wcel cN cM
    nnmulcl 3adant2 sylanc cA cr wcel cM cn wcel cN cn wcel cN cA cmul co cN cM
    cmul co cdiv co cfl cfv cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv
    wceq cA cr wcel cM cn wcel cN cn wcel w3a cA cfl cfv cM cdiv co cfl cfv cA
    cM cdiv co cfl cfv cN cA cfl cfv cmul co cN cM cmul co cdiv co cfl cfv cN
    cA cmul co cN cM cmul co cdiv co cfl cfv cA cr wcel cM cn wcel cA cfl cfv
    cM cdiv co cfl cfv cA cM cdiv co cfl cfv wceq cN cn wcel cA cM fldiv
    3adant3 cA cr wcel cM cn wcel cN cn wcel w3a cN cA cfl cfv cmul co cN cM
    cmul co cdiv co cA cfl cfv cM cdiv co cfl cA cfl cfv cc wcel cM cc wcel cM
    cc0 wne wa cN cc wcel cN cc0 wne wa cN cA cfl cfv cmul co cN cM cmul co
    cdiv co cA cfl cfv cM cdiv co wceq cA cr wcel cM cn wcel cN cn wcel cA cfl
    cfv cM cN divcan5 cA cr wcel cA cfl cfv cA reflcl recnd cM cn wcel cM cc
    wcel cM cc0 wne cM nncn cM nnne0 jca cN cn wcel cN cc wcel cN cc0 wne cN
    nncn cN nnne0 jca syl3an fveq2d cA cr wcel cM cn wcel cN cn wcel w3a cN cA
    cmul co cN cM cmul co cdiv co cA cM cdiv co cfl cA cc wcel cM cc wcel cM
    cc0 wne wa cN cc wcel cN cc0 wne wa cN cA cmul co cN cM cmul co cdiv co cA
    cM cdiv co wceq cA cr wcel cM cn wcel cN cn wcel cA cM cN divcan5 cA recn
    cM cn wcel cM cc wcel cM cc0 wne cM nncn cM nnne0 jca cN cn wcel cN cc wcel
    cN cc0 wne cN nncn cN nnne0 jca syl3an fveq2d 3eqtr4rd 3comr eqtrd opreq2d
    opreq2d eqtrd 3brtr4d $.
    $( [23-Feb-2009] $) $( [2-Jan-2009] $)

  $( Closure law for the modulo operation restricted to integers. $)
  zmodcl $p |- ( ( A e. ZZ /\ B e. NN ) -> ( A mod B ) e. NN0 ) $=
    cA cB cmo co cn0 wcel cA cB cmo co cz wcel cc0 cA cB cmo co cle wbr cA cz
    wcel cB cn wcel wa cA cB cmo co elnn0z cA cz wcel cB cn wcel wa cA cB cmo
    co cA cB cA cB cdiv co cfl cfv cmul co cmin co cz cA cr wcel cB crp wcel cA
    cB cmo co cA cB cA cB cdiv co cfl cfv cmul co cmin co wceq cA cz wcel cB cn
    wcel cA cB modval cA zre cB nnrp syl2an cA cz wcel cB cn wcel cB cA cB cdiv
    co cfl cfv cmul co cz wcel cA cB cA cB cdiv co cfl cfv cmul co cmin co cz
    wcel cB cz wcel cA cB cdiv co cfl cfv cz wcel cB cA cB cdiv co cfl cfv cmul
    co cz wcel cA cz wcel cB cn wcel wa cB cA cB cdiv co cfl cfv zmulcl cB cn
    wcel cB cz wcel cA cz wcel cB nnz adantl cA cz wcel cB cn wcel wa cA cB
    cdiv co cr wcel cA cB cdiv co cfl cfv cz wcel cA cr wcel cB cn wcel cA cB
    cdiv co cr wcel cA cz wcel cA cB nndivre cA zre sylan cA cB cdiv co flcl
    syl sylanc cA cB cA cB cdiv co cfl cfv cmul co zsubcl syldan eqeltrd cA cr
    wcel cB crp wcel cc0 cA cB cmo co cle wbr cA cz wcel cB cn wcel cA cB
    modge0 cA zre cB nnrp syl2an sylanbrc $.
    $( [25-Dec-2008] $) $( [27-Nov-2008] $)

  $( Identity law for modulo. $)
  modid $p |- ( ( ( A e. RR /\ B e. RR+ ) /\ ( 0 <_ A /\ A < B ) )
               -> ( A mod B ) = A ) $=
    cA cr wcel cB crp wcel wa cc0 cA cle wbr cA cB clt wbr wa wa cA cB cmo co
    cA cB cA cB cdiv co cfl cfv cmul co cmin co cA cc0 cmin co cA cA cr wcel cB
    crp wcel wa cA cB cmo co cA cB cA cB cdiv co cfl cfv cmul co cmin co wceq
    cc0 cA cle wbr cA cB clt wbr wa cA cB modval adantr cA cr wcel cB crp wcel
    wa cc0 cA cle wbr cA cB clt wbr wa wa cB cA cB cdiv co cfl cfv cmul co cc0
    cA cmin cA cr wcel cB crp wcel wa cc0 cA cle wbr cA cB clt wbr wa wa cB cA
    cB cdiv co cfl cfv cmul co cB cc0 cmul co cc0 cA cr wcel cB crp wcel wa cc0
    cA cle wbr cA cB clt wbr wa wa cA cB cdiv co cfl cfv cc0 cB cmul cA cr wcel
    cB crp wcel wa cc0 cA cle wbr cA cB clt wbr wa wa cc0 cA cB cdiv co caddc
    co cfl cfv cA cB cdiv co cfl cfv cc0 cA cr wcel cB crp wcel wa cc0 cA cle
    wbr cA cB clt wbr wa wa cA cB cdiv co cc wcel cc0 cA cB cdiv co caddc co
    cfl cfv cA cB cdiv co cfl cfv wceq cA cr wcel cB crp wcel wa cc0 cA cle wbr
    cA cB clt wbr wa wa cA cB cdiv co cA cr wcel cB crp wcel wa cA cB cdiv co
    cr wcel cc0 cA cle wbr cA cB clt wbr wa cA cB rerpdivcl adantr recnd cA cB
    cdiv co cc wcel cc0 cA cB cdiv co caddc co cA cB cdiv co cfl cA cB cdiv co
    addid2 fveq2d syl cA cr wcel cB crp wcel wa cc0 cA cle wbr cA cB clt wbr wa
    wa cc0 cA cB cdiv co caddc co cfl cfv cc0 wceq cc0 cA cB cdiv co cle wbr cA
    cB cdiv co c1 clt wbr wa cA cr wcel cB crp wcel wa cc0 cA cle wbr cA cB clt
    wbr wa wa cc0 cA cB cdiv co cle wbr cA cB cdiv co c1 clt wbr cA cr wcel cB
    crp wcel wa cc0 cA cle wbr cc0 cA cB cdiv co cle wbr cA cB clt wbr cA cr
    wcel cc0 cA cle wbr cB crp wcel cc0 cA cB cdiv co cle wbr cA cr wcel cc0 cA
    cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cB cdiv co cle wbr cB crp
    wcel cA cB divge0 cB rpregt0 sylan2 an1rs adantrr cA cr wcel cB crp wcel wa
    cc0 cA cle wbr cA cB clt wbr wa wa cA cB cdiv co c1 clt wbr cA cB c1 cmul
    co clt wbr cB crp wcel cA cB clt wbr cA cB c1 cmul co clt wbr cA cr wcel
    cc0 cA cle wbr cB crp wcel cA cB clt wbr wa cA cB cB c1 cmul co clt cB crp
    wcel cA cB clt wbr pm3.27 cB crp wcel cB c1 cmul co cB wceq cA cB clt wbr
    cB crp wcel cB cc wcel cB c1 cmul co cB wceq cB rpcn cB mulid1 syl adantr
    breqtrrd ad2ant2l cA cr wcel cB cr wcel cc0 cB clt wbr wa cA cB cdiv co c1
    clt wbr cA cB c1 cmul co clt wbr wb cA cr wcel cB crp wcel wa cc0 cA cle
    wbr cA cB clt wbr wa wa cA cr wcel c1 cr wcel cB cr wcel cc0 cB clt wbr wa
    cA cB cdiv co c1 clt wbr cA cB c1 cmul co clt wbr wb 1re cA c1 cB ltdivmul
    mp3an2 cA cr wcel cB crp wcel cc0 cA cle wbr cA cB clt wbr wa simpll cB crp
    wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cc0 cA cle wbr cA cB clt wbr
    wa cB rpregt0 ad2antlr sylanc mpbird jca cc0 cz wcel cA cB cdiv co cr wcel
    cc0 cA cB cdiv co caddc co cfl cfv cc0 wceq cc0 cA cB cdiv co cle wbr cA cB
    cdiv co c1 clt wbr wa wb cA cr wcel cB crp wcel wa cc0 cA cle wbr cA cB clt
    wbr wa wa cA cB cdiv co cc0 flbi2 0z cA cr wcel cB crp wcel wa cA cB cdiv
    co cr wcel cc0 cA cle wbr cA cB clt wbr wa cA cB rerpdivcl adantr sylancr
    mpbird eqtr3d opreq2d cB crp wcel cB cc0 cmul co cc0 wceq cA cr wcel cc0 cA
    cle wbr cA cB clt wbr wa cB crp wcel cB cc wcel cB cc0 cmul co cc0 wceq cB
    rpcn cB mul01 syl ad2antlr eqtrd opreq2d cA cr wcel cA cc0 cmin co cA wceq
    cB crp wcel cc0 cA cle wbr cA cB clt wbr wa cA cr wcel cA cc wcel cA cc0
    cmin co cA wceq cA recn cA subid1 syl ad2antrr 3eqtrd $.
    $( [4-Jan-2009] $) $( [29-Dec-2008] $)

  $( Identity law for modulo. $)
  modid2 $p |- ( ( A e. RR /\ B e. RR+ )
     -> ( ( A mod B ) = A <-> ( 0 <_ A /\ A < B ) ) ) $=
    cA cr wcel cB crp wcel wa cA cB cmo co cA wceq cc0 cA cle wbr cA cB clt wbr
    wa cA cB cmo co cA wceq cc0 cA cB cmo co cle wbr cA cB cmo co cB clt wbr wa
    cc0 cA cle wbr cA cB clt wbr wa cA cr wcel cB crp wcel wa cA cB cmo co cA
    wceq cc0 cA cB cmo co cle wbr cc0 cA cle wbr cA cB cmo co cB clt wbr cA cB
    clt wbr cA cB cmo co cA cc0 cle breq2 cA cB cmo co cA cB clt breq1 anbi12d
    cA cr wcel cB crp wcel wa cc0 cA cB cmo co cle wbr cA cB cmo co cB clt wbr
    cA cB modge0 cA cB modlt jca syl5cbi cA cr wcel cB crp wcel wa cc0 cA cle
    wbr cA cB clt wbr wa cA cB cmo co cA wceq cA cB modid ex impbid $.
    $( [27-Feb-2009] $) $( [29-Dec-2008] $)

  $( Absorption law for modulo. $)
  modabs $p |- ( ( ( A e. RR /\ B e. RR+ /\ C e. RR+ ) /\ B <_ C )
           -> ( ( A mod B ) mod C ) = ( A mod B ) ) $=
    cA cB cmo co cr wcel cC crp wcel wa cc0 cA cB cmo co cle wbr cA cB cmo co
    cC clt wbr wa cA cB cmo co cC cmo co cA cB cmo co wceq cA cr wcel cB crp
    wcel cC crp wcel w3a cB cC cle wbr wa cA cB cmo co cC modid cA cr wcel cB
    crp wcel cC crp wcel w3a cA cB cmo co cr wcel cC crp wcel wa cB cC cle wbr
    cA cr wcel cB crp wcel cC crp wcel cA cB cmo co cr wcel cC crp wcel wa cA
    cr wcel cB crp wcel wa cA cB cmo co cr wcel cC crp wcel cA cB modcl anim1i
    3impa adantr cA cr wcel cB crp wcel cC crp wcel w3a cB cC cle wbr wa cc0 cA
    cB cmo co cle wbr cA cB cmo co cC clt wbr cA cr wcel cB crp wcel cC crp
    wcel w3a cc0 cA cB cmo co cle wbr cB cC cle wbr cA cr wcel cB crp wcel cc0
    cA cB cmo co cle wbr cC crp wcel cA cB modge0 3adant3 adantr cA cr wcel cB
    crp wcel cC crp wcel w3a cB cC cle wbr wa cA cB cmo co cB cC cA cr wcel cB
    crp wcel cC crp wcel w3a cA cB cmo co cr wcel cB cC cle wbr cA cr wcel cB
    crp wcel cA cB cmo co cr wcel cC crp wcel cA cB modcl 3adant3 adantr cA cr
    wcel cB crp wcel cC crp wcel w3a cB cr wcel cB cC cle wbr cB crp wcel cA cr
    wcel cB cr wcel cC crp wcel cB rpre 3ad2ant2 adantr cA cr wcel cB crp wcel
    cC crp wcel w3a cC cr wcel cB cC cle wbr cC crp wcel cA cr wcel cC cr wcel
    cB crp wcel cC rpre 3ad2ant3 adantr cA cr wcel cB crp wcel cC crp wcel w3a
    cA cB cmo co cB clt wbr cB cC cle wbr cA cr wcel cB crp wcel cA cB cmo co
    cB clt wbr cC crp wcel cA cB modlt 3adant3 adantr cA cr wcel cB crp wcel cC
    crp wcel w3a cB cC cle wbr pm3.27 ltletrd jca sylanc $.
    $( [17-Feb-2009] $) $( [29-Dec-2008] $)

  $( Absorption law for modulo. $)
  modabs2 $p |- ( ( A e. RR /\ B e. RR+ )
           -> ( ( A mod B ) mod B ) = ( A mod B ) ) $=
    cA cr wcel cB crp wcel wa cB cB cle wbr cA cB cmo co cB cmo co cA cB cmo co
    wceq cB crp wcel cB cB cle wbr cA cr wcel cB crp wcel cB cr wcel cB cB cle
    wbr cB rpre cB leid syl adantl cA cr wcel cB crp wcel cB cB cle wbr cA cB
    cmo co cB cmo co cA cB cmo co wceq wi cA cr wcel cB crp wcel cB crp wcel
    w3a cB cB cle wbr cA cB cmo co cB cmo co cA cB cmo co wceq cA cB cB modabs
    ex 3anidm23 mpd $.
    $( [27-Feb-2009] $) $( [29-Dec-2008] $)

  $( The modulo operation is periodic. $)
  modcyc $p |- ( ( A e. RR /\ B e. RR+ /\ N e. ZZ )
        -> ( ( A + ( N x. B ) ) mod B ) = ( A mod B ) ) $=
    cA cr wcel cN cz wcel cB crp wcel cA cN cB cmul co caddc co cB cmo co cA cB
    cmo co wceq cA cr wcel cN cz wcel cB crp wcel w3a cA cN cB cmul co caddc co
    cB cmo co cA cB cA cB cdiv co cfl cfv cmul co cmin co cA cB cmo co cA cr
    wcel cN cz wcel cB crp wcel w3a cA cN cB cmul co caddc co cB cmo co cA cN
    cB cmul co caddc co cB cA cN cB cmul co caddc co cB cdiv co cfl cfv cmul co
    cmin co cA cN cB cmul co caddc co cB cA cB cdiv co cfl cfv cmul co cN cB
    cmul co caddc co cmin co cA cB cA cB cdiv co cfl cfv cmul co cmin co cA cN
    cB cmul co caddc co cr wcel cB crp wcel cA cN cB cmul co caddc co cB cmo co
    cA cN cB cmul co caddc co cB cA cN cB cmul co caddc co cB cdiv co cfl cfv
    cmul co cmin co wceq cA cr wcel cN cz wcel cB crp wcel w3a cA cN cB cmul co
    caddc co cB modval cA cr wcel cN cz wcel cB crp wcel cA cN cB cmul co caddc
    co cr wcel cA cr wcel cN cB cmul co cr wcel cA cN cB cmul co caddc co cr
    wcel cN cz wcel cB crp wcel wa cA cN cB cmul co readdcl cN cr wcel cB cr
    wcel cN cB cmul co cr wcel cN cz wcel cB crp wcel cN cB remulcl cN zre cB
    rpre syl2an sylan2 3impb cA cr wcel cN cz wcel cB crp wcel 3simp3 sylanc cA
    cr wcel cN cz wcel cB crp wcel w3a cB cA cN cB cmul co caddc co cB cdiv co
    cfl cfv cmul co cB cA cB cdiv co cfl cfv cmul co cN cB cmul co caddc co cA
    cN cB cmul co caddc co cmin cA cr wcel cN cz wcel cB crp wcel w3a cB cA cN
    cB cmul co caddc co cB cdiv co cfl cfv cmul co cB cA cB cdiv co cfl cfv cN
    caddc co cmul co cB cA cB cdiv co cfl cfv cmul co cB cN cmul co caddc co cB
    cA cB cdiv co cfl cfv cmul co cN cB cmul co caddc co cA cr wcel cN cz wcel
    cB crp wcel w3a cA cN cB cmul co caddc co cB cdiv co cfl cfv cA cB cdiv co
    cfl cfv cN caddc co cB cmul cA cr wcel cN cz wcel cB crp wcel w3a cA cN cB
    cmul co caddc co cB cdiv co cfl cfv cA cB cdiv co cN caddc co cfl cfv cA cB
    cdiv co cfl cfv cN caddc co cA cr wcel cN cz wcel cB crp wcel w3a cA cN cB
    cmul co caddc co cB cdiv co cA cB cdiv co cN caddc co cfl cA cr wcel cN cz
    wcel cB crp wcel w3a cA cN cB cmul co caddc co cB cdiv co cA cB cdiv co cN
    cB cmul co cB cdiv co caddc co cA cB cdiv co cN caddc co cA cc wcel cN cB
    cmul co cc wcel cB cc wcel cB cc0 wne wa cA cN cB cmul co caddc co cB cdiv
    co cA cB cdiv co cN cB cmul co cB cdiv co caddc co wceq cA cr wcel cN cz
    wcel cB crp wcel w3a cA cN cB cmul co cB divdir cA cr wcel cN cz wcel cA cc
    wcel cB crp wcel cA recn 3ad2ant1 cN cz wcel cB crp wcel cN cB cmul co cc
    wcel cA cr wcel cN cz wcel cB crp wcel wa cN cB cmul co cN cr wcel cB cr
    wcel cN cB cmul co cr wcel cN cz wcel cB crp wcel cN cB remulcl cN zre cB
    rpre syl2an recnd 3adant1 cB crp wcel cA cr wcel cB cc wcel cB cc0 wne wa
    cN cz wcel cB rpcnne0 3ad2ant3 syl3anc cA cr wcel cN cz wcel cB crp wcel
    w3a cN cB cmul co cB cdiv co cN cA cB cdiv co caddc cN cz wcel cB crp wcel
    cN cB cmul co cB cdiv co cN wceq cA cr wcel cN cc wcel cB cc wcel cB cc0
    wne wa cN cB cmul co cB cdiv co cN wceq cN cz wcel cB crp wcel cN cc wcel
    cB cc wcel cB cc0 wne cN cB cmul co cB cdiv co cN wceq cN cB divcan4 3expb
    cN zcn cB rpcnne0 syl2an 3adant1 opreq2d eqtrd fveq2d cA cB cdiv co cr wcel
    cN cz wcel cA cB cdiv co cN caddc co cfl cfv cA cB cdiv co cfl cfv cN caddc
    co wceq cA cr wcel cN cz wcel cB crp wcel w3a cA cB cdiv co cN fladdz cA cr
    wcel cB crp wcel cA cB cdiv co cr wcel cN cz wcel cA cB rerpdivcl 3adant2
    cA cr wcel cN cz wcel cB crp wcel 3simp2 sylanc eqtrd opreq2d cB cc wcel cA
    cB cdiv co cfl cfv cc wcel cN cc wcel cB cA cB cdiv co cfl cfv cN caddc co
    cmul co cB cA cB cdiv co cfl cfv cmul co cB cN cmul co caddc co wceq cA cr
    wcel cN cz wcel cB crp wcel w3a cB cA cB cdiv co cfl cfv cN adddi cB crp
    wcel cA cr wcel cB cc wcel cN cz wcel cB rpcn 3ad2ant3 cA cr wcel cB crp
    wcel cA cB cdiv co cfl cfv cc wcel cN cz wcel cA cr wcel cB crp wcel wa cA
    cB cdiv co cr wcel cA cB cdiv co cfl cfv cc wcel cA cB rerpdivcl cA cB cdiv
    co cr wcel cA cB cdiv co cfl cfv cA cB cdiv co reflcl recnd syl 3adant2 cN
    cz wcel cA cr wcel cN cc wcel cB crp wcel cN zcn 3ad2ant2 syl3anc cA cr
    wcel cN cz wcel cB crp wcel w3a cB cN cmul co cN cB cmul co cB cA cB cdiv
    co cfl cfv cmul co caddc cA cr wcel cN cz wcel cB crp wcel w3a cN cB cmul
    co cB cN cmul co cN cz wcel cB crp wcel cN cB cmul co cB cN cmul co wceq cA
    cr wcel cN cc wcel cB cc wcel cN cB cmul co cB cN cmul co wceq cN cz wcel
    cB crp wcel cN cB mulcom cN zcn cB rpcn syl2an 3adant1 eqcomd opreq2d
    3eqtrd opreq2d cA cc wcel cB cA cB cdiv co cfl cfv cmul co cc wcel cN cB
    cmul co cc wcel cA cN cB cmul co caddc co cB cA cB cdiv co cfl cfv cmul co
    cN cB cmul co caddc co cmin co cA cB cA cB cdiv co cfl cfv cmul co cmin co
    wceq cA cr wcel cN cz wcel cB crp wcel w3a cA cB cA cB cdiv co cfl cfv cmul
    co cN cB cmul co pnpcan2 cA cr wcel cN cz wcel cA cc wcel cB crp wcel cA
    recn 3ad2ant1 cA cr wcel cB crp wcel cB cA cB cdiv co cfl cfv cmul co cc
    wcel cN cz wcel cB cc wcel cA cB cdiv co cfl cfv cc wcel cB cA cB cdiv co
    cfl cfv cmul co cc wcel cA cr wcel cB crp wcel wa cB cA cB cdiv co cfl cfv
    mulcl cB crp wcel cB cc wcel cA cr wcel cB rpcn adantl cA cr wcel cB crp
    wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cc wcel cA cB rerpdivcl
    cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cA cB cdiv co reflcl recnd syl
    sylanc 3adant2 cN cz wcel cB crp wcel cN cB cmul co cc wcel cA cr wcel cN
    cz wcel cB crp wcel wa cN cB cmul co cN cr wcel cB cr wcel cN cB cmul co cr
    wcel cN cz wcel cB crp wcel cN cB remulcl cN zre cB rpre syl2an recnd
    3adant1 syl3anc 3eqtrd cA cr wcel cB crp wcel cA cB cmo co cA cB cA cB cdiv
    co cfl cfv cmul co cmin co wceq cN cz wcel cA cB modval 3adant2 eqtr4d
    3com23 $.
    $( [11-Dec-2008] $) $( [10-Nov-2008] $)

  $( The modulo operation is periodic. $)
  modcyc2 $p |- ( ( A e. RR /\ B e. RR+ /\ N e. ZZ )
        -> ( ( A - ( B x. N ) ) mod B ) = ( A mod B ) ) $=
    cA cr wcel cB crp wcel cN cz wcel w3a cA cB cN cmul co cmin co cB cmo co cA
    cN cneg cB cmul co caddc co cB cmo co cA cB cmo co cA cr wcel cB crp wcel
    cN cz wcel w3a cA cB cN cmul co cmin co cA cN cneg cB cmul co caddc co cB
    cmo cA cc wcel cB cc wcel cN cc wcel cA cB cN cmul co cmin co cA cN cneg cB
    cmul co caddc co wceq cA cr wcel cB crp wcel cN cz wcel cA cc wcel cB cc
    wcel cN cc wcel w3a cA cN cneg cB cmul co caddc co cA cB cN cmul co cneg
    caddc co cA cB cN cmul co cmin co cA cc wcel cB cc wcel cN cc wcel w3a cN
    cneg cB cmul co cB cN cmul co cneg cA caddc cB cc wcel cN cc wcel cN cneg
    cB cmul co cB cN cmul co cneg wceq cA cc wcel cB cc wcel cN cc wcel wa cN
    cneg cB cmul co cN cB cmul co cneg cB cN cmul co cneg cN cc wcel cB cc wcel
    cN cneg cB cmul co cN cB cmul co cneg wceq cN cB mulneg1 ancoms cB cc wcel
    cN cc wcel wa cB cN cmul co cN cB cmul co cB cN mulcom negeqd eqtr4d
    3adant1 opreq2d cA cc wcel cB cc wcel cN cc wcel cA cB cN cmul co cneg
    caddc co cA cB cN cmul co cmin co wceq cA cc wcel cB cN cmul co cc wcel cA
    cB cN cmul co cneg caddc co cA cB cN cmul co cmin co wceq cB cc wcel cN cc
    wcel wa cA cB cN cmul co negsub cB cN mulcl sylan2 3impb eqtr2d cA recn cB
    rpcn cN zcn syl3an opreq1d cA cr wcel cB crp wcel cN cneg cz wcel cA cN
    cneg cB cmul co caddc co cB cmo co cA cB cmo co wceq cN cz wcel cA cB cN
    cneg modcyc cN znegcl syl3an3 eqtrd $.
    $( [30-Nov-2008] $) $( [12-Nov-2008] $)

  $( Addition property of the modulo operation. $)
  modadd1 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR+ )
       /\ ( A mod D ) = ( B mod D ) )
       -> ( ( A + C ) mod D ) = ( ( B + C ) mod D ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD crp wcel wa cA cD cmo co cB cD cmo
    co wceq cA cC caddc co cD cmo co cB cC caddc co cD cmo co wceq cA cr wcel
    cB cr wcel wa cC cr wcel cD crp wcel wa wa cA cD cmo co cB cD cmo co wceq
    cA cC caddc co cD cA cD cdiv co cfl cfv cmul co cmin co cB cC caddc co cD
    cB cD cdiv co cfl cfv cmul co cmin co wceq cA cC caddc co cD cmo co cB cC
    caddc co cD cmo co wceq cA cr wcel cB cr wcel wa cC cr wcel cD crp wcel wa
    wa cA cD cmo co cB cD cmo co wceq cA cD cA cD cdiv co cfl cfv cmul co cmin
    co cC caddc co cB cD cB cD cdiv co cfl cfv cmul co cmin co cC caddc co wceq
    cA cC caddc co cD cA cD cdiv co cfl cfv cmul co cmin co cB cC caddc co cD
    cB cD cdiv co cfl cfv cmul co cmin co wceq cA cr wcel cB cr wcel wa cC cr
    wcel cD crp wcel wa wa cA cD cmo co cB cD cmo co wceq cA cD cA cD cdiv co
    cfl cfv cmul co cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin co wceq cA
    cD cA cD cdiv co cfl cfv cmul co cmin co cC caddc co cB cD cB cD cdiv co
    cfl cfv cmul co cmin co cC caddc co wceq cA cr wcel cB cr wcel wa cD crp
    wcel cA cD cmo co cB cD cmo co wceq cA cD cA cD cdiv co cfl cfv cmul co
    cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin co wceq wb cC cr wcel cA
    cr wcel cB cr wcel cD crp wcel cA cD cmo co cB cD cmo co wceq cA cD cA cD
    cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin co
    wceq wb cA cr wcel cD crp wcel wa cB cr wcel cD crp wcel wa cA cD cmo co cA
    cD cA cD cdiv co cfl cfv cmul co cmin co cB cD cmo co cB cD cB cD cdiv co
    cfl cfv cmul co cmin co cA cD modval cB cD modval eqeqan12d anandirs
    adantrl cA cD cA cD cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv co cfl
    cfv cmul co cmin co cC caddc opreq1 syl6bi cA cr wcel cB cr wcel wa cC cr
    wcel cD crp wcel wa wa cA cC caddc co cD cA cD cdiv co cfl cfv cmul co cmin
    co cA cD cA cD cdiv co cfl cfv cmul co cmin co cC caddc co cB cC caddc co
    cD cB cD cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv co cfl cfv cmul
    co cmin co cC caddc co cA cr wcel cC cr wcel cD crp wcel wa cA cC caddc co
    cD cA cD cdiv co cfl cfv cmul co cmin co cA cD cA cD cdiv co cfl cfv cmul
    co cmin co cC caddc co wceq cB cr wcel cA cc wcel cC cc wcel cD cA cD cdiv
    co cfl cfv cmul co cc wcel cA cC caddc co cD cA cD cdiv co cfl cfv cmul co
    cmin co cA cD cA cD cdiv co cfl cfv cmul co cmin co cC caddc co wceq cA cr
    wcel cC cr wcel cD crp wcel wa wa cA cC cD cA cD cdiv co cfl cfv cmul co
    addsub cA cr wcel cA cc wcel cC cr wcel cD crp wcel wa cA recn adantr cC cr
    wcel cC cc wcel cA cr wcel cD crp wcel cC recn ad2antrl cA cr wcel cD crp
    wcel cD cA cD cdiv co cfl cfv cmul co cc wcel cC cr wcel cD cc wcel cA cD
    cdiv co cfl cfv cc wcel cD cA cD cdiv co cfl cfv cmul co cc wcel cA cr wcel
    cD crp wcel wa cD cA cD cdiv co cfl cfv mulcl cD crp wcel cD cc wcel cA cr
    wcel cD rpcn adantl cA cr wcel cD crp wcel wa cA cD cdiv co cr wcel cA cD
    cdiv co cfl cfv cc wcel cA cD rerpdivcl cA cD cdiv co cr wcel cA cD cdiv co
    cfl cfv cA cD cdiv co reflcl recnd syl sylanc adantrl syl3anc adantlr cB cr
    wcel cC cr wcel cD crp wcel wa cB cC caddc co cD cB cD cdiv co cfl cfv cmul
    co cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin co cC caddc co wceq cA
    cr wcel cB cc wcel cC cc wcel cD cB cD cdiv co cfl cfv cmul co cc wcel cB
    cC caddc co cD cB cD cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv co
    cfl cfv cmul co cmin co cC caddc co wceq cB cr wcel cC cr wcel cD crp wcel
    wa wa cB cC cD cB cD cdiv co cfl cfv cmul co addsub cB cr wcel cB cc wcel
    cC cr wcel cD crp wcel wa cB recn adantr cC cr wcel cC cc wcel cB cr wcel
    cD crp wcel cC recn ad2antrl cB cr wcel cD crp wcel cD cB cD cdiv co cfl
    cfv cmul co cc wcel cC cr wcel cD cc wcel cB cD cdiv co cfl cfv cc wcel cD
    cB cD cdiv co cfl cfv cmul co cc wcel cB cr wcel cD crp wcel wa cD cB cD
    cdiv co cfl cfv mulcl cD crp wcel cD cc wcel cB cr wcel cD rpcn adantl cB
    cr wcel cD crp wcel wa cB cD cdiv co cr wcel cB cD cdiv co cfl cfv cc wcel
    cB cD rerpdivcl cB cD cdiv co cr wcel cB cD cdiv co cfl cfv cB cD cdiv co
    reflcl recnd syl sylanc adantrl syl3anc adantll eqeq12d sylibrd cA cr wcel
    cB cr wcel wa cC cr wcel cD crp wcel wa wa cA cC caddc co cD cA cD cdiv co
    cfl cfv cmul co cmin co cD cmo co cB cC caddc co cD cB cD cdiv co cfl cfv
    cmul co cmin co cD cmo co wceq cA cC caddc co cD cmo co cB cC caddc co cD
    cmo co wceq cA cC caddc co cD cA cD cdiv co cfl cfv cmul co cmin co cB cC
    caddc co cD cB cD cdiv co cfl cfv cmul co cmin co wceq cA cr wcel cB cr
    wcel wa cC cr wcel cD crp wcel wa wa cA cC caddc co cD cA cD cdiv co cfl
    cfv cmul co cmin co cD cmo co cA cC caddc co cD cmo co cB cC caddc co cD cB
    cD cdiv co cfl cfv cmul co cmin co cD cmo co cB cC caddc co cD cmo co cA cr
    wcel cC cr wcel cD crp wcel wa cA cC caddc co cD cA cD cdiv co cfl cfv cmul
    co cmin co cD cmo co cA cC caddc co cD cmo co wceq cB cr wcel cA cC caddc
    co cr wcel cD crp wcel cA cD cdiv co cfl cfv cz wcel cA cC caddc co cD cA
    cD cdiv co cfl cfv cmul co cmin co cD cmo co cA cC caddc co cD cmo co wceq
    cA cr wcel cC cr wcel cD crp wcel wa wa cA cC caddc co cD cA cD cdiv co cfl
    cfv modcyc2 cA cr wcel cC cr wcel cA cC caddc co cr wcel cD crp wcel cA cC
    readdcl adantrr cA cr wcel cC cr wcel cD crp wcel simprr cA cr wcel cD crp
    wcel cA cD cdiv co cfl cfv cz wcel cC cr wcel cA cr wcel cD crp wcel wa cA
    cD cdiv co cr wcel cA cD cdiv co cfl cfv cz wcel cA cD rerpdivcl cA cD cdiv
    co flcl syl adantrl syl3anc adantlr cB cr wcel cC cr wcel cD crp wcel wa cB
    cC caddc co cD cB cD cdiv co cfl cfv cmul co cmin co cD cmo co cB cC caddc
    co cD cmo co wceq cA cr wcel cB cC caddc co cr wcel cD crp wcel cB cD cdiv
    co cfl cfv cz wcel cB cC caddc co cD cB cD cdiv co cfl cfv cmul co cmin co
    cD cmo co cB cC caddc co cD cmo co wceq cB cr wcel cC cr wcel cD crp wcel
    wa wa cB cC caddc co cD cB cD cdiv co cfl cfv modcyc2 cB cr wcel cC cr wcel
    cB cC caddc co cr wcel cD crp wcel cB cC readdcl adantrr cB cr wcel cC cr
    wcel cD crp wcel simprr cB cr wcel cD crp wcel cB cD cdiv co cfl cfv cz
    wcel cC cr wcel cB cr wcel cD crp wcel wa cB cD cdiv co cr wcel cB cD cdiv
    co cfl cfv cz wcel cB cD rerpdivcl cB cD cdiv co flcl syl adantrl syl3anc
    adantll eqeq12d cA cC caddc co cD cA cD cdiv co cfl cfv cmul co cmin co cB
    cC caddc co cD cB cD cdiv co cfl cfv cmul co cmin co cD cmo opreq1 syl5bi
    syld 3impia $.
    $( [30-Nov-2008] $) $( [12-Nov-2008] $)

  $( Multiplication property of the modulo operation.  Note that the multiplier
     ` C ` must be an integer. $)
  modmul1 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. ZZ /\ D e. RR+ )
       /\ ( A mod D ) = ( B mod D ) )
       -> ( ( A x. C ) mod D ) = ( ( B x. C ) mod D ) ) $=
    cA cr wcel cB cr wcel wa cC cz wcel cD crp wcel wa cA cD cmo co cB cD cmo
    co wceq cA cC cmul co cD cmo co cB cC cmul co cD cmo co wceq cA cr wcel cB
    cr wcel wa cC cz wcel cD crp wcel wa wa cA cD cmo co cB cD cmo co wceq cA
    cC cmul co cD cC cA cD cdiv co cfl cfv cmul co cmul co cmin co cB cC cmul
    co cD cC cB cD cdiv co cfl cfv cmul co cmul co cmin co wceq cA cC cmul co
    cD cmo co cB cC cmul co cD cmo co wceq cA cr wcel cB cr wcel wa cC cz wcel
    cD crp wcel wa wa cA cD cmo co cB cD cmo co wceq cA cD cA cD cdiv co cfl
    cfv cmul co cmin co cC cmul co cB cD cB cD cdiv co cfl cfv cmul co cmin co
    cC cmul co wceq cA cC cmul co cD cC cA cD cdiv co cfl cfv cmul co cmul co
    cmin co cB cC cmul co cD cC cB cD cdiv co cfl cfv cmul co cmul co cmin co
    wceq cA cr wcel cB cr wcel wa cC cz wcel cD crp wcel wa wa cA cD cmo co cB
    cD cmo co wceq cA cD cA cD cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv
    co cfl cfv cmul co cmin co wceq cA cD cA cD cdiv co cfl cfv cmul co cmin co
    cC cmul co cB cD cB cD cdiv co cfl cfv cmul co cmin co cC cmul co wceq cA
    cr wcel cB cr wcel wa cD crp wcel cA cD cmo co cB cD cmo co wceq cA cD cA
    cD cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin
    co wceq wb cC cz wcel cA cr wcel cB cr wcel cD crp wcel cA cD cmo co cB cD
    cmo co wceq cA cD cA cD cdiv co cfl cfv cmul co cmin co cB cD cB cD cdiv co
    cfl cfv cmul co cmin co wceq wb cA cr wcel cD crp wcel wa cB cr wcel cD crp
    wcel wa cA cD cmo co cA cD cA cD cdiv co cfl cfv cmul co cmin co cB cD cmo
    co cB cD cB cD cdiv co cfl cfv cmul co cmin co cA cD modval cB cD modval
    eqeqan12d anandirs adantrl cA cD cA cD cdiv co cfl cfv cmul co cmin co cB
    cD cB cD cdiv co cfl cfv cmul co cmin co cC cmul opreq1 syl6bi cA cr wcel
    cB cr wcel wa cC cz wcel cD crp wcel wa wa cA cC cmul co cD cC cA cD cdiv
    co cfl cfv cmul co cmul co cmin co cA cD cA cD cdiv co cfl cfv cmul co cmin
    co cC cmul co cB cC cmul co cD cC cB cD cdiv co cfl cfv cmul co cmul co
    cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin co cC cmul co cA cr wcel
    cC cz wcel cD crp wcel wa cA cC cmul co cD cC cA cD cdiv co cfl cfv cmul co
    cmul co cmin co cA cD cA cD cdiv co cfl cfv cmul co cmin co cC cmul co wceq
    cB cr wcel cA cr wcel cC cz wcel cD crp wcel wa wa cA cC cmul co cD cC cA
    cD cdiv co cfl cfv cmul co cmul co cmin co cA cC cmul co cD cA cD cdiv co
    cfl cfv cmul co cC cmul co cmin co cA cD cA cD cdiv co cfl cfv cmul co cmin
    co cC cmul co cA cr wcel cC cz wcel cD crp wcel wa wa cD cC cA cD cdiv co
    cfl cfv cmul co cmul co cD cA cD cdiv co cfl cfv cmul co cC cmul co cA cC
    cmul co cmin cA cr wcel cC cz wcel cD crp wcel wa wa cD cC cmul co cA cD
    cdiv co cfl cfv cmul co cD cC cA cD cdiv co cfl cfv cmul co cmul co cD cA
    cD cdiv co cfl cfv cmul co cC cmul co cD cc wcel cC cc wcel cA cD cdiv co
    cfl cfv cc wcel cD cC cmul co cA cD cdiv co cfl cfv cmul co cD cC cA cD
    cdiv co cfl cfv cmul co cmul co wceq cA cr wcel cC cz wcel cD crp wcel wa
    wa cD cC cA cD cdiv co cfl cfv mulass cD crp wcel cD cc wcel cA cr wcel cC
    cz wcel cD rpcn ad2antll cC cz wcel cC cc wcel cA cr wcel cD crp wcel cC
    zcn ad2antrl cA cr wcel cD crp wcel cA cD cdiv co cfl cfv cc wcel cC cz
    wcel cA cr wcel cD crp wcel wa cA cD cdiv co cfl cfv cz wcel cA cD cdiv co
    cfl cfv cc wcel cA cr wcel cD crp wcel wa cA cD cdiv co cr wcel cA cD cdiv
    co cfl cfv cz wcel cA cD rerpdivcl cA cD cdiv co flcl syl cA cD cdiv co cfl
    cfv zcn syl adantrl syl3anc cD cc wcel cC cc wcel cA cD cdiv co cfl cfv cc
    wcel cD cC cmul co cA cD cdiv co cfl cfv cmul co cD cA cD cdiv co cfl cfv
    cmul co cC cmul co wceq cA cr wcel cC cz wcel cD crp wcel wa wa cD cC cA cD
    cdiv co cfl cfv mul23 cD crp wcel cD cc wcel cA cr wcel cC cz wcel cD rpcn
    ad2antll cC cz wcel cC cc wcel cA cr wcel cD crp wcel cC zcn ad2antrl cA cr
    wcel cD crp wcel cA cD cdiv co cfl cfv cc wcel cC cz wcel cA cr wcel cD crp
    wcel wa cA cD cdiv co cfl cfv cz wcel cA cD cdiv co cfl cfv cc wcel cA cr
    wcel cD crp wcel wa cA cD cdiv co cr wcel cA cD cdiv co cfl cfv cz wcel cA
    cD rerpdivcl cA cD cdiv co flcl syl cA cD cdiv co cfl cfv zcn syl adantrl
    syl3anc eqtr3d opreq2d cA cc wcel cD cA cD cdiv co cfl cfv cmul co cc wcel
    cC cc wcel cA cD cA cD cdiv co cfl cfv cmul co cmin co cC cmul co cA cC
    cmul co cD cA cD cdiv co cfl cfv cmul co cC cmul co cmin co wceq cA cr wcel
    cC cz wcel cD crp wcel wa wa cA cD cA cD cdiv co cfl cfv cmul co cC subdir
    cA cr wcel cA cc wcel cC cz wcel cD crp wcel wa cA recn adantr cA cr wcel
    cD crp wcel cD cA cD cdiv co cfl cfv cmul co cc wcel cC cz wcel cD cc wcel
    cA cD cdiv co cfl cfv cc wcel cD cA cD cdiv co cfl cfv cmul co cc wcel cA
    cr wcel cD crp wcel wa cD cA cD cdiv co cfl cfv mulcl cD crp wcel cD cc
    wcel cA cr wcel cD rpcn adantl cA cr wcel cD crp wcel wa cA cD cdiv co cfl
    cfv cz wcel cA cD cdiv co cfl cfv cc wcel cA cr wcel cD crp wcel wa cA cD
    cdiv co cr wcel cA cD cdiv co cfl cfv cz wcel cA cD rerpdivcl cA cD cdiv co
    flcl syl cA cD cdiv co cfl cfv zcn syl sylanc adantrl cC cz wcel cC cc wcel
    cA cr wcel cD crp wcel cC zcn ad2antrl syl3anc eqtr4d adantlr cB cr wcel cC
    cz wcel cD crp wcel wa cB cC cmul co cD cC cB cD cdiv co cfl cfv cmul co
    cmul co cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin co cC cmul co wceq
    cA cr wcel cB cr wcel cC cz wcel cD crp wcel wa wa cB cC cmul co cD cC cB
    cD cdiv co cfl cfv cmul co cmul co cmin co cB cC cmul co cD cB cD cdiv co
    cfl cfv cmul co cC cmul co cmin co cB cD cB cD cdiv co cfl cfv cmul co cmin
    co cC cmul co cB cr wcel cC cz wcel cD crp wcel wa wa cD cC cB cD cdiv co
    cfl cfv cmul co cmul co cD cB cD cdiv co cfl cfv cmul co cC cmul co cB cC
    cmul co cmin cB cr wcel cC cz wcel cD crp wcel wa wa cD cC cmul co cB cD
    cdiv co cfl cfv cmul co cD cC cB cD cdiv co cfl cfv cmul co cmul co cD cB
    cD cdiv co cfl cfv cmul co cC cmul co cD cc wcel cC cc wcel cB cD cdiv co
    cfl cfv cc wcel cD cC cmul co cB cD cdiv co cfl cfv cmul co cD cC cB cD
    cdiv co cfl cfv cmul co cmul co wceq cB cr wcel cC cz wcel cD crp wcel wa
    wa cD cC cB cD cdiv co cfl cfv mulass cD crp wcel cD cc wcel cB cr wcel cC
    cz wcel cD rpcn ad2antll cC cz wcel cC cc wcel cB cr wcel cD crp wcel cC
    zcn ad2antrl cB cr wcel cD crp wcel cB cD cdiv co cfl cfv cc wcel cC cz
    wcel cB cr wcel cD crp wcel wa cB cD cdiv co cfl cfv cz wcel cB cD cdiv co
    cfl cfv cc wcel cB cr wcel cD crp wcel wa cB cD cdiv co cr wcel cB cD cdiv
    co cfl cfv cz wcel cB cD rerpdivcl cB cD cdiv co flcl syl cB cD cdiv co cfl
    cfv zcn syl adantrl syl3anc cD cc wcel cC cc wcel cB cD cdiv co cfl cfv cc
    wcel cD cC cmul co cB cD cdiv co cfl cfv cmul co cD cB cD cdiv co cfl cfv
    cmul co cC cmul co wceq cB cr wcel cC cz wcel cD crp wcel wa wa cD cC cB cD
    cdiv co cfl cfv mul23 cD crp wcel cD cc wcel cB cr wcel cC cz wcel cD rpcn
    ad2antll cC cz wcel cC cc wcel cB cr wcel cD crp wcel cC zcn ad2antrl cB cr
    wcel cD crp wcel cB cD cdiv co cfl cfv cc wcel cC cz wcel cB cr wcel cD crp
    wcel wa cB cD cdiv co cfl cfv cz wcel cB cD cdiv co cfl cfv cc wcel cB cr
    wcel cD crp wcel wa cB cD cdiv co cr wcel cB cD cdiv co cfl cfv cz wcel cB
    cD rerpdivcl cB cD cdiv co flcl syl cB cD cdiv co cfl cfv zcn syl adantrl
    syl3anc eqtr3d opreq2d cB cc wcel cD cB cD cdiv co cfl cfv cmul co cc wcel
    cC cc wcel cB cD cB cD cdiv co cfl cfv cmul co cmin co cC cmul co cB cC
    cmul co cD cB cD cdiv co cfl cfv cmul co cC cmul co cmin co wceq cB cr wcel
    cC cz wcel cD crp wcel wa wa cB cD cB cD cdiv co cfl cfv cmul co cC subdir
    cB cr wcel cB cc wcel cC cz wcel cD crp wcel wa cB recn adantr cB cr wcel
    cD crp wcel cD cB cD cdiv co cfl cfv cmul co cc wcel cC cz wcel cD cc wcel
    cB cD cdiv co cfl cfv cc wcel cD cB cD cdiv co cfl cfv cmul co cc wcel cB
    cr wcel cD crp wcel wa cD cB cD cdiv co cfl cfv mulcl cD crp wcel cD cc
    wcel cB cr wcel cD rpcn adantl cB cr wcel cD crp wcel wa cB cD cdiv co cfl
    cfv cz wcel cB cD cdiv co cfl cfv cc wcel cB cr wcel cD crp wcel wa cB cD
    cdiv co cr wcel cB cD cdiv co cfl cfv cz wcel cB cD rerpdivcl cB cD cdiv co
    flcl syl cB cD cdiv co cfl cfv zcn syl sylanc adantrl cC cz wcel cC cc wcel
    cB cr wcel cD crp wcel cC zcn ad2antrl syl3anc eqtr4d adantll eqeq12d
    sylibrd cA cr wcel cB cr wcel wa cC cz wcel cD crp wcel wa wa cA cC cmul co
    cD cC cA cD cdiv co cfl cfv cmul co cmul co cmin co cD cmo co cB cC cmul co
    cD cC cB cD cdiv co cfl cfv cmul co cmul co cmin co cD cmo co wceq cA cC
    cmul co cD cmo co cB cC cmul co cD cmo co wceq cA cC cmul co cD cC cA cD
    cdiv co cfl cfv cmul co cmul co cmin co cB cC cmul co cD cC cB cD cdiv co
    cfl cfv cmul co cmul co cmin co wceq cA cr wcel cB cr wcel wa cC cz wcel cD
    crp wcel wa wa cA cC cmul co cD cC cA cD cdiv co cfl cfv cmul co cmul co
    cmin co cD cmo co cA cC cmul co cD cmo co cB cC cmul co cD cC cB cD cdiv co
    cfl cfv cmul co cmul co cmin co cD cmo co cB cC cmul co cD cmo co cA cr
    wcel cC cz wcel cD crp wcel wa cA cC cmul co cD cC cA cD cdiv co cfl cfv
    cmul co cmul co cmin co cD cmo co cA cC cmul co cD cmo co wceq cB cr wcel
    cA cC cmul co cr wcel cD crp wcel cC cA cD cdiv co cfl cfv cmul co cz wcel
    cA cC cmul co cD cC cA cD cdiv co cfl cfv cmul co cmul co cmin co cD cmo co
    cA cC cmul co cD cmo co wceq cA cr wcel cC cz wcel cD crp wcel wa wa cA cC
    cmul co cD cC cA cD cdiv co cfl cfv cmul co modcyc2 cA cr wcel cC cz wcel
    cA cC cmul co cr wcel cD crp wcel cA cr wcel cC cr wcel cA cC cmul co cr
    wcel cC cz wcel cA cC remulcl cC zre sylan2 adantrr cA cr wcel cC cz wcel
    cD crp wcel simprr cC cz wcel cA cD cdiv co cfl cfv cz wcel cC cA cD cdiv
    co cfl cfv cmul co cz wcel cA cr wcel cC cz wcel cD crp wcel wa wa cC cA cD
    cdiv co cfl cfv zmulcl cA cr wcel cC cz wcel cD crp wcel simprl cA cr wcel
    cD crp wcel cA cD cdiv co cfl cfv cz wcel cC cz wcel cA cr wcel cD crp wcel
    wa cA cD cdiv co cr wcel cA cD cdiv co cfl cfv cz wcel cA cD rerpdivcl cA
    cD cdiv co flcl syl adantrl sylanc syl3anc adantlr cB cr wcel cC cz wcel cD
    crp wcel wa cB cC cmul co cD cC cB cD cdiv co cfl cfv cmul co cmul co cmin
    co cD cmo co cB cC cmul co cD cmo co wceq cA cr wcel cB cC cmul co cr wcel
    cD crp wcel cC cB cD cdiv co cfl cfv cmul co cz wcel cB cC cmul co cD cC cB
    cD cdiv co cfl cfv cmul co cmul co cmin co cD cmo co cB cC cmul co cD cmo
    co wceq cB cr wcel cC cz wcel cD crp wcel wa wa cB cC cmul co cD cC cB cD
    cdiv co cfl cfv cmul co modcyc2 cB cr wcel cC cz wcel cB cC cmul co cr wcel
    cD crp wcel cB cr wcel cC cr wcel cB cC cmul co cr wcel cC cz wcel cB cC
    remulcl cC zre sylan2 adantrr cB cr wcel cC cz wcel cD crp wcel simprr cC
    cz wcel cB cD cdiv co cfl cfv cz wcel cC cB cD cdiv co cfl cfv cmul co cz
    wcel cB cr wcel cC cz wcel cD crp wcel wa wa cC cB cD cdiv co cfl cfv
    zmulcl cB cr wcel cC cz wcel cD crp wcel simprl cB cr wcel cD crp wcel cB
    cD cdiv co cfl cfv cz wcel cC cz wcel cB cr wcel cD crp wcel wa cB cD cdiv
    co cr wcel cB cD cdiv co cfl cfv cz wcel cB cD rerpdivcl cB cD cdiv co flcl
    syl adantrl sylanc syl3anc adantll eqeq12d cA cC cmul co cD cC cA cD cdiv
    co cfl cfv cmul co cmul co cmin co cB cC cmul co cD cC cB cD cdiv co cfl
    cfv cmul co cmul co cmin co cD cmo opreq1 syl5bi syld 3impia $.
    $( [27-Feb-2009] $) $( [12-Nov-2008] $)

  $( Distribute multiplication over a modulo operation. $)
  moddi $p |- ( ( A e. RR+ /\ B e. RR /\ C e. RR+ )
      -> ( A x. ( B mod C ) ) = ( ( A x. B ) mod ( A x. C ) ) ) $=
    cA crp wcel cB cr wcel cC crp wcel w3a cA cB cC cB cC cdiv co cfl cfv cmul
    co cmin co cmul co cA cB cmul co cA cC cmul co cA cB cmul co cA cC cmul co
    cdiv co cfl cfv cmul co cmin co cA cB cC cmo co cmul co cA cB cmul co cA cC
    cmul co cmo co cA crp wcel cB cr wcel cC crp wcel w3a cA cB cC cB cC cdiv
    co cfl cfv cmul co cmin co cmul co cA cB cmul co cA cC cB cC cdiv co cfl
    cfv cmul co cmul co cmin co cA cB cmul co cA cC cmul co cA cB cmul co cA cC
    cmul co cdiv co cfl cfv cmul co cmin co cA cc wcel cB cc wcel cC cB cC cdiv
    co cfl cfv cmul co cc wcel cA cB cC cB cC cdiv co cfl cfv cmul co cmin co
    cmul co cA cB cmul co cA cC cB cC cdiv co cfl cfv cmul co cmul co cmin co
    wceq cA crp wcel cB cr wcel cC crp wcel w3a cA cB cC cB cC cdiv co cfl cfv
    cmul co subdi cA crp wcel cB cr wcel cA cc wcel cC crp wcel cA rpcn
    3ad2ant1 cB cr wcel cA crp wcel cB cc wcel cC crp wcel cB recn 3ad2ant2 cB
    cr wcel cC crp wcel cC cB cC cdiv co cfl cfv cmul co cc wcel cA crp wcel cB
    cr wcel cC crp wcel wa cC cB cC cdiv co cfl cfv cmul co cC cr wcel cB cC
    cdiv co cfl cfv cr wcel cC cB cC cdiv co cfl cfv cmul co cr wcel cB cr wcel
    cC crp wcel wa cC cB cC cdiv co cfl cfv remulcl cC crp wcel cC cr wcel cB
    cr wcel cC rpre adantl cB cr wcel cC crp wcel wa cB cC cdiv co cr wcel cB
    cC cdiv co cfl cfv cr wcel cB cC rerpdivcl cB cC cdiv co reflcl syl sylanc
    recnd 3adant1 syl3anc cA crp wcel cB cr wcel cC crp wcel w3a cA cC cB cC
    cdiv co cfl cfv cmul co cmul co cA cC cmul co cA cB cmul co cA cC cmul co
    cdiv co cfl cfv cmul co cA cB cmul co cmin cA crp wcel cB cr wcel cC crp
    wcel w3a cA cC cmul co cA cB cmul co cA cC cmul co cdiv co cfl cfv cmul co
    cA cC cmul co cB cC cdiv co cfl cfv cmul co cA cC cB cC cdiv co cfl cfv
    cmul co cmul co cA crp wcel cB cr wcel cC crp wcel w3a cA cB cmul co cA cC
    cmul co cdiv co cfl cfv cB cC cdiv co cfl cfv cA cC cmul co cmul cA crp
    wcel cB cr wcel cC crp wcel w3a cA cB cmul co cA cC cmul co cdiv co cB cC
    cdiv co cfl cB cc wcel cC cc wcel cC cc0 wne wa cA cc wcel cA cc0 wne wa cA
    cB cmul co cA cC cmul co cdiv co cB cC cdiv co wceq cA crp wcel cB cr wcel
    cC crp wcel w3a cB cC cA divcan5 cB cr wcel cA crp wcel cB cc wcel cC crp
    wcel cB recn 3ad2ant2 cC crp wcel cA crp wcel cC cc wcel cC cc0 wne wa cB
    cr wcel cC rpcnne0 3ad2ant3 cA crp wcel cB cr wcel cA cc wcel cA cc0 wne wa
    cC crp wcel cA rpcnne0 3ad2ant1 syl3anc fveq2d opreq2d cA cc wcel cC cc
    wcel cB cC cdiv co cfl cfv cc wcel cA cC cmul co cB cC cdiv co cfl cfv cmul
    co cA cC cB cC cdiv co cfl cfv cmul co cmul co wceq cA crp wcel cB cr wcel
    cC crp wcel w3a cA cC cB cC cdiv co cfl cfv mulass cA crp wcel cB cr wcel
    cA cc wcel cC crp wcel cA rpcn 3ad2ant1 cC crp wcel cA crp wcel cC cc wcel
    cB cr wcel cC rpcn 3ad2ant3 cB cr wcel cC crp wcel cB cC cdiv co cfl cfv cc
    wcel cA crp wcel cB cr wcel cC crp wcel wa cB cC cdiv co cr wcel cB cC cdiv
    co cfl cfv cc wcel cB cC rerpdivcl cB cC cdiv co cr wcel cB cC cdiv co cfl
    cfv cB cC cdiv co reflcl recnd syl 3adant1 syl3anc eqtr2d opreq2d eqtrd cA
    crp wcel cB cr wcel cC crp wcel w3a cB cC cmo co cB cC cB cC cdiv co cfl
    cfv cmul co cmin co cA cmul cB cr wcel cC crp wcel cB cC cmo co cB cC cB cC
    cdiv co cfl cfv cmul co cmin co wceq cA crp wcel cB cC modval 3adant1
    opreq2d cA cB cmul co cr wcel cA cC cmul co crp wcel cA cB cmul co cA cC
    cmul co cmo co cA cB cmul co cA cC cmul co cA cB cmul co cA cC cmul co cdiv
    co cfl cfv cmul co cmin co wceq cA crp wcel cB cr wcel cC crp wcel w3a cA
    cB cmul co cA cC cmul co modval cA crp wcel cB cr wcel cA cB cmul co cr
    wcel cC crp wcel cA cr wcel cB cr wcel cA cB cmul co cr wcel cA crp wcel cA
    cB remulcl cA rpre sylan 3adant3 cA crp wcel cC crp wcel cA cC cmul co crp
    wcel cB cr wcel cA cC rpmulcl 3adant2 sylanc 3eqtr4d $.
    $( [27-Feb-2009] $) $( [11-Nov-2008] $)

  $( Distribute the modulo operation over a subtraction. $)
  modsubdir $p |- ( ( A e. RR /\ B e. RR /\ C e. RR+ ) -> ( ( B mod C )
  <_ ( A mod C ) <-> ( ( A - B ) mod C ) = ( ( A mod C ) - ( B mod C ) ) ) ) $=
    cA cr wcel cB cr wcel cC crp wcel w3a cc0 cA cC cmo co cB cC cmo co cmin co
    cle wbr cB cC cmo co cA cC cmo co cle wbr cA cB cmin co cC cmo co cA cC cmo
    co cB cC cmo co cmin co wceq cA cC cmo co cr wcel cB cC cmo co cr wcel cc0
    cA cC cmo co cB cC cmo co cmin co cle wbr cB cC cmo co cA cC cmo co cle wbr
    wb cA cr wcel cB cr wcel cC crp wcel w3a cA cC cmo co cB cC cmo co subge0
    cA cr wcel cC crp wcel cA cC cmo co cr wcel cB cr wcel cA cC modcl 3adant2
    cB cr wcel cC crp wcel cB cC cmo co cr wcel cA cr wcel cB cC modcl 3adant1
    sylanc cA cr wcel cB cr wcel cC crp wcel w3a cc0 cA cC cmo co cB cC cmo co
    cmin co cle wbr cA cB cmin co cC cmo co cA cC cmo co cB cC cmo co cmin co
    wceq cA cr wcel cB cr wcel cC crp wcel w3a cc0 cA cC cmo co cB cC cmo co
    cmin co cle wbr wa cA cB cmin co cC cmo co cA cC cmo co cB cC cmo co cmin
    co cC cmo co cA cC cmo co cB cC cmo co cmin co cA cr wcel cB cr wcel cC crp
    wcel w3a cA cB cmin co cC cmo co cA cC cmo co cB cC cmo co cmin co cC cmo
    co wceq cc0 cA cC cmo co cB cC cmo co cmin co cle wbr cA cr wcel cB cr wcel
    cC crp wcel w3a cA cB cmin co cC cA cC cdiv co cfl cfv cB cC cdiv co cfl
    cfv cmin co cmul co cmin co cC cmo co cA cB cmin co cC cmo co cA cC cmo co
    cB cC cmo co cmin co cC cmo co cA cB cmin co cr wcel cC crp wcel cA cC cdiv
    co cfl cfv cB cC cdiv co cfl cfv cmin co cz wcel cA cB cmin co cC cA cC
    cdiv co cfl cfv cB cC cdiv co cfl cfv cmin co cmul co cmin co cC cmo co cA
    cB cmin co cC cmo co wceq cA cr wcel cB cr wcel cC crp wcel w3a cA cB cmin
    co cC cA cC cdiv co cfl cfv cB cC cdiv co cfl cfv cmin co modcyc2 cA cr
    wcel cB cr wcel cA cB cmin co cr wcel cC crp wcel cA cB resubcl 3adant3 cA
    cr wcel cB cr wcel cC crp wcel 3simp3 cA cC cdiv co cfl cfv cz wcel cB cC
    cdiv co cfl cfv cz wcel cA cC cdiv co cfl cfv cB cC cdiv co cfl cfv cmin co
    cz wcel cA cr wcel cB cr wcel cC crp wcel w3a cA cC cdiv co cfl cfv cB cC
    cdiv co cfl cfv zsubcl cA cr wcel cC crp wcel cA cC cdiv co cfl cfv cz wcel
    cB cr wcel cA cr wcel cC crp wcel wa cA cC cdiv co cr wcel cA cC cdiv co
    cfl cfv cz wcel cA cC rerpdivcl cA cC cdiv co flcl syl 3adant2 cB cr wcel
    cC crp wcel cB cC cdiv co cfl cfv cz wcel cA cr wcel cB cr wcel cC crp wcel
    wa cB cC cdiv co cr wcel cB cC cdiv co cfl cfv cz wcel cB cC rerpdivcl cB
    cC cdiv co flcl syl 3adant1 sylanc syl3anc cA cr wcel cB cr wcel cC crp
    wcel w3a cA cB cmin co cC cA cC cdiv co cfl cfv cB cC cdiv co cfl cfv cmin
    co cmul co cmin co cA cC cmo co cB cC cmo co cmin co cC cmo cA cr wcel cB
    cr wcel cC crp wcel w3a cA cB cmin co cC cA cC cdiv co cfl cfv cmul co cC
    cB cC cdiv co cfl cfv cmul co cmin co cmin co cA cC cA cC cdiv co cfl cfv
    cmul co cmin co cB cC cB cC cdiv co cfl cfv cmul co cmin co cmin co cA cB
    cmin co cC cA cC cdiv co cfl cfv cB cC cdiv co cfl cfv cmin co cmul co cmin
    co cA cC cmo co cB cC cmo co cmin co cA cc wcel cB cc wcel cC cA cC cdiv co
    cfl cfv cmul co cc wcel cC cB cC cdiv co cfl cfv cmul co cc wcel cA cB cmin
    co cC cA cC cdiv co cfl cfv cmul co cC cB cC cdiv co cfl cfv cmul co cmin
    co cmin co cA cC cA cC cdiv co cfl cfv cmul co cmin co cB cC cB cC cdiv co
    cfl cfv cmul co cmin co cmin co wceq cA cr wcel cB cr wcel cC crp wcel w3a
    cA cB cC cA cC cdiv co cfl cfv cmul co cC cB cC cdiv co cfl cfv cmul co
    sub4 cA cr wcel cB cr wcel cA cc wcel cC crp wcel cA recn 3ad2ant1 cB cr
    wcel cA cr wcel cB cc wcel cC crp wcel cB recn 3ad2ant2 cA cr wcel cC crp
    wcel cC cA cC cdiv co cfl cfv cmul co cc wcel cB cr wcel cA cr wcel cC crp
    wcel wa cC cA cC cdiv co cfl cfv cmul co cC cr wcel cA cC cdiv co cfl cfv
    cr wcel cC cA cC cdiv co cfl cfv cmul co cr wcel cA cr wcel cC crp wcel wa
    cC cA cC cdiv co cfl cfv remulcl cC crp wcel cC cr wcel cA cr wcel cC rpre
    adantl cA cr wcel cC crp wcel wa cA cC cdiv co cr wcel cA cC cdiv co cfl
    cfv cr wcel cA cC rerpdivcl cA cC cdiv co reflcl syl sylanc recnd 3adant2
    cB cr wcel cC crp wcel cC cB cC cdiv co cfl cfv cmul co cc wcel cA cr wcel
    cB cr wcel cC crp wcel wa cC cB cC cdiv co cfl cfv cmul co cC cr wcel cB cC
    cdiv co cfl cfv cr wcel cC cB cC cdiv co cfl cfv cmul co cr wcel cB cr wcel
    cC crp wcel wa cC cB cC cdiv co cfl cfv remulcl cC crp wcel cC cr wcel cB
    cr wcel cC rpre adantl cB cr wcel cC crp wcel wa cB cC cdiv co cr wcel cB
    cC cdiv co cfl cfv cr wcel cB cC rerpdivcl cB cC cdiv co reflcl syl sylanc
    recnd 3adant1 syl2anc cA cr wcel cB cr wcel cC crp wcel w3a cC cA cC cdiv
    co cfl cfv cB cC cdiv co cfl cfv cmin co cmul co cC cA cC cdiv co cfl cfv
    cmul co cC cB cC cdiv co cfl cfv cmul co cmin co cA cB cmin co cmin cC cc
    wcel cA cC cdiv co cfl cfv cc wcel cB cC cdiv co cfl cfv cc wcel cC cA cC
    cdiv co cfl cfv cB cC cdiv co cfl cfv cmin co cmul co cC cA cC cdiv co cfl
    cfv cmul co cC cB cC cdiv co cfl cfv cmul co cmin co wceq cA cr wcel cB cr
    wcel cC crp wcel w3a cC cA cC cdiv co cfl cfv cB cC cdiv co cfl cfv subdi
    cA cr wcel cB cr wcel cC crp wcel w3a cC cC crp wcel cA cr wcel cC cr wcel
    cB cr wcel cC rpre 3ad2ant3 recnd cA cr wcel cC crp wcel cA cC cdiv co cfl
    cfv cc wcel cB cr wcel cA cr wcel cC crp wcel wa cA cC cdiv co cfl cfv cA
    cr wcel cC crp wcel wa cA cC cdiv co cr wcel cA cC cdiv co cfl cfv cr wcel
    cA cC rerpdivcl cA cC cdiv co reflcl syl recnd 3adant2 cB cr wcel cC crp
    wcel cB cC cdiv co cfl cfv cc wcel cA cr wcel cB cr wcel cC crp wcel wa cB
    cC cdiv co cfl cfv cB cr wcel cC crp wcel wa cB cC cdiv co cr wcel cB cC
    cdiv co cfl cfv cr wcel cB cC rerpdivcl cB cC cdiv co reflcl syl recnd
    3adant1 syl3anc opreq2d cA cr wcel cB cr wcel cC crp wcel w3a cA cC cmo co
    cA cC cA cC cdiv co cfl cfv cmul co cmin co cB cC cmo co cB cC cB cC cdiv
    co cfl cfv cmul co cmin co cmin cA cr wcel cC crp wcel cA cC cmo co cA cC
    cA cC cdiv co cfl cfv cmul co cmin co wceq cB cr wcel cA cC modval 3adant2
    cB cr wcel cC crp wcel cB cC cmo co cB cC cB cC cdiv co cfl cfv cmul co
    cmin co wceq cA cr wcel cB cC modval 3adant1 opreq12d 3eqtr4d opreq1d
    eqtr3d adantr cA cC cmo co cB cC cmo co cmin co cr wcel cC crp wcel cc0 cA
    cC cmo co cB cC cmo co cmin co cle wbr cA cC cmo co cB cC cmo co cmin co cC
    clt wbr cA cC cmo co cB cC cmo co cmin co cC cmo co cA cC cmo co cB cC cmo
    co cmin co wceq cA cr wcel cB cr wcel cC crp wcel w3a cc0 cA cC cmo co cB
    cC cmo co cmin co cle wbr wa cA cC cmo co cB cC cmo co cmin co cC modid cA
    cr wcel cB cr wcel cC crp wcel w3a cA cC cmo co cB cC cmo co cmin co cr
    wcel cc0 cA cC cmo co cB cC cmo co cmin co cle wbr cA cC cmo co cr wcel cB
    cC cmo co cr wcel cA cC cmo co cB cC cmo co cmin co cr wcel cA cr wcel cB
    cr wcel cC crp wcel w3a cA cC cmo co cB cC cmo co resubcl cA cr wcel cC crp
    wcel cA cC cmo co cr wcel cB cr wcel cA cC modcl 3adant2 cB cr wcel cC crp
    wcel cB cC cmo co cr wcel cA cr wcel cB cC modcl 3adant1 sylanc adantr cA
    cr wcel cB cr wcel cC crp wcel cc0 cA cC cmo co cB cC cmo co cmin co cle
    wbr 3simpl3 cA cr wcel cB cr wcel cC crp wcel w3a cc0 cA cC cmo co cB cC
    cmo co cmin co cle wbr pm3.27 cA cr wcel cB cr wcel cC crp wcel w3a cA cC
    cmo co cB cC cmo co cmin co cC clt wbr cc0 cA cC cmo co cB cC cmo co cmin
    co cle wbr cA cr wcel cB cr wcel cC crp wcel w3a cA cC cmo co cB cC cmo co
    cmin co cA cC cmo co cC cA cC cmo co cr wcel cB cC cmo co cr wcel cA cC cmo
    co cB cC cmo co cmin co cr wcel cA cr wcel cB cr wcel cC crp wcel w3a cA cC
    cmo co cB cC cmo co resubcl cA cr wcel cC crp wcel cA cC cmo co cr wcel cB
    cr wcel cA cC modcl 3adant2 cB cr wcel cC crp wcel cB cC cmo co cr wcel cA
    cr wcel cB cC modcl 3adant1 sylanc cA cr wcel cC crp wcel cA cC cmo co cr
    wcel cB cr wcel cA cC modcl 3adant2 cC crp wcel cA cr wcel cC cr wcel cB cr
    wcel cC rpre 3ad2ant3 cA cr wcel cB cr wcel cC crp wcel w3a cc0 cB cC cmo
    co cle wbr cA cC cmo co cB cC cmo co cmin co cA cC cmo co cle wbr cB cr
    wcel cC crp wcel cc0 cB cC cmo co cle wbr cA cr wcel cB cC modge0 3adant1
    cA cC cmo co cr wcel cB cC cmo co cr wcel cc0 cB cC cmo co cle wbr cA cC
    cmo co cB cC cmo co cmin co cA cC cmo co cle wbr wb cA cr wcel cB cr wcel
    cC crp wcel w3a cA cC cmo co cB cC cmo co subge02 cA cr wcel cC crp wcel cA
    cC cmo co cr wcel cB cr wcel cA cC modcl 3adant2 cB cr wcel cC crp wcel cB
    cC cmo co cr wcel cA cr wcel cB cC modcl 3adant1 sylanc mpbid cA cr wcel cC
    crp wcel cA cC cmo co cC clt wbr cB cr wcel cA cC modlt 3adant2 lelttrd
    adantr syl2anc eqtrd cA cr wcel cB cr wcel cC crp wcel w3a cA cB cmin co cC
    cmo co cA cC cmo co cB cC cmo co cmin co wceq wa cc0 cA cB cmin co cC cmo
    co cA cC cmo co cB cC cmo co cmin co cle cA cr wcel cB cr wcel cC crp wcel
    w3a cc0 cA cB cmin co cC cmo co cle wbr cA cB cmin co cC cmo co cA cC cmo
    co cB cC cmo co cmin co wceq cA cr wcel cB cr wcel cC crp wcel cc0 cA cB
    cmin co cC cmo co cle wbr cA cB cmin co cr wcel cC crp wcel cc0 cA cB cmin
    co cC cmo co cle wbr cA cr wcel cB cr wcel wa cA cB cmin co cC modge0 cA cB
    resubcl sylan 3impa adantr cA cr wcel cB cr wcel cC crp wcel w3a cA cB cmin
    co cC cmo co cA cC cmo co cB cC cmo co cmin co wceq pm3.27 breqtrd impbida
    bitr3d $.
    $( [27-Feb-2009] $) $( [30-Dec-2008] $)

  $( A number modulo an irrational multiple of it is nonzero. $)
  modirr $p |- ( ( A e. RR /\ B e. RR+ /\ ( A / B ) e. ( RR \ QQ ) )
      -> ( A mod B ) =/= 0 ) $=
    cA cr wcel cB crp wcel cA cB cdiv co cr cq cdif wcel cA cB cmo co cc0 wne
    cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cq wcel wn wa
    cA cB cmo co cc0 wne cA cB cdiv co cr cq cdif wcel cA cr wcel cB crp wcel
    wa cA cB cdiv co cq wcel wn cA cB cmo co cc0 wne cA cB cdiv co cr wcel cA
    cr wcel cB crp wcel wa cA cB cdiv co cq wcel cA cB cmo co cc0 cA cr wcel cB
    crp wcel wa cA cB cmo co cc0 wceq cA cB cdiv co cfl cfv cA cB cdiv co wceq
    cA cB cdiv co cq wcel cA cr wcel cB crp wcel wa cA cB cmo co cc0 wceq cA cB
    cA cB cdiv co cfl cfv cmul co cmin co cc0 wceq cA cB cA cB cdiv co cfl cfv
    cmul co wceq cA cB cdiv co cfl cfv cA cB cdiv co wceq cA cr wcel cB crp
    wcel wa cA cB cmo co cA cB cA cB cdiv co cfl cfv cmul co cmin co cc0 cA cB
    modval eqeq1d cA cc wcel cB cA cB cdiv co cfl cfv cmul co cc wcel cA cB cA
    cB cdiv co cfl cfv cmul co cmin co cc0 wceq cA cB cA cB cdiv co cfl cfv
    cmul co wceq wb cA cr wcel cB crp wcel wa cA cB cA cB cdiv co cfl cfv cmul
    co subeq0 cA cr wcel cA cc wcel cB crp wcel cA recn adantr cA cr wcel cB
    crp wcel wa cB cA cB cdiv co cfl cfv cmul co cB cr wcel cA cB cdiv co cfl
    cfv cr wcel cB cA cB cdiv co cfl cfv cmul co cr wcel cA cr wcel cB crp wcel
    wa cB cA cB cdiv co cfl cfv remulcl cB crp wcel cB cr wcel cA cr wcel cB
    rpre adantl cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co
    cfl cfv cr wcel cA cB rerpdivcl cA cB cdiv co reflcl syl sylanc recnd
    sylanc cA cr wcel cB crp wcel wa cA cB cdiv co cA cB cdiv co cfl cfv wceq
    cA cB cA cB cdiv co cfl cfv cmul co wceq cA cB cdiv co cfl cfv cA cB cdiv
    co wceq cA cc wcel cA cB cdiv co cfl cfv cc wcel cB cc wcel cB cc0 wne wa
    cA cB cdiv co cA cB cdiv co cfl cfv wceq cA cB cA cB cdiv co cfl cfv cmul
    co wceq wb cA cr wcel cB crp wcel wa cA cA cB cdiv co cfl cfv cB divmul2 cA
    cr wcel cA cc wcel cB crp wcel cA recn adantr cA cr wcel cB crp wcel wa cA
    cB cdiv co cr wcel cA cB cdiv co cfl cfv cc wcel cA cB rerpdivcl cA cB cdiv
    co cr wcel cA cB cdiv co cfl cfv cA cB cdiv co reflcl recnd syl cB crp wcel
    cB cc wcel cB cc0 wne wa cA cr wcel cB rpcnne0 adantl syl3anc cA cB cdiv co
    cA cB cdiv co cfl cfv eqcom syl5rbbr 3bitrd cA cr wcel cB crp wcel wa cA cB
    cdiv co cr wcel cA cB cdiv co cfl cfv cA cB cdiv co wceq cA cB cdiv co cq
    wcel wi cA cB rerpdivcl cA cB cdiv co cr wcel cA cB cdiv co cfl cfv cA cB
    cdiv co wceq cA cB cdiv co cz wcel cA cB cdiv co cq wcel cA cB cdiv co
    flidz cA cB cdiv co zq syl6bi syl sylbid necon3bd adantld cA cB cdiv co cr
    cq eldif syl5ib 3impia $.
    $( [27-Feb-2009] $) $( [11-Nov-2008] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Monotonic sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d y z A $.  $d y B $.  $d x y z F $.
    monoord.1 $e |- F : NN --> RR $.
    monoord.2 $e |- ( x e. NN -> ( F ` x ) <_ ( F ` ( x + 1 ) ) ) $.
    $( Ordering relation for a monotonic sequence. $)
    monoord $p |- ( ( A e. NN /\ B e. NN /\ A <_ B ) ->
                  ( F ` A ) <_ ( F ` B ) ) $=
      cA cn wcel cB cn wcel cA cB cle wbr cA cF cfv cB cF cfv cle wbr cB cn
      wcel cA cn wcel cA cB cle wbr cA cF cfv cB cF cfv cle wbr wi cA cn wcel
      cA vy cv cle wbr cA cF cfv vy cv cF cfv cle wbr wi wi cA cn wcel cA c1
      cle wbr cA cF cfv c1 cF cfv cle wbr wi wi cA cn wcel cA vz cv cle wbr cA
      cF cfv vz cv cF cfv cle wbr wi wi cA cn wcel cA vz cv c1 caddc co cle wbr
      cA cF cfv vz cv c1 caddc co cF cfv cle wbr wi wi cA cn wcel cA cB cle wbr
      cA cF cfv cB cF cfv cle wbr wi wi vy vz cB vy cv c1 wceq cA vy cv cle wbr
      cA cF cfv vy cv cF cfv cle wbr wi cA c1 cle wbr cA cF cfv c1 cF cfv cle
      wbr wi cA cn wcel vy cv c1 wceq cA vy cv cle wbr cA c1 cle wbr cA cF cfv
      vy cv cF cfv cle wbr cA cF cfv c1 cF cfv cle wbr vy cv c1 cA cle breq2 vy
      cv c1 wceq vy cv cF cfv c1 cF cfv cA cF cfv cle vy cv c1 cF fveq2 breq2d
      imbi12d imbi2d vy cv vz cv wceq cA vy cv cle wbr cA cF cfv vy cv cF cfv
      cle wbr wi cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA cn wcel
      vy cv vz cv wceq cA vy cv cle wbr cA vz cv cle wbr cA cF cfv vy cv cF cfv
      cle wbr cA cF cfv vz cv cF cfv cle wbr vy cv vz cv cA cle breq2 vy cv vz
      cv wceq vy cv cF cfv vz cv cF cfv cA cF cfv cle vy cv vz cv cF fveq2
      breq2d imbi12d imbi2d vy cv vz cv c1 caddc co wceq cA vy cv cle wbr cA cF
      cfv vy cv cF cfv cle wbr wi cA vz cv c1 caddc co cle wbr cA cF cfv vz cv
      c1 caddc co cF cfv cle wbr wi cA cn wcel vy cv vz cv c1 caddc co wceq cA
      vy cv cle wbr cA vz cv c1 caddc co cle wbr cA cF cfv vy cv cF cfv cle wbr
      cA cF cfv vz cv c1 caddc co cF cfv cle wbr vy cv vz cv c1 caddc co cA cle
      breq2 vy cv vz cv c1 caddc co wceq vy cv cF cfv vz cv c1 caddc co cF cfv
      cA cF cfv cle vy cv vz cv c1 caddc co cF fveq2 breq2d imbi12d imbi2d vy
      cv cB wceq cA vy cv cle wbr cA cF cfv vy cv cF cfv cle wbr wi cA cB cle
      wbr cA cF cfv cB cF cfv cle wbr wi cA cn wcel vy cv cB wceq cA vy cv cle
      wbr cA cB cle wbr cA cF cfv vy cv cF cfv cle wbr cA cF cfv cB cF cfv cle
      wbr vy cv cB cA cle breq2 vy cv cB wceq vy cv cF cfv cB cF cfv cA cF cfv
      cle vy cv cB cF fveq2 breq2d imbi12d imbi2d cA cn wcel cA c1 cle wbr c1
      cA cle wbr cA cF cfv c1 cF cfv cle wbr cA nnge1 cA cn wcel cA c1 cle wbr
      c1 cA cle wbr wa cA c1 wceq cA cF cfv c1 cF cfv cle wbr cA cr wcel c1 cr
      wcel cA c1 wceq cA c1 cle wbr c1 cA cle wbr wa wb cA cn wcel cA c1 letri3
      cA nnre 1re sylancl cA cn wcel cA c1 wceq cA cF cfv c1 cF cfv cle wbr cA
      cF cfv cr wcel cA cF cfv c1 cF cfv wceq cA cF cfv c1 cF cfv cle wbr cA cn
      wcel cA c1 wceq cA cF cfv c1 cF cfv eqle cn cr cA cF monoord.1 ffvelrni
      cA c1 cF fveq2 syl2an ex sylbird mpan2d vz cv cn wcel cA cn wcel cA vz cv
      cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA vz cv c1 caddc co cle wbr cA
      cF cfv vz cv c1 caddc co cF cfv cle wbr wi cA cn wcel vz cv cn wcel cA vz
      cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA vz cv c1 caddc co cle wbr
      cA cF cfv vz cv c1 caddc co cF cfv cle wbr wi wi cA cn wcel vz cv cn wcel
      cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA vz cv c1 caddc co
      cle wbr cA cF cfv vz cv c1 caddc co cF cfv cle wbr wi cA cn wcel vz cv cn
      wcel wa cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi wa cA vz cv c1
      caddc co cle wbr cA vz cv c1 caddc co clt wbr cA vz cv c1 caddc co wceq
      wo cA cF cfv vz cv c1 caddc co cF cfv cle wbr cA cn wcel vz cv cn wcel wa
      cA vz cv c1 caddc co cle wbr cA vz cv c1 caddc co clt wbr cA vz cv c1
      caddc co wceq wo wb cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA
      cr wcel vz cv c1 caddc co cr wcel cA vz cv c1 caddc co cle wbr cA vz cv
      c1 caddc co clt wbr cA vz cv c1 caddc co wceq wo wb cA cn wcel vz cv cn
      wcel cA vz cv c1 caddc co leloe cA nnre vz cv cn wcel vz cv c1 caddc co
      cn wcel vz cv c1 caddc co cr wcel vz cv peano2nn vz cv c1 caddc co nnre
      syl syl2an adantr cA cn wcel vz cv cn wcel wa cA vz cv cle wbr cA cF cfv
      vz cv cF cfv cle wbr wi wa cA vz cv c1 caddc co clt wbr cA cF cfv vz cv
      c1 caddc co cF cfv cle wbr cA vz cv c1 caddc co wceq cA cn wcel vz cv cn
      wcel wa cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi wa cA vz cv c1
      caddc co clt wbr cA vz cv cle wbr cA cF cfv vz cv c1 caddc co cF cfv cle
      wbr cA cn wcel vz cv cn wcel wa cA vz cv cle wbr cA vz cv c1 caddc co clt
      wbr wb cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA vz cv
      nnleltp1 adantr cA cn wcel vz cv cn wcel wa cA vz cv cle wbr cA cF cfv vz
      cv cF cfv cle wbr wi cA vz cv cle wbr cA cF cfv vz cv c1 caddc co cF cfv
      cle wbr wi cA cn wcel vz cv cn wcel wa cA cF cfv vz cv cF cfv cle wbr cA
      cF cfv vz cv c1 caddc co cF cfv cle wbr cA vz cv cle wbr cA cn wcel vz cv
      cn wcel wa cA cF cfv vz cv cF cfv cle wbr cA cF cfv vz cv c1 caddc co cF
      cfv cle wbr cA cn wcel vz cv cn wcel wa cA cF cfv vz cv cF cfv cle wbr wa
      cA cF cfv vz cv cF cfv vz cv c1 caddc co cF cfv cA cn wcel cA cF cfv cr
      wcel vz cv cn wcel cA cF cfv vz cv cF cfv cle wbr cn cr cA cF monoord.1
      ffvelrni ad2antrr vz cv cn wcel vz cv cF cfv cr wcel cA cn wcel cA cF cfv
      vz cv cF cfv cle wbr cn cr vz cv cF monoord.1 ffvelrni ad2antlr vz cv cn
      wcel vz cv c1 caddc co cF cfv cr wcel cA cn wcel cA cF cfv vz cv cF cfv
      cle wbr vz cv cn wcel vz cv c1 caddc co cn wcel vz cv c1 caddc co cF cfv
      cr wcel vz cv peano2nn cn cr vz cv c1 caddc co cF monoord.1 ffvelrni syl
      ad2antlr cA cn wcel vz cv cn wcel wa cA cF cfv vz cv cF cfv cle wbr
      pm3.27 vz cv cn wcel vz cv cF cfv vz cv c1 caddc co cF cfv cle wbr cA cn
      wcel cA cF cfv vz cv cF cfv cle wbr vx cv cF cfv vx cv c1 caddc co cF cfv
      cle wbr vz cv cF cfv vz cv c1 caddc co cF cfv cle wbr vx vz cv cn vx cv
      vz cv wceq vx cv cF cfv vz cv cF cfv vx cv c1 caddc co cF cfv vz cv c1
      caddc co cF cfv cle vx cv vz cv cF fveq2 vx cv vz cv wceq vx cv c1 caddc
      co vz cv c1 caddc co cF vx cv vz cv c1 caddc opreq1 fveq2d breq12d
      monoord.2 vtoclga ad2antlr letrd ex imim2d imp sylbird cA cn wcel cA vz
      cv c1 caddc co wceq cA cF cfv vz cv c1 caddc co cF cfv cle wbr wi vz cv
      cn wcel cA vz cv cle wbr cA cF cfv vz cv cF cfv cle wbr wi cA cn wcel cA
      vz cv c1 caddc co wceq cA cF cfv vz cv c1 caddc co cF cfv cle wbr cA cF
      cfv cr wcel cA cF cfv vz cv c1 caddc co cF cfv wceq cA cF cfv vz cv c1
      caddc co cF cfv cle wbr cA cn wcel cA vz cv c1 caddc co wceq cA cF cfv vz
      cv c1 caddc co cF cfv eqle cn cr cA cF monoord.1 ffvelrni cA vz cv c1
      caddc co cF fveq2 syl2an ex ad2antrr jaod sylbid exp31 com12 a2d nnind
      com12 3imp $.
      $( [6-Apr-2005] $) $( [13-Mar-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Real number intervals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c (,) $.
  $c (,] $.
  $c [,) $.
  $c [,] $.

  $( Extend class notation with the set of open intervals of extended reals. $)
  cioo $a class (,) $.

  $( Extend class notation with the set of open-below, closed-above intervals
     of extended reals. $)
  cioc $a class (,] $.

  $( Extend class notation with the set of closed-below, open-above
     intervals of extended reals. $)
  cico $a class [,) $.

  $( Extend class notation with the set of closed intervals of extended
     reals. $)
  cicc $a class [,] $.

  ${
    $d x y z w $.
    $( Define the set of open intervals of extended reals. $)
    df-ioo $a |- (,) = { <. <. x , y >. , z >. | ( ( x e. RR* /\ y e. RR* )
                   /\ z = { w e. RR* | ( x < w /\ w < y ) } ) } $.

    $( Define the set of open-below, closed-above intervals of extended
       reals. $)
    df-ioc $a |- (,] = { <. <. x , y >. , z >. | ( ( x e. RR* /\ y e. RR* )
                   /\ z = { w e. RR* | ( x < w /\ w <_ y ) } ) } $.

    $( Define the set of closed-below, open-above intervals of extended
       reals. $)
    df-ico $a |- [,) = { <. <. x , y >. , z >. | ( ( x e. RR* /\ y e. RR* )
                   /\ z = { w e. RR* | ( x <_ w /\ w < y ) } ) } $.

    $( Define the set of closed intervals of extended reals. $)
    df-icc $a |- [,] = { <. <. x , y >. , z >. | ( ( x e. RR* /\ y e. RR* )
                   /\ z = { w e. RR* | ( x <_ w /\ w <_ y ) } ) } $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x C $.  $d x D $.
    $( The set of open intervals of extended reals exists. $)
    iooex $p |- (,) e. _V $=
      vx vy vz cxr cxr vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab
      cioo xrex xrex vx vy vz vw df-ioo oprabex2 $.
      $( [11-Feb-2007] $) $( [6-Feb-2007] $)

    $( Value of the open interval function. $)
    iooval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) =
                 { x e. RR* | ( A < x /\ x < B ) } ) $=
      vy vz vw cA cB cxr cxr vy cv vx cv clt wbr vx cv vz cv clt wbr wa vx cxr
      crab cA vx cv clt wbr vx cv cB clt wbr wa vx cxr crab cioo cA vx cv clt
      wbr vx cv vz cv clt wbr wa vx cxr crab cA vx cv clt wbr vx cv cB clt wbr
      wa vx cxr xrex rabex vy cv cA wceq vy cv vx cv clt wbr vx cv vz cv clt
      wbr wa cA vx cv clt wbr vx cv vz cv clt wbr wa vx cxr vy cv cA wceq vy cv
      vx cv clt wbr cA vx cv clt wbr vx cv vz cv clt wbr vy cv cA vx cv clt
      breq1 anbi1d rabbisdv vz cv cB wceq cA vx cv clt wbr vx cv vz cv clt wbr
      wa cA vx cv clt wbr vx cv cB clt wbr wa vx cxr vz cv cB wceq vx cv vz cv
      clt wbr vx cv cB clt wbr cA vx cv clt wbr vz cv cB vx cv clt breq2 anbi2d
      rabbisdv vy vz vw vx df-ioo oprabval2 $.
      $( [27-Dec-2006] $) $( [24-Dec-2006] $)

    $( Value of the open interval function. $)
    iooval2 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) =
                 { x e. RR | ( A < x /\ x < B ) } ) $=
      cA cxr wcel cB cxr wcel wa cA cB cioo co cA vx cv clt wbr vx cv cB clt
      wbr wa vx cxr crab cA vx cv clt wbr vx cv cB clt wbr wa vx cr crab vx cA
      cB iooval cA cxr wcel cB cxr wcel wa vx cv cxr wcel cA vx cv clt wbr vx
      cv cB clt wbr wa wa vx cab vx cv cr wcel cA vx cv clt wbr vx cv cB clt
      wbr wa wa vx cab cA vx cv clt wbr vx cv cB clt wbr wa vx cxr crab cA vx
      cv clt wbr vx cv cB clt wbr wa vx cr crab cA cxr wcel cB cxr wcel wa vx
      cv cxr wcel cA vx cv clt wbr vx cv cB clt wbr wa wa vx cv cr wcel cA vx
      cv clt wbr vx cv cB clt wbr wa wa vx cA cxr wcel cB cxr wcel wa vx cv cxr
      wcel cA vx cv clt wbr vx cv cB clt wbr wa wa vx cv cr wcel cA vx cv clt
      wbr vx cv cB clt wbr wa wa cA cxr wcel cB cxr wcel wa vx cv cxr wcel cA
      vx cv clt wbr vx cv cB clt wbr wa wa vx cv cr wcel cA vx cv clt wbr vx cv
      cB clt wbr wa cA cxr wcel cB cxr wcel vx cv cxr wcel cA vx cv clt wbr vx
      cv cB clt wbr wa vx cv cr wcel cA cxr wcel cB cxr wcel vx cv cxr wcel cA
      vx cv clt wbr vx cv cB clt wbr wa vx cv cr wcel wi cA cxr wcel vx cv cxr
      wcel cB cxr wcel cA vx cv clt wbr vx cv cB clt wbr wa vx cv cr wcel wi cA
      cxr wcel vx cv cxr wcel cB cxr wcel w3a cA vx cv clt wbr vx cv cB clt wbr
      wa vx cv cr wcel cA vx cv cB xrre2 ex 3com23 3exp imp4b vx cv cxr wcel cA
      vx cv clt wbr vx cv cB clt wbr wa wa cA vx cv clt wbr vx cv cB clt wbr wa
      wi cA cxr wcel cB cxr wcel wa vx cv cxr wcel cA vx cv clt wbr vx cv cB
      clt wbr wa pm3.27 a1i jcad vx cv cr wcel vx cv cxr wcel cA vx cv clt wbr
      vx cv cB clt wbr wa vx cv rexr anim1i impbid1 abbidv cA vx cv clt wbr vx
      cv cB clt wbr wa vx cxr df-rab cA vx cv clt wbr vx cv cB clt wbr wa vx cr
      df-rab 3eqtr4g eqtrd $.
      $( [7-Feb-2007] $) $( [6-Feb-2007] $)

    $( An empty open interval of extended reals. $)
    ioo0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A (,) B ) = (/) <->
                 B <_ A ) ) $=
      cA cxr wcel cB cxr wcel wa cA cB cioo co c0 wceq cA vx cv clt wbr vx cv
      cB clt wbr wa vx cxr crab c0 wceq cB cA cle wbr cA cxr wcel cB cxr wcel
      wa cA cB cioo co cA vx cv clt wbr vx cv cB clt wbr wa vx cxr crab c0 vx
      cA cB iooval eqeq1d cA cxr wcel cB cxr wcel wa cA vx cv clt wbr vx cv cB
      clt wbr wa vx cxr crab c0 wceq cB cA cle wbr cA cxr wcel cB cxr wcel wa
      cA vx cv clt wbr vx cv cB clt wbr wa vx cxr crab c0 wceq wn cA cB clt wbr
      cB cA cle wbr wn cA cxr wcel cB cxr wcel wa cA vx cv clt wbr vx cv cB clt
      wbr wa vx cxr wrex cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx
      cxr crab c0 wceq wn cA cxr wcel cB cxr wcel wa cA vx cv clt wbr vx cv cB
      clt wbr wa vx cxr wrex cA cB clt wbr cA cxr wcel cB cxr wcel wa cA vx cv
      clt wbr vx cv cB clt wbr wa cA cB clt wbr vx cxr cA cxr wcel cB cxr wcel
      vx cv cxr wcel cA vx cv clt wbr vx cv cB clt wbr wa cA cB clt wbr wi cA
      cxr wcel vx cv cxr wcel cB cxr wcel cA vx cv clt wbr vx cv cB clt wbr wa
      cA cB clt wbr wi cA vx cv cB xrlttr 3com23 3expa r19.23adva cA cxr wcel
      cB cxr wcel cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cxr
      wrex cA cxr wcel cB cxr wcel cA cB clt wbr w3a cA vx cv clt wbr vx cv cB
      clt wbr wa vx cq wrex cA vx cv clt wbr vx cv cB clt wbr wa vx cxr wrex vx
      cA cB qbtwnxr cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv clt wbr vx cv
      cB clt wbr wa vx cq cxr vx cv cq wcel vx cv cxr wcel cA vx cv clt wbr vx
      cv cB clt wbr wa vx cv cq wcel vx cv cr wcel vx cv cxr wcel vx cv qre vx
      cv rexr syl anim1i r19.22i2 syl 3expia impbid cA vx cv clt wbr vx cv cB
      clt wbr wa vx cxr crab c0 wceq wn cA vx cv clt wbr vx cv cB clt wbr wa vx
      cxr crab c0 wne cA vx cv clt wbr vx cv cB clt wbr wa vx cxr wrex cA vx cv
      clt wbr vx cv cB clt wbr wa vx cxr crab c0 df-ne cA vx cv clt wbr vx cv
      cB clt wbr wa vx cxr rabn0 bitr3i syl5bb cA cB xrltnle bitrd con4bid
      bitrd $.
      $( [24-Feb-2007] $) $( [6-Feb-2007] $)

    $( An open interval of extended reals is nonempty iff the lower argument is
       less than the upper argument. $)
    ioon0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A (,) B ) =/= (/) <->
                 A < B ) ) $=
      cA cxr wcel cB cxr wcel wa cA cB clt wbr cA cB cioo co c0 cA cxr wcel cB
      cxr wcel wa cA cB cioo co c0 wceq cB cA cle wbr cA cB clt wbr wn cA cB
      ioo0 cB cxr wcel cA cxr wcel cB cA cle wbr cA cB clt wbr wn wb cB cA
      xrlenlt ancoms bitr2d necon1abid $.
      $( [3-Mar-2007] $) $( [2-Mar-2007] $)

    $( The open interval function's value is empty outside of its domain. $)
    ndmioo $p |- ( -. ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) = (/) ) $=
      cA cxr wcel cB cxr wcel wa wn cB cvv wcel cA cB cioo co c0 wceq cB cvv
      wcel cA cxr wcel cB cxr wcel wa wn cA cB cioo co c0 wceq cioo cdm cxr cxr
      cxp wceq cB cvv wcel cA cxr wcel cB cxr wcel wa wn cA cB cioo co c0 wceq
      vx vy vz cxr cxr vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab
      cioo vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr xrex rabex vx vy
      vz vw df-ioo dmoprab2 cA cB cvv cxr cxr cioo ndmoprg mp3an1 expcom cB cvv
      wcel wn cA cB cioo co cA cA cioo co c0 cA cB cioo oprprc2 cA cxr wcel cA
      cxr wcel wa cA cA cioo co c0 wceq cA cxr wcel cA cxr wcel wa cA cA cioo
      co c0 wceq cA cA cle wbr cA cxr wcel cA cA cle wbr cA cxr wcel cA xrleid
      adantr cA cA ioo0 mpbird cA cxr wcel cA cxr wcel wa wn cA cvv wcel cA cA
      cioo co c0 wceq cA cvv wcel cA cxr wcel cA cxr wcel wa wn cA cA cioo co
      c0 wceq cioo cdm cxr cxr cxp wceq cA cvv wcel cA cxr wcel cA cxr wcel wa
      wn cA cA cioo co c0 wceq vx vy vz cxr cxr vx cv vw cv clt wbr vw cv vy cv
      clt wbr wa vw cxr crab cioo vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw
      cxr xrex rabex vx vy vz vw df-ioo dmoprab2 cA cA cvv cxr cxr cioo ndmoprg
      mp3an1 expcom cA cA cioo cioo cdm wrel cxr cxr cxp wrel cxr cxr relxp
      cioo cdm cxr cxr cxp vx vy vz cxr cxr vx cv vw cv clt wbr vw cv vy cv clt
      wbr wa vw cxr crab cioo vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr
      xrex rabex vx vy vz vw df-ioo dmoprab2 releqi mpbir oprprc1 pm2.61d1
      pm2.61i syl6eq pm2.61d1 $.
      $( [22-Jun-2007] $) $( [21-Jun-2007] $)

    $( An open interval with identical lower and upper bounds is empty. $)
    iooid $p |- ( A (,) A ) = (/) $=
      cA cxr wcel cA cxr wcel wa cA cA cioo co c0 wceq cA cxr wcel cA cxr wcel
      wa cA cA cioo co c0 wceq cA cA cle wbr cA cxr wcel cA cA cle wbr cA cxr
      wcel cA xrleid adantr cA cA ioo0 mpbird cA cA ndmioo pm2.61i $.
      $( [21-Jun-2007] $) $( [21-Jun-2007] $)

    $( Intersection of two open intervals of extended reals. $)
    iooin $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) ) ->
         ( ( A (,) B ) i^i ( C (,) D ) ) =
         ( if ( A <_ C , C , A ) (,) if ( B <_ D , B , D ) ) ) $=
      cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel wa wa cA vx cv clt wbr
      vx cv cB clt wbr wa vx cxr crab cC vx cv clt wbr vx cv cD clt wbr wa vx
      cxr crab cin cA cC cle wbr cC cA cif vx cv clt wbr vx cv cB cD cle wbr cB
      cD cif clt wbr wa vx cxr crab cA cB cioo co cC cD cioo co cin cA cC cle
      wbr cC cA cif cB cD cle wbr cB cD cif cioo co cA cxr wcel cB cxr wcel wa
      cC cxr wcel cD cxr wcel wa wa cA cC cle wbr cC cA cif vx cv clt wbr vx cv
      cB cD cle wbr cB cD cif clt wbr wa vx cxr crab cA vx cv clt wbr vx cv cB
      clt wbr wa cC vx cv clt wbr vx cv cD clt wbr wa wa vx cxr crab cA vx cv
      clt wbr vx cv cB clt wbr wa vx cxr crab cC vx cv clt wbr vx cv cD clt wbr
      wa vx cxr crab cin cA cxr wcel cC cxr wcel cB cxr wcel cD cxr wcel cA cC
      cle wbr cC cA cif vx cv clt wbr vx cv cB cD cle wbr cB cD cif clt wbr wa
      vx cxr crab cA vx cv clt wbr vx cv cB clt wbr wa cC vx cv clt wbr vx cv
      cD clt wbr wa wa vx cxr crab wceq cA cxr wcel cC cxr wcel wa cB cxr wcel
      cD cxr wcel wa wa cA cC cle wbr cC cA cif vx cv clt wbr vx cv cB cD cle
      wbr cB cD cif clt wbr wa cA vx cv clt wbr vx cv cB clt wbr wa cC vx cv
      clt wbr vx cv cD clt wbr wa wa vx cxr cA cxr wcel cC cxr wcel wa cB cxr
      wcel cD cxr wcel wa wa vx cv cxr wcel wa cA cC cle wbr cC cA cif vx cv
      clt wbr vx cv cB cD cle wbr cB cD cif clt wbr wa cA vx cv clt wbr cC vx
      cv clt wbr wa vx cv cB clt wbr vx cv cD clt wbr wa wa cA vx cv clt wbr vx
      cv cB clt wbr wa cC vx cv clt wbr vx cv cD clt wbr wa wa cA cxr wcel cC
      cxr wcel wa cB cxr wcel cD cxr wcel wa wa vx cv cxr wcel wa cA cC cle wbr
      cC cA cif vx cv clt wbr cA vx cv clt wbr cC vx cv clt wbr wa vx cv cB cD
      cle wbr cB cD cif clt wbr vx cv cB clt wbr vx cv cD clt wbr wa cA cxr
      wcel cC cxr wcel wa vx cv cxr wcel cA cC cle wbr cC cA cif vx cv clt wbr
      cA vx cv clt wbr cC vx cv clt wbr wa wb cB cxr wcel cD cxr wcel wa cA cxr
      wcel cC cxr wcel vx cv cxr wcel cA cC cle wbr cC cA cif vx cv clt wbr cA
      vx cv clt wbr cC vx cv clt wbr wa wb cA cC vx cv xrmaxlt 3expa adantlr cB
      cxr wcel cD cxr wcel wa vx cv cxr wcel vx cv cB cD cle wbr cB cD cif clt
      wbr vx cv cB clt wbr vx cv cD clt wbr wa wb cA cxr wcel cC cxr wcel wa cB
      cxr wcel cD cxr wcel vx cv cxr wcel vx cv cB cD cle wbr cB cD cif clt wbr
      vx cv cB clt wbr vx cv cD clt wbr wa wb vx cv cxr wcel cB cxr wcel cD cxr
      wcel vx cv cB cD cle wbr cB cD cif clt wbr vx cv cB clt wbr vx cv cD clt
      wbr wa wb vx cv cB cD xrltmin 3coml 3expa adantll anbi12d cA vx cv clt
      wbr cC vx cv clt wbr vx cv cB clt wbr vx cv cD clt wbr an4 syl6bb rabbidv
      an4s cA vx cv clt wbr vx cv cB clt wbr wa cC vx cv clt wbr vx cv cD clt
      wbr wa vx cxr inrab syl6reqr cA cxr wcel cB cxr wcel wa cC cxr wcel cD
      cxr wcel wa cA cB cioo co cA vx cv clt wbr vx cv cB clt wbr wa vx cxr
      crab cC cD cioo co cC vx cv clt wbr vx cv cD clt wbr wa vx cxr crab vx cA
      cB iooval vx cC cD iooval ineqan12d cA cC cle wbr cC cA cif cxr wcel cB
      cD cle wbr cB cD cif cxr wcel cA cC cle wbr cC cA cif cB cD cle wbr cB cD
      cif cioo co cA cC cle wbr cC cA cif vx cv clt wbr vx cv cB cD cle wbr cB
      cD cif clt wbr wa vx cxr crab wceq cA cxr wcel cB cxr wcel wa cC cxr wcel
      cD cxr wcel wa wa vx cA cC cle wbr cC cA cif cB cD cle wbr cB cD cif
      iooval cA cxr wcel cC cxr wcel cA cC cle wbr cC cA cif cxr wcel cB cxr
      wcel cD cxr wcel cC cxr wcel cA cxr wcel cA cC cle wbr cC cA cif cxr wcel
      cA cC cle wbr cC cA cxr ifcl ancoms ad2ant2r cB cxr wcel cD cxr wcel cB
      cD cle wbr cB cD cif cxr wcel cA cxr wcel cC cxr wcel cB cD cle wbr cB cD
      cxr ifcl ad2ant2l sylanc 3eqtr4d $.
      $( [12-Feb-2007] $) $( [7-Feb-2007] $)

    $( Subset relationship for open intervals of extended reals. $)
    iooss1 $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ A <_ B ) ->
                 ( B (,) C ) C_ ( A (,) C ) ) $=
      cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cB cle wbr wa cB vx cv clt wbr
      vx cv cC clt wbr wa vx cxr crab cA vx cv clt wbr vx cv cC clt wbr wa vx
      cxr crab cB cC cioo co cA cC cioo co cA cxr wcel cB cxr wcel cA cB cle
      wbr cB vx cv clt wbr vx cv cC clt wbr wa vx cxr crab cA vx cv clt wbr vx
      cv cC clt wbr wa vx cxr crab wss cC cxr wcel cA cxr wcel cB cxr wcel wa
      cA cB cle wbr wa cB vx cv clt wbr vx cv cC clt wbr wa cA vx cv clt wbr vx
      cv cC clt wbr wa vx cxr cA cxr wcel cB cxr wcel wa cA cB cle wbr wa vx cv
      cxr wcel wa cB vx cv clt wbr cA vx cv clt wbr vx cv cC clt wbr cA cxr
      wcel cB cxr wcel wa vx cv cxr wcel cA cB cle wbr cB vx cv clt wbr cA vx
      cv clt wbr wi cA cxr wcel cB cxr wcel wa vx cv cxr wcel wa cA cB cle wbr
      cB vx cv clt wbr cA vx cv clt wbr wi cA cxr wcel cB cxr wcel vx cv cxr
      wcel cA cB cle wbr cB vx cv clt wbr cA vx cv clt wbr wi wi cA cxr wcel cB
      cxr wcel vx cv cxr wcel w3a cA cB cle wbr cB vx cv clt wbr cA vx cv clt
      wbr cA cB vx cv xrlelttr exp3a 3expa imp an1rs anim1d ss2rabdv 3adantl3
      cA cxr wcel cB cxr wcel cC cxr wcel w3a cB cC cioo co cB vx cv clt wbr vx
      cv cC clt wbr wa vx cxr crab wceq cA cB cle wbr cB cxr wcel cC cxr wcel
      cB cC cioo co cB vx cv clt wbr vx cv cC clt wbr wa vx cxr crab wceq cA
      cxr wcel vx cB cC iooval 3adant1 adantr cA cxr wcel cB cxr wcel cC cxr
      wcel w3a cA cC cioo co cA vx cv clt wbr vx cv cC clt wbr wa vx cxr crab
      wceq cA cB cle wbr cA cxr wcel cC cxr wcel cA cC cioo co cA vx cv clt wbr
      vx cv cC clt wbr wa vx cxr crab wceq cB cxr wcel vx cA cC iooval 3adant2
      adantr 3sstr4d $.
      $( [12-Feb-2007] $) $( [7-Feb-2007] $)

    $( Subset relationship for open intervals of extended reals. $)
    iooss2 $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ B <_ C ) ->
                 ( A (,) B ) C_ ( A (,) C ) ) $=
      cA cxr wcel cB cxr wcel cC cxr wcel w3a cB cC cle wbr wa cA vx cv clt wbr
      vx cv cB clt wbr wa vx cxr crab cA vx cv clt wbr vx cv cC clt wbr wa vx
      cxr crab cA cB cioo co cA cC cioo co cB cxr wcel cC cxr wcel cB cC cle
      wbr cA vx cv clt wbr vx cv cB clt wbr wa vx cxr crab cA vx cv clt wbr vx
      cv cC clt wbr wa vx cxr crab wss cA cxr wcel cB cxr wcel cC cxr wcel wa
      cB cC cle wbr wa cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv clt wbr vx
      cv cC clt wbr wa vx cxr cB cxr wcel cC cxr wcel wa cB cC cle wbr wa vx cv
      cxr wcel wa vx cv cB clt wbr vx cv cC clt wbr cA vx cv clt wbr cB cxr
      wcel cC cxr wcel wa vx cv cxr wcel cB cC cle wbr vx cv cB clt wbr vx cv
      cC clt wbr wi cB cxr wcel cC cxr wcel wa vx cv cxr wcel wa cB cC cle wbr
      vx cv cB clt wbr vx cv cC clt wbr wi cB cxr wcel cC cxr wcel vx cv cxr
      wcel cB cC cle wbr vx cv cB clt wbr vx cv cC clt wbr wi wi cB cxr wcel cC
      cxr wcel vx cv cxr wcel w3a cB cC cle wbr vx cv cB clt wbr vx cv cC clt
      wbr cB cxr wcel cC cxr wcel vx cv cxr wcel w3a vx cv cB clt wbr cB cC cle
      wbr vx cv cC clt wbr vx cv cxr wcel cB cxr wcel cC cxr wcel vx cv cB clt
      wbr cB cC cle wbr wa vx cv cC clt wbr wi vx cv cB cC xrltletr 3coml
      ancomsd exp3a 3expa imp an1rs anim2d ss2rabdv 3adantl1 cA cxr wcel cB cxr
      wcel cC cxr wcel w3a cA cB cioo co cA vx cv clt wbr vx cv cB clt wbr wa
      vx cxr crab wceq cB cC cle wbr cA cxr wcel cB cxr wcel cA cB cioo co cA
      vx cv clt wbr vx cv cB clt wbr wa vx cxr crab wceq cC cxr wcel vx cA cB
      iooval 3adant3 adantr cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cC cioo
      co cA vx cv clt wbr vx cv cC clt wbr wa vx cxr crab wceq cB cC cle wbr cA
      cxr wcel cC cxr wcel cA cC cioo co cA vx cv clt wbr vx cv cC clt wbr wa
      vx cxr crab wceq cB cxr wcel vx cA cC iooval 3adant2 adantr 3sstr4d $.
      $( [12-Feb-2007] $) $( [7-Feb-2007] $)

    $( Value of the open-below, closed-above interval function. $)
    iocval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,] B ) =
                 { x e. RR* | ( A < x /\ x <_ B ) } ) $=
      vy vz vw cA cB cxr cxr vy cv vx cv clt wbr vx cv vz cv cle wbr wa vx cxr
      crab cA vx cv clt wbr vx cv cB cle wbr wa vx cxr crab cioc cA vx cv clt
      wbr vx cv vz cv cle wbr wa vx cxr crab cA vx cv clt wbr vx cv cB cle wbr
      wa vx cxr xrex rabex vy cv cA wceq vy cv vx cv clt wbr vx cv vz cv cle
      wbr wa cA vx cv clt wbr vx cv vz cv cle wbr wa vx cxr vy cv cA wceq vy cv
      vx cv clt wbr cA vx cv clt wbr vx cv vz cv cle wbr vy cv cA vx cv clt
      breq1 anbi1d rabbisdv vz cv cB wceq cA vx cv clt wbr vx cv vz cv cle wbr
      wa cA vx cv clt wbr vx cv cB cle wbr wa vx cxr vz cv cB wceq vx cv vz cv
      cle wbr vx cv cB cle wbr cA vx cv clt wbr vz cv cB vx cv cle breq2 anbi2d
      rabbisdv vy vz vw vx df-ioc oprabval2 $.
      $( [27-Dec-2006] $) $( [24-Dec-2006] $)

    $( Value of the closed-below, open-above interval function. $)
    icoval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A [,) B ) =
                 { x e. RR* | ( A <_ x /\ x < B ) } ) $=
      vy vz vw cA cB cxr cxr vy cv vx cv cle wbr vx cv vz cv clt wbr wa vx cxr
      crab cA vx cv cle wbr vx cv cB clt wbr wa vx cxr crab cico cA vx cv cle
      wbr vx cv vz cv clt wbr wa vx cxr crab cA vx cv cle wbr vx cv cB clt wbr
      wa vx cxr xrex rabex vy cv cA wceq vy cv vx cv cle wbr vx cv vz cv clt
      wbr wa cA vx cv cle wbr vx cv vz cv clt wbr wa vx cxr vy cv cA wceq vy cv
      vx cv cle wbr cA vx cv cle wbr vx cv vz cv clt wbr vy cv cA vx cv cle
      breq1 anbi1d rabbisdv vz cv cB wceq cA vx cv cle wbr vx cv vz cv clt wbr
      wa cA vx cv cle wbr vx cv cB clt wbr wa vx cxr vz cv cB wceq vx cv vz cv
      clt wbr vx cv cB clt wbr cA vx cv cle wbr vz cv cB vx cv clt breq2 anbi2d
      rabbisdv vy vz vw vx df-ico oprabval2 $.
      $( [27-Dec-2006] $) $( [24-Dec-2006] $)

    $( Value of the closed interval function. $)
    iccval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A [,] B ) =
                 { x e. RR* | ( A <_ x /\ x <_ B ) } ) $=
      vy vz vw cA cB cxr cxr vy cv vx cv cle wbr vx cv vz cv cle wbr wa vx cxr
      crab cA vx cv cle wbr vx cv cB cle wbr wa vx cxr crab cicc cA vx cv cle
      wbr vx cv vz cv cle wbr wa vx cxr crab cA vx cv cle wbr vx cv cB cle wbr
      wa vx cxr xrex rabex vy cv cA wceq vy cv vx cv cle wbr vx cv vz cv cle
      wbr wa cA vx cv cle wbr vx cv vz cv cle wbr wa vx cxr vy cv cA wceq vy cv
      vx cv cle wbr cA vx cv cle wbr vx cv vz cv cle wbr vy cv cA vx cv cle
      breq1 anbi1d rabbisdv vz cv cB wceq cA vx cv cle wbr vx cv vz cv cle wbr
      wa cA vx cv cle wbr vx cv cB cle wbr wa vx cxr vz cv cB wceq vx cv vz cv
      cle wbr vx cv cB cle wbr cA vx cv cle wbr vz cv cB vx cv cle breq2 anbi2d
      rabbisdv vy vz vw vx df-icc oprabval2 $.
      $( [27-Dec-2006] $) $( [24-Dec-2006] $)

    $( Membership in an open interval of extended reals. $)
    elioo1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A (,) B ) <->
                 ( C e. RR* /\ A < C /\ C < B ) ) ) $=
      cA cxr wcel cB cxr wcel wa cC cA cB cioo co wcel cC cA vx cv clt wbr vx
      cv cB clt wbr wa vx cxr crab wcel cC cxr wcel cA cC clt wbr cC cB clt wbr
      w3a cA cxr wcel cB cxr wcel wa cA cB cioo co cA vx cv clt wbr vx cv cB
      clt wbr wa vx cxr crab cC vx cA cB iooval eleq2d cC cA vx cv clt wbr vx
      cv cB clt wbr wa vx cxr crab wcel cC cxr wcel cA cC clt wbr cC cB clt wbr
      wa wa cC cxr wcel cA cC clt wbr cC cB clt wbr w3a cA vx cv clt wbr vx cv
      cB clt wbr wa cA cC clt wbr cC cB clt wbr wa vx cC cxr vx cv cC wceq cA
      vx cv clt wbr cA cC clt wbr vx cv cB clt wbr cC cB clt wbr vx cv cC cA
      clt breq2 vx cv cC cB clt breq1 anbi12d elrab cC cxr wcel cA cC clt wbr
      cC cB clt wbr 3anass bitr4i syl6bb $.
      $( [27-Dec-2006] $) $( [24-Dec-2006] $)

    $( Membership in an open interval of extended reals. $)
    elioo2 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A (,) B ) <->
                 ( C e. RR /\ A < C /\ C < B ) ) ) $=
      cA cxr wcel cB cxr wcel wa cC cA cB cioo co wcel cC cA vx cv clt wbr vx
      cv cB clt wbr wa vx cr crab wcel cC cr wcel cA cC clt wbr cC cB clt wbr
      w3a cA cxr wcel cB cxr wcel wa cA cB cioo co cA vx cv clt wbr vx cv cB
      clt wbr wa vx cr crab cC vx cA cB iooval2 eleq2d cC cA vx cv clt wbr vx
      cv cB clt wbr wa vx cr crab wcel cC cr wcel cA cC clt wbr cC cB clt wbr
      wa wa cC cr wcel cA cC clt wbr cC cB clt wbr w3a cA vx cv clt wbr vx cv
      cB clt wbr wa cA cC clt wbr cC cB clt wbr wa vx cC cr vx cv cC wceq cA vx
      cv clt wbr cA cC clt wbr vx cv cB clt wbr cC cB clt wbr vx cv cC cA clt
      breq2 vx cv cC cB clt breq1 anbi12d elrab cC cr wcel cA cC clt wbr cC cB
      clt wbr 3anass bitr4i syl6bb $.
      $( [28-Apr-2007] $) $( [6-Feb-2007] $)

    $( Membership in a set of open intervals of extended reals.  We use the
       fact that an operation's value is empty outside of its domain to show
       ` A e. RR* ` and ` B e. RR* ` . $)
    elioo3g $p |- ( B e. D -> ( C e. ( A (,) B ) <->
          ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ ( A < C /\ C < B ) ) ) ) $=
      cB cD wcel cC cA cB cioo co wcel cA cxr wcel cB cxr wcel wa cC cxr wcel
      cA cC clt wbr cC cB clt wbr wa wa wa cA cxr wcel cB cxr wcel cC cxr wcel
      w3a cA cC clt wbr cC cB clt wbr wa wa cB cD wcel cA cxr wcel cB cxr wcel
      wa cC cA cB cioo co wcel cA cxr wcel cB cxr wcel wa cC cxr wcel cA cC clt
      wbr cC cB clt wbr wa wa wa wb cA cxr wcel cB cxr wcel wa cC cA cB cioo co
      wcel cA cxr wcel cB cxr wcel wa cC cxr wcel cA cC clt wbr cC cB clt wbr
      wa wa wa wb cB cD wcel cA cxr wcel cB cxr wcel wa cC cA cB cioo co wcel
      cC cxr wcel cA cC clt wbr cC cB clt wbr w3a cA cxr wcel cB cxr wcel wa cC
      cxr wcel cA cC clt wbr cC cB clt wbr wa wa wa cA cB cC elioo1 cA cxr wcel
      cB cxr wcel wa cC cxr wcel cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel
      cB cxr wcel wa cC cxr wcel cA cC clt wbr cC cB clt wbr wa wa wa cC cxr
      wcel cA cC clt wbr cC cB clt wbr w3a cA cxr wcel cB cxr wcel wa cC cxr
      wcel cA cC clt wbr cC cB clt wbr wa wa ibar cC cxr wcel cA cC clt wbr cC
      cB clt wbr 3anass syl5bb bitrd adantl cB cD wcel cA cxr wcel cB cxr wcel
      wa wn wa cC cA cB cioo co wcel cC c0 wcel cA cxr wcel cB cxr wcel wa cC
      cxr wcel cA cC clt wbr cC cB clt wbr wa wa wa cB cD wcel cA cxr wcel cB
      cxr wcel wa wn wa cA cB cioo co c0 cC cioo cdm cxr cxr cxp wceq cB cD
      wcel cA cxr wcel cB cxr wcel wa wn cA cB cioo co c0 wceq vx vy vz cxr cxr
      vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab cioo vx cv vw cv
      clt wbr vw cv vy cv clt wbr wa vw cxr xrex rabex vx vy vz vw df-ioo
      dmoprab2 cA cB cD cxr cxr cioo ndmoprg mp3an1 eleq2d cA cxr wcel cB cxr
      wcel wa wn cC c0 wcel cA cxr wcel cB cxr wcel wa cC cxr wcel cA cC clt
      wbr cC cB clt wbr wa wa wa wb cB cD wcel cC c0 wcel cA cxr wcel cB cxr
      wcel wa cA cxr wcel cB cxr wcel wa cC cxr wcel cA cC clt wbr cC cB clt
      wbr wa wa wa cC c0 wcel cA cxr wcel cB cxr wcel wa cC noel pm2.21i cA cxr
      wcel cB cxr wcel wa cC cxr wcel cA cC clt wbr cC cB clt wbr wa wa pm3.26
      pm5.21ni adantl bitrd pm2.61dan cA cxr wcel cB cxr wcel cC cxr wcel w3a
      cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel wa cC cxr wcel
      wa cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel wa cC cxr
      wcel cA cC clt wbr cC cB clt wbr wa wa wa cA cxr wcel cB cxr wcel cC cxr
      wcel w3a cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA cC clt wbr cC cB
      clt wbr wa cA cxr wcel cB cxr wcel cC cxr wcel df-3an anbi1i cA cxr wcel
      cB cxr wcel wa cC cxr wcel cA cC clt wbr cC cB clt wbr wa anass bitr2i
      syl6bb $.
      $( [7-Jun-2007] $) $( [24-Dec-2006] $)

    $( Membership in an open-below, closed-above interval of extended reals. $)
    elioc1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A (,] B ) <->
                 ( C e. RR* /\ A < C /\ C <_ B ) ) ) $=
      cA cxr wcel cB cxr wcel wa cC cA cB cioc co wcel cC cA vx cv clt wbr vx
      cv cB cle wbr wa vx cxr crab wcel cC cxr wcel cA cC clt wbr cC cB cle wbr
      w3a cA cxr wcel cB cxr wcel wa cA cB cioc co cA vx cv clt wbr vx cv cB
      cle wbr wa vx cxr crab cC vx cA cB iocval eleq2d cC cA vx cv clt wbr vx
      cv cB cle wbr wa vx cxr crab wcel cC cxr wcel cA cC clt wbr cC cB cle wbr
      wa wa cC cxr wcel cA cC clt wbr cC cB cle wbr w3a cA vx cv clt wbr vx cv
      cB cle wbr wa cA cC clt wbr cC cB cle wbr wa vx cC cxr vx cv cC wceq cA
      vx cv clt wbr cA cC clt wbr vx cv cB cle wbr cC cB cle wbr vx cv cC cA
      clt breq2 vx cv cC cB cle breq1 anbi12d elrab cC cxr wcel cA cC clt wbr
      cC cB cle wbr 3anass bitr4i syl6bb $.
      $( [28-Dec-2006] $) $( [24-Dec-2006] $)

    $( Membership in a closed-below, open-above interval of extended reals. $)
    elico1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A [,) B ) <->
                 ( C e. RR* /\ A <_ C /\ C < B ) ) ) $=
      cA cxr wcel cB cxr wcel wa cC cA cB cico co wcel cC cA vx cv cle wbr vx
      cv cB clt wbr wa vx cxr crab wcel cC cxr wcel cA cC cle wbr cC cB clt wbr
      w3a cA cxr wcel cB cxr wcel wa cA cB cico co cA vx cv cle wbr vx cv cB
      clt wbr wa vx cxr crab cC vx cA cB icoval eleq2d cC cA vx cv cle wbr vx
      cv cB clt wbr wa vx cxr crab wcel cC cxr wcel cA cC cle wbr cC cB clt wbr
      wa wa cC cxr wcel cA cC cle wbr cC cB clt wbr w3a cA vx cv cle wbr vx cv
      cB clt wbr wa cA cC cle wbr cC cB clt wbr wa vx cC cxr vx cv cC wceq cA
      vx cv cle wbr cA cC cle wbr vx cv cB clt wbr cC cB clt wbr vx cv cC cA
      cle breq2 vx cv cC cB clt breq1 anbi12d elrab cC cxr wcel cA cC cle wbr
      cC cB clt wbr 3anass bitr4i syl6bb $.
      $( [28-Dec-2006] $) $( [24-Dec-2006] $)

    $( Membership in a closed interval of extended reals. $)
    elicc1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A [,] B ) <->
                 ( C e. RR* /\ A <_ C /\ C <_ B ) ) ) $=
      cA cxr wcel cB cxr wcel wa cC cA cB cicc co wcel cC cA vx cv cle wbr vx
      cv cB cle wbr wa vx cxr crab wcel cC cxr wcel cA cC cle wbr cC cB cle wbr
      w3a cA cxr wcel cB cxr wcel wa cA cB cicc co cA vx cv cle wbr vx cv cB
      cle wbr wa vx cxr crab cC vx cA cB iccval eleq2d cC cA vx cv cle wbr vx
      cv cB cle wbr wa vx cxr crab wcel cC cxr wcel cA cC cle wbr cC cB cle wbr
      wa wa cC cxr wcel cA cC cle wbr cC cB cle wbr w3a cA vx cv cle wbr vx cv
      cB cle wbr wa cA cC cle wbr cC cB cle wbr wa vx cC cxr vx cv cC wceq cA
      vx cv cle wbr cA cC cle wbr vx cv cB cle wbr cC cB cle wbr vx cv cC cA
      cle breq2 vx cv cC cB cle breq1 anbi12d elrab cC cxr wcel cA cC cle wbr
      cC cB cle wbr 3anass bitr4i syl6bb $.
      $( [28-Dec-2006] $) $( [24-Dec-2006] $)
  $}

  $( MAY BE REVISED - see if this shortens the uses of any other
     elioo*'s $)
  $( Membership in an open interval of extended reals. $)
  elioo5 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* )
           -> ( C e. ( A (,) B ) <-> ( A < C /\ C < B ) ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cC cA cB cioo co wcel cC cxr wcel
    cA cC clt wbr cC cB clt wbr w3a cA cC clt wbr cC cB clt wbr wa cA cxr wcel
    cB cxr wcel cC cA cB cioo co wcel cC cxr wcel cA cC clt wbr cC cB clt wbr
    w3a wb cC cxr wcel cA cB cC elioo1 3adant3 cC cxr wcel cA cxr wcel cA cC
    clt wbr cC cB clt wbr wa cC cxr wcel cA cC clt wbr cC cB clt wbr w3a wb cB
    cxr wcel cC cxr wcel cA cC clt wbr cC cB clt wbr w3a cC cxr wcel cA cC clt
    wbr cC cB clt wbr wa cC cxr wcel cA cC clt wbr cC cB clt wbr 3anass baibr
    3ad2ant3 bitr4d $.
    $( [19-Aug-2008] $) $( [17-Aug-2008] $)

  $( Membership in an open interval of extended reals. $)
  elioo4g $p |- ( B e. D -> ( C e. ( A (,) B ) <->
        ( ( A e. RR* /\ B e. RR* /\ C e. RR ) /\ ( A < C /\ C < B ) ) ) ) $=
    cB cD wcel cC cA cB cioo co wcel cA cxr wcel cB cxr wcel cC cxr wcel w3a cA
    cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel cC cr wcel w3a cA cC
    clt wbr cC cB clt wbr wa wa cA cB cC cD elioo3g cA cxr wcel cB cxr wcel cC
    cxr wcel w3a cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel cC
    cr wcel w3a cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel cC
    cxr wcel w3a cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel cC
    cr wcel w3a cA cC clt wbr cC cB clt wbr wa cA cxr wcel cB cxr wcel cC cxr
    wcel w3a cA cC clt wbr cC cB clt wbr wa wa cA cxr wcel cB cxr wcel cC cr
    wcel cA cxr wcel cB cxr wcel cC cxr wcel cA cC clt wbr cC cB clt wbr wa
    3simpl1 cA cxr wcel cB cxr wcel cC cxr wcel cA cC clt wbr cC cB clt wbr wa
    3simpl2 cA cxr wcel cB cxr wcel cC cxr wcel w3a cA cC clt wbr cC cB clt wbr
    wa cC cr wcel cA cxr wcel cC cxr wcel cB cxr wcel cA cC clt wbr cC cB clt
    wbr wa cC cr wcel wi cA cxr wcel cC cxr wcel cB cxr wcel w3a cA cC clt wbr
    cC cB clt wbr wa cC cr wcel cA cC cB xrre2 ex 3com23 imp 3jca cA cxr wcel
    cB cxr wcel cC cxr wcel w3a cA cC clt wbr cC cB clt wbr wa pm3.27 jca cA
    cxr wcel cB cxr wcel cC cr wcel w3a cA cxr wcel cB cxr wcel cC cxr wcel w3a
    cA cC clt wbr cC cB clt wbr wa cA cxr wcel cA cxr wcel cB cxr wcel cB cxr
    wcel cC cr wcel cC cxr wcel cA cxr wcel id cB cxr wcel id cC rexr 3anim123i
    anim1i impbii syl6bb $.
    $( [2-Jul-2007] $) $( [8-Jun-2007] $)

  $( A member of an open interval of reals is a real. $)
  elioore $p |- ( A e. ( B (,) C ) -> A e. RR ) $=
    cC cvv wcel cA cB cC cioo co wcel cA cr wcel wi cC cvv wcel cA cB cC cioo
    co wcel cB cxr wcel cC cxr wcel cA cr wcel w3a cB cA clt wbr cA cC clt wbr
    wa wa cA cr wcel cB cC cA cvv elioo4g cB cxr wcel cC cxr wcel cA cr wcel cB
    cA clt wbr cA cC clt wbr wa 3simpl3 syl6bi cC cvv wcel wn cA cB cC cioo co
    wcel cA cr wcel cC cvv wcel wn cB cC cioo co c0 wceq cA cB cC cioo co wcel
    wn cC cvv wcel wn cB cC cioo co cB cB cioo co c0 cB cC cioo oprprc2 cB
    iooid syl6eq cB cC cioo co c0 wceq cA cB cC cioo co wcel cA c0 wcel cA noel
    cB cC cioo co c0 cA eleq2 mtbiri syl pm2.21d pm2.61i $.
    $( [21-Aug-2008] $) $( [17-Aug-2008] $)

  $( A non-empty open interval spans an interval of extended reals. $)
  eliooxr $p |- ( A e. ( B (,) C ) -> ( B e. RR* /\ C e. RR* ) ) $=
    cA cB cC cioo co wcel cB cC cioo co c0 wne cB cxr wcel cC cxr wcel wa cB cC
    cioo co cA ne0i cB cxr wcel cC cxr wcel wa cB cC cioo co c0 cB cC ndmioo
    necon1ai syl $.
    $( [24-Aug-2008] $) $( [17-Aug-2008] $)

  $( Ordering implied by a member of an open interval of reals. $)
  eliooord $p |- ( A e. ( B (,) C ) -> ( B <_ A /\ A <_ C ) ) $=
    cB cxr wcel cC cxr wcel cA cxr wcel w3a cB cA clt wbr cA cC clt wbr wa cB
    cA cle wbr cA cC cle wbr wa cA cB cC cioo co wcel cB cxr wcel cC cxr wcel
    cA cxr wcel w3a cB cA clt wbr cB cA cle wbr cA cC clt wbr cA cC cle wbr cB
    cxr wcel cA cxr wcel cB cA clt wbr cB cA cle wbr wi cC cxr wcel cB cA
    xrltle 3adant2 cC cxr wcel cA cxr wcel cA cC clt wbr cA cC cle wbr wi cB
    cxr wcel cA cxr wcel cC cxr wcel cA cC clt wbr cA cC cle wbr wi cA cC
    xrltle ancoms 3adant1 anim12d cB cxr wcel cC cxr wcel cA cxr wcel w3a cB
    cxr wcel cC cxr wcel wa cA cxr wcel cA cB cC cioo co wcel cB cxr wcel cC
    cxr wcel cA cxr wcel df-3an cA cB cC eliooxr cA cB cC cioo co wcel cA cr
    wcel cA cxr wcel cA cB cC elioore cA rexr syl sylanbrc cA cB cC cioo co
    wcel cA cr wcel cB cA clt wbr cA cC clt wbr w3a cB cA clt wbr cA cC clt wbr
    wa cA cB cC cioo co wcel cA cr wcel cB cA clt wbr cA cC clt wbr w3a cA cB
    cC cioo co wcel cB cxr wcel cC cxr wcel wa cA cB cC cioo co wcel cA cr wcel
    cB cA clt wbr cA cC clt wbr w3a wb cA cB cC eliooxr cB cC cA elioo2 syl ibi
    cA cr wcel cB cA clt wbr cA cC clt wbr 3simpc syl sylc $.
    $( [24-Aug-2008] $) $( [17-Aug-2008] $)

  ${
    $d x A $.  $d x B $.
    $( An open interval is a set of reals. $)
    ioossre $p |- ( A (,) B ) C_ RR $=
      vx cA cB cioo co cr vx cv cA cB elioore ssriv $.
      $( [21-Jun-2007] $) $( [31-May-2007] $)
  $}

  $( Membership in an open-below, closed-above real interval.  (Contributed by
     Paul Chapman, 30-Dec-2007.) $)
  elioc2 $p |- ( ( A e. RR /\ B e. RR ) ->
      ( C e. ( A (,] B ) <-> ( C e. RR /\ A < C /\ C <_ B ) ) ) $=
    cA cr wcel cB cr wcel wa cC cA cB cioc co wcel cC cr wcel cA cC clt wbr cC
    cB cle wbr w3a cA cr wcel cB cr wcel wa cC cA cB cioc co wcel cC cxr wcel
    cA cC clt wbr cC cB cle wbr w3a cC cr wcel cA cC clt wbr cC cB cle wbr w3a
    cA cxr wcel cB cxr wcel cC cA cB cioc co wcel cC cxr wcel cA cC clt wbr cC
    cB cle wbr w3a wb cA cr wcel cB cr wcel cA cB cC elioc1 cA rexr cB rexr
    syl2an cA cr wcel cB cr wcel wa cC cxr wcel cA cC clt wbr cC cB cle wbr wa
    wa cC cr wcel cA cC clt wbr cC cB cle wbr wa wa cC cxr wcel cA cC clt wbr
    cC cB cle wbr w3a cC cr wcel cA cC clt wbr cC cB cle wbr w3a cA cr wcel cB
    cr wcel wa cC cxr wcel cA cC clt wbr cC cB cle wbr wa wa cC cr wcel cA cC
    clt wbr cC cB cle wbr wa cA cr wcel cB cr wcel wa cC cxr wcel cA cC clt wbr
    cC cB cle wbr wa cC cr wcel cA cr wcel cB cr wcel wa cC cxr wcel wa cA cC
    clt wbr cC cB cle wbr wa cmnf cC clt wbr cC cpnf clt wbr wa cC cr wcel cA
    cr wcel cB cr wcel wa cC cxr wcel wa cA cC clt wbr cmnf cC clt wbr cC cB
    cle wbr cC cpnf clt wbr cA cr wcel cB cr wcel wa cC cxr wcel wa cmnf cA clt
    wbr cA cC clt wbr cmnf cC clt wbr cA cr wcel cmnf cA clt wbr cB cr wcel cC
    cxr wcel cA mnflt ad2antrr cA cr wcel cC cxr wcel cmnf cA clt wbr cA cC clt
    wbr wa cmnf cC clt wbr wi cB cr wcel cA cxr wcel cC cxr wcel cmnf cA clt
    wbr cA cC clt wbr wa cmnf cC clt wbr wi cA cr wcel cmnf cxr wcel cA cxr
    wcel cC cxr wcel cmnf cA clt wbr cA cC clt wbr wa cmnf cC clt wbr wi mnfxr
    cmnf cA cC xrlttr mp3an1 cA rexr sylan adantlr mpand cA cr wcel cB cr wcel
    wa cC cxr wcel wa cC cB cle wbr cB cpnf clt wbr cC cpnf clt wbr cB cr wcel
    cB cpnf clt wbr cA cr wcel cC cxr wcel cB ltpnf ad2antlr cB cr wcel cC cxr
    wcel cC cB cle wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cA cr wcel cC cxr
    wcel cB cr wcel cC cB cle wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cC cxr
    wcel cB cxr wcel cC cB cle wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cB cr
    wcel cC cxr wcel cB cxr wcel cpnf cxr wcel cC cB cle wbr cB cpnf clt wbr wa
    cC cpnf clt wbr wi pnfxr cC cB cpnf xrlelttr mp3an3 cB rexr sylan2 ancoms
    adantll mpan2d anim12d cC cxr wcel cC cr wcel cmnf cC clt wbr cC cpnf clt
    wbr wa wb cA cr wcel cB cr wcel wa cC xrrebnd adantl sylibrd expimpd cC cxr
    wcel cA cC clt wbr cC cB cle wbr wa wa cA cC clt wbr cC cB cle wbr wa wi cA
    cr wcel cB cr wcel wa cC cxr wcel cA cC clt wbr cC cB cle wbr wa pm3.27 a1i
    jcad cC cxr wcel cA cC clt wbr cC cB cle wbr 3anass cC cr wcel cA cC clt
    wbr cC cB cle wbr 3anass 3imtr4g sylbid cA cr wcel cB cr wcel wa cC cA cB
    cioc co wcel cC cxr wcel cA cC clt wbr cC cB cle wbr w3a cC cr wcel cA cC
    clt wbr cC cB cle wbr w3a cA cxr wcel cB cxr wcel cC cA cB cioc co wcel cC
    cxr wcel cA cC clt wbr cC cB cle wbr w3a wb cA cr wcel cB cr wcel cA cB cC
    elioc1 cA rexr cB rexr syl2an cC cr wcel cA cC clt wbr cC cB cle wbr wa wa
    cC cxr wcel cA cC clt wbr cC cB cle wbr wa wa cC cr wcel cA cC clt wbr cC
    cB cle wbr w3a cC cxr wcel cA cC clt wbr cC cB cle wbr w3a cC cr wcel cC
    cxr wcel cA cC clt wbr cC cB cle wbr wa cC rexr anim1i cC cr wcel cA cC clt
    wbr cC cB cle wbr 3anass cC cxr wcel cA cC clt wbr cC cB cle wbr 3anass
    3imtr4i syl5bir impbid $.
    $( [30-Dec-2007] $) $( [30-Dec-2007] $)

  $( Membership in a closed-below, open-above real interval.  (Contributed by
     Paul Chapman, 21-Jan-2008.) $)
  elico2 $p |- ( ( A e. RR /\ B e. RR ) ->
      ( C e. ( A [,) B ) <-> ( C e. RR /\ A <_ C /\ C < B ) ) ) $=
    cA cr wcel cB cr wcel wa cC cA cB cico co wcel cC cr wcel cA cC cle wbr cC
    cB clt wbr w3a cA cr wcel cB cr wcel wa cC cA cB cico co wcel cC cxr wcel
    cA cC cle wbr cC cB clt wbr w3a cC cr wcel cA cC cle wbr cC cB clt wbr w3a
    cA cxr wcel cB cxr wcel cC cA cB cico co wcel cC cxr wcel cA cC cle wbr cC
    cB clt wbr w3a wb cA cr wcel cB cr wcel cA cB cC elico1 cA rexr cB rexr
    syl2an cA cr wcel cB cr wcel wa cC cxr wcel cA cC cle wbr cC cB clt wbr wa
    wa cC cr wcel cA cC cle wbr cC cB clt wbr wa wa cC cxr wcel cA cC cle wbr
    cC cB clt wbr w3a cC cr wcel cA cC cle wbr cC cB clt wbr w3a cA cr wcel cB
    cr wcel wa cC cxr wcel cA cC cle wbr cC cB clt wbr wa wa cC cr wcel cA cC
    cle wbr cC cB clt wbr wa cA cr wcel cB cr wcel wa cC cxr wcel cA cC cle wbr
    cC cB clt wbr wa cC cr wcel cA cr wcel cB cr wcel wa cC cxr wcel wa cA cC
    cle wbr cC cB clt wbr wa cmnf cC clt wbr cC cpnf clt wbr wa cC cr wcel cA
    cr wcel cB cr wcel wa cC cxr wcel wa cA cC cle wbr cmnf cC clt wbr cC cB
    clt wbr cC cpnf clt wbr cA cr wcel cB cr wcel wa cC cxr wcel wa cmnf cA clt
    wbr cA cC cle wbr cmnf cC clt wbr cA cr wcel cmnf cA clt wbr cB cr wcel cC
    cxr wcel cA mnflt ad2antrr cA cr wcel cC cxr wcel cmnf cA clt wbr cA cC cle
    wbr wa cmnf cC clt wbr wi cB cr wcel cA cxr wcel cC cxr wcel cmnf cA clt
    wbr cA cC cle wbr wa cmnf cC clt wbr wi cA cr wcel cmnf cxr wcel cA cxr
    wcel cC cxr wcel cmnf cA clt wbr cA cC cle wbr wa cmnf cC clt wbr wi mnfxr
    cmnf cA cC xrltletr mp3an1 cA rexr sylan adantlr mpand cA cr wcel cB cr
    wcel wa cC cxr wcel wa cC cB clt wbr cB cpnf clt wbr cC cpnf clt wbr cB cr
    wcel cB cpnf clt wbr cA cr wcel cC cxr wcel cB ltpnf ad2antlr cB cr wcel cC
    cxr wcel cC cB clt wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cA cr wcel cC
    cxr wcel cB cr wcel cC cB clt wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cC
    cxr wcel cB cxr wcel cC cB clt wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cB
    cr wcel cC cxr wcel cB cxr wcel cpnf cxr wcel cC cB clt wbr cB cpnf clt wbr
    wa cC cpnf clt wbr wi pnfxr cC cB cpnf xrlttr mp3an3 cB rexr sylan2 ancoms
    adantll mpan2d anim12d cC cxr wcel cC cr wcel cmnf cC clt wbr cC cpnf clt
    wbr wa wb cA cr wcel cB cr wcel wa cC xrrebnd adantl sylibrd expimpd cC cxr
    wcel cA cC cle wbr cC cB clt wbr wa wa cA cC cle wbr cC cB clt wbr wa wi cA
    cr wcel cB cr wcel wa cC cxr wcel cA cC cle wbr cC cB clt wbr wa pm3.27 a1i
    jcad cC cxr wcel cA cC cle wbr cC cB clt wbr 3anass cC cr wcel cA cC cle
    wbr cC cB clt wbr 3anass 3imtr4g sylbid cA cr wcel cB cr wcel wa cC cA cB
    cico co wcel cC cxr wcel cA cC cle wbr cC cB clt wbr w3a cC cr wcel cA cC
    cle wbr cC cB clt wbr w3a cA cxr wcel cB cxr wcel cC cA cB cico co wcel cC
    cxr wcel cA cC cle wbr cC cB clt wbr w3a wb cA cr wcel cB cr wcel cA cB cC
    elico1 cA rexr cB rexr syl2an cC cr wcel cA cC cle wbr cC cB clt wbr wa wa
    cC cxr wcel cA cC cle wbr cC cB clt wbr wa wa cC cr wcel cA cC cle wbr cC
    cB clt wbr w3a cC cxr wcel cA cC cle wbr cC cB clt wbr w3a cC cr wcel cC
    cxr wcel cA cC cle wbr cC cB clt wbr wa cC rexr anim1i cC cr wcel cA cC cle
    wbr cC cB clt wbr 3anass cC cxr wcel cA cC cle wbr cC cB clt wbr 3anass
    3imtr4i syl5bir impbid $.
    $( [21-Jan-2008] $) $( [21-Jan-2008] $)

  $( Membership in a closed real interval.  (Contributed by Paul Chapman,
     21-Sep-2007.) $)
  elicc2 $p |- ( ( A e. RR /\ B e. RR ) -> ( C e. ( A [,] B ) <->
                    ( C e. RR /\ A <_ C /\ C <_ B ) ) ) $=
    cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC
    cB cle wbr w3a cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cC cxr wcel
    cA cC cle wbr cC cB cle wbr w3a cC cr wcel cA cC cle wbr cC cB cle wbr w3a
    cA cxr wcel cB cxr wcel cC cA cB cicc co wcel cC cxr wcel cA cC cle wbr cC
    cB cle wbr w3a wb cA cr wcel cB cr wcel cA cB cC elicc1 cA rexr cB rexr
    syl2an cA cr wcel cB cr wcel wa cC cxr wcel cA cC cle wbr cC cB cle wbr wa
    wa cC cr wcel cA cC cle wbr cC cB cle wbr wa wa cC cxr wcel cA cC cle wbr
    cC cB cle wbr w3a cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cr wcel cB
    cr wcel wa cC cxr wcel cA cC cle wbr cC cB cle wbr wa wa cC cr wcel cA cC
    cle wbr cC cB cle wbr wa cA cr wcel cB cr wcel wa cC cxr wcel cA cC cle wbr
    cC cB cle wbr wa cC cr wcel cA cr wcel cB cr wcel wa cC cxr wcel wa cA cC
    cle wbr cC cB cle wbr wa cmnf cC clt wbr cC cpnf clt wbr wa cC cr wcel cA
    cr wcel cB cr wcel wa cC cxr wcel wa cA cC cle wbr cmnf cC clt wbr cC cB
    cle wbr cC cpnf clt wbr cA cr wcel cB cr wcel wa cC cxr wcel wa cmnf cA clt
    wbr cA cC cle wbr cmnf cC clt wbr cA cr wcel cmnf cA clt wbr cB cr wcel cC
    cxr wcel cA mnflt ad2antrr cA cr wcel cC cxr wcel cmnf cA clt wbr cA cC cle
    wbr wa cmnf cC clt wbr wi cB cr wcel cA cxr wcel cC cxr wcel cmnf cA clt
    wbr cA cC cle wbr wa cmnf cC clt wbr wi cA cr wcel cmnf cxr wcel cA cxr
    wcel cC cxr wcel cmnf cA clt wbr cA cC cle wbr wa cmnf cC clt wbr wi mnfxr
    cmnf cA cC xrltletr mp3an1 cA rexr sylan adantlr mpand cA cr wcel cB cr
    wcel wa cC cxr wcel wa cC cB cle wbr cB cpnf clt wbr cC cpnf clt wbr cB cr
    wcel cB cpnf clt wbr cA cr wcel cC cxr wcel cB ltpnf ad2antlr cB cr wcel cC
    cxr wcel cC cB cle wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cA cr wcel cC
    cxr wcel cB cr wcel cC cB cle wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cC
    cxr wcel cB cxr wcel cC cB cle wbr cB cpnf clt wbr wa cC cpnf clt wbr wi cB
    cr wcel cC cxr wcel cB cxr wcel cpnf cxr wcel cC cB cle wbr cB cpnf clt wbr
    wa cC cpnf clt wbr wi pnfxr cC cB cpnf xrlelttr mp3an3 cB rexr sylan2
    ancoms adantll mpan2d anim12d cC cxr wcel cC cr wcel cmnf cC clt wbr cC
    cpnf clt wbr wa wb cA cr wcel cB cr wcel wa cC xrrebnd adantl sylibrd
    expimpd cC cxr wcel cA cC cle wbr cC cB cle wbr wa wa cA cC cle wbr cC cB
    cle wbr wa wi cA cr wcel cB cr wcel wa cC cxr wcel cA cC cle wbr cC cB cle
    wbr wa pm3.27 a1i jcad cC cxr wcel cA cC cle wbr cC cB cle wbr 3anass cC cr
    wcel cA cC cle wbr cC cB cle wbr 3anass 3imtr4g sylbid cA cr wcel cB cr
    wcel wa cC cA cB cicc co wcel cC cxr wcel cA cC cle wbr cC cB cle wbr w3a
    cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cxr wcel cB cxr wcel cC cA cB
    cicc co wcel cC cxr wcel cA cC cle wbr cC cB cle wbr w3a wb cA cr wcel cB
    cr wcel cA cB cC elicc1 cA rexr cB rexr syl2an cC cr wcel cA cC cle wbr cC
    cB cle wbr wa wa cC cxr wcel cA cC cle wbr cC cB cle wbr wa wa cC cr wcel
    cA cC cle wbr cC cB cle wbr w3a cC cxr wcel cA cC cle wbr cC cB cle wbr w3a
    cC cr wcel cC cxr wcel cA cC cle wbr cC cB cle wbr wa cC rexr anim1i cC cr
    wcel cA cC cle wbr cC cB cle wbr 3anass cC cxr wcel cA cC cle wbr cC cB cle
    wbr 3anass 3imtr4i syl5bir impbid $.
    $( [21-Sep-2007] $) $( [21-Sep-2007] $)

  $( The open interval from minus to plus infinity. $)
  ioomax $p |- ( -oo (,) +oo ) = RR $=
    cmnf cpnf cioo co cmnf vx cv clt wbr vx cv cpnf clt wbr wa vx cr crab cr
    cmnf cxr wcel cpnf cxr wcel cmnf cpnf cioo co cmnf vx cv clt wbr vx cv cpnf
    clt wbr wa vx cr crab wceq mnfxr pnfxr vx cmnf cpnf iooval2 mp2an cr cmnf
    vx cv clt wbr vx cv cpnf clt wbr wa vx cr crab wceq cmnf vx cv clt wbr vx
    cv cpnf clt wbr wa vx cr cmnf vx cv clt wbr vx cv cpnf clt wbr wa vx cr
    rabid2 vx cv cr wcel cmnf vx cv clt wbr vx cv cpnf clt wbr vx cv mnflt vx
    cv ltpnf jca mprgbir eqtr4i $.
    $( [8-Feb-2007] $) $( [6-Feb-2007] $)

  $( The set of positive reals expressed as an open interval. $)
  ioopos $p |- ( 0 (,) +oo ) = { x e. RR | 0 < x } $=
    cc0 cpnf cioo co cc0 vx cv clt wbr vx cv cpnf clt wbr wa vx cr crab cc0 vx
    cv clt wbr vx cr crab cc0 cxr wcel cpnf cxr wcel cc0 cpnf cioo co cc0 vx cv
    clt wbr vx cv cpnf clt wbr wa vx cr crab wceq cc0 cr wcel cc0 cxr wcel 0re
    cc0 rexr ax-mp pnfxr vx cc0 cpnf iooval2 mp2an cc0 vx cv clt wbr cc0 vx cv
    clt wbr vx cv cpnf clt wbr wa vx cr vx cv cr wcel vx cv cpnf clt wbr cc0 vx
    cv clt wbr vx cv ltpnf biantrud rabbii eqtr4i $.
    $( [8-May-2007] $) $( [7-May-2007] $)

  $( The set of positive reals expressed as an open interval.  (Contributed by
     Steve Rodriguez, 25-Nov-2007.) $)
  ioorp $p |- ( 0 (,) +oo ) = RR+ $=
    cc0 cpnf cioo co cc0 vx cv clt wbr vx cr crab crp vx ioopos vx df-rp eqtr4i
    $.
    $( [25-Nov-2007] $) $( [25-Nov-2007] $)

  $( Shift the arguments of the open interval function. $)
  iooshf $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) )
     -> ( ( A - B ) e. ( C (,) D ) <-> A e. ( ( C + B ) (,) ( D + B ) ) ) ) $=
    cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cC cB caddc co cA clt
    wbr cA cD cB caddc co clt wbr wa cC cA cB cmin co clt wbr cA cB cmin co cD
    clt wbr wa cA cC cB caddc co cD cB caddc co cioo co wcel cA cB cmin co cC
    cD cioo co wcel cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa wa cC cB
    caddc co cA clt wbr cC cA cB cmin co clt wbr cA cD cB caddc co clt wbr cA
    cB cmin co cD clt wbr cA cr wcel cB cr wcel wa cC cr wcel cC cB caddc co cA
    clt wbr cC cA cB cmin co clt wbr wb cD cr wcel cA cr wcel cB cr wcel cC cr
    wcel cC cB caddc co cA clt wbr cC cA cB cmin co clt wbr wb cC cr wcel cB cr
    wcel cA cr wcel cC cB caddc co cA clt wbr cC cA cB cmin co clt wbr wb cC cB
    cA ltaddsub 3com13 3expa adantrr cA cr wcel cB cr wcel wa cD cr wcel cA cD
    cB caddc co clt wbr cA cB cmin co cD clt wbr wb cC cr wcel cA cr wcel cB cr
    wcel cD cr wcel cA cD cB caddc co clt wbr cA cB cmin co cD clt wbr wb cA cr
    wcel cB cr wcel cD cr wcel w3a cA cB cmin co cD clt wbr cA cD cB caddc co
    clt wbr cA cB cD ltsubadd bicomd 3expa adantrl anbi12d cC cr wcel cD cr
    wcel wa cA cr wcel cB cr wcel wa cA cC cB caddc co cD cB caddc co cioo co
    wcel cC cB caddc co cA clt wbr cA cD cB caddc co clt wbr wa wb cC cB caddc
    co cxr wcel cD cB caddc co cxr wcel cA cxr wcel cA cC cB caddc co cD cB
    caddc co cioo co wcel cC cB caddc co cA clt wbr cA cD cB caddc co clt wbr
    wa wb cC cr wcel cD cr wcel wa cA cr wcel cB cr wcel wa wa cC cB caddc co
    cD cB caddc co cA elioo5 cC cr wcel cB cr wcel cC cB caddc co cxr wcel cD
    cr wcel cA cr wcel cC cr wcel cB cr wcel wa cC cB caddc co cr wcel cC cB
    caddc co cxr wcel cC cB readdcl cC cB caddc co rexr syl ad2ant2rl cD cr
    wcel cB cr wcel cD cB caddc co cxr wcel cC cr wcel cA cr wcel cD cr wcel cB
    cr wcel wa cD cB caddc co cr wcel cD cB caddc co cxr wcel cD cB readdcl cD
    cB caddc co rexr syl ad2ant2l cA cr wcel cA cxr wcel cC cr wcel cD cr wcel
    wa cB cr wcel cA rexr ad2antrl syl3anc ancoms cC cxr wcel cD cxr wcel cA cB
    cmin co cxr wcel cA cB cmin co cC cD cioo co wcel cC cA cB cmin co clt wbr
    cA cB cmin co cD clt wbr wa wb cA cr wcel cB cr wcel wa cC cr wcel cD cr
    wcel wa wa cC cD cA cB cmin co elioo5 cC cr wcel cC cxr wcel cA cr wcel cB
    cr wcel wa cD cr wcel cC rexr ad2antrl cD cr wcel cD cxr wcel cA cr wcel cB
    cr wcel wa cC cr wcel cD rexr ad2antll cA cr wcel cB cr wcel wa cA cB cmin
    co cxr wcel cC cr wcel cD cr wcel wa cA cr wcel cB cr wcel wa cA cB cmin co
    cr wcel cA cB cmin co cxr wcel cA cB resubcl cA cB cmin co rexr syl adantr
    syl3anc 3bitr4rd $.
    $( [1-Nov-2008] $) $( [17-Aug-2008] $)

  ${
    $d A x $.  $d B x $.
    $( A closed real interval is a set of reals.  (Contributed by FL,
       6-Jun-2007.  Proof shortened by Paul Chapman, 21-Jan-2008.) $)
    iccssre $p |- ( ( A e. RR /\ B e. RR ) -> ( A [,] B ) C_ RR ) $=
      cA cr wcel cB cr wcel wa vx cA cB cicc co cr cA cr wcel cB cr wcel vx cv
      cA cB cicc co wcel vx cv cr wcel cA cr wcel cB cr wcel vx cv cA cB cicc
      co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr cA cr wcel cB
      cr wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a cA cB vx cv elicc2 biimp3a 3simp1d 3expia ssrdv $.
      $( [21-Jan-2008] $) $( [6-Jun-2007] $)

    $( An open interval is a subset of its closure.  (Contributed by Paul
       Chapman, 18-Oct-2007.) $)
    ioossicc $p |- ( A (,) B ) C_ ( A [,] B ) $=
      vx cA cB cioo co cA cB cicc co vx cv cA cB cioo co wcel vx cv cxr wcel cA
      vx cv cle wbr vx cv cB cle wbr wa vx cv cA cB cicc co wcel vx cv cA cB
      cioo co wcel vx cv cr wcel vx cv cxr wcel vx cv cA cB elioore vx cv rexr
      syl vx cv cA cB eliooord vx cv cA cB cioo co wcel vx cv cxr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a vx cv cA cB cicc co wcel vx cv cxr wcel cA
      vx cv cle wbr vx cv cB cle wbr wa wa vx cv cA cB cioo co wcel vx cv cA cB
      cicc co wcel vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv
      cA cB cioo co wcel cA cxr wcel cB cxr wcel wa vx cv cA cB cicc co wcel vx
      cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wb vx cv cA cB eliooxr
      cA cB vx cv elicc1 syl biimprd vx cv cxr wcel cA vx cv cle wbr vx cv cB
      cle wbr 3anass syl5ibr mp2and ssriv $.
      $( [18-Oct-2007] $) $( [18-Oct-2007] $)
  $}

  ${
    $d A y $.  $d B x y $.  $d S x y $.
    $( A nonempty subset of a closed real interval satisfies the conditions for
       the existence of its supremum (see ~ suprcl ).  (Contributed by Paul
       Chapman, 21-Jan-2008.) $)
    iccsupr $p |- ( ( ( A e. RR /\ B e. RR ) /\ S C_ ( A [,] B ) /\ C e. S ) ->
                   ( S C_ RR /\ S =/= (/) /\ E. x e. RR A. y e. S y <_ x ) ) $=
      cA cr wcel cB cr wcel wa cS cA cB cicc co wss cC cS wcel w3a cS cr wss cS
      c0 wne vy cv vx cv cle wbr vy cS wral vx cr wrex cA cr wcel cB cr wcel wa
      cS cA cB cicc co wss cS cr wss cC cS wcel cA cB cicc co cr wss cS cA cB
      cicc co wss cS cr wss cA cr wcel cB cr wcel wa cS cA cB cicc co wss cA cB
      cicc co cr wss cS cr wss cS cA cB cicc co cr sstr ancoms cA cB iccssre
      sylan 3adant3 cC cS wcel cA cr wcel cB cr wcel wa cS c0 wne cS cA cB cicc
      co wss cS cC ne0i 3ad2ant3 cA cr wcel cB cr wcel wa cS cA cB cicc co wss
      vy cv vx cv cle wbr vy cS wral vx cr wrex cC cS wcel cB cr wcel vy cv cB
      cle wbr vy cS wral vy cv vx cv cle wbr vy cS wral vx cr wrex cA cr wcel
      cB cr wcel wa cS cA cB cicc co wss wa vy cv vx cv cle wbr vy cS wral vy
      cv cB cle wbr vy cS wral vx cB cr vx cv cB wceq vy cv vx cv cle wbr vy cv
      cB cle wbr vy cS vx cv cB vy cv cle breq2 ralbidv rcla4ev cA cr wcel cB
      cr wcel cS cA cB cicc co wss simplr cA cr wcel cB cr wcel wa cS cA cB
      cicc co wss wa vy cv cB cle wbr vy cS cA cr wcel cB cr wcel wa cS cA cB
      cicc co wss wa vy cv cS wcel wa vy cv cr wcel cA vy cv cle wbr vy cv cB
      cle wbr cA cr wcel cB cr wcel wa cS cA cB cicc co wss wa vy cv cS wcel vy
      cv cr wcel cA vy cv cle wbr vy cv cB cle wbr w3a cS cA cB cicc co wss vy
      cv cS wcel vy cv cA cB cicc co wcel cA cr wcel cB cr wcel wa vy cv cr
      wcel cA vy cv cle wbr vy cv cB cle wbr w3a cS cA cB cicc co vy cv ssel cA
      cr wcel cB cr wcel wa vy cv cA cB cicc co wcel vy cv cr wcel cA vy cv cle
      wbr vy cv cB cle wbr w3a cA cB vy cv elicc2 biimpd sylan9r imp 3simp3d
      r19.21aiva sylanc 3adant3 3jca $.
      $( [21-Jan-2008] $) $( [21-Jan-2008] $)
  $}

  ${
    $d w x y z A $.
    $( Two ways of saying that a real number is positive. $)
    repos $p |- ( A e. ( 0 (,) +oo ) <-> ( A e. RR /\ 0 < A ) ) $=
      cc0 vx cv clt wbr cc0 cA clt wbr vx cA cr cc0 cpnf cioo co vx cv cA cc0
      clt breq2 vx ioopos elrab2 $.
      $( [9-May-2007] $) $( [7-May-2007] $)

    $( The set of open intervals of extended reals maps to subsets of reals. $)
    ioof $p |- (,) : ( RR* X. RR* ) --> ~P RR $=
      vx vy vz cxr cxr vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab
      cr cpw cioo vx vy vz vw df-ioo vx cv cxr wcel vy cv cxr wcel wa vx cv vw
      cv clt wbr vw cv vy cv clt wbr wa vw cxr crab vx cv vy cv cioo co cr cpw
      vw vx cv vy cv iooval vx cv vy cv cioo co cr cpw wcel vx cv vy cv cioo co
      cr wss vx cv vy cv ioossre vx cv vy cv cioo co cr vx cv vy cv cioo oprex
      elpw mpbir syl6eqelr foprab $.
      $( [12-Feb-2007] $) $( [7-Feb-2007] $)

    $( The set of closed intervals of extended reals maps to subsets of
       extended reals.  (Contributed by FL, 14-Jun-2007.) $)
    iccf $p |- [,] : ( RR* X. RR* ) --> ~P RR* $=
      vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr crab cxr cpw wcel vy
      cxr wral vx cxr wral cxr cxr cxp cxr cpw cicc wf vx cv vw cv cle wbr vw
      cv vy cv cle wbr wa vw cxr crab cxr cpw wcel vx vy cxr vx cv cxr wcel vy
      cv cxr wcel wa vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr crab cxr
      wss vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr crab cxr cpw wcel
      vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr crab cxr wss vx cv cxr
      wcel vy cv cxr wcel wa vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr
      ssrab2 a1i vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr crab cxr vx
      cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr xrex rabex elpw sylibr
      rgen2a vx vy vz cxr cxr vx cv vw cv cle wbr vw cv vy cv cle wbr wa vw cxr
      crab cxr cpw cicc vx vy vz vw df-icc foprab2 mpbi $.
      $( [21-Sep-2007] $) $( [14-Jun-2007] $)

    $( The union of the range of the open interval function. $)
    unirnioo $p |- U. ran (,) = RR $=
      cioo crn cuni cr cioo crn cuni cr cpw cuni cr cioo crn cr cpw wss cioo
      crn cuni cr cpw cuni wss cxr cxr cxp cr cpw cioo wf cioo crn cr cpw wss
      ioof cxr cxr cxp cr cpw cioo frn ax-mp cioo crn cr cpw uniss ax-mp cr
      unipw sseqtri cr cioo crn wcel cr cioo crn cuni wss cmnf cpnf cioo co cr
      cioo crn ioomax cioo cxr cxr cxp wfn cmnf cxr wcel cpnf cxr wcel cmnf
      cpnf cioo co cioo crn wcel cxr cxr cxp cr cpw cioo wf cioo cxr cxr cxp
      wfn ioof cxr cxr cxp cr cpw cioo ffn ax-mp mnfxr pnfxr cxr cxr cmnf cpnf
      cioo fnoprvrn mp3an eqeltrri cr cioo crn elssuni ax-mp eqssi $.
      $( [7-May-2007] $) $( [7-May-2007] $)

    $( Alternate definition of the set of open intervals of extended reals. $)
    dfioo2 $p |- (,) = { <. <. x , y >. , z >. | ( ( x e. RR* /\ y e. RR* )
                   /\ z = { w e. RR | ( x < w /\ w < y ) } ) } $=
      cioo vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vy cv cioo co wceq wa
      vx vy vz copab2 vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt
      wbr vw cv vy cv clt wbr wa vw cr crab wceq wa vx vy vz copab2 cioo cxr
      cxr cxp wfn cioo vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vy cv cioo
      co wceq wa vx vy vz copab2 wceq cxr cxr cxp cr cpw cioo wf cioo cxr cxr
      cxp wfn ioof cxr cxr cxp cr cpw cioo ffn ax-mp vx vy vz cxr cxr cioo
      fnoprv mpbi vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vy cv cioo co
      wceq wa vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv
      vy cv clt wbr wa vw cr crab wceq wa vx vy vz vx cv cxr wcel vy cv cxr
      wcel wa vz cv vx cv vy cv cioo co wceq vz cv vx cv vw cv clt wbr vw cv vy
      cv clt wbr wa vw cr crab wceq vx cv cxr wcel vy cv cxr wcel wa vx cv vy
      cv cioo co vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cr crab vz cv vw
      vx cv vy cv iooval2 eqeq2d pm5.32i oprabbii eqtri $.
      $( [6-Mar-2007] $) $( [1-Mar-2007] $)
  $}

  $( The lower bound of a closed interval is a member of it.  (Contributed by
     Paul Chapman, 26-Nov-2007.) $)
  lbicc2 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) -> A e. ( A [,] B ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr w3a cA cA cB cicc co wcel cA cr wcel cA
    cA cle wbr cA cB cle wbr w3a cA cr wcel cB cr wcel cA cB cle wbr w3a cA cr
    wcel cA cA cle wbr cA cB cle wbr cA cr wcel cB cr wcel cA cB cle wbr 3simp1
    cA cr wcel cB cr wcel cA cA cle wbr cA cB cle wbr cA leid 3ad2ant1 cA cr
    wcel cB cr wcel cA cB cle wbr 3simp3 3jca cA cr wcel cB cr wcel cA cA cB
    cicc co wcel cA cr wcel cA cA cle wbr cA cB cle wbr w3a wb cA cB cle wbr cA
    cB cA elicc2 3adant3 mpbird $.
    $( [26-Nov-2007] $) $( [26-Nov-2007] $)

  $( The upper bound of a closed interval is a member of it.  (Contributed by
     Paul Chapman, 26-Nov-2007.) $)
  ubicc2 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) -> B e. ( A [,] B ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr w3a cB cA cB cicc co wcel cB cr wcel cA
    cB cle wbr cB cB cle wbr w3a cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr
    wcel cA cB cle wbr cB cB cle wbr cA cr wcel cB cr wcel cA cB cle wbr 3simp2
    cA cr wcel cB cr wcel cA cB cle wbr 3simp3 cB cr wcel cA cr wcel cB cB cle
    wbr cA cB cle wbr cB leid 3ad2ant2 3jca cA cr wcel cB cr wcel cB cA cB cicc
    co wcel cB cr wcel cA cB cle wbr cB cB cle wbr w3a wb cA cB cle wbr cA cB
    cB elicc2 3adant3 mpbird $.
    $( [26-Nov-2007] $) $( [26-Nov-2007] $)

  $( Membership in a negated open real interval.  (Contributed by Paul
     Chapman, 26-Nov-2007.) $)
  iooneg $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( C e. ( A (,) B ) <-> -u C e. ( -u B (,) -u A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cC clt wbr cC cB clt wbr wa cB cneg
    cC cneg clt wbr cC cneg cA cneg clt wbr wa cC cA cB cioo co wcel cC cneg cB
    cneg cA cneg cioo co wcel cA cr wcel cB cr wcel cC cr wcel w3a cA cC clt
    wbr cC cB clt wbr wa cC cneg cA cneg clt wbr cB cneg cC cneg clt wbr wa cB
    cneg cC cneg clt wbr cC cneg cA cneg clt wbr wa cA cr wcel cB cr wcel cC cr
    wcel w3a cA cC clt wbr cC cneg cA cneg clt wbr cC cB clt wbr cB cneg cC
    cneg clt wbr cA cr wcel cC cr wcel cA cC clt wbr cC cneg cA cneg clt wbr wb
    cB cr wcel cA cC ltneg 3adant2 cB cr wcel cC cr wcel cC cB clt wbr cB cneg
    cC cneg clt wbr wb cA cr wcel cC cr wcel cB cr wcel cC cB clt wbr cB cneg
    cC cneg clt wbr wb cC cB ltneg ancoms 3adant1 anbi12d cC cneg cA cneg clt
    wbr cB cneg cC cneg clt wbr ancom syl6bb cA cxr wcel cB cxr wcel cC cxr
    wcel cC cA cB cioo co wcel cA cC clt wbr cC cB clt wbr wa wb cA cr wcel cB
    cr wcel cC cr wcel cA cB cC elioo5 cA rexr cB rexr cC rexr syl3an cB cr
    wcel cA cr wcel cC cr wcel cC cneg cB cneg cA cneg cioo co wcel cB cneg cC
    cneg clt wbr cC cneg cA cneg clt wbr wa wb cB cneg cr wcel cA cneg cr wcel
    cC cneg cr wcel cC cneg cB cneg cA cneg cioo co wcel cB cneg cC cneg clt
    wbr cC cneg cA cneg clt wbr wa wb cB cr wcel cA cr wcel cC cr wcel cB cneg
    cxr wcel cA cneg cxr wcel cC cneg cxr wcel cC cneg cB cneg cA cneg cioo co
    wcel cB cneg cC cneg clt wbr cC cneg cA cneg clt wbr wa wb cB cneg cr wcel
    cA cneg cr wcel cC cneg cr wcel cB cneg cA cneg cC cneg elioo5 cB cneg rexr
    cA cneg rexr cC cneg rexr syl3an cB renegcl cA renegcl cC renegcl syl3an
    3com12 3bitr4d $.
    $( [26-Nov-2007] $) $( [26-Nov-2007] $)

  $( Membership in a negated closed real interval.  (Contributed by Paul
     Chapman, 26-Nov-2007.) $)
  iccneg $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( C e. ( A [,] B ) <-> -u C e. ( -u B [,] -u A ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cC cr wcel cA cC cle wbr cC cB cle wbr
    wa wa cC cneg cr wcel cB cneg cC cneg cle wbr cC cneg cA cneg cle wbr wa wa
    cC cA cB cicc co wcel cC cneg cB cneg cA cneg cicc co wcel cA cr wcel cB cr
    wcel cC cr wcel w3a cC cr wcel cC cneg cr wcel cA cC cle wbr cC cB cle wbr
    wa cB cneg cC cneg cle wbr cC cneg cA cneg cle wbr wa cC cr wcel cA cr wcel
    cC cr wcel cC cneg cr wcel wb cB cr wcel cC cr wcel cC cr wcel cC cneg cr
    wcel cC renegcl cC cr wcel cC cneg cr wcel ax-1 impbid2 3ad2ant3 cA cr wcel
    cB cr wcel cC cr wcel w3a cC cB cle wbr cA cC cle wbr wa cB cneg cC cneg
    cle wbr cC cneg cA cneg cle wbr wa cA cC cle wbr cC cB cle wbr wa cA cr
    wcel cB cr wcel cC cr wcel w3a cC cB cle wbr cB cneg cC cneg cle wbr cA cC
    cle wbr cC cneg cA cneg cle wbr cB cr wcel cC cr wcel cC cB cle wbr cB cneg
    cC cneg cle wbr wb cA cr wcel cC cr wcel cB cr wcel cC cB cle wbr cB cneg
    cC cneg cle wbr wb cC cB leneg ancoms 3adant1 cA cr wcel cC cr wcel cA cC
    cle wbr cC cneg cA cneg cle wbr wb cB cr wcel cA cC leneg 3adant2 anbi12d
    cC cB cle wbr cA cC cle wbr ancom syl5bbr anbi12d cA cr wcel cB cr wcel cC
    cr wcel w3a cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr
    w3a cC cr wcel cA cC cle wbr cC cB cle wbr wa wa cA cr wcel cB cr wcel cC
    cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb cC cr wcel
    cA cB cC elicc2 3adant3 cC cr wcel cA cC cle wbr cC cB cle wbr 3anass
    syl6bb cA cr wcel cB cr wcel cC cr wcel w3a cC cneg cB cneg cA cneg cicc co
    wcel cC cneg cr wcel cB cneg cC cneg cle wbr cC cneg cA cneg cle wbr w3a cC
    cneg cr wcel cB cneg cC cneg cle wbr cC cneg cA cneg cle wbr wa wa cA cr
    wcel cB cr wcel cC cneg cB cneg cA cneg cicc co wcel cC cneg cr wcel cB
    cneg cC cneg cle wbr cC cneg cA cneg cle wbr w3a wb cC cr wcel cA cr wcel
    cB cr wcel wa cB cneg cr wcel cA cneg cr wcel wa cC cneg cB cneg cA cneg
    cicc co wcel cC cneg cr wcel cB cneg cC cneg cle wbr cC cneg cA cneg cle
    wbr w3a wb cB cr wcel cA cr wcel cB cneg cr wcel cA cneg cr wcel wa cB cr
    wcel cB cneg cr wcel cA cr wcel cA cneg cr wcel cB renegcl cA renegcl
    anim12i ancoms cB cneg cA cneg cC cneg elicc2 syl 3adant3 cC cneg cr wcel
    cB cneg cC cneg cle wbr cC cneg cA cneg cle wbr 3anass syl6bb 3bitr4d $.
    $( [26-Nov-2007] $) $( [26-Nov-2007] $)

  $( A shifted real is a member of a shifted, closed-below, open-above real
     interval.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
  icoshft $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) -> ( X e. ( A [,) B ) ->
                  ( X + C ) e. ( ( A + C ) [,) ( B + C ) ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cX cA cB cico co wcel cX cr wcel cA cX
    cle wbr cX cB clt wbr wa wa cX cC caddc co cA cC caddc co cB cC caddc co
    cico co wcel cA cr wcel cB cr wcel cC cr wcel w3a cX cA cB cico co wcel cX
    cr wcel cA cX cle wbr cX cB clt wbr w3a cX cr wcel cA cX cle wbr cX cB clt
    wbr wa wa cA cr wcel cB cr wcel cX cA cB cico co wcel cX cr wcel cA cX cle
    wbr cX cB clt wbr w3a wi cC cr wcel cA cr wcel cB cr wcel wa cX cA cB cico
    co wcel cX cr wcel cA cX cle wbr cX cB clt wbr w3a cA cB cX elico2 biimpd
    3adant3 cX cr wcel cA cX cle wbr cX cB clt wbr 3anass syl6ib cA cr wcel cB
    cr wcel cC cr wcel w3a cX cr wcel cA cX cle wbr cX cB clt wbr wa wa cX cr
    wcel cA cC caddc co cX cC caddc co cle wbr cX cC caddc co cB cC caddc co
    clt wbr wa wa cX cC caddc co cA cC caddc co cB cC caddc co cico co wcel cA
    cr wcel cB cr wcel cC cr wcel w3a cX cr wcel cA cX cle wbr cX cB clt wbr wa
    cA cC caddc co cX cC caddc co cle wbr cX cC caddc co cB cC caddc co clt wbr
    wa cA cr wcel cB cr wcel cC cr wcel w3a cX cr wcel wa cA cX cle wbr cA cC
    caddc co cX cC caddc co cle wbr cX cB clt wbr cX cC caddc co cB cC caddc co
    clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cX cr wcel cA cX cle wbr cA cC
    caddc co cX cC caddc co cle wbr wb cA cr wcel cC cr wcel cX cr wcel cA cX
    cle wbr cA cC caddc co cX cC caddc co cle wbr wb wi cB cr wcel cX cr wcel
    cA cr wcel cC cr wcel wa cA cX cle wbr cA cC caddc co cX cC caddc co cle
    wbr wb cX cr wcel cA cr wcel cC cr wcel cA cX cle wbr cA cC caddc co cX cC
    caddc co cle wbr wb cA cr wcel cX cr wcel cC cr wcel cA cX cle wbr cA cC
    caddc co cX cC caddc co cle wbr wb cA cX cC leadd1 3com12 3expib com12
    3adant2 imp cA cr wcel cB cr wcel cC cr wcel w3a cX cr wcel cX cB clt wbr
    cX cC caddc co cB cC caddc co clt wbr wb cB cr wcel cC cr wcel cX cr wcel
    cX cB clt wbr cX cC caddc co cB cC caddc co clt wbr wb wi cA cr wcel cX cr
    wcel cB cr wcel cC cr wcel wa cX cB clt wbr cX cC caddc co cB cC caddc co
    clt wbr wb cX cr wcel cB cr wcel cC cr wcel cX cB clt wbr cX cC caddc co cB
    cC caddc co clt wbr wb cX cB cC ltadd1 3expib com12 3adant1 imp anbi12d
    pm5.32da cA cr wcel cB cr wcel cC cr wcel w3a cX cr wcel cA cC caddc co cX
    cC caddc co cle wbr cX cC caddc co cB cC caddc co clt wbr wa wa cX cC caddc
    co cr wcel cA cC caddc co cX cC caddc co cle wbr cX cC caddc co cB cC caddc
    co clt wbr w3a cX cC caddc co cA cC caddc co cB cC caddc co cico co wcel cC
    cr wcel cA cr wcel cX cr wcel cA cC caddc co cX cC caddc co cle wbr cX cC
    caddc co cB cC caddc co clt wbr wa wa cX cC caddc co cr wcel cA cC caddc co
    cX cC caddc co cle wbr cX cC caddc co cB cC caddc co clt wbr w3a wi cB cr
    wcel cC cr wcel cX cr wcel cA cC caddc co cX cC caddc co cle wbr cX cC
    caddc co cB cC caddc co clt wbr wa wa cX cC caddc co cr wcel cA cC caddc co
    cX cC caddc co cle wbr cX cC caddc co cB cC caddc co clt wbr wa wa cX cC
    caddc co cr wcel cA cC caddc co cX cC caddc co cle wbr cX cC caddc co cB cC
    caddc co clt wbr w3a cC cr wcel cX cr wcel cX cC caddc co cr wcel cA cC
    caddc co cX cC caddc co cle wbr cX cC caddc co cB cC caddc co clt wbr wa cX
    cr wcel cC cr wcel cX cC caddc co cr wcel cX cC readdcl expcom anim1d cX cC
    caddc co cr wcel cA cC caddc co cX cC caddc co cle wbr cX cC caddc co cB cC
    caddc co clt wbr 3anass syl6ibr 3ad2ant3 cA cC caddc co cr wcel cB cC caddc
    co cr wcel cX cC caddc co cr wcel cA cC caddc co cX cC caddc co cle wbr cX
    cC caddc co cB cC caddc co clt wbr w3a cX cC caddc co cA cC caddc co cB cC
    caddc co cico co wcel wi cA cr wcel cB cr wcel cC cr wcel w3a cA cC caddc
    co cr wcel cB cC caddc co cr wcel wa cX cC caddc co cA cC caddc co cB cC
    caddc co cico co wcel cX cC caddc co cr wcel cA cC caddc co cX cC caddc co
    cle wbr cX cC caddc co cB cC caddc co clt wbr w3a cA cC caddc co cB cC
    caddc co cX cC caddc co elico2 biimprd cA cr wcel cC cr wcel cA cC caddc co
    cr wcel cB cr wcel cA cC readdcl 3adant2 cB cr wcel cC cr wcel cB cC caddc
    co cr wcel cA cr wcel cB cC readdcl 3adant1 sylanc syld sylbid syld $.
    $( [26-Mar-2008] $) $( [25-Mar-2008] $)

  ${
    $d A x y $.  $d B x y $.  $d C x y $.
    icoshftf1o.1 $e |- F = { <. x , y >. | ( x e. ( A [,) B ) /\
                              y = ( x + C ) ) } $.

    ${
      $d A w z $.  $d B w z $.  $d C w z $.  $d F w z $.  $d w x y z $.
      icoshftf1o.2 $e |- A e. RR $.
      icoshftf1o.3 $e |- B e. RR $.
      icoshftf1o.4 $e |- C e. RR $.
      $( Shifting a closed-below, open-above interval is one-to-one onto.
        (Contributed by Paul Chapman, 25-Mar-2008.) $)
      icoshftf1oii $p |- F : ( A [,) B ) -1-1-onto->
                          ( ( A + C ) [,) ( B + C ) ) $=
        cA cB cico co cA cC caddc co cB cC caddc co cico co cF wf1o cA cB cico
        co cA cC caddc co cB cC caddc co cico co cF wf1 cA cB cico co cA cC
        caddc co cB cC caddc co cico co cF wfo cA cB cico co cA cC caddc co cB
        cC caddc co cico co cF df-f1o cA cB cico co cA cC caddc co cB cC caddc
        co cico co cF wf1 cA cB cico co cA cC caddc co cB cC caddc co cico co
        cF wf vz cv cF cfv vw cv cF cfv wceq vz cv vw cv wceq wi vw cA cB cico
        co wral vz cA cB cico co wral vz vw cA cB cico co cA cC caddc co cB cC
        caddc co cico co cF dff13 vx vy cA cB cico co cA cC caddc co cB cC
        caddc co cico co vx cv cC caddc co cF icoshftf1o.1 cA cr wcel cB cr
        wcel cC cr wcel vx cv cA cB cico co wcel vx cv cC caddc co cA cC caddc
        co cB cC caddc co cico co wcel wi icoshftf1o.2 icoshftf1o.3
        icoshftf1o.4 cA cB cC vx cv icoshft mp3an fopab vz cv cF cfv vw cv cF
        cfv wceq vz cv vw cv wceq wi vz vw cA cB cico co vz cv cA cB cico co
        wcel vw cv cA cB cico co wcel wa vz cv cF cfv vw cv cF cfv wceq vz cv
        cC caddc co vw cv cC caddc co wceq vz cv vw cv wceq vz cv cA cB cico co
        wcel vw cv cA cB cico co wcel vz cv cF cfv vz cv cC caddc co vw cv cF
        cfv vw cv cC caddc co vx vy vz cv vx cv cC caddc co vz cv cC caddc co
        cA cB cico co cF vx cv vz cv cC caddc opreq1 icoshftf1o.1 vz cv cC
        caddc oprex fvopab4 vx vy vw cv vx cv cC caddc co vw cv cC caddc co cA
        cB cico co cF vx cv vw cv cC caddc opreq1 icoshftf1o.1 vw cv cC caddc
        oprex fvopab4 eqeqan12d vz cv cc wcel vw cv cc wcel vz cv cC caddc co
        vw cv cC caddc co wceq vz cv vw cv wceq wi vz cv cA cB cico co wcel vw
        cv cA cB cico co wcel vz cv cc wcel vw cv cc wcel wa vz cv cC caddc co
        vw cv cC caddc co wceq vz cv vw cv wceq vz cv cc wcel vw cv cc wcel cC
        cc wcel vz cv cC caddc co vw cv cC caddc co wceq vz cv vw cv wceq wb cC
        icoshftf1o.4 recni vz cv vw cv cC addcan2 mp3an3 biimpd vz cv cA cB
        cico co wcel vz cv vz cv cA cB cico co wcel vz cv cr wcel cA vz cv cle
        wbr vz cv cB clt wbr vz cv cA cB cico co wcel vz cv cr wcel cA vz cv
        cle wbr vz cv cB clt wbr w3a cA cr wcel cB cr wcel vz cv cA cB cico co
        wcel vz cv cr wcel cA vz cv cle wbr vz cv cB clt wbr w3a wb
        icoshftf1o.2 icoshftf1o.3 cA cB vz cv elico2 mp2an biimpi 3simp1d recnd
        vw cv cA cB cico co wcel vw cv vw cv cA cB cico co wcel vw cv cr wcel
        cA vw cv cle wbr vw cv cB clt wbr vw cv cA cB cico co wcel vw cv cr
        wcel cA vw cv cle wbr vw cv cB clt wbr w3a cA cr wcel cB cr wcel vw cv
        cA cB cico co wcel vw cv cr wcel cA vw cv cle wbr vw cv cB clt wbr w3a
        wb icoshftf1o.2 icoshftf1o.3 cA cB vw cv elico2 mp2an biimpi 3simp1d
        recnd syl2an sylbid rgen2a mpbir2an cA cB cico co cA cC caddc co cB cC
        caddc co cico co cF wfo cA cB cico co cA cC caddc co cB cC caddc co
        cico co cF wf vz cv vw cv cF cfv wceq vw cA cB cico co wrex vz cA cC
        caddc co cB cC caddc co cico co wral vw vz cA cB cico co cA cC caddc co
        cB cC caddc co cico co cF dffo3 vx vy cA cB cico co cA cC caddc co cB
        cC caddc co cico co vx cv cC caddc co cF icoshftf1o.1 cA cr wcel cB cr
        wcel cC cr wcel vx cv cA cB cico co wcel vx cv cC caddc co cA cC caddc
        co cB cC caddc co cico co wcel wi icoshftf1o.2 icoshftf1o.3
        icoshftf1o.4 cA cB cC vx cv icoshft mp3an fopab vz cv vw cv cF cfv wceq
        vw cA cB cico co wrex vz cA cC caddc co cB cC caddc co cico co vz cv cC
        cmin co cA cB cico co wcel vz cv vz cv cC cmin co cF cfv wceq vz cv vw
        cv cF cfv wceq vw cA cB cico co wrex vz cv cA cC caddc co cB cC caddc
        co cico co wcel vz cv vw cv cF cfv wceq vz cv vz cv cC cmin co cF cfv
        wceq vw vz cv cC cmin co cA cB cico co vw cv vz cv cC cmin co wceq vw
        cv cF cfv vz cv cC cmin co cF cfv vz cv vw cv vz cv cC cmin co cF fveq2
        eqeq2d rcla4ev vz cv cA cC caddc co cB cC caddc co cico co wcel vz cv
        cC cneg caddc co vz cv cC cmin co cA cB cico co vz cv cA cC caddc co cB
        cC caddc co cico co wcel vz cv cr wcel vz cv cc wcel vz cv cC cneg
        caddc co vz cv cC cmin co wceq vz cv cA cC caddc co cB cC caddc co cico
        co wcel vz cv cr wcel cA cC caddc co vz cv cle wbr vz cv cB cC caddc co
        clt wbr vz cv cA cC caddc co cB cC caddc co cico co wcel vz cv cr wcel
        cA cC caddc co vz cv cle wbr vz cv cB cC caddc co clt wbr w3a cA cC
        caddc co cr wcel cB cC caddc co cr wcel vz cv cA cC caddc co cB cC
        caddc co cico co wcel vz cv cr wcel cA cC caddc co vz cv cle wbr vz cv
        cB cC caddc co clt wbr w3a wb cA cC icoshftf1o.2 icoshftf1o.4 readdcli
        cB cC icoshftf1o.3 icoshftf1o.4 readdcli cA cC caddc co cB cC caddc co
        vz cv elico2 mp2an biimpi 3simp1d vz cv recn vz cv cc wcel cC cc wcel
        vz cv cC cneg caddc co vz cv cC cmin co wceq cC icoshftf1o.4 recni vz
        cv cC negsub mpan2 3syl vz cv cA cC caddc co cB cC caddc co cico co
        wcel vz cv cC cneg caddc co cA cC caddc co cC cneg caddc co cB cC caddc
        co cC cneg caddc co cico co cA cB cico co cA cC caddc co cr wcel cB cC
        caddc co cr wcel cC cneg cr wcel vz cv cA cC caddc co cB cC caddc co
        cico co wcel vz cv cC cneg caddc co cA cC caddc co cC cneg caddc co cB
        cC caddc co cC cneg caddc co cico co wcel wi cA cC icoshftf1o.2
        icoshftf1o.4 readdcli cB cC icoshftf1o.3 icoshftf1o.4 readdcli cC
        icoshftf1o.4 renegcli cA cC caddc co cB cC caddc co cC cneg vz cv
        icoshft mp3an cA cC caddc co cC cneg caddc co cA cB cC caddc co cC cneg
        caddc co cB cico cA cC caddc co cC cneg caddc co cA cC caddc co cC cmin
        co cA cA cC caddc co cC cA cC caddc co cA cC icoshftf1o.2 icoshftf1o.4
        readdcli recni cC icoshftf1o.4 recni negsubi cA cc wcel cC cc wcel cA
        cC caddc co cC cmin co cA wceq cA icoshftf1o.2 recni cC icoshftf1o.4
        recni cA cC pncan mp2an eqtri cB cC caddc co cC cneg caddc co cB cC
        caddc co cC cmin co cB cB cC caddc co cC cB cC caddc co cB cC
        icoshftf1o.3 icoshftf1o.4 readdcli recni cC icoshftf1o.4 recni negsubi
        cB cc wcel cC cc wcel cB cC caddc co cC cmin co cB wceq cB icoshftf1o.3
        recni cC icoshftf1o.4 recni cB cC pncan mp2an eqtri opreq12i syl6eleq
        eqeltrrd vz cv cA cC caddc co cB cC caddc co cico co wcel vz cv cC cmin
        co cF cfv vz cv cC cmin co cC caddc co vz cv vz cv cA cC caddc co cB cC
        caddc co cico co wcel vz cv cC cmin co cA cB cico co wcel vz cv cC cmin
        co cF cfv vz cv cC cmin co cC caddc co wceq vz cv cA cC caddc co cB cC
        caddc co cico co wcel vz cv cC cneg caddc co vz cv cC cmin co cA cB
        cico co vz cv cA cC caddc co cB cC caddc co cico co wcel vz cv cr wcel
        vz cv cc wcel vz cv cC cneg caddc co vz cv cC cmin co wceq vz cv cA cC
        caddc co cB cC caddc co cico co wcel vz cv cr wcel cA cC caddc co vz cv
        cle wbr vz cv cB cC caddc co clt wbr vz cv cA cC caddc co cB cC caddc
        co cico co wcel vz cv cr wcel cA cC caddc co vz cv cle wbr vz cv cB cC
        caddc co clt wbr w3a cA cC caddc co cr wcel cB cC caddc co cr wcel vz
        cv cA cC caddc co cB cC caddc co cico co wcel vz cv cr wcel cA cC caddc
        co vz cv cle wbr vz cv cB cC caddc co clt wbr w3a wb cA cC icoshftf1o.2
        icoshftf1o.4 readdcli cB cC icoshftf1o.3 icoshftf1o.4 readdcli cA cC
        caddc co cB cC caddc co vz cv elico2 mp2an biimpi 3simp1d vz cv recn vz
        cv cc wcel cC cc wcel vz cv cC cneg caddc co vz cv cC cmin co wceq cC
        icoshftf1o.4 recni vz cv cC negsub mpan2 3syl vz cv cA cC caddc co cB
        cC caddc co cico co wcel vz cv cC cneg caddc co cA cC caddc co cC cneg
        caddc co cB cC caddc co cC cneg caddc co cico co cA cB cico co cA cC
        caddc co cr wcel cB cC caddc co cr wcel cC cneg cr wcel vz cv cA cC
        caddc co cB cC caddc co cico co wcel vz cv cC cneg caddc co cA cC caddc
        co cC cneg caddc co cB cC caddc co cC cneg caddc co cico co wcel wi cA
        cC icoshftf1o.2 icoshftf1o.4 readdcli cB cC icoshftf1o.3 icoshftf1o.4
        readdcli cC icoshftf1o.4 renegcli cA cC caddc co cB cC caddc co cC cneg
        vz cv icoshft mp3an cA cC caddc co cC cneg caddc co cA cB cC caddc co
        cC cneg caddc co cB cico cA cC caddc co cC cneg caddc co cA cC caddc co
        cC cmin co cA cA cC caddc co cC cA cC caddc co cA cC icoshftf1o.2
        icoshftf1o.4 readdcli recni cC icoshftf1o.4 recni negsubi cA cc wcel cC
        cc wcel cA cC caddc co cC cmin co cA wceq cA icoshftf1o.2 recni cC
        icoshftf1o.4 recni cA cC pncan mp2an eqtri cB cC caddc co cC cneg caddc
        co cB cC caddc co cC cmin co cB cB cC caddc co cC cB cC caddc co cB cC
        icoshftf1o.3 icoshftf1o.4 readdcli recni cC icoshftf1o.4 recni negsubi
        cB cc wcel cC cc wcel cB cC caddc co cC cmin co cB wceq cB icoshftf1o.3
        recni cC icoshftf1o.4 recni cB cC pncan mp2an eqtri opreq12i syl6eleq
        eqeltrrd vx vy vz cv cC cmin co vx cv cC caddc co vz cv cC cmin co cC
        caddc co cA cB cico co cF vx cv vz cv cC cmin co cC caddc opreq1
        icoshftf1o.1 vz cv cC cmin co cC caddc oprex fvopab4 syl vz cv cA cC
        caddc co cB cC caddc co cico co wcel vz cv cr wcel vz cv cc wcel vz cv
        cC cmin co cC caddc co vz cv wceq vz cv cA cC caddc co cB cC caddc co
        cico co wcel vz cv cr wcel cA cC caddc co vz cv cle wbr vz cv cB cC
        caddc co clt wbr vz cv cA cC caddc co cB cC caddc co cico co wcel vz cv
        cr wcel cA cC caddc co vz cv cle wbr vz cv cB cC caddc co clt wbr w3a
        cA cC caddc co cr wcel cB cC caddc co cr wcel vz cv cA cC caddc co cB
        cC caddc co cico co wcel vz cv cr wcel cA cC caddc co vz cv cle wbr vz
        cv cB cC caddc co clt wbr w3a wb cA cC icoshftf1o.2 icoshftf1o.4
        readdcli cB cC icoshftf1o.3 icoshftf1o.4 readdcli cA cC caddc co cB cC
        caddc co vz cv elico2 mp2an biimpi 3simp1d vz cv recn vz cv cc wcel cC
        cc wcel vz cv cC cmin co cC caddc co vz cv wceq cC icoshftf1o.4 recni
        vz cv cC npcan mpan2 3syl eqtr2d sylanc rgen mpbir2an mpbir2an $.
        $( [26-Mar-2008] $) $( [25-Mar-2008] $)
    $}

    ${
      icoshftf1olem.1 $e |- G = { <. x , y >. |
          ( x e. ( if ( A e. RR , A , 0 ) [,) if ( B e. RR , B , 0 ) ) /\
            y = ( x + if ( C e. RR , C , 0 ) ) ) } $.
      $( Lemma for ~ icoshftf1o . $)
      icoshftf1olem $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  F : ( A [,) B ) -1-1-onto-> ( ( A + C ) [,) ( B + C ) ) ) $=
        cA cr wcel cB cr wcel cC cr wcel w3a cA cB cico co cA cC caddc co cB cC
        caddc co cico co cG wf1o cA cB cico co cA cC caddc co cB cC caddc co
        cico co cF wf1o cA cr wcel cB cr wcel cC cr wcel cA cB cico co cA cC
        caddc co cB cC caddc co cico co cG wf1o cA cr wcel cA cc0 cif cB cico
        co cA cr wcel cA cc0 cif cC caddc co cB cC caddc co cico co cG wf1o cA
        cB cC cc0 cc0 cc0 cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co
        cA cr wcel cA cc0 cif cC caddc co cB cr wcel cB cc0 cif cC caddc co
        cico co cG wf1o cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cA
        cr wcel cA cc0 cif cC cr wcel cC cc0 cif caddc co cB cr wcel cB cc0 cif
        cC cr wcel cC cc0 cif caddc co cico co cG wf1o cA cA cr wcel cA cc0 cif
        wceq cA cB cico co cA cC caddc co cB cC caddc co cico co cG wf1o cA cr
        wcel cA cc0 cif cB cico co cA cC caddc co cB cC caddc co cico co cG
        wf1o cA cr wcel cA cc0 cif cB cico co cA cr wcel cA cc0 cif cC caddc co
        cB cC caddc co cico co cG wf1o cA cA cr wcel cA cc0 cif wceq cA cB cico
        co cA cr wcel cA cc0 cif cB cico co wceq cA cB cico co cA cC caddc co
        cB cC caddc co cico co cG wf1o cA cr wcel cA cc0 cif cB cico co cA cC
        caddc co cB cC caddc co cico co cG wf1o wb cA cA cr wcel cA cc0 cif cB
        cico opreq1 cA cB cico co cA cr wcel cA cc0 cif cB cico co cA cC caddc
        co cB cC caddc co cico co cG f1oeq2 syl cA cA cr wcel cA cc0 cif wceq
        cA cC caddc co cB cC caddc co cico co cA cr wcel cA cc0 cif cC caddc co
        cB cC caddc co cico co wceq cA cr wcel cA cc0 cif cB cico co cA cC
        caddc co cB cC caddc co cico co cG wf1o cA cr wcel cA cc0 cif cB cico
        co cA cr wcel cA cc0 cif cC caddc co cB cC caddc co cico co cG wf1o wb
        cA cA cr wcel cA cc0 cif wceq cA cC caddc co cA cr wcel cA cc0 cif cC
        caddc co cB cC caddc co cico cA cA cr wcel cA cc0 cif cC caddc opreq1
        opreq1d cA cC caddc co cB cC caddc co cico co cA cr wcel cA cc0 cif cC
        caddc co cB cC caddc co cico co cA cr wcel cA cc0 cif cB cico co cG
        f1oeq3 syl bitrd cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB
        cico co cA cr wcel cA cc0 cif cC caddc co cB cC caddc co cico co cG
        wf1o cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cA cr wcel cA
        cc0 cif cC caddc co cB cC caddc co cico co cG wf1o cA cr wcel cA cc0
        cif cB cr wcel cB cc0 cif cico co cA cr wcel cA cc0 cif cC caddc co cB
        cr wcel cB cc0 cif cC caddc co cico co cG wf1o cB cB cr wcel cB cc0 cif
        wceq cA cr wcel cA cc0 cif cB cico co cA cr wcel cA cc0 cif cB cr wcel
        cB cc0 cif cico co wceq cA cr wcel cA cc0 cif cB cico co cA cr wcel cA
        cc0 cif cC caddc co cB cC caddc co cico co cG wf1o cA cr wcel cA cc0
        cif cB cr wcel cB cc0 cif cico co cA cr wcel cA cc0 cif cC caddc co cB
        cC caddc co cico co cG wf1o wb cB cB cr wcel cB cc0 cif cA cr wcel cA
        cc0 cif cico opreq2 cA cr wcel cA cc0 cif cB cico co cA cr wcel cA cc0
        cif cB cr wcel cB cc0 cif cico co cA cr wcel cA cc0 cif cC caddc co cB
        cC caddc co cico co cG f1oeq2 syl cB cB cr wcel cB cc0 cif wceq cA cr
        wcel cA cc0 cif cC caddc co cB cC caddc co cico co cA cr wcel cA cc0
        cif cC caddc co cB cr wcel cB cc0 cif cC caddc co cico co wceq cA cr
        wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cA cr wcel cA cc0 cif cC
        caddc co cB cC caddc co cico co cG wf1o cA cr wcel cA cc0 cif cB cr
        wcel cB cc0 cif cico co cA cr wcel cA cc0 cif cC caddc co cB cr wcel cB
        cc0 cif cC caddc co cico co cG wf1o wb cB cB cr wcel cB cc0 cif wceq cB
        cC caddc co cB cr wcel cB cc0 cif cC caddc co cA cr wcel cA cc0 cif cC
        caddc co cico cB cB cr wcel cB cc0 cif cC caddc opreq1 opreq2d cA cr
        wcel cA cc0 cif cC caddc co cB cC caddc co cico co cA cr wcel cA cc0
        cif cC caddc co cB cr wcel cB cc0 cif cC caddc co cico co cA cr wcel cA
        cc0 cif cB cr wcel cB cc0 cif cico co cG f1oeq3 syl bitrd cC cC cr wcel
        cC cc0 cif wceq cA cr wcel cA cc0 cif cC caddc co cB cr wcel cB cc0 cif
        cC caddc co cico co cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif caddc
        co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif caddc co cico co wceq cA
        cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cA cr wcel cA cc0 cif
        cC caddc co cB cr wcel cB cc0 cif cC caddc co cico co cG wf1o cA cr
        wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cA cr wcel cA cc0 cif cC
        cr wcel cC cc0 cif caddc co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif
        caddc co cico co cG wf1o wb cC cC cr wcel cC cc0 cif wceq cA cr wcel cA
        cc0 cif cC caddc co cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif caddc
        co cB cr wcel cB cc0 cif cC caddc co cB cr wcel cB cc0 cif cC cr wcel
        cC cc0 cif caddc co cico cC cC cr wcel cC cc0 cif cA cr wcel cA cc0 cif
        caddc opreq2 cC cC cr wcel cC cc0 cif cB cr wcel cB cc0 cif caddc
        opreq2 opreq12d cA cr wcel cA cc0 cif cC caddc co cB cr wcel cB cc0 cif
        cC caddc co cico co cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif caddc
        co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif caddc co cico co cA cr
        wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cG f1oeq3 syl vx vy cA cr
        wcel cA cc0 cif cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cG
        icoshftf1olem.1 cA cc0 cr 0re elimel cB cc0 cr 0re elimel cC cc0 cr 0re
        elimel icoshftf1oii dedth3h cA cr wcel cB cr wcel cC cr wcel w3a cG cF
        wceq cA cB cico co cA cC caddc co cB cC caddc co cico co cG wf1o cA cB
        cico co cA cC caddc co cB cC caddc co cico co cF wf1o wb cA cr wcel cB
        cr wcel cC cr wcel w3a vx cv cA cr wcel cA cc0 cif cB cr wcel cB cc0
        cif cico co wcel vy cv vx cv cC cr wcel cC cc0 cif caddc co wceq wa vx
        vy copab vx cv cA cB cico co wcel vy cv vx cv cC caddc co wceq wa vx vy
        copab cG cF cA cr wcel cB cr wcel cC cr wcel w3a vx cv cA cr wcel cA
        cc0 cif cB cr wcel cB cc0 cif cico co wcel vy cv vx cv cC cr wcel cC
        cc0 cif caddc co wceq wa vx cv cA cB cico co wcel vy cv vx cv cC caddc
        co wceq wa vx vy cA cr wcel cB cr wcel cC cr wcel w3a vx cv cA cr wcel
        cA cc0 cif cB cr wcel cB cc0 cif cico co wcel vx cv cA cB cico co wcel
        vy cv vx cv cC cr wcel cC cc0 cif caddc co wceq vy cv vx cv cC caddc co
        wceq cA cr wcel cB cr wcel cC cr wcel w3a cA cr wcel cA cc0 cif cB cr
        wcel cB cc0 cif cico co cA cB cico co vx cv cA cr wcel cB cr wcel cC cr
        wcel w3a cA cr wcel cA cc0 cif cA cB cr wcel cB cc0 cif cB cico cA cr
        wcel cB cr wcel cA cr wcel cA cc0 cif cA wceq cC cr wcel cA cr wcel cA
        cc0 iftrue 3ad2ant1 cB cr wcel cA cr wcel cB cr wcel cB cc0 cif cB wceq
        cC cr wcel cB cr wcel cB cc0 iftrue 3ad2ant2 opreq12d eleq2d cA cr wcel
        cB cr wcel cC cr wcel w3a vx cv cC cr wcel cC cc0 cif caddc co vx cv cC
        caddc co vy cv cA cr wcel cB cr wcel cC cr wcel w3a cC cr wcel cC cc0
        cif cC vx cv caddc cC cr wcel cA cr wcel cC cr wcel cC cc0 cif cC wceq
        cB cr wcel cC cr wcel cC cc0 iftrue 3ad2ant3 opreq2d eqeq2d anbi12d
        opabbidv icoshftf1olem.1 icoshftf1o.1 3eqtr4g cA cB cico co cA cC caddc
        co cB cC caddc co cico co cG cF f1oeq1 syl mpbid $.
        $( [26-Mar-2008] $) $( [25-Mar-2008] $)
    $}

    $( Shifting a closed-below, open-above interval is one-to-one onto.
      (Contributed by Paul Chapman, 25-Mar-2008.) $)
    icoshftf1o $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
        F : ( A [,) B ) -1-1-onto-> ( ( A + C ) [,) ( B + C ) ) ) $=
      vx vy cA cB cC cF vx cv cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico
      co wcel vy cv vx cv cC cr wcel cC cc0 cif caddc co wceq wa vx vy copab
      icoshftf1o.1 vx cv cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co
      wcel vy cv vx cv cC cr wcel cC cc0 cif caddc co wceq wa vx vy copab eqid
      icoshftf1olem $.
      $( [26-Mar-2008] $) $( [25-Mar-2008] $)
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    icounlem.1 $e |- A e. RR $.
    icounlem.2 $e |- B e. RR $.
    icounlem.3 $e |- C e. RR $.
    $( Lemma for ~ icoun . $)
    icounlem $p |- ( ( A <_ B /\ B <_ C ) ->
                     ( ( A [,) B ) u. ( B [,) C ) ) = ( A [,) C ) ) $=
      cA cB cle wbr cB cC cle wbr wa vx cA cB cico co cB cC cico co cun cA cC
      cico co cA cB cle wbr cB cC cle wbr wa vx cv cA cB cico co wcel vx cv cB
      cC cico co wcel wo vx cv cr wcel cA vx cv cle wbr vx cv cC clt wbr wa wa
      vx cv cA cB cico co cB cC cico co cun wcel vx cv cA cC cico co wcel cA cB
      cle wbr cB cC cle wbr wa vx cv cr wcel cA vx cv cle wbr vx cv cC clt wbr
      wa wa vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr wa wa vx cv cr wcel
      cB vx cv cle wbr vx cv cC clt wbr wa wa wo vx cv cA cB cico co wcel vx cv
      cB cC cico co wcel wo cA cB cle wbr cB cC cle wbr wa vx cv cr wcel cA vx
      cv cle wbr vx cv cC clt wbr wa wa vx cv cr wcel cA vx cv cle wbr vx cv cB
      clt wbr wa cB vx cv cle wbr vx cv cC clt wbr wa wo wa vx cv cr wcel cA vx
      cv cle wbr vx cv cB clt wbr wa wa vx cv cr wcel cB vx cv cle wbr vx cv cC
      clt wbr wa wa wo cA cB cle wbr cB cC cle wbr wa vx cv cr wcel cA vx cv
      cle wbr vx cv cC clt wbr wa cA vx cv cle wbr vx cv cB clt wbr wa cB vx cv
      cle wbr vx cv cC clt wbr wa wo vx cv cr wcel cA cB cle wbr cB cC cle wbr
      wa cA vx cv cle wbr vx cv cC clt wbr wa cA vx cv cle wbr vx cv cB clt wbr
      wa cB vx cv cle wbr vx cv cC clt wbr wa wo wb vx cv cr wcel cA cB cle wbr
      cB cC cle wbr wa wa cA vx cv cle wbr vx cv cC clt wbr wa cA vx cv cle wbr
      cB vx cv cle wbr wo cA vx cv cle wbr vx cv cC clt wbr wo wa vx cv cB clt
      wbr cB vx cv cle wbr wo vx cv cB clt wbr vx cv cC clt wbr wo wa wa cA vx
      cv cle wbr vx cv cB clt wbr wa cB vx cv cle wbr vx cv cC clt wbr wa wo vx
      cv cr wcel cA cB cle wbr cB cC cle wbr wa wa cA vx cv cle wbr cA vx cv
      cle wbr cB vx cv cle wbr wo cA vx cv cle wbr vx cv cC clt wbr wo wa vx cv
      cC clt wbr vx cv cB clt wbr cB vx cv cle wbr wo vx cv cB clt wbr vx cv cC
      clt wbr wo wa vx cv cr wcel cA cB cle wbr cB cC cle wbr wa wa cA vx cv
      cle wbr cA vx cv cle wbr vx cv cC clt wbr wo cA vx cv cle wbr cB vx cv
      cle wbr wo wa cA vx cv cle wbr cB vx cv cle wbr wo cA vx cv cle wbr vx cv
      cC clt wbr wo wa vx cv cr wcel cA cB cle wbr cB cC cle wbr wa wa cA vx cv
      cle wbr cA vx cv cle wbr cB vx cv cle wbr wo cA vx cv cle wbr vx cv cC
      clt wbr wo cA vx cv cle wbr cB vx cv cle wbr wo wa vx cv cr wcel cA cB
      cle wbr cB cC cle wbr wa wa cA vx cv cle wbr cB vx cv cle wbr cA vx cv
      cle wbr wo cA vx cv cle wbr cB vx cv cle wbr wo vx cv cr wcel cA cB cle
      wbr cA vx cv cle wbr cB vx cv cle wbr cA vx cv cle wbr wo wb cB cC cle
      wbr vx cv cr wcel cA cB cle wbr wa cB vx cv cle wbr cA vx cv cle wbr wi
      cA vx cv cle wbr cB vx cv cle wbr cA vx cv cle wbr wo wb vx cv cr wcel cA
      cB cle wbr cB vx cv cle wbr cA vx cv cle wbr cA cr wcel cB cr wcel vx cv
      cr wcel cA cB cle wbr cB vx cv cle wbr wa cA vx cv cle wbr wi icounlem.1
      icounlem.2 cA cB vx cv letr mp3an12 expdimp cB vx cv cle wbr cA vx cv cle
      wbr pm4.72 sylib adantrr cB vx cv cle wbr cA vx cv cle wbr orcom syl6bb
      vx cv cr wcel cA cB cle wbr cB cC cle wbr wa wa cA vx cv cle wbr vx cv cC
      clt wbr wo cA vx cv cle wbr cB vx cv cle wbr wo vx cv cr wcel cA cC cle
      wbr cA vx cv cle wbr vx cv cC clt wbr wo cA cB cle wbr cB cC cle wbr wa
      vx cv cr wcel cA cC cle wbr wa cA vx cv cle wbr vx cv cC clt wbr vx cv cr
      wcel cA cC cle wbr wa cA vx cv cle wbr wn vx cv cA clt wbr vx cv cC clt
      wbr vx cv cr wcel vx cv cA clt wbr cA vx cv cle wbr wn wb cA cC cle wbr
      vx cv cr wcel cA cr wcel vx cv cA clt wbr cA vx cv cle wbr wn wb
      icounlem.1 vx cv cA ltnle mpan2 adantr vx cv cr wcel cA cC cle wbr vx cv
      cA clt wbr vx cv cC clt wbr wi vx cv cr wcel vx cv cA clt wbr cA cC cle
      wbr vx cv cC clt wbr vx cv cr wcel vx cv cA clt wbr cA cC cle wbr vx cv
      cC clt wbr vx cv cr wcel cA cr wcel cC cr wcel vx cv cA clt wbr cA cC cle
      wbr wa vx cv cC clt wbr wi icounlem.1 icounlem.3 vx cv cA cC ltletr
      mp3an23 exp3a com23 imp sylbird orrd cA cB cC icounlem.1 icounlem.2
      icounlem.3 letri sylan2 biantrurd bitrd cA vx cv cle wbr vx cv cC clt wbr
      wo cA vx cv cle wbr cB vx cv cle wbr wo ancom syl6bb vx cv cr wcel cA cB
      cle wbr cB cC cle wbr wa wa vx cv cC clt wbr vx cv cB clt wbr vx cv cC
      clt wbr wo vx cv cB clt wbr cB vx cv cle wbr wo vx cv cB clt wbr vx cv cC
      clt wbr wo wa vx cv cr wcel cB cC cle wbr vx cv cC clt wbr vx cv cB clt
      wbr vx cv cC clt wbr wo wb cA cB cle wbr vx cv cr wcel cB cC cle wbr wa
      vx cv cB clt wbr vx cv cC clt wbr wi vx cv cC clt wbr vx cv cB clt wbr vx
      cv cC clt wbr wo wb vx cv cr wcel cB cC cle wbr vx cv cB clt wbr vx cv cC
      clt wbr wi vx cv cr wcel vx cv cB clt wbr cB cC cle wbr vx cv cC clt wbr
      vx cv cr wcel vx cv cB clt wbr cB cC cle wbr vx cv cC clt wbr vx cv cr
      wcel cB cr wcel cC cr wcel vx cv cB clt wbr cB cC cle wbr wa vx cv cC clt
      wbr wi icounlem.2 icounlem.3 vx cv cB cC ltletr mp3an23 exp3a com23 imp
      vx cv cB clt wbr vx cv cC clt wbr pm4.72 sylib adantrl vx cv cr wcel cA
      cB cle wbr cB cC cle wbr wa wa vx cv cB clt wbr cB vx cv cle wbr wo vx cv
      cB clt wbr vx cv cC clt wbr wo vx cv cr wcel vx cv cB clt wbr cB vx cv
      cle wbr wo cA cB cle wbr cB cC cle wbr wa vx cv cr wcel cB vx cv cle wbr
      vx cv cB clt wbr wo vx cv cB clt wbr cB vx cv cle wbr wo cB cr wcel vx cv
      cr wcel cB vx cv cle wbr vx cv cB clt wbr wo icounlem.2 cB vx cv lelttric
      mpan cB vx cv cle wbr vx cv cB clt wbr orcom sylib adantr biantrurd bitrd
      anbi12d cA vx cv cle wbr vx cv cB clt wbr cB vx cv cle wbr vx cv cC clt
      wbr orddi syl6bbr expcom pm5.32d vx cv cr wcel cA vx cv cle wbr vx cv cB
      clt wbr wa cB vx cv cle wbr vx cv cC clt wbr wa andi syl6bb vx cv cA cB
      cico co wcel vx cv cB cC cico co wcel wo vx cv cr wcel cA vx cv cle wbr
      vx cv cB clt wbr w3a vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr w3a
      wo vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr wa wa vx cv cr wcel cB
      vx cv cle wbr vx cv cC clt wbr wa wa wo vx cv cA cB cico co wcel vx cv cr
      wcel cA vx cv cle wbr vx cv cB clt wbr w3a vx cv cB cC cico co wcel vx cv
      cr wcel cB vx cv cle wbr vx cv cC clt wbr w3a cA cr wcel cB cr wcel vx cv
      cA cB cico co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr w3a wb
      icounlem.1 icounlem.2 cA cB vx cv elico2 mp2an cB cr wcel cC cr wcel vx
      cv cB cC cico co wcel vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr w3a
      wb icounlem.2 icounlem.3 cB cC vx cv elico2 mp2an orbi12i vx cv cr wcel
      cA vx cv cle wbr vx cv cB clt wbr w3a vx cv cr wcel cA vx cv cle wbr vx
      cv cB clt wbr wa wa vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr w3a
      vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr wa wa vx cv cr wcel cA vx
      cv cle wbr vx cv cB clt wbr 3anass vx cv cr wcel cB vx cv cle wbr vx cv
      cC clt wbr 3anass orbi12i bitri syl6rbbr vx cv cA cB cico co cB cC cico
      co elun vx cv cA cC cico co wcel vx cv cr wcel cA vx cv cle wbr vx cv cC
      clt wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cC clt wbr wa wa cA cr
      wcel cC cr wcel vx cv cA cC cico co wcel vx cv cr wcel cA vx cv cle wbr
      vx cv cC clt wbr w3a wb icounlem.1 icounlem.3 cA cC vx cv elico2 mp2an vx
      cv cr wcel cA vx cv cle wbr vx cv cC clt wbr 3anass bitri 3bitr4g eqrdv
      $.
      $( [15-Mar-2008] $) $( [15-Mar-2008] $)
  $}

  $( The union of end-to-end closed-below, open-above real intervals.
     (Contributed by Paul Chapman, 15-Mar-2008.) $)
  icoun $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ ( A <_ B /\ B <_ C ) )
                -> ( ( A [,) B ) u. ( B [,) C ) ) = ( A [,) C ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cle wbr cB cC cle wbr wa cA cB
    cico co cB cC cico co cun cA cC cico co wceq cA cr wcel cB cr wcel cC cr
    wcel cA cB cle wbr cB cC cle wbr wa cA cB cico co cB cC cico co cun cA cC
    cico co wceq wi cA cr wcel cA cc0 cif cB cle wbr cB cC cle wbr wa cA cr
    wcel cA cc0 cif cB cico co cB cC cico co cun cA cr wcel cA cc0 cif cC cico
    co wceq wi cA cB cC cc0 cc0 cc0 cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cle wbr cB cr wcel cB cc0 cif cC cle wbr wa cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif cico co cB cr wcel cB cc0 cif cC cico co cun cA cr wcel cA
    cc0 cif cC cico co wceq wi cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle
    wbr cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cle wbr wa cA cr wcel cA
    cc0 cif cB cr wcel cB cc0 cif cico co cB cr wcel cB cc0 cif cC cr wcel cC
    cc0 cif cico co cun cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif cico co
    wceq wi cA cA cr wcel cA cc0 cif wceq cA cB cle wbr cB cC cle wbr wa cA cr
    wcel cA cc0 cif cB cle wbr cB cC cle wbr wa cA cB cico co cB cC cico co cun
    cA cC cico co wceq cA cr wcel cA cc0 cif cB cico co cB cC cico co cun cA cr
    wcel cA cc0 cif cC cico co wceq cA cA cr wcel cA cc0 cif wceq cA cB cle wbr
    cA cr wcel cA cc0 cif cB cle wbr cB cC cle wbr cA cA cr wcel cA cc0 cif cB
    cle breq1 anbi1d cA cA cr wcel cA cc0 cif wceq cA cB cico co cB cC cico co
    cun cA cr wcel cA cc0 cif cB cico co cB cC cico co cun cA cC cico co cA cr
    wcel cA cc0 cif cC cico co cA cA cr wcel cA cc0 cif wceq cA cB cico co cA
    cr wcel cA cc0 cif cB cico co cB cC cico co cA cA cr wcel cA cc0 cif cB
    cico opreq1 uneq1d cA cA cr wcel cA cc0 cif cC cico opreq1 eqeq12d imbi12d
    cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB cle wbr cB cC cle
    wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cB cr wcel cB
    cc0 cif cC cle wbr wa cA cr wcel cA cc0 cif cB cico co cB cC cico co cun cA
    cr wcel cA cc0 cif cC cico co wceq cA cr wcel cA cc0 cif cB cr wcel cB cc0
    cif cico co cB cr wcel cB cc0 cif cC cico co cun cA cr wcel cA cc0 cif cC
    cico co wceq cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB cle wbr
    cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cB cC cle wbr cB cr
    wcel cB cc0 cif cC cle wbr cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif
    cle breq2 cB cB cr wcel cB cc0 cif cC cle breq1 anbi12d cB cB cr wcel cB
    cc0 cif wceq cA cr wcel cA cc0 cif cB cico co cB cC cico co cun cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif cico co cB cr wcel cB cc0 cif cC cico co
    cun cA cr wcel cA cc0 cif cC cico co cB cB cr wcel cB cc0 cif wceq cA cr
    wcel cA cc0 cif cB cico co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico
    co cB cC cico co cB cr wcel cB cc0 cif cC cico co cB cB cr wcel cB cc0 cif
    cA cr wcel cA cc0 cif cico opreq2 cB cB cr wcel cB cc0 cif cC cico opreq1
    uneq12d eqeq1d imbi12d cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cle wbr cB cr wcel cB cc0 cif cC cle wbr wa cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cB cr wcel cB cc0 cif cC cr
    wcel cC cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico
    co cB cr wcel cB cc0 cif cC cico co cun cA cr wcel cA cc0 cif cC cico co
    wceq cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cB cr wcel cB cc0
    cif cC cr wcel cC cc0 cif cico co cun cA cr wcel cA cc0 cif cC cr wcel cC
    cc0 cif cico co wceq cC cC cr wcel cC cc0 cif wceq cB cr wcel cB cc0 cif cC
    cle wbr cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cle wbr cA cr wcel cA
    cc0 cif cB cr wcel cB cc0 cif cle wbr cC cC cr wcel cC cc0 cif cB cr wcel
    cB cc0 cif cle breq2 anbi2d cC cC cr wcel cC cc0 cif wceq cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif cico co cB cr wcel cB cc0 cif cC cico co cun cA
    cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cB cr wcel cB cc0 cif cC
    cr wcel cC cc0 cif cico co cun cA cr wcel cA cc0 cif cC cico co cA cr wcel
    cA cc0 cif cC cr wcel cC cc0 cif cico co cC cC cr wcel cC cc0 cif wceq cB
    cr wcel cB cc0 cif cC cico co cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif
    cico co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co cC cC cr wcel
    cC cc0 cif cB cr wcel cB cc0 cif cico opreq2 uneq2d cC cC cr wcel cC cc0
    cif cA cr wcel cA cc0 cif cico opreq2 eqeq12d imbi12d cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cC cr wcel cC cc0 cif cA cc0 cr 0re elimel cB cc0 cr
    0re elimel cC cc0 cr 0re elimel icounlem dedth3h imp $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  ${
    $d A x $.  $d B x $.
    snunioolem.1 $e |- A e. RR $.
    snunioolem.2 $e |- B e. RR $.
    $( Lemma for ~ snunioo . $)
    snunioolem $p |- ( A < B -> ( { A } u. ( A (,) B ) ) = ( A [,) B ) ) $=
      cA cB clt wbr vx cA csn cA cB cioo co cun cA cB cico co cA cB clt wbr vx
      cv cA cB cico co wcel cA vx cv wceq vx cv cA cB cioo co wcel wo vx cv cA
      csn cA cB cioo co cun wcel cA cB clt wbr vx cv cA cB cico co wcel vx cv
      cA cB cioo co wcel cA vx cv wceq wo cA vx cv wceq vx cv cA cB cioo co
      wcel wo cA cB clt wbr vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr wa
      wa vx cv cA cB cioo co wcel cA vx cv wceq wo vx cv cA cB cico co wcel cA
      cB clt wbr vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr wa wa vx cv cr
      wcel cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv wceq wo wa vx cv cA cB
      cioo co wcel cA vx cv wceq wo cA cB clt wbr vx cv cr wcel cA vx cv cle
      wbr vx cv cB clt wbr wa cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv
      wceq wo vx cv cr wcel cA cB clt wbr cA vx cv cle wbr vx cv cB clt wbr wa
      cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv wceq wo wb vx cv cr wcel cA
      vx cv cle wbr vx cv cB clt wbr wa cA vx cv clt wbr cA vx cv wceq wo vx cv
      cB clt wbr wa cA cB clt wbr cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv
      wceq wo vx cv cr wcel cA vx cv cle wbr cA vx cv clt wbr cA vx cv wceq wo
      vx cv cB clt wbr cA cr wcel vx cv cr wcel cA vx cv cle wbr cA vx cv clt
      wbr cA vx cv wceq wo wb snunioolem.1 cA vx cv leloe mpan anbi1d cA cB clt
      wbr cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv wceq wo cA vx cv clt
      wbr vx cv cB clt wbr wa cA vx cv wceq vx cv cB clt wbr wa wo cA vx cv clt
      wbr cA vx cv wceq wo vx cv cB clt wbr wa cA cB clt wbr cA vx cv wceq cA
      vx cv wceq vx cv cB clt wbr wa cA vx cv clt wbr vx cv cB clt wbr wa cA cB
      clt wbr cA vx cv wceq vx cv cB clt wbr wi cA vx cv wceq cA vx cv wceq vx
      cv cB clt wbr wa wb cA vx cv wceq cA cB clt wbr vx cv cB clt wbr cA vx cv
      cB clt breq1 biimpcd cA vx cv wceq vx cv cB clt wbr pm4.71 sylib orbi2d
      cA vx cv clt wbr cA vx cv wceq vx cv cB clt wbr andir syl6rbbr sylan9bb
      expcom pm5.32d vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa cA vx
      cv wceq wo wa vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa wa vx cv
      cr wcel cA vx cv wceq wa wo vx cv cA cB cioo co wcel cA vx cv wceq wo vx
      cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv wceq andi vx cv
      cA cB cioo co wcel vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa wa
      cA vx cv wceq vx cv cr wcel cA vx cv wceq wa vx cv cA cB cioo co wcel vx
      cv cr wcel cA vx cv clt wbr vx cv cB clt wbr w3a vx cv cr wcel cA vx cv
      clt wbr vx cv cB clt wbr wa wa cA cr wcel cB cr wcel vx cv cA cB cioo co
      wcel vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr w3a wb snunioolem.1
      snunioolem.2 cA cxr wcel cB cxr wcel vx cv cA cB cioo co wcel vx cv cr
      wcel cA vx cv clt wbr vx cv cB clt wbr w3a wb cA cr wcel cB cr wcel cA cB
      vx cv elioo2 cA rexr cB rexr syl2an mp2an vx cv cr wcel cA vx cv clt wbr
      vx cv cB clt wbr 3anass bitri cA vx cv wceq vx cv cr wcel cA vx cv wceq
      cA cr wcel vx cv cr wcel snunioolem.1 cA vx cv cr eleq1 mpbii pm4.71ri
      orbi12i bitr4i syl6bb vx cv cA cB cico co wcel vx cv cr wcel cA vx cv cle
      wbr vx cv cB clt wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr
      wa wa cA cr wcel cB cr wcel vx cv cA cB cico co wcel vx cv cr wcel cA vx
      cv cle wbr vx cv cB clt wbr w3a wb snunioolem.1 snunioolem.2 cA cB vx cv
      elico2 mp2an vx cv cr wcel cA vx cv cle wbr vx cv cB clt wbr 3anass bitri
      syl5bb vx cv cA cB cioo co wcel cA vx cv wceq orcom syl6bb vx cv cA csn
      cA cB cioo co cun wcel vx cv cA csn wcel vx cv cA cB cioo co wcel wo cA
      vx cv wceq vx cv cA cB cioo co wcel wo vx cv cA csn cA cB cioo co elun vx
      cv cA csn wcel cA vx cv wceq vx cv cA cB cioo co wcel vx cv cA csn wcel
      vx cv cA wceq cA vx cv wceq vx cA elsn vx cv cA eqcom bitri orbi1i bitri
      syl6rbbr eqrdv $.
      $( [15-Mar-2008] $) $( [15-Mar-2008] $)
  $}

  $( The closure of one end of an open real interval.  (Contributed by Paul
     Chapman, 15-Mar-2008.) $)
  snunioo $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
                  ( { A } u. ( A (,) B ) ) = ( A [,) B ) ) $=
    cA cr wcel cB cr wcel cA cB clt wbr cA csn cA cB cioo co cun cA cB cico co
    wceq cA cr wcel cB cr wcel cA cB clt wbr cA csn cA cB cioo co cun cA cB
    cico co wceq wi cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA cc0 cif csn
    cA cr wcel cA cc0 cif cB cioo co cun cA cr wcel cA cc0 cif cB cico co wceq
    wi cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0
    cif csn cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cioo co cun cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif cico co wceq wi cA cB cc0 cc0 cA cA cr
    wcel cA cc0 cif wceq cA cB clt wbr cA cr wcel cA cc0 cif cB clt wbr cA csn
    cA cB cioo co cun cA cB cico co wceq cA cr wcel cA cc0 cif csn cA cr wcel
    cA cc0 cif cB cioo co cun cA cr wcel cA cc0 cif cB cico co wceq cA cA cr
    wcel cA cc0 cif cB clt breq1 cA cA cr wcel cA cc0 cif wceq cA csn cA cB
    cioo co cun cA cr wcel cA cc0 cif csn cA cr wcel cA cc0 cif cB cioo co cun
    cA cB cico co cA cr wcel cA cc0 cif cB cico co cA cA cr wcel cA cc0 cif
    wceq cA csn cA cr wcel cA cc0 cif csn cA cB cioo co cA cr wcel cA cc0 cif
    cB cioo co cA cA cr wcel cA cc0 cif sneq cA cA cr wcel cA cc0 cif cB cioo
    opreq1 uneq12d cA cA cr wcel cA cc0 cif cB cico opreq1 eqeq12d imbi12d cB
    cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB clt wbr cA cr wcel cA
    cc0 cif cB cr wcel cB cc0 cif clt wbr cA cr wcel cA cc0 cif csn cA cr wcel
    cA cc0 cif cB cioo co cun cA cr wcel cA cc0 cif cB cico co wceq cA cr wcel
    cA cc0 cif csn cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cioo co cun cA
    cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co wceq cB cB cr wcel cB cc0
    cif cA cr wcel cA cc0 cif clt breq2 cB cB cr wcel cB cc0 cif wceq cA cr
    wcel cA cc0 cif csn cA cr wcel cA cc0 cif cB cioo co cun cA cr wcel cA cc0
    cif csn cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cioo co cun cA cr wcel
    cA cc0 cif cB cico co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cico co
    cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB cioo co cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif cioo co cA cr wcel cA cc0 cif csn cB cB cr
    wcel cB cc0 cif cA cr wcel cA cc0 cif cioo opreq2 uneq2d cB cB cr wcel cB
    cc0 cif cA cr wcel cA cc0 cif cico opreq2 eqeq12d imbi12d cA cr wcel cA cc0
    cif cB cr wcel cB cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel
    snunioolem dedth2h 3impia $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Join two open intervals to create a third. $)
    ioojoin $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ ( A < B /\ B < C )
           ) -> ( ( ( A (,) B ) u. { B } ) u. ( B (,) C ) ) = ( A (,) C ) ) $=
      cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa cA
      cB cioo co cB csn cB cC cioo co cun cun cA cC cioo co cA cB cioo co cB
      csn cun cB cC cioo co cun cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt
      wbr cB cC clt wbr wa wa cA cB cioo co cB csn cB cC cioo co cun cun cA cB
      cioo co cB cC cico co cun cA cC cioo co cA cr wcel cB cr wcel cC cr wcel
      w3a cA cB clt wbr cB cC clt wbr wa wa cB csn cB cC cioo co cun cB cC cico
      co cA cB cioo co cA cr wcel cB cr wcel cC cr wcel w3a cB cC clt wbr cB
      csn cB cC cioo co cun cB cC cico co wceq cA cB clt wbr cB cr wcel cC cr
      wcel cB cC clt wbr cB csn cB cC cioo co cun cB cC cico co wceq cA cr wcel
      cB cr wcel cC cr wcel cB cC clt wbr cB csn cB cC cioo co cun cB cC cico
      co wceq cB cC snunioo 3expa 3adantl1 adantrl uneq2d cA cr wcel cB cr wcel
      cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cA cB cioo co cB cC
      cico co cun cA cC cioo co cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt
      wbr cB cC clt wbr wa wa vx cv cA cB cioo co cB cC cico co cun wcel vx cv
      cr wcel cA vx cv clt wbr vx cv cC clt wbr w3a vx cv cA cC cioo co wcel cA
      cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv
      cA cB cioo co wcel vx cv cB cC cico co wcel wo vx cv cr wcel cA vx cv clt
      wbr vx cv cC clt wbr w3a vx cv cA cB cioo co cB cC cico co cun wcel cA cr
      wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cA
      cB cioo co wcel vx cv cB cC cico co wcel wo vx cv cr wcel cA vx cv clt
      wbr vx cv cB clt wbr wa wa vx cv cr wcel cB vx cv cle wbr vx cv cC clt
      wbr wa wa wo vx cv cr wcel cA vx cv clt wbr vx cv cC clt wbr w3a cA cr
      wcel cB cr wcel cC cr wcel w3a vx cv cA cB cioo co wcel vx cv cB cC cico
      co wcel wo vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa wa vx cv cr
      wcel cB vx cv cle wbr vx cv cC clt wbr wa wa wo wb cA cB clt wbr cB cC
      clt wbr wa cA cr wcel cB cr wcel cC cr wcel w3a vx cv cA cB cioo co wcel
      vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa wa vx cv cB cC cico co
      wcel vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr wa wa cA cr wcel cB
      cr wcel cC cr wcel w3a vx cv cA cB cioo co wcel vx cv cr wcel cA vx cv
      clt wbr vx cv cB clt wbr w3a vx cv cr wcel cA vx cv clt wbr vx cv cB clt
      wbr wa wa cA cr wcel cB cr wcel vx cv cA cB cioo co wcel vx cv cr wcel cA
      vx cv clt wbr vx cv cB clt wbr w3a wb cC cr wcel cA cxr wcel cB cxr wcel
      vx cv cA cB cioo co wcel vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr
      w3a wb cA cr wcel cB cr wcel cA cB vx cv elioo2 cA rexr cB rexr syl2an
      3adant3 vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr 3anass syl6bb cA
      cr wcel cB cr wcel cC cr wcel w3a vx cv cB cC cico co wcel vx cv cr wcel
      cB vx cv cle wbr vx cv cC clt wbr w3a vx cv cr wcel cB vx cv cle wbr vx
      cv cC clt wbr wa wa cB cr wcel cC cr wcel vx cv cB cC cico co wcel vx cv
      cr wcel cB vx cv cle wbr vx cv cC clt wbr w3a wb cA cr wcel cB cC vx cv
      elico2 3adant1 vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr 3anass
      syl6bb orbi12d adantr cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr
      cB cC clt wbr wa wa vx cv cr wcel cA vx cv clt wbr vx cv cC clt wbr w3a
      vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa cB vx cv cle wbr vx cv
      cC clt wbr wa wo wa vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa wa
      vx cv cr wcel cB vx cv cle wbr vx cv cC clt wbr wa wa wo cA cr wcel cB cr
      wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel cA vx
      cv clt wbr vx cv cC clt wbr wa wa vx cv cr wcel cA vx cv clt wbr vx cv cB
      clt wbr wa cB vx cv cle wbr vx cv cC clt wbr wa wo wa vx cv cr wcel cA vx
      cv clt wbr vx cv cC clt wbr w3a cA cr wcel cB cr wcel cC cr wcel w3a cA
      cB clt wbr cB cC clt wbr wa wa vx cv cr wcel cA vx cv clt wbr vx cv cC
      clt wbr wa cA vx cv clt wbr vx cv cB clt wbr wa cB vx cv cle wbr vx cv cC
      clt wbr wa wo cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC
      clt wbr wa wa vx cv cr wcel wa cA vx cv clt wbr vx cv cC clt wbr wa cA vx
      cv clt wbr vx cv cB clt wbr wa cB vx cv cle wbr vx cv cC clt wbr wa wo cA
      cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv
      cr wcel wa cA vx cv clt wbr vx cv cC clt wbr wa cA vx cv clt wbr vx cv cB
      clt wbr wa cB vx cv cle wbr vx cv cC clt wbr wa wo cA cr wcel cB cr wcel
      cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel wa cA vx
      cv clt wbr vx cv cC clt wbr wa wa cA vx cv clt wbr vx cv cB clt wbr wa cB
      vx cv cle wbr vx cv cC clt wbr wa cA cr wcel cB cr wcel cC cr wcel w3a cA
      cB clt wbr cB cC clt wbr wa wa vx cv cr wcel wa cA vx cv clt wbr vx cv cC
      clt wbr wa wa cA vx cv clt wbr vx cv cB clt wbr wa wn cB vx cv cle wbr vx
      cv cC clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC
      clt wbr wa wa vx cv cr wcel wa cA vx cv clt wbr vx cv cC clt wbr wa wa cA
      vx cv clt wbr wn vx cv cB clt wbr wn wo cB vx cv cle wbr cA vx cv clt wbr
      vx cv cB clt wbr wa wn cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr
      cB cC clt wbr wa wa vx cv cr wcel wa cA vx cv clt wbr vx cv cC clt wbr wa
      wa cA vx cv clt wbr wn cB vx cv cle wbr vx cv cB clt wbr wn cA vx cv clt
      wbr cA vx cv clt wbr wn cB vx cv cle wbr wi cA cr wcel cB cr wcel cC cr
      wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel wa vx cv cC clt
      wbr cA vx cv clt wbr cB vx cv cle wbr pm2.24 ad2antrl cA cr wcel cB cr
      wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel wa vx
      cv cB clt wbr wn cB vx cv cle wbr wi cA vx cv clt wbr vx cv cC clt wbr wa
      cA cr wcel cB cr wcel cC cr wcel w3a vx cv cr wcel vx cv cB clt wbr wn cB
      vx cv cle wbr wi cA cB clt wbr cB cC clt wbr wa cB cr wcel cA cr wcel vx
      cv cr wcel vx cv cB clt wbr wn cB vx cv cle wbr wi cC cr wcel cB cr wcel
      vx cv cr wcel wa cB vx cv cle wbr vx cv cB clt wbr wn cB vx cv lenlt
      biimprd 3ad2antl2 adantlr adantr jaod cA vx cv clt wbr vx cv cB clt wbr
      ianor syl5ib cA vx cv clt wbr vx cv cC clt wbr wa cA vx cv clt wbr vx cv
      cB clt wbr wa wn vx cv cC clt wbr wi cA cr wcel cB cr wcel cC cr wcel w3a
      cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel wa cA vx cv clt wbr vx cv
      cC clt wbr wa vx cv cC clt wbr cA vx cv clt wbr vx cv cB clt wbr wa wn cA
      vx cv clt wbr vx cv cC clt wbr pm3.27 a1d adantl jcad orrd ex cA cr wcel
      cB cr wcel cC cr wcel w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel
      wa cA vx cv clt wbr vx cv cB clt wbr wa cA vx cv clt wbr vx cv cC clt wbr
      wa cB vx cv cle wbr vx cv cC clt wbr wa cA cr wcel cB cr wcel cC cr wcel
      w3a cA cB clt wbr cB cC clt wbr wa wa vx cv cr wcel wa vx cv cB clt wbr
      vx cv cC clt wbr cA vx cv clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cA
      cB clt wbr cB cC clt wbr wa wa vx cv cr wcel vx cv cB clt wbr vx cv cC
      clt wbr wi cA cr wcel cB cr wcel cC cr wcel w3a cB cC clt wbr vx cv cr
      wcel vx cv cB clt wbr vx cv cC clt wbr wi wi cA cB clt wbr cB cr wcel cC
      cr wcel cB cC clt wbr vx cv cr wcel vx cv cB clt wbr vx cv cC clt wbr wi
      wi cA cr wcel cB cr wcel cC cr wcel cB cC clt wbr vx cv cr wcel vx cv cB
      clt wbr vx cv cC clt wbr wi wi vx cv cr wcel cB cr wcel cC cr wcel cB cC
      clt wbr vx cv cB clt wbr vx cv cC clt wbr wi vx cv cr wcel cB cr wcel cC
      cr wcel cB cC clt wbr vx cv cB clt wbr vx cv cC clt wbr wi wi vx cv cr
      wcel cB cr wcel cC cr wcel w3a vx cv cB clt wbr cB cC clt wbr vx cv cC
      clt wbr vx cv cr wcel cB cr wcel cC cr wcel w3a vx cv cB clt wbr cB cC
      clt wbr vx cv cC clt wbr vx cv cB cC axlttrn exp3a com23 3exp com4l imp31
      3adantl1 adantrl imp anim2d cA cr wcel cB cr wcel cC cr wcel w3a cA cB
      clt wbr cB cC clt wbr wa wa vx cv cr wcel wa cB vx cv cle wbr cA vx cv
      clt wbr vx cv cC clt wbr cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt
      wbr cB cC clt wbr wa wa vx cv cr wcel cB vx cv cle wbr cA vx cv clt wbr
      wi cA cr wcel cB cr wcel cC cr wcel w3a cA cB clt wbr vx cv cr wcel cB vx
      cv cle wbr cA vx cv clt wbr wi wi cB cC clt wbr cA cr wcel cB cr wcel cA
      cB clt wbr vx cv cr wcel cB vx cv cle wbr cA vx cv clt wbr wi wi cC cr
      wcel cA cr wcel cB cr wcel cA cB clt wbr vx cv cr wcel cB vx cv cle wbr
      cA vx cv clt wbr wi wi cA cr wcel cB cr wcel vx cv cr wcel cA cB clt wbr
      cB vx cv cle wbr cA vx cv clt wbr wi cA cr wcel cB cr wcel vx cv cr wcel
      cA cB clt wbr cB vx cv cle wbr cA vx cv clt wbr wi wi cA cr wcel cB cr
      wcel vx cv cr wcel w3a cA cB clt wbr cB vx cv cle wbr cA vx cv clt wbr cA
      cB vx cv ltletr exp3a 3exp com34 imp31 3adantl3 adantrr imp anim1d jaod
      impbid pm5.32da vx cv cr wcel cA vx cv clt wbr vx cv cC clt wbr 3anass
      syl5bb vx cv cr wcel cA vx cv clt wbr vx cv cB clt wbr wa cB vx cv cle
      wbr vx cv cC clt wbr wa andi syl6bb bitr4d vx cv cA cB cioo co cB cC cico
      co elun syl5bb cA cr wcel cB cr wcel cC cr wcel w3a vx cv cA cC cioo co
      wcel vx cv cr wcel cA vx cv clt wbr vx cv cC clt wbr w3a wb cA cB clt wbr
      cB cC clt wbr wa cA cr wcel cC cr wcel vx cv cA cC cioo co wcel vx cv cr
      wcel cA vx cv clt wbr vx cv cC clt wbr w3a wb cB cr wcel cA cxr wcel cC
      cxr wcel vx cv cA cC cioo co wcel vx cv cr wcel cA vx cv clt wbr vx cv cC
      clt wbr w3a wb cA cr wcel cC cr wcel cA cC vx cv elioo2 cA rexr cC rexr
      syl2an 3adant2 adantr bitr4d eqrdv eqtrd cA cB cioo co cB csn cB cC cioo
      co unass syl5eq $.
      $( [11-Aug-2008] $) $( [11-Aug-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Upper partititions of integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ZZ>= $. $( ` ZZ ` with greater-than-or-equal-to subscript. $)

  $( Extend class notation with the upper integer function.  Read
     " ` ZZ>= `` M ` " as "the set of integers greater than or equal to
     ` M ` ." $)
  cuz $a class ZZ>= $.

  ${
    $d j k y N $.  $d k M $.
    $( Define a function whose value at ` j ` is the semi-infinite set of
       contiguous integers starting at ` j ` , which we will also call the
       upper integers starting at ` j ` .  Read " ` ZZ>= `` M ` " as "the set
       of integers greater than or equal to ` M ` ." See ~ uzval for its
       value, ~ uzssz for its relationship to ` ZZ ` , ~ nnuz and ~ nn0uz for
       its relationships to ` NN ` and ` NN0 ` , and ~ eluz1 and ~ eluz2 for
       its membership relations. $)
    df-uz $a |- ZZ>= =
                  { <. j , y >. | ( j e. ZZ /\ y = { k e. ZZ | j <_ k } ) } $.

    $( The value of the upper integers function. $)
    uzval $p |- ( N e. ZZ -> ( ZZ>= ` N ) = { k e. ZZ | N <_ k } ) $=
      vj vy cN vj cv vk cv cle wbr vk cz crab cN vk cv cle wbr vk cz crab cz
      cuz vj cv cN wceq vj cv vk cv cle wbr cN vk cv cle wbr vk cz vj cv cN vk
      cv cle breq1 rabbisdv vy vj vk df-uz cN vk cv cle wbr vk cz zex rabex
      fvopab4 $.
      $( [11-Sep-2005] $) $( [5-Sep-2005] $)

    $( Membership in the set of upper integers starting at ` M ` . $)
    eluz1 $p |- ( M e. ZZ ->
           ( N e. ( ZZ>= ` M ) <-> ( N e. ZZ /\ M <_ N ) ) ) $=
      cM cz wcel cN cM cuz cfv wcel cN cM vk cv cle wbr vk cz crab wcel cN cz
      wcel cM cN cle wbr wa cM cz wcel cM cuz cfv cM vk cv cle wbr vk cz crab
      cN vk cM uzval eleq2d cM vk cv cle wbr cM cN cle wbr vk cN cz vk cv cN cM
      cle breq2 elrab syl6bb $.
      $( [11-Sep-2005] $) $( [5-Sep-2005] $)

    $( Membership in a set of upper integers.  We use the fact that a
       function's value (under our function value definition) is empty outside
       of its domain to show ` M e. ZZ ` . $)
    eluz2 $p |- ( N e. ( ZZ>= ` M ) <-> ( M e. ZZ /\ N e. ZZ /\ M <_ N ) ) $=
      cN cM cuz cfv wcel cM cz wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cN
      cM cuz cfv wcel cM cuz cdm cz cN cM cuz elfvdm vj vy cz vj cv vk cv cle
      wbr vk cz crab cuz vj cv vk cv cle wbr vk cz zex rabex vy vj vk df-uz
      dmopab2 syl6eleq cM cz wcel cN cz wcel cM cN cle wbr 3simp1 cM cz wcel cN
      cM cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr wa wa cM cz wcel cN
      cz wcel cM cN cle wbr w3a cM cz wcel cN cM cuz cfv wcel cN cz wcel cM cN
      cle wbr wa cM cz wcel cN cz wcel cM cN cle wbr wa wa cM cN eluz1 cM cz
      wcel cN cz wcel cM cN cle wbr wa ibar bitrd cM cz wcel cN cz wcel cM cN
      cle wbr 3anass syl6bbr pm5.21nii $.
      $( [12-Sep-2005] $) $( [5-Sep-2005] $)
  $}

  ${
    eluz.1 $e |- M e. ZZ $.
    $( Membership in a set of upper integers. $)
    eluz1i $p |- ( N e. ( ZZ>= ` M ) <-> ( N e. ZZ /\ M <_ N ) ) $=
      cM cz wcel cN cM cuz cfv wcel cN cz wcel cM cN cle wbr wa wb eluz.1 cM cN
      eluz1 ax-mp $.
      $( [12-Sep-2005] $) $( [5-Sep-2005] $)
  $}

  $( Implication of membership in a set of upper integers. $)
  eluzelz $p |- ( N e. ( ZZ>= ` M ) -> N e. ZZ ) $=
    cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cN cz wcel cM cN
    eluz2 cM cz wcel cN cz wcel cM cN cle wbr 3simp2 sylbi $.
    $( [14-Sep-2005] $) $( [6-Sep-2005] $)

  $( Implication of membership in a set of upper integers. $)
  eluzel2 $p |- ( N e. ( ZZ>= ` M ) -> M e. ZZ ) $=
    cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cM cz wcel cM cN
    eluz2 cM cz wcel cN cz wcel cM cN cle wbr 3simp1 sylbi $.
    $( [14-Sep-2005] $) $( [6-Sep-2005] $)

  $( Implication of membership in a set of upper integers. $)
  eluzle $p |- ( N e. ( ZZ>= ` M ) -> M <_ N ) $=
    cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cM cN cle wbr cM
    cN eluz2 cM cz wcel cN cz wcel cM cN cle wbr 3simp3 sylbi $.
    $( [14-Sep-2005] $) $( [6-Sep-2005] $)

  $( Membership in a set of upper integers. $)
  eluz $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
         ( N e. ( ZZ>= ` M ) <-> M <_ N ) ) $=
    cM cz wcel cN cz wcel cN cM cuz cfv wcel cM cN cle wbr wb cM cz wcel cN cz
    wcel cN cM cuz cfv wcel wa cN cz wcel cM cN cle wbr wa wb cN cz wcel cN cM
    cuz cfv wcel cM cN cle wbr wb wi cM cz wcel cN cM cuz cfv wcel cN cz wcel
    cM cN cle wbr wa cN cz wcel cN cM cuz cfv wcel wa cM cN eluz1 cN cM cuz cfv
    wcel cN cz wcel cM cN eluzelz pm4.71ri syl5bbr cN cz wcel cN cM cuz cfv
    wcel cM cN cle wbr pm5.32 sylibr imp $.
    $( [4-Oct-2005] $) $( [2-Oct-2005] $)

  $( Membership of the least member in a set of upper integers. $)
  uzid $p |- ( M e. ZZ -> M e. ( ZZ>= ` M ) ) $=
    cM cz wcel cM cM cuz cfv wcel cM cz wcel cM cM cle wbr wa cM cz wcel cM cM
    cle wbr cM cz wcel cM cr wcel cM cM cle wbr cM zre cM leid syl ancli cM cM
    eluz1 mpbird $.
    $( [12-Sep-2005] $) $( [2-Sep-2005] $)

  $( Transitive law for sets of upper integers. $)
  uztrn $p |- ( ( M e. ( ZZ>= ` K ) /\ K e. ( ZZ>= ` N ) ) ->
              M e. ( ZZ>= ` N ) ) $=
    cM cK cuz cfv wcel cK cN cuz cfv wcel wa cN cz wcel cM cz wcel cN cM cle
    wbr w3a cM cN cuz cfv wcel cM cK cuz cfv wcel cK cN cuz cfv wcel wa cN cz
    wcel cM cz wcel cN cM cle wbr cK cN cuz cfv wcel cN cz wcel cM cK cuz cfv
    wcel cN cK eluzel2 adantl cM cK cuz cfv wcel cM cz wcel cK cN cuz cfv wcel
    cK cM eluzelz adantr cM cK cuz cfv wcel cK cN cuz cfv wcel wa cN cK cle wbr
    cK cM cle wbr cN cM cle wbr cK cN cuz cfv wcel cN cK cle wbr cM cK cuz cfv
    wcel cN cK eluzle adantl cM cK cuz cfv wcel cK cM cle wbr cK cN cuz cfv
    wcel cK cM eluzle adantr cN cz wcel cK cz wcel cM cz wcel cN cK cle wbr cK
    cM cle wbr wa cN cM cle wbr wi cM cK cuz cfv wcel cK cN cuz cfv wcel wa cN
    cr wcel cK cr wcel cM cr wcel cN cK cle wbr cK cM cle wbr wa cN cM cle wbr
    wi cN cz wcel cK cz wcel cM cz wcel cN cK cM letr cN zre cK zre cM zre
    syl3an cK cN cuz cfv wcel cN cz wcel cM cK cuz cfv wcel cN cK eluzel2
    adantl cK cN cuz cfv wcel cK cz wcel cM cK cuz cfv wcel cN cK eluzelz
    adantl cM cK cuz cfv wcel cM cz wcel cK cN cuz cfv wcel cK cM eluzelz
    adantr syl3anc mp2and 3jca cN cM eluz2 sylibr $.
    $( [23-Sep-2005] $) $( [20-Sep-2005] $)

  $( Contraposition law for upper integers. $)
  uzneg $p |- ( N e. ( ZZ>= ` M ) -> -u M e. ( ZZ>= ` -u N ) ) $=
    cN cM cuz cfv wcel cM cneg cN cneg cuz cfv wcel cN cneg cM cneg cle wbr cN
    cM cuz cfv wcel cM cN cle wbr cN cneg cM cneg cle wbr cM cN eluzle cM cz
    wcel cN cz wcel cM cN cle wbr cN cneg cM cneg cle wbr wb cN cM cuz cfv wcel
    cM cr wcel cN cr wcel cM cN cle wbr cN cneg cM cneg cle wbr wb cM cz wcel
    cN cz wcel cM cN leneg cM zre cN zre syl2an cM cN eluzel2 cM cN eluzelz
    sylanc mpbid cN cz wcel cM cz wcel cM cneg cN cneg cuz cfv wcel cN cneg cM
    cneg cle wbr wb cN cM cuz cfv wcel cN cneg cz wcel cM cneg cz wcel cM cneg
    cN cneg cuz cfv wcel cN cneg cM cneg cle wbr wb cN cz wcel cM cz wcel cN
    cneg cM cneg eluz cN znegcl cM znegcl syl2an cM cN eluzelz cM cN eluzel2
    sylanc mpbird $.
    $( [6-Jan-2006] $) $( [28-Nov-2005] $)

  ${
    $d j k y M $.  $d k N $.
    $( A set of upper integers is a subset of all integers. $)
    uzssz $p |- ( ZZ>= ` M ) C_ ZZ $=
      cM cz wcel cM cuz cfv cz wss cM cz wcel cM cuz cfv cM vk cv cle wbr vk cz
      crab cz vk cM uzval cM vk cv cle wbr vk cz crab cz wss cM cz wcel cM vk
      cv cle wbr vk cz ssrab2 a1i eqsstrd cM cz wcel wn cM cuz cfv c0 cz cM cz
      wcel wn cM cuz cdm wcel wn cM cuz cfv c0 wceq cM cuz cdm wcel cM cz wcel
      cuz cdm cz cM cuz cdm vj cv cz wcel vy cv vj cv vk cv cle wbr vk cz crab
      wceq wa vj vy copab cdm cz cuz vj cv cz wcel vy cv vj cv vk cv cle wbr vk
      cz crab wceq wa vj vy copab vy vj vk df-uz dmeqi vy cv vj cv vk cv cle
      wbr vk cz crab wceq vj vy cz dmopabss eqsstri sseli con3i cM cuz ndmfv
      syl c0 cz wss cM cz wcel wn cz 0ss a1i eqsstrd pm2.61i $.
      $( [13-Sep-2005] $) $( [2-Sep-2005] $)

    $( Subset relationship for two sets of upper integers. $)
    uzss $p |- ( N e. ( ZZ>= ` M ) ->
               ( ZZ>= ` N ) C_ ( ZZ>= ` M ) ) $=
      cN cM cuz cfv wcel vk cN cuz cfv cM cuz cfv cN cM cuz cfv wcel vk cv cz
      wcel cN vk cv cle wbr wa vk cv cz wcel cM vk cv cle wbr wa vk cv cN cuz
      cfv wcel vk cv cM cuz cfv wcel cN cM cuz cfv wcel vk cv cz wcel cN vk cv
      cle wbr cM vk cv cle wbr cN cM cuz cfv wcel vk cv cz wcel cN vk cv cle
      wbr cM vk cv cle wbr wi cN cM cuz cfv wcel vk cv cz wcel wa cM cN cle wbr
      cN vk cv cle wbr cM vk cv cle wbr cN cM cuz cfv wcel cM cN cle wbr vk cv
      cz wcel cM cN eluzle adantr cM cz wcel cN cz wcel wa vk cv cz wcel cM cN
      cle wbr cN vk cv cle wbr wa cM vk cv cle wbr wi cN cM cuz cfv wcel cM cz
      wcel cN cz wcel vk cv cz wcel cM cN cle wbr cN vk cv cle wbr wa cM vk cv
      cle wbr wi cM cr wcel cN cr wcel vk cv cr wcel cM cN cle wbr cN vk cv cle
      wbr wa cM vk cv cle wbr wi cM cz wcel cN cz wcel vk cv cz wcel cM cN vk
      cv letr cM zre cN zre vk cv zre syl3an 3expa cN cM cuz cfv wcel cM cz
      wcel cN cz wcel cM cN eluzel2 cM cN eluzelz jca sylan mpand ex imdistand
      cN cM cuz cfv wcel cN cz wcel vk cv cN cuz cfv wcel vk cv cz wcel cN vk
      cv cle wbr wa wb cM cN eluzelz cN vk cv eluz1 syl cN cM cuz cfv wcel cM
      cz wcel vk cv cM cuz cfv wcel vk cv cz wcel cM vk cv cle wbr wa wb cM cN
      eluzel2 cM vk cv eluz1 syl 3imtr4d ssrdv $.
      $( [11-Sep-2005] $) $( [5-Sep-2005] $)
  $}

  $( The upper integers function is one-to-one. $)
  uz11 $p |- ( M e. ZZ ->
                ( ( ZZ>= ` M ) = ( ZZ>= ` N ) <-> M = N ) ) $=
    cM cz wcel cM cuz cfv cN cuz cfv wceq cM cN wceq cM cz wcel cM cuz cfv cN
    cuz cfv wceq cM cN wceq cM cz wcel cM cuz cfv cN cuz cfv wceq wa cN cz wcel
    cM cN wceq cM cuz cfv cN cuz cfv wceq cM cz wcel cN cz wcel cM cuz cfv cN
    cuz cfv wceq cM cM cuz cfv wcel cN cz wcel cM cz wcel cM cuz cfv cN cuz cfv
    wceq cM cM cuz cfv wcel cM cN cuz cfv wcel cN cz wcel cM cuz cfv cN cuz cfv
    cM eleq2 cN cM eluzel2 syl6bi cM uzid syl5 impcom cM cz wcel cM cuz cfv cN
    cuz cfv wceq wa cN cz wcel wa cM cN wceq cM cN cle wbr cN cM cle wbr wa cM
    cz wcel cM cuz cfv cN cuz cfv wceq cN cz wcel cM cN cle wbr cN cM cle wbr
    wa cM cuz cfv cN cuz cfv wceq cN cz wcel wa cM cz wcel cM cN cle wbr cN cM
    cle wbr wa cM cuz cfv cN cuz cfv wceq cN cz wcel cM cz wcel cM cN cle wbr
    cN cM cle wbr wa cM cuz cfv cN cuz cfv wceq cN cz wcel cM cz wcel wa cM cN
    cle wbr cN cM cle wbr wa cM cuz cfv cN cuz cfv wceq cN cz wcel cM cN cle
    wbr cM cz wcel cN cM cle wbr cM cuz cfv cN cuz cfv wceq cN cz wcel cN cM
    cuz cfv wcel cM cN cle wbr cM cuz cfv cN cuz cfv wceq cN cM cuz cfv wcel cN
    cN cuz cfv wcel cN cz wcel cM cuz cfv cN cuz cfv cN eleq2 cN uzid syl5bir
    cM cN eluzle syl6 cM cuz cfv cN cuz cfv wceq cM cz wcel cM cN cuz cfv wcel
    cN cM cle wbr cM cuz cfv cN cuz cfv wceq cM cM cuz cfv wcel cM cN cuz cfv
    wcel cM cz wcel cM cuz cfv cN cuz cfv cM eleq2 cM uzid syl5bi cN cM eluzle
    syl6 anim12d imp anassrs ancoms anassrs cM cz wcel cN cz wcel cM cN wceq cM
    cN cle wbr cN cM cle wbr wa wb cM cuz cfv cN cuz cfv wceq cM cr wcel cN cr
    wcel cM cN wceq cM cN cle wbr cN cM cle wbr wa wb cM cz wcel cN cz wcel cM
    cN letri3 cM zre cN zre syl2an adantlr mpbird mpdan ex cM cN cuz fveq2
    impbid1 $.
    $( [25-Dec-2005] $) $( [12-Dec-2005] $)

  $( Membership in the next set of upper integers. $)
  eluzp1m1 $p |- ( ( M e. ZZ /\
             N e. ( ZZ>= ` ( M + 1 ) ) ) -> ( N - 1 ) e. ( ZZ>= ` M ) ) $=
    cM cz wcel cN cM c1 caddc co cuz cfv wcel cN c1 cmin co cM cuz cfv wcel cM
    cz wcel cN cz wcel cM c1 caddc co cN cle wbr wa cN c1 cmin co cz wcel cM cN
    c1 cmin co cle wbr wa cN cM c1 caddc co cuz cfv wcel cN c1 cmin co cM cuz
    cfv wcel cM cz wcel cN cz wcel cM c1 caddc co cN cle wbr wa cN c1 cmin co
    cz wcel cM cN c1 cmin co cle wbr wa cM cz wcel cN cz wcel cM c1 caddc co cN
    cle wbr wa wa cN c1 cmin co cz wcel cM cN c1 cmin co cle wbr cN cz wcel cN
    c1 cmin co cz wcel cM cz wcel cM c1 caddc co cN cle wbr cN peano2zm
    ad2antrl cM cz wcel cN cz wcel cM c1 caddc co cN cle wbr cM cN c1 cmin co
    cle wbr cM cz wcel cN cz wcel wa cM c1 caddc co cN cle wbr cM cN c1 cmin co
    cle wbr cM cr wcel cN cr wcel cM c1 caddc co cN cle wbr cM cN c1 cmin co
    cle wbr wb cM cz wcel cN cz wcel cM cr wcel c1 cr wcel cN cr wcel cM c1
    caddc co cN cle wbr cM cN c1 cmin co cle wbr wb 1re cM c1 cN leaddsub
    mp3an2 cM zre cN zre syl2an biimpa anasss jca ex cM cz wcel cM c1 caddc co
    cz wcel cN cM c1 caddc co cuz cfv wcel cN cz wcel cM c1 caddc co cN cle wbr
    wa wb cM peano2z cM c1 caddc co cN eluz1 syl cM cN c1 cmin co eluz1 3imtr4d
    imp $.
    $( [28-Sep-2005] $) $( [12-Sep-2005] $)

  $( Strict ordering implied by membership in the next set of upper
     integers. $)
  eluzp1l $p |- ( ( M e. ZZ /\
             N e. ( ZZ>= ` ( M + 1 ) ) ) -> M < N ) $=
    cM cz wcel cN cM c1 caddc co cuz cfv wcel wa cM cN clt wbr cM c1 caddc co
    cN cle wbr cN cM c1 caddc co cuz cfv wcel cM c1 caddc co cN cle wbr cM cz
    wcel cM c1 caddc co cN eluzle adantl cM cz wcel cN cz wcel cM cN clt wbr cM
    c1 caddc co cN cle wbr wb cN cM c1 caddc co cuz cfv wcel cM cN zltp1le cM
    c1 caddc co cN eluzelz sylan2 mpbird $.
    $( [1-Oct-2005] $) $( [12-Sep-2005] $)

  $( Membership in the next set of upper integers. $)
  eluzp1p1 $p |- ( N e. ( ZZ>= ` M ) ->
                       ( N + 1 ) e. ( ZZ>= ` ( M + 1 ) ) ) $=
    cM cz wcel cN cz wcel cM cN cle wbr w3a cM c1 caddc co cz wcel cN c1 caddc
    co cz wcel cM c1 caddc co cN c1 caddc co cle wbr w3a cN cM cuz cfv wcel cN
    c1 caddc co cM c1 caddc co cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr
    w3a cM c1 caddc co cz wcel cN c1 caddc co cz wcel cM c1 caddc co cN c1
    caddc co cle wbr cM cz wcel cN cz wcel cM c1 caddc co cz wcel cM cN cle wbr
    cM peano2z 3ad2ant1 cN cz wcel cM cz wcel cN c1 caddc co cz wcel cM cN cle
    wbr cN peano2z 3ad2ant2 cM cz wcel cN cz wcel cM cN cle wbr cM c1 caddc co
    cN c1 caddc co cle wbr cM cr wcel cN cr wcel cM cN cle wbr cM c1 caddc co
    cN c1 caddc co cle wbr wb cM cz wcel cN cz wcel cM cr wcel cN cr wcel c1 cr
    wcel cM cN cle wbr cM c1 caddc co cN c1 caddc co cle wbr wb 1re cM cN c1
    leadd1 mp3an3 cM zre cN zre syl2an biimp3a 3jca cM cN eluz2 cM c1 caddc co
    cN c1 caddc co eluz2 3imtr4i $.
    $( [5-Oct-2005] $) $( [5-Oct-2005] $)

 ${
    eluzaddi.1 $e |- M e. ZZ $.
    eluzaddi.2 $e |- K e. ZZ $.
    $( Membership in a later set of upper integers.  (Contributed by Paul
       Chapman, 22-Nov-2007.) $)
    eluzaddi $p |- ( N e. ( ZZ>= ` M )
          -> ( N + K ) e. ( ZZ>= ` ( M + K ) ) ) $=
      cN cK caddc co cM cK caddc co cuz cfv wcel cN cK caddc co cz wcel cM cK
      caddc co cN cK caddc co cle wbr cN cM cuz cfv wcel cM cK caddc co cN cK
      caddc co cM cz wcel cK cz wcel cM cK caddc co cz wcel eluzaddi.1
      eluzaddi.2 cM cK zaddcl mp2an eluz1i cN cz wcel cK cz wcel cN cK caddc co
      cz wcel cN cM cuz cfv wcel cN cK zaddcl cM cN eluzelz eluzaddi.2 sylancl
      cN cM cuz cfv wcel cN cz wcel cM cN cle wbr wa cM cK caddc co cN cK caddc
      co cle wbr cM cN eluzaddi.1 eluz1i cN cz wcel cM cN cle wbr cM cK caddc
      co cN cK caddc co cle wbr cN cz wcel cN cr wcel cM cN cle wbr cM cK caddc
      co cN cK caddc co cle wbr wb cN zre cM cr wcel cN cr wcel cK cr wcel cM
      cN cle wbr cM cK caddc co cN cK caddc co cle wbr wb cM eluzaddi.1 zrei cK
      eluzaddi.2 zrei cM cN cK leadd1 mp3an13 syl biimpa sylbi sylanbrc $.
      $( [23-Nov-2007] $) $( [22-Nov-2007] $)

    $( Membership in an earlier set of upper integers.  (Contributed by Paul
       Chapman, 22-Nov-2007.) $)
    eluzsubi $p |- ( N e. ( ZZ>= ` ( M + K ) )
         -> ( N - K ) e. ( ZZ>= ` M ) ) $=
      cN cK cmin co cM cuz cfv wcel cN cK cmin co cz wcel cM cN cK cmin co cle
      wbr cN cM cK caddc co cuz cfv wcel cM cN cK cmin co eluzaddi.1 eluz1i cN
      cz wcel cK cz wcel cN cK cmin co cz wcel cN cM cK caddc co cuz cfv wcel
      cN cK zsubcl cM cK caddc co cN eluzelz eluzaddi.2 sylancl cN cM cK caddc
      co cuz cfv wcel cN cz wcel cM cK caddc co cN cle wbr wa cM cN cK cmin co
      cle wbr cM cK caddc co cN cM cz wcel cK cz wcel cM cK caddc co cz wcel
      eluzaddi.1 eluzaddi.2 cM cK zaddcl mp2an eluz1i cN cz wcel cM cK caddc co
      cN cle wbr cM cN cK cmin co cle wbr cN cz wcel cN cr wcel cM cK caddc co
      cN cle wbr cM cN cK cmin co cle wbr wb cN zre cM cr wcel cK cr wcel cN cr
      wcel cM cK caddc co cN cle wbr cM cN cK cmin co cle wbr wb cM eluzaddi.1
      zrei cK eluzaddi.2 zrei cM cK cN leaddsub mp3an12 syl biimpa sylbi
      sylanbrc $.
      $( [23-Nov-2007] $) $( [22-Nov-2007] $)
  $}

  $( Nonnegative integers expressed as a set of upper integers. $)
  nn0uz $p |- NN0 = ( ZZ>= ` 0 ) $=
    cn0 cc0 vk cv cle wbr vk cz crab cc0 cuz cfv vk nn0zrab cc0 cz wcel cc0 cuz
    cfv cc0 vk cv cle wbr vk cz crab wceq 0z vk cc0 uzval ax-mp eqtr4i $.
    $( [11-Sep-2005] $) $( [2-Sep-2005] $)

  $( Natural numbers expressed as a set of upper integers. $)
  nnuz $p |- NN = ( ZZ>= ` 1 ) $=
    cn c1 vk cv cle wbr vk cz crab c1 cuz cfv vk nnzrab c1 cz wcel c1 cuz cfv
    c1 vk cv cle wbr vk cz crab wceq 1z vk c1 uzval ax-mp eqtr4i $.
    $( [11-Sep-2005] $) $( [2-Sep-2005] $)

  $( A natural number expressed as a member of a set of upper integers. $)
  elnnuz $p |- ( N e. NN <-> N e. ( ZZ>= ` 1 ) ) $=
    cn c1 cuz cfv cN nnuz eleq2i $.
    $( [6-Jun-2006] $) $( [6-Jun-2006] $)

  $( A nonnegative integer expressed as a member a set of upper integers. $)
  elnn0uz $p |- ( N e. NN0 <-> N e. ( ZZ>= ` 0 ) ) $=
    cn0 cc0 cuz cfv cN nn0uz eleq2i $.
    $( [7-Jun-2006] $) $( [6-Jun-2006] $)

  ${
    $d m n M $.
    $( Restricted universal quantification in a set of upper integers. $)
    raluz $p |- ( M e. ZZ -> ( A. n e. ( ZZ>= ` M ) ph <->
               A. n e. ZZ ( M <_ n -> ph ) ) ) $=
      cM cz wcel wph cM vn cv cle wbr wph wi vn cM cuz cfv cz cM cz wcel vn cv
      cM cuz cfv wcel wph wi vn cv cz wcel cM vn cv cle wbr wa wph wi vn cv cz
      wcel cM vn cv cle wbr wph wi wi cM cz wcel vn cv cM cuz cfv wcel vn cv cz
      wcel cM vn cv cle wbr wa wph cM vn cv eluz1 imbi1d vn cv cz wcel cM vn cv
      cle wbr wph impexp syl6bb ralbidv2 $.
      $( [27-Sep-2005] $) $( [9-Sep-2005] $)

    $( Restricted universal quantification in a set of upper integers. $)
    raluz2 $p |- ( A. n e. ( ZZ>= ` M ) ph <->
               ( M e. ZZ -> A. n e. ZZ ( M <_ n -> ph ) ) ) $=
      wph vn cM cuz cfv wral cM cz wcel cM vn cv cle wbr wph wi wi vn cz wral
      cM cz wcel cM vn cv cle wbr wph wi vn cz wral wi wph cM cz wcel cM vn cv
      cle wbr wph wi wi vn cM cuz cfv cz vn cv cM cuz cfv wcel wph wi cM cz
      wcel vn cv cz wcel cM vn cv cle wbr wa wa wph wi cM cz wcel vn cv cz wcel
      cM vn cv cle wbr wph wi wi wi vn cv cz wcel cM cz wcel cM vn cv cle wbr
      wph wi wi wi vn cv cM cuz cfv wcel cM cz wcel vn cv cz wcel cM vn cv cle
      wbr wa wa wph vn cv cM cuz cfv wcel cM cz wcel vn cv cz wcel cM vn cv cle
      wbr w3a cM cz wcel vn cv cz wcel cM vn cv cle wbr wa wa cM vn cv eluz2 cM
      cz wcel vn cv cz wcel cM vn cv cle wbr 3anass bitri imbi1i cM cz wcel vn
      cv cz wcel cM vn cv cle wbr wa wa wph wi cM cz wcel vn cv cz wcel cM vn
      cv cle wbr wa wph wi wi cM cz wcel vn cv cz wcel cM vn cv cle wbr wph wi
      wi wi cM cz wcel vn cv cz wcel cM vn cv cle wbr wa wph impexp vn cv cz
      wcel cM vn cv cle wbr wa wph wi vn cv cz wcel cM vn cv cle wbr wph wi wi
      cM cz wcel vn cv cz wcel cM vn cv cle wbr wph impexp imbi2i bitri cM cz
      wcel vn cv cz wcel cM vn cv cle wbr wph wi bi2.04 3bitri ralbii2 cM cz
      wcel cM vn cv cle wbr wph wi vn cz r19.21v bitri $.
      $( [3-Oct-2005] $) $( [9-Sep-2005] $)

    $( Restricted existential quantification in a set of upper integers. $)
    rexuz $p |- ( M e. ZZ -> ( E. n e. ( ZZ>= ` M ) ph <->
               E. n e. ZZ ( M <_ n /\ ph ) ) ) $=
      cM cz wcel wph cM vn cv cle wbr wph wa vn cM cuz cfv cz cM cz wcel vn cv
      cM cuz cfv wcel wph wa vn cv cz wcel cM vn cv cle wbr wa wph wa vn cv cz
      wcel cM vn cv cle wbr wph wa wa cM cz wcel vn cv cM cuz cfv wcel vn cv cz
      wcel cM vn cv cle wbr wa wph cM vn cv eluz1 anbi1d vn cv cz wcel cM vn cv
      cle wbr wph anass syl6bb rexbidv2 $.
      $( [6-Oct-2005] $) $( [9-Sep-2005] $)

    $( Restricted existential quantification in a set of upper integers. $)
    rexuz2 $p |- ( E. n e. ( ZZ>= ` M ) ph <->
               ( M e. ZZ /\ E. n e. ZZ ( M <_ n /\ ph ) ) ) $=
      wph vn cM cuz cfv wrex cM cz wcel cM vn cv cle wbr wph wa wa vn cz wrex
      cM cz wcel cM vn cv cle wbr wph wa vn cz wrex wa wph cM cz wcel cM vn cv
      cle wbr wph wa wa vn cM cuz cfv cz vn cv cM cuz cfv wcel wph wa cM cz
      wcel vn cv cz wcel wa cM vn cv cle wbr wa wph wa cM cz wcel vn cv cz wcel
      wa cM vn cv cle wbr wph wa wa vn cv cz wcel cM cz wcel cM vn cv cle wbr
      wph wa wa wa vn cv cM cuz cfv wcel cM cz wcel vn cv cz wcel wa cM vn cv
      cle wbr wa wph vn cv cM cuz cfv wcel cM cz wcel vn cv cz wcel cM vn cv
      cle wbr w3a cM cz wcel vn cv cz wcel wa cM vn cv cle wbr wa cM vn cv
      eluz2 cM cz wcel vn cv cz wcel cM vn cv cle wbr df-3an bitri anbi1i cM cz
      wcel vn cv cz wcel wa cM vn cv cle wbr wph anass cM cz wcel vn cv cz wcel
      wa cM vn cv cle wbr wph wa wa cM cz wcel vn cv cz wcel cM vn cv cle wbr
      wph wa wa wa vn cv cz wcel cM cz wcel cM vn cv cle wbr wph wa wa wa cM cz
      wcel vn cv cz wcel cM vn cv cle wbr wph wa anass cM cz wcel vn cv cz wcel
      cM vn cv cle wbr wph wa an12 bitri 3bitri rexbii2 cM cz wcel cM vn cv cle
      wbr wph wa vn cz r19.42v bitri $.
      $( [17-Oct-2005] $) $( [9-Sep-2005] $)

    $( Double existential quantification in a set of upper integers. $)
    2rexuz $p |- ( E. m E. n e. ( ZZ>= ` m ) ph <->
                  E. m e. ZZ E. n e. ZZ ( m <_ n /\ ph ) ) $=
      wph vn vm cv cuz cfv wrex vm wex vm cv cz wcel vm cv vn cv cle wbr wph wa
      vn cz wrex wa vm wex vm cv vn cv cle wbr wph wa vn cz wrex vm cz wrex wph
      vn vm cv cuz cfv wrex vm cv cz wcel vm cv vn cv cle wbr wph wa vn cz wrex
      wa vm wph vn vm cv rexuz2 exbii vm cv vn cv cle wbr wph wa vn cz wrex vm
      cz df-rex bitr4i $.
      $( [4-Nov-2005] $) $( [3-Nov-2005] $)
  $}

  $( Second Peano postulate for a set of upper integers. $)
  peano2uz $p |- ( N e. ( ZZ>= ` M ) ->
                 ( N + 1 ) e. ( ZZ>= ` M ) ) $=
    cM cz wcel cN cz wcel cM cN cle wbr w3a cM cz wcel cN c1 caddc co cz wcel
    cM cN c1 caddc co cle wbr w3a cN cM cuz cfv wcel cN c1 caddc co cM cuz cfv
    wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cM cz wcel cN c1 caddc co cz
    wcel cM cN c1 caddc co cle wbr cM cz wcel cN cz wcel cM cN cle wbr 3simp1
    cN cz wcel cM cz wcel cN c1 caddc co cz wcel cM cN cle wbr cN peano2z
    3ad2ant2 cM cr wcel cN cz wcel cM cN cle wbr cM cN c1 caddc co cle wbr cM
    cz wcel cM cr wcel cN cr wcel cM cN cle wbr cM cN c1 caddc co cle wbr cN cz
    wcel cM cN letrp1 cN zre syl3an2 cM zre syl3an1 3jca cM cN eluz2 cM cN c1
    caddc co eluz2 3imtr4i $.
    $( [12-Sep-2005] $) $( [7-Sep-2005] $)

  $( Reversed second Peano axiom for upper integers. $)
  peano2uzr $p |- ( ( M e. ZZ /\
             N e. ( ZZ>= ` ( M + 1 ) ) ) -> N e. ( ZZ>= ` M ) ) $=
    cM cz wcel cN cM c1 caddc co cuz cfv wcel wa cN c1 cmin co c1 caddc co cN
    cM cuz cfv cN cM c1 caddc co cuz cfv wcel cN c1 cmin co c1 caddc co cN wceq
    cM cz wcel cN cM c1 caddc co cuz cfv wcel cN cz wcel cN cc wcel cN c1 cmin
    co c1 caddc co cN wceq cM c1 caddc co cN eluzelz cN zcn cN cc wcel c1 cc
    wcel cN c1 cmin co c1 caddc co cN wceq ax1cn cN c1 npcan mpan2 3syl adantl
    cM cz wcel cN cM c1 caddc co cuz cfv wcel wa cN c1 cmin co cM cuz cfv wcel
    cN c1 cmin co c1 caddc co cM cuz cfv wcel cM cN eluzp1m1 cM cN c1 cmin co
    peano2uz syl eqeltrrd $.
    $( [3-Jan-2006] $) $( [2-Jan-2006] $)

  ${
    $d j K $.  $d j k M $.  $d j k N $.
    $( Addition closure law for a set of upper integers. $)
    uzaddcl $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. NN0 ) ->
                   ( N + K ) e. ( ZZ>= ` M ) ) $=
      cK cn0 wcel cN cM cuz cfv wcel cN cK caddc co cM cuz cfv wcel cN cM cuz
      cfv wcel cN vj cv caddc co cM cuz cfv wcel wi cN cM cuz cfv wcel cN cc0
      caddc co cM cuz cfv wcel wi cN cM cuz cfv wcel cN vk cv caddc co cM cuz
      cfv wcel wi cN cM cuz cfv wcel cN vk cv c1 caddc co caddc co cM cuz cfv
      wcel wi cN cM cuz cfv wcel cN cK caddc co cM cuz cfv wcel wi vj vk cK vk
      cv cn0 wcel cN cM cuz cfv wcel cN vk cv caddc co cM cuz cfv wcel cN vk cv
      c1 caddc co caddc co cM cuz cfv wcel vk cv cn0 wcel cN cM cuz cfv wcel cN
      vk cv caddc co cM cuz cfv wcel cN vk cv c1 caddc co caddc co cM cuz cfv
      wcel vk cv cn0 wcel cN cM cuz cfv wcel wa cN vk cv caddc co cM cuz cfv
      wcel wa cN vk cv caddc co c1 caddc co cN vk cv c1 caddc co caddc co cM
      cuz cfv vk cv cn0 wcel cN cM cuz cfv wcel wa cN vk cv caddc co c1 caddc
      co cN vk cv c1 caddc co caddc co wceq cN vk cv caddc co cM cuz cfv wcel
      cN cM cuz cfv wcel vk cv cn0 wcel cN vk cv caddc co c1 caddc co cN vk cv
      c1 caddc co caddc co wceq cN cc wcel vk cv cc wcel cN vk cv caddc co c1
      caddc co cN vk cv c1 caddc co caddc co wceq cN cM cuz cfv wcel vk cv cn0
      wcel cN cc wcel vk cv cc wcel c1 cc wcel cN vk cv caddc co c1 caddc co cN
      vk cv c1 caddc co caddc co wceq ax1cn cN vk cv c1 addass mp3an3 cN cM cuz
      cfv wcel cN cz wcel cN cc wcel cM cN eluzelz cN zcn syl vk cv nn0cn
      syl2an ancoms adantr cN vk cv caddc co cM cuz cfv wcel cN vk cv caddc co
      c1 caddc co cM cuz cfv wcel vk cv cn0 wcel cN cM cuz cfv wcel wa cM cN vk
      cv caddc co peano2uz adantl eqeltrrd exp31 a2d cN cM cuz cfv wcel cN cc0
      caddc co cM cuz cfv wcel cN cM cuz cfv wcel cN cc0 caddc co cN cM cuz cfv
      cN cM cuz cfv wcel cN cc wcel cN cc0 caddc co cN wceq cN cM cuz cfv wcel
      cN cz wcel cN cc wcel cM cN eluzelz cN zcn syl cN addid1 syl eleq1d ibir
      vj cv cc0 wceq cN vj cv caddc co cM cuz cfv wcel cN cc0 caddc co cM cuz
      cfv wcel cN cM cuz cfv wcel vj cv cc0 wceq cN vj cv caddc co cN cc0 caddc
      co cM cuz cfv vj cv cc0 cN caddc opreq2 eleq1d imbi2d vj cv vk cv wceq cN
      vj cv caddc co cM cuz cfv wcel cN vk cv caddc co cM cuz cfv wcel cN cM
      cuz cfv wcel vj cv vk cv wceq cN vj cv caddc co cN vk cv caddc co cM cuz
      cfv vj cv vk cv cN caddc opreq2 eleq1d imbi2d vj cv vk cv c1 caddc co
      wceq cN vj cv caddc co cM cuz cfv wcel cN vk cv c1 caddc co caddc co cM
      cuz cfv wcel cN cM cuz cfv wcel vj cv vk cv c1 caddc co wceq cN vj cv
      caddc co cN vk cv c1 caddc co caddc co cM cuz cfv vj cv vk cv c1 caddc co
      cN caddc opreq2 eleq1d imbi2d vj cv cK wceq cN vj cv caddc co cM cuz cfv
      wcel cN cK caddc co cM cuz cfv wcel cN cM cuz cfv wcel vj cv cK wceq cN
      vj cv caddc co cN cK caddc co cM cuz cfv vj cv cK cN caddc opreq2 eleq1d
      imbi2d nn0indALT impcom $.
      $( [4-Jun-2006] $) $( [4-Jun-2006] $)
  $}

  ${
    $d j m N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.
    $d k ph $.  $d j k m M $.
    $( Substitutions. $)
    uzind4.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind4.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind4.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind4.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind4.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind4.6 $e |- ( k e. ( ZZ>= ` M ) -> ( ch -> th ) ) $.
    $( Induction on the set of upper integers that starts at an integer
       ` M ` .  The first four hypotheses give us the substitution instances we
       need, and the last two are the basis and the induction hypothesis. $)
    uzind4 $p |- ( N e. ( ZZ>= ` M ) -> ta ) $=
      cM cz wcel cN cM vm cv cle wbr vm cz crab wcel wta cN cM cuz cfv wcel wph
      wps wch wth wta vj vm vk cM cN uzind4.1 uzind4.2 uzind4.3 uzind4.4
      uzind4.5 cM cz wcel vk cv cM vm cv cle wbr vm cz crab wcel wa vk cv cM
      cuz cfv wcel wch wth wi cM cz wcel vk cv cz wcel cM vk cv cle wbr wa vk
      cv cM cuz cfv wcel vk cv cM vm cv cle wbr vm cz crab wcel cM cz wcel vk
      cv cz wcel cM vk cv cle wbr vk cv cM cuz cfv wcel vk cv cM cuz cfv wcel
      cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM vk cv eluz2 biimpri
      3expb cM vm cv cle wbr cM vk cv cle wbr vm vk cv cz vm cv vk cv cM cle
      breq2 elrab sylan2b uzind4.6 syl uzind3 cM cN eluzel2 cN cM vm cv cle wbr
      vm cz crab wcel cN cz wcel cM cN cle wbr cN cM cuz cfv wcel cM vm cv cle
      wbr cM cN cle wbr vm cN cz vm cv cN cM cle breq2 elrab cM cN eluzelz cM
      cN eluzle sylanbrc sylanc $.
      $( [24-Sep-2005] $) $( [7-Sep-2005] $)
  $}

  ${
    $d j N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.
    $d k ph $.  $d j k M $.
    $( Basis. $)
    uzind4ALT.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind4ALT.6 $e |- ( k e. ( ZZ>= ` M ) -> ( ch -> th ) ) $.
    $( Substitutions. $)
    uzind4ALT.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind4ALT.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind4ALT.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind4ALT.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Alternate version of ~ uzind4 with different hypothesis order for easier
       use with the Metamath Proof Assistant, since "assign last" will assign
       the substitutions first.  (This may or may not be kept permanenently,
       or it may replace ~ uzind4 - I haven't decided yet. -nm) $)
    uzind4ALT $p |- ( N e. ( ZZ>= ` M ) -> ta ) $=
      wph wps wch wth wta vj vk cM cN uzind4ALT.1 uzind4ALT.2 uzind4ALT.3
      uzind4ALT.4 uzind4ALT.5 uzind4ALT.6 uzind4 $.
      $( [14-Jan-2006] $) $( [7-Sep-2005] $)
  $}

  ${
    $d m k j M $.  $d j N $.  $d j m ph $.
    $( Basis. $)
    uzind4s.1 $e |- ( M e. ZZ -> [ M / k ] ph ) $.
    $( Induction hypothesis. $)
    uzind4s.2 $e |- ( k e. ( ZZ>= ` M ) -> ( ph -> [ ( k + 1 ) / k ] ph ) ) $.
    $( Induction on the set of upper integers that starts at an integer
       ` M ` , using explicit substitution.  The hypotheses are the basis and
       the induction hypothesis. $)
    uzind4s $p |- ( N e. ( ZZ>= ` M ) -> [ N / k ] ph ) $=
      wph vk vj cv wsbc wph vk cM wsbc wph vk vm cv wsbc wph vk vm cv c1 caddc
      co wsbc wph vk cN wsbc vj vm cM cN wph vk vj cv cM dfsbcq wph vk vj cv vm
      cv dfsbcq wph vk vj cv vm cv c1 caddc co dfsbcq wph vk vj cv cN dfsbcq
      uzind4s.1 vk cv cM cuz cfv wcel wph wph vk vk cv c1 caddc co wsbc wi wi
      vm cv cM cuz cfv wcel wph vk vm cv wsbc wph vk vm cv c1 caddc co wsbc wi
      wi vk vm vm cv cM cuz cfv wcel wph vk vm cv wsbc wph vk vm cv c1 caddc co
      wsbc wi vk vm cv cM cuz cfv wcel vk ax-17 wph vk vm cv wsbc wph vk vm cv
      c1 caddc co wsbc vk wph vk vm cv vm visset hbsbc1v wph vk vm cv c1 caddc
      co vm cv c1 caddc oprex hbsbc1v hbim hbim vk cv vm cv wceq vk cv cM cuz
      cfv wcel vm cv cM cuz cfv wcel wph wph vk vk cv c1 caddc co wsbc wi wph
      vk vm cv wsbc wph vk vm cv c1 caddc co wsbc wi vk cv vm cv cM cuz cfv
      eleq1 vk cv vm cv wceq wph wph vk vm cv wsbc wph vk vk cv c1 caddc co
      wsbc wph vk vm cv c1 caddc co wsbc wph vk vm sbequ12 vk cv vm cv wceq vk
      cv c1 caddc co vm cv c1 caddc co wceq wph vk vk cv c1 caddc co wsbc wph
      vk vm cv c1 caddc co wsbc wb vk cv vm cv c1 caddc opreq1 wph vk vk cv c1
      caddc co vm cv c1 caddc co dfsbcq syl imbi12d imbi12d uzind4s.2 chvar
      uzind4 $.
      $( [21-Feb-2006] $) $( [4-Nov-2005] $)
  $}

  ${
    $d k m n M $.  $d m N $.  $d k m n ph $.  $d j k m n $.
    $( Basis. $)
    uzind4s2.1 $e |- ( M e. ZZ -> [ M / j ] ph ) $.
    $( Induction hypothesis. $)
    uzind4s2.2 $e |- ( k e. ( ZZ>= ` M ) ->
                     ( [ k / j ] ph -> [ ( k + 1 ) / j ] ph ) ) $.
    $( Induction on the set of upper integers that starts at an integer
       ` M ` , using explicit substitution.  The hypotheses are the basis and
       the induction hypothesis.  Use this instead of ~ uzind4s when ` j `
       and ` k ` must be distinct in ` [ ( k + 1 ) / j ] ph ` . $)
    uzind4s2 $p |- ( N e. ( ZZ>= ` M ) -> [ N / j ] ph ) $=
      wph vj vm cv wsbc wph vj cM wsbc wph vj vn cv wsbc wph vj vn cv c1 caddc
      co wsbc wph vj cN wsbc vm vn cM cN wph vj vm cv cM dfsbcq wph vj vm cv vn
      cv dfsbcq wph vj vm cv vn cv c1 caddc co dfsbcq wph vj vm cv cN dfsbcq
      uzind4s2.1 vk cv cM cuz cfv wcel wph vj vk cv wsbc wph vj vk cv c1 caddc
      co wsbc wi wi vn cv cM cuz cfv wcel wph vj vn cv wsbc wph vj vn cv c1
      caddc co wsbc wi wi vk vn vn cv cM cuz cfv wcel wph vj vn cv wsbc wph vj
      vn cv c1 caddc co wsbc wi vk vn cv cM cuz cfv wcel vk ax-17 wph vj vn cv
      wsbc wph vj vn cv c1 caddc co wsbc vk wph vj vn cv wsbc vk ax-17 wph vj
      vn cv c1 caddc co wsbc vk ax-17 hbim hbim vk cv vn cv wceq vk cv cM cuz
      cfv wcel vn cv cM cuz cfv wcel wph vj vk cv wsbc wph vj vk cv c1 caddc co
      wsbc wi wph vj vn cv wsbc wph vj vn cv c1 caddc co wsbc wi vk cv vn cv cM
      cuz cfv eleq1 vk cv vn cv wceq wph vj vk cv wsbc wph vj vn cv wsbc wph vj
      vk cv c1 caddc co wsbc wph vj vn cv c1 caddc co wsbc wph vj vk cv vn cv
      dfsbcq vk cv vn cv wceq vk cv c1 caddc co vn cv c1 caddc co wceq wph vj
      vk cv c1 caddc co wsbc wph vj vn cv c1 caddc co wsbc wb vk cv vn cv c1
      caddc opreq1 wph vj vk cv c1 caddc co vn cv c1 caddc co dfsbcq syl
      imbi12d imbi12d uzind4s2.2 chvar uzind4 $.
      $( [7-Mar-2006] $) $( [16-Nov-2005] $)
  $}

  ${
    $d j m N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.
    $d k ph $.  $d j k m M $.
    $( Lower bound. $)
    uzind4i.1 $e |- M e. ZZ $.
    $( Substitutions. $)
    uzind4i.2 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind4i.3 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind4i.4 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind4i.5 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind4i.6 $e |- ps $.
    $( Induction hypothesis. $)
    uzind4i.7 $e |- ( k e. ( ZZ>= ` M ) -> ( ch -> th ) ) $.
    $( Induction on the upper integers that start at ` M ` .  The first
       hypothesis specifies the lower bound, the next four give us the
       substitution instances we need, and the last two are the basis and the
       induction hypothesis. $)
    uzind4i $p |- ( N e. ( ZZ>= ` M ) -> ta ) $=
      cN cM cuz cfv wcel cN cM vm cv cle wbr vm cz crab wcel wta cM cuz cfv cM
      vm cv cle wbr vm cz crab cN cM cz wcel cM cuz cfv cM vm cv cle wbr vm cz
      crab wceq uzind4i.1 vm cM uzval ax-mp eleq2i cM cz wcel cN cM vm cv cle
      wbr vm cz crab wcel wta uzind4i.1 wph wps wch wth wta vj vm vk cM cN
      uzind4i.2 uzind4i.3 uzind4i.4 uzind4i.5 wps cM cz wcel uzind4i.6 a1i vk
      cv cM vm cv cle wbr vm cz crab wcel wch wth wi cM cz wcel vk cv cM vm cv
      cle wbr vm cz crab wcel vk cv cM cuz cfv wcel wch wth wi cM cuz cfv cM vm
      cv cle wbr vm cz crab vk cv cM cz wcel cM cuz cfv cM vm cv cle wbr vm cz
      crab wceq uzind4i.1 vm cM uzval ax-mp eleq2i uzind4i.7 sylbir adantl
      uzind3 mpan sylbi $.
      $( [1-Oct-2005] $) $( [4-Sep-2005] $)
  $}

  ${
    $d h t n m M $.  $d h j t k m n S $.
    $( Well-ordering principle:  any non-empty subset of a set of upper
       integers has a least element. $)
    uzwo $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) ) ->
               E. j e. S A. k e. S j <_ k ) $=
      cS cM cuz cfv wss cS c0 wne wa vj cv vt cv cle wbr vt cS wral vj cS wrex
      vj cv vk cv cle wbr vk cS wral vj cS wrex cS cM cuz cfv wss cS c0 wne vj
      cv vt cv cle wbr vt cS wral vj cS wrex cS cM cuz cfv wss vj cv vt cv cle
      wbr vt cS wral vj cS wrex cS c0 cS cM cuz cfv wss vj cv vt cv cle wbr vt
      cS wral vj cS wrex wn vn cv cS wcel wn vn wal cS c0 wceq cS cM cuz cfv
      wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn vn cv cS wcel wn vn cS
      cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn vn cv cS wcel
      wn vn cv cM cuz cfv wcel cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral
      vj cS wrex wn wa vn cv cS wcel wn wi vn cv cM cuz cfv wcel cS cM cuz cfv
      wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vn cv vt cv cle wbr
      vt cS wral vn cv cS wcel wn cS cM cuz cfv wss vj cv vt cv cle wbr vt cS
      wral vj cS wrex wn wa vh cv vt cv cle wbr vt cS wral wi cS cM cuz cfv wss
      vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa cM vt cv cle wbr vt cS
      wral wi cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa
      vm cv vt cv cle wbr vt cS wral wi cS cM cuz cfv wss vj cv vt cv cle wbr
      vt cS wral vj cS wrex wn wa vm cv c1 caddc co vt cv cle wbr vt cS wral wi
      cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vn cv
      vt cv cle wbr vt cS wral wi vh vm cM vn cv vh cv cM wceq vh cv vt cv cle
      wbr vt cS wral cM vt cv cle wbr vt cS wral cS cM cuz cfv wss vj cv vt cv
      cle wbr vt cS wral vj cS wrex wn wa vh cv cM wceq vh cv vt cv cle wbr cM
      vt cv cle wbr vt cS vh cv cM vt cv cle breq1 ralbidv imbi2d vh cv vm cv
      wceq vh cv vt cv cle wbr vt cS wral vm cv vt cv cle wbr vt cS wral cS cM
      cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vh cv vm cv
      wceq vh cv vt cv cle wbr vm cv vt cv cle wbr vt cS vh cv vm cv vt cv cle
      breq1 ralbidv imbi2d vh cv vm cv c1 caddc co wceq vh cv vt cv cle wbr vt
      cS wral vm cv c1 caddc co vt cv cle wbr vt cS wral cS cM cuz cfv wss vj
      cv vt cv cle wbr vt cS wral vj cS wrex wn wa vh cv vm cv c1 caddc co wceq
      vh cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr vt cS vh cv vm cv c1
      caddc co vt cv cle breq1 ralbidv imbi2d vh cv vn cv wceq vh cv vt cv cle
      wbr vt cS wral vn cv vt cv cle wbr vt cS wral cS cM cuz cfv wss vj cv vt
      cv cle wbr vt cS wral vj cS wrex wn wa vh cv vn cv wceq vh cv vt cv cle
      wbr vn cv vt cv cle wbr vt cS vh cv vn cv vt cv cle breq1 ralbidv imbi2d
      cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa cM vt
      cv cle wbr vt cS wral wi cM cz wcel cS cM cuz cfv wss cM vt cv cle wbr vt
      cS wral vj cv vt cv cle wbr vt cS wral vj cS wrex wn cS cM cuz cfv wss cM
      vt cv cle wbr vt cS cS cM cuz cfv wss vt cv cS wcel vt cv cM cuz cfv wcel
      cM vt cv cle wbr cS cM cuz cfv vt cv ssel cM vt cv eluzle syl6 r19.21aiv
      adantr a1i vm cv cM cuz cfv wcel cS cM cuz cfv wss vj cv vt cv cle wbr vt
      cS wral vj cS wrex wn wa vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co
      vt cv cle wbr vt cS wral vm cv cM cuz cfv wcel cS cz wss vj cv vt cv cle
      wbr vt cS wral vj cS wrex wn vm cv vt cv cle wbr vt cS wral vm cv c1
      caddc co vt cv cle wbr vt cS wral wi cS cM cuz cfv wss vm cv cM cuz cfv
      wcel vm cv cz wcel cS cz wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn
      wa vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co vt cv cle wbr vt cS
      wral wi wi cM vm cv eluzelz vm cv cz wcel cS cz wss vj cv vt cv cle wbr
      vt cS wral vj cS wrex wn vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co
      vt cv cle wbr vt cS wral wi vm cv cz wcel cS cz wss vj cv vt cv cle wbr
      vt cS wral vj cS wrex wn vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co
      vt cv cle wbr vt cS wral wi vm cv cz wcel cS cz wss wa vj cv vt cv cle
      wbr vt cS wral vj cS wrex wn wa vm cv vt cv cle wbr vt cS wral vm cv c1
      caddc co vt cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS wral vj cS
      wrex wn vm cv vt cv cle wbr vt cS wral vm cv cS wcel wn vm cv cz wcel cS
      cz wss wa vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co vt cv cle wbr
      vt cS wral wi vm cv vt cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS
      wral vj cS wrex wn vm cv cS wcel wn vm cv vt cv cle wbr vt cS wral vm cv
      cS wcel vj cv vt cv cle wbr vt cS wral vj cS wrex vm cv cS wcel vm cv vt
      cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS wral vj cS wrex vj cv vt
      cv cle wbr vt cS wral vm cv vt cv cle wbr vt cS wral vj vm cv cS vj cv vm
      cv wceq vj cv vt cv cle wbr vm cv vt cv cle wbr vt cS vj cv vm cv vt cv
      cle breq1 ralbidv rcla4ev expcom con3d com12 vm cv cz wcel cS cz wss wa
      vm cv cS wcel wn vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co vt cv
      cle wbr vt cS wral wi vm cv cz wcel cS cz wss wa vm cv cS wcel wn wa vm
      cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr vt cS vm cv cz wcel cS
      cz wss vm cv cS wcel wn vt cv cS wcel vm cv vt cv cle wbr vm cv c1 caddc
      co vt cv cle wbr wi vm cv cz wcel cS cz wss vt cv cS wcel vm cv cS wcel
      wn vm cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr wi vm cv cz wcel
      cS cz wss vt cv cS wcel vm cv cS wcel wn vm cv vt cv cle wbr vm cv c1
      caddc co vt cv cle wbr wi wi vm cv cz wcel cS cz wss vt cv cS wcel wa wa
      vm cv vt cv cle wbr vm cv cS wcel wn vm cv c1 caddc co vt cv cle wbr vm
      cv cz wcel cS cz wss vt cv cS wcel wa wa vm cv vt cv cle wbr vm cv c1
      caddc co vt cv cle wbr wn vm cv cS wcel wi vm cv cS wcel wn vm cv c1
      caddc co vt cv cle wbr wi vm cv cz wcel cS cz wss vt cv cS wcel wa wa vm
      cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr wn vm cv cS wcel vm cv
      cz wcel cS cz wss vt cv cS wcel wa wa vm cv vt cv cle wbr vm cv c1 caddc
      co vt cv cle wbr wn wa vm cv vt cv wceq vm cv cS wcel vm cv cz wcel vt cv
      cz wcel vm cv vt cv wceq vm cv vt cv cle wbr vm cv c1 caddc co vt cv cle
      wbr wn wa wb cS cz wss vt cv cS wcel wa vm cv cz wcel vt cv cz wcel wa vm
      cv vt cv wceq vm cv vt cv cle wbr vt cv vm cv cle wbr wa vm cv vt cv cle
      wbr vm cv c1 caddc co vt cv cle wbr wn wa vm cv cr wcel vt cv cr wcel vm
      cv vt cv wceq vm cv vt cv cle wbr vt cv vm cv cle wbr wa wb vm cv cz wcel
      vt cv cz wcel vm cv vt cv letri3 vm cv zre vt cv zre syl2an vm cv cz wcel
      vt cv cz wcel wa vt cv vm cv cle wbr vm cv c1 caddc co vt cv cle wbr wn
      vm cv vt cv cle wbr vt cv cz wcel vm cv cz wcel vt cv vm cv cle wbr vm cv
      c1 caddc co vt cv cle wbr wn wb vt cv cz wcel vm cv cz wcel wa vt cv vm
      cv cle wbr vt cv vm cv c1 caddc co clt wbr vm cv c1 caddc co vt cv cle
      wbr wn vt cv vm cv zleltp1 vt cv cr wcel vm cv c1 caddc co cr wcel vt cv
      vm cv c1 caddc co clt wbr vm cv c1 caddc co vt cv cle wbr wn wb vt cv cz
      wcel vm cv cz wcel vt cv vm cv c1 caddc co ltnle vt cv zre vm cv cz wcel
      vm cv cr wcel vm cv c1 caddc co cr wcel vm cv zre vm cv peano2re syl
      syl2an bitrd ancoms anbi2d bitrd cS cz vt cv ssel2 sylan2 vt cv cS wcel
      vm cv vt cv wceq vm cv cS wcel wi vm cv cz wcel cS cz wss vt cv cS vm cv
      eleq1a ad2antll sylbird exp3a vm cv c1 caddc co vt cv cle wbr vm cv cS
      wcel con1 syl6 com23 exp32 com34 imp41 r19.20dva ex sylan9r pm2.43d exp31
      imp3a syl cS cM cuz cfv wss cM cuz cfv cz wss cS cz wss cM uzssz cS cM
      cuz cfv cz sstr mpan2 sylani a2d uzind4 vj cv vt cv cle wbr vt cS wral vj
      cS wrex wn vn cv vt cv cle wbr vt cS wral vn cv cS wcel wn wi cS cM cuz
      cfv wss vn cv vt cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS wral vj
      cS wrex wn vn cv cS wcel wn vn cv vt cv cle wbr vt cS wral vn cv cS wcel
      vj cv vt cv cle wbr vt cS wral vj cS wrex vn cv cS wcel vn cv vt cv cle
      wbr vt cS wral vj cv vt cv cle wbr vt cS wral vj cS wrex vj cv vt cv cle
      wbr vt cS wral vn cv vt cv cle wbr vt cS wral vj vn cv cS vj cv vn cv
      wceq vj cv vt cv cle wbr vn cv vt cv cle wbr vt cS vj cv vn cv vt cv cle
      breq1 ralbidv rcla4ev expcom con3d com12 adantl sylcom vn cv cM cuz cfv
      wcel wn cS cM cuz cfv wss vn cv cS wcel wn vj cv vt cv cle wbr vt cS wral
      vj cS wrex wn cS cM cuz cfv wss vn cv cM cuz cfv wcel wn vn cv cS wcel wn
      cS cM cuz cfv wss vn cv cS wcel vn cv cM cuz cfv wcel cS cM cuz cfv vn cv
      ssel con3d com12 adantrd pm2.61i ex 19.21adv vn cS eq0 syl6ibr necon1ad
      imp vj cv vt cv cle wbr vt cS wral vj cv vk cv cle wbr vk cS wral vj cS
      vj cv vt cv cle wbr vj cv vk cv cle wbr vt vk cS vt cv vk cv vj cv cle
      breq2 cbvralv rexbii sylib $.
      $( [17-Apr-2007] $) $( [8-Oct-2005] $)

    $( Well-ordering principle:  any non-empty subset of the upper integers
       has a least element. $)
    uzwoOLD $p |- ( ( S C_ ( ZZ>= ` M ) /\ -. S = (/) ) ->
               E. j e. S A. k e. S j <_ k ) $=
      cS cM cuz cfv wss cS c0 wceq wn wa vj cv vt cv cle wbr vt cS wral vj cS
      wrex vj cv vk cv cle wbr vk cS wral vj cS wrex cS cM cuz cfv wss cS c0
      wceq wn vj cv vt cv cle wbr vt cS wral vj cS wrex cS cM cuz cfv wss vj cv
      vt cv cle wbr vt cS wral vj cS wrex cS c0 wceq cS cM cuz cfv wss vj cv vt
      cv cle wbr vt cS wral vj cS wrex wn vn cv cS wcel wn vn wal cS c0 wceq cS
      cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn vn cv cS wcel
      wn vn cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn vn
      cv cS wcel wn vn cv cM cuz cfv wcel cS cM cuz cfv wss vj cv vt cv cle wbr
      vt cS wral vj cS wrex wn wa vn cv cS wcel wn wi vn cv cM cuz cfv wcel cS
      cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vn cv vt
      cv cle wbr vt cS wral vn cv cS wcel wn cS cM cuz cfv wss vj cv vt cv cle
      wbr vt cS wral vj cS wrex wn wa vh cv vt cv cle wbr vt cS wral wi cS cM
      cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa cM vt cv cle
      wbr vt cS wral wi cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS
      wrex wn wa vm cv vt cv cle wbr vt cS wral wi cS cM cuz cfv wss vj cv vt
      cv cle wbr vt cS wral vj cS wrex wn wa vm cv c1 caddc co vt cv cle wbr vt
      cS wral wi cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn
      wa vn cv vt cv cle wbr vt cS wral wi vh vm cM vn cv vh cv cM wceq vh cv
      vt cv cle wbr vt cS wral cM vt cv cle wbr vt cS wral cS cM cuz cfv wss vj
      cv vt cv cle wbr vt cS wral vj cS wrex wn wa vh cv cM wceq vh cv vt cv
      cle wbr cM vt cv cle wbr vt cS vh cv cM vt cv cle breq1 ralbidv imbi2d vh
      cv vm cv wceq vh cv vt cv cle wbr vt cS wral vm cv vt cv cle wbr vt cS
      wral cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vh
      cv vm cv wceq vh cv vt cv cle wbr vm cv vt cv cle wbr vt cS vh cv vm cv
      vt cv cle breq1 ralbidv imbi2d vh cv vm cv c1 caddc co wceq vh cv vt cv
      cle wbr vt cS wral vm cv c1 caddc co vt cv cle wbr vt cS wral cS cM cuz
      cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vh cv vm cv c1
      caddc co wceq vh cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr vt cS
      vh cv vm cv c1 caddc co vt cv cle breq1 ralbidv imbi2d vh cv vn cv wceq
      vh cv vt cv cle wbr vt cS wral vn cv vt cv cle wbr vt cS wral cS cM cuz
      cfv wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vh cv vn cv wceq
      vh cv vt cv cle wbr vn cv vt cv cle wbr vt cS vh cv vn cv vt cv cle breq1
      ralbidv imbi2d cS cM cuz cfv wss vj cv vt cv cle wbr vt cS wral vj cS
      wrex wn wa cM vt cv cle wbr vt cS wral wi cM cz wcel cS cM cuz cfv wss cM
      vt cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS wral vj cS wrex wn cS
      cM cuz cfv wss cM vt cv cle wbr vt cS cS cM cuz cfv wss vt cv cS wcel vt
      cv cM cuz cfv wcel cM vt cv cle wbr cS cM cuz cfv vt cv ssel cM vt cv
      eluzle syl6 r19.21aiv adantr a1i vm cv cM cuz cfv wcel cS cM cuz cfv wss
      vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vm cv vt cv cle wbr vt cS
      wral vm cv c1 caddc co vt cv cle wbr vt cS wral vm cv cM cuz cfv wcel cS
      cz wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn vm cv vt cv cle wbr
      vt cS wral vm cv c1 caddc co vt cv cle wbr vt cS wral wi cS cM cuz cfv
      wss vm cv cM cuz cfv wcel vm cv cz wcel cS cz wss vj cv vt cv cle wbr vt
      cS wral vj cS wrex wn wa vm cv vt cv cle wbr vt cS wral vm cv c1 caddc co
      vt cv cle wbr vt cS wral wi wi cM vm cv eluzelz vm cv cz wcel cS cz wss
      vj cv vt cv cle wbr vt cS wral vj cS wrex wn vm cv vt cv cle wbr vt cS
      wral vm cv c1 caddc co vt cv cle wbr vt cS wral wi vm cv cz wcel cS cz
      wss vj cv vt cv cle wbr vt cS wral vj cS wrex wn vm cv vt cv cle wbr vt
      cS wral vm cv c1 caddc co vt cv cle wbr vt cS wral wi vm cv cz wcel cS cz
      wss wa vj cv vt cv cle wbr vt cS wral vj cS wrex wn wa vm cv vt cv cle
      wbr vt cS wral vm cv c1 caddc co vt cv cle wbr vt cS wral vj cv vt cv cle
      wbr vt cS wral vj cS wrex wn vm cv vt cv cle wbr vt cS wral vm cv cS wcel
      wn vm cv cz wcel cS cz wss wa vm cv vt cv cle wbr vt cS wral vm cv c1
      caddc co vt cv cle wbr vt cS wral wi vm cv vt cv cle wbr vt cS wral vj cv
      vt cv cle wbr vt cS wral vj cS wrex wn vm cv cS wcel wn vm cv vt cv cle
      wbr vt cS wral vm cv cS wcel vj cv vt cv cle wbr vt cS wral vj cS wrex vm
      cv cS wcel vm cv vt cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS wral
      vj cS wrex vj cv vt cv cle wbr vt cS wral vm cv vt cv cle wbr vt cS wral
      vj vm cv cS vj cv vm cv wceq vj cv vt cv cle wbr vm cv vt cv cle wbr vt
      cS vj cv vm cv vt cv cle breq1 ralbidv rcla4ev expcom con3d com12 vm cv
      cz wcel cS cz wss wa vm cv cS wcel wn vm cv vt cv cle wbr vt cS wral vm
      cv c1 caddc co vt cv cle wbr vt cS wral wi vm cv cz wcel cS cz wss wa vm
      cv cS wcel wn wa vm cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr vt
      cS vm cv cz wcel cS cz wss vm cv cS wcel wn vt cv cS wcel vm cv vt cv cle
      wbr vm cv c1 caddc co vt cv cle wbr wi vm cv cz wcel cS cz wss vt cv cS
      wcel vm cv cS wcel wn vm cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr
      wi vm cv cz wcel cS cz wss vt cv cS wcel vm cv cS wcel wn vm cv vt cv cle
      wbr vm cv c1 caddc co vt cv cle wbr wi wi vm cv cz wcel cS cz wss vt cv
      cS wcel wa wa vm cv vt cv cle wbr vm cv cS wcel wn vm cv c1 caddc co vt
      cv cle wbr vm cv cz wcel cS cz wss vt cv cS wcel wa wa vm cv vt cv cle
      wbr vm cv c1 caddc co vt cv cle wbr wn vm cv cS wcel wi vm cv cS wcel wn
      vm cv c1 caddc co vt cv cle wbr wi vm cv cz wcel cS cz wss vt cv cS wcel
      wa wa vm cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr wn vm cv cS
      wcel vm cv cz wcel cS cz wss vt cv cS wcel wa wa vm cv vt cv cle wbr vm
      cv c1 caddc co vt cv cle wbr wn wa vm cv vt cv wceq vm cv cS wcel vm cv
      cz wcel vt cv cz wcel vm cv vt cv wceq vm cv vt cv cle wbr vm cv c1 caddc
      co vt cv cle wbr wn wa wb cS cz wss vt cv cS wcel wa vm cv cz wcel vt cv
      cz wcel wa vm cv vt cv wceq vm cv vt cv cle wbr vt cv vm cv cle wbr wa vm
      cv vt cv cle wbr vm cv c1 caddc co vt cv cle wbr wn wa vm cv cr wcel vt
      cv cr wcel vm cv vt cv wceq vm cv vt cv cle wbr vt cv vm cv cle wbr wa wb
      vm cv cz wcel vt cv cz wcel vm cv vt cv letri3 vm cv zre vt cv zre syl2an
      vm cv cz wcel vt cv cz wcel wa vt cv vm cv cle wbr vm cv c1 caddc co vt
      cv cle wbr wn vm cv vt cv cle wbr vt cv cz wcel vm cv cz wcel vt cv vm cv
      cle wbr vm cv c1 caddc co vt cv cle wbr wn wb vt cv cz wcel vm cv cz wcel
      wa vt cv vm cv cle wbr vt cv vm cv c1 caddc co clt wbr vm cv c1 caddc co
      vt cv cle wbr wn vt cv vm cv zleltp1 vt cv cr wcel vm cv c1 caddc co cr
      wcel vt cv vm cv c1 caddc co clt wbr vm cv c1 caddc co vt cv cle wbr wn
      wb vt cv cz wcel vm cv cz wcel vt cv vm cv c1 caddc co ltnle vt cv zre vm
      cv cz wcel vm cv cr wcel vm cv c1 caddc co cr wcel vm cv zre vm cv
      peano2re syl syl2an bitrd ancoms anbi2d bitrd cS cz vt cv ssel2 sylan2 vt
      cv cS wcel vm cv vt cv wceq vm cv cS wcel wi vm cv cz wcel cS cz wss vt
      cv cS vm cv eleq1a ad2antll sylbird exp3a vm cv c1 caddc co vt cv cle wbr
      vm cv cS wcel con1 syl6 com23 exp32 com34 imp41 r19.20dva ex sylan9r
      pm2.43d exp31 imp3a syl cS cM cuz cfv wss cM cuz cfv cz wss cS cz wss cM
      uzssz cS cM cuz cfv cz sstr mpan2 sylani a2d uzind4 vj cv vt cv cle wbr
      vt cS wral vj cS wrex wn vn cv vt cv cle wbr vt cS wral vn cv cS wcel wn
      wi cS cM cuz cfv wss vn cv vt cv cle wbr vt cS wral vj cv vt cv cle wbr
      vt cS wral vj cS wrex wn vn cv cS wcel wn vn cv vt cv cle wbr vt cS wral
      vn cv cS wcel vj cv vt cv cle wbr vt cS wral vj cS wrex vn cv cS wcel vn
      cv vt cv cle wbr vt cS wral vj cv vt cv cle wbr vt cS wral vj cS wrex vj
      cv vt cv cle wbr vt cS wral vn cv vt cv cle wbr vt cS wral vj vn cv cS vj
      cv vn cv wceq vj cv vt cv cle wbr vn cv vt cv cle wbr vt cS vj cv vn cv
      vt cv cle breq1 ralbidv rcla4ev expcom con3d com12 adantl sylcom vn cv cM
      cuz cfv wcel wn cS cM cuz cfv wss vn cv cS wcel wn vj cv vt cv cle wbr vt
      cS wral vj cS wrex wn cS cM cuz cfv wss vn cv cM cuz cfv wcel wn vn cv cS
      wcel wn cS cM cuz cfv wss vn cv cS wcel vn cv cM cuz cfv wcel cS cM cuz
      cfv vn cv ssel con3d com12 adantrd pm2.61i ex 19.21adv vn cS eq0 syl6ibr
      con1d imp vj cv vt cv cle wbr vt cS wral vj cv vk cv cle wbr vk cS wral
      vj cS vj cv vt cv cle wbr vj cv vk cv cle wbr vt vk cS vt cv vk cv vj cv
      cle breq2 cbvralv rexbii sylib $.
      $( [10-Oct-2005] $) $( [8-Oct-2005] $)

    $( Well-ordering principle:  any non-empty subset of upper integers has a
       unique least element. $)
    uzwo2 $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) ) ->
               E! j e. S A. k e. S j <_ k ) $=
      cS cM cuz cfv wss cS c0 wne vj cv vk cv cle wbr vk cS wral vj cS wrex vj
      cv vk cv cle wbr vk cS wral vj cS wreu cS vj vk cM uzwo cS cr wss vj cv
      vk cv cle wbr vk cS wral vj cS wrex vj cv vk cv cle wbr vk cS wral vj cS
      wreu cS cM cuz cfv wss vj vk cS lbreu cS cM cuz cfv wss cM cuz cfv cr wss
      cS cr wss cM cuz cfv cz cr cM uzssz zssre sstri cS cM cuz cfv cr sstr
      mpan2 sylan syldan $.
      $( [22-Apr-2007] $) $( [8-Oct-2005] $)
  $}

  ${
    $d x y A $.
    $( Well-ordering principle:  any non-empty set of natural numbers has a
       least element.  Theorem I.37 (well-ordering principle) of [Apostol]
       p. 34. $)
    nnwo $p |- ( ( A C_ NN /\ A =/= (/) ) -> E. x e. A A. y e. A x <_ y ) $=
      cA c1 cuz cfv wss cA c0 wceq wn vx cv vy cv cle wbr vy cA wral vx cA wrex
      cA cn wss cA c0 wne cA vx vy c1 uzwoOLD cn c1 cuz cfv cA nnuz sseq2i cA
      c0 df-ne syl2anb $.
      $( [11-Nov-2004] $) $( [17-Aug-2001] $)
  $}

  ${
    $d x y z w v $.  $d w v z A $.
    nnwof.1 $e |- ( z e. A -> A. x z e. A ) $.
    nnwof.2 $e |- ( z e. A -> A. y z e. A ) $.
    $( Well-ordering principle:  any non-empty set of natural numbers has a
       least element.  This version allows ` x ` and ` y ` to be present in
       ` A ` as long as they are effectively not free. $)
    nnwof $p |- ( ( A C_ NN /\ A =/= (/) ) -> E. x e. A A. y e. A x <_ y ) $=
      cA cn wss cA c0 wne wa vw cv vv cv cle wbr vv cA wral vw cA wrex vx cv vy
      cv cle wbr vy cA wral vx cA wrex vw vv cA nnwo vv cv cA wcel vw cv vv cv
      cle wbr wi vv wal vw cA wrex vy cv cA wcel vx cv vy cv cle wbr wi vy wal
      vx cA wrex vw cv vv cv cle wbr vv cA wral vw cA wrex vx cv vy cv cle wbr
      vy cA wral vx cA wrex vw cv cA wcel vv cv cA wcel vw cv vv cv cle wbr wi
      vv wal wa vw wex vx cv cA wcel vy cv cA wcel vx cv vy cv cle wbr wi vy
      wal wa vx wex vv cv cA wcel vw cv vv cv cle wbr wi vv wal vw cA wrex vy
      cv cA wcel vx cv vy cv cle wbr wi vy wal vx cA wrex vw cv cA wcel vv cv
      cA wcel vw cv vv cv cle wbr wi vv wal wa vw wex vw cv cA wcel vy cv cA
      wcel vw cv vy cv cle wbr wi vy wal wa vw wex vx cv cA wcel vy cv cA wcel
      vx cv vy cv cle wbr wi vy wal wa vx wex vw cv cA wcel vv cv cA wcel vw cv
      vv cv cle wbr wi vv wal wa vw cv cA wcel vy cv cA wcel vw cv vy cv cle
      wbr wi vy wal wa vw vv cv cA wcel vw cv vv cv cle wbr wi vv wal vy cv cA
      wcel vw cv vy cv cle wbr wi vy wal vw cv cA wcel vv cv cA wcel vw cv vv
      cv cle wbr wi vy cv cA wcel vw cv vy cv cle wbr wi vv vy vv cv cA wcel vw
      cv vv cv cle wbr vy vy vz vz vv cv cA vz cv vv cv wcel vy ax-17 nnwof.2
      hbel vw cv vv cv cle wbr vy ax-17 hbim vy cv cA wcel vw cv vy cv cle wbr
      wi vv ax-17 vv cv vy cv wceq vv cv cA wcel vy cv cA wcel vw cv vv cv cle
      wbr vw cv vy cv cle wbr vv cv vy cv cA eleq1 vv cv vy cv vw cv cle breq2
      imbi12d cbval anbi2i exbii vw cv cA wcel vy cv cA wcel vw cv vy cv cle
      wbr wi vy wal wa vx cv cA wcel vy cv cA wcel vx cv vy cv cle wbr wi vy
      wal wa vw vx vw cv cA wcel vy cv cA wcel vw cv vy cv cle wbr wi vy wal vx
      vx vz vz vw cv cA vz cv vw cv wcel vx ax-17 nnwof.1 hbel vy cv cA wcel vw
      cv vy cv cle wbr wi vx vy vy cv cA wcel vw cv vy cv cle wbr vx vx vz vz
      vy cv cA vz cv vy cv wcel vx ax-17 nnwof.1 hbel vw cv vy cv cle wbr vx
      ax-17 hbim hbal hban vx cv cA wcel vy cv cA wcel vx cv vy cv cle wbr wi
      vy wal wa vw ax-17 vw cv vx cv wceq vw cv cA wcel vx cv cA wcel vy cv cA
      wcel vw cv vy cv cle wbr wi vy wal vy cv cA wcel vx cv vy cv cle wbr wi
      vy wal vw cv vx cv cA eleq1 vw cv vx cv wceq vy cv cA wcel vw cv vy cv
      cle wbr wi vy cv cA wcel vx cv vy cv cle wbr wi vy vw cv vx cv wceq vw cv
      vy cv cle wbr vx cv vy cv cle wbr vy cv cA wcel vw cv vx cv vy cv cle
      breq1 imbi2d albidv anbi12d cbvex bitri vv cv cA wcel vw cv vv cv cle wbr
      wi vv wal vw cA df-rex vy cv cA wcel vx cv vy cv cle wbr wi vy wal vx cA
      df-rex 3bitr4i vw cv vv cv cle wbr vv cA wral vv cv cA wcel vw cv vv cv
      cle wbr wi vv wal vw cA vw cv vv cv cle wbr vv cA df-ral rexbii vx cv vy
      cv cle wbr vy cA wral vy cv cA wcel vx cv vy cv cle wbr wi vy wal vx cA
      vx cv vy cv cle wbr vy cA df-ral rexbii 3bitr4i sylib $.
      $( [17-Aug-2001] $)
  $}

  ${
    $d x y z $.  $d y z ph $.  $d x ps $.
    nnwos.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Well-ordering principle:  any non-empty set of natural numbers has a
       least element (schema form). $)
    nnwos $p |- ( E. x e. NN ph ->
                  E. x e. NN ( ph /\ A. y e. NN ( ps -> x <_ y ) ) ) $=
      wph vx cn crab cn wss wph vx cn crab c0 wne wa vx cv vy cv cle wbr vy wph
      vx cn crab wral vx wph vx cn crab wrex wph vx cn wrex wph wps vx cv vy cv
      cle wbr wi vy cn wral wa vx cn wrex vx vy vz wph vx cn crab wph vx vz cn
      hbrab1 vz cv wph vx cn crab wcel vy ax-17 nnwof wph vx cn crab cn wss wph
      vx cn crab c0 wne wa wph vx cn crab c0 wne wph vx cn wrex wph vx cn crab
      cn wss wph vx cn crab c0 wne wph vx cn ssrab2 biantrur wph vx cn rabn0
      bitr3i vx cv vy cv cle wbr vy wph vx cn crab wral vx wph vx cn crab wrex
      vx cv wph vx cn crab wcel vx cv vy cv cle wbr vy wph vx cn crab wral wa
      vx wex vx cv cn wcel wph wa vy cv cn wcel wps vx cv vy cv cle wbr wi wi
      vy wal wa vx wex wph wps vx cv vy cv cle wbr wi vy cn wral wa vx cn wrex
      vx cv vy cv cle wbr vy wph vx cn crab wral vx wph vx cn crab df-rex vx cv
      wph vx cn crab wcel vx cv vy cv cle wbr vy wph vx cn crab wral wa vx cv
      cn wcel wph wa vy cv cn wcel wps vx cv vy cv cle wbr wi wi vy wal wa vx
      vx cv wph vx cn crab wcel vx cv cn wcel wph wa vx cv vy cv cle wbr vy wph
      vx cn crab wral vy cv cn wcel wps vx cv vy cv cle wbr wi wi vy wal wph vx
      cn rabid vx cv vy cv cle wbr vy wph vx cn crab wral vy cv wph vx cn crab
      wcel vx cv vy cv cle wbr wi vy wal vy cv cn wcel wps vx cv vy cv cle wbr
      wi wi vy wal vx cv vy cv cle wbr vy wph vx cn crab df-ral vy cv wph vx cn
      crab wcel vx cv vy cv cle wbr wi vy cv cn wcel wps vx cv vy cv cle wbr wi
      wi vy vy cv wph vx cn crab wcel vx cv vy cv cle wbr wi vy cv cn wcel wps
      wa vx cv vy cv cle wbr wi vy cv cn wcel wps vx cv vy cv cle wbr wi wi vy
      cv wph vx cn crab wcel vy cv cn wcel wps wa vx cv vy cv cle wbr wph wps
      vx vy cv cn nnwos.1 elrab imbi1i vy cv cn wcel wps vx cv vy cv cle wbr
      impexp bitri albii bitri anbi12i exbii vx cv cn wcel wph wa vy cv cn wcel
      wps vx cv vy cv cle wbr wi wi vy wal wa vx wex vx cv cn wcel wph wps vx
      cv vy cv cle wbr wi vy cn wral wa wa vx wex wph wps vx cv vy cv cle wbr
      wi vy cn wral wa vx cn wrex vx cv cn wcel wph wa vy cv cn wcel wps vx cv
      vy cv cle wbr wi wi vy wal wa vx cv cn wcel wph wps vx cv vy cv cle wbr
      wi vy cn wral wa wa vx vx cv cn wcel wph wa vy cv cn wcel wps vx cv vy cv
      cle wbr wi wi vy wal wa vx cv cn wcel wph wa wps vx cv vy cv cle wbr wi
      vy cn wral wa vx cv cn wcel wph wps vx cv vy cv cle wbr wi vy cn wral wa
      wa wps vx cv vy cv cle wbr wi vy cn wral vy cv cn wcel wps vx cv vy cv
      cle wbr wi wi vy wal vx cv cn wcel wph wa wps vx cv vy cv cle wbr wi vy
      cn df-ral anbi2i vx cv cn wcel wph wps vx cv vy cv cle wbr wi vy cn wral
      anass bitr3i exbii wph wps vx cv vy cv cle wbr wi vy cn wral wa vx cn
      df-rex bitr4i 3bitri 3imtr3i $.
      $( [17-Aug-2001] $)
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    $( Substitutions. $)
    indstr.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Induction hypothesis. $)
    indstr.2 $e |- ( x e. NN -> ( A. y e. NN ( y < x -> ps ) -> ph ) ) $.
    $( Strong Mathematical Induction for positive integers (inference
       schema). $)
    indstr $p |- ( x e. NN -> ph ) $=
      wph vx cn wph vx cn wral wph wn vx cn wrex wn wph wn vx cn wrex wph wn
      wps wn vx cv vy cv cle wbr wi vy cn wral wa vx cn wrex wph wn wps wn vx
      cv vy cv cle wbr wi vy cn wral wa vx cn vx cv cn wcel wph wn wps wn vx cv
      vy cv cle wbr wi vy cn wral wa wph wph wn wa wph pm3.24 vx cv cn wcel wph
      wn wps wn vx cv vy cv cle wbr wi vy cn wral wa wph wn wph wa wph wph wn
      wa vx cv cn wcel wps wn vx cv vy cv cle wbr wi vy cn wral wph wph wn vx
      cv cn wcel wps wn vx cv vy cv cle wbr wi vy cn wral vy cv vx cv clt wbr
      wps wi vy cn wral wph vx cv cn wcel wps wn vx cv vy cv cle wbr wi vy cv
      vx cv clt wbr wps wi vy cn vx cv cn wcel vy cv cn wcel wa wps wn vx cv vy
      cv cle wbr wi wps wn vy cv vx cv clt wbr wn wi vy cv vx cv clt wbr wps wi
      vx cv cn wcel vy cv cn wcel wa vx cv vy cv cle wbr vy cv vx cv clt wbr wn
      wps wn vx cv cr wcel vy cv cr wcel vx cv vy cv cle wbr vy cv vx cv clt
      wbr wn wb vx cv cn wcel vy cv cn wcel vx cv vy cv lenlt vx cv nnre vy cv
      nnre syl2an imbi2d vy cv vx cv clt wbr wps con34b syl6bbr ralbidva
      indstr.2 sylbid anim2d wph wn wph ancom syl6ib mtoi nrex wph wn wps wn vx
      vy vx cv vy cv wceq wph wps indstr.1 notbid nnwos mto wph vx cn dfral2
      mpbir rspec $.
      $( [17-Aug-2001] $)
  $}

  ${
    $d j k M $.
    uzinfm.1 $e |- M e. ZZ $.
    $( Extract the lower bound of a set of upper integers as its infimum.  Note
       that the " ` ``' < ` " argument turns supremum into infimum (for which
       we do not currently have a separate notation). $)
    uzinfmi $p |- sup ( ( ZZ>= ` M ) , RR , `' < ) = M $=
      cM cuz cfv cr clt ccnv csup vj cv vk cv cle wbr vk cM cuz cfv wral vj cM
      cuz cfv crab cuni cM cM cuz cfv cr wss vj cv vk cv cle wbr vk cM cuz cfv
      wral vj cM cuz cfv wrex cM cuz cfv cr clt ccnv csup vj cv vk cv cle wbr
      vk cM cuz cfv wral vj cM cuz cfv crab cuni wceq cM cuz cfv cz cr cM uzssz
      zssre sstri cM cM cuz cfv wcel cM vk cv cle wbr vk cM cuz cfv wral vj cv
      vk cv cle wbr vk cM cuz cfv wral vj cM cuz cfv wrex cM cz wcel cM cM cuz
      cfv wcel uzinfm.1 cM uzid ax-mp cM vk cv cle wbr vk cM cuz cfv cM vk cv
      eluzle rgen vj cv vk cv cle wbr vk cM cuz cfv wral cM vk cv cle wbr vk cM
      cuz cfv wral vj cM cM cuz cfv vj cv cM wceq vj cv vk cv cle wbr cM vk cv
      cle wbr vk cM cuz cfv vj cv cM vk cv cle breq1 ralbidv rcla4ev mp2an vj
      vk cM cuz cfv lbinfm mp2an cM vk cv cle wbr vk cM cuz cfv wral vj cv vk
      cv cle wbr vk cM cuz cfv wral vj cM cuz cfv crab cuni cM wceq cM vk cv
      cle wbr vk cM cuz cfv cM vk cv eluzle rgen cM cM cuz cfv wcel vj cv vk cv
      cle wbr vk cM cuz cfv wral vj cM cuz cfv wreu cM vk cv cle wbr vk cM cuz
      cfv wral vj cv vk cv cle wbr vk cM cuz cfv wral vj cM cuz cfv crab cuni
      cM wceq wb cM cz wcel cM cM cuz cfv wcel uzinfm.1 cM uzid ax-mp cM cuz
      cfv cr wss vj cv vk cv cle wbr vk cM cuz cfv wral vj cM cuz cfv wrex vj
      cv vk cv cle wbr vk cM cuz cfv wral vj cM cuz cfv wreu cM cuz cfv cz cr
      cM uzssz zssre sstri cM cM cuz cfv wcel cM vk cv cle wbr vk cM cuz cfv
      wral vj cv vk cv cle wbr vk cM cuz cfv wral vj cM cuz cfv wrex cM cz wcel
      cM cM cuz cfv wcel uzinfm.1 cM uzid ax-mp cM vk cv cle wbr vk cM cuz cfv
      cM vk cv eluzle rgen vj cv vk cv cle wbr vk cM cuz cfv wral cM vk cv cle
      wbr vk cM cuz cfv wral vj cM cM cuz cfv vj cv cM wceq vj cv vk cv cle wbr
      cM vk cv cle wbr vk cM cuz cfv vj cv cM vk cv cle breq1 ralbidv rcla4ev
      mp2an vj vk cM cuz cfv lbreu mp2an vj cv vk cv cle wbr vk cM cuz cfv wral
      cM vk cv cle wbr vk cM cuz cfv wral vj cM cuz cfv cM vj cv cM wceq vj cv
      vk cv cle wbr cM vk cv cle wbr vk cM cuz cfv vj cv cM vk cv cle breq1
      ralbidv reuuni2 mp2an mpbi eqtri $.
      $( [8-Oct-2005] $) $( [7-Oct-2005] $)
  $}

  $( The infimum of the set of natural numbers is one. $)
  nninfm $p |- sup ( NN , RR , `' < ) = 1 $=
    cn cr clt ccnv csup c1 cuz cfv cr clt ccnv csup c1 cn c1 cuz cfv wceq cn cr
    clt ccnv csup c1 cuz cfv cr clt ccnv csup wceq nnuz cr cn c1 cuz cfv clt
    ccnv supeq1 ax-mp c1 1z uzinfmi eqtri $.
    $( [24-Jun-2005] $) $( [16-Jun-2005] $)

  $( The infimum of the set of nonnegative integers is zero.  Note that
     " ` ``' < ` " turns sup into inf. $)
  nn0infm $p |- sup ( NN0 , RR , `' < ) = 0 $=
    cn0 cr clt ccnv csup cc0 cuz cfv cr clt ccnv csup cc0 cn0 cc0 cuz cfv wceq
    cn0 cr clt ccnv csup cc0 cuz cfv cr clt ccnv csup wceq nn0uz cr cn0 cc0 cuz
    cfv clt ccnv supeq1 ax-mp cc0 0z uzinfmi eqtri $.
    $( [10-Jul-2005] $) $( [16-Jun-2005] $)

  ${
    $d j k S $.  $d k A $.
    $( The infimum of a subset of a set of upper integers is less than
       or equal to all members of the subset.  Note that the " ` ``' < ` "
       argument turns supremum into infimum (for which we do not currently have
       a separate notation). $)
    infmssuzle $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) /\ A e. S ) ->
                sup ( S , RR , `' < ) <_ A ) $=
      cS cr wss vj cv vk cv cle wbr vk cS wral vj cS wrex cA cS wcel cS cr clt
      ccnv csup cA cle wbr cS cM cuz cfv wss cS c0 wne cA cS wcel w3a vj vk cA
      cS lbinfmle cS cM cuz cfv wss cS c0 wne cS cr wss cA cS wcel cS cM cuz
      cfv wss cM cuz cfv cr wss cS cr wss cM cuz cfv cz cr cM uzssz zssre sstri
      cS cM cuz cfv cr sstr mpan2 3ad2ant1 cS cM cuz cfv wss cS c0 wne vj cv vk
      cv cle wbr vk cS wral vj cS wrex cA cS wcel cS vj vk cM uzwo 3adant3 cS
      cM cuz cfv wss cS c0 wne cA cS wcel 3simp3 syl3anc $.
      $( [2-Apr-2009] $) $( [11-Oct-2005] $)

    $( The infimum of a subset of a set of upper integers is less than
       or equal to all members of the subset.  Note that the " ` ``' < ` "
       argument turns supremum into infimum (for which we do not currently have
       a separate notation). $)
    infmssuzleOLD $p |- ( ( S C_ ( ZZ>= ` M ) /\ -. S = (/) /\ A e. S ) ->
                sup ( S , RR , `' < ) <_ A ) $=
      cS cr wss vj cv vk cv cle wbr vk cS wral vj cS wrex cA cS wcel cS cr clt
      ccnv csup cA cle wbr cS cM cuz cfv wss cS c0 wceq wn cA cS wcel w3a vj vk
      cA cS lbinfmle cS cM cuz cfv wss cS c0 wceq wn cS cr wss cA cS wcel cS cM
      cuz cfv wss cM cuz cfv cr wss cS cr wss cM cuz cfv cz cr cM uzssz zssre
      sstri cS cM cuz cfv cr sstr mpan2 3ad2ant1 cS cM cuz cfv wss cS c0 wceq
      wn vj cv vk cv cle wbr vk cS wral vj cS wrex cA cS wcel cS vj vk cM
      uzwoOLD 3adant3 cS cM cuz cfv wss cS c0 wceq wn cA cS wcel 3simp3 syl3anc
      $.
      $( [18-Nov-2006] $) $( [11-Oct-2005] $)

    $( The infimum of a subset of a set of upper integers belongs to the
       subset. $)
    infmssuzcl $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) ) ->
                  sup ( S , RR , `' < ) e. S ) $=
      cS cr wss vj cv vk cv cle wbr vk cS wral vj cS wrex cS cr clt ccnv csup
      cS wcel cS cM cuz cfv wss cS c0 wne wa vj vk cS lbinfmcl cS cM cuz cfv
      wss cS cr wss cS c0 wne cS cM cuz cfv wss cM cuz cfv cr wss cS cr wss cM
      cuz cfv cz cr cM uzssz zssre sstri cS cM cuz cfv cr sstr mpan2 adantr cS
      cM cuz cfv wss cS c0 wceq wn vj cv vk cv cle wbr vk cS wral vj cS wrex cS
      c0 wne cS vj vk cM uzwoOLD cS c0 df-ne sylan2b sylanc $.
      $( [10-May-2007] $) $( [11-Oct-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Finite intervals of integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ... $. $( Dots. $)

  $( Extend class notation to include the notation for a contiguous finite set
     of integers.  Read " ` M ... N ` " as "the set of integers from ` M ` to
     ` N ` inclusive." $)
  cfz $a class ... $.

  ${
    $d m n k z $.
    $( Define an operation that produces a finite set of sequential integers.
       Read " ` M ... N ` " as "the set of integers from ` M ` to ` N `
       inclusive."  See ~ fzval for its value and additional comments. $)
    df-fz $a |- ... = { <. <. m , n >. , z >. | ( ( m e. ZZ /\ n e. ZZ ) /\
      z = { k e. ZZ | ( m <_ k /\ k <_ n ) } ) } $.
  $}

  ${
    $d k m n z M $.  $d k m n z N $.
    $( The value of a finite set of sequential integers.  E.g., ` 2 ... 5 `
       means the set ` { 2 , 3 , 4 , 5 } ` .  A special case of this
       definition (starting at 1) appears as Definition 11-2.1 of [Gleason]
       p. 141, where ` NN `_k means our ` 1 ... k ` ; he calls these sets
       _segments_ of the integers. $)
    fzval $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M ... N ) =
                 { k e. ZZ | ( M <_ k /\ k <_ N ) } ) $=
      vm vn vz cM cN cz cz vm cv vk cv cle wbr vk cv vn cv cle wbr wa vk cz
      crab cM vk cv cle wbr vk cv cN cle wbr wa vk cz crab cfz cM vk cv cle wbr
      vk cv vn cv cle wbr wa vk cz crab cM vk cv cle wbr vk cv cN cle wbr wa vk
      cz zex rabex vm cv cM wceq vm cv vk cv cle wbr vk cv vn cv cle wbr wa cM
      vk cv cle wbr vk cv vn cv cle wbr wa vk cz vm cv cM wceq vm cv vk cv cle
      wbr cM vk cv cle wbr vk cv vn cv cle wbr vm cv cM vk cv cle breq1 anbi1d
      rabbisdv vn cv cN wceq cM vk cv cle wbr vk cv vn cv cle wbr wa cM vk cv
      cle wbr vk cv cN cle wbr wa vk cz vn cv cN wceq vk cv vn cv cle wbr vk cv
      cN cle wbr cM vk cv cle wbr vn cv cN vk cv cle breq2 anbi2d rabbisdv vz
      vk vm vn df-fz oprabval2 $.
      $( [18-Oct-2005] $) $( [6-Sep-2005] $)
  $}

  ${
    $d j K $.  $d j M $.  $d j N $.
    $( Membership in a finite set of sequential integers. $)
    elfz1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( K e. ( M ... N ) <->
                 ( K e. ZZ /\ M <_ K /\ K <_ N ) ) ) $=
      cM cz wcel cN cz wcel wa cK cM cN cfz co wcel cK cM vj cv cle wbr vj cv
      cN cle wbr wa vj cz crab wcel cK cz wcel cM cK cle wbr cK cN cle wbr w3a
      cM cz wcel cN cz wcel wa cM cN cfz co cM vj cv cle wbr vj cv cN cle wbr
      wa vj cz crab cK vj cM cN fzval eleq2d cK cM vj cv cle wbr vj cv cN cle
      wbr wa vj cz crab wcel cK cz wcel cM cK cle wbr cK cN cle wbr wa wa cK cz
      wcel cM cK cle wbr cK cN cle wbr w3a cM vj cv cle wbr vj cv cN cle wbr wa
      cM cK cle wbr cK cN cle wbr wa vj cK cz vj cv cK wceq cM vj cv cle wbr cM
      cK cle wbr vj cv cN cle wbr cK cN cle wbr vj cv cK cM cle breq2 vj cv cK
      cN cle breq1 anbi12d elrab cK cz wcel cM cK cle wbr cK cN cle wbr 3anass
      bitr4i syl6bb $.
      $( [31-Jul-2005] $) $( [21-Jul-2005] $)
  $}

  $( Membership in a finite set of sequential integers. $)
  elfz $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) -> ( K e. ( M ... N ) <->
                 ( M <_ K /\ K <_ N ) ) ) $=
    cM cz wcel cN cz wcel cK cz wcel cK cM cN cfz co wcel cM cK cle wbr cK cN
    cle wbr wa wb cM cz wcel cN cz wcel cK cz wcel cK cM cN cfz co wcel cM cK
    cle wbr cK cN cle wbr wa wb cM cz wcel cN cz wcel wa cK cM cN cfz co wcel
    cK cz wcel cM cK cle wbr cK cN cle wbr w3a cK cz wcel cM cK cle wbr cK cN
    cle wbr wa cK cM cN elfz1 cK cz wcel cM cK cle wbr cK cN cle wbr w3a cK cz
    wcel cM cK cle wbr cK cN cle wbr wa cK cz wcel cM cK cle wbr cK cN cle wbr
    3anass baib sylan9bb 3impa 3comr $.
    $( [11-Oct-2005] $) $( [29-Sep-2005] $)

  ${
    $d k n m z M $.  $d k n m z N $.
    $( Membership in a finite set of sequential integers.  We use the fact that
       an operation's value is empty outside of its domain to show ` M e. ZZ `
       and ` N e. ZZ ` . $)
    elfz2 $p |- ( N e. A -> ( K e. ( M ... N ) <->
           ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) /\ ( M <_ K /\ K <_ N ) ) ) ) $=
      cN cA wcel cK cM cN cfz co wcel cM cz wcel cN cz wcel wa cK cz wcel cM cK
      cle wbr cK cN cle wbr wa wa wa cM cz wcel cN cz wcel cK cz wcel w3a cM cK
      cle wbr cK cN cle wbr wa wa cN cA wcel cM cz wcel cN cz wcel wa cK cM cN
      cfz co wcel cM cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK cN cle
      wbr wa wa wa wb cM cz wcel cN cz wcel wa cK cM cN cfz co wcel cM cz wcel
      cN cz wcel wa cK cz wcel cM cK cle wbr cK cN cle wbr wa wa wa wb cN cA
      wcel cM cz wcel cN cz wcel wa cK cM cN cfz co wcel cK cz wcel cM cK cle
      wbr cK cN cle wbr w3a cM cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr
      cK cN cle wbr wa wa wa cK cM cN elfz1 cM cz wcel cN cz wcel wa cK cz wcel
      cM cK cle wbr cK cN cle wbr wa wa cM cz wcel cN cz wcel wa cK cz wcel cM
      cK cle wbr cK cN cle wbr wa wa wa cK cz wcel cM cK cle wbr cK cN cle wbr
      w3a cM cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK cN cle wbr wa wa
      ibar cK cz wcel cM cK cle wbr cK cN cle wbr 3anass syl5bb bitrd adantl cN
      cA wcel cM cz wcel cN cz wcel wa wn wa cK cM cN cfz co wcel cK c0 wcel cM
      cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK cN cle wbr wa wa wa cN
      cA wcel cM cz wcel cN cz wcel wa wn wa cM cN cfz co c0 cK cfz cdm cz cz
      cxp wceq cN cA wcel cM cz wcel cN cz wcel wa wn cM cN cfz co c0 wceq vm
      vn vz cz cz vm cv vk cv cle wbr vk cv vn cv cle wbr wa vk cz crab cfz vm
      cv vk cv cle wbr vk cv vn cv cle wbr wa vk cz zex rabex vz vk vm vn df-fz
      dmoprab2 cM cN cA cz cz cfz ndmoprg mp3an1 eleq2d cM cz wcel cN cz wcel
      wa wn cK c0 wcel cM cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK cN
      cle wbr wa wa wa wb cN cA wcel cK c0 wcel cM cz wcel cN cz wcel wa cM cz
      wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK cN cle wbr wa wa wa cK c0
      wcel cM cz wcel cN cz wcel wa cK noel pm2.21i cM cz wcel cN cz wcel wa cK
      cz wcel cM cK cle wbr cK cN cle wbr wa wa pm3.26 pm5.21ni adantl bitrd
      pm2.61dan cM cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle
      wbr wa wa cM cz wcel cN cz wcel wa cK cz wcel wa cM cK cle wbr cK cN cle
      wbr wa wa cM cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK cN cle wbr
      wa wa wa cM cz wcel cN cz wcel cK cz wcel w3a cM cz wcel cN cz wcel wa cK
      cz wcel wa cM cK cle wbr cK cN cle wbr wa cM cz wcel cN cz wcel cK cz
      wcel df-3an anbi1i cM cz wcel cN cz wcel wa cK cz wcel cM cK cle wbr cK
      cN cle wbr wa anass bitr2i syl6bb $.
      $( [7-Sep-2005] $) $( [6-Sep-2005] $)

    $( Lemma for ~ elfzel1 and others. $)
    elfzlem $p |- ( K e. ( M ... N ) ->
                    ( ( M e. ZZ /\ K e. ZZ ) /\ ( M <_ K /\ K <_ N ) ) ) $=
      cN cvv wcel cK cM cN cfz co wcel cM cz wcel cK cz wcel wa cM cK cle wbr
      cK cN cle wbr wa wa wi cN cvv wcel cK cM cN cfz co wcel cM cz wcel cN cz
      wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa cM cz wcel cK cz
      wcel wa cM cK cle wbr cK cN cle wbr wa wa cvv cK cM cN elfz2 cM cz wcel
      cN cz wcel cK cz wcel w3a cM cz wcel cK cz wcel wa cM cK cle wbr cK cN
      cle wbr wa cM cz wcel cN cz wcel cK cz wcel 3simpb anim1i syl6bi cN cvv
      wcel wn cK cM cN cfz co wcel cK cM cM cfz co wcel cM cz wcel cK cz wcel
      wa cM cK cle wbr cK cN cle wbr wa wa cN cvv wcel wn cM cN cfz co cM cM
      cfz co cK cM cN cfz oprprc2 eleq2d cN cvv wcel wn cM cz wcel cK cz wcel
      wa cM cK cle wbr cK cN cle wbr wa wa cM cz wcel cK cz wcel wa cM cK cle
      wbr cK cK cle wbr wa wa cK cM cM cfz co wcel cN cvv wcel wn cM cK cle wbr
      cK cN cle wbr wa cM cK cle wbr cK cK cle wbr wa cM cz wcel cK cz wcel wa
      cN cvv wcel wn cK cN cle wbr cK cK cle wbr cM cK cle wbr cK cN cle brprc
      anbi2d anbi2d cM cvv wcel cK cM cM cfz co wcel cM cz wcel cK cz wcel wa
      cM cK cle wbr cK cK cle wbr wa wa wi cM cvv wcel cK cM cM cfz co wcel cM
      cz wcel cK cz wcel wa cM cK cle wbr wa cK cK cle wbr wa cM cz wcel cK cz
      wcel wa cM cK cle wbr cK cK cle wbr wa wa cM cvv wcel cK cM cM cfz co
      wcel cM cz wcel cK cz wcel wa cM cK cle wbr wa cK cK cle wbr cM cvv wcel
      cK cM cM cfz co wcel cM cz wcel cM cz wcel cK cz wcel w3a cM cK cle wbr
      cK cM cle wbr wa wa cM cz wcel cK cz wcel wa cM cK cle wbr wa cvv cK cM
      cM elfz2 cM cz wcel cM cz wcel cK cz wcel w3a cM cz wcel cK cz wcel wa cM
      cK cle wbr cK cM cle wbr wa cM cK cle wbr cM cz wcel cM cz wcel cK cz
      wcel 3simpb cM cK cle wbr cK cM cle wbr pm3.26 anim12i syl6bi cM cvv wcel
      cK cM cM cfz co wcel cM cz wcel cM cz wcel cK cz wcel w3a cM cK cle wbr
      cK cM cle wbr wa wa cK cK cle wbr cvv cK cM cM elfz2 cM cz wcel cM cz
      wcel cK cz wcel w3a cK cK cle wbr cM cK cle wbr cK cM cle wbr wa cK cz
      wcel cM cz wcel cK cK cle wbr cM cz wcel cK cz wcel cK cr wcel cK cK cle
      wbr cK zre cK leid syl 3ad2ant3 adantr syl6bi jcad cM cz wcel cK cz wcel
      wa cM cK cle wbr cK cK cle wbr anass syl6ib cM cvv wcel wn cM cM cfz co
      c0 wceq wn cM cz wcel cK cz wcel wa cM cK cle wbr cK cK cle wbr wa wa cK
      cM cM cfz co wcel cM cvv wcel wn cM cM cfz co c0 wceq cM cz wcel cK cz
      wcel wa cM cK cle wbr cK cK cle wbr wa wa cM cM cfz cfz cdm wrel cz cz
      cxp wrel cz cz relxp cfz cdm cz cz cxp vm vn vz cz cz vm cv vk cv cle wbr
      vk cv vn cv cle wbr wa vk cz crab cfz vm cv vk cv cle wbr vk cv vn cv cle
      wbr wa vk cz zex rabex vz vk vm vn df-fz dmoprab2 releqi mpbir oprprc1
      pm2.24d cM cM cfz co cK n0i syl5 pm2.61i syl5bir sylbid pm2.61i $.
      $( [19-Sep-2005] $) $( [6-Sep-2005] $)
  $}

  $( Membership in a finite set of sequential integers. $)
  elfz5 $p |- ( ( K e. ( ZZ>= ` M ) /\ N e. ZZ ) ->
                 ( K e. ( M ... N ) <-> K <_ N ) ) $=
    cK cM cuz cfv wcel cN cz wcel wa cK cM cN cfz co wcel cM cK cle wbr cK cN
    cle wbr wa cK cN cle wbr cK cz wcel cM cz wcel wa cN cz wcel cK cM cN cfz
    co wcel cM cK cle wbr cK cN cle wbr wa wb cK cM cuz cfv wcel cK cz wcel cM
    cz wcel cN cz wcel cK cM cN cfz co wcel cM cK cle wbr cK cN cle wbr wa wb
    cK cM cN elfz 3expa cK cM cuz cfv wcel cK cz wcel cM cz wcel cM cK eluzelz
    cM cK eluzel2 jca sylan cK cM cuz cfv wcel cK cN cle wbr cM cK cle wbr cK
    cN cle wbr wa wb cN cz wcel cK cM cuz cfv wcel cM cK cle wbr cK cN cle wbr
    cM cK eluzle biantrurd adantr bitr4d $.
    $( [10-Mar-2006] $) $( [26-Dec-2005] $)

  $( Membership in a finite set of sequential integers. $)
  elfz4 $p |- ( ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) /\ ( M <_ K /\ K <_ N ) )
               -> K e. ( M ... N ) ) $=
    cM cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr cK cM cN
    cfz co wcel cM cz wcel cN cz wcel cK cz wcel cM cK cle wbr cK cN cle wbr cK
    cM cN cfz co wcel wi wi cK cz wcel cM cK cle wbr cK cN cle wbr cM cz wcel
    cN cz wcel wa cK cM cN cfz co wcel cK cz wcel cM cK cle wbr cK cN cle wbr
    cM cz wcel cN cz wcel wa cK cM cN cfz co wcel wi cM cz wcel cN cz wcel wa
    cK cM cN cfz co wcel cK cz wcel cM cK cle wbr cK cN cle wbr w3a cK cM cN
    elfz1 biimprcd 3exp com4r 3impia imp32 $.
    $( [3-Aug-2005] $) $( [21-Jul-2005] $)

  $( Membership in a finite set of sequential integers in terms of sets of
     upper integers. $)
  elfzuzb $p |- ( N e. A -> ( K e. ( M ... N ) <->
         ( K e. ( ZZ>= ` M ) /\ N e. ( ZZ>= ` K ) ) ) ) $=
    cN cA wcel cK cM cN cfz co wcel cM cz wcel cN cz wcel cK cz wcel w3a cM cK
    cle wbr cK cN cle wbr wa wa cK cM cuz cfv wcel cN cK cuz cfv wcel wa cA cK
    cM cN elfz2 cM cz wcel cK cz wcel cM cK cle wbr w3a cK cz wcel cN cz wcel
    cK cN cle wbr w3a wa cM cz wcel cK cz wcel wa cK cz wcel cN cz wcel wa cM
    cK cle wbr cK cN cle wbr wa w3a cK cM cuz cfv wcel cN cK cuz cfv wcel wa cM
    cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa cM cz
    wcel cK cz wcel cM cK cle wbr cK cz wcel cN cz wcel cK cN cle wbr an6 cK cM
    cuz cfv wcel cM cz wcel cK cz wcel cM cK cle wbr w3a cN cK cuz cfv wcel cK
    cz wcel cN cz wcel cK cN cle wbr w3a cM cK eluz2 cK cN eluz2 anbi12i cM cz
    wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa cM cz wcel
    cK cz wcel wa cK cz wcel cN cz wcel wa wa cM cK cle wbr cK cN cle wbr wa wa
    cM cz wcel cK cz wcel wa cK cz wcel cN cz wcel wa cM cK cle wbr cK cN cle
    wbr wa w3a cM cz wcel cN cz wcel cK cz wcel w3a cM cz wcel cK cz wcel wa cK
    cz wcel cN cz wcel wa wa cM cK cle wbr cK cN cle wbr wa cM cz wcel cN cz
    wcel cK cz wcel w3a cM cz wcel cN cz wcel wa cK cz wcel wa cM cz wcel cK cz
    wcel wa cN cz wcel cK cz wcel wa wa cM cz wcel cK cz wcel wa cK cz wcel cN
    cz wcel wa wa cM cz wcel cN cz wcel cK cz wcel df-3an cM cz wcel cN cz wcel
    cK cz wcel anandir cN cz wcel cK cz wcel wa cK cz wcel cN cz wcel wa cM cz
    wcel cK cz wcel wa cN cz wcel cK cz wcel ancom anbi2i 3bitri anbi1i cM cz
    wcel cK cz wcel wa cK cz wcel cN cz wcel wa cM cK cle wbr cK cN cle wbr wa
    df-3an bitr4i 3bitr4ri syl6bb $.
    $( [29-Sep-2005] $) $( [18-Sep-2005] $)

  $( Membership in a finite set of sequential integers. $)
  eluzfz $p |- ( ( K e. ( ZZ>= ` M ) /\ N e. ( ZZ>= ` K ) )
               -> K e. ( M ... N ) ) $=
    cN cz wcel cK cM cuz cfv wcel cN cK cuz cfv wcel wa cK cM cN cfz co wcel cN
    cK cuz cfv wcel cN cz wcel cK cM cuz cfv wcel cK cN eluzelz adantl cN cz
    wcel cK cM cN cfz co wcel cK cM cuz cfv wcel cN cK cuz cfv wcel wa cz cK cM
    cN elfzuzb biimpar mpancom $.
    $( [6-Oct-2005] $) $( [4-Oct-2005] $)

  $( Membership in a finite set of sequential integers implies membership in
     a set of upper integers. $)
  elfzuz3 $p |- ( ( N e. A /\ K e. ( M ... N ) ) -> N e. ( ZZ>= ` K ) ) $=
    cN cA wcel cK cM cN cfz co wcel cK cM cuz cfv wcel cN cK cuz cfv wcel cA cK
    cM cN elfzuzb pm3.27bda $.
    $( [27-Nov-2005] $) $( [28-Sep-2005] $)

  ${
    elfzel2.1 $e |- N e. _V $.
    $( Membership in a finite set of sequential integer implies the upper
       bound is an integer. $)
    elfzel2i $p |- ( K e. ( M ... N ) -> N e. ZZ ) $=
      cK cM cN cfz co wcel cM cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr
      cK cN cle wbr wa wa cN cz wcel cN cvv wcel cK cM cN cfz co wcel cM cz
      wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa wb
      elfzel2.1 cvv cK cM cN elfz2 ax-mp cM cz wcel cN cz wcel cK cz wcel cM cK
      cle wbr cK cN cle wbr wa 3simpl2 sylbi $.
      $( [17-Sep-2005] $) $( [6-Sep-2005] $)
  $}

  $( Membership in a finite set of sequential integers implies the upper
     bound is an integer. $)
  elfzel2g $p |- ( ( N e. A /\ K e. ( M ... N ) ) -> N e. ZZ ) $=
    cN cA wcel cK cM cN cfz co wcel cN cz wcel cN cA wcel cK cM cN cfz co wcel
    cM cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa cN
    cz wcel cA cK cM cN elfz2 cM cz wcel cN cz wcel cK cz wcel cM cK cle wbr cK
    cN cle wbr wa 3simpl2 syl6bi imp $.
    $( [6-Dec-2005] $) $( [6-Sep-2005] $)

  $( Membership in a finite set of sequential integer implies the lower
     bound is an integer. $)
  elfzel1 $p |- ( K e. ( M ... N ) -> M e. ZZ ) $=
    cK cM cN cfz co wcel cM cz wcel cK cz wcel wa cM cK cle wbr cK cN cle wbr
    wa wa cM cz wcel cK cM cN elfzlem cM cz wcel cK cz wcel cM cK cle wbr cK cN
    cle wbr wa simpll syl $.
    $( [19-Sep-2005] $) $( [6-Sep-2005] $)

  $( A member of a finite set of sequential integer is an integer. $)
  elfzelz $p |- ( K e. ( M ... N ) -> K e. ZZ ) $=
    cK cM cN cfz co wcel cM cz wcel cK cz wcel wa cM cK cle wbr cK cN cle wbr
    wa wa cK cz wcel cK cM cN elfzlem cM cz wcel cK cz wcel cM cK cle wbr cK cN
    cle wbr wa simplr syl $.
    $( [20-Sep-2005] $) $( [6-Sep-2005] $)

  $( A member of a finite set of sequential integer is greater than or
     equal to the lower bound. $)
  elfzle1 $p |- ( K e. ( M ... N ) -> M <_ K ) $=
    cK cM cN cfz co wcel cM cz wcel cK cz wcel wa cM cK cle wbr cK cN cle wbr
    wa wa cM cK cle wbr cK cM cN elfzlem cM cz wcel cK cz wcel wa cM cK cle wbr
    cK cN cle wbr simprl syl $.
    $( [20-Sep-2005] $) $( [6-Sep-2005] $)

  $( A member of a finite set of sequential integer is less than or
     equal to the upper bound. $)
  elfzle2 $p |- ( K e. ( M ... N ) -> K <_ N ) $=
    cK cM cN cfz co wcel cM cz wcel cK cz wcel wa cM cK cle wbr cK cN cle wbr
    wa wa cK cN cle wbr cK cM cN elfzlem cM cz wcel cK cz wcel wa cM cK cle wbr
    cK cN cle wbr simprr syl $.
    $( [2-Oct-2005] $) $( [6-Sep-2005] $)

  $( Membership in a finite set of sequential integer implies the bounds are
     comparable. $)
  elfzle3 $p |- ( ( N e. A /\ K e. ( M ... N ) ) -> M <_ N ) $=
    cN cA wcel cK cM cN cfz co wcel wa cM cK cle wbr cK cN cle wbr cM cN cle
    wbr cK cM cN cfz co wcel cM cK cle wbr cN cA wcel cK cM cN elfzle1 adantl
    cK cM cN cfz co wcel cK cN cle wbr cN cA wcel cK cM cN elfzle2 adantl cM cz
    wcel cK cz wcel cN cz wcel cM cK cle wbr cK cN cle wbr wa cM cN cle wbr wi
    cN cA wcel cK cM cN cfz co wcel wa cM cr wcel cK cr wcel cN cr wcel cM cK
    cle wbr cK cN cle wbr wa cM cN cle wbr wi cM cz wcel cK cz wcel cN cz wcel
    cM cK cN letr cM zre cK zre cN zre syl3an cK cM cN cfz co wcel cM cz wcel
    cN cA wcel cK cM cN elfzel1 adantl cK cM cN cfz co wcel cK cz wcel cN cA
    wcel cK cM cN elfzelz adantl cA cK cM cN elfzel2g syl3anc mp2and $.
    $( [17-Apr-2006] $) $( [18-Sep-2005] $)

  $( Implication of membership in a finite set of sequential integers. $)
  elfzuz2 $p |- ( ( N e. A /\ K e. ( M ... N ) ) -> N e. ( ZZ>= ` M ) ) $=
    cN cA wcel cK cM cN cfz co wcel wa cN cK cuz cfv wcel cK cM cuz cfv wcel wa
    cN cM cuz cfv wcel cN cA wcel cK cM cN cfz co wcel cN cK cuz cfv wcel cK cM
    cuz cfv wcel wa cN cA wcel cK cM cN cfz co wcel cK cM cuz cfv wcel cN cK
    cuz cfv wcel wa cN cK cuz cfv wcel cK cM cuz cfv wcel wa cA cK cM cN
    elfzuzb cK cM cuz cfv wcel cN cK cuz cfv wcel ancom syl6bb biimpa cK cN cM
    uztrn syl $.
    $( [1-Nov-2005] $) $( [20-Sep-2005] $)

  $( Membership in a finite set of sequential integers - special case. $)
  eluzfz1 $p |- ( N e. ( ZZ>= ` M ) -> M e. ( M ... N ) ) $=
    cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cM cM cN cfz co
    wcel cM cN eluz2 cM cz wcel cN cz wcel cM cz wcel w3a cM cM cle wbr cM cN
    cle wbr wa cM cM cN cfz co wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cM
    cM cN elfz4 cM cz wcel cN cz wcel cM cN cle wbr w3a cM cz wcel cN cz wcel
    cM cz wcel cM cz wcel cN cz wcel cM cN cle wbr 3simp1 cM cz wcel cN cz wcel
    cM cN cle wbr 3simp2 cM cz wcel cN cz wcel cM cN cle wbr 3simp1 3jca cM cz
    wcel cN cz wcel cM cN cle wbr w3a cM cM cle wbr cM cN cle wbr cM cz wcel cN
    cz wcel cM cM cle wbr cM cN cle wbr cM cz wcel cM cr wcel cM cM cle wbr cM
    zre cM leid syl 3ad2ant1 cM cz wcel cN cz wcel cM cN cle wbr 3simp3 jca
    sylanc sylbi $.
    $( [18-Sep-2005] $) $( [21-Jul-2005] $)

  $( A member of a finite set of sequential integers belongs to a set of upper
     integers. $)
  elfzuz $p |- ( K e. ( M ... N ) -> K e. ( ZZ>= ` M ) ) $=
    cK cM cN cfz co wcel cM cz wcel cK cz wcel cM cK cle wbr w3a cK cM cuz cfv
    wcel cK cM cN cfz co wcel cM cz wcel cK cz wcel cM cK cle wbr cK cM cN
    elfzel1 cK cM cN elfzelz cK cM cN elfzle1 3jca cM cK eluz2 sylibr $.
    $( [28-Oct-2005] $) $( [17-Sep-2005] $)

  $( Membership in a finite set of sequential integers - special case. $)
  eluzfz2 $p |- ( N e. ( ZZ>= ` M ) -> N e. ( M ... N ) ) $=
    cM cz wcel cN cz wcel cN cz wcel w3a cM cN cle wbr cN cN cle wbr wa cN cM
    cN cfz co wcel cN cM cuz cfv wcel cN cM cN elfz4 cN cM cuz cfv wcel cM cz
    wcel cN cz wcel cN cz wcel cM cN eluzel2 cM cN eluzelz cM cN eluzelz 3jca
    cN cM cuz cfv wcel cM cN cle wbr cN cN cle wbr cM cN eluzle cN cM cuz cfv
    wcel cN cz wcel cN cr wcel cN cN cle wbr cM cN eluzelz cN zre cN leid 3syl
    jca sylanc $.
    $( [14-Sep-2005] $) $( [13-Sep-2005] $)

  $( Membership in a finite set of sequential integers - special case. $)
  eluzfz2b $p |- ( N e. ( ZZ>= ` M ) <-> N e. ( M ... N ) ) $=
    cN cM cuz cfv wcel cN cM cN cfz co wcel cM cN eluzfz2 cN cM cN elfzuz
    impbii $.
    $( [20-Sep-2005] $) $( [14-Sep-2005] $)

  $( Membership in a finite set of sequential integers containing one
     integer. $)
  elfz3 $p |- ( N e. ZZ -> N e. ( N ... N ) ) $=
    cN cz wcel cN cN cuz cfv wcel cN cN cN cfz co wcel cN uzid cN cN eluzfz1
    syl $.
    $( [19-Aug-2005] $) $( [21-Jul-2005] $)

  $( Membership in a finite set of sequential integers containing one
     integer. $)
  elfz1eq $p |- ( K e. ( N ... N ) -> K = N ) $=
    cK cN cN cfz co wcel cN cz wcel cK cz wcel wa cN cK cle wbr cK cN cle wbr
    wa wa cK cN wceq cK cN cN elfzlem cN cz wcel cK cz wcel wa cN cK cle wbr cK
    cN cle wbr wa wa cN cK cN cz wcel cK cz wcel wa cN cK wceq cN cK cle wbr cK
    cN cle wbr wa cN cr wcel cK cr wcel cN cK wceq cN cK cle wbr cK cN cle wbr
    wa wb cN cz wcel cK cz wcel cN cK letri3 cN zre cK zre syl2an biimpar
    eqcomd syl $.
    $( [3-Oct-2005] $) $( [19-Sep-2005] $)

  ${
    $d K k m $.  $d M k m $.  $d N k m $.
    $( A finite set of sequential integers is empty if the bounds are
       reversed. $)
    fzn $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( N < M <-> ( M ... N ) = (/) ) ) $=
      cM cz wcel cN cz wcel wa cN cM clt wbr cM cN cfz co c0 wceq cM cz wcel cN
      cz wcel wa cM cN cle wbr cN cM clt wbr wn cM cN cfz co c0 wceq wn cM cr
      wcel cN cr wcel cM cN cle wbr cN cM clt wbr wn wb cM cz wcel cN cz wcel
      cM cN lenlt cM zre cN zre syl2an cM cz wcel cN cz wcel wa cM cN cle wbr
      cM cN cfz co c0 wceq wn cM cz wcel cN cz wcel cM cN cle wbr cM cN cfz co
      c0 wceq wn cM cz wcel cN cz wcel cM cN cle wbr w3a cM cM cN cfz co wcel
      cM cN cfz co c0 wceq wn cM cz wcel cN cz wcel cM cN cle wbr w3a cN cM cuz
      cfv wcel cM cM cN cfz co wcel cM cN eluz2 cM cN eluzfz1 sylbir cM cN cfz
      co cM n0i syl 3expia cN cz wcel cM cN cfz co c0 wceq wn cM cN cle wbr wi
      cM cz wcel cN cz wcel vk cv cM cN cfz co wcel vk wex cM cN cle wbr cM cN
      cfz co c0 wceq wn cN cz wcel vk cv cM cN cfz co wcel cM cN cle wbr vk cN
      cz wcel vk cv cM cN cfz co wcel cM cN cle wbr cz vk cv cM cN elfzle3 ex
      19.23adv vk cM cN cfz co neq0 syl5ib adantl impbid bitr3d con4bid $.
      $( [18-Apr-2006] $) $( [22-Aug-2005] $)

    $( A shifted finite set of sequential integers is equinumerous to the
       original set.  (Contributed by Paul Chapman, 11-Apr-2009.) $)
    fzen $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) ->
                 ( M ... N ) ~~ ( ( M + K ) ... ( N + K ) ) ) $=
      cM cz wcel cN cz wcel cK cz wcel w3a vk vm cM cN cfz co cM cK caddc co cN
      cK caddc co cfz co vk cv cK caddc co vm cv cK cmin co cM cN cfz co cvv
      wcel cM cz wcel cN cz wcel cK cz wcel w3a cM cN cfz oprex a1i cM cz wcel
      cN cz wcel cK cz wcel w3a vk cv cM cN cfz co wcel vk cv cz wcel cM vk cv
      cle wbr vk cv cN cle wbr w3a vk cv cK caddc co cM cK caddc co cN cK caddc
      co cfz co wcel cM cz wcel cN cz wcel vk cv cM cN cfz co wcel vk cv cz
      wcel cM vk cv cle wbr vk cv cN cle wbr w3a wi cK cz wcel cM cz wcel cN cz
      wcel wa vk cv cM cN cfz co wcel vk cv cz wcel cM vk cv cle wbr vk cv cN
      cle wbr w3a vk cv cM cN elfz1 biimpd 3adant3 vk cv cz wcel cM vk cv cle
      wbr vk cv cN cle wbr w3a cM cz wcel cN cz wcel cK cz wcel w3a vk cv cK
      caddc co cM cK caddc co cN cK caddc co cfz co wcel vk cv cz wcel cM vk cv
      cle wbr vk cv cN cle wbr cM cz wcel cN cz wcel cK cz wcel w3a vk cv cK
      caddc co cM cK caddc co cN cK caddc co cfz co wcel wi cM cz wcel cN cz
      wcel cK cz wcel w3a vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa wa
      vk cv cK caddc co cM cK caddc co cN cK caddc co cfz co wcel cM cz wcel cN
      cz wcel cK cz wcel w3a vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa
      wa vk cv cK caddc co cz wcel cM cK caddc co vk cv cK caddc co cle wbr vk
      cv cK caddc co cN cK caddc co cle wbr w3a vk cv cK caddc co cM cK caddc
      co cN cK caddc co cfz co wcel cM cz wcel cN cz wcel cK cz wcel w3a vk cv
      cz wcel cM vk cv cle wbr vk cv cN cle wbr wa wa vk cv cK caddc co cz wcel
      cM cK caddc co vk cv cK caddc co cle wbr vk cv cK caddc co cN cK caddc co
      cle wbr cM cz wcel cN cz wcel cK cz wcel w3a vk cv cz wcel vk cv cK caddc
      co cz wcel cM vk cv cle wbr vk cv cN cle wbr wa cK cz wcel cM cz wcel vk
      cv cz wcel vk cv cK caddc co cz wcel wi cN cz wcel vk cv cz wcel cK cz
      wcel vk cv cK caddc co cz wcel vk cv cK zaddcl expcom 3ad2ant3 adantrd cM
      cz wcel cK cz wcel vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa wa
      cM cK caddc co vk cv cK caddc co cle wbr wi cN cz wcel cM cz wcel cK cz
      wcel wa vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa cM cK caddc co
      vk cv cK caddc co cle wbr cM cz wcel cK cz wcel vk cv cz wcel cM vk cv
      cle wbr vk cv cN cle wbr wa cM cK caddc co vk cv cK caddc co cle wbr wi
      cM cz wcel vk cv cz wcel cK cz wcel cM vk cv cle wbr vk cv cN cle wbr wa
      cM cK caddc co vk cv cK caddc co cle wbr wi cM cz wcel vk cv cz wcel cK
      cz wcel w3a cM vk cv cle wbr cM cK caddc co vk cv cK caddc co cle wbr vk
      cv cN cle wbr cM cz wcel vk cv cz wcel cK cz wcel w3a cM vk cv cle wbr cM
      cK caddc co vk cv cK caddc co cle wbr cM cr wcel vk cv cr wcel cK cr wcel
      cM vk cv cle wbr cM cK caddc co vk cv cK caddc co cle wbr wb cM cz wcel
      vk cv cz wcel cK cz wcel cM vk cv cK leadd1 cM zre vk cv zre cK zre
      syl3an biimpd adantrd 3com23 3expia imp3a 3adant2 cN cz wcel cK cz wcel
      vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa wa vk cv cK caddc co
      cN cK caddc co cle wbr wi cM cz wcel cN cz wcel cK cz wcel wa vk cv cz
      wcel cM vk cv cle wbr vk cv cN cle wbr wa vk cv cK caddc co cN cK caddc
      co cle wbr cN cz wcel cK cz wcel vk cv cz wcel cM vk cv cle wbr vk cv cN
      cle wbr wa vk cv cK caddc co cN cK caddc co cle wbr wi vk cv cz wcel cN
      cz wcel cK cz wcel cM vk cv cle wbr vk cv cN cle wbr wa vk cv cK caddc co
      cN cK caddc co cle wbr wi vk cv cz wcel cN cz wcel cK cz wcel w3a vk cv
      cN cle wbr vk cv cK caddc co cN cK caddc co cle wbr cM vk cv cle wbr vk
      cv cz wcel cN cz wcel cK cz wcel w3a vk cv cN cle wbr vk cv cK caddc co
      cN cK caddc co cle wbr vk cv cr wcel cN cr wcel cK cr wcel vk cv cN cle
      wbr vk cv cK caddc co cN cK caddc co cle wbr wb vk cv cz wcel cN cz wcel
      cK cz wcel vk cv cN cK leadd1 vk cv zre cN zre cK zre syl3an biimpd
      adantld 3coml 3expia imp3a 3adant1 3jcad cM cz wcel cN cz wcel cK cz wcel
      w3a vk cv cK caddc co cM cK caddc co cN cK caddc co cfz co wcel vk cv cK
      caddc co cz wcel cM cK caddc co vk cv cK caddc co cle wbr vk cv cK caddc
      co cN cK caddc co cle wbr w3a cM cK caddc co cz wcel cN cK caddc co cz
      wcel vk cv cK caddc co cM cK caddc co cN cK caddc co cfz co wcel vk cv cK
      caddc co cz wcel cM cK caddc co vk cv cK caddc co cle wbr vk cv cK caddc
      co cN cK caddc co cle wbr w3a wb cM cz wcel cN cz wcel cK cz wcel w3a vk
      cv cK caddc co cM cK caddc co cN cK caddc co elfz1 cM cz wcel cK cz wcel
      cM cK caddc co cz wcel cN cz wcel cM cK zaddcl 3adant2 cN cz wcel cK cz
      wcel cN cK caddc co cz wcel cM cz wcel cN cK zaddcl 3adant1 sylanc
      biimprd syld com12 3impb com12 syld cM cz wcel cN cz wcel cK cz wcel w3a
      vm cv cM cK caddc co cN cK caddc co cfz co wcel vm cv cz wcel cM cK caddc
      co vm cv cle wbr vm cv cN cK caddc co cle wbr w3a vm cv cK cmin co cM cN
      cfz co wcel cM cz wcel cN cz wcel cK cz wcel w3a vm cv cM cK caddc co cN
      cK caddc co cfz co wcel vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv
      cN cK caddc co cle wbr w3a cM cK caddc co cz wcel cN cK caddc co cz wcel
      vm cv cM cK caddc co cN cK caddc co cfz co wcel vm cv cz wcel cM cK caddc
      co vm cv cle wbr vm cv cN cK caddc co cle wbr w3a wb cM cz wcel cN cz
      wcel cK cz wcel w3a vm cv cM cK caddc co cN cK caddc co elfz1 cM cz wcel
      cK cz wcel cM cK caddc co cz wcel cN cz wcel cM cK zaddcl 3adant2 cN cz
      wcel cK cz wcel cN cK caddc co cz wcel cM cz wcel cN cK zaddcl 3adant1
      sylanc biimpd vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK
      caddc co cle wbr w3a cM cz wcel cN cz wcel cK cz wcel w3a vm cv cK cmin
      co cM cN cfz co wcel vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN
      cK caddc co cle wbr cM cz wcel cN cz wcel cK cz wcel w3a vm cv cK cmin co
      cM cN cfz co wcel wi cM cz wcel cN cz wcel cK cz wcel w3a vm cv cz wcel
      cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr wa wa vm cv cK
      cmin co cM cN cfz co wcel cM cz wcel cN cz wcel cK cz wcel w3a vm cv cz
      wcel cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr wa wa vm
      cv cK cmin co cz wcel cM vm cv cK cmin co cle wbr vm cv cK cmin co cN cle
      wbr w3a vm cv cK cmin co cM cN cfz co wcel cM cz wcel cN cz wcel cK cz
      wcel w3a vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK caddc co
      cle wbr wa wa vm cv cK cmin co cz wcel cM vm cv cK cmin co cle wbr vm cv
      cK cmin co cN cle wbr cM cz wcel cN cz wcel cK cz wcel w3a vm cv cz wcel
      vm cv cK cmin co cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK caddc
      co cle wbr wa cK cz wcel cM cz wcel vm cv cz wcel vm cv cK cmin co cz
      wcel wi cN cz wcel vm cv cz wcel cK cz wcel vm cv cK cmin co cz wcel vm
      cv cK zsubcl expcom 3ad2ant3 adantrd cM cz wcel cK cz wcel vm cv cz wcel
      cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr wa wa cM vm cv
      cK cmin co cle wbr wi cN cz wcel cM cz wcel cK cz wcel wa vm cv cz wcel
      cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr wa cM vm cv cK
      cmin co cle wbr cM cz wcel cK cz wcel vm cv cz wcel cM cK caddc co vm cv
      cle wbr vm cv cN cK caddc co cle wbr wa cM vm cv cK cmin co cle wbr wi cM
      cz wcel cK cz wcel vm cv cz wcel w3a cM cK caddc co vm cv cle wbr cM vm
      cv cK cmin co cle wbr vm cv cN cK caddc co cle wbr cM cz wcel cK cz wcel
      vm cv cz wcel w3a cM cK caddc co vm cv cle wbr cM vm cv cK cmin co cle
      wbr cM cr wcel cK cr wcel vm cv cr wcel cM cK caddc co vm cv cle wbr cM
      vm cv cK cmin co cle wbr wb cM cz wcel cK cz wcel vm cv cz wcel cM cK vm
      cv leaddsub cM zre cK zre vm cv zre syl3an biimpd adantrd 3expia imp3a
      3adant2 cN cz wcel cK cz wcel vm cv cz wcel cM cK caddc co vm cv cle wbr
      vm cv cN cK caddc co cle wbr wa wa vm cv cK cmin co cN cle wbr wi cM cz
      wcel cK cz wcel cN cz wcel vm cv cz wcel cM cK caddc co vm cv cle wbr vm
      cv cN cK caddc co cle wbr wa wa vm cv cK cmin co cN cle wbr wi cK cz wcel
      cN cz wcel wa vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK
      caddc co cle wbr wa vm cv cK cmin co cN cle wbr cK cz wcel cN cz wcel vm
      cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr wa
      vm cv cK cmin co cN cle wbr wi vm cv cz wcel cK cz wcel cN cz wcel cM cK
      caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr wa vm cv cK cmin co
      cN cle wbr wi vm cv cz wcel cK cz wcel cN cz wcel w3a vm cv cN cK caddc
      co cle wbr vm cv cK cmin co cN cle wbr cM cK caddc co vm cv cle wbr vm cv
      cz wcel cK cz wcel cN cz wcel w3a vm cv cK cmin co cN cle wbr vm cv cN cK
      caddc co cle wbr vm cv cr wcel cK cr wcel cN cr wcel vm cv cK cmin co cN
      cle wbr vm cv cN cK caddc co cle wbr wb vm cv cz wcel cK cz wcel cN cz
      wcel vm cv cK cN lesubadd vm cv zre cK zre cN zre syl3an biimprd adantld
      3coml 3expia imp3a ancoms 3adant1 3jcad cM cz wcel cN cz wcel vm cv cK
      cmin co cz wcel cM vm cv cK cmin co cle wbr vm cv cK cmin co cN cle wbr
      w3a vm cv cK cmin co cM cN cfz co wcel wi cK cz wcel cM cz wcel cN cz
      wcel wa vm cv cK cmin co cM cN cfz co wcel vm cv cK cmin co cz wcel cM vm
      cv cK cmin co cle wbr vm cv cK cmin co cN cle wbr w3a vm cv cK cmin co cM
      cN elfz1 biimprd 3adant3 syld com12 3impb com12 syld cM cz wcel cN cz
      wcel cK cz wcel w3a vk cv cM cN cfz co wcel vm cv cM cK caddc co cN cK
      caddc co cfz co wcel wa vk cv cz wcel vm cv cz wcel wa vk cv vm cv cK
      cmin co wceq vm cv vk cv cK caddc co wceq wb cM cz wcel cN cz wcel cK cz
      wcel w3a vk cv cM cN cfz co wcel vk cv cz wcel vm cv cM cK caddc co cN cK
      caddc co cfz co wcel vm cv cz wcel cM cz wcel cN cz wcel cK cz wcel w3a
      vk cv cM cN cfz co wcel vk cv cz wcel cM cz wcel cN cz wcel cK cz wcel
      w3a vk cv cM cN cfz co wcel wa vk cv cz wcel cM vk cv cle wbr vk cv cN
      cle wbr cM cz wcel cN cz wcel cK cz wcel w3a vk cv cM cN cfz co wcel vk
      cv cz wcel cM vk cv cle wbr vk cv cN cle wbr w3a cM cz wcel cN cz wcel vk
      cv cM cN cfz co wcel vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr w3a
      wi cK cz wcel cM cz wcel cN cz wcel wa vk cv cM cN cfz co wcel vk cv cz
      wcel cM vk cv cle wbr vk cv cN cle wbr w3a vk cv cM cN elfz1 biimpd
      3adant3 imp 3simp1d ex cM cz wcel cN cz wcel cK cz wcel w3a vm cv cM cK
      caddc co cN cK caddc co cfz co wcel vm cv cz wcel cM cz wcel cN cz wcel
      cK cz wcel w3a vm cv cM cK caddc co cN cK caddc co cfz co wcel wa vm cv
      cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle wbr cM cz
      wcel cN cz wcel cK cz wcel w3a vm cv cM cK caddc co cN cK caddc co cfz co
      wcel vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN cK caddc co cle
      wbr w3a cM cz wcel cN cz wcel cK cz wcel w3a vm cv cM cK caddc co cN cK
      caddc co cfz co wcel vm cv cz wcel cM cK caddc co vm cv cle wbr vm cv cN
      cK caddc co cle wbr w3a cM cK caddc co cz wcel cN cK caddc co cz wcel vm
      cv cM cK caddc co cN cK caddc co cfz co wcel vm cv cz wcel cM cK caddc co
      vm cv cle wbr vm cv cN cK caddc co cle wbr w3a wb cM cz wcel cN cz wcel
      cK cz wcel w3a vm cv cM cK caddc co cN cK caddc co elfz1 cM cz wcel cK cz
      wcel cM cK caddc co cz wcel cN cz wcel cM cK zaddcl 3adant2 cN cz wcel cK
      cz wcel cN cK caddc co cz wcel cM cz wcel cN cK zaddcl 3adant1 sylanc
      biimpd imp 3simp1d ex anim12d cK cz wcel cM cz wcel vk cv cz wcel vm cv
      cz wcel wa vk cv vm cv cK cmin co wceq vm cv vk cv cK caddc co wceq wb wi
      cN cz wcel cK cz wcel vk cv cz wcel vm cv cz wcel vk cv vm cv cK cmin co
      wceq vm cv vk cv cK caddc co wceq wb vm cv cz wcel cK cz wcel vk cv cz
      wcel vk cv vm cv cK cmin co wceq vm cv vk cv cK caddc co wceq wb vm cv cc
      wcel cK cc wcel vk cv cc wcel vk cv vm cv cK cmin co wceq vm cv vk cv cK
      caddc co wceq wb vm cv cz wcel cK cz wcel vk cv cz wcel vm cv cc wcel cK
      cc wcel vk cv cc wcel w3a vk cv vm cv cK cmin co wceq vm cv cK vk cv
      caddc co wceq vm cv vk cv cK caddc co wceq vm cv cc wcel cK cc wcel vk cv
      cc wcel w3a vm cv cK cmin co vk cv wceq cK vk cv caddc co vm cv wceq vk
      cv vm cv cK cmin co wceq vm cv cK vk cv caddc co wceq vm cv cK vk cv
      subadd vm cv cK cmin co vk cv eqcom cK vk cv caddc co vm cv eqcom 3bitr3g
      vm cv cc wcel cK cc wcel vk cv cc wcel w3a cK vk cv caddc co vk cv cK
      caddc co vm cv cK cc wcel vk cv cc wcel cK vk cv caddc co vk cv cK caddc
      co wceq vm cv cc wcel cK vk cv addcom 3adant1 eqeq2d bitrd vm cv zcn cK
      zcn vk cv zcn syl3an 3coml 3expib 3ad2ant3 syld en3d $.
      $( [14-Apr-2009] $) $( [11-Apr-2009] $)
  $}

  $( 0-based and 1-based finite sets of sequential integers are equinumerous.
     (Contributed by Paul Chapman, 11-Apr-2009.) $)
  fz01en $p |- ( N e. ZZ -> ( 0 ... ( N - 1 ) ) ~~ ( 1 ... N ) ) $=
    cN cz wcel cc0 cN c1 cmin co cfz co cc0 c1 caddc co cN c1 cmin co c1 caddc
    co cfz co cen wbr cc0 cN c1 cmin co cfz co c1 cN cfz co cen wbr cN cz wcel
    cN c1 cmin co cz wcel cc0 cN c1 cmin co cfz co cc0 c1 caddc co cN c1 cmin
    co c1 caddc co cfz co cen wbr cN peano2zm cc0 cz wcel cN c1 cmin co cz wcel
    c1 cz wcel cc0 cN c1 cmin co cfz co cc0 c1 caddc co cN c1 cmin co c1 caddc
    co cfz co cen wbr 0z 1z c1 cc0 cN c1 cmin co fzen mp3an13 syl cN cz wcel
    cc0 c1 caddc co cN c1 cmin co c1 caddc co cfz co c1 cN cfz co cc0 cN c1
    cmin co cfz co cen cN cz wcel cc0 c1 caddc co c1 cN c1 cmin co c1 caddc co
    cN cfz cc0 c1 caddc co c1 wceq cN cz wcel c1 ax1cn addid2i a1i cN cc wcel
    c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN cz wcel cN c1 npcan cN zcn
    ax1cn sylancl opreq12d breq2d mpbid $.
    $( [14-Apr-2009] $) $( [11-Apr-2009] $)

  $( A member of a finite set of sequential integers starting at 1 is a
     natural number. $)
  elfznn $p |- ( K e. ( 1 ... N ) -> K e. NN ) $=
    cK cn wcel cK cz wcel c1 cK cle wbr cK c1 cN cfz co wcel cK elnnz1 cK c1 cN
    elfzelz cK c1 cN elfzle1 sylanbrc $.
    $( [27-Nov-2005] $) $( [24-Aug-2005] $)

  $( Membership in a finite set of sequential integers starting at 0. $)
  elfz2nn0 $p |- ( N e. A ->
           ( K e. ( 0 ... N ) <-> ( K e. NN0 /\ N e. NN0 /\ K <_ N ) ) ) $=
    cN cA wcel cK cc0 cN cfz co wcel cc0 cz wcel cN cz wcel cK cz wcel w3a cc0
    cK cle wbr cK cN cle wbr wa wa cK cn0 wcel cN cn0 wcel cK cN cle wbr w3a cA
    cK cc0 cN elfz2 cc0 cz wcel cN cz wcel cK cz wcel w3a cc0 cK cle wbr cK cN
    cle wbr wa wa cK cz wcel cc0 cK cle wbr wa cN cz wcel cc0 cN cle wbr wa cK
    cN cle wbr w3a cK cn0 wcel cN cn0 wcel cK cN cle wbr w3a cc0 cz wcel cN cz
    wcel cK cz wcel w3a cc0 cK cle wbr cK cN cle wbr wa wa cK cz wcel cc0 cK
    cle wbr wa cN cz wcel cc0 cN cle wbr wa cK cN cle wbr w3a cN cz wcel cK cz
    wcel cc0 cK cle wbr cK cN cle wbr wa cK cz wcel cc0 cK cle wbr wa cN cz
    wcel cc0 cN cle wbr wa cK cN cle wbr w3a cc0 cz wcel cN cz wcel cK cz wcel
    wa cc0 cK cle wbr cK cN cle wbr wa wa cK cz wcel cc0 cK cle wbr wa cN cz
    wcel cc0 cN cle wbr wa cK cN cle wbr cN cz wcel cK cz wcel wa cK cz wcel
    cc0 cK cle wbr cK cN cle wbr wa cc0 cK cle wbr cN cz wcel cK cz wcel pm3.27
    cc0 cK cle wbr cK cN cle wbr pm3.26 anim12i cN cz wcel cK cz wcel wa cc0 cK
    cle wbr cK cN cle wbr wa wa cN cz wcel cc0 cN cle wbr cN cz wcel cK cz wcel
    cc0 cK cle wbr cK cN cle wbr wa simpll cN cz wcel cK cz wcel wa cc0 cK cle
    wbr cK cN cle wbr wa cc0 cN cle wbr cN cr wcel cK cr wcel cc0 cK cle wbr cK
    cN cle wbr wa cc0 cN cle wbr wi cN cz wcel cK cz wcel cK cr wcel cN cr wcel
    cc0 cK cle wbr cK cN cle wbr wa cc0 cN cle wbr wi cc0 cr wcel cK cr wcel cN
    cr wcel cc0 cK cle wbr cK cN cle wbr wa cc0 cN cle wbr wi 0re cc0 cK cN
    letr mp3an1 ancoms cN zre cK zre syl2an imp jca cN cz wcel cK cz wcel wa
    cc0 cK cle wbr cK cN cle wbr simprr 3jca 3adantl1 cK cz wcel cc0 cK cle wbr
    wa cN cz wcel cc0 cN cle wbr wa cK cN cle wbr w3a cc0 cz wcel cN cz wcel cK
    cz wcel w3a cc0 cK cle wbr cK cN cle wbr wa cK cN cle wbr cN cz wcel cc0 cN
    cle wbr wa cK cz wcel cc0 cK cle wbr wa cc0 cz wcel cN cz wcel cK cz wcel
    w3a cK cN cle wbr cc0 cz wcel cN cz wcel cc0 cN cle wbr wa cN cz wcel cK cz
    wcel cc0 cK cle wbr wa cK cz wcel cc0 cz wcel cK cN cle wbr 0z a1i cN cz
    wcel cc0 cN cle wbr pm3.26 cK cz wcel cc0 cK cle wbr pm3.26 3anim123i
    3com13 cK cz wcel cc0 cK cle wbr wa cK cN cle wbr cc0 cK cle wbr cK cN cle
    wbr wa cN cz wcel cc0 cN cle wbr wa cc0 cK cle wbr cK cN cle wbr cc0 cK cle
    wbr cK cN cle wbr wa cK cz wcel cc0 cK cle wbr cK cN cle wbr wa id adantll
    3adant2 jca impbii cK cn0 wcel cK cz wcel cc0 cK cle wbr wa cN cn0 wcel cN
    cz wcel cc0 cN cle wbr wa cK cN cle wbr cK cN cle wbr cK elnn0z cN elnn0z
    cK cN cle wbr biid 3anbi123i bitr4i syl6bb $.
    $( [2-Feb-2006] $) $( [16-Sep-2005] $)

  $( A member of a finite set of sequential integers starting at 0 is a
     nonnegative integer. $)
  elfznn0 $p |- ( K e. ( 0 ... N ) -> K e. NN0 ) $=
    cK cn0 wcel cK cz wcel cc0 cK cle wbr cK cc0 cN cfz co wcel cK elnn0z cK
    cc0 cN elfzelz cK cc0 cN elfzle1 sylanbrc $.
    $( [22-Sep-2005] $) $( [5-Aug-2005] $)

  $( The upper bound of a nonempty finite set of sequential integers starting
     at 0 is a nonnegative integer. $)
  elfz3nn0 $p |- ( ( N e. A /\ K e. ( 0 ... N ) ) -> N e. NN0 ) $=
    cN cA wcel cK cc0 cN cfz co wcel cN cn0 wcel cN cA wcel cK cc0 cN cfz co
    wcel cK cn0 wcel cN cn0 wcel cK cN cle wbr w3a cN cn0 wcel cA cK cN
    elfz2nn0 cK cn0 wcel cN cn0 wcel cK cN cle wbr 3simp2 syl6bi imp $.
    $( [6-Feb-2006] $) $( [16-Sep-2005] $)

  $( Subtraction closure for a member of a finite set of sequential
     integers. $)
  fznn0sub $p |- ( ( N e. A /\ K e. ( M ... N ) ) -> ( N - K ) e. NN0 ) $=
    cN cA wcel cK cM cN cfz co wcel cN cK cmin co cn0 wcel cN cA wcel cK cM cN
    cfz co wcel cM cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle
    wbr wa wa cN cK cmin co cn0 wcel cA cK cM cN elfz2 cN cz wcel cK cz wcel cM
    cK cle wbr cK cN cle wbr wa cN cK cmin co cn0 wcel cM cz wcel cN cz wcel cK
    cz wcel wa cK cN cle wbr cN cK cmin co cn0 wcel cM cK cle wbr cN cz wcel cK
    cz wcel cK cN cle wbr cN cK cmin co cn0 wcel cK cz wcel cN cz wcel cK cN
    cle wbr cN cK cmin co cn0 wcel cK cN znn0sub2 3com12 3expa adantrl 3adantl1
    syl6bi imp $.
    $( [14-Jan-2006] $) $( [16-Sep-2005] $)

  $( Subtraction closure for a member of a finite set of sequential
     integers. $)
  fznn0sub2 $p |- ( ( N e. A /\ K e. ( 0 ... N ) ) ->
                   ( N - K ) e. ( 0 ... N ) ) $=
    cN cA wcel cK cc0 cN cfz co wcel cN cK cmin co cn0 wcel cN cn0 wcel cN cK
    cmin co cN cle wbr w3a cN cK cmin co cc0 cN cfz co wcel cN cA wcel cK cc0
    cN cfz co wcel wa cN cK cmin co cn0 wcel cN cn0 wcel cN cK cmin co cN cle
    wbr cA cK cc0 cN fznn0sub cA cK cN elfz3nn0 cN cA wcel cK cc0 cN cfz co
    wcel wa cc0 cK cle wbr cN cK cmin co cN cle wbr cK cc0 cN cfz co wcel cc0
    cK cle wbr cN cA wcel cK cc0 cN elfzle1 adantl cN cz wcel cK cz wcel cc0 cK
    cle wbr cN cK cmin co cN cle wbr wb cN cA wcel cK cc0 cN cfz co wcel wa cN
    cr wcel cK cr wcel cc0 cK cle wbr cN cK cmin co cN cle wbr wb cN cz wcel cK
    cz wcel cN cK subge02 cN zre cK zre syl2an cA cK cc0 cN elfzel2g cK cc0 cN
    cfz co wcel cK cz wcel cN cA wcel cK cc0 cN elfzelz adantl sylanc mpbid
    3jca cN cA wcel cN cK cmin co cc0 cN cfz co wcel cN cK cmin co cn0 wcel cN
    cn0 wcel cN cK cmin co cN cle wbr w3a cA cN cK cmin co cN elfz2nn0 biimpar
    syldan $.
    $( [5-Feb-2006] $) $( [26-Sep-2005] $)

  $( Membership of a sum in a finite set of sequential integers. $)
  fzaddel $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( J e. ( M ... N ) <-> ( J + K ) e. ( ( M + K ) ... ( N + K ) ) ) ) $=
    cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cJ cz wcel cM cJ cle
    wbr cJ cN cle wbr w3a cJ cK caddc co cz wcel cM cK caddc co cJ cK caddc co
    cle wbr cJ cK caddc co cN cK caddc co cle wbr w3a cJ cM cN cfz co wcel cJ
    cK caddc co cM cK caddc co cN cK caddc co cfz co wcel cM cz wcel cN cz wcel
    wa cJ cz wcel cK cz wcel wa wa cJ cz wcel cJ cK caddc co cz wcel cM cJ cle
    wbr cM cK caddc co cJ cK caddc co cle wbr cJ cN cle wbr cJ cK caddc co cN
    cK caddc co cle wbr cJ cz wcel cK cz wcel wa cJ cz wcel cJ cK caddc co cz
    wcel wb cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa cJ cz wcel cJ cK
    caddc co cz wcel cJ cz wcel cK cz wcel wa cJ cK caddc co cz wcel cJ cz wcel
    cJ cK zaddcl a1d cJ cz wcel cK cz wcel wa cJ cz wcel cJ cK caddc co cz wcel
    cJ cz wcel cK cz wcel pm3.26 a1d impbid adantl cM cz wcel cJ cz wcel cK cz
    wcel wa cM cJ cle wbr cM cK caddc co cJ cK caddc co cle wbr wb cN cz wcel
    cM cz wcel cJ cz wcel cK cz wcel cM cJ cle wbr cM cK caddc co cJ cK caddc
    co cle wbr wb cM cr wcel cJ cr wcel cK cr wcel cM cJ cle wbr cM cK caddc co
    cJ cK caddc co cle wbr wb cM cz wcel cJ cz wcel cK cz wcel cM cJ cK leadd1
    cM zre cJ zre cK zre syl3an 3expb adantlr cN cz wcel cJ cz wcel cK cz wcel
    wa cJ cN cle wbr cJ cK caddc co cN cK caddc co cle wbr wb cM cz wcel cN cz
    wcel cJ cz wcel cK cz wcel cJ cN cle wbr cJ cK caddc co cN cK caddc co cle
    wbr wb cJ cz wcel cN cz wcel cK cz wcel cJ cN cle wbr cJ cK caddc co cN cK
    caddc co cle wbr wb cJ cr wcel cN cr wcel cK cr wcel cJ cN cle wbr cJ cK
    caddc co cN cK caddc co cle wbr wb cJ cz wcel cN cz wcel cK cz wcel cJ cN
    cK leadd1 cJ zre cN zre cK zre syl3an 3com12 3expb adantll 3anbi123d cM cz
    wcel cN cz wcel wa cJ cM cN cfz co wcel cJ cz wcel cM cJ cle wbr cJ cN cle
    wbr w3a wb cJ cz wcel cK cz wcel wa cJ cM cN elfz1 adantr cM cz wcel cN cz
    wcel wa cK cz wcel cJ cK caddc co cM cK caddc co cN cK caddc co cfz co wcel
    cJ cK caddc co cz wcel cM cK caddc co cJ cK caddc co cle wbr cJ cK caddc co
    cN cK caddc co cle wbr w3a wb cJ cz wcel cM cz wcel cN cz wcel cK cz wcel
    cJ cK caddc co cM cK caddc co cN cK caddc co cfz co wcel cJ cK caddc co cz
    wcel cM cK caddc co cJ cK caddc co cle wbr cJ cK caddc co cN cK caddc co
    cle wbr w3a wb cM cK caddc co cz wcel cN cK caddc co cz wcel cJ cK caddc co
    cM cK caddc co cN cK caddc co cfz co wcel cJ cK caddc co cz wcel cM cK
    caddc co cJ cK caddc co cle wbr cJ cK caddc co cN cK caddc co cle wbr w3a
    wb cM cz wcel cK cz wcel wa cN cz wcel cK cz wcel wa cJ cK caddc co cM cK
    caddc co cN cK caddc co elfz1 cM cK zaddcl cN cK zaddcl syl2an anandirs
    adantrl 3bitr4d $.
    $( [24-Aug-2005] $) $( [30-Jul-2005] $)

  $( Membership of a difference in a finite set of sequential integers. $)
  fzsubel $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( J e. ( M ... N ) <-> ( J - K ) e. ( ( M - K ) ... ( N - K ) ) ) ) $=
    cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cJ cM cN cfz co wcel
    cJ cK cneg caddc co cM cK cneg caddc co cN cK cneg caddc co cfz co wcel cJ
    cK cmin co cM cK cmin co cN cK cmin co cfz co wcel cM cz wcel cN cz wcel wa
    cJ cz wcel cK cneg cz wcel cJ cM cN cfz co wcel cJ cK cneg caddc co cM cK
    cneg caddc co cN cK cneg caddc co cfz co wcel wb cK cz wcel cJ cK cneg cM
    cN fzaddel cK znegcl sylanr2 cM cc wcel cN cc wcel wa cJ cc wcel cK cc wcel
    wa cJ cK cneg caddc co cM cK cneg caddc co cN cK cneg caddc co cfz co wcel
    cJ cK cmin co cM cK cmin co cN cK cmin co cfz co wcel wb cM cz wcel cN cz
    wcel wa cJ cz wcel cK cz wcel wa cM cc wcel cN cc wcel wa cJ cc wcel cK cc
    wcel wa wa cJ cK cneg caddc co cJ cK cmin co cM cK cneg caddc co cN cK cneg
    caddc co cfz co cM cK cmin co cN cK cmin co cfz co cJ cc wcel cK cc wcel wa
    cJ cK cneg caddc co cJ cK cmin co wceq cM cc wcel cN cc wcel wa cJ cK
    negsub adantl cM cc wcel cN cc wcel wa cK cc wcel cM cK cneg caddc co cN cK
    cneg caddc co cfz co cM cK cmin co cN cK cmin co cfz co wceq cJ cc wcel cM
    cc wcel cN cc wcel cK cc wcel cM cK cneg caddc co cN cK cneg caddc co cfz
    co cM cK cmin co cN cK cmin co cfz co wceq cM cc wcel cK cc wcel wa cN cc
    wcel cK cc wcel wa cM cK cneg caddc co cM cK cmin co cN cK cneg caddc co cN
    cK cmin co cfz cM cK negsub cN cK negsub opreqan12d anandirs adantrl
    eleq12d cM cz wcel cM cc wcel cN cz wcel cN cc wcel cM zcn cN zcn anim12i
    cJ cz wcel cJ cc wcel cK cz wcel cK cc wcel cJ zcn cK zcn anim12i syl2an
    bitrd $.
    $( [1-Aug-2006] $) $( [30-Jul-2005] $)

  $( A finite set of sequential integers can represent an ordered pair. $)
  fzopth $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. A ) ->
                ( ( M ... N ) = ( J ... K ) <-> ( M = J /\ N = K ) ) ) $=
    cN cM cuz cfv wcel cK cA wcel wa cM cN cfz co cJ cK cfz co wceq cM cJ wceq
    cN cK wceq wa cN cM cuz cfv wcel cK cA wcel wa cM cN cfz co cJ cK cfz co
    wceq cK cJ cuz cfv wcel cM cJ wceq cN cK wceq wa cM cN cfz co cJ cK cfz co
    wceq cN cM cuz cfv wcel cK cA wcel wa cN cJ cK cfz co wcel cK cA wcel wa cK
    cJ cuz cfv wcel cM cN cfz co cJ cK cfz co wceq cN cM cuz cfv wcel cN cJ cK
    cfz co wcel cK cA wcel cM cN cfz co cJ cK cfz co wceq cN cM cN cfz co wcel
    cN cJ cK cfz co wcel cN cM cuz cfv wcel cM cN cfz co cJ cK cfz co cN eleq2
    cM cN eluzfz2 syl5bi anim1d cK cA wcel cN cJ cK cfz co wcel cK cJ cuz cfv
    wcel cA cN cJ cK elfzuz2 ancoms syl6com cN cM cuz cfv wcel cM cN cfz co cJ
    cK cfz co wceq cK cJ cuz cfv wcel cM cJ wceq cN cK wceq wa wi wi cK cA wcel
    cN cM cuz cfv wcel cK cJ cuz cfv wcel cM cN cfz co cJ cK cfz co wceq cM cJ
    wceq cN cK wceq wa cN cM cuz cfv wcel cK cJ cuz cfv wcel cM cN cfz co cJ cK
    cfz co wceq cM cJ wceq cN cK wceq wa wi cN cM cuz cfv wcel cK cJ cuz cfv
    wcel wa cM cN cfz co cJ cK cfz co wceq cM cJ wceq cN cK wceq cN cM cuz cfv
    wcel cK cJ cuz cfv wcel wa cM cN cfz co cJ cK cfz co wceq cM cJ cle wbr cJ
    cM cle wbr wa cM cJ wceq cN cM cuz cfv wcel cK cJ cuz cfv wcel wa cM cN cfz
    co cJ cK cfz co wceq cM cJ cle wbr cJ cM cle wbr cK cJ cuz cfv wcel cM cN
    cfz co cJ cK cfz co wceq cM cJ cle wbr wi cN cM cuz cfv wcel cM cN cfz co
    cJ cK cfz co wceq cK cJ cuz cfv wcel cJ cM cN cfz co wcel cM cJ cle wbr cM
    cN cfz co cJ cK cfz co wceq cJ cM cN cfz co wcel cJ cJ cK cfz co wcel cK cJ
    cuz cfv wcel cM cN cfz co cJ cK cfz co cJ eleq2 cJ cK eluzfz1 syl5bir cJ cM
    cN elfzle1 syl6com adantl cN cM cuz cfv wcel cM cN cfz co cJ cK cfz co wceq
    cJ cM cle wbr wi cK cJ cuz cfv wcel cM cN cfz co cJ cK cfz co wceq cN cM
    cuz cfv wcel cM cJ cK cfz co wcel cJ cM cle wbr cM cN cfz co cJ cK cfz co
    wceq cM cM cN cfz co wcel cM cJ cK cfz co wcel cN cM cuz cfv wcel cM cN cfz
    co cJ cK cfz co cM eleq2 cM cN eluzfz1 syl5bi cM cJ cK elfzle1 syl6com
    adantr jcad cM cr wcel cJ cr wcel cM cJ wceq cM cJ cle wbr cJ cM cle wbr wa
    wb cN cM cuz cfv wcel cK cJ cuz cfv wcel cM cJ letri3 cN cM cuz cfv wcel cM
    cz wcel cM cr wcel cM cN eluzel2 cM zre syl cK cJ cuz cfv wcel cJ cz wcel
    cJ cr wcel cJ cK eluzel2 cJ zre syl syl2an sylibrd cN cM cuz cfv wcel cK cJ
    cuz cfv wcel wa cM cN cfz co cJ cK cfz co wceq cN cK cle wbr cK cN cle wbr
    wa cN cK wceq cN cM cuz cfv wcel cM cN cfz co cJ cK cfz co wceq cN cK cle
    wbr cK cJ cuz cfv wcel cK cN cle wbr cM cN cfz co cJ cK cfz co wceq cN cM
    cuz cfv wcel cN cJ cK cfz co wcel cN cK cle wbr cM cN cfz co cJ cK cfz co
    wceq cN cM cN cfz co wcel cN cJ cK cfz co wcel cN cM cuz cfv wcel cM cN cfz
    co cJ cK cfz co cN eleq2 cM cN eluzfz2 syl5bi cN cJ cK elfzle2 syl6com cM
    cN cfz co cJ cK cfz co wceq cK cJ cuz cfv wcel cK cM cN cfz co wcel cK cN
    cle wbr cM cN cfz co cJ cK cfz co wceq cK cM cN cfz co wcel cK cJ cK cfz co
    wcel cK cJ cuz cfv wcel cM cN cfz co cJ cK cfz co cK eleq2 cJ cK eluzfz2
    syl5bir cK cM cN elfzle2 syl6com anim12ii cN cr wcel cK cr wcel cN cK wceq
    cN cK cle wbr cK cN cle wbr wa wb cN cM cuz cfv wcel cK cJ cuz cfv wcel cN
    cK letri3 cN cM cuz cfv wcel cN cz wcel cN cr wcel cM cN eluzelz cN zre syl
    cK cJ cuz cfv wcel cK cz wcel cK cr wcel cJ cK eluzelz cK zre syl syl2an
    sylibrd jcad ex com23 adantr mpdd cM cJ cN cK cfz opreq12 impbid1 $.
    $( [1-Nov-2005] $) $( [31-Oct-2005] $)

$(
  @{
    @d j K @.  @d j M @.  @d j N @.
    @( Union of two adjacent finite sets of sequential integers. @)
    fzunt @p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\ ( K <_ M /\ M <_ N ) )
                 -> ( ( K ... M ) u. ( M ... N ) ) = ( K ... N ) ) @=
      ( vj cz wcel w3a cle wbr wa cfz co cun cv wo cr wb wi letr exp3a com23
      3exp com3l imp42 adantlll adantrl anim2d 3expa imp adantlrl adantrr
      anim1d jaod impbid exp42 com34 ex 3imp zre syl3an syl5 pm5.32d andi
      bicomi syl5bb elfz1 3anass syl6bb 3adant3 adantr 3adant1 orbi12d
      3adant2 3bitr4d elun eqrdv ) AEFZBEFZCEFZGZABHIZBCHIZJZJZDABKLZBCKLZMZACK
      LZWDDNZWEFZWIWFFZOZWIWHFZWIWGFWDWIEFZAWIHIZWIBHIZJZJZWNBWIHIZWICHIZJZJZOZ
      WNWOWTJZJZWLWMWDWNWQXAOZJZXEXCWDWNXFXDWDWIPFZXFXDQZWNVTWCXHXIRZAPFZBPFZCP
      FZWCXJRZVQVRVSXKXLXMXNXKXLXMXNRXKXLJZXMXHWCXIXOXMXHWCXIXOXMXHJZJZWCJZXFXD
      XRWQXDXAXRWPWTWOXQWBWPWTRZWAXLXPWBXSXKXLXMXHWBXSXHXLXMWBXSRZXHXLXMXTXHXLX
      MGZWPWBWTYAWPWBWTWIBCSTUAUBUCUDUEUFUGXRWSWOWTXQWAWSWORZWBXOXHWAYBXMXOXHJZ
      WAYBYCWAWSWOXKXLXHWAWSJWORABWISUHTUIUJUKULUM?UNUOUPUQURAUSBUSCUSUTUIWIUSV
      AVBXGXCWNWQXAVCVDVEWDWJWRWKXBVTWJWRQZWCVQVRYDVSVQVRJWJWNWOWPGWRWIABVFWNWO
      WPVGVHVIVJVTWKXBQZWCVRVSYEVQVRVSJWKWNWSWTGXBWIBCVFWNWSWTVGVHVKVJVLVTWMXEQ
      ZWCVQVSYFVRVQVSJWMWNWOWTGXEWIACVFWNWOWTVGVHVMVJVNWIWEWFVOVEVP @.
      @( [ ?] @) @( [21-Jul-2005] @)
  @}
$)

  ${
    $d k M $.  $d k N $.  $d k K $.
    $( Subset relationship for finite sets of sequential integers. $)
    fzss1 $p |- ( ( K e. ( ZZ>= ` M ) /\ N e. ZZ ) ->
                  ( K ... N ) C_ ( M ... N ) ) $=
      cK cM cuz cfv wcel cN cz wcel wa cK vk cv cle wbr vk cv cN cle wbr wa vk
      cz crab cM vk cv cle wbr vk cv cN cle wbr wa vk cz crab cK cN cfz co cM
      cN cfz co cK cM cuz cfv wcel cK vk cv cle wbr vk cv cN cle wbr wa vk cz
      crab cM vk cv cle wbr vk cv cN cle wbr wa vk cz crab wss cN cz wcel cK cM
      cuz cfv wcel cK vk cv cle wbr vk cv cN cle wbr wa cM vk cv cle wbr vk cv
      cN cle wbr wa vk cz cK cM cuz cfv wcel vk cv cz wcel wa cK vk cv cle wbr
      cM vk cv cle wbr vk cv cN cle wbr cK cM cuz cfv wcel vk cv cz wcel wa cM
      cK cle wbr cK vk cv cle wbr cM vk cv cle wbr cK cM cuz cfv wcel cM cK cle
      wbr vk cv cz wcel cM cK eluzle adantr cM cz wcel cK cz wcel wa vk cv cz
      wcel cM cK cle wbr cK vk cv cle wbr wa cM vk cv cle wbr wi cK cM cuz cfv
      wcel cM cz wcel cK cz wcel vk cv cz wcel cM cK cle wbr cK vk cv cle wbr
      wa cM vk cv cle wbr wi cM cr wcel cK cr wcel vk cv cr wcel cM cK cle wbr
      cK vk cv cle wbr wa cM vk cv cle wbr wi cM cz wcel cK cz wcel vk cv cz
      wcel cM cK vk cv letr cM zre cK zre vk cv zre syl3an 3expa cK cM cuz cfv
      wcel cM cz wcel cK cz wcel cM cK eluzel2 cM cK eluzelz jca sylan mpand
      anim1d ss2rabdv adantr cK cz wcel cN cz wcel cK cN cfz co cK vk cv cle
      wbr vk cv cN cle wbr wa vk cz crab wceq cK cM cuz cfv wcel vk cK cN fzval
      cM cK eluzelz sylan cM cz wcel cN cz wcel cM cN cfz co cM vk cv cle wbr
      vk cv cN cle wbr wa vk cz crab wceq cK cM cuz cfv wcel vk cM cN fzval cM
      cK eluzel2 sylan 3sstr4d $.
      $( [10-Oct-2005] $) $( [28-Sep-2005] $)

    $( Subset relationship for finite sets of sequential integers. $)
    fzss2 $p |- ( ( N e. ( ZZ>= ` K ) /\ M e. ZZ ) ->
                  ( M ... K ) C_ ( M ... N ) ) $=
      cM cz wcel cN cK cuz cfv wcel cM cK cfz co cM cN cfz co wss cM cz wcel cN
      cK cuz cfv wcel wa cM vk cv cle wbr vk cv cK cle wbr wa vk cz crab cM vk
      cv cle wbr vk cv cN cle wbr wa vk cz crab cM cK cfz co cM cN cfz co cN cK
      cuz cfv wcel cM vk cv cle wbr vk cv cK cle wbr wa vk cz crab cM vk cv cle
      wbr vk cv cN cle wbr wa vk cz crab wss cM cz wcel cN cK cuz cfv wcel cM
      vk cv cle wbr vk cv cK cle wbr wa cM vk cv cle wbr vk cv cN cle wbr wa vk
      cz cN cK cuz cfv wcel vk cv cz wcel wa vk cv cK cle wbr vk cv cN cle wbr
      cM vk cv cle wbr vk cv cz wcel cN cK cuz cfv wcel vk cv cK cle wbr vk cv
      cN cle wbr wi vk cv cz wcel cN cK cuz cfv wcel wa vk cv cK cle wbr cK cN
      cle wbr vk cv cN cle wbr cN cK cuz cfv wcel cK cN cle wbr vk cv cz wcel
      cK cN eluzle adantl vk cv cz wcel cK cz wcel cN cz wcel wa vk cv cK cle
      wbr cK cN cle wbr wa vk cv cN cle wbr wi cN cK cuz cfv wcel vk cv cz wcel
      cK cz wcel cN cz wcel vk cv cK cle wbr cK cN cle wbr wa vk cv cN cle wbr
      wi vk cv cr wcel cK cr wcel cN cr wcel vk cv cK cle wbr cK cN cle wbr wa
      vk cv cN cle wbr wi vk cv cz wcel cK cz wcel cN cz wcel vk cv cK cN letr
      vk cv zre cK zre cN zre syl3an 3expb cN cK cuz cfv wcel cK cz wcel cN cz
      wcel cK cN eluzel2 cK cN eluzelz jca sylan2 mpan2d ancoms anim2d ss2rabdv
      adantl cM cz wcel cK cz wcel cM cK cfz co cM vk cv cle wbr vk cv cK cle
      wbr wa vk cz crab wceq cN cK cuz cfv wcel vk cM cK fzval cK cN eluzel2
      sylan2 cM cz wcel cN cz wcel cM cN cfz co cM vk cv cle wbr vk cv cN cle
      wbr wa vk cz crab wceq cN cK cuz cfv wcel vk cM cN fzval cK cN eluzelz
      sylan2 3sstr4d ancoms $.
      $( [2-Nov-2005] $) $( [4-Oct-2005] $)

    $( A finite set of sequential integers is a subset of a set of upper
       integers. $)
    fzssuz $p |- ( M ... N ) C_ ( ZZ>= ` M ) $=
      vk cM cN cfz co cM cuz cfv vk cv cM cN elfzuz ssriv $.
      $( [25-Apr-2006] $) $( [28-Oct-2005] $)
  $}

  ${
    $d M k $.  $d N k $.
    $( Join a successor to the end of a finite set of sequential integers. $)
    fzsuc $p |- ( ( M e. ZZ /\ N e. ZZ /\ M <_ ( N + 1 ) )
                -> ( M ... ( N + 1 ) ) = ( ( M ... N ) u. { ( N + 1 ) } ) ) $=
      cM cz wcel cN cz wcel cM cN c1 caddc co cle wbr w3a vk cM cN c1 caddc co
      cfz co cM cN cfz co cN c1 caddc co csn cun cM cz wcel cN cz wcel cM cN c1
      caddc co cle wbr w3a vk cv cM cN cfz co wcel vk cv cN c1 caddc co csn
      wcel wo vk cv cM cN c1 caddc co cfz co wcel vk cv cM cN cfz co cN c1
      caddc co csn cun wcel cM cz wcel cN cz wcel cM cN c1 caddc co cle wbr w3a
      vk cv cM cN cfz co wcel vk cv cN c1 caddc co csn wcel wo vk cv cz wcel cM
      vk cv cle wbr vk cv cN c1 caddc co cle wbr wa wa vk cv cM cN c1 caddc co
      cfz co wcel cM cz wcel cN cz wcel cM cN c1 caddc co cle wbr w3a vk cv cM
      cN cfz co wcel vk cv cN c1 caddc co csn wcel wo vk cv cz wcel cM vk cv
      cle wbr vk cv cN cle wbr wa wa vk cv cN c1 caddc co csn wcel wo vk cv cz
      wcel cM vk cv cle wbr vk cv cN cle wbr wa wa vk cv cz wcel cM vk cv cle
      wbr vk cv cN c1 caddc co wceq wa wa wo vk cv cz wcel cM vk cv cle wbr vk
      cv cN c1 caddc co cle wbr wa wa cM cz wcel cN cz wcel cM cN c1 caddc co
      cle wbr w3a vk cv cM cN cfz co wcel vk cv cz wcel cM vk cv cle wbr vk cv
      cN cle wbr wa wa vk cv cN c1 caddc co csn wcel cM cz wcel cN cz wcel vk
      cv cM cN cfz co wcel vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa
      wa wb cM cN c1 caddc co cle wbr cM cz wcel cN cz wcel wa vk cv cM cN cfz
      co wcel vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr w3a vk cv cz wcel
      cM vk cv cle wbr vk cv cN cle wbr wa wa vk cv cM cN elfz1 vk cv cz wcel
      cM vk cv cle wbr vk cv cN cle wbr 3anass syl6bb 3adant3 orbi1d cM cz wcel
      cN cz wcel cM cN c1 caddc co cle wbr w3a vk cv cN c1 caddc co csn wcel vk
      cv cz wcel cM vk cv cle wbr vk cv cN c1 caddc co wceq wa wa vk cv cz wcel
      cM vk cv cle wbr vk cv cN cle wbr wa wa cN cz wcel cM cN c1 caddc co cle
      wbr vk cv cN c1 caddc co csn wcel vk cv cz wcel cM vk cv cle wbr vk cv cN
      c1 caddc co wceq wa wa wb cM cz wcel cN cz wcel cM cN c1 caddc co cle wbr
      wa vk cv cN c1 caddc co wceq vk cv cz wcel cM vk cv cle wbr vk cv cN c1
      caddc co wceq wa wa vk cv cN c1 caddc co csn wcel cN cz wcel cM cN c1
      caddc co cle wbr wa vk cv cN c1 caddc co wceq vk cv cz wcel cM vk cv cle
      wbr wa vk cv cN c1 caddc co wceq wa vk cv cz wcel cM vk cv cle wbr vk cv
      cN c1 caddc co wceq wa wa cN cz wcel cM cN c1 caddc co cle wbr wa vk cv
      cN c1 caddc co wceq vk cv cz wcel cM vk cv cle wbr wa cN c1 caddc co cz
      wcel cM cN c1 caddc co cle wbr vk cv cN c1 caddc co wceq vk cv cz wcel cM
      vk cv cle wbr wa wi cN cz wcel vk cv cN c1 caddc co wceq vk cv cz wcel cM
      vk cv cle wbr wa cN c1 caddc co cz wcel cM cN c1 caddc co cle wbr wa vk
      cv cN c1 caddc co wceq vk cv cz wcel cN c1 caddc co cz wcel cM vk cv cle
      wbr cM cN c1 caddc co cle wbr vk cv cN c1 caddc co cz eleq1 vk cv cN c1
      caddc co cM cle breq2 anbi12d biimprcd cN peano2z sylan pm4.71rd vk cv cz
      wcel cM vk cv cle wbr vk cv cN c1 caddc co wceq anass syl6bb vk cN c1
      caddc co elsn syl5bb 3adant1 orbi2d cM cz wcel cN cz wcel vk cv cz wcel
      cM vk cv cle wbr vk cv cN cle wbr wa wa vk cv cz wcel cM vk cv cle wbr vk
      cv cN c1 caddc co wceq wa wa wo vk cv cz wcel cM vk cv cle wbr vk cv cN
      c1 caddc co cle wbr wa wa wb cM cN c1 caddc co cle wbr cM cz wcel cN cz
      wcel wa vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr vk cv cN c1 caddc
      co wceq wo wa wa vk cv cz wcel cM vk cv cle wbr vk cv cN c1 caddc co cle
      wbr wa wa vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa wa vk cv cz
      wcel cM vk cv cle wbr vk cv cN c1 caddc co wceq wa wa wo cM cz wcel cN cz
      wcel wa vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr vk cv cN c1 caddc
      co wceq wo wa cM vk cv cle wbr vk cv cN c1 caddc co cle wbr wa cM cz wcel
      cN cz wcel wa vk cv cz wcel wa vk cv cN cle wbr vk cv cN c1 caddc co wceq
      wo vk cv cN c1 caddc co cle wbr cM vk cv cle wbr cN cz wcel vk cv cz wcel
      vk cv cN cle wbr vk cv cN c1 caddc co wceq wo vk cv cN c1 caddc co cle
      wbr wb cM cz wcel vk cv cz wcel cN cz wcel vk cv cN cle wbr vk cv cN c1
      caddc co wceq wo vk cv cN c1 caddc co cle wbr wb vk cv cz wcel cN cz wcel
      wa vk cv cN cle wbr vk cv cN c1 caddc co wceq wo vk cv cN c1 caddc co clt
      wbr vk cv cN c1 caddc co wceq wo vk cv cN c1 caddc co cle wbr vk cv cz
      wcel cN cz wcel wa vk cv cN cle wbr vk cv cN c1 caddc co clt wbr vk cv cN
      c1 caddc co wceq vk cv cN zleltp1 orbi1d vk cv cr wcel cN c1 caddc co cr
      wcel vk cv cN c1 caddc co cle wbr vk cv cN c1 caddc co clt wbr vk cv cN
      c1 caddc co wceq wo wb vk cv cz wcel cN cz wcel vk cv cN c1 caddc co
      leloe vk cv zre cN cz wcel cN cr wcel cN c1 caddc co cr wcel cN zre cN
      peano2re syl syl2an bitr4d ancoms adantll anbi2d pm5.32da vk cv cz wcel
      cM vk cv cle wbr vk cv cN cle wbr vk cv cN c1 caddc co wceq wo wa wa vk
      cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa cM vk cv cle wbr vk cv cN
      c1 caddc co wceq wa wo wa vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr
      wa wa vk cv cz wcel cM vk cv cle wbr vk cv cN c1 caddc co wceq wa wa wo
      cM vk cv cle wbr vk cv cN cle wbr vk cv cN c1 caddc co wceq wo wa cM vk
      cv cle wbr vk cv cN cle wbr wa cM vk cv cle wbr vk cv cN c1 caddc co wceq
      wa wo vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr vk cv cN c1 caddc
      co wceq andi anbi2i vk cv cz wcel cM vk cv cle wbr vk cv cN cle wbr wa cM
      vk cv cle wbr vk cv cN c1 caddc co wceq wa andi bitr2i syl5bb 3adant3
      3bitrd cM cz wcel cN cz wcel vk cv cM cN c1 caddc co cfz co wcel vk cv cz
      wcel cM vk cv cle wbr vk cv cN c1 caddc co cle wbr wa wa wb cM cN c1
      caddc co cle wbr cM cz wcel cN c1 caddc co cz wcel vk cv cM cN c1 caddc
      co cfz co wcel vk cv cz wcel cM vk cv cle wbr vk cv cN c1 caddc co cle
      wbr wa wa wb cN cz wcel cM cz wcel cN c1 caddc co cz wcel wa vk cv cM cN
      c1 caddc co cfz co wcel vk cv cz wcel cM vk cv cle wbr vk cv cN c1 caddc
      co cle wbr w3a vk cv cz wcel cM vk cv cle wbr vk cv cN c1 caddc co cle
      wbr wa wa vk cv cM cN c1 caddc co elfz1 vk cv cz wcel cM vk cv cle wbr vk
      cv cN c1 caddc co cle wbr 3anass syl6bb cN peano2z sylan2 3adant3 bitr4d
      vk cv cM cN cfz co cN c1 caddc co csn elun syl5rbb eqrdv $.
      $( [20-Feb-2009] $) $( [19-Jul-2008] $)
  $}

  $( Subset relationship for finite sets of sequential integers. $)
  fzssp1 $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                ( M ... N ) C_ ( M ... ( N + 1 ) ) ) $=
    cN cz wcel cM cz wcel cM cN cfz co cM cN c1 caddc co cfz co wss cN c1 caddc
    co cN cuz cfv wcel cM cz wcel cM cN cfz co cM cN c1 caddc co cfz co wss cN
    cz wcel cN cM cN c1 caddc co fzss2 cN cz wcel cN cN cuz cfv wcel cN c1
    caddc co cN cuz cfv wcel cN uzid cN cN peano2uz syl sylan ancoms $.
    $( [19-Aug-2005] $) $( [21-Jul-2005] $)

  $( Subset relationship for finite sets of sequential integers. $)
  fzp1ss $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                ( ( M + 1 ) ... N ) C_ ( M ... N ) ) $=
    cM c1 caddc co cM cuz cfv wcel cN cz wcel cM c1 caddc co cN cfz co cM cN
    cfz co wss cM cz wcel cM c1 caddc co cM cN fzss1 cM cz wcel cM cM cuz cfv
    wcel cM c1 caddc co cM cuz cfv wcel cM uzid cM cM peano2uz syl sylan $.
    $( [23-Aug-2005] $) $( [26-Jul-2005] $)

  $( Membership in a set of sequential integers with an appended element. $)
  fzelp1 $p |- ( ( N e. A /\ K e. ( M ... N ) ) ->
                K e. ( M ... ( N + 1 ) ) ) $=
    cN cA wcel cK cM cN cfz co wcel wa cM cN cfz co cM cN c1 caddc co cfz co cK
    cM cz wcel cN cz wcel cM cN cfz co cM cN c1 caddc co cfz co wss cN cA wcel
    cK cM cN cfz co wcel wa cM cN fzssp1 cK cM cN cfz co wcel cM cz wcel cN cA
    wcel cK cM cN elfzel1 adantl cA cK cM cN elfzel2g sylanc cN cA wcel cK cM
    cN cfz co wcel pm3.27 sseldd $.
    $( [31-Jan-2006] $) $( [7-Dec-2005] $)

  ${
    fzelp1.1 $e |- N e. _V $.
    $( Membership in a set of sequential integers with an appended element. $)
    fzelp1i $p |- ( K e. ( M ... N ) -> K e. ( M ... ( N + 1 ) ) ) $=
      cN cvv wcel cK cM cN cfz co wcel cK cM cN c1 caddc co cfz co wcel
      fzelp1.1 cvv cK cM cN fzelp1 mpan $.
      $( [8-Feb-2006] $) $( [3-Dec-2005] $)
  $}

  $( MAY BE REVISED - generalize antecedent per ~ fzsuc ; use it or v.versa $)
  $( Append an element to a finite set of sequential integers. $)
  elfzp1 $p |- ( N e. ( ZZ>= ` M ) ->
    ( K e. ( M ... ( N + 1 ) ) <-> ( K e. ( M ... N ) \/ K = ( N + 1 ) ) ) ) $=
    cN cM cuz cfv wcel cK cM cN c1 caddc co cfz co wcel cK cM cN cfz co wcel cK
    cN c1 caddc co wceq wo cN cM cuz cfv wcel cK cM cN c1 caddc co cfz co wcel
    cK cM cN cfz co wcel cK cN c1 caddc co wceq wo cN cM cuz cfv wcel cK cM cN
    c1 caddc co cfz co wcel wa cN c1 caddc co cK wne cK cM cN cfz co wcel wi cK
    cM cN cfz co wcel cK cN c1 caddc co wceq wo cN cM cuz cfv wcel cK cM cN c1
    caddc co cfz co wcel wa cN c1 caddc co cK wne cM cz wcel cN cz wcel cK cz
    wcel w3a cM cK cle wbr cK cN cle wbr wa wa cK cM cN cfz co wcel cN cM cuz
    cfv wcel cK cM cN c1 caddc co cfz co wcel wa cN c1 caddc co cK wne cM cz
    wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa cN cM cuz
    cfv wcel cK cM cN c1 caddc co cfz co wcel wa cN c1 caddc co cK wne wa cM cz
    wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr cN cM cuz cfv
    wcel cK cM cN c1 caddc co cfz co wcel wa cN c1 caddc co cK wne wa cM cz
    wcel cN cz wcel cK cz wcel cN cM cuz cfv wcel cM cz wcel cK cM cN c1 caddc
    co cfz co wcel cN c1 caddc co cK wne cM cN eluzel2 ad2antrr cN cM cuz cfv
    wcel cN cz wcel cK cM cN c1 caddc co cfz co wcel cN c1 caddc co cK wne cM
    cN eluzelz ad2antrr cK cM cN c1 caddc co cfz co wcel cK cz wcel cN cM cuz
    cfv wcel cN c1 caddc co cK wne cK cM cN c1 caddc co elfzelz ad2antlr 3jca
    cK cM cN c1 caddc co cfz co wcel cM cK cle wbr cN cM cuz cfv wcel cN c1
    caddc co cK wne cK cM cN c1 caddc co elfzle1 ad2antlr cN cM cuz cfv wcel cK
    cM cN c1 caddc co cfz co wcel wa cN c1 caddc co cK wne wa cK cN cle wbr cK
    cN c1 caddc co clt wbr cN cM cuz cfv wcel cK cM cN c1 caddc co cfz co wcel
    wa cN c1 caddc co cK wne wa cK cN c1 caddc co clt wbr cK cN c1 caddc co cle
    wbr cN c1 caddc co cK wne wa cN cM cuz cfv wcel cK cM cN c1 caddc co cfz co
    wcel wa cK cN c1 caddc co cle wbr cN c1 caddc co cK wne cK cM cN c1 caddc
    co cfz co wcel cK cN c1 caddc co cle wbr cN cM cuz cfv wcel cK cM cN c1
    caddc co elfzle2 adantl anim1i cK cr wcel cN c1 caddc co cr wcel cK cN c1
    caddc co clt wbr cK cN c1 caddc co cle wbr cN c1 caddc co cK wne wa wb cN
    cM cuz cfv wcel cK cM cN c1 caddc co cfz co wcel wa cN c1 caddc co cK wne
    wa cK cN c1 caddc co ltlen cK cM cN c1 caddc co cfz co wcel cK cr wcel cN
    cM cuz cfv wcel cN c1 caddc co cK wne cK cM cN c1 caddc co cfz co wcel cK
    cz wcel cK cr wcel cK cM cN c1 caddc co elfzelz cK zre syl ad2antlr cN cM
    cuz cfv wcel cN c1 caddc co cr wcel cK cM cN c1 caddc co cfz co wcel cN c1
    caddc co cK wne cN cM cuz cfv wcel cN cz wcel cN cr wcel cN c1 caddc co cr
    wcel cM cN eluzelz cN zre cN peano2re 3syl ad2antrr sylanc mpbird cK cz
    wcel cN cz wcel cK cN cle wbr cK cN c1 caddc co clt wbr wb cN cM cuz cfv
    wcel cK cM cN c1 caddc co cfz co wcel wa cN c1 caddc co cK wne wa cK cN
    zleltp1 cK cM cN c1 caddc co cfz co wcel cK cz wcel cN cM cuz cfv wcel cN
    c1 caddc co cK wne cK cM cN c1 caddc co elfzelz ad2antlr cN cM cuz cfv wcel
    cN cz wcel cK cM cN c1 caddc co cfz co wcel cN c1 caddc co cK wne cM cN
    eluzelz ad2antrr sylanc mpbird jca32 ex cN cM cuz cfv wcel cK cM cN cfz co
    wcel cM cz wcel cN cz wcel cK cz wcel w3a cM cK cle wbr cK cN cle wbr wa wa
    wb cK cM cN c1 caddc co cfz co wcel cM cuz cfv cK cM cN elfz2 adantr
    sylibrd cN c1 caddc co cK wceq cK cM cN cfz co wcel wo cK cN c1 caddc co
    wceq cK cM cN cfz co wcel wo cN c1 caddc co cK wne cK cM cN cfz co wcel wi
    cK cM cN cfz co wcel cK cN c1 caddc co wceq wo cN c1 caddc co cK wceq cK cN
    c1 caddc co wceq cK cM cN cfz co wcel cN c1 caddc co cK eqcom orbi1i cK cM
    cN cfz co wcel cN c1 caddc co cK neor cK cN c1 caddc co wceq cK cM cN cfz
    co wcel orcom 3bitr3i sylib ex cN cM cuz cfv wcel cK cM cN cfz co wcel cK
    cM cN c1 caddc co cfz co wcel cK cN c1 caddc co wceq cN cM cuz cfv wcel cM
    cN cfz co cM cN c1 caddc co cfz co cK cM cz wcel cN cz wcel cM cN cfz co cM
    cN c1 caddc co cfz co wss cN cM cuz cfv wcel cM cN fzssp1 cM cN eluzel2 cM
    cN eluzelz sylanc sseld cK cN c1 caddc co wceq cK cM cN c1 caddc co cfz co
    wcel cN c1 caddc co cM cN c1 caddc co cfz co wcel cN cM cuz cfv wcel cK cN
    c1 caddc co cM cN c1 caddc co cfz co eleq1 cN cM cuz cfv wcel cN c1 caddc
    co cM cuz cfv wcel cN c1 caddc co cM cN c1 caddc co cfz co wcel cM cN
    peano2uz cM cN c1 caddc co eluzfz2 syl syl5cbir jaod impbid $.
    $( [3-Oct-2005] $) $( [19-Sep-2005] $)

  $( Reversal of start and end of a finite set of sequential integers. $)
  fzrev $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( K e. ( ( J - N ) ... ( J - M ) ) <-> ( J - K ) e. ( M ... N ) ) ) $=
    cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cJ cN cmin co cK cle
    wbr cK cJ cM cmin co cle wbr wa cM cJ cK cmin co cle wbr cJ cK cmin co cN
    cle wbr wa cK cJ cN cmin co cJ cM cmin co cfz co wcel cJ cK cmin co cM cN
    cfz co wcel cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cJ cK cmin
    co cN cle wbr cM cJ cK cmin co cle wbr wa cJ cN cmin co cK cle wbr cK cJ cM
    cmin co cle wbr wa cM cJ cK cmin co cle wbr cJ cK cmin co cN cle wbr wa cM
    cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cJ cK cmin co cN cle wbr
    cJ cN cmin co cK cle wbr cM cJ cK cmin co cle wbr cK cJ cM cmin co cle wbr
    cN cz wcel cJ cz wcel cK cz wcel wa cJ cK cmin co cN cle wbr cJ cN cmin co
    cK cle wbr wb cM cz wcel cN cz wcel cJ cz wcel cK cz wcel cJ cK cmin co cN
    cle wbr cJ cN cmin co cK cle wbr wb cJ cz wcel cK cz wcel cN cz wcel cJ cK
    cmin co cN cle wbr cJ cN cmin co cK cle wbr wb cJ cr wcel cK cr wcel cN cr
    wcel cJ cK cmin co cN cle wbr cJ cN cmin co cK cle wbr wb cJ cz wcel cK cz
    wcel cN cz wcel cJ cK cN suble cJ zre cK zre cN zre syl3an 3comr 3expb
    adantll cM cz wcel cJ cz wcel cK cz wcel wa cM cJ cK cmin co cle wbr cK cJ
    cM cmin co cle wbr wb cN cz wcel cM cz wcel cJ cz wcel cK cz wcel cM cJ cK
    cmin co cle wbr cK cJ cM cmin co cle wbr wb cM cr wcel cJ cr wcel cK cr
    wcel cM cJ cK cmin co cle wbr cK cJ cM cmin co cle wbr wb cM cz wcel cJ cz
    wcel cK cz wcel cM cJ cK lesub cM zre cJ zre cK zre syl3an 3expb adantlr
    anbi12d cJ cK cmin co cN cle wbr cM cJ cK cmin co cle wbr ancom syl5rbbr cK
    cz wcel cJ cN cmin co cz wcel cJ cM cmin co cz wcel cK cJ cN cmin co cJ cM
    cmin co cfz co wcel cJ cN cmin co cK cle wbr cK cJ cM cmin co cle wbr wa wb
    cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cK cJ cN cmin co cJ cM
    cmin co elfz cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel simprr cN cz
    wcel cJ cz wcel cJ cN cmin co cz wcel cM cz wcel cK cz wcel cJ cz wcel cN
    cz wcel cJ cN cmin co cz wcel cJ cN zsubcl ancoms ad2ant2lr cM cz wcel cJ
    cz wcel cJ cM cmin co cz wcel cN cz wcel cK cz wcel cJ cz wcel cM cz wcel
    cJ cM cmin co cz wcel cJ cM zsubcl ancoms ad2ant2r syl3anc cJ cK cmin co cz
    wcel cM cz wcel cN cz wcel cJ cK cmin co cM cN cfz co wcel cM cJ cK cmin co
    cle wbr cJ cK cmin co cN cle wbr wa wb cM cz wcel cN cz wcel wa cJ cz wcel
    cK cz wcel wa wa cJ cK cmin co cM cN elfz cJ cz wcel cK cz wcel wa cJ cK
    cmin co cz wcel cM cz wcel cN cz wcel wa cJ cK zsubcl adantl cM cz wcel cN
    cz wcel cJ cz wcel cK cz wcel wa simpll cM cz wcel cN cz wcel cJ cz wcel cK
    cz wcel wa simplr syl3anc 3bitr4d $.
    $( [2-Dec-2005] $) $( [25-Nov-2005] $)

  $( Reversal of start and end of a finite set of sequential integers. $)
  fzrev2 $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( K e. ( M ... N ) <-> ( J - K ) e. ( ( J - N ) ... ( J - M ) ) ) ) $=
    cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa wa cJ cK cmin co cJ cN
    cmin co cJ cM cmin co cfz co wcel cJ cJ cK cmin co cmin co cM cN cfz co
    wcel cK cM cN cfz co wcel cM cz wcel cN cz wcel wa cJ cz wcel cJ cK cmin co
    cz wcel wa cJ cK cmin co cJ cN cmin co cJ cM cmin co cfz co wcel cJ cJ cK
    cmin co cmin co cM cN cfz co wcel wb cJ cz wcel cK cz wcel wa cJ cJ cK cmin
    co cM cN fzrev cJ cz wcel cK cz wcel wa cJ cz wcel cJ cK cmin co cz wcel cJ
    cz wcel cK cz wcel pm3.26 cJ cK zsubcl jca sylan2 cM cz wcel cN cz wcel wa
    cJ cz wcel cK cz wcel wa wa cJ cJ cK cmin co cmin co cK cM cN cfz co cJ cz
    wcel cK cz wcel wa cJ cJ cK cmin co cmin co cK wceq cM cz wcel cN cz wcel
    wa cJ cc wcel cK cc wcel cJ cJ cK cmin co cmin co cK wceq cJ cz wcel cK cz
    wcel cJ cK nncan cJ zcn cK zcn syl2an adantl eleq1d bitr2d $.
    $( [4-Dec-2005] $) $( [25-Nov-2005] $)

  $( Reversal of start and end of a finite set of sequential integers. $)
  fzrev2i $p |- ( ( N e. A /\ J e. ZZ /\ K e. ( M ... N ) ) ->
                 ( J - K ) e. ( ( J - N ) ... ( J - M ) ) ) $=
    cN cA wcel cJ cz wcel cK cM cN cfz co wcel w3a cK cM cN cfz co wcel cJ cK
    cmin co cJ cN cmin co cJ cM cmin co cfz co wcel cN cA wcel cJ cz wcel cK cM
    cN cfz co wcel 3simp3 cM cz wcel cN cz wcel wa cJ cz wcel cK cz wcel wa cK
    cM cN cfz co wcel cJ cK cmin co cJ cN cmin co cJ cM cmin co cfz co wcel wb
    cN cA wcel cJ cz wcel cK cM cN cfz co wcel w3a cJ cK cM cN fzrev2 cN cA
    wcel cK cM cN cfz co wcel cM cz wcel cN cz wcel wa cJ cz wcel cN cA wcel cK
    cM cN cfz co wcel wa cM cz wcel cN cz wcel cK cM cN cfz co wcel cM cz wcel
    cN cA wcel cK cM cN elfzel1 adantl cA cK cM cN elfzel2g jca 3adant2 cJ cz
    wcel cK cM cN cfz co wcel cJ cz wcel cK cz wcel wa cN cA wcel cK cM cN cfz
    co wcel cK cz wcel cJ cz wcel cK cM cN elfzelz anim2i 3adant1 sylanc mpbid
    $.
    $( [7-Dec-2005] $) $( [25-Nov-2005] $)

  $( The "complement" of a member of a finite set of sequential integers. $)
  fzrev3 $p |- ( ( N e. A /\ K e. ZZ ) -> ( K e. ( M ... N ) <->
                ( ( M + N ) - K ) e. ( M ... N ) ) ) $=
    cN cA wcel cK cz wcel wa cK cM cN cfz co wcel cM cN caddc co cK cmin co cM
    cN cfz co wcel cK cz wcel cM cz wcel cN cz wcel w3a cN cA wcel cK cz wcel
    wa cK cM cN cfz co wcel wa cK cz wcel cM cz wcel cN cz wcel cN cA wcel cK
    cz wcel cK cM cN cfz co wcel simplr cK cM cN cfz co wcel cM cz wcel cN cA
    wcel cK cz wcel wa cK cM cN elfzel1 adantl cN cA wcel cK cM cN cfz co wcel
    cN cz wcel cK cz wcel cA cK cM cN elfzel2g adantlr 3jca cN cA wcel cK cz
    wcel wa cM cN caddc co cK cmin co cM cN cfz co wcel wa cK cz wcel cM cz
    wcel cN cz wcel cN cA wcel cK cz wcel cM cN caddc co cK cmin co cM cN cfz
    co wcel simplr cM cN caddc co cK cmin co cM cN cfz co wcel cM cz wcel cN cA
    wcel cK cz wcel wa cM cN caddc co cK cmin co cM cN elfzel1 adantl cN cA
    wcel cM cN caddc co cK cmin co cM cN cfz co wcel cN cz wcel cK cz wcel cA
    cM cN caddc co cK cmin co cM cN elfzel2g adantlr 3jca cK cz wcel cM cz wcel
    cN cz wcel w3a cK cM cN caddc co cN cmin co cM cN caddc co cM cmin co cfz
    co wcel cK cM cN cfz co wcel cM cN caddc co cK cmin co cM cN cfz co wcel cM
    cz wcel cN cz wcel cK cM cN caddc co cN cmin co cM cN caddc co cM cmin co
    cfz co wcel cK cM cN cfz co wcel wb cK cz wcel cM cz wcel cN cz wcel wa cM
    cN caddc co cN cmin co cM cN caddc co cM cmin co cfz co cM cN cfz co cK cM
    cc wcel cN cc wcel cM cN caddc co cN cmin co cM cN caddc co cM cmin co cfz
    co cM cN cfz co wceq cM cz wcel cN cz wcel cM cc wcel cN cc wcel wa cM cN
    caddc co cN cmin co cM cM cN caddc co cM cmin co cN cfz cM cN pncan cM cN
    pncan2 opreq12d cM zcn cN zcn syl2an eleq2d 3adant1 cM cz wcel cN cz wcel
    wa cM cN caddc co cz wcel cK cz wcel wa cK cM cN caddc co cN cmin co cM cN
    caddc co cM cmin co cfz co wcel cM cN caddc co cK cmin co cM cN cfz co wcel
    wb cK cz wcel cM cz wcel cN cz wcel w3a cM cN caddc co cK cM cN fzrev cK cz
    wcel cM cz wcel cN cz wcel 3simpc cK cz wcel cM cz wcel cN cz wcel w3a cM
    cN caddc co cz wcel cK cz wcel cM cz wcel cN cz wcel cM cN caddc co cz wcel
    cK cz wcel cM cN zaddcl 3adant1 cK cz wcel cM cz wcel cN cz wcel 3simp1 jca
    sylanc bitr3d pm5.21nd $.
    $( [23-Feb-2006] $) $( [20-Nov-2005] $)

  $( The "complement" of a member of a finite set of sequential integers. $)
  fzrev3i $p |- ( ( N e. A /\ K e. ( M ... N ) ) ->
                ( ( M + N ) - K ) e. ( M ... N ) ) $=
    cN cA wcel cK cM cN cfz co wcel wa cK cM cN cfz co wcel cM cN caddc co cK
    cmin co cM cN cfz co wcel cN cA wcel cK cM cN cfz co wcel pm3.27 cN cA wcel
    cK cz wcel cK cM cN cfz co wcel cM cN caddc co cK cmin co cM cN cfz co wcel
    wb cK cM cN cfz co wcel cA cK cM cN fzrev3 cK cM cN elfzelz sylan2 mpbid $.
    $( [1-May-2006] $) $( [20-Nov-2005] $)

  $( Finite set of sequential integers starting at 0. $)
  fznn0 $p |- ( N e. NN0 ->
              ( K e. ( 0 ... N ) <-> ( K e. NN0 /\ K <_ N ) ) ) $=
    cN cn0 wcel cK cc0 cN cfz co wcel cK cz wcel cc0 cK cle wbr cK cN cle wbr
    w3a cK cn0 wcel cK cN cle wbr wa cc0 cz wcel cN cz wcel cK cc0 cN cfz co
    wcel cK cz wcel cc0 cK cle wbr cK cN cle wbr w3a wb cN cn0 wcel cK cc0 cN
    elfz1 0z cN nn0z sylancr cK cz wcel cc0 cK cle wbr cK cN cle wbr w3a cK cz
    wcel cc0 cK cle wbr wa cK cN cle wbr wa cK cn0 wcel cK cN cle wbr wa cK cz
    wcel cc0 cK cle wbr cK cN cle wbr df-3an cK cn0 wcel cK cz wcel cc0 cK cle
    wbr wa cK cN cle wbr cK elnn0z anbi1i bitr4i syl6bb $.
    $( [23-Aug-2005] $) $( [1-Aug-2005] $)

  ${
    $d k N $.
    $( Quantification over a one-member finite set of sequential integers in
       terms of substitution. $)
    fz1sbc $p |- ( N e. ZZ -> ( A. k e. ( N ... N ) ph <-> [ N / k ] ph ) ) $=
      cN cz wcel wph vk cN wsbc vk cv cN wceq wph wi vk wal wph vk cN cN cfz co
      wral wph vk cN cz sbc6g cN cz wcel vk cv cN cN cfz co wcel wph wi vk wal
      vk cv cN wceq wph wi vk wal wph vk cN cN cfz co wral cN cz wcel vk cv cN
      cN cfz co wcel wph wi vk cv cN wceq wph wi vk cN cz wcel vk cv cN cN cfz
      co wcel vk cv cN wceq wph cN cz wcel vk cv cN cN cfz co wcel vk cv cN
      wceq vk cv cN elfz1eq vk cv cN wceq vk cv cN cN cfz co wcel cN cN cN cfz
      co wcel cN cz wcel vk cv cN cN cN cfz co eleq1 cN elfz3 syl5cbir impbid2
      imbi1d albidv wph vk cN cN cfz co df-ral syl5rbb bitr2d $.
      $( [12-Dec-2005] $) $( [28-Nov-2005] $)
  $}

  $( No finite set of sequential integers equals a set of upper integers. $)
  fzneuz $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ )
               -> -. ( M ... N ) = ( ZZ>= ` K ) ) $=
    cN cM cuz cfv wcel cK cz wcel wa cN cK cuz cfv wcel cM cN cfz co cK cuz cfv
    wceq wn cN cM cuz cfv wcel cK cz wcel wa cN cK cuz cfv wcel wa cK cuz cfv
    cM cN cfz co wceq wn cM cN cfz co cK cuz cfv wceq wn cN c1 caddc co cK cuz
    cfv wcel cN c1 caddc co cM cN cfz co wcel wn cK cuz cfv cM cN cfz co wceq
    wn cN cM cuz cfv wcel cK cz wcel wa cN cK cuz cfv wcel wa cN c1 caddc co cK
    cuz cfv cM cN cfz co nelneq2 cN cK cuz cfv wcel cN c1 caddc co cK cuz cfv
    wcel cN cM cuz cfv wcel cK cz wcel wa cK cN peano2uz adantl cN cM cuz cfv
    wcel cN c1 caddc co cM cN cfz co wcel wn cK cz wcel cN cK cuz cfv wcel cN
    cM cuz cfv wcel cN c1 caddc co cN cle wbr cN c1 caddc co cM cN cfz co wcel
    cN cM cuz cfv wcel cN cz wcel cN cr wcel cN c1 caddc co cN cle wbr wn cM cN
    eluzelz cN zre cN cr wcel cN cN c1 caddc co clt wbr cN c1 caddc co cN cle
    wbr wn cN ltp1 cN cr wcel cN c1 caddc co cr wcel cN cN c1 caddc co clt wbr
    cN c1 caddc co cN cle wbr wn wb cN peano2re cN cN c1 caddc co ltnle mpdan
    mpbid 3syl cN c1 caddc co cM cN elfzle2 nsyl ad2antrr sylanc cK cuz cfv cM
    cN cfz co wceq cM cN cfz co cK cuz cfv wceq cK cuz cfv cM cN cfz co eqcom
    notbii sylib cN cM cuz cfv wcel cK cz wcel wa cN cK cuz cfv wcel wn cN cM
    cN cfz co wcel cM cN cfz co cK cuz cfv wceq wn cN cM cuz cfv wcel cN cM cN
    cfz co wcel cK cz wcel cN cK cuz cfv wcel wn cM cN eluzfz2 ad2antrr cN cM
    cN cfz co cK cuz cfv nelneq2 sylancom pm2.61dan $.
    $( [20-Dec-2005] $) $( [11-Dec-2005] $)

  ${
    $d j k x K $.  $d j k x M $.  $d j k x N $.  $d k x ph $.
    $( Reversal of scanning order inside of a quantification over a finite set
       of sequential integers. $)
    fzrevral $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) -> ( A. j e. ( M ... N
       ) ph <-> A. k e. ( ( K - N ) ... ( K - M ) ) [ ( K - k ) / j ] ph ) ) $=
      cM cz wcel cN cz wcel cK cz wcel w3a wph vj cM cN cfz co wral wph vj cK
      vk cv cmin co wsbc vk cK cN cmin co cK cM cmin co cfz co wral cM cz wcel
      cN cz wcel cK cz wcel w3a wph vj cM cN cfz co wral wph vj cK vk cv cmin
      co wsbc vk cK cN cmin co cK cM cmin co cfz co cM cz wcel cN cz wcel cK cz
      wcel w3a vk cv cK cN cmin co cK cM cmin co cfz co wcel wph vj cM cN cfz
      co wral wph vj cK vk cv cmin co wsbc cM cz wcel cN cz wcel cK cz wcel vk
      cv cK cN cmin co cK cM cmin co cfz co wcel wph vj cM cN cfz co wral wph
      vj cK vk cv cmin co wsbc wi wi cM cz wcel cN cz wcel wa cK cz wcel wa vk
      cv cK cN cmin co cK cM cmin co cfz co wcel wph vj cM cN cfz co wral wph
      vj cK vk cv cmin co wsbc wi cM cz wcel cN cz wcel wa cK cz wcel wa vk cv
      cK cN cmin co cK cM cmin co cfz co wcel wa cK vk cv cmin co cM cN cfz co
      wcel wph vj cM cN cfz co wral wph vj cK vk cv cmin co wsbc wi cM cz wcel
      cN cz wcel wa cK cz wcel wa vk cv cK cN cmin co cK cM cmin co cfz co wcel
      wa vk cv cK cN cmin co cK cM cmin co cfz co wcel cK vk cv cmin co cM cN
      cfz co wcel cM cz wcel cN cz wcel wa cK cz wcel wa vk cv cK cN cmin co cK
      cM cmin co cfz co wcel pm3.27 cM cz wcel cN cz wcel wa cK cz wcel wa vk
      cv cz wcel vk cv cK cN cmin co cK cM cmin co cfz co wcel cK vk cv cmin co
      cM cN cfz co wcel wb vk cv cK cN cmin co cK cM cmin co cfz co wcel cM cz
      wcel cN cz wcel wa cK cz wcel vk cv cz wcel vk cv cK cN cmin co cK cM
      cmin co cfz co wcel cK vk cv cmin co cM cN cfz co wcel wb cK vk cv cM cN
      fzrev anassrs vk cv cK cN cmin co cK cM cmin co elfzelz sylan2 mpbid wph
      vj cK vk cv cmin co cM cN cfz co ra4sbc syl ex 3impa com23 r19.21adv cN
      cz wcel cK cz wcel wph vj cK vk cv cmin co wsbc vk cK cN cmin co cK cM
      cmin co cfz co wral wph vj cM cN cfz co wral wi cM cz wcel cN cz wcel cK
      cz wcel wa wph vj cK vk cv cmin co wsbc vk cK cN cmin co cK cM cmin co
      cfz co wral wph vj cM cN cfz co cN cz wcel cK cz wcel wa vj ax-17 wph vj
      cK vk cv cmin co wsbc vj vk cK cN cmin co cK cM cmin co cfz co vk cv cK
      cN cmin co cK cM cmin co cfz co wcel vj ax-17 wph vj cK vk cv cmin co cK
      vk cv cmin oprex hbsbc1v hbral cN cz wcel cK cz wcel wa vj cv cM cN cfz
      co wcel wph vj cK vk cv cmin co wsbc vk cK cN cmin co cK cM cmin co cfz
      co wral wph cN cz wcel cK cz wcel wa vj cv cM cN cfz co wcel wph vj cK vk
      cv cmin co wsbc vk cK cN cmin co cK cM cmin co cfz co wral wph wi cN cz
      wcel cK cz wcel wa vj cv cM cN cfz co wcel wa wph vj cK vk cv cmin co
      wsbc vk cK cN cmin co cK cM cmin co cfz co wral wph vj cK cK vj cv cmin
      co cmin co wsbc wph cN cz wcel cK cz wcel wa vj cv cM cN cfz co wcel wa
      cK vj cv cmin co cK cN cmin co cK cM cmin co cfz co wcel wph vj cK vk cv
      cmin co wsbc vk cK cN cmin co cK cM cmin co cfz co wral wph vj cK cK vj
      cv cmin co cmin co wsbc wi cN cz wcel cK cz wcel vj cv cM cN cfz co wcel
      cK vj cv cmin co cK cN cmin co cK cM cmin co cfz co wcel cz cK vj cv cM
      cN fzrev2i 3expa wph vj cK vk cv cmin co wsbc wph vj cK cK vj cv cmin co
      cmin co wsbc vk cK vj cv cmin co cK cN cmin co cK cM cmin co cfz co vk cv
      cK vj cv cmin co wceq cK vk cv cmin co cK cK vj cv cmin co cmin co wceq
      wph vj cK vk cv cmin co wsbc wph vj cK cK vj cv cmin co cmin co wsbc wb
      vk cv cK vj cv cmin co cK cmin opreq2 wph vj cK vk cv cmin co cK cK vj cv
      cmin co cmin co dfsbcq syl rcla4v syl cK cz wcel vj cv cM cN cfz co wcel
      wph wph vj cK cK vj cv cmin co cmin co wsbc wb cN cz wcel cK cz wcel vj
      cv cM cN cfz co wcel wa vj cv cK cK vj cv cmin co cmin co wceq wph wph vj
      cK cK vj cv cmin co cmin co wsbc wb cK cz wcel vj cv cM cN cfz co wcel wa
      cK cK vj cv cmin co cmin co vj cv cK cc wcel vj cv cc wcel cK cK vj cv
      cmin co cmin co vj cv wceq cK cz wcel vj cv cM cN cfz co wcel cK vj cv
      nncan cK zcn vj cv cM cN cfz co wcel vj cv cz wcel vj cv cc wcel vj cv cM
      cN elfzelz vj cv zcn syl syl2an eqcomd wph vj cK cK vj cv cmin co cmin co
      sbceq1a syl adantll sylibrd ex com23 r19.21ad 3adant1 impbid $.
      $( [8-Dec-2005] $) $( [25-Nov-2005] $)

    $( Reversal of scanning order inside of a quantification over a finite set
       of sequential integers. $)
    fzrevral2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) -> ( A. j e. ( ( K - N
       ) ... ( K - M ) ) ph <-> A. k e. ( M ... N ) [ ( K - k ) / j ] ph ) ) $=
      cK cz wcel cM cz wcel cN cz wcel wph vj cK cN cmin co cK cM cmin co cfz
      co wral wph vj cK vk cv cmin co wsbc vk cM cN cfz co wral wb cK cz wcel
      cM cz wcel cN cz wcel w3a wph vj cK cN cmin co cK cM cmin co cfz co wral
      wph vj cK vk cv cmin co wsbc vk cK cK cM cmin co cmin co cK cK cN cmin co
      cmin co cfz co wral wph vj cK vk cv cmin co wsbc vk cM cN cfz co wral cK
      cN cmin co cz wcel cK cM cmin co cz wcel cK cz wcel wph vj cK cN cmin co
      cK cM cmin co cfz co wral wph vj cK vk cv cmin co wsbc vk cK cK cM cmin
      co cmin co cK cK cN cmin co cmin co cfz co wral wb cK cz wcel cM cz wcel
      cN cz wcel w3a wph vj vk cK cK cN cmin co cK cM cmin co fzrevral cK cz
      wcel cN cz wcel cK cN cmin co cz wcel cM cz wcel cK cN zsubcl 3adant2 cK
      cz wcel cM cz wcel cK cM cmin co cz wcel cN cz wcel cK cM zsubcl 3adant3
      cK cz wcel cM cz wcel cN cz wcel 3simp1 syl3anc cK cz wcel cM cz wcel cN
      cz wcel w3a wph vj cK vk cv cmin co wsbc vk cK cK cM cmin co cmin co cK
      cK cN cmin co cmin co cfz co cM cN cfz co cK cc wcel cM cc wcel cN cc
      wcel cK cK cM cmin co cmin co cK cK cN cmin co cmin co cfz co cM cN cfz
      co wceq cK cz wcel cM cz wcel cN cz wcel cK cc wcel cM cc wcel cN cc wcel
      w3a cK cK cM cmin co cmin co cM cK cK cN cmin co cmin co cN cfz cK cc
      wcel cM cc wcel cK cK cM cmin co cmin co cM wceq cN cc wcel cK cM nncan
      3adant3 cK cc wcel cN cc wcel cK cK cN cmin co cmin co cN wceq cM cc wcel
      cK cN nncan 3adant2 opreq12d cK zcn cM zcn cN zcn syl3an raleq1d bitrd
      3coml $.
      $( [10-May-2006] $) $( [25-Nov-2005] $)

    $( Reversal of scanning order inside of a quantification over a finite set
       of sequential integers. $)
    fzrevral3 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( A. j e. ( M ... N ) ph
                   <-> A. k e. ( M ... N ) [ ( ( M + N ) - k ) / j ] ph ) ) $=
      cM cz wcel cN cz wcel wa wph vj cM cN cfz co wral wph vj cM cN caddc co
      vk cv cmin co wsbc vk cM cN caddc co cN cmin co cM cN caddc co cM cmin co
      cfz co wral wph vj cM cN caddc co vk cv cmin co wsbc vk cM cN cfz co wral
      cM cz wcel cN cz wcel cM cN caddc co cz wcel wph vj cM cN cfz co wral wph
      vj cM cN caddc co vk cv cmin co wsbc vk cM cN caddc co cN cmin co cM cN
      caddc co cM cmin co cfz co wral wb cM cN zaddcl wph vj vk cM cN caddc co
      cM cN fzrevral mpd3an3 cM cz wcel cN cz wcel wa wph vj cM cN caddc co vk
      cv cmin co wsbc vk cM cN caddc co cN cmin co cM cN caddc co cM cmin co
      cfz co cM cN cfz co cM cc wcel cN cc wcel cM cN caddc co cN cmin co cM cN
      caddc co cM cmin co cfz co cM cN cfz co wceq cM cz wcel cN cz wcel cM cc
      wcel cN cc wcel wa cM cN caddc co cN cmin co cM cM cN caddc co cM cmin co
      cN cfz cM cN pncan cM cN pncan2 opreq12d cM zcn cN zcn syl2an raleq1d
      bitrd $.
      $( [11-Jul-2006] $) $( [20-Nov-2005] $)

    $( Shift the scanning order inside of a quantification over a finite set
       of sequential integers. $)
    fzshftral $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) -> ( A. j e. ( M ... N
       ) ph <-> A. k e. ( ( M + K ) ... ( N + K ) ) [ ( k - K ) / j ] ph ) ) $=
      cM cz wcel cN cz wcel cK cz wcel w3a wph vj cM cN cfz co wral wph vj cc0
      vx cv cmin co wsbc vx cc0 cN cmin co cc0 cM cmin co cfz co wral wph vj
      cc0 vx cv cmin co wsbc vx cK vk cv cmin co wsbc vk cK cc0 cM cmin co cmin
      co cK cc0 cN cmin co cmin co cfz co wral wph vj vk cv cK cmin co wsbc vk
      cM cK caddc co cN cK caddc co cfz co wral cM cz wcel cN cz wcel wph vj cM
      cN cfz co wral wph vj cc0 vx cv cmin co wsbc vx cc0 cN cmin co cc0 cM
      cmin co cfz co wral wb cK cz wcel cM cz wcel cN cz wcel cc0 cz wcel wph
      vj cM cN cfz co wral wph vj cc0 vx cv cmin co wsbc vx cc0 cN cmin co cc0
      cM cmin co cfz co wral wb 0z wph vj vx cc0 cM cN fzrevral mp3an3 3adant3
      cN cz wcel cM cz wcel cK cz wcel wph vj cc0 vx cv cmin co wsbc vx cc0 cN
      cmin co cc0 cM cmin co cfz co wral wph vj cc0 vx cv cmin co wsbc vx cK vk
      cv cmin co wsbc vk cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co
      cfz co wral wb cc0 cN cmin co cz wcel cc0 cM cmin co cz wcel cK cz wcel
      wph vj cc0 vx cv cmin co wsbc vx cc0 cN cmin co cc0 cM cmin co cfz co
      wral wph vj cc0 vx cv cmin co wsbc vx cK vk cv cmin co wsbc vk cK cc0 cM
      cmin co cmin co cK cc0 cN cmin co cmin co cfz co wral wb cN cz wcel cM cz
      wcel cK cz wcel wph vj cc0 vx cv cmin co wsbc vx vk cK cc0 cN cmin co cc0
      cM cmin co fzrevral cc0 cz wcel cN cz wcel cc0 cN cmin co cz wcel 0z cc0
      cN zsubcl mpan cc0 cz wcel cM cz wcel cc0 cM cmin co cz wcel 0z cc0 cM
      zsubcl mpan cK cz wcel id syl3an 3com12 cM cz wcel cN cz wcel cK cz wcel
      w3a wph vj cc0 cK vk cv cmin co cmin co wsbc vk cK cc0 cM cmin co cmin co
      cK cc0 cN cmin co cmin co cfz co wral wph vj vk cv cK cmin co wsbc vk cM
      cK caddc co cN cK caddc co cfz co wral wph vj cc0 vx cv cmin co wsbc vx
      cK vk cv cmin co wsbc vk cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin
      co cfz co wral cM cz wcel cN cz wcel cK cz wcel w3a wph vj cc0 cK vk cv
      cmin co cmin co wsbc vk cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin
      co cfz co wral wph vj cc0 cK vk cv cmin co cmin co wsbc vk cM cK caddc co
      cN cK caddc co cfz co wral wph vj vk cv cK cmin co wsbc vk cM cK caddc co
      cN cK caddc co cfz co wral cM cz wcel cN cz wcel cK cz wcel w3a wph vj
      cc0 cK vk cv cmin co cmin co wsbc vk cK cc0 cM cmin co cmin co cK cc0 cN
      cmin co cmin co cfz co cM cK caddc co cN cK caddc co cfz co cM cc wcel cN
      cc wcel cK cc wcel cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co
      cfz co cM cK caddc co cN cK caddc co cfz co wceq cM cz wcel cN cz wcel cK
      cz wcel cK cc wcel cM cc wcel cN cc wcel cK cc0 cM cmin co cmin co cK cc0
      cN cmin co cmin co cfz co cM cK caddc co cN cK caddc co cfz co wceq cK cc
      wcel cM cc wcel cN cc wcel w3a cK cc0 cM cmin co cmin co cM cK caddc co
      cK cc0 cN cmin co cmin co cN cK caddc co cfz cK cc wcel cM cc wcel cK cc0
      cM cmin co cmin co cM cK caddc co wceq cN cc wcel cK cc wcel cM cc wcel
      wa cK cM cneg cmin co cM cK caddc co cK cc0 cM cmin co cmin co cK cc wcel
      cM cc wcel wa cK cM cneg cmin co cK cM caddc co cM cK caddc co cK cM
      subneg cK cM addcom eqtrd cM cneg cc0 cM cmin co cK cmin cM df-neg
      opreq2i syl5eqr 3adant3 cK cc wcel cN cc wcel cK cc0 cN cmin co cmin co
      cN cK caddc co wceq cM cc wcel cK cc wcel cN cc wcel wa cK cN cneg cmin
      co cN cK caddc co cK cc0 cN cmin co cmin co cK cc wcel cN cc wcel wa cK
      cN cneg cmin co cK cN caddc co cN cK caddc co cK cN subneg cK cN addcom
      eqtrd cN cneg cc0 cN cmin co cK cmin cN df-neg opreq2i syl5eqr 3adant2
      opreq12d 3coml cM zcn cN zcn cK zcn syl3an raleq1d cK cz wcel cM cz wcel
      wph vj cc0 cK vk cv cmin co cmin co wsbc vk cM cK caddc co cN cK caddc co
      cfz co wral wph vj vk cv cK cmin co wsbc vk cM cK caddc co cN cK caddc co
      cfz co wral wb cN cz wcel cK cz wcel wph vj cc0 cK vk cv cmin co cmin co
      wsbc wph vj vk cv cK cmin co wsbc vk cM cK caddc co cN cK caddc co cfz co
      cK cz wcel vk cv cM cK caddc co cN cK caddc co cfz co wcel wa cc0 cK vk
      cv cmin co cmin co vk cv cK cmin co wceq wph vj cc0 cK vk cv cmin co cmin
      co wsbc wph vj vk cv cK cmin co wsbc wb cK cc wcel vk cv cc wcel cc0 cK
      vk cv cmin co cmin co vk cv cK cmin co wceq cK cz wcel vk cv cM cK caddc
      co cN cK caddc co cfz co wcel cK cc wcel vk cv cc wcel wa cK vk cv cmin
      co cneg vk cv cK cmin co cc0 cK vk cv cmin co cmin co cK vk cv negsubdi2
      cK vk cv cmin co df-neg syl5eqr cK zcn vk cv cM cK caddc co cN cK caddc
      co cfz co wcel vk cv cz wcel vk cv cc wcel vk cv cM cK caddc co cN cK
      caddc co elfzelz vk cv zcn syl syl2an wph vj cc0 cK vk cv cmin co cmin co
      vk cv cK cmin co dfsbcq syl ralbidva 3ad2ant3 bitrd wph vj cc0 vx cv cmin
      co wsbc vx cK vk cv cmin co wsbc wph vj cc0 cK vk cv cmin co cmin co wsbc
      vk cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co cfz co cK vk cv
      cmin co cvv wcel cc0 vx cv cmin co cvv wcel vx wal wph vj cc0 vx cv cmin
      co wsbc vx cK vk cv cmin co wsbc wph vj cc0 cK vk cv cmin co cmin co wsbc
      wb cK vk cv cmin oprex cc0 vx cv cmin co cvv wcel vx cc0 vx cv cmin oprex
      ax-gen wph vx vj cK vk cv cmin co cc0 vx cv cmin co cc0 cK vk cv cmin co
      cmin co cvv cvv vx cv cK vk cv cmin co cc0 cmin opreq2 sbcco3g mp2an
      ralbii syl5bb 3bitrd $.
      $( [19-Jun-2007] $) $( [27-Nov-2005] $)
  $}

  ${
    $d j k m n x y F $.  $d j k m n x y M $.  $d j k n x y N $.
    $( The values of a finite real sequence have an upper bound.  _Warning:
       The HTML proof page is 1/2 megabyte in size_. $)
    fsequb $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N ) ( F ` k ) e. RR )
                 -> E. x e. RR A. k e. ( M ... N ) ( F ` k ) < x ) $=
      cN cM cuz cfv wcel vn cv cF cfv cr wcel vn cM cN cfz co wral vk cv cF cfv
      vx cv clt wbr vk cM cN cfz co wral vx cr wrex vk cv cF cfv cr wcel vk cM
      cN cfz co wral cN cM cuz cfv wcel vn cv cF cfv cr wcel vn cM cN cfz co
      wral vk cv cF cfv vx cv clt wbr vk cM cN cfz co wral vx cr wrex vn cv cF
      cfv cr wcel vn cM vj cv cfz co wral vk cv cF cfv vx cv clt wbr vk cM vj
      cv cfz co wral vx cr wrex wi vn cv cF cfv cr wcel vn cM cM cfz co wral vk
      cv cF cfv vx cv clt wbr vk cM cM cfz co wral vx cr wrex wi vn cv cF cfv
      cr wcel vn cM vm cv cfz co wral vk cv cF cfv vx cv clt wbr vk cM vm cv
      cfz co wral vx cr wrex wi vn cv cF cfv cr wcel vn cM vm cv c1 caddc co
      cfz co wral vk cv cF cfv vx cv clt wbr vk cM vm cv c1 caddc co cfz co
      wral vx cr wrex wi vn cv cF cfv cr wcel vn cM cN cfz co wral vk cv cF cfv
      vx cv clt wbr vk cM cN cfz co wral vx cr wrex wi vj vm cM cN vj cv cM
      wceq vn cv cF cfv cr wcel vn cM vj cv cfz co wral vn cv cF cfv cr wcel vn
      cM cM cfz co wral vk cv cF cfv vx cv clt wbr vk cM vj cv cfz co wral vx
      cr wrex vk cv cF cfv vx cv clt wbr vk cM cM cfz co wral vx cr wrex vj cv
      cM wceq vn cv cF cfv cr wcel vn cM vj cv cfz co cM cM cfz co vj cv cM cM
      cfz opreq2 raleq1d vj cv cM wceq vk cv cF cfv vx cv clt wbr vk cM vj cv
      cfz co wral vk cv cF cfv vx cv clt wbr vk cM cM cfz co wral vx cr vj cv
      cM wceq vk cv cF cfv vx cv clt wbr vk cM vj cv cfz co cM cM cfz co vj cv
      cM cM cfz opreq2 raleq1d rexbidv imbi12d vj cv vm cv wceq vn cv cF cfv cr
      wcel vn cM vj cv cfz co wral vn cv cF cfv cr wcel vn cM vm cv cfz co wral
      vk cv cF cfv vx cv clt wbr vk cM vj cv cfz co wral vx cr wrex vk cv cF
      cfv vx cv clt wbr vk cM vm cv cfz co wral vx cr wrex vj cv vm cv wceq vn
      cv cF cfv cr wcel vn cM vj cv cfz co cM vm cv cfz co vj cv vm cv cM cfz
      opreq2 raleq1d vj cv vm cv wceq vk cv cF cfv vx cv clt wbr vk cM vj cv
      cfz co wral vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vx cr vj
      cv vm cv wceq vk cv cF cfv vx cv clt wbr vk cM vj cv cfz co cM vm cv cfz
      co vj cv vm cv cM cfz opreq2 raleq1d rexbidv imbi12d vj cv vm cv c1 caddc
      co wceq vn cv cF cfv cr wcel vn cM vj cv cfz co wral vn cv cF cfv cr wcel
      vn cM vm cv c1 caddc co cfz co wral vk cv cF cfv vx cv clt wbr vk cM vj
      cv cfz co wral vx cr wrex vk cv cF cfv vx cv clt wbr vk cM vm cv c1 caddc
      co cfz co wral vx cr wrex vj cv vm cv c1 caddc co wceq vn cv cF cfv cr
      wcel vn cM vj cv cfz co cM vm cv c1 caddc co cfz co vj cv vm cv c1 caddc
      co cM cfz opreq2 raleq1d vj cv vm cv c1 caddc co wceq vk cv cF cfv vx cv
      clt wbr vk cM vj cv cfz co wral vk cv cF cfv vx cv clt wbr vk cM vm cv c1
      caddc co cfz co wral vx cr vj cv vm cv c1 caddc co wceq vk cv cF cfv vx
      cv clt wbr vk cM vj cv cfz co cM vm cv c1 caddc co cfz co vj cv vm cv c1
      caddc co cM cfz opreq2 raleq1d rexbidv imbi12d vj cv cN wceq vn cv cF cfv
      cr wcel vn cM vj cv cfz co wral vn cv cF cfv cr wcel vn cM cN cfz co wral
      vk cv cF cfv vx cv clt wbr vk cM vj cv cfz co wral vx cr wrex vk cv cF
      cfv vx cv clt wbr vk cM cN cfz co wral vx cr wrex vj cv cN wceq vn cv cF
      cfv cr wcel vn cM vj cv cfz co cM cN cfz co vj cv cN cM cfz opreq2
      raleq1d vj cv cN wceq vk cv cF cfv vx cv clt wbr vk cM vj cv cfz co wral
      vk cv cF cfv vx cv clt wbr vk cM cN cfz co wral vx cr vj cv cN wceq vk cv
      cF cfv vx cv clt wbr vk cM vj cv cfz co cM cN cfz co vj cv cN cM cfz
      opreq2 raleq1d rexbidv imbi12d cM cz wcel vn cv cF cfv cr wcel vn cM cM
      cfz co wral cM cF cfv cr wcel vk cv cF cfv vx cv clt wbr vk cM cM cfz co
      wral vx cr wrex cM cz wcel cM cM cM cfz co wcel vn cv cF cfv cr wcel vn
      cM cM cfz co wral cM cF cfv cr wcel wi cM elfz3 vn cv cF cfv cr wcel cM
      cF cfv cr wcel vn cM cM cM cfz co vn cv cM wceq vn cv cF cfv cM cF cfv cr
      vn cv cM cF fveq2 eleq1d rcla4v syl cM cz wcel cM cF cfv cr wcel cM cF
      cfv c1 caddc co cr wcel vk cv cF cfv cM cF cfv c1 caddc co clt wbr vk cM
      cM cfz co wral wa vk cv cF cfv vx cv clt wbr vk cM cM cfz co wral vx cr
      wrex cM cF cfv cr wcel cM cF cfv c1 caddc co cr wcel vk cv cF cfv cM cF
      cfv c1 caddc co clt wbr vk cM cM cfz co wral wa wi cM cz wcel cM cF cfv
      cr wcel cM cF cfv c1 caddc co cr wcel vk cv cF cfv cM cF cfv c1 caddc co
      clt wbr vk cM cM cfz co wral cM cF cfv peano2re cM cF cfv cr wcel vk cv
      cF cfv cM cF cfv c1 caddc co clt wbr vk cM cM cfz co cM cF cfv cr wcel vk
      cv cM wceq vk cv cF cfv cM cF cfv c1 caddc co clt wbr vk cv cM cM cfz co
      wcel vk cv cM wceq vk cv cF cfv cM cF cfv c1 caddc co clt wbr cM cF cfv
      cM cF cfv c1 caddc co clt wbr cM cF cfv cr wcel vk cv cM wceq vk cv cF
      cfv cM cF cfv cM cF cfv c1 caddc co clt vk cv cM cF fveq2 breq1d cM cF
      cfv ltp1 syl5cbir vk cv cM elfz1eq syl5 r19.21aiv jca a1i vk cv cF cfv vx
      cv clt wbr vk cM cM cfz co wral vk cv cF cfv cM cF cfv c1 caddc co clt
      wbr vk cM cM cfz co wral vx cM cF cfv c1 caddc co cr vx cv cM cF cfv c1
      caddc co wceq vk cv cF cfv vx cv clt wbr vk cv cF cfv cM cF cfv c1 caddc
      co clt wbr vk cM cM cfz co vx cv cM cF cfv c1 caddc co vk cv cF cfv clt
      breq2 ralbidv rcla4ev syl6 syld vm cv cM cuz cfv wcel vn cv cF cfv cr
      wcel vn cM vm cv cfz co wral vk cv cF cfv vx cv clt wbr vk cM vm cv cfz
      co wral vx cr wrex wi vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co
      wral vk cv cF cfv vx cv clt wbr vk cM vm cv c1 caddc co cfz co wral vx cr
      wrex vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv cfz co wral
      vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vx cr wrex wi vn cv cF
      cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa wa vk cv cF cfv vx cv
      clt wbr vk cM vm cv cfz co wral vx cr wrex vm cv c1 caddc co cF cfv cr
      wcel vk cv cF cfv vx cv clt wbr vk cM vm cv c1 caddc co cfz co wral vx cr
      wrex vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv cfz co wral
      vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vx cr wrex wi vn cv cF
      cfv cr wcel vn cM vm cv c1 caddc co cfz co wral vk cv cF cfv vx cv clt
      wbr vk cM vm cv cfz co wral vx cr wrex vm cv cM cuz cfv wcel vn cv cF cfv
      cr wcel vn cM vm cv c1 caddc co cfz co wral vn cv cF cfv cr wcel vn cM vm
      cv cfz co wral vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vx cr
      wrex vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cv cF cfv cr wcel vn
      cM vm cv c1 caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vn cv
      cM vm cv cfz co wcel vn cv cM vm cv c1 caddc co cfz co wcel vn cv cF cfv
      cr wcel vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co
      vn cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz
      co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv
      eluzelz sylanc sseld imim1d r19.20dv2 imim1d imp32 vm cv cM cuz cfv wcel
      vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral vm cv c1 caddc
      co cF cfv cr wcel vn cv cF cfv cr wcel vn cM vm cv cfz co wral vk cv cF
      cfv vx cv clt wbr vk cM vm cv cfz co wral vx cr wrex wi vm cv c1 caddc co
      cM vm cv c1 caddc co cfz co wcel vn cv cF cfv cr wcel vn cM vm cv c1
      caddc co cfz co wral vm cv c1 caddc co cF cfv cr wcel vm cv cM cuz cfv
      wcel vn cv cF cfv cr wcel vm cv c1 caddc co cF cfv cr wcel vn vm cv c1
      caddc co cM vm cv c1 caddc co cfz co vn cv vm cv c1 caddc co wceq vn cv
      cF cfv vm cv c1 caddc co cF cfv cr vn cv vm cv c1 caddc co cF fveq2
      eleq1d rcla4va vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel vm
      cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cM vm cv peano2uz cM vm
      cv c1 caddc co eluzfz2 syl sylan adantrl vm cv cM cuz cfv wcel vn cv cF
      cfv cr wcel vn cM vm cv c1 caddc co cfz co wral vk cv cF cfv vx cv clt
      wbr vk cM vm cv cfz co wral vx cr wrex vm cv c1 caddc co cF cfv cr wcel
      wa vk cv cF cfv vx cv clt wbr vk cM vm cv c1 caddc co cfz co wral vx cr
      wrex wi vn cv cF cfv cr wcel vn cM vm cv cfz co wral vk cv cF cfv vx cv
      clt wbr vk cM vm cv cfz co wral vx cr wrex wi vm cv cM cuz cfv wcel vn cv
      cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa vk cv cF cfv vx cv
      clt wbr vk cM vm cv cfz co wral vx cr wrex vm cv c1 caddc co cF cfv cr
      wcel wa vk cv cF cfv vy cv clt wbr vk cM vm cv c1 caddc co cfz co wral vy
      cr wrex vk cv cF cfv vx cv clt wbr vk cM vm cv c1 caddc co cfz co wral vx
      cr wrex vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc
      co cfz co wral wa vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vx
      cr wrex vm cv c1 caddc co cF cfv cr wcel vk cv cF cfv vy cv clt wbr vk cM
      vm cv c1 caddc co cfz co wral vy cr wrex vm cv cM cuz cfv wcel vn cv cF
      cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa vk cv cF cfv vx cv clt
      wbr vk cM vm cv cfz co wral vm cv c1 caddc co cF cfv cr wcel vk cv cF cfv
      vy cv clt wbr vk cM vm cv c1 caddc co cfz co wral vy cr wrex wi vx cr vm
      cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co
      wral wa vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel vk cv cF cfv vx cv
      clt wbr vk cM vm cv cfz co wral vk cv cF cfv vy cv clt wbr vk cM vm cv c1
      caddc co cfz co wral vy cr wrex vm cv cM cuz cfv wcel vn cv cF cfv cr
      wcel vn cM vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc
      co cF cfv cr wcel vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vk
      cv cF cfv vy cv clt wbr vk cM vm cv c1 caddc co cfz co wral vy cr wrex wi
      vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co
      wral wa vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa wa vk cv cF cfv
      vx cv clt wbr vk cM vm cv cfz co wral vm cv c1 caddc co cF cfv c1 caddc
      co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif cr wcel
      vk cv cF cfv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm
      cv c1 caddc co cF cfv c1 caddc co cif clt wbr vk cM vm cv c1 caddc co cfz
      co wral wa vk cv cF cfv vy cv clt wbr vk cM vm cv c1 caddc co cfz co wral
      vy cr wrex vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1
      caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa
      wa vk cv cF cfv vx cv clt wbr vk cM vm cv cfz co wral vk cv cF cfv vm cv
      c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF
      cfv c1 caddc co cif clt wbr vk cM vm cv c1 caddc co cfz co wral vm cv c1
      caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv
      c1 caddc co cif cr wcel vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM
      vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF cfv
      cr wcel wa wa vk cv cF cfv vx cv clt wbr vk cv cF cfv vm cv c1 caddc co
      cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc
      co cif clt wbr vk cM vm cv cfz co cM vm cv c1 caddc co cfz co vm cv cM
      cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa
      vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa wa vk cv cM vm cv cfz
      co wcel vk cv cF cfv vx cv clt wbr wi vk cv cM vm cv c1 caddc co cfz co
      wcel vk cv cF cfv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx
      cv vm cv c1 caddc co cF cfv c1 caddc co cif clt wbr wi vm cv cM cuz cfv
      wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa vx cv cr
      wcel vm cv c1 caddc co cF cfv cr wcel wa wa vk cv cM vm cv cfz co wcel vk
      cv cF cfv vx cv clt wbr wi wa vk cv cM vm cv c1 caddc co cfz co wcel vk
      cv cM vm cv cfz co wcel vk cv vm cv c1 caddc co wceq wo vk cv cF cfv vm
      cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co
      cF cfv c1 caddc co cif clt wbr vm cv cM cuz cfv wcel vn cv cF cfv cr wcel
      vn cM vm cv c1 caddc co cfz co wral wa vk cv cM vm cv c1 caddc co cfz co
      wcel vk cv cM vm cv cfz co wcel vk cv vm cv c1 caddc co wceq wo wb vx cv
      cr wcel vm cv c1 caddc co cF cfv cr wcel wa vk cv cM vm cv cfz co wcel vk
      cv cF cfv vx cv clt wbr wi vm cv cM cuz cfv wcel vk cv cM vm cv c1 caddc
      co cfz co wcel vk cv cM vm cv cfz co wcel vk cv vm cv c1 caddc co wceq wo
      wb vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral vk cv cM vm
      cv elfzp1 adantr ad2antrr vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn
      cM vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF
      cfv cr wcel wa wa vk cv cM vm cv cfz co wcel vk cv cF cfv vx cv clt wbr
      wi wa vk cv cM vm cv cfz co wcel vk cv cF cfv vm cv c1 caddc co cF cfv c1
      caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif clt
      wbr vk cv vm cv c1 caddc co wceq vm cv cM cuz cfv wcel vn cv cF cfv cr
      wcel vn cM vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc
      co cF cfv cr wcel wa wa vk cv cM vm cv cfz co wcel vk cv cF cfv vx cv clt
      wbr wi vk cv cM vm cv cfz co wcel vk cv cF cfv vm cv c1 caddc co cF cfv
      c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif
      clt wbr wi vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1
      caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa
      wa vk cv cM vm cv cfz co wcel vk cv cF cfv vx cv clt wbr vk cv cF cfv vm
      cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co
      cF cfv c1 caddc co cif clt wbr vm cv cM cuz cfv wcel vn cv cF cfv cr wcel
      vn cM vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF
      cfv cr wcel wa wa vk cv cM vm cv cfz co wcel vk cv cF cfv vx cv clt wbr
      vk cv cF cfv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm
      cv c1 caddc co cF cfv c1 caddc co cif clt wbr wi vm cv cM cuz cfv wcel vn
      cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm
      cv c1 caddc co cF cfv cr wcel wa wa vk cv cM vm cv cfz co wcel wa vk cv
      cF cfv vx cv clt wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle
      wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif cle wbr vk cv cF cfv
      vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc
      co cF cfv c1 caddc co cif clt wbr vx cv cr wcel vm cv c1 caddc co cF cfv
      cr wcel wa vx cv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv
      vm cv c1 caddc co cF cfv c1 caddc co cif cle wbr vm cv cM cuz cfv wcel vn
      cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa vk cv cM vm cv
      cfz co wcel vm cv c1 caddc co cF cfv cr wcel vx cv cr wcel vx cv vm cv c1
      caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv
      c1 caddc co cif cle wbr vm cv c1 caddc co cF cfv c1 caddc co cr wcel vx
      cv cr wcel vx cv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv
      vm cv c1 caddc co cF cfv c1 caddc co cif cle wbr vm cv c1 caddc co cF cfv
      cr wcel vm cv c1 caddc co cF cfv c1 caddc co vx cv max2 vm cv c1 caddc co
      cF cfv peano2re sylan ancoms ad2antlr vk cv cF cfv cr wcel vx cv cr wcel
      vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc
      co cF cfv c1 caddc co cif cr wcel vk cv cF cfv vx cv clt wbr vx cv vm cv
      c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF
      cfv c1 caddc co cif cle wbr wa vk cv cF cfv vm cv c1 caddc co cF cfv c1
      caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif clt
      wbr wi vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co
      cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa wa vk cv
      cM vm cv cfz co wcel wa vk cv cF cfv vx cv vm cv c1 caddc co cF cfv c1
      caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif
      ltletr vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co
      cfz co wral wa vk cv cM vm cv cfz co wcel vk cv cF cfv cr wcel vx cv cr
      wcel vm cv c1 caddc co cF cfv cr wcel wa vm cv cM cuz cfv wcel vk cv cM
      vm cv cfz co wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co cfz co
      wral vk cv cF cfv cr wcel vk cv cM vm cv c1 caddc co cfz co wcel vn cv cF
      cfv cr wcel vn cM vm cv c1 caddc co cfz co wral vk cv cF cfv cr wcel vm
      cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel wa vn cv cF cfv cr wcel vk
      cv cF cfv cr wcel vn vk cv cM vm cv c1 caddc co cfz co vn cv vk cv wceq
      vn cv cF cfv vk cv cF cfv cr vn cv vk cv cF fveq2 eleq1d rcla4va cM cuz
      cfv vk cv cM vm cv fzelp1 sylan an1rs adantlr vm cv cM cuz cfv wcel vn cv
      cF cfv cr wcel vn cM vm cv c1 caddc co cfz co wral wa vx cv cr wcel vm cv
      c1 caddc co cF cfv cr wcel vk cv cM vm cv cfz co wcel simplrl vx cv cr
      wcel vm cv c1 caddc co cF cfv cr wcel wa vm cv c1 caddc co cF cfv c1
      caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif cr
      wcel vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc co
      cfz co wral wa vk cv cM vm cv cfz co wcel vx cv cr wcel vm cv c1 caddc co
      cF cfv c1 caddc co cr wcel vm cv c1 caddc co cF cfv c1 caddc co vx cv cle
      wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif cr wcel vm cv c1 caddc
      co cF cfv cr wcel vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx
      cv vm cv c1 caddc co cF cfv c1 caddc co cr ifcl vm cv c1 caddc co cF cfv
      peano2re sylan2 ad2antlr syl3anc mpan2d ex a2d imp vx cv cr wcel vm cv c1
      caddc co cF cfv cr wcel wa vk cv vm cv c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co
      cF cfv c1 caddc co cif clt wbr wi vm cv cM cuz cfv wcel vn cv cF cfv cr
      wcel vn cM vm cv c1 caddc co cfz co wral wa vk cv cM vm cv cfz co wcel vk
      cv cF cfv vx cv clt wbr wi vk cv vm cv c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co
      cF cfv c1 caddc co cif clt wbr vm cv c1 caddc co cF cfv vm cv c1 caddc co
      cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc
      co cif clt wbr vx cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa vk cv vm
      cv c1 caddc co wceq vk cv cF cfv vm cv c1 caddc co cF cfv vm cv c1 caddc
      co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1
      caddc co cif clt vk cv vm cv c1 caddc co cF fveq2 breq1d vx cv cr wcel vm
      cv c1 caddc co cF cfv cr wcel wa vm cv c1 caddc co cF cfv vm cv c1 caddc
      co cF cfv c1 caddc co vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr
      vx cv vm cv c1 caddc co cF cfv c1 caddc co cif vx cv cr wcel vm cv c1
      caddc co cF cfv cr wcel pm3.27 vm cv c1 caddc co cF cfv cr wcel vm cv c1
      caddc co cF cfv c1 caddc co cr wcel vx cv cr wcel vm cv c1 caddc co cF
      cfv peano2re adantl vx cv cr wcel vm cv c1 caddc co cF cfv c1 caddc co cr
      wcel vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1
      caddc co cF cfv c1 caddc co cif cr wcel vm cv c1 caddc co cF cfv cr wcel
      vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc
      co cF cfv c1 caddc co cr ifcl vm cv c1 caddc co cF cfv peano2re sylan2 vm
      cv c1 caddc co cF cfv cr wcel vm cv c1 caddc co cF cfv vm cv c1 caddc co
      cF cfv c1 caddc co clt wbr vx cv cr wcel vm cv c1 caddc co cF cfv ltp1
      adantl vm cv c1 caddc co cF cfv cr wcel vm cv c1 caddc co cF cfv c1 caddc
      co vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1
      caddc co cF cfv c1 caddc co cif cle wbr vx cv cr wcel vm cv c1 caddc co
      cF cfv cr wcel vm cv c1 caddc co cF cfv c1 caddc co cr wcel vm cv c1
      caddc co cF cfv c1 caddc co vm cv c1 caddc co cF cfv c1 caddc co vx cv
      cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif cle wbr vm cv c1
      caddc co cF cfv peano2re vm cv c1 caddc co cF cfv c1 caddc co vx cv
      max1ALT syl adantl ltletrd syl5cbir ad2antlr jaod sylbid ex r19.20dv2 vx
      cv cr wcel vm cv c1 caddc co cF cfv cr wcel wa vm cv c1 caddc co cF cfv
      c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif
      cr wcel vm cv cM cuz cfv wcel vn cv cF cfv cr wcel vn cM vm cv c1 caddc
      co cfz co wral wa vx cv cr wcel vm cv c1 caddc co cF cfv c1 caddc co cr
      wcel vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1
      caddc co cF cfv c1 caddc co cif cr wcel vm cv c1 caddc co cF cfv cr wcel
      vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc
      co cF cfv c1 caddc co cr ifcl vm cv c1 caddc co cF cfv peano2re sylan2
      adantl jctild vk cv cF cfv vy cv clt wbr vk cM vm cv c1 caddc co cfz co
      wral vk cv cF cfv vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx
      cv vm cv c1 caddc co cF cfv c1 caddc co cif clt wbr vk cM vm cv c1 caddc
      co cfz co wral vy vm cv c1 caddc co cF cfv c1 caddc co vx cv cle wbr vx
      cv vm cv c1 caddc co cF cfv c1 caddc co cif cr vy cv vm cv c1 caddc co cF
      cfv c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co
      cif wceq vk cv cF cfv vy cv clt wbr vk cv cF cfv vm cv c1 caddc co cF cfv
      c1 caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif
      clt wbr vk cM vm cv c1 caddc co cfz co vy cv vm cv c1 caddc co cF cfv c1
      caddc co vx cv cle wbr vx cv vm cv c1 caddc co cF cfv c1 caddc co cif vk
      cv cF cfv clt breq2 ralbidv rcla4ev syl6 exp32 com34 r19.23adv imp3a vk
      cv cF cfv vy cv clt wbr vk cM vm cv c1 caddc co cfz co wral vk cv cF cfv
      vx cv clt wbr vk cM vm cv c1 caddc co cfz co wral vy vx cr vy cv vx cv
      wceq vk cv cF cfv vy cv clt wbr vk cv cF cfv vx cv clt wbr vk cM vm cv c1
      caddc co cfz co vy cv vx cv vk cv cF cfv clt breq2 ralbidv cbvrexv syl6ib
      adantrl mp2and exp32 uzind4 imp vk cv cF cfv cr wcel vn cv cF cfv cr wcel
      vk vn cM cN cfz co vk cv vn cv wceq vk cv cF cfv vn cv cF cfv cr vk cv vn
      cv cF fveq2 eleq1d cbvralv sylan2b $.
      $( [3-Oct-2005] $) $( [19-Sep-2005] $)

    $( The values of a finite real sequence have an upper bound. $)
    fsequb2 $p |- ( ( N e. ( ZZ>= ` M ) /\ F : ( M ... N ) --> RR ) ->
                  E. x e. RR A. y e. ran F y <_ x ) $=
      cN cM cuz cfv wcel cM cN cfz co cr cF wf wa vk cv cF cfv vx cv clt wbr vk
      cM cN cfz co wral vx cr wrex vy cv vx cv cle wbr vy cF crn wral vx cr
      wrex cN cM cuz cfv wcel vk cv cF cfv cr wcel vk cM cN cfz co wral vk cv
      cF cfv vx cv clt wbr vk cM cN cfz co wral vx cr wrex cM cN cfz co cr cF
      wf vx vk cF cM cN fsequb cM cN cfz co cr cF wf vk cv cF cfv cr wcel vk cM
      cN cfz co cM cN cfz co cr vk cv cF ffvelrn r19.21aiva sylan2 cN cM cuz
      cfv wcel cM cN cfz co cr cF wf wa vk cv cF cfv vx cv clt wbr vk cM cN cfz
      co wral vy cv vx cv cle wbr vy cF crn wral vx cr cN cM cuz cfv wcel cM cN
      cfz co cr cF wf wa vx cv cr wcel wa vk cv cF cfv vx cv clt wbr vk cM cN
      cfz co wral vy cv vx cv cle wbr vy cF crn cN cM cuz cfv wcel cM cN cfz co
      cr cF wf wa vx cv cr wcel wa vy cv cF crn wcel wa vk cv cF cfv vx cv clt
      wbr vk cM cN cfz co wral vy cv vx cv clt wbr vy cv vx cv cle wbr cN cM
      cuz cfv wcel cM cN cfz co cr cF wf wa vy cv cF crn wcel vk cv cF cfv vx
      cv clt wbr vk cM cN cfz co wral vy cv vx cv clt wbr wi vx cv cr wcel cM
      cN cfz co cr cF wf vy cv cF crn wcel vk cv cF cfv vx cv clt wbr vk cM cN
      cfz co wral vy cv vx cv clt wbr wi cN cM cuz cfv wcel cM cN cfz co cr cF
      wf vy cv cF crn wcel wa vk cv cF cfv vx cv clt wbr vy cv vx cv clt wbr wi
      vk cM cN cfz co wrex vk cv cF cfv vx cv clt wbr vk cM cN cfz co wral vy
      cv vx cv clt wbr wi cM cN cfz co cr cF wf vy cv cF crn wcel wa vk cv cF
      cfv vy cv wceq vk cM cN cfz co wrex vk cv cF cfv vx cv clt wbr vy cv vx
      cv clt wbr wi vk cM cN cfz co wrex cM cN cfz co cr cF wf vy cv cF crn
      wcel vk cv cF cfv vy cv wceq vk cM cN cfz co wrex cM cN cfz co cr cF wf
      cF cM cN cfz co wfn vy cv cF crn wcel vk cv cF cfv vy cv wceq vk cM cN
      cfz co wrex wb cM cN cfz co cr cF ffn vk cM cN cfz co vy cv cF fvelrnb
      syl biimpa vk cv cF cfv vy cv wceq vk cv cF cfv vx cv clt wbr vy cv vx cv
      clt wbr wi vk cM cN cfz co vk cv cF cfv vy cv wceq vk cv cF cfv vx cv clt
      wbr vy cv vx cv clt wbr vk cv cF cfv vy cv vx cv clt breq1 biimpd
      r19.22si syl vk cv cF cfv vx cv clt wbr vy cv vx cv clt wbr vk cM cN cfz
      co r19.36av syl adantll adantlr cM cN cfz co cr cF wf vx cv cr wcel vy cv
      cF crn wcel vy cv vx cv clt wbr vy cv vx cv cle wbr wi cN cM cuz cfv wcel
      vy cv cr wcel vx cv cr wcel vy cv vx cv clt wbr vy cv vx cv cle wbr wi cM
      cN cfz co cr cF wf vx cv cr wcel wa vy cv cF crn wcel wa vy cv vx cv ltle
      cM cN cfz co cr cF wf vy cv cF crn wcel vy cv cr wcel vx cv cr wcel cM cN
      cfz co cr cF wf vy cv cF crn wcel vy cv cr wcel cM cN cfz co cr cF wf cF
      crn cr vy cv cM cN cfz co cr cF frn sseld imp adantlr cM cN cfz co cr cF
      wf vx cv cr wcel vy cv cF crn wcel simplr sylanc adantlll syld r19.21adva
      r19.22dva mpd $.
      $( [15-Oct-2006] $) $( [20-Sep-2005] $)

    $( The values of a finite real sequence have a supremum. $)
    fseqsupcl $p |- ( ( N e. ( ZZ>= ` M ) /\ F : ( M ... N ) --> RR )
                 -> sup ( ran F , RR , < ) e. RR ) $=
      cF crn cr wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn wral vx cr wrex
      cF crn cr clt csup cr wcel cN cM cuz cfv wcel cM cN cfz co cr cF wf wa vx
      vy cF crn suprcl cM cN cfz co cr cF wf cF crn cr wss cN cM cuz cfv wcel
      cM cN cfz co cr cF frn adantl cM cM cN cfz co wcel cF cdm cM cN cfz co
      wceq cF crn c0 wne cN cM cuz cfv wcel cM cN cfz co cr cF wf cM cM cN cfz
      co wcel cF cdm cM cN cfz co wceq cF crn c0 wne cF cdm cM cN cfz co wceq
      cM cN cfz co c0 wne cF crn c0 wne cM cM cN cfz co wcel cF cdm cM cN cfz
      co wceq cF crn c0 cM cN cfz co c0 cF cdm cM cN cfz co wceq cF cdm c0 wceq
      cM cN cfz co c0 wceq cF crn c0 wceq cF cdm cM cN cfz co wceq cF cdm c0
      wceq cM cN cfz co c0 wceq cF cdm cM cN cfz co c0 eqeq1 biimpd cF dm0rn0
      syl5ibr necon3d cM cN cfz co cM ne0i syl5com imp cM cN eluzfz1 cM cN cfz
      co cr cF fdm syl2an vx vy cF cM cN fsequb2 syl3anc $.
      $( [9-Jul-2007] $) $( [20-Sep-2005] $)

    fseqsupub.1 $e |- N e. _V $.
    $( The values of a finite real sequence are bounded by their supremum. $)
    fseqsupubi $p |- ( ( K e. ( M ... N ) /\ F : ( M ... N ) --> RR ) ->
               ( F ` K ) <_ sup ( ran F , RR , < ) ) $=
      cF crn cr wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn wral vx cr wrex
      w3a cK cF cfv cF crn wcel cK cF cfv cF crn cr clt csup cle wbr cK cM cN
      cfz co wcel cM cN cfz co cr cF wf wa vx vy cF crn cK cF cfv suprub cK cM
      cN cfz co wcel cM cN cfz co cr cF wf wa cF crn cr wss cF crn c0 wne vy cv
      vx cv cle wbr vy cF crn wral vx cr wrex cM cN cfz co cr cF wf cF crn cr
      wss cK cM cN cfz co wcel cM cN cfz co cr cF frn adantl cK cM cN cfz co
      wcel cF cdm cM cN cfz co wceq cF crn c0 wne cM cN cfz co cr cF wf cK cM
      cN cfz co wcel cF cdm cM cN cfz co wceq cF crn c0 wne cF cdm cM cN cfz co
      wceq cM cN cfz co c0 wne cF crn c0 wne cK cM cN cfz co wcel cF cdm cM cN
      cfz co wceq cF crn c0 cM cN cfz co c0 cF cdm cM cN cfz co wceq cF cdm c0
      wceq cM cN cfz co c0 wceq cF crn c0 wceq cF cdm cM cN cfz co wceq cF cdm
      c0 wceq cM cN cfz co c0 wceq cF cdm cM cN cfz co c0 eqeq1 biimpd cF
      dm0rn0 syl5ibr necon3d cM cN cfz co cK ne0i syl5com imp cM cN cfz co cr
      cF fdm sylan2 cN cM cuz cfv wcel cM cN cfz co cr cF wf vy cv vx cv cle
      wbr vy cF crn wral vx cr wrex cK cM cN cfz co wcel vx vy cF cM cN fsequb2
      cN cvv wcel cK cM cN cfz co wcel cN cM cuz cfv wcel fseqsupub.1 cvv cK cM
      cN elfzuz2 mpan sylan 3jca cK cM cN cfz co wcel cF cM cN cfz co wfn cK cF
      cfv cF crn wcel cM cN cfz co cr cF wf cF cM cN cfz co wfn cK cM cN cfz co
      wcel cK cF cfv cF crn wcel cM cN cfz co cK cF fnfvelrn ancoms cM cN cfz
      co cr cF ffn sylan2 sylanc $.
      $( [29-Jul-2007] $) $( [20-Sep-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The infinite sequence builder "seq1"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u $.  $d z w v u G $.  $d z w v u A $.  $d z w v u B $.
    $d x y z w v u C $.
    om2uz.1 $e |- C e. ZZ $.
    om2uz.2 $e |- G = ( rec ( { <. x , y >. | y = ( x + 1 ) } , C ) |` om ) $.
    $( The mapping ` G ` is a one-to-one mapping from ` om ` onto upper
       integers that will be used to construct a recursive definition
       generator.  Ordinal natural number 0 maps to complex number ` C `
       (normally 0 for the upper integers ` NN0 ` or 1 for the upper integers
       ` NN ` ), 1 maps to ` C ` + 1, etc.  This theorem shows the value of
       ` G ` at ordinal natural number zero.  (This series of theorems
       generalizes an earlier series for ` NN0 ` contributed by Raph Levien,
       10-Apr-2004.) $)
    om2uz0i $p |- ( G ` (/) ) = C $=
      c0 cG cfv c0 vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com cres
      cfv cC c0 cG vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com cres
      om2uz.2 fveq1i cC cz wcel c0 vy cv vx cv c1 caddc co wceq vx vy copab cC
      crdg com cres cfv cC wceq om2uz.1 cC cz vy cv vx cv c1 caddc co wceq vx
      vy copab fr0g ax-mp eqtri $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)

    $( The value of ` G ` (see ~ om2uz0i ) at a successor. $)
    om2uzsuci $p |- ( A e. om -> ( G ` suc A ) = ( ( G ` A ) + 1 ) ) $=
      vw cv csuc cG cfv vw cv cG cfv c1 caddc co wceq cA csuc cG cfv cA cG cfv
      c1 caddc co wceq vw cA com vw cv cA wceq vw cv csuc cG cfv cA csuc cG cfv
      vw cv cG cfv c1 caddc co cA cG cfv c1 caddc co vw cv cA wceq vw cv csuc
      cA csuc cG vw cv cA suceq fveq2d vw cv cA wceq vw cv cG cfv cA cG cfv c1
      caddc vw cv cA cG fveq2 opreq1d eqeq12d vw cv com wcel vw cv cG cfv c1
      caddc co cvv wcel vw cv csuc cG cfv vw cv cG cfv c1 caddc co wceq vw cv
      cG cfv c1 caddc oprex vx vy vv cC vw cv vx cv c1 caddc co vw cv cG cfv c1
      caddc co cvv cG vv cv cC wcel vx ax-17 vv cv vw cv wcel vx ax-17 vx vv vw
      cv cG cfv c1 caddc co vw cv vy cv vx cv c1 caddc co wceq vx vy copab cC
      crdg com cres cfv c1 caddc co vw cv cG cfv vw cv vy cv vx cv c1 caddc co
      wceq vx vy copab cC crdg com cres cfv c1 caddc vw cv cG vy cv vx cv c1
      caddc co wceq vx vy copab cC crdg com cres om2uz.2 fveq1i opreq1i vx vv
      vw cv vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com cres cfv c1
      caddc vx vv vw cv vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com
      cres vx vv vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com vx vv cC
      vy cv vx cv c1 caddc co wceq vx vy copab vy cv vx cv c1 caddc co wceq vx
      vy vv hbopab1 vv cv cC wcel vx ax-17 hbrdg vv cv com wcel vx ax-17 hbres
      vv cv vw cv wcel vx ax-17 hbfv vv cv caddc wcel vx ax-17 vv cv c1 wcel vx
      ax-17 hbopr hbxfr om2uz.2 vx cv vw cv cG cfv c1 caddc opreq1 frsucopab
      mpan2 vtoclga $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)

    $( MAY BE REVISED - use ~ df-uz stuff instead of ` { z e. ZZ | C <_ z } `
       here and other om2uz* $)
    $( The value ` G ` (see ~ om2uz0i ) at an ordinal natural number is in the
       upper integers. $)
    om2uzuzi $p |- ( A e. om -> ( G ` A ) e. { z e. ZZ | C <_ z } ) $=
      vv cv cG cfv cC vz cv cle wbr vz cz crab wcel c0 cG cfv cC vz cv cle wbr
      vz cz crab wcel vw cv cG cfv cC vz cv cle wbr vz cz crab wcel vw cv csuc
      cG cfv cC vz cv cle wbr vz cz crab wcel cA cG cfv cC vz cv cle wbr vz cz
      crab wcel vv vw cA vv cv c0 wceq vv cv cG cfv c0 cG cfv cC vz cv cle wbr
      vz cz crab vv cv c0 cG fveq2 eleq1d vv cv vw cv wceq vv cv cG cfv vw cv
      cG cfv cC vz cv cle wbr vz cz crab vv cv vw cv cG fveq2 eleq1d vv cv vw
      cv csuc wceq vv cv cG cfv vw cv csuc cG cfv cC vz cv cle wbr vz cz crab
      vv cv vw cv csuc cG fveq2 eleq1d vv cv cA wceq vv cv cG cfv cA cG cfv cC
      vz cv cle wbr vz cz crab vv cv cA cG fveq2 eleq1d c0 cG cfv cC cC vz cv
      cle wbr vz cz crab vx vy cC cG om2uz.1 om2uz.2 om2uz0i cC cC vz cv cle
      wbr vz cz crab wcel cC cz wcel cC cC cle wbr cC vz cv cle wbr cC cC cle
      wbr vz cC cz vz cv cC cC cle breq2 elrab om2uz.1 cC cC om2uz.1 zrei leidi
      mpbir2an eqeltri vw cv com wcel vw cv csuc cG cfv cC vz cv cle wbr vz cz
      crab wcel vw cv cG cfv c1 caddc co cC vz cv cle wbr vz cz crab wcel vw cv
      cG cfv cC vz cv cle wbr vz cz crab wcel vw cv com wcel vw cv csuc cG cfv
      vw cv cG cfv c1 caddc co cC vz cv cle wbr vz cz crab vx vy vw cv cC cG
      om2uz.1 om2uz.2 om2uzsuci eleq1d cC cz wcel vw cv cG cfv cC vz cv cle wbr
      vz cz crab wcel vw cv cG cfv c1 caddc co cC vz cv cle wbr vz cz crab wcel
      om2uz.1 vz cC vw cv cG cfv peano2uz2 mpan syl5bir finds $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)

    $( Less-than relation for ` G ` (see ~ om2uz0i ). $)
    om2uzlti $p |- ( ( A e. om /\ B e. om ) ->
                   ( A e. B -> ( G ` A ) < ( G ` B ) ) ) $=
      cB com wcel cA com wcel cA cB wcel cA cG cfv cB cG cfv clt wbr wi cA com
      wcel cA vv cv wcel cA cG cfv vv cv cG cfv clt wbr wi wi cA com wcel cA c0
      wcel cA cG cfv c0 cG cfv clt wbr wi wi cA com wcel cA vw cv wcel cA cG
      cfv vw cv cG cfv clt wbr wi wi cA com wcel cA vw cv csuc wcel cA cG cfv
      vw cv csuc cG cfv clt wbr wi wi cA com wcel cA cB wcel cA cG cfv cB cG
      cfv clt wbr wi wi vv vw cB vv cv c0 wceq cA vv cv wcel cA cG cfv vv cv cG
      cfv clt wbr wi cA c0 wcel cA cG cfv c0 cG cfv clt wbr wi cA com wcel vv
      cv c0 wceq cA vv cv wcel cA c0 wcel cA cG cfv vv cv cG cfv clt wbr cA cG
      cfv c0 cG cfv clt wbr vv cv c0 cA eleq2 vv cv c0 wceq vv cv cG cfv c0 cG
      cfv cA cG cfv clt vv cv c0 cG fveq2 breq2d imbi12d imbi2d vv cv vw cv
      wceq cA vv cv wcel cA cG cfv vv cv cG cfv clt wbr wi cA vw cv wcel cA cG
      cfv vw cv cG cfv clt wbr wi cA com wcel vv cv vw cv wceq cA vv cv wcel cA
      vw cv wcel cA cG cfv vv cv cG cfv clt wbr cA cG cfv vw cv cG cfv clt wbr
      vv cv vw cv cA eleq2 vv cv vw cv wceq vv cv cG cfv vw cv cG cfv cA cG cfv
      clt vv cv vw cv cG fveq2 breq2d imbi12d imbi2d vv cv vw cv csuc wceq cA
      vv cv wcel cA cG cfv vv cv cG cfv clt wbr wi cA vw cv csuc wcel cA cG cfv
      vw cv csuc cG cfv clt wbr wi cA com wcel vv cv vw cv csuc wceq cA vv cv
      wcel cA vw cv csuc wcel cA cG cfv vv cv cG cfv clt wbr cA cG cfv vw cv
      csuc cG cfv clt wbr vv cv vw cv csuc cA eleq2 vv cv vw cv csuc wceq vv cv
      cG cfv vw cv csuc cG cfv cA cG cfv clt vv cv vw cv csuc cG fveq2 breq2d
      imbi12d imbi2d vv cv cB wceq cA vv cv wcel cA cG cfv vv cv cG cfv clt wbr
      wi cA cB wcel cA cG cfv cB cG cfv clt wbr wi cA com wcel vv cv cB wceq cA
      vv cv wcel cA cB wcel cA cG cfv vv cv cG cfv clt wbr cA cG cfv cB cG cfv
      clt wbr vv cv cB cA eleq2 vv cv cB wceq vv cv cG cfv cB cG cfv cA cG cfv
      clt vv cv cB cG fveq2 breq2d imbi12d imbi2d cA c0 wcel cA cG cfv c0 cG
      cfv clt wbr wi cA com wcel cA c0 wcel cA cG cfv c0 cG cfv clt wbr cA noel
      pm2.21i a1i vw cv com wcel cA com wcel cA vw cv wcel cA cG cfv vw cv cG
      cfv clt wbr wi cA vw cv csuc wcel cA cG cfv vw cv csuc cG cfv clt wbr wi
      cA com wcel vw cv com wcel cA vw cv wcel cA cG cfv vw cv cG cfv clt wbr
      wi cA vw cv csuc wcel cA cG cfv vw cv csuc cG cfv clt wbr wi wi cA com
      wcel vw cv com wcel wa cA vw cv wcel cA vw cv wceq wo cA cG cfv vw cv cG
      cfv clt wbr cA cG cfv vw cv cG cfv wceq wo wi cA vw cv csuc wcel cA cG
      cfv vw cv csuc cG cfv clt wbr wi cA vw cv wcel cA cG cfv vw cv cG cfv clt
      wbr wi cA com wcel vw cv com wcel wa cA vw cv wcel cA vw cv wceq wo cA vw
      cv csuc wcel cA cG cfv vw cv cG cfv clt wbr cA cG cfv vw cv cG cfv wceq
      wo cA cG cfv vw cv csuc cG cfv clt wbr vw cv com wcel cA vw cv wcel cA vw
      cv wceq wo cA vw cv csuc wcel wb cA com wcel vw cv com wcel cA vw cv csuc
      wcel cA vw cv wcel cA vw cv wceq wo cA vw cv com elsuc2g bicomd adantl cA
      com wcel vw cv com wcel wa cA cG cfv vw cv csuc cG cfv clt wbr cA cG cfv
      vw cv cG cfv c1 caddc co clt wbr cA cG cfv vw cv cG cfv cle wbr cA cG cfv
      vw cv cG cfv clt wbr cA cG cfv vw cv cG cfv wceq wo vw cv com wcel cA cG
      cfv vw cv csuc cG cfv clt wbr cA cG cfv vw cv cG cfv c1 caddc co clt wbr
      wb cA com wcel vw cv com wcel vw cv csuc cG cfv vw cv cG cfv c1 caddc co
      cA cG cfv clt vx vy vw cv cC cG om2uz.1 om2uz.2 om2uzsuci breq2d adantl
      cA cG cfv cC vz cv cle wbr vz cz crab wcel vw cv cG cfv cC vz cv cle wbr
      vz cz crab wcel cA cG cfv vw cv cG cfv cle wbr cA cG cfv vw cv cG cfv c1
      caddc co clt wbr wb cA com wcel vw cv com wcel cA cG cfv cz wcel vw cv cG
      cfv cz wcel cA cG cfv vw cv cG cfv cle wbr cA cG cfv vw cv cG cfv c1
      caddc co clt wbr wb cA cG cfv cC vz cv cle wbr vz cz crab wcel vw cv cG
      cfv cC vz cv cle wbr vz cz crab wcel cA cG cfv vw cv cG cfv zleltp1 cC vz
      cv cle wbr vz cz crab cz cA cG cfv cC vz cv cle wbr vz cz ssrab2 sseli cC
      vz cv cle wbr vz cz crab cz vw cv cG cfv cC vz cv cle wbr vz cz ssrab2
      sseli syl2an vx vy vz cA cC cG om2uz.1 om2uz.2 om2uzuzi vx vy vz vw cv cC
      cG om2uz.1 om2uz.2 om2uzuzi syl2an cA cG cfv cr wcel vw cv cG cfv cr wcel
      cA cG cfv vw cv cG cfv cle wbr cA cG cfv vw cv cG cfv clt wbr cA cG cfv
      vw cv cG cfv wceq wo wb cA com wcel vw cv com wcel cA cG cfv vw cv cG cfv
      leloe cA com wcel cA cG cfv cC vz cv cle wbr vz cz crab wcel cA cG cfv cz
      wcel cA cG cfv cr wcel vx vy vz cA cC cG om2uz.1 om2uz.2 om2uzuzi cC vz
      cv cle wbr vz cz crab cz cA cG cfv cC vz cv cle wbr vz cz ssrab2 sseli cA
      cG cfv zre 3syl vw cv com wcel vw cv cG cfv cC vz cv cle wbr vz cz crab
      wcel vw cv cG cfv cz wcel vw cv cG cfv cr wcel vx vy vz vw cv cC cG
      om2uz.1 om2uz.2 om2uzuzi cC vz cv cle wbr vz cz crab cz vw cv cG cfv cC
      vz cv cle wbr vz cz ssrab2 sseli vw cv cG cfv zre 3syl syl2an 3bitr2rd
      imbi12d cA vw cv wcel cA cG cfv vw cv cG cfv clt wbr wi cA vw cv wcel cA
      cG cfv vw cv cG cfv clt wbr cA vw cv wceq cA cG cfv vw cv cG cfv wceq cA
      vw cv wcel cA cG cfv vw cv cG cfv clt wbr wi id cA vw cv wceq cA cG cfv
      vw cv cG cfv wceq wi cA vw cv wcel cA cG cfv vw cv cG cfv clt wbr wi cA
      vw cv cG fveq2 a1i orim12d syl5bi expcom a2d finds impcom $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)

    $( The mapping ` G ` (see ~ om2uz0i ) preserves order. $)
    om2uzlt2i $p |- ( ( A e. om /\ B e. om ) ->
                   ( A e. B <-> ( G ` A ) < ( G ` B ) ) ) $=
      cA com wcel cB com wcel wa cA cB wcel cA cG cfv cB cG cfv clt wbr vx vy
      cA cB cC cG om2uz.1 om2uz.2 om2uzlti cA com wcel cB com wcel wa cA cB
      wcel cA cG cfv cB cG cfv clt wbr cA com wcel cB com wcel wa cB cA wcel cB
      cA wceq wo cB cG cfv cA cG cfv clt wbr cB cG cfv cA cG cfv wceq wo cA cB
      wcel wn cA cG cfv cB cG cfv clt wbr wn cB com wcel cA com wcel cB cA wcel
      cB cA wceq wo cB cG cfv cA cG cfv clt wbr cB cG cfv cA cG cfv wceq wo wi
      cB com wcel cA com wcel wa cB cA wcel cB cG cfv cA cG cfv clt wbr cB cA
      wceq cB cG cfv cA cG cfv wceq vx vy cB cA cC cG om2uz.1 om2uz.2 om2uzlti
      cB cA wceq cB cG cfv cA cG cfv wceq wi cB com wcel cA com wcel wa cB cA
      cG fveq2 a1i orim12d ancoms cB com wcel cA com wcel cB cA wcel cB cA wceq
      wo cA cB wcel wn wb cB con0 wcel cA con0 wcel cB cA wcel cB cA wceq wo cA
      cB wcel wn wb cB com wcel cA com wcel cB con0 wcel cA con0 wcel wa cB cA
      wss cB cA wcel cB cA wceq wo cA cB wcel wn cB cA onsseleq cB cA ontri1
      bitr3d cB nnon cA nnon syl2an ancoms cB com wcel cA com wcel cB cG cfv cA
      cG cfv clt wbr cB cG cfv cA cG cfv wceq wo cA cG cfv cB cG cfv clt wbr wn
      wb cB cG cfv cr wcel cA cG cfv cr wcel cB cG cfv cA cG cfv clt wbr cB cG
      cfv cA cG cfv wceq wo cA cG cfv cB cG cfv clt wbr wn wb cB com wcel cA
      com wcel cB cG cfv cr wcel cA cG cfv cr wcel wa cB cG cfv cA cG cfv cle
      wbr cB cG cfv cA cG cfv clt wbr cB cG cfv cA cG cfv wceq wo cA cG cfv cB
      cG cfv clt wbr wn cB cG cfv cA cG cfv leloe cB cG cfv cA cG cfv lenlt
      bitr3d cB com wcel cB cG cfv cC vz cv cle wbr vz cz crab wcel cB cG cfv
      cr wcel vx vy vz cB cC cG om2uz.1 om2uz.2 om2uzuzi cC vz cv cle wbr vz cz
      crab cr cB cG cfv cC vz cv cle wbr vz cz crab cz cr cC vz cv cle wbr vz
      cz ssrab2 zssre sstri sseli syl cA com wcel cA cG cfv cC vz cv cle wbr vz
      cz crab wcel cA cG cfv cr wcel vx vy vz cA cC cG om2uz.1 om2uz.2 om2uzuzi
      cC vz cv cle wbr vz cz crab cr cA cG cfv cC vz cv cle wbr vz cz crab cz
      cr cC vz cv cle wbr vz cz ssrab2 zssre sstri sseli syl syl2an ancoms
      3imtr3d con4d impbid $.
      $( [7-May-2005] $) $( [4-May-2005] $)

    $( Range of ` G ` (see ~ om2uz0i ). $)
    om2uzrani $p |- ran G = { z e. ZZ | C <_ z } $=
      vu cG crn cC vz cv cle wbr vz cz crab vu cv cG crn wcel vu cv cC vz cv
      cle wbr vz cz crab wcel vu cv cG crn wcel vw cv cG cfv vu cv wceq vw com
      wrex vu cv cC vz cv cle wbr vz cz crab wcel cG com wfn vu cv cG crn wcel
      vw cv cG cfv vu cv wceq vw com wrex wb cG com wfn vy cv vx cv c1 caddc co
      wceq vx vy copab cC crdg com cres com wfn cC vy cv vx cv c1 caddc co wceq
      vx vy copab frfnom cG vy cv vx cv c1 caddc co wceq vx vy copab cC crdg
      com cres wceq cG com wfn vy cv vx cv c1 caddc co wceq vx vy copab cC crdg
      com cres com wfn wb om2uz.2 com cG vy cv vx cv c1 caddc co wceq vx vy
      copab cC crdg com cres fneq1 ax-mp mpbir vw com vu cv cG fvelrnb ax-mp vw
      cv cG cfv vu cv wceq vu cv cC vz cv cle wbr vz cz crab wcel vw com vw cv
      cG cfv vu cv wceq vw cv cG cfv cC vz cv cle wbr vz cz crab wcel vu cv cC
      vz cv cle wbr vz cz crab wcel vw cv com wcel vw cv cG cfv vu cv cC vz cv
      cle wbr vz cz crab eleq1 vx vy vz vw cv cC cG om2uz.1 om2uz.2 om2uzuzi
      syl5cbi r19.23aiv sylbi vu cv cC vz cv cle wbr vz cz crab wcel vu cv cz
      wcel cC vu cv cle wbr wa vu cv cG crn wcel cC vz cv cle wbr cC vu cv cle
      wbr vz vu cv cz vz cv vu cv cC cle breq2 elrab cC cz wcel vu cv cz wcel
      cC vu cv cle wbr vu cv cG crn wcel om2uz.1 vw cv cG crn wcel cC cG crn
      wcel vv cv cG crn wcel vv cv c1 caddc co cG crn wcel vu cv cG crn wcel vw
      vv cC vu cv vw cv cC cG crn eleq1 vw cv vv cv cG crn eleq1 vw cv vv cv c1
      caddc co cG crn eleq1 vw cv vu cv cG crn eleq1 cC cG crn wcel cC cz wcel
      c0 cG cfv cC cG crn vx vy cC cG om2uz.1 om2uz.2 om2uz0i cG com wfn c0 com
      wcel c0 cG cfv cG crn wcel cG com wfn vy cv vx cv c1 caddc co wceq vx vy
      copab cC crdg com cres com wfn cC vy cv vx cv c1 caddc co wceq vx vy
      copab frfnom cG vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com cres
      wceq cG com wfn vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com cres
      com wfn wb om2uz.2 com cG vy cv vx cv c1 caddc co wceq vx vy copab cC
      crdg com cres fneq1 ax-mp mpbir peano1 com c0 cG fnfvelrn mp2an eqeltrri
      a1i vv cv cG crn wcel vv cv c1 caddc co cG crn wcel wi cC cz wcel vv cv
      cz wcel cC vv cv cle wbr w3a vv cv cG crn wcel vw cv cG cfv vv cv wceq vw
      com wrex vv cv c1 caddc co cG crn wcel cG com wfn vv cv cG crn wcel vw cv
      cG cfv vv cv wceq vw com wrex wb cG com wfn vy cv vx cv c1 caddc co wceq
      vx vy copab cC crdg com cres com wfn cC vy cv vx cv c1 caddc co wceq vx
      vy copab frfnom cG vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com
      cres wceq cG com wfn vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com
      cres com wfn wb om2uz.2 com cG vy cv vx cv c1 caddc co wceq vx vy copab
      cC crdg com cres fneq1 ax-mp mpbir vw com vv cv cG fvelrnb ax-mp vw cv cG
      cfv vv cv wceq vv cv c1 caddc co cG crn wcel vw com vw cv com wcel vw cv
      cG cfv vv cv wceq wa vw cv csuc cG cfv vv cv c1 caddc co cG crn vw cv com
      wcel vw cv cG cfv vv cv wceq vw cv csuc cG cfv vw cv cG cfv c1 caddc co
      vv cv c1 caddc co vx vy vw cv cC cG om2uz.1 om2uz.2 om2uzsuci vw cv cG
      cfv vv cv c1 caddc opreq1 sylan9eq vw cv com wcel vw cv csuc cG cfv cG
      crn wcel vw cv cG cfv vv cv wceq cG com wfn vw cv csuc com wcel vw cv
      csuc cG cfv cG crn wcel vw cv com wcel com vw cv csuc cG fnfvelrn cG com
      wfn vy cv vx cv c1 caddc co wceq vx vy copab cC crdg com cres com wfn cC
      vy cv vx cv c1 caddc co wceq vx vy copab frfnom cG vy cv vx cv c1 caddc
      co wceq vx vy copab cC crdg com cres wceq cG com wfn vy cv vx cv c1 caddc
      co wceq vx vy copab cC crdg com cres com wfn wb om2uz.2 com cG vy cv vx
      cv c1 caddc co wceq vx vy copab cC crdg com cres fneq1 ax-mp mpbir vw cv
      peano2 sylancr adantr eqeltrrd r19.23aiva sylbi a1i uzind mp3an1 sylbi
      impbii eqriv $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)

    $( ` G ` (see ~ om2uz0i ) is a one-to-one onto mapping. $)
    om2uzf1oi $p |- G : om -1-1-onto-> { z e. ZZ | C <_ z } $=
      com cC vz cv cle wbr vz cz crab cG wf1o com cC vz cv cle wbr vz cz crab
      cG wf1 cG crn cC vz cv cle wbr vz cz crab wceq com cC vz cv cle wbr vz cz
      crab cG dff1o5 com cC vz cv cle wbr vz cz crab cG wf1 com cC vz cv cle
      wbr vz cz crab cG wf vw cv cG cfv vv cv cG cfv wceq vw cv vv cv wceq wi
      vv com wral vw com wral vw vv com cC vz cv cle wbr vz cz crab cG dff13
      com cC vz cv cle wbr vz cz crab cG wf cG com wfn cG crn cC vz cv cle wbr
      vz cz crab wss com cC vz cv cle wbr vz cz crab cG df-f cG com wfn vy cv
      vx cv c1 caddc co wceq vx vy copab cC crdg com cres com wfn cC vy cv vx
      cv c1 caddc co wceq vx vy copab frfnom cG vy cv vx cv c1 caddc co wceq vx
      vy copab cC crdg com cres wceq cG com wfn vy cv vx cv c1 caddc co wceq vx
      vy copab cC crdg com cres com wfn wb om2uz.2 com cG vy cv vx cv c1 caddc
      co wceq vx vy copab cC crdg com cres fneq1 ax-mp mpbir cG crn cC vz cv
      cle wbr vz cz crab vx vy vz cC cG om2uz.1 om2uz.2 om2uzrani eqimssi
      mpbir2an vw cv cG cfv vv cv cG cfv wceq vw cv vv cv wceq wi vw vv com vw
      cv com wcel vv cv com wcel wa vw cv cG cfv vv cv cG cfv wceq vw cv cG cfv
      vv cv cG cfv clt wbr vv cv cG cfv vw cv cG cfv clt wbr wo wn vw cv vv cv
      wceq vw cv com wcel vv cv com wcel wa vw cv cG cfv vv cv cG cfv wceq vw
      cv cG cfv vv cv cG cfv clt wbr wn vv cv cG cfv vw cv cG cfv clt wbr wn wa
      vw cv cG cfv vv cv cG cfv clt wbr vv cv cG cfv vw cv cG cfv clt wbr wo wn
      vw cv cG cfv cr wcel vv cv cG cfv cr wcel vw cv cG cfv vv cv cG cfv wceq
      vw cv cG cfv vv cv cG cfv clt wbr wn vv cv cG cfv vw cv cG cfv clt wbr wn
      wa wb vw cv com wcel vv cv com wcel vw cv cG cfv vv cv cG cfv lttri3 vw
      cv com wcel vw cv cG cfv cC vz cv cle wbr vz cz crab wcel vw cv cG cfv cz
      wcel vw cv cG cfv cr wcel vx vy vz vw cv cC cG om2uz.1 om2uz.2 om2uzuzi
      cC vz cv cle wbr vz cz crab cz vw cv cG cfv cC vz cv cle wbr vz cz ssrab2
      sseli vw cv cG cfv zre 3syl vv cv com wcel vv cv cG cfv cC vz cv cle wbr
      vz cz crab wcel vv cv cG cfv cz wcel vv cv cG cfv cr wcel vx vy vz vv cv
      cC cG om2uz.1 om2uz.2 om2uzuzi cC vz cv cle wbr vz cz crab cz vv cv cG
      cfv cC vz cv cle wbr vz cz ssrab2 sseli vv cv cG cfv zre 3syl syl2an vw
      cv cG cfv vv cv cG cfv clt wbr vv cv cG cfv vw cv cG cfv clt wbr ioran
      syl6bbr vw cv com wcel vv cv com wcel wa vw cv vv cv wceq vw cv cG cfv vv
      cv cG cfv clt wbr vv cv cG cfv vw cv cG cfv clt wbr wo vw cv com wcel vv
      cv com wcel wa vw cv vv cv wceq wn vw cv vv cv wcel vv cv vw cv wcel wo
      vw cv cG cfv vv cv cG cfv clt wbr vv cv cG cfv vw cv cG cfv clt wbr wo vw
      cv com wcel vv cv com wcel wa vw cv vv cv wceq vw cv vv cv wcel vv cv vw
      cv wcel wo vw cv word vv cv word vw cv vv cv wceq vw cv vv cv wcel vv cv
      vw cv wcel wo wn wb vw cv com wcel vv cv com wcel vw cv vv cv ordtri3 vw
      cv nnord vv cv nnord syl2an con2bid vw cv com wcel vv cv com wcel wa vw
      cv vv cv wcel vw cv cG cfv vv cv cG cfv clt wbr vv cv vw cv wcel vv cv cG
      cfv vw cv cG cfv clt wbr vx vy vw cv vv cv cC cG om2uz.1 om2uz.2 om2uzlti
      vv cv com wcel vw cv com wcel vv cv vw cv wcel vv cv cG cfv vw cv cG cfv
      clt wbr wi vx vy vv cv vw cv cC cG om2uz.1 om2uz.2 om2uzlti ancoms
      orim12d sylbird con1d sylbid rgen2a mpbir2an vx vy vz cC cG om2uz.1
      om2uz.2 om2uzrani mpbir2an $.
      $( [15-Oct-2004] $) $( [3-Oct-2004] $)

    $( ` G ` (see ~ om2uz0i ) is an isomorphism from natural ordinals to
       upper integers. $)
    om2uzisoi $p |- G Isom _E , < ( om , { z e. ZZ | C <_ z } ) $=
      com cC vz cv cle wbr vz cz crab cep clt cG wiso com cC vz cv cle wbr vz
      cz crab cG wf1o vw cv vv cv cep wbr vw cv cG cfv vv cv cG cfv clt wbr wb
      vv com wral vw com wral vw vv com cC vz cv cle wbr vz cz crab cep clt cG
      df-iso vx vy vz cC cG om2uz.1 om2uz.2 om2uzf1oi vw cv vv cv cep wbr vw cv
      cG cfv vv cv cG cfv clt wbr wb vw vv com vw cv com wcel vv cv com wcel wa
      vw cv vv cv wcel vw cv cG cfv vv cv cG cfv clt wbr vw cv vv cv cep wbr vx
      vy vw cv vv cv cC cG om2uz.1 om2uz.2 om2uzlt2i vw vv epel syl5bb rgen2a
      mpbir2an $.
      $( [9-Oct-2008] $) $( [9-Oct-2008] $)

    $( A helper lemma for the value of a recursive definition generator on
       upper integers (typically either ` NN ` or ` NN0 ` ) with characteristic
       function ` F ` and initial value ` A ` .  Normally ` F ` is a function
       on the partition, and ` A ` is a member of the partition.  See also
       comment in ~ om2uz0i . $)
    uzrdgvali $p |- ( B e. { z e. ZZ | C <_ z } ->
                  ( ( rec ( F , A ) o. `' G ) ` B ) =
                  ( rec ( F , A ) ` ( `' G ` B ) ) ) $=
      cB cC vz cv cle wbr vz cz crab wcel cB cG ccnv cdm wcel cB cF cA crdg cG
      ccnv ccom cfv cB cG ccnv cfv cF cA crdg cfv wceq cC vz cv cle wbr vz cz
      crab cG ccnv cdm cB cG crn cC vz cv cle wbr vz cz crab cG ccnv cdm vx vy
      vz cC cG om2uz.1 om2uz.2 om2uzrani cG df-rn eqtr3i eleq2i cF cA crdg wfun
      cG ccnv wfun cB cG ccnv cdm wcel cB cF cA crdg cG ccnv ccom cfv cB cG
      ccnv cfv cF cA crdg cfv wceq cF cA crdg con0 wfn cF cA crdg wfun cA cF
      rdgfnon con0 cF cA crdg fnfun ax-mp cC vz cv cle wbr vz cz crab com cG
      ccnv wf1o cG ccnv wfun com cC vz cv cle wbr vz cz crab cG wf1o cC vz cv
      cle wbr vz cz crab com cG ccnv wf1o vx vy vz cC cG om2uz.1 om2uz.2
      om2uzf1oi com cC vz cv cle wbr vz cz crab cG f1ocnv ax-mp cC vz cv cle
      wbr vz cz crab com cG ccnv f1ofun ax-mp cB cF cA crdg cG ccnv fvco
      mp3an12 sylbi $.
      $( [16-Oct-2004] $) $( [3-Oct-2004] $)

    $( Initial value of a recursive definition generator on upper integers.
       See comment in ~ uzrdgvali . $)
    uzrdginii $p |- ( A e. B -> ( ( rec ( F , A ) o. `' G ) ` C ) = A ) $=
      cA cB wcel c0 cF cA crdg cfv cA cC cF cA crdg cG ccnv ccom cfv cA cB cF
      rdg0g cC cF cA crdg cG ccnv ccom cfv cC cG ccnv cfv cF cA crdg cfv c0 cF
      cA crdg cfv cC cC vz cv cle wbr vz cz crab wcel cC cF cA crdg cG ccnv
      ccom cfv cC cG ccnv cfv cF cA crdg cfv wceq cC cC vz cv cle wbr vz cz
      crab wcel cC cz wcel cC cC cle wbr cC vz cv cle wbr cC cC cle wbr vz cC
      cz vz cv cC cC cle breq2 elrab om2uz.1 cC cC om2uz.1 zrei leidi mpbir2an
      vx vy vz cA cC cC cF cG om2uz.1 om2uz.2 uzrdgvali ax-mp cC cG ccnv cfv c0
      cF cA crdg c0 cG cfv cC wceq cC cG ccnv cfv c0 wceq vx vy cC cG om2uz.1
      om2uz.2 om2uz0i com cC vz cv cle wbr vz cz crab cG wf1o c0 com wcel c0 cG
      cfv cC wceq cC cG ccnv cfv c0 wceq wi vx vy vz cC cG om2uz.1 om2uz.2
      om2uzf1oi peano1 com cC vz cv cle wbr vz cz crab c0 cC cG f1ocnvfv mp2an
      ax-mp fveq2i eqtri syl5eq $.
      $( [16-Oct-2004] $) $( [3-Oct-2004] $)

    $( Successor value of a recursive definition generator on upper integers.
       See comment in ~ uzrdgvali . $)
    uzrdgsuci $p |- ( B e. { z e. ZZ | C <_ z } ->
                  ( ( rec ( F , A ) o. `' G ) ` ( B + 1 ) )
                  = ( F ` ( ( rec ( F , A ) o. `' G ) ` B ) ) ) $=
      cB cC vz cv cle wbr vz cz crab wcel cB c1 caddc co cF cA crdg cG ccnv
      ccom cfv cB cG ccnv cfv cF cA crdg cfv cF cfv cB cF cA crdg cG ccnv ccom
      cfv cF cfv cB cC vz cv cle wbr vz cz crab wcel cB c1 caddc co cF cA crdg
      cG ccnv ccom cfv cB c1 caddc co cG ccnv cfv cF cA crdg cfv cB cG ccnv cfv
      csuc cF cA crdg cfv cB cG ccnv cfv cF cA crdg cfv cF cfv cB cC vz cv cle
      wbr vz cz crab wcel cB c1 caddc co cC vz cv cle wbr vz cz crab wcel cB c1
      caddc co cF cA crdg cG ccnv ccom cfv cB c1 caddc co cG ccnv cfv cF cA
      crdg cfv wceq cC cz wcel cB cC vz cv cle wbr vz cz crab wcel cB c1 caddc
      co cC vz cv cle wbr vz cz crab wcel om2uz.1 vz cC cB peano2uz2 mpan vx vy
      vz cA cB c1 caddc co cC cF cG om2uz.1 om2uz.2 uzrdgvali syl cB cC vz cv
      cle wbr vz cz crab wcel cB c1 caddc co cG ccnv cfv cB cG ccnv cfv csuc cF
      cA crdg cB cC vz cv cle wbr vz cz crab wcel cB cG ccnv cfv csuc cG cfv cB
      c1 caddc co wceq cB c1 caddc co cG ccnv cfv cB cG ccnv cfv csuc wceq cB
      cC vz cv cle wbr vz cz crab wcel cB cG ccnv cfv csuc cG cfv cB cG ccnv
      cfv cG cfv c1 caddc co cB c1 caddc co cB cC vz cv cle wbr vz cz crab wcel
      cB cG ccnv cfv com wcel cB cG ccnv cfv csuc cG cfv cB cG ccnv cfv cG cfv
      c1 caddc co wceq cC vz cv cle wbr vz cz crab com cB cG ccnv cC vz cv cle
      wbr vz cz crab com cG ccnv wf1o cC vz cv cle wbr vz cz crab com cG ccnv
      wf com cC vz cv cle wbr vz cz crab cG wf1o cC vz cv cle wbr vz cz crab
      com cG ccnv wf1o vx vy vz cC cG om2uz.1 om2uz.2 om2uzf1oi com cC vz cv
      cle wbr vz cz crab cG f1ocnv ax-mp cC vz cv cle wbr vz cz crab com cG
      ccnv f1of ax-mp ffvelrni vx vy cB cG ccnv cfv cC cG om2uz.1 om2uz.2
      om2uzsuci syl cB cC vz cv cle wbr vz cz crab wcel cB cG ccnv cfv cG cfv
      cB c1 caddc com cC vz cv cle wbr vz cz crab cG wf1o cB cC vz cv cle wbr
      vz cz crab wcel cB cG ccnv cfv cG cfv cB wceq vx vy vz cC cG om2uz.1
      om2uz.2 om2uzf1oi com cC vz cv cle wbr vz cz crab cB cG f1ocnvfv2 mpan
      opreq1d eqtrd cB cC vz cv cle wbr vz cz crab wcel cB cG ccnv cfv com wcel
      cB cG ccnv cfv csuc com wcel cB cG ccnv cfv csuc cG cfv cB c1 caddc co
      wceq cB c1 caddc co cG ccnv cfv cB cG ccnv cfv csuc wceq wi cC vz cv cle
      wbr vz cz crab com cB cG ccnv cC vz cv cle wbr vz cz crab com cG ccnv
      wf1o cC vz cv cle wbr vz cz crab com cG ccnv wf com cC vz cv cle wbr vz
      cz crab cG wf1o cC vz cv cle wbr vz cz crab com cG ccnv wf1o vx vy vz cC
      cG om2uz.1 om2uz.2 om2uzf1oi com cC vz cv cle wbr vz cz crab cG f1ocnv
      ax-mp cC vz cv cle wbr vz cz crab com cG ccnv f1of ax-mp ffvelrni cB cG
      ccnv cfv peano2 com cC vz cv cle wbr vz cz crab cG wf1o cB cG ccnv cfv
      csuc com wcel cB cG ccnv cfv csuc cG cfv cB c1 caddc co wceq cB c1 caddc
      co cG ccnv cfv cB cG ccnv cfv csuc wceq wi vx vy vz cC cG om2uz.1 om2uz.2
      om2uzf1oi com cC vz cv cle wbr vz cz crab cB cG ccnv cfv csuc cB c1 caddc
      co cG f1ocnvfv mpan 3syl mpd fveq2d cB cC vz cv cle wbr vz cz crab wcel
      cB cG ccnv cfv com wcel cB cG ccnv cfv con0 wcel cB cG ccnv cfv csuc cF
      cA crdg cfv cB cG ccnv cfv cF cA crdg cfv cF cfv wceq cC vz cv cle wbr vz
      cz crab com cB cG ccnv cC vz cv cle wbr vz cz crab com cG ccnv wf1o cC vz
      cv cle wbr vz cz crab com cG ccnv wf com cC vz cv cle wbr vz cz crab cG
      wf1o cC vz cv cle wbr vz cz crab com cG ccnv wf1o vx vy vz cC cG om2uz.1
      om2uz.2 om2uzf1oi com cC vz cv cle wbr vz cz crab cG f1ocnv ax-mp cC vz
      cv cle wbr vz cz crab com cG ccnv f1of ax-mp ffvelrni cB cG ccnv cfv nnon
      cA cB cG ccnv cfv cF rdgsuc 3syl 3eqtrd cB cC vz cv cle wbr vz cz crab
      wcel cB cF cA crdg cG ccnv ccom cfv cB cG ccnv cfv cF cA crdg cfv cF vx
      vy vz cA cB cC cF cG om2uz.1 om2uz.2 uzrdgvali fveq2d eqtr4d $.
      $( [16-Oct-2004] $) $( [3-Oct-2004] $)

    $( A helper lemma for the value of an ` NN ` or ` NN0 ` -based recursive
       definition generator.  Value at second index.  See comment in
       ~ uzrdgvali . $)
    uzrdginip1i $p |- ( A e. B -> ( ( rec ( F , A ) o. `' G ) ` ( C + 1 ) ) =
                  ( F ` A ) ) $=
      cA cB wcel cC cF cA crdg cG ccnv ccom cfv cF cfv cA cF cfv cC c1 caddc co
      cF cA crdg cG ccnv ccom cfv cA cB wcel cC cF cA crdg cG ccnv ccom cfv cA
      cF vx vy cA cB cC cF cG om2uz.1 om2uz.2 uzrdginii fveq2d cC cC vz cv cle
      wbr vz cz crab wcel cC c1 caddc co cF cA crdg cG ccnv ccom cfv cC cF cA
      crdg cG ccnv ccom cfv cF cfv wceq cC cC vz cv cle wbr vz cz crab wcel cC
      cz wcel cC cC cle wbr cC vz cv cle wbr cC cC cle wbr vz cC cz vz cv cC cC
      cle breq2 elrab om2uz.1 cC cC om2uz.1 zrei leidi mpbir2an vx vy vz cA cC
      cC cF cG om2uz.1 om2uz.2 uzrdgsuci ax-mp syl5eq $.
      $( [6-Jun-2005] $) $( [3-Oct-2004] $)

    $( A helper lemma for the value of an ` NN ` or ` NN0 ` -based recursive
       definition generator.  The generated function is a function on the upper
       integers starting at ` C ` (usually 1 or 0).  See comment in
       ~ uzrdgvali . $)
    uzrdgfnuzi $p |- ( rec ( F , A ) o. `' G ) Fn { z e. ZZ | C <_ z } $=
      cF cA crdg cG ccnv ccom cC vz cv cle wbr vz cz crab wfn cC vz cv cle wbr
      vz cz crab cvv cF cA crdg cG ccnv ccom wf con0 cvv cF cA crdg wf cC vz cv
      cle wbr vz cz crab con0 cG ccnv wf cC vz cv cle wbr vz cz crab cvv cF cA
      crdg cG ccnv ccom wf cF cA crdg con0 wfn con0 cvv cF cA crdg wf cA cF
      rdgfnon con0 cF cA crdg dffn2 mpbi cC vz cv cle wbr vz cz crab com cG
      ccnv wf com con0 wss cC vz cv cle wbr vz cz crab con0 cG ccnv wf cC vz cv
      cle wbr vz cz crab com cG ccnv wf1o cC vz cv cle wbr vz cz crab com cG
      ccnv wf com cC vz cv cle wbr vz cz crab cG wf1o cC vz cv cle wbr vz cz
      crab com cG ccnv wf1o vx vy vz cC cG om2uz.1 om2uz.2 om2uzf1oi com cC vz
      cv cle wbr vz cz crab cG f1ocnv ax-mp cC vz cv cle wbr vz cz crab com cG
      ccnv f1of ax-mp omsson cC vz cv cle wbr vz cz crab com con0 cG ccnv fss
      mp2an cC vz cv cle wbr vz cz crab con0 cvv cF cA crdg cG ccnv fco mp2an
      cC vz cv cle wbr vz cz crab cF cA crdg cG ccnv ccom dffn2 mpbir $.
      $( [27-Jun-2005] $) $( [3-Oct-2004] $)
  $}

  ${
    $d m n G $.  $d n N $.  $d j k n $.
    cardfz.1 $e |- G = ( rec ( { <. j , k >. | k = ( j + 1 ) } , 0 ) |` om ) $.
    $( The cardinality of a finite set of sequential integers.  (See ~ om2uz0i
       for a description of the antecedent.) $)
    cardfz $p |- ( N e. NN0 -> ( card ` ( 1 ... N ) ) = ( `' G ` N ) ) $=
      c1 vn cv cfz co ccrd cfv vn cv cG ccnv cfv wceq c1 cc0 cfz co ccrd cfv
      cc0 cG ccnv cfv wceq c1 vm cv cfz co ccrd cfv vm cv cG ccnv cfv wceq c1
      vm cv c1 caddc co cfz co ccrd cfv vm cv c1 caddc co cG ccnv cfv wceq c1
      cN cfz co ccrd cfv cN cG ccnv cfv wceq vn vm cN vm cv cn0 wcel c1 vm cv
      cfz co ccrd cfv vm cv cG ccnv cfv wceq c1 vm cv c1 caddc co cfz co ccrd
      cfv vm cv c1 caddc co cG ccnv cfv wceq vm cv cn0 wcel c1 vm cv cfz co
      ccrd cfv vm cv cG ccnv cfv wceq wa c1 vm cv c1 caddc co cfz co ccrd cfv
      c1 vm cv cfz co ccrd cfv csuc ccrd cfv vm cv c1 caddc co cG ccnv cfv vm
      cv cn0 wcel c1 vm cv c1 caddc co cfz co ccrd cfv c1 vm cv cfz co ccrd cfv
      csuc ccrd cfv wceq c1 vm cv cfz co ccrd cfv vm cv cG ccnv cfv wceq vm cv
      cn0 wcel c1 vm cv c1 caddc co cfz co ccrd cfv c1 vm cv cfz co vm cv c1
      caddc co csn cun ccrd cfv c1 vm cv cfz co ccrd cfv csuc ccrd cfv vm cv
      cn0 wcel c1 vm cv c1 caddc co cfz co c1 vm cv cfz co vm cv c1 caddc co
      csn cun ccrd vm cv cz wcel c1 vm cv c1 caddc co cle wbr c1 vm cv c1 caddc
      co cfz co c1 vm cv cfz co vm cv c1 caddc co csn cun wceq vm cv cn0 wcel
      c1 cz wcel vm cv cz wcel c1 vm cv c1 caddc co cle wbr c1 vm cv c1 caddc
      co cfz co c1 vm cv cfz co vm cv c1 caddc co csn cun wceq 1z c1 vm cv
      fzsuc mp3an1 vm cv nn0z vm cv cn0 wcel cc0 c1 caddc co vm cv c1 caddc co
      c1 cle vm cv cn0 wcel cc0 vm cv cle wbr cc0 c1 caddc co vm cv c1 caddc co
      cle wbr vm cv nn0ge0 vm cv cn0 wcel vm cv cr wcel cc0 vm cv cle wbr cc0
      c1 caddc co vm cv c1 caddc co cle wbr wb vm cv nn0re cc0 cr wcel vm cv cr
      wcel c1 cr wcel cc0 vm cv cle wbr cc0 c1 caddc co vm cv c1 caddc co cle
      wbr wb 0re 1re cc0 vm cv c1 leadd1 mp3an13 syl mpbid c1 ax1cn addid2i
      syl5eqbrr sylanc fveq2d vm cv cn0 wcel c1 vm cv cfz co vm cv c1 caddc co
      csn cun c1 vm cv cfz co ccrd cfv csuc cen wbr c1 vm cv cfz co vm cv c1
      caddc co csn cun ccrd cfv c1 vm cv cfz co ccrd cfv csuc ccrd cfv wceq vm
      cv cn0 wcel vm cv c1 caddc co c1 vm cv cfz co wcel wn c1 vm cv cfz co vm
      cv c1 caddc co csn cun c1 vm cv cfz co ccrd cfv csuc cen wbr vm cv cn0
      wcel vm cv c1 caddc co vm cv cle wbr vm cv c1 caddc co c1 vm cv cfz co
      wcel vm cv cn0 wcel vm cv cr wcel vm cv c1 caddc co vm cv cle wbr wn vm
      cv nn0re vm cv cr wcel vm cv vm cv c1 caddc co clt wbr vm cv c1 caddc co
      vm cv cle wbr wn vm cv ltp1 vm cv cr wcel vm cv c1 caddc co cr wcel vm cv
      vm cv c1 caddc co clt wbr vm cv c1 caddc co vm cv cle wbr wn wb vm cv
      peano2re vm cv vm cv c1 caddc co ltnle mpdan mpbid syl vm cv c1 caddc co
      c1 vm cv elfzle2 nsyl c1 vm cv cfz co vm cv c1 caddc co c1 vm cv cfz
      oprex vm cv c1 caddc oprex unsnen syl c1 vm cv cfz co vm cv c1 caddc co
      csn cun cvv wcel c1 vm cv cfz co ccrd cfv csuc cvv wcel c1 vm cv cfz co
      vm cv c1 caddc co csn cun ccrd cfv c1 vm cv cfz co ccrd cfv csuc ccrd cfv
      wceq c1 vm cv cfz co vm cv c1 caddc co csn cun c1 vm cv cfz co ccrd cfv
      csuc cen wbr wb c1 vm cv cfz co vm cv c1 caddc co csn c1 vm cv cfz oprex
      vm cv c1 caddc co snex unex c1 vm cv cfz co ccrd cfv c1 vm cv cfz co ccrd
      fvex sucex c1 vm cv cfz co vm cv c1 caddc co csn cun c1 vm cv cfz co ccrd
      cfv csuc cvv cvv carden mp2an sylibr eqtrd adantr c1 vm cv cfz co ccrd
      cfv vm cv cG ccnv cfv wceq vm cv cn0 wcel c1 vm cv cfz co ccrd cfv csuc
      ccrd cfv vm cv cG ccnv cfv csuc ccrd cfv vm cv c1 caddc co cG ccnv cfv c1
      vm cv cfz co ccrd cfv vm cv cG ccnv cfv wceq c1 vm cv cfz co ccrd cfv
      csuc vm cv cG ccnv cfv csuc ccrd c1 vm cv cfz co ccrd cfv vm cv cG ccnv
      cfv suceq fveq2d vm cv cn0 wcel vm cv cG ccnv cfv csuc ccrd cfv vm cv cG
      ccnv cfv csuc vm cv c1 caddc co cG ccnv cfv vm cv cn0 wcel vm cv cG ccnv
      cfv csuc com wcel vm cv cG ccnv cfv csuc ccrd cfv vm cv cG ccnv cfv csuc
      wceq vm cv cn0 wcel vm cv cG ccnv cfv com wcel vm cv cG ccnv cfv csuc com
      wcel vm cv cn0 wcel vm cv cc0 vn cv cle wbr vn cz crab wcel vm cv cG ccnv
      cfv com wcel cn0 cc0 vn cv cle wbr vn cz crab vm cv vn nn0zrab eleq2i com
      cc0 vn cv cle wbr vn cz crab cG wf1o vm cv cc0 vn cv cle wbr vn cz crab
      wcel vm cv cG ccnv cfv com wcel vj vk vn cc0 cG 0z cardfz.1 om2uzf1oi com
      cc0 vn cv cle wbr vn cz crab vm cv cG f1ocnvdm mpan sylbi vm cv cG ccnv
      cfv peano2 syl vm cv cG ccnv cfv csuc cardnn syl com cc0 vn cv cle wbr vn
      cz crab cG wf1o vm cv cG ccnv cfv csuc com wcel wa vm cv cG ccnv cfv csuc
      cG cfv vm cv c1 caddc co wceq vm cv c1 caddc co cG ccnv cfv vm cv cG ccnv
      cfv csuc wceq vm cv cn0 wcel com cc0 vn cv cle wbr vn cz crab vm cv cG
      ccnv cfv csuc vm cv c1 caddc co cG f1ocnvfv vm cv cn0 wcel vm cv cG ccnv
      cfv csuc com wcel com cc0 vn cv cle wbr vn cz crab cG wf1o vm cv cn0 wcel
      vm cv cG ccnv cfv com wcel vm cv cG ccnv cfv csuc com wcel vm cv cn0 wcel
      vm cv cc0 vn cv cle wbr vn cz crab wcel vm cv cG ccnv cfv com wcel cn0
      cc0 vn cv cle wbr vn cz crab vm cv vn nn0zrab eleq2i com cc0 vn cv cle
      wbr vn cz crab cG wf1o vm cv cc0 vn cv cle wbr vn cz crab wcel vm cv cG
      ccnv cfv com wcel vj vk vn cc0 cG 0z cardfz.1 om2uzf1oi com cc0 vn cv cle
      wbr vn cz crab vm cv cG f1ocnvdm mpan sylbi vm cv cG ccnv cfv peano2 syl
      vj vk vn cc0 cG 0z cardfz.1 om2uzf1oi jctil vm cv cn0 wcel vm cv cG ccnv
      cfv csuc cG cfv vm cv cG ccnv cfv cG cfv c1 caddc co vm cv c1 caddc co vm
      cv cn0 wcel vm cv cG ccnv cfv com wcel vm cv cG ccnv cfv csuc cG cfv vm
      cv cG ccnv cfv cG cfv c1 caddc co wceq vm cv cn0 wcel vm cv cc0 vn cv cle
      wbr vn cz crab wcel vm cv cG ccnv cfv com wcel cn0 cc0 vn cv cle wbr vn
      cz crab vm cv vn nn0zrab eleq2i com cc0 vn cv cle wbr vn cz crab cG wf1o
      vm cv cc0 vn cv cle wbr vn cz crab wcel vm cv cG ccnv cfv com wcel vj vk
      vn cc0 cG 0z cardfz.1 om2uzf1oi com cc0 vn cv cle wbr vn cz crab vm cv cG
      f1ocnvdm mpan sylbi vj vk vm cv cG ccnv cfv cc0 cG 0z cardfz.1 om2uzsuci
      syl vm cv cn0 wcel vm cv cG ccnv cfv cG cfv vm cv c1 caddc com cc0 vn cv
      cle wbr vn cz crab cG wf1o vm cv cc0 vn cv cle wbr vn cz crab wcel vm cv
      cG ccnv cfv cG cfv vm cv wceq vm cv cn0 wcel com cc0 vn cv cle wbr vn cz
      crab vm cv cG f1ocnvfv2 vj vk vn cc0 cG 0z cardfz.1 om2uzf1oi vm cv cn0
      wcel vm cv cc0 vn cv cle wbr vn cz crab wcel cn0 cc0 vn cv cle wbr vn cz
      crab vm cv vn nn0zrab eleq2i biimpi sylancr opreq1d eqtrd sylc eqtr4d
      sylan9eqr eqtrd ex c0 ccrd cfv c0 c1 cc0 cfz co ccrd cfv cc0 cG ccnv cfv
      card0 c1 cc0 cfz co c0 ccrd cc0 c1 clt wbr c1 cc0 cfz co c0 wceq lt01 c1
      cz wcel cc0 cz wcel cc0 c1 clt wbr c1 cc0 cfz co c0 wceq wb 1z 0z c1 cc0
      fzn mp2an mpbi fveq2i com cc0 vn cv cle wbr vn cz crab cG wf1o c0 com
      wcel wa c0 cG cfv cc0 wceq cc0 cG ccnv cfv c0 wceq com cc0 vn cv cle wbr
      vn cz crab cG wf1o c0 com wcel vj vk vn cc0 cG 0z cardfz.1 om2uzf1oi
      peano1 pm3.2i vj vk cc0 cG 0z cardfz.1 om2uz0i com cc0 vn cv cle wbr vn
      cz crab c0 cc0 cG f1ocnvfv mp2 3eqtr4i vn cv cc0 wceq c1 vn cv cfz co
      ccrd cfv c1 cc0 cfz co ccrd cfv vn cv cG ccnv cfv cc0 cG ccnv cfv vn cv
      cc0 wceq c1 vn cv cfz co c1 cc0 cfz co ccrd vn cv cc0 c1 cfz opreq2
      fveq2d vn cv cc0 cG ccnv fveq2 eqeq12d vn cv vm cv wceq c1 vn cv cfz co
      ccrd cfv c1 vm cv cfz co ccrd cfv vn cv cG ccnv cfv vm cv cG ccnv cfv vn
      cv vm cv wceq c1 vn cv cfz co c1 vm cv cfz co ccrd vn cv vm cv c1 cfz
      opreq2 fveq2d vn cv vm cv cG ccnv fveq2 eqeq12d vn cv vm cv c1 caddc co
      wceq c1 vn cv cfz co ccrd cfv c1 vm cv c1 caddc co cfz co ccrd cfv vn cv
      cG ccnv cfv vm cv c1 caddc co cG ccnv cfv vn cv vm cv c1 caddc co wceq c1
      vn cv cfz co c1 vm cv c1 caddc co cfz co ccrd vn cv vm cv c1 caddc co c1
      cfz opreq2 fveq2d vn cv vm cv c1 caddc co cG ccnv fveq2 eqeq12d vn cv cN
      wceq c1 vn cv cfz co ccrd cfv c1 cN cfz co ccrd cfv vn cv cG ccnv cfv cN
      cG ccnv cfv vn cv cN wceq c1 vn cv cfz co c1 cN cfz co ccrd vn cv cN c1
      cfz opreq2 fveq2d vn cv cN cG ccnv fveq2 eqeq12d nn0indALT $.
      $( [6-Mar-2009] $) $( [7-Nov-2008] $)
  $}

  $c seq1 $.  $( Symbol for recursive sequence builder. $)

  $( Extend class notation with recursive sequence builder. $)
  cseq1 $a class seq1 $.

  ${
    $d x y z w f g h $.
    $( Define a general-purpose operation that builds an recursive sequence
       (i.e. a function on the natural numbers ` NN ` ) whose value at an index
       is a function of its previous value and the value of an input sequence
       at that index.  This definition is complicated, but fortunately it is
       not intended to be used directly.  Instead, the only purpose of this
       definition is to provide us with an object that has the properties
       expressed by ~ seq11 and ~ seq1p1 .  Typically, those are the main
       theorems that would be used in practice.

       The first operand is the operation that is applied to the previous value
       and the value of the input sequence (second operand).  For example, for
       the operation ` + ` , an input sequence ` F ` with values 1, 1/2, 1/4,
       1/8,... would be transformed into the output sequence ` ( + seq1 F ) `
       with values 1, 3/2, 7/4, 15/8,.., so that
       ` ( ( + seq1 F ) `` 1 ) = 1 ` , ` ( ( + seq1 F ) `` 2 ) = ` 3/2, etc.
       In other words, ` ( + seq1 F ) ` transforms a sequence ` F ` into an
       infinite series.  ` ( + seq1 F ) ~~> 2 ` means "the sum of F(n) from n =
       1 to infinity is 2."  Since limits are unique ( ~ climuni ), then
       by ~ euabsn and ~ unisn the "sum of F(n) from n = 1 to infinity" can be
       expressed as ` U. { x | ( + seq1 F ) ~~> x } ` (provided the sequence
       converges) and evaluates to 2 in this example.

       Internally, we define a recursive function whose values are ordered
       pairs starting at ` <. 1 , ( g `` 1 ) >. ` . The first member of the
       ordered pair is a counter used to select the appropriate value of the
       input sequence ` g ` .  The first ` rec ` constructs this function
       on ` om ` , and the converse of the second ` rec ` maps ` NN ` to
       ` om ` .

       This definition has its roots in a series of theorems starting at
       ~ om2uz0i , originally proved by Raph Levien for use with ~ df-exp and
       later generalized for arbitrary recursive sequences.  The related
       definitions ~ df-seq0 and ~ df-seqz build recursive sequences on ` NN0 `
       and general upper integer sets respectively.  Definition ~ df-sum
       extracts the summation values from partial (finite) and complete
       (infinite) series. $)
    df-seq1 $a |- seq1 = { <. <. f , g >. , h >. |
                   h = { <. x , y >. | ( x e. NN /\
                     y = ( 2nd ` ( ( rec ( { <. z , w >. |
                         w = <. ( ( 1st ` z ) + 1 ) ,
                           ( ( 2nd ` z ) f ( g ` ( ( 1st ` z ) + 1 ) ) ) >. } ,
                       <. 1 , ( g ` 1 ) >. ) o. `'
       ( rec ( { <. z , w >. | w = ( z + 1 ) } , 1 ) |` om ) ) ` x ) ) ) } } $.
  $}

  ${
    $d x y v $.  $d z w v u f $.  $d v A $.  $d w v u f B $.
    $d x v u f C $.  $d v u f G $.
    seq1lem1.1 $e |- G =
                     ( rec ( { <. x , y >. | y = ( x + 1 ) } , 1 ) |` om ) $.
    $( We prove by induction that the first member of the ordered pair
       value of the internal sequence of ` seq1 ` equals its index. $)
    seq1lem1 $p |- ( A e. NN -> ( 1st `
                ( ( rec ( { <. z , w >. | w = <. ( ( 1st ` z ) + 1 ) , B >. } ,
                <. 1 , C >. ) o. `'  G ) ` A ) ) = A ) $=
      vv cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop
      crdg cG ccnv ccom cfv c1st cfv vv cv wceq c1 vw cv vz cv c1st cfv c1
      caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv
      c1 wceq vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1
      cC cop crdg cG ccnv ccom cfv c1st cfv vu cv wceq vu cv c1 caddc co vw cv
      vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv
      ccom cfv c1st cfv vu cv c1 caddc co wceq cA vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv cA
      wceq vv vu cA vv cv c1 wceq vv cv vw cv vz cv c1st cfv c1 caddc co cB cop
      wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 vw cv vz cv
      c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom
      cfv c1st cfv vv cv c1 vv cv c1 wceq vv cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1 vw cv vz cv
      c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom
      cfv c1st vv cv c1 vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom fveq2 fveq2d vv cv c1 wceq id eqeq12d
      vv cv vu cv wceq vv cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv vw cv vz cv c1st cfv
      c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st
      cfv vv cv vu cv vv cv vu cv wceq vv cv vw cv vz cv c1st cfv c1 caddc co
      cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv vu cv vw cv vz cv
      c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom
      cfv c1st vv cv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom fveq2 fveq2d vv cv vu cv wceq id
      eqeq12d vv cv vu cv c1 caddc co wceq vv cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv
      c1 caddc co vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1
      cC cop crdg cG ccnv ccom cfv c1st cfv vv cv vu cv c1 caddc co vv cv vu cv
      c1 caddc co wceq vv cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv vu cv c1 caddc co vw cv vz cv c1st
      cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv
      c1st vv cv vu cv c1 caddc co vw cv vz cv c1st cfv c1 caddc co cB cop wceq
      vz vw copab c1 cC cop crdg cG ccnv ccom fveq2 fveq2d vv cv vu cv c1 caddc
      co wceq id eqeq12d vv cv cA wceq vv cv vw cv vz cv c1st cfv c1 caddc co
      cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv cA vw cv
      vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv
      ccom cfv c1st cfv vv cv cA vv cv cA wceq vv cv vw cv vz cv c1st cfv c1
      caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv cA vw cv
      vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv
      ccom cfv c1st vv cv cA vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom fveq2 fveq2d vv cv cA wceq id eqeq12d
      c1 vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop
      crdg cG ccnv ccom cfv c1st cfv c1 cC cop c1st cfv c1 c1 vw cv vz cv c1st
      cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv
      c1 cC cop c1st c1 cC cop cvv wcel c1 vw cv vz cv c1st cfv c1 caddc co cB
      cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1 cC cop wceq c1 cC
      opex vx vy c1 cC cop cvv c1 vw cv vz cv c1st cfv c1 caddc co cB cop wceq
      vz vw copab cG 1z seq1lem1.1 uzrdginii ax-mp fveq2i c1 cC c1 cz 1z
      elisseti op1st eqtri vu cv cn wcel vu cv vw cv vz cv c1st cfv c1 caddc co
      cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv
      wceq vu cv c1 caddc co vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv c1 caddc co wceq vu
      cv cn wcel vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab
      c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv wceq vu cv c1 caddc co vw
      cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG
      ccnv ccom cfv c1st cfv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq
      vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co vu cv c1
      caddc co vu cv cn wcel vu cv c1 caddc co vw cv vz cv c1st cfv c1 caddc co
      cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv vw
      cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG
      ccnv ccom cfv c1st cfv c1 caddc co vz vu cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv cB csb cop
      c1st cfv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab
      c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co vu cv cn wcel vu cv
      c1 caddc co vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1
      cC cop crdg cG ccnv ccom cfv vu cv vw cv vz cv c1st cfv c1 caddc co cB
      cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co
      vz vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC
      cop crdg cG ccnv ccom cfv cB csb cop c1st vu cv cn wcel vu cv c1 caddc co
      vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg
      cG ccnv ccom cfv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv vw cv vz cv c1st cfv c1 caddc co cB
      cop wceq vz vw copab cfv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop
      wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co vz
      vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop
      crdg cG ccnv ccom cfv cB csb cop vu cv cn wcel vu cv c1 vv cv cle wbr vv
      cz crab wcel vu cv c1 caddc co vw cv vz cv c1st cfv c1 caddc co cB cop
      wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv vu cv vw cv vz cv c1st
      cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv
      vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab cfv wceq cn c1
      vv cv cle wbr vv cz crab vu cv vv nnzrab eleq2i vx vy vv c1 cC cop vu cv
      c1 vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab cG 1z
      seq1lem1.1 uzrdgsuci sylbi vu cv vw cv vz cv c1st cfv c1 caddc co cB cop
      wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv vw cv vz cv c1st cfv c1
      caddc co cB cop wceq vz vw copab cfv vu cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv vw cv vv cv
      c1st cfv c1 caddc co vz vv cv cB csb cop wceq vv vw copab cfv vu cv vw cv
      vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv
      ccom cfv c1st cfv c1 caddc co vz vu cv vw cv vz cv c1st cfv c1 caddc co
      cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv cB csb cop vu cv
      vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg
      cG ccnv ccom cfv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab
      vw cv vv cv c1st cfv c1 caddc co vz vv cv cB csb cop wceq vv vw copab vw
      cv vz cv c1st cfv c1 caddc co cB cop wceq vw cv vv cv c1st cfv c1 caddc
      co vz vv cv cB csb cop wceq vz vw vv vw cv vz cv c1st cfv c1 caddc co cB
      cop wceq vv ax-17 vz vw vv cv c1st cfv c1 caddc co vz vv cv cB csb cop vz
      vw vv cv c1st cfv c1 caddc co vz vv cv cB csb vw cv vv cv c1st cfv c1
      caddc co wcel vz ax-17 vz vw vv cv cB vv visset vw cv vv cv wcel vz ax-17
      hbcsb1 hbop hbeleq vz cv vv cv wceq vz cv c1st cfv c1 caddc co cB cop vv
      cv c1st cfv c1 caddc co vz vv cv cB csb cop vw cv vz cv vv cv wceq vz cv
      c1st cfv c1 caddc co vv cv c1st cfv c1 caddc co cB vz vv cv cB csb vz cv
      vv cv wceq vz cv c1st cfv vv cv c1st cfv c1 caddc vz cv vv cv c1st fveq2
      opreq1d vz vv cv cB csbeq1a opeq12d eqeq2d cbvopab1 fveq1i vv vw vf vu cv
      vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg
      cG ccnv ccom cfv vv cv c1st cfv c1 caddc co vz vv cv cB csb cop vu cv vw
      cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG
      ccnv ccom cfv c1st cfv c1 caddc co vz vu cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv cB csb cop vf
      cv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC
      cop crdg cG ccnv ccom cfv wcel vv ax-17 vf cv vu cv vw cv vz cv c1st cfv
      c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st
      cfv c1 caddc co vz vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz
      vw copab c1 cC cop crdg cG ccnv ccom cfv cB csb cop wcel vv ax-17 vu cv
      vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg
      cG ccnv ccom fvex vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz
      vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co vz vu cv vw
      cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG
      ccnv ccom cfv cB csb opex vv cv vu cv vw cv vz cv c1st cfv c1 caddc co cB
      cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv wceq vv cv c1st cfv
      c1 caddc co vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co vz vv cv cB
      csb vz vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1
      cC cop crdg cG ccnv ccom cfv cB csb vv cv vu cv vw cv vz cv c1st cfv c1
      caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv wceq vv
      cv c1st cfv vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1 caddc vv cv vu cv vw cv
      vz cv c1st cfv c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv
      ccom cfv c1st fveq2 opreq1d vz vv cv vu cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv cB csbeq1
      opeq12d fvopabf eqtri syl6eq fveq2d vu cv vw cv vz cv c1st cfv c1 caddc
      co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv c1
      caddc co vz vu cv vw cv vz cv c1st cfv c1 caddc co cB cop wceq vz vw
      copab c1 cC cop crdg cG ccnv ccom cfv cB csb vu cv vw cv vz cv c1st cfv
      c1 caddc co cB cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st
      cfv c1 caddc oprex op1st syl6eq vu cv vw cv vz cv c1st cfv c1 caddc co cB
      cop wceq vz vw copab c1 cC cop crdg cG ccnv ccom cfv c1st cfv vu cv c1
      caddc opreq1 sylan9eq ex nnind $.
      $( [21-Dec-2008] $) $( [5-Oct-2004] $)
  $}

  $( Lemma for recursive sequence builder theorems. $)
  seq1lem2 $p |- ( A e. NN -> ( A + 1 ) e. ( NN \ { 1 } ) ) $=
    cA c1 caddc co cn wcel c1 cA c1 caddc co clt wbr cA c1 caddc co cn c1 csn
    cdif wcel cA cn wcel cA c1 caddc co cn wcel c1 cA c1 caddc co clt wbr wa cA
    c1 caddc co cn c1 csn cdif wcel cA c1 caddc co cn wcel c1 cA c1 caddc co
    clt wbr wa cA c1 caddc co cn wcel cA c1 caddc co c1 wne wa cA c1 caddc co
    cn c1 csn cdif wcel cA c1 caddc co cn wcel c1 cA c1 caddc co clt wbr cA c1
    caddc co c1 wne cA c1 caddc co nngt1ne1 pm5.32i cA c1 caddc co cn c1
    eldifsn bitr4i biimpi cA peano2nn cA cn wcel cc0 cA clt wbr c1 cA c1 caddc
    co clt wbr cA nngt0 cA cn wcel cA cr wcel cc0 cA clt wbr c1 cA c1 caddc co
    clt wbr wb cA nnre cA cr wcel cc0 cA clt wbr cc0 c1 caddc co cA c1 caddc co
    clt wbr c1 cA c1 caddc co clt wbr cc0 cr wcel cA cr wcel c1 cr wcel cc0 cA
    clt wbr cc0 c1 caddc co cA c1 caddc co clt wbr wb 0re 1re cc0 cA c1 ltadd1
    mp3an13 cc0 c1 caddc co c1 cA c1 caddc co clt c1 ax1cn addid2i breq1i
    syl6bb syl mpbid sylanc $.
    $( [17-Oct-2004] $) $( [8-Oct-2004] $)

  ${
    $d A x z $.  $d w x $.  $d S x z w $.  $d F x z w $.
    seq1rval.1 $e |- H = { <. z , w >. | w = <. ( ( 1st ` z ) + 1 ) ,
                   ( ( 2nd ` z ) S ( F ` ( ( 1st ` z ) + 1 ) ) ) >. } $.
    seq1rval.2 $e |- A e. _V $.
    $( Value of the characteristic function of the inner recursion in
       ~ df-seq1 . $)
    seq1rval $p |- ( H ` A ) = <. ( ( 1st ` A ) + 1 ) ,
                     ( ( 2nd ` A ) S ( F ` ( ( 1st ` A ) + 1 ) ) ) >. $=
      cA cH cfv cA vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st
      cfv c1 caddc co cF cfv cS co cop wceq vz vw copab cfv cA c1st cfv c1
      caddc co cA c2nd cfv cA c1st cfv c1 caddc co cF cfv cS co cop cA cH vw cv
      vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF
      cfv cS co cop wceq vz vw copab seq1rval.1 fveq1i vz vw cA vz cv c1st cfv
      c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co cop cA
      c1st cfv c1 caddc co cA c2nd cfv cA c1st cfv c1 caddc co cF cfv cS co cop
      seq1rval.2 cA c1st cfv c1 caddc co cA c2nd cfv cA c1st cfv c1 caddc co cF
      cfv cS co opex vz cv cA wceq vz cv c1st cfv c1 caddc co cA c1st cfv c1
      caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co cA c2nd
      cfv cA c1st cfv c1 caddc co cF cfv cS co vz cv cA wceq vz cv c1st cfv cA
      c1st cfv c1 caddc vz cv cA c1st fveq2 opreq1d vz cv cA wceq vz cv c2nd
      cfv cA c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cA c1st cfv c1 caddc co
      cF cfv cS vz cv cA c2nd fveq2 vz cv cA wceq vz cv c1st cfv c1 caddc co cA
      c1st cfv c1 caddc co cF vz cv cA wceq vz cv c1st cfv cA c1st cfv c1 caddc
      vz cv cA c1st fveq2 opreq1d fveq2d opreq12d opeq12d fvopab eqtri $.
      $( [17-Oct-2004] $) $( [5-Oct-2004] $)
  $}

  ${
    $d x y A $.  $d x y f g h G $.  $d x y f g h H $.  $d x y z w f g h F $.
    $d x y z w f g h S $.
    seq1val.1 $e |- S e. _V $.
    seq1val.2 $e |- F e. _V $.
    seq1val.3 $e |- G =
                     ( rec ( { <. z , w >. | w = ( z + 1 ) } , 1 ) |` om ) $.
    seq1val.4 $e |- H = { <. z , w >. | w = <. ( ( 1st ` z ) + 1 ) ,
                     ( ( 2nd ` z ) S ( F ` ( ( 1st ` z ) + 1 ) ) ) >. } $.
    $( Value of the recursive sequence builder operation. $)
    seq1val $p |- ( S seq1 F ) = { <. x , y >. | ( x e. NN /\ y =
        ( 2nd ` ( ( rec ( H , <. 1 , ( F ` 1 ) >. ) o. `' G ) ` x ) ) ) } $=
      cS cvv wcel cF cvv wcel cS cF cseq1 co vx cv cn wcel vy cv vx cv cH c1 c1
      cF cfv cop crdg cG ccnv ccom cfv c2nd cfv wceq wa vx vy copab wceq
      seq1val.1 seq1val.2 vf vg vh cS cF cvv cvv vx cv cn wcel vy cv vx cv vw
      cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co
      vg cv cfv vf cv co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz
      cv c1 caddc co wceq vz vw copab c1 crdg com cres ccnv ccom cfv c2nd cfv
      wceq wa vx vy copab vx cv cn wcel vy cv vx cv cH c1 c1 cF cfv cop crdg cG
      ccnv ccom cfv c2nd cfv wceq wa vx vy copab cseq1 vx cv cn wcel vy cv vx
      cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cG
      ccnv ccom cfv c2nd cfv wceq wa vx vy copab vx vy cn vx cv cH c1 c1 cF cfv
      cop crdg cG ccnv ccom cfv c2nd cfv nnex opabex2 vf cv cS wceq vx cv cn
      wcel vy cv vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv
      c1st cfv c1 caddc co vg cv cfv vf cv co cop wceq vz vw copab c1 c1 vg cv
      cfv cop crdg vw cv vz cv c1 caddc co wceq vz vw copab c1 crdg com cres
      ccnv ccom cfv c2nd cfv wceq wa vx cv cn wcel vy cv vx cv vw cv vz cv c1st
      cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co
      cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cG ccnv ccom cfv c2nd cfv
      wceq wa vx vy vf cv cS wceq vy cv vx cv vw cv vz cv c1st cfv c1 caddc co
      vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv vf cv co cop wceq vz
      vw copab c1 c1 vg cv cfv cop crdg vw cv vz cv c1 caddc co wceq vz vw
      copab c1 crdg com cres ccnv ccom cfv c2nd cfv wceq vy cv vx cv vw cv vz
      cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv
      cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cG ccnv ccom cfv
      c2nd cfv wceq vx cv cn wcel vf cv cS wceq vx cv vw cv vz cv c1st cfv c1
      caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv vf cv co cop
      wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz cv c1 caddc co wceq vz
      vw copab c1 crdg com cres ccnv ccom cfv c2nd cfv vx cv vw cv vz cv c1st
      cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co
      cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cG ccnv ccom cfv c2nd cfv
      vy cv vf cv cS wceq vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv
      vz cv c1st cfv c1 caddc co vg cv cfv vf cv co cop wceq vz vw copab c1 c1
      vg cv cfv cop crdg vw cv vz cv c1 caddc co wceq vz vw copab c1 crdg com
      cres ccnv ccom cfv vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv
      vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg
      cv cfv cop crdg cG ccnv ccom cfv c2nd vf cv cS wceq vx cv vw cv vz cv
      c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv
      vf cv co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz cv c1
      caddc co wceq vz vw copab c1 crdg com cres ccnv ccom vw cv vz cv c1st cfv
      c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop
      wceq vz vw copab c1 c1 vg cv cfv cop crdg cG ccnv ccom vf cv cS wceq vw
      cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co
      vg cv cfv vf cv co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz
      cv c1 caddc co wceq vz vw copab c1 crdg com cres ccnv ccom vw cv vz cv
      c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv
      cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz cv c1 caddc
      co wceq vz vw copab c1 crdg com cres ccnv ccom vw cv vz cv c1st cfv c1
      caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop
      wceq vz vw copab c1 c1 vg cv cfv cop crdg cG ccnv ccom vf cv cS wceq vw
      cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co
      vg cv cfv vf cv co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz
      cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv
      cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv vz cv c1
      caddc co wceq vz vw copab c1 crdg com cres ccnv vf cv cS wceq vw cv vz cv
      c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv
      vf cv co cop wceq vz vw copab vw cv vz cv c1st cfv c1 caddc co vz cv c2nd
      cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab wceq
      vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc
      co vg cv cfv vf cv co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg vw cv
      vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg
      cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg wceq vf cv cS
      wceq vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv vf cv co cop wceq vw cv vz cv c1st cfv c1 caddc co vz
      cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz vw vf
      cv cS wceq vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv vf cv co cop vz cv c1st cfv c1 caddc co vz cv c2nd cfv
      vz cv c1st cfv c1 caddc co vg cv cfv cS co cop vw cv vf cv cS wceq vz cv
      c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv vf cv co vz cv c2nd cfv vz
      cv c1st cfv c1 caddc co vg cv cfv cS co vz cv c1st cfv c1 caddc co vz cv
      c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv vf cv cS opreq opeq2d
      eqeq2d opabbidv c1 c1 vg cv cfv cop vw cv vz cv c1st cfv c1 caddc co vz
      cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv vf cv co cop wceq vz vw
      copab vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv cS co cop wceq vz vw copab rdgeq1 syl coeq1d cG ccnv
      vw cv vz cv c1 caddc co wceq vz vw copab c1 crdg com cres ccnv vw cv vz
      cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv
      cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cG vw cv vz cv c1
      caddc co wceq vz vw copab c1 crdg com cres seq1val.3 cnveqi coeq2i
      syl6eqr fveq1d fveq2d eqeq2d anbi2d opabbidv vg cv cF wceq vx cv cn wcel
      vy cv vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st
      cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop
      crdg cG ccnv ccom cfv c2nd cfv wceq wa vx cv cn wcel vy cv vx cv cH c1 c1
      cF cfv cop crdg cG ccnv ccom cfv c2nd cfv wceq wa vx vy vg cv cF wceq vy
      cv vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv
      c1 caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg
      cG ccnv ccom cfv c2nd cfv wceq vy cv vx cv cH c1 c1 cF cfv cop crdg cG
      ccnv ccom cfv c2nd cfv wceq vx cv cn wcel vg cv cF wceq vx cv vw cv vz cv
      c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv
      cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cG ccnv ccom cfv c2nd
      cfv vx cv cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv vy cv vg cv
      cF wceq vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st
      cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop
      crdg cG ccnv ccom cfv vx cv cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv
      c2nd vg cv cF wceq vx cv vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv
      vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg
      cv cfv cop crdg cG ccnv ccom cH c1 c1 cF cfv cop crdg cG ccnv ccom vg cv
      cF wceq vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cH
      c1 c1 cF cfv cop crdg cG ccnv vg cv cF wceq vw cv vz cv c1st cfv c1 caddc
      co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz
      vw copab c1 c1 vg cv cfv cop crdg cH c1 c1 vg cv cfv cop crdg cH c1 c1 cF
      cfv cop crdg vg cv cF wceq vw cv vz cv c1st cfv c1 caddc co vz cv c2nd
      cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab cH
      wceq vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv cS co cop wceq vz vw copab c1 c1 vg cv cfv cop crdg cH
      c1 c1 vg cv cfv cop crdg wceq vg cv cF wceq vw cv vz cv c1st cfv c1 caddc
      co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz
      vw copab vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv
      c1 caddc co cF cfv cS co cop wceq vz vw copab cH vg cv cF wceq vw cv vz
      cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv
      cfv cS co cop wceq vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv
      c1st cfv c1 caddc co cF cfv cS co cop wceq vz vw vg cv cF wceq vz cv c1st
      cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co
      cop vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co
      cF cfv cS co cop vw cv vg cv cF wceq vz cv c2nd cfv vz cv c1st cfv c1
      caddc co vg cv cfv cS co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv
      cS co vz cv c1st cfv c1 caddc co vg cv cF wceq vz cv c1st cfv c1 caddc co
      vg cv cfv vz cv c1st cfv c1 caddc co cF cfv vz cv c2nd cfv cS vz cv c1st
      cfv c1 caddc co vg cv cF fveq1 opreq2d opeq2d eqeq2d opabbidv seq1val.4
      syl6eqr c1 c1 vg cv cfv cop vw cv vz cv c1st cfv c1 caddc co vz cv c2nd
      cfv vz cv c1st cfv c1 caddc co vg cv cfv cS co cop wceq vz vw copab cH
      rdgeq1 syl vg cv cF wceq c1 vg cv cfv c1 cF cfv wceq c1 c1 vg cv cfv cop
      c1 c1 cF cfv cop wceq cH c1 c1 vg cv cfv cop crdg cH c1 c1 cF cfv cop
      crdg wceq c1 vg cv cF fveq1 c1 vg cv cfv c1 cF cfv c1 opeq2 c1 c1 vg cv
      cfv cop c1 c1 cF cfv cop cH rdgeq2 3syl eqtrd coeq1d fveq1d fveq2d eqeq2d
      anbi2d opabbidv vx vy vz vw vf vg vh df-seq1 oprabval5 mp2an $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)

    $( Lemma for ~ seq1fn . $)
    seq1fnlem $p |- ( S seq1 F ) Fn NN $=
      vx vy cn vx cv cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv cS cF
      cseq1 co vx cv cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd fvex vx vy
      vz vw cS cF cG cH seq1val.1 seq1val.2 seq1val.3 seq1val.4 seq1val fnopab2
      $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)

    $( Value of the value of the recursive sequence builder operation. $)
    seq1val2 $p |- ( A e. NN -> ( ( S seq1 F ) ` A ) =
          ( 2nd ` ( ( rec ( H , <. 1 , ( F ` 1 ) >. ) o. `' G ) ` A ) ) ) $=
      vx vy cA vx cv cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv cA cH
      c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv cn cS cF cseq1 co vx cv
      cA wceq vx cv cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv cA cH c1 c1 cF
      cfv cop crdg cG ccnv ccom cfv c2nd vx cv cA cH c1 c1 cF cfv cop crdg cG
      ccnv ccom fveq2 fveq2d vx vy vz vw cS cF cG cH seq1val.1 seq1val.2
      seq1val.3 seq1val.4 seq1val cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv
      c2nd fvex fvopab4 $.
      $( [17-Oct-2004] $) $( [5-Oct-2004] $)

    $( Lemma for ~ seq11 . $)
    seq11lem $p |- ( ( S seq1 F ) ` 1 ) = ( F ` 1 ) $=
      c1 cS cF cseq1 co cfv c1 cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd
      cfv c1 c1 cF cfv cop c2nd cfv c1 cF cfv c1 cn wcel c1 cS cF cseq1 co cfv
      c1 cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv wceq 1nn vz vw c1
      cS cF cG cH seq1val.1 seq1val.2 seq1val.3 seq1val.4 seq1val2 ax-mp c1 cH
      c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1 c1 cF cfv cop c2nd c1 c1 cF cfv
      cop cvv wcel c1 cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1 c1 cF cfv
      cop wceq c1 c1 cF cfv opex vz vw c1 c1 cF cfv cop cvv c1 cH cG 1z
      seq1val.3 uzrdginii ax-mp fveq2i c1 c1 cF cfv c1 cn 1nn elisseti c1 cF
      fvex op2nd 3eqtri $.
      $( [17-Oct-2004] $) $( [5-Oct-2004] $)

    $( Lemma for ~ seq1p1 . $)
    seq1suclem $p |- ( A e. NN -> ( ( S seq1 F ) ` ( A + 1 ) ) =
                ( ( ( S seq1 F ) ` A ) S ( F ` ( A + 1 ) ) ) ) $=
      cA cn wcel cA c1 caddc co cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd
      cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv cA c1 caddc co
      cF cfv cS co cA c1 caddc co cS cF cseq1 co cfv cA cS cF cseq1 co cfv cA
      c1 caddc co cF cfv cS co cA cn wcel cA c1 caddc co cH c1 c1 cF cfv cop
      crdg cG ccnv ccom cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv c1
      caddc co cF cfv cS co cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd
      cfv cA c1 caddc co cF cfv cS co cA cn wcel cA c1 caddc co cH c1 c1 cF cfv
      cop crdg cG ccnv ccom cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv c1st cfv c1 caddc co cA cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv c1
      caddc co cF cfv cS co cop c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv
      c1 caddc co cF cfv cS co cA cn wcel cA c1 caddc co cH c1 c1 cF cfv cop
      crdg cG ccnv ccom cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st
      cfv c1 caddc co cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv cA
      cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co cF cfv cS
      co cop c2nd cA cn wcel cA c1 caddc co cH c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv cH cfv cA cH c1 c1
      cF cfv cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co cA cH c1 c1 cF cfv
      cop crdg cG ccnv ccom cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv c1st cfv c1 caddc co cF cfv cS co cop cA cn wcel cA c1 vx cv cle
      wbr vx cz crab wcel cA c1 caddc co cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv cH cfv wceq cn c1 vx cv
      cle wbr vx cz crab cA vx nnzrab eleq2i vz vw vx c1 c1 cF cfv cop cA c1 cH
      cG 1z seq1val.3 uzrdgsuci sylbi vx vy cA cH c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv cS cF cH cH vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz
      cv c1st cfv c1 caddc co cF cfv cS co cop wceq vz vw copab vy cv vx cv
      c1st cfv c1 caddc co vx cv c2nd cfv vx cv c1st cfv c1 caddc co cF cfv cS
      co cop wceq vx vy copab seq1val.4 vy cv vx cv c1st cfv c1 caddc co vx cv
      c2nd cfv vx cv c1st cfv c1 caddc co cF cfv cS co cop wceq vw cv vz cv
      c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS
      co cop wceq vx vy vz vw vx cv vz cv wceq vy cv vx cv c1st cfv c1 caddc co
      vx cv c2nd cfv vx cv c1st cfv c1 caddc co cF cfv cS co cop wceq vy cv vz
      cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv
      cS co cop wceq vy cv vw cv wceq vw cv vz cv c1st cfv c1 caddc co vz cv
      c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co cop wceq vx cv vz cv
      wceq vx cv c1st cfv c1 caddc co vx cv c2nd cfv vx cv c1st cfv c1 caddc co
      cF cfv cS co cop vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv
      c1 caddc co cF cfv cS co cop vy cv vx cv vz cv wceq vx cv c1st cfv c1
      caddc co vz cv c1st cfv c1 caddc co vx cv c2nd cfv vx cv c1st cfv c1
      caddc co cF cfv cS co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS
      co vx cv vz cv wceq vx cv c1st cfv vz cv c1st cfv c1 caddc vx cv vz cv
      c1st fveq2 opreq1d vx cv vz cv wceq vx cv c2nd cfv vz cv c2nd cfv vx cv
      c1st cfv c1 caddc co cF cfv vz cv c1st cfv c1 caddc co cF cfv cS vx cv vz
      cv c2nd fveq2 vx cv vz cv wceq vx cv c1st cfv c1 caddc co vz cv c1st cfv
      c1 caddc co cF vx cv vz cv wceq vx cv c1st cfv vz cv c1st cfv c1 caddc vx
      cv vz cv c1st fveq2 opreq1d fveq2d opreq12d opeq12d eqeq2d vy cv vw cv vz
      cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv
      cS co cop eqeq1 sylan9bb cbvopabv eqtr4i cA cH c1 c1 cF cfv cop crdg cG
      ccnv ccom fvex seq1rval syl6eq fveq2d cA cH c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv c1st cfv c1 caddc co cA cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv c2nd cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv c1
      caddc co cF cfv cS co cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st
      cfv c1 caddc oprex cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv
      cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv c1 caddc co cF cfv
      cS oprex op2nd syl6eq cA cn wcel cA cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv c1st cfv c1 caddc co cF cfv cA c1 caddc co cF cfv cA cH c1 c1 cF cfv
      cop crdg cG ccnv ccom cfv c2nd cfv cS cA cn wcel cA cH c1 c1 cF cfv cop
      crdg cG ccnv ccom cfv c1st cfv c1 caddc co cA c1 caddc co cF cA cn wcel
      cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st cfv cA c1 caddc cA cn
      wcel cA vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co cF cfv cS co cop wceq vz vw copab c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv c1st cfv cA cA cH c1 c1 cF cfv cop crdg cG ccnv ccom cfv c1st
      cfv vz vw vz vw cA vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co
      c1 cF cfv cG seq1val.3 seq1lem1 cA cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv cA vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co cF cfv cS co cop wceq vz vw copab c1 c1 cF cfv cop crdg cG ccnv
      ccom cfv c1st cA cH c1 c1 cF cfv cop crdg cG ccnv ccom vw cv vz cv c1st
      cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co
      cop wceq vz vw copab c1 c1 cF cfv cop crdg cG ccnv ccom cH c1 c1 cF cfv
      cop crdg vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv
      c1 caddc co cF cfv cS co cop wceq vz vw copab c1 c1 cF cfv cop crdg cG
      ccnv cH vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1
      caddc co cF cfv cS co cop wceq vz vw copab wceq cH c1 c1 cF cfv cop crdg
      vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc
      co cF cfv cS co cop wceq vz vw copab c1 c1 cF cfv cop crdg wceq seq1val.4
      c1 c1 cF cfv cop cH vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv
      c1st cfv c1 caddc co cF cfv cS co cop wceq vz vw copab rdgeq1 ax-mp
      coeq1i fveq1i fveq2i syl5eq opreq1d fveq2d opreq2d eqtrd cA cn wcel cA c1
      caddc co cn wcel cA c1 caddc co cS cF cseq1 co cfv cA c1 caddc co cH c1
      c1 cF cfv cop crdg cG ccnv ccom cfv c2nd cfv wceq cA peano2nn vz vw cA c1
      caddc co cS cF cG cH seq1val.1 seq1val.2 seq1val.3 seq1val.4 seq1val2 syl
      cA cn wcel cA cS cF cseq1 co cfv cA cH c1 c1 cF cfv cop crdg cG ccnv ccom
      cfv c2nd cfv cA c1 caddc co cF cfv cS vz vw cA cS cF cG cH seq1val.1
      seq1val.2 seq1val.3 seq1val.4 seq1val2 opreq1d 3eqtr4d $.
      $( [17-Oct-2004] $) $( [5-Oct-2004] $)
  $}

  ${
    $d x y z w v S $.  $d x y z w v F $.  $d x y z w v C $.  $d x y z w v D $.
    seq111.1 $e |- S e. _V $.
    seq111.2 $e |- F e. _V $.
    $( Value of the recursive sequence builder at 1.  See description in
       ~ df-seq1 . $)
    seq11 $p |- ( ( S seq1 F ) ` 1 ) = ( F ` 1 ) $=
      vz vw cS cF vw cv vz cv c1 caddc co wceq vz vw copab c1 crdg com cres vw
      cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co
      cF cfv cS co cop wceq vz vw copab seq111.1 seq111.2 vw cv vz cv c1 caddc
      co wceq vz vw copab c1 crdg com cres eqid vw cv vz cv c1st cfv c1 caddc
      co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co cop wceq vz vw
      copab eqid seq11lem $.
      $( [17-Oct-2004] $) $( [5-Oct-2004] $)

    $( Value of the recursive sequence builder at a successor.  See description
       in ~ df-seq1 . $)
    seq1p1 $p |- ( A e. NN -> ( ( S seq1 F ) ` ( A + 1 ) ) =
                ( ( ( S seq1 F ) ` A ) S ( F ` ( A + 1 ) ) ) ) $=
      vz vw cA cS cF vw cv vz cv c1 caddc co wceq vz vw copab c1 crdg com cres
      vw cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc
      co cF cfv cS co cop wceq vz vw copab seq111.1 seq111.2 vw cv vz cv c1
      caddc co wceq vz vw copab c1 crdg com cres eqid vw cv vz cv c1st cfv c1
      caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co cop wceq
      vz vw copab eqid seq1suclem $.
      $( [17-Oct-2004] $) $( [5-Oct-2004] $)

    $( Value of the recursive sequence builder in terms of its previous
       value. $)
    seq1m1 $p |- ( ( N e. NN /\ 1 < N ) -> ( ( S seq1 F ) ` N ) =
                ( ( ( S seq1 F ) ` ( N - 1 ) ) S ( F ` N ) ) ) $=
      cN cn wcel c1 cN clt wbr wa cN c1 cmin co c1 caddc co cS cF cseq1 co cfv
      cN c1 cmin co cS cF cseq1 co cfv cN c1 cmin co c1 caddc co cF cfv cS co
      cN cS cF cseq1 co cfv cN c1 cmin co cS cF cseq1 co cfv cN cF cfv cS co cN
      cn wcel c1 cN clt wbr wa cN c1 cmin co cn wcel cN c1 cmin co c1 caddc co
      cS cF cseq1 co cfv cN c1 cmin co cS cF cseq1 co cfv cN c1 cmin co c1
      caddc co cF cfv cS co wceq cN cn wcel c1 cN clt wbr cN c1 cmin co cn wcel
      c1 cn wcel cN cn wcel c1 cN clt wbr cN c1 cmin co cn wcel wb 1nn c1 cN
      nnsub mpan biimpa cN c1 cmin co cS cF seq111.1 seq111.2 seq1p1 syl cN cn
      wcel cN c1 cmin co c1 caddc co cS cF cseq1 co cfv cN cS cF cseq1 co cfv
      wceq c1 cN clt wbr cN cn wcel cN c1 cmin co c1 caddc co cN cS cF cseq1 co
      cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN cn wcel cN c1
      npcan cN nncn ax1cn sylancl fveq2d adantr cN cn wcel cN c1 cmin co cS cF
      cseq1 co cfv cN c1 cmin co c1 caddc co cF cfv cS co cN c1 cmin co cS cF
      cseq1 co cfv cN cF cfv cS co wceq c1 cN clt wbr cN cn wcel cN c1 cmin co
      c1 caddc co cF cfv cN cF cfv cN c1 cmin co cS cF cseq1 co cfv cS cN cn
      wcel cN c1 cmin co c1 caddc co cN cF cN cc wcel c1 cc wcel cN c1 cmin co
      c1 caddc co cN wceq cN cn wcel cN c1 npcan cN nncn ax1cn sylancl fveq2d
      opreq2d adantr 3eqtr3d $.
      $( [18-Aug-2005] $) $( [14-Aug-2005] $)

    $( Functionality and domain of the recursive sequence builder. $)
    seq1fn $p |- ( S seq1 F ) Fn NN $=
      vz vw cS cF vw cv vz cv c1 caddc co wceq vz vw copab c1 crdg com cres vw
      cv vz cv c1st cfv c1 caddc co vz cv c2nd cfv vz cv c1st cfv c1 caddc co
      cF cfv cS co cop wceq vz vw copab seq111.1 seq111.2 vw cv vz cv c1 caddc
      co wceq vz vw copab c1 crdg com cres eqid vw cv vz cv c1st cfv c1 caddc
      co vz cv c2nd cfv vz cv c1st cfv c1 caddc co cF cfv cS co cop wceq vz vw
      copab eqid seq1fnlem $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)

    $( Range of the recursive sequence builder. $)
    seq1rn2 $p |- ( ( ( F ` 1 ) e. C /\
               ( F |` ( NN \ { 1 } ) ) : ( NN \ { 1 } ) --> D /\
               S : ( C X. D ) --> C ) -> ran ( S seq1 F ) C_ C ) $=
      cS cF cseq1 co cn wfn vx cv cS cF cseq1 co cfv cC wcel vx cn wral cS cF
      cseq1 co crn cC wss c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif
      cres wf cC cD cxp cC cS wf w3a vx cn cC cS cF cseq1 co fnfvrnss cS cF
      seq111.1 seq111.2 seq1fn c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn
      cdif cres wf cC cD cxp cC cS wf w3a vx cv cS cF cseq1 co cfv cC wcel vx
      cn vx cv cn wcel c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif
      cres wf cC cD cxp cC cS wf w3a vx cv cS cF cseq1 co cfv cC wcel c1 cF cfv
      cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf
      w3a vy cv cS cF cseq1 co cfv cC wcel wi c1 cF cfv cC wcel cn c1 csn cdif
      cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf w3a c1 cS cF cseq1 co cfv
      cC wcel wi c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf
      cC cD cxp cC cS wf w3a vz cv cS cF cseq1 co cfv cC wcel wi c1 cF cfv cC
      wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf w3a
      vz cv c1 caddc co cS cF cseq1 co cfv cC wcel wi c1 cF cfv cC wcel cn c1
      csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf w3a vx cv cS cF
      cseq1 co cfv cC wcel wi vy vz vx cv vy cv c1 wceq vy cv cS cF cseq1 co
      cfv cC wcel c1 cS cF cseq1 co cfv cC wcel c1 cF cfv cC wcel cn c1 csn
      cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf w3a vy cv c1 wceq vy
      cv cS cF cseq1 co cfv c1 cS cF cseq1 co cfv cC vy cv c1 cS cF cseq1 co
      fveq2 eleq1d imbi2d vy cv vz cv wceq vy cv cS cF cseq1 co cfv cC wcel vz
      cv cS cF cseq1 co cfv cC wcel c1 cF cfv cC wcel cn c1 csn cdif cD cF cn
      c1 csn cdif cres wf cC cD cxp cC cS wf w3a vy cv vz cv wceq vy cv cS cF
      cseq1 co cfv vz cv cS cF cseq1 co cfv cC vy cv vz cv cS cF cseq1 co fveq2
      eleq1d imbi2d vy cv vz cv c1 caddc co wceq vy cv cS cF cseq1 co cfv cC
      wcel vz cv c1 caddc co cS cF cseq1 co cfv cC wcel c1 cF cfv cC wcel cn c1
      csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf w3a vy cv vz cv
      c1 caddc co wceq vy cv cS cF cseq1 co cfv vz cv c1 caddc co cS cF cseq1
      co cfv cC vy cv vz cv c1 caddc co cS cF cseq1 co fveq2 eleq1d imbi2d vy
      cv vx cv wceq vy cv cS cF cseq1 co cfv cC wcel vx cv cS cF cseq1 co cfv
      cC wcel c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf cC
      cD cxp cC cS wf w3a vy cv vx cv wceq vy cv cS cF cseq1 co cfv vx cv cS cF
      cseq1 co cfv cC vy cv vx cv cS cF cseq1 co fveq2 eleq1d imbi2d c1 cF cfv
      cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf c1 cS cF cseq1 co cfv
      cC wcel cC cD cxp cC cS wf c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1
      csn cdif cres wf wa c1 cF cfv cC c1 cS cF cseq1 co cfv c1 cF cfv cC wcel
      cn c1 csn cdif cD cF cn c1 csn cdif cres wf pm3.26 cS cF seq111.1
      seq111.2 seq11 syl5eqel 3adant3 vz cv cn wcel c1 cF cfv cC wcel cn c1 csn
      cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS wf w3a vz cv cS cF
      cseq1 co cfv cC wcel vz cv c1 caddc co cS cF cseq1 co cfv cC wcel c1 cF
      cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS
      wf w3a vz cv cn wcel vz cv cS cF cseq1 co cfv cC wcel vz cv c1 caddc co
      cS cF cseq1 co cfv cC wcel wi cn c1 csn cdif cD cF cn c1 csn cdif cres wf
      cC cD cxp cC cS wf vz cv cn wcel vz cv cS cF cseq1 co cfv cC wcel vz cv
      c1 caddc co cS cF cseq1 co cfv cC wcel wi wi c1 cF cfv cC wcel cC cD cxp
      cC cS wf cn c1 csn cdif cD cF cn c1 csn cdif cres wf vz cv cn wcel vz cv
      cS cF cseq1 co cfv cC wcel vz cv c1 caddc co cS cF cseq1 co cfv cC wcel
      wi wi cn c1 csn cdif cD cF cn c1 csn cdif cres wf vz cv cn wcel vz cv cS
      cF cseq1 co cfv cC wcel cC cD cxp cC cS wf vz cv c1 caddc co cS cF cseq1
      co cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf vz cv cn wcel
      vz cv cS cF cseq1 co cfv cC wcel cC cD cxp cC cS wf vz cv c1 caddc co cS
      cF cseq1 co cfv cC wcel wi wi cn c1 csn cdif cD cF cn c1 csn cdif cres wf
      vz cv cn wcel wa vz cv c1 caddc co cF cfv cD wcel vz cv cS cF cseq1 co
      cfv cC wcel cC cD cxp cC cS wf vz cv c1 caddc co cS cF cseq1 co cfv cC
      wcel wi wi cn c1 csn cdif cD cF cn c1 csn cdif cres wf vz cv c1 caddc co
      cn c1 csn cdif wcel vz cv c1 caddc co cF cfv cD wcel vz cv cn wcel cn c1
      csn cdif cD cF cn c1 csn cdif cres wf vz cv c1 caddc co cn c1 csn cdif
      wcel wa vz cv c1 caddc co cF cn c1 csn cdif cres cfv cD wcel vz cv c1
      caddc co cF cfv cD wcel cn c1 csn cdif cD vz cv c1 caddc co cF cn c1 csn
      cdif cres ffvelrn vz cv c1 caddc co cn c1 csn cdif wcel vz cv c1 caddc co
      cF cn c1 csn cdif cres cfv cD wcel vz cv c1 caddc co cF cfv cD wcel wb cn
      c1 csn cdif cD cF cn c1 csn cdif cres wf vz cv c1 caddc co cn c1 csn cdif
      wcel vz cv c1 caddc co cF cn c1 csn cdif cres cfv vz cv c1 caddc co cF
      cfv cD vz cv c1 caddc co cn c1 csn cdif cF fvres eleq1d adantl mpbid vz
      cv seq1lem2 sylan2 vz cv cn wcel vz cv c1 caddc co cF cfv cD wcel vz cv
      cS cF cseq1 co cfv cC wcel cC cD cxp cC cS wf vz cv c1 caddc co cS cF
      cseq1 co cfv cC wcel wi wi wi cn c1 csn cdif cD cF cn c1 csn cdif cres wf
      vz cv cn wcel vz cv c1 caddc co cF cfv cD wcel vz cv cS cF cseq1 co cfv
      cC wcel cC cD cxp cC cS wf vz cv c1 caddc co cS cF cseq1 co cfv cC wcel
      vz cv cn wcel vz cv c1 caddc co cS cF cseq1 co cfv cC wcel vz cv cS cF
      cseq1 co cfv vz cv c1 caddc co cF cfv cS co cC wcel vz cv c1 caddc co cF
      cfv cD wcel vz cv cS cF cseq1 co cfv cC wcel wa cC cD cxp cC cS wf wa vz
      cv cn wcel vz cv c1 caddc co cS cF cseq1 co cfv vz cv cS cF cseq1 co cfv
      vz cv c1 caddc co cF cfv cS co cC vz cv cS cF seq111.1 seq111.2 seq1p1
      eleq1d vz cv c1 caddc co cF cfv cD wcel vz cv cS cF cseq1 co cfv cC wcel
      wa cC cD cxp cC cS wf vz cv cS cF cseq1 co cfv vz cv c1 caddc co cF cfv
      cS co cC wcel vz cv c1 caddc co cF cfv cD wcel vz cv cS cF cseq1 co cfv
      cC wcel wa vw cv vv cv cS co cC wcel vv cD wral vw cC wral vz cv cS cF
      cseq1 co cfv vz cv c1 caddc co cF cfv cS co cC wcel cC cD cxp cC cS wf vz
      cv cS cF cseq1 co cfv cC wcel vz cv c1 caddc co cF cfv cD wcel vw cv vv
      cv cS co cC wcel vv cD wral vw cC wral vz cv cS cF cseq1 co cfv vz cv c1
      caddc co cF cfv cS co cC wcel wi vw cv vv cv cS co cC wcel vz cv cS cF
      cseq1 co cfv vz cv c1 caddc co cF cfv cS co cC wcel vz cv cS cF cseq1 co
      cfv vv cv cS co cC wcel vw vv vz cv cS cF cseq1 co cfv vz cv c1 caddc co
      cF cfv cC cD vw cv vz cv cS cF cseq1 co cfv wceq vw cv vv cv cS co vz cv
      cS cF cseq1 co cfv vv cv cS co cC vw cv vz cv cS cF cseq1 co cfv vv cv cS
      opreq1 eleq1d vv cv vz cv c1 caddc co cF cfv wceq vz cv cS cF cseq1 co
      cfv vv cv cS co vz cv cS cF cseq1 co cfv vz cv c1 caddc co cF cfv cS co
      cC vv cv vz cv c1 caddc co cF cfv vz cv cS cF cseq1 co cfv cS opreq2
      eleq1d rcla42v ancoms cC cD cxp cC cS wf cS cC cD cxp wfn vw cv vv cv cS
      co cC wcel vv cD wral vw cC wral vw vv cC cD cC cS ffnoprv pm3.27bi syl5
      imp syl5bir exp4c adantl mpd ex com4r impcom 3adant1 com12 a2d nnind
      com12 r19.21aiv sylancr $.
      $( [17-Oct-2004] $) $( [8-Oct-2004] $)

    $( Range of the recursive sequence builder (special case of
       ~ seq1rn2 ). $)
    seq1rn $p |- ( ( F : NN --> C /\ S : ( C X. C ) --> C ) ->
                 ran ( S seq1 F ) C_ C ) $=
      c1 cF cfv cC wcel cn c1 csn cdif cC cF cn c1 csn cdif cres wf wa cC cC
      cxp cC cS wf cS cF cseq1 co crn cC wss cn cC cF wf c1 cF cfv cC wcel cn
      c1 csn cdif cC cF cn c1 csn cdif cres wf cC cC cxp cC cS wf cS cF cseq1
      co crn cC wss cC cC cS cF seq111.1 seq111.2 seq1rn2 3expa cn cC cF wf c1
      cF cfv cC wcel cn c1 csn cdif cC cF cn c1 csn cdif cres wf cn cC cF wf c1
      cn wcel c1 cF cfv cC wcel 1nn cn cC c1 cF ffvelrn mpan2 cn cC cF wf cn c1
      csn cdif cn wss cn c1 csn cdif cC cF cn c1 csn cdif cres wf cn c1 csn
      difss cn cC cn c1 csn cdif cF fssres mpan2 jca sylan $.
      $( [9-Nov-2004] $) $( [8-Oct-2004] $)

    $( Mapping of the 1-based recursive sequence builder. $)
    seq1f $p |- ( ( F : NN --> C /\ S : ( C X. C ) --> C ) ->
                 ( S seq1 F ) : NN --> C ) $=
      cn cC cF wf cC cC cxp cC cS wf wa cS cF cseq1 co cn wfn cS cF cseq1 co
      crn cC wss wa cn cC cS cF cseq1 co wf cn cC cF wf cC cC cxp cC cS wf wa
      cS cF cseq1 co crn cC wss cS cF cseq1 co cn wfn cC cS cF seq111.1
      seq111.2 seq1rn cS cF seq111.1 seq111.2 seq1fn jctil cn cC cS cF cseq1 co
      df-f sylibr $.
      $( [18-Aug-2006] $) $( [17-Aug-2006] $)

    $( Mapping of the 1-based recursive sequence builder. $)
    seq1f2 $p |- ( ( ( F ` 1 ) e. C /\
               ( F |` ( NN \ { 1 } ) ) : ( NN \ { 1 } ) --> D /\
               S : ( C X. D ) --> C ) -> ( S seq1 F ) : NN --> C ) $=
      c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp
      cC cS wf w3a cS cF cseq1 co cn wfn cS cF cseq1 co crn cC wss wa cn cC cS
      cF cseq1 co wf c1 cF cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres
      wf cC cD cxp cC cS wf w3a cS cF cseq1 co crn cC wss cS cF cseq1 co cn wfn
      cC cD cS cF seq111.1 seq111.2 seq1rn2 cS cF seq111.1 seq111.2 seq1fn
      jctil cn cC cS cF cseq1 co df-f sylibr $.
      $( [10-Oct-2007] $) $( [23-Sep-2007] $)

    $( Closure of the value of the recursive sequence builder. $)
    seq1cl $p |- ( ( A e. NN /\ F : NN --> C /\ S : ( C X. C ) --> C ) ->
                 ( ( S seq1 F ) ` A ) e. C ) $=
      cn cC cF wf cC cC cxp cC cS wf cA cn wcel cA cS cF cseq1 co cfv cC wcel
      cn cC cF wf cC cC cxp cC cS wf cA cn wcel cA cS cF cseq1 co cfv cC wcel
      cn cC cS cF cseq1 co wf cA cn wcel cA cS cF cseq1 co cfv cC wcel cn cC cF
      wf cC cC cxp cC cS wf wa cn cC cA cS cF cseq1 co ffvelrn cC cS cF
      seq111.1 seq111.2 seq1f sylan 3impa 3comr $.
      $( [8-Mar-2005] $) $( [7-Mar-2005] $)

    $( Closure of the value of the recursive sequence builder. $)
    seq1cl2 $p |- ( ( ( ( F ` 1 ) e. C /\
               ( F |` ( NN \ { 1 } ) ) : ( NN \ { 1 } ) --> D /\
          S : ( C X. D ) --> C ) /\ A e. NN ) -> ( ( S seq1 F ) ` A ) e. C ) $=
      cn cC cS cF cseq1 co wf cA cn wcel cA cS cF cseq1 co cfv cC wcel c1 cF
      cfv cC wcel cn c1 csn cdif cD cF cn c1 csn cdif cres wf cC cD cxp cC cS
      wf w3a cn cC cA cS cF cseq1 co ffvelrn cC cD cS cF seq111.1 seq111.2
      seq1f2 sylan $.
      $( [11-Oct-2007] $) $( [23-Sep-2007] $)

    $( Restricting its characteristic function to ` NN ` does not affect the
       ` seq1 ` function. $)
    seq1res $p |- ( S seq1 ( F |` NN ) ) = ( S seq1 F ) $=
      cS cF cn cres cseq1 co cS cF cseq1 co wceq vx cv cS cF cn cres cseq1 co
      cfv vx cv cS cF cseq1 co cfv wceq vx cn wral vx cv cS cF cn cres cseq1 co
      cfv vx cv cS cF cseq1 co cfv wceq vx cn vy cv cS cF cn cres cseq1 co cfv
      vy cv cS cF cseq1 co cfv wceq c1 cS cF cn cres cseq1 co cfv c1 cS cF
      cseq1 co cfv wceq vz cv cS cF cn cres cseq1 co cfv vz cv cS cF cseq1 co
      cfv wceq vz cv c1 caddc co cS cF cn cres cseq1 co cfv vz cv c1 caddc co
      cS cF cseq1 co cfv wceq vx cv cS cF cn cres cseq1 co cfv vx cv cS cF
      cseq1 co cfv wceq vy vz vx cv vy cv c1 wceq vy cv cS cF cn cres cseq1 co
      cfv c1 cS cF cn cres cseq1 co cfv vy cv cS cF cseq1 co cfv c1 cS cF cseq1
      co cfv vy cv c1 cS cF cn cres cseq1 co fveq2 vy cv c1 cS cF cseq1 co
      fveq2 eqeq12d vy cv vz cv wceq vy cv cS cF cn cres cseq1 co cfv vz cv cS
      cF cn cres cseq1 co cfv vy cv cS cF cseq1 co cfv vz cv cS cF cseq1 co cfv
      vy cv vz cv cS cF cn cres cseq1 co fveq2 vy cv vz cv cS cF cseq1 co fveq2
      eqeq12d vy cv vz cv c1 caddc co wceq vy cv cS cF cn cres cseq1 co cfv vz
      cv c1 caddc co cS cF cn cres cseq1 co cfv vy cv cS cF cseq1 co cfv vz cv
      c1 caddc co cS cF cseq1 co cfv vy cv vz cv c1 caddc co cS cF cn cres
      cseq1 co fveq2 vy cv vz cv c1 caddc co cS cF cseq1 co fveq2 eqeq12d vy cv
      vx cv wceq vy cv cS cF cn cres cseq1 co cfv vx cv cS cF cn cres cseq1 co
      cfv vy cv cS cF cseq1 co cfv vx cv cS cF cseq1 co cfv vy cv vx cv cS cF
      cn cres cseq1 co fveq2 vy cv vx cv cS cF cseq1 co fveq2 eqeq12d c1 cF cn
      cres cfv c1 cF cfv c1 cS cF cn cres cseq1 co cfv c1 cS cF cseq1 co cfv c1
      cn wcel c1 cF cn cres cfv c1 cF cfv wceq 1nn c1 cn cF fvres ax-mp cS cF
      cn cres seq111.1 cF cvv wcel cF cn cres cvv wcel seq111.2 cF cn cvv
      resexg ax-mp seq11 cS cF seq111.1 seq111.2 seq11 3eqtr4i vz cv cn wcel vz
      cv cS cF cn cres cseq1 co cfv vz cv cS cF cseq1 co cfv wceq vz cv c1
      caddc co cS cF cn cres cseq1 co cfv vz cv c1 caddc co cS cF cseq1 co cfv
      wceq vz cv cn wcel vz cv cS cF cn cres cseq1 co cfv vz cv cS cF cseq1 co
      cfv wceq wa vz cv cS cF cn cres cseq1 co cfv vz cv c1 caddc co cF cn cres
      cfv cS co vz cv cS cF cseq1 co cfv vz cv c1 caddc co cF cfv cS co vz cv
      c1 caddc co cS cF cn cres cseq1 co cfv vz cv c1 caddc co cS cF cseq1 co
      cfv vz cv cS cF cn cres cseq1 co cfv vz cv cS cF cseq1 co cfv wceq vz cv
      cn wcel vz cv cS cF cn cres cseq1 co cfv vz cv cS cF cseq1 co cfv vz cv
      c1 caddc co cF cn cres cfv vz cv c1 caddc co cF cfv cS vz cv cS cF cn
      cres cseq1 co cfv vz cv cS cF cseq1 co cfv wceq id vz cv cn wcel vz cv c1
      caddc co cn wcel vz cv c1 caddc co cF cn cres cfv vz cv c1 caddc co cF
      cfv wceq vz cv peano2nn vz cv c1 caddc co cn cF fvres syl opreqan12rd vz
      cv cn wcel vz cv c1 caddc co cS cF cn cres cseq1 co cfv vz cv cS cF cn
      cres cseq1 co cfv vz cv c1 caddc co cF cn cres cfv cS co wceq vz cv cS cF
      cn cres cseq1 co cfv vz cv cS cF cseq1 co cfv wceq vz cv cS cF cn cres
      seq111.1 cF cvv wcel cF cn cres cvv wcel seq111.2 cF cn cvv resexg ax-mp
      seq1p1 adantr vz cv cn wcel vz cv c1 caddc co cS cF cseq1 co cfv vz cv cS
      cF cseq1 co cfv vz cv c1 caddc co cF cfv cS co wceq vz cv cS cF cn cres
      cseq1 co cfv vz cv cS cF cseq1 co cfv wceq vz cv cS cF seq111.1 seq111.2
      seq1p1 adantr 3eqtr4d ex nnind rgen cS cF cn cres cseq1 co cn wfn cS cF
      cseq1 co cn wfn cS cF cn cres cseq1 co cS cF cseq1 co wceq vx cv cS cF cn
      cres cseq1 co cfv vx cv cS cF cseq1 co cfv wceq vx cn wral wb cS cF cn
      cres seq111.1 cF cvv wcel cF cn cres cvv wcel seq111.2 cF cn cvv resexg
      ax-mp seq1fn cS cF seq111.1 seq111.2 seq1fn vx cn cS cF cn cres cseq1 co
      cS cF cseq1 co eqfnfv2 mp2an mpbir $.
      $( [27-Aug-2005] $) $( [16-Aug-2005] $)
  $}

  ${
    $d f F $.
    $( An infinite series of complex terms is a function from ` NN ` to
       ` CC ` . $)
    ser1f $p |- ( F : NN --> CC -> ( + seq1 F ) : NN --> CC ) $=
      cF cvv wcel cn cc cF wf cn cc caddc cF cseq1 co wf cn cc cF wf cn cvv
      wcel cF cvv wcel nnex cn cc cvv cF fex mpan2 cn cc vf cv wf cn cc caddc
      vf cv cseq1 co wf wi cn cc cF wf cn cc caddc cF cseq1 co wf wi vf cF cvv
      vf cv cF wceq cn cc vf cv wf cn cc cF wf cn cc caddc vf cv cseq1 co wf cn
      cc caddc cF cseq1 co wf cn cc vf cv cF feq1 vf cv cF wceq cn cc caddc vf
      cv cseq1 co caddc cF cseq1 co vf cv cF caddc cseq1 opreq2 feq1d imbi12d
      cn cc vf cv wf caddc vf cv cseq1 co cn wfn caddc vf cv cseq1 co crn cc
      wss wa cn cc caddc vf cv cseq1 co wf cn cc vf cv wf caddc vf cv cseq1 co
      crn cc wss caddc vf cv cseq1 co cn wfn cn cc vf cv wf cc cc cxp cc caddc
      wf caddc vf cv cseq1 co crn cc wss axaddopr cc caddc vf cv addex vf
      visset seq1rn mpan2 caddc vf cv addex vf visset seq1fn jctil cn cc caddc
      vf cv cseq1 co df-f sylibr vtoclg mpcom $.
      $( [19-Apr-2005] $) $( [18-Apr-2005] $)
  $}

  ${
    ser1f.1 $e |- F : NN --> CC $.
    $( An infinite series is a function from ` NN ` to ` CC ` . $)
    ser1fi $p |- ( + seq1 F ) : NN --> CC $=
      cn cc cF wf cn cc caddc cF cseq1 co wf ser1f.1 cF ser1f ax-mp $.
      $( [4-Apr-2005] $) $( [19-Mar-2005] $)
  $}

  ${
    $d x A $.  $d x y F $.
    ser1cl1.1 $e |- F : NN --> CC $.
    $( The partial sums in an infinite series of complex terms are complex. $)
    ser1cl1i $p |- ( A e. NN -> ( ( + seq1 F ) ` A ) e. CC ) $=
      cA cn wcel cn cc cF wf cc cc cxp cc caddc wf cA caddc cF cseq1 co cfv cc
      wcel ser1cl1.1 axaddopr cA cc caddc cF addex cn cc cF wf cn cvv wcel cF
      cvv wcel ser1cl1.1 nnex cn cc cvv cF fex mp2an seq1cl mp3an23 $.
      $( [18-Apr-2005] $) $( [17-Apr-2005] $)
  $}

  ${
    $d x A $.  $d x y F $.
    ser1recl.1 $e |- F : NN --> RR $.
    $( The partial sums in an infinite series of real terms are real. $)
    ser1recli $p |- ( A e. NN -> ( ( + seq1 F ) ` A ) e. RR ) $=
      vx cv caddc cF cseq1 co cfv cr wcel c1 caddc cF cseq1 co cfv cr wcel vy
      cv caddc cF cseq1 co cfv cr wcel vy cv c1 caddc co caddc cF cseq1 co cfv
      cr wcel cA caddc cF cseq1 co cfv cr wcel vx vy cA vx cv c1 wceq vx cv
      caddc cF cseq1 co cfv c1 caddc cF cseq1 co cfv cr vx cv c1 caddc cF cseq1
      co fveq2 eleq1d vx cv vy cv wceq vx cv caddc cF cseq1 co cfv vy cv caddc
      cF cseq1 co cfv cr vx cv vy cv caddc cF cseq1 co fveq2 eleq1d vx cv vy cv
      c1 caddc co wceq vx cv caddc cF cseq1 co cfv vy cv c1 caddc co caddc cF
      cseq1 co cfv cr vx cv vy cv c1 caddc co caddc cF cseq1 co fveq2 eleq1d vx
      cv cA wceq vx cv caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cr vx cv
      cA caddc cF cseq1 co fveq2 eleq1d c1 caddc cF cseq1 co cfv c1 cF cfv cr
      caddc cF addex cn cr cF wf cn cvv wcel cF cvv wcel ser1recl.1 nnex cn cr
      cvv cF fex mp2an seq11 cn cr cF wf c1 cn wcel c1 cF cfv cr wcel
      ser1recl.1 1nn cn cr c1 cF ffvelrn mp2an eqeltri vy cv caddc cF cseq1 co
      cfv cr wcel vy cv cn wcel vy cv c1 caddc co caddc cF cseq1 co cfv cr wcel
      vy cv caddc cF cseq1 co cfv cr wcel vy cv cn wcel wa vy cv c1 caddc co
      caddc cF cseq1 co cfv cr wcel vy cv caddc cF cseq1 co cfv vy cv c1 caddc
      co cF cfv caddc co cr wcel vy cv caddc cF cseq1 co cfv cr wcel vy cv c1
      caddc co cF cfv cr wcel vy cv caddc cF cseq1 co cfv vy cv c1 caddc co cF
      cfv caddc co cr wcel vy cv cn wcel vy cv caddc cF cseq1 co cfv vy cv c1
      caddc co cF cfv readdcl vy cv cn wcel vy cv c1 caddc co cn wcel vy cv c1
      caddc co cF cfv cr wcel vy cv peano2nn cn cr vy cv c1 caddc co cF
      ser1recl.1 ffvelrni syl sylan2 vy cv cn wcel vy cv c1 caddc co caddc cF
      cseq1 co cfv cr wcel vy cv caddc cF cseq1 co cfv vy cv c1 caddc co cF cfv
      caddc co cr wcel wb vy cv caddc cF cseq1 co cfv cr wcel vy cv cn wcel vy
      cv c1 caddc co caddc cF cseq1 co cfv vy cv caddc cF cseq1 co cfv vy cv c1
      caddc co cF cfv caddc co cr vy cv caddc cF addex cn cr cF wf cn cvv wcel
      cF cvv wcel ser1recl.1 nnex cn cr cvv cF fex mp2an seq1p1 eleq1d adantl
      mpbird expcom nnind $.
      $( [4-Apr-2005] $) $( [17-Mar-2005] $)

    $( The partial sums of an infinite series of reals is an infinite real
       sequence. $)
    ser1refi $p |- ( + seq1 F ) : NN --> RR $=
      cn cr caddc cF cseq1 co wf caddc cF cseq1 co cn wfn vx cv caddc cF cseq1
      co cfv cr wcel vx cn wral vx cn cr caddc cF cseq1 co ffnfv caddc cF addex
      cn cr cF wf cn cvv wcel cF cvv wcel ser1recl.1 nnex cn cr cvv cF fex
      mp2an seq1fn vx cv caddc cF cseq1 co cfv cr wcel vx cn vx cv cF
      ser1recl.1 ser1recli rgen mpbir2an $.
      $( [5-Apr-2005] $) $( [18-Mar-2005] $)
  $}

  ${
    $d x y z $.  $d y A $.  $d x B $.  $d z F $.
    ser1cl2.1 $e |- F = { <. x , y >. | ( x e. NN /\ y = A ) } $.
    ${
      ser1cl2.2 $e |- A. x e. NN A e. CC $.
      $( Closure of the value of the ` B ` th term of an infinite series. $)
      ser1cl2i $p |- ( B e. NN -> ( ( + seq1 F ) ` B ) e. CC ) $=
        cB cF cA cc wcel vx cn wral cn cc cF wf ser1cl2.2 vx vy cn cc cA cF
        ser1cl2.1 fopab2 mpbi ser1cl1i $.
        $( [7-Mar-2005] $) $( [8-Nov-2005] $)

      $( An infinite series is a function from ` NN ` to ` CC ` . $)
      ser1f2i $p |- ( + seq1 F ) : NN --> CC $=
        cn cc caddc cF cseq1 co wf caddc cF cseq1 co cn wfn vz cv caddc cF
        cseq1 co cfv cc wcel vz cn wral vz cn cc caddc cF cseq1 co ffnfv caddc
        cF addex vx vy cn cA cF nnex ser1cl2.1 fopabex2 seq1fn vz cv caddc cF
        cseq1 co cfv cc wcel vz cn vx vy cA vz cv cF ser1cl2.1 ser1cl2.2
        ser1cl2i rgen mpbir2an $.
        $( [25-Apr-2005] $) $( [5-Mar-2005] $)
    $}

    ${
      $d y B $.
      ser11.2 $e |- B e. _V $.
      ser11.3 $e |- ( x = 1 -> A = B ) $.
      $( The value of the first term in an infinite series. $)
      ser11i $p |- ( ( + seq1 F ) ` 1 ) = B $=
        c1 caddc cF cseq1 co cfv c1 cF cfv cB caddc cF addex vx vy cn cA cF
        nnex ser1cl2.1 fopabex2 seq11 c1 cn wcel c1 cF cfv cB wceq 1nn vx vy c1
        cA cB cn cF ser11.3 ser1cl2.1 ser11.2 fvopab4 ax-mp eqtri $.
        $( [13-Mar-2005] $) $( [8-Nov-2005] $)
    $}

    ${
      $d y B $.  $d x y C $.
      ser1p1.2 $e |- C e. _V $.
      ser1p1.3 $e |- ( x = ( B + 1 ) -> A = C ) $.
      $( The value of the next term in an infinite series. $)
      ser1p1i $p |- ( B e. NN ->
               ( ( + seq1 F ) ` ( B + 1 ) ) = ( ( ( + seq1 F ) ` B ) + C ) ) $=
        cB cn wcel cB c1 caddc co caddc cF cseq1 co cfv cB caddc cF cseq1 co
        cfv cB c1 caddc co cF cfv caddc co cB caddc cF cseq1 co cfv cC caddc co
        cB caddc cF addex vx vy cn cA cF nnex ser1cl2.1 fopabex2 seq1p1 cB cn
        wcel cB c1 caddc co cF cfv cC cB caddc cF cseq1 co cfv caddc cB cn wcel
        cB c1 caddc co cn wcel cB c1 caddc co cF cfv cC wceq cB peano2nn vx vy
        cB c1 caddc co cA cC cn cF ser1p1.3 ser1cl2.1 ser1p1.2 fvopab4 syl
        opreq2d eqtrd $.
        $( [14-Mar-2005] $) $( [8-Nov-2005] $)
    $}
  $}

  ${
    $d y A $.  $d x y F $.
    ser1mono.1 $e |- F : NN --> RR $.
    ser1mono.2 $e |- ( x e. NN -> 0 <_ ( F ` x ) ) $.
    $( The partial sums in an infinite series of positive terms form
       a monotonic sequence. $)
    ser1monoi $p |- ( A e. NN ->
                  ( ( + seq1 F ) ` A ) <_ ( ( + seq1 F ) ` ( A + 1 ) ) ) $=
      cA cn wcel cA caddc cF cseq1 co cfv cc0 caddc co cA caddc cF cseq1 co cfv
      cA c1 caddc co caddc cF cseq1 co cfv cle cA cn wcel cA caddc cF cseq1 co
      cfv cc wcel cA caddc cF cseq1 co cfv cc0 caddc co cA caddc cF cseq1 co
      cfv wceq cA cF cn cr cF wf cr cc wss cn cc cF wf ser1mono.1 axresscn cn
      cr cc cF fss mp2an ser1cl1i cA caddc cF cseq1 co cfv addid1 syl cA cn
      wcel cA caddc cF cseq1 co cfv cc0 caddc co cA caddc cF cseq1 co cfv cA c1
      caddc co cF cfv caddc co cA c1 caddc co caddc cF cseq1 co cfv cle cA cn
      wcel cc0 cA c1 caddc co cF cfv cle wbr cA caddc cF cseq1 co cfv cc0 caddc
      co cA caddc cF cseq1 co cfv cA c1 caddc co cF cfv caddc co cle wbr cA cn
      wcel cA c1 caddc co cn wcel cc0 cA c1 caddc co cF cfv cle wbr cA peano2nn
      cc0 vy cv cF cfv cle wbr cc0 cA c1 caddc co cF cfv cle wbr vy cA c1 caddc
      co cn vy cv cA c1 caddc co wceq vy cv cF cfv cA c1 caddc co cF cfv cc0
      cle vy cv cA c1 caddc co cF fveq2 breq2d cc0 vx cv cF cfv cle wbr cc0 vy
      cv cF cfv cle wbr vx vy cv cn vx cv vy cv wceq vx cv cF cfv vy cv cF cfv
      cc0 cle vx cv vy cv cF fveq2 breq2d ser1mono.2 vtoclga vtoclga syl cA c1
      caddc co cF cfv cr wcel cA caddc cF cseq1 co cfv cr wcel cc0 cA c1 caddc
      co cF cfv cle wbr cA caddc cF cseq1 co cfv cc0 caddc co cA caddc cF cseq1
      co cfv cA c1 caddc co cF cfv caddc co cle wbr wb cA cn wcel cc0 cr wcel
      cA c1 caddc co cF cfv cr wcel cA caddc cF cseq1 co cfv cr wcel cc0 cA c1
      caddc co cF cfv cle wbr cA caddc cF cseq1 co cfv cc0 caddc co cA caddc cF
      cseq1 co cfv cA c1 caddc co cF cfv caddc co cle wbr wb 0re cc0 cA c1
      caddc co cF cfv cA caddc cF cseq1 co cfv leadd2 mp3an1 cA cn wcel cA c1
      caddc co cn wcel cA c1 caddc co cF cfv cr wcel cA peano2nn cn cr cA c1
      caddc co cF ser1mono.1 ffvelrni syl cA cF ser1mono.1 ser1recli sylanc
      mpbid cA caddc cF addex cn cr cF wf cn cvv wcel cF cvv wcel ser1mono.1
      nnex cn cr cvv cF fex mp2an seq1p1 breqtrrd eqbrtrrd $.
      $( [7-Apr-2005] $) $( [17-Mar-2005] $)
  $}

  ${
    $d k j m F $.  $d k j m G $.  $d k j m H $.  $d j k m N $.
    ser1add2.1 $e |- F : NN --> CC $.
    ser1add2.2 $e |- G : NN --> CC $.
    ser1add2.3 $e |- H e. _V $.
    ser1add2.4 $e |- ( ( k e. NN /\ N e. NN /\ k <_ N ) ->
                   ( H ` k ) = ( ( F ` k ) + ( G ` k ) ) ) $.
    $( The sum of two infinite series. $)
    ser1add2i $p |- ( N e. NN ->
   ( ( + seq1 H ) ` N ) = ( ( ( + seq1 F ) ` N ) + ( ( + seq1 G ) ` N ) ) ) $=
      cN cn wcel cN caddc cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG
      cseq1 co cfv caddc co wceq cN cn wcel cN cn wcel cN cN cle wbr cN caddc
      cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG cseq1 co cfv caddc
      co wceq cN cn wcel cN cr wcel cN cN cle wbr cN nnre cN leid syl cN cn
      wcel vj cv cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv caddc cF cseq1
      co cfv vj cv caddc cG cseq1 co cfv caddc co wceq wi cN cn wcel c1 cN cle
      wbr wa c1 caddc cH cseq1 co cfv c1 caddc cF cseq1 co cfv c1 caddc cG
      cseq1 co cfv caddc co wceq wi cN cn wcel vm cv cN cle wbr wa vm cv caddc
      cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv
      caddc co wceq wi cN cn wcel vm cv c1 caddc co cN cle wbr wa vm cv c1
      caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm
      cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq wi cN cn wcel cN cN
      cle wbr wa cN caddc cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG
      cseq1 co cfv caddc co wceq wi vj vm cN vj cv c1 wceq cN cn wcel vj cv cN
      cle wbr wa cN cn wcel c1 cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq c1 caddc
      cH cseq1 co cfv c1 caddc cF cseq1 co cfv c1 caddc cG cseq1 co cfv caddc
      co wceq vj cv c1 wceq vj cv cN cle wbr c1 cN cle wbr cN cn wcel vj cv c1
      cN cle breq1 anbi2d vj cv c1 wceq vj cv caddc cH cseq1 co cfv c1 caddc cH
      cseq1 co cfv vj cv caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv
      caddc co c1 caddc cF cseq1 co cfv c1 caddc cG cseq1 co cfv caddc co vj cv
      c1 caddc cH cseq1 co fveq2 vj cv c1 wceq vj cv caddc cF cseq1 co cfv c1
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv c1 caddc cG cseq1 co
      cfv caddc vj cv c1 caddc cF cseq1 co fveq2 vj cv c1 caddc cG cseq1 co
      fveq2 opreq12d eqeq12d imbi12d vj cv vm cv wceq cN cn wcel vj cv cN cle
      wbr wa cN cn wcel vm cv cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq vj cv vm cv wceq vj cv cN cle wbr vm cv cN cle wbr cN
      cn wcel vj cv vm cv cN cle breq1 anbi2d vj cv vm cv wceq vj cv caddc cH
      cseq1 co cfv vm cv caddc cH cseq1 co cfv vj cv caddc cF cseq1 co cfv vj
      cv caddc cG cseq1 co cfv caddc co vm cv caddc cF cseq1 co cfv vm cv caddc
      cG cseq1 co cfv caddc co vj cv vm cv caddc cH cseq1 co fveq2 vj cv vm cv
      wceq vj cv caddc cF cseq1 co cfv vm cv caddc cF cseq1 co cfv vj cv caddc
      cG cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc vj cv vm cv caddc cF
      cseq1 co fveq2 vj cv vm cv caddc cG cseq1 co fveq2 opreq12d eqeq12d
      imbi12d vj cv vm cv c1 caddc co wceq cN cn wcel vj cv cN cle wbr wa cN cn
      wcel vm cv c1 caddc co cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq vm cv c1
      caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm
      cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq vj cv vm cv c1 caddc
      co wceq vj cv cN cle wbr vm cv c1 caddc co cN cle wbr cN cn wcel vj cv vm
      cv c1 caddc co cN cle breq1 anbi2d vj cv vm cv c1 caddc co wceq vj cv
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cH cseq1 co cfv vj cv caddc
      cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co vm cv c1 caddc co
      caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co vj
      cv vm cv c1 caddc co caddc cH cseq1 co fveq2 vj cv vm cv c1 caddc co wceq
      vj cv caddc cF cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vj cv
      caddc cG cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc vj cv
      vm cv c1 caddc co caddc cF cseq1 co fveq2 vj cv vm cv c1 caddc co caddc
      cG cseq1 co fveq2 opreq12d eqeq12d imbi12d vj cv cN wceq cN cn wcel vj cv
      cN cle wbr wa cN cn wcel cN cN cle wbr wa vj cv caddc cH cseq1 co cfv vj
      cv caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq cN
      caddc cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG cseq1 co cfv
      caddc co wceq vj cv cN wceq vj cv cN cle wbr cN cN cle wbr cN cn wcel vj
      cv cN cN cle breq1 anbi2d vj cv cN wceq vj cv caddc cH cseq1 co cfv cN
      caddc cH cseq1 co cfv vj cv caddc cF cseq1 co cfv vj cv caddc cG cseq1 co
      cfv caddc co cN caddc cF cseq1 co cfv cN caddc cG cseq1 co cfv caddc co
      vj cv cN caddc cH cseq1 co fveq2 vj cv cN wceq vj cv caddc cF cseq1 co
      cfv cN caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv cN caddc cG
      cseq1 co cfv caddc vj cv cN caddc cF cseq1 co fveq2 vj cv cN caddc cG
      cseq1 co fveq2 opreq12d eqeq12d imbi12d cN cn wcel c1 cN cle wbr wa c1 cH
      cfv c1 cF cfv c1 cG cfv caddc co c1 caddc cH cseq1 co cfv c1 caddc cF
      cseq1 co cfv c1 caddc cG cseq1 co cfv caddc co c1 cn wcel cN cn wcel c1
      cN cle wbr wa c1 cH cfv c1 cF cfv c1 cG cfv caddc co wceq wi 1nn cN cn
      wcel vk cv cN cle wbr wa vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co
      wceq wi cN cn wcel c1 cN cle wbr wa c1 cH cfv c1 cF cfv c1 cG cfv caddc
      co wceq wi vk c1 cn vk cv c1 wceq cN cn wcel vk cv cN cle wbr wa cN cn
      wcel c1 cN cle wbr wa vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co
      wceq c1 cH cfv c1 cF cfv c1 cG cfv caddc co wceq vk cv c1 wceq vk cv cN
      cle wbr c1 cN cle wbr cN cn wcel vk cv c1 cN cle breq1 anbi2d vk cv c1
      wceq vk cv cH cfv c1 cH cfv vk cv cF cfv vk cv cG cfv caddc co c1 cF cfv
      c1 cG cfv caddc co vk cv c1 cH fveq2 vk cv c1 wceq vk cv cF cfv c1 cF cfv
      vk cv cG cfv c1 cG cfv caddc vk cv c1 cF fveq2 vk cv c1 cG fveq2 opreq12d
      eqeq12d imbi12d vk cv cn wcel cN cn wcel vk cv cN cle wbr vk cv cH cfv vk
      cv cF cfv vk cv cG cfv caddc co wceq ser1add2.4 3expib vtoclga ax-mp
      caddc cH addex ser1add2.3 seq11 c1 caddc cF cseq1 co cfv c1 cF cfv c1
      caddc cG cseq1 co cfv c1 cG cfv caddc caddc cF addex cn cc cF wf cn cvv
      wcel cF cvv wcel ser1add2.1 nnex cn cc cvv cF fex mp2an seq11 caddc cG
      addex cn cc cG wf cn cvv wcel cG cvv wcel ser1add2.2 nnex cn cc cvv cG
      fex mp2an seq11 opreq12i 3eqtr4g vm cv cn wcel cN cn wcel vm cv c1 caddc
      co cN cle wbr wa cN cn wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co
      cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq
      wi vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF
      cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq vm cv
      cn wcel cN cn wcel vm cv c1 caddc co cN cle wbr cN cn wcel vm cv cN cle
      wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv
      caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co caddc cH cseq1
      co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG
      cseq1 co cfv caddc co wceq wi vm cv cn wcel cN cn wcel vm cv c1 caddc co
      cN cle wbr cN cn wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm
      cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm
      cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co
      cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq wi wi vm cv cn
      wcel cN cn wcel cN cn wcel vm cv c1 caddc co cN cle wbr cN cn wcel vm cv
      cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm
      cv caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co caddc cH
      cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1 caddc co
      caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel cN cn wcel wa cN cn
      wcel wa vm cv c1 caddc co cN cle wbr wa vm cv cN cle wbr cN cn wcel vm cv
      cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm
      cv caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co caddc cH
      cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1 caddc co
      caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel cN cn wcel vm cv c1
      caddc co cN cle wbr vm cv cN cle wbr cN cn wcel vm cv cn wcel cN cn wcel
      wa vm cv c1 caddc co cN cle wbr vm cv cN cle wbr vm cv cr wcel cN cr wcel
      vm cv c1 caddc co cN cle wbr vm cv cN cle wbr wi vm cv cn wcel cN cn wcel
      vm cv cr wcel cN cr wcel wa vm cv vm cv c1 caddc co cle wbr vm cv c1
      caddc co cN cle wbr vm cv cN cle wbr vm cv cr wcel vm cv vm cv c1 caddc
      co cle wbr cN cr wcel vm cv lep1 adantr vm cv cr wcel vm cv c1 caddc co
      cr wcel cN cr wcel vm cv vm cv c1 caddc co cle wbr vm cv c1 caddc co cN
      cle wbr wa vm cv cN cle wbr wi vm cv cr wcel cN cr wcel wa vm cv vm cv c1
      caddc co cN letr vm cv cr wcel cN cr wcel pm3.26 vm cv cr wcel vm cv c1
      caddc co cr wcel cN cr wcel vm cv peano2re adantr vm cv cr wcel cN cr
      wcel pm3.27 syl3anc mpand vm cv nnre cN nnre syl2an imp adantllr vm cv cn
      wcel cN cn wcel wa cN cn wcel wa vm cv c1 caddc co cN cle wbr vm cv cN
      cle wbr cN cn wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv
      caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm cv
      c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv
      vm cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel cN
      cn wcel wa vm cv c1 caddc co cN cle wbr cN cn wcel vm cv cN cle wbr cN cn
      wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1
      co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel cN cn wcel
      wa vm cv c1 caddc co cN cle wbr wa cN cn wcel vm cv cN cle wbr wa cN cn
      wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1
      co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel cN cn wcel
      wa vm cv c1 caddc co cN cle wbr wa cN cn wcel vm cv cN cle wbr wa vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq wi cN cn wcel vm cv cN cle wbr wa vm cv c1 caddc co
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co wceq vm cv cn wcel cN cn wcel wa
      vm cv c1 caddc co cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc
      cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq vm cv c1 caddc
      co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co wceq cN cn wcel vm cv cN cle wbr
      wa vm cv cn wcel cN cn wcel wa vm cv c1 caddc co cN cle wbr wa vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc
      co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co
      wceq vm cv cn wcel cN cn wcel wa vm cv c1 caddc co cN cle wbr wa vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq wa vm cv caddc cH cseq1 co cfv vm cv c1 caddc co cH cfv
      caddc co vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co
      vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv caddc co caddc co vm cv
      c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv
      vm cv c1 caddc co caddc cG cseq1 co cfv caddc co vm cv cn wcel cN cn wcel
      wa vm cv c1 caddc co cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv
      caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wa vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co vm cv c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1
      caddc co cG cfv caddc co caddc vm cv cn wcel cN cn wcel wa vm cv c1 caddc
      co cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv
      vm cv caddc cG cseq1 co cfv caddc co wceq pm3.27 vm cv cn wcel cN cn wcel
      wa vm cv c1 caddc co cN cle wbr wa vm cv c1 caddc co cH cfv vm cv c1
      caddc co cF cfv vm cv c1 caddc co cG cfv caddc co wceq vm cv caddc cH
      cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv
      caddc co wceq vm cv cn wcel cN cn wcel vm cv c1 caddc co cN cle wbr vm cv
      c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv
      caddc co wceq vm cv cn wcel vm cv c1 caddc co cn wcel cN cn wcel vm cv c1
      caddc co cN cle wbr vm cv c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm
      cv c1 caddc co cG cfv caddc co wceq wi wi vm cv peano2nn cN cn wcel vk cv
      cN cle wbr vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq wi wi cN
      cn wcel vm cv c1 caddc co cN cle wbr vm cv c1 caddc co cH cfv vm cv c1
      caddc co cF cfv vm cv c1 caddc co cG cfv caddc co wceq wi wi vk vm cv c1
      caddc co cn vk cv vm cv c1 caddc co wceq vk cv cN cle wbr vk cv cH cfv vk
      cv cF cfv vk cv cG cfv caddc co wceq wi vm cv c1 caddc co cN cle wbr vm
      cv c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv
      caddc co wceq wi cN cn wcel vk cv vm cv c1 caddc co wceq vk cv cN cle wbr
      vm cv c1 caddc co cN cle wbr vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc
      co wceq vm cv c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1 caddc
      co cG cfv caddc co wceq vk cv vm cv c1 caddc co cN cle breq1 vk cv vm cv
      c1 caddc co wceq vk cv cH cfv vm cv c1 caddc co cH cfv vk cv cF cfv vk cv
      cG cfv caddc co vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv caddc
      co vk cv vm cv c1 caddc co cH fveq2 vk cv vm cv c1 caddc co wceq vk cv cF
      cfv vm cv c1 caddc co cF cfv vk cv cG cfv vm cv c1 caddc co cG cfv caddc
      vk cv vm cv c1 caddc co cF fveq2 vk cv vm cv c1 caddc co cG fveq2
      opreq12d eqeq12d imbi12d imbi2d vk cv cn wcel cN cn wcel vk cv cN cle wbr
      vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq ser1add2.4 3exp
      vtoclga syl imp31 adantr opreq12d vm cv cn wcel vm cv c1 caddc co cN cle
      wbr vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc
      cG cseq1 co cfv caddc co wceq vm cv c1 caddc co caddc cH cseq1 co cfv vm
      cv caddc cH cseq1 co cfv vm cv c1 caddc co cH cfv caddc co wceq cN cn
      wcel vm cv cn wcel vm cv c1 caddc co caddc cH cseq1 co cfv vm cv caddc cH
      cseq1 co cfv vm cv c1 caddc co cH cfv caddc co wceq vm cv c1 caddc co cN
      cle wbr vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv
      caddc cG cseq1 co cfv caddc co wceq vm cv caddc cH addex ser1add2.3
      seq1p1 ad2antrr adantllr vm cv cn wcel cN cn wcel wa vm cv caddc cH cseq1
      co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co
      wceq vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG
      cseq1 co cfv caddc co vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv caddc co
      caddc co wceq vm cv c1 caddc co cN cle wbr vm cv cn wcel vm cv c1 caddc
      co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co
      vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1
      caddc co cF cfv vm cv c1 caddc co cG cfv caddc co caddc co wceq cN cn
      wcel vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc
      cG cseq1 co cfv caddc co wceq vm cv cn wcel vm cv c1 caddc co caddc cF
      cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co vm cv caddc
      cF cseq1 co cfv vm cv c1 caddc co cF cfv caddc co vm cv caddc cG cseq1 co
      cfv vm cv c1 caddc co cG cfv caddc co caddc co vm cv caddc cF cseq1 co
      cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1 caddc co cF cfv vm cv
      c1 caddc co cG cfv caddc co caddc co vm cv cn wcel vm cv c1 caddc co
      caddc cF cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv c1 caddc co cF
      cfv caddc co vm cv c1 caddc co caddc cG cseq1 co cfv vm cv caddc cG cseq1
      co cfv vm cv c1 caddc co cG cfv caddc co caddc vm cv caddc cF addex cn cc
      cF wf cn cvv wcel cF cvv wcel ser1add2.1 nnex cn cc cvv cF fex mp2an
      seq1p1 vm cv caddc cG addex cn cc cG wf cn cvv wcel cG cvv wcel
      ser1add2.2 nnex cn cc cvv cG fex mp2an seq1p1 opreq12d vm cv caddc cF
      cseq1 co cfv cc wcel vm cv c1 caddc co cF cfv cc wcel vm cv caddc cG
      cseq1 co cfv cc wcel vm cv c1 caddc co cG cfv cc wcel vm cv caddc cF
      cseq1 co cfv vm cv c1 caddc co cF cfv caddc co vm cv caddc cG cseq1 co
      cfv vm cv c1 caddc co cG cfv caddc co caddc co vm cv caddc cF cseq1 co
      cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1 caddc co cF cfv vm cv
      c1 caddc co cG cfv caddc co caddc co wceq vm cv cn wcel vm cv caddc cF
      cseq1 co cfv vm cv c1 caddc co cF cfv vm cv caddc cG cseq1 co cfv vm cv
      c1 caddc co cG cfv add4 vm cv cF ser1add2.1 ser1cl1i vm cv cn wcel vm cv
      c1 caddc co cn wcel vm cv c1 caddc co cF cfv cc wcel vm cv peano2nn cn cc
      vm cv c1 caddc co cF ser1add2.1 ffvelrni syl vm cv cG ser1add2.2 ser1cl1i
      vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co cG cfv cc wcel
      vm cv peano2nn cn cc vm cv c1 caddc co cG ser1add2.2 ffvelrni syl syl2anc
      eqtrd ad2antrr adantlr 3eqtr4d ex imim2d com23 imp an4s anassrs mpdan
      exp41 pm2.43d imp3a com23 nnind mpan2d pm2.43i $.
      $( [31-Jul-2005] $) $( [18-Jul-2005] $)
  $}

  ${
    $d k j m F $.  $d k j m G $.  $d k j m H $.  $d j k m N $.
    ser1add.1 $e |- F : NN --> CC $.
    ser1add.2 $e |- G : NN --> CC $.
    ser1add.3 $e |- H e. _V $.
    ser1add.4 $e |- ( ( k e. NN /\ k <_ N ) ->
                   ( H ` k ) = ( ( F ` k ) + ( G ` k ) ) ) $.
    $( The sum of two infinite series. $)
    ser1addi $p |- ( N e. NN ->
   ( ( + seq1 H ) ` N ) = ( ( ( + seq1 F ) ` N ) + ( ( + seq1 G ) ` N ) ) ) $=
      cN cn wcel cN caddc cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG
      cseq1 co cfv caddc co wceq cN cn wcel cN cn wcel cN cN cle wbr cN caddc
      cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG cseq1 co cfv caddc
      co wceq cN cn wcel cN cr wcel cN cN cle wbr cN nnre cN leid syl cN cn
      wcel vj cv cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv caddc cF cseq1
      co cfv vj cv caddc cG cseq1 co cfv caddc co wceq wi cN cn wcel c1 cN cle
      wbr wa c1 caddc cH cseq1 co cfv c1 caddc cF cseq1 co cfv c1 caddc cG
      cseq1 co cfv caddc co wceq wi cN cn wcel vm cv cN cle wbr wa vm cv caddc
      cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv
      caddc co wceq wi cN cn wcel vm cv c1 caddc co cN cle wbr wa vm cv c1
      caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm
      cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq wi cN cn wcel cN cN
      cle wbr wa cN caddc cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG
      cseq1 co cfv caddc co wceq wi vj vm cN vj cv c1 wceq cN cn wcel vj cv cN
      cle wbr wa cN cn wcel c1 cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq c1 caddc
      cH cseq1 co cfv c1 caddc cF cseq1 co cfv c1 caddc cG cseq1 co cfv caddc
      co wceq vj cv c1 wceq vj cv cN cle wbr c1 cN cle wbr cN cn wcel vj cv c1
      cN cle breq1 anbi2d vj cv c1 wceq vj cv caddc cH cseq1 co cfv c1 caddc cH
      cseq1 co cfv vj cv caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv
      caddc co c1 caddc cF cseq1 co cfv c1 caddc cG cseq1 co cfv caddc co vj cv
      c1 caddc cH cseq1 co fveq2 vj cv c1 wceq vj cv caddc cF cseq1 co cfv c1
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv c1 caddc cG cseq1 co
      cfv caddc vj cv c1 caddc cF cseq1 co fveq2 vj cv c1 caddc cG cseq1 co
      fveq2 opreq12d eqeq12d imbi12d vj cv vm cv wceq cN cn wcel vj cv cN cle
      wbr wa cN cn wcel vm cv cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq vj cv vm cv wceq vj cv cN cle wbr vm cv cN cle wbr cN
      cn wcel vj cv vm cv cN cle breq1 anbi2d vj cv vm cv wceq vj cv caddc cH
      cseq1 co cfv vm cv caddc cH cseq1 co cfv vj cv caddc cF cseq1 co cfv vj
      cv caddc cG cseq1 co cfv caddc co vm cv caddc cF cseq1 co cfv vm cv caddc
      cG cseq1 co cfv caddc co vj cv vm cv caddc cH cseq1 co fveq2 vj cv vm cv
      wceq vj cv caddc cF cseq1 co cfv vm cv caddc cF cseq1 co cfv vj cv caddc
      cG cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc vj cv vm cv caddc cF
      cseq1 co fveq2 vj cv vm cv caddc cG cseq1 co fveq2 opreq12d eqeq12d
      imbi12d vj cv vm cv c1 caddc co wceq cN cn wcel vj cv cN cle wbr wa cN cn
      wcel vm cv c1 caddc co cN cle wbr wa vj cv caddc cH cseq1 co cfv vj cv
      caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq vm cv c1
      caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm
      cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq vj cv vm cv c1 caddc
      co wceq vj cv cN cle wbr vm cv c1 caddc co cN cle wbr cN cn wcel vj cv vm
      cv c1 caddc co cN cle breq1 anbi2d vj cv vm cv c1 caddc co wceq vj cv
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cH cseq1 co cfv vj cv caddc
      cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co vm cv c1 caddc co
      caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co vj
      cv vm cv c1 caddc co caddc cH cseq1 co fveq2 vj cv vm cv c1 caddc co wceq
      vj cv caddc cF cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vj cv
      caddc cG cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc vj cv
      vm cv c1 caddc co caddc cF cseq1 co fveq2 vj cv vm cv c1 caddc co caddc
      cG cseq1 co fveq2 opreq12d eqeq12d imbi12d vj cv cN wceq cN cn wcel vj cv
      cN cle wbr wa cN cn wcel cN cN cle wbr wa vj cv caddc cH cseq1 co cfv vj
      cv caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv caddc co wceq cN
      caddc cH cseq1 co cfv cN caddc cF cseq1 co cfv cN caddc cG cseq1 co cfv
      caddc co wceq vj cv cN wceq vj cv cN cle wbr cN cN cle wbr cN cn wcel vj
      cv cN cN cle breq1 anbi2d vj cv cN wceq vj cv caddc cH cseq1 co cfv cN
      caddc cH cseq1 co cfv vj cv caddc cF cseq1 co cfv vj cv caddc cG cseq1 co
      cfv caddc co cN caddc cF cseq1 co cfv cN caddc cG cseq1 co cfv caddc co
      vj cv cN caddc cH cseq1 co fveq2 vj cv cN wceq vj cv caddc cF cseq1 co
      cfv cN caddc cF cseq1 co cfv vj cv caddc cG cseq1 co cfv cN caddc cG
      cseq1 co cfv caddc vj cv cN caddc cF cseq1 co fveq2 vj cv cN caddc cG
      cseq1 co fveq2 opreq12d eqeq12d imbi12d c1 cN cle wbr c1 caddc cH cseq1
      co cfv c1 caddc cF cseq1 co cfv c1 caddc cG cseq1 co cfv caddc co wceq cN
      cn wcel c1 cN cle wbr c1 cH cfv c1 cF cfv c1 cG cfv caddc co c1 caddc cH
      cseq1 co cfv c1 caddc cF cseq1 co cfv c1 caddc cG cseq1 co cfv caddc co
      c1 cn wcel c1 cN cle wbr c1 cH cfv c1 cF cfv c1 cG cfv caddc co wceq wi
      1nn vk cv cN cle wbr vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq
      wi c1 cN cle wbr c1 cH cfv c1 cF cfv c1 cG cfv caddc co wceq wi vk c1 cn
      vk cv c1 wceq vk cv cN cle wbr c1 cN cle wbr vk cv cH cfv vk cv cF cfv vk
      cv cG cfv caddc co wceq c1 cH cfv c1 cF cfv c1 cG cfv caddc co wceq vk cv
      c1 cN cle breq1 vk cv c1 wceq vk cv cH cfv c1 cH cfv vk cv cF cfv vk cv
      cG cfv caddc co c1 cF cfv c1 cG cfv caddc co vk cv c1 cH fveq2 vk cv c1
      wceq vk cv cF cfv c1 cF cfv vk cv cG cfv c1 cG cfv caddc vk cv c1 cF
      fveq2 vk cv c1 cG fveq2 opreq12d eqeq12d imbi12d vk cv cn wcel vk cv cN
      cle wbr vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq ser1add.4 ex
      vtoclga ax-mp caddc cH addex ser1add.3 seq11 c1 caddc cF cseq1 co cfv c1
      cF cfv c1 caddc cG cseq1 co cfv c1 cG cfv caddc caddc cF addex cn cc cF
      wf cn cvv wcel cF cvv wcel ser1add.1 nnex cn cc cvv cF fex mp2an seq11
      caddc cG addex cn cc cG wf cn cvv wcel cG cvv wcel ser1add.2 nnex cn cc
      cvv cG fex mp2an seq11 opreq12i 3eqtr4g adantl vm cv cn wcel cN cn wcel
      vm cv c1 caddc co cN cle wbr wa cN cn wcel vm cv cN cle wbr wa vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq wi vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1
      caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv
      caddc co wceq vm cv cn wcel cN cn wcel vm cv c1 caddc co cN cle wbr cN cn
      wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1
      co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel cN cn wcel
      vm cv c1 caddc co cN cle wbr cN cn wcel vm cv cN cle wbr wa vm cv caddc
      cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv
      caddc co wceq wi vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc
      co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co
      wceq wi vm cv cn wcel cN cn wcel wa vm cv c1 caddc co cN cle wbr wa vm cv
      cN cle wbr cN cn wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm
      cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm
      cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co
      cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq wi vm cv cn
      wcel cN cn wcel wa vm cv c1 caddc co cN cle wbr vm cv cN cle wbr vm cv cr
      wcel cN cr wcel vm cv c1 caddc co cN cle wbr vm cv cN cle wbr wi vm cv cn
      wcel cN cn wcel vm cv cr wcel cN cr wcel wa vm cv vm cv c1 caddc co cle
      wbr vm cv c1 caddc co cN cle wbr vm cv cN cle wbr vm cv cr wcel vm cv vm
      cv c1 caddc co cle wbr cN cr wcel vm cv lep1 adantr vm cv cr wcel vm cv
      c1 caddc co cr wcel cN cr wcel vm cv vm cv c1 caddc co cle wbr vm cv c1
      caddc co cN cle wbr wa vm cv cN cle wbr wi vm cv cr wcel cN cr wcel wa vm
      cv vm cv c1 caddc co cN letr vm cv cr wcel cN cr wcel pm3.26 vm cv cr
      wcel vm cv c1 caddc co cr wcel cN cr wcel vm cv peano2re adantr vm cv cr
      wcel cN cr wcel pm3.27 syl3anc mpand vm cv nnre cN nnre syl2an imp vm cv
      cn wcel cN cn wcel wa vm cv c1 caddc co cN cle wbr vm cv cN cle wbr cN cn
      wcel vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1
      co cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co
      caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co wceq wi vm cv cn wcel vm cv c1
      caddc co cN cle wbr cN cn wcel vm cv cN cle wbr cN cn wcel vm cv cN cle
      wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv
      caddc cG cseq1 co cfv caddc co wceq wi vm cv c1 caddc co caddc cH cseq1
      co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG
      cseq1 co cfv caddc co wceq wi vm cv cn wcel vm cv c1 caddc co cN cle wbr
      wa cN cn wcel vm cv cN cle wbr wa cN cn wcel vm cv cN cle wbr wa vm cv
      caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co
      cfv caddc co wceq wi vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1
      caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv
      caddc co wceq wi vm cv cn wcel vm cv c1 caddc co cN cle wbr wa cN cn wcel
      vm cv cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co
      cfv vm cv caddc cG cseq1 co cfv caddc co wceq wi cN cn wcel vm cv cN cle
      wbr wa vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF
      cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq vm cv
      cn wcel vm cv c1 caddc co cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv
      caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq vm cv c1
      caddc co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm
      cv c1 caddc co caddc cG cseq1 co cfv caddc co wceq cN cn wcel vm cv cN
      cle wbr wa vm cv cn wcel vm cv c1 caddc co cN cle wbr wa vm cv caddc cH
      cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv
      caddc co wceq vm cv c1 caddc co caddc cH cseq1 co cfv vm cv c1 caddc co
      caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv caddc co
      wceq vm cv cn wcel vm cv c1 caddc co cN cle wbr wa vm cv caddc cH cseq1
      co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co
      wceq wa vm cv caddc cH cseq1 co cfv vm cv c1 caddc co cH cfv caddc co vm
      cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1
      caddc co cF cfv vm cv c1 caddc co cG cfv caddc co caddc co vm cv c1 caddc
      co caddc cH cseq1 co cfv vm cv c1 caddc co caddc cF cseq1 co cfv vm cv c1
      caddc co caddc cG cseq1 co cfv caddc co vm cv cn wcel vm cv c1 caddc co
      cN cle wbr wa vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm
      cv caddc cG cseq1 co cfv caddc co wceq wa vm cv caddc cH cseq1 co cfv vm
      cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1
      caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv caddc
      co caddc vm cv cn wcel vm cv c1 caddc co cN cle wbr wa vm cv caddc cH
      cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv
      caddc co wceq pm3.27 vm cv cn wcel vm cv c1 caddc co cN cle wbr wa vm cv
      c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv
      caddc co wceq vm cv caddc cH cseq1 co cfv vm cv caddc cF cseq1 co cfv vm
      cv caddc cG cseq1 co cfv caddc co wceq vm cv c1 caddc co cn wcel vm cv c1
      caddc co cN cle wbr vm cv c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm
      cv c1 caddc co cG cfv caddc co wceq vm cv cn wcel vm cv c1 caddc co cn
      wcel vm cv c1 caddc co cN cle wbr vm cv c1 caddc co cH cfv vm cv c1 caddc
      co cF cfv vm cv c1 caddc co cG cfv caddc co wceq vk cv cN cle wbr vk cv
      cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq wi vm cv c1 caddc co cN
      cle wbr vm cv c1 caddc co cH cfv vm cv c1 caddc co cF cfv vm cv c1 caddc
      co cG cfv caddc co wceq wi vk vm cv c1 caddc co cn vk cv vm cv c1 caddc
      co wceq vk cv cN cle wbr vm cv c1 caddc co cN cle wbr vk cv cH cfv vk cv
      cF cfv vk cv cG cfv caddc co wceq vm cv c1 caddc co cH cfv vm cv c1 caddc
      co cF cfv vm cv c1 caddc co cG cfv caddc co wceq vk cv vm cv c1 caddc co
      cN cle breq1 vk cv vm cv c1 caddc co wceq vk cv cH cfv vm cv c1 caddc co
      cH cfv vk cv cF cfv vk cv cG cfv caddc co vm cv c1 caddc co cF cfv vm cv
      c1 caddc co cG cfv caddc co vk cv vm cv c1 caddc co cH fveq2 vk cv vm cv
      c1 caddc co wceq vk cv cF cfv vm cv c1 caddc co cF cfv vk cv cG cfv vm cv
      c1 caddc co cG cfv caddc vk cv vm cv c1 caddc co cF fveq2 vk cv vm cv c1
      caddc co cG fveq2 opreq12d eqeq12d imbi12d vk cv cn wcel vk cv cN cle wbr
      vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq ser1add.4 ex vtoclga
      imp vm cv peano2nn sylan adantr opreq12d vm cv cn wcel vm cv c1 caddc co
      caddc cH cseq1 co cfv vm cv caddc cH cseq1 co cfv vm cv c1 caddc co cH
      cfv caddc co wceq vm cv c1 caddc co cN cle wbr vm cv caddc cH cseq1 co
      cfv vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq
      vm cv caddc cH addex ser1add.3 seq1p1 ad2antrr vm cv cn wcel vm cv c1
      caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co cfv
      caddc co vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co
      vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv caddc co caddc co wceq
      vm cv c1 caddc co cN cle wbr vm cv caddc cH cseq1 co cfv vm cv caddc cF
      cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co wceq vm cv cn wcel vm
      cv c1 caddc co caddc cF cseq1 co cfv vm cv c1 caddc co caddc cG cseq1 co
      cfv caddc co vm cv caddc cF cseq1 co cfv vm cv c1 caddc co cF cfv caddc
      co vm cv caddc cG cseq1 co cfv vm cv c1 caddc co cG cfv caddc co caddc co
      vm cv caddc cF cseq1 co cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1
      caddc co cF cfv vm cv c1 caddc co cG cfv caddc co caddc co vm cv cn wcel
      vm cv c1 caddc co caddc cF cseq1 co cfv vm cv caddc cF cseq1 co cfv vm cv
      c1 caddc co cF cfv caddc co vm cv c1 caddc co caddc cG cseq1 co cfv vm cv
      caddc cG cseq1 co cfv vm cv c1 caddc co cG cfv caddc co caddc vm cv caddc
      cF addex cn cc cF wf cn cvv wcel cF cvv wcel ser1add.1 nnex cn cc cvv cF
      fex mp2an seq1p1 vm cv caddc cG addex cn cc cG wf cn cvv wcel cG cvv wcel
      ser1add.2 nnex cn cc cvv cG fex mp2an seq1p1 opreq12d vm cv caddc cF
      cseq1 co cfv cc wcel vm cv c1 caddc co cF cfv cc wcel vm cv caddc cG
      cseq1 co cfv cc wcel vm cv c1 caddc co cG cfv cc wcel vm cv caddc cF
      cseq1 co cfv vm cv c1 caddc co cF cfv caddc co vm cv caddc cG cseq1 co
      cfv vm cv c1 caddc co cG cfv caddc co caddc co vm cv caddc cF cseq1 co
      cfv vm cv caddc cG cseq1 co cfv caddc co vm cv c1 caddc co cF cfv vm cv
      c1 caddc co cG cfv caddc co caddc co wceq vm cv cn wcel vm cv caddc cF
      cseq1 co cfv vm cv c1 caddc co cF cfv vm cv caddc cG cseq1 co cfv vm cv
      c1 caddc co cG cfv add4 vm cv cF ser1add.1 ser1cl1i vm cv cn wcel vm cv
      c1 caddc co cn wcel vm cv c1 caddc co cF cfv cc wcel vm cv peano2nn cn cc
      vm cv c1 caddc co cF ser1add.1 ffvelrni syl vm cv cG ser1add.2 ser1cl1i
      vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co cG cfv cc wcel
      vm cv peano2nn cn cc vm cv c1 caddc co cG ser1add.2 ffvelrni syl syl2anc
      eqtrd ad2antrr 3eqtr4d ex imim2d com23 imp an4s anassrs mpdan exp31 imp3a
      com23 nnind mpan2d pm2.43i $.
      $( [24-Jul-2005] $) $( [18-Jul-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The "shift" operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c shift $.  $( Symbol for function shifter. $)

  $( Extend class notation with function shifter. $)
  cshi $a class shift $.

  ${
    $d x y z f g $.
    $( Define a function shifter.  This operation offsets the value argument of
       a function (ordinarily on a subset of ` CC ` ) and produces a new
       function on ` CC ` .  See ~ shftval for its value. $)
    df-shft $a |- shift = { <. <. f , x >. , g >. | g =
                  { <. y , z >. | ( y e. CC /\ z = ( f ` ( y - x ) ) ) } } $.
  $}

  ${
    $d x y w f g A $.  $d x y w f g F $.  $d x y B $.  $d x y C $.
    shftfval.1 $e |- F e. _V $.
    $( The value of the sequence shifter operation is a function on ` CC ` .
       ` A ` is ordinarily an integer. $)
    shftfval $p |- ( A e. B -> ( F shift A ) = { <. x , y >. | ( x e. CC /\
                   y = ( F ` ( x - A ) ) ) } ) $=
      cF cvv wcel cA cB wcel cF cA cshi co vx cv cc wcel vy cv vx cv cA cmin co
      cF cfv wceq wa vx vy copab wceq shftfval.1 vf vw vg cF cA cvv cB vx cv cc
      wcel vy cv vx cv vw cv cmin co vf cv cfv wceq wa vx vy copab vx cv cc
      wcel vy cv vx cv cA cmin co cF cfv wceq wa vx vy copab cshi vx cv cc wcel
      vy cv vx cv vw cv cmin co cF cfv wceq wa vx vy copab vx vy cc vx cv cA
      cmin co cF cfv axcnex opabex2 vf cv cF wceq vx cv cc wcel vy cv vx cv vw
      cv cmin co vf cv cfv wceq wa vx cv cc wcel vy cv vx cv vw cv cmin co cF
      cfv wceq wa vx vy vf cv cF wceq vy cv vx cv vw cv cmin co vf cv cfv wceq
      vy cv vx cv vw cv cmin co cF cfv wceq vx cv cc wcel vf cv cF wceq vx cv
      vw cv cmin co vf cv cfv vx cv vw cv cmin co cF cfv vy cv vx cv vw cv cmin
      co vf cv cF fveq1 eqeq2d anbi2d opabbidv vw cv cA wceq vx cv cc wcel vy
      cv vx cv vw cv cmin co cF cfv wceq wa vx cv cc wcel vy cv vx cv cA cmin
      co cF cfv wceq wa vx vy vw cv cA wceq vy cv vx cv vw cv cmin co cF cfv
      wceq vy cv vx cv cA cmin co cF cfv wceq vx cv cc wcel vw cv cA wceq vx cv
      vw cv cmin co cF cfv vx cv cA cmin co cF cfv vy cv vw cv cA wceq vx cv vw
      cv cmin co vx cv cA cmin co cF vw cv cA vx cv cmin opreq2 fveq2d eqeq2d
      anbi2d opabbidv vw vx vy vf vg df-shft oprabval5 mpan $.
      $( [20-Aug-2005] $) $( [20-Jul-2005] $)

    $( Functionality and domain of a sequence shifted by ` A ` . $)
    shftfn $p |- ( A e. B -> ( F shift A ) Fn CC ) $=
      cA cB wcel cF cA cshi co cc wfn vx cv cc wcel vy cv vx cv cA cmin co cF
      cfv wceq wa vx vy copab cc wfn vx vy cc vx cv cA cmin co cF cfv vx cv cc
      wcel vy cv vx cv cA cmin co cF cfv wceq wa vx vy copab vx cv cA cmin co
      cF fvex vx cv cc wcel vy cv vx cv cA cmin co cF cfv wceq wa vx vy copab
      eqid fnopab2 cA cB wcel cF cA cshi co vx cv cc wcel vy cv vx cv cA cmin
      co cF cfv wceq wa vx vy copab wceq cF cA cshi co cc wfn vx cv cc wcel vy
      cv vx cv cA cmin co cF cfv wceq wa vx vy copab cc wfn wb vx vy cA cB cF
      shftfval.1 shftfval cc cF cA cshi co vx cv cc wcel vy cv vx cv cA cmin co
      cF cfv wceq wa vx vy copab fneq1 syl mpbiri $.
      $( [3-Sep-2005] $) $( [20-Jul-2005] $)

    $( Restriction of a shifted sequence. $)
    shftres $p |- ( ( A e. C /\ B C_ CC ) ->
                  ( ( F shift A ) |` B ) Fn B ) $=
      cF cA cshi co cc wfn cB cc wss cF cA cshi co cB cres cB wfn cA cC wcel cc
      cB cF cA cshi co fnssres cA cC cF shftfval.1 shftfn sylan $.
      $( [4-Sep-2005] $) $( [19-Aug-2005] $)

    $( Value of a restricted shifted sequence. $)
    shftresval $p |- ( B e. C ->
       ( ( ( F shift A ) |` C ) ` B ) = ( ( F shift A ) ` B ) ) $=
      cB cC cF cA cshi co fvres $.
      $( [9-Sep-2005] $) $( [19-Aug-2005] $)

    $( Value of a sequence shifted by ` A ` . $)
    shftval $p |- ( ( A e. C /\ B e. CC ) ->
                    ( ( F shift A ) ` B ) = ( F ` ( B - A ) ) ) $=
      cA cC wcel cB cc wcel cB cF cA cshi co cfv cB vx cv cc wcel vy cv vx cv
      cA cmin co cF cfv wceq wa vx vy copab cfv cB cA cmin co cF cfv cA cC wcel
      cB cF cA cshi co vx cv cc wcel vy cv vx cv cA cmin co cF cfv wceq wa vx
      vy copab vx vy cA cC cF shftfval.1 shftfval fveq1d vx vy cB vx cv cA cmin
      co cF cfv cB cA cmin co cF cfv cc vx cv cc wcel vy cv vx cv cA cmin co cF
      cfv wceq wa vx vy copab vx cv cB wceq vx cv cA cmin co cB cA cmin co cF
      vx cv cB cA cmin opreq1 fveq2d vx cv cc wcel vy cv vx cv cA cmin co cF
      cfv wceq wa vx vy copab eqid cB cA cmin co cF fvex fvopab4 sylan9eq $.
      $( [21-Aug-2005] $) $( [20-Jul-2005] $)

    $( Value of a sequence shifted by ` A - B ` . $)
    shftval2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( F shift ( A - B ) ) ` ( A + C ) ) = ( F ` ( B + C ) ) ) $=
      cA cc wcel cB cc wcel cC cc wcel w3a cA cC caddc co cF cA cB cmin co cshi
      co cfv cA cC caddc co cA cB cmin co cmin co cF cfv cB cC caddc co cF cfv
      cA cB cmin co cc wcel cA cC caddc co cc wcel cA cC caddc co cF cA cB cmin
      co cshi co cfv cA cC caddc co cA cB cmin co cmin co cF cfv wceq cA cc
      wcel cB cc wcel cC cc wcel w3a cA cB cmin co cA cC caddc co cc cF
      shftfval.1 shftval cA cc wcel cB cc wcel cA cB cmin co cc wcel cC cc wcel
      cA cB subcl 3adant3 cA cc wcel cC cc wcel cA cC caddc co cc wcel cB cc
      wcel cA cC addcl 3adant2 sylanc cA cc wcel cB cc wcel cC cc wcel w3a cA
      cC caddc co cA cB cmin co cmin co cB cC caddc co cF cA cc wcel cB cc wcel
      cC cc wcel w3a cA cC caddc co cA cB cmin co cmin co cC cB caddc co cB cC
      caddc co cA cc wcel cC cc wcel cB cc wcel cA cC caddc co cA cB cmin co
      cmin co cC cB caddc co wceq cA cC cB pnncan 3com23 cB cc wcel cC cc wcel
      cB cC caddc co cC cB caddc co wceq cA cc wcel cB cC addcom 3adant1 eqtr4d
      fveq2d eqtrd $.
      $( [21-Aug-2005] $) $( [20-Jul-2005] $)

    $( Value of a sequence shifted by ` A - B ` . $)
    shftval3 $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( F shift ( A - B ) ) ` A ) = ( F ` B ) ) $=
      cA cc wcel cB cc wcel wa cA cc0 caddc co cF cA cB cmin co cshi co cfv cB
      cc0 caddc co cF cfv cA cF cA cB cmin co cshi co cfv cB cF cfv cA cc wcel
      cB cc wcel cc0 cc wcel cA cc0 caddc co cF cA cB cmin co cshi co cfv cB
      cc0 caddc co cF cfv wceq 0cn cA cB cc0 cF shftfval.1 shftval2 mp3an3 cA
      cc wcel cB cc wcel wa cA cc0 caddc co cA cF cA cB cmin co cshi co cA cc
      wcel cA cc0 caddc co cA wceq cB cc wcel cA addid1 adantr fveq2d cA cc
      wcel cB cc wcel wa cB cc0 caddc co cB cF cB cc wcel cB cc0 caddc co cB
      wceq cA cc wcel cB addid1 adantl fveq2d 3eqtr3d $.
      $( [21-Aug-2005] $) $( [20-Jul-2005] $)

    $( Value of a sequence shifted by ` -u A ` . $)
    shftval4 $p |- ( ( A e. CC /\ B e. CC ) ->
                ( ( F shift -u A ) ` B ) = ( F ` ( A + B ) ) ) $=
      cA cc wcel cB cc wcel wa cB cF cA cneg cshi co cfv cB cA cneg cmin co cF
      cfv cA cB caddc co cF cfv cA cneg cc wcel cB cc wcel cB cF cA cneg cshi
      co cfv cB cA cneg cmin co cF cfv wceq cA cc wcel cA cneg cB cc cF
      shftfval.1 shftval cA negcl sylan cA cc wcel cB cc wcel wa cB cA cneg
      cmin co cA cB caddc co cF cA cc wcel cB cc wcel wa cB cA cneg cmin co cB
      cA caddc co cA cB caddc co cB cc wcel cA cc wcel cB cA cneg cmin co cB cA
      caddc co wceq cB cA subneg ancoms cA cB addcom eqtr4d fveq2d eqtrd $.
      $( [26-Aug-2005] $) $( [18-Aug-2005] $)

    $( Value of a shifted sequence. $)
    shftval5 $p |- ( ( A e. CC /\ B e. CC ) ->
                ( ( F shift A ) ` ( B + A ) ) = ( F ` B ) ) $=
      cB cc wcel cA cc wcel cB cA caddc co cF cA cshi co cfv cB cF cfv wceq cB
      cc wcel cA cc wcel wa cB cA caddc co cF cA cshi co cfv cB cA caddc co cA
      cmin co cF cfv cB cF cfv cA cc wcel cB cA caddc co cc wcel cB cA caddc co
      cF cA cshi co cfv cB cA caddc co cA cmin co cF cfv wceq cB cc wcel cA cc
      wcel wa cA cB cA caddc co cc cF shftfval.1 shftval cB cc wcel cA cc wcel
      pm3.27 cB cA addcl sylanc cB cc wcel cA cc wcel wa cB cA caddc co cA cmin
      co cB cF cB cA pncan fveq2d eqtrd ancoms $.
      $( [27-Sep-2005] $) $( [19-Aug-2005] $)

    $( Functionality of a restricted shifted sequence. $)
    shftf $p |- ( ( A e. D /\ B C_ CC /\ A. x e. B ( F ` ( x - A ) ) e. C )
                  -> ( ( F shift A ) |` B ) : B --> C ) $=
      cA cvv wcel cB cc wss vx cv cA cmin co cF cfv cC wcel vx cB wral cB cC cF
      cA cshi co cB cres wf cA cD wcel cB cC cF cA cshi co cB cres wf cF cA
      cshi co cB cres cB wfn vx cv cF cA cshi co cB cres cfv cC wcel vx cB wral
      cA cvv wcel cB cc wss vx cv cA cmin co cF cfv cC wcel vx cB wral w3a vx
      cB cC cF cA cshi co cB cres ffnfv cA cvv wcel cB cc wss cF cA cshi co cB
      cres cB wfn vx cv cA cmin co cF cfv cC wcel vx cB wral cA cB cvv cF
      shftfval.1 shftres 3adant3 cA cvv wcel cB cc wss vx cv cA cmin co cF cfv
      cC wcel vx cB wral vx cv cF cA cshi co cB cres cfv cC wcel vx cB wral cA
      cvv wcel cB cc wss wa vx cv cA cmin co cF cfv cC wcel vx cv cF cA cshi co
      cB cres cfv cC wcel vx cB cA cvv wcel cB cc wss wa vx cv cB wcel wa vx cv
      cA cmin co cF cfv vx cv cF cA cshi co cB cres cfv cC cA cvv wcel cB cc
      wss wa vx cv cB wcel wa vx cv cF cA cshi co cB cres cfv vx cv cF cA cshi
      co cfv vx cv cA cmin co cF cfv vx cv cB wcel vx cv cF cA cshi co cB cres
      cfv vx cv cF cA cshi co cfv wceq cA cvv wcel cB cc wss wa cA vx cv cB cF
      shftfval.1 shftresval adantl cA cvv wcel cB cc wss wa vx cv cB wcel wa cA
      cvv wcel vx cv cc wcel wa vx cv cF cA cshi co cfv vx cv cA cmin co cF cfv
      wceq cA cvv wcel cB cc wss vx cv cB wcel cA cvv wcel vx cv cc wcel wa cB
      cc wss vx cv cB wcel wa vx cv cc wcel cA cvv wcel cB cc vx cv ssel2
      anim2i anassrs cA vx cv cvv cF shftfval.1 shftval syl eqtr2d eleq1d
      ralbidva biimp3a sylanbrc cA cD elisset syl3an1 $.
      $( [28-Sep-2005] $) $( [19-Aug-2005] $)

    $( Composite shift operations. $)
    2shfti $p |- ( ( A e. CC /\ B e. CC ) -> ( ( F shift A ) shift B ) =
                ( F shift ( A + B ) ) ) $=
      cA cc wcel cB cc wcel wa vx cv cc wcel vy cv vx cv cB cmin co cF cA cshi
      co cfv wceq wa vx vy copab vx cv cc wcel vy cv vx cv cA cB caddc co cmin
      co cF cfv wceq wa vx vy copab cF cA cshi co cB cshi co cF cA cB caddc co
      cshi co cA cc wcel cB cc wcel wa vx cv cc wcel vy cv vx cv cB cmin co cF
      cA cshi co cfv wceq wa vx cv cc wcel vy cv vx cv cA cB caddc co cmin co
      cF cfv wceq wa vx vy cA cc wcel cB cc wcel wa vx cv cc wcel vy cv vx cv
      cB cmin co cF cA cshi co cfv wceq vy cv vx cv cA cB caddc co cmin co cF
      cfv wceq cA cc wcel cB cc wcel wa vx cv cc wcel wa vx cv cB cmin co cF cA
      cshi co cfv vx cv cA cB caddc co cmin co cF cfv vy cv vx cv cc wcel cA cc
      wcel cB cc wcel wa vx cv cB cmin co cF cA cshi co cfv vx cv cA cB caddc
      co cmin co cF cfv wceq vx cv cc wcel cA cc wcel cB cc wcel wa wa vx cv cB
      cmin co cF cA cshi co cfv vx cv cB cmin co cA cmin co cF cfv vx cv cA cB
      caddc co cmin co cF cfv cA cc wcel vx cv cB cmin co cc wcel vx cv cB cmin
      co cF cA cshi co cfv vx cv cB cmin co cA cmin co cF cfv wceq vx cv cc
      wcel cA cc wcel cB cc wcel wa wa cA vx cv cB cmin co cc cF shftfval.1
      shftval vx cv cc wcel cA cc wcel cB cc wcel simprl vx cv cc wcel cB cc
      wcel vx cv cB cmin co cc wcel cA cc wcel vx cv cB subcl adantrl sylanc vx
      cv cc wcel cA cc wcel cB cc wcel wa wa vx cv cB cmin co cA cmin co vx cv
      cA cB caddc co cmin co cF vx cv cc wcel cA cc wcel cB cc wcel vx cv cB
      cmin co cA cmin co vx cv cA cB caddc co cmin co wceq vx cv cc wcel cA cc
      wcel cB cc wcel w3a vx cv cA cmin co cB cmin co vx cv cB cmin co cA cmin
      co vx cv cA cB caddc co cmin co vx cv cA cB sub23 vx cv cA cB subsub4
      eqtr3d 3expb fveq2d eqtrd ancoms eqeq2d pm5.32da opabbidv cB cc wcel cF
      cA cshi co cB cshi co vx cv cc wcel vy cv vx cv cB cmin co cF cA cshi co
      cfv wceq wa vx vy copab wceq cA cc wcel vx vy cB cc cF cA cshi co cF cA
      cshi oprex shftfval adantl cA cc wcel cB cc wcel wa cA cB caddc co cc
      wcel cF cA cB caddc co cshi co vx cv cc wcel vy cv vx cv cA cB caddc co
      cmin co cF cfv wceq wa vx vy copab wceq cA cB addcl vx vy cA cB caddc co
      cc cF shftfval.1 shftfval syl 3eqtr4d $.
      $( [5-Sep-2005] $) $( [19-Aug-2005] $)

    $( Cancellation law for the shift operation. $)
    shftcan2 $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( ( F shift -u A ) shift A ) ` B ) = ( F ` B ) ) $=
      cA cc wcel cB cc wcel wa cB cF cA cneg cshi co cA cshi co cfv cB cA cmin
      co cF cA cneg cshi co cfv cB cF cfv cA cB cc cF cA cneg cshi co cF cA
      cneg cshi oprex shftval cB cc wcel cA cc wcel cB cA cmin co cF cA cneg
      cshi co cfv cB cF cfv wceq cB cc wcel cA cc wcel wa cB cA cmin co cF cA
      cneg cshi co cfv cB cA cmin co cA cneg cmin co cF cfv cB cF cfv cA cneg
      cc wcel cB cA cmin co cc wcel cB cA cmin co cF cA cneg cshi co cfv cB cA
      cmin co cA cneg cmin co cF cfv wceq cB cc wcel cA cc wcel wa cA cneg cB
      cA cmin co cc cF shftfval.1 shftval cA cc wcel cA cneg cc wcel cB cc wcel
      cA negcl adantl cB cA subcl sylanc cB cc wcel cA cc wcel wa cB cA cmin co
      cA cneg cmin co cB cF cB cc wcel cA cc wcel wa cB cA cmin co cA cneg cmin
      co cB cA cmin co cA caddc co cB cB cc wcel cA cc wcel cB cA cmin co cc
      wcel cB cA cmin co cA cneg cmin co cB cA cmin co cA caddc co wceq cB cA
      subcl cB cA cmin co cA subneg sylancom cB cA npcan eqtrd fveq2d eqtrd
      ancoms eqtrd $.
      $( [5-Sep-2005] $) $( [4-Aug-2005] $)

    $( Cancellation law for the shift operation. $)
    shftcan1 $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( ( F shift A ) shift -u A ) ` B ) = ( F ` B ) ) $=
      cA cc wcel cB cc wcel wa cB cF cA cneg cneg cshi co cA cneg cshi co cfv
      cB cF cA cshi co cA cneg cshi co cfv cB cF cfv cA cc wcel cB cF cA cneg
      cneg cshi co cA cneg cshi co cfv cB cF cA cshi co cA cneg cshi co cfv
      wceq cB cc wcel cA cc wcel cB cF cA cneg cneg cshi co cA cneg cshi co cF
      cA cshi co cA cneg cshi co cA cc wcel cF cA cneg cneg cshi co cF cA cshi
      co cA cneg cshi cA cc wcel cA cneg cneg cA cF cshi cA negneg opreq2d
      opreq1d fveq1d adantr cA cneg cc wcel cB cc wcel cB cF cA cneg cneg cshi
      co cA cneg cshi co cfv cB cF cfv wceq cA cc wcel cA cneg cB cF shftfval.1
      shftcan2 cA negcl sylan eqtr3d $.
      $( [5-Sep-2005] $) $( [4-Aug-2005] $)

    $( Identity law for the shift operation. $)
    shftidt $p |- ( A e. CC ->
                    ( ( F shift 0 ) ` A ) = ( F ` A ) ) $=
      cA cc wcel cA cF cc0 cshi co cc0 cneg cshi co cfv cA cF cfv cA cF cc0
      cshi co cfv cc0 cc wcel cA cc wcel cA cF cc0 cshi co cc0 cneg cshi co cfv
      cA cF cfv wceq 0cn cc0 cA cF shftfval.1 shftcan1 mpan cA cF cc0 cshi co
      cc0 cneg cshi co cF cc0 cshi co cF cc0 cshi co cc0 cneg cshi co cF cc0
      cc0 cneg caddc co cshi co cF cc0 cshi co cc0 cc wcel cc0 cneg cc wcel cF
      cc0 cshi co cc0 cneg cshi co cF cc0 cc0 cneg caddc co cshi co wceq 0cn
      cc0 0cn negcli cc0 cc0 cneg cF shftfval.1 2shfti mp2an cc0 cc0 cneg caddc
      co cc0 cF cshi cc0 0cn negidi opreq2i eqtri fveq1i syl5eqr $.
      $( [5-Sep-2005] $) $( [19-Aug-2005] $)
  $}

  ${
    $d j k n S $.  $d j k n F $.
    seq1shftid.1 $e |- S e. _V $.
    seq1shftid.2 $e |- F e. _V $.
    $( Identity law for the shift operation in a 1-based sequence builder. $)
    seq1shftid $p |- ( S seq1 ( F shift 0 ) ) = ( S seq1 F ) $=
      cS cF cc0 cshi co cseq1 co cS cF cseq1 co wceq vn cv cS cF cc0 cshi co
      cseq1 co cfv vn cv cS cF cseq1 co cfv wceq vn cn wral vn cv cS cF cc0
      cshi co cseq1 co cfv vn cv cS cF cseq1 co cfv wceq vn cn vj cv cS cF cc0
      cshi co cseq1 co cfv vj cv cS cF cseq1 co cfv wceq c1 cS cF cc0 cshi co
      cseq1 co cfv c1 cS cF cseq1 co cfv wceq vk cv cS cF cc0 cshi co cseq1 co
      cfv vk cv cS cF cseq1 co cfv wceq vk cv c1 caddc co cS cF cc0 cshi co
      cseq1 co cfv vk cv c1 caddc co cS cF cseq1 co cfv wceq vn cv cS cF cc0
      cshi co cseq1 co cfv vn cv cS cF cseq1 co cfv wceq vj vk vn cv vj cv c1
      wceq vj cv cS cF cc0 cshi co cseq1 co cfv c1 cS cF cc0 cshi co cseq1 co
      cfv vj cv cS cF cseq1 co cfv c1 cS cF cseq1 co cfv vj cv c1 cS cF cc0
      cshi co cseq1 co fveq2 vj cv c1 cS cF cseq1 co fveq2 eqeq12d vj cv vk cv
      wceq vj cv cS cF cc0 cshi co cseq1 co cfv vk cv cS cF cc0 cshi co cseq1
      co cfv vj cv cS cF cseq1 co cfv vk cv cS cF cseq1 co cfv vj cv vk cv cS
      cF cc0 cshi co cseq1 co fveq2 vj cv vk cv cS cF cseq1 co fveq2 eqeq12d vj
      cv vk cv c1 caddc co wceq vj cv cS cF cc0 cshi co cseq1 co cfv vk cv c1
      caddc co cS cF cc0 cshi co cseq1 co cfv vj cv cS cF cseq1 co cfv vk cv c1
      caddc co cS cF cseq1 co cfv vj cv vk cv c1 caddc co cS cF cc0 cshi co
      cseq1 co fveq2 vj cv vk cv c1 caddc co cS cF cseq1 co fveq2 eqeq12d vj cv
      vn cv wceq vj cv cS cF cc0 cshi co cseq1 co cfv vn cv cS cF cc0 cshi co
      cseq1 co cfv vj cv cS cF cseq1 co cfv vn cv cS cF cseq1 co cfv vj cv vn
      cv cS cF cc0 cshi co cseq1 co fveq2 vj cv vn cv cS cF cseq1 co fveq2
      eqeq12d c1 cF cc0 cshi co cfv c1 cF cfv c1 cS cF cc0 cshi co cseq1 co cfv
      c1 cS cF cseq1 co cfv c1 cc wcel c1 cF cc0 cshi co cfv c1 cF cfv wceq
      ax1cn c1 cF seq1shftid.2 shftidt ax-mp cS cF cc0 cshi co seq1shftid.1 cF
      cc0 cshi oprex seq11 cS cF seq1shftid.1 seq1shftid.2 seq11 3eqtr4i vk cv
      cn wcel vk cv cS cF cc0 cshi co cseq1 co cfv vk cv cS cF cseq1 co cfv
      wceq vk cv c1 caddc co cS cF cc0 cshi co cseq1 co cfv vk cv c1 caddc co
      cS cF cseq1 co cfv wceq vk cv cn wcel vk cv cS cF cc0 cshi co cseq1 co
      cfv vk cv cS cF cseq1 co cfv wceq wa vk cv cS cF cc0 cshi co cseq1 co cfv
      vk cv c1 caddc co cF cc0 cshi co cfv cS co vk cv cS cF cseq1 co cfv vk cv
      c1 caddc co cF cfv cS co vk cv c1 caddc co cS cF cc0 cshi co cseq1 co cfv
      vk cv c1 caddc co cS cF cseq1 co cfv vk cv cS cF cc0 cshi co cseq1 co cfv
      vk cv cS cF cseq1 co cfv wceq vk cv cn wcel vk cv cS cF cc0 cshi co cseq1
      co cfv vk cv c1 caddc co cF cc0 cshi co cfv cS co vk cv cS cF cseq1 co
      cfv vk cv c1 caddc co cF cc0 cshi co cfv cS co vk cv cS cF cseq1 co cfv
      vk cv c1 caddc co cF cfv cS co vk cv cS cF cc0 cshi co cseq1 co cfv vk cv
      cS cF cseq1 co cfv vk cv c1 caddc co cF cc0 cshi co cfv cS opreq1 vk cv
      cn wcel vk cv c1 caddc co cF cc0 cshi co cfv vk cv c1 caddc co cF cfv vk
      cv cS cF cseq1 co cfv cS vk cv cn wcel vk cv c1 caddc co cc wcel vk cv c1
      caddc co cF cc0 cshi co cfv vk cv c1 caddc co cF cfv wceq vk cv cn wcel
      vk cv cc wcel vk cv c1 caddc co cc wcel vk cv nncn vk cv peano2cn syl vk
      cv c1 caddc co cF seq1shftid.2 shftidt syl opreq2d sylan9eqr vk cv cn
      wcel vk cv c1 caddc co cS cF cc0 cshi co cseq1 co cfv vk cv cS cF cc0
      cshi co cseq1 co cfv vk cv c1 caddc co cF cc0 cshi co cfv cS co wceq vk
      cv cS cF cc0 cshi co cseq1 co cfv vk cv cS cF cseq1 co cfv wceq vk cv cS
      cF cc0 cshi co seq1shftid.1 cF cc0 cshi oprex seq1p1 adantr vk cv cn wcel
      vk cv c1 caddc co cS cF cseq1 co cfv vk cv cS cF cseq1 co cfv vk cv c1
      caddc co cF cfv cS co wceq vk cv cS cF cc0 cshi co cseq1 co cfv vk cv cS
      cF cseq1 co cfv wceq vk cv cS cF seq1shftid.1 seq1shftid.2 seq1p1 adantr
      3eqtr4d ex nnind rgen cS cF cc0 cshi co cseq1 co cn wfn cS cF cseq1 co cn
      wfn cS cF cc0 cshi co cseq1 co cS cF cseq1 co wceq vn cv cS cF cc0 cshi
      co cseq1 co cfv vn cv cS cF cseq1 co cfv wceq vn cn wral wb cS cF cc0
      cshi co seq1shftid.1 cF cc0 cshi oprex seq1fn cS cF seq1shftid.1
      seq1shftid.2 seq1fn vn cn cS cF cc0 cshi co cseq1 co cS cF cseq1 co
      eqfnfv2 mp2an mpbir $.
      $( [6-Sep-2005] $) $( [1-Sep-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Superior limit (lim sup)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c limsup $.

  $( Extend class notation to include the limsup function. $)
  clsp $a class limsup $.

  ${
    $d k x y z F $.
$(
    df-limsupOLD $a |- limsup = { <. x , y >. | y = sup ( { z |
                  E. k e. ZZ ( ran ( x |` ( ZZ>= ` k ) ) C_ RR* /\
        z = sup ( ran ( x |` ( ZZ>= ` k ) ) , RR* , < ) ) } , RR* , `' < ) } $.

    df-limsupOLD2 $a |- limsup = { <. x , y >. | y = sup ( { z |
   E. k e. ZZ z = sup ( ( x " ( ZZ>= ` k ) ) , RR* , < ) } , RR* , `' < ) } $.
$)

    $( Define the superior limit of an infinite sequence of extended real
       numbers.  Definition 12-4.1 of [Gleason] p. 175.  See ~ limsupval for
       its value. $)
    df-limsup $a |- limsup = { <. x , y >. | y = sup ( { z | E. k e. ZZ
   z = sup ( ( ( x " ( ZZ>= ` k ) ) i^i RR* ) , RR* , < ) } , RR* , `' < ) } $.

    $( The superior limit of an infinite sequence ` F ` of extended real
       numbers, which is the infimum (indicated by ` ``' < ` ) of the set of
       suprema of all upper infinite subsequences of ` F ` .  Definition
       12-4.1 of [Gleason] p. 175. $)
    limsupval $p |- ( F e. A -> ( limsup ` F ) = sup ( { x | E. k e. ZZ x =
       sup ( ( ( F " ( ZZ>= ` k ) ) i^i RR* ) , RR* , < ) } , RR* , `' < ) ) $=
      cF cA wcel cF vy cv vx cv vz cv vk cv cuz cfv cima cxr cin cxr clt csup
      wceq vk cz wrex vx cab cxr clt ccnv csup wceq vz vy copab cfv vx cv cF vk
      cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab cxr clt ccnv
      csup cF clsp cfv cF cA wcel vx cv cF vk cv cuz cfv cima cxr cin cxr clt
      csup wceq vk cz wrex vx cab cxr clt ccnv csup cvv wcel cF vy cv vx cv vz
      cv vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab cxr clt
      ccnv csup wceq vz vy copab cfv vx cv cF vk cv cuz cfv cima cxr cin cxr
      clt csup wceq vk cz wrex vx cab cxr clt ccnv csup wceq cxr vx cv cF vk cv
      cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab clt ccnv cxr clt
      wor cxr clt ccnv wor xrltso cxr clt cnvso mpbi supex vz vy cF vx cv vz cv
      vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab cxr clt
      ccnv csup vx cv cF vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz
      wrex vx cab cxr clt ccnv csup cA cvv vz cv cF wceq vx cv vz cv vk cv cuz
      cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab vx cv cF vk cv cuz
      cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab wceq vx cv vz cv vk
      cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab cxr clt ccnv
      csup vx cv cF vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx
      cab cxr clt ccnv csup wceq vz cv cF wceq vx cv vz cv vk cv cuz cfv cima
      cxr cin cxr clt csup wceq vk cz wrex vx cv cF vk cv cuz cfv cima cxr cin
      cxr clt csup wceq vk cz wrex vx vz cv cF wceq vx cv vz cv vk cv cuz cfv
      cima cxr cin cxr clt csup wceq vx cv cF vk cv cuz cfv cima cxr cin cxr
      clt csup wceq vk cz vz cv cF wceq vz cv vk cv cuz cfv cima cxr cin cxr
      clt csup cF vk cv cuz cfv cima cxr cin cxr clt csup vx cv vz cv cF wceq
      vz cv vk cv cuz cfv cima cxr cin cF vk cv cuz cfv cima cxr cin wceq vz cv
      vk cv cuz cfv cima cxr cin cxr clt csup cF vk cv cuz cfv cima cxr cin cxr
      clt csup wceq vz cv cF wceq vz cv vk cv cuz cfv cima cF vk cv cuz cfv
      cima cxr vz cv cF vk cv cuz cfv imaeq1 ineq1d cxr vz cv vk cv cuz cfv
      cima cxr cin cF vk cv cuz cfv cima cxr cin clt supeq1 syl eqeq2d rexbidv
      abbidv cxr vx cv vz cv vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz
      wrex vx cab vx cv cF vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz
      wrex vx cab clt ccnv supeq1 syl fvopabg mpan2 cF clsp vy cv vx cv vz cv
      vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab cxr clt
      ccnv csup wceq vz vy copab vz vy vx vk df-limsup fveq1i syl5eq $.
      $( [30-Oct-2005] $) $( [26-Oct-2005] $)

    $( Closure of the superior limit. $)
    limsupcl $p |- ( F e. A -> ( limsup ` F ) e. RR* ) $=
      cF cA wcel cF clsp cfv vx cv cF vk cv cuz cfv cima cxr cin cxr clt csup
      wceq vk cz wrex vx cab cxr clt ccnv csup cxr vx cA vk cF limsupval vx cv
      cF vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab cxr wss
      vx cv cF vk cv cuz cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab
      cxr clt ccnv csup cxr wcel vx cv cF vk cv cuz cfv cima cxr cin cxr clt
      csup wceq vk cz wrex vx cxr vx cv cF vk cv cuz cfv cima cxr cin cxr clt
      csup wceq vx cv cxr wcel vk cz vx cv cF vk cv cuz cfv cima cxr cin cxr
      clt csup wceq vx cv cxr wcel wi vk cv cz wcel vx cv cF vk cv cuz cfv cima
      cxr cin cxr clt csup wceq vx cv cxr wcel cF vk cv cuz cfv cima cxr cin
      cxr clt csup cxr wcel cF vk cv cuz cfv cima cxr cin cxr wss cF vk cv cuz
      cfv cima cxr cin cxr clt csup cxr wcel cF vk cv cuz cfv cima cxr inss2 cF
      vk cv cuz cfv cima cxr cin supxrcl ax-mp vx cv cF vk cv cuz cfv cima cxr
      cin cxr clt csup cxr eleq1 mpbiri a1i r19.23aiv abssi vx cv cF vk cv cuz
      cfv cima cxr cin cxr clt csup wceq vk cz wrex vx cab infmxrcl ax-mp
      syl6eqel $.
      $( [11-Jun-2007] $) $( [26-Oct-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Infinite sequence builders "seq" and "seq0"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c seq $.  $( Symbol for recursive sequence builder starting at an arbitrary
                index. $)
  $c seq0 $.  $( Symbol for recursive sequence builder starting at index 0. $)

  $( Extend class notation with arbitrarily-based recursive sequence
     builder. $)
  cseqz $a class seq $.
  $( Extend class notation with 0-based recursive sequence builder. $)
  cseq0 $a class seq0 $.

  ${
    $d g h k x $.
    $( Define a recursive sequence builder operation that starts at an
       arbitrary integer index.  See ~ seqz1 and ~ seqzp1 for its initial and
       successor values.  Theorems ~ seq0seqz and ~ seq1seqz derive the
       0-based ` seq0 ` and the 1-based ` seq1 ` as special cases. $)
    df-seqz $a |- seq = { <. <. x , g >. , h >. |
        h = ( ( ( ( 2nd ` x ) seq1 ( g shift ( 1 - ( 1st ` x ) ) ) )
           shift ( ( 1st ` x ) - 1 ) ) |` { k e. ZZ | ( 1st ` x ) <_ k } ) } $.
  $}

$(
  @{
    @d g h k x y z @.
    @( Alternate version of ~ df-seqz . @)
    dfseqz @p |- seq = { <. <. x , g >. , h >. | h = ( ( ( ( 2nd ` x ) seq0 (
     g shift -u ( 1st ` x ) ) ) shift ( 1st ` x ) ) |` ( ZZ>= ` ( 1st ` x ) ) )
      } @=
      ( vy vz cseqz cv c2nd cfv c1st cneg cshi co cseq0 cuz cres wceq copab2
      cvv cxp wral wfn wa wb oprex resexg ax-mp visset pm3.2i biantrur
      oprabbii fnoprab2 df-seqz fneq1 mpbir wcel eqfnoprv mp2an eqid weq
      fveq2 negeqd opreq2d opreq12d reseq1 syl fveq2d reseq2 eqtrd opreq1
      opreq1d oprabval5 syl6reqr rgen2a mpbir2an )
      FCGAGZHIZBGZVPJIZKZLMZNMZVSLM
      ZVSOIZPZQZABCRZQZSSTZWIQZDGZEGZFMZWKWLWGMZQZESUADSUAZFWIUBZWGWIUBWHWJWPUC
      UDWQ????SS??????LUE??SUFUG??????????UHZWRUIUJUKUL??????UMWIF?UNUGUOABCSSW
      EWGWCSUPWESUPWBVSLUEWCWDSUFUGWFVPSUPZVRSUPZUCZWFUCABCXAWFWSWTAUHBUHUIUJUK
      ULDESSSSFWGUQURWIUSWODESWKSUPWLSUPUCWNWKHIZWLWKJIZKZLMZNMZXCLMZXCOIZPZWMA
      BCWKWLSSWEXIWGXBVRXDLMZNMZXCLMZXHPZXGSUPXISUPXFXCLUEXGXHSUFUGADUTZWEXLWDP
      ZXMXNWCXLQWEXOQXNWBXKVSXCLXNVQXBWAXJNVPWKHVAXNVTXDVRLXNVSXCVPWKJVAZVBVCVD
      XPVDWCXLWDVEVFXNWDXHQXOXMQXNVSXCOXPVGWDXHXLVHVFVIBEUTZXLXGQXMXIQXQXKXFXCL
      XQXJXEXBNVRWLXDLVJVCVKXLXGXHVEVFWGUSVL?VMVNVO @.
      @( [ ?] @) @( [27-Sep-2005] @)
  @}
$)

$(
  @{
    @d g h k x @.
    @( Alternate version of ~ df-seqz . @)
    dfseqz @p |- seq = { <. <. x , g >. , h >. |
        h = ( ( ( ( 2nd ` x ) seq1 ( g shift ( 1 - ( 1st ` x ) ) ) )
           shift ( ( 1st ` x ) - 1 ) ) |` ( ZZ>= ` ( 1st ` x ) ) ) } @=
      ( vk cseqz cv c2nd cfv c1 c1st cmin co cshi cseq1 cle wbr cz crab cres
      wceq copab2 cuz df-seqz cvv wcel fvex uzvaltOLD ax-mp reseq2 eqeq2i
      oprabbii
      eqtr4i ) ECFZAFZGHBFIUNJHZKLMLNLUOIKLMLZUODFOPDQRZSZTZABCUAUMUPUO
      UBHZSZTZABCUAABCDUCVBUSABCVAURUMUTUQTZVAURTUOUDUEVCUNJUFUDDUOUGUHUTUQUPUI
      UHUJUKUL @.
      @( [ ?] @) @( [2-Sep-2005] @)
  @}
$)

  ${
    $d f g h $.
    $( Define a recursive sequence builder operation that starts at index 0.
       This is a frequently-used variation of the ` seq1 ` operation (see
       ~ df-seq1 ), which starts at index 1.  See ~ seq00 and ~ seq0p1 for
       its initial and successor values.  See ~ dfseq0 for an alternate
       definition. $)
    df-seq0 $a |- seq0 = { <. <. f , g >. , h >. |
                   h = ( ( ( f seq1 ( g shift 1 ) ) shift -u 1 ) |` NN0 ) } $.
  $}

  ${
    $d f g h k x S $.  $d f g h k x F $.  $d k A $.  $d g h k x M $.  $d k N $.
    seq0val.1 $e |- S e. _V $.
    seq0val.2 $e |- F e. _V $.
    $( Value of the 0-based recursive sequence builder operation. $)
    seq0fval $p |- ( S seq0 F ) =
                  ( ( ( S seq1 ( F shift 1 ) ) shift -u 1 ) |` NN0 ) $=
      cS cvv wcel cF cvv wcel cS cF cseq0 co cS cF c1 cshi co cseq1 co c1 cneg
      cshi co cn0 cres wceq seq0val.1 seq0val.2 vf vg vh cS cF cvv cvv vf cv vg
      cv c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF c1 cshi co cseq1 co
      c1 cneg cshi co cn0 cres cseq0 cS vg cv c1 cshi co cseq1 co c1 cneg cshi
      co cn0 cres cS cF c1 cshi co cseq1 co c1 cneg cshi co cvv wcel cS cF c1
      cshi co cseq1 co c1 cneg cshi co cn0 cres cvv wcel cS cF c1 cshi co cseq1
      co c1 cneg cshi oprex cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cvv
      resexg ax-mp vf cv cS wceq vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi
      co cS vg cv c1 cshi co cseq1 co c1 cneg cshi co wceq vf cv vg cv c1 cshi
      co cseq1 co c1 cneg cshi co cn0 cres cS vg cv c1 cshi co cseq1 co c1 cneg
      cshi co cn0 cres wceq vf cv cS wceq vf cv vg cv c1 cshi co cseq1 co cS vg
      cv c1 cshi co cseq1 co c1 cneg cshi vf cv cS vg cv c1 cshi co cseq1
      opreq1 opreq1d vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co cS vg cv
      c1 cshi co cseq1 co c1 cneg cshi co cn0 reseq1 syl vg cv cF wceq cS vg cv
      c1 cshi co cseq1 co c1 cneg cshi co cS cF c1 cshi co cseq1 co c1 cneg
      cshi co wceq cS vg cv c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF
      c1 cshi co cseq1 co c1 cneg cshi co cn0 cres wceq vg cv cF wceq cS vg cv
      c1 cshi co cseq1 co cS cF c1 cshi co cseq1 co c1 cneg cshi vg cv cF wceq
      vg cv c1 cshi co cF c1 cshi co cS cseq1 vg cv cF c1 cshi opreq1 opreq2d
      opreq1d cS vg cv c1 cshi co cseq1 co c1 cneg cshi co cS cF c1 cshi co
      cseq1 co c1 cneg cshi co cn0 reseq1 syl vf vg vh df-seq0 oprabval5 mp2an
      $.
      $( [20-Aug-2005] $) $( [3-Aug-2005] $)

    $( Value of the 0-based recursive sequence builder operation. $)
    seq0valt $p |- ( N e. NN0 -> ( ( S seq0 F ) ` N ) =
                  ( ( ( S seq1 ( F shift 1 ) ) shift -u 1 ) ` N ) ) $=
      cN cn0 wcel cN cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cfv cN
      cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv cN cS cF cseq0 co cfv cN
      cn0 cS cF c1 cshi co cseq1 co c1 cneg cshi co fvres cN cS cF cseq0 co cS
      cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF seq0val.1 seq0val.2
      seq0fval fveq1i syl5eq $.
      $( [9-Sep-2005] $) $( [19-Aug-2005] $)

    $( Value of the arbitrary-based recursive sequence builder operation. $)
    seqzfval $p |- ( M e. A -> ( <. M , S >. seq F ) =
                   ( ( ( S seq1 ( F shift ( 1 - M ) ) ) shift ( M - 1 ) )
                   |` { k e. ZZ | M <_ k } ) ) $=
      cM cA wcel cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co
      cseq1 co cM cS cop c1st cfv c1 cmin co cshi co cM cS cop c1st cfv vk cv
      cle wbr vk cz crab cres cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin
      co cshi co cM vk cv cle wbr vk cz crab cres cM cS cop cF cseqz co cM cA
      wcel cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co
      cM cS cop c1st cfv c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk
      cz crab cres cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      cM cS cop c1st cfv vk cv cle wbr vk cz crab cres cS cF c1 cM cmin co cshi
      co cseq1 co cM c1 cmin co cshi co cM vk cv cle wbr vk cz crab cres cM cA
      wcel cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co
      cM cS cop c1st cfv c1 cmin co cshi co cS cF c1 cM cmin co cshi co cseq1
      co cM c1 cmin co cshi co wceq cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv
      cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin co cshi co cM cS cop
      c1st cfv vk cv cle wbr vk cz crab cres cS cF c1 cM cmin co cshi co cseq1
      co cM c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres
      wceq cM cA wcel cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi
      co cseq1 co cS cF c1 cM cmin co cshi co cseq1 co cM cS cop c1st cfv c1
      cmin co cM c1 cmin co cshi cM cA wcel cM cS cop c2nd cfv cS cF c1 cM cS
      cop c1st cfv cmin co cshi co cF c1 cM cmin co cshi co cseq1 cM cA wcel cS
      cvv wcel cM cS cop c2nd cfv cS wceq seq0val.1 cM cS cA cvv op2ndg mpan2
      cM cA wcel c1 cM cS cop c1st cfv cmin co c1 cM cmin co cF cshi cM cA wcel
      cM cS cop c1st cfv cM c1 cmin cM cS cA op1stg opreq2d opreq2d opreq12d cM
      cA wcel cM cS cop c1st cfv cM c1 cmin cM cS cA op1stg opreq1d opreq12d cM
      cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS
      cop c1st cfv c1 cmin co cshi co cS cF c1 cM cmin co cshi co cseq1 co cM
      c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab reseq1 syl
      cM cA wcel cM cS cop c1st cfv vk cv cle wbr vk cz crab cM vk cv cle wbr
      vk cz crab wceq cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi
      co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres cS cF c1 cM cmin co
      cshi co cseq1 co cM c1 cmin co cshi co cM vk cv cle wbr vk cz crab cres
      wceq cM cA wcel cM cS cop c1st cfv vk cv cle wbr cM vk cv cle wbr vk cz
      cM cA wcel cM cS cop c1st cfv cM vk cv cle cM cS cA op1stg breq1d
      rabbisdv cM cS cop c1st cfv vk cv cle wbr vk cz crab cM vk cv cle wbr vk
      cz crab cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co reseq2
      syl eqtrd cM cS cop cvv wcel cF cvv wcel cM cS cop cF cseqz co cM cS cop
      c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st
      cfv c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres
      wceq cM cS opex seq0val.2 vx vg vh cM cS cop cF cvv cvv vx cv c2nd cfv vg
      cv c1 vx cv c1st cfv cmin co cshi co cseq1 co vx cv c1st cfv c1 cmin co
      cshi co vx cv c1st cfv vk cv cle wbr vk cz crab cres cM cS cop c2nd cfv
      cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1
      cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres cseqz cM
      cS cop c2nd cfv vg cv c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM
      cS cop c1st cfv c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz
      crab cres cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co
      cseq1 co cM cS cop c1st cfv c1 cmin co cshi co cvv wcel cM cS cop c2nd
      cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv
      c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres cvv
      wcel cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co
      cM cS cop c1st cfv c1 cmin co cshi oprex cM cS cop c2nd cfv cF c1 cM cS
      cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin co cshi
      co cM cS cop c1st cfv vk cv cle wbr vk cz crab cvv resexg ax-mp vx cv cM
      cS cop wceq vx cv c2nd cfv vg cv c1 vx cv c1st cfv cmin co cshi co cseq1
      co vx cv c1st cfv c1 cmin co cshi co vx cv c1st cfv vk cv cle wbr vk cz
      crab cres cM cS cop c2nd cfv vg cv c1 cM cS cop c1st cfv cmin co cshi co
      cseq1 co cM cS cop c1st cfv c1 cmin co cshi co vx cv c1st cfv vk cv cle
      wbr vk cz crab cres cM cS cop c2nd cfv vg cv c1 cM cS cop c1st cfv cmin
      co cshi co cseq1 co cM cS cop c1st cfv c1 cmin co cshi co cM cS cop c1st
      cfv vk cv cle wbr vk cz crab cres vx cv cM cS cop wceq vx cv c2nd cfv vg
      cv c1 vx cv c1st cfv cmin co cshi co cseq1 co vx cv c1st cfv c1 cmin co
      cshi co cM cS cop c2nd cfv vg cv c1 cM cS cop c1st cfv cmin co cshi co
      cseq1 co cM cS cop c1st cfv c1 cmin co cshi co wceq vx cv c2nd cfv vg cv
      c1 vx cv c1st cfv cmin co cshi co cseq1 co vx cv c1st cfv c1 cmin co cshi
      co vx cv c1st cfv vk cv cle wbr vk cz crab cres cM cS cop c2nd cfv vg cv
      c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin
      co cshi co vx cv c1st cfv vk cv cle wbr vk cz crab cres wceq vx cv cM cS
      cop wceq vx cv c2nd cfv vg cv c1 vx cv c1st cfv cmin co cshi co cseq1 co
      cM cS cop c2nd cfv vg cv c1 cM cS cop c1st cfv cmin co cshi co cseq1 co
      vx cv c1st cfv c1 cmin co cM cS cop c1st cfv c1 cmin co cshi vx cv cM cS
      cop wceq vx cv c2nd cfv cM cS cop c2nd cfv vg cv c1 vx cv c1st cfv cmin
      co cshi co vg cv c1 cM cS cop c1st cfv cmin co cshi co cseq1 vx cv cM cS
      cop c2nd fveq2 vx cv cM cS cop wceq c1 vx cv c1st cfv cmin co c1 cM cS
      cop c1st cfv cmin co vg cv cshi vx cv cM cS cop wceq vx cv c1st cfv cM cS
      cop c1st cfv c1 cmin vx cv cM cS cop c1st fveq2 opreq2d opreq2d opreq12d
      vx cv cM cS cop wceq vx cv c1st cfv cM cS cop c1st cfv c1 cmin vx cv cM
      cS cop c1st fveq2 opreq1d opreq12d vx cv c2nd cfv vg cv c1 vx cv c1st cfv
      cmin co cshi co cseq1 co vx cv c1st cfv c1 cmin co cshi co cM cS cop c2nd
      cfv vg cv c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st
      cfv c1 cmin co cshi co vx cv c1st cfv vk cv cle wbr vk cz crab reseq1 syl
      vx cv cM cS cop wceq vx cv c1st cfv vk cv cle wbr vk cz crab cM cS cop
      c1st cfv vk cv cle wbr vk cz crab wceq cM cS cop c2nd cfv vg cv c1 cM cS
      cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin co cshi
      co vx cv c1st cfv vk cv cle wbr vk cz crab cres cM cS cop c2nd cfv vg cv
      c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin
      co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres wceq vx cv cM
      cS cop wceq vx cv c1st cfv vk cv cle wbr cM cS cop c1st cfv vk cv cle wbr
      vk cz vx cv cM cS cop wceq vx cv c1st cfv cM cS cop c1st cfv vk cv cle vx
      cv cM cS cop c1st fveq2 breq1d rabbisdv vx cv c1st cfv vk cv cle wbr vk
      cz crab cM cS cop c1st cfv vk cv cle wbr vk cz crab cM cS cop c2nd cfv vg
      cv c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1
      cmin co cshi co reseq2 syl eqtrd vg cv cF wceq cM cS cop c2nd cfv vg cv
      c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin
      co cshi co cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co
      cseq1 co cM cS cop c1st cfv c1 cmin co cshi co wceq cM cS cop c2nd cfv vg
      cv c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1
      cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab cres cM cS
      cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop
      c1st cfv c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab
      cres wceq vg cv cF wceq cM cS cop c2nd cfv vg cv c1 cM cS cop c1st cfv
      cmin co cshi co cseq1 co cM cS cop c2nd cfv cF c1 cM cS cop c1st cfv cmin
      co cshi co cseq1 co cM cS cop c1st cfv c1 cmin co cshi vg cv cF wceq vg
      cv c1 cM cS cop c1st cfv cmin co cshi co cF c1 cM cS cop c1st cfv cmin co
      cshi co cM cS cop c2nd cfv cseq1 vg cv cF c1 cM cS cop c1st cfv cmin co
      cshi opreq1 opreq2d opreq1d cM cS cop c2nd cfv vg cv c1 cM cS cop c1st
      cfv cmin co cshi co cseq1 co cM cS cop c1st cfv c1 cmin co cshi co cM cS
      cop c2nd cfv cF c1 cM cS cop c1st cfv cmin co cshi co cseq1 co cM cS cop
      c1st cfv c1 cmin co cshi co cM cS cop c1st cfv vk cv cle wbr vk cz crab
      reseq1 syl vx vg vh vk df-seqz oprabval5 mp2an syl5eq $.
      $( [6-Sep-2005] $) $( [1-Sep-2005] $)

    $( Value of the arbitrary-based recursive sequence builder operation. $)
    seqzfval2 $p |- ( M e. ZZ -> ( <. M , S >. seq F ) =
                   ( ( ( S seq1 ( F shift ( 1 - M ) ) ) shift ( M - 1 ) )
                   |` ( ZZ>= ` M ) ) ) $=
      cM cz wcel cM cS cop cF cseqz co cS cF c1 cM cmin co cshi co cseq1 co cM
      c1 cmin co cshi co cM vk cv cle wbr vk cz crab cres cS cF c1 cM cmin co
      cshi co cseq1 co cM c1 cmin co cshi co cM cuz cfv cres cz cS vk cF cM
      seq0val.1 seq0val.2 seqzfval cM cz wcel cM cuz cfv cM vk cv cle wbr vk cz
      crab wceq cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM
      cuz cfv cres cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      cM vk cv cle wbr vk cz crab cres wceq vk cM uzval cM cuz cfv cM vk cv cle
      wbr vk cz crab cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      reseq2 syl eqtr4d $.
      $( [13-Sep-2005] $) $( [5-Sep-2005] $)

    $( Functionality and domain of a sequence generated by the arbitrary-based
       recursive sequence builder. $)
    seqzfn $p |- ( M e. ZZ ->
                 ( <. M , S >. seq F ) Fn ( ZZ>= ` M ) ) $=
      cM cz wcel cM cS cop cF cseqz co cM cuz cfv wfn cS cF c1 cM cmin co cshi
      co cseq1 co cM c1 cmin co cshi co cM cuz cfv cres cM cuz cfv wfn cS cF c1
      cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cc wfn cM cuz cfv cc
      wss cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM cuz cfv
      cres cM cuz cfv wfn cM c1 cmin co cvv wcel cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cc wfn cM c1 cmin oprex cM c1 cmin co cvv
      cS cF c1 cM cmin co cshi co cseq1 co cS cF c1 cM cmin co cshi co cseq1
      oprex shftfn ax-mp cM cuz cfv cz cc cM uzssz zsscn sstri cc cM cuz cfv cS
      cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co fnssres mp2an cM
      cz wcel cM cS cop cF cseqz co cS cF c1 cM cmin co cshi co cseq1 co cM c1
      cmin co cshi co cM cuz cfv cres wceq cM cS cop cF cseqz co cM cuz cfv wfn
      cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM cuz cfv
      cres cM cuz cfv wfn wb cS cF cM seq0val.1 seq0val.2 seqzfval2 cM cuz cfv
      cM cS cop cF cseqz co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co
      cshi co cM cuz cfv cres fneq1 syl mpbiri $.
      $( [15-Sep-2005] $) $( [2-Sep-2005] $)

    $( Value of the arbitrary-based recursive sequence builder operation. $)
    seqzval $p |- ( ( M e. A /\ N e. ZZ /\ M <_ N ) ->
                   ( ( <. M , S >. seq F ) ` N ) =
              ( ( ( S seq1 ( F shift ( 1 - M ) ) ) shift ( M - 1 ) ) ` N ) ) $=
      cM cA wcel cN cz wcel cM cN cle wbr w3a cN cM cS cop cF cseqz co cfv cN
      cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM vk cv cle
      wbr vk cz crab cres cfv cN cS cF c1 cM cmin co cshi co cseq1 co cM c1
      cmin co cshi co cfv cM cA wcel cN cz wcel cN cM cS cop cF cseqz co cfv cN
      cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM vk cv cle
      wbr vk cz crab cres cfv wceq cM cN cle wbr cM cA wcel cN cM cS cop cF
      cseqz co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM vk
      cv cle wbr vk cz crab cres cA cS vk cF cM seq0val.1 seq0val.2 seqzfval
      fveq1d 3ad2ant1 cM cA wcel cN cz wcel cM cN cle wbr w3a cN cM vk cv cle
      wbr vk cz crab wcel cN cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co
      cshi co cM vk cv cle wbr vk cz crab cres cfv cN cS cF c1 cM cmin co cshi
      co cseq1 co cM c1 cmin co cshi co cfv wceq cM cA wcel cN cz wcel cM cN
      cle wbr w3a cN cz wcel cM cN cle wbr wa cN cM vk cv cle wbr vk cz crab
      wcel cM cA wcel cN cz wcel cM cN cle wbr 3simpc cM vk cv cle wbr cM cN
      cle wbr vk cN cz vk cv cN cM cle breq2 elrab sylibr cN cM vk cv cle wbr
      vk cz crab cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      fvres syl eqtrd $.
      $( [10-Sep-2005] $) $( [1-Sep-2005] $)

    $( The 1-based recursive sequence in terms of the arbitrary-based one. $)
    seq1seqz $p |- ( S seq1 F ) = ( <. 1 , S >. seq F ) $=
      cS cF cseq1 co cS cF c1 c1 cmin co cshi co cseq1 co c1 c1 cmin co cshi co
      c1 vk cv cle wbr vk cz crab cres c1 cS cop cF cseqz co cS cF cc0 cshi co
      cseq1 co cS cF c1 c1 cmin co cshi co cseq1 co c1 c1 cmin co cshi co cn
      cres cS cF cseq1 co cS cF c1 c1 cmin co cshi co cseq1 co c1 c1 cmin co
      cshi co c1 vk cv cle wbr vk cz crab cres cS cF cc0 cshi co cseq1 co cS cF
      cc0 cshi co cseq1 co cc0 cshi co cn cres cS cF c1 c1 cmin co cshi co
      cseq1 co c1 c1 cmin co cshi co cn cres cS cF cc0 cshi co cseq1 co cS cF
      cc0 cshi co cseq1 co cc0 cshi co cn cres wceq vk cv cS cF cc0 cshi co
      cseq1 co cfv vk cv cS cF cc0 cshi co cseq1 co cc0 cshi co cn cres cfv
      wceq vk cn wral vk cv cS cF cc0 cshi co cseq1 co cfv vk cv cS cF cc0 cshi
      co cseq1 co cc0 cshi co cn cres cfv wceq vk cn vk cv cn wcel vk cv cS cF
      cc0 cshi co cseq1 co cc0 cshi co cn cres cfv vk cv cS cF cc0 cshi co
      cseq1 co cc0 cshi co cfv vk cv cS cF cc0 cshi co cseq1 co cfv vk cv cn cS
      cF cc0 cshi co cseq1 co cc0 cshi co fvres vk cv cn wcel vk cv cc wcel vk
      cv cS cF cc0 cshi co cseq1 co cc0 cshi co cfv vk cv cS cF cc0 cshi co
      cseq1 co cfv wceq vk cv nncn vk cv cS cF cc0 cshi co cseq1 co cS cF cc0
      cshi co cseq1 oprex shftidt syl eqtr2d rgen cS cF cc0 cshi co cseq1 co cn
      wfn cS cF cc0 cshi co cseq1 co cc0 cshi co cn cres cn wfn cS cF cc0 cshi
      co cseq1 co cS cF cc0 cshi co cseq1 co cc0 cshi co cn cres wceq vk cv cS
      cF cc0 cshi co cseq1 co cfv vk cv cS cF cc0 cshi co cseq1 co cc0 cshi co
      cn cres cfv wceq vk cn wral wb cS cF cc0 cshi co seq0val.1 cF cc0 cshi
      oprex seq1fn cc0 cc wcel cn cc wss cS cF cc0 cshi co cseq1 co cc0 cshi co
      cn cres cn wfn 0cn nnsscn cc0 cn cc cS cF cc0 cshi co cseq1 co cS cF cc0
      cshi co cseq1 oprex shftres mp2an vk cn cS cF cc0 cshi co cseq1 co cS cF
      cc0 cshi co cseq1 co cc0 cshi co cn cres eqfnfv2 mp2an mpbir cS cF c1 c1
      cmin co cshi co cseq1 co c1 c1 cmin co cshi co cS cF cc0 cshi co cseq1 co
      cc0 cshi co wceq cS cF c1 c1 cmin co cshi co cseq1 co c1 c1 cmin co cshi
      co cn cres cS cF cc0 cshi co cseq1 co cc0 cshi co cn cres wceq cS cF c1
      c1 cmin co cshi co cseq1 co cS cF cc0 cshi co cseq1 co c1 c1 cmin co cc0
      cshi cF c1 c1 cmin co cshi co cF cc0 cshi co cS cseq1 c1 c1 cmin co cc0
      cF cshi c1 ax1cn subidi opreq2i opreq2i c1 ax1cn subidi opreq12i cS cF c1
      c1 cmin co cshi co cseq1 co c1 c1 cmin co cshi co cS cF cc0 cshi co cseq1
      co cc0 cshi co cn reseq1 ax-mp eqtr4i cS cF seq0val.1 seq0val.2
      seq1shftid cn c1 vk cv cle wbr vk cz crab wceq cS cF c1 c1 cmin co cshi
      co cseq1 co c1 c1 cmin co cshi co cn cres cS cF c1 c1 cmin co cshi co
      cseq1 co c1 c1 cmin co cshi co c1 vk cv cle wbr vk cz crab cres wceq vk
      nnzrab cn c1 vk cv cle wbr vk cz crab cS cF c1 c1 cmin co cshi co cseq1
      co c1 c1 cmin co cshi co reseq2 ax-mp 3eqtr3i c1 cc wcel c1 cS cop cF
      cseqz co cS cF c1 c1 cmin co cshi co cseq1 co c1 c1 cmin co cshi co c1 vk
      cv cle wbr vk cz crab cres wceq ax1cn cc cS vk cF c1 seq0val.1 seq0val.2
      seqzfval ax-mp eqtr4i $.
      $( [6-Sep-2005] $) $( [1-Sep-2005] $)

    $( The 0-based recursive sequence in terms of the arbitrary-based one. $)
    seq0seqz $p |- ( S seq0 F ) = ( <. 0 , S >. seq F ) $=
      cS cF cseq0 co cS cF c1 cc0 cmin co cshi co cseq1 co cc0 c1 cmin co cshi
      co cc0 vk cv cle wbr vk cz crab cres cc0 cS cop cF cseqz co cS cF cseq0
      co cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF c1 cc0 cmin
      co cshi co cseq1 co cc0 c1 cmin co cshi co cn0 cres cS cF c1 cc0 cmin co
      cshi co cseq1 co cc0 c1 cmin co cshi co cc0 vk cv cle wbr vk cz crab cres
      cS cF seq0val.1 seq0val.2 seq0fval cS cF c1 cshi co cseq1 co c1 cneg cshi
      co cS cF c1 cc0 cmin co cshi co cseq1 co cc0 c1 cmin co cshi co wceq cS
      cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF c1 cc0 cmin co cshi
      co cseq1 co cc0 c1 cmin co cshi co cn0 cres wceq cS cF c1 cshi co cseq1
      co cS cF c1 cc0 cmin co cshi co cseq1 co c1 cneg cc0 c1 cmin co cshi cF
      c1 cshi co cF c1 cc0 cmin co cshi co cS cseq1 c1 c1 cc0 cmin co cF cshi
      c1 cc0 cmin co c1 c1 ax1cn subid1i eqcomi opreq2i opreq2i c1 df-neg
      opreq12i cS cF c1 cshi co cseq1 co c1 cneg cshi co cS cF c1 cc0 cmin co
      cshi co cseq1 co cc0 c1 cmin co cshi co cn0 reseq1 ax-mp cn0 cc0 vk cv
      cle wbr vk cz crab wceq cS cF c1 cc0 cmin co cshi co cseq1 co cc0 c1 cmin
      co cshi co cn0 cres cS cF c1 cc0 cmin co cshi co cseq1 co cc0 c1 cmin co
      cshi co cc0 vk cv cle wbr vk cz crab cres wceq vk nn0zrab cn0 cc0 vk cv
      cle wbr vk cz crab cS cF c1 cc0 cmin co cshi co cseq1 co cc0 c1 cmin co
      cshi co reseq2 ax-mp 3eqtri cc0 cc wcel cc0 cS cop cF cseqz co cS cF c1
      cc0 cmin co cshi co cseq1 co cc0 c1 cmin co cshi co cc0 vk cv cle wbr vk
      cz crab cres wceq 0cn cc cS vk cF cc0 seq0val.1 seq0val.2 seqzfval ax-mp
      eqtr4i $.
      $( [7-Sep-2005] $) $( [1-Sep-2005] $)

    $( A relationship between the 1-based and 0-based recursive sequence
       builders. $)
    seq1seq02 $p |- ( N e. NN ->
  ( ( S seq1 ( F shift 1 ) ) ` N ) = ( ( ( S seq0 F ) shift 1 ) ` N ) ) $=
      cN cn wcel cN cS cF cseq0 co c1 cshi co cfv cN c1 cmin co cS cF cseq0 co
      cfv cN c1 cmin co cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv cN cS cF
      c1 cshi co cseq1 co cfv c1 cc wcel cN cc wcel cN cS cF cseq0 co c1 cshi
      co cfv cN c1 cmin co cS cF cseq0 co cfv wceq cN cn wcel c1 cN cc cS cF
      cseq0 co cS cF cseq0 oprex shftval ax1cn cN nncn sylancr cN cn wcel cN c1
      cmin co cn0 wcel cN c1 cmin co cS cF cseq0 co cfv cN c1 cmin co cS cF c1
      cshi co cseq1 co c1 cneg cshi co cfv wceq cN nnm1nn0 cS cF cN c1 cmin co
      seq0val.1 seq0val.2 seq0valt syl cN cn wcel cN c1 cmin co cS cF c1 cshi
      co cseq1 co c1 cneg cshi co cfv c1 cN c1 cmin co caddc co cS cF c1 cshi
      co cseq1 co cfv cN cS cF c1 cshi co cseq1 co cfv cN cn wcel cN cc wcel cN
      c1 cmin co cc wcel cN c1 cmin co cS cF c1 cshi co cseq1 co c1 cneg cshi
      co cfv c1 cN c1 cmin co caddc co cS cF c1 cshi co cseq1 co cfv wceq cN
      nncn cN cc wcel c1 cc wcel cN c1 cmin co cc wcel ax1cn cN c1 subcl mpan2
      c1 cc wcel cN c1 cmin co cc wcel cN c1 cmin co cS cF c1 cshi co cseq1 co
      c1 cneg cshi co cfv c1 cN c1 cmin co caddc co cS cF c1 cshi co cseq1 co
      cfv wceq ax1cn c1 cN c1 cmin co cS cF c1 cshi co cseq1 co cS cF c1 cshi
      co cseq1 oprex shftval4 mpan 3syl cN cn wcel c1 cN c1 cmin co caddc co cN
      cS cF c1 cshi co cseq1 co c1 cc wcel cN cc wcel c1 cN c1 cmin co caddc co
      cN wceq cN cn wcel c1 cN pncan3 ax1cn cN nncn sylancr fveq2d eqtrd
      3eqtrrd $.
      $( [10-Sep-2005] $) $( [19-Aug-2005] $)

    $( The 1-based recursive sequence builder operation in terms of the 0-based
       one. $)
    seq1seq01 $p |- ( N e. NN -> ( ( S seq1 F ) ` N ) =
            ( ( ( S seq0 ( F shift -u 1 ) ) shift 1 ) ` N ) ) $=
      cN cn wcel cN cS cF c1 cneg cshi co c1 cshi co cseq1 co cfv cN cS cF c1
      cneg cshi co cseq0 co c1 cshi co cfv cN cS cF cseq1 co cfv cS cF c1 cneg
      cshi co cN seq0val.1 cF c1 cneg cshi oprex seq1seq02 cN cS cF cseq1 co cS
      cF c1 cneg cshi co c1 cshi co cseq1 co cS cF c1 cneg cshi co c1 cshi co
      cseq1 co cS cF cc0 cshi co cseq1 co cS cF cseq1 co cF c1 cneg cshi co c1
      cshi co cF cc0 cshi co cS cseq1 cF c1 cneg cshi co c1 cshi co cF c1 cneg
      c1 caddc co cshi co cF cc0 cshi co c1 cneg cc wcel c1 cc wcel cF c1 cneg
      cshi co c1 cshi co cF c1 cneg c1 caddc co cshi co wceq c1 ax1cn negcli
      ax1cn c1 cneg c1 cF seq0val.2 2shfti mp2an c1 cneg c1 caddc co cc0 cF
      cshi c1 cneg c1 caddc co c1 c1 cneg caddc co cc0 c1 cneg c1 c1 ax1cn
      negcli ax1cn addcomi c1 ax1cn negidi eqtri opreq2i eqtri opreq2i cS cF
      seq0val.1 seq0val.2 seq1shftid eqtr2i fveq1i syl5eq $.
      $( [27-Sep-2005] $) $( [4-Sep-2005] $)

    $( The 1-based recursive sequence builder operation in terms of the 0-based
       one. $)
    seq1seq0 $p |- ( S seq1 F ) =
            ( ( ( S seq0 ( F shift -u 1 ) ) shift 1 ) |` NN ) $=
      cS cF cseq1 co cS cF c1 cneg cshi co cseq0 co c1 cshi co cn cres wceq vk
      cv cS cF cseq1 co cfv vk cv cS cF c1 cneg cshi co cseq0 co c1 cshi co cn
      cres cfv wceq vk cn wral vk cv cS cF cseq1 co cfv vk cv cS cF c1 cneg
      cshi co cseq0 co c1 cshi co cn cres cfv wceq vk cn vk cv cn wcel vk cv cS
      cF cseq1 co cfv vk cv cS cF c1 cneg cshi co cseq0 co c1 cshi co cfv vk cv
      cS cF c1 cneg cshi co cseq0 co c1 cshi co cn cres cfv cS cF vk cv
      seq0val.1 seq0val.2 seq1seq01 vk cv cn cS cF c1 cneg cshi co cseq0 co c1
      cshi co fvres eqtr4d rgen cS cF cseq1 co cn wfn cS cF c1 cneg cshi co
      cseq0 co c1 cshi co cn cres cn wfn cS cF cseq1 co cS cF c1 cneg cshi co
      cseq0 co c1 cshi co cn cres wceq vk cv cS cF cseq1 co cfv vk cv cS cF c1
      cneg cshi co cseq0 co c1 cshi co cn cres cfv wceq vk cn wral wb cS cF
      seq0val.1 seq0val.2 seq1fn c1 cc wcel cn cc wss cS cF c1 cneg cshi co
      cseq0 co c1 cshi co cn cres cn wfn ax1cn nnsscn c1 cn cc cS cF c1 cneg
      cshi co cseq0 co cS cF c1 cneg cshi co cseq0 oprex shftres mp2an vk cn cS
      cF cseq1 co cS cF c1 cneg cshi co cseq0 co c1 cshi co cn cres eqfnfv2
      mp2an mpbir $.
      $( [1-Oct-2005] $) $( [4-Sep-2005] $)

    $( Functionality and domain of the 0-based recursive sequence builder. $)
    seq0fn $p |- ( S seq0 F ) Fn NN0 $=
      cS cF cseq0 co cn0 wfn cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres
      cn0 wfn cS cF c1 cshi co cseq1 co c1 cneg cshi co cc wfn cn0 cc wss cS cF
      c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cn0 wfn c1 cneg cvv wcel cS
      cF c1 cshi co cseq1 co c1 cneg cshi co cc wfn c1 negex c1 cneg cvv cS cF
      c1 cshi co cseq1 co cS cF c1 cshi co cseq1 oprex shftfn ax-mp nn0sscn cc
      cn0 cS cF c1 cshi co cseq1 co c1 cneg cshi co fnssres mp2an cS cF cseq0
      co cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres wceq cS cF cseq0 co
      cn0 wfn cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cn0 wfn wb cS
      cF seq0val.1 seq0val.2 seq0fval cn0 cS cF cseq0 co cS cF c1 cshi co cseq1
      co c1 cneg cshi co cn0 cres fneq1 ax-mp mpbir $.
      $( [10-Sep-2005] $) $( [3-Aug-2005] $)

    $( Value of the arbitrary-based recursive sequence builder at its initial
       value. $)
    seqz1 $p |- ( M e. ZZ -> ( ( <. M , S >. seq F ) ` M ) = ( F ` M ) ) $=
      cM cz wcel cM cM cS cop cF cseqz co cfv cM cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cM vk cv cle wbr vk cz crab cres cfv cM cS
      cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cfv cM cF cfv cM
      cz wcel cM cM cS cop cF cseqz co cS cF c1 cM cmin co cshi co cseq1 co cM
      c1 cmin co cshi co cM vk cv cle wbr vk cz crab cres cz cS vk cF cM
      seq0val.1 seq0val.2 seqzfval fveq1d cM cz wcel cM cM vk cv cle wbr vk cz
      crab wcel cM cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      cM vk cv cle wbr vk cz crab cres cfv cM cS cF c1 cM cmin co cshi co cseq1
      co cM c1 cmin co cshi co cfv wceq cM cz wcel cM cz wcel cM cM cle wbr wa
      cM cM vk cv cle wbr vk cz crab wcel cM cz wcel cM cM cle wbr cM cz wcel
      cM cr wcel cM cM cle wbr cM zre cM leid syl ancli cM vk cv cle wbr cM cM
      cle wbr vk cM cz vk cv cM cM cle breq2 elrab sylibr cM cM vk cv cle wbr
      vk cz crab cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      fvres syl cM cz wcel cM cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin
      co cshi co cfv cM cM c1 cmin co cmin co cS cF c1 cM cmin co cshi co cseq1
      co cfv c1 cF c1 cM cmin co cshi co cfv cM cF cfv cM c1 cmin co cvv wcel
      cM cc wcel cM cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      cfv cM cM c1 cmin co cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv
      wceq cM cz wcel cM c1 cmin co cM cvv cS cF c1 cM cmin co cshi co cseq1 co
      cS cF c1 cM cmin co cshi co cseq1 oprex shftval cM c1 cmin oprex cM zcn
      sylancr cM cz wcel cM cM c1 cmin co cmin co cS cF c1 cM cmin co cshi co
      cseq1 co cfv c1 cS cF c1 cM cmin co cshi co cseq1 co cfv c1 cF c1 cM cmin
      co cshi co cfv cM cz wcel cM cM c1 cmin co cmin co c1 cS cF c1 cM cmin co
      cshi co cseq1 co cM cc wcel c1 cc wcel cM cM c1 cmin co cmin co c1 wceq
      cM cz wcel cM c1 nncan cM zcn ax1cn sylancl fveq2d cS cF c1 cM cmin co
      cshi co seq0val.1 cF c1 cM cmin co cshi oprex seq11 syl6eq c1 cc wcel cM
      cc wcel c1 cF c1 cM cmin co cshi co cfv cM cF cfv wceq cM cz wcel c1 cM
      cF seq0val.2 shftval3 ax1cn cM zcn sylancr 3eqtrd 3eqtrd $.
      $( [8-Sep-2005] $) $( [1-Sep-2005] $)

    $( Value of the arbitrary-based recursive sequence builder at a successor
       value. $)
    seqzp1 $p |- ( N e. ( ZZ>= ` M ) ->
                 ( ( <. M , S >. seq F ) ` ( N + 1 ) ) =
                 ( ( ( <. M , S >. seq F ) ` N ) S ( F ` ( N + 1 ) ) ) ) $=
      cN cM cuz cfv wcel cN c1 caddc co cM cS cop cF cseqz co cfv cN c1 caddc
      co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM vk cv
      cle wbr vk cz crab cres cfv cN cM cS cop cF cseqz co cfv cN c1 caddc co
      cF cfv cS co cN cM cuz cfv wcel cM cz wcel cN c1 caddc co cM cS cop cF
      cseqz co cfv cN c1 caddc co cS cF c1 cM cmin co cshi co cseq1 co cM c1
      cmin co cshi co cM vk cv cle wbr vk cz crab cres cfv wceq cM cN eluzel2
      cM cz wcel cN c1 caddc co cM cS cop cF cseqz co cS cF c1 cM cmin co cshi
      co cseq1 co cM c1 cmin co cshi co cM vk cv cle wbr vk cz crab cres cz cS
      vk cF cM seq0val.1 seq0val.2 seqzfval fveq1d syl cN cM cuz cfv wcel cN c1
      caddc co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM vk
      cv cle wbr vk cz crab cres cfv cN c1 caddc co cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cfv cN cM c1 cmin co cmin co cS cF c1 cM
      cmin co cshi co cseq1 co cfv cN c1 caddc co cF cfv cS co cN cM cS cop cF
      cseqz co cfv cN c1 caddc co cF cfv cS co cN cM cuz cfv wcel cN c1 caddc
      co cM cuz cfv wcel cN c1 caddc co cM vk cv cle wbr vk cz crab wcel cN c1
      caddc co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM vk
      cv cle wbr vk cz crab cres cfv cN c1 caddc co cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cfv wceq cM cN peano2uz cN c1 caddc co cM
      cuz cfv wcel cN c1 caddc co cM vk cv cle wbr vk cz crab wcel cN c1 caddc
      co cM cuz cfv wcel cM cuz cfv cM vk cv cle wbr vk cz crab cN c1 caddc co
      cN c1 caddc co cM cuz cfv wcel cM cz wcel cM cuz cfv cM vk cv cle wbr vk
      cz crab wceq cM cN c1 caddc co eluzel2 vk cM uzval syl eleq2d ibi cN c1
      caddc co cM vk cv cle wbr vk cz crab cS cF c1 cM cmin co cshi co cseq1 co
      cM c1 cmin co cshi co fvres 3syl cN cM cuz cfv wcel cN c1 caddc co cS cF
      c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cfv cN cM c1 cmin co
      cmin co c1 caddc co cS cF c1 cM cmin co cshi co cseq1 co cfv cN cM c1
      cmin co cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv cN cM c1 cmin co
      cmin co c1 caddc co cF c1 cM cmin co cshi co cfv cS co cN cM c1 cmin co
      cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv cN c1 caddc co cF cfv cS
      co cM cc wcel cN cc wcel cN c1 caddc co cS cF c1 cM cmin co cshi co cseq1
      co cM c1 cmin co cshi co cfv cN cM c1 cmin co cmin co c1 caddc co cS cF
      c1 cM cmin co cshi co cseq1 co cfv wceq cN cM cuz cfv wcel cM cc wcel cN
      cc wcel wa cN c1 caddc co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin
      co cshi co cfv cN c1 caddc co cM c1 cmin co cmin co cS cF c1 cM cmin co
      cshi co cseq1 co cfv cN cM c1 cmin co cmin co c1 caddc co cS cF c1 cM
      cmin co cshi co cseq1 co cfv cM c1 cmin co cc wcel cN c1 caddc co cc wcel
      cN c1 caddc co cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co
      cfv cN c1 caddc co cM c1 cmin co cmin co cS cF c1 cM cmin co cshi co
      cseq1 co cfv wceq cM cc wcel cN cc wcel cM c1 cmin co cN c1 caddc co cc
      cS cF c1 cM cmin co cshi co cseq1 co cS cF c1 cM cmin co cshi co cseq1
      oprex shftval cM cc wcel c1 cc wcel cM c1 cmin co cc wcel ax1cn cM c1
      subcl mpan2 cN peano2cn syl2an cM cc wcel cN cc wcel wa cN c1 caddc co cM
      c1 cmin co cmin co cN cM c1 cmin co cmin co c1 caddc co cS cF c1 cM cmin
      co cshi co cseq1 co cM cc wcel cN cc wcel wa cN cc wcel cM c1 cmin co cc
      wcel wa cN c1 caddc co cM c1 cmin co cmin co cN cM c1 cmin co cmin co c1
      caddc co wceq cN cc wcel cM cc wcel cN cc wcel cM c1 cmin co cc wcel wa
      cM cc wcel cM c1 cmin co cc wcel cN cc wcel cM cc wcel c1 cc wcel cM c1
      cmin co cc wcel ax1cn cM c1 subcl mpan2 anim2i ancoms cN cc wcel c1 cc
      wcel cM c1 cmin co cc wcel cN c1 caddc co cM c1 cmin co cmin co cN cM c1
      cmin co cmin co c1 caddc co wceq ax1cn cN c1 cM c1 cmin co addsub mp3an2
      syl fveq2d eqtrd cN cM cuz cfv wcel cM cz wcel cM cc wcel cM cN eluzel2
      cM zcn syl cN cM cuz cfv wcel cN cz wcel cN cc wcel cM cN eluzelz cN zcn
      syl sylanc cN cM cuz cfv wcel cN cM c1 cmin co cmin co cn wcel cN cM c1
      cmin co cmin co c1 caddc co cS cF c1 cM cmin co cshi co cseq1 co cfv cN
      cM c1 cmin co cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv cN cM c1
      cmin co cmin co c1 caddc co cF c1 cM cmin co cshi co cfv cS co wceq cN cM
      cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cN cM c1 cmin co
      cmin co cn wcel cM cN eluz2 cM cz wcel cN cz wcel cM cN cle wbr w3a cN cM
      c1 cmin co cmin co cN cM cmin co c1 caddc co cn cM cz wcel cN cz wcel cN
      cM c1 cmin co cmin co cN cM cmin co c1 caddc co wceq cM cN cle wbr cN cz
      wcel cM cz wcel cN cM c1 cmin co cmin co cN cM cmin co c1 caddc co wceq
      cN cc wcel cM cc wcel cN cM c1 cmin co cmin co cN cM cmin co c1 caddc co
      wceq cN cz wcel cM cz wcel cN cc wcel cM cc wcel c1 cc wcel cN cM c1 cmin
      co cmin co cN cM cmin co c1 caddc co wceq ax1cn cN cM c1 subsub mp3an3 cN
      zcn cM zcn syl2an ancoms 3adant3 cM cz wcel cN cz wcel cM cN cle wbr w3a
      cN cM cmin co cn0 wcel cN cM cmin co c1 caddc co cn wcel cM cN znn0sub2
      cN cM cmin co nn0p1nn syl eqeltrd sylbi cN cM c1 cmin co cmin co cS cF c1
      cM cmin co cshi co seq0val.1 cF c1 cM cmin co cshi oprex seq1p1 syl cN cM
      cuz cfv wcel cN cM c1 cmin co cmin co c1 caddc co cF c1 cM cmin co cshi
      co cfv cN c1 caddc co cF cfv cN cM c1 cmin co cmin co cS cF c1 cM cmin co
      cshi co cseq1 co cfv cS cM cc wcel cN cc wcel cN cM c1 cmin co cmin co c1
      caddc co cF c1 cM cmin co cshi co cfv cN c1 caddc co cF cfv wceq cN cM
      cuz cfv wcel cM cc wcel cN cc wcel wa cN cM c1 cmin co cmin co c1 caddc
      co cF c1 cM cmin co cshi co cfv cN cM c1 cmin co cmin co c1 caddc co c1
      cM cmin co cmin co cF cfv cN c1 caddc co cF cfv c1 cM cmin co cc wcel cN
      cM c1 cmin co cmin co c1 caddc co cc wcel cN cM c1 cmin co cmin co c1
      caddc co cF c1 cM cmin co cshi co cfv cN cM c1 cmin co cmin co c1 caddc
      co c1 cM cmin co cmin co cF cfv wceq cM cc wcel cN cc wcel wa c1 cM cmin
      co cN cM c1 cmin co cmin co c1 caddc co cc cF seq0val.2 shftval cM cc
      wcel c1 cM cmin co cc wcel cN cc wcel c1 cc wcel cM cc wcel c1 cM cmin co
      cc wcel ax1cn c1 cM subcl mpan adantr cM cc wcel cN cc wcel wa cN cM c1
      cmin co cmin co cc wcel cN cM c1 cmin co cmin co c1 caddc co cc wcel cN
      cc wcel cM cc wcel cN cM c1 cmin co cmin co cc wcel cN cc wcel cM c1 cmin
      co cc wcel cN cM c1 cmin co cmin co cc wcel cM cc wcel cN cM c1 cmin co
      subcl cM cc wcel c1 cc wcel cM c1 cmin co cc wcel ax1cn cM c1 subcl mpan2
      sylan2 ancoms cN cM c1 cmin co cmin co peano2cn syl sylanc cM cc wcel cN
      cc wcel wa cN cM c1 cmin co cmin co c1 caddc co c1 cM cmin co cmin co cN
      c1 caddc co cF cM cc wcel cN cc wcel wa cN cM c1 cmin co cmin co c1 caddc
      co c1 cM cmin co cmin co cN cM c1 cmin co cmin co c1 caddc co cM c1 cmin
      co caddc co cN c1 caddc co cN cM c1 cmin co cmin co c1 caddc co cc wcel
      cM cc wcel cN cM c1 cmin co cmin co c1 caddc co c1 cM cmin co cmin co cN
      cM c1 cmin co cmin co c1 caddc co cM c1 cmin co caddc co wceq cM cc wcel
      cN cc wcel wa cN cM c1 cmin co cmin co c1 caddc co cc wcel c1 cc wcel cM
      cc wcel cN cM c1 cmin co cmin co c1 caddc co c1 cM cmin co cmin co cN cM
      c1 cmin co cmin co c1 caddc co cM c1 cmin co caddc co wceq ax1cn cN cM c1
      cmin co cmin co c1 caddc co c1 cM subsub2 mp3an2 cM cc wcel cN cc wcel wa
      cN cM c1 cmin co cmin co cc wcel cN cM c1 cmin co cmin co c1 caddc co cc
      wcel cN cc wcel cM cc wcel cN cM c1 cmin co cmin co cc wcel cN cc wcel cM
      c1 cmin co cc wcel cN cM c1 cmin co cmin co cc wcel cM cc wcel cN cM c1
      cmin co subcl cM cc wcel c1 cc wcel cM c1 cmin co cc wcel ax1cn cM c1
      subcl mpan2 sylan2 ancoms cN cM c1 cmin co cmin co peano2cn syl cM cc
      wcel cN cc wcel pm3.26 sylanc cM cc wcel cN cc wcel wa cN cc wcel cM c1
      cmin co cc wcel wa cN cM c1 cmin co cmin co c1 caddc co cM c1 cmin co
      caddc co cN c1 caddc co wceq cN cc wcel cM cc wcel cN cc wcel cM c1 cmin
      co cc wcel wa cM cc wcel cM c1 cmin co cc wcel cN cc wcel cM cc wcel c1
      cc wcel cM c1 cmin co cc wcel ax1cn cM c1 subcl mpan2 anim2i ancoms cN cc
      wcel cM c1 cmin co cc wcel c1 cc wcel cN cM c1 cmin co cmin co c1 caddc
      co cM c1 cmin co caddc co cN c1 caddc co wceq ax1cn cN cM c1 cmin co c1
      nppcan mp3an3 syl eqtrd fveq2d eqtrd cN cM cuz cfv wcel cM cz wcel cM cc
      wcel cM cN eluzel2 cM zcn syl cN cM cuz cfv wcel cN cz wcel cN cc wcel cM
      cN eluzelz cN zcn syl sylanc opreq2d 3eqtrd cN cM cuz cfv wcel cN cM c1
      cmin co cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv cN cM cS cop cF
      cseqz co cfv cN c1 caddc co cF cfv cS cN cM cuz cfv wcel cN cM cS cop cF
      cseqz co cfv cN cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi
      co cM vk cv cle wbr vk cz crab cres cfv cN cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cfv cN cM c1 cmin co cmin co cS cF c1 cM
      cmin co cshi co cseq1 co cfv cN cM cuz cfv wcel cM cz wcel cN cM cS cop
      cF cseqz co cfv cN cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co
      cshi co cM vk cv cle wbr vk cz crab cres cfv wceq cM cN eluzel2 cM cz
      wcel cN cM cS cop cF cseqz co cS cF c1 cM cmin co cshi co cseq1 co cM c1
      cmin co cshi co cM vk cv cle wbr vk cz crab cres cz cS vk cF cM seq0val.1
      seq0val.2 seqzfval fveq1d syl cN cM cuz cfv wcel cN cM vk cv cle wbr vk
      cz crab wcel cN cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi
      co cM vk cv cle wbr vk cz crab cres cfv cN cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cfv wceq cN cM cuz cfv wcel cN cM vk cv
      cle wbr vk cz crab wcel cN cM cuz cfv wcel cM cz wcel cN cM cuz cfv wcel
      cN cM vk cv cle wbr vk cz crab wcel wb cM cN eluzel2 cM cz wcel cM cuz
      cfv cM vk cv cle wbr vk cz crab cN vk cM uzval eleq2d syl ibi cN cM vk cv
      cle wbr vk cz crab cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co
      cshi co fvres syl cM c1 cmin co cz wcel cN cc wcel cN cS cF c1 cM cmin co
      cshi co cseq1 co cM c1 cmin co cshi co cfv cN cM c1 cmin co cmin co cS cF
      c1 cM cmin co cshi co cseq1 co cfv wceq cN cM cuz cfv wcel cM c1 cmin co
      cN cz cS cF c1 cM cmin co cshi co cseq1 co cS cF c1 cM cmin co cshi co
      cseq1 oprex shftval cN cM cuz cfv wcel cM cz wcel cM c1 cmin co cz wcel
      cM cN eluzel2 cM peano2zm syl cN cM cuz cfv wcel cN cz wcel cN cc wcel cM
      cN eluzelz cN zcn syl sylanc 3eqtrrd opreq1d 3eqtrd eqtrd $.
      $( [26-Sep-2005] $) $( [7-Sep-2005] $)

    $( Value of the recursive sequence builder in terms of its _previous_
       value. $)
    seqzm1 $p |- ( ( M e. ZZ /\ N e. ZZ /\ M < N ) ->
                ( ( <. M , S >. seq F ) ` N ) =
                ( ( ( <. M , S >. seq F ) ` ( N - 1 ) ) S ( F ` N ) ) ) $=
      cM cz wcel cN cz wcel cM cN clt wbr w3a cN c1 cmin co c1 caddc co cM cS
      cop cF cseqz co cfv cN c1 cmin co cM cS cop cF cseqz co cfv cN c1 cmin co
      c1 caddc co cF cfv cS co cN cM cS cop cF cseqz co cfv cN c1 cmin co cM cS
      cop cF cseqz co cfv cN cF cfv cS co cM cz wcel cN c1 cmin co cz wcel cM
      cN c1 cmin co cle wbr cN c1 cmin co c1 caddc co cM cS cop cF cseqz co cfv
      cN c1 cmin co cM cS cop cF cseqz co cfv cN c1 cmin co c1 caddc co cF cfv
      cS co wceq cM cz wcel cN cz wcel cM cN clt wbr w3a cM cz wcel cN c1 cmin
      co cz wcel cM cN c1 cmin co cle wbr w3a cN c1 cmin co cM cuz cfv wcel cN
      c1 cmin co c1 caddc co cM cS cop cF cseqz co cfv cN c1 cmin co cM cS cop
      cF cseqz co cfv cN c1 cmin co c1 caddc co cF cfv cS co wceq cM cN c1 cmin
      co eluz2 cS cF cM cN c1 cmin co seq0val.1 seq0val.2 seqzp1 sylbir cM cz
      wcel cN cz wcel cM cN clt wbr 3simp1 cN cz wcel cM cz wcel cN c1 cmin co
      cz wcel cM cN clt wbr cN peano2zm 3ad2ant2 cM cz wcel cN cz wcel cM cN
      clt wbr cM cN c1 cmin co cle wbr cM cN zltlem1 biimp3a syl3anc cN cz wcel
      cM cz wcel cN c1 cmin co c1 caddc co cM cS cop cF cseqz co cfv cN cM cS
      cop cF cseqz co cfv wceq cM cN clt wbr cN cz wcel cN c1 cmin co c1 caddc
      co cN cM cS cop cF cseqz co cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc
      co cN wceq cN cz wcel cN c1 npcan cN zcn ax1cn sylancl fveq2d 3ad2ant2 cN
      cz wcel cM cz wcel cN c1 cmin co cM cS cop cF cseqz co cfv cN c1 cmin co
      c1 caddc co cF cfv cS co cN c1 cmin co cM cS cop cF cseqz co cfv cN cF
      cfv cS co wceq cM cN clt wbr cN cz wcel cN c1 cmin co c1 caddc co cF cfv
      cN cF cfv cN c1 cmin co cM cS cop cF cseqz co cfv cS cN cz wcel cN c1
      cmin co c1 caddc co cN cF cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co
      cN wceq cN cz wcel cN c1 npcan cN zcn ax1cn sylancl fveq2d opreq2d
      3ad2ant2 3eqtr3d $.
      $( [3-Oct-2005] $) $( [1-Sep-2005] $)

    $( Value of the 0-based recursive sequence builder at 0. $)
    seq00 $p |- ( ( S seq0 F ) ` 0 ) = ( F ` 0 ) $=
      cc0 cS cF cseq0 co cfv cc0 cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv
      cc0 c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv cc0 cF cfv cc0 cS cF
      cseq0 co cfv cc0 cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cfv
      cc0 cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv cc0 cS cF cseq0 co cS
      cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF seq0val.1 seq0val.2
      seq0fval fveq1i cc0 cn0 wcel cc0 cS cF c1 cshi co cseq1 co c1 cneg cshi
      co cn0 cres cfv cc0 cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv wceq
      0nn0 cc0 cn0 cS cF c1 cshi co cseq1 co c1 cneg cshi co fvres ax-mp eqtri
      c1 cneg cc wcel cc0 cc wcel cc0 cS cF c1 cshi co cseq1 co c1 cneg cshi co
      cfv cc0 c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv wceq c1 ax1cn
      negcli 0cn c1 cneg cc0 cc cS cF c1 cshi co cseq1 co cS cF c1 cshi co
      cseq1 oprex shftval mp2an cc0 c1 cneg cmin co cS cF c1 cshi co cseq1 co
      cfv c1 cS cF c1 cshi co cseq1 co cfv c1 cF c1 cshi co cfv cc0 cF cfv cc0
      c1 cneg cmin co c1 cS cF c1 cshi co cseq1 co c1 cneg cneg cc0 c1 cneg
      cmin co c1 c1 cneg df-neg c1 ax1cn negnegi eqtr3i fveq2i cS cF c1 cshi co
      seq0val.1 cF c1 cshi oprex seq11 c1 cF c1 cshi co cfv c1 c1 cmin co cF
      cfv cc0 cF cfv c1 cc wcel c1 cc wcel c1 cF c1 cshi co cfv c1 c1 cmin co
      cF cfv wceq ax1cn ax1cn c1 c1 cc cF seq0val.2 shftval mp2an c1 c1 cmin co
      cc0 cF c1 ax1cn subidi fveq2i eqtri 3eqtri 3eqtri $.
      $( [24-Aug-2005] $) $( [3-Aug-2005] $)

    $( Value of the 0-based recursive sequence builder at a successor. $)
    seq0p1 $p |- ( N e. NN0 -> ( ( S seq0 F ) ` ( N + 1 ) ) =
                ( ( ( S seq0 F ) ` N ) S ( F ` ( N + 1 ) ) ) ) $=
      cN cn0 wcel cN c1 caddc co cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0
      cres cfv cN cS cF cseq0 co cfv cN c1 caddc co cF cfv cS co cN c1 caddc co
      cS cF cseq0 co cfv cN cn0 wcel cN c1 caddc co cS cF c1 cshi co cseq1 co
      c1 cneg cshi co cn0 cres cfv cN c1 caddc co cS cF c1 cshi co cseq1 co c1
      cneg cshi co cfv cN c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv cN c1
      caddc co cF cfv cS co cN cS cF cseq0 co cfv cN c1 caddc co cF cfv cS co
      cN cn0 wcel cN c1 caddc co cn0 wcel cN c1 caddc co cS cF c1 cshi co cseq1
      co c1 cneg cshi co cn0 cres cfv cN c1 caddc co cS cF c1 cshi co cseq1 co
      c1 cneg cshi co cfv wceq cN peano2nn0 cN c1 caddc co cn0 cS cF c1 cshi co
      cseq1 co c1 cneg cshi co fvres syl cN cn0 wcel cN c1 caddc co cS cF c1
      cshi co cseq1 co c1 cneg cshi co cfv cN c1 caddc co c1 cneg cmin co cS cF
      c1 cshi co cseq1 co cfv cN c1 cneg cmin co c1 caddc co cS cF c1 cshi co
      cseq1 co cfv cN c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv cN c1 caddc
      co cF cfv cS co cN cn0 wcel cN cc wcel cN c1 caddc co cc wcel cN c1 caddc
      co cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv cN c1 caddc co c1 cneg
      cmin co cS cF c1 cshi co cseq1 co cfv wceq cN nn0cn cN peano2cn c1 cneg
      cc wcel cN c1 caddc co cc wcel cN c1 caddc co cS cF c1 cshi co cseq1 co
      c1 cneg cshi co cfv cN c1 caddc co c1 cneg cmin co cS cF c1 cshi co cseq1
      co cfv wceq c1 ax1cn negcli c1 cneg cN c1 caddc co cc cS cF c1 cshi co
      cseq1 co cS cF c1 cshi co cseq1 oprex shftval mpan 3syl cN cn0 wcel cN c1
      caddc co c1 cneg cmin co cN c1 cneg cmin co c1 caddc co cS cF c1 cshi co
      cseq1 co cN cn0 wcel cN cc wcel cN c1 caddc co c1 cneg cmin co cN c1 cneg
      cmin co c1 caddc co wceq cN nn0cn cN cc wcel c1 cc wcel c1 cneg cc wcel
      cN c1 caddc co c1 cneg cmin co cN c1 cneg cmin co c1 caddc co wceq ax1cn
      c1 ax1cn negcli cN c1 c1 cneg addsub mp3an23 syl fveq2d cN cn0 wcel cN c1
      cneg cmin co c1 caddc co cS cF c1 cshi co cseq1 co cfv cN c1 cneg cmin co
      cS cF c1 cshi co cseq1 co cfv cN c1 cneg cmin co c1 caddc co cF c1 cshi
      co cfv cS co cN c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv cN c1 caddc
      co cF cfv cS co cN cn0 wcel cN c1 cneg cmin co cn wcel cN c1 cneg cmin co
      c1 caddc co cS cF c1 cshi co cseq1 co cfv cN c1 cneg cmin co cS cF c1
      cshi co cseq1 co cfv cN c1 cneg cmin co c1 caddc co cF c1 cshi co cfv cS
      co wceq cN cn0 wcel cN c1 cneg cmin co cN c1 caddc co cn cN cc wcel c1 cc
      wcel cN c1 cneg cmin co cN c1 caddc co wceq cN cn0 wcel cN c1 subneg cN
      nn0cn ax1cn sylancl cN nn0p1nn eqeltrd cN c1 cneg cmin co cS cF c1 cshi
      co seq0val.1 cF c1 cshi oprex seq1p1 syl cN cn0 wcel cN c1 cneg cmin co
      c1 caddc co cF c1 cshi co cfv cN c1 caddc co cF cfv cN c1 cneg cmin co cS
      cF c1 cshi co cseq1 co cfv cS cN cn0 wcel cN c1 cneg cmin co c1 caddc co
      cF c1 cshi co cfv cN c1 cneg cmin co c1 caddc co c1 cmin co cF cfv cN c1
      caddc co cF cfv cN cn0 wcel cN c1 cneg cmin co cc wcel cN c1 cneg cmin co
      c1 caddc co cc wcel cN c1 cneg cmin co c1 caddc co cF c1 cshi co cfv cN
      c1 cneg cmin co c1 caddc co c1 cmin co cF cfv wceq cN cc wcel c1 cneg cc
      wcel cN c1 cneg cmin co cc wcel cN cn0 wcel cN c1 cneg subcl cN nn0cn c1
      ax1cn negcli sylancl cN c1 cneg cmin co peano2cn c1 cc wcel cN c1 cneg
      cmin co c1 caddc co cc wcel cN c1 cneg cmin co c1 caddc co cF c1 cshi co
      cfv cN c1 cneg cmin co c1 caddc co c1 cmin co cF cfv wceq ax1cn c1 cN c1
      cneg cmin co c1 caddc co cc cF seq0val.2 shftval mpan 3syl cN cn0 wcel cN
      c1 cneg cmin co c1 caddc co c1 cmin co cN c1 caddc co cF cN cn0 wcel cN
      cc wcel cN c1 cneg cmin co c1 caddc co c1 cmin co cN c1 caddc co wceq cN
      nn0cn cN cc wcel cN c1 cneg cmin co c1 caddc co c1 cmin co cN c1 cneg
      cmin co cN c1 caddc co cN c1 cneg cmin co cc wcel c1 cc wcel cN c1 cneg
      cmin co c1 caddc co c1 cmin co cN c1 cneg cmin co wceq cN cc wcel cN c1
      cneg cmin co c1 pncan cN cc wcel c1 cneg cc wcel cN c1 cneg cmin co cc
      wcel c1 ax1cn negcli cN c1 cneg subcl mpan2 ax1cn sylancl cN cc wcel c1
      cc wcel cN c1 cneg cmin co cN c1 caddc co wceq ax1cn cN c1 subneg mpan2
      eqtrd syl fveq2d eqtrd opreq2d eqtrd 3eqtrd cN cn0 wcel cN c1 cneg cmin
      co cS cF c1 cshi co cseq1 co cfv cN cS cF cseq0 co cfv cN c1 caddc co cF
      cfv cS cN cn0 wcel cN cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres
      cfv cN c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv cN cS cF cseq0 co
      cfv cN cn0 wcel cN cS cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cfv
      cN cS cF c1 cshi co cseq1 co c1 cneg cshi co cfv cN c1 cneg cmin co cS cF
      c1 cshi co cseq1 co cfv cN cn0 cS cF c1 cshi co cseq1 co c1 cneg cshi co
      fvres c1 cneg cc wcel cN cc wcel cN cS cF c1 cshi co cseq1 co c1 cneg
      cshi co cfv cN c1 cneg cmin co cS cF c1 cshi co cseq1 co cfv wceq cN cn0
      wcel c1 cneg cN cc cS cF c1 cshi co cseq1 co cS cF c1 cshi co cseq1 oprex
      shftval c1 ax1cn negcli cN nn0cn sylancr eqtrd cN cS cF cseq0 co cS cF c1
      cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF seq0val.1 seq0val.2
      seq0fval fveq1i syl5req opreq1d 3eqtrd cN c1 caddc co cS cF cseq0 co cS
      cF c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cS cF seq0val.1 seq0val.2
      seq0fval fveq1i syl5eq $.
      $( [24-Aug-2005] $) $( [3-Aug-2005] $)

    $( Value of the 0-based recursive sequence builder at 1. $)
    seq01 $p |- ( ( S seq0 F ) ` 1 ) = ( ( F ` 0 ) S ( F ` 1 ) ) $=
      cc0 c1 caddc co cS cF cseq0 co cfv cc0 cS cF cseq0 co cfv cc0 c1 caddc co
      cF cfv cS co c1 cS cF cseq0 co cfv cc0 cF cfv c1 cF cfv cS co cc0 cn0
      wcel cc0 c1 caddc co cS cF cseq0 co cfv cc0 cS cF cseq0 co cfv cc0 c1
      caddc co cF cfv cS co wceq 0nn0 cS cF cc0 seq0val.1 seq0val.2 seq0p1
      ax-mp cc0 c1 caddc co c1 cS cF cseq0 co c1 ax1cn addid2i fveq2i cc0 cS cF
      cseq0 co cfv cc0 cF cfv cc0 c1 caddc co cF cfv c1 cF cfv cS cS cF
      seq0val.1 seq0val.2 seq00 cc0 c1 caddc co c1 cF c1 ax1cn addid2i fveq2i
      opreq12i 3eqtr3i $.
      $( [8-Oct-2005] $) $( [3-Aug-2005] $)

    $( Value of the arbitrary-based recursive sequence builder operation. $)
    seqzval2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ M <_ N ) ->
                   ( ( <. M , S >. seq F ) ` N ) =
              ( ( ( S seq0 ( F shift -u M ) ) shift M ) ` N ) ) $=
      cM cz wcel cN cz wcel cM cN cle wbr w3a cN cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cfv cN cM cmin co cS cF cM cneg cshi co
      cseq0 co cfv cN cM cS cop cF cseqz co cfv cN cS cF cM cneg cshi co cseq0
      co cM cshi co cfv cM cz wcel cN cz wcel cM cN cle wbr w3a cN cS cF c1 cM
      cmin co cshi co cseq1 co cM c1 cmin co cshi co cfv cN cM c1 cmin co cmin
      co cS cF c1 cM cmin co cshi co cseq1 co cfv cN cM c1 cmin co cmin co cS
      cF cM cneg cshi co cseq0 co c1 cshi co cfv cN cM cmin co cS cF cM cneg
      cshi co cseq0 co cfv cN cz wcel cM cz wcel cN cS cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cfv cN cM c1 cmin co cmin co cS cF c1 cM
      cmin co cshi co cseq1 co cfv wceq cM cN cle wbr cM c1 cmin co cvv wcel cN
      cc wcel cN cS cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cfv
      cN cM c1 cmin co cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv wceq cN
      cz wcel cM c1 cmin co cN cvv cS cF c1 cM cmin co cshi co cseq1 co cS cF
      c1 cM cmin co cshi co cseq1 oprex shftval cM c1 cmin oprex cN zcn sylancr
      3ad2ant2 cM cz wcel cN cz wcel cM cN cle wbr w3a cN cM c1 cmin co cmin co
      cS cF cM cneg cshi co c1 cshi co cseq1 co cfv cN cM c1 cmin co cmin co cS
      cF c1 cM cmin co cshi co cseq1 co cfv cN cM c1 cmin co cmin co cS cF cM
      cneg cshi co cseq0 co c1 cshi co cfv cM cz wcel cN cz wcel cN cM c1 cmin
      co cmin co cS cF cM cneg cshi co c1 cshi co cseq1 co cfv cN cM c1 cmin co
      cmin co cS cF c1 cM cmin co cshi co cseq1 co cfv wceq cM cN cle wbr cM cz
      wcel cN cM c1 cmin co cmin co cS cF cM cneg cshi co c1 cshi co cseq1 co
      cS cF c1 cM cmin co cshi co cseq1 co cM cz wcel cF cM cneg cshi co c1
      cshi co cF c1 cM cmin co cshi co cS cseq1 cM cz wcel cM cc wcel cF cM
      cneg cshi co c1 cshi co cF c1 cM cmin co cshi co wceq cM zcn cM cc wcel
      cF cM cneg cshi co c1 cshi co cF cM cneg c1 caddc co cshi co cF c1 cM
      cmin co cshi co cM cneg cc wcel c1 cc wcel cF cM cneg cshi co c1 cshi co
      cF cM cneg c1 caddc co cshi co wceq cM cc wcel cM cneg c1 cF seq0val.2
      2shfti cM negcl ax1cn sylancl cM cc wcel cM cneg c1 caddc co c1 cM cmin
      co cF cshi cM cc wcel cM cneg c1 caddc co c1 cM cneg caddc co c1 cM cmin
      co cM cneg cc wcel c1 cc wcel cM cneg c1 caddc co c1 cM cneg caddc co
      wceq cM cc wcel cM cneg c1 addcom cM negcl ax1cn sylancl c1 cc wcel cM cc
      wcel c1 cM cneg caddc co c1 cM cmin co wceq ax1cn c1 cM negsub mpan eqtrd
      opreq2d eqtrd syl opreq2d fveq1d 3ad2ant1 cM cz wcel cN cz wcel cM cN cle
      wbr w3a cN cM c1 cmin co cmin co cn wcel cN cM c1 cmin co cmin co cS cF
      cM cneg cshi co c1 cshi co cseq1 co cfv cN cM c1 cmin co cmin co cS cF cM
      cneg cshi co cseq0 co c1 cshi co cfv wceq cM cz wcel cN cz wcel cM cN cle
      wbr w3a cN cM c1 cmin co cmin co cN cM cmin co c1 caddc co cn cM cz wcel
      cN cz wcel cN cM c1 cmin co cmin co cN cM cmin co c1 caddc co wceq cM cN
      cle wbr cN cz wcel cM cz wcel cN cM c1 cmin co cmin co cN cM cmin co c1
      caddc co wceq cN cc wcel cM cc wcel cN cM c1 cmin co cmin co cN cM cmin
      co c1 caddc co wceq cN cz wcel cM cz wcel cN cc wcel cM cc wcel c1 cc
      wcel cN cM c1 cmin co cmin co cN cM cmin co c1 caddc co wceq ax1cn cN cM
      c1 subsub mp3an3 cN zcn cM zcn syl2an ancoms 3adant3 cM cz wcel cN cz
      wcel cM cN cle wbr w3a cN cM cmin co cn0 wcel cN cM cmin co c1 caddc co
      cn wcel cM cN znn0sub2 cN cM cmin co nn0p1nn syl eqeltrd cS cF cM cneg
      cshi co cN cM c1 cmin co cmin co seq0val.1 cF cM cneg cshi oprex
      seq1seq02 syl eqtr3d cM cz wcel cN cz wcel cN cM c1 cmin co cmin co cS cF
      cM cneg cshi co cseq0 co c1 cshi co cfv cN cM cmin co cS cF cM cneg cshi
      co cseq0 co cfv wceq cM cN cle wbr cM cc wcel cN cc wcel cN cM c1 cmin co
      cmin co cS cF cM cneg cshi co cseq0 co c1 cshi co cfv cN cM cmin co cS cF
      cM cneg cshi co cseq0 co cfv wceq cM cz wcel cN cz wcel cN cc wcel cM cc
      wcel cN cM c1 cmin co cmin co cS cF cM cneg cshi co cseq0 co c1 cshi co
      cfv cN cM cmin co cS cF cM cneg cshi co cseq0 co cfv wceq cN cc wcel cM
      cc wcel wa cN cM c1 cmin co cmin co cS cF cM cneg cshi co cseq0 co c1
      cshi co cfv cN cM c1 cmin co cmin co c1 cmin co cS cF cM cneg cshi co
      cseq0 co cfv cN cM cmin co cS cF cM cneg cshi co cseq0 co cfv c1 cc wcel
      cN cM c1 cmin co cmin co cc wcel cN cM c1 cmin co cmin co cS cF cM cneg
      cshi co cseq0 co c1 cshi co cfv cN cM c1 cmin co cmin co c1 cmin co cS cF
      cM cneg cshi co cseq0 co cfv wceq cN cc wcel cM cc wcel wa c1 cN cM c1
      cmin co cmin co cc cS cF cM cneg cshi co cseq0 co cS cF cM cneg cshi co
      cseq0 oprex shftval ax1cn cN cc wcel cM c1 cmin co cc wcel cN cM c1 cmin
      co cmin co cc wcel cM cc wcel cN cM c1 cmin co subcl cM cc wcel c1 cc
      wcel cM c1 cmin co cc wcel ax1cn cM c1 subcl mpan2 sylan2 sylancr cN cc
      wcel cM cc wcel wa cN cM c1 cmin co cmin co c1 cmin co cN cM cmin co cS
      cF cM cneg cshi co cseq0 co cN cc wcel cM cc wcel c1 cc wcel cN cM c1
      cmin co cmin co c1 cmin co cN cM cmin co wceq ax1cn cN cM c1 nnncan
      mp3an3 fveq2d eqtrd ancoms cM zcn cN zcn syl2an 3adant3 3eqtrd cz cS cF
      cM cN seq0val.1 seq0val.2 seqzval cM cz wcel cN cz wcel cN cS cF cM cneg
      cshi co cseq0 co cM cshi co cfv cN cM cmin co cS cF cM cneg cshi co cseq0
      co cfv wceq cM cN cle wbr cM cz wcel cN cc wcel cN cS cF cM cneg cshi co
      cseq0 co cM cshi co cfv cN cM cmin co cS cF cM cneg cshi co cseq0 co cfv
      wceq cN cz wcel cM cN cz cS cF cM cneg cshi co cseq0 co cS cF cM cneg
      cshi co cseq0 oprex shftval cN zcn sylan2 3adant3 3eqtr4d $.
      $( [2-Aug-2006] $) $( [4-Sep-2005] $)
  $}

  ${
    $d j k m F $.  $d j k m G $.  $d j k m M $.  $d j k N $.  $d j m S $.
    seqzfveq.1 $e |- S e. _V $.
    seqzfveq.2 $e |- F e. _V $.
    seqzfveq.3 $e |- G e. _V $.
    $( Equality theorem for the recursive sequence builder. $)
    seqzfveq $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N ) ( F ` k ) = ( G
  ` k ) ) -> ( ( <. M , S >. seq F ) ` N ) = ( ( <. M , S >. seq G ) ` N ) ) $=
      cN cM cuz cfv wcel vk cv cF cfv vk cv cG cfv wceq vk cM cN cfz co wral cN
      cM cS cop cF cseqz co cfv cN cM cS cop cG cseqz co cfv wceq vk cv cF cfv
      vk cv cG cfv wceq vk cM vj cv cfz co wral vj cv cM cS cop cF cseqz co cfv
      vj cv cM cS cop cG cseqz co cfv wceq wi vk cv cF cfv vk cv cG cfv wceq vk
      cM cM cfz co wral cM cM cS cop cF cseqz co cfv cM cM cS cop cG cseqz co
      cfv wceq wi vk cv cF cfv vk cv cG cfv wceq vk cM vm cv cfz co wral vm cv
      cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq wi vk cv
      cF cfv vk cv cG cfv wceq vk cM vm cv c1 caddc co cfz co wral vm cv c1
      caddc co cM cS cop cF cseqz co cfv vm cv c1 caddc co cM cS cop cG cseqz
      co cfv wceq wi vk cv cF cfv vk cv cG cfv wceq vk cM cN cfz co wral cN cM
      cS cop cF cseqz co cfv cN cM cS cop cG cseqz co cfv wceq wi vj vm cM cN
      vj cv cM wceq vk cv cF cfv vk cv cG cfv wceq vk cM vj cv cfz co wral vk
      cv cF cfv vk cv cG cfv wceq vk cM cM cfz co wral vj cv cM cS cop cF cseqz
      co cfv vj cv cM cS cop cG cseqz co cfv wceq cM cM cS cop cF cseqz co cfv
      cM cM cS cop cG cseqz co cfv wceq vj cv cM wceq vk cv cF cfv vk cv cG cfv
      wceq vk cM vj cv cfz co cM cM cfz co vj cv cM cM cfz opreq2 raleq1d vj cv
      cM wceq vj cv cM cS cop cF cseqz co cfv cM cM cS cop cF cseqz co cfv vj
      cv cM cS cop cG cseqz co cfv cM cM cS cop cG cseqz co cfv vj cv cM cM cS
      cop cF cseqz co fveq2 vj cv cM cM cS cop cG cseqz co fveq2 eqeq12d
      imbi12d vj cv vm cv wceq vk cv cF cfv vk cv cG cfv wceq vk cM vj cv cfz
      co wral vk cv cF cfv vk cv cG cfv wceq vk cM vm cv cfz co wral vj cv cM
      cS cop cF cseqz co cfv vj cv cM cS cop cG cseqz co cfv wceq vm cv cM cS
      cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq vj cv vm cv wceq
      vk cv cF cfv vk cv cG cfv wceq vk cM vj cv cfz co cM vm cv cfz co vj cv
      vm cv cM cfz opreq2 raleq1d vj cv vm cv wceq vj cv cM cS cop cF cseqz co
      cfv vm cv cM cS cop cF cseqz co cfv vj cv cM cS cop cG cseqz co cfv vm cv
      cM cS cop cG cseqz co cfv vj cv vm cv cM cS cop cF cseqz co fveq2 vj cv
      vm cv cM cS cop cG cseqz co fveq2 eqeq12d imbi12d vj cv vm cv c1 caddc co
      wceq vk cv cF cfv vk cv cG cfv wceq vk cM vj cv cfz co wral vk cv cF cfv
      vk cv cG cfv wceq vk cM vm cv c1 caddc co cfz co wral vj cv cM cS cop cF
      cseqz co cfv vj cv cM cS cop cG cseqz co cfv wceq vm cv c1 caddc co cM cS
      cop cF cseqz co cfv vm cv c1 caddc co cM cS cop cG cseqz co cfv wceq vj
      cv vm cv c1 caddc co wceq vk cv cF cfv vk cv cG cfv wceq vk cM vj cv cfz
      co cM vm cv c1 caddc co cfz co vj cv vm cv c1 caddc co cM cfz opreq2
      raleq1d vj cv vm cv c1 caddc co wceq vj cv cM cS cop cF cseqz co cfv vm
      cv c1 caddc co cM cS cop cF cseqz co cfv vj cv cM cS cop cG cseqz co cfv
      vm cv c1 caddc co cM cS cop cG cseqz co cfv vj cv vm cv c1 caddc co cM cS
      cop cF cseqz co fveq2 vj cv vm cv c1 caddc co cM cS cop cG cseqz co fveq2
      eqeq12d imbi12d vj cv cN wceq vk cv cF cfv vk cv cG cfv wceq vk cM vj cv
      cfz co wral vk cv cF cfv vk cv cG cfv wceq vk cM cN cfz co wral vj cv cM
      cS cop cF cseqz co cfv vj cv cM cS cop cG cseqz co cfv wceq cN cM cS cop
      cF cseqz co cfv cN cM cS cop cG cseqz co cfv wceq vj cv cN wceq vk cv cF
      cfv vk cv cG cfv wceq vk cM vj cv cfz co cM cN cfz co vj cv cN cM cfz
      opreq2 raleq1d vj cv cN wceq vj cv cM cS cop cF cseqz co cfv cN cM cS cop
      cF cseqz co cfv vj cv cM cS cop cG cseqz co cfv cN cM cS cop cG cseqz co
      cfv vj cv cN cM cS cop cF cseqz co fveq2 vj cv cN cM cS cop cG cseqz co
      fveq2 eqeq12d imbi12d cM cz wcel vk cv cF cfv vk cv cG cfv wceq vk cM cM
      cfz co wral cM cM cS cop cF cseqz co cfv cM cM cS cop cG cseqz co cfv
      wceq cM cz wcel vk cv cF cfv vk cv cG cfv wceq vk cM cM cfz co wral wa cM
      cF cfv cM cG cfv cM cM cS cop cF cseqz co cfv cM cM cS cop cG cseqz co
      cfv cM cM cM cfz co wcel vk cv cF cfv vk cv cG cfv wceq vk cM cM cfz co
      wral cM cF cfv cM cG cfv wceq cM cz wcel vk cv cF cfv vk cv cG cfv wceq
      cM cF cfv cM cG cfv wceq vk cM cM cM cfz co vk cv cM wceq vk cv cF cfv cM
      cF cfv vk cv cG cfv cM cG cfv vk cv cM cF fveq2 vk cv cM cG fveq2 eqeq12d
      rcla4va cM elfz3 sylan cM cz wcel cM cM cS cop cF cseqz co cfv cM cF cfv
      wceq vk cv cF cfv vk cv cG cfv wceq vk cM cM cfz co wral cS cF cM
      seqzfveq.1 seqzfveq.2 seqz1 adantr cM cz wcel cM cM cS cop cG cseqz co
      cfv cM cG cfv wceq vk cv cF cfv vk cv cG cfv wceq vk cM cM cfz co wral cS
      cG cM seqzfveq.1 seqzfveq.3 seqz1 adantr 3eqtr4d ex vm cv cM cuz cfv wcel
      vk cv cF cfv vk cv cG cfv wceq vk cM vm cv cfz co wral vm cv cM cS cop cF
      cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq wi vk cv cF cfv vk cv
      cG cfv wceq vk cM vm cv c1 caddc co cfz co wral vm cv cM cS cop cF cseqz
      co cfv vm cv cM cS cop cG cseqz co cfv wceq wi vk cv cF cfv vk cv cG cfv
      wceq vk cM vm cv c1 caddc co cfz co wral vm cv c1 caddc co cM cS cop cF
      cseqz co cfv vm cv c1 caddc co cM cS cop cG cseqz co cfv wceq wi vm cv cM
      cuz cfv wcel vk cv cF cfv vk cv cG cfv wceq vk cM vm cv c1 caddc co cfz
      co wral vk cv cF cfv vk cv cG cfv wceq vk cM vm cv cfz co wral vm cv cM
      cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq vm cv cM cuz
      cfv wcel vk cv cF cfv vk cv cG cfv wceq vk cv cF cfv vk cv cG cfv wceq vk
      cM vm cv c1 caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv
      cM vm cv cfz co wcel vk cv cM vm cv c1 caddc co cfz co wcel vk cv cF cfv
      vk cv cG cfv wceq vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc
      co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv c1
      caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv
      eluzel2 cM vm cv eluzelz sylanc sseld imim1d r19.20dv2 imim1d vm cv cM
      cuz cfv wcel vk cv cF cfv vk cv cG cfv wceq vk cM vm cv c1 caddc co cfz
      co wral vm cv cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv
      wceq vm cv c1 caddc co cM cS cop cF cseqz co cfv vm cv c1 caddc co cM cS
      cop cG cseqz co cfv wceq vm cv cM cuz cfv wcel vk cv cF cfv vk cv cG cfv
      wceq vk cM vm cv c1 caddc co cfz co wral vm cv cM cS cop cF cseqz co cfv
      vm cv cM cS cop cG cseqz co cfv wceq vm cv c1 caddc co cM cS cop cF cseqz
      co cfv vm cv c1 caddc co cM cS cop cG cseqz co cfv wceq vm cv cM cuz cfv
      wcel vk cv cF cfv vk cv cG cfv wceq vk cM vm cv c1 caddc co cfz co wral
      wa vm cv cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq
      wa vm cv cM cS cop cF cseqz co cfv vm cv c1 caddc co cF cfv cS co vm cv
      cM cS cop cG cseqz co cfv vm cv c1 caddc co cG cfv cS co vm cv c1 caddc
      co cM cS cop cF cseqz co cfv vm cv c1 caddc co cM cS cop cG cseqz co cfv
      vm cv cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq vm
      cv cM cuz cfv wcel vk cv cF cfv vk cv cG cfv wceq vk cM vm cv c1 caddc co
      cfz co wral wa vm cv cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz
      co cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv cS vm cv cM cS
      cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq id vm cv c1
      caddc co cM vm cv c1 caddc co cfz co wcel vk cv cF cfv vk cv cG cfv wceq
      vk cM vm cv c1 caddc co cfz co wral vm cv c1 caddc co cF cfv vm cv c1
      caddc co cG cfv wceq vm cv cM cuz cfv wcel vk cv cF cfv vk cv cG cfv wceq
      vm cv c1 caddc co cF cfv vm cv c1 caddc co cG cfv wceq vk vm cv c1 caddc
      co cM vm cv c1 caddc co cfz co vk cv vm cv c1 caddc co wceq vk cv cF cfv
      vm cv c1 caddc co cF cfv vk cv cG cfv vm cv c1 caddc co cG cfv vk cv vm
      cv c1 caddc co cF fveq2 vk cv vm cv c1 caddc co cG fveq2 eqeq12d rcla4va
      vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co
      cM vm cv c1 caddc co cfz co wcel cM vm cv peano2uz cM vm cv c1 caddc co
      eluzfz2 syl sylan opreqan12rd vm cv cM cuz cfv wcel vm cv c1 caddc co cM
      cS cop cF cseqz co cfv vm cv cM cS cop cF cseqz co cfv vm cv c1 caddc co
      cF cfv cS co wceq vk cv cF cfv vk cv cG cfv wceq vk cM vm cv c1 caddc co
      cfz co wral vm cv cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co
      cfv wceq cS cF cM vm cv seqzfveq.1 seqzfveq.2 seqzp1 ad2antrr vm cv cM
      cuz cfv wcel vm cv c1 caddc co cM cS cop cG cseqz co cfv vm cv cM cS cop
      cG cseqz co cfv vm cv c1 caddc co cG cfv cS co wceq vk cv cF cfv vk cv cG
      cfv wceq vk cM vm cv c1 caddc co cfz co wral vm cv cM cS cop cF cseqz co
      cfv vm cv cM cS cop cG cseqz co cfv wceq cS cG cM vm cv seqzfveq.1
      seqzfveq.3 seqzp1 ad2antrr 3eqtr4d exp31 a2d syld uzind4 imp $.
      $( [4-Nov-2005] $) $( [3-Nov-2005] $)

    $( Equality theorem for the recursive sequence builder. $)
    seqzeq $p |- ( ( M e. ZZ /\ A. k e. ( ZZ>= ` M ) ( F ` k ) = ( G ` k ) ) ->
                 ( <. M , S >. seq F ) = ( <. M , S >. seq G ) ) $=
      cM cz wcel vk cv cF cfv vk cv cG cfv wceq vk cM cuz cfv wral wa cM cS cop
      cF cseqz co cM cS cop cG cseqz co wceq vm cv cM cS cop cF cseqz co cfv vm
      cv cM cS cop cG cseqz co cfv wceq vm cM cuz cfv wral vk cv cF cfv vk cv
      cG cfv wceq vk cM cuz cfv wral vm cv cM cS cop cF cseqz co cfv vm cv cM
      cS cop cG cseqz co cfv wceq vm cM cuz cfv wral cM cz wcel vk cv cF cfv vk
      cv cG cfv wceq vk cM cuz cfv wral vm cv cM cS cop cF cseqz co cfv vm cv
      cM cS cop cG cseqz co cfv wceq vm cM cuz cfv vm cv cM cuz cfv wcel vk cv
      cF cfv vk cv cG cfv wceq vk cM cuz cfv wral vm cv cM cS cop cF cseqz co
      cfv vm cv cM cS cop cG cseqz co cfv wceq vm cv cM cuz cfv wcel vk cv cF
      cfv vk cv cG cfv wceq vk cM vm cv cfz co wral vm cv cM cS cop cF cseqz co
      cfv vm cv cM cS cop cG cseqz co cfv wceq vk cv cF cfv vk cv cG cfv wceq
      vk cM cuz cfv wral cS vk cF cG cM vm cv seqzfveq.1 seqzfveq.2 seqzfveq.3
      seqzfveq vk cv cF cfv vk cv cG cfv wceq vk cv cF cfv vk cv cG cfv wceq vk
      cM cuz cfv cM vm cv cfz co vk cv cM vm cv cfz co wcel vk cv cM cuz cfv
      wcel vk cv cF cfv vk cv cG cfv wceq vk cv cM vm cv elfzuz imim1i r19.20i2
      sylan2 expcom r19.21aiv adantl cM cz wcel vk cv cF cfv vk cv cG cfv wceq
      vk cM cuz cfv wral wa cM cS cop cF cseqz co cM cuz cfv wfn cM cS cop cG
      cseqz co cM cuz cfv wfn wa cM cS cop cF cseqz co cM cS cop cG cseqz co
      wceq vm cv cM cS cop cF cseqz co cfv vm cv cM cS cop cG cseqz co cfv wceq
      vm cM cuz cfv wral wb cM cz wcel cM cS cop cF cseqz co cM cuz cfv wfn cM
      cS cop cG cseqz co cM cuz cfv wfn wa vk cv cF cfv vk cv cG cfv wceq vk cM
      cuz cfv wral cM cz wcel cM cS cop cF cseqz co cM cuz cfv wfn cM cS cop cG
      cseqz co cM cuz cfv wfn cS cF cM seqzfveq.1 seqzfveq.2 seqzfn cS cG cM
      seqzfveq.1 seqzfveq.3 seqzfn jca adantr vm cM cuz cfv cM cS cop cF cseqz
      co cM cS cop cG cseqz co eqfnfv2 syl mpbird $.
      $( [20-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d j m n v y B $.  $d j m n v y C $.  $d j k m n v y F $.
    $d j m n v y M $.  $d m N $.  $d j m n v y S $.
    seqzrn.1 $e |- S e. _V $.
    seqzrn.2 $e |- F e. _V $.
    $( Range of a sequence generated by the arbitrary-based recursive sequence
       builder. $)
    seqzrn2 $p |- ( ( ( M e. ZZ /\ ( F ` M ) e. C ) /\
       ( ( F |` ( ZZ>= ` ( M + 1 ) ) ) : ( ZZ>= ` ( M + 1 ) ) --> B /\
               S : ( C X. B ) --> C ) ) -> ran ( <. M , S >. seq F ) C_ C ) $=
      cM cz wcel cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co
      cuz cfv cres wf cC cB cxp cC cS wf wa cM cS cop cF cseqz co crn cC wss cM
      cS cop cF cseqz co cM cuz cfv wfn vn cv cM cS cop cF cseqz co cfv cC wcel
      vn cM cuz cfv wral cM cS cop cF cseqz co crn cC wss cM cz wcel cM cF cfv
      cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa vn cM cuz cfv cC cM cS cop cF cseqz co fnfvrnss cS cF
      cM seqzrn.1 seqzrn.2 seqzfn cM cF cfv cC wcel cM c1 caddc co cuz cfv cB
      cF cM c1 caddc co cuz cfv cres wf cC cB cxp cC cS wf wa wa vn cv cM cS
      cop cF cseqz co cfv cC wcel vn cM cuz cfv vn cv cM cuz cfv wcel cM cF cfv
      cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa vn cv cM cS cop cF cseqz co cfv cC wcel cM cF cfv cC
      wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa vj cv cM cS cop cF cseqz co cfv cC wcel wi cM cF cfv
      cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa cM cM cS cop cF cseqz co cfv cC wcel wi cM cF cfv cC
      wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa vm cv cM cS cop cF cseqz co cfv cC wcel wi cM cF cfv
      cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa vm cv c1 caddc co cM cS cop cF cseqz co cfv cC wcel wi
      cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv
      cres wf cC cB cxp cC cS wf wa wa vn cv cM cS cop cF cseqz co cfv cC wcel
      wi vj vm cM vn cv vj cv cM wceq vj cv cM cS cop cF cseqz co cfv cC wcel
      cM cM cS cop cF cseqz co cfv cC wcel cM cF cfv cC wcel cM c1 caddc co cuz
      cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB cxp cC cS wf wa wa vj cv
      cM wceq vj cv cM cS cop cF cseqz co cfv cM cM cS cop cF cseqz co cfv cC
      vj cv cM cM cS cop cF cseqz co fveq2 eleq1d imbi2d vj cv vm cv wceq vj cv
      cM cS cop cF cseqz co cfv cC wcel vm cv cM cS cop cF cseqz co cfv cC wcel
      cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv
      cres wf cC cB cxp cC cS wf wa wa vj cv vm cv wceq vj cv cM cS cop cF
      cseqz co cfv vm cv cM cS cop cF cseqz co cfv cC vj cv vm cv cM cS cop cF
      cseqz co fveq2 eleq1d imbi2d vj cv vm cv c1 caddc co wceq vj cv cM cS cop
      cF cseqz co cfv cC wcel vm cv c1 caddc co cM cS cop cF cseqz co cfv cC
      wcel cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz
      cfv cres wf cC cB cxp cC cS wf wa wa vj cv vm cv c1 caddc co wceq vj cv
      cM cS cop cF cseqz co cfv vm cv c1 caddc co cM cS cop cF cseqz co cfv cC
      vj cv vm cv c1 caddc co cM cS cop cF cseqz co fveq2 eleq1d imbi2d vj cv
      vn cv wceq vj cv cM cS cop cF cseqz co cfv cC wcel vn cv cM cS cop cF
      cseqz co cfv cC wcel cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1
      caddc co cuz cfv cres wf cC cB cxp cC cS wf wa wa vj cv vn cv wceq vj cv
      cM cS cop cF cseqz co cfv vn cv cM cS cop cF cseqz co cfv cC vj cv vn cv
      cM cS cop cF cseqz co fveq2 eleq1d imbi2d cM cz wcel cM cM cS cop cF
      cseqz co cfv cC wcel cM cF cfv cC wcel cM cF cfv cC wcel cM c1 caddc co
      cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB cxp cC cS wf wa wa cM
      cz wcel cM cM cS cop cF cseqz co cfv cM cF cfv cC cS cF cM seqzrn.1
      seqzrn.2 seqz1 eleq1d cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM
      c1 caddc co cuz cfv cres wf cC cB cxp cC cS wf wa pm3.26 syl5bir vm cv cM
      cuz cfv wcel cM cF cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc
      co cuz cfv cres wf cC cB cxp cC cS wf wa wa vm cv cM cS cop cF cseqz co
      cfv cC wcel vm cv c1 caddc co cM cS cop cF cseqz co cfv cC wcel cM cF cfv
      cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB
      cxp cC cS wf wa wa vm cv cM cuz cfv wcel vm cv cM cS cop cF cseqz co cfv
      cC wcel vm cv c1 caddc co cM cS cop cF cseqz co cfv cC wcel wi cM c1
      caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf cC cB cxp cC cS wf
      wa vm cv cM cuz cfv wcel vm cv cM cS cop cF cseqz co cfv cC wcel vm cv c1
      caddc co cM cS cop cF cseqz co cfv cC wcel wi wi cM cF cfv cC wcel cC cB
      cxp cC cS wf cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf
      vm cv cM cuz cfv wcel vm cv cM cS cop cF cseqz co cfv cC wcel vm cv c1
      caddc co cM cS cop cF cseqz co cfv cC wcel wi wi cM c1 caddc co cuz cfv
      cB cF cM c1 caddc co cuz cfv cres wf vm cv cM cuz cfv wcel vm cv cM cS
      cop cF cseqz co cfv cC wcel cC cB cxp cC cS wf vm cv c1 caddc co cM cS
      cop cF cseqz co cfv cC wcel cM c1 caddc co cuz cfv cB cF cM c1 caddc co
      cuz cfv cres wf vm cv cM cuz cfv wcel vm cv cM cS cop cF cseqz co cfv cC
      wcel cC cB cxp cC cS wf vm cv c1 caddc co cM cS cop cF cseqz co cfv cC
      wcel wi wi cM c1 caddc co cuz cfv cB cF cM c1 caddc co cuz cfv cres wf vm
      cv cM cuz cfv wcel wa vm cv c1 caddc co cF cfv cB wcel vm cv cM cS cop cF
      cseqz co cfv cC wcel cC cB cxp cC cS wf vm cv c1 caddc co cM cS cop cF
      cseqz co cfv cC wcel wi wi cM c1 caddc co cuz cfv cB cF cM c1 caddc co
      cuz cfv cres wf vm cv c1 caddc co cM c1 caddc co cuz cfv wcel vm cv c1
      caddc co cF cfv cB wcel vm cv cM cuz cfv wcel cM c1 caddc co cuz cfv cB
      cF cM c1 caddc co cuz cfv cres wf vm cv c1 caddc co cM c1 caddc co cuz
      cfv wcel wa vm cv c1 caddc co cF cM c1 caddc co cuz cfv cres cfv cB wcel
      vm cv c1 caddc co cF cfv cB wcel cM c1 caddc co cuz cfv cB vm cv c1 caddc
      co cF cM c1 caddc co cuz cfv cres ffvelrn vm cv c1 caddc co cM c1 caddc
      co cuz cfv wcel vm cv c1 caddc co cF cM c1 caddc co cuz cfv cres cfv cB
      wcel vm cv c1 caddc co cF cfv cB wcel wb cM c1 caddc co cuz cfv cB cF cM
      c1 caddc co cuz cfv cres wf vm cv c1 caddc co cM c1 caddc co cuz cfv wcel
      vm cv c1 caddc co cF cM c1 caddc co cuz cfv cres cfv vm cv c1 caddc co cF
      cfv cB vm cv c1 caddc co cM c1 caddc co cuz cfv cF fvres eleq1d adantl
      mpbid cM vm cv eluzp1p1 sylan2 vm cv cM cuz cfv wcel vm cv c1 caddc co cF
      cfv cB wcel vm cv cM cS cop cF cseqz co cfv cC wcel cC cB cxp cC cS wf vm
      cv c1 caddc co cM cS cop cF cseqz co cfv cC wcel wi wi wi cM c1 caddc co
      cuz cfv cB cF cM c1 caddc co cuz cfv cres wf vm cv cM cuz cfv wcel vm cv
      c1 caddc co cF cfv cB wcel vm cv cM cS cop cF cseqz co cfv cC wcel cC cB
      cxp cC cS wf vm cv c1 caddc co cM cS cop cF cseqz co cfv cC wcel vm cv cM
      cuz cfv wcel vm cv c1 caddc co cM cS cop cF cseqz co cfv cC wcel vm cv cM
      cS cop cF cseqz co cfv vm cv c1 caddc co cF cfv cS co cC wcel vm cv c1
      caddc co cF cfv cB wcel vm cv cM cS cop cF cseqz co cfv cC wcel wa cC cB
      cxp cC cS wf wa vm cv cM cuz cfv wcel vm cv c1 caddc co cM cS cop cF
      cseqz co cfv vm cv cM cS cop cF cseqz co cfv vm cv c1 caddc co cF cfv cS
      co cC cS cF cM vm cv seqzrn.1 seqzrn.2 seqzp1 eleq1d vm cv c1 caddc co cF
      cfv cB wcel vm cv cM cS cop cF cseqz co cfv cC wcel wa cC cB cxp cC cS wf
      vm cv cM cS cop cF cseqz co cfv vm cv c1 caddc co cF cfv cS co cC wcel vm
      cv c1 caddc co cF cfv cB wcel vm cv cM cS cop cF cseqz co cfv cC wcel wa
      vy cv vv cv cS co cC wcel vv cB wral vy cC wral vm cv cM cS cop cF cseqz
      co cfv vm cv c1 caddc co cF cfv cS co cC wcel cC cB cxp cC cS wf vm cv cM
      cS cop cF cseqz co cfv cC wcel vm cv c1 caddc co cF cfv cB wcel vy cv vv
      cv cS co cC wcel vv cB wral vy cC wral vm cv cM cS cop cF cseqz co cfv vm
      cv c1 caddc co cF cfv cS co cC wcel wi vy cv vv cv cS co cC wcel vm cv cM
      cS cop cF cseqz co cfv vm cv c1 caddc co cF cfv cS co cC wcel vm cv cM cS
      cop cF cseqz co cfv vv cv cS co cC wcel vy vv vm cv cM cS cop cF cseqz co
      cfv vm cv c1 caddc co cF cfv cC cB vy cv vm cv cM cS cop cF cseqz co cfv
      wceq vy cv vv cv cS co vm cv cM cS cop cF cseqz co cfv vv cv cS co cC vy
      cv vm cv cM cS cop cF cseqz co cfv vv cv cS opreq1 eleq1d vv cv vm cv c1
      caddc co cF cfv wceq vm cv cM cS cop cF cseqz co cfv vv cv cS co vm cv cM
      cS cop cF cseqz co cfv vm cv c1 caddc co cF cfv cS co cC vv cv vm cv c1
      caddc co cF cfv vm cv cM cS cop cF cseqz co cfv cS opreq2 eleq1d rcla42v
      ancoms cC cB cxp cC cS wf cS cC cB cxp wfn vy cv vv cv cS co cC wcel vv
      cB wral vy cC wral vy vv cC cB cC cS ffnoprv pm3.27bi syl5 imp syl5bir
      exp4c adantl mpd ex com4r impcom adantl com12 a2d uzind4 com12 r19.21aiv
      syl2an anassrs $.
      $( [26-Sep-2005] $) $( [7-Sep-2005] $)

    $( Range of the arbitrary-based recursive sequence builder (special case
       of ~ seqzrn2 ). $)
    seqzrn $p |- ( ( M e. ZZ /\ F : ( ZZ>= ` M ) --> C /\
                 S : ( C X. C ) --> C ) -> ran ( <. M , S >. seq F ) C_ C ) $=
      cM cz wcel cM cuz cfv cC cF wf cC cC cxp cC cS wf cM cS cop cF cseqz co
      crn cC wss cM cz wcel cM cF cfv cC wcel cM c1 caddc co cuz cfv cC cF cM
      c1 caddc co cuz cfv cres wf wa cC cC cxp cC cS wf cM cS cop cF cseqz co
      crn cC wss cM cuz cfv cC cF wf cM cz wcel cM cF cfv cC wcel cM c1 caddc
      co cuz cfv cC cF cM c1 caddc co cuz cfv cres wf cC cC cxp cC cS wf cM cS
      cop cF cseqz co crn cC wss cM cz wcel cM cF cfv cC wcel cM c1 caddc co
      cuz cfv cC cF cM c1 caddc co cuz cfv cres wf cC cC cxp cC cS wf cM cS cop
      cF cseqz co crn cC wss cC cC cS cF cM seqzrn.1 seqzrn.2 seqzrn2 exp43
      imp4c cM cuz cfv cC cF wf cM cz wcel cM cF cfv cC wcel cM c1 caddc co cuz
      cfv cC cF cM c1 caddc co cuz cfv cres wf wa cM cuz cfv cC cF wf cM cz
      wcel wa cM cF cfv cC wcel cM c1 caddc co cuz cfv cC cF cM c1 caddc co cuz
      cfv cres wf cM cuz cfv cC cF wf cM cM cuz cfv wcel cM cF cfv cC wcel cM
      cz wcel cM cuz cfv cC cM cF ffvelrn cM uzid sylan2 cM cuz cfv cC cF wf cM
      c1 caddc co cuz cfv cM cuz cfv wss cM c1 caddc co cuz cfv cC cF cM c1
      caddc co cuz cfv cres wf cM cz wcel cM cuz cfv cC cM c1 caddc co cuz cfv
      cF fssres cM cz wcel cM c1 caddc co cM cuz cfv wcel cM c1 caddc co cuz
      cfv cM cuz cfv wss cM cz wcel cM cM cuz cfv wcel cM c1 caddc co cM cuz
      cfv wcel cM uzid cM cM peano2uz syl cM cM c1 caddc co uzss syl sylan2 jca
      expcom syland 3impib $.
      $( [2-Oct-2005] $) $( [7-Sep-2005] $)

    $( Closure of the value of the arbitrary-based recursive sequence
       builder. $)
    seqzcl $p |- ( ( N e. ( ZZ>= ` M ) /\ F : ( ZZ>= ` M ) --> C /\
              S : ( C X. C ) --> C ) -> ( ( <. M , S >. seq F ) ` N ) e. C ) $=
      cN cM cuz cfv wcel cM cuz cfv cC cF wf cC cC cxp cC cS wf w3a cM cS cop
      cF cseqz co crn cC cN cM cS cop cF cseqz co cfv cM cz wcel cM cuz cfv cC
      cF wf cC cC cxp cC cS wf cM cS cop cF cseqz co crn cC wss cN cM cuz cfv
      wcel cC cS cF cM seqzrn.1 seqzrn.2 seqzrn cM cN eluzel2 syl3an1 cN cM cuz
      cfv wcel cM cuz cfv cC cF wf cN cM cS cop cF cseqz co cfv cM cS cop cF
      cseqz co crn wcel cC cC cxp cC cS wf cM cS cop cF cseqz co cM cuz cfv wfn
      cN cM cuz cfv wcel cN cM cS cop cF cseqz co cfv cM cS cop cF cseqz co crn
      wcel cN cM cuz cfv wcel cM cz wcel cM cS cop cF cseqz co cM cuz cfv wfn
      cM cN eluzel2 cS cF cM seqzrn.1 seqzrn.2 seqzfn syl cM cuz cfv cN cM cS
      cop cF cseqz co fnfvelrn mpancom 3ad2ant1 sseldd $.
      $( [10-Oct-2005] $) $( [7-Sep-2005] $)

    $( A restriction of its characteristic function that doesn't change the
       value of the ` seq ` function. $)
    seqzresval $p |- ( N e. ( ZZ>= ` M ) -> ( ( <. M , S >. seq
              ( F |` ( M ... N ) ) ) ` N ) = ( ( <. M , S >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel vm cv cF cM cN cfz co cres cfv vm cv cF cfv wceq vm cM
      cN cfz co wral cN cM cS cop cF cM cN cfz co cres cseqz co cfv cN cM cS
      cop cF cseqz co cfv wceq vm cv cF cM cN cfz co cres cfv vm cv cF cfv wceq
      vm cM cN cfz co vm cv cM cN cfz co cF fvres rgen cS vm cF cM cN cfz co
      cres cF cM cN seqzrn.1 cF cvv wcel cF cM cN cfz co cres cvv wcel seqzrn.2
      cF cM cN cfz co cvv resexg ax-mp seqzrn.2 seqzfveq mpan2 $.
      $( [22-Mar-2006] $) $( [2-Nov-2005] $)

    $( The ` seq ` function is unchanged by restricting its characteristic
       function to the ` seq ` function's domain. $)
    seqzres $p |- ( M e. ZZ -> ( <. M , S >. seq ( F |` ( ZZ>= ` M ) ) ) =
                     ( <. M , S >. seq F ) ) $=
      cM cS cop cF cM cuz cfv cres cseqz co cM cuz cfv wfn cM cS cop cF cseqz
      co cM cuz cfv wfn cM cS cop cF cM cuz cfv cres cseqz co cM cS cop cF
      cseqz co wceq cM cz wcel cM cS cop cF cM cuz cfv cres cseqz co cM cuz cfv
      wfn cM cS cop cF cseqz co cM cuz cfv wfn wa cM cS cop cF cM cuz cfv cres
      cseqz co cM cS cop cF cseqz co wceq vn cv cM cS cop cF cM cuz cfv cres
      cseqz co cfv vn cv cM cS cop cF cseqz co cfv wceq vn cM cuz cfv wral vn
      cv cM cS cop cF cM cuz cfv cres cseqz co cfv vn cv cM cS cop cF cseqz co
      cfv wceq vn cM cuz cfv vn cv cM cuz cfv wcel vm cv cF cM cuz cfv cres cfv
      vm cv cF cfv wceq vm cM vn cv cfz co wral vn cv cM cS cop cF cM cuz cfv
      cres cseqz co cfv vn cv cM cS cop cF cseqz co cfv wceq vm cv cF cM cuz
      cfv cres cfv vm cv cF cfv wceq vm cM vn cv cfz co vm cv cM vn cv cfz co
      wcel vm cv cM cuz cfv wcel vm cv cF cM cuz cfv cres cfv vm cv cF cfv wceq
      vm cv cM vn cv elfzuz vm cv cM cuz cfv cF fvres syl rgen cS vm cF cM cuz
      cfv cres cF cM vn cv seqzrn.1 cF cvv wcel cF cM cuz cfv cres cvv wcel
      seqzrn.2 cF cM cuz cfv cvv resexg ax-mp seqzrn.2 seqzfveq mpan2 rgen vn
      cM cuz cfv cM cS cop cF cM cuz cfv cres cseqz co cM cS cop cF cseqz co
      eqfnfv2 mpbiri cS cF cM cuz cfv cres cM seqzrn.1 cF cvv wcel cF cM cuz
      cfv cres cvv wcel seqzrn.2 cF cM cuz cfv cvv resexg ax-mp seqzfn cS cF cM
      seqzrn.1 seqzrn.2 seqzfn sylanc $.
      $( [7-Nov-2005] $) $( [7-Sep-2005] $)

    $( The ` seq ` function is unchanged by substituting its characteristic
       function with a restricted class builder based on that function. $)
    seqzres2 $p |- ( M e. ZZ -> ( <. M , S >. seq ( { <. k , y >. | y =
                   ( F ` k ) } |` ZZ ) ) = ( <. M , S >. seq F ) ) $=
      cM cz wcel cM cS cop vk cv cz wcel vy cv vk cv cF cfv wceq wa vk vy copab
      cseqz co cM cS cop cF cseqz co cM cS cop vy cv vk cv cF cfv wceq vk vy
      copab cz cres cseqz co cM cS cop vk cv cz wcel vy cv vk cv cF cfv wceq wa
      vk vy copab cseqz co cM cuz cfv wfn cM cS cop cF cseqz co cM cuz cfv wfn
      cM cS cop vk cv cz wcel vy cv vk cv cF cfv wceq wa vk vy copab cseqz co
      cM cS cop cF cseqz co wceq cM cz wcel cM cS cop vk cv cz wcel vy cv vk cv
      cF cfv wceq wa vk vy copab cseqz co cM cuz cfv wfn cM cS cop cF cseqz co
      cM cuz cfv wfn wa cM cS cop vk cv cz wcel vy cv vk cv cF cfv wceq wa vk
      vy copab cseqz co cM cS cop cF cseqz co wceq vn cv cM cS cop vk cv cz
      wcel vy cv vk cv cF cfv wceq wa vk vy copab cseqz co cfv vn cv cM cS cop
      cF cseqz co cfv wceq vn cM cuz cfv wral vn cv cM cS cop vk cv cz wcel vy
      cv vk cv cF cfv wceq wa vk vy copab cseqz co cfv vn cv cM cS cop cF cseqz
      co cfv wceq vn cM cuz cfv vn cv cM cuz cfv wcel vv cv vk cv cz wcel vy cv
      vk cv cF cfv wceq wa vk vy copab cfv vv cv cF cfv wceq vv cM vn cv cfz co
      wral vn cv cM cS cop vk cv cz wcel vy cv vk cv cF cfv wceq wa vk vy copab
      cseqz co cfv vn cv cM cS cop cF cseqz co cfv wceq vv cv vk cv cz wcel vy
      cv vk cv cF cfv wceq wa vk vy copab cfv vv cv cF cfv wceq vv cM vn cv cfz
      co vv cv cM vn cv cfz co wcel vv cv cz wcel vv cv vk cv cz wcel vy cv vk
      cv cF cfv wceq wa vk vy copab cfv vv cv cF cfv wceq vv cv cM vn cv
      elfzelz vk vy vv cv vk cv cF cfv vv cv cF cfv cz vk cv cz wcel vy cv vk
      cv cF cfv wceq wa vk vy copab vk cv vv cv cF fveq2 vk cv cz wcel vy cv vk
      cv cF cfv wceq wa vk vy copab eqid vv cv cF fvex fvopab4 syl rgen cS vv
      vk cv cz wcel vy cv vk cv cF cfv wceq wa vk vy copab cF cM vn cv seqzrn.1
      vk vy cz vk cv cF cfv zex opabex2 seqzrn.2 seqzfveq mpan2 rgen vn cM cuz
      cfv cM cS cop vk cv cz wcel vy cv vk cv cF cfv wceq wa vk vy copab cseqz
      co cM cS cop cF cseqz co eqfnfv2 mpbiri cS vk cv cz wcel vy cv vk cv cF
      cfv wceq wa vk vy copab cM seqzrn.1 vk vy cz vk cv cF cfv zex opabex2
      seqzfn cS cF cM seqzrn.1 seqzrn.2 seqzfn sylanc vy cv vk cv cF cfv wceq
      vk vy copab cz cres vk cv cz wcel vy cv vk cv cF cfv wceq wa vk vy copab
      cM cS cop cseqz vy cv vk cv cF cfv wceq vk vy cz resopab opreq2i syl5eq
      $.
      $( [1-Nov-2005] $) $( [1-Nov-2005] $)
  $}

  ${
    $d k M $.  $d k F $.
    serzcl1.1 $e |- F : ( ZZ>= ` M ) --> CC $.
    $( The partial sums in an infinite series of complex terms are complex. $)
    serzcl1i $p |- ( N e. ( ZZ>= ` M ) ->
                 ( ( <. M , + >. seq F ) ` N ) e. CC ) $=
      cN cM cuz cfv wcel cM cuz cfv cc cF wf cc cc cxp cc caddc wf cN cM caddc
      cop cF cseqz co cfv cc wcel serzcl1.1 axaddopr cc caddc cF cM cN addex cM
      cuz cfv cc cF wf cM cuz cfv cvv wcel cF cvv wcel serzcl1.1 cM cuz fvex cM
      cuz cfv cc cvv cF fex mp2an seqzcl mp3an23 $.
      $( [18-Oct-2005] $) $( [8-Sep-2005] $)
  $}

  ${
    $d f g h x y $.
    $( Alternate version of ~ df-seq0 . $)
    dfseq0 $p |- seq0 = { <. <. f , g >. , h >. |
                     h = ( <. 0 , f >. seq g ) } $=
      cseq0 vh cv cc0 vf cv cop vg cv cseqz co wceq vf vg vh copab2 wceq cvv
      cvv cxp cvv cvv cxp wceq vx cv vy cv cseq0 co vx cv vy cv vh cv cc0 vf cv
      cop vg cv cseqz co wceq vf vg vh copab2 co wceq vy cvv wral vx cvv wral
      cseq0 cvv cvv cxp wfn vh cv cc0 vf cv cop vg cv cseqz co wceq vf vg vh
      copab2 cvv cvv cxp wfn cseq0 vh cv cc0 vf cv cop vg cv cseqz co wceq vf
      vg vh copab2 wceq cvv cvv cxp cvv cvv cxp wceq vx cv vy cv cseq0 co vx cv
      vy cv vh cv cc0 vf cv cop vg cv cseqz co wceq vf vg vh copab2 co wceq vy
      cvv wral vx cvv wral wa wb cseq0 cvv cvv cxp wfn vh cv vf cv vg cv c1
      cshi co cseq1 co c1 cneg cshi co cn0 cres wceq vf vg vh copab2 cvv cvv
      cxp wfn vf vg vh cvv cvv vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co
      cn0 cres vh cv vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co cn0 cres
      wceq vf vg vh copab2 vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co cvv
      wcel vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co cn0 cres cvv wcel vf
      cv vg cv c1 cshi co cseq1 co c1 cneg cshi oprex vf cv vg cv c1 cshi co
      cseq1 co c1 cneg cshi co cn0 cvv resexg ax-mp vh cv vf cv vg cv c1 cshi
      co cseq1 co c1 cneg cshi co cn0 cres wceq vf cv cvv wcel vg cv cvv wcel
      wa vh cv vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co cn0 cres wceq wa
      vf vg vh vf cv cvv wcel vg cv cvv wcel wa vh cv vf cv vg cv c1 cshi co
      cseq1 co c1 cneg cshi co cn0 cres wceq vf cv cvv wcel vg cv cvv wcel vf
      visset vg visset pm3.2i biantrur oprabbii fnoprab2 cseq0 vh cv vf cv vg
      cv c1 cshi co cseq1 co c1 cneg cshi co cn0 cres wceq vf vg vh copab2 wceq
      cseq0 cvv cvv cxp wfn vh cv vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi
      co cn0 cres wceq vf vg vh copab2 cvv cvv cxp wfn wb vf vg vh df-seq0 cvv
      cvv cxp cseq0 vh cv vf cv vg cv c1 cshi co cseq1 co c1 cneg cshi co cn0
      cres wceq vf vg vh copab2 fneq1 ax-mp mpbir vf vg vh cvv cvv cc0 vf cv
      cop vg cv cseqz co vh cv cc0 vf cv cop vg cv cseqz co wceq vf vg vh
      copab2 cc0 vf cv cop vg cv cseqz oprex vh cv cc0 vf cv cop vg cv cseqz co
      wceq vf cv cvv wcel vg cv cvv wcel wa vh cv cc0 vf cv cop vg cv cseqz co
      wceq wa vf vg vh vf cv cvv wcel vg cv cvv wcel wa vh cv cc0 vf cv cop vg
      cv cseqz co wceq vf cv cvv wcel vg cv cvv wcel vf visset vg visset pm3.2i
      biantrur oprabbii fnoprab2 vx vy cvv cvv cvv cvv cseq0 vh cv cc0 vf cv
      cop vg cv cseqz co wceq vf vg vh copab2 eqfnoprv mp2an cvv cvv cxp eqid
      vx cv vy cv cseq0 co vx cv vy cv vh cv cc0 vf cv cop vg cv cseqz co wceq
      vf vg vh copab2 co wceq vx vy cvv vx cv cvv wcel vy cv cvv wcel wa vx cv
      vy cv vh cv cc0 vf cv cop vg cv cseqz co wceq vf vg vh copab2 co cc0 vx
      cv cop vy cv cseqz co vx cv vy cv cseq0 co vf vg vh vx cv vy cv cvv cvv
      cc0 vf cv cop vg cv cseqz co cc0 vx cv cop vy cv cseqz co vh cv cc0 vf cv
      cop vg cv cseqz co wceq vf vg vh copab2 cc0 vx cv cop vg cv cseqz co cc0
      vx cv cop vy cv cseqz oprex vf cv vx cv wceq cc0 vf cv cop cc0 vx cv cop
      vg cv cseqz vf cv vx cv cc0 opeq2 opreq1d vg cv vy cv cc0 vx cv cop cseqz
      opreq2 vh cv cc0 vf cv cop vg cv cseqz co wceq vf vg vh copab2 eqid
      oprabval5 vx cv vy cv vx visset vy visset seq0seqz syl6reqr rgen2a
      mpbir2an $.
      $( [27-Sep-2005] $) $( [1-Sep-2005] $)
  $}

  ${
    $d j N $.  $d j k F $.
    ser0cl.1 $e |- F : NN0 --> CC $.
    $( The partial sums in an infinite 0-based series of complex terms are
       complex. $)
    ser0cl1i $p |- ( N e. NN0 -> ( ( + seq0 F ) ` N ) e. CC ) $=
      vj cv caddc cF cseq0 co cfv cc wcel cc0 caddc cF cseq0 co cfv cc wcel vk
      cv caddc cF cseq0 co cfv cc wcel vk cv c1 caddc co caddc cF cseq0 co cfv
      cc wcel cN caddc cF cseq0 co cfv cc wcel vj vk cN vj cv cc0 wceq vj cv
      caddc cF cseq0 co cfv cc0 caddc cF cseq0 co cfv cc vj cv cc0 caddc cF
      cseq0 co fveq2 eleq1d vj cv vk cv wceq vj cv caddc cF cseq0 co cfv vk cv
      caddc cF cseq0 co cfv cc vj cv vk cv caddc cF cseq0 co fveq2 eleq1d vj cv
      vk cv c1 caddc co wceq vj cv caddc cF cseq0 co cfv vk cv c1 caddc co
      caddc cF cseq0 co cfv cc vj cv vk cv c1 caddc co caddc cF cseq0 co fveq2
      eleq1d vj cv cN wceq vj cv caddc cF cseq0 co cfv cN caddc cF cseq0 co cfv
      cc vj cv cN caddc cF cseq0 co fveq2 eleq1d cc0 caddc cF cseq0 co cfv cc0
      cF cfv cc caddc cF addex cn0 cc cF wf cn0 cvv wcel cF cvv wcel ser0cl.1
      nn0ex cn0 cc cvv cF fex mp2an seq00 cc0 cn0 wcel cc0 cF cfv cc wcel 0nn0
      cn0 cc cc0 cF ser0cl.1 ffvelrni ax-mp eqeltri vk cv cn0 wcel vk cv caddc
      cF cseq0 co cfv cc wcel vk cv c1 caddc co caddc cF cseq0 co cfv cc wcel
      vk cv cn0 wcel vk cv caddc cF cseq0 co cfv cc wcel wa vk cv c1 caddc co
      caddc cF cseq0 co cfv vk cv caddc cF cseq0 co cfv vk cv c1 caddc co cF
      cfv caddc co cc vk cv cn0 wcel vk cv c1 caddc co caddc cF cseq0 co cfv vk
      cv caddc cF cseq0 co cfv vk cv c1 caddc co cF cfv caddc co wceq vk cv
      caddc cF cseq0 co cfv cc wcel caddc cF vk cv addex cn0 cc cF wf cn0 cvv
      wcel cF cvv wcel ser0cl.1 nn0ex cn0 cc cvv cF fex mp2an seq0p1 adantr vk
      cv caddc cF cseq0 co cfv cc wcel vk cv cn0 wcel vk cv caddc cF cseq0 co
      cfv vk cv c1 caddc co cF cfv caddc co cc wcel vk cv caddc cF cseq0 co cfv
      cc wcel vk cv c1 caddc co cF cfv cc wcel vk cv caddc cF cseq0 co cfv vk
      cv c1 caddc co cF cfv caddc co cc wcel vk cv cn0 wcel vk cv caddc cF
      cseq0 co cfv vk cv c1 caddc co cF cfv addcl vk cv cn0 wcel vk cv c1 caddc
      co cn0 wcel vk cv c1 caddc co cF cfv cc wcel vk cv peano2nn0 cn0 cc vk cv
      c1 caddc co cF ser0cl.1 ffvelrni syl sylan2 ancoms eqeltrd ex nn0ind $.
      $( [17-Apr-2006] $) $( [19-Aug-2005] $)

    $( A 0-based infinite series is a function from ` NN0 ` to ` CC ` . $)
    ser0fi $p |- ( + seq0 F ) : NN0 --> CC $=
      cn0 cc caddc cF cseq0 co wf caddc cF cseq0 co cn0 wfn vj cv caddc cF
      cseq0 co cfv cc wcel vj cn0 wral vj cn0 cc caddc cF cseq0 co ffnfv caddc
      cF addex cn0 cc cF wf cn0 cvv wcel cF cvv wcel ser0cl.1 nn0ex cn0 cc cvv
      cF fex mp2an seq0fn vj cv caddc cF cseq0 co cfv cc wcel vj cn0 cF vj cv
      ser0cl.1 ser0cl1i rgen mpbir2an $.
      $( [24-Apr-2006] $) $( [19-Aug-2005] $)
  $}

  ${
    $d y A $.  $d k y B $.  $d k y N $.
    ser00.1 $e |- F = { <. k , y >. | ( k e. NN0 /\ y = A ) } $.
    ser00.2 $e |- B e. _V $.
    ${
      ser00.3 $e |- ( k = 0 -> A = B ) $.
      $( The value of the first term in a 0-based infinite series. $)
      ser00i $p |- ( ( + seq0 F ) ` 0 ) = B $=
        cc0 caddc cF cseq0 co cfv cc0 cF cfv cB caddc cF addex vk vy cn0 cA cF
        nn0ex ser00.1 fopabex2 seq00 cc0 cn0 wcel cc0 cF cfv cB wceq 0nn0 vk vy
        cc0 cA cB cn0 cF ser00.3 ser00.1 ser00.2 fvopab4 ax-mp eqtri $.
        $( [15-May-2006] $) $( [13-May-2006] $)
    $}

    ${
      ser0p1.3 $e |- ( k = ( N + 1 ) -> A = B ) $.
      $( The value of the next term in a 0-based infinite series. $)
      ser0p1i $p |- ( N e. NN0 ->
               ( ( + seq0 F ) ` ( N + 1 ) ) = ( ( ( + seq0 F ) ` N ) + B ) ) $=
        cN cn0 wcel cN c1 caddc co caddc cF cseq0 co cfv cN caddc cF cseq0 co
        cfv cN c1 caddc co cF cfv caddc co cN caddc cF cseq0 co cfv cB caddc co
        caddc cF cN addex vk vy cn0 cA cF nn0ex ser00.1 fopabex2 seq0p1 cN cn0
        wcel cN c1 caddc co cF cfv cB cN caddc cF cseq0 co cfv caddc cN cn0
        wcel cN c1 caddc co cn0 wcel cN c1 caddc co cF cfv cB wceq cN peano2nn0
        vk vy cN c1 caddc co cA cB cn0 cF ser0p1.3 ser00.1 ser00.2 fvopab4 syl
        opreq2d eqtrd $.
        $( [14-May-2006] $) $( [13-May-2006] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Integer powers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ^ $. $( Exponentiation. $)

  $( Extend class notation to include exponentiation of a complex number to an
     integer power. $)
  cexp $a class ^ $.

  ${
    $d x y z $.
    $( Define exponentiation to nonnegative integer powers.  This definition is
       not meant to be used directly; instead, ~ exp0 and ~ expp1 provide a
       the standard recursive definition.  The up-arrow notation is used by
       Donald Knuth for iterated exponentiation (_Science_ 194, 1235-1242,
       1976) and is convenient for us since we don't have superscripts.  See
       ~ expnnval for a description of how the recursive sequence builder is
       used.  10-Jun-2005: The definition was extended to include zero
       exponents, so that ` 0 ^ 0 = 1 ` per the convention of Definition
       10-4.1 of [Gleason] p. 134.  (Based on definition contributed by Raph
       Levien, 15-Oct-2004.) $)
    df-exp $a |- ^ = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. NN0 ) /\
          z = if ( y = 0 , 1 , ( ( x. seq1 ( NN X. { x } ) ) ` y ) ) ) }  $.

    $(
    Raph Levien's original definition from set.mm of 15-Oct-2004:
    df-exp $a |- ^ = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. NN0 ) /\
          z = ( ( rec ( { <. w , v >. | v = ( w x. x ) } , 1 ) o.
        `' ( rec ( { <. w , v >. | v = ( w + 1 ) } , 0 ) |` om ) ) ` y ) ) } $.

    Old NN-based version from set.mm of 21-May-2005:
    df-exp $a |- ^ = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. NN ) /\
          z = ( ( x. seq1 ( NN X. { x } ) ) ` y ) ) }  $.
    dfexp2 $p |- ^ = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. NN0 ) /\
        z = ( ( x. seq1 ( { <. 0 , 1 >. } u. ( NN X. { x } ) ) ) ` y ) ) } $=
          z = ( ( x. seq0 ( NN0 X. { if ( y = 0 , 1 , x ) } ) ) ` y ) ) } $=
    $)
  $}

  ${
    $d x y z A $.  $d x y z N $.
    $( Value of exponentiation to nonnegative integer powers. $)
    expval $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A ^ N ) =
                   if ( N = 0 , 1 , ( ( x. seq1 ( NN X. { A } ) ) ` N ) ) ) $=
      vx vy vz cA cN cc cn0 vy cv cc0 wceq c1 vy cv cmul cn vx cv csn cxp cseq1
      co cfv cif cN cc0 wceq c1 cN cmul cn cA csn cxp cseq1 co cfv cif cexp vy
      cv cc0 wceq c1 vy cv cmul cn cA csn cxp cseq1 co cfv cif cN cc0 wceq c1
      cN cmul cn cA csn cxp cseq1 co cfv c1 cn0 1nn0 elisseti cN cmul cn cA csn
      cxp cseq1 co fvex ifex vx cv cA wceq vy cv cc0 wceq vy cv cmul cn vx cv
      csn cxp cseq1 co cfv vy cv cmul cn cA csn cxp cseq1 co cfv c1 vx cv cA
      wceq vy cv cmul cn vx cv csn cxp cseq1 co cmul cn cA csn cxp cseq1 co vx
      cv cA wceq cn vx cv csn cxp cn cA csn cxp cmul cseq1 vx cv cA wceq vx cv
      csn cA csn wceq cn vx cv csn cxp cn cA csn cxp wceq vx cv cA sneq vx cv
      csn cA csn cn xpeq2 syl opreq2d fveq1d ifeq2d vy cv cN wceq vy cv cc0
      wceq c1 vy cv cmul cn cA csn cxp cseq1 co cfv cif vy cv cc0 wceq c1 cN
      cmul cn cA csn cxp cseq1 co cfv cif cN cc0 wceq c1 cN cmul cn cA csn cxp
      cseq1 co cfv cif vy cv cN wceq vy cv cc0 wceq vy cv cmul cn cA csn cxp
      cseq1 co cfv cN cmul cn cA csn cxp cseq1 co cfv c1 vy cv cN cmul cn cA
      csn cxp cseq1 co fveq2 ifeq2d vy cv cN wceq vy cv cc0 wceq cN cc0 wceq c1
      cN cmul cn cA csn cxp cseq1 co cfv vy cv cN cc0 eqeq1 ifbid eqtrd vx vy
      vz df-exp oprabval2 $.
      $( [11-Jun-2005] $) $( [20-May-2004] $)

    $( Value of a complex number raised to the 0th power.  Note that under our
       definition, ` 0 ^ 0 = 1 ` , following the convention used by Gleason.
       Part of Definition 10-4.1 of [Gleason] p. 134. $)
    exp0 $p |- ( A e. CC -> ( A ^ 0 ) = 1 ) $=
      cA cc wcel cA cc0 cexp co cc0 cc0 wceq c1 cc0 cmul cn cA csn cxp cseq1 co
      cfv cif c1 cA cc wcel cc0 cn0 wcel cA cc0 cexp co cc0 cc0 wceq c1 cc0
      cmul cn cA csn cxp cseq1 co cfv cif wceq 0nn0 cA cc0 expval mpan2 cc0 cc0
      wceq cc0 cc0 wceq c1 cc0 cmul cn cA csn cxp cseq1 co cfv cif c1 wceq cc0
      eqid cc0 cc0 wceq c1 cc0 cmul cn cA csn cxp cseq1 co cfv iftrue ax-mp
      syl6eq $.
      $( [11-Jun-2005] $) $( [20-May-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( Value of exponentiation to natural number powers.  ` NN X. { A }  `
       is the constant function with value ` A ` .  The ` seq1 ` operation
       produces the sequence ` A ` , ` A x. A ` , ` ( A x. A ) x. A ` ,...
       that we evaluate at index ` B ` . $)
    expnnval $p |- ( ( A e. CC /\ B e. NN ) -> ( A ^ B ) =
                   ( ( x. seq1 ( NN X. { A } ) ) ` B ) ) $=
      cA cc wcel cB cn wcel wa cA cB cexp co cB cc0 wceq c1 cB cmul cn cA csn
      cxp cseq1 co cfv cif cB cmul cn cA csn cxp cseq1 co cfv cA cc wcel cB cn0
      wcel cA cB cexp co cB cc0 wceq c1 cB cmul cn cA csn cxp cseq1 co cfv cif
      wceq cB cn wcel cA cB expval cB nnnn0 sylan2 cB cn wcel cB cc0 wceq c1 cB
      cmul cn cA csn cxp cseq1 co cfv cif cB cmul cn cA csn cxp cseq1 co cfv
      wceq cA cc wcel cB cn wcel cB cc0 wceq wn cB cc0 wceq c1 cB cmul cn cA
      csn cxp cseq1 co cfv cif cB cmul cn cA csn cxp cseq1 co cfv wceq cB cn
      wcel cB cc0 wne cB cc0 wceq wn cB nnne0 cB cc0 df-ne sylib cB cc0 wceq c1
      cB cmul cn cA csn cxp cseq1 co cfv iffalse syl adantl eqtrd $.
      $( [22-Oct-2004] $) $( [19-Oct-2004] $)
  $}

  $( Value of a complex number raised to the first power. $)
  exp1 $p |- ( A e. CC -> ( A ^ 1 ) = A ) $=
    cA cc wcel cA c1 cexp co c1 cmul cn cA csn cxp cseq1 co cfv cA cA cc wcel
    c1 cn wcel cA c1 cexp co c1 cmul cn cA csn cxp cseq1 co cfv wceq 1nn cA c1
    expnnval mpan2 cA cc wcel c1 cn cA csn cxp cfv cA c1 cmul cn cA csn cxp
    cseq1 co cfv cn cA csn cn cA csn cxp wf c1 cn wcel c1 cn cA csn cxp cfv cA
    wceq cA cc wcel cn cA c1 cn cA csn cxp fvconst cn cA cc fconstg 1nn sylancl
    cmul cn cA csn cxp mulex cn cA csn nnex cA snex xpex seq11 syl5eq eqtrd $.
    $( [22-Oct-2004] $) $( [20-Oct-2004] $)

  $( Value of a complex number raised to a nonnegative integer power plus one.
     Part of Definition 10-4.1 of [Gleason] p. 134. $)
  expp1 $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A ^ ( N + 1 ) ) =
               ( ( A ^ N ) x. A ) ) $=
    cA cc wcel cN cn0 wcel cA cN c1 caddc co cexp co cA cN cexp co cA cmul co
    wceq cA cc wcel cN cn wcel cN cc0 wceq wo cA cN c1 caddc co cexp co cA cN
    cexp co cA cmul co wceq cN cn0 wcel cA cc wcel cN cn wcel cA cN c1 caddc co
    cexp co cA cN cexp co cA cmul co wceq cN cc0 wceq cA cc wcel cN cn wcel cA
    cN c1 caddc co cexp co cA cN cexp co cA cmul co wceq cA cc wcel cN cn wcel
    wa cN c1 caddc co cmul cn cA csn cxp cseq1 co cfv cN cmul cn cA csn cxp
    cseq1 co cfv cA cmul co cA cN c1 caddc co cexp co cA cN cexp co cA cmul co
    cA cc wcel cN cn wcel wa cN c1 caddc co cmul cn cA csn cxp cseq1 co cfv cN
    cmul cn cA csn cxp cseq1 co cfv cN c1 caddc co cn cA csn cxp cfv cmul co cN
    cmul cn cA csn cxp cseq1 co cfv cA cmul co cN cn wcel cN c1 caddc co cmul
    cn cA csn cxp cseq1 co cfv cN cmul cn cA csn cxp cseq1 co cfv cN c1 caddc
    co cn cA csn cxp cfv cmul co wceq cA cc wcel cN cmul cn cA csn cxp mulex cn
    cA csn nnex cA snex xpex seq1p1 adantl cA cc wcel cN cn wcel wa cN c1 caddc
    co cn cA csn cxp cfv cA cN cmul cn cA csn cxp cseq1 co cfv cmul cn cA csn
    cn cA csn cxp wf cN c1 caddc co cn wcel cN c1 caddc co cn cA csn cxp cfv cA
    wceq cA cc wcel cN cn wcel cn cA cN c1 caddc co cn cA csn cxp fvconst cn cA
    cc fconstg cN peano2nn syl2an opreq2d eqtrd cA cc wcel cN c1 caddc co cn
    wcel cA cN c1 caddc co cexp co cN c1 caddc co cmul cn cA csn cxp cseq1 co
    cfv wceq cN cn wcel cA cN c1 caddc co expnnval cN peano2nn sylan2 cA cc
    wcel cN cn wcel wa cA cN cexp co cN cmul cn cA csn cxp cseq1 co cfv cA cmul
    cA cN expnnval opreq1d 3eqtr4d ex cN cc0 wceq cA cN c1 caddc co cexp co cA
    cN cexp co cA cmul co wceq cA cc0 c1 caddc co cexp co cA cc0 cexp co cA
    cmul co wceq cA cc wcel cN cc0 wceq cA cN c1 caddc co cexp co cA cc0 c1
    caddc co cexp co cA cN cexp co cA cmul co cA cc0 cexp co cA cmul co cN cc0
    wceq cN c1 caddc co cc0 c1 caddc co cA cexp cN cc0 c1 caddc opreq1 opreq2d
    cN cc0 wceq cA cN cexp co cA cc0 cexp co cA cmul cN cc0 cA cexp opreq2
    opreq1d eqeq12d cA cc wcel c1 cA cmul co cA cA cc0 cexp co cA cmul co cA
    cc0 c1 caddc co cexp co cA mulid2 cA cc wcel cA cc0 cexp co c1 cA cmul cA
    exp0 opreq1d cA cc wcel cA c1 cexp co cA cA cc0 c1 caddc co cexp co cA exp1
    cc0 c1 caddc co c1 cA cexp c1 ax1cn addid2i opreq2i syl5eq 3eqtr4rd
    syl5cbir jaod cN elnn0 syl5ib imp $.
    $( [27-Jul-2006] $) $( [20-May-2005] $)

  ${
    $d x y z w A $.  $d z B $.  $d x y z w F $.
    expcllem.1 $e |- F C_ CC $.
    expcllem.2 $e |- ( ( x e. F /\ y e. F ) -> ( x x. y ) e. F ) $.
    expcllem.3 $e |- 1 e. F $.
    $( Lemma for proving nonnegative integer exponentiation closure laws. $)
    expcllem $p |- ( ( A e. F /\ B e. NN0 ) -> ( A ^ B ) e. F ) $=
      cA cF wcel cB cn wcel cB cc0 wceq wo cA cB cexp co cF wcel cB cn0 wcel cA
      cF wcel cB cn wcel cA cB cexp co cF wcel cB cc0 wceq cB cn wcel cA cF
      wcel cA cB cexp co cF wcel cA cF wcel cA vz cv cexp co cF wcel wi cA cF
      wcel cA c1 cexp co cF wcel wi cA cF wcel cA vw cv cexp co cF wcel wi cA
      cF wcel cA vw cv c1 caddc co cexp co cF wcel wi cA cF wcel cA cB cexp co
      cF wcel wi vz vw cB vz cv c1 wceq cA vz cv cexp co cF wcel cA c1 cexp co
      cF wcel cA cF wcel vz cv c1 wceq cA vz cv cexp co cA c1 cexp co cF vz cv
      c1 cA cexp opreq2 eleq1d imbi2d vz cv vw cv wceq cA vz cv cexp co cF wcel
      cA vw cv cexp co cF wcel cA cF wcel vz cv vw cv wceq cA vz cv cexp co cA
      vw cv cexp co cF vz cv vw cv cA cexp opreq2 eleq1d imbi2d vz cv vw cv c1
      caddc co wceq cA vz cv cexp co cF wcel cA vw cv c1 caddc co cexp co cF
      wcel cA cF wcel vz cv vw cv c1 caddc co wceq cA vz cv cexp co cA vw cv c1
      caddc co cexp co cF vz cv vw cv c1 caddc co cA cexp opreq2 eleq1d imbi2d
      vz cv cB wceq cA vz cv cexp co cF wcel cA cB cexp co cF wcel cA cF wcel
      vz cv cB wceq cA vz cv cexp co cA cB cexp co cF vz cv cB cA cexp opreq2
      eleq1d imbi2d cA cF wcel cA c1 cexp co cF wcel cA cF wcel cA c1 cexp co
      cA cF cA cF wcel cA cc wcel cA c1 cexp co cA wceq cF cc cA expcllem.1
      sseli cA exp1 syl eleq1d ibir vw cv cn wcel cA cF wcel cA vw cv cexp co
      cF wcel cA vw cv c1 caddc co cexp co cF wcel cA cF wcel vw cv cn wcel cA
      vw cv cexp co cF wcel cA vw cv c1 caddc co cexp co cF wcel wi cA cF wcel
      vw cv cn wcel cA vw cv cexp co cF wcel cA vw cv c1 caddc co cexp co cF
      wcel cA cF wcel vw cv cn wcel wa cA vw cv cexp co cF wcel wa cA vw cv c1
      caddc co cexp co cF wcel cA vw cv cexp co cA cmul co cF wcel cA cF wcel
      cA vw cv cexp co cF wcel cA vw cv cexp co cA cmul co cF wcel vw cv cn
      wcel cA vw cv cexp co cF wcel cA cF wcel cA vw cv cexp co cA cmul co cF
      wcel vx cv vy cv cmul co cF wcel cA vw cv cexp co vy cv cmul co cF wcel
      cA vw cv cexp co cA cmul co cF wcel vx vy cA vw cv cexp co cA cF cF vx cv
      cA vw cv cexp co wceq vx cv vy cv cmul co cA vw cv cexp co vy cv cmul co
      cF vx cv cA vw cv cexp co vy cv cmul opreq1 eleq1d vy cv cA wceq cA vw cv
      cexp co vy cv cmul co cA vw cv cexp co cA cmul co cF vy cv cA cA vw cv
      cexp co cmul opreq2 eleq1d expcllem.2 vtocl2ga ancoms adantlr cA cF wcel
      vw cv cn wcel wa cA vw cv c1 caddc co cexp co cF wcel cA vw cv cexp co cA
      cmul co cF wcel wb cA vw cv cexp co cF wcel cA cF wcel vw cv cn wcel wa
      cA vw cv c1 caddc co cexp co cA vw cv cexp co cA cmul co cF cA cc wcel vw
      cv cn0 wcel cA vw cv c1 caddc co cexp co cA vw cv cexp co cA cmul co wceq
      cA cF wcel vw cv cn wcel cA vw cv expp1 cF cc cA expcllem.1 sseli vw cv
      nnnn0 syl2an eleq1d adantr mpbird exp31 com12 a2d nnind impcom cA cF wcel
      cB cc0 wceq wa cA cB cexp co c1 cF cB cc0 wceq cA cF wcel cA cB cexp co
      cA cc0 cexp co c1 cB cc0 cA cexp opreq2 cA cF wcel cA cc wcel cA cc0 cexp
      co c1 wceq cF cc cA expcllem.1 sseli cA exp0 syl sylan9eqr expcllem.3
      syl6eqel jaodan cB elnn0 sylan2b $.
      $( [15-Dec-2005] $) $( [14-Dec-2005] $)
  $}

  ${
    $d x y A $.  $d x y N $.
    $( Closure of exponentiation of nonnegative integers. $)
    nnexpcl $p |- ( ( A e. NN /\ N e. NN0 ) -> ( A ^ N ) e. NN ) $=
      vx vy cA cN cn nnsscn vx cv vy cv nnmulcl 1nn expcllem $.
      $( [28-Jan-2006] $) $( [16-Dec-2005] $)

    $( Closure of exponentiation of nonnegative integers. $)
    nn0expcl $p |- ( ( A e. NN0 /\ N e. NN0 ) -> ( A ^ N ) e. NN0 ) $=
      vx vy cA cN cn0 nn0sscn vx cv vy cv nn0mulcl 1nn0 expcllem $.
      $( [15-Dec-2005] $) $( [14-Dec-2005] $)

    $( Closure of exponentiation of integers. $)
    zexpcl $p |- ( ( A e. ZZ /\ N e. NN0 ) -> ( A ^ N ) e. ZZ ) $=
      vx vy cA cN cz zsscn vx cv vy cv zmulcl 1z expcllem $.
      $( [3-May-2006] $) $( [16-Dec-2005] $)

    $( Closure of exponentiation of rationals. $)
    qexpcl $p |- ( ( A e. QQ /\ N e. NN0 ) -> ( A ^ N ) e. QQ ) $=
      vx vy cA cN cq qsscn vx cv vy cv qmulcl c1 cz wcel c1 cq wcel 1z c1 zq
      ax-mp expcllem $.
      $( [16-Mar-2006] $) $( [16-Dec-2005] $)

    $( Closure of exponentiation of reals. $)
    reexpcl $p |- ( ( A e. RR /\ N e. NN0 ) -> ( A ^ N ) e. RR ) $=
      vx vy cA cN cr axresscn vx cv vy cv remulcl 1re expcllem $.
      $( [15-Dec-2005] $) $( [14-Dec-2005] $)

    $( Closure law for nonnegative integer exponentiation. $)
    expcl $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A ^ N ) e. CC ) $=
      vx vy cA cN cc cc ssid vx cv vy cv mulcl ax1cn expcllem $.
      $( [25-Jul-2005] $) $( [26-May-2005] $)

    $( Closure law for exponentiation of positive reals. $)
    rpexpcl $p |- ( ( A e. RR+ /\ N e. NN0 ) -> ( A ^ N ) e. RR+ ) $=
      vx vy cA cN crp crp cr cc rpssre axresscn sstri vx cv vy cv rpmulcl 1rp
      expcllem $.
      $( [20-Mar-2008] $) $( [24-Feb-2008] $)
  $}

  $( Exponentiation in terms of predecessor exponent. $)
  expm1t $p |- ( ( A e. CC /\ N e. NN ) -> ( A ^ N ) =
               ( ( A ^ ( N - 1 ) ) x. A ) ) $=
    cA cc wcel cN cn wcel wa cA cN c1 cmin co c1 caddc co cexp co cA cN cexp co
    cA cN c1 cmin co cexp co cA cmul co cN cn wcel cA cN c1 cmin co c1 caddc co
    cexp co cA cN cexp co wceq cA cc wcel cN cn wcel cN c1 cmin co c1 caddc co
    cN cA cexp cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN cn
    wcel cN c1 npcan cN nncn ax1cn sylancl opreq2d adantl cA cc wcel cN c1 cmin
    co cn0 wcel cA cN c1 cmin co c1 caddc co cexp co cA cN c1 cmin co cexp co
    cA cmul co wceq cN cn wcel cA cN c1 cmin co expp1 cN nnm1nn0 sylan2 eqtr3d
    $.
    $( [26-Jan-2006] $) $( [19-Dec-2005] $)

  ${
    $d j k N $.
    $( Value of one raised to a nonnegative integer power. $)
    1exp $p |- ( N e. NN0 -> ( 1 ^ N ) = 1 ) $=
      c1 vj cv cexp co c1 wceq c1 cc0 cexp co c1 wceq c1 vk cv cexp co c1 wceq
      c1 vk cv c1 caddc co cexp co c1 wceq c1 cN cexp co c1 wceq vj vk cN vj cv
      cc0 wceq c1 vj cv cexp co c1 cc0 cexp co c1 vj cv cc0 c1 cexp opreq2
      eqeq1d vj cv vk cv wceq c1 vj cv cexp co c1 vk cv cexp co c1 vj cv vk cv
      c1 cexp opreq2 eqeq1d vj cv vk cv c1 caddc co wceq c1 vj cv cexp co c1 vk
      cv c1 caddc co cexp co c1 vj cv vk cv c1 caddc co c1 cexp opreq2 eqeq1d
      vj cv cN wceq c1 vj cv cexp co c1 cN cexp co c1 vj cv cN c1 cexp opreq2
      eqeq1d c1 cc wcel c1 cc0 cexp co c1 wceq ax1cn c1 exp0 ax-mp vk cv cn0
      wcel c1 vk cv c1 caddc co cexp co c1 wceq c1 vk cv cexp co c1 cmul co c1
      wceq c1 vk cv cexp co c1 wceq vk cv cn0 wcel c1 vk cv c1 caddc co cexp co
      c1 vk cv cexp co c1 cmul co c1 c1 cc wcel vk cv cn0 wcel c1 vk cv c1
      caddc co cexp co c1 vk cv cexp co c1 cmul co wceq ax1cn c1 vk cv expp1
      mpan eqeq1d c1 vk cv cexp co c1 wceq c1 vk cv cexp co c1 cmul co c1 c1
      cmul co c1 c1 vk cv cexp co c1 c1 cmul opreq1 c1 ax1cn mulid1i syl6eq
      syl5bir nn0ind $.
      $( [16-Dec-2005] $) $( [15-Dec-2005] $)
  $}

  ${
    $d j k A $.  $d j k N $.
    $( Natural number exponentiation is 0 iff its mantissa is 0. $)
    expeq0 $p |- ( ( A e. CC /\ N e. NN ) -> ( ( A ^ N ) = 0 <-> A = 0 ) ) $=
      cN cn wcel cA cc wcel cA cN cexp co cc0 wceq cA cc0 wceq wb cA cc wcel cA
      vj cv cexp co cc0 wceq cA cc0 wceq wb wi cA cc wcel cA c1 cexp co cc0
      wceq cA cc0 wceq wb wi cA cc wcel cA vk cv cexp co cc0 wceq cA cc0 wceq
      wb wi cA cc wcel cA vk cv c1 caddc co cexp co cc0 wceq cA cc0 wceq wb wi
      cA cc wcel cA cN cexp co cc0 wceq cA cc0 wceq wb wi vj vk cN vj cv c1
      wceq cA vj cv cexp co cc0 wceq cA cc0 wceq wb cA c1 cexp co cc0 wceq cA
      cc0 wceq wb cA cc wcel vj cv c1 wceq cA vj cv cexp co cc0 wceq cA c1 cexp
      co cc0 wceq cA cc0 wceq vj cv c1 wceq cA vj cv cexp co cA c1 cexp co cc0
      vj cv c1 cA cexp opreq2 eqeq1d bibi1d imbi2d vj cv vk cv wceq cA vj cv
      cexp co cc0 wceq cA cc0 wceq wb cA vk cv cexp co cc0 wceq cA cc0 wceq wb
      cA cc wcel vj cv vk cv wceq cA vj cv cexp co cc0 wceq cA vk cv cexp co
      cc0 wceq cA cc0 wceq vj cv vk cv wceq cA vj cv cexp co cA vk cv cexp co
      cc0 vj cv vk cv cA cexp opreq2 eqeq1d bibi1d imbi2d vj cv vk cv c1 caddc
      co wceq cA vj cv cexp co cc0 wceq cA cc0 wceq wb cA vk cv c1 caddc co
      cexp co cc0 wceq cA cc0 wceq wb cA cc wcel vj cv vk cv c1 caddc co wceq
      cA vj cv cexp co cc0 wceq cA vk cv c1 caddc co cexp co cc0 wceq cA cc0
      wceq vj cv vk cv c1 caddc co wceq cA vj cv cexp co cA vk cv c1 caddc co
      cexp co cc0 vj cv vk cv c1 caddc co cA cexp opreq2 eqeq1d bibi1d imbi2d
      vj cv cN wceq cA vj cv cexp co cc0 wceq cA cc0 wceq wb cA cN cexp co cc0
      wceq cA cc0 wceq wb cA cc wcel vj cv cN wceq cA vj cv cexp co cc0 wceq cA
      cN cexp co cc0 wceq cA cc0 wceq vj cv cN wceq cA vj cv cexp co cA cN cexp
      co cc0 vj cv cN cA cexp opreq2 eqeq1d bibi1d imbi2d cA cc wcel cA c1 cexp
      co cA cc0 cA exp1 eqeq1d vk cv cn wcel cA cc wcel cA vk cv cexp co cc0
      wceq cA cc0 wceq wb cA vk cv c1 caddc co cexp co cc0 wceq cA cc0 wceq wb
      cA cc wcel vk cv cn wcel cA vk cv cexp co cc0 wceq cA cc0 wceq wb cA vk
      cv c1 caddc co cexp co cc0 wceq cA cc0 wceq wb wi cA cc wcel vk cv cn
      wcel cA vk cv cexp co cc0 wceq cA cc0 wceq wb cA vk cv c1 caddc co cexp
      co cc0 wceq cA cc0 wceq wb cA cc wcel vk cv cn wcel wa cA vk cv c1 caddc
      co cexp co cc0 wceq cA vk cv cexp co cc0 wceq cA cc0 wceq wo cA vk cv
      cexp co cc0 wceq cA cc0 wceq wb cA cc0 wceq cA cc wcel vk cv cn0 wcel cA
      vk cv c1 caddc co cexp co cc0 wceq cA vk cv cexp co cc0 wceq cA cc0 wceq
      wo wb vk cv cn wcel cA cc wcel vk cv cn0 wcel wa cA vk cv c1 caddc co
      cexp co cc0 wceq cA vk cv cexp co cA cmul co cc0 wceq cA vk cv cexp co
      cc0 wceq cA cc0 wceq wo cA cc wcel vk cv cn0 wcel wa cA vk cv c1 caddc co
      cexp co cA vk cv cexp co cA cmul co cc0 cA vk cv expp1 eqeq1d cA vk cv
      cexp co cc wcel cA cc wcel cA vk cv cexp co cA cmul co cc0 wceq cA vk cv
      cexp co cc0 wceq cA cc0 wceq wo wb cA cc wcel vk cv cn0 wcel wa cA vk cv
      cexp co cA mul0or cA vk cv expcl cA cc wcel vk cv cn0 wcel pm3.26 sylanc
      bitrd vk cv nnnn0 sylan2 cA vk cv cexp co cc0 wceq cA cc0 wceq wb cA vk
      cv cexp co cc0 wceq cA cc0 wceq wo cA cc0 wceq cA vk cv cexp co cc0 wceq
      cA cc0 wceq wb cA vk cv cexp co cc0 wceq cA cc0 wceq cA cc0 wceq cA vk cv
      cexp co cc0 wceq cA cc0 wceq bi1 cA vk cv cexp co cc0 wceq cA cc0 wceq wb
      cA cc0 wceq idd jaod cA cc0 wceq cA vk cv cexp co cc0 wceq olc impbid1
      sylan9bb exp31 com12 a2d nnind impcom $.
      $( [27-Jul-2006] $) $( [23-Feb-2005] $)

    $( Natural number exponentiation is nonzero iff its mantissa is nonzero. $)
    expne0 $p |- ( ( A e. CC /\ N e. NN ) ->
                  ( ( A ^ N ) =/= 0 <-> A =/= 0 ) ) $=
      cA cc wcel cN cn wcel wa cA cN cexp co cc0 cA cc0 cA cN expeq0 necon3bid
      $.
      $( [10-Jul-2008] $) $( [6-May-2005] $)

    $( Nonnegative integer exponentiation is nonzero if its mantissa is
       nonzero. $)
    expne0i $p |- ( ( A e. CC /\ A =/= 0 /\ N e. NN0 )
                -> ( A ^ N ) =/= 0 ) $=
      cA cc wcel cA cc0 wne cN cn0 wcel cA cN cexp co cc0 wne cA cc wcel cA cc0
      wne wa cN cn wcel cN cc0 wceq wo cA cN cexp co cc0 wne cN cn0 wcel cA cc
      wcel cA cc0 wne wa cN cn wcel cA cN cexp co cc0 wne cN cc0 wceq cA cc
      wcel cN cn wcel cA cc0 wne cA cN cexp co cc0 wne cA cc wcel cN cn wcel wa
      cA cN cexp co cc0 wne cA cc0 wne cA cN expne0 biimpar an1rs cA cc wcel cN
      cc0 wceq cA cN cexp co cc0 wne cA cc0 wne cA cc wcel cN cc0 wceq wa cA cN
      cexp co cc0 wne c1 cc0 wne ax1ne0 cA cc wcel cN cc0 wceq wa cA cN cexp co
      c1 cc0 cN cc0 wceq cA cc wcel cA cN cexp co cA cc0 cexp co c1 cN cc0 cA
      cexp opreq2 cA exp0 sylan9eqr neeq1d mpbiri adantlr jaodan cN elnn0
      sylan2b 3impa $.
      $( [1-Jan-2009] $) $( [2-Aug-2006] $)

    $( Nonnegative integer exponentiation with a positive mantissa is
       positive. $)
    expgt0 $p |- ( ( A e. RR /\ N e. NN0 /\ 0 < A ) -> 0 < ( A ^ N ) ) $=
      cA cr wcel cN cn0 wcel cc0 cA clt wbr cc0 cA cN cexp co clt wbr cN cn0
      wcel cA cr wcel cc0 cA clt wbr cc0 cA cN cexp co clt wbr wi cN cn0 wcel
      cA cr wcel cc0 cA clt wbr cc0 cA cN cexp co clt wbr cA cr wcel cc0 cA clt
      wbr wa cc0 cA vj cv cexp co clt wbr wi cA cr wcel cc0 cA clt wbr wa cc0
      cA cc0 cexp co clt wbr wi cA cr wcel cc0 cA clt wbr wa cc0 cA vk cv cexp
      co clt wbr wi cA cr wcel cc0 cA clt wbr wa cc0 cA vk cv c1 caddc co cexp
      co clt wbr wi cA cr wcel cc0 cA clt wbr wa cc0 cA cN cexp co clt wbr wi
      vj vk cN vj cv cc0 wceq cc0 cA vj cv cexp co clt wbr cc0 cA cc0 cexp co
      clt wbr cA cr wcel cc0 cA clt wbr wa vj cv cc0 wceq cA vj cv cexp co cA
      cc0 cexp co cc0 clt vj cv cc0 cA cexp opreq2 breq2d imbi2d vj cv vk cv
      wceq cc0 cA vj cv cexp co clt wbr cc0 cA vk cv cexp co clt wbr cA cr wcel
      cc0 cA clt wbr wa vj cv vk cv wceq cA vj cv cexp co cA vk cv cexp co cc0
      clt vj cv vk cv cA cexp opreq2 breq2d imbi2d vj cv vk cv c1 caddc co wceq
      cc0 cA vj cv cexp co clt wbr cc0 cA vk cv c1 caddc co cexp co clt wbr cA
      cr wcel cc0 cA clt wbr wa vj cv vk cv c1 caddc co wceq cA vj cv cexp co
      cA vk cv c1 caddc co cexp co cc0 clt vj cv vk cv c1 caddc co cA cexp
      opreq2 breq2d imbi2d vj cv cN wceq cc0 cA vj cv cexp co clt wbr cc0 cA cN
      cexp co clt wbr cA cr wcel cc0 cA clt wbr wa vj cv cN wceq cA vj cv cexp
      co cA cN cexp co cc0 clt vj cv cN cA cexp opreq2 breq2d imbi2d cA cr wcel
      cc0 cA cc0 cexp co clt wbr cc0 cA clt wbr cA cr wcel c1 cA cc0 cexp co
      cc0 clt cA cr wcel cA cc wcel cA cc0 cexp co c1 wceq cA recn cA exp0 syl
      lt01 syl5breqr adantr vk cv cn0 wcel cA cr wcel cc0 cA clt wbr wa cc0 cA
      vk cv cexp co clt wbr cc0 cA vk cv c1 caddc co cexp co clt wbr vk cv cn0
      wcel cA cr wcel cc0 cA clt wbr cc0 cA vk cv cexp co clt wbr cc0 cA vk cv
      c1 caddc co cexp co clt wbr wi vk cv cn0 wcel cA cr wcel cc0 cA vk cv
      cexp co clt wbr cc0 cA clt wbr cc0 cA vk cv c1 caddc co cexp co clt wbr
      cA cr wcel vk cv cn0 wcel cc0 cA vk cv cexp co clt wbr cc0 cA clt wbr cc0
      cA vk cv c1 caddc co cexp co clt wbr wi wi cA cr wcel vk cv cn0 wcel cc0
      cA vk cv cexp co clt wbr cc0 cA clt wbr cc0 cA vk cv c1 caddc co cexp co
      clt wbr cA cr wcel vk cv cn0 wcel wa cc0 cA vk cv cexp co clt wbr cc0 cA
      clt wbr wa cc0 cA vk cv cexp co cA cmul co clt wbr cc0 cA vk cv c1 caddc
      co cexp co clt wbr cA vk cv cexp co cr wcel cA cr wcel cc0 cA vk cv cexp
      co clt wbr cc0 cA clt wbr wa cc0 cA vk cv cexp co cA cmul co clt wbr wi
      cA cr wcel vk cv cn0 wcel wa cA vk cv cexp co cA axmulgt0 cA vk cv
      reexpcl cA cr wcel vk cv cn0 wcel pm3.26 sylanc cA cr wcel vk cv cn0 wcel
      wa cA vk cv c1 caddc co cexp co cA vk cv cexp co cA cmul co cc0 clt cA cc
      wcel vk cv cn0 wcel cA vk cv c1 caddc co cexp co cA vk cv cexp co cA cmul
      co wceq cA cr wcel cA vk cv expp1 cA recn sylan breq2d sylibrd exp4b
      com12 com34 imp3a a2d nn0ind exp3a com12 3imp $.
      $( [7-Apr-2006] $) $( [16-Dec-2005] $)
  $}

  $( Value of zero raised to a natural number power. $)
  0exp $p |- ( N e. NN -> ( 0 ^ N ) = 0 ) $=
    cN cn wcel cc0 cN cexp co cc0 wceq cc0 cc0 wceq cc0 eqid cc0 cc wcel cN cn
    wcel cc0 cN cexp co cc0 wceq cc0 cc0 wceq wb 0cn cc0 cN expeq0 mpan mpbiri
    $.
    $( [30-Oct-2004] $) $( [19-Aug-2004] $)

  $( Nonnegative integer exponentiation with a nonnegative mantissa is
     nonnegative. $)
  expge0 $p |- ( ( A e. RR /\ N e. NN0 /\ 0 <_ A ) -> 0 <_ ( A ^ N ) ) $=
    cA cr wcel cN cn0 wcel cc0 cA cle wbr cc0 cA cN cexp co cle wbr cA cr wcel
    cN cn wcel cN cc0 wceq wo cc0 cA cle wbr cc0 cA cN cexp co cle wbr wi cN
    cn0 wcel cA cr wcel cN cn wcel cc0 cA cle wbr cc0 cA cN cexp co cle wbr wi
    cN cc0 wceq cA cr wcel cN cn wcel cc0 cA cle wbr cc0 cA cN cexp co cle wbr
    wi cA cr wcel cN cn wcel wa cc0 cA clt wbr cc0 cA wceq wo cc0 cA cN cexp co
    clt wbr cc0 cA cN cexp co wceq wo cc0 cA cle wbr cc0 cA cN cexp co cle wbr
    cA cr wcel cN cn wcel wa cc0 cA clt wbr cc0 cA cN cexp co clt wbr cc0 cA
    wceq cc0 cA cN cexp co wceq cA cr wcel cN cn wcel cc0 cA clt wbr cc0 cA cN
    cexp co clt wbr cA cr wcel cN cn0 wcel cc0 cA clt wbr cc0 cA cN cexp co clt
    wbr cN cn wcel cA cN expgt0 cN nnnn0 syl3an2 3expia cN cn wcel cc0 cA wceq
    cc0 cA cN cexp co wceq wi cA cr wcel cc0 cA wceq cc0 cc0 cN cexp co wceq
    cc0 cA cN cexp co wceq cN cn wcel cc0 cA wceq cc0 cN cexp co cA cN cexp co
    cc0 cc0 cA cN cexp opreq1 eqeq2d cN cn wcel cc0 cN cexp co cc0 cN 0exp
    eqcomd syl5cbi adantl orim12d cA cr wcel cc0 cA cle wbr cc0 cA clt wbr cc0
    cA wceq wo wb cN cn wcel cc0 cr wcel cA cr wcel cc0 cA cle wbr cc0 cA clt
    wbr cc0 cA wceq wo wb 0re cc0 cA leloe mpan adantr cc0 cr wcel cA cN cexp
    co cr wcel cc0 cA cN cexp co cle wbr cc0 cA cN cexp co clt wbr cc0 cA cN
    cexp co wceq wo wb cA cr wcel cN cn wcel wa cc0 cA cN cexp co leloe 0re cA
    cr wcel cN cn0 wcel cA cN cexp co cr wcel cN cn wcel cA cN reexpcl cN nnnn0
    sylan2 sylancr 3imtr4d ex cA cr wcel cN cc0 wceq cc0 cA cN cexp co cle wbr
    cc0 cA cle wbr cN cc0 wceq cc0 cA cN cexp co cle wbr cc0 cA cc0 cexp co cle
    wbr cA cr wcel cN cc0 wceq cA cN cexp co cA cc0 cexp co cc0 cle cN cc0 cA
    cexp opreq2 breq2d cA cr wcel c1 cA cc0 cexp co cc0 cle cA cr wcel cA cc
    wcel cA cc0 cexp co c1 wceq cA recn cA exp0 syl cc0 c1 0re 1re lt01 ltleii
    syl5breqr syl5cbir a1dd jaod cN elnn0 syl5ib 3imp $.
    $( [28-Jul-2006] $) $( [16-Dec-2005] $)

  ${
    $d x y A $.  $d x N $.
    $( Natural number exponentiation with a mantissa greater than 1 is
       greater than 1. $)
    expgt1 $p |- ( ( A e. RR /\ N e. NN /\ 1 < A ) -> 1 < ( A ^ N ) ) $=
      cA cr wcel cN cn wcel c1 cA clt wbr c1 cA cN cexp co clt wbr cN cn wcel
      cA cr wcel c1 cA clt wbr c1 cA cN cexp co clt wbr wi cN cn wcel cA cr
      wcel c1 cA clt wbr c1 cA cN cexp co clt wbr cA cr wcel c1 cA clt wbr wa
      c1 cA vx cv cexp co clt wbr wi cA cr wcel c1 cA clt wbr wa c1 cA c1 cexp
      co clt wbr wi cA cr wcel c1 cA clt wbr wa c1 cA vy cv cexp co clt wbr wi
      cA cr wcel c1 cA clt wbr wa c1 cA vy cv c1 caddc co cexp co clt wbr wi cA
      cr wcel c1 cA clt wbr wa c1 cA cN cexp co clt wbr wi vx vy cN vx cv c1
      wceq c1 cA vx cv cexp co clt wbr c1 cA c1 cexp co clt wbr cA cr wcel c1
      cA clt wbr wa vx cv c1 wceq cA vx cv cexp co cA c1 cexp co c1 clt vx cv
      c1 cA cexp opreq2 breq2d imbi2d vx cv vy cv wceq c1 cA vx cv cexp co clt
      wbr c1 cA vy cv cexp co clt wbr cA cr wcel c1 cA clt wbr wa vx cv vy cv
      wceq cA vx cv cexp co cA vy cv cexp co c1 clt vx cv vy cv cA cexp opreq2
      breq2d imbi2d vx cv vy cv c1 caddc co wceq c1 cA vx cv cexp co clt wbr c1
      cA vy cv c1 caddc co cexp co clt wbr cA cr wcel c1 cA clt wbr wa vx cv vy
      cv c1 caddc co wceq cA vx cv cexp co cA vy cv c1 caddc co cexp co c1 clt
      vx cv vy cv c1 caddc co cA cexp opreq2 breq2d imbi2d vx cv cN wceq c1 cA
      vx cv cexp co clt wbr c1 cA cN cexp co clt wbr cA cr wcel c1 cA clt wbr
      wa vx cv cN wceq cA vx cv cexp co cA cN cexp co c1 clt vx cv cN cA cexp
      opreq2 breq2d imbi2d cA cr wcel c1 cA c1 cexp co clt wbr c1 cA clt wbr cA
      cr wcel cA c1 cexp co cA c1 clt cA cr wcel cA cc wcel cA c1 cexp co cA
      wceq cA recn cA exp1 syl breq2d biimpar vy cv cn wcel cA cr wcel c1 cA
      clt wbr wa c1 cA vy cv cexp co clt wbr c1 cA vy cv c1 caddc co cexp co
      clt wbr vy cv cn wcel cA cr wcel c1 cA clt wbr c1 cA vy cv cexp co clt
      wbr c1 cA vy cv c1 caddc co cexp co clt wbr wi vy cv cn wcel cA cr wcel
      c1 cA vy cv cexp co clt wbr c1 cA clt wbr c1 cA vy cv c1 caddc co cexp co
      clt wbr cA cr wcel vy cv cn wcel c1 cA vy cv cexp co clt wbr c1 cA clt
      wbr c1 cA vy cv c1 caddc co cexp co clt wbr wi wi cA cr wcel vy cv cn
      wcel c1 cA vy cv cexp co clt wbr c1 cA clt wbr c1 cA vy cv c1 caddc co
      cexp co clt wbr cA cr wcel vy cv cn0 wcel c1 cA vy cv cexp co clt wbr c1
      cA clt wbr wa c1 cA vy cv c1 caddc co cexp co clt wbr wi vy cv cn wcel cA
      cr wcel vy cv cn0 wcel wa c1 cA vy cv cexp co clt wbr c1 cA clt wbr wa c1
      cA vy cv cexp co cA cmul co clt wbr c1 cA vy cv c1 caddc co cexp co clt
      wbr cA cr wcel vy cv cn0 wcel wa c1 cA vy cv cexp co clt wbr c1 cA clt
      wbr wa c1 cA vy cv cexp co cA cmul co clt wbr cA vy cv cexp co cr wcel cA
      cr wcel wa c1 cA vy cv cexp co clt wbr c1 cA clt wbr wa c1 cA vy cv cexp
      co cA cmul co clt wbr cA cr wcel vy cv cn0 wcel wa cA vy cv cexp co cA
      mulgt1 cA cr wcel vy cv cn0 wcel wa cA vy cv cexp co cr wcel cA cr wcel
      cA vy cv reexpcl cA cr wcel vy cv cn0 wcel pm3.26 jca sylan ex cA cr wcel
      vy cv cn0 wcel wa cA vy cv c1 caddc co cexp co cA vy cv cexp co cA cmul
      co c1 clt cA cc wcel vy cv cn0 wcel cA vy cv c1 caddc co cexp co cA vy cv
      cexp co cA cmul co wceq cA cr wcel cA vy cv expp1 cA recn sylan breq2d
      sylibrd vy cv nnnn0 sylan2 exp4b com12 com34 imp3a a2d nnind exp3a com12
      3imp $.
      $( [27-Jul-2006] $) $( [13-Feb-2005] $)
  $}

  $( Nonnegative integer exponentiation with a mantissa greater than or equal
     to 1 is greater than or equal to 1. $)
  expge1 $p |- ( ( A e. RR /\ N e. NN0 /\ 1 <_ A ) -> 1 <_ ( A ^ N ) ) $=
    cA cr wcel cN cn0 wcel c1 cA cle wbr c1 cA cN cexp co cle wbr cA cr wcel cN
    cn wcel cN cc0 wceq wo c1 cA cle wbr c1 cA cN cexp co cle wbr wi cN cn0
    wcel cA cr wcel cN cn wcel c1 cA cle wbr c1 cA cN cexp co cle wbr wi cN cc0
    wceq cA cr wcel cN cn wcel wa c1 cA clt wbr c1 cA wceq wo c1 cA cN cexp co
    clt wbr c1 cA cN cexp co wceq wo c1 cA cle wbr c1 cA cN cexp co cle wbr cA
    cr wcel cN cn wcel wa c1 cA clt wbr c1 cA cN cexp co clt wbr c1 cA wceq c1
    cA cN cexp co wceq cA cr wcel cN cn wcel c1 cA clt wbr c1 cA cN cexp co clt
    wbr cA cN expgt1 3expia cN cn wcel c1 cA wceq c1 cA cN cexp co wceq wi cA
    cr wcel c1 cA wceq c1 c1 cN cexp co wceq c1 cA cN cexp co wceq cN cn wcel
    c1 cA wceq c1 cN cexp co cA cN cexp co c1 c1 cA cN cexp opreq1 eqeq2d cN cn
    wcel c1 cN cexp co c1 cN cn wcel cN cn0 wcel c1 cN cexp co c1 wceq cN nnnn0
    cN 1exp syl eqcomd syl5cbi adantl orim12d cA cr wcel c1 cA cle wbr c1 cA
    clt wbr c1 cA wceq wo wb cN cn wcel c1 cr wcel cA cr wcel c1 cA cle wbr c1
    cA clt wbr c1 cA wceq wo wb 1re c1 cA leloe mpan adantr c1 cr wcel cA cN
    cexp co cr wcel c1 cA cN cexp co cle wbr c1 cA cN cexp co clt wbr c1 cA cN
    cexp co wceq wo wb cA cr wcel cN cn wcel wa c1 cA cN cexp co leloe 1re cA
    cr wcel cN cn0 wcel cA cN cexp co cr wcel cN cn wcel cA cN reexpcl cN nnnn0
    sylan2 sylancr 3imtr4d cA cr wcel cN cc0 wceq wa c1 cA cN cexp co cle wbr
    c1 cA cle wbr cA cr wcel cN cc0 wceq wa c1 cA cN cexp co c1 cle cN cc0 wceq
    cA cr wcel cA cN cexp co cA cc0 cexp co c1 cN cc0 cA cexp opreq2 cA cr wcel
    cA cc wcel cA cc0 cexp co c1 wceq cA recn cA exp0 syl sylan9eqr c1 1re
    leidi syl5breqr a1d jaodan cN elnn0 sylan2b 3impia $.
    $( [16-Oct-2007] $) $( [21-Feb-2005] $)

  ${
    $d j k A $.  $d j k B $.  $d j k M $.  $d j N $.
    $( Natural number exponentiation of a product.  Proposition 10-4.2(c) of
       [Gleason] p. 135, restricted to nonnegative integer exponents. $)
    mulexp $p |- ( ( A e. CC /\ B e. CC /\ N e. NN0 ) ->
                  ( ( A x. B ) ^ N ) = ( ( A ^ N ) x. ( B ^ N ) ) ) $=
      cA cc wcel cB cc wcel cN cn0 wcel cA cB cmul co cN cexp co cA cN cexp co
      cB cN cexp co cmul co wceq cN cn0 wcel cA cc wcel cB cc wcel cA cB cmul
      co cN cexp co cA cN cexp co cB cN cexp co cmul co wceq cN cn0 wcel cA cc
      wcel cB cc wcel cA cB cmul co cN cexp co cA cN cexp co cB cN cexp co cmul
      co wceq cA cc wcel cB cc wcel wa cA cB cmul co vj cv cexp co cA vj cv
      cexp co cB vj cv cexp co cmul co wceq wi cA cc wcel cB cc wcel wa cA cB
      cmul co cc0 cexp co cA cc0 cexp co cB cc0 cexp co cmul co wceq wi cA cc
      wcel cB cc wcel wa cA cB cmul co vk cv cexp co cA vk cv cexp co cB vk cv
      cexp co cmul co wceq wi cA cc wcel cB cc wcel wa cA cB cmul co vk cv c1
      caddc co cexp co cA vk cv c1 caddc co cexp co cB vk cv c1 caddc co cexp
      co cmul co wceq wi cA cc wcel cB cc wcel wa cA cB cmul co cN cexp co cA
      cN cexp co cB cN cexp co cmul co wceq wi vj vk cN vj cv cc0 wceq cA cB
      cmul co vj cv cexp co cA vj cv cexp co cB vj cv cexp co cmul co wceq cA
      cB cmul co cc0 cexp co cA cc0 cexp co cB cc0 cexp co cmul co wceq cA cc
      wcel cB cc wcel wa vj cv cc0 wceq cA cB cmul co vj cv cexp co cA cB cmul
      co cc0 cexp co cA vj cv cexp co cB vj cv cexp co cmul co cA cc0 cexp co
      cB cc0 cexp co cmul co vj cv cc0 cA cB cmul co cexp opreq2 vj cv cc0 wceq
      cA vj cv cexp co cA cc0 cexp co cB vj cv cexp co cB cc0 cexp co cmul vj
      cv cc0 cA cexp opreq2 vj cv cc0 cB cexp opreq2 opreq12d eqeq12d imbi2d vj
      cv vk cv wceq cA cB cmul co vj cv cexp co cA vj cv cexp co cB vj cv cexp
      co cmul co wceq cA cB cmul co vk cv cexp co cA vk cv cexp co cB vk cv
      cexp co cmul co wceq cA cc wcel cB cc wcel wa vj cv vk cv wceq cA cB cmul
      co vj cv cexp co cA cB cmul co vk cv cexp co cA vj cv cexp co cB vj cv
      cexp co cmul co cA vk cv cexp co cB vk cv cexp co cmul co vj cv vk cv cA
      cB cmul co cexp opreq2 vj cv vk cv wceq cA vj cv cexp co cA vk cv cexp co
      cB vj cv cexp co cB vk cv cexp co cmul vj cv vk cv cA cexp opreq2 vj cv
      vk cv cB cexp opreq2 opreq12d eqeq12d imbi2d vj cv vk cv c1 caddc co wceq
      cA cB cmul co vj cv cexp co cA vj cv cexp co cB vj cv cexp co cmul co
      wceq cA cB cmul co vk cv c1 caddc co cexp co cA vk cv c1 caddc co cexp co
      cB vk cv c1 caddc co cexp co cmul co wceq cA cc wcel cB cc wcel wa vj cv
      vk cv c1 caddc co wceq cA cB cmul co vj cv cexp co cA cB cmul co vk cv c1
      caddc co cexp co cA vj cv cexp co cB vj cv cexp co cmul co cA vk cv c1
      caddc co cexp co cB vk cv c1 caddc co cexp co cmul co vj cv vk cv c1
      caddc co cA cB cmul co cexp opreq2 vj cv vk cv c1 caddc co wceq cA vj cv
      cexp co cA vk cv c1 caddc co cexp co cB vj cv cexp co cB vk cv c1 caddc
      co cexp co cmul vj cv vk cv c1 caddc co cA cexp opreq2 vj cv vk cv c1
      caddc co cB cexp opreq2 opreq12d eqeq12d imbi2d vj cv cN wceq cA cB cmul
      co vj cv cexp co cA vj cv cexp co cB vj cv cexp co cmul co wceq cA cB
      cmul co cN cexp co cA cN cexp co cB cN cexp co cmul co wceq cA cc wcel cB
      cc wcel wa vj cv cN wceq cA cB cmul co vj cv cexp co cA cB cmul co cN
      cexp co cA vj cv cexp co cB vj cv cexp co cmul co cA cN cexp co cB cN
      cexp co cmul co vj cv cN cA cB cmul co cexp opreq2 vj cv cN wceq cA vj cv
      cexp co cA cN cexp co cB vj cv cexp co cB cN cexp co cmul vj cv cN cA
      cexp opreq2 vj cv cN cB cexp opreq2 opreq12d eqeq12d imbi2d cA cc wcel cB
      cc wcel wa cA cB cmul co cc0 cexp co c1 cA cc0 cexp co cB cc0 cexp co
      cmul co cA cc wcel cB cc wcel wa cA cB cmul co cc wcel cA cB cmul co cc0
      cexp co c1 wceq cA cB mulcl cA cB cmul co exp0 syl cA cc wcel cB cc wcel
      wa cA cc0 cexp co cB cc0 cexp co cmul co c1 c1 cmul co c1 cA cc wcel cB
      cc wcel cA cc0 cexp co c1 cB cc0 cexp co c1 cmul cA exp0 cB exp0
      opreqan12d c1 ax1cn mulid1i syl6eq eqtr4d vk cv cn0 wcel cA cc wcel cB cc
      wcel wa cA cB cmul co vk cv cexp co cA vk cv cexp co cB vk cv cexp co
      cmul co wceq cA cB cmul co vk cv c1 caddc co cexp co cA vk cv c1 caddc co
      cexp co cB vk cv c1 caddc co cexp co cmul co wceq cA cc wcel cB cc wcel
      wa vk cv cn0 wcel cA cB cmul co vk cv cexp co cA vk cv cexp co cB vk cv
      cexp co cmul co wceq cA cB cmul co vk cv c1 caddc co cexp co cA vk cv c1
      caddc co cexp co cB vk cv c1 caddc co cexp co cmul co wceq wi cA cc wcel
      cB cc wcel wa vk cv cn0 wcel cA cB cmul co vk cv cexp co cA vk cv cexp co
      cB vk cv cexp co cmul co wceq cA cB cmul co vk cv c1 caddc co cexp co cA
      vk cv c1 caddc co cexp co cB vk cv c1 caddc co cexp co cmul co wceq cA cc
      wcel cB cc wcel wa vk cv cn0 wcel wa cA cB cmul co vk cv cexp co cA vk cv
      cexp co cB vk cv cexp co cmul co wceq wa cA cB cmul co vk cv c1 caddc co
      cexp co cA cB cmul co vk cv cexp co cA cB cmul co cmul co cA vk cv cexp
      co cB vk cv cexp co cmul co cA cB cmul co cmul co cA vk cv c1 caddc co
      cexp co cB vk cv c1 caddc co cexp co cmul co cA cc wcel cB cc wcel wa vk
      cv cn0 wcel wa cA cB cmul co vk cv c1 caddc co cexp co cA cB cmul co vk
      cv cexp co cA cB cmul co cmul co wceq cA cB cmul co vk cv cexp co cA vk
      cv cexp co cB vk cv cexp co cmul co wceq cA cB cmul co cc wcel vk cv cn0
      wcel cA cB cmul co vk cv c1 caddc co cexp co cA cB cmul co vk cv cexp co
      cA cB cmul co cmul co wceq cA cc wcel cB cc wcel wa cA cB cmul co vk cv
      expp1 cA cB mulcl sylan adantr cA cB cmul co vk cv cexp co cA vk cv cexp
      co cB vk cv cexp co cmul co wceq cA cB cmul co vk cv cexp co cA cB cmul
      co cmul co cA vk cv cexp co cB vk cv cexp co cmul co cA cB cmul co cmul
      co wceq cA cc wcel cB cc wcel wa vk cv cn0 wcel wa cA cB cmul co vk cv
      cexp co cA vk cv cexp co cB vk cv cexp co cmul co cA cB cmul co cmul
      opreq1 adantl cA cc wcel cB cc wcel wa vk cv cn0 wcel wa cA vk cv cexp co
      cB vk cv cexp co cmul co cA cB cmul co cmul co cA vk cv c1 caddc co cexp
      co cB vk cv c1 caddc co cexp co cmul co wceq cA cB cmul co vk cv cexp co
      cA vk cv cexp co cB vk cv cexp co cmul co wceq cA cc wcel cB cc wcel wa
      vk cv cn0 wcel wa cA vk cv cexp co cB vk cv cexp co cmul co cA cB cmul co
      cmul co cA vk cv cexp co cA cmul co cB vk cv cexp co cB cmul co cmul co
      cA vk cv c1 caddc co cexp co cB vk cv c1 caddc co cexp co cmul co cA vk
      cv cexp co cc wcel cB vk cv cexp co cc wcel wa cA cc wcel cB cc wcel wa
      cA vk cv cexp co cB vk cv cexp co cmul co cA cB cmul co cmul co cA vk cv
      cexp co cA cmul co cB vk cv cexp co cB cmul co cmul co wceq cA cc wcel cB
      cc wcel wa vk cv cn0 wcel wa cA vk cv cexp co cB vk cv cexp co cA cB mul4
      cA cc wcel cB cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel cB vk cv
      cexp co cc wcel wa cA cc wcel vk cv cn0 wcel wa cA vk cv cexp co cc wcel
      cB cc wcel vk cv cn0 wcel wa cB vk cv cexp co cc wcel cA vk cv expcl cB
      vk cv expcl anim12i anandirs cA cc wcel cB cc wcel wa vk cv cn0 wcel
      pm3.26 sylanc cA cc wcel cB cc wcel wa vk cv cn0 wcel wa cA vk cv c1
      caddc co cexp co cA vk cv cexp co cA cmul co cB vk cv c1 caddc co cexp co
      cB vk cv cexp co cB cmul co cmul cA cc wcel vk cv cn0 wcel cA vk cv c1
      caddc co cexp co cA vk cv cexp co cA cmul co wceq cB cc wcel cA vk cv
      expp1 adantlr cB cc wcel vk cv cn0 wcel cB vk cv c1 caddc co cexp co cB
      vk cv cexp co cB cmul co wceq cA cc wcel cB vk cv expp1 adantll opreq12d
      eqtr4d adantr 3eqtrd exp31 com12 a2d nn0ind exp3a com3l 3imp $.
      $( [16-Feb-2005] $) $( [13-Feb-2005] $)

    $( Nonnegative integer exponentiation of a reciprocal. $)
    exprec $p |- ( ( A e. CC /\ A =/= 0 /\ N e. NN0 ) ->
                  ( ( 1 / A ) ^ N ) = ( 1 / ( A ^ N ) ) ) $=
      cA cc wcel cA cc0 wne cN cn0 wcel c1 cA cdiv co cN cexp co c1 cA cN cexp
      co cdiv co wceq cN cn0 wcel cA cc wcel cA cc0 wne wa c1 cA cdiv co cN
      cexp co c1 cA cN cexp co cdiv co wceq cA cc wcel cA cc0 wne wa c1 cA cdiv
      co vj cv cexp co c1 cA vj cv cexp co cdiv co wceq wi cA cc wcel cA cc0
      wne wa c1 cA cdiv co cc0 cexp co c1 cA cc0 cexp co cdiv co wceq wi cA cc
      wcel cA cc0 wne wa c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv
      co wceq wi cA cc wcel cA cc0 wne wa c1 cA cdiv co vk cv c1 caddc co cexp
      co c1 cA vk cv c1 caddc co cexp co cdiv co wceq wi cA cc wcel cA cc0 wne
      wa c1 cA cdiv co cN cexp co c1 cA cN cexp co cdiv co wceq wi vj vk cN vj
      cv cc0 wceq c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp co cdiv co wceq
      c1 cA cdiv co cc0 cexp co c1 cA cc0 cexp co cdiv co wceq cA cc wcel cA
      cc0 wne wa vj cv cc0 wceq c1 cA cdiv co vj cv cexp co c1 cA cdiv co cc0
      cexp co c1 cA vj cv cexp co cdiv co c1 cA cc0 cexp co cdiv co vj cv cc0
      c1 cA cdiv co cexp opreq2 vj cv cc0 wceq cA vj cv cexp co cA cc0 cexp co
      c1 cdiv vj cv cc0 cA cexp opreq2 opreq2d eqeq12d imbi2d vj cv vk cv wceq
      c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp co cdiv co wceq c1 cA cdiv
      co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq cA cc wcel cA cc0 wne
      wa vj cv vk cv wceq c1 cA cdiv co vj cv cexp co c1 cA cdiv co vk cv cexp
      co c1 cA vj cv cexp co cdiv co c1 cA vk cv cexp co cdiv co vj cv vk cv c1
      cA cdiv co cexp opreq2 vj cv vk cv wceq cA vj cv cexp co cA vk cv cexp co
      c1 cdiv vj cv vk cv cA cexp opreq2 opreq2d eqeq12d imbi2d vj cv vk cv c1
      caddc co wceq c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp co cdiv co
      wceq c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA vk cv c1 caddc co cexp
      co cdiv co wceq cA cc wcel cA cc0 wne wa vj cv vk cv c1 caddc co wceq c1
      cA cdiv co vj cv cexp co c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA vj
      cv cexp co cdiv co c1 cA vk cv c1 caddc co cexp co cdiv co vj cv vk cv c1
      caddc co c1 cA cdiv co cexp opreq2 vj cv vk cv c1 caddc co wceq cA vj cv
      cexp co cA vk cv c1 caddc co cexp co c1 cdiv vj cv vk cv c1 caddc co cA
      cexp opreq2 opreq2d eqeq12d imbi2d vj cv cN wceq c1 cA cdiv co vj cv cexp
      co c1 cA vj cv cexp co cdiv co wceq c1 cA cdiv co cN cexp co c1 cA cN
      cexp co cdiv co wceq cA cc wcel cA cc0 wne wa vj cv cN wceq c1 cA cdiv co
      vj cv cexp co c1 cA cdiv co cN cexp co c1 cA vj cv cexp co cdiv co c1 cA
      cN cexp co cdiv co vj cv cN c1 cA cdiv co cexp opreq2 vj cv cN wceq cA vj
      cv cexp co cA cN cexp co c1 cdiv vj cv cN cA cexp opreq2 opreq2d eqeq12d
      imbi2d cA cc wcel cA cc0 wne wa c1 cA cdiv co cc0 cexp co c1 c1 cA cc0
      cexp co cdiv co cA cc wcel cA cc0 wne wa c1 cA cdiv co cc wcel c1 cA cdiv
      co cc0 cexp co c1 wceq cA reccl c1 cA cdiv co exp0 syl cA cc wcel c1 cA
      cc0 cexp co cdiv co c1 wceq cA cc0 wne cA cc wcel c1 cA cc0 cexp co cdiv
      co c1 c1 cdiv co c1 cA cc wcel cA cc0 cexp co c1 c1 cdiv cA exp0 opreq2d
      c1 ax1cn div1i syl6eq adantr eqtr4d vk cv cn0 wcel cA cc wcel cA cc0 wne
      wa c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq c1 cA
      cdiv co vk cv c1 caddc co cexp co c1 cA vk cv c1 caddc co cexp co cdiv co
      wceq vk cv cn0 wcel cA cc wcel cA cc0 wne c1 cA cdiv co vk cv cexp co c1
      cA vk cv cexp co cdiv co wceq c1 cA cdiv co vk cv c1 caddc co cexp co c1
      cA vk cv c1 caddc co cexp co cdiv co wceq wi cA cc wcel vk cv cn0 wcel cA
      cc0 wne c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq c1
      cA cdiv co vk cv c1 caddc co cexp co c1 cA vk cv c1 caddc co cexp co cdiv
      co wceq wi wi cA cc wcel vk cv cn0 wcel cA cc0 wne c1 cA cdiv co vk cv
      cexp co c1 cA vk cv cexp co cdiv co wceq c1 cA cdiv co vk cv c1 caddc co
      cexp co c1 cA vk cv c1 caddc co cexp co cdiv co wceq cA cc wcel vk cv cn0
      wcel wa cA cc0 wne c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv
      co wceq wa wa c1 cA cdiv co vk cv cexp co c1 cA cdiv co cmul co c1 cA vk
      cv cexp co cdiv co c1 cA cdiv co cmul co c1 cA cdiv co vk cv c1 caddc co
      cexp co c1 cA vk cv c1 caddc co cexp co cdiv co c1 cA cdiv co vk cv cexp
      co c1 cA vk cv cexp co cdiv co wceq c1 cA cdiv co vk cv cexp co c1 cA
      cdiv co cmul co c1 cA vk cv cexp co cdiv co c1 cA cdiv co cmul co wceq cA
      cc wcel vk cv cn0 wcel wa cA cc0 wne c1 cA cdiv co vk cv cexp co c1 cA vk
      cv cexp co cdiv co c1 cA cdiv co cmul opreq1 ad2antll cA cc wcel vk cv
      cn0 wcel wa cA cc0 wne c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA cdiv
      co vk cv cexp co c1 cA cdiv co cmul co wceq c1 cA cdiv co vk cv cexp co
      c1 cA vk cv cexp co cdiv co wceq cA cc wcel cA cc0 wne vk cv cn0 wcel c1
      cA cdiv co vk cv c1 caddc co cexp co c1 cA cdiv co vk cv cexp co c1 cA
      cdiv co cmul co wceq c1 cA cdiv co cc wcel vk cv cn0 wcel c1 cA cdiv co
      vk cv c1 caddc co cexp co c1 cA cdiv co vk cv cexp co c1 cA cdiv co cmul
      co wceq cA cc wcel cA cc0 wne wa c1 cA cdiv co vk cv expp1 cA reccl sylan
      an1rs adantrr cA cc wcel vk cv cn0 wcel wa cA cc0 wne c1 cA vk cv c1
      caddc co cexp co cdiv co c1 cA vk cv cexp co cdiv co c1 cA cdiv co cmul
      co wceq c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq cA
      cc wcel vk cv cn0 wcel wa cA cc0 wne wa c1 cA vk cv c1 caddc co cexp co
      cdiv co c1 cA vk cv cexp co cA cmul co cdiv co c1 cA vk cv cexp co cdiv
      co c1 cA cdiv co cmul co cA cc wcel vk cv cn0 wcel wa c1 cA vk cv c1
      caddc co cexp co cdiv co c1 cA vk cv cexp co cA cmul co cdiv co wceq cA
      cc0 wne cA cc wcel vk cv cn0 wcel wa cA vk cv c1 caddc co cexp co cA vk
      cv cexp co cA cmul co c1 cdiv cA vk cv expp1 opreq2d adantr cA cc wcel vk
      cv cn0 wcel wa cA cc0 wne wa c1 cA vk cv cexp co cdiv co c1 cA cdiv co
      cmul co c1 c1 cmul co cA vk cv cexp co cA cmul co cdiv co c1 cA vk cv
      cexp co cA cmul co cdiv co cA vk cv cexp co cc wcel cA vk cv cexp co cc0
      wne wa cA cc wcel cA cc0 wne wa c1 cA vk cv cexp co cdiv co c1 cA cdiv co
      cmul co c1 c1 cmul co cA vk cv cexp co cA cmul co cdiv co wceq cA cc wcel
      vk cv cn0 wcel wa cA cc0 wne wa c1 cc wcel c1 cc wcel cA vk cv cexp co cc
      wcel cA vk cv cexp co cc0 wne wa cA cc wcel cA cc0 wne wa wa c1 cA vk cv
      cexp co cdiv co c1 cA cdiv co cmul co c1 c1 cmul co cA vk cv cexp co cA
      cmul co cdiv co wceq ax1cn ax1cn c1 c1 cA vk cv cexp co cA divmuldiv
      mpanl12 cA cc wcel vk cv cn0 wcel wa cA cc0 wne wa cA vk cv cexp co cc
      wcel cA vk cv cexp co cc0 wne cA cc wcel vk cv cn0 wcel wa cA vk cv cexp
      co cc wcel cA cc0 wne cA vk cv expcl adantr cA cc wcel vk cv cn0 wcel cA
      cc0 wne cA vk cv cexp co cc0 wne cA cc wcel cA cc0 wne vk cv cn0 wcel cA
      vk cv cexp co cc0 wne cA vk cv expne0i 3com23 3expa jca cA cc wcel cA cc0
      wne cA cc wcel cA cc0 wne wa vk cv cn0 wcel cA cc wcel cA cc0 wne wa id
      adantlr sylanc c1 c1 cmul co c1 cA vk cv cexp co cA cmul co cdiv c1 ax1cn
      mulid1i opreq1i syl6req eqtrd adantrr 3eqtr4d exp43 com12 imp3a a2d
      nn0ind com12 3impia $.
      $( [7-Mar-2009] $) $( [2-Aug-2006] $)

    $( Nonnegative integer exponentiation of a reciprocal. $)
    exprecOLD $p |- ( ( A e. CC /\ N e. NN0 /\ A =/= 0 ) ->
                  ( ( 1 / A ) ^ N ) = ( 1 / ( A ^ N ) ) ) $=
      cA cc wcel cN cn0 wcel cA cc0 wne c1 cA cdiv co cN cexp co c1 cA cN cexp
      co cdiv co wceq cN cn0 wcel cA cc wcel cA cc0 wne c1 cA cdiv co cN cexp
      co c1 cA cN cexp co cdiv co wceq wi cN cn0 wcel cA cc wcel cA cc0 wne c1
      cA cdiv co cN cexp co c1 cA cN cexp co cdiv co wceq cA cc wcel cA cc0 wne
      wa c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp co cdiv co wceq wi cA cc
      wcel cA cc0 wne wa c1 cA cdiv co cc0 cexp co c1 cA cc0 cexp co cdiv co
      wceq wi cA cc wcel cA cc0 wne wa c1 cA cdiv co vk cv cexp co c1 cA vk cv
      cexp co cdiv co wceq wi cA cc wcel cA cc0 wne wa c1 cA cdiv co vk cv c1
      caddc co cexp co c1 cA vk cv c1 caddc co cexp co cdiv co wceq wi cA cc
      wcel cA cc0 wne wa c1 cA cdiv co cN cexp co c1 cA cN cexp co cdiv co wceq
      wi vj vk cN vj cv cc0 wceq c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp
      co cdiv co wceq c1 cA cdiv co cc0 cexp co c1 cA cc0 cexp co cdiv co wceq
      cA cc wcel cA cc0 wne wa vj cv cc0 wceq c1 cA cdiv co vj cv cexp co c1 cA
      cdiv co cc0 cexp co c1 cA vj cv cexp co cdiv co c1 cA cc0 cexp co cdiv co
      vj cv cc0 c1 cA cdiv co cexp opreq2 vj cv cc0 wceq cA vj cv cexp co cA
      cc0 cexp co c1 cdiv vj cv cc0 cA cexp opreq2 opreq2d eqeq12d imbi2d vj cv
      vk cv wceq c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp co cdiv co wceq
      c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq cA cc wcel
      cA cc0 wne wa vj cv vk cv wceq c1 cA cdiv co vj cv cexp co c1 cA cdiv co
      vk cv cexp co c1 cA vj cv cexp co cdiv co c1 cA vk cv cexp co cdiv co vj
      cv vk cv c1 cA cdiv co cexp opreq2 vj cv vk cv wceq cA vj cv cexp co cA
      vk cv cexp co c1 cdiv vj cv vk cv cA cexp opreq2 opreq2d eqeq12d imbi2d
      vj cv vk cv c1 caddc co wceq c1 cA cdiv co vj cv cexp co c1 cA vj cv cexp
      co cdiv co wceq c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA vk cv c1
      caddc co cexp co cdiv co wceq cA cc wcel cA cc0 wne wa vj cv vk cv c1
      caddc co wceq c1 cA cdiv co vj cv cexp co c1 cA cdiv co vk cv c1 caddc co
      cexp co c1 cA vj cv cexp co cdiv co c1 cA vk cv c1 caddc co cexp co cdiv
      co vj cv vk cv c1 caddc co c1 cA cdiv co cexp opreq2 vj cv vk cv c1 caddc
      co wceq cA vj cv cexp co cA vk cv c1 caddc co cexp co c1 cdiv vj cv vk cv
      c1 caddc co cA cexp opreq2 opreq2d eqeq12d imbi2d vj cv cN wceq c1 cA
      cdiv co vj cv cexp co c1 cA vj cv cexp co cdiv co wceq c1 cA cdiv co cN
      cexp co c1 cA cN cexp co cdiv co wceq cA cc wcel cA cc0 wne wa vj cv cN
      wceq c1 cA cdiv co vj cv cexp co c1 cA cdiv co cN cexp co c1 cA vj cv
      cexp co cdiv co c1 cA cN cexp co cdiv co vj cv cN c1 cA cdiv co cexp
      opreq2 vj cv cN wceq cA vj cv cexp co cA cN cexp co c1 cdiv vj cv cN cA
      cexp opreq2 opreq2d eqeq12d imbi2d cA cc wcel cA cc0 wne wa c1 cA cdiv co
      cc0 cexp co c1 c1 cA cc0 cexp co cdiv co cA cc wcel cA cc0 wne wa c1 cA
      cdiv co cc wcel c1 cA cdiv co cc0 cexp co c1 wceq cA reccl c1 cA cdiv co
      exp0 syl cA cc wcel c1 cA cc0 cexp co cdiv co c1 wceq cA cc0 wne cA cc
      wcel c1 cA cc0 cexp co cdiv co c1 c1 cdiv co c1 cA cc wcel cA cc0 cexp co
      c1 c1 cdiv cA exp0 opreq2d c1 ax1cn div1i syl6eq adantr eqtr4d vk cv cn0
      wcel cA cc wcel cA cc0 wne wa c1 cA cdiv co vk cv cexp co c1 cA vk cv
      cexp co cdiv co wceq c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA vk cv
      c1 caddc co cexp co cdiv co wceq vk cv cn0 wcel cA cc wcel cA cc0 wne c1
      cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq c1 cA cdiv co
      vk cv c1 caddc co cexp co c1 cA vk cv c1 caddc co cexp co cdiv co wceq wi
      cA cc wcel vk cv cn0 wcel cA cc0 wne c1 cA cdiv co vk cv cexp co c1 cA vk
      cv cexp co cdiv co wceq c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA vk
      cv c1 caddc co cexp co cdiv co wceq wi wi cA cc wcel vk cv cn0 wcel cA
      cc0 wne c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq c1
      cA cdiv co vk cv c1 caddc co cexp co c1 cA vk cv c1 caddc co cexp co cdiv
      co wceq cA cc wcel vk cv cn0 wcel wa cA cc0 wne c1 cA cdiv co vk cv cexp
      co c1 cA vk cv cexp co cdiv co wceq wa wa c1 cA cdiv co vk cv cexp co c1
      cA cdiv co cmul co c1 cA vk cv cexp co cdiv co c1 cA cdiv co cmul co c1
      cA cdiv co vk cv c1 caddc co cexp co c1 cA vk cv c1 caddc co cexp co cdiv
      co c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq c1 cA
      cdiv co vk cv cexp co c1 cA cdiv co cmul co c1 cA vk cv cexp co cdiv co
      c1 cA cdiv co cmul co wceq cA cc wcel vk cv cn0 wcel wa cA cc0 wne c1 cA
      cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co c1 cA cdiv co cmul
      opreq1 ad2antll cA cc wcel vk cv cn0 wcel wa cA cc0 wne c1 cA cdiv co vk
      cv c1 caddc co cexp co c1 cA cdiv co vk cv cexp co c1 cA cdiv co cmul co
      wceq c1 cA cdiv co vk cv cexp co c1 cA vk cv cexp co cdiv co wceq cA cc
      wcel cA cc0 wne vk cv cn0 wcel c1 cA cdiv co vk cv c1 caddc co cexp co c1
      cA cdiv co vk cv cexp co c1 cA cdiv co cmul co wceq c1 cA cdiv co cc wcel
      vk cv cn0 wcel c1 cA cdiv co vk cv c1 caddc co cexp co c1 cA cdiv co vk
      cv cexp co c1 cA cdiv co cmul co wceq cA cc wcel cA cc0 wne wa c1 cA cdiv
      co vk cv expp1 cA reccl sylan an1rs adantrr cA cc wcel vk cv cn0 wcel wa
      cA cc0 wne c1 cA vk cv c1 caddc co cexp co cdiv co c1 cA vk cv cexp co
      cdiv co c1 cA cdiv co cmul co wceq c1 cA cdiv co vk cv cexp co c1 cA vk
      cv cexp co cdiv co wceq cA cc wcel vk cv cn0 wcel wa cA cc0 wne wa c1 cA
      vk cv c1 caddc co cexp co cdiv co c1 cA vk cv cexp co cA cmul co cdiv co
      c1 cA vk cv cexp co cdiv co c1 cA cdiv co cmul co cA cc wcel vk cv cn0
      wcel wa c1 cA vk cv c1 caddc co cexp co cdiv co c1 cA vk cv cexp co cA
      cmul co cdiv co wceq cA cc0 wne cA cc wcel vk cv cn0 wcel wa cA vk cv c1
      caddc co cexp co cA vk cv cexp co cA cmul co c1 cdiv cA vk cv expp1
      opreq2d adantr cA cc wcel vk cv cn0 wcel wa cA cc0 wne wa c1 cA vk cv
      cexp co cdiv co c1 cA cdiv co cmul co c1 c1 cmul co cA vk cv cexp co cA
      cmul co cdiv co c1 cA vk cv cexp co cA cmul co cdiv co c1 cc wcel cA vk
      cv cexp co cc wcel wa c1 cc wcel cA cc wcel wa wa cA vk cv cexp co cc0
      wne cA cc0 wne wa c1 cA vk cv cexp co cdiv co c1 cA cdiv co cmul co c1 c1
      cmul co cA vk cv cexp co cA cmul co cdiv co wceq cA cc wcel vk cv cn0
      wcel wa cA cc0 wne wa c1 cc wcel c1 cc wcel wa cA vk cv cexp co cc wcel
      cA vk cv cexp co cc0 wne wa cA cc wcel cA cc0 wne wa wa c1 cA vk cv cexp
      co cdiv co c1 cA cdiv co cmul co c1 c1 cmul co cA vk cv cexp co cA cmul
      co cdiv co wceq c1 cc wcel cA vk cv cexp co cc wcel wa c1 cc wcel cA cc
      wcel wa wa cA vk cv cexp co cc0 wne cA cc0 wne wa wa c1 c1 cA vk cv cexp
      co cA divmuldiv c1 cc wcel cA vk cv cexp co cc wcel wa c1 cc wcel cA cc
      wcel wa wa cA vk cv cexp co cc0 wne cA cc0 wne wa wa c1 cc wcel c1 cc
      wcel c1 cc wcel cA vk cv cexp co cc wcel c1 cc wcel cA cc wcel wa cA vk
      cv cexp co cc0 wne cA cc0 wne wa simplll c1 cc wcel cA vk cv cexp co cc
      wcel c1 cc wcel cA cc wcel wa cA vk cv cexp co cc0 wne cA cc0 wne wa
      simplll jca c1 cc wcel cA vk cv cexp co cc wcel wa c1 cc wcel cA cc wcel
      wa wa cA vk cv cexp co cc0 wne cA cc0 wne wa wa cA vk cv cexp co cc wcel
      cA vk cv cexp co cc0 wne wa cA cc wcel cA cc0 wne wa c1 cc wcel cA vk cv
      cexp co cc wcel wa c1 cc wcel cA cc wcel wa wa cA vk cv cexp co cc wcel
      cA vk cv cexp co cc0 wne cA cc0 wne wa cA vk cv cexp co cc0 wne c1 cc
      wcel cA vk cv cexp co cc wcel c1 cc wcel cA cc wcel wa simplr cA vk cv
      cexp co cc0 wne cA cc0 wne pm3.26 anim12i c1 cc wcel cA vk cv cexp co cc
      wcel wa c1 cc wcel cA cc wcel wa wa cA cc wcel cA vk cv cexp co cc0 wne
      cA cc0 wne wa cA cc0 wne c1 cc wcel cA vk cv cexp co cc wcel wa c1 cc
      wcel cA cc wcel simprr cA vk cv cexp co cc0 wne cA cc0 wne pm3.27 anim12i
      jca sylanc cA cc wcel vk cv cn0 wcel wa c1 cc wcel cA vk cv cexp co cc
      wcel wa c1 cc wcel cA cc wcel wa wa cA cc0 wne cA cc wcel vk cv cn0 wcel
      wa c1 cc wcel cA vk cv cexp co cc wcel wa c1 cc wcel cA cc wcel wa cA cc
      wcel vk cv cn0 wcel wa cA vk cv cexp co cc wcel c1 cc wcel cA vk cv expcl
      ax1cn jctil cA cc wcel vk cv cn0 wcel wa cA cc wcel c1 cc wcel cA cc wcel
      vk cv cn0 wcel pm3.26 ax1cn jctil jca adantr cA cc wcel vk cv cn0 wcel wa
      cA cc0 wne wa cA vk cv cexp co cc0 wne cA cc0 wne cA cc wcel vk cv cn0
      wcel cA cc0 wne cA vk cv cexp co cc0 wne cA cc wcel cA cc0 wne vk cv cn0
      wcel cA vk cv cexp co cc0 wne cA cc wcel vk cv cn0 wcel cA cc0 wne w3a cA
      vk cv expne0i cA cc wcel vk cv cn0 wcel cA cc0 wne 3simp1 cA cc wcel vk
      cv cn0 wcel cA cc0 wne 3simp3 cA cc wcel vk cv cn0 wcel cA cc0 wne 3simp2
      syl3anc 3expa cA cc wcel vk cv cn0 wcel wa cA cc0 wne pm3.27 jca sylanc
      c1 c1 cmul co c1 cA vk cv cexp co cA cmul co cdiv c1 ax1cn mulid1i
      opreq1i syl6req eqtrd adantrr 3eqtr4d exp43 com12 imp3a a2d nn0ind exp3a
      com12 3imp $.
      $( [10-Oct-2006] $) $( [2-Aug-2006] $)

    $( Sum of exponents law for nonnegative integer exponentiation.
       Proposition 10-4.2(a) of [Gleason] p. 135. $)
    expadd $p |- ( ( A e. CC /\ M e. NN0 /\ N e. NN0 ) ->
                  ( A ^ ( M + N ) ) = ( ( A ^ M ) x. ( A ^ N ) ) ) $=
      cA cc wcel cM cn0 wcel cN cn0 wcel cA cM cN caddc co cexp co cA cM cexp
      co cA cN cexp co cmul co wceq cN cn0 wcel cA cc wcel cM cn0 wcel cA cM cN
      caddc co cexp co cA cM cexp co cA cN cexp co cmul co wceq cN cn0 wcel cA
      cc wcel cM cn0 wcel cA cM cN caddc co cexp co cA cM cexp co cA cN cexp co
      cmul co wceq cA cc wcel cM cn0 wcel wa cA cM vj cv caddc co cexp co cA cM
      cexp co cA vj cv cexp co cmul co wceq wi cA cc wcel cM cn0 wcel wa cA cM
      cc0 caddc co cexp co cA cM cexp co cA cc0 cexp co cmul co wceq wi cA cc
      wcel cM cn0 wcel wa cA cM vk cv caddc co cexp co cA cM cexp co cA vk cv
      cexp co cmul co wceq wi cA cc wcel cM cn0 wcel wa cA cM vk cv c1 caddc co
      caddc co cexp co cA cM cexp co cA vk cv c1 caddc co cexp co cmul co wceq
      wi cA cc wcel cM cn0 wcel wa cA cM cN caddc co cexp co cA cM cexp co cA
      cN cexp co cmul co wceq wi vj vk cN vj cv cc0 wceq cA cM vj cv caddc co
      cexp co cA cM cexp co cA vj cv cexp co cmul co wceq cA cM cc0 caddc co
      cexp co cA cM cexp co cA cc0 cexp co cmul co wceq cA cc wcel cM cn0 wcel
      wa vj cv cc0 wceq cA cM vj cv caddc co cexp co cA cM cc0 caddc co cexp co
      cA cM cexp co cA vj cv cexp co cmul co cA cM cexp co cA cc0 cexp co cmul
      co vj cv cc0 wceq cM vj cv caddc co cM cc0 caddc co cA cexp vj cv cc0 cM
      caddc opreq2 opreq2d vj cv cc0 wceq cA vj cv cexp co cA cc0 cexp co cA cM
      cexp co cmul vj cv cc0 cA cexp opreq2 opreq2d eqeq12d imbi2d vj cv vk cv
      wceq cA cM vj cv caddc co cexp co cA cM cexp co cA vj cv cexp co cmul co
      wceq cA cM vk cv caddc co cexp co cA cM cexp co cA vk cv cexp co cmul co
      wceq cA cc wcel cM cn0 wcel wa vj cv vk cv wceq cA cM vj cv caddc co cexp
      co cA cM vk cv caddc co cexp co cA cM cexp co cA vj cv cexp co cmul co cA
      cM cexp co cA vk cv cexp co cmul co vj cv vk cv wceq cM vj cv caddc co cM
      vk cv caddc co cA cexp vj cv vk cv cM caddc opreq2 opreq2d vj cv vk cv
      wceq cA vj cv cexp co cA vk cv cexp co cA cM cexp co cmul vj cv vk cv cA
      cexp opreq2 opreq2d eqeq12d imbi2d vj cv vk cv c1 caddc co wceq cA cM vj
      cv caddc co cexp co cA cM cexp co cA vj cv cexp co cmul co wceq cA cM vk
      cv c1 caddc co caddc co cexp co cA cM cexp co cA vk cv c1 caddc co cexp
      co cmul co wceq cA cc wcel cM cn0 wcel wa vj cv vk cv c1 caddc co wceq cA
      cM vj cv caddc co cexp co cA cM vk cv c1 caddc co caddc co cexp co cA cM
      cexp co cA vj cv cexp co cmul co cA cM cexp co cA vk cv c1 caddc co cexp
      co cmul co vj cv vk cv c1 caddc co wceq cM vj cv caddc co cM vk cv c1
      caddc co caddc co cA cexp vj cv vk cv c1 caddc co cM caddc opreq2 opreq2d
      vj cv vk cv c1 caddc co wceq cA vj cv cexp co cA vk cv c1 caddc co cexp
      co cA cM cexp co cmul vj cv vk cv c1 caddc co cA cexp opreq2 opreq2d
      eqeq12d imbi2d vj cv cN wceq cA cM vj cv caddc co cexp co cA cM cexp co
      cA vj cv cexp co cmul co wceq cA cM cN caddc co cexp co cA cM cexp co cA
      cN cexp co cmul co wceq cA cc wcel cM cn0 wcel wa vj cv cN wceq cA cM vj
      cv caddc co cexp co cA cM cN caddc co cexp co cA cM cexp co cA vj cv cexp
      co cmul co cA cM cexp co cA cN cexp co cmul co vj cv cN wceq cM vj cv
      caddc co cM cN caddc co cA cexp vj cv cN cM caddc opreq2 opreq2d vj cv cN
      wceq cA vj cv cexp co cA cN cexp co cA cM cexp co cmul vj cv cN cA cexp
      opreq2 opreq2d eqeq12d imbi2d cA cc wcel cM cn0 wcel wa cA cM cexp co c1
      cmul co cA cM cexp co cA cM cexp co cA cc0 cexp co cmul co cA cM cc0
      caddc co cexp co cA cc wcel cM cn0 wcel wa cA cM cexp co cc wcel cA cM
      cexp co c1 cmul co cA cM cexp co wceq cA cM expcl cA cM cexp co ax1id syl
      cA cc wcel cM cn0 wcel wa cA cc0 cexp co c1 cA cM cexp co cmul cA cc wcel
      cA cc0 cexp co c1 wceq cM cn0 wcel cA exp0 adantr opreq2d cA cc wcel cM
      cn0 wcel wa cM cc0 caddc co cM cA cexp cM cn0 wcel cM cc0 caddc co cM
      wceq cA cc wcel cM cn0 wcel cM cc wcel cM cc0 caddc co cM wceq cM nn0cn
      cM addid1 syl adantl opreq2d 3eqtr4rd vk cv cn0 wcel cA cc wcel cM cn0
      wcel wa cA cM vk cv caddc co cexp co cA cM cexp co cA vk cv cexp co cmul
      co wceq cA cM vk cv c1 caddc co caddc co cexp co cA cM cexp co cA vk cv
      c1 caddc co cexp co cmul co wceq cA cc wcel cM cn0 wcel wa vk cv cn0 wcel
      cA cM vk cv caddc co cexp co cA cM cexp co cA vk cv cexp co cmul co wceq
      cA cM vk cv c1 caddc co caddc co cexp co cA cM cexp co cA vk cv c1 caddc
      co cexp co cmul co wceq wi cA cc wcel cM cn0 wcel wa vk cv cn0 wcel wa cA
      cM vk cv c1 caddc co caddc co cexp co cA cM cexp co cA vk cv c1 caddc co
      cexp co cmul co wceq cA cM vk cv caddc co cexp co cA cmul co cA cM cexp
      co cA vk cv cexp co cmul co cA cmul co wceq cA cM vk cv caddc co cexp co
      cA cM cexp co cA vk cv cexp co cmul co wceq cA cc wcel cM cn0 wcel wa vk
      cv cn0 wcel wa cA cM vk cv c1 caddc co caddc co cexp co cA cM vk cv caddc
      co cexp co cA cmul co cA cM cexp co cA vk cv c1 caddc co cexp co cmul co
      cA cM cexp co cA vk cv cexp co cmul co cA cmul co cA cc wcel cM cn0 wcel
      wa vk cv cn0 wcel wa cA cM vk cv caddc co c1 caddc co cexp co cA cM vk cv
      c1 caddc co caddc co cexp co cA cM vk cv caddc co cexp co cA cmul co cA
      cc wcel cM cn0 wcel wa vk cv cn0 wcel wa cM vk cv caddc co c1 caddc co cM
      vk cv c1 caddc co caddc co cA cexp cM cn0 wcel vk cv cn0 wcel cM vk cv
      caddc co c1 caddc co cM vk cv c1 caddc co caddc co wceq cA cc wcel cM cc
      wcel vk cv cc wcel cM vk cv caddc co c1 caddc co cM vk cv c1 caddc co
      caddc co wceq cM cn0 wcel vk cv cn0 wcel cM cc wcel vk cv cc wcel c1 cc
      wcel cM vk cv caddc co c1 caddc co cM vk cv c1 caddc co caddc co wceq
      ax1cn cM vk cv c1 addass mp3an3 cM nn0cn vk cv nn0cn syl2an adantll
      opreq2d cA cc wcel cM vk cv caddc co cn0 wcel cA cM vk cv caddc co c1
      caddc co cexp co cA cM vk cv caddc co cexp co cA cmul co wceq cA cc wcel
      cM cn0 wcel wa vk cv cn0 wcel wa cA cM vk cv caddc co expp1 cA cc wcel cM
      cn0 wcel vk cv cn0 wcel simpll cM cn0 wcel vk cv cn0 wcel cM vk cv caddc
      co cn0 wcel cA cc wcel cM vk cv nn0addcl adantll sylanc eqtr3d cA cc wcel
      cM cn0 wcel wa vk cv cn0 wcel wa cA cM cexp co cA vk cv c1 caddc co cexp
      co cmul co cA cM cexp co cA vk cv cexp co cA cmul co cmul co cA cM cexp
      co cA vk cv cexp co cmul co cA cmul co cA cc wcel cM cn0 wcel wa vk cv
      cn0 wcel wa cA vk cv c1 caddc co cexp co cA vk cv cexp co cA cmul co cA
      cM cexp co cmul cA cc wcel vk cv cn0 wcel cA vk cv c1 caddc co cexp co cA
      vk cv cexp co cA cmul co wceq cM cn0 wcel cA vk cv expp1 adantlr opreq2d
      cA cM cexp co cc wcel cA vk cv cexp co cc wcel cA cc wcel cA cM cexp co
      cA vk cv cexp co cmul co cA cmul co cA cM cexp co cA vk cv cexp co cA
      cmul co cmul co wceq cA cc wcel cM cn0 wcel wa vk cv cn0 wcel wa cA cM
      cexp co cA vk cv cexp co cA mulass cA cc wcel cM cn0 wcel wa cA cM cexp
      co cc wcel vk cv cn0 wcel cA cM expcl adantr cA cc wcel vk cv cn0 wcel cA
      vk cv cexp co cc wcel cM cn0 wcel cA vk cv expcl adantlr cA cc wcel cM
      cn0 wcel vk cv cn0 wcel simpll syl3anc eqtr4d eqeq12d cA cM vk cv caddc
      co cexp co cA cM cexp co cA vk cv cexp co cmul co cA cmul opreq1 syl5bir
      expcom a2d nn0ind exp3a com3l 3imp $.
      $( [2-Dec-2004] $) $( [30-Nov-2004] $)

    $( Product of exponents law for natural number exponentiation.  Proposition
       10-4.2(b) of [Gleason] p. 135, restricted to nonnegative integer
       exponents. $)
    expmul $p |- ( ( A e. CC /\ M e. NN0 /\ N e. NN0 ) ->
               ( A ^ ( M x. N ) ) = ( ( A ^ M ) ^ N ) ) $=
      cA cc wcel cM cn0 wcel cN cn0 wcel cA cM cN cmul co cexp co cA cM cexp co
      cN cexp co wceq cN cn0 wcel cA cc wcel cM cn0 wcel cA cM cN cmul co cexp
      co cA cM cexp co cN cexp co wceq cN cn0 wcel cA cc wcel cM cn0 wcel cA cM
      cN cmul co cexp co cA cM cexp co cN cexp co wceq cA cc wcel cM cn0 wcel
      wa cA cM vj cv cmul co cexp co cA cM cexp co vj cv cexp co wceq wi cA cc
      wcel cM cn0 wcel wa cA cM cc0 cmul co cexp co cA cM cexp co cc0 cexp co
      wceq wi cA cc wcel cM cn0 wcel wa cA cM vk cv cmul co cexp co cA cM cexp
      co vk cv cexp co wceq wi cA cc wcel cM cn0 wcel wa cA cM vk cv c1 caddc
      co cmul co cexp co cA cM cexp co vk cv c1 caddc co cexp co wceq wi cA cc
      wcel cM cn0 wcel wa cA cM cN cmul co cexp co cA cM cexp co cN cexp co
      wceq wi vj vk cN vj cv cc0 wceq cA cM vj cv cmul co cexp co cA cM cexp co
      vj cv cexp co wceq cA cM cc0 cmul co cexp co cA cM cexp co cc0 cexp co
      wceq cA cc wcel cM cn0 wcel wa vj cv cc0 wceq cA cM vj cv cmul co cexp co
      cA cM cc0 cmul co cexp co cA cM cexp co vj cv cexp co cA cM cexp co cc0
      cexp co vj cv cc0 wceq cM vj cv cmul co cM cc0 cmul co cA cexp vj cv cc0
      cM cmul opreq2 opreq2d vj cv cc0 cA cM cexp co cexp opreq2 eqeq12d imbi2d
      vj cv vk cv wceq cA cM vj cv cmul co cexp co cA cM cexp co vj cv cexp co
      wceq cA cM vk cv cmul co cexp co cA cM cexp co vk cv cexp co wceq cA cc
      wcel cM cn0 wcel wa vj cv vk cv wceq cA cM vj cv cmul co cexp co cA cM vk
      cv cmul co cexp co cA cM cexp co vj cv cexp co cA cM cexp co vk cv cexp
      co vj cv vk cv wceq cM vj cv cmul co cM vk cv cmul co cA cexp vj cv vk cv
      cM cmul opreq2 opreq2d vj cv vk cv cA cM cexp co cexp opreq2 eqeq12d
      imbi2d vj cv vk cv c1 caddc co wceq cA cM vj cv cmul co cexp co cA cM
      cexp co vj cv cexp co wceq cA cM vk cv c1 caddc co cmul co cexp co cA cM
      cexp co vk cv c1 caddc co cexp co wceq cA cc wcel cM cn0 wcel wa vj cv vk
      cv c1 caddc co wceq cA cM vj cv cmul co cexp co cA cM vk cv c1 caddc co
      cmul co cexp co cA cM cexp co vj cv cexp co cA cM cexp co vk cv c1 caddc
      co cexp co vj cv vk cv c1 caddc co wceq cM vj cv cmul co cM vk cv c1
      caddc co cmul co cA cexp vj cv vk cv c1 caddc co cM cmul opreq2 opreq2d
      vj cv vk cv c1 caddc co cA cM cexp co cexp opreq2 eqeq12d imbi2d vj cv cN
      wceq cA cM vj cv cmul co cexp co cA cM cexp co vj cv cexp co wceq cA cM
      cN cmul co cexp co cA cM cexp co cN cexp co wceq cA cc wcel cM cn0 wcel
      wa vj cv cN wceq cA cM vj cv cmul co cexp co cA cM cN cmul co cexp co cA
      cM cexp co vj cv cexp co cA cM cexp co cN cexp co vj cv cN wceq cM vj cv
      cmul co cM cN cmul co cA cexp vj cv cN cM cmul opreq2 opreq2d vj cv cN cA
      cM cexp co cexp opreq2 eqeq12d imbi2d cA cc wcel cM cn0 wcel wa cA cM cc0
      cmul co cexp co c1 cA cM cexp co cc0 cexp co cM cn0 wcel cA cc wcel cA cM
      cc0 cmul co cexp co cA cc0 cexp co c1 cM cn0 wcel cM cc0 cmul co cc0 cA
      cexp cM cn0 wcel cM cc wcel cM cc0 cmul co cc0 wceq cM nn0cn cM mul01 syl
      opreq2d cA exp0 sylan9eqr cA cc wcel cM cn0 wcel wa cA cM cexp co cc wcel
      cA cM cexp co cc0 cexp co c1 wceq cA cM expcl cA cM cexp co exp0 syl
      eqtr4d vk cv cn0 wcel cA cc wcel cM cn0 wcel wa cA cM vk cv cmul co cexp
      co cA cM cexp co vk cv cexp co wceq cA cM vk cv c1 caddc co cmul co cexp
      co cA cM cexp co vk cv c1 caddc co cexp co wceq cA cc wcel cM cn0 wcel wa
      vk cv cn0 wcel cA cM vk cv cmul co cexp co cA cM cexp co vk cv cexp co
      wceq cA cM vk cv c1 caddc co cmul co cexp co cA cM cexp co vk cv c1 caddc
      co cexp co wceq wi cA cc wcel cM cn0 wcel wa vk cv cn0 wcel wa cA cM vk
      cv c1 caddc co cmul co cexp co cA cM cexp co vk cv c1 caddc co cexp co
      wceq cA cM vk cv cmul co cexp co cA cM cexp co cmul co cA cM cexp co vk
      cv cexp co cA cM cexp co cmul co wceq cA cM vk cv cmul co cexp co cA cM
      cexp co vk cv cexp co wceq cA cc wcel cM cn0 wcel wa vk cv cn0 wcel wa cA
      cM vk cv c1 caddc co cmul co cexp co cA cM vk cv cmul co cexp co cA cM
      cexp co cmul co cA cM cexp co vk cv c1 caddc co cexp co cA cM cexp co vk
      cv cexp co cA cM cexp co cmul co cA cc wcel cM cn0 wcel wa vk cv cn0 wcel
      wa cA cM vk cv c1 caddc co cmul co cexp co cA cM vk cv cmul co cM caddc
      co cexp co cA cM vk cv cmul co cexp co cA cM cexp co cmul co cA cc wcel
      cM cn0 wcel wa vk cv cn0 wcel wa cM vk cv c1 caddc co cmul co cM vk cv
      cmul co cM caddc co cA cexp cM cn0 wcel vk cv cn0 wcel cM vk cv c1 caddc
      co cmul co cM vk cv cmul co cM caddc co wceq cA cc wcel cM cc wcel vk cv
      cc wcel cM vk cv c1 caddc co cmul co cM vk cv cmul co cM caddc co wceq cM
      cn0 wcel vk cv cn0 wcel cM cc wcel vk cv cc wcel wa cM vk cv c1 caddc co
      cmul co cM vk cv cmul co cM c1 cmul co caddc co cM vk cv cmul co cM caddc
      co cM cc wcel vk cv cc wcel c1 cc wcel cM vk cv c1 caddc co cmul co cM vk
      cv cmul co cM c1 cmul co caddc co wceq ax1cn cM vk cv c1 adddi mp3an3 cM
      cc wcel vk cv cc wcel wa cM c1 cmul co cM cM vk cv cmul co caddc cM cc
      wcel cM c1 cmul co cM wceq vk cv cc wcel cM ax1id adantr opreq2d eqtrd cM
      nn0cn vk cv nn0cn syl2an adantll opreq2d cA cc wcel cM vk cv cmul co cn0
      wcel cM cn0 wcel cA cM vk cv cmul co cM caddc co cexp co cA cM vk cv cmul
      co cexp co cA cM cexp co cmul co wceq cA cc wcel cM cn0 wcel wa vk cv cn0
      wcel wa cA cM vk cv cmul co cM expadd cA cc wcel cM cn0 wcel vk cv cn0
      wcel simpll cM cn0 wcel vk cv cn0 wcel cM vk cv cmul co cn0 wcel cA cc
      wcel cM vk cv nn0mulcl adantll cA cc wcel cM cn0 wcel vk cv cn0 wcel
      simplr syl3anc eqtrd cA cM cexp co cc wcel vk cv cn0 wcel cA cM cexp co
      vk cv c1 caddc co cexp co cA cM cexp co vk cv cexp co cA cM cexp co cmul
      co wceq cA cc wcel cM cn0 wcel wa cA cM cexp co vk cv expp1 cA cM expcl
      sylan eqeq12d cA cM vk cv cmul co cexp co cA cM cexp co vk cv cexp co cA
      cM cexp co cmul opreq1 syl5bir expcom a2d nn0ind exp3a com3l 3imp $.
      $( [3-Feb-2006] $) $( [4-Jan-2006] $)
  $}

  $( Exponent subtraction law for nonnegative integer exponentiation. $)
  expsub $p |- ( ( ( ( A e. CC /\ A =/= 0 ) /\ M e. NN0 /\ N e. NN0 ) /\
      N <_ M ) -> ( A ^ ( M - N ) ) = ( ( A ^ M ) / ( A ^ N ) ) ) $=
    cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel w3a cN cM cle wbr wa cA cM
    cexp co cA cN cexp co cdiv co cA cM cN cmin co cexp co cA cc wcel cA cc0
    wne wa cM cn0 wcel cN cn0 wcel w3a cN cM cle wbr wa cA cM cexp co cA cN
    cexp co cdiv co cA cM cN cmin co cexp co wceq cA cN cexp co cA cM cN cmin
    co cexp co cmul co cA cM cexp co wceq cA cc wcel cA cc0 wne wa cM cn0 wcel
    cN cn0 wcel w3a cN cM cle wbr wa cA cN cM cN cmin co caddc co cexp co cA cN
    cexp co cA cM cN cmin co cexp co cmul co cA cM cexp co cA cc wcel cN cn0
    wcel cM cN cmin co cn0 wcel cA cN cM cN cmin co caddc co cexp co cA cN cexp
    co cA cM cN cmin co cexp co cmul co wceq cA cc wcel cA cc0 wne wa cM cn0
    wcel cN cn0 wcel w3a cN cM cle wbr wa cA cN cM cN cmin co expadd cA cc wcel
    cA cc0 wne wa cM cn0 wcel cN cM cle wbr cA cc wcel cN cn0 wcel cA cc wcel
    cA cc0 wne cN cM cle wbr simpll 3ad2antl1 cA cc wcel cA cc0 wne wa cM cn0
    wcel cN cn0 wcel cN cM cle wbr 3simpl3 cM cn0 wcel cN cn0 wcel cN cM cle
    wbr cM cN cmin co cn0 wcel cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel
    wa cN cM cle wbr cM cN cmin co cn0 wcel cN cn0 wcel cM cn0 wcel cN cM cle
    wbr cM cN cmin co cn0 wcel wb cN cM nn0sub ancoms biimpa 3adantl1 syl3anc
    cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel w3a cA cN cM cN cmin co
    caddc co cexp co cA cM cexp co wceq cN cM cle wbr cM cn0 wcel cN cn0 wcel
    cA cN cM cN cmin co caddc co cexp co cA cM cexp co wceq cA cc wcel cA cc0
    wne wa cM cn0 wcel cN cn0 wcel wa cN cM cN cmin co caddc co cM cA cexp cN
    cn0 wcel cM cn0 wcel cN cM cN cmin co caddc co cM wceq cN cc wcel cM cc
    wcel cN cM cN cmin co caddc co cM wceq cN cn0 wcel cM cn0 wcel cN cM pncan3
    cN nn0cn cM nn0cn syl2an ancoms opreq2d 3adant1 adantr eqtr3d cA cM cexp co
    cc wcel cA cM cN cmin co cexp co cc wcel cA cN cexp co cc wcel cA cN cexp
    co cc0 wne wa cA cM cexp co cA cN cexp co cdiv co cA cM cN cmin co cexp co
    wceq cA cN cexp co cA cM cN cmin co cexp co cmul co cA cM cexp co wceq wb
    cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel w3a cN cM cle wbr wa cA cM
    cexp co cA cM cN cmin co cexp co cA cN cexp co divmul cA cc wcel cA cc0 wne
    wa cM cn0 wcel cN cn0 wcel w3a cA cM cexp co cc wcel cN cM cle wbr cA cc
    wcel cA cc0 wne wa cM cn0 wcel cA cM cexp co cc wcel cN cn0 wcel cA cc wcel
    cM cn0 wcel cA cM cexp co cc wcel cA cc0 wne cA cM expcl adantlr 3adant3
    adantr cA cc wcel cM cN cmin co cn0 wcel cA cM cN cmin co cexp co cc wcel
    cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel w3a cN cM cle wbr wa cA cM
    cN cmin co expcl cA cc wcel cA cc0 wne wa cM cn0 wcel cN cM cle wbr cA cc
    wcel cN cn0 wcel cA cc wcel cA cc0 wne cN cM cle wbr simpll 3ad2antl1 cM
    cn0 wcel cN cn0 wcel cN cM cle wbr cM cN cmin co cn0 wcel cA cc wcel cA cc0
    wne wa cM cn0 wcel cN cn0 wcel wa cN cM cle wbr cM cN cmin co cn0 wcel cN
    cn0 wcel cM cn0 wcel cN cM cle wbr cM cN cmin co cn0 wcel wb cN cM nn0sub
    ancoms biimpa 3adantl1 sylanc cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0
    wcel w3a cN cM cle wbr wa cA cN cexp co cc wcel cA cN cexp co cc0 wne cA cc
    wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel w3a cA cN cexp co cc wcel cN cM
    cle wbr cA cc wcel cA cc0 wne wa cN cn0 wcel cA cN cexp co cc wcel cM cn0
    wcel cA cc wcel cN cn0 wcel cA cN cexp co cc wcel cA cc0 wne cA cN expcl
    adantlr 3adant2 adantr cA cc wcel cA cc0 wne wa cM cn0 wcel cN cn0 wcel w3a
    cA cN cexp co cc0 wne cN cM cle wbr cA cc wcel cA cc0 wne wa cN cn0 wcel cA
    cN cexp co cc0 wne cM cn0 wcel cA cc wcel cA cc0 wne cN cn0 wcel cA cN cexp
    co cc0 wne cA cN expne0i 3expa 3adant2 adantr jca syl3anc mpbird eqcomd $.
    $( [12-Jan-2009] $) $( [2-Aug-2006] $)

  $( Exponent subtraction law for nonnegative integer exponentiation. $)
  expsubOLD $p |- ( ( ( A e. CC /\ M e. NN0 /\ N e. NN0 ) /\
  ( A =/= 0 /\ N <_ M ) ) -> ( A ^ ( M - N ) ) = ( ( A ^ M ) / ( A ^ N ) ) ) $=
    cA cc wcel cM cn0 wcel cN cn0 wcel w3a cA cc0 wne cN cM cle wbr wa wa cA cM
    cexp co cA cN cexp co cdiv co cA cM cN cmin co cexp co cA cc wcel cM cn0
    wcel cN cn0 wcel w3a cA cc0 wne cN cM cle wbr wa wa cA cM cexp co cA cN
    cexp co cdiv co cA cM cN cmin co cexp co wceq cA cN cexp co cA cM cN cmin
    co cexp co cmul co cA cM cexp co wceq cA cc wcel cM cn0 wcel cN cn0 wcel
    w3a cN cM cle wbr cA cN cexp co cA cM cN cmin co cexp co cmul co cA cM cexp
    co wceq cA cc0 wne cA cc wcel cM cn0 wcel cN cn0 wcel w3a cN cM cle wbr wa
    cA cN cM cN cmin co caddc co cexp co cA cN cexp co cA cM cN cmin co cexp co
    cmul co cA cM cexp co cA cc wcel cN cn0 wcel cM cN cmin co cn0 wcel cA cN
    cM cN cmin co caddc co cexp co cA cN cexp co cA cM cN cmin co cexp co cmul
    co wceq cA cc wcel cM cn0 wcel cN cn0 wcel w3a cN cM cle wbr wa cA cN cM cN
    cmin co expadd cA cc wcel cM cn0 wcel cN cn0 wcel cN cM cle wbr 3simpl1 cA
    cc wcel cM cn0 wcel cN cn0 wcel cN cM cle wbr 3simpl3 cM cn0 wcel cN cn0
    wcel cN cM cle wbr cM cN cmin co cn0 wcel cA cc wcel cM cn0 wcel cN cn0
    wcel wa cN cM cle wbr cM cN cmin co cn0 wcel cN cn0 wcel cM cn0 wcel cN cM
    cle wbr cM cN cmin co cn0 wcel wb cN cM nn0sub ancoms biimpa 3adantl1
    syl3anc cA cc wcel cM cn0 wcel cN cn0 wcel w3a cA cN cM cN cmin co caddc co
    cexp co cA cM cexp co wceq cN cM cle wbr cM cn0 wcel cN cn0 wcel cA cN cM
    cN cmin co caddc co cexp co cA cM cexp co wceq cA cc wcel cM cn0 wcel cN
    cn0 wcel wa cN cM cN cmin co caddc co cM cA cexp cN cn0 wcel cM cn0 wcel cN
    cM cN cmin co caddc co cM wceq cN cc wcel cM cc wcel cN cM cN cmin co caddc
    co cM wceq cN cn0 wcel cM cn0 wcel cN cM pncan3 cN nn0cn cM nn0cn syl2an
    ancoms opreq2d 3adant1 adantr eqtr3d adantrl cA cM cexp co cc wcel cA cN
    cexp co cc wcel cA cM cN cmin co cexp co cc wcel w3a cA cN cexp co cc0 wne
    cA cM cexp co cA cN cexp co cdiv co cA cM cN cmin co cexp co wceq cA cN
    cexp co cA cM cN cmin co cexp co cmul co cA cM cexp co wceq wb cA cc wcel
    cM cn0 wcel cN cn0 wcel w3a cA cc0 wne cN cM cle wbr wa wa cA cM cexp co cc
    wcel cA cM cN cmin co cexp co cc wcel cA cN cexp co cc wcel cA cN cexp co
    cc0 wne wa cA cM cexp co cA cN cexp co cdiv co cA cM cN cmin co cexp co
    wceq cA cN cexp co cA cM cN cmin co cexp co cmul co cA cM cexp co wceq wb
    cA cM cexp co cc wcel cA cN cexp co cc wcel cA cM cN cmin co cexp co cc
    wcel w3a cA cN cexp co cc0 wne wa cA cM cexp co cA cM cN cmin co cexp co cA
    cN cexp co divmul cA cM cexp co cc wcel cA cN cexp co cc wcel cA cM cN cmin
    co cexp co cc wcel cA cN cexp co cc0 wne 3simpl1 cA cM cexp co cc wcel cA
    cN cexp co cc wcel cA cM cN cmin co cexp co cc wcel cA cN cexp co cc0 wne
    3simpl3 cA cM cexp co cc wcel cA cN cexp co cc wcel cA cM cN cmin co cexp
    co cc wcel w3a cA cN cexp co cc wcel cA cN cexp co cc0 wne cA cN cexp co
    cc0 wne cA cM cexp co cc wcel cA cN cexp co cc wcel cA cM cN cmin co cexp
    co cc wcel 3simp2 cA cN cexp co cc0 wne id anim12i syl3anc cA cc wcel cM
    cn0 wcel cN cn0 wcel w3a cA cc0 wne cN cM cle wbr wa wa cA cM cexp co cc
    wcel cA cN cexp co cc wcel cA cM cN cmin co cexp co cc wcel cA cc wcel cM
    cn0 wcel cN cn0 wcel w3a cA cM cexp co cc wcel cA cc0 wne cN cM cle wbr wa
    cA cc wcel cM cn0 wcel cA cM cexp co cc wcel cN cn0 wcel cA cM expcl
    3adant3 adantr cA cc wcel cM cn0 wcel cN cn0 wcel w3a cA cN cexp co cc wcel
    cA cc0 wne cN cM cle wbr wa cA cc wcel cN cn0 wcel cA cN cexp co cc wcel cM
    cn0 wcel cA cN expcl 3adant2 adantr cA cc wcel cM cn0 wcel cN cn0 wcel w3a
    cN cM cle wbr cA cM cN cmin co cexp co cc wcel cA cc0 wne cA cc wcel cM cN
    cmin co cn0 wcel cA cM cN cmin co cexp co cc wcel cA cc wcel cM cn0 wcel cN
    cn0 wcel w3a cN cM cle wbr wa cA cM cN cmin co expcl cA cc wcel cM cn0 wcel
    cN cn0 wcel cN cM cle wbr 3simpl1 cM cn0 wcel cN cn0 wcel cN cM cle wbr cM
    cN cmin co cn0 wcel cA cc wcel cM cn0 wcel cN cn0 wcel wa cN cM cle wbr cM
    cN cmin co cn0 wcel cN cn0 wcel cM cn0 wcel cN cM cle wbr cM cN cmin co cn0
    wcel wb cN cM nn0sub ancoms biimpa 3adantl1 sylanc adantrl 3jca cA cc wcel
    cM cn0 wcel cN cn0 wcel w3a cA cc0 wne cA cN cexp co cc0 wne cN cM cle wbr
    cA cc wcel cN cn0 wcel cA cc0 wne cA cN cexp co cc0 wne cM cn0 wcel cA cc
    wcel cN cn0 wcel cA cc0 wne cA cN cexp co cc0 wne cA cc wcel cA cc0 wne cN
    cn0 wcel cA cN cexp co cc0 wne cA cc wcel cN cn0 wcel cA cc0 wne w3a cA cN
    expne0i cA cc wcel cN cn0 wcel cA cc0 wne 3simp1 cA cc wcel cN cn0 wcel cA
    cc0 wne 3simp3 cA cc wcel cN cn0 wcel cA cc0 wne 3simp2 syl3anc 3expa
    3adantl2 adantrr sylanc mpbird eqcomd $.
    $( [10-Oct-2006] $) $( [2-Aug-2006] $)

  $( Value of a complex number raised to a nonnegative integer power minus
     one. $)
  expm1 $p |- ( ( A e. CC /\ A =/= 0 /\ N e. NN ) -> ( A ^ ( N - 1 ) ) =
               ( ( A ^ N ) / A ) ) $=
    cA cc wcel cA cc0 wne cN cn wcel w3a cA cN c1 cmin co cexp co cA cN cexp co
    cA c1 cexp co cdiv co cA cN cexp co cA cdiv co cA cc wcel cA cc0 wne wa cN
    cn0 wcel c1 cn0 wcel w3a c1 cN cle wbr cA cN c1 cmin co cexp co cA cN cexp
    co cA c1 cexp co cdiv co wceq cA cc wcel cA cc0 wne cN cn wcel w3a cA cN c1
    expsub cA cc wcel cA cc0 wne cN cn wcel w3a cA cc wcel cA cc0 wne wa cN cn0
    wcel c1 cn0 wcel cA cc wcel cA cc0 wne cN cn wcel 3simpa cN cn wcel cA cc
    wcel cN cn0 wcel cA cc0 wne cN nnnn0 3ad2ant3 c1 cn0 wcel cA cc wcel cA cc0
    wne cN cn wcel w3a 1nn0 a1i 3jca cN cn wcel cA cc wcel c1 cN cle wbr cA cc0
    wne cN nnge1 3ad2ant3 sylanc cA cc wcel cA cc0 wne cN cn wcel w3a cA c1
    cexp co cA cA cN cexp co cdiv cA cc wcel cA cc0 wne cA c1 cexp co cA wceq
    cN cn wcel cA exp1 3ad2ant1 opreq2d eqtrd $.
    $( [8-Mar-2009] $) $( [25-Dec-2008] $)

  $( Nonnegative integer exponentiation of a quotient. $)
  expdiv $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ N e. NN0 ) ->
                ( ( A / B ) ^ N ) = ( ( A ^ N ) / ( B ^ N ) ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne wa cN cn0 wcel w3a cA cB cdiv co cN cexp
    co cA c1 cB cdiv co cmul co cN cexp co cA cN cexp co c1 cB cdiv co cN cexp
    co cmul co cA cN cexp co cB cN cexp co cdiv co cA cc wcel cB cc wcel cB cc0
    wne wa cN cn0 wcel w3a cA cB cdiv co cA c1 cB cdiv co cmul co cN cexp cA cc
    wcel cB cc wcel cB cc0 wne wa cA cB cdiv co cA c1 cB cdiv co cmul co wceq
    cN cn0 wcel cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cA c1 cB cdiv co
    cmul co wceq cA cB divrec 3expb 3adant3 opreq1d cA cc wcel c1 cB cdiv co cc
    wcel cN cn0 wcel cA c1 cB cdiv co cmul co cN cexp co cA cN cexp co c1 cB
    cdiv co cN cexp co cmul co wceq cB cc wcel cB cc0 wne wa cA c1 cB cdiv co
    cN mulexp cB reccl syl3an2 cA cc wcel cB cc wcel cB cc0 wne wa cN cn0 wcel
    w3a cA cN cexp co c1 cB cdiv co cN cexp co cmul co cA cN cexp co c1 cB cN
    cexp co cdiv co cmul co cA cN cexp co cB cN cexp co cdiv co cA cc wcel cB
    cc wcel cB cc0 wne wa cN cn0 wcel w3a c1 cB cdiv co cN cexp co c1 cB cN
    cexp co cdiv co cA cN cexp co cmul cB cc wcel cB cc0 wne wa cN cn0 wcel c1
    cB cdiv co cN cexp co c1 cB cN cexp co cdiv co wceq cA cc wcel cB cc wcel
    cB cc0 wne cN cn0 wcel c1 cB cdiv co cN cexp co c1 cB cN cexp co cdiv co
    wceq cB cN exprec 3expa 3adant1 opreq2d cA cN cexp co cc wcel cB cN cexp co
    cc wcel cB cN cexp co cc0 wne cA cN cexp co cB cN cexp co cdiv co cA cN
    cexp co c1 cB cN cexp co cdiv co cmul co wceq cA cc wcel cB cc wcel cB cc0
    wne wa cN cn0 wcel w3a cA cN cexp co cB cN cexp co divrec cA cc wcel cN cn0
    wcel cA cN cexp co cc wcel cB cc wcel cB cc0 wne wa cA cN expcl 3adant2 cB
    cc wcel cB cc0 wne wa cN cn0 wcel cB cN cexp co cc wcel cA cc wcel cB cc
    wcel cN cn0 wcel cB cN cexp co cc wcel cB cc0 wne cB cN expcl adantlr
    3adant1 cB cc wcel cB cc0 wne wa cN cn0 wcel cB cN cexp co cc0 wne cA cc
    wcel cB cc wcel cB cc0 wne cN cn0 wcel cB cN cexp co cc0 wne cB cN expne0i
    3expa 3adant1 syl3anc eqtr4d 3eqtrd $.
    $( [12-Mar-2009] $) $( [2-Aug-2006] $)

  $( Ordering relationship for exponentiation. $)
  expordi $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. NN0 ) /\
             ( 1 < A /\ M < N ) ) -> ( A ^ M ) < ( A ^ N ) ) $=
    cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cM cN clt wbr wa wa c1
    cA cM cexp co cmul co cA cN cM cmin co cexp co cA cM cexp co cmul co cA cM
    cexp co cA cN cexp co clt cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt
    wbr cM cN clt wbr wa wa c1 cA cN cM cmin co cexp co clt wbr c1 cA cM cexp
    co cmul co cA cN cM cmin co cexp co cA cM cexp co cmul co clt wbr cA cr
    wcel cN cM cmin co cn wcel c1 cA clt wbr c1 cA cN cM cmin co cexp co clt
    wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cM cN clt wbr wa
    wa cA cN cM cmin co expgt1 cA cr wcel cM cn0 wcel cN cn0 wcel c1 cA clt wbr
    cM cN clt wbr wa 3simpl1 cA cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt
    wbr cN cM cmin co cn wcel c1 cA clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a cM cN clt wbr cN cM cmin co cn wcel cM cn0 wcel cN cn0 wcel cM cN clt
    wbr cN cM cmin co cn wcel wb cA cr wcel cM cz wcel cN cz wcel cM cN clt wbr
    cN cM cmin co cn wcel wb cM cn0 wcel cN cn0 wcel cM cN znnsub cM nn0z cN
    nn0z syl2an 3adant1 biimpa adantrl cA cr wcel cM cn0 wcel cN cn0 wcel w3a
    c1 cA clt wbr cM cN clt wbr simprl syl3anc cA cN cM cmin co cexp co cr wcel
    cA cM cexp co cr wcel cc0 cA cM cexp co clt wbr wa c1 cA cN cM cmin co cexp
    co clt wbr c1 cA cM cexp co cmul co cA cN cM cmin co cexp co cA cM cexp co
    cmul co clt wbr wb cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cM
    cN clt wbr wa wa c1 cr wcel cA cN cM cmin co cexp co cr wcel cA cM cexp co
    cr wcel cc0 cA cM cexp co clt wbr wa c1 cA cN cM cmin co cexp co clt wbr c1
    cA cM cexp co cmul co cA cN cM cmin co cexp co cA cM cexp co cmul co clt
    wbr wb 1re c1 cA cN cM cmin co cexp co cA cM cexp co ltmul1 mp3an1 cA cr
    wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt wbr cA cN cM cmin co cexp co cr
    wcel c1 cA clt wbr cA cr wcel cN cM cmin co cn0 wcel cA cN cM cmin co cexp
    co cr wcel cA cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt wbr wa cA cN cM
    cmin co reexpcl cA cr wcel cM cn0 wcel cN cn0 wcel cM cN clt wbr 3simpl1 cA
    cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt wbr wa cN cM cmin co cn wcel
    cN cM cmin co cn0 wcel cA cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt wbr
    cN cM cmin co cn wcel cM cn0 wcel cN cn0 wcel cM cN clt wbr cN cM cmin co
    cn wcel wb cA cr wcel cM cz wcel cN cz wcel cM cN clt wbr cN cM cmin co cn
    wcel wb cM cn0 wcel cN cn0 wcel cM cN znnsub cM nn0z cN nn0z syl2an 3adant1
    biimpa cN cM cmin co nnnn0 syl sylanc adantrl cA cr wcel cM cn0 wcel cN cn0
    wcel w3a c1 cA clt wbr cM cN clt wbr wa wa cA cM cexp co cr wcel cc0 cA cM
    cexp co clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cM cexp co cr
    wcel c1 cA clt wbr cM cN clt wbr wa cA cr wcel cM cn0 wcel cA cM cexp co cr
    wcel cN cn0 wcel cA cM reexpcl 3adant3 adantr cA cr wcel cM cn0 wcel cN cn0
    wcel w3a c1 cA clt wbr cc0 cA cM cexp co clt wbr cM cN clt wbr cA cr wcel
    cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cc0 cA cM cexp co clt wbr cA cr
    wcel cM cn0 wcel c1 cA clt wbr cc0 cA cM cexp co clt wbr wi cN cn0 wcel cA
    cr wcel cM cn0 wcel wa c1 cA clt wbr cc0 cA clt wbr cc0 cA cM cexp co clt
    wbr cA cr wcel c1 cA clt wbr cc0 cA clt wbr wi cM cn0 wcel cA cr wcel cc0
    c1 clt wbr c1 cA clt wbr cc0 cA clt wbr lt01 cc0 cr wcel c1 cr wcel cA cr
    wcel cc0 c1 clt wbr c1 cA clt wbr wa cc0 cA clt wbr wi 0re 1re cc0 c1 cA
    axlttrn mp3an12 mpani adantr cA cr wcel cM cn0 wcel cc0 cA clt wbr cc0 cA
    cM cexp co clt wbr cA cM expgt0 3expia syld 3adant3 imp adantrr jca sylanc
    mpbid cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA cM cexp co cmul co cA cM
    cexp co wceq c1 cA clt wbr cM cN clt wbr wa cA cr wcel cM cn0 wcel c1 cA cM
    cexp co cmul co cA cM cexp co wceq cN cn0 wcel cA cr wcel cM cn0 wcel wa cA
    cM cexp co cc wcel c1 cA cM cexp co cmul co cA cM cexp co wceq cA cc wcel
    cM cn0 wcel cA cM cexp co cc wcel cA cr wcel cA cM expcl cA recn sylan cA
    cM cexp co mulid2 syl 3adant3 adantr cA cr wcel cM cn0 wcel cN cn0 wcel w3a
    c1 cA clt wbr cM cN clt wbr wa wa cA cN cM cmin co cM caddc co cexp co cA
    cN cM cmin co cexp co cA cM cexp co cmul co cA cN cexp co cA cr wcel cM cn0
    wcel cN cn0 wcel w3a c1 cA clt wbr cM cN clt wbr wa wa cA cc wcel cN cM
    cmin co cn wcel cM cn0 wcel w3a cA cN cM cmin co cM caddc co cexp co cA cN
    cM cmin co cexp co cA cM cexp co cmul co wceq cA cr wcel cM cn0 wcel cN cn0
    wcel w3a cM cN clt wbr cA cc wcel cN cM cmin co cn wcel cM cn0 wcel w3a c1
    cA clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt wbr wa cA cc
    wcel cN cM cmin co cn wcel cM cn0 wcel cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a cA cc wcel cM cN clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cA
    cr wcel cM cn0 wcel cN cn0 wcel 3simp1 recnd adantr cA cr wcel cM cn0 wcel
    cN cn0 wcel w3a cM cN clt wbr cN cM cmin co cn wcel cM cn0 wcel cN cn0 wcel
    cM cN clt wbr cN cM cmin co cn wcel wb cA cr wcel cM cz wcel cN cz wcel cM
    cN clt wbr cN cM cmin co cn wcel wb cM cn0 wcel cN cn0 wcel cM cN znnsub cM
    nn0z cN nn0z syl2an 3adant1 biimpa cA cr wcel cM cn0 wcel cN cn0 wcel cM cN
    clt wbr 3simpl2 3jca adantrl cA cc wcel cN cM cmin co cn0 wcel cM cn0 wcel
    cA cN cM cmin co cM caddc co cexp co cA cN cM cmin co cexp co cA cM cexp co
    cmul co wceq cN cM cmin co cn wcel cA cN cM cmin co cM expadd cN cM cmin co
    nnnn0 syl3an2 syl cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cN cM cmin co
    cM caddc co cexp co cA cN cexp co wceq c1 cA clt wbr cM cN clt wbr wa cA cr
    wcel cM cn0 wcel cN cn0 wcel w3a cN cM cmin co cM caddc co cN cA cexp cM
    cn0 wcel cN cn0 wcel cN cM cmin co cM caddc co cN wceq cA cr wcel cN cn0
    wcel cM cn0 wcel cN cM cmin co cM caddc co cN wceq cN cc wcel cM cc wcel cN
    cM cmin co cM caddc co cN wceq cN cn0 wcel cM cn0 wcel cN cM npcan cN nn0cn
    cM nn0cn syl2an ancoms 3adant1 opreq2d adantr eqtr3d 3brtr3d $.
    $( [6-Oct-2006] $) $( [2-Aug-2006] $)

  $( Cancellation law for exponentiation. $)
  expcan $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. NN0 ) /\
             1 < A ) -> ( ( A ^ M ) = ( A ^ N ) <-> M = N ) ) $=
    cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr wa cA cM cexp co cA cN
    cexp co wceq cM cN wceq cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt
    wbr wa cM cN cA cM cexp co cA cN cexp co cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a c1 cA clt wbr wa cM cN clt wbr cN cM clt wbr wo cA cM cexp co cA cN
    cexp co clt wbr cA cN cexp co cA cM cexp co clt wbr wo cM cN wne cA cM cexp
    co cA cN cexp co wne cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr
    wa cM cN clt wbr cA cM cexp co cA cN cexp co clt wbr cN cM clt wbr cA cN
    cexp co cA cM cexp co clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA
    clt wbr cM cN clt wbr cA cM cexp co cA cN cexp co clt wbr wi cA cr wcel cM
    cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cM cN clt wbr cA cM cexp co cA cN
    cexp co clt wbr cA cM cN expordi exp32 imp cA cr wcel cM cn0 wcel cN cn0
    wcel w3a c1 cA clt wbr cN cM clt wbr cA cN cexp co cA cM cexp co clt wbr wi
    cA cr wcel cN cn0 wcel cM cn0 wcel c1 cA clt wbr cN cM clt wbr cA cN cexp
    co cA cM cexp co clt wbr wi wi cA cr wcel cN cn0 wcel cM cn0 wcel w3a c1 cA
    clt wbr cN cM clt wbr cA cN cexp co cA cM cexp co clt wbr cA cN cM expordi
    exp32 3com23 imp orim12d cA cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN wne
    cM cN clt wbr cN cM clt wbr wo wb c1 cA clt wbr cM cn0 wcel cN cn0 wcel cM
    cN wne cM cN clt wbr cN cM clt wbr wo wb cA cr wcel cM cr wcel cN cr wcel
    cM cN wne cM cN clt wbr cN cM clt wbr wo wb cM cn0 wcel cN cn0 wcel cM cN
    lttri2 cM nn0re cN nn0re syl2an 3adant1 adantr cA cr wcel cM cn0 wcel cN
    cn0 wcel w3a cA cM cexp co cA cN cexp co wne cA cM cexp co cA cN cexp co
    clt wbr cA cN cexp co cA cM cexp co clt wbr wo wb c1 cA clt wbr cA cr wcel
    cM cn0 wcel cN cn0 wcel cA cM cexp co cA cN cexp co wne cA cM cexp co cA cN
    cexp co clt wbr cA cN cexp co cA cM cexp co clt wbr wo wb cA cM cexp co cr
    wcel cA cN cexp co cr wcel cA cM cexp co cA cN cexp co wne cA cM cexp co cA
    cN cexp co clt wbr cA cN cexp co cA cM cexp co clt wbr wo wb cA cr wcel cM
    cn0 wcel wa cA cr wcel cN cn0 wcel wa cA cM cexp co cA cN cexp co lttri2 cA
    cM reexpcl cA cN reexpcl syl2an 3impdi adantr 3imtr4d necon4d cM cN cA cexp
    opreq2 impbid1 $.
    $( [8-Oct-2006] $) $( [2-Aug-2006] $)

  $( Ordering law for exponentiation. $)
  expord $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. NN0 ) /\
             1 < A ) -> ( M < N <-> ( A ^ M ) < ( A ^ N ) ) ) $=
    cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr wa cM cN clt wbr cA cM
    cexp co cA cN cexp co clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA
    clt wbr cM cN clt wbr cA cM cexp co cA cN cexp co clt wbr wi cA cr wcel cM
    cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cM cN clt wbr cA cM cexp co cA cN
    cexp co clt wbr cA cM cN expordi exp32 imp cA cr wcel cM cn0 wcel cN cn0
    wcel w3a c1 cA clt wbr wa cA cM cexp co cA cN cexp co wceq cA cN cexp co cA
    cM cexp co clt wbr wo wn cM cN wceq cN cM clt wbr wo wn cA cM cexp co cA cN
    cexp co clt wbr cM cN clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA
    clt wbr wa cM cN wceq cN cM clt wbr wo cA cM cexp co cA cN cexp co wceq cA
    cN cexp co cA cM cexp co clt wbr wo cA cr wcel cM cn0 wcel cN cn0 wcel w3a
    c1 cA clt wbr wa cM cN wceq cA cM cexp co cA cN cexp co wceq cN cM clt wbr
    cA cN cexp co cA cM cexp co clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a
    c1 cA clt wbr wa cA cM cexp co cA cN cexp co wceq cM cN wceq cA cM cN
    expcan biimprd cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cN cM
    clt wbr cA cN cexp co cA cM cexp co clt wbr wi cA cr wcel cN cn0 wcel cM
    cn0 wcel c1 cA clt wbr cN cM clt wbr cA cN cexp co cA cM cexp co clt wbr wi
    wi cA cr wcel cN cn0 wcel cM cn0 wcel w3a c1 cA clt wbr cN cM clt wbr cA cN
    cexp co cA cM cexp co clt wbr cA cN cM expordi exp32 3com23 imp orim12d
    con3d cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cM cexp co cA cN cexp co
    clt wbr cA cM cexp co cA cN cexp co wceq cA cN cexp co cA cM cexp co clt
    wbr wo wn wb c1 cA clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel cA cM cexp co
    cA cN cexp co clt wbr cA cM cexp co cA cN cexp co wceq cA cN cexp co cA cM
    cexp co clt wbr wo wn wb cA cM cexp co cr wcel cA cN cexp co cr wcel cA cM
    cexp co cA cN cexp co clt wbr cA cM cexp co cA cN cexp co wceq cA cN cexp
    co cA cM cexp co clt wbr wo wn wb cA cr wcel cM cn0 wcel wa cA cr wcel cN
    cn0 wcel wa cA cM cexp co cA cN cexp co axlttri cA cM reexpcl cA cN reexpcl
    syl2an 3impdi adantr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cM cN clt wbr
    cM cN wceq cN cM clt wbr wo wn wb c1 cA clt wbr cM cn0 wcel cN cn0 wcel cM
    cN clt wbr cM cN wceq cN cM clt wbr wo wn wb cA cr wcel cM cr wcel cN cr
    wcel cM cN clt wbr cM cN wceq cN cM clt wbr wo wn wb cM cn0 wcel cN cn0
    wcel cM cN axlttri cM nn0re cN nn0re syl2an 3adant1 adantr 3imtr4d impbid
    $.
    $( [9-Oct-2006] $) $( [2-Aug-2006] $)

  $( Weak ordering relationship for exponentiation. $)
  expwordi $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. NN0 ) /\
             ( 1 <_ A /\ M <_ N ) ) -> ( A ^ M ) <_ ( A ^ N ) ) $=
    cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA cle wbr cM cN cle wbr cA cM
    cexp co cA cN cexp co cle wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA
    cle wbr c1 cA clt wbr c1 cA wceq wo cM cN cle wbr cA cM cexp co cA cN cexp
    co cle wbr wi cA cr wcel cM cn0 wcel c1 cA cle wbr c1 cA clt wbr c1 cA wceq
    wo wb cN cn0 wcel c1 cr wcel cA cr wcel c1 cA cle wbr c1 cA clt wbr c1 cA
    wceq wo wb 1re c1 cA leloe mpan 3ad2ant1 cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a c1 cA clt wbr cM cN cle wbr cA cM cexp co cA cN cexp co cle wbr wi c1
    cA wceq cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr cM cN cle wbr
    cA cM cexp co cA cN cexp co cle wbr wi cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a c1 cA clt wbr wa cM cN clt wbr cM cN wceq wo cA cM cexp co cA cN cexp
    co clt wbr cA cM cexp co cA cN cexp co wceq wo cM cN cle wbr cA cM cexp co
    cA cN cexp co cle wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr
    wa cM cN clt wbr cA cM cexp co cA cN cexp co clt wbr cM cN wceq cA cM cexp
    co cA cN cexp co wceq cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA clt wbr
    wa cM cN clt wbr cA cM cexp co cA cN cexp co clt wbr cA cM cN expord biimpd
    cM cN wceq cA cM cexp co cA cN cexp co wceq wi cA cr wcel cM cn0 wcel cN
    cn0 wcel w3a c1 cA clt wbr wa cM cN cA cexp opreq2 a1i orim12d cA cr wcel
    cM cn0 wcel cN cn0 wcel w3a cM cN cle wbr cM cN clt wbr cM cN wceq wo wb c1
    cA clt wbr cM cn0 wcel cN cn0 wcel cM cN cle wbr cM cN clt wbr cM cN wceq
    wo wb cA cr wcel cM cr wcel cN cr wcel cM cN cle wbr cM cN clt wbr cM cN
    wceq wo wb cM cn0 wcel cN cn0 wcel cM cN leloe cM nn0re cN nn0re syl2an
    3adant1 adantr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cM cexp co cA cN
    cexp co cle wbr cA cM cexp co cA cN cexp co clt wbr cA cM cexp co cA cN
    cexp co wceq wo wb c1 cA clt wbr cA cM cexp co cr wcel cA cN cexp co cr
    wcel cA cM cexp co cA cN cexp co cle wbr cA cM cexp co cA cN cexp co clt
    wbr cA cM cexp co cA cN cexp co wceq wo wb cA cr wcel cM cn0 wcel cN cn0
    wcel w3a cA cM cexp co cA cN cexp co leloe cA cr wcel cM cn0 wcel cA cM
    cexp co cr wcel cN cn0 wcel cA cM reexpcl 3adant3 cA cr wcel cN cn0 wcel cA
    cN cexp co cr wcel cM cn0 wcel cA cN reexpcl 3adant2 sylanc adantr 3imtr4d
    ex cA cr wcel cM cn0 wcel cN cn0 wcel w3a c1 cA wceq cA cM cexp co cA cN
    cexp co cle wbr cM cN cle wbr cM cn0 wcel cN cn0 wcel c1 cA wceq cA cM cexp
    co cA cN cexp co cle wbr wi cA cr wcel c1 cA wceq c1 cM cexp co c1 cN cexp
    co cle wbr cA cM cexp co cA cN cexp co cle wbr cM cn0 wcel cN cn0 wcel wa
    c1 cA wceq c1 cM cexp co cA cM cexp co c1 cN cexp co cA cN cexp co cle c1
    cA cM cexp opreq1 c1 cA cN cexp opreq1 breq12d cM cn0 wcel cN cn0 wcel wa
    c1 cM cexp co c1 cN cexp co cle wbr c1 c1 cle wbr c1 1re leidi cM cn0 wcel
    cN cn0 wcel c1 cM cexp co c1 c1 cN cexp co c1 cle cM 1exp cN 1exp breqan12d
    mpbiri syl5cbi 3adant1 a1dd jaod sylbid imp32 $.
    $( [9-Oct-2006] $) $( [14-Dec-2005] $)

  $( The power of a positive number smaller than 1 decreases as its exponent
     increases. $)
  expord2 $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. NN0 ) /\
             ( 0 < A /\ A < 1 ) ) -> ( M < N <-> ( A ^ N ) < ( A ^ M ) ) ) $=
    cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cA c1 clt wbr wa wa
    cM cN clt wbr c1 cA cdiv co cM cexp co c1 cA cdiv co cN cexp co clt wbr cA
    cN cexp co cA cM cexp co clt wbr c1 cA cdiv co cr wcel cM cn0 wcel cN cn0
    wcel w3a c1 c1 cA cdiv co clt wbr cM cN clt wbr c1 cA cdiv co cM cexp co c1
    cA cdiv co cN cexp co clt wbr wb cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0
    cA clt wbr cA c1 clt wbr wa wa c1 cA cdiv co cM cN expord cA cr wcel cM cn0
    wcel cN cn0 wcel w3a cc0 cA clt wbr c1 cA cdiv co cr wcel cM cn0 wcel cN
    cn0 wcel w3a cA c1 clt wbr cc0 cA clt wbr cA cr wcel cM cn0 wcel cN cn0
    wcel w3a c1 cA cdiv co cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr
    cA cr wcel c1 cA cdiv co cr wcel cM cn0 wcel cM cn0 wcel cN cn0 wcel cN cn0
    wcel cA cr wcel cc0 cA clt wbr c1 cA cdiv co cr wcel cA cr wcel cc0 cA clt
    wbr cA cc0 wne c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan expcom cc0
    cA clt wbr cM cn0 wcel idd cc0 cA clt wbr cN cn0 wcel idd 3anim123d impcom
    adantrr cA cr wcel cM cn0 wcel cc0 cA clt wbr cA c1 clt wbr wa c1 c1 cA
    cdiv co clt wbr cN cn0 wcel cA cr wcel cc0 cA clt wbr cA c1 clt wbr c1 c1
    cA cdiv co clt wbr cA cr wcel cc0 cA clt wbr wa cA c1 clt wbr c1 c1 cA cdiv
    co clt wbr cA reclt1 biimpa anasss 3ad2antl1 sylanc cA cr wcel cM cn0 wcel
    cN cn0 wcel w3a cc0 cA clt wbr cA cN cexp co cA cM cexp co clt wbr c1 cA
    cdiv co cM cexp co c1 cA cdiv co cN cexp co clt wbr wb cA c1 clt wbr cA cr
    wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr wa cA cN cexp co cA cM cexp
    co clt wbr c1 cA cM cexp co cdiv co c1 cA cN cexp co cdiv co clt wbr c1 cA
    cdiv co cM cexp co c1 cA cdiv co cN cexp co clt wbr cA cN cexp co cr wcel
    cc0 cA cN cexp co clt wbr cA cM cexp co cr wcel cc0 cA cM cexp co clt wbr
    cA cN cexp co cA cM cexp co clt wbr c1 cA cM cexp co cdiv co c1 cA cN cexp
    co cdiv co clt wbr wb cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr
    wa cA cN cexp co cA cM cexp co ltrec cA cr wcel cN cn0 wcel cc0 cA clt wbr
    cA cN cexp co cr wcel cM cn0 wcel cA cr wcel cN cn0 wcel wa cA cN cexp co
    cr wcel cc0 cA clt wbr cA cN reexpcl adantr 3adantl2 cA cr wcel cN cn0 wcel
    cc0 cA clt wbr cc0 cA cN cexp co clt wbr cM cn0 wcel cA cr wcel cN cn0 wcel
    cc0 cA clt wbr cc0 cA cN cexp co clt wbr cA cN expgt0 3expa 3adantl2 cA cr
    wcel cM cn0 wcel cc0 cA clt wbr cA cM cexp co cr wcel cN cn0 wcel cA cr
    wcel cM cn0 wcel wa cA cM cexp co cr wcel cc0 cA clt wbr cA cM reexpcl
    adantr 3adantl3 cA cr wcel cM cn0 wcel cc0 cA clt wbr cc0 cA cM cexp co clt
    wbr cN cn0 wcel cA cr wcel cM cn0 wcel cc0 cA clt wbr cc0 cA cM cexp co clt
    wbr cA cM expgt0 3expa 3adantl3 syl2anc cA cc wcel cM cn0 wcel cN cn0 wcel
    w3a cA cc0 wne c1 cA cdiv co cM cexp co c1 cA cdiv co cN cexp co clt wbr c1
    cA cM cexp co cdiv co c1 cA cN cexp co cdiv co clt wbr wb cA cr wcel cM cn0
    wcel cN cn0 wcel w3a cc0 cA clt wbr wa cA cc wcel cM cn0 wcel cN cn0 wcel
    w3a cA cc0 wne wa c1 cA cdiv co cM cexp co c1 cA cM cexp co cdiv co c1 cA
    cdiv co cN cexp co c1 cA cN cexp co cdiv co clt cA cc wcel cM cn0 wcel cA
    cc0 wne c1 cA cdiv co cM cexp co c1 cA cM cexp co cdiv co wceq cN cn0 wcel
    cA cc wcel cM cn0 wcel cA cc0 wne c1 cA cdiv co cM cexp co c1 cA cM cexp co
    cdiv co wceq cA cM exprecOLD 3expa 3adantl3 cA cc wcel cN cn0 wcel cA cc0
    wne c1 cA cdiv co cN cexp co c1 cA cN cexp co cdiv co wceq cM cn0 wcel cA
    cc wcel cN cn0 wcel cA cc0 wne c1 cA cdiv co cN cexp co c1 cA cN cexp co
    cdiv co wceq cA cN exprecOLD 3expa 3adantl2 breq12d cA cr wcel cM cn0 wcel
    cN cn0 wcel w3a cA cc wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cA cr
    wcel cA cc wcel cM cn0 wcel cM cn0 wcel cN cn0 wcel cN cn0 wcel cA recn cM
    cn0 wcel id cN cn0 wcel id 3anim123i adantr cA cr wcel cM cn0 wcel cc0 cA
    clt wbr cA cc0 wne cN cn0 wcel cA gt0ne0 3ad2antl1 sylanc bitr4d adantrr
    bitr4d $.
    $( [10-Jul-2007] $) $( [2-Aug-2006] $)

  $( Weak ordering relationship for exponentiation.   (Contributed by Paul
     Chapman, 14-Jan-2008.) $)
  expword2i $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. NN0 ) /\
                       ( 0 < A /\ A <_ 1 /\ M < N ) ) ->
                     ( A ^ N ) <_ ( A ^ M ) ) $=
    cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cA c1 cle wbr wa cM
    cN clt wbr wa cA cN cexp co cA cM cexp co cle wbr cc0 cA clt wbr cA c1 cle
    wbr cM cN clt wbr w3a cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr
    cA c1 cle wbr wa cM cN clt wbr wa cA cN cexp co cA cM cexp co cle wbr cA cr
    wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cA c1 cle wbr wa cM cN clt
    wbr cA cN cexp co cA cM cexp co cle wbr cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a cc0 cA clt wbr cA c1 cle wbr cM cN clt wbr cA cN cexp co cA cM cexp co
    cle wbr wi cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cM cN clt
    wbr cA c1 cle wbr cA cN cexp co cA cM cexp co cle wbr cA cr wcel cM cn0
    wcel cN cn0 wcel w3a cc0 cA clt wbr cM cN clt wbr cA c1 cle wbr cA cN cexp
    co cA cM cexp co cle wbr wi cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA
    clt wbr cM cN clt wbr wa cA c1 cle wbr cA cN cexp co cA cM cexp co cle wbr
    wi cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cM cN clt wbr wa
    wa cA c1 clt wbr cA c1 wceq wo cA cN cexp co cA cM cexp co clt wbr cA cN
    cexp co cA cM cexp co wceq wo cA c1 cle wbr cA cN cexp co cA cM cexp co cle
    wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cM cN clt wbr wa
    wa cA c1 clt wbr cA cN cexp co cA cM cexp co clt wbr cA c1 wceq cA cN cexp
    co cA cM cexp co wceq cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr
    cM cN clt wbr wa cA c1 clt wbr cA cN cexp co cA cM cexp co clt wbr wi cA cr
    wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cM cN clt wbr cA c1 clt wbr
    cA cN cexp co cA cM cexp co clt wbr wi cA cr wcel cM cn0 wcel cN cn0 wcel
    w3a cc0 cA clt wbr cA c1 clt wbr cM cN clt wbr cA cN cexp co cA cM cexp co
    clt wbr cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt wbr cA c1 clt wbr
    cM cN clt wbr cA cN cexp co cA cM cexp co clt wbr wi cA cr wcel cM cn0 wcel
    cN cn0 wcel w3a cc0 cA clt wbr cA c1 clt wbr wa cM cN clt wbr cA cN cexp co
    cA cM cexp co clt wbr wi cA cr wcel cM cn0 wcel cN cn0 wcel w3a cc0 cA clt
    wbr cA c1 clt wbr wa wa cM cN clt wbr cA cN cexp co cA cM cexp co clt wbr
    cA cM cN expord2 biimpd ex exp3a com34 imp3a imp cA cr wcel cM cn0 wcel cN
    cn0 wcel w3a cA c1 wceq cA cN cexp co cA cM cexp co wceq wi cc0 cA clt wbr
    cM cN clt wbr wa cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA c1 wceq cA cN
    cexp co cA cM cexp co wceq cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA c1
    wceq wa c1 cM cexp co c1 cN cexp co cA cM cexp co cA cN cexp co cA cr wcel
    cM cn0 wcel cN cn0 wcel w3a c1 cM cexp co c1 cN cexp co wceq cA c1 wceq cM
    cn0 wcel cN cn0 wcel c1 cM cexp co c1 cN cexp co wceq cA cr wcel cM cn0
    wcel cN cn0 wcel wa c1 cM cexp co c1 c1 cN cexp co cM cn0 wcel c1 cM cexp
    co c1 wceq cN cn0 wcel cM 1exp adantr cN cn0 wcel c1 cN cexp co c1 wceq cM
    cn0 wcel cN 1exp adantl eqtr4d 3adant1 adantr cA c1 wceq cA cM cexp co c1
    cM cexp co wceq cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA c1 cM cexp opreq1
    adantl cA c1 wceq cA cN cexp co c1 cN cexp co wceq cA cr wcel cM cn0 wcel
    cN cn0 wcel w3a cA c1 cN cexp opreq1 adantl 3eqtr4rd ex adantr orim12d cA
    cr wcel cM cn0 wcel cN cn0 wcel w3a cA c1 cle wbr cA c1 clt wbr cA c1 wceq
    wo wb cc0 cA clt wbr cM cN clt wbr wa cA cr wcel cM cn0 wcel cA c1 cle wbr
    cA c1 clt wbr cA c1 wceq wo wb cN cn0 wcel cA cr wcel c1 cr wcel cA c1 cle
    wbr cA c1 clt wbr cA c1 wceq wo wb 1re cA c1 leloe mpan2 3ad2ant1 adantr cA
    cr wcel cM cn0 wcel cN cn0 wcel w3a cA cN cexp co cA cM cexp co cle wbr cA
    cN cexp co cA cM cexp co clt wbr cA cN cexp co cA cM cexp co wceq wo wb cc0
    cA clt wbr cM cN clt wbr wa cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cN
    cexp co cr wcel cA cM cexp co cr wcel wa cA cN cexp co cA cM cexp co cle
    wbr cA cN cexp co cA cM cexp co clt wbr cA cN cexp co cA cM cexp co wceq wo
    wb cA cr wcel cM cn0 wcel cN cn0 wcel w3a cA cN cexp co cr wcel cA cM cexp
    co cr wcel cA cr wcel cN cn0 wcel cA cN cexp co cr wcel cM cn0 wcel cA cN
    reexpcl 3adant2 cA cr wcel cM cn0 wcel cA cM cexp co cr wcel cN cn0 wcel cA
    cM reexpcl 3adant3 jca cA cN cexp co cA cM cexp co leloe syl adantr 3imtr4d
    ex exp3a com34 imp3a imp3a imp cc0 cA clt wbr cA c1 cle wbr cM cN clt wbr
    df-3an sylan2b $.
    $( [15-Jan-2008] $) $( [14-Jan-2008] $)

  ${
    $d j k A $.  $d j k B $.  $d j k N $.
    $( Weak mantissa ordering relationship for exponentiation. $)
    expmwordi $p |- ( ( ( A e. RR /\ B e. RR /\ N e. NN0 ) /\
               ( 0 <_ A /\ A <_ B ) ) -> ( A ^ N ) <_ ( B ^ N ) ) $=
      cA cr wcel cB cr wcel cN cn0 wcel cc0 cA cle wbr cA cB cle wbr wa cA cN
      cexp co cB cN cexp co cle wbr cN cn0 wcel cA cr wcel cB cr wcel cc0 cA
      cle wbr cA cB cle wbr wa cA cN cexp co cB cN cexp co cle wbr wi cN cn0
      wcel cA cr wcel cB cr wcel cc0 cA cle wbr cA cB cle wbr wa cA cN cexp co
      cB cN cexp co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle
      wbr wa wa cA vj cv cexp co cB vj cv cexp co cle wbr wi cA cr wcel cB cr
      wcel wa cc0 cA cle wbr cA cB cle wbr wa wa cA cc0 cexp co cB cc0 cexp co
      cle wbr wi cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa cA
      vk cv cexp co cB vk cv cexp co cle wbr wi cA cr wcel cB cr wcel wa cc0 cA
      cle wbr cA cB cle wbr wa wa cA vk cv c1 caddc co cexp co cB vk cv c1
      caddc co cexp co cle wbr wi cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB
      cle wbr wa wa cA cN cexp co cB cN cexp co cle wbr wi vj vk cN vk cv cn0
      wcel cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa cA vk cv
      cexp co cB vk cv cexp co cle wbr cA vk cv c1 caddc co cexp co cB vk cv c1
      caddc co cexp co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB
      cle wbr wa wa vk cv cn0 wcel cA vk cv cexp co cB vk cv cexp co cle wbr cA
      vk cv c1 caddc co cexp co cB vk cv c1 caddc co cexp co cle wbr wi cA cr
      wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa vk cv cn0 wcel wa
      cA vk cv cexp co cB vk cv cexp co cle wbr cA vk cv c1 caddc co cexp co cB
      vk cv c1 caddc co cexp co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr
      cA cB cle wbr wa wa vk cv cn0 wcel wa cA vk cv cexp co cB vk cv cexp co
      cle wbr wa cA vk cv cexp co cA cmul co cB vk cv cexp co cB cmul co cA vk
      cv c1 caddc co cexp co cB vk cv c1 caddc co cexp co cle cA vk cv cexp co
      cr wcel cB vk cv cexp co cr wcel wa cc0 cA vk cv cexp co cle wbr cA vk cv
      cexp co cB vk cv cexp co cle wbr wa wa cA cr wcel cB cr wcel wa cc0 cA
      cle wbr cA cB cle wbr wa wa cA vk cv cexp co cA cmul co cB vk cv cexp co
      cB cmul co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr
      wa wa vk cv cn0 wcel wa cA vk cv cexp co cB vk cv cexp co cle wbr wa cA
      vk cv cexp co cB vk cv cexp co cA cB lemul12aOLD cA cr wcel cB cr wcel wa
      cc0 cA cle wbr cA cB cle wbr wa wa vk cv cn0 wcel wa cA vk cv cexp co cB
      vk cv cexp co cle wbr wa cA vk cv cexp co cr wcel cB vk cv cexp co cr
      wcel cc0 cA vk cv cexp co cle wbr cA vk cv cexp co cB vk cv cexp co cle
      wbr wa cA cr wcel cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa vk cv
      cn0 wcel wa cA vk cv cexp co cr wcel cA vk cv cexp co cB vk cv cexp co
      cle wbr cA cr wcel cB cr wcel wa vk cv cn0 wcel cA vk cv cexp co cr wcel
      cc0 cA cle wbr cA cB cle wbr wa cA cr wcel vk cv cn0 wcel cA vk cv cexp
      co cr wcel cB cr wcel cA vk cv reexpcl adantlr adantlr adantr cA cr wcel
      cB cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa vk cv cn0 wcel wa cB vk
      cv cexp co cr wcel cA vk cv cexp co cB vk cv cexp co cle wbr cA cr wcel
      cB cr wcel wa vk cv cn0 wcel cB vk cv cexp co cr wcel cc0 cA cle wbr cA
      cB cle wbr wa cB cr wcel vk cv cn0 wcel cB vk cv cexp co cr wcel cA cr
      wcel cB vk cv reexpcl adantll adantlr adantr cA cr wcel cB cr wcel wa cc0
      cA cle wbr cA cB cle wbr wa wa vk cv cn0 wcel wa cc0 cA vk cv cexp co cle
      wbr cA vk cv cexp co cB vk cv cexp co cle wbr cA cr wcel cB cr wcel wa
      cc0 cA cle wbr vk cv cn0 wcel cc0 cA vk cv cexp co cle wbr cA cB cle wbr
      cA cr wcel cc0 cA cle wbr vk cv cn0 wcel cc0 cA vk cv cexp co cle wbr cB
      cr wcel cA cr wcel vk cv cn0 wcel cc0 cA cle wbr cc0 cA vk cv cexp co cle
      wbr cA cr wcel vk cv cn0 wcel cc0 cA cle wbr cc0 cA vk cv cexp co cle wbr
      cA vk cv expge0 3expa an1rs adantllr adantlrr anim1i jca31 cA cr wcel cB
      cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa vk cv cn0 wcel cA vk cv
      cexp co cB vk cv cexp co cle wbr simpll sylanc cA cr wcel cB cr wcel wa
      cc0 cA cle wbr cA cB cle wbr wa wa vk cv cn0 wcel wa cA vk cv c1 caddc co
      cexp co cA vk cv cexp co cA cmul co wceq cA vk cv cexp co cB vk cv cexp
      co cle wbr cA cr wcel cB cr wcel wa vk cv cn0 wcel cA vk cv c1 caddc co
      cexp co cA vk cv cexp co cA cmul co wceq cc0 cA cle wbr cA cB cle wbr wa
      cA cr wcel vk cv cn0 wcel cA vk cv c1 caddc co cexp co cA vk cv cexp co
      cA cmul co wceq cB cr wcel cA cc wcel vk cv cn0 wcel cA vk cv c1 caddc co
      cexp co cA vk cv cexp co cA cmul co wceq cA cr wcel cA vk cv expp1 cA
      recn sylan adantlr adantlr adantr cA cr wcel cB cr wcel wa cc0 cA cle wbr
      cA cB cle wbr wa wa vk cv cn0 wcel wa cB vk cv c1 caddc co cexp co cB vk
      cv cexp co cB cmul co wceq cA vk cv cexp co cB vk cv cexp co cle wbr cA
      cr wcel cB cr wcel wa vk cv cn0 wcel cB vk cv c1 caddc co cexp co cB vk
      cv cexp co cB cmul co wceq cc0 cA cle wbr cA cB cle wbr wa cB cr wcel vk
      cv cn0 wcel cB vk cv c1 caddc co cexp co cB vk cv cexp co cB cmul co wceq
      cA cr wcel cB cc wcel vk cv cn0 wcel cB vk cv c1 caddc co cexp co cB vk
      cv cexp co cB cmul co wceq cB cr wcel cB vk cv expp1 cB recn sylan
      adantll adantlr adantr 3brtr4d ex expcom a2d cA cr wcel cB cr wcel wa cA
      cc0 cexp co cB cc0 cexp co cle wbr cc0 cA cle wbr cA cB cle wbr wa cA cc
      wcel cB cc wcel cA cc0 cexp co cB cc0 cexp co cle wbr cA cr wcel cB cr
      wcel cA cc wcel cB cc wcel wa cA cc0 cexp co c1 cB cc0 cexp co cle cA cc
      wcel cB cc wcel wa cA cc0 cexp co c1 c1 cle cA cc wcel cA cc0 cexp co c1
      wceq cB cc wcel cA exp0 adantr c1 1re leidi syl6eqbr cB cc wcel cB cc0
      cexp co c1 wceq cA cc wcel cB exp0 adantl breqtrrd cA recn cB recn syl2an
      adantr vj cv cc0 wceq cA vj cv cexp co cB vj cv cexp co cle wbr cA cc0
      cexp co cB cc0 cexp co cle wbr cA cr wcel cB cr wcel wa cc0 cA cle wbr cA
      cB cle wbr wa wa vj cv cc0 wceq cA vj cv cexp co cA cc0 cexp co cB vj cv
      cexp co cB cc0 cexp co cle vj cv cc0 cA cexp opreq2 vj cv cc0 cB cexp
      opreq2 breq12d imbi2d vj cv vk cv wceq cA vj cv cexp co cB vj cv cexp co
      cle wbr cA vk cv cexp co cB vk cv cexp co cle wbr cA cr wcel cB cr wcel
      wa cc0 cA cle wbr cA cB cle wbr wa wa vj cv vk cv wceq cA vj cv cexp co
      cA vk cv cexp co cB vj cv cexp co cB vk cv cexp co cle vj cv vk cv cA
      cexp opreq2 vj cv vk cv cB cexp opreq2 breq12d imbi2d vj cv vk cv c1
      caddc co wceq cA vj cv cexp co cB vj cv cexp co cle wbr cA vk cv c1 caddc
      co cexp co cB vk cv c1 caddc co cexp co cle wbr cA cr wcel cB cr wcel wa
      cc0 cA cle wbr cA cB cle wbr wa wa vj cv vk cv c1 caddc co wceq cA vj cv
      cexp co cA vk cv c1 caddc co cexp co cB vj cv cexp co cB vk cv c1 caddc
      co cexp co cle vj cv vk cv c1 caddc co cA cexp opreq2 vj cv vk cv c1
      caddc co cB cexp opreq2 breq12d imbi2d vj cv cN wceq cA vj cv cexp co cB
      vj cv cexp co cle wbr cA cN cexp co cB cN cexp co cle wbr cA cr wcel cB
      cr wcel wa cc0 cA cle wbr cA cB cle wbr wa wa vj cv cN wceq cA vj cv cexp
      co cA cN cexp co cB vj cv cexp co cB cN cexp co cle vj cv cN cA cexp
      opreq2 vj cv cN cB cexp opreq2 breq12d imbi2d nn0indALT exp4c com3l 3imp1
      $.
      $( [24-Jan-2006] $) $( [18-Dec-2005] $)
  $}

  $( Nonnegative integer exponentiation with a mantissa between 0 and 1
     inclusive is less than or equal to 1.  (Contributed by Paul Chapman,
     29-Dec-2007.) $)
  exple1 $p |- ( ( ( A e. RR /\ 0 <_ A /\ A <_ 1 ) /\ N e. NN0 ) ->
                  ( A ^ N ) <_ 1 ) $=
    cA cr wcel cc0 cA cle wbr cA c1 cle wbr w3a cN cn0 wcel cA cN cexp co c1
    cle wbr cA cr wcel cc0 cA cle wbr cA c1 cle wbr cN cn0 wcel cA cN cexp co
    c1 cle wbr wi cA cr wcel cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cA c1
    cle wbr cN cn0 wcel cA cN cexp co c1 cle wbr wi wi cA cr wcel cc0 cA cle
    wbr cc0 cA clt wbr cc0 cA wceq wo cc0 cr wcel cA cr wcel cc0 cA cle wbr cc0
    cA clt wbr cc0 cA wceq wo wb 0re cc0 cA leloe mpan biimpa cA cr wcel cc0 cA
    clt wbr cA c1 cle wbr cN cn0 wcel cA cN cexp co c1 cle wbr wi wi cc0 cA
    wceq cA cr wcel cc0 cA clt wbr cA c1 cle wbr cN cn0 wcel cA cN cexp co c1
    cle wbr wi cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cN cn0 wcel cA cN
    cexp co c1 cle wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cN cn0 wcel
    wa cA cN cexp co c1 c1 cdiv co c1 cle cA cr wcel cc0 cA clt wbr cA c1 cle
    wbr w3a cN cn0 wcel wa c1 c1 cA cN cexp co cdiv co cle wbr cA cN cexp co c1
    c1 cdiv co cle wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cN cn0 wcel
    wa c1 c1 cA cdiv co cN cexp co c1 cA cN cexp co cdiv co cle c1 cA cdiv co
    cr wcel c1 c1 cA cdiv co cle wbr wa cN cn0 wcel c1 c1 cA cdiv co cN cexp co
    cle wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a c1 cA cdiv co cr wcel
    c1 c1 cA cdiv co cle wbr cN cn0 wcel c1 c1 cA cdiv co cN cexp co cle wbr c1
    cA cdiv co cr wcel cN cn0 wcel c1 c1 cA cdiv co cle wbr c1 c1 cA cdiv co cN
    cexp co cle wbr c1 cA cdiv co cN expge1 3com23 3expa cA cr wcel cc0 cA clt
    wbr cA c1 cle wbr w3a c1 cA cdiv co cr wcel c1 c1 cA cdiv co cle wbr cA cr
    wcel cA cc0 wne c1 cA cdiv co cr wcel cA cr wcel cc0 cA clt wbr cA c1 cle
    wbr w3a cA rereccl cA cr wcel cc0 cA clt wbr cA c1 cle wbr 3simp1 cA cr
    wcel cc0 cA clt wbr cA cc0 wne cA c1 cle wbr cA gt0ne0 3adant3 sylanc cA cr
    wcel cc0 cA clt wbr cA c1 cle wbr w3a c1 c1 cA cdiv co cle wbr cA c1 cle
    wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr 3simp3 cA cr wcel cc0 cA clt
    wbr cA c1 cle wbr w3a c1 c1 cA cdiv co cle wbr cA c1 c1 cdiv co cle wbr cA
    c1 cle wbr cA cr wcel cc0 cA clt wbr c1 c1 cA cdiv co cle wbr cA c1 c1 cdiv
    co cle wbr wb cA c1 cle wbr c1 cr wcel cc0 c1 clt wbr cA cr wcel cc0 cA clt
    wbr wa c1 c1 cA cdiv co cle wbr cA c1 c1 cdiv co cle wbr wb 1re lt01 c1 cA
    lerec2 mpanl12 3adant3 c1 c1 cdiv co c1 cA cle c1 ax1cn div1i breq2i syl6bb
    mpbird jca sylan cA cc wcel cA cc0 wne wa cN cn0 wcel c1 cA cdiv co cN cexp
    co c1 cA cN cexp co cdiv co wceq cA cr wcel cc0 cA clt wbr cA c1 cle wbr
    w3a cA cc wcel cA cc0 wne cN cn0 wcel c1 cA cdiv co cN cexp co c1 cA cN
    cexp co cdiv co wceq cA cc wcel cN cn0 wcel cA cc0 wne c1 cA cdiv co cN
    cexp co c1 cA cN cexp co cdiv co wceq cA cN exprecOLD 3com23 3expa cA cr
    wcel cc0 cA clt wbr cA c1 cle wbr w3a cA cc wcel cA cc0 wne cA cr wcel cc0
    cA clt wbr cA c1 cle wbr w3a cA cA cr wcel cc0 cA clt wbr cA c1 cle wbr
    3simp1 recnd cA cr wcel cc0 cA clt wbr cA cc0 wne cA c1 cle wbr cA gt0ne0
    3adant3 jca sylan breqtrd cA cN cexp co cr wcel cc0 cA cN cexp co clt wbr
    c1 c1 cA cN cexp co cdiv co cle wbr cA cN cexp co c1 c1 cdiv co cle wbr wb
    cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cN cn0 wcel wa c1 cr wcel cc0
    c1 clt wbr cA cN cexp co cr wcel cc0 cA cN cexp co clt wbr wa c1 c1 cA cN
    cexp co cdiv co cle wbr cA cN cexp co c1 c1 cdiv co cle wbr wb 1re lt01 c1
    cA cN cexp co lerec2 mpanl12 cA cr wcel cc0 cA clt wbr cN cn0 wcel cA cN
    cexp co cr wcel cA c1 cle wbr cA cN reexpcl 3ad2antl1 cA cr wcel cc0 cA clt
    wbr cN cn0 wcel cc0 cA cN cexp co clt wbr cA c1 cle wbr cA cr wcel cc0 cA
    clt wbr cN cn0 wcel cc0 cA cN cexp co clt wbr cA cr wcel cN cn0 wcel cc0 cA
    clt wbr cc0 cA cN cexp co clt wbr cA cN expgt0 3com23 3expa 3adantl3 sylanc
    mpbid c1 ax1cn div1i syl6breq ex 3expia cc0 cA wceq cA c1 cle wbr cN cn0
    wcel cA cN cexp co c1 cle wbr wi wi cA cr wcel cc0 cA wceq cN cn0 wcel cA
    cN cexp co c1 cle wbr wi cA c1 cle wbr cc0 cA wceq cc0 cN cexp co c1 cle
    wbr cA cN cexp co c1 cle wbr cN cn0 wcel cc0 cA wceq cc0 cN cexp co cA cN
    cexp co c1 cle cc0 cA cN cexp opreq1 breq1d cN cn0 wcel cN cn wcel cN cc0
    wceq wo cc0 cN cexp co c1 cle wbr cN elnn0 cN cn wcel cc0 cN cexp co c1 cle
    wbr cN cc0 wceq cN cn wcel cc0 cN cexp co cc0 c1 cle cN 0exp cc0 c1 0re 1re
    lt01 ltleii syl6eqbr cN cc0 wceq cc0 cN cexp co c1 c1 cle cN cc0 wceq cc0
    cN cexp co cc0 cc0 cexp co c1 cN cc0 cc0 cexp opreq2 cc0 cc wcel cc0 cc0
    cexp co c1 wceq 0cn cc0 exp0 ax-mp syl6eq c1 1re leidi syl6eqbr jaoi sylbi
    syl5bi a1d adantl jaodan syldan 3impia imp $.
    $( [30-Dec-2007] $) $( [29-Dec-2007] $)

  $( An upper bound on ` A ^ N ` when ` 2 <_ A ` . $)
  expubnd $p |- ( ( A e. RR /\ N e. NN0 /\ 2 <_ A ) ->
                  ( A ^ N ) <_ ( ( 2 ^ N ) x. ( ( A - 1 ) ^ N ) ) ) $=
    cA cr wcel cN cn0 wcel c2 cA cle wbr w3a cA cN cexp co c2 cA c1 cmin co
    cmul co cN cexp co c2 cN cexp co cA c1 cmin co cN cexp co cmul co cle cA cr
    wcel c2 cA c1 cmin co cmul co cr wcel cN cn0 wcel w3a cc0 cA cle wbr cA c2
    cA c1 cmin co cmul co cle wbr wa cA cN cexp co c2 cA c1 cmin co cmul co cN
    cexp co cle wbr cA cr wcel cN cn0 wcel c2 cA cle wbr w3a cA c2 cA c1 cmin
    co cmul co cN expmwordi cA cr wcel cN cn0 wcel c2 cA cle wbr w3a cA cr wcel
    c2 cA c1 cmin co cmul co cr wcel cN cn0 wcel cA cr wcel cN cn0 wcel c2 cA
    cle wbr 3simp1 cA cr wcel cN cn0 wcel c2 cA c1 cmin co cmul co cr wcel c2
    cA cle wbr c2 cr wcel cA c1 cmin co cr wcel c2 cA c1 cmin co cmul co cr
    wcel cA cr wcel c2 cA c1 cmin co remulcl 2re cA peano2rem sylancr 3ad2ant1
    cA cr wcel cN cn0 wcel c2 cA cle wbr 3simp2 3jca cA cr wcel c2 cA cle wbr
    cc0 cA cle wbr cA c2 cA c1 cmin co cmul co cle wbr wa cN cn0 wcel cA cr
    wcel c2 cA cle wbr wa cc0 cA cle wbr cA c2 cA c1 cmin co cmul co cle wbr cA
    cr wcel c2 cA cle wbr cc0 cA cle wbr cA cr wcel cc0 c2 cle wbr c2 cA cle
    wbr cc0 cA cle wbr cc0 c2 0re 2re 2pos ltleii cc0 cr wcel c2 cr wcel cA cr
    wcel cc0 c2 cle wbr c2 cA cle wbr wa cc0 cA cle wbr wi 0re 2re cc0 c2 cA
    letr mp3an12 mpani imp cA cr wcel c2 cA cle wbr wa cA c2 cmin co c2 caddc
    co cA c2 cmin co cA caddc co cA c2 cA c1 cmin co cmul co cle cA cr wcel c2
    cA cle wbr cA c2 cmin co c2 caddc co cA c2 cmin co cA caddc co cle wbr cA
    cr wcel cA c2 cmin co cr wcel c2 cA cle wbr cA c2 cmin co c2 caddc co cA c2
    cmin co cA caddc co cle wbr wb cA cr wcel c2 cr wcel cA c2 cmin co cr wcel
    2re cA c2 resubcl mpan2 c2 cr wcel cA cr wcel cA c2 cmin co cr wcel c2 cA
    cle wbr cA c2 cmin co c2 caddc co cA c2 cmin co cA caddc co cle wbr wb 2re
    c2 cA cA c2 cmin co leadd2 mp3an1 mpdan biimpa cA cr wcel cA c2 cmin co c2
    caddc co cA wceq c2 cA cle wbr cA cc wcel c2 cc wcel cA c2 cmin co c2 caddc
    co cA wceq cA cr wcel cA c2 npcan cA recn 2cn sylancl adantr cA cr wcel cA
    c2 cmin co cA caddc co c2 cA c1 cmin co cmul co wceq c2 cA cle wbr cA cr
    wcel cA cc wcel cA c2 cmin co cA caddc co c2 cA c1 cmin co cmul co wceq cA
    recn cA cc wcel c2 cA c1 cmin co cmul co c2 cA cmul co c2 c1 cmul co cmin
    co cA cA caddc co c2 cmin co cA c2 cmin co cA caddc co c2 cc wcel cA cc
    wcel c1 cc wcel c2 cA c1 cmin co cmul co c2 cA cmul co c2 c1 cmul co cmin
    co wceq 2cn ax1cn c2 cA c1 subdi mp3an13 cA cc wcel c2 cA cmul co cA cA
    caddc co c2 c1 cmul co c2 cmin cA 2times c2 c1 cmul co c2 wceq cA cc wcel
    c2 2cn mulid1i a1i opreq12d cA cc wcel cA cA caddc co c2 cmin co cA c2 cmin
    co cA caddc co wceq cA cc wcel cA cc wcel c2 cc wcel cA cA caddc co c2 cmin
    co cA c2 cmin co cA caddc co wceq 2cn cA cA c2 addsub mp3an3 anidms 3eqtrrd
    syl adantr 3brtr3d jca 3adant2 sylanc cA cr wcel cN cn0 wcel c2 cA c1 cmin
    co cmul co cN cexp co c2 cN cexp co cA c1 cmin co cN cexp co cmul co wceq
    c2 cA cle wbr cA c1 cmin co cc wcel cN cn0 wcel c2 cA c1 cmin co cmul co cN
    cexp co c2 cN cexp co cA c1 cmin co cN cexp co cmul co wceq cA cr wcel c2
    cc wcel cA c1 cmin co cc wcel cN cn0 wcel c2 cA c1 cmin co cmul co cN cexp
    co c2 cN cexp co cA c1 cmin co cN cexp co cmul co wceq 2cn c2 cA c1 cmin co
    cN mulexp mp3an1 cA cr wcel cA c1 cmin co cA peano2rem recnd sylan 3adant3
    breqtrd $.
    $( [24-Jan-2006] $) $( [19-Dec-2005] $)

  $( Value of the square of a complex number.  (Contributed by Raph Levien,
     10-Apr-2004.) $)
  sqval $p |- ( A e. CC -> ( A ^ 2 ) = ( A x. A ) ) $=
    cA cc wcel cA c2 cexp co cA c1 cexp co cA cmul co cA cA cmul co cA cc wcel
    cA c1 c1 caddc co cexp co cA c1 cexp co cA cmul co cA c2 cexp co cA cc wcel
    c1 cn0 wcel cA c1 c1 caddc co cexp co cA c1 cexp co cA cmul co wceq 1nn0 cA
    c1 expp1 mpan2 c2 c1 c1 caddc co cA cexp df-2 opreq2i syl5eq cA cc wcel cA
    c1 cexp co cA cA cmul cA exp1 opreq1d eqtrd $.
    $( [28-Jul-2006] $) $( [10-Apr-2004] $)

  $( The square of the negative of a number.) $)
  sqneg $p |- ( A e. CC -> ( -u A ^ 2 ) = ( A ^ 2 ) ) $=
    cA cc wcel cA cneg cA cneg cmul co cA cA cmul co cA cneg c2 cexp co cA c2
    cexp co cA cc wcel cA cneg cA cneg cmul co cA cA cmul co wceq cA cA mul2neg
    anidms cA cc wcel cA cneg cc wcel cA cneg c2 cexp co cA cneg cA cneg cmul
    co wceq cA negcl cA cneg sqval syl cA sqval 3eqtr4d $.
    $( [18-Feb-2007] $) $( [15-Jan-2006] $)

  $( Closure of square. $)
  sqcl $p |- ( A e. CC -> ( A ^ 2 ) e. CC ) $=
    cA cc wcel cA c2 cexp co cA cA cmul co cc cA sqval cA cc wcel cA cA cmul co
    cc wcel cA cA mulcl anidms eqeltrd $.
    $( [10-Aug-1999] $)

  $( Distribution of square over multiplication. $)
  sqmul $p |- ( ( A e. CC /\ B e. CC ) ->
             ( ( A x. B ) ^ 2 ) = ( ( A ^ 2 ) x. ( B ^ 2 ) ) ) $=
    cA cc wcel cB cc wcel c2 cn0 wcel cA cB cmul co c2 cexp co cA c2 cexp co cB
    c2 cexp co cmul co wceq 2nn0 cA cB c2 mulexp mp3an3 $.
    $( [23-Mar-2008] $) $( [21-Mar-2008] $)

  $( A number is zero iff its square is zero. $)
  sqeq0 $p |- ( A e. CC -> ( ( A ^ 2 ) = 0 <-> A = 0 ) ) $=
    cA cc wcel c2 cn wcel cA c2 cexp co cc0 wceq cA cc0 wceq wb 2nn cA c2
    expeq0 mpan2 $.
    $( [12-Apr-2006] $) $( [11-Mar-2006] $)

  ${
    sqval.1 $e |- A e. CC $.
    $( Value of square.  Inference version. $)
    sqvali $p |- ( A ^ 2 ) = ( A x. A ) $=
      cA cc wcel cA c2 cexp co cA cA cmul co wceq sqval.1 cA sqval ax-mp $.
      $( [1-Aug-1999] $)

    $( Closure of square. $)
    sqcli $p |- ( A ^ 2 ) e. CC $=
      cA cc wcel cA c2 cexp co cc wcel sqval.1 cA sqcl ax-mp $.
      $( [2-Aug-1999] $)

    $( A number is zero iff its square is zero. $)
    sqeq0i $p |- ( ( A ^ 2 ) = 0 <-> A = 0 ) $=
      cA cc wcel cA c2 cexp co cc0 wceq cA cc0 wceq wb sqval.1 cA sqeq0 ax-mp
      $.
      $( [2-Oct-1999] $)

    ${
      sqmul.2 $e |- B e. CC $.
      $( Distribution of square over multiplication. $)
      sqmuli $p |- ( ( A x. B ) ^ 2 ) = ( ( A ^ 2 ) x. ( B ^ 2 ) ) $=
        cA cc wcel cB cc wcel cA cB cmul co c2 cexp co cA c2 cexp co cB c2 cexp
        co cmul co wceq sqval.1 sqmul.2 cA cB sqmul mp2an $.
        $( [31-Jul-2006] $) $( [3-Sep-1999] $)

      ${
        sqdiv.3 $e |- B =/= 0 $.
        $( Distribution of square over division. $)
        sqdivi $p |- ( ( A / B ) ^ 2 ) = ( ( A ^ 2 ) / ( B ^ 2 ) ) $=
          cA cB cdiv co cA cB cdiv co cmul co cA cA cmul co cB cB cmul co cdiv
          co cA cB cdiv co c2 cexp co cA c2 cexp co cB c2 cexp co cdiv co cA cB
          cA cB sqval.1 sqmul.2 sqval.1 sqmul.2 sqdiv.3 sqdiv.3 divmuldivi cA
          cB cdiv co cA cB sqval.1 sqmul.2 sqdiv.3 divcli sqvali cA c2 cexp co
          cA cA cmul co cB c2 cexp co cB cB cmul co cdiv cA sqval.1 sqvali cB
          sqmul.2 sqvali opreq12i 3eqtr4i $.
          $( [20-Aug-2001] $)
      $}
    $}

    ${
      sqreci.1 $e |- A =/= 0 $.
      $( Square of reciprocal. $)
      sqrecii $p |- ( ( 1 / A ) ^ 2 ) = ( 1 / ( A ^ 2 ) ) $=
        c1 cA cdiv co c1 cA cdiv co cmul co c1 cA cA cmul co cdiv co c1 cA cdiv
        co c2 cexp co c1 cA c2 cexp co cdiv co c1 cA cdiv co c1 cA cdiv co cmul
        co c1 c1 cmul co cA cA cmul co cdiv co c1 cA cA cmul co cdiv co c1 cA
        c1 cA ax1cn sqval.1 ax1cn sqval.1 sqreci.1 sqreci.1 divmuldivi c1 c1
        cmul co c1 cA cA cmul co cdiv c1 ax1cn mulid1i opreq1i eqtri c1 cA cdiv
        co cA sqval.1 sqreci.1 reccli sqvali cA c2 cexp co cA cA cmul co c1
        cdiv cA sqval.1 sqvali opreq2i 3eqtr4i $.
        $( [17-Sep-1999] $)
    $}
  $}

  $( A number is nonzero iff its square is nonzero. $)
  sqne0 $p |- ( A e. CC -> ( ( A ^ 2 ) =/= 0 <-> A =/= 0 ) ) $=
    cA cc wcel cA c2 cexp co cc0 cA cc0 cA sqeq0 necon3bid $.
    $( [14-Apr-2006] $) $( [11-Mar-2006] $)

  $( Closure of the square of a real number. $)
  resqcl $p |- ( A e. RR -> ( A ^ 2 ) e. RR ) $=
    cA cr wcel c2 cn0 wcel cA c2 cexp co cr wcel 2nn0 cA c2 reexpcl mpan2 $.
    $( [29-Jul-2006] $) $( [18-Oct-1999] $)

  $( The square of a non-zero real is positive. $)
  sqgt0 $p |- ( ( A e. RR /\ A =/= 0 ) -> 0 < ( A ^ 2 ) ) $=
    cA cr wcel cA cc0 wne wa cc0 cA cA cmul co cA c2 cexp co clt cA msqgt0 cA
    cr wcel cA c2 cexp co cA cA cmul co wceq cA cc0 wne cA cr wcel cA cc wcel
    cA c2 cexp co cA cA cmul co wceq cA recn cA sqval syl adantr breqtrrd $.
    $( [8-Sep-2007] $) $( [8-Sep-2007] $)

  ${
    resqcl.1 $e |- A e. RR $.
    $( Closure of square in reals. $)
    resqcli $p |- ( A ^ 2 ) e. RR $=
      cA cr wcel cA c2 cexp co cr wcel resqcl.1 cA resqcl ax-mp $.
      $( [2-Aug-1999] $)

    ${
      lt2sq.2 $e |- B e. RR $.
      $( The square function on nonnegative reals is strictly monotonic. $)
      lt2sqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( A < B <-> ( A ^ 2 ) < ( B ^ 2 ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA cB clt wbr cA cA cmul co cB cB cmul
        co clt wbr cA c2 cexp co cB c2 cexp co clt wbr cA cB resqcl.1 lt2sq.2
        lt2msqi cA c2 cexp co cA cA cmul co cB c2 cexp co cB cB cmul co clt cA
        cA resqcl.1 recni sqvali cB cB lt2sq.2 recni sqvali breq12i syl6bbr $.
        $( [12-Sep-1999] $)

      $( The square function on nonnegative reals is monotonic. $)
      le2sqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( A <_ B <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA cB cle wbr cA cA cmul co cB cB cmul
        co cle wbr cA c2 cexp co cB c2 cexp co cle wbr cA cB resqcl.1 lt2sq.2
        le2msqi cA c2 cexp co cA cA cmul co cB c2 cexp co cB cB cmul co cle cA
        cA resqcl.1 recni sqvali cB cB lt2sq.2 recni sqvali breq12i syl6bbr $.
        $( [12-Sep-1999] $)

      $( The square function is one-to-one for nonnegative reals. $)
      sq11i $p |-  ( ( 0 <_ A /\ 0 <_ B ) ->
                ( ( A ^ 2 ) = ( B ^ 2 ) <-> A = B ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA cA cmul co cB cB cmul co wceq cA cB
        wceq cA c2 cexp co cB c2 cexp co wceq cA cB resqcl.1 lt2sq.2 msq11i cA
        c2 cexp co cA cA cmul co cB c2 cexp co cB cB cmul co cA cA resqcl.1
        recni sqvali cB cB lt2sq.2 recni sqvali eqeq12i syl5bb $.
        $( [27-Oct-1999] $)
    $}

    $( The square of a non-zero real is positive. $)
    sqgt0i $p |- ( A =/= 0 -> 0 < ( A ^ 2 ) ) $=
      cA cr wcel cA cc0 wne cc0 cA c2 cexp co clt wbr resqcl.1 cA sqgt0 mpan $.
      $( [17-Sep-1999] $)

    $( A square of a real is nonnegative. $)
    sqge0i $p |- 0 <_ ( A ^ 2 ) $=
      cc0 cA cA cmul co cA c2 cexp co cle cA resqcl.1 msqge0i cA cA resqcl.1
      recni sqvali breqtrri $.
      $( [3-Aug-1999] $)
  $}

  $( The square function is one-to-one for nonnegative reals. $)
  sq11 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
               ( ( A ^ 2 ) = ( B ^ 2 ) <-> A = B ) ) $=
    cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr cA c2 cexp co cB c2
    cexp co wceq cA cB wceq wb cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cB
    cle wbr wa cA c2 cexp co cB c2 cexp co wceq cA cB wceq wb cA cr wcel cB cr
    wcel cc0 cA cle wbr cc0 cB cle wbr wa cA c2 cexp co cB c2 cexp co wceq cA
    cB wceq wb wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cA cr
    wcel cA cc0 cif c2 cexp co cB c2 cexp co wceq cA cr wcel cA cc0 cif cB wceq
    wb wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr
    wa cA cr wcel cA cc0 cif c2 cexp co cB cr wcel cB cc0 cif c2 cexp co wceq
    cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif wceq wb wi cA cB cc0 cc0 cA cA
    cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA
    cc0 cif cle wbr cc0 cB cle wbr wa cA c2 cexp co cB c2 cexp co wceq cA cB
    wceq wb cA cr wcel cA cc0 cif c2 cexp co cB c2 cexp co wceq cA cr wcel cA
    cc0 cif cB wceq wb cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr
    wcel cA cc0 cif cle wbr cc0 cB cle wbr cA cA cr wcel cA cc0 cif cc0 cle
    breq2 anbi1d cA cA cr wcel cA cc0 cif wceq cA c2 cexp co cB c2 cexp co wceq
    cA cr wcel cA cc0 cif c2 cexp co cB c2 cexp co wceq cA cB wceq cA cr wcel
    cA cc0 cif cB wceq cA cA cr wcel cA cc0 cif wceq cA c2 cexp co cA cr wcel
    cA cc0 cif c2 cexp co cB c2 cexp co cA cA cr wcel cA cc0 cif c2 cexp opreq1
    eqeq1d cA cA cr wcel cA cc0 cif cB eqeq1 bibi12d imbi12d cB cB cr wcel cB
    cc0 cif wceq cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cc0 cA cr
    wcel cA cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA
    cc0 cif c2 cexp co cB c2 cexp co wceq cA cr wcel cA cc0 cif cB wceq wb cA
    cr wcel cA cc0 cif c2 cexp co cB cr wcel cB cc0 cif c2 cexp co wceq cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif wceq wb cB cB cr wcel cB cc0 cif wceq
    cc0 cB cle wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif
    cle wbr cB cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif c2 cexp co cB c2 cexp co wceq cA cr wcel cA
    cc0 cif c2 cexp co cB cr wcel cB cc0 cif c2 cexp co wceq cA cr wcel cA cc0
    cif cB wceq cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif wceq cB cB cr wcel
    cB cc0 cif wceq cB c2 cexp co cB cr wcel cB cc0 cif c2 cexp co cA cr wcel
    cA cc0 cif c2 cexp co cB cB cr wcel cB cc0 cif c2 cexp opreq1 eqeq2d cB cB
    cr wcel cB cc0 cif cA cr wcel cA cc0 cif eqeq2 bibi12d imbi12d cA cr wcel
    cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel
    sq11i dedth2h imp an4s $.
    $( [13-Mar-2006] $) $( [8-Apr-2001] $)

  $( The square function on nonnegative reals is strictly monotonic. $)
  lt2sq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( A < B <-> ( A ^ 2 ) < ( B ^ 2 ) ) ) $=
    cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa wa cA cB clt wbr
    cA cA cmul co cB cB cmul co clt wbr cA c2 cexp co cB c2 cexp co clt wbr cA
    cB lt2msq cA cr wcel cB cr wcel cA c2 cexp co cB c2 cexp co clt wbr cA cA
    cmul co cB cB cmul co clt wbr wb cc0 cA cle wbr cc0 cB cle wbr cA cc wcel
    cB cc wcel cA c2 cexp co cB c2 cexp co clt wbr cA cA cmul co cB cB cmul co
    clt wbr wb cA cr wcel cB cr wcel cA cc wcel cB cc wcel cA c2 cexp co cA cA
    cmul co cB c2 cexp co cB cB cmul co clt cA sqval cB sqval breqan12d cA recn
    cB recn syl2an ad2ant2r bitr4d $.
    $( [11-Apr-2006] $) $( [24-Feb-2006] $)

  $( The square function on nonnegative reals is monotonic. $)
  le2sq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( A <_ B <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
    cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa wa cA cB cle wbr
    cA cA cmul co cB cB cmul co cle wbr cA c2 cexp co cB c2 cexp co cle wbr cA
    cB le2msq cA cr wcel cB cr wcel cA c2 cexp co cB c2 cexp co cle wbr cA cA
    cmul co cB cB cmul co cle wbr wb cc0 cA cle wbr cc0 cB cle wbr cA cc wcel
    cB cc wcel cA c2 cexp co cB c2 cexp co cle wbr cA cA cmul co cB cB cmul co
    cle wbr wb cA cr wcel cB cr wcel cA cc wcel cB cc wcel cA c2 cexp co cA cA
    cmul co cB c2 cexp co cB cB cmul co cle cA sqval cB sqval breqan12d cA recn
    cB recn syl2an ad2ant2r bitr4d $.
    $( [26-Jul-2006] $) $( [18-Oct-1999] $)

  $( The square of a 'less than or equal to' ordering. $)
  le2sq2 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ A <_ B ) ) ->
              ( A ^ 2 ) <_ ( B ^ 2 ) ) $=
    cA cr wcel cc0 cA cle wbr wa cB cr wcel cA cB cle wbr wa wa cA cB cle wbr
    cA c2 cexp co cB c2 cexp co cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel
    cA cB cle wbr simprr cA cr wcel cc0 cA cle wbr wa cB cr wcel cA cB cle wbr
    wa cB cr wcel cc0 cB cle wbr wa cA cB cle wbr cA c2 cexp co cB c2 cexp co
    cle wbr wb cA cr wcel cc0 cA cle wbr wa cB cr wcel cA cB cle wbr wa wa cB
    cr wcel cc0 cB cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel cA cB cle
    wbr simprl cA cr wcel cc0 cA cle wbr cB cr wcel cA cB cle wbr cc0 cB cle
    wbr cA cr wcel cB cr wcel cc0 cA cle wbr cA cB cle wbr cc0 cB cle wbr wi cA
    cr wcel cB cr wcel cc0 cA cle wbr cA cB cle wbr cc0 cB cle wbr cc0 cr wcel
    cA cr wcel cB cr wcel cc0 cA cle wbr cA cB cle wbr wa cc0 cB cle wbr wi 0re
    cc0 cA cB letr mp3an1 exp4b com23 imp43 jca cA cB le2sq syldan mpbid $.
    $( [24-Mar-2008] $) $( [21-Mar-2008] $)

  $( A square of a real is nonnegative. $)
  sqge0 $p |- ( A e. RR -> 0 <_ ( A ^ 2 ) ) $=
    cA cr wcel cc0 cA c2 cexp co cle wbr cc0 cA cr wcel cA cc0 cif c2 cexp co
    cle wbr cA cc0 cA cA cr wcel cA cc0 cif wceq cA c2 cexp co cA cr wcel cA
    cc0 cif c2 cexp co cc0 cle cA cA cr wcel cA cc0 cif c2 cexp opreq1 breq2d
    cA cr wcel cA cc0 cif cA cc0 cr 0re elimel sqge0i dedth $.
    $( [18-Oct-1999] $)

  ${
    sumsqne0.1 $e |- A e. RR $.
    sumsqne0.2 $e |- B e. RR $.
    $( The sum of two squares is nonzero iff one of its terms is nonzero. $)
    sumsqne0i $p |- ( ( A =/= 0 \/ B =/= 0 ) <->
                   ( ( A ^ 2 ) + ( B ^ 2 ) ) =/= 0 ) $=
      cA cc0 wne cB cc0 wne wo cA c2 cexp co cB c2 cexp co caddc co cc0 wne cA
      cc0 wne cA c2 cexp co cB c2 cexp co caddc co cc0 wne cB cc0 wne cA cc0
      wne cc0 cA c2 cexp co clt wbr cc0 cA c2 cexp co cB c2 cexp co caddc co
      clt wbr cA c2 cexp co cB c2 cexp co caddc co cc0 wne cA sumsqne0.1 sqgt0i
      cc0 cA c2 cexp co clt wbr cA c2 cexp co cA c2 cexp co cB c2 cexp co caddc
      co cle wbr cc0 cA c2 cexp co cB c2 cexp co caddc co clt wbr cc0 cB c2
      cexp co cle wbr cA c2 cexp co cA c2 cexp co cB c2 cexp co caddc co cle
      wbr cB sumsqne0.2 sqge0i cA c2 cexp co cr wcel cB c2 cexp co cr wcel cc0
      cB c2 cexp co cle wbr cA c2 cexp co cA c2 cexp co cB c2 cexp co caddc co
      cle wbr wb cA sumsqne0.1 resqcli cB sumsqne0.2 resqcli cA c2 cexp co cB
      c2 cexp co addge01 mp2an mpbi cc0 cA c2 cexp co cA c2 cexp co cB c2 cexp
      co caddc co 0re cA sumsqne0.1 resqcli cA c2 cexp co cB c2 cexp co cA
      sumsqne0.1 resqcli cB sumsqne0.2 resqcli readdcli ltletri mpan2 cA c2
      cexp co cB c2 cexp co caddc co cA c2 cexp co cB c2 cexp co cA sumsqne0.1
      resqcli cB sumsqne0.2 resqcli readdcli gt0ne0i 3syl cB cc0 wne cc0 cB c2
      cexp co clt wbr cc0 cA c2 cexp co cB c2 cexp co caddc co clt wbr cA c2
      cexp co cB c2 cexp co caddc co cc0 wne cB sumsqne0.2 sqgt0i cc0 cB c2
      cexp co clt wbr cB c2 cexp co cA c2 cexp co cB c2 cexp co caddc co cle
      wbr cc0 cA c2 cexp co cB c2 cexp co caddc co clt wbr cc0 cA c2 cexp co
      cle wbr cB c2 cexp co cA c2 cexp co cB c2 cexp co caddc co cle wbr cA
      sumsqne0.1 sqge0i cB c2 cexp co cr wcel cA c2 cexp co cr wcel cc0 cA c2
      cexp co cle wbr cB c2 cexp co cA c2 cexp co cB c2 cexp co caddc co cle
      wbr wb cB sumsqne0.2 resqcli cA sumsqne0.1 resqcli cB c2 cexp co cA c2
      cexp co addge02 mp2an mpbi cc0 cB c2 cexp co cA c2 cexp co cB c2 cexp co
      caddc co 0re cB sumsqne0.2 resqcli cA c2 cexp co cB c2 cexp co cA
      sumsqne0.1 resqcli cB sumsqne0.2 resqcli readdcli ltletri mpan2 cA c2
      cexp co cB c2 cexp co caddc co cA c2 cexp co cB c2 cexp co cA sumsqne0.1
      resqcli cB sumsqne0.2 resqcli readdcli gt0ne0i 3syl jaoi cA c2 cexp co cB
      c2 cexp co caddc co cc0 wceq wn cA cc0 wceq cB cc0 wceq wa wn cA c2 cexp
      co cB c2 cexp co caddc co cc0 wne cA cc0 wne cB cc0 wne wo cA cc0 wceq cB
      cc0 wceq wa cA c2 cexp co cB c2 cexp co caddc co cc0 wceq cA cc0 wceq cB
      cc0 wceq wa cA c2 cexp co cB c2 cexp co caddc co cc0 c2 cexp co cc0 c2
      cexp co caddc co cc0 cA cc0 wceq cB cc0 wceq cA c2 cexp co cc0 c2 cexp co
      cB c2 cexp co cc0 c2 cexp co caddc cA cc0 c2 cexp opreq1 cB cc0 c2 cexp
      opreq1 opreqan12d cc0 c2 cexp co cc0 c2 cexp co caddc co cc0 cc0 caddc co
      cc0 cc0 c2 cexp co cc0 cc0 c2 cexp co cc0 caddc c2 cn wcel cc0 c2 cexp co
      cc0 wceq 2nn c2 0exp ax-mp c2 cn wcel cc0 c2 cexp co cc0 wceq 2nn c2 0exp
      ax-mp opreq12i cc0 0cn addid1i eqtri syl6eq con3i cA c2 cexp co cB c2
      cexp co caddc co cc0 df-ne cA cc0 cB cc0 neorian 3imtr4i impbii $.
      $( [25-Jul-2006] $) $( [29-Apr-2005] $)
  $}

  $( The square of 0 is 0. $)
  sq0 $p |- ( 0 ^ 2 ) = 0 $=
    cc0 c2 cexp co cc0 wceq cc0 cc0 wceq cc0 eqid cc0 0cn sqeq0i mpbir $.
    $( [7-Jun-2006] $) $( [6-Jun-2006] $)

  $( If a number is zero, its square is zero.  (Contributed by FL,
     10-Dec-2006.) $)
  sq0i $p |- ( A = 0 -> ( A ^ 2 ) = 0 ) $=
    cA cc0 wceq cA c2 cexp co cc0 c2 cexp co cc0 cA cc0 c2 cexp opreq1 sq0
    syl6eq $.
    $( [10-Dec-2006] $) $( [10-Dec-2006] $)

  $( The square of 1 is 1. $)
  sq1 $p |- ( 1 ^ 2 ) = 1 $=
    c2 cn0 wcel c1 c2 cexp co c1 wceq 2nn0 c2 1exp ax-mp $.
    $( [8-May-2007] $) $( [22-Aug-1999] $)

  $( The square of 2 is 4. $)
  sq2 $p |- ( 2 ^ 2 ) = 4 $=
    c2 c2 cexp co c2 c2 cmul co c4 c2 2cn sqvali 2t2e4 eqtri $.
    $( [22-Aug-1999] $)

  $( The square of 3 is 9. $)
  sq3 $p |- ( 3 ^ 2 ) = 9 $=
    c3 c2 cexp co c3 c3 cmul co c9 c3 c3 3re recni sqvali 3t3e9 eqtri $.
    $( [16-Jun-2006] $) $( [26-Apr-2006] $)

  $( The cube of 2 is 8. $)
  cu2 $p |- ( 2 ^ 3 ) = 8 $=
    c2 c3 cexp co c2 c2 c1 caddc co cexp co c2 c2 cexp co c2 cmul co c8 c3 c2
    c1 caddc co c2 cexp df-3 opreq2i c2 cc wcel c2 cn0 wcel c2 c2 c1 caddc co
    cexp co c2 c2 cexp co c2 cmul co wceq 2cn 2nn0 c2 c2 expp1 mp2an c2 c2 cexp
    co c2 cmul co c4 c2 cmul co c8 c2 c2 cexp co c4 c2 cmul sq2 opreq1i 4t2e8
    eqtri 3eqtri $.
    $( [28-Jul-2006] $) $( [2-Aug-2004] $)

  $( A counterexample showing that exponentiation is not associative.
     (Contributed by Stefan Allan and G&eacute;rard Lang, 21-Sep-2010.) $)
  expnass $p |- ( ( 3 ^ 3 ) ^ 3 ) < ( 3 ^ ( 3 ^ 3 ) ) $=
    c3 c3 c3 cmul co cexp co c3 c3 cexp co c3 cexp co c3 c3 c3 cexp co cexp co
    clt c3 cc wcel c3 cn0 wcel c3 cn0 wcel c3 c3 c3 cmul co cexp co c3 c3 cexp
    co c3 cexp co wceq c3 3nn nncni c3 3nn nnnn0i c3 3nn nnnn0i c3 c3 c3 expmul
    mp3an c3 cr wcel c3 c3 cmul co cn0 wcel c3 c3 cexp co cn0 wcel c3 c3 c3
    cmul co cexp co c3 c3 c3 cexp co cexp co clt wbr 3re c3 c3 c3 3nn nnnn0i c3
    3nn nnnn0i nn0mulcli c3 cn0 wcel c3 cn0 wcel c3 c3 cexp co cn0 wcel c3 3nn
    nnnn0i c3 3nn nnnn0i c3 c3 nn0expcl mp2an c3 cr wcel c3 c3 cmul co cn0 wcel
    c3 c3 cexp co cn0 wcel w3a c1 c3 clt wbr c3 c3 cmul co c3 c3 cexp co clt
    wbr c3 c3 c3 cmul co cexp co c3 c3 c3 cexp co cexp co clt wbr 1lt3 c3 c2
    cexp co c3 c3 cmul co c3 c3 cexp co clt c3 c3 3nn nncni sqvali c3 cr wcel
    c2 cn0 wcel c3 cn0 wcel c3 c2 cexp co c3 c3 cexp co clt wbr 3re 2nn0 c3 3nn
    nnnn0i c3 cr wcel c2 cn0 wcel c3 cn0 wcel w3a c1 c3 clt wbr c2 c3 clt wbr
    c3 c2 cexp co c3 c3 cexp co clt wbr 1lt3 2lt3 c3 c2 c3 expordi mpanr12
    mp3an eqbrtrri c3 c3 c3 cmul co c3 c3 cexp co expordi mpanr12 mp3an
    eqbrtrri $.
    $( [27-Sep-2010] $) $( [21-Sep-2010] $)

  $( Cancel one factor of a square in a ` <_ ` comparison.  Unlike ~ lemul1 ,
     the common factor ` A ` may be zero. $)
  sqlecan $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
      ( ( A ^ 2 ) <_ ( B x. A ) <-> A <_ B ) ) $=
    cA cr wcel cc0 cA cle wbr cB cr wcel cc0 cB cle wbr wa cA c2 cexp co cB cA
    cmul co cle wbr cA cB cle wbr wb cA cr wcel cc0 cA cle wbr cc0 cA clt wbr
    cc0 cA wceq wo cB cr wcel cc0 cB cle wbr wa cA c2 cexp co cB cA cmul co cle
    wbr cA cB cle wbr wb wi cc0 cr wcel cA cr wcel cc0 cA cle wbr cc0 cA clt
    wbr cc0 cA wceq wo wb 0re cc0 cA leloe mpan cA cr wcel cc0 cA clt wbr cB cr
    wcel cc0 cB cle wbr wa cA c2 cexp co cB cA cmul co cle wbr cA cB cle wbr wb
    wi cc0 cA wceq cA cr wcel cB cr wcel cc0 cB cle wbr wa cc0 cA clt wbr cA c2
    cexp co cB cA cmul co cle wbr cA cB cle wbr wb cA cr wcel cB cr wcel cc0 cA
    clt wbr cA c2 cexp co cB cA cmul co cle wbr cA cB cle wbr wb wi cc0 cB cle
    wbr cB cr wcel cA cr wcel cc0 cA clt wbr cA c2 cexp co cB cA cmul co cle
    wbr cA cB cle wbr wb wi cA cr wcel cB cr wcel cA cr wcel cc0 cA clt wbr cA
    c2 cexp co cB cA cmul co cle wbr cA cB cle wbr wb cA cr wcel cB cr wcel cA
    cr wcel w3a cc0 cA clt wbr wa cA c2 cexp co cB cA cmul co cle wbr cA cA
    cmul co cB cA cmul co cle wbr cA cB cle wbr cA cr wcel cB cr wcel cA cr
    wcel w3a cc0 cA clt wbr wa cA c2 cexp co cA cA cmul co cB cA cmul co cle cA
    cr wcel cB cr wcel cA cr wcel w3a cA c2 cexp co cA cA cmul co wceq cc0 cA
    clt wbr cA cr wcel cB cr wcel cA c2 cexp co cA cA cmul co wceq cA cr wcel
    cA cr wcel cA cc wcel cA c2 cexp co cA cA cmul co wceq cA recn cA sqval syl
    3ad2ant1 adantr breq1d cA cB cA lemul1OLD bitr4d 3exp1 pm2.43a adantrd
    com23 cc0 cA wceq cB cr wcel cc0 cB cle wbr wa cA c2 cexp co cB cA cmul co
    cle wbr cA cB cle wbr wb wi wi cA cr wcel cc0 cA wceq cB cr wcel cc0 cB cle
    wbr wa cA c2 cexp co cB cA cmul co cle wbr cA cB cle wbr wb cA c2 cexp co
    cB cA cmul co cle wbr cA cB cle wbr cA c2 cexp co cB cA cmul co cle wbr cA
    cB cle wbr wb cc0 cA wceq cB cr wcel cc0 cB cle wbr wa wa cA c2 cexp co cB
    cA cmul co cle wbr cA cB cle wbr pm5.1 cc0 cA wceq cB cr wcel cA c2 cexp co
    cB cA cmul co cle wbr cc0 cB cle wbr cc0 cA wceq cB cr wcel wa cc0 c2 cexp
    co cB cc0 cmul co cle wbr cA c2 cexp co cB cA cmul co cle wbr cB cr wcel
    cc0 c2 cexp co cB cc0 cmul co cle wbr cc0 cA wceq cB cr wcel cc0 cB cc0
    cmul co cc0 c2 cexp co cle cB cr wcel cB cc wcel cB cc0 cmul co cc0 wceq cB
    recn cB mul01 syl cc0 c2 cexp co cc0 cc0 cle sq0 cc0 0re leidi eqbrtri
    syl5breqr adantl cc0 cA wceq cc0 c2 cexp co cB cc0 cmul co cle wbr cA c2
    cexp co cB cA cmul co cle wbr wb cB cr wcel cc0 cA wceq cc0 c2 cexp co cA
    c2 cexp co cB cc0 cmul co cB cA cmul co cle cc0 cA c2 cexp opreq1 cc0 cA cB
    cmul opreq2 breq12d adantr mpbid adantrr cc0 cA wceq cc0 cB cle wbr cA cB
    cle wbr cB cr wcel cc0 cA wceq cc0 cB cle wbr cA cB cle wbr cc0 cA cB cle
    breq1 biimpa adantrl sylanc ex a1i jaod sylbid imp31 $.
    $( [25-Jan-2008] $) $( [17-Jan-2008] $)

  $( Factor the difference of two squares. $)
  subsq $p |- ( ( A e. CC /\ B e. CC ) ->
          ( ( A ^ 2 ) - ( B ^ 2 ) ) = ( ( A + B ) x. ( A - B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co cmul co cA cA cB cmin
    co cmul co cB cA cB cmin co cmul co caddc co cA c2 cexp co cA cB cmul co
    cmin co cA cB cmul co cB c2 cexp co cmin co caddc co cA c2 cexp co cB c2
    cexp co cmin co cA cc wcel cB cc wcel cA cB cmin co cc wcel cA cB caddc co
    cA cB cmin co cmul co cA cA cB cmin co cmul co cB cA cB cmin co cmul co
    caddc co wceq cA cc wcel cB cc wcel wa cA cB cA cB cmin co adddir cA cc
    wcel cB cc wcel pm3.26 cA cc wcel cB cc wcel pm3.27 cA cB subcl syl3anc cA
    cc wcel cB cc wcel wa cA cA cB cmin co cmul co cA c2 cexp co cA cB cmul co
    cmin co cB cA cB cmin co cmul co cA cB cmul co cB c2 cexp co cmin co caddc
    cA cc wcel cB cc wcel wa cA cA cB cmin co cmul co cA cA cmul co cA cB cmul
    co cmin co cA c2 cexp co cA cB cmul co cmin co cA cc wcel cB cc wcel cA cA
    cB cmin co cmul co cA cA cmul co cA cB cmul co cmin co wceq cA cA cB subdi
    3anidm12 cA cc wcel cB cc wcel wa cA c2 cexp co cA cA cmul co cA cB cmul co
    cmin cA cc wcel cA c2 cexp co cA cA cmul co wceq cB cc wcel cA sqval adantr
    opreq1d eqtr4d cA cc wcel cB cc wcel wa cB cA cB cmin co cmul co cB cA cmul
    co cB cB cmul co cmin co cA cB cmul co cB c2 cexp co cmin co cB cc wcel cA
    cc wcel cB cc wcel cB cA cB cmin co cmul co cB cA cmul co cB cB cmul co
    cmin co wceq cA cc wcel cB cc wcel wa cB cA cB subdi cA cc wcel cB cc wcel
    pm3.27 cA cc wcel cB cc wcel pm3.26 cA cc wcel cB cc wcel pm3.27 syl3anc cA
    cc wcel cB cc wcel wa cA cB cmul co cB cA cmul co cB c2 cexp co cB cB cmul
    co cmin cA cB mulcom cB cc wcel cB c2 cexp co cB cB cmul co wceq cA cc wcel
    cB sqval adantl opreq12d eqtr4d opreq12d cA cc wcel cB cc wcel wa cA c2
    cexp co cA cB cmul co cmin co cA cB cmul co caddc co cB c2 cexp co cmin co
    cA c2 cexp co cA cB cmul co cmin co cA cB cmul co cB c2 cexp co cmin co
    caddc co cA c2 cexp co cB c2 cexp co cmin co cA c2 cexp co cA cB cmul co
    cmin co cc wcel cA cB cmul co cc wcel cB c2 cexp co cc wcel cA c2 cexp co
    cA cB cmul co cmin co cA cB cmul co caddc co cB c2 cexp co cmin co cA c2
    cexp co cA cB cmul co cmin co cA cB cmul co cB c2 cexp co cmin co caddc co
    wceq cA cc wcel cB cc wcel wa cA c2 cexp co cA cB cmul co cmin co cA cB
    cmul co cB c2 cexp co addsubass cA c2 cexp co cc wcel cA cB cmul co cc wcel
    cA c2 cexp co cA cB cmul co cmin co cc wcel cA cc wcel cB cc wcel wa cA c2
    cexp co cA cB cmul co subcl cA cc wcel cA c2 cexp co cc wcel cB cc wcel cA
    sqcl adantr cA cB mulcl sylanc cA cB mulcl cB cc wcel cB c2 cexp co cc wcel
    cA cc wcel cB sqcl adantl syl3anc cA cc wcel cB cc wcel wa cA c2 cexp co cA
    cB cmul co cmin co cA cB cmul co caddc co cA c2 cexp co cB c2 cexp co cmin
    cA cc wcel cB cc wcel wa cA c2 cexp co cA cB cmul co cmin co cA cB cmul co
    caddc co cA cB cmul co cA c2 cexp co cA cB cmul co cmin co caddc co cA c2
    cexp co cA c2 cexp co cA cB cmul co cmin co cc wcel cA cB cmul co cc wcel
    cA c2 cexp co cA cB cmul co cmin co cA cB cmul co caddc co cA cB cmul co cA
    c2 cexp co cA cB cmul co cmin co caddc co wceq cA cc wcel cB cc wcel wa cA
    c2 cexp co cA cB cmul co cmin co cA cB cmul co addcom cA c2 cexp co cc wcel
    cA cB cmul co cc wcel cA c2 cexp co cA cB cmul co cmin co cc wcel cA cc
    wcel cB cc wcel wa cA c2 cexp co cA cB cmul co subcl cA cc wcel cA c2 cexp
    co cc wcel cB cc wcel cA sqcl adantr cA cB mulcl sylanc cA cB mulcl sylanc
    cA cB cmul co cc wcel cA c2 cexp co cc wcel cA cB cmul co cA c2 cexp co cA
    cB cmul co cmin co caddc co cA c2 cexp co wceq cA cc wcel cB cc wcel wa cA
    cB cmul co cA c2 cexp co pncan3 cA cB mulcl cA cc wcel cA c2 cexp co cc
    wcel cB cc wcel cA sqcl adantr sylanc eqtrd opreq1d eqtr3d 3eqtrrd $.
    $( [23-Feb-2008] $) $( [21-Feb-2008] $)

  $( Express the difference of the squares of two numbers as a polynomial in
     the difference of the numbers. $)
  subsq2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A ^ 2 ) - ( B ^ 2 ) ) =
    ( ( ( A - B ) ^ 2 ) + ( ( 2 x. B ) x. ( A - B ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co cA cB cmin co cmul co cA cB cmin co
    cA cB cmin co cmul co c2 cB cmul co cA cB cmin co cmul co caddc co cA c2
    cexp co cB c2 cexp co cmin co cA cB cmin co c2 cexp co c2 cB cmul co cA cB
    cmin co cmul co caddc co cA cc wcel cB cc wcel wa cA cB cmin co c2 cB cmul
    co caddc co cA cB cmin co cmul co cA cB caddc co cA cB cmin co cmul co cA
    cB cmin co cA cB cmin co cmul co c2 cB cmul co cA cB cmin co cmul co caddc
    co cA cc wcel cB cc wcel wa cA cB cmin co c2 cB cmul co caddc co cA cB
    caddc co cA cB cmin co cmul cA cc wcel cB cc wcel wa cA cB cmin co c2 cB
    cmul co caddc co cA c2 cB cmul co cB cmin co caddc co cA cB caddc co cA cc
    wcel cB cc wcel c2 cB cmul co cc wcel cA cB cmin co c2 cB cmul co caddc co
    cA c2 cB cmul co cB cmin co caddc co wceq cB cc wcel c2 cB cmul co cc wcel
    cA cc wcel c2 cc wcel cB cc wcel c2 cB cmul co cc wcel 2cn c2 cB mulcl mpan
    adantl cA cB c2 cB cmul co subadd23 mpd3an3 cA cc wcel cB cc wcel wa c2 cB
    cmul co cB cmin co cB cA caddc cB cc wcel c2 cB cmul co cB cmin co cB wceq
    cA cc wcel cB cc wcel c2 cB cmul co cB cmin co cB cB caddc co cB cmin co cB
    cB cc wcel c2 cB cmul co cB cB caddc co cB cmin cB 2times opreq1d cB cc
    wcel cB cB caddc co cB cmin co cB wceq cB cB pncan anidms eqtrd adantl
    opreq2d eqtrd opreq1d cA cB cmin co cc wcel c2 cB cmul co cc wcel cA cB
    cmin co cc wcel cA cB cmin co c2 cB cmul co caddc co cA cB cmin co cmul co
    cA cB cmin co cA cB cmin co cmul co c2 cB cmul co cA cB cmin co cmul co
    caddc co wceq cA cc wcel cB cc wcel wa cA cB cmin co c2 cB cmul co cA cB
    cmin co adddir cA cB subcl cB cc wcel c2 cB cmul co cc wcel cA cc wcel c2
    cc wcel cB cc wcel c2 cB cmul co cc wcel 2cn c2 cB mulcl mpan adantl cA cB
    subcl syl3anc eqtr3d cA cB subsq cA cc wcel cB cc wcel wa cA cB cmin co c2
    cexp co cA cB cmin co cA cB cmin co cmul co c2 cB cmul co cA cB cmin co
    cmul co caddc cA cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cB cmin co
    c2 cexp co cA cB cmin co cA cB cmin co cmul co wceq cA cB subcl cA cB cmin
    co sqval syl opreq1d 3eqtr4d $.
    $( [13-Mar-2008] $) $( [21-Feb-2008] $)

  ${
    binom2.1 $e |- A e. CC $.
    binom2.2 $e |- B e. CC $.
    $( The square of a binomial. $)
    binom2i $p |- ( ( A + B ) ^ 2 ) = ( ( ( A ^ 2 ) + ( 2 x.
                ( A x. B ) ) ) + ( B ^ 2 ) ) $=
      cA cB caddc co cA cB caddc co cmul co cA cA cmul co cA cB cmul co cA cB
      cmul co caddc co caddc co cB cB cmul co caddc co cA cB caddc co c2 cexp
      co cA c2 cexp co c2 cA cB cmul co cmul co caddc co cB c2 cexp co caddc co
      cA cB caddc co cA cB caddc co cmul co cA cB caddc co cA cmul co cA cB
      caddc co cB cmul co caddc co cA cA cmul co cA cB cmul co caddc co cA cB
      cmul co cB cB cmul co caddc co caddc co cA cA cmul co cA cB cmul co cA cB
      cmul co caddc co caddc co cB cB cmul co caddc co cA cB caddc co cA cB cA
      cB binom2.1 binom2.2 addcli binom2.1 binom2.2 adddii cA cB caddc co cA
      cmul co cA cA cmul co cA cB cmul co caddc co cA cB caddc co cB cmul co cA
      cB cmul co cB cB cmul co caddc co caddc cA cB caddc co cA cmul co cA cA
      cmul co cB cA cmul co caddc co cA cA cmul co cA cB cmul co caddc co cA cB
      cA binom2.1 binom2.2 binom2.1 adddiri cB cA cmul co cA cB cmul co cA cA
      cmul co caddc cB cA binom2.2 binom2.1 mulcomi opreq2i eqtri cA cB cB
      binom2.1 binom2.2 binom2.2 adddiri opreq12i cA cA cmul co cA cB cmul co
      caddc co cA cB cmul co caddc co cB cB cmul co caddc co cA cA cmul co cA
      cB cmul co caddc co cA cB cmul co cB cB cmul co caddc co caddc co cA cA
      cmul co cA cB cmul co cA cB cmul co caddc co caddc co cB cB cmul co caddc
      co cA cA cmul co cA cB cmul co caddc co cA cB cmul co cB cB cmul co cA cA
      cmul co cA cB cmul co cA cA binom2.1 binom2.1 mulcli cA cB binom2.1
      binom2.2 mulcli addcli cA cB binom2.1 binom2.2 mulcli cB cB binom2.2
      binom2.2 mulcli addassi cA cA cmul co cA cB cmul co caddc co cA cB cmul
      co caddc co cA cA cmul co cA cB cmul co cA cB cmul co caddc co caddc co
      cB cB cmul co caddc cA cA cmul co cA cB cmul co cA cB cmul co cA cA
      binom2.1 binom2.1 mulcli cA cB binom2.1 binom2.2 mulcli cA cB binom2.1
      binom2.2 mulcli addassi opreq1i eqtr3i 3eqtri cA cB caddc co cA cB
      binom2.1 binom2.2 addcli sqvali cA c2 cexp co c2 cA cB cmul co cmul co
      caddc co cA cA cmul co cA cB cmul co cA cB cmul co caddc co caddc co cB
      c2 cexp co cB cB cmul co caddc cA c2 cexp co cA cA cmul co c2 cA cB cmul
      co cmul co cA cB cmul co cA cB cmul co caddc co caddc cA binom2.1 sqvali
      cA cB cmul co cA cB binom2.1 binom2.2 mulcli 2timesi opreq12i cB binom2.2
      sqvali opreq12i 3eqtr4i $.
      $( [11-Aug-1999] $)

    $( Product of sum and difference. $)
    binom2aiOLD $p |- ( ( A + B ) x. ( A - B ) ) = ( ( A ^ 2 ) - ( B ^ 2 ) ) $=
      cA cB caddc co cA cB cmin co cmul co cA cA cB cmin co cmul co cB cA cB
      cmin co cmul co caddc co cA c2 cexp co cA cB cmul co cmin co cA cB cmul
      co cB c2 cexp co cmin co caddc co cA c2 cexp co cB c2 cexp co cmin co cA
      cB cA cB cmin co binom2.1 binom2.2 cA cB binom2.1 binom2.2 subcli adddiri
      cA cA cB cmin co cmul co cA c2 cexp co cA cB cmul co cmin co cB cA cB
      cmin co cmul co cA cB cmul co cB c2 cexp co cmin co caddc cA cA cB cmin
      co cmul co cA cA cmul co cA cB cmul co cmin co cA c2 cexp co cA cB cmul
      co cmin co cA cA cB binom2.1 binom2.1 binom2.2 subdii cA c2 cexp co cA cA
      cmul co cA cB cmul co cmin cA binom2.1 sqvali opreq1i eqtr4i cB cA cB
      cmin co cmul co cB cA cmul co cB cB cmul co cmin co cA cB cmul co cB c2
      cexp co cmin co cB cA cB binom2.2 binom2.1 binom2.2 subdii cA cB cmul co
      cB cA cmul co cB c2 cexp co cB cB cmul co cmin cA cB binom2.1 binom2.2
      mulcomi cB binom2.2 sqvali opreq12i eqtr4i opreq12i cA c2 cexp co cA cB
      cmul co cmin co cA cB cmul co caddc co cB c2 cexp co cmin co cA c2 cexp
      co cA cB cmul co cmin co cA cB cmul co cB c2 cexp co cmin co caddc co cA
      c2 cexp co cB c2 cexp co cmin co cA c2 cexp co cA cB cmul co cmin co cA
      cB cmul co cB c2 cexp co cA c2 cexp co cA cB cmul co cA binom2.1 sqcli cA
      cB binom2.1 binom2.2 mulcli subcli cA cB binom2.1 binom2.2 mulcli cB
      binom2.2 sqcli addsubassi cA c2 cexp co cA cB cmul co cmin co cA cB cmul
      co caddc co cA c2 cexp co cB c2 cexp co cmin cA c2 cexp co cA cB cmul co
      cmin co cA cB cmul co caddc co cA cB cmul co cA c2 cexp co cA cB cmul co
      cmin co caddc co cA c2 cexp co cA c2 cexp co cA cB cmul co cmin co cA cB
      cmul co cA c2 cexp co cA cB cmul co cA binom2.1 sqcli cA cB binom2.1
      binom2.2 mulcli subcli cA cB binom2.1 binom2.2 mulcli addcomi cA cB cmul
      co cA c2 cexp co cA cB binom2.1 binom2.2 mulcli cA binom2.1 sqcli pncan3i
      eqtri opreq1i eqtr3i 3eqtri $.
      $( [17-Jun-2005] $) $( [7-Feb-2005] $)

    $( Factor the difference of two squares. $)
    subsqi $p |- ( ( A ^ 2 ) - ( B ^ 2 ) ) = ( ( A + B ) x. ( A - B ) ) $=
      cA cc wcel cB cc wcel cA c2 cexp co cB c2 cexp co cmin co cA cB caddc co
      cA cB cmin co cmul co wceq binom2.1 binom2.2 cA cB subsq mp2an $.
      $( [24-Apr-2008] $) $( [7-Feb-2005] $)

    $( The squares of two complex numbers are equal iff one number equals the
       other or its negative.  Lemma 15-4.7 of [Gleason] p. 311 and its
       converse. $)
    sqeqori $p |- ( ( A ^ 2 ) = ( B ^ 2 ) <-> ( A = B \/ A = -u B ) ) $=
      cA c2 cexp co cB c2 cexp co wceq cA cB caddc co cc0 wceq cA cB cmin co
      cc0 wceq wo cA cB cmin co cc0 wceq cA cB caddc co cc0 wceq wo cA cB wceq
      cA cB cneg wceq wo cA cB caddc co cA cB cmin co cmul co cc0 wceq cA c2
      cexp co cB c2 cexp co cmin co cc0 wceq cA cB caddc co cc0 wceq cA cB cmin
      co cc0 wceq wo cA c2 cexp co cB c2 cexp co wceq cA cB caddc co cA cB cmin
      co cmul co cA c2 cexp co cB c2 cexp co cmin co cc0 cA cB binom2.1
      binom2.2 binom2aiOLD eqeq1i cA cB caddc co cA cB cmin co cA cB binom2.1
      binom2.2 addcli cA cB binom2.1 binom2.2 subcli mul0ori cA c2 cexp co cB
      c2 cexp co cA binom2.1 sqcli cB binom2.2 sqcli subeq0i 3bitr3ri cA cB
      caddc co cc0 wceq cA cB cmin co cc0 wceq orcom cA cB cmin co cc0 wceq cA
      cB wceq cA cB caddc co cc0 wceq cA cB cneg wceq cA cB binom2.1 binom2.2
      subeq0i cA cB caddc co cc0 wceq cA cB cneg cmin co cc0 wceq cA cB cneg
      wceq cA cB cneg cmin co cA cB caddc co cc0 cA cB binom2.1 binom2.2
      subnegi eqeq1i cA cB cneg binom2.1 cB binom2.2 negcli subeq0i bitr3i
      orbi12i 3bitri $.
      $( [26-Apr-2006] $) $( [15-Jan-2006] $)

    $( The two solutions to the difference of squares set equal to zero. $)
    subsq0i $p |- ( ( ( A ^ 2 ) - ( B ^ 2 ) ) = 0
                  <-> ( A = B \/ A = -u B ) ) $=
      cA c2 cexp co cB c2 cexp co cmin co cc0 wceq cA c2 cexp co cB c2 cexp co
      wceq cA cB wceq cA cB cneg wceq wo cA c2 cexp co cB c2 cexp co cA
      binom2.1 sqcli cB binom2.2 sqcli subeq0i cA cB binom2.1 binom2.2 sqeqori
      bitri $.
      $( [4-Aug-2007] $) $( [25-Apr-2006] $)
  $}

  $( The squares of two complex numbers are equal iff one number equals the
     other or its negative.  Lemma 15-4.7 of [Gleason] p. 311 and its
     converse. (Contributed by Paul Chapman, 15-Mar-2008.) $)
  sqeqor $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( ( A ^ 2 ) = ( B ^ 2 ) <-> ( A = B \/ A = -u B ) ) ) $=
    cA cc wcel cB cc wcel cA c2 cexp co cB c2 cexp co wceq cA cB wceq cA cB
    cneg wceq wo wb cA cc wcel cA cc0 cif c2 cexp co cB c2 cexp co wceq cA cc
    wcel cA cc0 cif cB wceq cA cc wcel cA cc0 cif cB cneg wceq wo wb cA cc wcel
    cA cc0 cif c2 cexp co cB cc wcel cB cc0 cif c2 cexp co wceq cA cc wcel cA
    cc0 cif cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif cneg wceq wo wb cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA c2 cexp
    co cB c2 cexp co wceq cA cc wcel cA cc0 cif c2 cexp co cB c2 cexp co wceq
    cA cB wceq cA cB cneg wceq wo cA cc wcel cA cc0 cif cB wceq cA cc wcel cA
    cc0 cif cB cneg wceq wo cA cA cc wcel cA cc0 cif wceq cA c2 cexp co cA cc
    wcel cA cc0 cif c2 cexp co cB c2 cexp co cA cA cc wcel cA cc0 cif c2 cexp
    opreq1 eqeq1d cA cA cc wcel cA cc0 cif wceq cA cB wceq cA cc wcel cA cc0
    cif cB wceq cA cB cneg wceq cA cc wcel cA cc0 cif cB cneg wceq cA cA cc
    wcel cA cc0 cif cB eqeq1 cA cA cc wcel cA cc0 cif cB cneg eqeq1 orbi12d
    bibi12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif c2 cexp co cB
    c2 cexp co wceq cA cc wcel cA cc0 cif c2 cexp co cB cc wcel cB cc0 cif c2
    cexp co wceq cA cc wcel cA cc0 cif cB wceq cA cc wcel cA cc0 cif cB cneg
    wceq wo cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cneg wceq wo cB cB cc wcel cB cc0 cif wceq cB c2
    cexp co cB cc wcel cB cc0 cif c2 cexp co cA cc wcel cA cc0 cif c2 cexp co
    cB cB cc wcel cB cc0 cif c2 cexp opreq1 eqeq2d cB cB cc wcel cB cc0 cif
    wceq cA cc wcel cA cc0 cif cB wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif wceq cA cc wcel cA cc0 cif cB cneg wceq cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif cneg wceq cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif
    eqeq2 cB cB cc wcel cB cc0 cif wceq cB cneg cB cc wcel cB cc0 cif cneg cA
    cc wcel cA cc0 cif cB cB cc wcel cB cc0 cif negeq eqeq2d orbi12d bibi12d cA
    cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel sqeqori dedth2h $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( The square of a binomial.  (Contributed by FL, 10-Dec-2006.) $)
  binom2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) ^ 2 ) =
     ( ( ( A ^ 2 ) + ( 2 x. ( A x. B ) ) ) + ( B ^ 2 ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co c2 cexp co cA c2 cexp co c2 cA cB cmul
    co cmul co caddc co cB c2 cexp co caddc co wceq cA cc wcel cA cc0 cif cB
    caddc co c2 cexp co cA cc wcel cA cc0 cif c2 cexp co c2 cA cc wcel cA cc0
    cif cB cmul co cmul co caddc co cB c2 cexp co caddc co wceq cA cc wcel cA
    cc0 cif cB cc wcel cB cc0 cif caddc co c2 cexp co cA cc wcel cA cc0 cif c2
    cexp co c2 cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co cmul co
    caddc co cB cc wcel cB cc0 cif c2 cexp co caddc co wceq cA cB cc0 cc0 cA cA
    cc wcel cA cc0 cif wceq cA cB caddc co c2 cexp co cA cc wcel cA cc0 cif cB
    caddc co c2 cexp co cA c2 cexp co c2 cA cB cmul co cmul co caddc co cB c2
    cexp co caddc co cA cc wcel cA cc0 cif c2 cexp co c2 cA cc wcel cA cc0 cif
    cB cmul co cmul co caddc co cB c2 cexp co caddc co cA cA cc wcel cA cc0 cif
    wceq cA cB caddc co cA cc wcel cA cc0 cif cB caddc co c2 cexp cA cA cc wcel
    cA cc0 cif cB caddc opreq1 opreq1d cA cA cc wcel cA cc0 cif wceq cA c2 cexp
    co c2 cA cB cmul co cmul co caddc co cA cc wcel cA cc0 cif c2 cexp co c2 cA
    cc wcel cA cc0 cif cB cmul co cmul co caddc co cB c2 cexp co caddc cA cA cc
    wcel cA cc0 cif wceq cA c2 cexp co cA cc wcel cA cc0 cif c2 cexp co c2 cA
    cB cmul co cmul co c2 cA cc wcel cA cc0 cif cB cmul co cmul co caddc cA cA
    cc wcel cA cc0 cif c2 cexp opreq1 cA cA cc wcel cA cc0 cif wceq cA cB cmul
    co cA cc wcel cA cc0 cif cB cmul co c2 cmul cA cA cc wcel cA cc0 cif cB
    cmul opreq1 opreq2d opreq12d opreq1d eqeq12d cB cB cc wcel cB cc0 cif wceq
    cA cc wcel cA cc0 cif cB caddc co c2 cexp co cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif caddc co c2 cexp co cA cc wcel cA cc0 cif c2 cexp co c2 cA
    cc wcel cA cc0 cif cB cmul co cmul co caddc co cB c2 cexp co caddc co cA cc
    wcel cA cc0 cif c2 cexp co c2 cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cmul co cmul co caddc co cB cc wcel cB cc0 cif c2 cexp co caddc co cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif caddc co c2 cexp cB cB cc wcel cB cc0 cif cA cc
    wcel cA cc0 cif caddc opreq2 opreq1d cB cB cc wcel cB cc0 cif wceq cA cc
    wcel cA cc0 cif c2 cexp co c2 cA cc wcel cA cc0 cif cB cmul co cmul co
    caddc co cA cc wcel cA cc0 cif c2 cexp co c2 cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif cmul co cmul co caddc co cB c2 cexp co cB cc wcel cB cc0
    cif c2 cexp co caddc cB cB cc wcel cB cc0 cif wceq c2 cA cc wcel cA cc0 cif
    cB cmul co cmul co c2 cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co
    cmul co cA cc wcel cA cc0 cif c2 cexp co caddc cB cB cc wcel cB cc0 cif
    wceq cA cc wcel cA cc0 cif cB cmul co cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cmul co c2 cmul cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmul
    opreq2 opreq2d opreq2d cB cB cc wcel cB cc0 cif c2 cexp opreq1 opreq12d
    eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB
    cc0 cc 0cn elimel binom2i dedth2h $.
    $( [10-Dec-2006] $) $( [27-Nov-2006] $)

  $( If a complex number equals its square, it must be 0 or 1. $)
  sq01 $p |- ( A e. CC -> ( ( A ^ 2 ) = A <-> ( A = 0 \/ A = 1 ) ) ) $=
    cA cc wcel cA c2 cexp co cA wceq cA cc0 wceq cA c1 wceq wo cA cc wcel cA c2
    cexp co cA wceq cA cc0 wceq cA c1 wceq wo cA cc wcel cA c2 cexp co cA wceq
    wa cA cc0 wceq cA c1 wceq cA cc wcel cA c2 cexp co cA wceq wa cA cc0 wne cA
    c1 wceq cA cc0 wceq wn cA cc wcel cA c2 cexp co cA wceq cA cc0 wne cA c1
    wceq wi cA cc wcel cA cc0 wne cA c2 cexp co cA wceq cA c1 wceq cA cc wcel
    cA cc0 wne cA c2 cexp co cA wceq cA c1 wceq wi cA cc wcel cA cc0 wne wa cA
    c2 cexp co cA wceq cA c1 wceq cA cc wcel cA cc0 wne wa cA c2 cexp co cA
    wceq cA cA cmul co cA c1 cmul co wceq cA c1 wceq cA cc wcel cA c2 cexp co
    cA wceq cA cA cmul co cA c1 cmul co wceq wb cA cc0 wne cA cc wcel cA c2
    cexp co cA cA cmul co cA cA c1 cmul co cA sqval cA cc wcel cA c1 cmul co cA
    cA ax1id eqcomd eqeq12d adantr cA cc wcel cA cc0 wne cA cA cmul co cA c1
    cmul co wceq cA c1 wceq wb cA cc wcel c1 cc wcel cA cc wcel cA cc0 wne wa
    cA cA cmul co cA c1 cmul co wceq cA c1 wceq wb ax1cn cA c1 cA mulcan mp3an2
    anabss5 bitrd biimpd ex com23 imp cA cc0 df-ne syl5ibr orrd ex cA cc0 wceq
    cA c2 cexp co cA wceq cA c1 wceq cA cc0 wceq cc0 c2 cexp co cc0 cA c2 cexp
    co cA sq0 cA cc0 c2 cexp opreq1 cA cc0 wceq id 3eqtr4a cA c1 wceq c1 c2
    cexp co c1 cA c2 cexp co cA sq1 cA c1 c2 cexp opreq1 cA c1 wceq id 3eqtr4a
    jaoi impbid1 $.
    $( [9-Jun-2006] $) $( [6-Jun-2006] $)

  ${
    $d j k A $.  $d j k N $.
    $( Bernoulli's inequality, due to Johan Bernoulli (1667-1748). $)
    bernneq $p |- ( ( A e. RR /\ N e. NN0 /\ -u 1 <_ A ) ->
                 ( 1 + ( A x. N ) ) <_ ( ( 1 + A ) ^ N ) ) $=
      cA cr wcel cN cn0 wcel c1 cneg cA cle wbr c1 cA cN cmul co caddc co c1 cA
      caddc co cN cexp co cle wbr cN cn0 wcel cA cr wcel c1 cneg cA cle wbr c1
      cA cN cmul co caddc co c1 cA caddc co cN cexp co cle wbr wi cN cn0 wcel
      cA cr wcel c1 cneg cA cle wbr c1 cA cN cmul co caddc co c1 cA caddc co cN
      cexp co cle wbr cA cr wcel c1 cneg cA cle wbr wa c1 cA vj cv cmul co
      caddc co c1 cA caddc co vj cv cexp co cle wbr wi cA cr wcel c1 cneg cA
      cle wbr wa c1 cA cc0 cmul co caddc co c1 cA caddc co cc0 cexp co cle wbr
      wi cA cr wcel c1 cneg cA cle wbr wa c1 cA vk cv cmul co caddc co c1 cA
      caddc co vk cv cexp co cle wbr wi cA cr wcel c1 cneg cA cle wbr wa c1 cA
      vk cv c1 caddc co cmul co caddc co c1 cA caddc co vk cv c1 caddc co cexp
      co cle wbr wi cA cr wcel c1 cneg cA cle wbr wa c1 cA cN cmul co caddc co
      c1 cA caddc co cN cexp co cle wbr wi vj vk cN vj cv cc0 wceq c1 cA vj cv
      cmul co caddc co c1 cA caddc co vj cv cexp co cle wbr c1 cA cc0 cmul co
      caddc co c1 cA caddc co cc0 cexp co cle wbr cA cr wcel c1 cneg cA cle wbr
      wa vj cv cc0 wceq c1 cA vj cv cmul co caddc co c1 cA cc0 cmul co caddc co
      c1 cA caddc co vj cv cexp co c1 cA caddc co cc0 cexp co cle vj cv cc0
      wceq cA vj cv cmul co cA cc0 cmul co c1 caddc vj cv cc0 cA cmul opreq2
      opreq2d vj cv cc0 c1 cA caddc co cexp opreq2 breq12d imbi2d vj cv vk cv
      wceq c1 cA vj cv cmul co caddc co c1 cA caddc co vj cv cexp co cle wbr c1
      cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr cA cr wcel
      c1 cneg cA cle wbr wa vj cv vk cv wceq c1 cA vj cv cmul co caddc co c1 cA
      vk cv cmul co caddc co c1 cA caddc co vj cv cexp co c1 cA caddc co vk cv
      cexp co cle vj cv vk cv wceq cA vj cv cmul co cA vk cv cmul co c1 caddc
      vj cv vk cv cA cmul opreq2 opreq2d vj cv vk cv c1 cA caddc co cexp opreq2
      breq12d imbi2d vj cv vk cv c1 caddc co wceq c1 cA vj cv cmul co caddc co
      c1 cA caddc co vj cv cexp co cle wbr c1 cA vk cv c1 caddc co cmul co
      caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle wbr cA cr wcel c1
      cneg cA cle wbr wa vj cv vk cv c1 caddc co wceq c1 cA vj cv cmul co caddc
      co c1 cA vk cv c1 caddc co cmul co caddc co c1 cA caddc co vj cv cexp co
      c1 cA caddc co vk cv c1 caddc co cexp co cle vj cv vk cv c1 caddc co wceq
      cA vj cv cmul co cA vk cv c1 caddc co cmul co c1 caddc vj cv vk cv c1
      caddc co cA cmul opreq2 opreq2d vj cv vk cv c1 caddc co c1 cA caddc co
      cexp opreq2 breq12d imbi2d vj cv cN wceq c1 cA vj cv cmul co caddc co c1
      cA caddc co vj cv cexp co cle wbr c1 cA cN cmul co caddc co c1 cA caddc
      co cN cexp co cle wbr cA cr wcel c1 cneg cA cle wbr wa vj cv cN wceq c1
      cA vj cv cmul co caddc co c1 cA cN cmul co caddc co c1 cA caddc co vj cv
      cexp co c1 cA caddc co cN cexp co cle vj cv cN wceq cA vj cv cmul co cA
      cN cmul co c1 caddc vj cv cN cA cmul opreq2 opreq2d vj cv cN c1 cA caddc
      co cexp opreq2 breq12d imbi2d cA cr wcel c1 cA cc0 cmul co caddc co c1 cA
      caddc co cc0 cexp co cle wbr c1 cneg cA cle wbr cA cr wcel cA cc wcel c1
      cA cc0 cmul co caddc co c1 cA caddc co cc0 cexp co cle wbr cA recn cA cc
      wcel c1 cA cc0 cmul co caddc co c1 c1 cA caddc co cc0 cexp co cle cA cc
      wcel c1 cA cc0 cmul co caddc co c1 cc0 caddc co c1 cA cc wcel cA cc0 cmul
      co cc0 c1 caddc cA mul01 opreq2d c1 ax1cn addid1i syl6eq cA cc wcel c1 c1
      cA caddc co cc0 cexp co c1 cle cA cc wcel c1 cA caddc co cc wcel c1 cA
      caddc co cc0 cexp co c1 wceq c1 cc wcel cA cc wcel c1 cA caddc co cc wcel
      ax1cn c1 cA addcl mpan c1 cA caddc co exp0 syl c1 1re leidi syl5breqr
      eqbrtrd syl adantr vk cv cn0 wcel cA cr wcel c1 cneg cA cle wbr wa c1 cA
      vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr c1 cA vk cv
      c1 caddc co cmul co caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle
      wbr vk cv cn0 wcel cA cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co
      caddc co c1 cA caddc co vk cv cexp co cle wbr c1 cA vk cv c1 caddc co
      cmul co caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle wbr wi cA
      cr wcel vk cv cn0 wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1
      cA caddc co vk cv cexp co cle wbr c1 cA vk cv c1 caddc co cmul co caddc
      co c1 cA caddc co vk cv c1 caddc co cexp co cle wbr wi wi cA cr wcel vk
      cv cn0 wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc
      co vk cv cexp co cle wbr c1 cA vk cv c1 caddc co cmul co caddc co c1 cA
      caddc co vk cv c1 caddc co cexp co cle wbr cA cr wcel vk cv cn0 wcel wa
      c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp
      co cle wbr wa wa c1 cA vk cv cmul co caddc co cA caddc co c1 cA caddc co
      vk cv cexp co c1 cA caddc co cmul co c1 cA vk cv c1 caddc co cmul co
      caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle cA cr wcel vk cv
      cn0 wcel wa c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc
      co vk cv cexp co cle wbr wa wa c1 cA vk cv cmul co caddc co cA caddc co
      c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co c1 cA caddc co vk cv
      cexp co c1 cA caddc co cmul co cA cr wcel vk cv cn0 wcel wa c1 cA vk cv
      cmul co caddc co cA caddc co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul
      co caddc co c1 cA caddc co vk cv cexp co cle wbr wa c1 cA vk cv cmul co
      caddc co cr wcel cA cr wcel c1 cA vk cv cmul co caddc co cA caddc co cr
      wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co cA readdcl
      c1 cr wcel cA vk cv cmul co cr wcel c1 cA vk cv cmul co caddc co cr wcel
      cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co readdcl 1re cA cr wcel
      vk cv cr wcel cA vk cv cmul co cr wcel vk cv cn0 wcel cA vk cv remulcl vk
      cv nn0re sylan2 sylancr cA cr wcel vk cv cn0 wcel pm3.26 sylanc adantr cA
      cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co c1 cA caddc co
      cmul co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA
      caddc co vk cv cexp co cle wbr wa c1 cA vk cv cmul co caddc co cr wcel c1
      cA caddc co cr wcel c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co
      cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co c1 cA
      caddc co remulcl c1 cr wcel cA vk cv cmul co cr wcel c1 cA vk cv cmul co
      caddc co cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co readdcl
      1re cA cr wcel vk cv cr wcel cA vk cv cmul co cr wcel vk cv cn0 wcel cA
      vk cv remulcl vk cv nn0re sylan2 sylancr cA cr wcel c1 cA caddc co cr
      wcel vk cv cn0 wcel c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1
      cA readdcl mpan adantr sylanc adantr cA cr wcel vk cv cn0 wcel wa c1 cA
      caddc co vk cv cexp co c1 cA caddc co cmul co cr wcel c1 cneg cA cle wbr
      c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa c1
      cA caddc co vk cv cexp co cr wcel c1 cA caddc co cr wcel c1 cA caddc co
      vk cv cexp co c1 cA caddc co cmul co cr wcel cA cr wcel vk cv cn0 wcel wa
      c1 cA caddc co vk cv cexp co c1 cA caddc co remulcl c1 cA caddc co cr
      wcel vk cv cn0 wcel c1 cA caddc co vk cv cexp co cr wcel cA cr wcel c1 cA
      caddc co vk cv reexpcl c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re
      c1 cA readdcl mpan sylan cA cr wcel c1 cA caddc co cr wcel vk cv cn0 wcel
      c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA readdcl mpan
      adantr sylanc adantr cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co
      caddc co cA caddc co c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co
      cle wbr c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk
      cv cexp co cle wbr wa cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co
      caddc co cA caddc co c1 cA vk cv cmul co caddc co cA caddc co cA vk cv
      cmul co cA cmul co caddc co c1 cA vk cv cmul co caddc co c1 cA caddc co
      cmul co cle cA cr wcel vk cv cn0 wcel wa cc0 cA vk cv cmul co cA cmul co
      cle wbr c1 cA vk cv cmul co caddc co cA caddc co c1 cA vk cv cmul co
      caddc co cA caddc co cA vk cv cmul co cA cmul co caddc co cle wbr cA cr
      wcel vk cv cn0 wcel wa cc0 cA cA cmul co vk cv cmul co cA vk cv cmul co
      cA cmul co cle cA cA cmul co cr wcel cc0 cA cA cmul co cle wbr wa vk cv
      cr wcel cc0 vk cv cle wbr wa cc0 cA cA cmul co vk cv cmul co cle wbr cA
      cr wcel vk cv cn0 wcel cA cA cmul co vk cv mulge0 cA cr wcel cA cA cmul
      co cr wcel cc0 cA cA cmul co cle wbr cA cr wcel cA cA cmul co cr wcel cA
      cA axmulrcl anidms cA msqge0 jca vk cv cn0 wcel vk cv cr wcel cc0 vk cv
      cle wbr vk cv nn0re vk cv nn0ge0 jca syl2an cA cc wcel cA cc wcel vk cv
      cc wcel cA cA cmul co vk cv cmul co cA vk cv cmul co cA cmul co wceq cA
      cr wcel vk cv cn0 wcel wa cA cA vk cv mul23 cA cr wcel cA cc wcel vk cv
      cn0 wcel cA recn adantr cA cr wcel cA cc wcel vk cv cn0 wcel cA recn
      adantr vk cv cn0 wcel vk cv cc wcel cA cr wcel vk cv nn0cn adantl syl3anc
      breqtrd c1 cA vk cv cmul co caddc co cA caddc co cr wcel cA vk cv cmul co
      cA cmul co cr wcel cc0 cA vk cv cmul co cA cmul co cle wbr c1 cA vk cv
      cmul co caddc co cA caddc co c1 cA vk cv cmul co caddc co cA caddc co cA
      vk cv cmul co cA cmul co caddc co cle wbr wb cA cr wcel vk cv cn0 wcel wa
      c1 cA vk cv cmul co caddc co cA caddc co cA vk cv cmul co cA cmul co
      addge01 c1 cA vk cv cmul co caddc co cr wcel cA cr wcel c1 cA vk cv cmul
      co caddc co cA caddc co cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv
      cmul co caddc co cA readdcl c1 cr wcel cA vk cv cmul co cr wcel c1 cA vk
      cv cmul co caddc co cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul
      co readdcl 1re cA cr wcel vk cv cr wcel cA vk cv cmul co cr wcel vk cv
      cn0 wcel cA vk cv remulcl vk cv nn0re sylan2 sylancr cA cr wcel vk cv cn0
      wcel pm3.26 sylanc cA cr wcel vk cv cr wcel cA vk cv cmul co cA cmul co
      cr wcel vk cv cn0 wcel cA vk cv cmul co cr wcel cA cr wcel cA vk cv cmul
      co cA cmul co cr wcel cA cr wcel vk cv cr wcel wa cA vk cv cmul co cA
      remulcl cA vk cv remulcl cA cr wcel vk cv cr wcel pm3.26 sylanc vk cv
      nn0re sylan2 sylanc mpbid cA cc wcel vk cv cc wcel c1 cA vk cv cmul co
      caddc co cA caddc co cA vk cv cmul co cA cmul co caddc co c1 cA vk cv
      cmul co caddc co c1 cA caddc co cmul co wceq cA cr wcel vk cv cn0 wcel cA
      cc wcel vk cv cc wcel wa c1 cA vk cv cmul co caddc co cA caddc co cA vk
      cv cmul co cA cmul co caddc co c1 cA vk cv cmul co caddc co cA cA vk cv
      cmul co cA cmul co caddc co caddc co c1 cA vk cv cmul co caddc co c1 cA
      caddc co cmul co c1 cA vk cv cmul co caddc co cc wcel cA cc wcel cA vk cv
      cmul co cA cmul co cc wcel c1 cA vk cv cmul co caddc co cA caddc co cA vk
      cv cmul co cA cmul co caddc co c1 cA vk cv cmul co caddc co cA cA vk cv
      cmul co cA cmul co caddc co caddc co wceq cA cc wcel vk cv cc wcel wa c1
      cA vk cv cmul co caddc co cA cA vk cv cmul co cA cmul co addass c1 cc
      wcel cA vk cv cmul co cc wcel c1 cA vk cv cmul co caddc co cc wcel cA cc
      wcel vk cv cc wcel wa c1 cA vk cv cmul co addcl ax1cn cA vk cv mulcl
      sylancr cA cc wcel vk cv cc wcel pm3.26 cA vk cv cmul co cc wcel cA cc
      wcel cA vk cv cmul co cA cmul co cc wcel cA cc wcel vk cv cc wcel wa cA
      vk cv cmul co cA mulcl cA vk cv mulcl cA cc wcel vk cv cc wcel pm3.26
      sylanc syl3anc cA vk cv cmul co cc wcel cA cc wcel c1 cA vk cv cmul co
      caddc co c1 cA caddc co cmul co c1 cA vk cv cmul co caddc co cA cA vk cv
      cmul co cA cmul co caddc co caddc co wceq cA cc wcel vk cv cc wcel wa cA
      vk cv cmul co cA muladd11 cA vk cv mulcl cA cc wcel vk cv cc wcel pm3.26
      sylanc eqtr4d cA recn vk cv nn0cn syl2an breqtrd adantr c1 cA vk cv cmul
      co caddc co cr wcel c1 cA caddc co vk cv cexp co cr wcel c1 cA caddc co
      cr wcel cc0 c1 cA caddc co cle wbr wa w3a c1 cA vk cv cmul co caddc co c1
      cA caddc co vk cv cexp co cle wbr c1 cA vk cv cmul co caddc co c1 cA
      caddc co cmul co c1 cA caddc co vk cv cexp co c1 cA caddc co cmul co cle
      wbr cA cr wcel vk cv cn0 wcel wa c1 cneg cA cle wbr c1 cA vk cv cmul co
      caddc co c1 cA caddc co vk cv cexp co cle wbr wa wa c1 cA vk cv cmul co
      caddc co c1 cA caddc co vk cv cexp co c1 cA caddc co lemul1a cA cr wcel
      vk cv cn0 wcel wa c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA
      caddc co vk cv cexp co cle wbr wa wa c1 cA vk cv cmul co caddc co cr wcel
      c1 cA caddc co vk cv cexp co cr wcel c1 cA caddc co cr wcel cc0 c1 cA
      caddc co cle wbr wa cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co
      caddc co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA
      caddc co vk cv cexp co cle wbr wa c1 cr wcel cA vk cv cmul co cr wcel c1
      cA vk cv cmul co caddc co cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk
      cv cmul co readdcl 1re cA cr wcel vk cv cr wcel cA vk cv cmul co cr wcel
      vk cv cn0 wcel cA vk cv remulcl vk cv nn0re sylan2 sylancr adantr cA cr
      wcel vk cv cn0 wcel wa c1 cA caddc co vk cv cexp co cr wcel c1 cneg cA
      cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr
      wa c1 cA caddc co cr wcel vk cv cn0 wcel c1 cA caddc co vk cv cexp co cr
      wcel cA cr wcel c1 cA caddc co vk cv reexpcl c1 cr wcel cA cr wcel c1 cA
      caddc co cr wcel 1re c1 cA readdcl mpan sylan adantr cA cr wcel vk cv cn0
      wcel wa c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk
      cv cexp co cle wbr wa wa c1 cA caddc co cr wcel cc0 c1 cA caddc co cle
      wbr cA cr wcel vk cv cn0 wcel wa c1 cA caddc co cr wcel c1 cneg cA cle
      wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa
      cA cr wcel c1 cA caddc co cr wcel vk cv cn0 wcel c1 cr wcel cA cr wcel c1
      cA caddc co cr wcel 1re c1 cA readdcl mpan adantr adantr cA cr wcel c1
      cneg cA cle wbr cc0 c1 cA caddc co cle wbr vk cv cn0 wcel c1 cA vk cv
      cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr cA cr wcel c1 cneg
      cA cle wbr cc0 c1 cA caddc co cle wbr cA cr wcel c1 cneg cA cle wbr c1 c1
      cneg caddc co c1 cA caddc co cle wbr cc0 c1 cA caddc co cle wbr c1 cneg
      cr wcel cA cr wcel c1 cr wcel c1 cneg cA cle wbr c1 c1 cneg caddc co c1
      cA caddc co cle wbr wb c1 1re renegcli 1re c1 cneg cA c1 leadd2 mp3an13
      c1 c1 cneg caddc co cc0 c1 cA caddc co cle c1 ax1cn negidi breq1i syl6bb
      biimpa ad2ant2r jca 3jca cA cr wcel vk cv cn0 wcel wa c1 cneg cA cle wbr
      c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr simprr
      sylanc letrd cA cr wcel vk cv cn0 wcel wa c1 cA vk cv c1 caddc co cmul co
      caddc co c1 cA vk cv cmul co caddc co cA caddc co wceq c1 cneg cA cle wbr
      c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa cA
      cc wcel vk cv cc wcel c1 cA vk cv c1 caddc co cmul co caddc co c1 cA vk
      cv cmul co caddc co cA caddc co wceq cA cr wcel vk cv cn0 wcel cA cc wcel
      vk cv cc wcel wa c1 cA vk cv c1 caddc co cmul co caddc co c1 cA vk cv
      cmul co cA caddc co caddc co c1 cA vk cv cmul co caddc co cA caddc co cA
      cc wcel vk cv cc wcel wa cA vk cv c1 caddc co cmul co cA vk cv cmul co cA
      caddc co c1 caddc cA cc wcel vk cv cc wcel wa cA vk cv c1 caddc co cmul
      co cA vk cv cmul co cA c1 cmul co caddc co cA vk cv cmul co cA caddc co
      cA cc wcel vk cv cc wcel c1 cc wcel cA vk cv c1 caddc co cmul co cA vk cv
      cmul co cA c1 cmul co caddc co wceq ax1cn cA vk cv c1 adddi mp3an3 cA cc
      wcel vk cv cc wcel wa cA c1 cmul co cA cA vk cv cmul co caddc cA cc wcel
      cA c1 cmul co cA wceq vk cv cc wcel cA ax1id adantr opreq2d eqtrd opreq2d
      cA vk cv cmul co cc wcel cA cc wcel c1 cA vk cv cmul co caddc co cA caddc
      co c1 cA vk cv cmul co cA caddc co caddc co wceq cA cc wcel vk cv cc wcel
      wa c1 cc wcel cA vk cv cmul co cc wcel cA cc wcel c1 cA vk cv cmul co
      caddc co cA caddc co c1 cA vk cv cmul co cA caddc co caddc co wceq ax1cn
      c1 cA vk cv cmul co cA addass mp3an1 cA vk cv mulcl cA cc wcel vk cv cc
      wcel pm3.26 sylanc eqtr4d cA recn vk cv nn0cn syl2an adantr cA cr wcel vk
      cv cn0 wcel wa c1 cA caddc co vk cv c1 caddc co cexp co c1 cA caddc co vk
      cv cexp co c1 cA caddc co cmul co wceq c1 cneg cA cle wbr c1 cA vk cv
      cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa c1 cA caddc co
      cc wcel vk cv cn0 wcel c1 cA caddc co vk cv c1 caddc co cexp co c1 cA
      caddc co vk cv cexp co c1 cA caddc co cmul co wceq cA cr wcel c1 cA caddc
      co vk cv expp1 c1 cc wcel cA cc wcel c1 cA caddc co cc wcel cA cr wcel c1
      cA addcl ax1cn cA recn sylancr sylan adantr 3brtr4d exp43 com12 imp3a a2d
      nn0ind exp3a com12 3imp $.
      $( [25-Jul-2009] $) $( [21-Feb-2005] $)

    $( Bernoulli's inequality, due to Johan Bernoulli (1667-1748). $)
    bernneqOLD $p |- ( ( A e. RR /\ N e. NN0 /\ -u 1 <_ A ) ->
                 ( 1 + ( A x. N ) ) <_ ( ( 1 + A ) ^ N ) ) $=
      cA cr wcel cN cn0 wcel c1 cneg cA cle wbr c1 cA cN cmul co caddc co c1 cA
      caddc co cN cexp co cle wbr cN cn0 wcel cA cr wcel c1 cneg cA cle wbr c1
      cA cN cmul co caddc co c1 cA caddc co cN cexp co cle wbr wi cN cn0 wcel
      cA cr wcel c1 cneg cA cle wbr c1 cA cN cmul co caddc co c1 cA caddc co cN
      cexp co cle wbr cA cr wcel c1 cneg cA cle wbr wa c1 cA vj cv cmul co
      caddc co c1 cA caddc co vj cv cexp co cle wbr wi cA cr wcel c1 cneg cA
      cle wbr wa c1 cA cc0 cmul co caddc co c1 cA caddc co cc0 cexp co cle wbr
      wi cA cr wcel c1 cneg cA cle wbr wa c1 cA vk cv cmul co caddc co c1 cA
      caddc co vk cv cexp co cle wbr wi cA cr wcel c1 cneg cA cle wbr wa c1 cA
      vk cv c1 caddc co cmul co caddc co c1 cA caddc co vk cv c1 caddc co cexp
      co cle wbr wi cA cr wcel c1 cneg cA cle wbr wa c1 cA cN cmul co caddc co
      c1 cA caddc co cN cexp co cle wbr wi vj vk cN vj cv cc0 wceq c1 cA vj cv
      cmul co caddc co c1 cA caddc co vj cv cexp co cle wbr c1 cA cc0 cmul co
      caddc co c1 cA caddc co cc0 cexp co cle wbr cA cr wcel c1 cneg cA cle wbr
      wa vj cv cc0 wceq c1 cA vj cv cmul co caddc co c1 cA cc0 cmul co caddc co
      c1 cA caddc co vj cv cexp co c1 cA caddc co cc0 cexp co cle vj cv cc0
      wceq cA vj cv cmul co cA cc0 cmul co c1 caddc vj cv cc0 cA cmul opreq2
      opreq2d vj cv cc0 c1 cA caddc co cexp opreq2 breq12d imbi2d vj cv vk cv
      wceq c1 cA vj cv cmul co caddc co c1 cA caddc co vj cv cexp co cle wbr c1
      cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr cA cr wcel
      c1 cneg cA cle wbr wa vj cv vk cv wceq c1 cA vj cv cmul co caddc co c1 cA
      vk cv cmul co caddc co c1 cA caddc co vj cv cexp co c1 cA caddc co vk cv
      cexp co cle vj cv vk cv wceq cA vj cv cmul co cA vk cv cmul co c1 caddc
      vj cv vk cv cA cmul opreq2 opreq2d vj cv vk cv c1 cA caddc co cexp opreq2
      breq12d imbi2d vj cv vk cv c1 caddc co wceq c1 cA vj cv cmul co caddc co
      c1 cA caddc co vj cv cexp co cle wbr c1 cA vk cv c1 caddc co cmul co
      caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle wbr cA cr wcel c1
      cneg cA cle wbr wa vj cv vk cv c1 caddc co wceq c1 cA vj cv cmul co caddc
      co c1 cA vk cv c1 caddc co cmul co caddc co c1 cA caddc co vj cv cexp co
      c1 cA caddc co vk cv c1 caddc co cexp co cle vj cv vk cv c1 caddc co wceq
      cA vj cv cmul co cA vk cv c1 caddc co cmul co c1 caddc vj cv vk cv c1
      caddc co cA cmul opreq2 opreq2d vj cv vk cv c1 caddc co c1 cA caddc co
      cexp opreq2 breq12d imbi2d vj cv cN wceq c1 cA vj cv cmul co caddc co c1
      cA caddc co vj cv cexp co cle wbr c1 cA cN cmul co caddc co c1 cA caddc
      co cN cexp co cle wbr cA cr wcel c1 cneg cA cle wbr wa vj cv cN wceq c1
      cA vj cv cmul co caddc co c1 cA cN cmul co caddc co c1 cA caddc co vj cv
      cexp co c1 cA caddc co cN cexp co cle vj cv cN wceq cA vj cv cmul co cA
      cN cmul co c1 caddc vj cv cN cA cmul opreq2 opreq2d vj cv cN c1 cA caddc
      co cexp opreq2 breq12d imbi2d cA cr wcel c1 cA cc0 cmul co caddc co c1 cA
      caddc co cc0 cexp co cle wbr c1 cneg cA cle wbr cA cr wcel cA cc wcel c1
      cA cc0 cmul co caddc co c1 cA caddc co cc0 cexp co cle wbr cA recn cA cc
      wcel c1 cA cc0 cmul co caddc co c1 c1 cA caddc co cc0 cexp co cle cA cc
      wcel c1 cA cc0 cmul co caddc co c1 cc0 caddc co c1 cA cc wcel cA cc0 cmul
      co cc0 c1 caddc cA mul01 opreq2d c1 ax1cn addid1i syl6eq cA cc wcel c1 c1
      cA caddc co cc0 cexp co c1 cle cA cc wcel c1 cA caddc co cc wcel c1 cA
      caddc co cc0 cexp co c1 wceq c1 cc wcel cA cc wcel c1 cA caddc co cc wcel
      ax1cn c1 cA addcl mpan c1 cA caddc co exp0 syl c1 1re leidi syl5breqr
      eqbrtrd syl adantr vk cv cn0 wcel cA cr wcel c1 cneg cA cle wbr wa c1 cA
      vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr c1 cA vk cv
      c1 caddc co cmul co caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle
      wbr vk cv cn0 wcel cA cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co
      caddc co c1 cA caddc co vk cv cexp co cle wbr c1 cA vk cv c1 caddc co
      cmul co caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle wbr wi cA
      cr wcel vk cv cn0 wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1
      cA caddc co vk cv cexp co cle wbr c1 cA vk cv c1 caddc co cmul co caddc
      co c1 cA caddc co vk cv c1 caddc co cexp co cle wbr wi wi cA cr wcel vk
      cv cn0 wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc
      co vk cv cexp co cle wbr c1 cA vk cv c1 caddc co cmul co caddc co c1 cA
      caddc co vk cv c1 caddc co cexp co cle wbr cA cr wcel vk cv cn0 wcel wa
      c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp
      co cle wbr wa wa c1 cA vk cv cmul co caddc co cA caddc co c1 cA caddc co
      vk cv cexp co c1 cA caddc co cmul co c1 cA vk cv c1 caddc co cmul co
      caddc co c1 cA caddc co vk cv c1 caddc co cexp co cle cA cr wcel vk cv
      cn0 wcel wa c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc
      co vk cv cexp co cle wbr wa wa c1 cA vk cv cmul co caddc co cA caddc co
      c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co c1 cA caddc co vk cv
      cexp co c1 cA caddc co cmul co cA cr wcel vk cv cn0 wcel wa c1 cA vk cv
      cmul co caddc co cA caddc co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul
      co caddc co c1 cA caddc co vk cv cexp co cle wbr wa c1 cA vk cv cmul co
      caddc co cr wcel cA cr wcel c1 cA vk cv cmul co caddc co cA caddc co cr
      wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co cA readdcl
      c1 cr wcel cA vk cv cmul co cr wcel c1 cA vk cv cmul co caddc co cr wcel
      cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co readdcl 1re cA cr wcel
      vk cv cr wcel cA vk cv cmul co cr wcel vk cv cn0 wcel cA vk cv remulcl vk
      cv nn0re sylan2 sylancr cA cr wcel vk cv cn0 wcel pm3.26 sylanc adantr cA
      cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co c1 cA caddc co
      cmul co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA
      caddc co vk cv cexp co cle wbr wa c1 cA vk cv cmul co caddc co cr wcel c1
      cA caddc co cr wcel c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co
      cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co c1 cA
      caddc co remulcl c1 cr wcel cA vk cv cmul co cr wcel c1 cA vk cv cmul co
      caddc co cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co readdcl
      1re cA cr wcel vk cv cr wcel cA vk cv cmul co cr wcel vk cv cn0 wcel cA
      vk cv remulcl vk cv nn0re sylan2 sylancr cA cr wcel c1 cA caddc co cr
      wcel vk cv cn0 wcel c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1
      cA readdcl mpan adantr sylanc adantr cA cr wcel vk cv cn0 wcel wa c1 cA
      caddc co vk cv cexp co c1 cA caddc co cmul co cr wcel c1 cneg cA cle wbr
      c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa c1
      cA caddc co vk cv cexp co cr wcel c1 cA caddc co cr wcel c1 cA caddc co
      vk cv cexp co c1 cA caddc co cmul co cr wcel cA cr wcel vk cv cn0 wcel wa
      c1 cA caddc co vk cv cexp co c1 cA caddc co remulcl c1 cA caddc co cr
      wcel vk cv cn0 wcel c1 cA caddc co vk cv cexp co cr wcel cA cr wcel c1 cA
      caddc co vk cv reexpcl c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re
      c1 cA readdcl mpan sylan cA cr wcel c1 cA caddc co cr wcel vk cv cn0 wcel
      c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA readdcl mpan
      adantr sylanc adantr cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co
      caddc co cA caddc co c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co
      cle wbr c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk
      cv cexp co cle wbr wa cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co
      caddc co cA caddc co c1 cA vk cv cmul co caddc co cA caddc co cA vk cv
      cmul co cA cmul co caddc co c1 cA vk cv cmul co caddc co c1 cA caddc co
      cmul co cle cA cr wcel vk cv cn0 wcel wa cc0 cA vk cv cmul co cA cmul co
      cle wbr c1 cA vk cv cmul co caddc co cA caddc co c1 cA vk cv cmul co
      caddc co cA caddc co cA vk cv cmul co cA cmul co caddc co cle wbr cA cr
      wcel vk cv cn0 wcel wa cc0 cA cA cmul co vk cv cmul co cA vk cv cmul co
      cA cmul co cle cA cA cmul co cr wcel vk cv cr wcel wa cc0 cA cA cmul co
      cle wbr cc0 vk cv cle wbr wa cc0 cA cA cmul co vk cv cmul co cle wbr cA
      cr wcel vk cv cn0 wcel wa cA cA cmul co vk cv mulge0OLD cA cr wcel cA cA
      cmul co cr wcel vk cv cn0 wcel vk cv cr wcel cA cr wcel cA cA cmul co cr
      wcel cA cA remulcl anidms vk cv nn0re anim12i cA cr wcel cc0 cA cA cmul
      co cle wbr vk cv cn0 wcel cc0 vk cv cle wbr cA msqge0 vk cv nn0ge0
      anim12i sylanc cA cc wcel cA cc wcel vk cv cc wcel cA cA cmul co vk cv
      cmul co cA vk cv cmul co cA cmul co wceq cA cr wcel vk cv cn0 wcel wa cA
      cA vk cv mul23 cA cr wcel cA cc wcel vk cv cn0 wcel cA recn adantr cA cr
      wcel cA cc wcel vk cv cn0 wcel cA recn adantr vk cv cn0 wcel vk cv cc
      wcel cA cr wcel vk cv nn0cn adantl syl3anc breqtrd c1 cA vk cv cmul co
      caddc co cA caddc co cr wcel cA vk cv cmul co cA cmul co cr wcel cc0 cA
      vk cv cmul co cA cmul co cle wbr c1 cA vk cv cmul co caddc co cA caddc co
      c1 cA vk cv cmul co caddc co cA caddc co cA vk cv cmul co cA cmul co
      caddc co cle wbr wb cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co
      caddc co cA caddc co cA vk cv cmul co cA cmul co addge01 c1 cA vk cv cmul
      co caddc co cr wcel cA cr wcel c1 cA vk cv cmul co caddc co cA caddc co
      cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co cA
      readdcl c1 cr wcel cA vk cv cmul co cr wcel c1 cA vk cv cmul co caddc co
      cr wcel cA cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co readdcl 1re cA
      cr wcel vk cv cr wcel cA vk cv cmul co cr wcel vk cv cn0 wcel cA vk cv
      remulcl vk cv nn0re sylan2 sylancr cA cr wcel vk cv cn0 wcel pm3.26
      sylanc cA cr wcel vk cv cr wcel cA vk cv cmul co cA cmul co cr wcel vk cv
      cn0 wcel cA vk cv cmul co cr wcel cA cr wcel cA vk cv cmul co cA cmul co
      cr wcel cA cr wcel vk cv cr wcel wa cA vk cv cmul co cA remulcl cA vk cv
      remulcl cA cr wcel vk cv cr wcel pm3.26 sylanc vk cv nn0re sylan2 sylanc
      mpbid cA cc wcel vk cv cc wcel c1 cA vk cv cmul co caddc co cA caddc co
      cA vk cv cmul co cA cmul co caddc co c1 cA vk cv cmul co caddc co c1 cA
      caddc co cmul co wceq cA cr wcel vk cv cn0 wcel cA cc wcel vk cv cc wcel
      wa c1 cA vk cv cmul co caddc co cA caddc co cA vk cv cmul co cA cmul co
      caddc co c1 cA vk cv cmul co caddc co cA cA vk cv cmul co cA cmul co
      caddc co caddc co c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co c1
      cA vk cv cmul co caddc co cc wcel cA cc wcel cA vk cv cmul co cA cmul co
      cc wcel c1 cA vk cv cmul co caddc co cA caddc co cA vk cv cmul co cA cmul
      co caddc co c1 cA vk cv cmul co caddc co cA cA vk cv cmul co cA cmul co
      caddc co caddc co wceq cA cc wcel vk cv cc wcel wa c1 cA vk cv cmul co
      caddc co cA cA vk cv cmul co cA cmul co addass c1 cc wcel cA vk cv cmul
      co cc wcel c1 cA vk cv cmul co caddc co cc wcel cA cc wcel vk cv cc wcel
      wa c1 cA vk cv cmul co addcl ax1cn cA vk cv mulcl sylancr cA cc wcel vk
      cv cc wcel pm3.26 cA vk cv cmul co cc wcel cA cc wcel cA vk cv cmul co cA
      cmul co cc wcel cA cc wcel vk cv cc wcel wa cA vk cv cmul co cA mulcl cA
      vk cv mulcl cA cc wcel vk cv cc wcel pm3.26 sylanc syl3anc cA vk cv cmul
      co cc wcel cA cc wcel c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co
      c1 cA vk cv cmul co caddc co cA cA vk cv cmul co cA cmul co caddc co
      caddc co wceq cA cc wcel vk cv cc wcel wa cA vk cv cmul co cA muladd11 cA
      vk cv mulcl cA cc wcel vk cv cc wcel pm3.26 sylanc eqtr4d cA recn vk cv
      nn0cn syl2an breqtrd adantr c1 cA vk cv cmul co caddc co cr wcel c1 cA
      caddc co vk cv cexp co cr wcel c1 cA caddc co cr wcel cc0 c1 cA caddc co
      cle wbr wa w3a c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co
      cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co cmul co c1 cA caddc
      co vk cv cexp co c1 cA caddc co cmul co cle wbr cA cr wcel vk cv cn0 wcel
      wa c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv
      cexp co cle wbr wa wa c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv
      cexp co c1 cA caddc co lemul1a cA cr wcel vk cv cn0 wcel wa c1 cneg cA
      cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr
      wa wa c1 cA vk cv cmul co caddc co cr wcel c1 cA caddc co vk cv cexp co
      cr wcel c1 cA caddc co cr wcel cc0 c1 cA caddc co cle wbr wa cA cr wcel
      vk cv cn0 wcel wa c1 cA vk cv cmul co caddc co cr wcel c1 cneg cA cle wbr
      c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa c1
      cr wcel cA vk cv cmul co cr wcel c1 cA vk cv cmul co caddc co cr wcel cA
      cr wcel vk cv cn0 wcel wa c1 cA vk cv cmul co readdcl 1re cA cr wcel vk
      cv cr wcel cA vk cv cmul co cr wcel vk cv cn0 wcel cA vk cv remulcl vk cv
      nn0re sylan2 sylancr adantr cA cr wcel vk cv cn0 wcel wa c1 cA caddc co
      vk cv cexp co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1
      cA caddc co vk cv cexp co cle wbr wa c1 cA caddc co cr wcel vk cv cn0
      wcel c1 cA caddc co vk cv cexp co cr wcel cA cr wcel c1 cA caddc co vk cv
      reexpcl c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA readdcl
      mpan sylan adantr cA cr wcel vk cv cn0 wcel wa c1 cneg cA cle wbr c1 cA
      vk cv cmul co caddc co c1 cA caddc co vk cv cexp co cle wbr wa wa c1 cA
      caddc co cr wcel cc0 c1 cA caddc co cle wbr cA cr wcel vk cv cn0 wcel wa
      c1 cA caddc co cr wcel c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1
      cA caddc co vk cv cexp co cle wbr wa cA cr wcel c1 cA caddc co cr wcel vk
      cv cn0 wcel c1 cr wcel cA cr wcel c1 cA caddc co cr wcel 1re c1 cA
      readdcl mpan adantr adantr cA cr wcel c1 cneg cA cle wbr cc0 c1 cA caddc
      co cle wbr vk cv cn0 wcel c1 cA vk cv cmul co caddc co c1 cA caddc co vk
      cv cexp co cle wbr cA cr wcel c1 cneg cA cle wbr cc0 c1 cA caddc co cle
      wbr cA cr wcel c1 cneg cA cle wbr c1 c1 cneg caddc co c1 cA caddc co cle
      wbr cc0 c1 cA caddc co cle wbr c1 cneg cr wcel cA cr wcel c1 cr wcel c1
      cneg cA cle wbr c1 c1 cneg caddc co c1 cA caddc co cle wbr wb c1 1re
      renegcli 1re c1 cneg cA c1 leadd2 mp3an13 c1 c1 cneg caddc co cc0 c1 cA
      caddc co cle c1 ax1cn negidi breq1i syl6bb biimpa ad2ant2r jca 3jca cA cr
      wcel vk cv cn0 wcel wa c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1
      cA caddc co vk cv cexp co cle wbr simprr sylanc letrd cA cr wcel vk cv
      cn0 wcel wa c1 cA vk cv c1 caddc co cmul co caddc co c1 cA vk cv cmul co
      caddc co cA caddc co wceq c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co
      c1 cA caddc co vk cv cexp co cle wbr wa cA cc wcel vk cv cc wcel c1 cA vk
      cv c1 caddc co cmul co caddc co c1 cA vk cv cmul co caddc co cA caddc co
      wceq cA cr wcel vk cv cn0 wcel cA cc wcel vk cv cc wcel wa c1 cA vk cv c1
      caddc co cmul co caddc co c1 cA vk cv cmul co cA caddc co caddc co c1 cA
      vk cv cmul co caddc co cA caddc co cA cc wcel vk cv cc wcel wa cA vk cv
      c1 caddc co cmul co cA vk cv cmul co cA caddc co c1 caddc cA cc wcel vk
      cv cc wcel wa cA vk cv c1 caddc co cmul co cA vk cv cmul co cA c1 cmul co
      caddc co cA vk cv cmul co cA caddc co cA cc wcel vk cv cc wcel c1 cc wcel
      cA vk cv c1 caddc co cmul co cA vk cv cmul co cA c1 cmul co caddc co wceq
      ax1cn cA vk cv c1 adddi mp3an3 cA cc wcel vk cv cc wcel wa cA c1 cmul co
      cA cA vk cv cmul co caddc cA cc wcel cA c1 cmul co cA wceq vk cv cc wcel
      cA ax1id adantr opreq2d eqtrd opreq2d cA vk cv cmul co cc wcel cA cc wcel
      c1 cA vk cv cmul co caddc co cA caddc co c1 cA vk cv cmul co cA caddc co
      caddc co wceq cA cc wcel vk cv cc wcel wa c1 cc wcel cA vk cv cmul co cc
      wcel cA cc wcel c1 cA vk cv cmul co caddc co cA caddc co c1 cA vk cv cmul
      co cA caddc co caddc co wceq ax1cn c1 cA vk cv cmul co cA addass mp3an1
      cA vk cv mulcl cA cc wcel vk cv cc wcel pm3.26 sylanc eqtr4d cA recn vk
      cv nn0cn syl2an adantr cA cr wcel vk cv cn0 wcel wa c1 cA caddc co vk cv
      c1 caddc co cexp co c1 cA caddc co vk cv cexp co c1 cA caddc co cmul co
      wceq c1 cneg cA cle wbr c1 cA vk cv cmul co caddc co c1 cA caddc co vk cv
      cexp co cle wbr wa c1 cA caddc co cc wcel vk cv cn0 wcel c1 cA caddc co
      vk cv c1 caddc co cexp co c1 cA caddc co vk cv cexp co c1 cA caddc co
      cmul co wceq cA cr wcel c1 cA caddc co vk cv expp1 c1 cc wcel cA cc wcel
      c1 cA caddc co cc wcel cA cr wcel c1 cA addcl ax1cn cA recn sylancr sylan
      adantr 3brtr4d exp43 com12 imp3a a2d nn0ind exp3a com12 3imp $.
      $( [11-Oct-2006] $) $( [21-Feb-2005] $)
  $}

  $( Variation of Bernoulli's inequality ~ bernneq . $)
  bernneq2 $p |- ( ( A e. RR /\ N e. NN0 /\ 0 <_ A ) ->
               ( ( ( A - 1 ) x. N ) + 1 ) <_ ( A ^ N ) ) $=
    cA cr wcel cN cn0 wcel cc0 cA cle wbr w3a c1 cA c1 cmin co cN cmul co caddc
    co c1 cA c1 cmin co caddc co cN cexp co cA c1 cmin co cN cmul co c1 caddc
    co cA cN cexp co cle cA c1 cmin co cr wcel cN cn0 wcel c1 cneg cA c1 cmin
    co cle wbr c1 cA c1 cmin co cN cmul co caddc co c1 cA c1 cmin co caddc co
    cN cexp co cle wbr cA cr wcel cN cn0 wcel cc0 cA cle wbr w3a cA c1 cmin co
    cN bernneq cA cr wcel cN cn0 wcel cA c1 cmin co cr wcel cc0 cA cle wbr cA
    peano2rem 3ad2ant1 cA cr wcel cN cn0 wcel cc0 cA cle wbr 3simp2 cA cr wcel
    cc0 cA cle wbr c1 cneg cA c1 cmin co cle wbr cN cn0 wcel cA cr wcel cc0 cA
    cle wbr wa cc0 c1 cmin co cA c1 cmin co c1 cneg cle cA cr wcel cc0 cA cle
    wbr cc0 c1 cmin co cA c1 cmin co cle wbr cc0 cr wcel cA cr wcel c1 cr wcel
    cc0 cA cle wbr cc0 c1 cmin co cA c1 cmin co cle wbr wb 0re 1re cc0 cA c1
    lesub1 mp3an13 biimpa c1 df-neg syl5eqbr 3adant2 syl3anc cA cr wcel cN cn0
    wcel c1 cA c1 cmin co cN cmul co caddc co cA c1 cmin co cN cmul co c1 caddc
    co wceq cc0 cA cle wbr c1 cc wcel cA c1 cmin co cN cmul co cc wcel c1 cA c1
    cmin co cN cmul co caddc co cA c1 cmin co cN cmul co c1 caddc co wceq cA cr
    wcel cN cn0 wcel wa c1 cA c1 cmin co cN cmul co addcom ax1cn cA c1 cmin co
    cc wcel cN cc wcel cA c1 cmin co cN cmul co cc wcel cA cr wcel cN cn0 wcel
    cA c1 cmin co cN mulcl cA cr wcel cA c1 cmin co cA peano2rem recnd cN nn0cn
    syl2an sylancr 3adant3 cA cr wcel cN cn0 wcel c1 cA c1 cmin co caddc co cN
    cexp co cA cN cexp co wceq cc0 cA cle wbr cA cr wcel c1 cA c1 cmin co caddc
    co cA cN cexp c1 cc wcel cA cc wcel c1 cA c1 cmin co caddc co cA wceq cA cr
    wcel c1 cA pncan3 ax1cn cA recn sylancr opreq1d 3ad2ant1 3brtr3d $.
    $( [26-Oct-2007] $) $( [18-Oct-2007] $)

  ${
    $d j k A $.  $d j k B $.
    $( MAY BE REVISED - note that min w/ ad2antlr, ad2antrl make compressed
       proof longer $)
    $( Exponentiation with a mantissa greater than 1 has no upper bound. $)
    expnbnd $p |- ( ( A e. RR /\ B e. RR /\ 1 < B ) ->
          E. k e. NN A < ( B ^ k ) ) $=
      cA cr wcel cB cr wcel c1 cB clt wbr w3a cA cB vk cv cexp co clt wbr vk cn
      wrex cA c1 c1 cn wcel cA cB c1 cexp co clt wbr cA cB vk cv cexp co clt
      wbr vk cn wrex cA cr wcel cB cr wcel c1 cB clt wbr w3a cA c1 clt wbr wa
      cA cB vk cv cexp co clt wbr cA cB c1 cexp co clt wbr vk c1 cn vk cv c1
      wceq cB vk cv cexp co cB c1 cexp co cA clt vk cv c1 cB cexp opreq2 breq2d
      rcla4ev 1nn cA cr wcel cB cr wcel c1 cB clt wbr w3a cA c1 clt wbr wa cA
      cB cB c1 cexp co clt cA cr wcel cB cr wcel c1 cB clt wbr cA c1 clt wbr cA
      cB clt wbr cA cr wcel cB cr wcel cA c1 clt wbr c1 cB clt wbr cA cB clt
      wbr cA cr wcel cB cr wcel cA c1 clt wbr c1 cB clt wbr cA cB clt wbr cA cr
      wcel c1 cr wcel cB cr wcel cA c1 clt wbr c1 cB clt wbr wa cA cB clt wbr
      wi 1re cA c1 cB axlttrn mp3an2 exp4b com34 3imp1 cA cr wcel cB cr wcel c1
      cB clt wbr w3a cB c1 cexp co cB wceq cA c1 clt wbr cB cr wcel cA cr wcel
      cB c1 cexp co cB wceq c1 cB clt wbr cB cr wcel cB cc wcel cB c1 cexp co
      cB wceq cB recn cB exp1 syl 3ad2ant2 adantr breqtrrd sylancr cA cr wcel
      cB cr wcel c1 cB clt wbr c1 cA cle wbr cA cB vk cv cexp co clt wbr vk cn
      wrex c1 cA cle wbr cA cr wcel cB cr wcel c1 cB clt wbr cA cB vk cv cexp
      co clt wbr vk cn wrex c1 cA cle wbr cA cr wcel cB cr wcel c1 cB clt wbr
      cA cB vk cv cexp co clt wbr vk cn wrex cA c1 cmin co cB c1 cmin co cdiv
      co cfl cfv c1 caddc co cn wcel cA cB cA c1 cmin co cB c1 cmin co cdiv co
      cfl cfv c1 caddc co cexp co clt wbr cA cB vk cv cexp co clt wbr vk cn
      wrex c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA cB vk
      cv cexp co clt wbr cA cB cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co cexp co clt wbr vk cA c1 cmin co cB c1 cmin co cdiv co cfl cfv
      c1 caddc co cn vk cv cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc
      co wceq cB vk cv cexp co cB cA c1 cmin co cB c1 cmin co cdiv co cfl cfv
      c1 caddc co cexp co cA clt vk cv cA c1 cmin co cB c1 cmin co cdiv co cfl
      cfv c1 caddc co cB cexp opreq2 breq2d rcla4ev c1 cA cle wbr cA cr wcel wa
      cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co cfl
      cfv cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cn
      wcel cA c1 cmin co cB c1 cmin co cdiv co cr wcel cc0 cA c1 cmin co cB c1
      cmin co cdiv co cle wbr cA c1 cmin co cB c1 cmin co cdiv co cfl cfv cn0
      wcel c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA c1
      cmin co cB c1 cmin co cdiv co flge0nn0 cA cr wcel cB cr wcel c1 cB clt
      wbr wa cA c1 cmin co cB c1 cmin co cdiv co cr wcel c1 cA cle wbr cA c1
      cmin co cr wcel cB c1 cmin co cr wcel cB c1 cmin co cc0 wne cA c1 cmin co
      cB c1 cmin co cdiv co cr wcel cA cr wcel cB cr wcel c1 cB clt wbr wa wa
      cA c1 cmin co cB c1 cmin co redivcl cA cr wcel cA c1 cmin co cr wcel cB
      cr wcel c1 cB clt wbr wa cA peano2rem adantr cB cr wcel c1 cB clt wbr wa
      cB c1 cmin co cr wcel cA cr wcel cB cr wcel cB c1 cmin co cr wcel c1 cB
      clt wbr cB peano2rem adantr adantl cB cr wcel c1 cB clt wbr wa cB c1 cmin
      co cc0 wne cA cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr
      cB c1 cmin co cc0 wne cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr
      c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1
      cB posdif mpan biimpa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr cB
      c1 cmin co cc0 wne cB cr wcel cB c1 cmin co gt0ne0 cB peano2rem sylan
      syldan adantl syl3anc adantll cA c1 cmin co cr wcel cc0 cA c1 cmin co cle
      wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr wa cc0 cA c1 cmin
      co cB c1 cmin co cdiv co cle wbr c1 cA cle wbr cA cr wcel wa cB cr wcel
      c1 cB clt wbr wa cA c1 cmin co cB c1 cmin co divge0 c1 cA cle wbr cA cr
      wcel wa cA c1 cmin co cr wcel cc0 cA c1 cmin co cle wbr cA cr wcel cA c1
      cmin co cr wcel c1 cA cle wbr cA peano2rem adantl cA cr wcel cc0 cA c1
      cmin co cle wbr c1 cA cle wbr cA cr wcel c1 cr wcel cc0 cA c1 cmin co cle
      wbr c1 cA cle wbr wb 1re cA c1 subge0 mpan2 biimparc jca cB cr wcel c1 cB
      clt wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr cB cr wcel cB
      c1 cmin co cr wcel c1 cB clt wbr cB peano2rem adantr cB cr wcel c1 cB clt
      wbr cc0 cB c1 cmin co clt wbr c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB
      c1 cmin co clt wbr wb 1re c1 cB posdif mpan biimpa jca syl2an sylanc cA
      c1 cmin co cB c1 cmin co cdiv co cfl cfv nn0p1nn syl c1 cA cle wbr cA cr
      wcel wa cB cr wcel c1 cB clt wbr wa wa cA cB c1 cmin co cA c1 cmin co cB
      c1 cmin co cdiv co cfl cfv c1 caddc co cmul co c1 caddc co cB cA c1 cmin
      co cB c1 cmin co cdiv co cfl cfv c1 caddc co cexp co c1 cA cle wbr cA cr
      wcel cB cr wcel c1 cB clt wbr wa simplr c1 cA cle wbr cA cr wcel wa cB cr
      wcel c1 cB clt wbr wa wa cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv
      co cfl cfv c1 caddc co cmul co cr wcel cB c1 cmin co cA c1 cmin co cB c1
      cmin co cdiv co cfl cfv c1 caddc co cmul co c1 caddc co cr wcel cB c1
      cmin co cr wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co
      cr wcel cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co cmul co cr wcel c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt
      wbr wa wa cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co remulcl cB cr wcel c1 cB clt wbr wa cB c1 cmin co cr wcel c1 cA
      cle wbr cA cr wcel wa cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB
      peano2rem adantr adantl c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt
      wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cn0
      wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cr wcel c1
      cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB
      c1 cmin co cdiv co cfl cfv cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co
      cfl cfv c1 caddc co cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co cr wcel
      cc0 cA c1 cmin co cB c1 cmin co cdiv co cle wbr cA c1 cmin co cB c1 cmin
      co cdiv co cfl cfv cn0 wcel c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB
      clt wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co flge0nn0 cA cr wcel cB
      cr wcel c1 cB clt wbr wa cA c1 cmin co cB c1 cmin co cdiv co cr wcel c1
      cA cle wbr cA c1 cmin co cr wcel cB c1 cmin co cr wcel cB c1 cmin co cc0
      wne cA c1 cmin co cB c1 cmin co cdiv co cr wcel cA cr wcel cB cr wcel c1
      cB clt wbr wa wa cA c1 cmin co cB c1 cmin co redivcl cA cr wcel cA c1
      cmin co cr wcel cB cr wcel c1 cB clt wbr wa cA peano2rem adantr cB cr
      wcel c1 cB clt wbr wa cB c1 cmin co cr wcel cA cr wcel cB cr wcel cB c1
      cmin co cr wcel c1 cB clt wbr cB peano2rem adantr adantl cB cr wcel c1 cB
      clt wbr wa cB c1 cmin co cc0 wne cA cr wcel cB cr wcel c1 cB clt wbr cc0
      cB c1 cmin co clt wbr cB c1 cmin co cc0 wne cB cr wcel c1 cB clt wbr cc0
      cB c1 cmin co clt wbr c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin
      co clt wbr wb 1re c1 cB posdif mpan biimpa cB c1 cmin co cr wcel cc0 cB
      c1 cmin co clt wbr cB c1 cmin co cc0 wne cB cr wcel cB c1 cmin co gt0ne0
      cB peano2rem sylan syldan adantl syl3anc adantll cA c1 cmin co cr wcel
      cc0 cA c1 cmin co cle wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt
      wbr wa cc0 cA c1 cmin co cB c1 cmin co cdiv co cle wbr c1 cA cle wbr cA
      cr wcel wa cB cr wcel c1 cB clt wbr wa cA c1 cmin co cB c1 cmin co divge0
      c1 cA cle wbr cA cr wcel wa cA c1 cmin co cr wcel cc0 cA c1 cmin co cle
      wbr cA cr wcel cA c1 cmin co cr wcel c1 cA cle wbr cA peano2rem adantl cA
      cr wcel cc0 cA c1 cmin co cle wbr c1 cA cle wbr cA cr wcel c1 cr wcel cc0
      cA c1 cmin co cle wbr c1 cA cle wbr wb 1re cA c1 subge0 mpan2 biimparc
      jca cB cr wcel c1 cB clt wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co
      clt wbr cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB peano2rem
      adantr cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel cB
      cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif mpan
      biimpa jca syl2an sylanc cA c1 cmin co cB c1 cmin co cdiv co cfl cfv
      peano2nn0 syl cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co
      nn0re syl sylanc cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl
      cfv c1 caddc co cmul co peano2re syl cB cr wcel cA c1 cmin co cB c1 cmin
      co cdiv co cfl cfv c1 caddc co cn0 wcel cB cA c1 cmin co cB c1 cmin co
      cdiv co cfl cfv c1 caddc co cexp co cr wcel c1 cA cle wbr cA cr wcel wa
      cB cr wcel c1 cB clt wbr wa wa cB cA c1 cmin co cB c1 cmin co cdiv co cfl
      cfv c1 caddc co reexpcl c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt
      wbr simprl c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA
      c1 cmin co cB c1 cmin co cdiv co cfl cfv cn0 wcel cA c1 cmin co cB c1
      cmin co cdiv co cfl cfv c1 caddc co cn0 wcel cA c1 cmin co cB c1 cmin co
      cdiv co cr wcel cc0 cA c1 cmin co cB c1 cmin co cdiv co cle wbr cA c1
      cmin co cB c1 cmin co cdiv co cfl cfv cn0 wcel c1 cA cle wbr cA cr wcel
      wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co
      flge0nn0 cA cr wcel cB cr wcel c1 cB clt wbr wa cA c1 cmin co cB c1 cmin
      co cdiv co cr wcel c1 cA cle wbr cA c1 cmin co cr wcel cB c1 cmin co cr
      wcel cB c1 cmin co cc0 wne cA c1 cmin co cB c1 cmin co cdiv co cr wcel cA
      cr wcel cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co
      redivcl cA cr wcel cA c1 cmin co cr wcel cB cr wcel c1 cB clt wbr wa cA
      peano2rem adantr cB cr wcel c1 cB clt wbr wa cB c1 cmin co cr wcel cA cr
      wcel cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB peano2rem adantr
      adantl cB cr wcel c1 cB clt wbr wa cB c1 cmin co cc0 wne cA cr wcel cB cr
      wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr cB c1 cmin co cc0 wne cB cr
      wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel cB cr wcel c1 cB
      clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif mpan biimpa cB c1
      cmin co cr wcel cc0 cB c1 cmin co clt wbr cB c1 cmin co cc0 wne cB cr
      wcel cB c1 cmin co gt0ne0 cB peano2rem sylan syldan adantl syl3anc
      adantll cA c1 cmin co cr wcel cc0 cA c1 cmin co cle wbr wa cB c1 cmin co
      cr wcel cc0 cB c1 cmin co clt wbr wa cc0 cA c1 cmin co cB c1 cmin co cdiv
      co cle wbr c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa cA c1
      cmin co cB c1 cmin co divge0 c1 cA cle wbr cA cr wcel wa cA c1 cmin co cr
      wcel cc0 cA c1 cmin co cle wbr cA cr wcel cA c1 cmin co cr wcel c1 cA cle
      wbr cA peano2rem adantl cA cr wcel cc0 cA c1 cmin co cle wbr c1 cA cle
      wbr cA cr wcel c1 cr wcel cc0 cA c1 cmin co cle wbr c1 cA cle wbr wb 1re
      cA c1 subge0 mpan2 biimparc jca cB cr wcel c1 cB clt wbr wa cB c1 cmin co
      cr wcel cc0 cB c1 cmin co clt wbr cB cr wcel cB c1 cmin co cr wcel c1 cB
      clt wbr cB peano2rem adantr cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co
      clt wbr c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb
      1re c1 cB posdif mpan biimpa jca syl2an sylanc cA c1 cmin co cB c1 cmin
      co cdiv co cfl cfv peano2nn0 syl sylanc c1 cA cle wbr cA cr wcel wa cB cr
      wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co cA c1 cmin co cB c1
      cmin co cdiv co cfl cfv c1 caddc co cmul co clt wbr cA cB c1 cmin co cA
      c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cmul co c1 caddc co
      clt wbr c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA c1
      cmin co cB c1 cmin co cdiv co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv
      c1 caddc co clt wbr cA c1 cmin co cB c1 cmin co cA c1 cmin co cB c1 cmin
      co cdiv co cfl cfv c1 caddc co cmul co clt wbr c1 cA cle wbr cA cr wcel
      wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co cr
      wcel cA c1 cmin co cB c1 cmin co cdiv co cA c1 cmin co cB c1 cmin co cdiv
      co cfl cfv c1 caddc co clt wbr cA cr wcel cB cr wcel c1 cB clt wbr wa cA
      c1 cmin co cB c1 cmin co cdiv co cr wcel c1 cA cle wbr cA c1 cmin co cr
      wcel cB c1 cmin co cr wcel cB c1 cmin co cc0 wne cA c1 cmin co cB c1 cmin
      co cdiv co cr wcel cA cr wcel cB cr wcel c1 cB clt wbr wa wa cA c1 cmin
      co cB c1 cmin co redivcl cA cr wcel cA c1 cmin co cr wcel cB cr wcel c1
      cB clt wbr wa cA peano2rem adantr cB cr wcel c1 cB clt wbr wa cB c1 cmin
      co cr wcel cA cr wcel cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB
      peano2rem adantr adantl cB cr wcel c1 cB clt wbr wa cB c1 cmin co cc0 wne
      cA cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr cB c1 cmin
      co cc0 wne cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel
      cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif
      mpan biimpa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr cB c1 cmin co
      cc0 wne cB cr wcel cB c1 cmin co gt0ne0 cB peano2rem sylan syldan adantl
      syl3anc adantll cA c1 cmin co cB c1 cmin co cdiv co flltp1 syl cA c1 cmin
      co cr wcel cB c1 cmin co cr wcel cA c1 cmin co cB c1 cmin co cdiv co cfl
      cfv c1 caddc co cr wcel w3a cc0 cB c1 cmin co clt wbr cA c1 cmin co cB c1
      cmin co cdiv co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co
      clt wbr cA c1 cmin co cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co
      cfl cfv c1 caddc co cmul co clt wbr wb c1 cA cle wbr cA cr wcel wa cB cr
      wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co cA c1 cmin co cB c1
      cmin co cdiv co cfl cfv c1 caddc co ltdivmulOLD c1 cA cle wbr cA cr wcel
      wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cr wcel cB c1 cmin co cr
      wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cr wcel c1
      cA cle wbr cA cr wcel wa cA c1 cmin co cr wcel cB cr wcel c1 cB clt wbr
      wa cA cr wcel cA c1 cmin co cr wcel c1 cA cle wbr cA peano2rem adantl
      adantr cB cr wcel c1 cB clt wbr wa cB c1 cmin co cr wcel c1 cA cle wbr cA
      cr wcel wa cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB peano2rem
      adantr adantl c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa
      cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cn0 wcel cA c1
      cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cr wcel c1 cA cle wbr
      cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co
      cdiv co cfl cfv cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co cr wcel cc0 cA c1
      cmin co cB c1 cmin co cdiv co cle wbr cA c1 cmin co cB c1 cmin co cdiv co
      cfl cfv cn0 wcel c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa
      wa cA c1 cmin co cB c1 cmin co cdiv co flge0nn0 cA cr wcel cB cr wcel c1
      cB clt wbr wa cA c1 cmin co cB c1 cmin co cdiv co cr wcel c1 cA cle wbr
      cA c1 cmin co cr wcel cB c1 cmin co cr wcel cB c1 cmin co cc0 wne cA c1
      cmin co cB c1 cmin co cdiv co cr wcel cA cr wcel cB cr wcel c1 cB clt wbr
      wa wa cA c1 cmin co cB c1 cmin co redivcl cA cr wcel cA c1 cmin co cr
      wcel cB cr wcel c1 cB clt wbr wa cA peano2rem adantr cB cr wcel c1 cB clt
      wbr wa cB c1 cmin co cr wcel cA cr wcel cB cr wcel cB c1 cmin co cr wcel
      c1 cB clt wbr cB peano2rem adantr adantl cB cr wcel c1 cB clt wbr wa cB
      c1 cmin co cc0 wne cA cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co
      clt wbr cB c1 cmin co cc0 wne cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co
      clt wbr c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb
      1re c1 cB posdif mpan biimpa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt
      wbr cB c1 cmin co cc0 wne cB cr wcel cB c1 cmin co gt0ne0 cB peano2rem
      sylan syldan adantl syl3anc adantll cA c1 cmin co cr wcel cc0 cA c1 cmin
      co cle wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr wa cc0 cA
      c1 cmin co cB c1 cmin co cdiv co cle wbr c1 cA cle wbr cA cr wcel wa cB
      cr wcel c1 cB clt wbr wa cA c1 cmin co cB c1 cmin co divge0 c1 cA cle wbr
      cA cr wcel wa cA c1 cmin co cr wcel cc0 cA c1 cmin co cle wbr cA cr wcel
      cA c1 cmin co cr wcel c1 cA cle wbr cA peano2rem adantl cA cr wcel cc0 cA
      c1 cmin co cle wbr c1 cA cle wbr cA cr wcel c1 cr wcel cc0 cA c1 cmin co
      cle wbr c1 cA cle wbr wb 1re cA c1 subge0 mpan2 biimparc jca cB cr wcel
      c1 cB clt wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr cB cr
      wcel cB c1 cmin co cr wcel c1 cB clt wbr cB peano2rem adantr cB cr wcel
      c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel cB cr wcel c1 cB clt
      wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif mpan biimpa jca syl2an
      sylanc cA c1 cmin co cB c1 cmin co cdiv co cfl cfv peano2nn0 syl cA c1
      cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co nn0re syl 3jca cB cr
      wcel c1 cB clt wbr wa cc0 cB c1 cmin co clt wbr c1 cA cle wbr cA cr wcel
      wa cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel cB cr
      wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif mpan
      biimpa adantl sylanc mpbid cA cr wcel cB c1 cmin co cA c1 cmin co cB c1
      cmin co cdiv co cfl cfv c1 caddc co cmul co cr wcel cA c1 cmin co cB c1
      cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cmul co
      clt wbr cA cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co cmul co c1 caddc co clt wbr wb c1 cA cle wbr cA cr wcel wa cB cr
      wcel c1 cB clt wbr wa wa cA cr wcel c1 cr wcel cB c1 cmin co cA c1 cmin
      co cB c1 cmin co cdiv co cfl cfv c1 caddc co cmul co cr wcel cA c1 cmin
      co cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co
      cmul co clt wbr cA cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl
      cfv c1 caddc co cmul co c1 caddc co clt wbr wb 1re cA c1 cB c1 cmin co cA
      c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cmul co ltsubadd
      mp3an2 c1 cA cle wbr cA cr wcel cB cr wcel c1 cB clt wbr wa simplr cB c1
      cmin co cr wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co
      cr wcel cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co cmul co cr wcel c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt
      wbr wa wa cB c1 cmin co cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1
      caddc co remulcl cB cr wcel c1 cB clt wbr wa cB c1 cmin co cr wcel c1 cA
      cle wbr cA cr wcel wa cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB
      peano2rem adantr adantl c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt
      wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cn0
      wcel cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cr wcel c1
      cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB
      c1 cmin co cdiv co cfl cfv cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co
      cfl cfv c1 caddc co cn0 wcel cA c1 cmin co cB c1 cmin co cdiv co cr wcel
      cc0 cA c1 cmin co cB c1 cmin co cdiv co cle wbr cA c1 cmin co cB c1 cmin
      co cdiv co cfl cfv cn0 wcel c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB
      clt wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co flge0nn0 cA cr wcel cB
      cr wcel c1 cB clt wbr wa cA c1 cmin co cB c1 cmin co cdiv co cr wcel c1
      cA cle wbr cA c1 cmin co cr wcel cB c1 cmin co cr wcel cB c1 cmin co cc0
      wne cA c1 cmin co cB c1 cmin co cdiv co cr wcel cA cr wcel cB cr wcel c1
      cB clt wbr wa wa cA c1 cmin co cB c1 cmin co redivcl cA cr wcel cA c1
      cmin co cr wcel cB cr wcel c1 cB clt wbr wa cA peano2rem adantr cB cr
      wcel c1 cB clt wbr wa cB c1 cmin co cr wcel cA cr wcel cB cr wcel cB c1
      cmin co cr wcel c1 cB clt wbr cB peano2rem adantr adantl cB cr wcel c1 cB
      clt wbr wa cB c1 cmin co cc0 wne cA cr wcel cB cr wcel c1 cB clt wbr cc0
      cB c1 cmin co clt wbr cB c1 cmin co cc0 wne cB cr wcel c1 cB clt wbr cc0
      cB c1 cmin co clt wbr c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin
      co clt wbr wb 1re c1 cB posdif mpan biimpa cB c1 cmin co cr wcel cc0 cB
      c1 cmin co clt wbr cB c1 cmin co cc0 wne cB cr wcel cB c1 cmin co gt0ne0
      cB peano2rem sylan syldan adantl syl3anc adantll cA c1 cmin co cr wcel
      cc0 cA c1 cmin co cle wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt
      wbr wa cc0 cA c1 cmin co cB c1 cmin co cdiv co cle wbr c1 cA cle wbr cA
      cr wcel wa cB cr wcel c1 cB clt wbr wa cA c1 cmin co cB c1 cmin co divge0
      c1 cA cle wbr cA cr wcel wa cA c1 cmin co cr wcel cc0 cA c1 cmin co cle
      wbr cA cr wcel cA c1 cmin co cr wcel c1 cA cle wbr cA peano2rem adantl cA
      cr wcel cc0 cA c1 cmin co cle wbr c1 cA cle wbr cA cr wcel c1 cr wcel cc0
      cA c1 cmin co cle wbr c1 cA cle wbr wb 1re cA c1 subge0 mpan2 biimparc
      jca cB cr wcel c1 cB clt wbr wa cB c1 cmin co cr wcel cc0 cB c1 cmin co
      clt wbr cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB peano2rem
      adantr cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel cB
      cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif mpan
      biimpa jca syl2an sylanc cA c1 cmin co cB c1 cmin co cdiv co cfl cfv
      peano2nn0 syl cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co
      nn0re syl sylanc sylanc mpbid cB cr wcel cA c1 cmin co cB c1 cmin co cdiv
      co cfl cfv c1 caddc co cn0 wcel cc0 cB cle wbr cB c1 cmin co cA c1 cmin
      co cB c1 cmin co cdiv co cfl cfv c1 caddc co cmul co c1 caddc co cB cA c1
      cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cexp co cle wbr c1 cA
      cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cB cA c1 cmin co cB
      c1 cmin co cdiv co cfl cfv c1 caddc co bernneq2 c1 cA cle wbr cA cr wcel
      wa cB cr wcel c1 cB clt wbr simprl c1 cA cle wbr cA cr wcel wa cB cr wcel
      c1 cB clt wbr wa wa cA c1 cmin co cB c1 cmin co cdiv co cfl cfv cn0 wcel
      cA c1 cmin co cB c1 cmin co cdiv co cfl cfv c1 caddc co cn0 wcel cA c1
      cmin co cB c1 cmin co cdiv co cr wcel cc0 cA c1 cmin co cB c1 cmin co
      cdiv co cle wbr cA c1 cmin co cB c1 cmin co cdiv co cfl cfv cn0 wcel c1
      cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co cB
      c1 cmin co cdiv co flge0nn0 cA cr wcel cB cr wcel c1 cB clt wbr wa cA c1
      cmin co cB c1 cmin co cdiv co cr wcel c1 cA cle wbr cA c1 cmin co cr wcel
      cB c1 cmin co cr wcel cB c1 cmin co cc0 wne cA c1 cmin co cB c1 cmin co
      cdiv co cr wcel cA cr wcel cB cr wcel c1 cB clt wbr wa wa cA c1 cmin co
      cB c1 cmin co redivcl cA cr wcel cA c1 cmin co cr wcel cB cr wcel c1 cB
      clt wbr wa cA peano2rem adantr cB cr wcel c1 cB clt wbr wa cB c1 cmin co
      cr wcel cA cr wcel cB cr wcel cB c1 cmin co cr wcel c1 cB clt wbr cB
      peano2rem adantr adantl cB cr wcel c1 cB clt wbr wa cB c1 cmin co cc0 wne
      cA cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr cB c1 cmin
      co cc0 wne cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr c1 cr wcel
      cB cr wcel c1 cB clt wbr cc0 cB c1 cmin co clt wbr wb 1re c1 cB posdif
      mpan biimpa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr cB c1 cmin co
      cc0 wne cB cr wcel cB c1 cmin co gt0ne0 cB peano2rem sylan syldan adantl
      syl3anc adantll cA c1 cmin co cr wcel cc0 cA c1 cmin co cle wbr wa cB c1
      cmin co cr wcel cc0 cB c1 cmin co clt wbr wa cc0 cA c1 cmin co cB c1 cmin
      co cdiv co cle wbr c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr
      wa cA c1 cmin co cB c1 cmin co divge0 c1 cA cle wbr cA cr wcel wa cA c1
      cmin co cr wcel cc0 cA c1 cmin co cle wbr cA cr wcel cA c1 cmin co cr
      wcel c1 cA cle wbr cA peano2rem adantl cA cr wcel cc0 cA c1 cmin co cle
      wbr c1 cA cle wbr cA cr wcel c1 cr wcel cc0 cA c1 cmin co cle wbr c1 cA
      cle wbr wb 1re cA c1 subge0 mpan2 biimparc jca cB cr wcel c1 cB clt wbr
      wa cB c1 cmin co cr wcel cc0 cB c1 cmin co clt wbr cB cr wcel cB c1 cmin
      co cr wcel c1 cB clt wbr cB peano2rem adantr cB cr wcel c1 cB clt wbr cc0
      cB c1 cmin co clt wbr c1 cr wcel cB cr wcel c1 cB clt wbr cc0 cB c1 cmin
      co clt wbr wb 1re c1 cB posdif mpan biimpa jca syl2an sylanc cA c1 cmin
      co cB c1 cmin co cdiv co cfl cfv peano2nn0 syl cB cr wcel c1 cB clt wbr
      wa cc0 cB cle wbr c1 cA cle wbr cA cr wcel wa cB cr wcel c1 cB clt wbr
      cc0 cB cle wbr cB cr wcel c1 cB clt wbr cc0 cB clt wbr cc0 cB cle wbr cB
      cr wcel cc0 c1 clt wbr c1 cB clt wbr cc0 cB clt wbr lt01 cc0 cr wcel c1
      cr wcel cB cr wcel cc0 c1 clt wbr c1 cB clt wbr wa cc0 cB clt wbr wi 0re
      1re cc0 c1 cB axlttrn mp3an12 mpani cc0 cr wcel cB cr wcel cc0 cB clt wbr
      cc0 cB cle wbr wi 0re cc0 cB ltle mpan syld imp adantl syl3anc ltletrd
      sylanc exp43 com4l 3imp1 cA cr wcel cB cr wcel c1 cB clt wbr 3simp1 c1 cr
      wcel cA cr wcel cB cr wcel c1 cB clt wbr w3a 1re a1i pm2.61ltlei $.
      $( [10-Nov-2007] $) $( [20-Oct-2007] $)

    $( The reciprocal of exponentiation with a mantissa greater than 1 has no
       lower bound. $)
    expnlbnd $p |- ( ( A e. RR+ /\ B e. RR /\ 1 < B ) ->
          E. k e. NN ( 1 / ( B ^ k ) ) < A ) $=
      cA crp wcel cB cr wcel c1 cB clt wbr w3a c1 cA cdiv co cB vk cv cexp co
      clt wbr vk cn wrex c1 cB vk cv cexp co cdiv co cA clt wbr vk cn wrex c1
      cA cdiv co cr wcel cB cr wcel c1 cB clt wbr c1 cA cdiv co cB vk cv cexp
      co clt wbr vk cn wrex cA crp wcel c1 cA cdiv co cB vk expnbnd cA cr wcel
      cA cc0 wne c1 cA cdiv co cr wcel cA crp wcel cA rereccl cA rpre cA rpne0
      sylanc syl3an1 cA crp wcel cB cr wcel c1 cB clt wbr w3a c1 cA cdiv co cB
      vk cv cexp co clt wbr c1 cB vk cv cexp co cdiv co cA clt wbr vk cn cA cr
      wcel cc0 cA clt wbr wa cB vk cv cexp co cr wcel cc0 cB vk cv cexp co clt
      wbr wa c1 cA cdiv co cB vk cv cexp co clt wbr c1 cB vk cv cexp co cdiv co
      cA clt wbr wb cA crp wcel cB cr wcel c1 cB clt wbr w3a vk cv cn wcel wa
      cA cB vk cv cexp co ltrec1 cA crp wcel cB cr wcel c1 cB clt wbr w3a cA cr
      wcel cc0 cA clt wbr wa vk cv cn wcel cA crp wcel cB cr wcel cA cr wcel
      cc0 cA clt wbr wa c1 cB clt wbr cA crp wcel cA cr wcel cc0 cA clt wbr wa
      cA elrp biimpi 3ad2ant1 adantr cB cr wcel c1 cB clt wbr vk cv cn wcel cB
      vk cv cexp co cr wcel cc0 cB vk cv cexp co clt wbr wa cA crp wcel cB cr
      wcel c1 cB clt wbr wa vk cv cn wcel wa cB vk cv cexp co cr wcel cc0 cB vk
      cv cexp co clt wbr cB cr wcel vk cv cn wcel cB vk cv cexp co cr wcel c1
      cB clt wbr cB cr wcel vk cv cn0 wcel cB vk cv cexp co cr wcel vk cv cn
      wcel cB vk cv reexpcl vk cv nnnn0 sylan2 adantlr cB cr wcel vk cv cn0
      wcel cc0 cB clt wbr cc0 cB vk cv cexp co clt wbr cB cr wcel c1 cB clt wbr
      wa vk cv cn wcel wa cB vk cv expgt0 cB cr wcel c1 cB clt wbr vk cv cn
      wcel simpll vk cv cn wcel vk cv cn0 wcel cB cr wcel c1 cB clt wbr wa vk
      cv nnnn0 adantl cB cr wcel c1 cB clt wbr wa cc0 cB clt wbr vk cv cn wcel
      cB cr wcel c1 cB clt wbr cc0 cB clt wbr cB cr wcel cc0 c1 clt wbr c1 cB
      clt wbr cc0 cB clt wbr lt01 cc0 cr wcel c1 cr wcel cB cr wcel cc0 c1 clt
      wbr c1 cB clt wbr wa cc0 cB clt wbr wi 0re 1re cc0 c1 cB lttr mp3an12
      mpani imp adantr syl3anc jca 3adantl1 sylanc rexbidva mpbid $.
      $( [18-Jul-2008] $) $( [18-Jul-2008] $)

    $( The reciprocal of exponentiation with a mantissa greater than 1 has no
       lower bound. $)
    expnlbnd2 $p |- ( ( A e. RR+ /\ B e. RR /\ 1 < B ) ->
          E. j e. NN A. k e. NN ( j <_ k -> ( 1 / ( B ^ k ) ) < A ) ) $=
      cA crp wcel cB cr wcel c1 cB clt wbr w3a c1 cB vj cv cexp co cdiv co cA
      clt wbr vj cn wrex vj cv vk cv cle wbr c1 cB vk cv cexp co cdiv co cA clt
      wbr wi vk cn wral vj cn wrex cA cB vj expnlbnd cA crp wcel cB cr wcel c1
      cB clt wbr w3a c1 cB vj cv cexp co cdiv co cA clt wbr vj cv vk cv cle wbr
      c1 cB vk cv cexp co cdiv co cA clt wbr wi vk cn wral vj cn cA crp wcel cB
      cr wcel c1 cB clt wbr w3a vj cv cn wcel wa c1 cB vj cv cexp co cdiv co cA
      clt wbr vj cv vk cv cle wbr c1 cB vk cv cexp co cdiv co cA clt wbr wi vk
      cn cA crp wcel cB cr wcel c1 cB clt wbr w3a vj cv cn wcel wa vk cv cn
      wcel wa vj cv vk cv cle wbr c1 cB vj cv cexp co cdiv co cA clt wbr c1 cB
      vk cv cexp co cdiv co cA clt wbr cA crp wcel cB cr wcel c1 cB clt wbr w3a
      vj cv cn wcel wa vk cv cn wcel wa vj cv vk cv cle wbr c1 cB vj cv cexp co
      cdiv co cA clt wbr c1 cB vk cv cexp co cdiv co cA clt wbr wi cA crp wcel
      cB cr wcel c1 cB clt wbr w3a vj cv cn wcel wa vk cv cn wcel wa vj cv vk
      cv cle wbr wa c1 cB vk cv cexp co cdiv co c1 cB vj cv cexp co cdiv co cle
      wbr c1 cB vj cv cexp co cdiv co cA clt wbr c1 cB vk cv cexp co cdiv co cA
      clt wbr cA crp wcel cB cr wcel c1 cB clt wbr w3a vj cv cn wcel wa vk cv
      cn wcel vj cv vk cv cle wbr c1 cB vk cv cexp co cdiv co c1 cB vj cv cexp
      co cdiv co cle wbr cB cr wcel c1 cB clt wbr vj cv cn wcel vk cv cn wcel
      vj cv vk cv cle wbr c1 cB vk cv cexp co cdiv co c1 cB vj cv cexp co cdiv
      co cle wbr wi wi cA crp wcel cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa
      vk cv cn wcel vj cv vk cv cle wbr c1 cB vk cv cexp co cdiv co c1 cB vj cv
      cexp co cdiv co cle wbr wi cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa
      vk cv cn wcel wa vj cv vk cv cle wbr cB vj cv cexp co cB vk cv cexp co
      cle wbr c1 cB vk cv cexp co cdiv co c1 cB vj cv cexp co cdiv co cle wbr
      cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa vk cv cn wcel wa vj cv vk cv
      cle wbr cB vj cv cexp co cB vk cv cexp co cle wbr cB cr wcel vj cv cn0
      wcel vk cv cn0 wcel w3a c1 cB cle wbr vj cv vk cv cle wbr wa cB vj cv
      cexp co cB vk cv cexp co cle wbr cB cr wcel c1 cB clt wbr wa vj cv cn
      wcel wa vk cv cn wcel wa vj cv vk cv cle wbr wa cB vj cv vk cv expwordi
      cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa vk cv cn wcel wa vj cv vk cv
      cle wbr wa cB cr wcel vj cv cn0 wcel vk cv cn0 wcel cB cr wcel c1 cB clt
      wbr wa vj cv cn wcel wa cB cr wcel vk cv cn wcel vj cv vk cv cle wbr cB
      cr wcel c1 cB clt wbr vj cv cn wcel simpll ad2antrr cB cr wcel c1 cB clt
      wbr wa vj cv cn wcel wa vj cv cn0 wcel vk cv cn wcel vj cv vk cv cle wbr
      vj cv cn wcel vj cv cn0 wcel cB cr wcel c1 cB clt wbr wa vj cv nnnn0
      adantl ad2antrr vk cv cn wcel vk cv cn0 wcel cB cr wcel c1 cB clt wbr wa
      vj cv cn wcel wa vj cv vk cv cle wbr vk cv nnnn0 ad2antlr 3jca cB cr wcel
      c1 cB clt wbr wa vj cv cn wcel wa vk cv cn wcel wa c1 cB cle wbr vj cv vk
      cv cle wbr cB cr wcel c1 cB clt wbr wa c1 cB cle wbr vj cv cn wcel vk cv
      cn wcel cB cr wcel c1 cB clt wbr c1 cB cle wbr c1 cr wcel cB cr wcel c1
      cB clt wbr c1 cB cle wbr wi 1re c1 cB ltle mpan imp ad2antrr anim1i
      sylanc ex cB vj cv cexp co cr wcel cc0 cB vj cv cexp co clt wbr cB vk cv
      cexp co cr wcel cc0 cB vk cv cexp co clt wbr cB vj cv cexp co cB vk cv
      cexp co cle wbr c1 cB vk cv cexp co cdiv co c1 cB vj cv cexp co cdiv co
      cle wbr wb cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa vk cv cn wcel wa
      cB vj cv cexp co cB vk cv cexp co lerec cB cr wcel c1 cB clt wbr wa vj cv
      cn wcel wa cB vj cv cexp co cr wcel vk cv cn wcel cB cr wcel vj cv cn
      wcel cB vj cv cexp co cr wcel c1 cB clt wbr cB cr wcel vj cv cn0 wcel cB
      vj cv cexp co cr wcel vj cv cn wcel cB vj cv reexpcl vj cv nnnn0 sylan2
      adantlr adantr cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa cc0 cB vj cv
      cexp co clt wbr vk cv cn wcel cB cr wcel vj cv cn0 wcel cc0 cB clt wbr
      cc0 cB vj cv cexp co clt wbr cB cr wcel c1 cB clt wbr wa vj cv cn wcel wa
      cB vj cv expgt0 cB cr wcel c1 cB clt wbr vj cv cn wcel simpll vj cv cn
      wcel vj cv cn0 wcel cB cr wcel c1 cB clt wbr wa vj cv nnnn0 adantl cB cr
      wcel c1 cB clt wbr wa cc0 cB clt wbr vj cv cn wcel cB cr wcel c1 cB clt
      wbr cc0 cB clt wbr cB cr wcel cc0 c1 clt wbr c1 cB clt wbr cc0 cB clt wbr
      lt01 cc0 cr wcel c1 cr wcel cB cr wcel cc0 c1 clt wbr c1 cB clt wbr wa
      cc0 cB clt wbr wi 0re 1re cc0 c1 cB lttr mp3an12 mpani imp adantr syl3anc
      adantr cB cr wcel c1 cB clt wbr wa vk cv cn wcel cB vk cv cexp co cr wcel
      vj cv cn wcel cB cr wcel vk cv cn wcel cB vk cv cexp co cr wcel c1 cB clt
      wbr cB cr wcel vk cv cn0 wcel cB vk cv cexp co cr wcel vk cv cn wcel cB
      vk cv reexpcl vk cv nnnn0 sylan2 adantlr adantlr cB cr wcel c1 cB clt wbr
      wa vk cv cn wcel cc0 cB vk cv cexp co clt wbr vj cv cn wcel cB cr wcel vk
      cv cn0 wcel cc0 cB clt wbr cc0 cB vk cv cexp co clt wbr cB cr wcel c1 cB
      clt wbr wa vk cv cn wcel wa cB vk cv expgt0 cB cr wcel c1 cB clt wbr vk
      cv cn wcel simpll vk cv cn wcel vk cv cn0 wcel cB cr wcel c1 cB clt wbr
      wa vk cv nnnn0 adantl cB cr wcel c1 cB clt wbr wa cc0 cB clt wbr vk cv cn
      wcel cB cr wcel c1 cB clt wbr cc0 cB clt wbr cB cr wcel cc0 c1 clt wbr c1
      cB clt wbr cc0 cB clt wbr lt01 cc0 cr wcel c1 cr wcel cB cr wcel cc0 c1
      clt wbr c1 cB clt wbr wa cc0 cB clt wbr wi 0re 1re cc0 c1 cB lttr mp3an12
      mpani imp adantr syl3anc adantlr syl2anc sylibd ex 3adantl1 imp31 cA crp
      wcel cB cr wcel c1 cB clt wbr w3a vj cv cn wcel wa vk cv cn wcel wa c1 cB
      vk cv cexp co cdiv co c1 cB vj cv cexp co cdiv co cle wbr c1 cB vj cv
      cexp co cdiv co cA clt wbr wa c1 cB vk cv cexp co cdiv co cA clt wbr wi
      vj cv vk cv cle wbr c1 cB vk cv cexp co cdiv co cr wcel c1 cB vj cv cexp
      co cdiv co cr wcel cA cr wcel c1 cB vk cv cexp co cdiv co c1 cB vj cv
      cexp co cdiv co cle wbr c1 cB vj cv cexp co cdiv co cA clt wbr wa c1 cB
      vk cv cexp co cdiv co cA clt wbr wi cA crp wcel cB cr wcel c1 cB clt wbr
      w3a vj cv cn wcel wa vk cv cn wcel wa c1 cB vk cv cexp co cdiv co c1 cB
      vj cv cexp co cdiv co cA lelttr cA crp wcel cB cr wcel c1 cB clt wbr w3a
      vk cv cn wcel c1 cB vk cv cexp co cdiv co cr wcel vj cv cn wcel cB cr
      wcel c1 cB clt wbr vk cv cn wcel c1 cB vk cv cexp co cdiv co cr wcel cA
      crp wcel cB vk cv cexp co cr wcel cB vk cv cexp co cc0 wne c1 cB vk cv
      cexp co cdiv co cr wcel cB cr wcel c1 cB clt wbr wa vk cv cn wcel wa cB
      vk cv cexp co rereccl cB cr wcel vk cv cn wcel cB vk cv cexp co cr wcel
      c1 cB clt wbr cB cr wcel vk cv cn0 wcel cB vk cv cexp co cr wcel vk cv cn
      wcel cB vk cv reexpcl vk cv nnnn0 sylan2 adantlr cB cc wcel cB cc0 wne vk
      cv cn0 wcel cB vk cv cexp co cc0 wne cB cr wcel c1 cB clt wbr wa vk cv cn
      wcel wa cB vk cv expne0i cB cr wcel cB cc wcel c1 cB clt wbr vk cv cn
      wcel cB recn ad2antrr cB cr wcel c1 cB clt wbr wa cB cc0 wne vk cv cn
      wcel cB cr wcel c1 cB clt wbr cc0 cB clt wbr cB cc0 wne cB cr wcel c1 cB
      clt wbr cc0 cB clt wbr cB cr wcel cc0 c1 clt wbr c1 cB clt wbr cc0 cB clt
      wbr lt01 cc0 cr wcel c1 cr wcel cB cr wcel cc0 c1 clt wbr c1 cB clt wbr
      wa cc0 cB clt wbr wi 0re 1re cc0 c1 cB lttr mp3an12 mpani imp cB gt0ne0
      syldan adantr vk cv cn wcel vk cv cn0 wcel cB cr wcel c1 cB clt wbr wa vk
      cv nnnn0 adantl syl3anc sylanc 3adantl1 adantlr cA crp wcel cB cr wcel c1
      cB clt wbr w3a vj cv cn wcel wa c1 cB vj cv cexp co cdiv co cr wcel vk cv
      cn wcel cB cr wcel c1 cB clt wbr vj cv cn wcel c1 cB vj cv cexp co cdiv
      co cr wcel cA crp wcel cB vj cv cexp co cr wcel cB vj cv cexp co cc0 wne
      c1 cB vj cv cexp co cdiv co cr wcel cB cr wcel c1 cB clt wbr wa vj cv cn
      wcel wa cB vj cv cexp co rereccl cB cr wcel vj cv cn wcel cB vj cv cexp
      co cr wcel c1 cB clt wbr cB cr wcel vj cv cn0 wcel cB vj cv cexp co cr
      wcel vj cv cn wcel cB vj cv reexpcl vj cv nnnn0 sylan2 adantlr cB cc wcel
      cB cc0 wne vj cv cn0 wcel cB vj cv cexp co cc0 wne cB cr wcel c1 cB clt
      wbr wa vj cv cn wcel wa cB vj cv expne0i cB cr wcel cB cc wcel c1 cB clt
      wbr vj cv cn wcel cB recn ad2antrr cB cr wcel c1 cB clt wbr wa cB cc0 wne
      vj cv cn wcel cB cr wcel c1 cB clt wbr cc0 cB clt wbr cB cc0 wne cB cr
      wcel c1 cB clt wbr cc0 cB clt wbr cB cr wcel cc0 c1 clt wbr c1 cB clt wbr
      cc0 cB clt wbr lt01 cc0 cr wcel c1 cr wcel cB cr wcel cc0 c1 clt wbr c1
      cB clt wbr wa cc0 cB clt wbr wi 0re 1re cc0 c1 cB lttr mp3an12 mpani imp
      cB gt0ne0 syldan adantr vj cv cn wcel vj cv cn0 wcel cB cr wcel c1 cB clt
      wbr wa vj cv nnnn0 adantl syl3anc sylanc 3adantl1 adantr cA crp wcel cB
      cr wcel c1 cB clt wbr w3a cA cr wcel vj cv cn wcel vk cv cn wcel cA crp
      wcel cB cr wcel cA cr wcel c1 cB clt wbr cA rpre 3ad2ant1 ad2antrr
      syl3anc adantr mpand ex com23 r19.21adva r19.22dva mpd $.
      $( [2-Nov-2008] $) $( [18-Jul-2008] $)
  $}

  $( Two ways to express the ` K ` th digit in the decimal (when base
     ` B = 10 ` ) expansion of a number ` A ` .  ` K = 1 ` corresponds to the
     first digit after the decimal point. $)
  digit2 $p |- ( ( A e. RR /\ B e. NN /\ K e. NN )
    -> ( ( |_ ` ( ( B ^ K ) x. A ) ) mod B ) = ( ( |_ ` ( ( B ^ K ) x.
      A ) ) - ( B x. ( |_ ` ( ( B ^ ( K - 1 ) ) x. A ) ) ) ) ) $=
    cA cr wcel cB cn wcel cK cn wcel w3a cB cK cexp co cA cmul co cfl cfv cB
    cmo co cB cK cexp co cA cmul co cfl cfv cB cB cK cexp co cA cmul co cfl cfv
    cB cdiv co cfl cfv cmul co cmin co cB cK cexp co cA cmul co cfl cfv cB cB
    cK c1 cmin co cexp co cA cmul co cfl cfv cmul co cmin co cB cK cexp co cA
    cmul co cfl cfv cr wcel cB crp wcel cB cK cexp co cA cmul co cfl cfv cB cmo
    co cB cK cexp co cA cmul co cfl cfv cB cB cK cexp co cA cmul co cfl cfv cB
    cdiv co cfl cfv cmul co cmin co wceq cA cr wcel cB cn wcel cK cn wcel w3a
    cB cK cexp co cA cmul co cfl cfv cB modval cA cr wcel cB cn wcel cK cn wcel
    w3a cB cK cexp co cA cmul co cr wcel cB cK cexp co cA cmul co cfl cfv cr
    wcel cB cn wcel cK cn wcel cA cr wcel cB cK cexp co cA cmul co cr wcel cB
    cn wcel cK cn wcel cA cr wcel cB cK cexp co cA cmul co cr wcel cB cK cexp
    co cr wcel cA cr wcel cB cK cexp co cA cmul co cr wcel cB cn wcel cK cn
    wcel wa cB cK cexp co cA remulcl cB cr wcel cK cn0 wcel cB cK cexp co cr
    wcel cB cn wcel cK cn wcel cB cK reexpcl cB nnre cK nnnn0 syl2an sylan
    3impa 3comr cB cK cexp co cA cmul co reflcl syl cB cn wcel cA cr wcel cB
    crp wcel cK cn wcel cB nnrp 3ad2ant2 sylanc cA cr wcel cB cn wcel cK cn
    wcel w3a cB cB cK cexp co cA cmul co cfl cfv cB cdiv co cfl cfv cmul co cB
    cB cK c1 cmin co cexp co cA cmul co cfl cfv cmul co cB cK cexp co cA cmul
    co cfl cfv cmin cA cr wcel cB cn wcel cK cn wcel w3a cB cK cexp co cA cmul
    co cfl cfv cB cdiv co cfl cfv cB cK c1 cmin co cexp co cA cmul co cfl cfv
    cB cmul cA cr wcel cB cn wcel cK cn wcel w3a cB cK cexp co cA cmul co cfl
    cfv cB cdiv co cfl cfv cB cK cexp co cA cmul co cB cdiv co cfl cfv cB cK c1
    cmin co cexp co cA cmul co cfl cfv cB cK cexp co cA cmul co cr wcel cB cn
    wcel cB cK cexp co cA cmul co cfl cfv cB cdiv co cfl cfv cB cK cexp co cA
    cmul co cB cdiv co cfl cfv wceq cA cr wcel cB cn wcel cK cn wcel w3a cB cK
    cexp co cA cmul co cB fldiv cB cn wcel cK cn wcel cA cr wcel cB cK cexp co
    cA cmul co cr wcel cB cn wcel cK cn wcel cA cr wcel cB cK cexp co cA cmul
    co cr wcel cB cK cexp co cr wcel cA cr wcel cB cK cexp co cA cmul co cr
    wcel cB cn wcel cK cn wcel wa cB cK cexp co cA remulcl cB cr wcel cK cn0
    wcel cB cK cexp co cr wcel cB cn wcel cK cn wcel cB cK reexpcl cB nnre cK
    nnnn0 syl2an sylan 3impa 3comr cA cr wcel cB cn wcel cK cn wcel 3simp2
    sylanc cA cr wcel cB cn wcel cK cn wcel w3a cB cK cexp co cA cmul co cB
    cdiv co cB cK c1 cmin co cexp co cA cmul co cfl cA cr wcel cB cn wcel cK cn
    wcel w3a cB cK cexp co cA cmul co cB cdiv co cB cK cexp co cB cdiv co cA
    cmul co cB cK c1 cmin co cexp co cA cmul co cB cK cexp co cc wcel cA cc
    wcel cB cc wcel cB cc0 wne wa cB cK cexp co cA cmul co cB cdiv co cB cK
    cexp co cB cdiv co cA cmul co wceq cA cr wcel cB cn wcel cK cn wcel w3a cB
    cK cexp co cA cB div23 cB cn wcel cK cn wcel cB cK cexp co cc wcel cA cr
    wcel cB cc wcel cK cn0 wcel cB cK cexp co cc wcel cB cn wcel cK cn wcel cB
    cK expcl cB nncn cK nnnn0 syl2an 3adant1 cA cr wcel cB cn wcel cA cc wcel
    cK cn wcel cA recn 3ad2ant1 cB cn wcel cA cr wcel cB cc wcel cB cc0 wne wa
    cK cn wcel cB cn wcel cB cc wcel cB cc0 wne cB nncn cB nnne0 jca 3ad2ant2
    syl3anc cA cr wcel cB cn wcel cK cn wcel w3a cB cK c1 cmin co cexp co cB cK
    cexp co cB cdiv co cA cmul cB cn wcel cK cn wcel cB cK c1 cmin co cexp co
    cB cK cexp co cB cdiv co wceq cA cr wcel cB cc wcel cB cc0 wne wa cK cn
    wcel cB cK c1 cmin co cexp co cB cK cexp co cB cdiv co wceq cB cn wcel cB
    cc wcel cB cc0 wne cK cn wcel cB cK c1 cmin co cexp co cB cK cexp co cB
    cdiv co wceq cB cK expm1 3expa cB cn wcel cB cc wcel cB cc0 wne cB nncn cB
    nnne0 jca sylan 3adant1 opreq1d eqtr4d fveq2d eqtrd opreq2d opreq2d eqtrd
    $.
    $( [16-Mar-2009] $) $( [25-Dec-2008] $)

  $( Two ways to express the ` K ` th digit in the decimal expansion of a
     number ` A ` (when base ` B = 10 ` ).  ` K = 1 ` corresponds to the first
     digit after the decimal point. $)
  digit1 $p |- ( ( A e. RR /\ B e. NN /\ K e. NN ) -> ( ( |_ ` ( ( B ^ K ) x.
        A ) ) mod B ) = ( ( ( |_ ` ( ( B ^ K ) x. A ) ) mod ( B ^ K ) )
        - ( ( B x. ( |_ ` ( ( B ^ ( K - 1 ) ) x. A ) ) ) mod ( B ^ K ) ) ) ) $=
    cB cn wcel cK cn wcel cA cr wcel cB cK cexp co cA cmul co cfl cfv cB cmo co
    cB cK cexp co cA cmul co cfl cfv cB cK cexp co cmo co cB cB cK c1 cmin co
    cexp co cA cmul co cfl cfv cmul co cB cK cexp co cmo co cmin co wceq cB cn
    wcel cK cn wcel cA cr wcel cB cK cexp co cA cmul co cfl cfv cB cmo co cB cK
    cexp co cA cmul co cfl cfv cB cK cexp co cmo co cB cB cK c1 cmin co cexp co
    cA cmul co cfl cfv cmul co cB cK cexp co cmo co cmin co wceq cB cn wcel cK
    cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co cfl cfv cB cmo co cB cK
    cexp co cmo co cB cK cexp co cA cmul co cfl cfv cB cB cK c1 cmin co cexp co
    cA cmul co cfl cfv cmul co cmin co cB cK cexp co cmo co cB cK cexp co cA
    cmul co cfl cfv cB cmo co cB cK cexp co cA cmul co cfl cfv cB cK cexp co
    cmo co cB cB cK c1 cmin co cexp co cA cmul co cfl cfv cmul co cB cK cexp co
    cmo co cmin co cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul
    co cfl cfv cB cmo co cB cK cexp co cA cmul co cfl cfv cB cB cK c1 cmin co
    cexp co cA cmul co cfl cfv cmul co cmin co cB cK cexp co cmo cB cn wcel cK
    cn wcel cA cr wcel cB cK cexp co cA cmul co cfl cfv cB cmo co cB cK cexp co
    cA cmul co cfl cfv cB cB cK c1 cmin co cexp co cA cmul co cfl cfv cmul co
    cmin co wceq cA cr wcel cB cn wcel cK cn wcel cB cK cexp co cA cmul co cfl
    cfv cB cmo co cB cK cexp co cA cmul co cfl cfv cB cB cK c1 cmin co cexp co
    cA cmul co cfl cfv cmul co cmin co wceq cA cB cK digit2 3coml 3expa opreq1d
    cB cK cexp co cA cmul co cfl cfv cB cmo co cr wcel cB cK cexp co crp wcel
    cc0 cB cK cexp co cA cmul co cfl cfv cB cmo co cle wbr cB cK cexp co cA
    cmul co cfl cfv cB cmo co cB cK cexp co clt wbr cB cK cexp co cA cmul co
    cfl cfv cB cmo co cB cK cexp co cmo co cB cK cexp co cA cmul co cfl cfv cB
    cmo co wceq cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co
    cfl cfv cB cmo co cB cK cexp co modid cB cK cexp co cA cmul co cfl cfv cr
    wcel cB crp wcel cB cK cexp co cA cmul co cfl cfv cB cmo co cr wcel cB cn
    wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co cfl cfv cB modcl
    cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co cr wcel cB
    cK cexp co cA cmul co cfl cfv cr wcel cB cK cexp co cr wcel cA cr wcel cB
    cK cexp co cA cmul co cr wcel cB cn wcel cK cn wcel wa cB cK cexp co cA
    remulcl cB cr wcel cK cn0 wcel cB cK cexp co cr wcel cB cn wcel cK cn wcel
    cB cK reexpcl cB nnre cK nnnn0 syl2an sylan cB cK cexp co cA cmul co reflcl
    syl cB cn wcel cB crp wcel cK cn wcel cA cr wcel cB nnrp ad2antrr sylanc cB
    cn wcel cK cn wcel wa cB cK cexp co crp wcel cA cr wcel cB cn wcel cK cn
    wcel wa cB cK cexp co cn wcel cB cK cexp co crp wcel cB cn wcel cK cn0 wcel
    cB cK cexp co cn wcel cK cn wcel cB cK nnexpcl cK nnnn0 sylan2 cB cK cexp
    co nnrp syl adantr cB cK cexp co cA cmul co cfl cfv cr wcel cB crp wcel cc0
    cB cK cexp co cA cmul co cfl cfv cB cmo co cle wbr cB cn wcel cK cn wcel wa
    cA cr wcel wa cB cK cexp co cA cmul co cfl cfv cB modge0 cB cn wcel cK cn
    wcel wa cA cr wcel wa cB cK cexp co cA cmul co cr wcel cB cK cexp co cA
    cmul co cfl cfv cr wcel cB cK cexp co cr wcel cA cr wcel cB cK cexp co cA
    cmul co cr wcel cB cn wcel cK cn wcel wa cB cK cexp co cA remulcl cB cr
    wcel cK cn0 wcel cB cK cexp co cr wcel cB cn wcel cK cn wcel cB cK reexpcl
    cB nnre cK nnnn0 syl2an sylan cB cK cexp co cA cmul co reflcl syl cB cn
    wcel cB crp wcel cK cn wcel cA cr wcel cB nnrp ad2antrr sylanc cB cn wcel
    cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co cfl cfv cB cmo co cB
    cB cK cexp co cB cK cexp co cA cmul co cfl cfv cr wcel cB crp wcel cB cK
    cexp co cA cmul co cfl cfv cB cmo co cr wcel cB cn wcel cK cn wcel wa cA cr
    wcel wa cB cK cexp co cA cmul co cfl cfv cB modcl cB cn wcel cK cn wcel wa
    cA cr wcel wa cB cK cexp co cA cmul co cr wcel cB cK cexp co cA cmul co cfl
    cfv cr wcel cB cK cexp co cr wcel cA cr wcel cB cK cexp co cA cmul co cr
    wcel cB cn wcel cK cn wcel wa cB cK cexp co cA remulcl cB cr wcel cK cn0
    wcel cB cK cexp co cr wcel cB cn wcel cK cn wcel cB cK reexpcl cB nnre cK
    nnnn0 syl2an sylan cB cK cexp co cA cmul co reflcl syl cB cn wcel cB crp
    wcel cK cn wcel cA cr wcel cB nnrp ad2antrr sylanc cB cn wcel cB cr wcel cK
    cn wcel cA cr wcel cB nnre ad2antrr cB cn wcel cK cn wcel wa cB cK cexp co
    cr wcel cA cr wcel cB cr wcel cK cn0 wcel cB cK cexp co cr wcel cB cn wcel
    cK cn wcel cB cK reexpcl cB nnre cK nnnn0 syl2an adantr cB cK cexp co cA
    cmul co cfl cfv cr wcel cB crp wcel cB cK cexp co cA cmul co cfl cfv cB cmo
    co cB clt wbr cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul
    co cfl cfv cB modlt cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA
    cmul co cr wcel cB cK cexp co cA cmul co cfl cfv cr wcel cB cK cexp co cr
    wcel cA cr wcel cB cK cexp co cA cmul co cr wcel cB cn wcel cK cn wcel wa
    cB cK cexp co cA remulcl cB cr wcel cK cn0 wcel cB cK cexp co cr wcel cB cn
    wcel cK cn wcel cB cK reexpcl cB nnre cK nnnn0 syl2an sylan cB cK cexp co
    cA cmul co reflcl syl cB cn wcel cB crp wcel cK cn wcel cA cr wcel cB nnrp
    ad2antrr sylanc cB cn wcel cK cn wcel wa cB cB cK cexp co cle wbr cA cr
    wcel cB cn wcel cK cn wcel wa cB c1 cexp co cB cB cK cexp co cle cB cn wcel
    cB c1 cexp co cB wceq cK cn wcel cB cn wcel cB cc wcel cB c1 cexp co cB
    wceq cB nncn cB exp1 syl adantr cB cr wcel c1 cn0 wcel cK cn0 wcel w3a c1
    cB cle wbr c1 cK cle wbr wa cB c1 cexp co cB cK cexp co cle wbr cB cn wcel
    cK cn wcel wa cB c1 cK expwordi cB cn wcel cK cn wcel wa cB cr wcel c1 cn0
    wcel cK cn0 wcel cB cn wcel cB cr wcel cK cn wcel cB nnre adantr c1 cn0
    wcel cB cn wcel cK cn wcel wa 1nn0 a1i cK cn wcel cK cn0 wcel cB cn wcel cK
    nnnn0 adantl 3jca cB cn wcel c1 cB cle wbr cK cn wcel c1 cK cle wbr cB
    nnge1 cK nnge1 anim12i sylanc eqbrtrrd adantr ltletrd syl2anc cB cn wcel cK
    cn wcel wa cA cr wcel wa cB cB cK c1 cmin co cexp co cA cmul co cfl cfv
    cmul co cB cK cexp co cmo co cB cK cexp co cA cmul co cfl cfv cB cK cexp co
    cmo co cle wbr cB cK cexp co cA cmul co cfl cfv cB cB cK c1 cmin co cexp co
    cA cmul co cfl cfv cmul co cmin co cB cK cexp co cmo co cB cK cexp co cA
    cmul co cfl cfv cB cK cexp co cmo co cB cB cK c1 cmin co cexp co cA cmul co
    cfl cfv cmul co cB cK cexp co cmo co cmin co wceq cB cn wcel cK cn wcel wa
    cA cr wcel wa cB cB cK c1 cmin co cexp co cA cmul co cfl cfv cmul co cB cB
    cK c1 cmin co cexp co cmul co cmo co cB cB cK c1 cmin co cexp co cA cmul co
    cmul co cfl cfv cB cB cK c1 cmin co cexp co cmul co cmo co cB cB cK c1 cmin
    co cexp co cA cmul co cfl cfv cmul co cB cK cexp co cmo co cB cK cexp co cA
    cmul co cfl cfv cB cK cexp co cmo co cle cB cn wcel cB cK c1 cmin co cexp
    co cA cmul co cr wcel cB cK c1 cmin co cexp co cn wcel cB cB cK c1 cmin co
    cexp co cA cmul co cfl cfv cmul co cB cB cK c1 cmin co cexp co cmul co cmo
    co cB cB cK c1 cmin co cexp co cA cmul co cmul co cfl cfv cB cB cK c1 cmin
    co cexp co cmul co cmo co cle wbr cB cn wcel cK cn wcel wa cA cr wcel wa cB
    cK c1 cmin co cexp co cA cmul co cB cK c1 cmin co cexp co cB modmulnn cB cn
    wcel cK cn wcel cA cr wcel simpll cB cK c1 cmin co cexp co cr wcel cA cr
    wcel cB cK c1 cmin co cexp co cA cmul co cr wcel cB cn wcel cK cn wcel wa
    cB cK c1 cmin co cexp co cA remulcl cB cr wcel cK c1 cmin co cn0 wcel cB cK
    c1 cmin co cexp co cr wcel cB cn wcel cK cn wcel cB cK c1 cmin co reexpcl
    cB nnre cK nnm1nn0 syl2an sylan cB cn wcel cK cn wcel wa cB cK c1 cmin co
    cexp co cn wcel cA cr wcel cB cn wcel cK c1 cmin co cn0 wcel cB cK c1 cmin
    co cexp co cn wcel cK cn wcel cB cK c1 cmin co nnexpcl cK nnm1nn0 sylan2
    adantr syl3anc cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cB cB
    cK c1 cmin co cexp co cmul co cB cB cK c1 cmin co cexp co cA cmul co cfl
    cfv cmul co cmo cB cn wcel cK cn wcel wa cB cK cexp co cB cB cK c1 cmin co
    cexp co cmul co wceq cA cr wcel cB cc wcel cK cn wcel cB cK cexp co cB cB
    cK c1 cmin co cexp co cmul co wceq cB cn wcel cB cc wcel cK cn wcel wa cB
    cK cexp co cB cK c1 cmin co cexp co cB cmul co cB cB cK c1 cmin co cexp co
    cmul co cB cK expm1t cB cK c1 cmin co cexp co cc wcel cB cc wcel cB cK c1
    cmin co cexp co cB cmul co cB cB cK c1 cmin co cexp co cmul co wceq cB cc
    wcel cK cn wcel wa cB cK c1 cmin co cexp co cB mulcom cB cc wcel cK c1 cmin
    co cn0 wcel cB cK c1 cmin co cexp co cc wcel cK cn wcel cB cK c1 cmin co
    expcl cK nnm1nn0 sylan2 cB cc wcel cK cn wcel pm3.26 sylanc eqtrd cB nncn
    sylan adantr opreq2d cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co
    cA cmul co cfl cfv cB cB cK c1 cmin co cexp co cA cmul co cmul co cfl cfv
    cB cK cexp co cB cB cK c1 cmin co cexp co cmul co cmo cB cn wcel cK cn wcel
    wa cA cr wcel wa cB cK cexp co cA cmul co cB cB cK c1 cmin co cexp co cA
    cmul co cmul co cfl cB cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA
    cmul co cB cB cK c1 cmin co cexp co cmul co cA cmul co cB cB cK c1 cmin co
    cexp co cA cmul co cmul co cB cn wcel cK cn wcel wa cA cr wcel wa cB cK
    cexp co cB cB cK c1 cmin co cexp co cmul co cA cmul cB cn wcel cK cn wcel
    wa cB cK cexp co cB cB cK c1 cmin co cexp co cmul co wceq cA cr wcel cB cc
    wcel cK cn wcel cB cK cexp co cB cB cK c1 cmin co cexp co cmul co wceq cB
    cn wcel cB cc wcel cK cn wcel wa cB cK cexp co cB cK c1 cmin co cexp co cB
    cmul co cB cB cK c1 cmin co cexp co cmul co cB cK expm1t cB cK c1 cmin co
    cexp co cc wcel cB cc wcel cB cK c1 cmin co cexp co cB cmul co cB cB cK c1
    cmin co cexp co cmul co wceq cB cc wcel cK cn wcel wa cB cK c1 cmin co cexp
    co cB mulcom cB cc wcel cK c1 cmin co cn0 wcel cB cK c1 cmin co cexp co cc
    wcel cK cn wcel cB cK c1 cmin co expcl cK nnm1nn0 sylan2 cB cc wcel cK cn
    wcel pm3.26 sylanc eqtrd cB nncn sylan adantr opreq1d cB cc wcel cB cK c1
    cmin co cexp co cc wcel cA cc wcel cB cB cK c1 cmin co cexp co cmul co cA
    cmul co cB cB cK c1 cmin co cexp co cA cmul co cmul co wceq cB cn wcel cK
    cn wcel wa cA cr wcel wa cB cB cK c1 cmin co cexp co cA mulass cB cn wcel
    cB cc wcel cK cn wcel cA cr wcel cB nncn ad2antrr cB cn wcel cK cn wcel wa
    cB cK c1 cmin co cexp co cc wcel cA cr wcel cB cc wcel cK c1 cmin co cn0
    wcel cB cK c1 cmin co cexp co cc wcel cB cn wcel cK cn wcel cB cK c1 cmin
    co expcl cB nncn cK nnm1nn0 syl2an adantr cA cr wcel cA cc wcel cB cn wcel
    cK cn wcel wa cA recn adantl syl3anc eqtrd fveq2d cB cn wcel cK cn wcel wa
    cB cK cexp co cB cB cK c1 cmin co cexp co cmul co wceq cA cr wcel cB cc
    wcel cK cn wcel cB cK cexp co cB cB cK c1 cmin co cexp co cmul co wceq cB
    cn wcel cB cc wcel cK cn wcel wa cB cK cexp co cB cK c1 cmin co cexp co cB
    cmul co cB cB cK c1 cmin co cexp co cmul co cB cK expm1t cB cK c1 cmin co
    cexp co cc wcel cB cc wcel cB cK c1 cmin co cexp co cB cmul co cB cB cK c1
    cmin co cexp co cmul co wceq cB cc wcel cK cn wcel wa cB cK c1 cmin co cexp
    co cB mulcom cB cc wcel cK c1 cmin co cn0 wcel cB cK c1 cmin co cexp co cc
    wcel cK cn wcel cB cK c1 cmin co expcl cK nnm1nn0 sylan2 cB cc wcel cK cn
    wcel pm3.26 sylanc eqtrd cB nncn sylan adantr opreq12d 3brtr4d cB cK cexp
    co cA cmul co cfl cfv cr wcel cB cB cK c1 cmin co cexp co cA cmul co cfl
    cfv cmul co cr wcel cB cK cexp co crp wcel cB cB cK c1 cmin co cexp co cA
    cmul co cfl cfv cmul co cB cK cexp co cmo co cB cK cexp co cA cmul co cfl
    cfv cB cK cexp co cmo co cle wbr cB cK cexp co cA cmul co cfl cfv cB cB cK
    c1 cmin co cexp co cA cmul co cfl cfv cmul co cmin co cB cK cexp co cmo co
    cB cK cexp co cA cmul co cfl cfv cB cK cexp co cmo co cB cB cK c1 cmin co
    cexp co cA cmul co cfl cfv cmul co cB cK cexp co cmo co cmin co wceq wb cB
    cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co cfl cfv cB cB
    cK c1 cmin co cexp co cA cmul co cfl cfv cmul co cB cK cexp co modsubdir cB
    cn wcel cK cn wcel wa cA cr wcel wa cB cK cexp co cA cmul co cr wcel cB cK
    cexp co cA cmul co cfl cfv cr wcel cB cK cexp co cr wcel cA cr wcel cB cK
    cexp co cA cmul co cr wcel cB cn wcel cK cn wcel wa cB cK cexp co cA
    remulcl cB cr wcel cK cn0 wcel cB cK cexp co cr wcel cB cn wcel cK cn wcel
    cB cK reexpcl cB nnre cK nnnn0 syl2an sylan cB cK cexp co cA cmul co reflcl
    syl cB cr wcel cB cK c1 cmin co cexp co cA cmul co cfl cfv cr wcel cB cB cK
    c1 cmin co cexp co cA cmul co cfl cfv cmul co cr wcel cB cn wcel cK cn wcel
    wa cA cr wcel wa cB cB cK c1 cmin co cexp co cA cmul co cfl cfv remulcl cB
    cn wcel cB cr wcel cK cn wcel cA cr wcel cB nnre ad2antrr cB cn wcel cK cn
    wcel wa cA cr wcel wa cB cK c1 cmin co cexp co cA cmul co cr wcel cB cK c1
    cmin co cexp co cA cmul co cfl cfv cr wcel cB cK c1 cmin co cexp co cr wcel
    cA cr wcel cB cK c1 cmin co cexp co cA cmul co cr wcel cB cn wcel cK cn
    wcel wa cB cK c1 cmin co cexp co cA remulcl cB cr wcel cK c1 cmin co cn0
    wcel cB cK c1 cmin co cexp co cr wcel cB cn wcel cK cn wcel cB cK c1 cmin
    co reexpcl cB nnre cK nnm1nn0 syl2an sylan cB cK c1 cmin co cexp co cA cmul
    co reflcl syl sylanc cB cn wcel cK cn wcel wa cB cK cexp co crp wcel cA cr
    wcel cB cn wcel cK cn wcel wa cB cK cexp co cn wcel cB cK cexp co crp wcel
    cB cn wcel cK cn0 wcel cB cK cexp co cn wcel cK cn wcel cB cK nnexpcl cK
    nnnn0 sylan2 cB cK cexp co nnrp syl adantr syl3anc mpbid 3eqtr3d 3impa
    3comr $.
    $( [8-Apr-2009] $)



$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Discriminant
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    discrlem.1 $e |- A e. RR $.
    discrlem.2 $e |- B e. RR $.
    discrlem.3 $e |- C e. RR $.
    ${
      discrlem1.4 $e |- D = -u ( B / ( 2 x. A ) ) $.
      ${
        discrlem1.5 $e |- 0 < A $.
        $( Lemma for discriminant theorem. $)
        discrlem1 $p |- ( 0 <_
                     ( ( ( A x. ( D ^ 2 ) ) + ( B x. D ) ) + C ) <->
                     ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) <_ 0 ) $=
          cc0 cA cD c2 cexp co cmul co cB cD cmul co caddc co cC caddc co cle
          wbr cc0 cneg cB c2 cexp co c4 cA cC cmul co cmul co cmin co cneg cle
          wbr cB c2 cexp co c4 cA cC cmul co cmul co cmin co cc0 cle wbr c4 cA
          cmul co cc0 cmul co c4 cA cmul co cA cD c2 cexp co cmul co cB cD cmul
          co caddc co cC caddc co cmul co cle wbr cc0 c4 cA cmul co cA cD c2
          cexp co cmul co cB cD cmul co caddc co cmul co c4 cA cmul co cC cmul
          co caddc co cle wbr cc0 cA cD c2 cexp co cmul co cB cD cmul co caddc
          co cC caddc co cle wbr cc0 cneg cB c2 cexp co c4 cA cC cmul co cmul
          co cmin co cneg cle wbr c4 cA cmul co cc0 cmul co cc0 c4 cA cmul co
          cA cD c2 cexp co cmul co cB cD cmul co caddc co cC caddc co cmul co
          c4 cA cmul co cA cD c2 cexp co cmul co cB cD cmul co caddc co cmul co
          c4 cA cmul co cC cmul co caddc co cle c4 cA cmul co c4 cA cmul co c4
          cA 4re discrlem.1 remulcli recni mul01i c4 cA cmul co cA cD c2 cexp
          co cmul co cB cD cmul co caddc co cC c4 cA cmul co c4 cA 4re
          discrlem.1 remulcli recni cA cD c2 cexp co cmul co cB cD cmul co
          caddc co cA cD c2 cexp co cmul co cB cD cmul co cA cD c2 cexp co
          discrlem.1 cD cD cB c2 cA cmul co cdiv co cneg cr discrlem1.4 cB c2
          cA cmul co cdiv co cB c2 cA cmul co discrlem.2 c2 cA 2re discrlem.1
          remulcli c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1 discrlem1.5
          gt0ne0ii muln0i redivcli renegcli eqeltri resqcli remulcli cB cD
          discrlem.2 cD cB c2 cA cmul co cdiv co cneg cr discrlem1.4 cB c2 cA
          cmul co cdiv co cB c2 cA cmul co discrlem.2 c2 cA 2re discrlem.1
          remulcli c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1 discrlem1.5
          gt0ne0ii muln0i redivcli renegcli eqeltri remulcli readdcli recni cC
          discrlem.3 recni adddii breq12i cc0 c4 cA cmul co clt wbr cc0 cA cD
          c2 cexp co cmul co cB cD cmul co caddc co cC caddc co cle wbr c4 cA
          cmul co cc0 cmul co c4 cA cmul co cA cD c2 cexp co cmul co cB cD cmul
          co caddc co cC caddc co cmul co cle wbr wb c4 cA 4re discrlem.1 4pos
          discrlem1.5 mulgt0ii cc0 cA cD c2 cexp co cmul co cB cD cmul co caddc
          co cC caddc co c4 cA cmul co 0re cA cD c2 cexp co cmul co cB cD cmul
          co caddc co cC cA cD c2 cexp co cmul co cB cD cmul co cA cD c2 cexp
          co discrlem.1 cD cD cB c2 cA cmul co cdiv co cneg cr discrlem1.4 cB
          c2 cA cmul co cdiv co cB c2 cA cmul co discrlem.2 c2 cA 2re
          discrlem.1 remulcli c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1
          discrlem1.5 gt0ne0ii muln0i redivcli renegcli eqeltri resqcli
          remulcli cB cD discrlem.2 cD cB c2 cA cmul co cdiv co cneg cr
          discrlem1.4 cB c2 cA cmul co cdiv co cB c2 cA cmul co discrlem.2 c2
          cA 2re discrlem.1 remulcli c2 cA 2cn cA discrlem.1 recni 2ne0 cA
          discrlem.1 discrlem1.5 gt0ne0ii muln0i redivcli renegcli eqeltri
          remulcli readdcli discrlem.3 readdcli c4 cA 4re discrlem.1 remulcli
          lemul2i ax-mp cc0 cneg cc0 cB c2 cexp co c4 cA cC cmul co cmul co
          cmin co cneg c4 cA cmul co cA cD c2 cexp co cmul co cB cD cmul co
          caddc co cmul co c4 cA cmul co cC cmul co caddc co cle neg0 cB c2
          cexp co c4 cA cC cmul co cmul co cmin co cneg cB c2 cexp co cneg c4
          cA cC cmul co cmul co caddc co c4 cA cmul co cA cD c2 cexp co cmul co
          cB cD cmul co caddc co cmul co c4 cA cmul co cC cmul co caddc co cB
          c2 cexp co c4 cA cC cmul co cmul co cB c2 cexp co cB discrlem.2
          resqcli recni c4 cA cC cmul co cmul co c4 cA cC cmul co 4re cA cC
          discrlem.1 discrlem.3 remulcli remulcli recni negsubdii c4 cA cmul co
          cA cD c2 cexp co cmul co cB cD cmul co caddc co cmul co cB c2 cexp co
          cneg c4 cA cmul co cC cmul co c4 cA cC cmul co cmul co caddc c4 cA
          cmul co cA cD c2 cexp co cmul co cB cD cmul co caddc co cmul co c4 cA
          cmul co cB c2 cexp co c4 cA cmul co cdiv co cneg cmul co c4 cA cmul
          co cB c2 cexp co c4 cA cmul co cdiv co cmul co cneg cB c2 cexp co
          cneg cA cD c2 cexp co cmul co cB cD cmul co caddc co cB c2 cexp co c4
          cA cmul co cdiv co cneg c4 cA cmul co cmul cA cD c2 cexp co cmul co
          cB cD cmul co caddc co c1 cB c2 cdiv co cmul co cB c2 cA cmul co cdiv
          co cmul co c2 cneg cB c2 cdiv co cmul co cB c2 cA cmul co cdiv co
          cmul co caddc co cB c2 cexp co c4 cA cmul co cdiv co cneg cA cD c2
          cexp co cmul co c1 cB c2 cdiv co cmul co cB c2 cA cmul co cdiv co
          cmul co cB cD cmul co c2 cneg cB c2 cdiv co cmul co cB c2 cA cmul co
          cdiv co cmul co caddc c2 cA cmul co c2 cdiv co cB c2 cA cmul co cdiv
          co cmul co cB c2 cA cmul co cdiv co cmul co c2 cA cmul co c2 cdiv co
          cB c2 cA cmul co cdiv co cB c2 cA cmul co cdiv co cmul co cmul co c1
          cB c2 cdiv co cmul co cB c2 cA cmul co cdiv co cmul co cA cD c2 cexp
          co cmul co c2 cA cmul co c2 cdiv co cB c2 cA cmul co cdiv co cB c2 cA
          cmul co cdiv co c2 cA cmul co c2 c2 cA cmul co c2 cA 2re discrlem.1
          remulcli recni 2cn 2ne0 divcli cB c2 cA cmul co cdiv co cB c2 cA cmul
          co discrlem.2 c2 cA 2re discrlem.1 remulcli c2 cA 2cn cA discrlem.1
          recni 2ne0 cA discrlem.1 discrlem1.5 gt0ne0ii muln0i redivcli recni
          cB c2 cA cmul co cdiv co cB c2 cA cmul co discrlem.2 c2 cA 2re
          discrlem.1 remulcli c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1
          discrlem1.5 gt0ne0ii muln0i redivcli recni mulassi c2 cA cmul co c2
          cdiv co cB c2 cA cmul co cdiv co cmul co c1 cB c2 cdiv co cmul co cB
          c2 cA cmul co cdiv co cmul c2 cA cmul co c2 cdiv co cB c2 cA cmul co
          cdiv co cmul co cB c2 cdiv co c2 cA cmul co c2 cA cmul co cdiv co
          cmul co cB c2 cdiv co c1 cmul co c1 cB c2 cdiv co cmul co c2 cA cmul
          co c2 cB c2 cA cmul co c2 cA cmul co c2 cA 2re discrlem.1 remulcli
          recni 2cn cB discrlem.2 recni c2 cA cmul co c2 cA 2re discrlem.1
          remulcli recni 2ne0 c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1
          discrlem1.5 gt0ne0ii muln0i divmul13i c2 cA cmul co c2 cA cmul co
          cdiv co c1 cB c2 cdiv co cmul c2 cA cmul co c2 cA cmul co c2 cA 2re
          discrlem.1 remulcli recni c2 cA 2cn cA discrlem.1 recni 2ne0 cA
          discrlem.1 discrlem1.5 gt0ne0ii muln0i dividi opreq2i cB c2 cdiv co
          c1 cB c2 cB discrlem.2 recni 2cn 2ne0 divcli ax1cn mulcomi 3eqtri
          opreq1i c2 cA cmul co c2 cdiv co cA cB c2 cA cmul co cdiv co cB c2 cA
          cmul co cdiv co cmul co cD c2 cexp co cmul cA c2 cA discrlem.1 recni
          2cn 2ne0 divcan3i cD c2 cexp co cB c2 cA cmul co cdiv co cneg c2 cexp
          co cB c2 cA cmul co cdiv co cneg cB c2 cA cmul co cdiv co cneg cmul
          co cB c2 cA cmul co cdiv co cB c2 cA cmul co cdiv co cmul co cD cB c2
          cA cmul co cdiv co cneg c2 cexp discrlem1.4 opreq1i cB c2 cA cmul co
          cdiv co cneg cB c2 cA cmul co cdiv co cneg cB c2 cA cmul co cdiv co
          cB c2 cA cmul co discrlem.2 c2 cA 2re discrlem.1 remulcli c2 cA 2cn
          cA discrlem.1 recni 2ne0 cA discrlem.1 discrlem1.5 gt0ne0ii muln0i
          redivcli renegcli recni sqvali cB c2 cA cmul co cdiv co cB c2 cA cmul
          co cdiv co cB c2 cA cmul co cdiv co cB c2 cA cmul co discrlem.2 c2 cA
          2re discrlem.1 remulcli c2 cA 2cn cA discrlem.1 recni 2ne0 cA
          discrlem.1 discrlem1.5 gt0ne0ii muln0i redivcli recni cB c2 cA cmul
          co cdiv co cB c2 cA cmul co discrlem.2 c2 cA 2re discrlem.1 remulcli
          c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1 discrlem1.5 gt0ne0ii
          muln0i redivcli recni mul2negi 3eqtrri opreq12i 3eqtr3ri cB cD cmul
          co c2 cneg cB c2 cdiv co cmul co cneg cB c2 cA cmul co cdiv co cneg
          cmul co c2 cneg cB c2 cdiv co cmul co cB c2 cA cmul co cdiv co cmul
          co cB c2 cneg cB c2 cdiv co cmul co cneg cD cB c2 cA cmul co cdiv co
          cneg cmul c2 cneg cneg cB c2 cdiv co cmul co c2 cB c2 cdiv co cmul co
          c2 cneg cB c2 cdiv co cmul co cneg cB c2 cneg cneg c2 cB c2 cdiv co
          cmul c2 2cn negnegi opreq1i c2 cneg cB c2 cdiv co c2 2cn negcli cB c2
          cB discrlem.2 recni 2cn 2ne0 divcli mulneg1i cB c2 cB discrlem.2
          recni 2cn 2ne0 divcan2i 3eqtr3ri discrlem1.4 opreq12i c2 cneg cB c2
          cdiv co cmul co cB c2 cA cmul co cdiv co c2 cneg cB c2 cdiv co c2 2cn
          negcli cB c2 cB discrlem.2 recni 2cn 2ne0 divcli mulcli cB c2 cA cmul
          co cdiv co cB c2 cA cmul co discrlem.2 c2 cA 2re discrlem.1 remulcli
          c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1 discrlem1.5 gt0ne0ii
          muln0i redivcli recni mul2negi eqtri opreq12i c1 cB c2 cdiv co cmul
          co c2 cneg cB c2 cdiv co cmul co caddc co cB c2 cA cmul co cdiv co
          cmul co cB c2 cdiv co cneg cB c2 cA cmul co cdiv co cmul co c1 cB c2
          cdiv co cmul co cB c2 cA cmul co cdiv co cmul co c2 cneg cB c2 cdiv
          co cmul co cB c2 cA cmul co cdiv co cmul co caddc co cB c2 cexp co c4
          cA cmul co cdiv co cneg c1 cB c2 cdiv co cmul co c2 cneg cB c2 cdiv
          co cmul co caddc co cB c2 cdiv co cneg cB c2 cA cmul co cdiv co cmul
          c1 c2 cneg caddc co cB c2 cdiv co cmul co c1 cneg cB c2 cdiv co cmul
          co c1 cB c2 cdiv co cmul co c2 cneg cB c2 cdiv co cmul co caddc co cB
          c2 cdiv co cneg c1 c2 cneg caddc co c1 cneg cB c2 cdiv co cmul c1 c2
          cneg caddc co c1 c1 cneg c1 cneg caddc co caddc co c1 cneg c2 cneg c1
          cneg c1 cneg caddc co c1 caddc c2 cneg c1 c1 caddc co cneg c1 cneg c1
          cneg caddc co c2 c1 c1 caddc co df-2 negeqi c1 c1 ax1cn ax1cn negdii
          eqtri opreq2i c1 c1 cneg caddc co c1 cneg caddc co cc0 c1 cneg caddc
          co c1 c1 cneg c1 cneg caddc co caddc co c1 cneg c1 c1 cneg caddc co
          cc0 c1 cneg caddc c1 ax1cn negidi opreq1i c1 c1 cneg c1 cneg ax1cn c1
          ax1cn negcli c1 ax1cn negcli addassi c1 cneg c1 ax1cn negcli addid2i
          3eqtr3i eqtri opreq1i c1 c2 cneg cB c2 cdiv co ax1cn c2 2cn negcli cB
          c2 cB discrlem.2 recni 2cn 2ne0 divcli adddiri cB c2 cdiv co cB c2 cB
          discrlem.2 recni 2cn 2ne0 divcli mulm1i 3eqtr3i opreq1i c1 cB c2 cdiv
          co cmul co c2 cneg cB c2 cdiv co cmul co cB c2 cA cmul co cdiv co c1
          cB c2 cdiv co ax1cn cB c2 cB discrlem.2 recni 2cn 2ne0 divcli mulcli
          c2 cneg cB c2 cdiv co c2 2cn negcli cB c2 cB discrlem.2 recni 2cn
          2ne0 divcli mulcli cB c2 cA cmul co cdiv co cB c2 cA cmul co
          discrlem.2 c2 cA 2re discrlem.1 remulcli c2 cA 2cn cA discrlem.1
          recni 2ne0 cA discrlem.1 discrlem1.5 gt0ne0ii muln0i redivcli recni
          adddiri cB c2 cdiv co cneg cB c2 cA cmul co cdiv co cmul co cB c2
          cdiv co cB c2 cA cmul co cdiv co cmul co cneg cB c2 cexp co c4 cA
          cmul co cdiv co cneg cB c2 cdiv co cB c2 cA cmul co cdiv co cB c2 cB
          discrlem.2 recni 2cn 2ne0 divcli cB c2 cA cmul co cdiv co cB c2 cA
          cmul co discrlem.2 c2 cA 2re discrlem.1 remulcli c2 cA 2cn cA
          discrlem.1 recni 2ne0 cA discrlem.1 discrlem1.5 gt0ne0ii muln0i
          redivcli recni mulneg1i cB c2 cexp co c4 cA cmul co cdiv co cB c2
          cdiv co cB c2 cA cmul co cdiv co cmul co cB c2 cexp co c4 cA cmul co
          cdiv co cB cB cmul co c2 c2 cA cmul co cmul co cdiv co cB c2 cdiv co
          cB c2 cA cmul co cdiv co cmul co cB c2 cexp co cB cB cmul co c4 cA
          cmul co c2 c2 cA cmul co cmul co cdiv cB cB discrlem.2 recni sqvali
          c2 c2 cmul co cA cmul co c4 cA cmul co c2 c2 cA cmul co cmul co c2 c2
          cmul co c4 cA cmul 2t2e4 opreq1i c2 c2 cA 2cn 2cn cA discrlem.1 recni
          mulassi eqtr3i opreq12i cB c2 cB c2 cA cmul co cB discrlem.2 recni
          2cn cB discrlem.2 recni c2 cA cmul co c2 cA 2re discrlem.1 remulcli
          recni 2ne0 c2 cA 2cn cA discrlem.1 recni 2ne0 cA discrlem.1
          discrlem1.5 gt0ne0ii muln0i divmuldivi eqtr4i negeqi eqtr4i 3eqtr3i
          eqtri opreq2i c4 cA cmul co cB c2 cexp co c4 cA cmul co cdiv co c4 cA
          cmul co c4 cA 4re discrlem.1 remulcli recni cB c2 cexp co c4 cA cmul
          co cdiv co cB c2 cexp co c4 cA cmul co cB discrlem.2 resqcli c4 cA
          4re discrlem.1 remulcli c4 cA c4 4re recni cA discrlem.1 recni c4 4re
          4pos gt0ne0ii cA discrlem.1 discrlem1.5 gt0ne0ii muln0i redivcli
          recni mulneg2i c4 cA cmul co cB c2 cexp co c4 cA cmul co cdiv co cmul
          co cB c2 cexp co cB c2 cexp co c4 cA cmul co cB c2 cexp co cB
          discrlem.2 resqcli recni c4 cA cmul co c4 cA 4re discrlem.1 remulcli
          recni c4 cA c4 4re recni cA discrlem.1 recni c4 4re 4pos gt0ne0ii cA
          discrlem.1 discrlem1.5 gt0ne0ii muln0i divcan2i negeqi 3eqtri c4 cA
          cC c4 4re recni cA discrlem.1 recni cC discrlem.3 recni mulassi
          opreq12i eqtr4i breq12i 3bitr4i cB c2 cexp co c4 cA cC cmul co cmul
          co cmin co cc0 cB c2 cexp co c4 cA cC cmul co cmul co cB discrlem.2
          resqcli c4 cA cC cmul co 4re cA cC discrlem.1 discrlem.3 remulcli
          remulcli resubcli 0re lenegi bitr4i $.
          $( [6-Aug-1999] $)
      $}

      ${
        discrlem2.5 $e |- ( D e. RR -> 0 <_
                     ( ( ( A x. ( D ^ 2 ) ) + ( B x. D ) ) + C ) ) $.
        $( Lemma for discriminant theorem. $)
        discrlem2 $p |- ( 0 < A ->
                      ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) <_ 0 ) $=
          cc0 cA clt wbr cc0 cA cD c2 cexp co cmul co cB cD cmul co caddc co cC
          caddc co cle wbr cB c2 cexp co c4 cA cC cmul co cmul co cmin co cc0
          cle wbr cc0 cA clt wbr cD cr wcel cc0 cA cD c2 cexp co cmul co cB cD
          cmul co caddc co cC caddc co cle wbr cc0 cA clt wbr cB c2 cA cmul co
          cdiv co cneg cr cD cc0 cA clt wbr c2 cA cmul co cc0 wne cB c2 cA cmul
          co cdiv co cr wcel cB c2 cA cmul co cdiv co cneg cr wcel cc0 cA clt
          wbr cc0 c2 cA cmul co clt wbr c2 cA cmul co cc0 wne cc0 c2 clt wbr
          cc0 cA clt wbr cc0 c2 cA cmul co clt wbr 2pos c2 cA 2re discrlem.1
          mulgt0i mpan c2 cA cmul co c2 cA 2re discrlem.1 remulcli gt0ne0i syl
          cB c2 cA cmul co discrlem.2 c2 cA 2re discrlem.1 remulcli redivclzi
          cB c2 cA cmul co cdiv co renegcl 3syl discrlem1.4 syl5eqel
          discrlem2.5 syl cc0 cA clt wbr cc0 cA cD c2 cexp co cmul co cB cD
          cmul co caddc co cC caddc co cle wbr cB c2 cexp co c4 cA cC cmul co
          cmul co cmin co cc0 cle wbr wb cc0 cc0 cA clt wbr cA c1 cif cB c2 cc0
          cA clt wbr cA c1 cif cmul co cdiv co cneg c2 cexp co cmul co cB cB c2
          cc0 cA clt wbr cA c1 cif cmul co cdiv co cneg cmul co caddc co cC
          caddc co cle wbr cB c2 cexp co c4 cc0 cA clt wbr cA c1 cif cC cmul co
          cmul co cmin co cc0 cle wbr wb cA c1 cA cc0 cA clt wbr cA c1 cif wceq
          cc0 cA cD c2 cexp co cmul co cB cD cmul co caddc co cC caddc co cle
          wbr cc0 cc0 cA clt wbr cA c1 cif cB c2 cc0 cA clt wbr cA c1 cif cmul
          co cdiv co cneg c2 cexp co cmul co cB cB c2 cc0 cA clt wbr cA c1 cif
          cmul co cdiv co cneg cmul co caddc co cC caddc co cle wbr cB c2 cexp
          co c4 cA cC cmul co cmul co cmin co cc0 cle wbr cB c2 cexp co c4 cc0
          cA clt wbr cA c1 cif cC cmul co cmul co cmin co cc0 cle wbr cA cc0 cA
          clt wbr cA c1 cif wceq cA cD c2 cexp co cmul co cB cD cmul co caddc
          co cC caddc co cc0 cA clt wbr cA c1 cif cB c2 cc0 cA clt wbr cA c1
          cif cmul co cdiv co cneg c2 cexp co cmul co cB cB c2 cc0 cA clt wbr
          cA c1 cif cmul co cdiv co cneg cmul co caddc co cC caddc co cc0 cle
          cA cc0 cA clt wbr cA c1 cif wceq cA cD c2 cexp co cmul co cB cD cmul
          co caddc co cc0 cA clt wbr cA c1 cif cB c2 cc0 cA clt wbr cA c1 cif
          cmul co cdiv co cneg c2 cexp co cmul co cB cB c2 cc0 cA clt wbr cA c1
          cif cmul co cdiv co cneg cmul co caddc co cC caddc cA cc0 cA clt wbr
          cA c1 cif wceq cA cD c2 cexp co cmul co cc0 cA clt wbr cA c1 cif cB
          c2 cc0 cA clt wbr cA c1 cif cmul co cdiv co cneg c2 cexp co cmul co
          cB cD cmul co cB cB c2 cc0 cA clt wbr cA c1 cif cmul co cdiv co cneg
          cmul co caddc cA cc0 cA clt wbr cA c1 cif wceq cA cc0 cA clt wbr cA
          c1 cif cD c2 cexp co cB c2 cc0 cA clt wbr cA c1 cif cmul co cdiv co
          cneg c2 cexp co cmul cA cc0 cA clt wbr cA c1 cif wceq id cA cc0 cA
          clt wbr cA c1 cif wceq cD cB c2 cc0 cA clt wbr cA c1 cif cmul co cdiv
          co cneg c2 cexp cA cc0 cA clt wbr cA c1 cif wceq cB c2 cA cmul co
          cdiv co cneg cB c2 cc0 cA clt wbr cA c1 cif cmul co cdiv co cneg cD
          cA cc0 cA clt wbr cA c1 cif wceq cB c2 cA cmul co cdiv co cB c2 cc0
          cA clt wbr cA c1 cif cmul co cdiv co cA cc0 cA clt wbr cA c1 cif wceq
          c2 cA cmul co c2 cc0 cA clt wbr cA c1 cif cmul co cB cdiv cA cc0 cA
          clt wbr cA c1 cif c2 cmul opreq2 opreq2d negeqd discrlem1.4 syl5eq
          opreq1d opreq12d cA cc0 cA clt wbr cA c1 cif wceq cD cB c2 cc0 cA clt
          wbr cA c1 cif cmul co cdiv co cneg cB cmul cA cc0 cA clt wbr cA c1
          cif wceq cB c2 cA cmul co cdiv co cneg cB c2 cc0 cA clt wbr cA c1 cif
          cmul co cdiv co cneg cD cA cc0 cA clt wbr cA c1 cif wceq cB c2 cA
          cmul co cdiv co cB c2 cc0 cA clt wbr cA c1 cif cmul co cdiv co cA cc0
          cA clt wbr cA c1 cif wceq c2 cA cmul co c2 cc0 cA clt wbr cA c1 cif
          cmul co cB cdiv cA cc0 cA clt wbr cA c1 cif c2 cmul opreq2 opreq2d
          negeqd discrlem1.4 syl5eq opreq2d opreq12d opreq1d breq2d cA cc0 cA
          clt wbr cA c1 cif wceq cB c2 cexp co c4 cA cC cmul co cmul co cmin co
          cB c2 cexp co c4 cc0 cA clt wbr cA c1 cif cC cmul co cmul co cmin co
          cc0 cle cA cc0 cA clt wbr cA c1 cif wceq c4 cA cC cmul co cmul co c4
          cc0 cA clt wbr cA c1 cif cC cmul co cmul co cB c2 cexp co cmin cA cc0
          cA clt wbr cA c1 cif wceq cA cC cmul co cc0 cA clt wbr cA c1 cif cC
          cmul co c4 cmul cA cc0 cA clt wbr cA c1 cif cC cmul opreq1 opreq2d
          opreq2d breq1d bibi12d cc0 cA clt wbr cA c1 cif cB cC cB c2 cc0 cA
          clt wbr cA c1 cif cmul co cdiv co cneg cc0 cA clt wbr cA c1 cr
          discrlem.1 1re keepel discrlem.2 discrlem.3 cB c2 cc0 cA clt wbr cA
          c1 cif cmul co cdiv co cneg eqid cA elimgt0 discrlem1 dedth mpbid $.
          $( [9-Aug-1999] $)
      $}

    $}

    ${
      discrlem3.4 $e |- D = ( ( C + 1 ) / -u B ) $.
      discrlem3.5 $e |- ( D e. RR -> 0 <_
                     ( ( ( A x. ( D ^ 2 ) ) + ( B x. D ) ) + C ) ) $.
      $( Lemma for discriminant theorem. $)
      discrlem3 $p |- ( 0 = A ->
                    ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) <_ 0 ) $=
        cc0 cA wceq cB c2 cexp co c4 cA cC cmul co cmul co cmin co cc0 wceq cB
        c2 cexp co c4 cA cC cmul co cmul co cmin co cc0 cle wbr cc0 cA wceq cB
        c2 cexp co c4 cA cC cmul co cmul co cmin co cc0 cc0 cmin co cc0 cc0 cA
        wceq cB c2 cexp co cc0 c4 cA cC cmul co cmul co cc0 cmin cc0 cA wceq cB
        cB cmul co cc0 cB c2 cexp co cc0 cA wceq cB cB cmul co cc0 cB cmul co
        cc0 cc0 cA wceq cB cc0 cB cmul cB cc0 wceq cc0 cA wceq cB cc0 wceq wn
        cc0 cA wceq cC cC c1 caddc co clt wbr cC discrlem.3 ltp1i cB cc0 wceq
        wn cB cneg cc0 wne cc0 cA wceq cC cC c1 caddc co clt wbr wn wi cB cc0
        wceq wn cB cc0 wne cB cneg cc0 wne cB cc0 df-ne cB cB discrlem.2 recni
        negne0bi bitr3i cB cneg cc0 wne cc0 cA wceq cC cC c1 caddc co clt wbr
        wn cB cneg cc0 wne cc0 cA wceq wa cC c1 caddc co cC cle wbr cC cC c1
        caddc co clt wbr wn cB cneg cc0 wne cc0 cA wceq wa cc0 cB cD cmul co
        cmin co cC cle wbr cC c1 caddc co cC cle wbr cB cneg cc0 wne cc0 cA
        wceq wa cc0 cB cD cmul co cmin co cC cle wbr cc0 cB cD cmul co cC caddc
        co cle wbr cB cneg cc0 wne cc0 cA wceq wa cc0 cA cD c2 cexp co cmul co
        cB cD cmul co caddc co cC caddc co cB cD cmul co cC caddc co cle cB
        cneg cc0 wne cc0 cA cD c2 cexp co cmul co cB cD cmul co caddc co cC
        caddc co cle wbr cc0 cA wceq cB cneg cc0 wne cD cr wcel cc0 cA cD c2
        cexp co cmul co cB cD cmul co caddc co cC caddc co cle wbr cB cneg cc0
        wne cC c1 caddc co cB cneg cdiv co cr cD cC c1 caddc co cB cneg cC c1
        discrlem.3 1re readdcli cB discrlem.2 renegcli redivclzi discrlem3.4
        syl5eqel discrlem3.5 syl adantr cB cneg cc0 wne cc0 cA wceq wa cA cD c2
        cexp co cmul co cB cD cmul co caddc co cB cD cmul co cC caddc cB cneg
        cc0 wne cc0 cA wceq wa cA cD c2 cexp co cmul co cB cD cmul co caddc co
        cc0 cB cD cmul co caddc co cB cD cmul co cB cneg cc0 wne cc0 cA wceq wa
        cA cD c2 cexp co cmul co cc0 cB cD cmul co caddc cc0 cA wceq cB cneg
        cc0 wne cA cD c2 cexp co cmul co cc0 cD c2 cexp co cmul co cc0 cc0 cA
        wceq cc0 cD c2 cexp co cmul co cA cD c2 cexp co cmul co cc0 cA cD c2
        cexp co cmul opreq1 eqcomd cB cneg cc0 wne cD cc wcel cD c2 cexp co cc
        wcel cc0 cD c2 cexp co cmul co cc0 wceq cB cneg cc0 wne cD cB cneg cc0
        wne cC c1 caddc co cB cneg cdiv co cr cD cC c1 caddc co cB cneg cC c1
        discrlem.3 1re readdcli cB discrlem.2 renegcli redivclzi discrlem3.4
        syl5eqel recnd cD sqcl cD c2 cexp co mul02 3syl sylan9eqr opreq1d cB
        cneg cc0 wne cc0 cB cD cmul co caddc co cB cD cmul co wceq cc0 cA wceq
        cB cneg cc0 wne cB cD cmul co cc wcel cc0 cB cD cmul co caddc co cB cD
        cmul co wceq cB cneg cc0 wne cB cD cmul co cB cr wcel cD cr wcel cB cD
        cmul co cr wcel cB cneg cc0 wne cB cD remulcl discrlem.2 cB cneg cc0
        wne cC c1 caddc co cB cneg cdiv co cr cD cC c1 caddc co cB cneg cC c1
        discrlem.3 1re readdcli cB discrlem.2 renegcli redivclzi discrlem3.4
        syl5eqel sylancr recnd cB cD cmul co addid2 syl adantr eqtrd opreq1d
        breqtrd cB cneg cc0 wne cc0 cB cD cmul co cmin co cC cle wbr cc0 cB cD
        cmul co cC caddc co cle wbr wb cc0 cA wceq cB cneg cc0 wne cB cr wcel
        cD cr wcel wa cB cD cmul co cr wcel cc0 cB cD cmul co cmin co cC cle
        wbr cc0 cB cD cmul co cC caddc co cle wbr wb cB cneg cc0 wne cD cr wcel
        cB cr wcel cB cneg cc0 wne cC c1 caddc co cB cneg cdiv co cr cD cC c1
        caddc co cB cneg cC c1 discrlem.3 1re readdcli cB discrlem.2 renegcli
        redivclzi discrlem3.4 syl5eqel discrlem.2 jctil cB cD remulcl cc0 cr
        wcel cB cD cmul co cr wcel cC cr wcel cc0 cB cD cmul co cmin co cC cle
        wbr cc0 cB cD cmul co cC caddc co cle wbr wb 0re discrlem.3 cc0 cB cD
        cmul co cC lesubadd2 mp3an13 3syl adantr mpbird cB cneg cc0 wne cc0 cB
        cD cmul co cmin co cC cle wbr cC c1 caddc co cC cle wbr wb cc0 cA wceq
        cB cneg cc0 wne cc0 cB cD cmul co cmin co cC c1 caddc co cC cle cB cneg
        cc0 wne cc0 cB cD cmul co cmin co cB cneg cC c1 caddc co cB cneg cdiv
        co cmul co cC c1 caddc co cB cneg cc0 wne cB cD cmul co cneg cB cneg cD
        cmul co cc0 cB cD cmul co cmin co cB cneg cC c1 caddc co cB cneg cdiv
        co cmul co cB cneg cc0 wne cB cneg cD cmul co cB cD cmul co cneg cB
        cneg cc0 wne cB cr wcel cD cr wcel wa cB cc wcel cD cc wcel wa cB cneg
        cD cmul co cB cD cmul co cneg wceq cB cneg cc0 wne cD cr wcel cB cr
        wcel cB cneg cc0 wne cC c1 caddc co cB cneg cdiv co cr cD cC c1 caddc
        co cB cneg cC c1 discrlem.3 1re readdcli cB discrlem.2 renegcli
        redivclzi discrlem3.4 syl5eqel discrlem.2 jctil cB cr wcel cB cc wcel
        cD cr wcel cD cc wcel cB recn cD recn anim12i cB cD mulneg1 3syl eqcomd
        cB cD cmul co df-neg cD cC c1 caddc co cB cneg cdiv co cB cneg cmul
        discrlem3.4 opreq2i 3eqtr3g cC c1 caddc co cB cneg cC c1 caddc co cC c1
        discrlem.3 1re readdcli recni cB cB discrlem.2 recni negcli divcan2zi
        eqtrd breq1d adantr mpbid cC c1 caddc co cC cC c1 discrlem.3 1re
        readdcli discrlem.3 lenlti sylib ex sylbi mt2i con4i opreq1d cB cB
        discrlem.2 recni mul02i syl6eq cB cB discrlem.2 recni sqvali syl5eq cc0
        cA wceq c4 cA cC cmul co cmul co c4 cc0 cmul co cc0 cc0 cA wceq cA cC
        cmul co cc0 c4 cmul cc0 cA wceq cc0 cC cmul co cA cC cmul co cc0 cc0 cA
        cC cmul opreq1 cC cC discrlem.3 recni mul02i syl5reqr opreq2d c4 c4 4re
        recni mul01i syl6eq opreq12d cc0 0cn subidi syl6eq cB c2 cexp co c4 cA
        cC cmul co cmul co cmin co cc0 cB c2 cexp co c4 cA cC cmul co cmul co
        cB discrlem.2 resqcli c4 cA cC cmul co 4re cA cC discrlem.1 discrlem.3
        remulcli remulcli resubcli 0re eqlei syl $.
        $( [9-Aug-1999] $)

    $}

    ${
      $d x A $.  $d x B $.  $d x C $.
      discrlem.4 $e |- A. x e. RR 0 <_
                     ( ( ( A x. ( x ^ 2 ) ) + ( B x. x ) ) + C ) $.
      $( If a quadratic polynomial with real coefficients is nonnegative for
         all values, then its discriminant is non-positive.  The antecedent
         ` 0 <_ A ` is redundant but simplifies the proof. $)
      discrlem $p |- ( 0 <_ A ->
                      ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) <_ 0 ) $=
        cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cB c2 cexp co c4 cA cC
        cmul co cmul co cmin co cc0 cle wbr cc0 cA 0re discrlem.1 leloei cc0 cA
        clt wbr cB c2 cexp co c4 cA cC cmul co cmul co cmin co cc0 cle wbr cc0
        cA wceq cA cB cC cB c2 cA cmul co cdiv co cneg discrlem.1 discrlem.2
        discrlem.3 cB c2 cA cmul co cdiv co cneg eqid cc0 cA vx cv c2 cexp co
        cmul co cB vx cv cmul co caddc co cC caddc co cle wbr cc0 cA cB c2 cA
        cmul co cdiv co cneg c2 cexp co cmul co cB cB c2 cA cmul co cdiv co
        cneg cmul co caddc co cC caddc co cle wbr vx cB c2 cA cmul co cdiv co
        cneg cr vx cv cB c2 cA cmul co cdiv co cneg wceq cA vx cv c2 cexp co
        cmul co cB vx cv cmul co caddc co cC caddc co cA cB c2 cA cmul co cdiv
        co cneg c2 cexp co cmul co cB cB c2 cA cmul co cdiv co cneg cmul co
        caddc co cC caddc co cc0 cle vx cv cB c2 cA cmul co cdiv co cneg wceq
        cA vx cv c2 cexp co cmul co cB vx cv cmul co caddc co cA cB c2 cA cmul
        co cdiv co cneg c2 cexp co cmul co cB cB c2 cA cmul co cdiv co cneg
        cmul co caddc co cC caddc vx cv cB c2 cA cmul co cdiv co cneg wceq cA
        vx cv c2 cexp co cmul co cA cB c2 cA cmul co cdiv co cneg c2 cexp co
        cmul co cB vx cv cmul co cB cB c2 cA cmul co cdiv co cneg cmul co caddc
        vx cv cB c2 cA cmul co cdiv co cneg wceq vx cv c2 cexp co cB c2 cA cmul
        co cdiv co cneg c2 cexp co cA cmul vx cv cB c2 cA cmul co cdiv co cneg
        c2 cexp opreq1 opreq2d vx cv cB c2 cA cmul co cdiv co cneg cB cmul
        opreq2 opreq12d opreq1d breq2d discrlem.4 vtoclri discrlem2 cA cB cC cC
        c1 caddc co cB cneg cdiv co discrlem.1 discrlem.2 discrlem.3 cC c1
        caddc co cB cneg cdiv co eqid cc0 cA vx cv c2 cexp co cmul co cB vx cv
        cmul co caddc co cC caddc co cle wbr cc0 cA cC c1 caddc co cB cneg cdiv
        co c2 cexp co cmul co cB cC c1 caddc co cB cneg cdiv co cmul co caddc
        co cC caddc co cle wbr vx cC c1 caddc co cB cneg cdiv co cr vx cv cC c1
        caddc co cB cneg cdiv co wceq cA vx cv c2 cexp co cmul co cB vx cv cmul
        co caddc co cC caddc co cA cC c1 caddc co cB cneg cdiv co c2 cexp co
        cmul co cB cC c1 caddc co cB cneg cdiv co cmul co caddc co cC caddc co
        cc0 cle vx cv cC c1 caddc co cB cneg cdiv co wceq cA vx cv c2 cexp co
        cmul co cB vx cv cmul co caddc co cA cC c1 caddc co cB cneg cdiv co c2
        cexp co cmul co cB cC c1 caddc co cB cneg cdiv co cmul co caddc co cC
        caddc vx cv cC c1 caddc co cB cneg cdiv co wceq cA vx cv c2 cexp co
        cmul co cA cC c1 caddc co cB cneg cdiv co c2 cexp co cmul co cB vx cv
        cmul co cB cC c1 caddc co cB cneg cdiv co cmul co caddc vx cv cC c1
        caddc co cB cneg cdiv co wceq vx cv c2 cexp co cC c1 caddc co cB cneg
        cdiv co c2 cexp co cA cmul vx cv cC c1 caddc co cB cneg cdiv co c2 cexp
        opreq1 opreq2d vx cv cC c1 caddc co cB cneg cdiv co cB cmul opreq2
        opreq12d opreq1d breq2d discrlem.4 vtoclri discrlem3 jaoi sylbi $.
        $( [10-Aug-1999] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        More natural number properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    nnsqcl.1 $e |- N e. NN $.
    $( The square of a natural number is a natural number. $)
    nnsqcli $p |- ( N ^ 2 ) e. NN $=
      cN cn wcel c2 cn0 wcel cN c2 cexp co cn wcel nnsqcl.1 2nn0 cN c2 nnexpcl
      mp2an $.
      $( [20-Aug-2001] $)

    $( A natural number is less than or equal to its square. $)
    nnlesqi $p |- N <_ ( N ^ 2 ) $=
      cN c1 cmul co cN cN c2 cexp co cle cN cN nnsqcl.1 nncni mulid1i cN c1
      cmul co cN cN cmul co cN c2 cexp co cle c1 cN cle wbr cN c1 cmul co cN cN
      cmul co cle wbr cN cn wcel c1 cN cle wbr nnsqcl.1 cN nnge1 ax-mp cc0 cN
      clt wbr c1 cN cle wbr cN c1 cmul co cN cN cmul co cle wbr wb cN nnsqcl.1
      nngt0i c1 cN cN 1re cN nnsqcl.1 nnrei cN nnsqcl.1 nnrei lemul2i ax-mp
      mpbi cN cN nnsqcl.1 nncni sqvali breqtrri eqbrtrri $.
      $( [15-Sep-1999] $)

    $( A natural number is even iff its square is even. $)
    nnesqi $p |- ( ( N / 2 ) e. NN <-> ( ( N ^ 2 ) / 2 ) e. NN ) $=
      cN c2 cdiv co cn wcel cN c2 cexp co c2 cdiv co cn wcel cN c2 cdiv co cn
      wcel cN c2 cdiv co cN c2 cdiv co cmul co cn wcel cN c2 cexp co c2 cdiv co
      cn wcel cN c2 cdiv co cn wcel cN c2 cdiv co cN c2 cdiv co cmul co cn wcel
      cN c2 cdiv co cN c2 cdiv co nnmulcl anidms cN c2 cdiv co cN c2 cdiv co
      cmul co cn wcel c2 cN c2 cdiv co cN c2 cdiv co cmul co cmul co cn cN c2
      cexp co c2 cdiv co c2 cn wcel cN c2 cdiv co cN c2 cdiv co cmul co cn wcel
      c2 cN c2 cdiv co cN c2 cdiv co cmul co cmul co cn wcel 2nn c2 cN c2 cdiv
      co cN c2 cdiv co cmul co nnmulcl mpan c2 cN c2 cdiv co cmul co cN c2 cdiv
      co cmul co c2 cN c2 cdiv co cN c2 cdiv co cmul co cmul co cN c2 cexp co
      c2 cdiv co c2 cN c2 cdiv co cN c2 cdiv co 2cn cN c2 cN nnsqcl.1 nncni 2cn
      2ne0 divcli cN c2 cN nnsqcl.1 nncni 2cn 2ne0 divcli mulassi cN cN cmul co
      c2 cdiv co cN cN c2 cdiv co cmul co cN c2 cexp co c2 cdiv co c2 cN c2
      cdiv co cmul co cN c2 cdiv co cmul co cN cN c2 cN nnsqcl.1 nncni cN
      nnsqcl.1 nncni 2cn 2ne0 divassi cN c2 cexp co cN cN cmul co c2 cdiv cN cN
      nnsqcl.1 nncni sqvali opreq1i c2 cN c2 cdiv co cmul co cN cN c2 cdiv co
      cmul cN c2 cN nnsqcl.1 nncni 2cn 2ne0 divcan2i opreq1i 3eqtr4ri eqtr3i
      syl5eqelr syl cN c2 cexp co c1 caddc co c2 cdiv co cn wcel wn cN c1 caddc
      co c2 cdiv co cn wcel wn cN c2 cexp co c2 cdiv co cn wcel cN c2 cdiv co
      cn wcel cN c1 caddc co c2 cdiv co cn wcel cN c2 cexp co c1 caddc co c2
      cdiv co cn wcel cN c1 caddc co c2 cdiv co cn wcel cN c1 caddc co c2 cdiv
      co cN c1 caddc co c2 cdiv co cmul co cn wcel c2 cN c1 caddc co c2 cdiv co
      cN c1 caddc co c2 cdiv co cmul co cmul co cn wcel cN c2 cexp co c1 caddc
      co c2 cdiv co cn wcel cN c1 caddc co c2 cdiv co cn wcel cN c1 caddc co c2
      cdiv co cN c1 caddc co c2 cdiv co cmul co cn wcel cN c1 caddc co c2 cdiv
      co cN c1 caddc co c2 cdiv co nnmulcl anidms c2 cn wcel cN c1 caddc co c2
      cdiv co cN c1 caddc co c2 cdiv co cmul co cn wcel c2 cN c1 caddc co c2
      cdiv co cN c1 caddc co c2 cdiv co cmul co cmul co cn wcel 2nn c2 cN c1
      caddc co c2 cdiv co cN c1 caddc co c2 cdiv co cmul co nnmulcl mpan c2 cN
      c1 caddc co c2 cdiv co cN c1 caddc co c2 cdiv co cmul co cmul co cn wcel
      cN c2 cexp co c1 caddc co c2 cdiv co cN caddc co cn wcel cN c2 cexp co c1
      caddc co c2 cdiv co cn wcel c2 cN c1 caddc co c2 cdiv co cN c1 caddc co
      c2 cdiv co cmul co cmul co cN c2 cexp co c1 caddc co c2 cdiv co cN caddc
      co cn c2 cN c1 caddc co c2 cdiv co cmul co cN c1 caddc co c2 cdiv co cmul
      co cN c1 caddc co cN c1 caddc co c2 cdiv co cmul co c2 cN c1 caddc co c2
      cdiv co cN c1 caddc co c2 cdiv co cmul co cmul co cN c2 cexp co c1 caddc
      co c2 cdiv co cN caddc co c2 cN c1 caddc co c2 cdiv co cmul co cN c1
      caddc co cN c1 caddc co c2 cdiv co cmul cN c1 caddc co c2 cN c1 cN
      nnsqcl.1 nncni ax1cn addcli 2cn 2ne0 divcan2i opreq1i c2 cN c1 caddc co
      c2 cdiv co cN c1 caddc co c2 cdiv co 2cn cN c1 caddc co c2 cN c1 cN
      nnsqcl.1 nncni ax1cn addcli 2cn 2ne0 divcli cN c1 caddc co c2 cN c1 cN
      nnsqcl.1 nncni ax1cn addcli 2cn 2ne0 divcli mulassi cN c1 caddc co cN c1
      caddc co cmul co c2 cdiv co cN c1 caddc co cN c1 caddc co c2 cdiv co cmul
      co cN c2 cexp co c1 caddc co c2 cdiv co cN caddc co cN c1 caddc co cN c1
      caddc co c2 cN c1 cN nnsqcl.1 nncni ax1cn addcli cN c1 cN nnsqcl.1 nncni
      ax1cn addcli 2cn 2ne0 divassi cN c1 caddc co cN c1 caddc co cmul co c2
      cdiv co cN c2 cexp co c1 caddc co c2 cN cmul co caddc co c2 cdiv co cN c2
      cexp co c1 caddc co c2 cdiv co c2 cN cmul co c2 cdiv co caddc co cN c2
      cexp co c1 caddc co c2 cdiv co cN caddc co cN c1 caddc co cN c1 caddc co
      cmul co cN c2 cexp co c1 caddc co c2 cN cmul co caddc co c2 cdiv cN c1
      caddc co c2 cexp co cN c1 caddc co cN c1 caddc co cmul co cN c2 cexp co
      c1 caddc co c2 cN cmul co caddc co cN c1 caddc co cN c1 cN nnsqcl.1 nncni
      ax1cn addcli sqvali cN c1 caddc co c2 cexp co cN c2 cexp co c2 cN c1 cmul
      co cmul co caddc co c1 c2 cexp co caddc co cN c2 cexp co c2 cN cmul co
      caddc co c1 caddc co cN c2 cexp co c1 caddc co c2 cN cmul co caddc co cN
      c1 cN nnsqcl.1 nncni ax1cn binom2i cN c2 cexp co c2 cN c1 cmul co cmul co
      caddc co cN c2 cexp co c2 cN cmul co caddc co c1 c2 cexp co c1 caddc c2
      cN c1 cmul co cmul co c2 cN cmul co cN c2 cexp co caddc cN c1 cmul co cN
      c2 cmul cN cN nnsqcl.1 nncni mulid1i opreq2i opreq2i sq1 opreq12i cN c2
      cexp co c2 cN cmul co c1 cN c2 cexp co cN nnsqcl.1 nnsqcli nncni c2 cN
      2cn cN nnsqcl.1 nncni mulcli ax1cn add23i 3eqtri eqtr3i opreq1i cN c2
      cexp co c1 caddc co c2 cN cmul co c2 cN c2 cexp co c1 caddc co cN c2 cexp
      co c1 cN c2 cexp co cN nnsqcl.1 nnsqcli nnrei 1re readdcli recni c2 cN
      2cn cN nnsqcl.1 nncni mulcli 2cn 2ne0 divdiri c2 cN cmul co c2 cdiv co cN
      cN c2 cexp co c1 caddc co c2 cdiv co caddc cN c2 cN nnsqcl.1 nncni 2cn
      2ne0 divcan3i opreq2i 3eqtri eqtr3i 3eqtr3i eleq1i cN c2 cexp co c1 caddc
      co c2 cdiv co cN caddc co cn wcel cN c2 cexp co c1 caddc co c2 cdiv co cN
      caddc co cN cmin co cn cN c2 cexp co c1 caddc co c2 cdiv co cN c2 cexp co
      c1 caddc co c2 cdiv co cN caddc co cn wcel cN cN c2 cexp co c1 caddc co
      c2 cdiv co cN caddc co clt wbr cN c2 cexp co c1 caddc co c2 cdiv co cN
      caddc co cN cmin co cn wcel cc0 cN caddc co cN cN c2 cexp co c1 caddc co
      c2 cdiv co cN caddc co clt cN cN nnsqcl.1 nncni addid2i cc0 cN c2 cexp co
      c1 caddc co c2 cdiv co clt wbr cc0 cN caddc co cN c2 cexp co c1 caddc co
      c2 cdiv co cN caddc co clt wbr cN c2 cexp co c1 caddc co c2 cN c2 cexp co
      c1 cN c2 cexp co cN nnsqcl.1 nnsqcli nnrei 1re readdcli 2re cN c2 cexp co
      c1 cN c2 cexp co cN nnsqcl.1 nnsqcli nnrei 1re cN c2 cexp co cN nnsqcl.1
      nnsqcli nngt0i lt01 addgt0ii 2pos divgt0ii cc0 cN c2 cexp co c1 caddc co
      c2 cdiv co cN 0re cN c2 cexp co c1 caddc co c2 cN c2 cexp co c1 cN c2
      cexp co cN nnsqcl.1 nnsqcli nnrei 1re readdcli 2re 2ne0 redivcli cN
      nnsqcl.1 nnrei ltadd1i mpbi eqbrtrri cN cn wcel cN c2 cexp co c1 caddc co
      c2 cdiv co cN caddc co cn wcel cN cN c2 cexp co c1 caddc co c2 cdiv co cN
      caddc co clt wbr cN c2 cexp co c1 caddc co c2 cdiv co cN caddc co cN cmin
      co cn wcel wb nnsqcl.1 cN cN c2 cexp co c1 caddc co c2 cdiv co cN caddc
      co nnsub mpan mpbii cN c2 cexp co c1 caddc co c2 cdiv co cN caddc co cN
      cmin co cN c2 cexp co c1 caddc co c2 cdiv co cN cN cmin co caddc co cN c2
      cexp co c1 caddc co c2 cdiv co cc0 caddc co cN c2 cexp co c1 caddc co c2
      cdiv co cN c2 cexp co c1 caddc co c2 cdiv co cN cN cN c2 cexp co c1 caddc
      co c2 cdiv co cN c2 cexp co c1 caddc co c2 cN c2 cexp co c1 cN c2 cexp co
      cN nnsqcl.1 nnsqcli nnrei 1re readdcli 2re 2ne0 redivcli recni cN
      nnsqcl.1 nncni cN nnsqcl.1 nncni addsubassi cN cN cmin co cc0 cN c2 cexp
      co c1 caddc co c2 cdiv co caddc cN cN nnsqcl.1 nncni subidi opreq2i cN c2
      cexp co c1 caddc co c2 cdiv co cN c2 cexp co c1 caddc co c2 cdiv co cN c2
      cexp co c1 caddc co c2 cN c2 cexp co c1 cN c2 cexp co cN nnsqcl.1 nnsqcli
      nnrei 1re readdcli 2re 2ne0 redivcli recni addid1i 3eqtri syl5eqelr sylbi
      3syl con3i cN c2 cexp co cN nnsqcl.1 nnsqcli nneoi cN nnsqcl.1 nneoi
      3imtr4i impbii $.
      $( [20-Aug-2001] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordered pair theorem for nonnegative integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    nn0le2msqi.1 $e |- A e. NN0 $.
    nn0le2msqi.2 $e |- B e. NN0 $.
    $( The square function on nonnegative integers is monotonic.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0le2msqi $p |- ( A <_ B <-> ( A x. A ) <_ ( B x. B ) ) $=
      cA cB cle wbr cA c2 cexp co cB c2 cexp co cle wbr cA cA cmul co cB cB
      cmul co cle wbr cc0 cA cle wbr cc0 cB cle wbr cA cB cle wbr cA c2 cexp co
      cB c2 cexp co cle wbr wb cA nn0le2msqi.1 nn0ge0i cB nn0le2msqi.2 nn0ge0i
      cA cB cA nn0le2msqi.1 nn0rei cB nn0le2msqi.2 nn0rei le2sqi mp2an cA c2
      cexp co cA cA cmul co cB c2 cexp co cB cB cmul co cle cA cA nn0le2msqi.1
      nn0cni sqvali cB cB nn0le2msqi.2 nn0cni sqvali breq12i bitri $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  ${
    nn0opthlem1.1 $e |- A e. NN0 $.
    nn0opthlem1.2 $e |- C e. NN0 $.
    $( A rather pretty lemma for ~ nn0opthi .  (Contributed by Raph Levien,
      10-Dec-2002.) $)
    nn0opthlem1 $p |- ( A < C <-> ( ( A x. A ) + ( 2 x. A ) ) < ( C x. C ) ) $=
      cA c1 caddc co cC cle wbr cA c1 caddc co cA c1 caddc co cmul co cC cC
      cmul co cle wbr cA cC clt wbr cA cA cmul co c2 cA cmul co caddc co cC cC
      cmul co clt wbr cA c1 caddc co cC cA c1 nn0opthlem1.1 1nn0 nn0addcli
      nn0opthlem1.2 nn0le2msqi cA cn0 wcel cC cn0 wcel cA cC clt wbr cA c1
      caddc co cC cle wbr wb nn0opthlem1.1 nn0opthlem1.2 cA cC nn0ltp1le mp2an
      cA cA cmul co c2 cA cmul co caddc co cC cC cmul co clt wbr cA cA cmul co
      c2 cA cmul co caddc co c1 caddc co cC cC cmul co cle wbr cA c1 caddc co
      cA c1 caddc co cmul co cC cC cmul co cle wbr cA cA cmul co c2 cA cmul co
      caddc co cn0 wcel cC cC cmul co cn0 wcel cA cA cmul co c2 cA cmul co
      caddc co cC cC cmul co clt wbr cA cA cmul co c2 cA cmul co caddc co c1
      caddc co cC cC cmul co cle wbr wb cA cA cmul co c2 cA cmul co cA cA
      nn0opthlem1.1 nn0opthlem1.1 nn0mulcli c2 cA 2nn0 nn0opthlem1.1 nn0mulcli
      nn0addcli cC cC nn0opthlem1.2 nn0opthlem1.2 nn0mulcli cA cA cmul co c2 cA
      cmul co caddc co cC cC cmul co nn0ltp1le mp2an cA c1 caddc co cA c1 caddc
      co cmul co cA cA cmul co c2 cA cmul co caddc co c1 caddc co cC cC cmul co
      cle cA c1 caddc co cA c1 caddc co cmul co cA cA cmul co c2 cA c1 cmul co
      cmul co caddc co c1 c1 cmul co caddc co cA cA cmul co c2 cA cmul co caddc
      co c1 caddc co cA c1 caddc co c2 cexp co cA c2 cexp co c2 cA c1 cmul co
      cmul co caddc co c1 c2 cexp co caddc co cA c1 caddc co cA c1 caddc co
      cmul co cA cA cmul co c2 cA c1 cmul co cmul co caddc co c1 c1 cmul co
      caddc co cA c1 cA nn0opthlem1.1 nn0cni ax1cn binom2i cA c1 caddc co cA c1
      cA nn0opthlem1.1 nn0cni ax1cn addcli sqvali cA c2 cexp co c2 cA c1 cmul
      co cmul co caddc co cA cA cmul co c2 cA c1 cmul co cmul co caddc co c1 c2
      cexp co c1 c1 cmul co caddc cA c2 cexp co cA cA cmul co c2 cA c1 cmul co
      cmul co caddc cA cA nn0opthlem1.1 nn0cni sqvali opreq1i c1 ax1cn sqvali
      opreq12i 3eqtr3i cA cA cmul co c2 cA c1 cmul co cmul co caddc co cA cA
      cmul co c2 cA cmul co caddc co c1 c1 cmul co c1 caddc c2 cA c1 cmul co
      cmul co c2 cA cmul co cA cA cmul co caddc cA c1 cmul co cA c2 cmul cA cA
      nn0opthlem1.1 nn0cni mulid1i opreq2i opreq2i c1 ax1cn mulid1i opreq12i
      eqtri breq1i bitr4i 3bitr4i $.
      $( [14-May-2003] $) $( [10-Dec-2002] $)
  $}

  ${
    nn0opth.1 $e |- A e. NN0 $.
    nn0opth.2 $e |- B e. NN0 $.
    nn0opth.3 $e |- C e. NN0 $.
    nn0opth.4 $e |- D e. NN0 $.
    $( Lemma for ~ nn0opthi . $)
    nn0opthlem2 $p |-  ( ( A + B ) < C
           -> ( ( C x. C ) + D ) =/= ( ( ( A + B ) x. ( A + B ) ) + B ) ) $=
      cA cB caddc co cC clt wbr cA cB caddc co cA cB caddc co cmul co cB caddc
      co cC cC cmul co clt wbr cA cB caddc co cA cB caddc co cmul co cB caddc
      co cC cC cmul co cD caddc co clt wbr cC cC cmul co cD caddc co cA cB
      caddc co cA cB caddc co cmul co cB caddc co wne cA cB caddc co cC clt wbr
      cA cB caddc co cA cB caddc co cmul co c2 cA cB caddc co cmul co caddc co
      cC cC cmul co clt wbr cA cB caddc co cA cB caddc co cmul co cB caddc co
      cC cC cmul co clt wbr cA cB caddc co cC cA cB nn0opth.1 nn0opth.2
      nn0addcli nn0opth.3 nn0opthlem1 cA cB caddc co cA cB caddc co cmul co cB
      caddc co cA cB caddc co cA cB caddc co cmul co c2 cA cB caddc co cmul co
      caddc co cle wbr cA cB caddc co cA cB caddc co cmul co c2 cA cB caddc co
      cmul co caddc co cC cC cmul co clt wbr cA cB caddc co cA cB caddc co cmul
      co cB caddc co cC cC cmul co clt wbr cB cA cB caddc co cle wbr cA cB
      caddc co cA cB caddc co cmul co cB caddc co cA cB caddc co cA cB caddc co
      cmul co c2 cA cB caddc co cmul co caddc co cle wbr cB cA cB nn0opth.2
      nn0rei nn0opth.1 nn0addge2i cB cA cB caddc co cle wbr cB c2 cA cB caddc
      co cmul co cle wbr cA cB caddc co cA cB caddc co cmul co cB caddc co cA
      cB caddc co cA cB caddc co cmul co c2 cA cB caddc co cmul co caddc co cle
      wbr cA cB caddc co cB cA cB nn0opth.1 nn0opth.2 nn0addcli nn0opth.2
      nn0lele2xi cB c2 cA cB caddc co cmul co cA cB caddc co cA cB caddc co
      cmul co cB nn0opth.2 nn0rei c2 cA cB caddc co 2re cA cB caddc co cA cB
      nn0opth.1 nn0opth.2 nn0addcli nn0rei remulcli cA cB caddc co cA cB caddc
      co cA cB caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cA cB caddc
      co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei remulcli leadd2i sylib
      ax-mp cA cB caddc co cA cB caddc co cmul co cB caddc co cA cB caddc co cA
      cB caddc co cmul co c2 cA cB caddc co cmul co caddc co cC cC cmul co cA
      cB caddc co cA cB caddc co cmul co cB cA cB caddc co cA cB caddc co cA cB
      caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cA cB caddc co cA cB
      nn0opth.1 nn0opth.2 nn0addcli nn0rei remulcli cB nn0opth.2 nn0rei
      readdcli cA cB caddc co cA cB caddc co cmul co c2 cA cB caddc co cmul co
      cA cB caddc co cA cB caddc co cA cB caddc co cA cB nn0opth.1 nn0opth.2
      nn0addcli nn0rei cA cB caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli
      nn0rei remulcli c2 cA cB caddc co 2re cA cB caddc co cA cB nn0opth.1
      nn0opth.2 nn0addcli nn0rei remulcli readdcli cC cC cC nn0opth.3 nn0rei cC
      nn0opth.3 nn0rei remulcli lelttri mpan sylbi cA cB caddc co cA cB caddc
      co cmul co cB caddc co cC cC cmul co clt wbr cC cC cmul co cC cC cmul co
      cD caddc co cle wbr cA cB caddc co cA cB caddc co cmul co cB caddc co cC
      cC cmul co cD caddc co clt wbr cC cC cmul co cD cC cC cC nn0opth.3 nn0rei
      cC nn0opth.3 nn0rei remulcli nn0opth.4 nn0addge1i cA cB caddc co cA cB
      caddc co cmul co cB caddc co cC cC cmul co cC cC cmul co cD caddc co cA
      cB caddc co cA cB caddc co cmul co cB cA cB caddc co cA cB caddc co cA cB
      caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cA cB caddc co cA cB
      nn0opth.1 nn0opth.2 nn0addcli nn0rei remulcli cB nn0opth.2 nn0rei
      readdcli cC cC cC nn0opth.3 nn0rei cC nn0opth.3 nn0rei remulcli cC cC
      cmul co cD cC cC cC nn0opth.3 nn0rei cC nn0opth.3 nn0rei remulcli cD
      nn0opth.4 nn0rei readdcli ltletri mpan2 cA cB caddc co cA cB caddc co
      cmul co cB caddc co cC cC cmul co cD caddc co cA cB caddc co cA cB caddc
      co cmul co cB cA cB caddc co cA cB caddc co cA cB caddc co cA cB
      nn0opth.1 nn0opth.2 nn0addcli nn0rei cA cB caddc co cA cB nn0opth.1
      nn0opth.2 nn0addcli nn0rei remulcli cB nn0opth.2 nn0rei readdcli cC cC
      cmul co cD cC cC cC nn0opth.3 nn0rei cC nn0opth.3 nn0rei remulcli cD
      nn0opth.4 nn0rei readdcli ltnei 3syl $.
      $( [8-Sep-2010] $) $( [14-May-2003] $)

    $( An ordered pair theorem for nonnegative integers.  Theorem 17.3 of
       [Quine] p. 124.  We can represent an ordered pair of nonnegative
       integers ` A ` and ` B ` by ` ( ( ( A + B ) x. ( A + B ) ) + B ) ` . If
       two such ordered pairs are equal, their first elements are equal and
       their second elements are equal.  Contrast this ordered pair
       representation with the standard one ~ df-op that works for any set.
       (Contributed by Raph Levien, 10-Dec-2002.  Proof shortened by Scott
       Fenton, 7-Sep-2010.) $)
    nn0opthi $p |- ( ( ( ( A + B ) x. ( A + B ) ) + B ) =
            ( ( ( C + D ) x. ( C + D ) ) + D ) <-> ( A = C /\ B = D ) ) $=
      cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD
      caddc co cmul co cD caddc co wceq cA cC wceq cB cD wceq wa cA cB caddc co
      cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co cmul co
      cD caddc co wceq cA cC wceq cB cD wceq cA cB caddc co cA cB caddc co cmul
      co cB caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co wceq cA
      cB caddc co cC cB caddc co wceq cA cC wceq cA cB caddc co cA cB caddc co
      cmul co cB caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co
      wceq cA cB caddc co cC cD caddc co cC cB caddc co cA cB caddc co cC cD
      caddc co cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co
      cC cD caddc co cmul co cD caddc co cA cB caddc co cC cD caddc co wne cA
      cB caddc co cC cD caddc co clt wbr cC cD caddc co cA cB caddc co clt wbr
      wo cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD
      caddc co cmul co cD caddc co wne cA cB caddc co cC cD caddc co cA cB
      caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cC cD caddc co cC cD
      nn0opth.3 nn0opth.4 nn0addcli nn0rei lttri2i cA cB caddc co cC cD caddc
      co clt wbr cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc
      co cC cD caddc co cmul co cD caddc co wne cC cD caddc co cA cB caddc co
      clt wbr cA cB caddc co cC cD caddc co clt wbr cC cD caddc co cC cD caddc
      co cmul co cD caddc co cA cB caddc co cA cB caddc co cmul co cB caddc co
      cA cB cC cD caddc co cD nn0opth.1 nn0opth.2 cC cD nn0opth.3 nn0opth.4
      nn0addcli nn0opth.4 nn0opthlem2 necomd cC cD cA cB caddc co cB nn0opth.3
      nn0opth.4 cA cB nn0opth.1 nn0opth.2 nn0addcli nn0opth.2 nn0opthlem2 jaoi
      sylbi necon4i cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD
      caddc co cC cD caddc co cmul co cD caddc co wceq cB cD cC caddc cA cB
      caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co
      cmul co cD caddc co wceq cA cB caddc co cA cB caddc co cmul co cB caddc
      co cA cB caddc co cA cB caddc co cmul co cD caddc co wceq cB cD wceq cA
      cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc
      co cmul co cD caddc co wceq cA cB caddc co cA cB caddc co cmul co cB
      caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co cA cB caddc co
      cA cB caddc co cmul co cD caddc co cA cB caddc co cA cB caddc co cmul co
      cB caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co wceq id cA
      cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc
      co cmul co cD caddc co wceq cA cB caddc co cA cB caddc co cmul co cC cD
      caddc co cC cD caddc co cmul co cD caddc cA cB caddc co cA cB caddc co
      cmul co cB caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co
      wceq cA cB caddc co cC cD caddc co cA cB caddc co cC cD caddc co cmul cA
      cB caddc co cC cD caddc co cA cB caddc co cA cB caddc co cmul co cB caddc
      co cC cD caddc co cC cD caddc co cmul co cD caddc co cA cB caddc co cC cD
      caddc co wne cA cB caddc co cC cD caddc co clt wbr cC cD caddc co cA cB
      caddc co clt wbr wo cA cB caddc co cA cB caddc co cmul co cB caddc co cC
      cD caddc co cC cD caddc co cmul co cD caddc co wne cA cB caddc co cC cD
      caddc co cA cB caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cC cD
      caddc co cC cD nn0opth.3 nn0opth.4 nn0addcli nn0rei lttri2i cA cB caddc
      co cC cD caddc co clt wbr cA cB caddc co cA cB caddc co cmul co cB caddc
      co cC cD caddc co cC cD caddc co cmul co cD caddc co wne cC cD caddc co
      cA cB caddc co clt wbr cA cB caddc co cC cD caddc co clt wbr cC cD caddc
      co cC cD caddc co cmul co cD caddc co cA cB caddc co cA cB caddc co cmul
      co cB caddc co cA cB cC cD caddc co cD nn0opth.1 nn0opth.2 cC cD
      nn0opth.3 nn0opth.4 nn0addcli nn0opth.4 nn0opthlem2 necomd cC cD cA cB
      caddc co cB nn0opth.3 nn0opth.4 cA cB nn0opth.1 nn0opth.2 nn0addcli
      nn0opth.2 nn0opthlem2 jaoi sylbi necon4i cA cB caddc co cC cD caddc co cA
      cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc
      co cmul co cD caddc co cA cB caddc co cC cD caddc co wne cA cB caddc co
      cC cD caddc co clt wbr cC cD caddc co cA cB caddc co clt wbr wo cA cB
      caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co
      cmul co cD caddc co wne cA cB caddc co cC cD caddc co cA cB caddc co cA
      cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cC cD caddc co cC cD nn0opth.3
      nn0opth.4 nn0addcli nn0rei lttri2i cA cB caddc co cC cD caddc co clt wbr
      cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD
      caddc co cmul co cD caddc co wne cC cD caddc co cA cB caddc co clt wbr cA
      cB caddc co cC cD caddc co clt wbr cC cD caddc co cC cD caddc co cmul co
      cD caddc co cA cB caddc co cA cB caddc co cmul co cB caddc co cA cB cC cD
      caddc co cD nn0opth.1 nn0opth.2 cC cD nn0opth.3 nn0opth.4 nn0addcli
      nn0opth.4 nn0opthlem2 necomd cC cD cA cB caddc co cB nn0opth.3 nn0opth.4
      cA cB nn0opth.1 nn0opth.2 nn0addcli nn0opth.2 nn0opthlem2 jaoi sylbi
      necon4i opreq12d opreq1d eqtr4d cA cB caddc co cA cB caddc co cmul co cB
      cD cA cB caddc co cA cB caddc co cA cB caddc co cA cB nn0opth.1 nn0opth.2
      nn0addcli nn0cni cA cB caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli
      nn0cni mulcli cB nn0opth.2 nn0cni cD nn0opth.4 nn0cni addcani sylib
      opreq2d eqtr4d cA cC cB cA nn0opth.1 nn0cni cC nn0opth.3 nn0cni cB
      nn0opth.2 nn0cni addcan2i sylib cA cB caddc co cA cB caddc co cmul co cB
      caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co wceq cA cB
      caddc co cA cB caddc co cmul co cB caddc co cA cB caddc co cA cB caddc co
      cmul co cD caddc co wceq cB cD wceq cA cB caddc co cA cB caddc co cmul co
      cB caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co wceq cA cB
      caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co
      cmul co cD caddc co cA cB caddc co cA cB caddc co cmul co cD caddc co cA
      cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc
      co cmul co cD caddc co wceq id cA cB caddc co cA cB caddc co cmul co cB
      caddc co cC cD caddc co cC cD caddc co cmul co cD caddc co wceq cA cB
      caddc co cA cB caddc co cmul co cC cD caddc co cC cD caddc co cmul co cD
      caddc cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC
      cD caddc co cmul co cD caddc co wceq cA cB caddc co cC cD caddc co cA cB
      caddc co cC cD caddc co cmul cA cB caddc co cC cD caddc co cA cB caddc co
      cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co cmul co
      cD caddc co cA cB caddc co cC cD caddc co wne cA cB caddc co cC cD caddc
      co clt wbr cC cD caddc co cA cB caddc co clt wbr wo cA cB caddc co cA cB
      caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co cmul co cD
      caddc co wne cA cB caddc co cC cD caddc co cA cB caddc co cA cB nn0opth.1
      nn0opth.2 nn0addcli nn0rei cC cD caddc co cC cD nn0opth.3 nn0opth.4
      nn0addcli nn0rei lttri2i cA cB caddc co cC cD caddc co clt wbr cA cB
      caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co cC cD caddc co
      cmul co cD caddc co wne cC cD caddc co cA cB caddc co clt wbr cA cB caddc
      co cC cD caddc co clt wbr cC cD caddc co cC cD caddc co cmul co cD caddc
      co cA cB caddc co cA cB caddc co cmul co cB caddc co cA cB cC cD caddc co
      cD nn0opth.1 nn0opth.2 cC cD nn0opth.3 nn0opth.4 nn0addcli nn0opth.4
      nn0opthlem2 necomd cC cD cA cB caddc co cB nn0opth.3 nn0opth.4 cA cB
      nn0opth.1 nn0opth.2 nn0addcli nn0opth.2 nn0opthlem2 jaoi sylbi necon4i cA
      cB caddc co cC cD caddc co cA cB caddc co cA cB caddc co cmul co cB caddc
      co cC cD caddc co cC cD caddc co cmul co cD caddc co cA cB caddc co cC cD
      caddc co wne cA cB caddc co cC cD caddc co clt wbr cC cD caddc co cA cB
      caddc co clt wbr wo cA cB caddc co cA cB caddc co cmul co cB caddc co cC
      cD caddc co cC cD caddc co cmul co cD caddc co wne cA cB caddc co cC cD
      caddc co cA cB caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0rei cC cD
      caddc co cC cD nn0opth.3 nn0opth.4 nn0addcli nn0rei lttri2i cA cB caddc
      co cC cD caddc co clt wbr cA cB caddc co cA cB caddc co cmul co cB caddc
      co cC cD caddc co cC cD caddc co cmul co cD caddc co wne cC cD caddc co
      cA cB caddc co clt wbr cA cB caddc co cC cD caddc co clt wbr cC cD caddc
      co cC cD caddc co cmul co cD caddc co cA cB caddc co cA cB caddc co cmul
      co cB caddc co cA cB cC cD caddc co cD nn0opth.1 nn0opth.2 cC cD
      nn0opth.3 nn0opth.4 nn0addcli nn0opth.4 nn0opthlem2 necomd cC cD cA cB
      caddc co cB nn0opth.3 nn0opth.4 cA cB nn0opth.1 nn0opth.2 nn0addcli
      nn0opth.2 nn0opthlem2 jaoi sylbi necon4i opreq12d opreq1d eqtr4d cA cB
      caddc co cA cB caddc co cmul co cB cD cA cB caddc co cA cB caddc co cA cB
      caddc co cA cB nn0opth.1 nn0opth.2 nn0addcli nn0cni cA cB caddc co cA cB
      nn0opth.1 nn0opth.2 nn0addcli nn0cni mulcli cB nn0opth.2 nn0cni cD
      nn0opth.4 nn0cni addcani sylib jca cA cC wceq cB cD wceq wa cA cB caddc
      co cA cB caddc co cmul co cC cD caddc co cC cD caddc co cmul co cB cD
      caddc cA cC wceq cB cD wceq wa cA cB caddc co cC cD caddc co cA cB caddc
      co cC cD caddc co cmul cA cC cB cD caddc opreq12 cA cC cB cD caddc
      opreq12 opreq12d cA cC wceq cB cD wceq pm3.27 opreq12d impbii $.
      $( [8-Sep-2010] $) $( [10-Dec-2002] $)

    $( An ordered pair theorem for nonnegative integers.  Theorem 17.3 of
       [Quine] p. 124.  See comments for ~ nn0opthi . $)
    nn0opth2i $p |- ( ( ( ( A + B ) ^ 2 ) + B ) = ( ( ( C + D ) ^ 2 ) + D ) <->
                   ( A = C /\ B = D ) ) $=
      cA cB caddc co c2 cexp co cB caddc co cC cD caddc co c2 cexp co cD caddc
      co wceq cA cB caddc co cA cB caddc co cmul co cB caddc co cC cD caddc co
      cC cD caddc co cmul co cD caddc co wceq cA cC wceq cB cD wceq wa cA cB
      caddc co c2 cexp co cB caddc co cA cB caddc co cA cB caddc co cmul co cB
      caddc co cC cD caddc co c2 cexp co cD caddc co cC cD caddc co cC cD caddc
      co cmul co cD caddc co cA cB caddc co c2 cexp co cA cB caddc co cA cB
      caddc co cmul co cB caddc cA cB caddc co cA cB cA nn0opth.1 nn0cni cB
      nn0opth.2 nn0cni addcli sqvali opreq1i cC cD caddc co c2 cexp co cC cD
      caddc co cC cD caddc co cmul co cD caddc cC cD caddc co cC cD cC
      nn0opth.3 nn0cni cD nn0opth.4 nn0cni addcli sqvali opreq1i eqeq12i cA cB
      cC cD nn0opth.1 nn0opth.2 nn0opth.3 nn0opth.4 nn0opthi bitri $.
      $( [1-Oct-2004] $) $( [22-Jul-2004] $)
  $}

  $( An ordered pair theorem for nonnegative integers.  Theorem 17.3 of
     [Quine] p. 124.  See ~ nn0opthi . $)
  nn0opth2 $p |- ( ( ( A e. NN0 /\ B e. NN0 ) /\ ( C e. NN0 /\ D e. NN0 ) ) ->
          ( ( ( ( A + B ) ^ 2 ) + B ) = ( ( ( C + D ) ^ 2 ) + D ) <->
                   ( A = C /\ B = D ) ) ) $=
    cA cn0 wcel cB cn0 wcel cC cn0 wcel cD cn0 wcel cA cB caddc co c2 cexp co
    cB caddc co cC cD caddc co c2 cexp co cD caddc co wceq cA cC wceq cB cD
    wceq wa wb cA cB cC cD cc0 cc0 cA cn0 wcel cA cc0 cif cB caddc co c2 cexp
    co cB caddc co cC cD caddc co c2 cexp co cD caddc co wceq cA cn0 wcel cA
    cc0 cif cC wceq cB cD wceq wa wb cA cn0 wcel cA cc0 cif cB cn0 wcel cB cc0
    cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cD caddc co c2
    cexp co cD caddc co wceq cA cn0 wcel cA cc0 cif cC wceq cB cn0 wcel cB cc0
    cif cD wceq wa wb cA cn0 wcel cA cc0 cif cB cn0 wcel cB cc0 cif caddc co c2
    cexp co cB cn0 wcel cB cc0 cif caddc co cC cn0 wcel cC cc0 cif cD caddc co
    c2 cexp co cD caddc co wceq cA cn0 wcel cA cc0 cif cC cn0 wcel cC cc0 cif
    wceq cB cn0 wcel cB cc0 cif cD wceq wa wb cA cn0 wcel cA cc0 cif cB cn0
    wcel cB cc0 cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cn0
    wcel cC cc0 cif cD cn0 wcel cD cc0 cif caddc co c2 cexp co cD cn0 wcel cD
    cc0 cif caddc co wceq cA cn0 wcel cA cc0 cif cC cn0 wcel cC cc0 cif wceq cB
    cn0 wcel cB cc0 cif cD cn0 wcel cD cc0 cif wceq wa wb cc0 cc0 cA cA cn0
    wcel cA cc0 cif wceq cA cB caddc co c2 cexp co cB caddc co cC cD caddc co
    c2 cexp co cD caddc co wceq cA cn0 wcel cA cc0 cif cB caddc co c2 cexp co
    cB caddc co cC cD caddc co c2 cexp co cD caddc co wceq cA cC wceq cB cD
    wceq wa cA cn0 wcel cA cc0 cif cC wceq cB cD wceq wa cA cA cn0 wcel cA cc0
    cif wceq cA cB caddc co c2 cexp co cB caddc co cA cn0 wcel cA cc0 cif cB
    caddc co c2 cexp co cB caddc co cC cD caddc co c2 cexp co cD caddc co cA cA
    cn0 wcel cA cc0 cif wceq cA cB caddc co c2 cexp co cA cn0 wcel cA cc0 cif
    cB caddc co c2 cexp co cB caddc cA cA cn0 wcel cA cc0 cif wceq cA cB caddc
    co cA cn0 wcel cA cc0 cif cB caddc co c2 cexp cA cA cn0 wcel cA cc0 cif cB
    caddc opreq1 opreq1d opreq1d eqeq1d cA cA cn0 wcel cA cc0 cif wceq cA cC
    wceq cA cn0 wcel cA cc0 cif cC wceq cB cD wceq cA cA cn0 wcel cA cc0 cif cC
    eqeq1 anbi1d bibi12d cB cB cn0 wcel cB cc0 cif wceq cA cn0 wcel cA cc0 cif
    cB caddc co c2 cexp co cB caddc co cC cD caddc co c2 cexp co cD caddc co
    wceq cA cn0 wcel cA cc0 cif cB cn0 wcel cB cc0 cif caddc co c2 cexp co cB
    cn0 wcel cB cc0 cif caddc co cC cD caddc co c2 cexp co cD caddc co wceq cA
    cn0 wcel cA cc0 cif cC wceq cB cD wceq wa cA cn0 wcel cA cc0 cif cC wceq cB
    cn0 wcel cB cc0 cif cD wceq wa cB cB cn0 wcel cB cc0 cif wceq cA cn0 wcel
    cA cc0 cif cB caddc co c2 cexp co cB caddc co cA cn0 wcel cA cc0 cif cB cn0
    wcel cB cc0 cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cD
    caddc co c2 cexp co cD caddc co cB cB cn0 wcel cB cc0 cif wceq cA cn0 wcel
    cA cc0 cif cB caddc co c2 cexp co cA cn0 wcel cA cc0 cif cB cn0 wcel cB cc0
    cif caddc co c2 cexp co cB cB cn0 wcel cB cc0 cif caddc cB cB cn0 wcel cB
    cc0 cif wceq cA cn0 wcel cA cc0 cif cB caddc co cA cn0 wcel cA cc0 cif cB
    cn0 wcel cB cc0 cif caddc co c2 cexp cB cB cn0 wcel cB cc0 cif cA cn0 wcel
    cA cc0 cif caddc opreq2 opreq1d cB cB cn0 wcel cB cc0 cif wceq id opreq12d
    eqeq1d cB cB cn0 wcel cB cc0 cif wceq cB cD wceq cB cn0 wcel cB cc0 cif cD
    wceq cA cn0 wcel cA cc0 cif cC wceq cB cB cn0 wcel cB cc0 cif cD eqeq1
    anbi2d bibi12d cC cC cn0 wcel cC cc0 cif wceq cA cn0 wcel cA cc0 cif cB cn0
    wcel cB cc0 cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cD
    caddc co c2 cexp co cD caddc co wceq cA cn0 wcel cA cc0 cif cB cn0 wcel cB
    cc0 cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cn0 wcel cC
    cc0 cif cD caddc co c2 cexp co cD caddc co wceq cA cn0 wcel cA cc0 cif cC
    wceq cB cn0 wcel cB cc0 cif cD wceq wa cA cn0 wcel cA cc0 cif cC cn0 wcel
    cC cc0 cif wceq cB cn0 wcel cB cc0 cif cD wceq wa cC cC cn0 wcel cC cc0 cif
    wceq cC cD caddc co c2 cexp co cD caddc co cC cn0 wcel cC cc0 cif cD caddc
    co c2 cexp co cD caddc co cA cn0 wcel cA cc0 cif cB cn0 wcel cB cc0 cif
    caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cC cn0 wcel cC cc0
    cif wceq cC cD caddc co c2 cexp co cC cn0 wcel cC cc0 cif cD caddc co c2
    cexp co cD caddc cC cC cn0 wcel cC cc0 cif wceq cC cD caddc co cC cn0 wcel
    cC cc0 cif cD caddc co c2 cexp cC cC cn0 wcel cC cc0 cif cD caddc opreq1
    opreq1d opreq1d eqeq2d cC cC cn0 wcel cC cc0 cif wceq cA cn0 wcel cA cc0
    cif cC wceq cA cn0 wcel cA cc0 cif cC cn0 wcel cC cc0 cif wceq cB cn0 wcel
    cB cc0 cif cD wceq cC cC cn0 wcel cC cc0 cif cA cn0 wcel cA cc0 cif eqeq2
    anbi1d bibi12d cD cD cn0 wcel cD cc0 cif wceq cA cn0 wcel cA cc0 cif cB cn0
    wcel cB cc0 cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cC cn0
    wcel cC cc0 cif cD caddc co c2 cexp co cD caddc co wceq cA cn0 wcel cA cc0
    cif cB cn0 wcel cB cc0 cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc
    co cC cn0 wcel cC cc0 cif cD cn0 wcel cD cc0 cif caddc co c2 cexp co cD cn0
    wcel cD cc0 cif caddc co wceq cA cn0 wcel cA cc0 cif cC cn0 wcel cC cc0 cif
    wceq cB cn0 wcel cB cc0 cif cD wceq wa cA cn0 wcel cA cc0 cif cC cn0 wcel
    cC cc0 cif wceq cB cn0 wcel cB cc0 cif cD cn0 wcel cD cc0 cif wceq wa cD cD
    cn0 wcel cD cc0 cif wceq cC cn0 wcel cC cc0 cif cD caddc co c2 cexp co cD
    caddc co cC cn0 wcel cC cc0 cif cD cn0 wcel cD cc0 cif caddc co c2 cexp co
    cD cn0 wcel cD cc0 cif caddc co cA cn0 wcel cA cc0 cif cB cn0 wcel cB cc0
    cif caddc co c2 cexp co cB cn0 wcel cB cc0 cif caddc co cD cD cn0 wcel cD
    cc0 cif wceq cC cn0 wcel cC cc0 cif cD caddc co c2 cexp co cC cn0 wcel cC
    cc0 cif cD cn0 wcel cD cc0 cif caddc co c2 cexp co cD cD cn0 wcel cD cc0
    cif caddc cD cD cn0 wcel cD cc0 cif wceq cC cn0 wcel cC cc0 cif cD caddc co
    cC cn0 wcel cC cc0 cif cD cn0 wcel cD cc0 cif caddc co c2 cexp cD cD cn0
    wcel cD cc0 cif cC cn0 wcel cC cc0 cif caddc opreq2 opreq1d cD cD cn0 wcel
    cD cc0 cif wceq id opreq12d eqeq2d cD cD cn0 wcel cD cc0 cif wceq cB cn0
    wcel cB cc0 cif cD wceq cB cn0 wcel cB cc0 cif cD cn0 wcel cD cc0 cif wceq
    cA cn0 wcel cA cc0 cif cC cn0 wcel cC cc0 cif wceq cD cD cn0 wcel cD cc0
    cif cB cn0 wcel cB cc0 cif eqeq2 anbi2d bibi12d cA cn0 wcel cA cc0 cif cB
    cn0 wcel cB cc0 cif cC cn0 wcel cC cc0 cif cD cn0 wcel cD cc0 cif cA cc0
    cn0 0nn0 elimel cB cc0 cn0 0nn0 elimel cC cc0 cn0 0nn0 elimel cD cc0 cn0
    0nn0 elimel nn0opth2i dedth4h $.
    $( [2-Oct-2004] $) $( [22-Jul-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Square root
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c sqr $. $( Positive square root of a positive real number. $)

  $( Extend class notation to include positive square root of a positive real
     number. $)
  csqr $a class sqr $.

  ${
    $d x y z w A $.
    $( Define a function whose value is the square root of a nonnegative
       real number.  The square root of ` x ` is the supremum of all reals
       whose square is less than ` x ` .  See ~ sqrcli for its closure,
       ~ sqrval for its value, ~ sqrsqi and ~ sqsqri for its relationship to
       squares, and ~ sqr11i for uniqueness. $)
    df-sqr $a |- sqr = { <. x , y >. | ( ( x e. RR /\ 0 <_ x ) /\
     y = sup ( { z e. RR | ( 0 <_ z /\ ( z x. z ) <_ x ) } , RR , < ) ) } $.

    $( Value of square root function. $)
    sqrval $p |- ( ( A e. RR /\ 0 <_ A ) -> ( sqr ` A ) =
          sup ( { x e. RR | ( 0 <_ x /\ ( x x. x ) <_ A ) } , RR , < ) ) $=
      cA cr wcel cc0 cA cle wbr wa cA cc0 vw cv cle wbr vw cr crab wcel cA csqr
      cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab cr clt
      csup wceq cc0 vw cv cle wbr cc0 cA cle wbr vw cA cr vw cv cA cc0 cle
      breq2 elrab vy vz cA cc0 vx cv cle wbr vx cv vx cv cmul co vy cv cle wbr
      wa vx cr crab cr clt csup cc0 vx cv cle wbr vx cv vx cv cmul co cA cle
      wbr wa vx cr crab cr clt csup cc0 vw cv cle wbr vw cr crab csqr vy cv cA
      wceq cc0 vx cv cle wbr vx cv vx cv cmul co vy cv cle wbr wa vx cr crab
      cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab wceq cc0
      vx cv cle wbr vx cv vx cv cmul co vy cv cle wbr wa vx cr crab cr clt csup
      cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab cr clt
      csup wceq vy cv cA wceq cc0 vx cv cle wbr vx cv vx cv cmul co vy cv cle
      wbr wa cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr vy cv cA
      wceq vx cv vx cv cmul co vy cv cle wbr vx cv vx cv cmul co cA cle wbr cc0
      vx cv cle wbr vy cv cA vx cv vx cv cmul co cle breq2 anbi2d rabbisdv cr
      cc0 vx cv cle wbr vx cv vx cv cmul co vy cv cle wbr wa vx cr crab cc0 vx
      cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab clt supeq1 syl
      csqr vy cv cr wcel cc0 vy cv cle wbr wa vz cv cc0 vx cv cle wbr vx cv vx
      cv cmul co vy cv cle wbr wa vx cr crab cr clt csup wceq wa vy vz copab vy
      cv cc0 vw cv cle wbr vw cr crab wcel vz cv cc0 vx cv cle wbr vx cv vx cv
      cmul co vy cv cle wbr wa vx cr crab cr clt csup wceq wa vy vz copab vy vz
      vx df-sqr vy cv cc0 vw cv cle wbr vw cr crab wcel vz cv cc0 vx cv cle wbr
      vx cv vx cv cmul co vy cv cle wbr wa vx cr crab cr clt csup wceq wa vy cv
      cr wcel cc0 vy cv cle wbr wa vz cv cc0 vx cv cle wbr vx cv vx cv cmul co
      vy cv cle wbr wa vx cr crab cr clt csup wceq wa vy vz vy cv cc0 vw cv cle
      wbr vw cr crab wcel vy cv cr wcel cc0 vy cv cle wbr wa vz cv cc0 vx cv
      cle wbr vx cv vx cv cmul co vy cv cle wbr wa vx cr crab cr clt csup wceq
      cc0 vw cv cle wbr cc0 vy cv cle wbr vw vy cv cr vw cv vy cv cc0 cle breq2
      elrab anbi1i opabbii eqtr4i cr cc0 vx cv cle wbr vx cv vx cv cmul co cA
      cle wbr wa vx cr crab clt ltso supex fvopab4 sylbir $.
      $( [23-May-1999] $)
  $}

  $( Square root of zero. $)
  sqr0 $p |- ( sqr ` 0 ) = 0 $=
    cc0 csqr cfv cc0 vx cv cle wbr vx cv vx cv cmul co cc0 cle wbr wa vx cr
    crab cr clt csup cc0 csn cr clt csup cc0 cc0 cr wcel cc0 cc0 cle wbr cc0
    csqr cfv cc0 vx cv cle wbr vx cv vx cv cmul co cc0 cle wbr wa vx cr crab cr
    clt csup wceq 0re cc0 0re leidi vx cc0 sqrval mp2an cc0 vx cv cle wbr vx cv
    vx cv cmul co cc0 cle wbr wa vx cr crab cc0 csn wceq cc0 vx cv cle wbr vx
    cv vx cv cmul co cc0 cle wbr wa vx cr crab cr clt csup cc0 csn cr clt csup
    wceq vx cv cr wcel cc0 vx cv cle wbr vx cv vx cv cmul co cc0 cle wbr wa wa
    vx cab vx cv cc0 wceq vx cab cc0 vx cv cle wbr vx cv vx cv cmul co cc0 cle
    wbr wa vx cr crab cc0 csn vx cv cr wcel cc0 vx cv cle wbr vx cv vx cv cmul
    co cc0 cle wbr wa wa vx cv cc0 wceq vx vx cv cr wcel cc0 vx cv cle wbr vx
    cv vx cv cmul co cc0 cle wbr wa wa vx cv cc0 wceq vx cv cr wcel cc0 vx cv
    cle wbr vx cv vx cv cmul co cc0 cle wbr wa vx cv cc0 wceq vx cv cr wcel vx
    cv vx cv cmul co cc0 cle wbr vx cv cc0 wceq cc0 vx cv cle wbr vx cv cr wcel
    vx cv vx cv cmul co cc0 cle wbr cc0 vx cv vx cv cmul co clt wbr wn vx cv
    cc0 wceq vx cv vx cv cmul co cr wcel cc0 cr wcel vx cv vx cv cmul co cc0
    cle wbr cc0 vx cv vx cv cmul co clt wbr wn wb vx cv cr wcel vx cv vx cv
    cmul co cc0 lenlt vx cv cr wcel vx cv vx cv cmul co cr wcel vx cv vx cv
    remulcl anidms 0re sylancl vx cv cr wcel cc0 vx cv vx cv cmul co clt wbr vx
    cv cc0 vx cv cr wcel vx cv cc0 wne cc0 vx cv vx cv cmul co clt wbr vx cv
    msqgt0 ex necon1bd sylbid adantld imp vx cv cc0 wceq vx cv cr wcel cc0 vx
    cv cle wbr vx cv vx cv cmul co cc0 cle wbr wa wa cc0 cr wcel cc0 cc0 cle
    wbr cc0 cc0 cmul co cc0 cle wbr wa wa cc0 cr wcel cc0 cc0 cle wbr cc0 cc0
    cmul co cc0 cle wbr wa 0re cc0 cc0 cle wbr cc0 cc0 cmul co cc0 cle wbr cc0
    0re leidi cc0 cc0 cmul co cc0 wceq cc0 cc0 cmul co cc0 cle wbr cc0 0cn
    mul01i cc0 cc0 cmul co cc0 cc0 cc0 0re 0re remulcli 0re eqlei ax-mp pm3.2i
    pm3.2i vx cv cc0 wceq vx cv cr wcel cc0 cr wcel cc0 vx cv cle wbr vx cv vx
    cv cmul co cc0 cle wbr wa cc0 cc0 cle wbr cc0 cc0 cmul co cc0 cle wbr wa vx
    cv cc0 cr eleq1 vx cv cc0 wceq cc0 vx cv cle wbr cc0 cc0 cle wbr vx cv vx
    cv cmul co cc0 cle wbr cc0 cc0 cmul co cc0 cle wbr vx cv cc0 cc0 cle breq2
    vx cv cc0 wceq vx cv vx cv cmul co cc0 cc0 cmul co cc0 cle vx cv cc0 wceq
    vx cv vx cv cmul co cc0 cc0 cmul co wceq vx cv cc0 vx cv cc0 cmul opreq12
    anidms breq1d anbi12d anbi12d mpbiri impbii abbii cc0 vx cv cle wbr vx cv
    vx cv cmul co cc0 cle wbr wa vx cr df-rab vx cc0 df-sn 3eqtr4i cr cc0 vx cv
    cle wbr vx cv vx cv cmul co cc0 cle wbr wa vx cr crab cc0 csn clt supeq1
    ax-mp cc0 cr wcel cc0 csn cr clt csup cc0 wceq 0re cr cc0 clt ltso supsn
    ax-mp 3eqtri $.
    $( [23-May-1999] $)

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w S $.  $d x y z C $.  $d x D $.
    sqrlem1.1 $e |- A e. RR $.
    sqrlem1.2 $e |- 0 < A $.
    $( Lemma for square root theorem. $)
    sqrlem1 $p |- A < ( ( 1 + A ) x. ( 1 + A ) ) $=
      cA c1 cA caddc co clt wbr c1 cA caddc co c1 cA caddc co c1 cA caddc co
      cmul co clt wbr cA c1 cA caddc co c1 cA caddc co cmul co clt wbr cc0 cA
      caddc co cA c1 cA caddc co clt cA cA sqrlem1.1 recni addid2i cc0 c1 clt
      wbr cc0 cA caddc co c1 cA caddc co clt wbr lt01 cc0 c1 cA 0re 1re
      sqrlem1.1 ltadd1i mpbi eqbrtrri c1 c1 cA caddc co cmul co c1 cA caddc co
      c1 cA caddc co c1 cA caddc co cmul co clt c1 cA caddc co c1 cA caddc co
      c1 cA 1re sqrlem1.1 readdcli recni mulid2i c1 c1 cA caddc co clt wbr c1
      c1 cA caddc co cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr c1
      cc0 caddc co c1 c1 cA caddc co clt c1 ax1cn addid1i cc0 cA clt wbr c1 cc0
      caddc co c1 cA caddc co clt wbr sqrlem1.2 cc0 cA c1 0re sqrlem1.1 1re
      ltadd2i mpbi eqbrtrri c1 c1 cA caddc co c1 cA caddc co 1re c1 cA 1re
      sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01
      sqrlem1.2 addgt0ii ltmul1ii mpbi eqbrtrri cA c1 cA caddc co c1 cA caddc
      co c1 cA caddc co cmul co sqrlem1.1 c1 cA 1re sqrlem1.1 readdcli c1 cA
      caddc co c1 cA caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1
      readdcli remulcli lttri mp2an $.
      $( [16-May-1999] $)

    $( Lemma for square root theorem. $)
    sqrlem2 $p |- ( ( A / ( 1 + A ) ) x. ( A / ( 1 + A ) ) ) < A $=
      cA cA cmul co c1 cA caddc co c1 cA caddc co cmul co cdiv co cA c1 cA
      caddc co c1 cA caddc co cmul co cmul co c1 cA caddc co c1 cA caddc co
      cmul co cdiv co cA c1 cA caddc co cdiv co cA c1 cA caddc co cdiv co cmul
      co cA clt cA cA cmul co cA c1 cA caddc co c1 cA caddc co cmul co cmul co
      clt wbr cA cA cmul co c1 cA caddc co c1 cA caddc co cmul co cdiv co cA c1
      cA caddc co c1 cA caddc co cmul co cmul co c1 cA caddc co c1 cA caddc co
      cmul co cdiv co clt wbr cA c1 cA caddc co c1 cA caddc co cmul co clt wbr
      cA cA cmul co cA c1 cA caddc co c1 cA caddc co cmul co cmul co clt wbr cA
      sqrlem1.1 sqrlem1.2 sqrlem1 cc0 cA clt wbr cA c1 cA caddc co c1 cA caddc
      co cmul co clt wbr cA cA cmul co cA c1 cA caddc co c1 cA caddc co cmul co
      cmul co clt wbr wb sqrlem1.2 cA c1 cA caddc co c1 cA caddc co cmul co cA
      sqrlem1.1 c1 cA caddc co c1 cA caddc co c1 cA 1re sqrlem1.1 readdcli c1
      cA 1re sqrlem1.1 readdcli remulcli sqrlem1.1 ltmul2i ax-mp mpbi cA cA
      cmul co cA c1 cA caddc co c1 cA caddc co cmul co cmul co c1 cA caddc co
      c1 cA caddc co cmul co cA cA sqrlem1.1 sqrlem1.1 remulcli cA c1 cA caddc
      co c1 cA caddc co cmul co sqrlem1.1 c1 cA caddc co c1 cA caddc co c1 cA
      1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli remulcli remulcli c1
      cA caddc co c1 cA caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re
      sqrlem1.1 readdcli remulcli cc0 cA clt wbr cA c1 cA caddc co c1 cA caddc
      co cmul co clt wbr cc0 c1 cA caddc co c1 cA caddc co cmul co clt wbr
      sqrlem1.2 cA sqrlem1.1 sqrlem1.2 sqrlem1 cc0 cA c1 cA caddc co c1 cA
      caddc co cmul co 0re sqrlem1.1 c1 cA caddc co c1 cA caddc co c1 cA 1re
      sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli remulcli lttri mp2an
      ltdiv1ii mpbi cA c1 cA caddc co cA c1 cA caddc co cA sqrlem1.1 recni c1
      cA caddc co c1 cA 1re sqrlem1.1 readdcli recni cA sqrlem1.1 recni c1 cA
      caddc co c1 cA 1re sqrlem1.1 readdcli recni c1 cA caddc co c1 cA 1re
      sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01 sqrlem1.2 addgt0ii gt0ne0ii
      c1 cA caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01
      sqrlem1.2 addgt0ii gt0ne0ii divmuldivi cA c1 cA caddc co c1 cA caddc co
      cmul co cmul co c1 cA caddc co c1 cA caddc co cmul co cdiv co cA c1 cA
      caddc co c1 cA caddc co cmul co c1 cA caddc co c1 cA caddc co cmul co
      cdiv co cmul co cA c1 cmul co cA cA c1 cA caddc co c1 cA caddc co cmul co
      c1 cA caddc co c1 cA caddc co cmul co cA sqrlem1.1 recni c1 cA caddc co
      c1 cA caddc co cmul co c1 cA caddc co c1 cA caddc co c1 cA 1re sqrlem1.1
      readdcli c1 cA 1re sqrlem1.1 readdcli remulcli recni c1 cA caddc co c1 cA
      caddc co cmul co c1 cA caddc co c1 cA caddc co c1 cA 1re sqrlem1.1
      readdcli c1 cA 1re sqrlem1.1 readdcli remulcli recni c1 cA caddc co c1 cA
      caddc co cmul co c1 cA caddc co c1 cA caddc co c1 cA 1re sqrlem1.1
      readdcli c1 cA 1re sqrlem1.1 readdcli remulcli cc0 cA clt wbr cA c1 cA
      caddc co c1 cA caddc co cmul co clt wbr cc0 c1 cA caddc co c1 cA caddc co
      cmul co clt wbr sqrlem1.2 cA sqrlem1.1 sqrlem1.2 sqrlem1 cc0 cA c1 cA
      caddc co c1 cA caddc co cmul co 0re sqrlem1.1 c1 cA caddc co c1 cA caddc
      co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli remulcli
      lttri mp2an gt0ne0ii divassi c1 cA caddc co c1 cA caddc co cmul co c1 cA
      caddc co c1 cA caddc co cmul co cdiv co c1 cA cmul c1 cA caddc co c1 cA
      caddc co cmul co c1 cA caddc co c1 cA caddc co cmul co c1 cA caddc co c1
      cA caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli
      remulcli recni c1 cA caddc co c1 cA caddc co cmul co c1 cA caddc co c1 cA
      caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli
      remulcli cc0 cA clt wbr cA c1 cA caddc co c1 cA caddc co cmul co clt wbr
      cc0 c1 cA caddc co c1 cA caddc co cmul co clt wbr sqrlem1.2 cA sqrlem1.1
      sqrlem1.2 sqrlem1 cc0 cA c1 cA caddc co c1 cA caddc co cmul co 0re
      sqrlem1.1 c1 cA caddc co c1 cA caddc co c1 cA 1re sqrlem1.1 readdcli c1
      cA 1re sqrlem1.1 readdcli remulcli lttri mp2an gt0ne0ii dividi opreq2i cA
      cA sqrlem1.1 recni mulid1i 3eqtrri 3brtr4i $.
      $( [16-May-1999] $)

    $( Lemma for square root theorem. $)
    sqrlem3 $p |- 0 < ( A / ( 1 + A ) ) $=
      cA c1 cA caddc co sqrlem1.1 c1 cA 1re sqrlem1.1 readdcli sqrlem1.2 c1 cA
      1re sqrlem1.1 lt01 sqrlem1.2 addgt0ii divgt0ii $.
      $( [16-May-1999] $)

    ${
      sqrlem4.3 $e |- S = { x e. RR | ( 0 <_ x /\ ( x x. x ) <_ A ) } $.
      $( Lemma for square root theorem. $)
      sqrlem4 $p |- ( D e. S <->
                    ( D e. RR /\ ( 0 <_ D /\ ( D x. D ) <_ A ) ) ) $=
        cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa cc0 cD cle wbr cD
        cD cmul co cA cle wbr wa vx cD cr cS vx cv cD wceq cc0 vx cv cle wbr
        cc0 cD cle wbr vx cv vx cv cmul co cA cle wbr cD cD cmul co cA cle wbr
        vx cv cD cc0 cle breq2 vx cv cD wceq vx cv vx cv cmul co cD cD cmul co
        cA cle vx cv cD wceq vx cv vx cv cmul co cD cD cmul co wceq vx cv cD vx
        cv cD cmul opreq12 anidms breq1d anbi12d sqrlem4.3 elrab2 $.
        $( [21-May-1999] $)

      $( Lemma for square root theorem. $)
      sqrlem5 $p |- ( ( D e. RR /\ ( 0 < D /\ ( D x. D ) < A ) ) ->
                        D e. S ) $=
        cD cr wcel cc0 cD clt wbr cD cD cmul co cA clt wbr wa wa cD cr wcel cc0
        cD cle wbr cD cD cmul co cA cle wbr wa wa cD cS wcel cD cr wcel cc0 cD
        clt wbr cD cD cmul co cA clt wbr wa cc0 cD cle wbr cD cD cmul co cA cle
        wbr wa cD cr wcel cc0 cD clt wbr cc0 cD cle wbr cD cD cmul co cA clt
        wbr cD cD cmul co cA cle wbr cc0 cr wcel cD cr wcel cc0 cD clt wbr cc0
        cD cle wbr wi 0re cc0 cD ltle mpan cD cD cmul co cr wcel cA cr wcel cD
        cD cmul co cA clt wbr cD cD cmul co cA cle wbr wi cD cr wcel cD cD cmul
        co cA ltle cD cr wcel cD cD cmul co cr wcel cD cD remulcl anidms
        sqrlem1.1 sylancl anim12d imdistani vx cA cD cS sqrlem1.1 sqrlem1.2
        sqrlem4.3 sqrlem4 sylibr $.
        $( [23-May-1999] $)

      $( Lemma for square root theorem. $)
      sqrlem6 $p |- ( S C_ RR /\ S =/= (/) /\
                     E. x e. RR A. y e. S y < x ) $=
        cS cr wss cS c0 wne vy cv vx cv clt wbr vy cS wral vx cr wrex cS cc0 vx
        cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab cr sqrlem4.3
        cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr ssrab2
        eqsstri cS c0 wne cS c0 wceq wn cc0 cS wcel cS c0 wceq wn cc0 cS wcel
        cc0 cr wcel cc0 cc0 cle wbr cc0 cc0 cmul co cA cle wbr wa vx cA cc0 cS
        sqrlem1.1 sqrlem1.2 sqrlem4.3 sqrlem4 0re cc0 cc0 cle wbr cc0 cc0 cmul
        co cA cle wbr cc0 0re leidi cc0 cc0 cmul co cc0 cA cle cc0 0cn mul01i
        cc0 cA 0re sqrlem1.1 sqrlem1.2 ltleii eqbrtri pm3.2i mpbir2an cS cc0
        n0i ax-mp cS c0 df-ne mpbir c1 cA caddc co cr wcel vy cv c1 cA caddc co
        clt wbr vy cS wral vy cv vx cv clt wbr vy cS wral vx cr wrex c1 cA 1re
        sqrlem1.1 readdcli vy cv c1 cA caddc co clt wbr vy cS vy cv cS wcel vy
        cv cr wcel cc0 vy cv cle wbr vy cv vy cv cmul co cA cle wbr wa wa vy cv
        c1 cA caddc co clt wbr vx cA vy cv cS sqrlem1.1 sqrlem1.2 sqrlem4.3
        sqrlem4 vy cv cr wcel cc0 vy cv cle wbr vy cv vy cv cmul co cA cle wbr
        vy cv c1 cA caddc co clt wbr vy cv cr wcel cc0 vy cv cle wbr vy cv vy
        cv cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv c1 cA
        caddc co clt wbr vy cv vy cv cmul co cA cle wbr vy cv cr wcel cc0 vy cv
        cle wbr cc0 vy cv clt wbr cc0 vy cv wceq wo vy cv vy cv cmul co c1 cA
        caddc co c1 cA caddc co cmul co clt wbr vy cv c1 cA caddc co clt wbr wi
        cc0 cr wcel vy cv cr wcel cc0 vy cv cle wbr cc0 vy cv clt wbr cc0 vy cv
        wceq wo wb 0re cc0 vy cv leloe mpan vy cv cr wcel cc0 vy cv clt wbr vy
        cv vy cv cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv c1
        cA caddc co clt wbr wi cc0 vy cv wceq vy cv cr wcel cc0 vy cv clt wbr
        vy cv vy cv cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv
        c1 cA caddc co clt wbr wi wi cc0 vy cv cr wcel vy cv c1 cif clt wbr vy
        cv cr wcel vy cv c1 cif vy cv cr wcel vy cv c1 cif cmul co c1 cA caddc
        co c1 cA caddc co cmul co clt wbr vy cv cr wcel vy cv c1 cif c1 cA
        caddc co clt wbr wi wi vy cv c1 vy cv vy cv cr wcel vy cv c1 cif wceq
        cc0 vy cv clt wbr cc0 vy cv cr wcel vy cv c1 cif clt wbr vy cv vy cv
        cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv c1 cA caddc
        co clt wbr wi vy cv cr wcel vy cv c1 cif vy cv cr wcel vy cv c1 cif
        cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv cr wcel vy
        cv c1 cif c1 cA caddc co clt wbr wi vy cv vy cv cr wcel vy cv c1 cif
        cc0 clt breq2 vy cv vy cv cr wcel vy cv c1 cif wceq vy cv vy cv cmul co
        c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv cr wcel vy cv c1
        cif vy cv cr wcel vy cv c1 cif cmul co c1 cA caddc co c1 cA caddc co
        cmul co clt wbr vy cv c1 cA caddc co clt wbr vy cv cr wcel vy cv c1 cif
        c1 cA caddc co clt wbr vy cv vy cv cr wcel vy cv c1 cif wceq vy cv vy
        cv cmul co vy cv cr wcel vy cv c1 cif vy cv cr wcel vy cv c1 cif cmul
        co c1 cA caddc co c1 cA caddc co cmul co clt vy cv vy cv cr wcel vy cv
        c1 cif wceq vy cv vy cv cmul co vy cv cr wcel vy cv c1 cif vy cv cr
        wcel vy cv c1 cif cmul co wceq vy cv vy cv cr wcel vy cv c1 cif vy cv
        vy cv cr wcel vy cv c1 cif cmul opreq12 anidms breq1d vy cv vy cv cr
        wcel vy cv c1 cif c1 cA caddc co clt breq1 imbi12d imbi12d cc0 vy cv cr
        wcel vy cv c1 cif clt wbr vy cv cr wcel vy cv c1 cif c1 cA caddc co clt
        wbr vy cv cr wcel vy cv c1 cif vy cv cr wcel vy cv c1 cif cmul co c1 cA
        caddc co c1 cA caddc co cmul co clt wbr cc0 vy cv cr wcel vy cv c1 cif
        clt wbr cc0 c1 cA caddc co clt wbr vy cv cr wcel vy cv c1 cif c1 cA
        caddc co clt wbr vy cv cr wcel vy cv c1 cif vy cv cr wcel vy cv c1 cif
        cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr wb c1 cA 1re
        sqrlem1.1 lt01 sqrlem1.2 addgt0ii cc0 vy cv cr wcel vy cv c1 cif cle
        wbr cc0 c1 cA caddc co cle wbr vy cv cr wcel vy cv c1 cif c1 cA caddc
        co clt wbr vy cv cr wcel vy cv c1 cif vy cv cr wcel vy cv c1 cif cmul
        co c1 cA caddc co c1 cA caddc co cmul co clt wbr wb cc0 vy cv cr wcel
        vy cv c1 cif clt wbr cc0 c1 cA caddc co clt wbr vy cv cr wcel vy cv c1
        cif c1 cA caddc co vy cv c1 cr 1re elimel c1 cA 1re sqrlem1.1 readdcli
        lt2msqi cc0 vy cv cr wcel vy cv c1 cif 0re vy cv c1 cr 1re elimel ltlei
        cc0 c1 cA caddc co 0re c1 cA 1re sqrlem1.1 readdcli ltlei syl2an mpan2
        biimprd dedth cc0 vy cv wceq vy cv vy cv cmul co c1 cA caddc co c1 cA
        caddc co cmul co clt wbr vy cv c1 cA caddc co clt wbr wi wi vy cv cr
        wcel cc0 vy cv wceq vy cv c1 cA caddc co clt wbr vy cv vy cv cmul co c1
        cA caddc co c1 cA caddc co cmul co clt wbr cc0 vy cv wceq cc0 c1 cA
        caddc co clt wbr vy cv c1 cA caddc co clt wbr c1 cA 1re sqrlem1.1 lt01
        sqrlem1.2 addgt0ii cc0 vy cv c1 cA caddc co clt breq1 mpbii a1d a1i
        jaod sylbid vy cv vy cv cmul co cr wcel cA cr wcel vy cv vy cv cmul co
        cA cle wbr vy cv vy cv cmul co c1 cA caddc co c1 cA caddc co cmul co
        clt wbr wi vy cv cr wcel vy cv vy cv cmul co cr wcel cA cr wcel wa vy
        cv vy cv cmul co cA cle wbr vy cv vy cv cmul co cA clt wbr vy cv vy cv
        cmul co cA wceq wo vy cv vy cv cmul co c1 cA caddc co c1 cA caddc co
        cmul co clt wbr vy cv vy cv cmul co cA leloe vy cv vy cv cmul co cr
        wcel cA cr wcel wa vy cv vy cv cmul co cA clt wbr vy cv vy cv cmul co
        c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv vy cv cmul co cA
        wceq vy cv vy cv cmul co cr wcel cA cr wcel wa vy cv vy cv cmul co cA
        clt wbr cA c1 cA caddc co c1 cA caddc co cmul co clt wbr vy cv vy cv
        cmul co c1 cA caddc co c1 cA caddc co cmul co clt wbr cA sqrlem1.1
        sqrlem1.2 sqrlem1 vy cv vy cv cmul co cr wcel cA cr wcel c1 cA caddc co
        c1 cA caddc co cmul co cr wcel vy cv vy cv cmul co cA clt wbr cA c1 cA
        caddc co c1 cA caddc co cmul co clt wbr wa vy cv vy cv cmul co c1 cA
        caddc co c1 cA caddc co cmul co clt wbr wi c1 cA caddc co c1 cA caddc
        co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 readdcli remulcli
        vy cv vy cv cmul co cA c1 cA caddc co c1 cA caddc co cmul co axlttrn
        mp3an3 mpan2i vy cv vy cv cmul co cA wceq vy cv vy cv cmul co c1 cA
        caddc co c1 cA caddc co cmul co clt wbr wi vy cv vy cv cmul co cr wcel
        cA cr wcel wa vy cv vy cv cmul co cA wceq vy cv vy cv cmul co c1 cA
        caddc co c1 cA caddc co cmul co clt wbr cA c1 cA caddc co c1 cA caddc
        co cmul co clt wbr cA sqrlem1.1 sqrlem1.2 sqrlem1 vy cv vy cv cmul co
        cA c1 cA caddc co c1 cA caddc co cmul co clt breq1 mpbiri a1i jaod
        sylbid vy cv cr wcel vy cv vy cv cmul co cr wcel vy cv vy cv remulcl
        anidms sqrlem1.1 sylancl syl5d imp32 sylbi rgen vy cv vx cv clt wbr vy
        cS wral vy cv c1 cA caddc co clt wbr vy cS wral vx c1 cA caddc co cr vx
        cv c1 cA caddc co wceq vy cv vx cv clt wbr vy cv c1 cA caddc co clt wbr
        vy cS vx cv c1 cA caddc co vy cv clt breq2 ralbidv rcla4ev mp2an
        3pm3.2i $.
        $( [21-May-1999] $)

      ${
        sqrlem7.4 $e |- B = sup ( S , RR , < ) $.
        $( Lemma for square root theorem. $)
        sqrlem7 $p |- B e. RR $=
          cB cS cr clt csup cr sqrlem7.4 vx vy vz cr cS clt ltso cS cr wss cS
          c0 wne vy cv vx cv clt wbr vy cS wral vx cr wrex w3a vx cv vy cv clt
          wbr wn vy cS wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cS wrex
          wi vy cr wral wa vx cr wrex vx vy cA cS sqrlem1.1 sqrlem1.2 sqrlem4.3
          sqrlem6 vx vy vz cS axsup ax-mp supcli eqeltri $.
          $( [24-May-1999] $)

        $( Lemma for square root theorem. $)
        sqrlem8 $p |- 0 < B $=
          cc0 cS cr clt csup cB clt cc0 cA c1 cA caddc co cdiv co clt wbr cA c1
          cA caddc co cdiv co cS cr clt csup cle wbr cc0 cS cr clt csup clt wbr
          cA sqrlem1.1 sqrlem1.2 sqrlem3 cA c1 cA caddc co cdiv co cS cr clt
          csup cle wbr cS cr clt csup cA c1 cA caddc co cdiv co clt wbr wn cA
          c1 cA caddc co cdiv co cS wcel cS cr clt csup cA c1 cA caddc co cdiv
          co clt wbr wn cA c1 cA caddc co cdiv co cr wcel cc0 cA c1 cA caddc co
          cdiv co clt wbr cA c1 cA caddc co cdiv co cA c1 cA caddc co cdiv co
          cmul co cA clt wbr wa cA c1 cA caddc co cdiv co cS wcel cA c1 cA
          caddc co sqrlem1.1 c1 cA 1re sqrlem1.1 readdcli c1 cA caddc co c1 cA
          1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01 sqrlem1.2 addgt0ii
          gt0ne0ii redivcli cc0 cA c1 cA caddc co cdiv co clt wbr cA c1 cA
          caddc co cdiv co cA c1 cA caddc co cdiv co cmul co cA clt wbr cA
          sqrlem1.1 sqrlem1.2 sqrlem3 cA sqrlem1.1 sqrlem1.2 sqrlem2 pm3.2i vx
          cA cA c1 cA caddc co cdiv co cS sqrlem1.1 sqrlem1.2 sqrlem4.3 sqrlem5
          mp2an vx vy vz cr cS cA c1 cA caddc co cdiv co clt ltso cS cr wss cS
          c0 wne vy cv vx cv clt wbr vy cS wral vx cr wrex w3a vx cv vy cv clt
          wbr wn vy cS wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cS wrex
          wi vy cr wral wa vx cr wrex vx vy cA cS sqrlem1.1 sqrlem1.2 sqrlem4.3
          sqrlem6 vx vy vz cS axsup ax-mp supubi ax-mp cA c1 cA caddc co cdiv
          co cS cr clt csup cA c1 cA caddc co sqrlem1.1 c1 cA 1re sqrlem1.1
          readdcli c1 cA caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re
          sqrlem1.1 lt01 sqrlem1.2 addgt0ii gt0ne0ii redivcli cB cS cr clt csup
          cr sqrlem7.4 vx cA cB cS sqrlem1.1 sqrlem1.2 sqrlem4.3 sqrlem7.4
          sqrlem7 eqeltrri lenlti mpbir cc0 cA c1 cA caddc co cdiv co cS cr clt
          csup 0re cA c1 cA caddc co sqrlem1.1 c1 cA 1re sqrlem1.1 readdcli c1
          cA caddc co c1 cA 1re sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01
          sqrlem1.2 addgt0ii gt0ne0ii redivcli cB cS cr clt csup cr sqrlem7.4
          vx cA cB cS sqrlem1.1 sqrlem1.2 sqrlem4.3 sqrlem7.4 sqrlem7 eqeltrri
          ltletri mp2an sqrlem7.4 breqtrri $.
          $( [24-May-1999] $)

      $}
    $}

    ${
      sqrlem9.3 $e |- B e. RR $.
      sqrlem9.4 $e |- C e. RR $.
      sqrlem9.5 $e |- 0 < B $.
      sqrlem9.6 $e |- A < ( B x. B ) $.
      sqrlem9.7 $e |- C = ( ( B + ( A / B ) ) / ( 1 + 1 ) ) $.
      $( Lemma for square root theorem. $)
      sqrlem9 $p |- 0 < C $=
        cc0 cB cA cB cdiv co caddc co c1 c1 caddc co cdiv co cC clt cB cA cB
        cdiv co caddc co c1 c1 caddc co cB cA cB cdiv co sqrlem9.3 cA cB
        sqrlem1.1 sqrlem9.3 cB sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli readdcli
        c1 c1 1re 1re readdcli cB cA cB cdiv co sqrlem9.3 cA cB sqrlem1.1
        sqrlem9.3 cB sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli sqrlem9.5 cA cB
        sqrlem1.1 sqrlem9.3 sqrlem1.2 sqrlem9.5 divgt0ii addgt0ii c1 c1 1re 1re
        lt01 lt01 addgt0ii divgt0ii sqrlem9.7 breqtrri $.
        $( [17-May-1999] $)

      $( Lemma for square root theorem. $)
      sqrlem10 $p |- C < B $=
        cC cB cA cB cdiv co caddc co c1 c1 caddc co cdiv co cB clt sqrlem9.7 cB
        cA cB cdiv co caddc co c1 c1 caddc co cdiv co cB c1 c1 caddc co cmul co
        c1 c1 caddc co cdiv co cB clt cB cA cB cdiv co caddc co cB c1 c1 caddc
        co cmul co clt wbr cB cA cB cdiv co caddc co c1 c1 caddc co cdiv co cB
        c1 c1 caddc co cmul co c1 c1 caddc co cdiv co clt wbr cB cA cB cdiv co
        caddc co cB cB caddc co cB c1 c1 caddc co cmul co clt cA cB cdiv co cB
        clt wbr cB cA cB cdiv co caddc co cB cB caddc co clt wbr cA cB cdiv co
        cB cB cmul co cB cdiv co cB clt cA cB cB cmul co clt wbr cA cB cdiv co
        cB cB cmul co cB cdiv co clt wbr sqrlem9.6 cA cB cB cmul co cB
        sqrlem1.1 cB cB sqrlem9.3 sqrlem9.3 remulcli sqrlem9.3 sqrlem9.5
        ltdiv1ii mpbi cB cB cB sqrlem9.3 recni cB sqrlem9.3 recni cB sqrlem9.3
        sqrlem9.5 gt0ne0ii divcan4i breqtri cA cB cdiv co cB cB cA cB sqrlem1.1
        sqrlem9.3 cB sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli sqrlem9.3 sqrlem9.3
        ltadd2i mpbi cB c1 c1 caddc co cmul co c1 c1 caddc co cB cmul co cB cB
        caddc co cB c1 c1 caddc co cB sqrlem9.3 recni c1 c1 caddc co c1 c1 1re
        1re readdcli recni mulcomi cB cB sqrlem9.3 recni 1p1timesi eqtri
        breqtrri cB cA cB cdiv co caddc co cB c1 c1 caddc co cmul co c1 c1
        caddc co cB cA cB cdiv co sqrlem9.3 cA cB sqrlem1.1 sqrlem9.3 cB
        sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli readdcli cB c1 c1 caddc co
        sqrlem9.3 c1 c1 1re 1re readdcli remulcli c1 c1 1re 1re readdcli c1 c1
        1re 1re lt01 lt01 addgt0ii ltdiv1ii mpbi cB c1 c1 caddc co cB sqrlem9.3
        recni c1 c1 caddc co c1 c1 1re 1re readdcli recni c1 c1 caddc co c1 c1
        1re 1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii divcan4i
        breqtri eqbrtri $.
        $( [17-May-1999] $)

      $( Lemma for square root theorem. $)
      sqrlem11 $p |- A < ( C x. C ) $=
        cA c1 c1 caddc co c1 c1 caddc co cmul co cmul co c1 c1 caddc co c1 c1
        caddc co cmul co cdiv co cB cA cB cdiv co caddc co cB cA cB cdiv co
        caddc co cmul co c1 c1 caddc co c1 c1 caddc co cmul co cdiv co cA cC cC
        cmul co clt cA c1 c1 caddc co c1 c1 caddc co cmul co cmul co cB cA cB
        cdiv co caddc co cB cA cB cdiv co caddc co cmul co clt wbr cA c1 c1
        caddc co c1 c1 caddc co cmul co cmul co c1 c1 caddc co c1 c1 caddc co
        cmul co cdiv co cB cA cB cdiv co caddc co cB cA cB cdiv co caddc co
        cmul co c1 c1 caddc co c1 c1 caddc co cmul co cdiv co clt wbr c1 c1
        caddc co cA cmul co c1 c1 caddc co cA cmul co caddc co cB cB cmul co cB
        cB cmul co cmul co cB cB cmul co cdiv co cA cneg cA cneg cmul co cB cB
        cmul co cdiv co caddc co c1 c1 caddc co cA cmul co caddc co cA c1 c1
        caddc co c1 c1 caddc co cmul co cmul co cB cA cB cdiv co caddc co cB cA
        cB cdiv co caddc co cmul co clt c1 c1 caddc co cA cmul co cB cB cmul co
        cB cB cmul co cmul co cB cB cmul co cdiv co cA cneg cA cneg cmul co cB
        cB cmul co cdiv co caddc co clt wbr c1 c1 caddc co cA cmul co c1 c1
        caddc co cA cmul co caddc co cB cB cmul co cB cB cmul co cmul co cB cB
        cmul co cdiv co cA cneg cA cneg cmul co cB cB cmul co cdiv co caddc co
        c1 c1 caddc co cA cmul co caddc co clt wbr cB cB cmul co c1 c1 caddc co
        cneg cA cneg cmul co cmul co cB cB cmul co cdiv co cB cB cmul co cB cB
        cmul co cmul co cA cneg cA cneg cmul co caddc co cB cB cmul co cdiv co
        c1 c1 caddc co cA cmul co cB cB cmul co cB cB cmul co cmul co cB cB
        cmul co cdiv co cA cneg cA cneg cmul co cB cB cmul co cdiv co caddc co
        clt cB cB cmul co c1 c1 caddc co cneg cA cneg cmul co cmul co cB cB
        cmul co cB cB cmul co cmul co cA cneg cA cneg cmul co caddc co clt wbr
        cB cB cmul co c1 c1 caddc co cneg cA cneg cmul co cmul co cB cB cmul co
        cdiv co cB cB cmul co cB cB cmul co cmul co cA cneg cA cneg cmul co
        caddc co cB cB cmul co cdiv co clt wbr cB cB cmul co c1 c1 caddc co
        cneg cA cneg cmul co cmul co cc0 cB cB cmul co cA cneg cmul co cB cB
        cmul co cA cneg cmul co caddc co cmin co cB cB cmul co cB cB cmul co
        cmul co cA cneg cA cneg cmul co caddc co clt cB cB cmul co c1 c1 caddc
        co cneg cA cneg cmul co cmul co c1 c1 caddc co cneg cB cB cmul co cA
        cneg cmul co cmul co c1 c1 caddc co cB cB cmul co cA cneg cmul co cmul
        co cneg cc0 cB cB cmul co cA cneg cmul co cB cB cmul co cA cneg cmul co
        caddc co cmin co cB cB cmul co c1 c1 caddc co cneg cA cneg cB cB cmul
        co cB cB sqrlem9.3 sqrlem9.3 remulcli recni c1 c1 caddc co c1 c1 caddc
        co c1 c1 1re 1re readdcli recni negcli cA cneg cA sqrlem1.1 renegcli
        recni mul12i c1 c1 caddc co cB cB cmul co cA cneg cmul co c1 c1 caddc
        co c1 c1 1re 1re readdcli recni cB cB cmul co cA cneg cmul co cB cB
        cmul co cA cneg cB cB sqrlem9.3 sqrlem9.3 remulcli cA sqrlem1.1
        renegcli remulcli recni mulneg1i c1 c1 caddc co cB cB cmul co cA cneg
        cmul co cmul co cneg cB cB cmul co cA cneg cmul co cB cB cmul co cA
        cneg cmul co caddc co cneg cc0 cB cB cmul co cA cneg cmul co cB cB cmul
        co cA cneg cmul co caddc co cmin co c1 c1 caddc co cB cB cmul co cA
        cneg cmul co cmul co cB cB cmul co cA cneg cmul co cB cB cmul co cA
        cneg cmul co caddc co cB cB cmul co cA cneg cmul co cB cB cmul co cA
        cneg cmul co cB cB cmul co cA cneg cB cB sqrlem9.3 sqrlem9.3 remulcli
        cA sqrlem1.1 renegcli remulcli recni 1p1timesi negeqi cB cB cmul co cA
        cneg cmul co cB cB cmul co cA cneg cmul co caddc co df-neg eqtri 3eqtri
        cc0 cB cB cmul co cA cneg cmul co cB cB cmul co cA cneg cmul co caddc
        co cmin co cB cB cmul co cB cB cmul co cmul co cA cneg cA cneg cmul co
        caddc co clt wbr cc0 cB cB cmul co cB cB cmul co cmul co cA cneg cA
        cneg cmul co caddc co cB cB cmul co cA cneg cmul co cB cB cmul co cA
        cneg cmul co caddc co caddc co clt wbr cc0 cB cB cmul co cA cneg caddc
        co cB cB cmul co cA cneg caddc co cmul co cB cB cmul co cB cB cmul co
        cmul co cA cneg cA cneg cmul co caddc co cB cB cmul co cA cneg cmul co
        cB cB cmul co cA cneg cmul co caddc co caddc co clt cB cB cmul co cA
        cneg caddc co cB cB cmul co cA cneg caddc co cB cB cmul co cA cneg cB
        cB sqrlem9.3 sqrlem9.3 remulcli cA sqrlem1.1 renegcli readdcli cB cB
        cmul co cA cneg cB cB sqrlem9.3 sqrlem9.3 remulcli cA sqrlem1.1
        renegcli readdcli cA cA cneg caddc co cc0 cB cB cmul co cA cneg caddc
        co clt cA cA sqrlem1.1 recni negidi cA cB cB cmul co clt wbr cA cA cneg
        caddc co cB cB cmul co cA cneg caddc co clt wbr sqrlem9.6 cA cB cB cmul
        co cA cneg sqrlem1.1 cB cB sqrlem9.3 sqrlem9.3 remulcli cA sqrlem1.1
        renegcli ltadd1i mpbi eqbrtrri cA cA cneg caddc co cc0 cB cB cmul co cA
        cneg caddc co clt cA cA sqrlem1.1 recni negidi cA cB cB cmul co clt wbr
        cA cA cneg caddc co cB cB cmul co cA cneg caddc co clt wbr sqrlem9.6 cA
        cB cB cmul co cA cneg sqrlem1.1 cB cB sqrlem9.3 sqrlem9.3 remulcli cA
        sqrlem1.1 renegcli ltadd1i mpbi eqbrtrri mulgt0ii cB cB cmul co cA cneg
        cB cB cmul co cA cneg cB cB cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli
        recni cA cneg cA sqrlem1.1 renegcli recni cB cB cmul co cB cB sqrlem9.3
        sqrlem9.3 remulcli recni cA cneg cA sqrlem1.1 renegcli recni muladdi
        breqtri cc0 cB cB cmul co cA cneg cmul co cB cB cmul co cA cneg cmul co
        caddc co cB cB cmul co cB cB cmul co cmul co cA cneg cA cneg cmul co
        caddc co 0re cB cB cmul co cA cneg cmul co cB cB cmul co cA cneg cmul
        co cB cB cmul co cA cneg cB cB sqrlem9.3 sqrlem9.3 remulcli cA
        sqrlem1.1 renegcli remulcli cB cB cmul co cA cneg cB cB sqrlem9.3
        sqrlem9.3 remulcli cA sqrlem1.1 renegcli remulcli readdcli cB cB cmul
        co cB cB cmul co cmul co cA cneg cA cneg cmul co cB cB cmul co cB cB
        cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli cB cB sqrlem9.3 sqrlem9.3
        remulcli remulcli cA cneg cA cneg cA sqrlem1.1 renegcli cA sqrlem1.1
        renegcli remulcli readdcli ltsubaddi mpbir eqbrtri cB cB cmul co c1 c1
        caddc co cneg cA cneg cmul co cmul co cB cB cmul co cB cB cmul co cmul
        co cA cneg cA cneg cmul co caddc co cB cB cmul co cB cB cmul co c1 c1
        caddc co cneg cA cneg cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli c1 c1
        caddc co cneg cA cneg c1 c1 caddc co c1 c1 1re 1re readdcli renegcli cA
        sqrlem1.1 renegcli remulcli remulcli cB cB cmul co cB cB cmul co cmul
        co cA cneg cA cneg cmul co cB cB cmul co cB cB cmul co cB cB sqrlem9.3
        sqrlem9.3 remulcli cB cB sqrlem9.3 sqrlem9.3 remulcli remulcli cA cneg
        cA cneg cA sqrlem1.1 renegcli cA sqrlem1.1 renegcli remulcli readdcli
        cB cB sqrlem9.3 sqrlem9.3 remulcli cB cB sqrlem9.3 sqrlem9.3 sqrlem9.5
        sqrlem9.5 mulgt0ii ltdiv1ii mpbi cB cB cmul co c1 c1 caddc co cneg cA
        cneg cmul co cmul co cB cB cmul co cdiv co c1 c1 caddc co cneg cA cneg
        cmul co c1 c1 caddc co cA cmul co c1 c1 caddc co cneg cA cneg cmul co
        cB cB cmul co c1 c1 caddc co cneg cA cneg cmul co c1 c1 caddc co cneg
        cA cneg c1 c1 caddc co c1 c1 1re 1re readdcli renegcli cA sqrlem1.1
        renegcli remulcli recni cB cB cmul co cB cB sqrlem9.3 sqrlem9.3
        remulcli recni cB cB cB sqrlem9.3 recni cB sqrlem9.3 recni cB sqrlem9.3
        sqrlem9.5 gt0ne0ii cB sqrlem9.3 sqrlem9.5 gt0ne0ii muln0i divcan3i c1
        c1 caddc co cA c1 c1 caddc co c1 c1 1re 1re readdcli recni cA sqrlem1.1
        recni mul2negi eqtri cB cB cmul co cB cB cmul co cmul co cA cneg cA
        cneg cmul co cB cB cmul co cB cB cmul co cB cB cmul co cmul co cB cB
        cmul co cB cB cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli cB cB
        sqrlem9.3 sqrlem9.3 remulcli remulcli recni cA cneg cA cneg cmul co cA
        cneg cA cneg cA sqrlem1.1 renegcli cA sqrlem1.1 renegcli remulcli recni
        cB cB cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli recni cB cB cmul co cB
        cB sqrlem9.3 sqrlem9.3 remulcli cB cB sqrlem9.3 sqrlem9.3 sqrlem9.5
        sqrlem9.5 mulgt0ii gt0ne0ii divdiri 3brtr3i c1 c1 caddc co cA cmul co
        cB cB cmul co cB cB cmul co cmul co cB cB cmul co cdiv co cA cneg cA
        cneg cmul co cB cB cmul co cdiv co caddc co c1 c1 caddc co cA cmul co
        c1 c1 caddc co cA c1 c1 1re 1re readdcli sqrlem1.1 remulcli cB cB cmul
        co cB cB cmul co cmul co cB cB cmul co cdiv co cA cneg cA cneg cmul co
        cB cB cmul co cdiv co cB cB cmul co cB cB cmul co cmul co cB cB cmul co
        cB cB cmul co cB cB cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli cB cB
        sqrlem9.3 sqrlem9.3 remulcli remulcli cB cB sqrlem9.3 sqrlem9.3
        remulcli cB cB cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli cB cB
        sqrlem9.3 sqrlem9.3 sqrlem9.5 sqrlem9.5 mulgt0ii gt0ne0ii redivcli cA
        cneg cA cneg cmul co cB cB cmul co cA cneg cA cneg cA sqrlem1.1
        renegcli cA sqrlem1.1 renegcli remulcli cB cB sqrlem9.3 sqrlem9.3
        remulcli cB cB cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli cB cB
        sqrlem9.3 sqrlem9.3 sqrlem9.5 sqrlem9.5 mulgt0ii gt0ne0ii redivcli
        readdcli c1 c1 caddc co cA c1 c1 1re 1re readdcli sqrlem1.1 remulcli
        ltadd1i mpbi cA c1 c1 caddc co c1 c1 caddc co cmul co cmul co c1 c1
        caddc co c1 c1 caddc co cmul co cA cmul co c1 c1 caddc co c1 c1 caddc
        co cA cmul co cmul co c1 c1 caddc co cA cmul co c1 c1 caddc co cA cmul
        co caddc co cA c1 c1 caddc co c1 c1 caddc co cmul co cA sqrlem1.1 recni
        c1 c1 caddc co c1 c1 caddc co cmul co c1 c1 caddc co c1 c1 caddc co c1
        c1 1re 1re readdcli c1 c1 1re 1re readdcli remulcli recni mulcomi c1 c1
        caddc co c1 c1 caddc co cA c1 c1 caddc co c1 c1 1re 1re readdcli recni
        c1 c1 caddc co c1 c1 1re 1re readdcli recni cA sqrlem1.1 recni mulassi
        c1 c1 caddc co cA cmul co c1 c1 caddc co cA cmul co c1 c1 caddc co cA
        c1 c1 1re 1re readdcli sqrlem1.1 remulcli recni 1p1timesi 3eqtri cB cA
        cB cdiv co caddc co cB cA cB cdiv co caddc co cmul co cB cB cmul co cA
        cB cdiv co cA cB cdiv co cmul co caddc co cB cA cB cdiv co cmul co cB
        cA cB cdiv co cmul co caddc co caddc co cB cB cmul co cB cB cmul co
        cmul co cB cB cmul co cdiv co cA cneg cA cneg cmul co cB cB cmul co
        cdiv co caddc co c1 c1 caddc co cA cmul co caddc co cB cA cB cdiv co cB
        cA cB cdiv co cB sqrlem9.3 recni cA cB cdiv co cA cB sqrlem1.1
        sqrlem9.3 cB sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli recni cB sqrlem9.3
        recni cA cB cdiv co cA cB sqrlem1.1 sqrlem9.3 cB sqrlem9.3 sqrlem9.5
        gt0ne0ii redivcli recni muladdi cB cB cmul co cA cB cdiv co cA cB cdiv
        co cmul co caddc co cB cB cmul co cB cB cmul co cmul co cB cB cmul co
        cdiv co cA cneg cA cneg cmul co cB cB cmul co cdiv co caddc co cB cA cB
        cdiv co cmul co cB cA cB cdiv co cmul co caddc co c1 c1 caddc co cA
        cmul co caddc cB cB cmul co cB cB cmul co cB cB cmul co cmul co cB cB
        cmul co cdiv co cA cB cdiv co cA cB cdiv co cmul co cA cneg cA cneg
        cmul co cB cB cmul co cdiv co caddc cB cB cmul co cB cB cmul co cmul co
        cB cB cmul co cdiv co cB cB cmul co cB cB cmul co cB cB cmul co cB cB
        cmul co cB cB sqrlem9.3 sqrlem9.3 remulcli recni cB cB cmul co cB cB
        sqrlem9.3 sqrlem9.3 remulcli recni cB cB cmul co cB cB sqrlem9.3
        sqrlem9.3 remulcli cB cB sqrlem9.3 sqrlem9.3 sqrlem9.5 sqrlem9.5
        mulgt0ii gt0ne0ii divcan4i eqcomi cA cB cdiv co cA cB cdiv co cmul co
        cA cA cmul co cB cB cmul co cdiv co cA cneg cA cneg cmul co cB cB cmul
        co cdiv co cA cB cA cB cA sqrlem1.1 recni cB sqrlem9.3 recni cA
        sqrlem1.1 recni cB sqrlem9.3 recni cB sqrlem9.3 sqrlem9.5 gt0ne0ii cB
        sqrlem9.3 sqrlem9.5 gt0ne0ii divmuldivi cA cneg cA cneg cmul co cA cA
        cmul co cB cB cmul co cdiv cA cA cA sqrlem1.1 recni cA sqrlem1.1 recni
        mul2negi opreq1i eqtr4i opreq12i c1 c1 caddc co cB cA cB cdiv co cmul
        co cmul co cB cA cB cdiv co cmul co cB cA cB cdiv co cmul co caddc co
        c1 c1 caddc co cA cmul co cB cA cB cdiv co cmul co cB cA cB cdiv co cB
        sqrlem9.3 recni cA cB cdiv co cA cB sqrlem1.1 sqrlem9.3 cB sqrlem9.3
        sqrlem9.5 gt0ne0ii redivcli recni mulcli 1p1timesi cB cA cB cdiv co
        cmul co cA c1 c1 caddc co cmul cA cB cA sqrlem1.1 recni cB sqrlem9.3
        recni cB sqrlem9.3 sqrlem9.5 gt0ne0ii divcan2i opreq2i eqtr3i opreq12i
        eqtri 3brtr4i cA c1 c1 caddc co c1 c1 caddc co cmul co cmul co cB cA cB
        cdiv co caddc co cB cA cB cdiv co caddc co cmul co c1 c1 caddc co c1 c1
        caddc co cmul co cA c1 c1 caddc co c1 c1 caddc co cmul co sqrlem1.1 c1
        c1 caddc co c1 c1 caddc co c1 c1 1re 1re readdcli c1 c1 1re 1re
        readdcli remulcli remulcli cB cA cB cdiv co caddc co cB cA cB cdiv co
        caddc co cB cA cB cdiv co sqrlem9.3 cA cB sqrlem1.1 sqrlem9.3 cB
        sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli readdcli cB cA cB cdiv co
        sqrlem9.3 cA cB sqrlem1.1 sqrlem9.3 cB sqrlem9.3 sqrlem9.5 gt0ne0ii
        redivcli readdcli remulcli c1 c1 caddc co c1 c1 caddc co c1 c1 1re 1re
        readdcli c1 c1 1re 1re readdcli remulcli c1 c1 caddc co c1 c1 caddc co
        c1 c1 1re 1re readdcli c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01
        addgt0ii c1 c1 1re 1re lt01 lt01 addgt0ii mulgt0ii ltdiv1ii mpbi cA c1
        c1 caddc co c1 c1 caddc co cmul co cA sqrlem1.1 recni c1 c1 caddc co c1
        c1 caddc co cmul co c1 c1 caddc co c1 c1 caddc co c1 c1 1re 1re
        readdcli c1 c1 1re 1re readdcli remulcli recni c1 c1 caddc co c1 c1
        caddc co cmul co c1 c1 caddc co c1 c1 caddc co c1 c1 1re 1re readdcli
        c1 c1 1re 1re readdcli remulcli c1 c1 caddc co c1 c1 caddc co c1 c1 1re
        1re readdcli c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii c1
        c1 1re 1re lt01 lt01 addgt0ii mulgt0ii gt0ne0ii divcan4i cC cC cmul co
        cB cA cB cdiv co caddc co c1 c1 caddc co cdiv co cB cA cB cdiv co caddc
        co c1 c1 caddc co cdiv co cmul co cB cA cB cdiv co caddc co cB cA cB
        cdiv co caddc co cmul co c1 c1 caddc co c1 c1 caddc co cmul co cdiv co
        cC cB cA cB cdiv co caddc co c1 c1 caddc co cdiv co cC cB cA cB cdiv co
        caddc co c1 c1 caddc co cdiv co cmul sqrlem9.7 sqrlem9.7 opreq12i cB cA
        cB cdiv co caddc co c1 c1 caddc co cB cA cB cdiv co caddc co c1 c1
        caddc co cB cA cB cdiv co caddc co cB cA cB cdiv co sqrlem9.3 cA cB
        sqrlem1.1 sqrlem9.3 cB sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli readdcli
        recni c1 c1 caddc co c1 c1 1re 1re readdcli recni cB cA cB cdiv co
        caddc co cB cA cB cdiv co sqrlem9.3 cA cB sqrlem1.1 sqrlem9.3 cB
        sqrlem9.3 sqrlem9.5 gt0ne0ii redivcli readdcli recni c1 c1 caddc co c1
        c1 1re 1re readdcli recni c1 c1 caddc co c1 c1 1re 1re readdcli c1 c1
        1re 1re lt01 lt01 addgt0ii gt0ne0ii c1 c1 caddc co c1 c1 1re 1re
        readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii divmuldivi eqtr2i
        3brtr3i $.
        $( [18-May-1999] $)

      ${
        sqrlem12.8 $e |- S = { x e. RR | ( 0 <_ x /\ ( x x. x ) <_ A ) } $.

        $( Lemma for square root theorem. $)
        sqrlem12 $p |- ( D e. S -> D < C ) $=
          cD cS wcel cc0 cD clt wbr cc0 cD wceq wo cD cC clt wbr cD cS wcel cc0
          cD cle wbr cc0 cD clt wbr cc0 cD wceq wo cD cS wcel cc0 cD cle wbr cD
          cD cmul co cA cle wbr cD cS wcel cD cr wcel cc0 cD cle wbr cD cD cmul
          co cA cle wbr wa vx cA cD cS sqrlem1.1 sqrlem1.2 sqrlem12.8 sqrlem4
          pm3.27bi pm3.26d cc0 cr wcel cD cr wcel cc0 cD cle wbr cc0 cD clt wbr
          cc0 cD wceq wo wb cD cS wcel cc0 cD leloe 0re cD cS wcel cD cr wcel
          cc0 cD cle wbr cD cD cmul co cA cle wbr wa vx cA cD cS sqrlem1.1
          sqrlem1.2 sqrlem12.8 sqrlem4 pm3.26bi sylancr mpbid cD cS wcel cc0 cD
          clt wbr cD cC clt wbr cc0 cD wceq cD cS wcel cc0 cD clt wbr cD cC clt
          wbr cD cS wcel cc0 cD clt wbr wa cD cC clt wbr cD cD cmul co cC cC
          cmul co clt wbr cD cS wcel cD cD cmul co cC cC cmul co clt wbr cc0 cD
          clt wbr cD cS wcel cD cD cmul co cA cle wbr cD cD cmul co cC cC cmul
          co clt wbr cD cS wcel cc0 cD cle wbr cD cD cmul co cA cle wbr cD cS
          wcel cD cr wcel cc0 cD cle wbr cD cD cmul co cA cle wbr wa vx cA cD
          cS sqrlem1.1 sqrlem1.2 sqrlem12.8 sqrlem4 pm3.27bi pm3.27d cD cS wcel
          cD cD cmul co cA cle wbr cA cC cC cmul co clt wbr cD cD cmul co cC cC
          cmul co clt wbr cA cB cC sqrlem1.1 sqrlem1.2 sqrlem9.3 sqrlem9.4
          sqrlem9.5 sqrlem9.6 sqrlem9.7 sqrlem11 cD cS wcel cD cr wcel cD cD
          cmul co cr wcel cD cD cmul co cA cle wbr cA cC cC cmul co clt wbr wa
          cD cD cmul co cC cC cmul co clt wbr wi cD cS wcel cD cr wcel cc0 cD
          cle wbr cD cD cmul co cA cle wbr wa vx cA cD cS sqrlem1.1 sqrlem1.2
          sqrlem12.8 sqrlem4 pm3.26bi cD cr wcel cD cD cmul co cr wcel cD cD
          remulcl anidms cD cD cmul co cr wcel cA cr wcel cC cC cmul co cr wcel
          cD cD cmul co cA cle wbr cA cC cC cmul co clt wbr wa cD cD cmul co cC
          cC cmul co clt wbr wi sqrlem1.1 cC cC sqrlem9.4 sqrlem9.4 remulcli cD
          cD cmul co cA cC cC cmul co lelttr mp3an23 3syl mpan2i mpd adantr cD
          cS wcel cc0 cD clt wbr cD cC clt wbr cD cD cmul co cC cC cmul co clt
          wbr wb cD cS wcel cc0 cD clt wbr cc0 cC clt wbr cD cC clt wbr cD cD
          cmul co cC cC cmul co clt wbr wb cA cB cC sqrlem1.1 sqrlem1.2
          sqrlem9.3 sqrlem9.4 sqrlem9.5 sqrlem9.6 sqrlem9.7 sqrlem9 cD cS wcel
          cD cr wcel cc0 cD clt wbr cc0 cC clt wbr wa cD cC clt wbr cD cD cmul
          co cC cC cmul co clt wbr wb wi cD cS wcel cD cr wcel cc0 cD cle wbr
          cD cD cmul co cA cle wbr wa vx cA cD cS sqrlem1.1 sqrlem1.2
          sqrlem12.8 sqrlem4 pm3.26bi cD cr wcel cc0 cD clt wbr cc0 cC clt wbr
          wa cD cC clt wbr cD cD cmul co cC cC cmul co clt wbr wb wi cc0 cD cr
          wcel cD cc0 cif clt wbr cc0 cC clt wbr wa cD cr wcel cD cc0 cif cC
          clt wbr cD cr wcel cD cc0 cif cD cr wcel cD cc0 cif cmul co cC cC
          cmul co clt wbr wb wi cD cc0 cD cD cr wcel cD cc0 cif wceq cc0 cD clt
          wbr cc0 cC clt wbr wa cc0 cD cr wcel cD cc0 cif clt wbr cc0 cC clt
          wbr wa cD cC clt wbr cD cD cmul co cC cC cmul co clt wbr wb cD cr
          wcel cD cc0 cif cC clt wbr cD cr wcel cD cc0 cif cD cr wcel cD cc0
          cif cmul co cC cC cmul co clt wbr wb cD cD cr wcel cD cc0 cif wceq
          cc0 cD clt wbr cc0 cD cr wcel cD cc0 cif clt wbr cc0 cC clt wbr cD cD
          cr wcel cD cc0 cif cc0 clt breq2 anbi1d cD cD cr wcel cD cc0 cif wceq
          cD cC clt wbr cD cr wcel cD cc0 cif cC clt wbr cD cD cmul co cC cC
          cmul co clt wbr cD cr wcel cD cc0 cif cD cr wcel cD cc0 cif cmul co
          cC cC cmul co clt wbr cD cD cr wcel cD cc0 cif cC clt breq1 cD cD cr
          wcel cD cc0 cif wceq cD cD cmul co cD cr wcel cD cc0 cif cD cr wcel
          cD cc0 cif cmul co cC cC cmul co clt cD cD cr wcel cD cc0 cif wceq cD
          cD cmul co cD cr wcel cD cc0 cif cD cr wcel cD cc0 cif cmul co wceq
          cD cD cr wcel cD cc0 cif cD cD cr wcel cD cc0 cif cmul opreq12 anidms
          breq1d bibi12d imbi12d cc0 cD cr wcel cD cc0 cif cle wbr cc0 cC cle
          wbr cD cr wcel cD cc0 cif cC clt wbr cD cr wcel cD cc0 cif cD cr wcel
          cD cc0 cif cmul co cC cC cmul co clt wbr wb cc0 cD cr wcel cD cc0 cif
          clt wbr cc0 cC clt wbr cD cr wcel cD cc0 cif cC cD cc0 cr 0re elimel
          sqrlem9.4 lt2msqi cc0 cD cr wcel cD cc0 cif 0re cD cc0 cr 0re elimel
          ltlei cc0 cC 0re sqrlem9.4 ltlei syl2an dedth syl mpan2i imp mpbird
          ex cc0 cD wceq cD cC clt wbr wi cD cS wcel cc0 cD wceq cc0 cC clt wbr
          cD cC clt wbr cA cB cC sqrlem1.1 sqrlem1.2 sqrlem9.3 sqrlem9.4
          sqrlem9.5 sqrlem9.6 sqrlem9.7 sqrlem9 cc0 cD cC clt breq1 mpbii a1i
          jaod mpd $.
          $( [23-May-1999] $)

        $( Lemma for square root theorem. $)
        sqrlem13 $p |- ( B = sup ( S , RR , < ) -> -. C < B ) $=
          cB cS cr clt csup wceq cC cB clt wbr cC cS cr clt csup clt wbr cC cr
          wcel cC vz cv clt wbr wn vz cS wral cC cS cr clt csup clt wbr wn
          sqrlem9.4 cC vz cv clt wbr wn vz cS vz cv cS wcel vz cv cC wceq wn cC
          vz cv clt wbr wn vz cv cS wcel vz cv cC wceq cC vz cv clt wbr wo wn
          vz cv cC wceq wn cC vz cv clt wbr wn wa vz cv cS wcel vz cv cC clt
          wbr vz cv cC wceq cC vz cv clt wbr wo wn vx cA cB cC vz cv cS
          sqrlem1.1 sqrlem1.2 sqrlem9.3 sqrlem9.4 sqrlem9.5 sqrlem9.6 sqrlem9.7
          sqrlem12.8 sqrlem12 vz cv cr wcel cC cr wcel vz cv cC clt wbr vz cv
          cC wceq cC vz cv clt wbr wo wn wb vz cv cS wcel vz cv cC axlttri vz
          cv cS wcel vz cv cr wcel cc0 vz cv cle wbr vz cv vz cv cmul co cA cle
          wbr wa vx cA vz cv cS sqrlem1.1 sqrlem1.2 sqrlem12.8 sqrlem4 pm3.26bi
          sqrlem9.4 sylancl mpbid vz cv cC wceq cC vz cv clt wbr ioran sylib
          pm3.27d rgen vx vy vz cr cS cC clt ltso cS cr wss cS c0 wne vy cv vx
          cv clt wbr vy cS wral vx cr wrex w3a vx cv vy cv clt wbr wn vy cS
          wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cS wrex wi vy cr wral
          wa vx cr wrex vx vy cA cS sqrlem1.1 sqrlem1.2 sqrlem12.8 sqrlem6 vx
          vy vz cS axsup ax-mp supnubi mp2an cB cS cr clt csup cC clt breq2
          mtbiri $.
          $( [25-May-1999] $)

        $( Lemma for square root theorem. $)
        sqrlem14 $p |- -. B = sup ( S , RR , < ) $=
          cB cS cr clt csup wceq cC cB clt wbr cA cB cC sqrlem1.1 sqrlem1.2
          sqrlem9.3 sqrlem9.4 sqrlem9.5 sqrlem9.6 sqrlem9.7 sqrlem10 vx cA cB
          cC cS sqrlem1.1 sqrlem1.2 sqrlem9.3 sqrlem9.4 sqrlem9.5 sqrlem9.6
          sqrlem9.7 sqrlem12.8 sqrlem13 mt2 $.
          $( [25-May-1999] $)
      $}

    $}

    ${
      sqrlem15.3 $e |- B e. RR $.
      sqrlem15.4 $e |- 0 < B $.

      ${
        sqrlem15.5 $e |- C e. RR $.
        sqrlem15.6 $e |- 0 < C $.
        $( Lemma for square root theorem. $)
        sqrlem15 $p |- B < ( B + C ) $=
          cB cc0 caddc co cB cB cC caddc co clt cB cB sqrlem15.3 recni addid1i
          cc0 cC clt wbr cB cc0 caddc co cB cC caddc co clt wbr sqrlem15.6 cc0
          cC cB 0re sqrlem15.5 sqrlem15.3 ltadd2i mpbi eqbrtrri $.
          $( [24-May-1999] $)

        ${
          sqrlem16.7 $e |- C < B $.
          $( Lemma for square root theorem. $)
          sqrlem16 $p |- (  C < ( ( A - ( B x. B ) ) /
                          ( ( ( 1 + 1 ) + 1 ) x. B ) ) ->
                          ( ( B + C ) x. ( B + C ) ) < A ) $=
            cC cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co
            cdiv co clt wbr c1 c1 caddc co c1 caddc co cB cC cmul co cmul co cB
            cB cmul co caddc co cA clt wbr cB cC caddc co cB cC caddc co cmul
            co cA clt wbr c1 c1 caddc co c1 caddc co cB cmul co cC cmul co c1
            c1 caddc co c1 caddc co cB cmul co cA cB cB cmul co cmin co c1 c1
            caddc co c1 caddc co cB cmul co cdiv co cmul co clt wbr c1 c1 caddc
            co c1 caddc co cB cC cmul co cmul co cA cB cB cmul co cmin co clt
            wbr cC cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul
            co cdiv co clt wbr c1 c1 caddc co c1 caddc co cB cC cmul co cmul co
            cB cB cmul co caddc co cA clt wbr c1 c1 caddc co c1 caddc co cB
            cmul co cC cmul co c1 c1 caddc co c1 caddc co cB cC cmul co cmul co
            c1 c1 caddc co c1 caddc co cB cmul co cA cB cB cmul co cmin co c1
            c1 caddc co c1 caddc co cB cmul co cdiv co cmul co cA cB cB cmul co
            cmin co clt c1 c1 caddc co c1 caddc co cB cC c1 c1 caddc co c1
            caddc co c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re readdcli
            recni cB sqrlem15.3 recni cC sqrlem15.5 recni mulassi cA cB cB cmul
            co cmin co c1 c1 caddc co c1 caddc co cB cmul co cA cB cB cmul co
            cmin co cA cB cB cmul co sqrlem1.1 cB cB sqrlem15.3 sqrlem15.3
            remulcli resubcli recni c1 c1 caddc co c1 caddc co cB cmul co c1 c1
            caddc co c1 caddc co cB c1 c1 caddc co c1 c1 c1 1re 1re readdcli
            1re readdcli sqrlem15.3 remulcli recni c1 c1 caddc co c1 caddc co
            cB c1 c1 caddc co c1 caddc co c1 c1 caddc co c1 c1 c1 1re 1re
            readdcli 1re readdcli recni cB sqrlem15.3 recni c1 c1 caddc co c1
            caddc co c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re readdcli c1
            c1 caddc co c1 c1 c1 1re 1re readdcli 1re c1 c1 1re 1re lt01 lt01
            addgt0ii lt01 addgt0ii gt0ne0ii cB sqrlem15.3 sqrlem15.4 gt0ne0ii
            muln0i divcan2i breq12i cc0 c1 c1 caddc co c1 caddc co cB cmul co
            clt wbr cC cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB
            cmul co cdiv co clt wbr c1 c1 caddc co c1 caddc co cB cmul co cC
            cmul co c1 c1 caddc co c1 caddc co cB cmul co cA cB cB cmul co cmin
            co c1 c1 caddc co c1 caddc co cB cmul co cdiv co cmul co clt wbr wb
            c1 c1 caddc co c1 caddc co cB c1 c1 caddc co c1 c1 c1 1re 1re
            readdcli 1re readdcli sqrlem15.3 c1 c1 caddc co c1 c1 c1 1re 1re
            readdcli 1re c1 c1 1re 1re lt01 lt01 addgt0ii lt01 addgt0ii
            sqrlem15.4 mulgt0ii cC cA cB cB cmul co cmin co c1 c1 caddc co c1
            caddc co cB cmul co cdiv co c1 c1 caddc co c1 caddc co cB cmul co
            sqrlem15.5 cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB
            cmul co cA cB cB cmul co sqrlem1.1 cB cB sqrlem15.3 sqrlem15.3
            remulcli resubcli c1 c1 caddc co c1 caddc co cB c1 c1 caddc co c1
            c1 c1 1re 1re readdcli 1re readdcli sqrlem15.3 remulcli c1 c1 caddc
            co c1 caddc co cB c1 c1 caddc co c1 caddc co c1 c1 caddc co c1 c1
            c1 1re 1re readdcli 1re readdcli recni cB sqrlem15.3 recni c1 c1
            caddc co c1 caddc co c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re
            readdcli c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re c1 c1 1re 1re
            lt01 lt01 addgt0ii lt01 addgt0ii gt0ne0ii cB sqrlem15.3 sqrlem15.4
            gt0ne0ii muln0i redivcli c1 c1 caddc co c1 caddc co cB c1 c1 caddc
            co c1 c1 c1 1re 1re readdcli 1re readdcli sqrlem15.3 remulcli
            ltmul2i ax-mp c1 c1 caddc co c1 caddc co cB cC cmul co cmul co cB
            cB cmul co cA c1 c1 caddc co c1 caddc co cB cC cmul co c1 c1 caddc
            co c1 c1 c1 1re 1re readdcli 1re readdcli cB cC sqrlem15.3
            sqrlem15.5 remulcli remulcli cB cB sqrlem15.3 sqrlem15.3 remulcli
            sqrlem1.1 ltaddsubi 3bitr4i cB cC caddc co cB cC caddc co cmul co
            c1 c1 caddc co c1 caddc co cB cC cmul co cmul co cB cB cmul co
            caddc co clt wbr c1 c1 caddc co c1 caddc co cB cC cmul co cmul co
            cB cB cmul co caddc co cA clt wbr cB cC caddc co cB cC caddc co
            cmul co cA clt wbr cB cB cmul co cC cC cmul co caddc co cB cC cmul
            co cB cC cmul co caddc co caddc co cB cB cmul co cC cB cmul co
            caddc co cB cC cmul co cB cC cmul co caddc co caddc co cB cC caddc
            co cB cC caddc co cmul co c1 c1 caddc co c1 caddc co cB cC cmul co
            cmul co cB cB cmul co caddc co clt cB cB cmul co cC cC cmul co
            caddc co cB cB cmul co cC cB cmul co caddc co clt wbr cB cB cmul co
            cC cC cmul co caddc co cB cC cmul co cB cC cmul co caddc co caddc
            co cB cB cmul co cC cB cmul co caddc co cB cC cmul co cB cC cmul co
            caddc co caddc co clt wbr cC cC cmul co cC cB cmul co clt wbr cB cB
            cmul co cC cC cmul co caddc co cB cB cmul co cC cB cmul co caddc co
            clt wbr cC cB clt wbr cC cC cmul co cC cB cmul co clt wbr
            sqrlem16.7 cc0 cC clt wbr cC cB clt wbr cC cC cmul co cC cB cmul co
            clt wbr wb sqrlem15.6 cC cB cC sqrlem15.5 sqrlem15.3 sqrlem15.5
            ltmul2i ax-mp mpbi cC cC cmul co cC cB cmul co cB cB cmul co cC cC
            sqrlem15.5 sqrlem15.5 remulcli cC cB sqrlem15.5 sqrlem15.3 remulcli
            cB cB sqrlem15.3 sqrlem15.3 remulcli ltadd2i mpbi cB cB cmul co cC
            cC cmul co caddc co cB cB cmul co cC cB cmul co caddc co cB cC cmul
            co cB cC cmul co caddc co cB cB cmul co cC cC cmul co cB cB
            sqrlem15.3 sqrlem15.3 remulcli cC cC sqrlem15.5 sqrlem15.5 remulcli
            readdcli cB cB cmul co cC cB cmul co cB cB sqrlem15.3 sqrlem15.3
            remulcli cC cB sqrlem15.5 sqrlem15.3 remulcli readdcli cB cC cmul
            co cB cC cmul co cB cC sqrlem15.3 sqrlem15.5 remulcli cB cC
            sqrlem15.3 sqrlem15.5 remulcli readdcli ltadd1i mpbi cB cC cB cC cB
            sqrlem15.3 recni cC sqrlem15.5 recni cB sqrlem15.3 recni cC
            sqrlem15.5 recni muladdi cC cB cmul co cB cC cmul co cB cC cmul co
            caddc co caddc co cB cB cmul co caddc co cB cB cmul co cC cB cmul
            co cB cC cmul co cB cC cmul co caddc co caddc co caddc co c1 c1
            caddc co c1 caddc co cB cC cmul co cmul co cB cB cmul co caddc co
            cB cB cmul co cC cB cmul co caddc co cB cC cmul co cB cC cmul co
            caddc co caddc co cC cB cmul co cB cC cmul co cB cC cmul co caddc
            co caddc co cB cB cmul co cC cB cmul co cB cC cmul co cB cC cmul co
            caddc co caddc co cC cB cmul co cB cC cmul co cB cC cmul co caddc
            co cC cB sqrlem15.5 sqrlem15.3 remulcli cB cC cmul co cB cC cmul co
            cB cC sqrlem15.3 sqrlem15.5 remulcli cB cC sqrlem15.3 sqrlem15.5
            remulcli readdcli readdcli recni cB cB cmul co cB cB sqrlem15.3
            sqrlem15.3 remulcli recni addcomi c1 c1 caddc co c1 caddc co cB cC
            cmul co cmul co cC cB cmul co cB cC cmul co cB cC cmul co caddc co
            caddc co cB cB cmul co caddc c1 c1 caddc co c1 caddc co cB cC cmul
            co cmul co c1 c1 caddc co cB cC cmul co cmul co c1 cB cC cmul co
            cmul co caddc co cB cC cmul co cB cC cmul co caddc co cC cB cmul co
            caddc co cC cB cmul co cB cC cmul co cB cC cmul co caddc co caddc
            co c1 c1 caddc co c1 cB cC cmul co c1 c1 caddc co c1 c1 1re 1re
            readdcli recni ax1cn cB cC cmul co cB cC sqrlem15.3 sqrlem15.5
            remulcli recni adddiri c1 c1 caddc co cB cC cmul co cmul co cB cC
            cmul co cB cC cmul co caddc co c1 cB cC cmul co cmul co cC cB cmul
            co caddc cB cC cmul co cB cC cmul co cB cC sqrlem15.3 sqrlem15.5
            remulcli recni 1p1timesi c1 cB cC cmul co cmul co cB cC cmul co cC
            cB cmul co cB cC cmul co cB cC cmul co cB cC sqrlem15.3 sqrlem15.5
            remulcli recni mulid2i cB cC cB sqrlem15.3 recni cC sqrlem15.5
            recni mulcomi eqtri opreq12i cB cC cmul co cB cC cmul co caddc co
            cC cB cmul co cB cC cmul co cB cC cmul co caddc co cB cC cmul co cB
            cC cmul co cB cC sqrlem15.3 sqrlem15.5 remulcli cB cC sqrlem15.3
            sqrlem15.5 remulcli readdcli recni cC cB cmul co cC cB sqrlem15.5
            sqrlem15.3 remulcli recni addcomi 3eqtri opreq1i cB cB cmul co cC
            cB cmul co cB cC cmul co cB cC cmul co caddc co cB cB cmul co cB cB
            sqrlem15.3 sqrlem15.3 remulcli recni cC cB cmul co cC cB sqrlem15.5
            sqrlem15.3 remulcli recni cB cC cmul co cB cC cmul co caddc co cB
            cC cmul co cB cC cmul co cB cC sqrlem15.3 sqrlem15.5 remulcli cB cC
            sqrlem15.3 sqrlem15.5 remulcli readdcli recni addassi 3eqtr4i
            3brtr4i cB cC caddc co cB cC caddc co cmul co c1 c1 caddc co c1
            caddc co cB cC cmul co cmul co cB cB cmul co caddc co cA cB cC
            caddc co cB cC caddc co cB cC sqrlem15.3 sqrlem15.5 readdcli cB cC
            sqrlem15.3 sqrlem15.5 readdcli remulcli c1 c1 caddc co c1 caddc co
            cB cC cmul co cmul co cB cB cmul co c1 c1 caddc co c1 caddc co cB
            cC cmul co c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re readdcli cB
            cC sqrlem15.3 sqrlem15.5 remulcli remulcli cB cB sqrlem15.3
            sqrlem15.3 remulcli readdcli sqrlem1.1 lttri mpan sylbi $.
            $( [26-May-1999] $)

          ${
            sqrlem17.8 $e |- S =
                             { x e. RR | ( 0 <_ x /\ ( x x. x ) <_ A ) } $.
            $( Lemma for square root theorem. $)
            sqrlem17 $p |- (  C < ( ( A - ( B x. B ) ) /
                          ( ( ( 1 + 1 ) + 1 ) x. B ) ) ->
                          ( B + C ) e. S ) $=
              cB cC caddc co cr wcel cc0 cB cC caddc co clt wbr cB cC caddc co
              cB cC caddc co cmul co cA clt wbr wa cB cC caddc co cS wcel cC cA
              cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co cdiv
              co clt wbr vx cA cB cC caddc co cS sqrlem1.1 sqrlem1.2 sqrlem17.8
              sqrlem5 cB cC sqrlem15.3 sqrlem15.5 readdcli cC cA cB cB cmul co
              cmin co c1 c1 caddc co c1 caddc co cB cmul co cdiv co clt wbr cB
              cC caddc co cB cC caddc co cmul co cA clt wbr cc0 cB cC caddc co
              clt wbr cA cB cC sqrlem1.1 sqrlem1.2 sqrlem15.3 sqrlem15.4
              sqrlem15.5 sqrlem15.6 sqrlem16.7 sqrlem16 cB cC sqrlem15.3
              sqrlem15.5 sqrlem15.4 sqrlem15.6 addgt0ii jctil sylancr $.
              $( [26-May-1999] $)

            $( Lemma for square root theorem. $)
            sqrlem18 $p |- (  C < ( ( A - ( B x. B ) ) /
                          ( ( ( 1 + 1 ) + 1 ) x. B ) ) ->
                          -. B = sup ( S , RR , < ) ) $=
              cC cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co
              cdiv co clt wbr cB cS cr clt csup wceq cB cB cC caddc co clt wbr
              cA cB cC sqrlem1.1 sqrlem1.2 sqrlem15.3 sqrlem15.4 sqrlem15.5
              sqrlem15.6 sqrlem15 cB cS cr clt csup wceq cB cB cC caddc co clt
              wbr wn cS cr clt csup cB cC caddc co clt wbr wn cC cA cB cB cmul
              co cmin co c1 c1 caddc co c1 caddc co cB cmul co cdiv co clt wbr
              cB cS cr clt csup wceq cB cB cC caddc co clt wbr cS cr clt csup
              cB cC caddc co clt wbr cB cS cr clt csup cB cC caddc co clt breq1
              notbid cC cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB
              cmul co cdiv co clt wbr cB cC caddc co cS wcel cS cr clt csup cB
              cC caddc co clt wbr wn vx cA cB cC cS sqrlem1.1 sqrlem1.2
              sqrlem15.3 sqrlem15.4 sqrlem15.5 sqrlem15.6 sqrlem16.7 sqrlem17.8
              sqrlem17 vx vy vz cr cS cB cC caddc co clt ltso cS cr wss cS c0
              wne vy cv vx cv clt wbr vy cS wral vx cr wrex w3a vx cv vy cv clt
              wbr wn vy cS wral vy cv vx cv clt wbr vy cv vz cv clt wbr vz cS
              wrex wi vy cr wral wa vx cr wrex vx vy cA cS sqrlem1.1 sqrlem1.2
              sqrlem17.8 sqrlem6 vx vy vz cS axsup ax-mp supubi syl syl5cbir
              mt2i $.
              $( [26-May-1999] $)

          $}
        $}
      $}

      ${
        sqrlem19.5 $e |- ( B x. B ) < A $.
        $( Lemma for square root theorem. $)
        sqrlem19 $p |- 0 < ( ( A - ( B x. B ) ) /
                      ( ( ( 1 + 1 ) + 1 ) x. B ) ) $=
          cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co cA cB
          cB cmul co sqrlem1.1 cB cB sqrlem15.3 sqrlem15.3 remulcli resubcli c1
          c1 caddc co c1 caddc co cB c1 c1 caddc co c1 c1 c1 1re 1re readdcli
          1re readdcli sqrlem15.3 remulcli cc0 cB cB cmul co caddc co cA clt
          wbr cc0 cA cB cB cmul co cmin co clt wbr cc0 cB cB cmul co caddc co
          cB cB cmul co cA clt cB cB cmul co cB cB cmul co cB cB sqrlem15.3
          sqrlem15.3 remulcli recni addid2i sqrlem19.5 eqbrtri cc0 cB cB cmul
          co cA 0re cB cB sqrlem15.3 sqrlem15.3 remulcli sqrlem1.1 ltaddsubi
          mpbi c1 c1 caddc co c1 caddc co cB c1 c1 caddc co c1 c1 c1 1re 1re
          readdcli 1re readdcli sqrlem15.3 c1 c1 caddc co c1 c1 c1 1re 1re
          readdcli 1re c1 c1 1re 1re lt01 lt01 addgt0ii lt01 addgt0ii
          sqrlem15.4 mulgt0ii divgt0ii $.
          $( [19-May-1999] $)

        ${
          sqrlem20.6 $e |- S =
                             { x e. RR | ( 0 <_ x /\ ( x x. x ) <_ A ) } $.
          $( Lemma for square root theorem. $)
          sqrlem20 $p |- -. B = sup ( S , RR , < ) $=
            cc0 vw cv clt wbr vw cv cB clt wbr vw cv cA cB cB cmul co cmin co
            c1 c1 caddc co c1 caddc co cB cmul co cdiv co clt wbr wa wa vw cr
            wrex cB cS cr clt csup wceq wn vw cB cA cB cB cmul co cmin co c1 c1
            caddc co c1 caddc co cB cmul co cdiv co sqrlem15.3 cA cB cB cmul co
            cmin co c1 c1 caddc co c1 caddc co cB cmul co cA cB cB cmul co
            sqrlem1.1 cB cB sqrlem15.3 sqrlem15.3 remulcli resubcli c1 c1 caddc
            co c1 caddc co cB c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re
            readdcli sqrlem15.3 remulcli c1 c1 caddc co c1 caddc co cB c1 c1
            caddc co c1 caddc co c1 c1 caddc co c1 c1 c1 1re 1re readdcli 1re
            readdcli recni cB sqrlem15.3 recni c1 c1 caddc co c1 caddc co c1 c1
            caddc co c1 c1 c1 1re 1re readdcli 1re readdcli c1 c1 caddc co c1
            c1 c1 1re 1re readdcli 1re c1 c1 1re 1re lt01 lt01 addgt0ii lt01
            addgt0ii gt0ne0ii cB sqrlem15.3 sqrlem15.4 gt0ne0ii muln0i redivcli
            sqrlem15.4 cA cB sqrlem1.1 sqrlem1.2 sqrlem15.3 sqrlem15.4
            sqrlem19.5 sqrlem19 posexi cc0 vw cv clt wbr vw cv cB clt wbr vw cv
            cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co cdiv
            co clt wbr wa wa cB cS cr clt csup wceq wn vw cr vw cv cr wcel cc0
            vw cv clt wbr vw cv cB clt wbr vw cv cA cB cB cmul co cmin co c1 c1
            caddc co c1 caddc co cB cmul co cdiv co clt wbr cB cS cr clt csup
            wceq wn vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr vw cv cA
            cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co cdiv co
            clt wbr cB cS cr clt csup wceq wn wi vw cv cr wcel cc0 vw cv clt
            wbr vw cv cB clt wbr w3a vw cv cA cB cB cmul co cmin co c1 c1 caddc
            co c1 caddc co cB cmul co cdiv co clt wbr cB cS cr clt csup wceq wn
            wi vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1
            c1 caddc co cdiv co cif cA cB cB cmul co cmin co c1 c1 caddc co c1
            caddc co cB cmul co cdiv co clt wbr cB cS cr clt csup wceq wn wi vw
            cv cB c1 c1 caddc co cdiv co vw cv vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif wceq vw cv
            cA cB cB cmul co cmin co c1 c1 caddc co c1 caddc co cB cmul co cdiv
            co clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw
            cv cB c1 c1 caddc co cdiv co cif cA cB cB cmul co cmin co c1 c1
            caddc co c1 caddc co cB cmul co cdiv co clt wbr cB cS cr clt csup
            wceq wn vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a
            vw cv cB c1 c1 caddc co cdiv co cif cA cB cB cmul co cmin co c1 c1
            caddc co c1 caddc co cB cmul co cdiv co clt breq1 imbi1d vx cA cB
            vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1
            caddc co cdiv co cif cS sqrlem1.1 sqrlem1.2 sqrlem15.3 sqrlem15.4
            vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1
            caddc co cdiv co cif cr wcel cc0 vw cv cr wcel cc0 vw cv clt wbr vw
            cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif clt wbr vw cv
            cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc
            co cdiv co cif cB clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB
            clt wbr w3a vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw
            cv cB c1 c1 caddc co cdiv co cif cr wcel cc0 vw cv cr wcel cc0 vw
            cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif
            clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv
            cB c1 c1 caddc co cdiv co cif cB clt wbr w3a cB c1 c1 caddc co cdiv
            co cr wcel cc0 cB c1 c1 caddc co cdiv co clt wbr cB c1 c1 caddc co
            cdiv co cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co vw cv vw cv
            cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc
            co cdiv co cif wceq vw cv cr wcel vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr wcel
            cc0 vw cv clt wbr cc0 vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt
            wbr w3a vw cv cB c1 c1 caddc co cdiv co cif clt wbr vw cv cB clt
            wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB
            c1 c1 caddc co cdiv co cif cB clt wbr vw cv vw cv cr wcel cc0 vw cv
            clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr
            eleq1 vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw
            cv cB c1 c1 caddc co cdiv co cif cc0 clt breq2 vw cv vw cv cr wcel
            cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv
            co cif cB clt breq1 3anbi123d cB c1 c1 caddc co cdiv co vw cv cr
            wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co
            cdiv co cif wceq cB c1 c1 caddc co cdiv co cr wcel vw cv cr wcel
            cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv
            co cif cr wcel cc0 cB c1 c1 caddc co cdiv co clt wbr cc0 vw cv cr
            wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co
            cdiv co cif clt wbr cB c1 c1 caddc co cdiv co cB clt wbr vw cv cr
            wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co
            cdiv co cif cB clt wbr cB c1 c1 caddc co cdiv co vw cv cr wcel cc0
            vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co
            cif cr eleq1 cB c1 c1 caddc co cdiv co vw cv cr wcel cc0 vw cv clt
            wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cc0
            clt breq2 cB c1 c1 caddc co cdiv co vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt
            breq1 3anbi123d cB c1 c1 caddc co cdiv co cr wcel cc0 cB c1 c1
            caddc co cdiv co clt wbr cB c1 c1 caddc co cdiv co cB clt wbr cB c1
            c1 caddc co sqrlem15.3 c1 c1 1re 1re readdcli c1 c1 caddc co c1 c1
            1re 1re readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii redivcli
            cB c1 c1 caddc co sqrlem15.3 c1 c1 1re 1re readdcli sqrlem15.4 c1
            c1 1re 1re lt01 lt01 addgt0ii divgt0ii cc0 cB clt wbr cB c1 c1
            caddc co cdiv co cB clt wbr sqrlem15.4 cB sqrlem15.3 halfposi mpbi
            3pm3.2i elimhyp 3simp1i vw cv cr wcel cc0 vw cv clt wbr vw cv cB
            clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr wcel cc0 vw cv
            cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc
            co cdiv co cif clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt
            wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt wbr vw cv cr
            wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cr wcel cc0 vw cv
            clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr
            wcel cc0 vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv
            cB c1 c1 caddc co cdiv co cif clt wbr vw cv cr wcel cc0 vw cv clt
            wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt
            wbr w3a cB c1 c1 caddc co cdiv co cr wcel cc0 cB c1 c1 caddc co
            cdiv co clt wbr cB c1 c1 caddc co cdiv co cB clt wbr w3a vw cv cB
            c1 c1 caddc co cdiv co vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv
            cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif wceq vw cv cr
            wcel vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB
            c1 c1 caddc co cdiv co cif cr wcel cc0 vw cv clt wbr cc0 vw cv cr
            wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co
            cdiv co cif clt wbr vw cv cB clt wbr vw cv cr wcel cc0 vw cv clt
            wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt
            wbr vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw
            cv cB c1 c1 caddc co cdiv co cif cr eleq1 vw cv vw cv cr wcel cc0
            vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co
            cif cc0 clt breq2 vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv cB
            clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt breq1
            3anbi123d cB c1 c1 caddc co cdiv co vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif wceq cB c1
            c1 caddc co cdiv co cr wcel vw cv cr wcel cc0 vw cv clt wbr vw cv
            cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr wcel cc0 cB
            c1 c1 caddc co cdiv co clt wbr cc0 vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif clt wbr cB
            c1 c1 caddc co cdiv co cB clt wbr vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt wbr
            cB c1 c1 caddc co cdiv co vw cv cr wcel cc0 vw cv clt wbr vw cv cB
            clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr eleq1 cB c1 c1
            caddc co cdiv co vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr
            w3a vw cv cB c1 c1 caddc co cdiv co cif cc0 clt breq2 cB c1 c1
            caddc co cdiv co vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr
            w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt breq1 3anbi123d cB
            c1 c1 caddc co cdiv co cr wcel cc0 cB c1 c1 caddc co cdiv co clt
            wbr cB c1 c1 caddc co cdiv co cB clt wbr cB c1 c1 caddc co
            sqrlem15.3 c1 c1 1re 1re readdcli c1 c1 caddc co c1 c1 1re 1re
            readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii redivcli cB c1
            c1 caddc co sqrlem15.3 c1 c1 1re 1re readdcli sqrlem15.4 c1 c1 1re
            1re lt01 lt01 addgt0ii divgt0ii cc0 cB clt wbr cB c1 c1 caddc co
            cdiv co cB clt wbr sqrlem15.4 cB sqrlem15.3 halfposi mpbi 3pm3.2i
            elimhyp 3simp2i vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr
            w3a vw cv cB c1 c1 caddc co cdiv co cif cr wcel cc0 vw cv cr wcel
            cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv
            co cif clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a
            vw cv cB c1 c1 caddc co cdiv co cif cB clt wbr vw cv cr wcel cc0 vw
            cv clt wbr vw cv cB clt wbr w3a vw cv cr wcel cc0 vw cv clt wbr vw
            cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cr wcel cc0
            vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1
            caddc co cdiv co cif clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv
            cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt wbr w3a
            cB c1 c1 caddc co cdiv co cr wcel cc0 cB c1 c1 caddc co cdiv co clt
            wbr cB c1 c1 caddc co cdiv co cB clt wbr w3a vw cv cB c1 c1 caddc
            co cdiv co vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr
            w3a vw cv cB c1 c1 caddc co cdiv co cif wceq vw cv cr wcel vw cv cr
            wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co
            cdiv co cif cr wcel cc0 vw cv clt wbr cc0 vw cv cr wcel cc0 vw cv
            clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif
            clt wbr vw cv cB clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB
            clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cB clt wbr vw cv vw
            cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1
            caddc co cdiv co cif cr eleq1 vw cv vw cv cr wcel cc0 vw cv clt wbr
            vw cv cB clt wbr w3a vw cv cB c1 c1 caddc co cdiv co cif cc0 clt
            breq2 vw cv vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw
            cv cB c1 c1 caddc co cdiv co cif cB clt breq1 3anbi123d cB c1 c1
            caddc co cdiv co vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr
            w3a vw cv cB c1 c1 caddc co cdiv co cif wceq cB c1 c1 caddc co cdiv
            co cr wcel vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw
            cv cB c1 c1 caddc co cdiv co cif cr wcel cc0 cB c1 c1 caddc co cdiv
            co clt wbr cc0 vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a
            vw cv cB c1 c1 caddc co cdiv co cif clt wbr cB c1 c1 caddc co cdiv
            co cB clt wbr vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a
            vw cv cB c1 c1 caddc co cdiv co cif cB clt wbr cB c1 c1 caddc co
            cdiv co vw cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv
            cB c1 c1 caddc co cdiv co cif cr eleq1 cB c1 c1 caddc co cdiv co vw
            cv cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1
            caddc co cdiv co cif cc0 clt breq2 cB c1 c1 caddc co cdiv co vw cv
            cr wcel cc0 vw cv clt wbr vw cv cB clt wbr w3a vw cv cB c1 c1 caddc
            co cdiv co cif cB clt breq1 3anbi123d cB c1 c1 caddc co cdiv co cr
            wcel cc0 cB c1 c1 caddc co cdiv co clt wbr cB c1 c1 caddc co cdiv
            co cB clt wbr cB c1 c1 caddc co sqrlem15.3 c1 c1 1re 1re readdcli
            c1 c1 caddc co c1 c1 1re 1re readdcli c1 c1 1re 1re lt01 lt01
            addgt0ii gt0ne0ii redivcli cB c1 c1 caddc co sqrlem15.3 c1 c1 1re
            1re readdcli sqrlem15.4 c1 c1 1re 1re lt01 lt01 addgt0ii divgt0ii
            cc0 cB clt wbr cB c1 c1 caddc co cdiv co cB clt wbr sqrlem15.4 cB
            sqrlem15.3 halfposi mpbi 3pm3.2i elimhyp 3simp3i sqrlem20.6
            sqrlem18 dedth 3exp imp4d r19.23aiv ax-mp $.
            $( [26-May-1999] $)
        $}
      $}
    $}

    ${
      sqrlem21.3 $e |- S = { x e. RR | ( 0 <_ x /\ ( x x. x ) <_ A ) } $.
      sqrlem21.4 $e |- B = sup ( S , RR , < ) $.
      $( Lemma for square root theorem. $)
      sqrlem21 $p |- -. A < ( B x. B ) $=
        cA cB cB cmul co clt wbr cB cS cr clt csup wceq sqrlem21.4 cA cB cB
        cmul co clt wbr cB cS cr clt csup wceq wn cA cB cB cmul co clt wbr cB
        c1 cA caddc co cif cS cr clt csup wceq wn cB c1 cA caddc co cB cA cB cB
        cmul co clt wbr cB c1 cA caddc co cif wceq cB cS cr clt csup wceq cA cB
        cB cmul co clt wbr cB c1 cA caddc co cif cS cr clt csup wceq cB cA cB
        cB cmul co clt wbr cB c1 cA caddc co cif cS cr clt csup eqeq1 notbid vx
        cA cA cB cB cmul co clt wbr cB c1 cA caddc co cif cA cB cB cmul co clt
        wbr cB c1 cA caddc co cif cA cA cB cB cmul co clt wbr cB c1 cA caddc co
        cif cdiv co caddc co c1 c1 caddc co cdiv co cS sqrlem1.1 sqrlem1.2 cA
        cB cB cmul co clt wbr cB c1 cA caddc co cr vx cA cB cS sqrlem1.1
        sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem7 c1 cA 1re sqrlem1.1 readdcli
        keepel cA cB cB cmul co clt wbr cB cA cB cdiv co caddc co c1 c1 caddc
        co cdiv co cr wcel c1 cA caddc co cA c1 cA caddc co cdiv co caddc co c1
        c1 caddc co cdiv co cr wcel cA cB cB cmul co clt wbr cB c1 cA caddc co
        cif cA cA cB cB cmul co clt wbr cB c1 cA caddc co cif cdiv co caddc co
        c1 c1 caddc co cdiv co cr wcel cB c1 cA caddc co cB cA cB cB cmul co
        clt wbr cB c1 cA caddc co cif wceq cB cA cB cdiv co caddc co c1 c1
        caddc co cdiv co cA cB cB cmul co clt wbr cB c1 cA caddc co cif cA cA
        cB cB cmul co clt wbr cB c1 cA caddc co cif cdiv co caddc co c1 c1
        caddc co cdiv co cr cB cA cB cB cmul co clt wbr cB c1 cA caddc co cif
        wceq cB cA cB cdiv co caddc co cA cB cB cmul co clt wbr cB c1 cA caddc
        co cif cA cA cB cB cmul co clt wbr cB c1 cA caddc co cif cdiv co caddc
        co c1 c1 caddc co cdiv cB cA cB cB cmul co clt wbr cB c1 cA caddc co
        cif wceq cB cA cB cB cmul co clt wbr cB c1 cA caddc co cif cA cB cdiv
        co cA cA cB cB cmul co clt wbr cB c1 cA caddc co cif cdiv co caddc cB
        cA cB cB cmul co clt wbr cB c1 cA caddc co cif wceq id cB cA cB cB cmul
        co clt wbr cB c1 cA caddc co cif cA cdiv opreq2 opreq12d opreq1d eleq1d
        c1 cA caddc co cA cB cB cmul co clt wbr cB c1 cA caddc co cif wceq c1
        cA caddc co cA c1 cA caddc co cdiv co caddc co c1 c1 caddc co cdiv co
        cA cB cB cmul co clt wbr cB c1 cA caddc co cif cA cA cB cB cmul co clt
        wbr cB c1 cA caddc co cif cdiv co caddc co c1 c1 caddc co cdiv co cr c1
        cA caddc co cA cB cB cmul co clt wbr cB c1 cA caddc co cif wceq c1 cA
        caddc co cA c1 cA caddc co cdiv co caddc co cA cB cB cmul co clt wbr cB
        c1 cA caddc co cif cA cA cB cB cmul co clt wbr cB c1 cA caddc co cif
        cdiv co caddc co c1 c1 caddc co cdiv c1 cA caddc co cA cB cB cmul co
        clt wbr cB c1 cA caddc co cif wceq c1 cA caddc co cA cB cB cmul co clt
        wbr cB c1 cA caddc co cif cA c1 cA caddc co cdiv co cA cA cB cB cmul co
        clt wbr cB c1 cA caddc co cif cdiv co caddc c1 cA caddc co cA cB cB
        cmul co clt wbr cB c1 cA caddc co cif wceq id c1 cA caddc co cA cB cB
        cmul co clt wbr cB c1 cA caddc co cif cA cdiv opreq2 opreq12d opreq1d
        eleq1d cB cA cB cdiv co caddc co c1 c1 caddc co cB cA cB cdiv co vx cA
        cB cS sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem7 cA cB sqrlem1.1
        vx cA cB cS sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem7 cB vx cA
        cB cS sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem7 vx cA cB cS
        sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem8 gt0ne0ii redivcli
        readdcli c1 c1 1re 1re readdcli c1 c1 caddc co c1 c1 1re 1re readdcli
        c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii redivcli c1 cA caddc co cA c1
        cA caddc co cdiv co caddc co c1 c1 caddc co c1 cA caddc co cA c1 cA
        caddc co cdiv co c1 cA 1re sqrlem1.1 readdcli cA c1 cA caddc co
        sqrlem1.1 c1 cA 1re sqrlem1.1 readdcli c1 cA caddc co c1 cA 1re
        sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01 sqrlem1.2 addgt0ii gt0ne0ii
        redivcli readdcli c1 c1 1re 1re readdcli c1 c1 caddc co c1 c1 1re 1re
        readdcli c1 c1 1re 1re lt01 lt01 addgt0ii gt0ne0ii redivcli keephyp cA
        cB cB cmul co clt wbr cc0 cB clt wbr cc0 c1 cA caddc co clt wbr cc0 cA
        cB cB cmul co clt wbr cB c1 cA caddc co cif clt wbr cB c1 cA caddc co
        cB cA cB cB cmul co clt wbr cB c1 cA caddc co cif cc0 clt breq2 c1 cA
        caddc co cA cB cB cmul co clt wbr cB c1 cA caddc co cif cc0 clt breq2
        vx cA cB cS sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem8 c1 cA 1re
        sqrlem1.1 lt01 sqrlem1.2 addgt0ii keephyp cA cB cB cmul co clt wbr cA
        cA cB cB cmul co clt wbr cB c1 cA caddc co cif cA cB cB cmul co clt wbr
        cB c1 cA caddc co cif cmul co clt wbr cA c1 cA caddc co c1 cA caddc co
        cmul co clt wbr cB c1 cA caddc co cB cA cB cB cmul co clt wbr cB c1 cA
        caddc co cif wceq cB cB cmul co cA cB cB cmul co clt wbr cB c1 cA caddc
        co cif cA cB cB cmul co clt wbr cB c1 cA caddc co cif cmul co cA clt cB
        cA cB cB cmul co clt wbr cB c1 cA caddc co cif wceq cB cB cmul co cA cB
        cB cmul co clt wbr cB c1 cA caddc co cif cA cB cB cmul co clt wbr cB c1
        cA caddc co cif cmul co wceq cB cA cB cB cmul co clt wbr cB c1 cA caddc
        co cif cB cA cB cB cmul co clt wbr cB c1 cA caddc co cif cmul opreq12
        anidms breq2d c1 cA caddc co cA cB cB cmul co clt wbr cB c1 cA caddc co
        cif wceq c1 cA caddc co c1 cA caddc co cmul co cA cB cB cmul co clt wbr
        cB c1 cA caddc co cif cA cB cB cmul co clt wbr cB c1 cA caddc co cif
        cmul co cA clt c1 cA caddc co cA cB cB cmul co clt wbr cB c1 cA caddc
        co cif wceq c1 cA caddc co c1 cA caddc co cmul co cA cB cB cmul co clt
        wbr cB c1 cA caddc co cif cA cB cB cmul co clt wbr cB c1 cA caddc co
        cif cmul co wceq c1 cA caddc co cA cB cB cmul co clt wbr cB c1 cA caddc
        co cif c1 cA caddc co cA cB cB cmul co clt wbr cB c1 cA caddc co cif
        cmul opreq12 anidms breq2d cA sqrlem1.1 sqrlem1.2 sqrlem1 elimhyp cA cB
        cB cmul co clt wbr cB c1 cA caddc co cif cA cA cB cB cmul co clt wbr cB
        c1 cA caddc co cif cdiv co caddc co c1 c1 caddc co cdiv co eqid
        sqrlem21.3 sqrlem14 dedth mt2 $.
        $( [24-May-1999] $)

      $( Lemma for square root theorem. $)
      sqrlem22 $p |- -. ( B x. B ) < A $=
        cB cB cmul co cA clt wbr cB cS cr clt csup wceq sqrlem21.4 cB cB cmul
        co cA clt wbr cB cS cr clt csup wceq wn cB cB cmul co cA clt wbr cB cA
        c1 cA caddc co cdiv co cif cS cr clt csup wceq wn cB cA c1 cA caddc co
        cdiv co cB cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv co cif
        wceq cB cS cr clt csup wceq cB cB cmul co cA clt wbr cB cA c1 cA caddc
        co cdiv co cif cS cr clt csup wceq cB cB cB cmul co cA clt wbr cB cA c1
        cA caddc co cdiv co cif cS cr clt csup eqeq1 notbid vx cA cB cB cmul co
        cA clt wbr cB cA c1 cA caddc co cdiv co cif cS sqrlem1.1 sqrlem1.2 cB
        cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv co cr vx cA cB cS
        sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem7 cA c1 cA caddc co
        sqrlem1.1 c1 cA 1re sqrlem1.1 readdcli c1 cA caddc co c1 cA 1re
        sqrlem1.1 readdcli c1 cA 1re sqrlem1.1 lt01 sqrlem1.2 addgt0ii gt0ne0ii
        redivcli keepel cB cB cmul co cA clt wbr cc0 cB clt wbr cc0 cA c1 cA
        caddc co cdiv co clt wbr cc0 cB cB cmul co cA clt wbr cB cA c1 cA caddc
        co cdiv co cif clt wbr cB cA c1 cA caddc co cdiv co cB cB cB cmul co cA
        clt wbr cB cA c1 cA caddc co cdiv co cif cc0 clt breq2 cA c1 cA caddc
        co cdiv co cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv co cif
        cc0 clt breq2 vx cA cB cS sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4
        sqrlem8 cA sqrlem1.1 sqrlem1.2 sqrlem3 keephyp cB cB cmul co cA clt wbr
        cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv co cif cB cB cmul co
        cA clt wbr cB cA c1 cA caddc co cdiv co cif cmul co cA clt wbr cA c1 cA
        caddc co cdiv co cA c1 cA caddc co cdiv co cmul co cA clt wbr cB cA c1
        cA caddc co cdiv co cB cB cB cmul co cA clt wbr cB cA c1 cA caddc co
        cdiv co cif wceq cB cB cmul co cB cB cmul co cA clt wbr cB cA c1 cA
        caddc co cdiv co cif cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv
        co cif cmul co cA clt cB cB cB cmul co cA clt wbr cB cA c1 cA caddc co
        cdiv co cif wceq cB cB cmul co cB cB cmul co cA clt wbr cB cA c1 cA
        caddc co cdiv co cif cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv
        co cif cmul co wceq cB cB cB cmul co cA clt wbr cB cA c1 cA caddc co
        cdiv co cif cB cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv co
        cif cmul opreq12 anidms breq1d cA c1 cA caddc co cdiv co cB cB cmul co
        cA clt wbr cB cA c1 cA caddc co cdiv co cif wceq cA c1 cA caddc co cdiv
        co cA c1 cA caddc co cdiv co cmul co cB cB cmul co cA clt wbr cB cA c1
        cA caddc co cdiv co cif cB cB cmul co cA clt wbr cB cA c1 cA caddc co
        cdiv co cif cmul co cA clt cA c1 cA caddc co cdiv co cB cB cmul co cA
        clt wbr cB cA c1 cA caddc co cdiv co cif wceq cA c1 cA caddc co cdiv co
        cA c1 cA caddc co cdiv co cmul co cB cB cmul co cA clt wbr cB cA c1 cA
        caddc co cdiv co cif cB cB cmul co cA clt wbr cB cA c1 cA caddc co cdiv
        co cif cmul co wceq cA c1 cA caddc co cdiv co cB cB cmul co cA clt wbr
        cB cA c1 cA caddc co cdiv co cif cA c1 cA caddc co cdiv co cB cB cmul
        co cA clt wbr cB cA c1 cA caddc co cdiv co cif cmul opreq12 anidms
        breq1d cA sqrlem1.1 sqrlem1.2 sqrlem2 elimhyp sqrlem21.3 sqrlem20 dedth
        mt2 $.
        $( [26-May-1999] $)

      $( Lemma for square root theorem. $)
      sqrlem23 $p |- ( B x. B ) = A $=
        cB cB cmul co cA wceq cB cB cmul co cA clt wbr wn cA cB cB cmul co clt
        wbr wn cB cB cmul co cA cB cB vx cA cB cS sqrlem1.1 sqrlem1.2
        sqrlem21.3 sqrlem21.4 sqrlem7 vx cA cB cS sqrlem1.1 sqrlem1.2
        sqrlem21.3 sqrlem21.4 sqrlem7 remulcli sqrlem1.1 lttri3i vx cA cB cS
        sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem22 vx cA cB cS
        sqrlem1.1 sqrlem1.2 sqrlem21.3 sqrlem21.4 sqrlem21 mpbir2an $.
        $( [26-May-1999] $)
    $}

    $( Lemma for square root closure. $)
    sqrlem24 $p |- ( sqr ` A ) e. RR $=
      vy cA cA csqr cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx
      cr crab sqrlem1.1 sqrlem1.2 cc0 vx cv cle wbr vx cv vx cv cmul co cA cle
      wbr wa cc0 vy cv cle wbr vy cv vy cv cmul co cA cle wbr wa vx vy cr vx cv
      vy cv wceq cc0 vx cv cle wbr cc0 vy cv cle wbr vx cv vx cv cmul co cA cle
      wbr vy cv vy cv cmul co cA cle wbr vx cv vy cv cc0 cle breq2 vx cv vy cv
      wceq vx cv vx cv cmul co vy cv vy cv cmul co cA cle vx cv vy cv wceq vx
      cv vx cv cmul co vy cv vy cv cmul co wceq vx cv vy cv vx cv vy cv cmul
      opreq12 anidms breq1d anbi12d cbvrabv cA cr wcel cc0 cA cle wbr cA csqr
      cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab cr clt
      csup wceq sqrlem1.1 cc0 cA 0re sqrlem1.1 sqrlem1.2 ltleii vx cA sqrval
      mp2an sqrlem7 $.
      $( [26-May-1999] $)

    $( The square root of a positive real is positive. $)
    sqrgt0ii $p |- 0 < ( sqr ` A ) $=
      vy cA cA csqr cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx
      cr crab sqrlem1.1 sqrlem1.2 cc0 vx cv cle wbr vx cv vx cv cmul co cA cle
      wbr wa cc0 vy cv cle wbr vy cv vy cv cmul co cA cle wbr wa vx vy cr vx cv
      vy cv wceq cc0 vx cv cle wbr cc0 vy cv cle wbr vx cv vx cv cmul co cA cle
      wbr vy cv vy cv cmul co cA cle wbr vx cv vy cv cc0 cle breq2 vx cv vy cv
      wceq vx cv vx cv cmul co vy cv vy cv cmul co cA cle vx cv vy cv wceq vx
      cv vx cv cmul co vy cv vy cv cmul co wceq vx cv vy cv vx cv vy cv cmul
      opreq12 anidms breq1d anbi12d cbvrabv cA cr wcel cc0 cA cle wbr cA csqr
      cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab cr clt
      csup wceq sqrlem1.1 cc0 cA 0re sqrlem1.1 sqrlem1.2 ltleii vx cA sqrval
      mp2an sqrlem8 $.
      $( [26-May-1999] $)

    $( Lemma for square root theorem. $)
    sqrlem26 $p |- ( ( sqr ` A ) x. ( sqr ` A ) ) = A $=
      vy cA cA csqr cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx
      cr crab sqrlem1.1 sqrlem1.2 cc0 vx cv cle wbr vx cv vx cv cmul co cA cle
      wbr wa cc0 vy cv cle wbr vy cv vy cv cmul co cA cle wbr wa vx vy cr vx cv
      vy cv wceq cc0 vx cv cle wbr cc0 vy cv cle wbr vx cv vx cv cmul co cA cle
      wbr vy cv vy cv cmul co cA cle wbr vx cv vy cv cc0 cle breq2 vx cv vy cv
      wceq vx cv vx cv cmul co vy cv vy cv cmul co cA cle vx cv vy cv wceq vx
      cv vx cv cmul co vy cv vy cv cmul co wceq vx cv vy cv vx cv vy cv cmul
      opreq12 anidms breq1d anbi12d cbvrabv cA cr wcel cc0 cA cle wbr cA csqr
      cfv cc0 vx cv cle wbr vx cv vx cv cmul co cA cle wbr wa vx cr crab cr clt
      csup wceq sqrlem1.1 cc0 cA 0re sqrlem1.1 sqrlem1.2 ltleii vx cA sqrval
      mp2an sqrlem23 $.
      $( [24-May-1999] $)

  $}

  ${
    sqrth.1 $e |- A e. RR $.
    $( Square root theorem.  Theorem I.35 of [Apostol] p. 29.

       (A bit of trivia:  This theorem was added to the database before the
       number ` 2 ` was defined and before exponents were defined.  Thus
       you will see ` ( 1 + 1 ) ` and ` ( x x. x ) ` throughout its lemmas.) $)
    sqrthi $p |- ( 0 <_ A -> ( ( sqr ` A ) x. ( sqr ` A ) ) = A ) $=
      cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cA csqr cfv cA csqr cfv cmul
      co cA wceq cc0 cA 0re sqrth.1 leloei cc0 cA clt wbr cA csqr cfv cA csqr
      cfv cmul co cA wceq cc0 cA wceq cc0 cA clt wbr cA csqr cfv cA csqr cfv
      cmul co cA wceq cc0 cA clt wbr cA c1 cif csqr cfv cc0 cA clt wbr cA c1
      cif csqr cfv cmul co cc0 cA clt wbr cA c1 cif wceq cA c1 cA cc0 cA clt
      wbr cA c1 cif wceq cA csqr cfv cA csqr cfv cmul co cc0 cA clt wbr cA c1
      cif csqr cfv cc0 cA clt wbr cA c1 cif csqr cfv cmul co cA cc0 cA clt wbr
      cA c1 cif cA cc0 cA clt wbr cA c1 cif wceq cA csqr cfv cc0 cA clt wbr cA
      c1 cif csqr cfv cA csqr cfv cc0 cA clt wbr cA c1 cif csqr cfv cmul cA cc0
      cA clt wbr cA c1 cif csqr fveq2 cA cc0 cA clt wbr cA c1 cif csqr fveq2
      opreq12d cA cc0 cA clt wbr cA c1 cif wceq id eqeq12d cc0 cA clt wbr cA c1
      cif cc0 cA clt wbr cA c1 cr sqrth.1 1re keepel cA elimgt0 sqrlem26 dedth
      cc0 cA wceq cc0 csqr cfv cc0 csqr cfv cmul co cc0 wceq cA csqr cfv cA
      csqr cfv cmul co cA wceq cc0 csqr cfv cc0 csqr cfv cmul co cc0 cc0 cmul
      co cc0 cc0 csqr cfv cc0 cc0 csqr cfv cc0 cmul sqr0 sqr0 opreq12i cc0 0cn
      mul01i eqtri cc0 cA wceq cc0 csqr cfv cc0 csqr cfv cmul co cA csqr cfv cA
      csqr cfv cmul co cc0 cA cc0 cA wceq cc0 csqr cfv cA csqr cfv cc0 csqr cfv
      cA csqr cfv cmul cc0 cA csqr fveq2 cc0 cA csqr fveq2 opreq12d cc0 cA wceq
      id eqeq12d mpbii jaoi sylbi $.
      $( [26-May-1999] $)

    $( The square root of a nonnegative real is a real. $)
    sqrcli $p |- ( 0 <_ A -> ( sqr ` A ) e. RR ) $=
      cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cA csqr cfv cr wcel cc0 cA
      0re sqrth.1 leloei cc0 cA clt wbr cA csqr cfv cr wcel cc0 cA wceq cc0 cA
      clt wbr cA csqr cfv cr wcel cc0 cA clt wbr cA c1 cif csqr cfv cr wcel cA
      c1 cA cc0 cA clt wbr cA c1 cif wceq cA csqr cfv cc0 cA clt wbr cA c1 cif
      csqr cfv cr cA cc0 cA clt wbr cA c1 cif csqr fveq2 eleq1d cc0 cA clt wbr
      cA c1 cif cc0 cA clt wbr cA c1 cr sqrth.1 1re keepel cA elimgt0 sqrlem24
      dedth cc0 cA wceq cA csqr cfv cc0 cr cc0 cA wceq cc0 csqr cfv cA csqr cfv
      cc0 cc0 cA csqr fveq2 sqr0 syl5eqr 0re syl6eqelr jaoi sylbi $.
      $( [26-May-1999] $)

    $( The square root of a positive real is positive. $)
    sqrgt0i $p |- ( 0 < A -> 0 < ( sqr ` A ) ) $=
      cc0 cA clt wbr cc0 cA csqr cfv clt wbr cc0 cc0 cA clt wbr cA c1 cif csqr
      cfv clt wbr cA c1 cA cc0 cA clt wbr cA c1 cif wceq cA csqr cfv cc0 cA clt
      wbr cA c1 cif csqr cfv cc0 clt cA cc0 cA clt wbr cA c1 cif csqr fveq2
      breq2d cc0 cA clt wbr cA c1 cif cc0 cA clt wbr cA c1 cr sqrth.1 1re
      keepel cA elimgt0 sqrgt0ii dedth $.
      $( [26-May-1999] $)

    $( The square root of a nonnegative real is nonnegative. $)
    sqrge0i $p |- ( 0 <_ A -> 0 <_ ( sqr ` A ) ) $=
      cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cc0 cA csqr cfv cle wbr cc0
      cA 0re sqrth.1 leloei cc0 cA clt wbr cc0 cA csqr cfv cle wbr cc0 cA wceq
      cA csqr cfv cr wcel cc0 cA clt wbr cc0 cA csqr cfv cle wbr cc0 cA clt wbr
      cc0 cA cle wbr cA csqr cfv cr wcel cc0 cA 0re sqrth.1 ltlei cA sqrth.1
      sqrcli syl cA csqr cfv cr wcel cc0 cA csqr cfv cle wbr cc0 cA csqr cfv
      clt wbr cc0 cA csqr cfv wceq wo cc0 cA clt wbr cc0 cr wcel cA csqr cfv cr
      wcel cc0 cA csqr cfv cle wbr cc0 cA csqr cfv clt wbr cc0 cA csqr cfv wceq
      wo wb 0re cc0 cA csqr cfv leloe mpan cc0 cA clt wbr cc0 cA csqr cfv clt
      wbr cc0 cA csqr cfv wceq cA sqrth.1 sqrgt0i orcd syl5bir mpcom cc0 cA
      wceq cc0 cA csqr cfv cc0 cle cc0 cA wceq cc0 csqr cfv cA csqr cfv cc0 cc0
      cA csqr fveq2 sqr0 syl5eqr cc0 0re leidi syl5breq jaoi sylbi $.
      $( [26-May-1999] $)

    ${
      sqr11.1 $e |- B e. RR $.
      $( The square root function is one-to-one. $)
      sqr11i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                 ( ( sqr ` A ) = ( sqr ` B ) <-> A = B ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA csqr cfv cB csqr cfv wceq cA cB
        wceq cc0 cA cle wbr cc0 cB cle wbr wa cA csqr cfv cB csqr cfv wceq cA
        cB wceq cc0 cA cle wbr cc0 cB cle wbr wa cA csqr cfv cB csqr cfv wceq
        wa cA csqr cfv cA csqr cfv cmul co cB csqr cfv cB csqr cfv cmul co cA
        cB cA csqr cfv cB csqr cfv wceq cA csqr cfv cA csqr cfv cmul co cB csqr
        cfv cB csqr cfv cmul co wceq cc0 cA cle wbr cc0 cB cle wbr wa cA csqr
        cfv cB csqr cfv wceq cA csqr cfv cA csqr cfv cmul co cB csqr cfv cB
        csqr cfv cmul co wceq cA csqr cfv cB csqr cfv cA csqr cfv cB csqr cfv
        cmul opreq12 anidms adantl cc0 cA cle wbr cA csqr cfv cA csqr cfv cmul
        co cA wceq cc0 cB cle wbr cA csqr cfv cB csqr cfv wceq cA sqrth.1
        sqrthi ad2antrr cc0 cB cle wbr cB csqr cfv cB csqr cfv cmul co cB wceq
        cc0 cA cle wbr cA csqr cfv cB csqr cfv wceq cB sqr11.1 sqrthi ad2antlr
        3eqtr3d ex cA cB csqr fveq2 impbid1 $.
        $( [27-Jul-1999] $)

      ${
        sqrmuli.1 $e |- 0 <_ A $.
        sqrmuli.2 $e |- 0 <_ B $.
        $( Square root distributes over multiplication. $)
        sqrmulii $p |- ( sqr ` ( A x. B ) ) = ( ( sqr ` A ) x. ( sqr ` B ) ) $=
          cA cB cmul co csqr cfv cA cB cmul co csqr cfv cmul co cA csqr cfv cB
          csqr cfv cmul co cA csqr cfv cB csqr cfv cmul co cmul co wceq cA cB
          cmul co csqr cfv cA csqr cfv cB csqr cfv cmul co wceq cA csqr cfv cA
          csqr cfv cmul co cB csqr cfv cB csqr cfv cmul co cmul co cA cB cmul
          co cA csqr cfv cB csqr cfv cmul co cA csqr cfv cB csqr cfv cmul co
          cmul co cA cB cmul co csqr cfv cA cB cmul co csqr cfv cmul co cA csqr
          cfv cA csqr cfv cmul co cA cB csqr cfv cB csqr cfv cmul co cB cmul
          cc0 cA cle wbr cA csqr cfv cA csqr cfv cmul co cA wceq sqrmuli.1 cA
          sqrth.1 sqrthi ax-mp cc0 cB cle wbr cB csqr cfv cB csqr cfv cmul co
          cB wceq sqrmuli.2 cB sqr11.1 sqrthi ax-mp opreq12i cA csqr cfv cB
          csqr cfv cA csqr cfv cB csqr cfv cA csqr cfv cc0 cA cle wbr cA csqr
          cfv cr wcel sqrmuli.1 cA sqrth.1 sqrcli ax-mp recni cB csqr cfv cc0
          cB cle wbr cB csqr cfv cr wcel sqrmuli.2 cB sqr11.1 sqrcli ax-mp
          recni cA csqr cfv cc0 cA cle wbr cA csqr cfv cr wcel sqrmuli.1 cA
          sqrth.1 sqrcli ax-mp recni cB csqr cfv cc0 cB cle wbr cB csqr cfv cr
          wcel sqrmuli.2 cB sqr11.1 sqrcli ax-mp recni mul4i cc0 cA cB cmul co
          cle wbr cA cB cmul co csqr cfv cA cB cmul co csqr cfv cmul co cA cB
          cmul co wceq cc0 cA cle wbr cc0 cB cle wbr cc0 cA cB cmul co cle wbr
          sqrmuli.1 sqrmuli.2 cA cB sqrth.1 sqr11.1 mulge0i mp2an cA cB cmul co
          cA cB sqrth.1 sqr11.1 remulcli sqrthi ax-mp 3eqtr4ri cc0 cA cB cmul
          co csqr cfv cle wbr cc0 cA csqr cfv cB csqr cfv cmul co cle wbr cA cB
          cmul co csqr cfv cA cB cmul co csqr cfv cmul co cA csqr cfv cB csqr
          cfv cmul co cA csqr cfv cB csqr cfv cmul co cmul co wceq cA cB cmul
          co csqr cfv cA csqr cfv cB csqr cfv cmul co wceq wb cc0 cA cB cmul co
          cle wbr cc0 cA cB cmul co csqr cfv cle wbr cc0 cA cle wbr cc0 cB cle
          wbr cc0 cA cB cmul co cle wbr sqrmuli.1 sqrmuli.2 cA cB sqrth.1
          sqr11.1 mulge0i mp2an cA cB cmul co cA cB sqrth.1 sqr11.1 remulcli
          sqrge0i ax-mp cc0 cA csqr cfv cle wbr cc0 cB csqr cfv cle wbr cc0 cA
          csqr cfv cB csqr cfv cmul co cle wbr cc0 cA cle wbr cc0 cA csqr cfv
          cle wbr sqrmuli.1 cA sqrth.1 sqrge0i ax-mp cc0 cB cle wbr cc0 cB csqr
          cfv cle wbr sqrmuli.2 cB sqr11.1 sqrge0i ax-mp cA csqr cfv cB csqr
          cfv cc0 cA cle wbr cA csqr cfv cr wcel sqrmuli.1 cA sqrth.1 sqrcli
          ax-mp cc0 cB cle wbr cB csqr cfv cr wcel sqrmuli.2 cB sqr11.1 sqrcli
          ax-mp mulge0i mp2an cA cB cmul co csqr cfv cA csqr cfv cB csqr cfv
          cmul co cc0 cA cB cmul co cle wbr cA cB cmul co csqr cfv cr wcel cc0
          cA cle wbr cc0 cB cle wbr cc0 cA cB cmul co cle wbr sqrmuli.1
          sqrmuli.2 cA cB sqrth.1 sqr11.1 mulge0i mp2an cA cB cmul co cA cB
          sqrth.1 sqr11.1 remulcli sqrcli ax-mp cA csqr cfv cB csqr cfv cc0 cA
          cle wbr cA csqr cfv cr wcel sqrmuli.1 cA sqrth.1 sqrcli ax-mp cc0 cB
          cle wbr cB csqr cfv cr wcel sqrmuli.2 cB sqr11.1 sqrcli ax-mp
          remulcli msq11i mp2an mpbi $.
          $( [30-Jul-1999] $)
      $}

      $( Square root distributes over multiplication. $)
      sqrmuli $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                 ( sqr ` ( A x. B ) ) = ( ( sqr ` A ) x. ( sqr ` B ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr cA cB cmul co csqr cfv cA csqr cfv cB
        csqr cfv cmul co wceq cc0 cA cle wbr cA cc0 cif cB cmul co csqr cfv cc0
        cA cle wbr cA cc0 cif csqr cfv cB csqr cfv cmul co wceq cc0 cA cle wbr
        cA cc0 cif cc0 cB cle wbr cB cc0 cif cmul co csqr cfv cc0 cA cle wbr cA
        cc0 cif csqr cfv cc0 cB cle wbr cB cc0 cif csqr cfv cmul co wceq cA cB
        cc0 cc0 cA cc0 cA cle wbr cA cc0 cif wceq cA cB cmul co csqr cfv cc0 cA
        cle wbr cA cc0 cif cB cmul co csqr cfv cA csqr cfv cB csqr cfv cmul co
        cc0 cA cle wbr cA cc0 cif csqr cfv cB csqr cfv cmul co cA cc0 cA cle
        wbr cA cc0 cif wceq cA cB cmul co cc0 cA cle wbr cA cc0 cif cB cmul co
        csqr cA cc0 cA cle wbr cA cc0 cif cB cmul opreq1 fveq2d cA cc0 cA cle
        wbr cA cc0 cif wceq cA csqr cfv cc0 cA cle wbr cA cc0 cif csqr cfv cB
        csqr cfv cmul cA cc0 cA cle wbr cA cc0 cif csqr fveq2 opreq1d eqeq12d
        cB cc0 cB cle wbr cB cc0 cif wceq cc0 cA cle wbr cA cc0 cif cB cmul co
        csqr cfv cc0 cA cle wbr cA cc0 cif cc0 cB cle wbr cB cc0 cif cmul co
        csqr cfv cc0 cA cle wbr cA cc0 cif csqr cfv cB csqr cfv cmul co cc0 cA
        cle wbr cA cc0 cif csqr cfv cc0 cB cle wbr cB cc0 cif csqr cfv cmul co
        cB cc0 cB cle wbr cB cc0 cif wceq cc0 cA cle wbr cA cc0 cif cB cmul co
        cc0 cA cle wbr cA cc0 cif cc0 cB cle wbr cB cc0 cif cmul co csqr cB cc0
        cB cle wbr cB cc0 cif cc0 cA cle wbr cA cc0 cif cmul opreq2 fveq2d cB
        cc0 cB cle wbr cB cc0 cif wceq cB csqr cfv cc0 cB cle wbr cB cc0 cif
        csqr cfv cc0 cA cle wbr cA cc0 cif csqr cfv cmul cB cc0 cB cle wbr cB
        cc0 cif csqr fveq2 opreq2d eqeq12d cc0 cA cle wbr cA cc0 cif cc0 cB cle
        wbr cB cc0 cif cc0 cA cle wbr cA cc0 cr sqrth.1 0re keepel cc0 cB cle
        wbr cB cc0 cr sqr11.1 0re keepel cA elimge0 cB elimge0 sqrmulii dedth2h
        $.
        $( [30-Jul-1999] $)

      $( Relationship between square root and squares. $)
      sqrmsq2i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
         ( ( sqr ` A ) = B <-> A = ( B x. B ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA csqr cfv cB cB cmul co csqr cfv
        wceq cA csqr cfv cB wceq cA cB cB cmul co wceq cc0 cB cle wbr cA csqr
        cfv cB cB cmul co csqr cfv wceq cA csqr cfv cB wceq wb cc0 cA cle wbr
        cc0 cB cle wbr cB cB cmul co csqr cfv cB cA csqr cfv cc0 cB cle wbr cB
        cB cmul co csqr cfv cB csqr cfv cB csqr cfv cmul co cB cc0 cB cle wbr
        cB cB cmul co csqr cfv cB csqr cfv cB csqr cfv cmul co wceq cB cB
        sqr11.1 sqr11.1 sqrmuli anidms cB sqr11.1 sqrthi eqtrd eqeq2d adantl
        cc0 cA cle wbr cA csqr cfv cB cB cmul co csqr cfv wceq cA cB cB cmul co
        wceq wb cc0 cB cle wbr cc0 cA cle wbr cc0 cB cB cmul co cle wbr cA csqr
        cfv cB cB cmul co csqr cfv wceq cA cB cB cmul co wceq wb cB sqr11.1
        msqge0i cA cB cB cmul co sqrth.1 cB cB sqr11.1 sqr11.1 remulcli sqr11i
        mpan2 adantr bitr3d $.
        $( [31-Jul-1999] $)

      $( Square root is monotonic. $)
      sqrlei $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
          ( A <_ B <-> ( sqr ` A ) <_ ( sqr ` B ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA csqr cfv cB csqr cfv cle wbr cA
        csqr cfv cA csqr cfv cmul co cB csqr cfv cB csqr cfv cmul co cle wbr cA
        cB cle wbr cA csqr cfv cr wcel cc0 cA csqr cfv cle wbr wa cB csqr cfv
        cr wcel cc0 cB csqr cfv cle wbr wa cA csqr cfv cB csqr cfv cle wbr cA
        csqr cfv cA csqr cfv cmul co cB csqr cfv cB csqr cfv cmul co cle wbr wb
        cc0 cA cle wbr cc0 cB cle wbr cA csqr cfv cB csqr cfv le2msq cc0 cA cle
        wbr cA csqr cfv cr wcel cc0 cA csqr cfv cle wbr cA sqrth.1 sqrcli cA
        sqrth.1 sqrge0i jca cc0 cB cle wbr cB csqr cfv cr wcel cc0 cB csqr cfv
        cle wbr cB sqr11.1 sqrcli cB sqr11.1 sqrge0i jca syl2an cc0 cA cle wbr
        cc0 cB cle wbr cA csqr cfv cA csqr cfv cmul co cA cB csqr cfv cB csqr
        cfv cmul co cB cle cA sqrth.1 sqrthi cB sqr11.1 sqrthi breqan12d bitr2d
        $.
        $( [26-Jul-2006] $) $( [3-Aug-1999] $)

      $( Square root is strictly monotonic.  (Contributed by Roy F. Longton,
         8-Aug-2005.) $)
      sqrlti $p |- ( ( 0 <_ A /\ 0 <_ B ) -> ( A < B <-> ( sqr ` A ) <
        ( sqr ` B ) ) ) $=
        cc0 cA cle wbr cc0 cB cle wbr wa cA csqr cfv cB csqr cfv clt wbr cA
        csqr cfv cA csqr cfv cmul co cB csqr cfv cB csqr cfv cmul co clt wbr cA
        cB clt wbr cA csqr cfv cr wcel cc0 cA csqr cfv cle wbr wa cB csqr cfv
        cr wcel cc0 cB csqr cfv cle wbr wa cA csqr cfv cB csqr cfv clt wbr cA
        csqr cfv cA csqr cfv cmul co cB csqr cfv cB csqr cfv cmul co clt wbr wb
        cc0 cA cle wbr cc0 cB cle wbr cA csqr cfv cB csqr cfv lt2msq cc0 cA cle
        wbr cA csqr cfv cr wcel cc0 cA csqr cfv cle wbr cA sqrth.1 sqrcli cA
        sqrth.1 sqrge0i jca cc0 cB cle wbr cB csqr cfv cr wcel cc0 cB csqr cfv
        cle wbr cB sqr11.1 sqrcli cB sqr11.1 sqrge0i jca syl2an cc0 cA cle wbr
        cc0 cB cle wbr cA csqr cfv cA csqr cfv cmul co cA cB csqr cfv cB csqr
        cfv cmul co cB clt cA sqrth.1 sqrthi cB sqr11.1 sqrthi breqan12d bitr2d
        $.
        $( [26-Jul-2006] $) $( [8-Aug-2005] $)
    $}

    $( Square root of square. $)
    sqrmsqi $p |- ( 0 <_ A -> ( sqr ` ( A x. A ) ) = A ) $=
      cc0 cA cA cmul co cle wbr cc0 cA cle wbr cA cA cmul co csqr cfv cA wceq
      cA sqrth.1 msqge0i cc0 cA cA cmul co cle wbr cc0 cA cle wbr wa cA cA cmul
      co csqr cfv cA wceq cA cA cmul co cA cA cmul co wceq cA cA cmul co eqid
      cA cA cmul co cA cA cA sqrth.1 sqrth.1 remulcli sqrth.1 sqrmsq2i mpbiri
      mpan $.
      $( [2-Aug-1999] $)
  $}

  $( The square root of a nonnegative real is a real. $)
  sqrcl $p |- ( ( A e. RR /\ 0 <_ A ) -> ( sqr ` A ) e. RR ) $=
    cA cr wcel cc0 cA cle wbr cA csqr cfv cr wcel cA cr wcel cc0 cA cle wbr cA
    csqr cfv cr wcel wi cc0 cA cr wcel cA cc0 cif cle wbr cA cr wcel cA cc0 cif
    csqr cfv cr wcel wi cA cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0
    cA cr wcel cA cc0 cif cle wbr cA csqr cfv cr wcel cA cr wcel cA cc0 cif
    csqr cfv cr wcel cA cA cr wcel cA cc0 cif cc0 cle breq2 cA cA cr wcel cA
    cc0 cif wceq cA csqr cfv cA cr wcel cA cc0 cif csqr cfv cr cA cA cr wcel cA
    cc0 cif csqr fveq2 eleq1d imbi12d cA cr wcel cA cc0 cif cA cc0 cr 0re
    elimel sqrcli dedth imp $.
    $( [29-May-1999] $)

  $( The square root of a positive real is positive. $)
  sqrgt0 $p |- ( ( A e. RR /\ 0 < A ) -> 0 < ( sqr ` A ) ) $=
    cA cr wcel cc0 cA clt wbr cc0 cA csqr cfv clt wbr cA cr wcel cc0 cA clt wbr
    cc0 cA csqr cfv clt wbr wi cc0 cA cr wcel cA cc0 cif clt wbr cc0 cA cr wcel
    cA cc0 cif csqr cfv clt wbr wi cA cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA
    clt wbr cc0 cA cr wcel cA cc0 cif clt wbr cc0 cA csqr cfv clt wbr cc0 cA cr
    wcel cA cc0 cif csqr cfv clt wbr cA cA cr wcel cA cc0 cif cc0 clt breq2 cA
    cA cr wcel cA cc0 cif wceq cA csqr cfv cA cr wcel cA cc0 cif csqr cfv cc0
    clt cA cA cr wcel cA cc0 cif csqr fveq2 breq2d imbi12d cA cr wcel cA cc0
    cif cA cc0 cr 0re elimel sqrgt0i dedth imp $.
    $( [29-May-1999] $)

  $( The square root of a nonnegative real is nonnegative. $)
  sqrge0 $p |- ( ( A e. RR /\ 0 <_ A ) -> 0 <_ ( sqr ` A ) ) $=
    cA cr wcel cc0 cA cle wbr cc0 cA csqr cfv cle wbr cA cr wcel cc0 cA cle wbr
    cc0 cA csqr cfv cle wbr wi cc0 cA cr wcel cA cc0 cif cle wbr cc0 cA cr wcel
    cA cc0 cif csqr cfv cle wbr wi cA cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA
    cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cc0 cA csqr cfv cle wbr cc0 cA cr
    wcel cA cc0 cif csqr cfv cle wbr cA cA cr wcel cA cc0 cif cc0 cle breq2 cA
    cA cr wcel cA cc0 cif wceq cA csqr cfv cA cr wcel cA cc0 cif csqr cfv cc0
    cle cA cA cr wcel cA cc0 cif csqr fveq2 breq2d imbi12d cA cr wcel cA cc0
    cif cA cc0 cr 0re elimel sqrge0i dedth imp $.
    $( [29-May-1999] $)

  $( Square root is monotonic. $)
  sqrle $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 0 <_ B ) ) ->
      ( A <_ B <-> ( sqr ` A ) <_ ( sqr ` B ) ) ) $=
    cA cr wcel cB cr wcel wa cc0 cA cle wbr cc0 cB cle wbr wa cA cB cle wbr cA
    csqr cfv cB csqr cfv cle wbr wb cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB
    cle wbr wa cA cB cle wbr cA csqr cfv cB csqr cfv cle wbr wb wi cc0 cA cr
    wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cA cr wcel cA cc0 cif cB cle wbr
    cA cr wcel cA cc0 cif csqr cfv cB csqr cfv cle wbr wb wi cc0 cA cr wcel cA
    cc0 cif cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif cle wbr cA cr wcel cA cc0 cif csqr cfv cB cr wcel cB
    cc0 cif csqr cfv cle wbr wb wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif wceq
    cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr cc0 cB
    cle wbr wa cA cB cle wbr cA csqr cfv cB csqr cfv cle wbr wb cA cr wcel cA
    cc0 cif cB cle wbr cA cr wcel cA cc0 cif csqr cfv cB csqr cfv cle wbr wb cA
    cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif cle wbr
    cc0 cB cle wbr cA cA cr wcel cA cc0 cif cc0 cle breq2 anbi1d cA cA cr wcel
    cA cc0 cif wceq cA cB cle wbr cA cr wcel cA cc0 cif cB cle wbr cA csqr cfv
    cB csqr cfv cle wbr cA cr wcel cA cc0 cif csqr cfv cB csqr cfv cle wbr cA
    cA cr wcel cA cc0 cif cB cle breq1 cA cA cr wcel cA cc0 cif wceq cA csqr
    cfv cA cr wcel cA cc0 cif csqr cfv cB csqr cfv cle cA cA cr wcel cA cc0 cif
    csqr fveq2 breq1d bibi12d imbi12d cB cB cr wcel cB cc0 cif wceq cc0 cA cr
    wcel cA cc0 cif cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr
    cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB cle wbr cA cr
    wcel cA cc0 cif csqr cfv cB csqr cfv cle wbr wb cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif cle wbr cA cr wcel cA cc0 cif csqr cfv cB cr wcel cB cc0
    cif csqr cfv cle wbr wb cB cB cr wcel cB cc0 cif wceq cc0 cB cle wbr cc0 cB
    cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cB cB cr wcel
    cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA
    cc0 cif cB cle wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cA
    cr wcel cA cc0 cif csqr cfv cB csqr cfv cle wbr cA cr wcel cA cc0 cif csqr
    cfv cB cr wcel cB cc0 cif csqr cfv cle wbr cB cB cr wcel cB cc0 cif cA cr
    wcel cA cc0 cif cle breq2 cB cB cr wcel cB cc0 cif wceq cB csqr cfv cB cr
    wcel cB cc0 cif csqr cfv cA cr wcel cA cc0 cif csqr cfv cle cB cB cr wcel
    cB cc0 cif csqr fveq2 breq2d bibi12d imbi12d cA cr wcel cA cc0 cif cB cr
    wcel cB cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re elimel sqrlei dedth2h
    imp $.
    $( [3-Apr-2005] $) $( [17-Mar-2005] $)

  $( A square root is zero iff its argument is 0. $)
  sqr00 $p |- ( ( A e. RR /\ 0 <_ A ) ->
               ( ( sqr ` A ) = 0 <-> A = 0 ) ) $=
    cA cr wcel cc0 cA cle wbr wa cA csqr cfv cc0 csqr cfv wceq cA cc0 wceq cA
    csqr cfv cc0 wceq cA cr wcel cc0 cA cle wbr cA csqr cfv cc0 csqr cfv wceq
    cA cc0 wceq wb cA cr wcel cc0 cA cle wbr cc0 cc0 cle wbr cA csqr cfv cc0
    csqr cfv wceq cA cc0 wceq wb cc0 0re leidi cA cr wcel cc0 cA cle wbr cc0
    cc0 cle wbr wa cA csqr cfv cc0 csqr cfv wceq cA cc0 wceq wb wi cc0 cA cr
    wcel cA cc0 cif cle wbr cc0 cc0 cle wbr wa cA cr wcel cA cc0 cif csqr cfv
    cc0 csqr cfv wceq cA cr wcel cA cc0 cif cc0 wceq wb wi cA cc0 cA cA cr wcel
    cA cc0 cif wceq cc0 cA cle wbr cc0 cc0 cle wbr wa cc0 cA cr wcel cA cc0 cif
    cle wbr cc0 cc0 cle wbr wa cA csqr cfv cc0 csqr cfv wceq cA cc0 wceq wb cA
    cr wcel cA cc0 cif csqr cfv cc0 csqr cfv wceq cA cr wcel cA cc0 cif cc0
    wceq wb cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0
    cif cle wbr cc0 cc0 cle wbr cA cA cr wcel cA cc0 cif cc0 cle breq2 anbi1d
    cA cA cr wcel cA cc0 cif wceq cA csqr cfv cc0 csqr cfv wceq cA cr wcel cA
    cc0 cif csqr cfv cc0 csqr cfv wceq cA cc0 wceq cA cr wcel cA cc0 cif cc0
    wceq cA cA cr wcel cA cc0 cif wceq cA csqr cfv cA cr wcel cA cc0 cif csqr
    cfv cc0 csqr cfv cA cA cr wcel cA cc0 cif csqr fveq2 eqeq1d cA cA cr wcel
    cA cc0 cif cc0 eqeq1 bibi12d imbi12d cA cr wcel cA cc0 cif cc0 cA cc0 cr
    0re elimel 0re sqr11i dedth mpan2i imp cc0 csqr cfv cc0 cA csqr cfv sqr0
    eqeq2i syl5bbr $.
    $( [27-Jul-1999] $)

  $( The square root of a positive real is a postive real. $)
  rpsqrcl $p |- ( A e. RR+ -> ( sqr ` A ) e. RR+ ) $=
    cA csqr cfv crp wcel cA csqr cfv cr wcel cc0 cA csqr cfv clt wbr cA crp
    wcel cA csqr cfv elrp cA cr wcel cc0 cA cle wbr cA csqr cfv cr wcel cA crp
    wcel cA sqrcl cA rpre cA rpge0 sylanc cA cr wcel cc0 cA clt wbr cc0 cA csqr
    cfv clt wbr cA crp wcel cA sqrgt0 cA rpre cA rpgt0 sylanc sylanbrc $.
    $( [12-Mar-2008] $) $( [22-Feb-2008] $)

  $( The square root of 1 is 1. $)
  sqr1 $p |- ( sqr ` 1 ) = 1 $=
    c1 c1 cmul co csqr cfv c1 csqr cfv c1 c1 c1 cmul co c1 csqr c1 ax1cn
    mulid1i fveq2i cc0 c1 cle wbr c1 c1 cmul co csqr cfv c1 wceq cc0 c1 0re 1re
    lt01 ltleii c1 1re sqrmsqi ax-mp eqtr3i $.
    $( [31-Jul-1999] $)

  $( The square root of 4 is 2. $)
  sqr4 $p |- ( sqr ` 4 ) = 2 $=
    c4 csqr cfv c2 wceq c4 c2 c2 cmul co wceq c2 c2 cmul co c4 2t2e4 eqcomi cc0
    c4 clt wbr cc0 c2 clt wbr c4 csqr cfv c2 wceq c4 c2 c2 cmul co wceq wb 4pos
    2pos cc0 c4 cle wbr cc0 c2 cle wbr c4 csqr cfv c2 wceq c4 c2 c2 cmul co
    wceq wb cc0 c4 clt wbr cc0 c2 clt wbr c4 c2 4re 2re sqrmsq2i cc0 c4 0re 4re
    ltlei cc0 c2 0re 2re ltlei syl2an mp2an mpbir $.
    $( [3-Aug-1999] $)

  $( The square root of 9 is 3. $)
  sqr9 $p |- ( sqr ` 9 ) = 3 $=
    c9 csqr cfv c3 wceq c9 c3 c3 cmul co wceq c3 c3 cmul co c9 3t3e9 eqcomi cc0
    c9 clt wbr cc0 c3 clt wbr c9 csqr cfv c3 wceq c9 c3 c3 cmul co wceq wb 9pos
    3pos cc0 c9 cle wbr cc0 c3 cle wbr c9 csqr cfv c3 wceq c9 c3 c3 cmul co
    wceq wb cc0 c9 clt wbr cc0 c3 clt wbr c9 c3 9re 3re sqrmsq2i cc0 c9 0re 9re
    ltlei cc0 c3 0re 3re ltlei syl2an mp2an mpbir $.
    $( [1-Jun-2004] $) $( [11-May-2004] $)

  $( The square root of 2 is bounded by 1 and 2.  (Contributed by Roy F.
     Longton, 8-Aug-2005.) $)
  sqr2gt1lt2 $p |- ( 1 < ( sqr ` 2 ) /\ ( sqr ` 2 ) < 2 ) $=
    c1 c2 csqr cfv clt wbr c2 csqr cfv c2 clt wbr c1 csqr cfv c1 c2 csqr cfv
    clt sqr1 c1 c2 clt wbr c1 csqr cfv c2 csqr cfv clt wbr 1lt2 cc0 c1 cle wbr
    cc0 c2 cle wbr c1 c2 clt wbr c1 csqr cfv c2 csqr cfv clt wbr wb cc0 c1 0re
    1re lt01 ltleii cc0 c2 0re 2re 2pos ltleii c1 c2 1re 2re sqrlti mp2an mpbi
    eqbrtrri c2 csqr cfv c4 csqr cfv c2 clt c2 c4 clt wbr c2 csqr cfv c4 csqr
    cfv clt wbr c2 c2 c2 caddc co c4 clt c2 c2 c2 2re 2pos 2re 2pos 2re 2pos
    sqrlem15 2p2e4 breqtri cc0 c2 cle wbr cc0 c4 cle wbr c2 c4 clt wbr c2 csqr
    cfv c4 csqr cfv clt wbr wb cc0 c2 0re 2re 2pos ltleii cc0 c4 0re 4re 4pos
    ltleii c2 c4 2re 4re sqrlti mp2an mpbi sqr4 breqtri pm3.2i $.
    $( [8-Aug-2005] $) $( [8-Aug-2005] $)

  ${
    sqrsq.1 $e |- A e. RR $.
    $( Square root of square. $)
    sqrsqi $p |- ( 0 <_ A -> ( sqr ` ( A ^ 2 ) ) = A ) $=
      cc0 cA cle wbr cA cA cmul co csqr cfv cA cA c2 cexp co csqr cfv cA
      sqrsq.1 sqrmsqi cA c2 cexp co cA cA cmul co csqr cA cA sqrsq.1 recni
      sqvali fveq2i syl5eq $.
      $( [11-Aug-1999] $)

    $( Square of square root. $)
    sqsqri $p |- ( 0 <_ A -> ( ( sqr ` A ) ^ 2 ) = A ) $=
      cc0 cA cle wbr cA csqr cfv c2 cexp co cA csqr cfv cA csqr cfv cmul co cA
      cc0 cA cle wbr cA csqr cfv cc wcel cA csqr cfv c2 cexp co cA csqr cfv cA
      csqr cfv cmul co wceq cc0 cA cle wbr cA csqr cfv cA sqrsq.1 sqrcli recnd
      cA csqr cfv sqval syl cA sqrsq.1 sqrthi eqtrd $.
      $( [11-Aug-1999] $)
  $}

  $( Square root of square. $)
  sqrsq $p |- ( ( A e. RR /\ 0 <_ A ) -> ( sqr ` ( A ^ 2 ) ) = A ) $=
    cA cr wcel cc0 cA cle wbr cA c2 cexp co csqr cfv cA wceq cA cr wcel cc0 cA
    cle wbr cA c2 cexp co csqr cfv cA wceq wi cc0 cA cr wcel cA cc0 cif cle wbr
    cA cr wcel cA cc0 cif c2 cexp co csqr cfv cA cr wcel cA cc0 cif wceq wi cA
    cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif
    cle wbr cA c2 cexp co csqr cfv cA wceq cA cr wcel cA cc0 cif c2 cexp co
    csqr cfv cA cr wcel cA cc0 cif wceq cA cA cr wcel cA cc0 cif cc0 cle breq2
    cA cA cr wcel cA cc0 cif wceq cA c2 cexp co csqr cfv cA cr wcel cA cc0 cif
    c2 cexp co csqr cfv cA cA cr wcel cA cc0 cif cA cA cr wcel cA cc0 cif wceq
    cA c2 cexp co cA cr wcel cA cc0 cif c2 cexp co csqr cA cA cr wcel cA cc0
    cif c2 cexp opreq1 fveq2d cA cA cr wcel cA cc0 cif wceq id eqeq12d imbi12d
    cA cr wcel cA cc0 cif cA cc0 cr 0re elimel sqrsqi dedth imp $.
    $( [4-Feb-2007] $) $( [14-Jan-2006] $)

  $( Square of square root. $)
  sqsqr $p |- ( ( A e. RR /\ 0 <_ A ) -> ( ( sqr ` A ) ^ 2 ) = A ) $=
    cA cr wcel cc0 cA cle wbr cA csqr cfv c2 cexp co cA wceq cA cr wcel cc0 cA
    cle wbr cA csqr cfv c2 cexp co cA wceq wi cc0 cA cr wcel cA cc0 cif cle wbr
    cA cr wcel cA cc0 cif csqr cfv c2 cexp co cA cr wcel cA cc0 cif wceq wi cA
    cc0 cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif
    cle wbr cA csqr cfv c2 cexp co cA wceq cA cr wcel cA cc0 cif csqr cfv c2
    cexp co cA cr wcel cA cc0 cif wceq cA cA cr wcel cA cc0 cif cc0 cle breq2
    cA cA cr wcel cA cc0 cif wceq cA csqr cfv c2 cexp co cA cr wcel cA cc0 cif
    csqr cfv c2 cexp co cA cA cr wcel cA cc0 cif cA cA cr wcel cA cc0 cif wceq
    cA csqr cfv cA cr wcel cA cc0 cif csqr cfv c2 cexp cA cA cr wcel cA cc0 cif
    csqr fveq2 opreq1d cA cA cr wcel cA cc0 cif wceq id eqeq12d imbi12d cA cr
    wcel cA cc0 cif cA cc0 cr 0re elimel sqsqri dedth imp $.
    $( [27-Sep-1999] $)

$(   Only true for certain real values
  @{
    quad.1 @e |- A e. CC @.
    quad.2 @e |- B e. CC @.
    quad.3 @e |- C e. CC @.
    @( The quadratic equation. @)
    quad @p |- ( ( ( A ^ 2 ) + ( ( B x. A ) + C ) ) = 0 <->
    ( A = ( ( B + ( sqr ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) ) ) / 2 ) \/
    A = ( ( B - ( sqr ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) ) ) / 2 ) ) ) @=
      ( c2 cexp co cmul caddc cc0 wceq jaoi impbii ) AGHIBAJICKIKILMZ???P???NO
      @.
      @( [ ?] @) @( [25-Apr-2006] @)
  @}
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Irrationality of square root of 2
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    sqr2irrlem1.1 $e |- A e. NN $.
    sqr2irrlem1.2 $e |- B e. NN $.
    $( Lemma for irrationality of square root of 2.  Technical lemma used
       to simplify the main induction step. $)
    sqr2irrlem1 $p |- ( ( A ^ 2 ) = ( 2 x. ( B ^ 2 ) ) ->
                      ( ( B < A /\ ( A / 2 ) e. NN ) /\
                     ( B ^ 2 ) = ( 2 x. ( ( A / 2 ) ^ 2 ) ) ) ) $=
      cA c2 cexp co c2 cB c2 cexp co cmul co wceq cB cA clt wbr cA c2 cdiv co
      cn wcel cB c2 cexp co c2 cA c2 cdiv co c2 cexp co cmul co wceq cA c2 cexp
      co c2 cB c2 cexp co cmul co wceq cB c2 cexp co cA c2 cexp co clt wbr cB
      cA clt wbr cA c2 cexp co c2 cB c2 cexp co cmul co wceq cB c2 cexp co cA
      c2 cexp co clt wbr cB c2 cexp co c2 cB c2 cexp co cmul co clt wbr c1 cB
      c2 cexp co cmul co cB c2 cexp co c2 cB c2 cexp co cmul co clt cB c2 cexp
      co cB c2 cexp co cB cB sqr2irrlem1.2 nnrei resqcli recni mulid2i c1 c2
      clt wbr c1 cB c2 cexp co cmul co c2 cB c2 cexp co cmul co clt wbr 1lt2 c1
      c2 cB c2 cexp co 1re 2re cB cB sqr2irrlem1.2 nnrei resqcli cB c2 cexp co
      cB sqr2irrlem1.2 nnsqcli nngt0i ltmul1ii mpbi eqbrtrri cA c2 cexp co c2
      cB c2 cexp co cmul co cB c2 cexp co clt breq2 mpbiri cc0 cB cle wbr cc0
      cA cle wbr cB cA clt wbr cB c2 cexp co cA c2 cexp co clt wbr wb cc0 cB
      0re cB sqr2irrlem1.2 nnrei cB sqr2irrlem1.2 nngt0i ltleii cc0 cA 0re cA
      sqr2irrlem1.1 nnrei cA sqr2irrlem1.1 nngt0i ltleii cB cA cB sqr2irrlem1.2
      nnrei cA sqr2irrlem1.1 nnrei lt2sqi mp2an sylibr cA c2 cdiv co cn wcel c2
      cB c2 cexp co cmul co cA c2 cexp co c2 cB c2 cexp co cmul co cA c2 cexp
      co wceq cA c2 cexp co c2 cdiv co cB c2 cexp co wceq cA c2 cdiv co cn wcel
      cA c2 cexp co c2 cB c2 cexp co cA c2 cexp co cA cA sqr2irrlem1.1 nnrei
      resqcli recni 2cn cB c2 cexp co cB cB sqr2irrlem1.2 nnrei resqcli recni
      2ne0 divmuli cA c2 cexp co c2 cdiv co cB c2 cexp co wceq cA c2 cexp co c2
      cdiv co cn wcel cA c2 cdiv co cn wcel cA c2 cexp co c2 cdiv co cB c2 cexp
      co wceq cA c2 cexp co c2 cdiv co cn wcel cB c2 cexp co cn wcel cB
      sqr2irrlem1.2 nnsqcli cA c2 cexp co c2 cdiv co cB c2 cexp co cn eleq1
      mpbiri cA sqr2irrlem1.1 nnesqi sylibr sylbir eqcoms cA c2 cexp co c2 cB
      c2 cexp co cmul co wceq c2 cA c2 cdiv co c2 cexp co cmul co cB c2 cexp co
      c2 cA c2 cdiv co c2 cexp co cmul co cB c2 cexp co wceq cA c2 cexp co c2
      cB c2 cexp co cmul co wceq c2 cA c2 cdiv co c2 cexp co cmul co cB c2 cexp
      co wceq c2 c2 cA c2 cdiv co c2 cexp co cmul co cmul co c2 cB c2 cexp co
      cmul co wceq cA c2 cexp co c2 cB c2 cexp co cmul co wceq c2 cA c2 cdiv co
      c2 cexp co cmul co cB c2 cexp co c2 c2 cA c2 cdiv co c2 cexp co cmul co
      c2 cA c2 cdiv co c2 cexp co 2re cA c2 cdiv co cA c2 cA sqr2irrlem1.1
      nnrei 2re 2ne0 redivcli resqcli remulcli recni cB c2 cexp co cB cB
      sqr2irrlem1.2 nnrei resqcli recni 2cn 2ne0 mulcani c2 c2 cA c2 cdiv co c2
      cexp co cmul co cmul co cA c2 cexp co c2 cB c2 cexp co cmul co c2 c2 cmul
      co cA c2 cdiv co c2 cexp co cmul co c2 c2 cmul co cA c2 cexp co c2 c2
      cmul co cdiv co cmul co c2 c2 cA c2 cdiv co c2 cexp co cmul co cmul co cA
      c2 cexp co cA c2 cdiv co c2 cexp co cA c2 cexp co c2 c2 cmul co cdiv co
      c2 c2 cmul co cmul cA c2 cdiv co c2 cexp co cA c2 cexp co c2 c2 cexp co
      cdiv co cA c2 cexp co c2 c2 cmul co cdiv co cA c2 cA sqr2irrlem1.1 nncni
      2cn 2ne0 sqdivi c2 c2 cexp co c2 c2 cmul co cA c2 cexp co cdiv c2 2cn
      sqvali opreq2i eqtri opreq2i c2 c2 cA c2 cdiv co c2 cexp co 2cn 2cn cA c2
      cdiv co c2 cexp co cA c2 cdiv co cA c2 cA sqr2irrlem1.1 nnrei 2re 2ne0
      redivcli resqcli recni mulassi cA c2 cexp co c2 c2 cmul co cA c2 cexp co
      cA cA sqr2irrlem1.1 nnrei resqcli recni c2 c2 2cn 2cn mulcli c2 c2 2cn
      2cn 2ne0 2ne0 muln0i divcan2i 3eqtr3i eqeq1i bitr3i biimpri eqcomd jca31
      $.
      $( [20-Aug-2001] $)
  $}

  $( Lemma for irrationality of square root of 2.  Eliminates hypotheses with
     weak deduction theorem. $)
  sqr2irrlem2 $p |- ( ( A e. NN /\ B e. NN ) ->
                   ( ( A ^ 2 ) = ( 2 x. ( B ^ 2 ) ) ->
                    ( ( B < A /\ ( A / 2 ) e. NN ) /\
                   ( B ^ 2 ) = ( 2 x. ( ( A / 2 ) ^ 2 ) ) ) ) ) $=
    cA cn wcel cB cn wcel cA c2 cexp co c2 cB c2 cexp co cmul co wceq cB cA clt
    wbr cA c2 cdiv co cn wcel wa cB c2 cexp co c2 cA c2 cdiv co c2 cexp co cmul
    co wceq wa wi cA cn wcel cA c2 cif c2 cexp co c2 cB c2 cexp co cmul co wceq
    cB cA cn wcel cA c2 cif clt wbr cA cn wcel cA c2 cif c2 cdiv co cn wcel wa
    cB c2 cexp co c2 cA cn wcel cA c2 cif c2 cdiv co c2 cexp co cmul co wceq wa
    wi cA cn wcel cA c2 cif c2 cexp co c2 cB cn wcel cB c2 cif c2 cexp co cmul
    co wceq cB cn wcel cB c2 cif cA cn wcel cA c2 cif clt wbr cA cn wcel cA c2
    cif c2 cdiv co cn wcel wa cB cn wcel cB c2 cif c2 cexp co c2 cA cn wcel cA
    c2 cif c2 cdiv co c2 cexp co cmul co wceq wa wi cA cB c2 c2 cA cA cn wcel
    cA c2 cif wceq cA c2 cexp co c2 cB c2 cexp co cmul co wceq cA cn wcel cA c2
    cif c2 cexp co c2 cB c2 cexp co cmul co wceq cB cA clt wbr cA c2 cdiv co cn
    wcel wa cB c2 cexp co c2 cA c2 cdiv co c2 cexp co cmul co wceq wa cB cA cn
    wcel cA c2 cif clt wbr cA cn wcel cA c2 cif c2 cdiv co cn wcel wa cB c2
    cexp co c2 cA cn wcel cA c2 cif c2 cdiv co c2 cexp co cmul co wceq wa cA cA
    cn wcel cA c2 cif wceq cA c2 cexp co cA cn wcel cA c2 cif c2 cexp co c2 cB
    c2 cexp co cmul co cA cA cn wcel cA c2 cif c2 cexp opreq1 eqeq1d cA cA cn
    wcel cA c2 cif wceq cB cA clt wbr cA c2 cdiv co cn wcel wa cB cA cn wcel cA
    c2 cif clt wbr cA cn wcel cA c2 cif c2 cdiv co cn wcel wa cB c2 cexp co c2
    cA c2 cdiv co c2 cexp co cmul co wceq cB c2 cexp co c2 cA cn wcel cA c2 cif
    c2 cdiv co c2 cexp co cmul co wceq cA cA cn wcel cA c2 cif wceq cB cA clt
    wbr cB cA cn wcel cA c2 cif clt wbr cA c2 cdiv co cn wcel cA cn wcel cA c2
    cif c2 cdiv co cn wcel cA cA cn wcel cA c2 cif cB clt breq2 cA cA cn wcel
    cA c2 cif wceq cA c2 cdiv co cA cn wcel cA c2 cif c2 cdiv co cn cA cA cn
    wcel cA c2 cif c2 cdiv opreq1 eleq1d anbi12d cA cA cn wcel cA c2 cif wceq
    c2 cA c2 cdiv co c2 cexp co cmul co c2 cA cn wcel cA c2 cif c2 cdiv co c2
    cexp co cmul co cB c2 cexp co cA cA cn wcel cA c2 cif wceq cA c2 cdiv co c2
    cexp co cA cn wcel cA c2 cif c2 cdiv co c2 cexp co c2 cmul cA cA cn wcel cA
    c2 cif wceq cA c2 cdiv co cA cn wcel cA c2 cif c2 cdiv co c2 cexp cA cA cn
    wcel cA c2 cif c2 cdiv opreq1 opreq1d opreq2d eqeq2d anbi12d imbi12d cB cB
    cn wcel cB c2 cif wceq cA cn wcel cA c2 cif c2 cexp co c2 cB c2 cexp co
    cmul co wceq cA cn wcel cA c2 cif c2 cexp co c2 cB cn wcel cB c2 cif c2
    cexp co cmul co wceq cB cA cn wcel cA c2 cif clt wbr cA cn wcel cA c2 cif
    c2 cdiv co cn wcel wa cB c2 cexp co c2 cA cn wcel cA c2 cif c2 cdiv co c2
    cexp co cmul co wceq wa cB cn wcel cB c2 cif cA cn wcel cA c2 cif clt wbr
    cA cn wcel cA c2 cif c2 cdiv co cn wcel wa cB cn wcel cB c2 cif c2 cexp co
    c2 cA cn wcel cA c2 cif c2 cdiv co c2 cexp co cmul co wceq wa cB cB cn wcel
    cB c2 cif wceq c2 cB c2 cexp co cmul co c2 cB cn wcel cB c2 cif c2 cexp co
    cmul co cA cn wcel cA c2 cif c2 cexp co cB cB cn wcel cB c2 cif wceq cB c2
    cexp co cB cn wcel cB c2 cif c2 cexp co c2 cmul cB cB cn wcel cB c2 cif c2
    cexp opreq1 opreq2d eqeq2d cB cB cn wcel cB c2 cif wceq cB cA cn wcel cA c2
    cif clt wbr cA cn wcel cA c2 cif c2 cdiv co cn wcel wa cB cn wcel cB c2 cif
    cA cn wcel cA c2 cif clt wbr cA cn wcel cA c2 cif c2 cdiv co cn wcel wa cB
    c2 cexp co c2 cA cn wcel cA c2 cif c2 cdiv co c2 cexp co cmul co wceq cB cn
    wcel cB c2 cif c2 cexp co c2 cA cn wcel cA c2 cif c2 cdiv co c2 cexp co
    cmul co wceq cB cB cn wcel cB c2 cif wceq cB cA cn wcel cA c2 cif clt wbr
    cB cn wcel cB c2 cif cA cn wcel cA c2 cif clt wbr cA cn wcel cA c2 cif c2
    cdiv co cn wcel cB cB cn wcel cB c2 cif cA cn wcel cA c2 cif clt breq1
    anbi1d cB cB cn wcel cB c2 cif wceq cB c2 cexp co cB cn wcel cB c2 cif c2
    cexp co c2 cA cn wcel cA c2 cif c2 cdiv co c2 cexp co cmul co cB cB cn wcel
    cB c2 cif c2 cexp opreq1 eqeq1d anbi12d imbi12d cA cn wcel cA c2 cif cB cn
    wcel cB c2 cif cA c2 cn 2nn elimel cB c2 cn 2nn elimel sqr2irrlem1 dedth2h
    $.
    $( [20-Aug-2001] $)

  ${
    $d x y z w $.
    $( Main theorem for irrationality of square root of 2.  There are no
       natural numbers such that the square of one is twice the square of the
       other.  Uses strong induction. $)
    sqr2irrlem3 $p |- -. E. x e. NN E. y e. NN
                            ( x ^ 2 ) = ( 2 x. ( y ^ 2 ) ) $=
      vx cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq vy cn wrex vx cn vx cv
      cn wcel vx cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq wn vy cn wral
      vx cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq vy cn wrex wn vx cv c2
      cexp co c2 vy cv c2 cexp co cmul co wceq wn vy cn wral vz cv c2 cexp co
      c2 vw cv c2 cexp co cmul co wceq wn vw cn wral vx vz vx cv vz cv wceq vx
      cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq wn vy cn wral vz cv c2
      cexp co c2 vy cv c2 cexp co cmul co wceq wn vy cn wral vz cv c2 cexp co
      c2 vw cv c2 cexp co cmul co wceq wn vw cn wral vx cv vz cv wceq vx cv c2
      cexp co c2 vy cv c2 cexp co cmul co wceq wn vz cv c2 cexp co c2 vy cv c2
      cexp co cmul co wceq wn vy cn vx cv vz cv wceq vx cv c2 cexp co c2 vy cv
      c2 cexp co cmul co wceq vz cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq
      vx cv vz cv wceq vx cv c2 cexp co vz cv c2 cexp co c2 vy cv c2 cexp co
      cmul co vx cv vz cv c2 cexp opreq1 eqeq1d notbid ralbidv vz cv c2 cexp co
      c2 vy cv c2 cexp co cmul co wceq wn vz cv c2 cexp co c2 vw cv c2 cexp co
      cmul co wceq wn vy vw cn vy cv vw cv wceq vz cv c2 cexp co c2 vy cv c2
      cexp co cmul co wceq vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq vy
      cv vw cv wceq c2 vy cv c2 cexp co cmul co c2 vw cv c2 cexp co cmul co vz
      cv c2 cexp co vy cv vw cv wceq vy cv c2 cexp co vw cv c2 cexp co c2 cmul
      vy cv vw cv c2 cexp opreq1 opreq2d eqeq2d notbid cbvralv syl6bb vx cv cn
      wcel vz cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co
      wceq wn vw cn wral wi vz cn wral vx cv c2 cexp co c2 vy cv c2 cexp co
      cmul co wceq wn vy cn vx cv cn wcel vz cv vx cv clt wbr vz cv c2 cexp co
      c2 vw cv c2 cexp co cmul co wceq wn vw cn wral wi vz cn wral vy cv cn
      wcel vx cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq wn vx cv cn wcel
      vz cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq wn
      vw cn wral wi vz cn wral wa vy cv cn wcel wa vx cv c2 cexp co c2 vy cv c2
      cexp co cmul co wceq vy cv vx cv clt wbr vx cv c2 cdiv co cn wcel wa vy
      cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq wa vz cv vx cv
      clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq wn vw cn wral
      wi vz cn wral vy cv cn wcel vy cv vx cv clt wbr vx cv c2 cdiv co cn wcel
      wa vy cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq wa wn vx
      cv cn wcel vz cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul
      co wceq wn vw cn wral wi vz cn wral vy cv cn wcel wa vy cv vx cv clt wbr
      vx cv c2 cdiv co cn wcel wa vy cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp
      co cmul co wceq wn wi vy cv vx cv clt wbr vx cv c2 cdiv co cn wcel wa vy
      cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq wa wn vz cv vx
      cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq wn vw cn
      wral wi vz cn wral vy cv cn wcel wa vy cv vx cv clt wbr vx cv c2 cdiv co
      cn wcel vy cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq wn
      vz cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq wn
      vw cn wral wi vz cn wral vy cv cn wcel wa vy cv vx cv clt wbr vy cv c2
      cexp co c2 vw cv c2 cexp co cmul co wceq wn vw cn wral vx cv c2 cdiv co
      cn wcel vy cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq wn
      wi vz cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq
      wn vw cn wral wi vy cv vx cv clt wbr vy cv c2 cexp co c2 vw cv c2 cexp co
      cmul co wceq wn vw cn wral wi vz vy cv cn vz cv vy cv wceq vz cv vx cv
      clt wbr vy cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co
      wceq wn vw cn wral vy cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq wn
      vw cn wral vz cv vy cv vx cv clt breq1 vz cv vy cv wceq vz cv c2 cexp co
      c2 vw cv c2 cexp co cmul co wceq wn vy cv c2 cexp co c2 vw cv c2 cexp co
      cmul co wceq wn vw cn vz cv vy cv wceq vz cv c2 cexp co c2 vw cv c2 cexp
      co cmul co wceq vy cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq vz cv
      vy cv wceq vz cv c2 cexp co vy cv c2 cexp co c2 vw cv c2 cexp co cmul co
      vz cv vy cv c2 cexp opreq1 eqeq1d notbid ralbidv imbi12d rcla4cva vy cv
      c2 cexp co c2 vw cv c2 cexp co cmul co wceq wn vy cv c2 cexp co c2 vx cv
      c2 cdiv co c2 cexp co cmul co wceq wn vw vx cv c2 cdiv co cn vw cv vx cv
      c2 cdiv co wceq vy cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq vy cv
      c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq vw cv vx cv c2
      cdiv co wceq c2 vw cv c2 cexp co cmul co c2 vx cv c2 cdiv co c2 cexp co
      cmul co vy cv c2 cexp co vw cv vx cv c2 cdiv co wceq vw cv c2 cexp co vx
      cv c2 cdiv co c2 cexp co c2 cmul vw cv vx cv c2 cdiv co c2 cexp opreq1
      opreq2d eqeq2d notbid rcla4cv syl6 imp3a vy cv vx cv clt wbr vx cv c2
      cdiv co cn wcel wa vy cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul
      co wceq imnan sylib adantll vx cv cn wcel vy cv cn wcel vx cv c2 cexp co
      c2 vy cv c2 cexp co cmul co wceq vy cv vx cv clt wbr vx cv c2 cdiv co cn
      wcel wa vy cv c2 cexp co c2 vx cv c2 cdiv co c2 cexp co cmul co wceq wa
      wi vz cv vx cv clt wbr vz cv c2 cexp co c2 vw cv c2 cexp co cmul co wceq
      wn vw cn wral wi vz cn wral vx cv vy cv sqr2irrlem2 adantlr mtod exp31
      r19.21adv indstr vx cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq vy cn
      ralnex sylib nrex $.
      $( [20-Aug-2001] $)
  $}

  ${
    sqr2irrlem4.1 $e |- A e. NN $.
    sqr2irrlem4.2 $e |- B e. NN $.
    $( Lemma for irrationality of square root of 2. $)
    sqr2irrlem4 $p |- ( ( sqr ` 2 ) = ( A / B ) <->
                      ( A ^ 2 ) = ( 2 x. ( B ^ 2 ) ) ) $=
      cA c2 cexp co c2 cB c2 cexp co cmul co wceq c2 cA cB cdiv co c2 cexp co
      wceq c2 csqr cfv cA cB cdiv co c2 cexp co csqr cfv wceq c2 csqr cfv cA cB
      cdiv co wceq cA c2 cexp co cB c2 cexp co cdiv co c2 cB c2 cexp co cmul co
      cB c2 cexp co cdiv co wceq cA cB cdiv co c2 cexp co c2 wceq cA c2 cexp co
      c2 cB c2 cexp co cmul co wceq c2 cA cB cdiv co c2 cexp co wceq cA c2 cexp
      co cB c2 cexp co cdiv co cA cB cdiv co c2 cexp co c2 cB c2 cexp co cmul
      co cB c2 cexp co cdiv co c2 cA cB cdiv co c2 cexp co cA c2 cexp co cB c2
      cexp co cdiv co cA cB cA sqr2irrlem4.1 nncni cB sqr2irrlem4.2 nncni cB
      sqr2irrlem4.2 nnne0i sqdivi eqcomi c2 cB c2 cexp co 2cn cB c2 cexp co cB
      sqr2irrlem4.2 nnsqcli nncni cB c2 cexp co cB sqr2irrlem4.2 nnsqcli nnne0i
      divcan4i eqeq12i cA c2 cexp co c2 cB c2 cexp co cmul co cB c2 cexp co cA
      c2 cexp co cA cA sqr2irrlem4.1 nnrei resqcli recni c2 cB c2 cexp co cmul
      co c2 cB c2 cexp co 2re cB c2 cexp co cB sqr2irrlem4.2 nnsqcli nnrei
      remulcli recni cB c2 cexp co cB sqr2irrlem4.2 nnsqcli nncni cB c2 cexp co
      cB sqr2irrlem4.2 nnsqcli nnne0i div11i cA cB cdiv co c2 cexp co c2 eqcom
      3bitr3i cc0 c2 cle wbr cc0 cA cB cdiv co c2 cexp co cle wbr c2 csqr cfv
      cA cB cdiv co c2 cexp co csqr cfv wceq c2 cA cB cdiv co c2 cexp co wceq
      wb cc0 c2 0re 2re 2pos ltleii cA cB cdiv co cA cB cA sqr2irrlem4.1 nnrei
      cB sqr2irrlem4.2 nnrei cB sqr2irrlem4.2 nnne0i redivcli sqge0i c2 cA cB
      cdiv co c2 cexp co 2re cA cB cdiv co cA cB cA sqr2irrlem4.1 nnrei cB
      sqr2irrlem4.2 nnrei cB sqr2irrlem4.2 nnne0i redivcli resqcli sqr11i mp2an
      cA cB cdiv co c2 cexp co csqr cfv cA cB cdiv co c2 csqr cfv cc0 cA cB
      cdiv co cle wbr cA cB cdiv co c2 cexp co csqr cfv cA cB cdiv co wceq cc0
      cA cB cdiv co 0re cA cB cA sqr2irrlem4.1 nnrei cB sqr2irrlem4.2 nnrei cB
      sqr2irrlem4.2 nnne0i redivcli cA cB cA sqr2irrlem4.1 nnrei cB
      sqr2irrlem4.2 nnrei cA sqr2irrlem4.1 nngt0i cB sqr2irrlem4.2 nngt0i
      divgt0ii ltleii cA cB cdiv co cA cB cA sqr2irrlem4.1 nnrei cB
      sqr2irrlem4.2 nnrei cB sqr2irrlem4.2 nnne0i redivcli sqrsqi ax-mp eqeq2i
      3bitr2ri $.
      $( [20-Aug-2001] $)
  $}

  $( Lemma for irrationality of square root of 2.  Eliminates hypotheses with
     weak deduction theorem. $)
  sqr2irrlem5 $p |- ( ( A e. NN /\ B e. NN ) -> ( ( sqr ` 2 ) = ( A / B )
                     <-> ( A ^ 2 ) = ( 2 x. ( B ^ 2 ) ) ) ) $=
    cA cn wcel cB cn wcel c2 csqr cfv cA cB cdiv co wceq cA c2 cexp co c2 cB c2
    cexp co cmul co wceq wb c2 csqr cfv cA cn wcel cA c2 cif cB cdiv co wceq cA
    cn wcel cA c2 cif c2 cexp co c2 cB c2 cexp co cmul co wceq wb c2 csqr cfv
    cA cn wcel cA c2 cif cB cn wcel cB c2 cif cdiv co wceq cA cn wcel cA c2 cif
    c2 cexp co c2 cB cn wcel cB c2 cif c2 cexp co cmul co wceq wb cA cB c2 c2
    cA cA cn wcel cA c2 cif wceq c2 csqr cfv cA cB cdiv co wceq c2 csqr cfv cA
    cn wcel cA c2 cif cB cdiv co wceq cA c2 cexp co c2 cB c2 cexp co cmul co
    wceq cA cn wcel cA c2 cif c2 cexp co c2 cB c2 cexp co cmul co wceq cA cA cn
    wcel cA c2 cif wceq cA cB cdiv co cA cn wcel cA c2 cif cB cdiv co c2 csqr
    cfv cA cA cn wcel cA c2 cif cB cdiv opreq1 eqeq2d cA cA cn wcel cA c2 cif
    wceq cA c2 cexp co cA cn wcel cA c2 cif c2 cexp co c2 cB c2 cexp co cmul co
    cA cA cn wcel cA c2 cif c2 cexp opreq1 eqeq1d bibi12d cB cB cn wcel cB c2
    cif wceq c2 csqr cfv cA cn wcel cA c2 cif cB cdiv co wceq c2 csqr cfv cA cn
    wcel cA c2 cif cB cn wcel cB c2 cif cdiv co wceq cA cn wcel cA c2 cif c2
    cexp co c2 cB c2 cexp co cmul co wceq cA cn wcel cA c2 cif c2 cexp co c2 cB
    cn wcel cB c2 cif c2 cexp co cmul co wceq cB cB cn wcel cB c2 cif wceq cA
    cn wcel cA c2 cif cB cdiv co cA cn wcel cA c2 cif cB cn wcel cB c2 cif cdiv
    co c2 csqr cfv cB cB cn wcel cB c2 cif cA cn wcel cA c2 cif cdiv opreq2
    eqeq2d cB cB cn wcel cB c2 cif wceq c2 cB c2 cexp co cmul co c2 cB cn wcel
    cB c2 cif c2 cexp co cmul co cA cn wcel cA c2 cif c2 cexp co cB cB cn wcel
    cB c2 cif wceq cB c2 cexp co cB cn wcel cB c2 cif c2 cexp co c2 cmul cB cB
    cn wcel cB c2 cif c2 cexp opreq1 opreq2d eqeq2d bibi12d cA cn wcel cA c2
    cif cB cn wcel cB c2 cif cA c2 cn 2nn elimel cB c2 cn 2nn elimel
    sqr2irrlem4 dedth2h $.
    $( [20-Aug-2001] $)

  ${
    $d x y $.
    $( The square root of 2 is irrational. $)
    sqr2irr $p |- ( sqr ` 2 ) e/ QQ $=
      c2 csqr cfv cq wnel c2 csqr cfv cq wcel wn c2 csqr cfv cq wcel c2 csqr
      cfv vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex c2 csqr cfv vx cv vy
      cv cdiv co wceq vy cn wrex vx cz wrex c2 csqr cfv vx cv vy cv cdiv co
      wceq vy cn wrex vx cn wrex c2 csqr cfv vx cv vy cv cdiv co wceq vy cn
      wrex vx cn wrex vx cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq vy cn
      wrex vx cn wrex vx vy sqr2irrlem3 c2 csqr cfv vx cv vy cv cdiv co wceq vx
      cv c2 cexp co c2 vy cv c2 cexp co cmul co wceq vx vy cn cn vx cv vy cv
      sqr2irrlem5 2rexbiia mtbir c2 csqr cfv vx cv vy cv cdiv co wceq vy cn
      wrex c2 csqr cfv vx cv vy cv cdiv co wceq vy cn wrex vx cz cn vx cv cz
      wcel c2 csqr cfv vx cv vy cv cdiv co wceq vy cn wrex vx cv cn wcel vx cv
      cz wcel c2 csqr cfv vx cv vy cv cdiv co wceq vy cn wrex vx cv cz wcel cc0
      vx cv clt wbr wa vx cv cn wcel vx cv cz wcel c2 csqr cfv vx cv vy cv cdiv
      co wceq vy cn wrex cc0 vx cv clt wbr vx cv cz wcel c2 csqr cfv vx cv vy
      cv cdiv co wceq cc0 vx cv clt wbr vy cn vx cv cz wcel vy cv cn wcel wa c2
      csqr cfv vx cv vy cv cdiv co wceq cc0 vy cv cmul co vx cv clt wbr cc0 vx
      cv clt wbr vx cv cz wcel vy cv cn wcel wa cc0 vy cv cmul co vx cv clt wbr
      cc0 vx cv vy cv cdiv co clt wbr c2 csqr cfv vx cv vy cv cdiv co wceq vy
      cv cn wcel vx cv cz wcel cc0 vy cv cmul co vx cv clt wbr cc0 vx cv vy cv
      cdiv co clt wbr wb vy cv cn wcel vx cv cz wcel wa cc0 vy cv clt wbr cc0
      vy cv cmul co vx cv clt wbr cc0 vx cv vy cv cdiv co clt wbr wb vy cv cn
      wcel cc0 vy cv clt wbr vx cv cz wcel vy cv nngt0 adantr vy cv cr wcel vx
      cv cr wcel cc0 vy cv clt wbr cc0 vy cv cmul co vx cv clt wbr cc0 vx cv vy
      cv cdiv co clt wbr wb wi vy cv cn wcel vx cv cz wcel cc0 cr wcel vy cv cr
      wcel vx cv cr wcel cc0 vy cv clt wbr cc0 vy cv cmul co vx cv clt wbr cc0
      vx cv vy cv cdiv co clt wbr wb wi 0re cc0 cr wcel vy cv cr wcel vx cv cr
      wcel w3a cc0 vy cv clt wbr cc0 vy cv cmul co vx cv clt wbr cc0 vx cv vy
      cv cdiv co clt wbr wb cc0 vy cv vx cv ltmuldivOLD ex mp3an1 vy cv nnre vx
      cv zre syl2an mpd ancoms c2 csqr cfv vx cv vy cv cdiv co wceq cc0 c2 csqr
      cfv clt wbr cc0 vx cv vy cv cdiv co clt wbr c2 2re 2pos sqrgt0ii c2 csqr
      cfv vx cv vy cv cdiv co cc0 clt breq2 mpbii syl5bir vy cv cn wcel cc0 vy
      cv cmul co vx cv clt wbr cc0 vx cv clt wbr wb vx cv cz wcel vy cv cn wcel
      cc0 vy cv cmul co cc0 vx cv clt vy cv cn wcel vy cv cc wcel cc0 vy cv
      cmul co cc0 wceq vy cv nncn vy cv mul02 syl breq1d adantl sylibd
      r19.23adva anc2li vx cv elnnz syl6ibr impac r19.22i2 mto vx vy c2 csqr
      cfv elq mtbir c2 csqr cfv cq df-nel mpbir $.
      $( [8-Jan-2002] $)
  $}

  $( The square root of 2 exists and is a real number. $)
  sqr2re $p |- ( sqr ` 2 ) e. RR $=
    c2 2re 2pos sqrlem24 $.
    $( [2-Nov-2004] $) $( [3-Dec-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Imaginary and complex number properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The reciprocal of ` _i ` . $)
  irec $p |- ( 1 / _i ) = -u _i $=
    c1 ci cdiv co ci cneg wceq ci ci cneg cmul co c1 wceq ci ci cneg cmul co ci
    ci cmul co cneg c1 ci ci axicn axicn mulneg2i c1 ci ci cmul co cneg wceq ci
    ci cmul co c1 cneg wceq ixi c1 ci ci cmul co ax1cn ci ci axicn axicn mulcli
    negcon2i mpbir eqtr4i c1 ci ci cneg ax1cn axicn ci axicn negcli ine0
    divmuli mpbir $.
    $( [11-Oct-1999] $)

  $( ` _i ` squared. $)
  i2 $p |- ( _i ^ 2 ) = -u 1 $=
    ci c2 cexp co ci ci cmul co c1 cneg ci axicn sqvali ixi eqtri $.
    $( [29-May-2005] $) $( [6-May-1999] $)

  $( ` _i `  cubed. $)
  i3 $p |- ( _i ^ 3 ) = -u _i $=
    ci c3 cexp co ci c2 c1 caddc co cexp co ci c2 cexp co ci cmul co ci cneg c3
    c2 c1 caddc co ci cexp df-3 opreq2i ci cc wcel c2 cn0 wcel ci c2 c1 caddc
    co cexp co ci c2 cexp co ci cmul co wceq axicn 2nn0 ci c2 expp1 mp2an ci c2
    cexp co ci cmul co c1 cneg ci cmul co ci cneg ci c2 cexp co c1 cneg ci cmul
    i2 opreq1i ci axicn mulm1i eqtri 3eqtri $.
    $( [31-Jan-2007] $) $( [31-Jan-2007] $)

  $( ` _i ` to the fourth power. $)
  i4 $p |- ( _i ^ 4 ) = 1 $=
    ci c2 c2 caddc co cexp co ci c2 cexp co ci c2 cexp co cmul co ci c4 cexp co
    c1 ci cc wcel c2 cn0 wcel c2 cn0 wcel ci c2 c2 caddc co cexp co ci c2 cexp
    co ci c2 cexp co cmul co wceq axicn 2nn0 2nn0 ci c2 c2 expadd mp3an c2 c2
    caddc co c4 ci cexp 2p2e4 opreq2i ci c2 cexp co ci c2 cexp co cmul co c1
    cneg c1 cneg cmul co c1 c1 cmul co c1 ci c2 cexp co c1 cneg ci c2 cexp co
    c1 cneg cmul i2 i2 opreq12i c1 c1 ax1cn ax1cn mul2negi c1 ax1cn mulid1i
    3eqtri 3eqtr3i $.
    $( [1-Feb-2007] $) $( [31-Jan-2007] $)

  $( The imaginary unit ` _i ` is not a real number. $)
  inelr $p |- -. _i e. RR $=
    ci cr wcel ci cc0 wceq ci cc0 wne ci cc0 wceq wn ine0 ci cc0 df-ne mpbi ci
    cr wcel cc0 ci ci cmul co clt wbr wn ci cc0 wceq cc0 ci ci cmul co clt wbr
    c1 cc0 clt wbr cc0 c1 clt wbr c1 cc0 clt wbr wn lt01 cc0 c1 0re 1re ltnsymi
    ax-mp cc0 ci ci cmul co clt wbr cc0 c1 caddc co ci ci cmul co c1 caddc co
    clt wbr c1 cc0 clt wbr cc0 ci ci cmul co c1 0re ci ci cmul co c1 cneg cr
    ixi c1 1re renegcli eqeltri 1re ltadd1i cc0 c1 caddc co c1 ci ci cmul co c1
    caddc co cc0 clt c1 ax1cn addid2i axi2m1 breq12i bitri mtbir ci cr wcel cc0
    ci ci cmul co clt wbr ci cc0 ci cr wcel ci cc0 wne cc0 ci ci cmul co clt
    wbr ci msqgt0 ex necon1bd mpi mto $.
    $( [6-May-1999] $)

  ${
    cru.1 $e |- A e. RR $.
    cru.2 $e |- B e. RR $.
    cru.3 $e |- C e. RR $.
    cru.4 $e |- D e. RR $.
    $( Lemma for ~ crui . $)
    crulem $p |- ( ( A + ( _i x. B ) ) = ( C + ( _i x. D ) ) -> B = D ) $=
      cA ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cB cD cmin co
      cc0 wceq cB cD wceq cA ci cB cmul co caddc co cC ci cD cmul co caddc co
      wceq cB cD cmin co cc0 wceq ci cr wcel inelr cA ci cB cmul co caddc co cC
      ci cD cmul co caddc co wceq cB cD cmin co cc0 wne ci cr wcel cB cD cmin
      co cc0 wceq wn cA ci cB cmul co caddc co cC ci cD cmul co caddc co wceq
      cB cD cmin co cc0 wne ci cr wcel cB cD cmin co cc0 wne cA ci cB cmul co
      caddc co cC ci cD cmul co caddc co wceq cB cD cmin co cc0 wne ci cr wcel
      wi cB cD cmin co cc0 wne cA ci cB cmul co caddc co cC ci cD cmul co caddc
      co wceq wa cC cA cneg caddc co cB cD cmin co cdiv co cr wcel ci cr wcel
      cB cD cmin co cc0 wne cB cD cmin co cc0 wne cA ci cB cmul co caddc co cC
      ci cD cmul co caddc co wceq wa cC cA cneg caddc co cB cD cmin co cdiv co
      ci cr cB cD cmin co cc0 wne cA ci cB cmul co caddc co cC ci cD cmul co
      caddc co wceq cC cA cneg caddc co cB cD cmin co cdiv co ci wceq cB cD
      cmin co cc0 wne cC cA cneg caddc co cB cD cmin co cdiv co ci wceq ci cB
      cD cmin co cmul co cC cA cneg caddc co wceq cA ci cB cmul co caddc co cC
      ci cD cmul co caddc co wceq cB cD cmin co cc0 wne cC cA cneg caddc co cB
      cD cmin co cdiv co ci wceq cB cD cmin co ci cmul co cC cA cneg caddc co
      wceq ci cB cD cmin co cmul co cC cA cneg caddc co wceq cC cA cneg caddc
      co cB cD cmin co ci cC cA cneg caddc co cC cA cneg cru.3 cA cru.1
      renegcli readdcli recni cB cD cmin co cB cD cru.2 cru.4 resubcli recni
      axicn divmulzi cB cD cmin co ci cmul co ci cB cD cmin co cmul co cC cA
      cneg caddc co cB cD cmin co ci cB cD cmin co cB cD cru.2 cru.4 resubcli
      recni axicn mulcomi eqeq1i syl6bb cA ci cB cmul co caddc co cC ci cD cmul
      co caddc co wceq ci cB cmul co ci cD cmul co cneg caddc co cC cA cneg
      caddc co ci cB cD cmin co cmul co cA ci cB cmul co caddc co cC ci cD cmul
      co caddc co wceq cA ci cB cmul co caddc co cA cneg ci cD cmul co cneg
      caddc co caddc co cC ci cD cmul co caddc co cA cneg ci cD cmul co cneg
      caddc co caddc co ci cB cmul co ci cD cmul co cneg caddc co cC cA cneg
      caddc co cA ci cB cmul co caddc co cC ci cD cmul co caddc co cA cneg ci
      cD cmul co cneg caddc co caddc opreq1 cA ci cB cmul co caddc co cA cneg
      ci cD cmul co cneg caddc co caddc co cA cA cneg caddc co ci cB cmul co ci
      cD cmul co cneg caddc co caddc co cc0 ci cB cmul co ci cD cmul co cneg
      caddc co caddc co ci cB cmul co ci cD cmul co cneg caddc co cA ci cB cmul
      co cA cneg ci cD cmul co cneg cA cru.1 recni ci cB axicn cB cru.2 recni
      mulcli cA cneg cA cru.1 renegcli recni ci cD cmul co ci cD axicn cD cru.4
      recni mulcli negcli add4i cA cA cneg caddc co cc0 ci cB cmul co ci cD
      cmul co cneg caddc co caddc cA cA cru.1 recni negidi opreq1i ci cB cmul
      co ci cD cmul co cneg caddc co ci cB cmul co ci cD cmul co cneg ci cB
      axicn cB cru.2 recni mulcli ci cD cmul co ci cD axicn cD cru.4 recni
      mulcli negcli addcli addid2i 3eqtri cC ci cD cmul co caddc co cA cneg ci
      cD cmul co cneg caddc co caddc co cC cA cneg caddc co ci cD cmul co ci cD
      cmul co cneg caddc co caddc co cC cA cneg caddc co cc0 caddc co cC cA
      cneg caddc co cC ci cD cmul co cA cneg ci cD cmul co cneg cC cru.3 recni
      ci cD axicn cD cru.4 recni mulcli cA cneg cA cru.1 renegcli recni ci cD
      cmul co ci cD axicn cD cru.4 recni mulcli negcli add4i ci cD cmul co ci
      cD cmul co cneg caddc co cc0 cC cA cneg caddc co caddc ci cD cmul co ci
      cD axicn cD cru.4 recni mulcli negidi opreq2i cC cA cneg caddc co cC cA
      cneg caddc co cC cA cneg cru.3 cA cru.1 renegcli readdcli recni addid1i
      3eqtri 3eqtr3g ci cB cD cmin co cmul co ci cB cmul co ci cD cmul co cmin
      co ci cB cmul co ci cD cmul co cneg caddc co ci cB cD axicn cB cru.2
      recni cD cru.4 recni subdii ci cB cmul co ci cD cmul co ci cB axicn cB
      cru.2 recni mulcli ci cD axicn cD cru.4 recni mulcli negsubi eqtr4i
      syl5eq syl5bir imp eleq1d cC cA cneg caddc co cB cD cmin co cC cA cneg
      cru.3 cA cru.1 renegcli readdcli cB cD cru.2 cru.4 resubcli redivclzi
      syl5bi ex pm2.43b cB cD cmin co cc0 df-ne syl5ibr mt3i cB cD cB cru.2
      recni cD cru.4 recni subeq0i sylib $.
      $( [11-Mar-2008] $) $( [8-May-1999] $)

    $( The representation of complex numbers in terms of real and imaginary
       parts is unique.  Proposition 10-1.3 of [Gleason] p. 130. $)
    crui $p |- ( ( A + ( _i x. B ) ) = ( C + ( _i x. D ) ) <->
                   ( A = C /\ B = D ) ) $=
      cA ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cA cC wceq cB cD
      wceq wa cA ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cA cC
      wceq cB cD wceq cB cD wceq cA ci cB cmul co caddc co cC ci cD cmul co
      caddc co wceq cA cC wceq cA cB cC cD cru.1 cru.2 cru.3 cru.4 crulem cB cD
      wceq cA ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cA ci cB
      cmul co caddc co cC ci cB cmul co caddc co wceq cA cC wceq cB cD wceq cC
      ci cB cmul co caddc co cC ci cD cmul co caddc co cA ci cB cmul co caddc
      co cB cD wceq ci cB cmul co ci cD cmul co cC caddc cB cD ci cmul opreq2
      opreq2d eqeq2d cA ci cB cmul co caddc co cC ci cB cmul co caddc co wceq
      ci cB cmul co cA caddc co ci cB cmul co cC caddc co wceq cA cC wceq cA ci
      cB cmul co caddc co ci cB cmul co cA caddc co cC ci cB cmul co caddc co
      ci cB cmul co cC caddc co cA ci cB cmul co cA cru.1 recni ci cB axicn cB
      cru.2 recni mulcli addcomi cC ci cB cmul co cC cru.3 recni ci cB axicn cB
      cru.2 recni mulcli addcomi eqeq12i ci cB cmul co cA caddc co ci cB cmul
      co cC caddc co wceq cA cC wceq ci cB cmul co cA cC ci cB axicn cB cru.2
      recni mulcli cA cru.1 recni cC cru.3 recni addcani biimpi sylbi syl6bir
      mpcom cA cB cC cD cru.1 cru.2 cru.3 cru.4 crulem jca cA cC wceq cB cD
      wceq cA cC ci cB cmul co ci cD cmul co caddc cA cC wceq id cB cD ci cmul
      opreq2 opreqan12d impbii $.
      $( [11-Mar-2008] $) $( [9-May-1999] $)
  $}

  $( The representation of complex numbers in terms of real and imaginary
     parts is unique.  Proposition 10-1.3 of [Gleason] p. 130. $)
  cru $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
      ( ( A + ( _i x. B ) ) = ( C + ( _i x. D ) ) <-> ( A = C /\ B = D ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel cD cr wcel cA ci cB cmul co caddc co cC ci
    cD cmul co caddc co wceq cA cC wceq cB cD wceq wa wb cA cB cC cD cc0 cc0 cA
    cr wcel cA cc0 cif ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cA
    cr wcel cA cc0 cif cC wceq cB cD wceq wa wb cA cr wcel cA cc0 cif ci cB cr
    wcel cB cc0 cif cmul co caddc co cC ci cD cmul co caddc co wceq cA cr wcel
    cA cc0 cif cC wceq cB cr wcel cB cc0 cif cD wceq wa wb cA cr wcel cA cc0
    cif ci cB cr wcel cB cc0 cif cmul co caddc co cC cr wcel cC cc0 cif ci cD
    cmul co caddc co wceq cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif wceq cB
    cr wcel cB cc0 cif cD wceq wa wb cA cr wcel cA cc0 cif ci cB cr wcel cB cc0
    cif cmul co caddc co cC cr wcel cC cc0 cif ci cD cr wcel cD cc0 cif cmul co
    caddc co wceq cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif wceq cB cr wcel
    cB cc0 cif cD cr wcel cD cc0 cif wceq wa wb cc0 cc0 cA cA cr wcel cA cc0
    cif wceq cA ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cA cr
    wcel cA cc0 cif ci cB cmul co caddc co cC ci cD cmul co caddc co wceq cA cC
    wceq cB cD wceq wa cA cr wcel cA cc0 cif cC wceq cB cD wceq wa cA cA cr
    wcel cA cc0 cif wceq cA ci cB cmul co caddc co cA cr wcel cA cc0 cif ci cB
    cmul co caddc co cC ci cD cmul co caddc co cA cA cr wcel cA cc0 cif ci cB
    cmul co caddc opreq1 eqeq1d cA cA cr wcel cA cc0 cif wceq cA cC wceq cA cr
    wcel cA cc0 cif cC wceq cB cD wceq cA cA cr wcel cA cc0 cif cC eqeq1 anbi1d
    bibi12d cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif ci cB cmul co
    caddc co cC ci cD cmul co caddc co wceq cA cr wcel cA cc0 cif ci cB cr wcel
    cB cc0 cif cmul co caddc co cC ci cD cmul co caddc co wceq cA cr wcel cA
    cc0 cif cC wceq cB cD wceq wa cA cr wcel cA cc0 cif cC wceq cB cr wcel cB
    cc0 cif cD wceq wa cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif ci
    cB cmul co caddc co cA cr wcel cA cc0 cif ci cB cr wcel cB cc0 cif cmul co
    caddc co cC ci cD cmul co caddc co cB cB cr wcel cB cc0 cif wceq ci cB cmul
    co ci cB cr wcel cB cc0 cif cmul co cA cr wcel cA cc0 cif caddc cB cB cr
    wcel cB cc0 cif ci cmul opreq2 opreq2d eqeq1d cB cB cr wcel cB cc0 cif wceq
    cB cD wceq cB cr wcel cB cc0 cif cD wceq cA cr wcel cA cc0 cif cC wceq cB
    cB cr wcel cB cc0 cif cD eqeq1 anbi2d bibi12d cC cC cr wcel cC cc0 cif wceq
    cA cr wcel cA cc0 cif ci cB cr wcel cB cc0 cif cmul co caddc co cC ci cD
    cmul co caddc co wceq cA cr wcel cA cc0 cif ci cB cr wcel cB cc0 cif cmul
    co caddc co cC cr wcel cC cc0 cif ci cD cmul co caddc co wceq cA cr wcel cA
    cc0 cif cC wceq cB cr wcel cB cc0 cif cD wceq wa cA cr wcel cA cc0 cif cC
    cr wcel cC cc0 cif wceq cB cr wcel cB cc0 cif cD wceq wa cC cC cr wcel cC
    cc0 cif wceq cC ci cD cmul co caddc co cC cr wcel cC cc0 cif ci cD cmul co
    caddc co cA cr wcel cA cc0 cif ci cB cr wcel cB cc0 cif cmul co caddc co cC
    cC cr wcel cC cc0 cif ci cD cmul co caddc opreq1 eqeq2d cC cC cr wcel cC
    cc0 cif wceq cA cr wcel cA cc0 cif cC wceq cA cr wcel cA cc0 cif cC cr wcel
    cC cc0 cif wceq cB cr wcel cB cc0 cif cD wceq cC cC cr wcel cC cc0 cif cA
    cr wcel cA cc0 cif eqeq2 anbi1d bibi12d cD cD cr wcel cD cc0 cif wceq cA cr
    wcel cA cc0 cif ci cB cr wcel cB cc0 cif cmul co caddc co cC cr wcel cC cc0
    cif ci cD cmul co caddc co wceq cA cr wcel cA cc0 cif ci cB cr wcel cB cc0
    cif cmul co caddc co cC cr wcel cC cc0 cif ci cD cr wcel cD cc0 cif cmul co
    caddc co wceq cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif wceq cB cr wcel
    cB cc0 cif cD wceq wa cA cr wcel cA cc0 cif cC cr wcel cC cc0 cif wceq cB
    cr wcel cB cc0 cif cD cr wcel cD cc0 cif wceq wa cD cD cr wcel cD cc0 cif
    wceq cC cr wcel cC cc0 cif ci cD cmul co caddc co cC cr wcel cC cc0 cif ci
    cD cr wcel cD cc0 cif cmul co caddc co cA cr wcel cA cc0 cif ci cB cr wcel
    cB cc0 cif cmul co caddc co cD cD cr wcel cD cc0 cif wceq ci cD cmul co ci
    cD cr wcel cD cc0 cif cmul co cC cr wcel cC cc0 cif caddc cD cD cr wcel cD
    cc0 cif ci cmul opreq2 opreq2d eqeq2d cD cD cr wcel cD cc0 cif wceq cB cr
    wcel cB cc0 cif cD wceq cB cr wcel cB cc0 cif cD cr wcel cD cc0 cif wceq cA
    cr wcel cA cc0 cif cC cr wcel cC cc0 cif wceq cD cD cr wcel cD cc0 cif cB
    cr wcel cB cc0 cif eqeq2 anbi2d bibi12d cA cr wcel cA cc0 cif cB cr wcel cB
    cc0 cif cC cr wcel cC cc0 cif cD cr wcel cD cc0 cif cA cc0 cr 0re elimel cB
    cc0 cr 0re elimel cC cc0 cr 0re elimel cD cc0 cr 0re elimel crui dedth4h $.
    $( [11-Mar-2008] $) $( [9-May-1999] $)

  ${
    crne0.1 $e |- A e. RR $.
    crne0.2 $e |- B e. RR $.
    $( The real representation of complex numbers is nonzero iff one of its
       terms is nonzero. $)
    crne0i $p |- ( ( A =/= 0 \/ B =/= 0 ) <-> ( A + ( _i x. B ) ) =/= 0 ) $=
      cA ci cB cmul co caddc co cc0 wceq wn cA cc0 wceq cB cc0 wceq wa wn cA ci
      cB cmul co caddc co cc0 wne cA cc0 wne cB cc0 wne wo cA ci cB cmul co
      caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa cA ci cB cmul co caddc co
      cc0 wceq cA cc0 wceq cB cc0 wceq wa cA ci cB cmul co caddc co cc0 wceq cA
      ci cB cmul co caddc co cc0 ci cc0 cmul co caddc co wceq cA cc0 wceq cB
      cc0 wceq wa cA ci cB cmul co caddc co cc0 wceq cA ci cB cmul co caddc co
      cc0 cc0 ci cc0 cmul co caddc co cA ci cB cmul co caddc co cc0 wceq id cc0
      ci cc0 cmul co caddc co ci cc0 cmul co cc0 ci cc0 cmul co ci cc0 axicn
      0cn mulcli addid2i ci axicn mul01i eqtr2i syl6eq cA cB cc0 cc0 crne0.1
      crne0.2 0re 0re crui sylib cA cc0 wceq cB cc0 wceq wa cA ci cB cmul co
      caddc co cc0 ci cc0 cmul co caddc co cc0 cA cc0 wceq cB cc0 wceq cA cc0
      ci cB cmul co ci cc0 cmul co caddc cA cc0 wceq id cB cc0 ci cmul opreq2
      opreqan12d cc0 ci cc0 cmul co caddc co ci cc0 cmul co cc0 ci cc0 cmul co
      ci cc0 axicn 0cn mulcli addid2i ci axicn mul01i eqtri syl6eq impbii
      notbii cA ci cB cmul co caddc co cc0 df-ne cA cc0 cB cc0 neorian 3bitr4ri
      $.
      $( [11-Mar-2008] $) $( [29-Apr-2005] $)
  $}

  ${
    crmul.1 $e |- A e. CC $.
    crmul.2 $e |- B e. CC $.
    crmul.3 $e |- C e. CC $.
    crmul.4 $e |- D e. CC $.
    $( Multiplication rule for complex number representation.  Remark in
       [Apostol] p. 361.  In normal use, the arguments are the real components
       of two complex numbers, but the theorem works for complex components as
       well. $)
    crmuli $p |- ( ( A + ( _i x. B ) ) x. ( C + ( _i x. D ) ) ) =
     ( ( ( A x. C ) - ( B x. D ) ) + ( _i x. ( ( A x. D ) + ( B x. C ) ) ) ) $=
      cA cB ci cmul co caddc co cC cD ci cmul co caddc co cmul co cA cC cmul co
      cB cD cmul co cmin co cA cD cmul co cB cC cmul co caddc co ci cmul co
      caddc co cA ci cB cmul co caddc co cC ci cD cmul co caddc co cmul co cA
      cC cmul co cB cD cmul co cmin co ci cA cD cmul co cB cC cmul co caddc co
      cmul co caddc co cA cB ci cmul co caddc co cC cD ci cmul co caddc co cmul
      co cA cC cD ci cmul co caddc co cmul co cB ci cmul co cC cD ci cmul co
      caddc co cmul co caddc co cA cC cmul co cB cD cmul co cneg caddc co cA cD
      cmul co cB cC cmul co caddc co ci cmul co caddc co cA cC cmul co cB cD
      cmul co cmin co cA cD cmul co cB cC cmul co caddc co ci cmul co caddc co
      cA cB ci cmul co cC cD ci cmul co caddc co crmul.1 cB ci crmul.2 axicn
      mulcli cC cD ci cmul co crmul.3 cD ci crmul.4 axicn mulcli addcli adddiri
      cA cC cmul co cA cD cmul co ci cmul co caddc co cB cD cmul co cneg cB cC
      cmul co ci cmul co caddc co caddc co cA cC cmul co cB cD cmul co cneg
      caddc co cA cD cmul co ci cmul co cB cC cmul co ci cmul co caddc co caddc
      co cA cC cD ci cmul co caddc co cmul co cB ci cmul co cC cD ci cmul co
      caddc co cmul co caddc co cA cC cmul co cB cD cmul co cneg caddc co cA cD
      cmul co cB cC cmul co caddc co ci cmul co caddc co cA cC cmul co cA cD
      cmul co ci cmul co cB cD cmul co cneg cB cC cmul co ci cmul co cA cC
      crmul.1 crmul.3 mulcli cA cD cmul co ci cA cD crmul.1 crmul.4 mulcli
      axicn mulcli cB cD cmul co cB cD crmul.2 crmul.4 mulcli negcli cB cC cmul
      co ci cB cC crmul.2 crmul.3 mulcli axicn mulcli add4i cA cC cD ci cmul co
      caddc co cmul co cA cC cmul co cA cD cmul co ci cmul co caddc co cB ci
      cmul co cC cD ci cmul co caddc co cmul co cB cD cmul co cneg cB cC cmul
      co ci cmul co caddc co caddc cA cC cD ci cmul co caddc co cmul co cA cC
      cmul co cA cD ci cmul co cmul co caddc co cA cC cmul co cA cD cmul co ci
      cmul co caddc co cA cC cD ci cmul co crmul.1 crmul.3 cD ci crmul.4 axicn
      mulcli adddii cA cD cmul co ci cmul co cA cD ci cmul co cmul co cA cC
      cmul co caddc cA cD ci crmul.1 crmul.4 axicn mulassi opreq2i eqtr4i cB ci
      cmul co cC cD ci cmul co caddc co cmul co cB ci cmul co cC cmul co cB ci
      cmul co cD ci cmul co cmul co caddc co cB cC cmul co ci cmul co cB cD
      cmul co cneg caddc co cB cD cmul co cneg cB cC cmul co ci cmul co caddc
      co cB ci cmul co cC cD ci cmul co cB ci crmul.2 axicn mulcli crmul.3 cD
      ci crmul.4 axicn mulcli adddii cB ci cmul co cC cmul co cB cC cmul co ci
      cmul co cB ci cmul co cD ci cmul co cmul co cB cD cmul co cneg caddc cB
      ci cC crmul.2 axicn crmul.3 mul23i cB ci cmul co cD ci cmul co cmul co cB
      cD cmul co ci ci cmul co cmul co cB cD cmul co c1 cneg cmul co cB cD cmul
      co cneg cB ci cD ci crmul.2 axicn crmul.4 axicn mul4i ci ci cmul co c1
      cneg cB cD cmul co cmul ixi opreq2i cB cD cmul co c1 cneg cmul co c1 cneg
      cB cD cmul co cmul co c1 cB cD cmul co cmul co cneg cB cD cmul co cneg cB
      cD cmul co c1 cneg cB cD crmul.2 crmul.4 mulcli c1 ax1cn negcli mulcomi
      c1 cB cD cmul co ax1cn cB cD crmul.2 crmul.4 mulcli mulneg1i c1 cB cD
      cmul co cmul co cB cD cmul co cB cD cmul co cB cD crmul.2 crmul.4 mulcli
      mulid2i negeqi 3eqtri 3eqtri opreq12i cB cC cmul co ci cmul co cB cD cmul
      co cneg cB cC cmul co ci cB cC crmul.2 crmul.3 mulcli axicn mulcli cB cD
      cmul co cB cD crmul.2 crmul.4 mulcli negcli addcomi 3eqtri opreq12i cA cD
      cmul co cB cC cmul co caddc co ci cmul co cA cD cmul co ci cmul co cB cC
      cmul co ci cmul co caddc co cA cC cmul co cB cD cmul co cneg caddc co
      caddc cA cD cmul co cB cC cmul co ci cA cD crmul.1 crmul.4 mulcli cB cC
      crmul.2 crmul.3 mulcli axicn adddiri opreq2i 3eqtr4i cA cC cmul co cB cD
      cmul co cneg caddc co cA cC cmul co cB cD cmul co cmin co cA cD cmul co
      cB cC cmul co caddc co ci cmul co caddc cA cC cmul co cB cD cmul co cA cC
      crmul.1 crmul.3 mulcli cB cD crmul.2 crmul.4 mulcli negsubi opreq1i
      3eqtri cA cB ci cmul co caddc co cA ci cB cmul co caddc co cC cD ci cmul
      co caddc co cC ci cD cmul co caddc co cmul cB ci cmul co ci cB cmul co cA
      caddc cB ci crmul.2 axicn mulcomi opreq2i cD ci cmul co ci cD cmul co cC
      caddc cD ci crmul.4 axicn mulcomi opreq2i opreq12i cA cD cmul co cB cC
      cmul co caddc co ci cmul co ci cA cD cmul co cB cC cmul co caddc co cmul
      co cA cC cmul co cB cD cmul co cmin co caddc cA cD cmul co cB cC cmul co
      caddc co ci cA cD cmul co cB cC cmul co cA cD crmul.1 crmul.4 mulcli cB
      cC crmul.2 crmul.3 mulcli addcli axicn mulcomi opreq2i 3eqtr3i $.
      $( [11-Mar-2008] $) $( [29-Apr-2005] $)
  $}

  ${
    crrecz.1 $e |- A e. RR $.
    crrecz.2 $e |- B e. RR $.
    $( Reciprocal of a complex number in terms of real and imaginary
       components.  Remark in [Apostol] p. 361. $)
    crreczi $p |- ( ( A =/= 0 \/ B =/= 0 ) -> ( 1 / ( A + ( _i x. B ) ) ) =
                    ( ( A - ( _i x. B ) ) / ( ( A ^ 2 ) + ( B ^ 2 ) ) ) ) $=
      cA cc0 wne cB cc0 wne wo c1 cA ci cB cmul co caddc co cdiv co c1 cA ci cB
      cmul co cmin co cmul co cA ci cB cmul co caddc co cA ci cB cmul co cmin
      co cmul co cdiv co cA ci cB cmul co cmin co cA c2 cexp co cB c2 cexp co
      caddc co cdiv co cA cc0 wne cB cc0 wne wo c1 cA ci cB cmul co caddc co
      cdiv co cA ci cB cmul co cmin co cA ci cB cmul co cmin co cdiv co cmul co
      c1 cA ci cB cmul co caddc co cdiv co c1 cmul co c1 cA ci cB cmul co cmin
      co cmul co cA ci cB cmul co caddc co cA ci cB cmul co cmin co cmul co
      cdiv co c1 cA ci cB cmul co caddc co cdiv co cA cc0 wne cB cc0 wne wo cA
      ci cB cmul co cmin co cA ci cB cmul co cmin co cdiv co c1 c1 cA ci cB
      cmul co caddc co cdiv co cmul cA cc0 wne cB cc0 wne wo cA ci cB cmul co
      cmin co cc0 wne cA ci cB cmul co cmin co cA ci cB cmul co cmin co cdiv co
      c1 wceq cA cc0 wne cB cneg cc0 wne wo cA ci cB cneg cmul co caddc co cc0
      wne cA cc0 wne cB cc0 wne wo cA ci cB cmul co cmin co cc0 wne cA cB cneg
      crrecz.1 cB crrecz.2 renegcli crne0i cB cc0 wne cB cneg cc0 wne cA cc0
      wne cB cB crrecz.2 recni negne0bi orbi2i cA ci cB cmul co cmin co cA ci
      cB cneg cmul co caddc co cc0 cA ci cB cneg cmul co caddc co cA ci cB cmul
      co cneg caddc co cA ci cB cmul co cmin co ci cB cneg cmul co ci cB cmul
      co cneg cA caddc ci cB axicn cB crrecz.2 recni mulneg2i opreq2i cA ci cB
      cmul co cA crrecz.1 recni ci cB axicn cB crrecz.2 recni mulcli negsubi
      eqtr2i neeq1i 3bitr4i cA ci cB cmul co cmin co cc wcel cA ci cB cmul co
      cmin co cc0 wne cA ci cB cmul co cmin co cA ci cB cmul co cmin co cdiv co
      c1 wceq cA ci cB cmul co cA crrecz.1 recni ci cB axicn cB crrecz.2 recni
      mulcli subcli cA ci cB cmul co cmin co divid mpan sylbi opreq2d cA ci cB
      cmul co caddc co cc0 wne cA ci cB cmul co cmin co cc0 wne c1 cA ci cB
      cmul co caddc co cdiv co cA ci cB cmul co cmin co cA ci cB cmul co cmin
      co cdiv co cmul co c1 cA ci cB cmul co cmin co cmul co cA ci cB cmul co
      caddc co cA ci cB cmul co cmin co cmul co cdiv co wceq cA cc0 wne cB cc0
      wne wo cA ci cB cmul co caddc co cc wcel cA ci cB cmul co caddc co cc0
      wne cA ci cB cmul co cmin co cc0 wne c1 cA ci cB cmul co caddc co cdiv co
      cA ci cB cmul co cmin co cA ci cB cmul co cmin co cdiv co cmul co c1 cA
      ci cB cmul co cmin co cmul co cA ci cB cmul co caddc co cA ci cB cmul co
      cmin co cmul co cdiv co wceq cA ci cB cmul co cA crrecz.1 recni ci cB
      axicn cB crrecz.2 recni mulcli addcli cA ci cB cmul co caddc co cc wcel
      cA ci cB cmul co caddc co cc0 wne wa cA ci cB cmul co cmin co cc wcel cA
      ci cB cmul co cmin co cc0 wne c1 cA ci cB cmul co caddc co cdiv co cA ci
      cB cmul co cmin co cA ci cB cmul co cmin co cdiv co cmul co c1 cA ci cB
      cmul co cmin co cmul co cA ci cB cmul co caddc co cA ci cB cmul co cmin
      co cmul co cdiv co wceq cA ci cB cmul co cA crrecz.1 recni ci cB axicn cB
      crrecz.2 recni mulcli subcli c1 cc wcel cA ci cB cmul co cmin co cc wcel
      cA ci cB cmul co caddc co cc wcel cA ci cB cmul co caddc co cc0 wne wa cA
      ci cB cmul co cmin co cc wcel cA ci cB cmul co cmin co cc0 wne wa wa c1
      cA ci cB cmul co caddc co cdiv co cA ci cB cmul co cmin co cA ci cB cmul
      co cmin co cdiv co cmul co c1 cA ci cB cmul co cmin co cmul co cA ci cB
      cmul co caddc co cA ci cB cmul co cmin co cmul co cdiv co wceq ax1cn cA
      ci cB cmul co cA crrecz.1 recni ci cB axicn cB crrecz.2 recni mulcli
      subcli c1 cA ci cB cmul co cmin co cA ci cB cmul co caddc co cA ci cB
      cmul co cmin co divmuldiv mpanl12 mpanr1 mpanl1 cA cB crrecz.1 crrecz.2
      crne0i cA cc0 wne cB cneg cc0 wne wo cA ci cB cneg cmul co caddc co cc0
      wne cA cc0 wne cB cc0 wne wo cA ci cB cmul co cmin co cc0 wne cA cB cneg
      crrecz.1 cB crrecz.2 renegcli crne0i cB cc0 wne cB cneg cc0 wne cA cc0
      wne cB cB crrecz.2 recni negne0bi orbi2i cA ci cB cmul co cmin co cA ci
      cB cneg cmul co caddc co cc0 cA ci cB cneg cmul co caddc co cA ci cB cmul
      co cneg caddc co cA ci cB cmul co cmin co ci cB cneg cmul co ci cB cmul
      co cneg cA caddc ci cB axicn cB crrecz.2 recni mulneg2i opreq2i cA ci cB
      cmul co cA crrecz.1 recni ci cB axicn cB crrecz.2 recni mulcli negsubi
      eqtr2i neeq1i 3bitr4i sylancb cA cc0 wne cB cc0 wne wo c1 cA ci cB cmul
      co caddc co cdiv co cc wcel c1 cA ci cB cmul co caddc co cdiv co c1 cmul
      co c1 cA ci cB cmul co caddc co cdiv co wceq cA cc0 wne cB cc0 wne wo cA
      ci cB cmul co caddc co cc0 wne c1 cA ci cB cmul co caddc co cdiv co cc
      wcel cA cB crrecz.1 crrecz.2 crne0i cA ci cB cmul co caddc co cA ci cB
      cmul co cA crrecz.1 recni ci cB axicn cB crrecz.2 recni mulcli addcli
      recclzi sylbi c1 cA ci cB cmul co caddc co cdiv co ax1id syl 3eqtr3rd c1
      cA ci cB cmul co cmin co cmul co cA ci cB cmul co cmin co cA ci cB cmul
      co caddc co cA ci cB cmul co cmin co cmul co cA c2 cexp co cB c2 cexp co
      caddc co cdiv cA ci cB cmul co cmin co cA ci cB cmul co cA crrecz.1 recni
      ci cB axicn cB crrecz.2 recni mulcli subcli mulid2i cA ci cB cmul co
      caddc co cA ci cB cmul co cmin co cmul co cA c2 cexp co ci cB cmul co c2
      cexp co cmin co cA c2 cexp co ci cB cmul co c2 cexp co cneg caddc co cA
      c2 cexp co cB c2 cexp co caddc co cA ci cB cmul co cA crrecz.1 recni ci
      cB axicn cB crrecz.2 recni mulcli binom2aiOLD cA c2 cexp co ci cB cmul co
      c2 cexp co cA cA crrecz.1 recni sqcli ci cB cmul co ci cB axicn cB
      crrecz.2 recni mulcli sqcli negsubi ci cB cmul co c2 cexp co cneg cB c2
      cexp co cA c2 cexp co caddc ci cB cmul co c2 cexp co cneg c1 cB c2 cexp
      co cmul co cneg cneg c1 cB c2 cexp co cmul co cB c2 cexp co ci cB cmul co
      c2 cexp co c1 cB c2 cexp co cmul co cneg ci cB cmul co c2 cexp co ci c2
      cexp co cB c2 cexp co cmul co c1 cneg cB c2 cexp co cmul co c1 cB c2 cexp
      co cmul co cneg ci cB axicn cB crrecz.2 recni sqmuli ci c2 cexp co c1
      cneg cB c2 cexp co cmul i2 opreq1i c1 cB c2 cexp co ax1cn cB cB crrecz.2
      recni sqcli mulneg1i 3eqtri negeqi c1 cB c2 cexp co cmul co c1 cB c2 cexp
      co ax1cn cB cB crrecz.2 recni sqcli mulcli negnegi cB c2 cexp co cB cB
      crrecz.2 recni sqcli mulid2i 3eqtri opreq2i 3eqtr2i opreq12i syl6eq $.
      $( [11-Mar-2008] $) $( [29-Apr-2005] $)
  $}

  ${
    $d x y z w A $.
    $( The real part of a complex number is unique.  Proposition
       10-1.3 of [Gleason] p. 130. $)
    creur $p |- ( A e. CC -> E! x e. RR E. y e. RR A = ( x + ( _i x. y ) ) ) $=
      cA cc wcel cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex
      cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA vz cv ci vw cv cmul
      co caddc co wceq vw cr wrex wa vx cv vz cv wceq wi vz cr wral vx cr wral
      wa cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wreu cA cc
      wcel cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex cA vx
      cv ci vy cv cmul co caddc co wceq vy cr wrex cA vz cv ci vw cv cmul co
      caddc co wceq vw cr wrex wa vx cv vz cv wceq wi vz cr wral vx cr wral vx
      vy cA axcnre cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA vz cv
      ci vw cv cmul co caddc co wceq vw cr wrex wa vx cv vz cv wceq wi vx vz cr
      vx cv cr wcel vz cv cr wcel wa vy cv cr wcel cA vx cv ci vy cv cmul co
      caddc co wceq wa vw cv cr wcel cA vz cv ci vw cv cmul co caddc co wceq wa
      wa vw wex vy wex vx cv vz cv wceq cA vx cv ci vy cv cmul co caddc co wceq
      vy cr wrex cA vz cv ci vw cv cmul co caddc co wceq vw cr wrex wa vx cv cr
      wcel vz cv cr wcel wa vy cv cr wcel cA vx cv ci vy cv cmul co caddc co
      wceq wa vw cv cr wcel cA vz cv ci vw cv cmul co caddc co wceq wa wa vx cv
      vz cv wceq vy vw vx cv cr wcel vz cv cr wcel wa vy cv cr wcel vw cv cr
      wcel wa cA vx cv ci vy cv cmul co caddc co wceq cA vz cv ci vw cv cmul co
      caddc co wceq wa wa vx cv vz cv wceq vy cv cr wcel cA vx cv ci vy cv cmul
      co caddc co wceq wa vw cv cr wcel cA vz cv ci vw cv cmul co caddc co wceq
      wa wa vx cv cr wcel vz cv cr wcel wa vy cv cr wcel vw cv cr wcel wa cA vx
      cv ci vy cv cmul co caddc co wceq cA vz cv ci vw cv cmul co caddc co wceq
      wa vx cv vz cv wceq vx cv cr wcel vy cv cr wcel vz cv cr wcel vw cv cr
      wcel cA vx cv ci vy cv cmul co caddc co wceq cA vz cv ci vw cv cmul co
      caddc co wceq wa vx cv vz cv wceq wi vx cv cr wcel vy cv cr wcel wa vz cv
      cr wcel vw cv cr wcel wa wa vx cv ci vy cv cmul co caddc co vz cv ci vw
      cv cmul co caddc co wceq vx cv vz cv wceq cA vx cv ci vy cv cmul co caddc
      co wceq cA vz cv ci vw cv cmul co caddc co wceq wa vx cv cr wcel vy cv cr
      wcel wa vz cv cr wcel vw cv cr wcel wa wa vx cv ci vy cv cmul co caddc co
      vz cv ci vw cv cmul co caddc co wceq vx cv vz cv wceq vy cv vw cv wceq wa
      vx cv vz cv wceq vx cv vy cv vz cv vw cv cru vx cv vz cv wceq vy cv vw cv
      wceq pm3.26 syl6bi cA vx cv ci vy cv cmul co caddc co vz cv ci vw cv cmul
      co caddc co eqtr2 syl5 an4s expimpd vy cv cr wcel cA vx cv ci vy cv cmul
      co caddc co wceq vw cv cr wcel cA vz cv ci vw cv cmul co caddc co wceq
      an4 syl5ib 19.23advv cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex
      cA vz cv ci vw cv cmul co caddc co wceq vw cr wrex wa vy cv cr wcel cA vx
      cv ci vy cv cmul co caddc co wceq wa vy wex vw cv cr wcel cA vz cv ci vw
      cv cmul co caddc co wceq wa vw wex wa vy cv cr wcel cA vx cv ci vy cv
      cmul co caddc co wceq wa vw cv cr wcel cA vz cv ci vw cv cmul co caddc co
      wceq wa wa vw wex vy wex cA vx cv ci vy cv cmul co caddc co wceq vy cr
      wrex vy cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa vy wex cA
      vz cv ci vw cv cmul co caddc co wceq vw cr wrex vw cv cr wcel cA vz cv ci
      vw cv cmul co caddc co wceq wa vw wex cA vx cv ci vy cv cmul co caddc co
      wceq vy cr df-rex cA vz cv ci vw cv cmul co caddc co wceq vw cr df-rex
      anbi12i vy cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa vw cv cr
      wcel cA vz cv ci vw cv cmul co caddc co wceq wa vy vw eeanv bitr4i syl5ib
      rgen2a jctir cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA vz cv
      ci vw cv cmul co caddc co wceq vw cr wrex vx vz cr vx cv vz cv wceq cA vx
      cv ci vy cv cmul co caddc co wceq vy cr wrex cA vz cv ci vy cv cmul co
      caddc co wceq vy cr wrex cA vz cv ci vw cv cmul co caddc co wceq vw cr
      wrex vx cv vz cv wceq cA vx cv ci vy cv cmul co caddc co wceq cA vz cv ci
      vy cv cmul co caddc co wceq vy cr vx cv vz cv wceq vx cv ci vy cv cmul co
      caddc co vz cv ci vy cv cmul co caddc co cA vx cv vz cv ci vy cv cmul co
      caddc opreq1 eqeq2d rexbidv cA vz cv ci vy cv cmul co caddc co wceq cA vz
      cv ci vw cv cmul co caddc co wceq vy vw cr vy cv vw cv wceq vz cv ci vy
      cv cmul co caddc co vz cv ci vw cv cmul co caddc co cA vy cv vw cv wceq
      ci vy cv cmul co ci vw cv cmul co vz cv caddc vy cv vw cv ci cmul opreq2
      opreq2d eqeq2d cbvrexv syl6bb reu4 sylibr $.
      $( [11-Mar-2008] $) $( [9-May-1999] $)

    $( The imaginary part of a complex number is unique.  Proposition
       10-1.3 of [Gleason] p. 130. $)
    creui $p |- ( A e. CC -> E! y e. RR E. x e. RR A = ( x + ( _i x. y ) ) ) $=
      cA cc wcel cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr wrex
      cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA vz cv ci vw cv cmul
      co caddc co wceq vz cr wrex wa vy cv vw cv wceq wi vw cr wral vy cr wral
      wa cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr wreu cA cc
      wcel cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr wrex cA vx
      cv ci vy cv cmul co caddc co wceq vx cr wrex cA vz cv ci vw cv cmul co
      caddc co wceq vz cr wrex wa vy cv vw cv wceq wi vw cr wral vy cr wral cA
      cc wcel cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr wrex cA
      vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr wrex vx vy cA
      axcnre cA vx cv ci vy cv cmul co caddc co wceq vx vy cr cr rexcom sylib
      cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA vz cv ci vw cv cmul
      co caddc co wceq vz cr wrex wa vy cv vw cv wceq wi vy vw cr vy cv cr wcel
      vw cv cr wcel wa vx cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa
      vz cv cr wcel cA vz cv ci vw cv cmul co caddc co wceq wa wa vz wex vx wex
      vy cv vw cv wceq cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA vz
      cv ci vw cv cmul co caddc co wceq vz cr wrex wa vy cv cr wcel vw cv cr
      wcel wa vx cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa vz cv cr
      wcel cA vz cv ci vw cv cmul co caddc co wceq wa wa vy cv vw cv wceq vx vz
      vy cv cr wcel vw cv cr wcel wa vx cv cr wcel vz cv cr wcel wa cA vx cv ci
      vy cv cmul co caddc co wceq cA vz cv ci vw cv cmul co caddc co wceq wa wa
      vy cv vw cv wceq vx cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa
      vz cv cr wcel cA vz cv ci vw cv cmul co caddc co wceq wa wa vy cv cr wcel
      vw cv cr wcel wa vx cv cr wcel vz cv cr wcel wa cA vx cv ci vy cv cmul co
      caddc co wceq cA vz cv ci vw cv cmul co caddc co wceq wa vy cv vw cv wceq
      vx cv cr wcel vz cv cr wcel wa vy cv cr wcel vw cv cr wcel wa cA vx cv ci
      vy cv cmul co caddc co wceq cA vz cv ci vw cv cmul co caddc co wceq wa vy
      cv vw cv wceq wi vx cv cr wcel vy cv cr wcel vz cv cr wcel vw cv cr wcel
      cA vx cv ci vy cv cmul co caddc co wceq cA vz cv ci vw cv cmul co caddc
      co wceq wa vy cv vw cv wceq wi vx cv cr wcel vy cv cr wcel wa vz cv cr
      wcel vw cv cr wcel wa wa vx cv ci vy cv cmul co caddc co vz cv ci vw cv
      cmul co caddc co wceq vy cv vw cv wceq cA vx cv ci vy cv cmul co caddc co
      wceq cA vz cv ci vw cv cmul co caddc co wceq wa vx cv cr wcel vy cv cr
      wcel wa vz cv cr wcel vw cv cr wcel wa wa vx cv ci vy cv cmul co caddc co
      vz cv ci vw cv cmul co caddc co wceq vx cv vz cv wceq vy cv vw cv wceq wa
      vy cv vw cv wceq vx cv vy cv vz cv vw cv cru vx cv vz cv wceq vy cv vw cv
      wceq pm3.27 syl6bi cA vx cv ci vy cv cmul co caddc co vz cv ci vw cv cmul
      co caddc co eqtr2 syl5 an4s expcom imp3a vx cv cr wcel cA vx cv ci vy cv
      cmul co caddc co wceq vz cv cr wcel cA vz cv ci vw cv cmul co caddc co
      wceq an4 syl5ib 19.23advv cA vx cv ci vy cv cmul co caddc co wceq vx cr
      wrex cA vz cv ci vw cv cmul co caddc co wceq vz cr wrex wa vx cv cr wcel
      cA vx cv ci vy cv cmul co caddc co wceq wa vx wex vz cv cr wcel cA vz cv
      ci vw cv cmul co caddc co wceq wa vz wex wa vx cv cr wcel cA vx cv ci vy
      cv cmul co caddc co wceq wa vz cv cr wcel cA vz cv ci vw cv cmul co caddc
      co wceq wa wa vz wex vx wex cA vx cv ci vy cv cmul co caddc co wceq vx cr
      wrex vx cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa vx wex cA
      vz cv ci vw cv cmul co caddc co wceq vz cr wrex vz cv cr wcel cA vz cv ci
      vw cv cmul co caddc co wceq wa vz wex cA vx cv ci vy cv cmul co caddc co
      wceq vx cr df-rex cA vz cv ci vw cv cmul co caddc co wceq vz cr df-rex
      anbi12i vx cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq wa vz cv cr
      wcel cA vz cv ci vw cv cmul co caddc co wceq wa vx vz eeanv bitr4i syl5ib
      rgen2a jctir cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA vz cv
      ci vw cv cmul co caddc co wceq vz cr wrex vy vw cr vy cv vw cv wceq cA vx
      cv ci vy cv cmul co caddc co wceq vx cr wrex cA vx cv ci vw cv cmul co
      caddc co wceq vx cr wrex cA vz cv ci vw cv cmul co caddc co wceq vz cr
      wrex vy cv vw cv wceq cA vx cv ci vy cv cmul co caddc co wceq cA vx cv ci
      vw cv cmul co caddc co wceq vx cr vy cv vw cv wceq vx cv ci vy cv cmul co
      caddc co vx cv ci vw cv cmul co caddc co cA vy cv vw cv wceq ci vy cv
      cmul co ci vw cv cmul co vx cv caddc vy cv vw cv ci cmul opreq2 opreq2d
      eqeq2d rexbidv cA vx cv ci vw cv cmul co caddc co wceq cA vz cv ci vw cv
      cmul co caddc co wceq vx vz cr vx cv vz cv wceq vx cv ci vw cv cmul co
      caddc co vz cv ci vw cv cmul co caddc co cA vx cv vz cv ci vw cv cmul co
      caddc opreq1 eqeq2d cbvrexv syl6bb reu4 sylibr $.
      $( [11-Mar-2008] $) $( [9-May-1999] $)
  $}

  $( A real number times the imaginary unit is real only if the number is 0. $)
  rimul $p |- ( ( A e. RR /\ ( _i x. A ) e. RR ) -> A = 0 ) $=
    cA cr wcel ci cA cmul co cr wcel wa cc0 ci cA cmul co wceq cA cc0 wceq cA
    cr wcel ci cA cmul co cr wcel wa cc0 ci cA cmul co caddc co ci cA cmul co
    ci cc0 cmul co caddc co wceq cc0 ci cA cmul co wceq cA cc0 wceq wa ci cA
    cmul co cr wcel cc0 ci cA cmul co caddc co ci cA cmul co ci cc0 cmul co
    caddc co wceq cA cr wcel ci cA cmul co cr wcel ci cA cmul co cc wcel cc0 ci
    cA cmul co caddc co ci cA cmul co ci cc0 cmul co caddc co wceq ci cA cmul
    co recn ci cA cmul co cc wcel ci cc0 cmul co ci cA cmul co caddc co ci cA
    cmul co ci cc0 cmul co caddc co cc0 ci cA cmul co caddc co ci cc0 cmul co
    cc wcel ci cA cmul co cc wcel ci cc0 cmul co ci cA cmul co caddc co ci cA
    cmul co ci cc0 cmul co caddc co wceq ci cc0 axicn 0cn mulcli ci cc0 cmul co
    ci cA cmul co addcom mpan ci cc0 cmul co cc0 ci cA cmul co caddc ci axicn
    mul01i opreq1i syl5eqr syl adantl cc0 cr wcel cA cr wcel ci cA cmul co cr
    wcel cc0 ci cA cmul co caddc co ci cA cmul co ci cc0 cmul co caddc co wceq
    cc0 ci cA cmul co wceq cA cc0 wceq wa wb 0re cc0 cr wcel cA cr wcel wa ci
    cA cmul co cr wcel cc0 cr wcel cc0 ci cA cmul co caddc co ci cA cmul co ci
    cc0 cmul co caddc co wceq cc0 ci cA cmul co wceq cA cc0 wceq wa wb 0re cc0
    cA ci cA cmul co cc0 cru mpanr2 mpanl1 mpbid pm3.27d $.
    $( [11-Mar-2008] $) $( [28-May-1999] $)

  ${
    $( The sequence ` NN ` , ` ZZ ` , ` QQ ` , ` RR ` , and ` CC ` forms
       a chain of proper subsets.  In each case the proper subset
       relationship is shown by demonstrating a number that belongs to
       one set but not the other.  We show that zero belongs to ` ZZ `
       but not ` NN ` , one-half belongs to ` QQ ` but not ` ZZ ` ,
       the square root of 2 belongs to ` RR ` but not ` QQ ` , and finally
       that the imaginary number ` _i ` belongs to ` CC ` but not ` RR ` .
       See ~ nthruz for a further refinement. $)
    nthruc $p |- ( ( NN C. ZZ /\ ZZ C. QQ ) /\ ( QQ C. RR /\ RR C. CC ) ) $=
      cn cz wpss cz cq wpss wa cq cr wpss cr cc wpss wa cn cz wpss cz cq wpss
      cn cz wss cc0 cz wcel cc0 cn wcel wn wa cn cz wpss nnssz cc0 cz wcel cc0
      cn wcel wn 0z 0nnn pm3.2i cn cz cc0 ssnelpss mp2 cz cq wss c1 c2 cdiv co
      cq wcel c1 c2 cdiv co cz wcel wn wa cz cq wpss zssq c1 c2 cdiv co cq wcel
      c1 c2 cdiv co cz wcel wn c1 cz wcel c2 cn wcel c1 c2 cdiv co cq wcel 1z
      2nn c1 c2 znq mp2an halfnz pm3.2i cz cq c1 c2 cdiv co ssnelpss mp2 pm3.2i
      cq cr wpss cr cc wpss cq cr wss c2 csqr cfv cr wcel c2 csqr cfv cq wcel
      wn wa cq cr wpss qssre c2 csqr cfv cr wcel c2 csqr cfv cq wcel wn sqr2re
      c2 csqr cfv cq wnel c2 csqr cfv cq wcel wn sqr2irr c2 csqr cfv cq df-nel
      mpbi pm3.2i cq cr c2 csqr cfv ssnelpss mp2 cr cc wss ci cc wcel ci cr
      wcel wn wa cr cc wpss axresscn ci cc wcel ci cr wcel wn axicn inelr
      pm3.2i cr cc ci ssnelpss mp2 pm3.2i pm3.2i $.
      $( [12-Jan-2002] $)
  $}

  ${
    $( The sequence ` NN ` , ` NN0 ` , and ` ZZ ` forms a chain of proper
       subsets.  In each case the proper subset relationship is shown by
       demonstrating a number that belongs to one set but not the other.  We
       show that zero belongs to ` NN0 ` but not ` NN ` and minus one belongs
       to ` ZZ ` but not ` NN0 ` .  This theorem refines the chain of proper
       subsets ~ nthruc . $)
    nthruz $p |- ( NN C. NN0 /\ NN0 C. ZZ ) $=
      cn cn0 wpss cn0 cz wpss cn cn0 wss cc0 cn0 wcel cc0 cn wcel wn wa cn cn0
      wpss nnssnn0 cc0 cn0 wcel cc0 cn wcel wn 0nn0 0nnn pm3.2i cn cn0 cc0
      ssnelpss mp2 cn0 cz wss c1 cneg cz wcel c1 cneg cn0 wcel wn wa cn0 cz
      wpss nn0ssz c1 cneg cz wcel c1 cneg cn0 wcel wn c1 cn wcel c1 cneg cz
      wcel 1nn c1 nnnegz ax-mp c1 cneg cr wcel c1 cneg cc0 clt wbr c1 cneg cn0
      wcel wn c1 1re renegcli c1 cneg cc0 clt wbr cc0 cneg c1 clt wbr cc0 cneg
      cc0 c1 clt neg0 lt01 eqbrtri c1 cc0 1re 0re ltnegcon1i mpbir c1 cneg
      lt0nnn0 mp2an pm3.2i cn0 cz c1 cneg ssnelpss mp2 pm3.2i $.
      $( [25-Jul-2004] $) $( [9-May-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Real and imaginary parts; conjugate; absolute value
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Re $. $( Real part of a complex number. $)
  $c Im $. $( Imaginary part of a complex number. $)
  $c * $. $( Complex conjugate function. $)
  $c abs $. $( Absolute value function. $)

  $( Extend class notation to include real part of a complex number. $)
  cre $a class Re $.

  $( Extend class notation to include imaginary part of a complex number. $)
  cim $a class Im $.

  $( Extend class notation to include complex conjugate function. $)
  ccj $a class * $.

  $( Extend class notation to include a function for the absolute value
     (modulus) of a complex number. $)
  cabs $a class abs $.

  ${
    $d x y z w $.
    $( Define a function whose value is the real part of a complex number.
       See ~ reval for its value, ~ recli for its closure, and ~ replim
       for its use in decomposing a complex number. $)
    df-re $a |- Re = { <. x , y >. | ( x e. CC /\
                 y = U. { z e. RR | E. w e. RR x = ( z + ( _i x. w ) ) } ) } $.

    $( Define a function whose value is the imaginary part of a complex
       number.  See ~ imval for its value, ~ imcli for its closure, and
       ~ replim for its use in decomposing a complex number. $)
    df-im $a |- Im = { <. x , y >. | ( x e. CC /\
                 y = U. { w e. RR | E. z e. RR x = ( z + ( _i x. w ) ) } ) } $.

    $( Define the complex conjugate function.  See ~ cjcli for its closure and
       ~ cjval for its value. $)
    df-cj $a |- * = { <. x , y >. | ( x e. CC /\
                        y = ( ( Re ` x ) - ( _i x. ( Im ` x ) ) ) ) } $.

    $( Define the function for the absolute value (modulus) of a complex
       number.  See ~ abscli for its closure and ~ absval or ~ absval2i
       for its value. $)
    df-abs $a |- abs = { <. x , y >. | ( x e. CC /\ y = ( sqr `
                 ( x x. ( * ` x ) ) ) ) } $.
  $}

  ${
    $d x y z w A $.
    $( The value of the real part of a complex number. $)
    reval $p |- ( A e. CC ->
        ( Re ` A ) = U. { x e. RR | E. y e. RR A = ( x + ( _i x. y ) ) } ) $=
      vz vw cA vz cv vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr crab
      cuni cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr crab cuni
      cc cre vz cv cA wceq vz cv vx cv ci vy cv cmul co caddc co wceq vy cr
      wrex vx cr crab cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr
      crab vz cv cA wceq vz cv vx cv ci vy cv cmul co caddc co wceq vy cr wrex
      cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr vz cv cA wceq vz
      cv vx cv ci vy cv cmul co caddc co wceq cA vx cv ci vy cv cmul co caddc
      co wceq vy cr vz cv cA vx cv ci vy cv cmul co caddc co eqeq1 rexbidv
      rabbisdv unieqd vz vw vx vy df-re cA vx cv ci vy cv cmul co caddc co wceq
      vy cr wrex vx cr crab cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex
      vx cr reex rabex uniex fvopab4 $.
      $( [11-Mar-2008] $) $( [9-May-1999] $)

    $( The value of the imaginary part of a complex number. $)
    imval $p |- ( A e. CC ->
        ( Im ` A ) = U. { y e. RR | E. x e. RR A = ( x + ( _i x. y ) ) } ) $=
      vz vw cA vz cv vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr crab
      cuni cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr crab cuni
      cc cim vz cv cA wceq vz cv vx cv ci vy cv cmul co caddc co wceq vx cr
      wrex vy cr crab cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr
      crab vz cv cA wceq vz cv vx cv ci vy cv cmul co caddc co wceq vx cr wrex
      cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr vz cv cA wceq vz
      cv vx cv ci vy cv cmul co caddc co wceq cA vx cv ci vy cv cmul co caddc
      co wceq vx cr vz cv cA vx cv ci vy cv cmul co caddc co eqeq1 rexbidv
      rabbisdv unieqd vz vw vx vy df-im cA vx cv ci vy cv cmul co caddc co wceq
      vx cr wrex vy cr crab cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex
      vy cr reex rabex uniex fvopab4 $.
      $( [11-Mar-2008] $) $( [9-May-1999] $)

    $( The real part of a complex number is real. $)
    recl $p |- ( A e. CC -> ( Re ` A ) e. RR ) $=
      cA cc wcel cA cre cfv cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex
      vx cr crab cuni cr vx vy cA reval cA cc wcel cA vx cv ci vy cv cmul co
      caddc co wceq vy cr wrex vx cr wreu cA vx cv ci vy cv cmul co caddc co
      wceq vy cr wrex vx cr crab cuni cr wcel vx vy cA creur cA vx cv ci vy cv
      cmul co caddc co wceq vy cr wrex vx cr reucl syl eqeltrd $.
      $( [9-May-1999] $)

    $( The imaginary part of a complex number is real. $)
    imcl $p |- ( A e. CC -> ( Im ` A ) e. RR ) $=
      cA cc wcel cA cim cfv cA vy cv ci vx cv cmul co caddc co wceq vy cr wrex
      vx cr crab cuni cr vy vx cA imval cA cc wcel cA vy cv ci vx cv cmul co
      caddc co wceq vy cr wrex vx cr wreu cA vy cv ci vx cv cmul co caddc co
      wceq vy cr wrex vx cr crab cuni cr wcel vy vx cA creui cA vy cv ci vx cv
      cmul co caddc co wceq vy cr wrex vx cr reucl syl eqeltrd $.
      $( [9-May-1999] $)

    $( Domain and codomain of the real part function.  (Contributed by Paul
       Chapman, 22-Oct-2007.) $)
    ref $p |- Re : CC --> RR $=
      cc cr cre wf cre cc wfn vx cv cre cfv cr wcel vx cc wral vx cc cr cre
      ffnfv vx vy cc vx cv vz cv ci vw cv cmul co caddc co wceq vw cr wrex vz
      cr crab cuni cre vx cv vz cv ci vw cv cmul co caddc co wceq vw cr wrex vz
      cr crab vx cv vz cv ci vw cv cmul co caddc co wceq vw cr wrex vz cr reex
      rabex uniex vx vy vz vw df-re fnopab2 vx cv cre cfv cr wcel vx cc vx cv
      recl rgen mpbir2an $.
      $( [22-Oct-2007] $) $( [22-Oct-2007] $)

    $( Domain and codomain of the imaginary part function. (Contributed by Paul
       Chapman, 22-Oct-2007.) $)
    imf $p |- Im : CC --> RR $=
      cc cr cim wf cim cc wfn vx cv cim cfv cr wcel vx cc wral vx cc cr cim
      ffnfv vx vy cc vx cv vw cv ci vz cv cmul co caddc co wceq vw cr wrex vz
      cr crab cuni cim vx cv vw cv ci vz cv cmul co caddc co wceq vw cr wrex vz
      cr crab vx cv vw cv ci vz cv cmul co caddc co wceq vw cr wrex vz cr reex
      rabex uniex vx vy vw vz df-im fnopab2 vx cv cim cfv cr wcel vx cc vx cv
      imcl rgen mpbir2an $.
      $( [22-Oct-2007] $) $( [22-Oct-2007] $)

    $( Reconstruct a complex number from its real and imaginary parts. $)
    replim $p |- ( A e. CC -> A = ( ( Re ` A ) + ( _i x. ( Im ` A ) ) ) ) $=
      cA cc wcel vx cv cr wcel vy cv cr wcel wa cA vx cv ci cA cim cfv cmul co
      caddc co wceq cA cA cre cfv ci vy cv cmul co caddc co wceq wa wa vy wex
      vx wex cA cA cre cfv ci cA cim cfv cmul co caddc co wceq vx cv cr wcel vy
      cv cr wcel wa cA vx cv ci cA cim cfv cmul co caddc co wceq cA cA cre cfv
      ci vy cv cmul co caddc co wceq wa wa vy wex vx wex vx cv cr wcel cA vx cv
      ci cA cim cfv cmul co caddc co wceq wa vx wex vy cv cr wcel cA cA cre cfv
      ci vy cv cmul co caddc co wceq wa vy wex cA cc wcel vx cv cr wcel vy cv
      cr wcel wa cA vx cv ci cA cim cfv cmul co caddc co wceq cA cA cre cfv ci
      vy cv cmul co caddc co wceq wa wa vy wex vx wex vx cv cr wcel cA vx cv ci
      cA cim cfv cmul co caddc co wceq wa vy cv cr wcel cA cA cre cfv ci vy cv
      cmul co caddc co wceq wa wa vy wex vx wex vx cv cr wcel cA vx cv ci cA
      cim cfv cmul co caddc co wceq wa vx wex vy cv cr wcel cA cA cre cfv ci vy
      cv cmul co caddc co wceq wa vy wex wa vx cv cr wcel vy cv cr wcel wa cA
      vx cv ci cA cim cfv cmul co caddc co wceq cA cA cre cfv ci vy cv cmul co
      caddc co wceq wa wa vx cv cr wcel cA vx cv ci cA cim cfv cmul co caddc co
      wceq wa vy cv cr wcel cA cA cre cfv ci vy cv cmul co caddc co wceq wa wa
      vx vy vx cv cr wcel vy cv cr wcel cA vx cv ci cA cim cfv cmul co caddc co
      wceq cA cA cre cfv ci vy cv cmul co caddc co wceq an4 2exbii vx cv cr
      wcel cA vx cv ci cA cim cfv cmul co caddc co wceq wa vy cv cr wcel cA cA
      cre cfv ci vy cv cmul co caddc co wceq wa vx vy eeanv bitri cA cc wcel cA
      vx cv ci cA cim cfv cmul co caddc co wceq vx cr wrex vx cv cr wcel cA vx
      cv ci cA cim cfv cmul co caddc co wceq wa vx wex cA cc wcel cA vx cv ci
      cA cim cfv cmul co caddc co wceq vx cr wrex cA cim cfv cA cim cfv wceq cA
      cim cfv eqid cA cim cfv cr wcel cA cc wcel cA vx cv ci cA cim cfv cmul co
      caddc co wceq vx cr wrex cA cim cfv cA cim cfv wceq wb cA imcl cA cc wcel
      cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA cim cfv vy cv wceq
      wb wi cA cc wcel cA vx cv ci cA cim cfv cmul co caddc co wceq vx cr wrex
      cA cim cfv cA cim cfv wceq wb wi vy cA cim cfv cr vy cv cA cim cfv wceq
      cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA cim cfv vy cv wceq
      wb cA vx cv ci cA cim cfv cmul co caddc co wceq vx cr wrex cA cim cfv cA
      cim cfv wceq wb cA cc wcel vy cv cA cim cfv wceq cA vx cv ci vy cv cmul
      co caddc co wceq vx cr wrex cA vx cv ci cA cim cfv cmul co caddc co wceq
      vx cr wrex cA cim cfv vy cv wceq cA cim cfv cA cim cfv wceq vy cv cA cim
      cfv wceq cA vx cv ci vy cv cmul co caddc co wceq cA vx cv ci cA cim cfv
      cmul co caddc co wceq vx cr vy cv cA cim cfv wceq vx cv ci vy cv cmul co
      caddc co vx cv ci cA cim cfv cmul co caddc co cA vy cv cA cim cfv wceq ci
      vy cv cmul co ci cA cim cfv cmul co vx cv caddc vy cv cA cim cfv ci cmul
      opreq2 opreq2d eqeq2d rexbidv vy cv cA cim cfv cA cim cfv eqeq2 bibi12d
      imbi2d vy cv cr wcel cA cc wcel cA vx cv ci vy cv cmul co caddc co wceq
      vx cr wrex cA cim cfv vy cv wceq wb vy cv cr wcel cA cc wcel wa cA vx cv
      ci vy cv cmul co caddc co wceq vx cr wrex cA vx cv ci vy cv cmul co caddc
      co wceq vx cr wrex vy cr crab cuni vy cv wceq cA cim cfv vy cv wceq vy cv
      cr wcel cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr wreu cA
      vx cv ci vy cv cmul co caddc co wceq vx cr wrex cA vx cv ci vy cv cmul co
      caddc co wceq vx cr wrex vy cr crab cuni vy cv wceq wb cA cc wcel cA vx
      cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr reuuni1 vx vy cA creui
      sylan2 cA cc wcel cA cim cfv vy cv wceq cA vx cv ci vy cv cmul co caddc
      co wceq vx cr wrex vy cr crab cuni vy cv wceq wb vy cv cr wcel cA cc wcel
      cA cim cfv cA vx cv ci vy cv cmul co caddc co wceq vx cr wrex vy cr crab
      cuni vy cv vx vy cA imval eqeq1d adantl bitr4d ex vtoclga mpcom mpbiri cA
      vx cv ci cA cim cfv cmul co caddc co wceq vx cr df-rex sylib cA cc wcel
      cA cA cre cfv ci vy cv cmul co caddc co wceq vy cr wrex vy cv cr wcel cA
      cA cre cfv ci vy cv cmul co caddc co wceq wa vy wex cA cc wcel cA cA cre
      cfv ci vy cv cmul co caddc co wceq vy cr wrex cA cre cfv cA cre cfv wceq
      cA cre cfv eqid cA cre cfv cr wcel cA cc wcel cA cA cre cfv ci vy cv cmul
      co caddc co wceq vy cr wrex cA cre cfv cA cre cfv wceq wb cA recl cA cc
      wcel cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA cre cfv vx cv
      wceq wb wi cA cc wcel cA cA cre cfv ci vy cv cmul co caddc co wceq vy cr
      wrex cA cre cfv cA cre cfv wceq wb wi vx cA cre cfv cr vx cv cA cre cfv
      wceq cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA cre cfv vx cv
      wceq wb cA cA cre cfv ci vy cv cmul co caddc co wceq vy cr wrex cA cre
      cfv cA cre cfv wceq wb cA cc wcel vx cv cA cre cfv wceq cA vx cv ci vy cv
      cmul co caddc co wceq vy cr wrex cA cA cre cfv ci vy cv cmul co caddc co
      wceq vy cr wrex cA cre cfv vx cv wceq cA cre cfv cA cre cfv wceq vx cv cA
      cre cfv wceq cA vx cv ci vy cv cmul co caddc co wceq cA cA cre cfv ci vy
      cv cmul co caddc co wceq vy cr vx cv cA cre cfv wceq vx cv ci vy cv cmul
      co caddc co cA cre cfv ci vy cv cmul co caddc co cA vx cv cA cre cfv ci
      vy cv cmul co caddc opreq1 eqeq2d rexbidv vx cv cA cre cfv cA cre cfv
      eqeq2 bibi12d imbi2d vx cv cr wcel cA cc wcel cA vx cv ci vy cv cmul co
      caddc co wceq vy cr wrex cA cre cfv vx cv wceq wb vx cv cr wcel cA cc
      wcel wa cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA vx cv ci vy
      cv cmul co caddc co wceq vy cr wrex vx cr crab cuni vx cv wceq cA cre cfv
      vx cv wceq vx cv cr wcel cA vx cv ci vy cv cmul co caddc co wceq vy cr
      wrex vx cr wreu cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex cA vx
      cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr crab cuni vx cv wceq
      wb cA cc wcel cA vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr
      reuuni1 vx vy cA creur sylan2 cA cc wcel cA cre cfv vx cv wceq cA vx cv
      ci vy cv cmul co caddc co wceq vy cr wrex vx cr crab cuni vx cv wceq wb
      vx cv cr wcel cA cc wcel cA cre cfv cA vx cv ci vy cv cmul co caddc co
      wceq vy cr wrex vx cr crab cuni vx cv vx vy cA reval eqeq1d adantl bitr4d
      ex vtoclga mpcom mpbiri cA cA cre cfv ci vy cv cmul co caddc co wceq vy
      cr df-rex sylib sylanbrc cA cc wcel vx cv cr wcel vy cv cr wcel wa cA vx
      cv ci cA cim cfv cmul co caddc co wceq cA cA cre cfv ci vy cv cmul co
      caddc co wceq wa wa cA cA cre cfv ci cA cim cfv cmul co caddc co wceq vx
      vy cA cc wcel vx cv cr wcel vy cv cr wcel wa cA vx cv ci cA cim cfv cmul
      co caddc co wceq cA cA cre cfv ci vy cv cmul co caddc co wceq wa wa cA cA
      cre cfv ci cA cim cfv cmul co caddc co wceq cA cc wcel vx cv cr wcel vy
      cv cr wcel wa cA vx cv ci cA cim cfv cmul co caddc co wceq cA cA cre cfv
      ci vy cv cmul co caddc co wceq wa wa wa cA vx cv ci cA cim cfv cmul co
      caddc co cA cre cfv ci cA cim cfv cmul co caddc co cA cc wcel vx cv cr
      wcel vy cv cr wcel wa cA vx cv ci cA cim cfv cmul co caddc co wceq cA cA
      cre cfv ci vy cv cmul co caddc co wceq simprrl cA cc wcel vx cv cr wcel
      vy cv cr wcel wa cA vx cv ci cA cim cfv cmul co caddc co wceq cA cA cre
      cfv ci vy cv cmul co caddc co wceq wa wa wa vx cv cA cre cfv ci cA cim
      cfv cmul co caddc cA cc wcel vx cv cr wcel vy cv cr wcel wa cA vx cv ci
      cA cim cfv cmul co caddc co wceq cA cA cre cfv ci vy cv cmul co caddc co
      wceq wa wa wa vx cv cA cre cfv wceq cA cim cfv vy cv wceq cA cc wcel vx
      cv cr wcel vy cv cr wcel wa cA vx cv ci cA cim cfv cmul co caddc co wceq
      cA cA cre cfv ci vy cv cmul co caddc co wceq wa vx cv cA cre cfv wceq cA
      cim cfv vy cv wceq wa cA cc wcel vx cv cr wcel vy cv cr wcel wa cA vx cv
      ci cA cim cfv cmul co caddc co wceq cA cA cre cfv ci vy cv cmul co caddc
      co wceq wa vx cv cA cre cfv wceq cA cim cfv vy cv wceq wa wi cA cc wcel
      vx cv cr wcel vy cv cr wcel wa wa vx cv ci cA cim cfv cmul co caddc co cA
      cre cfv ci vy cv cmul co caddc co wceq vx cv cA cre cfv wceq cA cim cfv
      vy cv wceq wa cA vx cv ci cA cim cfv cmul co caddc co wceq cA cA cre cfv
      ci vy cv cmul co caddc co wceq wa cA cc wcel vx cv cr wcel vy cv cr wcel
      wa wa vx cv cr wcel cA cim cfv cr wcel wa cA cre cfv cr wcel vy cv cr
      wcel wa wa vx cv ci cA cim cfv cmul co caddc co cA cre cfv ci vy cv cmul
      co caddc co wceq vx cv cA cre cfv wceq cA cim cfv vy cv wceq wa wb cA cc
      wcel vx cv cr wcel vy cv cr wcel wa vx cv cr wcel cA cim cfv cr wcel wa
      cA cre cfv cr wcel vy cv cr wcel wa wa cA cc wcel vx cv cr wcel vx cv cr
      wcel cA cim cfv cr wcel wa vy cv cr wcel cA cre cfv cr wcel vy cv cr wcel
      wa cA cc wcel vx cv cr wcel cA cim cfv cr wcel cA cc wcel cA cim cfv cr
      wcel vx cv cr wcel cA imcl a1d ancld cA cc wcel vy cv cr wcel cA cre cfv
      cr wcel cA cc wcel cA cre cfv cr wcel vy cv cr wcel cA recl a1d ancrd
      anim12d imp vx cv cA cim cfv cA cre cfv vy cv cru syl cA vx cv ci cA cim
      cfv cmul co caddc co cA cre cfv ci vy cv cmul co caddc co eqtr2 syl5bi ex
      imp32 pm3.26d opreq1d eqtrd ex 19.23advv mpd $.
      $( [11-Mar-2008] $) $( [10-May-1999] $)

    $( The absolute value (modulus) of a complex number.  Proposition
       10-3.7(a) of [Gleason] p. 133. $)
    absval $p |- ( A e. CC -> ( abs ` A ) = ( sqr ` ( A x. ( * ` A ) ) ) ) $=
      vx vy cA vx cv vx cv ccj cfv cmul co csqr cfv cA cA ccj cfv cmul co csqr
      cfv cc cabs vx cv cA wceq vx cv vx cv ccj cfv cmul co cA cA ccj cfv cmul
      co csqr vx cv cA wceq vx cv cA vx cv ccj cfv cA ccj cfv cmul vx cv cA
      wceq id vx cv cA ccj fveq2 opreq12d fveq2d vx vy df-abs cA cA ccj cfv
      cmul co csqr fvex fvopab4 $.
      $( [27-Jul-1999] $)
  $}

  ${
    $d x y A $.
    $( Value of the conjugate of a complex number.  The value is the real part
       minus ` _i ` times the imaginary part.  Definition 10-3.2 of [Gleason]
       p. 132. $)
    cjval $p |- ( A e. CC ->
                      ( * ` A ) = ( ( Re ` A ) - ( _i x. ( Im ` A ) ) ) ) $=
      vx vy cA vx cv cre cfv ci vx cv cim cfv cmul co cmin co cA cre cfv ci cA
      cim cfv cmul co cmin co cc ccj vx cv cA wceq vx cv cre cfv cA cre cfv ci
      vx cv cim cfv cmul co ci cA cim cfv cmul co cmin vx cv cA cre fveq2 vx cv
      cA wceq vx cv cim cfv cA cim cfv ci cmul vx cv cA cim fveq2 opreq2d
      opreq12d vx vy df-cj cA cre cfv ci cA cim cfv cmul co cmin oprex fvopab4
      $.
      $( [11-Mar-2008] $) $( [10-May-1999] $)
  $}

  $( The conjugate of a complex number is a complex number (closure law). $)
  cjcl $p |- ( A e. CC -> ( * ` A ) e. CC ) $=
    cA cc wcel cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co cc cA cjval
    cA cre cfv cc wcel ci cA cim cfv cmul co cc wcel cA cre cfv ci cA cim cfv
    cmul co cmin co cc wcel cA cc wcel cA cre cfv ci cA cim cfv cmul co subcl
    cA cc wcel cA cre cfv cA recl recnd ci cc wcel cA cim cfv cc wcel ci cA cim
    cfv cmul co cc wcel cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim
    cfv cA imcl recnd sylancr sylanc eqeltrd $.
    $( [10-May-1999] $)

  ${
    recl.1 $e |- A e. CC $.
    $( The real part of a complex number is real (closure law). $)
    recli $p |- ( Re ` A ) e. RR $=
      cA cc wcel cA cre cfv cr wcel recl.1 cA recl ax-mp $.
      $( [11-May-1999] $)

    $( The imaginary part of a complex number is real (closure law). $)
    imcli $p |- ( Im ` A ) e. RR $=
      cA cc wcel cA cim cfv cr wcel recl.1 cA imcl ax-mp $.
      $( [11-May-1999] $)

    $( Closure law for complex conjugate. $)
    cjcli $p |- ( * ` A ) e. CC $=
      cA cc wcel cA ccj cfv cc wcel recl.1 cA cjcl ax-mp $.
      $( [11-May-1999] $)

    $( Construct a complex number from its real and imaginary parts. $)
    replimi $p |- A = ( ( Re ` A ) + ( _i x. ( Im ` A ) ) ) $=
      cA cc wcel cA cA cre cfv ci cA cim cfv cmul co caddc co wceq recl.1 cA
      replim ax-mp $.
      $( [11-Mar-2008] $) $( [1-Oct-1999] $)
  $}

  $( The real part of a complex number representation.  Definition 10-3.1 of
     [Gleason] p. 132. $)
  crre $p |- ( ( A e. RR /\ B e. RR ) -> ( Re ` ( A + ( _i x. B ) ) ) = A ) $=
    cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cre cfv cA wceq cA ci cB
    cmul co caddc co cim cfv cB wceq cA cr wcel cB cr wcel wa cA ci cB cmul co
    caddc co cre cfv ci cA ci cB cmul co caddc co cim cfv cmul co caddc co cA
    ci cB cmul co caddc co wceq cA ci cB cmul co caddc co cre cfv cA wceq cA ci
    cB cmul co caddc co cim cfv cB wceq wa cA cr wcel cB cr wcel wa cA ci cB
    cmul co caddc co cA ci cB cmul co caddc co cre cfv ci cA ci cB cmul co
    caddc co cim cfv cmul co caddc co cA cr wcel cB cr wcel wa cA ci cB cmul co
    caddc co cc wcel cA ci cB cmul co caddc co cA ci cB cmul co caddc co cre
    cfv ci cA ci cB cmul co caddc co cim cfv cmul co caddc co wceq cA cc wcel
    ci cB cmul co cc wcel cA ci cB cmul co caddc co cc wcel cA cr wcel cB cr
    wcel cA ci cB cmul co addcl cA recn ci cc wcel cB cc wcel ci cB cmul co cc
    wcel cB cr wcel ci cB mulcl axicn cB recn sylancr syl2an cA ci cB cmul co
    caddc co replim syl eqcomd cA ci cB cmul co caddc co cre cfv cr wcel cA ci
    cB cmul co caddc co cim cfv cr wcel wa cA cr wcel cB cr wcel wa cA ci cB
    cmul co caddc co cre cfv ci cA ci cB cmul co caddc co cim cfv cmul co caddc
    co cA ci cB cmul co caddc co wceq cA ci cB cmul co caddc co cre cfv cA wceq
    cA ci cB cmul co caddc co cim cfv cB wceq wa wb cA cr wcel cB cr wcel wa cA
    ci cB cmul co caddc co cre cfv cr wcel cA ci cB cmul co caddc co cim cfv cr
    wcel cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cc wcel cA ci cB
    cmul co caddc co cre cfv cr wcel cA cc wcel ci cB cmul co cc wcel cA ci cB
    cmul co caddc co cc wcel cA cr wcel cB cr wcel cA ci cB cmul co addcl cA
    recn ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr wcel ci cB mulcl
    axicn cB recn sylancr syl2an cA ci cB cmul co caddc co recl syl cA cr wcel
    cB cr wcel wa cA ci cB cmul co caddc co cc wcel cA ci cB cmul co caddc co
    cim cfv cr wcel cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co caddc co
    cc wcel cA cr wcel cB cr wcel cA ci cB cmul co addcl cA recn ci cc wcel cB
    cc wcel ci cB cmul co cc wcel cB cr wcel ci cB mulcl axicn cB recn sylancr
    syl2an cA ci cB cmul co caddc co imcl syl jca cA ci cB cmul co caddc co cre
    cfv cA ci cB cmul co caddc co cim cfv cA cB cru mpancom mpbid pm3.26d $.
    $( [11-Mar-2005] $) $( [12-May-2005] $)

  $( The real part of a complex number representation.  Definition 10-3.1 of
     [Gleason] p. 132. $)
  crim $p |- ( ( A e. RR /\ B e. RR ) -> ( Im ` ( A + ( _i x. B ) ) ) = B ) $=
    cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cre cfv cA wceq cA ci cB
    cmul co caddc co cim cfv cB wceq cA cr wcel cB cr wcel wa cA ci cB cmul co
    caddc co cre cfv ci cA ci cB cmul co caddc co cim cfv cmul co caddc co cA
    ci cB cmul co caddc co wceq cA ci cB cmul co caddc co cre cfv cA wceq cA ci
    cB cmul co caddc co cim cfv cB wceq wa cA cr wcel cB cr wcel wa cA ci cB
    cmul co caddc co cA ci cB cmul co caddc co cre cfv ci cA ci cB cmul co
    caddc co cim cfv cmul co caddc co cA cr wcel cB cr wcel wa cA ci cB cmul co
    caddc co cc wcel cA ci cB cmul co caddc co cA ci cB cmul co caddc co cre
    cfv ci cA ci cB cmul co caddc co cim cfv cmul co caddc co wceq cA cc wcel
    ci cB cmul co cc wcel cA ci cB cmul co caddc co cc wcel cA cr wcel cB cr
    wcel cA ci cB cmul co addcl cA recn ci cc wcel cB cc wcel ci cB cmul co cc
    wcel cB cr wcel ci cB mulcl axicn cB recn sylancr syl2an cA ci cB cmul co
    caddc co replim syl eqcomd cA ci cB cmul co caddc co cre cfv cr wcel cA ci
    cB cmul co caddc co cim cfv cr wcel wa cA cr wcel cB cr wcel wa cA ci cB
    cmul co caddc co cre cfv ci cA ci cB cmul co caddc co cim cfv cmul co caddc
    co cA ci cB cmul co caddc co wceq cA ci cB cmul co caddc co cre cfv cA wceq
    cA ci cB cmul co caddc co cim cfv cB wceq wa wb cA cr wcel cB cr wcel wa cA
    ci cB cmul co caddc co cre cfv cr wcel cA ci cB cmul co caddc co cim cfv cr
    wcel cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cc wcel cA ci cB
    cmul co caddc co cre cfv cr wcel cA cc wcel ci cB cmul co cc wcel cA ci cB
    cmul co caddc co cc wcel cA cr wcel cB cr wcel cA ci cB cmul co addcl cA
    recn ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr wcel ci cB mulcl
    axicn cB recn sylancr syl2an cA ci cB cmul co caddc co recl syl cA cr wcel
    cB cr wcel wa cA ci cB cmul co caddc co cc wcel cA ci cB cmul co caddc co
    cim cfv cr wcel cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co caddc co
    cc wcel cA cr wcel cB cr wcel cA ci cB cmul co addcl cA recn ci cc wcel cB
    cc wcel ci cB cmul co cc wcel cB cr wcel ci cB mulcl axicn cB recn sylancr
    syl2an cA ci cB cmul co caddc co imcl syl jca cA ci cB cmul co caddc co cre
    cfv cA ci cB cmul co caddc co cim cfv cA cB cru mpancom mpbid pm3.27d $.
    $( [11-Mar-2005] $) $( [12-May-2005] $)

  ${
    crre.1 $e |- A e. RR $.
    crre.2 $e |- B e. RR $.
    $( The real part of a complex number representation.  Definition 10-3.1 of
       [Gleason] p. 132. $)
    crrei $p |- ( Re ` ( A + ( _i x. B ) ) ) = A $=
      cA cr wcel cB cr wcel cA ci cB cmul co caddc co cre cfv cA wceq crre.1
      crre.2 cA cB crre mp2an $.
      $( [11-Mar-2005] $) $( [10-May-1999] $)

    $( The imaginary part of a complex number representation.  Definition
       10-3.1 of [Gleason] p. 132. $)
    crimi $p |- ( Im ` ( A + ( _i x. B ) ) ) = B $=
      cA cr wcel cB cr wcel cA ci cB cmul co caddc co cim cfv cB wceq crre.1
      crre.2 cA cB crim mp2an $.
      $( [11-Mar-2005] $) $( [10-May-1999] $)
  $}

  $( The imaginary part of a complex number in terms of the real part
     function. $)
  imre $p |- ( A e. CC -> ( Im ` A ) = ( Re ` ( -u _i x. A ) ) ) $=
    cA cc wcel ci cneg cA cmul co cre cfv cA cim cfv ci cA cre cfv cneg cmul co
    caddc co cre cfv cA cim cfv cA cc wcel ci cneg cA cmul co cA cim cfv ci cA
    cre cfv cneg cmul co caddc co cre cA cc wcel ci cneg cA cmul co ci cneg cA
    cre cfv ci cA cim cfv cmul co caddc co cmul co ci cneg cA cre cfv cmul co
    ci cneg ci cA cim cfv cmul co cmul co caddc co cA cim cfv ci cA cre cfv
    cneg cmul co caddc co cA cc wcel cA cA cre cfv ci cA cim cfv cmul co caddc
    co ci cneg cmul cA replim opreq2d cA cre cfv cc wcel ci cA cim cfv cmul co
    cc wcel ci cneg cA cre cfv ci cA cim cfv cmul co caddc co cmul co ci cneg
    cA cre cfv cmul co ci cneg ci cA cim cfv cmul co cmul co caddc co wceq cA
    cc wcel ci cneg cc wcel cA cre cfv cc wcel ci cA cim cfv cmul co cc wcel ci
    cneg cA cre cfv ci cA cim cfv cmul co caddc co cmul co ci cneg cA cre cfv
    cmul co ci cneg ci cA cim cfv cmul co cmul co caddc co wceq ci axicn negcli
    ci cneg cA cre cfv ci cA cim cfv cmul co adddi mp3an1 cA cc wcel cA cre cfv
    cA recl recnd ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel
    cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd
    sylancr sylanc cA cc wcel ci cneg cA cre cfv cmul co ci cneg ci cA cim cfv
    cmul co cmul co caddc co ci cA cre cfv cneg cmul co cA cim cfv caddc co cA
    cim cfv ci cA cre cfv cneg cmul co caddc co cA cc wcel ci cneg cA cre cfv
    cmul co ci cA cre cfv cneg cmul co ci cneg ci cA cim cfv cmul co cmul co cA
    cim cfv caddc ci cc wcel cA cre cfv cc wcel ci cneg cA cre cfv cmul co ci
    cA cre cfv cneg cmul co wceq cA cc wcel ci cA cre cfv mulneg12 axicn cA cc
    wcel cA cre cfv cA recl recnd sylancr cA cc wcel ci cneg ci cmul co cA cim
    cfv cmul co ci cneg ci cA cim cfv cmul co cmul co cA cim cfv cA cc wcel cA
    cim cfv cc wcel ci cneg ci cmul co cA cim cfv cmul co ci cneg ci cA cim cfv
    cmul co cmul co wceq cA cc wcel cA cim cfv cA imcl recnd ci cneg cc wcel ci
    cc wcel cA cim cfv cc wcel ci cneg ci cmul co cA cim cfv cmul co ci cneg ci
    cA cim cfv cmul co cmul co wceq ci axicn negcli axicn ci cneg ci cA cim cfv
    mulass mp3an12 syl cA cc wcel c1 cA cim cfv cmul co cA cim cfv ci cneg ci
    cmul co cA cim cfv cmul co cA cc wcel cA cim cfv cc wcel c1 cA cim cfv cmul
    co cA cim cfv wceq cA cc wcel cA cim cfv cA imcl recnd cA cim cfv mulid2
    syl ci cneg ci cmul co c1 cA cim cfv cmul ci cneg ci cmul co ci ci cmul co
    cneg c1 ci ci axicn axicn mulneg1i ci ci cmul co cneg c1 cneg cneg c1 ci ci
    cmul co c1 cneg ixi negeqi c1 ax1cn negnegi eqtri eqtri opreq1i syl5eq
    eqtr3d opreq12d ci cA cre cfv cneg cmul co cc wcel cA cim cfv cc wcel ci cA
    cre cfv cneg cmul co cA cim cfv caddc co cA cim cfv ci cA cre cfv cneg cmul
    co caddc co wceq cA cc wcel ci cA cre cfv cneg cmul co cA cim cfv addcom ci
    cc wcel cA cre cfv cneg cc wcel ci cA cre cfv cneg cmul co cc wcel cA cc
    wcel ci cA cre cfv cneg mulcl axicn cA cc wcel cA cre cfv cc wcel cA cre
    cfv cneg cc wcel cA cc wcel cA cre cfv cA recl recnd cA cre cfv negcl syl
    sylancr cA cc wcel cA cim cfv cA imcl recnd sylanc eqtrd 3eqtrd fveq2d cA
    cim cfv cr wcel cA cre cfv cneg cr wcel cA cim cfv ci cA cre cfv cneg cmul
    co caddc co cre cfv cA cim cfv wceq cA cc wcel cA cim cfv cA cre cfv cneg
    crre cA imcl cA cc wcel cA cre cfv cr wcel cA cre cfv cneg cr wcel cA recl
    cA cre cfv renegcl syl sylanc eqtr2d $.
    $( [30-Jul-2008] $) $( [12-May-2005] $)

  $( The imaginary part of a real number is 0. $)
  reim0 $p |- ( A e. RR -> ( Im ` A ) = 0 ) $=
    cA cim cfv cr wcel ci cA cim cfv cmul co cr wcel cA cim cfv cc0 wceq cA cr
    wcel cA cim cfv rimul cA cr wcel cA cc wcel cA cim cfv cr wcel cA recn cA
    imcl syl cA cr wcel cA cA cre cfv cmin co ci cA cim cfv cmul co cr cA cr
    wcel cA cA cre cfv cmin co ci cA cim cfv cmul co wceq cA cre cfv ci cA cim
    cfv cmul co caddc co cA wceq cA cr wcel cA cA cre cfv ci cA cim cfv cmul co
    caddc co cA cr wcel cA cc wcel cA cA cre cfv ci cA cim cfv cmul co caddc co
    wceq cA recn cA replim syl eqcomd cA cc wcel cA cre cfv cc wcel ci cA cim
    cfv cmul co cc wcel cA cA cre cfv cmin co ci cA cim cfv cmul co wceq cA cre
    cfv ci cA cim cfv cmul co caddc co cA wceq wb cA cr wcel cA cA cre cfv ci
    cA cim cfv cmul co subadd cA recn cA cr wcel cA cre cfv cr wcel cA cre cfv
    cc wcel cA cr wcel cA cc wcel cA cre cfv cr wcel cA recn cA recl syl cA cre
    cfv recn syl ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA
    cr wcel ci cA cim cfv mulcl axicn cA cr wcel cA cim cfv cA cr wcel cA cc
    wcel cA cim cfv cr wcel cA recn cA imcl syl recnd sylancr syl3anc mpbird cA
    cr wcel cA cre cfv cr wcel cA cA cre cfv cmin co cr wcel cA cr wcel cA cc
    wcel cA cre cfv cr wcel cA recn cA recl syl cA cA cre cfv resubcl mpdan
    eqeltrrd sylanc $.
    $( [19-Mar-2005] $) $( [18-Mar-2005] $)

  $( A number is real iff its imaginary part is 0. $)
  reim0b $p |- ( A e. CC -> ( A e. RR <-> ( Im ` A ) = 0 ) ) $=
    cA cc wcel cA cr wcel cA cim cfv cc0 wceq cA reim0 cA cc wcel cA cim cfv
    cc0 wceq cA cr wcel cA cc wcel cA cim cfv cc0 wceq wa cA cA cre cfv cr cA
    cc wcel cA cim cfv cc0 wceq wa cA cA cre cfv ci cA cim cfv cmul co caddc co
    cA cre cfv cA cc wcel cA cA cre cfv ci cA cim cfv cmul co caddc co wceq cA
    cim cfv cc0 wceq cA replim adantr cA cim cfv cc0 wceq cA cc wcel cA cre cfv
    ci cA cim cfv cmul co caddc co cA cre cfv cc0 caddc co cA cre cfv cA cim
    cfv cc0 wceq ci cA cim cfv cmul co cc0 cA cre cfv caddc cA cim cfv cc0 wceq
    ci cA cim cfv cmul co ci cc0 cmul co cc0 cA cim cfv cc0 ci cmul opreq2 ci
    axicn mul01i syl6eq opreq2d cA cc wcel cA cre cfv cc wcel cA cre cfv cc0
    caddc co cA cre cfv wceq cA cc wcel cA cre cfv cA recl recnd cA cre cfv
    addid1 syl sylan9eqr eqtrd cA cc wcel cA cre cfv cr wcel cA cim cfv cc0
    wceq cA recl adantr eqeltrd ex impbid2 $.
    $( [24-Jul-2008] $) $( [26-Sep-2005] $)

  $( A number is real iff it equals its real part.  Proposition 10-3.4(f) of
    [Gleason] p. 133. $)
  rereb $p |- ( A e. CC -> ( A e. RR <-> ( Re ` A ) = A ) ) $=
    cA cc wcel cA cr wcel cA cre cfv cA wceq cA cc wcel cA cr wcel wa cA cA cre
    cfv ci cA cim cfv cmul co caddc co cA cre cfv cc0 caddc co cA cre cfv cA cc
    wcel cA cA cre cfv ci cA cim cfv cmul co caddc co wceq cA cr wcel cA replim
    adantr cA cc wcel cA cr wcel wa ci cA cim cfv cmul co cc0 cA cre cfv caddc
    cA cr wcel ci cA cim cfv cmul co cc0 wceq cA cc wcel cA cr wcel ci cA cim
    cfv cmul co ci cc0 cmul co cc0 cA cr wcel cA cim cfv cc0 ci cmul cA reim0
    opreq2d ci axicn mul01i syl6eq adantl opreq2d cA cc wcel cA cre cfv cc0
    caddc co cA cre cfv wceq cA cr wcel cA cc wcel cA cre cfv cc wcel cA cre
    cfv cc0 caddc co cA cre cfv wceq cA cc wcel cA cre cfv cA recl recnd cA cre
    cfv addid1 syl adantr 3eqtrrd cA cc wcel cA cre cfv cA wceq wa cA cre cfv
    cA cr cA cc wcel cA cre cfv cA wceq pm3.27 cA cc wcel cA cre cfv cr wcel cA
    cre cfv cA wceq cA recl adantr eqeltrrd impbida $.
    $( [22-Aug-2008] $) $( [20-Aug-2008] $)

  $( A product with a nonzero real multiplier is real iff the multiplicand is
     real. $)
  mulre $p |- ( ( A e. CC /\ B e. RR /\ B =/= 0 )
         -> ( A e. RR <-> ( B x. A ) e. RR ) ) $=
    cA cc wcel cB cr wcel cB cc0 wne w3a cA cr wcel cA cre cfv cA wceq cB cA
    cre cfv cmul co cB cA cmul co wceq cB cA cmul co cr wcel cA cc wcel cB cr
    wcel cA cr wcel cA cre cfv cA wceq wb cB cc0 wne cA rereb 3ad2ant1 cA cre
    cfv cc wcel cA cc wcel cB cc wcel cB cc0 wne wa cB cA cre cfv cmul co cB cA
    cmul co wceq cA cre cfv cA wceq wb cA cc wcel cB cr wcel cB cc0 wne w3a cA
    cre cfv cA cB mulcan cA cc wcel cB cr wcel cA cre cfv cc wcel cB cc0 wne cA
    cc wcel cA cre cfv cA recl recnd 3ad2ant1 cA cc wcel cB cr wcel cB cc0 wne
    3simp1 cB cr wcel cB cc0 wne cB cc wcel cB cc0 wne wa cA cc wcel cB cr wcel
    cB cc wcel cB cc0 wne cB recn anim1i 3adant1 syl3anc cA cc wcel cB cr wcel
    cB cA cre cfv cmul co cB cA cmul co wceq cB cA cmul co cr wcel wb cB cc0
    wne cB cr wcel cA cc wcel cB cA cre cfv cmul co cB cA cmul co wceq cB cA
    cmul co cr wcel wb cB cr wcel cA cc wcel wa cB cA cre cfv cmul co cB cA
    cmul co wceq cB cA cmul co cre cfv cB cA cmul co wceq cB cA cmul co cr wcel
    cB cr wcel cA cc wcel wa cB cA cre cfv cmul co cB cA cmul co cre cfv cB cA
    cmul co cB cr wcel cA cc wcel wa cB cA cmul co cre cfv cB cA cre cfv cmul
    co ci cB cA cim cfv cmul co cmul co caddc co cre cfv cB cA cre cfv cmul co
    cB cr wcel cA cc wcel wa cB cA cmul co cB cA cre cfv cmul co ci cB cA cim
    cfv cmul co cmul co caddc co cre cB cr wcel cA cc wcel wa cB cA cre cfv ci
    cA cim cfv cmul co caddc co cmul co cB cA cre cfv cmul co cB ci cA cim cfv
    cmul co cmul co caddc co cB cA cmul co cB cA cre cfv cmul co ci cB cA cim
    cfv cmul co cmul co caddc co cB cc wcel cA cre cfv cc wcel ci cA cim cfv
    cmul co cc wcel cB cA cre cfv ci cA cim cfv cmul co caddc co cmul co cB cA
    cre cfv cmul co cB ci cA cim cfv cmul co cmul co caddc co wceq cB cr wcel
    cA cc wcel wa cB cA cre cfv ci cA cim cfv cmul co adddi cB cr wcel cB cc
    wcel cA cc wcel cB recn adantr cA cc wcel cA cre cfv cc wcel cB cr wcel cA
    cc wcel cA cre cfv cA recl recnd adantl cA cc wcel ci cA cim cfv cmul co cc
    wcel cB cr wcel ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel
    cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd
    sylancr adantl syl3anc cB cr wcel cA cc wcel wa cA cA cre cfv ci cA cim cfv
    cmul co caddc co cB cmul cA cc wcel cA cA cre cfv ci cA cim cfv cmul co
    caddc co wceq cB cr wcel cA replim adantl opreq2d cB cr wcel cA cc wcel wa
    ci cB cA cim cfv cmul co cmul co cB ci cA cim cfv cmul co cmul co cB cA cre
    cfv cmul co caddc cB cc wcel cA cim cfv cc wcel ci cB cA cim cfv cmul co
    cmul co cB ci cA cim cfv cmul co cmul co wceq cB cr wcel cA cc wcel ci cc
    wcel cB cc wcel cA cim cfv cc wcel ci cB cA cim cfv cmul co cmul co cB ci
    cA cim cfv cmul co cmul co wceq axicn ci cB cA cim cfv mul12 mp3an1 cB recn
    cA cc wcel cA cim cfv cA imcl recnd syl2an opreq2d 3eqtr4d fveq2d cB cA cre
    cfv cmul co cr wcel cB cA cim cfv cmul co cr wcel cB cA cre cfv cmul co ci
    cB cA cim cfv cmul co cmul co caddc co cre cfv cB cA cre cfv cmul co wceq
    cB cr wcel cA cc wcel wa cB cA cre cfv cmul co cB cA cim cfv cmul co crre
    cB cr wcel cA cre cfv cr wcel cB cA cre cfv cmul co cr wcel cA cc wcel cB
    cA cre cfv remulcl cA recl sylan2 cB cr wcel cA cim cfv cr wcel cB cA cim
    cfv cmul co cr wcel cA cc wcel cB cA cim cfv remulcl cA imcl sylan2 sylanc
    eqtr2d eqeq1d cB cr wcel cA cc wcel wa cB cA cmul co cc wcel cB cA cmul co
    cr wcel cB cA cmul co cre cfv cB cA cmul co wceq wb cB cc wcel cA cc wcel
    cB cA cmul co cc wcel cB cr wcel cB cA mulcl cB recn sylan cB cA cmul co
    rereb syl bitr4d ancoms 3adant3 3bitr2d $.
    $( [7-Nov-2008] $) $( [21-Aug-2008] $)

  ${
    cjcji.1 $e |- A e. CC $.
    $( The conjugate of the conjugate is the original complex number.
       Proposition 10-3.4(e) of [Gleason] p. 133. $)
    cjcji $p |- ( * ` ( * ` A ) ) = A $=
      cA ccj cfv cre cfv ci cA ccj cfv cim cfv cmul co cmin co cA cre cfv ci cA
      cim cfv cmul co cneg cmin co cA ccj cfv ccj cfv cA cA ccj cfv cre cfv cA
      cre cfv ci cA ccj cfv cim cfv cmul co ci cA cim cfv cmul co cneg cmin cA
      ccj cfv cre cfv cA cre cfv ci cA cim cfv cneg cmul co caddc co cre cfv cA
      cre cfv cA ccj cfv cA cre cfv ci cA cim cfv cneg cmul co caddc co cre cA
      cre cfv ci cA cim cfv cmul co cneg caddc co cA cre cfv ci cA cim cfv cmul
      co cmin co cA cre cfv ci cA cim cfv cneg cmul co caddc co cA ccj cfv cA
      cre cfv ci cA cim cfv cmul co cA cre cfv cA cjcji.1 recli recni ci cA cim
      cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli negsubi ci cA cim cfv
      cneg cmul co ci cA cim cfv cmul co cneg cA cre cfv caddc ci cA cim cfv
      axicn cA cim cfv cA cjcji.1 imcli recni mulneg2i opreq2i cA cc wcel cA
      ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co wceq cjcji.1 cA cjval
      ax-mp 3eqtr4ri fveq2i cA cre cfv cA cim cfv cneg cA cjcji.1 recli cA cim
      cfv cA cjcji.1 imcli renegcli crrei eqtri ci cA ccj cfv cim cfv cmul co
      ci cA cre cfv ci cA cim cfv cneg cmul co caddc co cim cfv cmul co ci cA
      cim cfv cneg cmul co ci cA cim cfv cmul co cneg cA ccj cfv cim cfv cA cre
      cfv ci cA cim cfv cneg cmul co caddc co cim cfv ci cmul cA ccj cfv cA cre
      cfv ci cA cim cfv cneg cmul co caddc co cim cA cre cfv ci cA cim cfv cmul
      co cneg caddc co cA cre cfv ci cA cim cfv cmul co cmin co cA cre cfv ci
      cA cim cfv cneg cmul co caddc co cA ccj cfv cA cre cfv ci cA cim cfv cmul
      co cA cre cfv cA cjcji.1 recli recni ci cA cim cfv axicn cA cim cfv cA
      cjcji.1 imcli recni mulcli negsubi ci cA cim cfv cneg cmul co ci cA cim
      cfv cmul co cneg cA cre cfv caddc ci cA cim cfv axicn cA cim cfv cA
      cjcji.1 imcli recni mulneg2i opreq2i cA cc wcel cA ccj cfv cA cre cfv ci
      cA cim cfv cmul co cmin co wceq cjcji.1 cA cjval ax-mp 3eqtr4ri fveq2i
      opreq2i cA cre cfv ci cA cim cfv cneg cmul co caddc co cim cfv cA cim cfv
      cneg ci cmul cA cre cfv cA cim cfv cneg cA cjcji.1 recli cA cim cfv cA
      cjcji.1 imcli renegcli crimi opreq2i ci cA cim cfv axicn cA cim cfv cA
      cjcji.1 imcli recni mulneg2i 3eqtri opreq12i cA ccj cfv cc wcel cA ccj
      cfv ccj cfv cA ccj cfv cre cfv ci cA ccj cfv cim cfv cmul co cmin co wceq
      cA cjcji.1 cjcli cA ccj cfv cjval ax-mp cA cA cre cfv ci cA cim cfv cmul
      co caddc co cA cre cfv ci cA cim cfv cmul co cneg cmin co cA cjcji.1
      replimi cA cre cfv ci cA cim cfv cmul co cA cre cfv cA cjcji.1 recli
      recni ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli
      subnegi eqtr4i 3eqtr4i $.
      $( [11-May-1999] $)

    $( A number is real iff its imaginary part is 0. $)
    reim0bi $p |- ( A e. RR <-> ( Im ` A ) = 0 ) $=
      cA cc wcel cA cr wcel cA cim cfv cc0 wceq wb cjcji.1 cA reim0b ax-mp $.
      $( [29-May-1999] $)

    $( A real number equals its real part.  Proposition 10-3.4(f) of [Gleason]
       p. 133. $)
    rerebi $p |- ( A e. RR <-> ( Re ` A ) = A ) $=
      cA cc wcel cA cr wcel cA cre cfv cA wceq wb cjcji.1 cA rereb ax-mp $.
      $( [24-Jul-2008] $) $( [27-Oct-1999] $)

    $( A number is real iff it equals its complex conjugate.  Proposition
       10-3.4(f) of [Gleason] p. 133. $)
    cjrebi $p |- ( A e. RR <-> ( * ` A ) = A ) $=
      cA cr wcel cA cim cfv cc0 wceq cA cA ccj cfv wceq cA ccj cfv cA wceq cA
      cjcji.1 reim0bi cA cim cfv cc0 wceq cA cim cfv cA cim cfv cneg wceq cA cA
      ccj cfv wceq cA cim cfv cA cim cfv cA cjcji.1 imcli recni eqnegi ci cA
      cim cfv cmul co ci cA cim cfv cneg cmul co wceq ci cA cim cfv cmul co ci
      cA cim cfv cmul co cneg wceq cA cim cfv cA cim cfv cneg wceq cA cA ccj
      cfv wceq ci cA cim cfv cneg cmul co ci cA cim cfv cmul co cneg ci cA cim
      cfv cmul co ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni
      mulneg2i eqeq2i cA cim cfv cA cim cfv cneg ci cA cim cfv cA cjcji.1 imcli
      recni cA cim cfv cA cim cfv cA cjcji.1 imcli recni negcli axicn ine0
      mulcani cA cA ccj cfv wceq cA cre cfv ci cA cim cfv cmul co caddc co cA
      cre cfv ci cA cim cfv cmul co cneg caddc co wceq ci cA cim cfv cmul co ci
      cA cim cfv cmul co cneg wceq cA cA cre cfv ci cA cim cfv cmul co caddc co
      cA ccj cfv cA cre cfv ci cA cim cfv cmul co cneg caddc co cA cjcji.1
      replimi cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co cA cre cfv ci
      cA cim cfv cmul co cneg caddc co cA cc wcel cA ccj cfv cA cre cfv ci cA
      cim cfv cmul co cmin co wceq cjcji.1 cA cjval ax-mp cA cre cfv ci cA cim
      cfv cmul co cA cre cfv cA cjcji.1 recli recni ci cA cim cfv axicn cA cim
      cfv cA cjcji.1 imcli recni mulcli negsubi eqtr4i eqeq12i cA cre cfv ci cA
      cim cfv cmul co ci cA cim cfv cmul co cneg cA cre cfv cA cjcji.1 recli
      recni ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli ci cA
      cim cfv cmul co ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni
      mulcli negcli addcani bitr2i 3bitr3i bitr3i cA cA ccj cfv eqcom 3bitri $.
      $( [11-Oct-1999] $)

    $( Real part of a complex conjugate. $)
    recji $p |- ( Re ` ( * ` A ) ) = ( Re ` A ) $=
      cA ccj cfv cre cfv cA cre cfv ci cA cim cfv cneg cmul co caddc co cre cfv
      cA cre cfv cA ccj cfv cA cre cfv ci cA cim cfv cneg cmul co caddc co cre
      cA cre cfv ci cA cim cfv cmul co cneg caddc co cA cre cfv ci cA cim cfv
      cmul co cmin co cA cre cfv ci cA cim cfv cneg cmul co caddc co cA ccj cfv
      cA cre cfv ci cA cim cfv cmul co cA cre cfv cA cjcji.1 recli recni ci cA
      cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli negsubi ci cA cim
      cfv cneg cmul co ci cA cim cfv cmul co cneg cA cre cfv caddc ci cA cim
      cfv axicn cA cim cfv cA cjcji.1 imcli recni mulneg2i opreq2i cA cc wcel
      cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co wceq cjcji.1 cA cjval
      ax-mp 3eqtr4ri fveq2i cA cre cfv cA cim cfv cneg cA cjcji.1 recli cA cim
      cfv cA cjcji.1 imcli renegcli crrei eqtri $.
      $( [2-Oct-1999] $)

    $( Imaginary part of a complex conjugate. $)
    imcji $p |- ( Im ` ( * ` A ) ) = -u ( Im ` A ) $=
      cA ccj cfv cim cfv cA cre cfv ci cA cim cfv cneg cmul co caddc co cim cfv
      cA cim cfv cneg cA ccj cfv cA cre cfv ci cA cim cfv cneg cmul co caddc co
      cim cA cre cfv ci cA cim cfv cmul co cneg caddc co cA cre cfv ci cA cim
      cfv cmul co cmin co cA cre cfv ci cA cim cfv cneg cmul co caddc co cA ccj
      cfv cA cre cfv ci cA cim cfv cmul co cA cre cfv cA cjcji.1 recli recni ci
      cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli negsubi ci cA
      cim cfv cneg cmul co ci cA cim cfv cmul co cneg cA cre cfv caddc ci cA
      cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulneg2i opreq2i cA cc
      wcel cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co wceq cjcji.1 cA
      cjval ax-mp 3eqtr4ri fveq2i cA cre cfv cA cim cfv cneg cA cjcji.1 recli
      cA cim cfv cA cjcji.1 imcli renegcli crimi eqtri $.
      $( [2-Oct-1999] $)

    ${
      readdi.2 $e |- B e. CC $.
      $( Real part distributes over addition. $)
      readdi $p |- ( Re ` ( A + B ) ) = ( ( Re ` A ) + ( Re ` B ) ) $=
        cA cB caddc co cre cfv cA cre cfv cB cre cfv caddc co ci cA cim cfv cB
        cim cfv caddc co cmul co caddc co cre cfv cA cre cfv cB cre cfv caddc
        co cA cB caddc co cA cre cfv cB cre cfv caddc co ci cA cim cfv cB cim
        cfv caddc co cmul co caddc co cre cA cre cfv ci cA cim cfv cmul co
        caddc co cB cre cfv ci cB cim cfv cmul co caddc co caddc co cA cre cfv
        cB cre cfv caddc co ci cA cim cfv cmul co ci cB cim cfv cmul co caddc
        co caddc co cA cB caddc co cA cre cfv cB cre cfv caddc co ci cA cim cfv
        cB cim cfv caddc co cmul co caddc co cA cre cfv ci cA cim cfv cmul co
        cB cre cfv ci cB cim cfv cmul co cA cre cfv cA cjcji.1 recli recni ci
        cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli cB cre cfv cB
        readdi.2 recli recni ci cB cim cfv axicn cB cim cfv cB readdi.2 imcli
        recni mulcli add4i cA cA cre cfv ci cA cim cfv cmul co caddc co cB cB
        cre cfv ci cB cim cfv cmul co caddc co caddc cA cjcji.1 replimi cB
        readdi.2 replimi opreq12i ci cA cim cfv cB cim cfv caddc co cmul co ci
        cA cim cfv cmul co ci cB cim cfv cmul co caddc co cA cre cfv cB cre cfv
        caddc co caddc ci cA cim cfv cB cim cfv axicn cA cim cfv cA cjcji.1
        imcli recni cB cim cfv cB readdi.2 imcli recni adddii opreq2i 3eqtr4i
        fveq2i cA cre cfv cB cre cfv caddc co cA cim cfv cB cim cfv caddc co cA
        cre cfv cB cre cfv cA cjcji.1 recli cB readdi.2 recli readdcli cA cim
        cfv cB cim cfv cA cjcji.1 imcli cB readdi.2 imcli readdcli crrei eqtri
        $.
        $( [28-Jul-1999] $)

      $( Imaginary part distributes over addition. $)
      imaddi $p |- ( Im ` ( A + B ) ) = ( ( Im ` A ) + ( Im ` B ) ) $=
        cA cB caddc co cim cfv cA cre cfv cB cre cfv caddc co ci cA cim cfv cB
        cim cfv caddc co cmul co caddc co cim cfv cA cim cfv cB cim cfv caddc
        co cA cB caddc co cA cre cfv cB cre cfv caddc co ci cA cim cfv cB cim
        cfv caddc co cmul co caddc co cim cA cre cfv ci cA cim cfv cmul co
        caddc co cB cre cfv ci cB cim cfv cmul co caddc co caddc co cA cre cfv
        cB cre cfv caddc co ci cA cim cfv cmul co ci cB cim cfv cmul co caddc
        co caddc co cA cB caddc co cA cre cfv cB cre cfv caddc co ci cA cim cfv
        cB cim cfv caddc co cmul co caddc co cA cre cfv ci cA cim cfv cmul co
        cB cre cfv ci cB cim cfv cmul co cA cre cfv cA cjcji.1 recli recni ci
        cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli cB cre cfv cB
        readdi.2 recli recni ci cB cim cfv axicn cB cim cfv cB readdi.2 imcli
        recni mulcli add4i cA cA cre cfv ci cA cim cfv cmul co caddc co cB cB
        cre cfv ci cB cim cfv cmul co caddc co caddc cA cjcji.1 replimi cB
        readdi.2 replimi opreq12i ci cA cim cfv cB cim cfv caddc co cmul co ci
        cA cim cfv cmul co ci cB cim cfv cmul co caddc co cA cre cfv cB cre cfv
        caddc co caddc ci cA cim cfv cB cim cfv axicn cA cim cfv cA cjcji.1
        imcli recni cB cim cfv cB readdi.2 imcli recni adddii opreq2i 3eqtr4i
        fveq2i cA cre cfv cB cre cfv caddc co cA cim cfv cB cim cfv caddc co cA
        cre cfv cB cre cfv cA cjcji.1 recli cB readdi.2 recli readdcli cA cim
        cfv cB cim cfv cA cjcji.1 imcli cB readdi.2 imcli readdcli crimi eqtri
        $.
        $( [28-Jul-1999] $)

      $( Real part of a product. $)
      remuli $p |- ( Re ` ( A x. B ) ) =
            ( ( ( Re ` A ) x. ( Re ` B ) ) - ( ( Im ` A ) x. ( Im ` B ) ) ) $=
        cA cB cmul co cre cfv cA cre cfv cB cre cfv cmul co cA cim cfv cB cim
        cfv cmul co cmin co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre
        cfv cmul co caddc co cmul co caddc co cre cfv cA cre cfv cB cre cfv
        cmul co cA cim cfv cB cim cfv cmul co cmin co cA cB cmul co cA cre cfv
        cB cre cfv cmul co cA cim cfv cB cim cfv cmul co cmin co ci cA cre cfv
        cB cim cfv cmul co cA cim cfv cB cre cfv cmul co caddc co cmul co caddc
        co cre cA cB cmul co cA cre cfv ci cA cim cfv cmul co caddc co cB cre
        cfv ci cB cim cfv cmul co caddc co cmul co cA cre cfv cB cre cfv cmul
        co cA cim cfv cB cim cfv cmul co cmin co ci cA cre cfv cB cim cfv cmul
        co cA cim cfv cB cre cfv cmul co caddc co cmul co caddc co cA cA cre
        cfv ci cA cim cfv cmul co caddc co cB cB cre cfv ci cB cim cfv cmul co
        caddc co cmul cA cjcji.1 replimi cB readdi.2 replimi opreq12i cA cre
        cfv cA cim cfv cB cre cfv cB cim cfv cA cre cfv cA cjcji.1 recli recni
        cA cim cfv cA cjcji.1 imcli recni cB cre cfv cB readdi.2 recli recni cB
        cim cfv cB readdi.2 imcli recni crmuli eqtri fveq2i cA cre cfv cB cre
        cfv cmul co cA cim cfv cB cim cfv cmul co cmin co cA cre cfv cB cim cfv
        cmul co cA cim cfv cB cre cfv cmul co caddc co cA cre cfv cB cre cfv
        cmul co cA cim cfv cB cim cfv cmul co cA cre cfv cB cre cfv cA cjcji.1
        recli cB readdi.2 recli remulcli cA cim cfv cB cim cfv cA cjcji.1 imcli
        cB readdi.2 imcli remulcli resubcli cA cre cfv cB cim cfv cmul co cA
        cim cfv cB cre cfv cmul co cA cre cfv cB cim cfv cA cjcji.1 recli cB
        readdi.2 imcli remulcli cA cim cfv cB cre cfv cA cjcji.1 imcli cB
        readdi.2 recli remulcli readdcli crrei eqtri $.
        $( [28-Jul-1999] $)

      $( Imaginary part of a product. $)
      immuli $p |- ( Im ` ( A x. B ) ) =
            ( ( ( Re ` A ) x. ( Im ` B ) ) + ( ( Im ` A ) x. ( Re ` B ) ) ) $=
        cA cB cmul co cim cfv cA cre cfv cB cre cfv cmul co cA cim cfv cB cim
        cfv cmul co cmin co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre
        cfv cmul co caddc co cmul co caddc co cim cfv cA cre cfv cB cim cfv
        cmul co cA cim cfv cB cre cfv cmul co caddc co cA cB cmul co cA cre cfv
        cB cre cfv cmul co cA cim cfv cB cim cfv cmul co cmin co ci cA cre cfv
        cB cim cfv cmul co cA cim cfv cB cre cfv cmul co caddc co cmul co caddc
        co cim cA cB cmul co cA cre cfv ci cA cim cfv cmul co caddc co cB cre
        cfv ci cB cim cfv cmul co caddc co cmul co cA cre cfv cB cre cfv cmul
        co cA cim cfv cB cim cfv cmul co cmin co ci cA cre cfv cB cim cfv cmul
        co cA cim cfv cB cre cfv cmul co caddc co cmul co caddc co cA cA cre
        cfv ci cA cim cfv cmul co caddc co cB cB cre cfv ci cB cim cfv cmul co
        caddc co cmul cA cjcji.1 replimi cB readdi.2 replimi opreq12i cA cre
        cfv cA cim cfv cB cre cfv cB cim cfv cA cre cfv cA cjcji.1 recli recni
        cA cim cfv cA cjcji.1 imcli recni cB cre cfv cB readdi.2 recli recni cB
        cim cfv cB readdi.2 imcli recni crmuli eqtri fveq2i cA cre cfv cB cre
        cfv cmul co cA cim cfv cB cim cfv cmul co cmin co cA cre cfv cB cim cfv
        cmul co cA cim cfv cB cre cfv cmul co caddc co cA cre cfv cB cre cfv
        cmul co cA cim cfv cB cim cfv cmul co cA cre cfv cB cre cfv cA cjcji.1
        recli cB readdi.2 recli remulcli cA cim cfv cB cim cfv cA cjcji.1 imcli
        cB readdi.2 imcli remulcli resubcli cA cre cfv cB cim cfv cmul co cA
        cim cfv cB cre cfv cmul co cA cre cfv cB cim cfv cA cjcji.1 recli cB
        readdi.2 imcli remulcli cA cim cfv cB cre cfv cA cjcji.1 imcli cB
        readdi.2 recli remulcli readdcli crimi eqtri $.
        $( [28-Jul-1999] $)

      $( Complex conjugate distributes over addition.  Proposition 10-3.4(a) of
         [Gleason] p. 133. $)
      cjaddi $p |- ( * ` ( A + B ) ) = ( ( * ` A ) + ( * ` B ) ) $=
        cA cB caddc co cre cfv ci cA cB caddc co cim cfv cmul co cmin co cA cre
        cfv ci cA cim cfv cmul co cmin co cB cre cfv ci cB cim cfv cmul co cmin
        co caddc co cA cB caddc co ccj cfv cA ccj cfv cB ccj cfv caddc co cA cB
        caddc co cre cfv ci cA cB caddc co cim cfv cmul co cmin co cA cre cfv
        cB cre cfv caddc co ci cA cim cfv cmul co ci cB cim cfv cmul co caddc
        co cmin co cA cre cfv ci cA cim cfv cmul co cmin co cB cre cfv ci cB
        cim cfv cmul co cmin co caddc co cA cB caddc co cre cfv cA cre cfv cB
        cre cfv caddc co ci cA cB caddc co cim cfv cmul co ci cA cim cfv cmul
        co ci cB cim cfv cmul co caddc co cmin cA cB cjcji.1 readdi.2 readdi ci
        cA cB caddc co cim cfv cmul co ci cA cim cfv cB cim cfv caddc co cmul
        co ci cA cim cfv cmul co ci cB cim cfv cmul co caddc co cA cB caddc co
        cim cfv cA cim cfv cB cim cfv caddc co ci cmul cA cB cjcji.1 readdi.2
        imaddi opreq2i ci cA cim cfv cB cim cfv axicn cA cim cfv cA cjcji.1
        imcli recni cB cim cfv cB readdi.2 imcli recni adddii eqtri opreq12i cA
        cre cfv cB cre cfv ci cA cim cfv cmul co ci cB cim cfv cmul co cA cre
        cfv cA cjcji.1 recli recni cB cre cfv cB readdi.2 recli recni ci cA cim
        cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli ci cB cim cfv axicn
        cB cim cfv cB readdi.2 imcli recni mulcli addsub4i eqtri cA cB caddc co
        cc wcel cA cB caddc co ccj cfv cA cB caddc co cre cfv ci cA cB caddc co
        cim cfv cmul co cmin co wceq cA cB cjcji.1 readdi.2 addcli cA cB caddc
        co cjval ax-mp cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co cB
        ccj cfv cB cre cfv ci cB cim cfv cmul co cmin co caddc cA cc wcel cA
        ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co wceq cjcji.1 cA cjval
        ax-mp cB cc wcel cB ccj cfv cB cre cfv ci cB cim cfv cmul co cmin co
        wceq readdi.2 cB cjval ax-mp opreq12i 3eqtr4i $.
        $( [28-Jul-1999] $)

      $( Complex conjugate distributes over multiplication.  Proposition
         10-3.4(c) of [Gleason] p. 133. $)
      cjmuli $p |- ( * ` ( A x. B ) ) = ( ( * ` A ) x. ( * ` B ) ) $=
        cA cB cmul co cre cfv ci cA cB cmul co cim cfv cmul co cmin co cA cre
        cfv ci cA cim cfv cneg cmul co caddc co cB cre cfv ci cB cim cfv cneg
        cmul co caddc co cmul co cA cB cmul co ccj cfv cA ccj cfv cB ccj cfv
        cmul co cA cre cfv cB cre cfv cmul co cA cim cfv cB cim cfv cmul co
        cmin co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul co
        caddc co cmul co cmin co cA cre cfv cB cre cfv cmul co cA cim cfv cneg
        cB cim cfv cneg cmul co cmin co ci cA cre cfv cB cim cfv cneg cmul co
        cA cim cfv cneg cB cre cfv cmul co caddc co cmul co caddc co cA cB cmul
        co cre cfv ci cA cB cmul co cim cfv cmul co cmin co cA cre cfv ci cA
        cim cfv cneg cmul co caddc co cB cre cfv ci cB cim cfv cneg cmul co
        caddc co cmul co cA cre cfv cB cre cfv cmul co cA cim cfv cB cim cfv
        cmul co cmin co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv
        cmul co caddc co cmul co cneg caddc co cA cre cfv cB cre cfv cmul co cA
        cim cfv cB cim cfv cmul co cmin co ci cA cre cfv cB cim cfv cmul co cA
        cim cfv cB cre cfv cmul co caddc co cmul co cmin co cA cre cfv cB cre
        cfv cmul co cA cim cfv cneg cB cim cfv cneg cmul co cmin co ci cA cre
        cfv cB cim cfv cneg cmul co cA cim cfv cneg cB cre cfv cmul co caddc co
        cmul co caddc co cA cre cfv cB cre cfv cmul co cA cim cfv cB cim cfv
        cmul co cmin co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv
        cmul co caddc co cmul co cA cre cfv cB cre cfv cmul co cA cim cfv cB
        cim cfv cmul co cA cre cfv cB cre cfv cA cre cfv cA cjcji.1 recli recni
        cB cre cfv cB readdi.2 recli recni mulcli cA cim cfv cB cim cfv cA cim
        cfv cA cjcji.1 imcli recni cB cim cfv cB readdi.2 imcli recni mulcli
        subcli ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul co
        caddc co axicn cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul
        co cA cre cfv cB cim cfv cA cre cfv cA cjcji.1 recli recni cB cim cfv
        cB readdi.2 imcli recni mulcli cA cim cfv cB cre cfv cA cim cfv cA
        cjcji.1 imcli recni cB cre cfv cB readdi.2 recli recni mulcli addcli
        mulcli negsubi cA cre cfv cB cre cfv cmul co cA cim cfv cB cim cfv cmul
        co cmin co cA cre cfv cB cre cfv cmul co cA cim cfv cneg cB cim cfv
        cneg cmul co cmin co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre
        cfv cmul co caddc co cmul co cneg ci cA cre cfv cB cim cfv cneg cmul co
        cA cim cfv cneg cB cre cfv cmul co caddc co cmul co caddc cA cim cfv cB
        cim cfv cmul co cA cim cfv cneg cB cim cfv cneg cmul co cA cre cfv cB
        cre cfv cmul co cmin cA cim cfv cneg cB cim cfv cneg cmul co cA cim cfv
        cB cim cfv cmul co cA cim cfv cB cim cfv cA cim cfv cA cjcji.1 imcli
        recni cB cim cfv cB readdi.2 imcli recni mul2negi eqcomi opreq2i ci cA
        cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul co caddc co cneg
        cmul co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul co
        caddc co cmul co cneg ci cA cre cfv cB cim cfv cneg cmul co cA cim cfv
        cneg cB cre cfv cmul co caddc co cmul co ci cA cre cfv cB cim cfv cmul
        co cA cim cfv cB cre cfv cmul co caddc co axicn cA cre cfv cB cim cfv
        cmul co cA cim cfv cB cre cfv cmul co cA cre cfv cB cim cfv cA cre cfv
        cA cjcji.1 recli recni cB cim cfv cB readdi.2 imcli recni mulcli cA cim
        cfv cB cre cfv cA cim cfv cA cjcji.1 imcli recni cB cre cfv cB readdi.2
        recli recni mulcli addcli mulneg2i cA cre cfv cB cim cfv cmul co cA cim
        cfv cB cre cfv cmul co caddc co cneg cA cre cfv cB cim cfv cneg cmul co
        cA cim cfv cneg cB cre cfv cmul co caddc co ci cmul cA cre cfv cB cim
        cfv cmul co cA cim cfv cB cre cfv cmul co caddc co cneg cA cre cfv cB
        cim cfv cmul co cneg cA cim cfv cB cre cfv cmul co cneg caddc co cA cre
        cfv cB cim cfv cneg cmul co cA cim cfv cneg cB cre cfv cmul co caddc co
        cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul co cA cre cfv
        cB cim cfv cA cre cfv cA cjcji.1 recli recni cB cim cfv cB readdi.2
        imcli recni mulcli cA cim cfv cB cre cfv cA cim cfv cA cjcji.1 imcli
        recni cB cre cfv cB readdi.2 recli recni mulcli negdii cA cre cfv cB
        cim cfv cneg cmul co cA cre cfv cB cim cfv cmul co cneg cA cim cfv cneg
        cB cre cfv cmul co cA cim cfv cB cre cfv cmul co cneg caddc cA cre cfv
        cB cim cfv cA cre cfv cA cjcji.1 recli recni cB cim cfv cB readdi.2
        imcli recni mulneg2i cA cim cfv cB cre cfv cA cim cfv cA cjcji.1 imcli
        recni cB cre cfv cB readdi.2 recli recni mulneg1i opreq12i eqtr4i
        opreq2i eqtr3i opreq12i eqtr3i cA cB cmul co cre cfv cA cre cfv cB cre
        cfv cmul co cA cim cfv cB cim cfv cmul co cmin co ci cA cB cmul co cim
        cfv cmul co ci cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul
        co caddc co cmul co cmin cA cB cjcji.1 readdi.2 remuli cA cB cmul co
        cim cfv cA cre cfv cB cim cfv cmul co cA cim cfv cB cre cfv cmul co
        caddc co ci cmul cA cB cjcji.1 readdi.2 immuli opreq2i opreq12i cA cre
        cfv cA cim cfv cneg cB cre cfv cB cim cfv cneg cA cre cfv cA cjcji.1
        recli recni cA cim cfv cA cim cfv cA cjcji.1 imcli recni negcli cB cre
        cfv cB readdi.2 recli recni cB cim cfv cB cim cfv cB readdi.2 imcli
        recni negcli crmuli 3eqtr4i cA cB cmul co cc wcel cA cB cmul co ccj cfv
        cA cB cmul co cre cfv ci cA cB cmul co cim cfv cmul co cmin co wceq cA
        cB cjcji.1 readdi.2 mulcli cA cB cmul co cjval ax-mp cA ccj cfv cA cre
        cfv ci cA cim cfv cneg cmul co caddc co cB ccj cfv cB cre cfv ci cB cim
        cfv cneg cmul co caddc co cmul cA cre cfv ci cA cim cfv cmul co cneg
        caddc co cA cre cfv ci cA cim cfv cmul co cmin co cA cre cfv ci cA cim
        cfv cneg cmul co caddc co cA ccj cfv cA cre cfv ci cA cim cfv cmul co
        cA cre cfv cA cjcji.1 recli recni ci cA cim cfv axicn cA cim cfv cA
        cjcji.1 imcli recni mulcli negsubi ci cA cim cfv cneg cmul co ci cA cim
        cfv cmul co cneg cA cre cfv caddc ci cA cim cfv axicn cA cim cfv cA
        cjcji.1 imcli recni mulneg2i opreq2i cA cc wcel cA ccj cfv cA cre cfv
        ci cA cim cfv cmul co cmin co wceq cjcji.1 cA cjval ax-mp 3eqtr4ri cB
        cre cfv ci cB cim cfv cmul co cneg caddc co cB cre cfv ci cB cim cfv
        cmul co cmin co cB cre cfv ci cB cim cfv cneg cmul co caddc co cB ccj
        cfv cB cre cfv ci cB cim cfv cmul co cB cre cfv cB readdi.2 recli recni
        ci cB cim cfv axicn cB cim cfv cB readdi.2 imcli recni mulcli negsubi
        ci cB cim cfv cneg cmul co ci cB cim cfv cmul co cneg cB cre cfv caddc
        ci cB cim cfv axicn cB cim cfv cB readdi.2 imcli recni mulneg2i opreq2i
        cB cc wcel cB ccj cfv cB cre cfv ci cB cim cfv cmul co cmin co wceq
        readdi.2 cB cjval ax-mp 3eqtr4ri opreq12i 3eqtr4i $.
        $( [28-Jul-1999] $)

      $( Standard inner product on complex numbers. $)
      ipcni $p |- ( Re ` ( A x. ( * ` B ) ) ) =
             ( ( ( Re ` A ) x. ( Re ` B ) ) + ( ( Im ` A ) x. ( Im ` B ) ) ) $=
        cA cB ccj cfv cmul co cre cfv cA cre cfv cB ccj cfv cre cfv cmul co cA
        cim cfv cB ccj cfv cim cfv cmul co cmin co cA cre cfv cB ccj cfv cre
        cfv cmul co cA cim cfv cB ccj cfv cim cfv cmul co cneg caddc co cA cre
        cfv cB cre cfv cmul co cA cim cfv cB cim cfv cmul co caddc co cA cB ccj
        cfv cjcji.1 cB readdi.2 cjcli remuli cA cre cfv cB ccj cfv cre cfv cmul
        co cA cim cfv cB ccj cfv cim cfv cmul co cA cre cfv cB ccj cfv cre cfv
        cmul co cA cre cfv cB ccj cfv cre cfv cA cjcji.1 recli cB ccj cfv cB
        readdi.2 cjcli recli remulcli recni cA cim cfv cB ccj cfv cim cfv cmul
        co cA cim cfv cB ccj cfv cim cfv cA cjcji.1 imcli cB ccj cfv cB
        readdi.2 cjcli imcli remulcli recni negsubi cA cre cfv cB ccj cfv cre
        cfv cmul co cA cre cfv cB cre cfv cmul co cA cim cfv cB ccj cfv cim cfv
        cmul co cneg cA cim cfv cB cim cfv cmul co caddc cB ccj cfv cre cfv cB
        cre cfv cA cre cfv cmul cB readdi.2 recji opreq2i cA cim cfv cB cim cfv
        cmul co cA cim cfv cB ccj cfv cim cfv cneg cmul co cA cim cfv cB ccj
        cfv cim cfv cmul co cneg cB cim cfv cB ccj cfv cim cfv cneg cA cim cfv
        cmul cB ccj cfv cim cfv cB cim cfv cneg wceq cB cim cfv cB ccj cfv cim
        cfv cneg wceq cB readdi.2 imcji cB ccj cfv cim cfv cB cim cfv cB ccj
        cfv cim cfv cB ccj cfv cB readdi.2 cjcli imcli recni cB cim cfv cB
        readdi.2 imcli recni negcon2i mpbi opreq2i cA cim cfv cB ccj cfv cim
        cfv cA cim cfv cA cjcji.1 imcli recni cB ccj cfv cim cfv cB ccj cfv cB
        readdi.2 cjcli imcli recni mulneg2i eqtr2i opreq12i 3eqtr2i $.
        $( [2-Oct-1999] $)
    $}

    $( A complex number times its conjugate is real. $)
    cjmulrcli $p |- ( A x. ( * ` A ) ) e. RR $=
      cA cA ccj cfv cmul co cr wcel cA cA ccj cfv cmul co ccj cfv cA cA ccj cfv
      cmul co wceq cA ccj cfv cA ccj cfv ccj cfv cmul co cA ccj cfv cA cmul co
      cA cA ccj cfv cmul co ccj cfv cA cA ccj cfv cmul co cA ccj cfv ccj cfv cA
      cA ccj cfv cmul cA cjcji.1 cjcji opreq2i cA cA ccj cfv cjcji.1 cA cjcji.1
      cjcli cjmuli cA cA ccj cfv cjcji.1 cA cjcji.1 cjcli mulcomi 3eqtr4i cA cA
      ccj cfv cmul co cA cA ccj cfv cjcji.1 cA cjcji.1 cjcli mulcli cjrebi
      mpbir $.
      $( [11-May-1999] $)

    $( A complex number times its conjugate. $)
    cjmulvali $p |- ( A x. ( * ` A ) ) =
                   ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) $=
      cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cA cre cfv cA cre
      cfv cmul co cA cim cfv cA cim cfv cmul co caddc co cA cA ccj cfv cmul co
      cre cfv cA cA ccj cfv cmul co cA cre cfv c2 cexp co cA cre cfv cA cre cfv
      cmul co cA cim cfv c2 cexp co cA cim cfv cA cim cfv cmul co caddc cA cre
      cfv cA cre cfv cA cjcji.1 recli recni sqvali cA cim cfv cA cim cfv cA
      cjcji.1 imcli recni sqvali opreq12i cA cA cjcji.1 cjcji.1 ipcni cA cA ccj
      cfv cmul co cr wcel cA cA ccj cfv cmul co cre cfv cA cA ccj cfv cmul co
      wceq cA cjcji.1 cjmulrcli cA cA ccj cfv cmul co cA cA ccj cfv cmul co cA
      cjcji.1 cjmulrcli recni rerebi mpbi 3eqtr2ri $.
      $( [2-Oct-1999] $)

    $( A complex number times its conjugate is nonnegative. $)
    cjmulge0i $p |- 0 <_ ( A x. ( * ` A ) ) $=
      cc0 cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cA cA ccj cfv
      cmul co cle cc0 cA cre cfv c2 cexp co cle wbr cc0 cA cim cfv c2 cexp co
      cle wbr cc0 cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cle wbr
      cA cre cfv cA cjcji.1 recli sqge0i cA cim cfv cA cjcji.1 imcli sqge0i cA
      cre cfv c2 cexp co cA cim cfv c2 cexp co cA cre cfv cA cjcji.1 recli
      resqcli cA cim cfv cA cjcji.1 imcli resqcli addge0i mp2an cA cjcji.1
      cjmulvali breqtrri $.
      $( [28-May-1999] $)

    $( Real part of negative. $)
    renegi $p |- ( Re ` -u A ) = -u ( Re ` A ) $=
      cA cneg cre cfv cA cre cfv cneg ci cA cim cfv cneg cmul co caddc co cre
      cfv cA cre cfv cneg cA cneg cA cre cfv cneg ci cA cim cfv cneg cmul co
      caddc co cre cA cre cfv ci cA cim cfv cmul co caddc co cneg cA cre cfv
      cneg ci cA cim cfv cmul co cneg caddc co cA cneg cA cre cfv cneg ci cA
      cim cfv cneg cmul co caddc co cA cre cfv ci cA cim cfv cmul co cA cre cfv
      cA cjcji.1 recli recni ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli
      recni mulcli negdii cA cA cre cfv ci cA cim cfv cmul co caddc co cA
      cjcji.1 replimi negeqi ci cA cim cfv cneg cmul co ci cA cim cfv cmul co
      cneg cA cre cfv cneg caddc ci cA cim cfv axicn cA cim cfv cA cjcji.1
      imcli recni mulneg2i opreq2i 3eqtr4i fveq2i cA cre cfv cneg cA cim cfv
      cneg cA cre cfv cA cjcji.1 recli renegcli cA cim cfv cA cjcji.1 imcli
      renegcli crrei eqtri $.
      $( [24-Jul-2008] $) $( [2-Aug-1999] $)

    $( The negative of a real is real. $)
    negrebi $p |- ( -u A e. RR <-> A e. RR ) $=
      cA cneg cr wcel cA cr wcel cA cneg cr wcel cA cre cfv cA wceq cA cr wcel
      cA cneg cr wcel cA cneg cre cfv cA cneg wceq cA cre cfv cneg cA cneg wceq
      cA cre cfv cA wceq cA cneg cA cjcji.1 negcli rerebi cA cneg cre cfv cA
      cre cfv cneg cA cneg cA cjcji.1 renegi eqeq1i cA cre cfv cA cA cre cfv cA
      cjcji.1 recli recni cjcji.1 neg11i 3bitri cA cre cfv cA wceq cA cre cfv
      cr wcel cA cr wcel cA cjcji.1 recli cA cre cfv cA cr eleq1 mpbii sylbi cA
      renegcl impbii $.
      $( [11-Aug-1999] $)

    $( Imaginary part of negative. $)
    imnegi $p |- ( Im ` -u A ) = -u ( Im ` A ) $=
      cA cneg cim cfv cA cre cfv cneg ci cA cim cfv cneg cmul co caddc co cim
      cfv cA cim cfv cneg cA cneg cA cre cfv cneg ci cA cim cfv cneg cmul co
      caddc co cim cA cre cfv ci cA cim cfv cmul co caddc co cneg cA cre cfv
      cneg ci cA cim cfv cmul co cneg caddc co cA cneg cA cre cfv cneg ci cA
      cim cfv cneg cmul co caddc co cA cre cfv ci cA cim cfv cmul co cA cre cfv
      cA cjcji.1 recli recni ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli
      recni mulcli negdii cA cA cre cfv ci cA cim cfv cmul co caddc co cA
      cjcji.1 replimi negeqi ci cA cim cfv cneg cmul co ci cA cim cfv cmul co
      cneg cA cre cfv cneg caddc ci cA cim cfv axicn cA cim cfv cA cjcji.1
      imcli recni mulneg2i opreq2i 3eqtr4i fveq2i cA cre cfv cneg cA cim cfv
      cneg cA cre cfv cA cjcji.1 recli renegcli cA cim cfv cA cjcji.1 imcli
      renegcli crimi eqtri $.
      $( [24-Jul-2008] $) $( [2-Aug-1999] $)

    $( Complex conjugate of negative. $)
    cjnegi $p |- ( * ` -u A ) = -u ( * ` A ) $=
      cA cneg cre cfv ci cA cneg cim cfv cmul co cmin co cA cre cfv ci cA cim
      cfv cmul co cmin co cneg cA cneg ccj cfv cA ccj cfv cneg cA cneg cre cfv
      ci cA cneg cim cfv cmul co cmin co cA cre cfv ci cA cim cfv cmul co cneg
      caddc co cneg cA cre cfv ci cA cim cfv cmul co cmin co cneg cA cre cfv
      cneg ci cA cim cfv cmul co cneg cneg caddc co cA cre cfv cneg ci cA cim
      cfv cmul co cneg cmin co cA cre cfv ci cA cim cfv cmul co cneg caddc co
      cneg cA cneg cre cfv ci cA cneg cim cfv cmul co cmin co cA cre cfv cneg
      ci cA cim cfv cmul co cneg cA cre cfv cA cre cfv cA cjcji.1 recli recni
      negcli ci cA cim cfv cmul co ci cA cim cfv axicn cA cim cfv cA cjcji.1
      imcli recni mulcli negcli negsubi cA cre cfv ci cA cim cfv cmul co cneg
      cA cre cfv cA cjcji.1 recli recni ci cA cim cfv cmul co ci cA cim cfv
      axicn cA cim cfv cA cjcji.1 imcli recni mulcli negcli negdii cA cneg cre
      cfv cA cre cfv cneg ci cA cneg cim cfv cmul co ci cA cim cfv cmul co cneg
      cmin cA cjcji.1 renegi ci cA cneg cim cfv cmul co ci cA cim cfv cneg cmul
      co ci cA cim cfv cmul co cneg cA cneg cim cfv cA cim cfv cneg ci cmul cA
      cjcji.1 imnegi opreq2i ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli
      recni mulneg2i eqtri opreq12i 3eqtr4ri cA cre cfv ci cA cim cfv cmul co
      cneg caddc co cA cre cfv ci cA cim cfv cmul co cmin co cA cre cfv ci cA
      cim cfv cmul co cA cre cfv cA cjcji.1 recli recni ci cA cim cfv axicn cA
      cim cfv cA cjcji.1 imcli recni mulcli negsubi negeqi eqtri cA cneg cc
      wcel cA cneg ccj cfv cA cneg cre cfv ci cA cneg cim cfv cmul co cmin co
      wceq cA cjcji.1 negcli cA cneg cjval ax-mp cA ccj cfv cA cre cfv ci cA
      cim cfv cmul co cmin co cA cc wcel cA ccj cfv cA cre cfv ci cA cim cfv
      cmul co cmin co wceq cjcji.1 cA cjval ax-mp negeqi 3eqtr4i $.
      $( [2-Aug-1999] $)

    $( A number plus its conjugate is twice its real part.  Compare Proposition
       10-3.4(h) of [Gleason] p. 133. $)
    addcji $p |- ( A + ( * ` A ) ) = ( 2 x. ( Re ` A ) ) $=
      cA cre cfv ci cA cim cfv cmul co caddc co cA cre cfv ci cA cim cfv cmul
      co cneg caddc co caddc co cA cre cfv cA cre cfv caddc co cA cA ccj cfv
      caddc co c2 cA cre cfv cmul co cA cre cfv ci cA cim cfv cmul co caddc co
      cA cre cfv ci cA cim cfv cmul co cneg caddc co caddc co cA cre cfv cA cre
      cfv caddc co ci cA cim cfv cmul co ci cA cim cfv cmul co cneg caddc co
      caddc co cA cre cfv cA cre cfv caddc co cc0 caddc co cA cre cfv cA cre
      cfv caddc co cA cre cfv ci cA cim cfv cmul co cA cre cfv ci cA cim cfv
      cmul co cneg cA cre cfv cA cjcji.1 recli recni ci cA cim cfv axicn cA cim
      cfv cA cjcji.1 imcli recni mulcli cA cre cfv cA cjcji.1 recli recni ci cA
      cim cfv cmul co ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni
      mulcli negcli add4i ci cA cim cfv cmul co ci cA cim cfv cmul co cneg
      caddc co cc0 cA cre cfv cA cre cfv caddc co caddc ci cA cim cfv cmul co
      ci cA cim cfv axicn cA cim cfv cA cjcji.1 imcli recni mulcli negidi
      opreq2i cA cre cfv cA cre cfv caddc co cA cre cfv cA cre cfv cA cre cfv
      cA cjcji.1 recli recni cA cre cfv cA cjcji.1 recli recni addcli addid1i
      3eqtri cA cA cre cfv ci cA cim cfv cmul co caddc co cA ccj cfv cA cre cfv
      ci cA cim cfv cmul co cneg caddc co caddc cA cjcji.1 replimi cA ccj cfv
      cA cre cfv ci cA cim cfv cmul co cmin co cA cre cfv ci cA cim cfv cmul co
      cneg caddc co cA cc wcel cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin
      co wceq cjcji.1 cA cjval ax-mp cA cre cfv ci cA cim cfv cmul co cA cre
      cfv cA cjcji.1 recli recni ci cA cim cfv axicn cA cim cfv cA cjcji.1
      imcli recni mulcli negsubi eqtr4i opreq12i cA cre cfv cA cre cfv cA
      cjcji.1 recli recni 2timesi 3eqtr4i $.
      $( [2-Oct-1999] $)
  $}

  $( A real number equals its real part.  One direction of
     Proposition 10-3.4(f) of [Gleason] p. 133.  (Contributed by Paul
     Chapman, 7-Sep-2007.) $)
  rere $p |- ( A e. RR -> ( Re ` A ) = A ) $=
    cA cr wcel cA cre cfv cA wceq cA cr wcel cA cc wcel cA cr wcel cA cre cfv
    cA wceq wb cA recn cA rereb syl ibi $.
    $( [8-Sep-2007] $) $( [7-Sep-2007] $)

  $( A number is real iff it equals its complex conjugate.  Proposition
     10-3.4(f) of [Gleason] p. 133. $)
  cjreb $p |- ( A e. CC -> ( A e. RR <-> ( * ` A ) = A ) ) $=
    cA cc wcel cA cr wcel cA ccj cfv cA wceq wb cA cc wcel cA cc0 cif cr wcel
    cA cc wcel cA cc0 cif ccj cfv cA cc wcel cA cc0 cif wceq wb cA cc0 cA cA cc
    wcel cA cc0 cif wceq cA cr wcel cA cc wcel cA cc0 cif cr wcel cA ccj cfv cA
    wceq cA cc wcel cA cc0 cif ccj cfv cA cc wcel cA cc0 cif wceq cA cA cc wcel
    cA cc0 cif cr eleq1 cA cA cc wcel cA cc0 cif wceq cA ccj cfv cA cc wcel cA
    cc0 cif ccj cfv cA cA cc wcel cA cc0 cif cA cA cc wcel cA cc0 cif ccj fveq2
    cA cA cc wcel cA cc0 cif wceq id eqeq12d bibi12d cA cc wcel cA cc0 cif cA
    cc0 cc 0cn elimel cjrebi dedth $.
    $( [3-Jul-2005] $) $( [2-Jul-2005] $)

  $( A complex number times its conjugate is real. $)
  cjmulrcl $p |- ( A e. CC -> ( A x. ( * ` A ) ) e. RR ) $=
    cA cc wcel cA cA ccj cfv cmul co cr wcel cA cc wcel cA cc0 cif cA cc wcel
    cA cc0 cif ccj cfv cmul co cr wcel cA cc0 cA cA cc wcel cA cc0 cif wceq cA
    cA ccj cfv cmul co cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif ccj cfv cmul
    co cr cA cA cc wcel cA cc0 cif wceq cA cA cc wcel cA cc0 cif cA ccj cfv cA
    cc wcel cA cc0 cif ccj cfv cmul cA cA cc wcel cA cc0 cif wceq id cA cA cc
    wcel cA cc0 cif ccj fveq2 opreq12d eleq1d cA cc wcel cA cc0 cif cA cc0 cc
    0cn elimel cjmulrcli dedth $.
    $( [27-Mar-2005] $) $( [26-Mar-2005] $)

  $( A complex number times its conjugate. $)
  cjmulval $p |- ( A e. CC -> ( A x. ( * ` A ) ) =
                 ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
    cA cc wcel cA cA ccj cfv cmul co cA cre cfv c2 cexp co cA cim cfv c2 cexp
    co caddc co wceq cA cc wcel cA c2 cif cA cc wcel cA c2 cif ccj cfv cmul co
    cA cc wcel cA c2 cif cre cfv c2 cexp co cA cc wcel cA c2 cif cim cfv c2
    cexp co caddc co wceq cA c2 cA cA cc wcel cA c2 cif wceq cA cA ccj cfv cmul
    co cA cc wcel cA c2 cif cA cc wcel cA c2 cif ccj cfv cmul co cA cre cfv c2
    cexp co cA cim cfv c2 cexp co caddc co cA cc wcel cA c2 cif cre cfv c2 cexp
    co cA cc wcel cA c2 cif cim cfv c2 cexp co caddc co cA cA cc wcel cA c2 cif
    wceq cA cA cc wcel cA c2 cif cA ccj cfv cA cc wcel cA c2 cif ccj cfv cmul
    cA cA cc wcel cA c2 cif wceq id cA cA cc wcel cA c2 cif ccj fveq2 opreq12d
    cA cA cc wcel cA c2 cif wceq cA cre cfv c2 cexp co cA cc wcel cA c2 cif cre
    cfv c2 cexp co cA cim cfv c2 cexp co cA cc wcel cA c2 cif cim cfv c2 cexp
    co caddc cA cA cc wcel cA c2 cif wceq cA cre cfv cA cc wcel cA c2 cif cre
    cfv c2 cexp cA cA cc wcel cA c2 cif cre fveq2 opreq1d cA cA cc wcel cA c2
    cif wceq cA cim cfv cA cc wcel cA c2 cif cim cfv c2 cexp cA cA cc wcel cA
    c2 cif cim fveq2 opreq1d opreq12d eqeq12d cA cc wcel cA c2 cif cA c2 cc 2cn
    elimel cjmulvali dedth $.
    $( [2-Feb-2007] $) $( [1-Feb-2007] $)

  $( A complex number times its conjugate is nonnegative. $)
  cjmulge0 $p |- ( A e. CC -> 0 <_ ( A x. ( * ` A ) ) ) $=
    cA cc wcel cc0 cA cA ccj cfv cmul co cle wbr cc0 cA cc wcel cA cc0 cif cA
    cc wcel cA cc0 cif ccj cfv cmul co cle wbr cA cc0 cA cA cc wcel cA cc0 cif
    wceq cA cA ccj cfv cmul co cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif ccj
    cfv cmul co cc0 cle cA cA cc wcel cA cc0 cif wceq cA cA cc wcel cA cc0 cif
    cA ccj cfv cA cc wcel cA cc0 cif ccj cfv cmul cA cA cc wcel cA cc0 cif wceq
    id cA cA cc wcel cA cc0 cif ccj fveq2 opreq12d breq2d cA cc wcel cA cc0 cif
    cA cc0 cc 0cn elimel cjmulge0i dedth $.
    $( [27-Mar-2005] $) $( [26-Mar-2005] $)

  $( Real part of negative. $)
  reneg $p |- ( A e. CC -> ( Re ` -u A ) = -u ( Re ` A ) ) $=
    cA cc wcel cA cneg cre cfv cA cre cfv cneg wceq cA cc wcel cA cc0 cif cneg
    cre cfv cA cc wcel cA cc0 cif cre cfv cneg wceq cA cc0 cA cA cc wcel cA cc0
    cif wceq cA cneg cre cfv cA cc wcel cA cc0 cif cneg cre cfv cA cre cfv cneg
    cA cc wcel cA cc0 cif cre cfv cneg cA cA cc wcel cA cc0 cif wceq cA cneg cA
    cc wcel cA cc0 cif cneg cre cA cA cc wcel cA cc0 cif negeq fveq2d cA cA cc
    wcel cA cc0 cif wceq cA cre cfv cA cc wcel cA cc0 cif cre cfv cA cA cc wcel
    cA cc0 cif cre fveq2 negeqd eqeq12d cA cc wcel cA cc0 cif cA cc0 cc 0cn
    elimel renegi dedth $.
    $( [21-Apr-2005] $) $( [17-Mar-2005] $)

  $( Real part distributes over addition. $)
  readd $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Re ` ( A + B ) ) = ( ( Re ` A ) + ( Re ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co cre cfv cA cre cfv cB cre cfv caddc co
    wceq cA cc wcel cA cc0 cif cB caddc co cre cfv cA cc wcel cA cc0 cif cre
    cfv cB cre cfv caddc co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    caddc co cre cfv cA cc wcel cA cc0 cif cre cfv cB cc wcel cB cc0 cif cre
    cfv caddc co wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB caddc
    co cre cfv cA cc wcel cA cc0 cif cB caddc co cre cfv cA cre cfv cB cre cfv
    caddc co cA cc wcel cA cc0 cif cre cfv cB cre cfv caddc co cA cA cc wcel cA
    cc0 cif wceq cA cB caddc co cA cc wcel cA cc0 cif cB caddc co cre cA cA cc
    wcel cA cc0 cif cB caddc opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA cre
    cfv cA cc wcel cA cc0 cif cre cfv cB cre cfv caddc cA cA cc wcel cA cc0 cif
    cre fveq2 opreq1d eqeq12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0
    cif cB caddc co cre cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc
    co cre cfv cA cc wcel cA cc0 cif cre cfv cB cre cfv caddc co cA cc wcel cA
    cc0 cif cre cfv cB cc wcel cB cc0 cif cre cfv caddc co cB cB cc wcel cB cc0
    cif wceq cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif caddc co cre cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif
    caddc opreq2 fveq2d cB cB cc wcel cB cc0 cif wceq cB cre cfv cB cc wcel cB
    cc0 cif cre cfv cA cc wcel cA cc0 cif cre cfv caddc cB cB cc wcel cB cc0
    cif cre fveq2 opreq2d eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel readdi dedth2h $.
    $( [21-Apr-2005] $) $( [17-Mar-2005] $)

  $( Real part distributes over subtraction. $)
  resub $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Re ` ( A - B ) ) = ( ( Re ` A ) - ( Re ` B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg caddc co cre cfv cA cre cfv cB cre cfv
    cneg caddc co cA cB cmin co cre cfv cA cre cfv cB cre cfv cmin co cA cc
    wcel cB cc wcel wa cA cB cneg caddc co cre cfv cA cre cfv cB cneg cre cfv
    caddc co cA cre cfv cB cre cfv cneg caddc co cA cc wcel cB cneg cc wcel cA
    cB cneg caddc co cre cfv cA cre cfv cB cneg cre cfv caddc co wceq cB cc
    wcel cA cB cneg readd cB negcl sylan2 cA cc wcel cB cc wcel wa cB cneg cre
    cfv cB cre cfv cneg cA cre cfv caddc cB cc wcel cB cneg cre cfv cB cre cfv
    cneg wceq cA cc wcel cB reneg adantl opreq2d eqtrd cA cc wcel cB cc wcel wa
    cA cB cneg caddc co cA cB cmin co cre cA cB negsub fveq2d cA cre cfv cc
    wcel cB cre cfv cc wcel cA cre cfv cB cre cfv cneg caddc co cA cre cfv cB
    cre cfv cmin co wceq cA cc wcel cB cc wcel cA cre cfv cB cre cfv negsub cA
    cc wcel cA cre cfv cA recl recnd cB cc wcel cB cre cfv cB recl recnd syl2an
    3eqtr3d $.
    $( [2-Aug-2006] $) $( [17-Mar-2005] $)

  $( The imaginary part of a negative number. $)
  imneg $p |- ( A e. CC -> ( Im ` -u A ) = -u ( Im ` A ) ) $=
    cA cc wcel cA cneg cim cfv cA cim cfv cneg wceq cA cc wcel cA cc0 cif cneg
    cim cfv cA cc wcel cA cc0 cif cim cfv cneg wceq cA cc0 cA cA cc wcel cA cc0
    cif wceq cA cneg cim cfv cA cc wcel cA cc0 cif cneg cim cfv cA cim cfv cneg
    cA cc wcel cA cc0 cif cim cfv cneg cA cA cc wcel cA cc0 cif wceq cA cneg cA
    cc wcel cA cc0 cif cneg cim cA cA cc wcel cA cc0 cif negeq fveq2d cA cA cc
    wcel cA cc0 cif wceq cA cim cfv cA cc wcel cA cc0 cif cim cfv cA cA cc wcel
    cA cc0 cif cim fveq2 negeqd eqeq12d cA cc wcel cA cc0 cif cA cc0 cc 0cn
    elimel imnegi dedth $.
    $( [6-Apr-2005] $) $( [18-Mar-2005] $)

  $( Imaginary part distributes over addition. $)
  imadd $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Im ` ( A + B ) ) = ( ( Im ` A ) + ( Im ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co cim cfv cA cim cfv cB cim cfv caddc co
    wceq cA cc wcel cA cc0 cif cB caddc co cim cfv cA cc wcel cA cc0 cif cim
    cfv cB cim cfv caddc co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    caddc co cim cfv cA cc wcel cA cc0 cif cim cfv cB cc wcel cB cc0 cif cim
    cfv caddc co wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB caddc
    co cim cfv cA cc wcel cA cc0 cif cB caddc co cim cfv cA cim cfv cB cim cfv
    caddc co cA cc wcel cA cc0 cif cim cfv cB cim cfv caddc co cA cA cc wcel cA
    cc0 cif wceq cA cB caddc co cA cc wcel cA cc0 cif cB caddc co cim cA cA cc
    wcel cA cc0 cif cB caddc opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA cim
    cfv cA cc wcel cA cc0 cif cim cfv cB cim cfv caddc cA cA cc wcel cA cc0 cif
    cim fveq2 opreq1d eqeq12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0
    cif cB caddc co cim cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc
    co cim cfv cA cc wcel cA cc0 cif cim cfv cB cim cfv caddc co cA cc wcel cA
    cc0 cif cim cfv cB cc wcel cB cc0 cif cim cfv caddc co cB cB cc wcel cB cc0
    cif wceq cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif caddc co cim cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif
    caddc opreq2 fveq2d cB cB cc wcel cB cc0 cif wceq cB cim cfv cB cc wcel cB
    cc0 cif cim cfv cA cc wcel cA cc0 cif cim cfv caddc cB cB cc wcel cB cc0
    cif cim fveq2 opreq2d eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel imaddi dedth2h $.
    $( [7-Apr-2005] $) $( [18-Mar-2005] $)

  $( Imaginary part distributes over subtraction. $)
  imsub $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Im ` ( A - B ) ) = ( ( Im ` A ) - ( Im ` B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg caddc co cim cfv cA cim cfv cB cim cfv
    cneg caddc co cA cB cmin co cim cfv cA cim cfv cB cim cfv cmin co cA cc
    wcel cB cc wcel wa cA cB cneg caddc co cim cfv cA cim cfv cB cneg cim cfv
    caddc co cA cim cfv cB cim cfv cneg caddc co cA cc wcel cB cneg cc wcel cA
    cB cneg caddc co cim cfv cA cim cfv cB cneg cim cfv caddc co wceq cB cc
    wcel cA cB cneg imadd cB negcl sylan2 cA cc wcel cB cc wcel wa cB cneg cim
    cfv cB cim cfv cneg cA cim cfv caddc cB cc wcel cB cneg cim cfv cB cim cfv
    cneg wceq cA cc wcel cB imneg adantl opreq2d eqtrd cA cc wcel cB cc wcel wa
    cA cB cneg caddc co cA cB cmin co cim cA cB negsub fveq2d cA cim cfv cc
    wcel cB cim cfv cc wcel cA cim cfv cB cim cfv cneg caddc co cA cim cfv cB
    cim cfv cmin co wceq cA cc wcel cB cc wcel cA cim cfv cB cim cfv negsub cA
    cc wcel cA cim cfv cA imcl recnd cB cc wcel cB cim cfv cB imcl recnd syl2an
    3eqtr3d $.
    $( [1-Aug-2006] $) $( [18-Mar-2005] $)

  $( A real number equals its complex conjugate.  Proposition 10-3.4(f) of
     [Gleason] p. 133. $)
  cjre $p |- ( A e. RR -> ( * ` A ) = A ) $=
    cA cc wcel cA cr wcel cA ccj cfv cA wceq cA recn cA cc wcel cA cr wcel cA
    ccj cfv cA wceq cA cjreb biimpd mpcom $.
    $( [8-Oct-1999] $)

  $( The conjugate of the conjugate is the original complex number.
     Proposition 10-3.4(e) of [Gleason] p. 133. $)
  cjcj $p |- ( A e. CC -> ( * ` ( * ` A ) ) = A ) $=
    cA cc wcel cA ccj cfv ccj cfv cA wceq cA cc wcel cA cc0 cif ccj cfv ccj cfv
    cA cc wcel cA cc0 cif wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA ccj cfv
    ccj cfv cA cc wcel cA cc0 cif ccj cfv ccj cfv cA cA cc wcel cA cc0 cif cA
    cA cc wcel cA cc0 cif wceq cA ccj cfv cA cc wcel cA cc0 cif ccj cfv ccj cA
    cA cc wcel cA cc0 cif ccj fveq2 fveq2d cA cA cc wcel cA cc0 cif wceq id
    eqeq12d cA cc wcel cA cc0 cif cA cc0 cc 0cn elimel cjcji dedth $.
    $( [29-Jul-1999] $)

  $( Complex conjugate distributes over addition.  Proposition 10-3.4(a) of
     [Gleason] p. 133. $)
  cjadd $p |- ( ( A e. CC /\ B e. CC ) ->
                   ( * ` ( A + B ) ) = ( ( * ` A ) + ( * ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co ccj cfv cA ccj cfv cB ccj cfv caddc co
    wceq cA cc wcel cA cc0 cif cB caddc co ccj cfv cA cc wcel cA cc0 cif ccj
    cfv cB ccj cfv caddc co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    caddc co ccj cfv cA cc wcel cA cc0 cif ccj cfv cB cc wcel cB cc0 cif ccj
    cfv caddc co wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB caddc
    co ccj cfv cA cc wcel cA cc0 cif cB caddc co ccj cfv cA ccj cfv cB ccj cfv
    caddc co cA cc wcel cA cc0 cif ccj cfv cB ccj cfv caddc co cA cA cc wcel cA
    cc0 cif wceq cA cB caddc co cA cc wcel cA cc0 cif cB caddc co ccj cA cA cc
    wcel cA cc0 cif cB caddc opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA ccj
    cfv cA cc wcel cA cc0 cif ccj cfv cB ccj cfv caddc cA cA cc wcel cA cc0 cif
    ccj fveq2 opreq1d eqeq12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0
    cif cB caddc co ccj cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc
    co ccj cfv cA cc wcel cA cc0 cif ccj cfv cB ccj cfv caddc co cA cc wcel cA
    cc0 cif ccj cfv cB cc wcel cB cc0 cif ccj cfv caddc co cB cB cc wcel cB cc0
    cif wceq cA cc wcel cA cc0 cif cB caddc co cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif caddc co ccj cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif
    caddc opreq2 fveq2d cB cB cc wcel cB cc0 cif wceq cB ccj cfv cB cc wcel cB
    cc0 cif ccj cfv cA cc wcel cA cc0 cif ccj cfv caddc cB cB cc wcel cB cc0
    cif ccj fveq2 opreq2d eqeq12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel cjaddi dedth2h $.
    $( [31-Jul-1999] $)

  $( Complex conjugate distributes over multiplication.  Proposition 10-3.4(c)
     of [Gleason] p. 133. $)
  cjmul $p |- ( ( A e. CC /\ B e. CC ) ->
                   ( * ` ( A x. B ) ) = ( ( * ` A ) x. ( * ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB cmul co ccj cfv cA ccj cfv cB ccj cfv cmul co
    wceq cA cc wcel cA cc0 cif cB cmul co ccj cfv cA cc wcel cA cc0 cif ccj cfv
    cB ccj cfv cmul co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co
    ccj cfv cA cc wcel cA cc0 cif ccj cfv cB cc wcel cB cc0 cif ccj cfv cmul co
    wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB cmul co ccj cfv cA
    cc wcel cA cc0 cif cB cmul co ccj cfv cA ccj cfv cB ccj cfv cmul co cA cc
    wcel cA cc0 cif ccj cfv cB ccj cfv cmul co cA cA cc wcel cA cc0 cif wceq cA
    cB cmul co cA cc wcel cA cc0 cif cB cmul co ccj cA cA cc wcel cA cc0 cif cB
    cmul opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA ccj cfv cA cc wcel cA
    cc0 cif ccj cfv cB ccj cfv cmul cA cA cc wcel cA cc0 cif ccj fveq2 opreq1d
    eqeq12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmul co ccj
    cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co ccj cfv cA cc wcel
    cA cc0 cif ccj cfv cB ccj cfv cmul co cA cc wcel cA cc0 cif ccj cfv cB cc
    wcel cB cc0 cif ccj cfv cmul co cB cB cc wcel cB cc0 cif wceq cA cc wcel cA
    cc0 cif cB cmul co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmul co ccj
    cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmul opreq2 fveq2d cB cB cc
    wcel cB cc0 cif wceq cB ccj cfv cB cc wcel cB cc0 cif ccj cfv cA cc wcel cA
    cc0 cif ccj cfv cmul cB cB cc wcel cB cc0 cif ccj fveq2 opreq2d eqeq12d cA
    cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel cjmuli dedth2h $.
    $( [29-Jul-1999] $)

  $( Complex conjugate of negative. $)
  cjneg $p |- ( A e. CC -> ( * ` -u A ) = -u ( * ` A ) ) $=
    cA cc wcel cA cneg ccj cfv cA ccj cfv cneg wceq cA cc wcel cA cc0 cif cneg
    ccj cfv cA cc wcel cA cc0 cif ccj cfv cneg wceq cA cc0 cA cA cc wcel cA cc0
    cif wceq cA cneg ccj cfv cA cc wcel cA cc0 cif cneg ccj cfv cA ccj cfv cneg
    cA cc wcel cA cc0 cif ccj cfv cneg cA cA cc wcel cA cc0 cif wceq cA cneg cA
    cc wcel cA cc0 cif cneg ccj cA cA cc wcel cA cc0 cif negeq fveq2d cA cA cc
    wcel cA cc0 cif wceq cA ccj cfv cA cc wcel cA cc0 cif ccj cfv cA cA cc wcel
    cA cc0 cif ccj fveq2 negeqd eqeq12d cA cc wcel cA cc0 cif cA cc0 cc 0cn
    elimel cjnegi dedth $.
    $( [27-Feb-2005] $) $( [27-Feb-2005] $)

  $( A number plus its conjugate is twice its real part.  Compare Proposition
     10-3.4(h) of [Gleason] p. 133. $)
  addcj $p |- ( A e. CC -> ( A + ( * ` A ) ) = ( 2 x. ( Re ` A ) ) ) $=
    cA cc wcel cA cA ccj cfv caddc co c2 cA cre cfv cmul co wceq cA cc wcel cA
    cc0 cif cA cc wcel cA cc0 cif ccj cfv caddc co c2 cA cc wcel cA cc0 cif cre
    cfv cmul co wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA cA ccj cfv caddc
    co cA cc wcel cA cc0 cif cA cc wcel cA cc0 cif ccj cfv caddc co c2 cA cre
    cfv cmul co c2 cA cc wcel cA cc0 cif cre cfv cmul co cA cA cc wcel cA cc0
    cif wceq cA cA cc wcel cA cc0 cif cA ccj cfv cA cc wcel cA cc0 cif ccj cfv
    caddc cA cA cc wcel cA cc0 cif wceq id cA cA cc wcel cA cc0 cif ccj fveq2
    opreq12d cA cA cc wcel cA cc0 cif wceq cA cre cfv cA cc wcel cA cc0 cif cre
    cfv c2 cmul cA cA cc wcel cA cc0 cif cre fveq2 opreq2d eqeq12d cA cc wcel
    cA cc0 cif cA cc0 cc 0cn elimel addcji dedth $.
    $( [26-Jan-2007] $) $( [21-Jan-2007] $)

  $( Complex conjugate distributes over subtraction. $)
  cjsub $p |- ( ( A e. CC /\ B e. CC ) ->
                   ( * ` ( A - B ) ) = ( ( * ` A ) - ( * ` B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg caddc co ccj cfv cA ccj cfv cB cneg ccj
    cfv caddc co cA cB cmin co ccj cfv cA ccj cfv cB ccj cfv cmin co cA cc wcel
    cB cneg cc wcel cA cB cneg caddc co ccj cfv cA ccj cfv cB cneg ccj cfv
    caddc co wceq cB cc wcel cA cB cneg cjadd cB negcl sylan2 cA cc wcel cB cc
    wcel wa cA cB cneg caddc co cA cB cmin co ccj cA cB negsub fveq2d cA cc
    wcel cB cc wcel wa cA ccj cfv cB cneg ccj cfv caddc co cA ccj cfv cB ccj
    cfv cneg caddc co cA ccj cfv cB ccj cfv cmin co cA cc wcel cB cc wcel wa cB
    cneg ccj cfv cB ccj cfv cneg cA ccj cfv caddc cB cc wcel cB cneg ccj cfv cB
    ccj cfv cneg wceq cA cc wcel cB cjneg adantl opreq2d cA ccj cfv cc wcel cB
    ccj cfv cc wcel cA ccj cfv cB ccj cfv cneg caddc co cA ccj cfv cB ccj cfv
    cmin co wceq cA cc wcel cB cc wcel cA ccj cfv cB ccj cfv negsub cA cjcl cB
    cjcl syl2an eqtrd 3eqtr3d $.
    $( [1-Aug-2006] $) $( [28-Apr-2005] $)

  ${
    $d j k A $.  $d j k N $.
    $( Complex conjugate of natural number exponentiation. $)
    cjexp $p |- ( ( A e. CC /\ N e. NN0 ) ->
               ( * ` ( A ^ N ) ) = ( ( * ` A ) ^ N ) ) $=
      cN cn0 wcel cA cc wcel cA cN cexp co ccj cfv cA ccj cfv cN cexp co wceq
      cA cc wcel cA vj cv cexp co ccj cfv cA ccj cfv vj cv cexp co wceq wi cA
      cc wcel cA cc0 cexp co ccj cfv cA ccj cfv cc0 cexp co wceq wi cA cc wcel
      cA vk cv cexp co ccj cfv cA ccj cfv vk cv cexp co wceq wi cA cc wcel cA
      vk cv c1 caddc co cexp co ccj cfv cA ccj cfv vk cv c1 caddc co cexp co
      wceq wi cA cc wcel cA cN cexp co ccj cfv cA ccj cfv cN cexp co wceq wi vj
      vk cN vj cv cc0 wceq cA vj cv cexp co ccj cfv cA ccj cfv vj cv cexp co
      wceq cA cc0 cexp co ccj cfv cA ccj cfv cc0 cexp co wceq cA cc wcel vj cv
      cc0 wceq cA vj cv cexp co ccj cfv cA cc0 cexp co ccj cfv cA ccj cfv vj cv
      cexp co cA ccj cfv cc0 cexp co vj cv cc0 wceq cA vj cv cexp co cA cc0
      cexp co ccj vj cv cc0 cA cexp opreq2 fveq2d vj cv cc0 cA ccj cfv cexp
      opreq2 eqeq12d imbi2d vj cv vk cv wceq cA vj cv cexp co ccj cfv cA ccj
      cfv vj cv cexp co wceq cA vk cv cexp co ccj cfv cA ccj cfv vk cv cexp co
      wceq cA cc wcel vj cv vk cv wceq cA vj cv cexp co ccj cfv cA vk cv cexp
      co ccj cfv cA ccj cfv vj cv cexp co cA ccj cfv vk cv cexp co vj cv vk cv
      wceq cA vj cv cexp co cA vk cv cexp co ccj vj cv vk cv cA cexp opreq2
      fveq2d vj cv vk cv cA ccj cfv cexp opreq2 eqeq12d imbi2d vj cv vk cv c1
      caddc co wceq cA vj cv cexp co ccj cfv cA ccj cfv vj cv cexp co wceq cA
      vk cv c1 caddc co cexp co ccj cfv cA ccj cfv vk cv c1 caddc co cexp co
      wceq cA cc wcel vj cv vk cv c1 caddc co wceq cA vj cv cexp co ccj cfv cA
      vk cv c1 caddc co cexp co ccj cfv cA ccj cfv vj cv cexp co cA ccj cfv vk
      cv c1 caddc co cexp co vj cv vk cv c1 caddc co wceq cA vj cv cexp co cA
      vk cv c1 caddc co cexp co ccj vj cv vk cv c1 caddc co cA cexp opreq2
      fveq2d vj cv vk cv c1 caddc co cA ccj cfv cexp opreq2 eqeq12d imbi2d vj
      cv cN wceq cA vj cv cexp co ccj cfv cA ccj cfv vj cv cexp co wceq cA cN
      cexp co ccj cfv cA ccj cfv cN cexp co wceq cA cc wcel vj cv cN wceq cA vj
      cv cexp co ccj cfv cA cN cexp co ccj cfv cA ccj cfv vj cv cexp co cA ccj
      cfv cN cexp co vj cv cN wceq cA vj cv cexp co cA cN cexp co ccj vj cv cN
      cA cexp opreq2 fveq2d vj cv cN cA ccj cfv cexp opreq2 eqeq12d imbi2d cA
      cc wcel cA cc0 cexp co ccj cfv c1 ccj cfv cA ccj cfv cc0 cexp co cA cc
      wcel cA cc0 cexp co c1 ccj cA exp0 fveq2d cA cc wcel cA ccj cfv cc wcel
      cA ccj cfv cc0 cexp co c1 ccj cfv wceq cA cjcl cA ccj cfv cc wcel cA ccj
      cfv cc0 cexp co c1 c1 ccj cfv cA ccj cfv exp0 c1 cr wcel c1 ccj cfv c1
      wceq 1re c1 cjre ax-mp syl6eqr syl eqtr4d vk cv cn0 wcel cA cc wcel cA vk
      cv cexp co ccj cfv cA ccj cfv vk cv cexp co wceq cA vk cv c1 caddc co
      cexp co ccj cfv cA ccj cfv vk cv c1 caddc co cexp co wceq cA cc wcel vk
      cv cn0 wcel cA vk cv cexp co ccj cfv cA ccj cfv vk cv cexp co wceq cA vk
      cv c1 caddc co cexp co ccj cfv cA ccj cfv vk cv c1 caddc co cexp co wceq
      wi cA cc wcel vk cv cn0 wcel cA vk cv cexp co ccj cfv cA ccj cfv vk cv
      cexp co wceq cA vk cv c1 caddc co cexp co ccj cfv cA ccj cfv vk cv c1
      caddc co cexp co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv cexp co ccj
      cfv cA ccj cfv vk cv cexp co wceq wa cA vk cv c1 caddc co cexp co ccj cfv
      cA vk cv cexp co ccj cfv cA ccj cfv cmul co cA ccj cfv vk cv c1 caddc co
      cexp co cA cc wcel vk cv cn0 wcel wa cA vk cv c1 caddc co cexp co ccj cfv
      cA vk cv cexp co ccj cfv cA ccj cfv cmul co wceq cA vk cv cexp co ccj cfv
      cA ccj cfv vk cv cexp co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv c1
      caddc co cexp co ccj cfv cA vk cv cexp co cA cmul co ccj cfv cA vk cv
      cexp co ccj cfv cA ccj cfv cmul co cA cc wcel vk cv cn0 wcel wa cA vk cv
      c1 caddc co cexp co cA vk cv cexp co cA cmul co ccj cA vk cv expp1 fveq2d
      cA vk cv cexp co cc wcel cA cc wcel cA vk cv cexp co cA cmul co ccj cfv
      cA vk cv cexp co ccj cfv cA ccj cfv cmul co wceq cA cc wcel vk cv cn0
      wcel wa cA vk cv cexp co cA cjmul cA vk cv expcl cA cc wcel vk cv cn0
      wcel pm3.26 sylanc eqtrd adantr cA vk cv cexp co ccj cfv cA ccj cfv vk cv
      cexp co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv cexp co ccj cfv cA ccj
      cfv cmul co cA ccj cfv vk cv cexp co cA ccj cfv cmul co cA ccj cfv vk cv
      c1 caddc co cexp co cA vk cv cexp co ccj cfv cA ccj cfv vk cv cexp co cA
      ccj cfv cmul opreq1 cA cc wcel vk cv cn0 wcel wa cA ccj cfv vk cv c1
      caddc co cexp co cA ccj cfv vk cv cexp co cA ccj cfv cmul co cA ccj cfv
      cc wcel vk cv cn0 wcel cA ccj cfv vk cv c1 caddc co cexp co cA ccj cfv vk
      cv cexp co cA ccj cfv cmul co wceq cA cc wcel cA ccj cfv vk cv expp1 cA
      cjcl sylan eqcomd sylan9eqr eqtrd exp31 com12 a2d nn0ind impcom $.
      $( [8-Jun-2006] $) $( [7-Jun-2006] $)
  $}

  $( The real part of a number in terms of complex conjugate. $)
  recj $p |- ( A e. CC -> ( Re ` A ) = ( ( A + ( * ` A ) ) / 2 ) ) $=
    cA cc wcel cA cre cfv cA cre cfv caddc co c2 cdiv co cA cre cfv c2 cdiv co
    cA cre cfv c2 cdiv co caddc co cA cA ccj cfv caddc co c2 cdiv co cA cre cfv
    cA cre cfv cc wcel cA cre cfv cc wcel cA cre cfv cA cre cfv caddc co c2
    cdiv co cA cre cfv c2 cdiv co cA cre cfv c2 cdiv co caddc co wceq cA cc
    wcel cA cre cfv cc wcel cA cre cfv cc wcel c2 cc wcel c2 cc0 wne wa cA cre
    cfv cA cre cfv caddc co c2 cdiv co cA cre cfv c2 cdiv co cA cre cfv c2 cdiv
    co caddc co wceq c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i cA cre cfv cA cre
    cfv c2 divdir mp3an3 cA cc wcel cA cre cfv cA recl recnd cA cc wcel cA cre
    cfv cA recl recnd sylanc cA cc wcel cA cre cfv cA cre cfv caddc co cA cA
    ccj cfv caddc co c2 cdiv cA cc wcel cA cA ccj cfv caddc co cA cre cfv ci cA
    cim cfv cmul co caddc co cA cre cfv ci cA cim cfv cmul co cmin co caddc co
    cA cre cfv ci cA cim cfv cmul co caddc co cA cre cfv ci cA cim cfv cmul co
    cneg caddc co caddc co cA cre cfv cA cre cfv caddc co cA cc wcel cA cA cre
    cfv ci cA cim cfv cmul co caddc co cA ccj cfv cA cre cfv ci cA cim cfv cmul
    co cmin co caddc cA replim cA cjval opreq12d cA cc wcel cA cre cfv ci cA
    cim cfv cmul co cneg caddc co cA cre cfv ci cA cim cfv cmul co cmin co cA
    cre cfv ci cA cim cfv cmul co caddc co caddc cA cre cfv cc wcel ci cA cim
    cfv cmul co cc wcel cA cre cfv ci cA cim cfv cmul co cneg caddc co cA cre
    cfv ci cA cim cfv cmul co cmin co wceq cA cc wcel cA cre cfv ci cA cim cfv
    cmul co negsub cA cc wcel cA cre cfv cA recl recnd ci cc wcel cA cim cfv cc
    wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci cA cim cfv mulcl axicn cA
    cc wcel cA cim cfv cA imcl recnd sylancr sylanc opreq2d cA cc wcel cA cre
    cfv cA cre cfv caddc co ci cA cim cfv cmul co ci cA cim cfv cmul co cneg
    caddc co caddc co cA cre cfv cA cre cfv caddc co cc0 caddc co cA cre cfv ci
    cA cim cfv cmul co caddc co cA cre cfv ci cA cim cfv cmul co cneg caddc co
    caddc co cA cre cfv cA cre cfv caddc co cA cc wcel ci cA cim cfv cmul co ci
    cA cim cfv cmul co cneg caddc co cc0 cA cre cfv cA cre cfv caddc co caddc
    cA cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel ci cA cim cfv
    cmul co ci cA cim cfv cmul co cneg caddc co cc0 wceq cA cc wcel cA cim cfv
    cA imcl recnd ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel
    axicn ci cA cim cfv mulcl mpan ci cA cim cfv cmul co negid 3syl opreq2d cA
    cre cfv cc wcel cA cre cfv cc wcel ci cA cim cfv cmul co cc wcel ci cA cim
    cfv cmul co cneg cc wcel cA cre cfv cA cre cfv caddc co ci cA cim cfv cmul
    co ci cA cim cfv cmul co cneg caddc co caddc co cA cre cfv ci cA cim cfv
    cmul co caddc co cA cre cfv ci cA cim cfv cmul co cneg caddc co caddc co
    wceq cA cc wcel cA cre cfv cA cre cfv ci cA cim cfv cmul co ci cA cim cfv
    cmul co cneg add4 cA cc wcel cA cre cfv cA recl recnd cA cc wcel cA cre cfv
    cA recl recnd ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel
    cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd
    sylancr cA cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel ci cA
    cim cfv cmul co cneg cc wcel cA cc wcel cA cim cfv cA imcl recnd ci cc wcel
    cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel axicn ci cA cim cfv mulcl
    mpan ci cA cim cfv cmul co negcl 3syl syl2anc cA cc wcel cA cre cfv cc wcel
    cA cre cfv cc wcel wa cA cre cfv cA cre cfv caddc co cc wcel cA cre cfv cA
    cre cfv caddc co cc0 caddc co cA cre cfv cA cre cfv caddc co wceq cA cc
    wcel cA cre cfv cc wcel cA cre cfv cc wcel cA cc wcel cA cre cfv cA recl
    recnd cA cc wcel cA cre cfv cA recl recnd jca cA cre cfv cA cre cfv addcl
    cA cre cfv cA cre cfv caddc co addid1 3syl 3eqtr3d 3eqtr2rd opreq1d cA cc
    wcel cA cre cfv cc wcel cA cre cfv c2 cdiv co cA cre cfv c2 cdiv co caddc
    co cA cre cfv wceq cA cc wcel cA cre cfv cA recl recnd cA cre cfv 2halves
    syl 3eqtr3rd $.
    $( [2-Aug-2006] $) $( [30-Apr-2005] $)

  $( The imaginary part of a number in terms of complex conjugate. $)
  imcj $p |- ( A e. CC -> ( Im ` A ) = ( ( A - ( * ` A ) ) / ( 2 x. _i ) ) ) $=
    cA cc wcel cA cim cfv c2 ci cmul co cmul co c2 ci cmul co cdiv co cA cim
    cfv cA cA ccj cfv cmin co c2 ci cmul co cdiv co cA cc wcel cA cim cfv cc
    wcel cA cim cfv c2 ci cmul co cmul co c2 ci cmul co cdiv co cA cim cfv wceq
    cA cc wcel cA cim cfv cA imcl recnd cA cim cfv cc wcel c2 ci cmul co cc
    wcel c2 ci cmul co cc0 wne cA cim cfv c2 ci cmul co cmul co c2 ci cmul co
    cdiv co cA cim cfv wceq c2 ci 2cn axicn mulcli c2 ci 2cn axicn 2ne0 ine0
    muln0i cA cim cfv c2 ci cmul co divcan4 mp3an23 syl cA cc wcel cA cim cfv
    c2 ci cmul co cmul co cA cA ccj cfv cmin co c2 ci cmul co cdiv cA cc wcel
    cA cre cfv ci cA cim cfv cmul co caddc co cA cre cfv ci cA cim cfv cmul co
    cmin co cmin co cA cre cfv ci cA cim cfv cmul co caddc co cA cre cfv cmin
    co ci cA cim cfv cmul co caddc co cA cA ccj cfv cmin co cA cim cfv c2 ci
    cmul co cmul co cA cre cfv ci cA cim cfv cmul co caddc co cc wcel cA cre
    cfv cc wcel ci cA cim cfv cmul co cc wcel cA cre cfv ci cA cim cfv cmul co
    caddc co cA cre cfv ci cA cim cfv cmul co cmin co cmin co cA cre cfv ci cA
    cim cfv cmul co caddc co cA cre cfv cmin co ci cA cim cfv cmul co caddc co
    wceq cA cc wcel cA cre cfv ci cA cim cfv cmul co caddc co cA cre cfv ci cA
    cim cfv cmul co subsub cA cre cfv cc wcel ci cA cim cfv cmul co cc wcel cA
    cre cfv ci cA cim cfv cmul co caddc co cc wcel cA cc wcel cA cre cfv ci cA
    cim cfv cmul co addcl cA cc wcel cA cre cfv cA recl recnd ci cc wcel cA cim
    cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci cA cim cfv mulcl
    axicn cA cc wcel cA cim cfv cA imcl recnd sylancr sylanc cA cc wcel cA cre
    cfv cA recl recnd ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc
    wcel cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl
    recnd sylancr syl3anc cA cc wcel cA cA cre cfv ci cA cim cfv cmul co caddc
    co cA ccj cfv cA cre cfv ci cA cim cfv cmul co cmin co cmin cA replim cA
    cjval opreq12d cA cc wcel c2 ci cA cim cfv cmul co cmul co ci cA cim cfv
    cmul co ci cA cim cfv cmul co caddc co cA cim cfv c2 ci cmul co cmul co cA
    cre cfv ci cA cim cfv cmul co caddc co cA cre cfv cmin co ci cA cim cfv
    cmul co caddc co cA cc wcel ci cA cim cfv cmul co cc wcel c2 ci cA cim cfv
    cmul co cmul co ci cA cim cfv cmul co ci cA cim cfv cmul co caddc co wceq
    ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci
    cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd sylancr ci cA
    cim cfv cmul co 2times syl cA cc wcel cA cim cfv cc wcel cA cim cfv c2 ci
    cmul co cmul co c2 ci cA cim cfv cmul co cmul co wceq cA cc wcel cA cim cfv
    cA imcl recnd cA cim cfv cc wcel cA cim cfv c2 ci cmul co cmul co c2 ci
    cmul co cA cim cfv cmul co c2 ci cA cim cfv cmul co cmul co cA cim cfv cc
    wcel c2 ci cmul co cc wcel cA cim cfv c2 ci cmul co cmul co c2 ci cmul co
    cA cim cfv cmul co wceq c2 ci 2cn axicn mulcli cA cim cfv c2 ci cmul co
    mulcom mpan2 c2 cc wcel ci cc wcel cA cim cfv cc wcel c2 ci cmul co cA cim
    cfv cmul co c2 ci cA cim cfv cmul co cmul co wceq 2cn axicn c2 ci cA cim
    cfv mulass mp3an12 eqtrd syl cA cc wcel cA cre cfv ci cA cim cfv cmul co
    caddc co cA cre cfv cmin co ci cA cim cfv cmul co ci cA cim cfv cmul co
    caddc cA cre cfv cc wcel ci cA cim cfv cmul co cc wcel cA cre cfv ci cA cim
    cfv cmul co caddc co cA cre cfv cmin co ci cA cim cfv cmul co wceq cA cc
    wcel cA cre cfv ci cA cim cfv cmul co pncan2 cA cc wcel cA cre cfv cA recl
    recnd ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc
    wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd sylancr
    sylanc opreq1d 3eqtr4d 3eqtr4rd opreq1d eqtr3d $.
    $( [7-Aug-2005] $) $( [30-Apr-2005] $)

  $( The real part of zero. $)
  re0 $p |- ( Re ` 0 ) = 0 $=
    cc0 cr wcel cc0 cre cfv cc0 wceq 0re cc0 0cn rerebi mpbi $.
    $( [27-Jul-1999] $)

  $( The imaginary part of zero. $)
  im0 $p |- ( Im ` 0 ) = 0 $=
    cc0 cr wcel cc0 cim cfv cc0 wceq 0re cc0 0cn reim0bi mpbi $.
    $( [27-Jul-1999] $)

  $( The real part of one.  (Contributed by Scott Fenton, 9-Jun-2006.) $)
  re1 $p |- ( Re ` 1 ) = 1 $=
    c1 cr wcel c1 cre cfv c1 wceq 1re c1 ax1cn rerebi mpbi $.
    $( [10-Jun-2006] $) $( [9-Jun-2006] $)

  $( The imaginary part of one.  (Contributed by Scott Fenton, 9-Jun-2006.) $)
  im1 $p |- ( Im ` 1 ) = 0 $=
    c1 cr wcel c1 cim cfv cc0 wceq 1re c1 ax1cn reim0bi mpbi $.
    $( [10-Jun-2006] $) $( [9-Jun-2006] $)

  $( The real part of ` _i ` .  (Contributed by Scott Fenton, 9-Jun-2006.) $)
  rei $p |- ( Re ` _i ) = 0 $=
    cc0 ci c1 cmul co caddc co cre cfv ci c1 cmul co cre cfv cc0 ci cre cfv cc0
    ci c1 cmul co caddc co ci c1 cmul co cre ci c1 cmul co ci c1 axicn ax1cn
    mulcli addid2i fveq2i cc0 c1 0re 1re crrei ci c1 cmul co ci cre ci axicn
    mulid1i fveq2i 3eqtr3ri $.
    $( [15-Mar-2008] $) $( [9-Jun-2006] $)

  $( The imaginary part of ` _i ` .  (Contributed by Scott Fenton,
     9-Jun-2006.) $)
  imi $p |- ( Im ` _i ) = 1 $=
    ci c1 cmul co cim cfv cc0 ci c1 cmul co caddc co cim cfv ci cim cfv c1 ci
    c1 cmul co cc0 ci c1 cmul co caddc co cim cc0 ci c1 cmul co caddc co ci c1
    cmul co ci c1 cmul co ci c1 axicn ax1cn mulcli addid2i eqcomi fveq2i ci c1
    cmul co ci cim ci axicn mulid1i fveq2i cc0 c1 0re 1re crimi 3eqtr3i $.
    $( [15-Mar-2008] $) $( [9-Jun-2006] $)

  $( The conjugate of zero. $)
  cj0 $p |- ( * ` 0 ) = 0 $=
    cc0 cr wcel cc0 ccj cfv cc0 wceq 0re cc0 0cn cjrebi mpbi $.
    $( [27-Jul-1999] $)

  $( The complex conjugate of the imaginary unit. $)
  cji $p |- ( * ` _i ) = -u _i $=
    ci cre cfv ci ci cim cfv cmul co cmin co cc0 ci cmin co ci ccj cfv ci cneg
    ci cre cfv cc0 ci ci cim cfv cmul co ci cmin rei ci ci cim cfv cmul co ci
    c1 cmul co ci ci cim cfv c1 ci cmul imi opreq2i ci axicn mulid1i eqtri
    opreq12i ci cc wcel ci ccj cfv ci cre cfv ci ci cim cfv cmul co cmin co
    wceq axicn ci cjval ax-mp ci df-neg 3eqtr4i $.
    $( [13-Jun-2005] $) $( [26-Mar-2005] $)

  $( The conjugate of a representation of a complex number in terms of real
     and imaginary parts. $)
  cjreim $p |- ( ( A e. RR /\ B e. RR ) -> ( * ` ( A + ( _i x. B ) ) ) =
                ( A - ( _i x. B ) ) ) $=
    cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co ccj cfv cA ccj cfv ci cB
    cmul co ccj cfv caddc co cA ci cB cmul co cneg caddc co cA ci cB cmul co
    cmin co cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co caddc co ccj cfv
    cA ccj cfv ci cB cmul co ccj cfv caddc co wceq cA cr wcel cB cr wcel cA ci
    cB cmul co cjadd cA recn ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr
    wcel ci cB mulcl axicn cB recn sylancr syl2an cA cr wcel cB cr wcel cA ccj
    cfv cA ci cB cmul co ccj cfv ci cB cmul co cneg caddc cA cjre cB cr wcel ci
    cB cmul co ccj cfv ci ccj cfv cB ccj cfv cmul co ci cneg cB cmul co ci cB
    cmul co cneg ci cc wcel cB cc wcel ci cB cmul co ccj cfv ci ccj cfv cB ccj
    cfv cmul co wceq cB cr wcel ci cB cjmul axicn cB recn sylancr cB cr wcel ci
    ccj cfv ci cneg cB ccj cfv cB cmul ci ccj cfv ci cneg wceq cB cr wcel cji
    a1i cB cjre opreq12d ci cc wcel cB cc wcel ci cneg cB cmul co ci cB cmul co
    cneg wceq cB cr wcel ci cB mulneg1 axicn cB recn sylancr 3eqtrd opreqan12d
    cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co cneg caddc co cA ci cB
    cmul co cmin co wceq cA cr wcel cB cr wcel cA ci cB cmul co negsub cA recn
    ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr wcel ci cB mulcl axicn cB
    recn sylancr syl2an 3eqtrd $.
    $( [1-Aug-2006] $) $( [1-Jul-2005] $)

  $( The conjugate of the representation of a complex number in terms of real
     and imaginary parts. $)
  cjreim2 $p |- ( ( A e. RR /\ B e. RR ) -> ( * ` ( A - ( _i x. B ) ) ) =
                ( A + ( _i x. B ) ) ) $=
    cA cr wcel cB cr wcel wa cA ci cB cmul co cmin co ccj cfv cA ccj cfv ci cB
    cmul co ccj cfv cmin co cA ci cB cmul co cneg cmin co cA ci cB cmul co
    caddc co cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co cmin co ccj cfv
    cA ccj cfv ci cB cmul co ccj cfv cmin co wceq cA cr wcel cB cr wcel cA ci
    cB cmul co cjsub cA recn ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr
    wcel ci cB mulcl axicn cB recn sylancr syl2an cA cr wcel cB cr wcel cA ccj
    cfv cA ci cB cmul co ccj cfv ci cB cmul co cneg cmin cA cjre cB cr wcel ci
    cB cmul co ccj cfv ci ccj cfv cB ccj cfv cmul co ci cneg cB cmul co ci cB
    cmul co cneg ci cc wcel cB cc wcel ci cB cmul co ccj cfv ci ccj cfv cB ccj
    cfv cmul co wceq cB cr wcel ci cB cjmul axicn cB recn sylancr cB cr wcel ci
    ccj cfv ci cneg cB ccj cfv cB cmul ci ccj cfv ci cneg wceq cB cr wcel cji
    a1i cB cjre opreq12d ci cc wcel cB cc wcel ci cneg cB cmul co ci cB cmul co
    cneg wceq cB cr wcel ci cB mulneg1 axicn cB recn sylancr 3eqtrd opreqan12d
    cA cc wcel ci cB cmul co cc wcel cA ci cB cmul co cneg cmin co cA ci cB
    cmul co caddc co wceq cA cr wcel cB cr wcel cA ci cB cmul co subneg cA recn
    ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr wcel ci cB mulcl axicn cB
    recn sylancr syl2an 3eqtrd $.
    $( [5-Oct-2005] $) $( [1-Jul-2005] $)

  $( Complex conjugate is a one-to-one function.  (Proof shortened by Eric
     Schmidt, 2-Jul-2009.  Previous version is ~ cj11OLD .) $)
  cj11  $p |- ( ( A e. CC /\ B e. CC ) ->
              ( ( * ` A ) = ( * ` B ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel wa cA ccj cfv cB ccj cfv wceq cA cB wceq cA cc wcel
    cB cc wcel wa cA ccj cfv ccj cfv cB ccj cfv ccj cfv wceq cA cB wceq cA ccj
    cfv cB ccj cfv wceq cA cc wcel cB cc wcel cA ccj cfv ccj cfv cA cB ccj cfv
    ccj cfv cB cA cjcj cB cjcj eqeqan12d cA ccj cfv cB ccj cfv ccj fveq2 syl5bi
    cA cB ccj fveq2 impbid1 $.
    $( [2-Jul-2009] $) $( [29-Apr-2005] $)

  $( Complex conjugate is a one-to-one function. $)
  cj11OLD  $p |- ( ( A e. CC /\ B e. CC ) ->
              ( ( * ` A ) = ( * ` B ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel wa cA cre cfv ci cA cim cfv cneg cmul co caddc co cB
    cre cfv ci cB cim cfv cneg cmul co caddc co wceq cA cre cfv ci cA cim cfv
    cmul co caddc co cB cre cfv ci cB cim cfv cmul co caddc co wceq cA ccj cfv
    cB ccj cfv wceq cA cB wceq cA cc wcel cB cc wcel wa cA cre cfv cB cre cfv
    wceq cA cim cfv cneg cB cim cfv cneg wceq wa cA cre cfv cB cre cfv wceq cA
    cim cfv cB cim cfv wceq wa cA cre cfv ci cA cim cfv cneg cmul co caddc co
    cB cre cfv ci cB cim cfv cneg cmul co caddc co wceq cA cre cfv ci cA cim
    cfv cmul co caddc co cB cre cfv ci cB cim cfv cmul co caddc co wceq cA cc
    wcel cB cc wcel wa cA cim cfv cneg cB cim cfv cneg wceq cA cim cfv cB cim
    cfv wceq cA cre cfv cB cre cfv wceq cA cim cfv cc wcel cB cim cfv cc wcel
    cA cim cfv cneg cB cim cfv cneg wceq cA cim cfv cB cim cfv wceq wb cA cc
    wcel cB cc wcel cA cim cfv cB cim cfv neg11 cA cc wcel cA cim cfv cA imcl
    recnd cB cc wcel cB cim cfv cB imcl recnd syl2an anbi2d cA cre cfv cr wcel
    cA cim cfv cneg cr wcel wa cB cre cfv cr wcel cB cim cfv cneg cr wcel wa cA
    cre cfv ci cA cim cfv cneg cmul co caddc co cB cre cfv ci cB cim cfv cneg
    cmul co caddc co wceq cA cre cfv cB cre cfv wceq cA cim cfv cneg cB cim cfv
    cneg wceq wa wb cA cc wcel cB cc wcel cA cre cfv cA cim cfv cneg cB cre cfv
    cB cim cfv cneg cru cA cc wcel cA cre cfv cr wcel cA cim cfv cneg cr wcel
    cA recl cA cc wcel cA cim cfv cr wcel cA cim cfv cneg cr wcel cA imcl cA
    cim cfv renegcl syl jca cB cc wcel cB cre cfv cr wcel cB cim cfv cneg cr
    wcel cB recl cB cc wcel cB cim cfv cr wcel cB cim cfv cneg cr wcel cB imcl
    cB cim cfv renegcl syl jca syl2an cA cre cfv cr wcel cA cim cfv cr wcel wa
    cB cre cfv cr wcel cB cim cfv cr wcel wa cA cre cfv ci cA cim cfv cmul co
    caddc co cB cre cfv ci cB cim cfv cmul co caddc co wceq cA cre cfv cB cre
    cfv wceq cA cim cfv cB cim cfv wceq wa wb cA cc wcel cB cc wcel cA cre cfv
    cA cim cfv cB cre cfv cB cim cfv cru cA cc wcel cA cre cfv cr wcel cA cim
    cfv cr wcel cA recl cA imcl jca cB cc wcel cB cre cfv cr wcel cB cim cfv cr
    wcel cB recl cB imcl jca syl2an 3bitr4d cA cc wcel cB cc wcel cA ccj cfv cA
    cre cfv ci cA cim cfv cneg cmul co caddc co cB ccj cfv cB cre cfv ci cB cim
    cfv cneg cmul co caddc co cA cc wcel cA cre cfv ci cA cim cfv cmul co cneg
    caddc co cA cre cfv ci cA cim cfv cmul co cmin co cA cre cfv ci cA cim cfv
    cneg cmul co caddc co cA ccj cfv cA cre cfv cc wcel ci cA cim cfv cmul co
    cc wcel cA cre cfv ci cA cim cfv cmul co cneg caddc co cA cre cfv ci cA cim
    cfv cmul co cmin co wceq cA cc wcel cA cre cfv ci cA cim cfv cmul co negsub
    cA cc wcel cA cre cfv cA recl recnd ci cc wcel cA cim cfv cc wcel ci cA cim
    cfv cmul co cc wcel cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim
    cfv cA imcl recnd sylancr sylanc cA cc wcel ci cA cim cfv cneg cmul co ci
    cA cim cfv cmul co cneg cA cre cfv caddc ci cc wcel cA cim cfv cc wcel ci
    cA cim cfv cneg cmul co ci cA cim cfv cmul co cneg wceq cA cc wcel ci cA
    cim cfv mulneg2 axicn cA cc wcel cA cim cfv cA imcl recnd sylancr opreq2d
    cA cjval 3eqtr4rd cB cc wcel cB cre cfv ci cB cim cfv cmul co cneg caddc co
    cB cre cfv ci cB cim cfv cmul co cmin co cB cre cfv ci cB cim cfv cneg cmul
    co caddc co cB ccj cfv cB cre cfv cc wcel ci cB cim cfv cmul co cc wcel cB
    cre cfv ci cB cim cfv cmul co cneg caddc co cB cre cfv ci cB cim cfv cmul
    co cmin co wceq cB cc wcel cB cre cfv ci cB cim cfv cmul co negsub cB cc
    wcel cB cre cfv cB recl recnd ci cc wcel cB cim cfv cc wcel ci cB cim cfv
    cmul co cc wcel cB cc wcel ci cB cim cfv mulcl axicn cB cc wcel cB cim cfv
    cB imcl recnd sylancr sylanc cB cc wcel ci cB cim cfv cneg cmul co ci cB
    cim cfv cmul co cneg cB cre cfv caddc ci cc wcel cB cim cfv cc wcel ci cB
    cim cfv cneg cmul co ci cB cim cfv cmul co cneg wceq cB cc wcel ci cB cim
    cfv mulneg2 axicn cB cc wcel cB cim cfv cB imcl recnd sylancr opreq2d cB
    cjval 3eqtr4rd eqeqan12d cA cc wcel cB cc wcel cA cA cre cfv ci cA cim cfv
    cmul co caddc co cB cB cre cfv ci cB cim cfv cmul co caddc co cA replim cB
    replim eqeqan12d 3bitr4d $.
    $( [1-Aug-2006] $) $( [29-Apr-2005] $)

  $( A number is non-zero iff its complex conjugate is non-zero. $)
  cjne0 $p |- ( A e. CC -> ( A =/= 0 <-> ( * ` A ) =/= 0 ) ) $=
    cA cc wcel cA cc0 cA ccj cfv cc0 cA cc wcel cA ccj cfv cc0 ccj cfv wceq cA
    cc0 wceq cA ccj cfv cc0 wceq cA cc wcel cc0 cc wcel cA ccj cfv cc0 ccj cfv
    wceq cA cc0 wceq wb 0cn cA cc0 cj11 mpan2 cc0 ccj cfv cc0 cA ccj cfv cj0
    eqeq2i syl5rbbr necon3bid $.
    $( [8-Jul-2005] $) $( [29-Apr-2005] $)

  $( Absolute value of negative. $)
  absneg $p |- ( A e. CC -> ( abs ` -u A ) = ( abs ` A ) ) $=
    cA cc wcel cA cneg cA cneg ccj cfv cmul co csqr cfv cA cA ccj cfv cmul co
    csqr cfv cA cneg cabs cfv cA cabs cfv cA cc wcel cA cneg cA cneg ccj cfv
    cmul co cA cA ccj cfv cmul co csqr cA cc wcel cA cneg cA cneg ccj cfv cmul
    co cA cneg cA ccj cfv cneg cmul co cA cA ccj cfv cmul co cA cc wcel cA cneg
    ccj cfv cA ccj cfv cneg cA cneg cmul cA cjneg opreq2d cA cc wcel cA ccj cfv
    cc wcel cA cneg cA ccj cfv cneg cmul co cA cA ccj cfv cmul co wceq cA cjcl
    cA cA ccj cfv mul2neg mpdan eqtrd fveq2d cA cc wcel cA cneg cc wcel cA cneg
    cabs cfv cA cneg cA cneg ccj cfv cmul co csqr cfv wceq cA negcl cA cneg
    absval syl cA absval 3eqtr4d $.
    $( [28-Feb-2005] $) $( [27-Feb-2005] $)

  $( Real closure of absolute value. $)
  abscl $p |- ( A e. CC -> ( abs ` A ) e. RR ) $=
    cA cc wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv cr cA absval cA cA
    ccj cfv cmul co cr wcel cc0 cA cA ccj cfv cmul co cle wbr cA cA ccj cfv
    cmul co csqr cfv cr wcel cA cc wcel cA cA ccj cfv cmul co sqrcl cA cjmulrcl
    cA cjmulge0 sylanc eqeltrd $.
    $( [3-Oct-1999] $)

  $( The absolute value of a number and its conjugate are the same.
     Proposition 10-3.7(b) of [Gleason] p. 133. $)
  abscj $p |- ( A e. CC -> ( abs ` ( * ` A ) ) = ( abs ` A ) ) $=
    cA cc wcel cA cA ccj cfv cmul co csqr cfv cA ccj cfv cA ccj cfv ccj cfv
    cmul co csqr cfv cA cabs cfv cA ccj cfv cabs cfv cA cc wcel cA cA ccj cfv
    cmul co cA ccj cfv cA ccj cfv ccj cfv cmul co csqr cA cc wcel cA cA ccj cfv
    cmul co cA ccj cfv cA cmul co cA ccj cfv cA ccj cfv ccj cfv cmul co cA cc
    wcel cA ccj cfv cc wcel cA cA ccj cfv cmul co cA ccj cfv cA cmul co wceq cA
    cjcl cA cA ccj cfv mulcom mpdan cA cc wcel cA ccj cfv ccj cfv cA cA ccj cfv
    cmul cA cjcj opreq2d eqtr4d fveq2d cA absval cA cc wcel cA ccj cfv cc wcel
    cA ccj cfv cabs cfv cA ccj cfv cA ccj cfv ccj cfv cmul co csqr cfv wceq cA
    cjcl cA ccj cfv absval syl 3eqtr4rd $.
    $( [30-Apr-2005] $) $( [28-Apr-2005] $)

  $( Square of value of absolute value function. $)
  absvalsq $p |- ( A e. CC -> ( ( abs ` A ) ^ 2 ) = ( A x. ( * ` A ) ) ) $=
    cA cc wcel cA cabs cfv c2 cexp co cA cA ccj cfv cmul co csqr cfv c2 cexp co
    cA cA ccj cfv cmul co cA cc wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv
    c2 cexp cA absval opreq1d cA cA ccj cfv cmul co cr wcel cc0 cA cA ccj cfv
    cmul co cle wbr cA cA ccj cfv cmul co csqr cfv c2 cexp co cA cA ccj cfv
    cmul co wceq cA cc wcel cA cA ccj cfv cmul co sqsqr cA cjmulrcl cA cjmulge0
    sylanc eqtrd $.
    $( [2-Feb-2006] $) $( [16-Jan-2006] $)

  $( Square of value of absolute value function. $)
  absvalsq2 $p |- ( A e. CC -> ( ( abs ` A ) ^ 2 ) =
                    ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
    cA cc wcel cA cabs cfv c2 cexp co cA cA ccj cfv cmul co cA cre cfv c2 cexp
    co cA cim cfv c2 cexp co caddc co cA absvalsq cA cjmulval eqtrd $.
    $( [1-Feb-2007] $) $( [1-Feb-2007] $)

  ${
    absvalsqi.1 $e |- A e. CC $.
    $( Square of value of absolute value function. $)
    absvalsqi $p |- ( ( abs ` A ) ^ 2 ) = ( A x. ( * ` A ) ) $=
      cA cc wcel cA cabs cfv c2 cexp co cA cA ccj cfv cmul co wceq absvalsqi.1
      cA absvalsq ax-mp $.
      $( [2-Oct-1999] $)

    $( Square of value of absolute value function. $)
    absvalsq2i $p |- ( ( abs ` A ) ^ 2 ) =
                    ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) $=
      cA cc wcel cA cabs cfv c2 cexp co cA cre cfv c2 cexp co cA cim cfv c2
      cexp co caddc co wceq absvalsqi.1 cA absvalsq2 ax-mp $.
      $( [2-Oct-1999] $)

    $( Real closure of absolute value. $)
    abscli $p |- ( abs ` A ) e. RR $=
      cA cc wcel cA cabs cfv cr wcel absvalsqi.1 cA abscl ax-mp $.
      $( [2-Aug-1999] $)

    $( Absolute value is nonnegative. $)
    absge0i $p |- 0 <_ ( abs ` A ) $=
      cc0 cA cA ccj cfv cmul co csqr cfv cA cabs cfv cle cc0 cA cA ccj cfv cmul
      co cle wbr cc0 cA cA ccj cfv cmul co csqr cfv cle wbr cA absvalsqi.1
      cjmulge0i cA cA ccj cfv cmul co cA absvalsqi.1 cjmulrcli sqrge0i ax-mp cA
      cc wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv wceq absvalsqi.1 cA
      absval ax-mp breqtrri $.
      $( [2-Aug-1999] $)

    $( Value of absolute value function.  Definition 10.36 of [Gleason]
       p. 133. $)
    absval2i $p |- ( abs ` A ) =
                 ( sqr ` ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
      cA cabs cfv cA cA ccj cfv cmul co csqr cfv cA cre cfv c2 cexp co cA cim
      cfv c2 cexp co caddc co csqr cfv cA cc wcel cA cabs cfv cA cA ccj cfv
      cmul co csqr cfv wceq absvalsqi.1 cA absval ax-mp cA cA ccj cfv cmul co
      cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co csqr cA absvalsqi.1
      cjmulvali fveq2i eqtri $.
      $( [2-Oct-1999] $)

    $( The absolute value of a number is zero iff the number is zero.
       Proposition 10-3.7(c) of [Gleason] p. 133. $)
    abs00i $p |- ( ( abs ` A ) = 0 <-> A = 0 ) $=
      cA cabs cfv cc0 wceq cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co
      csqr cfv cc0 wceq cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co
      cc0 wceq cA cc0 wceq cA cabs cfv cA cre cfv c2 cexp co cA cim cfv c2 cexp
      co caddc co csqr cfv cc0 cA absvalsqi.1 absval2i eqeq1i cA cre cfv c2
      cexp co cA cim cfv c2 cexp co caddc co cr wcel cc0 cA cre cfv c2 cexp co
      cA cim cfv c2 cexp co caddc co cle wbr cA cre cfv c2 cexp co cA cim cfv
      c2 cexp co caddc co csqr cfv cc0 wceq cA cre cfv c2 cexp co cA cim cfv c2
      cexp co caddc co cc0 wceq wb cA cre cfv c2 cexp co cA cim cfv c2 cexp co
      cA cre cfv cA absvalsqi.1 recli resqcli cA cim cfv cA absvalsqi.1 imcli
      resqcli readdcli cc0 cA cre cfv c2 cexp co cle wbr cc0 cA cim cfv c2 cexp
      co cle wbr cc0 cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cle
      wbr cA cre cfv cA absvalsqi.1 recli sqge0i cA cim cfv cA absvalsqi.1
      imcli sqge0i cA cre cfv c2 cexp co cA cim cfv c2 cexp co cA cre cfv cA
      absvalsqi.1 recli resqcli cA cim cfv cA absvalsqi.1 imcli resqcli addge0i
      mp2an cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co sqr00 mp2an cA
      cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cc0 wceq cA cre cfv c2
      cexp co cc0 wceq cA cim cfv c2 cexp co cc0 wceq wa cA cre cfv cc0 wceq cA
      cim cfv cc0 wceq wa cA cc0 wceq cc0 cA cre cfv c2 cexp co cle wbr cc0 cA
      cim cfv c2 cexp co cle wbr cA cre cfv c2 cexp co cA cim cfv c2 cexp co
      caddc co cc0 wceq cA cre cfv c2 cexp co cc0 wceq cA cim cfv c2 cexp co
      cc0 wceq wa wb cA cre cfv cA absvalsqi.1 recli sqge0i cA cim cfv cA
      absvalsqi.1 imcli sqge0i cA cre cfv c2 cexp co cA cim cfv c2 cexp co cA
      cre cfv cA absvalsqi.1 recli resqcli cA cim cfv cA absvalsqi.1 imcli
      resqcli add20i mp2an cA cre cfv c2 cexp co cc0 wceq cA cre cfv cc0 wceq
      cA cim cfv c2 cexp co cc0 wceq cA cim cfv cc0 wceq cA cre cfv cA cre cfv
      cA absvalsqi.1 recli recni sqeq0i cA cim cfv cA cim cfv cA absvalsqi.1
      imcli recni sqeq0i anbi12i cA cre cfv cc0 wceq cA cim cfv cc0 wceq wa cA
      cc0 wceq cA cre cfv cc0 wceq cA cim cfv cc0 wceq wa cA cre cfv ci cA cim
      cfv cmul co caddc co cc0 cA cA cre cfv cc0 wceq cA cim cfv cc0 wceq wa cA
      cre cfv ci cA cim cfv cmul co caddc co cc0 ci cc0 cmul co caddc co cc0 cA
      cre cfv cc0 wceq cA cim cfv cc0 wceq cA cre cfv ci cA cim cfv cmul co
      caddc co cc0 ci cA cim cfv cmul co caddc co cc0 ci cc0 cmul co caddc co
      cA cre cfv cc0 ci cA cim cfv cmul co caddc opreq1 cA cim cfv cc0 wceq ci
      cA cim cfv cmul co ci cc0 cmul co cc0 caddc cA cim cfv cc0 ci cmul opreq2
      opreq2d sylan9eq cc0 ci cc0 cmul co caddc co ci cc0 cmul co cc0 ci cc0
      cmul co ci cc0 axicn 0cn mulcli addid2i ci axicn mul01i eqtri syl6eq cA
      absvalsqi.1 replimi syl5eq cA cc0 wceq cA cre cfv cc0 wceq cA cim cfv cc0
      wceq cA cc0 wceq cA cre cfv cc0 cre cfv cc0 cA cc0 cre fveq2 re0 syl6eq
      cA cc0 wceq cA cim cfv cc0 cim cfv cc0 cA cc0 cim fveq2 im0 syl6eq jca
      impbii 3bitri 3bitri $.
      $( [24-Jul-2008] $) $( [28-Jul-1999] $)

    $( The absolute value of a non-zero number is positive.  Remark in
       [Apostol] p. 363. $)
    absgt0i $p |- ( A =/= 0 <-> 0 < ( abs ` A ) ) $=
      cc0 cA cabs cfv clt wbr cc0 cA cabs cfv cle wbr cA cabs cfv cc0 wne wa cA
      cabs cfv cc0 wne cA cc0 wne cc0 cA cabs cfv 0re cA absvalsqi.1 abscli
      ltleni cc0 cA cabs cfv cle wbr cA cabs cfv cc0 wne cA absvalsqi.1 absge0i
      biantrur cA cabs cfv cc0 cA cc0 cA absvalsqi.1 abs00i necon3bii 3bitr2ri
      $.
      $( [6-Mar-2005] $) $( [1-Oct-1999] $)

    $( Absolute value of negative. $)
    absnegi $p |- ( abs ` -u A ) = ( abs ` A ) $=
      cA cc wcel cA cneg cabs cfv cA cabs cfv wceq absvalsqi.1 cA absneg ax-mp
      $.
      $( [2-Aug-1999] $)

    $( The absolute value of a number and its conjugate are the same.
       Proposition 10-3.7(b) of [Gleason] p. 133. $)
    abscji $p |- ( abs ` ( * ` A ) ) = ( abs ` A ) $=
      cA cc wcel cA ccj cfv cabs cfv cA cabs cfv wceq absvalsqi.1 cA abscj
      ax-mp $.
      $( [27-Mar-2005] $) $( [2-Oct-1999] $)

    ${
      abssub.2 $e |- B e. CC $.
      $( Swapping order of subtraction doesn't change the absolute value.
         Example of [Apostol] p. 363. $)
      abssubi $p |- ( abs ` ( A - B ) ) = ( abs ` ( B - A ) ) $=
        cB cA cmin co cneg cabs cfv cA cB cmin co cabs cfv cB cA cmin co cabs
        cfv cB cA cmin co cneg cA cB cmin co cabs cB cA abssub.2 absvalsqi.1
        negsubdi2i fveq2i cB cA cmin co cB cA abssub.2 absvalsqi.1 subcli
        absnegi eqtr3i $.
        $( [1-Oct-1999] $)

      $( Absolute value distributes over multiplication.  Proposition 10-3.7(f)
         of [Gleason] p. 133. $)
      absmuli $p |- ( abs ` ( A x. B ) ) = ( ( abs ` A ) x. ( abs ` B ) ) $=
        cA cB cmul co cA cB cmul co ccj cfv cmul co csqr cfv cA cA ccj cfv cmul
        co csqr cfv cB cB ccj cfv cmul co csqr cfv cmul co cA cB cmul co cabs
        cfv cA cabs cfv cB cabs cfv cmul co cA cB cmul co cA cB cmul co ccj cfv
        cmul co csqr cfv cA cA ccj cfv cmul co cB cB ccj cfv cmul co cmul co
        csqr cfv cA cA ccj cfv cmul co csqr cfv cB cB ccj cfv cmul co csqr cfv
        cmul co cA cB cmul co cA cB cmul co ccj cfv cmul co cA cA ccj cfv cmul
        co cB cB ccj cfv cmul co cmul co csqr cA cB cmul co cA cB cmul co ccj
        cfv cmul co cA cB cmul co cA ccj cfv cB ccj cfv cmul co cmul co cA cA
        ccj cfv cmul co cB cB ccj cfv cmul co cmul co cA cB cmul co ccj cfv cA
        ccj cfv cB ccj cfv cmul co cA cB cmul co cmul cA cB absvalsqi.1
        abssub.2 cjmuli opreq2i cA cB cA ccj cfv cB ccj cfv absvalsqi.1
        abssub.2 cA absvalsqi.1 cjcli cB abssub.2 cjcli mul4i eqtri fveq2i cA
        cA ccj cfv cmul co cB cB ccj cfv cmul co cA absvalsqi.1 cjmulrcli cB
        abssub.2 cjmulrcli cA absvalsqi.1 cjmulge0i cB abssub.2 cjmulge0i
        sqrmulii eqtri cA cB cmul co cc wcel cA cB cmul co cabs cfv cA cB cmul
        co cA cB cmul co ccj cfv cmul co csqr cfv wceq cA cB absvalsqi.1
        abssub.2 mulcli cA cB cmul co absval ax-mp cA cabs cfv cA cA ccj cfv
        cmul co csqr cfv cB cabs cfv cB cB ccj cfv cmul co csqr cfv cmul cA cc
        wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv wceq absvalsqi.1 cA
        absval ax-mp cB cc wcel cB cabs cfv cB cB ccj cfv cmul co csqr cfv wceq
        abssub.2 cB absval ax-mp opreq12i 3eqtr4i $.
        $( [1-Oct-1999] $)
    $}
  $}

  $( Square of absolute value of sum.  Proposition 10-3.7(g) of [Gleason]
     p. 133. $)
  sqabsadd $p |- ( ( A e. CC /\ B e. CC ) -> ( ( abs ` ( A + B ) ) ^ 2 ) =
                  ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) )
                    + ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB caddc co cA cB caddc co ccj cfv cmul co cA
    cA ccj cfv cmul co cB ccj cfv cB cmul co caddc co cA cB ccj cfv cmul co cA
    ccj cfv cB cmul co caddc co caddc co cA cB caddc co cabs cfv c2 cexp co cA
    cabs cfv c2 cexp co cB cabs cfv c2 cexp co caddc co c2 cA cB ccj cfv cmul
    co cre cfv cmul co caddc co cA cc wcel cB cc wcel wa cA cB caddc co cA cB
    caddc co ccj cfv cmul co cA cB caddc co cA ccj cfv cB ccj cfv caddc co cmul
    co cA cA ccj cfv cmul co cB ccj cfv cB cmul co caddc co cA cB ccj cfv cmul
    co cA ccj cfv cB cmul co caddc co caddc co cA cc wcel cB cc wcel wa cA cB
    caddc co ccj cfv cA ccj cfv cB ccj cfv caddc co cA cB caddc co cmul cA cB
    cjadd opreq2d cA cc wcel cB cc wcel wa cA ccj cfv cc wcel cB ccj cfv cc
    wcel wa cA cB caddc co cA ccj cfv cB ccj cfv caddc co cmul co cA cA ccj cfv
    cmul co cB ccj cfv cB cmul co caddc co cA cB ccj cfv cmul co cA ccj cfv cB
    cmul co caddc co caddc co wceq cA cc wcel cA ccj cfv cc wcel cB cc wcel cB
    ccj cfv cc wcel cA cjcl cB cjcl anim12i cA cB cA ccj cfv cB ccj cfv muladd
    mpdan eqtrd cA cc wcel cB cc wcel wa cA cB caddc co cc wcel cA cB caddc co
    cabs cfv c2 cexp co cA cB caddc co cA cB caddc co ccj cfv cmul co wceq cA
    cB addcl cA cB caddc co absvalsq syl cA cc wcel cB cc wcel wa cA cabs cfv
    c2 cexp co cB cabs cfv c2 cexp co caddc co cA cA ccj cfv cmul co cB ccj cfv
    cB cmul co caddc co c2 cA cB ccj cfv cmul co cre cfv cmul co cA cB ccj cfv
    cmul co cA ccj cfv cB cmul co caddc co caddc cA cc wcel cB cc wcel cA cabs
    cfv c2 cexp co cA cA ccj cfv cmul co cB cabs cfv c2 cexp co cB ccj cfv cB
    cmul co caddc cA absvalsq cB cc wcel cB cabs cfv c2 cexp co cB cB ccj cfv
    cmul co cB ccj cfv cB cmul co cB absvalsq cB cc wcel cB ccj cfv cc wcel cB
    cB ccj cfv cmul co cB ccj cfv cB cmul co wceq cB cjcl cB cB ccj cfv mulcom
    mpdan eqtrd opreqan12d cA cc wcel cB cc wcel wa cA cB ccj cfv cmul co cA cB
    ccj cfv cmul co ccj cfv caddc co c2 cA cB ccj cfv cmul co cre cfv cmul co
    cA cB ccj cfv cmul co cA ccj cfv cB cmul co caddc co cA cc wcel cB cc wcel
    wa cA cB ccj cfv cmul co cc wcel cA cB ccj cfv cmul co cA cB ccj cfv cmul
    co ccj cfv caddc co c2 cA cB ccj cfv cmul co cre cfv cmul co wceq cA cc
    wcel cB ccj cfv cc wcel cA cB ccj cfv cmul co cc wcel cB cc wcel cA cB ccj
    cfv mulcl cB cjcl sylan2 cA cB ccj cfv cmul co addcj syl cA cc wcel cB cc
    wcel wa cA cB ccj cfv cmul co ccj cfv cA ccj cfv cB cmul co cA cB ccj cfv
    cmul co caddc cA cc wcel cB cc wcel wa cA cB ccj cfv cmul co ccj cfv cA ccj
    cfv cB ccj cfv ccj cfv cmul co cA ccj cfv cB cmul co cA cc wcel cB ccj cfv
    cc wcel cA cB ccj cfv cmul co ccj cfv cA ccj cfv cB ccj cfv ccj cfv cmul co
    wceq cB cc wcel cA cB ccj cfv cjmul cB cjcl sylan2 cA cc wcel cB cc wcel wa
    cB ccj cfv ccj cfv cB cA ccj cfv cmul cB cc wcel cB ccj cfv ccj cfv cB wceq
    cA cc wcel cB cjcj adantl opreq2d eqtrd opreq2d eqtr3d opreq12d 3eqtr4d $.
    $( [26-Jan-2007] $) $( [21-Jan-2007] $)

  $( Square of absolute value of difference. $)
  sqabssub $p |- ( ( A e. CC /\ B e. CC ) -> ( ( abs ` ( A - B ) ) ^ 2 ) =
                  ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) )
                    - ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cmin co cA cB cmin co ccj cfv cmul co cA cA
    ccj cfv cmul co cB ccj cfv cB cmul co caddc co cA cB ccj cfv cmul co cA ccj
    cfv cB cmul co caddc co cmin co cA cB cmin co cabs cfv c2 cexp co cA cabs
    cfv c2 cexp co cB cabs cfv c2 cexp co caddc co c2 cA cB ccj cfv cmul co cre
    cfv cmul co cmin co cA cc wcel cB cc wcel wa cA cB cmin co cA cB cmin co
    ccj cfv cmul co cA cB cmin co cA ccj cfv cB ccj cfv cmin co cmul co cA cA
    ccj cfv cmul co cB ccj cfv cB cmul co caddc co cA cB ccj cfv cmul co cA ccj
    cfv cB cmul co caddc co cmin co cA cc wcel cB cc wcel wa cA cB cmin co ccj
    cfv cA ccj cfv cB ccj cfv cmin co cA cB cmin co cmul cA cB cjsub opreq2d cA
    cc wcel cB cc wcel wa cA ccj cfv cc wcel cB ccj cfv cc wcel wa cA cB cmin
    co cA ccj cfv cB ccj cfv cmin co cmul co cA cA ccj cfv cmul co cB ccj cfv
    cB cmul co caddc co cA cB ccj cfv cmul co cA ccj cfv cB cmul co caddc co
    cmin co wceq cA cc wcel cA ccj cfv cc wcel cB cc wcel cB ccj cfv cc wcel cA
    cjcl cB cjcl anim12i cA cB cA ccj cfv cB ccj cfv mulsub mpdan eqtrd cA cc
    wcel cB cc wcel wa cA cB cmin co cc wcel cA cB cmin co cabs cfv c2 cexp co
    cA cB cmin co cA cB cmin co ccj cfv cmul co wceq cA cB subcl cA cB cmin co
    absvalsq syl cA cc wcel cB cc wcel wa cA cabs cfv c2 cexp co cB cabs cfv c2
    cexp co caddc co cA cA ccj cfv cmul co cB ccj cfv cB cmul co caddc co c2 cA
    cB ccj cfv cmul co cre cfv cmul co cA cB ccj cfv cmul co cA ccj cfv cB cmul
    co caddc co cmin cA cc wcel cB cc wcel cA cabs cfv c2 cexp co cA cA ccj cfv
    cmul co cB cabs cfv c2 cexp co cB ccj cfv cB cmul co caddc cA absvalsq cB
    cc wcel cB cabs cfv c2 cexp co cB cB ccj cfv cmul co cB ccj cfv cB cmul co
    cB absvalsq cB cc wcel cB ccj cfv cc wcel cB cB ccj cfv cmul co cB ccj cfv
    cB cmul co wceq cB cjcl cB cB ccj cfv mulcom mpdan eqtrd opreqan12d cA cc
    wcel cB cc wcel wa cA cB ccj cfv cmul co cA cB ccj cfv cmul co ccj cfv
    caddc co c2 cA cB ccj cfv cmul co cre cfv cmul co cA cB ccj cfv cmul co cA
    ccj cfv cB cmul co caddc co cA cc wcel cB cc wcel wa cA cB ccj cfv cmul co
    cc wcel cA cB ccj cfv cmul co cA cB ccj cfv cmul co ccj cfv caddc co c2 cA
    cB ccj cfv cmul co cre cfv cmul co wceq cA cc wcel cB ccj cfv cc wcel cA cB
    ccj cfv cmul co cc wcel cB cc wcel cA cB ccj cfv mulcl cB cjcl sylan2 cA cB
    ccj cfv cmul co addcj syl cA cc wcel cB cc wcel wa cA cB ccj cfv cmul co
    ccj cfv cA ccj cfv cB cmul co cA cB ccj cfv cmul co caddc cA cc wcel cB cc
    wcel wa cA cB ccj cfv cmul co ccj cfv cA ccj cfv cB ccj cfv ccj cfv cmul co
    cA ccj cfv cB cmul co cA cc wcel cB ccj cfv cc wcel cA cB ccj cfv cmul co
    ccj cfv cA ccj cfv cB ccj cfv ccj cfv cmul co wceq cB cc wcel cA cB ccj cfv
    cjmul cB cjcl sylan2 cA cc wcel cB cc wcel wa cB ccj cfv ccj cfv cB cA ccj
    cfv cmul cB cc wcel cB ccj cfv ccj cfv cB wceq cA cc wcel cB cjcj adantl
    opreq2d eqtrd opreq2d eqtr3d opreq12d 3eqtr4d $.
    $( [28-Jan-2007] $) $( [21-Jan-2007] $)

  ${
    sqabsaddi.1 $e |- A e. CC $.
    sqabsaddi.2 $e |- B e. CC $.
    $( Square of absolute value of sum.  Proposition 10-3.7(g) of [Gleason]
       p. 133. $)
    sqabsaddi $p |- ( ( abs ` ( A + B ) ) ^ 2 ) =
                 ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) ) +
                 ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) $=
      cA cc wcel cB cc wcel cA cB caddc co cabs cfv c2 cexp co cA cabs cfv c2
      cexp co cB cabs cfv c2 cexp co caddc co c2 cA cB ccj cfv cmul co cre cfv
      cmul co caddc co wceq sqabsaddi.1 sqabsaddi.2 cA cB sqabsadd mp2an $.
      $( [2-Oct-1999] $)

    $( Square of absolute value of difference.  (Contributed by Steve
       Rodriguez, 20-Jan-2007.) $)
    sqabssubi $p |- ( ( abs ` ( A - B ) ) ^ 2 ) =
                    ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) )
                      - ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) $=
      cA cc wcel cB cc wcel cA cB cmin co cabs cfv c2 cexp co cA cabs cfv c2
      cexp co cB cabs cfv c2 cexp co caddc co c2 cA cB ccj cfv cmul co cre cfv
      cmul co cmin co wceq sqabsaddi.1 sqabsaddi.2 cA cB sqabssub mp2an $.
      $( [20-Jan-2007] $) $( [19-Jan-2007] $)
  $}

  $( Value of absolute value function.  Definition 10.36 of [Gleason]
     p. 133. $)
  absval2 $p |- ( A e. CC -> ( abs ` A ) =
               ( sqr ` ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) ) $=
    cA cc wcel cA cabs cfv cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co
    csqr cfv wceq cA cc wcel cA cc0 cif cabs cfv cA cc wcel cA cc0 cif cre cfv
    c2 cexp co cA cc wcel cA cc0 cif cim cfv c2 cexp co caddc co csqr cfv wceq
    cA cc0 cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA cc0 cif cabs
    cfv cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co csqr cfv cA cc
    wcel cA cc0 cif cre cfv c2 cexp co cA cc wcel cA cc0 cif cim cfv c2 cexp co
    caddc co csqr cfv cA cA cc wcel cA cc0 cif cabs fveq2 cA cA cc wcel cA cc0
    cif wceq cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cA cc wcel cA
    cc0 cif cre cfv c2 cexp co cA cc wcel cA cc0 cif cim cfv c2 cexp co caddc
    co csqr cA cA cc wcel cA cc0 cif wceq cA cre cfv c2 cexp co cA cc wcel cA
    cc0 cif cre cfv c2 cexp co cA cim cfv c2 cexp co cA cc wcel cA cc0 cif cim
    cfv c2 cexp co caddc cA cA cc wcel cA cc0 cif wceq cA cre cfv cA cc wcel cA
    cc0 cif cre cfv c2 cexp cA cA cc wcel cA cc0 cif cre fveq2 opreq1d cA cA cc
    wcel cA cc0 cif wceq cA cim cfv cA cc wcel cA cc0 cif cim cfv c2 cexp cA cA
    cc wcel cA cc0 cif cim fveq2 opreq1d opreq12d fveq2d eqeq12d cA cc wcel cA
    cc0 cif cA cc0 cc 0cn elimel absval2i dedth $.
    $( [3-Apr-2005] $) $( [17-Mar-2005] $)

  $( The absolute value of a number is zero iff the number is zero.
     Proposition 10-3.7(c) of [Gleason] p. 133. $)
  abs00 $p |- ( A e. CC -> ( ( abs ` A ) = 0 <-> A = 0 ) ) $=
    cA cc wcel cA cabs cfv cc0 wceq cA cc0 wceq wb cA cc wcel cA cc0 cif cabs
    cfv cc0 wceq cA cc wcel cA cc0 cif cc0 wceq wb cA cc0 cA cA cc wcel cA cc0
    cif wceq cA cabs cfv cc0 wceq cA cc wcel cA cc0 cif cabs cfv cc0 wceq cA
    cc0 wceq cA cc wcel cA cc0 cif cc0 wceq cA cA cc wcel cA cc0 cif wceq cA
    cabs cfv cA cc wcel cA cc0 cif cabs cfv cc0 cA cA cc wcel cA cc0 cif cabs
    fveq2 eqeq1d cA cA cc wcel cA cc0 cif cc0 eqeq1 bibi12d cA cc wcel cA cc0
    cif cA cc0 cc 0cn elimel abs00i dedth $.
    $( [26-Nov-2005] $) $( [26-Sep-2005] $)

  $( Absolute value is nonnegative. $)
  absge0 $p |- ( A e. CC -> 0 <_ ( abs ` A ) ) $=
    cA cc wcel cc0 cA cabs cfv cle wbr cc0 cA cc wcel cA cc0 cif cabs cfv cle
    wbr cA cc0 cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA cc0 cif
    cabs cfv cc0 cle cA cA cc wcel cA cc0 cif cabs fveq2 breq2d cA cc wcel cA
    cc0 cif cA cc0 cc 0cn elimel absge0i dedth $.
    $( [13-Mar-2005] $) $( [20-Nov-2004] $)

  $( The absolute value of a nonzero number is a positive real.  (Contributed
     by FL, 27-Dec-2007.) $)
  absrpcl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( abs ` A ) e. RR+ ) $=
    cA cabs cfv crp wcel cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cc wcel
    cA cc0 wne wa cA cabs cfv elrp cA cc wcel cA cabs cfv cr wcel cA cc0 wne cA
    abscl adantr cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr cc0 cA cabs cfv
    cle wbr cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr wi cA absge0 cc0 cr
    wcel cc0 cA cabs cfv cle wbr cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr
    wi wi wi 0re cc0 cr wcel cA cc wcel cc0 cA cabs cfv cle wbr cA cc0 wne cc0
    cA cabs cfv clt wbr wi cc0 cr wcel cA cc wcel cc0 cA cabs cfv cle wbr cA
    cc0 wne cc0 cA cabs cfv clt wbr wi cc0 cr wcel cA cc wcel cc0 cA cabs cfv
    cle wbr w3a cc0 cA cabs cfv clt wbr cA cc0 wne cc0 cr wcel cA cc wcel cc0
    cA cabs cfv cle wbr w3a cc0 cA cabs cfv clt wbr cA cabs cfv cc0 wne cA cc0
    wne cc0 cr wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr cc0 cA cabs cfv
    clt wbr cA cabs cfv cc0 wne wb cA cc wcel cc0 cA cabs cfv leltne cA abscl
    syl3an2 cc0 cr wcel cA cc wcel cc0 cA cabs cfv cle wbr w3a cA cabs cfv cc0
    cA cc0 cA cc wcel cc0 cr wcel cA cabs cfv cc0 wceq cA cc0 wceq wb cc0 cA
    cabs cfv cle wbr cA abs00 3ad2ant2 necon3bid bitrd biimprd 3exp com23 ax-mp
    mpcom imp sylanbrc $.
    $( [22-Jan-2008] $) $( [27-Dec-2007] $)

  $( Square of the absolute value of a number that has been decomposed into
     real and imaginary parts. $)
  absreimsq $p |- ( ( A e. RR /\ B e. RR ) ->
         ( ( abs ` ( A + ( _i x. B ) ) ) ^ 2 ) = ( ( A ^ 2 ) + ( B ^ 2 ) ) ) $=
    cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cabs cfv c2 cexp co cA
    ci cB cmul co caddc co cre cfv c2 cexp co cA ci cB cmul co caddc co cim cfv
    c2 cexp co caddc co cA c2 cexp co cB c2 cexp co caddc co cA cr wcel cB cr
    wcel wa cA ci cB cmul co caddc co cc wcel cA ci cB cmul co caddc co cabs
    cfv c2 cexp co cA ci cB cmul co caddc co cre cfv c2 cexp co cA ci cB cmul
    co caddc co cim cfv c2 cexp co caddc co wceq cA cc wcel ci cB cmul co cc
    wcel cA ci cB cmul co caddc co cc wcel cA cr wcel cB cr wcel cA ci cB cmul
    co addcl cA recn ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr wcel ci
    cB mulcl axicn cB recn sylancr syl2an cA ci cB cmul co caddc co absvalsq2
    syl cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cre cfv c2 cexp co
    cA c2 cexp co cA ci cB cmul co caddc co cim cfv c2 cexp co cB c2 cexp co
    caddc cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cre cfv cA c2 cexp
    cA cB crre opreq1d cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cim
    cfv cB c2 cexp cA cB crim opreq1d opreq12d eqtrd $.
    $( [15-Mar-2008] $) $( [1-Feb-2007] $)

  $( Absolute value of a number that has been decomposed into real and
     imaginary parts. $)
  absreim $p |- ( ( A e. RR /\ B e. RR ) -> ( abs ` ( A + ( _i x. B ) ) ) =
               ( sqr ` ( ( A ^ 2 ) + ( B ^ 2 ) ) ) ) $=
    cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cabs cfv c2 cexp co csqr
    cfv cA ci cB cmul co caddc co cabs cfv cA c2 cexp co cB c2 cexp co caddc co
    csqr cfv cA ci cB cmul co caddc co cabs cfv cr wcel cc0 cA ci cB cmul co
    caddc co cabs cfv cle wbr cA ci cB cmul co caddc co cabs cfv c2 cexp co
    csqr cfv cA ci cB cmul co caddc co cabs cfv wceq cA cr wcel cB cr wcel wa
    cA ci cB cmul co caddc co cabs cfv sqrsq cA cr wcel cB cr wcel wa cA ci cB
    cmul co caddc co cc wcel cA ci cB cmul co caddc co cabs cfv cr wcel cA cc
    wcel ci cB cmul co cc wcel cA ci cB cmul co caddc co cc wcel cA cr wcel cB
    cr wcel cA ci cB cmul co addcl cA recn ci cc wcel cB cc wcel ci cB cmul co
    cc wcel cB cr wcel ci cB mulcl axicn cB recn sylancr syl2an cA ci cB cmul
    co caddc co abscl syl cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cc
    wcel cc0 cA ci cB cmul co caddc co cabs cfv cle wbr cA cc wcel ci cB cmul
    co cc wcel cA ci cB cmul co caddc co cc wcel cA cr wcel cB cr wcel cA ci cB
    cmul co addcl cA recn ci cc wcel cB cc wcel ci cB cmul co cc wcel cB cr
    wcel ci cB mulcl axicn cB recn sylancr syl2an cA ci cB cmul co caddc co
    absge0 syl sylanc cA cr wcel cB cr wcel wa cA ci cB cmul co caddc co cabs
    cfv c2 cexp co cA c2 cexp co cB c2 cexp co caddc co csqr cA cB absreimsq
    fveq2d eqtr3d $.
    $( [10-Mar-2006] $) $( [14-Jan-2006] $)

  $( Absolute value distributes over multiplication.  Proposition 10-3.7(f)
     of [Gleason] p. 133. $)
  absmul $p |- ( ( A e. CC /\ B e. CC ) ->
                ( abs ` ( A x. B ) ) = ( ( abs ` A ) x. ( abs ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB cmul co cabs cfv cA cabs cfv cB cabs cfv cmul
    co wceq cA cc wcel cA cc0 cif cB cmul co cabs cfv cA cc wcel cA cc0 cif
    cabs cfv cB cabs cfv cmul co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif cmul co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0 cif
    cabs cfv cmul co wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB
    cmul co cabs cfv cA cc wcel cA cc0 cif cB cmul co cabs cfv cA cabs cfv cB
    cabs cfv cmul co cA cc wcel cA cc0 cif cabs cfv cB cabs cfv cmul co cA cA
    cc wcel cA cc0 cif wceq cA cB cmul co cA cc wcel cA cc0 cif cB cmul co cabs
    cA cA cc wcel cA cc0 cif cB cmul opreq1 fveq2d cA cA cc wcel cA cc0 cif
    wceq cA cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cabs cfv cmul cA cA cc
    wcel cA cc0 cif cabs fveq2 opreq1d eqeq12d cB cB cc wcel cB cc0 cif wceq cA
    cc wcel cA cc0 cif cB cmul co cabs cfv cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cmul co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cabs cfv cmul co
    cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0 cif cabs cfv cmul co cB cB
    cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmul co cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmul co cabs cB cB cc wcel cB cc0 cif cA cc wcel
    cA cc0 cif cmul opreq2 fveq2d cB cB cc wcel cB cc0 cif wceq cB cabs cfv cB
    cc wcel cB cc0 cif cabs cfv cA cc wcel cA cc0 cif cabs cfv cmul cB cB cc
    wcel cB cc0 cif cabs fveq2 opreq2d eqeq12d cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel absmuli dedth2h $.
    $( [11-Oct-1999] $)

  ${
    absdivzi.1 $e |- A e. CC $.
    absdivzi.2 $e |- B e. CC $.
    $( Absolute value distributes over division. $)
    absdivzi $p |- ( B =/= 0 ->
                  ( abs ` ( A / B ) ) = ( ( abs ` A ) / ( abs ` B ) ) ) $=
      cB cc0 wne cA cabs cfv cB cabs cfv cdiv co cA cB cdiv co cabs cfv cB cc0
      wne cA cabs cfv cB cabs cfv cdiv co cA cB cdiv co cabs cfv wceq cB cabs
      cfv cA cB cdiv co cabs cfv cmul co cA cabs cfv wceq cB cc0 wne cB cA cB
      cdiv co cmul co cabs cfv cB cabs cfv cA cB cdiv co cabs cfv cmul co cA
      cabs cfv cB cc wcel cA cB cdiv co cc wcel cB cA cB cdiv co cmul co cabs
      cfv cB cabs cfv cA cB cdiv co cabs cfv cmul co wceq cB cc0 wne cB cA cB
      cdiv co absmul absdivzi.2 cA cB absdivzi.1 absdivzi.2 divclzi sylancr cB
      cc0 wne cB cA cB cdiv co cmul co cA cabs cA cB absdivzi.1 absdivzi.2
      divcan2zi fveq2d eqtr3d cA cB cdiv co cabs cfv cc wcel cB cabs cfv cc0
      wne cA cabs cfv cB cabs cfv cdiv co cA cB cdiv co cabs cfv wceq cB cabs
      cfv cA cB cdiv co cabs cfv cmul co cA cabs cfv wceq wb cB cc0 wne cA cB
      cdiv co cabs cfv cc wcel cB cabs cfv cc wcel cB cabs cfv cc0 wne cA cabs
      cfv cB cabs cfv cdiv co cA cB cdiv co cabs cfv wceq cB cabs cfv cA cB
      cdiv co cabs cfv cmul co cA cabs cfv wceq wb cB cabs cfv cB absdivzi.2
      abscli recni cA cabs cfv cc wcel cA cB cdiv co cabs cfv cc wcel cB cabs
      cfv cc wcel cB cabs cfv cc0 wne wa cA cabs cfv cB cabs cfv cdiv co cA cB
      cdiv co cabs cfv wceq cB cabs cfv cA cB cdiv co cabs cfv cmul co cA cabs
      cfv wceq wb cA cabs cfv cA absdivzi.1 abscli recni cA cabs cfv cA cB cdiv
      co cabs cfv cB cabs cfv divmul mp3an1 mpanr1 cB cc0 wne cA cB cdiv co cc
      wcel cA cB cdiv co cabs cfv cc wcel cA cB absdivzi.1 absdivzi.2 divclzi
      cA cB cdiv co cc wcel cA cB cdiv co cabs cfv cr wcel cA cB cdiv co cabs
      cfv cc wcel cA cB cdiv co abscl cA cB cdiv co cabs cfv recn syl syl cB
      cabs cfv cc0 wne cB cc0 wne cB cabs cfv cc0 cB cc0 cB absdivzi.2 abs00i
      necon3bii biimpri sylanc mpbird eqcomd $.
      $( [1-May-2005] $) $( [26-Mar-2005] $)
  $}


  $( Absolute value distributes over division. $)
  absdiv $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                ( abs ` ( A / B ) ) = ( ( abs ` A ) / ( abs ` B ) ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cabs cfv cA cabs cfv cB cabs
    cfv cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co cabs cfv cA
    cabs cfv cB cabs cfv cdiv co wceq wi cB cc0 wne cA cc wcel cA cc0 cif cB
    cdiv co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cabs cfv cdiv co wceq wi
    cB cc wcel cB cc0 cif cc0 wne cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cdiv co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0 cif cabs
    cfv cdiv co wceq wi cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB cdiv
    co cabs cfv cA cabs cfv cB cabs cfv cdiv co wceq cA cc wcel cA cc0 cif cB
    cdiv co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cabs cfv cdiv co wceq cB
    cc0 wne cA cA cc wcel cA cc0 cif wceq cA cB cdiv co cabs cfv cA cc wcel cA
    cc0 cif cB cdiv co cabs cfv cA cabs cfv cB cabs cfv cdiv co cA cc wcel cA
    cc0 cif cabs cfv cB cabs cfv cdiv co cA cA cc wcel cA cc0 cif wceq cA cB
    cdiv co cA cc wcel cA cc0 cif cB cdiv co cabs cA cA cc wcel cA cc0 cif cB
    cdiv opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA
    cc0 cif cabs cfv cB cabs cfv cdiv cA cA cc wcel cA cc0 cif cabs fveq2
    opreq1d eqeq12d imbi2d cB cB cc wcel cB cc0 cif wceq cB cc0 wne cB cc wcel
    cB cc0 cif cc0 wne cA cc wcel cA cc0 cif cB cdiv co cabs cfv cA cc wcel cA
    cc0 cif cabs cfv cB cabs cfv cdiv co wceq cA cc wcel cA cc0 cif cB cc wcel
    cB cc0 cif cdiv co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB
    cc0 cif cabs cfv cdiv co wceq cB cB cc wcel cB cc0 cif cc0 neeq1 cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cdiv co cabs cfv cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif cdiv co cabs cfv cA cc wcel cA cc0 cif
    cabs cfv cB cabs cfv cdiv co cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB
    cc0 cif cabs cfv cdiv co cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0
    cif cB cdiv co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co cabs cB
    cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cdiv opreq2 fveq2d cB cB cc
    wcel cB cc0 cif wceq cB cabs cfv cB cc wcel cB cc0 cif cabs cfv cA cc wcel
    cA cc0 cif cabs cfv cdiv cB cB cc wcel cB cc0 cif cabs fveq2 opreq2d
    eqeq12d imbi12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn
    elimel cB cc0 cc 0cn elimel absdivzi dedth2h 3impia $.
    $( [4-May-2005] $) $( [27-Apr-2005] $)

  ${
    absidi.1 $e |- A e. RR $.
    $( A nonnegative number is its own absolute value. $)
    absidi $p |- ( 0 <_ A -> ( abs ` A ) = A ) $=
      cc0 cA cle wbr cA cA cmul co csqr cfv cA cA cabs cfv cA absidi.1 sqrmsqi
      cA cabs cfv cA cA ccj cfv cmul co csqr cfv cA cA cmul co csqr cfv cA cc
      wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv wceq cA absidi.1 recni cA
      absval ax-mp cA cA ccj cfv cmul co cA cA cmul co csqr cA ccj cfv cA cA
      cmul cA cr wcel cA ccj cfv cA wceq absidi.1 cA cA absidi.1 recni cjrebi
      mpbi opreq2i fveq2i eqtri syl5eq $.
      $( [2-Aug-1999] $)
  $}

  $( A nonnegative number is its own absolute value. $)
  absid $p |- ( ( A e. RR /\ 0 <_ A ) -> ( abs ` A ) = A ) $=
    cA cr wcel cc0 cA cle wbr cA cabs cfv cA wceq cA cr wcel cc0 cA cle wbr cA
    cabs cfv cA wceq wi cc0 cA cr wcel cA cc0 cif cle wbr cA cr wcel cA cc0 cif
    cabs cfv cA cr wcel cA cc0 cif wceq wi cA cc0 cA cA cr wcel cA cc0 cif wceq
    cc0 cA cle wbr cc0 cA cr wcel cA cc0 cif cle wbr cA cabs cfv cA wceq cA cr
    wcel cA cc0 cif cabs cfv cA cr wcel cA cc0 cif wceq cA cA cr wcel cA cc0
    cif cc0 cle breq2 cA cA cr wcel cA cc0 cif wceq cA cabs cfv cA cr wcel cA
    cc0 cif cabs cfv cA cA cr wcel cA cc0 cif cA cA cr wcel cA cc0 cif cabs
    fveq2 cA cA cr wcel cA cc0 cif wceq id eqeq12d imbi12d cA cr wcel cA cc0
    cif cA cc0 cr 0re elimel absidi dedth imp $.
    $( [28-Feb-2005] $) $( [11-Oct-1999] $)

  $( A negative number is the negative of its own absolute value. $)
  absnid $p |- ( ( A e. RR /\ A <_ 0 ) -> ( abs ` A ) = -u A ) $=
    cA cr wcel cA cc0 cle wbr cA cabs cfv cA cneg wceq cA cr wcel cA cc0 cle
    wbr cc0 cA cneg cle wbr cA cabs cfv cA cneg wceq cA le0neg1 cA cr wcel cc0
    cA cneg cle wbr cA cabs cfv cA cneg wceq cA cr wcel cc0 cA cneg cle wbr wa
    cA cneg cabs cfv cA cabs cfv cA cneg cA cr wcel cA cneg cabs cfv cA cabs
    cfv wceq cc0 cA cneg cle wbr cA cr wcel cA cc wcel cA cneg cabs cfv cA cabs
    cfv wceq cA recn cA absneg syl adantr cA cneg cr wcel cc0 cA cneg cle wbr
    cA cneg cabs cfv cA cneg wceq cA cr wcel cA cneg absid cA renegcl sylan
    eqtr3d ex sylbid imp $.
    $( [28-Feb-2005] $) $( [27-Feb-2005] $)

  $( A real number is less than or equal to its absolute value. $)
  leabs $p |- ( A e. RR -> A <_ ( abs ` A ) ) $=
    cA cr wcel cA cA cabs cfv cle wbr cc0 cA cc0 cr wcel cA cr wcel 0re a1i cA
    cr wcel id cA cr wcel cc0 cA cle wbr cA cabs cfv cA wceq cA cA cabs cfv cle
    wbr cA absid cA cr wcel cA cA cabs cfv wceq cA cA cabs cfv cle wbr cA cabs
    cfv cA wceq cA cA cabs cfv eqle cA cabs cfv cA eqcom sylan2b syldan cA cr
    wcel cA cc0 cle wbr cA cA cabs cfv cle wbr cA cr wcel cA cc0 cle wbr cc0 cA
    cabs cfv cle wbr cA cA cabs cfv cle wbr cA cr wcel cA cc wcel cc0 cA cabs
    cfv cle wbr cA recn cA absge0 syl cA cr wcel cA cabs cfv cr wcel cA cc0 cle
    wbr cc0 cA cabs cfv cle wbr wa cA cA cabs cfv cle wbr wi cA cr wcel cA cc
    wcel cA cabs cfv cr wcel cA recn cA abscl syl cA cr wcel cc0 cr wcel cA
    cabs cfv cr wcel cA cc0 cle wbr cc0 cA cabs cfv cle wbr wa cA cA cabs cfv
    cle wbr wi 0re cA cc0 cA cabs cfv letr mp3an2 mpdan mpan2d imp lecasei $.
    $( [3-Apr-2005] $) $( [27-Feb-2005] $)

  $( The absolute value of a real number is either that number or
     its negative. $)
  absor $p |- ( A e. RR -> ( ( abs ` A ) = A \/ ( abs ` A ) = -u A ) ) $=
    cA cr wcel cc0 cA cle wbr cA cc0 cle wbr wo cA cabs cfv cA wceq cA cabs cfv
    cA cneg wceq wo cc0 cr wcel cA cr wcel cc0 cA cle wbr cA cc0 cle wbr wo 0re
    cc0 cA letric mpan cA cr wcel cc0 cA cle wbr cA cabs cfv cA wceq cA cc0 cle
    wbr cA cabs cfv cA cneg wceq cA cr wcel cc0 cA cle wbr cA cabs cfv cA wceq
    cA absid ex cA cr wcel cA cc0 cle wbr cA cabs cfv cA cneg wceq cA absnid ex
    orim12d mpd $.
    $( [28-Feb-2005] $) $( [27-Feb-2005] $)

  $( Absolute value of a real number. $)
  absre $p |- ( A e. RR -> ( abs ` A ) = ( sqr ` ( A ^ 2 ) ) ) $=
    cA cr wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv cA c2 cexp co csqr
    cfv cA cr wcel cA cc wcel cA cabs cfv cA cA ccj cfv cmul co csqr cfv wceq
    cA recn cA absval syl cA cr wcel cA c2 cexp co cA cA ccj cfv cmul co csqr
    cA cr wcel cA c2 cexp co cA cA cmul co cA cA ccj cfv cmul co cA cr wcel cA
    cc wcel cA c2 cexp co cA cA cmul co wceq cA recn cA sqval syl cA cr wcel cA
    ccj cfv cA cA cmul cA cjre opreq2d eqtr4d fveq2d eqtr4d $.
    $( [19-Mar-2005] $) $( [17-Mar-2005] $)

  $( Square of the absolute value of a real number. $)
  absresq $p |- ( A e. RR -> ( ( abs ` A ) ^ 2 ) = ( A ^ 2 ) ) $=
    cA cr wcel cA cA ccj cfv cmul co cA cA cmul co cA cabs cfv c2 cexp co cA c2
    cexp co cA cr wcel cA ccj cfv cA cA cmul cA cjre opreq2d cA cr wcel cA cc
    wcel cA cabs cfv c2 cexp co cA cA ccj cfv cmul co wceq cA recn cA absvalsq
    syl cA cr wcel cA cc wcel cA c2 cexp co cA cA cmul co wceq cA recn cA sqval
    syl 3eqtr4d $.
    $( [22-Feb-2006] $) $( [16-Jan-2006] $)

  ${
    $d j k A $.  $d j k N $.
    $( Absolute value of natural number exponentiation. $)
    absexp $p |- ( ( A e. CC /\ N e. NN0 ) ->
                  ( abs ` ( A ^ N ) ) = ( ( abs ` A ) ^ N ) ) $=
      cN cn0 wcel cA cc wcel cA cN cexp co cabs cfv cA cabs cfv cN cexp co wceq
      cA cc wcel cA vj cv cexp co cabs cfv cA cabs cfv vj cv cexp co wceq wi cA
      cc wcel cA cc0 cexp co cabs cfv cA cabs cfv cc0 cexp co wceq wi cA cc
      wcel cA vk cv cexp co cabs cfv cA cabs cfv vk cv cexp co wceq wi cA cc
      wcel cA vk cv c1 caddc co cexp co cabs cfv cA cabs cfv vk cv c1 caddc co
      cexp co wceq wi cA cc wcel cA cN cexp co cabs cfv cA cabs cfv cN cexp co
      wceq wi vj vk cN vj cv cc0 wceq cA vj cv cexp co cabs cfv cA cabs cfv vj
      cv cexp co wceq cA cc0 cexp co cabs cfv cA cabs cfv cc0 cexp co wceq cA
      cc wcel vj cv cc0 wceq cA vj cv cexp co cabs cfv cA cc0 cexp co cabs cfv
      cA cabs cfv vj cv cexp co cA cabs cfv cc0 cexp co vj cv cc0 wceq cA vj cv
      cexp co cA cc0 cexp co cabs vj cv cc0 cA cexp opreq2 fveq2d vj cv cc0 cA
      cabs cfv cexp opreq2 eqeq12d imbi2d vj cv vk cv wceq cA vj cv cexp co
      cabs cfv cA cabs cfv vj cv cexp co wceq cA vk cv cexp co cabs cfv cA cabs
      cfv vk cv cexp co wceq cA cc wcel vj cv vk cv wceq cA vj cv cexp co cabs
      cfv cA vk cv cexp co cabs cfv cA cabs cfv vj cv cexp co cA cabs cfv vk cv
      cexp co vj cv vk cv wceq cA vj cv cexp co cA vk cv cexp co cabs vj cv vk
      cv cA cexp opreq2 fveq2d vj cv vk cv cA cabs cfv cexp opreq2 eqeq12d
      imbi2d vj cv vk cv c1 caddc co wceq cA vj cv cexp co cabs cfv cA cabs cfv
      vj cv cexp co wceq cA vk cv c1 caddc co cexp co cabs cfv cA cabs cfv vk
      cv c1 caddc co cexp co wceq cA cc wcel vj cv vk cv c1 caddc co wceq cA vj
      cv cexp co cabs cfv cA vk cv c1 caddc co cexp co cabs cfv cA cabs cfv vj
      cv cexp co cA cabs cfv vk cv c1 caddc co cexp co vj cv vk cv c1 caddc co
      wceq cA vj cv cexp co cA vk cv c1 caddc co cexp co cabs vj cv vk cv c1
      caddc co cA cexp opreq2 fveq2d vj cv vk cv c1 caddc co cA cabs cfv cexp
      opreq2 eqeq12d imbi2d vj cv cN wceq cA vj cv cexp co cabs cfv cA cabs cfv
      vj cv cexp co wceq cA cN cexp co cabs cfv cA cabs cfv cN cexp co wceq cA
      cc wcel vj cv cN wceq cA vj cv cexp co cabs cfv cA cN cexp co cabs cfv cA
      cabs cfv vj cv cexp co cA cabs cfv cN cexp co vj cv cN wceq cA vj cv cexp
      co cA cN cexp co cabs vj cv cN cA cexp opreq2 fveq2d vj cv cN cA cabs cfv
      cexp opreq2 eqeq12d imbi2d cA cc wcel c1 cabs cfv c1 cA cc0 cexp co cabs
      cfv cA cabs cfv cc0 cexp co cc0 c1 cle wbr c1 cabs cfv c1 wceq cc0 c1 0re
      1re lt01 ltleii c1 1re absidi ax-mp cA cc wcel cA cc0 cexp co c1 cabs cA
      exp0 fveq2d cA cc wcel cA cabs cfv cc wcel cA cabs cfv cc0 cexp co c1
      wceq cA cc wcel cA cabs cfv cA abscl recnd cA cabs cfv exp0 syl 3eqtr4a
      vk cv cn0 wcel cA cc wcel cA vk cv cexp co cabs cfv cA cabs cfv vk cv
      cexp co wceq cA vk cv c1 caddc co cexp co cabs cfv cA cabs cfv vk cv c1
      caddc co cexp co wceq cA cc wcel vk cv cn0 wcel cA vk cv cexp co cabs cfv
      cA cabs cfv vk cv cexp co wceq cA vk cv c1 caddc co cexp co cabs cfv cA
      cabs cfv vk cv c1 caddc co cexp co wceq wi cA cc wcel vk cv cn0 wcel cA
      vk cv cexp co cabs cfv cA cabs cfv vk cv cexp co wceq cA vk cv c1 caddc
      co cexp co cabs cfv cA cabs cfv vk cv c1 caddc co cexp co wceq cA cc wcel
      vk cv cn0 wcel wa cA vk cv cexp co cabs cfv cA cabs cfv vk cv cexp co
      wceq wa cA vk cv cexp co cabs cfv cA cabs cfv cmul co cA cabs cfv vk cv
      cexp co cA cabs cfv cmul co cA vk cv c1 caddc co cexp co cabs cfv cA cabs
      cfv vk cv c1 caddc co cexp co cA vk cv cexp co cabs cfv cA cabs cfv vk cv
      cexp co wceq cA vk cv cexp co cabs cfv cA cabs cfv cmul co cA cabs cfv vk
      cv cexp co cA cabs cfv cmul co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv
      cexp co cabs cfv cA cabs cfv vk cv cexp co cA cabs cfv cmul opreq1 adantl
      cA cc wcel vk cv cn0 wcel wa cA vk cv c1 caddc co cexp co cabs cfv cA vk
      cv cexp co cabs cfv cA cabs cfv cmul co wceq cA vk cv cexp co cabs cfv cA
      cabs cfv vk cv cexp co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv c1
      caddc co cexp co cabs cfv cA vk cv cexp co cA cmul co cabs cfv cA vk cv
      cexp co cabs cfv cA cabs cfv cmul co cA cc wcel vk cv cn0 wcel wa cA vk
      cv c1 caddc co cexp co cA vk cv cexp co cA cmul co cabs cA vk cv expp1
      fveq2d cA vk cv cexp co cc wcel cA cc wcel cA vk cv cexp co cA cmul co
      cabs cfv cA vk cv cexp co cabs cfv cA cabs cfv cmul co wceq cA cc wcel vk
      cv cn0 wcel wa cA vk cv cexp co cA absmul cA vk cv expcl cA cc wcel vk cv
      cn0 wcel pm3.26 sylanc eqtrd adantr cA cc wcel vk cv cn0 wcel wa cA cabs
      cfv vk cv c1 caddc co cexp co cA cabs cfv vk cv cexp co cA cabs cfv cmul
      co wceq cA vk cv cexp co cabs cfv cA cabs cfv vk cv cexp co wceq cA cabs
      cfv cc wcel vk cv cn0 wcel cA cabs cfv vk cv c1 caddc co cexp co cA cabs
      cfv vk cv cexp co cA cabs cfv cmul co wceq cA cc wcel cA cabs cfv vk cv
      expp1 cA cc wcel cA cabs cfv cA abscl recnd sylan adantr 3eqtr4d exp31
      com12 a2d nn0ind impcom $.
      $( [15-Feb-2006] $) $( [5-Jan-2006] $)
  $}

  $( The squares of two reals are equal iff their absolute values are equal. $)
  sqabs $p |- ( ( A e. RR /\ B e. RR ) -> ( ( A ^ 2 ) = ( B ^ 2 ) <->
               ( abs ` A ) = ( abs ` B ) ) ) $=
    cA cr wcel cB cr wcel wa cA c2 cexp co cB c2 cexp co wceq cA cabs cfv c2
    cexp co cB cabs cfv c2 cexp co wceq cA cabs cfv cB cabs cfv wceq cA cr wcel
    cB cr wcel cA c2 cexp co cA cabs cfv c2 cexp co cB c2 cexp co cB cabs cfv
    c2 cexp co cA cr wcel cA c2 cexp co cabs cfv cA c2 cexp co cA cabs cfv c2
    cexp co cA c2 cexp co cr wcel cc0 cA c2 cexp co cle wbr cA c2 cexp co cabs
    cfv cA c2 cexp co wceq cA cr wcel cA c2 cexp co absid cA resqcl cA sqge0
    sylanc cA cc wcel c2 cn0 wcel cA c2 cexp co cabs cfv cA cabs cfv c2 cexp co
    wceq cA cr wcel cA c2 absexp cA recn 2nn0 sylancl eqtr3d cB cr wcel cB c2
    cexp co cabs cfv cB c2 cexp co cB cabs cfv c2 cexp co cB c2 cexp co cr wcel
    cc0 cB c2 cexp co cle wbr cB c2 cexp co cabs cfv cB c2 cexp co wceq cB cr
    wcel cB c2 cexp co absid cB resqcl cB sqge0 sylanc cB cc wcel c2 cn0 wcel
    cB c2 cexp co cabs cfv cB cabs cfv c2 cexp co wceq cB cr wcel cB c2 absexp
    cB recn 2nn0 sylancl eqtr3d eqeqan12d cA cc wcel cB cc wcel cA cabs cfv c2
    cexp co cB cabs cfv c2 cexp co wceq cA cabs cfv cB cabs cfv wceq wb cA cr
    wcel cB cr wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr wa cB cabs cfv
    cr wcel cc0 cB cabs cfv cle wbr wa cA cabs cfv c2 cexp co cB cabs cfv c2
    cexp co wceq cA cabs cfv cB cabs cfv wceq wb cA cc wcel cB cc wcel cA cabs
    cfv cB cabs cfv sq11 cA cc wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr
    cA abscl cA absge0 jca cB cc wcel cB cabs cfv cr wcel cc0 cB cabs cfv cle
    wbr cB abscl cB absge0 jca syl2an cA recn cB recn syl2an bitrd $.
    $( [9-Mar-2009] $) $( [6-Mar-2009] $)

  $( The absolute value of a complex number is greater than or equal to the
     absolute value of its real part. $)
  absrele $p |- ( A e. CC -> ( abs ` ( Re ` A ) ) <_ ( abs ` A ) ) $=
    cA cc wcel cA cre cfv c2 cexp co csqr cfv cA cre cfv c2 cexp co cA cim cfv
    c2 cexp co caddc co csqr cfv cA cre cfv cabs cfv cA cabs cfv cle cA cc wcel
    cA cre cfv c2 cexp co cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co
    cle wbr cA cre cfv c2 cexp co csqr cfv cA cre cfv c2 cexp co cA cim cfv c2
    cexp co caddc co csqr cfv cle wbr cA cc wcel cc0 cA cim cfv c2 cexp co cle
    wbr cA cre cfv c2 cexp co cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc
    co cle wbr cA cc wcel cA cim cfv cr wcel cc0 cA cim cfv c2 cexp co cle wbr
    cA imcl cA cim cfv sqge0 syl cA cre cfv c2 cexp co cr wcel cA cim cfv c2
    cexp co cr wcel cc0 cA cim cfv c2 cexp co cle wbr cA cre cfv c2 cexp co cA
    cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cle wbr wb cA cc wcel cA
    cre cfv c2 cexp co cA cim cfv c2 cexp co addge01 cA cc wcel cA cre cfv cr
    wcel cA cre cfv c2 cexp co cr wcel cA recl cA cre cfv resqcl syl cA cc wcel
    cA cim cfv cr wcel cA cim cfv c2 cexp co cr wcel cA imcl cA cim cfv resqcl
    syl sylanc mpbid cA cre cfv c2 cexp co cr wcel cA cre cfv c2 cexp co cA cim
    cfv c2 cexp co caddc co cr wcel cc0 cA cre cfv c2 cexp co cle wbr cc0 cA
    cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cle wbr cA cre cfv c2
    cexp co cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cle wbr cA cre
    cfv c2 cexp co csqr cfv cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc
    co csqr cfv cle wbr wb cA cc wcel cA cre cfv c2 cexp co cA cre cfv c2 cexp
    co cA cim cfv c2 cexp co caddc co sqrle cA cc wcel cA cre cfv cr wcel cA
    cre cfv c2 cexp co cr wcel cA recl cA cre cfv resqcl syl cA cre cfv c2 cexp
    co cr wcel cA cim cfv c2 cexp co cr wcel cA cre cfv c2 cexp co cA cim cfv
    c2 cexp co caddc co cr wcel cA cc wcel cA cre cfv c2 cexp co cA cim cfv c2
    cexp co readdcl cA cc wcel cA cre cfv cr wcel cA cre cfv c2 cexp co cr wcel
    cA recl cA cre cfv resqcl syl cA cc wcel cA cim cfv cr wcel cA cim cfv c2
    cexp co cr wcel cA imcl cA cim cfv resqcl syl sylanc cA cc wcel cA cre cfv
    cr wcel cc0 cA cre cfv c2 cexp co cle wbr cA recl cA cre cfv sqge0 syl cA
    cre cfv c2 cexp co cr wcel cA cim cfv c2 cexp co cr wcel cc0 cA cre cfv c2
    cexp co cle wbr cc0 cA cim cfv c2 cexp co cle wbr cc0 cA cre cfv c2 cexp co
    cA cim cfv c2 cexp co caddc co cle wbr cA cc wcel cA cre cfv c2 cexp co cA
    cim cfv c2 cexp co addge0 cA cc wcel cA cre cfv cr wcel cA cre cfv c2 cexp
    co cr wcel cA recl cA cre cfv resqcl syl cA cc wcel cA cim cfv cr wcel cA
    cim cfv c2 cexp co cr wcel cA imcl cA cim cfv resqcl syl cA cc wcel cA cre
    cfv cr wcel cc0 cA cre cfv c2 cexp co cle wbr cA recl cA cre cfv sqge0 syl
    cA cc wcel cA cim cfv cr wcel cc0 cA cim cfv c2 cexp co cle wbr cA imcl cA
    cim cfv sqge0 syl syl2anc syl2anc mpbid cA cc wcel cA cre cfv cr wcel cA
    cre cfv cabs cfv cA cre cfv c2 cexp co csqr cfv wceq cA recl cA cre cfv
    absre syl cA absval2 3brtr4d $.
    $( [25-Jul-2006] $) $( [1-Apr-2005] $)

  $( The absolute value of a complex number is greater than or equal to the
     absolute value of its imaginary part. $)
  absimle $p |- ( A e. CC -> ( abs ` ( Im ` A ) ) <_ ( abs ` A ) ) $=
    cA cc wcel cA cim cfv c2 cexp co csqr cfv cA cre cfv c2 cexp co cA cim cfv
    c2 cexp co caddc co csqr cfv cA cim cfv cabs cfv cA cabs cfv cle cA cc wcel
    cA cim cfv c2 cexp co cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co
    cle wbr cA cim cfv c2 cexp co csqr cfv cA cre cfv c2 cexp co cA cim cfv c2
    cexp co caddc co csqr cfv cle wbr cA cim cfv c2 cexp co cr wcel cA cre cfv
    c2 cexp co cr wcel cc0 cA cre cfv c2 cexp co cle wbr cA cim cfv c2 cexp co
    cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co cle wbr cA cc wcel cA
    cim cfv c2 cexp co cr wcel cA cre cfv c2 cexp co cr wcel cc0 cA cre cfv c2
    cexp co cle wbr cA cim cfv c2 cexp co cA cre cfv c2 cexp co cA cim cfv c2
    cexp co caddc co cle wbr cA cim cfv c2 cexp co cA cre cfv c2 cexp co
    addge02 biimp3a cA cc wcel cA cim cfv cr wcel cA cim cfv c2 cexp co cr wcel
    cA imcl cA cim cfv resqcl syl cA cc wcel cA cre cfv cr wcel cA cre cfv c2
    cexp co cr wcel cA recl cA cre cfv resqcl syl cA cc wcel cA cre cfv cr wcel
    cc0 cA cre cfv c2 cexp co cle wbr cA recl cA cre cfv sqge0 syl syl3anc cA
    cim cfv c2 cexp co cr wcel cA cre cfv c2 cexp co cA cim cfv c2 cexp co
    caddc co cr wcel cc0 cA cim cfv c2 cexp co cle wbr cc0 cA cre cfv c2 cexp
    co cA cim cfv c2 cexp co caddc co cle wbr cA cim cfv c2 cexp co cA cre cfv
    c2 cexp co cA cim cfv c2 cexp co caddc co cle wbr cA cim cfv c2 cexp co
    csqr cfv cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co csqr cfv cle
    wbr wb cA cc wcel cA cim cfv c2 cexp co cA cre cfv c2 cexp co cA cim cfv c2
    cexp co caddc co sqrle cA cc wcel cA cim cfv cr wcel cA cim cfv c2 cexp co
    cr wcel cA imcl cA cim cfv resqcl syl cA cre cfv c2 cexp co cr wcel cA cim
    cfv c2 cexp co cr wcel cA cre cfv c2 cexp co cA cim cfv c2 cexp co caddc co
    cr wcel cA cc wcel cA cre cfv c2 cexp co cA cim cfv c2 cexp co readdcl cA
    cc wcel cA cre cfv cr wcel cA cre cfv c2 cexp co cr wcel cA recl cA cre cfv
    resqcl syl cA cc wcel cA cim cfv cr wcel cA cim cfv c2 cexp co cr wcel cA
    imcl cA cim cfv resqcl syl sylanc cA cc wcel cA cim cfv cr wcel cc0 cA cim
    cfv c2 cexp co cle wbr cA imcl cA cim cfv sqge0 syl cA cre cfv c2 cexp co
    cr wcel cA cim cfv c2 cexp co cr wcel cc0 cA cre cfv c2 cexp co cle wbr cc0
    cA cim cfv c2 cexp co cle wbr cc0 cA cre cfv c2 cexp co cA cim cfv c2 cexp
    co caddc co cle wbr cA cc wcel cA cre cfv c2 cexp co cA cim cfv c2 cexp co
    addge0 cA cc wcel cA cre cfv cr wcel cA cre cfv c2 cexp co cr wcel cA recl
    cA cre cfv resqcl syl cA cc wcel cA cim cfv cr wcel cA cim cfv c2 cexp co
    cr wcel cA imcl cA cim cfv resqcl syl cA cc wcel cA cre cfv cr wcel cc0 cA
    cre cfv c2 cexp co cle wbr cA recl cA cre cfv sqge0 syl cA cc wcel cA cim
    cfv cr wcel cc0 cA cim cfv c2 cexp co cle wbr cA imcl cA cim cfv sqge0 syl
    syl2anc syl2anc mpbid cA cc wcel cA cim cfv cr wcel cA cim cfv cabs cfv cA
    cim cfv c2 cexp co csqr cfv wceq cA imcl cA cim cfv absre syl cA absval2
    3brtr4d $.
    $( [25-Jul-2006] $) $( [17-Mar-2005] $)

  ${
    absnidi.1 $e |- A e. RR $.
    $( A negative number is the negative of its own absolute value. $)
    absnidi $p |- ( A <_ 0 -> ( abs ` A ) = -u A ) $=
      cA cr wcel cA cc0 cle wbr cA cabs cfv cA cneg wceq absnidi.1 cA absnid
      mpan $.
      $( [2-Aug-1999] $)

    $( A real number is less than or equal to its absolute value. $)
    leabsi $p |- A <_ ( abs ` A ) $=
      cc0 cA cle wbr cA cc0 cle wbr wo cA cA cabs cfv cle wbr cc0 cA 0re
      absnidi.1 letrii cc0 cA cle wbr cA cA cabs cfv cle wbr cA cc0 cle wbr cc0
      cA cle wbr cA cabs cfv cA wceq cA cA cabs cfv cle wbr cA absnidi.1 absidi
      cA cA cabs cfv cle wbr cA cA cabs cfv cA cA cabs cfv absnidi.1 cA cA
      absnidi.1 recni abscli eqlei eqcoms syl cA cc0 cle wbr cc0 cA cabs cfv
      cle wbr cA cA cabs cfv cle wbr cA cA absnidi.1 recni absge0i cA cc0 cA
      cabs cfv absnidi.1 0re cA cA absnidi.1 recni abscli letri mpan2 jaoi
      ax-mp $.
      $( [2-Aug-1999] $)

    $( The absolute value of a real number is either that number or
       its negative. $)
    absori $p |- ( ( abs ` A ) = A \/ ( abs ` A ) = -u A ) $=
      cA cr wcel cA cabs cfv cA wceq cA cabs cfv cA cneg wceq wo absnidi.1 cA
      absor ax-mp $.
      $( [30-Sep-1999] $)

    $( Absolute value of a real number. $)
    absrei $p |- ( abs ` A ) = ( sqr ` ( A ^ 2 ) ) $=
      cA cr wcel cA cabs cfv cA c2 cexp co csqr cfv wceq absnidi.1 cA absre
      ax-mp $.
      $( [3-Aug-1999] $)
  $}

  ${
    abslti.1 $e |- A e. RR $.
    abslti.2 $e |- B e. RR $.
    $( Absolute value and 'less than' relation. $)
    abslti $p |- ( ( abs ` A ) < B <-> ( -u B < A /\ A < B ) ) $=
      cA cabs cfv cB clt wbr cA cneg cB clt wbr cA cB clt wbr wa cB cneg cA clt
      wbr cA cB clt wbr wa cA cabs cfv cB clt wbr cA cneg cB clt wbr cA cB clt
      wbr wa cA cabs cfv cB clt wbr cA cneg cB clt wbr cA cB clt wbr cA cneg cA
      cabs cfv cle wbr cA cabs cfv cB clt wbr cA cneg cB clt wbr cA cneg cA
      cneg cabs cfv cA cabs cfv cle cA cneg cA abslti.1 renegcli leabsi cA cA
      abslti.1 recni absnegi breqtri cA cneg cA cabs cfv cB cA abslti.1
      renegcli cA cA abslti.1 recni abscli abslti.2 lelttri mpan cA cA cabs cfv
      cle wbr cA cabs cfv cB clt wbr cA cB clt wbr cA abslti.1 leabsi cA cA
      cabs cfv cB abslti.1 cA cA abslti.1 recni abscli abslti.2 lelttri mpan
      jca cA cB clt wbr cA cneg cB clt wbr cA cabs cfv cB clt wbr cA cB clt wbr
      cA cneg cB clt wbr wa cA cabs cfv cA wceq cA cabs cfv cA cneg wceq wo cA
      cabs cfv cB clt wbr cA abslti.1 absori cA cB clt wbr cA cabs cfv cA wceq
      cA cabs cfv cB clt wbr cA cneg cB clt wbr cA cabs cfv cA cneg wceq cA
      cabs cfv cA wceq cA cabs cfv cB clt wbr cA cB clt wbr cA cabs cfv cA cB
      clt breq1 biimprcd cA cabs cfv cA cneg wceq cA cabs cfv cB clt wbr cA
      cneg cB clt wbr cA cabs cfv cA cneg cB clt breq1 biimprcd jaao mpi ancoms
      impbii cA cneg cB clt wbr cB cneg cA clt wbr cA cB clt wbr cA cB abslti.1
      abslti.2 ltnegcon1i anbi1i bitri $.
      $( [5-May-2005] $) $( [6-Apr-2005] $)

    $( Absolute value and 'less than or equal to' relation. $)
    abslei $p |- ( ( abs ` A ) <_ B <-> ( -u B <_ A /\ A <_ B ) ) $=
      cA cabs cfv cB cle wbr cA cneg cB cle wbr cA cB cle wbr wa cB cneg cA cle
      wbr cA cB cle wbr wa cA cabs cfv cB cle wbr cA cneg cB cle wbr cA cB cle
      wbr wa cA cabs cfv cB cle wbr cA cneg cB cle wbr cA cB cle wbr cA cneg cA
      cabs cfv cle wbr cA cabs cfv cB cle wbr cA cneg cB cle wbr cA cneg cA
      cneg cabs cfv cA cabs cfv cle cA cneg cA abslti.1 renegcli leabsi cA cA
      abslti.1 recni absnegi breqtri cA cneg cA cabs cfv cB cA abslti.1
      renegcli cA cA abslti.1 recni abscli abslti.2 letri mpan cA cA cabs cfv
      cle wbr cA cabs cfv cB cle wbr cA cB cle wbr cA abslti.1 leabsi cA cA
      cabs cfv cB abslti.1 cA cA abslti.1 recni abscli abslti.2 letri mpan jca
      cA cB cle wbr cA cneg cB cle wbr cA cabs cfv cB cle wbr cA cB cle wbr cA
      cneg cB cle wbr wa cA cabs cfv cA wceq cA cabs cfv cA cneg wceq wo cA
      cabs cfv cB cle wbr cA abslti.1 absori cA cB cle wbr cA cabs cfv cA wceq
      cA cabs cfv cB cle wbr cA cneg cB cle wbr cA cabs cfv cA cneg wceq cA
      cabs cfv cA wceq cA cabs cfv cB cle wbr cA cB cle wbr cA cabs cfv cA cB
      cle breq1 biimprcd cA cabs cfv cA cneg wceq cA cabs cfv cB cle wbr cA
      cneg cB cle wbr cA cabs cfv cA cneg cB cle breq1 biimprcd jaao mpi ancoms
      impbii cA cneg cB cle wbr cB cneg cA cle wbr cA cB cle wbr cA cB abslti.1
      abslti.2 lenegcon1i anbi1i bitri $.
      $( [5-May-2005] $) $( [6-Apr-2005] $)
  $}

  $( The absolute value of 0. $)
  abs0 $p |- ( abs ` 0 ) = 0 $=
    cc0 cabs cfv cc0 wceq cc0 cc0 wceq cc0 eqid cc0 0cn abs00i mpbir $.
    $( [27-Mar-2005] $) $( [26-Mar-2005] $)

  $( The absolute value of the imaginary unit. $)
  absi $p |- ( abs ` _i ) = 1 $=
    ci cabs cfv ci ci ccj cfv cmul co csqr cfv c1 csqr cfv c1 ci cc wcel ci
    cabs cfv ci ci ccj cfv cmul co csqr cfv wceq axicn ci absval ax-mp ci ci
    ccj cfv cmul co c1 csqr ci ci cneg cmul co ci ci cmul co cneg ci ci ccj cfv
    cmul co c1 ci ci axicn axicn mulneg2i ci ccj cfv ci cneg ci cmul cji
    opreq2i ci ci cmul co c1 cneg wceq c1 ci ci cmul co cneg wceq ixi ci ci
    cmul co c1 ci ci axicn axicn mulcli ax1cn negcon2i mpbi 3eqtr4i fveq2i sqr1
    3eqtri $.
    $( [17-Jun-2005] $) $( [26-Mar-2005] $)

  $( The absolute value of an integer is a nonnegative integer. $)
  nn0abscl $p |- ( A e. ZZ -> ( abs ` A ) e. NN0 ) $=
    cA cabs cfv cn0 wcel cA cabs cfv cz wcel cc0 cA cabs cfv cle wbr cA cz wcel
    cA cabs cfv elnn0z cA cabs cfv cA wceq cA cabs cfv cA cneg wceq wo cA cz
    wcel cA cabs cfv cz wcel cA cz wcel cA cr wcel cA cabs cfv cA wceq cA cabs
    cfv cA cneg wceq wo cA zre cA absor syl cA cabs cfv cA wceq cA cz wcel cA
    cabs cfv cz wcel wi cA cabs cfv cA cneg wceq cA cabs cfv cA wceq cA cabs
    cfv cz wcel cA cz wcel cA cabs cfv cA cz eleq1 biimprd cA cabs cfv cA cneg
    wceq cA cabs cfv cz wcel cA cneg cz wcel cA cz wcel cA cabs cfv cA cneg cz
    eleq1 cA znegcl syl5bir jaoi mpcom cA cz wcel cA cc wcel cc0 cA cabs cfv
    cle wbr cA zcn cA absge0 syl sylanbrc $.
    $( [15-Mar-2005] $) $( [27-Feb-2005] $)

  $( Absolute value and 'less than' relation. $)
  abslt $p |- ( ( A e. RR /\ B e. RR ) ->
               ( ( abs ` A ) < B <-> ( -u B < A /\ A < B ) ) ) $=
    cA cr wcel cB cr wcel cA cabs cfv cB clt wbr cB cneg cA clt wbr cA cB clt
    wbr wa wb cA cr wcel cA cc0 cif cabs cfv cB clt wbr cB cneg cA cr wcel cA
    cc0 cif clt wbr cA cr wcel cA cc0 cif cB clt wbr wa wb cA cr wcel cA cc0
    cif cabs cfv cB cr wcel cB cc0 cif clt wbr cB cr wcel cB cc0 cif cneg cA cr
    wcel cA cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr
    wa wb cA cB cc0 cc0 cA cA cr wcel cA cc0 cif wceq cA cabs cfv cB clt wbr cA
    cr wcel cA cc0 cif cabs cfv cB clt wbr cB cneg cA clt wbr cA cB clt wbr wa
    cB cneg cA cr wcel cA cc0 cif clt wbr cA cr wcel cA cc0 cif cB clt wbr wa
    cA cA cr wcel cA cc0 cif wceq cA cabs cfv cA cr wcel cA cc0 cif cabs cfv cB
    clt cA cA cr wcel cA cc0 cif cabs fveq2 breq1d cA cA cr wcel cA cc0 cif
    wceq cB cneg cA clt wbr cB cneg cA cr wcel cA cc0 cif clt wbr cA cB clt wbr
    cA cr wcel cA cc0 cif cB clt wbr cA cA cr wcel cA cc0 cif cB cneg clt breq2
    cA cA cr wcel cA cc0 cif cB clt breq1 anbi12d bibi12d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif cabs cfv cB clt wbr cA cr wcel cA cc0 cif
    cabs cfv cB cr wcel cB cc0 cif clt wbr cB cneg cA cr wcel cA cc0 cif clt
    wbr cA cr wcel cA cc0 cif cB clt wbr wa cB cr wcel cB cc0 cif cneg cA cr
    wcel cA cc0 cif clt wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr
    wa cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cabs cfv clt breq2 cB cB
    cr wcel cB cc0 cif wceq cB cneg cA cr wcel cA cc0 cif clt wbr cB cr wcel cB
    cc0 cif cneg cA cr wcel cA cc0 cif clt wbr cA cr wcel cA cc0 cif cB clt wbr
    cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif clt wbr cB cB cr wcel cB cc0
    cif wceq cB cneg cB cr wcel cB cc0 cif cneg cA cr wcel cA cc0 cif clt cB cB
    cr wcel cB cc0 cif negeq breq1d cB cB cr wcel cB cc0 cif cA cr wcel cA cc0
    cif clt breq2 anbi12d bibi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cA cc0 cr 0re elimel cB cc0 cr 0re elimel abslti dedth2h $.
    $( [12-May-2005] $) $( [6-Apr-2005] $)

  $( Absolute value and 'less than or equal to' relation. $)
  absle $p |- ( ( A e. RR /\ B e. RR ) ->
               ( ( abs ` A ) <_ B <-> ( -u B <_ A /\ A <_ B ) ) ) $=
    cA cr wcel cB cr wcel cA cabs cfv cB cle wbr cB cneg cA cle wbr cA cB cle
    wbr wa wb cA cr wcel cA cc0 cif cabs cfv cB cle wbr cB cneg cA cr wcel cA
    cc0 cif cle wbr cA cr wcel cA cc0 cif cB cle wbr wa wb cA cr wcel cA cc0
    cif cabs cfv cB cr wcel cB cc0 cif cle wbr cB cr wcel cB cc0 cif cneg cA cr
    wcel cA cc0 cif cle wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr
    wa wb cA cB cc0 cc0 cA cA cr wcel cA cc0 cif wceq cA cabs cfv cB cle wbr cA
    cr wcel cA cc0 cif cabs cfv cB cle wbr cB cneg cA cle wbr cA cB cle wbr wa
    cB cneg cA cr wcel cA cc0 cif cle wbr cA cr wcel cA cc0 cif cB cle wbr wa
    cA cA cr wcel cA cc0 cif wceq cA cabs cfv cA cr wcel cA cc0 cif cabs cfv cB
    cle cA cA cr wcel cA cc0 cif cabs fveq2 breq1d cA cA cr wcel cA cc0 cif
    wceq cB cneg cA cle wbr cB cneg cA cr wcel cA cc0 cif cle wbr cA cB cle wbr
    cA cr wcel cA cc0 cif cB cle wbr cA cA cr wcel cA cc0 cif cB cneg cle breq2
    cA cA cr wcel cA cc0 cif cB cle breq1 anbi12d bibi12d cB cB cr wcel cB cc0
    cif wceq cA cr wcel cA cc0 cif cabs cfv cB cle wbr cA cr wcel cA cc0 cif
    cabs cfv cB cr wcel cB cc0 cif cle wbr cB cneg cA cr wcel cA cc0 cif cle
    wbr cA cr wcel cA cc0 cif cB cle wbr wa cB cr wcel cB cc0 cif cneg cA cr
    wcel cA cc0 cif cle wbr cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr
    wa cB cB cr wcel cB cc0 cif cA cr wcel cA cc0 cif cabs cfv cle breq2 cB cB
    cr wcel cB cc0 cif wceq cB cneg cA cr wcel cA cc0 cif cle wbr cB cr wcel cB
    cc0 cif cneg cA cr wcel cA cc0 cif cle wbr cA cr wcel cA cc0 cif cB cle wbr
    cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cle wbr cB cB cr wcel cB cc0
    cif wceq cB cneg cB cr wcel cB cc0 cif cneg cA cr wcel cA cc0 cif cle cB cB
    cr wcel cB cc0 cif negeq breq1d cB cB cr wcel cB cc0 cif cA cr wcel cA cc0
    cif cle breq2 anbi12d bibi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif
    cA cc0 cr 0re elimel cB cc0 cr 0re elimel abslei dedth2h $.
    $( [12-May-2005] $) $( [6-Apr-2005] $)

  $( If the absolute value of a complex number is less than a real, its
     difference from the real is nonzero. $)
  abssubne0 $p |- ( ( A e. CC /\ B e. RR /\ ( abs ` A ) < B ) ->
                   ( B - A ) =/= 0 ) $=
    cA cc wcel cB cr wcel cA cabs cfv cB clt wbr w3a cB cA cmin co cc0 wne cA
    cB wne cA cc wcel cB cr wcel cA cabs cfv cB clt wbr w3a cA cB wceq wn cA cB
    wne cA cc wcel cB cr wcel cA cabs cfv cB clt wbr w3a cA cB wceq cB cA cabs
    cfv wceq cA cc wcel cB cr wcel cA cabs cfv cB clt wbr w3a cB cA cabs cfv
    wne cB cA cabs cfv wceq wn cA cabs cfv cr wcel cB cr wcel cA cabs cfv cB
    clt wbr cB cA cabs cfv wne cA cc wcel cA cabs cfv cB ltne cA abscl syl3an1
    cB cA cabs cfv df-ne sylib cB cr wcel cA cabs cfv cB clt wbr cA cB wceq cB
    cA cabs cfv wceq wi cA cc wcel cA cB wceq cB cr wcel cA cabs cfv cB clt wbr
    wa cB cA cabs cfv wceq cA cB wceq cB cr wcel cB cabs cfv cB clt wbr wa cB
    cB cabs cfv wceq cB cr wcel cA cabs cfv cB clt wbr wa cB cA cabs cfv wceq
    cB cr wcel cB cabs cfv cB clt wbr wa cB cB cabs cfv wceq wi cA cB wceq cB
    cr wcel cB cabs cfv cB clt wbr cB cB cabs cfv wceq cB cr wcel cB cabs cfv
    cB clt wbr cB cB cabs cfv wceq cB cr wcel cB cabs cfv cB clt wbr cB cneg cB
    clt wbr cB cB clt wbr wa cB cr wcel cB cB clt wbr cB cneg cB clt wbr cB
    ltnr intnand cB cr wcel cB cabs cfv cB clt wbr cB cneg cB clt wbr cB cB clt
    wbr wa wb cB cB abslt anidms mtbird pm2.21d imp a1i cA cB wceq cA cabs cfv
    cB clt wbr cB cabs cfv cB clt wbr cB cr wcel cA cB wceq cA cabs cfv cB cabs
    cfv cB clt cA cB cabs fveq2 breq1d anbi2d cA cB wceq cA cabs cfv cB cabs
    cfv cB cA cB cabs fveq2 eqeq2d 3imtr4d com12 3adant1 mtod cA cB df-ne
    sylibr cA cc wcel cB cr wcel cB cA cmin co cc0 wne cA cB wne wb cA cabs cfv
    cB clt wbr cA cc wcel cB cr wcel wa cB cA cmin co cc0 cA cB cA cc wcel cB
    cr wcel wa cB cA cmin co cc0 wceq cB cA wceq cA cB wceq cB cr wcel cA cc
    wcel cB cA cmin co cc0 wceq cB cA wceq wb cB cc wcel cA cc wcel cB cA cmin
    co cc0 wceq cB cA wceq wb cB cr wcel cB cA subeq0 cB recn sylan ancoms cB
    cA eqcom syl6bb necon3bid 3adant3 mpbird $.
    $( [4-Nov-2007] $) $( [2-Nov-2007] $)

  $( The absolute value of a difference and 'less than' relation.  (Contributed
      by Paul Chapman, 18-Sep-2007.) $)
  absdiflt $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                    ( ( abs ` ( A - B ) ) < C <->
                      ( ( B - C ) < A /\ A < ( B + C ) ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cmin co cabs cfv cC clt wbr cC
    cneg cA cB cmin co clt wbr cA cB cmin co cC clt wbr wa cB cC cmin co cA clt
    wbr cA cB cC caddc co clt wbr wa cA cr wcel cB cr wcel cC cr wcel cA cB
    cmin co cabs cfv cC clt wbr cC cneg cA cB cmin co clt wbr cA cB cmin co cC
    clt wbr wa wb cA cB cmin co cr wcel cC cr wcel cA cB cmin co cabs cfv cC
    clt wbr cC cneg cA cB cmin co clt wbr cA cB cmin co cC clt wbr wa wb cA cr
    wcel cB cr wcel wa cA cB cmin co cC abslt cA cB resubcl sylan 3impa cA cr
    wcel cB cr wcel cC cr wcel w3a cC cneg cA cB cmin co clt wbr cB cC cmin co
    cA clt wbr cA cB cmin co cC clt wbr cA cB cC caddc co clt wbr cA cr wcel cB
    cr wcel cC cr wcel w3a cB cC cneg caddc co cA clt wbr cC cneg cA cB cmin co
    clt wbr cB cC cmin co cA clt wbr cB cr wcel cC cr wcel cA cr wcel cB cC
    cneg caddc co cA clt wbr cC cneg cA cB cmin co clt wbr wb cB cr wcel cC
    cneg cr wcel cA cr wcel cB cC cneg caddc co cA clt wbr cC cneg cA cB cmin
    co clt wbr wb cC cr wcel cB cC cneg cA ltaddsub2 cC renegcl syl3an2 3comr
    cA cr wcel cB cr wcel cC cr wcel w3a cB cC cneg caddc co cB cC cmin co cA
    clt cB cr wcel cC cr wcel cB cC cneg caddc co cB cC cmin co wceq cA cr wcel
    cB cc wcel cC cc wcel cB cC cneg caddc co cB cC cmin co wceq cB cr wcel cC
    cr wcel cB cC negsub cB recn cC recn syl2an 3adant1 breq1d bitr3d cA cB cC
    ltsubadd2 anbi12d bitrd $.
    $( [19-Sep-2007] $) $( [18-Sep-2007] $)

  $( The absolute value of a difference and 'less than or equal to' relation.
     (Contributed by Paul Chapman, 18-Sep-2007.) $)
  absdifle $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                    ( ( abs ` ( A - B ) ) <_ C <->
                      ( ( B - C ) <_ A /\ A <_ ( B + C ) ) ) ) $=
    cA cr wcel cB cr wcel cC cr wcel w3a cA cB cmin co cabs cfv cC cle wbr cC
    cneg cA cB cmin co cle wbr cA cB cmin co cC cle wbr wa cB cC cmin co cA cle
    wbr cA cB cC caddc co cle wbr wa cA cr wcel cB cr wcel cC cr wcel cA cB
    cmin co cabs cfv cC cle wbr cC cneg cA cB cmin co cle wbr cA cB cmin co cC
    cle wbr wa wb cA cB cmin co cr wcel cC cr wcel cA cB cmin co cabs cfv cC
    cle wbr cC cneg cA cB cmin co cle wbr cA cB cmin co cC cle wbr wa wb cA cr
    wcel cB cr wcel wa cA cB cmin co cC absle cA cB resubcl sylan 3impa cA cr
    wcel cB cr wcel cC cr wcel w3a cC cneg cA cB cmin co cle wbr cB cC cmin co
    cA cle wbr cA cB cmin co cC cle wbr cA cB cC caddc co cle wbr cA cr wcel cB
    cr wcel cC cr wcel w3a cB cC cneg caddc co cA cle wbr cC cneg cA cB cmin co
    cle wbr cB cC cmin co cA cle wbr cB cr wcel cC cr wcel cA cr wcel cB cC
    cneg caddc co cA cle wbr cC cneg cA cB cmin co cle wbr wb cB cr wcel cC
    cneg cr wcel cA cr wcel cB cC cneg caddc co cA cle wbr cC cneg cA cB cmin
    co cle wbr wb cC cr wcel cB cC cneg cA leaddsub2 cC renegcl syl3an2 3comr
    cA cr wcel cB cr wcel cC cr wcel w3a cB cC cneg caddc co cB cC cmin co cA
    cle cB cr wcel cC cr wcel cB cC cneg caddc co cB cC cmin co wceq cA cr wcel
    cB cc wcel cC cc wcel cB cC cneg caddc co cB cC cmin co wceq cB cr wcel cC
    cr wcel cB cC negsub cB recn cC recn syl2an 3adant1 breq1d bitr3d cA cB cC
    lesubadd2 anbi12d bitrd $.
    $( [19-Sep-2007] $) $( [18-Sep-2007] $)

  $( Comparison to a nonnegative number based on comparison to squares. $)
  lenegsq $p |- ( ( A e. RR /\ B e. RR /\ 0 <_ B ) ->
              ( ( A <_ B /\ -u A <_ B ) <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
    cA cr wcel cB cr wcel cc0 cB cle wbr cA cB cle wbr cA cneg cB cle wbr wa cA
    c2 cexp co cB c2 cexp co cle wbr wb cA cr wcel cB cr wcel cc0 cB cle wbr wa
    wa cA cabs cfv cB cle wbr cA cabs cfv c2 cexp co cB c2 cexp co cle wbr cA
    cB cle wbr cA cneg cB cle wbr wa cA c2 cexp co cB c2 cexp co cle wbr cA
    cabs cfv cr wcel cc0 cA cabs cfv cle wbr wa cB cr wcel cc0 cB cle wbr wa cA
    cabs cfv cB cle wbr cA cabs cfv c2 cexp co cB c2 cexp co cle wbr wb cA cr
    wcel cA cabs cfv cB le2sq cA cr wcel cA cc wcel cA cabs cfv cr wcel cc0 cA
    cabs cfv cle wbr wa cA recn cA cc wcel cA cabs cfv cr wcel cc0 cA cabs cfv
    cle wbr cA abscl cA absge0 jca syl sylan cA cr wcel cB cr wcel cA cabs cfv
    cB cle wbr cA cB cle wbr cA cneg cB cle wbr wa wb cc0 cB cle wbr cA cr wcel
    cB cr wcel wa cA cabs cfv cB cle wbr cB cneg cA cle wbr cA cB cle wbr wa cA
    cB cle wbr cA cneg cB cle wbr wa cA cB absle cA cr wcel cB cr wcel wa cA
    cneg cB cle wbr cA cB cle wbr wa cB cneg cA cle wbr cA cB cle wbr wa cA cB
    cle wbr cA cneg cB cle wbr wa cA cr wcel cB cr wcel wa cA cneg cB cle wbr
    cB cneg cA cle wbr cA cB cle wbr cA cB lenegcon1 anbi1d cA cneg cB cle wbr
    cA cB cle wbr ancom syl5rbbr bitrd adantrr cA cr wcel cA cabs cfv c2 cexp
    co cB c2 cexp co cle wbr cA c2 cexp co cB c2 cexp co cle wbr wb cB cr wcel
    cc0 cB cle wbr wa cA cr wcel cA cabs cfv c2 cexp co cA c2 cexp co cB c2
    cexp co cle cA absresq breq1d adantr 3bitr3d 3impb $.
    $( [2-Mar-2006] $) $( [16-Jan-2006] $)

  $( The real part of a number is less than or equal to its absolute value.
     Proposition 10-3.7(d) of [Gleason] p. 133. $)
  releabs $p |- ( A e. CC -> ( Re ` A ) <_ ( abs ` A ) ) $=
    cA cc wcel cA cre cfv cA cre cfv cabs cfv cA cabs cfv cA recl cA cc wcel cA
    cre cfv cr wcel cA cre cfv cc wcel cA cre cfv cabs cfv cr wcel cA recl cA
    cre cfv recn cA cre cfv abscl 3syl cA abscl cA cc wcel cA cre cfv cr wcel
    cA cre cfv cA cre cfv cabs cfv cle wbr cA recl cA cre cfv leabs syl cA
    absrele letrd $.
    $( [3-Apr-2005] $) $( [1-Apr-2005] $)

  ${
    recvalzi.1 $e |- A e. CC $.
    $( Reciprocal expressed with a real denominator. $)
    recvalzi $p |- ( A =/= 0 ->
                  ( 1 / A ) = ( ( * ` A ) / ( ( abs ` A ) ^ 2 ) ) ) $=
      cA cc0 wne c1 cA cabs cfv c2 cexp co cA ccj cfv cdiv co cdiv co c1 cA
      cdiv co cA ccj cfv cA cabs cfv c2 cexp co cdiv co cA cc0 wne cA cabs cfv
      c2 cexp co cA ccj cfv cdiv co cA c1 cdiv cA cc0 wne cA cabs cfv c2 cexp
      co cA ccj cfv cdiv co cA wceq cA ccj cfv cA cmul co cA cabs cfv c2 cexp
      co wceq cA ccj cfv cA cmul co cA cA ccj cfv cmul co cA cabs cfv c2 cexp
      co cA ccj cfv cA cA recvalzi.1 cjcli recvalzi.1 mulcomi cA recvalzi.1
      absvalsqi eqtr4i cA cc0 wne cA ccj cfv cc0 wne cA cabs cfv c2 cexp co cA
      ccj cfv cdiv co cA wceq cA ccj cfv cA cmul co cA cabs cfv c2 cexp co wceq
      wb cA cc wcel cA cc0 wne cA ccj cfv cc0 wne wb recvalzi.1 cA cjne0 ax-mp
      cA cabs cfv c2 cexp co cA ccj cfv cA cA cabs cfv c2 cexp co cA cabs cfv
      cA recvalzi.1 abscli resqcli recni cA recvalzi.1 cjcli recvalzi.1
      divmulzi sylbi mpbiri opreq2d cA cabs cfv c2 cexp co cc0 wne cA ccj cfv
      cc0 wne c1 cA cabs cfv c2 cexp co cA ccj cfv cdiv co cdiv co cA ccj cfv
      cA cabs cfv c2 cexp co cdiv co wceq cA cc0 wne cA cabs cfv c2 cexp co cc
      wcel cA cabs cfv c2 cexp co cc0 wne cA ccj cfv cc0 wne c1 cA cabs cfv c2
      cexp co cA ccj cfv cdiv co cdiv co cA ccj cfv cA cabs cfv c2 cexp co cdiv
      co wceq cA cabs cfv c2 cexp co cA cabs cfv cA recvalzi.1 abscli resqcli
      recni cA cabs cfv c2 cexp co cc wcel cA cabs cfv c2 cexp co cc0 wne wa cA
      ccj cfv cc wcel cA ccj cfv cc0 wne c1 cA cabs cfv c2 cexp co cA ccj cfv
      cdiv co cdiv co cA ccj cfv cA cabs cfv c2 cexp co cdiv co wceq cA
      recvalzi.1 cjcli cA cabs cfv c2 cexp co cA ccj cfv recdiv mpanr1 mpanl1
      cc0 cA cabs cfv clt wbr cA cabs cfv cc0 wne cA cc0 wne cA cabs cfv c2
      cexp co cc0 wne cA cabs cfv cA recvalzi.1 abscli gt0ne0i cA recvalzi.1
      absgt0i cA cabs cfv c2 cexp co cc0 cA cabs cfv cc0 cA cabs cfv cA cabs
      cfv cA recvalzi.1 abscli recni sqeq0i necon3bii 3imtr4i cA cc0 wne cA ccj
      cfv cc0 wne cA cc wcel cA cc0 wne cA ccj cfv cc0 wne wb recvalzi.1 cA
      cjne0 ax-mp biimpi sylanc eqtr3d $.
      $( [8-Jul-2005] $) $( [29-Apr-2005] $)
  $}

  ${
    cjdiv.1 $e |- A e. CC $.
    cjdiv.2 $e |- B e. CC $.
    $( Complex conjugate distributes over division. $)
    cjdivi $p |- ( B =/= 0 ->
                    ( * ` ( A / B ) ) = ( ( * ` A ) / ( * ` B ) ) ) $=
      cB cc0 wne cA cB cdiv co ccj cfv cA c1 cB cdiv co cmul co ccj cfv cA ccj
      cfv c1 cB cdiv co ccj cfv cmul co cA ccj cfv cB ccj cfv cdiv co cB cc0
      wne cA cB cdiv co cA c1 cB cdiv co cmul co ccj cA cB cjdiv.1 cjdiv.2
      divreczi fveq2d cA cc wcel c1 cB cdiv co cc wcel cA c1 cB cdiv co cmul co
      ccj cfv cA ccj cfv c1 cB cdiv co ccj cfv cmul co wceq cB cc0 wne cA c1 cB
      cdiv co cjmul cjdiv.1 cB cjdiv.2 recclzi sylancr cB cc0 wne cA ccj cfv cB
      ccj cfv cdiv co cA ccj cfv c1 cB ccj cfv cdiv co cmul co cA ccj cfv c1 cB
      cdiv co ccj cfv cmul co cB cc0 wne cB ccj cfv cc0 wne cA ccj cfv cB ccj
      cfv cdiv co cA ccj cfv c1 cB ccj cfv cdiv co cmul co wceq cB cc wcel cB
      cc0 wne cB ccj cfv cc0 wne wb cjdiv.2 cB cjne0 ax-mp cA ccj cfv cB ccj
      cfv cA cjdiv.1 cjcli cB cjdiv.2 cjcli divreczi sylbi cB cc0 wne c1 cB ccj
      cfv cdiv co c1 cB cdiv co ccj cfv cA ccj cfv cmul cB cc0 wne cB ccj cfv
      ccj cfv cB ccj cfv cabs cfv c2 cexp co cdiv co cB ccj cfv c1 cB cabs cfv
      c2 cexp co cdiv co cmul co ccj cfv c1 cB ccj cfv cdiv co c1 cB cdiv co
      ccj cfv cB cc0 wne cB ccj cfv ccj cfv c1 cB cabs cfv c2 cexp co cdiv co
      ccj cfv cmul co cB ccj cfv ccj cfv c1 cB cabs cfv c2 cexp co cdiv co cmul
      co cB ccj cfv c1 cB cabs cfv c2 cexp co cdiv co cmul co ccj cfv cB ccj
      cfv ccj cfv cB ccj cfv cabs cfv c2 cexp co cdiv co cB cc0 wne c1 cB cabs
      cfv c2 cexp co cdiv co ccj cfv c1 cB cabs cfv c2 cexp co cdiv co cB ccj
      cfv ccj cfv cmul cB cc0 wne cB cabs cfv c2 cexp co cc0 wne c1 cB cabs cfv
      c2 cexp co cdiv co cr wcel c1 cB cabs cfv c2 cexp co cdiv co ccj cfv c1
      cB cabs cfv c2 cexp co cdiv co wceq cc0 cB cabs cfv clt wbr cB cabs cfv
      cc0 wne cB cc0 wne cB cabs cfv c2 cexp co cc0 wne cB cabs cfv cB cjdiv.2
      abscli gt0ne0i cB cjdiv.2 absgt0i cB cabs cfv c2 cexp co cc0 cB cabs cfv
      cc0 cB cabs cfv cB cabs cfv cB cjdiv.2 abscli recni sqeq0i necon3bii
      3imtr4i cB cabs cfv c2 cexp co cB cabs cfv cB cjdiv.2 abscli resqcli
      rerecclzi c1 cB cabs cfv c2 cexp co cdiv co cjre 3syl opreq2d cB ccj cfv
      cc wcel c1 cB cabs cfv c2 cexp co cdiv co cc wcel cB ccj cfv c1 cB cabs
      cfv c2 cexp co cdiv co cmul co ccj cfv cB ccj cfv ccj cfv c1 cB cabs cfv
      c2 cexp co cdiv co ccj cfv cmul co wceq cB cc0 wne cB ccj cfv c1 cB cabs
      cfv c2 cexp co cdiv co cjmul cB cjdiv.2 cjcli cB cc0 wne cB cabs cfv c2
      cexp co cc0 wne c1 cB cabs cfv c2 cexp co cdiv co cc wcel cc0 cB cabs cfv
      clt wbr cB cabs cfv cc0 wne cB cc0 wne cB cabs cfv c2 cexp co cc0 wne cB
      cabs cfv cB cjdiv.2 abscli gt0ne0i cB cjdiv.2 absgt0i cB cabs cfv c2 cexp
      co cc0 cB cabs cfv cc0 cB cabs cfv cB cabs cfv cB cjdiv.2 abscli recni
      sqeq0i necon3bii 3imtr4i cB cabs cfv c2 cexp co cB cabs cfv c2 cexp co cB
      cabs cfv cB cjdiv.2 abscli resqcli recni recclzi syl sylancr cB cc0 wne
      cB ccj cfv ccj cfv cB cabs cfv c2 cexp co cdiv co cB ccj cfv ccj cfv c1
      cB cabs cfv c2 cexp co cdiv co cmul co cB ccj cfv ccj cfv cB ccj cfv cabs
      cfv c2 cexp co cdiv co cB cc0 wne cB cabs cfv c2 cexp co cc0 wne cB ccj
      cfv ccj cfv cB cabs cfv c2 cexp co cdiv co cB ccj cfv ccj cfv c1 cB cabs
      cfv c2 cexp co cdiv co cmul co wceq cc0 cB cabs cfv clt wbr cB cabs cfv
      cc0 wne cB cc0 wne cB cabs cfv c2 cexp co cc0 wne cB cabs cfv cB cjdiv.2
      abscli gt0ne0i cB cjdiv.2 absgt0i cB cabs cfv c2 cexp co cc0 cB cabs cfv
      cc0 cB cabs cfv cB cabs cfv cB cjdiv.2 abscli recni sqeq0i necon3bii
      3imtr4i cB ccj cfv ccj cfv cB cabs cfv c2 cexp co cB ccj cfv cB cjdiv.2
      cjcli cjcli cB cabs cfv c2 cexp co cB cabs cfv cB cjdiv.2 abscli resqcli
      recni divreczi syl cB ccj cfv cabs cfv c2 cexp co cB cabs cfv c2 cexp co
      cB ccj cfv ccj cfv cdiv cB ccj cfv cabs cfv cB cabs cfv c2 cexp cB
      cjdiv.2 abscji opreq1i opreq2i syl5eq 3eqtr4rd cB cc0 wne cB ccj cfv cc0
      wne c1 cB ccj cfv cdiv co cB ccj cfv ccj cfv cB ccj cfv cabs cfv c2 cexp
      co cdiv co wceq cB cc wcel cB cc0 wne cB ccj cfv cc0 wne wb cjdiv.2 cB
      cjne0 ax-mp cB ccj cfv cB cjdiv.2 cjcli recvalzi sylbi cB cc0 wne c1 cB
      cdiv co cB ccj cfv c1 cB cabs cfv c2 cexp co cdiv co cmul co ccj cB cc0
      wne c1 cB cdiv co cB ccj cfv cB cabs cfv c2 cexp co cdiv co cB ccj cfv c1
      cB cabs cfv c2 cexp co cdiv co cmul co cB cjdiv.2 recvalzi cB cc0 wne cB
      cabs cfv c2 cexp co cc0 wne cB ccj cfv cB cabs cfv c2 cexp co cdiv co cB
      ccj cfv c1 cB cabs cfv c2 cexp co cdiv co cmul co wceq cc0 cB cabs cfv
      clt wbr cB cabs cfv cc0 wne cB cc0 wne cB cabs cfv c2 cexp co cc0 wne cB
      cabs cfv cB cjdiv.2 abscli gt0ne0i cB cjdiv.2 absgt0i cB cabs cfv c2 cexp
      co cc0 cB cabs cfv cc0 cB cabs cfv cB cabs cfv cB cjdiv.2 abscli recni
      sqeq0i necon3bii 3imtr4i cB ccj cfv cB cabs cfv c2 cexp co cB cjdiv.2
      cjcli cB cabs cfv c2 cexp co cB cabs cfv cB cjdiv.2 abscli resqcli recni
      divreczi syl eqtrd fveq2d 3eqtr4d opreq2d eqtr2d 3eqtrd $.
      $( [13-Dec-2005] $) $( [29-Apr-2005] $)
  $}

  $( Complex conjugate distributes over division. $)
  cjdiv $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                   ( * ` ( A / B ) ) = ( ( * ` A ) / ( * ` B ) ) ) $=
    cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co ccj cfv cA ccj cfv cB ccj
    cfv cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne cA cB cdiv co ccj cfv cA
    ccj cfv cB ccj cfv cdiv co wceq wi cB cc0 wne cA cc wcel cA cc0 cif cB cdiv
    co ccj cfv cA cc wcel cA cc0 cif ccj cfv cB ccj cfv cdiv co wceq wi cB cc
    wcel cB cc0 cif cc0 wne cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co
    ccj cfv cA cc wcel cA cc0 cif ccj cfv cB cc wcel cB cc0 cif ccj cfv cdiv co
    wceq wi cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB cdiv co ccj cfv
    cA ccj cfv cB ccj cfv cdiv co wceq cA cc wcel cA cc0 cif cB cdiv co ccj cfv
    cA cc wcel cA cc0 cif ccj cfv cB ccj cfv cdiv co wceq cB cc0 wne cA cA cc
    wcel cA cc0 cif wceq cA cB cdiv co ccj cfv cA cc wcel cA cc0 cif cB cdiv co
    ccj cfv cA ccj cfv cB ccj cfv cdiv co cA cc wcel cA cc0 cif ccj cfv cB ccj
    cfv cdiv co cA cA cc wcel cA cc0 cif wceq cA cB cdiv co cA cc wcel cA cc0
    cif cB cdiv co ccj cA cA cc wcel cA cc0 cif cB cdiv opreq1 fveq2d cA cA cc
    wcel cA cc0 cif wceq cA ccj cfv cA cc wcel cA cc0 cif ccj cfv cB ccj cfv
    cdiv cA cA cc wcel cA cc0 cif ccj fveq2 opreq1d eqeq12d imbi2d cB cB cc
    wcel cB cc0 cif wceq cB cc0 wne cB cc wcel cB cc0 cif cc0 wne cA cc wcel cA
    cc0 cif cB cdiv co ccj cfv cA cc wcel cA cc0 cif ccj cfv cB ccj cfv cdiv co
    wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co ccj cfv cA cc wcel
    cA cc0 cif ccj cfv cB cc wcel cB cc0 cif ccj cfv cdiv co wceq cB cB cc wcel
    cB cc0 cif cc0 neeq1 cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB
    cdiv co ccj cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cdiv co ccj cfv
    cA cc wcel cA cc0 cif ccj cfv cB ccj cfv cdiv co cA cc wcel cA cc0 cif ccj
    cfv cB cc wcel cB cc0 cif ccj cfv cdiv co cB cB cc wcel cB cc0 cif wceq cA
    cc wcel cA cc0 cif cB cdiv co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif
    cdiv co ccj cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cdiv opreq2
    fveq2d cB cB cc wcel cB cc0 cif wceq cB ccj cfv cB cc wcel cB cc0 cif ccj
    cfv cA cc wcel cA cc0 cif ccj cfv cdiv cB cB cc wcel cB cc0 cif ccj fveq2
    opreq2d eqeq12d imbi12d cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0
    cc 0cn elimel cB cc0 cc 0cn elimel cjdivi dedth2h 3impia $.
    $( [3-Feb-2006] $) $( [29-Apr-2005] $)

  ${
    releabs.1 $e |- A e. CC $.
    $( The real part of a number is less than or equal to its absolute value.
       Proposition 10-3.7(d) of [Gleason] p. 133. $)
    releabsi $p |- ( Re ` A ) <_ ( abs ` A ) $=
      cA cc wcel cA cre cfv cA cabs cfv cle wbr releabs.1 cA releabs ax-mp $.
      $( [2-Oct-1999] $)

    ${
      abstri.2 $e |- B e. CC $.
      $( Triangle inequality for absolute value.  Proposition 10-3.7(h) of
         [Gleason] p. 133. $)
      abstrii $p |- ( abs ` ( A + B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) $=
        cA cB caddc co cabs cfv cA cabs cfv cB cabs cfv caddc co cle wbr cA cB
        caddc co cabs cfv c2 cexp co cA cabs cfv cB cabs cfv caddc co c2 cexp
        co cle wbr cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co caddc co c2 cA
        cB ccj cfv cmul co cre cfv cmul co caddc co cA cabs cfv c2 cexp co cB
        cabs cfv c2 cexp co caddc co c2 cA cabs cfv cB cabs cfv cmul co cmul co
        caddc co cA cB caddc co cabs cfv c2 cexp co cA cabs cfv cB cabs cfv
        caddc co c2 cexp co cle c2 cA cB ccj cfv cmul co cre cfv cmul co c2 cA
        cabs cfv cB cabs cfv cmul co cmul co cle wbr cA cabs cfv c2 cexp co cB
        cabs cfv c2 cexp co caddc co c2 cA cB ccj cfv cmul co cre cfv cmul co
        caddc co cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co caddc co c2 cA
        cabs cfv cB cabs cfv cmul co cmul co caddc co cle wbr cA cB ccj cfv
        cmul co cre cfv cA cabs cfv cB cabs cfv cmul co cle wbr c2 cA cB ccj
        cfv cmul co cre cfv cmul co c2 cA cabs cfv cB cabs cfv cmul co cmul co
        cle wbr cA cB ccj cfv cmul co cre cfv cA cB ccj cfv cmul co cabs cfv cA
        cabs cfv cB cabs cfv cmul co cle cA cB ccj cfv cmul co cA cB ccj cfv
        releabs.1 cB abstri.2 cjcli mulcli releabsi cA cB ccj cfv cmul co cabs
        cfv cA cabs cfv cB ccj cfv cabs cfv cmul co cA cabs cfv cB cabs cfv
        cmul co cA cB ccj cfv releabs.1 cB abstri.2 cjcli absmuli cB ccj cfv
        cabs cfv cB cabs cfv cA cabs cfv cmul cB abstri.2 abscji opreq2i eqtri
        breqtri cc0 c2 clt wbr cA cB ccj cfv cmul co cre cfv cA cabs cfv cB
        cabs cfv cmul co cle wbr c2 cA cB ccj cfv cmul co cre cfv cmul co c2 cA
        cabs cfv cB cabs cfv cmul co cmul co cle wbr wb 2pos cA cB ccj cfv cmul
        co cre cfv cA cabs cfv cB cabs cfv cmul co c2 cA cB ccj cfv cmul co cA
        cB ccj cfv releabs.1 cB abstri.2 cjcli mulcli recli cA cabs cfv cB cabs
        cfv cA releabs.1 abscli cB abstri.2 abscli remulcli 2re lemul2i ax-mp
        mpbi c2 cA cB ccj cfv cmul co cre cfv cmul co c2 cA cabs cfv cB cabs
        cfv cmul co cmul co cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co caddc
        co c2 cA cB ccj cfv cmul co cre cfv 2re cA cB ccj cfv cmul co cA cB ccj
        cfv releabs.1 cB abstri.2 cjcli mulcli recli remulcli c2 cA cabs cfv cB
        cabs cfv cmul co 2re cA cabs cfv cB cabs cfv cA releabs.1 abscli cB
        abstri.2 abscli remulcli remulcli cA cabs cfv c2 cexp co cB cabs cfv c2
        cexp co cA cabs cfv cA releabs.1 abscli resqcli cB cabs cfv cB abstri.2
        abscli resqcli readdcli leadd2i mpbi cA cB releabs.1 abstri.2 sqabsaddi
        cA cabs cfv cB cabs cfv caddc co c2 cexp co cA cabs cfv c2 cexp co c2
        cA cabs cfv cB cabs cfv cmul co cmul co caddc co cB cabs cfv c2 cexp co
        caddc co cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co caddc co c2 cA
        cabs cfv cB cabs cfv cmul co cmul co caddc co cA cabs cfv cB cabs cfv
        cA cabs cfv cA releabs.1 abscli recni cB cabs cfv cB abstri.2 abscli
        recni binom2i cA cabs cfv c2 cexp co c2 cA cabs cfv cB cabs cfv cmul co
        cmul co cB cabs cfv c2 cexp co cA cabs cfv cA cabs cfv cA releabs.1
        abscli recni sqcli c2 cA cabs cfv cB cabs cfv cmul co cmul co c2 cA
        cabs cfv cB cabs cfv cmul co 2re cA cabs cfv cB cabs cfv cA releabs.1
        abscli cB abstri.2 abscli remulcli remulcli recni cB cabs cfv cB cabs
        cfv cB abstri.2 abscli recni sqcli add23i eqtri 3brtr4i cc0 cA cB caddc
        co cabs cfv cle wbr cc0 cA cabs cfv cB cabs cfv caddc co cle wbr cA cB
        caddc co cabs cfv cA cabs cfv cB cabs cfv caddc co cle wbr cA cB caddc
        co cabs cfv c2 cexp co cA cabs cfv cB cabs cfv caddc co c2 cexp co cle
        wbr wb cA cB caddc co cA cB releabs.1 abstri.2 addcli absge0i cc0 cA
        cabs cfv cle wbr cc0 cB cabs cfv cle wbr cc0 cA cabs cfv cB cabs cfv
        caddc co cle wbr cA releabs.1 absge0i cB abstri.2 absge0i cA cabs cfv
        cB cabs cfv cA releabs.1 abscli cB abstri.2 abscli addge0i mp2an cA cB
        caddc co cabs cfv cA cabs cfv cB cabs cfv caddc co cA cB caddc co cA cB
        releabs.1 abstri.2 addcli abscli cA cabs cfv cB cabs cfv cA releabs.1
        abscli cB abstri.2 abscli readdcli le2sqi mp2an mpbir $.
        $( [2-Oct-1999] $)
    $}
  $}

  $( The absolute value function is idempotent. $)
  absidm $p |- ( A e. CC -> ( abs ` ( abs ` A ) ) = ( abs ` A ) ) $=
    cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr cA cabs cfv cabs cfv cA cabs
    cfv wceq cA cc wcel cA cabs cfv absid cA abscl cA absge0 sylanc $.
    $( [20-Jul-2005] $) $( [20-Nov-2004] $)

  $( The absolute value of a non-zero number is positive. $)
  absgt0 $p |- ( A e. CC -> ( A =/= 0 <-> 0 < ( abs ` A ) ) ) $=
    cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr wb cA cc wcel cA cc0 cif cc0
    wne cc0 cA cc wcel cA cc0 cif cabs cfv clt wbr wb cA cc0 cA cA cc wcel cA
    cc0 cif wceq cA cc0 wne cA cc wcel cA cc0 cif cc0 wne cc0 cA cabs cfv clt
    wbr cc0 cA cc wcel cA cc0 cif cabs cfv clt wbr cA cA cc wcel cA cc0 cif cc0
    neeq1 cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA cc0 cif cabs
    cfv cc0 clt cA cA cc wcel cA cc0 cif cabs fveq2 breq2d bibi12d cA cc wcel
    cA cc0 cif cA cc0 cc 0cn elimel absgt0i dedth $.
    $( [6-Mar-2005] $) $( [1-Oct-1999] $)

  $( Swapping order of subtraction doesn't change the absolute value. $)
  abssub $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( abs ` ( A - B ) ) = ( abs ` ( B - A ) ) ) $=
    cA cc wcel cB cc wcel cA cB cmin co cabs cfv cB cA cmin co cabs cfv wceq cA
    cc wcel cA cc0 cif cB cmin co cabs cfv cB cA cc wcel cA cc0 cif cmin co
    cabs cfv wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv
    cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmin co cabs cfv wceq cA cB cc0
    cc0 cA cA cc wcel cA cc0 cif wceq cA cB cmin co cabs cfv cA cc wcel cA cc0
    cif cB cmin co cabs cfv cB cA cmin co cabs cfv cB cA cc wcel cA cc0 cif
    cmin co cabs cfv cA cA cc wcel cA cc0 cif wceq cA cB cmin co cA cc wcel cA
    cc0 cif cB cmin co cabs cA cA cc wcel cA cc0 cif cB cmin opreq1 fveq2d cA
    cA cc wcel cA cc0 cif wceq cB cA cmin co cB cA cc wcel cA cc0 cif cmin co
    cabs cA cA cc wcel cA cc0 cif cB cmin opreq2 fveq2d eqeq12d cB cB cc wcel
    cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin co cabs cfv cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmin co cabs cfv cB cA cc wcel cA cc0 cif cmin co
    cabs cfv cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmin co cabs cfv cB cB
    cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin co cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif cmin co cabs cB cB cc wcel cB cc0 cif cA cc wcel
    cA cc0 cif cmin opreq2 fveq2d cB cB cc wcel cB cc0 cif wceq cB cA cc wcel
    cA cc0 cif cmin co cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmin co cabs
    cB cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif cmin opreq1 fveq2d eqeq12d
    cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc
    0cn elimel abssubi dedth2h $.
    $( [1-Oct-1999] $)

  $( Absolute value of a nonnegative difference. $)
  abssubge0 $p |- (  ( A e. RR /\ B e. RR /\ A <_ B )
                      -> ( abs ` ( B - A ) ) = ( B - A ) ) $=
    cB cr wcel cA cr wcel cA cB cle wbr cB cA cmin co cabs cfv cB cA cmin co
    wceq cB cA cmin co cr wcel cc0 cB cA cmin co cle wbr cB cA cmin co cabs cfv
    cB cA cmin co wceq cB cr wcel cA cr wcel cA cB cle wbr w3a cB cA cmin co
    absid cB cr wcel cA cr wcel cB cA cmin co cr wcel cA cB cle wbr cB cA
    resubcl 3adant3 cB cr wcel cA cr wcel cc0 cB cA cmin co cle wbr cA cB cle
    wbr cB cA subge0 biimp3ar sylanc 3com12 $.
    $( [14-Feb-2008] $) $( [14-Feb-2008] $)

  $( Absolute value of a nonpositive difference.  (Contributed by FL,
     3-Jan-2008.) $)
  abssuble0 $p |- (  ( A e. RR /\ B e. RR /\ A <_ B )
                      -> ( abs ` ( A - B ) ) = ( B - A ) ) $=
    cA cr wcel cB cr wcel cA cB cle wbr w3a cA cB cmin co cabs cfv cB cA cmin
    co cabs cfv cB cA cmin co cA cr wcel cB cr wcel cA cB cmin co cabs cfv cB
    cA cmin co cabs cfv wceq cA cB cle wbr cA cc wcel cB cc wcel cA cB cmin co
    cabs cfv cB cA cmin co cabs cfv wceq cA cr wcel cB cr wcel cA cB abssub cA
    recn cB recn syl2an 3adant3 cA cB abssubge0 eqtrd $.
    $( [23-Jan-2008] $) $( [3-Jan-2008] $)

  $( The maximum of two numbers using absolute value. $)
  absmax $p |- ( ( A e. RR /\ B e. RR ) -> if ( A <_ B , B , A )
              = ( ( ( A + B ) + ( abs ` ( A - B ) ) ) / 2 ) ) $=
    cA cr wcel cB cr wcel wa cA cB cle wbr cB cA cif cA cB caddc co cA cB cmin
    co cabs cfv caddc co c2 cdiv co wceq cB cA cB cr wcel cA cr wcel cB cA clt
    wbr cA cB cle wbr cB cA cif cA cB caddc co cA cB cmin co cabs cfv caddc co
    c2 cdiv co wceq cB cr wcel cA cr wcel wa cB cA clt wbr wa c2 cA cmul co c2
    cdiv co cA cA cB caddc co cA cB cmin co cabs cfv caddc co c2 cdiv co cA cB
    cle wbr cB cA cif cA cr wcel c2 cA cmul co c2 cdiv co cA wceq cB cr wcel cB
    cA clt wbr cA cr wcel cA cc wcel c2 cA cmul co c2 cdiv co cA wceq cA recn
    cA cc wcel c2 cc wcel c2 cc0 wne c2 cA cmul co c2 cdiv co cA wceq 2cn 2ne0
    cA c2 divcan3 mp3an23 syl ad2antlr cB cr wcel cA cr wcel wa cB cA clt wbr
    wa cA cB caddc co cA cB cmin co cabs cfv caddc co c2 cA cmul co c2 cdiv cB
    cr wcel cA cr wcel wa cB cA clt wbr wa cA cB caddc co cA cB cmin co cabs
    cfv caddc co cA cB caddc co cA cB cmin co caddc co c2 cA cmul co cB cr wcel
    cA cr wcel wa cB cA clt wbr wa cA cB cmin co cabs cfv cA cB cmin co cA cB
    caddc co caddc cB cr wcel cA cr wcel wa cB cA clt wbr cB cA cle wbr cA cB
    cmin co cabs cfv cA cB cmin co wceq cB cr wcel cA cr wcel wa cB cA clt wbr
    cB cA cle wbr cB cA ltle imp cB cr wcel cA cr wcel cB cA cle wbr cA cB cmin
    co cabs cfv cA cB cmin co wceq cB cA abssubge0 3expa syldan opreq2d cB cr
    wcel cA cr wcel wa cA cB caddc co cA cB cmin co caddc co c2 cA cmul co wceq
    cB cA clt wbr cB cc wcel cA cc wcel cA cB caddc co cA cB cmin co caddc co
    c2 cA cmul co wceq cB cr wcel cA cr wcel cB cc wcel cA cc wcel wa cA cB
    caddc co cA cB cmin co caddc co cA cA caddc co c2 cA cmul co cA cc wcel cB
    cc wcel cA cc wcel cA cB caddc co cA cB cmin co caddc co cA cA caddc co
    wceq cB cc wcel cA cc wcel wa cA cB cA ppncan cB cc wcel cA cc wcel pm3.27
    cB cc wcel cA cc wcel pm3.26 cB cc wcel cA cc wcel pm3.27 syl3anc cA cc
    wcel c2 cA cmul co cA cA caddc co wceq cB cc wcel cA 2times adantl eqtr4d
    cB recn cA recn syl2an adantr eqtrd opreq1d cB cr wcel cA cr wcel wa cB cA
    clt wbr wa cA cB cle wbr wn cA cB cle wbr cB cA cif cA wceq cB cr wcel cA
    cr wcel wa cB cA clt wbr cA cB cle wbr wn cB cA ltnle biimpa cA cB cle wbr
    cB cA iffalse syl 3eqtr4rd ancom1s cA cr wcel cB cr wcel wa cA cB cle wbr
    wa c2 cB cmul co c2 cdiv co cB cA cB caddc co cA cB cmin co cabs cfv caddc
    co c2 cdiv co cA cB cle wbr cB cA cif cB cr wcel c2 cB cmul co c2 cdiv co
    cB wceq cA cr wcel cA cB cle wbr cB cr wcel cB cc wcel c2 cB cmul co c2
    cdiv co cB wceq cB recn cB cc wcel c2 cc wcel c2 cc0 wne c2 cB cmul co c2
    cdiv co cB wceq 2cn 2ne0 cB c2 divcan3 mp3an23 syl ad2antlr cA cr wcel cB
    cr wcel wa cA cB cle wbr wa cA cB caddc co cA cB cmin co cabs cfv caddc co
    c2 cB cmul co c2 cdiv cA cr wcel cB cr wcel wa cA cB cle wbr wa cA cB caddc
    co cA cB cmin co cabs cfv caddc co cA cB caddc co cB cA cmin co caddc co c2
    cB cmul co cA cr wcel cB cr wcel wa cA cB cle wbr wa cA cB cmin co cabs cfv
    cB cA cmin co cA cB caddc co caddc cA cr wcel cB cr wcel cA cB cle wbr cA
    cB cmin co cabs cfv cB cA cmin co wceq cA cB abssuble0 3expa opreq2d cA cr
    wcel cB cr wcel wa cA cB caddc co cB cA cmin co caddc co c2 cB cmul co wceq
    cA cB cle wbr cA cc wcel cB cc wcel cA cB caddc co cB cA cmin co caddc co
    c2 cB cmul co wceq cA cr wcel cB cr wcel cA cc wcel cB cc wcel wa cB cA
    caddc co cB cA cmin co caddc co cB cB caddc co cA cB caddc co cB cA cmin co
    caddc co c2 cB cmul co cB cc wcel cA cc wcel cB cc wcel cB cA caddc co cB
    cA cmin co caddc co cB cB caddc co wceq cA cc wcel cB cc wcel wa cB cA cB
    ppncan cA cc wcel cB cc wcel pm3.27 cA cc wcel cB cc wcel pm3.26 cA cc wcel
    cB cc wcel pm3.27 syl3anc cA cc wcel cB cc wcel wa cA cB caddc co cB cA
    caddc co cB cA cmin co caddc cA cB addcom opreq1d cB cc wcel c2 cB cmul co
    cB cB caddc co wceq cA cc wcel cB 2times adantl 3eqtr4d cA recn cB recn
    syl2an adantr eqtrd opreq1d cA cB cle wbr cA cB cle wbr cB cA cif cB wceq
    cA cr wcel cB cr wcel wa cA cB cle wbr cB cA iftrue adantl 3eqtr4rd cA cr
    wcel cB cr wcel pm3.27 cA cr wcel cB cr wcel pm3.26 pm2.61ltlei $.
    $( [7-Aug-2008] $) $( [7-Aug-2008] $)

  $( Triangle inequality for absolute value.  Proposition 10-3.7(h) of
     [Gleason] p. 133. $)
  abstri $p |- ( ( A e. CC /\ B e. CC ) ->
                ( abs ` ( A + B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co cabs cfv cA cabs cfv cB cabs cfv caddc
    co cle wbr cA cc wcel cA cc0 cif cB caddc co cabs cfv cA cc wcel cA cc0 cif
    cabs cfv cB cabs cfv caddc co cle wbr cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif caddc co cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0
    cif cabs cfv caddc co cle wbr cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq
    cA cB caddc co cabs cfv cA cc wcel cA cc0 cif cB caddc co cabs cfv cA cabs
    cfv cB cabs cfv caddc co cA cc wcel cA cc0 cif cabs cfv cB cabs cfv caddc
    co cle cA cA cc wcel cA cc0 cif wceq cA cB caddc co cA cc wcel cA cc0 cif
    cB caddc co cabs cA cA cc wcel cA cc0 cif cB caddc opreq1 fveq2d cA cA cc
    wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA cc0 cif cabs cfv cB cabs cfv
    caddc cA cA cc wcel cA cc0 cif cabs fveq2 opreq1d breq12d cB cB cc wcel cB
    cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co cabs cfv cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif caddc co cabs cfv cA cc wcel cA cc0 cif cabs cfv
    cB cabs cfv caddc co cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0 cif
    cabs cfv caddc co cle cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif
    cB caddc co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co cabs cB cB
    cc wcel cB cc0 cif cA cc wcel cA cc0 cif caddc opreq2 fveq2d cB cB cc wcel
    cB cc0 cif wceq cB cabs cfv cB cc wcel cB cc0 cif cabs cfv cA cc wcel cA
    cc0 cif cabs cfv caddc cB cB cc wcel cB cc0 cif cabs fveq2 opreq2d breq12d
    cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc
    0cn elimel abstrii dedth2h $.
    $( [20-Apr-2005] $) $( [7-Mar-2005] $)

  $( Absolute value of differences around common element.  (Contributed by FL,
     9-Oct-2006.) $)
  abs3dif $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
            ( abs ` ( A - B ) ) <_ ( ( abs ` ( A - C ) ) +
                      ( abs ` ( C - B ) ) ) ) $=
    cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmin co cC cB cmin co caddc co
    cabs cfv cA cB cmin co cabs cfv cA cC cmin co cabs cfv cC cB cmin co cabs
    cfv caddc co cle cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmin co cC cB
    cmin co caddc co cA cB cmin co cabs cA cc wcel cC cc wcel cB cc wcel cA cC
    cmin co cC cB cmin co caddc co cA cB cmin co wceq cA cC cB npncan 3com23
    fveq2d cA cC cmin co cc wcel cC cB cmin co cc wcel cA cC cmin co cC cB cmin
    co caddc co cabs cfv cA cC cmin co cabs cfv cC cB cmin co cabs cfv caddc co
    cle wbr cA cc wcel cB cc wcel cC cc wcel w3a cA cC cmin co cC cB cmin co
    abstri cA cc wcel cC cc wcel cA cC cmin co cc wcel cB cc wcel cA cC subcl
    3adant2 cB cc wcel cC cc wcel cC cB cmin co cc wcel cA cc wcel cC cc wcel
    cB cc wcel cC cB cmin co cc wcel cC cB subcl ancoms 3adant1 sylanc eqbrtrrd
    $.
    $( [9-Oct-2006] $) $( [9-Oct-2006] $)

  ${
    abs3dif.1 $e |- A e. CC $.
    abs3dif.2 $e |- B e. CC $.
    abs3dif.3 $e |- C e. CC $.
    $( Absolute value of differences around common element. $)
    abs3difi $p |- ( abs ` ( A - B ) ) <_ ( ( abs ` ( A - C ) ) +
                  ( abs ` ( C - B ) ) ) $=
      cA cc wcel cB cc wcel cC cc wcel cA cB cmin co cabs cfv cA cC cmin co
      cabs cfv cC cB cmin co cabs cfv caddc co cle wbr abs3dif.1 abs3dif.2
      abs3dif.3 cA cB cC abs3dif mp3an $.
      $( [2-Oct-1999] $)
    ${
      abs3lem.4 $e |- D e. RR $.
      $( Lemma involving absolute value of differences. $)
      abs3lemi $p |- ( ( ( abs ` ( A - C ) ) < ( D / 2 ) /\
                         ( abs ` ( C - B ) ) < ( D / 2 ) ) ->
                         ( abs ` ( A - B ) ) < D ) $=
        cA cC cmin co cabs cfv cD c2 cdiv co clt wbr cC cB cmin co cabs cfv cD
        c2 cdiv co clt wbr wa cA cB cmin co cabs cfv cD c2 cdiv co cD c2 cdiv
        co caddc co cD clt cA cB cmin co cabs cfv cA cC cmin co cabs cfv cC cB
        cmin co cabs cfv caddc co cle wbr cA cC cmin co cabs cfv cC cB cmin co
        cabs cfv caddc co cD c2 cdiv co cD c2 cdiv co caddc co clt wbr cA cB
        cmin co cabs cfv cD c2 cdiv co cD c2 cdiv co caddc co clt wbr cA cC
        cmin co cabs cfv cD c2 cdiv co clt wbr cC cB cmin co cabs cfv cD c2
        cdiv co clt wbr wa cA cB cmin co cabs cfv cA cC cmin co cabs cfv cC cB
        cmin co cabs cfv caddc co cD c2 cdiv co cD c2 cdiv co caddc co cA cB
        cmin co cA cB abs3dif.1 abs3dif.2 subcli abscli cA cC cmin co cabs cfv
        cC cB cmin co cabs cfv cA cC cmin co cA cC abs3dif.1 abs3dif.3 subcli
        abscli cC cB cmin co cC cB abs3dif.3 abs3dif.2 subcli abscli readdcli
        cD c2 cdiv co cD c2 cdiv co cD c2 abs3lem.4 2re 2ne0 redivcli cD c2
        abs3lem.4 2re 2ne0 redivcli readdcli lelttri cA cB cC abs3dif.1
        abs3dif.2 abs3dif.3 abs3difi cA cC cmin co cabs cfv cC cB cmin co cabs
        cfv cD c2 cdiv co cD c2 cdiv co cA cC cmin co cA cC abs3dif.1 abs3dif.3
        subcli abscli cC cB cmin co cC cB abs3dif.3 abs3dif.2 subcli abscli cD
        c2 abs3lem.4 2re 2ne0 redivcli cD c2 abs3lem.4 2re 2ne0 redivcli
        lt2addi sylancr c2 cD c2 cdiv co cmul co cD c2 cdiv co cD c2 cdiv co
        caddc co cD cD c2 cdiv co cD c2 cdiv co cD c2 abs3lem.4 2re 2ne0
        redivcli recni 2timesi cD c2 cD abs3lem.4 recni 2cn 2ne0 divcan2i
        eqtr3i syl6breq $.
        $( [2-Oct-1999] $)
    $}
  $}

  $( Difference of absolute values.  (Contributed by Paul Chapman,
     7-Sep-2007.) $)
  abs2dif $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( ( abs ` A ) - ( abs ` B ) ) <_ ( abs ` ( A - B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cc0 cmin co cabs cfv cB cc0 cmin co cabs cfv
    cmin co cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs cfv cle cA cc
    wcel cB cc wcel cA cc0 cmin co cabs cfv cA cabs cfv cB cc0 cmin co cabs cfv
    cB cabs cfv cmin cA cc wcel cA cc0 cmin co cA cabs cA subid1 fveq2d cB cc
    wcel cB cc0 cmin co cB cabs cB subid1 fveq2d opreqan12d cA cc wcel cB cc
    wcel wa cA cc0 cmin co cabs cfv cB cc0 cmin co cabs cfv cmin co cA cB cmin
    co cabs cfv cle wbr cA cc0 cmin co cabs cfv cA cB cmin co cabs cfv cB cc0
    cmin co cabs cfv caddc co cle wbr cA cc wcel cc0 cc wcel cB cc wcel cA cc0
    cmin co cabs cfv cA cB cmin co cabs cfv cB cc0 cmin co cabs cfv caddc co
    cle wbr 0cn cA cc0 cB abs3dif mp3an2 cA cc wcel cB cc wcel wa cA cc0 cmin
    co cabs cfv cr wcel cB cc0 cmin co cabs cfv cr wcel cA cB cmin co cabs cfv
    cr wcel w3a cA cc0 cmin co cabs cfv cB cc0 cmin co cabs cfv cmin co cA cB
    cmin co cabs cfv cle wbr cA cc0 cmin co cabs cfv cA cB cmin co cabs cfv cB
    cc0 cmin co cabs cfv caddc co cle wbr wb cA cc0 cmin co cabs cfv cr wcel cB
    cc0 cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cr wcel w3a cA cc0 cmin
    co cabs cfv cr wcel cB cc0 cmin co cabs cfv cr wcel wa cA cB cmin co cabs
    cfv cr wcel cA cc wcel cB cc wcel wa cA cc0 cmin co cabs cfv cr wcel cB cc0
    cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cr wcel df-3an cA cc wcel
    cA cc0 cmin co cabs cfv cr wcel cB cc wcel cB cc0 cmin co cabs cfv cr wcel
    cA cc wcel cA cc0 cmin co cc wcel cA cc0 cmin co cabs cfv cr wcel cA cc
    wcel cc0 cc wcel cA cc0 cmin co cc wcel 0cn cA cc0 subcl mpan2 cA cc0 cmin
    co abscl syl cB cc wcel cB cc0 cmin co cc wcel cB cc0 cmin co cabs cfv cr
    wcel cB cc wcel cc0 cc wcel cB cc0 cmin co cc wcel 0cn cB cc0 subcl mpan2
    cB cc0 cmin co abscl syl anim12i cA cc wcel cB cc wcel wa cA cB cmin co cc
    wcel cA cB cmin co cabs cfv cr wcel cA cB subcl cA cB cmin co abscl syl
    sylanbrc cA cc0 cmin co cabs cfv cB cc0 cmin co cabs cfv cA cB cmin co cabs
    cfv lesubadd syl mpbird eqbrtrrd $.
    $( [8-Sep-2007] $) $( [7-Sep-2007] $)

  $( Absolute value of difference of absolute values.  (Contributed by Paul
     Chapman, 7-Sep-2007.) $)
  abs2difabs $p |- ( ( A e. CC /\ B e. CC ) ->
            ( abs ` ( ( abs ` A ) - ( abs ` B ) ) ) <_ ( abs ` ( A - B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cabs cfv cB cabs cfv cmin co cabs cfv cA cB
    cmin co cabs cfv cle wbr cA cabs cfv cB cabs cfv cmin co cneg cA cB cmin co
    cabs cfv cle wbr cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs cfv cle
    wbr wa cA cc wcel cB cc wcel wa cA cabs cfv cB cabs cfv cmin co cneg cA cB
    cmin co cabs cfv cle wbr cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs
    cfv cle wbr cA cc wcel cB cc wcel wa cB cabs cfv cA cabs cfv cmin co cB cA
    cmin co cabs cfv cA cabs cfv cB cabs cfv cmin co cneg cA cB cmin co cabs
    cfv cle cB cc wcel cA cc wcel cB cabs cfv cA cabs cfv cmin co cB cA cmin co
    cabs cfv cle wbr cB cA abs2dif ancoms cA cabs cfv cc wcel cB cabs cfv cc
    wcel cA cabs cfv cB cabs cfv cmin co cneg cB cabs cfv cA cabs cfv cmin co
    wceq cA cc wcel cB cc wcel cA cabs cfv cB cabs cfv negsubdi2 cA cc wcel cA
    cabs cfv cA abscl recnd cB cc wcel cB cabs cfv cB abscl recnd syl2an cA cB
    abssub 3brtr4d cA cB abs2dif jca cA cc wcel cB cc wcel wa cA cabs cfv cB
    cabs cfv cmin co cabs cfv cA cB cmin co cabs cfv cle wbr cA cB cmin co cabs
    cfv cneg cA cabs cfv cB cabs cfv cmin co cle wbr cA cabs cfv cB cabs cfv
    cmin co cA cB cmin co cabs cfv cle wbr wa cA cabs cfv cB cabs cfv cmin co
    cneg cA cB cmin co cabs cfv cle wbr cA cabs cfv cB cabs cfv cmin co cA cB
    cmin co cabs cfv cle wbr wa cA cabs cfv cB cabs cfv cmin co cr wcel cA cB
    cmin co cabs cfv cr wcel cA cabs cfv cB cabs cfv cmin co cabs cfv cA cB
    cmin co cabs cfv cle wbr cA cB cmin co cabs cfv cneg cA cabs cfv cB cabs
    cfv cmin co cle wbr cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs cfv
    cle wbr wa wb cA cc wcel cB cc wcel wa cA cabs cfv cB cabs cfv cmin co cA
    cB cmin co cabs cfv absle cA cabs cfv cr wcel cB cabs cfv cr wcel cA cabs
    cfv cB cabs cfv cmin co cr wcel cA cc wcel cB cc wcel cA cabs cfv cB cabs
    cfv resubcl cA abscl cB abscl syl2an cA cc wcel cB cc wcel wa cA cB cmin co
    cc wcel cA cB cmin co cabs cfv cr wcel cA cB subcl cA cB cmin co abscl syl
    sylanc cA cc wcel cB cc wcel wa cA cabs cfv cB cabs cfv cmin co cneg cA cB
    cmin co cabs cfv cle wbr cA cB cmin co cabs cfv cneg cA cabs cfv cB cabs
    cfv cmin co cle wbr cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs cfv
    cle wbr cA cabs cfv cB cabs cfv cmin co cr wcel cA cB cmin co cabs cfv cr
    wcel cA cabs cfv cB cabs cfv cmin co cneg cA cB cmin co cabs cfv cle wbr cA
    cB cmin co cabs cfv cneg cA cabs cfv cB cabs cfv cmin co cle wbr wb cA cc
    wcel cB cc wcel wa cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs cfv
    lenegcon1 cA cabs cfv cr wcel cB cabs cfv cr wcel cA cabs cfv cB cabs cfv
    cmin co cr wcel cA cc wcel cB cc wcel cA cabs cfv cB cabs cfv resubcl cA
    abscl cB abscl syl2an cA cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cB
    cmin co cabs cfv cr wcel cA cB subcl cA cB cmin co abscl syl sylanc anbi1d
    bitr4d mpbird $.
    $( [8-Sep-2007] $) $( [7-Sep-2007] $)

  ${
    $d x A $.
    abs1m.1 $e |- A e. CC $.
    $( For any complex number, there exists a unit-magnitude multiplier that
       produces its absolute value.  Part of proof of Theorem 13-2.12 of
       [Gleason] p. 195. $)
    abs1mi $p |- E. x e. CC ( ( abs ` x ) = 1 /\ ( abs ` A ) = ( x x. A ) ) $=
      vx cv cabs cfv c1 wceq cA cabs cfv vx cv cA cmul co wceq wa vx cc wrex cA
      cc0 c1 cc wcel c1 cabs cfv c1 wceq cA cabs cfv c1 cA cmul co wceq wa vx
      cv cabs cfv c1 wceq cA cabs cfv vx cv cA cmul co wceq wa vx cc wrex cA
      cc0 wceq vx cv cabs cfv c1 wceq cA cabs cfv vx cv cA cmul co wceq wa c1
      cabs cfv c1 wceq cA cabs cfv c1 cA cmul co wceq wa vx c1 cc vx cv c1 wceq
      vx cv cabs cfv c1 wceq c1 cabs cfv c1 wceq cA cabs cfv vx cv cA cmul co
      wceq cA cabs cfv c1 cA cmul co wceq vx cv c1 wceq vx cv cabs cfv c1 cabs
      cfv c1 vx cv c1 cabs fveq2 eqeq1d vx cv c1 wceq vx cv cA cmul co c1 cA
      cmul co cA cabs cfv vx cv c1 cA cmul opreq1 eqeq2d anbi12d rcla4ev ax1cn
      cA cc0 wceq cA cabs cfv c1 cA cmul co wceq c1 cabs cfv c1 wceq cA cc0
      wceq cA cabs cfv cc0 c1 cA cmul co cA cabs cfv cc0 wceq cA cc0 wceq cA
      abs1m.1 abs00i biimpri cA cc0 wceq c1 cA cmul co c1 cc0 cmul co cc0 cA
      cc0 c1 cmul opreq2 cc0 0cn mulid2i syl6eq eqtr4d cc0 c1 cle wbr c1 cabs
      cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp jctil sylancr
      cA cc0 wne cA ccj cfv cA cabs cfv cdiv co cc wcel cA ccj cfv cA cabs cfv
      cdiv co cabs cfv c1 wceq cA cabs cfv cA ccj cfv cA cabs cfv cdiv co cA
      cmul co wceq wa wa vx cv cabs cfv c1 wceq cA cabs cfv vx cv cA cmul co
      wceq wa vx cc wrex cA cc0 wne cA cabs cfv cc0 wne cA ccj cfv cA cabs cfv
      cdiv co cc wcel cA ccj cfv cA cabs cfv cdiv co cabs cfv c1 wceq cA cabs
      cfv cA ccj cfv cA cabs cfv cdiv co cA cmul co wceq wa wa cA cabs cfv cc0
      cA cc0 cA abs1m.1 abs00i necon3bii cA cabs cfv cc0 wne cA ccj cfv cA cabs
      cfv cdiv co cc wcel cA ccj cfv cA cabs cfv cdiv co cabs cfv c1 wceq cA
      cabs cfv cA ccj cfv cA cabs cfv cdiv co cA cmul co wceq cA ccj cfv cA
      cabs cfv cA abs1m.1 cjcli cA cabs cfv cA abs1m.1 abscli recni divclzi cA
      cabs cfv cc0 wne cA ccj cfv cA cabs cfv cdiv co cabs cfv cA ccj cfv cabs
      cfv cA cabs cfv cabs cfv cdiv co c1 cA ccj cfv cA cabs cfv cA abs1m.1
      cjcli cA cabs cfv cA abs1m.1 abscli recni absdivzi cA cabs cfv cc0 wne cA
      cabs cfv cA cabs cfv cdiv co c1 cA ccj cfv cabs cfv cA cabs cfv cabs cfv
      cdiv co cA cabs cfv cc wcel cA cabs cfv cc0 wne cA cabs cfv cA cabs cfv
      cdiv co c1 wceq cA cabs cfv cA abs1m.1 abscli recni cA cabs cfv divid
      mpan cA ccj cfv cabs cfv cA cabs cfv cA cabs cfv cabs cfv cA cabs cfv
      cdiv cA abs1m.1 abscji cA cc wcel cA cabs cfv cabs cfv cA cabs cfv wceq
      abs1m.1 cA absidm ax-mp opreq12i syl5eq eqtrd cA cabs cfv cc0 wne cA ccj
      cfv cA cmul co cA cabs cfv cdiv co cA cabs cfv cA ccj cfv cA cabs cfv
      cdiv co cA cmul co cA cabs cfv cc0 wne cA ccj cfv cA cmul co cA cabs cfv
      cdiv co cA cabs cfv wceq cA cabs cfv cA cabs cfv cmul co cA ccj cfv cA
      cmul co wceq cA cabs cfv c2 cexp co cA cA ccj cfv cmul co cA cabs cfv cA
      cabs cfv cmul co cA ccj cfv cA cmul co cA abs1m.1 absvalsqi cA cabs cfv
      cA cabs cfv cA abs1m.1 abscli recni sqvali cA cA ccj cfv abs1m.1 cA
      abs1m.1 cjcli mulcomi 3eqtr3i cA ccj cfv cA cmul co cA cabs cfv cA cabs
      cfv cA ccj cfv cA cA abs1m.1 cjcli abs1m.1 mulcli cA cabs cfv cA abs1m.1
      abscli recni cA cabs cfv cA abs1m.1 abscli recni divmulzi mpbiri cA cabs
      cfv cc wcel cA cabs cfv cc0 wne cA ccj cfv cA cmul co cA cabs cfv cdiv co
      cA ccj cfv cA cabs cfv cdiv co cA cmul co wceq cA cabs cfv cA abs1m.1
      abscli recni cA ccj cfv cc wcel cA cc wcel cA cabs cfv cc wcel cA cabs
      cfv cc0 wne wa cA ccj cfv cA cmul co cA cabs cfv cdiv co cA ccj cfv cA
      cabs cfv cdiv co cA cmul co wceq cA abs1m.1 cjcli abs1m.1 cA ccj cfv cA
      cA cabs cfv div23 mp3an12 mpan eqtr3d jca32 sylbir vx cv cabs cfv c1 wceq
      cA cabs cfv vx cv cA cmul co wceq wa cA ccj cfv cA cabs cfv cdiv co cabs
      cfv c1 wceq cA cabs cfv cA ccj cfv cA cabs cfv cdiv co cA cmul co wceq wa
      vx cA ccj cfv cA cabs cfv cdiv co cc vx cv cA ccj cfv cA cabs cfv cdiv co
      wceq vx cv cabs cfv c1 wceq cA ccj cfv cA cabs cfv cdiv co cabs cfv c1
      wceq cA cabs cfv vx cv cA cmul co wceq cA cabs cfv cA ccj cfv cA cabs cfv
      cdiv co cA cmul co wceq vx cv cA ccj cfv cA cabs cfv cdiv co wceq vx cv
      cabs cfv cA ccj cfv cA cabs cfv cdiv co cabs cfv c1 vx cv cA ccj cfv cA
      cabs cfv cdiv co cabs fveq2 eqeq1d vx cv cA ccj cfv cA cabs cfv cdiv co
      wceq vx cv cA cmul co cA ccj cfv cA cabs cfv cdiv co cA cmul co cA cabs
      cfv vx cv cA ccj cfv cA cabs cfv cdiv co cA cmul opreq1 eqeq2d anbi12d
      rcla4ev syl pm2.61ine $.
      $( [26-Jul-2005] $) $( [26-Mar-2005] $)
  $}

  ${
    $d x y A $.  $d x B $.
    $( Cancellation law involving the real part of a complex number. $)
    recan $p |- ( ( A e. CC /\ B e. CC ) -> ( A. x e. CC
                 ( Re ` ( x x. A ) ) = ( Re ` ( x x. B ) ) <-> A = B ) ) $=
      cA cc wcel cB cc wcel wa vx cv cA cmul co cre cfv vx cv cB cmul co cre
      cfv wceq vx cc wral cA cB wceq cA cc wcel cB cc wcel wa cA cB wceq c1 cA
      cmul co cre cfv ci ci cneg cA cmul co cre cfv cmul co caddc co c1 cB cmul
      co cre cfv ci ci cneg cB cmul co cre cfv cmul co caddc co wceq vx cv cA
      cmul co cre cfv vx cv cB cmul co cre cfv wceq vx cc wral cA cc wcel cB cc
      wcel cA c1 cA cmul co cre cfv ci ci cneg cA cmul co cre cfv cmul co caddc
      co cB c1 cB cmul co cre cfv ci ci cneg cB cmul co cre cfv cmul co caddc
      co cA cc wcel cA cA cre cfv ci cA cim cfv cmul co caddc co c1 cA cmul co
      cre cfv ci ci cneg cA cmul co cre cfv cmul co caddc co cA replim cA cc
      wcel cA cre cfv c1 cA cmul co cre cfv ci cA cim cfv cmul co ci ci cneg cA
      cmul co cre cfv cmul co caddc cA cc wcel cA c1 cA cmul co cre cA cc wcel
      c1 cA cmul co cA cA mulid2 eqcomd fveq2d cA cc wcel cA cim cfv ci cneg cA
      cmul co cre cfv ci cmul cA imre opreq2d opreq12d eqtrd cB cc wcel cB cB
      cre cfv ci cB cim cfv cmul co caddc co c1 cB cmul co cre cfv ci ci cneg
      cB cmul co cre cfv cmul co caddc co cB replim cB cc wcel cB cre cfv c1 cB
      cmul co cre cfv ci cB cim cfv cmul co ci ci cneg cB cmul co cre cfv cmul
      co caddc cB cc wcel cB c1 cB cmul co cre cB cc wcel c1 cB cmul co cB cB
      mulid2 eqcomd fveq2d cB cc wcel cB cim cfv ci cneg cB cmul co cre cfv ci
      cmul cB imre opreq2d opreq12d eqtrd eqeqan12d vx cv cA cmul co cre cfv vx
      cv cB cmul co cre cfv wceq vx cc wral c1 cA cmul co cre cfv c1 cB cmul co
      cre cfv ci ci cneg cA cmul co cre cfv cmul co ci ci cneg cB cmul co cre
      cfv cmul co caddc c1 cc wcel vx cv cA cmul co cre cfv vx cv cB cmul co
      cre cfv wceq vx cc wral c1 cA cmul co cre cfv c1 cB cmul co cre cfv wceq
      wi ax1cn vx cv cA cmul co cre cfv vx cv cB cmul co cre cfv wceq c1 cA
      cmul co cre cfv c1 cB cmul co cre cfv wceq vx c1 cc vx cv c1 wceq vx cv
      cA cmul co cre cfv c1 cA cmul co cre cfv vx cv cB cmul co cre cfv c1 cB
      cmul co cre cfv vx cv c1 wceq vx cv cA cmul co c1 cA cmul co cre vx cv c1
      cA cmul opreq1 fveq2d vx cv c1 wceq vx cv cB cmul co c1 cB cmul co cre vx
      cv c1 cB cmul opreq1 fveq2d eqeq12d rcla4v ax-mp vx cv cA cmul co cre cfv
      vx cv cB cmul co cre cfv wceq vx cc wral ci cneg cA cmul co cre cfv ci
      cneg cB cmul co cre cfv ci cmul ci cneg cc wcel vx cv cA cmul co cre cfv
      vx cv cB cmul co cre cfv wceq vx cc wral ci cneg cA cmul co cre cfv ci
      cneg cB cmul co cre cfv wceq wi ci axicn negcli vx cv cA cmul co cre cfv
      vx cv cB cmul co cre cfv wceq ci cneg cA cmul co cre cfv ci cneg cB cmul
      co cre cfv wceq vx ci cneg cc vx cv ci cneg wceq vx cv cA cmul co cre cfv
      ci cneg cA cmul co cre cfv vx cv cB cmul co cre cfv ci cneg cB cmul co
      cre cfv vx cv ci cneg wceq vx cv cA cmul co ci cneg cA cmul co cre vx cv
      ci cneg cA cmul opreq1 fveq2d vx cv ci cneg wceq vx cv cB cmul co ci cneg
      cB cmul co cre vx cv ci cneg cB cmul opreq1 fveq2d eqeq12d rcla4v ax-mp
      opreq2d opreq12d syl5bir cA cB wceq vx cv cA cmul co cre cfv vx cv cB
      cmul co cre cfv wceq vx cc cA cB wceq vx cv cA cmul co cre cfv vx cv cB
      cmul co cre cfv wceq vx cv cc wcel cA cB wceq vx cv cA cmul co vx cv cB
      cmul co cre cA cB vx cv cmul opreq2 fveq2d a1d r19.21aiv impbid1 $.
      $( [24-Jul-2008] $) $( [12-May-2005] $)

    $( Mapping domain and codomain of the absolute value function. $)
    absf $p |- abs : CC --> RR $=
      vx vy cc cr vx cv vx cv ccj cfv cmul co csqr cfv cabs vx vy df-abs vx cv
      cc wcel vx cv cabs cfv vx cv vx cv ccj cfv cmul co csqr cfv cr vx cv
      absval vx cv abscl eqeltrrd fopab $.
      $( [31-Aug-2007] $) $( [30-Aug-2007] $)
  $}

  $( Lemma involving absolute value of differences. $)
  abs3lem $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\
                   D e. RR ) ) -> (
          ( ( abs ` ( A - C ) ) < ( D / 2 ) /\
            ( abs ` ( C - B ) ) < ( D / 2 ) ) ->
            ( abs ` ( A - B ) ) < D ) ) $=
    cA cc wcel cB cc wcel cC cc wcel cD cr wcel cA cC cmin co cabs cfv cD c2
    cdiv co clt wbr cC cB cmin co cabs cfv cD c2 cdiv co clt wbr wa cA cB cmin
    co cabs cfv cD clt wbr wi cA cB cC cD cc0 cc0 cA cc wcel cA cc0 cif cC cmin
    co cabs cfv cD c2 cdiv co clt wbr cC cB cmin co cabs cfv cD c2 cdiv co clt
    wbr wa cA cc wcel cA cc0 cif cB cmin co cabs cfv cD clt wbr wi cA cc wcel
    cA cc0 cif cC cmin co cabs cfv cD c2 cdiv co clt wbr cC cB cc wcel cB cc0
    cif cmin co cabs cfv cD c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif cB cc
    wcel cB cc0 cif cmin co cabs cfv cD clt wbr wi cA cc wcel cA cc0 cif cC cc
    wcel cC cc0 cif cmin co cabs cfv cD c2 cdiv co clt wbr cC cc wcel cC cc0
    cif cB cc wcel cB cc0 cif cmin co cabs cfv cD c2 cdiv co clt wbr wa cA cc
    wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv cD clt wbr wi cA cc
    wcel cA cc0 cif cC cc wcel cC cc0 cif cmin co cabs cfv cD cr wcel cD cc0
    cif c2 cdiv co clt wbr cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif cmin co
    cabs cfv cD cr wcel cD cc0 cif c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif
    cB cc wcel cB cc0 cif cmin co cabs cfv cD cr wcel cD cc0 cif clt wbr wi cc0
    cc0 cA cA cc wcel cA cc0 cif wceq cA cC cmin co cabs cfv cD c2 cdiv co clt
    wbr cC cB cmin co cabs cfv cD c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif
    cC cmin co cabs cfv cD c2 cdiv co clt wbr cC cB cmin co cabs cfv cD c2 cdiv
    co clt wbr wa cA cB cmin co cabs cfv cD clt wbr cA cc wcel cA cc0 cif cB
    cmin co cabs cfv cD clt wbr cA cA cc wcel cA cc0 cif wceq cA cC cmin co
    cabs cfv cD c2 cdiv co clt wbr cA cc wcel cA cc0 cif cC cmin co cabs cfv cD
    c2 cdiv co clt wbr cC cB cmin co cabs cfv cD c2 cdiv co clt wbr cA cA cc
    wcel cA cc0 cif wceq cA cC cmin co cabs cfv cA cc wcel cA cc0 cif cC cmin
    co cabs cfv cD c2 cdiv co clt cA cA cc wcel cA cc0 cif wceq cA cC cmin co
    cA cc wcel cA cc0 cif cC cmin co cabs cA cA cc wcel cA cc0 cif cC cmin
    opreq1 fveq2d breq1d anbi1d cA cA cc wcel cA cc0 cif wceq cA cB cmin co
    cabs cfv cA cc wcel cA cc0 cif cB cmin co cabs cfv cD clt cA cA cc wcel cA
    cc0 cif wceq cA cB cmin co cA cc wcel cA cc0 cif cB cmin co cabs cA cA cc
    wcel cA cc0 cif cB cmin opreq1 fveq2d breq1d imbi12d cB cB cc wcel cB cc0
    cif wceq cA cc wcel cA cc0 cif cC cmin co cabs cfv cD c2 cdiv co clt wbr cC
    cB cmin co cabs cfv cD c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif cC cmin
    co cabs cfv cD c2 cdiv co clt wbr cC cB cc wcel cB cc0 cif cmin co cabs cfv
    cD c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif cB cmin co cabs cfv cD clt
    wbr cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv cD clt wbr
    cB cB cc wcel cB cc0 cif wceq cC cB cmin co cabs cfv cD c2 cdiv co clt wbr
    cC cB cc wcel cB cc0 cif cmin co cabs cfv cD c2 cdiv co clt wbr cA cc wcel
    cA cc0 cif cC cmin co cabs cfv cD c2 cdiv co clt wbr cB cB cc wcel cB cc0
    cif wceq cC cB cmin co cabs cfv cC cB cc wcel cB cc0 cif cmin co cabs cfv
    cD c2 cdiv co clt cB cB cc wcel cB cc0 cif wceq cC cB cmin co cC cB cc wcel
    cB cc0 cif cmin co cabs cB cB cc wcel cB cc0 cif cC cmin opreq2 fveq2d
    breq1d anbi2d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin
    co cabs cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv cD
    clt cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB cmin co cA cc
    wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cabs cB cB cc wcel cB cc0 cif
    cA cc wcel cA cc0 cif cmin opreq2 fveq2d breq1d imbi12d cC cC cc wcel cC
    cc0 cif wceq cA cc wcel cA cc0 cif cC cmin co cabs cfv cD c2 cdiv co clt
    wbr cC cB cc wcel cB cc0 cif cmin co cabs cfv cD c2 cdiv co clt wbr wa cA
    cc wcel cA cc0 cif cC cc wcel cC cc0 cif cmin co cabs cfv cD c2 cdiv co clt
    wbr cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv cD c2 cdiv
    co clt wbr wa cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv
    cD clt wbr cC cC cc wcel cC cc0 cif wceq cA cc wcel cA cc0 cif cC cmin co
    cabs cfv cD c2 cdiv co clt wbr cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif
    cmin co cabs cfv cD c2 cdiv co clt wbr cC cB cc wcel cB cc0 cif cmin co
    cabs cfv cD c2 cdiv co clt wbr cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif
    cmin co cabs cfv cD c2 cdiv co clt wbr cC cC cc wcel cC cc0 cif wceq cA cc
    wcel cA cc0 cif cC cmin co cabs cfv cA cc wcel cA cc0 cif cC cc wcel cC cc0
    cif cmin co cabs cfv cD c2 cdiv co clt cC cC cc wcel cC cc0 cif wceq cA cc
    wcel cA cc0 cif cC cmin co cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cmin
    co cabs cC cC cc wcel cC cc0 cif cA cc wcel cA cc0 cif cmin opreq2 fveq2d
    breq1d cC cC cc wcel cC cc0 cif wceq cC cB cc wcel cB cc0 cif cmin co cabs
    cfv cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv cD c2 cdiv
    co clt cC cC cc wcel cC cc0 cif wceq cC cB cc wcel cB cc0 cif cmin co cC cc
    wcel cC cc0 cif cB cc wcel cB cc0 cif cmin co cabs cC cC cc wcel cC cc0 cif
    cB cc wcel cB cc0 cif cmin opreq1 fveq2d breq1d anbi12d imbi1d cD cD cr
    wcel cD cc0 cif wceq cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cmin co
    cabs cfv cD c2 cdiv co clt wbr cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif
    cmin co cabs cfv cD c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif cC cc wcel
    cC cc0 cif cmin co cabs cfv cD cr wcel cD cc0 cif c2 cdiv co clt wbr cC cc
    wcel cC cc0 cif cB cc wcel cB cc0 cif cmin co cabs cfv cD cr wcel cD cc0
    cif c2 cdiv co clt wbr wa cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin
    co cabs cfv cD clt wbr cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif cmin co
    cabs cfv cD cr wcel cD cc0 cif clt wbr cD cD cr wcel cD cc0 cif wceq cA cc
    wcel cA cc0 cif cC cc wcel cC cc0 cif cmin co cabs cfv cD c2 cdiv co clt
    wbr cA cc wcel cA cc0 cif cC cc wcel cC cc0 cif cmin co cabs cfv cD cr wcel
    cD cc0 cif c2 cdiv co clt wbr cC cc wcel cC cc0 cif cB cc wcel cB cc0 cif
    cmin co cabs cfv cD c2 cdiv co clt wbr cC cc wcel cC cc0 cif cB cc wcel cB
    cc0 cif cmin co cabs cfv cD cr wcel cD cc0 cif c2 cdiv co clt wbr cD cD cr
    wcel cD cc0 cif wceq cD c2 cdiv co cD cr wcel cD cc0 cif c2 cdiv co cA cc
    wcel cA cc0 cif cC cc wcel cC cc0 cif cmin co cabs cfv clt cD cD cr wcel cD
    cc0 cif c2 cdiv opreq1 breq2d cD cD cr wcel cD cc0 cif wceq cD c2 cdiv co
    cD cr wcel cD cc0 cif c2 cdiv co cC cc wcel cC cc0 cif cB cc wcel cB cc0
    cif cmin co cabs cfv clt cD cD cr wcel cD cc0 cif c2 cdiv opreq1 breq2d
    anbi12d cD cD cr wcel cD cc0 cif cA cc wcel cA cc0 cif cB cc wcel cB cc0
    cif cmin co cabs cfv clt breq2 imbi12d cA cc wcel cA cc0 cif cB cc wcel cB
    cc0 cif cC cc wcel cC cc0 cif cD cr wcel cD cc0 cif cA cc0 cc 0cn elimel cB
    cc0 cc 0cn elimel cC cc0 cc 0cn elimel cD cc0 cr 0re elimel abs3lemi
    dedth4h $.
    $( [2-Oct-1999] $)

  ${
    abslem2.1 $e |- A e. CC $.
    ${
      abslem2i.2 $e |- A =/= 0 $.
      $( Lemma involving absolute values. $)
      abslem2i $p |- ( ( ( * ` ( A / ( abs ` A ) ) ) x. A ) +
      ( ( A / ( abs ` A ) ) x. ( * ` A ) ) ) = ( 2 x. ( abs ` A ) ) $=
        c2 cA cabs cfv cmul co cA cabs cfv cA cabs cfv caddc co cA cA cabs cfv
        cdiv co ccj cfv cA cmul co cA cA cabs cfv cdiv co cA ccj cfv cmul co
        caddc co cA cabs cfv cA cabs cfv cA abslem2.1 abscli recni 2timesi cA
        cabs cfv cA cA cabs cfv cdiv co ccj cfv cA cmul co cA cabs cfv cA cA
        cabs cfv cdiv co cA ccj cfv cmul co caddc cA cabs cfv cA cA cabs cfv
        cdiv co cA ccj cfv cmul co ccj cfv cA cA cabs cfv cdiv co ccj cfv cA
        ccj cfv ccj cfv cmul co cA cA cabs cfv cdiv co ccj cfv cA cmul co cA
        cabs cfv ccj cfv cA cabs cfv cA cA cabs cfv cdiv co cA ccj cfv cmul co
        ccj cfv cA cabs cfv cr wcel cA cabs cfv ccj cfv cA cabs cfv wceq cA
        abslem2.1 abscli cA cabs cfv cA cabs cfv cA abslem2.1 abscli recni
        cjrebi mpbi cA cabs cfv cA cA cabs cfv cdiv co cA ccj cfv cmul co ccj
        cA cabs cfv cA cabs cfv cmul co cA cabs cfv cdiv co cA cA ccj cfv cmul
        co cA cabs cfv cdiv co cA cabs cfv cA cA cabs cfv cdiv co cA ccj cfv
        cmul co cA cabs cfv cA cabs cfv cmul co cA cA ccj cfv cmul co cA cabs
        cfv cdiv cA cabs cfv c2 cexp co cA cabs cfv cA cabs cfv cmul co cA cA
        ccj cfv cmul co cA cabs cfv cA cabs cfv cA abslem2.1 abscli recni
        sqvali cA abslem2.1 absvalsqi eqtr3i opreq1i cA cabs cfv cA cabs cfv cA
        cabs cfv cA abslem2.1 abscli recni cA cabs cfv cA abslem2.1 abscli
        recni cA cabs cfv cc0 wne cA cc0 wne abslem2i.2 cA cabs cfv cc0 cA cc0
        cA abslem2.1 abs00i necon3bii mpbir divcan4i cA cA ccj cfv cA cabs cfv
        abslem2.1 cA abslem2.1 cjcli cA cabs cfv cA abslem2.1 abscli recni cA
        cabs cfv cc0 wne cA cc0 wne abslem2i.2 cA cabs cfv cc0 cA cc0 cA
        abslem2.1 abs00i necon3bii mpbir div23i 3eqtr3i fveq2i eqtr3i cA cA
        cabs cfv cdiv co cA ccj cfv cA cA cabs cfv abslem2.1 cA cabs cfv cA
        abslem2.1 abscli recni cA cabs cfv cc0 wne cA cc0 wne abslem2i.2 cA
        cabs cfv cc0 cA cc0 cA abslem2.1 abs00i necon3bii mpbir divcli cA
        abslem2.1 cjcli cjmuli cA ccj cfv ccj cfv cA cA cA cabs cfv cdiv co ccj
        cfv cmul cA abslem2.1 cjcji opreq2i 3eqtri cA cabs cfv cA cabs cfv cmul
        co cA cabs cfv cdiv co cA cA ccj cfv cmul co cA cabs cfv cdiv co cA
        cabs cfv cA cA cabs cfv cdiv co cA ccj cfv cmul co cA cabs cfv cA cabs
        cfv cmul co cA cA ccj cfv cmul co cA cabs cfv cdiv cA cabs cfv c2 cexp
        co cA cabs cfv cA cabs cfv cmul co cA cA ccj cfv cmul co cA cabs cfv cA
        cabs cfv cA abslem2.1 abscli recni sqvali cA abslem2.1 absvalsqi eqtr3i
        opreq1i cA cabs cfv cA cabs cfv cA cabs cfv cA abslem2.1 abscli recni
        cA cabs cfv cA abslem2.1 abscli recni cA cabs cfv cc0 wne cA cc0 wne
        abslem2i.2 cA cabs cfv cc0 cA cc0 cA abslem2.1 abs00i necon3bii mpbir
        divcan4i cA cA ccj cfv cA cabs cfv abslem2.1 cA abslem2.1 cjcli cA cabs
        cfv cA abslem2.1 abscli recni cA cabs cfv cc0 wne cA cc0 wne abslem2i.2
        cA cabs cfv cc0 cA cc0 cA abslem2.1 abs00i necon3bii mpbir div23i
        3eqtr3i opreq12i eqtr2i $.
        $( [11-Oct-1999] $)
    $}

    $( Lemma involving absolute values. $)
    abslem2 $p |- ( A =/= 0 -> ( ( ( * ` ( A / ( abs ` A ) ) ) x. A ) +
      ( ( A / ( abs ` A ) ) x. ( * ` A ) ) ) = ( 2 x. ( abs ` A ) ) ) $=
      cA cc0 wne cA cA cabs cfv cdiv co ccj cfv cA cmul co cA cA cabs cfv cdiv
      co cA ccj cfv cmul co caddc co c2 cA cabs cfv cmul co wceq cA cc0 wne cA
      c1 cif cA cc0 wne cA c1 cif cabs cfv cdiv co ccj cfv cA cc0 wne cA c1 cif
      cmul co cA cc0 wne cA c1 cif cA cc0 wne cA c1 cif cabs cfv cdiv co cA cc0
      wne cA c1 cif ccj cfv cmul co caddc co c2 cA cc0 wne cA c1 cif cabs cfv
      cmul co wceq cA c1 cA cA cc0 wne cA c1 cif wceq cA cA cabs cfv cdiv co
      ccj cfv cA cmul co cA cA cabs cfv cdiv co cA ccj cfv cmul co caddc co cA
      cc0 wne cA c1 cif cA cc0 wne cA c1 cif cabs cfv cdiv co ccj cfv cA cc0
      wne cA c1 cif cmul co cA cc0 wne cA c1 cif cA cc0 wne cA c1 cif cabs cfv
      cdiv co cA cc0 wne cA c1 cif ccj cfv cmul co caddc co c2 cA cabs cfv cmul
      co c2 cA cc0 wne cA c1 cif cabs cfv cmul co cA cA cc0 wne cA c1 cif wceq
      cA cA cabs cfv cdiv co ccj cfv cA cmul co cA cc0 wne cA c1 cif cA cc0 wne
      cA c1 cif cabs cfv cdiv co ccj cfv cA cc0 wne cA c1 cif cmul co cA cA
      cabs cfv cdiv co cA ccj cfv cmul co cA cc0 wne cA c1 cif cA cc0 wne cA c1
      cif cabs cfv cdiv co cA cc0 wne cA c1 cif ccj cfv cmul co caddc cA cA cc0
      wne cA c1 cif wceq cA cA cabs cfv cdiv co ccj cfv cA cc0 wne cA c1 cif cA
      cc0 wne cA c1 cif cabs cfv cdiv co ccj cfv cA cA cc0 wne cA c1 cif cmul
      cA cA cc0 wne cA c1 cif wceq cA cA cabs cfv cdiv co cA cc0 wne cA c1 cif
      cA cc0 wne cA c1 cif cabs cfv cdiv co ccj cA cA cc0 wne cA c1 cif wceq cA
      cA cc0 wne cA c1 cif cA cabs cfv cA cc0 wne cA c1 cif cabs cfv cdiv cA cA
      cc0 wne cA c1 cif wceq id cA cA cc0 wne cA c1 cif cabs fveq2 opreq12d
      fveq2d cA cA cc0 wne cA c1 cif wceq id opreq12d cA cA cc0 wne cA c1 cif
      wceq cA cA cabs cfv cdiv co cA cc0 wne cA c1 cif cA cc0 wne cA c1 cif
      cabs cfv cdiv co cA ccj cfv cA cc0 wne cA c1 cif ccj cfv cmul cA cA cc0
      wne cA c1 cif wceq cA cA cc0 wne cA c1 cif cA cabs cfv cA cc0 wne cA c1
      cif cabs cfv cdiv cA cA cc0 wne cA c1 cif wceq id cA cA cc0 wne cA c1 cif
      cabs fveq2 opreq12d cA cA cc0 wne cA c1 cif ccj fveq2 opreq12d opreq12d
      cA cA cc0 wne cA c1 cif wceq cA cabs cfv cA cc0 wne cA c1 cif cabs cfv c2
      cmul cA cA cc0 wne cA c1 cif cabs fveq2 opreq2d eqeq12d cA cc0 wne cA c1
      cif cA cc0 wne cA c1 cc abslem2.1 ax1cn keepel cA elimne0 abslem2i dedth
      $.
      $( [11-Oct-1999] $)
  $}

  ${
    $d x y z A $.  $d x y z w F $.
    seq1bnd.1 $e |- F : NN --> CC $.
    $( An initial segment of an infinite sequence of complex numbers is
       bounded. $)
    seq1bndi $p |- ( A e. NN -> E. x e. RR A. y e. NN ( y <_ A ->
                 ( abs ` ( F ` y ) ) < x ) ) $=
      vy cv vz cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vx
      cr wrex vy cv c1 cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn
      wral vx cr wrex vy cv vw cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr
      wi vy cn wral vx cr wrex vy cv vw cv c1 caddc co cle wbr vy cv cF cfv
      cabs cfv vx cv clt wbr wi vy cn wral vx cr wrex vy cv cA cle wbr vy cv cF
      cfv cabs cfv vx cv clt wbr wi vy cn wral vx cr wrex vz vw cA vz cv c1
      wceq vy cv vz cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cv c1
      cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vx vy cr cn vz cv c1 wceq
      vy cv vz cv cle wbr vy cv c1 cle wbr vy cv cF cfv cabs cfv vx cv clt wbr
      vz cv c1 vy cv cle breq2 imbi1d rexralbidv vz cv vw cv wceq vy cv vz cv
      cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cv vw cv cle wbr vy cv
      cF cfv cabs cfv vx cv clt wbr wi vx vy cr cn vz cv vw cv wceq vy cv vz cv
      cle wbr vy cv vw cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr vz cv vw
      cv vy cv cle breq2 imbi1d rexralbidv vz cv vw cv c1 caddc co wceq vy cv
      vz cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cv vw cv c1 caddc
      co cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vx vy cr cn vz cv vw cv
      c1 caddc co wceq vy cv vz cv cle wbr vy cv vw cv c1 caddc co cle wbr vy
      cv cF cfv cabs cfv vx cv clt wbr vz cv vw cv c1 caddc co vy cv cle breq2
      imbi1d rexralbidv vz cv cA wceq vy cv vz cv cle wbr vy cv cF cfv cabs cfv
      vx cv clt wbr wi vy cv cA cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi
      vx vy cr cn vz cv cA wceq vy cv vz cv cle wbr vy cv cA cle wbr vy cv cF
      cfv cabs cfv vx cv clt wbr vz cv cA vy cv cle breq2 imbi1d rexralbidv c1
      cF cfv cabs cfv c1 caddc co cr wcel vy cv c1 cle wbr vy cv cF cfv cabs
      cfv c1 cF cfv cabs cfv c1 caddc co clt wbr wi vy cn wral vy cv c1 cle wbr
      vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vx cr wrex c1 cF cfv
      cabs cfv c1 c1 cF cfv cn cc cF wf c1 cn wcel c1 cF cfv cc wcel seq1bnd.1
      1nn cn cc c1 cF ffvelrn mp2an abscli 1re readdcli vy cv c1 cle wbr vy cv
      cF cfv cabs cfv c1 cF cfv cabs cfv c1 caddc co clt wbr wi vy cn vy cv cn
      wcel vy cv c1 cle wbr vy cv c1 wceq vy cv cF cfv cabs cfv c1 cF cfv cabs
      cfv c1 caddc co clt wbr vy cv nnle1eq1 vy cv c1 wceq vy cv cF cfv cabs
      cfv c1 cF cfv cabs cfv c1 cF cfv cabs cfv c1 caddc co clt vy cv c1 wceq
      vy cv cF cfv c1 cF cfv cabs vy cv c1 cF fveq2 fveq2d c1 cF cfv cabs cfv
      c1 cF cfv cn cc cF wf c1 cn wcel c1 cF cfv cc wcel seq1bnd.1 1nn cn cc c1
      cF ffvelrn mp2an abscli ltp1i syl6eqbr syl6bi rgen vy cv c1 cle wbr vy cv
      cF cfv cabs cfv vx cv clt wbr wi vy cn wral vy cv c1 cle wbr vy cv cF cfv
      cabs cfv c1 cF cfv cabs cfv c1 caddc co clt wbr wi vy cn wral vx c1 cF
      cfv cabs cfv c1 caddc co cr vx cv c1 cF cfv cabs cfv c1 caddc co wceq vy
      cv c1 cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cv c1 cle wbr vy
      cv cF cfv cabs cfv c1 cF cfv cabs cfv c1 caddc co clt wbr wi vy cn vx cv
      c1 cF cfv cabs cfv c1 caddc co wceq vy cv cF cfv cabs cfv vx cv clt wbr
      vy cv cF cfv cabs cfv c1 cF cfv cabs cfv c1 caddc co clt wbr vy cv c1 cle
      wbr vx cv c1 cF cfv cabs cfv c1 caddc co vy cv cF cfv cabs cfv clt breq2
      imbi2d ralbidv rcla4ev mp2an vw cv cn wcel vy cv vw cv cle wbr vy cv cF
      cfv cabs cfv vz cv clt wbr wi vy cn wral vz cr wrex vy cv vw cv c1 caddc
      co cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vx cr wrex
      vy cv vw cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vx
      cr wrex vw cv cn wcel vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt
      wbr wi vy cn wral vy cv vw cv c1 caddc co cle wbr vy cv cF cfv cabs cfv
      vx cv clt wbr wi vy cn wral vx cr wrex vz cr vw cv cn wcel vz cv cr wcel
      wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi vy cn wral
      vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1
      caddc co cF cfv cabs cfv c1 caddc co vz cv cif cr wcel vy cv vw cv c1
      caddc co cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc
      co vz cv cif clt wbr wi vy cn wral wa vy cv vw cv c1 caddc co cle wbr vy
      cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vx cr wrex vw cv cn wcel
      vz cv cr wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr
      wi vy cn wral vy cv vw cv c1 caddc co cle wbr vy cv cF cfv cabs cfv vz cv
      vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co
      cF cfv cabs cfv c1 caddc co vz cv cif clt wbr wi vy cn wral vz cv vw cv
      c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co vz cv cif cr wcel vw cv cn wcel vz cv cr wcel wa vy
      cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi vy cv vw cv c1
      caddc co cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc
      co vz cv cif clt wbr wi vy cn vw cv cn wcel vz cv cr wcel wa vy cv cn
      wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi vy cv
      vw cv c1 caddc co cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co
      cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co vz cv cif clt wbr wi vw cv cn wcel vz cv cr wcel wa vy cv cn
      wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi wa vy
      cv vw cv c1 caddc co cle wbr vy cv vw cv cle wbr vy cv vw cv c1 caddc co
      wceq wo vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif
      clt wbr vw cv cn wcel vz cv cr wcel wa vy cv cn wcel wa vy cv vw cv c1
      caddc co cle wbr vy cv vw cv cle wbr vy cv vw cv c1 caddc co wceq wo wb
      vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi vw cv cn wcel
      vy cv cn wcel vy cv vw cv c1 caddc co cle wbr vy cv vw cv cle wbr vy cv
      vw cv c1 caddc co wceq wo wb vz cv cr wcel vy cv cn wcel vw cv cn wcel vy
      cv vw cv c1 caddc co cle wbr vy cv vw cv cle wbr vy cv vw cv c1 caddc co
      wceq wo wb vy cv cn wcel vw cv cn wcel wa vy cv vw cv c1 caddc co cle wbr
      vy cv vw cv c1 caddc co clt wbr vy cv vw cv c1 caddc co wceq wo vy cv vw
      cv cle wbr vy cv vw cv c1 caddc co wceq wo vy cv cr wcel vw cv c1 caddc
      co cr wcel vy cv vw cv c1 caddc co cle wbr vy cv vw cv c1 caddc co clt
      wbr vy cv vw cv c1 caddc co wceq wo wb vy cv cn wcel vw cv cn wcel vy cv
      vw cv c1 caddc co leloe vy cv nnre vw cv cn wcel vw cv c1 caddc co cn
      wcel vw cv c1 caddc co cr wcel vw cv peano2nn vw cv c1 caddc co nnre syl
      syl2an vy cv cn wcel vw cv cn wcel wa vy cv vw cv cle wbr vy cv vw cv c1
      caddc co clt wbr vy cv vw cv c1 caddc co wceq vy cv vw cv nnleltp1 orbi1d
      bitr4d ancoms adantlr adantr vw cv cn wcel vz cv cr wcel wa vy cv cn wcel
      wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi wa vy cv vw
      cv cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF cfv cabs cfv
      c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv
      cif clt wbr vy cv vw cv c1 caddc co wceq vw cv cn wcel vz cv cr wcel wa
      vy cv cn wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv clt wbr
      wi vy cv vw cv cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co vz cv cif clt wbr wi vw cv cn wcel vz cv cr wcel wa vy cv cn
      wcel wa vy cv cF cfv cabs cfv vz cv clt wbr vy cv cF cfv cabs cfv vz cv
      vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co
      cF cfv cabs cfv c1 caddc co vz cv cif clt wbr vy cv vw cv cle wbr vw cv
      cn wcel vz cv cr wcel wa vy cv cn wcel wa vy cv cF cfv cabs cfv vz cv clt
      wbr vz cv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif cle wbr vy cv cF cfv
      cabs cfv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif clt wbr vz cv cr
      wcel vz cv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif cle wbr vw cv cn
      wcel vy cv cn wcel vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co
      max1ALT ad2antlr vy cv cF cfv cabs cfv cr wcel vz cv cr wcel vz cv vw cv
      c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co vz cv cif cr wcel vy cv cF cfv cabs cfv vz cv clt
      wbr vz cv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif cle wbr wa vy cv cF
      cfv cabs cfv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr
      vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif clt wbr wi vw cv
      cn wcel vz cv cr wcel wa vy cv cn wcel wa vy cv cF cfv cabs cfv vz cv vz
      cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc
      co cF cfv cabs cfv c1 caddc co vz cv cif ltletr vy cv cn wcel vy cv cF
      cfv cabs cfv cr wcel vw cv cn wcel vz cv cr wcel wa vy cv cn wcel vy cv
      cF cfv cc wcel vy cv cF cfv cabs cfv cr wcel cn cc vy cv cF seq1bnd.1
      ffvelrni vy cv cF cfv abscl syl adantl vw cv cn wcel vz cv cr wcel vy cv
      cn wcel simplr vw cv cn wcel vz cv cr wcel wa vz cv vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co vz cv cif cr wcel vy cv cn wcel vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cr wcel vz cv cr wcel vz cv vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz
      cv cif cr wcel vw cv cn wcel vz cv vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cr
      ifcl vw cv cn wcel vw cv c1 caddc co cF cfv cc wcel vw cv c1 caddc co cF
      cfv cabs cfv cr wcel vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cr
      wcel vw cv cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cF cfv cc
      wcel vw cv peano2nn cn cc vw cv c1 caddc co cF seq1bnd.1 ffvelrni syl vw
      cv c1 caddc co cF cfv abscl vw cv c1 caddc co cF cfv cabs cfv peano2re
      3syl sylan adantr syl3anc mpan2d imim2d imp vw cv cn wcel vz cv cr wcel
      wa vy cv cn wcel wa vy cv vw cv c1 caddc co wceq vy cv cF cfv cabs cfv vz
      cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc
      co cF cfv cabs cfv c1 caddc co vz cv cif clt wbr wi vy cv vw cv cle wbr
      vy cv cF cfv cabs cfv vz cv clt wbr wi vw cv cn wcel vz cv cr wcel wa vy
      cv cn wcel wa vy cv vw cv c1 caddc co wceq vy cv cF cfv cabs cfv vw cv c1
      caddc co cF cfv cabs cfv c1 caddc co clt wbr vy cv cF cfv cabs cfv vz cv
      vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co
      cF cfv cabs cfv c1 caddc co vz cv cif clt wbr vw cv cn wcel vy cv vw cv
      c1 caddc co wceq vy cv cF cfv cabs cfv vw cv c1 caddc co cF cfv cabs cfv
      c1 caddc co clt wbr wi vz cv cr wcel vy cv cn wcel vy cv vw cv c1 caddc
      co wceq vy cv cF cfv cabs cfv vw cv c1 caddc co cF cfv cabs cfv c1 caddc
      co clt wbr vw cv c1 caddc co cF cfv cabs cfv vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co clt wbr vw cv cn wcel vy cv vw cv c1 caddc co wceq
      vy cv cF cfv cabs cfv vw cv c1 caddc co cF cfv cabs cfv vw cv c1 caddc co
      cF cfv cabs cfv c1 caddc co clt vy cv vw cv c1 caddc co wceq vy cv cF cfv
      vw cv c1 caddc co cF cfv cabs vy cv vw cv c1 caddc co cF fveq2 fveq2d
      breq1d vw cv cn wcel vw cv c1 caddc co cF cfv cc wcel vw cv c1 caddc co
      cF cfv cabs cfv cr wcel vw cv c1 caddc co cF cfv cabs cfv vw cv c1 caddc
      co cF cfv cabs cfv c1 caddc co clt wbr vw cv cn wcel vw cv c1 caddc co cn
      wcel vw cv c1 caddc co cF cfv cc wcel vw cv peano2nn cn cc vw cv c1 caddc
      co cF seq1bnd.1 ffvelrni syl vw cv c1 caddc co cF cfv abscl vw cv c1
      caddc co cF cfv cabs cfv ltp1 3syl syl5cbir ad2antrr vw cv cn wcel vz cv
      cr wcel wa vy cv cn wcel wa vy cv cF cfv cabs cfv vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co clt wbr vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif cle wbr vy cv cF cfv
      cabs cfv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif clt wbr vw cv cn
      wcel vz cv cr wcel wa vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv
      vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co
      cF cfv cabs cfv c1 caddc co vz cv cif cle wbr vy cv cn wcel vz cv cr wcel
      vw cv cn wcel vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv vw cv
      c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co vz cv cif cle wbr vz cv cr wcel vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co cr wcel vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif cle wbr vw cv cn
      wcel vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co max2 vw cv cn
      wcel vw cv c1 caddc co cF cfv cc wcel vw cv c1 caddc co cF cfv cabs cfv
      cr wcel vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cr wcel vw cv cn
      wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cF cfv cc wcel vw cv
      peano2nn cn cc vw cv c1 caddc co cF seq1bnd.1 ffvelrni syl vw cv c1 caddc
      co cF cfv abscl vw cv c1 caddc co cF cfv cabs cfv peano2re 3syl sylan2
      ancoms adantr vy cv cF cfv cabs cfv cr wcel vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cr wcel vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc
      co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif cr
      wcel vy cv cF cfv cabs cfv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co
      clt wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv vw cv c1
      caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co vz cv cif cle wbr wa vy cv cF cfv cabs cfv vz cv vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co vz cv cif clt wbr wi vw cv cn wcel vz cv cr wcel
      wa vy cv cn wcel wa vy cv cF cfv cabs cfv vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle
      wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif ltletr vy cv
      cn wcel vy cv cF cfv cabs cfv cr wcel vw cv cn wcel vz cv cr wcel wa vy
      cv cn wcel vy cv cF cfv cc wcel vy cv cF cfv cabs cfv cr wcel cn cc vy cv
      cF seq1bnd.1 ffvelrni vy cv cF cfv abscl syl adantl vw cv cn wcel vw cv
      c1 caddc co cF cfv cabs cfv c1 caddc co cr wcel vz cv cr wcel vy cv cn
      wcel vw cv cn wcel vw cv c1 caddc co cF cfv cc wcel vw cv c1 caddc co cF
      cfv cabs cfv cr wcel vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cr
      wcel vw cv cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cF cfv cc
      wcel vw cv peano2nn cn cc vw cv c1 caddc co cF seq1bnd.1 ffvelrni syl vw
      cv c1 caddc co cF cfv abscl vw cv c1 caddc co cF cfv cabs cfv peano2re
      3syl ad2antrr vw cv cn wcel vz cv cr wcel wa vz cv vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co vz cv cif cr wcel vy cv cn wcel vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cr wcel vz cv cr wcel vz cv vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz
      cv cif cr wcel vw cv cn wcel vz cv vw cv c1 caddc co cF cfv cabs cfv c1
      caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cr
      ifcl vw cv cn wcel vw cv c1 caddc co cF cfv cc wcel vw cv c1 caddc co cF
      cfv cabs cfv cr wcel vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cr
      wcel vw cv cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cF cfv cc
      wcel vw cv peano2nn cn cc vw cv c1 caddc co cF seq1bnd.1 ffvelrni syl vw
      cv c1 caddc co cF cfv abscl vw cv c1 caddc co cF cfv cabs cfv peano2re
      3syl sylan adantr syl3anc mpan2d syld adantr jaod sylbid ex r19.20dva vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co cr wcel vz cv cr wcel vz cv vw
      cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co vz cv cif cr wcel vw cv cn wcel vz cv vw cv c1
      caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co vz cv cr ifcl vw cv cn wcel vw cv c1 caddc co cF cfv
      cc wcel vw cv c1 caddc co cF cfv cabs cfv cr wcel vw cv c1 caddc co cF
      cfv cabs cfv c1 caddc co cr wcel vw cv cn wcel vw cv c1 caddc co cn wcel
      vw cv c1 caddc co cF cfv cc wcel vw cv peano2nn cn cc vw cv c1 caddc co
      cF seq1bnd.1 ffvelrni syl vw cv c1 caddc co cF cfv abscl vw cv c1 caddc
      co cF cfv cabs cfv peano2re 3syl sylan jctild vy cv vw cv c1 caddc co cle
      wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vy cv vw cv c1
      caddc co cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc
      co vz cv cif clt wbr wi vy cn wral vx vz cv vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz
      cv cif cr vx cv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle
      wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif wceq vy cv vw
      cv c1 caddc co cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cv vw cv
      c1 caddc co cle wbr vy cv cF cfv cabs cfv vz cv vw cv c1 caddc co cF cfv
      cabs cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc
      co vz cv cif clt wbr wi vy cn vx cv vz cv vw cv c1 caddc co cF cfv cabs
      cfv c1 caddc co cle wbr vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz
      cv cif wceq vy cv cF cfv cabs cfv vx cv clt wbr vy cv cF cfv cabs cfv vz
      cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr vw cv c1 caddc
      co cF cfv cabs cfv c1 caddc co vz cv cif clt wbr vy cv vw cv c1 caddc co
      cle wbr vx cv vz cv vw cv c1 caddc co cF cfv cabs cfv c1 caddc co cle wbr
      vw cv c1 caddc co cF cfv cabs cfv c1 caddc co vz cv cif vy cv cF cfv cabs
      cfv clt breq2 imbi2d ralbidv rcla4ev syl6 r19.23adva vy cv vw cv cle wbr
      vy cv cF cfv cabs cfv vx cv clt wbr wi vy cn wral vy cv vw cv cle wbr vy
      cv cF cfv cabs cfv vz cv clt wbr wi vy cn wral vx vz cr vx cv vz cv wceq
      vy cv vw cv cle wbr vy cv cF cfv cabs cfv vx cv clt wbr wi vy cv vw cv
      cle wbr vy cv cF cfv cabs cfv vz cv clt wbr wi vy cn vx cv vz cv wceq vy
      cv cF cfv cabs cfv vx cv clt wbr vy cv cF cfv cabs cfv vz cv clt wbr vy
      cv vw cv cle wbr vx cv vz cv vy cv cF cfv cabs cfv clt breq2 imbi2d
      ralbidv cbvrexv syl5ib nnind $.
      $( [22-Apr-2005] $) $( [3-Apr-2005] $)
  $}

  ${
    $d y A $.  $d x y z w v B $.  $d y z w v F $.
    seq1ub.1 $e |- F : NN --> RR $.
    $( Lemma for ~ seq1ubi . $)
    seq1ublem $p |- ( B e. NN -> ( ran ( F |` { x e. NN | x <_ B } ) C_ RR /\
        ran ( F |` { x e. NN | x <_ B } ) =/= (/) /\
        E. y e. RR A. z e. ran ( F |` { x e. NN | x <_ B } ) z <_ y ) ) $=
      cB cn wcel cF vx cv cB cle wbr vx cn crab cres crn cr wss cF vx cv cB cle
      wbr vx cn crab cres crn c0 wne vz cv vy cv cle wbr vz cF vx cv cB cle wbr
      vx cn crab cres crn wral vy cr wrex cF vx cv cB cle wbr vx cn crab cres
      crn cr wss cB cn wcel vx cv cB cle wbr vx cn crab cr cF vx cv cB cle wbr
      vx cn crab cres wf cF vx cv cB cle wbr vx cn crab cres crn cr wss cn cr
      cF wf vx cv cB cle wbr vx cn crab cn wss vx cv cB cle wbr vx cn crab cr
      cF vx cv cB cle wbr vx cn crab cres wf seq1ub.1 vx cv cB cle wbr vx cn
      ssrab2 cn cr vx cv cB cle wbr vx cn crab cF fssres mp2an vx cv cB cle wbr
      vx cn crab cr cF vx cv cB cle wbr vx cn crab cres frn ax-mp a1i cB cn
      wcel c1 cF vx cv cB cle wbr vx cn crab cres cfv cF vx cv cB cle wbr vx cn
      crab cres crn wcel cF vx cv cB cle wbr vx cn crab cres crn c0 wne cF vx
      cv cB cle wbr vx cn crab cres vx cv cB cle wbr vx cn crab wfn c1 vx cv cB
      cle wbr vx cn crab wcel c1 cF vx cv cB cle wbr vx cn crab cres cfv cF vx
      cv cB cle wbr vx cn crab cres crn wcel cB cn wcel vx cv cB cle wbr vx cn
      crab c1 cF vx cv cB cle wbr vx cn crab cres fnfvelrn cF cn wfn vx cv cB
      cle wbr vx cn crab cn wss cF vx cv cB cle wbr vx cn crab cres vx cv cB
      cle wbr vx cn crab wfn cn cr cF wf cF cn wfn seq1ub.1 cn cr cF ffn ax-mp
      vx cv cB cle wbr vx cn ssrab2 cn vx cv cB cle wbr vx cn crab cF fnssres
      mp2an cB cn wcel c1 cn wcel c1 cB cle wbr wa c1 vx cv cB cle wbr vx cn
      crab wcel cB cn wcel c1 cB cle wbr c1 cn wcel cB nnge1 1nn jctil vx cv cB
      cle wbr c1 cB cle wbr vx c1 cn vx cv c1 cB cle breq1 elrab sylibr sylancr
      cF vx cv cB cle wbr vx cn crab cres crn c1 cF vx cv cB cle wbr vx cn crab
      cres cfv ne0i syl cB cn wcel vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv
      clt wbr wi vw cn wral vy cr wrex vz cv vy cv cle wbr vz cF vx cv cB cle
      wbr vx cn crab cres crn wral vy cr wrex vy vw cB cF cn cr cF wf cr cc wss
      cn cc cF wf seq1ub.1 axresscn cn cr cc cF fss mp2an seq1bndi vw cv cB cle
      wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral vz cv vy cv cle wbr
      vz cF vx cv cB cle wbr vx cn crab cres crn wral vy cr vy cv cr wcel vw cv
      cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral vz cv vy cv
      cle wbr vz cF vx cv cB cle wbr vx cn crab cres crn vy cv cr wcel vw cv cB
      cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral vz cv cF vx cv
      cB cle wbr vx cn crab cres crn wcel vz cv vy cv cle wbr wi vy cv cr wcel
      vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral wa vv
      cv cF vx cv cB cle wbr vx cn crab cres cfv vz cv wceq vv vx cv cB cle wbr
      vx cn crab wrex vz cv vy cv cle wbr vz cv cF vx cv cB cle wbr vx cn crab
      cres crn wcel vy cv cr wcel vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv
      clt wbr wi vw cn wral wa vv cv cF vx cv cB cle wbr vx cn crab cres cfv vz
      cv wceq vz cv vy cv cle wbr vv vx cv cB cle wbr vx cn crab vy cv cr wcel
      vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral wa vv
      cv cn wcel vv cv cB cle wbr wa vv cv cF vx cv cB cle wbr vx cn crab cres
      cfv vz cv wceq vz cv vy cv cle wbr wi vv cv vx cv cB cle wbr vx cn crab
      wcel vy cv cr wcel vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr
      wi vw cn wral wa vv cv cn wcel vv cv cB cle wbr wa vv cv cF vx cv cB cle
      wbr vx cn crab cres cfv vz cv wceq vz cv vy cv cle wbr vy cv cr wcel vw
      cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral wa vv cv
      cn wcel vv cv cB cle wbr wa wa vv cv cF vx cv cB cle wbr vx cn crab cres
      cfv vz cv wceq wa vv cv cF cfv cabs cfv vy cv clt wbr vz cv vy cv cle wbr
      vy cv cr wcel vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw
      cn wral wa vv cv cn wcel vv cv cB cle wbr wa wa vv cv cF cfv cabs cfv vy
      cv clt wbr vv cv cF vx cv cB cle wbr vx cn crab cres cfv vz cv wceq vw cv
      cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral vv cv cn
      wcel vv cv cB cle wbr wa vv cv cF cfv cabs cfv vy cv clt wbr vy cv cr
      wcel vw cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vw cn wral
      vv cv cn wcel vv cv cB cle wbr vv cv cF cfv cabs cfv vy cv clt wbr vw cv
      cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr wi vv cv cB cle wbr vv cv
      cF cfv cabs cfv vy cv clt wbr wi vw vv cv cn vw cv vv cv wceq vw cv cB
      cle wbr vv cv cB cle wbr vw cv cF cfv cabs cfv vy cv clt wbr vv cv cF cfv
      cabs cfv vy cv clt wbr vw cv vv cv cB cle breq1 vw cv vv cv wceq vw cv cF
      cfv cabs cfv vv cv cF cfv cabs cfv vy cv clt vw cv vv cv wceq vw cv cF
      cfv vv cv cF cfv cabs vw cv vv cv cF fveq2 fveq2d breq1d imbi12d rcla4cv
      imp32 adantll adantr vy cv cr wcel vv cv cn wcel vv cv cB cle wbr wa vv
      cv cF vx cv cB cle wbr vx cn crab cres cfv vz cv wceq vv cv cF cfv cabs
      cfv vy cv clt wbr vz cv vy cv cle wbr wi vw cv cB cle wbr vw cv cF cfv
      cabs cfv vy cv clt wbr wi vw cn wral vy cv cr wcel vv cv cn wcel vv cv cB
      cle wbr wa wa vv cv cF cfv cabs cfv vy cv clt wbr vv cv cF vx cv cB cle
      wbr vx cn crab cres cfv vy cv cle wbr vv cv cF vx cv cB cle wbr vx cn
      crab cres cfv vz cv wceq vz cv vy cv cle wbr vy cv cr wcel vv cv cn wcel
      vv cv cB cle wbr wa wa vv cv cF cfv cabs cfv vy cv clt wbr vv cv cF cfv
      vy cv cle wbr vv cv cF vx cv cB cle wbr vx cn crab cres cfv vy cv cle wbr
      vy cv cr wcel vv cv cn wcel vv cv cF cfv cabs cfv vy cv clt wbr vv cv cF
      cfv vy cv cle wbr wi vv cv cB cle wbr vv cv cn wcel vy cv cr wcel vv cv
      cF cfv cabs cfv vy cv clt wbr vv cv cF cfv vy cv cle wbr wi vv cv cF cfv
      cr wcel vy cv cr wcel vv cv cF cfv cabs cfv vy cv clt wbr vv cv cF cfv vy
      cv cle wbr wi vv cv cn wcel vv cv cF cfv cr wcel vy cv cr wcel wa vv cv
      cF cfv cabs cfv vy cv clt wbr vv cv cF cfv vy cv clt wbr vv cv cF cfv vy
      cv cle wbr vv cv cF cfv cr wcel vy cv cr wcel wa vv cv cF cfv vv cv cF
      cfv cabs cfv cle wbr vv cv cF cfv cabs cfv vy cv clt wbr vv cv cF cfv vy
      cv clt wbr vv cv cF cfv cr wcel vv cv cF cfv vv cv cF cfv cabs cfv cle
      wbr vy cv cr wcel vv cv cF cfv leabs adantr vv cv cF cfv cr wcel vv cv cF
      cfv cabs cfv cr wcel wa vy cv cr wcel vv cv cF cfv vv cv cF cfv cabs cfv
      cle wbr vv cv cF cfv cabs cfv vy cv clt wbr wa vv cv cF cfv vy cv clt wbr
      wi vv cv cF cfv cr wcel vv cv cF cfv cr wcel vv cv cF cfv cabs cfv cr
      wcel vy cv cr wcel vv cv cF cfv vv cv cF cfv cabs cfv cle wbr vv cv cF
      cfv cabs cfv vy cv clt wbr wa vv cv cF cfv vy cv clt wbr wi vv cv cF cfv
      vv cv cF cfv cabs cfv vy cv lelttr 3expa vv cv cF cfv cr wcel vv cv cF
      cfv cabs cfv cr wcel vv cv cF cfv cr wcel vv cv cF cfv cc wcel vv cv cF
      cfv cabs cfv cr wcel vv cv cF cfv recn vv cv cF cfv abscl syl ancli sylan
      mpand vv cv cF cfv vy cv ltle syld cn cr vv cv cF seq1ub.1 ffvelrni sylan
      ancoms adantrr vv cv cn wcel vv cv cB cle wbr wa vv cv cF vx cv cB cle
      wbr vx cn crab cres cfv vy cv cle wbr vv cv cF cfv vy cv cle wbr wb vy cv
      cr wcel vv cv cn wcel vv cv cB cle wbr wa vv cv cF vx cv cB cle wbr vx cn
      crab cres cfv vv cv cF cfv vy cv cle vv cv cn wcel vv cv cB cle wbr wa vv
      cv vx cv cB cle wbr vx cn crab wcel vv cv cF vx cv cB cle wbr vx cn crab
      cres cfv vv cv cF cfv wceq vx cv cB cle wbr vv cv cB cle wbr vx vv cv cn
      vx cv vv cv cB cle breq1 elrab vv cv vx cv cB cle wbr vx cn crab cF fvres
      sylbir breq1d adantl sylibrd vv cv cF vx cv cB cle wbr vx cn crab cres
      cfv vz cv wceq vv cv cF vx cv cB cle wbr vx cn crab cres cfv vy cv cle
      wbr vz cv vy cv cle wbr vv cv cF vx cv cB cle wbr vx cn crab cres cfv vz
      cv vy cv cle breq1 biimpd sylan9 adantllr mpd exp31 vx cv cB cle wbr vv
      cv cB cle wbr vx vv cv cn vx cv vv cv cB cle breq1 elrab syl5ib r19.23adv
      cF vx cv cB cle wbr vx cn crab cres vx cv cB cle wbr vx cn crab wfn vz cv
      cF vx cv cB cle wbr vx cn crab cres crn wcel vv cv cF vx cv cB cle wbr vx
      cn crab cres cfv vz cv wceq vv vx cv cB cle wbr vx cn crab wrex wb cF cn
      wfn vx cv cB cle wbr vx cn crab cn wss cF vx cv cB cle wbr vx cn crab
      cres vx cv cB cle wbr vx cn crab wfn cn cr cF wf cF cn wfn seq1ub.1 cn cr
      cF ffn ax-mp vx cv cB cle wbr vx cn ssrab2 cn vx cv cB cle wbr vx cn crab
      cF fnssres mp2an vv vx cv cB cle wbr vx cn crab vz cv cF vx cv cB cle wbr
      vx cn crab cres fvelrnb ax-mp syl5ib ex r19.21adv r19.22i syl 3jca $.
      $( [17-Jun-2007] $) $( [20-Apr-2005] $)

    $( An upper bound for an initial segment of a sequence of reals. $)
    seq1ubi $p |- ( ( A e. NN /\ B e. NN /\ A <_ B ) ->
           ( F ` A ) <_ sup ( ran ( F |` { x e. NN | x <_ B } ) , RR , < ) ) $=
      cF vx cv cB cle wbr vx cn crab cres crn cr wss cF vx cv cB cle wbr vx cn
      crab cres crn c0 wne vz cv vy cv cle wbr vz cF vx cv cB cle wbr vx cn
      crab cres crn wral vy cr wrex w3a cA cF cfv cF vx cv cB cle wbr vx cn
      crab cres crn wcel cA cF cfv cF vx cv cB cle wbr vx cn crab cres crn cr
      clt csup cle wbr cA cn wcel cB cn wcel cA cB cle wbr w3a vy vz cF vx cv
      cB cle wbr vx cn crab cres crn cA cF cfv suprub cB cn wcel cA cn wcel cF
      vx cv cB cle wbr vx cn crab cres crn cr wss cF vx cv cB cle wbr vx cn
      crab cres crn c0 wne vz cv vy cv cle wbr vz cF vx cv cB cle wbr vx cn
      crab cres crn wral vy cr wrex w3a cA cB cle wbr vx vy vz cB cF seq1ub.1
      seq1ublem 3ad2ant2 cA cn wcel cA cB cle wbr cA cF cfv cF vx cv cB cle wbr
      vx cn crab cres crn wcel cB cn wcel cA cn wcel cA cB cle wbr wa cA cF vx
      cv cB cle wbr vx cn crab cres cfv cA cF cfv cF vx cv cB cle wbr vx cn
      crab cres crn cA cn wcel cA cB cle wbr wa cA vx cv cB cle wbr vx cn crab
      wcel cA cF vx cv cB cle wbr vx cn crab cres cfv cA cF cfv wceq vy cv cB
      cle wbr cA cB cle wbr vy cA cn vx cv cB cle wbr vx cn crab vy cv cA cB
      cle breq1 vx cv cB cle wbr vy cv cB cle wbr vx vy cn vx cv vy cv cB cle
      breq1 cbvrabv elrab2 cA vx cv cB cle wbr vx cn crab cF fvres sylbir cF vx
      cv cB cle wbr vx cn crab cres vx cv cB cle wbr vx cn crab wfn cA vx cv cB
      cle wbr vx cn crab wcel cA cF vx cv cB cle wbr vx cn crab cres cfv cF vx
      cv cB cle wbr vx cn crab cres crn wcel cA cn wcel cA cB cle wbr wa vx cv
      cB cle wbr vx cn crab cA cF vx cv cB cle wbr vx cn crab cres fnfvelrn cF
      cn wfn vx cv cB cle wbr vx cn crab cn wss cF vx cv cB cle wbr vx cn crab
      cres vx cv cB cle wbr vx cn crab wfn cn cr cF wf cF cn wfn seq1ub.1 cn cr
      cF ffn ax-mp vx cv cB cle wbr vx cn ssrab2 cn vx cv cB cle wbr vx cn crab
      cF fnssres mp2an cA vx cv cB cle wbr vx cn crab wcel cA cn wcel cA cB cle
      wbr wa vy cv cB cle wbr cA cB cle wbr vy cA cn vx cv cB cle wbr vx cn
      crab vy cv cA cB cle breq1 vx cv cB cle wbr vy cv cB cle wbr vx vy cn vx
      cv vy cv cB cle breq1 cbvrabv elrab2 biimpri sylancr eqeltrrd 3adant2
      sylanc $.
      $( [24-Apr-2005] $) $( [20-Apr-2005] $)
  $}

  ${
    $d x y z $.  $d y z R $.
    cau2.1 $e |- F : NN --> CC $.
    cau2.2 $e |- ( x e. RR -> ( 0 < x -> 0 R x ) ) $.
    $( Two ways to express that a sequence meets the Cauchy criterion.  Remark
       in [Gleason] p. 181.  ` R ` can be either ` < ` or ` <_ ` . $)
    cau2i $p |- ( A. x e. RR ( 0 < x -> E. y e. NN A. z e. NN ( y < z ->
                      ( abs ` ( ( F ` z ) - ( F ` y ) ) ) R x ) ) <->
                    A. x e. RR ( 0 < x -> E. y e. NN A. z e. NN ( y <_ z ->
                      ( abs ` ( ( F ` z ) - ( F ` y ) ) ) R x ) ) ) $=
      cc0 vx cv clt wbr vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv cmin co
      cabs cfv vx cv cR wbr wi vz cn wral vy cn wrex wi cc0 vx cv clt wbr vy cv
      vz cv cle wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi
      vz cn wral vy cn wrex wi vx cr vx cv cr wcel cc0 vx cv clt wbr vy cv vz
      cv clt wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi vz
      cn wral vy cn wrex vy cv vz cv cle wbr vz cv cF cfv vy cv cF cfv cmin co
      cabs cfv vx cv cR wbr wi vz cn wral vy cn wrex vx cv cr wcel cc0 vx cv
      clt wbr wa vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv
      vx cv cR wbr wi vz cn wral vy cv vz cv cle wbr vz cv cF cfv vy cv cF cfv
      cmin co cabs cfv vx cv cR wbr wi vz cn wral vy cn vx cv cr wcel cc0 vx cv
      clt wbr wa vy cv cn wcel wa vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv
      cmin co cabs cfv vx cv cR wbr wi vy cv vz cv cle wbr vz cv cF cfv vy cv
      cF cfv cmin co cabs cfv vx cv cR wbr wi vz cn vx cv cr wcel cc0 vx cv clt
      wbr wa vy cv cn wcel wa vz cv cn wcel wa vy cv vz cv clt wbr vz cv cF cfv
      vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi vy cv vz cv clt wbr vy cv
      vz cv wceq wo vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi
      vy cv vz cv cle wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv cR
      wbr wi vx cv cr wcel cc0 vx cv clt wbr wa vy cv cn wcel wa vz cv cn wcel
      wa vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv
      cR wbr wi vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv
      vx cv cR wbr wi vy cv vz cv wceq vz cv cF cfv vy cv cF cfv cmin co cabs
      cfv vx cv cR wbr wi wa vy cv vz cv clt wbr vy cv vz cv wceq wo vz cv cF
      cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi vx cv cr wcel cc0 vx cv
      clt wbr wa vy cv cn wcel wa vz cv cn wcel wa vy cv vz cv wceq vz cv cF
      cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi vy cv vz cv clt wbr vz
      cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr wi vx cv cr wcel cc0
      vx cv clt wbr wa vz cv cn wcel vy cv vz cv wceq vz cv cF cfv vy cv cF cfv
      cmin co cabs cfv vx cv cR wbr wi vy cv cn wcel vx cv cr wcel cc0 vx cv
      clt wbr wa vz cv cn wcel vy cv vz cv wceq vz cv cF cfv vy cv cF cfv cmin
      co cabs cfv vx cv cR wbr wi vx cv cr wcel cc0 vx cv clt wbr wa cc0 vx cv
      cR wbr vz cv cn wcel vy cv vz cv wceq vz cv cF cfv vy cv cF cfv cmin co
      cabs cfv vx cv cR wbr wi wi vx cv cr wcel cc0 vx cv clt wbr cc0 vx cv cR
      wbr cau2.2 imp cc0 vx cv cR wbr vz cv cn wcel vy cv vz cv wceq vz cv cF
      cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr vz cv cn wcel vy cv vz cv
      wceq wa vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv cR wbr cc0 vx cv
      cR wbr vz cv cn wcel vy cv vz cv wceq wa vz cv cF cfv vy cv cF cfv cmin
      co cabs cfv cc0 vx cv cR vz cv cn wcel vy cv vz cv wceq wa vz cv cF cfv
      vy cv cF cfv cmin co cabs cfv cc0 cabs cfv cc0 vz cv cn wcel vy cv vz cv
      wceq wa vz cv cF cfv vy cv cF cfv cmin co cc0 cabs vy cv vz cv wceq vz cv
      cn wcel vz cv cF cfv vy cv cF cfv cmin co vz cv cF cfv vz cv cF cfv cmin
      co cc0 vy cv vz cv wceq vy cv cF cfv vz cv cF cfv vz cv cF cfv cmin vy cv
      vz cv cF fveq2 opreq2d vz cv cn wcel vz cv cF cfv cc wcel vz cv cF cfv vz
      cv cF cfv cmin co cc0 wceq cn cc vz cv cF cau2.1 ffvelrni vz cv cF cfv
      subid syl sylan9eqr fveq2d abs0 syl6eq breq1d biimprcd exp3a syl imp
      adantlr biantrud vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv cmin co
      cabs cfv vx cv cR wbr vy cv vz cv wceq jaob syl6bbr vx cv cr wcel cc0 vx
      cv clt wbr wa vy cv cn wcel wa vz cv cn wcel wa vy cv vz cv cle wbr vy cv
      vz cv clt wbr vy cv vz cv wceq wo vz cv cF cfv vy cv cF cfv cmin co cabs
      cfv vx cv cR wbr vy cv cn wcel vz cv cn wcel vy cv vz cv cle wbr vy cv vz
      cv clt wbr vy cv vz cv wceq wo wb vx cv cr wcel cc0 vx cv clt wbr wa vy
      cv cr wcel vz cv cr wcel vy cv vz cv cle wbr vy cv vz cv clt wbr vy cv vz
      cv wceq wo wb vy cv cn wcel vz cv cn wcel vy cv vz cv leloe vy cv nnre vz
      cv nnre syl2an adantll imbi1d bitr4d ralbidva rexbidva pm5.74da ralbiia
      $.
      $( [25-Apr-2005] $) $( [10-Apr-2005] $)
  $}

  ${
    $d m ph $.  $d j m W $.  $d j k m Z $.
    cau3i.1 $e |- Z C_ ZZ $.
    $( A relationship used to derive two ways to express a Cauchy sequence. $)
    cau3ii $p |- ( E. m e. Z A. j e. Z A. k e. W ( ( m <_ j /\ m <_ k ) ->
                ph ) -> E. j e. Z A. k e. W ( j <_ k -> ph ) ) $=
      vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cW wral vj cZ wral
      vm cZ wrex vm cv vk cv cle wbr wph vj vm cv wsbc wi vk cW wral vm cZ wrex
      vj cv vk cv cle wbr wph wi vk cW wral vj cZ wrex vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi vk cW wral vj cZ wral vm cv vk cv cle wbr wph
      vj vm cv wsbc wi vk cW wral vm cZ vm cv cZ wcel vm cv vj cv cle wbr vm cv
      vk cv cle wbr wa wph wi vj cZ wral vk cW wral vm cv vk cv cle wbr wph vj
      vm cv wsbc wi vk cW wral vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph
      wi vk cW wral vj cZ wral vm cv cZ wcel vm cv vj cv cle wbr vm cv vk cv
      cle wbr wa wph wi vj cZ wral vm cv vk cv cle wbr wph vj vm cv wsbc wi vk
      cW vm cv cZ wcel vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vj cZ
      wral vm cv vm cv cle wbr vm cv vk cv cle wbr wa wph vj vm cv wsbc wi vm
      cv vk cv cle wbr wph vj vm cv wsbc wi vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vm cv vm cv cle wbr vm cv vk cv cle wbr wa wph vj vm cv
      wsbc wi vj vm cv cZ vm cv vm cv cle wbr vm cv vk cv cle wbr wa wph vj vm
      cv wsbc vj vm cv vm cv cle wbr vm cv vk cv cle wbr wa vj ax-17 wph vj vm
      hbs1 hbim vj cv vm cv wceq vm cv vj cv cle wbr vm cv vk cv cle wbr wa vm
      cv vm cv cle wbr vm cv vk cv cle wbr wa wph wph vj vm cv wsbc vj cv vm cv
      wceq vm cv vj cv cle wbr vm cv vm cv cle wbr vm cv vk cv cle wbr vj cv vm
      cv vm cv cle breq2 anbi1d wph vj vm sbequ12 imbi12d rcla4 vm cv cZ wcel
      vm cv vk cv cle wbr vm cv vm cv cle wbr vm cv vk cv cle wbr wa wph vj vm
      cv wsbc vm cv cZ wcel vm cv vm cv cle wbr vm cv vk cv cle wbr vm cv cZ
      wcel vm cv cr wcel vm cv vm cv cle wbr cZ cr vm cv cZ cz cr cau3i.1 zssre
      sstri sseli vm cv leid syl biantrurd imbi1d sylibrd r19.20sdv vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vj vk cZ cW ralcom syl5ib r19.22i
      vj cv vk cv cle wbr wph wi vk cW wral vm cv vk cv cle wbr wph vj vm cv
      wsbc wi vk cW wral vj vm cZ vj cv vk cv cle wbr wph wi vk cW wral vm
      ax-17 vm cv vk cv cle wbr wph vj vm cv wsbc wi vj vk cW vk cv cW wcel vj
      ax-17 vm cv vk cv cle wbr wph vj vm cv wsbc vj vm cv vk cv cle wbr vj
      ax-17 wph vj vm hbs1 hbim hbral vj cv vm cv wceq vj cv vk cv cle wbr wph
      wi vm cv vk cv cle wbr wph vj vm cv wsbc wi vk cW vj cv vm cv wceq vj cv
      vk cv cle wbr vm cv vk cv cle wbr wph wph vj vm cv wsbc vj cv vm cv vk cv
      cle breq1 wph vj vm sbequ12 imbi12d ralbidv cbvrex sylibr $.
      $( [22-Dec-2006] $) $( [17-Dec-2006] $)
  $}

  ${
    $v et $.
    cau3ir.wet $f wff et $.
    $d j k m n x y R $.  $d j k m n x y W $.  $d j k m n x y Z $.
    $d j n y ch $.  $d j k m y et $.  $d m n y ph $.  $d k ps $.  $d x th $.
    $d x ta $.
    cau3ir.1 $e |- ( k = m -> ( ph <-> ps ) ) $.
    cau3ir.2 $e |- ( j = k -> ( ps <-> ch ) ) $.
    cau3ir.3 $e |- ( x = ( y / 2 ) -> ( ( ph /\ ps ) <-> th ) ) $.
    cau3ir.4 $e |- ( x = y -> ( ch <-> ta ) ) $.
    cau3ir.5 $e |- ( ( ( et /\ y e. RR ) /\ ( j e. Z /\ k e. W /\ m e. W ) ) ->
                   ( th -> ta ) ) $.
    $( A relationship used to derive two ways to express a Cauchy sequence.
       Normally ` Z ` and ` W ` are subsets of ` ZZ ` , and ` R ` is ` <_ ` or
       ` < ` .  ` ph ` is ` ph ( j , k , x ) ` . $)
    cau3iri $p |- ( et -> ( A. x e. RR ( 0 < x -> E. j e. Z A. k e. W ( j R k
       -> ph ) ) -> A. x e. RR ( 0 < x -> E. m e. Z A. j e. W A. k e. W
          ( ( m R j /\ m R k ) -> ph ) ) ) ) $=
      cau3ir.wet cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi vk cW wral vj cZ
      wrex wi vx cr wral cc0 vy cv clt wbr vj cv vk cv cR wbr vj cv vm cv cR
      wbr wa wta wi vm cW wral vk cW wral vj cZ wrex wi vy cr wral cc0 vx cv
      clt wbr vm cv vj cv cR wbr vm cv vk cv cR wbr wa wph wi vk cW wral vj cW
      wral vm cZ wrex wi vx cr wral cau3ir.wet cc0 vx cv clt wbr vj cv vk cv cR
      wbr wph wi vk cW wral vj cZ wrex wi vx cr wral cc0 vy cv clt wbr vj cv vk
      cv cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral vj cZ wrex
      wi vy cr cau3ir.wet cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi vk cW
      wral vj cZ wrex wi vx cr wral vy cv cr wcel cc0 vy cv clt wbr vj cv vk cv
      cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral vj cZ wrex wi
      cau3ir.wet cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi vk cW wral vj cZ
      wrex wi vx cr wral vy cv cr wcel wa wa cc0 vy cv clt wbr vj cv vk cv cR
      wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk cW wral vj cZ wrex vj cv
      vk cv cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral vj cZ
      wrex cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi vk cW wral vj cZ wrex wi
      vx cr wral vy cv cr wcel wa cc0 vy cv clt wbr vj cv vk cv cR wbr vj cv vm
      cv cR wbr wa wth wi vm cW wral vk cW wral vj cZ wrex wi cau3ir.wet cc0 vx
      cv clt wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wph wps wa wi vm cW
      wral vk cW wral vj cZ wrex wi vx cr wral vy cv cr wcel cc0 vy cv clt wbr
      vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk cW wral vj
      cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi vk cW wral vj cZ
      wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cR wbr vj cv vm cv cR
      wbr wa wph wps wa wi vm cW wral vk cW wral vj cZ wrex wi vx cr wral vy cv
      cr wcel wa cc0 vy cv clt wbr cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cR
      wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk cW wral vj cZ wrex vy cv
      cr wcel cc0 vy cv clt wbr cc0 vy cv c2 cdiv co clt wbr wb cc0 vx cv clt
      wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wph wps wa wi vm cW wral vk
      cW wral vj cZ wrex wi vx cr wral vy cv halfpos2 adantl cc0 vx cv clt wbr
      vj cv vk cv cR wbr vj cv vm cv cR wbr wa wph wps wa wi vm cW wral vk cW
      wral vj cZ wrex wi vx cr wral vy cv c2 cdiv co cr wcel cc0 vy cv c2 cdiv
      co clt wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk
      cW wral vj cZ wrex wi vy cv cr wcel cc0 vx cv clt wbr vj cv vk cv cR wbr
      vj cv vm cv cR wbr wa wph wps wa wi vm cW wral vk cW wral vj cZ wrex wi
      cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth
      wi vm cW wral vk cW wral vj cZ wrex wi vx vy cv c2 cdiv co cr vx cv vy cv
      c2 cdiv co wceq cc0 vx cv clt wbr cc0 vy cv c2 cdiv co clt wbr vj cv vk
      cv cR wbr vj cv vm cv cR wbr wa wph wps wa wi vm cW wral vk cW wral vj cZ
      wrex vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk cW
      wral vj cZ wrex vx cv vy cv c2 cdiv co cc0 clt breq2 vx cv vy cv c2 cdiv
      co wceq vj cv vk cv cR wbr vj cv vm cv cR wbr wa wph wps wa wi vm cW wral
      vk cW wral vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk
      cW wral vj cZ vx cv vy cv c2 cdiv co wceq vj cv vk cv cR wbr vj cv vm cv
      cR wbr wa wph wps wa wi vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi
      vk vm cW cW vx cv vy cv c2 cdiv co wceq wph wps wa wth vj cv vk cv cR wbr
      vj cv vm cv cR wbr wa cau3ir.3 imbi2d 2ralbidv rexbidv imbi12d rcla4cva
      vy cv rehalfcl sylan2 sylbid cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi
      vk cW wral vj cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cR wbr vj cv vm cv
      cR wbr wa wph wps wa wi vm cW wral vk cW wral vj cZ wrex wi vx cr vj cv
      vk cv cR wbr wph wi vk cW wral vj cZ wrex vj cv vk cv cR wbr vj cv vm cv
      cR wbr wa wph wps wa wi vm cW wral vk cW wral vj cZ wrex cc0 vx cv clt
      wbr vj cv vk cv cR wbr wph wi vk cW wral vj cv vk cv cR wbr vj cv vm cv
      cR wbr wa wph wps wa wi vm cW wral vk cW wral vj cZ vj cv vk cv cR wbr
      wph wi vk cW wral vj cv vk cv cR wbr wph wi vj cv vm cv cR wbr wps wi wa
      vm cW wral vk cW wral vj cv vk cv cR wbr vj cv vm cv cR wbr wa wph wps wa
      wi vm cW wral vk cW wral vj cv vk cv cR wbr wph wi vj cv vm cv cR wbr wps
      wi wa vm cW wral vk cW wral vj cv vk cv cR wbr wph wi vk cW wral vj cv vm
      cv cR wbr wps wi vm cW wral wa vj cv vk cv cR wbr wph wi vk cW wral vj cv
      vk cv cR wbr wph wi vk cW wral wa vj cv vk cv cR wbr wph wi vk cW wral vj
      cv vk cv cR wbr wph wi vj cv vm cv cR wbr wps wi vk vm cW raaanv vj cv vk
      cv cR wbr wph wi vk cW wral vj cv vm cv cR wbr wps wi vm cW wral vj cv vk
      cv cR wbr wph wi vk cW wral vj cv vk cv cR wbr wph wi vj cv vm cv cR wbr
      wps wi vk vm cW vk cv vm cv wceq vj cv vk cv cR wbr vj cv vm cv cR wbr
      wph wps vk cv vm cv vj cv cR breq2 cau3ir.1 imbi12d cbvralv anbi2i vj cv
      vk cv cR wbr wph wi vk cW wral anidm 3bitr2ri vj cv vk cv cR wbr wph wi
      vj cv vm cv cR wbr wps wi wa vm cW wral vj cv vk cv cR wbr vj cv vm cv cR
      wbr wa wph wps wa wi vm cW wral vk cW vj cv vk cv cR wbr wph wi vj cv vm
      cv cR wbr wps wi wa vj cv vk cv cR wbr vj cv vm cv cR wbr wa wph wps wa
      wi vm cW vj cv vk cv cR wbr wph vj cv vm cv cR wbr wps prth r19.20si
      r19.20si sylbi r19.22si imim2i r19.20si sylan adantl cau3ir.wet vy cv cr
      wcel vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk cW
      wral vj cZ wrex vj cv vk cv cR wbr vj cv vm cv cR wbr wa wta wi vm cW
      wral vk cW wral vj cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cR wbr wph wi
      vk cW wral vj cZ wrex wi vx cr wral cau3ir.wet vy cv cr wcel wa vj cv vk
      cv cR wbr vj cv vm cv cR wbr wa wth wi vm cW wral vk cW wral vj cv vk cv
      cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral vj cZ
      cau3ir.wet vy cv cr wcel wa vj cv cZ wcel wa vj cv vk cv cR wbr vj cv vm
      cv cR wbr wa wth wi vm cW wral vj cv vk cv cR wbr vj cv vm cv cR wbr wa
      wta wi vm cW wral vk cW cau3ir.wet vy cv cr wcel wa vj cv cZ wcel wa vk
      cv cW wcel wa vj cv vk cv cR wbr vj cv vm cv cR wbr wa wth wi vj cv vk cv
      cR wbr vj cv vm cv cR wbr wa wta wi vm cW cau3ir.wet vy cv cr wcel wa vj
      cv cZ wcel wa vk cv cW wcel wa vm cv cW wcel wa wth wta vj cv vk cv cR
      wbr vj cv vm cv cR wbr wa cau3ir.wet vy cv cr wcel wa vj cv cZ wcel vk cv
      cW wcel vm cv cW wcel wth wta wi cau3ir.wet vy cv cr wcel wa vj cv cZ
      wcel vk cv cW wcel vm cv cW wcel wth wta wi cau3ir.5 3exp2 imp41 imim2d
      r19.20dva r19.20dva r19.22dva adantrl syld exp32 r19.21adv cc0 vy cv clt
      wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral
      vj cZ wrex wi vy cr wral cc0 vx cv clt wbr vj cv vk cv cR wbr vj cv vm cv
      cR wbr wa wch wi vm cW wral vk cW wral vj cZ wrex wi vx cr wral cc0 vx cv
      clt wbr vm cv vj cv cR wbr vm cv vk cv cR wbr wa wph wi vk cW wral vj cW
      wral vm cZ wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cR wbr vj cv
      vm cv cR wbr wa wch wi vm cW wral vk cW wral vj cZ wrex wi cc0 vy cv clt
      wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral
      vj cZ wrex wi vx vy cr vx cv vy cv wceq cc0 vx cv clt wbr cc0 vy cv clt
      wbr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wch wi vm cW wral vk cW wral
      vj cZ wrex vj cv vk cv cR wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk
      cW wral vj cZ wrex vx cv vy cv cc0 clt breq2 vx cv vy cv wceq vj cv vk cv
      cR wbr vj cv vm cv cR wbr wa wch wi vm cW wral vk cW wral vj cv vk cv cR
      wbr vj cv vm cv cR wbr wa wta wi vm cW wral vk cW wral vj cZ vx cv vy cv
      wceq vj cv vk cv cR wbr vj cv vm cv cR wbr wa wch wi vj cv vk cv cR wbr
      vj cv vm cv cR wbr wa wta wi vk vm cW cW vx cv vy cv wceq wch wta vj cv
      vk cv cR wbr vj cv vm cv cR wbr wa cau3ir.4 imbi2d 2ralbidv rexbidv
      imbi12d cbvralv cc0 vx cv clt wbr vj cv vk cv cR wbr vj cv vm cv cR wbr
      wa wch wi vm cW wral vk cW wral vj cZ wrex wi cc0 vx cv clt wbr vm cv vj
      cv cR wbr vm cv vk cv cR wbr wa wph wi vk cW wral vj cW wral vm cZ wrex
      wi vx cr vj cv vk cv cR wbr vj cv vm cv cR wbr wa wch wi vm cW wral vk cW
      wral vj cZ wrex vm cv vj cv cR wbr vm cv vk cv cR wbr wa wph wi vk cW
      wral vj cW wral vm cZ wrex cc0 vx cv clt wbr vj cv vk cv cR wbr vj cv vm
      cv cR wbr wa wch wi vm cW wral vk cW wral vj cZ wrex vn cv vk cv cR wbr
      vn cv vm cv cR wbr wa wch wi vm cW wral vk cW wral vn cZ wrex vn cv vj cv
      cR wbr vn cv vk cv cR wbr wa wph wi vk cW wral vj cW wral vn cZ wrex vm
      cv vj cv cR wbr vm cv vk cv cR wbr wa wph wi vk cW wral vj cW wral vm cZ
      wrex vj cv vk cv cR wbr vj cv vm cv cR wbr wa wch wi vm cW wral vk cW
      wral vn cv vk cv cR wbr vn cv vm cv cR wbr wa wch wi vm cW wral vk cW
      wral vj vn cZ vj cv vn cv wceq vj cv vk cv cR wbr vj cv vm cv cR wbr wa
      wch wi vn cv vk cv cR wbr vn cv vm cv cR wbr wa wch wi vk vm cW cW vj cv
      vn cv wceq vj cv vk cv cR wbr vj cv vm cv cR wbr wa vn cv vk cv cR wbr vn
      cv vm cv cR wbr wa wch vj cv vn cv wceq vj cv vk cv cR wbr vn cv vk cv cR
      wbr vj cv vm cv cR wbr vn cv vm cv cR wbr vj cv vn cv vk cv cR breq1 vj
      cv vn cv vm cv cR breq1 anbi12d imbi1d 2ralbidv cbvrexv vn cv vk cv cR
      wbr vn cv vm cv cR wbr wa wch wi vm cW wral vk cW wral vn cv vj cv cR wbr
      vn cv vk cv cR wbr wa wph wi vk cW wral vj cW wral vn cZ vn cv vj cv cR
      wbr vn cv vk cv cR wbr wa wph wi vk cW wral vj cW wral vn cv vj cv cR wbr
      vn cv vm cv cR wbr wa wps wi vm cW wral vj cW wral vn cv vk cv cR wbr vn
      cv vm cv cR wbr wa wch wi vm cW wral vk cW wral vn cv vj cv cR wbr vn cv
      vk cv cR wbr wa wph wi vk cW wral vn cv vj cv cR wbr vn cv vm cv cR wbr
      wa wps wi vm cW wral vj cW vn cv vj cv cR wbr vn cv vk cv cR wbr wa wph
      wi vn cv vj cv cR wbr vn cv vm cv cR wbr wa wps wi vk vm cW vk cv vm cv
      wceq vn cv vj cv cR wbr vn cv vk cv cR wbr wa vn cv vj cv cR wbr vn cv vm
      cv cR wbr wa wph wps vk cv vm cv wceq vn cv vk cv cR wbr vn cv vm cv cR
      wbr vn cv vj cv cR wbr vk cv vm cv vn cv cR breq2 anbi2d cau3ir.1 imbi12d
      cbvralv ralbii vn cv vj cv cR wbr vn cv vm cv cR wbr wa wps wi vm cW wral
      vn cv vk cv cR wbr vn cv vm cv cR wbr wa wch wi vm cW wral vj vk cW vj cv
      vk cv wceq vn cv vj cv cR wbr vn cv vm cv cR wbr wa wps wi vn cv vk cv cR
      wbr vn cv vm cv cR wbr wa wch wi vm cW vj cv vk cv wceq vn cv vj cv cR
      wbr vn cv vm cv cR wbr wa vn cv vk cv cR wbr vn cv vm cv cR wbr wa wps
      wch vj cv vk cv wceq vn cv vj cv cR wbr vn cv vk cv cR wbr vn cv vm cv cR
      wbr vj cv vk cv vn cv cR breq2 anbi1d cau3ir.2 imbi12d ralbidv cbvralv
      bitr2i rexbii vn cv vj cv cR wbr vn cv vk cv cR wbr wa wph wi vk cW wral
      vj cW wral vm cv vj cv cR wbr vm cv vk cv cR wbr wa wph wi vk cW wral vj
      cW wral vn vm cZ vn cv vm cv wceq vn cv vj cv cR wbr vn cv vk cv cR wbr
      wa wph wi vm cv vj cv cR wbr vm cv vk cv cR wbr wa wph wi vj vk cW cW vn
      cv vm cv wceq vn cv vj cv cR wbr vn cv vk cv cR wbr wa vm cv vj cv cR wbr
      vm cv vk cv cR wbr wa wph vn cv vm cv wceq vn cv vj cv cR wbr vm cv vj cv
      cR wbr vn cv vk cv cR wbr vm cv vk cv cR wbr vn cv vm cv vj cv cR breq1
      vn cv vm cv vk cv cR breq1 anbi12d imbi1d 2ralbidv cbvrexv 3bitri imbi2i
      ralbii bitr3i syl6ib $.
      $( [18-Apr-2007] $) $( [17-Dec-2006] $)
  $}

  ${
    $v et $.
    cau3.wet $f wff et $.
    $d j k m n x y R $.  $d j k m n x y Z $.  $d j n y ch $.
    $d j k m y et $.  $d m n y ph $.  $d k ps $.  $d x th $.  $d x ta $.
    cau3.1 $e |- ( k = m -> ( ph <-> ps ) ) $.
    cau3.2 $e |- ( j = k -> ( ps <-> ch ) ) $.
    cau3.3 $e |- ( x = ( y / 2 ) -> ( ( ph /\ ps ) <-> th ) ) $.
    cau3.4 $e |- ( x = y -> ( ch <-> ta ) ) $.
    cau3.5 $e |- ( ( ( et /\ y e. RR ) /\ ( j e. Z /\ k e. Z /\ m e. Z ) ) ->
                   ( th -> ta ) ) $.
    cau3.6 $e |- Z C_ ZZ $.
    $( A relationship used to derive two ways to express a Cauchy sequence.
         ` ph ` is ` ph ( j , k , x ) ` . $)
    cau3i $p |- ( et ->
         ( A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z
        ( j <_ k -> ph ) ) <-> A. x e. RR ( 0 < x ->
       E. m e. Z A. j e. Z A. k e. Z ( ( m <_ j /\ m <_ k ) -> ph ) ) ) ) $=
      cau3.wet cc0 vx cv clt wbr vj cv vk cv cle wbr wph wi vk cZ wral vj cZ
      wrex wi vx cr wral cc0 vx cv clt wbr vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vk cZ wral vj cZ wral vm cZ wrex wi vx cr wral wph wps wch
      wth wta vx vy cle vj vk vm cZ cZ cau3.wet cau3.1 cau3.2 cau3.3 cau3.4
      cau3.5 cau3iri cc0 vx cv clt wbr vm cv vj cv cle wbr vm cv vk cv cle wbr
      wa wph wi vk cZ wral vj cZ wral vm cZ wrex wi cc0 vx cv clt wbr vj cv vk
      cv cle wbr wph wi vk cZ wral vj cZ wrex wi vx cr vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cZ wrex vj cv vk cv
      cle wbr wph wi vk cZ wral vj cZ wrex cc0 vx cv clt wbr wph vj vk vm cZ cZ
      cau3.6 cau3ii imim2i r19.20si impbid1 $.
      $( [19-Apr-2007] $) $( [17-Dec-2006] $)
  $}

  ${
    $d j k m n M $.  $d m Z $.  $d m n ph $.
    cau5i.1 $e |- M e. ZZ $.
    cau5i.1a $e |- Z = ( ZZ>= ` M ) $.
    cau5i.2 $e |- W C_ ZZ $.
    cau5i.3 $e |- U C_ ZZ $.
    $( A relationship used to derive two ways to express a Cauchy
       sequence.  ` ph ` is ` ph ( j , k ) ` . $)
    cau5ii $p |- ( E. m e. ZZ A. j e. ZZ A. k e. ZZ ( ( m <_ j /\ m <_ k ) ->
            ph ) -> E. m e. Z A. j e. W A. k e. U
                ( ( m <_ j /\ m <_ k ) -> ph ) ) $=
      vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph wi vk cz wral vj cz wral
      vn cz wrex vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cU wral
      vj cW wral vm cM cuz cfv wrex vm cv vj cv cle wbr vm cv vk cv cle wbr wa
      wph wi vk cz wral vj cz wral vm cz wrex vm cv vj cv cle wbr vm cv vk cv
      cle wbr wa wph wi vk cU wral vj cW wral vm cZ wrex vn cv vj cv cle wbr vn
      cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vn cz wrex vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cM cuz cfv
      wrex vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cU wral vj cW
      wral vm cM cuz cfv wrex vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph wi
      vk cz wral vj cz wral vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi
      vk cz wral vj cz wral vm cM cuz cfv wrex vn cz vn cv cz wcel vn cv vj cv
      cle wbr vn cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cM cuz cfv
      wrex wi vn cv cM vn cv zre cM cr wcel vn cv cz wcel cM cau5i.1 zrei a1i
      vn cv cz wcel vn cv cM cle wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr
      wa wph wi vk cz wral vj cz wral cM vj cv cle wbr cM vk cv cle wbr wa wph
      wi vk cz wral vj cz wral vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph
      wi vk cz wral vj cz wral vm cM cuz cfv wrex vn cv cz wcel vn cv cM cle
      wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph wi vk cz wral cM vj
      cv cle wbr cM vk cv cle wbr wa wph wi vk cz wral vj cz vn cv cz wcel vn
      cv cM cle wbr wa vj cv cz wcel wa vn cv vj cv cle wbr vn cv vk cv cle wbr
      wa wph wi cM vj cv cle wbr cM vk cv cle wbr wa wph wi vk cz vn cv cz wcel
      vn cv cM cle wbr wa vj cv cz wcel wa vk cv cz wcel wa cM vj cv cle wbr cM
      vk cv cle wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph vn cv cz
      wcel vn cv cM cle wbr wa vj cv cz wcel vk cv cz wcel cM vj cv cle wbr cM
      vk cv cle wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa wi vn cv cz
      wcel vj cv cz wcel vk cv cz wcel wa vn cv cM cle wbr cM vj cv cle wbr cM
      vk cv cle wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa wi vn cv cz
      wcel vj cv cz wcel vk cv cz wcel wa wa vn cv cM cle wbr cM vj cv cle wbr
      cM vk cv cle wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa vn cv cz
      wcel vj cv cz wcel vk cv cz wcel wa wa vn cv cM cle wbr cM vj cv cle wbr
      wa vn cv cM cle wbr cM vk cv cle wbr wa wa vn cv vj cv cle wbr vn cv vk
      cv cle wbr wa vn cv cM cle wbr cM vj cv cle wbr cM vk cv cle wbr wa wa vn
      cv cr wcel vj cv cz wcel vk cv cz wcel wa vn cv cM cle wbr cM vj cv cle
      wbr wa vn cv cM cle wbr cM vk cv cle wbr wa wa vn cv vj cv cle wbr vn cv
      vk cv cle wbr wa wi vn cv cz wcel vn cv cr wcel vj cv cz wcel vk cv cz
      wcel vn cv cM cle wbr cM vj cv cle wbr wa vn cv cM cle wbr cM vk cv cle
      wbr wa wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa wi vn cv cr wcel vj
      cv cz wcel wa vn cv cM cle wbr cM vj cv cle wbr wa vn cv vj cv cle wbr vn
      cv cr wcel vk cv cz wcel wa vn cv cM cle wbr cM vk cv cle wbr wa vn cv vk
      cv cle wbr vn cv cr wcel vj cv cr wcel vn cv cM cle wbr cM vj cv cle wbr
      wa vn cv vj cv cle wbr wi vj cv cz wcel vn cv cr wcel cM cr wcel vj cv cr
      wcel vn cv cM cle wbr cM vj cv cle wbr wa vn cv vj cv cle wbr wi cM
      cau5i.1 zrei vn cv cM vj cv letr mp3an2 vj cv zre sylan2 vn cv cr wcel vk
      cv cr wcel vn cv cM cle wbr cM vk cv cle wbr wa vn cv vk cv cle wbr wi vk
      cv cz wcel vn cv cr wcel cM cr wcel vk cv cr wcel vn cv cM cle wbr cM vk
      cv cle wbr wa vn cv vk cv cle wbr wi cM cau5i.1 zrei vn cv cM vk cv letr
      mp3an2 vk cv zre sylan2 im2anan9 anandis vn cv zre sylan vn cv cM cle wbr
      cM vj cv cle wbr cM vk cv cle wbr anandi syl5ib expdimp an1rs anassrs
      imim1d r19.20dva r19.20dva cM cM cuz cfv wcel cM vj cv cle wbr cM vk cv
      cle wbr wa wph wi vk cz wral vj cz wral vm cv vj cv cle wbr vm cv vk cv
      cle wbr wa wph wi vk cz wral vj cz wral vm cM cuz cfv wrex cM cz wcel cM
      cM cuz cfv wcel cau5i.1 cM uzid ax-mp vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vk cz wral vj cz wral cM vj cv cle wbr cM vk cv cle wbr wa
      wph wi vk cz wral vj cz wral vm cM cM cuz cfv vm cv cM wceq vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi cM vj cv cle wbr cM vk cv cle wbr
      wa wph wi vj vk cz cz vm cv cM wceq vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa cM vj cv cle wbr cM vk cv cle wbr wa wph vm cv cM wceq vm cv vj cv
      cle wbr cM vj cv cle wbr vm cv vk cv cle wbr cM vk cv cle wbr vm cv cM vj
      cv cle breq1 vm cv cM vk cv cle breq1 anbi12d imbi1d 2ralbidv rcla4ev
      mpan syl6 vn cv cz wcel cM vn cv cle wbr wa vn cv cM cuz cfv wcel vn cv
      vj cv cle wbr vn cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cv
      vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cM
      cuz cfv wrex wi cM vn cv cau5i.1 eluz1i vn cv cM cuz cfv wcel vn cv vj cv
      cle wbr vn cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cM cuz cfv
      wrex vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz
      wral vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph wi vk cz wral vj cz
      wral vm vn cv cM cuz cfv vm cv vn cv wceq vm cv vj cv cle wbr vm cv vk cv
      cle wbr wa wph wi vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph wi vj vk
      cz cz vm cv vn cv wceq vm cv vj cv cle wbr vm cv vk cv cle wbr wa vn cv
      vj cv cle wbr vn cv vk cv cle wbr wa wph vm cv vn cv wceq vm cv vj cv cle
      wbr vn cv vj cv cle wbr vm cv vk cv cle wbr vn cv vk cv cle wbr vm cv vn
      cv vj cv cle breq1 vm cv vn cv vk cv cle breq1 anbi12d imbi1d 2ralbidv
      rcla4ev ex sylbir lecasei r19.23aiv vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vk cz wral vj cz wral vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vk cU wral vj cW wral vm cM cuz cfv vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi vk cz wral vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vk cU wral vj cz cW vj cv cW wcel vj cv cz wcel vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi vk cU wral cW cz vj cv cau5i.2 sseli vm cv vj
      cv cle wbr vm cv vk cv cle wbr wa wph wi vm cv vj cv cle wbr vm cv vk cv
      cle wbr wa wph wi vk cz cU vk cv cU wcel vk cv cz wcel vm cv vj cv cle
      wbr vm cv vk cv cle wbr wa wph wi cU cz vk cv cau5i.3 sseli imim1i
      r19.20i2 imim12i r19.20i2 r19.22si syl vm cv vj cv cle wbr vm cv vk cv
      cle wbr wa wph wi vk cz wral vj cz wral vn cv vj cv cle wbr vn cv vk cv
      cle wbr wa wph wi vk cz wral vj cz wral vm vn cz vm cv vn cv wceq vm cv
      vj cv cle wbr vm cv vk cv cle wbr wa wph wi vn cv vj cv cle wbr vn cv vk
      cv cle wbr wa wph wi vj vk cz cz vm cv vn cv wceq vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa vn cv vj cv cle wbr vn cv vk cv cle wbr wa wph vm cv
      vn cv wceq vm cv vj cv cle wbr vn cv vj cv cle wbr vm cv vk cv cle wbr vn
      cv vk cv cle wbr vm cv vn cv vj cv cle breq1 vm cv vn cv vk cv cle breq1
      anbi12d imbi1d 2ralbidv cbvrexv cZ cM cuz cfv wceq vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi vk cU wral vj cW wral vm cZ wrex vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cU wral vj cW wral vm cM cuz cfv
      wrex wb cau5i.1a vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cU
      wral vj cW wral vm cZ cM cuz cfv rexeq1 ax-mp 3imtr4i $.
      $( [22-Dec-2006] $) $( [17-Dec-2006] $)
  $}

  ${
    $d j k m M $.  $d j k m Z $.  $d m ph $.
    cau4i.1 $e |- M e. ZZ $.
    cau4i.2 $e |- Z = ( ZZ>= ` M ) $.
    $( A relationship used to derive two ways to express a Cauchy sequence.
       ` ph ` is ` ph ( j , k ) ` . $)
    cau4ii $p |- ( E. j e. Z A. k e. Z ( j <_ k -> ph ) ->
                  E. j e. ZZ A. k e. ZZ ( j <_ k -> ph ) ) $=
      vj cv vk cv cle wbr wph wi vk cZ wral vj cZ wrex cM vj cv cle wbr vj cv
      vk cv cle wbr wph wi vk cZ wral wa vj cz wrex vj cv vk cv cle wbr wph wi
      vk cz wral vj cz wrex vj cv vk cv cle wbr wph wi vk cZ wral vj cZ wrex vj
      cv vk cv cle wbr wph wi vk cZ wral vj cM cuz cfv wrex cM vj cv cle wbr vj
      cv vk cv cle wbr wph wi vk cZ wral wa vj cz wrex cZ cM cuz cfv wceq vj cv
      vk cv cle wbr wph wi vk cZ wral vj cZ wrex vj cv vk cv cle wbr wph wi vk
      cZ wral vj cM cuz cfv wrex wb cau4i.2 vj cv vk cv cle wbr wph wi vk cZ
      wral vj cZ cM cuz cfv rexeq1 ax-mp cM cz wcel vj cv vk cv cle wbr wph wi
      vk cZ wral vj cM cuz cfv wrex cM vj cv cle wbr vj cv vk cv cle wbr wph wi
      vk cZ wral wa vj cz wrex wb cau4i.1 vj cv vk cv cle wbr wph wi vk cZ wral
      vj cM rexuz ax-mp bitri cM vj cv cle wbr vj cv vk cv cle wbr wph wi vk cZ
      wral wa vj cv vk cv cle wbr wph wi vk cz wral vj cz vj cv cz wcel cM vj
      cv cle wbr vj cv vk cv cle wbr wph wi vk cZ wral vj cv vk cv cle wbr wph
      wi vk cz wral vj cv cz wcel cM vj cv cle wbr wa cM vk cv cle wbr vj cv vk
      cv cle wbr wph wi wi vk cz wral vj cv vk cv cle wbr wph wi vk cz wral vj
      cv vk cv cle wbr wph wi vk cZ wral vj cv cz wcel cM vj cv cle wbr wa cM
      vk cv cle wbr vj cv vk cv cle wbr wph wi wi vj cv vk cv cle wbr wph wi vk
      cz vj cv cz wcel cM vj cv cle wbr wa vk cv cz wcel wa cM vk cv cle wbr vj
      cv vk cv cle wbr wa wph wi vj cv vk cv cle wbr wph wi cM vk cv cle wbr vj
      cv vk cv cle wbr wph wi wi vj cv cz wcel cM vj cv cle wbr wa vk cv cz
      wcel wa vj cv vk cv cle wbr cM vk cv cle wbr vj cv vk cv cle wbr wa wph
      vj cv cz wcel cM vj cv cle wbr wa vk cv cz wcel wa vj cv vk cv cle wbr cM
      vk cv cle wbr vj cv cz wcel cM vj cv cle wbr vk cv cz wcel vj cv vk cv
      cle wbr cM vk cv cle wbr wi vj cv cz wcel vk cv cz wcel cM vj cv cle wbr
      vj cv vk cv cle wbr cM vk cv cle wbr wi vj cv cz wcel vk cv cz wcel cM vj
      cv cle wbr vj cv vk cv cle wbr cM vk cv cle wbr vj cv cr wcel vk cv cr
      wcel cM vj cv cle wbr vj cv vk cv cle wbr wa cM vk cv cle wbr wi vj cv cz
      wcel vk cv cz wcel cM cr wcel vj cv cr wcel vk cv cr wcel cM vj cv cle
      wbr vj cv vk cv cle wbr wa cM vk cv cle wbr wi cM cau4i.1 zrei cM vj cv
      vk cv letr mp3an1 vj cv zre vk cv zre syl2an exp4b com23 imp31 ancrd
      imim1d cM vk cv cle wbr vj cv vk cv cle wbr wph impexp syl5ibr r19.20dva
      vj cv vk cv cle wbr wph wi vk cZ wral vj cv vk cv cle wbr wph wi vk cM
      cuz cfv wral cM vk cv cle wbr vj cv vk cv cle wbr wph wi wi vk cz wral cZ
      cM cuz cfv wceq vj cv vk cv cle wbr wph wi vk cZ wral vj cv vk cv cle wbr
      wph wi vk cM cuz cfv wral wb cau4i.2 vj cv vk cv cle wbr wph wi vk cZ cM
      cuz cfv raleq1 ax-mp cM cz wcel vj cv vk cv cle wbr wph wi vk cM cuz cfv
      wral cM vk cv cle wbr vj cv vk cv cle wbr wph wi wi vk cz wral wb cau4i.1
      vj cv vk cv cle wbr wph wi vk cM raluz ax-mp bitri syl5ib expimpd r19.22i
      sylbi $.
      $( [19-Dec-2006] $) $( [18-Dec-2006] $)

    $( A relationship used to derive two ways to express a Cauchy sequence.
       ` ph ` is ` ph ( j , k ) ` . $)
    cau5i $p |- ( E. m e. ZZ A. j e. ZZ A. k e. ZZ ( ( m <_ j /\ m <_ k ) ->
     ph ) <-> E. m e. Z A. j e. Z A. k e. Z ( ( m <_ j /\ m <_ k ) -> ph ) ) $=
      vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral
      vm cz wrex vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral
      vj cZ wral vm cZ wrex wph cZ vj vk vm cM cZ cZ cau4i.1 cau4i.2 cZ cM cuz
      cfv cz cau4i.2 cM uzssz eqsstri cZ cM cuz cfv cz cau4i.2 cM uzssz eqsstri
      cau5ii vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ
      wral vm cZ wrex cM vm cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr
      wa wph wi vk cZ wral vj cZ wral wa vm cz wrex vm cv vj cv cle wbr vm cv
      vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cz wrex vm cv vj cv cle
      wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cZ wrex vm cv
      vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cM
      cuz cfv wrex cM vm cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa
      wph wi vk cZ wral vj cZ wral wa vm cz wrex cZ cM cuz cfv wceq vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cZ wrex vm
      cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm
      cM cuz cfv wrex wb cau4i.2 vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph
      wi vk cZ wral vj cZ wral vm cZ cM cuz cfv rexeq1 ax-mp cM cz wcel vm cv
      vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cM
      cuz cfv wrex cM vm cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa
      wph wi vk cZ wral vj cZ wral wa vm cz wrex wb cau4i.1 vm cv vj cv cle wbr
      vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cM rexuz ax-mp
      bitri cM vm cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi
      vk cZ wral vj cZ wral wa vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph
      wi vk cz wral vj cz wral vm cz vm cv cz wcel cM vm cv cle wbr vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cv cz wcel
      cM vm cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr
      vm cv vk cv cle wbr wa wph wi wi wi vk cz wral vj cz wral vm cv vj cv cle
      wbr vm cv vk cv cle wbr wa wph wi vk cz wral vj cz wral vm cv vj cv cle
      wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cv cz wcel cM
      vm cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi wi wi vk cz wral vm cv vj cv cle wbr vm cv vk
      cv cle wbr wa wph wi vk cz wral vj cz vm cv cz wcel cM vm cv cle wbr wa
      vj cv cz wcel wa cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi wi wi vm cv vj cv cle wbr vm cv vk cv cle wbr
      wa wph wi vk cz vm cv cz wcel cM vm cv cle wbr wa vj cv cz wcel wa vk cv
      cz wcel wa cM vk cv cle wbr cM vj cv cle wbr wa vm cv vj cv cle wbr vm cv
      vk cv cle wbr wa wa wph wi vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph
      wi cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi wi wi vm cv cz wcel cM vm cv cle wbr wa vj cv cz wcel wa vk
      cv cz wcel wa vm cv vj cv cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr
      cM vj cv cle wbr wa vm cv vj cv cle wbr vm cv vk cv cle wbr wa wa wph vm
      cv cz wcel cM vm cv cle wbr wa vj cv cz wcel wa vk cv cz wcel wa vm cv vj
      cv cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr wa vm
      cv cz wcel cM vm cv cle wbr wa vj cv cz wcel vk cv cz wcel vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr wa wi vm
      cv cz wcel cM vm cv cle wbr vj cv cz wcel vk cv cz wcel wa vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr wa wi vm
      cv cz wcel vj cv cz wcel vk cv cz wcel wa cM vm cv cle wbr vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr wa wi vm
      cv cz wcel vj cv cz wcel vk cv cz wcel wa cM vm cv cle wbr vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr wa vm cv
      cr wcel vj cv cr wcel vk cv cr wcel wa cM vm cv cle wbr vm cv vj cv cle
      wbr vm cv vk cv cle wbr wa wa cM vk cv cle wbr cM vj cv cle wbr wa wi vm
      cv cz wcel vj cv cz wcel vk cv cz wcel wa vm cv cr wcel vj cv cr wcel vk
      cv cr wcel wa wa cM vm cv cle wbr vm cv vj cv cle wbr wa cM vm cv cle wbr
      vm cv vk cv cle wbr wa wa cM vk cv cle wbr cM vj cv cle wbr wa cM vm cv
      cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wa vm cv cr wcel vj cv
      cr wcel vk cv cr wcel cM vm cv cle wbr vm cv vj cv cle wbr wa cM vm cv
      cle wbr vm cv vk cv cle wbr wa wa cM vk cv cle wbr cM vj cv cle wbr wa wi
      vm cv cr wcel vj cv cr wcel wa vm cv cr wcel vk cv cr wcel wa wa cM vm cv
      cle wbr vm cv vj cv cle wbr wa cM vm cv cle wbr vm cv vk cv cle wbr wa wa
      cM vj cv cle wbr cM vk cv cle wbr wa cM vk cv cle wbr cM vj cv cle wbr wa
      vm cv cr wcel vj cv cr wcel wa cM vm cv cle wbr vm cv vj cv cle wbr wa cM
      vj cv cle wbr vm cv cr wcel vk cv cr wcel wa cM vm cv cle wbr vm cv vk cv
      cle wbr wa cM vk cv cle wbr cM cr wcel vm cv cr wcel vj cv cr wcel cM vm
      cv cle wbr vm cv vj cv cle wbr wa cM vj cv cle wbr wi cM cau4i.1 zrei cM
      vm cv vj cv letr mp3an1 cM cr wcel vm cv cr wcel vk cv cr wcel cM vm cv
      cle wbr vm cv vk cv cle wbr wa cM vk cv cle wbr wi cM cau4i.1 zrei cM vm
      cv vk cv letr mp3an1 im2anan9 cM vj cv cle wbr cM vk cv cle wbr ancom
      syl6ib anandis cM vm cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr
      anandi syl5ib vm cv zre vj cv cz wcel vj cv cr wcel vk cv cz wcel vk cv
      cr wcel vj cv zre vk cv zre anim12i syl2an exp4b com23 imp31 anassrs
      ancrd imim1d cM vk cv cle wbr cM vj cv cle wbr wa vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wa wph wi cM vk cv cle wbr cM vj cv cle wbr wa vm cv
      vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi cM vk cv cle wbr cM vj cv
      cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi wi cM vk cv
      cle wbr cM vj cv cle wbr wa vm cv vj cv cle wbr vm cv vk cv cle wbr wa
      wph impexp cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk
      cv cle wbr wa wph wi impexp bitri syl5ibr r19.20dva r19.20dva vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cM cuz cfv wral cM vj
      cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral
      wi vj cz wral cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm cv
      vk cv cle wbr wa wph wi wi wi vk cz wral vj cz wral cZ cM cuz cfv wceq vm
      cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cZ wral vm
      cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral vj cM cuz cfv
      wral wb cau4i.2 vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ
      wral vj cZ cM cuz cfv raleq1 ax-mp cM cz wcel vm cv vj cv cle wbr vm cv
      vk cv cle wbr wa wph wi vk cZ wral vj cM cuz cfv wral cM vj cv cle wbr vm
      cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral wi vj cz wral
      wb cau4i.1 vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ wral
      vj cM raluz ax-mp cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle
      wbr wa wph wi vk cZ wral wi cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv
      cle wbr vm cv vk cv cle wbr wa wph wi wi wi vk cz wral vj cz cM vj cv cle
      wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi vk cZ wral cM vj
      cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi vk cM cuz
      cfv wral cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph
      wi vk cZ wral wi cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi wi wi vk cz wral cZ cM cuz cfv wceq cM vj cv
      cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi vk cZ wral
      cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi vk
      cM cuz cfv wral wb cau4i.2 cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk
      cv cle wbr wa wph wi wi vk cZ cM cuz cfv raleq1 ax-mp cM vj cv cle wbr vm
      cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi vk cZ r19.21v cM cz wcel
      cM vj cv cle wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi vk
      cM cuz cfv wral cM vk cv cle wbr cM vj cv cle wbr vm cv vj cv cle wbr vm
      cv vk cv cle wbr wa wph wi wi wi vk cz wral wb cau4i.1 cM vj cv cle wbr
      vm cv vj cv cle wbr vm cv vk cv cle wbr wa wph wi wi vk cM raluz ax-mp
      3bitr3i ralbii 3bitri syl5ib expimpd r19.22i sylbi impbii $.
      $( [23-Dec-2006] $) $( [18-Dec-2006] $)
  $}

  ${
    $d j k $.  $d k Z $.
    cvg1i.1 $e |- Z = ( ZZ>= ` M ) $.
    $( A relationship used to derive two ways to express that a sequence
       converges.  Unlike ~ cvg1 , ` j ` may be free in ` ph ` , so this can
       also be used for Cauchy sequences. $)
    cvg1i $p |- ( E. j e. Z A. k e. Z ( j <_ k -> ph ) ->
                  E. j e. Z A. k e. Z ( j < k -> ph ) ) $=
      vj cv vk cv cle wbr wph wi vk cZ wral vj cv vk cv clt wbr wph wi vk cZ
      wral vj cZ vj cv cZ wcel vj cv vk cv cle wbr wph wi vj cv vk cv clt wbr
      wph wi vk cZ vj cv cZ wcel vk cv cZ wcel wa vj cv vk cv clt wbr vj cv vk
      cv cle wbr wph vj cv cr wcel vk cv cr wcel vj cv vk cv clt wbr vj cv vk
      cv cle wbr wi vj cv cZ wcel vk cv cZ wcel vj cv vk cv ltle vj cv cZ wcel
      vj cv cM cuz cfv wcel vj cv cr wcel cZ cM cuz cfv vj cv cvg1i.1 eleq2i vj
      cv cM cuz cfv wcel vj cv cz wcel vj cv cr wcel cM vj cv eluzelz vj cv zre
      syl sylbi vk cv cZ wcel vk cv cM cuz cfv wcel vk cv cr wcel cZ cM cuz cfv
      vk cv cvg1i.1 eleq2i vk cv cM cuz cfv wcel vk cv cz wcel vk cv cr wcel cM
      vk cv eluzelz vk cv zre syl sylbi syl2an imim1d r19.20dva r19.22i $.
      $( [20-Dec-2006] $) $( [20-Dec-2006] $)
  $}

  ${
    $d k M $.  $d j k m Z $.  $d j m ph $.
    cvg1.1 $e |- Z = ( ZZ>= ` M ) $.
    $( A relationship used to derive two ways to express that a sequence
       converges.  ` ph ` is ` ph ( k ) ` . $)
    cvg1 $p |- ( E. j e. Z A. k e. Z ( j < k -> ph ) <->
               E. j e. Z A. k e. Z ( j <_ k -> ph ) ) $=
      vj cv vk cv clt wbr wph wi vk cZ wral vj cZ wrex vj cv vk cv cle wbr wph
      wi vk cZ wral vj cZ wrex vj cv vk cv clt wbr wph wi vk cZ wral vj cZ wrex
      vm cv vk cv cle wbr wph wi vk cZ wral vm cZ wrex vj cv vk cv cle wbr wph
      wi vk cZ wral vj cZ wrex vj cv vk cv clt wbr wph wi vk cZ wral vm cv vk
      cv cle wbr wph wi vk cZ wral vm cZ wrex vj cZ vj cv cZ wcel vj cv vk cv
      clt wbr wph wi vk cZ wral vj cv c1 caddc co cZ wcel vj cv c1 caddc co vk
      cv cle wbr wph wi vk cZ wral wa vm cv vk cv cle wbr wph wi vk cZ wral vm
      cZ wrex vj cv cZ wcel vj cv cM cuz cfv wcel vj cv vk cv clt wbr wph wi vk
      cZ wral vj cv c1 caddc co cZ wcel vj cv c1 caddc co vk cv cle wbr wph wi
      vk cZ wral wa wi cZ cM cuz cfv vj cv cvg1.1 eleq2i vj cv cM cuz cfv wcel
      vj cv vk cv clt wbr wph wi vk cZ wral vj cv c1 caddc co vk cv cle wbr wph
      wi vk cZ wral vj cv c1 caddc co cZ wcel vj cv cM cuz cfv wcel vj cv vk cv
      clt wbr wph wi vk cZ wral vj cv c1 caddc co vk cv cle wbr wph wi vk cZ
      wral vj cv cM cuz cfv wcel vj cv vk cv clt wbr wph wi vj cv c1 caddc co
      vk cv cle wbr wph wi vk cZ vj cv cM cuz cfv wcel vk cv cZ wcel wa vj cv
      vk cv clt wbr vj cv c1 caddc co vk cv cle wbr wph vj cv cz wcel vk cv cz
      wcel vj cv vk cv clt wbr vj cv c1 caddc co vk cv cle wbr wb vj cv cM cuz
      cfv wcel vk cv cZ wcel vj cv vk cv zltp1le cM vj cv eluzelz vk cv cZ wcel
      vk cv cM cuz cfv wcel vk cv cz wcel cZ cM cuz cfv vk cv cvg1.1 eleq2i cM
      vk cv eluzelz sylbi syl2an imbi1d ralbidva biimpd vj cv cM cuz cfv wcel
      vj cv c1 caddc co cM cuz cfv cZ cM vj cv peano2uz cvg1.1 syl6eleqr jctild
      sylbi vm cv vk cv cle wbr wph wi vk cZ wral vj cv c1 caddc co vk cv cle
      wbr wph wi vk cZ wral vm vj cv c1 caddc co cZ vm cv vj cv c1 caddc co
      wceq vm cv vk cv cle wbr wph wi vj cv c1 caddc co vk cv cle wbr wph wi vk
      cZ vm cv vj cv c1 caddc co wceq vm cv vk cv cle wbr vj cv c1 caddc co vk
      cv cle wbr wph vm cv vj cv c1 caddc co vk cv cle breq1 imbi1d ralbidv
      rcla4ev syl6 r19.23aiv vm cv vk cv cle wbr wph wi vk cZ wral vj cv vk cv
      cle wbr wph wi vk cZ wral vm vj cZ vm cv vj cv wceq vm cv vk cv cle wbr
      wph wi vj cv vk cv cle wbr wph wi vk cZ vm cv vj cv wceq vm cv vk cv cle
      wbr vj cv vk cv cle wbr wph vm cv vj cv vk cv cle breq1 imbi1d ralbidv
      cbvrexv sylib wph vj vk cM cZ cvg1.1 cvg1i impbii $.
      $( [20-Dec-2006] $) $( [20-Dec-2006] $)
  $}

  ${
    $d x y z w $.  $d x w A $.  $d x z w F $.  $d x w G $.  $d x w ph $.
    cvg2.1 $e |- ( ( y e. F /\ z e. G ) -> A e. RR ) $.
    $( Two ways to express that a sequence converges or is Cauchy. $)
    cvg2i $p |- ( A. x e. RR ( 0 < x ->
                 E. y e. F A. z e. G ( ph -> A < x ) ) <->
         A. x e. RR ( 0 < x -> E. y e. F A. z e. G ( ph -> A <_ x ) ) ) $=
      cc0 vx cv clt wbr wph cA vx cv clt wbr wi vz cG wral vy cF wrex wi vx cr
      wral cc0 vx cv clt wbr wph cA vx cv cle wbr wi vz cG wral vy cF wrex wi
      vx cr wral cc0 vx cv clt wbr wph cA vx cv clt wbr wi vz cG wral vy cF
      wrex wi cc0 vx cv clt wbr wph cA vx cv cle wbr wi vz cG wral vy cF wrex
      wi vx cr vx cv cr wcel wph cA vx cv clt wbr wi vz cG wral vy cF wrex wph
      cA vx cv cle wbr wi vz cG wral vy cF wrex cc0 vx cv clt wbr vx cv cr wcel
      wph cA vx cv clt wbr wi vz cG wral wph cA vx cv cle wbr wi vz cG wral vy
      cF vx cv cr wcel vy cv cF wcel wa wph cA vx cv clt wbr wi wph cA vx cv
      cle wbr wi vz cG vx cv cr wcel vy cv cF wcel wa vz cv cG wcel wa cA vx cv
      clt wbr cA vx cv cle wbr wph vx cv cr wcel vy cv cF wcel vz cv cG wcel cA
      vx cv clt wbr cA vx cv cle wbr wi vx cv cr wcel cA cr wcel cA vx cv clt
      wbr cA vx cv cle wbr wi vy cv cF wcel vz cv cG wcel wa cA cr wcel vx cv
      cr wcel cA vx cv clt wbr cA vx cv cle wbr wi cA vx cv ltle ancoms cvg2.1
      sylan2 anassrs imim2d r19.20dva r19.22dva imim2d r19.20i cc0 vx cv clt
      wbr wph cA vx cv cle wbr wi vz cG wral vy cF wrex wi vx cr wral cc0 vw cv
      clt wbr wph cA vw cv clt wbr wi vz cG wral vy cF wrex wi vw cr wral cc0
      vx cv clt wbr wph cA vx cv clt wbr wi vz cG wral vy cF wrex wi vx cr wral
      cc0 vx cv clt wbr wph cA vx cv cle wbr wi vz cG wral vy cF wrex wi vx cr
      wral cc0 vw cv clt wbr wph cA vw cv clt wbr wi vz cG wral vy cF wrex wi
      vw cr cc0 vx cv clt wbr wph cA vx cv cle wbr wi vz cG wral vy cF wrex wi
      vx cr wral vw cv c2 cdiv co cr wcel cc0 vw cv c2 cdiv co clt wbr wph cA
      vw cv c2 cdiv co cle wbr wi vz cG wral vy cF wrex wi wi vw cv cr wcel cc0
      vw cv clt wbr wph cA vw cv clt wbr wi vz cG wral vy cF wrex wi wi cc0 vx
      cv clt wbr wph cA vx cv cle wbr wi vz cG wral vy cF wrex wi cc0 vw cv c2
      cdiv co clt wbr wph cA vw cv c2 cdiv co cle wbr wi vz cG wral vy cF wrex
      wi vx vw cv c2 cdiv co cr vx cv vw cv c2 cdiv co wceq cc0 vx cv clt wbr
      cc0 vw cv c2 cdiv co clt wbr wph cA vx cv cle wbr wi vz cG wral vy cF
      wrex wph cA vw cv c2 cdiv co cle wbr wi vz cG wral vy cF wrex vx cv vw cv
      c2 cdiv co cc0 clt breq2 vx cv vw cv c2 cdiv co wceq wph cA vx cv cle wbr
      wi wph cA vw cv c2 cdiv co cle wbr wi vy vz cF cG vx cv vw cv c2 cdiv co
      wceq cA vx cv cle wbr cA vw cv c2 cdiv co cle wbr wph vx cv vw cv c2 cdiv
      co cA cle breq2 imbi2d rexralbidv imbi12d rcla4cv vw cv c2 cdiv co cr
      wcel cc0 vw cv c2 cdiv co clt wbr wph cA vw cv c2 cdiv co cle wbr wi vz
      cG wral vy cF wrex wi wi vw cv cr wcel cc0 vw cv clt wbr wph cA vw cv clt
      wbr wi vz cG wral vy cF wrex vw cv cr wcel cc0 vw cv clt wbr wa vw cv c2
      cdiv co cr wcel cc0 vw cv c2 cdiv co clt wbr wph cA vw cv c2 cdiv co cle
      wbr wi vz cG wral vy cF wrex wi wi wph cA vw cv clt wbr wi vz cG wral vy
      cF wrex vw cv cr wcel cc0 vw cv clt wbr wa vw cv c2 cdiv co cr wcel cc0
      vw cv c2 cdiv co clt wbr wph cA vw cv c2 cdiv co cle wbr wi vz cG wral vy
      cF wrex wi wi wph cA vw cv c2 cdiv co cle wbr wi vz cG wral vy cF wrex
      wph cA vw cv clt wbr wi vz cG wral vy cF wrex vw cv cr wcel cc0 vw cv clt
      wbr wa wph cA vw cv c2 cdiv co cle wbr wi vz cG wral vy cF wrex vw cv c2
      cdiv co cr wcel cc0 vw cv c2 cdiv co clt wbr wa wph cA vw cv c2 cdiv co
      cle wbr wi vz cG wral vy cF wrex wi vw cv c2 cdiv co cr wcel cc0 vw cv c2
      cdiv co clt wbr wph cA vw cv c2 cdiv co cle wbr wi vz cG wral vy cF wrex
      wi wi vw cv c2 cdiv co cr wcel cc0 vw cv c2 cdiv co clt wbr wph cA vw cv
      c2 cdiv co cle wbr wi vz cG wral vy cF wrex vw cv c2 cdiv co cr wcel cc0
      vw cv c2 cdiv co clt wbr wa wph cA vw cv c2 cdiv co cle wbr wi vz cG wral
      vy cF wrex wi wb vw cv cr wcel cc0 vw cv clt wbr wa vw cv c2 cdiv co cr
      wcel cc0 vw cv c2 cdiv co clt wbr wa wph cA vw cv c2 cdiv co cle wbr wi
      vz cG wral vy cF wrex biimt vw cv cr wcel vw cv c2 cdiv co cr wcel cc0 vw
      cv clt wbr vw cv rehalfcl adantr vw cv cr wcel cc0 vw cv clt wbr cc0 vw
      cv c2 cdiv co clt wbr vw cv halfpos2 biimpa sylanc vw cv c2 cdiv co cr
      wcel cc0 vw cv c2 cdiv co clt wbr wph cA vw cv c2 cdiv co cle wbr wi vz
      cG wral vy cF wrex impexp syl6bb vw cv cr wcel cc0 vw cv clt wbr wa wph
      cA vw cv c2 cdiv co cle wbr wi vz cG wral wph cA vw cv clt wbr wi vz cG
      wral vy cF vw cv cr wcel cc0 vw cv clt wbr wa vy cv cF wcel wa wph cA vw
      cv c2 cdiv co cle wbr wi wph cA vw cv clt wbr wi vz cG vw cv cr wcel cc0
      vw cv clt wbr wa vy cv cF wcel wa vz cv cG wcel wa cA vw cv c2 cdiv co
      cle wbr cA vw cv clt wbr wph vw cv cr wcel cc0 vw cv clt wbr wa vy cv cF
      wcel vz cv cG wcel cA vw cv c2 cdiv co cle wbr cA vw cv clt wbr wi vw cv
      cr wcel cc0 vw cv clt wbr wa cA cr wcel cA vw cv c2 cdiv co cle wbr cA vw
      cv clt wbr wi vy cv cF wcel vz cv cG wcel wa vw cv cr wcel cc0 vw cv clt
      wbr wa cA cr wcel wa cA vw cv c2 cdiv co cle wbr vw cv c2 cdiv co vw cv
      clt wbr cA vw cv clt wbr vw cv cr wcel cc0 vw cv clt wbr wa vw cv c2 cdiv
      co vw cv clt wbr cA cr wcel vw cv cr wcel cc0 vw cv clt wbr vw cv c2 cdiv
      co vw cv clt wbr vw cv halfpos biimpa adantr cA cr wcel vw cv c2 cdiv co
      cr wcel vw cv cr wcel cA vw cv c2 cdiv co cle wbr vw cv c2 cdiv co vw cv
      clt wbr wa cA vw cv clt wbr wi vw cv cr wcel cc0 vw cv clt wbr wa cA cr
      wcel wa cA vw cv c2 cdiv co vw cv lelttr vw cv cr wcel cc0 vw cv clt wbr
      wa cA cr wcel pm3.27 vw cv cr wcel vw cv c2 cdiv co cr wcel cc0 vw cv clt
      wbr cA cr wcel vw cv rehalfcl ad2antrr vw cv cr wcel cc0 vw cv clt wbr cA
      cr wcel simpll syl3anc mpan2d cvg2.1 sylan2 anassrs imim2d r19.20dva
      r19.22dva sylbird com12 exp3a syl r19.21aiv cc0 vw cv clt wbr wph cA vw
      cv clt wbr wi vz cG wral vy cF wrex wi cc0 vx cv clt wbr wph cA vx cv clt
      wbr wi vz cG wral vy cF wrex wi vw vx cr vw cv vx cv wceq cc0 vw cv clt
      wbr cc0 vx cv clt wbr wph cA vw cv clt wbr wi vz cG wral vy cF wrex wph
      cA vx cv clt wbr wi vz cG wral vy cF wrex vw cv vx cv cc0 clt breq2 vw cv
      vx cv wceq wph cA vw cv clt wbr wi wph cA vx cv clt wbr wi vy vz cF cG vw
      cv vx cv wceq cA vw cv clt wbr cA vx cv clt wbr wph vw cv vx cv cA clt
      breq2 imbi2d rexralbidv imbi12d cbvralv sylib impbii $.
      $( [1-Aug-2005] $) $( [10-Apr-2005] $)
  $}

  ${
    $d j k M $.  $d k m N $.  $d k W $.  $d j k m Z $.  $d j m ph $.
    cvg3.1 $e |- M e. ZZ $.
    cvg3.2 $e |- ( ZZ>= ` M ) C_ Z $.
    cvg3.3 $e |- Z C_ ZZ $.
    cvg3.4 $e |- N e. ZZ $.
    cvg3.5 $e |- ( ZZ>= ` N ) C_ W $.
    cvg3.6 $e |- W C_ ZZ $.
    $( A relationship used to derive two ways to express convergence.  ` ph `
       is ` ph ( k ) ` . $)
    cvg3i $p |- ( E. j e. ZZ A. k e. ZZ ( j <_ k -> ph ) <->
               E. j e. Z A. k e. W ( j <_ k -> ph ) ) $=
      vj cv vk cv cle wbr wph wi vk cz wral vj cz wrex vm cv vk cv cle wbr wph
      wi vk cz wral vm cz wrex vj cv vk cv cle wbr wph wi vk cW wral vj cZ wrex
      vj cv vk cv cle wbr wph wi vk cz wral vm cv vk cv cle wbr wph wi vk cz
      wral vj vm cz vj cv vm cv wceq vj cv vk cv cle wbr wph wi vm cv vk cv cle
      wbr wph wi vk cz vj cv vm cv wceq vj cv vk cv cle wbr vm cv vk cv cle wbr
      wph vj cv vm cv vk cv cle breq1 imbi1d ralbidv cbvrexv vm cv vk cv cle
      wbr wph wi vk cz wral vm cz wrex vj cv vk cv cle wbr wph wi vk cW wral vj
      cZ wrex vm cv vk cv cle wbr wph wi vk cz wral vm cz wrex vj cv vk cv cle
      wbr wph wi vk cz wral vj cZ wrex vj cv vk cv cle wbr wph wi vk cW wral vj
      cZ wrex vm cv vk cv cle wbr wph wi vk cz wral vj cv vk cv cle wbr wph wi
      vk cz wral vj cZ wrex vm cz vm cv cz wcel vm cv vk cv cle wbr wph wi vk
      cz wral vj cv vk cv cle wbr wph wi vk cz wral vj cZ wrex wi cM vm cv cM
      cr wcel vm cv cz wcel cM cvg3.1 zrei a1i vm cv zre vm cv cz wcel cM vm cv
      cle wbr wa vm cv vk cv cle wbr wph wi vk cz wral vj cv vk cv cle wbr wph
      wi vk cz wral vj cZ wrex vm cv cZ wcel vm cv vk cv cle wbr wph wi vk cz
      wral vj cv vk cv cle wbr wph wi vk cz wral vj cZ wrex vm cv cz wcel cM vm
      cv cle wbr wa vj cv vk cv cle wbr wph wi vk cz wral vm cv vk cv cle wbr
      wph wi vk cz wral vj vm cv cZ vj cv vm cv wceq vj cv vk cv cle wbr wph wi
      vm cv vk cv cle wbr wph wi vk cz vj cv vm cv wceq vj cv vk cv cle wbr vm
      cv vk cv cle wbr wph vj cv vm cv vk cv cle breq1 imbi1d ralbidv rcla4ev
      vm cv cz wcel cM vm cv cle wbr wa vm cv cM cuz cfv wcel vm cv cZ wcel cM
      vm cv cvg3.1 eluz1i cM cuz cfv cZ vm cv cvg3.2 sseli sylbir sylan ex vm
      cv cz wcel vm cv cM cle wbr wa vm cv vk cv cle wbr wph wi vk cz wral cM
      vk cv cle wbr wph wi vk cz wral vj cv vk cv cle wbr wph wi vk cz wral vj
      cZ wrex vm cv cz wcel vm cv cM cle wbr wa vm cv vk cv cle wbr wph wi cM
      vk cv cle wbr wph wi vk cz vm cv cz wcel vm cv cM cle wbr wa vk cv cz
      wcel wa cM vk cv cle wbr vm cv vk cv cle wbr wph vm cv cz wcel vk cv cz
      wcel vm cv cM cle wbr cM vk cv cle wbr vm cv vk cv cle wbr wi vm cv cz
      wcel vk cv cz wcel wa vm cv cM cle wbr cM vk cv cle wbr vm cv vk cv cle
      wbr vm cv cr wcel vk cv cr wcel vm cv cM cle wbr cM vk cv cle wbr wa vm
      cv vk cv cle wbr wi vm cv cz wcel vk cv cz wcel vm cv cr wcel cM cr wcel
      vk cv cr wcel vm cv cM cle wbr cM vk cv cle wbr wa vm cv vk cv cle wbr wi
      cM cvg3.1 zrei vm cv cM vk cv letr mp3an2 vm cv zre vk cv zre syl2an
      expdimp an1rs imim1d r19.20dva cM cZ wcel cM vk cv cle wbr wph wi vk cz
      wral vj cv vk cv cle wbr wph wi vk cz wral vj cZ wrex cM cuz cfv cZ cM
      cvg3.2 cM cz wcel cM cM cuz cfv wcel cvg3.1 cM uzid ax-mp sselii vj cv vk
      cv cle wbr wph wi vk cz wral cM vk cv cle wbr wph wi vk cz wral vj cM cZ
      vj cv cM wceq vj cv vk cv cle wbr wph wi cM vk cv cle wbr wph wi vk cz vj
      cv cM wceq vj cv vk cv cle wbr cM vk cv cle wbr wph vj cv cM vk cv cle
      breq1 imbi1d ralbidv rcla4ev mpan syl6 lecasei r19.23aiv vj cv vk cv cle
      wbr wph wi vk cz wral vj cv vk cv cle wbr wph wi vk cW wral vj cZ cW cz
      wss vj cv vk cv cle wbr wph wi vk cz wral vj cv vk cv cle wbr wph wi vk
      cW wral wi cvg3.6 vj cv vk cv cle wbr wph wi vk cW cz ssralv ax-mp
      r19.22si syl vj cv vk cv cle wbr wph wi vk cW wral vm cv vk cv cle wbr
      wph wi vk cz wral vm cz wrex vj cZ vj cv cZ wcel cN vj cv cle wbr vj cv
      cN cle wbr wo vj cv vk cv cle wbr wph wi vk cW wral vm cv vk cv cle wbr
      wph wi vk cz wral vm cz wrex wi cN cr wcel vj cv cr wcel cN vj cv cle wbr
      vj cv cN cle wbr wo vj cv cZ wcel cN vj cv letric cN cvg3.4 zrei vj cv cZ
      wcel vj cv cz wcel vj cv cr wcel cZ cz vj cv cvg3.3 sseli vj cv zre syl
      sylancr vj cv cZ wcel cN vj cv cle wbr vj cv cN cle wbr wo wa cN vk cv
      cle wbr vj cv vk cv cle wbr wa wph wi vk cz wral vm cv vk cv cle wbr wph
      wi vk cz wral vm cz wrex vj cv vk cv cle wbr wph wi vk cW wral vj cv cZ
      wcel cN vj cv cle wbr cN vk cv cle wbr vj cv vk cv cle wbr wa wph wi vk
      cz wral vm cv vk cv cle wbr wph wi vk cz wral vm cz wrex wi vj cv cN cle
      wbr vj cv cZ wcel cN vj cv cle wbr wa cN vk cv cle wbr vj cv vk cv cle
      wbr wa wph wi vk cz wral vj cv cz wcel vj cv vk cv cle wbr wph wi vk cz
      wral wa vm cv vk cv cle wbr wph wi vk cz wral vm cz wrex vj cv cZ wcel cN
      vj cv cle wbr wa cN vk cv cle wbr vj cv vk cv cle wbr wa wph wi vk cz
      wral vj cv vk cv cle wbr wph wi vk cz wral vj cv cz wcel vj cv cZ wcel cN
      vj cv cle wbr wa cN vk cv cle wbr vj cv vk cv cle wbr wa wph wi vj cv vk
      cv cle wbr wph wi vk cz vj cv cZ wcel cN vj cv cle wbr wa vk cv cz wcel
      wa vj cv vk cv cle wbr cN vk cv cle wbr vj cv vk cv cle wbr wa wph vj cv
      cZ wcel cN vj cv cle wbr wa vk cv cz wcel wa vj cv vk cv cle wbr cN vk cv
      cle wbr vj cv cZ wcel vk cv cz wcel cN vj cv cle wbr vj cv vk cv cle wbr
      cN vk cv cle wbr wi vj cv cZ wcel vk cv cz wcel wa cN vj cv cle wbr vj cv
      vk cv cle wbr cN vk cv cle wbr vj cv cr wcel vk cv cr wcel cN vj cv cle
      wbr vj cv vk cv cle wbr wa cN vk cv cle wbr wi vj cv cZ wcel vk cv cz
      wcel cN cr wcel vj cv cr wcel vk cv cr wcel cN vj cv cle wbr vj cv vk cv
      cle wbr wa cN vk cv cle wbr wi cN cvg3.4 zrei cN vj cv vk cv letr mp3an1
      vj cv cZ wcel vj cv cz wcel vj cv cr wcel cZ cz vj cv cvg3.3 sseli vj cv
      zre syl vk cv zre syl2an expdimp an1rs ancrd imim1d r19.20dva vj cv cZ
      wcel vj cv cz wcel cN vj cv cle wbr cZ cz vj cv cvg3.3 sseli adantr
      jctild vm cv vk cv cle wbr wph wi vk cz wral vj cv vk cv cle wbr wph wi
      vk cz wral vm vj cv cz vm cv vj cv wceq vm cv vk cv cle wbr wph wi vj cv
      vk cv cle wbr wph wi vk cz vm cv vj cv wceq vm cv vk cv cle wbr vj cv vk
      cv cle wbr wph vm cv vj cv vk cv cle breq1 imbi1d ralbidv rcla4ev syl6 vj
      cv cZ wcel vj cv cN cle wbr wa cN vk cv cle wbr vj cv vk cv cle wbr wa
      wph wi vk cz wral cN cz wcel cN vk cv cle wbr wph wi vk cz wral wa vm cv
      vk cv cle wbr wph wi vk cz wral vm cz wrex vj cv cZ wcel vj cv cN cle wbr
      wa cN vk cv cle wbr vj cv vk cv cle wbr wa wph wi vk cz wral cN cz wcel
      cN vk cv cle wbr wph wi vk cz wral vj cv cZ wcel vj cv cN cle wbr wa cN
      vk cv cle wbr vj cv vk cv cle wbr wa wph wi vk cz wral cN cz wcel cvg3.4
      a1i12 vj cv cZ wcel vj cv cN cle wbr wa cN vk cv cle wbr vj cv vk cv cle
      wbr wa wph wi cN vk cv cle wbr wph wi vk cz vj cv cZ wcel vj cv cN cle
      wbr wa vk cv cz wcel wa cN vk cv cle wbr cN vk cv cle wbr vj cv vk cv cle
      wbr wa wph vj cv cZ wcel vj cv cN cle wbr wa vk cv cz wcel wa cN vk cv
      cle wbr vj cv vk cv cle wbr vj cv cZ wcel vk cv cz wcel vj cv cN cle wbr
      cN vk cv cle wbr vj cv vk cv cle wbr wi vj cv cZ wcel vk cv cz wcel wa vj
      cv cN cle wbr cN vk cv cle wbr vj cv vk cv cle wbr vj cv cr wcel vk cv cr
      wcel vj cv cN cle wbr cN vk cv cle wbr wa vj cv vk cv cle wbr wi vj cv cZ
      wcel vk cv cz wcel vj cv cr wcel cN cr wcel vk cv cr wcel vj cv cN cle
      wbr cN vk cv cle wbr wa vj cv vk cv cle wbr wi cN cvg3.4 zrei vj cv cN vk
      cv letr mp3an2 vj cv cZ wcel vj cv cz wcel vj cv cr wcel cZ cz vj cv
      cvg3.3 sseli vj cv zre syl vk cv zre syl2an expdimp an1rs ancld imim1d
      r19.20dva jcad vm cv vk cv cle wbr wph wi vk cz wral cN vk cv cle wbr wph
      wi vk cz wral vm cN cz vm cv cN wceq vm cv vk cv cle wbr wph wi cN vk cv
      cle wbr wph wi vk cz vm cv cN wceq vm cv vk cv cle wbr cN vk cv cle wbr
      wph vm cv cN vk cv cle breq1 imbi1d ralbidv rcla4ev syl6 jaodan vj cv vk
      cv cle wbr wph wi vk cW wral vj cv vk cv cle wbr wph wi vk cN cuz cfv
      wral cN vk cv cle wbr vj cv vk cv cle wbr wa wph wi vk cz wral cN cuz cfv
      cW wss vj cv vk cv cle wbr wph wi vk cW wral vj cv vk cv cle wbr wph wi
      vk cN cuz cfv wral wi cvg3.5 vj cv vk cv cle wbr wph wi vk cN cuz cfv cW
      ssralv ax-mp vj cv vk cv cle wbr wph wi vk cN cuz cfv wral cN vk cv cle
      wbr vj cv vk cv cle wbr wph wi wi vk cz wral cN vk cv cle wbr vj cv vk cv
      cle wbr wa wph wi vk cz wral cN cz wcel vj cv vk cv cle wbr wph wi vk cN
      cuz cfv wral cN vk cv cle wbr vj cv vk cv cle wbr wph wi wi vk cz wral wb
      cvg3.4 vj cv vk cv cle wbr wph wi vk cN raluz ax-mp cN vk cv cle wbr vj
      cv vk cv cle wbr wa wph wi cN vk cv cle wbr vj cv vk cv cle wbr wph wi wi
      vk cz cN vk cv cle wbr vj cv vk cv cle wbr wph impexp ralbii bitr4i sylib
      syl5 mpdan r19.23aiv impbii bitri $.
      $( [7-Jan-2007] $) $( [27-Dec-2006] $)
  $}

  ${
    $d j k m n $.  $d j m n ph $.  $d j m n ps $.
    $( Equivalence that lets us conjoin the properties of two independent
       converging sequences.  ` k ` may be free in ` ph ` and ` ps ` .  Compare
       ~ r19.40 , where the implication holds in only one direction. $)
    cvganz $p |- ( ( E. j e. ZZ A. k e. ZZ ( j <_ k -> ph ) /\
                E. j e. ZZ A. k e. ZZ ( j <_ k -> ps ) ) <->
                E. j e. ZZ A. k e. ZZ ( j <_ k -> ( ph /\ ps ) ) ) $=
      vj cv vk cv cle wbr wph wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr
      wps wi vk cn0 wral vj cn0 wrex wa vj cv vk cv cle wbr wph wps wa wi vk
      cn0 wral vj cn0 wrex vj cv vk cv cle wbr wph wi vk cz wral vj cz wrex vj
      cv vk cv cle wbr wps wi vk cz wral vj cz wrex wa vj cv vk cv cle wbr wph
      wps wa wi vk cz wral vj cz wrex vj cv vk cv cle wbr wph wi vk cn0 wral vj
      cn0 wrex vj cv vk cv cle wbr wps wi vk cn0 wral vj cn0 wrex wa vj cv vk
      cv cle wbr wph wps wa wi vk cn0 wral vj cn0 wrex vm cv vk cv cle wbr wph
      wi vk cn0 wral vm cn0 wrex vn cv vk cv cle wbr wps wi vk cn0 wral vn cn0
      wrex vj cv vk cv cle wbr wph wps wa wi vk cn0 wral vj cn0 wrex vj cv vk
      cv cle wbr wph wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr wps wi vk
      cn0 wral vj cn0 wrex vm cv vk cv cle wbr wph wi vk cn0 wral vm cn0 wrex
      vn cv vk cv cle wbr wps wi vk cn0 wral vn cn0 wrex wa vm cv vk cv cle wbr
      wph wi vk cn0 wral vn cv vk cv cle wbr wps wi vk cn0 wral wa vn cn0 wrex
      vm cn0 wrex vj cv vk cv cle wbr wph wps wa wi vk cn0 wral vj cn0 wrex vm
      cv vk cv cle wbr wph wi vk cn0 wral vn cv vk cv cle wbr wps wi vk cn0
      wral vm vn cn0 cn0 reeanv vm cv vk cv cle wbr wph wi vk cn0 wral vn cv vk
      cv cle wbr wps wi vk cn0 wral wa vj cv vk cv cle wbr wph wps wa wi vk cn0
      wral vj cn0 wrex vm vn cn0 cn0 vm cv cn0 wcel vn cv cn0 wcel wa vm cv vk
      cv cle wbr wph wi vk cn0 wral vn cv vk cv cle wbr wps wi vk cn0 wral wa
      vm cv vn cv caddc co cn0 wcel vm cv vn cv caddc co vk cv cle wbr wph wps
      wa wi vk cn0 wral wa vj cv vk cv cle wbr wph wps wa wi vk cn0 wral vj cn0
      wrex vm cv cn0 wcel vn cv cn0 wcel wa vm cv vk cv cle wbr wph wi vk cn0
      wral vn cv vk cv cle wbr wps wi vk cn0 wral wa vm cv vn cv caddc co vk cv
      cle wbr wph wps wa wi vk cn0 wral vm cv vn cv caddc co cn0 wcel vm cv cn0
      wcel vn cv cn0 wcel wa vm cv vk cv cle wbr wph wi vn cv vk cv cle wbr wps
      wi wa vk cn0 wral vm cv vn cv caddc co vk cv cle wbr wph wps wa wi vk cn0
      wral vm cv vk cv cle wbr wph wi vk cn0 wral vn cv vk cv cle wbr wps wi vk
      cn0 wral wa vm cv cn0 wcel vn cv cn0 wcel wa vm cv vk cv cle wbr wph wi
      vn cv vk cv cle wbr wps wi wa vm cv vn cv caddc co vk cv cle wbr wph wps
      wa wi vk cn0 vm cv cn0 wcel vn cv cn0 wcel wa vk cv cn0 wcel wa vm cv vn
      cv caddc co vk cv cle wbr vm cv vk cv cle wbr vn cv vk cv cle wbr wa vm
      cv vk cv cle wbr wph wi vn cv vk cv cle wbr wps wi wa wph wps wa vm cv
      cn0 wcel vn cv cn0 wcel wa vk cv cn0 wcel wa vm cv vn cv caddc co vk cv
      cle wbr vm cv vk cv cle wbr vn cv vk cv cle wbr vm cv cn0 wcel vn cv cn0
      wcel wa vk cv cn0 wcel wa vm cv vm cv vn cv caddc co cle wbr vm cv vn cv
      caddc co vk cv cle wbr vm cv vk cv cle wbr vm cv cn0 wcel vn cv cn0 wcel
      wa vm cv vm cv vn cv caddc co cle wbr vk cv cn0 wcel vm cv cr wcel vn cv
      cn0 wcel vm cv vm cv vn cv caddc co cle wbr vm cv cn0 wcel vm cv vn cv
      nn0addge1 vm cv nn0re sylan adantr vm cv cr wcel vm cv vn cv caddc co cr
      wcel vk cv cr wcel vm cv vm cv vn cv caddc co cle wbr vm cv vn cv caddc
      co vk cv cle wbr wa vm cv vk cv cle wbr wi vm cv cn0 wcel vn cv cn0 wcel
      wa vk cv cn0 wcel wa vm cv vm cv vn cv caddc co vk cv letr vm cv cn0 wcel
      vm cv cr wcel vn cv cn0 wcel vk cv cn0 wcel vm cv nn0re ad2antrr vm cv
      cn0 wcel vn cv cn0 wcel wa vm cv vn cv caddc co cr wcel vk cv cn0 wcel vm
      cv cn0 wcel vn cv cn0 wcel wa vm cv vn cv caddc co cn0 wcel vm cv vn cv
      caddc co cr wcel vm cv vn cv nn0addcl vm cv vn cv caddc co nn0re syl
      adantr vk cv cn0 wcel vk cv cr wcel vm cv cn0 wcel vn cv cn0 wcel wa vk
      cv nn0re adantl syl3anc mpand vm cv cn0 wcel vn cv cn0 wcel wa vk cv cn0
      wcel wa vn cv vm cv vn cv caddc co cle wbr vm cv vn cv caddc co vk cv cle
      wbr vn cv vk cv cle wbr vm cv cn0 wcel vn cv cn0 wcel wa vn cv vm cv vn
      cv caddc co cle wbr vk cv cn0 wcel vn cv cn0 wcel vm cv cn0 wcel vn cv vm
      cv vn cv caddc co cle wbr vn cv cr wcel vm cv cn0 wcel vn cv vm cv vn cv
      caddc co cle wbr vn cv cn0 wcel vn cv vm cv nn0addge2 vn cv nn0re sylan
      ancoms adantr vn cv cr wcel vm cv vn cv caddc co cr wcel vk cv cr wcel vn
      cv vm cv vn cv caddc co cle wbr vm cv vn cv caddc co vk cv cle wbr wa vn
      cv vk cv cle wbr wi vm cv cn0 wcel vn cv cn0 wcel wa vk cv cn0 wcel wa vn
      cv vm cv vn cv caddc co vk cv letr vn cv cn0 wcel vn cv cr wcel vm cv cn0
      wcel vk cv cn0 wcel vn cv nn0re ad2antlr vm cv cn0 wcel vn cv cn0 wcel wa
      vm cv vn cv caddc co cr wcel vk cv cn0 wcel vm cv cn0 wcel vn cv cn0 wcel
      wa vm cv vn cv caddc co cn0 wcel vm cv vn cv caddc co cr wcel vm cv vn cv
      nn0addcl vm cv vn cv caddc co nn0re syl adantr vk cv cn0 wcel vk cv cr
      wcel vm cv cn0 wcel vn cv cn0 wcel wa vk cv nn0re adantl syl3anc mpand
      jcad vm cv vk cv cle wbr wph vn cv vk cv cle wbr wps prth syl9 r19.20dva
      vm cv vk cv cle wbr wph wi vn cv vk cv cle wbr wps wi vk cn0 r19.26
      syl5ibr vm cv vn cv nn0addcl jctild vj cv vk cv cle wbr wph wps wa wi vk
      cn0 wral vm cv vn cv caddc co vk cv cle wbr wph wps wa wi vk cn0 wral vj
      vm cv vn cv caddc co cn0 vj cv vm cv vn cv caddc co wceq vj cv vk cv cle
      wbr wph wps wa wi vm cv vn cv caddc co vk cv cle wbr wph wps wa wi vk cn0
      vj cv vm cv vn cv caddc co wceq vj cv vk cv cle wbr vm cv vn cv caddc co
      vk cv cle wbr wph wps wa vj cv vm cv vn cv caddc co vk cv cle breq1
      imbi1d ralbidv rcla4ev syl6 r19.23aivv sylbir vj cv vk cv cle wbr wph wi
      vk cn0 wral vm cv vk cv cle wbr wph wi vk cn0 wral vj vm cn0 vj cv vm cv
      wceq vj cv vk cv cle wbr wph wi vm cv vk cv cle wbr wph wi vk cn0 vj cv
      vm cv wceq vj cv vk cv cle wbr vm cv vk cv cle wbr wph vj cv vm cv vk cv
      cle breq1 imbi1d ralbidv cbvrexv vj cv vk cv cle wbr wps wi vk cn0 wral
      vn cv vk cv cle wbr wps wi vk cn0 wral vj vn cn0 vj cv vn cv wceq vj cv
      vk cv cle wbr wps wi vn cv vk cv cle wbr wps wi vk cn0 vj cv vn cv wceq
      vj cv vk cv cle wbr vn cv vk cv cle wbr wps vj cv vn cv vk cv cle breq1
      imbi1d ralbidv cbvrexv syl2anb vj cv vk cv cle wbr wph wps wa wi vk cn0
      wral vj cn0 wrex vj cv vk cv cle wbr wph wi vk cn0 wral vj cn0 wrex vj cv
      vk cv cle wbr wps wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr wph wps
      wa wi vk cn0 wral vj cv vk cv cle wbr wph wi vk cn0 wral vj cn0 vj cv vk
      cv cle wbr wph wps wa wi vj cv vk cv cle wbr wph wi vk cn0 wph wps wa wph
      vj cv vk cv cle wbr wph wps pm3.26 imim2i r19.20si r19.22si vj cv vk cv
      cle wbr wph wps wa wi vk cn0 wral vj cv vk cv cle wbr wps wi vk cn0 wral
      vj cn0 vj cv vk cv cle wbr wph wps wa wi vj cv vk cv cle wbr wps wi vk
      cn0 wph wps wa wps vj cv vk cv cle wbr wph wps pm3.27 imim2i r19.20si
      r19.22si jca impbii vj cv vk cv cle wbr wph wi vk cz wral vj cz wrex vj
      cv vk cv cle wbr wph wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr wps
      wi vk cz wral vj cz wrex vj cv vk cv cle wbr wps wi vk cn0 wral vj cn0
      wrex wph vj vk cc0 cc0 cn0 cn0 0z cn0 cc0 cuz cfv nn0uz eqimss2i nn0ssz
      0z cn0 cc0 cuz cfv nn0uz eqimss2i nn0ssz cvg3i wps vj vk cc0 cc0 cn0 cn0
      0z cn0 cc0 cuz cfv nn0uz eqimss2i nn0ssz 0z cn0 cc0 cuz cfv nn0uz
      eqimss2i nn0ssz cvg3i anbi12i wph wps wa vj vk cc0 cc0 cn0 cn0 0z cn0 cc0
      cuz cfv nn0uz eqimss2i nn0ssz 0z cn0 cc0 cuz cfv nn0uz eqimss2i nn0ssz
      cvg3i 3bitr4i $.
      $( [21-Dec-2006] $) $( [18-Dec-2006] $)
  $}

  ${
    $d j k M $.  $d j k Z $.  $d j ph $.  $d j ps $.
    cvganuz.1 $e |- M e. ZZ $.
    cvganuz.2 $e |- Z = ( ZZ>= ` M ) $.
    $( Lemma that lets us combine the properties of two independent converging
       sequences.  ` k ` may be free in ` ph ` and ` ps ` . $)
    cvganuzi $p |- ( ( E. j e. Z A. k e. Z ( j <_ k -> ph ) /\
                E. j e. Z A. k e. Z ( j <_ k -> ps ) ) <->
                E. j e. Z A. k e. Z ( j <_ k -> ( ph /\ ps ) ) ) $=
      vj cv vk cv cle wbr wph wi vk cz wral vj cz wrex vj cv vk cv cle wbr wps
      wi vk cz wral vj cz wrex wa vj cv vk cv cle wbr wph wps wa wi vk cz wral
      vj cz wrex vj cv vk cv cle wbr wph wi vk cZ wral vj cZ wrex vj cv vk cv
      cle wbr wps wi vk cZ wral vj cZ wrex wa vj cv vk cv cle wbr wph wps wa wi
      vk cZ wral vj cZ wrex wph wps vj vk cvganz vj cv vk cv cle wbr wph wi vk
      cz wral vj cz wrex vj cv vk cv cle wbr wph wi vk cZ wral vj cZ wrex vj cv
      vk cv cle wbr wps wi vk cz wral vj cz wrex vj cv vk cv cle wbr wps wi vk
      cZ wral vj cZ wrex wph vj vk cM cM cZ cZ cvganuz.1 cZ cM cuz cfv
      cvganuz.2 eqimss2i cZ cM cuz cfv cz cvganuz.2 cM uzssz eqsstri cvganuz.1
      cZ cM cuz cfv cvganuz.2 eqimss2i cZ cM cuz cfv cz cvganuz.2 cM uzssz
      eqsstri cvg3i wps vj vk cM cM cZ cZ cvganuz.1 cZ cM cuz cfv cvganuz.2
      eqimss2i cZ cM cuz cfv cz cvganuz.2 cM uzssz eqsstri cvganuz.1 cZ cM cuz
      cfv cvganuz.2 eqimss2i cZ cM cuz cfv cz cvganuz.2 cM uzssz eqsstri cvg3i
      anbi12i wph wps wa vj vk cM cM cZ cZ cvganuz.1 cZ cM cuz cfv cvganuz.2
      eqimss2i cZ cM cuz cfv cz cvganuz.2 cM uzssz eqsstri cvganuz.1 cZ cM cuz
      cfv cvganuz.2 eqimss2i cZ cM cuz cfv cz cvganuz.2 cM uzssz eqsstri cvg3i
      3bitr3i $.
      $( [24-Dec-2006] $) $( [18-Dec-2006] $)
  $}

  ${
    $d x y z w u t F $.
    caubnd.1 $e |- F : NN --> CC $.
    caubnd.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    $( A Cauchy sequence of complex numbers is bounded. $)
    caubndi $p |- E. x e. RR A. y e. NN ( abs ` ( F ` y ) ) < x $=
      vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi vy cn wral vu
      cr wrex vw cn wrex vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vx cr
      wrex vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1
      clt wbr wi vy cn wral vw cn wrex vw cv vy cv clt wbr vy cv cF cfv cabs
      cfv vu cv clt wbr wi vy cn wral vu cr wrex vw cn wrex cc0 c1 clt wbr vw
      cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr wi
      vy cn wral vw cn wrex lt01 c1 cr wcel cc0 vz cv clt wbr vw cv vy cv clt
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral cc0 c1 clt wbr vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr wi vy cn wral vw cn wrex wi
      1re caubnd.2 cc0 vz cv clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi cc0 c1 clt
      wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1 clt
      wbr wi vy cn wral vw cn wrex wi vz c1 cr vz cv c1 wceq cc0 vz cv clt wbr
      cc0 c1 clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr wi vy cn wral vw cn wrex vz
      cv c1 cc0 clt breq2 vz cv c1 wceq vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vz cv clt wbr wi vw cv vy cv clt wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv c1 clt wbr wi vw vy cn cn vz cv c1 wceq vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv c1 clt wbr vw cv vy cv clt wbr vz cv c1 vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv clt breq2 imbi2d rexralbidv imbi12d
      rcla4v mp2 ax-mp vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv c1 clt wbr wi vy cn wral vw cv vy cv clt wbr vy cv cF cfv cabs
      cfv vu cv clt wbr wi vy cn wral vu cr wrex vw cn vw cv cn wcel vw cv vy
      cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr wi vy cn
      wral c1 vw cv cF cfv cabs cfv caddc co cr wcel vw cv vy cv clt wbr vy cv
      cF cfv cabs cfv c1 vw cv cF cfv cabs cfv caddc co clt wbr wi vy cn wral
      wa vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi vy cn wral
      vu cr wrex vw cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv c1 clt wbr wi vy cn wral vw cv vy cv clt wbr vy cv cF
      cfv cabs cfv c1 vw cv cF cfv cabs cfv caddc co clt wbr wi vy cn wral c1
      vw cv cF cfv cabs cfv caddc co cr wcel vw cv cn wcel vw cv vy cv clt wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr wi vw cv vy cv clt
      wbr vy cv cF cfv cabs cfv c1 vw cv cF cfv cabs cfv caddc co clt wbr wi vy
      cn vw cv cn wcel vy cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv c1 clt wbr vy cv cF cfv cabs cfv c1 vw cv cF cfv cabs cfv caddc co
      clt wbr vw cv vy cv clt wbr vy cv cn wcel vw cv cn wcel vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv c1 clt wbr vy cv cF cfv cabs cfv c1 vw cv cF
      cfv cabs cfv caddc co clt wbr wi vy cv cn wcel vw cv cn wcel wa vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vw cv cF cfv cabs cfv caddc co c1 vw cv cF cfv cabs cfv
      caddc co clt wbr vy cv cF cfv cabs cfv c1 vw cv cF cfv cabs cfv caddc co
      clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vw cv cF cfv
      cabs cfv cr wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1 clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co c1
      vw cv cF cfv cabs cfv caddc co clt wbr wb vy cv cn wcel vw cv cn wcel wa
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel c1 cr wcel vw cv cF
      cfv cabs cfv cr wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv c1 clt
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv
      caddc co c1 vw cv cF cfv cabs cfv caddc co clt wbr wb 1re vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv c1 vw cv cF cfv cabs cfv ltadd1 mp3an2 vy cv
      cn wcel vw cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co cc wcel vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vy cv cF cfv cc wcel vw cv
      cF cfv cc wcel vy cv cF cfv vw cv cF cfv cmin co cc wcel vy cv cn wcel vw
      cv cn wcel vy cv cF cfv vw cv cF cfv subcl cn cc vy cv cF caubnd.1
      ffvelrni cn cc vw cv cF caubnd.1 ffvelrni syl2an vy cv cF cfv vw cv cF
      cfv cmin co abscl syl vw cv cn wcel vw cv cF cfv cabs cfv cr wcel vy cv
      cn wcel vw cv cn wcel vw cv cF cfv cc wcel vw cv cF cfv cabs cfv cr wcel
      cn cc vw cv cF caubnd.1 ffvelrni vw cv cF cfv abscl syl adantl sylanc vy
      cv cn wcel vw cv cn wcel wa vy cv cF cfv cabs cfv vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co cle wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co c1 vw cv cF
      cfv cabs cfv caddc co clt wbr vy cv cF cfv cabs cfv c1 vw cv cF cfv cabs
      cfv caddc co clt wbr vy cv cn wcel vw cv cn wcel wa vy cv cF cfv vw cv cF
      cfv cmin co vw cv cF cfv caddc co cabs cfv vy cv cF cfv cabs cfv vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co cle vy
      cv cn wcel vw cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co vw cv cF
      cfv caddc co vy cv cF cfv cabs vy cv cF cfv cc wcel vw cv cF cfv cc wcel
      vy cv cF cfv vw cv cF cfv cmin co vw cv cF cfv caddc co vy cv cF cfv wceq
      vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv cF cfv npcan cn cc vy cv
      cF caubnd.1 ffvelrni cn cc vw cv cF caubnd.1 ffvelrni syl2an fveq2d vy cv
      cF cfv vw cv cF cfv cmin co cc wcel vw cv cF cfv cc wcel vy cv cF cfv vw
      cv cF cfv cmin co vw cv cF cfv caddc co cabs cfv vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co cle wbr vy cv cn wcel
      vw cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co vw cv cF cfv abstri vy
      cv cF cfv cc wcel vw cv cF cfv cc wcel vy cv cF cfv vw cv cF cfv cmin co
      cc wcel vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv cF cfv subcl cn cc
      vy cv cF caubnd.1 ffvelrni cn cc vw cv cF caubnd.1 ffvelrni syl2an vw cv
      cn wcel vw cv cF cfv cc wcel vy cv cn wcel cn cc vw cv cF caubnd.1
      ffvelrni adantl sylanc eqbrtrrd vy cv cF cfv cabs cfv cr wcel vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co cr wcel
      c1 vw cv cF cfv cabs cfv caddc co cr wcel vy cv cF cfv cabs cfv vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co cle wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv cabs cfv caddc co
      c1 vw cv cF cfv cabs cfv caddc co clt wbr wa vy cv cF cfv cabs cfv c1 vw
      cv cF cfv cabs cfv caddc co clt wbr wi vy cv cn wcel vw cv cn wcel wa vy
      cv cF cfv cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv vw cv cF
      cfv cabs cfv caddc co c1 vw cv cF cfv cabs cfv caddc co lelttr vy cv cn
      wcel vy cv cF cfv cabs cfv cr wcel vw cv cn wcel vy cv cn wcel vy cv cF
      cfv cc wcel vy cv cF cfv cabs cfv cr wcel cn cc vy cv cF caubnd.1
      ffvelrni vy cv cF cfv abscl syl adantr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv cr wcel vw cv cF cfv cabs cfv cr wcel vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vw cv cF cfv cabs cfv caddc co cr wcel vy cv cn wcel vw
      cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv
      cabs cfv readdcl vy cv cn wcel vw cv cn wcel wa vy cv cF cfv vw cv cF cfv
      cmin co cc wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vy cv
      cF cfv cc wcel vw cv cF cfv cc wcel vy cv cF cfv vw cv cF cfv cmin co cc
      wcel vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv cF cfv subcl cn cc vy
      cv cF caubnd.1 ffvelrni cn cc vw cv cF caubnd.1 ffvelrni syl2an vy cv cF
      cfv vw cv cF cfv cmin co abscl syl vw cv cn wcel vw cv cF cfv cabs cfv cr
      wcel vy cv cn wcel vw cv cn wcel vw cv cF cfv cc wcel vw cv cF cfv cabs
      cfv cr wcel cn cc vw cv cF caubnd.1 ffvelrni vw cv cF cfv abscl syl
      adantl sylanc vw cv cn wcel c1 vw cv cF cfv cabs cfv caddc co cr wcel vy
      cv cn wcel c1 cr wcel vw cv cF cfv cabs cfv cr wcel c1 vw cv cF cfv cabs
      cfv caddc co cr wcel vw cv cn wcel c1 vw cv cF cfv cabs cfv readdcl 1re
      vw cv cn wcel vw cv cF cfv cc wcel vw cv cF cfv cabs cfv cr wcel cn cc vw
      cv cF caubnd.1 ffvelrni vw cv cF cfv abscl syl sylancr adantl syl3anc
      mpand sylbid ancoms imim2d r19.20dva c1 cr wcel vw cv cF cfv cabs cfv cr
      wcel c1 vw cv cF cfv cabs cfv caddc co cr wcel vw cv cn wcel c1 vw cv cF
      cfv cabs cfv readdcl 1re vw cv cn wcel vw cv cF cfv cc wcel vw cv cF cfv
      cabs cfv cr wcel cn cc vw cv cF caubnd.1 ffvelrni vw cv cF cfv abscl syl
      sylancr jctild vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi
      vy cn wral vw cv vy cv clt wbr vy cv cF cfv cabs cfv c1 vw cv cF cfv cabs
      cfv caddc co clt wbr wi vy cn wral vu c1 vw cv cF cfv cabs cfv caddc co
      cr vu cv c1 vw cv cF cfv cabs cfv caddc co wceq vw cv vy cv clt wbr vy cv
      cF cfv cabs cfv vu cv clt wbr wi vw cv vy cv clt wbr vy cv cF cfv cabs
      cfv c1 vw cv cF cfv cabs cfv caddc co clt wbr wi vy cn vu cv c1 vw cv cF
      cfv cabs cfv caddc co wceq vy cv cF cfv cabs cfv vu cv clt wbr vy cv cF
      cfv cabs cfv c1 vw cv cF cfv cabs cfv caddc co clt wbr vw cv vy cv clt
      wbr vu cv c1 vw cv cF cfv cabs cfv caddc co vy cv cF cfv cabs cfv clt
      breq2 imbi2d ralbidv rcla4ev syl6 r19.22i ax-mp vw cv vy cv clt wbr vy cv
      cF cfv cabs cfv vu cv clt wbr wi vy cn wral vu cr wrex vy cv cF cfv cabs
      cfv vx cv clt wbr vy cn wral vx cr wrex vw cn vw cv cn wcel vy cv vw cv
      cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vy cn wral vt cr wrex vw
      cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi vy cn wral vu cr
      wrex vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vx cr wrex wi vt vy
      vw cv cF caubnd.1 seq1bndi vw cv cn wcel vy cv vw cv cle wbr vy cv cF cfv
      cabs cfv vt cv clt wbr wi vy cn wral vw cv vy cv clt wbr vy cv cF cfv
      cabs cfv vu cv clt wbr wi vy cn wral vu cr wrex vy cv cF cfv cabs cfv vx
      cv clt wbr vy cn wral vx cr wrex wi vt cr vw cv cn wcel vt cv cr wcel vy
      cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vy cn wral vw cv
      vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi vy cn wral vu cr
      wrex vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vx cr wrex wi vw cv
      cn wcel vt cv cr wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv
      clt wbr wi vy cn wral wa vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv
      clt wbr wi vy cn wral vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vx
      cr wrex vu cr vw cv cn wcel vt cv cr wcel wa vy cv vw cv cle wbr vy cv cF
      cfv cabs cfv vt cv clt wbr wi vy cn wral vu cv cr wcel vw cv vy cv clt
      wbr vy cv cF cfv cabs cfv vu cv clt wbr wi vy cn wral vy cv cF cfv cabs
      cfv vx cv clt wbr vy cn wral vx cr wrex wi wi vw cv cn wcel vt cv cr wcel
      wa vu cv cr wcel vy cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt wbr
      wi vy cn wral vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi
      vy cn wral vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vx cr wrex wi
      vw cv cn wcel vt cv cr wcel wa vu cv cr wcel vy cv vw cv cle wbr vy cv cF
      cfv cabs cfv vt cv clt wbr wi vy cn wral vw cv vy cv clt wbr vy cv cF cfv
      cabs cfv vu cv clt wbr wi vy cn wral vy cv cF cfv cabs cfv vx cv clt wbr
      vy cn wral vx cr wrex vw cv cn wcel vt cv cr wcel wa vu cv cr wcel wa vy
      cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vw cv vy cv clt
      wbr vy cv cF cfv cabs cfv vu cv clt wbr wi wa vy cn wral vy cv cF cfv
      cabs cfv vx cv clt wbr vy cn wral vx cr wrex vy cv vw cv cle wbr vy cv cF
      cfv cabs cfv vt cv clt wbr wi vy cn wral vw cv vy cv clt wbr vy cv cF cfv
      cabs cfv vu cv clt wbr wi vy cn wral wa vw cv cn wcel vt cv cr wcel wa vu
      cv cr wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi
      vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi wa vy cn wral
      vu cv vt cv cle wbr vt cv vu cv cif cr wcel vy cv cF cfv cabs cfv vu cv
      vt cv cle wbr vt cv vu cv cif clt wbr vy cn wral wa vy cv cF cfv cabs cfv
      vx cv clt wbr vy cn wral vx cr wrex vw cv cn wcel vt cv cr wcel wa vu cv
      cr wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vw
      cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi wa vy cn wral vy
      cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr vy cn wral
      vu cv vt cv cle wbr vt cv vu cv cif cr wcel vw cv cn wcel vt cv cr wcel
      wa vu cv cr wcel wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt
      wbr wi vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi wa vy
      cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr vy cn vw
      cv cn wcel vt cv cr wcel wa vu cv cr wcel wa vy cv cn wcel wa vy cv vw cv
      cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vw cv vy cv clt wbr vy cv
      cF cfv cabs cfv vu cv clt wbr wi wa vy cv vw cv cle wbr vw cv vy cv clt
      wbr wo vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr
      vw cv cn wcel vt cv cr wcel wa vy cv cn wcel vy cv vw cv cle wbr vw cv vy
      cv clt wbr wo vu cv cr wcel vw cv cn wcel vy cv cn wcel vy cv vw cv cle
      wbr vw cv vy cv clt wbr wo vt cv cr wcel vy cv cn wcel vw cv cn wcel vy
      cv vw cv cle wbr vw cv vy cv clt wbr wo vy cv cr wcel vw cv cr wcel vy cv
      vw cv cle wbr vw cv vy cv clt wbr wo vy cv cn wcel vw cv cn wcel vy cv vw
      cv lelttric vy cv nnre vw cv nnre syl2an ancoms adantlr adantlr vt cv cr
      wcel vu cv cr wcel vy cv cn wcel vy cv vw cv cle wbr vy cv cF cfv cabs
      cfv vt cv clt wbr wi vw cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt
      wbr wi wa vy cv vw cv cle wbr vw cv vy cv clt wbr wo vy cv cF cfv cabs
      cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr wi wi vw cv cn wcel vt cv
      cr wcel vu cv cr wcel wa vy cv cn wcel wa vy cv vw cv cle wbr vy cv cF
      cfv cabs cfv vt cv clt wbr wi vw cv vy cv clt wbr vy cv cF cfv cabs cfv
      vu cv clt wbr wi wa vy cv vw cv cle wbr vy cv cF cfv cabs cfv vu cv vt cv
      cle wbr vt cv vu cv cif clt wbr wi vw cv vy cv clt wbr vy cv cF cfv cabs
      cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr wi wa vy cv vw cv cle wbr
      vw cv vy cv clt wbr wo vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu
      cv cif clt wbr wi vt cv cr wcel vu cv cr wcel wa vy cv cn wcel wa vy cv
      vw cv cle wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vy cv vw cv cle wbr
      vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr wi vw
      cv vy cv clt wbr vy cv cF cfv cabs cfv vu cv clt wbr wi vw cv vy cv clt
      wbr vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr wi
      vt cv cr wcel vu cv cr wcel wa vy cv cn wcel wa vy cv cF cfv cabs cfv vt
      cv clt wbr vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt
      wbr vy cv vw cv cle wbr vt cv cr wcel vu cv cr wcel wa vy cv cn wcel wa
      vy cv cF cfv cabs cfv vt cv clt wbr vt cv vu cv vt cv cle wbr vt cv vu cv
      cif cle wbr vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu cv cif clt
      wbr vt cv cr wcel vu cv cr wcel wa vt cv vu cv vt cv cle wbr vt cv vu cv
      cif cle wbr vy cv cn wcel vu cv cr wcel vt cv cr wcel vt cv vu cv vt cv
      cle wbr vt cv vu cv cif cle wbr vu cv vt cv max2 ancoms adantr vy cv cF
      cfv cabs cfv cr wcel vt cv cr wcel vu cv vt cv cle wbr vt cv vu cv cif cr
      wcel vy cv cF cfv cabs cfv vt cv clt wbr vt cv vu cv vt cv cle wbr vt cv
      vu cv cif cle wbr wa vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt cv vu
      cv cif clt wbr wi vt cv cr wcel vu cv cr wcel wa vy cv cn wcel wa vy cv
      cF cfv cabs cfv vt cv vu cv vt cv cle wbr vt cv vu cv cif ltletr vy cv cn
      wcel vy cv cF cfv cabs cfv cr wcel vt cv cr wcel vu cv cr wcel wa vy cv
      cn wcel vy cv cF cfv cc wcel vy cv cF cfv cabs cfv cr wcel cn cc vy cv cF
      caubnd.1 ffvelrni vy cv cF cfv abscl syl adantl vt cv cr wcel vu cv cr
      wcel vy cv cn wcel simpll vt cv cr wcel vu cv cr wcel wa vu cv vt cv cle
      wbr vt cv vu cv cif cr wcel vy cv cn wcel vu cv vt cv cle wbr vt cv vu cv
      cr ifcl adantr syl3anc mpan2d imim2d vt cv cr wcel vu cv cr wcel wa vy cv
      cn wcel wa vy cv cF cfv cabs cfv vu cv clt wbr vy cv cF cfv cabs cfv vu
      cv vt cv cle wbr vt cv vu cv cif clt wbr vw cv vy cv clt wbr vt cv cr
      wcel vu cv cr wcel wa vy cv cn wcel wa vy cv cF cfv cabs cfv vu cv clt
      wbr vu cv vu cv vt cv cle wbr vt cv vu cv cif cle wbr vy cv cF cfv cabs
      cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr vu cv cr wcel vu cv vu cv
      vt cv cle wbr vt cv vu cv cif cle wbr vt cv cr wcel vy cv cn wcel vu cv
      vt cv max1ALT ad2antlr vy cv cF cfv cabs cfv cr wcel vu cv cr wcel vu cv
      vt cv cle wbr vt cv vu cv cif cr wcel vy cv cF cfv cabs cfv vu cv clt wbr
      vu cv vu cv vt cv cle wbr vt cv vu cv cif cle wbr wa vy cv cF cfv cabs
      cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr wi vt cv cr wcel vu cv cr
      wcel wa vy cv cn wcel wa vy cv cF cfv cabs cfv vu cv vu cv vt cv cle wbr
      vt cv vu cv cif ltletr vy cv cn wcel vy cv cF cfv cabs cfv cr wcel vt cv
      cr wcel vu cv cr wcel wa vy cv cn wcel vy cv cF cfv cc wcel vy cv cF cfv
      cabs cfv cr wcel cn cc vy cv cF caubnd.1 ffvelrni vy cv cF cfv abscl syl
      adantl vt cv cr wcel vu cv cr wcel vy cv cn wcel simplr vt cv cr wcel vu
      cv cr wcel wa vu cv vt cv cle wbr vt cv vu cv cif cr wcel vy cv cn wcel
      vu cv vt cv cle wbr vt cv vu cv cr ifcl adantr syl3anc mpan2d imim2d
      anim12d vy cv vw cv cle wbr vy cv cF cfv cabs cfv vu cv vt cv cle wbr vt
      cv vu cv cif clt wbr vw cv vy cv clt wbr jaob syl6ibr adantlll mpid
      r19.20dva vt cv cr wcel vu cv cr wcel vu cv vt cv cle wbr vt cv vu cv cif
      cr wcel vw cv cn wcel vu cv vt cv cle wbr vt cv vu cv cr ifcl adantll
      jctild vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vy cv cF cfv cabs
      cfv vu cv vt cv cle wbr vt cv vu cv cif clt wbr vy cn wral vx vu cv vt cv
      cle wbr vt cv vu cv cif cr vx cv vu cv vt cv cle wbr vt cv vu cv cif wceq
      vy cv cF cfv cabs cfv vx cv clt wbr vy cv cF cfv cabs cfv vu cv vt cv cle
      wbr vt cv vu cv cif clt wbr vy cn vx cv vu cv vt cv cle wbr vt cv vu cv
      cif vy cv cF cfv cabs cfv clt breq2 ralbidv rcla4ev syl6 vy cv vw cv cle
      wbr vy cv cF cfv cabs cfv vt cv clt wbr wi vw cv vy cv clt wbr vy cv cF
      cfv cabs cfv vu cv clt wbr wi vy cn r19.26 syl5ibr exp4b com23 imp
      r19.23adv exp31 r19.23adv mpd r19.23aiv ax-mp $.
      $( [29-Apr-2005] $) $( [4-Apr-2005] $)
  $}

  ${
    $d y z w $.  $d x y w $.  $d x F $.  $d x G $.
    caure.1 $e |- F : NN --> CC $.
    caure.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    caure.3 $e |- G Fn NN $.
    caure.4 $e |- ( x e. NN -> ( G ` x ) = ( Re ` ( F ` x ) ) ) $.
    $( The real part of a complex Caucy sequence is a Cauchy sequence. $)
    caurei $p |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( G ` y ) - ( G ` w ) ) ) < z ) ) $=
      cc0 vz cv clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral cc0 vz cv
      clt wbr vw cv vy cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral caure.2 cc0 vz cv clt
      wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi cc0 vz cv clt wbr vw cv vy cv clt wbr
      vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr vz cv cr wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex vw cv vy cv
      clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex cc0 vz cv clt wbr vz cv cr wcel vw cv vy cv clt wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cv vy
      cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy
      cn wral vw cn vz cv cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vw cv vy cv clt wbr vy
      cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cn vz cv cr
      wcel vw cv cn wcel wa vy cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv
      clt wbr vw cv vy cv clt wbr vz cv cr wcel vw cv cn wcel vy cv cn wcel vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr vy cv cG cfv vw cv
      cG cfv cmin co cabs cfv vz cv clt wbr wi vy cv cn wcel vw cv cn wcel vz
      cv cr wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr vy cv
      cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cv cn wcel vw cv
      cn wcel vz cv cr wcel w3a vy cv cG cfv vw cv cG cfv cmin co cabs cfv vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv
      vz cv clt wbr vy cv cn wcel vw cv cn wcel vy cv cG cfv vw cv cG cfv cmin
      co cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv cle wbr vz cv cr
      wcel vy cv cn wcel vw cv cn wcel wa vy cv cG cfv vw cv cG cfv cmin co
      cabs cfv vy cv cF cfv vw cv cF cfv cmin co cre cfv cabs cfv vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv cle vy cv cn wcel vw cv cn wcel wa vy cv cG
      cfv vw cv cG cfv cmin co vy cv cF cfv vw cv cF cfv cmin co cre cfv cabs
      vy cv cn wcel vw cv cn wcel wa vy cv cG cfv vw cv cG cfv cmin co vy cv cF
      cfv cre cfv vw cv cF cfv cre cfv cmin co vy cv cF cfv vw cv cF cfv cmin
      co cre cfv vy cv cn wcel vw cv cn wcel vy cv cG cfv vy cv cF cfv cre cfv
      vw cv cG cfv vw cv cF cfv cre cfv cmin vx cv cG cfv vx cv cF cfv cre cfv
      wceq vy cv cG cfv vy cv cF cfv cre cfv wceq vx vy cv cn vx cv vy cv wceq
      vx cv cG cfv vy cv cG cfv vx cv cF cfv cre cfv vy cv cF cfv cre cfv vx cv
      vy cv cG fveq2 vx cv vy cv wceq vx cv cF cfv vy cv cF cfv cre vx cv vy cv
      cF fveq2 fveq2d eqeq12d caure.4 vtoclga vx cv cG cfv vx cv cF cfv cre cfv
      wceq vw cv cG cfv vw cv cF cfv cre cfv wceq vx vw cv cn vx cv vw cv wceq
      vx cv cG cfv vw cv cG cfv vx cv cF cfv cre cfv vw cv cF cfv cre cfv vx cv
      vw cv cG fveq2 vx cv vw cv wceq vx cv cF cfv vw cv cF cfv cre vx cv vw cv
      cF fveq2 fveq2d eqeq12d caure.4 vtoclga opreqan12d vy cv cF cfv cc wcel
      vw cv cF cfv cc wcel vy cv cF cfv vw cv cF cfv cmin co cre cfv vy cv cF
      cfv cre cfv vw cv cF cfv cre cfv cmin co wceq vy cv cn wcel vw cv cn wcel
      vy cv cF cfv vw cv cF cfv resub cn cc vy cv cF caure.1 ffvelrni cn cc vw
      cv cF caure.1 ffvelrni syl2an eqtr4d fveq2d vy cv cn wcel vw cv cn wcel
      wa vy cv cF cfv vw cv cF cfv cmin co cc wcel vy cv cF cfv vw cv cF cfv
      cmin co cre cfv cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv cle
      wbr vy cv cF cfv cc wcel vw cv cF cfv cc wcel vy cv cF cfv vw cv cF cfv
      cmin co cc wcel vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv cF cfv
      subcl cn cc vy cv cF caure.1 ffvelrni cn cc vw cv cF caure.1 ffvelrni
      syl2an vy cv cF cfv vw cv cF cfv cmin co absrele syl eqbrtrd 3adant3 vy
      cv cG cfv vw cv cG cfv cmin co cabs cfv cr wcel vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv cr wcel vz cv cr wcel vy cv cG cfv vw cv cG cfv cmin co
      cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv cle wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vz cv clt wbr wa vy cv cG cfv vw cv cG cfv
      cmin co cabs cfv vz cv clt wbr wi vy cv cn wcel vw cv cn wcel vz cv cr
      wcel w3a vy cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv lelttr vy cv cn wcel vw cv cn wcel vy cv cG
      cfv vw cv cG cfv cmin co cabs cfv cr wcel vz cv cr wcel vy cv cn wcel vw
      cv cn wcel wa vy cv cG cfv vw cv cG cfv cmin co cc wcel vy cv cG cfv vw
      cv cG cfv cmin co cabs cfv cr wcel vy cv cn wcel vw cv cn wcel wa vy cv
      cG cfv vw cv cG cfv cmin co vy cv cG cfv cr wcel vw cv cG cfv cr wcel vy
      cv cG cfv vw cv cG cfv cmin co cr wcel vy cv cn wcel vw cv cn wcel vy cv
      cG cfv vw cv cG cfv resubcl cn cr vy cv cG cn cr cG wf cG cn wfn vx cv cG
      cfv cr wcel vx cn wral vx cn cr cG ffnfv caure.3 vx cv cG cfv cr wcel vx
      cn vx cv cn wcel vx cv cG cfv vx cv cF cfv cre cfv cr caure.4 vx cv cn
      wcel vx cv cF cfv cc wcel vx cv cF cfv cre cfv cr wcel cn cc vx cv cF
      caure.1 ffvelrni vx cv cF cfv recl syl eqeltrd rgen mpbir2an ffvelrni cn
      cr vw cv cG cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx cn wral vx cn
      cr cG ffnfv caure.3 vx cv cG cfv cr wcel vx cn vx cv cn wcel vx cv cG cfv
      vx cv cF cfv cre cfv cr caure.4 vx cv cn wcel vx cv cF cfv cc wcel vx cv
      cF cfv cre cfv cr wcel cn cc vx cv cF caure.1 ffvelrni vx cv cF cfv recl
      syl eqeltrd rgen mpbir2an ffvelrni syl2an recnd vy cv cG cfv vw cv cG cfv
      cmin co abscl syl 3adant3 vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv cr wcel vz cv cr wcel vy cv cn wcel vw cv cn wcel
      wa vy cv cF cfv vw cv cF cfv cmin co cc wcel vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv cr wcel vy cv cF cfv cc wcel vw cv cF cfv cc wcel vy cv
      cF cfv vw cv cF cfv cmin co cc wcel vy cv cn wcel vw cv cn wcel vy cv cF
      cfv vw cv cF cfv subcl cn cc vy cv cF caure.1 ffvelrni cn cc vw cv cF
      caure.1 ffvelrni syl2an vy cv cF cfv vw cv cF cfv cmin co abscl syl
      3adant3 vy cv cn wcel vw cv cn wcel vz cv cr wcel 3simp3 syl3anc mpand
      3com13 3expa imim2d r19.20dva r19.22dva imim2d r19.20i ax-mp $.
      $( [3-May-2005] $) $( [16-Apr-2005] $)
  $}

  ${
    $d y z w $.  $d x y w $.  $d x F $.  $d x G $.
    cauim.1 $e |- F : NN --> CC $.
    cauim.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    cauim.3 $e |- G Fn NN $.
    cauim.4 $e |- ( x e. NN -> ( G ` x ) = ( Im ` ( F ` x ) ) ) $.
    $( The imaginary part of a complex Caucy sequence is a Cauchy sequence. $)
    cauimi $p |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( G ` y ) - ( G ` w ) ) ) < z ) ) $=
      cc0 vz cv clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral cc0 vz cv
      clt wbr vw cv vy cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral cauim.2 cc0 vz cv clt
      wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi cc0 vz cv clt wbr vw cv vy cv clt wbr
      vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr vz cv cr wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex vw cv vy cv
      clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex cc0 vz cv clt wbr vz cv cr wcel vw cv vy cv clt wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cv vy
      cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy
      cn wral vw cn vz cv cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vw cv vy cv clt wbr vy
      cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cn vz cv cr
      wcel vw cv cn wcel wa vy cv cn wcel wa vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv vz cv
      clt wbr vw cv vy cv clt wbr vz cv cr wcel vw cv cn wcel vy cv cn wcel vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr vy cv cG cfv vw cv
      cG cfv cmin co cabs cfv vz cv clt wbr wi vy cv cn wcel vw cv cn wcel vz
      cv cr wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr vy cv
      cG cfv vw cv cG cfv cmin co cabs cfv vz cv clt wbr wi vy cv cn wcel vw cv
      cn wcel vz cv cr wcel w3a vy cv cG cfv vw cv cG cfv cmin co cabs cfv vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr vy cv cG cfv vw cv cG cfv cmin co cabs cfv
      vz cv clt wbr vy cv cn wcel vw cv cn wcel vy cv cG cfv vw cv cG cfv cmin
      co cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv cle wbr vz cv cr
      wcel vy cv cn wcel vw cv cn wcel wa vy cv cG cfv vw cv cG cfv cmin co
      cabs cfv vy cv cF cfv vw cv cF cfv cmin co cim cfv cabs cfv vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv cle vy cv cn wcel vw cv cn wcel wa vy cv cG
      cfv vw cv cG cfv cmin co vy cv cF cfv vw cv cF cfv cmin co cim cfv cabs
      vy cv cn wcel vw cv cn wcel wa vy cv cG cfv vw cv cG cfv cmin co vy cv cF
      cfv cim cfv vw cv cF cfv cim cfv cmin co vy cv cF cfv vw cv cF cfv cmin
      co cim cfv vy cv cn wcel vw cv cn wcel vy cv cG cfv vy cv cF cfv cim cfv
      vw cv cG cfv vw cv cF cfv cim cfv cmin vx cv cG cfv vx cv cF cfv cim cfv
      wceq vy cv cG cfv vy cv cF cfv cim cfv wceq vx vy cv cn vx cv vy cv wceq
      vx cv cG cfv vy cv cG cfv vx cv cF cfv cim cfv vy cv cF cfv cim cfv vx cv
      vy cv cG fveq2 vx cv vy cv wceq vx cv cF cfv vy cv cF cfv cim vx cv vy cv
      cF fveq2 fveq2d eqeq12d cauim.4 vtoclga vx cv cG cfv vx cv cF cfv cim cfv
      wceq vw cv cG cfv vw cv cF cfv cim cfv wceq vx vw cv cn vx cv vw cv wceq
      vx cv cG cfv vw cv cG cfv vx cv cF cfv cim cfv vw cv cF cfv cim cfv vx cv
      vw cv cG fveq2 vx cv vw cv wceq vx cv cF cfv vw cv cF cfv cim vx cv vw cv
      cF fveq2 fveq2d eqeq12d cauim.4 vtoclga opreqan12d vy cv cF cfv cc wcel
      vw cv cF cfv cc wcel vy cv cF cfv vw cv cF cfv cmin co cim cfv vy cv cF
      cfv cim cfv vw cv cF cfv cim cfv cmin co wceq vy cv cn wcel vw cv cn wcel
      vy cv cF cfv vw cv cF cfv imsub cn cc vy cv cF cauim.1 ffvelrni cn cc vw
      cv cF cauim.1 ffvelrni syl2an eqtr4d fveq2d vy cv cn wcel vw cv cn wcel
      wa vy cv cF cfv vw cv cF cfv cmin co cc wcel vy cv cF cfv vw cv cF cfv
      cmin co cim cfv cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv cle
      wbr vy cv cF cfv cc wcel vw cv cF cfv cc wcel vy cv cF cfv vw cv cF cfv
      cmin co cc wcel vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv cF cfv
      subcl cn cc vy cv cF cauim.1 ffvelrni cn cc vw cv cF cauim.1 ffvelrni
      syl2an vy cv cF cfv vw cv cF cfv cmin co absimle syl eqbrtrd 3adant3 vy
      cv cG cfv vw cv cG cfv cmin co cabs cfv cr wcel vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv cr wcel vz cv cr wcel vy cv cG cfv vw cv cG cfv cmin co
      cabs cfv vy cv cF cfv vw cv cF cfv cmin co cabs cfv cle wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vz cv clt wbr wa vy cv cG cfv vw cv cG cfv
      cmin co cabs cfv vz cv clt wbr wi vy cv cn wcel vw cv cn wcel vz cv cr
      wcel w3a vy cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv lelttr vy cv cn wcel vw cv cn wcel vy cv cG
      cfv vw cv cG cfv cmin co cabs cfv cr wcel vz cv cr wcel vy cv cn wcel vw
      cv cn wcel wa vy cv cG cfv vw cv cG cfv cmin co cc wcel vy cv cG cfv vw
      cv cG cfv cmin co cabs cfv cr wcel vy cv cn wcel vw cv cn wcel wa vy cv
      cG cfv vw cv cG cfv cmin co vy cv cG cfv cr wcel vw cv cG cfv cr wcel vy
      cv cG cfv vw cv cG cfv cmin co cr wcel vy cv cn wcel vw cv cn wcel vy cv
      cG cfv vw cv cG cfv resubcl cn cr vy cv cG cn cr cG wf cG cn wfn vx cv cG
      cfv cr wcel vx cn wral vx cn cr cG ffnfv cauim.3 vx cv cG cfv cr wcel vx
      cn vx cv cn wcel vx cv cG cfv vx cv cF cfv cim cfv cr cauim.4 vx cv cn
      wcel vx cv cF cfv cc wcel vx cv cF cfv cim cfv cr wcel cn cc vx cv cF
      cauim.1 ffvelrni vx cv cF cfv imcl syl eqeltrd rgen mpbir2an ffvelrni cn
      cr vw cv cG cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx cn wral vx cn
      cr cG ffnfv cauim.3 vx cv cG cfv cr wcel vx cn vx cv cn wcel vx cv cG cfv
      vx cv cF cfv cim cfv cr cauim.4 vx cv cn wcel vx cv cF cfv cc wcel vx cv
      cF cfv cim cfv cr wcel cn cc vx cv cF cauim.1 ffvelrni vx cv cF cfv imcl
      syl eqeltrd rgen mpbir2an ffvelrni syl2an recnd vy cv cG cfv vw cv cG cfv
      cmin co abscl syl 3adant3 vy cv cn wcel vw cv cn wcel vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv cr wcel vz cv cr wcel vy cv cn wcel vw cv cn wcel
      wa vy cv cF cfv vw cv cF cfv cmin co cc wcel vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv cr wcel vy cv cF cfv cc wcel vw cv cF cfv cc wcel vy cv
      cF cfv vw cv cF cfv cmin co cc wcel vy cv cn wcel vw cv cn wcel vy cv cF
      cfv vw cv cF cfv subcl cn cc vy cv cF cauim.1 ffvelrni cn cc vw cv cF
      cauim.1 ffvelrni syl2an vy cv cF cfv vw cv cF cfv cmin co abscl syl
      3adant3 vy cv cn wcel vw cv cn wcel vz cv cr wcel 3simp3 syl3anc mpand
      3com13 3expa imim2d r19.20dva r19.22dva imim2d r19.20i ax-mp $.
      $( [17-May-2005] $) $( [16-Apr-2005] $)
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z F $.  $d x y z G $.
    ser1absdif.1 $e |- F : NN --> CC $.
    ser1absdif.2 $e |- G Fn NN $.
    ser1absdif.3 $e |- ( x e. NN -> ( G ` x ) = ( abs ` ( F ` x ) ) ) $.
    $( Lemma for ~ ser1absdifi .  _Warning:  The HTML proof page is 1/2
       megabyte in size_. $)
    ser1absdiflem $p |- ( ( A e. NN /\ B e. NN ) ->
       ( abs ` ( ( ( + seq1 F ) ` ( A + B ) ) - ( ( + seq1 F ) ` A ) ) ) <_
       ( ( ( + seq1 G ) ` ( A + B ) ) - ( ( + seq1 G ) ` A ) ) ) $=
      cB cn wcel cA cn wcel cA cB caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cabs cfv cA cB caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cle wbr cA cn wcel cA vy cv caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vy cv caddc
      co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr wi cA
      cn wcel cA c1 caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin co cabs cfv cA c1 caddc co caddc cG cseq1 co cfv cA caddc cG cseq1
      co cfv cmin co cle wbr wi cA cn wcel cA vz cv caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co caddc cG
      cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr wi cA cn wcel cA vz
      cv c1 caddc co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin co cabs cfv cA vz cv c1 caddc co caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cle wbr wi cA cn wcel cA cB caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA cB caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr wi vy vz
      cB vy cv c1 wceq cA vy cv caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cabs cfv cA vy cv caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cle wbr cA c1 caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA c1 caddc co caddc cG
      cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr cA cn wcel vy cv c1
      wceq cA vy cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin co cabs cfv cA c1 caddc co caddc cF cseq1 co cfv cA caddc cF cseq1
      co cfv cmin co cabs cfv cA vy cv caddc co caddc cG cseq1 co cfv cA caddc
      cG cseq1 co cfv cmin co cA c1 caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin co cle vy cv c1 wceq cA vy cv caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cA c1 caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cabs vy cv c1 wceq cA vy cv caddc co
      caddc cF cseq1 co cfv cA c1 caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin vy cv c1 wceq cA vy cv caddc co cA c1 caddc co caddc cF
      cseq1 co vy cv c1 cA caddc opreq2 fveq2d opreq1d fveq2d vy cv c1 wceq cA
      vy cv caddc co caddc cG cseq1 co cfv cA c1 caddc co caddc cG cseq1 co cfv
      cA caddc cG cseq1 co cfv cmin vy cv c1 wceq cA vy cv caddc co cA c1 caddc
      co caddc cG cseq1 co vy cv c1 cA caddc opreq2 fveq2d opreq1d breq12d
      imbi2d vy cv vz cv wceq cA vy cv caddc co caddc cF cseq1 co cfv cA caddc
      cF cseq1 co cfv cmin co cabs cfv cA vy cv caddc co caddc cG cseq1 co cfv
      cA caddc cG cseq1 co cfv cmin co cle wbr cA vz cv caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co caddc
      cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr cA cn wcel vy cv
      vz cv wceq cA vy cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cabs cfv cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cabs cfv cA vy cv caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cA vz cv caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cle vy cv vz cv wceq cA vy cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs vy cv vz cv
      wceq cA vy cv caddc co caddc cF cseq1 co cfv cA vz cv caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin vy cv vz cv wceq cA vy cv
      caddc co cA vz cv caddc co caddc cF cseq1 co vy cv vz cv cA caddc opreq2
      fveq2d opreq1d fveq2d vy cv vz cv wceq cA vy cv caddc co caddc cG cseq1
      co cfv cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv
      cmin vy cv vz cv wceq cA vy cv caddc co cA vz cv caddc co caddc cG cseq1
      co vy cv vz cv cA caddc opreq2 fveq2d opreq1d breq12d imbi2d vy cv vz cv
      c1 caddc co wceq cA vy cv caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cabs cfv cA vy cv caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cle wbr cA vz cv c1 caddc co caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv c1
      caddc co caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co
      cle wbr cA cn wcel vy cv vz cv c1 caddc co wceq cA vy cv caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv c1
      caddc co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cabs cfv cA vy cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv
      cmin co cA vz cv c1 caddc co caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin co cle vy cv vz cv c1 caddc co wceq cA vy cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv c1 caddc
      co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs
      vy cv vz cv c1 caddc co wceq cA vy cv caddc co caddc cF cseq1 co cfv cA
      vz cv c1 caddc co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin vy cv vz cv c1 caddc co wceq cA vy cv caddc co cA vz cv c1 caddc co
      caddc co caddc cF cseq1 co vy cv vz cv c1 caddc co cA caddc opreq2 fveq2d
      opreq1d fveq2d vy cv vz cv c1 caddc co wceq cA vy cv caddc co caddc cG
      cseq1 co cfv cA vz cv c1 caddc co caddc co caddc cG cseq1 co cfv cA caddc
      cG cseq1 co cfv cmin vy cv vz cv c1 caddc co wceq cA vy cv caddc co cA vz
      cv c1 caddc co caddc co caddc cG cseq1 co vy cv vz cv c1 caddc co cA
      caddc opreq2 fveq2d opreq1d breq12d imbi2d vy cv cB wceq cA vy cv caddc
      co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vy
      cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle
      wbr cA cB caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cabs cfv cA cB caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv
      cmin co cle wbr cA cn wcel vy cv cB wceq cA vy cv caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA cB caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vy cv caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA cB caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle vy cv cB wceq
      cA vy cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cA cB caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cabs vy cv cB wceq cA vy cv caddc co caddc cF cseq1 co cfv cA cB caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin vy cv cB wceq cA vy
      cv caddc co cA cB caddc co caddc cF cseq1 co vy cv cB cA caddc opreq2
      fveq2d opreq1d fveq2d vy cv cB wceq cA vy cv caddc co caddc cG cseq1 co
      cfv cA cB caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin vy
      cv cB wceq cA vy cv caddc co cA cB caddc co caddc cG cseq1 co vy cv cB cA
      caddc opreq2 fveq2d opreq1d breq12d imbi2d cA cn wcel cA c1 caddc co cF
      cfv cabs cfv cA c1 caddc co cF cfv cabs cfv cA c1 caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA c1 caddc co caddc cG
      cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle cA cn wcel cA c1 caddc
      co cF cfv cabs cfv cr wcel cA c1 caddc co cF cfv cabs cfv cA c1 caddc co
      cF cfv cabs cfv cle wbr cA cn wcel cA c1 caddc co cF cfv cc wcel cA c1
      caddc co cF cfv cabs cfv cr wcel cA cn wcel cA c1 caddc co cn wcel cA c1
      caddc co cF cfv cc wcel cA peano2nn cn cc cA c1 caddc co cF ser1absdif.1
      ffvelrni syl cA c1 caddc co cF cfv abscl syl cA c1 caddc co cF cfv cabs
      cfv leid syl cA cn wcel cA c1 caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cA c1 caddc co cF cfv cabs cA cn wcel cA c1 caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA caddc cF cseq1
      co cfv cA c1 caddc co cF cfv caddc co cA caddc cF cseq1 co cfv cmin co cA
      c1 caddc co cF cfv cA cn wcel cA c1 caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cA c1 caddc co cF cfv caddc co cA caddc cF cseq1 co
      cfv cmin cA caddc cF addex cn cc cF wf cn cvv wcel cF cvv wcel
      ser1absdif.1 nnex cn cc cvv cF fex mp2an seq1p1 opreq1d cA caddc cF cseq1
      co cfv cc wcel cA c1 caddc co cF cfv cc wcel cA caddc cF cseq1 co cfv cA
      c1 caddc co cF cfv caddc co cA caddc cF cseq1 co cfv cmin co cA c1 caddc
      co cF cfv wceq cA cn wcel cA caddc cF cseq1 co cfv cA c1 caddc co cF cfv
      pncan2 cA cF ser1absdif.1 ser1cl1i cA cn wcel cA c1 caddc co cn wcel cA
      c1 caddc co cF cfv cc wcel cA peano2nn cn cc cA c1 caddc co cF
      ser1absdif.1 ffvelrni syl sylanc eqtrd fveq2d cA cn wcel cA c1 caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA caddc cG cseq1
      co cfv cA c1 caddc co cG cfv caddc co cA caddc cG cseq1 co cfv cmin co cA
      c1 caddc co cG cfv cA c1 caddc co cF cfv cabs cfv cA cn wcel cA c1 caddc
      co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cA c1 caddc co cG cfv
      caddc co cA caddc cG cseq1 co cfv cmin cA caddc cG addex cG cn wfn cn cvv
      wcel cG cvv wcel ser1absdif.2 nnex cn cvv cG fnex mp2an seq1p1 opreq1d cA
      caddc cG cseq1 co cfv cc wcel cA c1 caddc co cG cfv cc wcel cA caddc cG
      cseq1 co cfv cA c1 caddc co cG cfv caddc co cA caddc cG cseq1 co cfv cmin
      co cA c1 caddc co cG cfv wceq cA cn wcel cA caddc cG cseq1 co cfv cA c1
      caddc co cG cfv pncan2 cA cG cn cr cG wf cr cc wss cn cc cG wf cn cr cG
      wf cG cn wfn vx cv cG cfv cr wcel vx cn wral vx cn cr cG ffnfv
      ser1absdif.2 vx cv cG cfv cr wcel vx cn vx cv cn wcel vx cv cG cfv vx cv
      cF cfv cabs cfv cr ser1absdif.3 vx cv cn wcel vx cv cF cfv cc wcel vx cv
      cF cfv cabs cfv cr wcel cn cc vx cv cF ser1absdif.1 ffvelrni vx cv cF cfv
      abscl syl eqeltrd rgen mpbir2an axresscn cn cr cc cG fss mp2an ser1cl1i
      cA cn wcel cA c1 caddc co cn wcel cA c1 caddc co cG cfv cc wcel cA
      peano2nn cA c1 caddc co cn wcel cA c1 caddc co cG cfv cA c1 caddc co cn
      wcel cA c1 caddc co cG cfv cA c1 caddc co cF cfv cabs cfv cr vx cv cG cfv
      vx cv cF cfv cabs cfv wceq cA c1 caddc co cG cfv cA c1 caddc co cF cfv
      cabs cfv wceq vx cA c1 caddc co cn vx cv cA c1 caddc co wceq vx cv cG cfv
      cA c1 caddc co cG cfv vx cv cF cfv cabs cfv cA c1 caddc co cF cfv cabs
      cfv vx cv cA c1 caddc co cG fveq2 vx cv cA c1 caddc co wceq vx cv cF cfv
      cA c1 caddc co cF cfv cabs vx cv cA c1 caddc co cF fveq2 fveq2d eqeq12d
      ser1absdif.3 vtoclga cA c1 caddc co cn wcel cA c1 caddc co cF cfv cc wcel
      cA c1 caddc co cF cfv cabs cfv cr wcel cn cc cA c1 caddc co cF
      ser1absdif.1 ffvelrni cA c1 caddc co cF cfv abscl syl eqeltrd recnd syl
      sylanc cA cn wcel cA c1 caddc co cn wcel cA c1 caddc co cG cfv cA c1
      caddc co cF cfv cabs cfv wceq cA peano2nn vx cv cG cfv vx cv cF cfv cabs
      cfv wceq cA c1 caddc co cG cfv cA c1 caddc co cF cfv cabs cfv wceq vx cA
      c1 caddc co cn vx cv cA c1 caddc co wceq vx cv cG cfv cA c1 caddc co cG
      cfv vx cv cF cfv cabs cfv cA c1 caddc co cF cfv cabs cfv vx cv cA c1
      caddc co cG fveq2 vx cv cA c1 caddc co wceq vx cv cF cfv cA c1 caddc co
      cF cfv cabs vx cv cA c1 caddc co cF fveq2 fveq2d eqeq12d ser1absdif.3
      vtoclga syl 3eqtrd 3brtr4d vz cv cn wcel cA cn wcel cA vz cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv
      caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr
      cA vz cv c1 caddc co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cabs cfv cA vz cv c1 caddc co caddc co caddc cG cseq1 co cfv
      cA caddc cG cseq1 co cfv cmin co cle wbr cA cn wcel vz cv cn wcel cA vz
      cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs
      cfv cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin
      co cle wbr cA vz cv c1 caddc co caddc co caddc cF cseq1 co cfv cA caddc
      cF cseq1 co cfv cmin co cabs cfv cA vz cv c1 caddc co caddc co caddc cG
      cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr wi cA cn wcel vz cv
      cn wcel wa cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cabs cfv cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc
      co cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin
      co cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc co cle wbr cA vz
      cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz
      cv caddc co c1 caddc co cF cfv caddc co cabs cfv cA vz cv caddc co caddc
      cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1
      caddc co cF cfv cabs cfv caddc co cle wbr cA vz cv caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle wbr cA vz cv
      c1 caddc co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin
      co cabs cfv cA vz cv c1 caddc co caddc co caddc cG cseq1 co cfv cA caddc
      cG cseq1 co cfv cmin co cle wbr cA cn wcel vz cv cn wcel wa cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv
      caddc co c1 caddc co cF cfv caddc co cabs cfv cA vz cv caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co
      c1 caddc co cF cfv cabs cfv caddc co cle wbr cA vz cv caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co
      c1 caddc co cF cfv cabs cfv caddc co cA vz cv caddc co caddc cG cseq1 co
      cfv cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv
      cabs cfv caddc co cle wbr cA vz cv caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv caddc
      co cabs cfv cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co
      cfv cmin co cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc co cle
      wbr cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin
      co cc wcel cA vz cv caddc co c1 caddc co cF cfv cc wcel cA vz cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co
      c1 caddc co cF cfv caddc co cabs cfv cA vz cv caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co c1 caddc
      co cF cfv cabs cfv caddc co cle wbr cA cn wcel vz cv cn wcel wa cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv
      caddc co c1 caddc co cF cfv abstri cA vz cv caddc co caddc cF cseq1 co
      cfv cc wcel cA caddc cF cseq1 co cfv cc wcel cA vz cv caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cc wcel cA cn wcel vz cv cn
      wcel wa cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      subcl cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv
      caddc co caddc cF cseq1 co cfv cc wcel cA vz cv nnaddcl cA vz cv caddc co
      cF ser1absdif.1 ser1cl1i syl cA cn wcel cA caddc cF cseq1 co cfv cc wcel
      vz cv cn wcel cA cF ser1absdif.1 ser1cl1i adantr sylanc cA cn wcel vz cv
      cn wcel wa cA vz cv caddc co c1 caddc co cn wcel cA vz cv caddc co c1
      caddc co cF cfv cc wcel cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn
      wcel cA vz cv caddc co c1 caddc co cn wcel cA vz cv nnaddcl cA vz cv
      caddc co peano2nn syl cn cc cA vz cv caddc co c1 caddc co cF ser1absdif.1
      ffvelrni syl sylanc cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv caddc co cabs
      cfv cr wcel cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cabs cfv cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc
      co cr wcel cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co
      cfv cmin co cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc co cr
      wcel cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin co cA vz cv caddc co c1 caddc co cF cfv caddc co cabs cfv cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv
      cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc co cle wbr cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv
      cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc co cA vz cv caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co
      c1 caddc co cF cfv cabs cfv caddc co cle wbr wa cA vz cv caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1
      caddc co cF cfv caddc co cabs cfv cA vz cv caddc co caddc cG cseq1 co cfv
      cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv
      cabs cfv caddc co cle wbr wi cA cn wcel vz cv cn wcel wa cA vz cv caddc
      co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc
      co c1 caddc co cF cfv caddc co cabs cfv cA vz cv caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co c1
      caddc co cF cfv cabs cfv caddc co cA vz cv caddc co caddc cG cseq1 co cfv
      cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv
      cabs cfv caddc co letr cA cn wcel vz cv cn wcel wa cA vz cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co
      c1 caddc co cF cfv caddc co cc wcel cA vz cv caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv
      caddc co cabs cfv cr wcel cA vz cv caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cmin co cc wcel cA vz cv caddc co c1 caddc co cF
      cfv cc wcel cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cA vz cv caddc co c1 caddc co cF cfv caddc co cc wcel cA cn
      wcel vz cv cn wcel wa cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv addcl cA vz cv
      caddc co caddc cF cseq1 co cfv cc wcel cA caddc cF cseq1 co cfv cc wcel
      cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cc wcel cA cn wcel vz cv cn wcel wa cA vz cv caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv subcl cA cn wcel vz cv cn wcel wa cA vz cv
      caddc co cn wcel cA vz cv caddc co caddc cF cseq1 co cfv cc wcel cA vz cv
      nnaddcl cA vz cv caddc co cF ser1absdif.1 ser1cl1i syl cA cn wcel cA
      caddc cF cseq1 co cfv cc wcel vz cv cn wcel cA cF ser1absdif.1 ser1cl1i
      adantr sylanc cA cn wcel vz cv cn wcel wa cA vz cv caddc co c1 caddc co
      cn wcel cA vz cv caddc co c1 caddc co cF cfv cc wcel cA cn wcel vz cv cn
      wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co c1 caddc co cn wcel
      cA vz cv nnaddcl cA vz cv caddc co peano2nn syl cn cc cA vz cv caddc co
      c1 caddc co cF ser1absdif.1 ffvelrni syl sylanc cA vz cv caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1
      caddc co cF cfv caddc co abscl syl cA vz cv caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cr wcel cA vz cv caddc co
      c1 caddc co cF cfv cabs cfv cr wcel cA vz cv caddc co caddc cF cseq1 co
      cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co c1 caddc
      co cF cfv cabs cfv caddc co cr wcel cA cn wcel vz cv cn wcel wa cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv
      cA vz cv caddc co c1 caddc co cF cfv cabs cfv readdcl cA cn wcel vz cv cn
      wcel wa cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin co cc wcel cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1
      co cfv cmin co cabs cfv cr wcel cA vz cv caddc co caddc cF cseq1 co cfv
      cc wcel cA caddc cF cseq1 co cfv cc wcel cA vz cv caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cc wcel cA cn wcel vz cv cn wcel
      wa cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv subcl
      cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co
      caddc cF cseq1 co cfv cc wcel cA vz cv nnaddcl cA vz cv caddc co cF
      ser1absdif.1 ser1cl1i syl cA cn wcel cA caddc cF cseq1 co cfv cc wcel vz
      cv cn wcel cA cF ser1absdif.1 ser1cl1i adantr sylanc cA vz cv caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co abscl syl cA cn
      wcel vz cv cn wcel wa cA vz cv caddc co c1 caddc co cF cfv cc wcel cA vz
      cv caddc co c1 caddc co cF cfv cabs cfv cr wcel cA cn wcel vz cv cn wcel
      wa cA vz cv caddc co c1 caddc co cn wcel cA vz cv caddc co c1 caddc co cF
      cfv cc wcel cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz
      cv caddc co c1 caddc co cn wcel cA vz cv nnaddcl cA vz cv caddc co
      peano2nn syl cn cc cA vz cv caddc co c1 caddc co cF ser1absdif.1 ffvelrni
      syl cA vz cv caddc co c1 caddc co cF cfv abscl syl sylanc cA vz cv caddc
      co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cr wcel cA vz
      cv caddc co c1 caddc co cF cfv cabs cfv cr wcel cA vz cv caddc co caddc
      cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1
      caddc co cF cfv cabs cfv caddc co cr wcel cA cn wcel vz cv cn wcel wa cA
      vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA
      vz cv caddc co c1 caddc co cF cfv cabs cfv readdcl cA vz cv caddc co
      caddc cG cseq1 co cfv cr wcel cA caddc cG cseq1 co cfv cr wcel cA vz cv
      caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cr wcel
      cA cn wcel vz cv cn wcel wa cA vz cv caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv resubcl cA cn wcel vz cv cn wcel wa cA vz cv caddc
      co cn wcel cA vz cv caddc co caddc cG cseq1 co cfv cr wcel cA vz cv
      nnaddcl cA vz cv caddc co cG cn cr cG wf cG cn wfn vx cv cG cfv cr wcel
      vx cn wral vx cn cr cG ffnfv ser1absdif.2 vx cv cG cfv cr wcel vx cn vx
      cv cn wcel vx cv cG cfv vx cv cF cfv cabs cfv cr ser1absdif.3 vx cv cn
      wcel vx cv cF cfv cc wcel vx cv cF cfv cabs cfv cr wcel cn cc vx cv cF
      ser1absdif.1 ffvelrni vx cv cF cfv abscl syl eqeltrd rgen mpbir2an
      ser1recli syl cA cn wcel cA caddc cG cseq1 co cfv cr wcel vz cv cn wcel
      cA cG cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx cn wral vx cn cr cG
      ffnfv ser1absdif.2 vx cv cG cfv cr wcel vx cn vx cv cn wcel vx cv cG cfv
      vx cv cF cfv cabs cfv cr ser1absdif.3 vx cv cn wcel vx cv cF cfv cc wcel
      vx cv cF cfv cabs cfv cr wcel cn cc vx cv cF ser1absdif.1 ffvelrni vx cv
      cF cfv abscl syl eqeltrd rgen mpbir2an ser1recli adantr sylanc cA cn wcel
      vz cv cn wcel wa cA vz cv caddc co c1 caddc co cF cfv cc wcel cA vz cv
      caddc co c1 caddc co cF cfv cabs cfv cr wcel cA cn wcel vz cv cn wcel wa
      cA vz cv caddc co c1 caddc co cn wcel cA vz cv caddc co c1 caddc co cF
      cfv cc wcel cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz
      cv caddc co c1 caddc co cn wcel cA vz cv nnaddcl cA vz cv caddc co
      peano2nn syl cn cc cA vz cv caddc co c1 caddc co cF ser1absdif.1 ffvelrni
      syl cA vz cv caddc co c1 caddc co cF cfv abscl syl sylanc syl3anc mpand
      cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cabs cfv cr wcel cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin co cr wcel cA vz cv caddc co c1 caddc co cF cfv cabs
      cfv cr wcel cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cabs cfv cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin co cle wbr cA vz cv caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co c1 caddc co cF
      cfv cabs cfv caddc co cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc
      co cle wbr wb cA cn wcel vz cv cn wcel wa cA vz cv caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA vz cv caddc co
      caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co
      c1 caddc co cF cfv cabs cfv leadd1 cA cn wcel vz cv cn wcel wa cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cc wcel
      cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co
      cabs cfv cr wcel cA vz cv caddc co caddc cF cseq1 co cfv cc wcel cA caddc
      cF cseq1 co cfv cc wcel cA vz cv caddc co caddc cF cseq1 co cfv cA caddc
      cF cseq1 co cfv cmin co cc wcel cA cn wcel vz cv cn wcel wa cA vz cv
      caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv subcl cA cn wcel
      vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co caddc cF
      cseq1 co cfv cc wcel cA vz cv nnaddcl cA vz cv caddc co cF ser1absdif.1
      ser1cl1i syl cA cn wcel cA caddc cF cseq1 co cfv cc wcel vz cv cn wcel cA
      cF ser1absdif.1 ser1cl1i adantr sylanc cA vz cv caddc co caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co abscl syl cA vz cv caddc co caddc
      cG cseq1 co cfv cr wcel cA caddc cG cseq1 co cfv cr wcel cA vz cv caddc
      co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cr wcel cA cn
      wcel vz cv cn wcel wa cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv resubcl cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn
      wcel cA vz cv caddc co caddc cG cseq1 co cfv cr wcel cA vz cv nnaddcl cA
      vz cv caddc co cG cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx cn wral
      vx cn cr cG ffnfv ser1absdif.2 vx cv cG cfv cr wcel vx cn vx cv cn wcel
      vx cv cG cfv vx cv cF cfv cabs cfv cr ser1absdif.3 vx cv cn wcel vx cv cF
      cfv cc wcel vx cv cF cfv cabs cfv cr wcel cn cc vx cv cF ser1absdif.1
      ffvelrni vx cv cF cfv abscl syl eqeltrd rgen mpbir2an ser1recli syl cA cn
      wcel cA caddc cG cseq1 co cfv cr wcel vz cv cn wcel cA cG cn cr cG wf cG
      cn wfn vx cv cG cfv cr wcel vx cn wral vx cn cr cG ffnfv ser1absdif.2 vx
      cv cG cfv cr wcel vx cn vx cv cn wcel vx cv cG cfv vx cv cF cfv cabs cfv
      cr ser1absdif.3 vx cv cn wcel vx cv cF cfv cc wcel vx cv cF cfv cabs cfv
      cr wcel cn cc vx cv cF ser1absdif.1 ffvelrni vx cv cF cfv abscl syl
      eqeltrd rgen mpbir2an ser1recli adantr sylanc cA cn wcel vz cv cn wcel wa
      cA vz cv caddc co c1 caddc co cF cfv cc wcel cA vz cv caddc co c1 caddc
      co cF cfv cabs cfv cr wcel cA cn wcel vz cv cn wcel wa cA vz cv caddc co
      c1 caddc co cn wcel cA vz cv caddc co c1 caddc co cF cfv cc wcel cA cn
      wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co c1
      caddc co cn wcel cA vz cv nnaddcl cA vz cv caddc co peano2nn syl cn cc cA
      vz cv caddc co c1 caddc co cF ser1absdif.1 ffvelrni syl cA vz cv caddc co
      c1 caddc co cF cfv abscl syl syl3anc cA cn wcel vz cv cn wcel wa cA vz cv
      c1 caddc co caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin
      co cabs cfv cA vz cv caddc co caddc cF cseq1 co cfv cA caddc cF cseq1 co
      cfv cmin co cA vz cv caddc co c1 caddc co cF cfv caddc co cabs cfv cA vz
      cv c1 caddc co caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv
      cmin co cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv
      cmin co cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc co cle cA cn
      wcel vz cv cn wcel wa cA vz cv c1 caddc co caddc co caddc cF cseq1 co cfv
      cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co caddc cF cseq1 co cfv
      cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv
      caddc co cabs cA cn wcel vz cv cn wcel wa cA vz cv c1 caddc co caddc co
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cA vz cv caddc co
      caddc cF cseq1 co cfv cA vz cv caddc co c1 caddc co cF cfv caddc co cA
      caddc cF cseq1 co cfv cmin co cA vz cv caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv caddc
      co cA cn wcel vz cv cn wcel wa cA vz cv c1 caddc co caddc co caddc cF
      cseq1 co cfv cA vz cv caddc co caddc cF cseq1 co cfv cA vz cv caddc co c1
      caddc co cF cfv caddc co cA caddc cF cseq1 co cfv cmin cA cn wcel vz cv
      cn wcel wa cA vz cv caddc co c1 caddc co caddc cF cseq1 co cfv cA vz cv
      c1 caddc co caddc co caddc cF cseq1 co cfv cA vz cv caddc co caddc cF
      cseq1 co cfv cA vz cv caddc co c1 caddc co cF cfv caddc co cA cn wcel vz
      cv cn wcel wa cA vz cv caddc co c1 caddc co cA vz cv c1 caddc co caddc co
      caddc cF cseq1 co cA cc wcel vz cv cc wcel cA vz cv caddc co c1 caddc co
      cA vz cv c1 caddc co caddc co wceq cA cn wcel vz cv cn wcel cA cc wcel vz
      cv cc wcel c1 cc wcel cA vz cv caddc co c1 caddc co cA vz cv c1 caddc co
      caddc co wceq ax1cn cA vz cv c1 addass mp3an3 cA nncn vz cv nncn syl2an
      fveq2d cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv
      caddc co c1 caddc co caddc cF cseq1 co cfv cA vz cv caddc co caddc cF
      cseq1 co cfv cA vz cv caddc co c1 caddc co cF cfv caddc co wceq cA vz cv
      nnaddcl cA vz cv caddc co caddc cF addex cn cc cF wf cn cvv wcel cF cvv
      wcel ser1absdif.1 nnex cn cc cvv cF fex mp2an seq1p1 syl eqtr3d opreq1d
      cA vz cv caddc co caddc cF cseq1 co cfv cc wcel cA vz cv caddc co c1
      caddc co cF cfv cc wcel cA caddc cF cseq1 co cfv cc wcel cA vz cv caddc
      co caddc cF cseq1 co cfv cA vz cv caddc co c1 caddc co cF cfv caddc co cA
      caddc cF cseq1 co cfv cmin co cA vz cv caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv caddc
      co wceq cA cn wcel vz cv cn wcel wa cA vz cv caddc co caddc cF cseq1 co
      cfv cA vz cv caddc co c1 caddc co cF cfv cA caddc cF cseq1 co cfv addsub
      cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co
      caddc cF cseq1 co cfv cc wcel cA vz cv nnaddcl cA vz cv caddc co cF
      ser1absdif.1 ser1cl1i syl cA cn wcel vz cv cn wcel wa cA vz cv caddc co
      c1 caddc co cn wcel cA vz cv caddc co c1 caddc co cF cfv cc wcel cA cn
      wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co c1
      caddc co cn wcel cA vz cv nnaddcl cA vz cv caddc co peano2nn syl cn cc cA
      vz cv caddc co c1 caddc co cF ser1absdif.1 ffvelrni syl cA cn wcel cA
      caddc cF cseq1 co cfv cc wcel vz cv cn wcel cA cF ser1absdif.1 ser1cl1i
      adantr syl3anc eqtrd fveq2d cA cn wcel vz cv cn wcel wa cA vz cv c1 caddc
      co caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA vz
      cv caddc co caddc cG cseq1 co cfv cA vz cv caddc co c1 caddc co cG cfv
      caddc co cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co caddc cG
      cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1 caddc
      co cG cfv caddc co cA vz cv caddc co caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cF cfv cabs cfv caddc
      co cA cn wcel vz cv cn wcel wa cA vz cv c1 caddc co caddc co caddc cG
      cseq1 co cfv cA vz cv caddc co caddc cG cseq1 co cfv cA vz cv caddc co c1
      caddc co cG cfv caddc co cA caddc cG cseq1 co cfv cmin cA cn wcel vz cv
      cn wcel wa cA vz cv caddc co c1 caddc co caddc cG cseq1 co cfv cA vz cv
      c1 caddc co caddc co caddc cG cseq1 co cfv cA vz cv caddc co caddc cG
      cseq1 co cfv cA vz cv caddc co c1 caddc co cG cfv caddc co cA cn wcel vz
      cv cn wcel wa cA vz cv caddc co c1 caddc co cA vz cv c1 caddc co caddc co
      caddc cG cseq1 co cA cc wcel vz cv cc wcel cA vz cv caddc co c1 caddc co
      cA vz cv c1 caddc co caddc co wceq cA cn wcel vz cv cn wcel cA cc wcel vz
      cv cc wcel c1 cc wcel cA vz cv caddc co c1 caddc co cA vz cv c1 caddc co
      caddc co wceq ax1cn cA vz cv c1 addass mp3an3 cA nncn vz cv nncn syl2an
      fveq2d cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv
      caddc co c1 caddc co caddc cG cseq1 co cfv cA vz cv caddc co caddc cG
      cseq1 co cfv cA vz cv caddc co c1 caddc co cG cfv caddc co wceq cA vz cv
      nnaddcl cA vz cv caddc co caddc cG addex cG cn wfn cn cvv wcel cG cvv
      wcel ser1absdif.2 nnex cn cvv cG fnex mp2an seq1p1 syl eqtr3d opreq1d cA
      vz cv caddc co caddc cG cseq1 co cfv cc wcel cA vz cv caddc co c1 caddc
      co cG cfv cc wcel cA caddc cG cseq1 co cfv cc wcel cA vz cv caddc co
      caddc cG cseq1 co cfv cA vz cv caddc co c1 caddc co cG cfv caddc co cA
      caddc cG cseq1 co cfv cmin co cA vz cv caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cA vz cv caddc co c1 caddc co cG cfv caddc
      co wceq cA cn wcel vz cv cn wcel wa cA vz cv caddc co caddc cG cseq1 co
      cfv cA vz cv caddc co c1 caddc co cG cfv cA caddc cG cseq1 co cfv addsub
      cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz cv caddc co
      caddc cG cseq1 co cfv cc wcel cA vz cv nnaddcl cA vz cv caddc co cG cn cr
      cG wf cr cc wss cn cc cG wf cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx
      cn wral vx cn cr cG ffnfv ser1absdif.2 vx cv cG cfv cr wcel vx cn vx cv
      cn wcel vx cv cG cfv vx cv cF cfv cabs cfv cr ser1absdif.3 vx cv cn wcel
      vx cv cF cfv cc wcel vx cv cF cfv cabs cfv cr wcel cn cc vx cv cF
      ser1absdif.1 ffvelrni vx cv cF cfv abscl syl eqeltrd rgen mpbir2an
      axresscn cn cr cc cG fss mp2an ser1cl1i syl cA cn wcel vz cv cn wcel wa
      cA vz cv caddc co c1 caddc co cn wcel cA vz cv caddc co c1 caddc co cG
      cfv cc wcel cA cn wcel vz cv cn wcel wa cA vz cv caddc co cn wcel cA vz
      cv caddc co c1 caddc co cn wcel cA vz cv nnaddcl cA vz cv caddc co
      peano2nn syl cA vz cv caddc co c1 caddc co cn wcel cA vz cv caddc co c1
      caddc co cG cfv cA vz cv caddc co c1 caddc co cn wcel cA vz cv caddc co
      c1 caddc co cG cfv cA vz cv caddc co c1 caddc co cF cfv cabs cfv cr vx cv
      cG cfv vx cv cF cfv cabs cfv wceq cA vz cv caddc co c1 caddc co cG cfv cA
      vz cv caddc co c1 caddc co cF cfv cabs cfv wceq vx cA vz cv caddc co c1
      caddc co cn vx cv cA vz cv caddc co c1 caddc co wceq vx cv cG cfv cA vz
      cv caddc co c1 caddc co cG cfv vx cv cF cfv cabs cfv cA vz cv caddc co c1
      caddc co cF cfv cabs cfv vx cv cA vz cv caddc co c1 caddc co cG fveq2 vx
      cv cA vz cv caddc co c1 caddc co wceq vx cv cF cfv cA vz cv caddc co c1
      caddc co cF cfv cabs vx cv cA vz cv caddc co c1 caddc co cF fveq2 fveq2d
      eqeq12d ser1absdif.3 vtoclga cA vz cv caddc co c1 caddc co cn wcel cA vz
      cv caddc co c1 caddc co cF cfv cc wcel cA vz cv caddc co c1 caddc co cF
      cfv cabs cfv cr wcel cn cc cA vz cv caddc co c1 caddc co cF ser1absdif.1
      ffvelrni cA vz cv caddc co c1 caddc co cF cfv abscl syl eqeltrd recnd syl
      cA cn wcel cA caddc cG cseq1 co cfv cc wcel vz cv cn wcel cA cG cn cr cG
      wf cr cc wss cn cc cG wf cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx cn
      wral vx cn cr cG ffnfv ser1absdif.2 vx cv cG cfv cr wcel vx cn vx cv cn
      wcel vx cv cG cfv vx cv cF cfv cabs cfv cr ser1absdif.3 vx cv cn wcel vx
      cv cF cfv cc wcel vx cv cF cfv cabs cfv cr wcel cn cc vx cv cF
      ser1absdif.1 ffvelrni vx cv cF cfv abscl syl eqeltrd rgen mpbir2an
      axresscn cn cr cc cG fss mp2an ser1cl1i adantr syl3anc cA cn wcel vz cv
      cn wcel wa cA vz cv caddc co c1 caddc co cG cfv cA vz cv caddc co c1
      caddc co cF cfv cabs cfv cA vz cv caddc co caddc cG cseq1 co cfv cA caddc
      cG cseq1 co cfv cmin co caddc cA cn wcel vz cv cn wcel wa cA vz cv caddc
      co c1 caddc co cn wcel cA vz cv caddc co c1 caddc co cG cfv cA vz cv
      caddc co c1 caddc co cF cfv cabs cfv wceq cA cn wcel vz cv cn wcel wa cA
      vz cv caddc co cn wcel cA vz cv caddc co c1 caddc co cn wcel cA vz cv
      nnaddcl cA vz cv caddc co peano2nn syl vx cv cG cfv vx cv cF cfv cabs cfv
      wceq cA vz cv caddc co c1 caddc co cG cfv cA vz cv caddc co c1 caddc co
      cF cfv cabs cfv wceq vx cA vz cv caddc co c1 caddc co cn vx cv cA vz cv
      caddc co c1 caddc co wceq vx cv cG cfv cA vz cv caddc co c1 caddc co cG
      cfv vx cv cF cfv cabs cfv cA vz cv caddc co c1 caddc co cF cfv cabs cfv
      vx cv cA vz cv caddc co c1 caddc co cG fveq2 vx cv cA vz cv caddc co c1
      caddc co wceq vx cv cF cfv cA vz cv caddc co c1 caddc co cF cfv cabs vx
      cv cA vz cv caddc co c1 caddc co cF fveq2 fveq2d eqeq12d ser1absdif.3
      vtoclga syl opreq2d 3eqtrd breq12d 3imtr4d expcom a2d nnind impcom $.
      $( [20-Apr-2005] $) $( [17-Apr-2005] $)

    $( Generalized triangle inequality:  absolute value of a partial sum
       is less than or equal to sum of absolute values. $)
    ser1absdifi $p |- ( ( A e. NN /\ B e. NN /\ A < B ) ->
       ( abs ` ( ( ( + seq1 F ) ` B ) - ( ( + seq1 F ) ` A ) ) ) <_
       ( ( ( + seq1 G ) ` B ) - ( ( + seq1 G ) ` A ) ) ) $=
      cA cn wcel cB cn wcel cA cB clt wbr w3a cA cB cA cmin co caddc co caddc
      cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cA cB cA cmin
      co caddc co caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cB
      caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cB caddc
      cG cseq1 co cfv cA caddc cG cseq1 co cfv cmin co cle cA cn wcel cB cA
      cmin co cn wcel cA cB cA cmin co caddc co caddc cF cseq1 co cfv cA caddc
      cF cseq1 co cfv cmin co cabs cfv cA cB cA cmin co caddc co caddc cG cseq1
      co cfv cA caddc cG cseq1 co cfv cmin co cle wbr cA cn wcel cB cn wcel cA
      cB clt wbr w3a vx cA cB cA cmin co cF cG ser1absdif.1 ser1absdif.2
      ser1absdif.3 ser1absdiflem cA cn wcel cB cn wcel cA cB clt wbr 3simp1 cA
      cn wcel cB cn wcel cA cB clt wbr cB cA cmin co cn wcel cA cB nnsub
      biimp3a sylanc cA cn wcel cB cn wcel cA cB cA cmin co caddc co caddc cF
      cseq1 co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv cB caddc cF cseq1
      co cfv cA caddc cF cseq1 co cfv cmin co cabs cfv wceq cA cB clt wbr cA cn
      wcel cB cn wcel wa cA cB cA cmin co caddc co caddc cF cseq1 co cfv cA
      caddc cF cseq1 co cfv cmin co cB caddc cF cseq1 co cfv cA caddc cF cseq1
      co cfv cmin co cabs cA cn wcel cB cn wcel wa cA cB cA cmin co caddc co
      caddc cF cseq1 co cfv cB caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv
      cmin cA cn wcel cB cn wcel wa cA cB cA cmin co caddc co cB caddc cF cseq1
      co cA cc wcel cB cc wcel cA cB cA cmin co caddc co cB wceq cA cn wcel cB
      cn wcel cA cB pncan3 cA nncn cB nncn syl2an fveq2d opreq1d fveq2d 3adant3
      cA cn wcel cB cn wcel cA cB cA cmin co caddc co caddc cG cseq1 co cfv cA
      caddc cG cseq1 co cfv cmin co cB caddc cG cseq1 co cfv cA caddc cG cseq1
      co cfv cmin co wceq cA cB clt wbr cA cn wcel cB cn wcel wa cA cB cA cmin
      co caddc co caddc cG cseq1 co cfv cB caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv cmin cA cn wcel cB cn wcel wa cA cB cA cmin co caddc co cB
      caddc cG cseq1 co cA cc wcel cB cc wcel cA cB cA cmin co caddc co cB wceq
      cA cn wcel cB cn wcel cA cB pncan3 cA nncn cB nncn syl2an fveq2d opreq1d
      3adant3 3brtr3d $.
      $( [20-Apr-2005] $) $( [17-Apr-2005] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Factorial function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ! $. $( Factorial. $)

  $( Extend class notation to include the factorial of nonnegative integers. $)
  cfa $a class ! $.

  ${
    $d x y $.
    $( Define the factorial function on nonnegative integers.  In the
       literature, the factorial function is written as a postscript
       exclamation point. $)
    df-fac $a |- ! = ( { <. 0 , 1 >. } u. ( x. seq1 ( _I |` NN ) ) ) $.
  $}

  $( Value of the factorial function for positive integers. $)
  facnn $p |- ( N e. NN -> ( ! ` N ) = ( ( x. seq1 ( _I |` NN ) ) ` N ) ) $=
    cN cn wcel cN cn0 cc0 csn cdif wcel cN cfa cfv cN cmul cid cn cres cseq1 co
    cfv wceq cn cn0 cc0 csn cdif cN dfn2 eleq2i cc0 c1 cn0 cN cmul cid cn cres
    cseq1 co cfa cc0 cn0 0nn0 elisseti c1 cn 1nn elisseti cfa cc0 c1 cop csn
    cmul cid cn cres cseq1 co cun cc0 c1 cop csn cmul cid cn cres cseq1 co cn0
    cc0 csn cdif cres cun df-fac cmul cid cn cres cseq1 co cn0 cc0 csn cdif
    cres cmul cid cn cres cseq1 co cc0 c1 cop csn cmul cid cn cres cseq1 co cn
    cres cmul cid cn cres cseq1 co cn0 cc0 csn cdif cres cmul cid cn cres cseq1
    co cn cn0 cc0 csn cdif wceq cmul cid cn cres cseq1 co cn cres cmul cid cn
    cres cseq1 co cn0 cc0 csn cdif cres wceq dfn2 cn cn0 cc0 csn cdif cmul cid
    cn cres cseq1 co reseq2 ax-mp cmul cid cn cres cseq1 co cn wfn cmul cid cn
    cres cseq1 co cn cres cmul cid cn cres cseq1 co wceq cmul cid cn cres mulex
    cn cvv wcel cid cn cres cvv wcel nnex cn cvv resiexg ax-mp seq1fn cn cmul
    cid cn cres cseq1 co fnresdm ax-mp eqtr3i uneq2i eqtr4i fvsnun2 sylbi $.
    $( [3-Dec-2004] $) $( [2-Dec-2004] $)

  $( The factorial of 0. $)
  fac0 $p |- ( ! ` 0 ) = 1 $=
    cc0 c1 cn0 cmul cid cn cres cseq1 co cfa cc0 cn0 0nn0 elisseti c1 cn 1nn
    elisseti cfa cc0 c1 cop csn cmul cid cn cres cseq1 co cun cc0 c1 cop csn
    cmul cid cn cres cseq1 co cn0 cc0 csn cdif cres cun df-fac cmul cid cn cres
    cseq1 co cmul cid cn cres cseq1 co cn0 cc0 csn cdif cres cc0 c1 cop csn
    cmul cid cn cres cseq1 co cn cres cmul cid cn cres cseq1 co cmul cid cn
    cres cseq1 co cn0 cc0 csn cdif cres cmul cid cn cres cseq1 co cn wfn cmul
    cid cn cres cseq1 co cn cres cmul cid cn cres cseq1 co wceq cmul cid cn
    cres mulex cn cvv wcel cid cn cres cvv wcel nnex cn cvv resiexg ax-mp
    seq1fn cn cmul cid cn cres cseq1 co fnresdm ax-mp cn cn0 cc0 csn cdif wceq
    cmul cid cn cres cseq1 co cn cres cmul cid cn cres cseq1 co cn0 cc0 csn
    cdif cres wceq dfn2 cn cn0 cc0 csn cdif cmul cid cn cres cseq1 co reseq2
    ax-mp eqtr3i uneq2i eqtri fvsnun1 $.
    $( [3-Dec-2004] $) $( [2-Dec-2004] $)

  $( The factorial of 1. $)
  fac1 $p |- ( ! ` 1 ) = 1 $=
    c1 cfa cfv c1 cmul cid cn cres cseq1 co cfv c1 cid cn cres cfv c1 c1 cn
    wcel c1 cfa cfv c1 cmul cid cn cres cseq1 co cfv wceq 1nn c1 facnn ax-mp
    cmul cid cn cres mulex cid wfun cn cvv wcel cid cn cres cvv wcel funi nnex
    cid cn cvv resfunexg mp2an seq11 c1 cid cn cres cfv c1 cid cfv c1 c1 cn
    wcel c1 cid cn cres cfv c1 cid cfv wceq 1nn c1 cn cid fvres ax-mp c1 cn
    wcel c1 cid cfv c1 wceq 1nn c1 cn fvi ax-mp eqtri 3eqtri $.
    $( [3-Dec-2004] $) $( [2-Dec-2004] $)

  $( The factorial of a successor. $)
  facp1 $p |- ( N e. NN0 ->
               ( ! ` ( N + 1 ) ) = ( ( ! ` N ) x. ( N + 1 ) ) ) $=
    cN cn0 wcel cN cn wcel cN cc0 wceq wo cN c1 caddc co cfa cfv cN cfa cfv cN
    c1 caddc co cmul co wceq cN elnn0 cN cn wcel cN c1 caddc co cfa cfv cN cfa
    cfv cN c1 caddc co cmul co wceq cN cc0 wceq cN cn wcel cN c1 caddc co cfa
    cfv cN c1 caddc co cmul cid cn cres cseq1 co cfv cN cmul cid cn cres cseq1
    co cfv cN c1 caddc co cid cn cres cfv cmul co cN cfa cfv cN c1 caddc co
    cmul co cN cn wcel cN c1 caddc co cn wcel cN c1 caddc co cfa cfv cN c1
    caddc co cmul cid cn cres cseq1 co cfv wceq cN peano2nn cN c1 caddc co
    facnn syl cN cmul cid cn cres mulex cid wfun cn cvv wcel cid cn cres cvv
    wcel funi nnex cid cn cvv resfunexg mp2an seq1p1 cN cn wcel cN cmul cid cn
    cres cseq1 co cfv cN c1 caddc co cid cn cres cfv cmul co cN cmul cid cn
    cres cseq1 co cfv cN c1 caddc co cmul co cN cfa cfv cN c1 caddc co cmul co
    cN cn wcel cN c1 caddc co cid cn cres cfv cN c1 caddc co cN cmul cid cn
    cres cseq1 co cfv cmul cN cn wcel cN c1 caddc co cid cn cres cfv cN c1
    caddc co cid cfv cN c1 caddc co cN cn wcel cN c1 caddc co cn wcel cN c1
    caddc co cid cn cres cfv cN c1 caddc co cid cfv wceq cN peano2nn cN c1
    caddc co cn cid fvres syl cN c1 caddc co cvv wcel cN c1 caddc co cid cfv cN
    c1 caddc co wceq cN c1 caddc oprex cN c1 caddc co cvv fvi ax-mp syl6eq
    opreq2d cN cn wcel cN cfa cfv cN cmul cid cn cres cseq1 co cfv cN c1 caddc
    co cmul cN facnn opreq1d eqtr4d 3eqtrd cN cc0 wceq cc0 c1 caddc co cfa cfv
    c1 cN c1 caddc co cfa cfv cN cfa cfv cN c1 caddc co cmul co cc0 c1 caddc co
    cfa cfv c1 cfa cfv c1 cc0 c1 caddc co c1 cfa c1 ax1cn addid2i fveq2i fac1
    eqtri cN cc0 wceq cN c1 caddc co cc0 c1 caddc co cfa cN cc0 c1 caddc opreq1
    fveq2d cN cc0 wceq cN cfa cfv cN c1 caddc co cmul co cc0 cfa cfv cc0 c1
    caddc co cmul co c1 cN cc0 wceq cN cfa cfv cc0 cfa cfv cN c1 caddc co cc0
    c1 caddc co cmul cN cc0 cfa fveq2 cN cc0 c1 caddc opreq1 opreq12d cc0 cfa
    cfv cc0 c1 caddc co cmul co c1 c1 cmul co c1 cc0 cfa cfv c1 cc0 c1 caddc co
    c1 cmul fac0 c1 ax1cn addid2i opreq12i c1 ax1cn mulid1i eqtri syl6eq
    3eqtr4a jaoi sylbi $.
    $( [3-Dec-2004] $) $( [2-Dec-2004] $)

  $( The factorial of 2. $)
  fac2 $p |- ( ! ` 2 ) = 2 $=
    c2 cfa cfv c1 c1 caddc co cfa cfv c1 cfa cfv c1 c1 caddc co cmul co c2 c2
    c1 c1 caddc co cfa df-2 fveq2i c1 cn0 wcel c1 c1 caddc co cfa cfv c1 cfa
    cfv c1 c1 caddc co cmul co wceq 1nn0 c1 facp1 ax-mp c1 cfa cfv c1 c1 caddc
    co cmul co c1 c2 cmul co c2 c1 cfa cfv c1 c1 c1 caddc co c2 cmul fac1 c2 c1
    c1 caddc co df-2 eqcomi opreq12i c2 2cn mulid2i eqtri 3eqtri $.
    $( [7-Jul-2005] $) $( [17-Mar-2005] $)

  $( The factorial of 3. $)
  fac3 $p |- ( ! ` 3 ) = 6 $=
    c3 cfa cfv c2 c1 caddc co cfa cfv c2 cfa cfv c2 c1 caddc co cmul co c6 c3
    c2 c1 caddc co cfa df-3 fveq2i c2 cn0 wcel c2 c1 caddc co cfa cfv c2 cfa
    cfv c2 c1 caddc co cmul co wceq 2nn0 c2 facp1 ax-mp c2 cfa cfv c2 c1 caddc
    co cmul co c2 c3 cmul co c3 c2 cmul co c6 c2 cfa cfv c2 c2 c1 caddc co c3
    cmul fac2 c3 c2 c1 caddc co df-3 eqcomi opreq12i c2 c3 2cn c3 3re recni
    mulcomi 3t2e6 3eqtri 3eqtri $.
    $( [19-Jul-2005] $) $( [17-Mar-2005] $)

  $( Value of the factorial function expressed recursively. $)
  facnn2 $p |- ( N e. NN ->
               ( ! ` N ) = ( ( ! ` ( N - 1 ) ) x. N ) ) $=
    cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel wa cN cfa cfv cN c1 cmin co
    cfa cfv cN cmul co wceq cN elnnnn0 cN cc wcel cN c1 cmin co cn0 wcel wa cN
    c1 cmin co c1 caddc co cfa cfv cN c1 cmin co cfa cfv cN c1 cmin co c1 caddc
    co cmul co cN cfa cfv cN c1 cmin co cfa cfv cN cmul co cN c1 cmin co cn0
    wcel cN c1 cmin co c1 caddc co cfa cfv cN c1 cmin co cfa cfv cN c1 cmin co
    c1 caddc co cmul co wceq cN cc wcel cN c1 cmin co facp1 adantl cN cc wcel
    cN c1 cmin co c1 caddc co cfa cfv cN cfa cfv wceq cN c1 cmin co cn0 wcel cN
    cc wcel cN c1 cmin co c1 caddc co cN cfa cN cc wcel c1 cc wcel cN c1 cmin
    co c1 caddc co cN wceq ax1cn cN c1 npcan mpan2 fveq2d adantr cN cc wcel cN
    c1 cmin co cfa cfv cN c1 cmin co c1 caddc co cmul co cN c1 cmin co cfa cfv
    cN cmul co wceq cN c1 cmin co cn0 wcel cN cc wcel cN c1 cmin co c1 caddc co
    cN cN c1 cmin co cfa cfv cmul cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc
    co cN wceq ax1cn cN c1 npcan mpan2 opreq2d adantr 3eqtr3d sylbi $.
    $( [5-Feb-2005] $) $( [2-Dec-2004] $)

  ${
    $d j k N $.
    $( Closure of the factorial function. $)
    faccl $p |- ( N e. NN0 -> ( ! ` N ) e. NN ) $=
      vj cv cfa cfv cn wcel cc0 cfa cfv cn wcel vk cv cfa cfv cn wcel vk cv c1
      caddc co cfa cfv cn wcel cN cfa cfv cn wcel vj vk cN vj cv cc0 wceq vj cv
      cfa cfv cc0 cfa cfv cn vj cv cc0 cfa fveq2 eleq1d vj cv vk cv wceq vj cv
      cfa cfv vk cv cfa cfv cn vj cv vk cv cfa fveq2 eleq1d vj cv vk cv c1
      caddc co wceq vj cv cfa cfv vk cv c1 caddc co cfa cfv cn vj cv vk cv c1
      caddc co cfa fveq2 eleq1d vj cv cN wceq vj cv cfa cfv cN cfa cfv cn vj cv
      cN cfa fveq2 eleq1d cc0 cfa cfv c1 cn fac0 1nn eqeltri vk cv cfa cfv cn
      wcel vk cv cn0 wcel vk cv c1 caddc co cfa cfv cn wcel vk cv cfa cfv cn
      wcel vk cv cn0 wcel wa vk cv c1 caddc co cfa cfv vk cv cfa cfv vk cv c1
      caddc co cmul co cn vk cv cn0 wcel vk cv c1 caddc co cfa cfv vk cv cfa
      cfv vk cv c1 caddc co cmul co wceq vk cv cfa cfv cn wcel vk cv facp1
      adantl vk cv cfa cfv cn wcel vk cv c1 caddc co cn wcel vk cv cfa cfv vk
      cv c1 caddc co cmul co cn wcel vk cv cn0 wcel vk cv cfa cfv vk cv c1
      caddc co nnmulcl vk cv nn0p1nn sylan2 eqeltrd expcom nn0ind $.
      $( [29-Dec-2004] $) $( [2-Dec-2004] $)
  $}

  $( The factorial function is nonzero. $)
  facne0 $p |- ( N e. NN0 -> ( ! ` N ) =/= 0 ) $=
    cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cc0 wne cN faccl cN cfa cfv nnne0
    syl $.
    $( [3-May-2005] $) $( [26-Apr-2005] $)

  ${
    $d j M $.  $d j k N $.
    $( A natural number divides the factorial of an equal or larger number. $)
    facdiv $p |- ( ( M e. NN0 /\ N e. NN /\ N <_ M ) ->
                  ( ( ! ` M ) / N ) e. NN ) $=
      cM cn0 wcel cN cn wcel cN cM cle wbr cM cfa cfv cN cdiv co cn wcel cN cn
      wcel cN vj cv cle wbr vj cv cfa cfv cN cdiv co cn wcel wi wi cN cn wcel
      cN cc0 cle wbr cc0 cfa cfv cN cdiv co cn wcel wi wi cN cn wcel cN vk cv
      cle wbr vk cv cfa cfv cN cdiv co cn wcel wi wi cN cn wcel cN vk cv c1
      caddc co cle wbr vk cv c1 caddc co cfa cfv cN cdiv co cn wcel wi wi cN cn
      wcel cN cM cle wbr cM cfa cfv cN cdiv co cn wcel wi wi vj vk cM vj cv cc0
      wceq cN vj cv cle wbr vj cv cfa cfv cN cdiv co cn wcel wi cN cc0 cle wbr
      cc0 cfa cfv cN cdiv co cn wcel wi cN cn wcel vj cv cc0 wceq cN vj cv cle
      wbr cN cc0 cle wbr vj cv cfa cfv cN cdiv co cn wcel cc0 cfa cfv cN cdiv
      co cn wcel vj cv cc0 cN cle breq2 vj cv cc0 wceq vj cv cfa cfv cN cdiv co
      cc0 cfa cfv cN cdiv co cn vj cv cc0 wceq vj cv cfa cfv cc0 cfa cfv cN
      cdiv vj cv cc0 cfa fveq2 opreq1d eleq1d imbi12d imbi2d vj cv vk cv wceq
      cN vj cv cle wbr vj cv cfa cfv cN cdiv co cn wcel wi cN vk cv cle wbr vk
      cv cfa cfv cN cdiv co cn wcel wi cN cn wcel vj cv vk cv wceq cN vj cv cle
      wbr cN vk cv cle wbr vj cv cfa cfv cN cdiv co cn wcel vk cv cfa cfv cN
      cdiv co cn wcel vj cv vk cv cN cle breq2 vj cv vk cv wceq vj cv cfa cfv
      cN cdiv co vk cv cfa cfv cN cdiv co cn vj cv vk cv wceq vj cv cfa cfv vk
      cv cfa cfv cN cdiv vj cv vk cv cfa fveq2 opreq1d eleq1d imbi12d imbi2d vj
      cv vk cv c1 caddc co wceq cN vj cv cle wbr vj cv cfa cfv cN cdiv co cn
      wcel wi cN vk cv c1 caddc co cle wbr vk cv c1 caddc co cfa cfv cN cdiv co
      cn wcel wi cN cn wcel vj cv vk cv c1 caddc co wceq cN vj cv cle wbr cN vk
      cv c1 caddc co cle wbr vj cv cfa cfv cN cdiv co cn wcel vk cv c1 caddc co
      cfa cfv cN cdiv co cn wcel vj cv vk cv c1 caddc co cN cle breq2 vj cv vk
      cv c1 caddc co wceq vj cv cfa cfv cN cdiv co vk cv c1 caddc co cfa cfv cN
      cdiv co cn vj cv vk cv c1 caddc co wceq vj cv cfa cfv vk cv c1 caddc co
      cfa cfv cN cdiv vj cv vk cv c1 caddc co cfa fveq2 opreq1d eleq1d imbi12d
      imbi2d vj cv cM wceq cN vj cv cle wbr vj cv cfa cfv cN cdiv co cn wcel wi
      cN cM cle wbr cM cfa cfv cN cdiv co cn wcel wi cN cn wcel vj cv cM wceq
      cN vj cv cle wbr cN cM cle wbr vj cv cfa cfv cN cdiv co cn wcel cM cfa
      cfv cN cdiv co cn wcel vj cv cM cN cle breq2 vj cv cM wceq vj cv cfa cfv
      cN cdiv co cM cfa cfv cN cdiv co cn vj cv cM wceq vj cv cfa cfv cM cfa
      cfv cN cdiv vj cv cM cfa fveq2 opreq1d eleq1d imbi12d imbi2d cN cn wcel
      cN cc0 cle wbr cc0 cfa cfv cN cdiv co cn wcel cN cn wcel cc0 cN clt wbr
      cN cc0 cle wbr wn cN nngt0 cc0 cr wcel cN cr wcel cc0 cN clt wbr cN cc0
      cle wbr wn wb cN cn wcel cc0 cN ltnle 0re cN nnre sylancr mpbid pm2.21d
      vk cv cn0 wcel cN cn wcel cN vk cv cle wbr vk cv cfa cfv cN cdiv co cn
      wcel wi cN vk cv c1 caddc co cle wbr vk cv c1 caddc co cfa cfv cN cdiv co
      cn wcel wi vk cv cn0 wcel cN cn wcel cN vk cv cle wbr vk cv cfa cfv cN
      cdiv co cn wcel wi cN vk cv c1 caddc co cle wbr vk cv c1 caddc co cfa cfv
      cN cdiv co cn wcel vk cv cn0 wcel cN cn wcel cN vk cv cle wbr vk cv cfa
      cfv cN cdiv co cn wcel wi cN vk cv c1 caddc co cle wbr wa wa vk cv cfa
      cfv vk cv c1 caddc co cmul co cN cdiv co cn wcel vk cv c1 caddc co cfa
      cfv cN cdiv co cn wcel vk cv cn0 wcel cN cn wcel cN vk cv cle wbr vk cv
      cfa cfv cN cdiv co cn wcel wi cN vk cv c1 caddc co cle wbr vk cv cfa cfv
      vk cv c1 caddc co cmul co cN cdiv co cn wcel cN cn wcel vk cv cn0 wcel cN
      vk cv cle wbr vk cv cfa cfv cN cdiv co cn wcel wi cN vk cv c1 caddc co
      cle wbr vk cv cfa cfv vk cv c1 caddc co cmul co cN cdiv co cn wcel wi wi
      cN cn wcel vk cv cn0 wcel cN vk cv c1 caddc co cle wbr cN vk cv cle wbr
      vk cv cfa cfv cN cdiv co cn wcel wi vk cv cfa cfv vk cv c1 caddc co cmul
      co cN cdiv co cn wcel cN cn wcel vk cv cn0 wcel cN vk cv c1 caddc co cle
      wbr cN vk cv cle wbr vk cv cfa cfv cN cdiv co cn wcel wi vk cv cfa cfv vk
      cv c1 caddc co cmul co cN cdiv co cn wcel wi wi cN cn wcel vk cv cn0 wcel
      wa cN vk cv c1 caddc co cle wbr cN vk cv c1 caddc co clt wbr cN vk cv c1
      caddc co wceq wo cN vk cv cle wbr vk cv cfa cfv cN cdiv co cn wcel wi vk
      cv cfa cfv vk cv c1 caddc co cmul co cN cdiv co cn wcel wi cN cr wcel vk
      cv c1 caddc co cr wcel cN vk cv c1 caddc co cle wbr cN vk cv c1 caddc co
      clt wbr cN vk cv c1 caddc co wceq wo wb cN cn wcel vk cv cn0 wcel cN vk
      cv c1 caddc co leloe cN nnre vk cv cn0 wcel vk cv c1 caddc co cn0 wcel vk
      cv c1 caddc co cr wcel vk cv peano2nn0 vk cv c1 caddc co nn0re syl syl2an
      cN cn wcel vk cv cn0 wcel wa cN vk cv c1 caddc co clt wbr cN vk cv cle
      wbr vk cv cfa cfv cN cdiv co cn wcel wi vk cv cfa cfv vk cv c1 caddc co
      cmul co cN cdiv co cn wcel wi cN vk cv c1 caddc co wceq cN cn wcel vk cv
      cn0 wcel wa cN vk cv c1 caddc co clt wbr cN vk cv cle wbr cN vk cv cle
      wbr vk cv cfa cfv cN cdiv co cn wcel wi vk cv cfa cfv vk cv c1 caddc co
      cmul co cN cdiv co cn wcel wi cN cn0 wcel vk cv cn0 wcel cN vk cv cle wbr
      cN vk cv c1 caddc co clt wbr wb cN cn wcel cN vk cv nn0leltp1 cN nnnn0
      sylan cN cn wcel vk cv cn0 wcel wa cN vk cv cle wbr vk cv cfa cfv cN cdiv
      co cn wcel wi cN vk cv cle wbr vk cv cfa cfv vk cv c1 caddc co cmul co cN
      cdiv co cn wcel cN cn wcel vk cv cn0 wcel wa vk cv cfa cfv cN cdiv co cn
      wcel vk cv cfa cfv vk cv c1 caddc co cmul co cN cdiv co cn wcel cN vk cv
      cle wbr cN cn wcel vk cv cn0 wcel wa vk cv cfa cfv cN cdiv co cn wcel vk
      cv cfa cfv cN cdiv co vk cv c1 caddc co cmul co cn wcel vk cv cfa cfv vk
      cv c1 caddc co cmul co cN cdiv co cn wcel vk cv cn0 wcel vk cv cfa cfv cN
      cdiv co cn wcel vk cv cfa cfv cN cdiv co vk cv c1 caddc co cmul co cn
      wcel wi cN cn wcel vk cv cfa cfv cN cdiv co cn wcel vk cv cn0 wcel vk cv
      cfa cfv cN cdiv co vk cv c1 caddc co cmul co cn wcel vk cv cfa cfv cN
      cdiv co cn wcel vk cv c1 caddc co cn wcel vk cv cfa cfv cN cdiv co vk cv
      c1 caddc co cmul co cn wcel vk cv cn0 wcel vk cv cfa cfv cN cdiv co vk cv
      c1 caddc co nnmulcl vk cv nn0p1nn sylan2 expcom adantl cN cn wcel vk cv
      cn0 wcel wa vk cv cfa cfv vk cv c1 caddc co cmul co cN cdiv co vk cv cfa
      cfv cN cdiv co vk cv c1 caddc co cmul co cn vk cv cfa cfv cc wcel vk cv
      c1 caddc co cc wcel cN cc wcel cN cc0 wne wa vk cv cfa cfv vk cv c1 caddc
      co cmul co cN cdiv co vk cv cfa cfv cN cdiv co vk cv c1 caddc co cmul co
      wceq cN cn wcel vk cv cn0 wcel wa vk cv cfa cfv vk cv c1 caddc co cN
      div23 vk cv cn0 wcel vk cv cfa cfv cc wcel cN cn wcel vk cv cn0 wcel vk
      cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn
      syl adantl vk cv cn0 wcel vk cv c1 caddc co cc wcel cN cn wcel vk cv cn0
      wcel vk cv c1 caddc co cn0 wcel vk cv c1 caddc co cc wcel vk cv peano2nn0
      vk cv c1 caddc co nn0cn syl adantl cN cn wcel cN cc wcel cN cc0 wne wa vk
      cv cn0 wcel cN cn wcel cN cc wcel cN cc0 wne cN nncn cN nnne0 jca adantr
      syl3anc eleq1d sylibrd imim2d com23 sylbird cN cn wcel vk cv cn0 wcel wa
      cN vk cv c1 caddc co wceq vk cv cfa cfv vk cv c1 caddc co cmul co cN cdiv
      co cn wcel cN vk cv cle wbr vk cv cfa cfv cN cdiv co cn wcel wi cN vk cv
      c1 caddc co wceq vk cv cfa cfv cN cmul co cN cdiv co cn wcel vk cv cfa
      cfv vk cv c1 caddc co cmul co cN cdiv co cn wcel cN cn wcel vk cv cn0
      wcel wa cN vk cv c1 caddc co wceq vk cv cfa cfv cN cmul co cN cdiv co vk
      cv cfa cfv vk cv c1 caddc co cmul co cN cdiv co cn cN vk cv c1 caddc co
      wceq vk cv cfa cfv cN cmul co vk cv cfa cfv vk cv c1 caddc co cmul co cN
      cdiv cN vk cv c1 caddc co vk cv cfa cfv cmul opreq2 opreq1d eleq1d cN cn
      wcel vk cv cn0 wcel wa vk cv cfa cfv cN cmul co cN cdiv co vk cv cfa cfv
      cn vk cv cfa cfv cc wcel cN cc wcel cN cc0 wne vk cv cfa cfv cN cmul co
      cN cdiv co vk cv cfa cfv wceq cN cn wcel vk cv cn0 wcel wa vk cv cfa cfv
      cN divcan4 vk cv cn0 wcel vk cv cfa cfv cc wcel cN cn wcel vk cv cn0 wcel
      vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv
      nncn syl adantl cN cn wcel cN cc wcel vk cv cn0 wcel cN nncn adantr cN cn
      wcel cN cc0 wne vk cv cn0 wcel cN nnne0 adantr syl3anc vk cv cn0 wcel vk
      cv cfa cfv cn wcel cN cn wcel vk cv faccl adantl eqeltrd syl5cbi a1dd
      jaod sylbid ex com34 com12 imp4d vk cv cn0 wcel vk cv c1 caddc co cfa cfv
      cN cdiv co vk cv cfa cfv vk cv c1 caddc co cmul co cN cdiv co cn vk cv
      cn0 wcel vk cv c1 caddc co cfa cfv vk cv cfa cfv vk cv c1 caddc co cmul
      co cN cdiv vk cv facp1 opreq1d eleq1d sylibrd exp4d a2d nn0ind 3imp $.
      $( [6-May-2005] $) $( [2-May-2005] $)
  $}

  $( No natural number (greater than one) divides the factorial plus one of an
     equal or larger number. $)
  facndiv $p |- ( ( ( M e. NN0 /\ N e. NN ) /\ ( 1 < N /\ N <_ M ) ) ->
                -. ( ( ( ! ` M ) + 1 ) / N ) e. ZZ ) $=
    cM cn0 wcel cN cn wcel wa c1 cN clt wbr cN cM cle wbr wa wa cM cfa cfv c1
    caddc co cN cdiv co cz wcel c1 cN cdiv co cz wcel cN cn wcel c1 cN clt wbr
    c1 cN cdiv co cz wcel wn cM cn0 wcel cN cM cle wbr cN cr wcel c1 cN clt wbr
    c1 cN cdiv co cz wcel wn cN cn wcel cN recnz cN nnre sylan ad2ant2lr cM cn0
    wcel cN cn wcel wa c1 cN clt wbr cN cM cle wbr wa wa cM cfa cfv c1 caddc co
    cN cdiv co cz wcel cM cfa cfv c1 caddc co cN cdiv co cM cfa cfv cN cdiv co
    cmin co cz wcel c1 cN cdiv co cz wcel cM cfa cfv c1 caddc co cN cdiv co cz
    wcel cM cfa cfv cN cdiv co cz wcel cM cfa cfv c1 caddc co cN cdiv co cM cfa
    cfv cN cdiv co cmin co cz wcel cM cn0 wcel cN cn wcel wa c1 cN clt wbr cN
    cM cle wbr wa wa cM cfa cfv c1 caddc co cN cdiv co cz wcel cM cfa cfv cN
    cdiv co cz wcel cM cfa cfv c1 caddc co cN cdiv co cM cfa cfv cN cdiv co
    cmin co cz wcel cM cfa cfv c1 caddc co cN cdiv co cM cfa cfv cN cdiv co
    zsubcl ex cM cn0 wcel cN cn wcel wa cN cM cle wbr cM cfa cfv cN cdiv co cz
    wcel c1 cN clt wbr cM cn0 wcel cN cn wcel wa cN cM cle wbr wa cM cfa cfv cN
    cdiv co cn wcel cM cfa cfv cN cdiv co cz wcel cM cn0 wcel cN cn wcel cN cM
    cle wbr cM cfa cfv cN cdiv co cn wcel cM cN facdiv 3expa cM cfa cfv cN cdiv
    co nnz syl adantrl syl5com cM cn0 wcel cN cn wcel wa c1 cN clt wbr cN cM
    cle wbr wa wa cM cfa cfv c1 caddc co cN cdiv co cM cfa cfv cN cdiv co cmin
    co c1 cN cdiv co cz cM cn0 wcel cN cn wcel wa c1 cN clt wbr cN cM cle wbr
    wa wa cM cfa cfv c1 caddc co cM cfa cfv cmin co cN cdiv co cM cfa cfv c1
    caddc co cN cdiv co cM cfa cfv cN cdiv co cmin co c1 cN cdiv co cM cfa cfv
    c1 caddc co cc wcel cM cfa cfv cc wcel cN cc wcel cN cc0 wne wa cM cfa cfv
    c1 caddc co cM cfa cfv cmin co cN cdiv co cM cfa cfv c1 caddc co cN cdiv co
    cM cfa cfv cN cdiv co cmin co wceq cM cn0 wcel cN cn wcel wa c1 cN clt wbr
    cN cM cle wbr wa wa cM cfa cfv c1 caddc co cM cfa cfv cN divsubdir cM cn0
    wcel cM cfa cfv c1 caddc co cc wcel cN cn wcel c1 cN clt wbr cN cM cle wbr
    wa cM cn0 wcel cM cfa cfv cc wcel cM cfa cfv c1 caddc co cc wcel cM cn0
    wcel cM cfa cfv cn wcel cM cfa cfv cc wcel cM faccl cM cfa cfv nncn syl cM
    cfa cfv peano2cn syl ad2antrr cM cn0 wcel cM cfa cfv cc wcel cN cn wcel c1
    cN clt wbr cN cM cle wbr wa cM cn0 wcel cM cfa cfv cn wcel cM cfa cfv cc
    wcel cM faccl cM cfa cfv nncn syl ad2antrr cN cn wcel cN cc wcel cN cc0 wne
    wa cM cn0 wcel c1 cN clt wbr cN cM cle wbr wa cN cn wcel cN cc wcel cN cc0
    wne cN nncn cN nnne0 jca ad2antlr syl3anc cM cn0 wcel cM cfa cfv c1 caddc
    co cM cfa cfv cmin co cN cdiv co c1 cN cdiv co wceq cN cn wcel c1 cN clt
    wbr cN cM cle wbr wa cM cn0 wcel cM cfa cfv c1 caddc co cM cfa cfv cmin co
    c1 cN cdiv cM cfa cfv cc wcel c1 cc wcel cM cfa cfv c1 caddc co cM cfa cfv
    cmin co c1 wceq cM cn0 wcel cM cfa cfv c1 pncan2 cM cn0 wcel cM cfa cfv cn
    wcel cM cfa cfv cc wcel cM faccl cM cfa cfv nncn syl ax1cn sylancl opreq1d
    ad2antrr eqtr3d eleq1d sylibd mtod $.
    $( [8-May-2005] $) $( [3-May-2005] $)

  ${
    $d j k M $.  $d j N $.
    $( Ordering property of factorial. $)
    facwordi $p |- ( ( M e. NN0 /\ N e. NN0 /\ M <_ N ) ->
                  ( ! ` M ) <_ ( ! ` N ) ) $=
      cN cn0 wcel cM cn0 wcel cM cN cle wbr cM cfa cfv cN cfa cfv cle wbr cN
      cn0 wcel cM cn0 wcel cM cN cle wbr cM cfa cfv cN cfa cfv cle wbr cM cn0
      wcel cM vj cv cle wbr wa cM cfa cfv vj cv cfa cfv cle wbr wi cM cn0 wcel
      cM cc0 cle wbr wa cM cfa cfv cc0 cfa cfv cle wbr wi cM cn0 wcel cM vk cv
      cle wbr wa cM cfa cfv vk cv cfa cfv cle wbr wi cM cn0 wcel cM vk cv c1
      caddc co cle wbr wa cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr wi cM
      cn0 wcel cM cN cle wbr wa cM cfa cfv cN cfa cfv cle wbr wi vj vk cN vj cv
      cc0 wceq cM cn0 wcel cM vj cv cle wbr wa cM cn0 wcel cM cc0 cle wbr wa cM
      cfa cfv vj cv cfa cfv cle wbr cM cfa cfv cc0 cfa cfv cle wbr vj cv cc0
      wceq cM vj cv cle wbr cM cc0 cle wbr cM cn0 wcel vj cv cc0 cM cle breq2
      anbi2d vj cv cc0 wceq vj cv cfa cfv cc0 cfa cfv cM cfa cfv cle vj cv cc0
      cfa fveq2 breq2d imbi12d vj cv vk cv wceq cM cn0 wcel cM vj cv cle wbr wa
      cM cn0 wcel cM vk cv cle wbr wa cM cfa cfv vj cv cfa cfv cle wbr cM cfa
      cfv vk cv cfa cfv cle wbr vj cv vk cv wceq cM vj cv cle wbr cM vk cv cle
      wbr cM cn0 wcel vj cv vk cv cM cle breq2 anbi2d vj cv vk cv wceq vj cv
      cfa cfv vk cv cfa cfv cM cfa cfv cle vj cv vk cv cfa fveq2 breq2d imbi12d
      vj cv vk cv c1 caddc co wceq cM cn0 wcel cM vj cv cle wbr wa cM cn0 wcel
      cM vk cv c1 caddc co cle wbr wa cM cfa cfv vj cv cfa cfv cle wbr cM cfa
      cfv vk cv c1 caddc co cfa cfv cle wbr vj cv vk cv c1 caddc co wceq cM vj
      cv cle wbr cM vk cv c1 caddc co cle wbr cM cn0 wcel vj cv vk cv c1 caddc
      co cM cle breq2 anbi2d vj cv vk cv c1 caddc co wceq vj cv cfa cfv vk cv
      c1 caddc co cfa cfv cM cfa cfv cle vj cv vk cv c1 caddc co cfa fveq2
      breq2d imbi12d vj cv cN wceq cM cn0 wcel cM vj cv cle wbr wa cM cn0 wcel
      cM cN cle wbr wa cM cfa cfv vj cv cfa cfv cle wbr cM cfa cfv cN cfa cfv
      cle wbr vj cv cN wceq cM vj cv cle wbr cM cN cle wbr cM cn0 wcel vj cv cN
      cM cle breq2 anbi2d vj cv cN wceq vj cv cfa cfv cN cfa cfv cM cfa cfv cle
      vj cv cN cfa fveq2 breq2d imbi12d cM cn0 wcel cM cc0 cle wbr wa cM cfa
      cfv cc0 cfa cfv cc0 cfa cfv cle cM cn0 wcel cM cc0 cle wbr wa cM cc0 cfa
      cM cn0 wcel cM cc0 cle wbr cM cc0 wceq cM nn0le0eq0 biimpa fveq2d cc0 cfa
      cfv cc0 cfa cfv c1 cr fac0 1re eqeltri leidi syl6eqbr vk cv cn0 wcel cM
      cn0 wcel cM vk cv cle wbr cM cfa cfv vk cv cfa cfv cle wbr wi wi cM cn0
      wcel cM vk cv c1 caddc co cle wbr wa cM cfa cfv vk cv c1 caddc co cfa cfv
      cle wbr wi cM cn0 wcel cM vk cv cle wbr wa cM cfa cfv vk cv cfa cfv cle
      wbr wi vk cv cn0 wcel cM cn0 wcel cM vk cv cle wbr cM cfa cfv vk cv cfa
      cfv cle wbr wi wi cM cn0 wcel cM vk cv c1 caddc co cle wbr cM cfa cfv vk
      cv c1 caddc co cfa cfv cle wbr vk cv cn0 wcel cM cn0 wcel cM vk cv cle
      wbr cM cfa cfv vk cv cfa cfv cle wbr wi cM vk cv c1 caddc co cle wbr cM
      cfa cfv vk cv c1 caddc co cfa cfv cle wbr wi cM vk cv c1 caddc co cle wbr
      vk cv cn0 wcel cM cn0 wcel cM vk cv cle wbr cM cfa cfv vk cv cfa cfv cle
      wbr wi cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr cM cn0 wcel vk cv cn0
      wcel cM vk cv c1 caddc co cle wbr cM vk cv cle wbr cM cfa cfv vk cv cfa
      cfv cle wbr wi cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr wi cM cn0
      wcel vk cv cn0 wcel cM vk cv c1 caddc co cle wbr cM vk cv cle wbr cM cfa
      cfv vk cv cfa cfv cle wbr wi cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr
      wi wi cM cn0 wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cle wbr cM vk cv
      c1 caddc co clt wbr cM vk cv c1 caddc co wceq wo cM vk cv cle wbr cM cfa
      cfv vk cv cfa cfv cle wbr wi cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr
      wi cM cr wcel vk cv c1 caddc co cr wcel cM vk cv c1 caddc co cle wbr cM
      vk cv c1 caddc co clt wbr cM vk cv c1 caddc co wceq wo wb cM cn0 wcel vk
      cv cn0 wcel cM vk cv c1 caddc co leloe cM nn0re vk cv cn0 wcel vk cv cr
      wcel vk cv c1 caddc co cr wcel vk cv nn0re vk cv peano2re syl syl2an cM
      cn0 wcel vk cv cn0 wcel wa cM vk cv c1 caddc co clt wbr cM vk cv cle wbr
      cM cfa cfv vk cv cfa cfv cle wbr wi cM cfa cfv vk cv c1 caddc co cfa cfv
      cle wbr wi cM vk cv c1 caddc co wceq cM cn0 wcel vk cv cn0 wcel wa cM vk
      cv c1 caddc co clt wbr cM vk cv cle wbr cM vk cv cle wbr cM cfa cfv vk cv
      cfa cfv cle wbr wi cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr wi cM vk
      cv nn0leltp1 cM cn0 wcel vk cv cn0 wcel wa cM vk cv cle wbr cM cfa cfv vk
      cv cfa cfv cle wbr wi cM vk cv cle wbr cM cfa cfv vk cv c1 caddc co cfa
      cfv cle wbr cM cn0 wcel vk cv cn0 wcel wa cM cfa cfv vk cv cfa cfv cle
      wbr cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr cM vk cv cle wbr cM cn0
      wcel vk cv cn0 wcel wa cM cfa cfv vk cv cfa cfv cle wbr vk cv cfa cfv vk
      cv c1 caddc co cfa cfv cle wbr cM cfa cfv vk cv c1 caddc co cfa cfv cle
      wbr vk cv cn0 wcel vk cv cfa cfv vk cv c1 caddc co cfa cfv cle wbr cM cn0
      wcel vk cv cn0 wcel vk cv cfa cfv vk cv cfa cfv vk cv c1 caddc co cmul co
      vk cv c1 caddc co cfa cfv cle vk cv cn0 wcel vk cv cfa cfv c1 cmul co vk
      cv cfa cfv vk cv cfa cfv vk cv c1 caddc co cmul co cle vk cv cn0 wcel vk
      cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv cfa cfv c1 cmul co vk cv
      cfa cfv wceq vk cv faccl vk cv cfa cfv nncn vk cv cfa cfv ax1id 3syl vk
      cv c1 caddc co cr wcel vk cv cfa cfv cr wcel cc0 vk cv cfa cfv cle wbr c1
      vk cv c1 caddc co cle wbr vk cv cfa cfv c1 cmul co vk cv cfa cfv vk cv c1
      caddc co cmul co cle wbr vk cv cn0 wcel c1 cr wcel vk cv c1 caddc co cr
      wcel vk cv cfa cfv cr wcel cc0 vk cv cfa cfv cle wbr c1 vk cv c1 caddc co
      cle wbr wa vk cv cfa cfv c1 cmul co vk cv cfa cfv vk cv c1 caddc co cmul
      co cle wbr 1re c1 vk cv c1 caddc co vk cv cfa cfv lemul2aOLD mp3anl1 vk
      cv cn0 wcel vk cv cr wcel vk cv c1 caddc co cr wcel vk cv nn0re vk cv
      peano2re syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel
      vk cv faccl vk cv cfa cfv nnre syl vk cv cn0 wcel vk cv cfa cfv cn wcel
      vk cv cfa cfv cn0 wcel cc0 vk cv cfa cfv cle wbr vk cv faccl vk cv cfa
      cfv nnnn0 vk cv cfa cfv nn0ge0 3syl vk cv cn0 wcel cc0 c1 caddc co vk cv
      c1 caddc co c1 cle vk cv cn0 wcel cc0 vk cv cle wbr cc0 c1 caddc co vk cv
      c1 caddc co cle wbr vk cv nn0ge0 vk cv cn0 wcel vk cv cr wcel cc0 vk cv
      cle wbr cc0 c1 caddc co vk cv c1 caddc co cle wbr wb vk cv nn0re cc0 cr
      wcel vk cv cr wcel c1 cr wcel cc0 vk cv cle wbr cc0 c1 caddc co vk cv c1
      caddc co cle wbr wb 0re 1re cc0 vk cv c1 leadd1 mp3an13 syl mpbid c1
      ax1cn addid2i syl5eqbrr syl2anc eqbrtrrd vk cv facp1 breqtrrd adantl cM
      cfa cfv cr wcel vk cv cfa cfv cr wcel vk cv c1 caddc co cfa cfv cr wcel
      cM cfa cfv vk cv cfa cfv cle wbr vk cv cfa cfv vk cv c1 caddc co cfa cfv
      cle wbr wa cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr wi cM cn0 wcel vk
      cv cn0 wcel wa cM cfa cfv vk cv cfa cfv vk cv c1 caddc co cfa cfv letr cM
      cn0 wcel cM cfa cfv cr wcel vk cv cn0 wcel cM cn0 wcel cM cfa cfv cn wcel
      cM cfa cfv cr wcel cM faccl cM cfa cfv nnre syl adantr vk cv cn0 wcel vk
      cv cfa cfv cr wcel cM cn0 wcel vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv
      cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl adantl vk cv cn0 wcel
      vk cv c1 caddc co cfa cfv cr wcel cM cn0 wcel vk cv cn0 wcel vk cv c1
      caddc co cn0 wcel vk cv c1 caddc co cfa cfv cn wcel vk cv c1 caddc co cfa
      cfv cr wcel vk cv peano2nn0 vk cv c1 caddc co faccl vk cv c1 caddc co cfa
      cfv nnre 3syl adantl syl3anc mpan2d imim2d com23 sylbird cM cn0 wcel vk
      cv cn0 wcel wa cM vk cv c1 caddc co wceq cM cfa cfv vk cv c1 caddc co cfa
      cfv cle wbr cM vk cv cle wbr cM cfa cfv vk cv cfa cfv cle wbr wi cM cn0
      wcel cM vk cv c1 caddc co wceq cM cfa cfv vk cv c1 caddc co cfa cfv cle
      wbr wi vk cv cn0 wcel cM cn0 wcel cM cfa cfv vk cv c1 caddc co cfa cfv
      wceq cM cfa cfv vk cv c1 caddc co cfa cfv cle wbr cM vk cv c1 caddc co
      wceq cM cn0 wcel cM cfa cfv cr wcel cM cfa cfv cM cfa cfv cle wbr cM cfa
      cfv vk cv c1 caddc co cfa cfv wceq cM cfa cfv vk cv c1 caddc co cfa cfv
      cle wbr wi cM cn0 wcel cM cfa cfv cn wcel cM cfa cfv cr wcel cM faccl cM
      cfa cfv nnre syl cM cfa cfv leid cM cfa cfv vk cv c1 caddc co cfa cfv
      wceq cM cfa cfv cM cfa cfv cle wbr cM cfa cfv vk cv c1 caddc co cfa cfv
      cle wbr cM cfa cfv vk cv c1 caddc co cfa cfv cM cfa cfv cle breq2 biimpcd
      3syl cM vk cv c1 caddc co cfa fveq2 syl5 adantr a1dd jaod sylbid ex com13
      com4l a2d imp4a cM cn0 wcel cM vk cv cle wbr cM cfa cfv vk cv cfa cfv cle
      wbr impexp syl5ib nn0ind 3impib 3com12 $.
      $( [30-Dec-2005] $) $( [9-Dec-2005] $)

    $( A lower bound for the factorial function. $)
    faclbnd $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                   ( M ^ ( N + 1 ) ) <_ ( ( M ^ M ) x. ( ! ` N ) ) ) $=
      cM cn wcel cM cc0 wceq wo cN cn0 wcel cM cN c1 caddc co cexp co cM cM
      cexp co cN cfa cfv cmul co cle wbr cM cn0 wcel cM cn wcel cN cn0 wcel cM
      cN c1 caddc co cexp co cM cM cexp co cN cfa cfv cmul co cle wbr cM cc0
      wceq cN cn0 wcel cM cn wcel cM cN c1 caddc co cexp co cM cM cexp co cN
      cfa cfv cmul co cle wbr cM cn wcel cM vj cv c1 caddc co cexp co cM cM
      cexp co vj cv cfa cfv cmul co cle wbr wi cM cn wcel cM cc0 c1 caddc co
      cexp co cM cM cexp co cc0 cfa cfv cmul co cle wbr wi cM cn wcel cM vk cv
      c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle wbr wi cM cn
      wcel cM vk cv c1 caddc co c1 caddc co cexp co cM cM cexp co vk cv c1
      caddc co cfa cfv cmul co cle wbr wi cM cn wcel cM cN c1 caddc co cexp co
      cM cM cexp co cN cfa cfv cmul co cle wbr wi vj vk cN vj cv cc0 wceq cM vj
      cv c1 caddc co cexp co cM cM cexp co vj cv cfa cfv cmul co cle wbr cM cc0
      c1 caddc co cexp co cM cM cexp co cc0 cfa cfv cmul co cle wbr cM cn wcel
      vj cv cc0 wceq cM vj cv c1 caddc co cexp co cM cc0 c1 caddc co cexp co cM
      cM cexp co vj cv cfa cfv cmul co cM cM cexp co cc0 cfa cfv cmul co cle vj
      cv cc0 wceq vj cv c1 caddc co cc0 c1 caddc co cM cexp vj cv cc0 c1 caddc
      opreq1 opreq2d vj cv cc0 wceq vj cv cfa cfv cc0 cfa cfv cM cM cexp co
      cmul vj cv cc0 cfa fveq2 opreq2d breq12d imbi2d vj cv vk cv wceq cM vj cv
      c1 caddc co cexp co cM cM cexp co vj cv cfa cfv cmul co cle wbr cM vk cv
      c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle wbr cM cn
      wcel vj cv vk cv wceq cM vj cv c1 caddc co cexp co cM vk cv c1 caddc co
      cexp co cM cM cexp co vj cv cfa cfv cmul co cM cM cexp co vk cv cfa cfv
      cmul co cle vj cv vk cv wceq vj cv c1 caddc co vk cv c1 caddc co cM cexp
      vj cv vk cv c1 caddc opreq1 opreq2d vj cv vk cv wceq vj cv cfa cfv vk cv
      cfa cfv cM cM cexp co cmul vj cv vk cv cfa fveq2 opreq2d breq12d imbi2d
      vj cv vk cv c1 caddc co wceq cM vj cv c1 caddc co cexp co cM cM cexp co
      vj cv cfa cfv cmul co cle wbr cM vk cv c1 caddc co c1 caddc co cexp co cM
      cM cexp co vk cv c1 caddc co cfa cfv cmul co cle wbr cM cn wcel vj cv vk
      cv c1 caddc co wceq cM vj cv c1 caddc co cexp co cM vk cv c1 caddc co c1
      caddc co cexp co cM cM cexp co vj cv cfa cfv cmul co cM cM cexp co vk cv
      c1 caddc co cfa cfv cmul co cle vj cv vk cv c1 caddc co wceq vj cv c1
      caddc co vk cv c1 caddc co c1 caddc co cM cexp vj cv vk cv c1 caddc co c1
      caddc opreq1 opreq2d vj cv vk cv c1 caddc co wceq vj cv cfa cfv vk cv c1
      caddc co cfa cfv cM cM cexp co cmul vj cv vk cv c1 caddc co cfa fveq2
      opreq2d breq12d imbi2d vj cv cN wceq cM vj cv c1 caddc co cexp co cM cM
      cexp co vj cv cfa cfv cmul co cle wbr cM cN c1 caddc co cexp co cM cM
      cexp co cN cfa cfv cmul co cle wbr cM cn wcel vj cv cN wceq cM vj cv c1
      caddc co cexp co cM cN c1 caddc co cexp co cM cM cexp co vj cv cfa cfv
      cmul co cM cM cexp co cN cfa cfv cmul co cle vj cv cN wceq vj cv c1 caddc
      co cN c1 caddc co cM cexp vj cv cN c1 caddc opreq1 opreq2d vj cv cN wceq
      vj cv cfa cfv cN cfa cfv cM cM cexp co cmul vj cv cN cfa fveq2 opreq2d
      breq12d imbi2d cM cn wcel cM c1 cexp co cM cM cexp co cM cc0 c1 caddc co
      cexp co cM cM cexp co cc0 cfa cfv cmul co cle cM cr wcel c1 cn0 wcel cM
      cn0 wcel w3a c1 cM cle wbr c1 cM cle wbr wa cM c1 cexp co cM cM cexp co
      cle wbr cM cn wcel cM c1 cM expwordi cM cn wcel cM cr wcel c1 cn0 wcel cM
      cn0 wcel cM nnre c1 cn0 wcel cM cn wcel 1nn0 a1i cM nnnn0 3jca cM cn wcel
      c1 cM cle wbr c1 cM cle wbr cM nnge1 cM nnge1 jca sylanc cM cc0 c1 caddc
      co cexp co cM c1 cexp co wceq cM cn wcel cc0 c1 caddc co c1 cM cexp c1
      ax1cn addid2i opreq2i a1i cM cn wcel cM cM cexp co c1 cmul co cM cM cexp
      co cM cM cexp co cc0 cfa cfv cmul co cM cn wcel cM cM cexp co cc wcel cM
      cM cexp co c1 cmul co cM cM cexp co wceq cM cn wcel cM cM cexp co cM cr
      wcel cM cn0 wcel cM cM cexp co cr wcel cM cn wcel cM cM reexpcl cM nnre
      cM nnnn0 sylanc recnd cM cM cexp co ax1id syl cc0 cfa cfv c1 cM cM cexp
      co cmul fac0 opreq2i syl5eq 3brtr4d vk cv cn0 wcel cM cn wcel cM vk cv c1
      caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle wbr cM vk cv c1
      caddc co c1 caddc co cexp co cM cM cexp co vk cv c1 caddc co cfa cfv cmul
      co cle wbr cM cn wcel vk cv cn0 wcel cM vk cv c1 caddc co cexp co cM cM
      cexp co vk cv cfa cfv cmul co cle wbr cM vk cv c1 caddc co c1 caddc co
      cexp co cM cM cexp co vk cv c1 caddc co cfa cfv cmul co cle wbr wi cM cn
      wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cle wbr vk cv c1 caddc co cM
      clt wbr wo cM vk cv c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul
      co cle wbr cM vk cv c1 caddc co c1 caddc co cexp co cM cM cexp co vk cv
      c1 caddc co cfa cfv cmul co cle wbr wi cM cr wcel vk cv c1 caddc co cr
      wcel cM vk cv c1 caddc co cle wbr vk cv c1 caddc co cM clt wbr wo cM cn
      wcel vk cv cn0 wcel cM vk cv c1 caddc co lelttric cM nnre vk cv cn0 wcel
      vk cv cr wcel vk cv c1 caddc co cr wcel vk cv nn0re vk cv peano2re syl
      syl2an cM cn wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cle wbr cM vk cv
      c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle wbr cM vk cv
      c1 caddc co c1 caddc co cexp co cM cM cexp co vk cv c1 caddc co cfa cfv
      cmul co cle wbr wi vk cv c1 caddc co cM clt wbr cM cn wcel vk cv cn0 wcel
      wa cM vk cv c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle
      wbr cM vk cv c1 caddc co cle wbr cM vk cv c1 caddc co c1 caddc co cexp co
      cM cM cexp co vk cv c1 caddc co cfa cfv cmul co cle wbr cM cn wcel vk cv
      cn0 wcel wa cM vk cv c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul
      co cle wbr cM vk cv c1 caddc co cle wbr cM vk cv c1 caddc co c1 caddc co
      cexp co cM cM cexp co vk cv c1 caddc co cfa cfv cmul co cle wbr cM cn
      wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cexp co cM cM cexp co vk cv
      cfa cfv cmul co cle wbr cM vk cv c1 caddc co cle wbr wa wa cM vk cv c1
      caddc co cexp co cM cmul co cM cM cexp co vk cv cfa cfv cmul co vk cv c1
      caddc co cmul co cM vk cv c1 caddc co c1 caddc co cexp co cM cM cexp co
      vk cv c1 caddc co cfa cfv cmul co cle cM cn wcel vk cv cn0 wcel wa cM vk
      cv c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle wbr cM vk
      cv c1 caddc co cle wbr cM vk cv c1 caddc co cexp co cM cmul co cM cM cexp
      co vk cv cfa cfv cmul co vk cv c1 caddc co cmul co cle wbr cM vk cv c1
      caddc co cexp co cr wcel cM cM cexp co vk cv cfa cfv cmul co cr wcel wa
      cc0 cM vk cv c1 caddc co cexp co cle wbr cM vk cv c1 caddc co cexp co cM
      cM cexp co vk cv cfa cfv cmul co cle wbr wa wa cM cr wcel vk cv c1 caddc
      co cr wcel wa cc0 cM cle wbr cM vk cv c1 caddc co cle wbr wa wa cM vk cv
      c1 caddc co cexp co cM cmul co cM cM cexp co vk cv cfa cfv cmul co vk cv
      c1 caddc co cmul co cle wbr cM cn wcel vk cv cn0 wcel wa cM vk cv c1
      caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co cle wbr wa cM cn
      wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cle wbr wa cM vk cv c1 caddc
      co cexp co cM cM cexp co vk cv cfa cfv cmul co cM vk cv c1 caddc co
      lemul12aOLD cM cn wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cexp co cM
      cM cexp co vk cv cfa cfv cmul co cle wbr wa cM vk cv c1 caddc co cexp co
      cr wcel cM cM cexp co vk cv cfa cfv cmul co cr wcel cc0 cM vk cv c1 caddc
      co cexp co cle wbr cM vk cv c1 caddc co cexp co cM cM cexp co vk cv cfa
      cfv cmul co cle wbr wa cM cn wcel vk cv cn0 wcel wa cM vk cv c1 caddc co
      cexp co cr wcel cM vk cv c1 caddc co cexp co cM cM cexp co vk cv cfa cfv
      cmul co cle wbr cM cr wcel vk cv c1 caddc co cn0 wcel cM vk cv c1 caddc
      co cexp co cr wcel cM cn wcel vk cv cn0 wcel cM vk cv c1 caddc co reexpcl
      cM nnre vk cv peano2nn0 syl2an adantr cM cn wcel vk cv cn0 wcel wa cM cM
      cexp co vk cv cfa cfv cmul co cr wcel cM vk cv c1 caddc co cexp co cM cM
      cexp co vk cv cfa cfv cmul co cle wbr cM cM cexp co cr wcel vk cv cfa cfv
      cr wcel cM cM cexp co vk cv cfa cfv cmul co cr wcel cM cn wcel vk cv cn0
      wcel cM cM cexp co vk cv cfa cfv remulcl cM cr wcel cM cn0 wcel cM cM
      cexp co cr wcel cM cn wcel cM cM reexpcl cM nnre cM nnnn0 sylanc vk cv
      cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk cv
      cfa cfv nnre syl syl2an adantr cM cn wcel vk cv cn0 wcel wa cc0 cM vk cv
      c1 caddc co cexp co cle wbr cM vk cv c1 caddc co cexp co cM cM cexp co vk
      cv cfa cfv cmul co cle wbr cM cr wcel vk cv c1 caddc co cn0 wcel cc0 cM
      cle wbr cc0 cM vk cv c1 caddc co cexp co cle wbr cM cn wcel vk cv cn0
      wcel wa cM vk cv c1 caddc co expge0 cM cn wcel cM cr wcel vk cv cn0 wcel
      cM nnre adantr vk cv cn0 wcel vk cv c1 caddc co cn0 wcel cM cn wcel vk cv
      peano2nn0 adantl cM cn wcel cc0 cM cle wbr vk cv cn0 wcel cM cn wcel cM
      cn0 wcel cc0 cM cle wbr cM nnnn0 cM nn0ge0 syl adantr syl3anc anim1i
      jca31 cM cn wcel vk cv cn0 wcel wa cM vk cv c1 caddc co cle wbr wa cM cr
      wcel vk cv c1 caddc co cr wcel cc0 cM cle wbr cM vk cv c1 caddc co cle
      wbr wa cM cn wcel cM cr wcel vk cv cn0 wcel cM vk cv c1 caddc co cle wbr
      cM nnre ad2antrr vk cv cn0 wcel vk cv c1 caddc co cr wcel cM cn wcel cM
      vk cv c1 caddc co cle wbr vk cv cn0 wcel vk cv cr wcel vk cv c1 caddc co
      cr wcel vk cv nn0re vk cv peano2re syl ad2antlr cM cn wcel vk cv cn0 wcel
      wa cc0 cM cle wbr cM vk cv c1 caddc co cle wbr cM cn wcel cc0 cM cle wbr
      vk cv cn0 wcel cM cn wcel cM cn0 wcel cc0 cM cle wbr cM nnnn0 cM nn0ge0
      syl adantr anim1i jca31 syl2an anandis cM cn wcel vk cv cn0 wcel wa cM vk
      cv c1 caddc co c1 caddc co cexp co cM vk cv c1 caddc co cexp co cM cmul
      co wceq cM vk cv c1 caddc co cexp co cM cM cexp co vk cv cfa cfv cmul co
      cle wbr cM vk cv c1 caddc co cle wbr wa cM cc wcel vk cv c1 caddc co cn0
      wcel cM vk cv c1 caddc co c1 caddc co cexp co cM vk cv c1 caddc co cexp
      co cM cmul co wceq cM cn wcel vk cv cn0 wcel cM vk cv c1 caddc co expp1
      cM nncn vk cv peano2nn0 syl2an adantr cM cn wcel vk cv cn0 wcel wa cM cM
      cexp co vk cv c1 caddc co cfa cfv cmul co cM cM cexp co vk cv cfa cfv
      cmul co vk cv c1 caddc co cmul co wceq cM vk cv c1 caddc co cexp co cM cM
      cexp co vk cv cfa cfv cmul co cle wbr cM vk cv c1 caddc co cle wbr wa cM
      cn wcel vk cv cn0 wcel wa cM cM cexp co vk cv c1 caddc co cfa cfv cmul co
      cM cM cexp co vk cv cfa cfv vk cv c1 caddc co cmul co cmul co cM cM cexp
      co vk cv cfa cfv cmul co vk cv c1 caddc co cmul co cM cn wcel vk cv cn0
      wcel wa vk cv c1 caddc co cfa cfv vk cv cfa cfv vk cv c1 caddc co cmul co
      cM cM cexp co cmul vk cv cn0 wcel vk cv c1 caddc co cfa cfv vk cv cfa cfv
      vk cv c1 caddc co cmul co wceq cM cn wcel vk cv facp1 adantl opreq2d cM
      cM cexp co cc wcel vk cv cfa cfv cc wcel vk cv c1 caddc co cc wcel cM cM
      cexp co vk cv cfa cfv cmul co vk cv c1 caddc co cmul co cM cM cexp co vk
      cv cfa cfv vk cv c1 caddc co cmul co cmul co wceq cM cn wcel vk cv cn0
      wcel wa cM cM cexp co vk cv cfa cfv vk cv c1 caddc co mulass cM cn wcel
      cM cM cexp co cc wcel vk cv cn0 wcel cM cn wcel cM cM cexp co cM cr wcel
      cM cn0 wcel cM cM cexp co cr wcel cM cn wcel cM cM reexpcl cM nnre cM
      nnnn0 sylanc recnd adantr vk cv cn0 wcel vk cv cfa cfv cc wcel cM cn wcel
      vk cv cn0 wcel vk cv cfa cfv vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv
      cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl recnd adantl vk cv cn0
      wcel vk cv c1 caddc co cc wcel cM cn wcel vk cv cn0 wcel vk cv cc wcel vk
      cv c1 caddc co cc wcel vk cv nn0cn vk cv peano2cn syl adantl syl3anc
      eqtr4d adantr 3brtr4d exp32 com23 cM cn wcel vk cv cn0 wcel wa vk cv c1
      caddc co cM clt wbr cM vk cv c1 caddc co c1 caddc co cexp co cM cM cexp
      co vk cv c1 caddc co cfa cfv cmul co cle wbr cM vk cv c1 caddc co cexp co
      cM cM cexp co vk cv cfa cfv cmul co cle wbr cM cn wcel vk cv cn0 wcel wa
      vk cv c1 caddc co cM clt wbr vk cv c1 caddc co c1 caddc co cM cle wbr cM
      vk cv c1 caddc co c1 caddc co cexp co cM cM cexp co vk cv c1 caddc co cfa
      cfv cmul co cle wbr vk cv cn0 wcel cM cn wcel vk cv c1 caddc co cM clt
      wbr vk cv c1 caddc co c1 caddc co cM cle wbr wb vk cv c1 caddc co cn0
      wcel cM cn0 wcel vk cv c1 caddc co cM clt wbr vk cv c1 caddc co c1 caddc
      co cM cle wbr wb vk cv cn0 wcel cM cn wcel vk cv c1 caddc co cM nn0ltp1le
      vk cv peano2nn0 cM nnnn0 syl2an ancoms cM cn wcel vk cv cn0 wcel wa vk cv
      c1 caddc co c1 caddc co cM cle wbr cM vk cv c1 caddc co c1 caddc co cexp
      co cM cM cexp co vk cv c1 caddc co cfa cfv cmul co cle wbr cM cn wcel vk
      cv cn0 wcel wa vk cv c1 caddc co c1 caddc co cM cle wbr wa cM vk cv c1
      caddc co c1 caddc co cexp co cM cM cexp co cM cM cexp co vk cv c1 caddc
      co cfa cfv cmul co cM cn wcel vk cv cn0 wcel wa cM vk cv c1 caddc co c1
      caddc co cexp co cr wcel vk cv c1 caddc co c1 caddc co cM cle wbr cM cr
      wcel vk cv c1 caddc co c1 caddc co cn0 wcel cM vk cv c1 caddc co c1 caddc
      co cexp co cr wcel cM cn wcel vk cv cn0 wcel cM vk cv c1 caddc co c1
      caddc co reexpcl cM nnre vk cv cn0 wcel vk cv c1 caddc co cn0 wcel vk cv
      c1 caddc co c1 caddc co cn0 wcel vk cv peano2nn0 vk cv c1 caddc co
      peano2nn0 syl syl2an adantr cM cn wcel cM cM cexp co cr wcel vk cv cn0
      wcel vk cv c1 caddc co c1 caddc co cM cle wbr cM cr wcel cM cn0 wcel cM
      cM cexp co cr wcel cM cn wcel cM cM reexpcl cM nnre cM nnnn0 sylanc
      ad2antrr cM cn wcel vk cv cn0 wcel wa cM cM cexp co vk cv c1 caddc co cfa
      cfv cmul co cr wcel vk cv c1 caddc co c1 caddc co cM cle wbr cM cM cexp
      co cr wcel vk cv c1 caddc co cfa cfv cr wcel cM cM cexp co vk cv c1 caddc
      co cfa cfv cmul co cr wcel cM cn wcel vk cv cn0 wcel cM cM cexp co vk cv
      c1 caddc co cfa cfv remulcl cM cr wcel cM cn0 wcel cM cM cexp co cr wcel
      cM cn wcel cM cM reexpcl cM nnre cM nnnn0 sylanc vk cv cn0 wcel vk cv c1
      caddc co cn0 wcel vk cv c1 caddc co cfa cfv cn wcel vk cv c1 caddc co cfa
      cfv cr wcel vk cv peano2nn0 vk cv c1 caddc co faccl vk cv c1 caddc co cfa
      cfv nnre 3syl syl2an adantr cM cr wcel vk cv c1 caddc co c1 caddc co cn0
      wcel cM cn0 wcel w3a c1 cM cle wbr vk cv c1 caddc co c1 caddc co cM cle
      wbr wa cM vk cv c1 caddc co c1 caddc co cexp co cM cM cexp co cle wbr cM
      cn wcel vk cv cn0 wcel wa vk cv c1 caddc co c1 caddc co cM cle wbr wa cM
      vk cv c1 caddc co c1 caddc co cM expwordi cM cn wcel vk cv cn0 wcel wa vk
      cv c1 caddc co c1 caddc co cM cle wbr wa cM cr wcel vk cv c1 caddc co c1
      caddc co cn0 wcel cM cn0 wcel cM cn wcel cM cr wcel vk cv cn0 wcel vk cv
      c1 caddc co c1 caddc co cM cle wbr cM nnre ad2antrr vk cv cn0 wcel vk cv
      c1 caddc co c1 caddc co cn0 wcel cM cn wcel vk cv c1 caddc co c1 caddc co
      cM cle wbr vk cv cn0 wcel vk cv c1 caddc co cn0 wcel vk cv c1 caddc co c1
      caddc co cn0 wcel vk cv peano2nn0 vk cv c1 caddc co peano2nn0 syl
      ad2antlr cM cn wcel cM cn0 wcel vk cv cn0 wcel vk cv c1 caddc co c1 caddc
      co cM cle wbr cM nnnn0 ad2antrr 3jca cM cn wcel vk cv cn0 wcel wa c1 cM
      cle wbr vk cv c1 caddc co c1 caddc co cM cle wbr cM cn wcel c1 cM cle wbr
      vk cv cn0 wcel cM nnge1 adantr anim1i sylanc cM cn wcel vk cv cn0 wcel wa
      cM cM cexp co cM cM cexp co vk cv c1 caddc co cfa cfv cmul co cle wbr vk
      cv c1 caddc co c1 caddc co cM cle wbr cM cM cexp co cr wcel vk cv c1
      caddc co cfa cfv cr wcel wa cc0 cM cM cexp co cle wbr c1 vk cv c1 caddc
      co cfa cfv cle wbr wa cM cM cexp co cM cM cexp co vk cv c1 caddc co cfa
      cfv cmul co cle wbr cM cn wcel vk cv cn0 wcel wa cM cM cexp co vk cv c1
      caddc co cfa cfv lemulge11 cM cn wcel cM cM cexp co cr wcel vk cv cn0
      wcel vk cv c1 caddc co cfa cfv cr wcel cM cr wcel cM cn0 wcel cM cM cexp
      co cr wcel cM cn wcel cM cM reexpcl cM nnre cM nnnn0 sylanc vk cv cn0
      wcel vk cv c1 caddc co cn0 wcel vk cv c1 caddc co cfa cfv cn wcel vk cv
      c1 caddc co cfa cfv cr wcel vk cv peano2nn0 vk cv c1 caddc co faccl vk cv
      c1 caddc co cfa cfv nnre 3syl anim12i cM cn wcel cc0 cM cM cexp co cle
      wbr vk cv cn0 wcel c1 vk cv c1 caddc co cfa cfv cle wbr cM cn wcel cM cn0
      wcel cc0 cM cM cexp co cle wbr cM nnnn0 cM cr wcel cM cn0 wcel cc0 cM cle
      wbr cc0 cM cM cexp co cle wbr cM cn0 wcel cM cM expge0 cM nn0re cM cn0
      wcel id cM nn0ge0 syl3anc syl vk cv cn0 wcel vk cv c1 caddc co cn0 wcel
      vk cv c1 caddc co cfa cfv cn wcel c1 vk cv c1 caddc co cfa cfv cle wbr vk
      cv peano2nn0 vk cv c1 caddc co faccl vk cv c1 caddc co cfa cfv nnge1 3syl
      anim12i sylanc adantr letrd ex sylbid a1dd jaod mpd expcom a2d nn0ind
      impcom cM cc0 wceq cN cn0 wcel cM cN c1 caddc co cexp co cM cM cexp co cN
      cfa cfv cmul co cle wbr cM cc0 wceq cM cN c1 caddc co cexp co cM cM cexp
      co cN cfa cfv cmul co cle wbr cc0 cN c1 caddc co cexp co cc0 cc0 cexp co
      cN cfa cfv cmul co cle wbr cN cn0 wcel cM cc0 wceq cM cN c1 caddc co cexp
      co cc0 cN c1 caddc co cexp co cM cM cexp co cN cfa cfv cmul co cc0 cc0
      cexp co cN cfa cfv cmul co cle cM cc0 cN c1 caddc co cexp opreq1 cM cc0
      wceq cM cM cexp co cc0 cc0 cexp co cN cfa cfv cmul cM cc0 wceq cM cM cexp
      co cc0 cc0 cexp co wceq cM cc0 cM cc0 cexp opreq12 anidms opreq1d breq12d
      cN cn0 wcel cc0 cN cfa cfv cc0 cN c1 caddc co cexp co cc0 cc0 cexp co cN
      cfa cfv cmul co cle cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cn0 wcel
      cc0 cN cfa cfv cle wbr cN faccl cN cfa cfv nnnn0 cN cfa cfv nn0ge0 3syl
      cN cn0 wcel cN c1 caddc co cn wcel cc0 cN c1 caddc co cexp co cc0 wceq cN
      nn0p1nn cN c1 caddc co 0exp syl cN cn0 wcel c1 cN cfa cfv cmul co cN cfa
      cfv cc0 cc0 cexp co cN cfa cfv cmul co cN cn0 wcel cN cfa cfv cn wcel cN
      cfa cfv cc wcel c1 cN cfa cfv cmul co cN cfa cfv wceq cN faccl cN cfa cfv
      nncn cN cfa cfv mulid2 3syl cc0 cc0 cexp co c1 cN cfa cfv cmul cc0 cc
      wcel cc0 cc0 cexp co c1 wceq 0cn cc0 exp0 ax-mp opreq1i syl5eq 3brtr4d
      syl5bir imp jaoian cM elnn0 sylanb $.
      $( [18-Dec-2005] $) $( [17-Dec-2005] $)
  $}

  $( A lower bound for the factorial function. $)
  faclbnd2 $p |- ( N e. NN0 -> ( ( 2 ^ N ) / 2 ) <_ ( ! ` N ) ) $=
    cN cn0 wcel c2 cN cexp co c2 cdiv co c2 cN c1 caddc co cexp co c2 c2 cexp
    co cdiv co cN cfa cfv cle cN cn0 wcel c2 cN c1 caddc co cexp co c2 c2 cexp
    co cdiv co c2 cN cexp co c2 cmul co c2 c2 cmul co cdiv co c2 cN cexp co c2
    cdiv co c2 c2 cdiv co cmul co c2 cN cexp co c2 cdiv co cN cn0 wcel c2 cN c1
    caddc co cexp co c2 c2 cmul co cdiv co c2 cN cexp co c2 cmul co c2 c2 cmul
    co cdiv co c2 cN c1 caddc co cexp co c2 c2 cexp co cdiv co cN cn0 wcel c2
    cN c1 caddc co cexp co c2 cN cexp co c2 cmul co c2 c2 cmul co cdiv c2 cc
    wcel cN cn0 wcel c2 cN c1 caddc co cexp co c2 cN cexp co c2 cmul co wceq
    2cn c2 cN expp1 mpan opreq1d c2 c2 cexp co c2 c2 cmul co c2 cN c1 caddc co
    cexp co cdiv c2 c2 cexp co c4 c2 c2 cmul co sq2 2t2e4 eqtr4i opreq2i syl5eq
    c2 cN cexp co cc wcel c2 cc wcel c2 cN cexp co c2 cdiv co c2 c2 cdiv co
    cmul co c2 cN cexp co c2 cmul co c2 c2 cmul co cdiv co wceq cN cn0 wcel c2
    cN cexp co cc wcel c2 cc wcel wa c2 cc wcel c2 cc0 wne wa c2 cc wcel c2 cc0
    wne wa c2 cN cexp co c2 cdiv co c2 c2 cdiv co cmul co c2 cN cexp co c2 cmul
    co c2 c2 cmul co cdiv co wceq c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i c2 cc
    wcel c2 cc0 wne 2cn 2ne0 pm3.2i c2 cN cexp co c2 c2 c2 divmuldiv mpanr12 c2
    cc wcel cN cn0 wcel c2 cN cexp co cc wcel 2cn c2 cN expcl mpan 2cn sylancl
    cN cn0 wcel c2 cN cexp co c2 cdiv co c1 cmul co c2 cN cexp co c2 cdiv co c2
    cN cexp co c2 cdiv co c2 c2 cdiv co cmul co cN cn0 wcel c2 cN cexp co cc
    wcel c2 cN cexp co c2 cdiv co cc wcel c2 cN cexp co c2 cdiv co c1 cmul co
    c2 cN cexp co c2 cdiv co wceq c2 cc wcel cN cn0 wcel c2 cN cexp co cc wcel
    2cn c2 cN expcl mpan c2 cN cexp co halfcl c2 cN cexp co c2 cdiv co ax1id
    3syl c2 c2 cdiv co c1 c2 cN cexp co c2 cdiv co cmul c2 2cn 2ne0 dividi
    opreq2i syl5eq 3eqtr2rd cN cn0 wcel c2 cN c1 caddc co cexp co c2 c2 cexp co
    cdiv co cN cfa cfv cle wbr c2 cN c1 caddc co cexp co c2 c2 cexp co cN cfa
    cfv cmul co cle wbr c2 cn0 wcel cN cn0 wcel c2 cN c1 caddc co cexp co c2 c2
    cexp co cN cfa cfv cmul co cle wbr 2nn0 c2 cN faclbnd mpan c2 cN c1 caddc
    co cexp co cr wcel cN cfa cfv cr wcel c2 cN c1 caddc co cexp co c2 c2 cexp
    co cdiv co cN cfa cfv cle wbr c2 cN c1 caddc co cexp co c2 c2 cexp co cN
    cfa cfv cmul co cle wbr wb cN cn0 wcel c2 cN c1 caddc co cexp co cr wcel cN
    cfa cfv cr wcel c2 c2 cexp co cr wcel cc0 c2 c2 cexp co clt wbr wa c2 cN c1
    caddc co cexp co c2 c2 cexp co cdiv co cN cfa cfv cle wbr c2 cN c1 caddc co
    cexp co c2 c2 cexp co cN cfa cfv cmul co cle wbr wb c2 c2 cexp co cr wcel
    cc0 c2 c2 cexp co clt wbr c2 c2 cexp co c4 cr sq2 4re eqeltri cc0 c4 c2 c2
    cexp co clt 4pos sq2 breqtrri pm3.2i c2 cN c1 caddc co cexp co cN cfa cfv
    c2 c2 cexp co ledivmul mp3an3 c2 cr wcel cN c1 caddc co cn0 wcel c2 cN c1
    caddc co cexp co cr wcel cN cn0 wcel c2 cN c1 caddc co reexpcl 2re cN
    peano2nn0 sylancr cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cr wcel cN
    faccl cN cfa cfv nnre syl sylanc mpbird eqbrtrd $.
    $( [18-Dec-2005] $) $( [17-Dec-2005] $)

  $( A lower bound for the factorial function. $)
  faclbnd3 $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                 ( M ^ N ) <_ ( ( M ^ M ) x. ( ! ` N ) ) ) $=
    cM cn wcel cM cc0 wceq wo cN cn0 wcel cM cN cexp co cM cM cexp co cN cfa
    cfv cmul co cle wbr cM cn0 wcel cM cn wcel cN cn0 wcel cM cN cexp co cM cM
    cexp co cN cfa cfv cmul co cle wbr cM cc0 wceq cM cn wcel cN cn0 wcel wa cM
    cN cexp co cM cN c1 caddc co cexp co cle wbr cM cN c1 caddc co cexp co cM
    cM cexp co cN cfa cfv cmul co cle wbr cM cN cexp co cM cM cexp co cN cfa
    cfv cmul co cle wbr cM cr wcel cN cn0 wcel cN c1 caddc co cn0 wcel w3a c1
    cM cle wbr cN cN c1 caddc co cle wbr wa cM cN cexp co cM cN c1 caddc co
    cexp co cle wbr cM cn wcel cN cn0 wcel wa cM cN cN c1 caddc co expwordi cM
    cn wcel cN cn0 wcel wa cM cr wcel cN cn0 wcel cN c1 caddc co cn0 wcel cM cn
    wcel cM cr wcel cN cn0 wcel cM nnre adantr cM cn wcel cN cn0 wcel pm3.27 cN
    cn0 wcel cN c1 caddc co cn0 wcel cM cn wcel cN peano2nn0 adantl 3jca cM cn
    wcel c1 cM cle wbr cN cn0 wcel cN cN c1 caddc co cle wbr cM nnge1 cN cr
    wcel cN cr wcel cN cN cle wbr cN cN c1 caddc co cle wbr cN cn0 wcel cN cN
    letrp1 cN nn0re cN nn0re cN cn0 wcel cN cr wcel cN cN cle wbr cN nn0re cN
    leid syl syl3anc anim12i sylanc cM cn0 wcel cN cn0 wcel cM cN c1 caddc co
    cexp co cM cM cexp co cN cfa cfv cmul co cle wbr cM cn wcel cM cN faclbnd
    cM nnnn0 sylan cM cn0 wcel cN cn0 wcel cM cN cexp co cM cN c1 caddc co cexp
    co cle wbr cM cN c1 caddc co cexp co cM cM cexp co cN cfa cfv cmul co cle
    wbr wa cM cN cexp co cM cM cexp co cN cfa cfv cmul co cle wbr wi cM cn wcel
    cM cN cexp co cr wcel cM cN c1 caddc co cexp co cr wcel cM cM cexp co cN
    cfa cfv cmul co cr wcel cM cN cexp co cM cN c1 caddc co cexp co cle wbr cM
    cN c1 caddc co cexp co cM cM cexp co cN cfa cfv cmul co cle wbr wa cM cN
    cexp co cM cM cexp co cN cfa cfv cmul co cle wbr wi cM cn0 wcel cN cn0 wcel
    wa cM cN cexp co cM cN c1 caddc co cexp co cM cM cexp co cN cfa cfv cmul co
    letr cM cr wcel cN cn0 wcel cM cN cexp co cr wcel cM cn0 wcel cM cN reexpcl
    cM nn0re sylan cM cr wcel cN c1 caddc co cn0 wcel cM cN c1 caddc co cexp co
    cr wcel cM cn0 wcel cN cn0 wcel cM cN c1 caddc co reexpcl cM nn0re cN
    peano2nn0 syl2an cM cM cexp co cr wcel cN cfa cfv cr wcel cM cM cexp co cN
    cfa cfv cmul co cr wcel cM cn0 wcel cN cn0 wcel cM cM cexp co cN cfa cfv
    remulcl cM cr wcel cM cn0 wcel cM cM cexp co cr wcel cM nn0re cM cM reexpcl
    mpancom cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cr wcel cN faccl cN cfa
    cfv nnre syl syl2an syl3anc cM nnnn0 sylan mp2and cM cc0 wceq cN cn0 wcel
    wa cM cN cexp co cM cM cexp co cN cfa cfv cmul co cle wbr cc0 cN cexp co c1
    cN cfa cfv cmul co cle wbr cN cn0 wcel cc0 cN cexp co c1 cN cfa cfv cmul co
    cle wbr cM cc0 wceq cN cn0 wcel cc0 cN cexp co c1 cle wbr c1 c1 cN cfa cfv
    cmul co cle wbr cc0 cN cexp co c1 cN cfa cfv cmul co cle wbr cN cn0 wcel cN
    cn wcel cN cc0 wceq wo cc0 cN cexp co c1 cle wbr cN elnn0 cN cn wcel cc0 cN
    cexp co c1 cle wbr cN cc0 wceq cN cn wcel cc0 cN cexp co cc0 c1 cle cN 0exp
    cc0 c1 0re 1re lt01 ltleii syl6eqbr cN cc0 wceq cc0 cN cexp co cc0 cc0 cexp
    co c1 cle cN cc0 cc0 cexp opreq2 cc0 cc0 cexp co c1 c1 cle cc0 cc wcel cc0
    cc0 cexp co c1 wceq 0cn cc0 exp0 ax-mp c1 1re leidi eqbrtri syl6eqbr jaoi
    sylbi cN cn0 wcel c1 cN cfa cfv cmul co cn wcel c1 c1 cN cfa cfv cmul co
    cle wbr c1 cn wcel cN cfa cfv cn wcel c1 cN cfa cfv cmul co cn wcel cN cn0
    wcel c1 cN cfa cfv nnmulcl 1nn cN faccl sylancr c1 cN cfa cfv cmul co nnge1
    syl cc0 cN cexp co cr wcel c1 cN cfa cfv cmul co cr wcel cc0 cN cexp co c1
    cle wbr c1 c1 cN cfa cfv cmul co cle wbr wa cc0 cN cexp co c1 cN cfa cfv
    cmul co cle wbr wi cN cn0 wcel cc0 cN cexp co cr wcel c1 cr wcel c1 cN cfa
    cfv cmul co cr wcel cc0 cN cexp co c1 cle wbr c1 c1 cN cfa cfv cmul co cle
    wbr wa cc0 cN cexp co c1 cN cfa cfv cmul co cle wbr wi 1re cc0 cN cexp co
    c1 c1 cN cfa cfv cmul co letr mp3an2 cc0 cr wcel cN cn0 wcel cc0 cN cexp co
    cr wcel 0re cc0 cN reexpcl mpan c1 cr wcel cN cfa cfv cr wcel c1 cN cfa cfv
    cmul co cr wcel cN cn0 wcel c1 cN cfa cfv remulcl 1re cN cn0 wcel cN cfa
    cfv cn wcel cN cfa cfv cr wcel cN faccl cN cfa cfv nnre syl sylancr sylanc
    mp2and adantl cM cc0 wceq cM cN cexp co cM cM cexp co cN cfa cfv cmul co
    cle wbr cc0 cN cexp co c1 cN cfa cfv cmul co cle wbr wb cN cn0 wcel cM cc0
    wceq cM cN cexp co cc0 cN cexp co cM cM cexp co cN cfa cfv cmul co c1 cN
    cfa cfv cmul co cle cM cc0 cN cexp opreq1 cM cc0 wceq cM cM cexp co c1 cN
    cfa cfv cmul cM cc0 wceq cM cM cexp co cc0 cc0 cexp co c1 cM cc0 wceq cM cM
    cexp co cc0 cc0 cexp co wceq cM cc0 cM cc0 cexp opreq12 anidms cc0 cc wcel
    cc0 cc0 cexp co c1 wceq 0cn cc0 exp0 ax-mp syl6eq opreq1d breq12d adantr
    mpbird jaoian cM elnn0 sylanb $.
    $( [24-Dec-2005] $) $( [19-Dec-2005] $)

  ${
    faclbnd4lem1.1 $e |- N e. NN $.
    faclbnd4lem1.2 $e |- K e. NN0 $.
    faclbnd4lem1.3 $e |- M e. NN0 $.
    $( Lemma for ~ faclbnd4 .  Prepare the induction step.  _Warning:  The HTML
       proof page is 0.6 megabyte in size_. $)
    faclbnd4lem1 $p |- ( ( ( ( N - 1 ) ^ K ) x. ( M ^ ( N - 1 ) ) ) <_
       ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` ( N - 1 ) ) ) ->
                   ( ( N ^ ( K + 1 ) ) x. ( M ^ N ) ) <_ ( ( (
  2 ^ ( ( K + 1 ) ^ 2 ) ) x. ( M ^ ( M + ( K + 1 ) ) ) ) x. ( ! ` N ) ) ) $=
      cN c1 cle wbr c1 cN clt wbr wo cN c1 cmin co cK cexp co cM cN c1 cmin co
      cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
      co cN c1 cmin co cfa cfv cmul co cle wbr cN cK c1 caddc co cexp co cM cN
      cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co
      caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cN cr wcel c1 cr wcel
      cN c1 cle wbr c1 cN clt wbr wo cN faclbnd4lem1.1 nnrei 1re cN c1 lelttric
      mp2an cN c1 cle wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co
      cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1
      cmin co cfa cfv cmul co cle wbr cN cK c1 caddc co cexp co cM cN cexp co
      cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co caddc
      co cexp co cmul co cN cfa cfv cmul co cle wbr c1 cN clt wbr cN c1 cle wbr
      cN cK c1 caddc co cexp co cM cN cexp co cmul co c2 cK c1 caddc co c2 cexp
      co cexp co cM cM cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul
      co cle wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2
      cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa
      cfv cmul co cle wbr cN c1 cle wbr cN c1 wceq cN cK c1 caddc co cexp co cM
      cN cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc
      co caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cN c1 wceq cN c1
      cle wbr c1 cN cle wbr cN c1 cN faclbnd4lem1.1 nnrei 1re letri3i cN cn
      wcel c1 cN cle wbr faclbnd4lem1.1 cN nnge1 ax-mp mpbiran2 cN c1 wceq cN
      cK c1 caddc co cexp co cM cN cexp co cmul co c2 cK c1 caddc co c2 cexp co
      cexp co cM cM cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co
      cle wbr c1 cM cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1
      caddc co caddc co cexp co cmul co cle wbr c1 cr wcel cc0 c1 cle wbr wa c2
      cK c1 caddc co c2 cexp co cexp co cr wcel wa cM cr wcel cc0 cM cle wbr wa
      cM cM cK c1 caddc co caddc co cexp co cr wcel wa wa c1 c2 cK c1 caddc co
      c2 cexp co cexp co cle wbr cM cM cM cK c1 caddc co caddc co cexp co cle
      wbr wa c1 cM cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1
      caddc co caddc co cexp co cmul co cle wbr c1 cr wcel cc0 c1 cle wbr wa c2
      cK c1 caddc co c2 cexp co cexp co cr wcel wa cM cr wcel cc0 cM cle wbr wa
      cM cM cK c1 caddc co caddc co cexp co cr wcel wa c1 cr wcel cc0 c1 cle
      wbr wa c2 cK c1 caddc co c2 cexp co cexp co cr wcel c1 cr wcel cc0 c1 cle
      wbr 1re cc0 c1 0re 1re lt01 ltleii pm3.2i c2 cr wcel cK c1 caddc co c2
      cexp co cn0 wcel c2 cK c1 caddc co c2 cexp co cexp co cr wcel 2re cK c1
      caddc co cn0 wcel c2 cn0 wcel cK c1 caddc co c2 cexp co cn0 wcel cK c1
      caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn
      cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK c1 caddc co c2 nn0expcl mp2an c2 cK
      c1 caddc co c2 cexp co reexpcl mp2an pm3.2i cM cr wcel cc0 cM cle wbr wa
      cM cM cK c1 caddc co caddc co cexp co cr wcel cM cr wcel cc0 cM cle wbr
      cM faclbnd4lem1.3 nn0rei cM faclbnd4lem1.3 nn0ge0i pm3.2i cM cM cK c1
      caddc co caddc co cexp co cM cn0 wcel cM cK c1 caddc co caddc co cn0 wcel
      cM cM cK c1 caddc co caddc co cexp co cn0 wcel faclbnd4lem1.3 cM cK c1
      caddc co caddc co cM cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co
      caddc co cn wcel faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn
      wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co
      nn0nnaddcl mp2an nnnn0i cM cM cK c1 caddc co caddc co nn0expcl mp2an
      nn0rei pm3.2i pm3.2i c1 c2 cK c1 caddc co c2 cexp co cexp co cle wbr cM
      cM cM cK c1 caddc co caddc co cexp co cle wbr c2 cc0 cexp co c1 c2 cK c1
      caddc co c2 cexp co cexp co cle c2 cc wcel c2 cc0 cexp co c1 wceq 2cn c2
      exp0 ax-mp c2 cr wcel cc0 cn0 wcel cK c1 caddc co c2 cexp co cn0 wcel w3a
      c1 c2 cle wbr cc0 cK c1 caddc co c2 cexp co cle wbr wa c2 cc0 cexp co c2
      cK c1 caddc co c2 cexp co cexp co cle wbr c2 cr wcel cc0 cn0 wcel cK c1
      caddc co c2 cexp co cn0 wcel 2re 0nn0 cK c1 caddc co cn0 wcel c2 cn0 wcel
      cK c1 caddc co c2 cexp co cn0 wcel cK c1 caddc co cK cn0 wcel c1 cn wcel
      cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnnn0i
      2nn0 cK c1 caddc co c2 nn0expcl mp2an 3pm3.2i c1 c2 cle wbr cc0 cK c1
      caddc co c2 cexp co cle wbr c1 c2 1re 2re 1lt2 ltleii cK c1 caddc co c2
      cexp co cK c1 caddc co cn0 wcel c2 cn0 wcel cK c1 caddc co c2 cexp co cn0
      wcel cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK c1 caddc co c2
      nn0expcl mp2an nn0ge0i pm3.2i c2 cc0 cK c1 caddc co c2 cexp co expwordi
      mp2an eqbrtrri cM cn0 wcel cM cM cM cK c1 caddc co caddc co cexp co cle
      wbr faclbnd4lem1.3 cM cn0 wcel cM cn wcel cM cc0 wceq wo cM cM cM cK c1
      caddc co caddc co cexp co cle wbr cM elnn0 cM cn wcel cM cM cM cK c1
      caddc co caddc co cexp co cle wbr cM cc0 wceq cM cn wcel cM c1 cexp co cM
      cM cM cK c1 caddc co caddc co cexp co cle cM cn wcel cM cc wcel cM c1
      cexp co cM wceq cM nncn cM exp1 syl c1 cM cle wbr c1 cM cK c1 caddc co
      caddc co cle wbr cM c1 cexp co cM cM cK c1 caddc co caddc co cexp co cle
      wbr cM cn wcel cM cr wcel c1 cn0 wcel cM cK c1 caddc co caddc co cn0 wcel
      w3a c1 cM cle wbr c1 cM cK c1 caddc co caddc co cle wbr wa cM c1 cexp co
      cM cM cK c1 caddc co caddc co cexp co cle wbr cM cr wcel c1 cn0 wcel cM
      cK c1 caddc co caddc co cn0 wcel cM faclbnd4lem1.3 nn0rei 1nn0 cM cK c1
      caddc co caddc co cM cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co
      caddc co cn wcel faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn
      wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co
      nn0nnaddcl mp2an nnnn0i 3pm3.2i cM c1 cM cK c1 caddc co caddc co expwordi
      mpan cM nnge1 cM cK c1 caddc co caddc co cn wcel c1 cM cK c1 caddc co
      caddc co cle wbr cM cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co
      caddc co cn wcel faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn
      wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co
      nn0nnaddcl mp2an cM cK c1 caddc co caddc co nnge1 ax-mp sylancl eqbrtrrd
      cM cc0 wceq cM cM cM cK c1 caddc co caddc co cexp co cle wbr cc0 cM cM cK
      c1 caddc co caddc co cexp co cle wbr cM cM cK c1 caddc co caddc co cexp
      co cM cn0 wcel cM cK c1 caddc co caddc co cn0 wcel cM cM cK c1 caddc co
      caddc co cexp co cn0 wcel faclbnd4lem1.3 cM cK c1 caddc co caddc co cM
      cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co caddc co cn wcel
      faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl
      mp2an nnnn0i cM cM cK c1 caddc co caddc co nn0expcl mp2an nn0ge0i cM cc0
      cM cM cK c1 caddc co caddc co cexp co cle breq1 mpbiri jaoi sylbi ax-mp
      pm3.2i c1 c2 cK c1 caddc co c2 cexp co cexp co cM cM cM cK c1 caddc co
      caddc co cexp co lemul12a mp2 cN c1 wceq cN cK c1 caddc co cexp co cM cN
      cexp co cmul co c1 cM cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM
      cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co c2 cK c1 caddc
      co c2 cexp co cexp co cM cM cK c1 caddc co caddc co cexp co cmul co cle
      cN c1 wceq cN cK c1 caddc co cexp co c1 cM cN cexp co cM cmul cN c1 wceq
      cN cK c1 caddc co cexp co c1 cK c1 caddc co cexp co c1 cN c1 cK c1 caddc
      co cexp opreq1 cK c1 caddc co cn0 wcel c1 cK c1 caddc co cexp co c1 wceq
      cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnnn0i cK c1 caddc co 1exp
      ax-mp syl6eq cN c1 wceq cM cN cexp co cM c1 cexp co cM cN c1 cM cexp
      opreq2 cM cc wcel cM c1 cexp co cM wceq cM faclbnd4lem1.3 nn0cni cM exp1
      ax-mp syl6eq opreq12d cN c1 wceq c2 cK c1 caddc co c2 cexp co cexp co cM
      cM cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co c2 cK c1
      caddc co c2 cexp co cexp co cM cM cK c1 caddc co caddc co cexp co cmul co
      c1 cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co
      caddc co cexp co cmul co cN c1 wceq cN cfa cfv c1 c2 cK c1 caddc co c2
      cexp co cexp co cM cM cK c1 caddc co caddc co cexp co cmul co cmul cN c1
      wceq cN cfa cfv c1 cfa cfv c1 cN c1 cfa fveq2 fac1 syl6eq opreq2d c2 cK
      c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co caddc co cexp co cmul
      co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co caddc co
      cexp co c2 cK c1 caddc co c2 cexp co cexp co c2 cr wcel cK c1 caddc co c2
      cexp co cn0 wcel c2 cK c1 caddc co c2 cexp co cexp co cr wcel 2re cK c1
      caddc co cn0 wcel c2 cn0 wcel cK c1 caddc co c2 cexp co cn0 wcel cK c1
      caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn
      cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK c1 caddc co c2 nn0expcl mp2an c2 cK
      c1 caddc co c2 cexp co reexpcl mp2an recni cM cM cK c1 caddc co caddc co
      cexp co cM cn0 wcel cM cK c1 caddc co caddc co cn0 wcel cM cM cK c1 caddc
      co caddc co cexp co cn0 wcel faclbnd4lem1.3 cM cK c1 caddc co caddc co cM
      cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co caddc co cn wcel
      faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl
      mp2an nnnn0i cM cM cK c1 caddc co caddc co nn0expcl mp2an nn0cni mulcli
      mulid1i syl6eq breq12d mpbiri sylbir adantr c1 cN clt wbr cN c1 cmin co
      cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM
      cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co cle wbr wa
      cN cK c1 caddc co cexp co cM cN cexp co cmul co c2 cK c1 caddc co c2 cexp
      co cexp co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul co cmul
      co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co caddc co
      cexp co cmul co cN cfa cfv cmul co cle c1 cN clt wbr cN c1 cmin co cK
      cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM cM
      cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co cle wbr wa cN
      cK c1 caddc co cexp co cM cN cexp co cmul co c2 cK c2 cexp co cexp co c2
      cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul
      co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co
      caddc co cexp co cN cfa cfv cmul co cmul co cN cK c1 caddc co cexp co cM
      cN cexp co cmul co cr wcel c1 cN clt wbr cN c1 cmin co cK cexp co cM cN
      c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co
      cexp co cmul co cN c1 cmin co cfa cfv cmul co cle wbr wa cN cK c1 caddc
      co cexp co cM cN cexp co cN cr wcel cK c1 caddc co cn0 wcel cN cK c1
      caddc co cexp co cr wcel cN faclbnd4lem1.1 nnrei cK c1 caddc co cK cn0
      wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1
      nn0nnaddcl mp2an nnnn0i cN cK c1 caddc co reexpcl mp2an cM cr wcel cN cn0
      wcel cM cN cexp co cr wcel cM faclbnd4lem1.3 nn0rei cN faclbnd4lem1.1
      nnnn0i cM cN reexpcl mp2an remulcli a1i c2 cK c2 cexp co cexp co c2 cK
      cexp co cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul co
      cmul co cr wcel c1 cN clt wbr cN c1 cmin co cK cexp co cM cN c1 cmin co
      cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
      co cN c1 cmin co cfa cfv cmul co cle wbr wa c2 cK c2 cexp co cexp co c2
      cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul
      co c2 cK c2 cexp co cexp co c2 cK cexp co c2 cr wcel cK c2 cexp co cn0
      wcel c2 cK c2 cexp co cexp co cr wcel 2re cK cn0 wcel c2 cn0 wcel cK c2
      cexp co cn0 wcel faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an c2 cK c2 cexp
      co reexpcl mp2an c2 cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0
      wcel 2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0rei remulcli cM cM cK c1
      caddc co caddc co cexp co cN cfa cfv cmul co cM cM cK c1 caddc co caddc
      co cexp co cN cfa cfv cM cn0 wcel cM cK c1 caddc co caddc co cn0 wcel cM
      cM cK c1 caddc co caddc co cexp co cn0 wcel faclbnd4lem1.3 cM cK c1 caddc
      co caddc co cM cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co caddc co
      cn wcel faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl
      mp2an nnnn0i cM cM cK c1 caddc co caddc co nn0expcl mp2an cN cfa cfv cN
      cn0 wcel cN cfa cfv cn wcel cN faclbnd4lem1.1 nnnn0i cN faccl ax-mp
      nnnn0i nn0mulcli nn0rei remulcli a1i c2 cK c1 caddc co c2 cexp co cexp co
      cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul co cmul co cr wcel
      c1 cN clt wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co
      c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co
      cfa cfv cmul co cle wbr wa c2 cK c1 caddc co c2 cexp co cexp co cM cM cK
      c1 caddc co caddc co cexp co cN cfa cfv cmul co c2 cr wcel cK c1 caddc co
      c2 cexp co cn0 wcel c2 cK c1 caddc co c2 cexp co cexp co cr wcel 2re cK
      c1 caddc co cn0 wcel c2 cn0 wcel cK c1 caddc co c2 cexp co cn0 wcel cK c1
      caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn
      cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK c1 caddc co c2 nn0expcl mp2an c2 cK
      c1 caddc co c2 cexp co reexpcl mp2an cM cM cK c1 caddc co caddc co cexp
      co cN cfa cfv cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cM
      cn0 wcel cM cK c1 caddc co caddc co cn0 wcel cM cM cK c1 caddc co caddc
      co cexp co cn0 wcel faclbnd4lem1.3 cM cK c1 caddc co caddc co cM cn0 wcel
      cK c1 caddc co cn wcel cM cK c1 caddc co caddc co cn wcel faclbnd4lem1.3
      cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1
      nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl mp2an nnnn0i cM cM cK c1
      caddc co caddc co nn0expcl mp2an cN cfa cfv cN cn0 wcel cN cfa cfv cn
      wcel cN faclbnd4lem1.1 nnnn0i cN faccl ax-mp nnnn0i nn0mulcli nn0rei
      remulcli a1i c1 cN clt wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp
      co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
      c1 cmin co cfa cfv cmul co cle wbr wa cN cK cexp co cN cM cN c1 cmin co
      cexp co cM cmul co cmul co cmul co c2 cK c2 cexp co cexp co c2 cK cexp co
      cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul co cmul co
      cN cK c1 caddc co cexp co cM cN cexp co cmul co cle c1 cN clt wbr cN c1
      cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp
      co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co cle
      wbr wa cN cK cexp co cN cM cN c1 cmin co cexp co cM cmul co cmul co cmul
      co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin
      co cfa cfv cmul co c2 cK cexp co cN cmul co cM cmul co cmul co c2 cK c2
      cexp co cexp co c2 cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp
      co cN cfa cfv cmul co cmul co cle c1 cN clt wbr cN c1 cmin co cK cexp co
      cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc
      co cexp co cmul co cN c1 cmin co cfa cfv cmul co cle wbr wa cN cK cexp co
      cN cM cN c1 cmin co cexp co cM cmul co cmul co cmul co cN c1 cmin co cK
      cexp co cM cN c1 cmin co cexp co cmul co c2 cK cexp co cN cmul co cM cmul
      co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
      c1 cmin co cfa cfv cmul co c2 cK cexp co cN cmul co cM cmul co cmul co cN
      cK cexp co cN cM cN c1 cmin co cexp co cM cmul co cmul co cmul co cr wcel
      c1 cN clt wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co
      c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co
      cfa cfv cmul co cle wbr wa cN cK cexp co cN cM cN c1 cmin co cexp co cM
      cmul co cmul co cN cr wcel cK cn0 wcel cN cK cexp co cr wcel cN
      faclbnd4lem1.1 nnrei faclbnd4lem1.2 cN cK reexpcl mp2an cN cM cN c1 cmin
      co cexp co cM cmul co cmul co cN cM cN c1 cmin co cexp co cM cmul co cN
      faclbnd4lem1.1 nnnn0i cM cN c1 cmin co cexp co cM cM cn0 wcel cN c1 cmin
      co cn0 wcel cM cN c1 cmin co cexp co cn0 wcel faclbnd4lem1.3 cN cc wcel
      cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel wa
      faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cM cN c1 cmin co nn0expcl mp2an
      faclbnd4lem1.3 nn0mulcli nn0mulcli nn0rei remulcli a1i cN c1 cmin co cK
      cexp co cM cN c1 cmin co cexp co cmul co c2 cK cexp co cN cmul co cM cmul
      co cmul co cr wcel c1 cN clt wbr cN c1 cmin co cK cexp co cM cN c1 cmin
      co cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
      cmul co cN c1 cmin co cfa cfv cmul co cle wbr wa cN c1 cmin co cK cexp co
      cM cN c1 cmin co cexp co cmul co c2 cK cexp co cN cmul co cM cmul co cN
      c1 cmin co cK cexp co cM cN c1 cmin co cexp co cN c1 cmin co cr wcel cK
      cn0 wcel cN c1 cmin co cK cexp co cr wcel cN c1 cmin co cN cc wcel cN c1
      cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel wa
      faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i nn0rei faclbnd4lem1.2 cN c1 cmin
      co cK reexpcl mp2an cM cN c1 cmin co cexp co cM cn0 wcel cN c1 cmin co
      cn0 wcel cM cN c1 cmin co cexp co cn0 wcel faclbnd4lem1.3 cN cc wcel cN
      c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel wa
      faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cM cN c1 cmin co nn0expcl mp2an
      nn0rei remulcli c2 cK cexp co cN cmul co cM cmul co c2 cK cexp co cN cmul
      co cM c2 cK cexp co cN c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel
      2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an cN faclbnd4lem1.1 nnnn0i
      nn0mulcli faclbnd4lem1.3 nn0mulcli nn0rei remulcli a1i c2 cK c2 cexp co
      cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co
      c2 cK cexp co cN cmul co cM cmul co cmul co cr wcel c1 cN clt wbr cN c1
      cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp
      co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co cle
      wbr wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1
      cmin co cfa cfv cmul co c2 cK cexp co cN cmul co cM cmul co c2 cK c2 cexp
      co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv c2 cK
      c2 cexp co cexp co cM cM cK caddc co cexp co c2 cr wcel cK c2 cexp co cn0
      wcel c2 cK c2 cexp co cexp co cr wcel 2re cK cn0 wcel c2 cn0 wcel cK c2
      cexp co cn0 wcel faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an c2 cK c2 cexp
      co reexpcl mp2an cM cr wcel cM cK caddc co cn0 wcel cM cM cK caddc co
      cexp co cr wcel cM faclbnd4lem1.3 nn0rei cM cK faclbnd4lem1.3
      faclbnd4lem1.2 nn0addcli cM cM cK caddc co reexpcl mp2an remulcli cN c1
      cmin co cfa cfv cN c1 cmin co cn0 wcel cN c1 cmin co cfa cfv cn wcel cN
      cc wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0
      wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cN c1 cmin co faccl ax-mp
      nnrei remulcli c2 cK cexp co cN cmul co cM cmul co c2 cK cexp co cN cmul
      co cM c2 cK cexp co cN c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel
      2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an cN faclbnd4lem1.1 nnnn0i
      nn0mulcli faclbnd4lem1.3 nn0mulcli nn0rei remulcli a1i c1 cN clt wbr cN
      cK cexp co cN cM cN c1 cmin co cexp co cM cmul co cmul co cmul co cN c1
      cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK cexp co cN cmul
      co cM cmul co cmul co cle wbr cN c1 cmin co cK cexp co cM cN c1 cmin co
      cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
      co cN c1 cmin co cfa cfv cmul co cle wbr c1 cN clt wbr cN cK cexp co cN
      cM cN c1 cmin co cexp co cM cmul co cmul co cmul co c2 cK cexp co cN c1
      cmin co cK cexp co cmul co cN cM cN c1 cmin co cexp co cM cmul co cmul co
      cmul co cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK
      cexp co cN cmul co cM cmul co cmul co cle cN cK cexp co cr wcel c2 cK
      cexp co cN c1 cmin co cK cexp co cmul co cr wcel cN cM cN c1 cmin co cexp
      co cM cmul co cmul co cr wcel cc0 cN cM cN c1 cmin co cexp co cM cmul co
      cmul co cle wbr wa w3a cN cK cexp co c2 cK cexp co cN c1 cmin co cK cexp
      co cmul co cle wbr cN cK cexp co cN cM cN c1 cmin co cexp co cM cmul co
      cmul co cmul co c2 cK cexp co cN c1 cmin co cK cexp co cmul co cN cM cN
      c1 cmin co cexp co cM cmul co cmul co cmul co cle wbr c1 cN clt wbr cN cK
      cexp co c2 cK cexp co cN c1 cmin co cK cexp co cmul co cN cM cN c1 cmin
      co cexp co cM cmul co cmul co lemul1a cN cK cexp co cr wcel c2 cK cexp co
      cN c1 cmin co cK cexp co cmul co cr wcel cN cM cN c1 cmin co cexp co cM
      cmul co cmul co cr wcel cc0 cN cM cN c1 cmin co cexp co cM cmul co cmul
      co cle wbr wa cN cr wcel cK cn0 wcel cN cK cexp co cr wcel cN
      faclbnd4lem1.1 nnrei faclbnd4lem1.2 cN cK reexpcl mp2an c2 cK cexp co cN
      c1 cmin co cK cexp co c2 cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK cexp co
      cn0 wcel 2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0rei cN c1 cmin co cr
      wcel cK cn0 wcel cN c1 cmin co cK cexp co cr wcel cN c1 cmin co cN cc
      wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel
      wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i nn0rei faclbnd4lem1.2 cN c1
      cmin co cK reexpcl mp2an remulcli cN cM cN c1 cmin co cexp co cM cmul co
      cmul co cr wcel cc0 cN cM cN c1 cmin co cexp co cM cmul co cmul co cle
      wbr cN cM cN c1 cmin co cexp co cM cmul co cmul co cN cM cN c1 cmin co
      cexp co cM cmul co cN faclbnd4lem1.1 nnnn0i cM cN c1 cmin co cexp co cM
      cM cn0 wcel cN c1 cmin co cn0 wcel cM cN c1 cmin co cexp co cn0 wcel
      faclbnd4lem1.3 cN cc wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN
      c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cM cN c1
      cmin co nn0expcl mp2an faclbnd4lem1.3 nn0mulcli nn0mulcli nn0rei cN cM cN
      c1 cmin co cexp co cM cmul co cmul co cN cM cN c1 cmin co cexp co cM cmul
      co cN faclbnd4lem1.1 nnnn0i cM cN c1 cmin co cexp co cM cM cn0 wcel cN c1
      cmin co cn0 wcel cM cN c1 cmin co cexp co cn0 wcel faclbnd4lem1.3 cN cc
      wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel
      wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cM cN c1 cmin co nn0expcl mp2an
      faclbnd4lem1.3 nn0mulcli nn0mulcli nn0ge0i pm3.2i 3pm3.2i c1 cN clt wbr
      c2 cN cle wbr cN cK cexp co c2 cK cexp co cN c1 cmin co cK cexp co cmul
      co cle wbr c1 cN clt wbr c1 c1 caddc co cN cle wbr c2 cN cle wbr c1 cn
      wcel cN cn wcel c1 cN clt wbr c1 c1 caddc co cN cle wbr wb 1nn
      faclbnd4lem1.1 c1 cN nnltp1le mp2an c2 c1 c1 caddc co cN cle df-2 breq1i
      bitr4i cN cr wcel cK cn0 wcel c2 cN cle wbr cN cK cexp co c2 cK cexp co
      cN c1 cmin co cK cexp co cmul co cle wbr cN faclbnd4lem1.1 nnrei
      faclbnd4lem1.2 cN cK expubnd mp3an12 sylbi sylancr c2 cK cexp co cN c1
      cmin co cK cexp co cmul co cN cM cN c1 cmin co cexp co cM cmul co cmul co
      cmul co c2 cK cexp co cN cmul co cN c1 cmin co cK cexp co cM cN c1 cmin
      co cexp co cM cmul co cmul co cmul co c2 cK cexp co cN cmul co cN c1 cmin
      co cK cexp co cM cN c1 cmin co cexp co cmul co cM cmul co cmul co cN c1
      cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK cexp co cN cmul
      co cM cmul co cmul co c2 cK cexp co cN c1 cmin co cK cexp co cN cM cN c1
      cmin co cexp co cM cmul co c2 cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK
      cexp co cn0 wcel 2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0cni cN c1
      cmin co cK cexp co cN c1 cmin co cr wcel cK cn0 wcel cN c1 cmin co cK
      cexp co cr wcel cN c1 cmin co cN cc wcel cN c1 cmin co cn0 wcel cN cn
      wcel cN cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi
      pm3.27i nn0rei faclbnd4lem1.2 cN c1 cmin co cK reexpcl mp2an recni cN
      faclbnd4lem1.1 nncni cM cN c1 cmin co cexp co cM cmul co cM cN c1 cmin co
      cexp co cM cM cn0 wcel cN c1 cmin co cn0 wcel cM cN c1 cmin co cexp co
      cn0 wcel faclbnd4lem1.3 cN cc wcel cN c1 cmin co cn0 wcel cN cn wcel cN
      cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i
      cM cN c1 cmin co nn0expcl mp2an faclbnd4lem1.3 nn0mulcli nn0cni mul4i cN
      c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co cM cmul co cN c1
      cmin co cK cexp co cM cN c1 cmin co cexp co cM cmul co cmul co c2 cK cexp
      co cN cmul co cmul cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cM
      cN c1 cmin co cK cexp co cN c1 cmin co cr wcel cK cn0 wcel cN c1 cmin co
      cK cexp co cr wcel cN c1 cmin co cN cc wcel cN c1 cmin co cn0 wcel cN cn
      wcel cN cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi
      pm3.27i nn0rei faclbnd4lem1.2 cN c1 cmin co cK reexpcl mp2an recni cM cN
      c1 cmin co cexp co cM cn0 wcel cN c1 cmin co cn0 wcel cM cN c1 cmin co
      cexp co cn0 wcel faclbnd4lem1.3 cN cc wcel cN c1 cmin co cn0 wcel cN cn
      wcel cN cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi
      pm3.27i cM cN c1 cmin co nn0expcl mp2an nn0cni cM faclbnd4lem1.3 nn0cni
      mulassi opreq2i c2 cK cexp co cN cmul co cN c1 cmin co cK cexp co cM cN
      c1 cmin co cexp co cmul co cM c2 cK cexp co cN cmul co c2 cK cexp co cN
      c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel 2nn0 faclbnd4lem1.2 c2 cK
      nn0expcl mp2an cN faclbnd4lem1.1 nnnn0i nn0mulcli nn0cni cN c1 cmin co cK
      cexp co cM cN c1 cmin co cexp co cmul co cN c1 cmin co cK cexp co cM cN
      c1 cmin co cexp co cN c1 cmin co cr wcel cK cn0 wcel cN c1 cmin co cK
      cexp co cr wcel cN c1 cmin co cN cc wcel cN c1 cmin co cn0 wcel cN cn
      wcel cN cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi
      pm3.27i nn0rei faclbnd4lem1.2 cN c1 cmin co cK reexpcl mp2an cM cN c1
      cmin co cexp co cM cn0 wcel cN c1 cmin co cn0 wcel cM cN c1 cmin co cexp
      co cn0 wcel faclbnd4lem1.3 cN cc wcel cN c1 cmin co cn0 wcel cN cn wcel
      cN cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi
      pm3.27i cM cN c1 cmin co nn0expcl mp2an nn0rei remulcli recni cM
      faclbnd4lem1.3 nn0cni mul12i 3eqtr2i syl6breq adantr cN c1 cmin co cK
      cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM cM
      cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co cle wbr cN c1
      cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK cexp co cN cmul
      co cM cmul co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
      cmul co cN c1 cmin co cfa cfv cmul co c2 cK cexp co cN cmul co cM cmul co
      cmul co cle wbr c1 cN clt wbr cN c1 cmin co cK cexp co cM cN c1 cmin co
      cexp co cmul co cr wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
      co cmul co cN c1 cmin co cfa cfv cmul co cr wcel c2 cK cexp co cN cmul co
      cM cmul co cr wcel cc0 c2 cK cexp co cN cmul co cM cmul co cle wbr wa w3a
      cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2 cexp
      co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul
      co cle wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2
      cK cexp co cN cmul co cM cmul co cmul co c2 cK c2 cexp co cexp co cM cM
      cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co c2 cK cexp co
      cN cmul co cM cmul co cmul co cle wbr cN c1 cmin co cK cexp co cM cN c1
      cmin co cexp co cmul co cr wcel c2 cK c2 cexp co cexp co cM cM cK caddc
      co cexp co cmul co cN c1 cmin co cfa cfv cmul co cr wcel c2 cK cexp co cN
      cmul co cM cmul co cr wcel cc0 c2 cK cexp co cN cmul co cM cmul co cle
      wbr wa cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cN c1 cmin co cr
      wcel cK cn0 wcel cN c1 cmin co cK cexp co cr wcel cN c1 cmin co cN cc
      wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel
      wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i nn0rei faclbnd4lem1.2 cN c1
      cmin co cK reexpcl mp2an cM cN c1 cmin co cexp co cM cn0 wcel cN c1 cmin
      co cn0 wcel cM cN c1 cmin co cexp co cn0 wcel faclbnd4lem1.3 cN cc wcel
      cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel wa
      faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cM cN c1 cmin co nn0expcl mp2an
      nn0rei remulcli c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
      co cN c1 cmin co cfa cfv c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
      co c2 cr wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co cexp co cr wcel 2re
      cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel faclbnd4lem1.2 2nn0 cK c2
      nn0expcl mp2an c2 cK c2 cexp co reexpcl mp2an cM cr wcel cM cK caddc co
      cn0 wcel cM cM cK caddc co cexp co cr wcel cM faclbnd4lem1.3 nn0rei cM cK
      faclbnd4lem1.3 faclbnd4lem1.2 nn0addcli cM cM cK caddc co reexpcl mp2an
      remulcli cN c1 cmin co cfa cfv cN c1 cmin co cn0 wcel cN c1 cmin co cfa
      cfv cn wcel cN cc wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1
      cmin co cn0 wcel wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cN c1 cmin co
      faccl ax-mp nnrei remulcli c2 cK cexp co cN cmul co cM cmul co cr wcel
      cc0 c2 cK cexp co cN cmul co cM cmul co cle wbr c2 cK cexp co cN cmul co
      cM cmul co c2 cK cexp co cN cmul co cM c2 cK cexp co cN c2 cn0 wcel cK
      cn0 wcel c2 cK cexp co cn0 wcel 2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an
      cN faclbnd4lem1.1 nnnn0i nn0mulcli faclbnd4lem1.3 nn0mulcli nn0rei c2 cK
      cexp co cN cmul co cM cmul co c2 cK cexp co cN cmul co cM c2 cK cexp co
      cN c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel 2nn0 faclbnd4lem1.2 c2
      cK nn0expcl mp2an cN faclbnd4lem1.1 nnnn0i nn0mulcli faclbnd4lem1.3
      nn0mulcli nn0ge0i pm3.2i 3pm3.2i cN c1 cmin co cK cexp co cM cN c1 cmin
      co cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
      cmul co cN c1 cmin co cfa cfv cmul co c2 cK cexp co cN cmul co cM cmul co
      lemul1a mpan adantl letrd c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
      co cmul co cN c1 cmin co cfa cfv cmul co c2 cK cexp co cN cmul co cM cmul
      co cmul co c2 cK c2 cexp co cexp co c2 cK cexp co cmul co cM cM cK c1
      caddc co caddc co cexp co cmul co cN cfa cfv cmul co c2 cK c2 cexp co
      cexp co c2 cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp co cN
      cfa cfv cmul co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
      co cmul co cN c1 cmin co cfa cfv cmul co c2 cK cexp co cM cmul co cN cmul
      co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co c2
      cK cexp co cM cmul co cmul co cN c1 cmin co cfa cfv cN cmul co cmul co c2
      cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa
      cfv cmul co c2 cK cexp co cN cmul co cM cmul co cmul co c2 cK c2 cexp co
      cexp co c2 cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp co cmul
      co cN cfa cfv cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
      cmul co cN c1 cmin co cfa cfv c2 cK cexp co cM cmul co cN c2 cK c2 cexp
      co cexp co cM cM cK caddc co cexp co cmul co c2 cK c2 cexp co cexp co cM
      cM cK caddc co cexp co c2 cr wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co
      cexp co cr wcel 2re cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel
      faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an c2 cK c2 cexp co reexpcl mp2an
      cM cr wcel cM cK caddc co cn0 wcel cM cM cK caddc co cexp co cr wcel cM
      faclbnd4lem1.3 nn0rei cM cK faclbnd4lem1.3 faclbnd4lem1.2 nn0addcli cM cM
      cK caddc co reexpcl mp2an remulcli recni cN c1 cmin co cfa cfv cN c1 cmin
      co cn0 wcel cN c1 cmin co cfa cfv cn wcel cN cc wcel cN c1 cmin co cn0
      wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel wa faclbnd4lem1.1 cN
      elnnnn0 mpbi pm3.27i cN c1 cmin co faccl ax-mp nncni c2 cK cexp co cM c2
      cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel 2nn0
      faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0cni cM faclbnd4lem1.3 nn0cni
      mulcli cN faclbnd4lem1.1 nncni mul4i c2 cK cexp co cN cmul co cM cmul co
      c2 cK cexp co cM cmul co cN cmul co c2 cK c2 cexp co cexp co cM cM cK
      caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co cmul c2 cK cexp co
      cN cM c2 cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel 2nn0
      faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0cni cN faclbnd4lem1.1 nncni cM
      faclbnd4lem1.3 nn0cni mul23i opreq2i c2 cK c2 cexp co cexp co c2 cK cexp
      co cmul co cM cM cK c1 caddc co caddc co cexp co cmul co c2 cK c2 cexp co
      cexp co cM cM cK caddc co cexp co cmul co c2 cK cexp co cM cmul co cmul
      co cN cfa cfv cN c1 cmin co cfa cfv cN cmul co cmul c2 cK c2 cexp co cexp
      co c2 cK cexp co cmul co cM cM cK caddc co cexp co cM cmul co cmul co c2
      cK c2 cexp co cexp co c2 cK cexp co cmul co cM cM cK c1 caddc co caddc co
      cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
      co c2 cK cexp co cM cmul co cmul co cM cM cK caddc co cexp co cM cmul co
      cM cM cK c1 caddc co caddc co cexp co c2 cK c2 cexp co cexp co c2 cK cexp
      co cmul co cmul cM cM cK caddc co c1 caddc co cexp co cM cM cK caddc co
      cexp co cM cmul co cM cM cK c1 caddc co caddc co cexp co cM cc wcel cM cK
      caddc co cn0 wcel cM cM cK caddc co c1 caddc co cexp co cM cM cK caddc co
      cexp co cM cmul co wceq cM faclbnd4lem1.3 nn0cni cM cK faclbnd4lem1.3
      faclbnd4lem1.2 nn0addcli cM cM cK caddc co expp1 mp2an cM cK caddc co c1
      caddc co cM cK c1 caddc co caddc co cM cexp cM cK c1 cM faclbnd4lem1.3
      nn0cni cK faclbnd4lem1.2 nn0cni ax1cn addassi opreq2i eqtr3i opreq2i c2
      cK c2 cexp co cexp co c2 cK cexp co cM cM cK caddc co cexp co cM c2 cK c2
      cexp co cexp co c2 cr wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co cexp
      co cr wcel 2re cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel
      faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an c2 cK c2 cexp co reexpcl mp2an
      recni c2 cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK cexp co cn0 wcel 2nn0
      faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0cni cM cM cK caddc co cexp co cM
      cr wcel cM cK caddc co cn0 wcel cM cM cK caddc co cexp co cr wcel cM
      faclbnd4lem1.3 nn0rei cM cK faclbnd4lem1.3 faclbnd4lem1.2 nn0addcli cM cM
      cK caddc co reexpcl mp2an recni cM faclbnd4lem1.3 nn0cni mul4i eqtr3i cN
      cn wcel cN cfa cfv cN c1 cmin co cfa cfv cN cmul co wceq faclbnd4lem1.1
      cN facnn2 ax-mp opreq12i 3eqtr4i c2 cK c2 cexp co cexp co c2 cK cexp co
      cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv c2 cK c2 cexp co
      cexp co c2 cK cexp co cmul co c2 cK c2 cexp co cexp co c2 cK cexp co c2
      cr wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co cexp co cr wcel 2re cK
      cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel faclbnd4lem1.2 2nn0 cK c2
      nn0expcl mp2an c2 cK c2 cexp co reexpcl mp2an c2 cK cexp co c2 cn0 wcel
      cK cn0 wcel c2 cK cexp co cn0 wcel 2nn0 faclbnd4lem1.2 c2 cK nn0expcl
      mp2an nn0rei remulcli recni cM cM cK c1 caddc co caddc co cexp co cM cn0
      wcel cM cK c1 caddc co caddc co cn0 wcel cM cM cK c1 caddc co caddc co
      cexp co cn0 wcel faclbnd4lem1.3 cM cK c1 caddc co caddc co cM cn0 wcel cK
      c1 caddc co cn wcel cM cK c1 caddc co caddc co cn wcel faclbnd4lem1.3 cK
      cn0 wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1
      nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl mp2an nnnn0i cM cM cK c1
      caddc co caddc co nn0expcl mp2an nn0cni cN cfa cfv cN cn0 wcel cN cfa cfv
      cn wcel cN faclbnd4lem1.1 nnnn0i cN faccl ax-mp nncni mulassi eqtri
      syl6breq cN cK c1 caddc co cexp co cM cN cexp co cmul co cN cK cexp co cN
      cmul co cM cN c1 cmin co cexp co cM cmul co cmul co cN cK cexp co cN cM
      cN c1 cmin co cexp co cM cmul co cmul co cmul co cN cK c1 caddc co cexp
      co cN cK cexp co cN cmul co cM cN cexp co cM cN c1 cmin co cexp co cM
      cmul co cmul cN cc wcel cK cn0 wcel cN cK c1 caddc co cexp co cN cK cexp
      co cN cmul co wceq cN faclbnd4lem1.1 nncni faclbnd4lem1.2 cN cK expp1
      mp2an cM cc wcel cN cn wcel cM cN cexp co cM cN c1 cmin co cexp co cM
      cmul co wceq cM faclbnd4lem1.3 nn0cni faclbnd4lem1.1 cM cN expm1t mp2an
      opreq12i cN cK cexp co cN cM cN c1 cmin co cexp co cM cmul co cN cK cexp
      co cN cr wcel cK cn0 wcel cN cK cexp co cr wcel cN faclbnd4lem1.1 nnrei
      faclbnd4lem1.2 cN cK reexpcl mp2an recni cN faclbnd4lem1.1 nncni cM cN c1
      cmin co cexp co cM cmul co cM cN c1 cmin co cexp co cM cM cn0 wcel cN c1
      cmin co cn0 wcel cM cN c1 cmin co cexp co cn0 wcel faclbnd4lem1.3 cN cc
      wcel cN c1 cmin co cn0 wcel cN cn wcel cN cc wcel cN c1 cmin co cn0 wcel
      wa faclbnd4lem1.1 cN elnnnn0 mpbi pm3.27i cM cN c1 cmin co nn0expcl mp2an
      faclbnd4lem1.3 nn0mulcli nn0cni mulassi eqtri syl5eqbr c2 cK c2 cexp co
      cexp co c2 cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp co cN
      cfa cfv cmul co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1
      caddc co caddc co cexp co cN cfa cfv cmul co cmul co cle wbr c1 cN clt
      wbr cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2
      cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv
      cmul co cle wbr wa c2 cK c2 cexp co cexp co c2 cK cexp co cmul co cr wcel
      c2 cK c1 caddc co c2 cexp co cexp co cr wcel cM cM cK c1 caddc co caddc
      co cexp co cN cfa cfv cmul co cr wcel cc0 cM cM cK c1 caddc co caddc co
      cexp co cN cfa cfv cmul co cle wbr wa w3a c2 cK c2 cexp co cexp co c2 cK
      cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co cle wbr c2 cK c2
      cexp co cexp co c2 cK cexp co cmul co cM cM cK c1 caddc co caddc co cexp
      co cN cfa cfv cmul co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM
      cK c1 caddc co caddc co cexp co cN cfa cfv cmul co cmul co cle wbr c2 cK
      c2 cexp co cexp co c2 cK cexp co cmul co cr wcel c2 cK c1 caddc co c2
      cexp co cexp co cr wcel cM cM cK c1 caddc co caddc co cexp co cN cfa cfv
      cmul co cr wcel cc0 cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul
      co cle wbr wa c2 cK c2 cexp co cexp co c2 cK cexp co c2 cr wcel cK c2
      cexp co cn0 wcel c2 cK c2 cexp co cexp co cr wcel 2re cK cn0 wcel c2 cn0
      wcel cK c2 cexp co cn0 wcel faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an c2
      cK c2 cexp co reexpcl mp2an c2 cK cexp co c2 cn0 wcel cK cn0 wcel c2 cK
      cexp co cn0 wcel 2nn0 faclbnd4lem1.2 c2 cK nn0expcl mp2an nn0rei remulcli
      c2 cr wcel cK c1 caddc co c2 cexp co cn0 wcel c2 cK c1 caddc co c2 cexp
      co cexp co cr wcel 2re cK c1 caddc co cn0 wcel c2 cn0 wcel cK c1 caddc co
      c2 cexp co cn0 wcel cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co
      cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK c1 caddc
      co c2 nn0expcl mp2an c2 cK c1 caddc co c2 cexp co reexpcl mp2an cM cM cK
      c1 caddc co caddc co cexp co cN cfa cfv cmul co cr wcel cc0 cM cM cK c1
      caddc co caddc co cexp co cN cfa cfv cmul co cle wbr cM cM cK c1 caddc co
      caddc co cexp co cN cfa cfv cmul co cM cM cK c1 caddc co caddc co cexp co
      cN cfa cfv cM cn0 wcel cM cK c1 caddc co caddc co cn0 wcel cM cM cK c1
      caddc co caddc co cexp co cn0 wcel faclbnd4lem1.3 cM cK c1 caddc co caddc
      co cM cn0 wcel cK c1 caddc co cn wcel cM cK c1 caddc co caddc co cn wcel
      faclbnd4lem1.3 cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl
      mp2an nnnn0i cM cM cK c1 caddc co caddc co nn0expcl mp2an cN cfa cfv cN
      cn0 wcel cN cfa cfv cn wcel cN faclbnd4lem1.1 nnnn0i cN faccl ax-mp
      nnnn0i nn0mulcli nn0rei cM cM cK c1 caddc co caddc co cexp co cN cfa cfv
      cmul co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cM cn0 wcel cM
      cK c1 caddc co caddc co cn0 wcel cM cM cK c1 caddc co caddc co cexp co
      cn0 wcel faclbnd4lem1.3 cM cK c1 caddc co caddc co cM cn0 wcel cK c1
      caddc co cn wcel cM cK c1 caddc co caddc co cn wcel faclbnd4lem1.3 cK cn0
      wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1
      nn0nnaddcl mp2an cM cK c1 caddc co nn0nnaddcl mp2an nnnn0i cM cM cK c1
      caddc co caddc co nn0expcl mp2an cN cfa cfv cN cn0 wcel cN cfa cfv cn
      wcel cN faclbnd4lem1.1 nnnn0i cN faccl ax-mp nnnn0i nn0mulcli nn0ge0i
      pm3.2i 3pm3.2i c2 cK c2 cexp co cK caddc co cexp co c2 cK c2 cexp co cexp
      co c2 cK cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co cle c2 cc
      wcel cK c2 cexp co cn0 wcel cK cn0 wcel c2 cK c2 cexp co cK caddc co cexp
      co c2 cK c2 cexp co cexp co c2 cK cexp co cmul co wceq 2cn cK cn0 wcel c2
      cn0 wcel cK c2 cexp co cn0 wcel faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an
      faclbnd4lem1.2 c2 cK c2 cexp co cK expadd mp3an c2 cr wcel cK c2 cexp co
      cK caddc co cn0 wcel cK c1 caddc co c2 cexp co cn0 wcel w3a c1 c2 cle wbr
      cK c2 cexp co cK caddc co cK c1 caddc co c2 cexp co cle wbr wa c2 cK c2
      cexp co cK caddc co cexp co c2 cK c1 caddc co c2 cexp co cexp co cle wbr
      c2 cr wcel cK c2 cexp co cK caddc co cn0 wcel cK c1 caddc co c2 cexp co
      cn0 wcel 2re cK c2 cexp co cK cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0
      wcel faclbnd4lem1.2 2nn0 cK c2 nn0expcl mp2an faclbnd4lem1.2 nn0addcli cK
      c1 caddc co cn0 wcel c2 cn0 wcel cK c1 caddc co c2 cexp co cn0 wcel cK c1
      caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn
      cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK c1 caddc co c2 nn0expcl mp2an
      3pm3.2i c1 c2 cle wbr cK c2 cexp co cK caddc co cK c1 caddc co c2 cexp co
      cle wbr c1 c2 1re 2re 1lt2 ltleii cK cK c1 caddc co cmul co cK c1 caddc
      co cK c1 caddc co cmul co cK c2 cexp co cK caddc co cK c1 caddc co c2
      cexp co cle cK cr wcel cK c1 caddc co cr wcel cK c1 caddc co cr wcel cc0
      cK c1 caddc co cle wbr wa w3a cK cK c1 caddc co cle wbr cK cK c1 caddc co
      cmul co cK c1 caddc co cK c1 caddc co cmul co cle wbr cK cr wcel cK c1
      caddc co cr wcel cK c1 caddc co cr wcel cc0 cK c1 caddc co cle wbr wa cK
      faclbnd4lem1.2 nn0rei cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1 caddc
      co cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnrei cK c1 caddc co
      cr wcel cc0 cK c1 caddc co cle wbr cK c1 caddc co cK cn0 wcel c1 cn wcel
      cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnrei cK
      c1 caddc co cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnnn0i nn0ge0i pm3.2i 3pm3.2i
      cK cK c1 caddc co cK faclbnd4lem1.2 nn0rei cK c1 caddc co cK cn0 wcel c1
      cn wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an
      nnrei cK cK faclbnd4lem1.2 nn0rei ltp1i ltleii cK cK c1 caddc co cK c1
      caddc co lemul1a mp2an cK c2 cexp co cK caddc co cK cK cmul co cK c1 cmul
      co caddc co cK cK c1 caddc co cmul co cK c2 cexp co cK cK cmul co cK cK
      c1 cmul co caddc cK cK faclbnd4lem1.2 nn0cni sqvali cK c1 cmul co cK cK
      cK faclbnd4lem1.2 nn0cni mulid1i eqcomi opreq12i cK cK c1 cK
      faclbnd4lem1.2 nn0cni cK faclbnd4lem1.2 nn0cni ax1cn adddii eqtr4i cK c1
      caddc co cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1 caddc co cn wcel
      faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nncni sqvali 3brtr4i pm3.2i c2
      cK c2 cexp co cK caddc co cK c1 caddc co c2 cexp co expwordi mp2an
      eqbrtrri c2 cK c2 cexp co cexp co c2 cK cexp co cmul co c2 cK c1 caddc co
      c2 cexp co cexp co cM cM cK c1 caddc co caddc co cexp co cN cfa cfv cmul
      co lemul1a mp2an a1i letrd c2 cK c1 caddc co c2 cexp co cexp co cM cM cK
      c1 caddc co caddc co cexp co cN cfa cfv c2 cK c1 caddc co c2 cexp co cexp
      co c2 cr wcel cK c1 caddc co c2 cexp co cn0 wcel c2 cK c1 caddc co c2
      cexp co cexp co cr wcel 2re cK c1 caddc co cn0 wcel c2 cn0 wcel cK c1
      caddc co c2 cexp co cn0 wcel cK c1 caddc co cK cn0 wcel c1 cn wcel cK c1
      caddc co cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an nnnn0i 2nn0 cK
      c1 caddc co c2 nn0expcl mp2an c2 cK c1 caddc co c2 cexp co reexpcl mp2an
      recni cM cM cK c1 caddc co caddc co cexp co cM cn0 wcel cM cK c1 caddc co
      caddc co cn0 wcel cM cM cK c1 caddc co caddc co cexp co cn0 wcel
      faclbnd4lem1.3 cM cK c1 caddc co caddc co cM cn0 wcel cK c1 caddc co cn
      wcel cM cK c1 caddc co caddc co cn wcel faclbnd4lem1.3 cK cn0 wcel c1 cn
      wcel cK c1 caddc co cn wcel faclbnd4lem1.2 1nn cK c1 nn0nnaddcl mp2an cM
      cK c1 caddc co nn0nnaddcl mp2an nnnn0i cM cM cK c1 caddc co caddc co
      nn0expcl mp2an nn0cni cN cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN
      faclbnd4lem1.1 nnnn0i cN faccl ax-mp nncni mulassi syl6breqr jaoian mpan
      $.
      $( [27-Jan-2006] $) $( [20-Dec-2005] $)
  $}

  $( Lemma for ~ faclbnd4 .  Use the weak deduction theorem to convert
     the hypotheses of ~ faclbnd4lem1 to antecedents. $)
  faclbnd4lem2 $p |- ( ( M e. NN0 /\ K e. NN0 /\ N e. NN ) ->
           ( ( ( ( N - 1 ) ^ K ) x. ( M ^ ( N - 1 ) ) ) <_
       ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` ( N - 1 ) ) ) ->
                   ( ( N ^ ( K + 1 ) ) x. ( M ^ N ) ) <_ ( ( (
  2 ^ ( ( K + 1 ) ^ 2 ) ) x. ( M ^ ( M + ( K + 1 ) ) ) ) x. ( ! ` N ) ) ) ) $=
    cM cn0 wcel cK cn0 wcel cN cn wcel cN c1 cmin co cK cexp co cM cN c1 cmin
    co cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co cN c1 cmin co cfa cfv cmul co cle wbr cN cK c1 caddc co cexp co cM cN
    cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1 caddc co
    caddc co cexp co cmul co cN cfa cfv cmul co cle wbr wi cN c1 cmin co cK
    cexp co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cmul co c2 cK c2 cexp
    co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK caddc co cexp co
    cmul co cN c1 cmin co cfa cfv cmul co cle wbr cN cK c1 caddc co cexp co cM
    cn0 wcel cM c1 cif cN cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co
    cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK c1 caddc co caddc co cexp co
    cmul co cN cfa cfv cmul co cle wbr wi cM cK cN c1 c1 c1 cN c1 cmin co cK
    cn0 wcel cK c1 cif cexp co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cmul
    co c2 cK cn0 wcel cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0
    wcel cM c1 cif cK cn0 wcel cK c1 cif caddc co cexp co cmul co cN c1 cmin co
    cfa cfv cmul co cle wbr cN cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0
    wcel cM c1 cif cN cexp co cmul co c2 cK cn0 wcel cK c1 cif c1 caddc co c2
    cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK
    c1 cif c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co cle wbr wi
    cN cn wcel cN c1 cif c1 cmin co cK cn0 wcel cK c1 cif cexp co cM cn0 wcel
    cM c1 cif cN cn wcel cN c1 cif c1 cmin co cexp co cmul co c2 cK cn0 wcel cK
    c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK
    cn0 wcel cK c1 cif caddc co cexp co cmul co cN cn wcel cN c1 cif c1 cmin co
    cfa cfv cmul co cle wbr cN cn wcel cN c1 cif cK cn0 wcel cK c1 cif c1 caddc
    co cexp co cM cn0 wcel cM c1 cif cN cn wcel cN c1 cif cexp co cmul co c2 cK
    cn0 wcel cK c1 cif c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM
    cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc co caddc co cexp co cmul
    co cN cn wcel cN c1 cif cfa cfv cmul co cle wbr wi cM cM cn0 wcel cM c1 cif
    wceq cN c1 cmin co cK cexp co cM cN c1 cmin co cexp co cmul co c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cN c1 cmin co cfa cfv
    cmul co cle wbr cN c1 cmin co cK cexp co cM cn0 wcel cM c1 cif cN c1 cmin
    co cexp co cmul co c2 cK c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0
    wcel cM c1 cif cK caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co
    cle wbr cN cK c1 caddc co cexp co cM cN cexp co cmul co c2 cK c1 caddc co
    c2 cexp co cexp co cM cM cK c1 caddc co caddc co cexp co cmul co cN cfa cfv
    cmul co cle wbr cN cK c1 caddc co cexp co cM cn0 wcel cM c1 cif cN cexp co
    cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0
    wcel cM c1 cif cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co
    cle wbr cM cM cn0 wcel cM c1 cif wceq cN c1 cmin co cK cexp co cM cN c1
    cmin co cexp co cmul co cN c1 cmin co cK cexp co cM cn0 wcel cM c1 cif cN
    c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
    co cmul co cN c1 cmin co cfa cfv cmul co c2 cK c2 cexp co cexp co cM cn0
    wcel cM c1 cif cM cn0 wcel cM c1 cif cK caddc co cexp co cmul co cN c1 cmin
    co cfa cfv cmul co cle cM cM cn0 wcel cM c1 cif wceq cM cN c1 cmin co cexp
    co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cN c1 cmin co cK cexp co
    cmul cM cM cn0 wcel cM c1 cif cN c1 cmin co cexp opreq1 opreq2d cM cM cn0
    wcel cM c1 cif wceq c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co c2 cK c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK
    caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul cM cM cn0 wcel cM c1
    cif wceq cM cM cK caddc co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1
    cif cK caddc co cexp co c2 cK c2 cexp co cexp co cmul cM cM cn0 wcel cM c1
    cif wceq cM cM cn0 wcel cM c1 cif cM cK caddc co cM cn0 wcel cM c1 cif cK
    caddc co cexp cM cM cn0 wcel cM c1 cif wceq id cM cM cn0 wcel cM c1 cif cK
    caddc opreq1 opreq12d opreq2d opreq1d breq12d cM cM cn0 wcel cM c1 cif wceq
    cN cK c1 caddc co cexp co cM cN cexp co cmul co cN cK c1 caddc co cexp co
    cM cn0 wcel cM c1 cif cN cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp
    co cM cM cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co c2 cK
    c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif
    cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co cle cM cM cn0
    wcel cM c1 cif wceq cM cN cexp co cM cn0 wcel cM c1 cif cN cexp co cN cK c1
    caddc co cexp co cmul cM cM cn0 wcel cM c1 cif cN cexp opreq1 opreq2d cM cM
    cn0 wcel cM c1 cif wceq c2 cK c1 caddc co c2 cexp co cexp co cM cM cK c1
    caddc co caddc co cexp co cmul co c2 cK c1 caddc co c2 cexp co cexp co cM
    cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK c1 caddc co caddc co cexp co
    cmul co cN cfa cfv cmul cM cM cn0 wcel cM c1 cif wceq cM cM cK c1 caddc co
    caddc co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK c1 caddc co
    caddc co cexp co c2 cK c1 caddc co c2 cexp co cexp co cmul cM cM cn0 wcel
    cM c1 cif wceq cM cM cn0 wcel cM c1 cif cM cK c1 caddc co caddc co cM cn0
    wcel cM c1 cif cK c1 caddc co caddc co cexp cM cM cn0 wcel cM c1 cif wceq
    id cM cM cn0 wcel cM c1 cif cK c1 caddc co caddc opreq1 opreq12d opreq2d
    opreq1d breq12d imbi12d cK cK cn0 wcel cK c1 cif wceq cN c1 cmin co cK cexp
    co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cmul co c2 cK c2 cexp co
    cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK caddc co cexp co
    cmul co cN c1 cmin co cfa cfv cmul co cle wbr cN c1 cmin co cK cn0 wcel cK
    c1 cif cexp co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cmul co c2 cK
    cn0 wcel cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM
    c1 cif cK cn0 wcel cK c1 cif caddc co cexp co cmul co cN c1 cmin co cfa cfv
    cmul co cle wbr cN cK c1 caddc co cexp co cM cn0 wcel cM c1 cif cN cexp co
    cmul co c2 cK c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0
    wcel cM c1 cif cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co
    cle wbr cN cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0 wcel cM c1 cif
    cN cexp co cmul co c2 cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co cexp co
    cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc
    co caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cK cK cn0 wcel cK c1
    cif wceq cN c1 cmin co cK cexp co cM cn0 wcel cM c1 cif cN c1 cmin co cexp
    co cmul co cN c1 cmin co cK cn0 wcel cK c1 cif cexp co cM cn0 wcel cM c1
    cif cN c1 cmin co cexp co cmul co c2 cK c2 cexp co cexp co cM cn0 wcel cM
    c1 cif cM cn0 wcel cM c1 cif cK caddc co cexp co cmul co cN c1 cmin co cfa
    cfv cmul co c2 cK cn0 wcel cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1
    cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif caddc co cexp co cmul co cN
    c1 cmin co cfa cfv cmul co cle cK cK cn0 wcel cK c1 cif wceq cN c1 cmin co
    cK cexp co cN c1 cmin co cK cn0 wcel cK c1 cif cexp co cM cn0 wcel cM c1
    cif cN c1 cmin co cexp co cmul cK cK cn0 wcel cK c1 cif cN c1 cmin co cexp
    opreq2 opreq1d cK cK cn0 wcel cK c1 cif wceq c2 cK c2 cexp co cexp co cM
    cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK caddc co cexp co cmul co c2 cK
    cn0 wcel cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM
    c1 cif cK cn0 wcel cK c1 cif caddc co cexp co cmul co cN c1 cmin co cfa cfv
    cmul cK cK cn0 wcel cK c1 cif wceq c2 cK c2 cexp co cexp co c2 cK cn0 wcel
    cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK
    caddc co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK
    c1 cif caddc co cexp co cmul cK cK cn0 wcel cK c1 cif wceq cK c2 cexp co cK
    cn0 wcel cK c1 cif c2 cexp co c2 cexp cK cK cn0 wcel cK c1 cif c2 cexp
    opreq1 opreq2d cK cK cn0 wcel cK c1 cif wceq cM cn0 wcel cM c1 cif cK caddc
    co cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif caddc co cM cn0 wcel cM c1
    cif cexp cK cK cn0 wcel cK c1 cif cM cn0 wcel cM c1 cif caddc opreq2
    opreq2d opreq12d opreq1d breq12d cK cK cn0 wcel cK c1 cif wceq cN cK c1
    caddc co cexp co cM cn0 wcel cM c1 cif cN cexp co cmul co cN cK cn0 wcel cK
    c1 cif c1 caddc co cexp co cM cn0 wcel cM c1 cif cN cexp co cmul co c2 cK
    c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif
    cK c1 caddc co caddc co cexp co cmul co cN cfa cfv cmul co c2 cK cn0 wcel
    cK c1 cif c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel
    cM c1 cif cK cn0 wcel cK c1 cif c1 caddc co caddc co cexp co cmul co cN cfa
    cfv cmul co cle cK cK cn0 wcel cK c1 cif wceq cN cK c1 caddc co cexp co cN
    cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0 wcel cM c1 cif cN cexp co
    cmul cK cK cn0 wcel cK c1 cif wceq cK c1 caddc co cK cn0 wcel cK c1 cif c1
    caddc co cN cexp cK cK cn0 wcel cK c1 cif c1 caddc opreq1 opreq2d opreq1d
    cK cK cn0 wcel cK c1 cif wceq c2 cK c1 caddc co c2 cexp co cexp co cM cn0
    wcel cM c1 cif cM cn0 wcel cM c1 cif cK c1 caddc co caddc co cexp co cmul
    co c2 cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co cexp co cM cn0 wcel cM
    c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc co caddc co
    cexp co cmul co cN cfa cfv cmul cK cK cn0 wcel cK c1 cif wceq c2 cK c1
    caddc co c2 cexp co cexp co c2 cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co
    cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK c1 caddc co caddc co
    cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif
    c1 caddc co caddc co cexp co cmul cK cK cn0 wcel cK c1 cif wceq cK c1 caddc
    co c2 cexp co cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co c2 cexp cK cK
    cn0 wcel cK c1 cif wceq cK c1 caddc co cK cn0 wcel cK c1 cif c1 caddc co c2
    cexp cK cK cn0 wcel cK c1 cif c1 caddc opreq1 opreq1d opreq2d cK cK cn0
    wcel cK c1 cif wceq cM cn0 wcel cM c1 cif cK c1 caddc co caddc co cM cn0
    wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc co caddc co cM cn0 wcel cM c1
    cif cexp cK cK cn0 wcel cK c1 cif wceq cK c1 caddc co cK cn0 wcel cK c1 cif
    c1 caddc co cM cn0 wcel cM c1 cif caddc cK cK cn0 wcel cK c1 cif c1 caddc
    opreq1 opreq2d opreq2d opreq12d opreq1d breq12d imbi12d cN cN cn wcel cN c1
    cif wceq cN c1 cmin co cK cn0 wcel cK c1 cif cexp co cM cn0 wcel cM c1 cif
    cN c1 cmin co cexp co cmul co c2 cK cn0 wcel cK c1 cif c2 cexp co cexp co
    cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif caddc co
    cexp co cmul co cN c1 cmin co cfa cfv cmul co cle wbr cN cn wcel cN c1 cif
    c1 cmin co cK cn0 wcel cK c1 cif cexp co cM cn0 wcel cM c1 cif cN cn wcel
    cN c1 cif c1 cmin co cexp co cmul co c2 cK cn0 wcel cK c1 cif c2 cexp co
    cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif
    caddc co cexp co cmul co cN cn wcel cN c1 cif c1 cmin co cfa cfv cmul co
    cle wbr cN cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0 wcel cM c1 cif
    cN cexp co cmul co c2 cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co cexp co
    cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc
    co caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cN cn wcel cN c1 cif
    cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0 wcel cM c1 cif cN cn wcel
    cN c1 cif cexp co cmul co c2 cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co
    cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif
    c1 caddc co caddc co cexp co cmul co cN cn wcel cN c1 cif cfa cfv cmul co
    cle wbr cN cN cn wcel cN c1 cif wceq cN c1 cmin co cK cn0 wcel cK c1 cif
    cexp co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cmul co cN cn wcel cN
    c1 cif c1 cmin co cK cn0 wcel cK c1 cif cexp co cM cn0 wcel cM c1 cif cN cn
    wcel cN c1 cif c1 cmin co cexp co cmul co c2 cK cn0 wcel cK c1 cif c2 cexp
    co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1
    cif caddc co cexp co cmul co cN c1 cmin co cfa cfv cmul co c2 cK cn0 wcel
    cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK
    cn0 wcel cK c1 cif caddc co cexp co cmul co cN cn wcel cN c1 cif c1 cmin co
    cfa cfv cmul co cle cN cN cn wcel cN c1 cif wceq cN c1 cmin co cK cn0 wcel
    cK c1 cif cexp co cN cn wcel cN c1 cif c1 cmin co cK cn0 wcel cK c1 cif
    cexp co cM cn0 wcel cM c1 cif cN c1 cmin co cexp co cM cn0 wcel cM c1 cif
    cN cn wcel cN c1 cif c1 cmin co cexp co cmul cN cN cn wcel cN c1 cif wceq
    cN c1 cmin co cN cn wcel cN c1 cif c1 cmin co cK cn0 wcel cK c1 cif cexp cN
    cN cn wcel cN c1 cif c1 cmin opreq1 opreq1d cN cN cn wcel cN c1 cif wceq cN
    c1 cmin co cN cn wcel cN c1 cif c1 cmin co cM cn0 wcel cM c1 cif cexp cN cN
    cn wcel cN c1 cif c1 cmin opreq1 opreq2d opreq12d cN cN cn wcel cN c1 cif
    wceq cN c1 cmin co cfa cfv cN cn wcel cN c1 cif c1 cmin co cfa cfv c2 cK
    cn0 wcel cK c1 cif c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM
    c1 cif cK cn0 wcel cK c1 cif caddc co cexp co cmul co cmul cN cN cn wcel cN
    c1 cif wceq cN c1 cmin co cN cn wcel cN c1 cif c1 cmin co cfa cN cN cn wcel
    cN c1 cif c1 cmin opreq1 fveq2d opreq2d breq12d cN cN cn wcel cN c1 cif
    wceq cN cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0 wcel cM c1 cif cN
    cexp co cmul co cN cn wcel cN c1 cif cK cn0 wcel cK c1 cif c1 caddc co cexp
    co cM cn0 wcel cM c1 cif cN cn wcel cN c1 cif cexp co cmul co c2 cK cn0
    wcel cK c1 cif c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0
    wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc co caddc co cexp co cmul co
    cN cfa cfv cmul co c2 cK cn0 wcel cK c1 cif c1 caddc co c2 cexp co cexp co
    cM cn0 wcel cM c1 cif cM cn0 wcel cM c1 cif cK cn0 wcel cK c1 cif c1 caddc
    co caddc co cexp co cmul co cN cn wcel cN c1 cif cfa cfv cmul co cle cN cN
    cn wcel cN c1 cif wceq cN cK cn0 wcel cK c1 cif c1 caddc co cexp co cN cn
    wcel cN c1 cif cK cn0 wcel cK c1 cif c1 caddc co cexp co cM cn0 wcel cM c1
    cif cN cexp co cM cn0 wcel cM c1 cif cN cn wcel cN c1 cif cexp co cmul cN
    cN cn wcel cN c1 cif cK cn0 wcel cK c1 cif c1 caddc co cexp opreq1 cN cN cn
    wcel cN c1 cif cM cn0 wcel cM c1 cif cexp opreq2 opreq12d cN cN cn wcel cN
    c1 cif wceq cN cfa cfv cN cn wcel cN c1 cif cfa cfv c2 cK cn0 wcel cK c1
    cif c1 caddc co c2 cexp co cexp co cM cn0 wcel cM c1 cif cM cn0 wcel cM c1
    cif cK cn0 wcel cK c1 cif c1 caddc co caddc co cexp co cmul co cmul cN cN
    cn wcel cN c1 cif cfa fveq2 opreq2d breq12d imbi12d cK cn0 wcel cK c1 cif
    cM cn0 wcel cM c1 cif cN cn wcel cN c1 cif cN c1 cn 1nn elimel cK c1 cn0
    1nn0 elimel cM c1 cn0 1nn0 elimel faclbnd4lem1 dedth3h $.
    $( [27-Jan-2006] $) $( [23-Dec-2005] $)


  $( Lemma for ~ faclbnd4 .  The ` N = 0 ` case. $)
  faclbnd4lem3 $p |- ( ( ( M e. NN0
            /\ K e. NN0 ) /\ N = 0 ) -> ( ( N ^ K ) x. ( M ^ N ) )
       <_ ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` N ) ) ) $=
    cM cn0 wcel cK cn0 wcel wa cN cc0 wceq wa cN cK cexp co cM cN cexp co cmul
    co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv
    cmul co cle wbr cc0 cK cexp co cM cc0 cexp co cmul co c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co cmul co c1 cmul co cle wbr cM cn0 wcel cK cn0
    wcel wa cc0 cK cexp co cM cc0 cexp co cmul co c2 cK c2 cexp co cexp co cM
    cM cK caddc co cexp co cmul co c1 cmul co cle wbr cN cc0 wceq cM cn0 wcel
    cK cn0 wcel wa cc0 cK cexp co c2 cK c2 cexp co cexp co cM cM cK caddc co
    cexp co cmul co cc0 cK cexp co cM cc0 cexp co cmul co c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co cmul co c1 cmul co cle cM cn0 wcel cK cn wcel
    cK cc0 wceq wo cc0 cK cexp co c2 cK c2 cexp co cexp co cM cM cK caddc co
    cexp co cmul co cle wbr cK cn0 wcel cM cn0 wcel cK cn wcel cc0 cK cexp co
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cle wbr cK cc0
    wceq cM cn0 wcel cK cn wcel wa cc0 cK cexp co cc0 c2 cK c2 cexp co cexp co
    cM cM cK caddc co cexp co cmul co cle cK cn wcel cc0 cK cexp co cc0 wceq cM
    cn0 wcel cK 0exp adantl cM cn0 wcel cK cn wcel wa c2 cK c2 cexp co cexp co
    cM cM cK caddc co cexp co cmul co cn0 wcel cc0 c2 cK c2 cexp co cexp co cM
    cM cK caddc co cexp co cmul co cle wbr cM cn0 wcel cK cn0 wcel c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cn0 wcel cK cn wcel c2 cK
    c2 cexp co cexp co cn0 wcel cM cM cK caddc co cexp co cn0 wcel c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cn0 wcel cM cn0 wcel cK
    cn0 wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co nn0mulcl cK
    cn0 wcel c2 cK c2 cexp co cexp co cn0 wcel cM cn0 wcel c2 cn0 wcel cK c2
    cexp co cn0 wcel c2 cK c2 cexp co cexp co cn0 wcel cK cn0 wcel c2 cK c2
    cexp co nn0expcl 2nn0 cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel 2nn0
    cK c2 nn0expcl mpan2 sylancr adantl cM cn0 wcel cK cn0 wcel cM cK caddc co
    cn0 wcel cM cM cK caddc co cexp co cn0 wcel cM cK nn0addcl cM cM cK caddc
    co nn0expcl syldan sylanc cK nnnn0 sylan2 c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co nn0ge0 syl eqbrtrd cM cn0 wcel cK cc0 wceq wa cc0
    cK cexp co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cle
    wbr c1 c1 cM cM cc0 caddc co cexp co cmul co cle wbr cM cn0 wcel c1 c1 cM
    cM cc0 caddc co cexp co cmul co cle wbr cK cc0 wceq cM cn0 wcel cM cM cc0
    caddc co cexp co cn wcel c1 cM cM cc0 caddc co cexp co cmul co cn wcel c1
    c1 cM cM cc0 caddc co cexp co cmul co cle wbr cM cn0 wcel cM cn wcel cM cc0
    wceq wo cM cM cc0 caddc co cexp co cn wcel cM elnn0 cM cn wcel cM cM cc0
    caddc co cexp co cn wcel cM cc0 wceq cM cn wcel cM cc0 caddc co cn0 wcel cM
    cM cc0 caddc co cexp co cn wcel cM cn0 wcel cc0 cn0 wcel cM cc0 caddc co
    cn0 wcel cM cn wcel cM cc0 nn0addcl cM nnnn0 0nn0 sylancl cM cM cc0 caddc
    co nnexpcl mpdan cM cc0 wceq cM cM cc0 caddc co cexp co c1 cn cM cc0 wceq
    cM cM cc0 caddc co cexp co cc0 cc0 cexp co c1 cM cc0 wceq cM cc0 cM cc0
    caddc co cc0 cexp cM cc0 wceq id cM cc0 wceq cM cc0 caddc co cc0 cc0 caddc
    co cc0 cM cc0 cc0 caddc opreq1 cc0 0cn addid1i syl6eq opreq12d cc0 cc wcel
    cc0 cc0 cexp co c1 wceq 0cn cc0 exp0 ax-mp syl6eq 1nn syl6eqel jaoi sylbi
    c1 cn wcel cM cM cc0 caddc co cexp co cn wcel c1 cM cM cc0 caddc co cexp co
    cmul co cn wcel 1nn c1 cM cM cc0 caddc co cexp co nnmulcl mpan c1 cM cM cc0
    caddc co cexp co cmul co nnge1 3syl adantr cK cc0 wceq cc0 cK cexp co c2 cK
    c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cle wbr c1 c1 cM cM
    cc0 caddc co cexp co cmul co cle wbr wb cM cn0 wcel cK cc0 wceq cc0 cK cexp
    co c1 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co c1 cM cM
    cc0 caddc co cexp co cmul co cle cK cc0 wceq cc0 cK cexp co cc0 cc0 cexp co
    c1 cK cc0 cc0 cexp opreq2 cc0 cc wcel cc0 cc0 cexp co c1 wceq 0cn cc0 exp0
    ax-mp syl6eq cK cc0 wceq c2 cK c2 cexp co cexp co c1 cM cM cK caddc co cexp
    co cM cM cc0 caddc co cexp co cmul cK cc0 wceq c2 cK c2 cexp co cexp co c2
    cc0 cexp co c1 cK cc0 wceq cK c2 cexp co cc0 c2 cexp cK sq0i opreq2d c2 cc
    wcel c2 cc0 cexp co c1 wceq 2cn c2 exp0 ax-mp syl6eq cK cc0 wceq cM cK
    caddc co cM cc0 caddc co cM cexp cK cc0 cM caddc opreq2 opreq2d opreq12d
    breq12d adantl mpbird jaodan cK elnn0 sylan2b cM cn0 wcel cK cn0 wcel cc0
    cK cexp co cM cc0 cexp co cmul co cc0 cK cexp co c1 cmul co cc0 cK cexp co
    cM cn0 wcel cM cc0 cexp co c1 cc0 cK cexp co cmul cM cn0 wcel cM cc wcel cM
    cc0 cexp co c1 wceq cM nn0cn cM exp0 syl opreq2d cK cn0 wcel cc0 cK cexp co
    cn0 wcel cc0 cK cexp co cc wcel cc0 cK cexp co c1 cmul co cc0 cK cexp co
    wceq cc0 cn0 wcel cK cn0 wcel cc0 cK cexp co cn0 wcel 0nn0 cc0 cK nn0expcl
    mpan cc0 cK cexp co nn0cn cc0 cK cexp co ax1id 3syl sylan9eq cM cn0 wcel cK
    cn0 wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn0
    wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cc wcel c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co c1 cmul co c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co wceq c2 cK c2 cexp co
    cexp co cn0 wcel cM cM cK caddc co cexp co cn0 wcel c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co cmul co cn0 wcel cM cn0 wcel cK cn0 wcel wa c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co nn0mulcl cK cn0 wcel c2 cK
    c2 cexp co cexp co cn0 wcel cM cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel
    c2 cK c2 cexp co cexp co cn0 wcel cK cn0 wcel c2 cK c2 cexp co nn0expcl
    2nn0 cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel 2nn0 cK c2 nn0expcl
    mpan2 sylancr adantl cM cn0 wcel cK cn0 wcel cM cK caddc co cn0 wcel cM cM
    cK caddc co cexp co cn0 wcel cM cK nn0addcl cM cM cK caddc co nn0expcl
    syldan sylanc c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co
    nn0cn c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co ax1id 3syl
    3brtr4d adantr cN cc0 wceq cN cK cexp co cM cN cexp co cmul co c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle
    wbr cc0 cK cexp co cM cc0 cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co c1 cmul co cle wbr wb cM cn0 wcel cK cn0 wcel wa
    cN cc0 wceq cN cK cexp co cM cN cexp co cmul co cc0 cK cexp co cM cc0 cexp
    co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
    cfa cfv cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co
    c1 cmul co cle cN cc0 wceq cN cK cexp co cc0 cK cexp co cM cN cexp co cM
    cc0 cexp co cmul cN cc0 cK cexp opreq1 cN cc0 cM cexp opreq2 opreq12d cN
    cc0 wceq cN cfa cfv c1 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
    cmul co cmul cN cc0 wceq cN cfa cfv cc0 cfa cfv c1 cN cc0 cfa fveq2 fac0
    syl6eq opreq2d breq12d adantl mpbird $.
    $( [28-Jan-2006] $) $( [23-Dec-2005] $)

  ${
    $d j m n M $.  $d j m n K $.  $d j n N $.
    $( Lemma for ~ faclbnd4 .  Prove the ` 0 < N ` case by induction on
       ` K ` . $)
    faclbnd4lem4 $p |- ( ( N e. NN /\ K e. NN0 /\ M e. NN0 ) ->
                   ( ( N ^ K ) x. ( M ^ N ) ) <_
              ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` N ) ) ) $=
      cN cn wcel cK cn0 wcel cM cn0 wcel cN cK cexp co cM cN cexp co cmul co c2
      cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul
      co cle wbr cN cn wcel vn cv cK cexp co cM vn cv cexp co cmul co c2 cK c2
      cexp co cexp co cM cM cK caddc co cexp co cmul co vn cv cfa cfv cmul co
      cle wbr vn cn wral cN cK cexp co cM cN cexp co cmul co c2 cK c2 cexp co
      cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cK
      cn0 wcel cM cn0 wcel wa vn cv cK cexp co cM vn cv cexp co cmul co c2 cK
      c2 cexp co cexp co cM cM cK caddc co cexp co cmul co vn cv cfa cfv cmul
      co cle wbr cN cK cexp co cM cN cexp co cmul co c2 cK c2 cexp co cexp co
      cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle wbr vn cN cn vn
      cv cN wceq vn cv cK cexp co cM vn cv cexp co cmul co cN cK cexp co cM cN
      cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
      co vn cv cfa cfv cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
      co cmul co cN cfa cfv cmul co cle vn cv cN wceq vn cv cK cexp co cN cK
      cexp co cM vn cv cexp co cM cN cexp co cmul vn cv cN cK cexp opreq1 vn cv
      cN cM cexp opreq2 opreq12d vn cv cN wceq vn cv cfa cfv cN cfa cfv c2 cK
      c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cmul vn cv cN cfa
      fveq2 opreq2d breq12d rcla4va cK cn0 wcel cM cn0 wcel vn cv cK cexp co cM
      vn cv cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
      cmul co vn cv cfa cfv cmul co cle wbr vn cn wral cM cn0 wcel vn cv vm cv
      cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co cexp co cM cM vm cv
      caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn wral wi cM
      cn0 wcel vn cv cc0 cexp co cM vn cv cexp co cmul co c2 cc0 c2 cexp co
      cexp co cM cM cc0 caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr
      vn cn wral wi cM cn0 wcel vn cv vj cv cexp co cM vn cv cexp co cmul co c2
      vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co vn cv cfa
      cfv cmul co cle wbr vn cn wral wi cM cn0 wcel vn cv vj cv c1 caddc co
      cexp co cM vn cv cexp co cmul co c2 vj cv c1 caddc co c2 cexp co cexp co
      cM cM vj cv c1 caddc co caddc co cexp co cmul co vn cv cfa cfv cmul co
      cle wbr vn cn wral wi cM cn0 wcel vn cv cK cexp co cM vn cv cexp co cmul
      co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co vn cv cfa
      cfv cmul co cle wbr vn cn wral wi vm vj cK vj cv cn0 wcel cM cn0 wcel vn
      cv vj cv cexp co cM vn cv cexp co cmul co c2 vj cv c2 cexp co cexp co cM
      cM vj cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn
      wral vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul co c2 vj cv c1
      caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co cmul
      co vn cv cfa cfv cmul co cle wbr vn cn wral cM cn0 wcel vj cv cn0 wcel vn
      cv vj cv cexp co cM vn cv cexp co cmul co c2 vj cv c2 cexp co cexp co cM
      cM vj cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn
      wral vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul co c2 vj cv c1
      caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co cmul
      co vn cv cfa cfv cmul co cle wbr vn cn wral wi cM cn0 wcel vj cv cn0 wcel
      wa vm cv vj cv cexp co cM vm cv cexp co cmul co c2 vj cv c2 cexp co cexp
      co cM cM vj cv caddc co cexp co cmul co vm cv cfa cfv cmul co cle wbr vm
      cn wral vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul co c2 vj cv
      c1 caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co
      cmul co vn cv cfa cfv cmul co cle wbr vn cn wral vn cv vj cv cexp co cM
      vn cv cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co
      cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn wral cM cn0 wcel vj
      cv cn0 wcel wa vm cv vj cv cexp co cM vm cv cexp co cmul co c2 vj cv c2
      cexp co cexp co cM cM vj cv caddc co cexp co cmul co vm cv cfa cfv cmul
      co cle wbr vm cn wral vn cv vj cv c1 caddc co cexp co cM vn cv cexp co
      cmul co c2 vj cv c1 caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co
      caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn cM cn0 wcel
      vj cv cn0 wcel wa vn cv cn wcel wa vm cv vj cv cexp co cM vm cv cexp co
      cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co
      vm cv cfa cfv cmul co cle wbr vm cn wral vn cv c1 cmin co vj cv cexp co
      cM vn cv c1 cmin co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj
      cv caddc co cexp co cmul co vn cv c1 cmin co cfa cfv cmul co cle wbr vn
      cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul co c2 vj cv c1 caddc
      co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co cmul co vn
      cv cfa cfv cmul co cle wbr cM cn0 wcel vj cv cn0 wcel wa vn cv cn wcel vn
      cv c1 cle wbr wa vn cv cn wcel c1 vn cv clt wbr wa wo vm cv vj cv cexp co
      cM vm cv cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co
      cexp co cmul co vm cv cfa cfv cmul co cle wbr vm cn wral vn cv c1 cmin co
      vj cv cexp co cM vn cv c1 cmin co cexp co cmul co c2 vj cv c2 cexp co
      cexp co cM cM vj cv caddc co cexp co cmul co vn cv c1 cmin co cfa cfv
      cmul co cle wbr wi vn cv cn wcel cM cn0 wcel vj cv cn0 wcel wa vn cv cn
      wcel vn cv c1 cle wbr wa vm cv vj cv cexp co cM vm cv cexp co cmul co c2
      vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co vm cv cfa
      cfv cmul co cle wbr vm cn wral vn cv c1 cmin co vj cv cexp co cM vn cv c1
      cmin co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co
      cexp co cmul co vn cv c1 cmin co cfa cfv cmul co cle wbr wi vn cv cn wcel
      c1 vn cv clt wbr wa cM cn0 wcel vj cv cn0 wcel wa vn cv cn wcel vn cv c1
      cle wbr wa wa vn cv c1 cmin co vj cv cexp co cM vn cv c1 cmin co cexp co
      cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co
      vn cv c1 cmin co cfa cfv cmul co cle wbr vm cv vj cv cexp co cM vm cv
      cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co
      cmul co vm cv cfa cfv cmul co cle wbr vm cn wral cM cn0 wcel vj cv cn0
      wcel wa vn cv c1 cmin co cc0 wceq vn cv c1 cmin co vj cv cexp co cM vn cv
      c1 cmin co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc
      co cexp co cmul co vn cv c1 cmin co cfa cfv cmul co cle wbr vn cv cn wcel
      vn cv c1 cle wbr wa vj cv cM vn cv c1 cmin co faclbnd4lem3 vn cv cn wcel
      vn cv c1 cle wbr wa vn cv c1 wceq vn cv c1 cmin co cc0 wceq vn cv cn wcel
      vn cv c1 cle wbr wa c1 vn cv cle wbr vn cv c1 wceq vn cv cn wcel c1 vn cv
      cle wbr vn cv c1 cle wbr vn cv nnge1 adantr vn cv cn wcel vn cv c1 cle
      wbr c1 vn cv cle wbr vn cv c1 wceq vn cv cn wcel vn cv c1 wceq vn cv c1
      cle wbr c1 vn cv cle wbr wa vn cv cr wcel c1 cr wcel vn cv c1 wceq vn cv
      c1 cle wbr c1 vn cv cle wbr wa wb vn cv cn wcel vn cv c1 letri3 vn cv
      nnre 1re sylancl biimpar anassrs mpdan vn cv c1 wceq vn cv c1 cmin co c1
      c1 cmin co cc0 vn cv c1 c1 cmin opreq1 c1 ax1cn subidi syl6eq syl sylan2
      a1d vn cv cn wcel c1 vn cv clt wbr wa vm cv vj cv cexp co cM vm cv cexp
      co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul
      co vm cv cfa cfv cmul co cle wbr vm cn wral vn cv c1 cmin co vj cv cexp
      co cM vn cv c1 cmin co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM
      vj cv caddc co cexp co cmul co vn cv c1 cmin co cfa cfv cmul co cle wbr
      wi cM cn0 wcel vj cv cn0 wcel wa vn cv cn wcel c1 vn cv clt wbr wa vn cv
      c1 cmin co cn wcel vm cv vj cv cexp co cM vm cv cexp co cmul co c2 vj cv
      c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co vm cv cfa cfv
      cmul co cle wbr vm cn wral vn cv c1 cmin co vj cv cexp co cM vn cv c1
      cmin co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co
      cexp co cmul co vn cv c1 cmin co cfa cfv cmul co cle wbr wi vn cv cn wcel
      c1 vn cv clt wbr vn cv c1 cmin co cn wcel c1 cn wcel vn cv cn wcel c1 vn
      cv clt wbr vn cv c1 cmin co cn wcel wb 1nn c1 vn cv nnsub mpan biimpa vm
      cv vj cv cexp co cM vm cv cexp co cmul co c2 vj cv c2 cexp co cexp co cM
      cM vj cv caddc co cexp co cmul co vm cv cfa cfv cmul co cle wbr vn cv c1
      cmin co vj cv cexp co cM vn cv c1 cmin co cexp co cmul co c2 vj cv c2
      cexp co cexp co cM cM vj cv caddc co cexp co cmul co vn cv c1 cmin co cfa
      cfv cmul co cle wbr vm vn cv c1 cmin co cn vm cv vn cv c1 cmin co wceq vm
      cv vj cv cexp co cM vm cv cexp co cmul co vn cv c1 cmin co vj cv cexp co
      cM vn cv c1 cmin co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj
      cv caddc co cexp co cmul co vm cv cfa cfv cmul co c2 vj cv c2 cexp co
      cexp co cM cM vj cv caddc co cexp co cmul co vn cv c1 cmin co cfa cfv
      cmul co cle vm cv vn cv c1 cmin co wceq vm cv vj cv cexp co vn cv c1 cmin
      co vj cv cexp co cM vm cv cexp co cM vn cv c1 cmin co cexp co cmul vm cv
      vn cv c1 cmin co vj cv cexp opreq1 vm cv vn cv c1 cmin co cM cexp opreq2
      opreq12d vm cv vn cv c1 cmin co wceq vm cv cfa cfv vn cv c1 cmin co cfa
      cfv c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co cmul
      vm cv vn cv c1 cmin co cfa fveq2 opreq2d breq12d rcla4v syl adantl jaodan
      vn cv cn wcel vn cv cn wcel vn cv c1 cle wbr c1 vn cv clt wbr wo wa vn cv
      cn wcel vn cv c1 cle wbr wa vn cv cn wcel c1 vn cv clt wbr wa wo vn cv cn
      wcel vn cv c1 cle wbr c1 vn cv clt wbr wo vn cv cr wcel c1 cr wcel vn cv
      c1 cle wbr c1 vn cv clt wbr wo vn cv cn wcel vn cv c1 lelttric vn cv nnre
      1re sylancl ancli vn cv cn wcel vn cv c1 cle wbr c1 vn cv clt wbr andi
      sylib sylan2 cM cn0 wcel vj cv cn0 wcel vn cv cn wcel vn cv c1 cmin co vj
      cv cexp co cM vn cv c1 cmin co cexp co cmul co c2 vj cv c2 cexp co cexp
      co cM cM vj cv caddc co cexp co cmul co vn cv c1 cmin co cfa cfv cmul co
      cle wbr vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul co c2 vj cv
      c1 caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co
      cmul co vn cv cfa cfv cmul co cle wbr wi vj cv cM vn cv faclbnd4lem2
      3expa syld r19.21adva vn cv vj cv cexp co cM vn cv cexp co cmul co c2 vj
      cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co vn cv cfa cfv
      cmul co cle wbr vm cv vj cv cexp co cM vm cv cexp co cmul co c2 vj cv c2
      cexp co cexp co cM cM vj cv caddc co cexp co cmul co vm cv cfa cfv cmul
      co cle wbr vn vm cn vn cv vm cv wceq vn cv vj cv cexp co cM vn cv cexp co
      cmul co vm cv vj cv cexp co cM vm cv cexp co cmul co c2 vj cv c2 cexp co
      cexp co cM cM vj cv caddc co cexp co cmul co vn cv cfa cfv cmul co c2 vj
      cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co vm cv cfa cfv
      cmul co cle vn cv vm cv wceq vn cv vj cv cexp co vm cv vj cv cexp co cM
      vn cv cexp co cM vm cv cexp co cmul vn cv vm cv vj cv cexp opreq1 vn cv
      vm cv cM cexp opreq2 opreq12d vn cv vm cv wceq vn cv cfa cfv vm cv cfa
      cfv c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co cmul
      vn cv vm cv cfa fveq2 opreq2d breq12d cbvralv syl5ib expcom a2d cM cn0
      wcel vn cv cc0 cexp co cM vn cv cexp co cmul co c2 cc0 c2 cexp co cexp co
      cM cM cc0 caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn cM
      cn0 wcel vn cv cn wcel wa cM vn cv cexp co cM cM cexp co vn cv cfa cfv
      cmul co vn cv cc0 cexp co cM vn cv cexp co cmul co c2 cc0 c2 cexp co cexp
      co cM cM cc0 caddc co cexp co cmul co vn cv cfa cfv cmul co cle cM cn0
      wcel vn cv cn0 wcel cM vn cv cexp co cM cM cexp co vn cv cfa cfv cmul co
      cle wbr vn cv cn wcel cM vn cv faclbnd3 vn cv nnnn0 sylan2 cM cn0 wcel vn
      cv cn wcel wa vn cv cc0 cexp co cM vn cv cexp co cmul co c1 cM vn cv cexp
      co cmul co cM vn cv cexp co vn cv cn wcel vn cv cc0 cexp co cM vn cv cexp
      co cmul co c1 cM vn cv cexp co cmul co wceq cM cn0 wcel vn cv cn wcel vn
      cv cc0 cexp co c1 cM vn cv cexp co cmul vn cv cn wcel vn cv cc wcel vn cv
      cc0 cexp co c1 wceq vn cv nncn vn cv exp0 syl opreq1d adantl cM cn0 wcel
      vn cv cn wcel wa cM vn cv cexp co cc wcel c1 cM vn cv cexp co cmul co cM
      vn cv cexp co wceq cM cc wcel vn cv cn0 wcel cM vn cv cexp co cc wcel cM
      cn0 wcel vn cv cn wcel cM vn cv expcl cM nn0cn vn cv nnnn0 syl2an cM vn
      cv cexp co mulid2 syl eqtrd cM cn0 wcel c2 cc0 c2 cexp co cexp co cM cM
      cc0 caddc co cexp co cmul co vn cv cfa cfv cmul co cM cM cexp co vn cv
      cfa cfv cmul co wceq vn cv cn wcel cM cn0 wcel c2 cc0 c2 cexp co cexp co
      cM cM cc0 caddc co cexp co cmul co cM cM cexp co vn cv cfa cfv cmul cM
      cn0 wcel c2 cc0 c2 cexp co cexp co cM cM cc0 caddc co cexp co cmul co c1
      cM cM cexp co cmul co cM cM cexp co cM cn0 wcel c2 cc0 c2 cexp co cexp co
      c1 cM cM cc0 caddc co cexp co cM cM cexp co cmul c2 cc0 c2 cexp co cexp
      co c1 wceq cM cn0 wcel c2 cc0 c2 cexp co cexp co c2 cc0 cexp co c1 cc0 c2
      cexp co cc0 c2 cexp sq0 opreq2i c2 cc wcel c2 cc0 cexp co c1 wceq 2cn c2
      exp0 ax-mp eqtri a1i cM cn0 wcel cM cc0 caddc co cM cM cexp cM cn0 wcel
      cM cc wcel cM cc0 caddc co cM wceq cM nn0cn cM addid1 syl opreq2d
      opreq12d cM cn0 wcel cM cM cexp co cc wcel c1 cM cM cexp co cmul co cM cM
      cexp co wceq cM cc wcel cM cn0 wcel cM cM cexp co cc wcel cM nn0cn cM cM
      expcl mpancom cM cM cexp co mulid2 syl eqtrd opreq1d adantr 3brtr4d
      r19.21aiva vm cv cc0 wceq vn cv vm cv cexp co cM vn cv cexp co cmul co c2
      vm cv c2 cexp co cexp co cM cM vm cv caddc co cexp co cmul co vn cv cfa
      cfv cmul co cle wbr vn cn wral vn cv cc0 cexp co cM vn cv cexp co cmul co
      c2 cc0 c2 cexp co cexp co cM cM cc0 caddc co cexp co cmul co vn cv cfa
      cfv cmul co cle wbr vn cn wral cM cn0 wcel vm cv cc0 wceq vn cv vm cv
      cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co cexp co cM cM vm cv
      caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cv cc0 cexp co
      cM vn cv cexp co cmul co c2 cc0 c2 cexp co cexp co cM cM cc0 caddc co
      cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn vm cv cc0 wceq vn cv
      vm cv cexp co cM vn cv cexp co cmul co vn cv cc0 cexp co cM vn cv cexp co
      cmul co c2 vm cv c2 cexp co cexp co cM cM vm cv caddc co cexp co cmul co
      vn cv cfa cfv cmul co c2 cc0 c2 cexp co cexp co cM cM cc0 caddc co cexp
      co cmul co vn cv cfa cfv cmul co cle vm cv cc0 wceq vn cv vm cv cexp co
      vn cv cc0 cexp co cM vn cv cexp co cmul vm cv cc0 vn cv cexp opreq2
      opreq1d vm cv cc0 wceq c2 vm cv c2 cexp co cexp co cM cM vm cv caddc co
      cexp co cmul co c2 cc0 c2 cexp co cexp co cM cM cc0 caddc co cexp co cmul
      co vn cv cfa cfv cmul vm cv cc0 wceq c2 vm cv c2 cexp co cexp co c2 cc0
      c2 cexp co cexp co cM cM vm cv caddc co cexp co cM cM cc0 caddc co cexp
      co cmul vm cv cc0 wceq vm cv c2 cexp co cc0 c2 cexp co c2 cexp vm cv cc0
      c2 cexp opreq1 opreq2d vm cv cc0 wceq cM vm cv caddc co cM cc0 caddc co
      cM cexp vm cv cc0 cM caddc opreq2 opreq2d opreq12d opreq1d breq12d
      ralbidv imbi2d vm cv vj cv wceq vn cv vm cv cexp co cM vn cv cexp co cmul
      co c2 vm cv c2 cexp co cexp co cM cM vm cv caddc co cexp co cmul co vn cv
      cfa cfv cmul co cle wbr vn cn wral vn cv vj cv cexp co cM vn cv cexp co
      cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv caddc co cexp co cmul co
      vn cv cfa cfv cmul co cle wbr vn cn wral cM cn0 wcel vm cv vj cv wceq vn
      cv vm cv cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co cexp co cM
      cM vm cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cv vj
      cv cexp co cM vn cv cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj
      cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn vm cv vj
      cv wceq vn cv vm cv cexp co cM vn cv cexp co cmul co vn cv vj cv cexp co
      cM vn cv cexp co cmul co c2 vm cv c2 cexp co cexp co cM cM vm cv caddc co
      cexp co cmul co vn cv cfa cfv cmul co c2 vj cv c2 cexp co cexp co cM cM
      vj cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle vm cv vj cv wceq
      vn cv vm cv cexp co vn cv vj cv cexp co cM vn cv cexp co cmul vm cv vj cv
      vn cv cexp opreq2 opreq1d vm cv vj cv wceq c2 vm cv c2 cexp co cexp co cM
      cM vm cv caddc co cexp co cmul co c2 vj cv c2 cexp co cexp co cM cM vj cv
      caddc co cexp co cmul co vn cv cfa cfv cmul vm cv vj cv wceq c2 vm cv c2
      cexp co cexp co c2 vj cv c2 cexp co cexp co cM cM vm cv caddc co cexp co
      cM cM vj cv caddc co cexp co cmul vm cv vj cv wceq vm cv c2 cexp co vj cv
      c2 cexp co c2 cexp vm cv vj cv c2 cexp opreq1 opreq2d vm cv vj cv wceq cM
      vm cv caddc co cM vj cv caddc co cM cexp vm cv vj cv cM caddc opreq2
      opreq2d opreq12d opreq1d breq12d ralbidv imbi2d vm cv vj cv c1 caddc co
      wceq vn cv vm cv cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co
      cexp co cM cM vm cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle
      wbr vn cn wral vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul co
      c2 vj cv c1 caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co
      cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn wral cM cn0 wcel vm
      cv vj cv c1 caddc co wceq vn cv vm cv cexp co cM vn cv cexp co cmul co c2
      vm cv c2 cexp co cexp co cM cM vm cv caddc co cexp co cmul co vn cv cfa
      cfv cmul co cle wbr vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul
      co c2 vj cv c1 caddc co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc
      co cexp co cmul co vn cv cfa cfv cmul co cle wbr vn cn vm cv vj cv c1
      caddc co wceq vn cv vm cv cexp co cM vn cv cexp co cmul co vn cv vj cv c1
      caddc co cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co cexp co cM
      cM vm cv caddc co cexp co cmul co vn cv cfa cfv cmul co c2 vj cv c1 caddc
      co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co cmul co vn
      cv cfa cfv cmul co cle vm cv vj cv c1 caddc co wceq vn cv vm cv cexp co
      vn cv vj cv c1 caddc co cexp co cM vn cv cexp co cmul vm cv vj cv c1
      caddc co vn cv cexp opreq2 opreq1d vm cv vj cv c1 caddc co wceq c2 vm cv
      c2 cexp co cexp co cM cM vm cv caddc co cexp co cmul co c2 vj cv c1 caddc
      co c2 cexp co cexp co cM cM vj cv c1 caddc co caddc co cexp co cmul co vn
      cv cfa cfv cmul vm cv vj cv c1 caddc co wceq c2 vm cv c2 cexp co cexp co
      c2 vj cv c1 caddc co c2 cexp co cexp co cM cM vm cv caddc co cexp co cM
      cM vj cv c1 caddc co caddc co cexp co cmul vm cv vj cv c1 caddc co wceq
      vm cv c2 cexp co vj cv c1 caddc co c2 cexp co c2 cexp vm cv vj cv c1
      caddc co c2 cexp opreq1 opreq2d vm cv vj cv c1 caddc co wceq cM vm cv
      caddc co cM vj cv c1 caddc co caddc co cM cexp vm cv vj cv c1 caddc co cM
      caddc opreq2 opreq2d opreq12d opreq1d breq12d ralbidv imbi2d vm cv cK
      wceq vn cv vm cv cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co
      cexp co cM cM vm cv caddc co cexp co cmul co vn cv cfa cfv cmul co cle
      wbr vn cn wral vn cv cK cexp co cM vn cv cexp co cmul co c2 cK c2 cexp co
      cexp co cM cM cK caddc co cexp co cmul co vn cv cfa cfv cmul co cle wbr
      vn cn wral cM cn0 wcel vm cv cK wceq vn cv vm cv cexp co cM vn cv cexp co
      cmul co c2 vm cv c2 cexp co cexp co cM cM vm cv caddc co cexp co cmul co
      vn cv cfa cfv cmul co cle wbr vn cv cK cexp co cM vn cv cexp co cmul co
      c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co vn cv cfa cfv
      cmul co cle wbr vn cn vm cv cK wceq vn cv vm cv cexp co cM vn cv cexp co
      cmul co vn cv cK cexp co cM vn cv cexp co cmul co c2 vm cv c2 cexp co
      cexp co cM cM vm cv caddc co cexp co cmul co vn cv cfa cfv cmul co c2 cK
      c2 cexp co cexp co cM cM cK caddc co cexp co cmul co vn cv cfa cfv cmul
      co cle vm cv cK wceq vn cv vm cv cexp co vn cv cK cexp co cM vn cv cexp
      co cmul vm cv cK vn cv cexp opreq2 opreq1d vm cv cK wceq c2 vm cv c2 cexp
      co cexp co cM cM vm cv caddc co cexp co cmul co c2 cK c2 cexp co cexp co
      cM cM cK caddc co cexp co cmul co vn cv cfa cfv cmul vm cv cK wceq c2 vm
      cv c2 cexp co cexp co c2 cK c2 cexp co cexp co cM cM vm cv caddc co cexp
      co cM cM cK caddc co cexp co cmul vm cv cK wceq vm cv c2 cexp co cK c2
      cexp co c2 cexp vm cv cK c2 cexp opreq1 opreq2d vm cv cK wceq cM vm cv
      caddc co cM cK caddc co cM cexp vm cv cK cM caddc opreq2 opreq2d opreq12d
      opreq1d breq12d ralbidv imbi2d nn0indALT imp sylan2 3impb $.
      $( [28-Jan-2006] $) $( [19-Dec-2005] $)
  $}

  $( Variant of ~ faclbnd5 providing a non-strict lower bound. $)
  faclbnd4 $p |- ( ( N e. NN0 /\ K e. NN0 /\ M e. NN0 ) ->
                 ( ( N ^ K ) x. ( M ^ N ) ) <_
            ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` N ) ) ) $=
    cM cn0 wcel cK cn0 wcel cN cn0 wcel cN cK cexp co cM cN cexp co cmul co c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co
    cle wbr cM cn0 wcel cK cn0 wcel cN cn0 wcel cN cK cexp co cM cN cexp co
    cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa
    cfv cmul co cle wbr cM cn0 wcel cK cn0 wcel wa cN cn wcel cN cc0 wceq wo cN
    cK cexp co cM cN cexp co cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co
    cexp co cmul co cN cfa cfv cmul co cle wbr cN cn0 wcel cM cn0 wcel cK cn0
    wcel wa cN cn wcel cN cK cexp co cM cN cexp co cmul co c2 cK c2 cexp co
    cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cN cc0
    wceq cM cn0 wcel cK cn0 wcel cN cn wcel cN cK cexp co cM cN cexp co cmul co
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul
    co cle wbr cN cn wcel cK cn0 wcel cM cn0 wcel cN cK cexp co cM cN cexp co
    cmul co c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa
    cfv cmul co cle wbr cK cM cN faclbnd4lem4 3com13 3expa cK cM cN
    faclbnd4lem3 jaodan cN elnn0 sylan2b 3impa 3com13 $.
    $( [28-Jan-2006] $) $( [23-Dec-2005] $)

  $( The factorial function grows faster than powers and exponentiations.  If
     we consider ` K ` and ` M ` to be constants, the right-hand side of the
     inequality is a constant times ` N ` -factorial. $)
  faclbnd5 $p |- ( ( N e. NN0 /\ K e. NN0 /\ M e. NN ) ->
                 ( ( N ^ K ) x. ( M ^ N ) ) <
      ( ( 2 x. ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) ) x. ( ! ` N ) ) ) $=
    cK cn0 wcel cM cn wcel cN cn0 wcel cN cK cexp co cM cN cexp co cmul co c2
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cmul co cN cfa
    cfv cmul co clt wbr cK cn0 wcel cM cn wcel cN cn0 wcel cN cK cexp co cM cN
    cexp co cmul co c2 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co cmul co cN cfa cfv cmul co clt wbr cK cn0 wcel cM cn wcel wa cN cn0 wcel
    wa cN cK cexp co cM cN cexp co cmul co c2 c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co cN cfa cfv cmul co cmul co c2 c2 cK c2 cexp co
    cexp co cM cM cK caddc co cexp co cmul co cmul co cN cfa cfv cmul co clt cK
    cn0 wcel cM cn wcel wa cN cn0 wcel wa cN cK cexp co cM cN cexp co cmul co
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul
    co c2 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv
    cmul co cmul co cK cn0 wcel cM cn wcel cN cn0 wcel cN cK cexp co cM cN cexp
    co cmul co cr wcel cN cK cexp co cr wcel cM cN cexp co cr wcel cN cK cexp
    co cM cN cexp co cmul co cr wcel cK cn0 wcel cN cn0 wcel wa cM cn wcel cN
    cn0 wcel wa cN cK cexp co cM cN cexp co remulcl cN cn0 wcel cK cn0 wcel cN
    cK cexp co cr wcel cN cr wcel cK cn0 wcel cN cK cexp co cr wcel cN cn0 wcel
    cN cK reexpcl cN nn0re sylan ancoms cM cr wcel cN cn0 wcel cM cN cexp co cr
    wcel cM cn wcel cM cN reexpcl cM nnre sylan syl2an anandirs c2 cK c2 cexp
    co cexp co cM cM cK caddc co cexp co cmul co cr wcel cN cfa cfv cr wcel c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co
    cr wcel cK cn0 wcel cM cn wcel wa cN cn0 wcel c2 cK c2 cexp co cexp co cM
    cM cK caddc co cexp co cmul co cN cfa cfv remulcl cK cn0 wcel cM cn wcel wa
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn wcel c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cr wcel cK cn0 wcel cM cn
    wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn wcel c2
    cK c2 cexp co cexp co cn wcel cM cM cK caddc co cexp co cn wcel c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cn wcel cK cn0 wcel cK
    cn0 wcel cM cn wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
    nnmulcl c2 cn wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co cexp co cn wcel
    cK cn0 wcel c2 cK c2 cexp co nnexpcl 2nn cK cn0 wcel c2 cn0 wcel cK c2 cexp
    co cn0 wcel 2nn0 cK c2 nn0expcl mpan2 sylancr cK cn0 wcel cM cn wcel cM cM
    cK caddc co cexp co cn wcel cM cn wcel cM cK caddc co cn0 wcel cM cM cK
    caddc co cexp co cn wcel cK cn0 wcel cM cn wcel wa cM cM cK caddc co
    nnexpcl cK cn0 wcel cM cn0 wcel cM cK caddc co cn0 wcel cM cn wcel cM cn0
    wcel cK cn0 wcel cM cK caddc co cn0 wcel cM cK nn0addcl ancoms cM nnnn0
    sylan2 sylan2 anabss7 syl2an anabss5 c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co nnre syl cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv
    cr wcel cN faccl cN cfa cfv nnre syl syl2an c2 cr wcel c2 cK c2 cexp co
    cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cr wcel c2 c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co
    cmul co cr wcel cK cn0 wcel cM cn wcel wa cN cn0 wcel wa c2 c2 cK c2 cexp
    co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co remulcl 2re
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cr wcel cN cfa
    cfv cr wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
    cfa cfv cmul co cr wcel cK cn0 wcel cM cn wcel wa cN cn0 wcel c2 cK c2 cexp
    co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv remulcl cK cn0 wcel
    cM cn wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn
    wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cr wcel cK
    cn0 wcel cM cn wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co cn wcel c2 cK c2 cexp co cexp co cn wcel cM cM cK caddc co cexp co cn
    wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn wcel cK
    cn0 wcel cK cn0 wcel cM cn wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc
    co cexp co nnmulcl c2 cn wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co cexp
    co cn wcel cK cn0 wcel c2 cK c2 cexp co nnexpcl 2nn cK cn0 wcel c2 cn0 wcel
    cK c2 cexp co cn0 wcel 2nn0 cK c2 nn0expcl mpan2 sylancr cK cn0 wcel cM cn
    wcel cM cM cK caddc co cexp co cn wcel cM cn wcel cM cK caddc co cn0 wcel
    cM cM cK caddc co cexp co cn wcel cK cn0 wcel cM cn wcel wa cM cM cK caddc
    co nnexpcl cK cn0 wcel cM cn0 wcel cM cK caddc co cn0 wcel cM cn wcel cM
    cn0 wcel cK cn0 wcel cM cK caddc co cn0 wcel cM cK nn0addcl ancoms cM nnnn0
    sylan2 sylan2 anabss7 syl2an anabss5 c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co nnre syl cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv
    cr wcel cN faccl cN cfa cfv nnre syl syl2an sylancr cK cn0 wcel cM cn wcel
    cN cn0 wcel cN cK cexp co cM cN cexp co cmul co c2 cK c2 cexp co cexp co cM
    cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cN cn0 wcel cK
    cn0 wcel cM cn wcel cN cK cexp co cM cN cexp co cmul co c2 cK c2 cexp co
    cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle wbr cN cn0
    wcel cK cn0 wcel cM cn0 wcel cN cK cexp co cM cN cexp co cmul co c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cle
    wbr cM cn wcel cK cM cN faclbnd4 cM nnnn0 syl3an3 3coml 3expa cK cn0 wcel
    cM cn wcel wa cN cn0 wcel wa c1 c2 clt wbr c2 cK c2 cexp co cexp co cM cM
    cK caddc co cexp co cmul co cN cfa cfv cmul co c2 c2 cK c2 cexp co cexp co
    cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cmul co clt wbr 1lt2
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul
    co cr wcel cc0 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co
    cN cfa cfv cmul co clt wbr c1 c2 clt wbr c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co cN cfa cfv cmul co c2 c2 cK c2 cexp co cexp co cM
    cM cK caddc co cexp co cmul co cN cfa cfv cmul co cmul co clt wbr wb cK cn0
    wcel cM cn wcel wa cN cn0 wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc
    co cexp co cmul co cN cfa cfv cmul co cr wcel c2 cr wcel cc0 c2 cK c2 cexp
    co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co clt wbr c1
    c2 clt wbr c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
    cfa cfv cmul co c2 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co cN cfa cfv cmul co cmul co clt wbr wb 2re c2 cK c2 cexp co cexp co cM cM
    cK caddc co cexp co cmul co cN cfa cfv cmul co c2 ltmulgt12 mp3an2 c2 cK c2
    cexp co cexp co cM cM cK caddc co cexp co cmul co cr wcel cN cfa cfv cr
    wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv
    cmul co cr wcel cK cn0 wcel cM cn wcel wa cN cn0 wcel c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co cmul co cN cfa cfv remulcl cK cn0 wcel cM cn
    wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn wcel
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cr wcel cK cn0
    wcel cM cn wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co
    cn wcel c2 cK c2 cexp co cexp co cn wcel cM cM cK caddc co cexp co cn wcel
    c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cn wcel cK cn0
    wcel cK cn0 wcel cM cn wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co
    cexp co nnmulcl c2 cn wcel cK c2 cexp co cn0 wcel c2 cK c2 cexp co cexp co
    cn wcel cK cn0 wcel c2 cK c2 cexp co nnexpcl 2nn cK cn0 wcel c2 cn0 wcel cK
    c2 cexp co cn0 wcel 2nn0 cK c2 nn0expcl mpan2 sylancr cK cn0 wcel cM cn
    wcel cM cM cK caddc co cexp co cn wcel cM cn wcel cM cK caddc co cn0 wcel
    cM cM cK caddc co cexp co cn wcel cK cn0 wcel cM cn wcel wa cM cM cK caddc
    co nnexpcl cK cn0 wcel cM cn0 wcel cM cK caddc co cn0 wcel cM cn wcel cM
    cn0 wcel cK cn0 wcel cM cK caddc co cn0 wcel cM cK nn0addcl ancoms cM nnnn0
    sylan2 sylan2 anabss7 syl2an anabss5 c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co nnre syl cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv
    cr wcel cN faccl cN cfa cfv nnre syl syl2an cK cn0 wcel cM cn wcel wa cN
    cn0 wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
    cfa cfv cmul co cn wcel cc0 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
    co cmul co cN cfa cfv cmul co clt wbr c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co cn wcel cN cfa cfv cn wcel c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co cmul co cN cfa cfv cmul co cn wcel cK cn0 wcel
    cM cn wcel wa cN cn0 wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp
    co cmul co cN cfa cfv nnmulcl cK cn0 wcel cM cn wcel c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co cmul co cn wcel c2 cK c2 cexp co cexp co cn
    wcel cM cM cK caddc co cexp co cn wcel c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co cn wcel cK cn0 wcel cK cn0 wcel cM cn wcel wa c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co nnmulcl c2 cn wcel cK c2
    cexp co cn0 wcel c2 cK c2 cexp co cexp co cn wcel cK cn0 wcel c2 cK c2 cexp
    co nnexpcl 2nn cK cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel 2nn0 cK c2
    nn0expcl mpan2 sylancr cK cn0 wcel cM cn wcel cM cM cK caddc co cexp co cn
    wcel cM cn wcel cM cK caddc co cn0 wcel cM cM cK caddc co cexp co cn wcel
    cK cn0 wcel cM cn wcel wa cM cM cK caddc co nnexpcl cK cn0 wcel cM cn0 wcel
    cM cK caddc co cn0 wcel cM cn wcel cM cn0 wcel cK cn0 wcel cM cK caddc co
    cn0 wcel cM cK nn0addcl ancoms cM nnnn0 sylan2 sylan2 anabss7 syl2an
    anabss5 cN faccl syl2an c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
    cmul co cN cfa cfv cmul co nngt0 syl sylanc mpbii lelttrd c2 cK c2 cexp co
    cexp co cM cM cK caddc co cexp co cmul co cc wcel cN cfa cfv cc wcel c2 c2
    cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cmul co cN cfa cfv
    cmul co c2 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cN
    cfa cfv cmul co cmul co wceq cK cn0 wcel cM cn wcel wa cN cn0 wcel c2 cc
    wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul co cc wcel cN
    cfa cfv cc wcel c2 c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co cmul co cN cfa cfv cmul co c2 c2 cK c2 cexp co cexp co cM cM cK caddc co
    cexp co cmul co cN cfa cfv cmul co cmul co wceq 2cn c2 c2 cK c2 cexp co
    cexp co cM cM cK caddc co cexp co cmul co cN cfa cfv mulass mp3an1 cK cn0
    wcel cM cn wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co cmul
    co cK cn0 wcel cM cn wcel wa c2 cK c2 cexp co cexp co cM cM cK caddc co
    cexp co cmul co cn wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
    cmul co cr wcel cK cn0 wcel cM cn wcel c2 cK c2 cexp co cexp co cM cM cK
    caddc co cexp co cmul co cn wcel c2 cK c2 cexp co cexp co cn wcel cM cM cK
    caddc co cexp co cn wcel c2 cK c2 cexp co cexp co cM cM cK caddc co cexp co
    cmul co cn wcel cK cn0 wcel cK cn0 wcel cM cn wcel wa c2 cK c2 cexp co cexp
    co cM cM cK caddc co cexp co nnmulcl c2 cn wcel cK c2 cexp co cn0 wcel c2
    cK c2 cexp co cexp co cn wcel cK cn0 wcel c2 cK c2 cexp co nnexpcl 2nn cK
    cn0 wcel c2 cn0 wcel cK c2 cexp co cn0 wcel 2nn0 cK c2 nn0expcl mpan2
    sylancr cK cn0 wcel cM cn wcel cM cM cK caddc co cexp co cn wcel cM cn wcel
    cM cK caddc co cn0 wcel cM cM cK caddc co cexp co cn wcel cK cn0 wcel cM cn
    wcel wa cM cM cK caddc co nnexpcl cK cn0 wcel cM cn0 wcel cM cK caddc co
    cn0 wcel cM cn wcel cM cn0 wcel cK cn0 wcel cM cK caddc co cn0 wcel cM cK
    nn0addcl ancoms cM nnnn0 sylan2 sylan2 anabss7 syl2an anabss5 c2 cK c2 cexp
    co cexp co cM cM cK caddc co cexp co cmul co nnre syl recnd cN cn0 wcel cN
    cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cr wcel cN faccl cN cfa
    cfv nnre syl recnd syl2an breqtrrd 3impa 3comr $.
    $( [16-Feb-2006] $) $( [24-Dec-2005] $)

  ${
    $d M m $.  $d N k m $.
    $( Geometric lower bound for the factorial function, where N is usually
       held constant.  (Contributed by Paul Chapman, 28-Dec-2007.) $)
    faclbnd6 $p |- ( ( N e. NN0 /\ M e. NN0 ) ->
             ( ( ! ` N ) x. ( ( N + 1 ) ^ M ) ) <_ ( ! ` ( N + M ) ) ) $=
      cM cn0 wcel cN cn0 wcel cN cfa cfv cN c1 caddc co cM cexp co cmul co cN
      cM caddc co cfa cfv cle wbr cN cn0 wcel cN cfa cfv cN c1 caddc co vm cv
      cexp co cmul co cN vm cv caddc co cfa cfv cle wbr wi cN cn0 wcel cN cfa
      cfv cN c1 caddc co cc0 cexp co cmul co cN cc0 caddc co cfa cfv cle wbr wi
      cN cn0 wcel cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN vk cv
      caddc co cfa cfv cle wbr wi cN cn0 wcel cN cfa cfv cN c1 caddc co vk cv
      c1 caddc co cexp co cmul co cN vk cv c1 caddc co caddc co cfa cfv cle wbr
      wi cN cn0 wcel cN cfa cfv cN c1 caddc co cM cexp co cmul co cN cM caddc
      co cfa cfv cle wbr wi vm vk cM vm cv cc0 wceq cN cfa cfv cN c1 caddc co
      vm cv cexp co cmul co cN vm cv caddc co cfa cfv cle wbr cN cfa cfv cN c1
      caddc co cc0 cexp co cmul co cN cc0 caddc co cfa cfv cle wbr cN cn0 wcel
      vm cv cc0 wceq cN cfa cfv cN c1 caddc co vm cv cexp co cmul co cN cfa cfv
      cN c1 caddc co cc0 cexp co cmul co cN vm cv caddc co cfa cfv cN cc0 caddc
      co cfa cfv cle vm cv cc0 wceq cN c1 caddc co vm cv cexp co cN c1 caddc co
      cc0 cexp co cN cfa cfv cmul vm cv cc0 cN c1 caddc co cexp opreq2 opreq2d
      vm cv cc0 wceq cN vm cv caddc co cN cc0 caddc co cfa vm cv cc0 cN caddc
      opreq2 fveq2d breq12d imbi2d vm cv vk cv wceq cN cfa cfv cN c1 caddc co
      vm cv cexp co cmul co cN vm cv caddc co cfa cfv cle wbr cN cfa cfv cN c1
      caddc co vk cv cexp co cmul co cN vk cv caddc co cfa cfv cle wbr cN cn0
      wcel vm cv vk cv wceq cN cfa cfv cN c1 caddc co vm cv cexp co cmul co cN
      cfa cfv cN c1 caddc co vk cv cexp co cmul co cN vm cv caddc co cfa cfv cN
      vk cv caddc co cfa cfv cle vm cv vk cv wceq cN c1 caddc co vm cv cexp co
      cN c1 caddc co vk cv cexp co cN cfa cfv cmul vm cv vk cv cN c1 caddc co
      cexp opreq2 opreq2d vm cv vk cv wceq cN vm cv caddc co cN vk cv caddc co
      cfa vm cv vk cv cN caddc opreq2 fveq2d breq12d imbi2d vm cv vk cv c1
      caddc co wceq cN cfa cfv cN c1 caddc co vm cv cexp co cmul co cN vm cv
      caddc co cfa cfv cle wbr cN cfa cfv cN c1 caddc co vk cv c1 caddc co cexp
      co cmul co cN vk cv c1 caddc co caddc co cfa cfv cle wbr cN cn0 wcel vm
      cv vk cv c1 caddc co wceq cN cfa cfv cN c1 caddc co vm cv cexp co cmul co
      cN cfa cfv cN c1 caddc co vk cv c1 caddc co cexp co cmul co cN vm cv
      caddc co cfa cfv cN vk cv c1 caddc co caddc co cfa cfv cle vm cv vk cv c1
      caddc co wceq cN c1 caddc co vm cv cexp co cN c1 caddc co vk cv c1 caddc
      co cexp co cN cfa cfv cmul vm cv vk cv c1 caddc co cN c1 caddc co cexp
      opreq2 opreq2d vm cv vk cv c1 caddc co wceq cN vm cv caddc co cN vk cv c1
      caddc co caddc co cfa vm cv vk cv c1 caddc co cN caddc opreq2 fveq2d
      breq12d imbi2d vm cv cM wceq cN cfa cfv cN c1 caddc co vm cv cexp co cmul
      co cN vm cv caddc co cfa cfv cle wbr cN cfa cfv cN c1 caddc co cM cexp co
      cmul co cN cM caddc co cfa cfv cle wbr cN cn0 wcel vm cv cM wceq cN cfa
      cfv cN c1 caddc co vm cv cexp co cmul co cN cfa cfv cN c1 caddc co cM
      cexp co cmul co cN vm cv caddc co cfa cfv cN cM caddc co cfa cfv cle vm
      cv cM wceq cN c1 caddc co vm cv cexp co cN c1 caddc co cM cexp co cN cfa
      cfv cmul vm cv cM cN c1 caddc co cexp opreq2 opreq2d vm cv cM wceq cN vm
      cv caddc co cN cM caddc co cfa vm cv cM cN caddc opreq2 fveq2d breq12d
      imbi2d cN cn0 wcel cN cfa cfv cN cfa cfv cN cfa cfv cN c1 caddc co cc0
      cexp co cmul co cN cc0 caddc co cfa cfv cle cN cn0 wcel cN cfa cfv cn
      wcel cN cfa cfv cr wcel cN cfa cfv cN cfa cfv cle wbr cN faccl cN cfa cfv
      nnre cN cfa cfv leid 3syl cN cn0 wcel cN cfa cfv cN c1 caddc co cc0 cexp
      co cmul co cN cfa cfv c1 cmul co cN cfa cfv cN cn0 wcel cN c1 caddc co
      cc0 cexp co c1 cN cfa cfv cmul cN cn0 wcel cN c1 caddc co cc wcel cN c1
      caddc co cc0 cexp co c1 wceq cN cn0 wcel cN cc wcel cN c1 caddc co cc
      wcel cN nn0cn cN peano2cn syl cN c1 caddc co exp0 syl opreq2d cN cn0 wcel
      cN cfa cfv cc wcel cN cfa cfv c1 cmul co cN cfa cfv wceq cN cn0 wcel cN
      cfa cfv cn wcel cN cfa cfv cc wcel cN faccl cN cfa cfv nncn syl cN cfa
      cfv ax1id syl eqtrd cN cn0 wcel cN cc0 caddc co cN cfa cN cn0 wcel cN cc
      wcel cN cc0 caddc co cN wceq cN nn0cn cN addid1 syl fveq2d 3brtr4d vk cv
      cn0 wcel cN cn0 wcel cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN
      vk cv caddc co cfa cfv cle wbr cN cfa cfv cN c1 caddc co vk cv c1 caddc
      co cexp co cmul co cN vk cv c1 caddc co caddc co cfa cfv cle wbr cN cn0
      wcel vk cv cn0 wcel cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN vk
      cv caddc co cfa cfv cle wbr cN cfa cfv cN c1 caddc co vk cv c1 caddc co
      cexp co cmul co cN vk cv c1 caddc co caddc co cfa cfv cle wbr wi cN cn0
      wcel vk cv cn0 wcel wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN
      vk cv caddc co cfa cfv cle wbr cN cfa cfv cN c1 caddc co vk cv c1 caddc
      co cexp co cmul co cN vk cv c1 caddc co caddc co cfa cfv cle wbr cN cn0
      wcel vk cv cn0 wcel wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN
      vk cv caddc co cfa cfv cle wbr wa cN cfa cfv cN c1 caddc co vk cv cexp co
      cmul co cN c1 caddc co cmul co cN vk cv caddc co cfa cfv cN vk cv c1
      caddc co caddc co cmul co cN cfa cfv cN c1 caddc co vk cv c1 caddc co
      cexp co cmul co cN vk cv c1 caddc co caddc co cfa cfv cle cN cfa cfv cN
      c1 caddc co vk cv cexp co cmul co cr wcel cN vk cv caddc co cfa cfv cr
      wcel wa cc0 cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cle wbr cN
      cfa cfv cN c1 caddc co vk cv cexp co cmul co cN vk cv caddc co cfa cfv
      cle wbr wa wa cN c1 caddc co cr wcel cN vk cv c1 caddc co caddc co cr
      wcel wa cc0 cN c1 caddc co cle wbr cN c1 caddc co cN vk cv c1 caddc co
      caddc co cle wbr wa wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN
      c1 caddc co cmul co cN vk cv caddc co cfa cfv cN vk cv c1 caddc co caddc
      co cmul co cle wbr cN cn0 wcel vk cv cn0 wcel wa cN cfa cfv cN c1 caddc
      co vk cv cexp co cmul co cN vk cv caddc co cfa cfv cle wbr wa cN cfa cfv
      cN c1 caddc co vk cv cexp co cmul co cN vk cv caddc co cfa cfv cN c1
      caddc co cN vk cv c1 caddc co caddc co lemul12aOLD cN cn0 wcel vk cv cn0
      wcel wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN vk cv caddc co
      cfa cfv cle wbr wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cr
      wcel cN vk cv caddc co cfa cfv cr wcel wa cc0 cN cfa cfv cN c1 caddc co
      vk cv cexp co cmul co cle wbr cN cfa cfv cN c1 caddc co vk cv cexp co
      cmul co cN vk cv caddc co cfa cfv cle wbr wa cN cn0 wcel vk cv cn0 wcel
      wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cr wcel cN vk cv caddc
      co cfa cfv cr wcel wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN
      vk cv caddc co cfa cfv cle wbr cN cn0 wcel vk cv cn0 wcel wa cN cfa cfv
      cN c1 caddc co vk cv cexp co cmul co cr wcel cN vk cv caddc co cfa cfv cr
      wcel cN cfa cfv cr wcel cN c1 caddc co vk cv cexp co cr wcel cN cfa cfv
      cN c1 caddc co vk cv cexp co cmul co cr wcel cN cn0 wcel vk cv cn0 wcel
      wa cN cfa cfv cN c1 caddc co vk cv cexp co remulcl cN cn0 wcel cN cfa cfv
      cr wcel vk cv cn0 wcel cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cr wcel
      cN faccl cN cfa cfv nnre syl adantr cN c1 caddc co cr wcel vk cv cn0 wcel
      cN c1 caddc co vk cv cexp co cr wcel cN cn0 wcel cN c1 caddc co vk cv
      reexpcl cN cn0 wcel cN cr wcel cN c1 caddc co cr wcel cN nn0re cN
      peano2re syl sylan sylanc cN cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co
      cn0 wcel cN vk cv caddc co cfa cfv cn wcel cN vk cv caddc co cfa cfv cr
      wcel cN vk cv nn0addcl cN vk cv caddc co faccl cN vk cv caddc co cfa cfv
      nnre 3syl jca adantr cN cn0 wcel vk cv cn0 wcel wa cc0 cN cfa cfv cN c1
      caddc co vk cv cexp co cmul co cle wbr cN cfa cfv cN c1 caddc co vk cv
      cexp co cmul co cN vk cv caddc co cfa cfv cle wbr cN cn0 wcel vk cv cn0
      wcel wa cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cn0 wcel cc0 cN
      cfa cfv cN c1 caddc co vk cv cexp co cmul co cle wbr cN cfa cfv cn0 wcel
      cN c1 caddc co vk cv cexp co cn0 wcel cN cfa cfv cN c1 caddc co vk cv
      cexp co cmul co cn0 wcel cN cn0 wcel vk cv cn0 wcel wa cN cfa cfv cN c1
      caddc co vk cv cexp co nn0mulcl cN cn0 wcel cN cfa cfv cn0 wcel vk cv cn0
      wcel cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cn0 wcel cN faccl cN cfa
      cfv nnnn0 syl adantr cN c1 caddc co cn0 wcel vk cv cn0 wcel cN c1 caddc
      co vk cv cexp co cn0 wcel cN cn0 wcel cN c1 caddc co vk cv nn0expcl cN
      peano2nn0 sylan sylanc cN cfa cfv cN c1 caddc co vk cv cexp co cmul co
      nn0ge0 syl anim1i jca cN cn0 wcel vk cv cn0 wcel wa cN c1 caddc co cr
      wcel cN vk cv c1 caddc co caddc co cr wcel wa cc0 cN c1 caddc co cle wbr
      cN c1 caddc co cN vk cv c1 caddc co caddc co cle wbr wa wa cN cfa cfv cN
      c1 caddc co vk cv cexp co cmul co cN vk cv caddc co cfa cfv cle wbr cN
      cn0 wcel vk cv cn0 wcel wa cN c1 caddc co cr wcel cN vk cv c1 caddc co
      caddc co cr wcel cc0 cN c1 caddc co cle wbr cN c1 caddc co cN vk cv c1
      caddc co caddc co cle wbr wa cN cn0 wcel cN c1 caddc co cr wcel vk cv cn0
      wcel cN cn0 wcel cN cr wcel cN c1 caddc co cr wcel cN nn0re cN peano2re
      syl adantr cN cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co c1 caddc co cN
      vk cv c1 caddc co caddc co cr cN cc wcel vk cv cc wcel cN vk cv caddc co
      c1 caddc co cN vk cv c1 caddc co caddc co wceq cN cn0 wcel vk cv cn0 wcel
      cN cc wcel vk cv cc wcel c1 cc wcel cN vk cv caddc co c1 caddc co cN vk
      cv c1 caddc co caddc co wceq ax1cn cN vk cv c1 addass mp3an3 cN nn0cn vk
      cv nn0cn syl2an cN cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co cn0 wcel
      cN vk cv caddc co c1 caddc co cn0 wcel cN vk cv caddc co c1 caddc co cr
      wcel cN vk cv nn0addcl cN vk cv caddc co peano2nn0 cN vk cv caddc co c1
      caddc co nn0re 3syl eqeltrrd cN cn0 wcel vk cv cn0 wcel wa cc0 cN c1
      caddc co cle wbr cN c1 caddc co cN vk cv c1 caddc co caddc co cle wbr cN
      cn0 wcel cc0 cN c1 caddc co cle wbr vk cv cn0 wcel cN cn0 wcel cN c1
      caddc co cn0 wcel cc0 cN c1 caddc co cle wbr cN peano2nn0 cN c1 caddc co
      nn0ge0 syl adantr cN cn0 wcel vk cv cn0 wcel wa cN c1 caddc co vk cv cN
      c1 caddc co caddc co cN vk cv c1 caddc co caddc co cle cN cn0 wcel vk cv
      cn0 wcel wa cc0 vk cv cle wbr cN c1 caddc co vk cv cN c1 caddc co caddc
      co cle wbr vk cv cn0 wcel cc0 vk cv cle wbr cN cn0 wcel vk cv nn0ge0
      adantl cN c1 caddc co cr wcel vk cv cr wcel cc0 vk cv cle wbr cN c1 caddc
      co vk cv cN c1 caddc co caddc co cle wbr wb cN cn0 wcel vk cv cn0 wcel cN
      c1 caddc co vk cv addge02 cN cn0 wcel cN cr wcel cN c1 caddc co cr wcel
      cN nn0re cN peano2re syl vk cv nn0re syl2an mpbid cN cc wcel vk cv cc
      wcel cN vk cv c1 caddc co caddc co vk cv cN c1 caddc co caddc co wceq cN
      cn0 wcel vk cv cn0 wcel cN cc wcel vk cv cc wcel c1 cc wcel cN vk cv c1
      caddc co caddc co vk cv cN c1 caddc co caddc co wceq ax1cn cN vk cv c1
      add12 mp3an3 cN nn0cn vk cv nn0cn syl2an breqtrrd jca jca31 adantr sylanc
      cN cn0 wcel vk cv cn0 wcel wa cN cfa cfv cN c1 caddc co vk cv c1 caddc co
      cexp co cmul co cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN c1
      caddc co cmul co wceq cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN
      vk cv caddc co cfa cfv cle wbr cN cn0 wcel vk cv cn0 wcel wa cN cfa cfv
      cN c1 caddc co vk cv c1 caddc co cexp co cmul co cN cfa cfv cN c1 caddc
      co vk cv cexp co cN c1 caddc co cmul co cmul co cN cfa cfv cN c1 caddc co
      vk cv cexp co cmul co cN c1 caddc co cmul co cN cn0 wcel vk cv cn0 wcel
      wa cN c1 caddc co vk cv c1 caddc co cexp co cN c1 caddc co vk cv cexp co
      cN c1 caddc co cmul co cN cfa cfv cmul cN c1 caddc co cc wcel vk cv cn0
      wcel cN c1 caddc co vk cv c1 caddc co cexp co cN c1 caddc co vk cv cexp
      co cN c1 caddc co cmul co wceq cN cn0 wcel cN c1 caddc co vk cv expp1 cN
      cn0 wcel cN cc wcel cN c1 caddc co cc wcel cN nn0cn cN peano2cn syl sylan
      opreq2d cN cfa cfv cc wcel cN c1 caddc co vk cv cexp co cc wcel cN c1
      caddc co cc wcel cN cfa cfv cN c1 caddc co vk cv cexp co cmul co cN c1
      caddc co cmul co cN cfa cfv cN c1 caddc co vk cv cexp co cN c1 caddc co
      cmul co cmul co wceq cN cn0 wcel vk cv cn0 wcel wa cN cfa cfv cN c1 caddc
      co vk cv cexp co cN c1 caddc co mulass cN cn0 wcel cN cfa cfv cc wcel vk
      cv cn0 wcel cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cc wcel cN faccl cN
      cfa cfv nncn syl adantr cN c1 caddc co cc wcel vk cv cn0 wcel cN c1 caddc
      co vk cv cexp co cc wcel cN cn0 wcel cN c1 caddc co vk cv expcl cN cn0
      wcel cN cc wcel cN c1 caddc co cc wcel cN nn0cn cN peano2cn syl sylan cN
      cn0 wcel cN c1 caddc co cc wcel vk cv cn0 wcel cN cn0 wcel cN cc wcel cN
      c1 caddc co cc wcel cN nn0cn cN peano2cn syl adantr syl3anc eqtr4d adantr
      cN cn0 wcel vk cv cn0 wcel wa cN vk cv c1 caddc co caddc co cfa cfv cN vk
      cv caddc co cfa cfv cN vk cv c1 caddc co caddc co cmul co wceq cN cfa cfv
      cN c1 caddc co vk cv cexp co cmul co cN vk cv caddc co cfa cfv cle wbr cN
      cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co c1 caddc co cfa cfv cN vk cv
      caddc co cfa cfv cN vk cv caddc co c1 caddc co cmul co cN vk cv c1 caddc
      co caddc co cfa cfv cN vk cv caddc co cfa cfv cN vk cv c1 caddc co caddc
      co cmul co cN cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co cn0 wcel cN vk
      cv caddc co c1 caddc co cfa cfv cN vk cv caddc co cfa cfv cN vk cv caddc
      co c1 caddc co cmul co wceq cN vk cv nn0addcl cN vk cv caddc co facp1 syl
      cN cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co c1 caddc co cN vk cv c1
      caddc co caddc co cfa cN cc wcel vk cv cc wcel cN vk cv caddc co c1 caddc
      co cN vk cv c1 caddc co caddc co wceq cN cn0 wcel vk cv cn0 wcel cN cc
      wcel vk cv cc wcel c1 cc wcel cN vk cv caddc co c1 caddc co cN vk cv c1
      caddc co caddc co wceq ax1cn cN vk cv c1 addass mp3an3 cN nn0cn vk cv
      nn0cn syl2an fveq2d cN cn0 wcel vk cv cn0 wcel wa cN vk cv caddc co c1
      caddc co cN vk cv c1 caddc co caddc co cN vk cv caddc co cfa cfv cmul cN
      cc wcel vk cv cc wcel cN vk cv caddc co c1 caddc co cN vk cv c1 caddc co
      caddc co wceq cN cn0 wcel vk cv cn0 wcel cN cc wcel vk cv cc wcel c1 cc
      wcel cN vk cv caddc co c1 caddc co cN vk cv c1 caddc co caddc co wceq
      ax1cn cN vk cv c1 addass mp3an3 cN nn0cn vk cv nn0cn syl2an opreq2d
      3eqtr3d adantr 3brtr4d ex expcom a2d nn0ind impcom $.
      $( [29-Dec-2007] $) $( [28-Dec-2007] $)
  $}

  $( The product of two factorials is greater than or equal to the factorial of
     (the floor of) their average. $)
  facavg $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
       ( ! ` ( |_ ` ( ( M + N ) / 2 ) ) ) <_ ( ( ! ` M ) x. ( ! ` N ) ) ) $=
    cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co cM cle wbr cM cN caddc
    co c2 cdiv co cN cle wbr wo cM cN caddc co c2 cdiv co cfl cfv cfa cfv cM
    cfa cfv cN cfa cfv cmul co cle wbr cM cr wcel cN cr wcel cM cN caddc co c2
    cdiv co cM cle wbr cM cN caddc co c2 cdiv co cN cle wbr wo cM cn0 wcel cN
    cn0 wcel cM cN avgle cM nn0re cN nn0re syl2an cM cn0 wcel cN cn0 wcel wa cM
    cN caddc co c2 cdiv co cM cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv
    cM cfa cfv cN cfa cfv cmul co cle wbr cM cN caddc co c2 cdiv co cN cle wbr
    cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co cM cle wbr cM cN caddc
    co c2 cdiv co cfl cfv cM cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv
    cM cfa cfv cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv cM cfa cfv cN
    cfa cfv cmul co cle wbr cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv
    co cfl cfv cM cN caddc co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cM
    cle wbr cM cN caddc co c2 cdiv co cfl cfv cM cle wbr cM cn0 wcel cN cn0
    wcel wa cM cN caddc co cr wcel cM cN caddc co c2 cdiv co cr wcel cM cN
    caddc co c2 cdiv co cfl cfv cM cN caddc co c2 cdiv co cle wbr cM cn0 wcel
    cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel cM cN
    nn0addcl cM cN caddc co nn0re syl cM cN caddc co rehalfcl cM cN caddc co c2
    cdiv co flle 3syl cM cN caddc co c2 cdiv co cfl cfv cr wcel cM cN caddc co
    c2 cdiv co cr wcel cM cr wcel cM cN caddc co c2 cdiv co cfl cfv cM cN caddc
    co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cM cle wbr wa cM cN caddc
    co c2 cdiv co cfl cfv cM cle wbr wi cM cn0 wcel cN cn0 wcel wa cM cN caddc
    co c2 cdiv co cfl cfv cM cN caddc co c2 cdiv co cM letr cM cn0 wcel cN cn0
    wcel wa cM cN caddc co cr wcel cM cN caddc co c2 cdiv co cr wcel cM cN
    caddc co c2 cdiv co cfl cfv cr wcel cM cn0 wcel cN cn0 wcel wa cM cN caddc
    co cn0 wcel cM cN caddc co cr wcel cM cN nn0addcl cM cN caddc co nn0re syl
    cM cN caddc co rehalfcl cM cN caddc co c2 cdiv co reflcl 3syl cM cn0 wcel
    cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel cM cN caddc
    co c2 cdiv co cr wcel cM cN nn0addcl cM cN caddc co nn0re cM cN caddc co
    rehalfcl 3syl cM cn0 wcel cM cr wcel cN cn0 wcel cM nn0re adantr syl3anc
    mpand cM cN caddc co c2 cdiv co cfl cfv cn0 wcel cM cn0 wcel cM cN caddc co
    c2 cdiv co cfl cfv cM cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv cM
    cfa cfv cle wbr wi cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co cfl
    cfv cn0 wcel cM cn0 wcel cM cN caddc co c2 cdiv co cfl cfv cM cle wbr cM cN
    caddc co c2 cdiv co cfl cfv cfa cfv cM cfa cfv cle wbr cM cN caddc co c2
    cdiv co cfl cfv cM facwordi 3exp cM cN caddc co c2 cdiv co cr wcel cc0 cM
    cN caddc co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cfl cfv cn0 wcel
    cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co flge0nn0 cM cn0 wcel
    cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel cM cN caddc
    co c2 cdiv co cr wcel cM cN nn0addcl cM cN caddc co nn0re cM cN caddc co
    rehalfcl 3syl cM cn0 wcel cN cn0 wcel wa cc0 cM cN caddc co cle wbr cc0 cM
    cN caddc co c2 cdiv co cle wbr cM cn0 wcel cN cn0 wcel wa cM cN caddc co
    cn0 wcel cc0 cM cN caddc co cle wbr cM cN nn0addcl cM cN caddc co nn0ge0
    syl cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr
    wcel cc0 cM cN caddc co cle wbr cc0 cM cN caddc co c2 cdiv co cle wbr wb cM
    cN nn0addcl cM cN caddc co nn0re cM cN caddc co halfnneg2 3syl mpbid sylanc
    cM cn0 wcel cN cn0 wcel pm3.26 sylc cM cn0 wcel cN cn0 wcel wa cM cN caddc
    co c2 cdiv co cfl cfv cfa cfv cM cfa cfv cle wbr cM cfa cfv cM cfa cfv cN
    cfa cfv cmul co cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv cM cfa
    cfv cN cfa cfv cmul co cle wbr cM cn0 wcel cN cn0 wcel wa cM cfa cfv c1
    cmul co cM cfa cfv cM cfa cfv cN cfa cfv cmul co cle cM cn0 wcel cM cfa cfv
    c1 cmul co cM cfa cfv wceq cN cn0 wcel cM cn0 wcel cM cfa cfv cn wcel cM
    cfa cfv cc wcel cM cfa cfv c1 cmul co cM cfa cfv wceq cM faccl cM cfa cfv
    nncn cM cfa cfv ax1id 3syl adantr cN cfa cfv cr wcel cM cfa cfv cr wcel wa
    cc0 cM cfa cfv cle wbr c1 cN cfa cfv cle wbr wa cM cfa cfv c1 cmul co cM
    cfa cfv cN cfa cfv cmul co cle wbr cM cn0 wcel cN cn0 wcel wa c1 cr wcel cN
    cfa cfv cr wcel cM cfa cfv cr wcel cc0 cM cfa cfv cle wbr c1 cN cfa cfv cle
    wbr wa cM cfa cfv c1 cmul co cM cfa cfv cN cfa cfv cmul co cle wbr 1re c1
    cN cfa cfv cM cfa cfv lemul2aOLD mp3anl1 cN cn0 wcel cM cn0 wcel cN cfa cfv
    cr wcel cM cfa cfv cr wcel wa cN cn0 wcel cN cfa cfv cr wcel cM cn0 wcel cM
    cfa cfv cr wcel cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cr wcel cN faccl
    cN cfa cfv nnre syl cM cn0 wcel cM cfa cfv cn wcel cM cfa cfv cr wcel cM
    faccl cM cfa cfv nnre syl anim12i ancoms cM cn0 wcel cc0 cM cfa cfv cle wbr
    cN cn0 wcel c1 cN cfa cfv cle wbr cM cn0 wcel cM cfa cfv cn wcel cM cfa cfv
    cn0 wcel cc0 cM cfa cfv cle wbr cM faccl cM cfa cfv nnnn0 cM cfa cfv nn0ge0
    3syl cN cn0 wcel cN cfa cfv cn wcel c1 cN cfa cfv cle wbr cN faccl cN cfa
    cfv nnge1 syl anim12i sylanc eqbrtrrd cM cN caddc co c2 cdiv co cfl cfv cfa
    cfv cr wcel cM cfa cfv cr wcel cM cfa cfv cN cfa cfv cmul co cr wcel cM cN
    caddc co c2 cdiv co cfl cfv cfa cfv cM cfa cfv cle wbr cM cfa cfv cM cfa
    cfv cN cfa cfv cmul co cle wbr wa cM cN caddc co c2 cdiv co cfl cfv cfa cfv
    cM cfa cfv cN cfa cfv cmul co cle wbr wi cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co c2 cdiv co cfl cfv cfa cfv cM cfa cfv cM cfa cfv cN cfa cfv cmul
    co letr cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co cfl cfv cn0
    wcel cM cN caddc co c2 cdiv co cfl cfv cfa cfv cn wcel cM cN caddc co c2
    cdiv co cfl cfv cfa cfv cr wcel cM cN caddc co c2 cdiv co cr wcel cc0 cM cN
    caddc co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cfl cfv cn0 wcel cM
    cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co flge0nn0 cM cn0 wcel cN
    cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel cM cN caddc co
    c2 cdiv co cr wcel cM cN nn0addcl cM cN caddc co nn0re cM cN caddc co
    rehalfcl 3syl cM cn0 wcel cN cn0 wcel wa cc0 cM cN caddc co cle wbr cc0 cM
    cN caddc co c2 cdiv co cle wbr cM cn0 wcel cN cn0 wcel wa cM cN caddc co
    cn0 wcel cc0 cM cN caddc co cle wbr cM cN nn0addcl cM cN caddc co nn0ge0
    syl cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr
    wcel cc0 cM cN caddc co cle wbr cc0 cM cN caddc co c2 cdiv co cle wbr wb cM
    cN nn0addcl cM cN caddc co nn0re cM cN caddc co halfnneg2 3syl mpbid sylanc
    cM cN caddc co c2 cdiv co cfl cfv faccl cM cN caddc co c2 cdiv co cfl cfv
    cfa cfv nnre 3syl cM cn0 wcel cM cfa cfv cr wcel cN cn0 wcel cM cn0 wcel cM
    cfa cfv cn wcel cM cfa cfv cr wcel cM faccl cM cfa cfv nnre syl adantr cM
    cfa cfv cr wcel cN cfa cfv cr wcel cM cfa cfv cN cfa cfv cmul co cr wcel cM
    cn0 wcel cN cn0 wcel cM cfa cfv cN cfa cfv remulcl cM cn0 wcel cM cfa cfv
    cn wcel cM cfa cfv cr wcel cM faccl cM cfa cfv nnre syl cN cn0 wcel cN cfa
    cfv cn wcel cN cfa cfv cr wcel cN faccl cN cfa cfv nnre syl syl2an syl3anc
    mpan2d 3syld cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co cN cle
    wbr cM cN caddc co c2 cdiv co cfl cfv cN cle wbr cM cN caddc co c2 cdiv co
    cfl cfv cfa cfv cN cfa cfv cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa
    cfv cM cfa cfv cN cfa cfv cmul co cle wbr cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co c2 cdiv co cfl cfv cM cN caddc co c2 cdiv co cle wbr cM cN caddc
    co c2 cdiv co cN cle wbr cM cN caddc co c2 cdiv co cfl cfv cN cle wbr cM
    cn0 wcel cN cn0 wcel wa cM cN caddc co cr wcel cM cN caddc co c2 cdiv co cr
    wcel cM cN caddc co c2 cdiv co cfl cfv cM cN caddc co c2 cdiv co cle wbr cM
    cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel cM
    cN nn0addcl cM cN caddc co nn0re syl cM cN caddc co rehalfcl cM cN caddc co
    c2 cdiv co flle 3syl cM cN caddc co c2 cdiv co cfl cfv cr wcel cM cN caddc
    co c2 cdiv co cr wcel cN cr wcel cM cN caddc co c2 cdiv co cfl cfv cM cN
    caddc co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cN cle wbr wa cM cN
    caddc co c2 cdiv co cfl cfv cN cle wbr wi cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co c2 cdiv co cfl cfv cM cN caddc co c2 cdiv co cN letr cM cn0 wcel
    cN cn0 wcel wa cM cN caddc co cr wcel cM cN caddc co c2 cdiv co cr wcel cM
    cN caddc co c2 cdiv co cfl cfv cr wcel cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co cn0 wcel cM cN caddc co cr wcel cM cN nn0addcl cM cN caddc co
    nn0re syl cM cN caddc co rehalfcl cM cN caddc co c2 cdiv co reflcl 3syl cM
    cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel cM
    cN caddc co c2 cdiv co cr wcel cM cN nn0addcl cM cN caddc co nn0re cM cN
    caddc co rehalfcl 3syl cN cn0 wcel cN cr wcel cM cn0 wcel cN nn0re adantl
    syl3anc mpand cM cN caddc co c2 cdiv co cfl cfv cn0 wcel cN cn0 wcel cM cN
    caddc co c2 cdiv co cfl cfv cN cle wbr cM cN caddc co c2 cdiv co cfl cfv
    cfa cfv cN cfa cfv cle wbr wi cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2
    cdiv co cfl cfv cn0 wcel cN cn0 wcel cM cN caddc co c2 cdiv co cfl cfv cN
    cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv cN cfa cfv cle wbr cM cN
    caddc co c2 cdiv co cfl cfv cN facwordi 3exp cM cN caddc co c2 cdiv co cr
    wcel cc0 cM cN caddc co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cfl
    cfv cn0 wcel cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co flge0nn0
    cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel
    cM cN caddc co c2 cdiv co cr wcel cM cN nn0addcl cM cN caddc co nn0re cM cN
    caddc co rehalfcl 3syl cM cn0 wcel cN cn0 wcel wa cc0 cM cN caddc co cle
    wbr cc0 cM cN caddc co c2 cdiv co cle wbr cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co cn0 wcel cc0 cM cN caddc co cle wbr cM cN nn0addcl cM cN caddc co
    nn0ge0 syl cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc
    co cr wcel cc0 cM cN caddc co cle wbr cc0 cM cN caddc co c2 cdiv co cle wbr
    wb cM cN nn0addcl cM cN caddc co nn0re cM cN caddc co halfnneg2 3syl mpbid
    sylanc cM cn0 wcel cN cn0 wcel pm3.27 sylc cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co c2 cdiv co cfl cfv cfa cfv cN cfa cfv cle wbr cN cfa cfv cM cfa
    cfv cN cfa cfv cmul co cle wbr cM cN caddc co c2 cdiv co cfl cfv cfa cfv cM
    cfa cfv cN cfa cfv cmul co cle wbr cM cn0 wcel cN cn0 wcel wa c1 cN cfa cfv
    cmul co cN cfa cfv cM cfa cfv cN cfa cfv cmul co cle cN cn0 wcel c1 cN cfa
    cfv cmul co cN cfa cfv wceq cM cn0 wcel cN cn0 wcel cN cfa cfv cn wcel cN
    cfa cfv cc wcel c1 cN cfa cfv cmul co cN cfa cfv wceq cN faccl cN cfa cfv
    nncn cN cfa cfv mulid2 3syl adantl cM cfa cfv cr wcel cN cfa cfv cr wcel wa
    cc0 cN cfa cfv cle wbr c1 cM cfa cfv cle wbr wa c1 cN cfa cfv cmul co cM
    cfa cfv cN cfa cfv cmul co cle wbr cM cn0 wcel cN cn0 wcel wa c1 cr wcel cM
    cfa cfv cr wcel cN cfa cfv cr wcel cc0 cN cfa cfv cle wbr c1 cM cfa cfv cle
    wbr wa c1 cN cfa cfv cmul co cM cfa cfv cN cfa cfv cmul co cle wbr 1re c1
    cM cfa cfv cN cfa cfv lemul1aOLD mp3anl1 cM cn0 wcel cM cfa cfv cr wcel cN
    cn0 wcel cN cfa cfv cr wcel cM cn0 wcel cM cfa cfv cn wcel cM cfa cfv cr
    wcel cM faccl cM cfa cfv nnre syl cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv
    cr wcel cN faccl cN cfa cfv nnre syl anim12i cN cn0 wcel cM cn0 wcel cc0 cN
    cfa cfv cle wbr c1 cM cfa cfv cle wbr wa cN cn0 wcel cc0 cN cfa cfv cle wbr
    cM cn0 wcel c1 cM cfa cfv cle wbr cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv
    cn0 wcel cc0 cN cfa cfv cle wbr cN faccl cN cfa cfv nnnn0 cN cfa cfv nn0ge0
    3syl cM cn0 wcel cM cfa cfv cn wcel c1 cM cfa cfv cle wbr cM faccl cM cfa
    cfv nnge1 syl anim12i ancoms sylanc eqbrtrrd cM cN caddc co c2 cdiv co cfl
    cfv cfa cfv cr wcel cN cfa cfv cr wcel cM cfa cfv cN cfa cfv cmul co cr
    wcel cM cN caddc co c2 cdiv co cfl cfv cfa cfv cN cfa cfv cle wbr cN cfa
    cfv cM cfa cfv cN cfa cfv cmul co cle wbr wa cM cN caddc co c2 cdiv co cfl
    cfv cfa cfv cM cfa cfv cN cfa cfv cmul co cle wbr wi cM cn0 wcel cN cn0
    wcel wa cM cN caddc co c2 cdiv co cfl cfv cfa cfv cN cfa cfv cM cfa cfv cN
    cfa cfv cmul co letr cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co
    cfl cfv cn0 wcel cM cN caddc co c2 cdiv co cfl cfv cfa cfv cn wcel cM cN
    caddc co c2 cdiv co cfl cfv cfa cfv cr wcel cM cN caddc co c2 cdiv co cr
    wcel cc0 cM cN caddc co c2 cdiv co cle wbr cM cN caddc co c2 cdiv co cfl
    cfv cn0 wcel cM cn0 wcel cN cn0 wcel wa cM cN caddc co c2 cdiv co flge0nn0
    cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc co cr wcel
    cM cN caddc co c2 cdiv co cr wcel cM cN nn0addcl cM cN caddc co nn0re cM cN
    caddc co rehalfcl 3syl cM cn0 wcel cN cn0 wcel wa cc0 cM cN caddc co cle
    wbr cc0 cM cN caddc co c2 cdiv co cle wbr cM cn0 wcel cN cn0 wcel wa cM cN
    caddc co cn0 wcel cc0 cM cN caddc co cle wbr cM cN nn0addcl cM cN caddc co
    nn0ge0 syl cM cn0 wcel cN cn0 wcel wa cM cN caddc co cn0 wcel cM cN caddc
    co cr wcel cc0 cM cN caddc co cle wbr cc0 cM cN caddc co c2 cdiv co cle wbr
    wb cM cN nn0addcl cM cN caddc co nn0re cM cN caddc co halfnneg2 3syl mpbid
    sylanc cM cN caddc co c2 cdiv co cfl cfv faccl cM cN caddc co c2 cdiv co
    cfl cfv cfa cfv nnre 3syl cN cn0 wcel cN cfa cfv cr wcel cM cn0 wcel cN cn0
    wcel cN cfa cfv cn wcel cN cfa cfv cr wcel cN faccl cN cfa cfv nnre syl
    adantl cM cfa cfv cr wcel cN cfa cfv cr wcel cM cfa cfv cN cfa cfv cmul co
    cr wcel cM cn0 wcel cN cn0 wcel cM cfa cfv cN cfa cfv remulcl cM cn0 wcel
    cM cfa cfv cn wcel cM cfa cfv cr wcel cM faccl cM cfa cfv nnre syl cN cn0
    wcel cN cfa cfv cn wcel cN cfa cfv cr wcel cN faccl cN cfa cfv nnre syl
    syl2an syl3anc mpan2d 3syld jaod mpd $.
    $( [6-Feb-2006] $) $( [9-Dec-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The binomial coefficient operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c _C $. $( Binomial coefficient operation. $)

  $( Extend class notation to include the binomial coefficient operation
     (combinatorial choose operation). $)
  cbc $a class _C $.

  ${
    $d n k m $.
    $( Define the binomial coefficient operation.  In the literature, this
       function is often written as a column vector of the two arguments, or
       with the arguments as subscripts before and after the letter "C".
       ` ( N _C K ) ` is read " ` N ` choose ` K ` ."  Definition of
       binomial coefficient in [Gleason] p. 295.  As suggested by Gleason,
       we define it to be 0 when ` 0 <_ k <_ n ` does not hold. $)
    df-bc $a |- _C = { <. <. n , k >. , m >. | ( ( n e. NN0 /\ k e. ZZ ) /\
                m = if ( ( 0 <_ k /\ k <_ n ) ,
                ( ( ! ` n ) / ( ( ! ` ( n - k ) ) x. ( ! ` k ) ) ) , 0 ) ) } $.
  $}

  ${
    $d n k m N $.  $d n k m K $.
    $( Value of the binomial coefficient, ` N ` choose ` K ` .  Definition
       of binomial coefficient in [Gleason] p. 295.  As suggested by Gleason,
       we define it to be 0 when ` 0 <_ K <_ N ` does not hold.  See ~ bcval2
       for the value in the standard domain. $)
    bcval $p |- ( ( N e. NN0 /\ K e. ZZ ) -> ( N _C K ) = if ( ( 0 <_ K /\
    K <_ N ) , ( ( ! ` N ) / ( ( ! ` ( N - K ) ) x. ( ! ` K ) ) ) , 0 ) ) $=
      vn vk vm cN cK cn0 cz cc0 vk cv cle wbr vk cv vn cv cle wbr wa vn cv cfa
      cfv vn cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cc0 cif cc0
      cK cle wbr cK cN cle wbr wa cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv
      cmul co cdiv co cc0 cif cbc cc0 vk cv cle wbr vk cv cN cle wbr wa cN cfa
      cfv cN vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cc0 cif cc0 cK
      cle wbr cK cN cle wbr wa cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul
      co cdiv co cc0 cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul co cdiv
      oprex cc0 cn0 0nn0 elisseti ifex vn cv cN wceq cc0 vk cv cle wbr vk cv vn
      cv cle wbr wa vn cv cfa cfv vn cv vk cv cmin co cfa cfv vk cv cfa cfv
      cmul co cdiv co cc0 cif cc0 vk cv cle wbr vk cv cN cle wbr wa vn cv cfa
      cfv vn cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cc0 cif cc0
      vk cv cle wbr vk cv cN cle wbr wa cN cfa cfv cN vk cv cmin co cfa cfv vk
      cv cfa cfv cmul co cdiv co cc0 cif vn cv cN wceq cc0 vk cv cle wbr vk cv
      vn cv cle wbr wa cc0 vk cv cle wbr vk cv cN cle wbr wa vn cv cfa cfv vn
      cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cc0 vn cv cN wceq
      vk cv vn cv cle wbr vk cv cN cle wbr cc0 vk cv cle wbr vn cv cN vk cv cle
      breq2 anbi2d ifbid vn cv cN wceq cc0 vk cv cle wbr vk cv cN cle wbr wa vn
      cv cfa cfv vn cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cN
      cfa cfv cN vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cc0 vn cv
      cN wceq vn cv cfa cfv cN cfa cfv vn cv vk cv cmin co cfa cfv vk cv cfa
      cfv cmul co cN vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv vn cv cN
      cfa fveq2 vn cv cN wceq vn cv vk cv cmin co cfa cfv cN vk cv cmin co cfa
      cfv vk cv cfa cfv cmul vn cv cN wceq vn cv vk cv cmin co cN vk cv cmin co
      cfa vn cv cN vk cv cmin opreq1 fveq2d opreq1d opreq12d ifeq1d eqtrd vk cv
      cK wceq cc0 vk cv cle wbr vk cv cN cle wbr wa cN cfa cfv cN vk cv cmin co
      cfa cfv vk cv cfa cfv cmul co cdiv co cc0 cif cc0 cK cle wbr cK cN cle
      wbr wa cN cfa cfv cN vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co
      cc0 cif cc0 cK cle wbr cK cN cle wbr wa cN cfa cfv cN cK cmin co cfa cfv
      cK cfa cfv cmul co cdiv co cc0 cif vk cv cK wceq cc0 vk cv cle wbr vk cv
      cN cle wbr wa cc0 cK cle wbr cK cN cle wbr wa cN cfa cfv cN vk cv cmin co
      cfa cfv vk cv cfa cfv cmul co cdiv co cc0 vk cv cK wceq cc0 vk cv cle wbr
      cc0 cK cle wbr vk cv cN cle wbr cK cN cle wbr vk cv cK cc0 cle breq2 vk
      cv cK cN cle breq1 anbi12d ifbid vk cv cK wceq cc0 cK cle wbr cK cN cle
      wbr wa cN cfa cfv cN vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co
      cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul co cdiv co cc0 vk cv cK
      wceq cN vk cv cmin co cfa cfv vk cv cfa cfv cmul co cN cK cmin co cfa cfv
      cK cfa cfv cmul co cN cfa cfv cdiv vk cv cK wceq cN vk cv cmin co cfa cfv
      cN cK cmin co cfa cfv vk cv cfa cfv cK cfa cfv cmul vk cv cK wceq cN vk
      cv cmin co cN cK cmin co cfa vk cv cK cN cmin opreq2 fveq2d vk cv cK cfa
      fveq2 opreq12d opreq2d ifeq1d eqtrd vk vm vn df-bc oprabval2 $.
      $( [11-Jul-2005] $) $( [10-Jul-2005] $)

    $( Value of the binomial coefficient, ` N ` choose ` K ` , in its standard
       domain. $)
    bcval2 $p |- ( ( N e. NN0 /\ K e. NN0 /\ K <_ N ) -> ( N _C K ) =
                    ( ( ! ` N ) / ( ( ! ` ( N - K ) ) x. ( ! ` K ) ) ) ) $=
      cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr wa cN cK cbc co cN
      cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul co cdiv co wceq cN cn0 wcel
      cK cn0 wcel cK cN cle wbr w3a cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK
      cN cle wbr wa cN cK cbc co cc0 cK cle wbr cK cN cle wbr wa cN cfa cfv cN
      cK cmin co cfa cfv cK cfa cfv cmul co cdiv co cc0 cif cN cfa cfv cN cK
      cmin co cfa cfv cK cfa cfv cmul co cdiv co cK cN bcval cc0 cK cle wbr cK
      cN cle wbr wa cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul co cdiv co
      cc0 iftrue sylan9eq cN cn0 wcel cK cn0 wcel cN cn0 wcel cK cz wcel wa cK
      cN cle wbr cK cn0 wcel cK cz wcel cN cn0 wcel cK nn0z anim2i 3adant3 cK
      cn0 wcel cK cN cle wbr cc0 cK cle wbr cK cN cle wbr wa cN cn0 wcel cK cn0
      wcel cc0 cK cle wbr cK cN cle wbr cK nn0ge0 anim1i 3adant1 sylanc $.
      $( [28-Jul-2008] $) $( [9-Jun-2005] $)

    $( Value of the binomial coefficient, ` N ` choose ` K ` , in its standard
       domain. $)
    bcval3 $p |- ( ( N e. NN0 /\ K e. ( 0 ... N ) ) -> ( N _C K ) =
                    ( ( ! ` N ) / ( ( ! ` ( N - K ) ) x. ( ! ` K ) ) ) ) $=
      cN cn0 wcel cK cn0 wcel cK cN cle wbr cN cK cbc co cN cfa cfv cN cK cmin
      co cfa cfv cK cfa cfv cmul co cdiv co wceq cN cn0 wcel cK cc0 cN cfz co
      wcel wa cK cN bcval2 cn0 cK cN elfz3nn0 cK cc0 cN cfz co wcel cK cn0 wcel
      cN cn0 wcel cK cN elfznn0 adantl cK cc0 cN cfz co wcel cK cN cle wbr cN
      cn0 wcel cK cc0 cN elfzle2 adantl syl3anc $.
      $( [3-Feb-2006] $) $( [3-Jan-2006] $)

    $( Value of the binomial coefficient, ` N ` choose ` K ` , outside of its
       standard domain.  Remark in [Gleason] p. 295. $)
    bcval4 $p |- ( ( N e. NN0 /\ K e. ZZ /\ ( K < 0 \/ N < K ) ) ->
          ( N _C K ) = 0 ) $=
      cN cn0 wcel cK cz wcel cK cc0 clt wbr cN cK clt wbr wo cN cK cbc co cc0
      wceq cN cn0 wcel cK cz wcel wa cK cc0 clt wbr cN cK clt wbr wo cc0 cK cle
      wbr wn cK cN cle wbr wn wo cN cK cbc co cc0 wceq cN cn0 wcel cK cz wcel
      wa cK cc0 clt wbr cN cK clt wbr wo cc0 cK cle wbr wn cK cN cle wbr wn wo
      cN cr wcel cK cr wcel cK cc0 clt wbr cN cK clt wbr wo cc0 cK cle wbr wn
      cK cN cle wbr wn wo wb cN cn0 wcel cK cz wcel cN cr wcel cK cr wcel wa cK
      cc0 clt wbr cc0 cK cle wbr wn cN cK clt wbr cK cN cle wbr wn cK cr wcel
      cK cc0 clt wbr cc0 cK cle wbr wn wb cN cr wcel cK cr wcel cc0 cr wcel cK
      cc0 clt wbr cc0 cK cle wbr wn wb 0re cK cc0 ltnle mpan2 adantl cN cK
      ltnle orbi12d cN nn0re cK zre syl2an biimpa cN cn0 wcel cK cz wcel wa cc0
      cK cle wbr cK cN cle wbr wa wn cN cK cbc co cc0 wceq cc0 cK cle wbr wn cK
      cN cle wbr wn wo cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr
      wa wn cN cK cbc co cc0 cK cle wbr cK cN cle wbr wa cN cfa cfv cN cK cmin
      co cfa cfv cK cfa cfv cmul co cdiv co cc0 cif cc0 cK cN bcval cc0 cK cle
      wbr cK cN cle wbr wa cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul co
      cdiv co cc0 iffalse sylan9eq cc0 cK cle wbr cK cN cle wbr ianor sylan2br
      syldan 3impa $.
      $( [9-Sep-2005] $) $( [14-Jul-2005] $)
  $}

  $( "Complementing" its second argument doesn't change a binary
     coefficient. $)
  bccmpl $p |- ( ( N e. NN0 /\ K e. NN0 /\ K <_ N ) -> ( N _C K ) =
                    ( N _C ( N - K ) ) ) $=
    cN cn0 wcel cK cn0 wcel cK cN cle wbr w3a cN cfa cfv cN cK cmin co cfa cfv
    cK cfa cfv cmul co cdiv co cN cfa cfv cN cN cK cmin co cmin co cfa cfv cN
    cK cmin co cfa cfv cmul co cdiv co cN cK cbc co cN cN cK cmin co cbc co cN
    cn0 wcel cK cn0 wcel cK cN cle wbr w3a cN cK cmin co cfa cfv cK cfa cfv
    cmul co cN cN cK cmin co cmin co cfa cfv cN cK cmin co cfa cfv cmul co cN
    cfa cfv cdiv cN cn0 wcel cK cn0 wcel cK cN cle wbr w3a cN cK cmin co cfa
    cfv cK cfa cfv cmul co cK cfa cfv cN cK cmin co cfa cfv cmul co cN cN cK
    cmin co cmin co cfa cfv cN cK cmin co cfa cfv cmul co cN cK cmin co cfa cfv
    cc wcel cK cfa cfv cc wcel cN cK cmin co cfa cfv cK cfa cfv cmul co cK cfa
    cfv cN cK cmin co cfa cfv cmul co wceq cN cn0 wcel cK cn0 wcel cK cN cle
    wbr w3a cN cK cmin co cfa cfv cK cfa cfv mulcom cN cn0 wcel cK cn0 wcel cK
    cN cle wbr w3a cN cK cmin co cn0 wcel cN cK cmin co cfa cfv cn wcel cN cK
    cmin co cfa cfv cc wcel cN cn0 wcel cK cn0 wcel cK cN cle wbr cN cK cmin co
    cn0 wcel cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb cK
    cN nn0sub ancoms biimp3a cN cK cmin co faccl cN cK cmin co cfa cfv nncn
    3syl cK cn0 wcel cN cn0 wcel cK cfa cfv cc wcel cK cN cle wbr cK cn0 wcel
    cK cfa cfv cn wcel cK cfa cfv cc wcel cK faccl cK cfa cfv nncn syl 3ad2ant2
    sylanc cN cn0 wcel cK cn0 wcel cK cN cle wbr w3a cN cN cK cmin co cmin co
    cfa cfv cK cfa cfv cN cK cmin co cfa cfv cmul cN cn0 wcel cK cn0 wcel cN cN
    cK cmin co cmin co cfa cfv cK cfa cfv wceq cK cN cle wbr cN cn0 wcel cK cn0
    wcel wa cN cN cK cmin co cmin co cK cfa cN cc wcel cK cc wcel cN cN cK cmin
    co cmin co cK wceq cN cn0 wcel cK cn0 wcel cN cK nncan cN nn0cn cK nn0cn
    syl2an fveq2d 3adant3 opreq1d eqtr4d opreq2d cK cN bcval2 cN cn0 wcel cN cK
    cmin co cn0 wcel cN cK cmin co cN cle wbr cN cN cK cmin co cbc co cN cfa
    cfv cN cN cK cmin co cmin co cfa cfv cN cK cmin co cfa cfv cmul co cdiv co
    wceq cN cn0 wcel cK cn0 wcel cK cN cle wbr w3a cN cK cmin co cN bcval2 cN
    cn0 wcel cK cn0 wcel cK cN cle wbr 3simp1 cN cn0 wcel cK cn0 wcel cK cN cle
    wbr cN cK cmin co cn0 wcel cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin
    co cn0 wcel wb cK cN nn0sub ancoms biimp3a cN cn0 wcel cK cn0 wcel cN cK
    cmin co cN cle wbr cK cN cle wbr cN cr wcel cK cn0 wcel cN cK cmin co cN
    cle wbr cN cn0 wcel cN cr wcel cK cn0 wcel wa cN cK cmin co cN cle wbr cN
    cN cK caddc co cle wbr cN cK nn0addge1 cN cr wcel cK cr wcel cN cK cmin co
    cN cle wbr cN cN cK caddc co cle wbr wb cK cn0 wcel cN cr wcel cK cr wcel
    cN cK cmin co cN cle wbr cN cN cK caddc co cle wbr wb cN cK cN lesubadd
    3anidm13 cK nn0re sylan2 mpbird cN nn0re sylan 3adant3 syl3anc 3eqtr4d $.
    $( [9-Jul-2005] $) $( [21-Jun-2005] $)

  $( ` N ` choose 0 is 1.  Remark in [Gleason] p. 296. $)
  bcn0 $p |- ( N e. NN0 -> ( N _C 0 ) = 1 ) $=
    cN cn0 wcel cN cc0 cbc co cN cfa cfv cN cc0 cmin co cfa cfv cc0 cfa cfv
    cmul co cdiv co cN cfa cfv cN cfa cfv cdiv co c1 cN cn0 wcel cc0 cN cle wbr
    cN cc0 cbc co cN cfa cfv cN cc0 cmin co cfa cfv cc0 cfa cfv cmul co cdiv co
    wceq cN nn0ge0 cN cn0 wcel cc0 cn0 wcel cc0 cN cle wbr cN cc0 cbc co cN cfa
    cfv cN cc0 cmin co cfa cfv cc0 cfa cfv cmul co cdiv co wceq 0nn0 cc0 cN
    bcval2 mp3an2 mpdan cN cn0 wcel cN cc0 cmin co cfa cfv cc0 cfa cfv cmul co
    cN cfa cfv cN cfa cfv cdiv cN cn0 wcel cN cc0 cmin co cfa cfv cc0 cfa cfv
    cmul co cN cfa cfv c1 cmul co cN cfa cfv cN cn0 wcel cN cc0 cmin co cfa cfv
    cN cfa cfv cc0 cfa cfv c1 cmul cN cn0 wcel cN cc0 cmin co cN cfa cN cn0
    wcel cN cc wcel cN cc0 cmin co cN wceq cN nn0cn cN subid1 syl fveq2d cc0
    cfa cfv c1 wceq cN cn0 wcel fac0 a1i opreq12d cN cn0 wcel cN cfa cfv cc
    wcel cN cfa cfv c1 cmul co cN cfa cfv wceq cN cn0 wcel cN cfa cfv cn wcel
    cN cfa cfv cc wcel cN faccl cN cfa cfv nncn syl cN cfa cfv ax1id syl eqtrd
    opreq2d cN cfa cfv cc wcel cN cfa cfv cc0 wne cN cfa cfv cN cfa cfv cdiv co
    c1 wceq cN cn0 wcel cN cfa cfv divid cN cn0 wcel cN cfa cfv cn wcel cN cfa
    cfv cc wcel cN faccl cN cfa cfv nncn syl cN facne0 sylanc 3eqtrd $.
    $( [18-Jun-2005] $) $( [17-Jun-2005] $)

  $( ` N ` choose ` N ` is 1.  Remark in [Gleason] p. 296. $)
  bcnn $p |- ( N e. NN0 -> ( N _C N ) = 1 ) $=
    cN cn0 wcel cN cc0 cbc co cN cN cc0 cmin co cbc co c1 cN cN cbc co cN cn0
    wcel cc0 cN cle wbr cN cc0 cbc co cN cN cc0 cmin co cbc co wceq cN nn0ge0
    cN cn0 wcel cc0 cn0 wcel cc0 cN cle wbr cN cc0 cbc co cN cN cc0 cmin co cbc
    co wceq 0nn0 cc0 cN bccmpl mp3an2 mpdan cN bcn0 cN cn0 wcel cN cc0 cmin co
    cN cN cbc cN cn0 wcel cN cc wcel cN cc0 cmin co cN wceq cN nn0cn cN subid1
    syl opreq2d 3eqtr3rd $.
    $( [2-Aug-2005] $) $( [17-Jun-2005] $)

  $( Binomial coefficient: ` N + 1 ` choose ` 1 ` . $)
  bcnp11 $p |- ( N e. NN0 -> ( ( N + 1 ) _C 1 ) = ( N + 1 ) ) $=
    cN cn0 wcel cN c1 caddc co c1 cbc co cN c1 caddc co cfa cfv cN c1 caddc co
    c1 cmin co cfa cfv c1 cfa cfv cmul co cdiv co cN c1 caddc co cfa cfv cN cfa
    cfv cdiv co cN c1 caddc co cN c1 caddc co cn0 wcel c1 cN c1 caddc co cle
    wbr cN c1 caddc co c1 cbc co cN c1 caddc co cfa cfv cN c1 caddc co c1 cmin
    co cfa cfv c1 cfa cfv cmul co cdiv co wceq cN cn0 wcel cN c1 caddc co cn0
    wcel c1 cn0 wcel c1 cN c1 caddc co cle wbr cN c1 caddc co c1 cbc co cN c1
    caddc co cfa cfv cN c1 caddc co c1 cmin co cfa cfv c1 cfa cfv cmul co cdiv
    co wceq 1nn0 c1 cN c1 caddc co bcval2 mp3an2 cN peano2nn0 c1 cr wcel cN cn0
    wcel c1 cN c1 caddc co cle wbr 1re c1 cN nn0addge2 mpan sylanc cN cn0 wcel
    cN c1 caddc co c1 cmin co cfa cfv c1 cfa cfv cmul co cN cfa cfv cN c1 caddc
    co cfa cfv cdiv cN cn0 wcel cN c1 caddc co c1 cmin co cfa cfv c1 cfa cfv
    cmul co cN cfa cfv c1 cmul co cN cfa cfv cN cn0 wcel cN c1 caddc co c1 cmin
    co cfa cfv cN cfa cfv c1 cfa cfv c1 cmul cN cn0 wcel cN c1 caddc co c1 cmin
    co cN cfa cN cc wcel c1 cc wcel cN c1 caddc co c1 cmin co cN wceq cN cn0
    wcel cN c1 pncan cN nn0cn ax1cn sylancl fveq2d c1 cfa cfv c1 wceq cN cn0
    wcel fac1 a1i opreq12d cN cn0 wcel cN cfa cfv cc wcel cN cfa cfv c1 cmul co
    cN cfa cfv wceq cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cc wcel cN faccl
    cN cfa cfv nncn syl cN cfa cfv ax1id syl eqtrd opreq2d cN cn0 wcel cN c1
    caddc co cfa cfv cN cfa cfv cdiv co cN c1 caddc co wceq cN cfa cfv cN c1
    caddc co cmul co cN c1 caddc co cfa cfv wceq cN cn0 wcel cN c1 caddc co cfa
    cfv cN cfa cfv cN c1 caddc co cmul co cN facp1 eqcomd cN c1 caddc co cfa
    cfv cc wcel cN c1 caddc co cc wcel cN cfa cfv cc wcel cN cfa cfv cc0 wne wa
    cN c1 caddc co cfa cfv cN cfa cfv cdiv co cN c1 caddc co wceq cN cfa cfv cN
    c1 caddc co cmul co cN c1 caddc co cfa cfv wceq wb cN cn0 wcel cN c1 caddc
    co cfa cfv cN c1 caddc co cN cfa cfv divmul cN cn0 wcel cN c1 caddc co cfa
    cfv cn wcel cN c1 caddc co cfa cfv cc wcel cN cn0 wcel cN c1 caddc co cn0
    wcel cN c1 caddc co cfa cfv cn wcel cN peano2nn0 cN c1 caddc co faccl syl
    cN c1 caddc co cfa cfv nncn syl cN cn0 wcel cN c1 caddc co cn0 wcel cN c1
    caddc co cc wcel cN peano2nn0 cN c1 caddc co nn0cn syl cN cn0 wcel cN cfa
    cfv cc wcel cN cfa cfv cc0 wne cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cc
    wcel cN faccl cN cfa cfv nncn syl cN facne0 jca syl3anc mpbird 3eqtrd $.
    $( [8-Aug-2005] $) $( [21-Jun-2005] $)

  $( Binomial coefficient: ` N + 1 ` choose ` N ` . $)
  bcnp1n $p |- ( N e. NN0 -> ( ( N + 1 ) _C N ) = ( N + 1 ) ) $=
    cN cn0 wcel cN c1 caddc co c1 cbc co cN c1 caddc co cN c1 caddc co c1 cmin
    co cbc co cN c1 caddc co cN c1 caddc co cN cbc co cN c1 caddc co cn0 wcel
    c1 cN c1 caddc co cle wbr cN c1 caddc co c1 cbc co cN c1 caddc co cN c1
    caddc co c1 cmin co cbc co wceq cN cn0 wcel cN c1 caddc co cn0 wcel c1 cn0
    wcel c1 cN c1 caddc co cle wbr cN c1 caddc co c1 cbc co cN c1 caddc co cN
    c1 caddc co c1 cmin co cbc co wceq 1nn0 c1 cN c1 caddc co bccmpl mp3an2 cN
    peano2nn0 c1 cr wcel cN cn0 wcel c1 cN c1 caddc co cle wbr 1re c1 cN
    nn0addge2 mpan sylanc cN bcnp11 cN cn0 wcel cN c1 caddc co c1 cmin co cN cN
    c1 caddc co cbc cN cc wcel c1 cc wcel cN c1 caddc co c1 cmin co cN wceq cN
    cn0 wcel cN c1 pncan cN nn0cn ax1cn sylancl opreq2d 3eqtr3rd $.
    $( [25-Nov-2005] $) $( [20-Jun-2005] $)

  ${
    bcpasc2.1 $e |- N e. NN $.
    bcpasc2.2 $e |- K e. NN $.
    bcpasc2.3 $e |- K <_ N $.
    $( Pascal's rule for the binomial coefficient.  Equation 2 of [Gleason]
       p. 295. $)
    bcpasc2i $p |- ( ( N _C K ) + ( N _C ( K - 1 ) ) ) = ( ( N + 1 ) _C K ) $=
      cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cdiv co c1
      cK cdiv co cmul co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv
      cmul co cdiv co c1 cN cK cmin co c1 caddc co cdiv co cmul co caddc co cN
      c1 caddc co cfa cfv cN c1 caddc co cK cmin co cfa cfv cK cfa cfv cmul co
      cdiv co cN cK cbc co cN cK c1 cmin co cbc co caddc co cN c1 caddc co cK
      cbc co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co
      cdiv co c1 cK cdiv co c1 cN cK cmin co c1 caddc co cdiv co caddc co cmul
      co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cdiv co
      cN c1 caddc co cK cN cK cmin co c1 caddc co cmul co cdiv co cmul co cN
      cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cdiv co c1 cK
      cdiv co cmul co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv
      cmul co cdiv co c1 cN cK cmin co c1 caddc co cdiv co cmul co caddc co cN
      c1 caddc co cfa cfv cN c1 caddc co cK cmin co cfa cfv cK cfa cfv cmul co
      cdiv co c1 cK cdiv co c1 cN cK cmin co c1 caddc co cdiv co caddc co cN c1
      caddc co cK cN cK cmin co c1 caddc co cmul co cdiv co cN cfa cfv cK c1
      cmin co cfa cfv cN cK cmin co cfa cfv cmul co cdiv co cmul c1 cK cdiv co
      c1 cN cK cmin co c1 caddc co cdiv co caddc co c1 cN cK cmin co c1 caddc
      co cmul co cK c1 cmul co caddc co cK cN cK cmin co c1 caddc co cmul co
      cdiv co cN c1 caddc co cK cN cK cmin co c1 caddc co cmul co cdiv co c1 cK
      c1 cN cK cmin co c1 caddc co ax1cn cK bcpasc2.2 nncni ax1cn cN cK cmin co
      c1 cN cK cN bcpasc2.1 nncni cK bcpasc2.2 nncni subcli ax1cn addcli cK
      bcpasc2.2 nnne0i cN cK cmin co c1 caddc co cN cK cmin co cn0 wcel cN cK
      cmin co c1 caddc co cn wcel cK cN cle wbr cN cK cmin co cn0 wcel
      bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb
      cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK
      cmin co nn0p1nn ax-mp nnne0i divadddivi c1 cN cK cmin co c1 caddc co cmul
      co cK c1 cmul co caddc co cN c1 caddc co cK cN cK cmin co c1 caddc co
      cmul co cdiv c1 cN cK cmin co c1 caddc co cmul co cK c1 cmul co caddc co
      cN cK cmin co c1 caddc co cK caddc co cN cK cmin co cK caddc co c1 caddc
      co cN c1 caddc co c1 cN cK cmin co c1 caddc co cmul co cN cK cmin co c1
      caddc co cK c1 cmul co cK caddc cN cK cmin co c1 caddc co cN cK cmin co
      c1 cN cK cN bcpasc2.1 nncni cK bcpasc2.2 nncni subcli ax1cn addcli
      mulid2i cK cK bcpasc2.2 nncni mulid1i opreq12i cN cK cmin co c1 cK cN cK
      cN bcpasc2.1 nncni cK bcpasc2.2 nncni subcli ax1cn cK bcpasc2.2 nncni
      add23i cN cK cmin co cK caddc co cN c1 caddc cN cc wcel cK cc wcel cN cK
      cmin co cK caddc co cN wceq cN bcpasc2.1 nncni cK bcpasc2.2 nncni cN cK
      npcan mp2an opreq1i 3eqtri opreq1i eqtri opreq2i cN cfa cfv cK c1 cmin co
      cfa cfv cN cK cmin co cfa cfv cmul co cdiv co c1 cK cdiv co c1 cN cK cmin
      co c1 caddc co cdiv co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa
      cfv cmul co cN cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN bcpasc2.1 nnnn0i
      cN faccl ax-mp nncni cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co
      cK c1 cmin co cfa cfv cn wcel cN cK cmin co cfa cfv cn wcel cK c1 cmin co
      cfa cfv cN cK cmin co cfa cfv cmul co cn wcel cK c1 cmin co cn0 wcel cK
      c1 cmin co cfa cfv cn wcel c1 cK cle wbr cK c1 cmin co cn0 wcel cK cn
      wcel c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK
      cle wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub
      mp2an mpbi cK c1 cmin co faccl ax-mp cN cK cmin co cn0 wcel cN cK cmin co
      cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0 wcel bcpasc2.3 cK cn0
      wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb cK bcpasc2.2
      nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK cmin co faccl
      ax-mp cK c1 cmin co cfa cfv cN cK cmin co cfa cfv nnmulcl mp2an nncni cK
      c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cK c1 cmin co cfa cfv cn
      wcel cN cK cmin co cfa cfv cn wcel cK c1 cmin co cfa cfv cN cK cmin co
      cfa cfv cmul co cn wcel cK c1 cmin co cn0 wcel cK c1 cmin co cfa cfv cn
      wcel c1 cK cle wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK cle wbr
      bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK c1 cmin
      co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi cK c1
      cmin co faccl ax-mp cN cK cmin co cn0 wcel cN cK cmin co cfa cfv cn wcel
      cK cN cle wbr cN cK cmin co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK
      cN cle wbr cN cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1
      nnnn0i cK cN nn0sub mp2an mpbi cN cK cmin co faccl ax-mp cK c1 cmin co
      cfa cfv cN cK cmin co cfa cfv nnmulcl mp2an nnne0i divcli cK cK bcpasc2.2
      nncni cK bcpasc2.2 nnne0i reccli cN cK cmin co c1 caddc co cN cK cmin co
      c1 cN cK cN bcpasc2.1 nncni cK bcpasc2.2 nncni subcli ax1cn addcli cN cK
      cmin co c1 caddc co cN cK cmin co cn0 wcel cN cK cmin co c1 caddc co cn
      wcel cK cN cle wbr cN cK cmin co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0
      wcel cK cN cle wbr cN cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN
      bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK cmin co nn0p1nn ax-mp
      nnne0i reccli adddii cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa
      cfv cmul co cdiv co cN c1 caddc co cK cN cK cmin co c1 caddc co cmul co
      cdiv co cmul co cN cfa cfv cN c1 caddc co cmul co cK c1 cmin co cfa cfv
      cN cK cmin co cfa cfv cmul co cK cN cK cmin co c1 caddc co cmul co cmul
      co cdiv co cN c1 caddc co cfa cfv cN c1 caddc co cK cmin co cfa cfv cK
      cfa cfv cmul co cdiv co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co
      cfa cfv cmul co cN c1 caddc co cK cN cK cmin co c1 caddc co cmul co cN
      cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN bcpasc2.1 nnnn0i cN faccl ax-mp
      nncni cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cK c1 cmin co
      cfa cfv cn wcel cN cK cmin co cfa cfv cn wcel cK c1 cmin co cfa cfv cN cK
      cmin co cfa cfv cmul co cn wcel cK c1 cmin co cn0 wcel cK c1 cmin co cfa
      cfv cn wcel c1 cK cle wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK cle wbr
      bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK c1 cmin
      co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi cK c1
      cmin co faccl ax-mp cN cK cmin co cn0 wcel cN cK cmin co cfa cfv cn wcel
      cK cN cle wbr cN cK cmin co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK
      cN cle wbr cN cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1
      nnnn0i cK cN nn0sub mp2an mpbi cN cK cmin co faccl ax-mp cK c1 cmin co
      cfa cfv cN cK cmin co cfa cfv nnmulcl mp2an nncni cN c1 caddc co cN c1 cN
      bcpasc2.1 nnnn0i 1nn0 nn0addcli nn0cni cK cN cK cmin co c1 caddc co cK
      bcpasc2.2 nncni cN cK cmin co c1 cN cK cN bcpasc2.1 nncni cK bcpasc2.2
      nncni subcli ax1cn addcli mulcli cK c1 cmin co cfa cfv cN cK cmin co cfa
      cfv cmul co cK c1 cmin co cfa cfv cn wcel cN cK cmin co cfa cfv cn wcel
      cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cn wcel cK c1 cmin co
      cn0 wcel cK c1 cmin co cfa cfv cn wcel c1 cK cle wbr cK c1 cmin co cn0
      wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0
      wcel c1 cK cle wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1
      cK nn0sub mp2an mpbi cK c1 cmin co faccl ax-mp cN cK cmin co cn0 wcel cN
      cK cmin co cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0 wcel bcpasc2.3
      cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb cK
      bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK cmin
      co faccl ax-mp cK c1 cmin co cfa cfv cN cK cmin co cfa cfv nnmulcl mp2an
      nnne0i cK cN cK cmin co c1 caddc co cK bcpasc2.2 nncni cN cK cmin co c1
      cN cK cN bcpasc2.1 nncni cK bcpasc2.2 nncni subcli ax1cn addcli cK
      bcpasc2.2 nnne0i cN cK cmin co c1 caddc co cN cK cmin co cn0 wcel cN cK
      cmin co c1 caddc co cn wcel cK cN cle wbr cN cK cmin co cn0 wcel
      bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb
      cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK
      cmin co nn0p1nn ax-mp nnne0i muln0i divmuldivi cN c1 caddc co cfa cfv cN
      cfa cfv cN c1 caddc co cmul co cN c1 caddc co cK cmin co cfa cfv cK cfa
      cfv cmul co cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cK cN cK
      cmin co c1 caddc co cmul co cmul co cdiv cN cn0 wcel cN c1 caddc co cfa
      cfv cN cfa cfv cN c1 caddc co cmul co wceq cN bcpasc2.1 nnnn0i cN facp1
      ax-mp cN c1 caddc co cK cmin co cfa cfv cK cfa cfv cmul co cK cfa cfv cN
      c1 caddc co cK cmin co cfa cfv cmul co cK c1 cmin co cfa cfv cK cmul co
      cN cK cmin co cfa cfv cN cK cmin co c1 caddc co cmul co cmul co cK c1
      cmin co cfa cfv cN cK cmin co cfa cfv cmul co cK cN cK cmin co c1 caddc
      co cmul co cmul co cN c1 caddc co cK cmin co cfa cfv cK cfa cfv cN c1
      caddc co cK cmin co cfa cfv cN c1 caddc co cK cmin co cn0 wcel cN c1
      caddc co cK cmin co cfa cfv cn wcel cK cN c1 caddc co cle wbr cN c1 caddc
      co cK cmin co cn0 wcel cK cN c1 caddc co cK bcpasc2.2 nnrei cN c1 caddc
      co cN c1 cN bcpasc2.1 nnnn0i 1nn0 nn0addcli nn0rei cK cN cle wbr cK cN c1
      caddc co clt wbr bcpasc2.3 cK cn wcel cN cn wcel cK cN cle wbr cK cN c1
      caddc co clt wbr wb bcpasc2.2 bcpasc2.1 cK cN nnleltp1 mp2an mpbi ltleii
      cK cn0 wcel cN c1 caddc co cn0 wcel cK cN c1 caddc co cle wbr cN c1 caddc
      co cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN c1 cN bcpasc2.1 nnnn0i
      1nn0 nn0addcli cK cN c1 caddc co nn0sub mp2an mpbi cN c1 caddc co cK cmin
      co faccl ax-mp nncni cK cfa cfv cK cn0 wcel cK cfa cfv cn wcel cK
      bcpasc2.2 nnnn0i cK faccl ax-mp nncni mulcomi cK cfa cfv cK c1 cmin co
      cfa cfv cK cmul co cN c1 caddc co cK cmin co cfa cfv cN cK cmin co cfa
      cfv cN cK cmin co c1 caddc co cmul co cmul cK cn wcel cK cfa cfv cK c1
      cmin co cfa cfv cK cmul co wceq bcpasc2.2 cK facnn2 ax-mp cN c1 caddc co
      cK cmin co cfa cfv cN cK cmin co c1 caddc co cfa cfv cN cK cmin co cfa
      cfv cN cK cmin co c1 caddc co cmul co cN c1 caddc co cK cmin co cN cK
      cmin co c1 caddc co cfa cN c1 cK cN bcpasc2.1 nncni ax1cn cK bcpasc2.2
      nncni addsubi fveq2i cN cK cmin co cn0 wcel cN cK cmin co c1 caddc co cfa
      cfv cN cK cmin co cfa cfv cN cK cmin co c1 caddc co cmul co wceq cK cN
      cle wbr cN cK cmin co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN
      cle wbr cN cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i
      cK cN nn0sub mp2an mpbi cN cK cmin co facp1 ax-mp eqtri opreq12i cK c1
      cmin co cfa cfv cK cN cK cmin co cfa cfv cN cK cmin co c1 caddc co cK c1
      cmin co cfa cfv cK c1 cmin co cn0 wcel cK c1 cmin co cfa cfv cn wcel c1
      cK cle wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK
      nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel
      wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi cK c1 cmin co faccl
      ax-mp nncni cK bcpasc2.2 nncni cN cK cmin co cfa cfv cN cK cmin co cn0
      wcel cN cK cmin co cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0 wcel
      bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb
      cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK
      cmin co faccl ax-mp nncni cN cK cmin co c1 cN cK cN bcpasc2.1 nncni cK
      bcpasc2.2 nncni subcli ax1cn addcli mul4i 3eqtri opreq12i eqtr4i 3eqtr3i
      cN cK cbc co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul
      co cdiv co c1 cK cdiv co cmul co cN cK c1 cmin co cbc co cN cfa cfv cK c1
      cmin co cfa cfv cN cK cmin co cfa cfv cmul co cdiv co c1 cN cK cmin co c1
      caddc co cdiv co cmul co caddc cN cfa cfv c1 cmul co cK c1 cmin co cfa
      cfv cN cK cmin co cfa cfv cmul co cK cmul co cdiv co cN cfa cfv cN cK
      cmin co cfa cfv cK cfa cfv cmul co cdiv co cN cfa cfv cK c1 cmin co cfa
      cfv cN cK cmin co cfa cfv cmul co cdiv co c1 cK cdiv co cmul co cN cK cbc
      co cN cfa cfv c1 cmul co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co
      cfa cfv cmul co cK cmul co cN cK cmin co cfa cfv cK cfa cfv cmul co cdiv
      cN cfa cfv cN cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN bcpasc2.1 nnnn0i
      cN faccl ax-mp nncni mulid1i cK c1 cmin co cfa cfv cN cK cmin co cfa cfv
      cmul co cK cmul co cK c1 cmin co cfa cfv cK cmul co cN cK cmin co cfa cfv
      cmul co cK cfa cfv cN cK cmin co cfa cfv cmul co cN cK cmin co cfa cfv cK
      cfa cfv cmul co cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cK cK c1 cmin
      co cfa cfv cK c1 cmin co cn0 wcel cK c1 cmin co cfa cfv cn wcel c1 cK cle
      wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK nnge1
      ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel wb
      1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi cK c1 cmin co faccl
      ax-mp nncni cN cK cmin co cfa cfv cN cK cmin co cn0 wcel cN cK cmin co
      cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0 wcel bcpasc2.3 cK cn0
      wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb cK bcpasc2.2
      nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK cmin co faccl
      ax-mp nncni cK bcpasc2.2 nncni mul23i cK cfa cfv cK c1 cmin co cfa cfv cK
      cmul co cN cK cmin co cfa cfv cmul cK cn wcel cK cfa cfv cK c1 cmin co
      cfa cfv cK cmul co wceq bcpasc2.2 cK facnn2 ax-mp opreq1i cK cfa cfv cN
      cK cmin co cfa cfv cK cfa cfv cK cn0 wcel cK cfa cfv cn wcel cK bcpasc2.2
      nnnn0i cK faccl ax-mp nncni cN cK cmin co cfa cfv cN cK cmin co cn0 wcel
      cN cK cmin co cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0 wcel
      bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb
      cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK
      cmin co faccl ax-mp nncni mulcomi 3eqtr2i opreq12i cN cfa cfv cK c1 cmin
      co cfa cfv cN cK cmin co cfa cfv cmul co c1 cK cN cfa cfv cN cn0 wcel cN
      cfa cfv cn wcel cN bcpasc2.1 nnnn0i cN faccl ax-mp nncni cK c1 cmin co
      cfa cfv cN cK cmin co cfa cfv cmul co cK c1 cmin co cfa cfv cn wcel cN cK
      cmin co cfa cfv cn wcel cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul
      co cn wcel cK c1 cmin co cn0 wcel cK c1 cmin co cfa cfv cn wcel c1 cK cle
      wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK nnge1
      ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel wb
      1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi cK c1 cmin co faccl
      ax-mp cN cK cmin co cn0 wcel cN cK cmin co cfa cfv cn wcel cK cN cle wbr
      cN cK cmin co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN
      cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN
      nn0sub mp2an mpbi cN cK cmin co faccl ax-mp cK c1 cmin co cfa cfv cN cK
      cmin co cfa cfv nnmulcl mp2an nncni ax1cn cK bcpasc2.2 nncni cK c1 cmin
      co cfa cfv cN cK cmin co cfa cfv cmul co cK c1 cmin co cfa cfv cn wcel cN
      cK cmin co cfa cfv cn wcel cK c1 cmin co cfa cfv cN cK cmin co cfa cfv
      cmul co cn wcel cK c1 cmin co cn0 wcel cK c1 cmin co cfa cfv cn wcel c1
      cK cle wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK
      nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel
      wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi cK c1 cmin co faccl
      ax-mp cN cK cmin co cn0 wcel cN cK cmin co cfa cfv cn wcel cK cN cle wbr
      cN cK cmin co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN
      cK cmin co cn0 wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN
      nn0sub mp2an mpbi cN cK cmin co faccl ax-mp cK c1 cmin co cfa cfv cN cK
      cmin co cfa cfv nnmulcl mp2an nnne0i cK bcpasc2.2 nnne0i divmuldivi cN
      cn0 wcel cK cn0 wcel cK cN cle wbr cN cK cbc co cN cfa cfv cN cK cmin co
      cfa cfv cK cfa cfv cmul co cdiv co wceq cN bcpasc2.1 nnnn0i cK bcpasc2.2
      nnnn0i bcpasc2.3 cK cN bcval2 mp3an 3eqtr4ri cN cfa cfv c1 cmul co cK c1
      cmin co cfa cfv cN cK cmin co cfa cfv cmul co cN cK cmin co c1 caddc co
      cmul co cdiv co cN cfa cfv cN cK c1 cmin co cmin co cfa cfv cK c1 cmin co
      cfa cfv cmul co cdiv co cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co
      cfa cfv cmul co cdiv co c1 cN cK cmin co c1 caddc co cdiv co cmul co cN
      cK c1 cmin co cbc co cN cfa cfv c1 cmul co cN cfa cfv cK c1 cmin co cfa
      cfv cN cK cmin co cfa cfv cmul co cN cK cmin co c1 caddc co cmul co cN cK
      c1 cmin co cmin co cfa cfv cK c1 cmin co cfa cfv cmul co cdiv cN cfa cfv
      cN cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN bcpasc2.1 nnnn0i cN faccl
      ax-mp nncni mulid1i cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co
      cN cK cmin co c1 caddc co cmul co cK c1 cmin co cfa cfv cN cK cmin co cfa
      cfv cN cK cmin co c1 caddc co cmul co cmul co cK c1 cmin co cfa cfv cN cK
      c1 cmin co cmin co cfa cfv cmul co cN cK c1 cmin co cmin co cfa cfv cK c1
      cmin co cfa cfv cmul co cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cN cK
      cmin co c1 caddc co cK c1 cmin co cfa cfv cK c1 cmin co cn0 wcel cK c1
      cmin co cfa cfv cn wcel c1 cK cle wbr cK c1 cmin co cn0 wcel cK cn wcel
      c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle
      wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an
      mpbi cK c1 cmin co faccl ax-mp nncni cN cK cmin co cfa cfv cN cK cmin co
      cn0 wcel cN cK cmin co cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0
      wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0
      wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi
      cN cK cmin co faccl ax-mp nncni cN cK cmin co c1 cN cK cN bcpasc2.1 nncni
      cK bcpasc2.2 nncni subcli ax1cn addcli mulassi cN cK cmin co cfa cfv cN
      cK cmin co c1 caddc co cmul co cN cK c1 cmin co cmin co cfa cfv cK c1
      cmin co cfa cfv cmul cN cK c1 cmin co cmin co cfa cfv cN cK cmin co c1
      caddc co cfa cfv cN cK cmin co cfa cfv cN cK cmin co c1 caddc co cmul co
      cN cK c1 cmin co cmin co cN cK cmin co c1 caddc co cfa cN cc wcel cK cc
      wcel c1 cc wcel cN cK c1 cmin co cmin co cN cK cmin co c1 caddc co wceq
      cN bcpasc2.1 nncni cK bcpasc2.2 nncni ax1cn cN cK c1 subsub mp3an fveq2i
      cN cK cmin co cn0 wcel cN cK cmin co c1 caddc co cfa cfv cN cK cmin co
      cfa cfv cN cK cmin co c1 caddc co cmul co wceq cK cN cle wbr cN cK cmin
      co cn0 wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co
      cn0 wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an
      mpbi cN cK cmin co facp1 ax-mp eqtr2i opreq2i cK c1 cmin co cfa cfv cN cK
      c1 cmin co cmin co cfa cfv cK c1 cmin co cfa cfv cK c1 cmin co cn0 wcel
      cK c1 cmin co cfa cfv cn wcel c1 cK cle wbr cK c1 cmin co cn0 wcel cK cn
      wcel c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK
      cle wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub
      mp2an mpbi cK c1 cmin co faccl ax-mp nncni cN cK c1 cmin co cmin co cfa
      cfv cN cK c1 cmin co cmin co cn0 wcel cN cK c1 cmin co cmin co cfa cfv cn
      wcel cK c1 cmin co cN cle wbr cN cK c1 cmin co cmin co cn0 wcel cK c1
      cmin co cN cle wbr cK cN c1 caddc co cle wbr cK cN c1 caddc co cK
      bcpasc2.2 nnrei cN c1 caddc co cN c1 cN bcpasc2.1 nnnn0i 1nn0 nn0addcli
      nn0rei cK cN cle wbr cK cN c1 caddc co clt wbr bcpasc2.3 cK cn wcel cN cn
      wcel cK cN cle wbr cK cN c1 caddc co clt wbr wb bcpasc2.2 bcpasc2.1 cK cN
      nnleltp1 mp2an mpbi ltleii cK c1 cN cK bcpasc2.2 nnrei 1re cN bcpasc2.1
      nnrei lesubaddi mpbir cK c1 cmin co cn0 wcel cN cn0 wcel cK c1 cmin co cN
      cle wbr cN cK c1 cmin co cmin co cn0 wcel wb c1 cK cle wbr cK c1 cmin co
      cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK
      cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i
      c1 cK nn0sub mp2an mpbi cN bcpasc2.1 nnnn0i cK c1 cmin co cN nn0sub mp2an
      mpbi cN cK c1 cmin co cmin co faccl ax-mp nncni mulcomi 3eqtri opreq12i
      cN cfa cfv cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co c1 cN cK
      cmin co c1 caddc co cN cfa cfv cN cn0 wcel cN cfa cfv cn wcel cN
      bcpasc2.1 nnnn0i cN faccl ax-mp nncni cK c1 cmin co cfa cfv cN cK cmin co
      cfa cfv cmul co cK c1 cmin co cfa cfv cn wcel cN cK cmin co cfa cfv cn
      wcel cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cn wcel cK c1
      cmin co cn0 wcel cK c1 cmin co cfa cfv cn wcel c1 cK cle wbr cK c1 cmin
      co cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel
      cK cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2
      nnnn0i c1 cK nn0sub mp2an mpbi cK c1 cmin co faccl ax-mp cN cK cmin co
      cn0 wcel cN cK cmin co cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0
      wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0
      wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi
      cN cK cmin co faccl ax-mp cK c1 cmin co cfa cfv cN cK cmin co cfa cfv
      nnmulcl mp2an nncni ax1cn cN cK cmin co c1 cN cK cN bcpasc2.1 nncni cK
      bcpasc2.2 nncni subcli ax1cn addcli cK c1 cmin co cfa cfv cN cK cmin co
      cfa cfv cmul co cK c1 cmin co cfa cfv cn wcel cN cK cmin co cfa cfv cn
      wcel cK c1 cmin co cfa cfv cN cK cmin co cfa cfv cmul co cn wcel cK c1
      cmin co cn0 wcel cK c1 cmin co cfa cfv cn wcel c1 cK cle wbr cK c1 cmin
      co cn0 wcel cK cn wcel c1 cK cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel
      cK cn0 wcel c1 cK cle wbr cK c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2
      nnnn0i c1 cK nn0sub mp2an mpbi cK c1 cmin co faccl ax-mp cN cK cmin co
      cn0 wcel cN cK cmin co cfa cfv cn wcel cK cN cle wbr cN cK cmin co cn0
      wcel bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0
      wcel wb cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi
      cN cK cmin co faccl ax-mp cK c1 cmin co cfa cfv cN cK cmin co cfa cfv
      nnmulcl mp2an nnne0i cN cK cmin co c1 caddc co cN cK cmin co cn0 wcel cN
      cK cmin co c1 caddc co cn wcel cK cN cle wbr cN cK cmin co cn0 wcel
      bcpasc2.3 cK cn0 wcel cN cn0 wcel cK cN cle wbr cN cK cmin co cn0 wcel wb
      cK bcpasc2.2 nnnn0i cN bcpasc2.1 nnnn0i cK cN nn0sub mp2an mpbi cN cK
      cmin co nn0p1nn ax-mp nnne0i divmuldivi cN cn0 wcel cK c1 cmin co cn0
      wcel cK c1 cmin co cN cle wbr cN cK c1 cmin co cbc co cN cfa cfv cN cK c1
      cmin co cmin co cfa cfv cK c1 cmin co cfa cfv cmul co cdiv co wceq cN
      bcpasc2.1 nnnn0i c1 cK cle wbr cK c1 cmin co cn0 wcel cK cn wcel c1 cK
      cle wbr bcpasc2.2 cK nnge1 ax-mp c1 cn0 wcel cK cn0 wcel c1 cK cle wbr cK
      c1 cmin co cn0 wcel wb 1nn0 cK bcpasc2.2 nnnn0i c1 cK nn0sub mp2an mpbi
      cK c1 cmin co cN cle wbr cK cN c1 caddc co cle wbr cK cN c1 caddc co cK
      bcpasc2.2 nnrei cN c1 caddc co cN c1 cN bcpasc2.1 nnnn0i 1nn0 nn0addcli
      nn0rei cK cN cle wbr cK cN c1 caddc co clt wbr bcpasc2.3 cK cn wcel cN cn
      wcel cK cN cle wbr cK cN c1 caddc co clt wbr wb bcpasc2.2 bcpasc2.1 cK cN
      nnleltp1 mp2an mpbi ltleii cK c1 cN cK bcpasc2.2 nnrei 1re cN bcpasc2.1
      nnrei lesubaddi mpbir cK c1 cmin co cN bcval2 mp3an 3eqtr4ri opreq12i cN
      c1 caddc co cn0 wcel cK cn0 wcel cK cN c1 caddc co cle wbr cN c1 caddc co
      cK cbc co cN c1 caddc co cfa cfv cN c1 caddc co cK cmin co cfa cfv cK cfa
      cfv cmul co cdiv co wceq cN c1 cN bcpasc2.1 nnnn0i 1nn0 nn0addcli cK
      bcpasc2.2 nnnn0i cK cN c1 caddc co cK bcpasc2.2 nnrei cN c1 caddc co cN
      c1 cN bcpasc2.1 nnnn0i 1nn0 nn0addcli nn0rei cK cN cle wbr cK cN c1 caddc
      co clt wbr bcpasc2.3 cK cn wcel cN cn wcel cK cN cle wbr cK cN c1 caddc
      co clt wbr wb bcpasc2.2 bcpasc2.1 cK cN nnleltp1 mp2an mpbi ltleii cK cN
      c1 caddc co bcval2 mp3an 3eqtr4i $.
      $( [23-Jun-2005] $) $( [19-Jun-2005] $)
  $}

  $( Pascal's rule for the binomial coefficient.  Equation 2 of [Gleason]
     p. 295. $)
  bcpasc2 $p |- ( ( N e. NN /\ K e. NN /\ K <_ N ) ->
                ( ( N _C K ) + ( N _C ( K - 1 ) ) ) = ( ( N + 1 ) _C K ) ) $=
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN cK cbc co cN cK c1 cmin co cbc
    co caddc co cN c1 caddc co cK cbc co wceq cN cn wcel cK cn wcel cK cN cle
    wbr w3a cN c1 cif cK cbc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1
    cif cK c1 cmin co cbc co caddc co cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif c1 caddc co cK cbc co wceq cN cn wcel cK cn wcel cK cN cle wbr
    w3a cN c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cbc co cN
    cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cN cn wcel cK cn wcel cK cN
    cle wbr w3a cK c1 cif c1 cmin co cbc co caddc co cN cn wcel cK cn wcel cK
    cN cle wbr w3a cN c1 cif c1 caddc co cN cn wcel cK cn wcel cK cN cle wbr
    w3a cK c1 cif cbc co wceq cN cK c1 c1 cN cN cn wcel cK cn wcel cK cN cle
    wbr w3a cN c1 cif wceq cN cK cbc co cN cK c1 cmin co cbc co caddc co cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK cbc co cN cn wcel cK cn wcel
    cK cN cle wbr w3a cN c1 cif cK c1 cmin co cbc co caddc co cN c1 caddc co cK
    cbc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif c1 caddc co cK cbc
    co cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif wceq cN cK cbc co
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK cbc co cN cK c1 cmin
    co cbc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK c1 cmin co
    cbc co caddc cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK cbc
    opreq1 cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK c1 cmin co
    cbc opreq1 opreq12d cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif
    wceq cN c1 caddc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif c1
    caddc co cK cbc cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif c1
    caddc opreq1 opreq1d eqeq12d cK cN cn wcel cK cn wcel cK cN cle wbr w3a cK
    c1 cif wceq cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK cbc co cN
    cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK c1 cmin co cbc co caddc
    co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cN cn wcel cK cn wcel
    cK cN cle wbr w3a cK c1 cif cbc co cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif c1 cmin co cbc
    co caddc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif c1 caddc co
    cK cbc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif c1 caddc co cN
    cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cbc co cK cN cn wcel cK cn
    wcel cK cN cle wbr w3a cK c1 cif wceq cN cn wcel cK cn wcel cK cN cle wbr
    w3a cN c1 cif cK cbc co cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif
    cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cbc co cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cK c1 cmin co cbc co cN cn wcel cK cn wcel
    cK cN cle wbr w3a cN c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1
    cif c1 cmin co cbc co caddc cK cN cn wcel cK cn wcel cK cN cle wbr w3a cK
    c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cbc opreq2 cK cN
    cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif wceq cK c1 cmin co cN cn
    wcel cK cn wcel cK cN cle wbr w3a cK c1 cif c1 cmin co cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cbc cK cN cn wcel cK cn wcel cK cN cle wbr
    w3a cK c1 cif c1 cmin opreq1 opreq2d opreq12d cK cN cn wcel cK cn wcel cK
    cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif
    c1 caddc co cbc opreq2 eqeq12d cN cn wcel cK cn wcel cK cN cle wbr w3a cK
    c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cn wcel cN cn wcel cK cn wcel cK cN cle
    wbr w3a cK c1 cif cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn
    wcel cK cn wcel cK cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle
    wbr w3a cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel cN cn
    wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn wcel cN cn wcel cK cn wcel
    cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1
    cif cle wbr w3a c1 cn wcel c1 cn wcel c1 c1 cle wbr w3a cN cK c1 c1 cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel c1 cn wcel c1 cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr w3a cN cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif wceq cN cn wcel cN cn wcel cK cn wcel cK
    cN cle wbr w3a cN c1 cif cn wcel cK cN cle wbr cK cN cn wcel cK cn wcel cK
    cN cle wbr w3a cN c1 cif cle wbr cK cn wcel cN cN cn wcel cK cn wcel cK cN
    cle wbr w3a cN c1 cif cn eleq1 cN cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cK cle breq2 3anbi13d cK cN cn wcel cK cn wcel cK cN cle wbr w3a
    cK c1 cif wceq cK cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif
    cn wcel cK cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn
    wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle
    wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif
    cn wcel cK cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn eleq1 cK cN
    cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN
    cle wbr w3a cN c1 cif cle breq1 3anbi23d c1 cN cn wcel cK cn wcel cK cN cle
    wbr w3a cN c1 cif wceq c1 cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cn wcel c1 c1 cle wbr c1 cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cle wbr c1 cn wcel c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN
    c1 cif cn eleq1 c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif c1 cle
    breq2 3anbi13d c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif wceq c1
    cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn wcel c1 cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel
    cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1
    cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel c1 cN
    cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn eleq1 c1 cN cn wcel cK cn
    wcel cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN
    c1 cif cle breq1 3anbi23d c1 cn wcel c1 cn wcel c1 c1 cle wbr 1nn 1nn c1
    1re leidi 3pm3.2i elimhyp2v 3simp1i cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn wcel
    cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK
    cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cN
    cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel cK cn wcel cK cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr w3a cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cn wcel cN cn wcel cK cn wcel cK cN cle
    wbr w3a cK c1 cif cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr w3a c1 cn wcel c1
    cn wcel c1 c1 cle wbr w3a cN cK c1 c1 cN cn wcel cK cn wcel cK cN cle wbr
    w3a cN c1 cif cn wcel c1 cn wcel c1 cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cle wbr w3a cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif
    wceq cN cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel
    cK cN cle wbr cK cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr
    cK cn wcel cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn eleq1 cN
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cK cle breq2 3anbi13d cK
    cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif wceq cK cn wcel cN cn
    wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn wcel cK cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel cK cN cle
    wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel cK cN cn wcel cK
    cn wcel cK cN cle wbr w3a cK c1 cif cn eleq1 cK cN cn wcel cK cn wcel cK cN
    cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle
    breq1 3anbi23d c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif wceq c1
    cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel c1 c1 cle
    wbr c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr c1 cn wcel
    c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn eleq1 c1 cN cn wcel
    cK cn wcel cK cN cle wbr w3a cN c1 cif c1 cle breq2 3anbi13d c1 cN cn wcel
    cK cn wcel cK cN cle wbr w3a cK c1 cif wceq c1 cn wcel cN cn wcel cK cn
    wcel cK cN cle wbr w3a cK c1 cif cn wcel c1 cN cn wcel cK cn wcel cK cN cle
    wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cn wcel c1 cN cn wcel cK cn wcel cK cN cle
    wbr w3a cK c1 cif cn eleq1 c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1
    cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle breq1 3anbi23d c1
    cn wcel c1 cn wcel c1 c1 cle wbr 1nn 1nn c1 1re leidi 3pm3.2i elimhyp2v
    3simp2i cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel cN cn
    wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn wcel cN cn wcel cK cn wcel
    cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1
    cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cN cn wcel cK cn wcel
    cK cN cle wbr w3a cN c1 cif cn wcel cK cn wcel cK cN cn wcel cK cn wcel cK
    cN cle wbr w3a cN c1 cif cle wbr w3a cN cn wcel cK cn wcel cK cN cle wbr
    w3a cN c1 cif cn wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cn
    wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cle wbr w3a c1 cn wcel c1 cn wcel c1 c1
    cle wbr w3a cN cK c1 c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif
    cn wcel c1 cn wcel c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle
    wbr w3a cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif wceq cN cn
    wcel cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel cK cN cle
    wbr cK cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cK cn wcel
    cN cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn eleq1 cN cN cn wcel
    cK cn wcel cK cN cle wbr w3a cN c1 cif cK cle breq2 3anbi13d cK cN cn wcel
    cK cn wcel cK cN cle wbr w3a cK c1 cif wceq cK cn wcel cN cn wcel cK cn
    wcel cK cN cle wbr w3a cK c1 cif cn wcel cK cN cn wcel cK cn wcel cK cN cle
    wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif cn wcel cK cN cn wcel cK cn wcel cK cN cle
    wbr w3a cK c1 cif cn eleq1 cK cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1
    cif cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle breq1 3anbi23d c1
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif wceq c1 cn wcel cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn wcel c1 c1 cle wbr c1 cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr c1 cn wcel c1 cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cn eleq1 c1 cN cn wcel cK cn
    wcel cK cN cle wbr w3a cN c1 cif c1 cle breq2 3anbi13d c1 cN cn wcel cK cn
    wcel cK cN cle wbr w3a cK c1 cif wceq c1 cn wcel cN cn wcel cK cn wcel cK
    cN cle wbr w3a cK c1 cif cn wcel c1 cN cn wcel cK cn wcel cK cN cle wbr w3a
    cN c1 cif cle wbr cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif cN cn
    wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle wbr cN cn wcel cK cn wcel
    cK cN cle wbr w3a cN c1 cif cn wcel c1 cN cn wcel cK cn wcel cK cN cle wbr
    w3a cK c1 cif cn eleq1 c1 cN cn wcel cK cn wcel cK cN cle wbr w3a cK c1 cif
    cN cn wcel cK cn wcel cK cN cle wbr w3a cN c1 cif cle breq1 3anbi23d c1 cn
    wcel c1 cn wcel c1 c1 cle wbr 1nn 1nn c1 1re leidi 3pm3.2i elimhyp2v
    3simp3i bcpasc2i dedth2v $.
    $( [9-Sep-2005] $) $( [20-Jun-2005] $)

  ${
    bcpasc.1 $e |- N e. NN0 $.
    bcpasc.2 $e |- K e. ZZ $.
    $( Pascal's rule for the binomial coefficient, generalized to all integers
       ` K ` .  Equation 2 of [Gleason] p. 295. $)
    bcpasci $p |- ( ( N _C K ) + ( N _C ( K - 1 ) ) ) = ( ( N + 1 ) _C K ) $=
      cN cn wcel cK cn wcel cK cN cle wbr cN cK cbc co cN cK c1 cmin co cbc co
      caddc co cN c1 caddc co cK cbc co wceq cN cn wcel wn cN cc0 wceq cN cK
      cbc co cN cK c1 cmin co cbc co caddc co cN c1 caddc co cK cbc co wceq cN
      cn wcel cN cc0 wceq cN cn0 wcel cN cn wcel cN cc0 wceq wo bcpasc.1 cN
      elnn0 mpbi ori cN cc0 wceq cc0 cK cbc co cc0 cK c1 cmin co cbc co caddc
      co c1 cK cbc co cN cK cbc co cN cK c1 cmin co cbc co caddc co cN c1 caddc
      co cK cbc co cc0 cK cbc co cc0 cK c1 cmin co cbc co caddc co c1 cK cbc co
      wceq cK cc0 cK cc0 wceq c1 cc0 caddc co c1 cc0 cK cbc co cc0 cK c1 cmin
      co cbc co caddc co c1 cK cbc co c1 ax1cn addid1i cK cc0 wceq cc0 cK cbc
      co c1 cc0 cK c1 cmin co cbc co cc0 caddc cK cc0 wceq cc0 cK cbc co cc0
      cc0 cbc co c1 cK cc0 cc0 cbc opreq2 cc0 cn0 wcel cc0 cc0 cbc co c1 wceq
      0nn0 cc0 bcn0 ax-mp syl6eq cK cc0 wceq cc0 cK c1 cmin co cbc co cc0 c1
      cneg cbc co cc0 cK cc0 wceq cK c1 cmin co c1 cneg cc0 cbc cK cc0 wceq cK
      c1 cmin co cc0 c1 cmin co c1 cneg cK cc0 c1 cmin opreq1 c1 df-neg syl6eqr
      opreq2d cc0 cn0 wcel c1 cneg cz wcel c1 cneg cc0 clt wbr cc0 c1 cneg clt
      wbr wo cc0 c1 cneg cbc co cc0 wceq 0nn0 c1 cz wcel c1 cneg cz wcel 1z c1
      znegcl ax-mp c1 cneg cc0 clt wbr cc0 c1 cneg clt wbr cc0 c1 clt wbr c1
      cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr wb
      1re c1 lt0neg2 ax-mp mpbi orci c1 cneg cc0 bcval4 mp3an syl6eq opreq12d
      cK cc0 wceq c1 cK cbc co c1 cc0 cbc co c1 cK cc0 c1 cbc opreq2 c1 cn0
      wcel c1 cc0 cbc co c1 wceq 1nn0 c1 bcn0 ax-mp syl6eq 3eqtr4a cK cc0 wne
      cK cc0 clt wbr cc0 cK clt wbr wo cc0 cK cbc co cc0 cK c1 cmin co cbc co
      caddc co c1 cK cbc co wceq cK cc0 cK bcpasc.2 zrei 0re lttri2i cK cc0 clt
      wbr cc0 cK cbc co cc0 cK c1 cmin co cbc co caddc co c1 cK cbc co wceq cc0
      cK clt wbr cK cc0 clt wbr cc0 cc0 caddc co cc0 cc0 cK cbc co cc0 cK c1
      cmin co cbc co caddc co c1 cK cbc co cc0 0cn addid1i cK cc0 clt wbr cc0
      cK cbc co cc0 cc0 cK c1 cmin co cbc co cc0 caddc cK cc0 clt wbr cc0 cK
      clt wbr cc0 cK cbc co cc0 wceq cc0 cn0 wcel cK cz wcel cK cc0 clt wbr cc0
      cK clt wbr wo cc0 cK cbc co cc0 wceq 0nn0 bcpasc.2 cK cc0 bcval4 mp3an12
      orcs cK cc0 clt wbr cK c1 cmin co cc0 clt wbr cK c1 cmin co cc0 clt wbr
      cc0 cK c1 cmin co clt wbr wo cc0 cK c1 cmin co cbc co cc0 wceq cK c1 cmin
      co cK clt wbr cK cc0 clt wbr cK c1 cmin co cc0 clt wbr cK cK cle wbr cK
      c1 cmin co cK clt wbr cK cK bcpasc.2 zrei leidi cK cz wcel cK cz wcel cK
      cK cle wbr cK c1 cmin co cK clt wbr wb bcpasc.2 bcpasc.2 cK cK zlem1lt
      mp2an mpbi cK c1 cmin co cK cc0 cK c1 cK bcpasc.2 zrei 1re resubcli cK
      bcpasc.2 zrei 0re lttri mpan cK c1 cmin co cc0 clt wbr cc0 cK c1 cmin co
      clt wbr orc cc0 cn0 wcel cK c1 cmin co cz wcel cK c1 cmin co cc0 clt wbr
      cc0 cK c1 cmin co clt wbr wo cc0 cK c1 cmin co cbc co cc0 wceq 0nn0 cK cz
      wcel c1 cz wcel cK c1 cmin co cz wcel bcpasc.2 1z cK c1 zsubcl mp2an cK
      c1 cmin co cc0 bcval4 mp3an12 3syl opreq12d cK cc0 clt wbr c1 cK clt wbr
      c1 cK cbc co cc0 wceq c1 cn0 wcel cK cz wcel cK cc0 clt wbr c1 cK clt wbr
      wo c1 cK cbc co cc0 wceq 1nn0 bcpasc.2 cK c1 bcval4 mp3an12 orcs 3eqtr4a
      cc0 cK clt wbr cc0 cK cbc co cc0 cK c1 cmin co cbc co caddc co cc0 cc0 cK
      c1 cmin co cbc co caddc co c1 cK cbc co cc0 cK clt wbr cc0 cK cbc co cc0
      cc0 cK c1 cmin co cbc co caddc cK cc0 clt wbr cc0 cK clt wbr cc0 cK cbc
      co cc0 wceq cc0 cn0 wcel cK cz wcel cK cc0 clt wbr cc0 cK clt wbr wo cc0
      cK cbc co cc0 wceq 0nn0 bcpasc.2 cK cc0 bcval4 mp3an12 olcs opreq1d cc0
      cK clt wbr c1 cK clt wbr c1 cK wceq wo cc0 cc0 cK c1 cmin co cbc co caddc
      co c1 cK cbc co wceq cc0 cK clt wbr cc0 c1 caddc co cK cle wbr c1 cK cle
      wbr c1 cK clt wbr c1 cK wceq wo cc0 cz wcel cK cz wcel cc0 cK clt wbr cc0
      c1 caddc co cK cle wbr wb 0z bcpasc.2 cc0 cK zltp1le mp2an cc0 c1 caddc
      co c1 cK cle c1 ax1cn addid2i breq1i c1 cK 1re cK bcpasc.2 zrei leloei
      3bitri c1 cK clt wbr cc0 cc0 cK c1 cmin co cbc co caddc co c1 cK cbc co
      wceq c1 cK wceq c1 cK clt wbr c1 cK cbc co cc0 cc0 cc0 cK c1 cmin co cbc
      co caddc co cK cc0 clt wbr c1 cK clt wbr c1 cK cbc co cc0 wceq c1 cn0
      wcel cK cz wcel cK cc0 clt wbr c1 cK clt wbr wo c1 cK cbc co cc0 wceq
      1nn0 bcpasc.2 cK c1 bcval4 mp3an12 olcs c1 cK clt wbr cc0 cc0 caddc co
      cc0 cc0 cK c1 cmin co cbc co caddc co cc0 c1 cK clt wbr cc0 cc0 cK c1
      cmin co cbc co cc0 caddc c1 cK clt wbr cc0 cK c1 cmin co cbc co cc0 c1 cK
      clt wbr cK c1 cmin co cc0 clt wbr cc0 cK c1 cmin co clt wbr wo cc0 cK c1
      cmin co cbc co cc0 wceq c1 cK clt wbr cc0 cK c1 cmin co clt wbr cK c1
      cmin co cc0 clt wbr cc0 cK c1 cmin co clt wbr wo c1 cK 1re cK bcpasc.2
      zrei posdifi cc0 cK c1 cmin co clt wbr cK c1 cmin co cc0 clt wbr olc
      sylbi cc0 cn0 wcel cK c1 cmin co cz wcel cK c1 cmin co cc0 clt wbr cc0 cK
      c1 cmin co clt wbr wo cc0 cK c1 cmin co cbc co cc0 wceq 0nn0 cK cz wcel
      c1 cz wcel cK c1 cmin co cz wcel bcpasc.2 1z cK c1 zsubcl mp2an cK c1
      cmin co cc0 bcval4 mp3an12 syl eqcomd opreq2d cc0 0cn addid1i syl5eqr
      eqtr2d c1 cK wceq c1 cc0 cc0 cK c1 cmin co cbc co caddc co c1 cK cbc co
      c1 cK wceq cc0 c1 caddc co cc0 cc0 cK c1 cmin co cbc co caddc co c1 c1 cK
      wceq c1 cc0 cK c1 cmin co cbc co cc0 caddc c1 cK wceq cc0 cc0 cbc co cc0
      cK c1 cmin co cbc co c1 c1 cK wceq cc0 cK c1 cmin co cc0 cbc c1 cK wceq
      c1 c1 cmin co cK c1 cmin co cc0 c1 cK c1 cmin opreq1 c1 ax1cn subidi
      syl5eqr opreq2d cc0 cn0 wcel cc0 cc0 cbc co c1 wceq 0nn0 cc0 bcn0 ax-mp
      syl5eqr opreq2d c1 ax1cn addid2i syl5eqr c1 cK wceq c1 c1 cbc co c1 cK
      cbc co c1 c1 cK c1 cbc opreq2 c1 cn0 wcel c1 c1 cbc co c1 wceq 1nn0 c1
      bcnn ax-mp syl5eqr eqtr3d jaoi sylbi eqtrd jaoi sylbi pm2.61ine cN cc0
      wceq cN cK cbc co cc0 cK cbc co cN cK c1 cmin co cbc co cc0 cK c1 cmin co
      cbc co caddc cN cc0 cK cbc opreq1 cN cc0 cK c1 cmin co cbc opreq1
      opreq12d cN cc0 wceq cN c1 caddc co c1 cK cbc cN cc0 wceq cN c1 caddc co
      cc0 c1 caddc co c1 cN cc0 c1 caddc opreq1 c1 ax1cn addid2i syl6eq opreq1d
      3eqtr4a syl cK cn wcel wn cK cc0 clt wbr cK cc0 wceq wo cN cK cbc co cN
      cK c1 cmin co cbc co caddc co cN c1 caddc co cK cbc co wceq cK cn wcel wn
      cK c1 clt wbr cK cc0 clt wbr cK cc0 wceq wo cK cz wcel cK cn wcel wn cK
      c1 clt wbr wb bcpasc.2 cK znnnlt1 ax-mp cK cc0 cle wbr cK cc0 c1 caddc co
      clt wbr cK cc0 clt wbr cK cc0 wceq wo cK c1 clt wbr cK cz wcel cc0 cz
      wcel cK cc0 cle wbr cK cc0 c1 caddc co clt wbr wb bcpasc.2 0z cK cc0
      zleltp1 mp2an cK cc0 cK bcpasc.2 zrei 0re leloei cc0 c1 caddc co c1 cK
      clt c1 ax1cn addid2i breq2i 3bitr3ri bitri cK cc0 clt wbr cN cK cbc co cN
      cK c1 cmin co cbc co caddc co cN c1 caddc co cK cbc co wceq cK cc0 wceq
      cK cc0 clt wbr cc0 cc0 caddc co cc0 cN cK cbc co cN cK c1 cmin co cbc co
      caddc co cN c1 caddc co cK cbc co cc0 0cn addid1i cK cc0 clt wbr cN cK
      cbc co cc0 cN cK c1 cmin co cbc co cc0 caddc cK cc0 clt wbr cN cK clt wbr
      cN cK cbc co cc0 wceq cN cn0 wcel cK cz wcel cK cc0 clt wbr cN cK clt wbr
      wo cN cK cbc co cc0 wceq bcpasc.1 bcpasc.2 cK cN bcval4 mp3an12 orcs cK
      cc0 clt wbr cK c1 cmin co cc0 clt wbr cK c1 cmin co cc0 clt wbr cN cK c1
      cmin co clt wbr wo cN cK c1 cmin co cbc co cc0 wceq cK c1 cmin co cK clt
      wbr cK cc0 clt wbr cK c1 cmin co cc0 clt wbr cK cK cle wbr cK c1 cmin co
      cK clt wbr cK cK bcpasc.2 zrei leidi cK cz wcel cK cz wcel cK cK cle wbr
      cK c1 cmin co cK clt wbr wb bcpasc.2 bcpasc.2 cK cK zlem1lt mp2an mpbi cK
      c1 cmin co cK cc0 cK c1 cK bcpasc.2 zrei 1re resubcli cK bcpasc.2 zrei
      0re lttri mpan cK c1 cmin co cc0 clt wbr cN cK c1 cmin co clt wbr orc cN
      cn0 wcel cK c1 cmin co cz wcel cK c1 cmin co cc0 clt wbr cN cK c1 cmin co
      clt wbr wo cN cK c1 cmin co cbc co cc0 wceq bcpasc.1 cK cz wcel c1 cz
      wcel cK c1 cmin co cz wcel bcpasc.2 1z cK c1 zsubcl mp2an cK c1 cmin co
      cN bcval4 mp3an12 3syl opreq12d cK cc0 clt wbr cN c1 caddc co cK clt wbr
      cN c1 caddc co cK cbc co cc0 wceq cN c1 caddc co cn0 wcel cK cz wcel cK
      cc0 clt wbr cN c1 caddc co cK clt wbr wo cN c1 caddc co cK cbc co cc0
      wceq cN c1 bcpasc.1 1nn0 nn0addcli bcpasc.2 cK cN c1 caddc co bcval4
      mp3an12 orcs 3eqtr4a cK cc0 wceq cN cK cbc co cN cK c1 cmin co cbc co
      caddc co c1 cN c1 caddc co cK cbc co cK cc0 wceq cN cK cbc co cN cK c1
      cmin co cbc co caddc co c1 cc0 caddc co c1 cK cc0 wceq cN cK cbc co c1 cN
      cK c1 cmin co cbc co cc0 caddc cK cc0 wceq cN cK cbc co cN cc0 cbc co c1
      cK cc0 cN cbc opreq2 cN cn0 wcel cN cc0 cbc co c1 wceq bcpasc.1 cN bcn0
      ax-mp syl6eq cK cc0 wceq cK c1 cmin co cc0 clt wbr cK c1 cmin co cc0 clt
      wbr cN cK c1 cmin co clt wbr wo cN cK c1 cmin co cbc co cc0 wceq cK cc0
      wceq cK c1 cmin co cc0 c1 cmin co cc0 clt cK cc0 c1 cmin opreq1 c1 cneg
      cc0 c1 cmin co cc0 clt c1 df-neg cc0 c1 clt wbr c1 cneg cc0 clt wbr lt01
      c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr wb 1re c1 lt0neg2 ax-mp
      mpbi eqbrtrri syl6eqbr cK c1 cmin co cc0 clt wbr cN cK c1 cmin co clt wbr
      orc cN cn0 wcel cK c1 cmin co cz wcel cK c1 cmin co cc0 clt wbr cN cK c1
      cmin co clt wbr wo cN cK c1 cmin co cbc co cc0 wceq bcpasc.1 cK cz wcel
      c1 cz wcel cK c1 cmin co cz wcel bcpasc.2 1z cK c1 zsubcl mp2an cK c1
      cmin co cN bcval4 mp3an12 3syl opreq12d c1 ax1cn addid1i syl6eq cK cc0
      wceq cN c1 caddc co cK cbc co cN c1 caddc co cc0 cbc co c1 cK cc0 cN c1
      caddc co cbc opreq2 cN c1 caddc co cn0 wcel cN c1 caddc co cc0 cbc co c1
      wceq cN c1 bcpasc.1 1nn0 nn0addcli cN c1 caddc co bcn0 ax-mp syl6req
      eqtrd jaoi sylbi cK cN cle wbr wn cN cK clt wbr cN cK cbc co cN cK c1
      cmin co cbc co caddc co cN c1 caddc co cK cbc co wceq cN cK cN bcpasc.1
      nn0rei cK bcpasc.2 zrei ltnlei cN cK clt wbr cN cK cbc co cN cK c1 cmin
      co cbc co caddc co cc0 cN cK c1 cmin co cbc co caddc co cN c1 caddc co cK
      cbc co cN cK clt wbr cN cK cbc co cc0 cN cK c1 cmin co cbc co caddc cK
      cc0 clt wbr cN cK clt wbr cN cK cbc co cc0 wceq cN cn0 wcel cK cz wcel cK
      cc0 clt wbr cN cK clt wbr wo cN cK cbc co cc0 wceq bcpasc.1 bcpasc.2 cK
      cN bcval4 mp3an12 olcs opreq1d cN cK clt wbr cN c1 caddc co cK clt wbr cN
      c1 caddc co cK wceq wo cc0 cN cK c1 cmin co cbc co caddc co cN c1 caddc
      co cK cbc co wceq cN cK clt wbr cN c1 caddc co cK cle wbr cN c1 caddc co
      cK clt wbr cN c1 caddc co cK wceq wo cN cz wcel cK cz wcel cN cK clt wbr
      cN c1 caddc co cK cle wbr wb cN cn0 wcel cN cz wcel bcpasc.1 cN nn0z
      ax-mp bcpasc.2 cN cK zltp1le mp2an cN c1 caddc co cK cN c1 cN bcpasc.1
      nn0rei 1re readdcli cK bcpasc.2 zrei leloei bitri cN c1 caddc co cK clt
      wbr cc0 cN cK c1 cmin co cbc co caddc co cN c1 caddc co cK cbc co wceq cN
      c1 caddc co cK wceq cN c1 caddc co cK clt wbr cc0 cc0 caddc co cc0 cc0 cN
      cK c1 cmin co cbc co caddc co cN c1 caddc co cK cbc co cc0 0cn addid1i cN
      c1 caddc co cK clt wbr cN cK c1 cmin co cbc co cc0 cc0 caddc cN c1 caddc
      co cK clt wbr cK c1 cmin co cc0 clt wbr cN cK c1 cmin co clt wbr wo cN cK
      c1 cmin co cbc co cc0 wceq cN c1 caddc co cK clt wbr cN cK c1 cmin co clt
      wbr cK c1 cmin co cc0 clt wbr cN cK c1 cmin co clt wbr wo cN c1 cK cN
      bcpasc.1 nn0rei 1re cK bcpasc.2 zrei ltaddsubi cN cK c1 cmin co clt wbr
      cK c1 cmin co cc0 clt wbr olc sylbi cN cn0 wcel cK c1 cmin co cz wcel cK
      c1 cmin co cc0 clt wbr cN cK c1 cmin co clt wbr wo cN cK c1 cmin co cbc
      co cc0 wceq bcpasc.1 cK cz wcel c1 cz wcel cK c1 cmin co cz wcel bcpasc.2
      1z cK c1 zsubcl mp2an cK c1 cmin co cN bcval4 mp3an12 syl opreq2d cK cc0
      clt wbr cN c1 caddc co cK clt wbr cN c1 caddc co cK cbc co cc0 wceq cN c1
      caddc co cn0 wcel cK cz wcel cK cc0 clt wbr cN c1 caddc co cK clt wbr wo
      cN c1 caddc co cK cbc co cc0 wceq cN c1 bcpasc.1 1nn0 nn0addcli bcpasc.2
      cK cN c1 caddc co bcval4 mp3an12 olcs 3eqtr4a cN c1 caddc co cK wceq c1
      cc0 cN cK c1 cmin co cbc co caddc co cN c1 caddc co cK cbc co cN c1 caddc
      co cK wceq cc0 c1 caddc co cc0 cN cK c1 cmin co cbc co caddc co c1 cN c1
      caddc co cK wceq c1 cN cK c1 cmin co cbc co cc0 caddc cN c1 caddc co cK
      wceq cN cN cbc co cN cK c1 cmin co cbc co c1 cN c1 caddc co cK wceq cN cK
      c1 cmin co cN cbc cN c1 caddc co cK wceq cN c1 caddc co c1 cmin co cK c1
      cmin co cN cN c1 caddc co cK c1 cmin opreq1 cN cc wcel c1 cc wcel cN c1
      caddc co c1 cmin co cN wceq cN bcpasc.1 nn0cni ax1cn cN c1 pncan mp2an
      syl5eqr opreq2d cN cn0 wcel cN cN cbc co c1 wceq bcpasc.1 cN bcnn ax-mp
      syl5eqr opreq2d c1 ax1cn addid2i syl5eqr cN c1 caddc co cK wceq cN c1
      caddc co cN c1 caddc co cbc co cN c1 caddc co cK cbc co c1 cN c1 caddc co
      cK cN c1 caddc co cbc opreq2 cN c1 caddc co cn0 wcel cN c1 caddc co cN c1
      caddc co cbc co c1 wceq cN c1 bcpasc.1 1nn0 nn0addcli cN c1 caddc co bcnn
      ax-mp syl5eqr eqtr3d jaoi sylbi eqtrd sylbir cK cN bcpasc2 3ecase $.
      $( [21-Sep-2005] $) $( [13-Jul-2005] $)
  $}

  $( Pascal's rule for the binomial coefficient, generalized to all integers
     ` K ` .  Equation 2 of [Gleason] p. 295. $)
  bcpasc $p |- ( ( N e. NN0 /\ K e. ZZ ) ->
                ( ( N _C K ) + ( N _C ( K - 1 ) ) ) = ( ( N + 1 ) _C K ) ) $=
    cN cn0 wcel cK cz wcel cN cK cbc co cN cK c1 cmin co cbc co caddc co cN c1
    caddc co cK cbc co wceq cN cn0 wcel cN c1 cif cK cbc co cN cn0 wcel cN c1
    cif cK c1 cmin co cbc co caddc co cN cn0 wcel cN c1 cif c1 caddc co cK cbc
    co wceq cN cn0 wcel cN c1 cif cK cz wcel cK c1 cif cbc co cN cn0 wcel cN c1
    cif cK cz wcel cK c1 cif c1 cmin co cbc co caddc co cN cn0 wcel cN c1 cif
    c1 caddc co cK cz wcel cK c1 cif cbc co wceq cN cK c1 c1 cN cN cn0 wcel cN
    c1 cif wceq cN cK cbc co cN cK c1 cmin co cbc co caddc co cN cn0 wcel cN c1
    cif cK cbc co cN cn0 wcel cN c1 cif cK c1 cmin co cbc co caddc co cN c1
    caddc co cK cbc co cN cn0 wcel cN c1 cif c1 caddc co cK cbc co cN cN cn0
    wcel cN c1 cif wceq cN cK cbc co cN cn0 wcel cN c1 cif cK cbc co cN cK c1
    cmin co cbc co cN cn0 wcel cN c1 cif cK c1 cmin co cbc co caddc cN cN cn0
    wcel cN c1 cif cK cbc opreq1 cN cN cn0 wcel cN c1 cif cK c1 cmin co cbc
    opreq1 opreq12d cN cN cn0 wcel cN c1 cif wceq cN c1 caddc co cN cn0 wcel cN
    c1 cif c1 caddc co cK cbc cN cN cn0 wcel cN c1 cif c1 caddc opreq1 opreq1d
    eqeq12d cK cK cz wcel cK c1 cif wceq cN cn0 wcel cN c1 cif cK cbc co cN cn0
    wcel cN c1 cif cK c1 cmin co cbc co caddc co cN cn0 wcel cN c1 cif cK cz
    wcel cK c1 cif cbc co cN cn0 wcel cN c1 cif cK cz wcel cK c1 cif c1 cmin co
    cbc co caddc co cN cn0 wcel cN c1 cif c1 caddc co cK cbc co cN cn0 wcel cN
    c1 cif c1 caddc co cK cz wcel cK c1 cif cbc co cK cK cz wcel cK c1 cif wceq
    cN cn0 wcel cN c1 cif cK cbc co cN cn0 wcel cN c1 cif cK cz wcel cK c1 cif
    cbc co cN cn0 wcel cN c1 cif cK c1 cmin co cbc co cN cn0 wcel cN c1 cif cK
    cz wcel cK c1 cif c1 cmin co cbc co caddc cK cK cz wcel cK c1 cif cN cn0
    wcel cN c1 cif cbc opreq2 cK cK cz wcel cK c1 cif wceq cK c1 cmin co cK cz
    wcel cK c1 cif c1 cmin co cN cn0 wcel cN c1 cif cbc cK cK cz wcel cK c1 cif
    c1 cmin opreq1 opreq2d opreq12d cK cK cz wcel cK c1 cif cN cn0 wcel cN c1
    cif c1 caddc co cbc opreq2 eqeq12d cK cz wcel cK c1 cif cN cn0 wcel cN c1
    cif cN c1 cn0 1nn0 elimel cK c1 cz 1z elimel bcpasci dedth2h $.
    $( [31-Jan-2006] $) $( [13-Jul-2005] $)

  ${
    $d k n N $.  $d n j k $.  $d k K $.
    $( A binomial coefficient, in its standard domain, is a natural number. $)
    bccl2 $p |- ( ( N e. NN0 /\ K e. ( 0 ... N ) ) -> ( N _C K ) e. NN ) $=
      cN cn0 wcel cK cn0 wcel cK cN cle wbr cN cK cbc co cn wcel cN cn0 wcel cK
      cc0 cN cfz co wcel wa cN cn0 wcel cK cn0 wcel cK cN cle wbr cN cK cbc co
      cn wcel cN cn wcel cN cc0 wceq wo cK cn wcel cK cc0 wceq wo cK cN cle wbr
      cN cK cbc co cn wcel wi cN cn0 wcel cK cn0 wcel cN cn wcel cK cn wcel cN
      cc0 wceq cK cc0 wceq cK cN cle wbr cN cK cbc co cn wcel wi cN cn wcel cK
      cn wcel cK cN cle wbr cN cK cbc co cn wcel wi cK cn wcel vk cv cN cle wbr
      cN vk cv cbc co cn wcel wi vk cn wral cK cN cle wbr cN cK cbc co cn wcel
      wi cN cn wcel vk cv cN cle wbr cN vk cv cbc co cn wcel wi cK cN cle wbr
      cN cK cbc co cn wcel wi vk cK cn vk cv cK wceq vk cv cN cle wbr cK cN cle
      wbr cN vk cv cbc co cn wcel cN cK cbc co cn wcel vk cv cK cN cle breq1 vk
      cv cK wceq cN vk cv cbc co cN cK cbc co cn vk cv cK cN cbc opreq2 eleq1d
      imbi12d rcla4v vk cv vn cv cle wbr vn cv vk cv cbc co cn wcel wi vk cn
      wral vk cv c1 cle wbr c1 vk cv cbc co cn wcel wi vk cn wral vk cv vj cv
      cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vk cv vj cv c1 caddc co
      cle wbr vj cv c1 caddc co vk cv cbc co cn wcel wi vk cn wral vk cv cN cle
      wbr cN vk cv cbc co cn wcel wi vk cn wral vn vj cN vn cv c1 wceq vk cv vn
      cv cle wbr vn cv vk cv cbc co cn wcel wi vk cv c1 cle wbr c1 vk cv cbc co
      cn wcel wi vk cn vn cv c1 wceq vk cv vn cv cle wbr vk cv c1 cle wbr vn cv
      vk cv cbc co cn wcel c1 vk cv cbc co cn wcel vn cv c1 vk cv cle breq2 vn
      cv c1 wceq vn cv vk cv cbc co c1 vk cv cbc co cn vn cv c1 vk cv cbc
      opreq1 eleq1d imbi12d ralbidv vn cv vj cv wceq vk cv vn cv cle wbr vn cv
      vk cv cbc co cn wcel wi vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi
      vk cn vn cv vj cv wceq vk cv vn cv cle wbr vk cv vj cv cle wbr vn cv vk
      cv cbc co cn wcel vj cv vk cv cbc co cn wcel vn cv vj cv vk cv cle breq2
      vn cv vj cv wceq vn cv vk cv cbc co vj cv vk cv cbc co cn vn cv vj cv vk
      cv cbc opreq1 eleq1d imbi12d ralbidv vn cv vj cv c1 caddc co wceq vk cv
      vn cv cle wbr vn cv vk cv cbc co cn wcel wi vk cv vj cv c1 caddc co cle
      wbr vj cv c1 caddc co vk cv cbc co cn wcel wi vk cn vn cv vj cv c1 caddc
      co wceq vk cv vn cv cle wbr vk cv vj cv c1 caddc co cle wbr vn cv vk cv
      cbc co cn wcel vj cv c1 caddc co vk cv cbc co cn wcel vn cv vj cv c1
      caddc co vk cv cle breq2 vn cv vj cv c1 caddc co wceq vn cv vk cv cbc co
      vj cv c1 caddc co vk cv cbc co cn vn cv vj cv c1 caddc co vk cv cbc
      opreq1 eleq1d imbi12d ralbidv vn cv cN wceq vk cv vn cv cle wbr vn cv vk
      cv cbc co cn wcel wi vk cv cN cle wbr cN vk cv cbc co cn wcel wi vk cn vn
      cv cN wceq vk cv vn cv cle wbr vk cv cN cle wbr vn cv vk cv cbc co cn
      wcel cN vk cv cbc co cn wcel vn cv cN vk cv cle breq2 vn cv cN wceq vn cv
      vk cv cbc co cN vk cv cbc co cn vn cv cN vk cv cbc opreq1 eleq1d imbi12d
      ralbidv vk cv c1 cle wbr c1 vk cv cbc co cn wcel wi vk cn vk cv cn wcel
      vk cv c1 cle wbr vk cv c1 wceq c1 vk cv cbc co cn wcel vk cv nnle1eq1 vk
      cv c1 wceq c1 vk cv cbc co c1 c1 cbc co cn vk cv c1 c1 cbc opreq2 c1 c1
      cbc co c1 cn c1 cn0 wcel c1 c1 cbc co c1 wceq 1nn0 c1 bcnn ax-mp 1nn
      eqeltri syl6eqel syl6bi rgen vj cv cn wcel vk cv vj cv cle wbr vj cv vk
      cv cbc co cn wcel wi vk cn wral vk cv vj cv c1 caddc co cle wbr vj cv c1
      caddc co vk cv cbc co cn wcel wi vk cn vj cv cn wcel vk ax-17 vk cv vj cv
      cle wbr vj cv vk cv cbc co cn wcel wi vk cn hbra1 vk cv cn wcel vk cv vj
      cv c1 caddc co cle wbr vj cv cn wcel vk cv vj cv cle wbr vj cv vk cv cbc
      co cn wcel wi vk cn wral vj cv c1 caddc co vk cv cbc co cn wcel vk cv cn
      wcel vj cv cn wcel vk cv vj cv c1 caddc co cle wbr vk cv vj cv cle wbr vj
      cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc co vk cv cbc co cn
      wcel wi vk cv cn wcel vj cv cn wcel vk cv vj cv c1 caddc co cle wbr vk cv
      vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc co
      vk cv cbc co cn wcel wi wi vk cv cn wcel vj cv cn wcel wa vk cv vj cv c1
      caddc co cle wbr vk cv vj cv cle wbr vk cv vj cv c1 caddc co wceq wo vk
      cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc
      co vk cv cbc co cn wcel wi vk cv cn wcel vj cv cn wcel wa vk cv vj cv c1
      caddc co cle wbr vk cv vj cv c1 caddc co clt wbr vk cv vj cv c1 caddc co
      wceq wo vk cv vj cv cle wbr vk cv vj cv c1 caddc co wceq wo vk cv cr wcel
      vj cv c1 caddc co cr wcel vk cv vj cv c1 caddc co cle wbr vk cv vj cv c1
      caddc co clt wbr vk cv vj cv c1 caddc co wceq wo wb vk cv cn wcel vj cv
      cn wcel vk cv vj cv c1 caddc co leloe vk cv nnre vj cv cn wcel vj cv c1
      caddc co cn wcel vj cv c1 caddc co cr wcel vj cv peano2nn vj cv c1 caddc
      co nnre syl syl2an vk cv cn wcel vj cv cn wcel wa vk cv vj cv cle wbr vk
      cv vj cv c1 caddc co clt wbr vk cv vj cv c1 caddc co wceq vk cv vj cv
      nnleltp1 orbi1d bitr4d vk cv cn wcel vj cv cn wcel wa c1 vk cv clt wbr c1
      vk cv wceq wo vk cv vj cv cle wbr vk cv vj cv c1 caddc co wceq wo vk cv
      vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc co
      vk cv cbc co cn wcel wi vk cv cn wcel c1 vk cv clt wbr c1 vk cv wceq wo
      vj cv cn wcel vk cv cn wcel c1 vk cv cle wbr c1 vk cv clt wbr c1 vk cv
      wceq wo vk cv nnge1 c1 cr wcel vk cv cr wcel c1 vk cv cle wbr c1 vk cv
      clt wbr c1 vk cv wceq wo wb vk cv cn wcel c1 vk cv leloe 1re vk cv nnre
      sylancr mpbid adantr c1 vk cv clt wbr c1 vk cv wceq wo vk cv vj cv cle
      wbr vk cv vj cv c1 caddc co wceq wo wa vk cv cn wcel vj cv cn wcel wa vk
      cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc
      co vk cv cbc co cn wcel wi c1 vk cv clt wbr vk cv vj cv cle wbr c1 vk cv
      wceq vk cv vj cv c1 caddc co wceq vk cv cn wcel vj cv cn wcel wa vk cv vj
      cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc co vk
      cv cbc co cn wcel wi wi vk cv cn wcel vj cv cn wcel wa c1 vk cv clt wbr
      vk cv vj cv cle wbr wa vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi
      vk cn wral vj cv c1 caddc co vk cv cbc co cn wcel wi vk cv cn wcel vj cv
      cn wcel wa c1 vk cv clt wbr vk cv vj cv cle wbr wa vk cv vj cv cle wbr vj
      cv vk cv cbc co cn wcel wi vk cn wral vj cv c1 caddc co vk cv cbc co cn
      wcel vk cv cn wcel vj cv cn wcel wa c1 vk cv clt wbr vk cv vj cv cle wbr
      wa wa vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral wa vj
      cv vk cv cbc co vj cv vk cv c1 cmin co cbc co caddc co cn wcel vj cv c1
      caddc co vk cv cbc co cn wcel vj cv vk cv cbc co cn wcel vj cv vk cv c1
      cmin co cbc co cn wcel vj cv vk cv cbc co vj cv vk cv c1 cmin co cbc co
      caddc co cn wcel vk cv cn wcel vj cv cn wcel wa c1 vk cv clt wbr vk cv vj
      cv cle wbr wa wa vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn
      wral wa vj cv vk cv cbc co vj cv vk cv c1 cmin co cbc co nnaddcl vk cv cn
      wcel vj cv cn wcel wa vk cv vj cv cle wbr vk cv vj cv cle wbr vj cv vk cv
      cbc co cn wcel wi vk cn wral vj cv vk cv cbc co cn wcel c1 vk cv clt wbr
      vk cv cn wcel vk cv vj cv cle wbr vk cv vj cv cle wbr vj cv vk cv cbc co
      cn wcel wi vk cn wral vj cv vk cv cbc co cn wcel vj cv cn wcel vk cv vj
      cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vk cv cn wcel vk cv
      vj cv cle wbr wa vj cv vk cv cbc co cn wcel vk cv vj cv cle wbr vj cv vk
      cv cbc co cn wcel wi vk cn wral vk cv cn wcel vk cv vj cv cle wbr vj cv
      vk cv cbc co cn wcel vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk
      cn ra4 imp32 ancoms adantllr adantlrl vk cv cn wcel vj cv cn wcel wa c1
      vk cv clt wbr vk cv vj cv cle wbr vk cv vj cv cle wbr vj cv vk cv cbc co
      cn wcel wi vk cn wral vj cv vk cv c1 cmin co cbc co cn wcel vk cv cn wcel
      vj cv cn wcel wa c1 vk cv clt wbr vk cv c1 cmin co vj cv cle wbr vk cv vj
      cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vj cv vk cv c1 cmin
      co cbc co cn wcel wi vk cv vj cv cle wbr vk cv cn wcel c1 vk cv clt wbr
      vk cv c1 cmin co vj cv cle wbr vk cv vj cv cle wbr vj cv vk cv cbc co cn
      wcel wi vk cn wral vj cv vk cv c1 cmin co cbc co cn wcel wi wi wi vj cv
      cn wcel vk cv cn wcel c1 vk cv clt wbr vk cv c1 cmin co cn wcel vk cv c1
      cmin co vj cv cle wbr vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi
      vk cn wral vj cv vk cv c1 cmin co cbc co cn wcel wi wi vk cv cn wcel vk
      cv c1 cmin co cz wcel c1 vk cv clt wbr vk cv c1 cmin co cn wcel vk cv cn
      wcel vk cv cz wcel vk cv c1 cmin co cz wcel vk cv nnz vk cv peano2zm syl
      vk cv cn wcel vk cv c1 cmin co cz wcel c1 vk cv clt wbr wa vk cv c1 cmin
      co cz wcel c1 vk cv c1 cmin co cle wbr wa vk cv c1 cmin co cn wcel vk cv
      cn wcel c1 vk cv clt wbr c1 vk cv c1 cmin co cle wbr vk cv c1 cmin co cz
      wcel vk cv cn wcel c1 vk cv clt wbr c1 vk cv c1 cmin co cle wbr c1 cn
      wcel vk cv cn wcel c1 vk cv clt wbr c1 vk cv c1 cmin co cle wbr wb 1nn c1
      vk cv nnltlem1 mpan biimpd anim2d vk cv c1 cmin co elnnz1 syl6ibr mpand
      vk cv c1 cmin co cn wcel vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel
      wi vk cn wral vk cv c1 cmin co vj cv cle wbr vj cv vk cv c1 cmin co cbc
      co cn wcel vk cv c1 cmin co cn wcel vn cv vj cv cle wbr vj cv vn cv cbc
      co cn wcel wi vn cn wral vk cv c1 cmin co vj cv cle wbr vj cv vk cv c1
      cmin co cbc co cn wcel wi vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel
      wi vk cn wral vn cv vj cv cle wbr vj cv vn cv cbc co cn wcel wi vk cv c1
      cmin co vj cv cle wbr vj cv vk cv c1 cmin co cbc co cn wcel wi vn vk cv
      c1 cmin co cn vn cv vk cv c1 cmin co wceq vn cv vj cv cle wbr vk cv c1
      cmin co vj cv cle wbr vj cv vn cv cbc co cn wcel vj cv vk cv c1 cmin co
      cbc co cn wcel vn cv vk cv c1 cmin co vj cv cle breq1 vn cv vk cv c1 cmin
      co wceq vj cv vn cv cbc co vj cv vk cv c1 cmin co cbc co cn vn cv vk cv
      c1 cmin co vj cv cbc opreq2 eleq1d imbi12d rcla4v vk cv vj cv cle wbr vj
      cv vk cv cbc co cn wcel wi vn cv vj cv cle wbr vj cv vn cv cbc co cn wcel
      wi vk vn cn vk cv vn cv wceq vk cv vj cv cle wbr vn cv vj cv cle wbr vj
      cv vk cv cbc co cn wcel vj cv vn cv cbc co cn wcel vk cv vn cv vj cv cle
      breq1 vk cv vn cv wceq vj cv vk cv cbc co vj cv vn cv cbc co cn vk cv vn
      cv vj cv cbc opreq2 eleq1d imbi12d cbvralv syl5ib com23 syl6 adantr vk cv
      cr wcel vj cv cr wcel vk cv vj cv cle wbr vk cv c1 cmin co vj cv cle wbr
      wi vk cv cn wcel vj cv cn wcel vk cv cr wcel vj cv cr wcel wa vk cv c1
      cmin co vk cv cle wbr vk cv vj cv cle wbr vk cv c1 cmin co vj cv cle wbr
      vk cv cr wcel vk cv c1 cmin co vk cv cle wbr vj cv cr wcel vk cv cr wcel
      vk cv c1 cmin co vk cv cle wbr vk cv vk cv c1 caddc co cle wbr vk cv lep1
      vk cv cr wcel vk cv c1 cmin co vk cv cle wbr vk cv vk cv c1 caddc co cle
      wbr wb vk cv cr wcel c1 cr wcel vk cv cr wcel vk cv c1 cmin co vk cv cle
      wbr vk cv vk cv c1 caddc co cle wbr wb 1re vk cv c1 vk cv lesubadd mp3an2
      anidms mpbird adantr vk cv c1 cmin co cr wcel vk cv cr wcel wa vj cv cr
      wcel vk cv c1 cmin co vk cv cle wbr vk cv vj cv cle wbr wa vk cv c1 cmin
      co vj cv cle wbr wi vk cv cr wcel vk cv c1 cmin co cr wcel vk cv cr wcel
      vj cv cr wcel vk cv c1 cmin co vk cv cle wbr vk cv vj cv cle wbr wa vk cv
      c1 cmin co vj cv cle wbr wi vk cv c1 cmin co vk cv vj cv letr 3expa vk cv
      cr wcel vk cv c1 cmin co cr wcel vk cv peano2rem ancri sylan mpand vk cv
      nnre vj cv nnre syl2an syl5d imp42 sylanc vk cv cn wcel vj cv cn wcel wa
      c1 vk cv clt wbr vk cv vj cv cle wbr wa wa vj cv vk cv cbc co vj cv vk cv
      c1 cmin co cbc co caddc co cn wcel vj cv c1 caddc co vk cv cbc co cn wcel
      wb vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi vk cn wral vk cv cn
      wcel vj cv cn wcel wa vk cv vj cv cle wbr vj cv vk cv cbc co vj cv vk cv
      c1 cmin co cbc co caddc co cn wcel vj cv c1 caddc co vk cv cbc co cn wcel
      wb c1 vk cv clt wbr vk cv cn wcel vj cv cn wcel wa vk cv vj cv cle wbr wa
      vj cv vk cv cbc co vj cv vk cv c1 cmin co cbc co caddc co vj cv c1 caddc
      co vk cv cbc co cn vk cv cn wcel vj cv cn wcel vk cv vj cv cle wbr vj cv
      vk cv cbc co vj cv vk cv c1 cmin co cbc co caddc co vj cv c1 caddc co vk
      cv cbc co wceq vj cv cn wcel vk cv cn wcel vk cv vj cv cle wbr vj cv vk
      cv cbc co vj cv vk cv c1 cmin co cbc co caddc co vj cv c1 caddc co vk cv
      cbc co wceq vk cv vj cv bcpasc2 3com12 3expa eleq1d adantrl adantr mpbid
      exp31 com12 c1 vk cv wceq vk cv cn wcel vj cv cn wcel wa vj cv c1 caddc
      co vk cv cbc co cn wcel vk cv vj cv cle wbr vj cv vk cv cbc co cn wcel wi
      vk cn wral c1 vk cv wceq vj cv cn wcel vj cv c1 caddc co vk cv cbc co cn
      wcel vk cv cn wcel c1 vk cv wceq vj cv c1 caddc co c1 cbc co cn wcel vj
      cv c1 caddc co vk cv cbc co cn wcel vj cv cn wcel c1 vk cv wceq vj cv c1
      caddc co c1 cbc co vj cv c1 caddc co vk cv cbc co cn c1 vk cv vj cv c1
      caddc co cbc opreq2 eleq1d vj cv cn wcel vj cv c1 caddc co c1 cbc co vj
      cv c1 caddc co cn vj cv cn wcel vj cv cn0 wcel vj cv c1 caddc co c1 cbc
      co vj cv c1 caddc co wceq vj cv nnnn0 vj cv bcnp11 syl vj cv peano2nn
      eqeltrd syl5bi adantld a1dd vk cv vj cv c1 caddc co wceq vk cv cn wcel vj
      cv cn wcel wa vj cv c1 caddc co vk cv cbc co cn wcel vk cv vj cv cle wbr
      vj cv vk cv cbc co cn wcel wi vk cn wral vk cv vj cv c1 caddc co wceq vk
      cv cn wcel vj cv c1 caddc co vk cv cbc co cn wcel vj cv cn wcel vk cv vj
      cv c1 caddc co wceq vk cv vk cv cbc co cn wcel vj cv c1 caddc co vk cv
      cbc co cn wcel vk cv cn wcel vk cv vj cv c1 caddc co wceq vk cv vk cv cbc
      co vj cv c1 caddc co vk cv cbc co cn vk cv vj cv c1 caddc co vk cv cbc
      opreq1 eleq1d vk cv cn wcel vk cv vk cv cbc co c1 cn vk cv cn wcel vk cv
      cn0 wcel vk cv vk cv cbc co c1 wceq vk cv nnnn0 vk cv bcnn syl 1nn
      syl6eqel syl5bi adantrd a1dd ccase2 com12 mpand sylbid ex com23 com4t
      r19.21ad nnind syl5com imp cN cc0 wceq cK cn wcel wa cK cN cle wbr cN cK
      cbc co cn wcel cN cc0 wceq cK cn wcel cK cN cle wbr wn cN cc0 wceq cK cN
      cle wbr wn cK cc0 cle wbr wn cK cn wcel cN cc0 wceq cK cN cle wbr cK cc0
      cle wbr cN cc0 cK cle breq2 notbid cK cn wcel cc0 cK clt wbr cK cc0 cle
      wbr wn cK nngt0 cc0 cr wcel cK cr wcel cc0 cK clt wbr cK cc0 cle wbr wn
      wb cK cn wcel cc0 cK ltnle 0re cK nnre sylancr mpbid syl5bir imp pm2.21d
      cN cn wcel cK cc0 wceq wa cN cK cbc co cn wcel cK cN cle wbr cN cn wcel
      cK cc0 wceq wa cN cK cbc co cn wcel cN cc0 cbc co cn wcel cN cn wcel cN
      cc0 cbc co cn wcel cK cc0 wceq cN cn wcel cN cc0 cbc co c1 cn cN cn wcel
      cN cn0 wcel cN cc0 cbc co c1 wceq cN nnnn0 cN bcn0 syl 1nn syl6eqel
      adantr cK cc0 wceq cN cK cbc co cn wcel cN cc0 cbc co cn wcel wb cN cn
      wcel cK cc0 wceq cN cK cbc co cN cc0 cbc co cn cK cc0 cN cbc opreq2
      eleq1d adantl mpbird a1d cN cc0 wceq cK cc0 wceq wa cN cK cbc co cn wcel
      cK cN cle wbr cN cc0 wceq cK cc0 wceq wa cN cK cbc co cc0 cc0 cbc co cn
      cN cc0 cK cc0 cbc opreq12 cc0 cc0 cbc co c1 cn cc0 cn0 wcel cc0 cc0 cbc
      co c1 wceq 0nn0 cc0 bcn0 ax-mp 1nn eqeltri syl6eqel a1d ccase cN elnn0 cK
      elnn0 syl2anb 3impia cn0 cK cN elfz3nn0 cK cc0 cN cfz co wcel cK cn0 wcel
      cN cn0 wcel cK cN elfznn0 adantl cK cc0 cN cfz co wcel cK cN cle wbr cN
      cn0 wcel cK cc0 cN elfzle2 adantl syl3anc $.
      $( [11-Apr-2006] $) $( [3-Jan-2006] $)
  $}

  $( A binomial coefficient, in its extended domain, is a nonnegative
     integer. $)
  bccl $p |- ( ( N e. NN0 /\ K e. ZZ ) -> ( N _C K ) e. NN0 ) $=
    cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr wa cN cK cbc co cn0
    wcel cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr wa wa cN cK cbc
    co cn wcel cN cK cbc co cn0 wcel cN cn0 wcel cK cc0 cN cfz co wcel cN cK
    cbc co cn wcel cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr wa wa
    cK cN bccl2 cN cn0 wcel cK cz wcel cc0 cK cle wbr cK cN cle wbr wa simpll
    cN cn0 wcel cK cz wcel cc0 cK cle wbr cK cN cle wbr cK cc0 cN cfz co wcel
    cN cn0 wcel cK cz wcel cc0 cK cle wbr cK cN cle wbr cK cc0 cN cfz co wcel
    wi cN cn0 wcel cK cn0 wcel cK cN cle wbr cK cc0 cN cfz co wcel wi cK cz
    wcel cc0 cK cle wbr wa cN cn0 wcel cK cn0 wcel cK cN cle wbr cK cc0 cN cfz
    co wcel cN cn0 wcel cK cc0 cN cfz co wcel cK cn0 wcel cK cN cle wbr wa cK
    cN fznn0 biimprd exp3a cK elnn0z syl5ibr exp3a imp43 sylanc cN cK cbc co
    nnnn0 syl cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr wa wn wa
    cN cK cbc co cc0 cn0 cN cn0 wcel cK cz wcel wa cc0 cK cle wbr cK cN cle wbr
    wa wn cN cK cbc co cc0 cK cle wbr cK cN cle wbr wa cN cfa cfv cN cK cmin co
    cfa cfv cK cfa cfv cmul co cdiv co cc0 cif cc0 cK cN bcval cc0 cK cle wbr
    cK cN cle wbr wa cN cfa cfv cN cK cmin co cfa cfv cK cfa cfv cmul co cdiv
    co cc0 iffalse sylan9eq 0nn0 syl6eqel pm2.61dan $.
    $( [22-Sep-2005] $) $( [10-Jul-2005] $)

  $( The number of permutations of ` N - R ` objects from a collection of ` N `
     objects is a natural number.  (Contributed by Jason Orendorff,
     24-Jan-2007.) $)
  permnn $p |- ( ( N e. NN0 /\ R e. ( 0 ... N ) ) ->
               ( ( ! ` N ) / ( ! ` R ) ) e. NN ) $=
    cR cfa cfv cn wcel cN cR cmin co cfa cfv cR cfa cfv cmul co cn wcel cN cfa
    cfv cc wcel w3a cN cR cmin co cfa cfv cR cfa cfv cmul co cR cfa cfv cdiv co
    cn wcel cN cfa cfv cN cR cmin co cfa cfv cR cfa cfv cmul co cdiv co cn wcel
    wa cN cfa cfv cR cfa cfv cdiv co cn wcel cN cn0 wcel cR cc0 cN cfz co wcel
    wa cR cfa cfv cN cR cmin co cfa cfv cR cfa cfv cmul co cN cfa cfv nndivtr
    cN cn0 wcel cR cc0 cN cfz co wcel wa cR cfa cfv cn wcel cN cR cmin co cfa
    cfv cR cfa cfv cmul co cn wcel cN cfa cfv cc wcel cR cc0 cN cfz co wcel cR
    cfa cfv cn wcel cN cn0 wcel cR cc0 cN cfz co wcel cR cn0 wcel cR cfa cfv cn
    wcel cR cN elfznn0 cR faccl syl adantl cN cR cmin co cfa cfv cn wcel cR cfa
    cfv cn wcel cN cR cmin co cfa cfv cR cfa cfv cmul co cn wcel cN cn0 wcel cR
    cc0 cN cfz co wcel wa cN cR cmin co cfa cfv cR cfa cfv nnmulcl cN cn0 wcel
    cR cc0 cN cfz co wcel wa cN cR cmin co cn0 wcel cN cR cmin co cfa cfv cn
    wcel cn0 cR cc0 cN fznn0sub cN cR cmin co faccl syl cR cc0 cN cfz co wcel
    cR cfa cfv cn wcel cN cn0 wcel cR cc0 cN cfz co wcel cR cn0 wcel cR cfa cfv
    cn wcel cR cN elfznn0 cR faccl syl adantl sylanc cN cn0 wcel cN cfa cfv cc
    wcel cR cc0 cN cfz co wcel cN cn0 wcel cN cfa cfv cn wcel cN cfa cfv cc
    wcel cN faccl cN cfa cfv nncn syl adantr 3jca cN cn0 wcel cR cc0 cN cfz co
    wcel wa cN cR cmin co cfa cfv cR cfa cfv cmul co cR cfa cfv cdiv co cn wcel
    cN cfa cfv cN cR cmin co cfa cfv cR cfa cfv cmul co cdiv co cn wcel cN cn0
    wcel cR cc0 cN cfz co wcel wa cN cR cmin co cfa cfv cR cfa cfv cmul co cR
    cfa cfv cdiv co cN cR cmin co cfa cfv cn cN cR cmin co cfa cfv cc wcel cR
    cfa cfv cc wcel cR cfa cfv cc0 wne cN cR cmin co cfa cfv cR cfa cfv cmul co
    cR cfa cfv cdiv co cN cR cmin co cfa cfv wceq cN cn0 wcel cR cc0 cN cfz co
    wcel wa cN cR cmin co cfa cfv cR cfa cfv divcan4 cN cn0 wcel cR cc0 cN cfz
    co wcel wa cN cR cmin co cfa cfv cn wcel cN cR cmin co cfa cfv cc wcel cN
    cn0 wcel cR cc0 cN cfz co wcel wa cN cR cmin co cn0 wcel cN cR cmin co cfa
    cfv cn wcel cn0 cR cc0 cN fznn0sub cN cR cmin co faccl syl cN cR cmin co
    cfa cfv nncn syl cR cc0 cN cfz co wcel cR cfa cfv cc wcel cN cn0 wcel cR
    cc0 cN cfz co wcel cR cfa cfv cn wcel cR cfa cfv cc wcel cR cc0 cN cfz co
    wcel cR cn0 wcel cR cfa cfv cn wcel cR cN elfznn0 cR faccl syl cR cfa cfv
    nncn syl adantl cR cc0 cN cfz co wcel cR cfa cfv cc0 wne cN cn0 wcel cR cc0
    cN cfz co wcel cR cn0 wcel cR cfa cfv cc0 wne cR cN elfznn0 cR facne0 syl
    adantl syl3anc cN cn0 wcel cR cc0 cN cfz co wcel wa cN cR cmin co cn0 wcel
    cN cR cmin co cfa cfv cn wcel cn0 cR cc0 cN fznn0sub cN cR cmin co faccl
    syl eqeltrd cN cn0 wcel cR cc0 cN cfz co wcel wa cN cR cbc co cN cfa cfv cN
    cR cmin co cfa cfv cR cfa cfv cmul co cdiv co cn cR cN bcval3 cR cN bccl2
    eqeltrrd jca sylanc $.
    $( [24-Jan-2007] $) $( [24-Jan-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~~> $.  $( Limit arrow. $)

  $( Extend class notation with convergence relation for limits. $)
  cli $a class ~~> $.

  ${
    $d j k x y f $.
    $( Define the limit relation for complex number sequences.   See ~ clim
       for its relational expression. $)
    df-clim $a |- ~~> = { <. f , y >. | ( y e. CC /\
          A. x e. RR ( 0 < x ->
             E. j e. ZZ A. k e. ZZ ( j <_ k ->
              ( ( f ` k ) e. CC /\ ( abs ` ( ( f ` k ) - y ) ) < x ) ) ) ) } $.

    $( The limit relation is a relation. $)
    climrel $p |- Rel ~~> $=
      cli wrel vy cv cc wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv
      cfv cc wcel vk cv vf cv cfv vy cv cmin co cabs cfv vx cv clt wbr wa wi vk
      cz wral vj cz wrex wi vx cr wral wa vf vy copab wrel vy cv cc wcel cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cc wcel vk cv vf cv cfv vy
      cv cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral wa vf vy relopab cli vy cv cc wcel cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv vf cv cfv cc wcel vk cv vf cv cfv vy cv cmin co cabs cfv vx cv
      clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral wa vf vy copab vx vy vf
      vj vk df-clim releqi mpbir $.
      $( [21-Sep-2005] $) $( [28-Aug-2005] $)
  $}

  ${
    $d j k x y f F $.  $d j k x y f A $.  $d j k x B $.
    $( Express the predicate: The limit of complex number sequence ` F `
       is ` A ` , or ` F ` converges to ` A ` .  This means that for any
       real ` x ` , no matter how small, there always exists an integer
       ` j ` such that the absolute difference of any later complex number
       in the sequence and the limit is less than ` x ` . $)
    clim $p |- ( ( F e. C /\ A e. D ) -> ( F ~~> A <-> ( A e. CC /\
   A. x e. RR ( 0 < x -> E. j e. ZZ A. k e. ZZ ( j <_ k ->
    ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) ) ) $=
      vy cv cc wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cc
      wcel vk cv vf cv cfv vy cv cmin co cabs cfv vx cv clt wbr wa wi vk cz
      wral vj cz wrex wi vx cr wral wa vy cv cc wcel cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin co cabs cfv vx cv
      clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral wa cA cc wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral wa vf vy
      cF cA cC cD cli vf cv cF wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      vf cv cfv cc wcel vk cv vf cv cfv vy cv cmin co cabs cfv vx cv clt wbr wa
      wi vk cz wral vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin co cabs cfv vx cv clt
      wbr wa wi vk cz wral vj cz wrex wi vx cr wral vy cv cc wcel vf cv cF wceq
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cc wcel vk cv vf cv
      cfv vy cv cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex wi
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv
      vy cv cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      vf cv cF wceq vj cv vk cv cle wbr vk cv vf cv cfv cc wcel vk cv vf cv cfv
      vy cv cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex vj cv vk
      cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin co cabs cfv vx cv
      clt wbr wa wi vk cz wral vj cz wrex cc0 vx cv clt wbr vf cv cF wceq vj cv
      vk cv cle wbr vk cv vf cv cfv cc wcel vk cv vf cv cfv vy cv cmin co cabs
      cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF
      cfv vy cv cmin co cabs cfv vx cv clt wbr wa wi vj vk cz cz vf cv cF wceq
      vk cv vf cv cfv cc wcel vk cv vf cv cfv vy cv cmin co cabs cfv vx cv clt
      wbr wa vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin co cabs cfv vx cv clt
      wbr wa vj cv vk cv cle wbr vf cv cF wceq vk cv vf cv cfv cc wcel vk cv cF
      cfv cc wcel vk cv vf cv cfv vy cv cmin co cabs cfv vx cv clt wbr vk cv cF
      cfv vy cv cmin co cabs cfv vx cv clt wbr vf cv cF wceq vk cv vf cv cfv vk
      cv cF cfv cc vk cv vf cv cF fveq1 eleq1d vf cv cF wceq vk cv vf cv cfv vy
      cv cmin co cabs cfv vk cv cF cfv vy cv cmin co cabs cfv vx cv clt vf cv
      cF wceq vk cv vf cv cfv vy cv cmin co vk cv cF cfv vy cv cmin co cabs vf
      cv cF wceq vk cv vf cv cfv vk cv cF cfv vy cv cmin vk cv vf cv cF fveq1
      opreq1d fveq2d breq1d anbi12d imbi2d rexralbidv imbi2d ralbidv anbi2d vy
      cv cA wceq vy cv cc wcel cA cc wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin co cabs cfv vx cv clt wbr wa
      wi vk cz wral vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wa wi vk cz wral vj cz wrex wi vx cr wral vy cv cA cc eleq1 vy cv cA wceq
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv
      vy cv cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex wi cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr vy cv
      cA wceq vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin
      co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vk cz wral vj cz wrex cc0 vx cv clt wbr vy cv cA wceq vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv vy cv cmin co cabs cfv vx cv clt wbr wa
      wi vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wa wi vj vk cz cz vy cv cA wceq vk cv cF cfv cc wcel vk
      cv cF cfv vy cv cmin co cabs cfv vx cv clt wbr wa vk cv cF cfv cc wcel vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vj cv vk cv cle wbr vy cv
      cA wceq vk cv cF cfv vy cv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr vk cv cF cfv cc wcel vy cv cA wceq vk cv
      cF cfv vy cv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv vx cv clt
      vy cv cA wceq vk cv cF cfv vy cv cmin co vk cv cF cfv cA cmin co cabs vy
      cv cA vk cv cF cfv cmin opreq2 fveq2d breq1d anbi2d imbi2d rexralbidv
      imbi2d ralbidv anbi12d vx vy vf vj vk df-clim brabg $.
      $( [18-Sep-2005] $) $( [28-Aug-2005] $)

    $( Closure of the limit of a sequence of complex numbers. $)
    climcl $p |- ( ( A e. C /\ F ~~> A ) -> A e. CC ) $=
      cA cC wcel cF cA cli wbr cA cc wcel cF cvv wcel cA cC wcel cF cA cli wbr
      cA cc wcel wi cF cvv wcel cA cC wcel wa cF cA cli wbr cA cc wcel cF cvv
      wcel cA cC wcel wa cF cA cli wbr cA cc wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wa wi vk cz wral vj cz wrex wi vx cr wral vx cA cvv cC vj vk cF clim
      pm3.26bda ex cF cvv wcel wn cF cA cli wbr cA cc wcel wi cA cC wcel cF cvv
      wcel wn cF cA cli wbr cA cc wcel cF cA cli wbr cF cvv wcel cF cA cli
      climrel brrelexi con3i pm2.21d adantr pm2.61ian imp $.
      $( [21-Sep-2005] $) $( [28-Aug-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Finite and infinite sums
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c sum_ $. $( Summation sign. $)

  $( Extend class notation to include finite summations. (An underscore was
     added to the ASCII token in order to facilitate set.mm text searches,
     since "sum" is is a commonly used word in comments.) $)
  csu $a class sum_ k e. A B $.

  ${
    $d k m n x y $.  $d A m n x y $.  $d B m n x y $.  $d C m n x y $.
    $( Define the sum of a series with an index set of integers ` A ` .
       ` k ` is normally a free variable in ` B ` , i.e. ` B ` can be thought
       of as ` B ( k ) ` .  The definition is meaningful when ` A ` is a finite
       set of sequential integers (representing a finite sum over them) or a
       set of upper integers (representing an infinite sum, when the sum
       converges).  The left-hand side of the union expresses the finite sum
       case, and the right-hand side expresses the infinite sum case.  In
       either case, the other side of the union equals the empty set.
       Examples: ` sum_ k e. ( 2 ... 4 ) ` ` k ` means 2 + 3 + 4 = 9, and
       ` sum_ k e. NN ` ` ( 1 / ( 2 ^ k ) ) ` means 1/2 + 1/4 + 1/8 + ... = 1.
       Note 1:  The restrictions to ` ZZ ` force the class abstractions to be
       sets.  Note 2:  This definition is complex because it is "overloaded"
       with both finite and infinite sums as disjoint sets.  An advantage is
       that equality theorems, for example, need to be proved only once for
       both cases. $)
    df-sum $a |- sum_ k e. A B = (
                     { x | E. m E. n e. ( ZZ>= ` m ) ( A = ( m ... n )
   /\ x e. ( ( <. m , + >. seq ( { <. k , y >. | y = B } |` ZZ ) ) ` n ) ) }
   u. U. { x | E. m e. ZZ ( A = ( ZZ>= ` m ) /\
    ( <. m , + >. seq ( { <. k , y >. | y = B } |` ZZ ) ) ~~> x ) } ) $.

    $( A sum is a set. $)
    sumex $p |- sum_ k e. A B e. _V $=
      cA cB vk csu cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv
      cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk vy
      copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cun cvv vx
      vy cA cB vk vm vn df-sum cA vm cv vn cv cfz co wceq vx cv vn cv vm cv
      caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex vx cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB
      wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni
      cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cB wceq vk
      vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cab
      vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa wa vn cz wrex
      vm cz wrex vx cab cvv cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm wex vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn
      cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa
      wa vn cz wrex vm cz wrex vx cA vm cv vn cv cfz co wceq vx cv vn cv vm cv
      caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vm vn
      2rexuz abbii vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv
      vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa wa
      vn cz wrex vm vx cz zex vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx
      cv vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv
      wcel wa wa vn vx cz zex vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx
      cv vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv
      wcel wa wa vx cab vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co fvex vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv
      vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa wa
      vx cab vx cv vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv wcel vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq wa wa vx
      cab vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv
      vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa wa vx cv vn cv
      vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel vm cv
      vn cv cle wbr cA vm cv vn cv cfz co wceq wa wa vx vm cv vn cv cle wbr cA
      vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv wcel wa wa vm cv vn cv cle wbr cA vm cv vn cv
      cfz co wceq wa vx cv vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz
      cres cseqz co cfv wcel wa vx cv vn cv vm cv caddc cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv wcel vm cv vn cv cle wbr cA vm cv vn cv cfz co
      wceq wa wa vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm
      cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel anass vm
      cv vn cv cle wbr cA vm cv vn cv cfz co wceq wa vx cv vn cv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel ancom bitr3i
      abbii vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq wa vx vn cv vm cv
      caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv ssab2 eqsstri
      ssexi abrexex2 abrexex2 eqeltri cA vm cv cuz cfv wceq vm cv caddc cop vy
      cv cB wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx
      cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm vx cz zex cA vm cv cuz cfv wceq vm cv
      caddc cop vy cv cB wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vx
      cab vx cv cc wcel vx cab vx cv cc wcel vx cab cc cvv vx cc abid2 axcnex
      eqeltri cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk vy copab
      cz cres cseqz co vx cv cli wbr wa vx cv cc wcel vx vm cv caddc cop vy cv
      cB wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cv cc wcel cA vm cv
      cuz cfv wceq vx cv cvv wcel vm cv caddc cop vy cv cB wceq vk vy copab cz
      cres cseqz co vx cv cli wbr vx cv cc wcel vx visset vx cv cvv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co climcl mpan adantl ss2abi
      ssexi abrexex2 uniex unex eqeltri $.
      $( [23-Dec-2005] $) $( [11-Dec-2005] $)

    $( Equality theorem for a sum. $)
    sumeq1 $p |- ( A = B -> sum_ k e. A C = sum_ k e. B C ) $=
      cA cB wceq cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv
      cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy
      copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cun cB vm
      cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk vy
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cab cB
      vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy copab cz cres
      cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cun cA cC vk csu cB cC
      vk csu cA cB wceq cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop
      vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vx cab cB vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop
      vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vx cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk
      vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cB vm
      cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz
      co vx cv cli wbr wa vm cz wrex vx cab cuni cA cB wceq cA vm cv vn cv cfz
      co wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex cB vm cv vn cv cfz co
      wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cA cB wceq cA vm cv vn cv
      cfz co wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv wcel wa vn vm cv cuz cfv wrex cB vm cv vn cv cfz co wceq vx
      cv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cfv
      wcel wa vn vm cv cuz cfv wrex vm cA cB wceq cA vm cv vn cv cfz co wceq vx
      cv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cfv
      wcel wa cB vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cC
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv cA cB wceq
      cA vm cv vn cv cfz co wceq cB vm cv vn cv cfz co wceq vx cv vn cv vm cv
      caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel cA cB vm cv
      vn cv cfz co eqeq1 anbi1d rexbidv exbidv abbidv cA cB wceq cA vm cv cuz
      cfv wceq vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co vx cv
      cli wbr wa vm cz wrex vx cab cB vm cv cuz cfv wceq vm cv caddc cop vy cv
      cC wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab
      cA cB wceq cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy
      copab cz cres cseqz co vx cv cli wbr wa vm cz wrex cB vm cv cuz cfv wceq
      vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co vx cv cli wbr
      wa vm cz wrex vx cA cB wceq cA vm cv cuz cfv wceq vm cv caddc cop vy cv
      cC wceq vk vy copab cz cres cseqz co vx cv cli wbr wa cB vm cv cuz cfv
      wceq vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co vx cv cli
      wbr wa vm cz cA cB wceq cA vm cv cuz cfv wceq cB vm cv cuz cfv wceq vm cv
      caddc cop vy cv cC wceq vk vy copab cz cres cseqz co vx cv cli wbr cA cB
      vm cv cuz cfv eqeq1 anbi1d rexbidv abbidv unieqd uneq12d vx vy cA cC vk
      vm vn df-sum vx vy cB cC vk vm vn df-sum 3eqtr4g $.
      $( [20-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d m n x y z A $.  $d m n x y z B $.  $d m n x y z k $.
    hbsum1.1 $e |- ( x e. A -> A. k x e. A ) $.
    $( Bound-variable hypothesis builder for sum. $)
    hbsum1 $p |- ( x e. sum_ k e. A B -> A. k x e. sum_ k e. A B ) $=
      vk vx cA cB vk csu cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop
      vz cv cB wceq vk vz copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vy cab cA vm cv cuz cfv wceq vm cv caddc cop vz cv cB wceq vk
      vz copab cz cres cseqz co vy cv cli wbr wa vm cz wrex vy cab cuni cun vy
      vz cA cB vk vm vn df-sum vk vx cA vm cv vn cv cfz co wceq vy cv vn cv vm
      cv caddc cop vz cv cB wceq vk vz copab cz cres cseqz co cfv wcel wa vn vm
      cv cuz cfv wrex vm wex vy cab cA vm cv cuz cfv wceq vm cv caddc cop vz cv
      cB wceq vk vz copab cz cres cseqz co vy cv cli wbr wa vm cz wrex vy cab
      cuni cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vz cv cB wceq
      vk vz copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vk
      vy vx cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vz cv cB
      wceq vk vz copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vk vm
      cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vz cv cB wceq vk
      vz copab cz cres cseqz co cfv wcel wa vk vn vm cv cuz cfv vn cv vm cv cuz
      cfv wcel vk ax-17 cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop
      vz cv cB wceq vk vz copab cz cres cseqz co cfv wcel vk vk vx vx cA vm cv
      vn cv cfz co hbsum1.1 vx cv vm cv vn cv cfz co wcel vk ax-17 hbeq vk vy
      vn cv vm cv caddc cop vz cv cB wceq vk vz copab cz cres cseqz co vk vy vm
      cv caddc cop vz cv cB wceq vk vz copab cz cres cseqz vy cv vm cv caddc
      cop wcel vk ax-17 vy cv cseqz wcel vk ax-17 vk vy vz cv cB wceq vk vz
      copab cz vz cv cB wceq vk vz vy hbopab1 vy cv cz wcel vk ax-17 hbres
      hbopr vy cv vn cv wcel vk ax-17 hbfv hban hbrex hbex hbab vk vx cA vm cv
      cuz cfv wceq vm cv caddc cop vz cv cB wceq vk vz copab cz cres cseqz co
      vy cv cli wbr wa vm cz wrex vy cab cA vm cv cuz cfv wceq vm cv caddc cop
      vz cv cB wceq vk vz copab cz cres cseqz co vy cv cli wbr wa vm cz wrex vk
      vy vx cA vm cv cuz cfv wceq vm cv caddc cop vz cv cB wceq vk vz copab cz
      cres cseqz co vy cv cli wbr wa vk vm cz vm cv cz wcel vk ax-17 cA vm cv
      cuz cfv wceq vm cv caddc cop vz cv cB wceq vk vz copab cz cres cseqz co
      vy cv cli wbr vk vk vx vx cA vm cv cuz cfv hbsum1.1 vx cv vm cv cuz cfv
      wcel vk ax-17 hbeq vk vn vm cv caddc cop vz cv cB wceq vk vz copab cz
      cres cseqz co vy cv cli vk vn vm cv caddc cop vz cv cB wceq vk vz copab
      cz cres cseqz vn cv vm cv caddc cop wcel vk ax-17 vn cv cseqz wcel vk
      ax-17 vk vn vz cv cB wceq vk vz copab cz vz cv cB wceq vk vz vn hbopab1
      vn cv cz wcel vk ax-17 hbres hbopr vn cv cli wcel vk ax-17 vn cv vy cv
      wcel vk ax-17 hbbr hban hbrex hbab hbuni hbun hbxfr $.
      $( [24-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d m n w y z A $.  $d m n w y z B $.  $d k m n w x y z $.
    hbsum.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbsum.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable hypothesis builder for sum:  if ` x ` is (effectively)
       not free in ` A ` and ` B ` , it is not free in ` sum_ k e. A B ` . $)
    hbsum $p |- ( y e. sum_ k e. A B -> A. x y e. sum_ k e. A B ) $=
      vx vy cA cB vk csu cA vm cv vn cv cfz co wceq vz cv vn cv vm cv caddc cop
      vw cv cB wceq vk vw copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vz cab cA vm cv cuz cfv wceq vm cv caddc cop vw cv cB wceq vk
      vw copab cz cres cseqz co vz cv cli wbr wa vm cz wrex vz cab cuni cun vz
      vw cA cB vk vm vn df-sum vx vy cA vm cv vn cv cfz co wceq vz cv vn cv vm
      cv caddc cop vw cv cB wceq vk vw copab cz cres cseqz co cfv wcel wa vn vm
      cv cuz cfv wrex vm wex vz cab cA vm cv cuz cfv wceq vm cv caddc cop vw cv
      cB wceq vk vw copab cz cres cseqz co vz cv cli wbr wa vm cz wrex vz cab
      cuni cA vm cv vn cv cfz co wceq vz cv vn cv vm cv caddc cop vw cv cB wceq
      vk vw copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx
      vz vy cA vm cv vn cv cfz co wceq vz cv vn cv vm cv caddc cop vw cv cB
      wceq vk vw copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vx vm
      cA vm cv vn cv cfz co wceq vz cv vn cv vm cv caddc cop vw cv cB wceq vk
      vw copab cz cres cseqz co cfv wcel wa vx vn vm cv cuz cfv vn cv vm cv cuz
      cfv wcel vx ax-17 cA vm cv vn cv cfz co wceq vz cv vn cv vm cv caddc cop
      vw cv cB wceq vk vw copab cz cres cseqz co cfv wcel vx vx vy vy cA vm cv
      vn cv cfz co hbsum.1 vy cv vm cv vn cv cfz co wcel vx ax-17 hbeq vx vz vn
      cv vm cv caddc cop vw cv cB wceq vk vw copab cz cres cseqz co vx vz vm cv
      caddc cop vw cv cB wceq vk vw copab cz cres cseqz vz cv vm cv caddc cop
      wcel vx ax-17 vz cv cseqz wcel vx ax-17 vx vz vw cv cB wceq vk vw copab
      cz vw cv cB wceq vk vw vx vz vx vy vy vw cv cB vy cv vw cv wcel vx ax-17
      hbsum.2 hbeq hbopab vz cv cz wcel vx ax-17 hbres hbopr vz cv vn cv wcel
      vx ax-17 hbfv hban hbrex hbex hbab vx vy cA vm cv cuz cfv wceq vm cv
      caddc cop vw cv cB wceq vk vw copab cz cres cseqz co vz cv cli wbr wa vm
      cz wrex vz cab cA vm cv cuz cfv wceq vm cv caddc cop vw cv cB wceq vk vw
      copab cz cres cseqz co vz cv cli wbr wa vm cz wrex vx vz vy cA vm cv cuz
      cfv wceq vm cv caddc cop vw cv cB wceq vk vw copab cz cres cseqz co vz cv
      cli wbr wa vx vm cz vm cv cz wcel vx ax-17 cA vm cv cuz cfv wceq vm cv
      caddc cop vw cv cB wceq vk vw copab cz cres cseqz co vz cv cli wbr vx vx
      vy vy cA vm cv cuz cfv hbsum.1 vy cv vm cv cuz cfv wcel vx ax-17 hbeq vx
      vy vm cv caddc cop vw cv cB wceq vk vw copab cz cres cseqz co vz cv cli
      vx vy vm cv caddc cop vw cv cB wceq vk vw copab cz cres cseqz vy cv vm cv
      caddc cop wcel vx ax-17 vy cv cseqz wcel vx ax-17 vx vy vw cv cB wceq vk
      vw copab cz vw cv cB wceq vk vw vx vy vx vy vy vw cv cB vy cv vw cv wcel
      vx ax-17 hbsum.2 hbeq hbopab vy cv cz wcel vx ax-17 hbres hbopr vy cv cli
      wcel vx ax-17 vy cv vz cv wcel vx ax-17 hbbr hban hbrex hbab hbuni hbun
      hbxfr $.
      $( [2-Feb-2006] $) $( [11-Dec-2005] $)
  $}

  ${
    $d k m n x y A $.  $d m n x y B $.  $d m n x y C $.
    $( Equality theorem for sum. $)
    sumeq2 $p |- ( A. k e. A B = C -> sum_ k e. A B = sum_ k e. A C ) $=
      cB cC wceq vk cA wral cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm wex vx cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB
      wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni
      cun cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cC wceq
      vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx
      cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cun cA cB vk csu cA
      cC vk csu cB cC wceq vk cA wral cA vm cv vn cv cfz co wceq vx cv vn cv vm
      cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm
      cv cuz cfv wrex vm wex vx cab cA vm cv vn cv cfz co wceq vx cv vn cv vm
      cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm
      cv cuz cfv wrex vm wex vx cab cA vm cv cuz cfv wceq vm cv caddc cop vy cv
      cB wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab
      cuni cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cB cC wceq vk cA
      wral cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cB wceq
      vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex cA
      vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk vy
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cB cC
      wceq vk cA wral cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy
      cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex
      cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk
      vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm cB cC wceq
      vk cA wral cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv
      cB wceq vk vy copab cz cres cseqz co cfv wcel wa cA vm cv vn cv cfz co
      wceq vx cv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv cB cC wceq vk cA wral vn cv vm cv cuz cfv
      wcel wa cA vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cB
      wceq vk vy copab cz cres cseqz co cfv wcel vx cv vn cv vm cv caddc cop vy
      cv cC wceq vk vy copab cz cres cseqz co cfv wcel cB cC wceq vk cA wral vn
      cv vm cv cuz cfv wcel wa cA vm cv vn cv cfz co wceq wa vn cv vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv vn cv vm cv caddc cop
      vy cv cC wceq vk vy copab cz cres cseqz co cfv vx cv cB cC wceq vk cA
      wral vn cv vm cv cuz cfv wcel wa cA vm cv vn cv cfz co wceq wa vn cv vm
      cv caddc cop vy cv cB wceq vk vy copab vm cv vn cv cfz co cres cseqz co
      cfv vn cv vm cv caddc cop vy cv cC wceq vk vy copab vm cv vn cv cfz co
      cres cseqz co cfv vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv vn cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv cB cC wceq vk cA wral cA vm cv vn cv cfz co wceq vn cv vm cv
      caddc cop vy cv cB wceq vk vy copab vm cv vn cv cfz co cres cseqz co cfv
      vn cv vm cv caddc cop vy cv cC wceq vk vy copab vm cv vn cv cfz co cres
      cseqz co cfv wceq vn cv vm cv cuz cfv wcel cB cC wceq vk cA wral cA vm cv
      vn cv cfz co wceq wa vn cv vm cv caddc cop vy cv cB wceq vk vy copab vm
      cv vn cv cfz co cres cseqz co vm cv caddc cop vy cv cC wceq vk vy copab
      vm cv vn cv cfz co cres cseqz co cB cC wceq vk cA wral cA vm cv vn cv cfz
      co wceq wa vy cv cB wceq vk vy copab vm cv vn cv cfz co cres vy cv cC
      wceq vk vy copab vm cv vn cv cfz co cres vm cv caddc cop cseqz cB cC wceq
      vk cA wral cA vm cv vn cv cfz co wceq wa vy cv cB wceq vk vy copab cA
      cres vy cv cC wceq vk vy copab cA cres vy cv cB wceq vk vy copab vm cv vn
      cv cfz co cres vy cv cC wceq vk vy copab vm cv vn cv cfz co cres cB cC
      wceq vk cA wral vy cv cB wceq vk vy copab cA cres vy cv cC wceq vk vy
      copab cA cres wceq cA vm cv vn cv cfz co wceq cB cC wceq vk cA wral vk cv
      cA wcel vy cv cB wceq wa vk vy copab vk cv cA wcel vy cv cC wceq wa vk vy
      copab vy cv cB wceq vk vy copab cA cres vy cv cC wceq vk vy copab cA cres
      cB cC wceq vk cA wral vk cv cA wcel vy cv cB wceq wa vk cv cA wcel vy cv
      cC wceq wa vk vy cB cC wceq vk cA hbra1 cB cC wceq vk cA wral vy ax-17 cB
      cC wceq vk cA wral vk cv cA wcel vy cv cB wceq vy cv cC wceq cB cC wceq
      vk cA wral vk cv cA wcel wa cB cC vy cv cB cC wceq vk cA wral vk cv cA
      wcel cB cC wceq cB cC wceq vk cA ra4 imp eqeq2d pm5.32da opabbid vy cv cB
      wceq vk vy cA resopab vy cv cC wceq vk vy cA resopab 3eqtr4g adantr cA vm
      cv vn cv cfz co wceq vy cv cB wceq vk vy copab cA cres vy cv cB wceq vk
      vy copab vm cv vn cv cfz co cres wceq cB cC wceq vk cA wral cA vm cv vn
      cv cfz co vy cv cB wceq vk vy copab reseq2 adantl cA vm cv vn cv cfz co
      wceq vy cv cC wceq vk vy copab cA cres vy cv cC wceq vk vy copab vm cv vn
      cv cfz co cres wceq cB cC wceq vk cA wral cA vm cv vn cv cfz co vy cv cC
      wceq vk vy copab reseq2 adantl 3eqtr3d opreq2d fveq1d adantlr vn cv vm cv
      cuz cfv wcel vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv vn cv vm cv caddc cop vy cv cB wceq vk vy copab vm cv vn cv
      cfz co cres cseqz co cfv wceq cB cC wceq vk cA wral cA vm cv vn cv cfz co
      wceq vn cv vm cv cuz cfv wcel vx cv vy cv cB wceq vk vy copab cz cres cfv
      vx cv vy cv cB wceq vk vy copab vm cv vn cv cfz co cres cfv wceq vx vm cv
      vn cv cfz co wral vn cv vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv vn cv vm cv caddc cop vy cv cB wceq vk vy copab vm cv vn cv
      cfz co cres cseqz co cfv wceq vx cv vy cv cB wceq vk vy copab cz cres cfv
      vx cv vy cv cB wceq vk vy copab vm cv vn cv cfz co cres cfv wceq vx vm cv
      vn cv cfz co vx cv vm cv vn cv cfz co wcel vx cv vy cv cB wceq vk vy
      copab cz cres cfv vx cv vy cv cB wceq vk vy copab cfv vx cv vy cv cB wceq
      vk vy copab vm cv vn cv cfz co cres cfv vx cv vm cv vn cv cfz co wcel vx
      cv cz wcel vx cv vy cv cB wceq vk vy copab cz cres cfv vx cv vy cv cB
      wceq vk vy copab cfv wceq vx cv vm cv vn cv elfzelz vx cv cz vy cv cB
      wceq vk vy copab fvres syl vx cv vm cv vn cv cfz co vy cv cB wceq vk vy
      copab fvres eqtr4d rgen caddc vx vy cv cB wceq vk vy copab cz cres vy cv
      cB wceq vk vy copab vm cv vn cv cfz co cres vm cv vn cv addex vy cv cB
      wceq vk vy copab wfun cz cvv wcel vy cv cB wceq vk vy copab cz cres cvv
      wcel vk vy cB funopabeq zex vy cv cB wceq vk vy copab cz cvv resfunexg
      mp2an vy cv cB wceq vk vy copab wfun vm cv vn cv cfz co cvv wcel vy cv cB
      wceq vk vy copab vm cv vn cv cfz co cres cvv wcel vk vy cB funopabeq vm
      cv vn cv cfz oprex vy cv cB wceq vk vy copab vm cv vn cv cfz co cvv
      resfunexg mp2an seqzfveq mpan2 ad2antlr vn cv vm cv cuz cfv wcel vn cv vm
      cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cfv vn cv vm cv
      caddc cop vy cv cC wceq vk vy copab vm cv vn cv cfz co cres cseqz co cfv
      wceq cB cC wceq vk cA wral cA vm cv vn cv cfz co wceq vn cv vm cv cuz cfv
      wcel vx cv vy cv cC wceq vk vy copab cz cres cfv vx cv vy cv cC wceq vk
      vy copab vm cv vn cv cfz co cres cfv wceq vx vm cv vn cv cfz co wral vn
      cv vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cfv vn cv
      vm cv caddc cop vy cv cC wceq vk vy copab vm cv vn cv cfz co cres cseqz
      co cfv wceq vx cv vy cv cC wceq vk vy copab cz cres cfv vx cv vy cv cC
      wceq vk vy copab vm cv vn cv cfz co cres cfv wceq vx vm cv vn cv cfz co
      vx cv vm cv vn cv cfz co wcel vx cv vy cv cC wceq vk vy copab cz cres cfv
      vx cv vy cv cC wceq vk vy copab cfv vx cv vy cv cC wceq vk vy copab vm cv
      vn cv cfz co cres cfv vx cv vm cv vn cv cfz co wcel vx cv cz wcel vx cv
      vy cv cC wceq vk vy copab cz cres cfv vx cv vy cv cC wceq vk vy copab cfv
      wceq vx cv vm cv vn cv elfzelz vx cv cz vy cv cC wceq vk vy copab fvres
      syl vx cv vm cv vn cv cfz co vy cv cC wceq vk vy copab fvres eqtr4d rgen
      caddc vx vy cv cC wceq vk vy copab cz cres vy cv cC wceq vk vy copab vm
      cv vn cv cfz co cres vm cv vn cv addex vy cv cC wceq vk vy copab wfun cz
      cvv wcel vy cv cC wceq vk vy copab cz cres cvv wcel vk vy cC funopabeq
      zex vy cv cC wceq vk vy copab cz cvv resfunexg mp2an vy cv cC wceq vk vy
      copab wfun vm cv vn cv cfz co cvv wcel vy cv cC wceq vk vy copab vm cv vn
      cv cfz co cres cvv wcel vk vy cC funopabeq vm cv vn cv cfz oprex vy cv cC
      wceq vk vy copab vm cv vn cv cfz co cvv resfunexg mp2an seqzfveq mpan2
      ad2antlr 3eqtr4d eleq2d pm5.32da rexbidva exbidv abbidv cB cC wceq vk cA
      wral cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cA vm cv cuz cfv wceq vm
      cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co vx cv cli wbr wa
      vm cz wrex vx cab cB cC wceq vk cA wral cA vm cv cuz cfv wceq vm cv caddc
      cop vy cv cB wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz
      wrex cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cB cC wceq vk cA wral cA vm
      cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz
      co vx cv cli wbr wa cA vm cv cuz cfv wceq vm cv caddc cop vy cv cC wceq
      vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz cB cC wceq vk cA wral
      vm cv cz wcel wa cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk
      vy copab cz cres cseqz co vx cv cli wbr vm cv caddc cop vy cv cC wceq vk
      vy copab cz cres cseqz co vx cv cli wbr cB cC wceq vk cA wral vm cv cz
      wcel wa cA vm cv cuz cfv wceq wa vm cv caddc cop vy cv cB wceq vk vy
      copab cz cres cseqz co vm cv caddc cop vy cv cC wceq vk vy copab cz cres
      cseqz co vx cv cli cB cC wceq vk cA wral vm cv cz wcel wa cA vm cv cuz
      cfv wceq wa vm cv caddc cop vy cv cB wceq vk vy copab vm cv cuz cfv cres
      cseqz co vm cv caddc cop vy cv cC wceq vk vy copab vm cv cuz cfv cres
      cseqz co vm cv caddc cop vy cv cB wceq vk vy copab cz cres cseqz co vm cv
      caddc cop vy cv cC wceq vk vy copab cz cres cseqz co cB cC wceq vk cA
      wral cA vm cv cuz cfv wceq vm cv caddc cop vy cv cB wceq vk vy copab vm
      cv cuz cfv cres cseqz co vm cv caddc cop vy cv cC wceq vk vy copab vm cv
      cuz cfv cres cseqz co wceq vm cv cz wcel cB cC wceq vk cA wral cA vm cv
      cuz cfv wceq wa vy cv cB wceq vk vy copab vm cv cuz cfv cres vy cv cC
      wceq vk vy copab vm cv cuz cfv cres vm cv caddc cop cseqz cB cC wceq vk
      cA wral cA vm cv cuz cfv wceq wa vy cv cB wceq vk vy copab cA cres vy cv
      cC wceq vk vy copab cA cres vy cv cB wceq vk vy copab vm cv cuz cfv cres
      vy cv cC wceq vk vy copab vm cv cuz cfv cres cB cC wceq vk cA wral vy cv
      cB wceq vk vy copab cA cres vy cv cC wceq vk vy copab cA cres wceq cA vm
      cv cuz cfv wceq cB cC wceq vk cA wral vk cv cA wcel vy cv cB wceq wa vk
      vy copab vk cv cA wcel vy cv cC wceq wa vk vy copab vy cv cB wceq vk vy
      copab cA cres vy cv cC wceq vk vy copab cA cres cB cC wceq vk cA wral vk
      cv cA wcel vy cv cB wceq wa vk cv cA wcel vy cv cC wceq wa vk vy cB cC
      wceq vk cA hbra1 cB cC wceq vk cA wral vy ax-17 cB cC wceq vk cA wral vk
      cv cA wcel vy cv cB wceq vy cv cC wceq cB cC wceq vk cA wral vk cv cA
      wcel wa cB cC vy cv cB cC wceq vk cA wral vk cv cA wcel cB cC wceq cB cC
      wceq vk cA ra4 imp eqeq2d pm5.32da opabbid vy cv cB wceq vk vy cA resopab
      vy cv cC wceq vk vy cA resopab 3eqtr4g adantr cA vm cv cuz cfv wceq vy cv
      cB wceq vk vy copab cA cres vy cv cB wceq vk vy copab vm cv cuz cfv cres
      wceq cB cC wceq vk cA wral cA vm cv cuz cfv vy cv cB wceq vk vy copab
      reseq2 adantl cA vm cv cuz cfv wceq vy cv cC wceq vk vy copab cA cres vy
      cv cC wceq vk vy copab vm cv cuz cfv cres wceq cB cC wceq vk cA wral cA
      vm cv cuz cfv vy cv cC wceq vk vy copab reseq2 adantl 3eqtr3d opreq2d
      adantlr vm cv cz wcel vm cv caddc cop vy cv cB wceq vk vy copab cz cres
      cseqz co vm cv caddc cop vy cv cB wceq vk vy copab vm cv cuz cfv cres
      cseqz co wceq cB cC wceq vk cA wral cA vm cv cuz cfv wceq vm cv cz wcel
      vx cv vy cv cB wceq vk vy copab cz cres cfv vx cv vy cv cB wceq vk vy
      copab vm cv cuz cfv cres cfv wceq vx vm cv cuz cfv wral vm cv caddc cop
      vy cv cB wceq vk vy copab cz cres cseqz co vm cv caddc cop vy cv cB wceq
      vk vy copab vm cv cuz cfv cres cseqz co wceq vx cv vy cv cB wceq vk vy
      copab cz cres cfv vx cv vy cv cB wceq vk vy copab vm cv cuz cfv cres cfv
      wceq vx vm cv cuz cfv vx cv vm cv cuz cfv wcel vx cv vy cv cB wceq vk vy
      copab cz cres cfv vx cv vy cv cB wceq vk vy copab cfv vx cv vy cv cB wceq
      vk vy copab vm cv cuz cfv cres cfv vx cv vm cv cuz cfv wcel vx cv cz wcel
      vx cv vy cv cB wceq vk vy copab cz cres cfv vx cv vy cv cB wceq vk vy
      copab cfv wceq vm cv vx cv eluzelz vx cv cz vy cv cB wceq vk vy copab
      fvres syl vx cv vm cv cuz cfv vy cv cB wceq vk vy copab fvres eqtr4d rgen
      caddc vx vy cv cB wceq vk vy copab cz cres vy cv cB wceq vk vy copab vm
      cv cuz cfv cres vm cv addex vy cv cB wceq vk vy copab wfun cz cvv wcel vy
      cv cB wceq vk vy copab cz cres cvv wcel vk vy cB funopabeq zex vy cv cB
      wceq vk vy copab cz cvv resfunexg mp2an vy cv cB wceq vk vy copab wfun vm
      cv cuz cfv cvv wcel vy cv cB wceq vk vy copab vm cv cuz cfv cres cvv wcel
      vk vy cB funopabeq vm cv cuz fvex vy cv cB wceq vk vy copab vm cv cuz cfv
      cvv resfunexg mp2an seqzeq mpan2 ad2antlr vm cv cz wcel vm cv caddc cop
      vy cv cC wceq vk vy copab cz cres cseqz co vm cv caddc cop vy cv cC wceq
      vk vy copab vm cv cuz cfv cres cseqz co wceq cB cC wceq vk cA wral cA vm
      cv cuz cfv wceq vm cv cz wcel vx cv vy cv cC wceq vk vy copab cz cres cfv
      vx cv vy cv cC wceq vk vy copab vm cv cuz cfv cres cfv wceq vx vm cv cuz
      cfv wral vm cv caddc cop vy cv cC wceq vk vy copab cz cres cseqz co vm cv
      caddc cop vy cv cC wceq vk vy copab vm cv cuz cfv cres cseqz co wceq vx
      cv vy cv cC wceq vk vy copab cz cres cfv vx cv vy cv cC wceq vk vy copab
      vm cv cuz cfv cres cfv wceq vx vm cv cuz cfv vx cv vm cv cuz cfv wcel vx
      cv vy cv cC wceq vk vy copab cz cres cfv vx cv vy cv cC wceq vk vy copab
      cfv vx cv vy cv cC wceq vk vy copab vm cv cuz cfv cres cfv vx cv vm cv
      cuz cfv wcel vx cv cz wcel vx cv vy cv cC wceq vk vy copab cz cres cfv vx
      cv vy cv cC wceq vk vy copab cfv wceq vm cv vx cv eluzelz vx cv cz vy cv
      cC wceq vk vy copab fvres syl vx cv vm cv cuz cfv vy cv cC wceq vk vy
      copab fvres eqtr4d rgen caddc vx vy cv cC wceq vk vy copab cz cres vy cv
      cC wceq vk vy copab vm cv cuz cfv cres vm cv addex vy cv cC wceq vk vy
      copab wfun cz cvv wcel vy cv cC wceq vk vy copab cz cres cvv wcel vk vy
      cC funopabeq zex vy cv cC wceq vk vy copab cz cvv resfunexg mp2an vy cv
      cC wceq vk vy copab wfun vm cv cuz cfv cvv wcel vy cv cC wceq vk vy copab
      vm cv cuz cfv cres cvv wcel vk vy cC funopabeq vm cv cuz fvex vy cv cC
      wceq vk vy copab vm cv cuz cfv cvv resfunexg mp2an seqzeq mpan2 ad2antlr
      3eqtr4d breq1d pm5.32da rexbidva abbidv unieqd uneq12d vx vy cA cB vk vm
      vn df-sum vx vy cA cC vk vm vn df-sum 3eqtr4g $.
      $( [20-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d m n x y A $.  $d m n x y B $.  $d m n x y C $.  $d j k m n x y $.
    cbvsum.1 $e |- ( x e. B -> A. k x e. B ) $.
    cbvsum.2 $e |- ( x e. C -> A. j x e. C ) $.
    cbvsum.3 $e |- ( j = k -> B = C ) $.
    $( Change bound variable in a sum. $)
    cbvsumi $p |- sum_ j e. A B = sum_ k e. A C $=
      cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv cB wceq vj
      vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vy cab
      cA vm cv cuz cfv wceq vm cv caddc cop vx cv cB wceq vj vx copab cz cres
      cseqz co vy cv cli wbr wa vm cz wrex vy cab cuni cun cA vm cv vn cv cfz
      co wceq vy cv vn cv vm cv caddc cop vx cv cC wceq vk vx copab cz cres
      cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vy cab cA vm cv cuz cfv
      wceq vm cv caddc cop vx cv cC wceq vk vx copab cz cres cseqz co vy cv cli
      wbr wa vm cz wrex vy cab cuni cun cA cB vj csu cA cC vk csu cA vm cv vn
      cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv cB wceq vj vx copab cz
      cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vy cab cA vm cv vn
      cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv cC wceq vk vx copab cz
      cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vy cab cA vm cv
      cuz cfv wceq vm cv caddc cop vx cv cB wceq vj vx copab cz cres cseqz co
      vy cv cli wbr wa vm cz wrex vy cab cuni cA vm cv cuz cfv wceq vm cv caddc
      cop vx cv cC wceq vk vx copab cz cres cseqz co vy cv cli wbr wa vm cz
      wrex vy cab cuni cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop
      vx cv cB wceq vj vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv
      cC wceq vk vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vy cA vm cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv cB
      wceq vj vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex cA vm
      cv vn cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv cC wceq vk vx
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm cA vm cv vn
      cv cfz co wceq vy cv vn cv vm cv caddc cop vx cv cB wceq vj vx copab cz
      cres cseqz co cfv wcel wa cA vm cv vn cv cfz co wceq vy cv vn cv vm cv
      caddc cop vx cv cC wceq vk vx copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv vy cv vn cv vm cv caddc cop vx cv cB wceq vj vx copab cz cres
      cseqz co cfv wcel vy cv vn cv vm cv caddc cop vx cv cC wceq vk vx copab
      cz cres cseqz co cfv wcel cA vm cv vn cv cfz co wceq vn cv vm cv caddc
      cop vx cv cB wceq vj vx copab cz cres cseqz co cfv vn cv vm cv caddc cop
      vx cv cC wceq vk vx copab cz cres cseqz co cfv vy cv vn cv vm cv caddc
      cop vx cv cB wceq vj vx copab cz cres cseqz co vm cv caddc cop vx cv cC
      wceq vk vx copab cz cres cseqz co vx cv cB wceq vj vx copab cz cres vx cv
      cC wceq vk vx copab cz cres vm cv caddc cop cseqz vx cv cB wceq vj vx
      copab vx cv cC wceq vk vx copab wceq vx cv cB wceq vj vx copab cz cres vx
      cv cC wceq vk vx copab cz cres wceq vx cv cB wceq vx cv cC wceq vj vx vk
      vk vx cB cbvsum.1 hbeleq vj vx cC cbvsum.2 hbeleq vj cv vk cv wceq cB cC
      vx cv cbvsum.3 eqeq2d cbvopab1 vx cv cB wceq vj vx copab vx cv cC wceq vk
      vx copab cz reseq1 ax-mp opreq2i fveq1i eleq2i anbi2i rexbii exbii abbii
      cA vm cv cuz cfv wceq vm cv caddc cop vx cv cB wceq vj vx copab cz cres
      cseqz co vy cv cli wbr wa vm cz wrex vy cab cA vm cv cuz cfv wceq vm cv
      caddc cop vx cv cC wceq vk vx copab cz cres cseqz co vy cv cli wbr wa vm
      cz wrex vy cab cA vm cv cuz cfv wceq vm cv caddc cop vx cv cB wceq vj vx
      copab cz cres cseqz co vy cv cli wbr wa vm cz wrex cA vm cv cuz cfv wceq
      vm cv caddc cop vx cv cC wceq vk vx copab cz cres cseqz co vy cv cli wbr
      wa vm cz wrex vy cA vm cv cuz cfv wceq vm cv caddc cop vx cv cB wceq vj
      vx copab cz cres cseqz co vy cv cli wbr wa cA vm cv cuz cfv wceq vm cv
      caddc cop vx cv cC wceq vk vx copab cz cres cseqz co vy cv cli wbr wa vm
      cz vm cv caddc cop vx cv cB wceq vj vx copab cz cres cseqz co vy cv cli
      wbr vm cv caddc cop vx cv cC wceq vk vx copab cz cres cseqz co vy cv cli
      wbr cA vm cv cuz cfv wceq vm cv caddc cop vx cv cB wceq vj vx copab cz
      cres cseqz co vm cv caddc cop vx cv cC wceq vk vx copab cz cres cseqz co
      vy cv cli vx cv cB wceq vj vx copab cz cres vx cv cC wceq vk vx copab cz
      cres vm cv caddc cop cseqz vx cv cB wceq vj vx copab vx cv cC wceq vk vx
      copab wceq vx cv cB wceq vj vx copab cz cres vx cv cC wceq vk vx copab cz
      cres wceq vx cv cB wceq vx cv cC wceq vj vx vk vk vx cB cbvsum.1 hbeleq
      vj vx cC cbvsum.2 hbeleq vj cv vk cv wceq cB cC vx cv cbvsum.3 eqeq2d
      cbvopab1 vx cv cB wceq vj vx copab vx cv cC wceq vk vx copab cz reseq1
      ax-mp opreq2i breq1i anbi2i rexbii abbii unieqi uneq12i vy vx cA cB vj vm
      vn df-sum vy vx cA cC vk vm vn df-sum 3eqtr4i $.
      $( [20-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    sumeq1i.1 $e |- A = B $.
    $( Equality inference for sum. $)
    sumeq1i $p |- sum_ k e. A C = sum_ k e. B C $=
      cA cB wceq cA cC vk csu cB cC vk csu wceq sumeq1i.1 cA cB cC vk sumeq1
      ax-mp $.
      $( [10-Jan-2006] $) $( [2-Jan-2006] $)
  $}

  ${
    $d k A $.
    sumeq2i.1 $e |- ( k e. A -> B = C ) $.
    $( Equality inference for sum. $)
    sumeq2i $p |- sum_ k e. A B = sum_ k e. A C $=
      cB cC wceq cA cB vk csu cA cC vk csu wceq vk cA cA cB cC vk sumeq2
      sumeq2i.1 mprg $.
      $( [19-Dec-2005] $) $( [3-Dec-2005] $)
  $}

  ${
    $d k A $.
    sumeq12i.1 $e |- A = B $.
    sumeq12i.2 $e |- ( k e. A -> C = D ) $.
    $( Equality inference for sum.  (Contributed by FL, 10-Dec-2006.) $)
    sumeq12i $p |- sum_ k e. A C = sum_ k e. B D $=
      cA cC vk csu cA cD vk csu cB cD vk csu cA cC cD vk sumeq12i.2 sumeq2i cA
      cB cD vk sumeq12i.1 sumeq1i eqtri $.
      $( [30-Jan-2007] $) $( [9-Dec-2006] $)
  $}

  ${
    sumeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for sum. $)
    sumeq1d $p |- ( ph -> sum_ k e. A C = sum_ k e. B C ) $=
      wph cA cB wceq cA cC vk csu cB cC vk csu wceq sumeq1d.1 cA cB cC vk
      sumeq1 syl $.
      $( [18-Nov-2005] $) $( [1-Nov-2005] $)
  $}

  ${
    $d k A $.
    sumeq2d.1 $e |- ( ph -> A. k e. A B = C ) $.
    $( Equality deduction for sum.  Note that unlike ~ sumeq2dv , ` k ` may
       occur in ` ph ` . $)
    sumeq2d $p |- ( ph -> sum_ k e. A B = sum_ k e. A C ) $=
      wph cB cC wceq vk cA wral cA cB vk csu cA cC vk csu wceq sumeq2d.1 cA cB
      cC vk sumeq2 syl $.
      $( [27-Nov-2005] $) $( [1-Nov-2005] $)
  $}

  ${
    $d k A $.  $d k ph $.
    sumeq2dv.1 $e |- ( ( ph /\ k e. A ) -> B = C ) $.
    $( Equality deduction for sum. $)
    sumeq2dv $p |- ( ph -> sum_ k e. A B = sum_ k e. A C ) $=
      wph cB cC wceq vk cA wral cA cB vk csu cA cC vk csu wceq wph cB cC wceq
      vk cA sumeq2dv.1 r19.21aiva cA cB cC vk sumeq2 syl $.
      $( [11-Jan-2006] $) $( [3-Jan-2006] $)
  $}

  ${
    $d k A $.  $d k ph $.
    sumeq2sdv.1 $e |- ( ph -> B = C ) $.
    $( Equality deduction for sum. $)
    sumeq2sdv $p |- ( ph -> sum_ k e. A B = sum_ k e. A C ) $=
      wph cA cB cC vk wph cB cC wceq vk cv cA wcel sumeq2sdv.1 adantr sumeq2dv
      $.
      $( [11-Jan-2006] $) $( [3-Jan-2006] $)
  $}

  ${
    $d j k A $.  $d k B $.  $d j k ph $.
    2sumeq2dv.1 $e |- ( ( ph /\ j e. A /\ k e. B ) -> C = D ) $.
    $( Equality deduction for double sum. $)
    2sumeq2dv $p |- ( ph ->
           sum_ j e. A sum_ k e. B C = sum_ j e. A sum_ k e. B D ) $=
      wph cB cC vk csu cB cD vk csu wceq vj cA wral cA cB cC vk csu vj csu cA
      cB cD vk csu vj csu wceq wph cC cD wceq vk cB wral vj cA wral cB cC vk
      csu cB cD vk csu wceq vj cA wral wph cC cD wceq vk cB wral vj cA wph vj
      cv cA wcel wa cC cD wceq vk cB wph vj cv cA wcel vk cv cB wcel cC cD wceq
      2sumeq2dv.1 3expa r19.21aiva r19.21aiva cC cD wceq vk cB wral cB cC vk
      csu cB cD vk csu wceq vj cA cB cC cD vk sumeq2 r19.20si syl cA cB cC vk
      csu cB cD vk csu vj sumeq2 syl $.
      $( [19-Apr-2006] $) $( [3-Jan-2006] $)
  $}

  ${
    $d k A $.  $d k ph $.
    sumeq12dv.1 $e |- ( ph -> A = B ) $.
    sumeq12dv.2 $e |- ( ( ph /\ k e. A ) -> C = D ) $.
    $( Equality deduction for sum. $)
    sumeq12dv $p |- ( ph -> sum_ k e. A C = sum_ k e. B D ) $=
      wph cA cC vk csu cA cD vk csu cB cD vk csu wph cA cC cD vk sumeq12dv.2
      sumeq2dv wph cA cB cD vk sumeq12dv.1 sumeq1d eqtrd $.
      $( [3-Feb-2007] $) $( [1-Dec-2005] $)
  $}

  ${
    $d k B $.  $d k ph $.
    sumeq12rdv.1 $e |- ( ph -> A = B ) $.
    sumeq12rdv.2 $e |- ( ( ph /\ k e. B ) -> C = D ) $.
    $( Equality deduction for sum. $)
    sumeq12rdv $p |- ( ph -> sum_ k e. A C = sum_ k e. B D ) $=
      wph cA cC vk csu cB cC vk csu cB cD vk csu wph cA cB cC vk sumeq12rdv.1
      sumeq1d wph cB cC cD vk sumeq12rdv.2 sumeq2dv eqtrd $.
      $( [1-Feb-2007] $) $( [1-Dec-2005] $)
  $}

  ${
    $d y A $.  $d k y B $.  $d k C $.
    sumeqfv.1 $e |- A e. _V $.
    sumeqfv.2 $e |- F = { <. k , y >. | ( k e. B /\ y = A ) } $.
    $( Convert a sum of function values to a sum of classes ` A ( k ) ` . $)
    sumeqfv $p |- ( C C_ B -> sum_ k e. C ( F ` k ) = sum_ k e. C A ) $=
      cC cB wss cC vk cv cF cfv cA vk cC cB wss vk cv cC wcel wa vk cv cB wcel
      vk cv cF cfv cA wceq cC cB vk cv ssel2 vk cv cB wcel vk cv vk cv cB wcel
      vy cv cA wceq wa vk vy copab cfv cA vk cv cF cfv vk cv cB wcel cA cvv
      wcel vk cv vk cv cB wcel vy cv cA wceq wa vk vy copab cfv cA wceq
      sumeqfv.1 vk vy cB cA cvv fvopab2 mpan2 vk cv cF vk cv cB wcel vy cv cA
      wceq wa vk vy copab sumeqfv.2 fveq1i syl5eq syl sumeq2dv $.
      $( [11-May-2006] $) $( [10-May-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Finite sums (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d m n x y A $.  $d m n x y M $.  $d m n x y N $.  $d k m n x y $.
    $( Special case of series sum over a finite index set. $)
    dffsum $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... N ) A =
       ( ( <. M , + >. seq ( { <. k , y >. | y = A } |` ZZ ) ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex vx cab cM cN cfz co vm cv cuz cfv wceq vm cv caddc
      cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz
      wrex vx cab cuni cun cN cM caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co cfv cM cN cfz co cA vk csu cN cM cuz cfv wcel cM cN cfz co vm cv
      vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab
      cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cab cM cN
      cfz co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cun cN cM caddc cop
      vy cv cA wceq vk vy copab cz cres cseqz co cfv c0 cun cN cM caddc cop vy
      cv cA wceq vk vy copab cz cres cseqz co cfv cN cM cuz cfv wcel cM cN cfz
      co vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA wceq vk
      vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cab
      cN cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv cM cN cfz
      co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni c0 cN cM cuz cfv wcel cM
      cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cN cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv cN
      cM cuz cfv wcel cM cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex vx cv cN cM caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co cfv wcel cN cM cuz cfv wcel cM cN cfz co vm cv vn cv cfz co
      wceq vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vm cv cM wceq vn cv cN wceq wa vx cv
      vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel
      wa vn vm cv cuz cfv wrex vm cN cM cuz cfv wcel cM cN cfz co vm cv vn cv
      cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co cfv wcel wa vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv cN cM cuz cfv wcel cM cN cfz co vm cv vn cv cfz co wceq vm cv cM
      wceq vn cv cN wceq wa vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz co cfv wcel cN cM cuz cfv wcel cM cN cfz co vm cv vn
      cv cfz co wceq cM vm cv wceq cN vn cv wceq wa vm cv cM wceq vn cv cN wceq
      wa cN cM cuz cfv wcel vn cv cvv wcel cM cN cfz co vm cv vn cv cfz co wceq
      cM vm cv wceq cN vn cv wceq wa wb vn visset cvv vm cv vn cv cM cN fzopth
      mpan2 cM vm cv wceq vm cv cM wceq cN vn cv wceq vn cv cN wceq cM vm cv
      eqcom cN vn cv eqcom anbi12i syl6bb anbi1d rexbidv exbidv cN cM cuz cfv
      wcel vm cv cM wceq vn cv cN wceq wa vm cv vn cv cle wbr vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa wa vn cz
      wrex vm cz wrex vx cv cN cM caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co cfv wcel vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv caddc
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm wex cN cM cuz cfv wcel vm cv cM wceq vn cv cN wceq wa vm cv
      vn cv cle wbr vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co cfv wcel wa wa vn cz wrex vm cz wrex cM cN cle wbr vx cv cN
      cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vx cv
      cN cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel cM cz
      wcel cN cz wcel vm cv cM wceq vn cv cN wceq wa vm cv vn cv cle wbr vx cv
      vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel
      wa wa vn cz wrex vm cz wrex cM cN cle wbr vx cv cN cM caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel wa wb cN cM cuz cfv wcel vm cv
      vn cv cle wbr vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co cfv wcel wa cM vn cv cle wbr vx cv vn cv cM caddc cop vy cv
      cA wceq vk vy copab cz cres cseqz co cfv wcel wa cM cN cle wbr vx cv cN
      cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vm vn
      cM cN cz cz vm cv cM wceq vm cv vn cv cle wbr cM vn cv cle wbr vx cv vn
      cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel vx
      cv vn cv cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel
      vm cv cM vn cv cle breq1 vm cv cM wceq vn cv vm cv caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv vn cv cM caddc cop vy cv cA wceq vk
      vy copab cz cres cseqz co cfv vx cv vm cv cM wceq vn cv vm cv caddc cop
      vy cv cA wceq vk vy copab cz cres cseqz co cM caddc cop vy cv cA wceq vk
      vy copab cz cres cseqz co vm cv cM wceq vm cv caddc cop cM caddc cop vy
      cv cA wceq vk vy copab cz cres cseqz vm cv cM caddc opeq1 opreq1d fveq1d
      eleq2d anbi12d vn cv cN wceq cM vn cv cle wbr cM cN cle wbr vx cv vn cv
      cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel vx cv cN
      cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel vn cv cN
      cM cle breq2 vn cv cN wceq vn cv cM caddc cop vy cv cA wceq vk vy copab
      cz cres cseqz co cfv cN cM caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co cfv vx cv vn cv cN cM caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co fveq2 eleq2d anbi12d ceqsrex2v cM cN eluzel2 cM cN eluzelz
      sylanc cN cM cuz cfv wcel cM cN cle wbr vx cv cN cM caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel cM cN eluzle biantrurd bitr4d
      vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv caddc cop vy cv cA wceq
      vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vm
      cv vn cv cle wbr vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv caddc
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa wa vn cz wrex
      vm cz wrex vm cv cM wceq vn cv cN wceq wa vm cv vn cv cle wbr vx cv vn cv
      vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa wa
      vn cz wrex vm cz wrex vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vm vn
      2rexuz vm cv vn cv cle wbr vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm
      cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa wa vm
      cv cM wceq vn cv cN wceq wa vm cv vn cv cle wbr vx cv vn cv vm cv caddc
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa wa vm vn cz cz
      vm cv vn cv cle wbr vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel an12
      2rexbii bitri syl5bb bitrd abbi1dv cN cM cuz cfv wcel cM cN cfz co vm cv
      cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co
      vx cv cli wbr wa vm cz wrex vx cab cuni c0 cuni c0 cN cM cuz cfv wcel cM
      cN cfz co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cab c0 cN cM cuz cfv wcel cM
      cN cfz co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx wex wn cM cN cfz co vm cv
      cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co
      vx cv cli wbr wa vm cz wrex vx cab c0 wceq cN cM cuz cfv wcel cM cN cfz
      co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co vx cv cli wbr wa vm cz wrex vx cN cM cuz cfv wcel cM cN cfz co
      vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co vx cv cli wbr wa vm cz cN cM cuz cfv wcel vm cv cz wcel wa cM cN
      cfz co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr vm cv cM cN fzneuz intnanrd nrexdv nexdv cM
      cN cfz co vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx wex cM cN cfz co vm cv cuz
      cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv
      cli wbr wa vm cz wrex vx cab c0 cM cN cfz co vm cv cuz cfv wceq vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm
      cz wrex vx abn0 necon1bbii sylib unieqd uni0 syl6eq uneq12d cN cM caddc
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv un0 syl6eq vx vy cM cN
      cfz co cA vk vm vn df-sum syl5eq $.
      $( [20-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d k y F $.  $d y M $.  $d y N $.
    fsumserz.1 $e |- F e. _V $.
    $( A finite sum expressed in terms of a partial sum of an infinite
       series.  The recursive definition of follows as ~ fsum1i and ~ fsump1i ,
       which should make our notation clear and from which, along with closure
       ~ fsumcl , we will derive the basic properties of finite sums. $)
    fsumserz $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... N ) ( F ` k ) =
                    ( ( <. M , + >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vk cv cF cfv vk csu cN cM caddc cop vy cv
      vk cv cF cfv wceq vk vy copab cz cres cseqz co cfv cN cM caddc cop cF
      cseqz co cfv vy vk cv cF cfv vk cM cN dffsum cN cM cuz cfv wcel cN cM
      caddc cop vy cv vk cv cF cfv wceq vk vy copab cz cres cseqz co cM caddc
      cop cF cseqz co cN cM cuz cfv wcel cM cz wcel cM caddc cop vy cv vk cv cF
      cfv wceq vk vy copab cz cres cseqz co cM caddc cop cF cseqz co wceq cM cN
      eluzel2 vy caddc vk cF cM addex fsumserz.1 seqzres2 syl fveq1d eqtrd $.
      $( [21-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d j x F $.  $d j x M $.  $d x N $.  $d j k x $.
    fsumserzf.1 $e |- F e. _V $.
    fsumserzf.2 $e |- ( x e. F -> A. k x e. F ) $.
    $( Version of ~ fsumserz with a bound-variable hypothesis instead of a
       distinct variable condition. $)
    fsumserzfi $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... N ) ( F ` k )
                   = ( ( <. M , + >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vj cv cF cfv vj csu cN cM caddc cop cF
      cseqz co cfv cM cN cfz co vk cv cF cfv vk csu vj cF cM cN fsumserzf.1
      fsumserz vx cM cN cfz co vk cv cF cfv vj cv cF cfv vk vj vx cv vk cv cF
      cfv wcel vj ax-17 vk vx vj cv cF fsumserzf.2 vx cv vj cv wcel vk ax-17
      hbfv vk cv vj cv cF fveq2 cbvsumi syl5eq $.
      $( [21-Nov-2005] $) $( [3-Nov-2005] $)

    $( A finite sum expressed in terms of a partial sum of an infinite
       0-based series. $)
    fsumser0fi $p |- ( N e. NN0 -> sum_ k e. ( 0 ... N ) ( F ` k )
                   = ( ( + seq0 F ) ` N ) ) $=
      cN cc0 cuz cfv wcel cc0 cN cfz co vk cv cF cfv vk csu cN cc0 caddc cop cF
      cseqz co cfv wceq cN cn0 wcel cc0 cN cfz co vk cv cF cfv vk csu cN caddc
      cF cseq0 co cfv wceq vx vk cF cc0 cN fsumserzf.1 fsumserzf.2 fsumserzfi
      cN elnn0uz cN caddc cF cseq0 co cfv cN cc0 caddc cop cF cseqz co cfv cc0
      cN cfz co vk cv cF cfv vk csu cN caddc cF cseq0 co cc0 caddc cop cF cseqz
      co caddc cF addex fsumserzf.1 seq0seqz fveq1i eqeq2i 3imtr4i $.
      $( [4-May-2006] $) $( [10-Jan-2006] $)

    $( A finite sum expressed in terms of a partial sum of an infinite
       1-based series. $)
    fsumser1fi $p |- ( N e. NN -> sum_ k e. ( 1 ... N ) ( F ` k )
                   = ( ( + seq1 F ) ` N ) ) $=
      cN c1 cuz cfv wcel c1 cN cfz co vk cv cF cfv vk csu cN c1 caddc cop cF
      cseqz co cfv wceq cN cn wcel c1 cN cfz co vk cv cF cfv vk csu cN caddc cF
      cseq1 co cfv wceq vx vk cF c1 cN fsumserzf.1 fsumserzf.2 fsumserzfi cN
      elnnuz cN caddc cF cseq1 co cfv cN c1 caddc cop cF cseqz co cfv c1 cN cfz
      co vk cv cF cfv vk csu cN caddc cF cseq1 co c1 caddc cop cF cseqz co
      caddc cF addex fsumserzf.1 seq1seqz fveq1i eqeq2i 3imtr4i $.
      $( [4-May-2006] $) $( [10-Jan-2006] $)
  $}

  ${
    $d y A $.  $d x F $.  $d k x y M $.  $d k x N $.
    fsumserz2.1 $e |- A e. _V $.
    fsumserz2.2 $e |- F = { <. k , y >. | ( k e. ( ZZ>= ` M ) /\ y = A ) } $.
    $( A finite sum expressed in terms of a partial sum of an infinite
       series. $)
    fsumserz2 $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... N ) A =
                    ( ( <. M , + >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vk cv cF cfv vk csu cN cM caddc cop cF
      cseqz co cfv cM cN cfz co cA vk csu vx vk cF cM cN vk vy cM cuz cfv cA cF
      cM cuz fvex fsumserz2.2 fopabex2 vk vx cF vk cv cM cuz cfv wcel vy cv cA
      wceq wa vk vy copab fsumserz2.2 vk cv cM cuz cfv wcel vy cv cA wceq wa vk
      vy vx hbopab1 hbxfr fsumserzfi cM cN cfz co cM cuz cfv wss cM cN cfz co
      vk cv cF cfv vk csu cM cN cfz co cA vk csu wceq cM cN fzssuz vy cA cM cuz
      cfv cM cN cfz co vk cF fsumserz2.1 fsumserz2.2 sumeqfv ax-mp syl5eqr $.
      $( [10-May-2006] $) $( [10-May-2006] $)
  $}

  ${
    $d y A $.  $d n x z F $.  $d k n x y z M $.
    serzfsum.1 $e |- A e. _V $.
    serzfsum.2 $e |- F = { <. k , y >. | ( k e. ( ZZ>= ` M ) /\ y = A ) } $.
    serzfsum.3 $e |- G = { <. n , z >. | ( n e. ( ZZ>= ` M ) /\ z =
                      sum_ k e. ( M ... n ) A ) } $.
    $( An infinite series in terms of finite partial sums of ` A ( k ) ` . $)
    serzfsum $p |- ( M e. ZZ -> ( <. M , + >. seq F ) = G ) $=
      cM cz wcel cM caddc cop cF cseqz co vn cv cM cuz cfv wcel vz cv vn cv cM
      caddc cop cF cseqz co cfv wceq wa vn vz copab cG cM cz wcel cM caddc cop
      cF cseqz co cM cuz cfv wfn cM caddc cop cF cseqz co vn cv cM cuz cfv wcel
      vz cv vn cv cM caddc cop cF cseqz co cfv wceq wa vn vz copab wceq caddc
      cF cM addex vk vy cM cuz cfv cA cF cM cuz fvex serzfsum.2 fopabex2 seqzfn
      vn vz cM cuz cfv cM caddc cop cF cseqz co dffn5 sylib cG vn cv cM cuz cfv
      wcel vz cv cM vn cv cfz co cA vk csu wceq wa vn vz copab vn cv cM cuz cfv
      wcel vz cv vn cv cM caddc cop cF cseqz co cfv wceq wa vn vz copab
      serzfsum.3 vn cv cM cuz cfv wcel vz cv cM vn cv cfz co cA vk csu wceq wa
      vn cv cM cuz cfv wcel vz cv vn cv cM caddc cop cF cseqz co cfv wceq wa vn
      vz vn cv cM cuz cfv wcel vz cv cM vn cv cfz co cA vk csu wceq vz cv vn cv
      cM caddc cop cF cseqz co cfv wceq vn cv cM cuz cfv wcel cM vn cv cfz co
      cA vk csu vn cv cM caddc cop cF cseqz co cfv vz cv vn cv cM cuz cfv wcel
      cM vn cv cfz co vk cv cF cfv vk csu cM vn cv cfz co cA vk csu vn cv cM
      caddc cop cF cseqz co cfv vn cv cM cuz cfv wcel cM vn cv cfz co vk cv cF
      cfv cA vk vn cv cM cuz cfv wcel vk cv cM vn cv cfz co wcel wa vk cv vk cv
      cM cuz cfv wcel vy cv cA wceq wa vk vy copab cfv cA vk cv cF cfv vk cv cM
      vn cv cfz co wcel vk cv vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy
      copab cfv cA wceq vn cv cM cuz cfv wcel vk cv cM cuz cfv wcel cA cvv wcel
      vk cv vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy copab cfv cA wceq vk
      cv cM vn cv cfz co wcel vk vy cM cuz cfv cA cvv fvopab2 vk cv cM vn cv
      elfzuz serzfsum.1 sylancl adantl vk cv cF vk cv cM cuz cfv wcel vy cv cA
      wceq wa vk vy copab serzfsum.2 fveq1i syl5eq sumeq2dv vx vk cF cM vn cv
      vk vy cM cuz cfv cA cF cM cuz fvex serzfsum.2 fopabex2 vk vx cF vk cv cM
      cuz cfv wcel vy cv cA wceq wa vk vy copab serzfsum.2 vk cv cM cuz cfv
      wcel vy cv cA wceq wa vk vy vx hbopab1 hbxfr fsumserzfi eqtr3d eqeq2d
      pm5.32i opabbii eqtri syl6eqr $.
      $( [13-Jan-2006] $) $( [9-Jan-2006] $)
  $}

  ${
    $d x y A $.  $d k y B $.  $d k x y M $.
    fsum1.1 $e |- ( k = M -> A = B ) $.
    $( The finite sum of ` A ( k ) ` from ` k = M ` to ` M ` (i.e. a sum with
       only one term) is ` B ` i.e. ` A ( M ) ` . $)
    fsum1i $p |- ( ( B e. C /\ M e. ZZ ) ->
                   sum_ k e. ( M ... M ) A = B ) $=
      cB cC wcel cM cz wcel wa cM cM cfz co cA vk csu cM cM caddc cop vk cv cz
      wcel vy cv cA wceq wa vk vy copab cseqz co cfv cM vk cv cz wcel vy cv cA
      wceq wa vk vy copab cfv cB cB cC wcel cM cz wcel cM cM cfz co cA vk csu
      cM cM cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk csu
      cM cM caddc cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv
      cB cC wcel cB cvv wcel cA cvv wcel vk cM cM cfz co wral cM cM cfz co vk
      cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk csu cM cM cfz co cA
      vk csu wceq cB cC elisset cB cvv wcel cA cvv wcel vk cM cM cfz co cB cvv
      wcel vk cv cM wceq cA cvv wcel vk cv cM cM cfz co wcel vk cv cM wceq cA
      cvv wcel cB cvv wcel vk cv cM wceq cA cB cvv fsum1.1 eleq1d biimprcd vk
      cv cM elfz1eq syl5 r19.21aiv cA cvv wcel vk cM cM cfz co wral cM cM cfz
      co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA vk cA cvv wcel
      vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA wceq vk cM cM cfz
      co vk cv cM cM cfz co wcel vk cv cz wcel cA cvv wcel vk cv vk cv cz wcel
      vy cv cA wceq wa vk vy copab cfv cA wceq wi vk cv cM cM elfzelz vk cv cz
      wcel cA cvv wcel vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA
      wceq vk vy cz cA cvv fvopab2 ex syl r19.20i sumeq2d 3syl cM cz wcel cM cM
      cuz cfv wcel cM cM cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy
      copab cfv vk csu cM cM caddc cop vk cv cz wcel vy cv cA wceq wa vk vy
      copab cseqz co cfv wceq cM uzid vx vk vk cv cz wcel vy cv cA wceq wa vk
      vy copab cM cM vk vy cz cA zex opabex2 vk cv cz wcel vy cv cA wceq wa vk
      vy vx hbopab1 fsumserzfi syl sylan9req cM cz wcel cM cM caddc cop vk cv
      cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cM vk cv cz wcel vy cv
      cA wceq wa vk vy copab cfv wceq cB cC wcel caddc vk cv cz wcel vy cv cA
      wceq wa vk vy copab cM addex vk vy cz cA zex opabex2 seqz1 adantl cM cz
      wcel cB cC wcel cM vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cB wceq
      vk vy cM cA cB cz cC vk cv cz wcel vy cv cA wceq wa vk vy copab fsum1.1
      vk cv cz wcel vy cv cA wceq wa vk vy copab eqid fvopab4g ancoms 3eqtrd $.
      $( [9-Dec-2005] $) $( [8-Nov-2005] $)
  $}

  ${
    $d x y A $.  $d k y B $.  $d k x M $.  $d k x y N $.
    fsump1i.1 $e |- A e. _V $.
    fsump1i.2 $e |- B e. _V $.
    fsump1i.3 $e |- ( k = ( N + 1 ) -> A = B ) $.
    $( The addition of the next term in a finite sum of ` A ( k ) ` is the
       current term plus ` B ` i.e. ` A ( N + 1 ) ` . $)
    fsump1i $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... ( N + 1 ) ) A =
                ( sum_ k e. ( M ... N ) A + B ) ) $=
      cN cM cuz cfv wcel cM cN c1 caddc co cfz co cA vk csu cN c1 caddc co cM
      caddc cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cN cM
      caddc cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cN c1
      caddc co vk cv cz wcel vy cv cA wceq wa vk vy copab cfv caddc co cM cN
      cfz co cA vk csu cB caddc co cN cM cuz cfv wcel cM cN c1 caddc co cfz co
      vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk csu cN c1 caddc
      co cM caddc cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv
      cM cN c1 caddc co cfz co cA vk csu cN cM cuz cfv wcel cN c1 caddc co cM
      cuz cfv wcel cM cN c1 caddc co cfz co vk cv vk cv cz wcel vy cv cA wceq
      wa vk vy copab cfv vk csu cN c1 caddc co cM caddc cop vk cv cz wcel vy cv
      cA wceq wa vk vy copab cseqz co cfv wceq cM cN peano2uz vx vk vk cv cz
      wcel vy cv cA wceq wa vk vy copab cM cN c1 caddc co vk vy cz cA zex
      opabex2 vk cv cz wcel vy cv cA wceq wa vk vy vx hbopab1 fsumserzfi syl vk
      cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA wceq cM cN c1 caddc
      co cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk csu cM
      cN c1 caddc co cfz co cA vk csu wceq vk cM cN c1 caddc co cfz co cM cN c1
      caddc co cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA
      vk sumeq2 vk cv cz wcel cA cvv wcel vk cv vk cv cz wcel vy cv cA wceq wa
      vk vy copab cfv cA wceq vk cv cM cN c1 caddc co cfz co wcel vk vy cz cA
      cvv fvopab2 vk cv cM cN c1 caddc co elfzelz fsump1i.1 sylancl mprg
      syl5eqr caddc vk cv cz wcel vy cv cA wceq wa vk vy copab cM cN addex vk
      vy cz cA zex opabex2 seqzp1 cN cM cuz cfv wcel cN cM caddc cop vk cv cz
      wcel vy cv cA wceq wa vk vy copab cseqz co cfv cM cN cfz co cA vk csu cN
      c1 caddc co vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cB caddc cN cM
      cuz cfv wcel cM cN cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy
      copab cfv vk csu cN cM caddc cop vk cv cz wcel vy cv cA wceq wa vk vy
      copab cseqz co cfv cM cN cfz co cA vk csu vx vk vk cv cz wcel vy cv cA
      wceq wa vk vy copab cM cN vk vy cz cA zex opabex2 vk cv cz wcel vy cv cA
      wceq wa vk vy vx hbopab1 fsumserzfi vk cv vk cv cz wcel vy cv cA wceq wa
      vk vy copab cfv cA wceq cM cN cfz co vk cv vk cv cz wcel vy cv cA wceq wa
      vk vy copab cfv vk csu cM cN cfz co cA vk csu wceq vk cM cN cfz co cM cN
      cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA vk sumeq2
      vk cv cz wcel cA cvv wcel vk cv vk cv cz wcel vy cv cA wceq wa vk vy
      copab cfv cA wceq vk cv cM cN cfz co wcel vk vy cz cA cvv fvopab2 vk cv
      cM cN elfzelz fsump1i.1 sylancl mprg syl5reqr cN cM cuz cfv wcel cN cz
      wcel cN c1 caddc co cz wcel cN c1 caddc co vk cv cz wcel vy cv cA wceq wa
      vk vy copab cfv cB wceq cM cN eluzelz cN peano2z vk vy cN c1 caddc co cA
      cB cz vk cv cz wcel vy cv cA wceq wa vk vy copab fsump1i.3 vk cv cz wcel
      vy cv cA wceq wa vk vy copab eqid fsump1i.2 fvopab4 3syl opreq12d 3eqtrd
      $.
      $( [9-Dec-2005] $) $( [4-Nov-2005] $)
  $}

  ${
    $d j z A $.  $d j x z B $.  $d j k z M $.  $d k x $.
    fsum1fi.3 $e |- ( x e. B -> A. k x e. B ) $.
    fsum1fi.4 $e |- ( k = M -> A = B ) $.
    $( The finite sum of a term ` A ( k ) ` from ` M ` to ` M ` (i.e. a sum
       with only one term) is ` A ( M ) = B ` , where ` k ` is effectively
       not free in ` B ` . $)
    fsum1fi $p |- ( ( B e. C /\ M e. ZZ ) -> sum_ k e. ( M ... M ) A = B ) $=
      cB cC wcel cM cz wcel wa cM cM cfz co vk vj cv cA csb vj csu cB cM cM cfz
      co cA vk csu vk vj cv cA csb cB cC vj cM vk vj vz cM cA cB vz cv cM wcel
      vk ax-17 vk vx vz cB fsum1fi.3 hblem fsum1fi.4 csbhypf fsum1i vz cM cM
      cfz co cA vk vj cv cA csb vk vj vz cv cA wcel vj ax-17 vk vz vj cv cA vj
      visset vz cv vj cv wcel vk ax-17 hbcsb1 vk vj cv cA csbeq1a cbvsumi
      syl5eq $.
      $( [21-Dec-2008] $) $( [8-Nov-2005] $)
  $}

  ${
    $d x y A $.  $d x M $.  $d k x y $.
    fsum1slem.1 $e |- A e. _V $.
    $( Lemma for ~ fsum1s . $)
    fsum1slem $p |- ( M e. ZZ ->
                    sum_ k e. ( M ... M ) A = [_ M / k ]_ A ) $=
      vx cv vx cv cfz co cA vk csu vk vx cv cA csb wceq cM cM cfz co cA vk csu
      vk cM cA csb wceq vx cM cz vx cv cM wceq vx cv vx cv cfz co cA vk csu cM
      cM cfz co cA vk csu vk vx cv cA csb vk cM cA csb vx cv cM wceq vx cv vx
      cv cfz co cM cM cfz co cA vk vx cv cM wceq vx cv vx cv cfz co cM cM cfz
      co wceq vx cv cM vx cv cM cfz opreq12 anidms sumeq1d vk vx cv cM cA
      csbeq1 eqeq12d vk vx cv cA csb cvv wcel vx cv cz wcel vx cv vx cv cfz co
      cA vk csu vk vx cv cA csb wceq vk vx cv cA vx visset fsum1slem.1 csbex vy
      cA vk vx cv cA csb cvv vk vx cv vk vy vx cv cA vx visset vy cv vx cv wcel
      vk ax-17 hbcsb1 vk vx cv cA csbeq1a fsum1fi mpan vtoclga $.
      $( [13-Dec-2005] $) $( [5-Nov-2005] $)
  $}

  ${
    $d k x M $.  $d x A $.  $d x B $.
    $( The finite sum of a sequence ` A ( k ) ` from ` M ` to ` M ` (i.e. a sum
       with only one term) is ` A ( M ) ` . $)
    fsum1s $p |- ( ( M e. ZZ /\ A. k e. ( M ... M ) A e. B ) ->
                    sum_ k e. ( M ... M ) A = [_ M / k ]_ A ) $=
      cM cz wcel cA cvv wcel vk cM cM cfz co wral cM cM cfz co cA vk csu vk cM
      cA csb wceq cA cB wcel vk cM cM cfz co wral cM cz wcel cA cvv wcel vk cM
      cM cfz co wral wa cM cM cfz co cA cvv wcel vx cA crab vk csu vk cM cA cvv
      wcel vx cA crab csb cM cM cfz co cA vk csu vk cM cA csb cM cz wcel cM cM
      cfz co cA cvv wcel vx cA crab vk csu vk cM cA cvv wcel vx cA crab csb
      wceq cA cvv wcel vk cM cM cfz co wral cA cvv wcel vx cA crab vk cM vx cA
      class2set fsum1slem adantr cA cvv wcel vk cM cM cfz co wral cM cM cfz co
      cA cvv wcel vx cA crab vk csu cM cM cfz co cA vk csu wceq cM cz wcel cA
      cvv wcel vk cM cM cfz co wral cM cM cfz co cA cvv wcel vx cA crab cA vk
      cA cvv wcel cA cvv wcel vx cA crab cA wceq vk cM cM cfz co vx cA cvv
      class2seteq r19.20si sumeq2d adantl cM cz wcel cA cvv wcel vk cM cM cfz
      co wral vk cM cA cvv wcel vx cA crab csb vk cM cA csb wceq cM cz wcel cA
      cvv wcel vk cM cM cfz co wral cA cvv wcel vx cA crab cA wceq vk cM wsbc
      vk cM cA cvv wcel vx cA crab csb vk cM cA csb wceq cM cz wcel cA cvv wcel
      vk cM cM cfz co wral cA cvv wcel vk cM wsbc cA cvv wcel vx cA crab cA
      wceq vk cM wsbc cA cvv wcel vk cM fz1sbc vx cv vx cv wceq cM cz wcel cA
      cvv wcel vk cM wsbc cA cvv wcel vx cA crab cA wceq vk cM wsbc wi vx equid
      vx cv vx cv wceq cA cvv wcel cA cvv wcel vx cA crab cA wceq vk cM cz cA
      cvv wcel cA cvv wcel vx cA crab cA wceq wi vx cv vx cv wceq vx cA cvv
      class2seteq a1i sbc19.20dv mpan sylbid vk cM cA cvv wcel vx cA crab cA cz
      sbceqdig sylibd imp 3eqtr3d cA cB wcel cA cvv wcel vk cM cM cfz co cA cB
      elisset r19.20si sylan2 $.
      $( [14-Dec-2005] $) $( [13-Dec-2005] $)

    $( The finite sum of a sequence ` A ( k ) ` from ` M ` to ` M ` (i.e. a sum
       with only one term) is ` A ( M ) ` . $)
    fsum1s2 $p |- ( ( M e. ZZ /\ [_ M / k ]_ A e. B ) ->
                    sum_ k e. ( M ... M ) A = [_ M / k ]_ A ) $=
      cM cz wcel vk cM cA csb cB wcel cA cvv wcel vk cM cM cfz co wral cM cM
      cfz co cA vk csu vk cM cA csb wceq cM cz wcel vk cM cA csb cB wcel cA cvv
      wcel vk cM cM cfz co wral cM cz wcel cA cvv wcel vk cM cM cfz co wral vk
      cM cA csb cvv wcel vk cM cA csb cB wcel cM cz wcel cA cvv wcel vk cM cM
      cfz co wral cA cvv wcel vk cM wsbc vk cM cA csb cvv wcel cA cvv wcel vk
      cM fz1sbc vk cM cA cvv cz sbcel1g bitrd vk cM cA csb cB elisset syl5bir
      imp cA cvv vk cM fsum1s syldan $.
      $( [14-Dec-2005] $) $( [29-Nov-2005] $)
  $}

  ${
    $d j z A $.  $d j x z B $.  $d j z M $.  $d j k z N $.  $d k x $.
    fsump1fi.1 $e |- A e. _V $.
    fsump1fi.2 $e |- B e. _V $.
    fsump1fi.3 $e |- ( x e. B -> A. k x e. B ) $.
    fsump1fi.4 $e |- ( k = ( N + 1 ) -> A = B ) $.
    $( The addition of the next term in a finite sum of ` A ( k ) ` is the
       previous term plus ` A ( N + 1 ) = B ` . $)
    fsump1fi $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... ( N + 1 ) ) A =
                ( sum_ k e. ( M ... N ) A + B ) ) $=
      cN cM cuz cfv wcel cM cN c1 caddc co cfz co vk vj cv cA csb vj csu cM cN
      cfz co vk vj cv cA csb vj csu cB caddc co cM cN c1 caddc co cfz co cA vk
      csu cM cN cfz co cA vk csu cB caddc co vk vj cv cA csb cB vj cM cN vk vj
      cv cA vj visset fsump1fi.1 csbex fsump1fi.2 vk vj vz cN c1 caddc co cA cB
      vz cv cN c1 caddc co wcel vk ax-17 vk vx vz cB fsump1fi.3 hblem
      fsump1fi.4 csbhypf fsump1i vz cM cN c1 caddc co cfz co cA vk vj cv cA csb
      vk vj vz cv cA wcel vj ax-17 vk vz vj cv cA vj visset vz cv vj cv wcel vk
      ax-17 hbcsb1 vk vj cv cA csbeq1a cbvsumi cM cN cfz co cA vk csu cM cN cfz
      co vk vj cv cA csb vj csu cB caddc vz cM cN cfz co cA vk vj cv cA csb vk
      vj vz cv cA wcel vj ax-17 vk vz vj cv cA vj visset vz cv vj cv wcel vk
      ax-17 hbcsb1 vk vj cv cA csbeq1a cbvsumi opreq1i 3eqtr4g $.
      $( [15-Dec-2005] $) $( [4-Nov-2005] $)
  $}

  ${
    $d j x A $.  $d j M $.  $d j N $.  $d j k x $.
    fsump1slem.1 $e |- A e. _V $.
    $( Lemma for ~ fsump1s . $)
    fsump1slem $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... ( N + 1 ) ) A
           = ( sum_ k e. ( M ... N ) A + [_ ( N + 1 ) / k ]_ A ) ) $=
      cM vj cv c1 caddc co cfz co cA vk csu cM vj cv cfz co cA vk csu vk vj cv
      c1 caddc co cA csb caddc co wceq cM cN c1 caddc co cfz co cA vk csu cM cN
      cfz co cA vk csu vk cN c1 caddc co cA csb caddc co wceq vj cN cM cuz cfv
      vj cv cN wceq cM vj cv c1 caddc co cfz co cA vk csu cM cN c1 caddc co cfz
      co cA vk csu cM vj cv cfz co cA vk csu vk vj cv c1 caddc co cA csb caddc
      co cM cN cfz co cA vk csu vk cN c1 caddc co cA csb caddc co vj cv cN wceq
      cM vj cv c1 caddc co cfz co cM cN c1 caddc co cfz co cA vk vj cv cN wceq
      vj cv c1 caddc co cN c1 caddc co cM cfz vj cv cN c1 caddc opreq1 opreq2d
      sumeq1d vj cv cN wceq cM vj cv cfz co cA vk csu cM cN cfz co cA vk csu vk
      vj cv c1 caddc co cA csb vk cN c1 caddc co cA csb caddc vj cv cN wceq cM
      vj cv cfz co cM cN cfz co cA vk vj cv cN cM cfz opreq2 sumeq1d vj cv cN
      wceq vk vj cv c1 caddc co cN c1 caddc co cA vj cv cN c1 caddc opreq1
      csbeq1d opreq12d eqeq12d vx cA vk vj cv c1 caddc co cA csb vk cM vj cv
      fsump1slem.1 vk vj cv c1 caddc co cA vj cv c1 caddc oprex fsump1slem.1
      csbex vk vx vj cv c1 caddc co cA vj cv c1 caddc oprex vx cv vj cv c1
      caddc co wcel vk ax-17 hbcsb1 vk vj cv c1 caddc co cA csbeq1a fsump1fi
      vtoclga $.
      $( [15-Dec-2005] $) $( [12-Nov-2005] $)
  $}

  ${
    $d k x M $.  $d k x N $.  $d x A $.  $d x B $.
    $( The addition of the next term in a finite sum of ` A ( k ) ` is the
       previous term plus ` A ( N + 1 ) ` . $)
    fsump1s $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... ( N + 1 ) ) A e. B )
            -> sum_ k e. ( M ... ( N + 1 ) ) A =
                ( sum_ k e. ( M ... N ) A + [_ ( N + 1 ) / k ]_ A ) ) $=
      cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral cM cN c1
      caddc co cfz co cA vk csu cM cN cfz co cA vk csu vk cN c1 caddc co cA csb
      caddc co wceq cA cB wcel vk cM cN c1 caddc co cfz co wral cN cM cuz cfv
      wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral wa cM cN c1 caddc co
      cfz co cA cvv wcel vx cA crab vk csu cM cN cfz co cA cvv wcel vx cA crab
      vk csu vk cN c1 caddc co cA cvv wcel vx cA crab csb caddc co cM cN c1
      caddc co cfz co cA vk csu cM cN cfz co cA vk csu vk cN c1 caddc co cA csb
      caddc co cN cM cuz cfv wcel cM cN c1 caddc co cfz co cA cvv wcel vx cA
      crab vk csu cM cN cfz co cA cvv wcel vx cA crab vk csu vk cN c1 caddc co
      cA cvv wcel vx cA crab csb caddc co wceq cA cvv wcel vk cM cN c1 caddc co
      cfz co wral cA cvv wcel vx cA crab vk cM cN vx cA class2set fsump1slem
      adantr cA cvv wcel vk cM cN c1 caddc co cfz co wral cM cN c1 caddc co cfz
      co cA cvv wcel vx cA crab vk csu cM cN c1 caddc co cfz co cA vk csu wceq
      cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral cM cN c1
      caddc co cfz co cA cvv wcel vx cA crab cA vk cA cvv wcel cA cvv wcel vx
      cA crab cA wceq vk cM cN c1 caddc co cfz co vx cA cvv class2seteq
      r19.20si sumeq2d adantl cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc
      co cfz co wral wa cM cN cfz co cA cvv wcel vx cA crab vk csu cM cN cfz co
      cA vk csu vk cN c1 caddc co cA cvv wcel vx cA crab csb vk cN c1 caddc co
      cA csb caddc cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co
      wral wa cM cN cfz co cA cvv wcel vx cA crab cA vk cN cM cuz cfv wcel cA
      cvv wcel vk cM cN c1 caddc co cfz co wral cA cvv wcel vx cA crab cA wceq
      vk cM cN cfz co wral cN cM cuz cfv wcel cA cvv wcel cA cvv wcel vx cA
      crab cA wceq vk cM cN c1 caddc co cfz co cM cN cfz co cN cM cuz cfv wcel
      vk cv cM cN cfz co wcel vk cv cM cN c1 caddc co cfz co wcel cA cvv wcel
      cA cvv wcel vx cA crab cA wceq cN cM cuz cfv wcel cM cN cfz co cM cN c1
      caddc co cfz co vk cv cM cz wcel cN cz wcel cM cN cfz co cM cN c1 caddc
      co cfz co wss cN cM cuz cfv wcel cM cN fzssp1 cM cN eluzel2 cM cN eluzelz
      sylanc sseld cA cvv wcel cA cvv wcel vx cA crab cA wceq wi cN cM cuz cfv
      wcel vx cA cvv class2seteq a1i imim12d r19.20dv2 imp sumeq2d cN cM cuz
      cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral wa cA cvv wcel vx
      cA crab cA wceq vk cN c1 caddc co wsbc vk cN c1 caddc co cA cvv wcel vx
      cA crab csb vk cN c1 caddc co cA csb wceq cN cM cuz cfv wcel cA cvv wcel
      vk cM cN c1 caddc co cfz co wral wa cA cvv wcel vk cN c1 caddc co wsbc cA
      cvv wcel vx cA crab cA wceq vk cN c1 caddc co wsbc cN c1 caddc co cM cN
      c1 caddc co cfz co wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral cA
      cvv wcel vk cN c1 caddc co wsbc cN cM cuz cfv wcel cA cvv wcel vk cN c1
      caddc co cM cN c1 caddc co cfz co ra4sbca cN cM cuz cfv wcel cN c1 caddc
      co cM cuz cfv wcel cN c1 caddc co cM cN c1 caddc co cfz co wcel cM cN
      peano2uz cM cN c1 caddc co eluzfz2 syl sylan vx cv vx cv wceq cN c1 caddc
      co cvv wcel cA cvv wcel vk cN c1 caddc co wsbc cA cvv wcel vx cA crab cA
      wceq vk cN c1 caddc co wsbc wi vx equid cN c1 caddc oprex vx cv vx cv
      wceq cA cvv wcel cA cvv wcel vx cA crab cA wceq vk cN c1 caddc co cvv cA
      cvv wcel cA cvv wcel vx cA crab cA wceq wi vx cv vx cv wceq vx cA cvv
      class2seteq a1i sbc19.20dv mp2an syl cN c1 caddc co cvv wcel cA cvv wcel
      vx cA crab cA wceq vk cN c1 caddc co wsbc vk cN c1 caddc co cA cvv wcel
      vx cA crab csb vk cN c1 caddc co cA csb wceq wb cN c1 caddc oprex vk cN
      c1 caddc co cA cvv wcel vx cA crab cA cvv sbceqdig ax-mp sylib opreq12d
      3eqtr3d cA cB wcel cA cvv wcel vk cM cN c1 caddc co cfz co cA cB elisset
      r19.20si sylan2 $.
      $( [15-Dec-2005] $) $( [13-Dec-2005] $)
  $}

  ${
    $d j m x y A $.  $d j k m x y C $.  $d j k m x y M $.  $d j k N $.
    fsumcllem.1 $e |- ( ( x e. C /\ y e. C ) -> ( x + y ) e. C ) $.
    $( - Lemma for finite sum closures.  (The "-" before "Lemma" forces the
       math content to be displayed in the Statement List - NM 11-Feb-2008.) $)
    fsumcllem $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
                     A e. C ) -> sum_ k e. ( M ... N ) A e. C ) $=
      cN cM cuz cfv wcel cA cC wcel vk cM cN cfz co wral cM cN cfz co cA vk csu
      cC wcel cA cC wcel vk cM vj cv cfz co wral cM vj cv cfz co cA vk csu cC
      wcel wi cA cC wcel vk cM cM cfz co wral cM cM cfz co cA vk csu cC wcel wi
      cA cC wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk csu cC wcel wi
      cA cC wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz
      co cA vk csu cC wcel wi cA cC wcel vk cM cN cfz co wral cM cN cfz co cA
      vk csu cC wcel wi vj vm cM cN vj cv cM wceq cA cC wcel vk cM vj cv cfz co
      wral cA cC wcel vk cM cM cfz co wral cM vj cv cfz co cA vk csu cC wcel cM
      cM cfz co cA vk csu cC wcel vj cv cM wceq cA cC wcel vk cM vj cv cfz co
      cM cM cfz co vj cv cM cM cfz opreq2 raleq1d vj cv cM wceq cM vj cv cfz co
      cA vk csu cM cM cfz co cA vk csu cC vj cv cM wceq cM vj cv cfz co cM cM
      cfz co cA vk vj cv cM cM cfz opreq2 sumeq1d eleq1d imbi12d vj cv vm cv
      wceq cA cC wcel vk cM vj cv cfz co wral cA cC wcel vk cM vm cv cfz co
      wral cM vj cv cfz co cA vk csu cC wcel cM vm cv cfz co cA vk csu cC wcel
      vj cv vm cv wceq cA cC wcel vk cM vj cv cfz co cM vm cv cfz co vj cv vm
      cv cM cfz opreq2 raleq1d vj cv vm cv wceq cM vj cv cfz co cA vk csu cM vm
      cv cfz co cA vk csu cC vj cv vm cv wceq cM vj cv cfz co cM vm cv cfz co
      cA vk vj cv vm cv cM cfz opreq2 sumeq1d eleq1d imbi12d vj cv vm cv c1
      caddc co wceq cA cC wcel vk cM vj cv cfz co wral cA cC wcel vk cM vm cv
      c1 caddc co cfz co wral cM vj cv cfz co cA vk csu cC wcel cM vm cv c1
      caddc co cfz co cA vk csu cC wcel vj cv vm cv c1 caddc co wceq cA cC wcel
      vk cM vj cv cfz co cM vm cv c1 caddc co cfz co vj cv vm cv c1 caddc co cM
      cfz opreq2 raleq1d vj cv vm cv c1 caddc co wceq cM vj cv cfz co cA vk csu
      cM vm cv c1 caddc co cfz co cA vk csu cC vj cv vm cv c1 caddc co wceq cM
      vj cv cfz co cM vm cv c1 caddc co cfz co cA vk vj cv vm cv c1 caddc co cM
      cfz opreq2 sumeq1d eleq1d imbi12d vj cv cN wceq cA cC wcel vk cM vj cv
      cfz co wral cA cC wcel vk cM cN cfz co wral cM vj cv cfz co cA vk csu cC
      wcel cM cN cfz co cA vk csu cC wcel vj cv cN wceq cA cC wcel vk cM vj cv
      cfz co cM cN cfz co vj cv cN cM cfz opreq2 raleq1d vj cv cN wceq cM vj cv
      cfz co cA vk csu cM cN cfz co cA vk csu cC vj cv cN wceq cM vj cv cfz co
      cM cN cfz co cA vk vj cv cN cM cfz opreq2 sumeq1d eleq1d imbi12d cM cz
      wcel cA cC wcel vk cM cM cfz co wral cM cM cfz co cA vk csu cC wcel cM cz
      wcel cA cC wcel vk cM cM cfz co wral wa cM cM cfz co cA vk csu vk cM cA
      csb cC cA cC vk cM fsum1s cM cM cM cfz co wcel cA cC wcel vk cM cM cfz co
      wral vk cM cA csb cC wcel cM cz wcel vk cM cM cM cfz co cA cC ra4csbela
      cM elfz3 sylan eqeltrd ex vm cv cM cuz cfv wcel cA cC wcel vk cM vm cv
      cfz co wral cM vm cv cfz co cA vk csu cC wcel wi cA cC wcel vk cM vm cv
      c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu cC wcel vm
      cv cM cuz cfv wcel cA cC wcel vk cM vm cv cfz co wral cM vm cv cfz co cA
      vk csu cC wcel wi cA cC wcel vk cM vm cv c1 caddc co cfz co wral wa wa cM
      vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1
      caddc co cA csb caddc co cC vm cv cM cuz cfv wcel cA cC wcel vk cM vm cv
      c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu cM vm cv
      cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co wceq cA cC wcel vk
      cM vm cv cfz co wral cM vm cv cfz co cA vk csu cC wcel wi cA cC vk cM vm
      cv fsump1s adantrl cM vm cv cfz co cA vk csu cC wcel vk vm cv c1 caddc co
      cA csb cC wcel cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb
      caddc co cC wcel vm cv cM cuz cfv wcel cA cC wcel vk cM vm cv cfz co wral
      cM vm cv cfz co cA vk csu cC wcel wi cA cC wcel vk cM vm cv c1 caddc co
      cfz co wral wa wa vx vy cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA
      csb cC caddc fsumcllem.1 caoprcl vm cv cM cuz cfv wcel cA cC wcel vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk csu cC wcel wi cA cC wcel vk cM
      vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk csu cC wcel vm cv cM
      cuz cfv wcel cA cC wcel vk cM vm cv c1 caddc co cfz co wral cA cC wcel vk
      cM vm cv cfz co wral cM vm cv cfz co cA vk csu cC wcel vm cv cM cuz cfv
      wcel cA cC wcel cA cC wcel vk cM vm cv c1 caddc co cfz co cM vm cv cfz co
      vm cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv c1 caddc
      co cfz co wcel cA cC wcel vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv
      c1 caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm
      cv c1 caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv
      eluzel2 cM vm cv eluzelz sylanc sseld imim1d r19.20dv2 imim1d imp32 vm cv
      cM cuz cfv wcel cA cC wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv
      c1 caddc co cA csb cC wcel cA cC wcel vk cM vm cv cfz co wral cM vm cv
      cfz co cA vk csu cC wcel wi vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cA cC wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co
      cA csb cC wcel vm cv cM cuz cfv wcel vk vm cv c1 caddc co cM vm cv c1
      caddc co cfz co cA cC ra4csbela vm cv cM cuz cfv wcel vm cv c1 caddc co
      cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cM vm
      cv peano2uz cM vm cv c1 caddc co eluzfz2 syl sylan adantrl sylanc eqeltrd
      exp32 uzind4 imp $.
      $( [11-Feb-2008] $) $( [9-Nov-2005] $)
  $}

  ${
    $d x y A $.  $d x y k M $.  $d k N $.
    $( Closure of a finite sum of complex numbers ` A ( k ) ` . $)
    fsumcl $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
                     A e. CC ) -> sum_ k e. ( M ... N ) A e. CC ) $=
      vx vy cA cc vk cM cN vx cv vy cv addcl fsumcllem $.
      $( [21-Dec-2005] $) $( [9-Nov-2005] $)

    $( Closure of a finite sum of complex numbers ` A ( k ) ` , starting at
       index zero. $)
    fsum0cl $p |- ( ( N e. NN0 /\ A. k e. ( 0 ... N )
                     A e. CC ) -> sum_ k e. ( 0 ... N ) A e. CC ) $=
      cN cc0 cuz cfv wcel cA cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cA vk
      csu cc wcel cN cn0 wcel cA vk cc0 cN fsumcl cN elnn0uz sylanb $.
      $( [13-Jan-2006] $) $( [10-Jan-2006] $)
  $}

  ${
    $d x y A $.  $d x y k M $.  $d k N $.
    $( Closure of a finite sum of reals. $)
    fsumrecl $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
                     A e. RR ) -> sum_ k e. ( M ... N ) A e. RR ) $=
      vx vy cA cr vk cM cN vx cv vy cv readdcl fsumcllem $.
      $( [22-Dec-2005] $) $( [9-Nov-2005] $)
  $}

  ${
    $d j m A $.  $d j k m M $.  $d j k N $.
    $( Separate out the first term in a finite sum. $)
    fsum1ps $p |- ( ( N e. ( ZZ>= ` M ) /\ M < N /\
               A. k e. ( M ... N ) A e. CC ) -> sum_ k e. ( M ... N ) A =
                  ( [_ M / k ]_ A + sum_ k e. ( ( M + 1 ) ... N ) A ) ) $=
      cN cM cuz cfv wcel cM cN clt wbr cA cc wcel vk cM cN cfz co wral cM cN
      cfz co cA vk csu vk cM cA csb cM c1 caddc co cN cfz co cA vk csu caddc co
      wceq cM cz wcel cN cz wcel wa cM cN clt wbr cA cc wcel vk cM cN cfz co
      wral cM cN cfz co cA vk csu vk cM cA csb cM c1 caddc co cN cfz co cA vk
      csu caddc co wceq wi cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN clt
      wbr cA cc wcel vk cM cN cfz co wral cM cN cfz co cA vk csu vk cM cA csb
      cM c1 caddc co cN cfz co cA vk csu caddc co wceq wi cA cc wcel vk cM vj
      cv cfz co wral cM vj cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vj
      cv cfz co cA vk csu caddc co wceq wi cA cc wcel vk cM cM c1 caddc co cfz
      co wral cM cM c1 caddc co cfz co cA vk csu vk cM cA csb cM c1 caddc co cM
      c1 caddc co cfz co cA vk csu caddc co wceq wi cA cc wcel vk cM vm cv cfz
      co wral cM vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vm cv cfz
      co cA vk csu caddc co wceq wi cA cc wcel vk cM vm cv c1 caddc co cfz co
      wral cM vm cv c1 caddc co cfz co cA vk csu vk cM cA csb cM c1 caddc co vm
      cv c1 caddc co cfz co cA vk csu caddc co wceq wi cA cc wcel vk cM cN cfz
      co wral cM cN cfz co cA vk csu vk cM cA csb cM c1 caddc co cN cfz co cA
      vk csu caddc co wceq wi vj vm cM cN vj cv cM c1 caddc co wceq cA cc wcel
      vk cM vj cv cfz co wral cA cc wcel vk cM cM c1 caddc co cfz co wral cM vj
      cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vj cv cfz co cA vk csu
      caddc co wceq cM cM c1 caddc co cfz co cA vk csu vk cM cA csb cM c1 caddc
      co cM c1 caddc co cfz co cA vk csu caddc co wceq vj cv cM c1 caddc co
      wceq cA cc wcel vk cM vj cv cfz co cM cM c1 caddc co cfz co vj cv cM c1
      caddc co cM cfz opreq2 raleq1d vj cv cM c1 caddc co wceq cM vj cv cfz co
      cA vk csu cM cM c1 caddc co cfz co cA vk csu vk cM cA csb cM c1 caddc co
      vj cv cfz co cA vk csu caddc co vk cM cA csb cM c1 caddc co cM c1 caddc
      co cfz co cA vk csu caddc co vj cv cM c1 caddc co wceq cM vj cv cfz co cM
      cM c1 caddc co cfz co cA vk vj cv cM c1 caddc co cM cfz opreq2 sumeq1d vj
      cv cM c1 caddc co wceq cM c1 caddc co vj cv cfz co cA vk csu cM c1 caddc
      co cM c1 caddc co cfz co cA vk csu vk cM cA csb caddc vj cv cM c1 caddc
      co wceq cM c1 caddc co vj cv cfz co cM c1 caddc co cM c1 caddc co cfz co
      cA vk vj cv cM c1 caddc co cM c1 caddc co cfz opreq2 sumeq1d opreq2d
      eqeq12d imbi12d vj cv vm cv wceq cA cc wcel vk cM vj cv cfz co wral cA cc
      wcel vk cM vm cv cfz co wral cM vj cv cfz co cA vk csu vk cM cA csb cM c1
      caddc co vj cv cfz co cA vk csu caddc co wceq cM vm cv cfz co cA vk csu
      vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu caddc co wceq vj cv vm
      cv wceq cA cc wcel vk cM vj cv cfz co cM vm cv cfz co vj cv vm cv cM cfz
      opreq2 raleq1d vj cv vm cv wceq cM vj cv cfz co cA vk csu cM vm cv cfz co
      cA vk csu vk cM cA csb cM c1 caddc co vj cv cfz co cA vk csu caddc co vk
      cM cA csb cM c1 caddc co vm cv cfz co cA vk csu caddc co vj cv vm cv wceq
      cM vj cv cfz co cM vm cv cfz co cA vk vj cv vm cv cM cfz opreq2 sumeq1d
      vj cv vm cv wceq cM c1 caddc co vj cv cfz co cA vk csu cM c1 caddc co vm
      cv cfz co cA vk csu vk cM cA csb caddc vj cv vm cv wceq cM c1 caddc co vj
      cv cfz co cM c1 caddc co vm cv cfz co cA vk vj cv vm cv cM c1 caddc co
      cfz opreq2 sumeq1d opreq2d eqeq12d imbi12d vj cv vm cv c1 caddc co wceq
      cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM vm cv c1 caddc co cfz
      co wral cM vj cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vj cv cfz
      co cA vk csu caddc co wceq cM vm cv c1 caddc co cfz co cA vk csu vk cM cA
      csb cM c1 caddc co vm cv c1 caddc co cfz co cA vk csu caddc co wceq vj cv
      vm cv c1 caddc co wceq cA cc wcel vk cM vj cv cfz co cM vm cv c1 caddc co
      cfz co vj cv vm cv c1 caddc co cM cfz opreq2 raleq1d vj cv vm cv c1 caddc
      co wceq cM vj cv cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu
      vk cM cA csb cM c1 caddc co vj cv cfz co cA vk csu caddc co vk cM cA csb
      cM c1 caddc co vm cv c1 caddc co cfz co cA vk csu caddc co vj cv vm cv c1
      caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co cfz co cA vk vj cv vm
      cv c1 caddc co cM cfz opreq2 sumeq1d vj cv vm cv c1 caddc co wceq cM c1
      caddc co vj cv cfz co cA vk csu cM c1 caddc co vm cv c1 caddc co cfz co
      cA vk csu vk cM cA csb caddc vj cv vm cv c1 caddc co wceq cM c1 caddc co
      vj cv cfz co cM c1 caddc co vm cv c1 caddc co cfz co cA vk vj cv vm cv c1
      caddc co cM c1 caddc co cfz opreq2 sumeq1d opreq2d eqeq12d imbi12d vj cv
      cN wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM cN cfz co
      wral cM vj cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vj cv cfz co
      cA vk csu caddc co wceq cM cN cfz co cA vk csu vk cM cA csb cM c1 caddc
      co cN cfz co cA vk csu caddc co wceq vj cv cN wceq cA cc wcel vk cM vj cv
      cfz co cM cN cfz co vj cv cN cM cfz opreq2 raleq1d vj cv cN wceq cM vj cv
      cfz co cA vk csu cM cN cfz co cA vk csu vk cM cA csb cM c1 caddc co vj cv
      cfz co cA vk csu caddc co vk cM cA csb cM c1 caddc co cN cfz co cA vk csu
      caddc co vj cv cN wceq cM vj cv cfz co cM cN cfz co cA vk vj cv cN cM cfz
      opreq2 sumeq1d vj cv cN wceq cM c1 caddc co vj cv cfz co cA vk csu cM c1
      caddc co cN cfz co cA vk csu vk cM cA csb caddc vj cv cN wceq cM c1 caddc
      co vj cv cfz co cM c1 caddc co cN cfz co cA vk vj cv cN cM c1 caddc co
      cfz opreq2 sumeq1d opreq2d eqeq12d imbi12d cM cz wcel cA cc wcel vk cM cM
      c1 caddc co cfz co wral cM cM c1 caddc co cfz co cA vk csu vk cM cA csb
      cM c1 caddc co cM c1 caddc co cfz co cA vk csu caddc co wceq cM cz wcel
      cA cc wcel vk cM cM c1 caddc co cfz co wral wa cM cM c1 caddc co cfz co
      cA vk csu cM cM cfz co cA vk csu vk cM c1 caddc co cA csb caddc co vk cM
      cA csb cM c1 caddc co cM c1 caddc co cfz co cA vk csu caddc co cM cM cuz
      cfv wcel cA cc wcel vk cM cM c1 caddc co cfz co wral cM cM c1 caddc co
      cfz co cA vk csu cM cM cfz co cA vk csu vk cM c1 caddc co cA csb caddc co
      wceq cM cz wcel cA cc vk cM cM fsump1s cM uzid sylan cM cz wcel cA cc
      wcel vk cM cM c1 caddc co cfz co wral wa vk cM cA csb cM cM cfz co cA vk
      csu cM c1 caddc co cM c1 caddc co cfz co cA vk csu vk cM c1 caddc co cA
      csb caddc cM cz wcel cA cc wcel vk cM cM c1 caddc co cfz co wral wa cM cM
      cfz co cA vk csu vk cM cA csb cM cz wcel cA cc wcel vk cM cM c1 caddc co
      cfz co wral cA cc wcel vk cM cM cfz co wral cM cM cfz co cA vk csu vk cM
      cA csb wceq cM cz wcel cA cc wcel vk cM cM c1 caddc co cfz co wral cA cc
      wcel vk cM cM cfz co wral cM cz wcel cA cc wcel cA cc wcel vk cM cM c1
      caddc co cfz co cM cM cfz co cM cz wcel vk cv cM cM cfz co wcel vk cv cM
      cM c1 caddc co cfz co wcel cA cc wcel cM cz wcel cM cM cfz co cM cM c1
      caddc co cfz co vk cv cM cz wcel cM cM cfz co cM cM c1 caddc co cfz co
      wss cM cM fzssp1 anidms sseld imim1d r19.20dv2 imp cA cc vk cM fsum1s
      syldan eqcomd cM cz wcel cA cc wcel vk cM cM c1 caddc co cfz co wral cA
      cc wcel vk cM c1 caddc co cM c1 caddc co cfz co wral cM c1 caddc co cM c1
      caddc co cfz co cA vk csu vk cM c1 caddc co cA csb wceq cM cz wcel cA cc
      wcel vk cM cM c1 caddc co cfz co wral cA cc wcel vk cM c1 caddc co cM c1
      caddc co cfz co wral cM cz wcel cA cc wcel cA cc wcel vk cM cM c1 caddc
      co cfz co cM c1 caddc co cM c1 caddc co cfz co cM cz wcel vk cv cM c1
      caddc co cM c1 caddc co cfz co wcel vk cv cM cM c1 caddc co cfz co wcel
      cA cc wcel cM cz wcel cM c1 caddc co cM c1 caddc co cfz co cM cM c1 caddc
      co cfz co vk cv cM cz wcel cM c1 caddc co cz wcel cM c1 caddc co cM c1
      caddc co cfz co cM cM c1 caddc co cfz co wss cM peano2z cM cM c1 caddc co
      fzp1ss mpdan sseld imim1d r19.20dv2 imp cM c1 caddc co cz wcel cA cc wcel
      vk cM c1 caddc co cM c1 caddc co cfz co wral cM c1 caddc co cM c1 caddc
      co cfz co cA vk csu vk cM c1 caddc co cA csb wceq cM cz wcel cA cc vk cM
      c1 caddc co fsum1s cM peano2z sylan syldan opreq12d eqtr4d ex cM cz wcel
      vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk cM vm cv cfz co wral cM
      vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu
      caddc co wceq wi cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv
      cfz co cA vk csu vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu caddc
      co wceq wi cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1
      caddc co cfz co cA vk csu vk cM cA csb cM c1 caddc co vm cv c1 caddc co
      cfz co cA vk csu caddc co wceq wi cM cz wcel vm cv cz wcel cM vm cv clt
      wbr w3a cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc co
      vm cv cfz co cA vk csu caddc co wceq cM cz wcel vm cv cz wcel cM vm cv
      clt wbr w3a cA cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cM vm cv
      cfz co cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a vk cv cM vm cv cfz
      co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel cM cz wcel vm
      cv cz wcel cM vm cv clt wbr w3a cM vm cv cfz co cM vm cv c1 caddc co cfz
      co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co
      cfz co wss cM vm cv clt wbr cM vm cv fzssp1 3adant3 sseld imim1d
      r19.20dv2 imim1d cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk csu vk cM cA
      csb cM c1 caddc co vm cv cfz co cA vk csu caddc co wceq wi cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu vk
      cM cA csb cM c1 caddc co vm cv c1 caddc co cfz co cA vk csu caddc co wceq
      cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc
      co vm cv cfz co cA vk csu caddc co wceq wi wa cA cc wcel vk cM vm cv c1
      caddc co cfz co wral wa cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA
      csb caddc co vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu caddc co
      vk vm cv c1 caddc co cA csb caddc co cM vm cv c1 caddc co cfz co cA vk
      csu vk cM cA csb cM c1 caddc co vm cv c1 caddc co cfz co cA vk csu caddc
      co cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk
      csu vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu caddc co wceq wi
      cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk csu
      vk vm cv c1 caddc co cA csb caddc co vk cM cA csb cM c1 caddc co vm cv
      cfz co cA vk csu caddc co vk vm cv c1 caddc co cA csb caddc co wceq cM cz
      wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk cM vm cv c1 caddc
      co cfz co wral cM vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vm
      cv cfz co cA vk csu caddc co wceq wi cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral wa cM vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vm
      cv cfz co cA vk csu caddc co vk vm cv c1 caddc co cA csb caddc cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral cM vm cv cfz co cA vk csu vk cM cA csb cM c1 caddc co vm cv
      cfz co cA vk csu caddc co wceq wi cM vm cv cfz co cA vk csu vk cM cA csb
      cM c1 caddc co vm cv cfz co cA vk csu caddc co wceq cA cc wcel vk cM vm
      cv c1 caddc co cfz co wral cM vm cv cfz co cA vk csu vk cM cA csb cM c1
      caddc co vm cv cfz co cA vk csu caddc co wceq pm3.35 ancoms opreq1d
      adantll cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk cM vm
      cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu cM vm cv
      cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co wceq cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk csu vk cM cA csb
      cM c1 caddc co vm cv cfz co cA vk csu caddc co wceq wi vm cv cM cuz cfv
      wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co
      cfz co cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb
      caddc co wceq cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc vk cM
      vm cv fsump1s cM cz wcel vm cv cz wcel cM vm cv clt wbr vm cv cM cuz cfv
      wcel cM cz wcel vm cv cz wcel wa cM vm cv clt wbr cM vm cv cle wbr vm cv
      cM cuz cfv wcel cM cr wcel vm cv cr wcel cM vm cv clt wbr cM vm cv cle
      wbr wi cM cz wcel vm cv cz wcel cM vm cv ltle cM zre vm cv zre syl2an cM
      vm cv eluz sylibrd 3impia sylan adantlr cM cz wcel vm cv cz wcel cM vm cv
      clt wbr w3a cA cc wcel vk cM vm cv c1 caddc co cfz co wral vk cM cA csb
      cM c1 caddc co vm cv c1 caddc co cfz co cA vk csu caddc co vk cM cA csb
      cM c1 caddc co vm cv cfz co cA vk csu caddc co vk vm cv c1 caddc co cA
      csb caddc co wceq cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv
      cfz co cA vk csu vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu caddc
      co wceq wi cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk cM
      vm cv c1 caddc co cfz co wral wa vk cM cA csb cM c1 caddc co vm cv c1
      caddc co cfz co cA vk csu caddc co vk cM cA csb cM c1 caddc co vm cv cfz
      co cA vk csu vk vm cv c1 caddc co cA csb caddc co caddc co vk cM cA csb
      cM c1 caddc co vm cv cfz co cA vk csu caddc co vk vm cv c1 caddc co cA
      csb caddc co cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral wa cM c1 caddc co vm cv c1 caddc co cfz
      co cA vk csu cM c1 caddc co vm cv cfz co cA vk csu vk vm cv c1 caddc co
      cA csb caddc co vk cM cA csb caddc cM cz wcel vm cv cz wcel cM vm cv clt
      wbr w3a cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM
      c1 caddc co vm cv c1 caddc co cfz co wral cM c1 caddc co vm cv c1 caddc
      co cfz co cA vk csu cM c1 caddc co vm cv cfz co cA vk csu vk vm cv c1
      caddc co cA csb caddc co wceq cM cz wcel vm cv cz wcel cM vm cv clt wbr
      w3a cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM c1
      caddc co vm cv c1 caddc co cfz co wral cM cz wcel vm cv cz wcel cM vm cv
      clt wbr w3a cA cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cM c1
      caddc co vm cv c1 caddc co cfz co cM cz wcel vm cv cz wcel cM vm cv clt
      wbr w3a vk cv cM c1 caddc co vm cv c1 caddc co cfz co wcel vk cv cM vm cv
      c1 caddc co cfz co wcel cA cc wcel cM cz wcel vm cv cz wcel cM vm cv clt
      wbr w3a cM c1 caddc co vm cv c1 caddc co cfz co cM vm cv c1 caddc co cfz
      co vk cv cM cz wcel vm cv cz wcel cM c1 caddc co vm cv c1 caddc co cfz co
      cM vm cv c1 caddc co cfz co wss cM vm cv clt wbr cM cz wcel vm cv c1
      caddc co cz wcel cM c1 caddc co vm cv c1 caddc co cfz co cM vm cv c1
      caddc co cfz co wss vm cv cz wcel cM vm cv c1 caddc co fzp1ss vm cv
      peano2z sylan2 3adant3 sseld imim1d r19.20dv2 imp vm cv cM c1 caddc co
      cuz cfv wcel cA cc wcel vk cM c1 caddc co vm cv c1 caddc co cfz co wral
      cM c1 caddc co vm cv c1 caddc co cfz co cA vk csu cM c1 caddc co vm cv
      cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co wceq cM cz wcel vm
      cv cz wcel cM vm cv clt wbr w3a cA cc vk cM c1 caddc co vm cv fsump1s cM
      cz wcel vm cv cz wcel cM vm cv clt wbr vm cv cM c1 caddc co cuz cfv wcel
      cM cz wcel vm cv cz wcel wa cM vm cv clt wbr cM c1 caddc co vm cv cle wbr
      vm cv cM c1 caddc co cuz cfv wcel cM vm cv zltp1le cM c1 caddc co cz wcel
      vm cv cz wcel vm cv cM c1 caddc co cuz cfv wcel cM c1 caddc co vm cv cle
      wbr wb cM cz wcel cM c1 caddc co vm cv eluz cM peano2z sylan bitr4d
      biimp3a sylan syldan opreq2d vk cM cA csb cc wcel cM c1 caddc co vm cv
      cfz co cA vk csu cc wcel vk vm cv c1 caddc co cA csb cc wcel vk cM cA csb
      cM c1 caddc co vm cv cfz co cA vk csu caddc co vk vm cv c1 caddc co cA
      csb caddc co vk cM cA csb cM c1 caddc co vm cv cfz co cA vk csu vk vm cv
      c1 caddc co cA csb caddc co caddc co wceq cM cz wcel vm cv cz wcel cM vm
      cv clt wbr w3a cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa vk cM cA
      csb cM c1 caddc co vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb
      addass cM cM vm cv c1 caddc co cfz co wcel cA cc wcel vk cM vm cv c1
      caddc co cfz co wral vk cM cA csb cc wcel cM cz wcel vm cv cz wcel cM vm
      cv clt wbr w3a vk cM cM vm cv c1 caddc co cfz co cA cc ra4csbela cM cz
      wcel vm cv cz wcel cM vm cv clt wbr w3a vm cv c1 caddc co cM cuz cfv wcel
      cM cM vm cv c1 caddc co cfz co wcel cM cz wcel vm cv cz wcel cM vm cv clt
      wbr w3a vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel cM cz
      wcel vm cv cz wcel cM vm cv clt wbr vm cv cM cuz cfv wcel cM cz wcel vm
      cv cz wcel wa cM vm cv clt wbr cM vm cv cle wbr vm cv cM cuz cfv wcel cM
      cr wcel vm cv cr wcel cM vm cv clt wbr cM vm cv cle wbr wi cM cz wcel vm
      cv cz wcel cM vm cv ltle cM zre vm cv zre syl2an cM vm cv eluz sylibrd
      3impia cM vm cv peano2uz syl cM vm cv c1 caddc co eluzfz1 syl sylan cM cz
      wcel vm cv cz wcel cM vm cv clt wbr w3a cA cc wcel vk cM vm cv c1 caddc
      co cfz co wral cA cc wcel vk cM c1 caddc co vm cv cfz co wral cM c1 caddc
      co vm cv cfz co cA vk csu cc wcel cM cz wcel vm cv cz wcel cM vm cv clt
      wbr w3a cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM
      c1 caddc co vm cv cfz co wral cM cz wcel vm cv cz wcel cM vm cv clt wbr
      w3a cA cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cM c1 caddc co
      vm cv cfz co cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a vk cv cM c1
      caddc co vm cv cfz co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc
      wcel cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cM c1 caddc co vm cv
      cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM c1
      caddc co vm cv cfz co cM vm cv c1 caddc co cfz co wss cM vm cv clt wbr cM
      cz wcel vm cv cz wcel wa cM c1 caddc co vm cv cfz co cM vm cv cfz co cM
      vm cv c1 caddc co cfz co cM vm cv fzp1ss cM vm cv fzssp1 sstrd 3adant3
      sseld imim1d r19.20dv2 imp vm cv cM c1 caddc co cuz cfv wcel cA cc wcel
      vk cM c1 caddc co vm cv cfz co wral cM c1 caddc co vm cv cfz co cA vk csu
      cc wcel cM cz wcel vm cv cz wcel cM vm cv clt wbr w3a cA vk cM c1 caddc
      co vm cv fsumcl cM cz wcel vm cv cz wcel cM vm cv clt wbr vm cv cM c1
      caddc co cuz cfv wcel cM cz wcel vm cv cz wcel wa cM vm cv clt wbr cM c1
      caddc co vm cv cle wbr vm cv cM c1 caddc co cuz cfv wcel cM vm cv zltp1le
      cM c1 caddc co cz wcel vm cv cz wcel vm cv cM c1 caddc co cuz cfv wcel cM
      c1 caddc co vm cv cle wbr wb cM cz wcel cM c1 caddc co vm cv eluz cM
      peano2z sylan bitr4d biimp3a sylan syldan vm cv c1 caddc co cM vm cv c1
      caddc co cfz co wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral vk vm
      cv c1 caddc co cA csb cc wcel cM cz wcel vm cv cz wcel cM vm cv clt wbr
      w3a vk vm cv c1 caddc co cM vm cv c1 caddc co cfz co cA cc ra4csbela cM
      cz wcel vm cv cz wcel cM vm cv clt wbr w3a vm cv c1 caddc co cM cuz cfv
      wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cM cz wcel vm cv
      cz wcel cM vm cv clt wbr w3a vm cv cM cuz cfv wcel vm cv c1 caddc co cM
      cuz cfv wcel cM cz wcel vm cv cz wcel cM vm cv clt wbr vm cv cM cuz cfv
      wcel cM cz wcel vm cv cz wcel wa cM vm cv clt wbr cM vm cv cle wbr vm cv
      cM cuz cfv wcel cM cr wcel vm cv cr wcel cM vm cv clt wbr cM vm cv cle
      wbr wi cM cz wcel vm cv cz wcel cM vm cv ltle cM zre vm cv zre syl2an cM
      vm cv eluz sylibrd 3impia cM vm cv peano2uz syl cM vm cv c1 caddc co
      eluzfz2b sylib sylan syl3anc eqtr4d adantlr 3eqtr4d exp31 syld uzind2
      3expa cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN eluzel2 cM cN
      eluzelz jca sylan 3impia $.
      $( [22-Dec-2005] $) $( [24-Nov-2005] $)
  $}

  ${
    $d x k B $.  $d x k M $.  $d k N $.
    fsum1p.1 $e |- ( k = M -> A = B ) $.
    $( Separate out the first term in a finite sum. $)
    fsum1p $p |- ( ( N e. ( ZZ>= ` M ) /\ M < N /\
               A. k e. ( M ... N ) A e. CC ) -> sum_ k e. ( M ... N ) A =
                  ( B + sum_ k e. ( ( M + 1 ) ... N ) A ) ) $=
      cN cM cuz cfv wcel cM cN clt wbr cA cc wcel vk cM cN cfz co wral w3a cM
      cN cfz co cA vk csu vk cM cA csb cM c1 caddc co cN cfz co cA vk csu caddc
      co cB cM c1 caddc co cN cfz co cA vk csu caddc co cA vk cM cN fsum1ps cN
      cM cuz cfv wcel cM cN clt wbr vk cM cA csb cM c1 caddc co cN cfz co cA vk
      csu caddc co cB cM c1 caddc co cN cfz co cA vk csu caddc co wceq cA cc
      wcel vk cM cN cfz co wral cN cM cuz cfv wcel vk cM cA csb cB cM c1 caddc
      co cN cfz co cA vk csu caddc cN cM cuz cfv wcel cM cz wcel vk cM cA csb
      cB wceq cM cN eluzel2 vk vx cM cA cB cz vx cv cB wcel vx cv cB wcel vk
      wal wi cM cz wcel vx cv cB wcel vk ax-17 a1i fsum1p.1 csbiegf syl opreq1d
      3ad2ant1 eqtrd $.
      $( [4-Jan-2006] $) $( [3-Jan-2006] $)
  $}

  ${
    $d j m A $.  $d j K $.  $d j k m M $.  $d j k m N $.
    $( Split a finite sum into two parts.  _Warning:  The HTML proof page is
       0.6 megabyte in size_. $)
    fsumsplit $p |- ( ( N e. ZZ /\ K e. ( M ... ( N - 1 ) )
       /\ A. k e. ( M ... N ) A e. CC ) -> sum_ k e. ( M ... N ) A =
    ( sum_ k e. ( M ... K ) A + sum_ k e. ( ( K + 1 ) ... N ) A ) ) $=
      cN cz wcel cK cM cN c1 cmin co cfz co wcel cA cc wcel vk cM cN cfz co
      wral cM cN cfz co cA vk csu cM cK cfz co cA vk csu cK c1 caddc co cN cfz
      co cA vk csu caddc co wceq cK cM cuz cfv wcel cN cz wcel cK cN clt wbr wa
      wa cA cc wcel vk cM cN cfz co wral cM cN cfz co cA vk csu cM cK cfz co cA
      vk csu cK c1 caddc co cN cfz co cA vk csu caddc co wceq cN cz wcel cK cM
      cN c1 cmin co cfz co wcel wa cK cM cuz cfv wcel cN cz wcel cK cN clt wbr
      wa cA cc wcel vk cM cN cfz co wral cM cN cfz co cA vk csu cM cK cfz co cA
      vk csu cK c1 caddc co cN cfz co cA vk csu caddc co wceq cK cM cuz cfv
      wcel cN cz wcel cK cN clt wbr wa cA cc wcel vk cM cN cfz co wral cM cN
      cfz co cA vk csu cM cK cfz co cA vk csu cK c1 caddc co cN cfz co cA vk
      csu caddc co wceq cN cz wcel vj cv cN clt wbr wa cA cc wcel vk cM cN cfz
      co wral wa cM cN cfz co cA vk csu cM vj cv cfz co cA vk csu vj cv c1
      caddc co cN cfz co cA vk csu caddc co wceq wi cN cz wcel cM cN clt wbr wa
      cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA vk csu cM cM cfz co cA
      vk csu cM c1 caddc co cN cfz co cA vk csu caddc co wceq wi cN cz wcel vm
      cv cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA vk
      csu cM vm cv cfz co cA vk csu vm cv c1 caddc co cN cfz co cA vk csu caddc
      co wceq wi cN cz wcel vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN
      cfz co wral wa cM cN cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk
      csu vm cv c1 caddc co c1 caddc co cN cfz co cA vk csu caddc co wceq wi cN
      cz wcel cK cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz co
      cA vk csu cM cK cfz co cA vk csu cK c1 caddc co cN cfz co cA vk csu caddc
      co wceq wi vj vm cM cK vj cv cM wceq cN cz wcel vj cv cN clt wbr wa cA cc
      wcel vk cM cN cfz co wral wa cN cz wcel cM cN clt wbr wa cA cc wcel vk cM
      cN cfz co wral wa cM cN cfz co cA vk csu cM vj cv cfz co cA vk csu vj cv
      c1 caddc co cN cfz co cA vk csu caddc co wceq cM cN cfz co cA vk csu cM
      cM cfz co cA vk csu cM c1 caddc co cN cfz co cA vk csu caddc co wceq vj
      cv cM wceq cN cz wcel vj cv cN clt wbr wa cN cz wcel cM cN clt wbr wa cA
      cc wcel vk cM cN cfz co wral vj cv cM wceq vj cv cN clt wbr cM cN clt wbr
      cN cz wcel vj cv cM cN clt breq1 anbi2d anbi1d vj cv cM wceq cM vj cv cfz
      co cA vk csu vj cv c1 caddc co cN cfz co cA vk csu caddc co cM cM cfz co
      cA vk csu cM c1 caddc co cN cfz co cA vk csu caddc co cM cN cfz co cA vk
      csu vj cv cM wceq cM vj cv cfz co cA vk csu cM cM cfz co cA vk csu vj cv
      c1 caddc co cN cfz co cA vk csu cM c1 caddc co cN cfz co cA vk csu caddc
      vj cv cM wceq cM vj cv cfz co cM cM cfz co cA vk vj cv cM cM cfz opreq2
      sumeq1d vj cv cM wceq vj cv c1 caddc co cN cfz co cM c1 caddc co cN cfz
      co cA vk vj cv cM wceq vj cv c1 caddc co cM c1 caddc co cN cfz vj cv cM
      c1 caddc opreq1 opreq1d sumeq1d opreq12d eqeq2d imbi12d vj cv vm cv wceq
      cN cz wcel vj cv cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cN cz
      wcel vm cv cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz co
      cA vk csu cM vj cv cfz co cA vk csu vj cv c1 caddc co cN cfz co cA vk csu
      caddc co wceq cM cN cfz co cA vk csu cM vm cv cfz co cA vk csu vm cv c1
      caddc co cN cfz co cA vk csu caddc co wceq vj cv vm cv wceq cN cz wcel vj
      cv cN clt wbr wa cN cz wcel vm cv cN clt wbr wa cA cc wcel vk cM cN cfz
      co wral vj cv vm cv wceq vj cv cN clt wbr vm cv cN clt wbr cN cz wcel vj
      cv vm cv cN clt breq1 anbi2d anbi1d vj cv vm cv wceq cM vj cv cfz co cA
      vk csu vj cv c1 caddc co cN cfz co cA vk csu caddc co cM vm cv cfz co cA
      vk csu vm cv c1 caddc co cN cfz co cA vk csu caddc co cM cN cfz co cA vk
      csu vj cv vm cv wceq cM vj cv cfz co cA vk csu cM vm cv cfz co cA vk csu
      vj cv c1 caddc co cN cfz co cA vk csu vm cv c1 caddc co cN cfz co cA vk
      csu caddc vj cv vm cv wceq cM vj cv cfz co cM vm cv cfz co cA vk vj cv vm
      cv cM cfz opreq2 sumeq1d vj cv vm cv wceq vj cv c1 caddc co cN cfz co vm
      cv c1 caddc co cN cfz co cA vk vj cv vm cv wceq vj cv c1 caddc co vm cv
      c1 caddc co cN cfz vj cv vm cv c1 caddc opreq1 opreq1d sumeq1d opreq12d
      eqeq2d imbi12d vj cv vm cv c1 caddc co wceq cN cz wcel vj cv cN clt wbr
      wa cA cc wcel vk cM cN cfz co wral wa cN cz wcel vm cv c1 caddc co cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA vk csu cM vj cv
      cfz co cA vk csu vj cv c1 caddc co cN cfz co cA vk csu caddc co wceq cM
      cN cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu vm cv c1 caddc
      co c1 caddc co cN cfz co cA vk csu caddc co wceq vj cv vm cv c1 caddc co
      wceq cN cz wcel vj cv cN clt wbr wa cN cz wcel vm cv c1 caddc co cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral vj cv vm cv c1 caddc co wceq vj cv
      cN clt wbr vm cv c1 caddc co cN clt wbr cN cz wcel vj cv vm cv c1 caddc
      co cN clt breq1 anbi2d anbi1d vj cv vm cv c1 caddc co wceq cM vj cv cfz
      co cA vk csu vj cv c1 caddc co cN cfz co cA vk csu caddc co cM vm cv c1
      caddc co cfz co cA vk csu vm cv c1 caddc co c1 caddc co cN cfz co cA vk
      csu caddc co cM cN cfz co cA vk csu vj cv vm cv c1 caddc co wceq cM vj cv
      cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu vj cv c1 caddc co
      cN cfz co cA vk csu vm cv c1 caddc co c1 caddc co cN cfz co cA vk csu
      caddc vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co
      cfz co cA vk vj cv vm cv c1 caddc co cM cfz opreq2 sumeq1d vj cv vm cv c1
      caddc co wceq vj cv c1 caddc co cN cfz co vm cv c1 caddc co c1 caddc co
      cN cfz co cA vk vj cv vm cv c1 caddc co wceq vj cv c1 caddc co vm cv c1
      caddc co c1 caddc co cN cfz vj cv vm cv c1 caddc co c1 caddc opreq1
      opreq1d sumeq1d opreq12d eqeq2d imbi12d vj cv cK wceq cN cz wcel vj cv cN
      clt wbr wa cA cc wcel vk cM cN cfz co wral wa cN cz wcel cK cN clt wbr wa
      cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA vk csu cM vj cv cfz co
      cA vk csu vj cv c1 caddc co cN cfz co cA vk csu caddc co wceq cM cN cfz
      co cA vk csu cM cK cfz co cA vk csu cK c1 caddc co cN cfz co cA vk csu
      caddc co wceq vj cv cK wceq cN cz wcel vj cv cN clt wbr wa cN cz wcel cK
      cN clt wbr wa cA cc wcel vk cM cN cfz co wral vj cv cK wceq vj cv cN clt
      wbr cK cN clt wbr cN cz wcel vj cv cK cN clt breq1 anbi2d anbi1d vj cv cK
      wceq cM vj cv cfz co cA vk csu vj cv c1 caddc co cN cfz co cA vk csu
      caddc co cM cK cfz co cA vk csu cK c1 caddc co cN cfz co cA vk csu caddc
      co cM cN cfz co cA vk csu vj cv cK wceq cM vj cv cfz co cA vk csu cM cK
      cfz co cA vk csu vj cv c1 caddc co cN cfz co cA vk csu cK c1 caddc co cN
      cfz co cA vk csu caddc vj cv cK wceq cM vj cv cfz co cM cK cfz co cA vk
      vj cv cK cM cfz opreq2 sumeq1d vj cv cK wceq vj cv c1 caddc co cN cfz co
      cK c1 caddc co cN cfz co cA vk vj cv cK wceq vj cv c1 caddc co cK c1
      caddc co cN cfz vj cv cK c1 caddc opreq1 opreq1d sumeq1d opreq12d eqeq2d
      imbi12d cM cz wcel cN cz wcel cM cN clt wbr cA cc wcel vk cM cN cfz co
      wral cM cN cfz co cA vk csu cM cM cfz co cA vk csu cM c1 caddc co cN cfz
      co cA vk csu caddc co wceq cM cz wcel cN cz wcel cM cN clt wbr cA cc wcel
      vk cM cN cfz co wral cM cN cfz co cA vk csu cM cM cfz co cA vk csu cM c1
      caddc co cN cfz co cA vk csu caddc co wceq cN cM cuz cfv wcel cM cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral cM cN cfz co cA vk csu cM cM cfz
      co cA vk csu cM c1 caddc co cN cfz co cA vk csu caddc co wceq cM cz wcel
      cN cz wcel wa cM cN clt wbr wa cN cM cuz cfv wcel cM cN clt wbr wa cA cc
      wcel vk cM cN cfz co wral wa cM cN cfz co cA vk csu vk cM cA csb cM c1
      caddc co cN cfz co cA vk csu caddc co cM cM cfz co cA vk csu cM c1 caddc
      co cN cfz co cA vk csu caddc co cN cM cuz cfv wcel cM cN clt wbr cA cc
      wcel vk cM cN cfz co wral cM cN cfz co cA vk csu vk cM cA csb cM c1 caddc
      co cN cfz co cA vk csu caddc co wceq cA vk cM cN fsum1ps 3expa cN cM cuz
      cfv wcel cM cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cM cM cfz co
      cA vk csu vk cM cA csb cM c1 caddc co cN cfz co cA vk csu caddc cN cM cuz
      cfv wcel cA cc wcel vk cM cN cfz co wral cM cM cfz co cA vk csu vk cM cA
      csb wceq cM cN clt wbr cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral
      cA cc wcel vk cM cM cfz co wral cM cM cfz co cA vk csu vk cM cA csb wceq
      cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral cA cc wcel vk cM cM
      cfz co wral cN cM cuz cfv wcel cA cc wcel cA cc wcel vk cM cN cfz co cM
      cM cfz co cN cM cuz cfv wcel vk cv cM cM cfz co wcel vk cv cM cN cfz co
      wcel cA cc wcel cN cM cuz cfv wcel cM cM cfz co cM cN cfz co vk cv cN cM
      cuz cfv wcel cM cz wcel cM cM cfz co cM cN cfz co wss cM cN eluzel2 cM cM
      cN fzss2 mpdan sseld imim1d r19.20dv2 imp cM cz wcel cA cc wcel vk cM cM
      cfz co wral cM cM cfz co cA vk csu vk cM cA csb wceq cN cM cuz cfv wcel
      cA cc vk cM fsum1s cM cN eluzel2 sylan syldan adantlr opreq1d eqtr4d cM
      cz wcel cN cz wcel wa cM cN clt wbr cN cM cuz cfv wcel cM cz wcel cN cz
      wcel wa cM cN clt wbr cM cN cle wbr cN cM cuz cfv wcel cM cr wcel cN cr
      wcel cM cN clt wbr cM cN cle wbr wi cM cz wcel cN cz wcel cM cN ltle cM
      zre cN zre syl2an cM cN eluz sylibrd impac sylan exp41 imp4c vm cv cM cuz
      cfv wcel cN cz wcel vm cv cN clt wbr wa cA cc wcel vk cM cN cfz co wral
      wa cM cN cfz co cA vk csu cM vm cv cfz co cA vk csu vm cv c1 caddc co cN
      cfz co cA vk csu caddc co wceq wi cN cz wcel vm cv c1 caddc co cN clt wbr
      wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA vk csu cM vm cv cfz
      co cA vk csu vm cv c1 caddc co cN cfz co cA vk csu caddc co wceq wi cN cz
      wcel vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa
      cM cN cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu vm cv c1
      caddc co c1 caddc co cN cfz co cA vk csu caddc co wceq wi vm cv cM cuz
      cfv wcel cN cz wcel vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN
      cfz co wral wa cN cz wcel vm cv cN clt wbr wa cA cc wcel vk cM cN cfz co
      wral wa cM cN cfz co cA vk csu cM vm cv cfz co cA vk csu vm cv c1 caddc
      co cN cfz co cA vk csu caddc co wceq vm cv cM cuz cfv wcel cN cz wcel vm
      cv c1 caddc co cN clt wbr wa cN cz wcel vm cv cN clt wbr wa cA cc wcel vk
      cM cN cfz co wral vm cv cM cuz cfv wcel cN cz wcel vm cv c1 caddc co cN
      clt wbr vm cv cN clt wbr vm cv cM cuz cfv wcel vm cv cz wcel cN cz wcel
      vm cv c1 caddc co cN clt wbr vm cv cN clt wbr wi wi cM vm cv eluzelz vm
      cv cz wcel cN cz wcel vm cv c1 caddc co cN clt wbr vm cv cN clt wbr wi vm
      cv cr wcel cN cr wcel vm cv c1 caddc co cN clt wbr vm cv cN clt wbr wi vm
      cv cz wcel cN cz wcel vm cv cr wcel cN cr wcel wa vm cv vm cv c1 caddc co
      clt wbr vm cv c1 caddc co cN clt wbr vm cv cN clt wbr vm cv cr wcel vm cv
      vm cv c1 caddc co clt wbr cN cr wcel vm cv ltp1 adantr vm cv cr wcel vm
      cv c1 caddc co cr wcel wa cN cr wcel vm cv vm cv c1 caddc co clt wbr vm
      cv c1 caddc co cN clt wbr wa vm cv cN clt wbr wi vm cv cr wcel vm cv cr
      wcel vm cv c1 caddc co cr wcel cN cr wcel vm cv vm cv c1 caddc co clt wbr
      vm cv c1 caddc co cN clt wbr wa vm cv cN clt wbr wi vm cv vm cv c1 caddc
      co cN axlttrn 3expa vm cv cr wcel vm cv c1 caddc co cr wcel vm cv
      peano2re ancli sylan mpand vm cv zre cN zre syl2an ex syl imdistand
      anim1d imim1d vm cv cM cuz cfv wcel cN cz wcel vm cv c1 caddc co cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA vk csu cM vm cv
      cfz co cA vk csu vm cv c1 caddc co cN cfz co cA vk csu caddc co wceq cM
      cN cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu vm cv c1 caddc
      co c1 caddc co cN cfz co cA vk csu caddc co wceq vm cv cM cuz cfv wcel cN
      cz wcel vm cv c1 caddc co cN clt wbr cA cc wcel vk cM cN cfz co wral cM
      cN cfz co cA vk csu cM vm cv cfz co cA vk csu vm cv c1 caddc co cN cfz co
      cA vk csu caddc co wceq cM cN cfz co cA vk csu cM vm cv c1 caddc co cfz
      co cA vk csu vm cv c1 caddc co c1 caddc co cN cfz co cA vk csu caddc co
      wceq wi vm cv cM cuz cfv wcel cN cz wcel vm cv c1 caddc co cN clt wbr cA
      cc wcel vk cM cN cfz co wral cM cN cfz co cA vk csu cM vm cv cfz co cA vk
      csu vm cv c1 caddc co cN cfz co cA vk csu caddc co wceq cM cN cfz co cA
      vk csu cM vm cv c1 caddc co cfz co cA vk csu vm cv c1 caddc co c1 caddc
      co cN cfz co cA vk csu caddc co wceq wi vm cv cM cuz cfv wcel cN cz wcel
      wa vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cM
      cN cfz co cA vk csu cM vm cv cfz co cA vk csu vm cv c1 caddc co cN cfz co
      cA vk csu caddc co wceq cM cN cfz co cA vk csu cM vm cv c1 caddc co cfz
      co cA vk csu vm cv c1 caddc co c1 caddc co cN cfz co cA vk csu caddc co
      wceq cM cN cfz co cA vk csu cM vm cv cfz co cA vk csu vm cv c1 caddc co
      cN cfz co cA vk csu caddc co wceq vm cv cM cuz cfv wcel cN cz wcel wa vm
      cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN cfz co wral wa cM cN cfz
      co cA vk csu cM vm cv cfz co cA vk csu vm cv c1 caddc co cN cfz co cA vk
      csu caddc co cM vm cv c1 caddc co cfz co cA vk csu vm cv c1 caddc co c1
      caddc co cN cfz co cA vk csu caddc co cM cN cfz co cA vk csu cM vm cv cfz
      co cA vk csu vm cv c1 caddc co cN cfz co cA vk csu caddc co wceq id vm cv
      cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc wcel
      vk cM cN cfz co wral wa cM vm cv c1 caddc co cfz co cA vk csu vm cv c1
      caddc co c1 caddc co cN cfz co cA vk csu caddc co cM vm cv cfz co cA vk
      csu vk vm cv c1 caddc co cA csb caddc co vm cv c1 caddc co cN cfz co cA
      vk csu vk vm cv c1 caddc co cA csb cmin co caddc co cM vm cv cfz co cA vk
      csu vm cv c1 caddc co cN cfz co cA vk csu caddc co vm cv cM cuz cfv wcel
      cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN cfz co
      wral wa cM vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu
      vk vm cv c1 caddc co cA csb caddc co vm cv c1 caddc co c1 caddc co cN cfz
      co cA vk csu vm cv c1 caddc co cN cfz co cA vk csu vk vm cv c1 caddc co
      cA csb cmin co caddc vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz
      co cA vk csu vk vm cv c1 caddc co cA csb caddc co wceq vm cv cM cuz cfv
      wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN
      cfz co wral wa cA cc vk cM vm cv fsump1s vm cv cM cuz cfv wcel cN cz wcel
      vm cv c1 caddc co cN clt wbr cA cc wcel vk cM cN cfz co wral simplll vm
      cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc
      wcel vk cM cN cfz co wral cA cc wcel vk cM vm cv c1 caddc co cfz co wral
      vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc
      wcel cA cc wcel vk cM cN cfz co cM vm cv c1 caddc co cfz co vm cv cM cuz
      cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa vk cv cM vm cv c1
      caddc co cfz co wcel vk cv cM cN cfz co wcel cA cc wcel vm cv cM cuz cfv
      wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cM vm cv c1 caddc co
      cfz co cM cN cfz co vk cv cN vm cv c1 caddc co cuz cfv wcel cM cz wcel cM
      vm cv c1 caddc co cfz co cM cN cfz co wss vm cv cM cuz cfv wcel cN cz
      wcel wa vm cv c1 caddc co cN clt wbr wa vm cv c1 caddc co cM cN fzss2 vm
      cv c1 caddc co cz wcel cN cz wcel vm cv c1 caddc co cN clt wbr cN vm cv
      c1 caddc co cuz cfv wcel vm cv cM cuz cfv wcel vm cv c1 caddc co cz wcel
      cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cN vm cv c1 caddc co cuz
      cfv wcel vm cv c1 caddc co cN cle wbr vm cv c1 caddc co cz wcel cN cz
      wcel wa vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN cle wbr vm cv
      c1 caddc co cr wcel cN cr wcel vm cv c1 caddc co cN clt wbr vm cv c1
      caddc co cN cle wbr wi vm cv c1 caddc co cz wcel cN cz wcel vm cv c1
      caddc co cN ltle vm cv c1 caddc co zre cN zre syl2an imp vm cv c1 caddc
      co cz wcel cN cz wcel wa cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc
      co cN cle wbr wb vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN eluz
      adantr mpbird vm cv cM cuz cfv wcel vm cv cM vm cv eluzelz peano2zdi
      sylanl1 vm cv cM cuz cfv wcel cM cz wcel cN cz wcel vm cv c1 caddc co cN
      clt wbr cM vm cv eluzel2 ad2antrr sylanc sseld imim1d r19.20dv2 imp
      sylanc vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr
      wa cA cc wcel vk cM cN cfz co wral wa vm cv c1 caddc co cN cfz co cA vk
      csu vk vm cv c1 caddc co cA csb cmin co vm cv c1 caddc co c1 caddc co cN
      cfz co cA vk csu vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN
      clt wbr wa cA cc wcel vk cM cN cfz co wral wa vm cv c1 caddc co cN cfz co
      cA vk csu vk vm cv c1 caddc co cA csb cmin co vm cv c1 caddc co c1 caddc
      co cN cfz co cA vk csu wceq vk vm cv c1 caddc co cA csb vm cv c1 caddc co
      c1 caddc co cN cfz co cA vk csu caddc co vm cv c1 caddc co cN cfz co cA
      vk csu wceq vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral wa vm cv c1 caddc co cN cfz co cA
      vk csu vk vm cv c1 caddc co cA csb vm cv c1 caddc co c1 caddc co cN cfz
      co cA vk csu caddc co cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc co
      cN clt wbr cA cc wcel vk vm cv c1 caddc co cN cfz co wral vm cv c1 caddc
      co cN cfz co cA vk csu vk vm cv c1 caddc co cA csb vm cv c1 caddc co c1
      caddc co cN cfz co cA vk csu caddc co wceq vm cv cM cuz cfv wcel cN cz
      wcel wa vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM cN cfz co wral
      wa cA vk vm cv c1 caddc co cN fsum1ps vm cv cM cuz cfv wcel cN cz wcel wa
      vm cv c1 caddc co cN clt wbr wa cN vm cv c1 caddc co cuz cfv wcel cA cc
      wcel vk cM cN cfz co wral vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1
      caddc co cN clt wbr cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc co
      cz wcel cN cz wcel vm cv c1 caddc co cN clt wbr cN vm cv c1 caddc co cuz
      cfv wcel wi vm cv cM cuz cfv wcel vm cv c1 caddc co cz wcel cN cz wcel wa
      vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN cle wbr cN vm cv c1
      caddc co cuz cfv wcel vm cv c1 caddc co cr wcel cN cr wcel vm cv c1 caddc
      co cN clt wbr vm cv c1 caddc co cN cle wbr wi vm cv c1 caddc co cz wcel
      cN cz wcel vm cv c1 caddc co cN ltle vm cv c1 caddc co zre cN zre syl2an
      vm cv c1 caddc co cN eluz sylibrd vm cv cM cuz cfv wcel vm cv cM vm cv
      eluzelz peano2zdi sylan imp adantr vm cv cM cuz cfv wcel cN cz wcel wa vm
      cv c1 caddc co cN clt wbr cA cc wcel vk cM cN cfz co wral simplr vm cv cM
      cuz cfv wcel cN cz wcel wa cA cc wcel vk cM cN cfz co wral cA cc wcel vk
      vm cv c1 caddc co cN cfz co wral vm cv c1 caddc co cN clt wbr vm cv cM
      cuz cfv wcel cN cz wcel wa cA cc wcel vk cM cN cfz co wral cA cc wcel vk
      vm cv c1 caddc co cN cfz co wral vm cv cM cuz cfv wcel cN cz wcel wa cA
      cc wcel cA cc wcel vk cM cN cfz co vm cv c1 caddc co cN cfz co vm cv cM
      cuz cfv wcel cN cz wcel wa vk cv vm cv c1 caddc co cN cfz co wcel vk cv
      cM cN cfz co wcel cA cc wcel vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1
      caddc co cN cfz co cM cN cfz co vk cv vm cv c1 caddc co cM cuz cfv wcel
      cN cz wcel vm cv c1 caddc co cN cfz co cM cN cfz co wss vm cv cM cuz cfv
      wcel vm cv c1 caddc co cM cN fzss1 cM vm cv peano2uz sylan sseld imim1d
      r19.20dv2 imp adantlr syl3anc eqcomd vm cv c1 caddc co cN cfz co cA vk
      csu cc wcel vk vm cv c1 caddc co cA csb cc wcel vm cv c1 caddc co c1
      caddc co cN cfz co cA vk csu cc wcel vm cv c1 caddc co cN cfz co cA vk
      csu vk vm cv c1 caddc co cA csb cmin co vm cv c1 caddc co c1 caddc co cN
      cfz co cA vk csu wceq vk vm cv c1 caddc co cA csb vm cv c1 caddc co c1
      caddc co cN cfz co cA vk csu caddc co vm cv c1 caddc co cN cfz co cA vk
      csu wceq wb vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral wa vm cv c1 caddc co cN cfz co cA
      vk csu vk vm cv c1 caddc co cA csb vm cv c1 caddc co c1 caddc co cN cfz
      co cA vk csu subadd vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co
      cN clt wbr wa cA cc wcel vk cM cN cfz co wral cA cc wcel vk vm cv c1
      caddc co cN cfz co wral vm cv c1 caddc co cN cfz co cA vk csu cc wcel vm
      cv cM cuz cfv wcel cN cz wcel wa cA cc wcel vk cM cN cfz co wral cA cc
      wcel vk vm cv c1 caddc co cN cfz co wral vm cv c1 caddc co cN clt wbr vm
      cv cM cuz cfv wcel cN cz wcel wa cA cc wcel vk cM cN cfz co wral cA cc
      wcel vk vm cv c1 caddc co cN cfz co wral vm cv cM cuz cfv wcel cN cz wcel
      wa cA cc wcel cA cc wcel vk cM cN cfz co vm cv c1 caddc co cN cfz co vm
      cv cM cuz cfv wcel cN cz wcel wa vk cv vm cv c1 caddc co cN cfz co wcel
      vk cv cM cN cfz co wcel cA cc wcel vm cv cM cuz cfv wcel cN cz wcel wa vm
      cv c1 caddc co cN cfz co cM cN cfz co vk cv vm cv c1 caddc co cM cuz cfv
      wcel cN cz wcel vm cv c1 caddc co cN cfz co cM cN cfz co wss vm cv cM cuz
      cfv wcel vm cv c1 caddc co cM cN fzss1 cM vm cv peano2uz sylan sseld
      imim1d r19.20dv2 imp adantlr cN vm cv c1 caddc co cuz cfv wcel cA cc wcel
      vk vm cv c1 caddc co cN cfz co wral vm cv c1 caddc co cN cfz co cA vk csu
      cc wcel vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr
      wa cA vk vm cv c1 caddc co cN fsumcl vm cv c1 caddc co cz wcel cN cz wcel
      vm cv c1 caddc co cN clt wbr cN vm cv c1 caddc co cuz cfv wcel vm cv cM
      cuz cfv wcel vm cv c1 caddc co cz wcel cN cz wcel wa vm cv c1 caddc co cN
      clt wbr wa cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc co cN cle wbr
      vm cv c1 caddc co cz wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr vm
      cv c1 caddc co cN cle wbr vm cv c1 caddc co cr wcel cN cr wcel vm cv c1
      caddc co cN clt wbr vm cv c1 caddc co cN cle wbr wi vm cv c1 caddc co cz
      wcel cN cz wcel vm cv c1 caddc co cN ltle vm cv c1 caddc co zre cN zre
      syl2an imp vm cv c1 caddc co cz wcel cN cz wcel wa cN vm cv c1 caddc co
      cuz cfv wcel vm cv c1 caddc co cN cle wbr wb vm cv c1 caddc co cN clt wbr
      vm cv c1 caddc co cN eluz adantr mpbird vm cv cM cuz cfv wcel vm cv cM vm
      cv eluzelz peano2zdi sylanl1 sylan syldan vm cv c1 caddc co cM cN cfz co
      wcel cA cc wcel vk cM cN cfz co wral vk vm cv c1 caddc co cA csb cc wcel
      vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa vk vm
      cv c1 caddc co cM cN cfz co cA cc ra4csbela vm cv c1 caddc co cM cuz cfv
      wcel cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc co cM cN cfz co
      wcel vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa
      vm cv c1 caddc co cM cN eluzfz vm cv cM cuz cfv wcel vm cv c1 caddc co cM
      cuz cfv wcel cN cz wcel vm cv c1 caddc co cN clt wbr cM vm cv peano2uz
      ad2antrr vm cv c1 caddc co cz wcel cN cz wcel vm cv c1 caddc co cN clt
      wbr cN vm cv c1 caddc co cuz cfv wcel vm cv cM cuz cfv wcel vm cv c1
      caddc co cz wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cN vm cv
      c1 caddc co cuz cfv wcel vm cv c1 caddc co cN cle wbr vm cv c1 caddc co
      cz wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN
      cle wbr vm cv c1 caddc co cr wcel cN cr wcel vm cv c1 caddc co cN clt wbr
      vm cv c1 caddc co cN cle wbr wi vm cv c1 caddc co cz wcel cN cz wcel vm
      cv c1 caddc co cN ltle vm cv c1 caddc co zre cN zre syl2an imp vm cv c1
      caddc co cz wcel cN cz wcel wa cN vm cv c1 caddc co cuz cfv wcel vm cv c1
      caddc co cN cle wbr wb vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN
      eluz adantr mpbird vm cv cM cuz cfv wcel vm cv cM vm cv eluzelz peano2zdi
      sylanl1 sylanc sylan vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa vm
      cv c1 caddc co c1 caddc co cN cle wbr wa cA cc wcel vk cM cN cfz co wral
      vm cv c1 caddc co c1 caddc co cN cfz co cA vk csu cc wcel vm cv cM cuz
      cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa vm cv c1 caddc co
      cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co c1 caddc co cN cle wbr wa
      cA cc wcel vk cM cN cfz co wral cA cc wcel vk vm cv c1 caddc co c1 caddc
      co cN cfz co wral vm cv c1 caddc co c1 caddc co cN cfz co cA vk csu cc
      wcel vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa cA cc wcel vk cM cN
      cfz co wral cA cc wcel vk vm cv c1 caddc co c1 caddc co cN cfz co wral vm
      cv c1 caddc co c1 caddc co cN cle wbr vm cv c1 caddc co cM cuz cfv wcel
      cN cz wcel wa cA cc wcel vk cM cN cfz co wral cA cc wcel vk vm cv c1
      caddc co c1 caddc co cN cfz co wral vm cv c1 caddc co cM cuz cfv wcel cN
      cz wcel wa cA cc wcel cA cc wcel vk cM cN cfz co vm cv c1 caddc co c1
      caddc co cN cfz co vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa vk cv
      vm cv c1 caddc co c1 caddc co cN cfz co wcel vk cv cM cN cfz co wcel cA
      cc wcel vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co
      c1 caddc co cN cfz co cM cN cfz co vk cv vm cv c1 caddc co c1 caddc co cM
      cuz cfv wcel cN cz wcel vm cv c1 caddc co c1 caddc co cN cfz co cM cN cfz
      co wss vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co c1 caddc co cM
      cN fzss1 cM vm cv c1 caddc co peano2uz sylan sseld imim1d r19.20dv2 imp
      adantlr cN vm cv c1 caddc co c1 caddc co cuz cfv wcel cA cc wcel vk vm cv
      c1 caddc co c1 caddc co cN cfz co wral vm cv c1 caddc co c1 caddc co cN
      cfz co cA vk csu cc wcel vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa
      vm cv c1 caddc co c1 caddc co cN cle wbr wa cA vk vm cv c1 caddc co c1
      caddc co cN fsumcl vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa cN vm
      cv c1 caddc co c1 caddc co cuz cfv wcel vm cv c1 caddc co c1 caddc co cN
      cle wbr vm cv c1 caddc co c1 caddc co cz wcel cN cz wcel cN vm cv c1
      caddc co c1 caddc co cuz cfv wcel vm cv c1 caddc co c1 caddc co cN cle
      wbr wb vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co c1 caddc co cN
      eluz vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1
      caddc co eluzelz peano2zdi sylan biimpar sylan syldan vm cv c1 caddc co
      cM cuz cfv wcel cN cz wcel vm cv c1 caddc co cN clt wbr vm cv c1 caddc co
      cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co c1 caddc co cN cle wbr wa
      vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel cN cz wcel wa vm
      cv c1 caddc co cN clt wbr wa vm cv c1 caddc co cM cuz cfv wcel cN cz wcel
      wa vm cv c1 caddc co c1 caddc co cN cle wbr vm cv c1 caddc co cM cuz cfv
      wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr pm3.26 vm cv c1 caddc co
      cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr vm cv c1 caddc
      co c1 caddc co cN cle wbr vm cv c1 caddc co cz wcel cN cz wcel vm cv c1
      caddc co cN clt wbr vm cv c1 caddc co c1 caddc co cN cle wbr wb vm cv c1
      caddc co cM cuz cfv wcel vm cv c1 caddc co cN zltp1le cM vm cv c1 caddc
      co eluzelz sylan biimpa jca cM vm cv peano2uz sylanl1 sylan syl3anc
      mpbird eqcomd opreq12d cM vm cv cfz co cA vk csu cc wcel vk vm cv c1
      caddc co cA csb cc wcel vm cv c1 caddc co cN cfz co cA vk csu cc wcel cM
      vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co vm cv c1
      caddc co cN cfz co cA vk csu vk vm cv c1 caddc co cA csb cmin co caddc co
      cM vm cv cfz co cA vk csu vm cv c1 caddc co cN cfz co cA vk csu caddc co
      wceq vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa
      cA cc wcel vk cM cN cfz co wral wa cM vm cv cfz co cA vk csu vk vm cv c1
      caddc co cA csb vm cv c1 caddc co cN cfz co cA vk csu ppncan vm cv cM cuz
      cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM
      cN cfz co wral cA cc wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk
      csu cc wcel vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt
      wbr wa cA cc wcel vk cM cN cfz co wral cA cc wcel vk cM vm cv cfz co wral
      vm cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc
      wcel cA cc wcel vk cM cN cfz co cM vm cv cfz co vm cv cM cuz cfv wcel cN
      cz wcel wa vm cv c1 caddc co cN clt wbr wa vk cv cM vm cv cfz co wcel vk
      cv cM cN cfz co wcel cA cc wcel vm cv cM cuz cfv wcel cN cz wcel wa vm cv
      c1 caddc co cN clt wbr wa cM vm cv cfz co cM cN cfz co vk cv cN vm cv cuz
      cfv wcel cM cz wcel cM vm cv cfz co cM cN cfz co wss vm cv cM cuz cfv
      wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa vm cv cM cN fzss2 vm
      cv cz wcel cN cz wcel vm cv c1 caddc co cN clt wbr cN vm cv cuz cfv wcel
      vm cv cM cuz cfv wcel vm cv cz wcel cN cz wcel wa vm cv c1 caddc co cN
      clt wbr vm cv cN cle wbr cN vm cv cuz cfv wcel vm cv cz wcel cN cz wcel
      wa vm cv c1 caddc co cN clt wbr vm cv cN cle wbr vm cv cr wcel cN cr wcel
      vm cv c1 caddc co cN clt wbr vm cv cN cle wbr wi vm cv cz wcel cN cz wcel
      vm cv cr wcel cN cr wcel wa vm cv c1 caddc co cN clt wbr vm cv cN clt wbr
      vm cv cN cle wbr vm cv cr wcel cN cr wcel wa vm cv vm cv c1 caddc co clt
      wbr vm cv c1 caddc co cN clt wbr vm cv cN clt wbr vm cv cr wcel vm cv vm
      cv c1 caddc co clt wbr cN cr wcel vm cv ltp1 adantr vm cv cr wcel vm cv
      c1 caddc co cr wcel wa cN cr wcel vm cv vm cv c1 caddc co clt wbr vm cv
      c1 caddc co cN clt wbr wa vm cv cN clt wbr wi vm cv cr wcel vm cv cr wcel
      vm cv c1 caddc co cr wcel cN cr wcel vm cv vm cv c1 caddc co clt wbr vm
      cv c1 caddc co cN clt wbr wa vm cv cN clt wbr wi vm cv vm cv c1 caddc co
      cN axlttrn 3expa vm cv cr wcel vm cv c1 caddc co cr wcel vm cv peano2re
      ancli sylan mpand vm cv cN ltle syld vm cv zre cN zre syl2an imp vm cv cz
      wcel cN cz wcel wa cN vm cv cuz cfv wcel vm cv cN cle wbr vm cv cN eluz
      biimpar syldan cM vm cv eluzelz sylanl1 vm cv cM cuz cfv wcel cM cz wcel
      cN cz wcel vm cv c1 caddc co cN clt wbr cM vm cv eluzel2 ad2antrr sylanc
      sseld imim1d r19.20dv2 imp vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv
      cfz co wral cM vm cv cfz co cA vk csu cc wcel vm cv cM cuz cfv wcel cN cz
      wcel wa vm cv c1 caddc co cN clt wbr wa cA vk cM vm cv fsumcl vm cv cM
      cuz cfv wcel cN cz wcel vm cv c1 caddc co cN clt wbr simpll sylan syldan
      vm cv c1 caddc co cM cN cfz co wcel cA cc wcel vk cM cN cfz co wral vk vm
      cv c1 caddc co cA csb cc wcel vm cv cM cuz cfv wcel cN cz wcel wa vm cv
      c1 caddc co cN clt wbr wa vk vm cv c1 caddc co cM cN cfz co cA cc
      ra4csbela vm cv c1 caddc co cM cuz cfv wcel cN vm cv c1 caddc co cuz cfv
      wcel vm cv c1 caddc co cM cN cfz co wcel vm cv cM cuz cfv wcel cN cz wcel
      wa vm cv c1 caddc co cN clt wbr wa vm cv c1 caddc co cM cN eluzfz vm cv
      cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel cN cz wcel vm cv c1
      caddc co cN clt wbr cM vm cv peano2uz ad2antrr vm cv c1 caddc co cz wcel
      cN cz wcel vm cv c1 caddc co cN clt wbr cN vm cv c1 caddc co cuz cfv wcel
      vm cv cM cuz cfv wcel vm cv c1 caddc co cz wcel cN cz wcel wa vm cv c1
      caddc co cN clt wbr wa cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc
      co cN cle wbr vm cv c1 caddc co cz wcel cN cz wcel wa vm cv c1 caddc co
      cN clt wbr vm cv c1 caddc co cN cle wbr vm cv c1 caddc co cr wcel cN cr
      wcel vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN cle wbr wi vm cv
      c1 caddc co cz wcel cN cz wcel vm cv c1 caddc co cN ltle vm cv c1 caddc
      co zre cN zre syl2an imp vm cv c1 caddc co cz wcel cN cz wcel wa cN vm cv
      c1 caddc co cuz cfv wcel vm cv c1 caddc co cN cle wbr wb vm cv c1 caddc
      co cN clt wbr vm cv c1 caddc co cN eluz adantr mpbird vm cv cM cuz cfv
      wcel vm cv cM vm cv eluzelz peano2zdi sylanl1 sylanc sylan vm cv cM cuz
      cfv wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cA cc wcel vk cM
      cN cfz co wral cA cc wcel vk vm cv c1 caddc co cN cfz co wral vm cv c1
      caddc co cN cfz co cA vk csu cc wcel vm cv cM cuz cfv wcel cN cz wcel wa
      cA cc wcel vk cM cN cfz co wral cA cc wcel vk vm cv c1 caddc co cN cfz co
      wral vm cv c1 caddc co cN clt wbr vm cv cM cuz cfv wcel cN cz wcel wa cA
      cc wcel vk cM cN cfz co wral cA cc wcel vk vm cv c1 caddc co cN cfz co
      wral vm cv cM cuz cfv wcel cN cz wcel wa cA cc wcel cA cc wcel vk cM cN
      cfz co vm cv c1 caddc co cN cfz co vm cv cM cuz cfv wcel cN cz wcel wa vk
      cv vm cv c1 caddc co cN cfz co wcel vk cv cM cN cfz co wcel cA cc wcel vm
      cv cM cuz cfv wcel cN cz wcel wa vm cv c1 caddc co cN cfz co cM cN cfz co
      vk cv vm cv c1 caddc co cM cuz cfv wcel cN cz wcel vm cv c1 caddc co cN
      cfz co cM cN cfz co wss vm cv cM cuz cfv wcel vm cv c1 caddc co cM cN
      fzss1 cM vm cv peano2uz sylan sseld imim1d r19.20dv2 imp adantlr cN vm cv
      c1 caddc co cuz cfv wcel cA cc wcel vk vm cv c1 caddc co cN cfz co wral
      vm cv c1 caddc co cN cfz co cA vk csu cc wcel vm cv cM cuz cfv wcel cN cz
      wcel wa vm cv c1 caddc co cN clt wbr wa cA vk vm cv c1 caddc co cN fsumcl
      vm cv c1 caddc co cz wcel cN cz wcel vm cv c1 caddc co cN clt wbr cN vm
      cv c1 caddc co cuz cfv wcel vm cv cM cuz cfv wcel vm cv c1 caddc co cz
      wcel cN cz wcel wa vm cv c1 caddc co cN clt wbr wa cN vm cv c1 caddc co
      cuz cfv wcel vm cv c1 caddc co cN cle wbr vm cv c1 caddc co cz wcel cN cz
      wcel wa vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN cle wbr vm cv
      c1 caddc co cr wcel cN cr wcel vm cv c1 caddc co cN clt wbr vm cv c1
      caddc co cN cle wbr wi vm cv c1 caddc co cz wcel cN cz wcel vm cv c1
      caddc co cN ltle vm cv c1 caddc co zre cN zre syl2an imp vm cv c1 caddc
      co cz wcel cN cz wcel wa cN vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc
      co cN cle wbr wb vm cv c1 caddc co cN clt wbr vm cv c1 caddc co cN eluz
      adantr mpbird vm cv cM cuz cfv wcel vm cv cM vm cv eluzelz peano2zdi
      sylanl1 sylan syldan syl3anc eqtr2d sylan9eqr ex exp41 imp4c a2d syld
      uzind4 exp3a imp31 cN cz wcel cK cM cN c1 cmin co cfz co wcel wa cK cM
      cuz cfv wcel cN cz wcel cK cN clt wbr cK cM cN c1 cmin co cfz co wcel cK
      cM cuz cfv wcel cN cz wcel cK cM cN c1 cmin co elfzuz adantl cN cz wcel
      cK cM cN c1 cmin co cfz co wcel pm3.26 cN cz wcel cK cz wcel cK cN c1
      cmin co cle wbr wa cK cN clt wbr cK cM cN c1 cmin co cfz co wcel cN cz
      wcel cK cz wcel cK cN c1 cmin co cle wbr cK cN clt wbr cN cz wcel cK cz
      wcel wa cK cN clt wbr cK cN c1 cmin co cle wbr cK cz wcel cN cz wcel cK
      cN clt wbr cK cN c1 cmin co cle wbr wb cK cN zltlem1 ancoms biimpar
      anasss cK cM cN c1 cmin co cfz co wcel cK cz wcel cK cN c1 cmin co cle
      wbr cK cM cN c1 cmin co elfzelz cK cM cN c1 cmin co elfzle2 jca sylan2
      jca32 sylan 3impa $.
      $( [4-Jan-2005] $) $( [10-Dec-2005] $)

    $( Split a finite sum into two parts. $)
    fsum0split $p |- ( ( N e. ZZ /\ K e. ( 1 ... N )
       /\ A. k e. ( 0 ... N ) A e. CC ) -> sum_ k e. ( 0 ... N ) A =
    ( sum_ k e. ( 0 ... ( N - K ) ) A +
                               sum_ k e. ( ( ( N - K ) + 1 ) ... N ) A ) ) $=
      cN cz wcel cN cK cmin co cc0 cN c1 cmin co cfz co wcel cA cc wcel vk cc0
      cN cfz co wral cc0 cN cfz co cA vk csu cc0 cN cK cmin co cfz co cA vk csu
      cN cK cmin co c1 caddc co cN cfz co cA vk csu caddc co wceq cK c1 cN cfz
      co wcel cA vk cN cK cmin co cc0 cN fsumsplit cN cz wcel cK c1 cN cfz co
      wcel cN cK cmin co cc0 cN c1 cmin co cfz co wcel cA cc wcel vk cc0 cN cfz
      co wral cN cz wcel cK c1 cN cfz co wcel wa cN cK cmin co cN cN cmin co cN
      c1 cmin co cfz co cc0 cN c1 cmin co cfz co cN cz wcel cK c1 cN cfz co
      wcel cN cK cmin co cN cN cmin co cN c1 cmin co cfz co wcel cz cN cK c1 cN
      fzrev2i 3anidm12 cN cz wcel cN cN cmin co cN c1 cmin co cfz co cc0 cN c1
      cmin co cfz co wceq cK c1 cN cfz co wcel cN cz wcel cN cN cmin co cc0 cN
      c1 cmin co cfz cN cz wcel cN cc wcel cN cN cmin co cc0 wceq cN zcn cN
      subid syl opreq1d adantr eleqtrd 3adant3 syld3an2 $.
      $( [7-Jan-2006] $) $( [31-Dec-2005] $)
  $}

  ${
    $d j m A $.  $d j m B $.  $d j k m M $.  $d j k N $.
    $( The sum of two finite sums. $)
    fsumadd $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
       ( A e. CC /\ B e. CC ) ) -> sum_ k e. ( M ... N ) ( A + B ) =
           ( sum_ k e. ( M ... N ) A + sum_ k e. ( M ... N ) B ) ) $=
      cN cM cuz cfv wcel cA cc wcel cB cc wcel wa vk cM cN cfz co wral cM cN
      cfz co cA cB caddc co vk csu cM cN cfz co cA vk csu cM cN cfz co cB vk
      csu caddc co wceq cA cc wcel cB cc wcel wa vk cM vj cv cfz co wral cM vj
      cv cfz co cA cB caddc co vk csu cM vj cv cfz co cA vk csu cM vj cv cfz co
      cB vk csu caddc co wceq wi cA cc wcel cB cc wcel wa vk cM cM cfz co wral
      cM cM cfz co cA cB caddc co vk csu cM cM cfz co cA vk csu cM cM cfz co cB
      vk csu caddc co wceq wi cA cc wcel cB cc wcel wa vk cM vm cv cfz co wral
      cM vm cv cfz co cA cB caddc co vk csu cM vm cv cfz co cA vk csu cM vm cv
      cfz co cB vk csu caddc co wceq wi cA cc wcel cB cc wcel wa vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA cB caddc co vk csu cM
      vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu
      caddc co wceq wi cA cc wcel cB cc wcel wa vk cM cN cfz co wral cM cN cfz
      co cA cB caddc co vk csu cM cN cfz co cA vk csu cM cN cfz co cB vk csu
      caddc co wceq wi vj vm cM cN vj cv cM wceq cA cc wcel cB cc wcel wa vk cM
      vj cv cfz co wral cA cc wcel cB cc wcel wa vk cM cM cfz co wral cM vj cv
      cfz co cA cB caddc co vk csu cM vj cv cfz co cA vk csu cM vj cv cfz co cB
      vk csu caddc co wceq cM cM cfz co cA cB caddc co vk csu cM cM cfz co cA
      vk csu cM cM cfz co cB vk csu caddc co wceq vj cv cM wceq cA cc wcel cB
      cc wcel wa vk cM vj cv cfz co cM cM cfz co vj cv cM cM cfz opreq2 raleq1d
      vj cv cM wceq cM vj cv cfz co cA cB caddc co vk csu cM cM cfz co cA cB
      caddc co vk csu cM vj cv cfz co cA vk csu cM vj cv cfz co cB vk csu caddc
      co cM cM cfz co cA vk csu cM cM cfz co cB vk csu caddc co vj cv cM wceq
      cM vj cv cfz co cM cM cfz co cA cB caddc co vk vj cv cM cM cfz opreq2
      sumeq1d vj cv cM wceq cM vj cv cfz co cA vk csu cM cM cfz co cA vk csu cM
      vj cv cfz co cB vk csu cM cM cfz co cB vk csu caddc vj cv cM wceq cM vj
      cv cfz co cM cM cfz co cA vk vj cv cM cM cfz opreq2 sumeq1d vj cv cM wceq
      cM vj cv cfz co cM cM cfz co cB vk vj cv cM cM cfz opreq2 sumeq1d
      opreq12d eqeq12d imbi12d vj cv vm cv wceq cA cc wcel cB cc wcel wa vk cM
      vj cv cfz co wral cA cc wcel cB cc wcel wa vk cM vm cv cfz co wral cM vj
      cv cfz co cA cB caddc co vk csu cM vj cv cfz co cA vk csu cM vj cv cfz co
      cB vk csu caddc co wceq cM vm cv cfz co cA cB caddc co vk csu cM vm cv
      cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co wceq vj cv vm cv wceq
      cA cc wcel cB cc wcel wa vk cM vj cv cfz co cM vm cv cfz co vj cv vm cv
      cM cfz opreq2 raleq1d vj cv vm cv wceq cM vj cv cfz co cA cB caddc co vk
      csu cM vm cv cfz co cA cB caddc co vk csu cM vj cv cfz co cA vk csu cM vj
      cv cfz co cB vk csu caddc co cM vm cv cfz co cA vk csu cM vm cv cfz co cB
      vk csu caddc co vj cv vm cv wceq cM vj cv cfz co cM vm cv cfz co cA cB
      caddc co vk vj cv vm cv cM cfz opreq2 sumeq1d vj cv vm cv wceq cM vj cv
      cfz co cA vk csu cM vm cv cfz co cA vk csu cM vj cv cfz co cB vk csu cM
      vm cv cfz co cB vk csu caddc vj cv vm cv wceq cM vj cv cfz co cM vm cv
      cfz co cA vk vj cv vm cv cM cfz opreq2 sumeq1d vj cv vm cv wceq cM vj cv
      cfz co cM vm cv cfz co cB vk vj cv vm cv cM cfz opreq2 sumeq1d opreq12d
      eqeq12d imbi12d vj cv vm cv c1 caddc co wceq cA cc wcel cB cc wcel wa vk
      cM vj cv cfz co wral cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz
      co wral cM vj cv cfz co cA cB caddc co vk csu cM vj cv cfz co cA vk csu
      cM vj cv cfz co cB vk csu caddc co wceq cM vm cv c1 caddc co cfz co cA cB
      caddc co vk csu cM vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc
      co cfz co cB vk csu caddc co wceq vj cv vm cv c1 caddc co wceq cA cc wcel
      cB cc wcel wa vk cM vj cv cfz co cM vm cv c1 caddc co cfz co vj cv vm cv
      c1 caddc co cM cfz opreq2 raleq1d vj cv vm cv c1 caddc co wceq cM vj cv
      cfz co cA cB caddc co vk csu cM vm cv c1 caddc co cfz co cA cB caddc co
      vk csu cM vj cv cfz co cA vk csu cM vj cv cfz co cB vk csu caddc co cM vm
      cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu
      caddc co vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1 caddc
      co cfz co cA cB caddc co vk vj cv vm cv c1 caddc co cM cfz opreq2 sumeq1d
      vj cv vm cv c1 caddc co wceq cM vj cv cfz co cA vk csu cM vm cv c1 caddc
      co cfz co cA vk csu cM vj cv cfz co cB vk csu cM vm cv c1 caddc co cfz co
      cB vk csu caddc vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1
      caddc co cfz co cA vk vj cv vm cv c1 caddc co cM cfz opreq2 sumeq1d vj cv
      vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co cfz co cB vk
      vj cv vm cv c1 caddc co cM cfz opreq2 sumeq1d opreq12d eqeq12d imbi12d vj
      cv cN wceq cA cc wcel cB cc wcel wa vk cM vj cv cfz co wral cA cc wcel cB
      cc wcel wa vk cM cN cfz co wral cM vj cv cfz co cA cB caddc co vk csu cM
      vj cv cfz co cA vk csu cM vj cv cfz co cB vk csu caddc co wceq cM cN cfz
      co cA cB caddc co vk csu cM cN cfz co cA vk csu cM cN cfz co cB vk csu
      caddc co wceq vj cv cN wceq cA cc wcel cB cc wcel wa vk cM vj cv cfz co
      cM cN cfz co vj cv cN cM cfz opreq2 raleq1d vj cv cN wceq cM vj cv cfz co
      cA cB caddc co vk csu cM cN cfz co cA cB caddc co vk csu cM vj cv cfz co
      cA vk csu cM vj cv cfz co cB vk csu caddc co cM cN cfz co cA vk csu cM cN
      cfz co cB vk csu caddc co vj cv cN wceq cM vj cv cfz co cM cN cfz co cA
      cB caddc co vk vj cv cN cM cfz opreq2 sumeq1d vj cv cN wceq cM vj cv cfz
      co cA vk csu cM cN cfz co cA vk csu cM vj cv cfz co cB vk csu cM cN cfz
      co cB vk csu caddc vj cv cN wceq cM vj cv cfz co cM cN cfz co cA vk vj cv
      cN cM cfz opreq2 sumeq1d vj cv cN wceq cM vj cv cfz co cM cN cfz co cB vk
      vj cv cN cM cfz opreq2 sumeq1d opreq12d eqeq12d imbi12d cM cz wcel cA cc
      wcel cB cc wcel wa vk cM cM cfz co wral cM cM cfz co cA cB caddc co vk
      csu cM cM cfz co cA vk csu cM cM cfz co cB vk csu caddc co wceq cM cz
      wcel cA cc wcel cB cc wcel wa vk cM cM cfz co wral wa vk cM cA cB caddc
      co csb vk cM cA csb vk cM cB csb caddc co cM cM cfz co cA cB caddc co vk
      csu cM cM cfz co cA vk csu cM cM cfz co cB vk csu caddc co cM cz wcel vk
      cM cA cB caddc co csb vk cM cA csb vk cM cB csb caddc co wceq cA cc wcel
      cB cc wcel wa vk cM cM cfz co wral vk cM cA cB cz caddc csbopr12g adantr
      cM cz wcel cA cB caddc co cc wcel vk cM cM cfz co wral cM cM cfz co cA cB
      caddc co vk csu vk cM cA cB caddc co csb wceq cA cc wcel cB cc wcel wa vk
      cM cM cfz co wral cA cB caddc co cc vk cM fsum1s cA cc wcel cB cc wcel wa
      cA cB caddc co cc wcel vk cM cM cfz co cA cB addcl r19.20si sylan2 cM cz
      wcel cA cc wcel cB cc wcel wa vk cM cM cfz co wral wa cM cM cfz co cA vk
      csu vk cM cA csb cM cM cfz co cB vk csu vk cM cB csb caddc cM cz wcel cA
      cc wcel vk cM cM cfz co wral cM cM cfz co cA vk csu vk cM cA csb wceq cA
      cc wcel cB cc wcel wa vk cM cM cfz co wral cA cc vk cM fsum1s cA cc wcel
      cB cc wcel wa cA cc wcel vk cM cM cfz co cA cc wcel cB cc wcel pm3.26
      r19.20si sylan2 cM cz wcel cB cc wcel vk cM cM cfz co wral cM cM cfz co
      cB vk csu vk cM cB csb wceq cA cc wcel cB cc wcel wa vk cM cM cfz co wral
      cB cc vk cM fsum1s cA cc wcel cB cc wcel wa cB cc wcel vk cM cM cfz co cA
      cc wcel cB cc wcel pm3.27 r19.20si sylan2 opreq12d 3eqtr4d ex vm cv cM
      cuz cfv wcel cA cc wcel cB cc wcel wa vk cM vm cv cfz co wral cM vm cv
      cfz co cA cB caddc co vk csu cM vm cv cfz co cA vk csu cM vm cv cfz co cB
      vk csu caddc co wceq wi cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co
      cfz co wral cM vm cv cfz co cA cB caddc co vk csu cM vm cv cfz co cA vk
      csu cM vm cv cfz co cB vk csu caddc co wceq wi cA cc wcel cB cc wcel wa
      vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA cB
      caddc co vk csu cM vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc
      co cfz co cB vk csu caddc co wceq wi vm cv cM cuz cfv wcel cA cc wcel cB
      cc wcel wa vk cM vm cv c1 caddc co cfz co wral cA cc wcel cB cc wcel wa
      vk cM vm cv cfz co wral cM vm cv cfz co cA cB caddc co vk csu cM vm cv
      cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co wceq vm cv cM cuz cfv
      wcel cA cc wcel cB cc wcel wa cA cc wcel cB cc wcel wa vk cM vm cv c1
      caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz
      co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel cB cc wcel wa
      vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv
      cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss
      vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz
      sylanc sseld imim1d r19.20dv2 imim1d vm cv cM cuz cfv wcel cA cc wcel cB
      cc wcel wa vk cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA cB
      caddc co vk csu cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu caddc
      co wceq cM vm cv c1 caddc co cfz co cA cB caddc co vk csu cM vm cv c1
      caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu caddc co
      wceq vm cv cM cuz cfv wcel cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc
      co cfz co wral cM vm cv cfz co cA cB caddc co vk csu cM vm cv cfz co cA
      vk csu cM vm cv cfz co cB vk csu caddc co wceq cM vm cv c1 caddc co cfz
      co cA cB caddc co vk csu cM vm cv c1 caddc co cfz co cA vk csu cM vm cv
      c1 caddc co cfz co cB vk csu caddc co wceq vm cv cM cuz cfv wcel cA cc
      wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co
      cA cB caddc co vk csu cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu
      caddc co wceq wa cM vm cv cfz co cA cB caddc co vk csu vk vm cv c1 caddc
      co cA cB caddc co csb caddc co cM vm cv cfz co cA vk csu vk vm cv c1
      caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk vm cv c1 caddc co
      cB csb caddc co caddc co cM vm cv c1 caddc co cfz co cA cB caddc co vk
      csu cM vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB
      vk csu caddc co cM vm cv cfz co cA cB caddc co vk csu cM vm cv cfz co cA
      vk csu cM vm cv cfz co cB vk csu caddc co wceq vm cv cM cuz cfv wcel cA
      cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz
      co cA cB caddc co vk csu vk vm cv c1 caddc co cA cB caddc co csb caddc co
      cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co vk vm cv c1
      caddc co cA cB caddc co csb caddc co cM vm cv cfz co cA vk csu vk vm cv
      c1 caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk vm cv c1 caddc
      co cB csb caddc co caddc co cM vm cv cfz co cA cB caddc co vk csu cM vm
      cv cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co vk vm cv c1 caddc
      co cA cB caddc co csb caddc opreq1 vm cv cM cuz cfv wcel cA cc wcel cB cc
      wcel wa vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk csu
      cM vm cv cfz co cB vk csu caddc co vk vm cv c1 caddc co cA csb vk vm cv
      c1 caddc co cB csb caddc co caddc co cM vm cv cfz co cA vk csu vk vm cv
      c1 caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk vm cv c1 caddc
      co cB csb caddc co caddc co cM vm cv cfz co cA vk csu cM vm cv cfz co cB
      vk csu caddc co vk vm cv c1 caddc co cA cB caddc co csb caddc co cM vm cv
      cfz co cA vk csu cc wcel cM vm cv cfz co cB vk csu cc wcel wa vk vm cv c1
      caddc co cA csb cc wcel vk vm cv c1 caddc co cB csb cc wcel wa cM vm cv
      cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co vk vm cv c1 caddc co
      cA csb vk vm cv c1 caddc co cB csb caddc co caddc co cM vm cv cfz co cA
      vk csu vk vm cv c1 caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk
      vm cv c1 caddc co cB csb caddc co caddc co wceq vm cv cM cuz cfv wcel cA
      cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz
      co cA vk csu cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb vk vm
      cv c1 caddc co cB csb add4 vm cv cM cuz cfv wcel cA cc wcel cB cc wcel wa
      vk cM vm cv c1 caddc co cfz co wral cA cc wcel cB cc wcel wa vk cM vm cv
      cfz co wral cM vm cv cfz co cA vk csu cc wcel cM vm cv cfz co cB vk csu
      cc wcel wa vm cv cM cuz cfv wcel cA cc wcel cB cc wcel wa vk cM vm cv c1
      caddc co cfz co wral cA cc wcel cB cc wcel wa vk cM vm cv cfz co wral vm
      cv cM cuz cfv wcel cA cc wcel cB cc wcel wa cA cc wcel cB cc wcel wa vk
      cM vm cv c1 caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv
      cM vm cv cfz co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel cB
      cc wcel wa vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz
      co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co
      cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm
      cv eluzelz sylanc sseld imim1d r19.20dv2 imp vm cv cM cuz cfv wcel cA cc
      wcel cB cc wcel wa vk cM vm cv cfz co wral wa cM vm cv cfz co cA vk csu
      cc wcel cM vm cv cfz co cB vk csu cc wcel vm cv cM cuz cfv wcel cA cc
      wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk csu cc wcel cA cc wcel
      cB cc wcel wa vk cM vm cv cfz co wral cA vk cM vm cv fsumcl cA cc wcel cB
      cc wcel wa cA cc wcel vk cM vm cv cfz co cA cc wcel cB cc wcel pm3.26
      r19.20si sylan2 vm cv cM cuz cfv wcel cB cc wcel vk cM vm cv cfz co wral
      cM vm cv cfz co cB vk csu cc wcel cA cc wcel cB cc wcel wa vk cM vm cv
      cfz co wral cB vk cM vm cv fsumcl cA cc wcel cB cc wcel wa cB cc wcel vk
      cM vm cv cfz co cA cc wcel cB cc wcel pm3.27 r19.20si sylan2 jca syldan
      vm cv cM cuz cfv wcel cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co
      cfz co wral wa vk vm cv c1 caddc co cA csb cc wcel vk vm cv c1 caddc co
      cB csb cc wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co cA csb cc
      wcel vm cv cM cuz cfv wcel cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc
      co cfz co wral vk vm cv c1 caddc co cM vm cv c1 caddc co cfz co cA cc
      ra4csbela vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel vm cv
      c1 caddc co cM vm cv c1 caddc co cfz co wcel cM vm cv peano2uz cM vm cv
      c1 caddc co eluzfz2 syl cA cc wcel cB cc wcel wa cA cc wcel vk cM vm cv
      c1 caddc co cfz co cA cc wcel cB cc wcel pm3.26 r19.20si syl2an vm cv c1
      caddc co cM vm cv c1 caddc co cfz co wcel cB cc wcel vk cM vm cv c1 caddc
      co cfz co wral vk vm cv c1 caddc co cB csb cc wcel vm cv cM cuz cfv wcel
      cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral vk vm cv c1
      caddc co cM vm cv c1 caddc co cfz co cB cc ra4csbela vm cv cM cuz cfv
      wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1
      caddc co cfz co wcel cM vm cv peano2uz cM vm cv c1 caddc co eluzfz2 syl
      cA cc wcel cB cc wcel wa cB cc wcel vk cM vm cv c1 caddc co cfz co cA cc
      wcel cB cc wcel pm3.27 r19.20si syl2an jca sylanc vk vm cv c1 caddc co cA
      cB caddc co csb vk vm cv c1 caddc co cA csb vk vm cv c1 caddc co cB csb
      caddc co cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co
      caddc vm cv c1 caddc co cvv wcel vk vm cv c1 caddc co cA cB caddc co csb
      vk vm cv c1 caddc co cA csb vk vm cv c1 caddc co cB csb caddc co wceq vm
      cv c1 caddc oprex vk vm cv c1 caddc co cA cB cvv caddc csbopr12g ax-mp
      opreq2i syl5eq sylan9eqr vm cv cM cuz cfv wcel cA cc wcel cB cc wcel wa
      vk cM vm cv c1 caddc co cfz co wral wa cM vm cv c1 caddc co cfz co cA cB
      caddc co vk csu cM vm cv cfz co cA cB caddc co vk csu vk vm cv c1 caddc
      co cA cB caddc co csb caddc co wceq cM vm cv cfz co cA cB caddc co vk csu
      cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu caddc co wceq vm cv
      cM cuz cfv wcel cA cB caddc co cc wcel vk cM vm cv c1 caddc co cfz co
      wral cM vm cv c1 caddc co cfz co cA cB caddc co vk csu cM vm cv cfz co cA
      cB caddc co vk csu vk vm cv c1 caddc co cA cB caddc co csb caddc co wceq
      cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral cA cB caddc
      co cc vk cM vm cv fsump1s cA cc wcel cB cc wcel wa cA cB caddc co cc wcel
      vk cM vm cv c1 caddc co cfz co cA cB addcl r19.20si sylan2 adantr vm cv
      cM cuz cfv wcel cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co
      wral wa cM vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co
      cB vk csu caddc co cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb
      caddc co cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cB csb caddc co
      caddc co wceq cM vm cv cfz co cA cB caddc co vk csu cM vm cv cfz co cA vk
      csu cM vm cv cfz co cB vk csu caddc co wceq vm cv cM cuz cfv wcel cA cc
      wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral wa cM vm cv c1
      caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1 caddc co
      cA csb caddc co cM vm cv c1 caddc co cfz co cB vk csu cM vm cv cfz co cB
      vk csu vk vm cv c1 caddc co cB csb caddc co caddc vm cv cM cuz cfv wcel
      cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz
      co cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc
      co wceq cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co wral cA
      cc vk cM vm cv fsump1s cA cc wcel cB cc wcel wa cA cc wcel vk cM vm cv c1
      caddc co cfz co cA cc wcel cB cc wcel pm3.26 r19.20si sylan2 vm cv cM cuz
      cfv wcel cB cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc
      co cfz co cB vk csu cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cB csb
      caddc co wceq cA cc wcel cB cc wcel wa vk cM vm cv c1 caddc co cfz co
      wral cB cc vk cM vm cv fsump1s cA cc wcel cB cc wcel wa cB cc wcel vk cM
      vm cv c1 caddc co cfz co cA cc wcel cB cc wcel pm3.27 r19.20si sylan2
      opreq12d adantr 3eqtr4d exp31 a2d syld uzind4 imp $.
      $( [18-Jan-2006] $) $( [14-Nov-2005] $)
  $}

  ${
    fsum2.1 $e |- A e. _V $.
    $( The sum of two terms. $)
    fsum2 $p |- ( M e. ZZ -> sum_ k e. ( M ... ( M + 1 ) ) A =
                ( [_ M / k ]_ A + [_ ( M + 1 ) / k ]_ A ) ) $=
      cM cz wcel cM cM c1 caddc co cfz co cA vk csu cM cM cfz co cA vk csu vk
      cM c1 caddc co cA csb caddc co vk cM cA csb vk cM c1 caddc co cA csb
      caddc co cM cz wcel cM cM cuz cfv wcel cM cM c1 caddc co cfz co cA vk csu
      cM cM cfz co cA vk csu vk cM c1 caddc co cA csb caddc co wceq cM uzid cA
      vk cM cM fsum2.1 fsump1slem syl cM cz wcel cM cM cfz co cA vk csu vk cM
      cA csb vk cM c1 caddc co cA csb caddc cA vk cM fsum2.1 fsum1slem opreq1d
      eqtrd $.
      $( [5-Feb-2007] $) $( [31-Jan-2007] $)

    $( The sum of three terms. $)
    fsum3 $p |- ( M e. ZZ -> sum_ k e. ( M ... ( M + 2 ) ) A =
    ( ( [_ M / k ]_ A + [_ ( M + 1 ) / k ]_ A ) + [_ ( M + 2 ) / k ]_ A ) ) $=
      cM cz wcel cM cM c1 caddc co c1 caddc co cfz co cA vk csu cM cM c1 caddc
      co cfz co cA vk csu vk cM c1 caddc co c1 caddc co cA csb caddc co cM cM
      c2 caddc co cfz co cA vk csu vk cM cA csb vk cM c1 caddc co cA csb caddc
      co vk cM c2 caddc co cA csb caddc co cM cz wcel cM cM cuz cfv wcel cM c1
      caddc co cM cuz cfv wcel cM cM c1 caddc co c1 caddc co cfz co cA vk csu
      cM cM c1 caddc co cfz co cA vk csu vk cM c1 caddc co c1 caddc co cA csb
      caddc co wceq cM uzid cM cM peano2uz cA vk cM cM c1 caddc co fsum2.1
      fsump1slem 3syl cM cz wcel cM cM c1 caddc co c1 caddc co cfz co cM cM c2
      caddc co cfz co cA vk cM cz wcel cM c1 caddc co c1 caddc co cM c2 caddc
      co cM cfz cM cz wcel cM c1 caddc co c1 caddc co cM c1 c1 caddc co caddc
      co cM c2 caddc co cM cz wcel cM cc wcel cM c1 caddc co c1 caddc co cM c1
      c1 caddc co caddc co wceq cM zcn cM cc wcel c1 cc wcel c1 cc wcel cM c1
      caddc co c1 caddc co cM c1 c1 caddc co caddc co wceq ax1cn ax1cn cM c1 c1
      addass mp3an23 syl c2 c1 c1 caddc co cM caddc df-2 opreq2i syl6eqr
      opreq2d sumeq1d cM cz wcel cM cM c1 caddc co cfz co cA vk csu vk cM cA
      csb vk cM c1 caddc co cA csb caddc co vk cM c1 caddc co c1 caddc co cA
      csb vk cM c2 caddc co cA csb caddc cA vk cM fsum2.1 fsum2 cM cz wcel vk
      cM c1 caddc co c1 caddc co cM c2 caddc co cA cM cz wcel cM c1 caddc co c1
      caddc co cM c1 c1 caddc co caddc co cM c2 caddc co cM cz wcel cM cc wcel
      cM c1 caddc co c1 caddc co cM c1 c1 caddc co caddc co wceq cM zcn cM cc
      wcel c1 cc wcel c1 cc wcel cM c1 caddc co c1 caddc co cM c1 c1 caddc co
      caddc co wceq ax1cn ax1cn cM c1 c1 addass mp3an23 syl c2 c1 c1 caddc co
      cM caddc df-2 opreq2i syl6eqr csbeq1d opreq12d 3eqtr3d $.
      $( [7-Feb-2007] $) $( [31-Jan-2007] $)

    $( The sum of four terms. $)
    fsum4 $p |- ( M e. ZZ -> sum_ k e. ( M ... ( M + 3 ) ) A =
                ( ( ( [_ M / k ]_ A + [_ ( M + 1 ) / k ]_ A )
                  + [_ ( M + 2 ) / k ]_ A ) + [_ ( M + 3 ) / k ]_ A ) ) $=
      cM cz wcel cM cM c2 caddc co c1 caddc co cfz co cA vk csu cM cM c2 caddc
      co cfz co cA vk csu vk cM c2 caddc co c1 caddc co cA csb caddc co cM cM
      c3 caddc co cfz co cA vk csu vk cM cA csb vk cM c1 caddc co cA csb caddc
      co vk cM c2 caddc co cA csb caddc co vk cM c3 caddc co cA csb caddc co cM
      cz wcel cM cM cuz cfv wcel cM c2 caddc co cM cuz cfv wcel cM cM c2 caddc
      co c1 caddc co cfz co cA vk csu cM cM c2 caddc co cfz co cA vk csu vk cM
      c2 caddc co c1 caddc co cA csb caddc co wceq cM uzid cM cM cuz cfv wcel
      c2 cn0 wcel cM c2 caddc co cM cuz cfv wcel 2nn0 c2 cM cM uzaddcl mpan2 cA
      vk cM cM c2 caddc co fsum2.1 fsump1slem 3syl cM cz wcel cM cM c2 caddc co
      c1 caddc co cfz co cM cM c3 caddc co cfz co cA vk cM cz wcel cM c2 caddc
      co c1 caddc co cM c3 caddc co cM cfz cM cz wcel cM c2 caddc co c1 caddc
      co cM c2 c1 caddc co caddc co cM c3 caddc co cM cz wcel cM cc wcel cM c2
      caddc co c1 caddc co cM c2 c1 caddc co caddc co wceq cM zcn cM cc wcel c2
      cc wcel c1 cc wcel cM c2 caddc co c1 caddc co cM c2 c1 caddc co caddc co
      wceq 2cn ax1cn cM c2 c1 addass mp3an23 syl c3 c2 c1 caddc co cM caddc
      df-3 opreq2i syl6eqr opreq2d sumeq1d cM cz wcel cM cM c2 caddc co cfz co
      cA vk csu vk cM cA csb vk cM c1 caddc co cA csb caddc co vk cM c2 caddc
      co cA csb caddc co vk cM c2 caddc co c1 caddc co cA csb vk cM c3 caddc co
      cA csb caddc cA vk cM fsum2.1 fsum3 cM cz wcel vk cM c2 caddc co c1 caddc
      co cM c3 caddc co cA cM cz wcel cM c2 caddc co c1 caddc co cM c2 c1 caddc
      co caddc co cM c3 caddc co cM cz wcel cM cc wcel cM c2 caddc co c1 caddc
      co cM c2 c1 caddc co caddc co wceq cM zcn cM cc wcel c2 cc wcel c1 cc
      wcel cM c2 caddc co c1 caddc co cM c2 c1 caddc co caddc co wceq 2cn ax1cn
      cM c2 c1 addass mp3an23 syl c3 c2 c1 caddc co cM caddc df-3 opreq2i
      syl6eqr csbeq1d opreq12d 3eqtr3d $.
      $( [9-Feb-2007] $) $( [31-Jan-2007] $)
  $}

  ${
    $d x k m n A $.  $d m n B $.  $d x k m n M $.  $d x n N $.
    csbfsumlem.1 $e |- A e. _V $.
    csbfsumlem.2 $e |- B e. _V $.
    $( Lemma for ~ csbfsum . $)
    csbfsumlem $p |- ( N e. ( ZZ>= ` M ) -> [_ A / x ]_ sum_ k e. ( M ... N ) B
           = sum_ k e. ( M ... N ) [_ A / x ]_ B ) $=
      vx cA cM vn cv cfz co cB vk csu csb cM vn cv cfz co vx cA cB csb vk csu
      wceq vx cA cM cM cfz co cB vk csu csb cM cM cfz co vx cA cB csb vk csu
      wceq vx cA cM vm cv cfz co cB vk csu csb cM vm cv cfz co vx cA cB csb vk
      csu wceq vx cA cM vm cv c1 caddc co cfz co cB vk csu csb cM vm cv c1
      caddc co cfz co vx cA cB csb vk csu wceq vx cA cM cN cfz co cB vk csu csb
      cM cN cfz co vx cA cB csb vk csu wceq vn vm cM cN vn cv cM wceq vx cA cM
      vn cv cfz co cB vk csu csb vx cA cM cM cfz co cB vk csu csb cM vn cv cfz
      co vx cA cB csb vk csu cM cM cfz co vx cA cB csb vk csu vn cv cM wceq cA
      cvv wcel vx cA cM vn cv cfz co cB vk csu csb vx cA cM cM cfz co cB vk csu
      csb wceq csbfsumlem.1 vn cv cM wceq vx cA cM vn cv cfz co cB vk csu cM cM
      cfz co cB vk csu cvv vn cv cM wceq cM vn cv cfz co cM cM cfz co cB vk vn
      cv cM cM cfz opreq2 sumeq1d csbeq2dv mpan2 vn cv cM wceq cM vn cv cfz co
      cM cM cfz co vx cA cB csb vk vn cv cM cM cfz opreq2 sumeq1d eqeq12d vn cv
      vm cv wceq vx cA cM vn cv cfz co cB vk csu csb vx cA cM vm cv cfz co cB
      vk csu csb cM vn cv cfz co vx cA cB csb vk csu cM vm cv cfz co vx cA cB
      csb vk csu vn cv vm cv wceq cA cvv wcel vx cA cM vn cv cfz co cB vk csu
      csb vx cA cM vm cv cfz co cB vk csu csb wceq csbfsumlem.1 vn cv vm cv
      wceq vx cA cM vn cv cfz co cB vk csu cM vm cv cfz co cB vk csu cvv vn cv
      vm cv wceq cM vn cv cfz co cM vm cv cfz co cB vk vn cv vm cv cM cfz
      opreq2 sumeq1d csbeq2dv mpan2 vn cv vm cv wceq cM vn cv cfz co cM vm cv
      cfz co vx cA cB csb vk vn cv vm cv cM cfz opreq2 sumeq1d eqeq12d vn cv vm
      cv c1 caddc co wceq vx cA cM vn cv cfz co cB vk csu csb vx cA cM vm cv c1
      caddc co cfz co cB vk csu csb cM vn cv cfz co vx cA cB csb vk csu cM vm
      cv c1 caddc co cfz co vx cA cB csb vk csu vn cv vm cv c1 caddc co wceq cA
      cvv wcel vx cA cM vn cv cfz co cB vk csu csb vx cA cM vm cv c1 caddc co
      cfz co cB vk csu csb wceq csbfsumlem.1 vn cv vm cv c1 caddc co wceq vx cA
      cM vn cv cfz co cB vk csu cM vm cv c1 caddc co cfz co cB vk csu cvv vn cv
      vm cv c1 caddc co wceq cM vn cv cfz co cM vm cv c1 caddc co cfz co cB vk
      vn cv vm cv c1 caddc co cM cfz opreq2 sumeq1d csbeq2dv mpan2 vn cv vm cv
      c1 caddc co wceq cM vn cv cfz co cM vm cv c1 caddc co cfz co vx cA cB csb
      vk vn cv vm cv c1 caddc co cM cfz opreq2 sumeq1d eqeq12d vn cv cN wceq vx
      cA cM vn cv cfz co cB vk csu csb vx cA cM cN cfz co cB vk csu csb cM vn
      cv cfz co vx cA cB csb vk csu cM cN cfz co vx cA cB csb vk csu vn cv cN
      wceq cA cvv wcel vx cA cM vn cv cfz co cB vk csu csb vx cA cM cN cfz co
      cB vk csu csb wceq csbfsumlem.1 vn cv cN wceq vx cA cM vn cv cfz co cB vk
      csu cM cN cfz co cB vk csu cvv vn cv cN wceq cM vn cv cfz co cM cN cfz co
      cB vk vn cv cN cM cfz opreq2 sumeq1d csbeq2dv mpan2 vn cv cN wceq cM vn
      cv cfz co cM cN cfz co vx cA cB csb vk vn cv cN cM cfz opreq2 sumeq1d
      eqeq12d cM cz wcel vx cA vk cM cB csb csb vk cM vx cA cB csb csb vx cA cM
      cM cfz co cB vk csu csb cM cM cfz co vx cA cB csb vk csu cA cvv wcel cM
      cz wcel vx cA vk cM cB csb csb vk cM vx cA cB csb csb wceq csbfsumlem.1
      vx vk cA cM cB cvv cz csbcomg mpan cM cz wcel cA cvv wcel vx cA cM cM cfz
      co cB vk csu csb vx cA vk cM cB csb csb wceq csbfsumlem.1 cM cz wcel vx
      cA cM cM cfz co cB vk csu vk cM cB csb cvv cB vk cM csbfsumlem.2
      fsum1slem csbeq2dv mpan2 vx cA cB csb vk cM vx cA cB csbfsumlem.1
      csbfsumlem.2 csbex fsum1slem 3eqtr4d vm cv cM cuz cfv wcel vx cA cM vm cv
      cfz co cB vk csu csb cM vm cv cfz co vx cA cB csb vk csu wceq vx cA cM vm
      cv c1 caddc co cfz co cB vk csu csb cM vm cv c1 caddc co cfz co vx cA cB
      csb vk csu wceq vm cv cM cuz cfv wcel vx cA cM vm cv cfz co cB vk csu csb
      cM vm cv cfz co vx cA cB csb vk csu wceq wa vx cA cM vm cv cfz co cB vk
      csu csb vk vm cv c1 caddc co vx cA cB csb csb caddc co cM vm cv cfz co vx
      cA cB csb vk csu vk vm cv c1 caddc co vx cA cB csb csb caddc co vx cA cM
      vm cv c1 caddc co cfz co cB vk csu csb cM vm cv c1 caddc co cfz co vx cA
      cB csb vk csu vm cv cM cuz cfv wcel vx cA cM vm cv cfz co cB vk csu csb
      cM vm cv cfz co vx cA cB csb vk csu wceq wa vx cA cM vm cv cfz co cB vk
      csu csb cM vm cv cfz co vx cA cB csb vk csu vk vm cv c1 caddc co vx cA cB
      csb csb caddc vm cv cM cuz cfv wcel vx cA cM vm cv cfz co cB vk csu csb
      cM vm cv cfz co vx cA cB csb vk csu wceq pm3.27 opreq1d vm cv cM cuz cfv
      wcel vx cA cM vm cv c1 caddc co cfz co cB vk csu csb vx cA cM vm cv cfz
      co cB vk csu csb vk vm cv c1 caddc co vx cA cB csb csb caddc co wceq vx
      cA cM vm cv cfz co cB vk csu csb cM vm cv cfz co vx cA cB csb vk csu wceq
      vm cv cM cuz cfv wcel vx cA cM vm cv c1 caddc co cfz co cB vk csu csb vx
      cA cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cB csb caddc co csb vx
      cA cM vm cv cfz co cB vk csu csb vk vm cv c1 caddc co vx cA cB csb csb
      caddc co vm cv cM cuz cfv wcel cA cvv wcel vx cA cM vm cv c1 caddc co cfz
      co cB vk csu csb vx cA cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cB
      csb caddc co csb wceq csbfsumlem.1 vm cv cM cuz cfv wcel vx cA cM vm cv
      c1 caddc co cfz co cB vk csu cM vm cv cfz co cB vk csu vk vm cv c1 caddc
      co cB csb caddc co cvv cB vk cM vm cv csbfsumlem.2 fsump1slem csbeq2dv
      mpan2 vx cA cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cB csb caddc
      co csb vx cA cM vm cv cfz co cB vk csu csb vx cA vk vm cv c1 caddc co cB
      csb csb caddc co vx cA cM vm cv cfz co cB vk csu csb vk vm cv c1 caddc co
      vx cA cB csb csb caddc co cA cvv wcel vx cA cM vm cv cfz co cB vk csu vk
      vm cv c1 caddc co cB csb caddc co csb vx cA cM vm cv cfz co cB vk csu csb
      vx cA vk vm cv c1 caddc co cB csb csb caddc co wceq csbfsumlem.1 vx cA cM
      vm cv cfz co cB vk csu vk vm cv c1 caddc co cB csb cvv caddc csbopr12g
      ax-mp vx cA vk vm cv c1 caddc co cB csb csb vk vm cv c1 caddc co vx cA cB
      csb csb vx cA cM vm cv cfz co cB vk csu csb caddc cA cvv wcel vm cv c1
      caddc co cvv wcel vx cA vk vm cv c1 caddc co cB csb csb vk vm cv c1 caddc
      co vx cA cB csb csb wceq csbfsumlem.1 vm cv c1 caddc oprex vx vk cA vm cv
      c1 caddc co cB cvv cvv csbcomg mp2an opreq2i eqtri syl6eq adantr vm cv cM
      cuz cfv wcel cM vm cv c1 caddc co cfz co vx cA cB csb vk csu cM vm cv cfz
      co vx cA cB csb vk csu vk vm cv c1 caddc co vx cA cB csb csb caddc co
      wceq vx cA cM vm cv cfz co cB vk csu csb cM vm cv cfz co vx cA cB csb vk
      csu wceq vx cA cB csb vk cM vm cv vx cA cB csbfsumlem.1 csbfsumlem.2
      csbex fsump1slem adantr 3eqtr4d ex uzind4 $.
      $( [22-Feb-2006] $) $( [14-Nov-2005] $)
  $}

  ${
    $d k y A $.  $d y B $.  $d x k y M $.  $d x k y N $.
    $( Distribute substitution for classes over a finite sum. $)
    csbfsum $p |- ( ( A e. C /\ N e. ( ZZ>= ` M ) /\
           A. k e. ( M ... N ) [_ A / x ]_ B e. CC ) ->
             [_ A / x ]_ sum_ k e. ( M ... N ) B
                  = sum_ k e. ( M ... N ) [_ A / x ]_ B ) $=
      cA cC wcel cN cM cuz cfv wcel vx cA cB csb cc wcel vk cM cN cfz co wral
      vx cA cM cN cfz co cB vk csu csb cM cN cfz co vx cA cB csb vk csu wceq cN
      cM cuz cfv wcel vx vy cv cB csb cc wcel vk cM cN cfz co wral wa vx vy cv
      cM cN cfz co cB vk csu csb cM cN cfz co vx vy cv cB csb vk csu wceq wi cN
      cM cuz cfv wcel vx cA cB csb cc wcel vk cM cN cfz co wral wa vx cA cM cN
      cfz co cB vk csu csb cM cN cfz co vx cA cB csb vk csu wceq wi vy cA cC vy
      cv cA wceq cN cM cuz cfv wcel vx vy cv cB csb cc wcel vk cM cN cfz co
      wral wa cN cM cuz cfv wcel vx cA cB csb cc wcel vk cM cN cfz co wral wa
      vx vy cv cM cN cfz co cB vk csu csb cM cN cfz co vx vy cv cB csb vk csu
      wceq vx cA cM cN cfz co cB vk csu csb cM cN cfz co vx cA cB csb vk csu
      wceq vy cv cA wceq vx vy cv cB csb cc wcel vk cM cN cfz co wral vx cA cB
      csb cc wcel vk cM cN cfz co wral cN cM cuz cfv wcel vy cv cA wceq vx vy
      cv cB csb cc wcel vx cA cB csb cc wcel vk cM cN cfz co vy cv cA wceq vx
      vy cv cB csb vx cA cB csb cc vx vy cv cA cB csbeq1 eleq1d ralbidv anbi2d
      vy cv cA wceq vx vy cv cM cN cfz co cB vk csu csb vx cA cM cN cfz co cB
      vk csu csb cM cN cfz co vx vy cv cB csb vk csu cM cN cfz co vx cA cB csb
      vk csu vx vy cv cA cM cN cfz co cB vk csu csbeq1 vy cv cA wceq cM cN cfz
      co vx vy cv cB csb vx cA cB csb vk vx vy cv cA cB csbeq1 sumeq2sdv
      eqeq12d imbi12d cN cM cuz cfv wcel vx vy cv cB csb cc wcel vk cM cN cfz
      co wral wa vx vy cv cM cN cfz co cB cc0 caddc co vk csu csb cM cN cfz co
      vx vy cv cB cc0 caddc co csb vk csu vx vy cv cM cN cfz co cB vk csu csb
      cM cN cfz co vx vy cv cB csb vk csu cN cM cuz cfv wcel vx vy cv cM cN cfz
      co cB cc0 caddc co vk csu csb cM cN cfz co vx vy cv cB cc0 caddc co csb
      vk csu wceq vx vy cv cB csb cc wcel vk cM cN cfz co wral vx vy cv cB cc0
      caddc co vk cM cN vy visset cB cc0 caddc oprex csbfsumlem adantr vx vy cv
      cB csb cc wcel vk cM cN cfz co wral vx vy cv cM cN cfz co cB cc0 caddc co
      vk csu csb vx vy cv cM cN cfz co cB vk csu csb wceq cN cM cuz cfv wcel cB
      cc wcel vk cM cN cfz co wral vx vy cv wsbc cM cN cfz co cB cc0 caddc co
      vk csu cM cN cfz co cB vk csu wceq vx vy cv wsbc vx vy cv cB csb cc wcel
      vk cM cN cfz co wral vx vy cv cM cN cfz co cB cc0 caddc co vk csu csb vx
      vy cv cM cN cfz co cB vk csu csb wceq cB cc wcel vk cM cN cfz co wral cM
      cN cfz co cB cc0 caddc co vk csu cM cN cfz co cB vk csu wceq vx vy cB cc
      wcel vk cM cN cfz co wral cM cN cfz co cB cc0 caddc co cB vk cB cc wcel
      cB cc0 caddc co cB wceq vk cM cN cfz co cB addid1 r19.20si sumeq2d sbimi
      cB cc wcel vk cM cN cfz co wral vx vy cv wsbc cB cc wcel vx vy cv wsbc vk
      cM cN cfz co wral vx vy cv cB csb cc wcel vk cM cN cfz co wral vy cv cvv
      wcel cB cc wcel vk cM cN cfz co wral vx vy cv wsbc cB cc wcel vx vy cv
      wsbc vk cM cN cfz co wral wb vy visset cB cc wcel vx vk vy cv cM cN cfz
      co cvv sbcralg ax-mp cB cc wcel vx vy cv wsbc vx vy cv cB csb cc wcel vk
      cM cN cfz co vy cv cvv wcel cB cc wcel vx vy cv wsbc vx vy cv cB csb cc
      wcel wb vy visset vx vy cv cB cc cvv sbcel1g ax-mp ralbii bitri vy cv cvv
      wcel cM cN cfz co cB cc0 caddc co vk csu cM cN cfz co cB vk csu wceq vx
      vy cv wsbc vx vy cv cM cN cfz co cB cc0 caddc co vk csu csb vx vy cv cM
      cN cfz co cB vk csu csb wceq wb vy visset vx vy cv cM cN cfz co cB cc0
      caddc co vk csu cM cN cfz co cB vk csu cvv sbceqdig ax-mp 3imtr3i adantl
      vx vy cv cB csb cc wcel vk cM cN cfz co wral cM cN cfz co vx vy cv cB cc0
      caddc co csb vk csu cM cN cfz co vx vy cv cB csb vk csu wceq cN cM cuz
      cfv wcel vx vy cv cB csb cc wcel vk cM cN cfz co wral cM cN cfz co vx vy
      cv cB cc0 caddc co csb vx vy cv cB csb vk vx vy cv cB csb cc wcel vx vy
      cv cB cc0 caddc co csb vx vy cv cB csb wceq vk cM cN cfz co vx vy cv cB
      csb cc wcel vx vy cv cB csb cc0 caddc co vx vy cv cB csb vx vy cv cB cc0
      caddc co csb vx vy cv cB csb addid1 vy cv cvv wcel vx vy cv cB cc0 caddc
      co csb vx vy cv cB csb cc0 caddc co wceq vy visset vx vy cv cB cc0 cvv
      caddc csbopr1g ax-mp syl5eq r19.20si sumeq2d adantl 3eqtr3d vtoclg 3impib
      $.
      $( [22-Feb-2006] $) $( [15-Nov-2005] $)
  $}

  ${
    $d k n A $.  $d j k m n J $.  $d j k m K $.  $d j k m n M $.
    $d j k m n N $.
    $( Interchange order of summation.  _Warning:  The HTML proof page is 0.6MB
       in size_. $)
    fsumcom $p |- ( ( K e. ( ZZ>= ` J ) /\ N e. ( ZZ>= ` M ) /\
           A. j e. ( J ... K ) A. m e. ( M ... N ) A e. CC ) ->
              sum_ j e. ( J ... K ) sum_ m e. ( M ... N ) A =
              sum_ m e. ( M ... N ) sum_ j e. ( J ... K ) A ) $=
      cK cJ cuz cfv wcel cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj
      cJ cK cfz co wral cJ cK cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co
      cJ cK cfz co cA vj csu vm csu wceq cN cM cuz cfv wcel cA cc wcel vm cM cN
      cfz co wral vj cJ vk cv cfz co wral wa cJ vk cv cfz co cM cN cfz co cA vm
      csu vj csu cM cN cfz co cJ vk cv cfz co cA vj csu vm csu wceq wi cN cM
      cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ cJ cfz co wral wa cJ
      cJ cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ cJ cfz co cA vj
      csu vm csu wceq wi cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj
      cJ vn cv cfz co wral wa cJ vn cv cfz co cM cN cfz co cA vm csu vj csu cM
      cN cfz co cJ vn cv cfz co cA vj csu vm csu wceq wi cN cM cuz cfv wcel cA
      cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral wa cJ vn
      cv c1 caddc co cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv
      c1 caddc co cfz co cA vj csu vm csu wceq wi cN cM cuz cfv wcel cA cc wcel
      vm cM cN cfz co wral vj cJ cK cfz co wral wa cJ cK cfz co cM cN cfz co cA
      vm csu vj csu cM cN cfz co cJ cK cfz co cA vj csu vm csu wceq wi vk vn cJ
      cK vk cv cJ wceq cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ
      vk cv cfz co wral wa cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral
      vj cJ cJ cfz co wral wa cJ vk cv cfz co cM cN cfz co cA vm csu vj csu cM
      cN cfz co cJ vk cv cfz co cA vj csu vm csu wceq cJ cJ cfz co cM cN cfz co
      cA vm csu vj csu cM cN cfz co cJ cJ cfz co cA vj csu vm csu wceq vk cv cJ
      wceq cA cc wcel vm cM cN cfz co wral vj cJ vk cv cfz co wral cA cc wcel
      vm cM cN cfz co wral vj cJ cJ cfz co wral cN cM cuz cfv wcel vk cv cJ
      wceq cA cc wcel vm cM cN cfz co wral vj cJ vk cv cfz co cJ cJ cfz co vk
      cv cJ cJ cfz opreq2 raleq1d anbi2d vk cv cJ wceq cJ vk cv cfz co cM cN
      cfz co cA vm csu vj csu cJ cJ cfz co cM cN cfz co cA vm csu vj csu cM cN
      cfz co cJ vk cv cfz co cA vj csu vm csu cM cN cfz co cJ cJ cfz co cA vj
      csu vm csu vk cv cJ wceq cJ vk cv cfz co cJ cJ cfz co cM cN cfz co cA vm
      csu vj vk cv cJ cJ cfz opreq2 sumeq1d vk cv cJ wceq cM cN cfz co cJ vk cv
      cfz co cA vj csu cJ cJ cfz co cA vj csu vm vk cv cJ wceq cJ vk cv cfz co
      cJ cJ cfz co cA vj vk cv cJ cJ cfz opreq2 sumeq1d sumeq2sdv eqeq12d
      imbi12d vk cv vn cv wceq cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co
      wral vj cJ vk cv cfz co wral wa cN cM cuz cfv wcel cA cc wcel vm cM cN
      cfz co wral vj cJ vn cv cfz co wral wa cJ vk cv cfz co cM cN cfz co cA vm
      csu vj csu cM cN cfz co cJ vk cv cfz co cA vj csu vm csu wceq cJ vn cv
      cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv cfz co cA vj
      csu vm csu wceq vk cv vn cv wceq cA cc wcel vm cM cN cfz co wral vj cJ vk
      cv cfz co wral cA cc wcel vm cM cN cfz co wral vj cJ vn cv cfz co wral cN
      cM cuz cfv wcel vk cv vn cv wceq cA cc wcel vm cM cN cfz co wral vj cJ vk
      cv cfz co cJ vn cv cfz co vk cv vn cv cJ cfz opreq2 raleq1d anbi2d vk cv
      vn cv wceq cJ vk cv cfz co cM cN cfz co cA vm csu vj csu cJ vn cv cfz co
      cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vk cv cfz co cA vj csu vm
      csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu vk cv vn cv wceq cJ vk
      cv cfz co cJ vn cv cfz co cM cN cfz co cA vm csu vj vk cv vn cv cJ cfz
      opreq2 sumeq1d vk cv vn cv wceq cM cN cfz co cJ vk cv cfz co cA vj csu cJ
      vn cv cfz co cA vj csu vm vk cv vn cv wceq cJ vk cv cfz co cJ vn cv cfz
      co cA vj vk cv vn cv cJ cfz opreq2 sumeq1d sumeq2sdv eqeq12d imbi12d vk
      cv vn cv c1 caddc co wceq cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co
      wral vj cJ vk cv cfz co wral wa cN cM cuz cfv wcel cA cc wcel vm cM cN
      cfz co wral vj cJ vn cv c1 caddc co cfz co wral wa cJ vk cv cfz co cM cN
      cfz co cA vm csu vj csu cM cN cfz co cJ vk cv cfz co cA vj csu vm csu
      wceq cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm csu vj csu cM cN cfz
      co cJ vn cv c1 caddc co cfz co cA vj csu vm csu wceq vk cv vn cv c1 caddc
      co wceq cA cc wcel vm cM cN cfz co wral vj cJ vk cv cfz co wral cA cc
      wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral cN cM cuz
      cfv wcel vk cv vn cv c1 caddc co wceq cA cc wcel vm cM cN cfz co wral vj
      cJ vk cv cfz co cJ vn cv c1 caddc co cfz co vk cv vn cv c1 caddc co cJ
      cfz opreq2 raleq1d anbi2d vk cv vn cv c1 caddc co wceq cJ vk cv cfz co cM
      cN cfz co cA vm csu vj csu cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm
      csu vj csu cM cN cfz co cJ vk cv cfz co cA vj csu vm csu cM cN cfz co cJ
      vn cv c1 caddc co cfz co cA vj csu vm csu vk cv vn cv c1 caddc co wceq cJ
      vk cv cfz co cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm csu vj vk cv
      vn cv c1 caddc co cJ cfz opreq2 sumeq1d vk cv vn cv c1 caddc co wceq cM
      cN cfz co cJ vk cv cfz co cA vj csu cJ vn cv c1 caddc co cfz co cA vj csu
      vm vk cv vn cv c1 caddc co wceq cJ vk cv cfz co cJ vn cv c1 caddc co cfz
      co cA vj vk cv vn cv c1 caddc co cJ cfz opreq2 sumeq1d sumeq2sdv eqeq12d
      imbi12d vk cv cK wceq cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral
      vj cJ vk cv cfz co wral wa cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co
      wral vj cJ cK cfz co wral wa cJ vk cv cfz co cM cN cfz co cA vm csu vj
      csu cM cN cfz co cJ vk cv cfz co cA vj csu vm csu wceq cJ cK cfz co cM cN
      cfz co cA vm csu vj csu cM cN cfz co cJ cK cfz co cA vj csu vm csu wceq
      vk cv cK wceq cA cc wcel vm cM cN cfz co wral vj cJ vk cv cfz co wral cA
      cc wcel vm cM cN cfz co wral vj cJ cK cfz co wral cN cM cuz cfv wcel vk
      cv cK wceq cA cc wcel vm cM cN cfz co wral vj cJ vk cv cfz co cJ cK cfz
      co vk cv cK cJ cfz opreq2 raleq1d anbi2d vk cv cK wceq cJ vk cv cfz co cM
      cN cfz co cA vm csu vj csu cJ cK cfz co cM cN cfz co cA vm csu vj csu cM
      cN cfz co cJ vk cv cfz co cA vj csu vm csu cM cN cfz co cJ cK cfz co cA
      vj csu vm csu vk cv cK wceq cJ vk cv cfz co cJ cK cfz co cM cN cfz co cA
      vm csu vj vk cv cK cJ cfz opreq2 sumeq1d vk cv cK wceq cM cN cfz co cJ vk
      cv cfz co cA vj csu cJ cK cfz co cA vj csu vm vk cv cK wceq cJ vk cv cfz
      co cJ cK cfz co cA vj vk cv cK cJ cfz opreq2 sumeq1d sumeq2sdv eqeq12d
      imbi12d cJ cz wcel cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj
      cJ cJ cfz co wral wa cJ cJ cfz co cM cN cfz co cA vm csu vj csu cM cN cfz
      co cJ cJ cfz co cA vj csu vm csu wceq cJ cz wcel cN cM cuz cfv wcel cA cc
      wcel vm cM cN cfz co wral vj cJ cJ cfz co wral wa wa vj cJ cM cN cfz co
      cA vm csu csb cM cN cfz co vj cJ cA csb vm csu cJ cJ cfz co cM cN cfz co
      cA vm csu vj csu cM cN cfz co cJ cJ cfz co cA vj csu vm csu cJ cz wcel cN
      cM cuz cfv wcel vj cJ cA csb cc wcel vm cM cN cfz co wral vj cJ cM cN cfz
      co cA vm csu csb cM cN cfz co vj cJ cA csb vm csu wceq cJ cz wcel cN cM
      cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ cJ cfz co wral wa wa
      vj cJ cA cz vm cM cN csbfsum cJ cz wcel cN cM cuz cfv wcel cA cc wcel vm
      cM cN cfz co wral vj cJ cJ cfz co wral wa pm3.26 cJ cz wcel cN cM cuz cfv
      wcel cA cc wcel vm cM cN cfz co wral vj cJ cJ cfz co wral simprl cJ cz
      wcel cA cc wcel vm cM cN cfz co wral vj cJ cJ cfz co wral vj cJ cA csb cc
      wcel vm cM cN cfz co wral cN cM cuz cfv wcel cJ cz wcel cA cc wcel vj cJ
      cJ cfz co wral vm cM cN cfz co wral vj cJ cA csb cc wcel vm cM cN cfz co
      wral cA cc wcel vm cM cN cfz co wral vj cJ cJ cfz co wral cJ cz wcel cA
      cc wcel vj cJ cJ cfz co wral vm cM cN cfz co wral vj cJ cA csb cc wcel vm
      cM cN cfz co wral cJ cz wcel cA cc wcel vj cJ cJ cfz co wral vj cJ cA csb
      cc wcel vm cM cN cfz co cJ cz wcel cA cc wcel vj cJ cJ cfz co wral vj cJ
      cA csb cc wcel cJ cJ cJ cfz co wcel cA cc wcel vj cJ cJ cfz co wral vj cJ
      cA csb cc wcel cJ cz wcel vj cJ cJ cJ cfz co cA cc ra4csbela cJ elfz3
      sylan ex r19.20sdv imp cA cc wcel vj vm cJ cJ cfz co cM cN cfz co ralcom
      sylan2b adantrl syl3anc cJ cz wcel cM cN cfz co cA vm csu cc wcel vj cJ
      cJ cfz co wral cJ cJ cfz co cM cN cfz co cA vm csu vj csu vj cJ cM cN cfz
      co cA vm csu csb wceq cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral
      vj cJ cJ cfz co wral wa cM cN cfz co cA vm csu cc vj cJ fsum1s cN cM cuz
      cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ cJ cfz co wral cM cN cfz
      co cA vm csu cc wcel vj cJ cJ cfz co wral cN cM cuz cfv wcel cA cc wcel
      vm cM cN cfz co wral cM cN cfz co cA vm csu cc wcel vj cJ cJ cfz co cN cM
      cuz cfv wcel cA cc wcel vm cM cN cfz co wral cM cN cfz co cA vm csu cc
      wcel cA vm cM cN fsumcl ex r19.20sdv imp sylan2 cJ cz wcel cA cc wcel vm
      cM cN cfz co wral vj cJ cJ cfz co wral cM cN cfz co cJ cJ cfz co cA vj
      csu vm csu cM cN cfz co vj cJ cA csb vm csu wceq cN cM cuz cfv wcel cJ cz
      wcel cA cc wcel vj cJ cJ cfz co wral vm cM cN cfz co wral cM cN cfz co cJ
      cJ cfz co cA vj csu vm csu cM cN cfz co vj cJ cA csb vm csu wceq cA cc
      wcel vm cM cN cfz co wral vj cJ cJ cfz co wral cJ cz wcel cA cc wcel vj
      cJ cJ cfz co wral vm cM cN cfz co wral wa cM cN cfz co cJ cJ cfz co cA vj
      csu vj cJ cA csb vm cJ cz wcel cA cc wcel vj cJ cJ cfz co wral vm cM cN
      cfz co wral cJ cJ cfz co cA vj csu vj cJ cA csb wceq vm cM cN cfz co wral
      cJ cz wcel cA cc wcel vj cJ cJ cfz co wral cJ cJ cfz co cA vj csu vj cJ
      cA csb wceq vm cM cN cfz co cJ cz wcel cA cc wcel vj cJ cJ cfz co wral cJ
      cJ cfz co cA vj csu vj cJ cA csb wceq cA cc vj cJ fsum1s ex r19.20sdv imp
      sumeq2d cA cc wcel vj vm cJ cJ cfz co cM cN cfz co ralcom sylan2b adantrl
      3eqtr4d ex vn cv cJ cuz cfv wcel cN cM cuz cfv wcel cA cc wcel vm cM cN
      cfz co wral vj cJ vn cv cfz co wral wa cJ vn cv cfz co cM cN cfz co cA vm
      csu vj csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu wceq wi cN cM
      cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz
      co wral wa cJ vn cv cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ
      vn cv cfz co cA vj csu vm csu wceq wi cN cM cuz cfv wcel cA cc wcel vm cM
      cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral wa cJ vn cv c1 caddc
      co cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv c1 caddc co
      cfz co cA vj csu vm csu wceq wi vn cv cJ cuz cfv wcel cN cM cuz cfv wcel
      cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral wa cN
      cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ vn cv cfz co wral
      wa cJ vn cv cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv
      cfz co cA vj csu vm csu wceq vn cv cJ cuz cfv wcel cA cc wcel vm cM cN
      cfz co wral vj cJ vn cv c1 caddc co cfz co wral cA cc wcel vm cM cN cfz
      co wral vj cJ vn cv cfz co wral cN cM cuz cfv wcel vn cv cJ cuz cfv wcel
      cA cc wcel vm cM cN cfz co wral cA cc wcel vm cM cN cfz co wral vj cJ vn
      cv c1 caddc co cfz co cJ vn cv cfz co vn cv cJ cuz cfv wcel vj cv cJ vn
      cv cfz co wcel vj cv cJ vn cv c1 caddc co cfz co wcel cA cc wcel vm cM cN
      cfz co wral vn cv cJ cuz cfv wcel cJ vn cv cfz co cJ vn cv c1 caddc co
      cfz co vj cv cJ cz wcel vn cv cz wcel cJ vn cv cfz co cJ vn cv c1 caddc
      co cfz co wss vn cv cJ cuz cfv wcel cJ vn cv fzssp1 cJ vn cv eluzel2 cJ
      vn cv eluzelz sylanc sseld imim1d r19.20dv2 anim2d imim1d vn cv cJ cuz
      cfv wcel cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ vn cv
      c1 caddc co cfz co wral wa cJ vn cv cfz co cM cN cfz co cA vm csu vj csu
      cM cN cfz co cJ vn cv cfz co cA vj csu vm csu wceq cJ vn cv c1 caddc co
      cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv c1 caddc co
      cfz co cA vj csu vm csu wceq vn cv cJ cuz cfv wcel cN cM cuz cfv wcel cA
      cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral cJ vn cv
      cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv cfz co cA vj
      csu vm csu wceq cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm csu vj csu
      cM cN cfz co cJ vn cv c1 caddc co cfz co cA vj csu vm csu wceq wi vn cv
      cJ cuz cfv wcel cN cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ
      vn cv c1 caddc co cfz co wral cJ vn cv cfz co cM cN cfz co cA vm csu vj
      csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu wceq cJ vn cv c1 caddc
      co cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv c1 caddc co
      cfz co cA vj csu vm csu wceq vn cv cJ cuz cfv wcel cN cM cuz cfv wcel wa
      cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral cJ vn
      cv cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ vn cv cfz co cA
      vj csu vm csu wceq wa wa cJ vn cv cfz co cM cN cfz co cA vm csu vj csu vj
      vn cv c1 caddc co cM cN cfz co cA vm csu csb caddc co cM cN cfz co cJ vn
      cv cfz co cA vj csu vm csu cM cN cfz co vj vn cv c1 caddc co cA csb vm
      csu caddc co cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm csu vj csu cM
      cN cfz co cJ vn cv c1 caddc co cfz co cA vj csu vm csu vn cv cJ cuz cfv
      wcel cN cM cuz cfv wcel wa cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1
      caddc co cfz co wral cJ vn cv cfz co cM cN cfz co cA vm csu vj csu cM cN
      cfz co cJ vn cv cfz co cA vj csu vm csu wceq cJ vn cv cfz co cM cN cfz co
      cA vm csu vj csu vj vn cv c1 caddc co cM cN cfz co cA vm csu csb caddc co
      cM cN cfz co cJ vn cv cfz co cA vj csu vm csu cM cN cfz co vj vn cv c1
      caddc co cA csb vm csu caddc co wceq cJ vn cv cfz co cM cN cfz co cA vm
      csu vj csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu wceq vn cv cJ
      cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vm cM cN cfz co wral vj cJ
      vn cv c1 caddc co cfz co wral wa cJ vn cv cfz co cM cN cfz co cA vm csu
      vj csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu vj vn cv c1 caddc co
      cM cN cfz co cA vm csu csb cM cN cfz co vj vn cv c1 caddc co cA csb vm
      csu caddc cJ vn cv cfz co cM cN cfz co cA vm csu vj csu cM cN cfz co cJ
      vn cv cfz co cA vj csu vm csu wceq id cN cM cuz cfv wcel vj vn cv c1
      caddc co cA csb cc wcel vm cM cN cfz co wral vj vn cv c1 caddc co cM cN
      cfz co cA vm csu csb cM cN cfz co vj vn cv c1 caddc co cA csb vm csu wceq
      vn cv cJ cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vm cM cN cfz co
      wral vj cJ vn cv c1 caddc co cfz co wral wa vn cv c1 caddc co cvv wcel cN
      cM cuz cfv wcel vj vn cv c1 caddc co cA csb cc wcel vm cM cN cfz co wral
      vj vn cv c1 caddc co cM cN cfz co cA vm csu csb cM cN cfz co vj vn cv c1
      caddc co cA csb vm csu wceq vn cv c1 caddc oprex vj vn cv c1 caddc co cA
      cvv vm cM cN csbfsum mp3an1 vn cv cJ cuz cfv wcel cN cM cuz cfv wcel cA
      cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral simplr
      vn cv cJ cuz cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1
      caddc co cfz co wral vj vn cv c1 caddc co cA csb cc wcel vm cM cN cfz co
      wral cN cM cuz cfv wcel vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1
      caddc co cfz co wral vm cM cN cfz co wral vj vn cv c1 caddc co cA csb cc
      wcel vm cM cN cfz co wral cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1
      caddc co cfz co wral vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1
      caddc co cfz co wral vm cM cN cfz co wral vj vn cv c1 caddc co cA csb cc
      wcel vm cM cN cfz co wral vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1
      caddc co cfz co wral vj vn cv c1 caddc co cA csb cc wcel vm cM cN cfz co
      vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral vj
      vn cv c1 caddc co cA csb cc wcel vn cv c1 caddc co cJ vn cv c1 caddc co
      cfz co wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral vj vn cv c1
      caddc co cA csb cc wcel vn cv cJ cuz cfv wcel vj vn cv c1 caddc co cJ vn
      cv c1 caddc co cfz co cA cc ra4csbela vn cv cJ cuz cfv wcel vn cv c1
      caddc co cJ cuz cfv wcel vn cv c1 caddc co cJ vn cv c1 caddc co cfz co
      wcel cJ vn cv peano2uz cJ vn cv c1 caddc co eluzfz2 syl sylan ex
      r19.20sdv imp cA cc wcel vj vm cJ vn cv c1 caddc co cfz co cM cN cfz co
      ralcom sylan2b adantlr sylanc opreqan12rd anasss vn cv cJ cuz cfv wcel cN
      cM cuz cfv wcel wa cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc
      co cfz co wral cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm csu vj csu
      cJ vn cv cfz co cM cN cfz co cA vm csu vj csu vj vn cv c1 caddc co cM cN
      cfz co cA vm csu csb caddc co wceq cJ vn cv cfz co cM cN cfz co cA vm csu
      vj csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu wceq vn cv cJ cuz
      cfv wcel cM cN cfz co cA vm csu cc wcel vj cJ vn cv c1 caddc co cfz co
      wral cJ vn cv c1 caddc co cfz co cM cN cfz co cA vm csu vj csu cJ vn cv
      cfz co cM cN cfz co cA vm csu vj csu vj vn cv c1 caddc co cM cN cfz co cA
      vm csu csb caddc co wceq vn cv cJ cuz cfv wcel cN cM cuz cfv wcel wa cA
      cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral wa cM cN
      cfz co cA vm csu cc vj cJ vn cv fsump1s vn cv cJ cuz cfv wcel cN cM cuz
      cfv wcel cA cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co
      wral simpll vn cv cJ cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vm cM
      cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral cM cN cfz co cA vm csu
      cc wcel vj cJ vn cv c1 caddc co cfz co wral vn cv cJ cuz cfv wcel cN cM
      cuz cfv wcel wa cA cc wcel vm cM cN cfz co wral cM cN cfz co cA vm csu cc
      wcel vj cJ vn cv c1 caddc co cfz co cN cM cuz cfv wcel cA cc wcel vm cM
      cN cfz co wral cM cN cfz co cA vm csu cc wcel wi vn cv cJ cuz cfv wcel cN
      cM cuz cfv wcel cA cc wcel vm cM cN cfz co wral cM cN cfz co cA vm csu cc
      wcel cA vm cM cN fsumcl ex adantl r19.20sdv imp sylanc adantrr vn cv cJ
      cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vm cM cN cfz co wral vj cJ
      vn cv c1 caddc co cfz co wral cM cN cfz co cJ vn cv c1 caddc co cfz co cA
      vj csu vm csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu cM cN cfz co
      vj vn cv c1 caddc co cA csb vm csu caddc co wceq cJ vn cv cfz co cM cN
      cfz co cA vm csu vj csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu
      wceq vn cv cJ cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vj cJ vn cv
      c1 caddc co cfz co wral vm cM cN cfz co wral cM cN cfz co cJ vn cv c1
      caddc co cfz co cA vj csu vm csu cM cN cfz co cJ vn cv cfz co cA vj csu
      vm csu cM cN cfz co vj vn cv c1 caddc co cA csb vm csu caddc co wceq cA
      cc wcel vm cM cN cfz co wral vj cJ vn cv c1 caddc co cfz co wral vn cv cJ
      cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vj cJ vn cv c1 caddc co cfz
      co wral vm cM cN cfz co wral wa cM cN cfz co cJ vn cv c1 caddc co cfz co
      cA vj csu vm csu cM cN cfz co cJ vn cv cfz co cA vj csu vj vn cv c1 caddc
      co cA csb caddc co vm csu cM cN cfz co cJ vn cv cfz co cA vj csu vm csu
      cM cN cfz co vj vn cv c1 caddc co cA csb vm csu caddc co vn cv cJ cuz cfv
      wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral vm cM cN cfz co wral
      cM cN cfz co cJ vn cv c1 caddc co cfz co cA vj csu vm csu cM cN cfz co cJ
      vn cv cfz co cA vj csu vj vn cv c1 caddc co cA csb caddc co vm csu wceq
      cN cM cuz cfv wcel vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc
      co cfz co wral vm cM cN cfz co wral wa cM cN cfz co cJ vn cv c1 caddc co
      cfz co cA vj csu cJ vn cv cfz co cA vj csu vj vn cv c1 caddc co cA csb
      caddc co vm vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz
      co wral vm cM cN cfz co wral cJ vn cv c1 caddc co cfz co cA vj csu cJ vn
      cv cfz co cA vj csu vj vn cv c1 caddc co cA csb caddc co wceq vm cM cN
      cfz co wral vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz
      co wral cJ vn cv c1 caddc co cfz co cA vj csu cJ vn cv cfz co cA vj csu
      vj vn cv c1 caddc co cA csb caddc co wceq vm cM cN cfz co vn cv cJ cuz
      cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral cJ vn cv c1 caddc
      co cfz co cA vj csu cJ vn cv cfz co cA vj csu vj vn cv c1 caddc co cA csb
      caddc co wceq cA cc vj cJ vn cv fsump1s ex r19.20sdv imp sumeq2d adantlr
      cN cM cuz cfv wcel cJ vn cv cfz co cA vj csu cc wcel vj vn cv c1 caddc co
      cA csb cc wcel wa vm cM cN cfz co wral cM cN cfz co cJ vn cv cfz co cA vj
      csu vj vn cv c1 caddc co cA csb caddc co vm csu cM cN cfz co cJ vn cv cfz
      co cA vj csu vm csu cM cN cfz co vj vn cv c1 caddc co cA csb vm csu caddc
      co wceq vn cv cJ cuz cfv wcel cN cM cuz cfv wcel wa cA cc wcel vj cJ vn
      cv c1 caddc co cfz co wral vm cM cN cfz co wral wa cJ vn cv cfz co cA vj
      csu vj vn cv c1 caddc co cA csb vm cM cN fsumadd vn cv cJ cuz cfv wcel cN
      cM cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral vm cM cN
      cfz co wral simplr vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc
      co cfz co wral vm cM cN cfz co wral cJ vn cv cfz co cA vj csu cc wcel vj
      vn cv c1 caddc co cA csb cc wcel wa vm cM cN cfz co wral cN cM cuz cfv
      wcel vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral
      vm cM cN cfz co wral cJ vn cv cfz co cA vj csu cc wcel vj vn cv c1 caddc
      co cA csb cc wcel wa vm cM cN cfz co wral vn cv cJ cuz cfv wcel cA cc
      wcel vj cJ vn cv c1 caddc co cfz co wral cJ vn cv cfz co cA vj csu cc
      wcel vj vn cv c1 caddc co cA csb cc wcel wa vm cM cN cfz co vn cv cJ cuz
      cfv wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral cJ vn cv cfz co
      cA vj csu cc wcel vj vn cv c1 caddc co cA csb cc wcel vn cv cJ cuz cfv
      wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co wral cA cc wcel vj cJ vn
      cv cfz co wral cJ vn cv cfz co cA vj csu cc wcel vn cv cJ cuz cfv wcel cA
      cc wcel cA cc wcel vj cJ vn cv c1 caddc co cfz co cJ vn cv cfz co vn cv
      cJ cuz cfv wcel vj cv cJ vn cv cfz co wcel vj cv cJ vn cv c1 caddc co cfz
      co wcel cA cc wcel vn cv cJ cuz cfv wcel cJ vn cv cfz co cJ vn cv c1
      caddc co cfz co vj cv cJ cz wcel vn cv cz wcel cJ vn cv cfz co cJ vn cv
      c1 caddc co cfz co wss vn cv cJ cuz cfv wcel cJ vn cv fzssp1 cJ vn cv
      eluzel2 cJ vn cv eluzelz sylanc sseld imim1d r19.20dv2 vn cv cJ cuz cfv
      wcel cA cc wcel vj cJ vn cv cfz co wral cJ vn cv cfz co cA vj csu cc wcel
      cA vj cJ vn cv fsumcl ex syld vn cv cJ cuz cfv wcel cA cc wcel vj cJ vn
      cv c1 caddc co cfz co wral vj vn cv c1 caddc co cA csb cc wcel vn cv c1
      caddc co cJ vn cv c1 caddc co cfz co wcel cA cc wcel vj cJ vn cv c1 caddc
      co cfz co wral vj vn cv c1 caddc co cA csb cc wcel vn cv cJ cuz cfv wcel
      vj vn cv c1 caddc co cJ vn cv c1 caddc co cfz co cA cc ra4csbela vn cv cJ
      cuz cfv wcel vn cv c1 caddc co cJ cuz cfv wcel vn cv c1 caddc co cJ vn cv
      c1 caddc co cfz co wcel cJ vn cv peano2uz cJ vn cv c1 caddc co eluzfz2
      syl sylan ex jcad r19.20sdv imp adantlr sylanc eqtrd cA cc wcel vj vm cJ
      vn cv c1 caddc co cfz co cM cN cfz co ralcom sylan2b adantrr 3eqtr4d
      exp43 imp3a a2d syld uzind4 3impib $.
      $( [22-Feb-2006] $) $( [15-Nov-2005] $)
  $}

  ${
    $d k m n A $.  $d j k m n K $.  $d j k m n M $.  $d j k m N $.
    $( Reversal of a finite sum.  _Warning:  The HTML proof page is 0.6 MB
       in size_. $)
    fsumrev $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ /\
          A. j e. ( M ... N ) A e. CC ) -> sum_ j e. ( M ... N ) A =
            sum_ k e. ( ( K - N ) ... ( K - M ) ) [_ ( K - k ) / j ]_ A ) $=
      cN cM cuz cfv wcel cK cz wcel cA cc wcel vj cM cN cfz co wral cM cN cfz
      co cA vj csu cK cN cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu wceq cK cz wcel cA cc wcel vj cM vm cv cfz co wral wa cM vm cv
      cfz co cA vj csu cK vm cv cmin co cK cM cmin co cfz co vj cK vk cv cmin
      co cA csb vk csu wceq wi cK cz wcel cA cc wcel vj cM cM cfz co wral wa cM
      cM cfz co cA vj csu cK cM cmin co cK cM cmin co cfz co vj cK vk cv cmin
      co cA csb vk csu wceq wi cK cz wcel cA cc wcel vj cM vn cv cfz co wral wa
      cM vn cv cfz co cA vj csu cK vn cv cmin co cK cM cmin co cfz co vj cK vk
      cv cmin co cA csb vk csu wceq wi cK cz wcel cA cc wcel vj cM vn cv c1
      caddc co cfz co wral wa cM vn cv c1 caddc co cfz co cA vj csu cK vn cv c1
      caddc co cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu
      wceq wi cK cz wcel cA cc wcel vj cM cN cfz co wral wa cM cN cfz co cA vj
      csu cK cN cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu
      wceq wi vm vn cM cN cM cz wcel cK cz wcel cA cc wcel vj cM cM cfz co wral
      wa cM cM cfz co cA vj csu cK cM cmin co cK cM cmin co cfz co vj cK vk cv
      cmin co cA csb vk csu wceq cK cz wcel cM cz wcel cA cc wcel vj cM cM cfz
      co wral cM cM cfz co cA vj csu cK cM cmin co cK cM cmin co cfz co vj cK
      vk cv cmin co cA csb vk csu wceq cK cz wcel cM cz wcel cA cc wcel vj cM
      cM cfz co wral cM cM cfz co cA vj csu cK cM cmin co cK cM cmin co cfz co
      vj cK vk cv cmin co cA csb vk csu wceq cK cz wcel cM cz wcel wa cA cc
      wcel vj cM cM cfz co wral wa vj cK cK cM cmin co cmin co cA csb vj cM cA
      csb cK cM cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu
      cM cM cfz co cA vj csu cK cz wcel cM cz wcel wa vj cK cK cM cmin co cmin
      co cA csb vj cM cA csb wceq cA cc wcel vj cM cM cfz co wral cK cz wcel cM
      cz wcel wa vj cK cK cM cmin co cmin co cM cA cK cc wcel cM cc wcel cK cK
      cM cmin co cmin co cM wceq cK cz wcel cM cz wcel cK cM nncan cK zcn cM
      zcn syl2an csbeq1d adantr cK cz wcel cM cz wcel wa cA cc wcel vj cM cM
      cfz co wral vj cK vk cv cmin co cA csb cc wcel vk cK cM cmin co cK cM
      cmin co cfz co wral cK cM cmin co cK cM cmin co cfz co vj cK vk cv cmin
      co cA csb vk csu vj cK cK cM cmin co cmin co cA csb wceq cK cz wcel cM cz
      wcel wa cA cc wcel vj cM cM cfz co wral vj cK vk cv cmin co cA csb cc
      wcel vk cK cM cmin co cK cM cmin co cfz co wral cK cz wcel cM cz wcel wa
      cA cc wcel vj cM cM cfz co wral cA cc wcel vj cK vk cv cmin co wsbc vk cK
      cM cmin co cK cM cmin co cfz co wral vj cK vk cv cmin co cA csb cc wcel
      vk cK cM cmin co cK cM cmin co cfz co wral cM cz wcel cM cz wcel cK cz
      wcel cA cc wcel vj cM cM cfz co wral cA cc wcel vj cK vk cv cmin co wsbc
      vk cK cM cmin co cK cM cmin co cfz co wral wb cK cz wcel cM cz wcel wa cA
      cc wcel vj vk cK cM cM fzrevral cK cz wcel cM cz wcel pm3.27 cK cz wcel
      cM cz wcel pm3.27 cK cz wcel cM cz wcel pm3.26 syl3anc cA cc wcel vj cK
      vk cv cmin co wsbc vj cK vk cv cmin co cA csb cc wcel vk cK cM cmin co cK
      cM cmin co cfz co cK vk cv cmin co cvv wcel cA cc wcel vj cK vk cv cmin
      co wsbc vj cK vk cv cmin co cA csb cc wcel wb cK vk cv cmin oprex vj cK
      vk cv cmin co cA cc cvv sbcel1g ax-mp ralbii syl6bb biimpa cK cM cmin co
      cz wcel vj cK vk cv cmin co cA csb cc wcel vk cK cM cmin co cK cM cmin co
      cfz co wral cK cM cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb
      vk csu vj cK cK cM cmin co cmin co cA csb wceq cK cz wcel cM cz wcel wa
      cK cM cmin co cz wcel vj cK vk cv cmin co cA csb cc wcel vk cK cM cmin co
      cK cM cmin co cfz co wral wa cK cM cmin co cK cM cmin co cfz co vj cK vk
      cv cmin co cA csb vk csu vk cK cM cmin co vj cK vk cv cmin co cA csb csb
      vj cK cK cM cmin co cmin co cA csb vj cK vk cv cmin co cA csb cc vk cK cM
      cmin co fsum1s cK cM cmin co cvv wcel cK vk cv cmin co cvv wcel vk wal vk
      cK cM cmin co vj cK vk cv cmin co cA csb csb vj cK cK cM cmin co cmin co
      cA csb wceq cK cM cmin oprex cK vk cv cmin co cvv wcel vk cK vk cv cmin
      oprex ax-gen vk vj cK cM cmin co cK vk cv cmin co cA cK cK cM cmin co
      cmin co cvv cvv vk cv cK cM cmin co cK cmin opreq2 csbco3g mp2an syl6eq
      cK cM zsubcl sylan syldan cM cz wcel cA cc wcel vj cM cM cfz co wral cM
      cM cfz co cA vj csu vj cM cA csb wceq cK cz wcel cA cc vj cM fsum1s
      adantll 3eqtr4rd anasss an1s ex vn cv cM cuz cfv wcel cK cz wcel cA cc
      wcel vj cM vn cv cfz co wral wa cM vn cv cfz co cA vj csu cK vn cv cmin
      co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq wi cK cz
      wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral wa cM vn cv cfz co cA
      vj csu cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb
      vk csu wceq wi cK cz wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral
      wa cM vn cv c1 caddc co cfz co cA vj csu cK vn cv c1 caddc co cmin co cK
      cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq wi vn cv cM cuz
      cfv wcel cK cz wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral wa cK
      cz wcel cA cc wcel vj cM vn cv cfz co wral wa cM vn cv cfz co cA vj csu
      cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu
      wceq vn cv cM cuz cfv wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral
      cA cc wcel vj cM vn cv cfz co wral cK cz wcel vn cv cM cuz cfv wcel cA cc
      wcel cA cc wcel vj cM vn cv c1 caddc co cfz co cM vn cv cfz co vn cv cM
      cuz cfv wcel vj cv cM vn cv cfz co wcel vj cv cM vn cv c1 caddc co cfz co
      wcel cA cc wcel vn cv cM cuz cfv wcel cM vn cv cfz co cM vn cv c1 caddc
      co cfz co vj cv cM cz wcel vn cv cz wcel cM vn cv cfz co cM vn cv c1
      caddc co cfz co wss vn cv cM cuz cfv wcel cM vn cv fzssp1 cM vn cv
      eluzel2 cM vn cv eluzelz sylanc sseld imim1d r19.20dv2 anim2d imim1d vn
      cv cM cuz cfv wcel cK cz wcel cA cc wcel vj cM vn cv c1 caddc co cfz co
      wral wa cM vn cv cfz co cA vj csu cK vn cv cmin co cK cM cmin co cfz co
      vj cK vk cv cmin co cA csb vk csu wceq cM vn cv c1 caddc co cfz co cA vj
      csu cK vn cv c1 caddc co cmin co cK cM cmin co cfz co vj cK vk cv cmin co
      cA csb vk csu wceq vn cv cM cuz cfv wcel cK cz wcel cA cc wcel vj cM vn
      cv c1 caddc co cfz co wral cM vn cv cfz co cA vj csu cK vn cv cmin co cK
      cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq cM vn cv c1
      caddc co cfz co cA vj csu cK vn cv c1 caddc co cmin co cK cM cmin co cfz
      co vj cK vk cv cmin co cA csb vk csu wceq wi cK cz wcel vn cv cM cuz cfv
      wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral cM vn cv cfz co cA vj
      csu cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk
      csu wceq cM vn cv c1 caddc co cfz co cA vj csu cK vn cv c1 caddc co cmin
      co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq wi wi cK
      cz wcel vn cv cM cuz cfv wcel cA cc wcel vj cM vn cv c1 caddc co cfz co
      wral cM vn cv cfz co cA vj csu cK vn cv cmin co cK cM cmin co cfz co vj
      cK vk cv cmin co cA csb vk csu wceq cM vn cv c1 caddc co cfz co cA vj csu
      cK vn cv c1 caddc co cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu wceq cK cz wcel vn cv cM cuz cfv wcel wa cA cc wcel vj cM vn
      cv c1 caddc co cfz co wral wa cM vn cv cfz co cA vj csu cK vn cv cmin co
      cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq wa vj vn cv
      c1 caddc co cA csb cM vn cv cfz co cA vj csu caddc co vk cK vn cv c1
      caddc co cmin co vj cK vk cv cmin co cA csb csb cK vn cv cmin co cK cM
      cmin co cfz co vj cK vk cv cmin co cA csb vk csu caddc co cM vn cv c1
      caddc co cfz co cA vj csu cK vn cv c1 caddc co cmin co cK cM cmin co cfz
      co vj cK vk cv cmin co cA csb vk csu cK cz wcel vn cv cM cuz cfv wcel wa
      cA cc wcel vj cM vn cv c1 caddc co cfz co wral wa cM vn cv cfz co cA vj
      csu cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk
      csu wceq vj vn cv c1 caddc co cA csb vk cK vn cv c1 caddc co cmin co vj
      cK vk cv cmin co cA csb csb cM vn cv cfz co cA vj csu cK vn cv cmin co cK
      cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu caddc cK cz wcel vn
      cv cM cuz cfv wcel wa vj vn cv c1 caddc co cA csb vk cK vn cv c1 caddc co
      cmin co vj cK vk cv cmin co cA csb csb wceq cA cc wcel vj cM vn cv c1
      caddc co cfz co wral cK cz wcel vn cv cM cuz cfv wcel wa vj cK cK vn cv
      c1 caddc co cmin co cmin co cA csb vj vn cv c1 caddc co cA csb vk cK vn
      cv c1 caddc co cmin co vj cK vk cv cmin co cA csb csb cK cz wcel vn cv cM
      cuz cfv wcel wa vj cK cK vn cv c1 caddc co cmin co cmin co vn cv c1 caddc
      co cA cK cc wcel vn cv c1 caddc co cc wcel cK cK vn cv c1 caddc co cmin
      co cmin co vn cv c1 caddc co wceq cK cz wcel vn cv cM cuz cfv wcel cK vn
      cv c1 caddc co nncan cK zcn vn cv cM cuz cfv wcel vn cv cz wcel vn cv cc
      wcel vn cv c1 caddc co cc wcel cM vn cv eluzelz vn cv zcn vn cv peano2cn
      3syl syl2an csbeq1d cK vn cv c1 caddc co cmin co cvv wcel cK vk cv cmin
      co cvv wcel vk wal vk cK vn cv c1 caddc co cmin co vj cK vk cv cmin co cA
      csb csb vj cK cK vn cv c1 caddc co cmin co cmin co cA csb wceq cK vn cv
      c1 caddc co cmin oprex cK vk cv cmin co cvv wcel vk cK vk cv cmin oprex
      ax-gen vk vj cK vn cv c1 caddc co cmin co cK vk cv cmin co cA cK cK vn cv
      c1 caddc co cmin co cmin co cvv cvv vk cv cK vn cv c1 caddc co cmin co cK
      cmin opreq2 csbco3g mp2an syl5req adantr cM vn cv cfz co cA vj csu cK vn
      cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq id
      opreqan12d cK cz wcel vn cv cM cuz cfv wcel wa cA cc wcel vj cM vn cv c1
      caddc co cfz co wral wa cM vn cv c1 caddc co cfz co cA vj csu vj vn cv c1
      caddc co cA csb cM vn cv cfz co cA vj csu caddc co wceq cM vn cv cfz co
      cA vj csu cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu wceq vn cv cM cuz cfv wcel cA cc wcel vj cM vn cv c1 caddc co
      cfz co wral cM vn cv c1 caddc co cfz co cA vj csu vj vn cv c1 caddc co cA
      csb cM vn cv cfz co cA vj csu caddc co wceq cK cz wcel vn cv cM cuz cfv
      wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral wa cM vn cv c1 caddc
      co cfz co cA vj csu cM vn cv cfz co cA vj csu vj vn cv c1 caddc co cA csb
      caddc co vj vn cv c1 caddc co cA csb cM vn cv cfz co cA vj csu caddc co
      cA cc vj cM vn cv fsump1s cM vn cv cfz co cA vj csu cc wcel vj vn cv c1
      caddc co cA csb cc wcel cM vn cv cfz co cA vj csu vj vn cv c1 caddc co cA
      csb caddc co vj vn cv c1 caddc co cA csb cM vn cv cfz co cA vj csu caddc
      co wceq vn cv cM cuz cfv wcel cA cc wcel vj cM vn cv c1 caddc co cfz co
      wral wa cM vn cv cfz co cA vj csu vj vn cv c1 caddc co cA csb addcom vn
      cv cM cuz cfv wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral cA cc
      wcel vj cM vn cv cfz co wral cM vn cv cfz co cA vj csu cc wcel vn cv cM
      cuz cfv wcel cA cc wcel vj cM vn cv c1 caddc co cfz co wral cA cc wcel vj
      cM vn cv cfz co wral vn cv cM cuz cfv wcel cA cc wcel cA cc wcel vj cM vn
      cv c1 caddc co cfz co cM vn cv cfz co vn cv cM cuz cfv wcel vj cv cM vn
      cv cfz co wcel vj cv cM vn cv c1 caddc co cfz co wcel cA cc wcel vn cv cM
      cuz cfv wcel cM vn cv cfz co cM vn cv c1 caddc co cfz co vj cv cM cz wcel
      vn cv cz wcel cM vn cv cfz co cM vn cv c1 caddc co cfz co wss vn cv cM
      cuz cfv wcel cM vn cv fzssp1 cM vn cv eluzel2 cM vn cv eluzelz sylanc
      sseld imim1d r19.20dv2 imp cA vj cM vn cv fsumcl syldan vn cv c1 caddc co
      cM vn cv c1 caddc co cfz co wcel cA cc wcel vj cM vn cv c1 caddc co cfz
      co wral vj vn cv c1 caddc co cA csb cc wcel vn cv cM cuz cfv wcel vj vn
      cv c1 caddc co cM vn cv c1 caddc co cfz co cA cc ra4csbela vn cv cM cuz
      cfv wcel vn cv c1 caddc co cM cuz cfv wcel vn cv c1 caddc co cM vn cv c1
      caddc co cfz co wcel cM vn cv peano2uz cM vn cv c1 caddc co eluzfz2 syl
      sylan sylanc eqtrd adantll adantr cK cz wcel vn cv cM cuz cfv wcel wa cA
      cc wcel vj cM vn cv c1 caddc co cfz co wral wa cK vn cv c1 caddc co cmin
      co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu vk cK vn cv c1
      caddc co cmin co vj cK vk cv cmin co cA csb csb cK vn cv cmin co cK cM
      cmin co cfz co vj cK vk cv cmin co cA csb vk csu caddc co wceq cM vn cv
      cfz co cA vj csu cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin
      co cA csb vk csu wceq cK cz wcel vn cv cM cuz cfv wcel wa cA cc wcel vj
      cM vn cv c1 caddc co cfz co wral wa cK vn cv c1 caddc co cmin co cK cM
      cmin co cfz co vj cK vk cv cmin co cA csb vk csu vk cK vn cv c1 caddc co
      cmin co vj cK vk cv cmin co cA csb csb cK vn cv c1 caddc co cmin co c1
      caddc co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu caddc co
      vk cK vn cv c1 caddc co cmin co vj cK vk cv cmin co cA csb csb cK vn cv
      cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu caddc co
      cK cM cmin co cK vn cv c1 caddc co cmin co cuz cfv wcel cK vn cv c1 caddc
      co cmin co cK cM cmin co clt wbr vj cK vk cv cmin co cA csb cc wcel vk cK
      vn cv c1 caddc co cmin co cK cM cmin co cfz co wral cK vn cv c1 caddc co
      cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu vk cK vn
      cv c1 caddc co cmin co vj cK vk cv cmin co cA csb csb cK vn cv c1 caddc
      co cmin co c1 caddc co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk
      csu caddc co wceq cK cz wcel vn cv cM cuz cfv wcel wa cA cc wcel vj cM vn
      cv c1 caddc co cfz co wral wa vj cK vk cv cmin co cA csb vk cK vn cv c1
      caddc co cmin co cK cM cmin co fsum1ps cK cz wcel vn cv cM cuz cfv wcel
      wa cK cM cmin co cK vn cv c1 caddc co cmin co cuz cfv wcel cA cc wcel vj
      cM vn cv c1 caddc co cfz co wral cK cz wcel vn cv cM cuz cfv wcel wa cK
      cM cmin co cK vn cv c1 caddc co cmin co cuz cfv wcel cK vn cv c1 caddc co
      cmin co cK cM cmin co cle wbr cK cz wcel vn cv cM cuz cfv wcel wa cM vn
      cv c1 caddc co cle wbr cK vn cv c1 caddc co cmin co cK cM cmin co cle wbr
      vn cv cM cuz cfv wcel cM vn cv c1 caddc co cle wbr cK cz wcel cM cr wcel
      vn cv cr wcel cM vn cv cle wbr cM vn cv c1 caddc co cle wbr vn cv cM cuz
      cfv wcel cM vn cv letrp1 vn cv cM cuz cfv wcel cM cz wcel cM cr wcel cM
      vn cv eluzel2 cM zre syl vn cv cM cuz cfv wcel vn cv cz wcel vn cv cr
      wcel cM vn cv eluzelz vn cv zre syl cM vn cv eluzle syl3anc adantl cM cz
      wcel vn cv c1 caddc co cz wcel cK cz wcel cM vn cv c1 caddc co cle wbr cK
      vn cv c1 caddc co cmin co cK cM cmin co cle wbr wb cK cz wcel vn cv cM
      cuz cfv wcel wa cM cr wcel vn cv c1 caddc co cr wcel cK cr wcel cM vn cv
      c1 caddc co cle wbr cK vn cv c1 caddc co cmin co cK cM cmin co cle wbr wb
      cM cz wcel vn cv c1 caddc co cz wcel cK cz wcel cM vn cv c1 caddc co cK
      lesub2 cM zre vn cv c1 caddc co zre cK zre syl3an vn cv cM cuz cfv wcel
      cM cz wcel cK cz wcel cM vn cv eluzel2 adantl vn cv cM cuz cfv wcel vn cv
      c1 caddc co cz wcel cK cz wcel vn cv cM cuz cfv wcel vn cv cM vn cv
      eluzelz peano2zdi adantl cK cz wcel vn cv cM cuz cfv wcel pm3.26 syl3anc
      mpbid cK vn cv c1 caddc co cmin co cz wcel cK cM cmin co cz wcel cK cM
      cmin co cK vn cv c1 caddc co cmin co cuz cfv wcel cK vn cv c1 caddc co
      cmin co cK cM cmin co cle wbr wb cK cz wcel vn cv cM cuz cfv wcel wa cK
      vn cv c1 caddc co cmin co cK cM cmin co eluz cK cz wcel vn cv c1 caddc co
      cz wcel cK vn cv c1 caddc co cmin co cz wcel vn cv cM cuz cfv wcel cK vn
      cv c1 caddc co zsubcl vn cv cM cuz cfv wcel vn cv cM vn cv eluzelz
      peano2zdi sylan2 cK cz wcel cM cz wcel cK cM cmin co cz wcel vn cv cM cuz
      cfv wcel cK cM zsubcl cM vn cv eluzel2 sylan2 sylanc mpbird adantr cK cz
      wcel vn cv cM cuz cfv wcel wa cK vn cv c1 caddc co cmin co cK cM cmin co
      clt wbr cA cc wcel vj cM vn cv c1 caddc co cfz co wral cK cz wcel vn cv
      cM cuz cfv wcel wa cM vn cv c1 caddc co clt wbr cK vn cv c1 caddc co cmin
      co cK cM cmin co clt wbr vn cv cM cuz cfv wcel cM vn cv c1 caddc co clt
      wbr cK cz wcel vn cv cM cuz cfv wcel cM vn cv cle wbr cM vn cv c1 caddc
      co clt wbr cM vn cv eluzle cM cz wcel vn cv cz wcel cM vn cv cle wbr cM
      vn cv c1 caddc co clt wbr wb vn cv cM cuz cfv wcel cM vn cv zleltp1 cM vn
      cv eluzel2 cM vn cv eluzelz sylanc mpbid adantl cM cz wcel vn cv c1 caddc
      co cz wcel cK cz wcel cM vn cv c1 caddc co clt wbr cK vn cv c1 caddc co
      cmin co cK cM cmin co clt wbr wb cK cz wcel vn cv cM cuz cfv wcel wa cM
      cr wcel vn cv c1 caddc co cr wcel cK cr wcel cM vn cv c1 caddc co clt wbr
      cK vn cv c1 caddc co cmin co cK cM cmin co clt wbr wb cM cz wcel vn cv c1
      caddc co cz wcel cK cz wcel cM vn cv c1 caddc co cK ltsub2 cM zre vn cv
      c1 caddc co zre cK zre syl3an vn cv cM cuz cfv wcel cM cz wcel cK cz wcel
      cM vn cv eluzel2 adantl vn cv cM cuz cfv wcel vn cv c1 caddc co cz wcel
      cK cz wcel vn cv cM cuz cfv wcel vn cv cM vn cv eluzelz peano2zdi adantl
      cK cz wcel vn cv cM cuz cfv wcel pm3.26 syl3anc mpbid adantr cK cz wcel
      vn cv cM cuz cfv wcel wa cA cc wcel vj cM vn cv c1 caddc co cfz co wral
      vj cK vk cv cmin co cA csb cc wcel vk cK vn cv c1 caddc co cmin co cK cM
      cmin co cfz co wral cK cz wcel vn cv cM cuz cfv wcel wa cA cc wcel vj cM
      vn cv c1 caddc co cfz co wral cA cc wcel vj cK vk cv cmin co wsbc vk cK
      vn cv c1 caddc co cmin co cK cM cmin co cfz co wral vj cK vk cv cmin co
      cA csb cc wcel vk cK vn cv c1 caddc co cmin co cK cM cmin co cfz co wral
      cM cz wcel vn cv c1 caddc co cz wcel cK cz wcel cA cc wcel vj cM vn cv c1
      caddc co cfz co wral cA cc wcel vj cK vk cv cmin co wsbc vk cK vn cv c1
      caddc co cmin co cK cM cmin co cfz co wral wb cK cz wcel vn cv cM cuz cfv
      wcel wa cA cc wcel vj vk cK cM vn cv c1 caddc co fzrevral vn cv cM cuz
      cfv wcel cM cz wcel cK cz wcel cM vn cv eluzel2 adantl vn cv cM cuz cfv
      wcel vn cv c1 caddc co cz wcel cK cz wcel vn cv cM cuz cfv wcel vn cv cM
      vn cv eluzelz peano2zdi adantl cK cz wcel vn cv cM cuz cfv wcel pm3.26
      syl3anc cA cc wcel vj cK vk cv cmin co wsbc vj cK vk cv cmin co cA csb cc
      wcel vk cK vn cv c1 caddc co cmin co cK cM cmin co cfz co cK vk cv cmin
      co cvv wcel cA cc wcel vj cK vk cv cmin co wsbc vj cK vk cv cmin co cA
      csb cc wcel wb cK vk cv cmin oprex vj cK vk cv cmin co cA cc cvv sbcel1g
      ax-mp ralbii syl6bb biimpa syl3anc cK cz wcel vn cv cM cuz cfv wcel wa vk
      cK vn cv c1 caddc co cmin co vj cK vk cv cmin co cA csb csb cK vn cv c1
      caddc co cmin co c1 caddc co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu caddc co vk cK vn cv c1 caddc co cmin co vj cK vk cv cmin co
      cA csb csb cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu caddc co wceq cA cc wcel vj cM vn cv c1 caddc co cfz co wral
      cK cz wcel vn cv cM cuz cfv wcel wa cK vn cv c1 caddc co cmin co c1 caddc
      co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu cK vn cv cmin
      co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu vk cK vn cv c1
      caddc co cmin co vj cK vk cv cmin co cA csb csb caddc cK cz wcel vn cv cM
      cuz cfv wcel wa cK vn cv c1 caddc co cmin co c1 caddc co cK cM cmin co
      cfz co cK vn cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb
      vk cK cz wcel vn cv cM cuz cfv wcel wa cK vn cv c1 caddc co cmin co c1
      caddc co cK vn cv cmin co cK cM cmin co cfz cK cc wcel vn cv cc wcel cK
      vn cv c1 caddc co cmin co c1 caddc co cK vn cv cmin co wceq cK cz wcel vn
      cv cM cuz cfv wcel cK cc wcel vn cv cc wcel c1 cc wcel cK vn cv c1 caddc
      co cmin co c1 caddc co cK vn cv cmin co wceq ax1cn cK vn cv c1 nppcan2
      mp3an3 cK zcn vn cv cM cuz cfv wcel vn cv cz wcel vn cv cc wcel cM vn cv
      eluzelz vn cv zcn syl syl2an opreq1d sumeq1d opreq2d adantr eqtrd adantr
      3eqtr4d exp41 com12 imp3a a2d syld vm cv cM wceq cK cz wcel cA cc wcel vj
      cM vm cv cfz co wral wa cK cz wcel cA cc wcel vj cM cM cfz co wral wa cM
      vm cv cfz co cA vj csu cK vm cv cmin co cK cM cmin co cfz co vj cK vk cv
      cmin co cA csb vk csu wceq cM cM cfz co cA vj csu cK cM cmin co cK cM
      cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq vm cv cM wceq cA cc
      wcel vj cM vm cv cfz co wral cA cc wcel vj cM cM cfz co wral cK cz wcel
      vm cv cM wceq cA cc wcel vj cM vm cv cfz co cM cM cfz co vm cv cM cM cfz
      opreq2 raleq1d anbi2d vm cv cM wceq cM vm cv cfz co cA vj csu cM cM cfz
      co cA vj csu cK vm cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu cK cM cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb
      vk csu vm cv cM wceq cM vm cv cfz co cM cM cfz co cA vj vm cv cM cM cfz
      opreq2 sumeq1d vm cv cM wceq cK vm cv cmin co cK cM cmin co cfz co cK cM
      cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk vm cv cM wceq
      cK vm cv cmin co cK cM cmin co cK cM cmin co cfz vm cv cM cK cmin opreq2
      opreq1d sumeq1d eqeq12d imbi12d vm cv vn cv wceq cK cz wcel cA cc wcel vj
      cM vm cv cfz co wral wa cK cz wcel cA cc wcel vj cM vn cv cfz co wral wa
      cM vm cv cfz co cA vj csu cK vm cv cmin co cK cM cmin co cfz co vj cK vk
      cv cmin co cA csb vk csu wceq cM vn cv cfz co cA vj csu cK vn cv cmin co
      cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu wceq vm cv vn cv
      wceq cA cc wcel vj cM vm cv cfz co wral cA cc wcel vj cM vn cv cfz co
      wral cK cz wcel vm cv vn cv wceq cA cc wcel vj cM vm cv cfz co cM vn cv
      cfz co vm cv vn cv cM cfz opreq2 raleq1d anbi2d vm cv vn cv wceq cM vm cv
      cfz co cA vj csu cM vn cv cfz co cA vj csu cK vm cv cmin co cK cM cmin co
      cfz co vj cK vk cv cmin co cA csb vk csu cK vn cv cmin co cK cM cmin co
      cfz co vj cK vk cv cmin co cA csb vk csu vm cv vn cv wceq cM vm cv cfz co
      cM vn cv cfz co cA vj vm cv vn cv cM cfz opreq2 sumeq1d vm cv vn cv wceq
      cK vm cv cmin co cK cM cmin co cfz co cK vn cv cmin co cK cM cmin co cfz
      co vj cK vk cv cmin co cA csb vk vm cv vn cv wceq cK vm cv cmin co cK vn
      cv cmin co cK cM cmin co cfz vm cv vn cv cK cmin opreq2 opreq1d sumeq1d
      eqeq12d imbi12d vm cv vn cv c1 caddc co wceq cK cz wcel cA cc wcel vj cM
      vm cv cfz co wral wa cK cz wcel cA cc wcel vj cM vn cv c1 caddc co cfz co
      wral wa cM vm cv cfz co cA vj csu cK vm cv cmin co cK cM cmin co cfz co
      vj cK vk cv cmin co cA csb vk csu wceq cM vn cv c1 caddc co cfz co cA vj
      csu cK vn cv c1 caddc co cmin co cK cM cmin co cfz co vj cK vk cv cmin co
      cA csb vk csu wceq vm cv vn cv c1 caddc co wceq cA cc wcel vj cM vm cv
      cfz co wral cA cc wcel vj cM vn cv c1 caddc co cfz co wral cK cz wcel vm
      cv vn cv c1 caddc co wceq cA cc wcel vj cM vm cv cfz co cM vn cv c1 caddc
      co cfz co vm cv vn cv c1 caddc co cM cfz opreq2 raleq1d anbi2d vm cv vn
      cv c1 caddc co wceq cM vm cv cfz co cA vj csu cM vn cv c1 caddc co cfz co
      cA vj csu cK vm cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu cK vn cv c1 caddc co cmin co cK cM cmin co cfz co vj cK vk cv
      cmin co cA csb vk csu vm cv vn cv c1 caddc co wceq cM vm cv cfz co cM vn
      cv c1 caddc co cfz co cA vj vm cv vn cv c1 caddc co cM cfz opreq2 sumeq1d
      vm cv vn cv c1 caddc co wceq cK vm cv cmin co cK cM cmin co cfz co cK vn
      cv c1 caddc co cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk
      vm cv vn cv c1 caddc co wceq cK vm cv cmin co cK vn cv c1 caddc co cmin
      co cK cM cmin co cfz vm cv vn cv c1 caddc co cK cmin opreq2 opreq1d
      sumeq1d eqeq12d imbi12d vm cv cN wceq cK cz wcel cA cc wcel vj cM vm cv
      cfz co wral wa cK cz wcel cA cc wcel vj cM cN cfz co wral wa cM vm cv cfz
      co cA vj csu cK vm cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA
      csb vk csu wceq cM cN cfz co cA vj csu cK cN cmin co cK cM cmin co cfz co
      vj cK vk cv cmin co cA csb vk csu wceq vm cv cN wceq cA cc wcel vj cM vm
      cv cfz co wral cA cc wcel vj cM cN cfz co wral cK cz wcel vm cv cN wceq
      cA cc wcel vj cM vm cv cfz co cM cN cfz co vm cv cN cM cfz opreq2 raleq1d
      anbi2d vm cv cN wceq cM vm cv cfz co cA vj csu cM cN cfz co cA vj csu cK
      vm cv cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu cK
      cN cmin co cK cM cmin co cfz co vj cK vk cv cmin co cA csb vk csu vm cv
      cN wceq cM vm cv cfz co cM cN cfz co cA vj vm cv cN cM cfz opreq2 sumeq1d
      vm cv cN wceq cK vm cv cmin co cK cM cmin co cfz co cK cN cmin co cK cM
      cmin co cfz co vj cK vk cv cmin co cA csb vk vm cv cN wceq cK vm cv cmin
      co cK cN cmin co cK cM cmin co cfz vm cv cN cK cmin opreq2 opreq1d
      sumeq1d eqeq12d imbi12d uzind4ALT 3impib $.
      $( [16-Jan-2006] $) $( [26-Nov-2005] $)

    $( Reversal of a finite sum. $)
    fsumrev2 $p |- ( ( N e. ( ZZ>= ` M ) /\ A. j e. ( M ... N ) A e. CC )
                  -> sum_ j e. ( M ... N ) A =
                     sum_ k e. ( M ... N ) [_ ( ( M + N ) - k ) / j ]_ A ) $=
      cN cM cuz cfv wcel cA cc wcel vj cM cN cfz co wral wa cM cN cfz co cA vj
      csu cM cN caddc co cN cmin co cM cN caddc co cM cmin co cfz co vj cM cN
      caddc co vk cv cmin co cA csb vk csu cM cN cfz co vj cM cN caddc co vk cv
      cmin co cA csb vk csu cN cM cuz cfv wcel cM cN caddc co cz wcel wa cA cc
      wcel vj cM cN cfz co wral cM cN cfz co cA vj csu cM cN caddc co cN cmin
      co cM cN caddc co cM cmin co cfz co vj cM cN caddc co vk cv cmin co cA
      csb vk csu wceq cN cM cuz cfv wcel cN cM cuz cfv wcel cM cN caddc co cz
      wcel cA cc wcel vj cM cN cfz co wral cM cN cfz co cA vj csu cM cN caddc
      co cN cmin co cM cN caddc co cM cmin co cfz co vj cM cN caddc co vk cv
      cmin co cA csb vk csu wceq cA vj vk cM cN caddc co cM cN fsumrev 3expa cN
      cM cuz cfv wcel cM cN caddc co cz wcel cM cz wcel cN cz wcel cM cN caddc
      co cz wcel cN cM cuz cfv wcel cM cN zaddcl cM cN eluzel2 cM cN eluzelz
      sylanc ancli sylan cN cM cuz cfv wcel cM cN caddc co cN cmin co cM cN
      caddc co cM cmin co cfz co vj cM cN caddc co vk cv cmin co cA csb vk csu
      cM cN cfz co vj cM cN caddc co vk cv cmin co cA csb vk csu wceq cA cc
      wcel vj cM cN cfz co wral cN cM cuz cfv wcel cM cN caddc co cN cmin co cM
      cN caddc co cM cmin co cfz co cM cN cfz co vj cM cN caddc co vk cv cmin
      co cA csb vk cN cM cuz cfv wcel cM cN caddc co cN cmin co cM cM cN caddc
      co cM cmin co cN cfz cM cz wcel cN cz wcel cM cN caddc co cN cmin co cM
      wceq cN cM cuz cfv wcel cM cc wcel cN cc wcel cM cN caddc co cN cmin co
      cM wceq cM cz wcel cN cz wcel cM cN pncan cM zcn cN zcn syl2an cM cN
      eluzel2 cM cN eluzelz sylanc cM cz wcel cN cz wcel cM cN caddc co cM cmin
      co cN wceq cN cM cuz cfv wcel cM cc wcel cN cc wcel cM cN caddc co cM
      cmin co cN wceq cM cz wcel cN cz wcel cM cN pncan2 cM zcn cN zcn syl2an
      cM cN eluzel2 cM cN eluzelz sylanc opreq12d sumeq1d adantr eqtrd $.
      $( [15-May-2007] $) $( [27-Nov-2005] $)

    $( Index shift of a finite sum. $)
    fsumshft $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ /\
          A. j e. ( M ... N ) A e. CC ) -> sum_ j e. ( M ... N ) A =
            sum_ k e. ( ( M + K ) ... ( N + K ) ) [_ ( k - K ) / j ]_ A ) $=
      cN cM cuz cfv wcel cK cz wcel cA cc wcel vj cM cN cfz co wral w3a cM cN
      cfz co cA vj csu cc0 cN cmin co cc0 cM cmin co cfz co vj cc0 vm cv cmin
      co cA csb vm csu cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co cfz
      co vm cK vk cv cmin co vj cc0 vm cv cmin co cA csb csb vk csu cM cK caddc
      co cN cK caddc co cfz co vj vk cv cK cmin co cA csb vk csu cN cM cuz cfv
      wcel cA cc wcel vj cM cN cfz co wral cM cN cfz co cA vj csu cc0 cN cmin
      co cc0 cM cmin co cfz co vj cc0 vm cv cmin co cA csb vm csu wceq cK cz
      wcel cN cM cuz cfv wcel cc0 cz wcel cA cc wcel vj cM cN cfz co wral cM cN
      cfz co cA vj csu cc0 cN cmin co cc0 cM cmin co cfz co vj cc0 vm cv cmin
      co cA csb vm csu wceq 0z cA vj vm cc0 cM cN fsumrev mp3an2 3adant2 cc0 cM
      cmin co cc0 cN cmin co cuz cfv wcel cK cz wcel vj cc0 vm cv cmin co cA
      csb cc wcel vm cc0 cN cmin co cc0 cM cmin co cfz co wral cc0 cN cmin co
      cc0 cM cmin co cfz co vj cc0 vm cv cmin co cA csb vm csu cK cc0 cM cmin
      co cmin co cK cc0 cN cmin co cmin co cfz co vm cK vk cv cmin co vj cc0 vm
      cv cmin co cA csb csb vk csu wceq cN cM cuz cfv wcel cK cz wcel cA cc
      wcel vj cM cN cfz co wral w3a vj cc0 vm cv cmin co cA csb vm vk cK cc0 cN
      cmin co cc0 cM cmin co fsumrev cN cM cuz cfv wcel cK cz wcel cc0 cM cmin
      co cc0 cN cmin co cuz cfv wcel cA cc wcel vj cM cN cfz co wral cN cM cuz
      cfv wcel cM cneg cN cneg cuz cfv wcel cc0 cM cmin co cc0 cN cmin co cuz
      cfv wcel cM cN uzneg cM cneg cc0 cM cmin co cN cneg cuz cfv cc0 cN cmin
      co cuz cfv cM df-neg cN cneg cc0 cN cmin co cuz cN df-neg fveq2i eleq12i
      sylib 3ad2ant1 cN cM cuz cfv wcel cK cz wcel cA cc wcel vj cM cN cfz co
      wral 3simp2 cN cM cuz cfv wcel cA cc wcel vj cM cN cfz co wral vj cc0 vm
      cv cmin co cA csb cc wcel vm cc0 cN cmin co cc0 cM cmin co cfz co wral cK
      cz wcel cN cM cuz cfv wcel cA cc wcel vj cM cN cfz co wral vj cc0 vm cv
      cmin co cA csb cc wcel vm cc0 cN cmin co cc0 cM cmin co cfz co wral cN cM
      cuz cfv wcel cA cc wcel vj cM cN cfz co wral cA cc wcel vj cc0 vm cv cmin
      co wsbc vm cc0 cN cmin co cc0 cM cmin co cfz co wral vj cc0 vm cv cmin co
      cA csb cc wcel vm cc0 cN cmin co cc0 cM cmin co cfz co wral cM cz wcel cN
      cz wcel cA cc wcel vj cM cN cfz co wral cA cc wcel vj cc0 vm cv cmin co
      wsbc vm cc0 cN cmin co cc0 cM cmin co cfz co wral wb cN cM cuz cfv wcel
      cM cz wcel cN cz wcel cc0 cz wcel cA cc wcel vj cM cN cfz co wral cA cc
      wcel vj cc0 vm cv cmin co wsbc vm cc0 cN cmin co cc0 cM cmin co cfz co
      wral wb 0z cA cc wcel vj vm cc0 cM cN fzrevral mp3an3 cM cN eluzel2 cM cN
      eluzelz sylanc cA cc wcel vj cc0 vm cv cmin co wsbc vj cc0 vm cv cmin co
      cA csb cc wcel vm cc0 cN cmin co cc0 cM cmin co cfz co cc0 vm cv cmin co
      cvv wcel cA cc wcel vj cc0 vm cv cmin co wsbc vj cc0 vm cv cmin co cA csb
      cc wcel wb cc0 vm cv cmin oprex vj cc0 vm cv cmin co cA cc cvv sbcel1g
      ax-mp ralbii syl6bb biimpa 3adant2 syl3anc cN cM cuz cfv wcel cK cz wcel
      cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co cfz co vm cK vk cv
      cmin co vj cc0 vm cv cmin co cA csb csb vk csu cM cK caddc co cN cK caddc
      co cfz co vj vk cv cK cmin co cA csb vk csu wceq cA cc wcel vj cM cN cfz
      co wral cN cM cuz cfv wcel cK cz wcel wa cK cc0 cM cmin co cmin co cK cc0
      cN cmin co cmin co cfz co cM cK caddc co cN cK caddc co cfz co vm cK vk
      cv cmin co vj cc0 vm cv cmin co cA csb csb vj vk cv cK cmin co cA csb vk
      cK cz wcel cN cM cuz cfv wcel cK cc0 cM cmin co cmin co cK cc0 cN cmin co
      cmin co cfz co cM cK caddc co cN cK caddc co cfz co wceq cK cc wcel cM cc
      wcel cN cc wcel wa cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co
      cfz co cM cK caddc co cN cK caddc co cfz co wceq cK cz wcel cN cM cuz cfv
      wcel cK cc wcel cM cc wcel cN cc wcel wa wa cK cc0 cM cmin co cmin co cM
      cK caddc co cK cc0 cN cmin co cmin co cN cK caddc co cfz cK cc wcel cM cc
      wcel cK cc0 cM cmin co cmin co cM cK caddc co wceq cN cc wcel cK cc wcel
      cM cc wcel wa cK cM cneg cmin co cM cK caddc co cK cc0 cM cmin co cmin co
      cK cc wcel cM cc wcel wa cK cM cneg cmin co cK cM caddc co cM cK caddc co
      cK cM subneg cK cM addcom eqtrd cM cneg cc0 cM cmin co cK cmin cM df-neg
      opreq2i syl5eqr adantrr cK cc wcel cN cc wcel cK cc0 cN cmin co cmin co
      cN cK caddc co wceq cM cc wcel cK cc wcel cN cc wcel wa cK cN cneg cmin
      co cN cK caddc co cK cc0 cN cmin co cmin co cK cc wcel cN cc wcel wa cK
      cN cneg cmin co cK cN caddc co cN cK caddc co cK cN subneg cK cN addcom
      eqtrd cN cneg cc0 cN cmin co cK cmin cN df-neg opreq2i syl5eqr adantrl
      opreq12d cK zcn cN cM cuz cfv wcel cM cc wcel cN cc wcel cN cM cuz cfv
      wcel cM cz wcel cM cc wcel cM cN eluzel2 cM zcn syl cN cM cuz cfv wcel cN
      cz wcel cN cc wcel cM cN eluzelz cN zcn syl jca syl2an ancoms cK cz wcel
      vk cv cK cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co cfz co wcel vm
      cK vk cv cmin co vj cc0 vm cv cmin co cA csb csb vj vk cv cK cmin co cA
      csb wceq cN cM cuz cfv wcel cK cz wcel vk cv cz wcel vm cK vk cv cmin co
      vj cc0 vm cv cmin co cA csb csb vj vk cv cK cmin co cA csb wceq vk cv cK
      cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co cfz co wcel cK cz wcel
      vk cv cz wcel wa vj cc0 cK vk cv cmin co cmin co cA csb vj vk cv cK cmin
      co cA csb vm cK vk cv cmin co vj cc0 vm cv cmin co cA csb csb cK cz wcel
      vk cv cz wcel wa vj cc0 cK vk cv cmin co cmin co vk cv cK cmin co cA cK
      cz wcel vk cv cz wcel wa cK vk cv cmin co cneg vk cv cK cmin co cc0 cK vk
      cv cmin co cmin co cK cc wcel vk cv cc wcel cK vk cv cmin co cneg vk cv
      cK cmin co wceq cK cz wcel vk cv cz wcel cK vk cv negsubdi2 cK zcn vk cv
      zcn syl2an cK vk cv cmin co df-neg syl5eqr csbeq1d cK vk cv cmin co cvv
      wcel cc0 vm cv cmin co cvv wcel vm wal vm cK vk cv cmin co vj cc0 vm cv
      cmin co cA csb csb vj cc0 cK vk cv cmin co cmin co cA csb wceq cK vk cv
      cmin oprex cc0 vm cv cmin co cvv wcel vm cc0 vm cv cmin oprex ax-gen vm
      vj cK vk cv cmin co cc0 vm cv cmin co cA cc0 cK vk cv cmin co cmin co cvv
      cvv vm cv cK vk cv cmin co cc0 cmin opreq2 csbco3g mp2an syl5eq vk cv cK
      cc0 cM cmin co cmin co cK cc0 cN cmin co cmin co elfzelz sylan2 adantll
      sumeq12dv 3adant3 3eqtrd $.
      $( [17-Jan-2006] $) $( [27-Nov-2005] $)

    $( Negative index shift of a finite sum. $)
    fsumshftm $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ /\
          A. j e. ( M ... N ) A e. CC ) -> sum_ j e. ( M ... N ) A =
            sum_ k e. ( ( M - K ) ... ( N - K ) ) [_ ( k + K ) / j ]_ A ) $=
      cN cM cuz cfv wcel cK cz wcel cA cc wcel vj cM cN cfz co wral w3a cM cN
      cfz co cA vj csu cM cK cneg caddc co cN cK cneg caddc co cfz co vj vk cv
      cK cneg cmin co cA csb vk csu cM cK cmin co cN cK cmin co cfz co vj vk cv
      cK caddc co cA csb vk csu cN cM cuz cfv wcel cK cneg cz wcel cA cc wcel
      vj cM cN cfz co wral cM cN cfz co cA vj csu cM cK cneg caddc co cN cK
      cneg caddc co cfz co vj vk cv cK cneg cmin co cA csb vk csu wceq cK cz
      wcel cA vj vk cK cneg cM cN fsumshft cK znegcl syl3an2 cN cM cuz cfv wcel
      cK cz wcel cM cK cneg caddc co cN cK cneg caddc co cfz co vj vk cv cK
      cneg cmin co cA csb vk csu cM cK cmin co cN cK cmin co cfz co vj vk cv cK
      caddc co cA csb vk csu wceq cA cc wcel vj cM cN cfz co wral cN cM cuz cfv
      wcel cK cz wcel wa cM cK cneg caddc co cN cK cneg caddc co cfz co cM cK
      cmin co cN cK cmin co cfz co vj vk cv cK cneg cmin co cA csb vj vk cv cK
      caddc co cA csb vk cM cz wcel cN cz wcel wa cK cz wcel cM cK cneg caddc
      co cN cK cneg caddc co cfz co cM cK cmin co cN cK cmin co cfz co wceq cN
      cM cuz cfv wcel cM cz wcel cN cz wcel cK cz wcel cM cK cneg caddc co cN
      cK cneg caddc co cfz co cM cK cmin co cN cK cmin co cfz co wceq cM cc
      wcel cN cc wcel cK cc wcel cM cK cneg caddc co cN cK cneg caddc co cfz co
      cM cK cmin co cN cK cmin co cfz co wceq cM cz wcel cN cz wcel cK cz wcel
      cM cc wcel cN cc wcel cK cc wcel w3a cM cK cneg caddc co cM cK cmin co cN
      cK cneg caddc co cN cK cmin co cfz cM cc wcel cK cc wcel cM cK cneg caddc
      co cM cK cmin co wceq cN cc wcel cM cK negsub 3adant2 cN cc wcel cK cc
      wcel cN cK cneg caddc co cN cK cmin co wceq cM cc wcel cN cK negsub
      3adant1 opreq12d cM zcn cN zcn cK zcn syl3an 3expa cN cM cuz cfv wcel cM
      cz wcel cN cz wcel cM cN eluzel2 cM cN eluzelz jca sylan cK cz wcel vk cv
      cM cK cneg caddc co cN cK cneg caddc co cfz co wcel vj vk cv cK cneg cmin
      co cA csb vj vk cv cK caddc co cA csb wceq cN cM cuz cfv wcel cK cz wcel
      vk cv cM cK cneg caddc co cN cK cneg caddc co cfz co wcel vj vk cv cK
      cneg cmin co cA csb vj vk cv cK caddc co cA csb wceq cK cz wcel vk cv cz
      wcel vj vk cv cK cneg cmin co cA csb vj vk cv cK caddc co cA csb wceq vk
      cv cM cK cneg caddc co cN cK cneg caddc co cfz co wcel cK cz wcel vk cv
      cz wcel vk cv cK cneg cmin co vk cv cK caddc co wceq vj vk cv cK cneg
      cmin co cA csb vj vk cv cK caddc co cA csb wceq cK cz wcel vk cv cz wcel
      vk cv cK cneg cmin co vk cv cK caddc co wceq cK cc wcel vk cv cc wcel vk
      cv cK cneg cmin co vk cv cK caddc co wceq cK cz wcel vk cv cz wcel vk cv
      cc wcel cK cc wcel vk cv cK cneg cmin co vk cv cK caddc co wceq vk cv cK
      subneg ancoms cK zcn vk cv zcn syl2an ex vj vk cv cK cneg cmin co vk cv
      cK caddc co cA csbeq1 syl6 vk cv cM cK cneg caddc co cN cK cneg caddc co
      elfzelz syl5 imp adantll sumeq12dv 3adant3 eqtrd $.
      $( [12-Dec-2006] $) $( [28-Nov-2005] $)
  $}

  ${
    $d j k m C $.  $d j m A $.  $d j k m M $.  $d j k N $.
    $( A finite sum multiplied by a constant. $)
    fsummulc1 $p |- ( ( N e. ( ZZ>= ` M ) /\ C e. CC /\
                      A. k e. ( M ... N ) A e. CC ) ->
   ( C x. sum_ k e. ( M ... N ) A ) = sum_ k e. ( M ... N ) ( C x. A ) ) $=
      cN cM cuz cfv wcel cC cc wcel cA cc wcel vk cM cN cfz co wral cC cM cN
      cfz co cA vk csu cmul co cM cN cfz co cC cA cmul co vk csu wceq cC cc
      wcel cA cc wcel vk cM vj cv cfz co wral wa cC cM vj cv cfz co cA vk csu
      cmul co cM vj cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel cA cc
      wcel vk cM cM cfz co wral wa cC cM cM cfz co cA vk csu cmul co cM cM cfz
      co cC cA cmul co vk csu wceq wi cC cc wcel cA cc wcel vk cM vm cv cfz co
      wral wa cC cM vm cv cfz co cA vk csu cmul co cM vm cv cfz co cC cA cmul
      co vk csu wceq wi cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co
      wral wa cC cM vm cv c1 caddc co cfz co cA vk csu cmul co cM vm cv c1
      caddc co cfz co cC cA cmul co vk csu wceq wi cC cc wcel cA cc wcel vk cM
      cN cfz co wral wa cC cM cN cfz co cA vk csu cmul co cM cN cfz co cC cA
      cmul co vk csu wceq wi vj vm cM cN cM cz wcel cC cc wcel cA cc wcel vk cM
      cM cfz co wral wa cC cM cM cfz co cA vk csu cmul co cM cM cfz co cC cA
      cmul co vk csu wceq cM cz wcel cC cc wcel cA cc wcel vk cM cM cfz co wral
      wa wa vk cM cC cA cmul co csb cC vk cM cA csb cmul co cM cM cfz co cC cA
      cmul co vk csu cC cM cM cfz co cA vk csu cmul co cM cz wcel vk cM cC cA
      cmul co csb cC vk cM cA csb cmul co wceq cC cc wcel cA cc wcel vk cM cM
      cfz co wral wa vk cM cC cA cz cmul csbopr2g adantr cM cz wcel cC cA cmul
      co cc wcel vk cM cM cfz co wral cM cM cfz co cC cA cmul co vk csu vk cM
      cC cA cmul co csb wceq cC cc wcel cA cc wcel vk cM cM cfz co wral wa cC
      cA cmul co cc vk cM fsum1s cC cc wcel cA cc wcel vk cM cM cfz co wral wa
      cC cc wcel cA cc wcel wa vk cM cM cfz co wral cC cA cmul co cc wcel vk cM
      cM cfz co wral cC cc wcel cA cc wcel vk cM cM cfz co r19.28av cC cc wcel
      cA cc wcel wa cC cA cmul co cc wcel vk cM cM cfz co cC cA mulcl r19.20si
      syl sylan2 cM cz wcel cC cc wcel cA cc wcel vk cM cM cfz co wral wa wa cM
      cM cfz co cA vk csu vk cM cA csb cC cmul cM cz wcel cA cc wcel vk cM cM
      cfz co wral cM cM cfz co cA vk csu vk cM cA csb wceq cC cc wcel cA cc vk
      cM fsum1s adantrl opreq2d 3eqtr4rd ex vm cv cM cuz cfv wcel cC cc wcel cA
      cc wcel vk cM vm cv cfz co wral wa cC cM vm cv cfz co cA vk csu cmul co
      cM vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel cA cc wcel vk cM
      vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu cmul co cM
      vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel cA cc wcel vk cM vm
      cv c1 caddc co cfz co wral wa cC cM vm cv c1 caddc co cfz co cA vk csu
      cmul co cM vm cv c1 caddc co cfz co cC cA cmul co vk csu wceq wi vm cv cM
      cuz cfv wcel cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa
      cC cc wcel cA cc wcel vk cM vm cv cfz co wral wa cC cM vm cv cfz co cA vk
      csu cmul co cM vm cv cfz co cC cA cmul co vk csu wceq vm cv cM cuz cfv
      wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM vm
      cv cfz co wral cC cc wcel vm cv cM cuz cfv wcel cA cc wcel cA cc wcel vk
      cM vm cv c1 caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv
      cM vm cv cfz co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel vm
      cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM
      cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm
      cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz
      sylanc sseld imim1d r19.20dv2 anim2d imim1d vm cv cM cuz cfv wcel cC cc
      wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co
      cA vk csu cmul co cM vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel
      cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv c1 caddc co
      cfz co cA vk csu cmul co cM vm cv c1 caddc co cfz co cC cA cmul co vk csu
      wceq vm cv cM cuz cfv wcel cC cc wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral wa cC cM vm cv cfz co cA vk csu cmul co cM vm cv cfz co cC cA
      cmul co vk csu wceq wi wa cC cc wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral wa wa cC cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA
      csb caddc co cmul co cM vm cv cfz co cC cA cmul co vk csu vk vm cv c1
      caddc co cC cA cmul co csb caddc co cC cM vm cv c1 caddc co cfz co cA vk
      csu cmul co cM vm cv c1 caddc co cfz co cC cA cmul co vk csu vm cv cM cuz
      cfv wcel cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cC
      cM vm cv cfz co cA vk csu cmul co cM vm cv cfz co cC cA cmul co vk csu
      wceq wi wa cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa
      wa cC cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co cmul
      co cC cM vm cv cfz co cA vk csu cmul co cC vk vm cv c1 caddc co cA csb
      cmul co caddc co cM vm cv cfz co cC cA cmul co vk csu vk vm cv c1 caddc
      co cC cA cmul co csb caddc co vm cv cM cuz cfv wcel cC cc wcel cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu vk vm
      cv c1 caddc co cA csb caddc co cmul co cC cM vm cv cfz co cA vk csu cmul
      co cC vk vm cv c1 caddc co cA csb cmul co caddc co wceq cC cc wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu
      cmul co cM vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel cM vm cv
      cfz co cA vk csu cc wcel vk vm cv c1 caddc co cA csb cc wcel cC cM vm cv
      cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co cmul co cC cM vm cv
      cfz co cA vk csu cmul co cC vk vm cv c1 caddc co cA csb cmul co caddc co
      wceq vm cv cM cuz cfv wcel cC cc wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral wa wa cC cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA
      csb adddi vm cv cM cuz cfv wcel cC cc wcel cA cc wcel vk cM vm cv c1
      caddc co cfz co wral simprl vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv
      c1 caddc co cfz co wral cM vm cv cfz co cA vk csu cc wcel cC cc wcel vm
      cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc
      wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk csu cc wcel vm cv cM
      cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk
      cM vm cv cfz co wral vm cv cM cuz cfv wcel cA cc wcel cA cc wcel vk cM vm
      cv c1 caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv cM vm
      cv cfz co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel vm cv cM
      cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel
      vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm cv cM
      cuz cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz sylanc
      sseld imim1d r19.20dv2 imp cA vk cM vm cv fsumcl syldan adantrl vm cv cM
      cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1
      caddc co cA csb cc wcel cC cc wcel vm cv c1 caddc co cM vm cv c1 caddc co
      cfz co wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1
      caddc co cA csb cc wcel vm cv cM cuz cfv wcel vk vm cv c1 caddc co cM vm
      cv c1 caddc co cfz co cA cc ra4csbela vm cv cM cuz cfv wcel vm cv c1
      caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cM vm cv peano2uz cM vm cv c1 caddc co eluzfz2 syl sylan adantrl
      syl3anc adantlr cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral
      wa cC cM vm cv cfz co cA vk csu cmul co cM vm cv cfz co cC cA cmul co vk
      csu wceq wi cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa
      cC cM vm cv cfz co cA vk csu cmul co cC vk vm cv c1 caddc co cA csb cmul
      co caddc co cM vm cv cfz co cC cA cmul co vk csu vk vm cv c1 caddc co cC
      cA cmul co csb caddc co wceq vm cv cM cuz cfv wcel cC cc wcel cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu cmul
      co cM vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral wa wa cC cM vm cv cfz co cA vk csu cmul
      co cM vm cv cfz co cC cA cmul co vk csu cC vk vm cv c1 caddc co cA csb
      cmul co vk vm cv c1 caddc co cC cA cmul co csb caddc cC cc wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu
      cmul co cM vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu
      cmul co cM vm cv cfz co cC cA cmul co vk csu wceq cC cc wcel cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu cmul
      co cM vm cv cfz co cC cA cmul co vk csu wceq wi id imp cC vk vm cv c1
      caddc co cA csb cmul co vk vm cv c1 caddc co cC cA cmul co csb wceq cC cc
      wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co
      cA vk csu cmul co cM vm cv cfz co cC cA cmul co vk csu wceq wi cC cc wcel
      cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa wa vk vm cv c1 caddc co
      cC cA cmul co csb cC vk vm cv c1 caddc co cA csb cmul co vm cv c1 caddc
      co cvv wcel vk vm cv c1 caddc co cC cA cmul co csb cC vk vm cv c1 caddc
      co cA csb cmul co wceq vm cv c1 caddc oprex vk vm cv c1 caddc co cC cA
      cvv cmul csbopr2g ax-mp eqcomi a1i opreq12d adantll eqtrd vm cv cM cuz
      cfv wcel cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cC
      cM vm cv c1 caddc co cfz co cA vk csu cmul co cC cM vm cv cfz co cA vk
      csu vk vm cv c1 caddc co cA csb caddc co cmul co wceq cC cc wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu
      cmul co cM vm cv cfz co cC cA cmul co vk csu wceq wi vm cv cM cuz cfv
      wcel cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa wa cM
      vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1
      caddc co cA csb caddc co cC cmul vm cv cM cuz cfv wcel cA cc wcel vk cM
      vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu cM vm
      cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co wceq cC cc wcel
      cA cc vk cM vm cv fsump1s adantrl opreq2d adantlr vm cv cM cuz cfv wcel
      cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cM vm cv c1
      caddc co cfz co cC cA cmul co vk csu cM vm cv cfz co cC cA cmul co vk csu
      vk vm cv c1 caddc co cC cA cmul co csb caddc co wceq cC cc wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral wa cC cM vm cv cfz co cA vk csu
      cmul co cM vm cv cfz co cC cA cmul co vk csu wceq wi vm cv cM cuz cfv
      wcel cC cA cmul co cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv
      c1 caddc co cfz co cC cA cmul co vk csu cM vm cv cfz co cC cA cmul co vk
      csu vk vm cv c1 caddc co cC cA cmul co csb caddc co wceq cC cc wcel cA cc
      wcel vk cM vm cv c1 caddc co cfz co wral wa cC cA cmul co cc vk cM vm cv
      fsump1s cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cC
      cc wcel cA cc wcel wa vk cM vm cv c1 caddc co cfz co wral cC cA cmul co
      cc wcel vk cM vm cv c1 caddc co cfz co wral cC cc wcel cA cc wcel vk cM
      vm cv c1 caddc co cfz co r19.28av cC cc wcel cA cc wcel wa cC cA cmul co
      cc wcel vk cM vm cv c1 caddc co cfz co cC cA mulcl r19.20si syl sylan2
      adantlr 3eqtr4d exp31 syld vj cv cM wceq cC cc wcel cA cc wcel vk cM vj
      cv cfz co wral wa cC cc wcel cA cc wcel vk cM cM cfz co wral wa cC cM vj
      cv cfz co cA vk csu cmul co cM vj cv cfz co cC cA cmul co vk csu wceq cC
      cM cM cfz co cA vk csu cmul co cM cM cfz co cC cA cmul co vk csu wceq vj
      cv cM wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM cM cfz co
      wral cC cc wcel vj cv cM wceq cA cc wcel vk cM vj cv cfz co cM cM cfz co
      vj cv cM cM cfz opreq2 raleq1d anbi2d vj cv cM wceq cC cM vj cv cfz co cA
      vk csu cmul co cC cM cM cfz co cA vk csu cmul co cM vj cv cfz co cC cA
      cmul co vk csu cM cM cfz co cC cA cmul co vk csu vj cv cM wceq cM vj cv
      cfz co cA vk csu cM cM cfz co cA vk csu cC cmul vj cv cM wceq cM vj cv
      cfz co cM cM cfz co cA vk vj cv cM cM cfz opreq2 sumeq1d opreq2d vj cv cM
      wceq cM vj cv cfz co cM cM cfz co cC cA cmul co vk vj cv cM cM cfz opreq2
      sumeq1d eqeq12d imbi12d vj cv vm cv wceq cC cc wcel cA cc wcel vk cM vj
      cv cfz co wral wa cC cc wcel cA cc wcel vk cM vm cv cfz co wral wa cC cM
      vj cv cfz co cA vk csu cmul co cM vj cv cfz co cC cA cmul co vk csu wceq
      cC cM vm cv cfz co cA vk csu cmul co cM vm cv cfz co cC cA cmul co vk csu
      wceq vj cv vm cv wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM
      vm cv cfz co wral cC cc wcel vj cv vm cv wceq cA cc wcel vk cM vj cv cfz
      co cM vm cv cfz co vj cv vm cv cM cfz opreq2 raleq1d anbi2d vj cv vm cv
      wceq cC cM vj cv cfz co cA vk csu cmul co cC cM vm cv cfz co cA vk csu
      cmul co cM vj cv cfz co cC cA cmul co vk csu cM vm cv cfz co cC cA cmul
      co vk csu vj cv vm cv wceq cM vj cv cfz co cA vk csu cM vm cv cfz co cA
      vk csu cC cmul vj cv vm cv wceq cM vj cv cfz co cM vm cv cfz co cA vk vj
      cv vm cv cM cfz opreq2 sumeq1d opreq2d vj cv vm cv wceq cM vj cv cfz co
      cM vm cv cfz co cC cA cmul co vk vj cv vm cv cM cfz opreq2 sumeq1d
      eqeq12d imbi12d vj cv vm cv c1 caddc co wceq cC cc wcel cA cc wcel vk cM
      vj cv cfz co wral wa cC cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co
      wral wa cC cM vj cv cfz co cA vk csu cmul co cM vj cv cfz co cC cA cmul
      co vk csu wceq cC cM vm cv c1 caddc co cfz co cA vk csu cmul co cM vm cv
      c1 caddc co cfz co cC cA cmul co vk csu wceq vj cv vm cv c1 caddc co wceq
      cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM vm cv c1 caddc co cfz
      co wral cC cc wcel vj cv vm cv c1 caddc co wceq cA cc wcel vk cM vj cv
      cfz co cM vm cv c1 caddc co cfz co vj cv vm cv c1 caddc co cM cfz opreq2
      raleq1d anbi2d vj cv vm cv c1 caddc co wceq cC cM vj cv cfz co cA vk csu
      cmul co cC cM vm cv c1 caddc co cfz co cA vk csu cmul co cM vj cv cfz co
      cC cA cmul co vk csu cM vm cv c1 caddc co cfz co cC cA cmul co vk csu vj
      cv vm cv c1 caddc co wceq cM vj cv cfz co cA vk csu cM vm cv c1 caddc co
      cfz co cA vk csu cC cmul vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM
      vm cv c1 caddc co cfz co cA vk vj cv vm cv c1 caddc co cM cfz opreq2
      sumeq1d opreq2d vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1
      caddc co cfz co cC cA cmul co vk vj cv vm cv c1 caddc co cM cfz opreq2
      sumeq1d eqeq12d imbi12d vj cv cN wceq cC cc wcel cA cc wcel vk cM vj cv
      cfz co wral wa cC cc wcel cA cc wcel vk cM cN cfz co wral wa cC cM vj cv
      cfz co cA vk csu cmul co cM vj cv cfz co cC cA cmul co vk csu wceq cC cM
      cN cfz co cA vk csu cmul co cM cN cfz co cC cA cmul co vk csu wceq vj cv
      cN wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM cN cfz co
      wral cC cc wcel vj cv cN wceq cA cc wcel vk cM vj cv cfz co cM cN cfz co
      vj cv cN cM cfz opreq2 raleq1d anbi2d vj cv cN wceq cC cM vj cv cfz co cA
      vk csu cmul co cC cM cN cfz co cA vk csu cmul co cM vj cv cfz co cC cA
      cmul co vk csu cM cN cfz co cC cA cmul co vk csu vj cv cN wceq cM vj cv
      cfz co cA vk csu cM cN cfz co cA vk csu cC cmul vj cv cN wceq cM vj cv
      cfz co cM cN cfz co cA vk vj cv cN cM cfz opreq2 sumeq1d opreq2d vj cv cN
      wceq cM vj cv cfz co cM cN cfz co cC cA cmul co vk vj cv cN cM cfz opreq2
      sumeq1d eqeq12d imbi12d uzind4ALT 3impib $.
      $( [16-Jan-2006] $) $( [12-Nov-2005] $)

    $( A finite sum multiplied by a constant. $)
    fsummulc2 $p |- ( ( N e. ( ZZ>= ` M ) /\ C e. CC /\
                      A. k e. ( M ... N ) A e. CC ) ->
   ( sum_ k e. ( M ... N ) A x. C ) = sum_ k e. ( M ... N ) ( A x. C ) ) $=
      cN cM cuz cfv wcel cC cc wcel cA cc wcel vk cM cN cfz co wral w3a cC cM
      cN cfz co cA vk csu cmul co cM cN cfz co cC cA cmul co vk csu cM cN cfz
      co cA vk csu cC cmul co cM cN cfz co cA cC cmul co vk csu cA cC vk cM cN
      fsummulc1 cC cc wcel cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral
      cC cM cN cfz co cA vk csu cmul co cM cN cfz co cA vk csu cC cmul co wceq
      cC cc wcel cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral cC cM cN
      cfz co cA vk csu cmul co cM cN cfz co cA vk csu cC cmul co wceq cC cc
      wcel cM cN cfz co cA vk csu cc wcel cC cM cN cfz co cA vk csu cmul co cM
      cN cfz co cA vk csu cC cmul co wceq cN cM cuz cfv wcel cA cc wcel vk cM
      cN cfz co wral wa cC cM cN cfz co cA vk csu mulcom cA vk cM cN fsumcl
      sylan2 3impb 3com12 cC cc wcel cA cc wcel vk cM cN cfz co wral cM cN cfz
      co cC cA cmul co vk csu cM cN cfz co cA cC cmul co vk csu wceq cN cM cuz
      cfv wcel cC cc wcel cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cC cA
      cmul co cA cC cmul co vk cC cc wcel cA cc wcel vk cM cN cfz co wral cC cA
      cmul co cA cC cmul co wceq vk cM cN cfz co wral cC cc wcel cA cc wcel cC
      cA cmul co cA cC cmul co wceq vk cM cN cfz co cC cc wcel cA cc wcel cC cA
      cmul co cA cC cmul co wceq cC cA mulcom ex r19.20sdv imp sumeq2d 3adant1
      3eqtr3d $.
      $( [17-Jan-2006] $) $( [13-Nov-2005] $)

    $( A finite sum divided by a constant. $)
    fsumdivc $p |- ( ( ( N e. ( ZZ>= ` M ) /\ C e. CC ) /\ ( C =/= 0 /\
                      A. k e. ( M ... N ) A e. CC ) ) ->
   ( sum_ k e. ( M ... N ) A / C ) = sum_ k e. ( M ... N ) ( A / C ) ) $=
      cN cM cuz cfv wcel cC cc wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co
      wral wa wa cM cN cfz co cA vk csu c1 cC cdiv co cmul co cM cN cfz co cA
      c1 cC cdiv co cmul co vk csu cM cN cfz co cA vk csu cC cdiv co cM cN cfz
      co cA cC cdiv co vk csu cN cM cuz cfv wcel c1 cC cdiv co cc wcel cA cc
      wcel vk cM cN cfz co wral cM cN cfz co cA vk csu c1 cC cdiv co cmul co cM
      cN cfz co cA c1 cC cdiv co cmul co vk csu wceq cN cM cuz cfv wcel cC cc
      wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co wral wa wa cA c1 cC cdiv co
      vk cM cN fsummulc2 cN cM cuz cfv wcel cC cc wcel cC cc0 wne cA cc wcel vk
      cM cN cfz co wral wa simpll cC cc wcel cC cc0 wne c1 cC cdiv co cc wcel
      cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral cC reccl ad2ant2lr cN
      cM cuz cfv wcel cC cc wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co wral
      simprr syl3anc cM cN cfz co cA vk csu cc wcel cC cc wcel cC cc0 wne cM cN
      cfz co cA vk csu cC cdiv co cM cN cfz co cA vk csu c1 cC cdiv co cmul co
      wceq cN cM cuz cfv wcel cC cc wcel wa cC cc0 wne cA cc wcel vk cM cN cfz
      co wral wa wa cM cN cfz co cA vk csu cC divrec cN cM cuz cfv wcel cA cc
      wcel vk cM cN cfz co wral cM cN cfz co cA vk csu cc wcel cC cc wcel cC
      cc0 wne cA vk cM cN fsumcl ad2ant2rl cN cM cuz cfv wcel cC cc wcel cC cc0
      wne cA cc wcel vk cM cN cfz co wral wa simplr cN cM cuz cfv wcel cC cc
      wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co wral simprl syl3anc cC cc
      wcel cC cc0 wne cA cc wcel vk cM cN cfz co wral wa cM cN cfz co cA cC
      cdiv co vk csu cM cN cfz co cA c1 cC cdiv co cmul co vk csu wceq cN cM
      cuz cfv wcel cC cc wcel cC cc0 wne cA cc wcel vk cM cN cfz co wral wa wa
      cM cN cfz co cA cC cdiv co cA c1 cC cdiv co cmul co vk cC cc wcel cC cc0
      wne cA cc wcel vk cM cN cfz co wral cA cC cdiv co cA c1 cC cdiv co cmul
      co wceq vk cM cN cfz co wral cC cc wcel cC cc0 wne wa cA cc wcel vk cM cN
      cfz co wral cA cC cdiv co cA c1 cC cdiv co cmul co wceq vk cM cN cfz co
      wral cC cc wcel cC cc0 wne wa cA cc wcel cA cC cdiv co cA c1 cC cdiv co
      cmul co wceq vk cM cN cfz co cA cc wcel cC cc wcel cC cc0 wne wa cA cC
      cdiv co cA c1 cC cdiv co cmul co wceq cA cc wcel cC cc wcel cC cc0 wne cA
      cC cdiv co cA c1 cC cdiv co cmul co wceq cA cC divrec 3expb expcom
      r19.20sdv imp anasss sumeq2d adantll 3eqtr4d $.
      $( [20-Jan-2006] $) $( [2-Jan-2006] $)

    $( A finite sum divided by a constant.  (An experiment: this version
       of ~ fsumdivc adds 5 bytes and 233 bytes to the compressed and
       uncompressed proofs, but saves 540 bytes on the HTML page.) $)
    fsumdivcALT $p |- ( ( ( N e. ( ZZ>= ` M ) /\ C e. CC ) /\ ( C =/= 0 /\
                      A. k e. ( M ... N ) A e. CC ) ) ->
   ( sum_ k e. ( M ... N ) A / C ) = sum_ k e. ( M ... N ) ( A / C ) ) $=
      cN cM cuz cfv wcel cC cc wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co
      wral wa wa cM cN cfz co cA vk csu c1 cC cdiv co cmul co cM cN cfz co cA
      c1 cC cdiv co cmul co vk csu cM cN cfz co cA vk csu cC cdiv co cM cN cfz
      co cA cC cdiv co vk csu cN cM cuz cfv wcel c1 cC cdiv co cc wcel cA cc
      wcel vk cM cN cfz co wral cM cN cfz co cA vk csu c1 cC cdiv co cmul co cM
      cN cfz co cA c1 cC cdiv co cmul co vk csu wceq cN cM cuz cfv wcel cC cc
      wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co wral wa wa cA c1 cC cdiv co
      vk cM cN fsummulc2 cN cM cuz cfv wcel cC cc wcel cC cc0 wne cA cc wcel vk
      cM cN cfz co wral wa simpll cC cc wcel cC cc0 wne c1 cC cdiv co cc wcel
      cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral cC reccl ad2ant2lr cN
      cM cuz cfv wcel cC cc wcel wa cC cc0 wne cA cc wcel vk cM cN cfz co wral
      simprr syl3anc cM cN cfz co cA vk csu cc wcel cC cc wcel cC cc0 wne wa cM
      cN cfz co cA vk csu cC cdiv co cM cN cfz co cA vk csu c1 cC cdiv co cmul
      co wceq cN cM cuz cfv wcel cC cc wcel wa cC cc0 wne cA cc wcel vk cM cN
      cfz co wral wa wa cM cN cfz co cA vk csu cc wcel cC cc wcel cC cc0 wne cM
      cN cfz co cA vk csu cC cdiv co cM cN cfz co cA vk csu c1 cC cdiv co cmul
      co wceq cM cN cfz co cA vk csu cC divrec 3expb cN cM cuz cfv wcel cA cc
      wcel vk cM cN cfz co wral cM cN cfz co cA vk csu cc wcel cC cc wcel cC
      cc0 wne cA vk cM cN fsumcl ad2ant2rl cN cM cuz cfv wcel cC cc wcel wa cC
      cc wcel cC cc0 wne cA cc wcel vk cM cN cfz co wral wa cC cc0 wne cN cM
      cuz cfv wcel cC cc wcel pm3.27 cC cc0 wne cA cc wcel vk cM cN cfz co wral
      pm3.26 anim12i sylanc cC cc wcel cC cc0 wne cA cc wcel vk cM cN cfz co
      wral wa cM cN cfz co cA cC cdiv co vk csu cM cN cfz co cA c1 cC cdiv co
      cmul co vk csu wceq cN cM cuz cfv wcel cC cc wcel cC cc0 wne cA cc wcel
      vk cM cN cfz co wral wa wa cM cN cfz co cA cC cdiv co cA c1 cC cdiv co
      cmul co vk cC cc wcel cC cc0 wne cA cc wcel vk cM cN cfz co wral cA cC
      cdiv co cA c1 cC cdiv co cmul co wceq vk cM cN cfz co wral cC cc wcel cC
      cc0 wne wa cA cc wcel vk cM cN cfz co wral cA cC cdiv co cA c1 cC cdiv co
      cmul co wceq vk cM cN cfz co wral cC cc wcel cC cc0 wne wa cA cc wcel cA
      cC cdiv co cA c1 cC cdiv co cmul co wceq vk cM cN cfz co cA cc wcel cC cc
      wcel cC cc0 wne wa cA cC cdiv co cA c1 cC cdiv co cmul co wceq cA cc wcel
      cC cc wcel cC cc0 wne cA cC cdiv co cA c1 cC cdiv co cmul co wceq cA cC
      divrec 3expb expcom r19.20sdv imp anasss sumeq2d adantll 3eqtr4d $.
      $( [5-Nov-2006] $) $( [2-Jan-2006] $)
  $}

  ${
    $d m A $.  $d j B $.  $d j J $.  $d j K $.  $d j m M $.  $d j m N $.
    $( Separate the nested sum of the product ` A ( j ) x. B ( m ) ` . $)
    fsum2mul $p |- ( ( ( K e. ( ZZ>= ` J ) /\ A. j e. ( J ... K ) A e. CC ) /\
       ( N e. ( ZZ>= ` M ) /\ A. m e. ( M ... N ) B e. CC ) ) ->
    sum_ j e. ( J ... K ) sum_ m e. ( M ... N ) ( A x. B ) =
    ( sum_ j e. ( J ... K ) A x. sum_ m e. ( M ... N ) B ) ) $=
      cK cJ cuz cfv wcel cA cc wcel vj cJ cK cfz co wral wa cN cM cuz cfv wcel
      cB cc wcel vm cM cN cfz co wral wa wa cJ cK cfz co cA vj csu cM cN cfz co
      cB vm csu cmul co cJ cK cfz co cA cM cN cfz co cB vm csu cmul co vj csu
      cJ cK cfz co cM cN cfz co cA cB cmul co vm csu vj csu cK cJ cuz cfv wcel
      cA cc wcel vj cJ cK cfz co wral wa cM cN cfz co cB vm csu cc wcel cJ cK
      cfz co cA vj csu cM cN cfz co cB vm csu cmul co cJ cK cfz co cA cM cN cfz
      co cB vm csu cmul co vj csu wceq cN cM cuz cfv wcel cB cc wcel vm cM cN
      cfz co wral wa cK cJ cuz cfv wcel cM cN cfz co cB vm csu cc wcel cA cc
      wcel vj cJ cK cfz co wral cJ cK cfz co cA vj csu cM cN cfz co cB vm csu
      cmul co cJ cK cfz co cA cM cN cfz co cB vm csu cmul co vj csu wceq cK cJ
      cuz cfv wcel cM cN cfz co cB vm csu cc wcel cA cc wcel vj cJ cK cfz co
      wral cJ cK cfz co cA vj csu cM cN cfz co cB vm csu cmul co cJ cK cfz co
      cA cM cN cfz co cB vm csu cmul co vj csu wceq cA cM cN cfz co cB vm csu
      vj cJ cK fsummulc2 3expa an1rs cB vm cM cN fsumcl sylan2 cA cc wcel vj cJ
      cK cfz co wral cN cM cuz cfv wcel cB cc wcel vm cM cN cfz co wral wa cJ
      cK cfz co cA cM cN cfz co cB vm csu cmul co vj csu cJ cK cfz co cM cN cfz
      co cA cB cmul co vm csu vj csu wceq cK cJ cuz cfv wcel cA cc wcel vj cJ
      cK cfz co wral cN cM cuz cfv wcel cB cc wcel vm cM cN cfz co wral wa wa
      cJ cK cfz co cA cM cN cfz co cB vm csu cmul co cM cN cfz co cA cB cmul co
      vm csu vj cN cM cuz cfv wcel cB cc wcel vm cM cN cfz co wral wa cA cc
      wcel vj cJ cK cfz co wral cA cM cN cfz co cB vm csu cmul co cM cN cfz co
      cA cB cmul co vm csu wceq vj cJ cK cfz co wral cN cM cuz cfv wcel cB cc
      wcel vm cM cN cfz co wral wa cA cc wcel cA cM cN cfz co cB vm csu cmul co
      cM cN cfz co cA cB cmul co vm csu wceq vj cJ cK cfz co cN cM cuz cfv wcel
      cB cc wcel vm cM cN cfz co wral wa cA cc wcel cA cM cN cfz co cB vm csu
      cmul co cM cN cfz co cA cB cmul co vm csu wceq cN cM cuz cfv wcel cA cc
      wcel cB cc wcel vm cM cN cfz co wral cA cM cN cfz co cB vm csu cmul co cM
      cN cfz co cA cB cmul co vm csu wceq cN cM cuz cfv wcel cA cc wcel cB cc
      wcel vm cM cN cfz co wral cA cM cN cfz co cB vm csu cmul co cM cN cfz co
      cA cB cmul co vm csu wceq cB cA vm cM cN fsummulc1 3expa an1rs ex
      r19.20sdv impcom sumeq2d adantll eqtr2d $.
      $( [20-Jan-2006] $) $( [13-Nov-2005] $)
  $}

  ${
    $d j k m A $.  $d j k m M $.  $d j k N $.
    $( The sum of constant terms ( ` k ` is not free in ` A ` ). $)
    fsumconst $p |- ( ( N e. ( ZZ>= ` M ) /\ A e. CC ) ->
                    sum_ k e. ( M ... N ) A = ( ( ( N - M ) + 1 ) x. A ) ) $=
      cN cM cuz cfv wcel cA cc wcel cM cN cfz co cA vk csu cN cM cmin co c1
      caddc co cA cmul co wceq cA cc wcel cM vj cv cfz co cA vk csu vj cv cM
      cmin co c1 caddc co cA cmul co wceq wi cA cc wcel cM cM cfz co cA vk csu
      cM cM cmin co c1 caddc co cA cmul co wceq wi cA cc wcel cM vm cv cfz co
      cA vk csu vm cv cM cmin co c1 caddc co cA cmul co wceq wi cA cc wcel cM
      vm cv c1 caddc co cfz co cA vk csu vm cv c1 caddc co cM cmin co c1 caddc
      co cA cmul co wceq wi cA cc wcel cM cN cfz co cA vk csu cN cM cmin co c1
      caddc co cA cmul co wceq wi vj vm cM cN vj cv cM wceq cM vj cv cfz co cA
      vk csu vj cv cM cmin co c1 caddc co cA cmul co wceq cM cM cfz co cA vk
      csu cM cM cmin co c1 caddc co cA cmul co wceq cA cc wcel vj cv cM wceq cM
      vj cv cfz co cA vk csu cM cM cfz co cA vk csu vj cv cM cmin co c1 caddc
      co cA cmul co cM cM cmin co c1 caddc co cA cmul co vj cv cM wceq cM vj cv
      cfz co cM cM cfz co cA vk vj cv cM cM cfz opreq2 sumeq1d vj cv cM wceq vj
      cv cM cmin co c1 caddc co cM cM cmin co c1 caddc co cA cmul vj cv cM wceq
      vj cv cM cmin co cM cM cmin co c1 caddc vj cv cM cM cmin opreq1 opreq1d
      opreq1d eqeq12d imbi2d vj cv vm cv wceq cM vj cv cfz co cA vk csu vj cv
      cM cmin co c1 caddc co cA cmul co wceq cM vm cv cfz co cA vk csu vm cv cM
      cmin co c1 caddc co cA cmul co wceq cA cc wcel vj cv vm cv wceq cM vj cv
      cfz co cA vk csu cM vm cv cfz co cA vk csu vj cv cM cmin co c1 caddc co
      cA cmul co vm cv cM cmin co c1 caddc co cA cmul co vj cv vm cv wceq cM vj
      cv cfz co cM vm cv cfz co cA vk vj cv vm cv cM cfz opreq2 sumeq1d vj cv
      vm cv wceq vj cv cM cmin co c1 caddc co vm cv cM cmin co c1 caddc co cA
      cmul vj cv vm cv wceq vj cv cM cmin co vm cv cM cmin co c1 caddc vj cv vm
      cv cM cmin opreq1 opreq1d opreq1d eqeq12d imbi2d vj cv vm cv c1 caddc co
      wceq cM vj cv cfz co cA vk csu vj cv cM cmin co c1 caddc co cA cmul co
      wceq cM vm cv c1 caddc co cfz co cA vk csu vm cv c1 caddc co cM cmin co
      c1 caddc co cA cmul co wceq cA cc wcel vj cv vm cv c1 caddc co wceq cM vj
      cv cfz co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu vj cv cM cmin
      co c1 caddc co cA cmul co vm cv c1 caddc co cM cmin co c1 caddc co cA
      cmul co vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co
      cfz co cA vk vj cv vm cv c1 caddc co cM cfz opreq2 sumeq1d vj cv vm cv c1
      caddc co wceq vj cv cM cmin co c1 caddc co vm cv c1 caddc co cM cmin co
      c1 caddc co cA cmul vj cv vm cv c1 caddc co wceq vj cv cM cmin co vm cv
      c1 caddc co cM cmin co c1 caddc vj cv vm cv c1 caddc co cM cmin opreq1
      opreq1d opreq1d eqeq12d imbi2d vj cv cN wceq cM vj cv cfz co cA vk csu vj
      cv cM cmin co c1 caddc co cA cmul co wceq cM cN cfz co cA vk csu cN cM
      cmin co c1 caddc co cA cmul co wceq cA cc wcel vj cv cN wceq cM vj cv cfz
      co cA vk csu cM cN cfz co cA vk csu vj cv cM cmin co c1 caddc co cA cmul
      co cN cM cmin co c1 caddc co cA cmul co vj cv cN wceq cM vj cv cfz co cM
      cN cfz co cA vk vj cv cN cM cfz opreq2 sumeq1d vj cv cN wceq vj cv cM
      cmin co c1 caddc co cN cM cmin co c1 caddc co cA cmul vj cv cN wceq vj cv
      cM cmin co cN cM cmin co c1 caddc vj cv cN cM cmin opreq1 opreq1d opreq1d
      eqeq12d imbi2d cM cz wcel cA cc wcel cM cM cfz co cA vk csu cM cM cmin co
      c1 caddc co cA cmul co wceq cM cz wcel cA cc wcel wa cM cM cfz co cA vk
      csu cA cM cM cmin co c1 caddc co cA cmul co cA cc wcel cM cz wcel cM cM
      cfz co cA vk csu cA wceq cA cA cc vk cM vk cv cM wceq cA eqidd fsum1i
      ancoms cM cc wcel cA cc wcel cM cM cmin co c1 caddc co cA cmul co cA wceq
      cM cz wcel cM cc wcel cA cc wcel cM cM cmin co c1 caddc co cA cmul co c1
      cA cmul co cA cM cc wcel cM cM cmin co c1 caddc co c1 cA cmul cM cc wcel
      cM cM cmin co c1 caddc co cc0 c1 caddc co c1 cM cc wcel cM cM cmin co cc0
      c1 caddc cM subid opreq1d c1 ax1cn addid2i syl6eq opreq1d cA mulid2
      sylan9eq cM zcn sylan eqtr4d ex vm cv cM cuz cfv wcel cA cc wcel cM vm cv
      cfz co cA vk csu vm cv cM cmin co c1 caddc co cA cmul co wceq cM vm cv c1
      caddc co cfz co cA vk csu vm cv c1 caddc co cM cmin co c1 caddc co cA
      cmul co wceq vm cv cM cuz cfv wcel cA cc wcel cM vm cv cfz co cA vk csu
      vm cv cM cmin co c1 caddc co cA cmul co wceq cM vm cv c1 caddc co cfz co
      cA vk csu vm cv c1 caddc co cM cmin co c1 caddc co cA cmul co wceq vm cv
      cM cuz cfv wcel cA cc wcel wa cM vm cv cfz co cA vk csu vm cv cM cmin co
      c1 caddc co cA cmul co wceq wa cM vm cv c1 caddc co cfz co cA vk csu vm
      cv cM cmin co c1 caddc co cA cmul co cA caddc co vm cv c1 caddc co cM
      cmin co c1 caddc co cA cmul co vm cv cM cuz cfv wcel cA cc wcel wa cM vm
      cv cfz co cA vk csu vm cv cM cmin co c1 caddc co cA cmul co wceq cM vm cv
      c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu cA caddc co vm cv
      cM cmin co c1 caddc co cA cmul co cA caddc co vm cv cM cuz cfv wcel cA cc
      wcel wa cM vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu
      vk vm cv c1 caddc co cA csb caddc co cM vm cv cfz co cA vk csu cA caddc
      co vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral
      cM vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk csu vk vm cv
      c1 caddc co cA csb caddc co wceq cA cc wcel cA cc vk cM vm cv fsump1s cA
      cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cA cc wcel vk cv cM vm
      cv c1 caddc co cfz co wcel ax-1 r19.21aiv sylan2 vk vm cv c1 caddc co cA
      csb cA cM vm cv cfz co cA vk csu caddc vm cv c1 caddc co cvv wcel vk vm
      cv c1 caddc co cA csb cA wceq vm cv c1 caddc oprex vk vj vm cv c1 caddc
      co cA cvv vj cv cA wcel vk ax-17 csbconstgf ax-mp opreq2i syl6eq cM vm cv
      cfz co cA vk csu vm cv cM cmin co c1 caddc co cA cmul co cA caddc opreq1
      sylan9eq vm cv cM cuz cfv wcel cA cc wcel wa vm cv c1 caddc co cM cmin co
      c1 caddc co cA cmul co vm cv cM cmin co c1 caddc co cA cmul co cA caddc
      co wceq cM vm cv cfz co cA vk csu vm cv cM cmin co c1 caddc co cA cmul co
      wceq vm cv cc wcel cM cc wcel wa cA cc wcel vm cv c1 caddc co cM cmin co
      c1 caddc co cA cmul co vm cv cM cmin co c1 caddc co cA cmul co cA caddc
      co wceq vm cv cM cuz cfv wcel vm cv cc wcel cM cc wcel wa cA cc wcel wa
      vm cv c1 caddc co cM cmin co c1 caddc co cA cmul co vm cv cM cmin co c1
      caddc co c1 caddc co cA cmul co vm cv cM cmin co c1 caddc co cA cmul co
      c1 cA cmul co caddc co vm cv cM cmin co c1 caddc co cA cmul co cA caddc
      co vm cv cc wcel cM cc wcel wa cA cc wcel wa vm cv c1 caddc co cM cmin co
      c1 caddc co vm cv cM cmin co c1 caddc co c1 caddc co cA cmul vm cv cc
      wcel cM cc wcel wa cA cc wcel wa vm cv c1 caddc co cM cmin co vm cv cM
      cmin co c1 caddc co c1 caddc vm cv cc wcel cM cc wcel wa vm cv c1 caddc
      co cM cmin co vm cv cM cmin co c1 caddc co wceq cA cc wcel vm cv cc wcel
      c1 cc wcel cM cc wcel vm cv c1 caddc co cM cmin co vm cv cM cmin co c1
      caddc co wceq ax1cn vm cv c1 cM addsub mp3an2 adantr opreq1d opreq1d vm
      cv cM cmin co c1 caddc co cc wcel cA cc wcel vm cv cM cmin co c1 caddc co
      c1 caddc co cA cmul co vm cv cM cmin co c1 caddc co cA cmul co c1 cA cmul
      co caddc co wceq vm cv cc wcel cM cc wcel wa vm cv cM cmin co c1 caddc co
      cc wcel c1 cc wcel cA cc wcel vm cv cM cmin co c1 caddc co c1 caddc co cA
      cmul co vm cv cM cmin co c1 caddc co cA cmul co c1 cA cmul co caddc co
      wceq ax1cn vm cv cM cmin co c1 caddc co c1 cA adddir mp3an2 vm cv cc wcel
      cM cc wcel wa vm cv cM cmin co cc wcel vm cv cM cmin co c1 caddc co cc
      wcel vm cv cM subcl vm cv cM cmin co peano2cn syl sylan cA cc wcel vm cv
      cM cmin co c1 caddc co cA cmul co c1 cA cmul co caddc co vm cv cM cmin co
      c1 caddc co cA cmul co cA caddc co wceq vm cv cc wcel cM cc wcel wa cA cc
      wcel c1 cA cmul co cA vm cv cM cmin co c1 caddc co cA cmul co caddc cA
      mulid2 opreq2d adantl 3eqtrd vm cv cM cuz cfv wcel vm cv cc wcel cM cc
      wcel vm cv cM cuz cfv wcel vm cv cz wcel vm cv cc wcel cM vm cv eluzelz
      vm cv zcn syl vm cv cM cuz cfv wcel cM cz wcel cM cc wcel cM vm cv
      eluzel2 cM zcn syl jca sylan adantr eqtr4d exp31 a2d uzind4 imp $.
      $( [22-Jan-2006] $) $( [24-Dec-2005] $)
  $}

  ${
    $d k M $.  $d k N $.
    $( If all of the terms of a finite sum are zero, so is the sum. $)
    fsum0 $p |- ( N e. ( ZZ>= ` M ) -> sum_ k e. ( M ... N ) 0 = 0 ) $=
      cN cM cuz cfv wcel cM cN cfz co cc0 vk csu cN cM cmin co c1 caddc co cc0
      cmul co cc0 cN cM cuz cfv wcel cc0 cc wcel cM cN cfz co cc0 vk csu cN cM
      cmin co c1 caddc co cc0 cmul co wceq 0cn cc0 vk cM cN fsumconst mpan2 cN
      cM cuz cfv wcel cN cM cmin co cc wcel cN cM cmin co c1 caddc co cc wcel
      cN cM cmin co c1 caddc co cc0 cmul co cc0 wceq cN cM cuz cfv wcel cN cM
      cmin co cz wcel cN cM cmin co cc wcel cN cz wcel cM cz wcel cN cM cmin co
      cz wcel cN cM cuz cfv wcel cN cM zsubcl cM cN eluzelz cM cN eluzel2
      sylanc cN cM cmin co zcn syl cN cM cmin co peano2cn cN cM cmin co c1
      caddc co mul01 3syl eqtrd $.
      $( [17-Jul-2006] $) $( [26-Dec-2005] $)
  $}

  ${
    $d j m A $.  $d j m B $.  $d j k m M $.  $d j k N $.
    $( If all of the terms of finite sums compare, so do the sums. $)
    fsumcmp $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
         ( A e. RR /\ B e. RR /\ A <_ B ) ) ->
           sum_ k e. ( M ... N ) A <_ sum_ k e. ( M ... N ) B ) $=
      cN cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM cN cfz
      co wral cM cN cfz co cA vk csu cM cN cfz co cB vk csu cle wbr cA cr wcel
      cB cr wcel cA cB cle wbr w3a vk cM vj cv cfz co wral cM vj cv cfz co cA
      vk csu cM vj cv cfz co cB vk csu cle wbr wi cA cr wcel cB cr wcel cA cB
      cle wbr w3a vk cM cM cfz co wral cM cM cfz co cA vk csu cM cM cfz co cB
      vk csu cle wbr wi cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv cfz
      co wral cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu cle wbr wi cA
      cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral
      cM vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk
      csu cle wbr wi cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM cN cfz co
      wral cM cN cfz co cA vk csu cM cN cfz co cB vk csu cle wbr wi vj vm cM cN
      cM cz wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM cM cfz co wral
      cM cM cfz co cA vk csu cM cM cfz co cB vk csu cle wbr cM cz wcel cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM cM cfz co wral wa vk cM cA csb vk
      cM cB csb cM cM cfz co cA vk csu cM cM cfz co cB vk csu cle cM cz wcel cA
      cr wcel cB cr wcel cA cB cle wbr w3a vk cM cM cfz co wral wa cA cB cle
      wbr vk cM wsbc vk cM cA csb vk cM cB csb cle wbr cM cM cM cfz co wcel cA
      cB cle wbr vk cM cM cfz co wral cA cB cle wbr vk cM wsbc cM cz wcel cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM cM cfz co wral cA cB cle wbr vk
      cM cM cM cfz co ra4sbca cM elfz3 cA cr wcel cB cr wcel cA cB cle wbr w3a
      cA cB cle wbr vk cM cM cfz co cA cr wcel cB cr wcel cA cB cle wbr 3simp3
      r19.20si syl2an cM cz wcel cA cB cle wbr vk cM wsbc vk cM cA csb vk cM cB
      csb cle wbr wb cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM cM cfz co
      wral vk cM cA cB cz cle sbcbr12g adantr mpbid cM cz wcel cA cr wcel vk cM
      cM cfz co wral cM cM cfz co cA vk csu vk cM cA csb wceq cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM cM cfz co wral cA cr vk cM fsum1s cA cr wcel
      cB cr wcel cA cB cle wbr w3a cA cr wcel vk cM cM cfz co cA cr wcel cB cr
      wcel cA cB cle wbr 3simp1 r19.20si sylan2 cM cz wcel cB cr wcel vk cM cM
      cfz co wral cM cM cfz co cB vk csu vk cM cB csb wceq cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM cM cfz co wral cB cr vk cM fsum1s cA cr wcel
      cB cr wcel cA cB cle wbr w3a cB cr wcel vk cM cM cfz co cA cr wcel cB cr
      wcel cA cB cle wbr 3simp2 r19.20si sylan2 3brtr4d ex vm cv cM cuz cfv
      wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv cfz co wral cM
      vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu cle wbr wi cA cr wcel cB
      cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cM vm cv
      cfz co cA vk csu cM vm cv cfz co cB vk csu cle wbr wi cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cM vm cv c1
      caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu cle wbr
      wi vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm
      cv c1 caddc co cfz co wral cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu cle
      wbr vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co cM vm cv
      cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv c1
      caddc co cfz co wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vm cv cM cuz
      cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel vm
      cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm cv cM cuz
      cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz sylanc sseld
      imim1d r19.20dv2 imim1d vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB
      cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk csu
      cM vm cv cfz co cB vk csu cle wbr cM vm cv c1 caddc co cfz co cA vk csu
      cM vm cv c1 caddc co cfz co cB vk csu cle wbr vm cv cM cuz cfv wcel cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cM
      vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu cle wbr cM vm cv c1
      caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu cle wbr
      vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv
      c1 caddc co cfz co wral wa cM vm cv cfz co cA vk csu cM vm cv cfz co cB
      vk csu cle wbr wa cM vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co
      cB vk csu vk vm cv c1 caddc co cA csb caddc co cle wbr cM vm cv cfz co cB
      vk csu vk vm cv c1 caddc co cA csb caddc co cM vm cv c1 caddc co cfz co
      cB vk csu cle wbr cM vm cv c1 caddc co cfz co cA vk csu cM vm cv c1 caddc
      co cfz co cB vk csu cle wbr vm cv cM cuz cfv wcel cA cr wcel cB cr wcel
      cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co
      cA vk csu cM vm cv cfz co cB vk csu cle wbr wa cM vm cv c1 caddc co cfz
      co cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc
      co cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb caddc co cle vm
      cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1
      caddc co cfz co wral wa cM vm cv c1 caddc co cfz co cA vk csu cM vm cv
      cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co wceq cM vm cv cfz
      co cA vk csu cM vm cv cfz co cB vk csu cle wbr vm cv cM cuz cfv wcel cA
      cr wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co
      cA vk csu cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co
      wceq cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz
      co wral cA cr vk cM vm cv fsump1s cA cr wcel cB cr wcel cA cB cle wbr w3a
      cA cr wcel vk cM vm cv c1 caddc co cfz co cA cr wcel cB cr wcel cA cB cle
      wbr 3simp1 r19.20si sylan2 adantr vm cv cM cuz cfv wcel cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv
      cfz co cA vk csu cM vm cv cfz co cB vk csu cle wbr wa cM vm cv cfz co cA
      vk csu cM vm cv cfz co cB vk csu cle wbr cM vm cv cfz co cA vk csu vk vm
      cv c1 caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk vm cv c1
      caddc co cA csb caddc co cle wbr vm cv cM cuz cfv wcel cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv
      cfz co cA vk csu cM vm cv cfz co cB vk csu cle wbr pm3.27 cM vm cv cfz co
      cA vk csu cr wcel cM vm cv cfz co cB vk csu cr wcel vk vm cv c1 caddc co
      cA csb cr wcel cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu cle
      wbr cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co cM vm
      cv cfz co cB vk csu vk vm cv c1 caddc co cA csb caddc co cle wbr wb vm cv
      cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1
      caddc co cfz co wral wa cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk
      csu cle wbr wa cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu vk vm
      cv c1 caddc co cA csb leadd1 vm cv cM cuz cfv wcel cA cr wcel cB cr wcel
      cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co
      cA vk csu cr wcel cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk csu cle
      wbr vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM
      vm cv c1 caddc co cfz co wral cA cr wcel vk cM vm cv cfz co wral cM vm cv
      cfz co cA vk csu cr wcel vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA
      cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cA cr wcel vk cM vm cv
      cfz co wral vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a
      cA cr wcel vk cM vm cv c1 caddc co cfz co cM vm cv cfz co vm cv cM cuz
      cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv c1 caddc co cfz co
      wcel cA cr wcel cB cr wcel cA cB cle wbr w3a cA cr wcel vm cv cM cuz cfv
      wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel vm cv
      cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm cv cM cuz cfv
      wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz sylanc sseld cA cr
      wcel cB cr wcel cA cB cle wbr w3a cA cr wcel wi vm cv cM cuz cfv wcel cA
      cr wcel cB cr wcel cA cB cle wbr 3simp1 a1i imim12d r19.20dv2 imp cA vk
      cM vm cv fsumrecl syldan adantr vm cv cM cuz cfv wcel cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv
      cfz co cB vk csu cr wcel cM vm cv cfz co cA vk csu cM vm cv cfz co cB vk
      csu cle wbr vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a
      vk cM vm cv c1 caddc co cfz co wral cB cr wcel vk cM vm cv cfz co wral cM
      vm cv cfz co cB vk csu cr wcel vm cv cM cuz cfv wcel cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cB cr wcel vk
      cM vm cv cfz co wral vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB
      cle wbr w3a cB cr wcel vk cM vm cv c1 caddc co cfz co cM vm cv cfz co vm
      cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv c1 caddc co
      cfz co wcel cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr wcel vm cv cM
      cuz cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel
      vm cv cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm cv cM
      cuz cfv wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz sylanc
      sseld cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr wcel wi vm cv cM cuz
      cfv wcel cA cr wcel cB cr wcel cA cB cle wbr 3simp2 a1i imim12d r19.20dv2
      imp cB vk cM vm cv fsumrecl syldan adantr vm cv cM cuz cfv wcel cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa
      vk vm cv c1 caddc co cA csb cr wcel cM vm cv cfz co cA vk csu cM vm cv
      cfz co cB vk csu cle wbr vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cA cr wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co
      cA csb cr wcel vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr
      w3a vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co cM vm cv c1
      caddc co cfz co cA cr ra4csbela vm cv cM cuz cfv wcel vm cv c1 caddc co
      cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cM vm
      cv peano2uz cM vm cv c1 caddc co eluzfz2 syl cA cr wcel cB cr wcel cA cB
      cle wbr w3a cA cr wcel vk cM vm cv c1 caddc co cfz co cA cr wcel cB cr
      wcel cA cB cle wbr 3simp1 r19.20si syl2an adantr syl3anc mpbid eqbrtrd vm
      cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1
      caddc co cfz co wral wa cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA
      csb caddc co cM vm cv c1 caddc co cfz co cB vk csu cle wbr cM vm cv cfz
      co cA vk csu cM vm cv cfz co cB vk csu cle wbr vm cv cM cuz cfv wcel cA
      cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral
      wa cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb caddc co cM vm
      cv cfz co cB vk csu vk vm cv c1 caddc co cB csb caddc co cM vm cv c1
      caddc co cfz co cB vk csu cle vm cv cM cuz cfv wcel cA cr wcel cB cr wcel
      cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa vk vm cv c1
      caddc co cA csb vk vm cv c1 caddc co cB csb cle wbr cM vm cv cfz co cB vk
      csu vk vm cv c1 caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk vm
      cv c1 caddc co cB csb caddc co cle wbr vm cv c1 caddc co cM vm cv c1
      caddc co cfz co wcel cA cB cle wbr vk cM vm cv c1 caddc co cfz co wral vk
      vm cv c1 caddc co cA csb vk vm cv c1 caddc co cB csb cle wbr vm cv cM cuz
      cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co
      cfz co wral vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cA cB cle
      wbr vk cM vm cv c1 caddc co cfz co wral wa cA cB cle wbr vk vm cv c1
      caddc co wsbc vk vm cv c1 caddc co cA csb vk vm cv c1 caddc co cB csb cle
      wbr cA cB cle wbr vk vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      ra4sbca vm cv c1 caddc co cvv wcel cA cB cle wbr vk vm cv c1 caddc co
      wsbc vk vm cv c1 caddc co cA csb vk vm cv c1 caddc co cB csb cle wbr wb
      vm cv c1 caddc oprex vk vm cv c1 caddc co cA cB cvv cle sbcbr12g ax-mp
      sylib vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1
      caddc co cM vm cv c1 caddc co cfz co wcel cM vm cv peano2uz cM vm cv c1
      caddc co eluzfz2 syl cA cr wcel cB cr wcel cA cB cle wbr w3a cA cB cle
      wbr vk cM vm cv c1 caddc co cfz co cA cr wcel cB cr wcel cA cB cle wbr
      3simp3 r19.20si syl2an vk vm cv c1 caddc co cA csb cr wcel vk vm cv c1
      caddc co cB csb cr wcel cM vm cv cfz co cB vk csu cr wcel vk vm cv c1
      caddc co cA csb vk vm cv c1 caddc co cB csb cle wbr cM vm cv cfz co cB vk
      csu vk vm cv c1 caddc co cA csb caddc co cM vm cv cfz co cB vk csu vk vm
      cv c1 caddc co cB csb caddc co cle wbr wb vm cv cM cuz cfv wcel cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa
      vk vm cv c1 caddc co cA csb vk vm cv c1 caddc co cB csb cM vm cv cfz co
      cB vk csu leadd2 vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cA cr
      wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co cA csb cr
      wcel vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM
      vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co cM vm cv c1 caddc co
      cfz co cA cr ra4csbela vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv
      wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cM vm cv peano2uz
      cM vm cv c1 caddc co eluzfz2 syl cA cr wcel cB cr wcel cA cB cle wbr w3a
      cA cr wcel vk cM vm cv c1 caddc co cfz co cA cr wcel cB cr wcel cA cB cle
      wbr 3simp1 r19.20si syl2an vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cB cr wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co
      cB csb cr wcel vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr
      w3a vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co cM vm cv c1
      caddc co cfz co cB cr ra4csbela vm cv cM cuz cfv wcel vm cv c1 caddc co
      cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co wcel cM vm
      cv peano2uz cM vm cv c1 caddc co eluzfz2 syl cA cr wcel cB cr wcel cA cB
      cle wbr w3a cB cr wcel vk cM vm cv c1 caddc co cfz co cA cr wcel cB cr
      wcel cA cB cle wbr 3simp2 r19.20si syl2an vm cv cM cuz cfv wcel cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cB
      cr wcel vk cM vm cv cfz co wral cM vm cv cfz co cB vk csu cr wcel vm cv
      cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1
      caddc co cfz co wral cB cr wcel vk cM vm cv cfz co wral vm cv cM cuz cfv
      wcel cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr wcel vk cM vm cv c1
      caddc co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz
      co wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cr wcel cB cr wcel cA
      cB cle wbr w3a cB cr wcel vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv
      c1 caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm
      cv c1 caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv
      eluzel2 cM vm cv eluzelz sylanc sseld cA cr wcel cB cr wcel cA cB cle wbr
      w3a cB cr wcel wi vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle
      wbr 3simp2 a1i imim12d r19.20dv2 imp cB vk cM vm cv fsumrecl syldan
      syl3anc mpbid vm cv cM cuz cfv wcel cB cr wcel vk cM vm cv c1 caddc co
      cfz co wral cM vm cv c1 caddc co cfz co cB vk csu cM vm cv cfz co cB vk
      csu vk vm cv c1 caddc co cB csb caddc co wceq cA cr wcel cB cr wcel cA cB
      cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cB cr vk cM vm cv fsump1s
      cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr wcel vk cM vm cv c1 caddc
      co cfz co cA cr wcel cB cr wcel cA cB cle wbr 3simp2 r19.20si sylan2
      breqtrrd adantr vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr
      w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv c1 caddc co cfz co cA
      vk csu cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb caddc co cle
      wbr cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb caddc co cM vm
      cv c1 caddc co cfz co cB vk csu cle wbr wa cM vm cv c1 caddc co cfz co cA
      vk csu cM vm cv c1 caddc co cfz co cB vk csu cle wbr wi cM vm cv cfz co
      cA vk csu cM vm cv cfz co cB vk csu cle wbr cM vm cv c1 caddc co cfz co
      cA vk csu cr wcel cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb
      caddc co cr wcel cM vm cv c1 caddc co cfz co cB vk csu cr wcel cM vm cv
      c1 caddc co cfz co cA vk csu cM vm cv cfz co cB vk csu vk vm cv c1 caddc
      co cA csb caddc co cle wbr cM vm cv cfz co cB vk csu vk vm cv c1 caddc co
      cA csb caddc co cM vm cv c1 caddc co cfz co cB vk csu cle wbr wa cM vm cv
      c1 caddc co cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu cle
      wbr wi vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk
      cM vm cv c1 caddc co cfz co wral wa cM vm cv c1 caddc co cfz co cA vk csu
      cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA csb caddc co cM vm cv
      c1 caddc co cfz co cB vk csu letr vm cv c1 caddc co cM cuz cfv wcel cA cr
      wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA
      vk csu cr wcel vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr
      w3a vk cM vm cv c1 caddc co cfz co wral cA vk cM vm cv c1 caddc co
      fsumrecl cM vm cv peano2uz cA cr wcel cB cr wcel cA cB cle wbr w3a cA cr
      wcel vk cM vm cv c1 caddc co cfz co cA cr wcel cB cr wcel cA cB cle wbr
      3simp1 r19.20si syl2an cM vm cv cfz co cB vk csu cr wcel vk vm cv c1
      caddc co cA csb cr wcel cM vm cv cfz co cB vk csu vk vm cv c1 caddc co cA
      csb caddc co cr wcel vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB
      cle wbr w3a vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cB vk
      csu vk vm cv c1 caddc co cA csb readdcl vm cv cM cuz cfv wcel cA cr wcel
      cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cB cr
      wcel vk cM vm cv cfz co wral cM vm cv cfz co cB vk csu cr wcel vm cv cM
      cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc
      co cfz co wral cB cr wcel vk cM vm cv cfz co wral vm cv cM cuz cfv wcel
      cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr wcel vk cM vm cv c1 caddc
      co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz co
      wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cr wcel cB cr wcel cA cB
      cle wbr w3a cB cr wcel vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1
      caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv
      c1 caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv
      eluzel2 cM vm cv eluzelz sylanc sseld cA cr wcel cB cr wcel cA cB cle wbr
      w3a cB cr wcel wi vm cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle
      wbr 3simp2 a1i imim12d r19.20dv2 imp cB vk cM vm cv fsumrecl syldan vm cv
      c1 caddc co cM vm cv c1 caddc co cfz co wcel cA cr wcel vk cM vm cv c1
      caddc co cfz co wral vk vm cv c1 caddc co cA csb cr wcel vm cv cM cuz cfv
      wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz
      co wral vk vm cv c1 caddc co cM vm cv c1 caddc co cfz co cA cr ra4csbela
      vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co
      cM vm cv c1 caddc co cfz co wcel cM vm cv peano2uz cM vm cv c1 caddc co
      eluzfz2 syl cA cr wcel cB cr wcel cA cB cle wbr w3a cA cr wcel vk cM vm
      cv c1 caddc co cfz co cA cr wcel cB cr wcel cA cB cle wbr 3simp1 r19.20si
      syl2an sylanc vm cv c1 caddc co cM cuz cfv wcel cB cr wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cB vk csu cr wcel vm cv
      cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vm cv c1
      caddc co cfz co wral cB vk cM vm cv c1 caddc co fsumrecl cM vm cv
      peano2uz cA cr wcel cB cr wcel cA cB cle wbr w3a cB cr wcel vk cM vm cv
      c1 caddc co cfz co cA cr wcel cB cr wcel cA cB cle wbr 3simp2 r19.20si
      syl2an syl3anc adantr mp2and exp31 a2d syld vj cv cM wceq cA cr wcel cB
      cr wcel cA cB cle wbr w3a vk cM vj cv cfz co wral cA cr wcel cB cr wcel
      cA cB cle wbr w3a vk cM cM cfz co wral cM vj cv cfz co cA vk csu cM vj cv
      cfz co cB vk csu cle wbr cM cM cfz co cA vk csu cM cM cfz co cB vk csu
      cle wbr vj cv cM wceq cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vj cv
      cfz co cM cM cfz co vj cv cM cM cfz opreq2 raleq1d vj cv cM wceq cM vj cv
      cfz co cA vk csu cM cM cfz co cA vk csu cM vj cv cfz co cB vk csu cM cM
      cfz co cB vk csu cle vj cv cM wceq cM vj cv cfz co cM cM cfz co cA vk vj
      cv cM cM cfz opreq2 sumeq1d vj cv cM wceq cM vj cv cfz co cM cM cfz co cB
      vk vj cv cM cM cfz opreq2 sumeq1d breq12d imbi12d vj cv vm cv wceq cA cr
      wcel cB cr wcel cA cB cle wbr w3a vk cM vj cv cfz co wral cA cr wcel cB
      cr wcel cA cB cle wbr w3a vk cM vm cv cfz co wral cM vj cv cfz co cA vk
      csu cM vj cv cfz co cB vk csu cle wbr cM vm cv cfz co cA vk csu cM vm cv
      cfz co cB vk csu cle wbr vj cv vm cv wceq cA cr wcel cB cr wcel cA cB cle
      wbr w3a vk cM vj cv cfz co cM vm cv cfz co vj cv vm cv cM cfz opreq2
      raleq1d vj cv vm cv wceq cM vj cv cfz co cA vk csu cM vm cv cfz co cA vk
      csu cM vj cv cfz co cB vk csu cM vm cv cfz co cB vk csu cle vj cv vm cv
      wceq cM vj cv cfz co cM vm cv cfz co cA vk vj cv vm cv cM cfz opreq2
      sumeq1d vj cv vm cv wceq cM vj cv cfz co cM vm cv cfz co cB vk vj cv vm
      cv cM cfz opreq2 sumeq1d breq12d imbi12d vj cv vm cv c1 caddc co wceq cA
      cr wcel cB cr wcel cA cB cle wbr w3a vk cM vj cv cfz co wral cA cr wcel
      cB cr wcel cA cB cle wbr w3a vk cM vm cv c1 caddc co cfz co wral cM vj cv
      cfz co cA vk csu cM vj cv cfz co cB vk csu cle wbr cM vm cv c1 caddc co
      cfz co cA vk csu cM vm cv c1 caddc co cfz co cB vk csu cle wbr vj cv vm
      cv c1 caddc co wceq cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vj cv
      cfz co cM vm cv c1 caddc co cfz co vj cv vm cv c1 caddc co cM cfz opreq2
      raleq1d vj cv vm cv c1 caddc co wceq cM vj cv cfz co cA vk csu cM vm cv
      c1 caddc co cfz co cA vk csu cM vj cv cfz co cB vk csu cM vm cv c1 caddc
      co cfz co cB vk csu cle vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM
      vm cv c1 caddc co cfz co cA vk vj cv vm cv c1 caddc co cM cfz opreq2
      sumeq1d vj cv vm cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co
      cfz co cB vk vj cv vm cv c1 caddc co cM cfz opreq2 sumeq1d breq12d
      imbi12d vj cv cN wceq cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM vj cv
      cfz co wral cA cr wcel cB cr wcel cA cB cle wbr w3a vk cM cN cfz co wral
      cM vj cv cfz co cA vk csu cM vj cv cfz co cB vk csu cle wbr cM cN cfz co
      cA vk csu cM cN cfz co cB vk csu cle wbr vj cv cN wceq cA cr wcel cB cr
      wcel cA cB cle wbr w3a vk cM vj cv cfz co cM cN cfz co vj cv cN cM cfz
      opreq2 raleq1d vj cv cN wceq cM vj cv cfz co cA vk csu cM cN cfz co cA vk
      csu cM vj cv cfz co cB vk csu cM cN cfz co cB vk csu cle vj cv cN wceq cM
      vj cv cfz co cM cN cfz co cA vk vj cv cN cM cfz opreq2 sumeq1d vj cv cN
      wceq cM vj cv cfz co cM cN cfz co cB vk vj cv cN cM cfz opreq2 sumeq1d
      breq12d imbi12d uzind4ALT imp $.
      $( [23-Jan-2006] $) $( [11-Dec-2005] $)
  $}

  ${
    $d k M $.  $d k N $.
    $( If all of the terms of a finite sum are nonnegative, so is the sum. $)
    fsumcmp0 $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
         ( A e. RR /\ 0 <_ A ) ) -> 0 <_ sum_ k e. ( M ... N ) A ) $=
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa
      cM cN cfz co cc0 vk csu cc0 cM cN cfz co cA vk csu cle cN cM cuz cfv wcel
      cM cN cfz co cc0 vk csu cc0 wceq cA cr wcel cc0 cA cle wbr wa vk cM cN
      cfz co wral vk cM cN fsum0 adantr cN cM cuz cfv wcel cc0 cr wcel cA cr
      wcel cc0 cA cle wbr w3a vk cM cN cfz co wral cM cN cfz co cc0 vk csu cM
      cN cfz co cA vk csu cle wbr cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral cc0 cA vk cM cN fsumcmp cA cr wcel cc0 cA cle wbr wa cc0 cr wcel cA
      cr wcel cc0 cA cle wbr w3a vk cM cN cfz co cA cr wcel cc0 cA cle wbr wa
      cc0 cr wcel cA cr wcel cc0 cA cle wbr cc0 cr wcel cA cr wcel cc0 cA cle
      wbr wa 0re a1i cA cr wcel cc0 cA cle wbr pm3.26 cA cr wcel cc0 cA cle wbr
      pm3.27 3jca r19.20si sylan2 eqbrtrrd $.
      $( [26-Oct-2006] $) $( [26-Dec-2005] $)
  $}


  ${
    $d k J $.  $d k K $.  $d k M $.
    $( A shorter sum of nonnegative terms is smaller than a longer one. $)
    fsumcmpndx2 $p |- ( ( ( J e. ( ZZ>= ` M ) /\ K e. ( ZZ>= ` M ) ) /\
         ( A. k e. ( M ... K ) ( A e. RR /\ 0 <_ A ) /\ J <_ K ) ) ->
            sum_ k e. ( M ... J ) A <_ sum_ k e. ( M ... K ) A ) $=
      cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk
      cM cK cfz co wral cJ cK cle wbr cM cJ cfz co cA vk csu cM cK cfz co cA vk
      csu cle wbr cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA
      cle wbr wa vk cM cK cfz co wral wa cJ cK cle wbr cJ cK clt wbr cJ cK wceq
      wo cM cJ cfz co cA vk csu cM cK cfz co cA vk csu cle wbr cJ cM cuz cfv
      wcel cK cM cuz cfv wcel wa cJ cK cle wbr cJ cK clt wbr cJ cK wceq wo cA
      cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cJ cK cle wbr cJ cK clt wbr cJ cK wceq wo cJ cz wcel cK
      cz wcel cJ cK cle wbr cJ cK clt wbr cJ cK wceq wo wb cJ cM cuz cfv wcel
      cK cM cuz cfv wcel cJ cr wcel cK cr wcel cJ cK cle wbr cJ cK clt wbr cJ
      cK wceq wo wb cJ cz wcel cK cz wcel cJ cK leloe cJ zre cK zre syl2an cM
      cJ eluzelz cM cK eluzelz syl2an biimpa adantlr cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral wa cJ
      cK clt wbr cM cJ cfz co cA vk csu cM cK cfz co cA vk csu cle wbr cJ cK
      wceq cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle wbr
      wa vk cM cK cfz co wral wa cJ cK clt wbr wa cM cJ cfz co cA vk csu cM cJ
      cfz co cA vk csu cJ c1 caddc co cK cfz co cA vk csu caddc co cM cK cfz co
      cA vk csu cle cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA
      cle wbr wa vk cM cK cfz co wral wa cJ cK clt wbr wa cc0 cJ c1 caddc co cK
      cfz co cA vk csu cle wbr cM cJ cfz co cA vk csu cM cJ cfz co cA vk csu cJ
      c1 caddc co cK cfz co cA vk csu caddc co cle wbr cK cJ c1 caddc co cuz
      cfv wcel cA cr wcel cc0 cA cle wbr wa vk cJ c1 caddc co cK cfz co wral
      cc0 cJ c1 caddc co cK cfz co cA vk csu cle wbr cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral wa cJ
      cK clt wbr wa cA vk cJ c1 caddc co cK fsumcmp0 cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cJ cK clt wbr cK cJ c1 caddc co cuz cfv wcel cA cr wcel
      cc0 cA cle wbr wa vk cM cK cfz co wral cJ cM cuz cfv wcel cK cM cuz cfv
      wcel wa cJ cK clt wbr cK cJ c1 caddc co cuz cfv wcel cJ cz wcel cK cz
      wcel cJ cK clt wbr cK cJ c1 caddc co cuz cfv wcel wb cJ cM cuz cfv wcel
      cK cM cuz cfv wcel cJ cz wcel cK cz wcel wa cJ cK clt wbr cJ c1 caddc co
      cK cle wbr cK cJ c1 caddc co cuz cfv wcel cJ cK zltp1le cJ c1 caddc co cz
      wcel cK cz wcel cK cJ c1 caddc co cuz cfv wcel cJ c1 caddc co cK cle wbr
      wb cJ cz wcel cJ c1 caddc co cK eluz cJ peano2z sylan bitr4d cM cJ
      eluzelz cM cK eluzelz syl2an biimpa adantlr cJ cM cuz cfv wcel cK cM cuz
      cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral wa cA cr
      wcel cc0 cA cle wbr wa vk cJ c1 caddc co cK cfz co wral cJ cK clt wbr cJ
      cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk cM
      cK cfz co wral cA cr wcel cc0 cA cle wbr wa vk cJ c1 caddc co cK cfz co
      wral cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle wbr
      wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co cJ c1 caddc co cK cfz co
      cJ cM cuz cfv wcel cK cM cuz cfv wcel wa vk cv cJ c1 caddc co cK cfz co
      wcel vk cv cM cK cfz co wcel cA cr wcel cc0 cA cle wbr wa cJ cM cuz cfv
      wcel cK cM cuz cfv wcel wa cJ c1 caddc co cK cfz co cM cK cfz co vk cv cJ
      c1 caddc co cM cuz cfv wcel cK cz wcel cJ c1 caddc co cK cfz co cM cK cfz
      co wss cJ cM cuz cfv wcel cK cM cuz cfv wcel cJ c1 caddc co cM cK fzss1
      cM cJ peano2uz cM cK eluzelz syl2an sseld imim1d r19.20dv2 imp adantr
      sylanc cM cJ cfz co cA vk csu cr wcel cJ c1 caddc co cK cfz co cA vk csu
      cr wcel cc0 cJ c1 caddc co cK cfz co cA vk csu cle wbr cM cJ cfz co cA vk
      csu cM cJ cfz co cA vk csu cJ c1 caddc co cK cfz co cA vk csu caddc co
      cle wbr wb cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle
      wbr wa vk cM cK cfz co wral wa cJ cK clt wbr wa cM cJ cfz co cA vk csu cJ
      c1 caddc co cK cfz co cA vk csu addge01 cJ cM cuz cfv wcel cA cr wcel vk
      cM cJ cfz co wral cM cJ cfz co cA vk csu cr wcel cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral wa cJ
      cK clt wbr wa cA vk cM cJ fsumrecl cJ cM cuz cfv wcel cK cM cuz cfv wcel
      cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cJ cK clt wbr simplll
      cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cJ cK clt wbr cA cr wcel cc0 cA
      cle wbr wa vk cM cK cfz co wral cA cr wcel vk cM cJ cfz co wral cJ cM cuz
      cfv wcel cK cM cuz cfv wcel wa cJ cK clt wbr wa cA cr wcel cc0 cA cle wbr
      wa vk cM cK cfz co wral cA cr wcel vk cM cJ cfz co wral cJ cM cuz cfv
      wcel cK cM cuz cfv wcel wa cJ cK clt wbr wa cA cr wcel cc0 cA cle wbr wa
      cA cr wcel vk cM cK cfz co cM cJ cfz co cJ cM cuz cfv wcel cK cM cuz cfv
      wcel wa cJ cK clt wbr wa vk cv cM cJ cfz co wcel vk cv cM cK cfz co wcel
      cA cr wcel cc0 cA cle wbr wa cA cr wcel cJ cM cuz cfv wcel cK cM cuz cfv
      wcel wa cJ cK clt wbr wa cM cJ cfz co cM cK cfz co vk cv cK cJ cuz cfv
      wcel cM cz wcel cM cJ cfz co cM cK cfz co wss cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cJ cK clt wbr wa cJ cM cK fzss2 cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cJ cK clt wbr cK cJ cuz cfv wcel cJ cz wcel cK cz wcel cJ
      cK clt wbr cK cJ cuz cfv wcel wi cJ cM cuz cfv wcel cK cM cuz cfv wcel cJ
      cz wcel cK cz wcel wa cJ cK clt wbr cJ cK cle wbr cK cJ cuz cfv wcel cJ
      cr wcel cK cr wcel cJ cK clt wbr cJ cK cle wbr wi cJ cz wcel cK cz wcel
      cJ cK ltle cJ zre cK zre syl2an cJ cK eluz sylibrd cM cJ eluzelz cM cK
      eluzelz syl2an imp cJ cM cuz cfv wcel cM cz wcel cK cM cuz cfv wcel cJ cK
      clt wbr cM cJ eluzel2 ad2antrr sylanc sseld cA cr wcel cc0 cA cle wbr wa
      cA cr wcel wi cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cJ cK clt wbr wa
      cA cr wcel cc0 cA cle wbr pm3.26 a1i imim12d r19.20dv2 imp an1rs sylanc
      cK cJ c1 caddc co cuz cfv wcel cA cr wcel vk cJ c1 caddc co cK cfz co
      wral cJ c1 caddc co cK cfz co cA vk csu cr wcel cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral wa cJ
      cK clt wbr wa cA vk cJ c1 caddc co cK fsumrecl cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cJ cK clt wbr cK cJ c1 caddc co cuz cfv wcel cA cr wcel
      cc0 cA cle wbr wa vk cM cK cfz co wral cJ cM cuz cfv wcel cK cM cuz cfv
      wcel wa cJ cK clt wbr cK cJ c1 caddc co cuz cfv wcel cJ cz wcel cK cz
      wcel cJ cK clt wbr cK cJ c1 caddc co cuz cfv wcel wb cJ cM cuz cfv wcel
      cK cM cuz cfv wcel cJ cz wcel cK cz wcel wa cJ cK clt wbr cJ c1 caddc co
      cK cle wbr cK cJ c1 caddc co cuz cfv wcel cJ cK zltp1le cJ c1 caddc co cz
      wcel cK cz wcel cK cJ c1 caddc co cuz cfv wcel cJ c1 caddc co cK cle wbr
      wb cJ cz wcel cJ c1 caddc co cK eluz cJ peano2z sylan bitr4d cM cJ
      eluzelz cM cK eluzelz syl2an biimpa adantlr cJ cM cuz cfv wcel cK cM cuz
      cfv wcel wa cJ cK clt wbr cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co
      wral cA cr wcel vk cJ c1 caddc co cK cfz co wral cJ cM cuz cfv wcel cK cM
      cuz cfv wcel wa cJ cK clt wbr wa cA cr wcel cc0 cA cle wbr wa vk cM cK
      cfz co wral cA cr wcel vk cJ c1 caddc co cK cfz co wral cJ cM cuz cfv
      wcel cK cM cuz cfv wcel wa cJ cK clt wbr wa cA cr wcel cc0 cA cle wbr wa
      cA cr wcel vk cM cK cfz co cJ c1 caddc co cK cfz co cJ cM cuz cfv wcel cK
      cM cuz cfv wcel wa cJ cK clt wbr wa vk cv cJ c1 caddc co cK cfz co wcel
      vk cv cM cK cfz co wcel cA cr wcel cc0 cA cle wbr wa cA cr wcel cJ cM cuz
      cfv wcel cK cM cuz cfv wcel wa vk cv cJ c1 caddc co cK cfz co wcel vk cv
      cM cK cfz co wcel wi cJ cK clt wbr cJ cM cuz cfv wcel cK cM cuz cfv wcel
      wa cJ c1 caddc co cK cfz co cM cK cfz co vk cv cJ c1 caddc co cM cuz cfv
      wcel cK cz wcel cJ c1 caddc co cK cfz co cM cK cfz co wss cJ cM cuz cfv
      wcel cK cM cuz cfv wcel cJ c1 caddc co cM cK fzss1 cM cJ peano2uz cM cK
      eluzelz syl2an sseld adantr cA cr wcel cc0 cA cle wbr wa cA cr wcel wi cJ
      cM cuz cfv wcel cK cM cuz cfv wcel wa cJ cK clt wbr wa cA cr wcel cc0 cA
      cle wbr pm3.26 a1i imim12d r19.20dv2 imp an1rs sylanc sylanc mpbid cK cz
      wcel cJ cM cK c1 cmin co cfz co wcel cA cc wcel vk cM cK cfz co wral cM
      cK cfz co cA vk csu cM cJ cfz co cA vk csu cJ c1 caddc co cK cfz co cA vk
      csu caddc co wceq cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0
      cA cle wbr wa vk cM cK cfz co wral wa cJ cK clt wbr wa cA vk cJ cM cK
      fsumsplit cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cK cz wcel cA cr wcel
      cc0 cA cle wbr wa vk cM cK cfz co wral cJ cK clt wbr cK cM cuz cfv wcel
      cK cz wcel cJ cM cuz cfv wcel cM cK eluzelz adantl ad2antrr cJ cM cuz cfv
      wcel cK cM cuz cfv wcel wa cJ cK clt wbr cJ cM cK c1 cmin co cfz co wcel
      cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cJ cM cuz cfv wcel cK
      cM cuz cfv wcel wa cJ cK clt wbr cJ cM cK c1 cmin co cfz co wcel cJ cM
      cuz cfv wcel cK cM cuz cfv wcel wa cJ cK clt wbr cJ cK c1 cmin co cle wbr
      cJ cM cK c1 cmin co cfz co wcel cJ cz wcel cK cz wcel cJ cK clt wbr cJ cK
      c1 cmin co cle wbr wb cJ cM cuz cfv wcel cK cM cuz cfv wcel cJ cK zltlem1
      cM cJ eluzelz cM cK eluzelz syl2an cJ cM cuz cfv wcel cK c1 cmin co cz
      wcel cJ cM cK c1 cmin co cfz co wcel cJ cK c1 cmin co cle wbr wb cK cM
      cuz cfv wcel cJ cM cK c1 cmin co elfz5 cK cM cuz cfv wcel cK cz wcel cK
      c1 cmin co cz wcel cM cK eluzelz cK peano2zm syl sylan2 bitr4d biimpa
      adantlr cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cA cc wcel vk
      cM cK cfz co wral cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cJ cK clt wbr
      cA cr wcel cc0 cA cle wbr wa cA cc wcel vk cM cK cfz co cA cr wcel cc0 cA
      cle wbr wa cA cA cr wcel cc0 cA cle wbr pm3.26 recnd r19.20si ad2antlr
      syl3anc breqtrrd cM cJ cfz co cA vk csu cr wcel cM cJ cfz co cA vk csu cM
      cK cfz co cA vk csu wceq cM cJ cfz co cA vk csu cM cK cfz co cA vk csu
      cle wbr cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle
      wbr wa vk cM cK cfz co wral wa cJ cK wceq wa cM cJ cfz co cA vk csu cM cK
      cfz co cA vk csu eqle cJ cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk
      cM cK cfz co wral cJ cK wceq cM cJ cfz co cA vk csu cr wcel cK cM cuz cfv
      wcel cJ cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral
      cJ cK wceq cM cJ cfz co cA vk csu cr wcel cJ cM cuz cfv wcel cA cr wcel
      vk cM cJ cfz co wral cM cJ cfz co cA vk csu cr wcel cA cr wcel cc0 cA cle
      wbr wa vk cM cK cfz co wral cJ cK wceq wa cA vk cM cJ fsumrecl cJ cK wceq
      cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cA cr wcel vk cM cJ cfz
      co wral cJ cK wceq cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cA
      cr wcel cc0 cA cle wbr wa vk cM cJ cfz co wral cA cr wcel vk cM cJ cfz co
      wral cJ cK wceq cA cr wcel cc0 cA cle wbr wa vk cM cJ cfz co cM cK cfz co
      cJ cK cM cfz opreq2 raleq1d cA cr wcel cc0 cA cle wbr wa cA cr wcel vk cM
      cJ cfz co cA cr wcel cc0 cA cle wbr pm3.26 r19.20si syl6bir impcom sylan2
      anassrs adantllr cJ cK wceq cM cJ cfz co cA vk csu cM cK cfz co cA vk csu
      wceq cJ cM cuz cfv wcel cK cM cuz cfv wcel wa cA cr wcel cc0 cA cle wbr
      wa vk cM cK cfz co wral wa cJ cK wceq cM cJ cfz co cM cK cfz co cA vk cJ
      cK cM cfz opreq2 sumeq1d adantl sylanc jaodan syldan anasss $.
      $( [23-Jun-2007] $) $( [26-Dec-2005] $)

$(
    @( A longer sum of nonnegative terms is larger than a shorter one. @)
    fsumcmpndx1 @p |- ( ( ( N e. ( ZZ>= ` J ) /\ N e. ( ZZ>= ` K ) ) /\
         ( A. k e. ( J ... N ) ( A e. RR /\ 0 <_ A ) /\ J <_ K ) ) ->
            sum_ k e. ( K ... N ) A <_ sum_ k e. ( J ... N ) A ) @=
?@.
      @( [ ?] @) @( [4-Jan-2006] @)
$)
  $}

  ${
    $d j m A $.  $d j k m x M $.  $d j k N $.
    $( Generalized triangle inequality:  the absolute value of a finite sum is
       less than or equal to the sum of absolute values. $)
    fsumabs $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
            A e. CC ) -> ( abs ` sum_ k e. ( M ... N ) A ) <_
                     sum_ k e. ( M ... N ) ( abs ` A ) ) $=
      cN cM cuz cfv wcel cA cc wcel vk cM cN cfz co wral cM cN cfz co cA vk csu
      cabs cfv cM cN cfz co cA cabs cfv vk csu cle wbr cA cc wcel vk cM vj cv
      cfz co wral cM vj cv cfz co cA vk csu cabs cfv cM vj cv cfz co cA cabs
      cfv vk csu cle wbr wi cA cc wcel vk cM cM cfz co wral cM cM cfz co cA vk
      csu cabs cfv cM cM cfz co cA cabs cfv vk csu cle wbr wi cA cc wcel vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA
      cabs cfv vk csu cle wbr wi cA cc wcel vk cM vm cv c1 caddc co cfz co wral
      cM vm cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv c1 caddc co cfz
      co cA cabs cfv vk csu cle wbr wi cA cc wcel vk cM cN cfz co wral cM cN
      cfz co cA vk csu cabs cfv cM cN cfz co cA cabs cfv vk csu cle wbr wi vj
      vm cM cN vj cv cM wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk
      cM cM cfz co wral cM vj cv cfz co cA vk csu cabs cfv cM vj cv cfz co cA
      cabs cfv vk csu cle wbr cM cM cfz co cA vk csu cabs cfv cM cM cfz co cA
      cabs cfv vk csu cle wbr vj cv cM wceq cA cc wcel vk cM vj cv cfz co cM cM
      cfz co vj cv cM cM cfz opreq2 raleq1d vj cv cM wceq cM vj cv cfz co cA vk
      csu cabs cfv cM cM cfz co cA vk csu cabs cfv cM vj cv cfz co cA cabs cfv
      vk csu cM cM cfz co cA cabs cfv vk csu cle vj cv cM wceq cM vj cv cfz co
      cA vk csu cM cM cfz co cA vk csu cabs vj cv cM wceq cM vj cv cfz co cM cM
      cfz co cA vk vj cv cM cM cfz opreq2 sumeq1d fveq2d vj cv cM wceq cM vj cv
      cfz co cM cM cfz co cA cabs cfv vk vj cv cM cM cfz opreq2 sumeq1d breq12d
      imbi12d vj cv vm cv wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk
      cM vm cv cfz co wral cM vj cv cfz co cA vk csu cabs cfv cM vj cv cfz co
      cA cabs cfv vk csu cle wbr cM vm cv cfz co cA vk csu cabs cfv cM vm cv
      cfz co cA cabs cfv vk csu cle wbr vj cv vm cv wceq cA cc wcel vk cM vj cv
      cfz co cM vm cv cfz co vj cv vm cv cM cfz opreq2 raleq1d vj cv vm cv wceq
      cM vj cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA vk csu cabs cfv cM
      vj cv cfz co cA cabs cfv vk csu cM vm cv cfz co cA cabs cfv vk csu cle vj
      cv vm cv wceq cM vj cv cfz co cA vk csu cM vm cv cfz co cA vk csu cabs vj
      cv vm cv wceq cM vj cv cfz co cM vm cv cfz co cA vk vj cv vm cv cM cfz
      opreq2 sumeq1d fveq2d vj cv vm cv wceq cM vj cv cfz co cM vm cv cfz co cA
      cabs cfv vk vj cv vm cv cM cfz opreq2 sumeq1d breq12d imbi12d vj cv vm cv
      c1 caddc co wceq cA cc wcel vk cM vj cv cfz co wral cA cc wcel vk cM vm
      cv c1 caddc co cfz co wral cM vj cv cfz co cA vk csu cabs cfv cM vj cv
      cfz co cA cabs cfv vk csu cle wbr cM vm cv c1 caddc co cfz co cA vk csu
      cabs cfv cM vm cv c1 caddc co cfz co cA cabs cfv vk csu cle wbr vj cv vm
      cv c1 caddc co wceq cA cc wcel vk cM vj cv cfz co cM vm cv c1 caddc co
      cfz co vj cv vm cv c1 caddc co cM cfz opreq2 raleq1d vj cv vm cv c1 caddc
      co wceq cM vj cv cfz co cA vk csu cabs cfv cM vm cv c1 caddc co cfz co cA
      vk csu cabs cfv cM vj cv cfz co cA cabs cfv vk csu cM vm cv c1 caddc co
      cfz co cA cabs cfv vk csu cle vj cv vm cv c1 caddc co wceq cM vj cv cfz
      co cA vk csu cM vm cv c1 caddc co cfz co cA vk csu cabs vj cv vm cv c1
      caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co cfz co cA vk vj cv vm
      cv c1 caddc co cM cfz opreq2 sumeq1d fveq2d vj cv vm cv c1 caddc co wceq
      cM vj cv cfz co cM vm cv c1 caddc co cfz co cA cabs cfv vk vj cv vm cv c1
      caddc co cM cfz opreq2 sumeq1d breq12d imbi12d vj cv cN wceq cA cc wcel
      vk cM vj cv cfz co wral cA cc wcel vk cM cN cfz co wral cM vj cv cfz co
      cA vk csu cabs cfv cM vj cv cfz co cA cabs cfv vk csu cle wbr cM cN cfz
      co cA vk csu cabs cfv cM cN cfz co cA cabs cfv vk csu cle wbr vj cv cN
      wceq cA cc wcel vk cM vj cv cfz co cM cN cfz co vj cv cN cM cfz opreq2
      raleq1d vj cv cN wceq cM vj cv cfz co cA vk csu cabs cfv cM cN cfz co cA
      vk csu cabs cfv cM vj cv cfz co cA cabs cfv vk csu cM cN cfz co cA cabs
      cfv vk csu cle vj cv cN wceq cM vj cv cfz co cA vk csu cM cN cfz co cA vk
      csu cabs vj cv cN wceq cM vj cv cfz co cM cN cfz co cA vk vj cv cN cM cfz
      opreq2 sumeq1d fveq2d vj cv cN wceq cM vj cv cfz co cM cN cfz co cA cabs
      cfv vk vj cv cN cM cfz opreq2 sumeq1d breq12d imbi12d cM cz wcel cA cc
      wcel vk cM cM cfz co wral cM cM cfz co cA vk csu cabs cfv cM cM cfz co cA
      cabs cfv vk csu cle wbr cM cz wcel cA cc wcel vk cM cM cfz co wral wa vk
      cM cA csb cabs cfv vk cM cA cabs cfv csb cM cM cfz co cA vk csu cabs cfv
      cM cM cfz co cA cabs cfv vk csu cle cM cz wcel cA cc wcel vk cM cM cfz co
      wral wa vk cM cA cabs cfv csb vk cM cA csb cabs cfv vk cM cA cabs cfv csb
      cle cM cz wcel vk cM cA cabs cfv csb vk cM cA csb cabs cfv wceq cA cc
      wcel vk cM cM cfz co wral vk cM cA cz cabs csbfv2g adantr cM cz wcel cA
      cc wcel vk cM cM cfz co wral wa vk cM cA cabs cfv csb cr wcel vk cM cA
      cabs cfv csb vk cM cA cabs cfv csb cle wbr cM cM cM cfz co wcel cA cabs
      cfv cr wcel vk cM cM cfz co wral vk cM cA cabs cfv csb cr wcel cM cz wcel
      cA cc wcel vk cM cM cfz co wral vk cM cM cM cfz co cA cabs cfv cr
      ra4csbela cM elfz3 cA cc wcel cA cabs cfv cr wcel vk cM cM cfz co cA
      abscl r19.20si syl2an vk cM cA cabs cfv csb leid syl eqbrtrrd cM cz wcel
      cA cc wcel vk cM cM cfz co wral wa cM cM cfz co cA vk csu vk cM cA csb
      cabs cA cc vk cM fsum1s fveq2d cM cz wcel cA cabs cfv cc wcel vk cM cM
      cfz co wral cM cM cfz co cA cabs cfv vk csu vk cM cA cabs cfv csb wceq cA
      cc wcel vk cM cM cfz co wral cA cabs cfv cc vk cM fsum1s cA cc wcel cA
      cabs cfv cc wcel vk cM cM cfz co cA cc wcel cA cabs cfv cA abscl recnd
      r19.20si sylan2 3brtr4d ex vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv
      cfz co wral cM vm cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA cabs
      cfv vk csu cle wbr wi cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM
      vm cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA cabs cfv vk csu cle
      wbr wi cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc
      co cfz co cA vk csu cabs cfv cM vm cv c1 caddc co cfz co cA cabs cfv vk
      csu cle wbr wi vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral cA cc wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk csu
      cabs cfv cM vm cv cfz co cA cabs cfv vk csu cle wbr vm cv cM cuz cfv wcel
      cA cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cM vm cv cfz co vm
      cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv c1 caddc co
      cfz co wcel cA cc wcel vm cv cM cuz cfv wcel cM vm cv cfz co cM vm cv c1
      caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv
      c1 caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM vm cv
      eluzel2 cM vm cv eluzelz sylanc sseld imim1d r19.20dv2 imim1d vm cv cM
      cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv cfz
      co cA vk csu cabs cfv cM vm cv cfz co cA cabs cfv vk csu cle wbr cM vm cv
      c1 caddc co cfz co cA vk csu cabs cfv cM vm cv c1 caddc co cfz co cA cabs
      cfv vk csu cle wbr vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc
      co cfz co wral cM vm cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA cabs
      cfv vk csu cle wbr cM vm cv c1 caddc co cfz co cA vk csu cabs cfv cM vm
      cv c1 caddc co cfz co cA cabs cfv vk csu cle wbr vm cv cM cuz cfv wcel cA
      cc wcel vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk csu
      cabs cfv cM vm cv cfz co cA cabs cfv vk csu cle wbr wa cM vm cv c1 caddc
      co cfz co cA vk csu cabs cfv cM vm cv cfz co cA vk csu cabs cfv vk vm cv
      c1 caddc co cA cabs cfv csb caddc co cle wbr cM vm cv cfz co cA vk csu
      cabs cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cM vm cv c1 caddc
      co cfz co cA cabs cfv vk csu cle wbr cM vm cv c1 caddc co cfz co cA vk
      csu cabs cfv cM vm cv c1 caddc co cfz co cA cabs cfv vk csu cle wbr vm cv
      cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cM vm
      cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv cfz co cA vk csu cabs
      cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cle wbr cM vm cv cfz co
      cA vk csu cabs cfv cM vm cv cfz co cA cabs cfv vk csu cle wbr vm cv cM
      cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cM vm cv
      cfz co cA vk csu vk vm cv c1 caddc co cA csb caddc co cabs cfv cM vm cv
      cfz co cA vk csu cabs cfv vk vm cv c1 caddc co cA csb cabs cfv caddc co
      cM vm cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv cfz co cA vk csu
      cabs cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cle cM vm cv cfz
      co cA vk csu cc wcel vk vm cv c1 caddc co cA csb cc wcel cM vm cv cfz co
      cA vk csu vk vm cv c1 caddc co cA csb caddc co cabs cfv cM vm cv cfz co
      cA vk csu cabs cfv vk vm cv c1 caddc co cA csb cabs cfv caddc co cle wbr
      vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa
      cM vm cv cfz co cA vk csu vk vm cv c1 caddc co cA csb abstri vm cv cM cuz
      cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk csu cc wcel vm cv cM cuz cfv wcel
      cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM vm cv cfz
      co wral vm cv cM cuz cfv wcel cA cc wcel cA cc wcel vk cM vm cv c1 caddc
      co cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz co
      wcel vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel vm cv cM cuz cfv
      wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel vm cv
      cz wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm cv cM cuz cfv
      wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz sylanc sseld
      imim1d r19.20dv2 imp cA vk cM vm cv fsumcl syldan vm cv c1 caddc co cM vm
      cv c1 caddc co cfz co wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral
      vk vm cv c1 caddc co cA csb cc wcel vm cv cM cuz cfv wcel vk vm cv c1
      caddc co cM vm cv c1 caddc co cfz co cA cc ra4csbela vm cv cM cuz cfv
      wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1
      caddc co cfz co wcel cM vm cv peano2uz cM vm cv c1 caddc co eluzfz2 syl
      sylan sylanc vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz
      co wral wa cM vm cv c1 caddc co cfz co cA vk csu cM vm cv cfz co cA vk
      csu vk vm cv c1 caddc co cA csb caddc co cabs cA cc vk cM vm cv fsump1s
      fveq2d vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co
      wral wa vk vm cv c1 caddc co cA cabs cfv csb vk vm cv c1 caddc co cA csb
      cabs cfv cM vm cv cfz co cA vk csu cabs cfv caddc vk vm cv c1 caddc co cA
      cabs cfv csb vk vm cv c1 caddc co cA csb cabs cfv wceq vm cv cM cuz cfv
      wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa vm cv c1 caddc co
      cvv wcel vk vm cv c1 caddc co cA cabs cfv csb vk vm cv c1 caddc co cA csb
      cabs cfv wceq vm cv c1 caddc oprex vk vm cv c1 caddc co cA cvv cabs
      csbfv2g ax-mp a1i opreq2d 3brtr4d adantr vm cv cM cuz cfv wcel cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk csu cabs cfv
      cM vm cv cfz co cA cabs cfv vk csu cle wbr wa cM vm cv cfz co cA vk csu
      cabs cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cM vm cv cfz co cA
      cabs cfv vk csu vk vm cv c1 caddc co cA cabs cfv csb caddc co cM vm cv c1
      caddc co cfz co cA cabs cfv vk csu cle vm cv cM cuz cfv wcel cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk csu cabs cfv
      cM vm cv cfz co cA cabs cfv vk csu cle wbr cM vm cv cfz co cA vk csu cabs
      cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cM vm cv cfz co cA cabs
      cfv vk csu vk vm cv c1 caddc co cA cabs cfv csb caddc co cle wbr cM vm cv
      cfz co cA vk csu cabs cfv cr wcel cM vm cv cfz co cA cabs cfv vk csu cr
      wcel vk vm cv c1 caddc co cA cabs cfv csb cr wcel cM vm cv cfz co cA vk
      csu cabs cfv cM vm cv cfz co cA cabs cfv vk csu cle wbr cM vm cv cfz co
      cA vk csu cabs cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cM vm cv
      cfz co cA cabs cfv vk csu vk vm cv c1 caddc co cA cabs cfv csb caddc co
      cle wbr wb vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz
      co wral wa cM vm cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA cabs cfv
      vk csu vk vm cv c1 caddc co cA cabs cfv csb leadd1 vm cv cM cuz cfv wcel
      cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk
      csu cc wcel cM vm cv cfz co cA vk csu cabs cfv cr wcel vm cv cM cuz cfv
      wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM vm
      cv cfz co wral cM vm cv cfz co cA vk csu cc wcel vm cv cM cuz cfv wcel cA
      cc wcel vk cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM vm cv cfz co
      wral vm cv cM cuz cfv wcel cA cc wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co cM vm cv cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel
      vk cv cM vm cv c1 caddc co cfz co wcel cA cc wcel vm cv cM cuz cfv wcel
      cM vm cv cfz co cM vm cv c1 caddc co cfz co vk cv cM cz wcel vm cv cz
      wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss vm cv cM cuz cfv
      wcel cM vm cv fzssp1 cM vm cv eluzel2 cM vm cv eluzelz sylanc sseld
      imim1d r19.20dv2 imp cA vk cM vm cv fsumcl syldan cM vm cv cfz co cA vk
      csu abscl syl vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral cA cabs cfv cr wcel vk cM vm cv cfz co wral cM vm cv cfz co
      cA cabs cfv vk csu cr wcel vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv
      c1 caddc co cfz co wral wa cA cc wcel vk cM vm cv cfz co wral cA cabs cfv
      cr wcel vk cM vm cv cfz co wral vm cv cM cuz cfv wcel cA cc wcel vk cM vm
      cv c1 caddc co cfz co wral cA cc wcel vk cM vm cv cfz co wral vm cv cM
      cuz cfv wcel cA cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cM vm
      cv cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv
      c1 caddc co cfz co wcel cA cc wcel vm cv cM cuz cfv wcel cM vm cv cfz co
      cM vm cv c1 caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz
      co cM vm cv c1 caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1
      cM vm cv eluzel2 cM vm cv eluzelz sylanc sseld imim1d r19.20dv2 imp cA cc
      wcel cA cabs cfv cr wcel vk cM vm cv cfz co cA abscl r19.20si syl cA cabs
      cfv vk cM vm cv fsumrecl syldan vm cv c1 caddc co cM vm cv c1 caddc co
      cfz co wcel cA cabs cfv cr wcel vk cM vm cv c1 caddc co cfz co wral vk vm
      cv c1 caddc co cA cabs cfv csb cr wcel vm cv cM cuz cfv wcel cA cc wcel
      vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc co cM vm cv c1
      caddc co cfz co cA cabs cfv cr ra4csbela vm cv cM cuz cfv wcel vm cv c1
      caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cM vm cv peano2uz cM vm cv c1 caddc co eluzfz2 syl cA cc wcel cA
      cabs cfv cr wcel vk cM vm cv c1 caddc co cfz co cA abscl r19.20si syl2an
      syl3anc biimpa vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co
      cfz co wral wa cM vm cv c1 caddc co cfz co cA cabs cfv vk csu cM vm cv
      cfz co cA cabs cfv vk csu vk vm cv c1 caddc co cA cabs cfv csb caddc co
      wceq cM vm cv cfz co cA vk csu cabs cfv cM vm cv cfz co cA cabs cfv vk
      csu cle wbr vm cv cM cuz cfv wcel cA cabs cfv cc wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA cabs cfv vk csu cM vm
      cv cfz co cA cabs cfv vk csu vk vm cv c1 caddc co cA cabs cfv csb caddc
      co wceq cA cc wcel vk cM vm cv c1 caddc co cfz co wral cA cabs cfv cc vk
      cM vm cv fsump1s cA cc wcel cA cabs cfv cc wcel vk cM vm cv c1 caddc co
      cfz co cA cc wcel cA cabs cfv cA abscl recnd r19.20si sylan2 adantr
      breqtrrd vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co
      wral wa cM vm cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv cfz co cA
      vk csu cabs cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co cle wbr cM
      vm cv cfz co cA vk csu cabs cfv vk vm cv c1 caddc co cA cabs cfv csb
      caddc co cM vm cv c1 caddc co cfz co cA cabs cfv vk csu cle wbr wa cM vm
      cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv c1 caddc co cfz co cA
      cabs cfv vk csu cle wbr wi cM vm cv cfz co cA vk csu cabs cfv cM vm cv
      cfz co cA cabs cfv vk csu cle wbr cM vm cv c1 caddc co cfz co cA vk csu
      cabs cfv cr wcel cM vm cv cfz co cA vk csu cabs cfv vk vm cv c1 caddc co
      cA cabs cfv csb caddc co cr wcel cM vm cv c1 caddc co cfz co cA cabs cfv
      vk csu cr wcel cM vm cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv
      cfz co cA vk csu cabs cfv vk vm cv c1 caddc co cA cabs cfv csb caddc co
      cle wbr cM vm cv cfz co cA vk csu cabs cfv vk vm cv c1 caddc co cA cabs
      cfv csb caddc co cM vm cv c1 caddc co cfz co cA cabs cfv vk csu cle wbr
      wa cM vm cv c1 caddc co cfz co cA vk csu cabs cfv cM vm cv c1 caddc co
      cfz co cA cabs cfv vk csu cle wbr wi vm cv cM cuz cfv wcel cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral wa cM vm cv c1 caddc co cfz co cA vk csu
      cabs cfv cM vm cv cfz co cA vk csu cabs cfv vk vm cv c1 caddc co cA cabs
      cfv csb caddc co cM vm cv c1 caddc co cfz co cA cabs cfv vk csu letr vm
      cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral wa cM
      vm cv c1 caddc co cfz co cA vk csu cc wcel cM vm cv c1 caddc co cfz co cA
      vk csu cabs cfv cr wcel vm cv c1 caddc co cM cuz cfv wcel cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk csu cc
      wcel vm cv cM cuz cfv wcel cA vk cM vm cv c1 caddc co fsumcl cM vm cv
      peano2uz sylan cM vm cv c1 caddc co cfz co cA vk csu abscl syl cM vm cv
      cfz co cA vk csu cabs cfv cr wcel vk vm cv c1 caddc co cA cabs cfv csb cr
      wcel cM vm cv cfz co cA vk csu cabs cfv vk vm cv c1 caddc co cA cabs cfv
      csb caddc co cr wcel vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1
      caddc co cfz co wral wa cM vm cv cfz co cA vk csu cabs cfv vk vm cv c1
      caddc co cA cabs cfv csb readdcl vm cv cM cuz cfv wcel cA cc wcel vk cM
      vm cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk csu cc wcel cM vm
      cv cfz co cA vk csu cabs cfv cr wcel vm cv cM cuz cfv wcel cA cc wcel vk
      cM vm cv c1 caddc co cfz co wral cA cc wcel vk cM vm cv cfz co wral cM vm
      cv cfz co cA vk csu cc wcel vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv
      c1 caddc co cfz co wral cA cc wcel vk cM vm cv cfz co wral vm cv cM cuz
      cfv wcel cA cc wcel cA cc wcel vk cM vm cv c1 caddc co cfz co cM vm cv
      cfz co vm cv cM cuz cfv wcel vk cv cM vm cv cfz co wcel vk cv cM vm cv c1
      caddc co cfz co wcel cA cc wcel vm cv cM cuz cfv wcel cM vm cv cfz co cM
      vm cv c1 caddc co cfz co vk cv cM cz wcel vm cv cz wcel cM vm cv cfz co
      cM vm cv c1 caddc co cfz co wss vm cv cM cuz cfv wcel cM vm cv fzssp1 cM
      vm cv eluzel2 cM vm cv eluzelz sylanc sseld imim1d r19.20dv2 imp cA vk cM
      vm cv fsumcl syldan cM vm cv cfz co cA vk csu abscl syl vm cv c1 caddc co
      cM vm cv c1 caddc co cfz co wcel cA cabs cfv cr wcel vk cM vm cv c1 caddc
      co cfz co wral vk vm cv c1 caddc co cA cabs cfv csb cr wcel vm cv cM cuz
      cfv wcel cA cc wcel vk cM vm cv c1 caddc co cfz co wral vk vm cv c1 caddc
      co cM vm cv c1 caddc co cfz co cA cabs cfv cr ra4csbela vm cv cM cuz cfv
      wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1
      caddc co cfz co wcel cM vm cv peano2uz cM vm cv c1 caddc co eluzfz2 syl
      cA cc wcel cA cabs cfv cr wcel vk cM vm cv c1 caddc co cfz co cA abscl
      r19.20si syl2an sylanc vm cv c1 caddc co cM cuz cfv wcel cA cabs cfv cr
      wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA
      cabs cfv vk csu cr wcel vm cv cM cuz cfv wcel cA cc wcel vk cM vm cv c1
      caddc co cfz co wral cA cabs cfv vk cM vm cv c1 caddc co fsumrecl cM vm
      cv peano2uz cA cc wcel cA cabs cfv cr wcel vk cM vm cv c1 caddc co cfz co
      cA abscl r19.20si syl2an syl3anc adantr mp2and exp31 a2d syld uzind4 imp
      $.
      $( [25-Jan-2006] $) $( [9-Nov-2005] $)
  $}

  ${
    $d m A $.  $d j B $.  $d j J $.  $d j K $.  $d j m M $.  $d j m N $.
    $( The sum of absolute values of the product ` A ( j ) x. B ( m ) ` is
       less than or equal to the product of the two sums of absolute values. $)
    fsumabs2mul $p |- ( ( ( K e. ( ZZ>= ` J ) /\ A. j e. ( J ... K ) A e. CC )
       /\ ( N e. ( ZZ>= ` M ) /\ A. m e. ( M ... N ) B e. CC ) ) ->
    ( abs ` sum_ j e. ( J ... K ) sum_ m e. ( M ... N ) ( A x. B ) ) <_ (
  sum_ j e. ( J ... K ) ( abs ` A ) x. sum_ m e. ( M ... N ) ( abs ` B ) ) ) $=
      cK cJ cuz cfv wcel cA cc wcel vj cJ cK cfz co wral wa cN cM cuz cfv wcel
      cB cc wcel vm cM cN cfz co wral wa wa cJ cK cfz co cM cN cfz co cA cB
      cmul co vm csu vj csu cabs cfv cJ cK cfz co cA vj csu cabs cfv cM cN cfz
      co cB vm csu cabs cfv cmul co cJ cK cfz co cA cabs cfv vj csu cM cN cfz
      co cB cabs cfv vm csu cmul co cle cK cJ cuz cfv wcel cA cc wcel vj cJ cK
      cfz co wral wa cN cM cuz cfv wcel cB cc wcel vm cM cN cfz co wral wa wa
      cJ cK cfz co cM cN cfz co cA cB cmul co vm csu vj csu cabs cfv cJ cK cfz
      co cA vj csu cM cN cfz co cB vm csu cmul co cabs cfv cJ cK cfz co cA vj
      csu cabs cfv cM cN cfz co cB vm csu cabs cfv cmul co cK cJ cuz cfv wcel
      cA cc wcel vj cJ cK cfz co wral wa cN cM cuz cfv wcel cB cc wcel vm cM cN
      cfz co wral wa wa cJ cK cfz co cM cN cfz co cA cB cmul co vm csu vj csu
      cJ cK cfz co cA vj csu cM cN cfz co cB vm csu cmul co cabs cA cB vj vm cJ
      cK cM cN fsum2mul fveq2d cJ cK cfz co cA vj csu cc wcel cM cN cfz co cB
      vm csu cc wcel cJ cK cfz co cA vj csu cM cN cfz co cB vm csu cmul co cabs
      cfv cJ cK cfz co cA vj csu cabs cfv cM cN cfz co cB vm csu cabs cfv cmul
      co wceq cK cJ cuz cfv wcel cA cc wcel vj cJ cK cfz co wral wa cN cM cuz
      cfv wcel cB cc wcel vm cM cN cfz co wral wa cJ cK cfz co cA vj csu cM cN
      cfz co cB vm csu absmul cA vj cJ cK fsumcl cB vm cM cN fsumcl syl2an
      eqtrd cJ cK cfz co cA vj csu cabs cfv cr wcel cJ cK cfz co cA cabs cfv vj
      csu cr wcel wa cc0 cJ cK cfz co cA vj csu cabs cfv cle wbr cJ cK cfz co
      cA vj csu cabs cfv cJ cK cfz co cA cabs cfv vj csu cle wbr wa wa cM cN
      cfz co cB vm csu cabs cfv cr wcel cM cN cfz co cB cabs cfv vm csu cr wcel
      wa cc0 cM cN cfz co cB vm csu cabs cfv cle wbr cM cN cfz co cB vm csu
      cabs cfv cM cN cfz co cB cabs cfv vm csu cle wbr wa wa cJ cK cfz co cA vj
      csu cabs cfv cM cN cfz co cB vm csu cabs cfv cmul co cJ cK cfz co cA cabs
      cfv vj csu cM cN cfz co cB cabs cfv vm csu cmul co cle wbr cK cJ cuz cfv
      wcel cA cc wcel vj cJ cK cfz co wral wa cN cM cuz cfv wcel cB cc wcel vm
      cM cN cfz co wral wa cJ cK cfz co cA vj csu cabs cfv cJ cK cfz co cA cabs
      cfv vj csu cM cN cfz co cB vm csu cabs cfv cM cN cfz co cB cabs cfv vm
      csu lemul12aOLD cK cJ cuz cfv wcel cA cc wcel vj cJ cK cfz co wral wa cJ
      cK cfz co cA vj csu cabs cfv cr wcel cJ cK cfz co cA cabs cfv vj csu cr
      wcel cc0 cJ cK cfz co cA vj csu cabs cfv cle wbr cJ cK cfz co cA vj csu
      cabs cfv cJ cK cfz co cA cabs cfv vj csu cle wbr wa cK cJ cuz cfv wcel cA
      cc wcel vj cJ cK cfz co wral wa cJ cK cfz co cA vj csu cc wcel cJ cK cfz
      co cA vj csu cabs cfv cr wcel cA vj cJ cK fsumcl cJ cK cfz co cA vj csu
      abscl syl cK cJ cuz cfv wcel cA cabs cfv cr wcel vj cJ cK cfz co wral cJ
      cK cfz co cA cabs cfv vj csu cr wcel cA cc wcel vj cJ cK cfz co wral cA
      cabs cfv vj cJ cK fsumrecl cA cc wcel cA cabs cfv cr wcel vj cJ cK cfz co
      cA abscl r19.20si sylan2 cK cJ cuz cfv wcel cA cc wcel vj cJ cK cfz co
      wral wa cc0 cJ cK cfz co cA vj csu cabs cfv cle wbr cJ cK cfz co cA vj
      csu cabs cfv cJ cK cfz co cA cabs cfv vj csu cle wbr cK cJ cuz cfv wcel
      cA cc wcel vj cJ cK cfz co wral wa cJ cK cfz co cA vj csu cc wcel cc0 cJ
      cK cfz co cA vj csu cabs cfv cle wbr cA vj cJ cK fsumcl cJ cK cfz co cA
      vj csu absge0 syl cA vj cJ cK fsumabs jca jca31 cN cM cuz cfv wcel cB cc
      wcel vm cM cN cfz co wral wa cM cN cfz co cB vm csu cabs cfv cr wcel cM
      cN cfz co cB cabs cfv vm csu cr wcel cc0 cM cN cfz co cB vm csu cabs cfv
      cle wbr cM cN cfz co cB vm csu cabs cfv cM cN cfz co cB cabs cfv vm csu
      cle wbr wa cN cM cuz cfv wcel cB cc wcel vm cM cN cfz co wral wa cM cN
      cfz co cB vm csu cc wcel cM cN cfz co cB vm csu cabs cfv cr wcel cB vm cM
      cN fsumcl cM cN cfz co cB vm csu abscl syl cN cM cuz cfv wcel cB cabs cfv
      cr wcel vm cM cN cfz co wral cM cN cfz co cB cabs cfv vm csu cr wcel cB
      cc wcel vm cM cN cfz co wral cB cabs cfv vm cM cN fsumrecl cB cc wcel cB
      cabs cfv cr wcel vm cM cN cfz co cB abscl r19.20si sylan2 cN cM cuz cfv
      wcel cB cc wcel vm cM cN cfz co wral wa cc0 cM cN cfz co cB vm csu cabs
      cfv cle wbr cM cN cfz co cB vm csu cabs cfv cM cN cfz co cB cabs cfv vm
      csu cle wbr cN cM cuz cfv wcel cB cc wcel vm cM cN cfz co wral wa cM cN
      cfz co cB vm csu cc wcel cc0 cM cN cfz co cB vm csu cabs cfv cle wbr cB
      vm cM cN fsumcl cM cN cfz co cB vm csu absge0 syl cB vm cM cN fsumabs jca
      jca31 syl2an eqbrtrd $.
      $( [30-Dec-2006] $) $( [13-Nov-2005] $)
  $}

  ${
    $d k F $.  $d k M $.  $d k N $.
    serzclt.1 $e |- F e. _V $.
    $( Closure of partial sums of an infinite series. $)
    serzcl $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
               ( F ` k ) e. CC ) -> ( ( <. M , + >. seq F ) ` N ) e. CC ) $=
      cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cN cfz co wral wa cM cN cfz
      co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv cc cN cM cuz cfv
      wcel cM cN cfz co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv
      wceq vk cv cF cfv cc wcel vk cM cN cfz co wral vk cF cM cN serzclt.1
      fsumserz adantr vk cv cF cfv vk cM cN fsumcl eqeltrrd $.
      $( [4-Jan-2006] $) $( [3-Oct-2005] $)

    $( Closure of partial sums of a 0-based infinite series. $)
    ser0cl $p |- ( ( N e. NN0 /\ A. k e. ( 0 ... N )
               ( F ` k ) e. CC ) -> ( ( + seq0 F ) ` N ) e. CC ) $=
      cN cn0 wcel vk cv cF cfv cc wcel vk cc0 cN cfz co wral wa cN cc0 caddc
      cop cF cseqz co cfv cc cN caddc cF cseq0 co cfv cN cc0 cuz cfv wcel vk cv
      cF cfv cc wcel vk cc0 cN cfz co wral cN cc0 caddc cop cF cseqz co cfv cc
      wcel cN cn0 wcel vk cF cc0 cN serzclt.1 serzcl cN elnn0uz sylanb cN caddc
      cF cseq0 co cc0 caddc cop cF cseqz co caddc cF addex serzclt.1 seq0seqz
      fveq1i syl5eqel $.
      $( [17-Jul-2006] $) $( [6-Jun-2006] $)

    $( Closure of partial sums of a 1-based infinite series. $)
    ser1cl $p |- ( ( N e. NN /\ A. k e. ( 1 ... N )
               ( F ` k ) e. CC ) -> ( ( + seq1 F ) ` N ) e. CC ) $=
      cN cn wcel vk cv cF cfv cc wcel vk c1 cN cfz co wral wa cN c1 caddc cop
      cF cseqz co cfv cc cN caddc cF cseq1 co cfv cN c1 cuz cfv wcel vk cv cF
      cfv cc wcel vk c1 cN cfz co wral cN c1 caddc cop cF cseqz co cfv cc wcel
      cN cn wcel vk cF c1 cN serzclt.1 serzcl cN elnnuz sylanb cN caddc cF
      cseq1 co c1 caddc cop cF cseqz co caddc cF addex serzclt.1 seq1seqz
      fveq1i syl5eqel $.
      $( [21-Jul-2006] $) $( [6-Jun-2006] $)
  $}

  ${
    $d k x F $.  $d k x N $.
    ser1ser0.1 $e |- F e. _V $.
    ser1ser0.2 $e |- ( k e. NN0 -> ( F ` k ) e. CC ) $.
    $( A 1-based infinite series in terms of a 0-based infinite series. $)
    ser1ser0i $p |- ( N e. NN -> ( ( + seq1 F ) ` N ) =
                   ( ( ( + seq0 F ) ` N ) - ( F ` 0 ) ) ) $=
      cN cn wcel cN caddc cF cseq0 co cfv cc0 cF cfv cmin co cN caddc cF cseq1
      co cfv cN cn wcel cN caddc cF cseq0 co cfv cc0 cF cfv cmin co cN caddc cF
      cseq1 co cfv wceq cc0 cF cfv cN caddc cF cseq1 co cfv caddc co cN caddc
      cF cseq0 co cfv wceq cN cn wcel cc0 cN cfz co vk cv cF cfv vk csu cc0 cN
      cN cmin co cfz co vk cv cF cfv vk csu cN cN cmin co c1 caddc co cN cfz co
      vk cv cF cfv vk csu caddc co cN caddc cF cseq0 co cfv cc0 cF cfv cN caddc
      cF cseq1 co cfv caddc co cN cz wcel cN c1 cN cfz co wcel vk cv cF cfv cc
      wcel vk cc0 cN cfz co wral cc0 cN cfz co vk cv cF cfv vk csu cc0 cN cN
      cmin co cfz co vk cv cF cfv vk csu cN cN cmin co c1 caddc co cN cfz co vk
      cv cF cfv vk csu caddc co wceq cN cn wcel vk cv cF cfv vk cN cN
      fsum0split cN nnz cN cn wcel cN c1 cuz cfv wcel cN c1 cN cfz co wcel cN
      elnnuz c1 cN eluzfz2 sylbi vk cv cF cfv cc wcel vk cc0 cN cfz co wral cN
      cn wcel vk cv cF cfv cc wcel vk cc0 cN cfz co vk cv cc0 cN cfz co wcel vk
      cv cn0 wcel vk cv cF cfv cc wcel vk cv cN elfznn0 ser1ser0.2 syl rgen a1i
      syl3anc cN cn wcel cN cn0 wcel cc0 cN cfz co vk cv cF cfv vk csu cN caddc
      cF cseq0 co cfv wceq cN nnnn0 vx vk cF cN ser1ser0.1 vx cv cF wcel vk
      ax-17 fsumser0fi syl cN cn wcel cc0 cN cN cmin co cfz co vk cv cF cfv vk
      csu cc0 cF cfv cN cN cmin co c1 caddc co cN cfz co vk cv cF cfv vk csu cN
      caddc cF cseq1 co cfv caddc cN cn wcel cc0 cN cN cmin co cfz co vk cv cF
      cfv vk csu cc0 caddc cF cseq0 co cfv cc0 cF cfv cN cn wcel cc0 cN cN cmin
      co cfz co vk cv cF cfv vk csu cc0 cc0 cfz co vk cv cF cfv vk csu cc0
      caddc cF cseq0 co cfv cN cn wcel cc0 cN cN cmin co cfz co cc0 cc0 cfz co
      vk cv cF cfv vk cN cn wcel cN cN cmin co cc0 cc0 cfz cN cn wcel cN cc
      wcel cN cN cmin co cc0 wceq cN nncn cN subid syl opreq2d sumeq1d cc0 cn0
      wcel cc0 cc0 cfz co vk cv cF cfv vk csu cc0 caddc cF cseq0 co cfv wceq
      0nn0 vx vk cF cc0 ser1ser0.1 vx cv cF wcel vk ax-17 fsumser0fi ax-mp
      syl6eq caddc cF addex ser1ser0.1 seq00 syl6eq cN cn wcel cN cN cmin co c1
      caddc co cN cfz co vk cv cF cfv vk csu c1 cN cfz co vk cv cF cfv vk csu
      cN caddc cF cseq1 co cfv cN cn wcel cN cN cmin co c1 caddc co cN cfz co
      c1 cN cfz co vk cv cF cfv vk cN cn wcel cN cN cmin co c1 caddc co c1 cN
      cfz cN cn wcel cN cN cmin co c1 caddc co cc0 c1 caddc co c1 cN cn wcel cN
      cN cmin co cc0 c1 caddc cN cn wcel cN cc wcel cN cN cmin co cc0 wceq cN
      nncn cN subid syl opreq1d c1 ax1cn addid2i syl6eq opreq1d sumeq1d vx vk
      cF cN ser1ser0.1 vx cv cF wcel vk ax-17 fsumser1fi eqtrd opreq12d
      3eqtr3rd cN caddc cF cseq0 co cfv cc wcel cc0 cF cfv cc wcel cN caddc cF
      cseq1 co cfv cc wcel cN caddc cF cseq0 co cfv cc0 cF cfv cmin co cN caddc
      cF cseq1 co cfv wceq cc0 cF cfv cN caddc cF cseq1 co cfv caddc co cN
      caddc cF cseq0 co cfv wceq wb cN cn wcel cN caddc cF cseq0 co cfv cc0 cF
      cfv cN caddc cF cseq1 co cfv subadd cN cn0 wcel vk cv cF cfv cc wcel vk
      cc0 cN cfz co wral cN caddc cF cseq0 co cfv cc wcel cN cn wcel vk cF cN
      ser1ser0.1 ser0cl cN nnnn0 vk cv cF cfv cc wcel vk cc0 cN cfz co vk cv
      cc0 cN cfz co wcel vk cv cn0 wcel vk cv cF cfv cc wcel vk cv cN elfznn0
      ser1ser0.2 syl rgen sylancl cc0 cF cfv cc wcel cN cn wcel cc0 cn0 wcel
      cc0 cF cfv cc wcel 0nn0 vk cv cF cfv cc wcel cc0 cF cfv cc wcel vk cc0
      cn0 vk cv cc0 wceq vk cv cF cfv cc0 cF cfv cc vk cv cc0 cF fveq2 eleq1d
      ser1ser0.2 vtoclga ax-mp a1i cN cn wcel vk cv cF cfv cc wcel vk c1 cN cfz
      co wral cN caddc cF cseq1 co cfv cc wcel vk cv cF cfv cc wcel vk c1 cN
      cfz co vk cv c1 cN cfz co wcel vk cv cn wcel vk cv cn0 wcel vk cv cF cfv
      cc wcel vk cv cN elfznn vk cv nnnn0 ser1ser0.2 3syl rgen vk cF cN
      ser1ser0.1 ser1cl mpan2 syl3anc mpbird eqcomd $.
      $( [9-Dec-2006] $) $( [6-Jun-2006] $)
  $}

  ${
    $d j k F $.  $d j k M $.  $d j N $.
    serzcl2t.1 $e |- F e. _V $.
    $( Closure of partial sums of an infinite series. $)
    serzcl2 $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( ZZ>= ` M )
               ( F ` k ) e. CC ) -> ( ( <. M , + >. seq F ) ` N ) e. CC ) $=
      cN cM cuz cfv wcel vj cv cF cfv cc wcel vj cM cN cfz co wral cN cM caddc
      cop cF cseqz co cfv cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vj cF
      cM cN serzcl2t.1 serzcl vk cv cF cfv cc wcel vk cM cuz cfv wral vj cv cF
      cfv cc wcel vj cM cN cfz co vk cv cF cfv cc wcel vk cM cuz cfv wral vj cv
      cM cuz cfv wcel vj cv cF cfv cc wcel vj cv cM cN cfz co wcel vk cv cF cfv
      cc wcel vj cv cF cfv cc wcel vk vj cv cM cuz cfv vk cv vj cv wceq vk cv
      cF cfv vj cv cF cfv cc vk cv vj cv cF fveq2 eleq1d rcla4cv vj cv cM cN
      elfzuz syl5 r19.21aiv sylan2 $.
      $( [29-Jul-2006] $) $( [3-Oct-2005] $)
  $}

  ${
    $d k F $.  $d k M $.  $d k N $.
    serzreclt.1 $e |- F e. _V $.
    $( The partial sums in an infinite series of real terms are real. $)
    serzrecl $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
               ( F ` k ) e. RR ) -> ( ( <. M , + >. seq F ) ` N ) e. RR ) $=
      cN cM cuz cfv wcel vk cv cF cfv cr wcel vk cM cN cfz co wral wa cM cN cfz
      co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv cr cN cM cuz cfv
      wcel cM cN cfz co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv
      wceq vk cv cF cfv cr wcel vk cM cN cfz co wral vk cF cM cN serzreclt.1
      fsumserz adantr vk cv cF cfv vk cM cN fsumrecl eqeltrrd $.
      $( [24-Mar-2006] $) $( [25-Dec-2005] $)
  $}

  ${
    $d j k F $.  $d j k M $.  $d j N $.
    serzref.1 $e |- M e. ZZ $.
    serzref.2 $e |- F : ( ZZ>= ` M ) --> RR $.
    $( An infinite series of reals is an infinite real sequence. $)
    serzrefi $p |- ( <. M , + >. seq F ) : ( ZZ>= ` M ) --> RR $=
      cM cuz cfv cr cM caddc cop cF cseqz co wf cM caddc cop cF cseqz co cM cuz
      cfv wfn vk cv cM caddc cop cF cseqz co cfv cr wcel vk cM cuz cfv wral vk
      cM cuz cfv cr cM caddc cop cF cseqz co ffnfv cM cz wcel cM caddc cop cF
      cseqz co cM cuz cfv wfn serzref.1 caddc cF cM addex cM cuz cfv cr cF wf
      cM cuz cfv cvv wcel cF cvv wcel serzref.2 cM cuz fvex cM cuz cfv cr cvv
      cF fex mp2an seqzfn ax-mp vk cv cM caddc cop cF cseqz co cfv cr wcel vk
      cM cuz cfv vk cv cM cuz cfv wcel vj cv cF cfv cr wcel vj cM vk cv cfz co
      wral vk cv cM caddc cop cF cseqz co cfv cr wcel vj cv cF cfv cr wcel vj
      cM vk cv cfz co vj cv cM vk cv cfz co wcel vj cv cM cuz cfv wcel vj cv cF
      cfv cr wcel vj cv cM vk cv elfzuz cM cuz cfv cr vj cv cF serzref.2
      ffvelrni syl rgen vj cF cM vk cv cM cuz cfv cr cF wf cM cuz cfv cvv wcel
      cF cvv wcel serzref.2 cM cuz fvex cM cuz cfv cr cvv cF fex mp2an serzrecl
      mpan2 rgen mpbir2an $.
      $( [20-Oct-2005] $) $( [5-Sep-2005] $)
  $}

  ${
    $d k F $.  $d k M $.  $d k N $.
    serz1p.1 $e |- F e. _V $.
    $( Separate out the first term in an infinite series. $)
    serz1p $p |- ( ( N e. ( ZZ>= ` M ) /\ M < N /\
       A. k e. ( M ... N ) ( F ` k ) e. CC ) -> ( ( <. M , + >. seq F ) ` N ) =
                 ( ( F ` M ) + ( ( <. ( M + 1 ) , + >. seq F ) ` N ) ) ) $=
      cN cM cuz cfv wcel cM cN clt wbr vk cv cF cfv cc wcel vk cM cN cfz co
      wral w3a cM cN cfz co vk cv cF cfv vk csu cM cF cfv cM c1 caddc co cN cfz
      co vk cv cF cfv vk csu caddc co cN cM caddc cop cF cseqz co cfv cM cF cfv
      cN cM c1 caddc co caddc cop cF cseqz co cfv caddc co vk cv cF cfv cM cF
      cfv vk cM cN vk cv cM cF fveq2 fsum1p cN cM cuz cfv wcel cM cN clt wbr cM
      cN cfz co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv wceq vk cv
      cF cfv cc wcel vk cM cN cfz co wral vk cF cM cN serz1p.1 fsumserz
      3ad2ant1 cN cM cuz cfv wcel cM cN clt wbr cM cF cfv cM c1 caddc co cN cfz
      co vk cv cF cfv vk csu caddc co cM cF cfv cN cM c1 caddc co caddc cop cF
      cseqz co cfv caddc co wceq vk cv cF cfv cc wcel vk cM cN cfz co wral cN
      cM cuz cfv wcel cM cN clt wbr wa cM c1 caddc co cN cfz co vk cv cF cfv vk
      csu cN cM c1 caddc co caddc cop cF cseqz co cfv cM cF cfv caddc cN cM cuz
      cfv wcel cM cN clt wbr wa cN cM c1 caddc co cuz cfv wcel cM c1 caddc co
      cN cfz co vk cv cF cfv vk csu cN cM c1 caddc co caddc cop cF cseqz co cfv
      wceq cN cM cuz cfv wcel cN cM c1 caddc co cuz cfv wcel cM cN clt wbr cM
      cz wcel cN cz wcel cN cM c1 caddc co cuz cfv wcel cM cN clt wbr wb cN cM
      cuz cfv wcel cM cz wcel cN cz wcel wa cN cM c1 caddc co cuz cfv wcel cM
      c1 caddc co cN cle wbr cM cN clt wbr cM c1 caddc co cz wcel cN cz wcel cN
      cM c1 caddc co cuz cfv wcel cM c1 caddc co cN cle wbr wb cM cz wcel cM c1
      caddc co cN eluz cM peano2z sylan cM cN zltp1le bitr4d cM cN eluzel2 cM
      cN eluzelz sylanc biimpar vk cF cM c1 caddc co cN serz1p.1 fsumserz syl
      opreq2d 3adant3 3eqtr3d $.
      $( [4-Jan-2006] $) $( [1-Jan-2006] $)
  $}

  ${
    $d k M $.  $d k N $.
    $( The value of the partial sums in a zero-valued infinite series. $)
    serz0 $p |- ( N e. ( ZZ>= ` M ) ->
               ( ( <. M , + >. seq ( ( ZZ>= ` M ) X. { 0 } ) ) ` N ) = 0 ) $=
      cN cM cuz cfv wcel cM cN cfz co vk cv cM cuz cfv cc0 csn cxp cfv vk csu
      cN cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cfv cc0 vk cM cuz cfv cc0
      csn cxp cM cN cM cuz cfv cc0 csn cM cuz fvex cc0 snex xpex fsumserz cN cM
      cuz cfv wcel vk cv cM cuz cfv cc0 csn cxp cfv cc0 wceq vk cM cN cfz co
      wral cM cN cfz co vk cv cM cuz cfv cc0 csn cxp cfv vk csu cc0 wceq vk cv
      cM cuz cfv cc0 csn cxp cfv cc0 wceq vk cM cN cfz co vk cv cM cN cfz co
      wcel vk cv cM cuz cfv wcel vk cv cM cuz cfv cc0 csn cxp cfv cc0 wceq vk
      cv cM cN elfzuz cM cuz cfv cc0 vk cv cc0 cc 0cn elisseti fvconst2 syl
      rgen vk cv cM cuz cfv cc0 csn cxp cfv cc0 wceq vk cM cN cfz co wral cN cM
      cuz cfv wcel cM cN cfz co vk cv cM cuz cfv cc0 csn cxp cfv vk csu cM cN
      cfz co cc0 vk csu cc0 cM cN cfz co vk cv cM cuz cfv cc0 csn cxp cfv cc0
      vk sumeq2 vk cM cN fsum0 sylan9eqr mpan2 eqtr3d $.
      $( [5-Aug-2006] $) $( [27-Dec-2005] $)
  $}

  ${
    $d k F $.  $d k G $.  $d k M $.  $d k N $.
    serzcmp.1 $e |- F e. _V $.
    serzcmp.2 $e |- G e. _V $.
    $( Comparison of partial sums of two infinite series of reals. $)
    serzcmp $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N ) ( ( F ` k ) e.
      RR /\ ( G ` k ) e. RR /\ ( F ` k ) <_ ( G ` k ) ) ) ->
        ( ( <. M , + >. seq F ) ` N ) <_ ( ( <. M , + >. seq G ) ` N ) ) $=
      cN cM cuz cfv wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv
      vk cv cG cfv cle wbr w3a vk cM cN cfz co wral wa cM cN cfz co vk cv cF
      cfv vk csu cM cN cfz co vk cv cG cfv vk csu cN cM caddc cop cF cseqz co
      cfv cN cM caddc cop cG cseqz co cfv cle vk cv cF cfv vk cv cG cfv vk cM
      cN fsumcmp cN cM cuz cfv wcel cM cN cfz co vk cv cF cfv vk csu cN cM
      caddc cop cF cseqz co cfv wceq vk cv cF cfv cr wcel vk cv cG cfv cr wcel
      vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cN cfz co wral vk cF cM cN
      serzcmp.1 fsumserz adantr cN cM cuz cfv wcel cM cN cfz co vk cv cG cfv vk
      csu cN cM caddc cop cG cseqz co cfv wceq vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cN cfz co wral vk
      cG cM cN serzcmp.2 fsumserz adantr 3brtr3d $.
      $( [13-Aug-2006] $) $( [27-Dec-2005] $)
  $}

  ${
    $d k F $.  $d k G $.  $d k M $.  $d k N $.
    serzcmp0.1 $e |- F e. _V $.
    $( A partial sum of an infinite series is nonnegative if each term is
       nonnegative. $)
    serzcmp0 $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N ) ( ( F ` k )
         e. RR /\ 0 <_ ( F ` k ) ) ) -> 0 <_ ( ( <. M , + >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM
      cN cfz co wral wa cN cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cfv cc0
      cN cM caddc cop cF cseqz co cfv cle cN cM cuz cfv wcel cN cM caddc cop cM
      cuz cfv cc0 csn cxp cseqz co cfv cc0 wceq vk cv cF cfv cr wcel cc0 vk cv
      cF cfv cle wbr wa vk cM cN cfz co wral cM cN serz0 adantr cN cM cuz cfv
      wcel vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cF cfv cr wcel vk cv
      cM cuz cfv cc0 csn cxp cfv vk cv cF cfv cle wbr w3a vk cM cN cfz co wral
      cN cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cfv cN cM caddc cop cF
      cseqz co cfv cle wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk
      cM cN cfz co wral vk cM cuz cfv cc0 csn cxp cF cM cN cM cuz cfv cc0 csn
      cM cuz fvex cc0 snex xpex serzcmp0.1 serzcmp vk cv cF cfv cr wcel cc0 vk
      cv cF cfv cle wbr wa vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cF
      cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF cfv cle wbr w3a vk
      cM cN cfz co vk cv cM cN cfz co wcel vk cv cF cfv cr wcel cc0 vk cv cF
      cfv cle wbr wa wa vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cF cfv
      cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF cfv cle wbr vk cv cM cN
      cfz co wcel vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cF cfv cr wcel
      cc0 vk cv cF cfv cle wbr wa vk cv cM cN cfz co wcel vk cv cM cuz cfv cc0
      csn cxp cfv cc0 cr vk cv cM cN cfz co wcel vk cv cM cuz cfv wcel vk cv cM
      cuz cfv cc0 csn cxp cfv cc0 wceq vk cv cM cN elfzuz cM cuz cfv cc0 vk cv
      cc0 cr 0re elisseti fvconst2 syl 0re syl6eqel adantr vk cv cM cN cfz co
      wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr simprl vk cv cM cN cfz
      co wcel cc0 vk cv cF cfv cle wbr vk cv cM cuz cfv cc0 csn cxp cfv vk cv
      cF cfv cle wbr vk cv cF cfv cr wcel vk cv cM cN cfz co wcel vk cv cM cuz
      cfv cc0 csn cxp cfv vk cv cF cfv cle wbr cc0 vk cv cF cfv cle wbr vk cv
      cM cN cfz co wcel vk cv cM cuz cfv cc0 csn cxp cfv cc0 vk cv cF cfv cle
      vk cv cM cN cfz co wcel vk cv cM cuz cfv wcel vk cv cM cuz cfv cc0 csn
      cxp cfv cc0 wceq vk cv cM cN elfzuz cM cuz cfv cc0 vk cv cc0 cr 0re
      elisseti fvconst2 syl breq1d biimpar adantrl 3jca r19.20ia sylan2
      eqbrtrrd $.
      $( [21-Sep-2006] $) $( [27-Dec-2005] $)
  $}

  ${
    $d k F $.  $d k M $.  $d k N $.
    serzsplit.1 $e |- F e. _V $.
    $( Split off an initial piece of the partial sum of an infinite series. $)
    serzsplit $p |- ( ( N e. ZZ /\ K e. ( M ... ( N - 1 ) )
       /\ A. k e. ( M ... N ) ( F ` k ) e. CC ) ->
     ( ( <. M , + >. seq F ) ` N ) = ( ( ( <. M , + >. seq F ) ` K ) +
        ( ( <. ( K + 1 ) , + >. seq F ) ` N ) ) ) $=
      cN cz wcel cK cM cN c1 cmin co cfz co wcel vk cv cF cfv cc wcel vk cM cN
      cfz co wral w3a cM cN cfz co vk cv cF cfv vk csu cM cK cfz co vk cv cF
      cfv vk csu cK c1 caddc co cN cfz co vk cv cF cfv vk csu caddc co cN cM
      caddc cop cF cseqz co cfv cK cM caddc cop cF cseqz co cfv cN cK c1 caddc
      co caddc cop cF cseqz co cfv caddc co vk cv cF cfv vk cK cM cN fsumsplit
      cN cz wcel cK cM cN c1 cmin co cfz co wcel cM cN cfz co vk cv cF cfv vk
      csu cN cM caddc cop cF cseqz co cfv wceq vk cv cF cfv cc wcel vk cM cN
      cfz co wral cN cz wcel cK cM cN c1 cmin co cfz co wcel wa cN cM cuz cfv
      wcel cM cN cfz co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv
      wceq cN cz wcel cK cM cN c1 cmin co cfz co wcel wa cN c1 cmin co c1 caddc
      co cN cM cuz cfv cN cz wcel cN c1 cmin co c1 caddc co cN wceq cK cM cN c1
      cmin co cfz co wcel cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN
      wceq cN cz wcel cN c1 npcan cN zcn ax1cn sylancl adantr cK cM cN c1 cmin
      co cfz co wcel cN c1 cmin co c1 caddc co cM cuz cfv wcel cN cz wcel cK cM
      cN c1 cmin co cfz co wcel cN c1 cmin co cM cuz cfv wcel cN c1 cmin co c1
      caddc co cM cuz cfv wcel cN c1 cmin co cvv wcel cK cM cN c1 cmin co cfz
      co wcel cN c1 cmin co cM cuz cfv wcel cN c1 cmin oprex cvv cK cM cN c1
      cmin co elfzuz2 mpan cM cN c1 cmin co peano2uz syl adantl eqeltrrd vk cF
      cM cN serzsplit.1 fsumserz syl 3adant3 cN cz wcel cK cM cN c1 cmin co cfz
      co wcel cM cK cfz co vk cv cF cfv vk csu cK c1 caddc co cN cfz co vk cv
      cF cfv vk csu caddc co cK cM caddc cop cF cseqz co cfv cN cK c1 caddc co
      caddc cop cF cseqz co cfv caddc co wceq vk cv cF cfv cc wcel vk cM cN cfz
      co wral cN cz wcel cK cM cN c1 cmin co cfz co wcel wa cM cK cfz co vk cv
      cF cfv vk csu cK cM caddc cop cF cseqz co cfv cK c1 caddc co cN cfz co vk
      cv cF cfv vk csu cN cK c1 caddc co caddc cop cF cseqz co cfv caddc cN cz
      wcel cK cM cN c1 cmin co cfz co wcel wa cK cM cuz cfv wcel cM cK cfz co
      vk cv cF cfv vk csu cK cM caddc cop cF cseqz co cfv wceq cK cM cN c1 cmin
      co cfz co wcel cK cM cuz cfv wcel cN cz wcel cK cM cN c1 cmin co elfzuz
      adantl vk cF cM cK serzsplit.1 fsumserz syl cN cz wcel cK cM cN c1 cmin
      co cfz co wcel wa cN cK c1 caddc co cuz cfv wcel cK c1 caddc co cN cfz co
      vk cv cF cfv vk csu cN cK c1 caddc co caddc cop cF cseqz co cfv wceq cN
      cz wcel cK cM cN c1 cmin co cfz co wcel wa cN c1 cmin co c1 caddc co cN
      cK c1 caddc co cuz cfv cN cz wcel cN c1 cmin co c1 caddc co cN wceq cK cM
      cN c1 cmin co cfz co wcel cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co
      cN wceq cN cz wcel cN c1 npcan cN zcn ax1cn sylancl adantr cK cM cN c1
      cmin co cfz co wcel cN c1 cmin co c1 caddc co cK c1 caddc co cuz cfv wcel
      cN cz wcel cK cM cN c1 cmin co cfz co wcel cN c1 cmin co cK cuz cfv wcel
      cN c1 cmin co c1 caddc co cK c1 caddc co cuz cfv wcel cN c1 cmin co cvv
      wcel cK cM cN c1 cmin co cfz co wcel cN c1 cmin co cK cuz cfv wcel cN c1
      cmin oprex cvv cK cM cN c1 cmin co elfzuz3 mpan cK cN c1 cmin co eluzp1p1
      syl adantl eqeltrrd vk cF cK c1 caddc co cN serzsplit.1 fsumserz syl
      opreq12d 3adant3 3eqtr3d $.
      $( [9-Jun-2006] $) $( [26-Dec-2005] $)

  $}

  ${
    $d k C $.  $d k F $.  $d k G $.  $d k M $.  $d k N $.
    serzmulc1.1 $e |- F e. _V $.
    serzmulc1.2 $e |- G e. _V $.
    $( A constant ` C ` times a series. $)
    serzmulc1 $p |- ( ( N e. ( ZZ>= ` M ) /\ C e. CC /\ A. k e. ( M ... N )
         ( ( F ` k ) e. CC /\ ( G ` k ) = ( C x. ( F ` k ) ) ) ) ->
    ( C x. ( ( <. M , + >. seq F ) ` N ) ) = ( ( <. M , + >. seq G ) ` N ) ) $=
      cN cM cuz cfv wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv
      cF cfv cmul co wceq wa vk cM cN cfz co wral w3a cM cN cfz co vk cv cG cfv
      vk csu cC cM cN cfz co vk cv cF cfv vk csu cmul co cN cM caddc cop cG
      cseqz co cfv cC cN cM caddc cop cF cseqz co cfv cmul co cN cM cuz cfv
      wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co
      wceq wa vk cM cN cfz co wral w3a cM cN cfz co vk cv cG cfv vk csu cM cN
      cfz co cC vk cv cF cfv cmul co vk csu cC cM cN cfz co vk cv cF cfv vk csu
      cmul co vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa
      vk cM cN cfz co wral cN cM cuz cfv wcel cM cN cfz co vk cv cG cfv vk csu
      cM cN cfz co cC vk cv cF cfv cmul co vk csu wceq cC cc wcel vk cv cF cfv
      cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cN cfz co wral
      cM cN cfz co vk cv cG cfv cC vk cv cF cfv cmul co vk vk cv cF cfv cc wcel
      vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cv cG cfv cC vk cv cF cfv
      cmul co wceq vk cM cN cfz co vk cv cF cfv cc wcel vk cv cG cfv cC vk cv
      cF cfv cmul co wceq pm3.27 r19.20si sumeq2d 3ad2ant3 cN cM cuz cfv wcel
      cC cc wcel vk cv cF cfv cc wcel vk cM cN cfz co wral cC cM cN cfz co vk
      cv cF cfv vk csu cmul co cM cN cfz co cC vk cv cF cfv cmul co vk csu wceq
      vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM
      cN cfz co wral vk cv cF cfv cC vk cM cN fsummulc1 vk cv cF cfv cc wcel vk
      cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cv cF cfv cc wcel vk cM cN
      cfz co vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq
      pm3.26 r19.20si syl3an3 eqtr4d cN cM cuz cfv wcel cC cc wcel cM cN cfz co
      vk cv cG cfv vk csu cN cM caddc cop cG cseqz co cfv wceq vk cv cF cfv cc
      wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cN cfz co wral vk
      cG cM cN serzmulc1.2 fsumserz 3ad2ant1 cN cM cuz cfv wcel cC cc wcel cC
      cM cN cfz co vk cv cF cfv vk csu cmul co cC cN cM caddc cop cF cseqz co
      cfv cmul co wceq vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul
      co wceq wa vk cM cN cfz co wral cN cM cuz cfv wcel cM cN cfz co vk cv cF
      cfv vk csu cN cM caddc cop cF cseqz co cfv cC cmul vk cF cM cN
      serzmulc1.1 fsumserz opreq2d 3ad2ant1 3eqtr3rd $.
      $( [2-Nov-2007] $) $( [1-Nov-2007] $)
  $}

  ${
    $d j k C $.  $d j k F $.  $d j k G $.  $d j k M $.  $d j N $.
    serzmulc.1 $e |- C e. CC $.
    serzmulc.2 $e |- F : ( ZZ>= ` M ) --> CC $.
    serzmulc.3 $e |- G e. _V $.
    serzmulc.4 $e |- ( k e. ( ZZ>= ` M ) ->
                     ( G ` k ) = ( C x. ( F ` k ) ) ) $.
    $( MAY BE REVISED - replace with serzmulc1 $)
    $( A constant ` C ` times a series. $)
    serzmulci $p |- ( N e. ( ZZ>= ` M ) -> ( ( <. M , + >. seq G ) ` N ) =
                   ( C x. ( ( <. M , + >. seq F ) ` N ) ) ) $=
      cN cM cuz cfv wcel cC cN cM caddc cop cF cseqz co cfv cmul co cN cM caddc
      cop cG cseqz co cfv cN cM cuz cfv wcel cC cc wcel cC cN cM caddc cop cF
      cseqz co cfv cmul co cN cM caddc cop cG cseqz co cfv wceq serzmulc.1 cN
      cM cuz cfv wcel cC cc wcel vj cv cF cfv cc wcel vj cv cG cfv cC vj cv cF
      cfv cmul co wceq wa vj cM cN cfz co wral cC cN cM caddc cop cF cseqz co
      cfv cmul co cN cM caddc cop cG cseqz co cfv wceq vj cv cF cfv cc wcel vj
      cv cG cfv cC vj cv cF cfv cmul co wceq wa vj cM cN cfz co vj cv cM cN cfz
      co wcel vj cv cM cuz cfv wcel vj cv cF cfv cc wcel vj cv cG cfv cC vj cv
      cF cfv cmul co wceq wa vj cv cM cN elfzuz vj cv cM cuz cfv wcel vj cv cF
      cfv cc wcel vj cv cG cfv cC vj cv cF cfv cmul co wceq cM cuz cfv cc vj cv
      cF serzmulc.2 ffvelrni vk cv cG cfv cC vk cv cF cfv cmul co wceq vj cv cG
      cfv cC vj cv cF cfv cmul co wceq vk vj cv cM cuz cfv vk cv vj cv wceq vk
      cv cG cfv vj cv cG cfv cC vk cv cF cfv cmul co cC vj cv cF cfv cmul co vk
      cv vj cv cG fveq2 vk cv vj cv wceq vk cv cF cfv vj cv cF cfv cC cmul vk
      cv vj cv cF fveq2 opreq2d eqeq12d serzmulc.4 vtoclga jca syl rgen cC vj
      cF cG cM cN cM cuz cfv cc cF wf cM cuz cfv cvv wcel cF cvv wcel
      serzmulc.2 cM cuz fvex cM cuz cfv cc cvv cF fex mp2an serzmulc.3
      serzmulc1 mp3an3 mpan2 eqcomd $.
      $( [21-Nov-2005] $) $( [7-Sep-2005] $)
  $}

  ${
    $d k F $.  $d k G $.  $d k C $.
    ser0mulc.1 $e |- C e. CC $.
    ser0mulc.2 $e |- F : NN0 --> CC $.
    ser0mulc.3 $e |- G e. _V $.
    ser0mulc.4 $e |- ( k e. NN0 -> ( G ` k ) = ( C x. ( F ` k ) ) ) $.
    $( MAY BE REVISED $)
    $( A constant ` C ` times a 0-based series. $)
    ser0mulci $p |- ( N e. NN0 ->
                    ( ( + seq0 G ) ` N ) = ( C x. ( ( + seq0 F ) ` N ) ) ) $=
      cN cn0 wcel cN cc0 caddc cop cG cseqz co cfv cC cN cc0 caddc cop cF cseqz
      co cfv cmul co cN caddc cG cseq0 co cfv cC cN caddc cF cseq0 co cfv cmul
      co cN cn0 wcel cN cc0 cuz cfv wcel cN cc0 caddc cop cG cseqz co cfv cC cN
      cc0 caddc cop cF cseqz co cfv cmul co wceq cN elnn0uz cC vk cF cG cc0 cN
      ser0mulc.1 cn0 cc cF wf cc0 cuz cfv cc cF wf ser0mulc.2 cn0 cc0 cuz cfv
      wceq cn0 cc cF wf cc0 cuz cfv cc cF wf wb nn0uz cn0 cc0 cuz cfv cc cF
      feq2 ax-mp mpbi ser0mulc.3 vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cG
      cfv cC vk cv cF cfv cmul co wceq vk cv elnn0uz ser0mulc.4 sylbir
      serzmulci sylbi cN caddc cG cseq0 co cc0 caddc cop cG cseqz co caddc cG
      addex ser0mulc.3 seq0seqz fveq1i cN caddc cF cseq0 co cfv cN cc0 caddc
      cop cF cseqz co cfv cC cmul cN caddc cF cseq0 co cc0 caddc cop cF cseqz
      co caddc cF addex cn0 cc cF wf cn0 cvv wcel cF cvv wcel ser0mulc.2 nn0ex
      cn0 cc cvv cF fex mp2an seq0seqz fveq1i opreq2i 3eqtr4g $.
      $( [28-Mar-2006] $) $( [9-Sep-2005] $)
  $}

  ${
    $d k F $.  $d k G $.  $d k C $.
    ser1mulc.1 $e |- C e. CC $.
    ser1mulc.2 $e |- F : NN --> CC $.
    ser1mulc.3 $e |- G e. _V $.
    ser1mulc.4 $e |- ( k e. NN -> ( G ` k ) = ( C x. ( F ` k ) ) ) $.
    $( MAY BE REVISED $)
    $( A constant ` C ` times a 1-based series. $)
    ser1mulci $p |- ( N e. NN ->
                    ( ( + seq1 G ) ` N ) = ( C x. ( ( + seq1 F ) ` N ) ) ) $=
      cN cn wcel cN c1 caddc cop cG cseqz co cfv cC cN c1 caddc cop cF cseqz co
      cfv cmul co cN caddc cG cseq1 co cfv cC cN caddc cF cseq1 co cfv cmul co
      cN cn wcel cN c1 cuz cfv wcel cN c1 caddc cop cG cseqz co cfv cC cN c1
      caddc cop cF cseqz co cfv cmul co wceq cN elnnuz cC vk cF cG c1 cN
      ser1mulc.1 cn cc cF wf c1 cuz cfv cc cF wf ser1mulc.2 cn c1 cuz cfv wceq
      cn cc cF wf c1 cuz cfv cc cF wf wb nnuz cn c1 cuz cfv cc cF feq2 ax-mp
      mpbi ser1mulc.3 vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cG cfv cC vk cv
      cF cfv cmul co wceq vk cv elnnuz ser1mulc.4 sylbir serzmulci sylbi cN
      caddc cG cseq1 co c1 caddc cop cG cseqz co caddc cG addex ser1mulc.3
      seq1seqz fveq1i cN caddc cF cseq1 co cfv cN c1 caddc cop cF cseqz co cfv
      cC cmul cN caddc cF cseq1 co c1 caddc cop cF cseqz co caddc cF addex cn
      cc cF wf cn cvv wcel cF cvv wcel ser1mulc.2 nnex cn cc cvv cF fex mp2an
      seq1seqz fveq1i opreq2i 3eqtr4g $.
      $( [6-Apr-2006] $) $( [9-Sep-2005] $)
  $}

  ${
    $d F j k m $.  $d G j k m $.  $d H j k m $.  $d M j k m $.  $d N j $.
    serzre.1 $e |- F e. _V $.
    serzre.2 $e |- G e. _V $.
    ${
      serzrelem.3 $e |- ( k e. ( ZZ>= ` M ) ->
                     ( ( F ` k ) e. CC /\ ( G ` k ) = ( H ` ( F ` k ) ) ) ) $.
      serzrelem.4 $e |- ( ( ( ( <. M , + >. seq F ) ` m ) e. CC /\
                          ( F ` ( m + 1 ) ) e. CC ) ->
    ( H ` ( ( ( <. M , + >. seq F ) ` m ) + ( F ` ( m + 1 ) ) ) ) =
    ( ( H ` ( ( <. M , + >. seq F ) ` m ) ) + ( H ` ( F ` ( m + 1 ) ) ) ) ) $.
      $( Lemma for ~ serzrei , ~ serzimi and ~ serzcji . $)
      serzrelem $p |- ( N e. ( ZZ>= ` M ) -> ( ( <. M , + >. seq G ) ` N ) =
                        ( H ` ( ( <. M , + >. seq F ) ` N ) ) ) $=
        vj cv cM caddc cop cG cseqz co cfv vj cv cM caddc cop cF cseqz co cfv
        cH cfv wceq cM cM caddc cop cG cseqz co cfv cM cM caddc cop cF cseqz co
        cfv cH cfv wceq vm cv cM caddc cop cG cseqz co cfv vm cv cM caddc cop
        cF cseqz co cfv cH cfv wceq vm cv c1 caddc co cM caddc cop cG cseqz co
        cfv vm cv c1 caddc co cM caddc cop cF cseqz co cfv cH cfv wceq cN cM
        caddc cop cG cseqz co cfv cN cM caddc cop cF cseqz co cfv cH cfv wceq
        vj vm cM cN vj cv cM wceq vj cv cM caddc cop cG cseqz co cfv cM cM
        caddc cop cG cseqz co cfv vj cv cM caddc cop cF cseqz co cfv cH cfv cM
        cM caddc cop cF cseqz co cfv cH cfv vj cv cM cM caddc cop cG cseqz co
        fveq2 vj cv cM wceq vj cv cM caddc cop cF cseqz co cfv cM cM caddc cop
        cF cseqz co cfv cH vj cv cM cM caddc cop cF cseqz co fveq2 fveq2d
        eqeq12d vj cv vm cv wceq vj cv cM caddc cop cG cseqz co cfv vm cv cM
        caddc cop cG cseqz co cfv vj cv cM caddc cop cF cseqz co cfv cH cfv vm
        cv cM caddc cop cF cseqz co cfv cH cfv vj cv vm cv cM caddc cop cG
        cseqz co fveq2 vj cv vm cv wceq vj cv cM caddc cop cF cseqz co cfv vm
        cv cM caddc cop cF cseqz co cfv cH vj cv vm cv cM caddc cop cF cseqz co
        fveq2 fveq2d eqeq12d vj cv vm cv c1 caddc co wceq vj cv cM caddc cop cG
        cseqz co cfv vm cv c1 caddc co cM caddc cop cG cseqz co cfv vj cv cM
        caddc cop cF cseqz co cfv cH cfv vm cv c1 caddc co cM caddc cop cF
        cseqz co cfv cH cfv vj cv vm cv c1 caddc co cM caddc cop cG cseqz co
        fveq2 vj cv vm cv c1 caddc co wceq vj cv cM caddc cop cF cseqz co cfv
        vm cv c1 caddc co cM caddc cop cF cseqz co cfv cH vj cv vm cv c1 caddc
        co cM caddc cop cF cseqz co fveq2 fveq2d eqeq12d vj cv cN wceq vj cv cM
        caddc cop cG cseqz co cfv cN cM caddc cop cG cseqz co cfv vj cv cM
        caddc cop cF cseqz co cfv cH cfv cN cM caddc cop cF cseqz co cfv cH cfv
        vj cv cN cM caddc cop cG cseqz co fveq2 vj cv cN wceq vj cv cM caddc
        cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cH vj cv cN cM
        caddc cop cF cseqz co fveq2 fveq2d eqeq12d cM cz wcel cM cG cfv cM cF
        cfv cH cfv cM cM caddc cop cG cseqz co cfv cM cM caddc cop cF cseqz co
        cfv cH cfv cM cz wcel cM cM cuz cfv wcel cM cG cfv cM cF cfv cH cfv
        wceq cM uzid vk cv cG cfv vk cv cF cfv cH cfv wceq cM cG cfv cM cF cfv
        cH cfv wceq vk cM cM cuz cfv vk cv cM wceq vk cv cG cfv cM cG cfv vk cv
        cF cfv cH cfv cM cF cfv cH cfv vk cv cM cG fveq2 vk cv cM wceq vk cv cF
        cfv cM cF cfv cH vk cv cM cF fveq2 fveq2d eqeq12d vk cv cM cuz cfv wcel
        vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv wceq serzrelem.3
        pm3.27d vtoclga syl caddc cG cM addex serzre.2 seqz1 cM cz wcel cM cM
        caddc cop cF cseqz co cfv cM cF cfv cH caddc cF cM addex serzre.1 seqz1
        fveq2d 3eqtr4d vm cv cM cuz cfv wcel vm cv cM caddc cop cG cseqz co cfv
        vm cv cM caddc cop cF cseqz co cfv cH cfv wceq vm cv c1 caddc co cM
        caddc cop cG cseqz co cfv vm cv c1 caddc co cM caddc cop cF cseqz co
        cfv cH cfv wceq vm cv cM cuz cfv wcel vm cv cM caddc cop cG cseqz co
        cfv vm cv cM caddc cop cF cseqz co cfv cH cfv wceq wa vm cv c1 caddc co
        cM caddc cop cG cseqz co cfv vm cv cM caddc cop cF cseqz co cfv cH cfv
        vm cv c1 caddc co cG cfv caddc co vm cv c1 caddc co cM caddc cop cF
        cseqz co cfv cH cfv vm cv cM cuz cfv wcel vm cv cM caddc cop cG cseqz
        co cfv vm cv cM caddc cop cF cseqz co cfv cH cfv wceq vm cv c1 caddc co
        cM caddc cop cG cseqz co cfv vm cv cM caddc cop cG cseqz co cfv vm cv
        c1 caddc co cG cfv caddc co vm cv cM caddc cop cF cseqz co cfv cH cfv
        vm cv c1 caddc co cG cfv caddc co caddc cG cM vm cv addex serzre.2
        seqzp1 vm cv cM caddc cop cG cseqz co cfv vm cv cM caddc cop cF cseqz
        co cfv cH cfv vm cv c1 caddc co cG cfv caddc opreq1 sylan9eq vm cv cM
        cuz cfv wcel vm cv cM caddc cop cF cseqz co cfv cH cfv vm cv c1 caddc
        co cG cfv caddc co vm cv c1 caddc co cM caddc cop cF cseqz co cfv cH
        cfv wceq vm cv cM caddc cop cG cseqz co cfv vm cv cM caddc cop cF cseqz
        co cfv cH cfv wceq vm cv cM cuz cfv wcel vm cv cM caddc cop cF cseqz co
        cfv vm cv c1 caddc co cF cfv caddc co cH cfv vm cv cM caddc cop cF
        cseqz co cfv cH cfv vm cv c1 caddc co cF cfv cH cfv caddc co vm cv c1
        caddc co cM caddc cop cF cseqz co cfv cH cfv vm cv cM caddc cop cF
        cseqz co cfv cH cfv vm cv c1 caddc co cG cfv caddc co vm cv cM caddc
        cop cF cseqz co cfv cc wcel vm cv c1 caddc co cF cfv cc wcel vm cv cM
        caddc cop cF cseqz co cfv vm cv c1 caddc co cF cfv caddc co cH cfv vm
        cv cM caddc cop cF cseqz co cfv cH cfv vm cv c1 caddc co cF cfv cH cfv
        caddc co wceq vm cv cM cuz cfv wcel serzrelem.4 vm cv cM cuz cfv wcel
        vk cv cF cfv cc wcel vk cM cuz cfv wral vm cv cM caddc cop cF cseqz co
        cfv cc wcel vk cv cF cfv cc wcel vk cM cuz cfv vk cv cM cuz cfv wcel vk
        cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv wceq serzrelem.3
        pm3.26d rgen vk cF cM vm cv serzre.1 serzcl2 mpan2 vm cv cM cuz cfv
        wcel vm cv c1 caddc co cM cuz cfv wcel vm cv c1 caddc co cF cfv cc wcel
        cM vm cv peano2uz vk cv cF cfv cc wcel vm cv c1 caddc co cF cfv cc wcel
        vk vm cv c1 caddc co cM cuz cfv vk cv vm cv c1 caddc co wceq vk cv cF
        cfv vm cv c1 caddc co cF cfv cc vk cv vm cv c1 caddc co cF fveq2 eleq1d
        vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH
        cfv wceq serzrelem.3 pm3.26d vtoclga syl sylanc vm cv cM cuz cfv wcel
        vm cv c1 caddc co cM caddc cop cF cseqz co cfv vm cv cM caddc cop cF
        cseqz co cfv vm cv c1 caddc co cF cfv caddc co cH caddc cF cM vm cv
        addex serzre.1 seqzp1 fveq2d vm cv cM cuz cfv wcel vm cv c1 caddc co cG
        cfv vm cv c1 caddc co cF cfv cH cfv vm cv cM caddc cop cF cseqz co cfv
        cH cfv caddc vm cv cM cuz cfv wcel vm cv c1 caddc co cM cuz cfv wcel vm
        cv c1 caddc co cG cfv vm cv c1 caddc co cF cfv cH cfv wceq cM vm cv
        peano2uz vk cv cG cfv vk cv cF cfv cH cfv wceq vm cv c1 caddc co cG cfv
        vm cv c1 caddc co cF cfv cH cfv wceq vk vm cv c1 caddc co cM cuz cfv vk
        cv vm cv c1 caddc co wceq vk cv cG cfv vm cv c1 caddc co cG cfv vk cv
        cF cfv cH cfv vm cv c1 caddc co cF cfv cH cfv vk cv vm cv c1 caddc co
        cG fveq2 vk cv vm cv c1 caddc co wceq vk cv cF cfv vm cv c1 caddc co cF
        cfv cH vk cv vm cv c1 caddc co cF fveq2 fveq2d eqeq12d vk cv cM cuz cfv
        wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv wceq
        serzrelem.3 pm3.27d vtoclga syl opreq2d 3eqtr4rd adantr eqtrd ex uzind4
        $.
        $( [10-Nov-2007] $) $( [9-Nov-2007] $)
    $}

    ${
      serzre.3 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                       ( G ` k ) = ( Re ` ( F ` k ) ) ) ) $.
      $( The real part of a series.  (Contributed by Paul Chapman,
         9-Nov-2007.) $)
      serzrei $p |- ( N e. ( ZZ>= ` M ) -> ( ( <. M , + >. seq G ) ` N ) =
                     ( Re ` ( ( <. M , + >. seq F ) ` N ) ) ) $=
        vk vm cF cG cre cM cN serzre.1 serzre.2 serzre.3 vm cv cM caddc cop cF
        cseqz co cfv vm cv c1 caddc co cF cfv readd serzrelem $.
        $( [10-Nov-2007] $) $( [9-Nov-2007] $)
    $}

    ${
      serzim.3 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                       ( G ` k ) = ( Im ` ( F ` k ) ) ) ) $.
      $( The imaginary part of a series.  (Contributed by Paul Chapman,
         9-Nov-2007.) $)
      serzimi $p |- ( N e. ( ZZ>= ` M ) -> ( ( <. M , + >. seq G ) ` N ) =
                     ( Im ` ( ( <. M , + >. seq F ) ` N ) ) ) $=
        vk vm cF cG cim cM cN serzre.1 serzre.2 serzim.3 vm cv cM caddc cop cF
        cseqz co cfv vm cv c1 caddc co cF cfv imadd serzrelem $.
        $( [10-Nov-2007] $) $( [9-Nov-2007] $)
    $}

    ${
      serzcj.3 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                       ( G ` k ) = ( * ` ( F ` k ) ) ) ) $.
      $( The complex conjugate of a series.  (Contributed by Paul Chapman,
         9-Nov-2007.) $)
      serzcji $p |- ( N e. ( ZZ>= ` M ) -> ( ( <. M , + >. seq G ) ` N ) =
                     ( * ` ( ( <. M , + >. seq F ) ` N ) ) ) $=
        vk vm cF cG ccj cM cN serzre.1 serzre.2 serzcj.3 vm cv cM caddc cop cF
        cseqz co cfv vm cv c1 caddc co cF cfv cjadd serzrelem $.
        $( [10-Nov-2007] $) $( [9-Nov-2007] $)
    $}
  $}

  ${
    $d F k $.  $d G k $.
    ser0cj.1 $e |- F e. _V $.
    ser0cj.2 $e |- G e. _V $.
    ser0cj.3 $e |- ( k e. NN0 -> ( ( F ` k ) e. CC /\
                        ( G ` k ) = ( * ` ( F ` k ) ) ) ) $.
    $( The complex conjugate of a 0-based series. $)
    ser0cji $p |- ( N e. NN0 ->
                    ( ( + seq0 G ) ` N ) = ( * ` ( ( + seq0 F ) ` N ) ) ) $=
      cN cc0 cuz cfv wcel cN cc0 caddc cop cG cseqz co cfv cN cc0 caddc cop cF
      cseqz co cfv ccj cfv wceq cN cn0 wcel cN caddc cG cseq0 co cfv cN caddc
      cF cseq0 co cfv ccj cfv wceq vk cF cG cc0 cN ser0cj.1 ser0cj.2 vk cv cc0
      cuz cfv wcel vk cv cn0 wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv ccj cfv wceq wa vk cv elnn0uz ser0cj.3 sylbir serzcji cN elnn0uz cN
      caddc cG cseq0 co cfv cN cc0 caddc cop cG cseqz co cfv cN caddc cF cseq0
      co cfv ccj cfv cN cc0 caddc cop cF cseqz co cfv ccj cfv cN caddc cG cseq0
      co cc0 caddc cop cG cseqz co caddc cG addex ser0cj.2 seq0seqz fveq1i cN
      caddc cF cseq0 co cfv cN cc0 caddc cop cF cseqz co cfv ccj cN caddc cF
      cseq0 co cc0 caddc cop cF cseqz co caddc cF addex ser0cj.1 seq0seqz
      fveq1i fveq2i eqeq12i 3imtr4i $.
      $( [10-Nov-2007] $) $( [7-Jun-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The binomial theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k x A $.  $d j k x B $.  $d j k x N $.
    binomlem.1 $e |- A e. CC $.
    binomlem.2 $e |- B e. CC $.
    $( Lemma for ~ binomi (binomial theorem).  Break out and simplify the first
       term of the summation. $)
    binomlem1 $p |- ( N e. NN -> ( sum_ k e. ( 0 ... N )
             ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) x. A ) =
         ( ( A ^ ( N + 1 ) ) + sum_ k e. ( 1 ... N ) ( ( N _C k ) x.
             ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) ) ) $=
      cN cn wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu cA cmul co cc0 cN cfz co cN vk cv
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu vk cc0 cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co csb cc0 c1 caddc co cN cfz co cN
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu caddc co cA cN c1 caddc co cexp co c1 cN cfz co cN
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu caddc co cN cn wcel cN cn0 wcel cc0 cN cfz co cN
      vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cA cmul co cc0 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cN nnnn0 cN
      cn0 wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu cA cmul co cc0 cN cfz co cN vk cv cbc
      co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cA cmul
      co vk csu cc0 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu cN cc0 cuz cfv wcel cN vk
      cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc
      wcel vk cc0 cN cfz co wral cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cmul co cc0 cN cfz
      co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cA cmul co vk csu wceq cN cn0 wcel cN cc0 cuz cfv wcel cA cc wcel
      cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cmul co cc0
      cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co cA cmul co vk csu wceq binomlem.1 cN vk cv cbc co cA cN
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cA vk cc0 cN
      fsummulc2 mp3an2 cN cn0 wcel cN cc0 cuz cfv wcel cN elnn0uz biimpi cN cn0
      wcel cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cc wcel vk cc0 cN cfz co cN vk cv cbc co cc wcel cA cN vk cv cmin
      co cexp co cB vk cv cexp co cmul co cc wcel cN vk cv cbc co cA cN vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel cN cn0 wcel vk
      cv cc0 cN cfz co wcel wa cN vk cv cbc co cA cN vk cv cmin co cexp co cB
      vk cv cexp co cmul co mulcl cN cn0 wcel vk cv cz wcel cN vk cv cbc co cc
      wcel vk cv cc0 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN vk cv cbc
      co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc co nn0cn
      syl vk cv cc0 cN elfzelz sylan2 cA cN vk cv cmin co cexp co cc wcel cB vk
      cv cexp co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co cexp
      co cB vk cv cexp co mulcl cA cc wcel cN vk cv cmin co cn0 wcel cA cN vk
      cv cmin co cexp co cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN
      vk cv cmin co expcl binomlem.1 cn0 vk cv cc0 cN fznn0sub sylancr vk cv
      cc0 cN cfz co wcel cB vk cv cexp co cc wcel cN cn0 wcel cB cc wcel vk cv
      cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 cN cfz co wcel cB vk cv expcl
      binomlem.2 vk cv cN elfznn0 sylancr adantl sylanc sylanc r19.21aiva
      sylanc cN cn0 wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cA cmul co cN vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk cN cn0
      wcel vk cv cc0 cN cfz co wcel wa cN vk cv cbc co cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cA cmul co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cA cmul co cmul co cN vk cv
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cN vk cv cbc co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp
      co cmul co cc wcel cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cA cmul co cN vk cv cbc co cA cN vk cv cmin co
      cexp co cB vk cv cexp co cmul co cA cmul co cmul co wceq cN cn0 wcel vk
      cv cc0 cN cfz co wcel wa cN vk cv cbc co cc wcel cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cc wcel cA cc wcel cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co cA cmul co cN vk cv
      cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cA cmul co
      cmul co wceq binomlem.1 cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cA mulass mp3an3 cN cn0 wcel vk cv cz wcel cN vk cv
      cbc co cc wcel vk cv cc0 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN
      vk cv cbc co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc
      co nn0cn syl vk cv cc0 cN elfzelz sylan2 cA cN vk cv cmin co cexp co cc
      wcel cB vk cv cexp co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp
      co cmul co cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv
      cmin co cexp co cB vk cv cexp co mulcl cA cc wcel cN vk cv cmin co cn0
      wcel cA cN vk cv cmin co cexp co cc wcel cN cn0 wcel vk cv cc0 cN cfz co
      wcel wa cA cN vk cv cmin co expcl binomlem.1 cn0 vk cv cc0 cN fznn0sub
      sylancr vk cv cc0 cN cfz co wcel cB vk cv cexp co cc wcel cN cn0 wcel cB
      cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 cN cfz co wcel
      cB vk cv expcl binomlem.2 vk cv cN elfznn0 sylancr adantl sylanc sylanc
      cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cA cmul co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co cN vk cv cbc co cmul cN cn0 wcel vk cv cc0 cN cfz
      co wcel wa cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cA cN vk cv cmin co cexp co cA cmul co cB vk cv cexp co cmul co cA cN
      vk cv cmin co cexp co cB vk cv cexp co cmul co cA cmul co cN cn0 wcel vk
      cv cc0 cN cfz co wcel wa cA cN c1 caddc co vk cv cmin co cexp co cA cN vk
      cv cmin co cexp co cA cmul co cB vk cv cexp co cmul cN cn0 wcel vk cv cc0
      cN cfz co wcel wa cA cN c1 caddc co vk cv cmin co cexp co cA cN vk cv
      cmin co c1 caddc co cexp co cA cN vk cv cmin co cexp co cA cmul co cN cn0
      wcel vk cv cc0 cN cfz co wcel wa cN c1 caddc co vk cv cmin co cN vk cv
      cmin co c1 caddc co cA cexp cN cc wcel vk cv cc wcel cN c1 caddc co vk cv
      cmin co cN vk cv cmin co c1 caddc co wceq cN cn0 wcel vk cv cc0 cN cfz co
      wcel cN cc wcel c1 cc wcel vk cv cc wcel cN c1 caddc co vk cv cmin co cN
      vk cv cmin co c1 caddc co wceq ax1cn cN c1 vk cv addsub mp3an2 cN nn0cn
      vk cv cc0 cN cfz co wcel vk cv cz wcel vk cv cc wcel vk cv cc0 cN elfzelz
      vk cv zcn syl syl2an opreq2d cA cc wcel cN vk cv cmin co cn0 wcel cA cN
      vk cv cmin co c1 caddc co cexp co cA cN vk cv cmin co cexp co cA cmul co
      wceq cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co expp1
      binomlem.1 cn0 vk cv cc0 cN fznn0sub sylancr eqtrd opreq1d cA cN vk cv
      cmin co cexp co cc wcel cB vk cv cexp co cc wcel cA cN vk cv cmin co cexp
      co cA cmul co cB vk cv cexp co cmul co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cA cmul co wceq cN cn0 wcel vk cv cc0 cN cfz co wcel
      wa cA cN vk cv cmin co cexp co cc wcel cA cc wcel cB vk cv cexp co cc
      wcel cA cN vk cv cmin co cexp co cA cmul co cB vk cv cexp co cmul co cA
      cN vk cv cmin co cexp co cB vk cv cexp co cmul co cA cmul co wceq
      binomlem.1 cA cN vk cv cmin co cexp co cA cB vk cv cexp co mul23 mp3an2
      cA cc wcel cN vk cv cmin co cn0 wcel cA cN vk cv cmin co cexp co cc wcel
      cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co expcl
      binomlem.1 cn0 vk cv cc0 cN fznn0sub sylancr vk cv cc0 cN cfz co wcel cB
      vk cv cexp co cc wcel cN cn0 wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel vk cv cc0 cN cfz co wcel cB vk cv expcl binomlem.2 vk cv cN
      elfznn0 sylancr adantl sylanc eqtr2d opreq2d eqtrd sumeq2dv eqtrd syl cN
      cc0 cuz cfv wcel cc0 cN clt wbr cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk cc0 cN cfz co
      wral cc0 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu vk cc0 cN vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co csb
      cc0 c1 caddc co cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu caddc co wceq cN cn wcel
      cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk cc0 cN fsum1ps cN cn wcel cN cn0 cc0 cuz cfv cN nnnn0
      nn0uz syl6eleq cN nngt0 cN cn wcel cN vk cv cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk cc0 cN cfz
      co cN cn0 wcel vk cv cc0 cN cfz co wcel cN vk cv cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel cN cn wcel
      cN vk cv cbc co cc wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cc wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co cc wcel cN cn0 wcel vk cv cc0 cN
      cfz co wcel wa cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co mulcl cN cn0 wcel vk cv cz wcel cN vk cv cbc co cc
      wcel vk cv cc0 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN vk cv cbc
      co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc co nn0cn
      syl vk cv cc0 cN elfzelz sylan2 cA cN c1 caddc co vk cv cmin co cexp co
      cc wcel cB vk cv cexp co cc wcel cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co mulcl cA cc wcel
      cN c1 caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co
      cexp co cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN c1 caddc co
      vk cv cmin co expcl binomlem.1 cN c1 caddc co cn0 wcel vk cv cc0 cN c1
      caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cN cn0 wcel vk
      cv cc0 cN cfz co wcel wa cn0 vk cv cc0 cN c1 caddc co fznn0sub cN cn0
      wcel cN c1 caddc co cn0 wcel vk cv cc0 cN cfz co wcel cN peano2nn0 adantr
      cn0 vk cv cc0 cN fzelp1 sylanc sylancr vk cv cc0 cN cfz co wcel cB vk cv
      cexp co cc wcel cN cn0 wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc
      wcel vk cv cc0 cN cfz co wcel cB vk cv expcl binomlem.2 vk cv cN elfznn0
      sylancr adantl sylanc sylanc cN nnnn0 sylan r19.21aiva syl3anc cN cn wcel
      cN cn0 wcel vk cc0 cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co csb cc0 c1 caddc co cN cfz co cN vk
      cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co vk csu caddc co cA cN c1 caddc co cexp co c1 cN cfz co cN vk
      cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co vk csu caddc co wceq cN nnnn0 cN cn0 wcel vk cc0 cN vk cv cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co csb cA cN c1 caddc co cexp co cc0 c1 caddc co cN cfz co cN vk cv cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk csu c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu caddc cN cn0 wcel cN cc0
      cbc co cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul co cA cN c1
      caddc co cexp co vk cc0 cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co csb cN cn0 wcel cN cc0 cbc co cA
      cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul co c1 cA cN c1 caddc
      co cexp co cmul co cA cN c1 caddc co cexp co cN cn0 wcel cN cc0 cbc co c1
      cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cA cN c1 caddc co cexp
      co cmul cN bcn0 cN cn0 wcel cA cN c1 caddc co cc0 cmin co cexp co c1 cmul
      co cA cN c1 caddc co cexp co c1 cmul co cA cN c1 caddc co cexp co cN cn0
      wcel cA cN c1 caddc co cc0 cmin co cexp co cA cN c1 caddc co cexp co c1
      cmul cN cn0 wcel cN c1 caddc co cc0 cmin co cN c1 caddc co cA cexp cN cn0
      wcel cN cc wcel cN c1 caddc co cc wcel cN c1 caddc co cc0 cmin co cN c1
      caddc co wceq cN nn0cn cN peano2cn cN c1 caddc co subid1 3syl opreq2d
      opreq1d cN cn0 wcel cN c1 caddc co cn0 wcel cA cN c1 caddc co cexp co cc
      wcel cA cN c1 caddc co cexp co c1 cmul co cA cN c1 caddc co cexp co wceq
      cN peano2nn0 cA cc wcel cN c1 caddc co cn0 wcel cA cN c1 caddc co cexp co
      cc wcel binomlem.1 cA cN c1 caddc co expcl mpan cA cN c1 caddc co cexp co
      ax1id 3syl eqtrd opreq12d cN cn0 wcel cN c1 caddc co cn0 wcel cA cN c1
      caddc co cexp co cc wcel c1 cA cN c1 caddc co cexp co cmul co cA cN c1
      caddc co cexp co wceq cN peano2nn0 cA cc wcel cN c1 caddc co cn0 wcel cA
      cN c1 caddc co cexp co cc wcel binomlem.1 cA cN c1 caddc co expcl mpan cA
      cN c1 caddc co cexp co mulid2 3syl eqtrd vk vx cc0 cN vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cN cc0
      cbc co cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul co cc0 cc
      0cn elisseti vx cv cN cc0 cbc co cA cN c1 caddc co cc0 cmin co cexp co c1
      cmul co cmul co wcel vk ax-17 vk cv cc0 wceq cN vk cv cbc co cN cc0 cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cA cN
      c1 caddc co cc0 cmin co cexp co c1 cmul co cmul vk cv cc0 cN cbc opreq2
      vk cv cc0 wceq cA cN c1 caddc co vk cv cmin co cexp co cA cN c1 caddc co
      cc0 cmin co cexp co cB vk cv cexp co c1 cmul vk cv cc0 wceq cN c1 caddc
      co vk cv cmin co cN c1 caddc co cc0 cmin co cA cexp vk cv cc0 cN c1 caddc
      co cmin opreq2 opreq2d vk cv cc0 wceq cB vk cv cexp co cB cc0 cexp co c1
      vk cv cc0 cB cexp opreq2 cB cc wcel cB cc0 cexp co c1 wceq binomlem.2 cB
      exp0 ax-mp syl6eq opreq12d opreq12d csbief syl5eq cc0 c1 caddc co cN cfz
      co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co vk csu c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cN cn0
      wcel cc0 c1 caddc co cN cfz co c1 cN cfz co cN vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk cc0 c1
      caddc co c1 cN cfz c1 ax1cn addid2i opreq1i sumeq1i a1i opreq12d syl
      3eqtrd $.
      $( [30-Jan-2006] $) $( [6-Dec-2005] $)

    $( Lemma for ~ binomi (binomial theorem).  Shift up the summation index
       with ~ fsumshft , then break out and simplify the last term of the
       summation. $)
    binomlem2 $p |- ( N e. NN -> ( sum_ k e. ( 0 ... N )
             ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) x. B ) =
         ( sum_ k e. ( 1 ... N ) ( ( N _C ( k - 1 ) ) x.
        ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) + ( B ^ ( N + 1 ) ) ) ) $=
      cN cn wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu cB cmul co c1 cN c1 caddc co cfz co
      cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu c1 cN cfz co cN vk cv c1 cmin co cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cN cN c1 caddc co c1 cmin co cbc co cA cN c1 caddc co cN c1 caddc
      co cmin co cexp co cB cN c1 caddc co cexp co cmul co cmul co caddc co c1
      cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co cexp co
      caddc co cN cn wcel cN cn0 wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cmul co c1 cN
      c1 caddc co cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cN nnnn0 cN
      cn0 wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu cB cmul co cc0 cN cfz co cN vk cv cbc
      co cA cN vk cv cmin co cexp co cB vk cv c1 caddc co cexp co cmul co cmul
      co vk csu cc0 c1 caddc co cN c1 caddc co cfz co vj vk cv c1 cmin co cN vj
      cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul
      co cmul co csb vk csu c1 cN c1 caddc co cfz co cN vk cv c1 cmin co cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cN cn0 wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu cB cmul co cc0 cN cfz co cN vk
      cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cB
      cmul co vk csu cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co
      cB vk cv c1 caddc co cexp co cmul co cmul co vk csu cN cc0 cuz cfv wcel
      cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cmul co cc0
      cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co cB cmul co vk csu wceq cN cn0 wcel cN cc0 cuz cfv wcel cB
      cc wcel cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cN vk cv cbc co cA
      cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cmul
      co cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cB cmul co vk csu wceq binomlem.2 cN vk cv cbc co
      cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cB vk cc0 cN
      fsummulc2 mp3an2 cN cn0 wcel cN cc0 cuz cfv wcel cN elnn0uz biimpi cN cn0
      wcel cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cc wcel vk cc0 cN cfz co cN vk cv cbc co cc wcel cA cN vk cv cmin
      co cexp co cB vk cv cexp co cmul co cc wcel cN vk cv cbc co cA cN vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel cN cn0 wcel vk
      cv cc0 cN cfz co wcel wa cN vk cv cbc co cA cN vk cv cmin co cexp co cB
      vk cv cexp co cmul co mulcl cN cn0 wcel vk cv cz wcel cN vk cv cbc co cc
      wcel vk cv cc0 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN vk cv cbc
      co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc co nn0cn
      syl vk cv cc0 cN elfzelz sylan2 cA cN vk cv cmin co cexp co cc wcel cB vk
      cv cexp co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co cexp
      co cB vk cv cexp co mulcl cA cc wcel cN vk cv cmin co cn0 wcel cA cN vk
      cv cmin co cexp co cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN
      vk cv cmin co expcl binomlem.1 cn0 vk cv cc0 cN fznn0sub sylancr vk cv
      cc0 cN cfz co wcel cB vk cv cexp co cc wcel cN cn0 wcel cB cc wcel vk cv
      cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 cN cfz co wcel cB vk cv expcl
      binomlem.2 vk cv cN elfznn0 sylancr adantl sylanc sylanc r19.21aiva
      sylanc cN cn0 wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cB cmul co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv c1 caddc co cexp co cmul co cmul co vk cN cn0
      wcel vk cv cc0 cN cfz co wcel wa cN vk cv cbc co cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cB cmul co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cB cmul co cmul co cN vk cv
      cbc co cA cN vk cv cmin co cexp co cB vk cv c1 caddc co cexp co cmul co
      cmul co cN vk cv cbc co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp
      co cmul co cc wcel cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cB cmul co cN vk cv cbc co cA cN vk cv cmin co
      cexp co cB vk cv cexp co cmul co cB cmul co cmul co wceq cN cn0 wcel vk
      cv cc0 cN cfz co wcel wa cN vk cv cbc co cc wcel cA cN vk cv cmin co cexp
      co cB vk cv cexp co cmul co cc wcel cB cc wcel cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co cB cmul co cN vk cv
      cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cB cmul co
      cmul co wceq binomlem.2 cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cB mulass mp3an3 cN cn0 wcel vk cv cz wcel cN vk cv
      cbc co cc wcel vk cv cc0 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN
      vk cv cbc co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc
      co nn0cn syl vk cv cc0 cN elfzelz sylan2 cA cN vk cv cmin co cexp co cc
      wcel cB vk cv cexp co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp
      co cmul co cc wcel cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv
      cmin co cexp co cB vk cv cexp co mulcl cA cc wcel cN vk cv cmin co cn0
      wcel cA cN vk cv cmin co cexp co cc wcel cN cn0 wcel vk cv cc0 cN cfz co
      wcel wa cA cN vk cv cmin co expcl binomlem.1 cn0 vk cv cc0 cN fznn0sub
      sylancr vk cv cc0 cN cfz co wcel cB vk cv cexp co cc wcel cN cn0 wcel cB
      cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 cN cfz co wcel
      cB vk cv expcl binomlem.2 vk cv cN elfznn0 sylancr adantl sylanc sylanc
      cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cB cmul co cA cN vk cv cmin co cexp co cB vk cv c1
      caddc co cexp co cmul co cN vk cv cbc co cmul cN cn0 wcel vk cv cc0 cN
      cfz co wcel wa cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cB
      cmul co cA cN vk cv cmin co cexp co cB vk cv cexp co cB cmul co cmul co
      cA cN vk cv cmin co cexp co cB vk cv c1 caddc co cexp co cmul co cA cN vk
      cv cmin co cexp co cc wcel cB vk cv cexp co cc wcel cA cN vk cv cmin co
      cexp co cB vk cv cexp co cmul co cB cmul co cA cN vk cv cmin co cexp co
      cB vk cv cexp co cB cmul co cmul co wceq cN cn0 wcel vk cv cc0 cN cfz co
      wcel wa cA cN vk cv cmin co cexp co cc wcel cB vk cv cexp co cc wcel cB
      cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cB cmul co
      cA cN vk cv cmin co cexp co cB vk cv cexp co cB cmul co cmul co wceq
      binomlem.2 cA cN vk cv cmin co cexp co cB vk cv cexp co cB mulass mp3an3
      cA cc wcel cN vk cv cmin co cn0 wcel cA cN vk cv cmin co cexp co cc wcel
      cN cn0 wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co expcl
      binomlem.1 cn0 vk cv cc0 cN fznn0sub sylancr vk cv cc0 cN cfz co wcel cB
      vk cv cexp co cc wcel cN cn0 wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel vk cv cc0 cN cfz co wcel cB vk cv expcl binomlem.2 vk cv cN
      elfznn0 sylancr adantl sylanc cN cn0 wcel vk cv cc0 cN cfz co wcel wa cB
      vk cv c1 caddc co cexp co cB vk cv cexp co cB cmul co cA cN vk cv cmin co
      cexp co cmul vk cv cc0 cN cfz co wcel cB vk cv c1 caddc co cexp co cB vk
      cv cexp co cB cmul co wceq cN cn0 wcel cB cc wcel vk cv cn0 wcel cB vk cv
      c1 caddc co cexp co cB vk cv cexp co cB cmul co wceq vk cv cc0 cN cfz co
      wcel cB vk cv expp1 binomlem.2 vk cv cN elfznn0 sylancr adantl opreq2d
      eqtr4d opreq2d eqtrd sumeq2dv eqtrd cN cn0 wcel cc0 cN cfz co cN vj cv
      cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul co
      cmul co vj csu cc0 c1 caddc co cN c1 caddc co cfz co vj vk cv c1 cmin co
      cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co
      cmul co cmul co csb vk csu cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin
      co cexp co cB vk cv c1 caddc co cexp co cmul co cmul co vk csu cN cc0 cuz
      cfv wcel cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co
      cexp co cmul co cmul co cc wcel vj cc0 cN cfz co wral cc0 cN cfz co cN vj
      cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul
      co cmul co vj csu cc0 c1 caddc co cN c1 caddc co cfz co vj vk cv c1 cmin
      co cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp
      co cmul co cmul co csb vk csu wceq cN cn0 wcel cN cc0 cuz cfv wcel c1 cz
      wcel cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co
      cexp co cmul co cmul co cc wcel vj cc0 cN cfz co wral cc0 cN cfz co cN vj
      cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul
      co cmul co vj csu cc0 c1 caddc co cN c1 caddc co cfz co vj vk cv c1 cmin
      co cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp
      co cmul co cmul co csb vk csu wceq 1z cN vj cv cbc co cA cN vj cv cmin co
      cexp co cB vj cv c1 caddc co cexp co cmul co cmul co vj vk c1 cc0 cN
      fsumshft mp3an2 cN cn0 wcel cN cc0 cuz cfv wcel cN elnn0uz biimpi cN cn0
      wcel cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co
      cexp co cmul co cmul co cc wcel vj cc0 cN cfz co cN vj cv cbc co cc wcel
      cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul co cc wcel
      cN vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co
      cmul co cmul co cc wcel cN cn0 wcel vj cv cc0 cN cfz co wcel wa cN vj cv
      cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul co
      mulcl cN cn0 wcel vj cv cz wcel cN vj cv cbc co cc wcel vj cv cc0 cN cfz
      co wcel cN cn0 wcel vj cv cz wcel wa cN vj cv cbc co cn0 wcel cN vj cv
      cbc co cc wcel vj cv cN bccl cN vj cv cbc co nn0cn syl vj cv cc0 cN
      elfzelz sylan2 cA cN vj cv cmin co cexp co cc wcel cB vj cv c1 caddc co
      cexp co cc wcel cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co
      cmul co cc wcel cN cn0 wcel vj cv cc0 cN cfz co wcel wa cA cN vj cv cmin
      co cexp co cB vj cv c1 caddc co cexp co mulcl cA cc wcel cN vj cv cmin co
      cn0 wcel cA cN vj cv cmin co cexp co cc wcel cN cn0 wcel vj cv cc0 cN cfz
      co wcel wa cA cN vj cv cmin co expcl binomlem.1 cn0 vj cv cc0 cN fznn0sub
      sylancr vj cv cc0 cN cfz co wcel cB vj cv c1 caddc co cexp co cc wcel cN
      cn0 wcel cB cc wcel vj cv c1 caddc co cn0 wcel cB vj cv c1 caddc co cexp
      co cc wcel vj cv cc0 cN cfz co wcel cB vj cv c1 caddc co expcl binomlem.2
      vj cv cc0 cN cfz co wcel vj cv cn0 wcel vj cv c1 caddc co cn0 wcel vj cv
      cN elfznn0 vj cv peano2nn0 syl sylancr adantl sylanc sylanc r19.21aiva
      sylanc vx cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv c1 caddc co cexp co cmul co cmul co cN vj cv cbc co cA cN vj cv cmin
      co cexp co cB vj cv c1 caddc co cexp co cmul co cmul co vk vj vx cv cN vk
      cv cbc co cA cN vk cv cmin co cexp co cB vk cv c1 caddc co cexp co cmul
      co cmul co wcel vj ax-17 vx cv cN vj cv cbc co cA cN vj cv cmin co cexp
      co cB vj cv c1 caddc co cexp co cmul co cmul co wcel vk ax-17 vk cv vj cv
      wceq cN vk cv cbc co cN vj cv cbc co cA cN vk cv cmin co cexp co cB vk cv
      c1 caddc co cexp co cmul co cA cN vj cv cmin co cexp co cB vj cv c1 caddc
      co cexp co cmul co cmul vk cv vj cv cN cbc opreq2 vk cv vj cv wceq cA cN
      vk cv cmin co cexp co cA cN vj cv cmin co cexp co cB vk cv c1 caddc co
      cexp co cB vj cv c1 caddc co cexp co cmul vk cv vj cv wceq cN vk cv cmin
      co cN vj cv cmin co cA cexp vk cv vj cv cN cmin opreq2 opreq2d vk cv vj
      cv wceq vk cv c1 caddc co vj cv c1 caddc co cB cexp vk cv vj cv c1 caddc
      opreq1 opreq2d opreq12d opreq12d cbvsumi syl5eq cN cn0 wcel cc0 c1 caddc
      co cN c1 caddc co cfz co c1 cN c1 caddc co cfz co vj vk cv c1 cmin co cN
      vj cv cbc co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co
      cmul co cmul co csb cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk cc0 c1 caddc co cN c1
      caddc co cfz co c1 cN c1 caddc co cfz co wceq cN cn0 wcel cc0 c1 caddc co
      c1 cN c1 caddc co cfz c1 ax1cn addid2i opreq1i a1i cN cn0 wcel vk cv c1
      cN c1 caddc co cfz co wcel wa cN vk cv c1 cmin co cbc co cA cN vk cv c1
      cmin co cmin co cexp co cB vk cv c1 cmin co c1 caddc co cexp co cmul co
      cmul co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vj vk cv c1 cmin co cN vj cv cbc co
      cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul co cmul co
      csb cN cn0 wcel vk cv c1 cN c1 caddc co cfz co wcel wa cA cN vk cv c1
      cmin co cmin co cexp co cB vk cv c1 cmin co c1 caddc co cexp co cmul co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cN vk cv
      c1 cmin co cbc co cmul cN cc wcel vk cv cc wcel cA cN vk cv c1 cmin co
      cmin co cexp co cB vk cv c1 cmin co c1 caddc co cexp co cmul co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co wceq cN cn0 wcel
      vk cv c1 cN c1 caddc co cfz co wcel cN cc wcel vk cv cc wcel wa cA cN vk
      cv c1 cmin co cmin co cexp co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv c1 cmin co c1 caddc co cexp co cB vk cv cexp co cmul cN cc wcel vk
      cv cc wcel wa cN vk cv c1 cmin co cmin co cN c1 caddc co vk cv cmin co cA
      cexp cN cc wcel vk cv cc wcel c1 cc wcel cN vk cv c1 cmin co cmin co cN
      c1 caddc co vk cv cmin co wceq ax1cn cN vk cv c1 subsub3 mp3an3 opreq2d
      vk cv cc wcel cB vk cv c1 cmin co c1 caddc co cexp co cB vk cv cexp co
      wceq cN cc wcel vk cv cc wcel vk cv c1 cmin co c1 caddc co vk cv cB cexp
      vk cv cc wcel c1 cc wcel vk cv c1 cmin co c1 caddc co vk cv wceq ax1cn vk
      cv c1 npcan mpan2 opreq2d adantl opreq12d cN nn0cn vk cv c1 cN c1 caddc
      co cfz co wcel vk cv cz wcel vk cv cc wcel vk cv c1 cN c1 caddc co
      elfzelz vk cv zcn syl syl2an opreq2d vj vx vk cv c1 cmin co cN vj cv cbc
      co cA cN vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul co cmul
      co cN vk cv c1 cmin co cbc co cA cN vk cv c1 cmin co cmin co cexp co cB
      vk cv c1 cmin co c1 caddc co cexp co cmul co cmul co vk cv c1 cmin oprex
      vx cv cN vk cv c1 cmin co cbc co cA cN vk cv c1 cmin co cmin co cexp co
      cB vk cv c1 cmin co c1 caddc co cexp co cmul co cmul co wcel vj ax-17 vj
      cv vk cv c1 cmin co wceq cN vj cv cbc co cN vk cv c1 cmin co cbc co cA cN
      vj cv cmin co cexp co cB vj cv c1 caddc co cexp co cmul co cA cN vk cv c1
      cmin co cmin co cexp co cB vk cv c1 cmin co c1 caddc co cexp co cmul co
      cmul vj cv vk cv c1 cmin co cN cbc opreq2 vj cv vk cv c1 cmin co wceq cA
      cN vj cv cmin co cexp co cA cN vk cv c1 cmin co cmin co cexp co cB vj cv
      c1 caddc co cexp co cB vk cv c1 cmin co c1 caddc co cexp co cmul vj cv vk
      cv c1 cmin co wceq cN vj cv cmin co cN vk cv c1 cmin co cmin co cA cexp
      vj cv vk cv c1 cmin co cN cmin opreq2 opreq2d vj cv vk cv c1 cmin co wceq
      vj cv c1 caddc co vk cv c1 cmin co c1 caddc co cB cexp vj cv vk cv c1
      cmin co c1 caddc opreq1 opreq2d opreq12d opreq12d csbief syl5eq
      sumeq12rdv 3eqtrd syl cN cn wcel cN c1 cuz cfv wcel c1 cN c1 caddc co cfz
      co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu c1 cN cfz co cN vk cv c1 cmin co cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk csu cN cN c1 caddc co c1 cmin co cbc co cA cN c1 caddc co cN c1
      caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co cmul co caddc
      co wceq cN elnnuz cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co cN cN c1 caddc co c1 cmin co
      cbc co cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB cN c1 caddc co
      cexp co cmul co cmul co vk c1 cN cN vk cv c1 cmin co cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul oprex cN cN
      c1 caddc co c1 cmin co cbc co cA cN c1 caddc co cN c1 caddc co cmin co
      cexp co cB cN c1 caddc co cexp co cmul co cmul oprex vk cv cN c1 caddc co
      wceq cN vk cv c1 cmin co cbc co cN cN c1 caddc co c1 cmin co cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cA cN c1 caddc
      co cN c1 caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co cmul
      vk cv cN c1 caddc co wceq vk cv c1 cmin co cN c1 caddc co c1 cmin co cN
      cbc vk cv cN c1 caddc co c1 cmin opreq1 opreq2d vk cv cN c1 caddc co wceq
      cA cN c1 caddc co vk cv cmin co cexp co cA cN c1 caddc co cN c1 caddc co
      cmin co cexp co cB vk cv cexp co cB cN c1 caddc co cexp co cmul vk cv cN
      c1 caddc co wceq cN c1 caddc co vk cv cmin co cN c1 caddc co cN c1 caddc
      co cmin co cA cexp vk cv cN c1 caddc co cN c1 caddc co cmin opreq2
      opreq2d vk cv cN c1 caddc co cB cexp opreq2 opreq12d opreq12d fsump1i
      sylbi cN cn wcel cN cN c1 caddc co c1 cmin co cbc co cA cN c1 caddc co cN
      c1 caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co cmul co cB
      cN c1 caddc co cexp co c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      caddc cN cn wcel cN cn0 wcel cN cN c1 caddc co c1 cmin co cbc co cA cN c1
      caddc co cN c1 caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co
      cmul co cB cN c1 caddc co cexp co wceq cN nnnn0 cN cn0 wcel cN cN c1
      caddc co c1 cmin co cbc co cA cN c1 caddc co cN c1 caddc co cmin co cexp
      co cB cN c1 caddc co cexp co cmul co cmul co c1 cB cN c1 caddc co cexp co
      cmul co cB cN c1 caddc co cexp co cN cn0 wcel cN cN c1 caddc co c1 cmin
      co cbc co c1 cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB cN c1
      caddc co cexp co cmul co cB cN c1 caddc co cexp co cmul cN cn0 wcel cN cN
      c1 caddc co c1 cmin co cbc co cN cN cbc co c1 cN cn0 wcel cN c1 caddc co
      c1 cmin co cN cN cbc cN cc wcel c1 cc wcel cN c1 caddc co c1 cmin co cN
      wceq cN cn0 wcel cN c1 pncan cN nn0cn ax1cn sylancl opreq2d cN bcnn eqtrd
      cN cn0 wcel cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB cN c1
      caddc co cexp co cmul co c1 cB cN c1 caddc co cexp co cmul co cB cN c1
      caddc co cexp co cN cn0 wcel cA cN c1 caddc co cN c1 caddc co cmin co
      cexp co c1 cB cN c1 caddc co cexp co cmul cN cn0 wcel cA cN c1 caddc co
      cN c1 caddc co cmin co cexp co cA cc0 cexp co c1 cN cn0 wcel cN c1 caddc
      co cN c1 caddc co cmin co cc0 cA cexp cN cn0 wcel cN cc wcel cN c1 caddc
      co cc wcel cN c1 caddc co cN c1 caddc co cmin co cc0 wceq cN nn0cn cN
      peano2cn cN c1 caddc co subid 3syl opreq2d cA cc wcel cA cc0 cexp co c1
      wceq binomlem.1 cA exp0 ax-mp syl6eq opreq1d cN cn0 wcel cN c1 caddc co
      cn0 wcel cB cN c1 caddc co cexp co cc wcel c1 cB cN c1 caddc co cexp co
      cmul co cB cN c1 caddc co cexp co wceq cN peano2nn0 cB cc wcel cN c1
      caddc co cn0 wcel cB cN c1 caddc co cexp co cc wcel binomlem.2 cB cN c1
      caddc co expcl mpan cB cN c1 caddc co cexp co mulid2 3syl eqtrd opreq12d
      cN cn0 wcel cN c1 caddc co cn0 wcel cB cN c1 caddc co cexp co cc wcel c1
      cB cN c1 caddc co cexp co cmul co cB cN c1 caddc co cexp co wceq cN
      peano2nn0 cB cc wcel cN c1 caddc co cn0 wcel cB cN c1 caddc co cexp co cc
      wcel binomlem.2 cB cN c1 caddc co expcl mpan cB cN c1 caddc co cexp co
      mulid2 3syl eqtrd syl opreq2d 3eqtrd $.
      $( [30-Jan-2006] $) $( [7-Dec-2005] $)

    $( Lemma for ~ binomi (binomial theorem).  Break out the last term of the
       summation used by the induction hypothesis. $)
    binomlem3 $p |- ( N e. NN ->
       sum_ k e. ( 1 ... ( N + 1 ) ) ( ( ( N + 1 ) _C k ) x.
             ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) =
   ( sum_ k e. ( 1 ... N ) ( ( ( N + 1 ) _C k ) x.
             ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) )
                  + ( B ^ ( N + 1 ) ) ) ) $=
      cN cn wcel c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1
      cN cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu cN c1 caddc co cN c1
      caddc co cbc co cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB cN c1
      caddc co cexp co cmul co cmul co caddc co c1 cN cfz co cN c1 caddc co vk
      cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co vk csu cB cN c1 caddc co cexp co caddc co cN cn wcel cN c1 cuz
      cfv wcel c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1
      cN cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu cN c1 caddc co cN c1
      caddc co cbc co cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB cN c1
      caddc co cexp co cmul co cmul co caddc co wceq cN elnnuz cN c1 caddc co
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co cN c1 caddc co cN c1 caddc co cbc co cA cN c1 caddc co cN
      c1 caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co cmul co vk
      c1 cN cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul oprex cN c1 caddc co cN c1 caddc co cbc co
      cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB cN c1 caddc co cexp
      co cmul co cmul oprex vk cv cN c1 caddc co wceq cN c1 caddc co vk cv cbc
      co cN c1 caddc co cN c1 caddc co cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cA cN c1 caddc co cN c1 caddc co cmin co
      cexp co cB cN c1 caddc co cexp co cmul co cmul vk cv cN c1 caddc co cN c1
      caddc co cbc opreq2 vk cv cN c1 caddc co wceq cA cN c1 caddc co vk cv
      cmin co cexp co cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB vk cv
      cexp co cB cN c1 caddc co cexp co cmul vk cv cN c1 caddc co wceq cN c1
      caddc co vk cv cmin co cN c1 caddc co cN c1 caddc co cmin co cA cexp vk
      cv cN c1 caddc co cN c1 caddc co cmin opreq2 opreq2d vk cv cN c1 caddc co
      cB cexp opreq2 opreq12d opreq12d fsump1i sylbi cN cn wcel cN c1 caddc co
      cN c1 caddc co cbc co cA cN c1 caddc co cN c1 caddc co cmin co cexp co cB
      cN c1 caddc co cexp co cmul co cmul co cB cN c1 caddc co cexp co c1 cN
      cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu caddc cN cn wcel cN cn0 wcel
      cN c1 caddc co cn0 wcel cN c1 caddc co cN c1 caddc co cbc co cA cN c1
      caddc co cN c1 caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co
      cmul co cB cN c1 caddc co cexp co wceq cN nnnn0 cN peano2nn0 cN c1 caddc
      co cn0 wcel cN c1 caddc co cN c1 caddc co cbc co cA cN c1 caddc co cN c1
      caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co cmul co c1 cB
      cN c1 caddc co cexp co cmul co cB cN c1 caddc co cexp co cN c1 caddc co
      cn0 wcel cN c1 caddc co cN c1 caddc co cbc co c1 cA cN c1 caddc co cN c1
      caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co cB cN c1 caddc
      co cexp co cmul cN c1 caddc co bcnn cN c1 caddc co cn0 wcel cA cN c1
      caddc co cN c1 caddc co cmin co cexp co cB cN c1 caddc co cexp co cmul co
      c1 cB cN c1 caddc co cexp co cmul co cB cN c1 caddc co cexp co cN c1
      caddc co cn0 wcel cA cN c1 caddc co cN c1 caddc co cmin co cexp co c1 cB
      cN c1 caddc co cexp co cmul cN c1 caddc co cn0 wcel cA cN c1 caddc co cN
      c1 caddc co cmin co cexp co cA cc0 cexp co c1 cN c1 caddc co cn0 wcel cN
      c1 caddc co cN c1 caddc co cmin co cc0 cA cexp cN c1 caddc co cn0 wcel cN
      c1 caddc co cc wcel cN c1 caddc co cN c1 caddc co cmin co cc0 wceq cN c1
      caddc co nn0cn cN c1 caddc co subid syl opreq2d cA cc wcel cA cc0 cexp co
      c1 wceq binomlem.1 cA exp0 ax-mp syl6eq opreq1d cN c1 caddc co cn0 wcel
      cB cN c1 caddc co cexp co cc wcel c1 cB cN c1 caddc co cexp co cmul co cB
      cN c1 caddc co cexp co wceq cB cc wcel cN c1 caddc co cn0 wcel cB cN c1
      caddc co cexp co cc wcel binomlem.2 cB cN c1 caddc co expcl mpan cB cN c1
      caddc co cexp co mulid2 syl eqtrd opreq12d cN c1 caddc co cn0 wcel cB cN
      c1 caddc co cexp co cc wcel c1 cB cN c1 caddc co cexp co cmul co cB cN c1
      caddc co cexp co wceq cB cc wcel cN c1 caddc co cn0 wcel cB cN c1 caddc
      co cexp co cc wcel binomlem.2 cB cN c1 caddc co expcl mpan cB cN c1 caddc
      co cexp co mulid2 syl eqtrd 3syl opreq2d eqtrd $.
      $( [30-Jan-2006] $) $( [7-Dec-2005] $)

    $( Lemma for ~ binomi (binomial theorem).  Break out the first term of the
       summation used by the induction hypothesis. $)
    binomlem4 $p |- ( N e. NN0 ->
       sum_ k e. ( 0 ... ( N + 1 ) ) ( ( ( N + 1 ) _C k ) x.
             ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) =
   ( ( A ^ ( N + 1 ) ) + sum_ k e. ( 1 ... ( N + 1 ) ) ( ( ( N + 1 ) _C k ) x.
             ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) ) ) $=
      cN cn0 wcel cc0 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      vk cc0 cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co csb cc0 c1 caddc co cN c1 caddc co
      cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu caddc co cA cN c1 caddc co
      cexp co c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      caddc co cN c1 caddc co cc0 cuz cfv wcel cc0 cN c1 caddc co clt wbr cN c1
      caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cc wcel vk cc0 cN c1 caddc co cfz co wral cc0 cN
      c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu vk cc0 cN c1
      caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co csb cc0 c1 caddc co cN c1 caddc co cfz co cN c1
      caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk csu caddc co wceq cN cn0 wcel cN c1 caddc co
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk cc0 cN c1 caddc co fsum1ps cN cn0 wcel cN c1 caddc co
      cn0 cc0 cuz cfv cN peano2nn0 nn0uz syl6eleq cN cn0 wcel cN c1 caddc co cn
      wcel cc0 cN c1 caddc co clt wbr cN nn0p1nn cN c1 caddc co nngt0 syl cN
      cn0 wcel cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cc wcel vk cc0 cN c1 caddc co cfz co
      cN c1 caddc co vk cv cbc co cc wcel cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cc wcel cN c1 caddc co vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel
      cN cn0 wcel vk cv cc0 cN c1 caddc co cfz co wcel wa cN c1 caddc co vk cv
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      mulcl cN c1 caddc co cn0 wcel vk cv cz wcel cN c1 caddc co vk cv cbc co
      cc wcel cN cn0 wcel vk cv cc0 cN c1 caddc co cfz co wcel cN c1 caddc co
      cn0 wcel vk cv cz wcel wa cN c1 caddc co vk cv cbc co cn0 wcel cN c1
      caddc co vk cv cbc co cc wcel vk cv cN c1 caddc co bccl cN c1 caddc co vk
      cv cbc co nn0cn syl cN peano2nn0 vk cv cc0 cN c1 caddc co elfzelz syl2an
      cA cN c1 caddc co vk cv cmin co cexp co cc wcel cB vk cv cexp co cc wcel
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cc wcel
      cN cn0 wcel vk cv cc0 cN c1 caddc co cfz co wcel wa cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co mulcl vk cv cc0 cN c1 caddc co cfz co
      wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel cN cn0 wcel cA cc
      wcel cN c1 caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin
      co cexp co cc wcel vk cv cc0 cN c1 caddc co cfz co wcel cA cN c1 caddc co
      vk cv cmin co expcl binomlem.1 cN c1 caddc co cvv wcel vk cv cc0 cN c1
      caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cN c1 caddc
      oprex cvv vk cv cc0 cN c1 caddc co fznn0sub mpan sylancr adantl vk cv cc0
      cN c1 caddc co cfz co wcel cB vk cv cexp co cc wcel cN cn0 wcel cB cc
      wcel vk cv cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 cN c1 caddc co cfz
      co wcel cB vk cv expcl binomlem.2 vk cv cN c1 caddc co elfznn0 sylancr
      adantl sylanc sylanc r19.21aiva syl3anc cN cn0 wcel vk cc0 cN c1 caddc co
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co csb cA cN c1 caddc co cexp co cc0 c1 caddc co cN c1 caddc
      co cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu c1 cN c1 caddc co cfz co
      cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu caddc cN cn0 wcel cN c1 caddc co cc0
      cbc co cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul co cA cN c1
      caddc co cexp co vk cc0 cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co csb cN cn0 wcel cN c1
      caddc co cc0 cbc co cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul
      co c1 cA cN c1 caddc co cexp co cmul co cA cN c1 caddc co cexp co cN cn0
      wcel cN c1 caddc co cc0 cbc co c1 cA cN c1 caddc co cc0 cmin co cexp co
      c1 cmul co cA cN c1 caddc co cexp co cmul cN cn0 wcel cN c1 caddc co cn0
      wcel cN c1 caddc co cc0 cbc co c1 wceq cN peano2nn0 cN c1 caddc co bcn0
      syl cN cn0 wcel cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cA cN c1
      caddc co cexp co c1 cmul co cA cN c1 caddc co cexp co cN cn0 wcel cA cN
      c1 caddc co cc0 cmin co cexp co cA cN c1 caddc co cexp co c1 cmul cN cn0
      wcel cN c1 caddc co cc0 cmin co cN c1 caddc co cA cexp cN cn0 wcel cN c1
      caddc co cn0 wcel cN c1 caddc co cc wcel cN c1 caddc co cc0 cmin co cN c1
      caddc co wceq cN peano2nn0 cN c1 caddc co nn0cn cN c1 caddc co subid1
      3syl opreq2d opreq1d cN cn0 wcel cN c1 caddc co cn0 wcel cA cN c1 caddc
      co cexp co cc wcel cA cN c1 caddc co cexp co c1 cmul co cA cN c1 caddc co
      cexp co wceq cN peano2nn0 cA cc wcel cN c1 caddc co cn0 wcel cA cN c1
      caddc co cexp co cc wcel binomlem.1 cA cN c1 caddc co expcl mpan cA cN c1
      caddc co cexp co ax1id 3syl eqtrd opreq12d cN cn0 wcel cN c1 caddc co cn0
      wcel cA cN c1 caddc co cexp co cc wcel c1 cA cN c1 caddc co cexp co cmul
      co cA cN c1 caddc co cexp co wceq cN peano2nn0 cA cc wcel cN c1 caddc co
      cn0 wcel cA cN c1 caddc co cexp co cc wcel binomlem.1 cA cN c1 caddc co
      expcl mpan cA cN c1 caddc co cexp co mulid2 3syl eqtrd vk vx cc0 cN c1
      caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cN c1 caddc co cc0 cbc co cA cN c1 caddc co cc0
      cmin co cexp co c1 cmul co cmul co cc0 cc 0cn elisseti vx cv cN c1 caddc
      co cc0 cbc co cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul co
      wcel vk ax-17 vk cv cc0 wceq cN c1 caddc co vk cv cbc co cN c1 caddc co
      cc0 cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cA cN c1 caddc co cc0 cmin co cexp co c1 cmul co cmul vk cv cc0 cN c1
      caddc co cbc opreq2 vk cv cc0 wceq cA cN c1 caddc co vk cv cmin co cexp
      co cA cN c1 caddc co cc0 cmin co cexp co cB vk cv cexp co c1 cmul vk cv
      cc0 wceq cN c1 caddc co vk cv cmin co cN c1 caddc co cc0 cmin co cA cexp
      vk cv cc0 cN c1 caddc co cmin opreq2 opreq2d vk cv cc0 wceq cB vk cv cexp
      co cB cc0 cexp co c1 vk cv cc0 cB cexp opreq2 cB cc wcel cB cc0 cexp co
      c1 wceq binomlem.2 cB exp0 ax-mp syl6eq opreq12d opreq12d csbief syl5eq
      cc0 c1 caddc co cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cN cn0
      wcel cc0 c1 caddc co cN c1 caddc co cfz co c1 cN c1 caddc co cfz co cN c1
      caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk cc0 c1 caddc co c1 cN c1 caddc co cfz c1 ax1cn
      addid2i opreq1i sumeq1i a1i opreq12d eqtrd $.
      $( [30-Jan-2006] $) $( [7-Dec-2005] $)

    $( Lemma for ~ binomi (binomial theorem).  We use Pascal's rule ~ bcpasc
       to combine the sum of the summations in ~ binomlem1 and ~ binomlem2
       into a single summation. $)
    binomlem5 $p |- ( N e. NN -> ( sum_ k e. ( 0 ... N )
         ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) x. ( A + B ) ) =
      sum_ k e. ( 0 ... ( N + 1 ) ) ( ( ( N + 1 ) _C k ) x.
             ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) ) $=
      cN cn wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu cA cmul co cc0 cN cfz co cN vk cv
      cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu cB cmul co caddc co cA cN c1 caddc co cexp co c1 cN c1 caddc co cfz
      co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu caddc co cc0 cN cfz co cN vk cv cbc
      co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA
      cB caddc co cmul co cc0 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cN cn wcel cA cN c1 caddc co cexp co c1 cN cfz co cN vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu caddc co c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cN c1
      caddc co cexp co caddc co caddc co cA cN c1 caddc co cexp co c1 cN cfz co
      cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB
      cN c1 caddc co cexp co caddc co caddc co caddc co cc0 cN cfz co cN vk cv
      cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu cA cmul co cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul co vk csu cB cmul co caddc co cA cN c1
      caddc co cexp co c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA
      cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu caddc co cA cN c1 caddc co cexp co cc wcel c1 cN cfz co cN vk cv cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk csu cc wcel c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc
      co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cN c1
      caddc co cexp co caddc co cc wcel cA cN c1 caddc co cexp co c1 cN cfz co
      cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu caddc co c1 cN cfz co cN vk cv c1 cmin co cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cB cN c1 caddc co cexp co caddc co caddc co cA cN c1 caddc co cexp
      co c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul co vk csu c1 cN cfz co cN vk cv c1 cmin co
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu cB cN c1 caddc co cexp co caddc co caddc co caddc co wceq
      cN cn wcel cA cN c1 caddc co cexp co c1 cN cfz co cN vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co cexp co
      caddc co addass cA cc wcel cN c1 caddc co cn wcel cA cN c1 caddc co cexp
      co cc wcel cN cn wcel cA cc wcel cN c1 caddc co cn0 wcel cA cN c1 caddc
      co cexp co cc wcel cN c1 caddc co cn wcel cA cN c1 caddc co expcl cN c1
      caddc co nnnn0 sylan2 binomlem.1 cN peano2nn sylancr cN cn wcel cN vk cv
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cc wcel vk c1 cN cfz co wral c1 cN cfz co cN vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      cc wcel cN cn wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cc wcel vk c1 cN cfz co cN vk cv cbc
      co cc wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cc wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co cc wcel cN cn wcel vk cv c1 cN cfz co wcel wa
      cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co mulcl cN cn0 wcel vk cv cz wcel cN vk cv cbc co cc wcel cN cn
      wcel vk cv c1 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN vk cv cbc co
      cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc co nn0cn syl
      cN nnnn0 vk cv c1 cN elfzelz syl2an cA cN c1 caddc co vk cv cmin co cexp
      co cc wcel cB vk cv cexp co cc wcel cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cc wcel cN cn wcel vk cv c1 cN cfz co wcel wa
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co mulcl cN cn wcel
      vk cv c1 cN cfz co wcel wa vk cv c1 cN c1 caddc co cfz co wcel cN c1
      caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co
      cc wcel cn vk cv c1 cN fzelp1 cN c1 caddc co cvv wcel vk cv c1 cN c1
      caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cN c1 caddc
      oprex cvv vk cv c1 cN c1 caddc co fznn0sub mpan cA cc wcel cN c1 caddc co
      vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel
      binomlem.1 cA cN c1 caddc co vk cv cmin co expcl mpan 3syl vk cv c1 cN
      cfz co wcel cB vk cv cexp co cc wcel cN cn wcel cB cc wcel vk cv cn wcel
      cB vk cv cexp co cc wcel vk cv c1 cN cfz co wcel cB cc wcel vk cv cn0
      wcel cB vk cv cexp co cc wcel vk cv cn wcel cB vk cv expcl vk cv nnnn0
      sylan2 binomlem.2 vk cv cN elfznn sylancr adantl sylanc sylanc r19.21aiva
      cN c1 cuz cfv wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cc wcel vk c1 cN cfz co wral c1 cN
      cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk csu cc wcel cN cn wcel cN vk cv cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk c1
      cN fsumcl cN elnnuz sylanb mpdan c1 cN cfz co cN vk cv c1 cmin co cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cc wcel cB cN c1 caddc co cexp co cc wcel c1 cN cfz co cN vk cv c1
      cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu cB cN c1 caddc co cexp co caddc co cc wcel cN cn
      wcel c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co cexp
      co addcl cN cn wcel cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk c1 cN cfz co
      wral c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk csu cc wcel cN cn wcel cN
      vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cc wcel vk c1 cN cfz co cN vk cv c1 cmin co cbc
      co cc wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cc wcel cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co cc wcel cN cn wcel vk cv c1 cN
      cfz co wcel wa cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co mulcl cN cn0 wcel vk cv c1 cmin co cz
      wcel cN vk cv c1 cmin co cbc co cc wcel cN cn wcel vk cv c1 cN cfz co
      wcel cN cn0 wcel vk cv c1 cmin co cz wcel wa cN vk cv c1 cmin co cbc co
      cn0 wcel cN vk cv c1 cmin co cbc co cc wcel vk cv c1 cmin co cN bccl cN
      vk cv c1 cmin co cbc co nn0cn syl cN nnnn0 vk cv c1 cN cfz co wcel vk cv
      cz wcel vk cv c1 cmin co cz wcel vk cv c1 cN elfzelz vk cv peano2zm syl
      syl2an cA cN c1 caddc co vk cv cmin co cexp co cc wcel cB vk cv cexp co
      cc wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cc wcel cN cn wcel vk cv c1 cN cfz co wcel wa cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co mulcl cN cn wcel vk cv c1 cN cfz co wcel
      wa vk cv c1 cN c1 caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0
      wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel cn vk cv c1 cN
      fzelp1 cN c1 caddc co cvv wcel vk cv c1 cN c1 caddc co cfz co wcel cN c1
      caddc co vk cv cmin co cn0 wcel cN c1 caddc oprex cvv vk cv c1 cN c1
      caddc co fznn0sub mpan cA cc wcel cN c1 caddc co vk cv cmin co cn0 wcel
      cA cN c1 caddc co vk cv cmin co cexp co cc wcel binomlem.1 cA cN c1 caddc
      co vk cv cmin co expcl mpan 3syl vk cv c1 cN cfz co wcel cB vk cv cexp co
      cc wcel cN cn wcel cB cc wcel vk cv cn wcel cB vk cv cexp co cc wcel vk
      cv c1 cN cfz co wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      vk cv cn wcel cB vk cv expcl vk cv nnnn0 sylan2 binomlem.2 vk cv cN
      elfznn sylancr adantl sylanc sylanc r19.21aiva cN c1 cuz cfv wcel cN vk
      cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cc wcel vk c1 cN cfz co wral c1 cN cfz co cN vk
      cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk csu cc wcel cN cn wcel cN vk cv c1 cmin co cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk c1 cN fsumcl cN elnnuz sylanb mpdan cB cc wcel cN c1 caddc co cn
      wcel cB cN c1 caddc co cexp co cc wcel cN cn wcel cB cc wcel cN c1 caddc
      co cn0 wcel cB cN c1 caddc co cexp co cc wcel cN c1 caddc co cn wcel cB
      cN c1 caddc co expcl cN c1 caddc co nnnn0 sylan2 binomlem.2 cN peano2nn
      sylancr sylanc syl3anc cN cn wcel cc0 cN cfz co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cmul co cA
      cN c1 caddc co cexp co c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu caddc co cc0
      cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu cB cmul co c1 cN cfz co cN vk cv c1 cmin co cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cB cN c1 caddc co cexp co caddc co caddc cA cB vk cN binomlem.1
      binomlem.2 binomlem1 cA cB vk cN binomlem.1 binomlem.2 binomlem2 opreq12d
      cN cn wcel c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1
      cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu c1 cN cfz co cN vk cv c1 cmin co cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu cB cN c1 caddc co cexp co caddc co caddc co cA cN c1 caddc co cexp
      co caddc cN cn wcel c1 cN c1 caddc co cfz co cN c1 caddc co vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu c1 cN cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co
      cexp co caddc co c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1 cN cfz co cN
      vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk csu caddc co cB cN c1 caddc co cexp co caddc
      co c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul co vk csu c1 cN cfz co cN vk cv c1 cmin co
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu cB cN c1 caddc co cexp co caddc co caddc co cA cB vk cN
      binomlem.1 binomlem.2 binomlem3 cN cn wcel c1 cN cfz co cN vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu caddc co c1 cN
      cfz co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co cexp co
      caddc cN cn wcel c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cN vk cv c1 cmin co cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co caddc co vk csu c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1 cN cfz co cN
      vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk csu caddc co c1 cN cfz co cN c1 caddc co vk cv
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu cN cn wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co cc wcel cN vk cv c1 cmin co cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co cc wcel wa vk c1 cN cfz co wral c1 cN cfz co cN vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cN vk cv
      c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co caddc co vk csu c1 cN cfz co cN vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1
      cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu caddc co wceq cN cn wcel cN vk
      cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co cc wcel cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel wa vk c1 cN cfz
      co cN cn wcel vk cv c1 cN cfz co wcel wa cN vk cv cbc co cA cN c1 caddc
      co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel cN vk
      cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cc wcel cN vk cv cbc co cc wcel cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cc wcel cN vk cv cbc co cA
      cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc
      wcel cN cn wcel vk cv c1 cN cfz co wcel wa cN vk cv cbc co cA cN c1 caddc
      co vk cv cmin co cexp co cB vk cv cexp co cmul co mulcl cN cn wcel vk cv
      c1 cN cfz co wcel wa cN vk cv cbc co cn0 wcel cN vk cv cbc co cc wcel cN
      cn0 wcel vk cv cz wcel cN vk cv cbc co cn0 wcel cN cn wcel vk cv c1 cN
      cfz co wcel vk cv cN bccl cN nnnn0 vk cv c1 cN elfzelz syl2an cN vk cv
      cbc co nn0cn syl cA cN c1 caddc co vk cv cmin co cexp co cc wcel cB vk cv
      cexp co cc wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cc wcel cN cn wcel vk cv c1 cN cfz co wcel wa cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co mulcl cN cn wcel vk cv c1 cN cfz
      co wcel wa vk cv c1 cN c1 caddc co cfz co wcel cN c1 caddc co vk cv cmin
      co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel cn vk cv c1
      cN fzelp1 cN c1 caddc co cvv wcel vk cv c1 cN c1 caddc co cfz co wcel cN
      c1 caddc co vk cv cmin co cn0 wcel cN c1 caddc oprex cvv vk cv c1 cN c1
      caddc co fznn0sub mpan cA cc wcel cN c1 caddc co vk cv cmin co cn0 wcel
      cA cN c1 caddc co vk cv cmin co cexp co cc wcel binomlem.1 cA cN c1 caddc
      co vk cv cmin co expcl mpan 3syl vk cv c1 cN cfz co wcel cB vk cv cexp co
      cc wcel cN cn wcel cB cc wcel vk cv cn wcel cB vk cv cexp co cc wcel vk
      cv c1 cN cfz co wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      vk cv cn wcel cB vk cv expcl vk cv nnnn0 sylan2 binomlem.2 vk cv cN
      elfznn sylancr adantl sylanc sylanc cN vk cv c1 cmin co cbc co cc wcel cA
      cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cc wcel cN
      vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cc wcel cN cn wcel vk cv c1 cN cfz co wcel wa cN
      vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co mulcl cN cn wcel vk cv c1 cN cfz co wcel wa cN vk cv c1
      cmin co cbc co cn0 wcel cN vk cv c1 cmin co cbc co cc wcel cN cn0 wcel vk
      cv c1 cmin co cz wcel cN vk cv c1 cmin co cbc co cn0 wcel cN cn wcel vk
      cv c1 cN cfz co wcel vk cv c1 cmin co cN bccl cN nnnn0 vk cv c1 cN cfz co
      wcel vk cv cz wcel vk cv c1 cmin co cz wcel vk cv c1 cN elfzelz vk cv
      peano2zm syl syl2an cN vk cv c1 cmin co cbc co nn0cn syl cA cN c1 caddc
      co vk cv cmin co cexp co cc wcel cB vk cv cexp co cc wcel cA cN c1 caddc
      co vk cv cmin co cexp co cB vk cv cexp co cmul co cc wcel cN cn wcel vk
      cv c1 cN cfz co wcel wa cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co mulcl cN cn wcel vk cv c1 cN cfz co wcel wa vk cv c1 cN c1 caddc
      co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk
      cv cmin co cexp co cc wcel cn vk cv c1 cN fzelp1 cN c1 caddc co cvv wcel
      vk cv c1 cN c1 caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel
      cN c1 caddc oprex cvv vk cv c1 cN c1 caddc co fznn0sub mpan cA cc wcel cN
      c1 caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp
      co cc wcel binomlem.1 cA cN c1 caddc co vk cv cmin co expcl mpan 3syl vk
      cv c1 cN cfz co wcel cB vk cv cexp co cc wcel cN cn wcel cB cc wcel vk cv
      cn wcel cB vk cv cexp co cc wcel vk cv c1 cN cfz co wcel cB cc wcel vk cv
      cn0 wcel cB vk cv cexp co cc wcel vk cv cn wcel cB vk cv expcl vk cv
      nnnn0 sylan2 binomlem.2 vk cv cN elfznn sylancr adantl sylanc sylanc jca
      r19.21aiva cN c1 cuz cfv wcel cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel cN vk cv c1 cmin
      co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co cc wcel wa vk c1 cN cfz co wral c1 cN cfz co cN vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co caddc co vk csu c1 cN cfz co cN vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu caddc co wceq cN
      cn wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk c1 cN fsumadd cN
      elnnuz sylanb mpdan cN cn wcel c1 cN cfz co cN vk cv cbc co cA cN c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cN vk cv
      c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co caddc co cN c1 caddc co vk cv cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk cN cn wcel vk
      cv c1 cN cfz co wcel wa cN vk cv cbc co cN vk cv c1 cmin co cbc co caddc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co caddc co cN c1 caddc co
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co cN vk cv cbc co cc wcel cN vk cv c1 cmin co cbc co cc
      wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cc
      wcel cN vk cv cbc co cN vk cv c1 cmin co cbc co caddc co cA cN c1 caddc
      co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cN vk cv cbc co
      cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co caddc co wceq cN cn wcel vk cv c1 cN cfz co
      wcel wa cN vk cv cbc co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co adddir cN cn wcel vk cv c1 cN
      cfz co wcel wa cN vk cv cbc co cn0 wcel cN vk cv cbc co cc wcel cN cn0
      wcel vk cv cz wcel cN vk cv cbc co cn0 wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv cN bccl cN nnnn0 vk cv c1 cN elfzelz syl2an cN vk cv cbc co
      nn0cn syl cN cn wcel vk cv c1 cN cfz co wcel wa cN vk cv c1 cmin co cbc
      co cn0 wcel cN vk cv c1 cmin co cbc co cc wcel cN cn0 wcel vk cv c1 cmin
      co cz wcel cN vk cv c1 cmin co cbc co cn0 wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv c1 cmin co cN bccl cN nnnn0 vk cv c1 cN cfz co wcel vk cv
      cz wcel vk cv c1 cmin co cz wcel vk cv c1 cN elfzelz vk cv peano2zm syl
      syl2an cN vk cv c1 cmin co cbc co nn0cn syl cA cN c1 caddc co vk cv cmin
      co cexp co cc wcel cB vk cv cexp co cc wcel cA cN c1 caddc co vk cv cmin
      co cexp co cB vk cv cexp co cmul co cc wcel cN cn wcel vk cv c1 cN cfz co
      wcel wa cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co mulcl cN
      cn wcel vk cv c1 cN cfz co wcel wa vk cv c1 cN c1 caddc co cfz co wcel cN
      c1 caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp
      co cc wcel cn vk cv c1 cN fzelp1 cN c1 caddc co cvv wcel vk cv c1 cN c1
      caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cN c1 caddc
      oprex cvv vk cv c1 cN c1 caddc co fznn0sub mpan cA cc wcel cN c1 caddc co
      vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel
      binomlem.1 cA cN c1 caddc co vk cv cmin co expcl mpan 3syl vk cv c1 cN
      cfz co wcel cB vk cv cexp co cc wcel cN cn wcel cB cc wcel vk cv cn wcel
      cB vk cv cexp co cc wcel vk cv c1 cN cfz co wcel cB cc wcel vk cv cn0
      wcel cB vk cv cexp co cc wcel vk cv cn wcel cB vk cv expcl vk cv nnnn0
      sylan2 binomlem.2 vk cv cN elfznn sylancr adantl sylanc syl3anc cN cn
      wcel vk cv c1 cN cfz co wcel wa cN vk cv cbc co cN vk cv c1 cmin co cbc
      co caddc co cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul cN cn0 wcel vk cv cz wcel cN vk cv
      cbc co cN vk cv c1 cmin co cbc co caddc co cN c1 caddc co vk cv cbc co
      wceq cN cn wcel vk cv c1 cN cfz co wcel vk cv cN bcpasc cN nnnn0 vk cv c1
      cN elfzelz syl2an opreq1d eqtr3d sumeq2dv eqtr3d opreq1d c1 cN cfz co cN
      vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu cc wcel c1 cN cfz co cN vk cv c1 cmin co cbc co cA
      cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu cc wcel cB cN c1 caddc co cexp co cc wcel c1 cN cfz co cN vk cv cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk csu c1 cN cfz co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu caddc co cB cN c1
      caddc co cexp co caddc co c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1 cN cfz
      co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co cexp co caddc co
      caddc co wceq cN cn wcel c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1 cN cfz
      co cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu cB cN c1 caddc co cexp co addass cN
      cn wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cc wcel vk c1 cN cfz co wral c1 cN cfz co cN vk
      cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co vk csu cc wcel cN cn wcel cN vk cv cbc co cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk c1 cN cfz
      co cN vk cv cbc co cc wcel cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cc wcel cN vk cv cbc co cA cN c1 caddc co vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co cc wcel cN cn wcel vk cv c1
      cN cfz co wcel wa cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co mulcl cN cn0 wcel vk cv cz wcel cN vk cv cbc co
      cc wcel cN cn wcel vk cv c1 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa
      cN vk cv cbc co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv
      cbc co nn0cn syl cN nnnn0 vk cv c1 cN elfzelz syl2an cA cN c1 caddc co vk
      cv cmin co cexp co cc wcel cB vk cv cexp co cc wcel cA cN c1 caddc co vk
      cv cmin co cexp co cB vk cv cexp co cmul co cc wcel cN cn wcel vk cv c1
      cN cfz co wcel wa cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp
      co mulcl cN cn wcel vk cv c1 cN cfz co wcel wa vk cv c1 cN c1 caddc co
      cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv
      cmin co cexp co cc wcel cn vk cv c1 cN fzelp1 cN c1 caddc co cvv wcel vk
      cv c1 cN c1 caddc co cfz co wcel cN c1 caddc co vk cv cmin co cn0 wcel cN
      c1 caddc oprex cvv vk cv c1 cN c1 caddc co fznn0sub mpan cA cc wcel cN c1
      caddc co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co
      cc wcel binomlem.1 cA cN c1 caddc co vk cv cmin co expcl mpan 3syl vk cv
      c1 cN cfz co wcel cB vk cv cexp co cc wcel cN cn wcel cB cc wcel vk cv cn
      wcel cB vk cv cexp co cc wcel vk cv c1 cN cfz co wcel cB cc wcel vk cv
      cn0 wcel cB vk cv cexp co cc wcel vk cv cn wcel cB vk cv expcl vk cv
      nnnn0 sylan2 binomlem.2 vk cv cN elfznn sylancr adantl sylanc sylanc
      r19.21aiva cN c1 cuz cfv wcel cN vk cv cbc co cA cN c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk c1 cN cfz co
      wral c1 cN cfz co cN vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul co vk csu cc wcel cN cn wcel cN vk cv cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk c1 cN fsumcl cN elnnuz sylanb mpdan cN cn wcel cN vk cv c1 cmin co
      cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cc wcel vk c1 cN cfz co wral c1 cN cfz co cN vk cv c1 cmin co cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk csu cc wcel cN cn wcel cN vk cv c1 cmin co cbc co cA cN c1 caddc co
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk c1 cN
      cfz co cN vk cv c1 cmin co cbc co cc wcel cA cN c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cc wcel cN vk cv c1 cmin co cbc co cA cN
      c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc
      wcel cN cn wcel vk cv c1 cN cfz co wcel wa cN vk cv c1 cmin co cbc co cA
      cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co mulcl cN
      cn0 wcel vk cv c1 cmin co cz wcel cN vk cv c1 cmin co cbc co cc wcel cN
      cn wcel vk cv c1 cN cfz co wcel cN cn0 wcel vk cv c1 cmin co cz wcel wa
      cN vk cv c1 cmin co cbc co cn0 wcel cN vk cv c1 cmin co cbc co cc wcel vk
      cv c1 cmin co cN bccl cN vk cv c1 cmin co cbc co nn0cn syl cN nnnn0 vk cv
      c1 cN cfz co wcel vk cv cz wcel vk cv c1 cmin co cz wcel vk cv c1 cN
      elfzelz vk cv peano2zm syl syl2an cA cN c1 caddc co vk cv cmin co cexp co
      cc wcel cB vk cv cexp co cc wcel cA cN c1 caddc co vk cv cmin co cexp co
      cB vk cv cexp co cmul co cc wcel cN cn wcel vk cv c1 cN cfz co wcel wa cA
      cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co mulcl cN cn wcel vk
      cv c1 cN cfz co wcel wa vk cv c1 cN c1 caddc co cfz co wcel cN c1 caddc
      co vk cv cmin co cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel
      cn vk cv c1 cN fzelp1 cN c1 caddc co cvv wcel vk cv c1 cN c1 caddc co cfz
      co wcel cN c1 caddc co vk cv cmin co cn0 wcel cN c1 caddc oprex cvv vk cv
      c1 cN c1 caddc co fznn0sub mpan cA cc wcel cN c1 caddc co vk cv cmin co
      cn0 wcel cA cN c1 caddc co vk cv cmin co cexp co cc wcel binomlem.1 cA cN
      c1 caddc co vk cv cmin co expcl mpan 3syl vk cv c1 cN cfz co wcel cB vk
      cv cexp co cc wcel cN cn wcel cB cc wcel vk cv cn wcel cB vk cv cexp co
      cc wcel vk cv c1 cN cfz co wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel vk cv cn wcel cB vk cv expcl vk cv nnnn0 sylan2 binomlem.2 vk
      cv cN elfznn sylancr adantl sylanc sylanc r19.21aiva cN c1 cuz cfv wcel
      cN vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co cc wcel vk c1 cN cfz co wral c1 cN cfz co cN
      vk cv c1 cmin co cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk csu cc wcel cN cn wcel cN vk cv c1 cmin co cbc
      co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co vk c1 cN fsumcl cN elnnuz sylanb mpdan cB cc wcel cN c1 caddc co cn
      wcel cB cN c1 caddc co cexp co cc wcel cN cn wcel cB cc wcel cN c1 caddc
      co cn0 wcel cB cN c1 caddc co cexp co cc wcel cN c1 caddc co cn wcel cB
      cN c1 caddc co expcl cN c1 caddc co nnnn0 sylan2 binomlem.2 cN peano2nn
      sylancr syl3anc 3eqtr2d opreq2d 3eqtr4d cN cn wcel cN cc0 cuz cfv wcel
      cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co vk csu cc wcel cc0 cN cfz co cN vk cv cbc co cA cN vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cB caddc co
      cmul co cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu cA cmul co cc0 cN cfz co cN vk cv cbc
      co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB
      cmul co caddc co wceq cN cn wcel cN cn0 cc0 cuz cfv cN nnnn0 nn0uz
      syl6eleq cN cc0 cuz cfv wcel cN vk cv cbc co cA cN vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul co cc wcel vk cc0 cN cfz co wral cc0 cN cfz
      co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu cc wcel cN cc0 cuz cfv wcel cN vk cv cbc co cA cN vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel vk cc0 cN cfz co
      cN vk cv cbc co cc wcel cA cN vk cv cmin co cexp co cB vk cv cexp co cmul
      co cc wcel cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co cc wcel cN cc0 cuz cfv wcel vk cv cc0 cN cfz co wcel wa
      cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co
      mulcl cN cn0 wcel vk cv cz wcel cN vk cv cbc co cc wcel cN cc0 cuz cfv
      wcel vk cv cc0 cN cfz co wcel cN cn0 wcel vk cv cz wcel wa cN vk cv cbc
      co cn0 wcel cN vk cv cbc co cc wcel vk cv cN bccl cN vk cv cbc co nn0cn
      syl cN cn0 wcel cN cc0 cuz cfv wcel cN elnn0uz biimpri vk cv cc0 cN
      elfzelz syl2an cA cN vk cv cmin co cexp co cc wcel cB vk cv cexp co cc
      wcel cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cc wcel cN cc0
      cuz cfv wcel vk cv cc0 cN cfz co wcel wa cA cN vk cv cmin co cexp co cB
      vk cv cexp co mulcl cA cc wcel cN vk cv cmin co cn0 wcel cA cN vk cv cmin
      co cexp co cc wcel cN cc0 cuz cfv wcel vk cv cc0 cN cfz co wcel wa cA cN
      vk cv cmin co expcl binomlem.1 cc0 cuz cfv vk cv cc0 cN fznn0sub sylancr
      vk cv cc0 cN cfz co wcel cB vk cv cexp co cc wcel cN cc0 cuz cfv wcel cB
      cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 cN cfz co wcel
      cB vk cv expcl binomlem.2 vk cv cN elfznn0 sylancr adantl sylanc sylanc
      r19.21aiva cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk cc0 cN fsumcl mpdan cc0 cN cfz co cN vk cv cbc co cA
      cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cc wcel
      cA cc wcel cB cc wcel cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu cA cB caddc co cmul co
      cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co vk csu cA cmul co cc0 cN cfz co cN vk cv cbc co cA cN
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cB cmul co
      caddc co wceq binomlem.1 binomlem.2 cc0 cN cfz co cN vk cv cbc co cA cN
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cB adddi
      mp3an23 3syl cN cn wcel cN cn0 wcel cc0 cN c1 caddc co cfz co cN c1 caddc
      co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu cA cN c1 caddc co cexp co c1 cN c1 caddc co cfz co
      cN c1 caddc co vk cv cbc co cA cN c1 caddc co vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu caddc co wceq cN nnnn0 cA cB vk cN
      binomlem.1 binomlem.2 binomlem4 syl 3eqtr4d $.
      $( [31-Jul-2006] $) $( [7-Dec-2005] $)

    $( Lemma for ~ binomi (binomial theorem).  Do the final induction. $)
    binomlem6 $p |- ( N e. NN -> ( ( A + B ) ^ N ) = sum_ k e. ( 0 ... N )
         ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) ) $=
      cA cB caddc co vx cv cexp co cc0 vx cv cfz co vx cv vk cv cbc co cA vx cv
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cA cB
      caddc co c1 cexp co cc0 c1 cfz co c1 vk cv cbc co cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cA cB caddc co vj cv
      cexp co cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vk csu wceq cA cB caddc co vj cv c1
      caddc co cexp co cc0 vj cv c1 caddc co cfz co vj cv c1 caddc co vk cv cbc
      co cA vj cv c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu wceq cA cB caddc co cN cexp co cc0 cN cfz co cN vk cv cbc
      co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      wceq vx vj cN vx cv c1 wceq cA cB caddc co vx cv cexp co cA cB caddc co
      c1 cexp co cc0 vx cv cfz co vx cv vk cv cbc co cA vx cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu cc0 c1 cfz co c1 vk cv
      cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu vx cv c1 cA cB caddc co cexp opreq2 vx cv c1 wceq cc0 vx cv cfz co
      cc0 c1 cfz co vx cv vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk vx cv c1 cc0 cfz opreq2 vx cv c1 wceq vx cv
      vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co wceq vk cv cc0 c1 cfz co wcel vx cv c1 wceq vx cv vk cv cbc co c1
      vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv cexp co cmul co cA
      c1 vk cv cmin co cexp co cB vk cv cexp co cmul co cmul vx cv c1 vk cv cbc
      opreq1 vx cv c1 wceq cA vx cv vk cv cmin co cexp co cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul vx cv c1 wceq vx cv vk cv cmin co c1 vk cv
      cmin co cA cexp vx cv c1 vk cv cmin opreq1 opreq2d opreq1d opreq12d
      adantr sumeq12rdv eqeq12d vx cv vj cv wceq cA cB caddc co vx cv cexp co
      cA cB caddc co vj cv cexp co cc0 vx cv cfz co vx cv vk cv cbc co cA vx cv
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cc0 vj cv
      cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu vx cv vj cv cA cB caddc co cexp opreq2 vx cv vj cv
      wceq cc0 vx cv cfz co cc0 vj cv cfz co vx cv vk cv cbc co cA vx cv vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vj cv vk cv cbc co cA vj
      cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk vx cv vj cv
      cc0 cfz opreq2 vx cv vj cv wceq vx cv vk cv cbc co cA vx cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vj cv vk cv cbc co cA vj cv vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co wceq vk cv cc0 vj cv
      cfz co wcel vx cv vj cv wceq vx cv vk cv cbc co vj cv vk cv cbc co cA vx
      cv vk cv cmin co cexp co cB vk cv cexp co cmul co cA vj cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul vx cv vj cv vk cv cbc opreq1 vx cv
      vj cv wceq cA vx cv vk cv cmin co cexp co cA vj cv vk cv cmin co cexp co
      cB vk cv cexp co cmul vx cv vj cv wceq vx cv vk cv cmin co vj cv vk cv
      cmin co cA cexp vx cv vj cv vk cv cmin opreq1 opreq2d opreq1d opreq12d
      adantr sumeq12rdv eqeq12d vx cv vj cv c1 caddc co wceq cA cB caddc co vx
      cv cexp co cA cB caddc co vj cv c1 caddc co cexp co cc0 vx cv cfz co vx
      cv vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu cc0 vj cv c1 caddc co cfz co vj cv c1 caddc co vk cv cbc
      co cA vj cv c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu vx cv vj cv c1 caddc co cA cB caddc co cexp opreq2 vx cv
      vj cv c1 caddc co wceq cc0 vx cv cfz co cc0 vj cv c1 caddc co cfz co vx
      cv vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vj cv c1 caddc co vk cv cbc co cA vj cv c1 caddc co vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk vx cv vj cv c1 caddc co cc0
      cfz opreq2 vx cv vj cv c1 caddc co wceq vx cv vk cv cbc co cA vx cv vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vj cv c1 caddc co vk cv
      cbc co cA vj cv c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co wceq vk cv cc0 vj cv c1 caddc co cfz co wcel vx cv vj cv c1
      caddc co wceq vx cv vk cv cbc co vj cv c1 caddc co vk cv cbc co cA vx cv
      vk cv cmin co cexp co cB vk cv cexp co cmul co cA vj cv c1 caddc co vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul vx cv vj cv c1 caddc co vk
      cv cbc opreq1 vx cv vj cv c1 caddc co wceq cA vx cv vk cv cmin co cexp co
      cA vj cv c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul vx cv vj
      cv c1 caddc co wceq vx cv vk cv cmin co vj cv c1 caddc co vk cv cmin co
      cA cexp vx cv vj cv c1 caddc co vk cv cmin opreq1 opreq2d opreq1d
      opreq12d adantr sumeq12rdv eqeq12d vx cv cN wceq cA cB caddc co vx cv
      cexp co cA cB caddc co cN cexp co cc0 vx cv cfz co vx cv vk cv cbc co cA
      vx cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cc0
      cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu vx cv cN cA cB caddc co cexp opreq2 vx cv cN wceq
      cc0 vx cv cfz co cc0 cN cfz co vx cv vk cv cbc co cA vx cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co cN vk cv cbc co cA cN vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk vx cv cN cc0 cfz opreq2 vx
      cv cN wceq vx cv vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co wceq vk cv cc0 cN cfz co wcel vx cv cN wceq vx
      cv vk cv cbc co cN vk cv cbc co cA vx cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      vx cv cN vk cv cbc opreq1 vx cv cN wceq cA vx cv vk cv cmin co cexp co cA
      cN vk cv cmin co cexp co cB vk cv cexp co cmul vx cv cN wceq vx cv vk cv
      cmin co cN vk cv cmin co cA cexp vx cv cN vk cv cmin opreq1 opreq2d
      opreq1d opreq12d adantr sumeq12rdv eqeq12d cA cB caddc co c1 cexp co cA
      cB caddc co cc0 cc0 c1 caddc co cfz co c1 vk cv cbc co cA c1 vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk csu cc0 c1 cfz co c1 vk cv
      cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu cA cB caddc co cc wcel cA cB caddc co c1 cexp co cA cB caddc co wceq
      cA cB binomlem.1 binomlem.2 addcli cA cB caddc co exp1 ax-mp cc0 cc0 c1
      caddc co cfz co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co vk csu cc0 cc0 cfz co c1 vk cv cbc co cA c1 vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk csu cB caddc co cA cB
      caddc co cc0 cc0 cuz cfv wcel cc0 cc0 c1 caddc co cfz co c1 vk cv cbc co
      cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cc0
      cc0 cfz co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu cB caddc co wceq cc0 cz wcel cc0 cc0 cuz cfv wcel
      0z cc0 uzid ax-mp c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co cB vk cc0 cc0 c1 vk cv cbc co cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul oprex cB cc binomlem.2 elisseti vk
      cv cc0 c1 caddc co wceq vk cv c1 wceq c1 vk cv cbc co cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co cB wceq cc0 c1 caddc co c1 vk cv
      c1 ax1cn addid2i eqeq2i vk cv c1 wceq c1 vk cv cbc co cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co c1 cB cmul co cB vk cv c1 wceq
      c1 vk cv cbc co c1 cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co
      cB cmul vk cv c1 wceq c1 vk cv cbc co c1 c1 cbc co c1 vk cv c1 c1 cbc
      opreq2 c1 cn0 wcel c1 c1 cbc co c1 wceq 1nn0 c1 bcnn ax-mp syl6eq vk cv
      c1 wceq cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co c1 cB cmul
      co cB vk cv c1 wceq cA c1 vk cv cmin co cexp co c1 cB vk cv cexp co cB
      cmul vk cv c1 wceq cA c1 vk cv cmin co cexp co cA cc0 cexp co c1 vk cv c1
      wceq c1 vk cv cmin co cc0 cA cexp vk cv c1 wceq c1 vk cv cmin co c1 c1
      cmin co cc0 vk cv c1 c1 cmin opreq2 c1 ax1cn subidi syl6eq opreq2d cA cc
      wcel cA cc0 cexp co c1 wceq binomlem.1 cA exp0 ax-mp syl6eq vk cv c1 wceq
      cB vk cv cexp co cB c1 cexp co cB vk cv c1 cB cexp opreq2 cB cc wcel cB
      c1 cexp co cB wceq binomlem.2 cB exp1 ax-mp syl6eq opreq12d cB binomlem.2
      mulid2i syl6eq opreq12d cB binomlem.2 mulid2i syl6eq sylbi fsump1i ax-mp
      cc0 cc0 cfz co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co vk csu cA cB caddc cA cc wcel cc0 cz wcel cc0 cc0 cfz
      co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu cA wceq binomlem.1 0z c1 vk cv cbc co cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co cA cc vk cc0 vk cv cc0 wceq c1
      vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      c1 cA cmul co cA vk cv cc0 wceq c1 vk cv cbc co c1 cA c1 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cA cmul vk cv cc0 wceq c1 vk cv cbc co
      c1 cc0 cbc co c1 vk cv cc0 c1 cbc opreq2 c1 cn0 wcel c1 cc0 cbc co c1
      wceq 1nn0 c1 bcn0 ax-mp syl6eq vk cv cc0 wceq cA c1 vk cv cmin co cexp co
      cB vk cv cexp co cmul co cA c1 cmul co cA vk cv cc0 wceq cA c1 vk cv cmin
      co cexp co cA cB vk cv cexp co c1 cmul vk cv cc0 wceq cA c1 vk cv cmin co
      cexp co cA c1 cexp co cA vk cv cc0 wceq c1 vk cv cmin co c1 cA cexp vk cv
      cc0 wceq c1 vk cv cmin co c1 cc0 cmin co c1 vk cv cc0 c1 cmin opreq2 c1
      ax1cn subid1i syl6eq opreq2d cA cc wcel cA c1 cexp co cA wceq binomlem.1
      cA exp1 ax-mp syl6eq vk cv cc0 wceq cB vk cv cexp co cB cc0 cexp co c1 vk
      cv cc0 cB cexp opreq2 cB cc wcel cB cc0 cexp co c1 wceq binomlem.2 cB
      exp0 ax-mp syl6eq opreq12d cA binomlem.1 mulid1i syl6eq opreq12d cA
      binomlem.1 mulid2i syl6eq fsum1i mp2an opreq1i eqtr2i cc0 cc0 c1 caddc co
      cfz co cc0 c1 cfz co c1 vk cv cbc co cA c1 vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vk cc0 c1 caddc co c1 cc0 cfz c1 ax1cn addid2i
      opreq2i sumeq1i 3eqtri vj cv cn wcel cA cB caddc co vj cv cexp co cc0 vj
      cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co vk csu wceq cA cB caddc co vj cv c1 caddc co cexp co
      cc0 vj cv c1 caddc co cfz co vj cv c1 caddc co vk cv cbc co cA vj cv c1
      caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      wceq vj cv cn wcel cA cB caddc co vj cv cexp co cc0 vj cv cfz co vj cv vk
      cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vk csu wceq wa cA cB caddc co vj cv c1 caddc co cexp co cA cB caddc co vj
      cv cexp co cA cB caddc co cmul co cc0 vj cv cfz co vj cv vk cv cbc co cA
      vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cB
      caddc co cmul co cc0 vj cv c1 caddc co cfz co vj cv c1 caddc co vk cv cbc
      co cA vj cv c1 caddc co vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk csu vj cv cn wcel cA cB caddc co vj cv c1 caddc co cexp co cA
      cB caddc co vj cv cexp co cA cB caddc co cmul co wceq cA cB caddc co vj
      cv cexp co cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu wceq cA cB caddc co cc
      wcel vj cv cn0 wcel cA cB caddc co vj cv c1 caddc co cexp co cA cB caddc
      co vj cv cexp co cA cB caddc co cmul co wceq vj cv cn wcel cA cB caddc co
      vj cv expp1 cA cB binomlem.1 binomlem.2 addcli vj cv nnnn0 sylancr adantr
      vj cv cn wcel cA cB caddc co vj cv cexp co cc0 vj cv cfz co vj cv vk cv
      cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk
      csu wceq wa cA cB caddc co vj cv cexp co cc0 vj cv cfz co vj cv vk cv cbc
      co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu
      cA cB caddc co cmul vj cv cn wcel cA cB caddc co vj cv cexp co cc0 vj cv
      cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu wceq pm3.27 opreq1d vj cv cn wcel cc0 vj cv cfz co
      vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co vk csu cA cB caddc co cmul co cc0 vj cv c1 caddc co cfz co vj
      cv c1 caddc co vk cv cbc co cA vj cv c1 caddc co vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vk csu wceq cA cB caddc co vj cv cexp co
      cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu wceq cA cB vk vj cv binomlem.1
      binomlem.2 binomlem5 adantr 3eqtrd ex nnind $.
      $( [28-Jul-2006] $) $( [7-Dec-2005] $)

    $( The binomial theorem:  ` ( A + B ) ^ N ` is the sum from ` k = 0 ` to
       ` N ` of ` ( N _C k ) x. ( ( A ^ k ) x. ( B ^ ( N - k ) ) ` .  Theorem
       15-2.8 of [Gleason] p. 296.  This final piece of the proof combines
       the ` 0 < N ` case of ~ binomlem6 with the ` N = 0 ` case. $)
    binomi $p |- ( N e. NN0 -> ( ( A + B ) ^ N ) = sum_ k e. ( 0 ... N )
         ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) ) $=
      cN cn0 wcel cN cn wcel cN cc0 wceq wo cA cB caddc co cN cexp co cc0 cN
      cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co vk csu wceq cN elnn0 cN cn wcel cA cB caddc co cN cexp co cc0
      cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co
      cmul co cmul co vk csu wceq cN cc0 wceq cA cB vk cN binomlem.1 binomlem.2
      binomlem6 cN cc0 wceq c1 cc0 cc0 cfz co cc0 vk cv cbc co cA cc0 vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu cA cB caddc co cN
      cexp co cc0 cN cfz co cN vk cv cbc co cA cN vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vk csu cc0 cc0 cfz co cc0 vk cv cbc co cA cc0
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu c1 c1 cc
      wcel cc0 cz wcel cc0 cc0 cfz co cc0 vk cv cbc co cA cc0 vk cv cmin co
      cexp co cB vk cv cexp co cmul co cmul co vk csu c1 wceq ax1cn 0z cc0 vk
      cv cbc co cA cc0 vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      c1 cc vk cc0 vk cv cc0 wceq cc0 vk cv cbc co cA cc0 vk cv cmin co cexp co
      cB vk cv cexp co cmul co cmul co c1 c1 cmul co c1 vk cv cc0 wceq cc0 vk
      cv cbc co c1 cA cc0 vk cv cmin co cexp co cB vk cv cexp co cmul co c1
      cmul vk cv cc0 wceq cc0 vk cv cbc co cc0 cc0 cbc co c1 vk cv cc0 cc0 cbc
      opreq2 cc0 cn0 wcel cc0 cc0 cbc co c1 wceq 0nn0 cc0 bcn0 ax-mp syl6eq vk
      cv cc0 wceq cA cc0 vk cv cmin co cexp co cB vk cv cexp co cmul co c1 c1
      cmul co c1 vk cv cc0 wceq cA cc0 vk cv cmin co cexp co c1 cB vk cv cexp
      co c1 cmul vk cv cc0 wceq cA cc0 vk cv cmin co cexp co cA cc0 cexp co c1
      vk cv cc0 wceq cc0 vk cv cmin co cc0 cA cexp vk cv cc0 wceq cc0 vk cv
      cmin co cc0 cc0 cmin co cc0 vk cv cc0 cc0 cmin opreq2 cc0 0cn subidi
      syl6eq opreq2d cA cc wcel cA cc0 cexp co c1 wceq binomlem.1 cA exp0 ax-mp
      syl6eq vk cv cc0 wceq cB vk cv cexp co cB cc0 cexp co c1 vk cv cc0 cB
      cexp opreq2 cB cc wcel cB cc0 cexp co c1 wceq binomlem.2 cB exp0 ax-mp
      syl6eq opreq12d c1 ax1cn mulid1i syl6eq opreq12d c1 ax1cn mulid1i syl6eq
      fsum1i mp2an eqcomi cN cc0 wceq cA cB caddc co cN cexp co cA cB caddc co
      cc0 cexp co c1 cN cc0 cA cB caddc co cexp opreq2 cA cB caddc co cc wcel
      cA cB caddc co cc0 cexp co c1 wceq cA cB binomlem.1 binomlem.2 addcli cA
      cB caddc co exp0 ax-mp syl6eq cN cc0 wceq cc0 cN cfz co cc0 cc0 cfz co cN
      vk cv cbc co cA cN vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      cc0 vk cv cbc co cA cc0 vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vk cN cc0 cc0 cfz opreq2 cN cc0 wceq cN vk cv cbc co cA cN vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co cc0 vk cv cbc co cA cc0
      vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co wceq vk cv cc0 cc0
      cfz co wcel cN cc0 wceq cN vk cv cbc co cc0 vk cv cbc co cA cN vk cv cmin
      co cexp co cB vk cv cexp co cmul co cA cc0 vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul cN cc0 vk cv cbc opreq1 cN cc0 wceq cA cN vk cv cmin
      co cexp co cA cc0 vk cv cmin co cexp co cB vk cv cexp co cmul cN cc0 wceq
      cN vk cv cmin co cc0 vk cv cmin co cA cexp cN cc0 vk cv cmin opreq1
      opreq2d opreq1d opreq12d adantr sumeq12rdv 3eqtr4a jaoi sylbi $.
      $( [31-Jan-2006] $) $( [7-Dec-2005] $)
  $}

  ${
    $d k A $.  $d k N $.
    binom1p.1 $e |- A e. CC $.
    $( Special case of the binomial theorem for ` ( 1 + A ) ^ N ` .
       (Contributed by Paul Chapman, 10-May-2007.) $)
    binom1pi $p |- ( N e. NN0 -> ( ( 1 + A ) ^ N ) =
                  sum_ k e. ( 0 ... N ) ( ( N _C k ) x. ( A ^ k ) ) ) $=
      cN cn0 wcel c1 cA caddc co cN cexp co cc0 cN cfz co cN vk cv cbc co c1 cN
      vk cv cmin co cexp co cA vk cv cexp co cmul co cmul co vk csu cc0 cN cfz
      co cN vk cv cbc co cA vk cv cexp co cmul co vk csu c1 cA vk cN ax1cn
      binom1p.1 binomi cN cn0 wcel cc0 cN cfz co cN vk cv cbc co c1 cN vk cv
      cmin co cexp co cA vk cv cexp co cmul co cmul co cN vk cv cbc co cA vk cv
      cexp co cmul co vk cN cn0 wcel vk cv cc0 cN cfz co wcel wa c1 cN vk cv
      cmin co cexp co cA vk cv cexp co cmul co cA vk cv cexp co cN vk cv cbc co
      cmul cN cn0 wcel vk cv cc0 cN cfz co wcel wa c1 cN vk cv cmin co cexp co
      cA vk cv cexp co cmul co c1 cA vk cv cexp co cmul co cA vk cv cexp co cN
      cn0 wcel vk cv cc0 cN cfz co wcel wa c1 cN vk cv cmin co cexp co c1 cA vk
      cv cexp co cmul cN cn0 wcel vk cv cc0 cN cfz co wcel wa cN vk cv cmin co
      cn0 wcel c1 cN vk cv cmin co cexp co c1 wceq cn0 vk cv cc0 cN fznn0sub cN
      vk cv cmin co 1exp syl opreq1d vk cv cc0 cN cfz co wcel c1 cA vk cv cexp
      co cmul co cA vk cv cexp co wceq cN cn0 wcel vk cv cc0 cN cfz co wcel vk
      cv cn0 wcel c1 cA vk cv cexp co cmul co cA vk cv cexp co wceq vk cv cN
      elfznn0 vk cv cn0 wcel cA vk cv cexp co cc wcel c1 cA vk cv cexp co cmul
      co cA vk cv cexp co wceq cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc
      wcel binom1p.1 cA vk cv expcl mpan cA vk cv cexp co mulid2 syl syl adantl
      eqtrd opreq2d sumeq2dv eqtrd $.
      $( [10-May-2007] $) $( [10-May-2007] $)
  $}

  ${
    $d M m $.  $d N j k m $.
    $( Lemma for ~ bcxmas . $)
    bcxmaslem1 $p |- ( A = B -> ( ( N + A ) _C A ) = ( ( N + B ) _C B ) ) $=
      cN cA caddc co cN cB caddc co wceq cA cB wceq cN cA caddc co cA cbc co cN
      cB caddc co cB cbc co wceq cA cB cN caddc opreq2 cN cA caddc co cN cB
      caddc co cA cB cbc opreq12 mpancom $.
      $( [18-May-2007] $) $( [18-May-2007] $)

    $( Lemma for ~ bcxmas . $)
    bcxmaslem2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                          ( A + ( B + C ) ) = ( ( A + C ) + B ) ) $=
      cA cc wcel cB cc wcel cC cc wcel w3a cA cB caddc co cC caddc co cA cB cC
      caddc co caddc co cA cC caddc co cB caddc co cA cB cC addass cA cB cC
      add23 eqtr3d $.
      $( [18-May-2007] $) $( [18-May-2007] $)

    $( Parallel summation (Christmas Stocking) theorem for Pascal's Triangle.
       (Contributed by Paul Chapman, 18-May-2007.) $)
    bcxmas $p |- ( ( N e. NN0 /\ M e. NN0 ) ->
                     ( ( ( N + 1 ) + M ) _C M ) =
                     sum_ j e. ( 0 ... M ) ( ( N + j ) _C j ) ) $=
      cM cn0 wcel cN cn0 wcel cN c1 caddc co cM caddc co cM cbc co cc0 cM cfz
      co cN vj cv caddc co vj cv cbc co vj csu wceq cN cn0 wcel cN c1 caddc co
      vm cv caddc co vm cv cbc co cc0 vm cv cfz co cN vj cv caddc co vj cv cbc
      co vj csu wceq wi cN cn0 wcel cN c1 caddc co cc0 caddc co cc0 cbc co cc0
      cc0 cfz co cN vj cv caddc co vj cv cbc co vj csu wceq wi cN cn0 wcel cN
      c1 caddc co vk cv caddc co vk cv cbc co cc0 vk cv cfz co cN vj cv caddc
      co vj cv cbc co vj csu wceq wi cN cn0 wcel cN c1 caddc co vk cv c1 caddc
      co caddc co vk cv c1 caddc co cbc co cc0 vk cv c1 caddc co cfz co cN vj
      cv caddc co vj cv cbc co vj csu wceq wi cN cn0 wcel cN c1 caddc co cM
      caddc co cM cbc co cc0 cM cfz co cN vj cv caddc co vj cv cbc co vj csu
      wceq wi vm vk cM vm cv cc0 wceq cN c1 caddc co vm cv caddc co vm cv cbc
      co cc0 vm cv cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN c1
      caddc co cc0 caddc co cc0 cbc co cc0 cc0 cfz co cN vj cv caddc co vj cv
      cbc co vj csu wceq cN cn0 wcel vm cv cc0 wceq cN c1 caddc co vm cv caddc
      co vm cv cbc co cN c1 caddc co cc0 caddc co cc0 cbc co cc0 vm cv cfz co
      cN vj cv caddc co vj cv cbc co vj csu cc0 cc0 cfz co cN vj cv caddc co vj
      cv cbc co vj csu vm cv cc0 cN c1 caddc co bcxmaslem1 vm cv cc0 wceq cc0
      vm cv cfz co cc0 cc0 cfz co cN vj cv caddc co vj cv cbc co vj vm cv cc0
      cc0 cfz opreq2 sumeq1d eqeq12d imbi2d vm cv vk cv wceq cN c1 caddc co vm
      cv caddc co vm cv cbc co cc0 vm cv cfz co cN vj cv caddc co vj cv cbc co
      vj csu wceq cN c1 caddc co vk cv caddc co vk cv cbc co cc0 vk cv cfz co
      cN vj cv caddc co vj cv cbc co vj csu wceq cN cn0 wcel vm cv vk cv wceq
      cN c1 caddc co vm cv caddc co vm cv cbc co cN c1 caddc co vk cv caddc co
      vk cv cbc co cc0 vm cv cfz co cN vj cv caddc co vj cv cbc co vj csu cc0
      vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu vm cv vk cv cN c1
      caddc co bcxmaslem1 vm cv vk cv wceq cc0 vm cv cfz co cc0 vk cv cfz co cN
      vj cv caddc co vj cv cbc co vj vm cv vk cv cc0 cfz opreq2 sumeq1d eqeq12d
      imbi2d vm cv vk cv c1 caddc co wceq cN c1 caddc co vm cv caddc co vm cv
      cbc co cc0 vm cv cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN c1
      caddc co vk cv c1 caddc co caddc co vk cv c1 caddc co cbc co cc0 vk cv c1
      caddc co cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN cn0 wcel vm
      cv vk cv c1 caddc co wceq cN c1 caddc co vm cv caddc co vm cv cbc co cN
      c1 caddc co vk cv c1 caddc co caddc co vk cv c1 caddc co cbc co cc0 vm cv
      cfz co cN vj cv caddc co vj cv cbc co vj csu cc0 vk cv c1 caddc co cfz co
      cN vj cv caddc co vj cv cbc co vj csu vm cv vk cv c1 caddc co cN c1 caddc
      co bcxmaslem1 vm cv vk cv c1 caddc co wceq cc0 vm cv cfz co cc0 vk cv c1
      caddc co cfz co cN vj cv caddc co vj cv cbc co vj vm cv vk cv c1 caddc co
      cc0 cfz opreq2 sumeq1d eqeq12d imbi2d vm cv cM wceq cN c1 caddc co vm cv
      caddc co vm cv cbc co cc0 vm cv cfz co cN vj cv caddc co vj cv cbc co vj
      csu wceq cN c1 caddc co cM caddc co cM cbc co cc0 cM cfz co cN vj cv
      caddc co vj cv cbc co vj csu wceq cN cn0 wcel vm cv cM wceq cN c1 caddc
      co vm cv caddc co vm cv cbc co cN c1 caddc co cM caddc co cM cbc co cc0
      vm cv cfz co cN vj cv caddc co vj cv cbc co vj csu cc0 cM cfz co cN vj cv
      caddc co vj cv cbc co vj csu vm cv cM cN c1 caddc co bcxmaslem1 vm cv cM
      wceq cc0 vm cv cfz co cc0 cM cfz co cN vj cv caddc co vj cv cbc co vj vm
      cv cM cc0 cfz opreq2 sumeq1d eqeq12d imbi2d cN cn0 wcel cN cc0 caddc co
      cc0 cbc co c1 cc0 cc0 cfz co cN vj cv caddc co vj cv cbc co vj csu cN c1
      caddc co cc0 caddc co cc0 cbc co cN cn0 wcel cc0 cn0 wcel cN cc0 caddc co
      cc0 cbc co c1 wceq 0nn0 cN cn0 wcel cc0 cn0 wcel wa cN cc0 caddc co cn0
      wcel cN cc0 caddc co cc0 cbc co c1 wceq cN cc0 nn0addcl cN cc0 caddc co
      bcn0 syl mpan2 cN cc0 caddc co cc0 cbc co cn0 wcel cc0 cz wcel cc0 cc0
      cfz co cN vj cv caddc co vj cv cbc co vj csu cN cc0 caddc co cc0 cbc co
      wceq cN cn0 wcel cN vj cv caddc co vj cv cbc co cN cc0 caddc co cc0 cbc
      co cn0 vj cc0 vj cv cc0 cN bcxmaslem1 fsum1i cN cn0 wcel cN cc0 caddc co
      cc0 cbc co c1 cn0 cN cn0 wcel cc0 cn0 wcel cN cc0 caddc co cc0 cbc co c1
      wceq 0nn0 cN cn0 wcel cc0 cn0 wcel wa cN cc0 caddc co cn0 wcel cN cc0
      caddc co cc0 cbc co c1 wceq cN cc0 nn0addcl cN cc0 caddc co bcn0 syl
      mpan2 1nn0 syl6eqel 0z sylancl cN cn0 wcel cN c1 caddc co cn0 wcel cc0
      cn0 wcel wa cN c1 caddc co cc0 caddc co cn0 wcel cN c1 caddc co cc0 caddc
      co cc0 cbc co c1 wceq cN cn0 wcel cN c1 caddc co cn0 wcel cc0 cn0 wcel cN
      peano2nn0 0nn0 jctir cN c1 caddc co cc0 nn0addcl cN c1 caddc co cc0 caddc
      co bcn0 3syl 3eqtr4rd vk cv cn0 wcel cN cn0 wcel cN c1 caddc co vk cv
      caddc co vk cv cbc co cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj
      csu wceq cN c1 caddc co vk cv c1 caddc co caddc co vk cv c1 caddc co cbc
      co cc0 vk cv c1 caddc co cfz co cN vj cv caddc co vj cv cbc co vj csu
      wceq cN cn0 wcel vk cv cn0 wcel cN c1 caddc co vk cv caddc co vk cv cbc
      co cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN c1
      caddc co vk cv c1 caddc co caddc co vk cv c1 caddc co cbc co cc0 vk cv c1
      caddc co cfz co cN vj cv caddc co vj cv cbc co vj csu wceq wi cN cn0 wcel
      vk cv cn0 wcel wa cN c1 caddc co vk cv caddc co vk cv cbc co cc0 vk cv
      cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN c1 caddc co vk cv c1
      caddc co caddc co vk cv c1 caddc co cbc co cc0 vk cv c1 caddc co cfz co
      cN vj cv caddc co vj cv cbc co vj csu wceq cN cn0 wcel vk cv cn0 wcel wa
      cN c1 caddc co vk cv caddc co vk cv cbc co cc0 vk cv cfz co cN vj cv
      caddc co vj cv cbc co vj csu wceq wa cc0 vk cv c1 caddc co cfz co cN vj
      cv caddc co vj cv cbc co vj csu cc0 vk cv cfz co cN vj cv caddc co vj cv
      cbc co vj csu cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co
      caddc co cN c1 caddc co vk cv caddc co vk cv cbc co cN c1 caddc co vk cv
      caddc co vk cv c1 caddc co cbc co caddc co cN c1 caddc co vk cv c1 caddc
      co caddc co vk cv c1 caddc co cbc co cN cn0 wcel vk cv cn0 wcel wa cc0 vk
      cv c1 caddc co cfz co cN vj cv caddc co vj cv cbc co vj csu cc0 vk cv cfz
      co cN vj cv caddc co vj cv cbc co vj csu cN c1 caddc co vk cv caddc co vk
      cv c1 caddc co cbc co caddc co wceq cN c1 caddc co vk cv caddc co vk cv
      cbc co cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN cn0
      wcel vk cv cn0 wcel wa cc0 vk cv c1 caddc co cfz co cN vj cv caddc co vj
      cv cbc co vj csu cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu
      cN vk cv c1 caddc co caddc co vk cv c1 caddc co cbc co caddc co cc0 vk cv
      cfz co cN vj cv caddc co vj cv cbc co vj csu cN c1 caddc co vk cv caddc
      co vk cv c1 caddc co cbc co caddc co cN cn0 wcel vk cv cn0 wcel wa vk cv
      cc0 cuz cfv wcel cc0 vk cv c1 caddc co cfz co cN vj cv caddc co vj cv cbc
      co vj csu cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu cN vk cv
      c1 caddc co caddc co vk cv c1 caddc co cbc co caddc co wceq cN cn0 wcel
      vk cv cn0 wcel wa vk cv cn0 wcel vk cv cc0 cuz cfv wcel cN cn0 wcel vk cv
      cn0 wcel pm3.27 vk cv elnn0uz sylib cN vj cv caddc co vj cv cbc co cN vk
      cv c1 caddc co caddc co vk cv c1 caddc co cbc co vj cc0 vk cv cN vj cv
      caddc co vj cv cbc oprex cN vk cv c1 caddc co caddc co vk cv c1 caddc co
      cbc oprex vj cv vk cv c1 caddc co cN bcxmaslem1 fsump1i syl cN cn0 wcel
      vk cv cn0 wcel wa cN vk cv c1 caddc co caddc co vk cv c1 caddc co cbc co
      cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co cc0 vk cv cfz co
      cN vj cv caddc co vj cv cbc co vj csu caddc cN cn0 wcel vk cv cn0 wcel wa
      cN vk cv c1 caddc co caddc co cN c1 caddc co vk cv caddc co vk cv c1
      caddc co cbc cN cc wcel vk cv cc wcel c1 cc wcel cN vk cv c1 caddc co
      caddc co cN c1 caddc co vk cv caddc co wceq cN cn0 wcel vk cv cn0 wcel wa
      cN vk cv c1 bcxmaslem2 cN cn0 wcel cN cc wcel vk cv cn0 wcel cN nn0cn
      adantr vk cv cn0 wcel vk cv cc wcel cN cn0 wcel vk cv nn0cn adantl c1 cc
      wcel cN cn0 wcel vk cv cn0 wcel wa ax1cn a1i syl3anc opreq1d opreq2d
      eqtrd adantr cN c1 caddc co vk cv caddc co vk cv cbc co cc0 vk cv cfz co
      cN vj cv caddc co vj cv cbc co vj csu wceq cN c1 caddc co vk cv caddc co
      vk cv cbc co cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co caddc
      co cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu cN c1 caddc co
      vk cv caddc co vk cv c1 caddc co cbc co caddc co wceq cN cn0 wcel vk cv
      cn0 wcel wa cN c1 caddc co vk cv caddc co vk cv cbc co cc0 vk cv cfz co
      cN vj cv caddc co vj cv cbc co vj csu cN c1 caddc co vk cv caddc co vk cv
      c1 caddc co cbc co caddc opreq1 adantl cN cn0 wcel vk cv cn0 wcel wa cN
      c1 caddc co vk cv caddc co vk cv cbc co cN c1 caddc co vk cv caddc co vk
      cv c1 caddc co cbc co caddc co cN c1 caddc co vk cv c1 caddc co caddc co
      vk cv c1 caddc co cbc co wceq cN c1 caddc co vk cv caddc co vk cv cbc co
      cc0 vk cv cfz co cN vj cv caddc co vj cv cbc co vj csu wceq cN cn0 wcel
      vk cv cn0 wcel wa cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co
      cN c1 caddc co vk cv caddc co vk cv cbc co caddc co cN c1 caddc co vk cv
      caddc co c1 caddc co vk cv c1 caddc co cbc co cN c1 caddc co vk cv caddc
      co vk cv cbc co cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co
      caddc co cN c1 caddc co vk cv c1 caddc co caddc co vk cv c1 caddc co cbc
      co cN cn0 wcel vk cv cn0 wcel wa cN c1 caddc co vk cv caddc co vk cv c1
      caddc co cbc co cN c1 caddc co vk cv caddc co vk cv c1 caddc co c1 cmin
      co cbc co caddc co cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co
      cN c1 caddc co vk cv caddc co vk cv cbc co caddc co cN c1 caddc co vk cv
      caddc co c1 caddc co vk cv c1 caddc co cbc co cN cn0 wcel vk cv cn0 wcel
      wa cN c1 caddc co vk cv caddc co vk cv c1 caddc co c1 cmin co cbc co cN
      c1 caddc co vk cv caddc co vk cv cbc co cN c1 caddc co vk cv caddc co vk
      cv c1 caddc co cbc co caddc cN cn0 wcel vk cv cn0 wcel wa vk cv c1 caddc
      co c1 cmin co vk cv cN c1 caddc co vk cv caddc co cbc vk cv cc wcel c1 cc
      wcel vk cv c1 caddc co c1 cmin co vk cv wceq cN cn0 wcel vk cv cn0 wcel
      wa vk cv c1 pncan vk cv cn0 wcel vk cv cc wcel cN cn0 wcel vk cv nn0cn
      adantl ax1cn sylancl opreq2d opreq2d cN c1 caddc co vk cv caddc co cn
      wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cN c1 caddc co vk cv
      caddc co cle wbr cN c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co
      cN c1 caddc co vk cv caddc co vk cv c1 caddc co c1 cmin co cbc co caddc
      co cN c1 caddc co vk cv caddc co c1 caddc co vk cv c1 caddc co cbc co
      wceq cN cn0 wcel vk cv cn0 wcel wa vk cv c1 caddc co cN c1 caddc co vk cv
      caddc co bcpasc2 cN c1 caddc co cn wcel vk cv cn0 wcel cN c1 caddc co vk
      cv caddc co cn wcel cN cn0 wcel cN c1 caddc co vk cv nnnn0addcl cN
      nn0p1nn sylan vk cv cn0 wcel vk cv c1 caddc co cn wcel cN cn0 wcel vk cv
      nn0p1nn adantl cN cn0 wcel vk cv cn0 wcel wa vk cv c1 caddc co cN vk cv
      c1 caddc co caddc co cN c1 caddc co vk cv caddc co cle vk cv c1 caddc co
      cr wcel cN cn0 wcel vk cv c1 caddc co cN vk cv c1 caddc co caddc co cle
      wbr cN cn0 wcel vk cv cn0 wcel wa vk cv c1 caddc co cN nn0addge2 cN cn0
      wcel vk cv cn0 wcel wa vk cv c1 caddc co cn wcel vk cv c1 caddc co cr
      wcel vk cv cn0 wcel vk cv c1 caddc co cn wcel cN cn0 wcel vk cv nn0p1nn
      adantl vk cv c1 caddc co nnre syl cN cn0 wcel vk cv cn0 wcel pm3.26
      sylanc cN cc wcel vk cv cc wcel c1 cc wcel cN vk cv c1 caddc co caddc co
      cN c1 caddc co vk cv caddc co wceq cN cn0 wcel vk cv cn0 wcel wa cN vk cv
      c1 bcxmaslem2 cN cn0 wcel cN cc wcel vk cv cn0 wcel cN nn0cn adantr vk cv
      cn0 wcel vk cv cc wcel cN cn0 wcel vk cv nn0cn adantl c1 cc wcel cN cn0
      wcel vk cv cn0 wcel wa ax1cn a1i syl3anc breqtrd syl3anc eqtr3d cN c1
      caddc co vk cv caddc co vk cv c1 caddc co cbc co cc wcel cN c1 caddc co
      vk cv caddc co vk cv cbc co cc wcel cN c1 caddc co vk cv caddc co vk cv
      c1 caddc co cbc co cN c1 caddc co vk cv caddc co vk cv cbc co caddc co cN
      c1 caddc co vk cv caddc co vk cv cbc co cN c1 caddc co vk cv caddc co vk
      cv c1 caddc co cbc co caddc co wceq cN cn0 wcel vk cv cn0 wcel wa cN c1
      caddc co vk cv caddc co vk cv c1 caddc co cbc co cN c1 caddc co vk cv
      caddc co vk cv cbc co addcom cN cn0 wcel vk cv cn0 wcel wa cN c1 caddc co
      vk cv caddc co vk cv c1 caddc co cbc co cn0 wcel cN c1 caddc co vk cv
      caddc co vk cv c1 caddc co cbc co cc wcel cN c1 caddc co vk cv caddc co
      cn0 wcel vk cv c1 caddc co cz wcel cN c1 caddc co vk cv caddc co vk cv c1
      caddc co cbc co cn0 wcel cN cn0 wcel vk cv cn0 wcel wa vk cv c1 caddc co
      cN c1 caddc co vk cv caddc co bccl cN cn0 wcel vk cv cn0 wcel wa cN c1
      caddc co vk cv caddc co cn wcel cN c1 caddc co vk cv caddc co cn0 wcel cN
      c1 caddc co cn wcel vk cv cn0 wcel cN c1 caddc co vk cv caddc co cn wcel
      cN cn0 wcel cN c1 caddc co vk cv nnnn0addcl cN nn0p1nn sylan cN c1 caddc
      co vk cv caddc co nnnn0 syl cN cn0 wcel vk cv cn0 wcel wa vk cv c1 caddc
      co cn wcel vk cv c1 caddc co cz wcel vk cv cn0 wcel vk cv c1 caddc co cn
      wcel cN cn0 wcel vk cv nn0p1nn adantl vk cv c1 caddc co nnz syl sylanc cN
      c1 caddc co vk cv caddc co vk cv c1 caddc co cbc co nn0cn syl cN cn0 wcel
      vk cv cn0 wcel wa cN c1 caddc co vk cv caddc co vk cv cbc co cn0 wcel cN
      c1 caddc co vk cv caddc co vk cv cbc co cc wcel cN c1 caddc co cn0 wcel
      vk cv cn0 wcel cN c1 caddc co vk cv caddc co vk cv cbc co cn0 wcel cN cn0
      wcel cN c1 caddc co vk cv caddc co cn0 wcel vk cv cz wcel cN c1 caddc co
      vk cv caddc co vk cv cbc co cn0 wcel cN c1 caddc co cn0 wcel vk cv cn0
      wcel wa vk cv cN c1 caddc co vk cv caddc co bccl cN c1 caddc co vk cv
      nn0addcl vk cv cn0 wcel vk cv cz wcel cN c1 caddc co cn0 wcel vk cv nn0z
      adantl sylanc cN peano2nn0 sylan cN c1 caddc co vk cv caddc co vk cv cbc
      co nn0cn syl sylanc cN cn0 wcel vk cv cn0 wcel wa cN c1 caddc co vk cv
      caddc co c1 caddc co cN c1 caddc co vk cv c1 caddc co caddc co vk cv c1
      caddc co cbc cN c1 caddc co cc wcel vk cv cc wcel c1 cc wcel cN c1 caddc
      co vk cv caddc co c1 caddc co cN c1 caddc co vk cv c1 caddc co caddc co
      wceq cN cn0 wcel vk cv cn0 wcel wa cN c1 caddc co vk cv c1 addass cN cn0
      wcel cN c1 caddc co cc wcel vk cv cn0 wcel cN cn0 wcel cN cc wcel cN c1
      caddc co cc wcel cN nn0cn cN peano2cn syl adantr vk cv cn0 wcel vk cv cc
      wcel cN cn0 wcel vk cv nn0cn adantl c1 cc wcel cN cn0 wcel vk cv cn0 wcel
      wa ax1cn a1i syl3anc opreq1d 3eqtr3d adantr 3eqtr2rd ex expcom a2d nn0ind
      impcom $.
      $( [18-May-2007] $) $( [18-May-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Limits (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k m n x y A $.  $d j k y B $.  $d j k m n x y F $.  $d j k m n M $.
    $d k N $.  $d j k m n x y W $.  $d j k m n x y Z $.
    clm1.1 $e |- M e. ZZ $.
    clm1.2 $e |- ( ZZ>= ` M ) C_ Z $.
    clm1.3 $e |- Z C_ ZZ $.
    clm1.4 $e |- N e. ZZ $.
    clm1.5 $e |- ( ZZ>= ` N ) C_ W $.
    clm1.6 $e |- W C_ ZZ $.
    $( Express the predicate: The limit of complex number sequence ` F `
       is ` A ` , or ` F ` converges to ` A ` , with more general quantifier
       restrictions than ~ clim . $)
    clm1i $p |- ( ( F e. C /\ A e. D ) -> ( F ~~> A <-> ( A e. CC /\
   A. x e. RR ( 0 < x -> E. j e. Z A. k e. W ( j <_ k ->
    ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) ) ) $=
      cF cC wcel cA cD wcel wa cF cA cli wbr cA cc wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral wa cA cc wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vk cW wral vj cZ wrex wi vx cr wral wa vx cA
      cC cD vj vk cF clim cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc
      wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj
      cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral
      vj cZ wrex wi vx cr wral cA cc wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vk cz wral vj cz wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW
      wral vj cZ wrex wi vx cr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cz wral vj cz wrex vj
      cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wa wi vk cW wral vj cZ wrex cc0 vx cv clt wbr vk cv cF cfv cc
      wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vj vk cM cN cW cZ
      clm1.1 clm1.2 clm1.3 clm1.4 clm1.5 clm1.6 cvg3i imbi2i ralbii anbi2i
      syl6bb $.
      $( [11-Jan-2007] $) $( [6-Jan-2007] $)

    ${
      clm2.7 $e |- F e. _V $.
      $( Express the predicate: The limit of complex number sequence ` F `
         is ` A ` , or ` F ` converges to ` A ` . $)
      clm2i $p |- ( A e. CC -> ( F ~~> A <-> A. x e. RR ( 0 < x ->
            E. j e. Z A. k e. W ( j <_ k ->
        ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) ) $=
        cA cc wcel cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
        cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW
        wral vj cZ wrex wi vx cr wral cF cvv wcel cA cc wcel cF cA cli wbr cA
        cc wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral vj cZ wrex
        wi vx cr wral wa wb clm2.7 vx cA cvv cc vj vk cF cM cN cW cZ clm1.1
        clm1.2 clm1.3 clm1.4 clm1.5 clm1.6 clm1i mpan bianabs $.
        $( [11-Jan-2007] $) $( [6-Jan-2007] $)

      $( A sufficient existence condition for convergence of a complex
         number sequence ` F ` . $)
      clm3i $p |- ( ( A e. CC /\ E. m e. Z A. k e. W ( m <_ k ->
             ( F ` k ) e. CC ) ) -> ( F ~~> A <-> A. x e. RR ( 0 < x ->
     E. j e. Z A. k e. W ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) $=
        cA cc wcel cF cA cli wbr cc0 vx cv clt wbr vn cv vk cv cle wbr vk cv cF
        cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW
        wral vn cZ wrex wi vx cr wral vm cv vk cv cle wbr vk cv cF cfv cc wcel
        wi vk cW wral vm cZ wrex cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
        cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex wi vx cr
        wral vx cA vn vk cF cM cN cW cZ clm1.1 clm1.2 clm1.3 clm1.4 clm1.5
        clm1.6 clm2.7 clm2i vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vk cW
        wral vm cZ wrex cc0 vx cv clt wbr vn cv vk cv cle wbr vk cv cF cfv cc
        wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral vn
        cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin
        co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex wi vx cr vm cv vk cv
        cle wbr vk cv cF cfv cc wcel wi vk cW wral vm cZ wrex vn cv vk cv cle
        wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
        wa wi vk cW wral vn cZ wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co
        cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex cc0 vx cv clt wbr vm cv
        vk cv cle wbr vk cv cF cfv cc wcel wi vk cW wral vm cZ wrex vn cv vk cv
        cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt
        wbr wa wi vk cW wral vn cZ wrex vj cv vk cv cle wbr vk cv cF cfv cA
        cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex vn cv vk cv cle
        wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
        wa wi vk cW wral vn cZ wrex vn cv vk cv cle wbr vk cv cF cfv cA cmin co
        cabs cfv vx cv clt wbr wi vk cW wral vn cZ wrex vj cv vk cv cle wbr vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex vn
        cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv
        vx cv clt wbr wa wi vk cW wral vn cv vk cv cle wbr vk cv cF cfv cA cmin
        co cabs cfv vx cv clt wbr wi vk cW wral vn cZ vn cv vk cv cle wbr vk cv
        cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn
        cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk
        cW vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
        wa vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr vn cv vk cv cle wbr
        vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
        pm3.27 imim2i r19.20si r19.22si vn cv vk cv cle wbr vk cv cF cfv cA
        cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cv vk cv cle wbr vk cv
        cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vn vj cZ vn cv
        vj cv wceq vn cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
        clt wbr wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
        clt wbr wi vk cW vn cv vj cv wceq vn cv vk cv cle wbr vj cv vk cv cle
        wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr vn cv vj cv vk cv
        cle breq1 imbi1d ralbidv cbvrexv sylib vm cv vk cv cle wbr vk cv cF cfv
        cc wcel wi vk cW wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
        cfv vx cv clt wbr wi vk cW wral vj cZ wrex vn cv vk cv cle wbr vk cv cF
        cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW
        wral vn cZ wrex wi vm cZ vm cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv
        cc wcel wi vk cW wral wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co
        cabs cfv vx cv clt wbr wi vk cW wral vn cv vk cv cle wbr vk cv cF cfv
        cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral
        vn cZ wrex vj cZ vm cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel
        wi vk cW wral wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
        vx cv clt wbr wi vk cW wral vj cv cZ wcel vn cv vk cv cle wbr vk cv cF
        cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW
        wral vn cZ wrex vm cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel
        wi vk cW wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
        cv clt wbr wi vk cW wral vj cv cZ wcel vn cv vk cv cle wbr vk cv cF cfv
        cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral
        vn cZ wrex wi wi vm cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel
        wi vk cW wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
        cv clt wbr wi vk cW wral vj cv cZ wcel vn cv vk cv cle wbr vk cv cF cfv
        cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral
        vn cZ wrex wi vm cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel wi
        vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi
        wa vk cW wral vj cv cZ wcel vn cv vk cv cle wbr vk cv cF cfv cc wcel vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral vn cZ wrex
        wi vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vk cW wral vj cv vk cv
        cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral wa
        vm cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vj cv vk cv
        cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi wa vk cW wral
        wa vj cv cZ wcel vm cv vj cv cle wbr vj cv vm cv cif cZ wcel vm cv vj
        cv cle wbr vj cv vm cv cif vk cv cle wbr vk cv cF cfv cc wcel vk cv cF
        cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral wa vn cv vk cv
        cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt
        wbr wa wi vk cW wral vn cZ wrex vm cv cZ wcel vm cv vk cv cle wbr vk cv
        cF cfv cc wcel wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
        vx cv clt wbr wi wa vk cW wral wa vj cv cZ wcel vm cv vj cv cle wbr vj
        cv vm cv cif cZ wcel vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr
        vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa
        wi vk cW wral vm cv cZ wcel vj cv cZ wcel vm cv vj cv cle wbr vj cv vm
        cv cif cZ wcel wi vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vj cv vk
        cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi wa vk cW
        wral vj cv cZ wcel vm cv cZ wcel vm cv vj cv cle wbr vj cv vm cv cif cZ
        wcel vm cv vj cv cle wbr vj cv vm cv cZ ifcl expcom adantr vm cv cZ
        wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vj cv vk cv cle wbr vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi wa vk cW wral vj cv cZ
        wcel vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr vk cv cF cfv cc
        wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW wral wi
        vm cv cZ wcel vj cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel wi
        vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi
        wa vk cW wral vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr vk cv
        cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk
        cW wral vm cv cZ wcel vj cv cZ wcel vm cv vk cv cle wbr vk cv cF cfv cc
        wcel wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
        wbr wi wa vk cW wral vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr
        vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa
        wi vk cW wral wi vm cv cZ wcel vj cv cZ wcel wa vm cv vk cv cle wbr vk
        cv cF cfv cc wcel wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
        cfv vx cv clt wbr wi wa vm cv vj cv cle wbr vj cv vm cv cif vk cv cle
        wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
        wa wi vk cW vm cv cZ wcel vj cv cZ wcel wa vk cv cW wcel wa vm cv vj cv
        cle wbr vj cv vm cv cif vk cv cle wbr vm cv vk cv cle wbr vj cv vk cv
        cle wbr wa vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vj cv vk cv cle
        wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi wa vk cv cF cfv
        cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vm cv cr wcel
        vj cv cr wcel wa vk cv cr wcel vm cv vj cv cle wbr vj cv vm cv cif vk
        cv cle wbr vm cv vk cv cle wbr vj cv vk cv cle wbr wa wi vm cv cZ wcel
        vj cv cZ wcel wa vk cv cW wcel vm cv cr wcel vj cv cr wcel wa vk cv cr
        wcel wa vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr vm cv vk cv
        cle wbr vj cv vk cv cle wbr vm cv cr wcel vj cv cr wcel wa vk cv cr
        wcel wa vm cv vm cv vj cv cle wbr vj cv vm cv cif cle wbr vm cv vj cv
        cle wbr vj cv vm cv cif vk cv cle wbr vm cv vk cv cle wbr vm cv cr wcel
        vj cv cr wcel wa vm cv vm cv vj cv cle wbr vj cv vm cv cif cle wbr vk
        cv cr wcel vm cv vj cv max1 adantr vm cv cr wcel vm cv vj cv cle wbr vj
        cv vm cv cif cr wcel wa vk cv cr wcel vm cv vm cv vj cv cle wbr vj cv
        vm cv cif cle wbr vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr wa
        vm cv vk cv cle wbr wi vm cv cr wcel vj cv cr wcel wa vm cv cr wcel vm
        cv vj cv cle wbr vj cv vm cv cif cr wcel vk cv cr wcel vm cv vm cv vj
        cv cle wbr vj cv vm cv cif cle wbr vm cv vj cv cle wbr vj cv vm cv cif
        vk cv cle wbr wa vm cv vk cv cle wbr wi vm cv vm cv vj cv cle wbr vj cv
        vm cv cif vk cv letr 3expa vm cv cr wcel vj cv cr wcel wa vm cv cr wcel
        vm cv vj cv cle wbr vj cv vm cv cif cr wcel vm cv cr wcel vj cv cr wcel
        pm3.26 vj cv cr wcel vm cv cr wcel vm cv vj cv cle wbr vj cv vm cv cif
        cr wcel vm cv vj cv cle wbr vj cv vm cv cr ifcl ancoms jca sylan mpand
        vm cv cr wcel vj cv cr wcel wa vk cv cr wcel wa vj cv vm cv vj cv cle
        wbr vj cv vm cv cif cle wbr vm cv vj cv cle wbr vj cv vm cv cif vk cv
        cle wbr vj cv vk cv cle wbr vm cv cr wcel vj cv cr wcel wa vj cv vm cv
        vj cv cle wbr vj cv vm cv cif cle wbr vk cv cr wcel vm cv vj cv max2
        adantr vj cv cr wcel vm cv vj cv cle wbr vj cv vm cv cif cr wcel wa vk
        cv cr wcel vj cv vm cv vj cv cle wbr vj cv vm cv cif cle wbr vm cv vj
        cv cle wbr vj cv vm cv cif vk cv cle wbr wa vj cv vk cv cle wbr wi vm
        cv cr wcel vj cv cr wcel wa vj cv cr wcel vm cv vj cv cle wbr vj cv vm
        cv cif cr wcel vk cv cr wcel vj cv vm cv vj cv cle wbr vj cv vm cv cif
        cle wbr vm cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr wa vj cv vk
        cv cle wbr wi vj cv vm cv vj cv cle wbr vj cv vm cv cif vk cv letr
        3expa vm cv cr wcel vj cv cr wcel wa vj cv cr wcel vm cv vj cv cle wbr
        vj cv vm cv cif cr wcel vm cv cr wcel vj cv cr wcel pm3.27 vj cv cr
        wcel vm cv cr wcel vm cv vj cv cle wbr vj cv vm cv cif cr wcel vm cv vj
        cv cle wbr vj cv vm cv cr ifcl ancoms jca sylan mpand jcad vm cv cZ
        wcel vm cv cr wcel vj cv cZ wcel vj cv cr wcel cZ cr vm cv cZ cz cr
        clm1.3 zssre sstri sseli cZ cr vj cv cZ cz cr clm1.3 zssre sstri sseli
        anim12i cW cr vk cv cW cz cr clm1.6 zssre sstri sseli syl2an vm cv vk
        cv cle wbr vk cv cF cfv cc wcel vj cv vk cv cle wbr vk cv cF cfv cA
        cmin co cabs cfv vx cv clt wbr prth syl9 r19.20dva ex com23 imp jcad vn
        cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv
        vx cv clt wbr wa wi vk cW wral vm cv vj cv cle wbr vj cv vm cv cif vk
        cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv
        clt wbr wa wi vk cW wral vn vm cv vj cv cle wbr vj cv vm cv cif cZ vn
        cv vm cv vj cv cle wbr vj cv vm cv cif wceq vn cv vk cv cle wbr vk cv
        cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vm
        cv vj cv cle wbr vj cv vm cv cif vk cv cle wbr vk cv cF cfv cc wcel vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cW vn cv vm cv vj
        cv cle wbr vj cv vm cv cif wceq vn cv vk cv cle wbr vm cv vj cv cle wbr
        vj cv vm cv cif vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin
        co cabs cfv vx cv clt wbr wa vn cv vm cv vj cv cle wbr vj cv vm cv cif
        vk cv cle breq1 imbi1d ralbidv rcla4ev syl6 vm cv vk cv cle wbr vk cv
        cF cfv cc wcel wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
        vx cv clt wbr wi vk cW r19.26 sylan2br exp32 imp com23 r19.23adv
        r19.23aiva impbid2 imbi2d ralbidv sylan9bb $.
        $( [14-Jan-2007] $) $( [10-Jan-2007] $)

    $( Express the predicate ` F ` converges to ` A ` . $)
    clm4i $p |- ( ( A e. CC /\ A. k e. ( Z i^i W ) ( F ` k ) e. CC )
           -> ( F ~~> A <-> A. x e. RR ( 0 < x -> E. j e. Z
           A. k e. W ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) $=
      cA cc wcel vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vk cW wral vm cZ
      wrex cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex wi vx cr wral wb
      vk cv cF cfv cc wcel vk cZ cW cin wral vx cA vj vk vm cF cM cN cW cZ
      clm1.1 clm1.2 clm1.3 clm1.4 clm1.5 clm1.6 clm2.7 clm3i cM cZ wcel cM vk
      cv cle wbr vk cv cF cfv cc wcel wi vk cW wral vm cv vk cv cle wbr vk cv
      cF cfv cc wcel wi vk cW wral vm cZ wrex vk cv cF cfv cc wcel vk cZ cW cin
      wral vm cv vk cv cle wbr vk cv cF cfv cc wcel wi vk cW wral cM vk cv cle
      wbr vk cv cF cfv cc wcel wi vk cW wral vm cM cZ vm cv cM wceq vm cv vk cv
      cle wbr vk cv cF cfv cc wcel wi cM vk cv cle wbr vk cv cF cfv cc wcel wi
      vk cW vm cv cM wceq vm cv vk cv cle wbr cM vk cv cle wbr vk cv cF cfv cc
      wcel vm cv cM vk cv cle breq1 imbi1d ralbidv rcla4ev cM cuz cfv cZ cM
      clm1.2 cM cz wcel cM cM cuz cfv wcel clm1.1 cM uzid ax-mp sselii vk cv cF
      cfv cc wcel vk cZ cW cin wral vk cv cZ wcel vk cv cF cfv cc wcel wi vk cW
      wral cM vk cv cle wbr vk cv cF cfv cc wcel wi vk cW wral vk cv cF cfv cc
      wcel vk cv cZ wcel vk cv cF cfv cc wcel wi vk cZ cW cin cW vk cv cZ cW
      cin wcel vk cv cF cfv cc wcel wi vk cv cW wcel vk cv cZ wcel wa vk cv cF
      cfv cc wcel wi vk cv cW wcel vk cv cZ wcel vk cv cF cfv cc wcel wi wi vk
      cv cZ cW cin wcel vk cv cW wcel vk cv cZ wcel wa vk cv cF cfv cc wcel vk
      cv cZ cW cin wcel vk cv cZ wcel vk cv cW wcel wa vk cv cW wcel vk cv cZ
      wcel wa vk cv cZ cW elin vk cv cZ wcel vk cv cW wcel ancom bitri imbi1i
      vk cv cW wcel vk cv cZ wcel vk cv cF cfv cc wcel impexp bitri ralbii2 vk
      cv cZ wcel vk cv cF cfv cc wcel wi cM vk cv cle wbr vk cv cF cfv cc wcel
      wi vk cW vk cv cW wcel cM vk cv cle wbr vk cv cZ wcel vk cv cF cfv cc
      wcel vk cv cW wcel vk cv cz wcel cM vk cv cle wbr vk cv cZ wcel wi cW cz
      vk cv clm1.6 sseli vk cv cz wcel cM vk cv cle wbr vk cv cZ wcel vk cv cz
      wcel cM vk cv cle wbr wa vk cv cM cuz cfv wcel vk cv cZ wcel cM vk cv
      clm1.1 eluz1i cM cuz cfv cZ vk cv clm1.2 sseli sylbir ex syl imim1d
      r19.20i sylbi sylancr sylan2 $.
      $( [14-Jan-2007] $) $( [10-Jan-2007] $)

    $( Express the predicate ` F ` converges to ` A ` , with a non-strict
       ordering requirement. $)
    clm4lei $p |- ( ( A e. CC /\ A. k e. W ( F ` k ) e. CC )
           -> ( F ~~> A <-> A. x e. RR ( 0 < x -> E. j e. Z
           A. k e. W ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) <_ x ) ) ) ) $=
      cA cc wcel vk cv cF cfv cc wcel vk cW wral wa cF cA cli wbr cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr wi
      vk cW wral vj cZ wrex wi vx cr wral cA cc wcel vk cv cF cfv cc wcel vk cW
      wral wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex wi vx cr wral
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv cle wbr wi vk cW wral vj cZ wrex wi vx cr wral cA cc wcel vk cv cF cfv
      cc wcel vk cZ cW cin wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ
      wrex wi vx cr wral wb vk cv cF cfv cc wcel vk cW wral vx cA vj vk cF cM
      cN cW cZ clm1.1 clm1.2 clm1.3 clm1.4 clm1.5 clm1.6 clm2.7 clm4i cZ cW cin
      cW wss vk cv cF cfv cc wcel vk cW wral vk cv cF cfv cc wcel vk cZ cW cin
      wral wi cZ cW inss2 vk cv cF cfv cc wcel vk cZ cW cin cW ssralv ax-mp
      sylan2 cA cc wcel vk cv cF cfv cc wcel vk cW wral wa cc0 vx cv clt wbr vj
      cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW
      wral vj cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv cle wbr wi vk cW wral vj cZ wrex wi vx cr cA cc
      wcel vk cv cF cfv cc wcel vk cW wral wa vx cv cr wcel wa vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ
      wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr
      wi vk cW wral vj cZ wrex cc0 vx cv clt wbr cA cc wcel vk cv cF cfv cc
      wcel vk cW wral wa vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv cle wbr wi vk cW wral vj cZ cA cc wcel vk
      cv cF cfv cc wcel vk cW wral wa vx cv cr wcel wa vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv
      cF cfv cA cmin co cabs cfv vx cv cle wbr wi vk cW cA cc wcel vk cv cF cfv
      cc wcel vk cW wral wa vx cv cr wcel vk cA cc wcel vk cv cF cfv cc wcel vk
      cW wral vk cA cc wcel vk ax-17 vk cv cF cfv cc wcel vk cW hbra1 hban vx
      cv cr wcel vk ax-17 hban cA cc wcel vk cv cF cfv cc wcel vk cW wral wa vx
      cv cr wcel wa vk cv cW wcel wa vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr
      wi cA cc wcel vk cv cF cfv cc wcel vk cW wral wa vx cv cr wcel wa vk cv
      cW wcel wa vk cv cF cfv cA cmin co cabs cfv vx cv ltle cA cc wcel vk cv
      cF cfv cc wcel vk cW wral wa vk cv cW wcel vk cv cF cfv cA cmin co cabs
      cfv cr wcel vx cv cr wcel cA cc wcel vk cv cF cfv cc wcel vk cW wral vk
      cv cW wcel vk cv cF cfv cA cmin co cabs cfv cr wcel cA cc wcel vk cv cF
      cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cc wcel
      vk cW wral vk cv cW wcel wa cA cc wcel vk cv cF cfv cc wcel wa vk cv cF
      cfv cA cmin co cc wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cF
      cfv cc wcel cA cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA
      subcl ancoms vk cv cF cfv cA cmin co abscl syl vk cv cF cfv cc wcel vk cW
      wral vk cv cW wcel vk cv cF cfv cc wcel vk cv cF cfv cc wcel vk cW ra4
      imp sylan2 anassrs adantlr cA cc wcel vk cv cF cfv cc wcel vk cW wral wa
      vx cv cr wcel vk cv cW wcel simplr sylanc imim2d r19.20da r19.22sdv
      imim2d r19.20dva sylbid cA cc wcel vk cv cF cfv cc wcel vk cW wral wa cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
      cle wbr wi vk cW wral vj cZ wrex wi vx cr wral cc0 vy cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr wi vk cW wral
      vj cZ wrex wi vy cr wral cF cA cli wbr cA cc wcel vk cv cF cfv cc wcel vk
      cW wral wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv cle wbr wi vk cW wral vj cZ wrex wi vx cr wral cc0 vy cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv clt
      wbr wi vk cW wral vj cZ wrex wi vy cr vy cv cr wcel cc0 vy cv clt wbr cA
      cc wcel vk cv cF cfv cc wcel vk cW wral wa cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr wi vk cW wral vj
      cZ wrex wi vx cr wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vy cv clt wbr wi vk cW wral vj cZ wrex vy cv cr wcel cc0 vy cv clt
      wbr cA cc wcel vk cv cF cfv cc wcel vk cW wral wa cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr wi vk cW
      wral vj cZ wrex wi vx cr wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vy cv clt wbr wi vk cW wral vj cZ wrex wi vy cv cr wcel cc0 vy
      cv clt wbr wa cA cc wcel vk cv cF cfv cc wcel vk cW wral wa wa cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle
      wbr wi vk cW wral vj cZ wrex wi vx cr wral cc0 vy cv c2 cdiv co clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle
      wbr wi vk cW wral vj cZ wrex wi vj cv vk cv cle wbr vk cv cF cfv cA cmin
      co cabs cfv vy cv clt wbr wi vk cW wral vj cZ wrex vy cv cr wcel cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle
      wbr wi vk cW wral vj cZ wrex wi vx cr wral cc0 vy cv c2 cdiv co clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle
      wbr wi vk cW wral vj cZ wrex wi wi cc0 vy cv clt wbr cA cc wcel vk cv cF
      cfv cc wcel vk cW wral wa vy cv cr wcel vy cv c2 cdiv co cr wcel cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle
      wbr wi vk cW wral vj cZ wrex wi vx cr wral cc0 vy cv c2 cdiv co clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle
      wbr wi vk cW wral vj cZ wrex wi wi vy cv rehalfcl cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr wi vk cW
      wral vj cZ wrex wi cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle wbr wi vk cW wral vj cZ
      wrex wi vx vy cv c2 cdiv co cr vx cv vy cv c2 cdiv co wceq cc0 vx cv clt
      wbr cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv cle wbr wi vk cW wral vj cZ wrex vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle wbr wi vk cW wral vj
      cZ wrex vx cv vy cv c2 cdiv co cc0 clt breq2 vx cv vy cv c2 cdiv co wceq
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv cle wbr wi vj
      cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle
      wbr wi vj vk cZ cW vx cv vy cv c2 cdiv co wceq vk cv cF cfv cA cmin co
      cabs cfv vx cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co
      cle wbr vj cv vk cv cle wbr vx cv vy cv c2 cdiv co vk cv cF cfv cA cmin
      co cabs cfv cle breq2 imbi2d rexralbidv imbi12d rcla4v syl ad2antrr vy cv
      cr wcel cc0 vy cv clt wbr wa cA cc wcel vk cv cF cfv cc wcel vk cW wral
      wa wa cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv vy cv c2 cdiv co cle wbr wi vk cW wral vj cZ wrex wi cc0
      vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vy cv clt wbr wi vk cW wral vj cZ wrex vy cv cr wcel cc0 vy cv clt
      wbr wa cc0 vy cv c2 cdiv co clt wbr cA cc wcel vk cv cF cfv cc wcel vk cW
      wral wa vy cv cr wcel cc0 vy cv clt wbr cc0 vy cv c2 cdiv co clt wbr vy
      cv halfpos2 biimpa adantr vy cv cr wcel cc0 vy cv clt wbr wa cA cc wcel
      vk cv cF cfv cc wcel vk cW wral wa wa vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv vy cv c2 cdiv co cle wbr wi vk cW wral vj cZ wrex vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr wi vk cW
      wral vj cZ wrex cc0 vy cv c2 cdiv co clt wbr vy cv cr wcel cc0 vy cv clt
      wbr wa cA cc wcel vk cv cF cfv cc wcel vk cW wral wa wa vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle wbr wi vk cW
      wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr
      wi vk cW wral vj cZ vy cv cr wcel cc0 vy cv clt wbr wa cA cc wcel vk cv
      cF cfv cc wcel vk cW wral wa wa vj cv vk cv cle wbr vk cv cF cfv cA cmin
      co cabs cfv vy cv c2 cdiv co cle wbr wi vj cv vk cv cle wbr vk cv cF cfv
      cA cmin co cabs cfv vy cv clt wbr wi vk cW vy cv cr wcel cc0 vy cv clt
      wbr wa cA cc wcel vk cv cF cfv cc wcel vk cW wral wa vk vy cv cr wcel cc0
      vy cv clt wbr wa vk ax-17 cA cc wcel vk cv cF cfv cc wcel vk cW wral vk
      cA cc wcel vk ax-17 vk cv cF cfv cc wcel vk cW hbra1 hban hban vy cv cr
      wcel cc0 vy cv clt wbr wa cA cc wcel vk cv cF cfv cc wcel vk cW wral wa
      vk cv cW wcel vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv
      c2 cdiv co cle wbr wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vy cv clt wbr wi wi vy cv cr wcel cc0 vy cv clt wbr wa cA cc wcel vk
      cv cF cfv cc wcel wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vy cv c2 cdiv co cle wbr wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vy cv clt wbr wi wi cA cc wcel vk cv cF cfv cc wcel vk cW wral
      wa vk cv cW wcel wa vy cv cr wcel cc0 vy cv clt wbr wa cA cc wcel vk cv
      cF cfv cc wcel wa wa vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co
      cle wbr vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr vj cv vk cv cle
      wbr vy cv cr wcel cc0 vy cv clt wbr wa cA cc wcel vk cv cF cfv cc wcel wa
      wa vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle wbr vy cv c2
      cdiv co vy cv clt wbr vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr vy
      cv cr wcel cc0 vy cv clt wbr wa vy cv c2 cdiv co vy cv clt wbr cA cc wcel
      vk cv cF cfv cc wcel wa vy cv cr wcel cc0 vy cv clt wbr vy cv c2 cdiv co
      vy cv clt wbr vy cv halfpos biimpa adantr vy cv cr wcel cc0 vy cv clt wbr
      wa vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cA cmin co cabs
      cfv vy cv c2 cdiv co cle wbr vy cv c2 cdiv co vy cv clt wbr wa vk cv cF
      cfv cA cmin co cabs cfv vy cv clt wbr wi cA cc wcel vk cv cF cfv cc wcel
      wa vk cv cF cfv cA cmin co cabs cfv cr wcel vy cv cr wcel cc0 vy cv clt
      wbr wa vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle wbr vy cv c2
      cdiv co vy cv clt wbr wa vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr
      wi vk cv cF cfv cA cmin co cabs cfv cr wcel vy cv c2 cdiv co cr wcel vy
      cv cr wcel wa vk cv cF cfv cA cmin co cabs cfv vy cv c2 cdiv co cle wbr
      vy cv c2 cdiv co vy cv clt wbr wa vk cv cF cfv cA cmin co cabs cfv vy cv
      clt wbr wi vy cv cr wcel cc0 vy cv clt wbr wa vk cv cF cfv cA cmin co
      cabs cfv cr wcel vy cv c2 cdiv co cr wcel vy cv cr wcel vk cv cF cfv cA
      cmin co cabs cfv vy cv c2 cdiv co cle wbr vy cv c2 cdiv co vy cv clt wbr
      wa vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr wi vk cv cF cfv cA cmin
      co cabs cfv vy cv c2 cdiv co vy cv lelttr 3expb vy cv cr wcel cc0 vy cv
      clt wbr wa vy cv c2 cdiv co cr wcel vy cv cr wcel vy cv cr wcel vy cv c2
      cdiv co cr wcel cc0 vy cv clt wbr vy cv rehalfcl adantr vy cv cr wcel cc0
      vy cv clt wbr pm3.26 jca sylan2 ancoms cA cc wcel vk cv cF cfv cc wcel wa
      vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin co cabs cfv cr wcel
      vk cv cF cfv cc wcel cA cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cF
      cfv cA subcl ancoms vk cv cF cfv cA cmin co abscl syl sylan2 mpan2d
      imim2d cA cc wcel vk cv cF cfv cc wcel vk cW wral vk cv cW wcel cA cc
      wcel vk cv cF cfv cc wcel wa vk cv cF cfv cc wcel vk cW wral vk cv cW
      wcel wa vk cv cF cfv cc wcel cA cc wcel vk cv cF cfv cc wcel vk cW wral
      vk cv cW wcel vk cv cF cfv cc wcel vk cv cF cfv cc wcel vk cW ra4 imp
      anim2i anassrs sylan2 anassrs r19.20da r19.22sdv imim2d mpid syld exp31
      com4t r19.21adv cA cc wcel vk cv cF cfv cc wcel vk cZ cW cin wral cF cA
      cli wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vy cv clt wbr wi vk cW wral vj cZ wrex wi vy cr wral wb vk cv cF
      cfv cc wcel vk cW wral vy cA vj vk cF cM cN cW cZ clm1.1 clm1.2 clm1.3
      clm1.4 clm1.5 clm1.6 clm2.7 clm4i cZ cW cin cW wss vk cv cF cfv cc wcel
      vk cW wral vk cv cF cfv cc wcel vk cZ cW cin wral wi cZ cW inss2 vk cv cF
      cfv cc wcel vk cZ cW cin cW ssralv ax-mp sylan2 sylibrd impbid $.
      $( [20-Jun-2007] $) $( [14-Jan-2007] $)

    $( Express the predicate ` F ` converges to ` A ` . $)
    clm4fi $p |- ( ( A e. CC /\ F : W --> CC ) -> ( F ~~> A <-> A. x e. RR+
      E. j e. Z A. k e. W ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) $=
      cA cc wcel cW cc cF wf wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj cZ
      wrex wi vx cr wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cW wral vj cZ wrex vx crp wral cA cc wcel vk cv cF
      cfv cc wcel vk cZ cW cin wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cW wral vj
      cZ wrex wi vx cr wral wb cW cc cF wf vx cA vj vk cF cM cN cW cZ clm1.1
      clm1.2 clm1.3 clm1.4 clm1.5 clm1.6 clm2.7 clm4i cW cc cF wf vk cv cF cfv
      cc wcel vk cZ cW cin cW cc cF wf vk cv cW wcel vk cv cF cfv cc wcel vk cv
      cZ cW cin wcel cW cc vk cv cF ffvelrn cZ cW cin cW vk cv cZ cW inss2
      sseli sylan2 r19.21aiva sylan2 vj cv vk cv cle wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex vx ralrp syl6bbr $.
      $( [25-Mar-2008] $) $( [24-Feb-2008] $)

    $( Express the predicate ` F ` converges to 0. $)
    clm0i $p |- ( A. k e. W ( F ` k ) e. CC ->
               ( F ~~> 0 <-> A. x e. RR ( 0 < x ->
           E. j e. Z A. k e. W ( j <_ k -> ( abs ` ( F ` k ) ) < x ) ) ) ) $=
      vk cv cF cfv cc wcel vk cW wral cF cc0 cli wbr cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wi vk cW wral
      vj cZ wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex wi vx cr wral cc0 cc
      wcel vk cv cF cfv cc wcel vk cZ cW cin wral cF cc0 cli wbr cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr
      wi vk cW wral vj cZ wrex wi vx cr wral wb vk cv cF cfv cc wcel vk cW wral
      vx cc0 vj vk cF cM cN cW cZ clm1.1 clm1.2 clm1.3 clm1.4 clm1.5 clm1.6
      clm2.7 clm4i 0cn cZ cW cin cW wss vk cv cF cfv cc wcel vk cW wral vk cv
      cF cfv cc wcel vk cZ cW cin wral wi cZ cW inss2 vk cv cF cfv cc wcel vk
      cZ cW cin cW ssralv ax-mp sylancr vk cv cF cfv cc wcel vk cW wral cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc0 cmin co cabs cfv vx cv
      clt wbr wi vk cW wral vj cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex wi vx cr vk
      cv cF cfv cc wcel vk cW wral vj cv vk cv cle wbr vk cv cF cfv cc0 cmin co
      cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex vj cv vk cv cle wbr vk cv
      cF cfv cabs cfv vx cv clt wbr wi vk cW wral vj cZ wrex cc0 vx cv clt wbr
      vk cv cF cfv cc wcel vk cW wral vj cv vk cv cle wbr vk cv cF cfv cc0 cmin
      co cabs cfv vx cv clt wbr wi vk cW wral vj cv vk cv cle wbr vk cv cF cfv
      cabs cfv vx cv clt wbr wi vk cW wral vj cZ vk cv cF cfv cc wcel vk cW
      wral vj cv vk cv cle wbr vk cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr
      wi vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cW vk cv
      cF cfv cc wcel vk cW hbra1 vk cv cF cfv cc wcel vk cW wral vk cv cW wcel
      wa vk cv cF cfv cc wcel vj cv vk cv cle wbr vk cv cF cfv cc0 cmin co cabs
      cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt
      wbr wi wb vk cv cF cfv cc wcel vk cW wral vk cv cW wcel vk cv cF cfv cc
      wcel vk cv cF cfv cc wcel vk cW ra4 imp vk cv cF cfv cc wcel vk cv cF cfv
      cc0 cmin co cabs cfv vx cv clt wbr vk cv cF cfv cabs cfv vx cv clt wbr vj
      cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cc0 cmin co cabs cfv
      vk cv cF cfv cabs cfv vx cv clt vk cv cF cfv cc wcel vk cv cF cfv cc0
      cmin co vk cv cF cfv cabs vk cv cF cfv subid1 fveq2d breq1d imbi2d syl
      ralbida rexbidv imbi2d ralbidv bitrd $.
      $( [15-Jan-2007] $) $( [14-Jan-2007] $)
    $}
  $}

  ${
    $d j k x A $.  $d j k x F $.
    clmnns.1 $e |- F e. _V $.
    clmnns.2 $e |- ( k e. NN -> ( F ` k ) = B ) $.
    $( Express the predicate " ` F ` converges to ` A ` ," using implicit
       substitution. $)
    clmnnsi $p |- ( ( A e. CC /\ A. k e. NN B e. CC ) -> ( F ~~> A <-> A. x e.
       RR+ E. j e. NN A. k e. NN ( j <_ k -> ( abs ` ( B - A ) ) < x ) ) ) $=
      cA cc wcel cB cc wcel vk cn wral wa cF cA cli wbr vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx
      crp wral vj cv vk cv cle wbr cB cA cmin co cabs cfv vx cv clt wbr wi vk
      cn wral vj cn wrex vx crp wral cA cc wcel vk cv cF cfv cc wcel vk cn cn
      cin wral cF cA cli wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral wb cB cc wcel vk
      cn wral cA cc wcel vk cv cF cfv cc wcel vk cn cn cin wral wa cF cA cli
      wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex vx crp wral vx cA vj vk cF c1 c1 cn cn 1z cn c1 cuz cfv nnuz
      eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz clmnns.1 clm4i vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex vx ralrp syl6bbr vk cv cF cfv cc wcel vk cn cn cin wral
      vk cv cF cfv cc wcel vk cn wral cB cc wcel vk cn wral cn cn cin cn wceq
      vk cv cF cfv cc wcel vk cn cn cin wral vk cv cF cfv cc wcel vk cn wral wb
      cn inidm vk cv cF cfv cc wcel vk cn cn cin cn raleq1 ax-mp vk cv cF cfv
      cc wcel cB cc wcel vk cn vk cv cn wcel vk cv cF cfv cB cc clmnns.2 eleq1d
      ralbiia bitr2i sylan2b vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr cB cA cmin
      co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cv vk
      cv cle wbr cB cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk
      cv cle wbr cB cA cmin co cabs cfv vx cv clt wbr wi vk cn vk cv cn wcel vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr cB cA cmin co cabs cfv vx cv
      clt wbr vj cv vk cv cle wbr vk cv cn wcel vk cv cF cfv cA cmin co cabs
      cfv cB cA cmin co cabs cfv vx cv clt vk cv cn wcel vk cv cF cfv cA cmin
      co cB cA cmin co cabs vk cv cn wcel vk cv cF cfv cB cA cmin clmnns.2
      opreq1d fveq2d breq1d imbi2d ralbiia rexbii ralbii syl6bb $.
      $( [8-Mar-2008] $) $( [26-Feb-2008] $)

    ${
      $d j x B $.
      $( Express the predicate " ` F ` converges to 0." $)
      clm0nnsi $p |- ( A. k e. NN B e. CC -> ( F ~~> 0 <-> A. x e. RR+
             E. j e. NN A. k e. NN ( j <_ k -> ( abs ` B ) < x ) ) ) $=
        cB cc wcel vk cn wral cF cc0 cli wbr vj cv vk cv cle wbr cB cc0 cmin co
        cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral vj cv vk cv
        cle wbr cB cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral
        cc0 cc wcel cB cc wcel vk cn wral cF cc0 cli wbr vj cv vk cv cle wbr cB
        cc0 cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral
        wb 0cn vx cc0 cB vj vk cF clmnns.1 clmnns.2 clmnnsi mpan cB cc wcel vk
        cn wral vj cv vk cv cle wbr cB cc0 cmin co cabs cfv vx cv clt wbr wi vk
        cn wral vj cn wrex vj cv vk cv cle wbr cB cabs cfv vx cv clt wbr wi vk
        cn wral vj cn wrex vx crp cB cc wcel vk cn wral vj cv vk cv cle wbr cB
        cc0 cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr cB
        cabs cfv vx cv clt wbr wi vk cn wral vj cn cB cc wcel vk cn wral vj cv
        vk cv cle wbr cB cc0 cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle
        wbr cB cabs cfv vx cv clt wbr wi vk cn cB cc wcel vk cn hbra1 cB cc
        wcel vk cn wral vk cv cn wcel wa cB cc0 cmin co cabs cfv vx cv clt wbr
        cB cabs cfv vx cv clt wbr vj cv vk cv cle wbr cB cc wcel vk cn wral vk
        cv cn wcel wa cB cc0 cmin co cabs cfv cB cabs cfv vx cv clt cB cc wcel
        vk cn wral vk cv cn wcel wa cB cc0 cmin co cB cabs cB cc wcel vk cn
        wral vk cv cn wcel wa cB cc wcel cB cc0 cmin co cB wceq cB cc wcel vk
        cn wral vk cv cn wcel cB cc wcel cB cc wcel vk cn ra4 imp cB subid1 syl
        fveq2d breq1d imbi2d ralbida rexbidv ralbidv bitrd $.
        $( [16-Mar-2008] $) $( [27-Feb-2008] $)
    $}
  $}

  ${
    $d j k y A $.  $d j k y B $.  $d j k y F $.  $d j k y M $.  $d k W $.
    $d j Z $.
    clmi1.1 $e |- M e. ZZ $.
    clmi1.2 $e |- ( ZZ>= ` M ) C_ Z $.
    clmi1.6 $e |- W C_ ZZ $.
    $( Convergence of a sequence of complex numbers. $)
    clmi1i $p |- ( ( ( A e. C /\ F ~~> A ) /\ ( B e. RR /\ 0 < B ) ) ->
                 E. j e. Z A. k e. W ( j <_ k ->
             ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - A ) ) < B ) ) ) $=
      cA cC wcel cF cA cli wbr wa cB cr wcel cc0 cB clt wbr wa wa vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr
      wa wi vk cz wral vj cM cuz cfv wrex vj cv vk cv cle wbr vk cv cF cfv cc
      wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cW wral vj cZ
      wrex cA cC wcel cF cA cli wbr cB cr wcel cc0 cB clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa
      wi vk cz wral vj cM cuz cfv wrex cF cvv wcel cA cC wcel cF cA cli wbr cB
      cr wcel cc0 cB clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF
      cfv cA cmin co cabs cfv cB clt wbr wa wi vk cz wral vj cM cuz cfv wrex wi
      wi wi wi cF cvv wcel cA cC wcel cF cA cli wbr cB cr wcel cc0 cB clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv
      cB clt wbr wa wi vk cz wral vj cM cuz cfv wrex wi wi cB cr wcel cc0 vy cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co
      cabs cfv vy cv clt wbr wa wi vk cz wral vj cM cuz cfv wrex wi vy cr wral
      cc0 cB clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA
      cmin co cabs cfv cB clt wbr wa wi vk cz wral vj cM cuz cfv wrex wi cF cvv
      wcel cA cC wcel wa cF cA cli wbr wa cc0 vy cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr wa wi
      vk cz wral vj cM cuz cfv wrex wi cc0 cB clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cz
      wral vj cM cuz cfv wrex wi vy cB cr vy cv cB wceq cc0 vy cv clt wbr cc0
      cB clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin
      co cabs cfv vy cv clt wbr wa wi vk cz wral vj cM cuz cfv wrex vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr
      wa wi vk cz wral vj cM cuz cfv wrex vy cv cB cc0 clt breq2 vy cv cB wceq
      vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv
      vy cv clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv
      cA cmin co cabs cfv cB clt wbr wa wi vj vk cM cuz cfv cz vy cv cB wceq vk
      cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr wa vk cv
      cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa vj cv vk cv
      cle wbr vy cv cB wceq vk cv cF cfv cA cmin co cabs cfv vy cv clt wbr vk
      cv cF cfv cA cmin co cabs cfv cB clt wbr vk cv cF cfv cc wcel vy cv cB vk
      cv cF cfv cA cmin co cabs cfv clt breq2 anbi2d imbi2d rexralbidv imbi12d
      rcla4v cF cvv wcel cA cC wcel wa cF cA cli wbr cA cc wcel cc0 vy cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs
      cfv vy cv clt wbr wa wi vk cz wral vj cM cuz cfv wrex wi vy cr wral vy cA
      cvv cC vj vk cF cM cc0 cz cM cuz cfv clmi1.1 cM cuz cfv ssid cM uzssz 0z
      cc0 uzssz cz ssid clm1i pm3.27bda syl5com exp31 cF cvv wcel wn cF cA cli
      wbr cB cr wcel cc0 cB clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk
      cv cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cz wral vj cM cuz cfv
      wrex wi wi wi cA cC wcel cF cvv wcel wn cF cA cli wbr cB cr wcel cc0 cB
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co
      cabs cfv cB clt wbr wa wi vk cz wral vj cM cuz cfv wrex wi wi cF cA cli
      wbr cF cvv wcel cF cA cli climrel brrelexi con3i pm2.21d a1d pm2.61i
      imp43 vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co
      cabs cfv cB clt wbr wa wi vk cz wral vj cM cuz cfv wrex vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa
      wi vk cz wral vj cZ wrex vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv
      cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cW wral vj cZ wrex cM cuz
      cfv cZ wss vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin
      co cabs cfv cB clt wbr wa wi vk cz wral vj cM cuz cfv wrex vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr
      wa wi vk cz wral vj cZ wrex wi clmi1.2 vj cv vk cv cle wbr vk cv cF cfv
      cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cz wral vj
      cM cuz cfv cZ ssrexv ax-mp vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv
      cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cz wral vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa
      wi vk cW wral vj cZ cW cz wss vj cv vk cv cle wbr vk cv cF cfv cc wcel vk
      cv cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cz wral vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa
      wi vk cW wral wi clmi1.6 vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv
      cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cW cz ssralv ax-mp
      r19.22si syl syl $.
      $( [16-Jan-2007] $) $( [11-Jan-2007] $)

    $( Convergence of a sequence of complex numbers. $)
    clmi2i $p |- ( ( ( A e. C /\ F ~~> A ) /\ ( B e. RR /\ 0 < B ) ) ->
       E. j e. Z A. k e. W ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < B ) ) $=
      cA cC wcel cF cA cli wbr wa cB cr wcel cc0 cB clt wbr wa wa vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr
      wa wi vk cW wral vj cZ wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv cB clt wbr wi vk cW wral vj cZ wrex cA cB cC vj vk cF cM cW cZ
      clmi1.1 clmi1.2 clmi1.6 clmi1i vj cv vk cv cle wbr vk cv cF cfv cc wcel
      vk cv cF cfv cA cmin co cabs cfv cB clt wbr wa wi vk cW wral vj cv vk cv
      cle wbr vk cv cF cfv cA cmin co cabs cfv cB clt wbr wi vk cW wral vj cZ
      vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv
      cB clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv cB
      clt wbr wi vk cW vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB
      clt wbr wa vk cv cF cfv cA cmin co cabs cfv cB clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cB clt wbr
      pm3.27 imim2i r19.20si r19.22si syl $.
      $( [17-Jan-2007] $) $( [11-Jan-2007] $)

    $( Convergence of a sequence of complex numbers, using positive reals. $)
    clmi2rpi $p |- ( ( A e. C /\ F ~~> A /\ B e. RR+ ) ->
       E. j e. Z A. k e. W ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < B ) ) $=
      cA cC wcel cF cA cli wbr cB crp wcel vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv cB clt wbr wi vk cW wral vj cZ wrex cA cC wcel cF cA cli
      wbr wa cB cr wcel cc0 cB clt wbr wa vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv cB clt wbr wi vk cW wral vj cZ wrex cB crp wcel cA cB cC
      vj vk cF cM cW cZ clmi1.1 clmi1.2 clmi1.6 clmi2i cB elrp sylan2b 3impa $.
      $( [4-Mar-2008] $) $( [21-Feb-2008] $)

    $( Convergence of a sequence of complex numbers to zero. $)
    clm0ii $p |- ( ( F ~~> 0 /\ A e. RR /\ 0 < A ) -> E. j e. Z
        A. k e. W ( j <_ k -> ( abs ` ( F ` k ) ) < A ) ) $=
      cF cc0 cli wbr cA cr wcel cc0 cA clt wbr w3a vj cv vk cv cle wbr vk cv cF
      cfv cc wcel vk cv cF cfv cc0 cmin co cabs cfv cA clt wbr wa wi vk cW wral
      vj cZ wrex vj cv vk cv cle wbr vk cv cF cfv cabs cfv cA clt wbr wi vk cW
      wral vj cZ wrex cF cc0 cli wbr cA cr wcel cc0 cA clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cc wcel vk cv cF cfv cc0 cmin co cabs cfv cA clt wbr wa
      wi vk cW wral vj cZ wrex cc0 cc wcel cF cc0 cli wbr cA cr wcel cc0 cA clt
      wbr wa vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cc0 cmin co
      cabs cfv cA clt wbr wa wi vk cW wral vj cZ wrex 0cn cc0 cA cc vj vk cF cM
      cW cZ clmi1.1 clmi1.2 clmi1.6 clmi1i mpanl1 3impb vj cv vk cv cle wbr vk
      cv cF cfv cc wcel vk cv cF cfv cc0 cmin co cabs cfv cA clt wbr wa wi vk
      cW wral vj cv vk cv cle wbr vk cv cF cfv cabs cfv cA clt wbr wi vk cW
      wral vj cZ vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cc0 cmin
      co cabs cfv cA clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cabs cfv cA
      clt wbr wi vk cW vk cv cF cfv cc wcel vk cv cF cfv cc0 cmin co cabs cfv
      cA clt wbr wa vk cv cF cfv cabs cfv cA clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cc wcel vk cv cF cfv cc0 cmin co cabs cfv cA clt wbr vk cv cF cfv
      cabs cfv cA clt wbr vk cv cF cfv cc wcel vk cv cF cfv cc0 cmin co cabs
      cfv vk cv cF cfv cabs cfv cA clt vk cv cF cfv cc wcel vk cv cF cfv cc0
      cmin co vk cv cF cfv cabs vk cv cF cfv subid1 fveq2d breq1d biimpa imim2i
      r19.20si r19.22si syl $.
      $( [18-Jan-2007] $) $( [11-Jan-2007] $)
  $}

  ${
    $d j k x A $.  $d j k x F $.  $d j k x M $.
    clm4at.1 $e |- F e. _V $.
    $( Express the predicate ` F ` converges to ` A ` , requiring convergence
       in the upper integers starting at ` M ` . $)
    clm4a $p |- ( ( M e. ZZ /\
           A e. CC /\ A. k e. ( ZZ>= ` M ) ( F ` k ) e. CC )
   -> ( F ~~> A <-> A. x e. RR ( 0 < x -> E. j e. ZZ A. k e. ( ZZ>= ` M )
         ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) $=
      cM cz wcel cA cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cF cA cli
      wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb cM cz
      wcel cA cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa cF cA cli wbr
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb wi cA cc
      wcel vk cv cF cfv cc wcel vk cM cz wcel cM cc0 cif cuz cfv wral wa cF cA
      cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cM cz wcel cM cc0 cif cuz cfv wral vj cz
      wrex wi vx cr wral wb wi cM cc0 cM cM cz wcel cM cc0 cif wceq cA cc wcel
      vk cv cF cfv cc wcel vk cM cuz cfv wral wa cA cc wcel vk cv cF cfv cc
      wcel vk cM cz wcel cM cc0 cif cuz cfv wral wa cF cA cli wbr cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi
      vk cM cuz cfv wral vj cz wrex wi vx cr wral wb cF cA cli wbr cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cM cz wcel cM cc0 cif cuz cfv wral vj cz wrex wi vx cr wral wb
      cM cM cz wcel cM cc0 cif wceq vk cv cF cfv cc wcel vk cM cuz cfv wral vk
      cv cF cfv cc wcel vk cM cz wcel cM cc0 cif cuz cfv wral cA cc wcel cM cM
      cz wcel cM cc0 cif wceq vk cv cF cfv cc wcel vk cM cuz cfv cM cz wcel cM
      cc0 cif cuz cfv cM cM cz wcel cM cc0 cif cuz fveq2 raleq1d anbi2d cM cM
      cz wcel cM cc0 cif wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi
      vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cM cz wcel cM cc0 cif cuz cfv wral vj cz
      wrex wi vx cr wral cF cA cli wbr cM cM cz wcel cM cc0 cif wceq cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cM cuz cfv wral vj cz wrex wi cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cz wcel cM
      cc0 cif cuz cfv wral vj cz wrex wi vx cr cM cM cz wcel cM cc0 cif wceq vj
      cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM
      cuz cfv wral vj cz wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cM cz wcel cM cc0 cif cuz cfv wral vj cz wrex cc0
      vx cv clt wbr cM cM cz wcel cM cc0 cif wceq vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv
      cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cz wcel
      cM cc0 cif cuz cfv wral vj cz cM cM cz wcel cM cc0 cif wceq vj cv vk cv
      cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv
      cM cz wcel cM cc0 cif cuz cfv cM cM cz wcel cM cc0 cif cuz fveq2 raleq1d
      rexbidv imbi2d ralbidv bibi2d imbi12d cA cc wcel vk cv cF cfv cc wcel vk
      cz cM cz wcel cM cc0 cif cuz cfv cin wral cF cA cli wbr cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk
      cM cz wcel cM cc0 cif cuz cfv wral vj cz wrex wi vx cr wral wb vk cv cF
      cfv cc wcel vk cM cz wcel cM cc0 cif cuz cfv wral vx cA vj vk cF cc0 cM
      cz wcel cM cc0 cif cM cz wcel cM cc0 cif cuz cfv cz 0z cc0 uzssz cz ssid
      cM cc0 cz 0z elimel cM cz wcel cM cc0 cif cuz cfv ssid cM cz wcel cM cc0
      cif uzssz clm4at.1 clm4i cz cM cz wcel cM cc0 cif cuz cfv cin cM cz wcel
      cM cc0 cif cuz cfv wss vk cv cF cfv cc wcel vk cM cz wcel cM cc0 cif cuz
      cfv wral vk cv cF cfv cc wcel vk cz cM cz wcel cM cc0 cif cuz cfv cin
      wral wi cz cM cz wcel cM cc0 cif cuz cfv inss2 vk cv cF cfv cc wcel vk cz
      cM cz wcel cM cc0 cif cuz cfv cin cM cz wcel cM cc0 cif cuz cfv ssralv
      ax-mp sylan2 dedth 3impib $.
      $( [20-Jan-2007] $) $( [10-Sep-2005] $)
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k F $.  $d j k M $.
    $( Convergence of a sequence of complex numbers in the upper integers
       starting at ` M ` . $)
    clmi2a $p |- ( ( M e. ZZ /\ ( ( A e. C /\ F ~~> A ) /\
            ( B e. RR /\ 0 < B ) ) ) -> E. j e. ( ZZ>= ` M )
            A. k e. ZZ ( j <_ k -> ( abs ` ( ( F ` k ) - A ) ) < B ) ) $=
      cM cz wcel cA cC wcel cF cA cli wbr wa cB cr wcel cc0 cB clt wbr wa wa vj
      cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv cB clt wbr wi vk cz
      wral vj cM cuz cfv wrex cM cz wcel cA cC wcel cF cA cli wbr wa cB cr wcel
      cc0 cB clt wbr wa wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      cB clt wbr wi vk cz wral vj cM cuz cfv wrex wi cA cC wcel cF cA cli wbr
      wa cB cr wcel cc0 cB clt wbr wa wa vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv cB clt wbr wi vk cz wral vj cM cz wcel cM cc0 cif cuz
      cfv wrex wi cM cc0 cM cM cz wcel cM cc0 cif wceq vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv cB clt wbr wi vk cz wral vj cM cuz cfv wrex
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv cB clt wbr wi vk cz
      wral vj cM cz wcel cM cc0 cif cuz cfv wrex cA cC wcel cF cA cli wbr wa cB
      cr wcel cc0 cB clt wbr wa wa cM cM cz wcel cM cc0 cif wceq vj cv vk cv
      cle wbr vk cv cF cfv cA cmin co cabs cfv cB clt wbr wi vk cz wral vj cM
      cuz cfv cM cz wcel cM cc0 cif cuz cfv cM cM cz wcel cM cc0 cif cuz fveq2
      rexeq1d imbi2d cA cB cC vj vk cF cM cz wcel cM cc0 cif cz cM cz wcel cM
      cc0 cif cuz cfv cM cc0 cz 0z elimel cM cz wcel cM cc0 cif cuz cfv ssid cz
      ssid clmi2i dedth imp $.
      $( [21-Jan-2007] $) $( [10-Sep-2005] $)
  $}

  ${
    $d f j k x A $.  $d f j k x F $.
    $( Express the predicate ` F ` converges to ` A ` for an explicit function,
       using natural numbers. $)
    climfnn $p |- ( ( F : NN --> CC /\ A e. CC ) -> ( F ~~> A <->
              A. x e. RR ( 0 < x -> E. j e. NN A. k e. NN ( j <_ k ->
                   ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) ) $=
      cF cvv wcel cn cc cF wf cA cc wcel wa cF cA cli wbr cc0 vx cv clt wbr vj
      cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex wi vx cr wral wb cn cc cF wf cF cvv wcel cA cc wcel cn cc
      cF wf cn cvv wcel cF cvv wcel nnex cn cc cvv cF fex mpan2 adantr cn cc vf
      cv wf cA cc wcel wa vf cv cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv vf cv cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex wi vx cr wral wb wi cn cc cF wf cA cc wcel wa cF cA cli wbr cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr wral wb wi vf cF cvv vf cv cF wceq
      cn cc vf cv wf cA cc wcel wa cn cc cF wf cA cc wcel wa vf cv cA cli wbr
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wb cF cA cli wbr cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr wral wb vf cv cF wceq cn cc vf
      cv wf cn cc cF wf cA cc wcel cn cc vf cv cF feq1 anbi1d vf cv cF wceq vf
      cv cA cli wbr cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      vf cv cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi
      vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral vf cv cF cA
      cli breq1 vf cv cF wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr vf cv cF wceq vj cv vk cv cle wbr
      vk cv vf cv cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wi vk cn wral vj cn wrex cc0 vx cv clt wbr vf cv cF wceq vj cv vk cv cle
      wbr vk cv vf cv cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj vk cn cn vf cv
      cF wceq vk cv vf cv cfv cA cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr vj cv vk cv cle wbr vf cv cF wceq vk cv vf
      cv cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv vx cv clt vf
      cv cF wceq vk cv vf cv cfv cA cmin co vk cv cF cfv cA cmin co cabs vf cv
      cF wceq vk cv vf cv cfv vk cv cF cfv cA cmin vk cv vf cv cF fveq1 opreq1d
      fveq2d breq1d imbi2d rexralbidv imbi2d ralbidv bibi12d imbi12d cA cc wcel
      cn cc vf cv wf vf cv cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv vf cv cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex
      wi vx cr wral wb cA cc wcel vk cv vf cv cfv cc wcel vk cn wral vf cv cA
      cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wb cn cc vf
      cv wf cA cc wcel vk cv vf cv cfv cc wcel vk cn cn cin wral vf cv cA cli
      wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wb vk cv vf cv
      cfv cc wcel vk cn wral vx cA vj vk vf cv c1 c1 cn cn 1z cn c1 cuz cfv
      nnuz eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz vf visset clm4i
      cn cn cin cn wss vk cv vf cv cfv cc wcel vk cn wral vk cv vf cv cfv cc
      wcel vk cn cn cin wral wi cn cn inss2 vk cv vf cv cfv cc wcel vk cn cn
      cin cn ssralv ax-mp sylan2 cn cc vf cv wf vk cv vf cv cfv cc wcel vk cn
      cn cc vk cv vf cv ffvelrn r19.21aiva sylan2 ancoms vtoclg mpcom $.
      $( [9-Jan-2006] $) $( [1-Jan-2006] $)

    $( Express the predicate ` F ` converges to ` A ` for an explicit function,
       using natural numbers. $)
    clmfnn $p |- ( ( F : NN --> CC /\ A e. CC ) -> ( F ~~> A <->
              A. x e. RR+ E. j e. NN A. k e. NN ( j <_ k ->
                   ( abs ` ( ( F ` k ) - A ) ) < x ) ) ) $=
      cn cc cF wf cA cc wcel wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex wi vx cr wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral vx cA vj vk cF climfnn
      vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk
      cn wral vj cn wrex vx ralrp syl6bbr $.
      $( [11-Jul-2008] $) $( [11-Jul-2008] $)
  $}

  ${
    $d j k x A $.  $d j k x F $.  $d j k x M $.
    climconsti.1 $e |- F e. _V $.
    climconsti.2 $e |- M e. ZZ $.
    $( MAY BE REVISED? $)
    $( An (eventually) constant sequence converges to its value. $)
    climconsti $p |- ( ( A e. CC /\
                  A. k e. ( ZZ>= ` M ) ( F ` k ) = A ) -> F ~~> A ) $=
      cA cc wcel vk cv cF cfv cA wceq vk cM cuz cfv wral wa cF cA cli wbr cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral cA cc wcel vk cv
      cF cfv cA wceq vk cM cuz cfv wral cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj
      cz wrex wi vx cr wral cA cc wcel vk cv cF cfv cA wceq vk cM cuz cfv wral
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr cA cc wcel vk cv cF
      cfv cA wceq vk cM cuz cfv wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz
      wrex wi vx cv cr wcel cA cc wcel vk cv cF cfv cA wceq vk cM cuz cfv wral
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wi vk cM cuz cfv wral vj cz wrex cM cz wcel cM vk cv cle wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj
      cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM
      cuz cfv wral vj cz wrex cA cc wcel vk cv cF cfv cA wceq vk cM cuz cfv
      wral wa cc0 vx cv clt wbr wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cM cuz cfv wral cM vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cM cz vj
      cv cM wceq vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi cM vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi
      vk cM cuz cfv vj cv cM wceq vj cv vk cv cle wbr cM vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr vj cv cM vk cv cle breq1 imbi1d
      ralbidv rcla4ev climconsti.2 cA cc wcel cc0 vx cv clt wbr vk cv cF cfv cA
      wceq vk cM cuz cfv wral cM vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cM cuz cfv wral cA cc wcel cc0 vx cv clt wbr wa vk cv
      cF cfv cA wceq vk cM cuz cfv wral cM vk cv cle wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral cA cc wcel cc0 vx cv clt
      wbr wa vk cv cF cfv cA wceq cM vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cM cuz cfv cA cc wcel cc0 vx cv clt wbr wa vk cv
      cF cfv cA wceq vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr cM vk cv
      cle wbr cA cc wcel cc0 vx cv clt wbr wa vk cv cF cfv cA wceq vk cv cF cfv
      cA cmin co cabs cfv vx cv clt wbr cA cc wcel vk cv cF cfv cA wceq cc0 vx
      cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr cA cc wcel vk
      cv cF cfv cA wceq wa vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr cc0
      vx cv clt wbr cA cc wcel vk cv cF cfv cA wceq wa vk cv cF cfv cA cmin co
      cabs cfv cc0 vx cv clt cA cc wcel vk cv cF cfv cA wceq wa vk cv cF cfv cA
      cmin co cabs cfv cc0 cabs cfv cc0 cA cc wcel vk cv cF cfv cA wceq wa vk
      cv cF cfv cA cmin co cc0 cabs vk cv cF cfv cA wceq cA cc wcel vk cv cF
      cfv cA cmin co cA cA cmin co cc0 vk cv cF cfv cA cA cmin opreq1 cA subid
      sylan9eqr fveq2d abs0 syl6eq breq1d biimpar an1rs ex a1dd r19.20sdv imp
      an1rs sylancr exp31 a1dd r19.21adv imp cA cc wcel vk cv cF cfv cA wceq vk
      cM cuz cfv wral vk cv cF cfv cc wcel vk cz cM cuz cfv cin wral cF cA cli
      wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb cA cc
      wcel vk cv cF cfv cA wceq vk cM cuz cfv wral vk cv cF cfv cc wcel vk cz
      cM cuz cfv cin wral cA cc wcel vk cv cF cfv cA wceq vk cv cF cfv cc wcel
      vk cM cuz cfv cz cM cuz cfv cin cA cc wcel vk cv cz cM cuz cfv cin wcel
      vk cv cM cuz cfv wcel vk cv cF cfv cA wceq vk cv cF cfv cc wcel vk cv cz
      cM cuz cfv cin wcel vk cv cM cuz cfv wcel wi cA cc wcel cz cM cuz cfv cin
      cM cuz cfv vk cv cz cM cuz cfv inss2 sseli a1i cA cc vk cv cF cfv eleq1a
      imim12d r19.20dv2 imp vx cA vj vk cF cM cM cM cuz cfv cz climconsti.2 cM
      uzssz cz ssid climconsti.2 cM cuz cfv ssid cM uzssz climconsti.1 clm4i
      syldan mpbird $.
      $( [17-Jan-2007] $) $( [28-Aug-2005] $)
  $}

  ${
    $d k A $.
    $( A constant sequence on the integers converges to its value. $)
    climconst2 $p |- ( A e. CC -> ( ZZ X. { A } ) ~~> A ) $=
      cA cc wcel cc0 vk cv cle wbr vk cv cz cA csn cxp cfv cA wceq wi vk cz
      wral cz cA csn cxp cA cli wbr cA cc wcel cc0 vk cv cle wbr vk cv cz cA
      csn cxp cfv cA wceq wi vk cz cA cc wcel vk cv cz wcel vk cv cz cA csn cxp
      cfv cA wceq cc0 vk cv cle wbr cA cc wcel vk cv cz wcel vk cv cz cA csn
      cxp cfv cA wceq cz cA vk cv cc fvconst2g ex a1dd r19.21aiv cA cc wcel vk
      cv cz cA csn cxp cfv cA wceq vk cc0 cuz cfv wral cz cA csn cxp cA cli wbr
      cc0 vk cv cle wbr vk cv cz cA csn cxp cfv cA wceq wi vk cz wral cA vk cz
      cA csn cxp cc0 cz cA csn zex cA snex xpex 0z climconsti cc0 cz wcel vk cv
      cz cA csn cxp cfv cA wceq vk cc0 cuz cfv wral cc0 vk cv cle wbr vk cv cz
      cA csn cxp cfv cA wceq wi vk cz wral wb 0z vk cv cz cA csn cxp cfv cA
      wceq vk cc0 raluz ax-mp sylan2br mpdan $.
      $( [27-Sep-2005] $) $( [28-Aug-2005] $)
  $}

  ${
    $d k A $.  $d k M $.
    $( MAY BE REVISED - do we need this? $)
    $( A constant sequence converges to its value. $)
    climconst3 $p |- ( ( A e. CC /\ M e. ZZ ) ->
             ( ( ZZ>= ` M ) X. { A } ) ~~> A ) $=
      cA cc wcel cM cz wcel wa vk cv cM cuz cfv cA csn cxp cfv cA wceq vk cM
      cuz cfv wral cM cuz cfv cA csn cxp cA cli wbr cA cc wcel vk cv cM cuz cfv
      cA csn cxp cfv cA wceq vk cM cuz cfv wral cM cz wcel cA cc wcel vk cv cM
      cuz cfv cA csn cxp cfv cA wceq vk cM cuz cfv cM cuz cfv cA vk cv cc
      fvconst2g r19.21aiva adantr cM cz wcel cA cc wcel vk cv cM cuz cfv cA csn
      cxp cfv cA wceq vk cM cuz cfv wral cM cuz cfv cA csn cxp cA cli wbr wi cM
      cz wcel cA cc wcel vk cv cM cuz cfv cA csn cxp cfv cA wceq vk cM cuz cfv
      wral cM cuz cfv cA csn cxp cA cli wbr cM cz wcel cA cc wcel vk cv cM cuz
      cfv cA csn cxp cfv cA wceq vk cM cuz cfv wral wa cM cuz cfv cA csn cxp cA
      cli wbr wi cA cc wcel vk cv cM cz wcel cM cc0 cif cuz cfv cA csn cxp cfv
      cA wceq vk cM cz wcel cM cc0 cif cuz cfv wral wa cM cz wcel cM cc0 cif
      cuz cfv cA csn cxp cA cli wbr wi cM cc0 cM cM cz wcel cM cc0 cif wceq cA
      cc wcel vk cv cM cuz cfv cA csn cxp cfv cA wceq vk cM cuz cfv wral wa cA
      cc wcel vk cv cM cz wcel cM cc0 cif cuz cfv cA csn cxp cfv cA wceq vk cM
      cz wcel cM cc0 cif cuz cfv wral wa cM cuz cfv cA csn cxp cA cli wbr cM cz
      wcel cM cc0 cif cuz cfv cA csn cxp cA cli wbr cM cM cz wcel cM cc0 cif
      wceq vk cv cM cuz cfv cA csn cxp cfv cA wceq vk cM cuz cfv wral vk cv cM
      cz wcel cM cc0 cif cuz cfv cA csn cxp cfv cA wceq vk cM cz wcel cM cc0
      cif cuz cfv wral cA cc wcel cM cM cz wcel cM cc0 cif wceq vk cv cM cuz
      cfv cA csn cxp cfv cA wceq vk cv cM cz wcel cM cc0 cif cuz cfv cA csn cxp
      cfv cA wceq vk cM cuz cfv cM cz wcel cM cc0 cif cuz cfv cM cM cz wcel cM
      cc0 cif cuz fveq2 cM cM cz wcel cM cc0 cif wceq vk cv cM cuz cfv cA csn
      cxp cfv vk cv cM cz wcel cM cc0 cif cuz cfv cA csn cxp cfv cA cM cM cz
      wcel cM cc0 cif wceq vk cv cM cuz cfv cA csn cxp cM cz wcel cM cc0 cif
      cuz cfv cA csn cxp cM cM cz wcel cM cc0 cif wceq cM cuz cfv cM cz wcel cM
      cc0 cif cuz cfv wceq cM cuz cfv cA csn cxp cM cz wcel cM cc0 cif cuz cfv
      cA csn cxp wceq cM cM cz wcel cM cc0 cif cuz fveq2 cM cuz cfv cM cz wcel
      cM cc0 cif cuz cfv cA csn xpeq1 syl fveq1d eqeq1d raleq12d anbi2d cM cM
      cz wcel cM cc0 cif wceq cM cuz cfv cA csn cxp cM cz wcel cM cc0 cif cuz
      cfv cA csn cxp cA cli cM cM cz wcel cM cc0 cif wceq cM cuz cfv cM cz wcel
      cM cc0 cif cuz cfv wceq cM cuz cfv cA csn cxp cM cz wcel cM cc0 cif cuz
      cfv cA csn cxp wceq cM cM cz wcel cM cc0 cif cuz fveq2 cM cuz cfv cM cz
      wcel cM cc0 cif cuz cfv cA csn xpeq1 syl breq1d imbi12d cA vk cM cz wcel
      cM cc0 cif cuz cfv cA csn cxp cM cz wcel cM cc0 cif cM cz wcel cM cc0 cif
      cuz cfv cA csn cM cz wcel cM cc0 cif cuz fvex cA snex xpex cM cc0 cz 0z
      elimel climconsti dedth exp3a impcom mpd $.
      $( [6-Feb-2008] $) $( [6-Feb-2008] $)
  $}

  $( The zero sequence converges to zero. $)
  clim0 $p |- ( ZZ X. { 0 } ) ~~> 0 $=
    cc0 cc wcel cz cc0 csn cxp cc0 cli wbr 0cn cc0 climconst2 ax-mp $.
    $( [29-Sep-2005] $) $( [2-Oct-1999] $)

  ${
    $d j k m A $.  $d j k m B $.  $d j k m F $.
    climuni.1 $e |- A e. _V $.
    climuni.2 $e |- B e. _V $.
    ${
      climunii.3 $e |- ( F ~~> A /\ F ~~> B ) $.
      $( An infinite sequence of complex numbers converges to at most one
         limit. $)
      climunii $p |- A = B $=
        cA cB cmin co cc0 wceq cA cB wceq cc0 cA cB cmin co cabs cfv clt wbr wn
        cA cB cmin co cc0 wceq cc0 cA cB cmin co cabs cfv clt wbr vk cv vj cv
        cle wbr vm cv vj cv cle wbr wa vj cz wrex vm cz wral vk cz wral vk cv
        vj cv cle wbr vm cv vj cv cle wbr wa vj cz wrex vk vm cz vj vk cv vm cv
        z2ge rgen2a cc0 cA cB cmin co cabs cfv clt wbr cc0 cA cB cmin co cabs
        cfv c2 cdiv co clt wbr vk cv vj cv cle wbr vj cv cF cfv cc wcel vj cv
        cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa
        wi vj cz wral vk cz wrex vm cv vj cv cle wbr vj cv cF cfv cc wcel vj cv
        cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa
        wi vj cz wral vm cz wrex wa vk cv vj cv cle wbr vm cv vj cv cle wbr wa
        vj cz wrex vm cz wral vk cz wral wn cA cB cmin co cabs cfv c2 cA cB
        cmin co cA cB cA cvv wcel cF cA cli wbr cA cc wcel climuni.1 cF cA cli
        wbr cF cB cli wbr climunii.3 pm3.26i cA cvv cF climcl mp2an cB cvv wcel
        cF cB cli wbr cB cc wcel climuni.2 cF cA cli wbr cF cB cli wbr
        climunii.3 pm3.27i cB cvv cF climcl mp2an subcli abscli 2re 2pos
        divgt0i2i cc0 cA cB cmin co cabs cfv c2 cdiv co clt wbr vk cv vj cv cle
        wbr vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vk cz wrex vm cv vj cv cle
        wbr vj cv cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vm cz wrex cA cB cmin co
        cabs cfv c2 cdiv co cr wcel cc0 cA cB cmin co cabs cfv c2 cdiv co clt
        wbr vk cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cA cmin co
        cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vk
        cz wrex cA cB cmin co cabs cfv c2 cA cB cmin co cA cB cA cvv wcel cF cA
        cli wbr cA cc wcel climuni.1 cF cA cli wbr cF cB cli wbr climunii.3
        pm3.26i cA cvv cF climcl mp2an cB cvv wcel cF cB cli wbr cB cc wcel
        climuni.2 cF cA cli wbr cF cB cli wbr climunii.3 pm3.27i cB cvv cF
        climcl mp2an subcli abscli 2re 2ne0 redivcli cA cvv wcel cF cA cli wbr
        cA cB cmin co cabs cfv c2 cdiv co cr wcel cc0 cA cB cmin co cabs cfv c2
        cdiv co clt wbr wa vk cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF
        cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi
        vj cz wral vk cz wrex climuni.1 cF cA cli wbr cF cB cli wbr climunii.3
        pm3.26i cA cA cB cmin co cabs cfv c2 cdiv co cvv vk vj cF cc0 cz cz 0z
        cc0 uzssz cz ssid clmi1i mpanl12 mpan cA cB cmin co cabs cfv c2 cdiv co
        cr wcel cc0 cA cB cmin co cabs cfv c2 cdiv co clt wbr vm cv vj cv cle
        wbr vj cv cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vm cz wrex cA cB cmin co
        cabs cfv c2 cA cB cmin co cA cB cA cvv wcel cF cA cli wbr cA cc wcel
        climuni.1 cF cA cli wbr cF cB cli wbr climunii.3 pm3.26i cA cvv cF
        climcl mp2an cB cvv wcel cF cB cli wbr cB cc wcel climuni.2 cF cA cli
        wbr cF cB cli wbr climunii.3 pm3.27i cB cvv cF climcl mp2an subcli
        abscli 2re 2ne0 redivcli cB cvv wcel cF cB cli wbr cA cB cmin co cabs
        cfv c2 cdiv co cr wcel cc0 cA cB cmin co cabs cfv c2 cdiv co clt wbr wa
        vm cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cB cmin co cabs
        cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vm cz
        wrex climuni.2 cF cA cli wbr cF cB cli wbr climunii.3 pm3.27i cB cA cB
        cmin co cabs cfv c2 cdiv co cvv vm vj cF cc0 cz cz 0z cc0 uzssz cz ssid
        clmi1i mpanl12 mpan jca vk cv vj cv cle wbr vj cv cF cfv cc wcel vj cv
        cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa
        wi vj cz wral vm cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cB
        cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi vj cz
        wral wa vm cz wrex vk cz wrex vk cv vj cv cle wbr vm cv vj cv cle wbr
        wa wn vj cz wral vm cz wrex vk cz wrex vk cv vj cv cle wbr vj cv cF cfv
        cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv
        co clt wbr wa wi vj cz wral vk cz wrex vm cv vj cv cle wbr vj cv cF cfv
        cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv
        co clt wbr wa wi vj cz wral vm cz wrex wa vk cv vj cv cle wbr vm cv vj
        cv cle wbr wa vj cz wrex vm cz wral vk cz wral wn vk cv vj cv cle wbr
        vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vm cv vj cv cle wbr vj cv
        cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv
        c2 cdiv co clt wbr wa wi vj cz wral wa vm cz wrex vk cv vj cv cle wbr
        vm cv vj cv cle wbr wa wn vj cz wral vm cz wrex vk cz vk cv vj cv cle
        wbr vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr wa wi vj cz wral vm cv vj cv cle wbr vj cv
        cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv
        c2 cdiv co clt wbr wa wi vj cz wral wa vk cv vj cv cle wbr vm cv vj cv
        cle wbr wa wn vj cz wral vm cz vk cv vj cv cle wbr vj cv cF cfv cc wcel
        vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt
        wbr wa wi vj cz wral vm cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF
        cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi
        vj cz wral wa vk cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cA
        cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi vm cv
        vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA
        cB cmin co cabs cfv c2 cdiv co clt wbr wa wi wa vj cz wral vk cv vj cv
        cle wbr vm cv vj cv cle wbr wa wn vj cz wral vk cv vj cv cle wbr vj cv
        cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv
        c2 cdiv co clt wbr wa wi vm cv vj cv cle wbr vj cv cF cfv cc wcel vj cv
        cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa
        wi vj cz r19.26 vk cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv
        cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi vm
        cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv
        cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi wa vk cv vj cv cle wbr
        vm cv vj cv cle wbr wa wn vj cz vk cv vj cv cle wbr vj cv cF cfv cc
        wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co
        clt wbr wa wi vm cv vj cv cle wbr vj cv cF cfv cc wcel vj cv cF cfv cB
        cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wi wa vk
        cv vj cv cle wbr vm cv vj cv cle wbr wa vj cv cF cfv cc wcel vj cv cF
        cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa vj
        cv cF cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs
        cfv c2 cdiv co clt wbr wa wa vj cv cF cfv cc wcel vj cv cF cfv cA cmin
        co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa vj cv cF cfv
        cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv
        co clt wbr wa wa cA cB cmin co cabs cfv cA cB cmin co cabs cfv clt wbr
        cA cB cmin co cabs cfv cA cB cmin co cA cB cA cvv wcel cF cA cli wbr cA
        cc wcel climuni.1 cF cA cli wbr cF cB cli wbr climunii.3 pm3.26i cA cvv
        cF climcl mp2an cB cvv wcel cF cB cli wbr cB cc wcel climuni.2 cF cA
        cli wbr cF cB cli wbr climunii.3 pm3.27i cB cvv cF climcl mp2an subcli
        abscli ltnri vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA
        cB cmin co cabs cfv c2 cdiv co clt wbr wa vj cv cF cfv cc wcel vj cv cF
        cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr wa wa
        vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr vj cv cF cfv cB cmin co cabs cfv cA cB cmin
        co cabs cfv c2 cdiv co clt wbr wa wa cA cB cmin co cabs cfv cA cB cmin
        co cabs cfv clt wbr vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs
        cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr vj cv cF cfv cB cmin co
        cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr anandi vj cv cF cfv
        cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv
        co clt wbr vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2
        cdiv co clt wbr wa cA cB cmin co cabs cfv cA cB cmin co cabs cfv clt
        wbr vj cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co
        cabs cfv c2 cdiv co clt wbr vj cv cF cfv cB cmin co cabs cfv cA cB cmin
        co cabs cfv c2 cdiv co clt wbr wa cA vj cv cF cfv cmin co cabs cfv cA
        cB cmin co cabs cfv c2 cdiv co clt wbr vj cv cF cfv cB cmin co cabs cfv
        cA cB cmin co cabs cfv c2 cdiv co clt wbr wa cA cB cmin co cabs cfv cA
        cB cmin co cabs cfv clt wbr vj cv cF cfv cc wcel vj cv cF cfv cA cmin
        co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr cA vj cv cF cfv
        cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr vj cv cF cfv
        cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr vj cv cF
        cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA vj cv cF cfv cmin co
        cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt vj cv cF cfv cc wcel cA
        cc wcel vj cv cF cfv cA cmin co cabs cfv cA vj cv cF cfv cmin co cabs
        cfv wceq cA cvv wcel cF cA cli wbr cA cc wcel climuni.1 cF cA cli wbr
        cF cB cli wbr climunii.3 pm3.26i cA cvv cF climcl mp2an vj cv cF cfv cA
        abssub mpan2 breq1d anbi1d vj cv cF cfv cc wcel cA cB cmin co cabs cfv
        cr wcel cA vj cv cF cfv cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv
        co clt wbr vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2
        cdiv co clt wbr wa cA cB cmin co cabs cfv cA cB cmin co cabs cfv clt
        wbr wi cA cB cmin co cA cB cA cvv wcel cF cA cli wbr cA cc wcel
        climuni.1 cF cA cli wbr cF cB cli wbr climunii.3 pm3.26i cA cvv cF
        climcl mp2an cB cvv wcel cF cB cli wbr cB cc wcel climuni.2 cF cA cli
        wbr cF cB cli wbr climunii.3 pm3.27i cB cvv cF climcl mp2an subcli
        abscli cA cc wcel cB cc wcel vj cv cF cfv cc wcel cA cB cmin co cabs
        cfv cr wcel wa cA vj cv cF cfv cmin co cabs cfv cA cB cmin co cabs cfv
        c2 cdiv co clt wbr vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs
        cfv c2 cdiv co clt wbr wa cA cB cmin co cabs cfv cA cB cmin co cabs cfv
        clt wbr wi cA cvv wcel cF cA cli wbr cA cc wcel climuni.1 cF cA cli wbr
        cF cB cli wbr climunii.3 pm3.26i cA cvv cF climcl mp2an cB cvv wcel cF
        cB cli wbr cB cc wcel climuni.2 cF cA cli wbr cF cB cli wbr climunii.3
        pm3.27i cB cvv cF climcl mp2an cA cB vj cv cF cfv cA cB cmin co cabs
        cfv abs3lem mpanl12 mpan2 sylbid imp sylbir mto vk cv vj cv cle wbr vj
        cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs
        cfv c2 cdiv co clt wbr wa vm cv vj cv cle wbr vj cv cF cfv cc wcel vj
        cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2 cdiv co clt wbr
        wa prth mtoi r19.20si sylbir r19.22si r19.22si vk cv vj cv cle wbr vj
        cv cF cfv cc wcel vj cv cF cfv cA cmin co cabs cfv cA cB cmin co cabs
        cfv c2 cdiv co clt wbr wa wi vj cz wral vm cv vj cv cle wbr vj cv cF
        cfv cc wcel vj cv cF cfv cB cmin co cabs cfv cA cB cmin co cabs cfv c2
        cdiv co clt wbr wa wi vj cz wral vk vm cz cz reeanv vk cv vj cv cle wbr
        vm cv vj cv cle wbr wa wn vj cz wral vm cz wrex vk cz wrex vk cv vj cv
        cle wbr vm cv vj cv cle wbr wa vj cz wrex vm cz wral wn vk cz wrex vk
        cv vj cv cle wbr vm cv vj cv cle wbr wa vj cz wrex vm cz wral vk cz
        wral wn vk cv vj cv cle wbr vm cv vj cv cle wbr wa wn vj cz wral vm cz
        wrex vk cv vj cv cle wbr vm cv vj cv cle wbr wa vj cz wrex vm cz wral
        wn vk cz vk cv vj cv cle wbr vm cv vj cv cle wbr wa wn vj cz wral vm cz
        wrex vk cv vj cv cle wbr vm cv vj cv cle wbr wa vj cz wrex wn vm cz
        wrex vk cv vj cv cle wbr vm cv vj cv cle wbr wa vj cz wrex vm cz wral
        wn vk cv vj cv cle wbr vm cv vj cv cle wbr wa wn vj cz wral vk cv vj cv
        cle wbr vm cv vj cv cle wbr wa vj cz wrex wn vm cz vk cv vj cv cle wbr
        vm cv vj cv cle wbr wa vj cz ralnex rexbii vk cv vj cv cle wbr vm cv vj
        cv cle wbr wa vj cz wrex vm cz rexnal bitri rexbii vk cv vj cv cle wbr
        vm cv vj cv cle wbr wa vj cz wrex vm cz wral vk cz rexnal bitri 3imtr3i
        3syl mt2 cc0 cA cB cmin co cabs cfv clt wbr cA cB cmin co cc0 cA cB
        cmin co cA cB cA cvv wcel cF cA cli wbr cA cc wcel climuni.1 cF cA cli
        wbr cF cB cli wbr climunii.3 pm3.26i cA cvv cF climcl mp2an cB cvv wcel
        cF cB cli wbr cB cc wcel climuni.2 cF cA cli wbr cF cB cli wbr
        climunii.3 pm3.27i cB cvv cF climcl mp2an subcli absgt0i necon1bbii
        mpbi cA cB cA cvv wcel cF cA cli wbr cA cc wcel climuni.1 cF cA cli wbr
        cF cB cli wbr climunii.3 pm3.26i cA cvv cF climcl mp2an cB cvv wcel cF
        cB cli wbr cB cc wcel climuni.2 cF cA cli wbr cF cB cli wbr climunii.3
        pm3.27i cB cvv cF climcl mp2an subeq0i mpbi $.
        $( [23-Sep-2005] $) $( [28-Aug-2005] $)
    $}

    $( An infinite sequence of complex numbers converges to at most one
       limit. $)
    climuni $p |- ( ( F ~~> A /\ F ~~> B ) -> A = B ) $=
      cF cA cli wbr cF cB cli wbr wa cA cB wceq cF cA cli wbr cF cB cli wbr wa
      cA cc0 cif cB wceq cF cA cli wbr cF cB cli wbr wa cA cc0 cif cF cA cli
      wbr cF cB cli wbr wa cB cc0 cif wceq cA cB cc0 cc0 cA cF cA cli wbr cF cB
      cli wbr wa cA cc0 cif cB eqeq1 cB cF cA cli wbr cF cB cli wbr wa cB cc0
      cif cF cA cli wbr cF cB cli wbr wa cA cc0 cif eqeq2 cF cA cli wbr cF cB
      cli wbr wa cA cc0 cif cF cA cli wbr cF cB cli wbr wa cB cc0 cif cF cA cli
      wbr cF cB cli wbr wa cF cz cc0 csn cxp cif cF cA cli wbr cF cB cli wbr wa
      cA cc0 climuni.1 cc0 cc 0cn elisseti ifex cF cA cli wbr cF cB cli wbr wa
      cB cc0 climuni.2 cc0 cc 0cn elisseti ifex cF cA cli wbr cF cB cli wbr wa
      cF cF cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cF cB cli wbr wa cF
      cF cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cF cF cA cli wbr cF cB
      cli wbr wa cB cc0 cif cli wbr wa cF cA cli wbr cF cB cli wbr wa cF cz cc0
      csn cxp cif cF cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cF cA cli
      wbr cF cB cli wbr wa cF cz cc0 csn cxp cif cF cA cli wbr cF cB cli wbr wa
      cB cc0 cif cli wbr wa cA cB cF cc0 cc0 cz cc0 csn cxp cz cc0 csn cxp cc0
      cli wbr cz cc0 csn cxp cc0 cli wbr wa cz cc0 csn cxp cF cA cli wbr cF cB
      cli wbr wa cA cc0 cif cli wbr cz cc0 csn cxp cc0 cli wbr wa cz cc0 csn
      cxp cF cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cz cc0 csn cxp cF
      cA cli wbr cF cB cli wbr wa cB cc0 cif cli wbr wa cA cF cA cli wbr cF cB
      cli wbr wa cA cc0 cif wceq cF cA cli wbr cF cF cA cli wbr cF cB cli wbr
      wa cA cc0 cif cli wbr cF cB cli wbr cA cF cA cli wbr cF cB cli wbr wa cA
      cc0 cif cF cli breq2 anbi1d cB cF cA cli wbr cF cB cli wbr wa cB cc0 cif
      wceq cF cB cli wbr cF cF cA cli wbr cF cB cli wbr wa cB cc0 cif cli wbr
      cF cF cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cB cF cA cli wbr cF
      cB cli wbr wa cB cc0 cif cF cli breq2 anbi2d cF cF cA cli wbr cF cB cli
      wbr wa cF cz cc0 csn cxp cif wceq cF cF cA cli wbr cF cB cli wbr wa cA
      cc0 cif cli wbr cF cA cli wbr cF cB cli wbr wa cF cz cc0 csn cxp cif cF
      cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cF cF cA cli wbr cF cB cli
      wbr wa cB cc0 cif cli wbr cF cA cli wbr cF cB cli wbr wa cF cz cc0 csn
      cxp cif cF cA cli wbr cF cB cli wbr wa cB cc0 cif cli wbr cF cF cA cli
      wbr cF cB cli wbr wa cF cz cc0 csn cxp cif cF cA cli wbr cF cB cli wbr wa
      cA cc0 cif cli breq1 cF cF cA cli wbr cF cB cli wbr wa cF cz cc0 csn cxp
      cif cF cA cli wbr cF cB cli wbr wa cB cc0 cif cli breq1 anbi12d cc0 cF cA
      cli wbr cF cB cli wbr wa cA cc0 cif wceq cz cc0 csn cxp cc0 cli wbr cz
      cc0 csn cxp cF cA cli wbr cF cB cli wbr wa cA cc0 cif cli wbr cz cc0 csn
      cxp cc0 cli wbr cc0 cF cA cli wbr cF cB cli wbr wa cA cc0 cif cz cc0 csn
      cxp cli breq2 anbi1d cc0 cF cA cli wbr cF cB cli wbr wa cB cc0 cif wceq
      cz cc0 csn cxp cc0 cli wbr cz cc0 csn cxp cF cA cli wbr cF cB cli wbr wa
      cB cc0 cif cli wbr cz cc0 csn cxp cF cA cli wbr cF cB cli wbr wa cA cc0
      cif cli wbr cc0 cF cA cli wbr cF cB cli wbr wa cB cc0 cif cz cc0 csn cxp
      cli breq2 anbi2d cz cc0 csn cxp cF cA cli wbr cF cB cli wbr wa cF cz cc0
      csn cxp cif wceq cz cc0 csn cxp cF cA cli wbr cF cB cli wbr wa cA cc0 cif
      cli wbr cF cA cli wbr cF cB cli wbr wa cF cz cc0 csn cxp cif cF cA cli
      wbr cF cB cli wbr wa cA cc0 cif cli wbr cz cc0 csn cxp cF cA cli wbr cF
      cB cli wbr wa cB cc0 cif cli wbr cF cA cli wbr cF cB cli wbr wa cF cz cc0
      csn cxp cif cF cA cli wbr cF cB cli wbr wa cB cc0 cif cli wbr cz cc0 csn
      cxp cF cA cli wbr cF cB cli wbr wa cF cz cc0 csn cxp cif cF cA cli wbr cF
      cB cli wbr wa cA cc0 cif cli breq1 cz cc0 csn cxp cF cA cli wbr cF cB cli
      wbr wa cF cz cc0 csn cxp cif cF cA cli wbr cF cB cli wbr wa cB cc0 cif
      cli breq1 anbi12d cz cc0 csn cxp cc0 cli wbr cz cc0 csn cxp cc0 cli wbr
      clim0 clim0 pm3.2i elimhyp3v climunii dedth2v $.
      $( [29-Sep-2005] $) $( [2-Oct-1999] $)
  $}

  ${
    $d y A $.  $d x y F $.
    climreu.1 $e |- A e. _V $.
    $( An infinite sequence of complex numbers converges to at most one
       limit. $)
    climeu $p |- ( F ~~> A -> E! x F ~~> x ) $=
      cF cA cli wbr cF vy cv cli wbr vy wex cF vy cv cli wbr cF vx cv cli wbr
      wa vy cv vx cv wceq wi vx wal vy wal wa cF vx cv cli wbr vx weu cF cA cli
      wbr cF vy cv cli wbr vy wex cF vy cv cli wbr cF vx cv cli wbr wa vy cv vx
      cv wceq wi vx wal vy wal cF vy cv cli wbr cF cA cli wbr vy cA climreu.1
      vy cv cA cF cli breq2 cla4ev cF vy cv cli wbr cF vx cv cli wbr wa vy cv
      vx cv wceq wi vy vx vy cv vx cv cF vy visset vx visset climuni gen2 jctir
      cF vx cv cli wbr vx weu cF vy cv cli wbr vy weu cF vy cv cli wbr vy wex
      cF vy cv cli wbr cF vx cv cli wbr wa vy cv vx cv wceq wi vx wal vy wal wa
      cF vx cv cli wbr cF vy cv cli wbr vx vy cF vx cv cli wbr vy ax-17 cF vy
      cv cli wbr vx ax-17 vx cv vy cv cF cli breq2 cbveu cF vy cv cli wbr cF vx
      cv cli wbr vy vx vy cv vx cv cF cli breq2 eu4 bitri sylibr $.
      $( [26-Dec-2005] $) $( [25-Dec-2005] $)

    $( An infinite sequence of complex numbers converges to at most one
       limit. $)
    climreu $p |- ( F ~~> A -> E! x e. CC F ~~> x ) $=
      cF cA cli wbr cF vx cv cli wbr vx weu cF vx cv cli wbr vx cc wreu vx cA
      cF climreu.1 climeu cF vx cv cli wbr vx weu vx cv cc wcel cF vx cv cli
      wbr wa vx weu cF vx cv cli wbr vx cc wreu cF vx cv cli wbr vx cv cc wcel
      cF vx cv cli wbr wa vx cF vx cv cli wbr vx cv cc wcel vx cv cvv wcel cF
      vx cv cli wbr vx cv cc wcel vx visset vx cv cvv cF climcl mpan pm4.71ri
      eubii cF vx cv cli wbr vx cc df-reu bitr4i sylib $.
      $( [27-Dec-2005] $) $( [25-Dec-2005] $)
  $}

  ${
    $d x y k j A $.  $d j k x y F $.  $d x y k j G $.
    2climnn.1 $e |- G e. _V $.
    $( If two sequences converge to each other, they converge to the same
       limit. $)
    2climnn $p |- ( ( ( A e. CC /\ A. k e. NN
  ( ( F ` k ) e. CC /\ ( G ` k ) e. CC ) ) /\ ( A. x e. RR ( 0 < x ->
             E. j e. NN A. k e. NN ( j <_ k ->
   ( abs ` ( ( G ` k ) - ( F ` k ) ) ) < x ) ) /\ F ~~> A ) ) -> G ~~> A ) $=
      cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral cF cA cli wbr wa
      wa cG cA cli wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral cF cA cli wbr wa wa
      cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy
      cv clt wbr wi vk cn wral vj cn wrex wi vy cr vy cv cr wcel cA cc wcel vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr wral cF cA cli wbr wa wa cc0 vy cv
      clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv clt
      wbr wi vk cn wral vj cn wrex wi vy cv cr wcel cA cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv cc wcel wa vk cn wral wa cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex wi vx cr wral cF cA cli wbr wa wa cc0 vy cv c2 cdiv co
      clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2
      cdiv co vy cv c2 cdiv co caddc co clt wbr wi vk cn wral vj cn wrex wi cc0
      vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv
      clt wbr wi vk cn wral vj cn wrex wi vy cv cr wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt
      wbr wi vk cn wral vj cn wrex wi vx cr wral cc0 vy cv c2 cdiv co clt wbr
      vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy
      cv c2 cdiv co caddc co clt wbr wi vk cn wral vj cn wrex wi cA cc wcel vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr wral cF cA cli wbr wa wa vy cv cr
      wcel vy cv c2 cdiv co cr wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj
      cn wrex wi vx cr wral cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk
      cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co
      clt wbr wi vk cn wral vj cn wrex wi wi vy cv rehalfcl cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co
      clt wbr wi vk cn wral vj cn wrex wi cc0 vy cv c2 cdiv co clt wbr vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2
      cdiv co caddc co clt wbr wi vk cn wral vj cn wrex wi vx vy cv c2 cdiv co
      cr vx cv vy cv c2 cdiv co wceq cc0 vx cv clt wbr cc0 vy cv c2 cdiv co clt
      wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv
      caddc co clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt
      wbr wi vk cn wral vj cn wrex vx cv vy cv c2 cdiv co cc0 clt breq2 vx cv
      vy cv c2 cdiv co wceq vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs
      cfv vx cv vx cv caddc co clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi vj
      vk cn cn vx cv vy cv c2 cdiv co wceq vk cv cG cfv cA cmin co cabs cfv vx
      cv vx cv caddc co clt wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv
      co vy cv c2 cdiv co caddc co clt wbr vj cv vk cv cle wbr vx cv vy cv c2
      cdiv co wceq vx cv vx cv caddc co vy cv c2 cdiv co vy cv c2 cdiv co caddc
      co vk cv cG cfv cA cmin co cabs cfv clt vx cv vy cv c2 cdiv co wceq vx cv
      vx cv caddc co vy cv c2 cdiv co vy cv c2 cdiv co caddc co wceq vx cv vy
      cv c2 cdiv co vx cv vy cv c2 cdiv co caddc opreq12 anidms breq2d imbi2d
      rexralbidv imbi12d rcla4v syl cA cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv cc wcel wa vk cn wral wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex wi vx cr wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral
      vj cn wrex wi vx cr wral cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa vk cn wral wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj
      cn wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv
      cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj cn wrex
      wi vx cr wral cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk
      cn wral wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG
      cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex
      wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj cn wrex wi vx
      cr wral wi cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn
      wral wa cF cA cli wbr wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG
      cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex
      wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv
      vx cv vx cv caddc co clt wbr wi vk cn wral vj cn wrex wi vx cr cA cc wcel
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cF cA cli wbr
      wa vx cv cr wcel wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk
      cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vj cv
      vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt
      wbr wi vk cn wral vj cn wrex cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv
      cc wcel wa vk cn wral wa cF cA cli wbr wa vx cv cr wcel wa cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv
      clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj cn wrex wi cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cF cA
      cli wbr wa vx cv cr wcel wa cc0 vx cv clt wbr wa vj cv vk cv cle wbr vk
      cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs
      cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj cn wrex cA cc wcel vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cF cA cli wbr wa
      vx cv cr wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex cA cc wcel cF cA cli
      wbr vx cv cr wcel cc0 vx cv clt wbr wa vj cv vk cv cle wbr vk cv cF cfv
      cA cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vk cv cF cfv
      cc wcel vk cv cG cfv cc wcel wa vk cn wral cA vx cv cc vj vk cF c1 cn cn
      1z cn c1 cuz cfv nnuz eqimss2i nnssz clmi2i adantllr anassrs cA cc wcel
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cF cA cli wbr
      wa vx cv cr wcel wa cc0 vx cv clt wbr wa vj cv vk cv cle wbr vk cv cG cfv
      vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wa wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv
      cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj
      cn wrex vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx
      cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wa cA cc wcel vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cF cA cli wbr wa
      vx cv cr wcel wa cc0 vx cv clt wbr wa vj cv vk cv cle wbr vk cv cG cfv vk
      cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wa wi vk cn wral vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral vj cn cA cc wcel
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa cF cA cli wbr
      wa vx cv cr wcel wa vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co
      cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa
      wi vk cn wral vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv
      vx cv caddc co clt wbr wi vk cn wral wi cc0 vx cv clt wbr cA cc wcel vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral wa vx cv cr wcel vj
      cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cn wral vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr
      wi vk cn wral wi cF cA cli wbr cA cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv cc wcel wa vk cn wral wa vx cv cr wcel wa vj cv vk cv cle wbr vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv vx cv caddc co clt wbr wi wi vk cn wral vj cv vk cv cle
      wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv
      cA cmin co cabs cfv vx cv clt wbr wa wi vk cn wral vj cv vk cv cle wbr vk
      cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn wral
      wi cA cc wcel vx cv cr wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa
      vk cn wral vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vj cv
      vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt
      wbr wi wi vk cn wral cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel wa vk cn wral vj cv vk cv cle wbr vk cv cG cfv vk cv cF
      cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv
      vx cv caddc co clt wbr wi wi vk cn wral cA cc wcel vx cv cr wcel wa vk cv
      cF cfv cc wcel vk cv cG cfv cc wcel wa vj cv vk cv cle wbr vk cv cG cfv
      vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs
      cfv vx cv vx cv caddc co clt wbr wi wi vk cn cA cc wcel vx cv cr wcel wa
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vj cv vk cv cle wbr vk cv cG
      cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co
      cabs cfv vx cv vx cv caddc co clt wbr wi wi cA cc wcel vx cv cr wcel wa
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wa vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr vj
      cv vk cv cle wbr cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv
      cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vk cv cG cfv vk cv
      cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co vx cv
      vx cv caddc co clt wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc
      co clt wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv cr wcel vk cv cF
      cfv cA cmin co cabs cfv cr wcel wa vx cv cr wcel vx cv cr wcel wa vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      vk cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv caddc co clt wbr wi
      cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa
      wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co
      cabs cfv vx cv vx cv lt2add cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv
      cc wcel wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv cr wcel vk cv cF
      cfv cA cmin co cabs cfv cr wcel wa vx cv cr wcel cA cc wcel vk cv cF cfv
      cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv cmin co cabs
      cfv cr wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cc wcel
      vk cv cG cfv cc wcel wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv cr
      wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv cG cfv
      vk cv cF cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      cr wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv subcl ancoms vk cv cG cfv
      vk cv cF cfv cmin co abscl syl adantl cA cc wcel vk cv cF cfv cc wcel vk
      cv cF cfv cA cmin co cabs cfv cr wcel vk cv cG cfv cc wcel cA cc wcel vk
      cv cF cfv cc wcel wa vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin
      co cabs cfv cr wcel vk cv cF cfv cc wcel cA cc wcel vk cv cF cfv cA cmin
      co cc wcel vk cv cF cfv cA subcl ancoms vk cv cF cfv cA cmin co abscl syl
      adantrr jca adantlr vx cv cr wcel vx cv cr wcel vx cv cr wcel wa cA cc
      wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vx cv cr wcel vx cv cr
      wcel vx cv cr wcel wa vx cv cr wcel vx cv cr wcel pm3.2 pm2.43i ad2antlr
      sylanc cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cle wbr vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv
      caddc co vx cv vx cv caddc co clt wbr vk cv cG cfv cA cmin co cabs cfv vx
      cv vx cv caddc co clt wbr cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv cmin
      co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cle wbr vx cv cr
      wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG
      cfv vk cv cF cfv cmin co vk cv cF cfv cA cmin co caddc co cabs cfv vk cv
      cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk
      cv cF cfv cA cmin co cabs cfv caddc co cle cA cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv cmin co vk cv
      cF cfv cA cmin co caddc co vk cv cG cfv cA cmin co cabs cA cc wcel vk cv
      cF cfv cc wcel vk cv cG cfv cc wcel vk cv cG cfv vk cv cF cfv cmin co vk
      cv cF cfv cA cmin co caddc co vk cv cG cfv cA cmin co wceq vk cv cG cfv
      cc wcel vk cv cF cfv cc wcel cA cc wcel vk cv cG cfv vk cv cF cfv cmin co
      vk cv cF cfv cA cmin co caddc co vk cv cG cfv cA cmin co wceq vk cv cG
      cfv vk cv cF cfv cA npncan 3com13 3expb fveq2d vk cv cG cfv vk cv cF cfv
      cmin co cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cG cfv vk cv cF cfv
      cmin co vk cv cF cfv cA cmin co caddc co cabs cfv vk cv cG cfv vk cv cF
      cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cle wbr cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk
      cv cF cfv cmin co vk cv cF cfv cA cmin co abstri vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel wa vk cv cG cfv vk cv cF cfv cmin co cc wcel cA cc wcel
      vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cmin
      co cc wcel vk cv cG cfv vk cv cF cfv subcl ancoms adantl cA cc wcel vk cv
      cF cfv cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cG cfv cc wcel vk cv
      cF cfv cc wcel cA cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA
      subcl ancoms adantrr sylanc eqbrtrrd adantlr vk cv cG cfv cA cmin co cabs
      cfv cr wcel vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA
      cmin co cabs cfv caddc co cr wcel vx cv vx cv caddc co cr wcel vk cv cG
      cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk cv
      cF cfv cA cmin co cabs cfv caddc co cle wbr vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv
      caddc co clt wbr wa vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co
      clt wbr wi cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv
      cc wcel wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv
      caddc co lelttr cA cc wcel vk cv cG cfv cc wcel vk cv cG cfv cA cmin co
      cabs cfv cr wcel vx cv cr wcel vk cv cF cfv cc wcel cA cc wcel vk cv cG
      cfv cc wcel wa vk cv cG cfv cA cmin co cc wcel vk cv cG cfv cA cmin co
      cabs cfv cr wcel vk cv cG cfv cc wcel cA cc wcel vk cv cG cfv cA cmin co
      cc wcel vk cv cG cfv cA subcl ancoms vk cv cG cfv cA cmin co abscl syl
      ad2ant2rl cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv
      caddc co cr wcel vx cv cr wcel vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      cr wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cG cfv vk cv cF
      cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cr wcel cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk
      cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv readdcl vk cv
      cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv cG cfv vk cv cF cfv cmin co
      cabs cfv cr wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa
      vk cv cG cfv vk cv cF cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv cmin
      co cabs cfv cr wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv vk cv cF cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv subcl ancoms
      vk cv cG cfv vk cv cF cfv cmin co abscl syl adantl cA cc wcel vk cv cF
      cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cG cfv cc wcel
      cA cc wcel vk cv cF cfv cc wcel wa vk cv cF cfv cA cmin co cc wcel vk cv
      cF cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cc wcel cA cc wcel vk cv
      cF cfv cA cmin co cc wcel vk cv cF cfv cA subcl ancoms vk cv cF cfv cA
      cmin co abscl syl adantrr sylanc adantlr vx cv cr wcel vx cv vx cv caddc
      co cr wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vx cv
      cr wcel vx cv vx cv caddc co cr wcel vx cv vx cv readdcl anidms ad2antlr
      syl3anc mpand syld imim2d ex r19.20sdv imp an1rs vj cv vk cv cle wbr vk
      cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn r19.20 syl adantlr
      adantr r19.22sdv vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr vj vk c1 cn 1z nnuz
      cvganuzi syl5ib mpan2d ex a2d r19.20dva ex com23 imp32 syl5 vy cv cr wcel
      cc0 vy cv c2 cdiv co clt wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv
      cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt
      wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv cG cfv cA cmin co
      cabs cfv vy cv clt wbr wi vk cn wral vj cn wrex vy cv cr wcel cc0 vy cv
      clt wbr cc0 vy cv c2 cdiv co clt wbr vy cv halfpos2 bicomd vy cv cr wcel
      vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy
      cv c2 cdiv co caddc co clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vy cv clt wbr wi vj vk cn cn vy cv cr wcel vk cv cG cfv
      cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr vk
      cv cG cfv cA cmin co cabs cfv vy cv clt wbr vj cv vk cv cle wbr vy cv cr
      wcel vy cv c2 cdiv co vy cv c2 cdiv co caddc co vy cv vk cv cG cfv cA
      cmin co cabs cfv clt vy cv cr wcel vy cv cc wcel vy cv c2 cdiv co vy cv
      c2 cdiv co caddc co vy cv wceq vy cv recn vy cv 2halves syl breq2d imbi2d
      rexralbidv imbi12d sylibd com12 r19.21aiv cA cc wcel vk cv cF cfv cc wcel
      vk cv cG cfv cc wcel wa vk cn wral wa cG cA cli wbr cc0 vy cv clt wbr vj
      cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv clt wbr wi vk cn
      wral vj cn wrex wi vy cr wral wb cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex wi vx cr wral cF cA cli wbr wa cA cc wcel vk cv cG cfv cc wcel vk cn
      wral cG cA cli wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral wb
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn wral cA cc wcel vk cv
      cG cfv cc wcel vk cn cn cin wral cG cA cli wbr cc0 vy cv clt wbr vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv clt wbr wi vk cn wral
      vj cn wrex wi vy cr wral wb vk cv cG cfv cc wcel vk cn wral vy cA vj vk
      cG c1 c1 cn cn 1z cn c1 cuz cfv nnuz eqimss2i nnssz 1z cn c1 cuz cfv nnuz
      eqimss2i nnssz 2climnn.1 clm4i cn cn cin cn wss vk cv cG cfv cc wcel vk
      cn wral vk cv cG cfv cc wcel vk cn cn cin wral wi cn cn inss2 vk cv cG
      cfv cc wcel vk cn cn cin cn ssralv ax-mp sylan2 vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel wa vk cv cG cfv cc wcel vk cn vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel pm3.27 r19.20si sylan2 adantr mpbird $.
      $( [17-Feb-2006] $) $( [24-Dec-2005] $)

    $( If two sequences converge to each other, they converge to the same
       limit. $)
    2climnn0 $p |- ( ( ( A e. CC /\ A. k e. NN0
  ( ( F ` k ) e. CC /\ ( G ` k ) e. CC ) ) /\ ( A. x e. RR ( 0 < x ->
             E. j e. NN0 A. k e. NN0 ( j <_ k ->
   ( abs ` ( ( G ` k ) - ( F ` k ) ) ) < x ) ) /\ F ~~> A ) ) -> G ~~> A ) $=
      cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co
      cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral cF cA cli
      wbr wa wa cG cA cli wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vy cv clt wbr wi vk cn0 wral vj cn0 wrex wi vy cr
      wral cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral
      wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin
      co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral cF cA
      cli wbr wa wa cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vy cv clt wbr wi vk cn0 wral vj cn0 wrex wi vy cr vy cv cr
      wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral
      wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin
      co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral cF cA
      cli wbr wa wa cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vy cv clt wbr wi vk cn0 wral vj cn0 wrex wi vy cv cr wcel cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs
      cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral cF cA cli wbr
      wa wa cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi vk
      cn0 wral vj cn0 wrex wi cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vy cv clt wbr wi vk cn0 wral vj cn0 wrex wi vy cv
      cr wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co
      cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr
      wral cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi vk
      cn0 wral vj cn0 wrex wi cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa vk cn0 wral wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv
      vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi
      vx cr wral cF cA cli wbr wa wa vy cv cr wcel vy cv c2 cdiv co cr wcel cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv
      vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral cc0 vy cv
      c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv
      vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi vk cn0 wral vj cn0
      wrex wi wi vy cv rehalfcl cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj
      cn0 wrex wi cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr vk cv cG cfv
      cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi
      vk cn0 wral vj cn0 wrex wi vx vy cv c2 cdiv co cr vx cv vy cv c2 cdiv co
      wceq cc0 vx cv clt wbr cc0 vy cv c2 cdiv co clt wbr vj cv vk cv cle wbr
      vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0
      wral vj cn0 wrex vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy
      cv c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi vk cn0 wral vj cn0
      wrex vx cv vy cv c2 cdiv co cc0 clt breq2 vx cv vy cv c2 cdiv co wceq vj
      cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co
      clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2
      cdiv co vy cv c2 cdiv co caddc co clt wbr wi vj vk cn0 cn0 vx cv vy cv c2
      cdiv co wceq vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt
      wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co
      caddc co clt wbr vj cv vk cv cle wbr vx cv vy cv c2 cdiv co wceq vx cv vx
      cv caddc co vy cv c2 cdiv co vy cv c2 cdiv co caddc co vk cv cG cfv cA
      cmin co cabs cfv clt vx cv vy cv c2 cdiv co wceq vx cv vx cv caddc co vy
      cv c2 cdiv co vy cv c2 cdiv co caddc co wceq vx cv vy cv c2 cdiv co vx cv
      vy cv c2 cdiv co caddc opreq12 anidms breq2d imbi2d rexralbidv imbi12d
      rcla4v syl cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0
      wral wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral
      cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex wi vx
      cr wral cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0
      wral wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv
      vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi
      vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co
      cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr
      wral cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral
      wa cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv
      cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr
      wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs
      cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr wral
      wi cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa
      cF cA cli wbr wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv
      cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex wi cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv
      vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex wi vx cr cA cc wcel vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa cF cA cli wbr wa
      vx cv cr wcel wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv vk cv
      cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr
      wi vk cn0 wral vj cn0 wrex cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv
      cc wcel wa vk cn0 wral wa cF cA cli wbr wa vx cv cr wcel wa cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv
      clt wbr wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex
      wi cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa
      cF cA cli wbr wa vx cv cr wcel wa cc0 vx cv clt wbr wa vj cv vk cv cle
      wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0
      wral vj cn0 wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral vj cn0 wrex
      cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa cF
      cA cli wbr wa vx cv cr wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex cA cc
      wcel cF cA cli wbr vx cv cr wcel cc0 vx cv clt wbr wa vj cv vk cv cle wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0 wrex
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral cA vx cv cc vj
      vk cF cc0 cn0 cn0 0z cn0 cc0 cuz cfv nn0uz eqimss2i nn0ssz clmi2i
      adantllr anassrs cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa
      vk cn0 wral wa cF cA cli wbr wa vx cv cr wcel wa cc0 vx cv clt wbr wa vj
      cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cn0 wral vj cn0
      wrex vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv
      caddc co clt wbr wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr vk cv cG
      cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr wi vk cn0 wral vj cn0
      wrex vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wi vk cn0 wral vj cn0 wrex wa cA cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv cc wcel wa vk cn0 wral wa cF cA cli wbr wa vx cv cr wcel wa cc0 vx cv
      clt wbr wa vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cn0
      wral vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv
      caddc co clt wbr wi vk cn0 wral vj cn0 cA cc wcel vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel wa vk cn0 wral wa cF cA cli wbr wa vx cv cr wcel wa vj
      cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vk cn0 wral vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr
      wi vk cn0 wral wi cc0 vx cv clt wbr cA cc wcel vk cv cF cfv cc wcel vk cv
      cG cfv cc wcel wa vk cn0 wral wa vx cv cr wcel vj cv vk cv cle wbr vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vk cn0 wral vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral wi cF
      cA cli wbr cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0
      wral wa vx cv cr wcel wa vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx
      cv caddc co clt wbr wi wi vk cn0 wral vj cv vk cv cle wbr vk cv cG cfv vk
      cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wa wi vk cn0 wral vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 wral wi cA cc wcel vx
      cv cr wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral vj cv
      vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk
      cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr wi wi vk cn0
      wral cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa vk cn0 wral vj cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co
      cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa
      wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc
      co clt wbr wi wi vk cn0 wral cA cc wcel vx cv cr wcel wa vk cv cF cfv cc
      wcel vk cv cG cfv cc wcel wa vj cv vk cv cle wbr vk cv cG cfv vk cv cF
      cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv
      vx cv caddc co clt wbr wi wi vk cn0 cA cc wcel vx cv cr wcel wa vk cv cF
      cfv cc wcel vk cv cG cfv cc wcel wa vj cv vk cv cle wbr vk cv cG cfv vk
      cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv
      vx cv vx cv caddc co clt wbr wi wi cA cc wcel vx cv cr wcel wa vk cv cF
      cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv cmin co
      cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa
      vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co clt wbr vj cv vk cv
      cle wbr cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wa vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv
      caddc co clt wbr vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co
      clt wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv cr wcel vk cv cF cfv
      cA cmin co cabs cfv cr wcel wa vx cv cr wcel vx cv cr wcel wa vk cv cG
      cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk
      cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv caddc co clt wbr wi cA
      cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa
      vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs
      cfv vx cv vx cv lt2add cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv cr wcel vk cv cF cfv
      cA cmin co cabs cfv cr wcel wa vx cv cr wcel cA cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv cmin co cabs
      cfv cr wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cc wcel
      vk cv cG cfv cc wcel wa vk cv cG cfv vk cv cF cfv cmin co cabs cfv cr
      wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv cG cfv
      vk cv cF cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      cr wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv subcl ancoms vk cv cG cfv
      vk cv cF cfv cmin co abscl syl adantl cA cc wcel vk cv cF cfv cc wcel vk
      cv cF cfv cA cmin co cabs cfv cr wcel vk cv cG cfv cc wcel cA cc wcel vk
      cv cF cfv cc wcel wa vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin
      co cabs cfv cr wcel vk cv cF cfv cc wcel cA cc wcel vk cv cF cfv cA cmin
      co cc wcel vk cv cF cfv cA subcl ancoms vk cv cF cfv cA cmin co abscl syl
      adantrr jca adantlr vx cv cr wcel vx cv cr wcel vx cv cr wcel wa cA cc
      wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vx cv cr wcel vx cv cr
      wcel vx cv cr wcel wa vx cv cr wcel vx cv cr wcel pm3.2 pm2.43i ad2antlr
      sylanc cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cle wbr vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv
      caddc co vx cv vx cv caddc co clt wbr vk cv cG cfv cA cmin co cabs cfv vx
      cv vx cv caddc co clt wbr cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel wa vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv cmin
      co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cle wbr vx cv cr
      wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG
      cfv vk cv cF cfv cmin co vk cv cF cfv cA cmin co caddc co cabs cfv vk cv
      cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk
      cv cF cfv cA cmin co cabs cfv caddc co cle cA cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk cv cF cfv cmin co vk cv
      cF cfv cA cmin co caddc co vk cv cG cfv cA cmin co cabs cA cc wcel vk cv
      cF cfv cc wcel vk cv cG cfv cc wcel vk cv cG cfv vk cv cF cfv cmin co vk
      cv cF cfv cA cmin co caddc co vk cv cG cfv cA cmin co wceq vk cv cG cfv
      cc wcel vk cv cF cfv cc wcel cA cc wcel vk cv cG cfv vk cv cF cfv cmin co
      vk cv cF cfv cA cmin co caddc co vk cv cG cfv cA cmin co wceq vk cv cG
      cfv vk cv cF cfv cA npncan 3com13 3expb fveq2d vk cv cG cfv vk cv cF cfv
      cmin co cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cG cfv vk cv cF cfv
      cmin co vk cv cF cfv cA cmin co caddc co cabs cfv vk cv cG cfv vk cv cF
      cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cle wbr cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk
      cv cF cfv cmin co vk cv cF cfv cA cmin co abstri vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel wa vk cv cG cfv vk cv cF cfv cmin co cc wcel cA cc wcel
      vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cmin
      co cc wcel vk cv cG cfv vk cv cF cfv subcl ancoms adantl cA cc wcel vk cv
      cF cfv cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cG cfv cc wcel vk cv
      cF cfv cc wcel cA cc wcel vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA
      subcl ancoms adantrr sylanc eqbrtrrd adantlr vk cv cG cfv cA cmin co cabs
      cfv cr wcel vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA
      cmin co cabs cfv caddc co cr wcel vx cv vx cv caddc co cr wcel vk cv cG
      cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv cmin co cabs cfv vk cv
      cF cfv cA cmin co cabs cfv caddc co cle wbr vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv
      caddc co clt wbr wa vk cv cG cfv cA cmin co cabs cfv vx cv vx cv caddc co
      clt wbr wi cA cc wcel vx cv cr wcel wa vk cv cF cfv cc wcel vk cv cG cfv
      cc wcel wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv vk cv cF cfv
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co vx cv vx cv
      caddc co lelttr cA cc wcel vk cv cG cfv cc wcel vk cv cG cfv cA cmin co
      cabs cfv cr wcel vx cv cr wcel vk cv cF cfv cc wcel cA cc wcel vk cv cG
      cfv cc wcel wa vk cv cG cfv cA cmin co cc wcel vk cv cG cfv cA cmin co
      cabs cfv cr wcel vk cv cG cfv cc wcel cA cc wcel vk cv cG cfv cA cmin co
      cc wcel vk cv cG cfv cA subcl ancoms vk cv cG cfv cA cmin co abscl syl
      ad2ant2rl cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv
      cG cfv vk cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv
      caddc co cr wcel vx cv cr wcel vk cv cG cfv vk cv cF cfv cmin co cabs cfv
      cr wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cG cfv vk cv cF
      cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv caddc co cr wcel cA
      cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa wa vk cv cG cfv vk
      cv cF cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv readdcl vk cv
      cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv cG cfv vk cv cF cfv cmin co
      cabs cfv cr wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa
      vk cv cG cfv vk cv cF cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv cmin
      co cabs cfv cr wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv vk cv cF cfv cmin co cc wcel vk cv cG cfv vk cv cF cfv subcl ancoms
      vk cv cG cfv vk cv cF cfv cmin co abscl syl adantl cA cc wcel vk cv cF
      cfv cc wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vk cv cG cfv cc wcel
      cA cc wcel vk cv cF cfv cc wcel wa vk cv cF cfv cA cmin co cc wcel vk cv
      cF cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cc wcel cA cc wcel vk cv
      cF cfv cA cmin co cc wcel vk cv cF cfv cA subcl ancoms vk cv cF cfv cA
      cmin co abscl syl adantrr sylanc adantlr vx cv cr wcel vx cv vx cv caddc
      co cr wcel cA cc wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vx cv
      cr wcel vx cv vx cv caddc co cr wcel vx cv vx cv readdcl anidms ad2antlr
      syl3anc mpand syld imim2d ex r19.20sdv imp an1rs vj cv vk cv cle wbr vk
      cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr vk cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vx cv vx cv caddc co clt wbr wi vk cn0 r19.20 syl
      adantlr adantr r19.22sdv vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv
      clt wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr vj vk cc0 cn0 0z
      nn0uz cvganuzi syl5ib mpan2d ex a2d r19.20dva ex com23 imp32 syl5 vy cv
      cr wcel cc0 vy cv c2 cdiv co clt wbr cc0 vy cv clt wbr vj cv vk cv cle
      wbr vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co
      caddc co clt wbr wi vk cn0 wral vj cn0 wrex vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vy cv clt wbr wi vk cn0 wral vj cn0 wrex vy cv cr
      wcel cc0 vy cv clt wbr cc0 vy cv c2 cdiv co clt wbr vy cv halfpos2 bicomd
      vy cv cr wcel vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv
      c2 cdiv co vy cv c2 cdiv co caddc co clt wbr wi vj cv vk cv cle wbr vk cv
      cG cfv cA cmin co cabs cfv vy cv clt wbr wi vj vk cn0 cn0 vy cv cr wcel
      vk cv cG cfv cA cmin co cabs cfv vy cv c2 cdiv co vy cv c2 cdiv co caddc
      co clt wbr vk cv cG cfv cA cmin co cabs cfv vy cv clt wbr vj cv vk cv cle
      wbr vy cv cr wcel vy cv c2 cdiv co vy cv c2 cdiv co caddc co vy cv vk cv
      cG cfv cA cmin co cabs cfv clt vy cv cr wcel vy cv cc wcel vy cv c2 cdiv
      co vy cv c2 cdiv co caddc co vy cv wceq vy cv recn vy cv 2halves syl
      breq2d imbi2d rexralbidv imbi12d sylibd com12 r19.21aiv cA cc wcel vk cv
      cF cfv cc wcel vk cv cG cfv cc wcel wa vk cn0 wral wa cG cA cli wbr cc0
      vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv
      clt wbr wi vk cn0 wral vj cn0 wrex wi vy cr wral wb cc0 vx cv clt wbr vj
      cv vk cv cle wbr vk cv cG cfv vk cv cF cfv cmin co cabs cfv vx cv clt wbr
      wi vk cn0 wral vj cn0 wrex wi vx cr wral cF cA cli wbr wa cA cc wcel vk
      cv cG cfv cc wcel vk cn0 wral cG cA cli wbr cc0 vy cv clt wbr vj cv vk cv
      cle wbr vk cv cG cfv cA cmin co cabs cfv vy cv clt wbr wi vk cn0 wral vj
      cn0 wrex wi vy cr wral wb vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk
      cn0 wral cA cc wcel vk cv cG cfv cc wcel vk cn0 cn0 cin wral cG cA cli
      wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs
      cfv vy cv clt wbr wi vk cn0 wral vj cn0 wrex wi vy cr wral wb vk cv cG
      cfv cc wcel vk cn0 wral vy cA vj vk cG cc0 cc0 cn0 cn0 0z cn0 cc0 cuz cfv
      nn0uz eqimss2i nn0ssz 0z cn0 cc0 cuz cfv nn0uz eqimss2i nn0ssz 2climnn.1
      clm4i cn0 cn0 cin cn0 wss vk cv cG cfv cc wcel vk cn0 wral vk cv cG cfv
      cc wcel vk cn0 cn0 cin wral wi cn0 cn0 inss2 vk cv cG cfv cc wcel vk cn0
      cn0 cin cn0 ssralv ax-mp sylan2 vk cv cF cfv cc wcel vk cv cG cfv cc wcel
      wa vk cv cG cfv cc wcel vk cn0 vk cv cF cfv cc wcel vk cv cG cfv cc wcel
      pm3.27 r19.20si sylan2 adantr mpbird $.
      $( [11-Jan-2007] $) $( [24-Dec-2005] $)
  $}

  ${
    $d j t m n x A $.  $d j k t m n x M $.  $d j t m n x F $.
    climshft.1 $e |- F e. _V $.
    climshft.2 $e |- M e. ZZ $.
    $( A shifted function converges iff the original function converges. $)
    climshfti $p |- ( A e. CC -> ( ( F shift M ) ~~> A <-> F ~~> A ) ) $=
      cA cc wcel cF cM cshi co cA cli wbr cc0 vx cv clt wbr vm cv vn cv cle wbr
      vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vn cz wral vm cz wrex wi vx cr wral cF cA cli wbr cA cc wcel cF cM cshi
      co cA cli wbr cc0 vx cv clt wbr vj cv vt cv cle wbr vt cv cF cM cshi co
      cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa
      wi vt cz wral vj cz wrex wi vx cr wral cc0 vx cv clt wbr vm cv vn cv cle
      wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wa wi vn cz wral vm cz wrex wi vx cr wral vx cA vj vt cF cM cshi co cc0
      cc0 cz cz 0z cc0 uzssz cz ssid 0z cc0 uzssz cz ssid cF cM cshi oprex
      clm2i cc0 vx cv clt wbr vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc
      wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt
      cz wral vj cz wrex wi cc0 vx cv clt wbr vm cv vn cv cle wbr vn cv cF cfv
      cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral
      vm cz wrex wi vx cr vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel
      vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz
      wral vj cz wrex vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vm cz wrex cc0 vx cv clt
      wbr vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi
      co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vj cz wrex vm
      cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wa wi vn cz wral vm cz wrex vj cv vt cv cle wbr vt cv cF cM
      cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt
      wbr wa wi vt cz wral vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vm cz wrex vj cz
      vj cv cz wcel vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv
      cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vj
      cv cM cmin co cz wcel vj cv cM cmin co vn cv cle wbr vn cv cF cfv cc wcel
      vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral wa vm cv
      vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vn cz wral vm cz wrex vj cv cz wcel vj cv vt cv cle wbr vt
      cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv
      vx cv clt wbr wa wi vt cz wral vj cv cM cmin co vn cv cle wbr vn cv cF
      cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz
      wral vj cv cM cmin co cz wcel vj cv cz wcel vj cv vt cv cle wbr vt cv cF
      cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vt cz wral vj cv cM cmin co vn cv cle wbr vn cv cF cfv cc
      wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz vj cv cz
      wcel vn cv cz wcel vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt
      cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral
      vj cv cM cmin co vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vj cv cz wcel vn cv cz wcel vj cv vt cv
      cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vt cz wral vj cv cM cmin co vn cv cle wbr
      vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vj
      cv cz wcel vn cv cz wcel wa vj cv vt cv cle wbr vt cv cF cM cshi co cfv
      cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vt cz wral wa vj cv cM cmin co vn cv cle wbr wa vn cv cF cfv cc wcel vn
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vn cv cM caddc co cF cM
      cshi co cfv cc wcel vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs
      cfv vx cv clt wbr wa vj cv cz wcel vn cv cz wcel wa vj cv vt cv cle wbr
      vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs
      cfv vx cv clt wbr wa wi vt cz wral wa vj cv cM cmin co vn cv cle wbr vn
      cv cM caddc co cF cM cshi co cfv cc wcel vn cv cM caddc co cF cM cshi co
      cfv cA cmin co cabs cfv vx cv clt wbr wa vj cv cz wcel vn cv cz wcel wa
      vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co
      cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral wa vj cv cM cmin
      co vn cv cle wbr vj cv vn cv cM caddc co cle wbr vn cv cM caddc co cF cM
      cshi co cfv cc wcel vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs
      cfv vx cv clt wbr wa vj cv cz wcel vn cv cz wcel wa vj cv cM cmin co vn
      cv cle wbr vj cv vn cv cM caddc co cle wbr wb vj cv vt cv cle wbr vt cv
      cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx
      cv clt wbr wa wi vt cz wral vj cv cr wcel vn cv cr wcel vj cv cM cmin co
      vn cv cle wbr vj cv vn cv cM caddc co cle wbr wb vj cv cz wcel vn cv cz
      wcel vj cv cr wcel cM cr wcel vn cv cr wcel vj cv cM cmin co vn cv cle
      wbr vj cv vn cv cM caddc co cle wbr wb cM climshft.2 zrei vj cv cM vn cv
      lesubadd mp3an2 vj cv zre vn cv zre syl2an adantr vn cv cz wcel vj cv vt
      cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vj cv vn cv cM caddc co
      cle wbr vn cv cM caddc co cF cM cshi co cfv cc wcel vn cv cM caddc co cF
      cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vj cv cz wcel vn
      cv cz wcel vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF
      cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vj cv
      vn cv cM caddc co cle wbr vn cv cM caddc co cF cM cshi co cfv cc wcel vn
      cv cM caddc co cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vn cv cz wcel vn cv cM caddc co cz wcel vj cv vt cv cle wbr vt cv cF cM
      cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt
      wbr wa wi vt cz wral vj cv vn cv cM caddc co cle wbr vn cv cM caddc co cF
      cM cshi co cfv cc wcel vn cv cM caddc co cF cM cshi co cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi wi vn cv cz wcel cM cz wcel vn cv cM caddc
      co cz wcel climshft.2 vn cv cM zaddcl mpan2 vj cv vt cv cle wbr vt cv cF
      cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vj cv vn cv cM caddc co cle wbr vn cv cM caddc co cF cM
      cshi co cfv cc wcel vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs
      cfv vx cv clt wbr wa wi vt vn cv cM caddc co cz vt cv vn cv cM caddc co
      wceq vj cv vt cv cle wbr vj cv vn cv cM caddc co cle wbr vt cv cF cM cshi
      co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr
      wa vn cv cM caddc co cF cM cshi co cfv cc wcel vn cv cM caddc co cF cM
      cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa vt cv vn cv cM caddc co
      vj cv cle breq2 vt cv vn cv cM caddc co wceq vt cv cF cM cshi co cfv cc
      wcel vn cv cM caddc co cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv
      cA cmin co cabs cfv vx cv clt wbr vn cv cM caddc co cF cM cshi co cfv cA
      cmin co cabs cfv vx cv clt wbr vt cv vn cv cM caddc co wceq vt cv cF cM
      cshi co cfv vn cv cM caddc co cF cM cshi co cfv cc vt cv vn cv cM caddc
      co cF cM cshi co fveq2 eleq1d vt cv vn cv cM caddc co wceq vt cv cF cM
      cshi co cfv cA cmin co cabs cfv vn cv cM caddc co cF cM cshi co cfv cA
      cmin co cabs cfv vx cv clt vt cv vn cv cM caddc co wceq vt cv cF cM cshi
      co cfv cA cmin co vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs vt
      cv vn cv cM caddc co wceq vt cv cF cM cshi co cfv vn cv cM caddc co cF cM
      cshi co cfv cA cmin vt cv vn cv cM caddc co cF cM cshi co fveq2 opreq1d
      fveq2d breq1d anbi12d imbi12d rcla4v syl imp adantll sylbid imp vj cv cz
      wcel vn cv cz wcel wa vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel
      vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz
      wral wa vj cv cM cmin co vn cv cle wbr wa vn cv cF cfv vn cv cM caddc co
      cF cM cshi co cfv wceq vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wa vn cv cM caddc co cF cM cshi co cfv cc wcel vn cv cM
      caddc co cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wb vj cv
      cz wcel vn cv cz wcel wa vn cv cF cfv vn cv cM caddc co cF cM cshi co cfv
      wceq vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi
      co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vj cv cM cmin
      co vn cv cle wbr vn cv cz wcel vn cv cF cfv vn cv cM caddc co cF cM cshi
      co cfv wceq vj cv cz wcel vn cv cz wcel vn cv cM caddc co cF cM cshi co
      cfv vn cv cM caddc co cM cmin co cF cfv vn cv cF cfv vn cv cz wcel vn cv
      cM caddc co cz wcel vn cv cM caddc co cc wcel vn cv cM caddc co cF cM
      cshi co cfv vn cv cM caddc co cM cmin co cF cfv wceq vn cv cz wcel cM cz
      wcel vn cv cM caddc co cz wcel climshft.2 vn cv cM zaddcl mpan2 vn cv cM
      caddc co zcn cM cz wcel vn cv cM caddc co cc wcel vn cv cM caddc co cF cM
      cshi co cfv vn cv cM caddc co cM cmin co cF cfv wceq climshft.2 cM vn cv
      cM caddc co cz cF climshft.1 shftval mpan 3syl vn cv cz wcel vn cv cM
      caddc co cM cmin co vn cv cF vn cv cc wcel cM cc wcel vn cv cM caddc co
      cM cmin co vn cv wceq vn cv cz wcel vn cv cM pncan vn cv zcn cM cM
      climshft.2 zrei recni sylancl fveq2d eqtr2d adantl ad2antrr vn cv cF cfv
      vn cv cM caddc co cF cM cshi co cfv wceq vn cv cF cfv cc wcel vn cv cM
      caddc co cF cM cshi co cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs cfv vx cv clt
      wbr vn cv cF cfv vn cv cM caddc co cF cM cshi co cfv cc eleq1 vn cv cF
      cfv vn cv cM caddc co cF cM cshi co cfv wceq vn cv cF cfv cA cmin co cabs
      cfv vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs cfv vx cv clt vn
      cv cF cfv vn cv cM caddc co cF cM cshi co cfv wceq vn cv cF cfv cA cmin
      co vn cv cM caddc co cF cM cshi co cfv cA cmin co cabs vn cv cF cfv vn cv
      cM caddc co cF cM cshi co cfv cA cmin opreq1 fveq2d breq1d anbi12d syl
      mpbird exp41 com23 r19.21adv vj cv cz wcel cM cz wcel vj cv cM cmin co cz
      wcel climshft.2 vj cv cM zsubcl mpan2 jctild vm cv vn cv cle wbr vn cv cF
      cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz
      wral vj cv cM cmin co vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vm vj cv cM cmin co cz vm
      cv vj cv cM cmin co wceq vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vj cv cM cmin co vn cv cle
      wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wa wi vn cz vm cv vj cv cM cmin co wceq vm cv vn cv cle wbr vj cv cM cmin
      co vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wa vm cv vj cv cM cmin co vn cv cle breq1 imbi1d ralbidv
      rcla4ev syl6 r19.23aiv vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vj cv vt cv cle
      wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vt cz wral vj cz wrex vm cz vm cv cz wcel vm
      cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wa wi vn cz wral vm cv cM caddc co cz wcel vm cv cM caddc co
      vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vt cz wral wa vj cv vt cv cle wbr vt
      cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv
      vx cv clt wbr wa wi vt cz wral vj cz wrex vm cv cz wcel vm cv vn cv cle
      wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wa wi vn cz wral vm cv cM caddc co vt cv cle wbr vt cv cF cM cshi co cfv
      cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vt cz wral vm cv cM caddc co cz wcel vm cv cz wcel vm cv vn cv cle wbr vn
      cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn
      cz wral vm cv cM caddc co vt cv cle wbr vt cv cF cM cshi co cfv cc wcel
      vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz vm
      cv cz wcel vt cv cz wcel vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vm cv cM caddc
      co vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv
      cA cmin co cabs cfv vx cv clt wbr wa wi vm cv cz wcel vt cv cz wcel vm cv
      vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vn cz wral vm cv cM caddc co vt cv cle wbr vt cv cF cM cshi
      co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr
      wa vm cv cz wcel vt cv cz wcel wa vm cv vn cv cle wbr vn cv cF cfv cc
      wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral wa
      vm cv cM caddc co vt cv cle wbr wa vt cv cF cM cshi co cfv cc wcel vt cv
      cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa vt cv cM cmin co
      cF cfv cc wcel vt cv cM cmin co cF cfv cA cmin co cabs cfv vx cv clt wbr
      wa vm cv cz wcel vt cv cz wcel wa vm cv vn cv cle wbr vn cv cF cfv cc
      wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral wa
      vm cv cM caddc co vt cv cle wbr vt cv cM cmin co cF cfv cc wcel vt cv cM
      cmin co cF cfv cA cmin co cabs cfv vx cv clt wbr wa vm cv cz wcel vt cv
      cz wcel wa vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vn cz wral wa vm cv cM caddc co vt cv cle
      wbr vm cv vt cv cM cmin co cle wbr vt cv cM cmin co cF cfv cc wcel vt cv
      cM cmin co cF cfv cA cmin co cabs cfv vx cv clt wbr wa vm cv cz wcel vt
      cv cz wcel wa vm cv cM caddc co vt cv cle wbr vm cv vt cv cM cmin co cle
      wbr wb vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vn cz wral vm cv cr wcel vt cv cr wcel vm cv
      cM caddc co vt cv cle wbr vm cv vt cv cM cmin co cle wbr wb vm cv cz wcel
      vt cv cz wcel vm cv cr wcel cM cr wcel vt cv cr wcel vm cv cM caddc co vt
      cv cle wbr vm cv vt cv cM cmin co cle wbr wb cM climshft.2 zrei vm cv cM
      vt cv leaddsub mp3an2 vm cv zre vt cv zre syl2an adantr vt cv cz wcel vm
      cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wa wi vn cz wral vm cv vt cv cM cmin co cle wbr vt cv cM cmin
      co cF cfv cc wcel vt cv cM cmin co cF cfv cA cmin co cabs cfv vx cv clt
      wbr wa wi vm cv cz wcel vt cv cz wcel vm cv vn cv cle wbr vn cv cF cfv cc
      wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vm
      cv vt cv cM cmin co cle wbr vt cv cM cmin co cF cfv cc wcel vt cv cM cmin
      co cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cv cz wcel vt cv cM
      cmin co cz wcel vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA
      cmin co cabs cfv vx cv clt wbr wa wi vn cz wral vm cv vt cv cM cmin co
      cle wbr vt cv cM cmin co cF cfv cc wcel vt cv cM cmin co cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi wi vt cv cz wcel cM cz wcel vt cv cM cmin
      co cz wcel climshft.2 vt cv cM zsubcl mpan2 vm cv vn cv cle wbr vn cv cF
      cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vm cv vt
      cv cM cmin co cle wbr vt cv cM cmin co cF cfv cc wcel vt cv cM cmin co cF
      cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn vt cv cM cmin co cz vn cv
      vt cv cM cmin co wceq vm cv vn cv cle wbr vm cv vt cv cM cmin co cle wbr
      vn cv cF cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vt
      cv cM cmin co cF cfv cc wcel vt cv cM cmin co cF cfv cA cmin co cabs cfv
      vx cv clt wbr wa vn cv vt cv cM cmin co vm cv cle breq2 vn cv vt cv cM
      cmin co wceq vn cv cF cfv cc wcel vt cv cM cmin co cF cfv cc wcel vn cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr vt cv cM cmin co cF cfv cA cmin
      co cabs cfv vx cv clt wbr vn cv vt cv cM cmin co wceq vn cv cF cfv vt cv
      cM cmin co cF cfv cc vn cv vt cv cM cmin co cF fveq2 eleq1d vn cv vt cv
      cM cmin co wceq vn cv cF cfv cA cmin co cabs cfv vt cv cM cmin co cF cfv
      cA cmin co cabs cfv vx cv clt vn cv vt cv cM cmin co wceq vn cv cF cfv cA
      cmin co vt cv cM cmin co cF cfv cA cmin co cabs vn cv vt cv cM cmin co
      wceq vn cv cF cfv vt cv cM cmin co cF cfv cA cmin vn cv vt cv cM cmin co
      cF fveq2 opreq1d fveq2d breq1d anbi12d imbi12d rcla4v syl imp adantll
      sylbid imp vm cv cz wcel vt cv cz wcel wa vm cv vn cv cle wbr vn cv cF
      cfv cc wcel vn cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vn cz
      wral wa vm cv cM caddc co vt cv cle wbr wa vt cv cF cM cshi co cfv vt cv
      cM cmin co cF cfv wceq vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi
      co cfv cA cmin co cabs cfv vx cv clt wbr wa vt cv cM cmin co cF cfv cc
      wcel vt cv cM cmin co cF cfv cA cmin co cabs cfv vx cv clt wbr wa wb vm
      cv cz wcel vt cv cz wcel wa vt cv cF cM cshi co cfv vt cv cM cmin co cF
      cfv wceq vm cv vn cv cle wbr vn cv cF cfv cc wcel vn cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vn cz wral vm cv cM caddc co vt cv cle wbr
      vt cv cz wcel vt cv cF cM cshi co cfv vt cv cM cmin co cF cfv wceq vm cv
      cz wcel cM cz wcel vt cv cc wcel vt cv cF cM cshi co cfv vt cv cM cmin co
      cF cfv wceq vt cv cz wcel cM vt cv cz cF climshft.1 shftval climshft.2 vt
      cv zcn sylancr adantl ad2antrr vt cv cF cM cshi co cfv vt cv cM cmin co
      cF cfv wceq vt cv cF cM cshi co cfv cc wcel vt cv cM cmin co cF cfv cc
      wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr vt cv cM
      cmin co cF cfv cA cmin co cabs cfv vx cv clt wbr vt cv cF cM cshi co cfv
      vt cv cM cmin co cF cfv cc eleq1 vt cv cF cM cshi co cfv vt cv cM cmin co
      cF cfv wceq vt cv cF cM cshi co cfv cA cmin co cabs cfv vt cv cM cmin co
      cF cfv cA cmin co cabs cfv vx cv clt vt cv cF cM cshi co cfv vt cv cM
      cmin co cF cfv wceq vt cv cF cM cshi co cfv cA cmin co vt cv cM cmin co
      cF cfv cA cmin co cabs vt cv cF cM cshi co cfv vt cv cM cmin co cF cfv cA
      cmin opreq1 fveq2d breq1d anbi12d syl mpbird exp41 com23 r19.21adv vm cv
      cz wcel cM cz wcel vm cv cM caddc co cz wcel climshft.2 vm cv cM zaddcl
      mpan2 jctild vj cv vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF
      cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vm cv
      cM caddc co vt cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM
      cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cz wral vj vm cv
      cM caddc co cz vj cv vm cv cM caddc co wceq vj cv vt cv cle wbr vt cv cF
      cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv
      clt wbr wa wi vm cv cM caddc co vt cv cle wbr vt cv cF cM cshi co cfv cc
      wcel vt cv cF cM cshi co cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt
      cz vj cv vm cv cM caddc co wceq vj cv vt cv cle wbr vm cv cM caddc co vt
      cv cle wbr vt cv cF cM cshi co cfv cc wcel vt cv cF cM cshi co cfv cA
      cmin co cabs cfv vx cv clt wbr wa vj cv vm cv cM caddc co vt cv cle breq1
      imbi1d ralbidv rcla4ev syl6 r19.23aiv impbii imbi2i ralbii syl6bb vx cA
      vm vn cF cc0 cc0 cz cz 0z cc0 uzssz cz ssid 0z cc0 uzssz cz ssid
      climshft.1 clm2i bitr4d $.
      $( [15-Mar-2006] $) $( [16-Aug-2005] $)

    $( A function restricted to upper integers converges iff the original
       function converges. $)
    climresi $p |- ( A e. B ->
                        ( ( F |` ( ZZ>= ` M ) ) ~~> A <-> F ~~> A ) ) $=
      cA cB wcel cF cM cuz cfv cres cA cli wbr cF cA cli wbr cA cc wcel cA cB
      cF cM cuz cfv cres climcl cA cB cF climcl cA cc wcel cF cM cuz cfv cres
      cA cli wbr cc0 vx cv clt wbr vj cv vt cv cle wbr vt cv cF cfv cc wcel vt
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cM cuz cfv wral vj
      cz wrex wi vx cr wral cF cA cli wbr cA cc wcel cF cM cuz cfv cres cA cli
      wbr cc0 vx cv clt wbr vj cv vt cv cle wbr vt cv cF cM cuz cfv cres cfv cc
      wcel vt cv cF cM cuz cfv cres cfv cA cmin co cabs cfv vx cv clt wbr wa wi
      vt cM cuz cfv wral vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vt cv
      cle wbr vt cv cF cfv cc wcel vt cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wa wi vt cM cuz cfv wral vj cz wrex wi vx cr wral vx cA vj vt cF cM
      cuz cfv cres cc0 cM cM cuz cfv cz 0z cc0 uzssz cz ssid climshft.2 cM cuz
      cfv ssid cM uzssz cF cvv wcel cF cM cuz cfv cres cvv wcel climshft.1 cF
      cM cuz cfv cvv resexg ax-mp clm2i cc0 vx cv clt wbr vj cv vt cv cle wbr
      vt cv cF cM cuz cfv cres cfv cc wcel vt cv cF cM cuz cfv cres cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vt cM cuz cfv wral vj cz wrex wi cc0 vx
      cv clt wbr vj cv vt cv cle wbr vt cv cF cfv cc wcel vt cv cF cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vt cM cuz cfv wral vj cz wrex wi vx cr vj
      cv vt cv cle wbr vt cv cF cM cuz cfv cres cfv cc wcel vt cv cF cM cuz cfv
      cres cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cM cuz cfv wral vj cz
      wrex vj cv vt cv cle wbr vt cv cF cfv cc wcel vt cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vt cM cuz cfv wral vj cz wrex cc0 vx cv clt
      wbr vj cv vt cv cle wbr vt cv cF cM cuz cfv cres cfv cc wcel vt cv cF cM
      cuz cfv cres cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cM cuz cfv
      wral vj cv vt cv cle wbr vt cv cF cfv cc wcel vt cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa wi vt cM cuz cfv wral vj cz vj cv vt cv cle wbr
      vt cv cF cM cuz cfv cres cfv cc wcel vt cv cF cM cuz cfv cres cfv cA cmin
      co cabs cfv vx cv clt wbr wa wi vj cv vt cv cle wbr vt cv cF cfv cc wcel
      vt cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa wi vt cM cuz cfv vt cv
      cM cuz cfv wcel vt cv cF cM cuz cfv cres cfv cc wcel vt cv cF cM cuz cfv
      cres cfv cA cmin co cabs cfv vx cv clt wbr wa vt cv cF cfv cc wcel vt cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wa vj cv vt cv cle wbr vt cv cM
      cuz cfv wcel vt cv cF cM cuz cfv cres cfv cc wcel vt cv cF cfv cc wcel vt
      cv cF cM cuz cfv cres cfv cA cmin co cabs cfv vx cv clt wbr vt cv cF cfv
      cA cmin co cabs cfv vx cv clt wbr vt cv cM cuz cfv wcel vt cv cF cM cuz
      cfv cres cfv vt cv cF cfv cc vt cv cM cuz cfv cF fvres eleq1d vt cv cM
      cuz cfv wcel vt cv cF cM cuz cfv cres cfv cA cmin co cabs cfv vt cv cF
      cfv cA cmin co cabs cfv vx cv clt vt cv cM cuz cfv wcel vt cv cF cM cuz
      cfv cres cfv cA cmin co vt cv cF cfv cA cmin co cabs vt cv cM cuz cfv
      wcel vt cv cF cM cuz cfv cres cfv vt cv cF cfv cA cmin vt cv cM cuz cfv
      cF fvres opreq1d fveq2d breq1d anbi12d imbi2d ralbiia rexbii imbi2i
      ralbii syl6bb vx cA vj vt cF cc0 cM cM cuz cfv cz 0z cc0 uzssz cz ssid
      climshft.2 cM cuz cfv ssid cM uzssz climshft.1 clm2i bitr4d pm5.21nd $.
      $( [17-Nov-2007] $) $( [2-Jul-2006] $)
  $}

  ${
    $d F k $.  $d G k $.  $d K k $.  $d M k $.
    climshft2.1 $e |- F e. _V $.
    climshft2.2 $e |- G e. _V $.
    climshft2.3 $e |- M e. ZZ $.
    climshft2.4 $e |- K e. ZZ $.
    $( A shifted function converges iff the original function converges.
       (Contributed by Paul Chapman, 19-Nov-2007.) $)
    climshft2i $p |- ( ( A e. B /\ A. k e. ( ZZ>= ` M )
             ( G ` ( k + K ) ) = ( F ` k ) ) -> ( F ~~> A <-> G ~~> A ) ) $=
      cA cB wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq vk cM cuz cfv wral
      wa cF cA cli wbr cG cA cli wbr cA cc wcel vk cv cK caddc co cG cfv vk cv
      cF cfv wceq vk cM cuz cfv wral wa cA cB wcel cF cA cli wbr vk cv cK caddc
      co cG cfv vk cv cF cfv wceq vk cM cuz cfv wral cA cc wcel vk cv cK caddc
      co cG cfv vk cv cF cfv wceq vk cM cuz cfv wral wa cA cB wcel cF cA cli
      wbr wa cA cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq vk cM cuz
      cfv wral cA cB cF climcl anim1i an1rs cA cB wcel cG cA cli wbr vk cv cK
      caddc co cG cfv vk cv cF cfv wceq vk cM cuz cfv wral cA cc wcel vk cv cK
      caddc co cG cfv vk cv cF cfv wceq vk cM cuz cfv wral wa cA cB wcel cG cA
      cli wbr wa cA cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq vk cM
      cuz cfv wral cA cB cG climcl anim1i an1rs cA cc wcel vk cv cK caddc co cG
      cfv vk cv cF cfv wceq vk cM cuz cfv wral wa cG cK cneg cshi co cM cuz cfv
      cres cA cli wbr cF cc0 cshi co cM cuz cfv cres cA cli wbr cG cA cli wbr
      cF cA cli wbr vk cv cK caddc co cG cfv vk cv cF cfv wceq vk cM cuz cfv
      wral cG cK cneg cshi co cM cuz cfv cres cA cli wbr cF cc0 cshi co cM cuz
      cfv cres cA cli wbr wb cA cc wcel vk cv cK caddc co cG cfv vk cv cF cfv
      wceq vk cM cuz cfv wral cG cK cneg cshi co cM cuz cfv cres cF cc0 cshi co
      cM cuz cfv cres wceq cG cK cneg cshi co cM cuz cfv cres cA cli wbr cF cc0
      cshi co cM cuz cfv cres cA cli wbr wb cG cK cneg cshi co cM cuz cfv cres
      cF cc0 cshi co cM cuz cfv cres wceq vk cv cG cK cneg cshi co cfv vk cv cF
      cc0 cshi co cfv wceq vk cM cuz cfv wral vk cv cK caddc co cG cfv vk cv cF
      cfv wceq vk cM cuz cfv wral cG cK cneg cshi co cc wfn cF cc0 cshi co cc
      wfn cG cK cneg cshi co cM cuz cfv cres cF cc0 cshi co cM cuz cfv cres
      wceq vk cv cG cK cneg cshi co cfv vk cv cF cc0 cshi co cfv wceq vk cM cuz
      cfv wral wb cK cneg cz wcel cG cK cneg cshi co cc wfn cK cz wcel cK cneg
      cz wcel climshft2.4 cK znegcl ax-mp cK cneg cz cG climshft2.2 shftfn
      ax-mp cc0 cz wcel cF cc0 cshi co cc wfn 0z cc0 cz cF climshft2.1 shftfn
      ax-mp cG cK cneg cshi co cc wfn cF cc0 cshi co cc wfn wa cM cuz cfv cc
      wss cG cK cneg cshi co cM cuz cfv cres cF cc0 cshi co cM cuz cfv cres
      wceq vk cv cG cK cneg cshi co cfv vk cv cF cc0 cshi co cfv wceq vk cM cuz
      cfv wral wb cM cuz cfv cz cc cM uzssz zsscn sstri vk cc cM cuz cfv cG cK
      cneg cshi co cF cc0 cshi co fvreseq mpan2 mp2an vk cv cG cK cneg cshi co
      cfv vk cv cF cc0 cshi co cfv wceq vk cv cK caddc co cG cfv vk cv cF cfv
      wceq vk cM cuz cfv vk cv cM cuz cfv wcel vk cv cG cK cneg cshi co cfv vk
      cv cK caddc co cG cfv vk cv cF cc0 cshi co cfv vk cv cF cfv vk cv cM cuz
      cfv wcel vk cv cc wcel vk cv cG cK cneg cshi co cfv vk cv cK caddc co cG
      cfv wceq vk cv cM cuz cfv wcel vk cv cz wcel vk cv cc wcel cM vk cv
      eluzelz vk cv zcn syl vk cv cc wcel vk cv cG cK cneg cshi co cfv cK vk cv
      caddc co cG cfv vk cv cK caddc co cG cfv cK cc wcel vk cv cc wcel vk cv
      cG cK cneg cshi co cfv cK vk cv caddc co cG cfv wceq cK cK climshft2.4
      zrei recni cK vk cv cG climshft2.2 shftval4 mpan vk cv cc wcel cK vk cv
      caddc co vk cv cK caddc co cG cK cc wcel vk cv cc wcel cK vk cv caddc co
      vk cv cK caddc co wceq cK cK climshft2.4 zrei recni cK vk cv addcom mpan
      fveq2d eqtrd syl vk cv cM cuz cfv wcel vk cv cc wcel vk cv cF cc0 cshi co
      cfv vk cv cF cfv wceq vk cv cM cuz cfv wcel vk cv cz wcel vk cv cc wcel
      cM vk cv eluzelz vk cv zcn syl vk cv cF climshft2.1 shftidt syl eqeq12d
      ralbiia bitri cG cK cneg cshi co cM cuz cfv cres cF cc0 cshi co cM cuz
      cfv cres cA cli breq1 sylbir adantl cA cc wcel cG cK cneg cshi co cM cuz
      cfv cres cA cli wbr cG cA cli wbr wb vk cv cK caddc co cG cfv vk cv cF
      cfv wceq vk cM cuz cfv wral cA cc wcel cG cK cneg cshi co cM cuz cfv cres
      cA cli wbr cG cK cneg cshi co cA cli wbr cG cA cli wbr cA cc cG cK cneg
      cshi co cM cG cK cneg cshi oprex climshft2.3 climresi cA cG cK cneg
      climshft2.2 cK cz wcel cK cneg cz wcel climshft2.4 cK znegcl ax-mp
      climshfti bitrd adantr cA cc wcel cF cc0 cshi co cM cuz cfv cres cA cli
      wbr cF cA cli wbr wb vk cv cK caddc co cG cfv vk cv cF cfv wceq vk cM cuz
      cfv wral cA cc wcel cF cc0 cshi co cM cuz cfv cres cA cli wbr cF cc0 cshi
      co cA cli wbr cF cA cli wbr cA cc cF cc0 cshi co cM cF cc0 cshi oprex
      climshft2.3 climresi cA cF cc0 climshft2.1 0z climshfti bitrd adantr
      3bitr3rd pm5.21nd $.
      $( [19-Nov-2007] $) $( [21-Nov-2007] $)
  $}

  ${
    $d F k m n x $.  $d G k m n x $.  $d K k m n x $.  $d M k m n x $.
    iserzshft2.1 $e |- F e. _V $.
    iserzshft2.2 $e |- G e. _V $.
    iserzshft2.3 $e |- M e. ZZ $.
    iserzshft2.4 $e |- K e. ZZ $.
    $( Index shift of an infinite series.  (Contributed by Paul Chapman,
       19-Nov-2007.) $)
    iserzshft2i $p |- ( ( A e. B /\ A. k e. ( ZZ>= ` M )
                     ( ( F ` k ) e. CC /\ ( G ` ( k + K ) ) = ( F ` k ) ) ) ->
   ( ( <. M , + >. seq F ) ~~> A <-> ( <. ( M + K ) , + >. seq G ) ~~> A ) ) $=
      cA cB wcel vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv
      wceq wa vk cM cuz cfv wral wa cM caddc cop cF cseqz co cA cli wbr cM cK
      caddc co caddc cop cG cseqz co cA cli wbr cA cc wcel vk cv cF cfv cc wcel
      vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral wa cA cB
      wcel cM caddc cop cF cseqz co cA cli wbr vk cv cF cfv cc wcel vk cv cK
      caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral cA cc wcel vk cv
      cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz
      cfv wral wa cA cB wcel cM caddc cop cF cseqz co cA cli wbr wa cA cc wcel
      vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM
      cuz cfv wral cA cB cM caddc cop cF cseqz co climcl anim1i an1rs cA cB
      wcel cM cK caddc co caddc cop cG cseqz co cA cli wbr vk cv cF cfv cc wcel
      vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral cA cc
      wcel vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa
      vk cM cuz cfv wral wa cA cB wcel cM cK caddc co caddc cop cG cseqz co cA
      cli wbr wa cA cc wcel vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv
      cF cfv wceq wa vk cM cuz cfv wral cA cB cM cK caddc co caddc cop cG cseqz
      co climcl anim1i an1rs cA cc wcel vk cv cF cfv cc wcel vk cv cK caddc co
      cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral cM caddc cop cF cseqz co
      cA cli wbr cM cK caddc co caddc cop cG cseqz co cA cli wbr wb cA cc wcel
      vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM
      cuz cfv wral cM caddc cop cF cseqz co cA cli wbr cM cK caddc co caddc cop
      cG cseqz co cA cli wbr wb wi vk cv cF cfv cc wcel vk cv cK caddc co cG
      cfv vk cv cF cfv wceq wa vk cM cuz cfv wral cM caddc cop cF cseqz co cA
      cc wcel cA cc0 cif cli wbr cM cK caddc co caddc cop cG cseqz co cA cc
      wcel cA cc0 cif cli wbr wb wi cA cc0 cA cA cc wcel cA cc0 cif wceq cM
      caddc cop cF cseqz co cA cli wbr cM cK caddc co caddc cop cG cseqz co cA
      cli wbr wb cM caddc cop cF cseqz co cA cc wcel cA cc0 cif cli wbr cM cK
      caddc co caddc cop cG cseqz co cA cc wcel cA cc0 cif cli wbr wb vk cv cF
      cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv
      wral cA cA cc wcel cA cc0 cif wceq cM caddc cop cF cseqz co cA cli wbr cM
      caddc cop cF cseqz co cA cc wcel cA cc0 cif cli wbr cM cK caddc co caddc
      cop cG cseqz co cA cli wbr cM cK caddc co caddc cop cG cseqz co cA cc
      wcel cA cc0 cif cli wbr cA cA cc wcel cA cc0 cif cM caddc cop cF cseqz co
      cli breq2 cA cA cc wcel cA cc0 cif cM cK caddc co caddc cop cG cseqz co
      cli breq2 bibi12d imbi2d cA cc wcel cA cc0 cif cc wcel vm cv cK caddc co
      cM cK caddc co caddc cop cG cseqz co cfv vm cv cM caddc cop cF cseqz co
      cfv wceq vm cM cuz cfv wral cM caddc cop cF cseqz co cA cc wcel cA cc0
      cif cli wbr cM cK caddc co caddc cop cG cseqz co cA cc wcel cA cc0 cif
      cli wbr wb vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv
      wceq wa vk cM cuz cfv wral cA cc wcel cA cc0 cif cc vm cM caddc cop cF
      cseqz co cM cK caddc co caddc cop cG cseqz co cK cM cM caddc cop cF cseqz
      oprex cM cK caddc co caddc cop cG cseqz oprex iserzshft2.3 iserzshft2.4
      climshft2i cA cc0 cc 0cn elimel vk cv cF cfv cc wcel vk cv cK caddc co cG
      cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vm cv cK caddc co cM cK caddc
      co caddc cop cG cseqz co cfv vm cv cM caddc cop cF cseqz co cfv wceq vm
      cM cuz cfv vm cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cK caddc co
      cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vm cv cK caddc co cM cK
      caddc co caddc cop cG cseqz co cfv vm cv cM caddc cop cF cseqz co cfv
      wceq vm cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cK caddc co cG cfv
      vk cv cF cfv wceq wa vk cM cuz cfv wral wa cM vm cv cfz co vk cv cF cfv
      vk csu cM cK caddc co vm cv cK caddc co cfz co vn cv cG cfv vn csu vm cv
      cM caddc cop cF cseqz co cfv vm cv cK caddc co cM cK caddc co caddc cop
      cG cseqz co cfv vm cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cK caddc
      co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral wa cM vm cv cfz co vk
      cv cF cfv vk csu cM cK caddc co vm cv cK caddc co cfz co vk vn cv cK cmin
      co vk cv cF cfv csb vn csu cM cK caddc co vm cv cK caddc co cfz co vn cv
      cG cfv vn csu vm cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM vm cv cfz
      co wral cM vm cv cfz co vk cv cF cfv vk csu cM cK caddc co vm cv cK caddc
      co cfz co vk vn cv cK cmin co vk cv cF cfv csb vn csu wceq vk cv cF cfv
      cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral
      vm cv cM cuz cfv wcel cK cz wcel vk cv cF cfv cc wcel vk cM vm cv cfz co
      wral cM vm cv cfz co vk cv cF cfv vk csu cM cK caddc co vm cv cK caddc co
      cfz co vk vn cv cK cmin co vk cv cF cfv csb vn csu wceq iserzshft2.4 vk
      cv cF cfv vk vn cK cM vm cv fsumshft mp3an2 vk cv cF cfv cc wcel vk cv cK
      caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vk cv cF cfv cc
      wcel vk cM cuz cfv wral vk cv cF cfv cc wcel vk cM vm cv cfz co wral vk
      cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz
      cfv wral vk cv cF cfv cc wcel vk cM cuz cfv wral vk cv cK caddc co cG cfv
      vk cv cF cfv wceq vk cM cuz cfv wral vk cv cF cfv cc wcel vk cv cK caddc
      co cG cfv vk cv cF cfv wceq vk cM cuz cfv r19.26 pm3.26bi vk cv cF cfv cc
      wcel vk cv cF cfv cc wcel vk cM cuz cfv cM vm cv cfz co vk cv cM vm cv
      cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cM vm cv
      elfzuz imim1i r19.20i2 syl sylan2 vk cv cF cfv cc wcel vk cv cK caddc co
      cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral cM cK caddc co vm cv cK
      caddc co cfz co vn cv cG cfv vn csu cM cK caddc co vm cv cK caddc co cfz
      co vk vn cv cK cmin co vk cv cF cfv csb vn csu wceq vm cv cM cuz cfv wcel
      vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM
      cuz cfv wral cM cK caddc co vm cv cK caddc co cfz co vn cv cG cfv vk vn
      cv cK cmin co vk cv cF cfv csb vn vk cv cF cfv cc wcel vk cv cK caddc co
      cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vn cv cM cK caddc co cuz
      cfv wcel vn cv cG cfv vk vn cv cK cmin co vk cv cF cfv csb wceq vn cv cM
      cK caddc co vm cv cK caddc co cfz co wcel vk cv cF cfv cc wcel vk cv cK
      caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vn cv cM cK caddc
      co cuz cfv wcel wa vn cv cG cfv vn cv cK cmin co cF cfv vk vn cv cK cmin
      co vk cv cF cfv csb vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv
      cF cfv wceq wa vk cM cuz cfv wral vn cv cM cK caddc co cuz cfv wcel wa vn
      cv cK cmin co cK caddc co cG cfv vn cv cG cfv vn cv cK cmin co cF cfv vn
      cv cM cK caddc co cuz cfv wcel vn cv cK cmin co cK caddc co cG cfv vn cv
      cG cfv wceq vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv
      wceq wa vk cM cuz cfv wral vn cv cM cK caddc co cuz cfv wcel vn cv cK
      cmin co cK caddc co vn cv cG vn cv cc wcel cK cc wcel vn cv cK cmin co cK
      caddc co vn cv wceq vn cv cM cK caddc co cuz cfv wcel vn cv cK npcan vn
      cv cM cK caddc co cuz cfv wcel vn cv cz wcel vn cv cc wcel cM cK caddc co
      vn cv eluzelz vn cv zcn syl cK cK iserzshft2.4 zrei recni sylancl fveq2d
      adantl vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa
      vk cM cuz cfv wral vn cv cM cK caddc co cuz cfv wcel wa vn cv cK cmin co
      cF cfv cc wcel vn cv cK cmin co cK caddc co cG cfv vn cv cK cmin co cF
      cfv wceq vn cv cM cK caddc co cuz cfv wcel vk cv cF cfv cc wcel vk cv cK
      caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vn cv cK cmin co
      cF cfv cc wcel vn cv cK cmin co cK caddc co cG cfv vn cv cK cmin co cF
      cfv wceq wa vn cv cM cK caddc co cuz cfv wcel vn cv cK cmin co cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa
      vk cM cuz cfv wral vn cv cK cmin co cF cfv cc wcel vn cv cK cmin co cK
      caddc co cG cfv vn cv cK cmin co cF cfv wceq wa wi cK cM vn cv
      iserzshft2.3 iserzshft2.4 eluzsubi vk cv cF cfv cc wcel vk cv cK caddc co
      cG cfv vk cv cF cfv wceq wa vn cv cK cmin co cF cfv cc wcel vn cv cK cmin
      co cK caddc co cG cfv vn cv cK cmin co cF cfv wceq wa vk vn cv cK cmin co
      cM cuz cfv vk cv vn cv cK cmin co wceq vk cv cF cfv cc wcel vn cv cK cmin
      co cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq vn cv cK
      cmin co cK caddc co cG cfv vn cv cK cmin co cF cfv wceq vk cv vn cv cK
      cmin co wceq vk cv cF cfv vn cv cK cmin co cF cfv cc vk cv vn cv cK cmin
      co cF fveq2 eleq1d vk cv vn cv cK cmin co wceq vk cv cK caddc co cG cfv
      vn cv cK cmin co cK caddc co cG cfv vk cv cF cfv vn cv cK cmin co cF cfv
      vk cv vn cv cK cmin co wceq vk cv cK caddc co vn cv cK cmin co cK caddc
      co cG vk cv vn cv cK cmin co cK caddc opreq1 fveq2d vk cv vn cv cK cmin
      co cF fveq2 eqeq12d anbi12d rcla4v syl impcom pm3.27d eqtr3d vk vx vn cv
      cK cmin co vk cv cF cfv vn cv cK cmin co cF cfv vn cv cK cmin oprex vx cv
      vn cv cK cmin co cF cfv wcel vk ax-17 vk cv vn cv cK cmin co cF fveq2
      csbief syl6eqr vn cv cM cK caddc co vm cv cK caddc co elfzuz sylan2
      sumeq2dv adantl eqtr4d vm cv cM cuz cfv wcel cM vm cv cfz co vk cv cF cfv
      vk csu vm cv cM caddc cop cF cseqz co cfv wceq vk cv cF cfv cc wcel vk cv
      cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vk cF cM vm cv
      iserzshft2.1 fsumserz adantr vm cv cM cuz cfv wcel cM cK caddc co vm cv
      cK caddc co cfz co vn cv cG cfv vn csu vm cv cK caddc co cM cK caddc co
      caddc cop cG cseqz co cfv wceq vk cv cF cfv cc wcel vk cv cK caddc co cG
      cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vm cv cM cuz cfv wcel vm cv
      cK caddc co cM cK caddc co cuz cfv wcel cM cK caddc co vm cv cK caddc co
      cfz co vn cv cG cfv vn csu vm cv cK caddc co cM cK caddc co caddc cop cG
      cseqz co cfv wceq cK cM vm cv iserzshft2.3 iserzshft2.4 eluzaddi vn cG cM
      cK caddc co vm cv cK caddc co iserzshft2.2 fsumserz syl adantr 3eqtr3rd
      expcom r19.21aiv sylancr dedth imp pm5.21nd $.
      $( [21-Nov-2007] $) $( [19-Nov-2007] $)
  $}

  ${
    climuz0.1 $e |- M e. ZZ $.
    $( A zero sequence converges to zero. $)
    climuz0i $p |- ( ( ZZ>= ` M ) X. { 0 } ) ~~> 0 $=
      cM cuz cfv cc0 csn cxp cc0 cli wbr cz cc0 csn cxp cc0 cli wbr clim0 cM
      cuz cfv cc0 csn cxp cc0 cli wbr cz cc0 csn cxp cM cuz cfv cres cc0 cli
      wbr cz cc0 csn cxp cc0 cli wbr cz cc0 csn cxp cM cuz cfv cres cM cuz cfv
      cc0 csn cxp cc0 cli cz cc0 csn cxp cM cuz cfv cc0 csn cxp cdm cres cz cc0
      csn cxp cM cuz cfv cres cM cuz cfv cc0 csn cxp cM cuz cfv cc0 csn cxp cdm
      cM cuz cfv wceq cz cc0 csn cxp cM cuz cfv cc0 csn cxp cdm cres cz cc0 csn
      cxp cM cuz cfv cres wceq cc0 csn c0 wne cM cuz cfv cc0 csn cxp cdm cM cuz
      cfv wceq cc0 cc0 cc 0cn elisseti snnz cM cuz cfv cc0 csn dmxp ax-mp cM
      cuz cfv cc0 csn cxp cdm cM cuz cfv cz cc0 csn cxp reseq2 ax-mp cz cc0 csn
      cxp wfun cM cuz cfv cc0 csn cxp cz cc0 csn cxp wss cz cc0 csn cxp cM cuz
      cfv cc0 csn cxp cdm cres cM cuz cfv cc0 csn cxp wceq cz cc0 csn cz cc0
      csn cxp wf cz cc0 csn cxp wfun cz cc0 cc0 cc 0cn elisseti fconst cz cc0
      csn cz cc0 csn cxp ffun ax-mp cM cuz cfv cz wss cc0 csn cc0 csn wss cM
      cuz cfv cc0 csn cxp cz cc0 csn cxp wss cM uzssz cc0 csn ssid cM cuz cfv
      cz cc0 csn cc0 csn ssxp mp2an cz cc0 csn cxp cM cuz cfv cc0 csn cxp
      funssres mp2an eqtr3i breq1i cc0 cvv wcel cz cc0 csn cxp cM cuz cfv cres
      cc0 cli wbr cz cc0 csn cxp cc0 cli wbr wb cc0 cc 0cn elisseti cc0 cvv cz
      cc0 csn cxp cM cz cc0 csn zex cc0 snex xpex climuz0.1 climresi ax-mp
      bitr3i mpbir $.
      $( [17-Nov-2007] $) $( [2-Jul-2006] $)
  $}

  ${
    $d M k n y z $.
    $( The zero series converges to zero.  (Contributed by Paul Chapman,
       9-Feb-2007.) $)
    serzclim0 $p |- ( M e. ZZ ->
                      ( <. M , + >. seq ( ( ZZ>= ` M ) X. { 0 } ) ) ~~> 0 ) $=
      cM cz wcel cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cM cuz cfv cc0
      csn cxp cc0 cli vy vz cc0 vk vn cM cuz cfv cc0 csn cxp cM cuz cfv cc0 csn
      cxp cM cc0 cc 0cn elisseti vk vy cM cuz cfv cc0 fconstopab cM cuz cfv cc0
      csn cxp vn cv cM cuz cfv wcel vz cv cc0 wceq wa vn vz copab vn cv cM cuz
      cfv wcel vz cv cM vn cv cfz co cc0 vk csu wceq wa vn vz copab vn vz cM
      cuz cfv cc0 fconstopab vn cv cM cuz cfv wcel vz cv cM vn cv cfz co cc0 vk
      csu wceq wa vn cv cM cuz cfv wcel vz cv cc0 wceq wa vn vz vn cv cM cuz
      cfv wcel vz cv cM vn cv cfz co cc0 vk csu wceq vz cv cc0 wceq vn cv cM
      cuz cfv wcel cM vn cv cfz co cc0 vk csu cc0 vz cv vk cM vn cv fsum0
      eqeq2d pm5.32i opabbii eqtr4i serzfsum cM cz wcel cM cuz cfv cc0 csn cxp
      cc0 cli wbr cM cz wcel cM cc0 cif cuz cfv cc0 csn cxp cc0 cli wbr cM cc0
      cM cM cz wcel cM cc0 cif wceq cM cuz cfv cc0 csn cxp cM cz wcel cM cc0
      cif cuz cfv cc0 csn cxp cc0 cli cM cM cz wcel cM cc0 cif wceq cM cuz cfv
      cM cz wcel cM cc0 cif cuz cfv wceq cM cuz cfv cc0 csn cxp cM cz wcel cM
      cc0 cif cuz cfv cc0 csn cxp wceq cM cM cz wcel cM cc0 cif cuz fveq2 cM
      cuz cfv cM cz wcel cM cc0 cif cuz cfv cc0 csn xpeq1 syl breq1d cM cz wcel
      cM cc0 cif cM cc0 cz 0z elimel climuz0i dedth eqbrtrd $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d j m A $.  $d j k m F $.  $d j k m M $.
    climrecl.1 $e |- A e. _V $.
    $( The limit of a convergent real sequence is real.  Corollary 12-2.5 of
       [Gleason] p. 172. $)
    climrecl $p |- ( ( M e. ZZ /\ F ~~> A /\
                      A. k e. ( ZZ>= ` M ) ( F ` k ) e. RR ) -> A e. RR ) $=
      cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral w3a cA
      cc wcel cA cr wcel cF cA cli wbr cM cz wcel cA cc wcel vk cv cF cfv cr
      wcel vk cM cuz cfv wral cA cvv wcel cF cA cli wbr cA cc wcel climrecl.1
      cA cvv cF climcl mpan 3ad2ant2 cM cz wcel cF cA cli wbr vk cv cF cfv cr
      wcel vk cM cuz cfv wral w3a cA cc wcel wa cA cr wcel cA cim cfv cc0 wceq
      cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral w3a cA
      cc wcel wa cA cim cfv cabs cfv cc0 wceq cA cim cfv cc0 wceq cM cz wcel cF
      cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral w3a cA cc wcel wa cc0
      cA cim cfv cabs cfv cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cM
      cuz cfv wral w3a cA cc wcel wa cc0 cA cim cfv cabs cfv wceq cc0 cA cim
      cfv cabs cfv cle wbr cc0 cA cim cfv cabs cfv clt wbr wn wa cM cz wcel cF
      cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral w3a cA cc wcel wa cc0
      cA cim cfv cabs cfv cle wbr cc0 cA cim cfv cabs cfv clt wbr wn cA cc wcel
      cc0 cA cim cfv cabs cfv cle wbr cM cz wcel cF cA cli wbr vk cv cF cfv cr
      wcel vk cM cuz cfv wral w3a cA cc wcel cA cim cfv cc wcel cc0 cA cim cfv
      cabs cfv cle wbr cA cc wcel cA cim cfv cA imcl recnd cA cim cfv absge0
      syl adantl cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv
      wral w3a cA cc wcel wa cc0 cA cim cfv cabs cfv clt wbr vj cv vm cv cle
      wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi vm cz
      wral vj cM cuz cfv wrex vk cv cF cfv cr wcel vk cM cuz cfv wral cM cz
      wcel cA cc wcel vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA
      cim cfv cabs cfv clt wbr wi vm cz wral vj cM cuz cfv wrex wn cF cA cli
      wbr vk cv cF cfv cr wcel vk cM cuz cfv wral cA cc wcel wa vj cv vm cv cle
      wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi vm cz
      wral vj cM cuz cfv vk cv cF cfv cr wcel vk cM cuz cfv wral vj cv cM cuz
      cfv wcel cA cc wcel vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv
      cA cim cfv cabs cfv clt wbr wi vm cz wral wn vj cv cF cfv cr wcel vj cv
      cM cuz cfv wcel wa cA cc wcel vj cv vm cv cle wbr vm cv cF cfv cA cmin co
      cabs cfv cA cim cfv cabs cfv clt wbr wi vm cz wral wn vk cv cF cfv cr
      wcel vk cM cuz cfv wral vj cv cM cuz cfv wcel wa vj cv cF cfv cr wcel vj
      cv cM cuz cfv wcel wa cA cc wcel wa vj cv vm cv cle wbr vm cv cF cfv cA
      cmin co cabs cfv cA cim cfv cabs cfv clt wbr wn wa vm cz wrex vj cv vm cv
      cle wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi
      vm cz wral wn vj cv cz wcel vj cv vj cv cle wbr vj cv cF cfv cA cmin co
      cabs cfv cA cim cfv cabs cfv clt wbr wn wa vj cv vm cv cle wbr vm cv cF
      cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wn wa vm cz wrex vj
      cv cF cfv cr wcel vj cv cM cuz cfv wcel wa cA cc wcel wa vj cv vm cv cle
      wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wn wa vj
      cv vj cv cle wbr vj cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt
      wbr wn wa vm vj cv cz vm cv vj cv wceq vj cv vm cv cle wbr vj cv vj cv
      cle wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wn
      vj cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wn vm cv vj
      cv vj cv cle breq2 vm cv vj cv wceq vm cv cF cfv cA cmin co cabs cfv cA
      cim cfv cabs cfv clt wbr vj cv cF cfv cA cmin co cabs cfv cA cim cfv cabs
      cfv clt wbr vm cv vj cv wceq vm cv cF cfv cA cmin co cabs cfv vj cv cF
      cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt vm cv vj cv wceq vm cv cF
      cfv cA cmin co vj cv cF cfv cA cmin co cabs vm cv vj cv wceq vm cv cF cfv
      vj cv cF cfv cA cmin vm cv vj cv cF fveq2 opreq1d fveq2d breq1d notbid
      anbi12d rcla4ev vj cv cM cuz cfv wcel vj cv cz wcel vj cv cF cfv cr wcel
      cA cc wcel cM vj cv eluzelz ad2antlr vj cv cF cfv cr wcel vj cv cM cuz
      cfv wcel wa cA cc wcel wa vj cv vj cv cle wbr vj cv cF cfv cA cmin co
      cabs cfv cA cim cfv cabs cfv clt wbr wn vj cv cM cuz cfv wcel vj cv vj cv
      cle wbr vj cv cF cfv cr wcel cA cc wcel vj cv cM cuz cfv wcel vj cv cz
      wcel vj cv cr wcel vj cv vj cv cle wbr cM vj cv eluzelz vj cv zre vj cv
      leid 3syl ad2antlr vj cv cF cfv cr wcel cA cc wcel vj cv cF cfv cA cmin
      co cabs cfv cA cim cfv cabs cfv clt wbr wn vj cv cM cuz cfv wcel vj cv cF
      cfv cr wcel cA cc wcel wa cA cim cfv cabs cfv vj cv cF cfv cA cmin co
      cabs cfv cle wbr vj cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt
      wbr wn vj cv cF cfv cr wcel cA cc wcel wa cA cim cfv cabs cfv vj cv cF
      cfv cA cmin co cim cfv cabs cfv vj cv cF cfv cA cmin co cabs cfv cle vj
      cv cF cfv cr wcel cA cc wcel wa cA cim cfv cneg cabs cfv cA cim cfv cabs
      cfv vj cv cF cfv cA cmin co cim cfv cabs cfv cA cc wcel cA cim cfv cneg
      cabs cfv cA cim cfv cabs cfv wceq vj cv cF cfv cr wcel cA cc wcel cA cim
      cfv cc wcel cA cim cfv cneg cabs cfv cA cim cfv cabs cfv wceq cA cc wcel
      cA cim cfv cA imcl recnd cA cim cfv absneg syl adantl vj cv cF cfv cr
      wcel cA cc wcel wa cA cim cfv cneg vj cv cF cfv cA cmin co cim cfv cabs
      vj cv cF cfv cr wcel cA cc wcel wa cA cim cfv cneg vj cv cF cfv cim cfv
      cA cim cfv cmin co vj cv cF cfv cA cmin co cim cfv vj cv cF cfv cr wcel
      cA cim cfv cneg vj cv cF cfv cim cfv cA cim cfv cmin co wceq cA cc wcel
      vj cv cF cfv cr wcel vj cv cF cfv cim cfv cA cim cfv cmin co cc0 cA cim
      cfv cmin co cA cim cfv cneg vj cv cF cfv cr wcel vj cv cF cfv cim cfv cc0
      cA cim cfv cmin vj cv cF cfv reim0 opreq1d cA cim cfv df-neg syl6reqr
      adantr vj cv cF cfv cc wcel cA cc wcel vj cv cF cfv cA cmin co cim cfv vj
      cv cF cfv cim cfv cA cim cfv cmin co wceq vj cv cF cfv cr wcel vj cv cF
      cfv cA imsub vj cv cF cfv recn sylan eqtr4d fveq2d eqtr3d vj cv cF cfv cr
      wcel cA cc wcel wa vj cv cF cfv cA cmin co cc wcel vj cv cF cfv cA cmin
      co cim cfv cabs cfv vj cv cF cfv cA cmin co cabs cfv cle wbr vj cv cF cfv
      cc wcel cA cc wcel vj cv cF cfv cA cmin co cc wcel vj cv cF cfv cr wcel
      vj cv cF cfv cA subcl vj cv cF cfv recn sylan vj cv cF cfv cA cmin co
      absimle syl eqbrtrd cA cim cfv cabs cfv cr wcel vj cv cF cfv cA cmin co
      cabs cfv cr wcel cA cim cfv cabs cfv vj cv cF cfv cA cmin co cabs cfv cle
      wbr vj cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wn wb vj
      cv cF cfv cr wcel cA cc wcel wa cA cim cfv cabs cfv vj cv cF cfv cA cmin
      co cabs cfv lenlt cA cc wcel cA cim cfv cabs cfv cr wcel vj cv cF cfv cr
      wcel cA cc wcel cA cim cfv cc wcel cA cim cfv cabs cfv cr wcel cA cc wcel
      cA cim cfv cA imcl recnd cA cim cfv abscl syl adantl vj cv cF cfv cr wcel
      cA cc wcel wa vj cv cF cfv cA cmin co cc wcel vj cv cF cfv cA cmin co
      cabs cfv cr wcel vj cv cF cfv cc wcel cA cc wcel vj cv cF cfv cA cmin co
      cc wcel vj cv cF cfv cr wcel vj cv cF cfv cA subcl vj cv cF cfv recn
      sylan vj cv cF cfv cA cmin co abscl syl sylanc mpbid adantlr jca sylanc
      vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv
      clt wbr vm cz rexanali sylib vk cv cF cfv cr wcel vk cM cuz cfv wral vj
      cv cM cuz cfv wcel wa vj cv cF cfv cr wcel vj cv cM cuz cfv wcel vk cv cF
      cfv cr wcel vj cv cF cfv cr wcel vk vj cv cM cuz cfv vk cv vj cv wceq vk
      cv cF cfv vj cv cF cfv cr vk cv vj cv cF fveq2 eleq1d rcla4cva vk cv cF
      cfv cr wcel vk cM cuz cfv wral vj cv cM cuz cfv wcel pm3.27 jca sylan
      an1rs nrexdv 3ad2antl3 cM cz wcel cF cA cli wbr cA cc wcel cc0 cA cim cfv
      cabs cfv clt wbr vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA
      cim cfv cabs cfv clt wbr wi vm cz wral vj cM cuz cfv wrex wi vk cv cF cfv
      cr wcel vk cM cuz cfv wral cM cz wcel cA cc wcel cF cA cli wbr cc0 cA cim
      cfv cabs cfv clt wbr vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv
      cA cim cfv cabs cfv clt wbr wi vm cz wral vj cM cuz cfv wrex wi cM cz
      wcel cA cc wcel cF cA cli wbr cc0 cA cim cfv cabs cfv clt wbr vj cv vm cv
      cle wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi
      vm cz wral vj cM cuz cfv wrex wi cM cz wcel cA cc wcel cF cA cli wbr wa
      wa cA cim cfv cabs cfv cr wcel cc0 cA cim cfv cabs cfv clt wbr vj cv vm
      cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr
      wi vm cz wral vj cM cuz cfv wrex wi cA cc wcel cA cim cfv cabs cfv cr
      wcel cM cz wcel cF cA cli wbr cA cc wcel cA cim cfv cc wcel cA cim cfv
      cabs cfv cr wcel cA cc wcel cA cim cfv cA imcl recnd cA cim cfv abscl syl
      ad2antrl cM cz wcel cA cc wcel cF cA cli wbr wa wa cA cim cfv cabs cfv cr
      wcel wa cc0 cA cim cfv cabs cfv clt wbr vj cv vm cv cle wbr vm cv cF cfv
      cA cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi vm cz wral vj cM cuz
      cfv wrex cM cz wcel cA cc wcel cF cA cli wbr wa wa cA cim cfv cabs cfv cr
      wcel cc0 cA cim cfv cabs cfv clt wbr vj cv vm cv cle wbr vm cv cF cfv cA
      cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi vm cz wral vj cM cuz cfv
      wrex cM cz wcel cA cc wcel cF cA cli wbr wa cA cim cfv cabs cfv cr wcel
      cc0 cA cim cfv cabs cfv clt wbr wa vj cv vm cv cle wbr vm cv cF cfv cA
      cmin co cabs cfv cA cim cfv cabs cfv clt wbr wi vm cz wral vj cM cuz cfv
      wrex cA cA cim cfv cabs cfv cc vj vm cF cM clmi2a anassrs anassrs ex
      mpdan anassrs an1rs 3adantl3 mtod jca cA cc wcel cc0 cA cim cfv cabs cfv
      wceq cc0 cA cim cfv cabs cfv cle wbr cc0 cA cim cfv cabs cfv clt wbr wn
      wa wb cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral
      w3a cc0 cr wcel cA cim cfv cabs cfv cr wcel cc0 cA cim cfv cabs cfv wceq
      cc0 cA cim cfv cabs cfv cle wbr cc0 cA cim cfv cabs cfv clt wbr wn wa wb
      cA cc wcel cc0 cA cim cfv cabs cfv eqlelt 0re cA cc wcel cA cim cfv cc
      wcel cA cim cfv cabs cfv cr wcel cA cc wcel cA cim cfv cA imcl recnd cA
      cim cfv abscl syl sylancr adantl mpbird eqcomd cA cc wcel cA cim cfv cabs
      cfv cc0 wceq cA cim cfv cc0 wceq wb cM cz wcel cF cA cli wbr vk cv cF cfv
      cr wcel vk cM cuz cfv wral w3a cA cc wcel cA cim cfv cc wcel cA cim cfv
      cabs cfv cc0 wceq cA cim cfv cc0 wceq wb cA cc wcel cA cim cfv cA imcl
      recnd cA cim cfv abs00 syl adantl mpbid cA cc wcel cA cr wcel cA cim cfv
      cc0 wceq wb cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv
      wral w3a cA reim0b adantl mpbird mpdan $.
      $( [2-Dec-2005] $) $( [10-Sep-2005] $)
  $}

  ${
    $d k F $.
    climfnrcl.1 $e |- A e. _V $.
    climfnrcl.2 $e |- F : NN --> RR $.
    climfnrcl.3 $e |- F ~~> A $.
    $( The limit of a convergent real sequence on natural numbers is real.
       Corollary 12-2.5 of [Gleason] p. 172. $)
    climfnrcli $p |- A e. RR $=
      c1 cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk c1 cuz cfv wral cA cr
      wcel 1z climfnrcl.3 vk cv cF cfv cr wcel vk c1 cuz cfv vk cv c1 cuz cfv
      wcel vk cv cn wcel vk cv cF cfv cr wcel vk cv elnnuz cn cr vk cv cF
      climfnrcl.2 ffvelrni sylbir rgen cA vk cF c1 climfnrcl.1 climrecl mp3an
      $.
      $( [6-Jun-2006] $) $( [5-Jun-2006] $)
  $}

  ${
    $d j m A $.  $d j k m F $.  $d j k m M $.
    climge0.1 $e |- A e. _V $.
    $( A nonnegative sequence converges to a nonnegative number. $)
    climge0 $p |- ( ( M e. ZZ /\ F ~~> A /\ A. k e. ( ZZ>= ` M )
                     ( ( F ` k ) e. RR /\ 0 <_ ( F ` k ) ) ) -> 0 <_ A ) $=
      cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa
      vk cM cuz cfv wral w3a cA cr wcel cc0 cA cle wbr cM cz wcel cF cA cli wbr
      vk cv cF cfv cr wcel vk cM cuz cfv wral cA cr wcel vk cv cF cfv cr wcel
      cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv wral cA vk cF cM climge0.1
      climrecl vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cv cF cfv cr
      wcel vk cM cuz cfv vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr pm3.26
      r19.20si syl3an3 cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel cc0 vk cv
      cF cfv cle wbr wa vk cM cuz cfv wral w3a cA cr wcel wa cc0 cA cle wbr cA
      cc0 clt wbr wn cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel cc0 vk cv cF
      cfv cle wbr wa vk cM cuz cfv wral w3a cA cr wcel wa cA cc0 clt wbr vj cv
      vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm cz
      wral vj cM cuz cfv wrex cM cz wcel cF cA cli wbr cA cr wcel cA cc0 clt
      wbr vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr
      wi vm cz wral vj cM cuz cfv wrex wi vk cv cF cfv cr wcel cc0 vk cv cF cfv
      cle wbr wa vk cM cuz cfv wral cM cz wcel cF cA cli wbr wa cA cr wcel wa
      cA cc0 clt wbr cc0 cA cneg clt wbr vj cv vm cv cle wbr vm cv cF cfv cA
      cmin co cabs cfv cA cneg clt wbr wi vm cz wral vj cM cuz cfv wrex cA cr
      wcel cA cc0 clt wbr cc0 cA cneg clt wbr wb cM cz wcel cF cA cli wbr wa cA
      lt0neg1 adantl cM cz wcel cF cA cli wbr wa cA cneg cr wcel cc0 cA cneg
      clt wbr vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt
      wbr wi vm cz wral vj cM cuz cfv wrex wi cA cr wcel cM cz wcel cF cA cli
      wbr wa cA cneg cr wcel wa cc0 cA cneg clt wbr vj cv vm cv cle wbr vm cv
      cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm cz wral vj cM cuz cfv
      wrex cM cz wcel cF cA cli wbr wa cA cneg cr wcel cc0 cA cneg clt wbr vj
      cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm
      cz wral vj cM cuz cfv wrex cM cz wcel cF cA cli wbr cA cneg cr wcel cc0
      cA cneg clt wbr wa vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv
      cA cneg clt wbr wi vm cz wral vj cM cuz cfv wrex cM cz wcel cA cvv wcel
      cF cA cli wbr wa cA cneg cr wcel cc0 cA cneg clt wbr wa vj cv vm cv cle
      wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm cz wral vj cM
      cuz cfv wrex cF cA cli wbr cA cA cneg cvv vj vm cF cM clmi2a cF cA cli
      wbr cA cvv wcel climge0.1 jctl sylanr1 anassrs anassrs ex cA renegcl
      sylan2 sylbid 3adantl3 cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel cc0
      vk cv cF cfv cle wbr wa vk cM cuz cfv wral w3a cA cr wcel cA cc0 clt wbr
      vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi
      vm cz wral vj cM cuz cfv wrex wn wi vk cv cF cfv cr wcel cc0 vk cv cF cfv
      cle wbr wa vk cM cuz cfv wral cM cz wcel cA cr wcel cA cc0 clt wbr vj cv
      vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm cz
      wral vj cM cuz cfv wrex wn wi wi cF cA cli wbr vk cv cF cfv cr wcel cc0
      vk cv cF cfv cle wbr wa vk cM cuz cfv wral cA cr wcel cA cc0 clt wbr vj
      cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm
      cz wral vj cM cuz cfv wrex wn vk cv cF cfv cr wcel cc0 vk cv cF cfv cle
      wbr wa vk cM cuz cfv wral cA cr wcel cA cc0 clt wbr wa wa vj cv vm cv cle
      wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi vm cz wral vj cM
      cuz cfv vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv
      wral cA cr wcel cA cc0 clt wbr wa wa vj cv cM cuz cfv wcel wa vj cv vm cv
      cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wn wa vm cz wrex
      vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wi
      vm cz wral wn vj cv cz wcel vj cv vj cv cle wbr vj cv cF cfv cA cmin co
      cabs cfv cA cneg clt wbr wn wa vj cv vm cv cle wbr vm cv cF cfv cA cmin
      co cabs cfv cA cneg clt wbr wn wa vm cz wrex vk cv cF cfv cr wcel cc0 vk
      cv cF cfv cle wbr wa vk cM cuz cfv wral cA cr wcel cA cc0 clt wbr wa wa
      vj cv cM cuz cfv wcel wa vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs
      cfv cA cneg clt wbr wn wa vj cv vj cv cle wbr vj cv cF cfv cA cmin co
      cabs cfv cA cneg clt wbr wn wa vm vj cv cz vm cv vj cv wceq vj cv vm cv
      cle wbr vj cv vj cv cle wbr vm cv cF cfv cA cmin co cabs cfv cA cneg clt
      wbr wn vj cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wn vm cv vj cv vj
      cv cle breq2 vm cv vj cv wceq vm cv cF cfv cA cmin co cabs cfv cA cneg
      clt wbr vj cv cF cfv cA cmin co cabs cfv cA cneg clt wbr vm cv vj cv wceq
      vm cv cF cfv cA cmin co cabs cfv vj cv cF cfv cA cmin co cabs cfv cA cneg
      clt vm cv vj cv wceq vm cv cF cfv cA cmin co vj cv cF cfv cA cmin co cabs
      vm cv vj cv wceq vm cv cF cfv vj cv cF cfv cA cmin vm cv vj cv cF fveq2
      opreq1d fveq2d breq1d notbid anbi12d rcla4ev vj cv cM cuz cfv wcel vj cv
      cz wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv
      wral cA cr wcel cA cc0 clt wbr wa wa cM vj cv eluzelz adantl vk cv cF cfv
      cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv wral cA cr wcel cA cc0
      clt wbr wa wa vj cv cM cuz cfv wcel wa vj cv vj cv cle wbr vj cv cF cfv
      cA cmin co cabs cfv cA cneg clt wbr wn vj cv cM cuz cfv wcel vj cv vj cv
      cle wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv
      wral cA cr wcel cA cc0 clt wbr wa wa vj cv cM cuz cfv wcel vj cv cz wcel
      vj cv cr wcel vj cv vj cv cle wbr cM vj cv eluzelz vj cv zre vj cv leid
      3syl adantl vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz
      cfv wral vj cv cM cuz cfv wcel cA cr wcel cA cc0 clt wbr wa vj cv cF cfv
      cA cmin co cabs cfv cA cneg clt wbr wn vj cv cF cfv cr wcel cc0 vj cv cF
      cfv cle wbr wa cA cr wcel cA cc0 clt wbr wa vj cv cF cfv cA cmin co cabs
      cfv cA cneg clt wbr wn vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa
      vk cM cuz cfv wral vj cv cM cuz cfv wcel wa vj cv cF cfv cr wcel cc0 vj
      cv cF cfv cle wbr wa cA cr wcel cA cc0 clt wbr wa wa cA cneg vj cv cF cfv
      cA cmin co cabs cfv cle wbr vj cv cF cfv cA cmin co cabs cfv cA cneg clt
      wbr wn vj cv cF cfv cr wcel cc0 vj cv cF cfv cle wbr wa cA cr wcel cA cc0
      clt wbr wa wa cA cneg vj cv cF cfv cA cneg caddc co vj cv cF cfv cA cmin
      co cabs cfv cle vj cv cF cfv cr wcel cc0 vj cv cF cfv cle wbr wa cA cr
      wcel cA cneg vj cv cF cfv cA cneg caddc co cle wbr cA cc0 clt wbr cA cr
      wcel vj cv cF cfv cr wcel cc0 vj cv cF cfv cle wbr wa cA cneg vj cv cF
      cfv cA cneg caddc co cle wbr cA cr wcel vj cv cF cfv cr wcel cc0 vj cv cF
      cfv cle wbr cA cneg vj cv cF cfv cA cneg caddc co cle wbr cA cr wcel vj
      cv cF cfv cr wcel wa cc0 vj cv cF cfv cle wbr cA cneg vj cv cF cfv cA
      cneg caddc co cle wbr cA cneg cr wcel vj cv cF cfv cr wcel cc0 vj cv cF
      cfv cle wbr cA cneg vj cv cF cfv cA cneg caddc co cle wbr wb cA cr wcel
      cA cneg vj cv cF cfv addge02 cA renegcl sylan biimpa anasss ancoms
      adantrr vj cv cF cfv cr wcel cc0 vj cv cF cfv cle wbr wa cA cr wcel cA
      cc0 clt wbr wa wa vj cv cF cfv cA cneg caddc co cabs cfv vj cv cF cfv cA
      cneg caddc co vj cv cF cfv cA cmin co cabs cfv vj cv cF cfv cA cneg caddc
      co cr wcel cc0 vj cv cF cfv cA cneg caddc co cle wbr vj cv cF cfv cA cneg
      caddc co cabs cfv vj cv cF cfv cA cneg caddc co wceq vj cv cF cfv cr wcel
      cc0 vj cv cF cfv cle wbr wa cA cr wcel cA cc0 clt wbr wa wa vj cv cF cfv
      cA cneg caddc co absid vj cv cF cfv cr wcel cA cr wcel vj cv cF cfv cA
      cneg caddc co cr wcel cc0 vj cv cF cfv cle wbr cA cc0 clt wbr vj cv cF
      cfv cr wcel cA cneg cr wcel vj cv cF cfv cA cneg caddc co cr wcel cA cr
      wcel vj cv cF cfv cA cneg readdcl cA renegcl sylan2 ad2ant2r vj cv cF cfv
      cr wcel cc0 vj cv cF cfv cle wbr wa cA cneg cr wcel cc0 cA cneg cle wbr
      wa cc0 vj cv cF cfv cA cneg caddc co cle wbr cA cr wcel cA cc0 clt wbr wa
      vj cv cF cfv cr wcel cA cneg cr wcel cc0 vj cv cF cfv cle wbr cc0 cA cneg
      cle wbr cc0 vj cv cF cfv cA cneg caddc co cle wbr vj cv cF cfv cA cneg
      addge0 an4s cA cr wcel cA cc0 clt wbr wa cA cneg cr wcel cc0 cA cneg cle
      wbr cA cr wcel cA cneg cr wcel cA cc0 clt wbr cA renegcl adantr cA cr
      wcel cA cc0 clt wbr cc0 cA cneg cle wbr cA cr wcel cA cc0 clt wbr cA cc0
      cle wbr cc0 cA cneg cle wbr cA cr wcel cc0 cr wcel cA cc0 clt wbr cA cc0
      cle wbr wi 0re cA cc0 ltle mpan2 cA le0neg1 sylibd imp jca sylan2 sylanc
      vj cv cF cfv cr wcel cA cr wcel vj cv cF cfv cA cneg caddc co cabs cfv vj
      cv cF cfv cA cmin co cabs cfv wceq cc0 vj cv cF cfv cle wbr cA cc0 clt
      wbr vj cv cF cfv cr wcel cA cr wcel wa vj cv cF cfv cA cneg caddc co vj
      cv cF cfv cA cmin co cabs vj cv cF cfv cc wcel cA cc wcel vj cv cF cfv cA
      cneg caddc co vj cv cF cfv cA cmin co wceq vj cv cF cfv cr wcel cA cr
      wcel vj cv cF cfv cA negsub vj cv cF cfv recn cA recn syl2an fveq2d
      ad2ant2r eqtr3d breqtrd vj cv cF cfv cr wcel cA cr wcel cA cneg vj cv cF
      cfv cA cmin co cabs cfv cle wbr vj cv cF cfv cA cmin co cabs cfv cA cneg
      clt wbr wn wb cc0 vj cv cF cfv cle wbr cA cc0 clt wbr cA cneg cr wcel vj
      cv cF cfv cA cmin co cabs cfv cr wcel cA cneg vj cv cF cfv cA cmin co
      cabs cfv cle wbr vj cv cF cfv cA cmin co cabs cfv cA cneg clt wbr wn wb
      vj cv cF cfv cr wcel cA cr wcel wa cA cneg vj cv cF cfv cA cmin co cabs
      cfv lenlt cA cr wcel cA cneg cr wcel vj cv cF cfv cr wcel cA renegcl
      adantl vj cv cF cfv cr wcel cA cr wcel wa vj cv cF cfv cA cmin co cc wcel
      vj cv cF cfv cA cmin co cabs cfv cr wcel vj cv cF cfv cr wcel cA cr wcel
      wa vj cv cF cfv cA cmin co vj cv cF cfv cA resubcl recnd vj cv cF cfv cA
      cmin co abscl syl sylanc ad2ant2r mpbid vk cv cF cfv cr wcel cc0 vk cv cF
      cfv cle wbr wa vj cv cF cfv cr wcel cc0 vj cv cF cfv cle wbr wa vk vj cv
      cM cuz cfv vk cv vj cv wceq vk cv cF cfv cr wcel vj cv cF cfv cr wcel cc0
      vk cv cF cfv cle wbr cc0 vj cv cF cfv cle wbr vk cv vj cv wceq vk cv cF
      cfv vj cv cF cfv cr vk cv vj cv cF fveq2 eleq1d vk cv vj cv wceq vk cv cF
      cfv vj cv cF cfv cc0 cle vk cv vj cv cF fveq2 breq2d anbi12d rcla4cva
      sylan an1rs jca sylanc vj cv vm cv cle wbr vm cv cF cfv cA cmin co cabs
      cfv cA cneg clt wbr vm cz rexanali sylib nrexdv exp32 3ad2ant3 imp
      pm2.65d cA cr wcel cc0 cA cle wbr cA cc0 clt wbr wn wb cM cz wcel cF cA
      cli wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv
      wral w3a cc0 cr wcel cA cr wcel cc0 cA cle wbr cA cc0 clt wbr wn wb 0re
      cc0 cA lenlt mpan adantl mpbird mpdan $.
      $( [1-Aug-2006] $) $( [11-Sep-2005] $)
  $}

  ${
    $d j k x F $.  $d j k x G $.
    climabs0.1 $e |- F e. _V $.
    climabs0.2 $e |- G e. _V $.
    climabs0.3 $e |- ( k e. NN -> ( G ` k ) = ( abs ` ( F ` k ) ) ) $.
    $( Convergence to zero of the absolute value is equivalent to convergence
       to zero. $)
    climabs0i $p |- ( A. k e. NN ( F ` k ) e. CC
           -> ( F ~~> 0 <-> G ~~> 0 ) ) $=
      vk cv cF cfv cc wcel vk cn wral vj cv vk cv cle wbr vk cv cF cfv cabs cfv
      cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral vj cv vk cv
      cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx
      crp wral cG cc0 cli wbr cF cc0 cli wbr vk cv cF cfv cc wcel vk cn wral vj
      cv vk cv cle wbr vk cv cF cfv cabs cfv cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr
      wi vk cn wral vj cn wrex vx crp vk cv cF cfv cc wcel vk cn wral vj cv vk
      cv cle wbr vk cv cF cfv cabs cfv cabs cfv vx cv clt wbr wi vk cn wral vj
      cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn
      vk cv cF cfv cc wcel vk cn wral vj cv vk cv cle wbr vk cv cF cfv cabs cfv
      cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv
      clt wbr wi vk cn vk cv cF cfv cc wcel vk cn hbra1 vk cv cF cfv cc wcel vk
      cn wral vk cv cn wcel wa vk cv cF cfv cabs cfv cabs cfv vx cv clt wbr vk
      cv cF cfv cabs cfv vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel
      vk cn wral vk cv cn wcel wa vk cv cF cfv cabs cfv cabs cfv vk cv cF cfv
      cabs cfv vx cv clt vk cv cF cfv cc wcel vk cn wral vk cv cn wcel wa vk cv
      cF cfv cc wcel vk cv cF cfv cabs cfv cabs cfv vk cv cF cfv cabs cfv wceq
      vk cv cF cfv cc wcel vk cn wral vk cv cn wcel vk cv cF cfv cc wcel vk cv
      cF cfv cc wcel vk cn ra4 imp vk cv cF cfv absidm syl breq1d imbi2d
      ralbida rexbidv ralbidv vk cv cF cfv cc wcel vk cn wral vk cv cF cfv cabs
      cfv cc wcel vk cn wral cG cc0 cli wbr vj cv vk cv cle wbr vk cv cF cfv
      cabs cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral wb
      vk cv cF cfv cc wcel vk cv cF cfv cabs cfv cc wcel vk cn vk cv cF cfv cc
      wcel vk cv cF cfv cabs cfv vk cv cF cfv abscl recnd r19.20si vx vk cv cF
      cfv cabs cfv vj vk cG climabs0.2 climabs0.3 clm0nnsi syl vx vk cv cF cfv
      vj vk cF climabs0.1 vk cv cn wcel vk cv cF cfv eqidd clm0nnsi 3bitr4rd $.
      $( [3-Aug-2008] $) $( [8-Jul-2008] $)
  $}

  ${
    $d f g h t u v A $.  $d f g h t u v B $.  $d f g k t u v F $.
    $d f g k t u v G $.  $d f h k t u v H $.  $d f g h k t u v M $.
    climadd.1 $e |- F e. _V $.
    climadd.2 $e |- G e. _V $.
    climadd.3 $e |- H e. _V $.
    climadd.4 $e |- A e. _V $.
    climadd.5 $e |- B e. _V $.
    ${
      $d f t u v ph $.
      climaddlem.6 $e |- ( ph <-> ( ( F ~~> A /\ G ~~> B ) /\
                 A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\ ( G ` k ) e. CC /\
                  ( H ` k ) = ( ( F ` k ) + ( G ` k ) ) ) ) ) $.
      $( Lemma for ~ climadd . $)
      climaddlem1 $p |- ( ( t e. ( ZZ>= ` M ) /\ ph ) ->
         ( ( F ` t ) e. CC /\ ( G ` t ) e. CC /\
                  ( H ` t ) = ( ( F ` t ) + ( G ` t ) ) ) ) $=
        vt cv cM cuz cfv wcel cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc
        wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc
        co wceq w3a vk cM cuz cfv wral wa vt cv cF cfv cc wcel vt cv cG cfv cc
        wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq w3a wph vt cv
        cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv
        vk cv cF cfv vk cv cG cfv caddc co wceq w3a vk cM cuz cfv wral vt cv cF
        cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv
        caddc co wceq w3a cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel
        vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co
        wceq w3a vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv
        cF cfv vt cv cG cfv caddc co wceq w3a vk vt cv cM cuz cfv vk cv vt cv
        wceq vk cv cF cfv cc wcel vt cv cF cfv cc wcel vk cv cG cfv cc wcel vt
        cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq
        vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq vk cv vt cv wceq
        vk cv cF cfv vt cv cF cfv cc vk cv vt cv cF fveq2 eleq1d vk cv vt cv
        wceq vk cv cG cfv vt cv cG cfv cc vk cv vt cv cG fveq2 eleq1d vk cv vt
        cv wceq vk cv cH cfv vt cv cH cfv vk cv cF cfv vk cv cG cfv caddc co vt
        cv cF cfv vt cv cG cfv caddc co vk cv vt cv cH fveq2 vk cv vt cv wceq
        vk cv cF cfv vt cv cF cfv vk cv cG cfv vt cv cG cfv caddc vk cv vt cv
        cF fveq2 vk cv vt cv cG fveq2 opreq12d eqeq12d 3anbi123d rcla4va
        adantrl climaddlem.6 sylan2b $.
        $( [13-Nov-2005] $) $( [24-Sep-2005] $)

      $( Lemma for ~ climadd . $)
      climaddlem2 $p |- ( ph -> ( A e. CC /\ B e. CC ) ) $=
        wph cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk cv cG cfv cc
        wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq w3a vk cM cuz
        cfv wral wa cA cc wcel cB cc wcel wa climaddlem.6 cF cA cli wbr cG cB
        cli wbr wa cA cc wcel cB cc wcel wa vk cv cF cfv cc wcel vk cv cG cfv
        cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq w3a vk cM
        cuz cfv wral cF cA cli wbr cA cc wcel cG cB cli wbr cB cc wcel cA cvv
        wcel cF cA cli wbr cA cc wcel climadd.4 cA cvv cF climcl mpan cB cvv
        wcel cG cB cli wbr cB cc wcel climadd.5 cB cvv cG climcl mpan anim12i
        adantr sylbi $.
        $( [13-Nov-2005] $) $( [24-Sep-2005] $)

      $( Lemma for ~ climadd .  _Warning:  The HTML proof page is 3/4 megabyte
         in size_. $)
      climaddlem3 $p |- ( ( M e. ZZ /\ ph ) -> H ~~> ( A + B ) ) $=
        cM cz wcel wph wa cH cA cB caddc co cli wbr cc0 vv cv clt wbr vh cv vt
        cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr
        wi vt cM cuz cfv wral vh cz wrex wi vv cr wral wph cc0 vv cv clt wbr vh
        cv vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt
        wbr wi vt cM cuz cfv wral vh cz wrex wi vv cr wral cM cz wcel wph cc0
        vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co
        cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wi vv cr wph vv
        cv cr wcel cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cA cB
        caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz
        wrex wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv vt cv cle wbr vt
        cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz cfv
        wral vu cn0 wrex vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv
        vv cv c2 cdiv co clt wbr wi vg cM cuz cfv wral vf cn0 wrex wa vh cv vt
        cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr
        wi vt cM cuz cfv wral vh cz wrex wph vv cv c2 cdiv co cr wcel cc0 vv cv
        c2 cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv vv cv c2 cdiv co clt wbr wi vt cM cuz cfv wral vu cn0 wrex vf cv vg
        cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi
        vg cM cuz cfv wral vf cn0 wrex wa vv cv cr wcel cc0 vv cv clt wbr wa cF
        cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk cv cG cfv cc wcel
        vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq w3a vk cM cuz cfv
        wral wa vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vu cv
        vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr
        wi vt cM cuz cfv wral vu cn0 wrex vf cv vg cv cle wbr vg cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vg cM cuz cfv wral vf cn0
        wrex wa wph cF cA cli wbr cG cB cli wbr wa vv cv c2 cdiv co cr wcel cc0
        vv cv c2 cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co
        cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz cfv wral vu cn0 wrex vf
        cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt
        wbr wi vg cM cuz cfv wral vf cn0 wrex wa vk cv cF cfv cc wcel vk cv cG
        cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq w3a vk
        cM cuz cfv wral cF cA cli wbr cG cB cli wbr vv cv c2 cdiv co cr wcel
        cc0 vv cv c2 cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cA
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz cfv wral vu cn0
        wrex vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv
        co clt wbr wi vg cM cuz cfv wral vf cn0 wrex wa cF cA cli wbr vv cv c2
        cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa wa vu cv vt cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz
        cfv wral vu cn0 wrex cG cB cli wbr vv cv c2 cdiv co cr wcel cc0 vv cv
        c2 cdiv co clt wbr wa wa vf cv vg cv cle wbr vg cv cG cfv cB cmin co
        cabs cfv vv cv c2 cdiv co clt wbr wi vg cM cuz cfv wral vf cn0 wrex cA
        cvv wcel cF cA cli wbr vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co
        clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv
        c2 cdiv co clt wbr wi vt cM cuz cfv wral vu cn0 wrex climadd.4 cA vv cv
        c2 cdiv co cvv vu vt cF cc0 cM cuz cfv cn0 0z cn0 cc0 cuz cfv nn0uz
        eqimss2i cM uzssz clmi2i mpanl1 cB cvv wcel cG cB cli wbr vv cv c2 cdiv
        co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vf cv vg cv cle wbr vg cv cG
        cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vg cM cuz cfv wral
        vf cn0 wrex climadd.5 cB vv cv c2 cdiv co cvv vf vg cG cc0 cM cuz cfv
        cn0 0z cn0 cc0 cuz cfv nn0uz eqimss2i cM uzssz clmi2i mpanl1 anim12i
        anandirs adantlr climaddlem.6 sylanb vv cv cr wcel cc0 vv cv clt wbr wa
        vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr vv cv cr wcel vv
        cv c2 cdiv co cr wcel cc0 vv cv clt wbr vv cv rehalfcl adantr vv cv cr
        wcel cc0 vv cv clt wbr wa c2 cr wcel cc0 c2 clt wbr cc0 vv cv c2 cdiv
        co clt wbr 2re 2pos vv cv c2 divgt0 mpanr12 jca sylan2 wph vv cv cr
        wcel cc0 vv cv clt wbr wa wa vu cv vt cv cle wbr vt cv cF cfv cA cmin
        co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz cfv wral vf cv vg cv
        cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vg
        cM cuz cfv wral wa vf cn0 wrex vu cn0 wrex vh cv vt cv cle wbr vt cv cH
        cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral
        vh cz wrex vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv
        c2 cdiv co clt wbr wi vt cM cuz cfv wral vu cn0 wrex vf cv vg cv cle
        wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vg cM
        cuz cfv wral vf cn0 wrex wa wph vv cv cr wcel cc0 vv cv clt wbr wa wa
        vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co
        clt wbr wi vt cM cuz cfv wral vf cv vg cv cle wbr vg cv cG cfv cB cmin
        co cabs cfv vv cv c2 cdiv co clt wbr wi vg cM cuz cfv wral wa vh cv vt
        cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr
        wi vt cM cuz cfv wral vh cz wrex vu vf cn0 cn0 wph vv cv cr wcel cc0 vv
        cv clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa vu cv vt cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz
        cfv wral vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co clt wbr wi vg cM cuz cfv wral wa vh cv vt cv cle wbr vt cv cH
        cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral
        vh cz wrex wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cn0 wcel
        vf cv cn0 wcel wa wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wi wa vg cM cuz cfv wral vt
        cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co
        cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex vu cv vt cv cle
        wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM
        cuz cfv wral vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv
        c2 cdiv co clt wbr wi vg cM cuz cfv wral wa wph vv cv cr wcel cc0 vv cv
        clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa wa vu cv vt cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg
        cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi
        wa vg cM cuz cfv wral vt cM cuz cfv wral vu cv vf cv caddc co vt cv cle
        wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM
        cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co
        cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wph vv cv cr
        wcel vu cv cn0 wcel vf cv cn0 wcel wa vu cv vt cv cle wbr vt cv cF cfv
        cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi wa vg cM cuz
        cfv wral vt cM cuz cfv wral vu cv vf cv caddc co vt cv cle wbr vt cv cH
        cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral
        wi cc0 vv cv clt wbr wph vv cv cr wcel wa vu cv cn0 wcel vf cv cn0 wcel
        wa wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2
        cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv
        vv cv c2 cdiv co clt wbr wi wa vg cM cuz cfv wral vu cv vf cv caddc co
        vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt
        wbr wi vt cM cuz cfv wph vv cv cr wcel wa vu cv cn0 wcel vf cv cn0 wcel
        wa wa vt cv cM cuz cfv wcel wa vu cv vf cv caddc co vt cv cle wbr vu cv
        vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr
        wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv
        co clt wbr wi wa vg cM cuz cfv wral vt cv cH cfv cA cB caddc co cmin co
        cabs cfv vv cv clt wbr wph vv cv cr wcel wa vu cv cn0 wcel vf cv cn0
        wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf cv caddc co vt cv cle wbr
        vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co
        clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv
        c2 cdiv co clt wbr wi wa vg cM cuz cfv wral vt cv cF cfv cA cmin co
        cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv
        cv c2 cdiv co clt wbr wa vt cv cH cfv cA cB caddc co cmin co cabs cfv
        vv cv clt wbr vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz cfv wcel vu
        cv vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr vt cv cF cfv cA
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi wa vg cM cuz cfv
        wral vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG
        cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi wi wph vv cv cr
        wcel wa vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz cfv wcel wa vu cv
        vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr
        wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv
        co clt wbr wi wa vg cM cuz cfv wral vu cv vf cv caddc co vt cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa vu cv cn0 wcel vf cv
        cn0 wcel wa vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv
        cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi wa vg cM cuz
        cfv wral vt cv cM cuz cfv wcel vu cv vf cv caddc co vt cv cle wbr vt cv
        cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi vu cv cn0 wcel vf cv
        cn0 wcel wa vt cv cM cuz cfv wcel pm3.27 vu cv cn0 wcel vf cv cn0 wcel
        wa vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co
        cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi wa vg cM cuz cfv wral
        vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi wi vg cM cuz cfv
        wral vt cv cM cuz cfv wcel vu cv vf cv caddc co vt cv cle wbr vt cv cF
        cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin
        co cabs cfv vv cv c2 cdiv co clt wbr wa wi wi vu cv cn0 wcel vf cv cn0
        wcel wa vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cA
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi wa vu cv vf cv
        caddc co vt cv cle wbr vu cv vf cv caddc co vg cv cle wbr vt cv cF cfv
        cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg cv cG cfv cB cmin co
        cabs cfv vv cv c2 cdiv co clt wbr wa wi wi vg cM cuz cfv vu cv cn0 wcel
        vf cv cn0 wcel wa vt cv cM cuz cfv wcel wa vg cv cM cuz cfv wcel wa vu
        cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt
        wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co clt wbr wi wa vu cv vf cv caddc co vt cv cle wbr vu cv vf cv
        caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv
        co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa
        vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz cfv wcel wa vg cv cM cuz
        cfv wcel wa vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg
        cv cle wbr wa vu cv vt cv cle wbr vf cv vg cv cle wbr wa vu cv vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vf
        cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt
        wbr wi wa vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa vu cv cn0
        wcel vf cv cn0 wcel wa vt cv cM cuz cfv wcel wa vg cv cM cuz cfv wcel
        wa vu cv vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr vu cv vf cv
        caddc co vg cv cle wbr vf cv vg cv cle wbr vu cv cn0 wcel vf cv cn0
        wcel wa vt cv cM cuz cfv wcel wa vu cv vf cv caddc co vt cv cle wbr vu
        cv vt cv cle wbr wi vg cv cM cuz cfv wcel vu cv cn0 wcel vf cv cn0 wcel
        wa vt cv cr wcel vu cv vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr
        wi vt cv cM cuz cfv wcel vu cv cn0 wcel vf cv cn0 wcel wa vt cv cr wcel
        wa vu cv vu cv vf cv caddc co cle wbr vu cv vf cv caddc co vt cv cle
        wbr vu cv vt cv cle wbr vu cv cn0 wcel vf cv cn0 wcel wa vu cv vu cv vf
        cv caddc co cle wbr vt cv cr wcel vu cv cr wcel vf cv cn0 wcel vu cv vu
        cv vf cv caddc co cle wbr vu cv cn0 wcel vu cv vf cv nn0addge1 vu cv
        nn0re sylan adantr vu cv cr wcel vu cv vf cv caddc co cr wcel wa vt cv
        cr wcel vu cv vu cv vf cv caddc co cle wbr vu cv vf cv caddc co vt cv
        cle wbr wa vu cv vt cv cle wbr wi vu cv cn0 wcel vf cv cn0 wcel wa vu
        cv cr wcel vu cv vf cv caddc co cr wcel vt cv cr wcel vu cv vu cv vf cv
        caddc co cle wbr vu cv vf cv caddc co vt cv cle wbr wa vu cv vt cv cle
        wbr wi vu cv vu cv vf cv caddc co vt cv letr 3expa vu cv cr wcel vf cv
        cr wcel vu cv cr wcel vu cv vf cv caddc co cr wcel wa vu cv cn0 wcel vf
        cv cn0 wcel vu cv cr wcel vf cv cr wcel wa vu cv cr wcel vu cv vf cv
        caddc co cr wcel vu cv cr wcel vf cv cr wcel pm3.26 vu cv vf cv readdcl
        jca vu cv nn0re vf cv nn0re syl2an sylan mpand vt cv cM cuz cfv wcel vt
        cv cz wcel vt cv cr wcel cM vt cv eluzelz vt cv zre syl sylan2 adantr
        vu cv cn0 wcel vf cv cn0 wcel wa vg cv cM cuz cfv wcel vu cv vf cv
        caddc co vg cv cle wbr vf cv vg cv cle wbr wi vt cv cM cuz cfv wcel vu
        cv cn0 wcel vf cv cn0 wcel wa vg cv cr wcel vu cv vf cv caddc co vg cv
        cle wbr vf cv vg cv cle wbr wi vg cv cM cuz cfv wcel vu cv cn0 wcel vf
        cv cn0 wcel wa vg cv cr wcel wa vf cv vu cv vf cv caddc co cle wbr vu
        cv vf cv caddc co vg cv cle wbr vf cv vg cv cle wbr vu cv cn0 wcel vf
        cv cn0 wcel wa vf cv vu cv vf cv caddc co cle wbr vg cv cr wcel vu cv
        cn0 wcel vf cv cr wcel vf cv vu cv vf cv caddc co cle wbr vf cv cn0
        wcel vf cv cr wcel vu cv cn0 wcel vf cv vu cv vf cv caddc co cle wbr vf
        cv vu cv nn0addge2 ancoms vf cv nn0re sylan2 adantr vf cv cr wcel vu cv
        vf cv caddc co cr wcel wa vg cv cr wcel vf cv vu cv vf cv caddc co cle
        wbr vu cv vf cv caddc co vg cv cle wbr wa vf cv vg cv cle wbr wi vu cv
        cn0 wcel vf cv cn0 wcel wa vf cv cr wcel vu cv vf cv caddc co cr wcel
        vg cv cr wcel vf cv vu cv vf cv caddc co cle wbr vu cv vf cv caddc co
        vg cv cle wbr wa vf cv vg cv cle wbr wi vf cv vu cv vf cv caddc co vg
        cv letr 3expa vu cv cr wcel vf cv cr wcel vf cv cr wcel vu cv vf cv
        caddc co cr wcel wa vu cv cn0 wcel vf cv cn0 wcel vu cv cr wcel vf cv
        cr wcel wa vf cv cr wcel vu cv vf cv caddc co cr wcel vu cv cr wcel vf
        cv cr wcel pm3.27 vu cv vf cv readdcl jca vu cv nn0re vf cv nn0re
        syl2an sylan mpand vg cv cM cuz cfv wcel vg cv cz wcel vg cv cr wcel cM
        vg cv eluzelz vg cv zre syl sylan2 adantlr anim12d vu cv vt cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vf cv vg cv
        cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr prth
        syl9 exp4a r19.20dva vt cv cM cuz cfv wcel vu cv vf cv caddc co vt cv
        cle wbr vu cv vf cv caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv vv cv c2 cdiv co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co clt wbr wa wi wi vg cM cuz cfv wral vu cv vf cv caddc co vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi vt cv cM cuz
        cfv wcel vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi vg cM cuz cfv
        wral wi vu cv vf cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co clt wbr wa wi vu cv vf cv caddc co vt cv cle wbr vu cv vf cv
        caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv
        co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa
        wi wi vg cM cuz cfv wral vt cv cM cuz cfv wcel vu cv vf cv caddc co vt
        cv cle wbr vu cv vf cv caddc co vg cv cle wbr vt cv cF cfv cA cmin co
        cabs cfv vv cv c2 cdiv co clt wbr vg cv cG cfv cB cmin co cabs cfv vv
        cv c2 cdiv co clt wbr wa wi vg cM cuz cfv wral vt cv cF cfv cA cmin co
        cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv
        cv c2 cdiv co clt wbr wa vt cv cM cuz cfv wcel vu cv vf cv caddc co vg
        cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi vg cM cuz
        cfv wral vu cv vf cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co
        cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv
        cv c2 cdiv co clt wbr wa vu cv vf cv caddc co vg cv cle wbr vt cv cF
        cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg cv cG cfv cB cmin
        co cabs cfv vv cv c2 cdiv co clt wbr wa wi vu cv vf cv caddc co vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi vg vt cv cM
        cuz cfv vg cv vt cv wceq vu cv vf cv caddc co vg cv cle wbr vu cv vf cv
        caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv
        co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa
        vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa vg cv vt cv vu cv vf cv
        caddc co cle breq2 vg cv vt cv wceq vg cv cG cfv cB cmin co cabs cfv vv
        cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co
        clt wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vg cv
        vt cv wceq vg cv cG cfv cB cmin co cabs cfv vt cv cG cfv cB cmin co
        cabs cfv vv cv c2 cdiv co clt vg cv vt cv wceq vg cv cG cfv cB cmin co
        vt cv cG cfv cB cmin co cabs vg cv vt cv wceq vg cv cG cfv vt cv cG cfv
        cB cmin vg cv vt cv cG fveq2 opreq1d fveq2d breq1d anbi2d imbi12d
        rcla4v com23 a2d vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc
        co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt
        wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa wi vg
        cM cuz cfv r19.21v syl5ib com12 syl6 mpid com23 adantll wph vv cv cr
        wcel wa vt cv cM cuz cfv wcel vu cv vf cv caddc co vt cv cle wbr vt cv
        cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wa vt cv cH cfv cA cB caddc
        co cmin co cabs cfv vv cv clt wbr wi wi vu cv cn0 wcel vf cv cn0 wcel
        wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa vt cv cF cfv cA cmin
        co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv
        vv cv c2 cdiv co clt wbr wa vt cv cH cfv cA cB caddc co cmin co cabs
        cfv vv cv clt wbr wi vu cv vf cv caddc co vt cv cle wbr vt cv cM cuz
        cfv wcel wph vv cv cr wcel wa vt cv cF cfv cA cmin co cabs cfv vv cv c2
        cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt
        wbr wa vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt
        cv cM cuz cfv wcel wph vv cv cr wcel wa wa vt cv cF cfv cA cmin co cabs
        cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co clt wbr wa vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB
        cmin co cabs cfv caddc co vv cv clt wbr vt cv cH cfv cA cB caddc co
        cmin co cabs cfv vv cv clt wbr vt cv cM cuz cfv wcel wph vv cv cr wcel
        wa wa vt cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wa vt cv cF cfv cA
        cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co vv cv c2
        cdiv co vv cv c2 cdiv co caddc co clt wbr vt cv cF cfv cA cmin co cabs
        cfv vt cv cG cfv cB cmin co cabs cfv caddc co vv cv clt wbr vt cv cM
        cuz cfv wcel wph vv cv cr wcel vt cv cF cfv cA cmin co cabs cfv vv cv
        c2 cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co
        clt wbr wa vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin co
        cabs cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc co clt wbr wi
        vt cv cF cfv cA cmin co cabs cfv cr wcel vt cv cG cfv cB cmin co cabs
        cfv cr wcel wa vv cv c2 cdiv co cr wcel vv cv c2 cdiv co cr wcel wa vt
        cv cF cfv cA cmin co cabs cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co clt wbr wa vt cv cF cfv cA cmin co
        cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co vv cv c2 cdiv co vv
        cv c2 cdiv co caddc co clt wbr wi vt cv cM cuz cfv wcel wph wa vv cv cr
        wcel vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv
        vv cv c2 cdiv co vv cv c2 cdiv co lt2add vt cv cM cuz cfv wcel wph wa
        vt cv cF cfv cA cmin co cabs cfv cr wcel vt cv cG cfv cB cmin co cabs
        cfv cr wcel vt cv cM cuz cfv wcel wph wa vt cv cF cfv cA cmin co cc
        wcel vt cv cF cfv cA cmin co cabs cfv cr wcel vt cv cF cfv cc wcel cA
        cc wcel vt cv cF cfv cA cmin co cc wcel vt cv cM cuz cfv wcel wph wa vt
        cv cF cfv cA subcl vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt
        cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq
        wph vt cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3 climadd.4
        climadd.5 climaddlem.6 climaddlem1 3simp1d wph cA cc wcel vt cv cM cuz
        cfv wcel wph cA cc wcel cB cc wcel wph cA cB vk cF cG cH cM climadd.1
        climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem2
        pm3.26d adantl sylanc vt cv cF cfv cA cmin co abscl syl vt cv cM cuz
        cfv wcel wph wa vt cv cG cfv cB cmin co cc wcel vt cv cG cfv cB cmin co
        cabs cfv cr wcel vt cv cG cfv cc wcel cB cc wcel vt cv cG cfv cB cmin
        co cc wcel vt cv cM cuz cfv wcel wph wa vt cv cG cfv cB subcl vt cv cM
        cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH
        cfv vt cv cF cfv vt cv cG cfv caddc co wceq wph vt cA cB vk cF cG cH cM
        climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem1 3simp2d wph cB cc wcel vt cv cM cuz cfv wcel wph cA cc wcel
        cB cc wcel wph cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3
        climadd.4 climadd.5 climaddlem.6 climaddlem2 pm3.27d adantl sylanc vt
        cv cG cfv cB cmin co abscl syl jca vv cv cr wcel vv cv c2 cdiv co cr
        wcel vv cv c2 cdiv co cr wcel vv cv rehalfcl vv cv rehalfcl jca syl2an
        anasss vt cv cM cuz cfv wcel wph vv cv cr wcel wa wa vv cv c2 cdiv co
        vv cv c2 cdiv co caddc co vv cv vt cv cF cfv cA cmin co cabs cfv vt cv
        cG cfv cB cmin co cabs cfv caddc co clt vv cv cr wcel vv cv c2 cdiv co
        vv cv c2 cdiv co caddc co vv cv wceq vt cv cM cuz cfv wcel wph vv cv cr
        wcel c2 vv cv c2 cdiv co cmul co vv cv c2 cdiv co vv cv c2 cdiv co
        caddc co vv cv vv cv cr wcel vv cv c2 cdiv co cr wcel vv cv c2 cdiv co
        cc wcel c2 vv cv c2 cdiv co cmul co vv cv c2 cdiv co vv cv c2 cdiv co
        caddc co wceq vv cv rehalfcl vv cv c2 cdiv co recn vv cv c2 cdiv co
        2times 3syl vv cv cr wcel vv cv cc wcel c2 vv cv c2 cdiv co cmul co vv
        cv wceq vv cv recn vv cv cc wcel c2 cc wcel c2 cc0 wne c2 vv cv c2 cdiv
        co cmul co vv cv wceq 2cn 2ne0 vv cv c2 divcan2 mp3an23 syl eqtr3d
        ad2antll breq2d sylibd vt cv cM cuz cfv wcel wph vv cv cr wcel wa wa vt
        cv cH cfv cA cB caddc co cmin co cabs cfv vt cv cF cfv cA cmin co cabs
        cfv vt cv cG cfv cB cmin co cabs cfv caddc co cle wbr vt cv cF cfv cA
        cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co vv cv clt
        wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr vt cv cM
        cuz cfv wcel wph vt cv cH cfv cA cB caddc co cmin co cabs cfv vt cv cF
        cfv cA cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co cle
        wbr vv cv cr wcel vt cv cM cuz cfv wcel wph wa vt cv cH cfv cA cB caddc
        co cmin co cabs cfv vt cv cF cfv cA cmin co vt cv cG cfv cB cmin co
        caddc co cabs cfv vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin
        co cabs cfv caddc co cle vt cv cM cuz cfv wcel wph wa vt cv cH cfv cA
        cB caddc co cmin co vt cv cF cfv cA cmin co vt cv cG cfv cB cmin co
        caddc co cabs vt cv cM cuz cfv wcel wph wa vt cv cH cfv cA cB caddc co
        cmin co vt cv cF cfv vt cv cG cfv caddc co cA cB caddc co cmin co vt cv
        cF cfv cA cmin co vt cv cG cfv cB cmin co caddc co vt cv cM cuz cfv
        wcel wph wa vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co cA cB caddc
        co cmin vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv
        cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq wph vt cA
        cB vk cF cG cH cM climadd.1 climadd.2 climadd.3 climadd.4 climadd.5
        climaddlem.6 climaddlem1 3simp3d opreq1d vt cv cF cfv cc wcel vt cv cG
        cfv cc wcel wa cA cc wcel cB cc wcel wa vt cv cF cfv vt cv cG cfv caddc
        co cA cB caddc co cmin co vt cv cF cfv cA cmin co vt cv cG cfv cB cmin
        co caddc co wceq vt cv cM cuz cfv wcel wph wa vt cv cF cfv vt cv cG cfv
        cA cB addsub4 vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv
        cG cfv cc wcel vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv
        cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq wph
        vt cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3 climadd.4
        climadd.5 climaddlem.6 climaddlem1 3simp1d vt cv cM cuz cfv wcel wph wa
        vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt
        cv cG cfv caddc co wceq wph vt cA cB vk cF cG cH cM climadd.1 climadd.2
        climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem1 3simp2d jca wph
        cA cc wcel cB cc wcel wa vt cv cM cuz cfv wcel wph cA cB vk cF cG cH cM
        climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem2 adantl sylanc eqtrd fveq2d vt cv cF cfv cA cmin co cc wcel
        vt cv cG cfv cB cmin co cc wcel vt cv cF cfv cA cmin co vt cv cG cfv cB
        cmin co caddc co cabs cfv vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv
        cB cmin co cabs cfv caddc co cle wbr vt cv cM cuz cfv wcel wph wa vt cv
        cF cfv cA cmin co vt cv cG cfv cB cmin co abstri vt cv cF cfv cc wcel
        cA cc wcel vt cv cF cfv cA cmin co cc wcel vt cv cM cuz cfv wcel wph wa
        vt cv cF cfv cA subcl vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel
        vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co
        wceq wph vt cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3
        climadd.4 climadd.5 climaddlem.6 climaddlem1 3simp1d wph cA cc wcel vt
        cv cM cuz cfv wcel wph cA cc wcel cB cc wcel wph cA cB vk cF cG cH cM
        climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem2 pm3.26d adantl sylanc vt cv cG cfv cc wcel cB cc wcel vt cv
        cG cfv cB cmin co cc wcel vt cv cM cuz cfv wcel wph wa vt cv cG cfv cB
        subcl vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc
        wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq wph vt cA cB
        vk cF cG cH cM climadd.1 climadd.2 climadd.3 climadd.4 climadd.5
        climaddlem.6 climaddlem1 3simp2d wph cB cc wcel vt cv cM cuz cfv wcel
        wph cA cc wcel cB cc wcel wph cA cB vk cF cG cH cM climadd.1 climadd.2
        climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem2 pm3.27d adantl
        sylanc sylanc eqbrtrd adantrr vt cv cM cuz cfv wcel wph vv cv cr wcel
        vt cv cH cfv cA cB caddc co cmin co cabs cfv vt cv cF cfv cA cmin co
        cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co cle wbr vt cv cF cfv
        cA cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co vv cv clt
        wbr wa vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt
        cv cH cfv cA cB caddc co cmin co cabs cfv cr wcel vt cv cF cfv cA cmin
        co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co cr wcel wa vv cv
        cr wcel vt cv cH cfv cA cB caddc co cmin co cabs cfv vt cv cF cfv cA
        cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co cle wbr vt
        cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co
        vv cv clt wbr wa vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt
        wbr wi vt cv cM cuz cfv wcel wph wa vt cv cH cfv cA cB caddc co cmin co
        cabs cfv cr wcel vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin
        co cabs cfv caddc co cr wcel vv cv cr wcel vt cv cH cfv cA cB caddc co
        cmin co cabs cfv vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin
        co cabs cfv caddc co cle wbr vt cv cF cfv cA cmin co cabs cfv vt cv cG
        cfv cB cmin co cabs cfv caddc co vv cv clt wbr wa vt cv cH cfv cA cB
        caddc co cmin co cabs cfv vv cv clt wbr wi vt cv cH cfv cA cB caddc co
        cmin co cabs cfv vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin
        co cabs cfv caddc co vv cv lelttr 3expa vt cv cM cuz cfv wcel wph wa vt
        cv cH cfv cA cB caddc co cmin co cabs cfv cr wcel vt cv cF cfv cA cmin
        co cabs cfv vt cv cG cfv cB cmin co cabs cfv caddc co cr wcel vt cv cM
        cuz cfv wcel wph wa vt cv cH cfv cA cB caddc co cmin co cc wcel vt cv
        cH cfv cA cB caddc co cmin co cabs cfv cr wcel vt cv cH cfv cc wcel cA
        cB caddc co cc wcel vt cv cH cfv cA cB caddc co cmin co cc wcel vt cv
        cM cuz cfv wcel wph wa vt cv cH cfv cA cB caddc co subcl vt cv cM cuz
        cfv wcel wph wa vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co cc vt
        cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt
        cv cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq wph vt cA cB vk cF cG
        cH cM climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem1 3simp3d vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cF
        cfv vt cv cG cfv caddc co cc wcel vt cv cM cuz cfv wcel wph wa vt cv cF
        cfv vt cv cG cfv addcl vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc
        wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc
        co wceq wph vt cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3
        climadd.4 climadd.5 climaddlem.6 climaddlem1 3simp1d vt cv cM cuz cfv
        wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt
        cv cF cfv vt cv cG cfv caddc co wceq wph vt cA cB vk cF cG cH cM
        climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem1 3simp2d sylanc eqeltrd cA cc wcel cB cc wcel cA cB caddc co
        cc wcel vt cv cM cuz cfv wcel wph wa cA cB addcl wph cA cc wcel vt cv
        cM cuz cfv wcel wph cA cc wcel cB cc wcel wph cA cB vk cF cG cH cM
        climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem2 pm3.26d adantl wph cB cc wcel vt cv cM cuz cfv wcel wph cA
        cc wcel cB cc wcel wph cA cB vk cF cG cH cM climadd.1 climadd.2
        climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem2 pm3.27d adantl
        sylanc sylanc vt cv cH cfv cA cB caddc co cmin co abscl syl vt cv cF
        cfv cA cmin co cabs cfv cr wcel vt cv cG cfv cB cmin co cabs cfv cr
        wcel vt cv cF cfv cA cmin co cabs cfv vt cv cG cfv cB cmin co cabs cfv
        caddc co cr wcel vt cv cM cuz cfv wcel wph wa vt cv cF cfv cA cmin co
        cabs cfv vt cv cG cfv cB cmin co cabs cfv readdcl vt cv cM cuz cfv wcel
        wph wa vt cv cF cfv cA cmin co cc wcel vt cv cF cfv cA cmin co cabs cfv
        cr wcel vt cv cF cfv cc wcel cA cc wcel vt cv cF cfv cA cmin co cc wcel
        vt cv cM cuz cfv wcel wph wa vt cv cF cfv cA subcl vt cv cM cuz cfv
        wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt
        cv cF cfv vt cv cG cfv caddc co wceq wph vt cA cB vk cF cG cH cM
        climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem1 3simp1d wph cA cc wcel vt cv cM cuz cfv wcel wph cA cc wcel
        cB cc wcel wph cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3
        climadd.4 climadd.5 climaddlem.6 climaddlem2 pm3.26d adantl sylanc vt
        cv cF cfv cA cmin co abscl syl vt cv cM cuz cfv wcel wph wa vt cv cG
        cfv cB cmin co cc wcel vt cv cG cfv cB cmin co cabs cfv cr wcel vt cv
        cG cfv cc wcel cB cc wcel vt cv cG cfv cB cmin co cc wcel vt cv cM cuz
        cfv wcel wph wa vt cv cG cfv cB subcl vt cv cM cuz cfv wcel wph wa vt
        cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv
        cG cfv caddc co wceq wph vt cA cB vk cF cG cH cM climadd.1 climadd.2
        climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem1 3simp2d wph cB
        cc wcel vt cv cM cuz cfv wcel wph cA cc wcel cB cc wcel wph cA cB vk cF
        cG cH cM climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem2 pm3.27d adantl sylanc vt cv cG cfv cB cmin co abscl syl
        sylanc jca sylan anasss mpand syld ancoms a1d adantlr syldd com23
        r19.20dva adantlrr vu cv cn0 wcel vf cv cn0 wcel wa vu cv vf cv caddc
        co vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt
        wbr wi vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cA cB caddc
        co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wi
        wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel
        wa vu cv vf cv caddc co vt cv cle wbr vt cv cH cfv cA cB caddc co cmin
        co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cv vt cv cle wbr vt
        cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz
        cfv wral vh cz wrex vu cv vf cv caddc co cz wcel vu cv vf cv caddc co
        vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt
        wbr wi vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cA cB caddc
        co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex vu
        cv cn0 wcel vf cv cn0 wcel wa vh cv vt cv cle wbr vt cv cH cfv cA cB
        caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vu cv vf
        cv caddc co vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv
        vv cv clt wbr wi vt cM cuz cfv wral vh vu cv vf cv caddc co cz vh cv vu
        cv vf cv caddc co wceq vh cv vt cv cle wbr vt cv cH cfv cA cB caddc co
        cmin co cabs cfv vv cv clt wbr wi vu cv vf cv caddc co vt cv cle wbr vt
        cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz
        cfv vh cv vu cv vf cv caddc co wceq vh cv vt cv cle wbr vu cv vf cv
        caddc co vt cv cle wbr vt cv cH cfv cA cB caddc co cmin co cabs cfv vv
        cv clt wbr vh cv vu cv vf cv caddc co vt cv cle breq1 imbi1d ralbidv
        rcla4ev vu cv cn0 wcel vf cv cn0 wcel wa vu cv vf cv caddc co cn0 wcel
        vu cv vf cv caddc co cz wcel vu cv vf cv nn0addcl vu cv vf cv caddc co
        nn0z syl sylan ex adantl syld vu cv vt cv cle wbr vt cv cF cfv cA cmin
        co cabs cfv vv cv c2 cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG
        cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vt vg cM cuz cfv
        raaanv syl5ibr ex r19.23advv vu cv vt cv cle wbr vt cv cF cfv cA cmin
        co cabs cfv vv cv c2 cdiv co clt wbr wi vt cM cuz cfv wral vf cv vg cv
        cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co clt wbr wi vg
        cM cuz cfv wral vu vf cn0 cn0 reeanv syl5ibr mpd exp32 r19.21aiv adantl
        cM cz wcel cA cB caddc co cc wcel vt cv cH cfv cc wcel vt cM cuz cfv
        wral wa cH cA cB caddc co cli wbr cc0 vv cv clt wbr vh cv vt cv cle wbr
        vt cv cH cfv cA cB caddc co cmin co cabs cfv vv cv clt wbr wi vt cM cuz
        cfv wral vh cz wrex wi vv cr wral wb wph cM cz wcel cA cB caddc co cc
        wcel vt cv cH cfv cc wcel vt cM cuz cfv wral cH cA cB caddc co cli wbr
        cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cA cB caddc co cmin
        co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wi vv cr
        wral wb vv cA cB caddc co vh vt cH cM climadd.3 clm4a 3expb wph cA cB
        caddc co cc wcel vt cv cH cfv cc wcel vt cM cuz cfv wral wph cA cc wcel
        cB cc wcel wa cA cB caddc co cc wcel wph cA cB vk cF cG cH cM climadd.1
        climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem2 cA cB
        addcl syl wph vt cv cH cfv cc wcel vt cM cuz cfv vt cv cM cuz cfv wcel
        wph vt cv cH cfv cc wcel vt cv cM cuz cfv wcel wph wa vt cv cH cfv vt
        cv cF cfv vt cv cG cfv caddc co cc vt cv cM cuz cfv wcel wph wa vt cv
        cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG
        cfv caddc co wceq wph vt cA cB vk cF cG cH cM climadd.1 climadd.2
        climadd.3 climadd.4 climadd.5 climaddlem.6 climaddlem1 3simp3d vt cv cF
        cfv cc wcel vt cv cG cfv cc wcel vt cv cF cfv vt cv cG cfv caddc co cc
        wcel vt cv cM cuz cfv wcel wph wa vt cv cF cfv vt cv cG cfv addcl vt cv
        cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv
        cH cfv vt cv cF cfv vt cv cG cfv caddc co wceq wph vt cA cB vk cF cG cH
        cM climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 climaddlem.6
        climaddlem1 3simp1d vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel
        vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv caddc co
        wceq wph vt cA cB vk cF cG cH cM climadd.1 climadd.2 climadd.3
        climadd.4 climadd.5 climaddlem.6 climaddlem1 3simp2d sylanc eqeltrd
        expcom r19.21aiv jca sylan2 mpbird $.
        $( [13-Nov-2005] $) $( [24-Sep-2005] $)
    $}

    $( Limit of the sum of two converging sequences.  Proposition 12-2.1(a) of
       [Gleason] p. 168. $)
    climadd $p |- ( ( ( F ~~> A /\ G ~~> B ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\ ( G ` k ) e. CC /\
           ( H ` k ) = ( ( F ` k ) + ( G ` k ) ) ) ) ) -> H ~~> ( A + B ) ) $=
      cM cz wcel cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk cv cG
      cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv caddc co wceq w3a vk
      cM cuz cfv wral cH cA cB caddc co cli wbr cF cA cli wbr cG cB cli wbr wa
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv
      cG cfv caddc co wceq w3a vk cM cuz cfv wral wa cA cB vk cF cG cH cM
      climadd.1 climadd.2 climadd.3 climadd.4 climadd.5 cF cA cli wbr cG cB cli
      wbr wa vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF
      cfv vk cv cG cfv caddc co wceq w3a vk cM cuz cfv wral wa biid climaddlem3
      an1s $.
      $( [13-Nov-2005] $) $( [24-Sep-2005] $)
  $}

  ${
    $d k A $.  $d k C $.  $d k F $.  $d k G $.  $d k M $.
    climaddc1.1 $e |- F e. _V $.
    climaddc1.2 $e |- G e. _V $.
    climaddc1.3 $e |- A e. _V $.
    climaddc1.4 $e |- C e. _V $.

    $( Limit of a constant ` C ` added to each term of a sequence. $)
    climaddc1 $p |- ( ( ( F ~~> A /\ C e. CC ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\
           ( G ` k ) = ( ( F ` k ) + C ) ) ) ) -> G ~~> ( A + C ) ) $=
      cF cA cli wbr cz cC csn cxp cC cli wbr wa cM cz wcel vk cv cF cfv cc wcel
      vk cv cz cC csn cxp cfv cc wcel vk cv cG cfv vk cv cF cfv vk cv cz cC csn
      cxp cfv caddc co wceq w3a vk cM cuz cfv wral wa cG cA cC caddc co cli wbr
      cF cA cli wbr cC cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv
      vk cv cF cfv cC caddc co wceq wa vk cM cuz cfv wral wa wa cA cC vk cF cz
      cC csn cxp cG cM climaddc1.1 cz cC csn zex cC snex xpex climaddc1.2
      climaddc1.3 climaddc1.4 climadd cF cA cli wbr cC cc wcel wa cF cA cli wbr
      cz cC csn cxp cC cli wbr wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv
      vk cv cF cfv cC caddc co wceq wa vk cM cuz cfv wral wa cC cc wcel cz cC
      csn cxp cC cli wbr cF cA cli wbr cC climconst2 anim2i adantr cF cA cli
      wbr cC cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cC caddc co wceq wa vk cM cuz cfv wral wa wa cM cz wcel vk cv cF cfv
      cc wcel vk cv cz cC csn cxp cfv cc wcel vk cv cG cfv vk cv cF cfv vk cv
      cz cC csn cxp cfv caddc co wceq w3a vk cM cuz cfv wral cF cA cli wbr cC
      cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC
      caddc co wceq wa vk cM cuz cfv wral simprl cC cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq wa vk cM cuz cfv wral vk
      cv cF cfv cc wcel vk cv cz cC csn cxp cfv cc wcel vk cv cG cfv vk cv cF
      cfv vk cv cz cC csn cxp cfv caddc co wceq w3a vk cM cuz cfv wral cF cA
      cli wbr cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cC caddc co wceq wa vk cM cuz cfv wral vk cv cF cfv cc wcel vk cv cz
      cC csn cxp cfv cc wcel vk cv cG cfv vk cv cF cfv vk cv cz cC csn cxp cfv
      caddc co wceq w3a vk cM cuz cfv wral cC cc wcel vk cv cF cfv cc wcel vk
      cv cG cfv vk cv cF cfv cC caddc co wceq wa vk cv cF cfv cc wcel vk cv cz
      cC csn cxp cfv cc wcel vk cv cG cfv vk cv cF cfv vk cv cz cC csn cxp cfv
      caddc co wceq w3a vk cM cuz cfv cC cc wcel vk cv cz wcel vk cv cF cfv cc
      wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq wa vk cv cF cfv cc wcel
      vk cv cz cC csn cxp cfv cc wcel vk cv cG cfv vk cv cF cfv vk cv cz cC csn
      cxp cfv caddc co wceq w3a wi vk cv cM cuz cfv wcel cC cc wcel vk cv cz
      wcel wa vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq
      wa vk cv cF cfv cc wcel vk cv cz cC csn cxp cfv cc wcel vk cv cG cfv vk
      cv cF cfv vk cv cz cC csn cxp cfv caddc co wceq w3a cC cc wcel vk cv cz
      wcel wa vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq
      wa wa vk cv cF cfv cc wcel vk cv cz cC csn cxp cfv cc wcel vk cv cG cfv
      vk cv cF cfv vk cv cz cC csn cxp cfv caddc co wceq cC cc wcel vk cv cz
      wcel wa vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq
      simprl cC cc wcel vk cv cz wcel wa vk cv cz cC csn cxp cfv cc wcel vk cv
      cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq wa cC cc wcel
      vk cv cz wcel wa vk cv cz cC csn cxp cfv cC cc cz cC vk cv cc fvconst2g
      cC cc wcel vk cv cz wcel pm3.26 eqeltrd adantr cC cc wcel vk cv cz wcel
      wa vk cv cG cfv vk cv cF cfv cC caddc co wceq vk cv cG cfv vk cv cF cfv
      vk cv cz cC csn cxp cfv caddc co wceq vk cv cF cfv cc wcel cC cc wcel vk
      cv cz wcel wa vk cv cG cfv vk cv cF cfv cC caddc co wceq wa vk cv cG cfv
      vk cv cF cfv cC caddc co vk cv cF cfv vk cv cz cC csn cxp cfv caddc co cC
      cc wcel vk cv cz wcel wa vk cv cG cfv vk cv cF cfv cC caddc co wceq
      pm3.27 cC cc wcel vk cv cz wcel wa vk cv cF cfv vk cv cz cC csn cxp cfv
      caddc co vk cv cF cfv cC caddc co wceq vk cv cG cfv vk cv cF cfv cC caddc
      co wceq cC cc wcel vk cv cz wcel wa vk cv cz cC csn cxp cfv cC vk cv cF
      cfv caddc cz cC vk cv cc fvconst2g opreq2d adantr eqtr4d adantrl 3jca ex
      cM vk cv eluzelz sylan2 r19.20dva imp ad2ant2l jca sylanc $.
      $( [16-Nov-2005] $) $( [24-Sep-2005] $)

    $( Limit of a constant ` C ` added to each term of a sequence. $)
    climaddc2 $p |- ( ( ( F ~~> A /\ C e. CC ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\
           ( G ` k ) = ( C + ( F ` k ) ) ) ) ) -> G ~~> ( C + A ) ) $=
      cF cA cli wbr cC cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv
      cC vk cv cF cfv caddc co wceq wa vk cM cuz cfv wral wa cM cz wcel vk cv
      cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq wa vk cM cuz
      cfv wral wa cG cC cA caddc co cli wbr cC cc wcel cM cz wcel vk cv cF cfv
      cc wcel vk cv cG cfv cC vk cv cF cfv caddc co wceq wa vk cM cuz cfv wral
      wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co
      wceq wa vk cM cuz cfv wral wa cF cA cli wbr cC cc wcel cM cz wcel vk cv
      cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv caddc co wceq wa vk cM cuz
      cfv wral wa wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv
      cC caddc co wceq wa vk cM cuz cfv wral cC cc wcel cM cz wcel vk cv cF cfv
      cc wcel vk cv cG cfv cC vk cv cF cfv caddc co wceq wa vk cM cuz cfv wral
      simprl cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv caddc
      co wceq wa vk cM cuz cfv wral vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cC caddc co wceq wa vk cM cuz cfv wral cM cz wcel cC cc wcel vk cv cF
      cfv cc wcel vk cv cG cfv cC vk cv cF cfv caddc co wceq wa vk cM cuz cfv
      wral vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC caddc co wceq wa
      vk cM cuz cfv wral cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv
      cF cfv caddc co wceq wa vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cC
      caddc co wceq wa vk cM cuz cfv cC cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv cC vk cv cF cfv caddc co wceq vk cv cG cfv vk cv cF cfv cC caddc co
      wceq cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv caddc
      co wceq vk cv cG cfv vk cv cF cfv cC caddc co wceq wi cC cc wcel vk cv cF
      cfv cc wcel wa vk cv cG cfv cC vk cv cF cfv caddc co wceq vk cv cG cfv vk
      cv cF cfv cC caddc co wceq cC cc wcel vk cv cF cfv cc wcel wa cC vk cv cF
      cfv caddc co vk cv cF cfv cC caddc co vk cv cG cfv cC vk cv cF cfv addcom
      eqeq2d biimpd ex imdistand r19.20sdv imp adantrl jca adantll cF cA cli
      wbr cC cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cC caddc co wceq wa vk cM cuz cfv wral wa wa cG cA cC caddc co cC cA
      caddc co cli cA cC vk cF cG cM climaddc1.1 climaddc1.2 climaddc1.3
      climaddc1.4 climaddc1 cF cA cli wbr cC cc wcel wa cA cC caddc co cC cA
      caddc co wceq cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv
      cC caddc co wceq wa vk cM cuz cfv wral wa cA cc wcel cC cc wcel cA cC
      caddc co cC cA caddc co wceq cF cA cli wbr cA cC addcom cA cvv wcel cF cA
      cli wbr cA cc wcel climaddc1.3 cA cvv cF climcl mpan sylan adantr breqtrd
      syldan $.
      $( [10-Jan-2006] $) $( [2-Jan-2006] $)
  $}

  $( Lemma for ~ climmul . $)
  climmullem1 $p |- ( ( A e. CC /\ ( v e. RR /\ 0 < v ) ) -> ( ( ( v / 2 ) /
  ( 1 + ( abs ` A ) ) ) e. RR /\ 0 < ( ( v / 2 ) / ( 1 + ( abs ` A ) ) ) ) ) $=
    cA cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cA
    cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cA cabs cfv caddc
    co cdiv co clt wbr cA cc wcel vv cv cr wcel vv cv c2 cdiv co c1 cA cabs cfv
    caddc co cdiv co cr wcel cc0 vv cv clt wbr vv cv cr wcel cA cc wcel vv cv
    c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel vv cv c2 cdiv co cr wcel
    c1 cA cabs cfv caddc co cr wcel c1 cA cabs cfv caddc co cc0 wne wa vv cv c2
    cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel vv cv cr wcel cA cc wcel vv
    cv c2 cdiv co cr wcel c1 cA cabs cfv caddc co cr wcel c1 cA cabs cfv caddc
    co cc0 wne vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel vv cv
    c2 cdiv co c1 cA cabs cfv caddc co redivcl 3expb vv cv rehalfcl cA cc wcel
    c1 cA cabs cfv caddc co cr wcel c1 cA cabs cfv caddc co cc0 wne c1 cr wcel
    cA cabs cfv cr wcel c1 cA cabs cfv caddc co cr wcel cA cc wcel c1 cA cabs
    cfv readdcl 1re cA abscl sylancr c1 cA cabs cfv caddc co cr wcel cc0 c1 cA
    cabs cfv caddc co clt wbr c1 cA cabs cfv caddc co cc0 wne cA cc wcel c1 cA
    cabs cfv caddc co gt0ne0 c1 cr wcel cA cabs cfv cr wcel c1 cA cabs cfv
    caddc co cr wcel cA cc wcel c1 cA cabs cfv readdcl 1re cA abscl sylancr cA
    cabs cfv cr wcel cc0 cA cabs cfv cle wbr cc0 c1 cA cabs cfv caddc co clt
    wbr cA cc wcel c1 cr wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr cc0
    c1 cA cabs cfv caddc co clt wbr 1re c1 cr wcel cA cabs cfv cr wcel wa cc0
    c1 clt wbr cc0 cA cabs cfv cle wbr cc0 c1 cA cabs cfv caddc co clt wbr lt01
    c1 cA cabs cfv addgtge0 mpanr1 mpanl1 cA abscl cA absge0 sylanc sylanc jca
    syl2an ancoms adantrr vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr
    c1 cA cabs cfv caddc co cr wcel cc0 c1 cA cabs cfv caddc co clt wbr cc0 vv
    cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr cA cc wcel vv cv cr
    wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cA cabs cfv caddc co
    divgt0 vv cv cr wcel vv cv c2 cdiv co cr wcel cA cc wcel cc0 vv cv clt wbr
    vv cv rehalfcl ad2antrl vv cv cr wcel cc0 vv cv clt wbr wa cc0 vv cv c2
    cdiv co clt wbr cA cc wcel vv cv cr wcel cc0 vv cv clt wbr cc0 vv cv c2
    cdiv co clt wbr vv cv halfpos2 biimpa adantl cA cc wcel c1 cA cabs cfv
    caddc co cr wcel vv cv cr wcel cc0 vv cv clt wbr wa c1 cr wcel cA cabs cfv
    cr wcel c1 cA cabs cfv caddc co cr wcel cA cc wcel c1 cA cabs cfv readdcl
    1re cA abscl sylancr adantr cA cc wcel cc0 c1 cA cabs cfv caddc co clt wbr
    vv cv cr wcel cc0 vv cv clt wbr wa cA cabs cfv cr wcel cc0 cA cabs cfv cle
    wbr cc0 c1 cA cabs cfv caddc co clt wbr cA cc wcel c1 cr wcel cA cabs cfv
    cr wcel cc0 cA cabs cfv cle wbr cc0 c1 cA cabs cfv caddc co clt wbr 1re c1
    cr wcel cA cabs cfv cr wcel wa cc0 c1 clt wbr cc0 cA cabs cfv cle wbr cc0
    c1 cA cabs cfv caddc co clt wbr lt01 c1 cA cabs cfv addgtge0 mpanr1 mpanl1
    cA abscl cA absge0 sylanc adantr syl2anc jca $.
    $( [9-Feb-2006] $) $( [28-Dec-2005] $)

  $( Lemma for ~ climmul . $)
  climmullem2 $p |- ( ( B e. CC /\ ( v e. RR /\ 0 < v ) ) ->
      ( ( 1 / ( 1 + ( 1 / ( ( v / 2 ) / ( 1 + ( abs ` B ) ) ) ) ) ) e. RR /\
        0 < ( 1 / ( 1 + ( 1 / ( ( v / 2 ) / ( 1 + ( abs ` B ) ) ) ) ) ) ) ) $=
    cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa c1 c1 c1 vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1
    c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
    co clt wbr c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co cr wcel c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cdiv co caddc co cc0 wne c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co caddc co cdiv co cr wcel cB cc wcel vv cv cr wcel cc0 vv cv
    clt wbr wa wa c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
    co caddc co rereccl c1 cr wcel c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co cr wcel c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co cdiv co caddc co cr wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa
    wa c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co readdcl
    1re vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cc0 wne c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co cr wcel cB cc wcel vv cv cr wcel cc0 vv cv clt
    wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co rereccl cB cc
    wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co clt wbr vv cB climmullem1 pm3.26d cB cc wcel vv cv cr wcel cc0 vv cv clt
    wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr wa vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cc0 wne vv cB climmullem1 vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co gt0ne0 syl sylanc sylancr c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cr wcel cc0 c1 c1
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co clt wbr
    c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cc0
    wne cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa c1 c1 vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cdiv co caddc co gt0ne0 c1 cr wcel c1 vv cv
    c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co cr wcel c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cr wcel cB cc wcel
    vv cv cr wcel cc0 vv cv clt wbr wa wa c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co readdcl 1re vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co cr wcel vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cc0 wne
    c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co cr wcel cB cc
    wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co rereccl cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co clt wbr vv cB climmullem1 pm3.26d cB cc
    wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cc0 wne vv
    cB climmullem1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co gt0ne0 syl
    sylanc sylancr c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    cr wcel cc0 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co clt
    wbr cc0 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co clt wbr cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa c1 cr
    wcel c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co cr wcel
    cc0 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co clt wbr cc0
    c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co clt
    wbr 1re c1 cr wcel c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
    co cr wcel wa cc0 c1 clt wbr cc0 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co cdiv co clt wbr cc0 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co cdiv co caddc co clt wbr lt01 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co addgt0 mpanr1 mpanl1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cr wcel vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cc0 wne c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    cr wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co rereccl cB cc wcel vv cv cr wcel cc0 vv cv
    clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr vv cB climmullem1
    pm3.26d cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co cc0 wne vv cB climmullem1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co gt0ne0 syl sylanc cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv
    c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co clt wbr wa cc0 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co clt wbr vv cB climmullem1 vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co recgt0 syl sylanc sylanc sylanc c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cr wcel cc0 c1 c1
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co clt wbr
    cc0 c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc
    co cdiv co clt wbr cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa c1 c1
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co recgt0 c1
    cr wcel c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co cr wcel
    c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cr
    wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa c1 c1 vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cdiv co readdcl 1re vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co cr wcel vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co cc0 wne c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
    co cr wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co rereccl cB cc wcel vv cv cr wcel cc0 vv
    cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel
    cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr vv cB
    climmullem1 pm3.26d cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv
    c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cc0 wne vv cB climmullem1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co gt0ne0 syl sylanc sylancr c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co cr wcel cc0 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co clt wbr cc0 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co caddc co clt wbr cB cc wcel vv cv cr wcel cc0 vv
    cv clt wbr wa wa c1 cr wcel c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co cr wcel cc0 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co clt wbr cc0 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co caddc co clt wbr 1re c1 cr wcel c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co cr wcel wa cc0 c1 clt wbr cc0 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co clt wbr cc0 c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co clt wbr lt01 c1 c1
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co addgt0 mpanr1
    mpanl1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cc0 wne c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co cr wcel cB cc wcel vv cv cr wcel cc0 vv
    cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co rereccl
    cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co clt wbr vv cB climmullem1 pm3.26d cB cc wcel vv cv cr wcel cc0
    vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr
    wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr wa vv cv
    c2 cdiv co c1 cB cabs cfv caddc co cdiv co cc0 wne vv cB climmullem1 vv cv
    c2 cdiv co c1 cB cabs cfv caddc co cdiv co gt0ne0 syl sylanc cB cc wcel vv
    cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt
    wbr wa cc0 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co clt
    wbr vv cB climmullem1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    recgt0 syl sylanc sylanc jca $.
    $( [9-Feb-2006] $) $( [28-Dec-2005] $)

  $( Lemma for ~ climmul . $)
  climmullem3 $p |- ( ( ( ( F e. CC /\ G e. CC ) /\ ( A e. CC /\ B e. CC ) /\
                       ( v e. RR /\ 0 < v ) ) /\ ( ( abs ` ( F - A ) ) < 1 /\
             ( abs ` ( G - B ) ) < ( ( v / 2 ) / ( 1 + ( abs ` A ) ) ) ) ) ->
             ( abs ` ( F x. ( G - B ) ) ) < ( v / 2 ) ) $=
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv
    clt wbr wa w3a cF cA cmin co cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv
    cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wa cF cabs cfv cG
    cB cmin co cabs cfv cmul co c1 cA cabs cfv caddc co vv cv c2 cdiv co c1 cA
    cabs cfv caddc co cdiv co cmul co cF cG cB cmin co cmul co cabs cfv vv cv
    c2 cdiv co clt cF cabs cfv cr wcel c1 cA cabs cfv caddc co cr wcel wa cc0
    cF cabs cfv cle wbr cF cabs cfv c1 cA cabs cfv caddc co clt wbr wa cG cB
    cmin co cabs cfv cr wcel vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
    cr wcel wa cc0 cG cB cmin co cabs cfv cle wbr cG cB cmin co cabs cfv vv cv
    c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cabs cfv cG cB
    cmin co cabs cfv cmul co c1 cA cabs cfv caddc co vv cv c2 cdiv co c1 cA
    cabs cfv caddc co cdiv co cmul co clt wbr cF cc wcel cG cc wcel wa cA cc
    wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co
    cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
    caddc co cdiv co clt wbr wa wa cF cabs cfv c1 cA cabs cfv caddc co cG cB
    cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co ltmul12a
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv
    clt wbr wa w3a cF cA cmin co cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv
    cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wa cF cabs cfv cr
    wcel c1 cA cabs cfv caddc co cr wcel cF cc wcel cG cc wcel wa cA cc wcel cB
    cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cabs cfv cr wcel cF cA
    cmin co cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
    cabs cfv caddc co cdiv co clt wbr wa cF cc wcel cG cc wcel wa cA cc wcel cB
    cc wcel wa cF cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc
    wcel cF cabs cfv cr wcel cG cc wcel cA cc wcel cB cc wcel wa cF abscl
    ad2antrr 3adant3 adantr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa
    vv cv cr wcel cc0 vv cv clt wbr wa w3a c1 cA cabs cfv caddc co cr wcel cF
    cA cmin co cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1
    cA cabs cfv caddc co cdiv co clt wbr wa cF cc wcel cG cc wcel wa cA cc wcel
    cB cc wcel wa c1 cA cabs cfv caddc co cr wcel vv cv cr wcel cc0 vv cv clt
    wbr wa cA cc wcel c1 cA cabs cfv caddc co cr wcel cF cc wcel cG cc wcel wa
    cB cc wcel c1 cr wcel cA cabs cfv cr wcel c1 cA cabs cfv caddc co cr wcel
    cA cc wcel c1 cA cabs cfv readdcl 1re cA abscl sylancr ad2antrl 3adant3
    adantr jca cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel
    cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 clt wbr cG cB cmin co
    cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wa cc0
    cF cabs cfv cle wbr cF cabs cfv c1 cA cabs cfv caddc co clt wbr cF cc wcel
    cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa
    w3a cc0 cF cabs cfv cle wbr cF cA cmin co cabs cfv c1 clt wbr cG cB cmin co
    cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cc
    wcel cG cc wcel wa cA cc wcel cB cc wcel wa cc0 cF cabs cfv cle wbr vv cv
    cr wcel cc0 vv cv clt wbr wa cF cc wcel cc0 cF cabs cfv cle wbr cG cc wcel
    cA cc wcel cB cc wcel wa cF absge0 ad2antrr 3adant3 adantr cF cc wcel cG cc
    wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF
    cA cmin co cabs cfv c1 clt wbr cF cabs cfv c1 cA cabs cfv caddc co clt wbr
    cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
    wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin co cabs
    cfv c1 clt wbr cF cabs cfv c1 cA cabs cfv caddc co clt wbr vv cv cr wcel
    cc0 vv cv clt wbr wa cF cc wcel cA cc wcel cB cc wcel wa cF cA cmin co cabs
    cfv c1 clt wbr cF cabs cfv c1 cA cabs cfv caddc co clt wbr cG cc wcel cF cc
    wcel cA cc wcel cF cA cmin co cabs cfv c1 clt wbr cF cabs cfv c1 cA cabs
    cfv caddc co clt wbr cB cc wcel cF cc wcel cA cc wcel wa cF cA cmin co cabs
    cfv c1 clt wbr wa cF cabs cfv cF cA cmin co cabs cfv cA cabs cfv caddc co
    cle wbr cF cA cmin co cabs cfv cA cabs cfv caddc co c1 cA cabs cfv caddc co
    clt wbr cF cabs cfv c1 cA cabs cfv caddc co clt wbr cF cc wcel cA cc wcel
    wa cF cabs cfv cF cA cmin co cabs cfv cA cabs cfv caddc co cle wbr cF cA
    cmin co cabs cfv c1 clt wbr cF cc wcel cA cc wcel wa cF cA cmin co cA caddc
    co cabs cfv cF cabs cfv cF cA cmin co cabs cfv cA cabs cfv caddc co cle cF
    cc wcel cA cc wcel wa cF cA cmin co cA caddc co cF cabs cF cA npcan fveq2d
    cF cc wcel cA cc wcel cF cA cmin co cc wcel cF cA cmin co cA caddc co cabs
    cfv cF cA cmin co cabs cfv cA cabs cfv caddc co cle wbr cF cA subcl cF cA
    cmin co cA abstri sylancom eqbrtrrd adantr cF cc wcel cA cc wcel wa cF cA
    cmin co cabs cfv c1 clt wbr cF cA cmin co cabs cfv cA cabs cfv caddc co c1
    cA cabs cfv caddc co clt wbr cF cA cmin co cabs cfv cr wcel c1 cr wcel cA
    cabs cfv cr wcel cF cA cmin co cabs cfv c1 clt wbr cF cA cmin co cabs cfv
    cA cabs cfv caddc co c1 cA cabs cfv caddc co clt wbr wb cF cc wcel cA cc
    wcel wa cF cA cmin co cabs cfv c1 cA cabs cfv ltadd1 cF cc wcel cA cc wcel
    wa cF cA cmin co cc wcel cF cA cmin co cabs cfv cr wcel cF cA subcl cF cA
    cmin co abscl syl c1 cr wcel cF cc wcel cA cc wcel wa 1re a1i cA cc wcel cA
    cabs cfv cr wcel cF cc wcel cA abscl adantl syl3anc biimpa cF cc wcel cA cc
    wcel wa cF cabs cfv cF cA cmin co cabs cfv cA cabs cfv caddc co cle wbr cF
    cA cmin co cabs cfv cA cabs cfv caddc co c1 cA cabs cfv caddc co clt wbr wa
    cF cabs cfv c1 cA cabs cfv caddc co clt wbr wi cF cA cmin co cabs cfv c1
    clt wbr cF cabs cfv cr wcel cF cA cmin co cabs cfv cA cabs cfv caddc co cr
    wcel c1 cA cabs cfv caddc co cr wcel cF cabs cfv cF cA cmin co cabs cfv cA
    cabs cfv caddc co cle wbr cF cA cmin co cabs cfv cA cabs cfv caddc co c1 cA
    cabs cfv caddc co clt wbr wa cF cabs cfv c1 cA cabs cfv caddc co clt wbr wi
    cF cc wcel cA cc wcel wa cF cabs cfv cF cA cmin co cabs cfv cA cabs cfv
    caddc co c1 cA cabs cfv caddc co lelttr cF cc wcel cF cabs cfv cr wcel cA
    cc wcel cF abscl adantr cF cA cmin co cabs cfv cr wcel cA cabs cfv cr wcel
    cF cA cmin co cabs cfv cA cabs cfv caddc co cr wcel cF cc wcel cA cc wcel
    wa cF cA cmin co cabs cfv cA cabs cfv readdcl cF cc wcel cA cc wcel wa cF
    cA cmin co cc wcel cF cA cmin co cabs cfv cr wcel cF cA subcl cF cA cmin co
    abscl syl cA cc wcel cA cabs cfv cr wcel cF cc wcel cA abscl adantl sylanc
    cA cc wcel c1 cA cabs cfv caddc co cr wcel cF cc wcel c1 cr wcel cA cabs
    cfv cr wcel c1 cA cabs cfv caddc co cr wcel cA cc wcel c1 cA cabs cfv
    readdcl 1re cA abscl sylancr adantl syl3anc adantr mp2and adantlrr adantllr
    3adantl3 adantrr jca cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv
    cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 clt wbr cG cB
    cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr
    wa wa cG cB cmin co cabs cfv cr wcel vv cv c2 cdiv co c1 cA cabs cfv caddc
    co cdiv co cr wcel cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv
    cr wcel cc0 vv cv clt wbr wa w3a cG cB cmin co cabs cfv cr wcel cF cA cmin
    co cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
    cfv caddc co cdiv co clt wbr wa cF cc wcel cG cc wcel wa cA cc wcel cB cc
    wcel wa cG cB cmin co cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa
    cG cc wcel cB cc wcel cG cB cmin co cabs cfv cr wcel cF cc wcel cA cc wcel
    cG cc wcel cB cc wcel wa cG cB cmin co cc wcel cG cB cmin co cabs cfv cr
    wcel cG cB subcl cG cB cmin co abscl syl ad2ant2l 3adant3 adantr cF cc wcel
    cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa
    w3a vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cF cA cmin co
    cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
    caddc co cdiv co clt wbr wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv
    cv clt wbr wa vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cF
    cc wcel cG cc wcel wa cA cc wcel vv cv cr wcel cc0 vv cv clt wbr wa vv cv
    c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cB cc wcel cA cc wcel vv
    cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cA cabs cfv caddc co
    cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
    wbr vv cA climmullem1 pm3.26d adantlr 3adant1 adantr jca cF cc wcel cG cc
    wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cc0
    cG cB cmin co cabs cfv cle wbr cF cA cmin co cabs cfv c1 clt wbr cG cB cmin
    co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cG
    cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
    wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cc0 cG cB cmin co
    cabs cfv cle wbr vv cv cr wcel cc0 vv cv clt wbr wa cG cc wcel cB cc wcel
    cc0 cG cB cmin co cabs cfv cle wbr cF cc wcel cA cc wcel cG cc wcel cB cc
    wcel wa cG cB cmin co cc wcel cc0 cG cB cmin co cabs cfv cle wbr cG cB
    subcl cG cB cmin co absge0 syl ad2ant2l 3adant3 cF cA cmin co cabs cfv c1
    clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
    cdiv co clt wbr pm3.27 anim12i syl2anc cF cc wcel cG cc wcel wa cA cc wcel
    cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv
    c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
    cdiv co clt wbr wa wa cF cG cB cmin co cmul co cabs cfv cF cabs cfv cG cB
    cmin co cabs cfv cmul co cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa
    vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cG cB cmin co cmul co cabs cfv cF
    cabs cfv cG cB cmin co cabs cfv cmul co wceq cF cA cmin co cabs cfv c1 clt
    wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
    clt wbr wa cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cG cB cmin
    co cmul co cabs cfv cF cabs cfv cG cB cmin co cabs cfv cmul co wceq vv cv
    cr wcel cc0 vv cv clt wbr wa cF cc wcel cG cc wcel wa cB cc wcel cF cG cB
    cmin co cmul co cabs cfv cF cabs cfv cG cB cmin co cabs cfv cmul co wceq cA
    cc wcel cF cc wcel cG cc wcel cB cc wcel cF cG cB cmin co cmul co cabs cfv
    cF cabs cfv cG cB cmin co cabs cfv cmul co wceq cF cc wcel cG cB cmin co cc
    wcel cF cG cB cmin co cmul co cabs cfv cF cabs cfv cG cB cmin co cabs cfv
    cmul co wceq cG cc wcel cB cc wcel wa cF cG cB cmin co absmul cG cB subcl
    sylan2 anassrs adantrl 3adant3 adantr eqcomd cF cc wcel cG cc wcel wa cA cc
    wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a c1 cA cabs cfv
    caddc co vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cmul co vv cv c2
    cdiv co wceq cF cA cmin co cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv
    c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cA cc wcel cB cc wcel
    wa vv cv cr wcel cc0 vv cv clt wbr wa c1 cA cabs cfv caddc co vv cv c2 cdiv
    co c1 cA cabs cfv caddc co cdiv co cmul co vv cv c2 cdiv co wceq cF cc wcel
    cG cc wcel wa cA cc wcel vv cv cr wcel c1 cA cabs cfv caddc co vv cv c2
    cdiv co c1 cA cabs cfv caddc co cdiv co cmul co vv cv c2 cdiv co wceq cB cc
    wcel cc0 vv cv clt wbr vv cv c2 cdiv co cc wcel c1 cA cabs cfv caddc co cc
    wcel c1 cA cabs cfv caddc co cc0 wne c1 cA cabs cfv caddc co vv cv c2 cdiv
    co c1 cA cabs cfv caddc co cdiv co cmul co vv cv c2 cdiv co wceq cA cc wcel
    vv cv cr wcel wa vv cv c2 cdiv co c1 cA cabs cfv caddc co divcan2 vv cv cr
    wcel vv cv c2 cdiv co cc wcel cA cc wcel vv cv cr wcel vv cv c2 cdiv co vv
    cv rehalfcl recnd adantl cA cc wcel c1 cA cabs cfv caddc co cc wcel vv cv
    cr wcel cA cc wcel c1 cA cabs cfv caddc co c1 cr wcel cA cabs cfv cr wcel
    c1 cA cabs cfv caddc co cr wcel cA cc wcel c1 cA cabs cfv readdcl 1re cA
    abscl sylancr recnd adantr cA cc wcel c1 cA cabs cfv caddc co cc0 wne vv cv
    cr wcel c1 cA cabs cfv caddc co cr wcel cc0 c1 cA cabs cfv caddc co clt wbr
    c1 cA cabs cfv caddc co cc0 wne cA cc wcel c1 cA cabs cfv caddc co gt0ne0
    c1 cr wcel cA cabs cfv cr wcel c1 cA cabs cfv caddc co cr wcel cA cc wcel
    c1 cA cabs cfv readdcl 1re cA abscl sylancr cA cabs cfv cr wcel cc0 cA cabs
    cfv cle wbr cc0 c1 cA cabs cfv caddc co clt wbr cA cc wcel c1 cr wcel cA
    cabs cfv cr wcel cc0 cA cabs cfv cle wbr cc0 c1 cA cabs cfv caddc co clt
    wbr 1re c1 cr wcel cA cabs cfv cr wcel wa cc0 c1 clt wbr cc0 cA cabs cfv
    cle wbr cc0 c1 cA cabs cfv caddc co clt wbr lt01 c1 cA cabs cfv addgtge0
    mpanr1 mpanl1 cA abscl cA absge0 sylanc sylanc adantr syl3anc ad2ant2r
    3adant1 adantr 3brtr3d $.
    $( [9-Feb-2006] $) $( [30-Dec-2005] $)

  $( Lemma for ~ climmul . $)
  climmullem4 $p |- ( ( ( ( F e. CC /\ G e. CC ) /\ ( A e. CC /\ B e. CC ) /\
                           ( v e. RR /\ 0 < v ) ) /\ ( abs ` ( F - A ) ) <
                 ( ( v / 2 ) / ( 1 + ( abs ` B ) ) ) ) ->
             ( abs ` ( ( F - A ) x. B ) ) < ( v / 2 ) ) $=
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv
    clt wbr wa w3a cF cA cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co clt wbr wa cF cA cmin co cB cmul co cabs cfv vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co cB cabs cfv cmul co cle wbr vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cB cabs cfv cmul co vv cv c2 cdiv co clt
    wbr cF cA cmin co cB cmul co cabs cfv vv cv c2 cdiv co clt wbr cF cc wcel
    cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa
    w3a cF cA cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    clt wbr wa cF cA cmin co cB cmul co cabs cfv cF cA cmin co cabs cfv cB cabs
    cfv cmul co vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB cabs cfv
    cmul co cle cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel
    cc0 vv cv clt wbr wa w3a cF cA cmin co cB cmul co cabs cfv cF cA cmin co
    cabs cfv cB cabs cfv cmul co wceq cF cA cmin co cabs cfv vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co clt wbr cF cc wcel cG cc wcel wa cA cc wcel
    cB cc wcel wa cF cA cmin co cB cmul co cabs cfv cF cA cmin co cabs cfv cB
    cabs cfv cmul co wceq vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cA cc
    wcel cB cc wcel wa cF cA cmin co cB cmul co cabs cfv cF cA cmin co cabs cfv
    cB cabs cfv cmul co wceq cG cc wcel cF cc wcel cA cc wcel cB cc wcel cF cA
    cmin co cB cmul co cabs cfv cF cA cmin co cabs cfv cB cabs cfv cmul co wceq
    cF cA cmin co cc wcel cB cc wcel cF cA cmin co cB cmul co cabs cfv cF cA
    cmin co cabs cfv cB cabs cfv cmul co wceq cF cc wcel cA cc wcel wa cF cA
    cmin co cB absmul cF cA subcl sylan anasss adantlr 3adant3 adantr cF cA
    cmin co cabs cfv cr wcel vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cr wcel cB cabs cfv cr wcel cc0 cB cabs cfv cle wbr wa w3a cF cA cmin co
    cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cle wbr cF cA
    cmin co cabs cfv cB cabs cfv cmul co vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co cB cabs cfv cmul co cle wbr cF cc wcel cG cc wcel wa cA cc wcel
    cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr wa cF cA cmin co
    cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB cabs cfv
    lemul1a cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0
    vv cv clt wbr wa w3a cF cA cmin co cabs cfv cr wcel vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cr wcel cB cabs cfv cr wcel cc0 cB cabs cfv cle
    wbr wa w3a cF cA cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co clt wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr
    wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv cr wcel vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cr wcel cB cabs cfv cr wcel cc0 cB cabs
    cfv cle wbr wa cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin
    co cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cA cc
    wcel cF cA cmin co cabs cfv cr wcel cG cc wcel cB cc wcel cF cc wcel cA cc
    wcel wa cF cA cmin co cc wcel cF cA cmin co cabs cfv cr wcel cF cA subcl cF
    cA cmin co abscl syl ad2ant2r 3adant3 cA cc wcel cB cc wcel wa vv cv cr
    wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cr wcel cF cc wcel cG cc wcel wa cB cc wcel vv cv cr wcel cc0 vv cv clt wbr
    wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cA cc wcel cB
    cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co clt wbr vv cB climmullem1 pm3.26d adantll 3adant1 cF cc wcel cG cc
    wcel wa cA cc wcel cB cc wcel wa cB cabs cfv cr wcel cc0 cB cabs cfv cle
    wbr wa vv cv cr wcel cc0 vv cv clt wbr wa cB cc wcel cB cabs cfv cr wcel
    cc0 cB cabs cfv cle wbr wa cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel
    cB cabs cfv cr wcel cc0 cB cabs cfv cle wbr cB abscl cB absge0 jca ad2antll
    3adant3 3jca adantr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv
    cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co clt wbr cF cA cmin co cabs cfv vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cle wbr cF cA cmin co cabs cfv cr wcel
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cF cA cmin co cabs
    cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr cF cA cmin co
    cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cle wbr wi cF cc
    wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr
    wa w3a cF cA cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co ltle cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin co
    cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cA cc wcel
    cF cA cmin co cabs cfv cr wcel cG cc wcel cB cc wcel cF cc wcel cA cc wcel
    wa cF cA cmin co cc wcel cF cA cmin co cabs cfv cr wcel cF cA subcl cF cA
    cmin co abscl syl ad2ant2r 3adant3 cA cc wcel cB cc wcel wa vv cv cr wcel
    cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr
    wcel cF cc wcel cG cc wcel wa cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cA cc wcel cB cc
    wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co clt wbr vv cB climmullem1 pm3.26d adantll 3adant1 sylanc imp sylanc
    eqbrtrd cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0
    vv cv clt wbr wa w3a vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB
    cabs cfv cmul co vv cv c2 cdiv co clt wbr cF cA cmin co cabs cfv vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr cA cc wcel cB cc wcel wa vv
    cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cB cabs cfv cmul co vv cv c2 cdiv co clt wbr cF cc wcel cG cc wcel
    wa cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cB cabs cfv cmul co vv cv c2 cdiv co clt wbr cA
    cc wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa cB cabs cfv c1 cB
    cabs cfv caddc co cdiv co vv cv c2 cdiv co cmul co c1 vv cv c2 cdiv co cmul
    co vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB cabs cfv cmul co vv
    cv c2 cdiv co clt cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa cB cabs
    cfv c1 cB cabs cfv caddc co cdiv co c1 clt wbr cB cabs cfv c1 cB cabs cfv
    caddc co cdiv co vv cv c2 cdiv co cmul co c1 vv cv c2 cdiv co cmul co clt
    wbr cB cc wcel cB cabs cfv c1 cB cabs cfv caddc co cdiv co c1 clt wbr vv cv
    cr wcel cc0 vv cv clt wbr wa cB cabs cfv cr wcel cc0 cB cabs cfv cle wbr cB
    cabs cfv c1 cB cabs cfv caddc co cdiv co c1 clt wbr cB cc wcel cB cabs cfv
    recp1lt1 cB abscl cB absge0 sylanc adantr cB cabs cfv c1 cB cabs cfv caddc
    co cdiv co cr wcel vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa
    cB cabs cfv c1 cB cabs cfv caddc co cdiv co c1 clt wbr cB cabs cfv c1 cB
    cabs cfv caddc co cdiv co vv cv c2 cdiv co cmul co c1 vv cv c2 cdiv co cmul
    co clt wbr wb cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa cB cabs cfv c1
    cB cabs cfv caddc co cdiv co cr wcel c1 cr wcel vv cv c2 cdiv co cr wcel
    cc0 vv cv c2 cdiv co clt wbr wa cB cabs cfv c1 cB cabs cfv caddc co cdiv co
    c1 clt wbr cB cabs cfv c1 cB cabs cfv caddc co cdiv co vv cv c2 cdiv co
    cmul co c1 vv cv c2 cdiv co cmul co clt wbr wb 1re cB cabs cfv c1 cB cabs
    cfv caddc co cdiv co c1 vv cv c2 cdiv co ltmul1 mp3an2 cB cabs cfv cr wcel
    c1 cB cabs cfv caddc co cr wcel c1 cB cabs cfv caddc co cc0 wne cB cabs cfv
    c1 cB cabs cfv caddc co cdiv co cr wcel cB cc wcel cB cabs cfv c1 cB cabs
    cfv caddc co redivcl cB abscl c1 cr wcel cB cabs cfv cr wcel c1 cB cabs cfv
    caddc co cr wcel cB cc wcel c1 cB cabs cfv readdcl 1re cB abscl sylancr c1
    cB cabs cfv caddc co cr wcel cc0 c1 cB cabs cfv caddc co clt wbr c1 cB cabs
    cfv caddc co cc0 wne cB cc wcel c1 cB cabs cfv caddc co gt0ne0 c1 cr wcel
    cB cabs cfv cr wcel c1 cB cabs cfv caddc co cr wcel cB cc wcel c1 cB cabs
    cfv readdcl 1re cB abscl sylancr cB cabs cfv cr wcel cc0 cB cabs cfv cle
    wbr cc0 c1 cB cabs cfv caddc co clt wbr cB cc wcel c1 cr wcel cB cabs cfv
    cr wcel cc0 cB cabs cfv cle wbr cc0 c1 cB cabs cfv caddc co clt wbr 1re c1
    cr wcel cB cabs cfv cr wcel wa cc0 c1 clt wbr cc0 cB cabs cfv cle wbr cc0
    c1 cB cabs cfv caddc co clt wbr lt01 c1 cB cabs cfv addgtge0 mpanr1 mpanl1
    cB abscl cB absge0 sylanc sylanc syl3anc vv cv cr wcel cc0 vv cv clt wbr wa
    vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr vv cv cr wcel vv cv
    c2 cdiv co cr wcel cc0 vv cv clt wbr vv cv rehalfcl adantr vv cv cr wcel
    cc0 vv cv clt wbr cc0 vv cv c2 cdiv co clt wbr vv cv halfpos2 biimpa jca
    syl2an mpbid cB cabs cfv cc wcel c1 cB cabs cfv caddc co cc wcel c1 cB cabs
    cfv caddc co cc0 wne wa vv cv c2 cdiv co cc wcel cB cabs cfv c1 cB cabs cfv
    caddc co cdiv co vv cv c2 cdiv co cmul co vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cB cabs cfv cmul co wceq cB cc wcel vv cv cr wcel cc0 vv
    cv clt wbr wa wa cB cabs cfv c1 cB cabs cfv caddc co vv cv c2 cdiv co div13
    cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa cB cabs cfv cB cc wcel cB
    cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cB abscl adantr recnd
    cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa c1 cB cabs cfv caddc co cc
    wcel c1 cB cabs cfv caddc co cc0 wne cB cc wcel c1 cB cabs cfv caddc co cc
    wcel vv cv cr wcel cc0 vv cv clt wbr wa cB cc wcel c1 cB cabs cfv caddc co
    c1 cr wcel cB cabs cfv cr wcel c1 cB cabs cfv caddc co cr wcel cB cc wcel
    c1 cB cabs cfv readdcl 1re cB abscl sylancr recnd adantr cB cc wcel c1 cB
    cabs cfv caddc co cc0 wne vv cv cr wcel cc0 vv cv clt wbr wa c1 cB cabs cfv
    caddc co cr wcel cc0 c1 cB cabs cfv caddc co clt wbr c1 cB cabs cfv caddc
    co cc0 wne cB cc wcel c1 cB cabs cfv caddc co gt0ne0 c1 cr wcel cB cabs cfv
    cr wcel c1 cB cabs cfv caddc co cr wcel cB cc wcel c1 cB cabs cfv readdcl
    1re cB abscl sylancr cB cabs cfv cr wcel cc0 cB cabs cfv cle wbr cc0 c1 cB
    cabs cfv caddc co clt wbr cB cc wcel c1 cr wcel cB cabs cfv cr wcel cc0 cB
    cabs cfv cle wbr cc0 c1 cB cabs cfv caddc co clt wbr 1re c1 cr wcel cB cabs
    cfv cr wcel wa cc0 c1 clt wbr cc0 cB cabs cfv cle wbr cc0 c1 cB cabs cfv
    caddc co clt wbr lt01 c1 cB cabs cfv addgtge0 mpanr1 mpanl1 cB abscl cB
    absge0 sylanc sylanc adantr jca vv cv cr wcel vv cv c2 cdiv co cc wcel cB
    cc wcel cc0 vv cv clt wbr vv cv cr wcel vv cv c2 cdiv co vv cv rehalfcl
    recnd ad2antrl syl3anc vv cv cr wcel c1 vv cv c2 cdiv co cmul co vv cv c2
    cdiv co wceq cB cc wcel cc0 vv cv clt wbr vv cv cr wcel vv cv c2 cdiv co cc
    wcel c1 vv cv c2 cdiv co cmul co vv cv c2 cdiv co wceq vv cv cr wcel vv cv
    c2 cdiv co vv cv rehalfcl recnd vv cv c2 cdiv co mulid2 syl ad2antrl
    3brtr3d adantll 3adant1 adantr cF cc wcel cG cc wcel wa cA cc wcel cB cc
    wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cB cmul co
    cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB cabs cfv cmul
    co cle wbr vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB cabs cfv
    cmul co vv cv c2 cdiv co clt wbr wa cF cA cmin co cB cmul co cabs cfv vv cv
    c2 cdiv co clt wbr wi cF cA cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co clt wbr cF cA cmin co cB cmul co cabs cfv cr wcel vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cB cabs cfv cmul co cr wcel
    vv cv c2 cdiv co cr wcel cF cA cmin co cB cmul co cabs cfv vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cB cabs cfv cmul co cle wbr vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cB cabs cfv cmul co vv cv c2 cdiv co clt
    wbr wa cF cA cmin co cB cmul co cabs cfv vv cv c2 cdiv co clt wbr wi cF cc
    wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr
    wa w3a cF cA cmin co cB cmul co cabs cfv vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cB cabs cfv cmul co vv cv c2 cdiv co lelttr cF cc wcel cG
    cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin co cB cmul co cabs cfv cr
    wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cA cc wcel cB cc wcel wa
    cF cA cmin co cB cmul co cabs cfv cr wcel cG cc wcel cF cc wcel cA cc wcel
    cB cc wcel wa wa cF cA cmin co cB cmul co cc wcel cF cA cmin co cB cmul co
    cabs cfv cr wcel cF cc wcel cA cc wcel cB cc wcel cF cA cmin co cB cmul co
    cc wcel cF cA cmin co cc wcel cB cc wcel cF cA cmin co cB cmul co cc wcel
    cF cc wcel cA cc wcel wa cF cA cmin co cB mulcl cF cA subcl sylan anasss cF
    cA cmin co cB cmul co abscl syl adantlr 3adant3 cA cc wcel cB cc wcel wa vv
    cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cB cabs cfv cmul co cr wcel cF cc wcel cG cc wcel wa cB cc wcel vv
    cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cB cabs cfv cmul co cr wcel cA cc wcel vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cr wcel cB cabs cfv cr wcel vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cB cabs cfv cmul co cr wcel cB cc wcel vv cv cr
    wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co cB cabs cfv remulcl cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co clt wbr vv cB climmullem1 pm3.26d cB cc
    wcel cB cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cB abscl adantr
    sylanc adantll 3adant1 cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt
    wbr wa vv cv c2 cdiv co cr wcel cF cc wcel cG cc wcel wa vv cv cr wcel vv
    cv c2 cdiv co cr wcel cA cc wcel cB cc wcel wa cc0 vv cv clt wbr vv cv
    rehalfcl ad2antrl 3adant1 syl3anc adantr mp2and $.
    $( [10-Feb-2006] $) $( [30-Dec-2005] $)

  $( Lemma for ~ climmul .  Instead of the infimum that Gleason uses (bottom
     of p. 170), we use ~ recreclt to give us a number smaller than both a
     given number and 1.  _Warning:  The HTML proof page is 1/2 megabyte in
     size_. $)
  climmullem5 $p |- ( ( ( F e. CC /\ G e. CC ) /\ ( A e. CC /\ B e. CC ) /\
                           ( v e. RR /\ 0 < v ) ) -> ( ( ( abs ` ( F - A ) ) <
                 ( 1 / ( 1 + ( 1 / ( ( v / 2 ) / ( 1 + ( abs ` B ) ) ) ) ) ) /\
                ( abs ` ( G - B ) ) < ( ( v / 2 ) / ( 1 + ( abs ` A ) ) ) ) ->
                ( abs ` ( ( F x. G ) - ( A x. B ) ) ) < v ) ) $=
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv
    clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cG cB cmin co cabs
    cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cG cmul
    co cA cB cmul co cmin co cabs cfv vv cv clt wbr cF cc wcel cG cc wcel wa cA
    cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co
    cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co cdiv co clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
    cfv caddc co cdiv co clt wbr wa wa cF cG cmul co cA cB cmul co cmin co cabs
    cfv vv cv c2 cdiv co vv cv c2 cdiv co caddc co vv cv clt cF cc wcel cG cc
    wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF
    cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co cdiv co caddc co cdiv co clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co
    c1 cA cabs cfv caddc co cdiv co clt wbr wa wa cF cG cmul co cA cB cmul co
    cmin co cabs cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co
    cabs cfv caddc co cle wbr cF cG cB cmin co cmul co cabs cfv cF cA cmin co
    cB cmul co cabs cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc co clt
    wbr cF cG cmul co cA cB cmul co cmin co cabs cfv vv cv c2 cdiv co vv cv c2
    cdiv co caddc co clt wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa
    vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cG cmul co cA cB cmul co cmin co
    cabs cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs
    cfv caddc co cle wbr cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cG cB cmin co
    cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cc
    wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cG cmul co cA cB cmul co
    cmin co cabs cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co
    cabs cfv caddc co cle wbr vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cG
    cc wcel wa cA cc wcel cB cc wcel wa wa cF cG cmul co cA cB cmul co cmin co
    cabs cfv cF cG cB cmin co cmul co cF cA cmin co cB cmul co caddc co cabs
    cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs cfv
    caddc co cle cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa wa cF cG
    cmul co cA cB cmul co cmin co cF cG cB cmin co cmul co cF cA cmin co cB
    cmul co caddc co cabs cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa wa
    cF cG cB cmin co cmul co cF cA cmin co cB cmul co caddc co cF cG cmul co cF
    cB cmul co cmin co cF cB cmul co cA cB cmul co cmin co caddc co cF cG cmul
    co cA cB cmul co cmin co cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa
    wa cF cG cB cmin co cmul co cF cG cmul co cF cB cmul co cmin co cF cA cmin
    co cB cmul co cF cB cmul co cA cB cmul co cmin co caddc cF cc wcel cG cc
    wcel wa cB cc wcel cF cG cB cmin co cmul co cF cG cmul co cF cB cmul co
    cmin co wceq cA cc wcel cF cc wcel cG cc wcel cB cc wcel cF cG cB cmin co
    cmul co cF cG cmul co cF cB cmul co cmin co wceq cF cG cB subdi 3expa
    adantrl cF cc wcel cA cc wcel cB cc wcel wa cF cA cmin co cB cmul co cF cB
    cmul co cA cB cmul co cmin co wceq cG cc wcel cF cc wcel cA cc wcel cB cc
    wcel cF cA cmin co cB cmul co cF cB cmul co cA cB cmul co cmin co wceq cF
    cA cB subdir 3expb adantlr opreq12d cF cG cmul co cc wcel cF cB cmul co cc
    wcel cA cB cmul co cc wcel cF cG cmul co cF cB cmul co cmin co cF cB cmul
    co cA cB cmul co cmin co caddc co cF cG cmul co cA cB cmul co cmin co wceq
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa wa cF cG cmul co cF cB
    cmul co cA cB cmul co npncan cF cc wcel cG cc wcel wa cF cG cmul co cc wcel
    cA cc wcel cB cc wcel wa cF cG mulcl adantr cF cc wcel cB cc wcel cF cB
    cmul co cc wcel cG cc wcel cA cc wcel cF cB mulcl ad2ant2rl cA cc wcel cB
    cc wcel wa cA cB cmul co cc wcel cF cc wcel cG cc wcel wa cA cB mulcl
    adantl syl3anc eqtr2d fveq2d cF cG cB cmin co cmul co cc wcel cF cA cmin co
    cB cmul co cc wcel cF cG cB cmin co cmul co cF cA cmin co cB cmul co caddc
    co cabs cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs
    cfv caddc co cle wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa wa
    cF cG cB cmin co cmul co cF cA cmin co cB cmul co abstri cF cc wcel cG cc
    wcel wa cB cc wcel cF cG cB cmin co cmul co cc wcel cA cc wcel cF cc wcel
    cG cc wcel cB cc wcel cF cG cB cmin co cmul co cc wcel cF cc wcel cG cB
    cmin co cc wcel cF cG cB cmin co cmul co cc wcel cG cc wcel cB cc wcel wa
    cF cG cB cmin co mulcl cG cB subcl sylan2 anassrs adantrl cF cc wcel cA cc
    wcel cB cc wcel wa cF cA cmin co cB cmul co cc wcel cG cc wcel cF cc wcel
    cA cc wcel cB cc wcel cF cA cmin co cB cmul co cc wcel cF cA cmin co cc
    wcel cB cc wcel cF cA cmin co cB cmul co cc wcel cF cc wcel cA cc wcel wa
    cF cA cmin co cB mulcl cF cA subcl sylan anasss adantlr sylanc eqbrtrd
    3adant3 adantr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr
    wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cG cB
    cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr
    wa wa cF cG cB cmin co cmul co cabs cfv vv cv c2 cdiv co clt wbr cF cA cmin
    co cB cmul co cabs cfv vv cv c2 cdiv co clt wbr cF cG cB cmin co cmul co
    cabs cfv cF cA cmin co cB cmul co cabs cfv caddc co vv cv c2 cdiv co vv cv
    c2 cdiv co caddc co clt wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel
    wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co
    clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
    cdiv co clt wbr wa cF cA cmin co cabs cfv c1 clt wbr cG cB cmin co cabs cfv
    vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cG cB cmin
    co cmul co cabs cfv vv cv c2 cdiv co clt wbr cF cc wcel cG cc wcel wa cA cc
    wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co
    cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co cdiv co clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
    cfv caddc co cdiv co clt wbr wa cF cA cmin co cabs cfv c1 clt wbr cG cB
    cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr
    wa cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv
    cv clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cF cA cmin co
    cabs cfv c1 clt wbr cG cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
    caddc co cdiv co clt wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa
    vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
    wbr c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc
    co cdiv co c1 clt wbr cF cA cmin co cabs cfv c1 clt wbr cA cc wcel cB cc
    wcel wa vv cv cr wcel cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co c1 clt wbr cF cc wcel cG
    cc wcel wa cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co c1 clt wbr
    cA cc wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co caddc co cdiv co c1 clt wbr vv cB climmullem1 vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co c1 clt wbr c1 c1 c1 vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co recreclt pm3.26d syl adantll 3adant1 cF cA
    cmin co cabs cfv cr wcel c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co caddc co cdiv co cr wcel cF cA cmin co cabs cfv c1 c1 c1 vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
    wbr c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc
    co cdiv co c1 clt wbr wa cF cA cmin co cabs cfv c1 clt wbr wi cF cc wcel cG
    cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a
    cF cA cmin co cabs cfv cr wcel c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co caddc co cdiv co cr wcel c1 cr wcel cF cA cmin co
    cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co cdiv co clt wbr c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co caddc co cdiv co c1 clt wbr wa cF cA cmin co cabs cfv c1
    clt wbr wi 1re cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co caddc co cdiv co c1 axlttrn mp3an3 cF cc wcel
    cG cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin co cabs cfv cr wcel vv cv
    cr wcel cc0 vv cv clt wbr wa cF cc wcel cA cc wcel cF cA cmin co cabs cfv
    cr wcel cG cc wcel cB cc wcel cF cc wcel cA cc wcel wa cF cA cmin co cc
    wcel cF cA cmin co cabs cfv cr wcel cF cA subcl cF cA cmin co abscl syl
    ad2ant2r 3adant3 cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr
    wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc
    co cdiv co cr wcel cF cc wcel cG cc wcel wa cB cc wcel vv cv cr wcel cc0 vv
    cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cdiv co caddc co cdiv co cr wcel cA cc wcel cB cc wcel vv cv cr wcel cc0 vv
    cv clt wbr wa wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vv cB climmullem2
    pm3.26d adantll 3adant1 sylanc mpan2d anim1d imp vv cA cB cF cG climmullem3
    syldan cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0
    vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cF cA cmin co cB
    cmul co cabs cfv vv cv c2 cdiv co clt wbr cG cB cmin co cabs cfv vv cv c2
    cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr cF cc wcel cG cc wcel wa cA
    cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin co
    cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co cdiv co clt wbr cF cA cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co clt wbr cF cA cmin co cB cmul co cabs cfv vv cv c2
    cdiv co clt wbr cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr
    wcel cc0 vv cv clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cF cA
    cmin co cabs cfv vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv
    clt wbr wa w3a cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr c1 c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr cF cA cmin co cabs cfv vv
    cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr cA cc wcel cB cc wcel
    wa vv cv cr wcel cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co caddc co cdiv co vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co clt wbr cF cc wcel cG cc wcel wa cB cc wcel vv cv cr
    wcel cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co cdiv co caddc co cdiv co vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co clt wbr cA cc wcel cB cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa
    vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv
    co c1 cB cabs cfv caddc co cdiv co clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co clt wbr vv cB climmullem1 vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co cdiv co caddc co cdiv co c1 clt wbr c1 c1 c1 vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co vv cv c2 cdiv co c1
    cB cabs cfv caddc co cdiv co clt wbr vv cv c2 cdiv co c1 cB cabs cfv caddc
    co cdiv co recreclt pm3.27d syl adantll 3adant1 cF cA cmin co cabs cfv cr
    wcel c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
    caddc co cdiv co cr wcel vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cr wcel cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co caddc co cdiv co clt wbr c1 c1 c1 vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co vv cv c2 cdiv co
    c1 cB cabs cfv caddc co cdiv co clt wbr wa cF cA cmin co cabs cfv vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co clt wbr wi cF cc wcel cG cc wcel wa
    cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cA cmin
    co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
    co caddc co cdiv co vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    axlttrn cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin co
    cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cA cc wcel
    cF cA cmin co cabs cfv cr wcel cG cc wcel cB cc wcel cF cc wcel cA cc wcel
    wa cF cA cmin co cc wcel cF cA cmin co cabs cfv cr wcel cF cA subcl cF cA
    cmin co abscl syl ad2ant2r 3adant3 cA cc wcel cB cc wcel wa vv cv cr wcel
    cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
    co cdiv co caddc co cdiv co cr wcel cF cc wcel cG cc wcel wa cB cc wcel vv
    cv cr wcel cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co caddc co cdiv co cr wcel cA cc wcel cB cc wcel vv
    cv cr wcel cc0 vv cv clt wbr wa wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
    caddc co cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2
    cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vv
    cB climmullem2 pm3.26d adantll 3adant1 cA cc wcel cB cc wcel wa vv cv cr
    wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
    cr wcel cF cc wcel cG cc wcel wa cB cc wcel vv cv cr wcel cc0 vv cv clt wbr
    wa vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cr wcel cA cc wcel cB
    cc wcel vv cv cr wcel cc0 vv cv clt wbr wa wa vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cB cabs cfv caddc co
    cdiv co clt wbr vv cB climmullem1 pm3.26d adantll 3adant1 syl3anc mpan2d
    imp vv cA cB cF cG climmullem4 syldan adantrr cF cc wcel cG cc wcel wa cA
    cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cG cB cmin
    co cmul co cabs cfv vv cv c2 cdiv co clt wbr cF cA cmin co cB cmul co cabs
    cfv vv cv c2 cdiv co clt wbr wa cF cG cB cmin co cmul co cabs cfv cF cA
    cmin co cB cmul co cabs cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co
    caddc co clt wbr wi cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cG cB cmin co
    cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cG
    cB cmin co cmul co cabs cfv cr wcel cF cA cmin co cB cmul co cabs cfv cr
    wcel wa vv cv c2 cdiv co cr wcel vv cv c2 cdiv co cr wcel wa cF cG cB cmin
    co cmul co cabs cfv vv cv c2 cdiv co clt wbr cF cA cmin co cB cmul co cabs
    cfv vv cv c2 cdiv co clt wbr wa cF cG cB cmin co cmul co cabs cfv cF cA
    cmin co cB cmul co cabs cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co
    caddc co clt wbr wi cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv
    cr wcel cc0 vv cv clt wbr wa w3a cF cG cB cmin co cmul co cabs cfv cF cA
    cmin co cB cmul co cabs cfv vv cv c2 cdiv co vv cv c2 cdiv co lt2add cF cc
    wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr
    wa w3a cF cG cB cmin co cmul co cabs cfv cr wcel cF cA cmin co cB cmul co
    cabs cfv cr wcel cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cG cB
    cmin co cmul co cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc
    wcel cG cc wcel wa cB cc wcel cF cG cB cmin co cmul co cabs cfv cr wcel cA
    cc wcel cF cc wcel cG cc wcel wa cB cc wcel wa cF cG cB cmin co cmul co cc
    wcel cF cG cB cmin co cmul co cabs cfv cr wcel cF cc wcel cG cc wcel cB cc
    wcel cF cG cB cmin co cmul co cc wcel cF cc wcel cG cB cmin co cc wcel cF
    cG cB cmin co cmul co cc wcel cG cc wcel cB cc wcel wa cF cG cB cmin co
    mulcl cG cB subcl sylan2 anassrs cF cG cB cmin co cmul co abscl syl adantrl
    3adant3 cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cA cmin co cB
    cmul co cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cA
    cc wcel cB cc wcel wa cF cA cmin co cB cmul co cabs cfv cr wcel cG cc wcel
    cF cc wcel cA cc wcel cB cc wcel wa wa cF cA cmin co cB cmul co cc wcel cF
    cA cmin co cB cmul co cabs cfv cr wcel cF cc wcel cA cc wcel cB cc wcel cF
    cA cmin co cB cmul co cc wcel cF cA cmin co cc wcel cB cc wcel cF cA cmin
    co cB cmul co cc wcel cF cc wcel cA cc wcel wa cF cA cmin co cB mulcl cF cA
    subcl sylan anasss cF cA cmin co cB cmul co abscl syl adantlr 3adant3 jca
    cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv
    co cr wcel vv cv c2 cdiv co cr wcel wa cF cc wcel cG cc wcel wa vv cv cr
    wcel vv cv c2 cdiv co cr wcel vv cv c2 cdiv co cr wcel wa cA cc wcel cB cc
    wcel wa cc0 vv cv clt wbr vv cv cr wcel vv cv c2 cdiv co cr wcel vv cv c2
    cdiv co cr wcel vv cv rehalfcl vv cv rehalfcl jca ad2antrl 3adant1 sylanc
    adantr mp2and cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv cv cr
    wcel cc0 vv cv clt wbr wa w3a cF cG cmul co cA cB cmul co cmin co cabs cfv
    cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs cfv caddc
    co cle wbr cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs
    cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc co clt wbr wa cF cG
    cmul co cA cB cmul co cmin co cabs cfv vv cv c2 cdiv co vv cv c2 cdiv co
    caddc co clt wbr wi cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
    cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cG cB cmin co
    cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cF cG
    cmul co cA cB cmul co cmin co cabs cfv cr wcel cF cG cB cmin co cmul co
    cabs cfv cF cA cmin co cB cmul co cabs cfv caddc co cr wcel vv cv c2 cdiv
    co vv cv c2 cdiv co caddc co cr wcel cF cG cmul co cA cB cmul co cmin co
    cabs cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs
    cfv caddc co cle wbr cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB
    cmul co cabs cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc co clt
    wbr wa cF cG cmul co cA cB cmul co cmin co cabs cfv vv cv c2 cdiv co vv cv
    c2 cdiv co caddc co clt wbr wi cF cc wcel cG cc wcel wa cA cc wcel cB cc
    wcel wa vv cv cr wcel cc0 vv cv clt wbr wa w3a cF cG cmul co cA cB cmul co
    cmin co cabs cfv cF cG cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co
    cabs cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc co lelttr cF cc
    wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cG cmul co cA cB cmul co
    cmin co cabs cfv cr wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cc wcel cG
    cc wcel wa cA cc wcel cB cc wcel wa wa cF cG cmul co cA cB cmul co cmin co
    cc wcel cF cG cmul co cA cB cmul co cmin co cabs cfv cr wcel cF cG cmul co
    cc wcel cA cB cmul co cc wcel cF cG cmul co cA cB cmul co cmin co cc wcel
    cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cG cmul co cA cB cmul
    co subcl cF cG mulcl cA cB mulcl syl2an cF cG cmul co cA cB cmul co cmin co
    abscl syl 3adant3 cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa cF cG
    cB cmin co cmul co cabs cfv cF cA cmin co cB cmul co cabs cfv caddc co cr
    wcel vv cv cr wcel cc0 vv cv clt wbr wa cF cG cB cmin co cmul co cabs cfv
    cr wcel cF cA cmin co cB cmul co cabs cfv cr wcel cF cG cB cmin co cmul co
    cabs cfv cF cA cmin co cB cmul co cabs cfv caddc co cr wcel cF cc wcel cG
    cc wcel wa cA cc wcel cB cc wcel wa wa cF cG cB cmin co cmul co cabs cfv cF
    cA cmin co cB cmul co cabs cfv readdcl cF cc wcel cG cc wcel wa cB cc wcel
    cF cG cB cmin co cmul co cabs cfv cr wcel cA cc wcel cF cc wcel cG cc wcel
    wa cB cc wcel wa cF cG cB cmin co cmul co cc wcel cF cG cB cmin co cmul co
    cabs cfv cr wcel cF cc wcel cG cc wcel cB cc wcel cF cG cB cmin co cmul co
    cc wcel cF cc wcel cG cB cmin co cc wcel cF cG cB cmin co cmul co cc wcel
    cG cc wcel cB cc wcel wa cF cG cB cmin co mulcl cG cB subcl sylan2 anassrs
    cF cG cB cmin co cmul co abscl syl adantrl cF cc wcel cA cc wcel cB cc wcel
    wa cF cA cmin co cB cmul co cabs cfv cr wcel cG cc wcel cF cc wcel cA cc
    wcel cB cc wcel wa wa cF cA cmin co cB cmul co cc wcel cF cA cmin co cB
    cmul co cabs cfv cr wcel cF cc wcel cA cc wcel cB cc wcel cF cA cmin co cB
    cmul co cc wcel cF cA cmin co cc wcel cB cc wcel cF cA cmin co cB cmul co
    cc wcel cF cc wcel cA cc wcel wa cF cA cmin co cB mulcl cF cA subcl sylan
    anasss cF cA cmin co cB cmul co abscl syl adantlr sylanc 3adant3 cA cc wcel
    cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co vv cv c2
    cdiv co caddc co cr wcel cF cc wcel cG cc wcel wa vv cv cr wcel vv cv c2
    cdiv co vv cv c2 cdiv co caddc co cr wcel cA cc wcel cB cc wcel wa cc0 vv
    cv clt wbr vv cv c2 cdiv co cr wcel vv cv c2 cdiv co cr wcel vv cv c2 cdiv
    co vv cv c2 cdiv co caddc co cr wcel vv cv cr wcel vv cv c2 cdiv co vv cv
    c2 cdiv co readdcl vv cv rehalfcl vv cv rehalfcl sylanc ad2antrl 3adant1
    syl3anc adantr mp2and cF cc wcel cG cc wcel wa cA cc wcel cB cc wcel wa vv
    cv cr wcel cc0 vv cv clt wbr wa w3a vv cv c2 cdiv co vv cv c2 cdiv co caddc
    co vv cv wceq cF cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
    cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr cG cB cmin co cabs
    cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa cA cc wcel
    cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa vv cv c2 cdiv co vv cv c2
    cdiv co caddc co vv cv wceq cF cc wcel cG cc wcel wa vv cv cr wcel vv cv c2
    cdiv co vv cv c2 cdiv co caddc co vv cv wceq cA cc wcel cB cc wcel wa cc0
    vv cv clt wbr vv cv cr wcel vv cv cc wcel vv cv c2 cdiv co vv cv c2 cdiv co
    caddc co vv cv wceq vv cv recn vv cv 2halves syl ad2antrl 3adant1 adantr
    breqtrd ex $.
    $( [10-Feb-2006] $) $( [30-Dec-2005] $)

  ${
    $d f g h t u v A $.  $d f g h t u v B $.  $d f g k t u v F $.
    $d f g k t u v G $.  $d f h k t u v H $.  $d f g h k t u v M $.
    climmul.1 $e |- F e. _V $.
    climmul.2 $e |- G e. _V $.
    climmul.3 $e |- H e. _V $.
    climmul.4 $e |- A e. _V $.
    climmul.5 $e |- B e. _V $.
    ${
      $d f t u v ph $.
      climmullem.6 $e |- ( ph <-> ( ( F ~~> A /\ G ~~> B ) /\
                 A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\ ( G ` k ) e. CC /\
                  ( H ` k ) = ( ( F ` k ) x. ( G ` k ) ) ) ) ) $.
      $( Lemma for ~ climmul . $)
      climmullem6 $p |- ( ( t e. ( ZZ>= ` M ) /\ ph ) ->
         ( ( F ` t ) e. CC /\ ( G ` t ) e. CC /\
                  ( H ` t ) = ( ( F ` t ) x. ( G ` t ) ) ) ) $=
        vt cv cM cuz cfv wcel cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc
        wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul
        co wceq w3a vk cM cuz cfv wral wa vt cv cF cfv cc wcel vt cv cG cfv cc
        wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cmul co wceq w3a wph vt cv
        cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv
        vk cv cF cfv vk cv cG cfv cmul co wceq w3a vk cM cuz cfv wral vt cv cF
        cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv
        cmul co wceq w3a cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk
        cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul co wceq
        w3a vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv
        vt cv cG cfv cmul co wceq w3a vk vt cv cM cuz cfv vk cv vt cv wceq vk
        cv cF cfv cc wcel vt cv cF cfv cc wcel vk cv cG cfv cc wcel vt cv cG
        cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul co wceq vt cv
        cH cfv vt cv cF cfv vt cv cG cfv cmul co wceq vk cv vt cv wceq vk cv cF
        cfv vt cv cF cfv cc vk cv vt cv cF fveq2 eleq1d vk cv vt cv wceq vk cv
        cG cfv vt cv cG cfv cc vk cv vt cv cG fveq2 eleq1d vk cv vt cv wceq vk
        cv cH cfv vt cv cH cfv vk cv cF cfv vk cv cG cfv cmul co vt cv cF cfv
        vt cv cG cfv cmul co vk cv vt cv cH fveq2 vk cv vt cv wceq vk cv cF cfv
        vt cv cF cfv vk cv cG cfv vt cv cG cfv cmul vk cv vt cv cF fveq2 vk cv
        vt cv cG fveq2 opreq12d eqeq12d 3anbi123d rcla4va adantrl climmullem.6
        sylan2b $.
        $( [9-Feb-2006] $) $( [27-Dec-2005] $)

      $( Lemma for ~ climmul . $)
      climmullem7 $p |- ( ph -> ( A e. CC /\ B e. CC ) ) $=
        wph cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk cv cG cfv cc
        wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul co wceq w3a vk cM cuz
        cfv wral wa cA cc wcel cB cc wcel wa climmullem.6 cF cA cli wbr cG cB
        cli wbr wa cA cc wcel cB cc wcel wa vk cv cF cfv cc wcel vk cv cG cfv
        cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul co wceq w3a vk cM
        cuz cfv wral cF cA cli wbr cA cc wcel cG cB cli wbr cB cc wcel cA cvv
        wcel cF cA cli wbr cA cc wcel climmul.4 cA cvv cF climcl mpan cB cvv
        wcel cG cB cli wbr cB cc wcel climmul.5 cB cvv cG climcl mpan anim12i
        adantr sylbi $.
        $( [9-Feb-2006] $) $( [27-Dec-2005] $)

      $( Lemma for ~ climmul .  _Warning:  The HTML proof page is 3/4 megabyte
         in size_. $)
      climmullem8 $p |- ( ( M e. ZZ /\ ph ) -> H ~~> ( A x. B ) ) $=
        cM cz wcel wph wa cH cA cB cmul co cli wbr cc0 vv cv clt wbr vh cv vt
        cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi
        vt cM cuz cfv wral vh cz wrex wi vv cr wral wph cc0 vv cv clt wbr vh cv
        vt cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr
        wi vt cM cuz cfv wral vh cz wrex wi vv cr wral cM cz wcel wph cc0 vv cv
        clt wbr vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv
        vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wi vv cr wph vv cv cr
        wcel cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co
        cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wph vv
        cv cr wcel cc0 vv cv clt wbr wa wa vu cv vt cv cle wbr vt cv cF cfv cA
        cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
        co cdiv co caddc co cdiv co clt wbr wi vt cM cuz cfv wral vu cc0 cuz
        cfv wrex vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi vg cM cuz cfv wral
        vf cc0 cuz cfv wrex wa vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co
        cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wph vv
        cv cr wcel cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
        cfv caddc co cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv
        cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co
        clt wbr wa vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cc0
        vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wa vu cv vt
        cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vt
        cM cuz cfv wral vu cc0 cuz cfv wrex vf cv vg cv cle wbr vg cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
        wbr wi vg cM cuz cfv wral vf cc0 cuz cfv wrex wa wph vv cv cr wcel cc0
        vv cv clt wbr wa wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wa vv
        cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv
        co c1 cA cabs cfv caddc co cdiv co clt wbr wa cB cc wcel vv cv cr wcel
        cc0 vv cv clt wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wa wph
        vv cB climmullem2 wph cA cc wcel cB cc wcel wph cA cB vk cF cG cH cM
        climmul.1 climmul.2 climmul.3 climmul.4 climmul.5 climmullem.6
        climmullem7 pm3.27d sylan cA cc wcel vv cv cr wcel cc0 vv cv clt wbr wa
        vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2
        cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wph vv cA
        climmullem1 wph cA cc wcel cB cc wcel wph cA cB vk cF cG cH cM
        climmul.1 climmul.2 climmul.3 climmul.4 climmul.5 climmullem.6
        climmullem7 pm3.26d sylan jca cF cA cli wbr cG cB cli wbr wa vk cv cF
        cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv
        cmul co wceq w3a vk cM cuz cfv wral wa c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1
        vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
        co clt wbr wa vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel
        cc0 vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wa vu
        cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2
        cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
        wbr wi vt cM cuz cfv wral vu cc0 cuz cfv wrex vf cv vg cv cle wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi vg cM cuz cfv wral vf cc0 cuz cfv wrex wa wph cF cA
        cli wbr cG cB cli wbr wa c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc
        co cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2 cdiv
        co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wa
        vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cc0 vv cv c2
        cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wa vu cv vt cv cle
        wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vt cM cuz
        cfv wral vu cc0 cuz cfv wrex vf cv vg cv cle wbr vg cv cG cfv cB cmin
        co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi
        vg cM cuz cfv wral vf cc0 cuz cfv wrex wa vk cv cF cfv cc wcel vk cv cG
        cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul co wceq w3a vk
        cM cuz cfv wral cF cA cli wbr c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
        caddc co cdiv co cdiv co caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2
        cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
        wbr wa cG cB cli wbr vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
        cr wcel cc0 vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa
        vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2
        cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
        wbr wi vt cM cuz cfv wral vu cc0 cuz cfv wrex vf cv vg cv cle wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi vg cM cuz cfv wral vf cc0 cuz cfv wrex wa cF cA cli
        wbr c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
        caddc co cdiv co cr wcel cc0 c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
        caddc co cdiv co cdiv co caddc co cdiv co clt wbr wa wa vu cv vt cv cle
        wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vt cM cuz
        cfv wral vu cc0 cuz cfv wrex cG cB cli wbr vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co cr wcel cc0 vv cv c2 cdiv co c1 cA cabs cfv caddc
        co cdiv co clt wbr wa wa vf cv vg cv cle wbr vg cv cG cfv cB cmin co
        cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi vg
        cM cuz cfv wral vf cc0 cuz cfv wrex cA cvv wcel cF cA cli wbr c1 c1 c1
        vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
        co cr wcel cc0 c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
        co cdiv co caddc co cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv
        cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co clt wbr wi vt cM cuz cfv wral vu cc0
        cuz cfv wrex climmul.4 cA c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
        caddc co cdiv co cdiv co caddc co cdiv co cvv vu vt cF cc0 cM cuz cfv
        cc0 cuz cfv 0z cc0 cuz cfv ssid cM uzssz clmi2i mpanl1 cB cvv wcel cG
        cB cli wbr vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cr wcel cc0
        vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa vf cv vg cv
        cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr wi vg cM cuz cfv wral vf cc0 cuz cfv wrex
        climmul.5 cB vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co cvv vf vg
        cG cc0 cM cuz cfv cc0 cuz cfv 0z cc0 cuz cfv ssid cM uzssz clmi2i
        mpanl1 anim12i an4s adantlr climmullem.6 sylanb syldan wph vv cv cr
        wcel cc0 vv cv clt wbr wa wa vu cv vt cv cle wbr vt cv cF cfv cA cmin
        co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
        cdiv co caddc co cdiv co clt wbr wi vt cM cuz cfv wral vf cv vg cv cle
        wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
        caddc co cdiv co clt wbr wi vg cM cuz cfv wral wa vf cc0 cuz cfv wrex
        vu cc0 cuz cfv wrex vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co cmin
        co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex vu cv vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1
        cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vt cM
        cuz cfv wral vu cc0 cuz cfv wrex vf cv vg cv cle wbr vg cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
        wbr wi vg cM cuz cfv wral vf cc0 cuz cfv wrex wa wph vv cv cr wcel cc0
        vv cv clt wbr wa wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
        caddc co cdiv co clt wbr wi vt cM cuz cfv wral vf cv vg cv cle wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi vg cM cuz cfv wral wa vh cv vt cv cle wbr vt cv cH
        cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral
        vh cz wrex vu vf cc0 cuz cfv cc0 cuz cfv wph vv cv cr wcel cc0 vv cv
        clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa vu cv vt cv cle wbr vt
        cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
        caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vt cM cuz cfv wral
        vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co
        c1 cA cabs cfv caddc co cdiv co clt wbr wi vg cM cuz cfv wral wa vh cv
        vt cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr
        wi vt cM cuz cfv wral vh cz wrex wi vu cv cc0 cuz cfv wcel vf cv cc0
        cuz cfv wcel wa wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cn0
        wcel vf cv cn0 wcel wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
        caddc co cdiv co clt wbr wi vt cM cuz cfv wral vf cv vg cv cle wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi vg cM cuz cfv wral wa vh cv vt cv cle wbr vt cv cH
        cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral
        vh cz wrex wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cn0 wcel
        vf cv cn0 wcel wa wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs
        cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
        caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co
        cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi wa
        vg cM cuz cfv wral vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv
        cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh
        cz wrex vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1
        vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
        co clt wbr wi vt cM cuz cfv wral vf cv vg cv cle wbr vg cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
        wbr wi vg cM cuz cfv wral wa wph vv cv cr wcel cc0 vv cv clt wbr wa wa
        vu cv cn0 wcel vf cv cn0 wcel wa wa vu cv vt cv cle wbr vt cv cF cfv cA
        cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv
        co cdiv co caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
        clt wbr wi wa vg cM cuz cfv wral vt cM cuz cfv wral vu cv vf cv caddc
        co vt cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt
        wbr wi vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cA cB cmul
        co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wph
        vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa
        wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv
        c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
        wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi wa vg cM cuz cfv
        wral vu cv vf cv caddc co vt cv cle wbr vt cv cH cfv cA cB cmul co cmin
        co cabs cfv vv cv clt wbr wi vt cM cuz cfv wph vv cv cr wcel cc0 vv cv
        clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa wa vt cv cM cuz cfv wcel
        wa vu cv vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr vt cv cF cfv
        cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi wa vg cM cuz cfv wral vt cv cH cfv cA cB cmul co
        cmin co cabs cfv vv cv clt wbr wph vv cv cr wcel cc0 vv cv clt wbr wa
        wa vu cv cn0 wcel vf cv cn0 wcel wa wa vt cv cM cuz cfv wcel wa vu cv
        vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr vt cv cF cfv cA cmin
        co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co
        cdiv co caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
        wbr wi wa vg cM cuz cfv wral vt cv cF cfv cA cmin co cabs cfv c1 c1 c1
        vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
        co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr wa vt cv cH cfv cA cB cmul co cmin co cabs
        cfv vv cv clt wbr vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz cfv
        wcel vu cv vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr vt cv cF
        cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc
        co cdiv co cdiv co caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg
        cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi wa vg cM cuz cfv wral vt cv cF cfv cA cmin co cabs
        cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
        caddc co cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv
        co c1 cA cabs cfv caddc co cdiv co clt wbr wa wi wi wph vv cv cr wcel
        cc0 vv cv clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz
        cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1
        c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv
        vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi wa vg cM
        cuz cfv wral vu cv vf cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co
        cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
        co caddc co cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa vu cv cn0 wcel vf cv
        cn0 wcel wa vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv
        cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wi wa vg cM cuz cfv wral vt cv cM cuz cfv wcel vu cv vf
        cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv
        cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co
        clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr wa wi vu cv cn0 wcel vf cv cn0 wcel wa vt
        cv cM cuz cfv wcel pm3.27 vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz
        cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1
        c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv
        vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi wa vg cM
        cuz cfv wral vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg
        cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wa wi wi vg cM cuz cfv wral vt cv cM cuz cfv wcel vu cv
        vf cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1
        vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
        co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr wa wi wi vu cv cn0 wcel vf cv cn0 wcel wa
        vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co
        cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
        co caddc co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin
        co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi
        wa vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg cv cle
        wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
        clt wbr wa wi wi vg cM cuz cfv vu cv cn0 wcel vf cv cn0 wcel wa vt cv
        cM cuz cfv wcel wa vg cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv
        cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
        caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vf cv vg cv cle
        wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
        caddc co cdiv co clt wbr wi wa vu cv vf cv caddc co vt cv cle wbr vu cv
        vf cv caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1
        vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv
        co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr wa vu cv cn0 wcel vf cv cn0 wcel wa vt cv
        cM cuz cfv wcel wa vg cv cM cuz cfv wcel wa vu cv vf cv caddc co vt cv
        cle wbr vu cv vf cv caddc co vg cv cle wbr wa vu cv vt cv cle wbr vf cv
        vg cv cle wbr wa vu cv vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv
        c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc
        co cdiv co clt wbr wi vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs
        cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi wa vt
        cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv
        caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv cG cfv cB cmin
        co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa
        vu cv cn0 wcel vf cv cn0 wcel wa vt cv cM cuz cfv wcel wa vg cv cM cuz
        cfv wcel wa vu cv vf cv caddc co vt cv cle wbr vu cv vt cv cle wbr vu
        cv vf cv caddc co vg cv cle wbr vf cv vg cv cle wbr vu cv cn0 wcel vf
        cv cn0 wcel wa vt cv cM cuz cfv wcel wa vu cv vf cv caddc co vt cv cle
        wbr vu cv vt cv cle wbr wi vg cv cM cuz cfv wcel vu cv cn0 wcel vf cv
        cn0 wcel wa vt cv cr wcel vu cv vf cv caddc co vt cv cle wbr vu cv vt
        cv cle wbr wi vt cv cM cuz cfv wcel vu cv cn0 wcel vf cv cn0 wcel wa vt
        cv cr wcel wa vu cv vu cv vf cv caddc co cle wbr vu cv vf cv caddc co
        vt cv cle wbr vu cv vt cv cle wbr vu cv cn0 wcel vf cv cn0 wcel wa vu
        cv vu cv vf cv caddc co cle wbr vt cv cr wcel vu cv cr wcel vf cv cn0
        wcel vu cv vu cv vf cv caddc co cle wbr vu cv cn0 wcel vu cv vf cv
        nn0addge1 vu cv nn0re sylan adantr vu cv cr wcel vu cv vf cv caddc co
        cr wcel wa vt cv cr wcel vu cv vu cv vf cv caddc co cle wbr vu cv vf cv
        caddc co vt cv cle wbr wa vu cv vt cv cle wbr wi vu cv cn0 wcel vf cv
        cn0 wcel wa vu cv cr wcel vu cv vf cv caddc co cr wcel vt cv cr wcel vu
        cv vu cv vf cv caddc co cle wbr vu cv vf cv caddc co vt cv cle wbr wa
        vu cv vt cv cle wbr wi vu cv vu cv vf cv caddc co vt cv letr 3expa vu
        cv cr wcel vf cv cr wcel vu cv cr wcel vu cv vf cv caddc co cr wcel wa
        vu cv cn0 wcel vf cv cn0 wcel vu cv cr wcel vf cv cr wcel wa vu cv cr
        wcel vu cv vf cv caddc co cr wcel vu cv cr wcel vf cv cr wcel pm3.26 vu
        cv vf cv readdcl jca vu cv nn0re vf cv nn0re syl2an sylan mpand vt cv
        cM cuz cfv wcel vt cv cz wcel vt cv cr wcel cM vt cv eluzelz vt cv zre
        syl sylan2 adantr vu cv cn0 wcel vf cv cn0 wcel wa vg cv cM cuz cfv
        wcel vu cv vf cv caddc co vg cv cle wbr vf cv vg cv cle wbr wi vt cv cM
        cuz cfv wcel vu cv cn0 wcel vf cv cn0 wcel wa vg cv cr wcel vu cv vf cv
        caddc co vg cv cle wbr vf cv vg cv cle wbr wi vg cv cM cuz cfv wcel vu
        cv cn0 wcel vf cv cn0 wcel wa vg cv cr wcel wa vf cv vu cv vf cv caddc
        co cle wbr vu cv vf cv caddc co vg cv cle wbr vf cv vg cv cle wbr vu cv
        cn0 wcel vf cv cn0 wcel wa vf cv vu cv vf cv caddc co cle wbr vg cv cr
        wcel vu cv cn0 wcel vf cv cr wcel vf cv vu cv vf cv caddc co cle wbr vf
        cv cn0 wcel vf cv cr wcel vu cv cn0 wcel vf cv vu cv vf cv caddc co cle
        wbr vf cv vu cv nn0addge2 ancoms vf cv nn0re sylan2 adantr vf cv cr
        wcel vu cv vf cv caddc co cr wcel wa vg cv cr wcel vf cv vu cv vf cv
        caddc co cle wbr vu cv vf cv caddc co vg cv cle wbr wa vf cv vg cv cle
        wbr wi vu cv cn0 wcel vf cv cn0 wcel wa vf cv cr wcel vu cv vf cv caddc
        co cr wcel vg cv cr wcel vf cv vu cv vf cv caddc co cle wbr vu cv vf cv
        caddc co vg cv cle wbr wa vf cv vg cv cle wbr wi vf cv vu cv vf cv
        caddc co vg cv letr 3expa vu cv cr wcel vf cv cr wcel vf cv cr wcel vu
        cv vf cv caddc co cr wcel wa vu cv cn0 wcel vf cv cn0 wcel vu cv cr
        wcel vf cv cr wcel wa vf cv cr wcel vu cv vf cv caddc co cr wcel vu cv
        cr wcel vf cv cr wcel pm3.27 vu cv vf cv readdcl jca vu cv nn0re vf cv
        nn0re syl2an sylan mpand vg cv cM cuz cfv wcel vg cv cz wcel vg cv cr
        wcel cM vg cv eluzelz vg cv zre syl sylan2 adantlr anim12d vu cv vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1
        cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vf cv vg
        cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr prth syl9 exp4a r19.20dva vt cv cM cuz cfv
        wcel vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg cv cle
        wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
        clt wbr wa wi wi vg cM cuz cfv wral vu cv vf cv caddc co vt cv cle wbr
        vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
        cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vt cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
        wbr wa wi vt cv cM cuz cfv wcel vu cv vf cv caddc co vt cv cle wbr vu
        cv vf cv caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1
        c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
        cabs cfv caddc co cdiv co clt wbr wa wi vg cM cuz cfv wral wi vu cv vf
        cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv
        cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co
        clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr wa wi vu cv vf cv caddc co vt cv cle wbr
        vu cv vf cv caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1
        c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
        cabs cfv caddc co cdiv co clt wbr wa wi wi vg cM cuz cfv wral vt cv cM
        cuz cfv wcel vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg
        cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wa wi vg cM cuz cfv wral vt cv cF cfv cA cmin co cabs
        cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co
        caddc co cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv
        co c1 cA cabs cfv caddc co cdiv co clt wbr wa vt cv cM cuz cfv wcel vu
        cv vf cv caddc co vg cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1
        c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
        cabs cfv caddc co cdiv co clt wbr wa wi vg cM cuz cfv wral vu cv vf cv
        caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv
        c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
        wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
        caddc co cdiv co clt wbr wa vu cv vf cv caddc co vg cv cle wbr vt cv cF
        cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc
        co cdiv co cdiv co caddc co cdiv co clt wbr vg cv cG cfv cB cmin co
        cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa wi
        vu cv vf cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1
        c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
        cabs cfv caddc co cdiv co clt wbr wa wi vg vt cv cM cuz cfv vg cv vt cv
        wceq vu cv vf cv caddc co vg cv cle wbr vu cv vf cv caddc co vt cv cle
        wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
        clt wbr wa vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vt cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wa vg cv vt cv vu cv vf cv caddc co cle breq2 vg cv vt
        cv wceq vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2
        cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr vt cv cF cfv cA cmin co
        cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv
        co caddc co cdiv co clt wbr vg cv vt cv wceq vg cv cG cfv cB cmin co
        cabs cfv vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs
        cfv caddc co cdiv co clt vg cv vt cv wceq vg cv cG cfv cB cmin co vt cv
        cG cfv cB cmin co cabs vg cv vt cv wceq vg cv cG cfv vt cv cG cfv cB
        cmin vg cv vt cv cG fveq2 opreq1d fveq2d breq1d anbi2d imbi12d rcla4v
        com23 a2d vu cv vf cv caddc co vt cv cle wbr vu cv vf cv caddc co vg cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1
        cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vg cv cG
        cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv
        co clt wbr wa wi vg cM cuz cfv r19.21v syl5ib com12 syl6 mpid com23
        adantll wph vv cv cr wcel cc0 vv cv clt wbr wa wa vt cv cM cuz cfv wcel
        vu cv vf cv caddc co vt cv cle wbr vt cv cF cfv cA cmin co cabs cfv c1
        c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co
        cdiv co clt wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
        cabs cfv caddc co cdiv co clt wbr wa vt cv cH cfv cA cB cmul co cmin co
        cabs cfv vv cv clt wbr wi wi vu cv cn0 wcel vf cv cn0 wcel wa wph vv cv
        cr wcel cc0 vv cv clt wbr wa wa vt cv cM cuz cfv wcel wa vt cv cF cfv
        cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co clt wbr vt cv cG cfv cB cmin co cabs
        cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa vt cv
        cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vu cv vf cv
        caddc co vt cv cle wbr vt cv cM cuz cfv wcel wph vv cv cr wcel cc0 vv
        cv clt wbr wa wa vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2
        cdiv co c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt
        wbr vt cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv
        caddc co cdiv co clt wbr wa vt cv cH cfv cA cB cmul co cmin co cabs cfv
        vv cv clt wbr wi vt cv cM cuz cfv wcel wph vv cv cr wcel cc0 vv cv clt
        wbr wa wa wa vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co
        c1 cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vt cv
        cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co
        cdiv co clt wbr wa vt cv cF cfv vt cv cG cfv cmul co cA cB cmul co cmin
        co cabs cfv vv cv clt wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv
        vv cv clt wbr vt cv cM cuz cfv wcel wph vv cv cr wcel cc0 vv cv clt wbr
        wa vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB
        cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vt cv cG cfv
        cB cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co
        clt wbr wa vt cv cF cfv vt cv cG cfv cmul co cA cB cmul co cmin co cabs
        cfv vv cv clt wbr wi vt cv cF cfv cc wcel vt cv cG cfv cc wcel wa cA cc
        wcel cB cc wcel wa wa vv cv cr wcel cc0 vv cv clt wbr wa vt cv cF cfv
        cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs cfv caddc co
        cdiv co cdiv co caddc co cdiv co clt wbr vt cv cG cfv cB cmin co cabs
        cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wa vt cv
        cF cfv vt cv cG cfv cmul co cA cB cmul co cmin co cabs cfv vv cv clt
        wbr wi vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv
        cc wcel wa cA cc wcel cB cc wcel wa vv cv cr wcel cc0 vv cv clt wbr wa
        vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1 cB cabs
        cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr vt cv cG cfv cB
        cmin co cabs cfv vv cv c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt
        wbr wa vt cv cF cfv vt cv cG cfv cmul co cA cB cmul co cmin co cabs cfv
        vv cv clt wbr wi vv cA cB vt cv cF cfv vt cv cG cfv climmullem5 3expa
        vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel
        cA cc wcel cB cc wcel wa vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc
        wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cmul
        co wceq wph vt cA cB vk cF cG cH cM climmul.1 climmul.2 climmul.3
        climmul.4 climmul.5 climmullem.6 climmullem6 3simp1d vt cv cM cuz cfv
        wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt
        cv cF cfv vt cv cG cfv cmul co wceq wph vt cA cB vk cF cG cH cM
        climmul.1 climmul.2 climmul.3 climmul.4 climmul.5 climmullem.6
        climmullem6 3simp2d wph cA cc wcel cB cc wcel wa vt cv cM cuz cfv wcel
        wph cA cB vk cF cG cH cM climmul.1 climmul.2 climmul.3 climmul.4
        climmul.5 climmullem.6 climmullem7 adantl jca31 sylan anasss vt cv cM
        cuz cfv wcel wph vv cv cr wcel cc0 vv cv clt wbr wa wa wa vt cv cH cfv
        cA cB cmul co cmin co cabs cfv vt cv cF cfv vt cv cG cfv cmul co cA cB
        cmul co cmin co cabs cfv vv cv clt vt cv cM cuz cfv wcel wph vv cv cr
        wcel cc0 vv cv clt wbr wa wa wa vt cv cH cfv cA cB cmul co cmin co vt
        cv cF cfv vt cv cG cfv cmul co cA cB cmul co cmin co cabs vt cv cM cuz
        cfv wcel wph vv cv cr wcel cc0 vv cv clt wbr wa wa wa vt cv cH cfv vt
        cv cF cfv vt cv cG cfv cmul co cA cB cmul co cmin vt cv cM cuz cfv wcel
        wph vt cv cH cfv vt cv cF cfv vt cv cG cfv cmul co wceq vv cv cr wcel
        cc0 vv cv clt wbr wa vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel
        vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cmul co
        wceq wph vt cA cB vk cF cG cH cM climmul.1 climmul.2 climmul.3
        climmul.4 climmul.5 climmullem.6 climmullem6 3simp3d adantrr opreq1d
        fveq2d breq1d sylibrd ancoms a1d adantlr syldd com23 r19.20dva vu cv
        cn0 wcel vf cv cn0 wcel wa vu cv vf cv caddc co vt cv cle wbr vt cv cH
        cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral
        vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv
        clt wbr wi vt cM cuz cfv wral vh cz wrex wi wph vv cv cr wcel cc0 vv cv
        clt wbr wa wa vu cv cn0 wcel vf cv cn0 wcel wa vu cv vf cv caddc co vt
        cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi
        vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co cmin
        co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex vu cv vf cv
        caddc co cz wcel vu cv vf cv caddc co vt cv cle wbr vt cv cH cfv cA cB
        cmul co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cv vt
        cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi
        vt cM cuz cfv wral vh cz wrex vu cv cn0 wcel vf cv cn0 wcel wa vh cv vt
        cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi
        vt cM cuz cfv wral vu cv vf cv caddc co vt cv cle wbr vt cv cH cfv cA
        cB cmul co cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh vu
        cv vf cv caddc co cz vh cv vu cv vf cv caddc co wceq vh cv vt cv cle
        wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vu cv
        vf cv caddc co vt cv cle wbr vt cv cH cfv cA cB cmul co cmin co cabs
        cfv vv cv clt wbr wi vt cM cuz cfv vh cv vu cv vf cv caddc co wceq vh
        cv vt cv cle wbr vu cv vf cv caddc co vt cv cle wbr vt cv cH cfv cA cB
        cmul co cmin co cabs cfv vv cv clt wbr vh cv vu cv vf cv caddc co vt cv
        cle breq1 imbi1d ralbidv rcla4ev vu cv cn0 wcel vf cv cn0 wcel wa vu cv
        vf cv caddc co cn0 wcel vu cv vf cv caddc co cz wcel vu cv vf cv
        nn0addcl vu cv vf cv caddc co nn0z syl sylan ex adantl syld vu cv vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1
        cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vf cv
        vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv c2 cdiv co c1 cA
        cabs cfv caddc co cdiv co clt wbr wi vt vg cM cuz cfv raaanv syl5ibr ex
        vu cv cn0 wcel vu cv cc0 cuz cfv wcel vf cv cn0 wcel vf cv cc0 cuz cfv
        wcel vu cv elnn0uz vf cv elnn0uz anbi12i syl5ibr r19.23advv vu cv vt cv
        cle wbr vt cv cF cfv cA cmin co cabs cfv c1 c1 c1 vv cv c2 cdiv co c1
        cB cabs cfv caddc co cdiv co cdiv co caddc co cdiv co clt wbr wi vt cM
        cuz cfv wral vf cv vg cv cle wbr vg cv cG cfv cB cmin co cabs cfv vv cv
        c2 cdiv co c1 cA cabs cfv caddc co cdiv co clt wbr wi vg cM cuz cfv
        wral vu vf cc0 cuz cfv cc0 cuz cfv reeanv syl5ibr mpd exp32 r19.21aiv
        adantl cM cz wcel cA cB cmul co cc wcel vt cv cH cfv cc wcel vt cM cuz
        cfv wral wa cH cA cB cmul co cli wbr cc0 vv cv clt wbr vh cv vt cv cle
        wbr vt cv cH cfv cA cB cmul co cmin co cabs cfv vv cv clt wbr wi vt cM
        cuz cfv wral vh cz wrex wi vv cr wral wb wph cM cz wcel cA cB cmul co
        cc wcel vt cv cH cfv cc wcel vt cM cuz cfv wral cH cA cB cmul co cli
        wbr cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cA cB cmul co
        cmin co cabs cfv vv cv clt wbr wi vt cM cuz cfv wral vh cz wrex wi vv
        cr wral wb vv cA cB cmul co vh vt cH cM climmul.3 clm4a 3expb wph cA cB
        cmul co cc wcel vt cv cH cfv cc wcel vt cM cuz cfv wral wph cA cc wcel
        cB cc wcel wa cA cB cmul co cc wcel wph cA cB vk cF cG cH cM climmul.1
        climmul.2 climmul.3 climmul.4 climmul.5 climmullem.6 climmullem7 cA cB
        mulcl syl wph vt cv cH cfv cc wcel vt cM cuz cfv vt cv cM cuz cfv wcel
        wph vt cv cH cfv cc wcel vt cv cM cuz cfv wcel wph wa vt cv cH cfv vt
        cv cF cfv vt cv cG cfv cmul co cc vt cv cM cuz cfv wcel wph wa vt cv cF
        cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv
        cmul co wceq wph vt cA cB vk cF cG cH cM climmul.1 climmul.2 climmul.3
        climmul.4 climmul.5 climmullem.6 climmullem6 3simp3d vt cv cF cfv cc
        wcel vt cv cG cfv cc wcel vt cv cF cfv vt cv cG cfv cmul co cc wcel vt
        cv cM cuz cfv wcel wph wa vt cv cF cfv vt cv cG cfv mulcl vt cv cM cuz
        cfv wcel wph wa vt cv cF cfv cc wcel vt cv cG cfv cc wcel vt cv cH cfv
        vt cv cF cfv vt cv cG cfv cmul co wceq wph vt cA cB vk cF cG cH cM
        climmul.1 climmul.2 climmul.3 climmul.4 climmul.5 climmullem.6
        climmullem6 3simp1d vt cv cM cuz cfv wcel wph wa vt cv cF cfv cc wcel
        vt cv cG cfv cc wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cmul co
        wceq wph vt cA cB vk cF cG cH cM climmul.1 climmul.2 climmul.3
        climmul.4 climmul.5 climmullem.6 climmullem6 3simp2d sylanc eqeltrd
        expcom r19.21aiv jca sylan2 mpbird $.
        $( [11-Feb-2006] $) $( [27-Dec-2005] $)
    $}

    $( Limit of the product of two converging sequences.  Proposition 12-2.1(c)
       of [Gleason] p. 168. $)
    climmul $p |- ( ( ( F ~~> A /\ G ~~> B ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\ ( G ` k ) e. CC /\
          ( H ` k ) = ( ( F ` k ) x. ( G ` k ) ) ) ) ) -> H ~~> ( A x. B ) ) $=
      cM cz wcel cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk cv cG
      cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmul co wceq w3a vk cM
      cuz cfv wral cH cA cB cmul co cli wbr cF cA cli wbr cG cB cli wbr wa vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG
      cfv cmul co wceq w3a vk cM cuz cfv wral wa cA cB vk cF cG cH cM climmul.1
      climmul.2 climmul.3 climmul.4 climmul.5 cF cA cli wbr cG cB cli wbr wa vk
      cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG
      cfv cmul co wceq w3a vk cM cuz cfv wral wa biid climmullem8 an1s $.
      $( [11-Feb-2006] $) $( [27-Dec-2005] $)
  $}

  ${
    $d x A $.  $d k x C $.  $d k x F $.  $d k x G $.  $d k x M $.
    climmulc2.1 $e |- F e. _V $.
    climmulc2.2 $e |- G e. _V $.
    climmulc2.3 $e |- A e. _V $.
    $( Limit of a sequence multiplied by a constant ` C ` .  Corollary 12-2.2
       of [Gleason] p. 171. $)
    climmulc2 $p |- ( ( ( C e. CC /\ F ~~> A ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC  /\
          ( G ` k ) = ( C x. ( F ` k ) ) ) ) ) -> G ~~> ( C x. A ) ) $=
      cC cc wcel cF cA cli wbr cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv cC
      vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral cG cC cA cmul co cli wbr
      cF cA cli wbr cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF
      cfv cmul co wceq wa vk cM cuz cfv wral cG vx cv cA cmul co cli wbr wi wi
      wi cF cA cli wbr cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF
      cfv cmul co wceq wa vk cM cuz cfv wral cG cC cA cmul co cli wbr wi wi wi
      vx cC cc vx cv cC wceq cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv
      vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral cG vx cv cA cmul co cli
      wbr wi wi cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv
      cmul co wceq wa vk cM cuz cfv wral cG cC cA cmul co cli wbr wi wi cF cA
      cli wbr vx cv cC wceq vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF
      cfv cmul co wceq wa vk cM cuz cfv wral cG vx cv cA cmul co cli wbr wi vk
      cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz
      cfv wral cG cC cA cmul co cli wbr wi cM cz wcel vx cv cC wceq vk cv cF
      cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co wceq wa vk cM cuz cfv
      wral vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk
      cM cuz cfv wral cG vx cv cA cmul co cli wbr cG cC cA cmul co cli wbr vx
      cv cC wceq vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co
      wceq wa vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa
      vk cM cuz cfv vx cv cC wceq vk cv cG cfv vx cv vk cv cF cfv cmul co wceq
      vk cv cG cfv cC vk cv cF cfv cmul co wceq vk cv cF cfv cc wcel vx cv cC
      wceq vx cv vk cv cF cfv cmul co cC vk cv cF cfv cmul co vk cv cG cfv vx
      cv cC vk cv cF cfv cmul opreq1 eqeq2d anbi2d ralbidv vx cv cC wceq vx cv
      cA cmul co cC cA cmul co cG cli vx cv cC cA cmul opreq1 breq2d imbi12d
      imbi2d imbi2d vx cv cc wcel cF cA cli wbr cM cz wcel vk cv cF cfv cc wcel
      vk cv cG cfv vx cv vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral cG vx
      cv cA cmul co cli wbr cz vx cv csn cxp vx cv cli wbr cF cA cli wbr wa cM
      cz wcel vk cv cz vx cv csn cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG
      cfv vk cv cz vx cv csn cxp cfv vk cv cF cfv cmul co wceq w3a vk cM cuz
      cfv wral wa cG vx cv cA cmul co cli wbr vx cv cc wcel cF cA cli wbr wa cM
      cz wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co wceq
      wa vk cM cuz cfv wral wa wa vx cv cA vk cz vx cv csn cxp cF cG cM cz vx
      cv csn zex vx cv snex xpex climmulc2.1 climmulc2.2 vx visset climmulc2.3
      climmul vx cv cc wcel cF cA cli wbr wa cz vx cv csn cxp vx cv cli wbr cF
      cA cli wbr wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF
      cfv cmul co wceq wa vk cM cuz cfv wral wa vx cv cc wcel cz vx cv csn cxp
      vx cv cli wbr cF cA cli wbr vx cv climconst2 anim1i adantr vx cv cc wcel
      cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co
      wceq wa vk cM cuz cfv wral wa cM cz wcel vk cv cz vx cv csn cxp cfv cc
      wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz vx cv csn cxp cfv vk cv
      cF cfv cmul co wceq w3a vk cM cuz cfv wral wa cF cA cli wbr vx cv cc wcel
      cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co
      wceq wa vk cM cuz cfv wral wa cM cz wcel vk cv cz vx cv csn cxp cfv cc
      wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz vx cv csn cxp cfv vk cv
      cF cfv cmul co wceq w3a vk cM cuz cfv wral wa vx cv cc wcel vk cv cF cfv
      cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co wceq wa vk cM cuz cfv
      wral vk cv cz vx cv csn cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv
      vk cv cz vx cv csn cxp cfv vk cv cF cfv cmul co wceq w3a vk cM cuz cfv
      wral cM cz wcel vx cv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv vk
      cv cF cfv cmul co wceq wa vk cv cz vx cv csn cxp cfv cc wcel vk cv cF cfv
      cc wcel vk cv cG cfv vk cv cz vx cv csn cxp cfv vk cv cF cfv cmul co wceq
      w3a vk cM cuz cfv vx cv cc wcel vk cv cM cuz cfv wcel wa vk cv cF cfv cc
      wcel vk cv cG cfv vx cv vk cv cF cfv cmul co wceq wa vk cv cz vx cv csn
      cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz vx cv csn cxp
      cfv vk cv cF cfv cmul co wceq vx cv cc wcel vk cv cM cuz cfv wcel wa vk
      cv cz vx cv csn cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vx cv
      vk cv cF cfv cmul co wceq wa vx cv cc wcel vk cv cM cuz cfv wcel wa vk cv
      cz vx cv csn cxp cfv vx cv cc vx cv cc wcel vk cv cz wcel vk cv cz vx cv
      csn cxp cfv vx cv wceq vk cv cM cuz cfv wcel cz vx cv vk cv cc fvconst2g
      cM vk cv eluzelz sylan2 vx cv cc wcel vk cv cM cuz cfv wcel pm3.26
      eqeltrd a1d vk cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co
      wceq wa vk cv cF cfv cc wcel wi vx cv cc wcel vk cv cM cuz cfv wcel wa vk
      cv cF cfv cc wcel vk cv cG cfv vx cv vk cv cF cfv cmul co wceq pm3.26 a1i
      vx cv cc wcel vk cv cM cuz cfv wcel wa vk cv cG cfv vx cv vk cv cF cfv
      cmul co wceq vk cv cG cfv vk cv cz vx cv csn cxp cfv vk cv cF cfv cmul co
      wceq vk cv cF cfv cc wcel vx cv cc wcel vk cv cM cuz cfv wcel wa vk cv cG
      cfv vk cv cz vx cv csn cxp cfv vk cv cF cfv cmul co wceq vk cv cG cfv vx
      cv vk cv cF cfv cmul co wceq vx cv cc wcel vk cv cM cuz cfv wcel wa vk cv
      cz vx cv csn cxp cfv vk cv cF cfv cmul co vx cv vk cv cF cfv cmul co vk
      cv cG cfv vx cv cc wcel vk cv cM cuz cfv wcel wa vk cv cz vx cv csn cxp
      cfv vx cv vk cv cF cfv cmul vx cv cc wcel vk cv cz wcel vk cv cz vx cv
      csn cxp cfv vx cv wceq vk cv cM cuz cfv wcel cz vx cv vk cv cc fvconst2g
      cM vk cv eluzelz sylan2 opreq1d eqeq2d biimprd adantld 3jcad r19.20dva
      anim2d imp adantlr sylanc exp43 vtoclga imp43 $.
      $( [16-May-2006] $) $( [30-Dec-2005] $)
  $}

  ${
    $d k F $.  $d k u v G $.  $d k H $.  $d k u v M $.
    climsub.1 $e |- F e. _V $.
    climsub.2 $e |- G e. _V $.
    climsub.3 $e |- H e. _V $.
    climsub.4 $e |- A e. _V $.
    climsub.5 $e |- B e. _V $.
    $( Limit of the difference of two converging sequences.  Proposition
       12-2.1(b) of [Gleason] p. 168. $)
    climsub $p |- ( ( ( F ~~> A /\ G ~~> B ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\ ( G ` k ) e. CC /\
           ( H ` k ) = ( ( F ` k ) - ( G ` k ) ) ) ) ) -> H ~~> ( A - B ) ) $=
      cF cA cli wbr cG cB cli wbr wa cM cz wcel vk cv cF cfv cc wcel vk cv cG
      cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq w3a vk cM
      cuz cfv wral wa wa cH cA c1 cneg cB cmul co caddc co cA cB cmin co cli cF
      cA cli wbr vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq
      wa vu vv copab c1 cneg cB cmul co cli wbr wa cM cz wcel vk cv cF cfv cc
      wcel vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq
      wa vu vv copab cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv vu cv cM cuz
      cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv caddc
      co wceq w3a vk cM cuz cfv wral wa cH cA c1 cneg cB cmul co caddc co cli
      wbr cF cA cli wbr cG cB cli wbr wa cM cz wcel vk cv cF cfv cc wcel vk cv
      cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq w3a vk
      cM cuz cfv wral wa wa cA c1 cneg cB cmul co vk cF vu cv cM cuz cfv wcel
      vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cH cM climsub.1 vu
      vv cM cuz cfv c1 cneg vu cv cG cfv cmul co cM cuz fvex opabex2 climsub.3
      climsub.4 c1 cneg cB cmul oprex climadd cF cA cli wbr cG cB cli wbr wa cM
      cz wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF
      cfv vk cv cG cfv cmin co wceq w3a vk cM cuz cfv wral wa wa cF cA cli wbr
      vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv
      copab c1 cneg cB cmul co cli wbr cF cA cli wbr cG cB cli wbr cM cz wcel
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv
      cG cfv cmin co wceq w3a vk cM cuz cfv wral wa simpll cG cB cli wbr cM cz
      wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv
      vk cv cG cfv cmin co wceq w3a vk cM cuz cfv wral wa vu cv cM cuz cfv wcel
      vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab c1 cneg cB cmul co
      cli wbr cF cA cli wbr cG cB cli wbr cM cz wcel vk cv cG cfv cc wcel vk cv
      vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv
      copab cfv c1 cneg vk cv cG cfv cmul co wceq wa vk cM cuz cfv wral vu cv
      cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab c1
      cneg cB cmul co cli wbr vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv
      cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq w3a vk cM cuz cfv wral c1
      cneg cc wcel cG cB cli wbr cM cz wcel vk cv cG cfv cc wcel vk cv vu cv cM
      cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv
      c1 cneg vk cv cG cfv cmul co wceq wa vk cM cuz cfv wral wa vu cv cM cuz
      cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab c1 cneg
      cB cmul co cli wbr c1 ax1cn negcli cB c1 cneg vk cG vu cv cM cuz cfv wcel
      vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cM climsub.2 vu vv
      cM cuz cfv c1 cneg vu cv cG cfv cmul co cM cuz fvex opabex2 climsub.5
      climmulc2 mpanl1 vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv
      vk cv cF cfv vk cv cG cfv cmin co wceq w3a vk cv cG cfv cc wcel vk cv vu
      cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab
      cfv c1 cneg vk cv cG cfv cmul co wceq wa vk cM cuz cfv vk cv cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cG cfv cc wcel vk cv
      vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv
      copab cfv c1 cneg vk cv cG cfv cmul co wceq wa vk cv cH cfv vk cv cF cfv
      vk cv cG cfv cmin co wceq vk cv cM cuz cfv wcel vk cv cG cfv cc wcel wa
      vk cv cG cfv cc wcel vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG
      cfv cmul co wceq wa vu vv copab cfv c1 cneg vk cv cG cfv cmul co wceq vk
      cv cM cuz cfv wcel vk cv cG cfv cc wcel pm3.27 vk cv cM cuz cfv wcel vk
      cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv
      copab cfv c1 cneg vk cv cG cfv cmul co wceq vk cv cG cfv cc wcel vu vv vk
      cv c1 cneg vu cv cG cfv cmul co c1 cneg vk cv cG cfv cmul co cM cuz cfv
      vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv
      copab vu cv vk cv wceq vu cv cG cfv vk cv cG cfv c1 cneg cmul vu cv vk cv
      cG fveq2 opreq2d vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co
      wceq wa vu vv copab eqid c1 cneg vk cv cG cfv cmul oprex fvopab4 adantr
      jca 3ad2antr2 r19.20ia sylanr2 adantll jca cM cz wcel vk cv cF cfv cc
      wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co
      wceq w3a vk cM cuz cfv wral wa cM cz wcel vk cv cF cfv cc wcel vk cv vu
      cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab
      cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv vu cv cM cuz cfv wcel vv cv
      c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv caddc co wceq w3a vk
      cM cuz cfv wral wa cF cA cli wbr cG cB cli wbr wa vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq w3a
      vk cM cuz cfv wral vk cv cF cfv cc wcel vk cv vu cv cM cuz cfv wcel vv cv
      c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv cc wcel vk cv cH cfv
      vk cv cF cfv vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul
      co wceq wa vu vv copab cfv caddc co wceq w3a vk cM cuz cfv wral cM cz
      wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv
      vk cv cG cfv cmin co wceq w3a vk cv cF cfv cc wcel vk cv vu cv cM cuz cfv
      wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv cc wcel
      vk cv cH cfv vk cv cF cfv vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv
      cG cfv cmul co wceq wa vu vv copab cfv caddc co wceq w3a vk cM cuz cfv vk
      cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv
      vk cv cF cfv vk cv cG cfv cmin co wceq w3a wa vk cv cF cfv cc wcel vk cv
      vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv
      copab cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv vu cv cM cuz cfv wcel
      vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv caddc co wceq
      vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH
      cfv vk cv cF cfv vk cv cG cfv cmin co wceq 3simpr1 vk cv cM cuz cfv wcel
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv vu cv cM cuz cfv wcel vv
      cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv cc wcel vk cv cH
      cfv vk cv cF cfv vk cv cG cfv cmin co wceq vk cv cM cuz cfv wcel vk cv cG
      cfv cc wcel wa vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv
      cmul co wceq wa vu vv copab cfv c1 cneg vk cv cG cfv cmul co cc vk cv cM
      cuz cfv wcel vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul
      co wceq wa vu vv copab cfv c1 cneg vk cv cG cfv cmul co wceq vk cv cG cfv
      cc wcel vu vv vk cv c1 cneg vu cv cG cfv cmul co c1 cneg vk cv cG cfv
      cmul co cM cuz cfv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul
      co wceq wa vu vv copab vu cv vk cv wceq vu cv cG cfv vk cv cG cfv c1 cneg
      cmul vu cv vk cv cG fveq2 opreq2d vu cv cM cuz cfv wcel vv cv c1 cneg vu
      cv cG cfv cmul co wceq wa vu vv copab eqid c1 cneg vk cv cG cfv cmul
      oprex fvopab4 adantr vk cv cG cfv cc wcel c1 cneg vk cv cG cfv cmul co cc
      wcel vk cv cM cuz cfv wcel c1 cneg cc wcel vk cv cG cfv cc wcel c1 cneg
      vk cv cG cfv cmul co cc wcel c1 ax1cn negcli c1 cneg vk cv cG cfv mulcl
      mpan adantl eqeltrd 3ad2antr2 vk cv cM cuz cfv wcel vk cv cF cfv cc wcel
      vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq
      w3a wa vk cv cH cfv vk cv cF cfv c1 cneg vk cv cG cfv cmul co caddc co vk
      cv cF cfv vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co
      wceq wa vu vv copab cfv caddc co vk cv cF cfv cc wcel vk cv cG cfv cc
      wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq w3a vk cv cH cfv
      vk cv cF cfv c1 cneg vk cv cG cfv cmul co caddc co wceq vk cv cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv
      vk cv cG cfv cmin co wceq vk cv cH cfv vk cv cF cfv c1 cneg vk cv cG cfv
      cmul co caddc co wceq vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq
      vk cv cF cfv cc wcel vk cv cG cfv cc wcel wa vk cv cH cfv vk cv cF cfv vk
      cv cG cfv cmin co vk cv cF cfv c1 cneg vk cv cG cfv cmul co caddc co vk
      cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq id vk cv cF cfv cc wcel
      vk cv cG cfv cc wcel wa vk cv cF cfv c1 cneg vk cv cG cfv cmul co caddc
      co vk cv cF cfv vk cv cG cfv cneg caddc co vk cv cF cfv vk cv cG cfv cmin
      co vk cv cG cfv cc wcel vk cv cF cfv c1 cneg vk cv cG cfv cmul co caddc
      co vk cv cF cfv vk cv cG cfv cneg caddc co wceq vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel c1 cneg vk cv cG cfv cmul co vk cv cG cfv cneg vk cv cF
      cfv caddc vk cv cG cfv mulm1 opreq2d adantl vk cv cF cfv vk cv cG cfv
      negsub eqtr2d sylan9eqr 3impa adantl vk cv cM cuz cfv wcel vk cv cF cfv
      vk cv vu cv cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu
      vv copab cfv caddc co vk cv cF cfv c1 cneg vk cv cG cfv cmul co caddc co
      wceq vk cv cF cfv cc wcel vk cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv
      vk cv cG cfv cmin co wceq w3a vk cv cM cuz cfv wcel vk cv vu cv cM cuz
      cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab cfv c1
      cneg vk cv cG cfv cmul co vk cv cF cfv caddc vu vv vk cv c1 cneg vu cv cG
      cfv cmul co c1 cneg vk cv cG cfv cmul co cM cuz cfv vu cv cM cuz cfv wcel
      vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab vu cv vk cv wceq
      vu cv cG cfv vk cv cG cfv c1 cneg cmul vu cv vk cv cG fveq2 opreq2d vu cv
      cM cuz cfv wcel vv cv c1 cneg vu cv cG cfv cmul co wceq wa vu vv copab
      eqid c1 cneg vk cv cG cfv cmul oprex fvopab4 opreq2d adantr eqtr4d 3jca
      r19.20ia anim2i adantl sylanc cF cA cli wbr cG cB cli wbr wa cA c1 cneg
      cB cmul co caddc co cA cB cmin co wceq cM cz wcel vk cv cF cfv cc wcel vk
      cv cG cfv cc wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cmin co wceq w3a
      vk cM cuz cfv wral wa cA cc wcel cB cc wcel cA c1 cneg cB cmul co caddc
      co cA cB cmin co wceq cF cA cli wbr cG cB cli wbr cA cc wcel cB cc wcel
      wa cA c1 cneg cB cmul co caddc co cA cB cneg caddc co cA cB cmin co cB cc
      wcel cA c1 cneg cB cmul co caddc co cA cB cneg caddc co wceq cA cc wcel
      cB cc wcel c1 cneg cB cmul co cB cneg cA caddc cB mulm1 opreq2d adantl cA
      cB negsub eqtrd cA cvv wcel cF cA cli wbr cA cc wcel climsub.4 cA cvv cF
      climcl mpan cB cvv wcel cG cB cli wbr cB cc wcel climsub.5 cB cvv cG
      climcl mpan syl2an adantr breqtrd $.
      $( [5-Aug-2007] $) $( [4-Aug-2007] $)
  $}

  ${
    $d k A $.  $d k C $.  $d k F $.  $d k G $.  $d k M $.
    climsubc2.1 $e |- F e. _V $.
    climsubc2.2 $e |- G e. _V $.
    climsubc2.3 $e |- A e. _V $.
    climsubc2.4 $e |- C e. _V $.
    $( Limit of a constant ` C ` minus each term of a sequence. $)
    climsubc2 $p |- ( ( ( F ~~> A /\ C e. CC ) /\ ( M e. ZZ /\
            A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\
           ( G ` k ) = ( C - ( F ` k ) ) ) ) ) -> G ~~> ( C - A ) ) $=
      cz cC csn cxp cC cli wbr cF cA cli wbr wa cM cz wcel vk cv cz cC csn cxp
      cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz cC csn cxp cfv vk
      cv cF cfv cmin co wceq w3a vk cM cuz cfv wral wa cG cC cA cmin co cli wbr
      cF cA cli wbr cC cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv
      cC vk cv cF cfv cmin co wceq wa vk cM cuz cfv wral wa wa cC cA vk cz cC
      csn cxp cF cG cM cz cC csn zex cC snex xpex climsubc2.1 climsubc2.2
      climsubc2.4 climsubc2.3 climsub cF cA cli wbr cC cc wcel wa cz cC csn cxp
      cC cli wbr cF cA cli wbr wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv
      cC vk cv cF cfv cmin co wceq wa vk cM cuz cfv wral wa cC cc wcel cF cA
      cli wbr cz cC csn cxp cC cli wbr cF cA cli wbr wa cC cc wcel cz cC csn
      cxp cC cli wbr cF cA cli wbr cC climconst2 anim1i ancoms adantr cF cA cli
      wbr cC cc wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv
      cF cfv cmin co wceq wa vk cM cuz cfv wral wa wa cM cz wcel vk cv cz cC
      csn cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz cC csn cxp
      cfv vk cv cF cfv cmin co wceq w3a vk cM cuz cfv wral cF cA cli wbr cC cc
      wcel wa cM cz wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmin
      co wceq wa vk cM cuz cfv wral simprl cC cc wcel vk cv cF cfv cc wcel vk
      cv cG cfv cC vk cv cF cfv cmin co wceq wa vk cM cuz cfv wral vk cv cz cC
      csn cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz cC csn cxp
      cfv vk cv cF cfv cmin co wceq w3a vk cM cuz cfv wral cF cA cli wbr cM cz
      wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmin co
      wceq wa vk cM cuz cfv wral vk cv cz cC csn cxp cfv cc wcel vk cv cF cfv
      cc wcel vk cv cG cfv vk cv cz cC csn cxp cfv vk cv cF cfv cmin co wceq
      w3a vk cM cuz cfv wral cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk
      cv cF cfv cmin co wceq wa vk cv cz cC csn cxp cfv cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv vk cv cz cC csn cxp cfv vk cv cF cfv cmin co wceq w3a
      vk cM cuz cfv cC cc wcel vk cv cz wcel vk cv cF cfv cc wcel vk cv cG cfv
      cC vk cv cF cfv cmin co wceq wa vk cv cz cC csn cxp cfv cc wcel vk cv cF
      cfv cc wcel vk cv cG cfv vk cv cz cC csn cxp cfv vk cv cF cfv cmin co
      wceq w3a wi vk cv cM cuz cfv wcel cC cc wcel vk cv cz wcel wa vk cv cF
      cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmin co wceq wa vk cv cz cC csn
      cxp cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz cC csn cxp cfv
      vk cv cF cfv cmin co wceq w3a cC cc wcel vk cv cz wcel wa vk cv cF cfv cc
      wcel vk cv cG cfv cC vk cv cF cfv cmin co wceq wa wa vk cv cz cC csn cxp
      cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cz cC csn cxp cfv vk
      cv cF cfv cmin co wceq cC cc wcel vk cv cz wcel wa vk cv cz cC csn cxp
      cfv cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmin co
      wceq wa cC cc wcel vk cv cz wcel wa vk cv cz cC csn cxp cfv cC cc cz cC
      vk cv cc fvconst2g cC cc wcel vk cv cz wcel pm3.26 eqeltrd adantr cC cc
      wcel vk cv cz wcel wa vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv
      cmin co wceq simprl cC cc wcel vk cv cz wcel wa vk cv cG cfv cC vk cv cF
      cfv cmin co wceq vk cv cG cfv vk cv cz cC csn cxp cfv vk cv cF cfv cmin
      co wceq vk cv cF cfv cc wcel cC cc wcel vk cv cz wcel wa vk cv cG cfv cC
      vk cv cF cfv cmin co wceq wa vk cv cG cfv cC vk cv cF cfv cmin co vk cv
      cz cC csn cxp cfv vk cv cF cfv cmin co cC cc wcel vk cv cz wcel wa vk cv
      cG cfv cC vk cv cF cfv cmin co wceq pm3.27 cC cc wcel vk cv cz wcel wa vk
      cv cz cC csn cxp cfv vk cv cF cfv cmin co cC vk cv cF cfv cmin co wceq vk
      cv cG cfv cC vk cv cF cfv cmin co wceq cC cc wcel vk cv cz wcel wa vk cv
      cz cC csn cxp cfv cC vk cv cF cfv cmin cz cC vk cv cc fvconst2g opreq1d
      adantr eqtr4d adantrl 3jca ex cM vk cv eluzelz sylan2 r19.20dva imp
      ad2ant2l jca sylanc $.
      $( [1-Mar-2008] $) $( [6-Feb-2008] $)
  $}

  ${
    $d k A $.  $d k F $.  $d k G $.
    climaddc.1 $e |- A e. CC $.
    climaddc.2 $e |- B e. _V $.
    climaddc.3 $e |- F ~~> B $.
    climaddc.4 $e |- G Fn NN $.
    ${
      $d k B $.
      climaddc.5 $e |- ( k e. NN ->
                      ( ( F ` k ) e. CC /\ ( G ` k ) = ( A + ( F ` k ) ) ) ) $.
      $( MAY BE REVISED - make this obsolete? $)
      $( Limit of a constant ` A ` added to a sequence. $)
      climaddci $p |- G ~~> ( A + B ) $=
        cF cB cli wbr cA cc wcel wa c1 cz wcel vk cv cF cfv cc wcel vk cv cG
        cfv cA vk cv cF cfv caddc co wceq wa vk c1 cuz cfv wral wa cG cA cB
        caddc co cli wbr cF cB cli wbr cA cc wcel climaddc.3 climaddc.1 pm3.2i
        c1 cz wcel vk cv cF cfv cc wcel vk cv cG cfv cA vk cv cF cfv caddc co
        wceq wa vk c1 cuz cfv wral 1z vk cv cF cfv cc wcel vk cv cG cfv cA vk
        cv cF cfv caddc co wceq wa vk c1 cuz cfv vk cv c1 cuz cfv wcel vk cv cn
        wcel vk cv cF cfv cc wcel vk cv cG cfv cA vk cv cF cfv caddc co wceq wa
        vk cv elnnuz climaddc.5 sylbir rgen pm3.2i cB cA vk cF cG c1 cF cB cli
        wbr cF cvv wcel climaddc.3 cF cB cli climrel brrelexi ax-mp cG cn wfn
        cn cvv wcel cG cvv wcel climaddc.4 nnex cn cvv cG fnex mp2an climaddc.2
        cA cc climaddc.1 elisseti climaddc2 mp2an $.
        $( [13-Jun-2006] $) $( [4-Mar-2005] $)
    $}

    ${
      climmulc.5 $e |- ( k e. NN ->
                     ( ( F ` k ) e. CC /\ ( G ` k ) = ( A x. ( F ` k ) ) ) ) $.
      $( Limit of a sequence multiplied by a constant ` A ` .  Corollary 12-2.2
         of [Gleason] p. 171. $)
      climmulci $p |- G ~~> ( A x. B ) $=
        cA cc wcel cF cB cli wbr wa c1 cz wcel vk cv cF cfv cc wcel vk cv cG
        cfv cA vk cv cF cfv cmul co wceq wa vk c1 cuz cfv wral wa cG cA cB cmul
        co cli wbr cA cc wcel cF cB cli wbr climaddc.1 climaddc.3 pm3.2i c1 cz
        wcel vk cv cF cfv cc wcel vk cv cG cfv cA vk cv cF cfv cmul co wceq wa
        vk c1 cuz cfv wral 1z vk cv cF cfv cc wcel vk cv cG cfv cA vk cv cF cfv
        cmul co wceq wa vk c1 cuz cfv vk cv c1 cuz cfv wcel vk cv cn wcel vk cv
        cF cfv cc wcel vk cv cG cfv cA vk cv cF cfv cmul co wceq wa vk cv
        elnnuz climmulc.5 sylbir rgen pm3.2i cB cA vk cF cG c1 cF cB cli wbr cF
        cvv wcel climaddc.3 cF cB cli climrel brrelexi ax-mp cG cn wfn cn cvv
        wcel cG cvv wcel climaddc.4 nnex cn cvv cG fnex mp2an climaddc.2
        climmulc2 mp2an $.
        $( [8-Jun-2006] $) $( [4-Mar-2005] $)
    $}
  $}

  ${
    $d A n $.  $d F k n $.  $d M k n $.  $d N k n $.
    clim2serzt.1 $e |- A e. _V $.
    clim2serzt.2 $e |- F e. _V $.
    $( The limit of an infinite series with an initial segment removed.
       (Contributed by Paul Chapman, 9-Feb-2007.) $)
    clim2serz $p |- ( ( ( <. M , + >. seq F ) ~~> A /\ N e. ( ZZ>= ` M ) /\
                         A. k e. ( ZZ>= ` M ) ( F ` k ) e. CC ) ->
  ( <. ( N + 1 ) , + >. seq F ) ~~> ( A - ( ( <. M , + >. seq F ) ` N ) ) ) $=
      cM caddc cop cF cseqz co cA cli wbr cN cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral cN c1 caddc co caddc cop cF cseqz co cA cN cM
      caddc cop cF cseqz co cfv cmin co cli wbr cM caddc cop cF cseqz co cA cli
      wbr cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa wa cN
      c1 caddc co caddc cop cF cseqz co cA cN cM caddc cop cF cseqz co cfv cneg
      caddc co cA cN cM caddc cop cF cseqz co cfv cmin co cli cM caddc cop cF
      cseqz co cA cli wbr cN cM caddc cop cF cseqz co cfv cneg cc wcel cN c1
      caddc co cz wcel vn cv cM caddc cop cF cseqz co cfv cc wcel vn cv cN c1
      caddc co caddc cop cF cseqz co cfv vn cv cM caddc cop cF cseqz co cfv cN
      cM caddc cop cF cseqz co cfv cneg caddc co wceq wa vn cN c1 caddc co cuz
      cfv wral wa wa cN c1 caddc co caddc cop cF cseqz co cA cN cM caddc cop cF
      cseqz co cfv cneg caddc co cli wbr cN cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral wa cM caddc cop cF cseqz co cA cli wbr cN cM
      caddc cop cF cseqz co cfv cneg cc wcel cN c1 caddc co cz wcel vn cv cM
      caddc cop cF cseqz co cfv cc wcel vn cv cN c1 caddc co caddc cop cF cseqz
      co cfv vn cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv
      cneg caddc co wceq wa vn cN c1 caddc co cuz cfv wral wa cN c1 caddc co
      caddc cop cF cseqz co cA cN cM caddc cop cF cseqz co cfv cneg caddc co
      cli wbr cA cN cM caddc cop cF cseqz co cfv cneg vn cM caddc cop cF cseqz
      co cN c1 caddc co caddc cop cF cseqz co cN c1 caddc co cM caddc cop cF
      cseqz oprex cN c1 caddc co caddc cop cF cseqz oprex clim2serzt.1 cN cM
      caddc cop cF cseqz co cfv negex climaddc1 anasss cN cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cM cuz cfv wral wa cN cM caddc cop cF cseqz co cfv cneg
      cc wcel cN c1 caddc co cz wcel vn cv cM caddc cop cF cseqz co cfv cc wcel
      vn cv cN c1 caddc co caddc cop cF cseqz co cfv vn cv cM caddc cop cF
      cseqz co cfv cN cM caddc cop cF cseqz co cfv cneg caddc co wceq wa vn cN
      c1 caddc co cuz cfv wral cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cN
      cfz co wral cN cM caddc cop cF cseqz co cfv cneg cc wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cN
      cfz co wral wa cN cM caddc cop cF cseqz co cfv cc wcel cN cM caddc cop cF
      cseqz co cfv cneg cc wcel vk cF cM cN clim2serzt.2 serzcl cN cM caddc cop
      cF cseqz co cfv negcl syl vk cv cF cfv cc wcel vk cv cF cfv cc wcel vk cM
      cuz cfv cM cN cfz co vk cv cM cN cfz co wcel vk cv cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cv cM cN elfzuz imim1i r19.20i2 sylan2 cN cM cuz cfv
      wcel cN c1 caddc co cz wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cN cM
      cuz cfv wcel cN cM cN eluzelz peano2zdi adantr cN cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cM cuz cfv wral wa vn cv cM caddc cop cF cseqz co cfv
      cc wcel vn cv cN c1 caddc co caddc cop cF cseqz co cfv vn cv cM caddc cop
      cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cneg caddc co wceq wa vn
      cN c1 caddc co cuz cfv cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz
      cfv wral wa vn cv cN c1 caddc co cuz cfv wcel vn cv cM caddc cop cF cseqz
      co cfv cc wcel vn cv cN c1 caddc co caddc cop cF cseqz co cfv vn cv cM
      caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cneg caddc co
      wceq cN cM cuz cfv wcel vn cv cN c1 caddc co cuz cfv wcel vn cv cM cuz
      cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vn cv cM caddc cop cF
      cseqz co cfv cc wcel cN cM cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vn
      cv cN c1 caddc co cuz cfv wcel vn cv cM cuz cfv wcel wi cM cN peano2uz vn
      cv cN c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vn cv cM
      cuz cfv wcel cN c1 caddc co vn cv cM uztrn expcom syl vn cv cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vn cv cM caddc cop cF cseqz
      co cfv cc wcel vk cF cM vn cv clim2serzt.2 serzcl2 expcom sylan9 cN cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa vn cv cN c1 caddc
      co cuz cfv wcel vn cv cN c1 caddc co caddc cop cF cseqz co cfv vn cv cM
      caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cneg caddc co
      wceq cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa vn cv
      cN c1 caddc co cuz cfv wcel wa vn cv cM caddc cop cF cseqz co cfv cN cM
      caddc cop cF cseqz co cfv cneg caddc co vn cv cM caddc cop cF cseqz co
      cfv cN cM caddc cop cF cseqz co cfv cmin co vn cv cN c1 caddc co caddc
      cop cF cseqz co cfv cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv
      wral wa vn cv cN c1 caddc co cuz cfv wcel vn cv cM caddc cop cF cseqz co
      cfv cN cM caddc cop cF cseqz co cfv cneg caddc co vn cv cM caddc cop cF
      cseqz co cfv cN cM caddc cop cF cseqz co cfv cmin co wceq cN cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa vn cv cN c1 caddc co cuz
      cfv wcel vn cv cM caddc cop cF cseqz co cfv cc wcel cN cM caddc cop cF
      cseqz co cfv cc wcel wa vn cv cM caddc cop cF cseqz co cfv cN cM caddc
      cop cF cseqz co cfv cneg caddc co vn cv cM caddc cop cF cseqz co cfv cN
      cM caddc cop cF cseqz co cfv cmin co wceq cN cM cuz cfv wcel vk cv cF cfv
      cc wcel vk cM cuz cfv wral wa vn cv cN c1 caddc co cuz cfv wcel vn cv cM
      caddc cop cF cseqz co cfv cc wcel cN cM caddc cop cF cseqz co cfv cc wcel
      cN cM cuz cfv wcel vn cv cN c1 caddc co cuz cfv wcel vn cv cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vn cv cM caddc cop cF cseqz
      co cfv cc wcel cN cM cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vn cv cN
      c1 caddc co cuz cfv wcel vn cv cM cuz cfv wcel wi cM cN peano2uz vn cv cN
      c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vn cv cM cuz cfv
      wcel cN c1 caddc co vn cv cM uztrn expcom syl vn cv cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cM cuz cfv wral vn cv cM caddc cop cF cseqz co cfv cc
      wcel vk cF cM vn cv clim2serzt.2 serzcl2 expcom sylan9 vk cF cM cN
      clim2serzt.2 serzcl2 jctird vn cv cM caddc cop cF cseqz co cfv cN cM
      caddc cop cF cseqz co cfv negsub syl6 imp cN cM cuz cfv wcel vk cv cF cfv
      cc wcel vk cM cuz cfv wral wa vn cv cN c1 caddc co cuz cfv wcel wa vn cv
      cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cmin co vn
      cv cN c1 caddc co caddc cop cF cseqz co cfv wceq cN cM caddc cop cF cseqz
      co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc co vn cv cM
      caddc cop cF cseqz co cfv wceq vn cv cN c1 caddc co cuz cfv wcel cN cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa cN cM caddc cop
      cF cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc co
      vn cv cM caddc cop cF cseqz co cfv wceq vn cv cN c1 caddc co cuz cfv wcel
      cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cN cM caddc
      cop cF cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc
      co vn cv cM caddc cop cF cseqz co cfv wceq vn cv cN c1 caddc co cuz cfv
      wcel cN cM cuz cfv wcel wa vk cv cF cfv cc wcel vk cM vn cv cfz co wral
      cN cM caddc cop cF cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz
      co cfv caddc co vn cv cM caddc cop cF cseqz co cfv wceq vk cv cF cfv cc
      wcel vk cM cuz cfv wral vn cv cN c1 caddc co cuz cfv wcel cN cM cuz cfv
      wcel cN cM vn cv c1 cmin co cfz co wcel vk cv cF cfv cc wcel vk cM vn cv
      cfz co wral cN cM caddc cop cF cseqz co cfv vn cv cN c1 caddc co caddc
      cop cF cseqz co cfv caddc co vn cv cM caddc cop cF cseqz co cfv wceq wi
      cN cM cuz cfv wcel vn cv cN c1 caddc co cuz cfv wcel cN cM vn cv c1 cmin
      co cfz co wcel cN cM cuz cfv wcel vn cv cN c1 caddc co cuz cfv wcel vn cv
      c1 cmin co cN cuz cfv wcel cN cM vn cv c1 cmin co cfz co wcel cN cz wcel
      vn cv cN c1 caddc co cuz cfv wcel vn cv c1 cmin co cN cuz cfv wcel cN cM
      cuz cfv wcel cN vn cv eluzp1m1 cM cN eluzelz sylan cN cM vn cv c1 cmin co
      eluzfz syldan ancoms vn cv cN c1 caddc co cuz cfv wcel cN cM vn cv c1
      cmin co cfz co wcel vk cv cF cfv cc wcel vk cM vn cv cfz co wral cN cM
      caddc cop cF cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv
      caddc co vn cv cM caddc cop cF cseqz co cfv wceq vn cv cN c1 caddc co cuz
      cfv wcel cN cM vn cv c1 cmin co cfz co wcel vk cv cF cfv cc wcel vk cM vn
      cv cfz co wral w3a vn cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF
      cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc co vn
      cv cz wcel cN cM vn cv c1 cmin co cfz co wcel vk cv cF cfv cc wcel vk cM
      vn cv cfz co wral vn cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF
      cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc co wceq
      vn cv cN c1 caddc co cuz cfv wcel vk cF cN cM vn cv clim2serzt.2
      serzsplit cN c1 caddc co vn cv eluzelz syl3an1 eqcomd 3expia syldan vk cv
      cF cfv cc wcel vk cv cF cfv cc wcel vk cM cuz cfv cM vn cv cfz co vk cv
      cM vn cv cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cM
      vn cv elfzuz imim1i r19.20i2 syl5 expimpd impcom cN cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cM cuz cfv wral wa vn cv cN c1 caddc co cuz cfv wcel vn
      cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cmin co
      vn cv cN c1 caddc co caddc cop cF cseqz co cfv wceq cN cM caddc cop cF
      cseqz co cfv vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc co vn
      cv cM caddc cop cF cseqz co cfv wceq wb cN cM cuz cfv wcel vk cv cF cfv
      cc wcel vk cM cuz cfv wral wa vn cv cN c1 caddc co cuz cfv wcel vn cv cM
      caddc cop cF cseqz co cfv cc wcel cN cM caddc cop cF cseqz co cfv cc wcel
      vn cv cN c1 caddc co caddc cop cF cseqz co cfv cc wcel w3a vn cv cM caddc
      cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cmin co vn cv cN c1
      caddc co caddc cop cF cseqz co cfv wceq cN cM caddc cop cF cseqz co cfv
      vn cv cN c1 caddc co caddc cop cF cseqz co cfv caddc co vn cv cM caddc
      cop cF cseqz co cfv wceq wb cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral wa vn cv cN c1 caddc co cuz cfv wcel vn cv cM caddc cop cF
      cseqz co cfv cc wcel cN cM caddc cop cF cseqz co cfv cc wcel vn cv cN c1
      caddc co caddc cop cF cseqz co cfv cc wcel cN cM cuz cfv wcel vn cv cN c1
      caddc co cuz cfv wcel vn cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral vn cv cM caddc cop cF cseqz co cfv cc wcel cN cM cuz cfv
      wcel cN c1 caddc co cM cuz cfv wcel vn cv cN c1 caddc co cuz cfv wcel vn
      cv cM cuz cfv wcel wi cM cN peano2uz vn cv cN c1 caddc co cuz cfv wcel cN
      c1 caddc co cM cuz cfv wcel vn cv cM cuz cfv wcel cN c1 caddc co vn cv cM
      uztrn expcom syl vn cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv
      wral vn cv cM caddc cop cF cseqz co cfv cc wcel vk cF cM vn cv
      clim2serzt.2 serzcl2 expcom sylan9 cN cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral wa cN cM caddc cop cF cseqz co cfv cc wcel vn cv
      cN c1 caddc co cuz cfv wcel vk cF cM cN clim2serzt.2 serzcl2 a1d vn cv cN
      c1 caddc co cuz cfv wcel cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral wa vn cv cN c1 caddc co caddc cop cF cseqz co cfv cc wcel vn
      cv cN c1 caddc co cuz cfv wcel vk cv cF cfv cc wcel vk cN c1 caddc co vn
      cv cfz co wral vn cv cN c1 caddc co caddc cop cF cseqz co cfv cc wcel cN
      cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa vk cF cN c1
      caddc co vn cv clim2serzt.2 serzcl cN cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral vk cv cF cfv cc wcel vk cN c1 caddc co vn cv cfz
      co wral cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cF cfv cc wcel vk
      cM cuz cfv cN c1 caddc co vn cv cfz co cN cM cuz cfv wcel vk cv cN c1
      caddc co vn cv cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk
      cv cN c1 caddc co vn cv cfz co wcel cN cM cuz cfv wcel vk cv cM cuz cfv
      wcel vk cv cN c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vk
      cv cM cuz cfv wcel vk cv cN c1 caddc co vn cv cfz co wcel cN cM cuz cfv
      wcel cN c1 caddc co vk cv cM uztrn vk cv cN c1 caddc co vn cv elfzuz cM
      cN peano2uz syl2an expcom imim1d r19.20dv2 imp sylan2 expcom 3jcad vn cv
      cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv vn cv cN c1
      caddc co caddc cop cF cseqz co cfv subadd syl6 imp mpbird eqtr2d ex jcad
      r19.21aiv jca32 sylan2 cA cc wcel cN cM caddc cop cF cseqz co cfv cc wcel
      cA cN cM caddc cop cF cseqz co cfv cneg caddc co cA cN cM caddc cop cF
      cseqz co cfv cmin co wceq cM caddc cop cF cseqz co cA cli wbr cN cM cuz
      cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral wa cA cN cM caddc cop cF
      cseqz co cfv negsub cA cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc
      wcel clim2serzt.1 cA cvv cM caddc cop cF cseqz co climcl mpan vk cF cM cN
      clim2serzt.2 serzcl2 syl2an breqtrd 3impb $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d F k x $.  $d F x z $.  $d M k x $.  $d M x z $.  $d N k x $.
    $d N x z $.
    iserzext.1 $e |- F e. _V $.
    $( If an infinite series converges, so does the series with initial terms
       removed.  (Contributed by Paul Chapman, 9-Feb-2007.) $)
    iserzex $p |- ( ( N e. ( ZZ>= ` M ) /\
  A. k e. ( ZZ>= ` M ) ( F ` k ) e. CC /\ E. x ( <. M , + >. seq F ) ~~> x ) ->
                     E. x ( <. ( N + 1 ) , + >. seq F ) ~~> x ) $=
      cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex cN c1 caddc co caddc cop cF cseqz co vx
      cv cli wbr vx wex cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv
      wral wa cM caddc cop cF cseqz co vx cv cli wbr vx wex cN c1 caddc co
      caddc cop cF cseqz co vz cv cli wbr vz wex cN c1 caddc co caddc cop cF
      cseqz co vx cv cli wbr vx wex cN cM cuz cfv wcel vk cv cF cfv cc wcel vk
      cM cuz cfv wral wa cM caddc cop cF cseqz co vx cv cli wbr cN c1 caddc co
      caddc cop cF cseqz co vz cv cli wbr vz wex vx cN cM cuz cfv wcel vk cv cF
      cfv cc wcel vk cM cuz cfv wral wa cM caddc cop cF cseqz co vx cv cli wbr
      cN c1 caddc co caddc cop cF cseqz co vx cv cN cM caddc cop cF cseqz co
      cfv cmin co cli wbr cN c1 caddc co caddc cop cF cseqz co vz cv cli wbr vz
      wex cM caddc cop cF cseqz co vx cv cli wbr cN cM cuz cfv wcel vk cv cF
      cfv cc wcel vk cM cuz cfv wral wa cN c1 caddc co caddc cop cF cseqz co vx
      cv cN cM caddc cop cF cseqz co cfv cmin co cli wbr cM caddc cop cF cseqz
      co vx cv cli wbr cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv
      wral cN c1 caddc co caddc cop cF cseqz co vx cv cN cM caddc cop cF cseqz
      co cfv cmin co cli wbr vx cv vk cF cM cN vx visset iserzext.1 clim2serz
      3expb expcom cN c1 caddc co caddc cop cF cseqz co vz cv cli wbr cN c1
      caddc co caddc cop cF cseqz co vx cv cN cM caddc cop cF cseqz co cfv cmin
      co cli wbr vz vx cv cN cM caddc cop cF cseqz co cfv cmin co vx cv cN cM
      caddc cop cF cseqz co cfv cmin oprex vz cv vx cv cN cM caddc cop cF cseqz
      co cfv cmin co cN c1 caddc co caddc cop cF cseqz co cli breq2 cla4ev syl6
      19.23adv cN c1 caddc co caddc cop cF cseqz co vz cv cli wbr cN c1 caddc
      co caddc cop cF cseqz co vx cv cli wbr vz vx vz cv vx cv cN c1 caddc co
      caddc cop cF cseqz co cli breq2 cbvexv syl6ib 3impia $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d C k m $.  $d F k m $.  $d G k m $.  $d M k m $.
    iserzmulc1.1 $e |- A e. _V $.
    iserzmulc1.2 $e |- F e. _V $.
    iserzmulc1.3 $e |- G e. _V $.
    $( Multiplication of an infinite series by a constant.  (Contributed by
       Paul Chapman, 14-Nov-2007.) $)
    iserzmulc1 $p |- ( ( M e. ZZ /\ C e. CC /\ A. k e. ( ZZ>= ` M )
       ( ( F ` k ) e. CC /\ ( G ` k ) = ( C x. ( F ` k ) ) ) ) ->
     ( ( <. M , + >. seq F ) ~~> A ->
       ( <. M , + >. seq G ) ~~> ( C x. A ) ) ) $=
      cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv
      cmul co wceq wa vk cM cuz cfv wral cM caddc cop cF cseqz co cA cli wbr cM
      caddc cop cG cseqz co cC cA cmul co cli wbr wi cM cz wcel vm cv cM caddc
      cop cF cseqz co cfv cc wcel vm cv cM caddc cop cG cseqz co cfv cC vm cv
      cM caddc cop cF cseqz co cfv cmul co wceq wa vm cM cuz cfv wral cC cc
      wcel wa cM caddc cop cF cseqz co cA cli wbr cM caddc cop cG cseqz co cC
      cA cmul co cli wbr wi cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk
      cv cF cfv cmul co wceq wa vk cM cuz cfv wral wa cM cz wcel vm cv cM caddc
      cop cF cseqz co cfv cc wcel vm cv cM caddc cop cG cseqz co cfv cC vm cv
      cM caddc cop cF cseqz co cfv cmul co wceq wa vm cM cuz cfv wral cC cc
      wcel cM caddc cop cF cseqz co cA cli wbr cM caddc cop cG cseqz co cC cA
      cmul co cli wbr wi cM cz wcel vm cv cM caddc cop cF cseqz co cfv cc wcel
      vm cv cM caddc cop cG cseqz co cfv cC vm cv cM caddc cop cF cseqz co cfv
      cmul co wceq wa vm cM cuz cfv wral cC cc wcel cM caddc cop cF cseqz co cA
      cli wbr cM caddc cop cG cseqz co cC cA cmul co cli wbr cC cc wcel cM
      caddc cop cF cseqz co cA cli wbr wa cM cz wcel vm cv cM caddc cop cF
      cseqz co cfv cc wcel vm cv cM caddc cop cG cseqz co cfv cC vm cv cM caddc
      cop cF cseqz co cfv cmul co wceq wa vm cM cuz cfv wral wa cM caddc cop cG
      cseqz co cC cA cmul co cli wbr cA cC vm cM caddc cop cF cseqz co cM caddc
      cop cG cseqz co cM cM caddc cop cF cseqz oprex cM caddc cop cG cseqz
      oprex iserzmulc1.1 climmulc2 expcom exp4b imp3a cC cc wcel vk cv cF cfv
      cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral
      wa vm cv cM caddc cop cF cseqz co cfv cc wcel vm cv cM caddc cop cG cseqz
      co cfv cC vm cv cM caddc cop cF cseqz co cfv cmul co wceq wa vm cM cuz
      cfv wral cC cc wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv
      cF cfv cmul co wceq wa vk cM cuz cfv wral wa vm cv cM caddc cop cF cseqz
      co cfv cc wcel vm cv cM caddc cop cG cseqz co cfv cC vm cv cM caddc cop
      cF cseqz co cfv cmul co wceq wa vm cM cuz cfv cC cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral wa
      vm cv cM cuz cfv wcel vm cv cM caddc cop cF cseqz co cfv cc wcel vm cv cM
      caddc cop cG cseqz co cfv cC vm cv cM caddc cop cF cseqz co cfv cmul co
      wceq vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk
      cM cuz cfv wral vm cv cM cuz cfv wcel vm cv cM caddc cop cF cseqz co cfv
      cc wcel wi cC cc wcel vm cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG
      cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral vm cv cM caddc cop
      cF cseqz co cfv cc wcel vm cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral vm cv cM caddc cop cF cseqz co cfv cc wcel vk cv cF cfv cc
      wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral vk
      cF cM vm cv iserzmulc1.2 serzcl2 vk cv cF cfv cc wcel vk cv cG cfv cC vk
      cv cF cfv cmul co wceq wa vk cv cF cfv cc wcel vk cM cuz cfv vk cv cF cfv
      cc wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq pm3.26 r19.20si sylan2
      expcom adantl vm cv cM cuz cfv wcel cC cc wcel vk cv cF cfv cc wcel vk cv
      cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral wa vm cv cM
      caddc cop cG cseqz co cfv cC vm cv cM caddc cop cF cseqz co cfv cmul co
      wceq vm cv cM cuz cfv wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv
      cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral vm cv cM caddc cop cG
      cseqz co cfv cC vm cv cM caddc cop cF cseqz co cfv cmul co wceq vm cv cM
      cuz cfv wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv
      cmul co wceq wa vk cM vm cv cfz co wral vm cv cM caddc cop cG cseqz co
      cfv cC vm cv cM caddc cop cF cseqz co cfv cmul co wceq vk cv cF cfv cc
      wcel vk cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral vm
      cv cM cuz cfv wcel cC cc wcel vk cv cF cfv cc wcel vk cv cG cfv cC vk cv
      cF cfv cmul co wceq wa vk cM vm cv cfz co wral w3a cC vm cv cM caddc cop
      cF cseqz co cfv cmul co vm cv cM caddc cop cG cseqz co cfv cC vk cF cG cM
      vm cv iserzmulc1.2 iserzmulc1.3 serzmulc1 eqcomd vk cv cF cfv cc wcel vk
      cv cG cfv cC vk cv cF cfv cmul co wceq wa vk cv cF cfv cc wcel vk cv cG
      cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv cM vm cv cfz co vk cv
      cM vm cv cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG
      cfv cC vk cv cF cfv cmul co wceq wa vk cv cM vm cv elfzuz imim1i r19.20i2
      syl3an3 3expib com12 jcad r19.21aiv cC cc wcel vk cv cF cfv cc wcel vk cv
      cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral pm3.26 jca syl5
      3impib $.
      $( [15-Nov-2007] $) $( [14-Nov-2007] $)
  $}

  ${
    $d F j k y $.  $d G j k y $.  $d H k $.  $d M j k y $.
    climcmplem.1 $e |- F e. _V $.
    climcmplem.2 $e |- G e. _V $.
    climcmplem.3 $e |- A e. _V $.
    climcmplem.4 $e |- B e. _V $.
    climcmplem.5 $e |- H = { <. j , y >. |
                 ( j e. ( ZZ>= ` M ) /\ y = ( ( G ` j ) - ( F ` j ) ) ) } $.
    climcmplem.6 $e |- ( ph <-> ( ( F ` k ) e. RR /\
                ( G ` k ) e. RR /\ ( F ` k ) <_ ( G ` k ) ) ) $.
    climcmplem.7 $e |- ( ps <-> ( H ` k ) = ( ( G ` k ) - ( F ` k ) ) ) $.
    climcmplem.8 $e |- ( ch <-> ( F ~~> A /\ G ~~> B ) ) $.
    $( Lemma for ~ climcmp . $)
    climcmplem $p |- ( ( ch /\ ( M e. ZZ /\ A. k e. ( ZZ>= ` M ) ph ) ) ->
                      A <_ B ) $=
      wch cM cz wcel wph vk cM cuz cfv wral wa wa cc0 cB cA cmin co cle wbr cA
      cB cle wbr wch cM cz wcel wph vk cM cuz cfv wral wa cc0 cB cA cmin co cle
      wbr wch cM cz wcel wph vk cM cuz cfv wral wa cc0 cB cA cmin co cle wbr
      wch cM cz wcel wph vk cM cuz cfv wral wa cM cz wcel wph vk cM cuz cfv
      wral wa cc0 cB cA cmin co cle wbr wi wch cM cz wcel wph vk cM cuz cfv
      wral wa wa cF cA cli wbr cG cB cli wbr wa cM cz wcel vk cv cG cfv cc wcel
      vk cv cF cfv cc wcel vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq
      w3a vk cM cuz cfv wral wa wa cH cB cA cmin co cli wbr cM cz wcel wph vk
      cM cuz cfv wral wa cc0 cB cA cmin co cle wbr wi cF cA cli wbr cG cB cli
      wbr wa cM cz wcel wph vk cM cuz cfv wral wa cF cA cli wbr cG cB cli wbr
      wa cM cz wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cH cfv vk
      cv cG cfv vk cv cF cfv cmin co wceq w3a vk cM cuz cfv wral wa wa wch cM
      cz wcel wph vk cM cuz cfv wral wa cM cz wcel vk cv cG cfv cc wcel vk cv
      cF cfv cc wcel vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq w3a vk
      cM cuz cfv wral wa cF cA cli wbr cG cB cli wbr wa wph vk cM cuz cfv wral
      vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cH cfv vk cv cG cfv vk cv
      cF cfv cmin co wceq w3a vk cM cuz cfv wral cM cz wcel wph vk cM cuz cfv
      wral wph wps wa vk cM cuz cfv wral vk cv cG cfv cc wcel vk cv cF cfv cc
      wcel vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq w3a vk cM cuz
      cfv wral wph wph wps wa vk cM cuz cfv vk cv cM cuz cfv wcel wph wps vk cv
      cM cuz cfv wcel wps wph vk cv cM cuz cfv wcel vk cv cH cfv vk cv cG cfv
      vk cv cF cfv cmin co wceq wps vj vy vk cv vj cv cG cfv vj cv cF cfv cmin
      co vk cv cG cfv vk cv cF cfv cmin co cM cuz cfv cH vj cv vk cv wceq vj cv
      cG cfv vk cv cG cfv vj cv cF cfv vk cv cF cfv cmin vj cv vk cv cG fveq2
      vj cv vk cv cF fveq2 opreq12d climcmplem.5 vk cv cG cfv vk cv cF cfv cmin
      oprex fvopab4 climcmplem.7 sylibr a1d ancld r19.20i wph wps wa vk cv cG
      cfv cc wcel vk cv cF cfv cc wcel vk cv cH cfv vk cv cG cfv vk cv cF cfv
      cmin co wceq w3a vk cM cuz cfv wph vk cv cH cfv vk cv cG cfv vk cv cF cfv
      cmin co wceq wa vk cv cG cfv cc wcel vk cv cF cfv cc wcel wa vk cv cH cfv
      vk cv cG cfv vk cv cF cfv cmin co wceq wa wph wps wa vk cv cG cfv cc wcel
      vk cv cF cfv cc wcel vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq
      w3a wph vk cv cG cfv cc wcel vk cv cF cfv cc wcel wa vk cv cH cfv vk cv
      cG cfv vk cv cF cfv cmin co wceq vk cv cG cfv cr wcel vk cv cF cfv cr
      wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel wa wph vk cv cG cfv cr
      wcel vk cv cG cfv cc wcel vk cv cF cfv cr wcel vk cv cF cfv cc wcel vk cv
      cG cfv recn vk cv cF cfv recn anim12i wph vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cG cfv cr wcel
      climcmplem.6 vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv
      cG cfv cle wbr 3simp2 sylbi wph vk cv cF cfv cr wcel vk cv cG cfv cr wcel
      vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cF cfv cr wcel climcmplem.6
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle
      wbr 3simp1 sylbi sylanc anim1i wps vk cv cH cfv vk cv cG cfv vk cv cF cfv
      cmin co wceq wph climcmplem.7 anbi2i vk cv cG cfv cc wcel vk cv cF cfv cc
      wcel vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq df-3an 3imtr4i
      r19.20si syl anim2i anim2i climcmplem.8 sylanb cG cB cli wbr cF cA cli
      wbr cM cz wcel vk cv cG cfv cc wcel vk cv cF cfv cc wcel vk cv cH cfv vk
      cv cG cfv vk cv cF cfv cmin co wceq w3a vk cM cuz cfv wral wa cH cB cA
      cmin co cli wbr cB cA vk cG cF cH cM climcmplem.2 climcmplem.1 vj vy cM
      cuz cfv vj cv cG cfv vj cv cF cfv cmin co cH cM cuz fvex climcmplem.5
      fopabex2 climcmplem.4 climcmplem.3 climsub ancom1s cH cB cA cmin co cli
      wbr cM cz wcel wph vk cM cuz cfv wral wa cc0 cB cA cmin co cle wbr cH cB
      cA cmin co cli wbr cM cz wcel wph vk cM cuz cfv wral wa wa cM cz wcel cH
      cB cA cmin co cli wbr wa wph vk cM cuz cfv wral wa cc0 cB cA cmin co cle
      wbr cM cz wcel cH cB cA cmin co cli wbr wph vk cM cuz cfv wral w3a cH cB
      cA cmin co cli wbr cM cz wcel wph vk cM cuz cfv wral w3a cM cz wcel cH cB
      cA cmin co cli wbr wa wph vk cM cuz cfv wral wa cH cB cA cmin co cli wbr
      cM cz wcel wph vk cM cuz cfv wral wa wa cM cz wcel cH cB cA cmin co cli
      wbr wph vk cM cuz cfv wral 3ancoma cM cz wcel cH cB cA cmin co cli wbr
      wph vk cM cuz cfv wral df-3an cH cB cA cmin co cli wbr cM cz wcel wph vk
      cM cuz cfv wral 3anass 3bitr3i cM cz wcel cH cB cA cmin co cli wbr wa wph
      vk cM cuz cfv wral wa cM cz wcel cH cB cA cmin co cli wbr vk cv cH cfv cr
      wcel cc0 vk cv cH cfv cle wbr wa vk cM cuz cfv wral w3a cc0 cB cA cmin co
      cle wbr cM cz wcel cH cB cA cmin co cli wbr wa wph vk cM cuz cfv wral wa
      cM cz wcel cH cB cA cmin co cli wbr wa vk cv cH cfv cr wcel cc0 vk cv cH
      cfv cle wbr wa vk cM cuz cfv wral wa cM cz wcel cH cB cA cmin co cli wbr
      vk cv cH cfv cr wcel cc0 vk cv cH cfv cle wbr wa vk cM cuz cfv wral w3a
      wph vk cM cuz cfv wral vk cv cH cfv cr wcel cc0 vk cv cH cfv cle wbr wa
      vk cM cuz cfv wral cM cz wcel cH cB cA cmin co cli wbr wa wph vk cM cuz
      cfv wral wph wps wa vk cM cuz cfv wral vk cv cH cfv cr wcel cc0 vk cv cH
      cfv cle wbr wa vk cM cuz cfv wral wph wph wps wa vk cM cuz cfv vk cv cM
      cuz cfv wcel wph wps vk cv cM cuz cfv wcel wps wph vk cv cM cuz cfv wcel
      vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq wps vj vy vk cv vj cv
      cG cfv vj cv cF cfv cmin co vk cv cG cfv vk cv cF cfv cmin co cM cuz cfv
      cH vj cv vk cv wceq vj cv cG cfv vk cv cG cfv vj cv cF cfv vk cv cF cfv
      cmin vj cv vk cv cG fveq2 vj cv vk cv cF fveq2 opreq12d climcmplem.5 vk
      cv cG cfv vk cv cF cfv cmin oprex fvopab4 climcmplem.7 sylibr a1d ancld
      r19.20i wph wps wa vk cv cH cfv cr wcel cc0 vk cv cH cfv cle wbr wa vk cM
      cuz cfv wph wps wa vk cv cH cfv cr wcel cc0 vk cv cH cfv cle wbr wps wph
      vk cv cH cfv cr wcel wps vk cv cH cfv cr wcel vk cv cG cfv vk cv cF cfv
      cmin co cr wcel wph wps vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co
      wceq vk cv cH cfv cr wcel vk cv cG cfv vk cv cF cfv cmin co cr wcel wb
      climcmplem.7 vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co cr eleq1
      sylbi vk cv cG cfv cr wcel vk cv cF cfv cr wcel vk cv cG cfv vk cv cF cfv
      cmin co cr wcel wph vk cv cG cfv vk cv cF cfv resubcl wph vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cG
      cfv cr wcel climcmplem.6 vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv
      cF cfv vk cv cG cfv cle wbr 3simp2 sylbi wph vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cF cfv cr wcel
      climcmplem.6 vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv
      cG cfv cle wbr 3simp1 sylbi sylanc syl5bir impcom wph wps wa cc0 vk cv cH
      cfv cle wbr cc0 vk cv cG cfv vk cv cF cfv cmin co cle wbr wph cc0 vk cv
      cG cfv vk cv cF cfv cmin co cle wbr wps wph cc0 vk cv cG cfv vk cv cF cfv
      cmin co cle wbr vk cv cF cfv vk cv cG cfv cle wbr wph vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cF
      cfv vk cv cG cfv cle wbr climcmplem.6 vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel vk cv cF cfv vk cv cG cfv cle wbr 3simp3 sylbi vk cv cG cfv cr
      wcel vk cv cF cfv cr wcel cc0 vk cv cG cfv vk cv cF cfv cmin co cle wbr
      vk cv cF cfv vk cv cG cfv cle wbr wb wph vk cv cG cfv vk cv cF cfv subge0
      wph vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv
      cle wbr w3a vk cv cG cfv cr wcel climcmplem.6 vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr 3simp2 sylbi wph vk cv
      cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a
      vk cv cF cfv cr wcel climcmplem.6 vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel vk cv cF cfv vk cv cG cfv cle wbr 3simp1 sylbi sylanc mpbird adantr
      wps cc0 vk cv cH cfv cle wbr cc0 vk cv cG cfv vk cv cF cfv cmin co cle
      wbr wb wph wps vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co wceq cc0 vk
      cv cH cfv cle wbr cc0 vk cv cG cfv vk cv cF cfv cmin co cle wbr wb
      climcmplem.7 vk cv cH cfv vk cv cG cfv vk cv cF cfv cmin co cc0 cle breq2
      sylbi adantl mpbird jca r19.20si syl anim2i cM cz wcel cH cB cA cmin co
      cli wbr vk cv cH cfv cr wcel cc0 vk cv cH cfv cle wbr wa vk cM cuz cfv
      wral df-3an sylibr cB cA cmin co vk cH cM cB cA cmin oprex climge0 syl
      sylbir ex 3syl ex pm2.43d imp wch cM cz wcel wph vk cM cuz cfv wral cc0
      cB cA cmin co cle wbr cA cB cle wbr wb cB cr wcel cA cr wcel cc0 cB cA
      cmin co cle wbr cA cB cle wbr wb wch cM cz wcel wph vk cM cuz cfv wral
      w3a cB cA subge0 wch cM cz wcel vk cv cG cfv cr wcel vk cM cuz cfv wral
      cB cr wcel wph vk cM cuz cfv wral cF cA cli wbr cG cB cli wbr wa cM cz
      wcel vk cv cG cfv cr wcel vk cM cuz cfv wral cB cr wcel wch cG cB cli wbr
      cM cz wcel vk cv cG cfv cr wcel vk cM cuz cfv wral cB cr wcel cF cA cli
      wbr cM cz wcel cG cB cli wbr vk cv cG cfv cr wcel vk cM cuz cfv wral cB
      cr wcel cB vk cG cM climcmplem.4 climrecl 3com12 3adant1l climcmplem.8
      syl3an1b wph vk cv cG cfv cr wcel vk cM cuz cfv wph vk cv cF cfv cr wcel
      vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cG cfv
      cr wcel climcmplem.6 vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF
      cfv vk cv cG cfv cle wbr 3simp2 sylbi r19.20si syl3an3 wch cM cz wcel vk
      cv cF cfv cr wcel vk cM cuz cfv wral cA cr wcel wph vk cM cuz cfv wral cF
      cA cli wbr cG cB cli wbr wa cM cz wcel vk cv cF cfv cr wcel vk cM cuz cfv
      wral cA cr wcel wch cF cA cli wbr cM cz wcel vk cv cF cfv cr wcel vk cM
      cuz cfv wral cA cr wcel cG cB cli wbr cM cz wcel cF cA cli wbr vk cv cF
      cfv cr wcel vk cM cuz cfv wral cA cr wcel cA vk cF cM climcmplem.3
      climrecl 3com12 3adant1r climcmplem.8 syl3an1b wph vk cv cF cfv cr wcel
      vk cM cuz cfv wph vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv
      vk cv cG cfv cle wbr w3a vk cv cF cfv cr wcel climcmplem.6 vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr 3simp1
      sylbi r19.20si syl3an3 sylanc 3expb mpbid $.
      $( [11-Sep-2007] $) $( [10-Sep-2007] $)
  $}

  ${
    $d F j k y $.  $d G j k y $.  $d M j k y $.
    climcmp.1 $e |- F e. _V $.
    climcmp.2 $e |- G e. _V $.
    climcmp.3 $e |- A e. _V $.
    climcmp.4 $e |- B e. _V $.
    $( Comparison of the limits of two sequences.  (Contributed by Paul
       Chapman, 10-Sep-2007.) $)
    climcmp $p |- ( ( ( F ~~> A /\ G ~~> B ) /\ ( M e. ZZ /\
     A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. RR /\ ( G ` k ) e. RR /\
     ( F ` k ) <_ ( G ` k ) ) ) ) -> A <_ B ) $=
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle
      wbr w3a vk cv vj cv cM cuz cfv wcel vy cv vj cv cG cfv vj cv cF cfv cmin
      co wceq wa vj vy copab cfv vk cv cG cfv vk cv cF cfv cmin co wceq cF cA
      cli wbr cG cB cli wbr wa vy cA cB vj vk cF cG vj cv cM cuz cfv wcel vy cv
      vj cv cG cfv vj cv cF cfv cmin co wceq wa vj vy copab cM climcmp.1
      climcmp.2 climcmp.3 climcmp.4 vj cv cM cuz cfv wcel vy cv vj cv cG cfv vj
      cv cF cfv cmin co wceq wa vj vy copab eqid vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a biid vk cv vj cv cM cuz
      cfv wcel vy cv vj cv cG cfv vj cv cF cfv cmin co wceq wa vj vy copab cfv
      vk cv cG cfv vk cv cF cfv cmin co wceq biid cF cA cli wbr cG cB cli wbr
      wa biid climcmplem $.
      $( [11-Sep-2007] $) $( [10-Sep-2007] $)
  $}

  ${
    $d k A $.  $d k B $.  $d k F $.  $d k M $.
    climcmpc1.1 $e |- F e. _V $.
    climcmpc1.3 $e |- A e. _V $.
    climcmpc1.4 $e |- B e. _V $.
    $( Comparison of a constant to the limit of a sequence. $)
    climcmpc1 $p |- ( ( ( A e. RR /\ F ~~> B ) /\ ( M e. ZZ /\
  A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. RR /\ A <_ ( F ` k ) ) ) ) -> A <_ B ) $=
      cM cuz cfv cA csn cxp cA cli wbr cF cB cli wbr cM cz wcel vk cv cM cuz
      cfv cA csn cxp cfv cr wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cA csn
      cxp cfv vk cv cF cfv cle wbr w3a vk cM cuz cfv wral cA cB cle wbr cA cr
      wcel cF cB cli wbr wa cM cz wcel vk cv cF cfv cr wcel cA vk cv cF cfv cle
      wbr wa vk cM cuz cfv wral wa wa cA cB vk cM cuz cfv cA csn cxp cF cM cM
      cuz cfv cA csn cM cuz fvex cA snex xpex climcmpc1.1 climcmpc1.3
      climcmpc1.4 climcmp cA cr wcel cM cz wcel cM cuz cfv cA csn cxp cA cli
      wbr cF cB cli wbr vk cv cF cfv cr wcel cA vk cv cF cfv cle wbr wa vk cM
      cuz cfv wral cA cc wcel cM cz wcel cM cuz cfv cA csn cxp cA cli wbr cA cr
      wcel cA cM climconst3 cA recn sylan ad2ant2r cA cr wcel cF cB cli wbr cM
      cz wcel vk cv cF cfv cr wcel cA vk cv cF cfv cle wbr wa vk cM cuz cfv
      wral wa simplr cA cr wcel cF cB cli wbr wa cM cz wcel vk cv cF cfv cr
      wcel cA vk cv cF cfv cle wbr wa vk cM cuz cfv wral simprl cA cr wcel cF
      cB cli wbr wa cM cz wcel vk cv cF cfv cr wcel cA vk cv cF cfv cle wbr wa
      vk cM cuz cfv wral vk cv cM cuz cfv cA csn cxp cfv cr wcel vk cv cF cfv
      cr wcel vk cv cM cuz cfv cA csn cxp cfv vk cv cF cfv cle wbr w3a vk cM
      cuz cfv wral cA cr wcel cF cB cli wbr wa cM cz wcel vk cv cF cfv cr wcel
      cA vk cv cF cfv cle wbr wa vk cM cuz cfv wral vk cv cM cuz cfv cA csn cxp
      cfv cr wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cA csn cxp cfv vk cv cF
      cfv cle wbr w3a vk cM cuz cfv wral wi cA cr wcel cF cB cli wbr wa cM cz
      wcel wa vk cv cF cfv cr wcel cA vk cv cF cfv cle wbr wa vk cv cM cuz cfv
      cA csn cxp cfv cr wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cA csn cxp
      cfv vk cv cF cfv cle wbr w3a vk cM cuz cfv cA cr wcel cF cB cli wbr wa cM
      cz wcel wa vk cv cM cuz cfv wcel wa vk cv cF cfv cr wcel cA vk cv cF cfv
      cle wbr wa vk cv cM cuz cfv cA csn cxp cfv cr wcel vk cv cF cfv cr wcel
      vk cv cM cuz cfv cA csn cxp cfv vk cv cF cfv cle wbr w3a cA cr wcel cF cB
      cli wbr wa cM cz wcel wa vk cv cM cuz cfv wcel wa vk cv cF cfv cr wcel cA
      vk cv cF cfv cle wbr wa wa vk cv cM cuz cfv cA csn cxp cfv cr wcel vk cv
      cF cfv cr wcel vk cv cM cuz cfv cA csn cxp cfv vk cv cF cfv cle wbr cA cr
      wcel cF cB cli wbr wa cM cz wcel wa vk cv cM cuz cfv wcel wa vk cv cM cuz
      cfv cA csn cxp cfv cr wcel vk cv cF cfv cr wcel cA vk cv cF cfv cle wbr
      wa cA cr wcel cF cB cli wbr wa vk cv cM cuz cfv wcel vk cv cM cuz cfv cA
      csn cxp cfv cr wcel cM cz wcel cA cr wcel vk cv cM cuz cfv wcel vk cv cM
      cuz cfv cA csn cxp cfv cr wcel cF cB cli wbr cA cr wcel vk cv cM cuz cfv
      wcel wa vk cv cM cuz cfv cA csn cxp cfv cA cr cM cuz cfv cA vk cv cr
      fvconst2g cA cr wcel vk cv cM cuz cfv wcel pm3.26 eqeltrd adantlr adantlr
      adantr cA cr wcel cF cB cli wbr wa cM cz wcel wa vk cv cM cuz cfv wcel wa
      vk cv cF cfv cr wcel cA vk cv cF cfv cle wbr simprl cA cr wcel cF cB cli
      wbr wa cM cz wcel wa vk cv cM cuz cfv wcel wa cA vk cv cF cfv cle wbr vk
      cv cM cuz cfv cA csn cxp cfv vk cv cF cfv cle wbr vk cv cF cfv cr wcel cA
      cr wcel cF cB cli wbr wa vk cv cM cuz cfv wcel cA vk cv cF cfv cle wbr vk
      cv cM cuz cfv cA csn cxp cfv vk cv cF cfv cle wbr cM cz wcel cA cr wcel
      vk cv cM cuz cfv wcel cA vk cv cF cfv cle wbr vk cv cM cuz cfv cA csn cxp
      cfv vk cv cF cfv cle wbr cF cB cli wbr cA cr wcel vk cv cM cuz cfv wcel
      wa vk cv cM cuz cfv cA csn cxp cfv vk cv cF cfv cle wbr cA vk cv cF cfv
      cle wbr cA cr wcel vk cv cM cuz cfv wcel wa vk cv cM cuz cfv cA csn cxp
      cfv cA vk cv cF cfv cle cM cuz cfv cA vk cv cr fvconst2g breq1d biimpar
      adantllr adantllr adantrl 3jca ex r19.20dva ex imp32 syl2anc $.
      $( [19-Mar-2008] $) $( [28-Feb-2008] $)
  $}

  ${
    $d j k x A $.  $d j k x F $.  $d j k x G $.  $d j k x M $.
    climsqueeze.1 $e |- F e. _V $.
    climsqueeze.2 $e |- G e. _V $.
    climsqueeze.3 $e |- A e. _V $.
    $( Convergence of a sequence sandwiched between another converging
       sequence and its limit. $)
    climsqueeze $p |- ( ( F ~~> A /\ M e. ZZ /\
     A. k e. ( ZZ>= ` M ) ( ( ( F ` k ) e. RR /\ ( G ` k ) e. RR ) /\
     ( ( F ` k ) <_ ( G ` k ) /\ ( G ` k ) <_ A ) ) ) -> G ~~> A ) $=
      cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk
      cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz
      cfv wral cG cA cli wbr cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk
      cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA
      cle wbr wa wa vk cM cuz cfv wral w3a cA cr wcel cG cA cli wbr cM cz wcel
      cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral cA cr wcel vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk
      cv cG cfv cA cle wbr wa wa vk cM cuz cfv wral cA vk cF cM climsqueeze.3
      climrecl vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv
      cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cv cF cfv cr wcel vk cM
      cuz cfv vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG
      cfv cle wbr vk cv cG cfv cA cle wbr wa simpll r19.20si syl3an3 cM cz wcel
      cF cA cli wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv
      vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz cfv wral cA
      cr wcel cG cA cli wbr wi cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle
      wbr wa wa vk cM cuz cfv wral cF cA cli wbr cG cA cli wbr cM cz wcel cA cr
      wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG
      cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz cfv wral cF cA cli
      wbr cG cA cli wbr wi cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr
      wa wa vk cM cuz cfv wral w3a cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex
      wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral
      cF cA cli wbr cG cA cli wbr cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk
      cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA
      cle wbr wa wa vk cM cuz cfv wral w3a cc0 vx cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral
      vj cz wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin
      co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr cM cz
      wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv
      vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz cfv wral w3a
      vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wi vk cM cuz cfv wral vj cz wrex vj cv vk cv cle wbr vk cv cG
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex
      cc0 vx cv clt wbr cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa
      wa vk cM cuz cfv wral w3a vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv
      cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv
      wral vj cz cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv
      cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz cfv
      wral vx cv cr wcel vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral wi cM cz wcel cA cr
      wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG
      cfv cle wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz cfv wral wa vx cv cr
      wcel wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr
      wi wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cG cfv
      cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral wi cA cr wcel vk
      cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle
      wbr vk cv cG cfv cA cle wbr wa wa vk cM cuz cfv wral vx cv cr wcel vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz
      cfv wral cA cr wcel vx cv cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa
      vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx
      cv clt wbr wi wi vk cM cuz cfv wral cA cr wcel vx cv cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv
      cG cfv cA cle wbr wa wa vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv
      cA cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz cfv wral wi cA cr wcel
      vx cv cr wcel wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF
      cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr
      vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz cfv cA cr
      wcel vx cv cr wcel wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv
      cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr
      vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi wi cA cr wcel vx cv cr
      wcel wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv
      cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa wa vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr vj
      cv vk cv cle wbr cA cr wcel vx cv cr wcel wa vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle
      wbr wa wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co
      cabs cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr vk cv cG
      cfv cA cmin co cabs cfv vx cv clt wbr cA cr wcel vk cv cF cfv cr wcel vk
      cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA
      cle wbr wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co
      cabs cfv cle wbr vx cv cr wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr
      wa wa wa cA vk cv cG cfv cmin co cA vk cv cF cfv cmin co vk cv cG cfv cA
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv cle cA cr wcel vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr cA
      vk cv cG cfv cmin co cA vk cv cF cfv cmin co cle wbr vk cv cG cfv cA cle
      wbr cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk
      cv cG cfv cle wbr cA vk cv cG cfv cmin co cA vk cv cF cfv cmin co cle wbr
      cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv
      cG cfv cle wbr cA vk cv cG cfv cmin co cA vk cv cF cfv cmin co cle wbr wi
      cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel w3a vk cv cF cfv vk
      cv cG cfv cle wbr cA vk cv cG cfv cmin co cA vk cv cF cfv cmin co cle wbr
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel cA cr wcel vk cv cF cfv vk cv
      cG cfv cle wbr cA vk cv cG cfv cmin co cA vk cv cF cfv cmin co cle wbr wb
      vk cv cF cfv vk cv cG cfv cA lesub2 3comr biimpd 3exp imp44 adantrrr cA
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cG
      cfv cA cle wbr wa vk cv cG cfv cA cmin co cabs cfv cA vk cv cG cfv cmin
      co wceq vk cv cF cfv cr wcel cA cr wcel vk cv cG cfv cr wcel vk cv cG cfv
      cA cle wbr vk cv cG cfv cA cmin co cabs cfv cA vk cv cG cfv cmin co wceq
      vk cv cF cfv vk cv cG cfv cle wbr cA cr wcel vk cv cG cfv cr wcel vk cv
      cG cfv cA cle wbr vk cv cG cfv cA cmin co cabs cfv cA vk cv cG cfv cmin
      co wceq vk cv cG cfv cr wcel cA cr wcel vk cv cG cfv cA cle wbr vk cv cG
      cfv cA cmin co cabs cfv cA vk cv cG cfv cmin co wceq vk cv cG cfv cA
      abssuble0 3com12 3expb adantrrl adantrll vk cv cF cfv cr wcel cA cr wcel
      vk cv cF cfv cA cle wbr vk cv cF cfv cA cmin co cabs cfv cA vk cv cF cfv
      cmin co wceq cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk
      cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa wa vk cv cF
      cfv cA abssuble0 cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk
      cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa simprll cA cr
      wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG
      cfv cle wbr vk cv cG cfv cA cle wbr wa wa pm3.26 cA cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cG
      cfv cA cle wbr wa vk cv cF cfv cA cle wbr cA cr wcel vk cv cF cfv cr wcel
      vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA
      cle wbr wa vk cv cF cfv cA cle wbr wi vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel cA cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle
      wbr wa vk cv cF cfv cA cle wbr wi vk cv cF cfv vk cv cG cfv cA letr 3comr
      3exp imp44 syl3anc 3brtr4d adantlr cA cr wcel vx cv cr wcel wa vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel wa vk cv cG cfv cA cmin co cabs cfv vk
      cv cF cfv cA cmin co cabs cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vx
      cv clt wbr wa vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi vk cv cF
      cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa vk cv cG cfv cA cmin
      co cabs cfv cr wcel vk cv cF cfv cA cmin co cabs cfv cr wcel vx cv cr
      wcel vk cv cG cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv
      cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vk cv cG cfv cA
      cmin co cabs cfv vx cv clt wbr wi cA cr wcel vx cv cr wcel wa vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel wa wa vk cv cG cfv cA cmin co cabs cfv
      vk cv cF cfv cA cmin co cabs cfv vx cv lelttr cA cr wcel vk cv cG cfv cr
      wcel vk cv cG cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vk cv cF cfv
      cr wcel cA cr wcel vk cv cG cfv cr wcel wa vk cv cG cfv cA cmin co cc
      wcel vk cv cG cfv cA cmin co cabs cfv cr wcel cA cr wcel vk cv cG cfv cr
      wcel wa vk cv cG cfv cA cmin co vk cv cG cfv cr wcel cA cr wcel vk cv cG
      cfv cA cmin co cr wcel vk cv cG cfv cA resubcl ancoms recnd vk cv cG cfv
      cA cmin co abscl syl ad2ant2rl cA cr wcel vk cv cF cfv cr wcel vk cv cF
      cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vk cv cG cfv cr wcel cA cr
      wcel vk cv cF cfv cr wcel wa vk cv cF cfv cA cmin co cc wcel vk cv cF cfv
      cA cmin co cabs cfv cr wcel cA cr wcel vk cv cF cfv cr wcel wa vk cv cF
      cfv cA cmin co vk cv cF cfv cr wcel cA cr wcel vk cv cF cfv cA cmin co cr
      wcel vk cv cF cfv cA resubcl ancoms recnd vk cv cF cfv cA cmin co abscl
      syl ad2ant2r cA cr wcel vx cv cr wcel vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel wa simplr syl3anc adantrr mpand imim2d ex r19.20sdv ex com23
      imp31 vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi
      vk cM cuz cfv r19.20 syl 3adantl1 r19.22sdv imim2d r19.20dva cM cz wcel
      cA cr wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cF cA cli wbr cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG
      cfv cA cle wbr wa wa vk cM cuz cfv wral cM cz wcel cA cc wcel vk cv cF
      cfv cc wcel vk cM cuz cfv wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz
      cfv wral vj cz wrex wi vx cr wral wb cA cr wcel vx cA vj vk cF cM
      climsqueeze.1 clm4a cA recn syl3an2 vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa
      vk cv cF cfv cc wcel vk cM cuz cfv vk cv cF cfv cr wcel vk cv cF cfv cc
      wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv
      cA cle wbr wa vk cv cF cfv recn ad2antrr r19.20si syl3an3 cM cz wcel cA
      cr wcel vk cv cG cfv cc wcel vk cM cuz cfv wral cG cA cli wbr cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG
      cfv cA cle wbr wa wa vk cM cuz cfv wral cM cz wcel cA cc wcel vk cv cG
      cfv cc wcel vk cM cuz cfv wral cG cA cli wbr cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz
      cfv wral vj cz wrex wi vx cr wral wb cA cr wcel vx cA vj vk cG cM
      climsqueeze.2 clm4a cA recn syl3an2 vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cA cle wbr wa wa
      vk cv cG cfv cc wcel vk cM cuz cfv vk cv cG cfv cr wcel vk cv cG cfv cc
      wcel vk cv cF cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv
      cA cle wbr wa vk cv cG cfv recn ad2antlr r19.20si syl3an3 3imtr4d 3exp
      com24 3imp mpd 3com12 $.
      $( [14-Feb-2008] $) $( [6-Feb-2008] $)

    $( Convergence of a sequence sandwiched between another converging
       sequence and its limit. $)
    climsqueeze2 $p |- ( ( F ~~> A /\ M e. ZZ /\
     A. k e. ( ZZ>= ` M ) ( ( ( F ` k ) e. RR /\ ( G ` k ) e. RR ) /\
     ( A <_ ( G ` k ) /\ ( G ` k ) <_ ( F ` k ) ) ) ) -> G ~~> A ) $=
      cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA
      vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz
      cfv wral cG cA cli wbr cM cz wcel cF cA cli wbr vk cv cF cfv cr wcel vk
      cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv
      cle wbr wa wa vk cM cuz cfv wral w3a cA cr wcel cG cA cli wbr cM cz wcel
      cF cA cli wbr vk cv cF cfv cr wcel vk cM cuz cfv wral cA cr wcel vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv
      vk cv cF cfv cle wbr wa wa vk cM cuz cfv wral cA vk cF cM climsqueeze.3
      climrecl vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle
      wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cv cF cfv cr wcel vk cM
      cuz cfv vk cv cF cfv cr wcel vk cv cG cfv cr wcel cA vk cv cG cfv cle wbr
      vk cv cG cfv vk cv cF cfv cle wbr wa simpll r19.20si syl3an3 cM cz wcel
      cF cA cli wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG
      cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz cfv wral cA
      cr wcel cG cA cli wbr wi cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle
      wbr wa wa vk cM cuz cfv wral cF cA cli wbr cG cA cli wbr cM cz wcel cA cr
      wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr
      vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz cfv wral cF cA cli wbr
      cG cA cli wbr wi cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa
      wa vk cM cuz cfv wral w3a cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi
      vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral cF
      cA cli wbr cG cA cli wbr cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle
      wbr wa wa vk cM cuz cfv wral w3a cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz
      wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co
      cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr cM cz
      wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG
      cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz cfv wral
      w3a vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex vj cv vk cv cle wbr vk cv
      cG cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex
      cc0 vx cv clt wbr cM cz wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa
      wa vk cM cuz cfv wral w3a vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv
      cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv
      wral vj cz cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk
      cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz cfv
      wral vx cv cr wcel vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cG cfv cA
      cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral wi cM cz wcel cA cr
      wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr
      vk cv cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz cfv wral wa vx cv cr
      wcel wa vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr
      wi wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
      cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cG cfv
      cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral wi cA cr wcel vk
      cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv
      cG cfv vk cv cF cfv cle wbr wa wa vk cM cuz cfv wral vx cv cr wcel vj cv
      vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz
      cfv wral cA cr wcel vx cv cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa
      vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv
      vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx
      cv clt wbr wi wi vk cM cuz cfv wral cA cr wcel vx cv cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk
      cv cF cfv cle wbr wa wa vk cM cuz cfv wral vj cv vk cv cle wbr vk cv cF
      cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv
      cA cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz cfv wral wi cA cr wcel
      vx cv cr wcel wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG
      cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vj cv vk cv cle wbr
      vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr vk
      cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz cfv cA cr
      wcel vx cv cr wcel wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk
      cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa vj cv vk cv cle
      wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr
      vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi wi cA cr wcel vx cv cr
      wcel wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle
      wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa wa vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr vj
      cv vk cv cle wbr cA cr wcel vx cv cr wcel wa vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle
      wbr wa wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co
      cabs cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr vk cv cG
      cfv cA cmin co cabs cfv vx cv clt wbr cA cr wcel vk cv cF cfv cr wcel vk
      cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv
      cle wbr wa wa vk cv cG cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co
      cabs cfv cle wbr vx cv cr wcel cA cr wcel vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr
      wa wa wa vk cv cG cfv cA cmin co vk cv cF cfv cA cmin co vk cv cG cfv cA
      cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv cle cA cr wcel vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel wa vk cv cG cfv vk cv cF cfv cle wbr vk
      cv cG cfv cA cmin co vk cv cF cfv cA cmin co cle wbr cA vk cv cG cfv cle
      wbr cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cG cfv vk
      cv cF cfv cle wbr vk cv cG cfv cA cmin co vk cv cF cfv cA cmin co cle wbr
      cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cG cfv vk cv
      cF cfv cle wbr vk cv cG cfv cA cmin co vk cv cF cfv cA cmin co cle wbr wi
      cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel w3a vk cv cG cfv vk
      cv cF cfv cle wbr vk cv cG cfv cA cmin co vk cv cF cfv cA cmin co cle wbr
      vk cv cG cfv cr wcel vk cv cF cfv cr wcel cA cr wcel vk cv cG cfv vk cv
      cF cfv cle wbr vk cv cG cfv cA cmin co vk cv cF cfv cA cmin co cle wbr wb
      vk cv cG cfv vk cv cF cfv cA lesub1 3com13 biimpd 3exp imp44 adantrrl cA
      cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle
      wbr vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv cA cmin co wceq vk cv
      cG cfv vk cv cF cfv cle wbr cA cr wcel vk cv cG cfv cr wcel cA vk cv cG
      cfv cle wbr vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv cA cmin co wceq
      vk cv cF cfv cr wcel cA cr wcel vk cv cG cfv cr wcel cA vk cv cG cfv cle
      wbr vk cv cG cfv cA cmin co cabs cfv vk cv cG cfv cA cmin co wceq cA vk
      cv cG cfv abssubge0 3expb adantrll adantrrr cA cr wcel vk cv cF cfv cr
      wcel cA vk cv cF cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vk cv cF
      cfv cA cmin co wceq cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel
      wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa wa cA
      vk cv cF cfv abssubge0 cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa
      pm3.26 cA cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel cA vk cv cG
      cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa simprll cA cr wcel vk cv
      cF cfv cr wcel vk cv cG cfv cr wcel cA vk cv cG cfv cle wbr vk cv cG cfv
      vk cv cF cfv cle wbr wa cA vk cv cF cfv cle wbr cA cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel cA vk cv cG cfv cle wbr vk cv cG cfv vk cv
      cF cfv cle wbr wa cA vk cv cF cfv cle wbr wi cA cr wcel vk cv cG cfv cr
      wcel vk cv cF cfv cr wcel cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF
      cfv cle wbr wa cA vk cv cF cfv cle wbr wi cA vk cv cG cfv vk cv cF cfv
      letr 3com23 3exp imp44 syl3anc 3brtr4d adantlr cA cr wcel vx cv cr wcel
      wa vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cG cfv cA cmin co
      cabs cfv vk cv cF cfv cA cmin co cabs cfv cle wbr vk cv cF cfv cA cmin co
      cabs cfv vx cv clt wbr wa vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr
      wi cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa vk cv cG
      cfv cA cmin co cabs cfv cr wcel vk cv cF cfv cA cmin co cabs cfv cr wcel
      vx cv cr wcel vk cv cG cfv cA cmin co cabs cfv vk cv cF cfv cA cmin co
      cabs cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wa vk cv
      cG cfv cA cmin co cabs cfv vx cv clt wbr wi cA cr wcel vx cv cr wcel wa
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa wa vk cv cG cfv cA cmin co
      cabs cfv vk cv cF cfv cA cmin co cabs cfv vx cv lelttr cA cr wcel vk cv
      cG cfv cr wcel vk cv cG cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vk
      cv cF cfv cr wcel cA cr wcel vk cv cG cfv cr wcel wa vk cv cG cfv cA cmin
      co cc wcel vk cv cG cfv cA cmin co cabs cfv cr wcel cA cr wcel vk cv cG
      cfv cr wcel wa vk cv cG cfv cA cmin co vk cv cG cfv cr wcel cA cr wcel vk
      cv cG cfv cA cmin co cr wcel vk cv cG cfv cA resubcl ancoms recnd vk cv
      cG cfv cA cmin co abscl syl ad2ant2rl cA cr wcel vk cv cF cfv cr wcel vk
      cv cF cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vk cv cG cfv cr wcel
      cA cr wcel vk cv cF cfv cr wcel wa vk cv cF cfv cA cmin co cc wcel vk cv
      cF cfv cA cmin co cabs cfv cr wcel cA cr wcel vk cv cF cfv cr wcel wa vk
      cv cF cfv cA cmin co vk cv cF cfv cr wcel cA cr wcel vk cv cF cfv cA cmin
      co cr wcel vk cv cF cfv cA resubcl ancoms recnd vk cv cF cfv cA cmin co
      abscl syl ad2ant2r cA cr wcel vx cv cr wcel vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel wa simplr syl3anc adantrr mpand imim2d ex r19.20sdv ex com23
      imp31 vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
      wi vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi
      vk cM cuz cfv r19.20 syl 3adantl1 r19.22sdv imim2d r19.20dva cM cz wcel
      cA cr wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cF cA cli wbr cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv
      cF cfv cle wbr wa wa vk cM cuz cfv wral cM cz wcel cA cc wcel vk cv cF
      cfv cc wcel vk cM cuz cfv wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz
      cfv wral vj cz wrex wi vx cr wral wb cA cr wcel vx cA vj vk cF cM
      climsqueeze.1 clm4a cA recn syl3an2 vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa
      vk cv cF cfv cc wcel vk cM cuz cfv vk cv cF cfv cr wcel vk cv cF cfv cc
      wcel vk cv cG cfv cr wcel cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF
      cfv cle wbr wa vk cv cF cfv recn ad2antrr r19.20si syl3an3 cM cz wcel cA
      cr wcel vk cv cG cfv cc wcel vk cM cuz cfv wral cG cA cli wbr cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt
      wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr wral wb vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv
      cF cfv cle wbr wa wa vk cM cuz cfv wral cM cz wcel cA cc wcel vk cv cG
      cfv cc wcel vk cM cuz cfv wral cG cA cli wbr cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cG cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz
      cfv wral vj cz wrex wi vx cr wral wb cA cr wcel vx cA vj vk cG cM
      climsqueeze.2 clm4a cA recn syl3an2 vk cv cF cfv cr wcel vk cv cG cfv cr
      wcel wa cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF cfv cle wbr wa wa
      vk cv cG cfv cc wcel vk cM cuz cfv vk cv cG cfv cr wcel vk cv cG cfv cc
      wcel vk cv cF cfv cr wcel cA vk cv cG cfv cle wbr vk cv cG cfv vk cv cF
      cfv cle wbr wa vk cv cG cfv recn ad2antlr r19.20si syl3an3 3imtr4d 3exp
      com24 3imp mpd 3com12 $.
      $( [9-Mar-2008] $) $( [14-Feb-2008] $)
  $}

  ${
    $d F k m $.  $d G k m $.  $d M k m $.
    iserzcmp.1 $e |- A e. _V $.
    iserzcmp.2 $e |- B e. _V $.
    iserzcmp.3 $e |- F e. _V $.
    iserzcmp.4 $e |- G e. _V $.
    $( Comparison of the limits of two infinite series.  (Contributed by Paul
       Chapman, 12-Nov-2007.) $)
    iserzcmp $p |- ( ( ( ( <. M , + >. seq F ) ~~> A /\ ( <. M , + >. seq G )
      ~~> B ) /\ ( M e. ZZ /\ A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. RR /\
      ( G ` k ) e. RR /\ ( F ` k ) <_ ( G ` k ) ) ) ) -> A <_ B ) $=
      cM caddc cop cF cseqz co cA cli wbr cM caddc cop cG cseqz co cB cli wbr
      wa cM cz wcel vm cv cM caddc cop cF cseqz co cfv cr wcel vm cv cM caddc
      cop cG cseqz co cfv cr wcel vm cv cM caddc cop cF cseqz co cfv vm cv cM
      caddc cop cG cseqz co cfv cle wbr w3a vm cM cuz cfv wral cA cB cle wbr vk
      cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr
      w3a vk cM cuz cfv wral cA cB vm cM caddc cop cF cseqz co cM caddc cop cG
      cseqz co cM cM caddc cop cF cseqz oprex cM caddc cop cG cseqz oprex
      iserzcmp.1 iserzcmp.2 climcmp vk cv cF cfv cr wcel vk cv cG cfv cr wcel
      vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral vm cv cM caddc
      cop cF cseqz co cfv cr wcel vm cv cM caddc cop cG cseqz co cfv cr wcel vm
      cv cM caddc cop cF cseqz co cfv vm cv cM caddc cop cG cseqz co cfv cle
      wbr w3a vm cM cuz cfv vm cv cM cuz cfv wcel vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral vm
      cv cM caddc cop cF cseqz co cfv cr wcel vm cv cM caddc cop cG cseqz co
      cfv cr wcel vm cv cM caddc cop cF cseqz co cfv vm cv cM caddc cop cG
      cseqz co cfv cle wbr w3a vm cv cM cuz cfv wcel vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral
      wa vm cv cM caddc cop cF cseqz co cfv cr wcel vm cv cM caddc cop cG cseqz
      co cfv cr wcel vm cv cM caddc cop cF cseqz co cfv vm cv cM caddc cop cG
      cseqz co cfv cle wbr vm cv cM cuz cfv wcel vk cv cF cfv cr wcel vk cM vm
      cv cfz co wral vm cv cM caddc cop cF cseqz co cfv cr wcel vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cuz
      cfv wral vk cF cM vm cv iserzcmp.3 serzrecl vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral vk
      cv cF cfv cr wcel vk cM cuz cfv wral vk cv cF cfv cr wcel vk cM vm cv cfz
      co wral vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG
      cfv cle wbr w3a vk cv cF cfv cr wcel vk cM cuz cfv vk cv cF cfv cr wcel
      vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr 3simp1 r19.20si cM
      vm cv cfz co cM cuz cfv wss vk cv cF cfv cr wcel vk cM cuz cfv wral vk cv
      cF cfv cr wcel vk cM vm cv cfz co wral wi cM vm cv fzssuz vk cv cF cfv cr
      wcel vk cM vm cv cfz co cM cuz cfv ssralv ax-mp syl sylan2 vm cv cM cuz
      cfv wcel vk cv cG cfv cr wcel vk cM vm cv cfz co wral vm cv cM caddc cop
      cG cseqz co cfv cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv
      cF cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral vk cG cM vm cv
      iserzcmp.4 serzrecl vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF
      cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral vk cv cG cfv cr wcel vk
      cM cuz cfv wral vk cv cG cfv cr wcel vk cM vm cv cfz co wral vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv
      cG cfv cr wcel vk cM cuz cfv vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk
      cv cF cfv vk cv cG cfv cle wbr 3simp2 r19.20si cM vm cv cfz co cM cuz cfv
      wss vk cv cG cfv cr wcel vk cM cuz cfv wral vk cv cG cfv cr wcel vk cM vm
      cv cfz co wral wi cM vm cv fzssuz vk cv cG cfv cr wcel vk cM vm cv cfz co
      cM cuz cfv ssralv ax-mp syl sylan2 vm cv cM cuz cfv wcel vk cv cF cfv cr
      wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM vm
      cv cfz co wral vm cv cM caddc cop cF cseqz co cfv vm cv cM caddc cop cG
      cseqz co cfv cle wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF
      cfv vk cv cG cfv cle wbr w3a vk cM cuz cfv wral vk cF cG cM vm cv
      iserzcmp.3 iserzcmp.4 serzcmp cM vm cv cfz co cM cuz cfv wss vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM
      cuz cfv wral vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv
      cG cfv cle wbr w3a vk cM vm cv cfz co wral wi cM vm cv fzssuz vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk
      cM vm cv cfz co cM cuz cfv ssralv ax-mp sylan2 3jca expcom r19.21aiv
      sylanr2 $.
      $( [12-Nov-2007] $) $( [12-Nov-2007] $)
  $}

  ${
    $d F k $.  $d M k $.
    iserzcmp0.1 $e |- A e. _V $.
    iserzcmp0.2 $e |- F e. _V $.
    $( The limit of an infinite series of nonnegative reals is nonnegative.
       (Contributed by Paul Chapman, 9-Feb-2007.) $)
    iserzcmp0 $p |- ( ( M e. ZZ /\ ( <. M , + >. seq F ) ~~> A /\
    A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. RR /\ 0 <_ ( F ` k ) ) ) -> 0 <_ A ) $=
      cM cz wcel cM caddc cop cF cseqz co cA cli wbr vk cv cF cfv cr wcel cc0
      vk cv cF cfv cle wbr wa vk cM cuz cfv wral cc0 cA cle wbr cM cz wcel cM
      caddc cop cF cseqz co cA cli wbr vk cv cM cuz cfv cc0 csn cxp cfv cr wcel
      vk cv cF cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF cfv cle
      wbr w3a vk cM cuz cfv wral cc0 cA cle wbr vk cv cF cfv cr wcel cc0 vk cv
      cF cfv cle wbr wa vk cM cuz cfv wral cM cz wcel cM caddc cop cF cseqz co
      cA cli wbr vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cF cfv cr wcel
      vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF cfv cle wbr w3a vk cM cuz cfv
      wral cc0 cA cle wbr cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cc0 cli
      wbr cM caddc cop cF cseqz co cA cli wbr cM cz wcel vk cv cM cuz cfv cc0
      csn cxp cfv cr wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv
      vk cv cF cfv cle wbr w3a vk cM cuz cfv wral wa cc0 cA cle wbr cM cz wcel
      cc0 cA vk cM cuz cfv cc0 csn cxp cF cM cc0 cr 0re elisseti iserzcmp0.1 cM
      cuz cfv cc0 csn cM cuz fvex cc0 snex xpex iserzcmp0.2 iserzcmp cM
      serzclim0 sylanl1 anandis vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr
      wa vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cF cfv cr wcel vk cv cM
      cuz cfv cc0 csn cxp cfv vk cv cF cfv cle wbr w3a vk cM cuz cfv vk cv cM
      cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cv cM
      cuz cfv cc0 csn cxp cfv cr wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cc0
      csn cxp cfv vk cv cF cfv cle wbr wa wa vk cv cM cuz cfv cc0 csn cxp cfv
      cr wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF
      cfv cle wbr w3a vk cv cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF
      cfv cle wbr wa vk cv cF cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk
      cv cF cfv cle wbr wa vk cv cM cuz cfv cc0 csn cxp cfv cr wcel vk cv cM
      cuz cfv wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv
      cF cfv cle wbr wa vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cv
      cM cuz cfv wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF cfv cle wbr cc0
      vk cv cF cfv cle wbr vk cv cF cfv cr wcel vk cv cM cuz cfv wcel vk cv cM
      cuz cfv cc0 csn cxp cfv cc0 vk cv cF cfv cle cM cuz cfv cc0 vk cv cc0 cr
      0re elisseti fvconst2 breq1d anbi2d biimprd vk cv cM cuz cfv wcel vk cv
      cM cuz cfv cc0 csn cxp cfv cc0 cr cM cuz cfv cc0 vk cv cc0 cr 0re
      elisseti fvconst2 0re syl6eqel jctild vk cv cM cuz cfv cc0 csn cxp cfv cr
      wcel vk cv cF cfv cr wcel vk cv cM cuz cfv cc0 csn cxp cfv vk cv cF cfv
      cle wbr 3anass syl6ibr r19.20i sylanr2 3impb $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    iserzshft.1 $e |- F e. _V $.
    iserzshft.2 $e |- M e. ZZ $.
    iserzshft.3 $e |- K e. ZZ $.
    iserzshft.4 $e |- N = ( M + K ) $.
    iserzshft.5 $e |- G = ( F shift K ) $.
    $( Index shift of an infinite series. (Contributed by Paul Chapman,
       31-Oct-2007.) $)
    iserzshfti $p |- ( A e. B -> ( ( <. M , + >. seq F ) ~~> A <->
                                  ( <. N , + >. seq G ) ~~> A ) ) $=
      cA cB wcel cM caddc cop cF cseqz co cA cli wbr cN caddc cop cG cseqz co
      cA cli wbr cA cc wcel cA cB cM caddc cop cF cseqz co climcl cA cB cN
      caddc cop cG cseqz co climcl cA cc wcel caddc cG c1 cN cmin co cshi co
      cseq1 co cN c1 cmin co cshi co cN cuz cfv cres cA cli wbr caddc cG c1 cN
      cmin co cshi co cseq1 co cN c1 cmin co cshi co cA cli wbr cN caddc cop cG
      cseqz co cA cli wbr cM caddc cop cF cseqz co cA cli wbr cA cc caddc cG c1
      cN cmin co cshi co cseq1 co cN c1 cmin co cshi co cN caddc cG c1 cN cmin
      co cshi co cseq1 co cN c1 cmin co cshi oprex cN cM cK caddc co cz
      iserzshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel iserzshft.2
      iserzshft.3 cM cK zaddcl mp2an eqeltri climresi cN caddc cop cG cseqz co
      cA cli wbr caddc cG c1 cN cmin co cshi co cseq1 co cN c1 cmin co cshi co
      cN cuz cfv cres cA cli wbr wb cA cc wcel cN caddc cop cG cseqz co caddc
      cG c1 cN cmin co cshi co cseq1 co cN c1 cmin co cshi co cN cuz cfv cres
      cA cli cN cz wcel cN caddc cop cG cseqz co caddc cG c1 cN cmin co cshi co
      cseq1 co cN c1 cmin co cshi co cN cuz cfv cres wceq cN cM cK caddc co cz
      iserzshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel iserzshft.2
      iserzshft.3 cM cK zaddcl mp2an eqeltri caddc cG cN addex cG cF cK cshi co
      cvv iserzshft.5 cF cK cshi oprex eqeltri seqzfval2 ax-mp breq1i a1i cA cc
      wcel cM caddc cop cF cseqz co cA cli wbr caddc cF c1 cM cmin co cshi co
      cseq1 co cM c1 cmin co cshi co cM cuz cfv cres cA cli wbr caddc cF c1 cM
      cmin co cshi co cseq1 co cM c1 cmin co cshi co cA cli wbr caddc cG c1 cN
      cmin co cshi co cseq1 co cN c1 cmin co cshi co cA cli wbr cM caddc cop cF
      cseqz co cA cli wbr caddc cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co
      cshi co cM cuz cfv cres cA cli wbr wb cA cc wcel cM caddc cop cF cseqz co
      caddc cF c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM cuz cfv
      cres cA cli cM cz wcel cM caddc cop cF cseqz co caddc cF c1 cM cmin co
      cshi co cseq1 co cM c1 cmin co cshi co cM cuz cfv cres wceq iserzshft.2
      caddc cF cM addex iserzshft.1 seqzfval2 ax-mp breq1i a1i cA cc caddc cF
      c1 cM cmin co cshi co cseq1 co cM c1 cmin co cshi co cM caddc cF c1 cM
      cmin co cshi co cseq1 co cM c1 cmin co cshi oprex iserzshft.2 climresi cA
      cc wcel caddc cF c1 cM cmin co cshi co cseq1 co cN c1 cmin co cshi co cA
      cli wbr caddc cF c1 cM cmin co cshi co cseq1 co cA cli wbr caddc cG c1 cN
      cmin co cshi co cseq1 co cN c1 cmin co cshi co cA cli wbr caddc cF c1 cM
      cmin co cshi co cseq1 co cM c1 cmin co cshi co cA cli wbr cA caddc cF c1
      cM cmin co cshi co cseq1 co cN c1 cmin co caddc cF c1 cM cmin co cshi co
      cseq1 oprex cN cz wcel c1 cz wcel cN c1 cmin co cz wcel cN cM cK caddc co
      cz iserzshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel iserzshft.2
      iserzshft.3 cM cK zaddcl mp2an eqeltri 1z cN c1 zsubcl mp2an climshfti
      caddc cG c1 cN cmin co cshi co cseq1 co cN c1 cmin co cshi co cA cli wbr
      caddc cF c1 cM cmin co cshi co cseq1 co cN c1 cmin co cshi co cA cli wbr
      wb cA cc wcel caddc cG c1 cN cmin co cshi co cseq1 co cN c1 cmin co cshi
      co caddc cF c1 cM cmin co cshi co cseq1 co cN c1 cmin co cshi co cA cli
      caddc cG c1 cN cmin co cshi co cseq1 co caddc cF c1 cM cmin co cshi co
      cseq1 co cN c1 cmin co cshi cG c1 cN cmin co cshi co cF c1 cM cmin co
      cshi co caddc cseq1 cG c1 cN cmin co cshi co cF cK cshi co c1 cN cmin co
      cshi co cF cK c1 cN cmin co caddc co cshi co cF c1 cM cmin co cshi co cG
      cF cK cshi co c1 cN cmin co cshi iserzshft.5 opreq1i cK cc wcel c1 cN
      cmin co cc wcel cF cK cshi co c1 cN cmin co cshi co cF cK c1 cN cmin co
      caddc co cshi co wceq cK cz wcel cK cc wcel iserzshft.3 cK zcn ax-mp c1
      cN ax1cn cN cz wcel cN cc wcel cN cM cK caddc co cz iserzshft.4 cM cz
      wcel cK cz wcel cM cK caddc co cz wcel iserzshft.2 iserzshft.3 cM cK
      zaddcl mp2an eqeltri cN zcn ax-mp subcli cK c1 cN cmin co cF iserzshft.1
      2shfti mp2an cK c1 cN cmin co caddc co c1 cM cmin co cF cshi c1 cN cK
      cmin co cmin co c1 cN cmin co cK caddc co c1 cM cmin co cK c1 cN cmin co
      caddc co c1 cc wcel cN cc wcel cK cc wcel c1 cN cK cmin co cmin co c1 cN
      cmin co cK caddc co wceq ax1cn cN cz wcel cN cc wcel cN cM cK caddc co cz
      iserzshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel iserzshft.2
      iserzshft.3 cM cK zaddcl mp2an eqeltri cN zcn ax-mp cK cz wcel cK cc wcel
      iserzshft.3 cK zcn ax-mp c1 cN cK subsub mp3an cN cK cmin co cM c1 cmin
      cN cK cmin co cM wceq cM cK caddc co cN wceq cN cM cK caddc co
      iserzshft.4 eqcomi cN cK cM cN cz wcel cN cc wcel cN cM cK caddc co cz
      iserzshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel iserzshft.2
      iserzshft.3 cM cK zaddcl mp2an eqeltri cN zcn ax-mp cK cz wcel cK cc wcel
      iserzshft.3 cK zcn ax-mp cM cz wcel cM cc wcel iserzshft.2 cM zcn ax-mp
      subadd2i mpbir opreq2i c1 cN cmin co cK c1 cN ax1cn cN cz wcel cN cc wcel
      cN cM cK caddc co cz iserzshft.4 cM cz wcel cK cz wcel cM cK caddc co cz
      wcel iserzshft.2 iserzshft.3 cM cK zaddcl mp2an eqeltri cN zcn ax-mp
      subcli cK cz wcel cK cc wcel iserzshft.3 cK zcn ax-mp addcomi 3eqtr3ri
      opreq2i 3eqtri opreq2i opreq1i breq1i a1i cA caddc cF c1 cM cmin co cshi
      co cseq1 co cM c1 cmin co caddc cF c1 cM cmin co cshi co cseq1 oprex cM
      cz wcel c1 cz wcel cM c1 cmin co cz wcel iserzshft.2 1z cM c1 zsubcl
      mp2an climshfti 3bitr4rd 3bitrd 3bitr4rd pm5.21nd $.
      $( [31-Oct-2007] $) $( [31-Oct-2007] $)
  $}

  ${
    $d k A $.  $d j k F $.  $d j k M $.  $d j k N $.
    clim2serz.1 $e |- F e. _V $.
    clim2serz.2 $e |- A e. _V $.
    clim2serz.3 $e |- ( <. M , + >. seq F ) ~~> A $.
    clim2serz.4 $e |- F : ( ZZ>= ` M ) --> CC $.
    $( Limit of an infinite series with an initial segment removed. $)
    clim2serzi $p |- ( N e. ( ZZ>= ` M ) -> ( <. ( N + 1 ) , + >. seq F )
                ~~> ( A - ( ( <. M , + >. seq F ) ` N ) ) ) $=
      cN cM cuz cfv wcel cN c1 caddc co caddc cop cF cseqz co cA cN cM caddc
      cop cF cseqz co cfv cneg caddc co cA cN cM caddc cop cF cseqz co cfv cmin
      co cli cN cM caddc cop cF cseqz co cfv cneg cc wcel cN c1 caddc co cz
      wcel vk cv cM caddc cop cF cseqz co cfv cc wcel vk cv cN c1 caddc co
      caddc cop cF cseqz co cfv vk cv cM caddc cop cF cseqz co cfv cN cM caddc
      cop cF cseqz co cfv cneg caddc co wceq wa vk cN c1 caddc co cuz cfv wral
      wa cN c1 caddc co caddc cop cF cseqz co cA cN cM caddc cop cF cseqz co
      cfv cneg caddc co cli wbr cN cM cuz cfv wcel cM caddc cop cF cseqz co cA
      cli wbr cN cM caddc cop cF cseqz co cfv cneg cc wcel cN c1 caddc co cz
      wcel vk cv cM caddc cop cF cseqz co cfv cc wcel vk cv cN c1 caddc co
      caddc cop cF cseqz co cfv vk cv cM caddc cop cF cseqz co cfv cN cM caddc
      cop cF cseqz co cfv cneg caddc co wceq wa vk cN c1 caddc co cuz cfv wral
      wa cN c1 caddc co caddc cop cF cseqz co cA cN cM caddc cop cF cseqz co
      cfv cneg caddc co cli wbr clim2serz.3 cA cN cM caddc cop cF cseqz co cfv
      cneg vk cM caddc cop cF cseqz co cN c1 caddc co caddc cop cF cseqz co cN
      c1 caddc co cM caddc cop cF cseqz oprex cN c1 caddc co caddc cop cF cseqz
      oprex clim2serz.2 cN cM caddc cop cF cseqz co cfv negex climaddc1 mpanl1
      cN cM cuz cfv wcel cN cM caddc cop cF cseqz co cfv cc wcel cN cM caddc
      cop cF cseqz co cfv cneg cc wcel cN cM cuz cfv wcel vj cv cF cfv cc wcel
      vj cM cN cfz co wral cN cM caddc cop cF cseqz co cfv cc wcel vj cv cF cfv
      cc wcel vj cM cN cfz co vj cv cM cN cfz co wcel vj cv cM cuz cfv wcel vj
      cv cF cfv cc wcel vj cv cM cN elfzuz cM cuz cfv cc vj cv cF clim2serz.4
      ffvelrni syl rgen vj cF cM cN clim2serz.1 serzcl mpan2 cN cM caddc cop cF
      cseqz co cfv negcl syl cN cM cuz cfv wcel cN c1 caddc co cz wcel vk cv cM
      caddc cop cF cseqz co cfv cc wcel vk cv cN c1 caddc co caddc cop cF cseqz
      co cfv vk cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv
      cneg caddc co wceq wa vk cN c1 caddc co cuz cfv wral cN cM cuz cfv wcel
      cN cM cN eluzelz peano2zdi cN cM cuz cfv wcel vk cv cM caddc cop cF cseqz
      co cfv cc wcel vk cv cN c1 caddc co caddc cop cF cseqz co cfv vk cv cM
      caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv cneg caddc co
      wceq wa vk cN c1 caddc co cuz cfv cN cM cuz cfv wcel vk cv cN c1 caddc co
      cuz cfv wcel wa vk cv cM caddc cop cF cseqz co cfv cc wcel vk cv cN c1
      caddc co caddc cop cF cseqz co cfv vk cv cM caddc cop cF cseqz co cfv cN
      cM caddc cop cF cseqz co cfv cneg caddc co wceq vk cv cM cuz cfv wcel vj
      cv cF cfv cc wcel vj cM vk cv cfz co wral vk cv cM caddc cop cF cseqz co
      cfv cc wcel cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel wa vj cF
      cM vk cv clim2serz.1 serzcl vk cv cN c1 caddc co cuz cfv wcel cN cM cuz
      cfv wcel vk cv cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel cN c1
      caddc co cM cuz cfv wcel vk cv cM cuz cfv wcel cN cM cuz cfv wcel cN c1
      caddc co vk cv cM uztrn cM cN peano2uz sylan2 ancoms vj cv cF cfv cc wcel
      vj cM vk cv cfz co vj cv cM vk cv cfz co wcel vj cv cM cuz cfv wcel vj cv
      cF cfv cc wcel vj cv cM vk cv elfzuz cM cuz cfv cc vj cv cF clim2serz.4
      ffvelrni syl rgen sylancl cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv
      wcel wa vk cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co
      cfv cneg caddc co vk cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF
      cseqz co cfv cmin co vk cv cN c1 caddc co caddc cop cF cseqz co cfv vk cv
      cM caddc cop cF cseqz co cfv cc wcel cN cM caddc cop cF cseqz co cfv cc
      wcel vk cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv
      cneg caddc co vk cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz
      co cfv cmin co wceq cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel
      wa vk cv cM caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv
      negsub vk cv cM cuz cfv wcel vj cv cF cfv cc wcel vj cM vk cv cfz co wral
      vk cv cM caddc cop cF cseqz co cfv cc wcel cN cM cuz cfv wcel vk cv cN c1
      caddc co cuz cfv wcel wa vj cF cM vk cv clim2serz.1 serzcl vk cv cN c1
      caddc co cuz cfv wcel cN cM cuz cfv wcel vk cv cM cuz cfv wcel vk cv cN
      c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vk cv cM cuz cfv
      wcel cN cM cuz cfv wcel cN c1 caddc co vk cv cM uztrn cM cN peano2uz
      sylan2 ancoms vj cv cF cfv cc wcel vj cM vk cv cfz co vj cv cM vk cv cfz
      co wcel vj cv cM cuz cfv wcel vj cv cF cfv cc wcel vj cv cM vk cv elfzuz
      cM cuz cfv cc vj cv cF clim2serz.4 ffvelrni syl rgen sylancl cN cM cuz
      cfv wcel cN cM caddc cop cF cseqz co cfv cc wcel vk cv cN c1 caddc co cuz
      cfv wcel cN cM cuz cfv wcel vj cv cF cfv cc wcel vj cM cN cfz co wral cN
      cM caddc cop cF cseqz co cfv cc wcel vj cv cF cfv cc wcel vj cM cN cfz co
      vj cv cM cN cfz co wcel vj cv cM cuz cfv wcel vj cv cF cfv cc wcel vj cv
      cM cN elfzuz cM cuz cfv cc vj cv cF clim2serz.4 ffvelrni syl rgen vj cF
      cM cN clim2serz.1 serzcl mpan2 adantr sylanc cN cM cuz cfv wcel vk cv cN
      c1 caddc co cuz cfv wcel wa vk cv cM caddc cop cF cseqz co cfv cN cM
      caddc cop cF cseqz co cfv cmin co vk cv cN c1 caddc co caddc cop cF cseqz
      co cfv wceq cN cM caddc cop cF cseqz co cfv vk cv cN c1 caddc co caddc
      cop cF cseqz co cfv caddc co vk cv cM caddc cop cF cseqz co cfv wceq cN
      cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel wa vk cv cM caddc cop
      cF cseqz co cfv cN cM caddc cop cF cseqz co cfv vk cv cN c1 caddc co
      caddc cop cF cseqz co cfv caddc co vk cv cz wcel cN cM vk cv c1 cmin co
      cfz co wcel vj cv cF cfv cc wcel vj cM vk cv cfz co wral vk cv cM caddc
      cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv vk cv cN c1 caddc co
      caddc cop cF cseqz co cfv caddc co wceq cN cM cuz cfv wcel vk cv cN c1
      caddc co cuz cfv wcel wa vj cF cN cM vk cv clim2serz.1 serzsplit vk cv cN
      c1 caddc co cuz cfv wcel vk cv cz wcel cN cM cuz cfv wcel cN c1 caddc co
      vk cv eluzelz adantl cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel
      vk cv c1 cmin co cN cuz cfv wcel cN cM vk cv c1 cmin co cfz co wcel cN cz
      wcel vk cv cN c1 caddc co cuz cfv wcel vk cv c1 cmin co cN cuz cfv wcel
      cN cM cuz cfv wcel cN vk cv eluzp1m1 cM cN eluzelz sylan cN cM vk cv c1
      cmin co eluzfz syldan vj cv cF cfv cc wcel vj cM vk cv cfz co wral cN cM
      cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel wa vj cv cF cfv cc wcel vj
      cM vk cv cfz co vj cv cM vk cv cfz co wcel vj cv cM cuz cfv wcel vj cv cF
      cfv cc wcel vj cv cM vk cv elfzuz cM cuz cfv cc vj cv cF clim2serz.4
      ffvelrni syl rgen a1i syl3anc eqcomd vk cv cM caddc cop cF cseqz co cfv
      cc wcel cN cM caddc cop cF cseqz co cfv cc wcel vk cv cN c1 caddc co
      caddc cop cF cseqz co cfv cc wcel vk cv cM caddc cop cF cseqz co cfv cN
      cM caddc cop cF cseqz co cfv cmin co vk cv cN c1 caddc co caddc cop cF
      cseqz co cfv wceq cN cM caddc cop cF cseqz co cfv vk cv cN c1 caddc co
      caddc cop cF cseqz co cfv caddc co vk cv cM caddc cop cF cseqz co cfv
      wceq wb cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel wa vk cv cM
      caddc cop cF cseqz co cfv cN cM caddc cop cF cseqz co cfv vk cv cN c1
      caddc co caddc cop cF cseqz co cfv subadd vk cv cM cuz cfv wcel vj cv cF
      cfv cc wcel vj cM vk cv cfz co wral vk cv cM caddc cop cF cseqz co cfv cc
      wcel cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel wa vj cF cM vk
      cv clim2serz.1 serzcl vk cv cN c1 caddc co cuz cfv wcel cN cM cuz cfv
      wcel vk cv cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel cN c1 caddc
      co cM cuz cfv wcel vk cv cM cuz cfv wcel cN cM cuz cfv wcel cN c1 caddc
      co vk cv cM uztrn cM cN peano2uz sylan2 ancoms vj cv cF cfv cc wcel vj cM
      vk cv cfz co vj cv cM vk cv cfz co wcel vj cv cM cuz cfv wcel vj cv cF
      cfv cc wcel vj cv cM vk cv elfzuz cM cuz cfv cc vj cv cF clim2serz.4
      ffvelrni syl rgen sylancl cN cM cuz cfv wcel cN cM caddc cop cF cseqz co
      cfv cc wcel vk cv cN c1 caddc co cuz cfv wcel cN cM cuz cfv wcel vj cv cF
      cfv cc wcel vj cM cN cfz co wral cN cM caddc cop cF cseqz co cfv cc wcel
      vj cv cF cfv cc wcel vj cM cN cfz co vj cv cM cN cfz co wcel vj cv cM cuz
      cfv wcel vj cv cF cfv cc wcel vj cv cM cN elfzuz cM cuz cfv cc vj cv cF
      clim2serz.4 ffvelrni syl rgen vj cF cM cN clim2serz.1 serzcl mpan2 adantr
      cN cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel wa vk cv cN c1 caddc
      co caddc cop cF cN c1 caddc co cuz cfv cres cseqz co cfv cc wcel vk cv cN
      c1 caddc co caddc cop cF cseqz co cfv cc wcel vk cv cN c1 caddc co cuz
      cfv wcel vj cv cF cN c1 caddc co cuz cfv cres cfv cc wcel vj cN c1 caddc
      co vk cv cfz co wral vk cv cN c1 caddc co caddc cop cF cN c1 caddc co cuz
      cfv cres cseqz co cfv cc wcel cN cM cuz cfv wcel vk cv cN c1 caddc co cuz
      cfv wcel wa vj cF cN c1 caddc co cuz cfv cres cN c1 caddc co vk cv cF cvv
      wcel cF cN c1 caddc co cuz cfv cres cvv wcel clim2serz.1 cF cN c1 caddc
      co cuz cfv cvv resexg ax-mp serzcl cN cM cuz cfv wcel vk cv cN c1 caddc
      co cuz cfv wcel pm3.27 cN cM cuz cfv wcel vj cv cF cN c1 caddc co cuz cfv
      cres cfv cc wcel vj cN c1 caddc co vk cv cfz co wral vk cv cN c1 caddc co
      cuz cfv wcel cN cM cuz cfv wcel vj cv cF cN c1 caddc co cuz cfv cres cfv
      cc wcel vj cN c1 caddc co vk cv cfz co cN cM cuz cfv wcel vj cv cN c1
      caddc co vk cv cfz co wcel wa vj cv cF cN c1 caddc co cuz cfv cres cfv cc
      wcel vj cv cF cfv cc wcel vj cv cN c1 caddc co vk cv cfz co wcel cN cM
      cuz cfv wcel vj cv cF cfv cc wcel vj cv cN c1 caddc co vk cv cfz co wcel
      cN cM cuz cfv wcel wa vj cv cM cuz cfv wcel vj cv cF cfv cc wcel vj cv cN
      c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vj cv cM cuz cfv
      wcel vj cv cN c1 caddc co vk cv cfz co wcel cN cM cuz cfv wcel cN c1
      caddc co vj cv cM uztrn vj cv cN c1 caddc co vk cv elfzuz cM cN peano2uz
      syl2an cM cuz cfv cc vj cv cF clim2serz.4 ffvelrni syl ancoms vj cv cN c1
      caddc co vk cv cfz co wcel vj cv cF cN c1 caddc co cuz cfv cres cfv cc
      wcel vj cv cF cfv cc wcel wb cN cM cuz cfv wcel vj cv cN c1 caddc co vk
      cv cfz co wcel vj cv cF cN c1 caddc co cuz cfv cres cfv vj cv cF cfv cc
      vj cv cN c1 caddc co vk cv cfz co wcel vj cv cN c1 caddc co cuz cfv wcel
      vj cv cF cN c1 caddc co cuz cfv cres cfv vj cv cF cfv wceq vj cv cN c1
      caddc co vk cv elfzuz vj cv cN c1 caddc co cuz cfv cF fvres syl eleq1d
      adantl mpbird r19.21aiva adantr sylanc cN cM cuz cfv wcel vk cv cN c1
      caddc co caddc cop cF cN c1 caddc co cuz cfv cres cseqz co cfv cc wcel vk
      cv cN c1 caddc co caddc cop cF cseqz co cfv cc wcel wb vk cv cN c1 caddc
      co cuz cfv wcel cN cM cuz cfv wcel vk cv cN c1 caddc co caddc cop cF cN
      c1 caddc co cuz cfv cres cseqz co cfv vk cv cN c1 caddc co caddc cop cF
      cseqz co cfv cc cN cM cuz cfv wcel vk cv cN c1 caddc co caddc cop cF cN
      c1 caddc co cuz cfv cres cseqz co cN c1 caddc co caddc cop cF cseqz co cN
      cM cuz cfv wcel cN c1 caddc co cz wcel cN c1 caddc co caddc cop cF cN c1
      caddc co cuz cfv cres cseqz co cN c1 caddc co caddc cop cF cseqz co wceq
      cN cM cuz cfv wcel cN cM cN eluzelz peano2zdi caddc cF cN c1 caddc co
      addex clim2serz.1 seqzres syl fveq1d eleq1d adantr mpbid syl3anc mpbird
      eqtr2d jca r19.21aiva jca sylanc cA cc wcel cN cM caddc cop cF cseqz co
      cfv cc wcel cA cN cM caddc cop cF cseqz co cfv cneg caddc co cA cN cM
      caddc cop cF cseqz co cfv cmin co wceq cN cM cuz cfv wcel cA cN cM caddc
      cop cF cseqz co cfv negsub cA cvv wcel cM caddc cop cF cseqz co cA cli
      wbr cA cc wcel clim2serz.2 clim2serz.3 cA cvv cM caddc cop cF cseqz co
      climcl mp2an cN cM cuz cfv wcel vj cv cF cfv cc wcel vj cM cN cfz co wral
      cN cM caddc cop cF cseqz co cfv cc wcel vj cv cF cfv cc wcel vj cM cN cfz
      co vj cv cM cN cfz co wcel vj cv cM cuz cfv wcel vj cv cF cfv cc wcel vj
      cv cM cN elfzuz cM cuz cfv cc vj cv cF clim2serz.4 ffvelrni syl rgen vj
      cF cM cN clim2serz.1 serzcl mpan2 sylancr breqtrd $.
      $( [11-Jun-2006] $) $( [27-Dec-2005] $)
  $}

  ${
    $d A x $.  $d F x $.  $d M x $.  $d N x $.
    iserzex.1 $e |- F e. _V $.
    iserzex.2 $e |- A e. _V $.
    iserzex.3 $e |- M e. ZZ $.
    iserzex.4 $e |- F : ( ZZ>= ` M ) --> CC $.
    iserzex.5 $e |- ( <. M , + >. seq F ) ~~> A $.
    $( If an infinite series converges, so does the series with initial terms
       removed.  (Contributed by Paul Chapman, 23-Nov-2007.) $)
    iserzexi $p |- ( ( N e. ZZ /\ M < N ) ->
                    E. x ( <. N , + >. seq F ) ~~> x ) $=
      cN cz wcel cM cN clt wbr wa cN caddc cop cF cseqz co vx cv cli wbr vx cN
      cz wcel cM cN clt wbr wa cN caddc cop cF cseqz co cA cN c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co cli wbr wi cN cz wcel cM cN clt wbr wa
      cN caddc cop cF cseqz co vx cv cli wbr wi vx wex cN cz wcel cM cN clt wbr
      wa cN c1 cmin co c1 caddc co caddc cop cF cseqz co cA cN c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co cli wbr cN caddc cop cF cseqz co cA cN
      c1 cmin co cM caddc cop cF cseqz co cfv cmin co cli wbr cN cz wcel cM cN
      clt wbr wa cN cM c1 caddc co cuz cfv wcel cN c1 cmin co c1 caddc co caddc
      cop cF cseqz co cA cN c1 cmin co cM caddc cop cF cseqz co cfv cmin co cli
      wbr cN cz wcel cM cN clt wbr cM c1 caddc co cN cle wbr cN cM c1 caddc co
      cuz cfv wcel cN cz wcel cM cN clt wbr cM c1 caddc co cN cle wbr cM cz
      wcel cN cz wcel cM cN clt wbr cM c1 caddc co cN cle wbr wb iserzex.3 cM
      cN zltp1le mpan biimpa cN cM c1 caddc co cuz cfv wcel cN cz wcel cM c1
      caddc co cN cle wbr wa cM c1 caddc co cN cM cz wcel cM c1 caddc co cz
      wcel iserzex.3 cM peano2z ax-mp eluz1i biimpri syldan cN cM c1 caddc co
      cuz cfv wcel cN c1 cmin co cM cuz cfv wcel cN c1 cmin co c1 caddc co
      caddc cop cF cseqz co cA cN c1 cmin co cM caddc cop cF cseqz co cfv cmin
      co cli wbr cM cz wcel cN cM c1 caddc co cuz cfv wcel cN c1 cmin co cM cuz
      cfv wcel iserzex.3 cM cN eluzp1m1 mpan cA cF cM cN c1 cmin co iserzex.1
      iserzex.2 iserzex.5 iserzex.4 clim2serzi syl syl cN cz wcel cM cN clt wbr
      wa cN cc wcel cN c1 cmin co c1 caddc co caddc cop cF cseqz co cA cN c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cli wbr cN caddc cop cF
      cseqz co cA cN c1 cmin co cM caddc cop cF cseqz co cfv cmin co cli wbr wb
      cN cz wcel cN cc wcel cM cN clt wbr cN zcn adantr cN cc wcel cN c1 cmin
      co c1 caddc co caddc cop cF cseqz co cN caddc cop cF cseqz co cA cN c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cli cN cc wcel cN c1 cmin co
      c1 caddc co caddc cop cN caddc cop cF cseqz cN cc wcel cN c1 cmin co c1
      caddc co cN caddc cN cc wcel cN c1 cmin co c1 caddc co cN c1 c1 cmin co
      caddc co cN cN cc wcel c1 cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN
      c1 c1 cmin co caddc co wceq ax1cn ax1cn cN c1 c1 subadd23 mp3an23 cN cc
      wcel cN cc0 caddc co cN cN c1 c1 cmin co caddc co cN addid1 c1 c1 cmin co
      cc0 cN caddc c1 ax1cn subidi opreq2i syl5eq eqtrd opeq1d opreq1d breq1d
      syl mpbid cN cz wcel cM cN clt wbr wa cN caddc cop cF cseqz co vx cv cli
      wbr wi cN cz wcel cM cN clt wbr wa cN caddc cop cF cseqz co cA cN c1 cmin
      co cM caddc cop cF cseqz co cfv cmin co cli wbr wi vx cA cN c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co cA cN c1 cmin co cM caddc cop cF cseqz
      co cfv cmin oprex vx cv cA cN c1 cmin co cM caddc cop cF cseqz co cfv
      cmin co wceq cN caddc cop cF cseqz co vx cv cli wbr cN caddc cop cF cseqz
      co cA cN c1 cmin co cM caddc cop cF cseqz co cfv cmin co cli wbr cN cz
      wcel cM cN clt wbr wa vx cv cA cN c1 cmin co cM caddc cop cF cseqz co cfv
      cmin co cN caddc cop cF cseqz co cli breq2 imbi2d cla4ev ax-mp 19.37aiv
      $.
      $( [23-Nov-2007] $) $( [23-Nov-2007] $)
  $}

  ${
    $d j k F $.  $d j k M $.  $d j k N $.
    climserzle.1 $e |- F e. _V $.
    climserzle.2 $e |- A e. _V $.
    climserzle.3 $e |- ( <. M , + >. seq F ) ~~> A $.
    climserzle.4 $e |- F : ( ZZ>= ` M ) --> RR $.
    $( The partial sums of a converging infinite series with nonnegative terms
       are bounded by its limit. $)
    climserzlei $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( ZZ>= ` M )
                    0 <_ ( F ` k ) ) -> ( ( <. M , + >. seq F ) ` N ) <_ A ) $=
      cN cM cuz cfv wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral wa cc0 cA
      cN cM caddc cop cF cseqz co cfv cmin co cle wbr cN cM caddc cop cF cseqz
      co cfv cA cle wbr cN c1 caddc co cz wcel cN c1 caddc co caddc cop cF
      cseqz co cA cN cM caddc cop cF cseqz co cfv cmin co cli wbr vj cv cN c1
      caddc co caddc cop cF cseqz co cfv cr wcel cc0 vj cv cN c1 caddc co caddc
      cop cF cseqz co cfv cle wbr wa vj cN c1 caddc co cuz cfv wral cc0 cA cN
      cM caddc cop cF cseqz co cfv cmin co cle wbr cN cM cuz cfv wcel cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral wa cA cN cM caddc cop cF cseqz co cfv
      cmin co vj cN c1 caddc co caddc cop cF cseqz co cN c1 caddc co cA cN cM
      caddc cop cF cseqz co cfv cmin oprex climge0 cN cM cuz cfv wcel cN c1
      caddc co cz wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cN cM cuz
      cfv wcel cN cM cN eluzelz peano2zdi adantr cN cM cuz cfv wcel cN c1 caddc
      co caddc cop cF cseqz co cA cN cM caddc cop cF cseqz co cfv cmin co cli
      wbr cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cA cF cM cN climserzle.1
      climserzle.2 climserzle.3 cM cuz cfv cr cF wf cr cc wss cM cuz cfv cc cF
      wf climserzle.4 axresscn cM cuz cfv cr cc cF fss mp2an clim2serzi adantr
      cN cM cuz cfv wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral wa vj cv
      cN c1 caddc co caddc cop cF cseqz co cfv cr wcel cc0 vj cv cN c1 caddc co
      caddc cop cF cseqz co cfv cle wbr wa vj cN c1 caddc co cuz cfv cN cM cuz
      cfv wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral wa vj cv cN c1 caddc
      co cuz cfv wcel wa vj cv cN c1 caddc co caddc cop cF cseqz co cfv cr wcel
      cc0 vj cv cN c1 caddc co caddc cop cF cseqz co cfv cle wbr cN cM cuz cfv
      wcel vj cv cN c1 caddc co cuz cfv wcel vj cv cN c1 caddc co caddc cop cF
      cseqz co cfv cr wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral vj cv cN
      c1 caddc co cuz cfv wcel vk cv cF cfv cr wcel vk cN c1 caddc co vj cv cfz
      co wral vj cv cN c1 caddc co caddc cop cF cseqz co cfv cr wcel cN cM cuz
      cfv wcel vj cv cN c1 caddc co cuz cfv wcel wa vk cF cN c1 caddc co vj cv
      climserzle.1 serzrecl cN cM cuz cfv wcel vj cv cN c1 caddc co cuz cfv
      wcel pm3.27 cN cM cuz cfv wcel vk cv cF cfv cr wcel vk cN c1 caddc co vj
      cv cfz co wral vj cv cN c1 caddc co cuz cfv wcel cN cM cuz cfv wcel vk cv
      cF cfv cr wcel vk cN c1 caddc co vj cv cfz co cN cM cuz cfv wcel vk cv cN
      c1 caddc co vj cv cfz co wcel wa vk cv cM cuz cfv wcel vk cv cF cfv cr
      wcel cN c1 caddc co cM cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel vk
      cv cM cuz cfv wcel cN cM cuz cfv wcel vk cv cN c1 caddc co vj cv cfz co
      wcel vk cv cN c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vk
      cv cM cuz cfv wcel cN c1 caddc co vk cv cM uztrn ancoms cM cN peano2uz vk
      cv cN c1 caddc co vj cv elfzuz syl2an cM cuz cfv cr vk cv cF climserzle.4
      ffvelrni syl r19.21aiva adantr sylanc adantlr vj cv cN c1 caddc co cuz
      cfv wcel cN cM cuz cfv wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      wa cc0 vj cv cN c1 caddc co caddc cop cF cseqz co cfv cle wbr vj cv cN c1
      caddc co cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk
      cN c1 caddc co vj cv cfz co wral cc0 vj cv cN c1 caddc co caddc cop cF
      cseqz co cfv cle wbr cN cM cuz cfv wcel cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral wa vk cF cN c1 caddc co vj cv climserzle.1 serzcmp0 cN cM
      cuz cfv wcel cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral vk cv cF cfv cr
      wcel cc0 vk cv cF cfv cle wbr wa vk cN c1 caddc co vj cv cfz co wral cN
      cM cuz cfv wcel cc0 vk cv cF cfv cle wbr vk cv cF cfv cr wcel cc0 vk cv
      cF cfv cle wbr wa vk cM cuz cfv cN c1 caddc co vj cv cfz co vk cv cM cuz
      cfv wcel cc0 vk cv cF cfv cle wbr wi vk cv cN c1 caddc co vj cv cfz co
      wcel cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa
      vk cv cM cuz cfv wcel cc0 vk cv cF cfv cle wbr wi vk cv cN c1 caddc co vj
      cv cfz co wcel cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv
      cle wbr wa vk cv cM cuz cfv wcel cc0 vk cv cF cfv cle wbr wi vk cv cM cuz
      cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cv cN c1
      caddc co vj cv cfz co wcel cN cM cuz cfv wcel wa vk cv cM cuz cfv wcel
      cc0 vk cv cF cfv cle wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa
      vk cv cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr vk cv
      cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa wi cM cuz cfv cr vk cv cF
      climserzle.4 ffvelrni vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr pm3.2
      syl a2i vk cv cN c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel
      vk cv cM cuz cfv wcel vk cv cN c1 caddc co vj cv cfz co wcel cN cM cuz
      cfv wcel cN c1 caddc co vk cv cM uztrn vk cv cN c1 caddc co vj cv elfzuz
      cM cN peano2uz syl2an syl5 exp3a com3r r19.20dv2 imp sylan2 ancoms jca
      r19.21aiva syl3anc cN cM cuz cfv wcel cc0 cA cN cM caddc cop cF cseqz co
      cfv cmin co cle wbr cN cM caddc cop cF cseqz co cfv cA cle wbr wb cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cA cr wcel cN cM caddc cop cF cseqz
      co cfv cr wcel cc0 cA cN cM caddc cop cF cseqz co cfv cmin co cle wbr cN
      cM caddc cop cF cseqz co cfv cA cle wbr wb cN cM cuz cfv wcel cA cN cM
      caddc cop cF cseqz co cfv subge0 cN cM cuz cfv wcel cM cz wcel cA cr wcel
      cM cN eluzel2 cM cz wcel cM caddc cop cF cseqz co cA cli wbr vj cv cM
      caddc cop cF cseqz co cfv cr wcel vj cM cuz cfv wral cA cr wcel
      climserzle.3 vj cv cM caddc cop cF cseqz co cfv cr wcel vj cM cuz cfv vj
      cv cM cuz cfv wcel vk cv cF cfv cr wcel vk cM vj cv cfz co wral vj cv cM
      caddc cop cF cseqz co cfv cr wcel vk cv cF cfv cr wcel vk cM vj cv cfz co
      vk cv cM vj cv cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel vk
      cv cM vj cv elfzuz cM cuz cfv cr vk cv cF climserzle.4 ffvelrni syl rgen
      vk cF cM vj cv climserzle.1 serzrecl mpan2 rgen cA vj cM caddc cop cF
      cseqz co cM climserzle.2 climrecl mp3an23 syl cN cM cuz cfv wcel vj cv cF
      cfv cr wcel vj cM cN cfz co wral cN cM caddc cop cF cseqz co cfv cr wcel
      vj cv cF cfv cr wcel vj cM cN cfz co vj cv cM cN cfz co wcel vj cv cM cuz
      cfv wcel vj cv cF cfv cr wcel vj cv cM cN elfzuz cM cuz cfv cr vj cv cF
      climserzle.4 ffvelrni syl rgen vj cF cM cN climserzle.1 serzrecl mpan2
      sylanc adantr mpbid $.
      $( [8-Jan-2007] $) $( [27-Dec-2005] $)
  $}

  ${
    $d A j k x $.  $d F j k x $.  $d G j k x $.  $d M j k x $.
    climabs.1 $e |- A e. _V $.
    climabs.2 $e |- G e. _V $.
    climabs.3 $e |- M e. ZZ $.
    climabs.4 $e |- F ~~> A $.
    ${
      $d H j k x $.
      climabslem.5 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                             ( G ` k ) = ( H ` ( F ` k ) ) ) ) $.
      climabslem.6 $e |- A. x e. CC ( H ` x ) e. CC $.
      climabslem.7 $e |- ( ( ( F ` k ) e. CC /\ A e. CC ) ->
                          ( abs ` ( ( H ` ( F ` k ) ) - ( H ` A ) ) ) <_
                          ( abs ` ( ( F ` k ) - A ) ) ) $.
      $( Lemma for ~ climabsi , ~ climcji , ~ climrei , and ~ climimi . $)
      climabslem $p |- G ~~> ( H ` A ) $=
        cG cA cH cfv cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv
        cA cH cfv cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz
        wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
        cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi
        vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cH cfv
        cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx
        cr wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
        cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex
        wi vx cr wral climabs.4 cM cz wcel cA cc wcel vk cv cF cfv cc wcel vk
        cM cuz cfv wral cF cA cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz
        wrex wi vx cr wral wb climabs.3 cA cvv wcel cF cA cli wbr cA cc wcel
        climabs.1 climabs.4 cA cvv cF climcl mp2an vk cv cF cfv cc wcel vk cM
        cuz cfv vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv
        cF cfv cH cfv wceq climabslem.5 pm3.26d rgen vx cA vj vk cF cM cF cA
        cli wbr cF cvv wcel climabs.4 cF cA cli climrel brrelexi ax-mp clm4a
        mp3an mpbi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cA cmin
        co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi cc0 vx cv
        clt wbr vj cv vk cv cle wbr vk cv cG cfv cA cH cfv cmin co cabs cfv vx
        cv clt wbr wi vk cM cuz cfv wral vj cz wrex wi vx cr vx cv cr wcel vj
        cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk
        cM cuz cfv wral vj cz wrex vj cv vk cv cle wbr vk cv cG cfv cA cH cfv
        cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cz wrex cc0 vx
        cv clt wbr vx cv cr wcel vj cv vk cv cle wbr vk cv cF cfv cA cmin co
        cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv vk cv cle wbr vk cv
        cG cfv cA cH cfv cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral
        vj cz vx cv cr wcel vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
        cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cH cfv cmin co
        cabs cfv vx cv clt wbr wi wi vk cM cuz cfv wral vj cv vk cv cle wbr vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral vj cv
        vk cv cle wbr vk cv cG cfv cA cH cfv cmin co cabs cfv vx cv clt wbr wi
        vk cM cuz cfv wral wi vx cv cr wcel vj cv vk cv cle wbr vk cv cF cfv cA
        cmin co cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA
        cH cfv cmin co cabs cfv vx cv clt wbr wi wi vk cM cuz cfv vk cv cM cuz
        cfv wcel vx cv cr wcel vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs
        cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cH cfv cmin co
        cabs cfv vx cv clt wbr wi wi vk cv cM cuz cfv wcel vx cv cr wcel wa vk
        cv cF cfv cA cmin co cabs cfv vx cv clt wbr vk cv cG cfv cA cH cfv cmin
        co cabs cfv vx cv clt wbr vj cv vk cv cle wbr vk cv cM cuz cfv wcel vx
        cv cr wcel wa vk cv cG cfv cA cH cfv cmin co cabs cfv vk cv cF cfv cA
        cmin co cabs cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv clt wbr
        vk cv cG cfv cA cH cfv cmin co cabs cfv vx cv clt wbr vk cv cM cuz cfv
        wcel vk cv cG cfv cA cH cfv cmin co cabs cfv vk cv cF cfv cA cmin co
        cabs cfv cle wbr vx cv cr wcel vk cv cM cuz cfv wcel vk cv cG cfv cA cH
        cfv cmin co cabs cfv vk cv cF cfv cH cfv cA cH cfv cmin co cabs cfv vk
        cv cF cfv cA cmin co cabs cfv cle vk cv cM cuz cfv wcel vk cv cG cfv cA
        cH cfv cmin co vk cv cF cfv cH cfv cA cH cfv cmin co cabs vk cv cM cuz
        cfv wcel vk cv cG cfv vk cv cF cfv cH cfv cA cH cfv cmin vk cv cM cuz
        cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv wceq
        climabslem.5 pm3.27d opreq1d fveq2d vk cv cF cfv cc wcel cA cc wcel vk
        cv cF cfv cH cfv cA cH cfv cmin co cabs cfv vk cv cF cfv cA cmin co
        cabs cfv cle wbr vk cv cM cuz cfv wcel climabslem.7 vk cv cM cuz cfv
        wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv wceq
        climabslem.5 pm3.26d cA cvv wcel cF cA cli wbr cA cc wcel climabs.1
        climabs.4 cA cvv cF climcl mp2an sylancl eqbrtrd adantr vk cv cG cfv cA
        cH cfv cmin co cabs cfv cr wcel vk cv cF cfv cA cmin co cabs cfv cr
        wcel wa vx cv cr wcel vk cv cG cfv cA cH cfv cmin co cabs cfv vk cv cF
        cfv cA cmin co cabs cfv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
        clt wbr wa vk cv cG cfv cA cH cfv cmin co cabs cfv vx cv clt wbr wi vk
        cv cM cuz cfv wcel vk cv cG cfv cA cH cfv cmin co cabs cfv cr wcel vk
        cv cF cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vk cv cG cfv cA cH
        cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv cle wbr vk cv cF
        cfv cA cmin co cabs cfv vx cv clt wbr wa vk cv cG cfv cA cH cfv cmin co
        cabs cfv vx cv clt wbr wi vk cv cG cfv cA cH cfv cmin co cabs cfv vk cv
        cF cfv cA cmin co cabs cfv vx cv lelttr 3expa vk cv cM cuz cfv wcel vk
        cv cG cfv cA cH cfv cmin co cabs cfv cr wcel vk cv cF cfv cA cmin co
        cabs cfv cr wcel vk cv cM cuz cfv wcel vk cv cG cfv cA cH cfv cmin co
        cc wcel vk cv cG cfv cA cH cfv cmin co cabs cfv cr wcel vk cv cG cfv cc
        wcel cA cH cfv cc wcel vk cv cG cfv cA cH cfv cmin co cc wcel vk cv cM
        cuz cfv wcel vk cv cG cfv cA cH cfv subcl vk cv cM cuz cfv wcel vk cv
        cG cfv vk cv cF cfv cH cfv cc vk cv cM cuz cfv wcel vk cv cF cfv cc
        wcel vk cv cG cfv vk cv cF cfv cH cfv wceq climabslem.5 pm3.27d vk cv
        cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cF cfv cH cfv cc wcel vk cv
        cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv
        wceq climabslem.5 pm3.26d vx cv cH cfv cc wcel vk cv cF cfv cH cfv cc
        wcel vx vk cv cF cfv cc vx cv vk cv cF cfv wceq vx cv cH cfv vk cv cF
        cfv cH cfv cc vx cv vk cv cF cfv cH fveq2 eleq1d climabslem.6 vtoclri
        syl eqeltrd cA cc wcel cA cH cfv cc wcel cA cvv wcel cF cA cli wbr cA
        cc wcel climabs.1 climabs.4 cA cvv cF climcl mp2an vx cv cH cfv cc wcel
        cA cH cfv cc wcel vx cA cc vx cv cA wceq vx cv cH cfv cA cH cfv cc vx
        cv cA cH fveq2 eleq1d climabslem.6 vtoclri ax-mp sylancl vk cv cG cfv
        cA cH cfv cmin co abscl syl vk cv cM cuz cfv wcel vk cv cF cfv cc wcel
        vk cv cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin co cabs cfv cr
        wcel vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
        cfv cH cfv wceq climabslem.5 pm3.26d vk cv cF cfv cc wcel cA cc wcel vk
        cv cF cfv cA cmin co cc wcel cA cvv wcel cF cA cli wbr cA cc wcel
        climabs.1 climabs.4 cA cvv cF climcl mp2an vk cv cF cfv cA subcl mpan2
        vk cv cF cfv cA cmin co abscl 3syl jca sylan mpand imim2d expcom
        r19.21aiv vj cv vk cv cle wbr vk cv cF cfv cA cmin co cabs cfv vx cv
        clt wbr wi vj cv vk cv cle wbr vk cv cG cfv cA cH cfv cmin co cabs cfv
        vx cv clt wbr wi vk cM cuz cfv r19.20 syl r19.22sdv imim2d r19.20i
        ax-mp cM cz wcel cA cH cfv cc wcel vk cv cG cfv cc wcel vk cM cuz cfv
        wral cG cA cH cfv cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
        cG cfv cA cH cfv cmin co cabs cfv vx cv clt wbr wi vk cM cuz cfv wral
        vj cz wrex wi vx cr wral wb climabs.3 cA cc wcel cA cH cfv cc wcel cA
        cvv wcel cF cA cli wbr cA cc wcel climabs.1 climabs.4 cA cvv cF climcl
        mp2an vx cv cH cfv cc wcel cA cH cfv cc wcel vx cA cc vx cv cA wceq vx
        cv cH cfv cA cH cfv cc vx cv cA cH fveq2 eleq1d climabslem.6 vtoclri
        ax-mp vk cv cG cfv cc wcel vk cM cuz cfv vk cv cM cuz cfv wcel vk cv cG
        cfv vk cv cF cfv cH cfv cc vk cv cM cuz cfv wcel vk cv cF cfv cc wcel
        vk cv cG cfv vk cv cF cfv cH cfv wceq climabslem.5 pm3.27d vk cv cM cuz
        cfv wcel vk cv cF cfv cc wcel vk cv cF cfv cH cfv cc wcel vk cv cM cuz
        cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cH cfv wceq
        climabslem.5 pm3.26d vx cv cH cfv cc wcel vk cv cF cfv cH cfv cc wcel
        vx vk cv cF cfv cc vx cv vk cv cF cfv wceq vx cv cH cfv vk cv cF cfv cH
        cfv cc vx cv vk cv cF cfv cH fveq2 eleq1d climabslem.6 vtoclri syl
        eqeltrd rgen vx cA cH cfv vj vk cG cM climabs.2 clm4a mp3an mpbir $.
        $( [24-Sep-2007] $) $( [24-Sep-2007] $)
    $}

    ${
      climabs.5 $e |- ( k e. ( ZZ>= ` M ) ->
                  ( ( F ` k ) e. CC /\ ( G ` k ) = ( abs ` ( F ` k ) ) ) ) $.
      $( Limit of the absolute value of a sequence.  (Contributed by Paul
         Chapman, 7-Sep-2007.) $)
      climabsi $p |- G ~~> ( abs ` A ) $=
        vx cA vk cF cG cabs cM climabs.1 climabs.2 climabs.3 climabs.4
        climabs.5 vx cv cabs cfv cc wcel vx cc vx cv cc wcel vx cv cabs cfv vx
        cv abscl recnd rgen vk cv cF cfv cA abs2difabs climabslem $.
        $( [8-Sep-2007] $) $( [7-Sep-2007] $)
    $}

    ${
      climcj.5 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                   ( G ` k ) = ( * ` ( F ` k ) ) ) ) $.
      $( Limit of the complex conjugate of a sequence.  Proposition 12-2.4(c)
         of [Gleason] p. 172. $)
      climcji $p |- G ~~> ( * ` A ) $=
        vx cA vk cF cG ccj cM climabs.1 climabs.2 climabs.3 climabs.4 climcj.5
        vx cv ccj cfv cc wcel vx cc vx cv cjcl rgen vk cv cF cfv ccj cfv cA ccj
        cfv cmin co cabs cfv cr wcel vk cv cF cfv ccj cfv cA ccj cfv cmin co
        cabs cfv vk cv cF cfv cA cmin co cabs cfv wceq vk cv cF cfv ccj cfv cA
        ccj cfv cmin co cabs cfv vk cv cF cfv cA cmin co cabs cfv cle wbr vk cv
        cF cfv cc wcel cA cc wcel wa vk cv cF cfv ccj cfv cA ccj cfv cmin co
        cabs cfv vk cv cF cfv cA cmin co cabs cfv eqle vk cv cF cfv cc wcel cA
        cc wcel wa vk cv cF cfv ccj cfv cc wcel cA ccj cfv cc wcel wa vk cv cF
        cfv ccj cfv cA ccj cfv cmin co cc wcel vk cv cF cfv ccj cfv cA ccj cfv
        cmin co cabs cfv cr wcel vk cv cF cfv cc wcel vk cv cF cfv ccj cfv cc
        wcel cA cc wcel cA ccj cfv cc wcel vk cv cF cfv cjcl cA cjcl anim12i vk
        cv cF cfv ccj cfv cA ccj cfv subcl vk cv cF cfv ccj cfv cA ccj cfv cmin
        co abscl 3syl vk cv cF cfv cc wcel cA cc wcel wa vk cv cF cfv cA cmin
        co ccj cfv cabs cfv vk cv cF cfv ccj cfv cA ccj cfv cmin co cabs cfv vk
        cv cF cfv cA cmin co cabs cfv vk cv cF cfv cc wcel cA cc wcel wa vk cv
        cF cfv cA cmin co ccj cfv vk cv cF cfv ccj cfv cA ccj cfv cmin co cabs
        vk cv cF cfv cA cjsub fveq2d vk cv cF cfv cc wcel cA cc wcel wa vk cv
        cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin co ccj cfv cabs cfv vk
        cv cF cfv cA cmin co cabs cfv wceq vk cv cF cfv cA subcl vk cv cF cfv
        cA cmin co abscj syl eqtr3d sylanc climabslem $.
        $( [24-Jun-2006] $) $( [7-Jun-2006] $)
    $}

    ${
      climre.5 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                         ( G ` k ) = ( Re ` ( F ` k ) ) ) ) $.
      $( Limit of the real part of a sequence.  (Contributed by Paul Chapman,
         24-Sep-2007.) $)
      climrei $p |- G ~~> ( Re ` A ) $=
        vx cA vk cF cG cre cM climabs.1 climabs.2 climabs.3 climabs.4 climre.5
        vx cv cre cfv cc wcel vx cc vx cv cc wcel vx cv cre cfv vx cv recl
        recnd rgen vk cv cF cfv cc wcel cA cc wcel wa vk cv cF cfv cA cmin co
        cre cfv cabs cfv vk cv cF cfv cre cfv cA cre cfv cmin co cabs cfv vk cv
        cF cfv cA cmin co cabs cfv cle vk cv cF cfv cc wcel cA cc wcel wa vk cv
        cF cfv cA cmin co cre cfv vk cv cF cfv cre cfv cA cre cfv cmin co cabs
        vk cv cF cfv cA resub fveq2d vk cv cF cfv cc wcel cA cc wcel wa vk cv
        cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin co cre cfv cabs cfv vk
        cv cF cfv cA cmin co cabs cfv cle wbr vk cv cF cfv cA subcl vk cv cF
        cfv cA cmin co absrele syl eqbrtrrd climabslem $.
        $( [24-Sep-2007] $) $( [24-Sep-2007] $)
    $}

    ${
      climim.5 $e |- ( k e. ( ZZ>= ` M ) -> ( ( F ` k ) e. CC /\
                         ( G ` k ) = ( Im ` ( F ` k ) ) ) ) $.
      $( Limit of the imaginary part of a sequence.  (Contributed by Paul
         Chapman, 7-Sep-2007.) $)
      climimi $p |- G ~~> ( Im ` A ) $=
        vx cA vk cF cG cim cM climabs.1 climabs.2 climabs.3 climabs.4 climim.5
        vx cv cim cfv cc wcel vx cc vx cv cc wcel vx cv cim cfv vx cv imcl
        recnd rgen vk cv cF cfv cc wcel cA cc wcel wa vk cv cF cfv cA cmin co
        cim cfv cabs cfv vk cv cF cfv cim cfv cA cim cfv cmin co cabs cfv vk cv
        cF cfv cA cmin co cabs cfv cle vk cv cF cfv cc wcel cA cc wcel wa vk cv
        cF cfv cA cmin co cim cfv vk cv cF cfv cim cfv cA cim cfv cmin co cabs
        vk cv cF cfv cA imsub fveq2d vk cv cF cfv cc wcel cA cc wcel wa vk cv
        cF cfv cA cmin co cc wcel vk cv cF cfv cA cmin co cim cfv cabs cfv vk
        cv cF cfv cA cmin co cabs cfv cle wbr vk cv cF cfv cA subcl vk cv cF
        cfv cA cmin co absimle syl eqbrtrrd climabslem $.
        $( [24-Sep-2007] $) $( [24-Sep-2007] $)
    $}
  $}

  ${
    $d j m w A $.  $d j k m w F $.  $d j m w N $.
    climub.1 $e |- A e. _V $.
    climub.2 $e |- F : NN --> RR $.
    climub.3 $e |- ( k e. NN -> ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
    climub.4 $e |- F ~~> A $.
    ${
      climubi.5 $e |- N e. NN $.
      $( The limit of a monotonic sequence is an upper bound. $)
      climubii $p |- ( F ` N ) <_ A $=
        cN cF cfv cA cle wbr cA cN cF cfv clt wbr wn cA cN cF cfv clt wbr cc0
        cN cF cfv cA cmin co clt wbr cc0 cN cF cfv cA cmin co clt wbr vm cv vj
        cv cle wbr vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt
        wbr wi vj cn wral vm cn wrex vm cv vj cv cle wbr vj cv cF cfv cA cmin
        co cabs cfv cN cF cfv cA cmin co clt wbr wi vj cn wral vm cn vm cv cn
        wcel vm cv vj cv cle wbr vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA
        cmin co clt wbr wi wn vj cn wrex vm cv vj cv cle wbr vj cv cF cfv cA
        cmin co cabs cfv cN cF cfv cA cmin co clt wbr wi vj cn wral wn cN vm cv
        caddc co cn wcel vm cv cN vm cv caddc co cle wbr cN vm cv caddc co cF
        cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr wi wn vm cv vj cv
        cle wbr vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr
        wi wn vj cn wrex vm cv cn wcel vm cv vj cv cle wbr vj cv cF cfv cA cmin
        co cabs cfv cN cF cfv cA cmin co clt wbr wi wn vm cv cN vm cv caddc co
        cle wbr cN vm cv caddc co cF cfv cA cmin co cabs cfv cN cF cfv cA cmin
        co clt wbr wi wn vj cN vm cv caddc co cn vj cv cN vm cv caddc co wceq
        vm cv vj cv cle wbr vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin
        co clt wbr wi vm cv cN vm cv caddc co cle wbr cN vm cv caddc co cF cfv
        cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr wi vj cv cN vm cv
        caddc co wceq vm cv vj cv cle wbr vm cv cN vm cv caddc co cle wbr vj cv
        cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr cN vm cv caddc
        co cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr vj cv cN vm
        cv caddc co vm cv cle breq2 vj cv cN vm cv caddc co wceq vj cv cF cfv
        cA cmin co cabs cfv cN vm cv caddc co cF cfv cA cmin co cabs cfv cN cF
        cfv cA cmin co clt vj cv cN vm cv caddc co wceq vj cv cF cfv cA cmin co
        cN vm cv caddc co cF cfv cA cmin co cabs vj cv cN vm cv caddc co wceq
        vj cv cF cfv cN vm cv caddc co cF cfv cA cmin vj cv cN vm cv caddc co
        cF fveq2 opreq1d fveq2d breq1d imbi12d notbid rcla4ev cN cn wcel vm cv
        cn wcel cN vm cv caddc co cn wcel climubi.5 cN vm cv nnaddcl mpan vm cv
        cn wcel vm cv cN vm cv caddc co cle wbr cN vm cv caddc co cF cfv cA
        cmin co cabs cfv cN cF cfv cA cmin co clt wbr wn wa vm cv cN vm cv
        caddc co cle wbr cN vm cv caddc co cF cfv cA cmin co cabs cfv cN cF cfv
        cA cmin co clt wbr wi wn vm cv cn wcel vm cv cN vm cv caddc co cle wbr
        cN vm cv caddc co cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt
        wbr wn vm cv cr wcel cN cn0 wcel vm cv cN vm cv caddc co cle wbr vm cv
        cn wcel vm cv cN nn0addge2 vm cv nnre cN climubi.5 nnnn0i sylancl vm cv
        cn wcel cN cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cabs
        cfv cle wbr cN vm cv caddc co cF cfv cA cmin co cabs cfv cN cF cfv cA
        cmin co clt wbr wn cN vm cv caddc co cF cfv cA cmin co cr wcel cN vm cv
        caddc co cF cfv cA cmin co cabs cfv cr wcel wa cN cF cfv cA cmin co cN
        vm cv caddc co cF cfv cA cmin co cle wbr cN vm cv caddc co cF cfv cA
        cmin co cN vm cv caddc co cF cfv cA cmin co cabs cfv cle wbr wa cN cF
        cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cabs cfv cle wbr vm
        cv cn wcel cN cF cfv cA cmin co cr wcel cN vm cv caddc co cF cfv cA
        cmin co cr wcel cN vm cv caddc co cF cfv cA cmin co cabs cfv cr wcel cN
        cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cle wbr cN vm cv
        caddc co cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cabs cfv
        cle wbr wa cN cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co
        cabs cfv cle wbr wi cN cF cfv cA cn cr cF wf cN cn wcel cN cF cfv cr
        wcel climub.2 climubi.5 cn cr cN cF ffvelrn mp2an cA cF climub.1
        climub.2 climub.4 climfnrcli resubcli cN cF cfv cA cmin co cN vm cv
        caddc co cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cabs cfv
        letr mp3an1 vm cv cn wcel cN vm cv caddc co cF cfv cA cmin co cr wcel
        cN vm cv caddc co cF cfv cA cmin co cabs cfv cr wcel cN vm cv caddc co
        cF cfv cr wcel cA cr wcel cN vm cv caddc co cF cfv cA cmin co cr wcel
        vm cv cn wcel cN vm cv caddc co cF cfv cA resubcl vm cv cn wcel cN vm
        cv caddc co cn wcel cN vm cv caddc co cF cfv cr wcel cN cn wcel vm cv
        cn wcel cN vm cv caddc co cn wcel climubi.5 cN vm cv nnaddcl mpan cn cr
        cN vm cv caddc co cF climub.2 ffvelrni syl cA cF climub.1 climub.2
        climub.4 climfnrcli sylancl vm cv cn wcel cN vm cv caddc co cF cfv cA
        cmin co cc wcel cN vm cv caddc co cF cfv cA cmin co cabs cfv cr wcel vm
        cv cn wcel cN vm cv caddc co cF cfv cA cmin co cr wcel cN vm cv caddc
        co cF cfv cA cmin co cc wcel cN vm cv caddc co cF cfv cr wcel cA cr
        wcel cN vm cv caddc co cF cfv cA cmin co cr wcel vm cv cn wcel cN vm cv
        caddc co cF cfv cA resubcl vm cv cn wcel cN vm cv caddc co cn wcel cN
        vm cv caddc co cF cfv cr wcel cN cn wcel vm cv cn wcel cN vm cv caddc
        co cn wcel climubi.5 cN vm cv nnaddcl mpan cn cr cN vm cv caddc co cF
        climub.2 ffvelrni syl cA cF climub.1 climub.2 climub.4 climfnrcli
        sylancl cN vm cv caddc co cF cfv cA cmin co recn syl cN vm cv caddc co
        cF cfv cA cmin co abscl syl jca vm cv cn wcel cN cF cfv cA cmin co cN
        vm cv caddc co cF cfv cA cmin co cle wbr cN vm cv caddc co cF cfv cA
        cmin co cN vm cv caddc co cF cfv cA cmin co cabs cfv cle wbr vm cv cn
        wcel cN cF cfv cN vm cv caddc co cF cfv cle wbr cN cF cfv cA cmin co cN
        vm cv caddc co cF cfv cA cmin co cle wbr cN vm cv caddc co cn wcel cN
        cN vm cv caddc co cle wbr cN cF cfv cN vm cv caddc co cF cfv cle wbr vm
        cv cn wcel cN cn wcel cN vm cv caddc co cn wcel cN cN vm cv caddc co
        cle wbr cN cF cfv cN vm cv caddc co cF cfv cle wbr climubi.5 vk cN cN
        vm cv caddc co cF climub.2 climub.3 monoord mp3an1 cN cn wcel vm cv cn
        wcel cN vm cv caddc co cn wcel climubi.5 cN vm cv nnaddcl mpan cN cr
        wcel vm cv cn0 wcel cN cN vm cv caddc co cle wbr vm cv cn wcel cN vm cv
        nn0addge1 cN climubi.5 nnrei vm cv nnnn0 sylancr sylanc vm cv cn wcel
        cN vm cv caddc co cF cfv cr wcel cN cF cfv cN vm cv caddc co cF cfv cle
        wbr cN cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cle wbr wb
        vm cv cn wcel cN vm cv caddc co cn wcel cN vm cv caddc co cF cfv cr
        wcel cN cn wcel vm cv cn wcel cN vm cv caddc co cn wcel climubi.5 cN vm
        cv nnaddcl mpan cn cr cN vm cv caddc co cF climub.2 ffvelrni syl cN cF
        cfv cr wcel cN vm cv caddc co cF cfv cr wcel cA cr wcel cN cF cfv cN vm
        cv caddc co cF cfv cle wbr cN cF cfv cA cmin co cN vm cv caddc co cF
        cfv cA cmin co cle wbr wb cn cr cF wf cN cn wcel cN cF cfv cr wcel
        climub.2 climubi.5 cn cr cN cF ffvelrn mp2an cA cF climub.1 climub.2
        climub.4 climfnrcli cN cF cfv cN vm cv caddc co cF cfv cA lesub1
        mp3an13 syl mpbid vm cv cn wcel cN vm cv caddc co cF cfv cA cmin co cr
        wcel cN vm cv caddc co cF cfv cA cmin co cN vm cv caddc co cF cfv cA
        cmin co cabs cfv cle wbr cN vm cv caddc co cF cfv cr wcel cA cr wcel cN
        vm cv caddc co cF cfv cA cmin co cr wcel vm cv cn wcel cN vm cv caddc
        co cF cfv cA resubcl vm cv cn wcel cN vm cv caddc co cn wcel cN vm cv
        caddc co cF cfv cr wcel cN cn wcel vm cv cn wcel cN vm cv caddc co cn
        wcel climubi.5 cN vm cv nnaddcl mpan cn cr cN vm cv caddc co cF
        climub.2 ffvelrni syl cA cF climub.1 climub.2 climub.4 climfnrcli
        sylancl cN vm cv caddc co cF cfv cA cmin co leabs syl jca sylc cN cF
        cfv cA cmin co cr wcel cN vm cv caddc co cF cfv cA cmin co cabs cfv cr
        wcel cN cF cfv cA cmin co cN vm cv caddc co cF cfv cA cmin co cabs cfv
        cle wbr cN vm cv caddc co cF cfv cA cmin co cabs cfv cN cF cfv cA cmin
        co clt wbr wn wb vm cv cn wcel cN cF cfv cA cmin co cN vm cv caddc co
        cF cfv cA cmin co cabs cfv lenlt cN cF cfv cA cn cr cF wf cN cn wcel cN
        cF cfv cr wcel climub.2 climubi.5 cn cr cN cF ffvelrn mp2an cA cF
        climub.1 climub.2 climub.4 climfnrcli resubcli vm cv cn wcel cN vm cv
        caddc co cF cfv cA cmin co cc wcel cN vm cv caddc co cF cfv cA cmin co
        cabs cfv cr wcel vm cv cn wcel cN vm cv caddc co cF cfv cA cmin co cr
        wcel cN vm cv caddc co cF cfv cA cmin co cc wcel cN vm cv caddc co cF
        cfv cr wcel cA cr wcel cN vm cv caddc co cF cfv cA cmin co cr wcel vm
        cv cn wcel cN vm cv caddc co cF cfv cA resubcl vm cv cn wcel cN vm cv
        caddc co cn wcel cN vm cv caddc co cF cfv cr wcel cN cn wcel vm cv cn
        wcel cN vm cv caddc co cn wcel climubi.5 cN vm cv nnaddcl mpan cn cr cN
        vm cv caddc co cF climub.2 ffvelrni syl cA cF climub.1 climub.2
        climub.4 climfnrcli sylancl cN vm cv caddc co cF cfv cA cmin co recn
        syl cN vm cv caddc co cF cfv cA cmin co abscl syl sylancr mpbid jca vm
        cv cN vm cv caddc co cle wbr cN vm cv caddc co cF cfv cA cmin co cabs
        cfv cN cF cfv cA cmin co clt wbr annim sylib sylanc vm cv vj cv cle wbr
        vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr wi vj cn
        rexnal sylib nrex cN cF cfv cA cmin co cr wcel cc0 vw cv clt wbr vm cv
        vj cv cle wbr vj cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vj cn
        wral vm cn wrex wi vw cr wral cc0 cN cF cfv cA cmin co clt wbr vm cv vj
        cv cle wbr vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt
        wbr wi vj cn wral vm cn wrex wi cN cF cfv cA cn cr cF wf cN cn wcel cN
        cF cfv cr wcel climub.2 climubi.5 cn cr cN cF ffvelrn mp2an cA cF
        climub.1 climub.2 climub.4 climfnrcli resubcli cF cA cli wbr cc0 vw cv
        clt wbr vm cv vj cv cle wbr vj cv cF cfv cA cmin co cabs cfv vw cv clt
        wbr wi vj cn wral vm cn wrex wi vw cr wral climub.4 cF cA cli wbr cc0
        vw cv clt wbr vm cv vj cv cle wbr vj cv cF cfv cA cmin co cabs cfv vw
        cv clt wbr wi vj cn wral vm cn wrex wi vw cr cF cA cli wbr vw cv cr
        wcel cc0 vw cv clt wbr vm cv vj cv cle wbr vj cv cF cfv cA cmin co cabs
        cfv vw cv clt wbr wi vj cn wral vm cn wrex cA cvv wcel cF cA cli wbr vw
        cv cr wcel cc0 vw cv clt wbr wa vm cv vj cv cle wbr vj cv cF cfv cA
        cmin co cabs cfv vw cv clt wbr wi vj cn wral vm cn wrex climub.1 cA vw
        cv cvv vm vj cF c1 cn cn 1z cn c1 cuz cfv nnuz eqimss2i nnssz clmi2i
        mpanl1 exp32 r19.21aiv ax-mp cc0 vw cv clt wbr vm cv vj cv cle wbr vj
        cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vj cn wral vm cn wrex wi
        cc0 cN cF cfv cA cmin co clt wbr vm cv vj cv cle wbr vj cv cF cfv cA
        cmin co cabs cfv cN cF cfv cA cmin co clt wbr wi vj cn wral vm cn wrex
        wi vw cN cF cfv cA cmin co cr vw cv cN cF cfv cA cmin co wceq cc0 vw cv
        clt wbr cc0 cN cF cfv cA cmin co clt wbr vm cv vj cv cle wbr vj cv cF
        cfv cA cmin co cabs cfv vw cv clt wbr wi vj cn wral vm cn wrex vm cv vj
        cv cle wbr vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt
        wbr wi vj cn wral vm cn wrex vw cv cN cF cfv cA cmin co cc0 clt breq2
        vw cv cN cF cfv cA cmin co wceq vm cv vj cv cle wbr vj cv cF cfv cA
        cmin co cabs cfv vw cv clt wbr wi vm cv vj cv cle wbr vj cv cF cfv cA
        cmin co cabs cfv cN cF cfv cA cmin co clt wbr wi vm vj cn cn vw cv cN
        cF cfv cA cmin co wceq vj cv cF cfv cA cmin co cabs cfv vw cv clt wbr
        vj cv cF cfv cA cmin co cabs cfv cN cF cfv cA cmin co clt wbr vm cv vj
        cv cle wbr vw cv cN cF cfv cA cmin co vj cv cF cfv cA cmin co cabs cfv
        clt breq2 imbi2d rexralbidv imbi12d rcla4v mp2 mto cA cN cF cfv cA cF
        climub.1 climub.2 climub.4 climfnrcli cn cr cF wf cN cn wcel cN cF cfv
        cr wcel climub.2 climubi.5 cn cr cN cF ffvelrn mp2an posdifi mtbir cN
        cF cfv cA cn cr cF wf cN cn wcel cN cF cfv cr wcel climub.2 climubi.5
        cn cr cN cF ffvelrn mp2an cA cF climub.1 climub.2 climub.4 climfnrcli
        lenlti mpbir $.
        $( [7-Jun-2006] $) $( [18-Mar-2005] $)
    $}

    $( The limit of a monotonic sequence is an upper bound. $)
    climubi $p |- ( N e. NN -> ( F ` N ) <_ A ) $=
      cN cn wcel cN cF cfv cA cle wbr cN cn wcel cN c1 cif cF cfv cA cle wbr cN
      c1 cN cN cn wcel cN c1 cif wceq cN cF cfv cN cn wcel cN c1 cif cF cfv cA
      cle cN cN cn wcel cN c1 cif cF fveq2 breq1d cA vk cF cN cn wcel cN c1 cif
      climub.1 climub.2 climub.3 climub.4 cN c1 cn 1nn elimel climubii dedth $.
      $( [8-Jun-2006] $) $( [18-Mar-2005] $)
  $}

  ${
    $d j k x y z F $.
    climsup.1 $e |- F : NN --> RR $.
    climsup.2 $e |- ( k e. NN -> ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
    climsup.3 $e |- E. x e. RR A. k e. NN ( F ` k ) <_ x $.
    $( A bounded monotonic sequence converges to the supremum of its range.
       Theorem 12-5.1 of [Gleason] p. 180. $)
    climsupi $p |- F ~~> sup ( ran F , RR , < ) $=
      cF cF crn cr clt csup cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt wbr wi vk cn wral vj
      cn wrex wi vx cr cn cc cF wf cF crn cr clt csup cc wcel cF cF crn cr clt
      csup cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cF crn cr
      clt csup cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr
      wral wb cn cr cF wf cr cc wss cn cc cF wf climsup.1 axresscn cn cr cc cF
      fss mp2an cF crn cr clt csup vx vy cF crn cF crn cr wss cF crn c0 wne vy
      cv vx cv cle wbr vy cF crn wral vx cr wrex cn cr cF wf cF crn cr wss
      climsup.1 cn cr cF frn ax-mp cF cdm c0 wne cF crn c0 wne cF cdm c0 wne cn
      c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i ax-mp cF cdm cn c0 cn cr cF
      climsup.1 fdmi neeq1i mpbir cF cdm c0 cF crn c0 cF dm0rn0 necon3bii mpbi
      vk cv cF cfv vx cv cle wbr vk cn wral vx cr wrex vy cv vx cv cle wbr vy
      cF crn wral vx cr wrex climsup.3 vk cv cF cfv vx cv cle wbr vk cn wral vy
      cv vx cv cle wbr vy cF crn wral vx cr vk cv cF cfv vx cv cle wbr vk cn
      wral vy cv vx cv cle wbr vy cF crn vk cv cF cfv vx cv cle wbr vk cn wral
      vk cv cF cfv vy cv wceq vk cn wrex vy cv vx cv cle wbr vy cv cF crn wcel
      vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv wceq vy cv vx cv
      cle wbr vk cn vk cv cF cfv vx cv cle wbr vk cn hbra1 vy cv vx cv cle wbr
      vk ax-17 vk cv cF cfv vx cv cle wbr vk cn wral vk cv cn wcel vk cv cF cfv
      vx cv cle wbr vk cv cF cfv vy cv wceq vy cv vx cv cle wbr wi vk cv cF cfv
      vx cv cle wbr vk cn ra4 vk cv cF cfv vy cv wceq vk cv cF cfv vx cv cle
      wbr vy cv vx cv cle wbr vk cv cF cfv vy cv vx cv cle breq1 biimpcd syl6
      r19.23ad cF cn wfn vy cv cF crn wcel vk cv cF cfv vy cv wceq vk cn wrex
      wb cn cr cF wf cF cn wfn climsup.1 cn cr cF ffn ax-mp vk cn vy cv cF
      fvelrnb ax-mp syl5ib r19.21aiv r19.22si ax-mp 3pm3.2i suprclii recni vx
      cF crn cr clt csup vj vk cF climfnn mp2an vx cv cr wcel cc0 vx cv clt wbr
      cF crn cr clt csup vx cv cmin co vy cv clt wbr vy cF crn wrex vj cv vk cv
      cle wbr vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt wbr wi
      vk cn wral vj cn wrex vx cv cr wcel cc0 vx cv clt wbr cF crn cr clt csup
      vx cv cmin co cF crn cr clt csup clt wbr cF crn cr clt csup vx cv cmin co
      vy cv clt wbr vy cF crn wrex vx cv cr wcel cF crn cr clt csup cr wcel cc0
      vx cv clt wbr cF crn cr clt csup vx cv cmin co cF crn cr clt csup clt wbr
      wb vx vy cF crn cF crn cr wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn
      wral vx cr wrex cn cr cF wf cF crn cr wss climsup.1 cn cr cF frn ax-mp cF
      cdm c0 wne cF crn c0 wne cF cdm c0 wne cn c0 wne c1 cn wcel cn c0 wne 1nn
      cn c1 ne0i ax-mp cF cdm cn c0 cn cr cF climsup.1 fdmi neeq1i mpbir cF cdm
      c0 cF crn c0 cF dm0rn0 necon3bii mpbi vk cv cF cfv vx cv cle wbr vk cn
      wral vx cr wrex vy cv vx cv cle wbr vy cF crn wral vx cr wrex climsup.3
      vk cv cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn wral
      vx cr vk cv cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn
      vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv wceq vk cn wrex
      vy cv vx cv cle wbr vy cv cF crn wcel vk cv cF cfv vx cv cle wbr vk cn
      wral vk cv cF cfv vy cv wceq vy cv vx cv cle wbr vk cn vk cv cF cfv vx cv
      cle wbr vk cn hbra1 vy cv vx cv cle wbr vk ax-17 vk cv cF cfv vx cv cle
      wbr vk cn wral vk cv cn wcel vk cv cF cfv vx cv cle wbr vk cv cF cfv vy
      cv wceq vy cv vx cv cle wbr wi vk cv cF cfv vx cv cle wbr vk cn ra4 vk cv
      cF cfv vy cv wceq vk cv cF cfv vx cv cle wbr vy cv vx cv cle wbr vk cv cF
      cfv vy cv vx cv cle breq1 biimpcd syl6 r19.23ad cF cn wfn vy cv cF crn
      wcel vk cv cF cfv vy cv wceq vk cn wrex wb cn cr cF wf cF cn wfn
      climsup.1 cn cr cF ffn ax-mp vk cn vy cv cF fvelrnb ax-mp syl5ib
      r19.21aiv r19.22si ax-mp 3pm3.2i suprclii vx cv cF crn cr clt csup
      ltsubpos mpan2 vx cv cr wcel cF crn cr clt csup vx cv cmin co cF crn cr
      clt csup clt wbr cF crn cr clt csup vx cv cmin co vy cv clt wbr vy cF crn
      wrex cF crn cr clt csup vx cv cmin co cr wcel cF crn cr clt csup vx cv
      cmin co cF crn cr clt csup clt wbr cF crn cr clt csup vx cv cmin co vy cv
      clt wbr vy cF crn wrex vx cv cr wcel vx vz vy cF crn cF crn cr clt csup
      vx cv cmin co cF crn cr wss cF crn c0 wne vz cv vx cv cle wbr vz cF crn
      wral vx cr wrex cn cr cF wf cF crn cr wss climsup.1 cn cr cF frn ax-mp cF
      cdm c0 wne cF crn c0 wne cF cdm c0 wne cn c0 wne c1 cn wcel cn c0 wne 1nn
      cn c1 ne0i ax-mp cF cdm cn c0 cn cr cF climsup.1 fdmi neeq1i mpbir cF cdm
      c0 cF crn c0 cF dm0rn0 necon3bii mpbi vk cv cF cfv vx cv cle wbr vk cn
      wral vx cr wrex vz cv vx cv cle wbr vz cF crn wral vx cr wrex climsup.3
      vk cv cF cfv vx cv cle wbr vk cn wral vz cv vx cv cle wbr vz cF crn wral
      vx cr vk cv cF cfv vx cv cle wbr vk cn wral vz cv vx cv cle wbr vz cF crn
      vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vz cv wceq vk cn wrex
      vz cv vx cv cle wbr vz cv cF crn wcel vk cv cF cfv vx cv cle wbr vk cn
      wral vk cv cF cfv vz cv wceq vz cv vx cv cle wbr vk cn vk cv cF cfv vx cv
      cle wbr vk cn hbra1 vz cv vx cv cle wbr vk ax-17 vk cv cF cfv vx cv cle
      wbr vk cn wral vk cv cn wcel vk cv cF cfv vx cv cle wbr vk cv cF cfv vz
      cv wceq vz cv vx cv cle wbr wi vk cv cF cfv vx cv cle wbr vk cn ra4 vk cv
      cF cfv vz cv wceq vk cv cF cfv vx cv cle wbr vz cv vx cv cle wbr vk cv cF
      cfv vz cv vx cv cle breq1 biimpcd syl6 r19.23ad cF cn wfn vz cv cF crn
      wcel vk cv cF cfv vz cv wceq vk cn wrex wb cn cr cF wf cF cn wfn
      climsup.1 cn cr cF ffn ax-mp vk cn vz cv cF fvelrnb ax-mp syl5ib
      r19.21aiv r19.22si ax-mp 3pm3.2i suprlubii cF crn cr clt csup cr wcel vx
      cv cr wcel cF crn cr clt csup vx cv cmin co cr wcel vx vy cF crn cF crn
      cr wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn wral vx cr wrex cn cr
      cF wf cF crn cr wss climsup.1 cn cr cF frn ax-mp cF cdm c0 wne cF crn c0
      wne cF cdm c0 wne cn c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i ax-mp cF
      cdm cn c0 cn cr cF climsup.1 fdmi neeq1i mpbir cF cdm c0 cF crn c0 cF
      dm0rn0 necon3bii mpbi vk cv cF cfv vx cv cle wbr vk cn wral vx cr wrex vy
      cv vx cv cle wbr vy cF crn wral vx cr wrex climsup.3 vk cv cF cfv vx cv
      cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn wral vx cr vk cv cF cfv
      vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn vk cv cF cfv vx cv
      cle wbr vk cn wral vk cv cF cfv vy cv wceq vk cn wrex vy cv vx cv cle wbr
      vy cv cF crn wcel vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy
      cv wceq vy cv vx cv cle wbr vk cn vk cv cF cfv vx cv cle wbr vk cn hbra1
      vy cv vx cv cle wbr vk ax-17 vk cv cF cfv vx cv cle wbr vk cn wral vk cv
      cn wcel vk cv cF cfv vx cv cle wbr vk cv cF cfv vy cv wceq vy cv vx cv
      cle wbr wi vk cv cF cfv vx cv cle wbr vk cn ra4 vk cv cF cfv vy cv wceq
      vk cv cF cfv vx cv cle wbr vy cv vx cv cle wbr vk cv cF cfv vy cv vx cv
      cle breq1 biimpcd syl6 r19.23ad cF cn wfn vy cv cF crn wcel vk cv cF cfv
      vy cv wceq vk cn wrex wb cn cr cF wf cF cn wfn climsup.1 cn cr cF ffn
      ax-mp vk cn vy cv cF fvelrnb ax-mp syl5ib r19.21aiv r19.22si ax-mp
      3pm3.2i suprclii cF crn cr clt csup vx cv resubcl mpan sylan ex sylbid vx
      cv cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt wbr wi vk
      cn wral vj cn wrex vy cF crn vx cv cr wcel cF crn cr clt csup vx cv cmin
      co vy cv clt wbr vy cv cF crn wcel vj cv vk cv cle wbr vk cv cF cfv cF
      crn cr clt csup cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex
      vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr vy cv cF crn
      wcel vj cv vk cv cle wbr vk cv cF cfv cF crn cr clt csup cmin co cabs cfv
      vx cv clt wbr wi vk cn wral vj cn wrex wi vx cv cr wcel cF crn cr clt
      csup vx cv cmin co vy cv clt wbr wa vj cv cF cfv vy cv wceq vj cn wrex vj
      cv vk cv cle wbr vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv
      clt wbr wi vk cn wral vj cn wrex vy cv cF crn wcel vx cv cr wcel cF crn
      cr clt csup vx cv cmin co vy cv clt wbr wa vj cv cF cfv vy cv wceq vj cv
      vk cv cle wbr vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt
      wbr wi vk cn wral vj cn vx cv cr wcel cF crn cr clt csup vx cv cmin co vy
      cv clt wbr wa vj cv cn wcel vj cv cF cfv vy cv wceq vj cv vk cv cle wbr
      vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt wbr wi vk cn
      wral vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr wa vj
      cv cn wcel vj cv cF cfv vy cv wceq wa wa vj cv vk cv cle wbr vk cv cF cfv
      cF crn cr clt csup cmin co cabs cfv vx cv clt wbr wi vk cn vx cv cr wcel
      cF crn cr clt csup vx cv cmin co vy cv clt wbr wa vj cv cn wcel vj cv cF
      cfv vy cv wceq wa wa vk cv cn wcel vj cv vk cv cle wbr vk cv cF cfv cF
      crn cr clt csup cmin co cabs cfv vx cv clt wbr vx cv cr wcel cF crn cr
      clt csup vx cv cmin co vy cv clt wbr wa vj cv cn wcel vj cv cF cfv vy cv
      wceq wa wa vk cv cn wcel vj cv vk cv cle wbr wa wa vk cv cF cfv cF crn cr
      clt csup cmin co cabs cfv vx cv clt wbr cF crn cr clt csup vx cv cmin co
      vk cv cF cfv clt wbr vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv
      clt wbr wa vj cv cn wcel vj cv cF cfv vy cv wceq wa wa vk cv cn wcel vj
      cv vk cv cle wbr wa wa cF crn cr clt csup vx cv cmin co vj cv cF cfv vk
      cv cF cfv vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr wa
      cF crn cr clt csup vx cv cmin co cr wcel vj cv cn wcel vj cv cF cfv vy cv
      wceq wa vk cv cn wcel vj cv vk cv cle wbr wa vx cv cr wcel cF crn cr clt
      csup vx cv cmin co cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr
      cF crn cr clt csup cr wcel vx cv cr wcel cF crn cr clt csup vx cv cmin co
      cr wcel vx vy cF crn cF crn cr wss cF crn c0 wne vy cv vx cv cle wbr vy
      cF crn wral vx cr wrex cn cr cF wf cF crn cr wss climsup.1 cn cr cF frn
      ax-mp cF cdm c0 wne cF crn c0 wne cF cdm c0 wne cn c0 wne c1 cn wcel cn
      c0 wne 1nn cn c1 ne0i ax-mp cF cdm cn c0 cn cr cF climsup.1 fdmi neeq1i
      mpbir cF cdm c0 cF crn c0 cF dm0rn0 necon3bii mpbi vk cv cF cfv vx cv cle
      wbr vk cn wral vx cr wrex vy cv vx cv cle wbr vy cF crn wral vx cr wrex
      climsup.3 vk cv cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF
      crn wral vx cr vk cv cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr
      vy cF crn vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv wceq
      vk cn wrex vy cv vx cv cle wbr vy cv cF crn wcel vk cv cF cfv vx cv cle
      wbr vk cn wral vk cv cF cfv vy cv wceq vy cv vx cv cle wbr vk cn vk cv cF
      cfv vx cv cle wbr vk cn hbra1 vy cv vx cv cle wbr vk ax-17 vk cv cF cfv
      vx cv cle wbr vk cn wral vk cv cn wcel vk cv cF cfv vx cv cle wbr vk cv
      cF cfv vy cv wceq vy cv vx cv cle wbr wi vk cv cF cfv vx cv cle wbr vk cn
      ra4 vk cv cF cfv vy cv wceq vk cv cF cfv vx cv cle wbr vy cv vx cv cle
      wbr vk cv cF cfv vy cv vx cv cle breq1 biimpcd syl6 r19.23ad cF cn wfn vy
      cv cF crn wcel vk cv cF cfv vy cv wceq vk cn wrex wb cn cr cF wf cF cn
      wfn climsup.1 cn cr cF ffn ax-mp vk cn vy cv cF fvelrnb ax-mp syl5ib
      r19.21aiv r19.22si ax-mp 3pm3.2i suprclii cF crn cr clt csup vx cv
      resubcl mpan adantr ad2antrr vj cv cn wcel vj cv cF cfv vy cv wceq wa vj
      cv cF cfv cr wcel vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv
      clt wbr wa vk cv cn wcel vj cv vk cv cle wbr wa vj cv cn wcel vj cv cF
      cfv cr wcel vj cv cF cfv vy cv wceq cn cr vj cv cF climsup.1 ffvelrni
      adantr ad2antlr vk cv cn wcel vk cv cF cfv cr wcel vx cv cr wcel cF crn
      cr clt csup vx cv cmin co vy cv clt wbr wa vj cv cn wcel vj cv cF cfv vy
      cv wceq wa wa vj cv vk cv cle wbr cn cr vk cv cF climsup.1 ffvelrni
      ad2antrl vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr wa
      vj cv cn wcel vj cv cF cfv vy cv wceq wa wa cF crn cr clt csup vx cv cmin
      co vj cv cF cfv clt wbr vk cv cn wcel vj cv vk cv cle wbr wa cF crn cr
      clt csup vx cv cmin co vy cv clt wbr vj cv cF cfv vy cv wceq cF crn cr
      clt csup vx cv cmin co vj cv cF cfv clt wbr vx cv cr wcel vj cv cn wcel
      vj cv cF cfv vy cv wceq cF crn cr clt csup vx cv cmin co vj cv cF cfv clt
      wbr cF crn cr clt csup vx cv cmin co vy cv clt wbr vj cv cF cfv vy cv cF
      crn cr clt csup vx cv cmin co clt breq2 biimparc ad2ant2l adantr vj cv cn
      wcel vj cv cF cfv vy cv wceq wa vk cv cn wcel vj cv vk cv cle wbr wa vj
      cv cF cfv vk cv cF cfv cle wbr vx cv cr wcel cF crn cr clt csup vx cv
      cmin co vy cv clt wbr wa vj cv cn wcel vk cv cn wcel vj cv vk cv cle wbr
      wa vj cv cF cfv vk cv cF cfv cle wbr vj cv cF cfv vy cv wceq vj cv cn
      wcel vk cv cn wcel vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cle wbr
      vk vj cv vk cv cF climsup.1 climsup.2 monoord 3expb adantlr adantll
      ltletrd vx cv cr wcel cF crn cr clt csup vx cv cmin co vy cv clt wbr wa
      vk cv cn wcel vj cv vk cv cle wbr wa vk cv cF cfv cF crn cr clt csup cmin
      co cabs cfv vx cv clt wbr cF crn cr clt csup vx cv cmin co vk cv cF cfv
      clt wbr wb vj cv cn wcel vj cv cF cfv vy cv wceq wa vx cv cr wcel vk cv
      cn wcel vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt wbr cF
      crn cr clt csup vx cv cmin co vk cv cF cfv clt wbr wb cF crn cr clt csup
      vx cv cmin co vy cv clt wbr vj cv vk cv cle wbr vx cv cr wcel vk cv cn
      wcel wa vk cv cF cfv cF crn cr clt csup cmin co cabs cfv vx cv clt wbr cF
      crn cr clt csup vk cv cF cfv cmin co vx cv clt wbr cF crn cr clt csup vx
      cv cmin co vk cv cF cfv clt wbr vk cv cn wcel vk cv cF cfv cF crn cr clt
      csup cmin co cabs cfv vx cv clt wbr cF crn cr clt csup vk cv cF cfv cmin
      co vx cv clt wbr wb vx cv cr wcel vk cv cn wcel vk cv cF cfv cF crn cr
      clt csup cmin co cabs cfv cF crn cr clt csup vk cv cF cfv cmin co vx cv
      clt vk cv cn wcel vk cv cF cfv cF crn cr clt csup cmin co cabs cfv cF crn
      cr clt csup vk cv cF cfv cmin co cabs cfv cF crn cr clt csup vk cv cF cfv
      cmin co vk cv cn wcel vk cv cF cfv cr wcel vk cv cF cfv cc wcel vk cv cF
      cfv cF crn cr clt csup cmin co cabs cfv cF crn cr clt csup vk cv cF cfv
      cmin co cabs cfv wceq cn cr vk cv cF climsup.1 ffvelrni vk cv cF cfv recn
      vk cv cF cfv cc wcel cF crn cr clt csup cc wcel vk cv cF cfv cF crn cr
      clt csup cmin co cabs cfv cF crn cr clt csup vk cv cF cfv cmin co cabs
      cfv wceq cF crn cr clt csup vx vy cF crn cF crn cr wss cF crn c0 wne vy
      cv vx cv cle wbr vy cF crn wral vx cr wrex cn cr cF wf cF crn cr wss
      climsup.1 cn cr cF frn ax-mp cF cdm c0 wne cF crn c0 wne cF cdm c0 wne cn
      c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i ax-mp cF cdm cn c0 cn cr cF
      climsup.1 fdmi neeq1i mpbir cF cdm c0 cF crn c0 cF dm0rn0 necon3bii mpbi
      vk cv cF cfv vx cv cle wbr vk cn wral vx cr wrex vy cv vx cv cle wbr vy
      cF crn wral vx cr wrex climsup.3 vk cv cF cfv vx cv cle wbr vk cn wral vy
      cv vx cv cle wbr vy cF crn wral vx cr vk cv cF cfv vx cv cle wbr vk cn
      wral vy cv vx cv cle wbr vy cF crn vk cv cF cfv vx cv cle wbr vk cn wral
      vk cv cF cfv vy cv wceq vk cn wrex vy cv vx cv cle wbr vy cv cF crn wcel
      vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv wceq vy cv vx cv
      cle wbr vk cn vk cv cF cfv vx cv cle wbr vk cn hbra1 vy cv vx cv cle wbr
      vk ax-17 vk cv cF cfv vx cv cle wbr vk cn wral vk cv cn wcel vk cv cF cfv
      vx cv cle wbr vk cv cF cfv vy cv wceq vy cv vx cv cle wbr wi vk cv cF cfv
      vx cv cle wbr vk cn ra4 vk cv cF cfv vy cv wceq vk cv cF cfv vx cv cle
      wbr vy cv vx cv cle wbr vk cv cF cfv vy cv vx cv cle breq1 biimpcd syl6
      r19.23ad cF cn wfn vy cv cF crn wcel vk cv cF cfv vy cv wceq vk cn wrex
      wb cn cr cF wf cF cn wfn climsup.1 cn cr cF ffn ax-mp vk cn vy cv cF
      fvelrnb ax-mp syl5ib r19.21aiv r19.22si ax-mp 3pm3.2i suprclii recni vk
      cv cF cfv cF crn cr clt csup abssub mpan2 3syl cF crn cr clt csup vk cv
      cF cfv cmin co cr wcel cc0 cF crn cr clt csup vk cv cF cfv cmin co cle
      wbr cF crn cr clt csup vk cv cF cfv cmin co cabs cfv cF crn cr clt csup
      vk cv cF cfv cmin co wceq vk cv cn wcel cF crn cr clt csup vk cv cF cfv
      cmin co absid cF crn cr clt csup cr wcel vk cv cF cfv cr wcel cF crn cr
      clt csup vk cv cF cfv cmin co cr wcel vk cv cn wcel cF crn cr clt csup vk
      cv cF cfv resubcl vx vy cF crn cF crn cr wss cF crn c0 wne vy cv vx cv
      cle wbr vy cF crn wral vx cr wrex cn cr cF wf cF crn cr wss climsup.1 cn
      cr cF frn ax-mp cF cdm c0 wne cF crn c0 wne cF cdm c0 wne cn c0 wne c1 cn
      wcel cn c0 wne 1nn cn c1 ne0i ax-mp cF cdm cn c0 cn cr cF climsup.1 fdmi
      neeq1i mpbir cF cdm c0 cF crn c0 cF dm0rn0 necon3bii mpbi vk cv cF cfv vx
      cv cle wbr vk cn wral vx cr wrex vy cv vx cv cle wbr vy cF crn wral vx cr
      wrex climsup.3 vk cv cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr
      vy cF crn wral vx cr vk cv cF cfv vx cv cle wbr vk cn wral vy cv vx cv
      cle wbr vy cF crn vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy
      cv wceq vk cn wrex vy cv vx cv cle wbr vy cv cF crn wcel vk cv cF cfv vx
      cv cle wbr vk cn wral vk cv cF cfv vy cv wceq vy cv vx cv cle wbr vk cn
      vk cv cF cfv vx cv cle wbr vk cn hbra1 vy cv vx cv cle wbr vk ax-17 vk cv
      cF cfv vx cv cle wbr vk cn wral vk cv cn wcel vk cv cF cfv vx cv cle wbr
      vk cv cF cfv vy cv wceq vy cv vx cv cle wbr wi vk cv cF cfv vx cv cle wbr
      vk cn ra4 vk cv cF cfv vy cv wceq vk cv cF cfv vx cv cle wbr vy cv vx cv
      cle wbr vk cv cF cfv vy cv vx cv cle breq1 biimpcd syl6 r19.23ad cF cn
      wfn vy cv cF crn wcel vk cv cF cfv vy cv wceq vk cn wrex wb cn cr cF wf
      cF cn wfn climsup.1 cn cr cF ffn ax-mp vk cn vy cv cF fvelrnb ax-mp
      syl5ib r19.21aiv r19.22si ax-mp 3pm3.2i suprclii cn cr vk cv cF climsup.1
      ffvelrni sylancr vk cv cn wcel cc0 cF crn cr clt csup vk cv cF cfv cmin
      co cle wbr vk cv cF cfv cF crn cr clt csup cle wbr vk cv cn wcel vk cv cF
      cfv cF crn wcel vk cv cF cfv cF crn cr clt csup cle wbr cF cn wfn vk cv
      cn wcel vk cv cF cfv cF crn wcel cn cr cF wf cF cn wfn climsup.1 cn cr cF
      ffn ax-mp cn vk cv cF fnfvelrn mpan vx vy cF crn vk cv cF cfv cF crn cr
      wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn wral vx cr wrex cn cr cF
      wf cF crn cr wss climsup.1 cn cr cF frn ax-mp cF cdm c0 wne cF crn c0 wne
      cF cdm c0 wne cn c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i ax-mp cF cdm
      cn c0 cn cr cF climsup.1 fdmi neeq1i mpbir cF cdm c0 cF crn c0 cF dm0rn0
      necon3bii mpbi vk cv cF cfv vx cv cle wbr vk cn wral vx cr wrex vy cv vx
      cv cle wbr vy cF crn wral vx cr wrex climsup.3 vk cv cF cfv vx cv cle wbr
      vk cn wral vy cv vx cv cle wbr vy cF crn wral vx cr vk cv cF cfv vx cv
      cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn vk cv cF cfv vx cv cle
      wbr vk cn wral vk cv cF cfv vy cv wceq vk cn wrex vy cv vx cv cle wbr vy
      cv cF crn wcel vk cv cF cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv
      wceq vy cv vx cv cle wbr vk cn vk cv cF cfv vx cv cle wbr vk cn hbra1 vy
      cv vx cv cle wbr vk ax-17 vk cv cF cfv vx cv cle wbr vk cn wral vk cv cn
      wcel vk cv cF cfv vx cv cle wbr vk cv cF cfv vy cv wceq vy cv vx cv cle
      wbr wi vk cv cF cfv vx cv cle wbr vk cn ra4 vk cv cF cfv vy cv wceq vk cv
      cF cfv vx cv cle wbr vy cv vx cv cle wbr vk cv cF cfv vy cv vx cv cle
      breq1 biimpcd syl6 r19.23ad cF cn wfn vy cv cF crn wcel vk cv cF cfv vy
      cv wceq vk cn wrex wb cn cr cF wf cF cn wfn climsup.1 cn cr cF ffn ax-mp
      vk cn vy cv cF fvelrnb ax-mp syl5ib r19.21aiv r19.22si ax-mp 3pm3.2i
      suprubii syl cF crn cr clt csup cr wcel vk cv cF cfv cr wcel cc0 cF crn
      cr clt csup vk cv cF cfv cmin co cle wbr vk cv cF cfv cF crn cr clt csup
      cle wbr wb vk cv cn wcel cF crn cr clt csup vk cv cF cfv subge0 vx vy cF
      crn cF crn cr wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn wral vx cr
      wrex cn cr cF wf cF crn cr wss climsup.1 cn cr cF frn ax-mp cF cdm c0 wne
      cF crn c0 wne cF cdm c0 wne cn c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i
      ax-mp cF cdm cn c0 cn cr cF climsup.1 fdmi neeq1i mpbir cF cdm c0 cF crn
      c0 cF dm0rn0 necon3bii mpbi vk cv cF cfv vx cv cle wbr vk cn wral vx cr
      wrex vy cv vx cv cle wbr vy cF crn wral vx cr wrex climsup.3 vk cv cF cfv
      vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn wral vx cr vk cv
      cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn vk cv cF
      cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv wceq vk cn wrex vy cv vx
      cv cle wbr vy cv cF crn wcel vk cv cF cfv vx cv cle wbr vk cn wral vk cv
      cF cfv vy cv wceq vy cv vx cv cle wbr vk cn vk cv cF cfv vx cv cle wbr vk
      cn hbra1 vy cv vx cv cle wbr vk ax-17 vk cv cF cfv vx cv cle wbr vk cn
      wral vk cv cn wcel vk cv cF cfv vx cv cle wbr vk cv cF cfv vy cv wceq vy
      cv vx cv cle wbr wi vk cv cF cfv vx cv cle wbr vk cn ra4 vk cv cF cfv vy
      cv wceq vk cv cF cfv vx cv cle wbr vy cv vx cv cle wbr vk cv cF cfv vy cv
      vx cv cle breq1 biimpcd syl6 r19.23ad cF cn wfn vy cv cF crn wcel vk cv
      cF cfv vy cv wceq vk cn wrex wb cn cr cF wf cF cn wfn climsup.1 cn cr cF
      ffn ax-mp vk cn vy cv cF fvelrnb ax-mp syl5ib r19.21aiv r19.22si ax-mp
      3pm3.2i suprclii cn cr vk cv cF climsup.1 ffvelrni sylancr mpbird sylanc
      eqtrd breq1d adantl vx cv cr wcel vk cv cF cfv cr wcel cF crn cr clt csup
      vx cv cmin co vk cv cF cfv clt wbr cF crn cr clt csup vk cv cF cfv cmin
      co vx cv clt wbr wb vk cv cn wcel cF crn cr clt csup cr wcel vx cv cr
      wcel vk cv cF cfv cr wcel cF crn cr clt csup vx cv cmin co vk cv cF cfv
      clt wbr cF crn cr clt csup vk cv cF cfv cmin co vx cv clt wbr wb vx vy cF
      crn cF crn cr wss cF crn c0 wne vy cv vx cv cle wbr vy cF crn wral vx cr
      wrex cn cr cF wf cF crn cr wss climsup.1 cn cr cF frn ax-mp cF cdm c0 wne
      cF crn c0 wne cF cdm c0 wne cn c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i
      ax-mp cF cdm cn c0 cn cr cF climsup.1 fdmi neeq1i mpbir cF cdm c0 cF crn
      c0 cF dm0rn0 necon3bii mpbi vk cv cF cfv vx cv cle wbr vk cn wral vx cr
      wrex vy cv vx cv cle wbr vy cF crn wral vx cr wrex climsup.3 vk cv cF cfv
      vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn wral vx cr vk cv
      cF cfv vx cv cle wbr vk cn wral vy cv vx cv cle wbr vy cF crn vk cv cF
      cfv vx cv cle wbr vk cn wral vk cv cF cfv vy cv wceq vk cn wrex vy cv vx
      cv cle wbr vy cv cF crn wcel vk cv cF cfv vx cv cle wbr vk cn wral vk cv
      cF cfv vy cv wceq vy cv vx cv cle wbr vk cn vk cv cF cfv vx cv cle wbr vk
      cn hbra1 vy cv vx cv cle wbr vk ax-17 vk cv cF cfv vx cv cle wbr vk cn
      wral vk cv cn wcel vk cv cF cfv vx cv cle wbr vk cv cF cfv vy cv wceq vy
      cv vx cv cle wbr wi vk cv cF cfv vx cv cle wbr vk cn ra4 vk cv cF cfv vy
      cv wceq vk cv cF cfv vx cv cle wbr vy cv vx cv cle wbr vk cv cF cfv vy cv
      vx cv cle breq1 biimpcd syl6 r19.23ad cF cn wfn vy cv cF crn wcel vk cv
      cF cfv vy cv wceq vk cn wrex wb cn cr cF wf cF cn wfn climsup.1 cn cr cF
      ffn ax-mp vk cn vy cv cF fvelrnb ax-mp syl5ib r19.21aiv r19.22si ax-mp
      3pm3.2i suprclii cF crn cr clt csup vx cv vk cv cF cfv ltsub23 mp3an1 cn
      cr vk cv cF climsup.1 ffvelrni sylan2 bitr4d ad2ant2r adantlr mpbird
      exp32 r19.21aiv exp32 r19.22dv cF cn wfn vy cv cF crn wcel vj cv cF cfv
      vy cv wceq vj cn wrex wb cn cr cF wf cF cn wfn climsup.1 cn cr cF ffn
      ax-mp vj cn vy cv cF fvelrnb ax-mp syl5ib ex com23 r19.23adv syld mprgbir
      $.
      $( [12-Jun-2006] $) $( [13-Mar-2005] $)
  $}

  ${
    $( MAY BE REVISED - 3rd hyp is theoretically unnecessary $)
    $d x y z w v F $.  $d y z w v A $.  $( y z w A could be eliminated $)
    climcau.1 $e |- A e. _V $.
    climcau.2 $e |- F ~~> A $.
    climcau.3 $e |- F : NN --> CC $.
    $( A converging sequence of complex numbers is a Cauchy sequence.
       Theorem 12-5.3 of [Gleason] p. 180 (necessity part). $)
    climcaui $p |- A. x e. RR ( 0 < x -> E. y e. NN A. z e. NN ( y < z ->
                      ( abs ` ( ( F ` z ) - ( F ` y ) ) ) < x ) ) $=
      cc0 vx cv clt wbr vy cv vz cv clt wbr vz cv cF cfv vy cv cF cfv cmin co
      cabs cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr vx cv cr wcel
      cc0 vx cv clt wbr vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx
      cv c2 cdiv co clt wbr wi vv cn wral vy cn wrex vy cv vz cv clt wbr vz cv
      cF cfv vy cv cF cfv cmin co cabs cfv vx cv clt wbr wi vz cn wral vy cn
      wrex vx cv cr wcel cc0 vx cv clt wbr cc0 vx cv c2 cdiv co clt wbr vy cv
      vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wi vv cn wral vy cn wrex vx cv halfpos2 vx cv cr wcel vx cv c2 cdiv co cr
      wcel cc0 vx cv c2 cdiv co clt wbr vy cv vv cv cle wbr vv cv cF cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vy cn wrex wi vx
      cv rehalfcl cc0 vw cv clt wbr vy cv vv cv cle wbr vv cv cF cfv cA cmin co
      cabs cfv vw cv clt wbr wi vv cn wral vy cn wrex wi cc0 vx cv c2 cdiv co
      clt wbr vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vv cn wral vy cn wrex wi vw vx cv c2 cdiv co cr vw cv
      vx cv c2 cdiv co wceq cc0 vw cv clt wbr cc0 vx cv c2 cdiv co clt wbr vy
      cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vv cn
      wral vy cn wrex vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx
      cv c2 cdiv co clt wbr wi vv cn wral vy cn wrex vw cv vx cv c2 cdiv co cc0
      clt breq2 vw cv vx cv c2 cdiv co wceq vy cv vv cv cle wbr vv cv cF cfv cA
      cmin co cabs cfv vw cv clt wbr wi vy cv vv cv cle wbr vv cv cF cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy vv cn cn vw cv vx cv c2
      cdiv co wceq vv cv cF cfv cA cmin co cabs cfv vw cv clt wbr vv cv cF cfv
      cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vy cv vv cv cle wbr vw cv vx
      cv c2 cdiv co vv cv cF cfv cA cmin co cabs cfv clt breq2 imbi2d
      rexralbidv imbi12d cF cA cli wbr cc0 vw cv clt wbr vy cv vv cv cle wbr vv
      cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vv cn wral vy cn wrex wi
      vw cr wral climcau.2 cF cA cli wbr cc0 vw cv clt wbr vy cv vv cv cle wbr
      vv cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vv cn wral vy cn wrex
      wi vw cr cF cA cli wbr vw cv cr wcel cc0 vw cv clt wbr vy cv vv cv cle
      wbr vv cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vv cn wral vy cn
      wrex cA cvv wcel cF cA cli wbr vw cv cr wcel cc0 vw cv clt wbr wa vy cv
      vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vw cv clt wbr wi vv cn
      wral vy cn wrex climcau.1 cA vw cv cvv vy vv cF c1 cn cn 1z cn c1 cuz cfv
      nnuz eqimss2i nnssz clmi2i mpanl1 exp32 r19.21aiv ax-mp vtoclri syl
      sylbid vx cv cr wcel vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv
      vx cv c2 cdiv co clt wbr wi vv cn wral vy cv vz cv clt wbr vz cv cF cfv
      vy cv cF cfv cmin co cabs cfv vx cv clt wbr wi vz cn wral vy cn vx cv cr
      wcel vy cv cn wcel wa vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vv cn wral vy cv vz cv clt wbr vz cv cF
      cfv vy cv cF cfv cmin co cabs cfv vx cv clt wbr wi vz cn vx cv cr wcel vy
      cv cn wcel wa vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv
      c2 cdiv co clt wbr wi vv cn wral vz cv cn wcel vy cv vz cv clt wbr vz cv
      cF cfv vy cv cF cfv cmin co cabs cfv vx cv clt wbr wi vx cv cr wcel vy cv
      cn wcel wa vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vv cn wral vz cv cn wcel wa wa vy cv vz cv clt wbr vz
      cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co
      vx cv clt wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv clt wbr vx
      cv cr wcel vy cv cn wcel wa vy cv vv cv cle wbr vv cv cF cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vz cv cn wcel wa wa vy cv
      vz cv clt wbr vz cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co
      cabs cfv caddc co vx cv clt wbr vx cv cr wcel vy cv cn wcel wa vy cv vv
      cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi
      vv cn wral vz cv cn wcel wa wa vy cv vz cv clt wbr wa vz cv cF cfv cA
      cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co vx cv c2 cdiv
      co vx cv c2 cdiv co caddc co vx cv clt vx cv cr wcel vy cv cn wcel wa vy
      cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vv cn wral vz cv cn wcel wa wa vy cv vz cv clt wbr wa vz cv cF cfv
      cA cmin co cabs cfv vx cv c2 cdiv co clt wbr cA vy cv cF cfv cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wa vz cv cF cfv cA cmin co cabs cfv cA vy cv
      cF cfv cmin co cabs cfv caddc co vx cv c2 cdiv co vx cv c2 cdiv co caddc
      co clt wbr vy cv cn wcel vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vv cn wral vz cv cn wcel wa vy cv vz cv
      clt wbr vz cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr cA vy
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wa vx cv cr wcel vy
      cv cn wcel vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vv cn wral vz cv cn wcel wa wa vy cv vz cv clt wbr wa
      vz cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr cA vy cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr vy cv cn wcel vy cv vv cv cle
      wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv cn
      wral vz cv cn wcel wa wa vy cv vz cv clt wbr vz cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr vy cv cn wcel vy cv vv cv cle wbr vv cv cF
      cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vz cv cn
      wcel wa wa vy cv vz cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmin
      co cabs cfv vx cv c2 cdiv co clt wbr vy cv cn wcel vz cv cn wcel vy cv vz
      cv clt wbr vy cv vz cv cle wbr wi vy cv vv cv cle wbr vv cv cF cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vy cv cr wcel vz
      cv cr wcel vy cv vz cv clt wbr vy cv vz cv cle wbr wi vy cv cn wcel vz cv
      cn wcel vy cv vz cv ltle vy cv nnre vz cv nnre syl2an adantrl vy cv vv cv
      cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv
      cn wral vz cv cn wcel wa vy cv vz cv cle wbr vz cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vy cv cn wcel vy cv vv cv cle wbr vv cv
      cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cv vz cv cle
      wbr vz cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv vz cv
      cn vv cv vz cv wceq vy cv vv cv cle wbr vy cv vz cv cle wbr vv cv cF cfv
      cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vz cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr vv cv vz cv vy cv cle breq2 vv cv vz cv wceq
      vv cv cF cfv cA cmin co cabs cfv vz cv cF cfv cA cmin co cabs cfv vx cv
      c2 cdiv co clt vv cv vz cv wceq vv cv cF cfv cA cmin co vz cv cF cfv cA
      cmin co cabs vv cv vz cv wceq vv cv cF cfv vz cv cF cfv cA cmin vv cv vz
      cv cF fveq2 opreq1d fveq2d breq1d imbi12d rcla4cva adantl syld imp vy cv
      cn wcel vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vv cn wral vz cv cn wcel wa wa cA vy cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr vy cv vz cv clt wbr vy cv cn wcel vy cv
      vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wi vv cn wral cA vy cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      vz cv cn wcel vy cv cn wcel vy cv vv cv cle wbr vv cv cF cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral wa cA vy cv cF cfv cmin
      co cabs cfv vy cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt vy cv
      cn wcel cA vy cv cF cfv cmin co cabs cfv vy cv cF cfv cA cmin co cabs cfv
      wceq vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv
      co clt wbr wi vv cn wral cA cc wcel vy cv cF cfv cc wcel cA vy cv cF cfv
      cmin co cabs cfv vy cv cF cfv cA cmin co cabs cfv wceq vy cv cn wcel cA
      vy cv cF cfv abssub cA cvv wcel cF cA cli wbr cA cc wcel climcau.1
      climcau.2 cA cvv cF climcl mp2an cn cc vy cv cF climcau.3 ffvelrni
      sylancr adantr vy cv cn wcel vy cv vv cv cle wbr vv cv cF cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vy cv cF cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr vy cv cn wcel vy cv vv cv cle wbr vv cv
      cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vy cv
      vy cv cle wbr vy cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr
      vy cv cn wcel vy cv cr wcel vy cv vy cv cle wbr vy cv nnre vy cv leid syl
      vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vy cv vy cv cle wbr vy cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv
      co clt wbr wi vv vy cv cn vv cv vy cv wceq vy cv vv cv cle wbr vy cv vy
      cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vy
      cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vv cv vy cv vy cv
      cle breq2 vv cv vy cv wceq vv cv cF cfv cA cmin co cabs cfv vy cv cF cfv
      cA cmin co cabs cfv vx cv c2 cdiv co clt vv cv vy cv wceq vv cv cF cfv cA
      cmin co vy cv cF cfv cA cmin co cabs vv cv vy cv wceq vv cv cF cfv vy cv
      cF cfv cA cmin vv cv vy cv cF fveq2 opreq1d fveq2d breq1d imbi12d rcla4v
      mpid imp eqbrtrd adantrr adantr jca adantlll vx cv cr wcel vy cv cn wcel
      wa vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vv cn wral vz cv cn wcel wa wa vz cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr cA vy cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr wa vz cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin
      co cabs cfv caddc co vx cv c2 cdiv co vx cv c2 cdiv co caddc co clt wbr
      wi vy cv vz cv clt wbr vx cv cr wcel vy cv cn wcel wa vz cv cn wcel vz cv
      cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr cA vy cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wa vz cv cF cfv cA cmin co cabs cfv
      cA vy cv cF cfv cmin co cabs cfv caddc co vx cv c2 cdiv co vx cv c2 cdiv
      co caddc co clt wbr wi vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vv cn wral vz cv cF cfv cA cmin co cabs
      cfv cr wcel cA vy cv cF cfv cmin co cabs cfv cr wcel vx cv c2 cdiv co cr
      wcel vx cv c2 cdiv co cr wcel vz cv cF cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr cA vy cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wa vz cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv
      caddc co vx cv c2 cdiv co vx cv c2 cdiv co caddc co clt wbr wi vx cv cr
      wcel vy cv cn wcel wa vz cv cn wcel wa vz cv cF cfv cA cmin co cabs cfv
      cA vy cv cF cfv cmin co cabs cfv vx cv c2 cdiv co vx cv c2 cdiv co lt2add
      vz cv cn wcel vz cv cF cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vy
      cv cn wcel wa vz cv cn wcel vz cv cF cfv cA cmin co cc wcel vz cv cF cfv
      cA cmin co cabs cfv cr wcel vz cv cF cfv cc wcel cA cc wcel vz cv cF cfv
      cA cmin co cc wcel vz cv cn wcel vz cv cF cfv cA subcl cn cc vz cv cF
      climcau.3 ffvelrni cA cvv wcel cF cA cli wbr cA cc wcel climcau.1
      climcau.2 cA cvv cF climcl mp2an sylancl vz cv cF cfv cA cmin co abscl
      syl adantl vy cv cn wcel cA vy cv cF cfv cmin co cabs cfv cr wcel vx cv
      cr wcel vz cv cn wcel vy cv cn wcel cA vy cv cF cfv cmin co cc wcel cA vy
      cv cF cfv cmin co cabs cfv cr wcel cA cc wcel vy cv cF cfv cc wcel cA vy
      cv cF cfv cmin co cc wcel vy cv cn wcel cA vy cv cF cfv subcl cA cvv wcel
      cF cA cli wbr cA cc wcel climcau.1 climcau.2 cA cvv cF climcl mp2an cn cc
      vy cv cF climcau.3 ffvelrni sylancr cA vy cv cF cfv cmin co abscl syl
      ad2antlr vx cv cr wcel vx cv c2 cdiv co cr wcel vy cv cn wcel vz cv cn
      wcel vx cv rehalfcl ad2antrr vx cv cr wcel vx cv c2 cdiv co cr wcel vy cv
      cn wcel vz cv cn wcel vx cv rehalfcl ad2antrr syl2anc adantrl adantr mpd
      vx cv cr wcel vy cv cn wcel wa vx cv c2 cdiv co vx cv c2 cdiv co caddc co
      vx cv wceq vy cv vv cv cle wbr vv cv cF cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vv cn wral vz cv cn wcel wa vy cv vz cv clt wbr vx cv
      cr wcel vx cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv wceq vy cv cn
      wcel vx cv cr wcel vx cv cc wcel vx cv c2 cdiv co vx cv c2 cdiv co caddc
      co vx cv wceq vx cv recn vx cv 2halves syl adantr ad2antrr breqtrd ex vx
      cv cr wcel vy cv cn wcel wa vz cv cn wcel vz cv cF cfv cA cmin co cabs
      cfv cA vy cv cF cfv cmin co cabs cfv caddc co vx cv clt wbr vz cv cF cfv
      vy cv cF cfv cmin co cabs cfv vx cv clt wbr wi vy cv vv cv cle wbr vv cv
      cF cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vv cn wral vx cv
      cr wcel vz cv cn wcel vy cv cn wcel vz cv cF cfv cA cmin co cabs cfv cA
      vy cv cF cfv cmin co cabs cfv caddc co vx cv clt wbr vz cv cF cfv vy cv
      cF cfv cmin co cabs cfv vx cv clt wbr wi vx cv cr wcel vz cv cn wcel wa
      vy cv cn wcel wa vz cv cF cfv vy cv cF cfv cmin co cabs cfv vz cv cF cfv
      cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co cle wbr vz
      cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co
      vx cv clt wbr vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv clt wbr vz
      cv cn wcel vy cv cn wcel vz cv cF cfv vy cv cF cfv cmin co cabs cfv vz cv
      cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co cle
      wbr vx cv cr wcel vz cv cn wcel vy cv cn wcel wa vz cv cF cfv cA cmin co
      cA vy cv cF cfv cmin co caddc co cabs cfv vz cv cF cfv vy cv cF cfv cmin
      co cabs cfv vz cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs
      cfv caddc co cle vz cv cn wcel vy cv cn wcel wa vz cv cF cfv cA cmin co
      cA vy cv cF cfv cmin co caddc co vz cv cF cfv vy cv cF cfv cmin co cabs
      vz cv cF cfv cc wcel vy cv cF cfv cc wcel vz cv cF cfv cA cmin co cA vy
      cv cF cfv cmin co caddc co vz cv cF cfv vy cv cF cfv cmin co wceq vz cv
      cn wcel vy cv cn wcel vz cv cF cfv cc wcel cA cc wcel vy cv cF cfv cc
      wcel vz cv cF cfv cA cmin co cA vy cv cF cfv cmin co caddc co vz cv cF
      cfv vy cv cF cfv cmin co wceq cA cvv wcel cF cA cli wbr cA cc wcel
      climcau.1 climcau.2 cA cvv cF climcl mp2an vz cv cF cfv cA vy cv cF cfv
      npncan mp3an2 cn cc vz cv cF climcau.3 ffvelrni cn cc vy cv cF climcau.3
      ffvelrni syl2an fveq2d vz cv cF cfv cA cmin co cc wcel cA vy cv cF cfv
      cmin co cc wcel vz cv cF cfv cA cmin co cA vy cv cF cfv cmin co caddc co
      cabs cfv vz cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs
      cfv caddc co cle wbr vz cv cn wcel vy cv cn wcel vz cv cF cfv cA cmin co
      cA vy cv cF cfv cmin co abstri vz cv cF cfv cc wcel cA cc wcel vz cv cF
      cfv cA cmin co cc wcel vz cv cn wcel vz cv cF cfv cA subcl cn cc vz cv cF
      climcau.3 ffvelrni cA cvv wcel cF cA cli wbr cA cc wcel climcau.1
      climcau.2 cA cvv cF climcl mp2an sylancl cA cc wcel vy cv cF cfv cc wcel
      cA vy cv cF cfv cmin co cc wcel vy cv cn wcel cA vy cv cF cfv subcl cA
      cvv wcel cF cA cli wbr cA cc wcel climcau.1 climcau.2 cA cvv cF climcl
      mp2an cn cc vy cv cF climcau.3 ffvelrni sylancr syl2an eqbrtrrd adantll
      vz cv cF cfv vy cv cF cfv cmin co cabs cfv cr wcel vz cv cF cfv cA cmin
      co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co cr wcel vx cv cr
      wcel vz cv cF cfv vy cv cF cfv cmin co cabs cfv vz cv cF cfv cA cmin co
      cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co cle wbr vz cv cF cfv
      cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co vx cv clt
      wbr wa vz cv cF cfv vy cv cF cfv cmin co cabs cfv vx cv clt wbr wi vx cv
      cr wcel vz cv cn wcel wa vy cv cn wcel wa vz cv cF cfv vy cv cF cfv cmin
      co cabs cfv vz cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs
      cfv caddc co vx cv lelttr vz cv cn wcel vy cv cn wcel vz cv cF cfv vy cv
      cF cfv cmin co cabs cfv cr wcel vx cv cr wcel vz cv cn wcel vy cv cn wcel
      wa vz cv cF cfv vy cv cF cfv cmin co cc wcel vz cv cF cfv vy cv cF cfv
      cmin co cabs cfv cr wcel vz cv cF cfv cc wcel vy cv cF cfv cc wcel vz cv
      cF cfv vy cv cF cfv cmin co cc wcel vz cv cn wcel vy cv cn wcel vz cv cF
      cfv vy cv cF cfv subcl cn cc vz cv cF climcau.3 ffvelrni cn cc vy cv cF
      climcau.3 ffvelrni syl2an vz cv cF cfv vy cv cF cfv cmin co abscl syl
      adantll vz cv cn wcel vy cv cn wcel vz cv cF cfv cA cmin co cabs cfv cA
      vy cv cF cfv cmin co cabs cfv caddc co cr wcel vx cv cr wcel vz cv cF cfv
      cA cmin co cabs cfv cr wcel cA vy cv cF cfv cmin co cabs cfv cr wcel vz
      cv cF cfv cA cmin co cabs cfv cA vy cv cF cfv cmin co cabs cfv caddc co
      cr wcel vz cv cn wcel vy cv cn wcel vz cv cF cfv cA cmin co cabs cfv cA
      vy cv cF cfv cmin co cabs cfv readdcl vz cv cn wcel vz cv cF cfv cA cmin
      co cc wcel vz cv cF cfv cA cmin co cabs cfv cr wcel vz cv cF cfv cc wcel
      cA cc wcel vz cv cF cfv cA cmin co cc wcel vz cv cn wcel vz cv cF cfv cA
      subcl cn cc vz cv cF climcau.3 ffvelrni cA cvv wcel cF cA cli wbr cA cc
      wcel climcau.1 climcau.2 cA cvv cF climcl mp2an sylancl vz cv cF cfv cA
      cmin co abscl syl vy cv cn wcel cA vy cv cF cfv cmin co cc wcel cA vy cv
      cF cfv cmin co cabs cfv cr wcel cA cc wcel vy cv cF cfv cc wcel cA vy cv
      cF cfv cmin co cc wcel vy cv cn wcel cA vy cv cF cfv subcl cA cvv wcel cF
      cA cli wbr cA cc wcel climcau.1 climcau.2 cA cvv cF climcl mp2an cn cc vy
      cv cF climcau.3 ffvelrni sylancr cA vy cv cF cfv cmin co abscl syl syl2an
      adantll vx cv cr wcel vz cv cn wcel vy cv cn wcel simpll syl3anc mpand
      an1rs adantrl syld exp32 r19.21adv r19.22dva syld rgen $.
      $( [8-Jun-2006] $) $( [16-Apr-2005] $)
  $}

  ${
    $d x y z w u v t f F $.  $d x z w t f S $.
    caucvg.1 $e |- F : NN --> RR $.
    caucvg.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    caucvg.3 $e |- S = { u e. RR | E. v e. NN A. y e. NN (
                      v <_ y -> u < ( F ` y ) ) } $.
    ${
        $d y v u A $.
      $( Lemma for ~ caucvgi .  This lemma shows the membership relation for
         ` S ` . $)
      caucvglem1 $p |- ( A e. S <-> ( A e. RR /\ E. v e. NN A. y e. NN (
                        v <_ y -> A < ( F ` y ) ) ) ) $=
        vv cv vy cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex
        vv cv vy cv cle wbr cA vy cv cF cfv clt wbr wi vy cn wral vv cn wrex vu
        cA cr cS vu cv cA wceq vv cv vy cv cle wbr vu cv vy cv cF cfv clt wbr
        wi vv cv vy cv cle wbr cA vy cv cF cfv clt wbr wi vv vy cn cn vu cv cA
        wceq vu cv vy cv cF cfv clt wbr cA vy cv cF cfv clt wbr vv cv vy cv cle
        wbr vu cv cA vy cv cF cfv clt breq1 imbi2d rexralbidv caucvg.3 elrab2
        $.
        $( [12-May-2005] $) $( [6-Apr-2005] $)
    $}

    $( Lemma for ~ caucvgi .  ` S ` is a nonempty bounded subset of
       ` RR ` . $)
    caucvglem2 $p |- ( S C_ RR /\ S =/= (/) /\ E. x e. RR A. f e. S f <_ x ) $=
      cS cr wss cS c0 wne vf cv vx cv cle wbr vf cS wral vx cr wrex cS vv cv vy
      cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex vu cr crab
      cr caucvg.3 vv cv vy cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral
      vv cn wrex vu cr ssrab2 eqsstri vy cv cF cfv cabs cfv vx cv clt wbr vy cn
      wral vx cr wrex cS c0 wne vx vy vz vw cF cn cr cF wf cr cc wss cn cc cF
      wf caucvg.1 axresscn cn cr cc cF fss mp2an caucvg.2 caubndi vy cv cF cfv
      cabs cfv vx cv clt wbr vy cn wral cS c0 wne vx cr vx cv cr wcel vy cv cF
      cfv cabs cfv vx cv clt wbr vy cn wral vx cv cneg cS wcel cS c0 wne vx cv
      cr wcel vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vx cv cneg cr wcel
      vv cv vy cv cle wbr vx cv cneg vy cv cF cfv clt wbr wi vy cn wral vv cn
      wrex wa vx cv cneg cS wcel vx cv cr wcel vy cv cF cfv cabs cfv vx cv clt
      wbr vy cn wral vv cv vy cv cle wbr vx cv cneg vy cv cF cfv clt wbr wi vy
      cn wral vv cn wrex vx cv cneg cr wcel vx cv cr wcel vy cv cF cfv cabs cfv
      vx cv clt wbr vy cn wral c1 cn wcel c1 vy cv cle wbr vx cv cneg vy cv cF
      cfv clt wbr wi vy cn wral wa vv cv vy cv cle wbr vx cv cneg vy cv cF cfv
      clt wbr wi vy cn wral vv cn wrex vx cv cr wcel vy cv cF cfv cabs cfv vx
      cv clt wbr vy cn wral c1 vy cv cle wbr vx cv cneg vy cv cF cfv clt wbr wi
      vy cn wral c1 cn wcel vx cv cr wcel vy cv cF cfv cabs cfv vx cv clt wbr
      c1 vy cv cle wbr vx cv cneg vy cv cF cfv clt wbr wi vy cn vx cv cr wcel
      vy cv cn wcel wa vy cv cF cfv cabs cfv vx cv clt wbr vx cv cneg vy cv cF
      cfv clt wbr c1 vy cv cle wbr vy cv cn wcel vx cv cr wcel vy cv cF cfv
      cabs cfv vx cv clt wbr vx cv cneg vy cv cF cfv clt wbr wi vy cv cF cfv cr
      wcel vx cv cr wcel vy cv cF cfv cabs cfv vx cv clt wbr vx cv cneg vy cv
      cF cfv clt wbr wi vy cv cn wcel vy cv cF cfv cr wcel vx cv cr wcel wa vy
      cv cF cfv cabs cfv vx cv clt wbr vx cv cneg vy cv cF cfv clt wbr vy cv cF
      cfv vx cv clt wbr wa vx cv cneg vy cv cF cfv clt wbr vy cv cF cfv vx cv
      abslt vx cv cneg vy cv cF cfv clt wbr vy cv cF cfv vx cv clt wbr pm3.26
      syl6bi cn cr vy cv cF caucvg.1 ffvelrni sylan ancoms a1dd r19.20dva c1 cn
      wcel vx cv cr wcel 1nn a1i jctild vv cv vy cv cle wbr vx cv cneg vy cv cF
      cfv clt wbr wi vy cn wral c1 vy cv cle wbr vx cv cneg vy cv cF cfv clt
      wbr wi vy cn wral vv c1 cn vv cv c1 wceq vv cv vy cv cle wbr vx cv cneg
      vy cv cF cfv clt wbr wi c1 vy cv cle wbr vx cv cneg vy cv cF cfv clt wbr
      wi vy cn vv cv c1 wceq vv cv vy cv cle wbr c1 vy cv cle wbr vx cv cneg vy
      cv cF cfv clt wbr vv cv c1 vy cv cle breq1 imbi1d ralbidv rcla4ev syl6 vx
      cv renegcl jctild vy vz vw vv vu vx cv cneg cS cF caucvg.1 caucvg.2
      caucvg.3 caucvglem1 syl6ibr cS vx cv cneg ne0i syl6 r19.23aiv ax-mp vy cv
      cF cfv cabs cfv vx cv clt wbr vy cn wral vx cr wrex vf cv vx cv cle wbr
      vf cS wral vx cr wrex vx vy vz vw cF cn cr cF wf cr cc wss cn cc cF wf
      caucvg.1 axresscn cn cr cc cF fss mp2an caucvg.2 caubndi vy cv cF cfv
      cabs cfv vx cv clt wbr vy cn wral vf cv vx cv cle wbr vf cS wral vx cr vx
      cv cr wcel vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vf cv vx cv cle
      wbr vf cS vf cv cS wcel vx cv cr wcel vy cv cF cfv cabs cfv vx cv clt wbr
      vy cn wral vf cv vx cv cle wbr vf cv cS wcel vf cv cr wcel vv cv vy cv
      cle wbr vf cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex wa vx cv cr
      wcel vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vf cv vx cv cle wbr
      wi wi vy vz vw vv vu vf cv cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem1 vf
      cv cr wcel vv cv vy cv cle wbr vf cv vy cv cF cfv clt wbr wi vy cn wral
      vv cn wrex vx cv cr wcel vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral
      vf cv vx cv cle wbr wi wi vf cv cr wcel vv cv vy cv cle wbr vf cv vy cv
      cF cfv clt wbr wi vy cn wral vx cv cr wcel vy cv cF cfv cabs cfv vx cv
      clt wbr vy cn wral vf cv vx cv cle wbr wi wi vv cn vf cv cr wcel vv cv cn
      wcel vx cv cr wcel vv cv vy cv cle wbr vf cv vy cv cF cfv clt wbr wi vy
      cn wral vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vf cv vx cv cle
      wbr wi vf cv cr wcel vv cv cn wcel vx cv cr wcel vv cv vy cv cle wbr vf
      cv vy cv cF cfv clt wbr wi vy cn wral vy cv cF cfv cabs cfv vx cv clt wbr
      vy cn wral vf cv vx cv cle wbr wi wi vf cv cr wcel vv cv cn wcel vx cv cr
      wcel w3a vv cv vy cv cle wbr vf cv vy cv cF cfv clt wbr wi vy cn wral vy
      cv cF cfv cabs cfv vx cv clt wbr vy cn wral vf cv vx cv cle wbr vf cv cr
      wcel vv cv cn wcel vx cv cr wcel w3a vv cv vy cv cle wbr vf cv vy cv cF
      cfv clt wbr wi vy cn wral vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral
      wa vf cv vv cv cF cfv clt wbr vv cv cF cfv vx cv clt wbr wa vf cv vx cv
      clt wbr vf cv vx cv cle wbr vv cv cn wcel vx cv cr wcel vv cv vy cv cle
      wbr vf cv vy cv cF cfv clt wbr wi vy cn wral vy cv cF cfv cabs cfv vx cv
      clt wbr vy cn wral wa vf cv vv cv cF cfv clt wbr vv cv cF cfv vx cv clt
      wbr wa wi vf cv cr wcel vv cv cn wcel vx cv cr wcel wa vv cv vy cv cle
      wbr vf cv vy cv cF cfv clt wbr wi vy cn wral vf cv vv cv cF cfv clt wbr
      vy cv cF cfv cabs cfv vx cv clt wbr vy cn wral vv cv cF cfv vx cv clt wbr
      vv cv cn wcel vv cv vy cv cle wbr vf cv vy cv cF cfv clt wbr wi vy cn
      wral vf cv vv cv cF cfv clt wbr wi vx cv cr wcel vv cv cn wcel vv cv vy
      cv cle wbr vf cv vy cv cF cfv clt wbr wi vy cn wral vv cv vv cv cle wbr
      vf cv vv cv cF cfv clt wbr vv cv cn wcel vv cv cr wcel vv cv vv cv cle
      wbr vv cv nnre vv cv leid syl vv cv vy cv cle wbr vf cv vy cv cF cfv clt
      wbr wi vv cv vv cv cle wbr vf cv vv cv cF cfv clt wbr wi vy vv cv cn vy
      cv vv cv wceq vv cv vy cv cle wbr vv cv vv cv cle wbr vf cv vy cv cF cfv
      clt wbr vf cv vv cv cF cfv clt wbr vy cv vv cv vv cv cle breq2 vy cv vv
      cv wceq vy cv cF cfv vv cv cF cfv vf cv clt vy cv vv cv cF fveq2 breq2d
      imbi12d rcla4v mpid adantr vv cv cn wcel vx cv cr wcel wa vy cv cF cfv
      cabs cfv vx cv clt wbr vy cn wral vv cv cF cfv cabs cfv vx cv clt wbr vv
      cv cF cfv vx cv clt wbr vv cv cn wcel vy cv cF cfv cabs cfv vx cv clt wbr
      vy cn wral vv cv cF cfv cabs cfv vx cv clt wbr wi vx cv cr wcel vy cv cF
      cfv cabs cfv vx cv clt wbr vv cv cF cfv cabs cfv vx cv clt wbr vy vv cv
      cn vy cv vv cv wceq vy cv cF cfv cabs cfv vv cv cF cfv cabs cfv vx cv clt
      vy cv vv cv wceq vy cv cF cfv vv cv cF cfv cabs vy cv vv cv cF fveq2
      fveq2d breq1d rcla4v adantr vv cv cn wcel vx cv cr wcel wa vv cv cF cfv
      cabs cfv vx cv clt wbr vx cv cneg vv cv cF cfv clt wbr vv cv cF cfv vx cv
      clt wbr wa vv cv cF cfv vx cv clt wbr vv cv cF cfv cr wcel vx cv cr wcel
      vv cv cF cfv cabs cfv vx cv clt wbr vx cv cneg vv cv cF cfv clt wbr vv cv
      cF cfv vx cv clt wbr wa wb vv cv cn wcel vv cv cF cfv vx cv abslt cn cr
      vv cv cF caucvg.1 ffvelrni sylan vx cv cneg vv cv cF cfv clt wbr vv cv cF
      cfv vx cv clt wbr pm3.27 syl6bi syld anim12d 3adant1 vf cv cr wcel vv cv
      cF cfv cr wcel vx cv cr wcel vf cv vv cv cF cfv clt wbr vv cv cF cfv vx
      cv clt wbr wa vf cv vx cv clt wbr wi vv cv cn wcel vf cv vv cv cF cfv vx
      cv axlttrn cn cr vv cv cF caucvg.1 ffvelrni syl3an2 vf cv cr wcel vx cv
      cr wcel vf cv vx cv clt wbr vf cv vx cv cle wbr wi vv cv cn wcel vf cv vx
      cv ltle 3adant2 3syld exp3a 3exp com34 r19.23adv imp sylbi com3l
      r19.21adv r19.22i ax-mp 3pm3.2i $.
      $( [18-Jun-2007] $) $( [6-Apr-2005] $)

    $( Lemma for ~ caucvgi .  The supremum of ` S ` is a real number. $)
    caucvglem3 $p |- sup ( S , RR , < ) e. RR $=
      vx vf cS vx vy vz vw vv vu cS vf cF caucvg.1 caucvg.2 caucvg.3 caucvglem2
      suprclii $.
      $( [12-May-2005] $) $( [6-Apr-2005] $)

    ${
      $d y v u t A $.
      $( Lemma for ~ caucvgi .  Anything less that the supremum of ` S `
         belongs to ` S ` . $)
      caucvglem4 $p |- ( A e. RR -> ( A < sup ( S , RR , < ) -> A e. S ) ) $=
        cA cr wcel cA cS cr clt csup clt wbr cA vt cv clt wbr vt cS wrex cA cS
        wcel cA cr wcel cA cS cr clt csup clt wbr cA vt cv clt wbr vt cS wrex
        vx vf vt cS cA vx vy vz vw vv vu cS vf cF caucvg.1 caucvg.2 caucvg.3
        caucvglem2 suprlubii ex cA cr wcel cA vt cv clt wbr cA cS wcel vt cS cA
        cr wcel cA vt cv clt wbr vt cv cS wcel cA cS wcel cA cr wcel cA vt cv
        clt wbr vt cv cS wcel cA cS wcel wi cA cr wcel cA vt cv clt wbr wa vt
        cv cr wcel vv cv vy cv cle wbr vt cv vy cv cF cfv clt wbr wi vy cn wral
        vv cn wrex wa cA cr wcel vv cv vy cv cle wbr cA vy cv cF cfv clt wbr wi
        vy cn wral vv cn wrex wa vt cv cS wcel cA cS wcel cA cr wcel cA vt cv
        clt wbr wa vt cv cr wcel vv cv vy cv cle wbr vt cv vy cv cF cfv clt wbr
        wi vy cn wral vv cn wrex wa vv cv vy cv cle wbr cA vy cv cF cfv clt wbr
        wi vy cn wral vv cn wrex cA cr wcel cA cr wcel cA vt cv clt wbr wa vt
        cv cr wcel vv cv vy cv cle wbr vt cv vy cv cF cfv clt wbr wi vy cn wral
        vv cn wrex vv cv vy cv cle wbr cA vy cv cF cfv clt wbr wi vy cn wral vv
        cn wrex cA cr wcel cA vt cv clt wbr wa vt cv cr wcel wa vv cv vy cv cle
        wbr vt cv vy cv cF cfv clt wbr wi vy cn wral vv cv vy cv cle wbr cA vy
        cv cF cfv clt wbr wi vy cn wral vv cn cA cr wcel cA vt cv clt wbr wa vt
        cv cr wcel wa vv cv vy cv cle wbr vt cv vy cv cF cfv clt wbr wi vv cv
        vy cv cle wbr cA vy cv cF cfv clt wbr wi vy cn cA cr wcel cA vt cv clt
        wbr wa vt cv cr wcel wa vy cv cn wcel wa vt cv vy cv cF cfv clt wbr cA
        vy cv cF cfv clt wbr vv cv vy cv cle wbr cA cr wcel cA vt cv clt wbr vt
        cv cr wcel vy cv cn wcel vt cv vy cv cF cfv clt wbr cA vy cv cF cfv clt
        wbr wi vt cv cr wcel vy cv cn wcel cA cr wcel cA vt cv clt wbr vt cv vy
        cv cF cfv clt wbr cA vy cv cF cfv clt wbr wi cA cr wcel vt cv cr wcel
        vy cv cn wcel cA vt cv clt wbr vt cv vy cv cF cfv clt wbr cA vy cv cF
        cfv clt wbr wi wi cA cr wcel vt cv cr wcel vy cv cn wcel cA vt cv clt
        wbr vt cv vy cv cF cfv clt wbr cA vy cv cF cfv clt wbr wi wi cA cr wcel
        vt cv cr wcel vy cv cn wcel w3a cA vt cv clt wbr vt cv vy cv cF cfv clt
        wbr cA vy cv cF cfv clt wbr cA cr wcel vt cv cr wcel vy cv cF cfv cr
        wcel cA vt cv clt wbr vt cv vy cv cF cfv clt wbr wa cA vy cv cF cfv clt
        wbr wi vy cv cn wcel cA vt cv vy cv cF cfv axlttrn cn cr vy cv cF
        caucvg.1 ffvelrni syl3an3 exp3a 3exp com3l com4t imp41 imim2d r19.20dva
        r19.22sdv expimpd cA cr wcel cA vt cv clt wbr pm3.26 jctild vy vz vw vv
        vu vt cv cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem1 vy vz vw vv vu cA
        cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem1 3imtr4g ex com23 r19.23adv
        syld $.
        $( [13-May-2005] $) $( [6-Apr-2005] $)
    $}

    $( Lemma for ~ caucvgi . $)
    caucvglem5 $p |- ( ( x e. RR /\ w e. NN ) -> ( A. y e. NN
      ( w < y -> ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < ( x / 2 ) ) ->
      -u ( x / 2 ) <_ ( sup ( S , RR , < ) - ( F ` w ) ) ) ) $=
      vx cv c2 cdiv co cr wcel vw cv cn wcel vw cv vy cv clt wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vx
      cv c2 cdiv co cneg cS cr clt csup vw cv cF cfv cmin co cle wbr wi vx cv
      cr wcel vx cv c2 cdiv co cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vx cv c2 cdiv co cneg vw cv cF cfv caddc co cS cr clt csup cle wbr
      vx cv c2 cdiv co cneg cS cr clt csup vw cv cF cfv cmin co cle wbr vx cv
      c2 cdiv co cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vx cv
      c2 cdiv co cneg vw cv cF cfv caddc co cr wcel vv cv vy cv cle wbr vx cv
      c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral
      vv cn wrex wa vx cv c2 cdiv co cneg vw cv cF cfv caddc co cS cr clt csup
      cle wbr vx cv c2 cdiv co cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vv cv vy cv cle wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc co vy
      cv cF cfv clt wbr wi vy cn wral vv cn wrex vx cv c2 cdiv co cneg vw cv cF
      cfv caddc co cr wcel vx cv c2 cdiv co cr wcel vw cv cn wcel wa vw cv vy
      cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral vw cv c1 caddc co cn wcel vw cv c1 caddc co vy cv
      cle wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr
      wi vy cn wral wa vv cv vy cv cle wbr vx cv c2 cdiv co cneg vw cv cF cfv
      caddc co vy cv cF cfv clt wbr wi vy cn wral vv cn wrex vx cv c2 cdiv co
      cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cv c1 caddc co
      vy cv cle wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv
      clt wbr wi vy cn wral vw cv c1 caddc co cn wcel vx cv c2 cdiv co cr wcel
      vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vw cv c1 caddc co vy cv cle wbr vx
      cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn vx
      cv c2 cdiv co cr wcel vw cv cn wcel wa vy cv cn wcel wa vw cv c1 caddc co
      vy cv cle wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc co
      vy cv cF cfv clt wbr vw cv cn wcel vy cv cn wcel vw cv c1 caddc co vy cv
      cle wbr vw cv vy cv clt wbr wi vx cv c2 cdiv co cr wcel vw cv cn wcel vy
      cv cn wcel wa vw cv vy cv clt wbr vw cv c1 caddc co vy cv cle wbr vw cv
      vy cv nnltp1le biimprd adantll vx cv c2 cdiv co cr wcel vw cv cn wcel vy
      cv cn wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr
      wi vx cv c2 cdiv co cr wcel vw cv cn wcel vy cv cF cfv cr wcel vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv
      co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cv cn wcel vx cv
      c2 cdiv co cr wcel vw cv cF cfv cr wcel vy cv cF cfv cr wcel vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv co
      cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vw cv cn wcel vx cv c2
      cdiv co cr wcel vw cv cF cfv cr wcel vy cv cF cfv cr wcel w3a vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv
      co cneg vy cv cF cfv vw cv cF cfv cmin co clt wbr vx cv c2 cdiv co cneg
      vw cv cF cfv caddc co vy cv cF cfv clt wbr vy cv cF cfv cr wcel vw cv cF
      cfv cr wcel vx cv c2 cdiv co cr wcel vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv co cneg vy cv cF cfv vw
      cv cF cfv cmin co clt wbr wi vy cv cF cfv cr wcel vw cv cF cfv cr wcel vx
      cv c2 cdiv co cr wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr vx cv c2 cdiv co cneg vy cv cF cfv vw cv cF cfv cmin co
      clt wbr wi vy cv cF cfv vw cv cF cfv cmin co cr wcel vx cv c2 cdiv co cr
      wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      vx cv c2 cdiv co cneg vy cv cF cfv vw cv cF cfv cmin co clt wbr wi vy cv
      cF cfv cr wcel vw cv cF cfv cr wcel wa vy cv cF cfv vw cv cF cfv cmin co
      cr wcel vx cv c2 cdiv co cr wcel wa vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv co cneg vy cv cF cfv vw
      cv cF cfv cmin co clt wbr vy cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv
      co clt wbr wa vx cv c2 cdiv co cneg vy cv cF cfv vw cv cF cfv cmin co clt
      wbr vy cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv co abslt vx cv c2
      cdiv co cneg vy cv cF cfv vw cv cF cfv cmin co clt wbr vy cv cF cfv vw cv
      cF cfv cmin co vx cv c2 cdiv co clt wbr pm3.26 syl6bi vy cv cF cfv vw cv
      cF cfv resubcl sylan 3impa 3com13 vx cv c2 cdiv co cneg cr wcel vw cv cF
      cfv cr wcel vy cv cF cfv cr wcel vx cv c2 cdiv co cneg vw cv cF cfv caddc
      co vy cv cF cfv clt wbr vx cv c2 cdiv co cneg vy cv cF cfv vw cv cF cfv
      cmin co clt wbr wb vx cv c2 cdiv co cr wcel vx cv c2 cdiv co cneg vw cv
      cF cfv vy cv cF cfv ltaddsub vx cv c2 cdiv co renegcl syl3an1 sylibrd cn
      cr vw cv cF caucvg.1 ffvelrni syl3an2 cn cr vy cv cF caucvg.1 ffvelrni
      syl3an3 3expa imim12d r19.20dva vw cv cn wcel vw cv c1 caddc co cn wcel
      vx cv c2 cdiv co cr wcel vw cv peano2nn adantl jctild vv cv vy cv cle wbr
      vx cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn
      wral vw cv c1 caddc co vy cv cle wbr vx cv c2 cdiv co cneg vw cv cF cfv
      caddc co vy cv cF cfv clt wbr wi vy cn wral vv vw cv c1 caddc co cn vv cv
      vw cv c1 caddc co wceq vv cv vy cv cle wbr vx cv c2 cdiv co cneg vw cv cF
      cfv caddc co vy cv cF cfv clt wbr wi vw cv c1 caddc co vy cv cle wbr vx
      cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn vv
      cv vw cv c1 caddc co wceq vv cv vy cv cle wbr vw cv c1 caddc co vy cv cle
      wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc co vy cv cF cfv clt wbr vv
      cv vw cv c1 caddc co vy cv cle breq1 imbi1d ralbidv rcla4ev syl6 vx cv c2
      cdiv co cneg cr wcel vw cv cF cfv cr wcel vx cv c2 cdiv co cneg vw cv cF
      cfv caddc co cr wcel vx cv c2 cdiv co cr wcel vw cv cn wcel vx cv c2 cdiv
      co cneg vw cv cF cfv readdcl vx cv c2 cdiv co renegcl cn cr vw cv cF
      caucvg.1 ffvelrni syl2an jctild vx cv c2 cdiv co cneg vw cv cF cfv caddc
      co cr wcel vv cv vy cv cle wbr vx cv c2 cdiv co cneg vw cv cF cfv caddc
      co vy cv cF cfv clt wbr wi vy cn wral vv cn wrex wa vx cv c2 cdiv co cneg
      vw cv cF cfv caddc co cS wcel vx cv c2 cdiv co cneg vw cv cF cfv caddc co
      cS cr clt csup cle wbr vy vz vw vv vu vx cv c2 cdiv co cneg vw cv cF cfv
      caddc co cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem1 vx vf cS vx cv c2
      cdiv co cneg vw cv cF cfv caddc co vx vy vz vw vv vu cS vf cF caucvg.1
      caucvg.2 caucvg.3 caucvglem2 suprubii sylbir syl6 vx cv c2 cdiv co cneg
      cr wcel vw cv cF cfv cr wcel vx cv c2 cdiv co cneg vw cv cF cfv caddc co
      cS cr clt csup cle wbr vx cv c2 cdiv co cneg cS cr clt csup vw cv cF cfv
      cmin co cle wbr wb vx cv c2 cdiv co cr wcel vw cv cn wcel vx cv c2 cdiv
      co cneg cr wcel vw cv cF cfv cr wcel cS cr clt csup cr wcel vx cv c2 cdiv
      co cneg vw cv cF cfv caddc co cS cr clt csup cle wbr vx cv c2 cdiv co
      cneg cS cr clt csup vw cv cF cfv cmin co cle wbr wb vy vz vw vv vu cS cF
      caucvg.1 caucvg.2 caucvg.3 caucvglem3 vx cv c2 cdiv co cneg vw cv cF cfv
      cS cr clt csup leaddsub mp3an3 vx cv c2 cdiv co renegcl cn cr vw cv cF
      caucvg.1 ffvelrni syl2an sylibd vx cv rehalfcl sylan $.
      $( [13-May-2005] $) $( [8-Apr-2005] $)

    $( Lemma for ~ caucvgi . $)
    caucvglem6 $p |- ( ( x e. RR /\ w e. NN ) -> ( A. y e. NN
      ( w < y -> ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < ( x / 2 ) ) ->
      ( sup ( S , RR , < ) - ( F ` w ) ) <_ ( x / 2 ) ) ) $=
      vx cv c2 cdiv co cr wcel vw cv cn wcel vw cv vy cv clt wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral cS
      cr clt csup vw cv cF cfv cmin co vx cv c2 cdiv co cle wbr wi vx cv cr
      wcel vx cv c2 cdiv co cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral cS cr clt csup vx cv c2 cdiv co vw cv cF cfv caddc co cle wbr cS cr
      clt csup vw cv cF cfv cmin co vx cv c2 cdiv co cle wbr vx cv c2 cdiv co
      cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vx cv c2 cdiv co
      vw cv cF cfv caddc co cS cr clt csup clt wbr wn cS cr clt csup vx cv c2
      cdiv co vw cv cF cfv caddc co cle wbr vx cv c2 cdiv co cr wcel vw cv cn
      wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx
      cv c2 cdiv co clt wbr wi vy cn wral vv cv vy cv cle wbr vx cv c2 cdiv co
      vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral vv cn wrex wn vx
      cv c2 cdiv co vw cv cF cfv caddc co cS cr clt csup clt wbr wn vx cv c2
      cdiv co cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vv cv vy
      cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi
      vy cn wral vv cn wrex wn vx cv c2 cdiv co cr wcel vw cv cn wcel wa vw cv
      vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral wa vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF
      cfv caddc co vy cv cF cfv clt wbr wi vy cn wral vv cn vx cv c2 cdiv co cr
      wcel vw cv cn wcel wa vv cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vv cv
      vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr
      wi vy cn wral wn vx cv c2 cdiv co cr wcel vw cv cn wcel wa vv cv cn wcel
      wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv
      c2 cdiv co clt wbr wi vy cn wral vv cv vy cv cle wbr vx cv c2 cdiv co vw
      cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral wn vx cv c2 cdiv co
      cr wcel vw cv cn wcel wa vv cv cn wcel wa vw cv vv cv caddc co vy cv cle
      wbr vy cn wrex vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vy cn wral vv cv vy cv cle wbr vx cv c2
      cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral wn wi vw
      cv cn wcel vv cv cn wcel vw cv vv cv caddc co vy cv cle wbr vy cn wrex vx
      cv c2 cdiv co cr wcel vw cv vv cv caddc co cn wcel vw cv vv cv caddc co
      vw cv vv cv caddc co cle wbr vw cv vv cv caddc co vy cv cle wbr vy cn
      wrex vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co vy cv cle wbr vw
      cv vv cv caddc co vw cv vv cv caddc co cle wbr vy vw cv vv cv caddc co cn
      vy cv vw cv vv cv caddc co vw cv vv cv caddc co cle breq2 rcla4ev vw cv
      vv cv nnaddcl vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co cr wcel
      vw cv vv cv caddc co vw cv vv cv caddc co cle wbr vw cv cn wcel vv cv cn
      wcel wa vw cv vv cv caddc co cn wcel vw cv vv cv caddc co cr wcel vw cv
      vv cv nnaddcl vw cv vv cv caddc co nnre syl vw cv vv cv caddc co leid syl
      sylanc adantll vx cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel vw cv
      vv cv caddc co vy cv cle wbr vy cn wrex vw cv vy cv clt wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vv
      cv vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt
      wbr wi vy cn wral wn wi wi vx cv c2 cdiv co cr wcel vw cv cn wcel vv cv
      cn wcel wa wa vw cv vv cv caddc co vy cv cle wbr vw cv vy cv clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF
      cfv clt wbr wi vy cn wral wn wi vy cn vx cv c2 cdiv co cr wcel vw cv cn
      wcel vv cv cn wcel wa wa vy ax-17 vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vv cv vy
      cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi
      vy cn wral wn vy vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vy cn hbra1 vv cv vy cv cle wbr vx
      cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral vy
      vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv
      clt wbr wi vy cn hbra1 hbn hbim vy cv cn wcel vx cv c2 cdiv co cr wcel vw
      cv cn wcel vv cv cn wcel wa wa vw cv vv cv caddc co vy cv cle wbr vw cv
      vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv
      caddc co vy cv cF cfv clt wbr wi vy cn wral wn wi wi vy cv cn wcel vx cv
      c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel wa wa vw cv vv cv caddc co
      vy cv cle wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vy cn wral vv cv vy cv cle wbr vx cv c2
      cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral wn wi vy
      cv cn wcel vx cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel wa wa vw
      cv vv cv caddc co vy cv cle wbr wa wa vw cv vy cv clt wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vx cv
      c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr vv cv vy cv cle wbr
      vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral
      vy cv cn wcel vx cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel wa wa
      vw cv vv cv caddc co vy cv cle wbr wa wa vy cv cn wcel vw cv vy cv clt
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wi wi vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn vw
      cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv
      co clt wbr wi vy cn wral vy cv cn wcel vw cv vy cv clt wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi wi vy cv cn
      wcel vx cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel wa wa vw cv vv
      cv caddc co vy cv cle wbr wa wa vx cv c2 cdiv co vw cv cF cfv caddc co vy
      cv cF cfv clt wbr wn vy cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi wi vy cv cn wcel vx
      cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel wa wa vw cv vv cv caddc
      co vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt
      wbr wn vy cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vx cv c2 cdiv co cr wcel vw cv cn
      wcel vv cv cn wcel wa wa vw cv vv cv caddc co vy cv cle wbr vx cv c2 cdiv
      co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn wi wi vy cv cn wcel vx
      cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel wa wa vw cv vy cv clt
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wi vw cv vv cv caddc co vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc
      co vy cv cF cfv clt wbr wn wi vy cv cn wcel vx cv c2 cdiv co cr wcel vw
      cv cn wcel vv cv cn wcel wa wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vw cv vv cv caddc co vy
      cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn
      wi wi vy cv cn wcel vx cv c2 cdiv co cr wcel vw cv cn wcel vv cv cn wcel
      wa wa wa vw cv vv cv caddc co vy cv cle wbr vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv
      co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn vy cv cn wcel vw cv cn
      wcel vv cv cn wcel wa vw cv vv cv caddc co vy cv cle wbr vw cv vy cv clt
      wbr wi vx cv c2 cdiv co cr wcel vy cv cr wcel vw cv cn wcel vv cv cn wcel
      wa vw cv vv cv caddc co vy cv cle wbr vw cv vy cv clt wbr wi vy cv cn
      wcel vy cv cr wcel vw cv cn wcel vv cv cn wcel wa wa vw cv vw cv vv cv
      caddc co clt wbr vw cv vv cv caddc co vy cv cle wbr vw cv vy cv clt wbr
      vw cv cn wcel vv cv cn wcel wa vw cv vw cv vv cv caddc co clt wbr vy cv
      cr wcel vw cv cn wcel vv cv cn wcel wa cc0 vv cv clt wbr vw cv vw cv vv
      cv caddc co clt wbr vv cv cn wcel cc0 vv cv clt wbr vw cv cn wcel vv cv
      nngt0 adantl vw cv cr wcel vv cv cr wcel cc0 vv cv clt wbr vw cv vw cv vv
      cv caddc co clt wbr wb vw cv cn wcel vv cv cn wcel vv cv cr wcel vw cv cr
      wcel cc0 vv cv clt wbr vw cv vw cv vv cv caddc co clt wbr wb vv cv vw cv
      ltaddpos ancoms vw cv nnre vv cv nnre syl2an mpbid adantl vw cv cr wcel
      vw cv vv cv caddc co cr wcel vy cv cr wcel vw cv vw cv vv cv caddc co clt
      wbr vw cv vv cv caddc co vy cv cle wbr wa vw cv vy cv clt wbr wi vy cv cr
      wcel vw cv cn wcel vv cv cn wcel wa wa vw cv vw cv vv cv caddc co vy cv
      ltletr vw cv cn wcel vw cv cr wcel vy cv cr wcel vv cv cn wcel vw cv nnre
      ad2antrl vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co cr wcel vy
      cv cr wcel vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co cn wcel vw
      cv vv cv caddc co cr wcel vw cv vv cv nnaddcl vw cv vv cv caddc co nnre
      syl adantl vy cv cr wcel vw cv cn wcel vv cv cn wcel wa pm3.26 syl3anc
      mpand vy cv nnre sylan adantrl vy cv cn wcel vx cv c2 cdiv co cr wcel vw
      cv cn wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn wi
      vv cv cn wcel vy cv cn wcel vx cv c2 cdiv co cr wcel vw cv cF cfv cr wcel
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv
      c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn wi vw cv cn wcel
      vy cv cF cfv cr wcel vx cv c2 cdiv co cr wcel vw cv cF cfv cr wcel wa vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2
      cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wn wi vy cv cn wcel vy
      cv cF cfv cr wcel vx cv c2 cdiv co cr wcel vw cv cF cfv cr wcel wa wa vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vy cv cF
      cfv vx cv c2 cdiv co vw cv cF cfv caddc co clt wbr vx cv c2 cdiv co vw cv
      cF cfv caddc co vy cv cF cfv clt wbr wn vy cv cF cfv cr wcel vx cv c2
      cdiv co cr wcel vw cv cF cfv cr wcel wa wa vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr vy cv cF cfv vw cv cF cfv cmin co vx
      cv c2 cdiv co clt wbr vy cv cF cfv vx cv c2 cdiv co vw cv cF cfv caddc co
      clt wbr vx cv c2 cdiv co cr wcel vy cv cF cfv cr wcel vw cv cF cfv cr
      wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      vy cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv co clt wbr wi vx cv c2
      cdiv co cr wcel vy cv cF cfv vw cv cF cfv cmin co cr wcel vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vy cv cF cfv vw cv cF
      cfv cmin co vx cv c2 cdiv co clt wbr wi vy cv cF cfv cr wcel vw cv cF cfv
      cr wcel wa vy cv cF cfv vw cv cF cfv cmin co cr wcel vx cv c2 cdiv co cr
      wcel vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      vy cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv co clt wbr wi vy cv cF
      cfv vw cv cF cfv cmin co cr wcel vx cv c2 cdiv co cr wcel wa vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv co
      cneg vy cv cF cfv vw cv cF cfv cmin co clt wbr vy cv cF cfv vw cv cF cfv
      cmin co vx cv c2 cdiv co clt wbr wa vy cv cF cfv vw cv cF cfv cmin co vx
      cv c2 cdiv co clt wbr vy cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv co
      abslt vx cv c2 cdiv co cneg vy cv cF cfv vw cv cF cfv cmin co clt wbr vy
      cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv co clt wbr pm3.27 syl6bi
      ancoms vy cv cF cfv vw cv cF cfv resubcl sylan2 an1s vy cv cF cfv cr wcel
      vx cv c2 cdiv co cr wcel vw cv cF cfv cr wcel vy cv cF cfv vw cv cF cfv
      cmin co vx cv c2 cdiv co clt wbr vy cv cF cfv vx cv c2 cdiv co vw cv cF
      cfv caddc co clt wbr wb vy cv cF cfv cr wcel vw cv cF cfv cr wcel vx cv
      c2 cdiv co cr wcel vy cv cF cfv vw cv cF cfv cmin co vx cv c2 cdiv co clt
      wbr vy cv cF cfv vx cv c2 cdiv co vw cv cF cfv caddc co clt wbr wb vy cv
      cF cfv vw cv cF cfv vx cv c2 cdiv co ltsubadd 3com23 3expb sylibd vy cv
      cF cfv cr wcel vx cv c2 cdiv co vw cv cF cfv caddc co cr wcel vy cv cF
      cfv vx cv c2 cdiv co vw cv cF cfv caddc co clt wbr vx cv c2 cdiv co vw cv
      cF cfv caddc co vy cv cF cfv clt wbr wn wi vx cv c2 cdiv co cr wcel vw cv
      cF cfv cr wcel wa vy cv cF cfv vx cv c2 cdiv co vw cv cF cfv caddc co
      ltnsym vx cv c2 cdiv co vw cv cF cfv readdcl sylan2 syld cn cr vy cv cF
      caucvg.1 ffvelrni sylan cn cr vw cv cF caucvg.1 ffvelrni sylanr2 adantrrr
      imim12d ex com23 a2i imp4d com12 vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn ra4 syl5 vy cv
      cn wcel vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co vy cv cle wbr
      vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv
      clt wbr wi vy cn wral vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv
      clt wbr wi vx cv c2 cdiv co cr wcel vy cv cn wcel vw cv cn wcel vv cv cn
      wcel wa vw cv vv cv caddc co vy cv cle wbr wa wa vy cv cn wcel vv cv vy
      cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi
      wi vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr vv cv vy
      cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi
      vy cn wral vy cv cn wcel vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF
      cfv caddc co vy cv cF cfv clt wbr wi wi vy cv cn wcel vw cv cn wcel vv cv
      cn wcel wa vw cv vv cv caddc co vy cv cle wbr wa wa vx cv c2 cdiv co vw
      cv cF cfv caddc co vy cv cF cfv clt wbr vy cv cn wcel vv cv vy cv cle wbr
      vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi wi vy cv
      cn wcel vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co vy cv cle wbr
      vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr vy cv cn wcel
      vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv
      clt wbr wi vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co vy cv cle
      wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi wi vy
      cv cn wcel vw cv cn wcel vv cv cn wcel wa vv cv vy cv cle wbr vx cv c2
      cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vw cv vv cv caddc
      co vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt
      wbr wi vy cv cn wcel vw cv cn wcel vv cv cn wcel wa vv cv vy cv cle wbr
      vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vw cv vv
      cv caddc co vy cv cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF
      cfv clt wbr wi wi vy cv cn wcel vw cv cn wcel vv cv cn wcel wa wa vw cv
      vv cv caddc co vy cv cle wbr vv cv vy cv cle wbr vx cv c2 cdiv co vw cv
      cF cfv caddc co vy cv cF cfv clt wbr vw cv cn wcel vv cv cn wcel wa vy cv
      cn wcel vw cv vv cv caddc co vy cv cle wbr vv cv vy cv cle wbr wi vw cv
      cn wcel vv cv cn wcel wa vy cv cr wcel vw cv vv cv caddc co vy cv cle wbr
      vv cv vy cv cle wbr wi vy cv cn wcel vw cv cn wcel vv cv cn wcel wa vy cv
      cr wcel wa vw cv vv cv caddc co vy cv cle wbr vv cv vy cv clt wbr vv cv
      vy cv cle wbr vw cv cn wcel vv cv cn wcel wa vy cv cr wcel wa vv cv vw cv
      vv cv caddc co clt wbr vw cv vv cv caddc co vy cv cle wbr vv cv vy cv clt
      wbr vw cv cn wcel vv cv cn wcel wa vv cv vw cv vv cv caddc co clt wbr vy
      cv cr wcel vw cv cn wcel vv cv cn wcel wa cc0 vw cv clt wbr vv cv vw cv
      vv cv caddc co clt wbr vw cv cn wcel cc0 vw cv clt wbr vv cv cn wcel vw
      cv nngt0 adantr vw cv cr wcel vv cv cr wcel cc0 vw cv clt wbr vv cv vw cv
      vv cv caddc co clt wbr wb vw cv cn wcel vv cv cn wcel vw cv vv cv
      ltaddpos2 vw cv nnre vv cv nnre syl2an mpbid adantr vv cv cr wcel vw cv
      vv cv caddc co cr wcel vy cv cr wcel vv cv vw cv vv cv caddc co clt wbr
      vw cv vv cv caddc co vy cv cle wbr wa vv cv vy cv clt wbr wi vw cv cn
      wcel vv cv cn wcel wa vy cv cr wcel wa vv cv vw cv vv cv caddc co vy cv
      ltletr vv cv cn wcel vv cv cr wcel vw cv cn wcel vy cv cr wcel vv cv nnre
      ad2antlr vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co cr wcel vy
      cv cr wcel vw cv cn wcel vv cv cn wcel wa vw cv vv cv caddc co cn wcel vw
      cv vv cv caddc co cr wcel vw cv vv cv nnaddcl vw cv vv cv caddc co nnre
      syl adantr vw cv cn wcel vv cv cn wcel wa vy cv cr wcel pm3.27 syl3anc
      mpand vv cv cn wcel vy cv cr wcel vv cv vy cv clt wbr vv cv vy cv cle wbr
      wi vw cv cn wcel vv cv cr wcel vy cv cr wcel vv cv vy cv clt wbr vv cv vy
      cv cle wbr wi vv cv cn wcel vv cv vy cv ltle vv cv nnre sylan adantll
      syld vy cv nnre sylan2 ancoms imim1d ex com23 a2i imp4d com12 vv cv vy cv
      cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy
      cn ra4 syl5 adantrll nsyld exp32 com12 r19.23ad anassrs mpd imp an1rs
      nrexdv ex vx cv c2 cdiv co cr wcel vw cv cn wcel wa vx cv c2 cdiv co vw
      cv cF cfv caddc co cr wcel vv cv vy cv cle wbr vx cv c2 cdiv co vw cv cF
      cfv caddc co vy cv cF cfv clt wbr wi vy cn wral vv cn wrex wn vx cv c2
      cdiv co vw cv cF cfv caddc co cS cr clt csup clt wbr wn wi vx cv c2 cdiv
      co cr wcel vw cv cF cfv cr wcel vx cv c2 cdiv co vw cv cF cfv caddc co cr
      wcel vw cv cn wcel vx cv c2 cdiv co vw cv cF cfv readdcl cn cr vw cv cF
      caucvg.1 ffvelrni sylan2 vx cv c2 cdiv co vw cv cF cfv caddc co cr wcel
      vx cv c2 cdiv co vw cv cF cfv caddc co cS cr clt csup clt wbr vv cv vy cv
      cle wbr vx cv c2 cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy
      cn wral vv cn wrex vx cv c2 cdiv co vw cv cF cfv caddc co cr wcel vx cv
      c2 cdiv co vw cv cF cfv caddc co cS cr clt csup clt wbr vx cv c2 cdiv co
      vw cv cF cfv caddc co cS wcel vv cv vy cv cle wbr vx cv c2 cdiv co vw cv
      cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral vv cn wrex vy vz vw vv
      vu vx cv c2 cdiv co vw cv cF cfv caddc co cS cF caucvg.1 caucvg.2
      caucvg.3 caucvglem4 vx cv c2 cdiv co vw cv cF cfv caddc co cS wcel vx cv
      c2 cdiv co vw cv cF cfv caddc co cr wcel vv cv vy cv cle wbr vx cv c2
      cdiv co vw cv cF cfv caddc co vy cv cF cfv clt wbr wi vy cn wral vv cn
      wrex vy vz vw vv vu vx cv c2 cdiv co vw cv cF cfv caddc co cS cF caucvg.1
      caucvg.2 caucvg.3 caucvglem1 pm3.27bi syl6 con3d syl syld cS cr clt csup
      cr wcel vx cv c2 cdiv co vw cv cF cfv caddc co cr wcel cS cr clt csup vx
      cv c2 cdiv co vw cv cF cfv caddc co cle wbr vx cv c2 cdiv co vw cv cF cfv
      caddc co cS cr clt csup clt wbr wn wb vx cv c2 cdiv co cr wcel vw cv cn
      wcel wa cS cr clt csup vx cv c2 cdiv co vw cv cF cfv caddc co lenlt vy vz
      vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem3 vx cv c2 cdiv co cr
      wcel vw cv cF cfv cr wcel vx cv c2 cdiv co vw cv cF cfv caddc co cr wcel
      vw cv cn wcel vx cv c2 cdiv co vw cv cF cfv readdcl cn cr vw cv cF
      caucvg.1 ffvelrni sylan2 sylancr sylibrd vw cv cn wcel vx cv c2 cdiv co
      cr wcel cS cr clt csup vw cv cF cfv cmin co vx cv c2 cdiv co cle wbr cS
      cr clt csup vx cv c2 cdiv co vw cv cF cfv caddc co cle wbr wb vw cv cF
      cfv cr wcel vx cv c2 cdiv co cr wcel cS cr clt csup vw cv cF cfv cmin co
      vx cv c2 cdiv co cle wbr cS cr clt csup vx cv c2 cdiv co vw cv cF cfv
      caddc co cle wbr wb vw cv cn wcel cS cr clt csup cr wcel vw cv cF cfv cr
      wcel vx cv c2 cdiv co cr wcel cS cr clt csup vw cv cF cfv cmin co vx cv
      c2 cdiv co cle wbr cS cr clt csup vx cv c2 cdiv co vw cv cF cfv caddc co
      cle wbr wb vy vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem3 cS
      cr clt csup vw cv cF cfv vx cv c2 cdiv co lesubadd mp3an1 cn cr vw cv cF
      caucvg.1 ffvelrni sylan ancoms sylibrd vx cv rehalfcl sylan $.
      $( [13-May-2005] $) $( [8-Apr-2005] $)

    $( A Cauchy sequence of real numbers converges.  The second hypothesis
       specifies that ` F ` is a Cauchy sequence.  ` S ` is the set of numbers
       less than all values of ` F ` except for finitely many.  Reference:
       Bert G. Wachsmuth,
       ~ http://www.shu.edu/projects/reals/numseq/proofs/cauconv.html .
       _Request: Please contact Norm Megill if you know of a textbook
       reference for the version of the proof in the link above_.
       _Warning:  The HTML proof page is 1/2 megabyte in size_. $)
    caucvgi $p |- F ~~> sup ( S , RR , < ) $=
      cF cS cr clt csup cli wbr cc0 vx cv clt wbr vw cv vt cv cle wbr vt cv cF
      cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vt cn wral vw cn
      wrex wi vx cr wral cc0 vx cv clt wbr vw cv vt cv clt wbr vt cv cF cfv cS
      cr clt csup cmin co cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex wi vx
      cr wral cc0 vx cv clt wbr vw cv vt cv cle wbr vt cv cF cfv cS cr clt csup
      cmin co cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex wi vx cr wral cc0
      vz cv clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral cc0 vx cv clt
      wbr vw cv vt cv clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx
      cv clt wbr wi vt cn wral vw cn wrex wi vx cr wral caucvg.2 cc0 vz cv clt
      wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi vz cr wral cc0 vx cv clt wbr vw cv vt
      cv clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi
      vt cn wral vw cn wrex wi vx cr cc0 vz cv clt wbr vw cv vy cv clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr
      vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vy cn wral vw cn wrex wi wi vx cv cr wcel cc0 vx cv
      clt wbr vw cv vt cv clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv
      vx cv clt wbr wi vt cn wral vw cn wrex wi wi cc0 vz cv clt wbr vw cv vy
      cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy
      cn wral vw cn wrex wi cc0 vx cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vw cn wrex wi vz vx cv c2 cdiv co cr vz cv vx cv c2 cdiv co wceq cc0
      vz cv clt wbr cc0 vx cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vy cn wral vw cn wrex vz cv vx cv c2 cdiv co cc0 clt
      breq2 vz cv vx cv c2 cdiv co wceq vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vz cv clt wbr wi vw cv vy cv clt wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vw vy cn cn vz
      cv vx cv c2 cdiv co wceq vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt
      wbr vw cv vy cv clt wbr vz cv vx cv c2 cdiv co vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv clt breq2 imbi2d rexralbidv imbi12d rcla4cv vx cv c2
      cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral
      vw cn wrex wi wi vx cv cr wcel cc0 vx cv clt wbr vw cv vt cv clt wbr vt
      cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vt cn wral vw
      cn wrex vx cv cr wcel cc0 vx cv clt wbr wa vx cv c2 cdiv co cr wcel cc0
      vx cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cn wrex wi wi
      vw cv vt cv clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv
      clt wbr wi vt cn wral vw cn wrex vx cv cr wcel cc0 vx cv clt wbr wa vx cv
      c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vw cn wrex wi wi vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cn wrex vw cv vt cv
      clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vt
      cn wral vw cn wrex vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr
      vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vy cn wral vw cn wrex vx cv c2 cdiv co cr wcel cc0 vx
      cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cn wrex wi wi wb vx
      cv cr wcel cc0 vx cv clt wbr wa vx cv c2 cdiv co cr wcel cc0 vx cv c2
      cdiv co clt wbr wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cn wrex vx cv c2 cdiv
      co cr wcel cc0 vx cv c2 cdiv co clt wbr wa vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral
      vw cn wrex wi vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr vw cv
      vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral vw cn wrex wi wi vx cv c2 cdiv co cr wcel cc0 vx cv
      c2 cdiv co clt wbr wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cn wrex biimt vx cv
      c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vw cn wrex impexp syl6bb vx cv cr wcel vx cv c2 cdiv co cr wcel cc0
      vx cv clt wbr vx cv rehalfcl adantr vx cv cr wcel cc0 vx cv clt wbr cc0
      vx cv c2 cdiv co clt wbr vx cv halfpos2 biimpa sylanc vx cv cr wcel vw cv
      vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral vw cn wrex vw cv vt cv clt wbr vt cv cF cfv cS cr
      clt csup cmin co cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex wi cc0
      vx cv clt wbr vx cv cr wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vw cv vt cv clt
      wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vt cn
      wral vw cn vx cv cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral
      vw cv vt cv clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv
      clt wbr wi vt cn vx cv cr wcel vw cv cn wcel wa vw cv vt cv clt wbr vt cv
      cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx
      cv c2 cdiv co clt wbr wi vy cn wral vt cv cF cfv cS cr clt csup cmin co
      cabs cfv vx cv clt wbr vx cv cr wcel vw cv cn wcel wa vw cv vt cv clt wbr
      vt cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vy cn wral vt cv cF cfv cS cr clt csup
      cmin co cabs cfv vx cv clt wbr wi vx cv cr wcel vw cv cn wcel wa vw cv vt
      cv clt wbr vt cv cn wcel wa wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vt cv cF cfv
      cS cr clt csup cmin co cabs cfv vx cv c2 cdiv co vt cv cF cfv vw cv cF
      cfv cmin co cabs cfv caddc co cle wbr vx cv c2 cdiv co vt cv cF cfv vw cv
      cF cfv cmin co cabs cfv caddc co vx cv clt wbr wa vt cv cF cfv cS cr clt
      csup cmin co cabs cfv vx cv clt wbr vx cv cr wcel vw cv cn wcel wa vw cv
      vt cv clt wbr vt cv cn wcel wa wa vw cv vy cv clt wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vt cv cF
      cfv cS cr clt csup cmin co cabs cfv vx cv c2 cdiv co vt cv cF cfv vw cv
      cF cfv cmin co cabs cfv caddc co cle wbr vx cv c2 cdiv co vt cv cF cfv vw
      cv cF cfv cmin co cabs cfv caddc co vx cv clt wbr vx cv cr wcel vw cv cn
      wcel wa vt cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vt cv cF cfv cS cr clt
      csup cmin co cabs cfv vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv caddc co cle wbr wi vw cv vt cv clt wbr vx cv cr wcel vw cv cn
      wcel wa vt cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral cS cr clt csup vw
      cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv
      caddc co vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv
      caddc co cle wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv c2
      cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cle wbr vx cv
      cr wcel vw cv cn wcel wa vt cv cn wcel wa vw cv vy cv clt wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral
      cS cr clt csup vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co cle wbr cS
      cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin
      co cabs cfv caddc co vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv caddc co cle wbr vx cv cr wcel vw cv cn wcel wa vw cv vy cv clt
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wi vy cn wral cS cr clt csup vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv
      co cle wbr wi vt cv cn wcel vx cv cr wcel vw cv cn wcel wa vw cv vy cv
      clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vy cn wral vx cv c2 cdiv co cneg cS cr clt csup vw cv cF cfv cmin
      co cle wbr cS cr clt csup vw cv cF cfv cmin co vx cv c2 cdiv co cle wbr
      wa cS cr clt csup vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co cle wbr
      vx cv cr wcel vw cv cn wcel wa vw cv vy cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn wral vx cv c2 cdiv
      co cneg cS cr clt csup vw cv cF cfv cmin co cle wbr cS cr clt csup vw cv
      cF cfv cmin co vx cv c2 cdiv co cle wbr vx vy vz vw vv vu cS cF caucvg.1
      caucvg.2 caucvg.3 caucvglem5 vx vy vz vw vv vu cS cF caucvg.1 caucvg.2
      caucvg.3 caucvglem6 jcad cS cr clt csup vw cv cF cfv cmin co cr wcel vx
      cv c2 cdiv co cr wcel cS cr clt csup vw cv cF cfv cmin co cabs cfv vx cv
      c2 cdiv co cle wbr vx cv c2 cdiv co cneg cS cr clt csup vw cv cF cfv cmin
      co cle wbr cS cr clt csup vw cv cF cfv cmin co vx cv c2 cdiv co cle wbr
      wa wb vx cv cr wcel vw cv cn wcel wa cS cr clt csup vw cv cF cfv cmin co
      vx cv c2 cdiv co absle vw cv cn wcel cS cr clt csup vw cv cF cfv cmin co
      cr wcel vx cv cr wcel cS cr clt csup cr wcel vw cv cF cfv cr wcel cS cr
      clt csup vw cv cF cfv cmin co cr wcel vw cv cn wcel cS cr clt csup vw cv
      cF cfv resubcl vy vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem3
      cn cr vw cv cF caucvg.1 ffvelrni sylancr adantl vx cv cr wcel vx cv c2
      cdiv co cr wcel vw cv cn wcel vx cv rehalfcl adantr sylanc sylibrd adantr
      cS cr clt csup vw cv cF cfv cmin co cabs cfv cr wcel vx cv c2 cdiv co cr
      wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel cS cr clt csup vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co cle wbr cS cr clt csup vw cv
      cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc
      co vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co
      cle wbr wb vx cv cr wcel vw cv cn wcel wa vt cv cn wcel wa cS cr clt csup
      vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv leadd1 vw cv cn wcel cS cr clt csup vw cv cF cfv cmin co
      cabs cfv cr wcel vx cv cr wcel vt cv cn wcel vw cv cn wcel cS cr clt csup
      vw cv cF cfv cmin co cc wcel cS cr clt csup vw cv cF cfv cmin co cabs cfv
      cr wcel vw cv cn wcel cS cr clt csup vw cv cF cfv cmin co cS cr clt csup
      cr wcel vw cv cF cfv cr wcel cS cr clt csup vw cv cF cfv cmin co cr wcel
      vw cv cn wcel cS cr clt csup vw cv cF cfv resubcl vy vz vw vv vu cS cF
      caucvg.1 caucvg.2 caucvg.3 caucvglem3 cn cr vw cv cF caucvg.1 ffvelrni
      sylancr recnd cS cr clt csup vw cv cF cfv cmin co abscl syl ad2antlr vx
      cv cr wcel vx cv c2 cdiv co cr wcel vw cv cn wcel vt cv cn wcel vx cv
      rehalfcl ad2antrr vw cv cn wcel vt cv cn wcel vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv cr wcel vx cv cr wcel vw cv cn wcel vt cv cn wcel wa vt
      cv cF cfv vw cv cF cfv cmin co cc wcel vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv cr wcel vw cv cn wcel vt cv cn wcel wa vt cv cF cfv vw cv cF cfv
      cmin co vt cv cn wcel vw cv cn wcel vt cv cF cfv vw cv cF cfv cmin co cr
      wcel vt cv cF cfv cr wcel vw cv cF cfv cr wcel vt cv cF cfv vw cv cF cfv
      cmin co cr wcel vt cv cn wcel vw cv cn wcel vt cv cF cfv vw cv cF cfv
      resubcl cn cr vt cv cF caucvg.1 ffvelrni cn cr vw cv cF caucvg.1 ffvelrni
      syl2an ancoms recnd vt cv cF cfv vw cv cF cfv cmin co abscl syl adantll
      syl3anc sylibd vx cv cr wcel vw cv cn wcel wa vt cv cn wcel wa vt cv cF
      cfv cS cr clt csup cmin co cabs cfv cS cr clt csup vw cv cF cfv cmin co
      cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cle wbr cS
      cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin
      co cabs cfv caddc co vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv caddc co cle wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx
      cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cle wbr
      vw cv cn wcel vt cv cn wcel vt cv cF cfv cS cr clt csup cmin co cabs cfv
      cS cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv caddc co cle wbr vx cv cr wcel vw cv cn wcel vt cv cn
      wcel wa cS cr clt csup vt cv cF cfv cmin co cabs cfv cS cr clt csup vw cv
      cF cfv cmin co cabs cfv vw cv cF cfv vt cv cF cfv cmin co cabs cfv caddc
      co vt cv cF cfv cS cr clt csup cmin co cabs cfv cS cr clt csup vw cv cF
      cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co
      cle vw cv cn wcel vt cv cn wcel wa cS cr clt csup vw cv cF cfv cmin co vw
      cv cF cfv vt cv cF cfv cmin co caddc co cabs cfv cS cr clt csup vt cv cF
      cfv cmin co cabs cfv cS cr clt csup vw cv cF cfv cmin co cabs cfv vw cv
      cF cfv vt cv cF cfv cmin co cabs cfv caddc co cle vw cv cn wcel vt cv cn
      wcel wa cS cr clt csup vw cv cF cfv cmin co vw cv cF cfv vt cv cF cfv
      cmin co caddc co cS cr clt csup vt cv cF cfv cmin co cabs vw cv cF cfv cc
      wcel vt cv cF cfv cc wcel cS cr clt csup vw cv cF cfv cmin co vw cv cF
      cfv vt cv cF cfv cmin co caddc co cS cr clt csup vt cv cF cfv cmin co
      wceq vw cv cn wcel vt cv cn wcel cS cr clt csup cc wcel vw cv cF cfv cc
      wcel vt cv cF cfv cc wcel cS cr clt csup vw cv cF cfv cmin co vw cv cF
      cfv vt cv cF cfv cmin co caddc co cS cr clt csup vt cv cF cfv cmin co
      wceq cS cr clt csup vy vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3
      caucvglem3 recni cS cr clt csup vw cv cF cfv vt cv cF cfv npncan mp3an1
      vw cv cn wcel vw cv cF cfv cn cr vw cv cF caucvg.1 ffvelrni recnd vt cv
      cn wcel vt cv cF cfv cn cr vt cv cF caucvg.1 ffvelrni recnd syl2an fveq2d
      cS cr clt csup vw cv cF cfv cmin co cc wcel vw cv cF cfv vt cv cF cfv
      cmin co cc wcel cS cr clt csup vw cv cF cfv cmin co vw cv cF cfv vt cv cF
      cfv cmin co caddc co cabs cfv cS cr clt csup vw cv cF cfv cmin co cabs
      cfv vw cv cF cfv vt cv cF cfv cmin co cabs cfv caddc co cle wbr vw cv cn
      wcel vt cv cn wcel wa cS cr clt csup vw cv cF cfv cmin co vw cv cF cfv vt
      cv cF cfv cmin co abstri vw cv cn wcel cS cr clt csup vw cv cF cfv cmin
      co cc wcel vt cv cn wcel vw cv cn wcel cS cr clt csup vw cv cF cfv cmin
      co cS cr clt csup cr wcel vw cv cF cfv cr wcel cS cr clt csup vw cv cF
      cfv cmin co cr wcel vw cv cn wcel cS cr clt csup vw cv cF cfv resubcl vy
      vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem3 cn cr vw cv cF
      caucvg.1 ffvelrni sylancr recnd adantr vw cv cn wcel vt cv cn wcel wa vw
      cv cF cfv vt cv cF cfv cmin co vw cv cF cfv cr wcel vt cv cF cfv cr wcel
      vw cv cF cfv vt cv cF cfv cmin co cr wcel vw cv cn wcel vt cv cn wcel vw
      cv cF cfv vt cv cF cfv resubcl cn cr vw cv cF caucvg.1 ffvelrni cn cr vt
      cv cF caucvg.1 ffvelrni syl2an recnd sylanc eqbrtrrd vt cv cn wcel cS cr
      clt csup vt cv cF cfv cmin co cabs cfv vt cv cF cfv cS cr clt csup cmin
      co cabs cfv wceq vw cv cn wcel cS cr clt csup cc wcel vt cv cF cfv cc
      wcel cS cr clt csup vt cv cF cfv cmin co cabs cfv vt cv cF cfv cS cr clt
      csup cmin co cabs cfv wceq vt cv cn wcel cS cr clt csup vt cv cF cfv
      abssub cS cr clt csup vy vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3
      caucvglem3 recni vt cv cn wcel vt cv cF cfv cn cr vt cv cF caucvg.1
      ffvelrni recnd sylancr adantl vw cv cn wcel vt cv cn wcel wa vw cv cF cfv
      vt cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv
      cS cr clt csup vw cv cF cfv cmin co cabs cfv caddc vw cv cF cfv cc wcel
      vt cv cF cfv cc wcel vw cv cF cfv vt cv cF cfv cmin co cabs cfv vt cv cF
      cfv vw cv cF cfv cmin co cabs cfv wceq vw cv cn wcel vt cv cn wcel vw cv
      cF cfv vt cv cF cfv abssub vw cv cn wcel vw cv cF cfv cn cr vw cv cF
      caucvg.1 ffvelrni recnd vt cv cn wcel vt cv cF cfv cn cr vt cv cF
      caucvg.1 ffvelrni recnd syl2an opreq2d 3brtr3d adantll vt cv cF cfv cS cr
      clt csup cmin co cabs cfv cr wcel cS cr clt csup vw cv cF cfv cmin co
      cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cr wcel vx
      cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cr wcel
      vt cv cF cfv cS cr clt csup cmin co cabs cfv cS cr clt csup vw cv cF cfv
      cmin co cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cle
      wbr cS cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF
      cfv cmin co cabs cfv caddc co vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv caddc co cle wbr wa vt cv cF cfv cS cr clt csup cmin co
      cabs cfv vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv
      caddc co cle wbr wi vx cv cr wcel vw cv cn wcel wa vt cv cn wcel wa vt cv
      cF cfv cS cr clt csup cmin co cabs cfv cS cr clt csup vw cv cF cfv cmin
      co cabs cfv vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co vx cv c2
      cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co letr vt cv cn
      wcel vt cv cF cfv cS cr clt csup cmin co cabs cfv cr wcel vx cv cr wcel
      vw cv cn wcel wa vt cv cn wcel vt cv cF cfv cS cr clt csup cmin co cc
      wcel vt cv cF cfv cS cr clt csup cmin co cabs cfv cr wcel vt cv cn wcel
      vt cv cF cfv cS cr clt csup cmin co vt cv cF cfv cr wcel cS cr clt csup
      cr wcel vt cv cF cfv cS cr clt csup cmin co cr wcel vt cv cn wcel vt cv
      cF cfv cS cr clt csup resubcl cn cr vt cv cF caucvg.1 ffvelrni vy vz vw
      vv vu cS cF caucvg.1 caucvg.2 caucvg.3 caucvglem3 sylancl recnd vt cv cF
      cfv cS cr clt csup cmin co abscl syl adantl vw cv cn wcel vt cv cn wcel
      cS cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv caddc co cr wcel vx cv cr wcel cS cr clt csup vw cv cF
      cfv cmin co cabs cfv cr wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv
      cr wcel cS cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv
      cF cfv cmin co cabs cfv caddc co cr wcel vw cv cn wcel vt cv cn wcel wa
      cS cr clt csup vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv readdcl vw cv cn wcel cS cr clt csup vw cv cF cfv cmin
      co cabs cfv cr wcel vt cv cn wcel vw cv cn wcel cS cr clt csup vw cv cF
      cfv cmin co cc wcel cS cr clt csup vw cv cF cfv cmin co cabs cfv cr wcel
      vw cv cn wcel cS cr clt csup vw cv cF cfv cmin co cS cr clt csup cr wcel
      vw cv cF cfv cr wcel cS cr clt csup vw cv cF cfv cmin co cr wcel vw cv cn
      wcel cS cr clt csup vw cv cF cfv resubcl vy vz vw vv vu cS cF caucvg.1
      caucvg.2 caucvg.3 caucvglem3 cn cr vw cv cF caucvg.1 ffvelrni sylancr
      recnd cS cr clt csup vw cv cF cfv cmin co abscl syl adantr vw cv cn wcel
      vt cv cn wcel wa vt cv cF cfv vw cv cF cfv cmin co cc wcel vt cv cF cfv
      vw cv cF cfv cmin co cabs cfv cr wcel vw cv cn wcel vt cv cn wcel wa vt
      cv cF cfv vw cv cF cfv cmin co vt cv cn wcel vw cv cn wcel vt cv cF cfv
      vw cv cF cfv cmin co cr wcel vt cv cF cfv cr wcel vw cv cF cfv cr wcel vt
      cv cF cfv vw cv cF cfv cmin co cr wcel vt cv cn wcel vw cv cn wcel vt cv
      cF cfv vw cv cF cfv resubcl cn cr vt cv cF caucvg.1 ffvelrni cn cr vw cv
      cF caucvg.1 ffvelrni syl2an ancoms recnd vt cv cF cfv vw cv cF cfv cmin
      co abscl syl sylanc adantll vx cv cr wcel vw cv cn wcel vt cv cn wcel vx
      cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cr wcel
      vx cv c2 cdiv co cr wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv cr
      wcel vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co
      cr wcel vx cv cr wcel vw cv cn wcel vt cv cn wcel wa vx cv c2 cdiv co vt
      cv cF cfv vw cv cF cfv cmin co cabs cfv readdcl vx cv rehalfcl vw cv cn
      wcel vt cv cn wcel wa vt cv cF cfv vw cv cF cfv cmin co cc wcel vt cv cF
      cfv vw cv cF cfv cmin co cabs cfv cr wcel vw cv cn wcel vt cv cn wcel wa
      vt cv cF cfv vw cv cF cfv cmin co vt cv cn wcel vw cv cn wcel vt cv cF
      cfv vw cv cF cfv cmin co cr wcel vt cv cF cfv cr wcel vw cv cF cfv cr
      wcel vt cv cF cfv vw cv cF cfv cmin co cr wcel vt cv cn wcel vw cv cn
      wcel vt cv cF cfv vw cv cF cfv resubcl cn cr vt cv cF caucvg.1 ffvelrni
      cn cr vw cv cF caucvg.1 ffvelrni syl2an ancoms recnd vt cv cF cfv vw cv
      cF cfv cmin co abscl syl syl2an anassrs syl3anc mpand syld adantrl vx cv
      cr wcel vw cv cn wcel wa vw cv vt cv clt wbr vt cv cn wcel wa wa vw cv vy
      cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral vt cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs
      cfv caddc co vx cv clt wbr vw cv vt cv clt wbr vt cv cn wcel wa vw cv vy
      cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co
      clt wbr wi vy cn wral vt cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vx cv cr wcel vw cv cn wcel wa vw cv vt cv clt wbr vt
      cv cn wcel vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vx cv c2 cdiv co clt wbr wi vy cn wral vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vt cv cn wcel vw cv vy cv clt wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy cn
      wral vw cv vt cv clt wbr vt cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv
      c2 cdiv co clt wbr vw cv vy cv clt wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vw cv vt cv clt wbr vt cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vy vt cv cn vy cv
      vt cv wceq vw cv vy cv clt wbr vw cv vt cv clt wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co clt wbr vy cv vt cv vw cv clt breq2 vy
      cv vt cv wceq vy cv cF cfv vw cv cF cfv cmin co cabs cfv vt cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt vy cv vt cv wceq vy cv cF
      cfv vw cv cF cfv cmin co vt cv cF cfv vw cv cF cfv cmin co cabs vy cv vt
      cv wceq vy cv cF cfv vt cv cF cfv vw cv cF cfv cmin vy cv vt cv cF fveq2
      opreq1d fveq2d breq1d imbi12d rcla4v com3r imp adantl vx cv cr wcel vw cv
      cn wcel wa vw cv vt cv clt wbr vt cv cn wcel wa wa vt cv cF cfv vw cv cF
      cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr vx cv c2 cdiv co vt cv cF
      cfv vw cv cF cfv cmin co cabs cfv caddc co vx cv c2 cdiv co vx cv c2 cdiv
      co caddc co clt wbr vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv caddc co vx cv clt wbr vx cv cr wcel vw cv cn wcel wa vt cv cn
      wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv c2 cdiv co clt wbr
      vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co vx
      cv c2 cdiv co vx cv c2 cdiv co caddc co clt wbr wb vw cv vt cv clt wbr vt
      cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vx cv c2 cdiv co cr wcel
      vx cv c2 cdiv co cr wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv
      c2 cdiv co clt wbr vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv caddc co vx cv c2 cdiv co vx cv c2 cdiv co caddc co clt wbr wb
      vx cv cr wcel vw cv cn wcel wa vt cv cn wcel wa vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv c2 cdiv co vx cv c2 cdiv co ltadd2 vw cv cn wcel
      vt cv cn wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vx cv cr
      wcel vw cv cn wcel vt cv cn wcel wa vt cv cF cfv vw cv cF cfv cmin co cc
      wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vw cv cn wcel vt
      cv cn wcel wa vt cv cF cfv vw cv cF cfv cmin co vt cv cn wcel vw cv cn
      wcel vt cv cF cfv vw cv cF cfv cmin co cr wcel vt cv cF cfv cr wcel vw cv
      cF cfv cr wcel vt cv cF cfv vw cv cF cfv cmin co cr wcel vt cv cn wcel vw
      cv cn wcel vt cv cF cfv vw cv cF cfv resubcl cn cr vt cv cF caucvg.1
      ffvelrni cn cr vw cv cF caucvg.1 ffvelrni syl2an ancoms recnd vt cv cF
      cfv vw cv cF cfv cmin co abscl syl adantll vx cv cr wcel vx cv c2 cdiv co
      cr wcel vw cv cn wcel vt cv cn wcel vx cv rehalfcl ad2antrr vx cv cr wcel
      vx cv c2 cdiv co cr wcel vw cv cn wcel vt cv cn wcel vx cv rehalfcl
      ad2antrr syl3anc adantrl vx cv cr wcel vw cv cn wcel wa vw cv vt cv clt
      wbr vt cv cn wcel wa wa vx cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv
      vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co clt
      vx cv cr wcel vx cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv wceq vw cv
      cn wcel vw cv vt cv clt wbr vt cv cn wcel wa vx cv cr wcel vx cv cc wcel
      vx cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv wceq vx cv recn vx cv
      2halves syl ad2antrr breq2d bitrd sylibd jcad vx cv cr wcel vw cv cn wcel
      wa vt cv cn wcel vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv c2
      cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cle wbr vx cv
      c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co vx cv clt
      wbr wa vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vw
      cv vt cv clt wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv cr wcel vx
      cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cr wcel
      vx cv cr wcel vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv c2 cdiv
      co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cle wbr vx cv c2
      cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co vx cv clt wbr
      wa vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vx cv cr
      wcel vw cv cn wcel wa vt cv cn wcel wa vt cv cF cfv cS cr clt csup cmin
      co cabs cfv vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv cmin co cabs cfv
      caddc co vx cv lelttr vt cv cn wcel vt cv cF cfv cS cr clt csup cmin co
      cabs cfv cr wcel vx cv cr wcel vw cv cn wcel wa vt cv cn wcel vt cv cF
      cfv cS cr clt csup cmin co cc wcel vt cv cF cfv cS cr clt csup cmin co
      cabs cfv cr wcel vt cv cn wcel vt cv cF cfv cS cr clt csup cmin co vt cv
      cF cfv cr wcel cS cr clt csup cr wcel vt cv cF cfv cS cr clt csup cmin co
      cr wcel vt cv cn wcel vt cv cF cfv cS cr clt csup resubcl cn cr vt cv cF
      caucvg.1 ffvelrni vy vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3
      caucvglem3 sylancl recnd vt cv cF cfv cS cr clt csup cmin co abscl syl
      adantl vx cv cr wcel vw cv cn wcel vt cv cn wcel vx cv c2 cdiv co vt cv
      cF cfv vw cv cF cfv cmin co cabs cfv caddc co cr wcel vx cv c2 cdiv co cr
      wcel vt cv cF cfv vw cv cF cfv cmin co cabs cfv cr wcel vx cv c2 cdiv co
      vt cv cF cfv vw cv cF cfv cmin co cabs cfv caddc co cr wcel vx cv cr wcel
      vw cv cn wcel vt cv cn wcel wa vx cv c2 cdiv co vt cv cF cfv vw cv cF cfv
      cmin co cabs cfv readdcl vx cv rehalfcl vw cv cn wcel vt cv cn wcel wa vt
      cv cF cfv vw cv cF cfv cmin co cc wcel vt cv cF cfv vw cv cF cfv cmin co
      cabs cfv cr wcel vw cv cn wcel vt cv cn wcel wa vt cv cF cfv vw cv cF cfv
      cmin co vt cv cn wcel vw cv cn wcel vt cv cF cfv vw cv cF cfv cmin co cr
      wcel vt cv cF cfv cr wcel vw cv cF cfv cr wcel vt cv cF cfv vw cv cF cfv
      cmin co cr wcel vt cv cn wcel vw cv cn wcel vt cv cF cfv vw cv cF cfv
      resubcl cn cr vt cv cF caucvg.1 ffvelrni cn cr vw cv cF caucvg.1 ffvelrni
      syl2an ancoms recnd vt cv cF cfv vw cv cF cfv cmin co abscl syl syl2an
      anassrs vx cv cr wcel vw cv cn wcel vt cv cn wcel simpll syl3anc adantrl
      syld exp32 com24 r19.21adv r19.22dva adantr sylbird com12 exp3a syl
      r19.21aiv ax-mp cc0 vx cv clt wbr vw cv vt cv clt wbr vt cv cF cfv cS cr
      clt csup cmin co cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex wi cc0
      vx cv clt wbr vw cv vt cv cle wbr vt cv cF cfv cS cr clt csup cmin co
      cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex wi vx cr vw cv vt cv clt
      wbr vt cv cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr wi vt cn
      wral vw cn wrex vw cv vt cv cle wbr vt cv cF cfv cS cr clt csup cmin co
      cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex cc0 vx cv clt wbr vt cv
      cF cfv cS cr clt csup cmin co cabs cfv vx cv clt wbr vw vt c1 cn nnuz
      cvg1 imbi2i ralbii mpbi cn cc cF wf cS cr clt csup cc wcel cF cS cr clt
      csup cli wbr cc0 vx cv clt wbr vw cv vt cv cle wbr vt cv cF cfv cS cr clt
      csup cmin co cabs cfv vx cv clt wbr wi vt cn wral vw cn wrex wi vx cr
      wral wb cn cr cF wf cr cc wss cn cc cF wf caucvg.1 axresscn cn cr cc cF
      fss mp2an cS cr clt csup vy vz vw vv vu cS cF caucvg.1 caucvg.2 caucvg.3
      caucvglem3 recni vx cS cr clt csup vw vt cF climfnn mp2an mpbir $.
      $( [6-Jun-2006] $) $( [4-Apr-2005] $)
  $}

  ${
    $d x v u F $.  $d x y z w v u G $.  $d x y z w v u H $.  $d x u v D $.
    $d x z w R $.  $d z w S $.
    caucvg3a.1 $e |- F : NN --> CC $.
    caucvg3a.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    caucvg3a.3 $e |- G Fn NN $.
    caucvg3a.4 $e |- ( x e. NN -> ( G ` x ) = ( Re ` ( F ` x ) ) ) $.
    caucvg3a.4a $e |- R = { u e. RR | E. v e. NN A. y e. NN (
                      v <_ y -> u < ( G ` y ) ) } $.
    caucvg3a.5 $e |- H Fn NN $.
    caucvg3a.6 $e |- ( x e. NN -> ( H ` x ) = ( Im ` ( F ` x ) ) ) $.
    caucvg3a.6a $e |- S = { u e. RR | E. v e. NN A. y e. NN (
                      v <_ y -> u < ( H ` y ) ) } $.
    caucvg3a.7 $e |- D Fn NN $.
    caucvg3a.8 $e |- ( x e. NN -> ( D ` x ) = ( _i x. ( H ` x ) ) ) $.
    $( A Cauchy sequence of complex numbers converges to a complex number.
       Theorem 12-5.3 of [Gleason] p. 180 (sufficiency part).  This version
       shows the explicit value of the limit (which is why we need all the
       hypotheses) rather than just its existence. $)
    caucvg3ai $p |- F ~~>
                   ( sup ( R , RR , < ) + ( _i x. sup ( S , RR , < ) ) ) $=
      cG cR cr clt csup cli wbr cD ci cS cr clt csup cmul co cli wbr wa c1 cz
      wcel vx cv cG cfv cc wcel vx cv cD cfv cc wcel vx cv cF cfv vx cv cG cfv
      vx cv cD cfv caddc co wceq w3a vx c1 cuz cfv wral wa cF cR cr clt csup ci
      cS cr clt csup cmul co caddc co cli wbr cG cR cr clt csup cli wbr cD ci
      cS cr clt csup cmul co cli wbr vy vz vw vv vu cR cG cn cr cG wf cG cn wfn
      vx cv cG cfv cr wcel vx cn wral vx cn cr cG ffnfv caucvg3a.3 vx cv cG cfv
      cr wcel vx cn vx cv cn wcel vx cv cG cfv vx cv cF cfv cre cfv cr
      caucvg3a.4 vx cv cn wcel vx cv cF cfv cc wcel vx cv cF cfv cre cfv cr
      wcel cn cc vx cv cF caucvg3a.1 ffvelrni vx cv cF cfv recl syl eqeltrd
      rgen mpbir2an vx vy vz vw cF cG caucvg3a.1 caucvg3a.2 caucvg3a.3
      caucvg3a.4 caurei caucvg3a.4a caucvgi ci cS cr clt csup vx cH cD axicn cr
      cS clt ltso supex vy vz vw vv vu cS cH cn cr cH wf cH cn wfn vx cv cH cfv
      cr wcel vx cn wral vx cn cr cH ffnfv caucvg3a.5 vx cv cH cfv cr wcel vx
      cn vx cv cn wcel vx cv cH cfv vx cv cF cfv cim cfv cr caucvg3a.6 vx cv cn
      wcel vx cv cF cfv cc wcel vx cv cF cfv cim cfv cr wcel cn cc vx cv cF
      caucvg3a.1 ffvelrni vx cv cF cfv imcl syl eqeltrd rgen mpbir2an vx vy vz
      vw cF cH caucvg3a.1 caucvg3a.2 caucvg3a.5 caucvg3a.6 cauimi caucvg3a.6a
      caucvgi caucvg3a.7 vx cv cn wcel vx cv cH cfv cc wcel vx cv cD cfv ci vx
      cv cH cfv cmul co wceq vx cv cn wcel vx cv cH cfv vx cv cn wcel vx cv cH
      cfv vx cv cF cfv cim cfv cr caucvg3a.6 vx cv cn wcel vx cv cF cfv cc wcel
      vx cv cF cfv cim cfv cr wcel cn cc vx cv cF caucvg3a.1 ffvelrni vx cv cF
      cfv imcl syl eqeltrd recnd caucvg3a.8 jca climmulci pm3.2i c1 cz wcel vx
      cv cG cfv cc wcel vx cv cD cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cD
      cfv caddc co wceq w3a vx c1 cuz cfv wral 1z vx cv cG cfv cc wcel vx cv cD
      cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cD cfv caddc co wceq w3a vx
      c1 cuz cfv vx cv c1 cuz cfv wcel vx cv cn wcel vx cv cG cfv cc wcel vx cv
      cD cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cD cfv caddc co wceq w3a
      vx cv elnnuz vx cv cn wcel vx cv cG cfv cc wcel vx cv cD cfv cc wcel vx
      cv cF cfv vx cv cG cfv vx cv cD cfv caddc co wceq vx cv cn wcel vx cv cG
      cfv vx cv cF cfv cre cfv cc caucvg3a.4 vx cv cn wcel vx cv cF cfv cre cfv
      vx cv cn wcel vx cv cF cfv cc wcel vx cv cF cfv cre cfv cr wcel cn cc vx
      cv cF caucvg3a.1 ffvelrni vx cv cF cfv recl syl recnd eqeltrd vx cv cn
      wcel vx cv cD cfv ci vx cv cH cfv cmul co cc caucvg3a.8 ci cc wcel vx cv
      cH cfv cc wcel ci vx cv cH cfv cmul co cc wcel vx cv cn wcel ci vx cv cH
      cfv mulcl axicn vx cv cn wcel vx cv cH cfv vx cv cn wcel vx cv cH cfv vx
      cv cF cfv cim cfv cr caucvg3a.6 vx cv cn wcel vx cv cF cfv cc wcel vx cv
      cF cfv cim cfv cr wcel cn cc vx cv cF caucvg3a.1 ffvelrni vx cv cF cfv
      imcl syl eqeltrd recnd sylancr eqeltrd vx cv cn wcel vx cv cF cfv vx cv
      cF cfv cre cfv ci vx cv cF cfv cim cfv cmul co caddc co vx cv cG cfv vx
      cv cD cfv caddc co vx cv cn wcel vx cv cF cfv cc wcel vx cv cF cfv vx cv
      cF cfv cre cfv ci vx cv cF cfv cim cfv cmul co caddc co wceq cn cc vx cv
      cF caucvg3a.1 ffvelrni vx cv cF cfv replim syl vx cv cn wcel vx cv cG cfv
      vx cv cF cfv cre cfv vx cv cD cfv ci vx cv cF cfv cim cfv cmul co caddc
      caucvg3a.4 vx cv cn wcel vx cv cD cfv ci vx cv cH cfv cmul co ci vx cv cF
      cfv cim cfv cmul co caucvg3a.8 vx cv cn wcel vx cv cH cfv vx cv cF cfv
      cim cfv ci cmul caucvg3a.6 opreq2d eqtrd opreq12d eqtr4d 3jca sylbir rgen
      pm3.2i cR cr clt csup ci cS cr clt csup cmul co vx cG cD cF c1 cG cn wfn
      cn cvv wcel cG cvv wcel caucvg3a.3 nnex cn cvv cG fnex mp2an cD cn wfn cn
      cvv wcel cD cvv wcel caucvg3a.7 nnex cn cvv cD fnex mp2an cn cc cF wf cn
      cvv wcel cF cvv wcel caucvg3a.1 nnex cn cc cvv cF fex mp2an cr cR clt
      ltso supex ci cS cr clt csup cmul oprex climadd mp2an $.
      $( [25-Jul-2008] $) $( [20-Apr-2005] $)
  $}

  ${
    $d x y z w u v F $.
    caucvg2.1 $e |- F : NN --> RR $.
    caucvg2.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    $( A Cauchy sequence of real numbers converges to a real number. $)
    caucvg2i $p |- E. x e. RR F ~~> x $=
      vv cv vy cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex
      vu cr crab cr clt csup cr wcel cF vv cv vy cv cle wbr vu cv vy cv cF cfv
      clt wbr wi vy cn wral vv cn wrex vu cr crab cr clt csup cli wbr cF vx cv
      cli wbr vx cr wrex vy vz vw vv vu vv cv vy cv cle wbr vu cv vy cv cF cfv
      clt wbr wi vy cn wral vv cn wrex vu cr crab cF caucvg2.1 caucvg2.2 vv cv
      vy cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex vu cr
      crab eqid caucvglem3 vy vz vw vv vu vv cv vy cv cle wbr vu cv vy cv cF
      cfv clt wbr wi vy cn wral vv cn wrex vu cr crab cF caucvg2.1 caucvg2.2 vv
      cv vy cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex vu
      cr crab eqid caucvgi cF vx cv cli wbr cF vv cv vy cv cle wbr vu cv vy cv
      cF cfv clt wbr wi vy cn wral vv cn wrex vu cr crab cr clt csup cli wbr vx
      vv cv vy cv cle wbr vu cv vy cv cF cfv clt wbr wi vy cn wral vv cn wrex
      vu cr crab cr clt csup cr vx cv vv cv vy cv cle wbr vu cv vy cv cF cfv
      clt wbr wi vy cn wral vv cn wrex vu cr crab cr clt csup cF cli breq2
      rcla4ev mp2an $.
      $( [9-Dec-2006] $) $( [11-Apr-2005] $)
  $}

  ${
    $d x u v F $.  $d x y z w u v G $.  $d x y z w t H $.  $d x u v t R $.
    caucvg3lem.1 $e |- F : NN --> CC $.
    caucvg3lem.2 $e |- A. z e. RR ( 0 < z -> E. w e. NN A. y e. NN ( w < y ->
                      ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) $.
    caucvg3lem.3 $e |- G Fn NN $.
    caucvg3lem.4 $e |- ( x e. NN -> ( G ` x ) = ( Re ` ( F ` x ) ) ) $.
    caucvg3lem.5 $e |- H Fn NN $.
    caucvg3lem.6 $e |- ( x e. NN -> ( H ` x ) = ( Im ` ( F ` x ) ) ) $.
    caucvg3lem.7 $e |- R Fn NN $.
    caucvg3lem.8 $e |- ( x e. NN -> ( R ` x ) = ( _i x. ( H ` x ) ) ) $.
    $( Lemma for ~ caucvg3i . $)
    caucvg3lem $p |- E. x e. CC F ~~> x $=
      cG vv cv cli wbr vv cr wrex cR vu cv cli wbr vu cc wrex cF vx cv cli wbr
      vx cc wrex vv vy vz vw cG cn cr cG wf cG cn wfn vx cv cG cfv cr wcel vx
      cn wral vx cn cr cG ffnfv caucvg3lem.3 vx cv cG cfv cr wcel vx cn vx cv
      cn wcel vx cv cG cfv vx cv cF cfv cre cfv cr caucvg3lem.4 vx cv cn wcel
      vx cv cF cfv cc wcel vx cv cF cfv cre cfv cr wcel cn cc vx cv cF
      caucvg3lem.1 ffvelrni vx cv cF cfv recl syl eqeltrd rgen mpbir2an vx vy
      vz vw cF cG caucvg3lem.1 caucvg3lem.2 caucvg3lem.3 caucvg3lem.4 caurei
      caucvg2i cH vt cv cli wbr vt cr wrex cR vu cv cli wbr vu cc wrex vt vy vz
      vw cH cn cr cH wf cH cn wfn vx cv cH cfv cr wcel vx cn wral vx cn cr cH
      ffnfv caucvg3lem.5 vx cv cH cfv cr wcel vx cn vx cv cn wcel vx cv cH cfv
      vx cv cF cfv cim cfv cr caucvg3lem.6 vx cv cn wcel vx cv cF cfv cc wcel
      vx cv cF cfv cim cfv cr wcel cn cc vx cv cF caucvg3lem.1 ffvelrni vx cv
      cF cfv imcl syl eqeltrd rgen mpbir2an vx vy vz vw cF cH caucvg3lem.1
      caucvg3lem.2 caucvg3lem.5 caucvg3lem.6 cauimi caucvg2i cH vt cv cli wbr
      cR vu cv cli wbr vu cc wrex vt cr cH vt cv cli wbr cR vu cv cli wbr vu cc
      wrex wi vt cv cr wcel cH vt cv cli wbr cR ci vt cv cmul co cli wbr cR vu
      cv cli wbr vu cc wrex ci cc wcel cH vt cv cli wbr cR ci vt cv cmul co cli
      wbr axicn ci cc wcel cH vt cv cli wbr wa c1 cz wcel vx cv cH cfv cc wcel
      vx cv cR cfv ci vx cv cH cfv cmul co wceq wa vx c1 cuz cfv wral cR ci vt
      cv cmul co cli wbr 1z vx cv cH cfv cc wcel vx cv cR cfv ci vx cv cH cfv
      cmul co wceq wa vx c1 cuz cfv vx cv c1 cuz cfv wcel vx cv cn wcel vx cv
      cH cfv cc wcel vx cv cR cfv ci vx cv cH cfv cmul co wceq wa vx cv elnnuz
      vx cv cn wcel vx cv cH cfv cc wcel vx cv cR cfv ci vx cv cH cfv cmul co
      wceq vx cv cn wcel vx cv cH cfv vx cv cn wcel vx cv cH cfv vx cv cF cfv
      cim cfv cr caucvg3lem.6 vx cv cn wcel vx cv cF cfv cc wcel vx cv cF cfv
      cim cfv cr wcel cn cc vx cv cF caucvg3lem.1 ffvelrni vx cv cF cfv imcl
      syl eqeltrd recnd caucvg3lem.8 jca sylbir rgen vt cv ci vx cH cR c1 cH cn
      wfn cn cvv wcel cH cvv wcel caucvg3lem.5 nnex cn cvv cH fnex mp2an cR cn
      wfn cn cvv wcel cR cvv wcel caucvg3lem.7 nnex cn cvv cR fnex mp2an vt
      visset climmulc2 mpanr12 mpan ci vt cv cmul co cc wcel cR ci vt cv cmul
      co cli wbr cR vu cv cli wbr vu cc wrex ci vt cv cmul co cvv wcel cR ci vt
      cv cmul co cli wbr ci vt cv cmul co cc wcel ci vt cv cmul oprex ci vt cv
      cmul co cvv cR climcl mpan cR vu cv cli wbr cR ci vt cv cmul co cli wbr
      vu ci vt cv cmul co cc vu cv ci vt cv cmul co cR cli breq2 rcla4ev
      mpancom syl a1i r19.23aiv ax-mp cG vv cv cli wbr cR vu cv cli wbr vu cc
      wrex cF vx cv cli wbr vx cc wrex wi vv cr cG vv cv cli wbr cR vu cv cli
      wbr vu cc wrex cF vx cv cli wbr vx cc wrex wi wi vv cv cr wcel cG vv cv
      cli wbr cR vu cv cli wbr cF vx cv cli wbr vx cc wrex vu cc cG vv cv cli
      wbr cR vu cv cli wbr cF vx cv cli wbr vx cc wrex wi vu cv cc wcel cG vv
      cv cli wbr cR vu cv cli wbr cF vx cv cli wbr vx cc wrex cG vv cv cli wbr
      cR vu cv cli wbr wa cF vv cv vu cv caddc co cli wbr cF vx cv cli wbr vx
      cc wrex cG vv cv cli wbr cR vu cv cli wbr wa c1 cz wcel vx cv cG cfv cc
      wcel vx cv cR cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cR cfv caddc co
      wceq w3a vx c1 cuz cfv wral cF vv cv vu cv caddc co cli wbr 1z vx cv cG
      cfv cc wcel vx cv cR cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cR cfv
      caddc co wceq w3a vx c1 cuz cfv vx cv c1 cuz cfv wcel vx cv cn wcel vx cv
      cG cfv cc wcel vx cv cR cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cR
      cfv caddc co wceq w3a vx cv elnnuz vx cv cn wcel vx cv cG cfv cc wcel vx
      cv cR cfv cc wcel vx cv cF cfv vx cv cG cfv vx cv cR cfv caddc co wceq vx
      cv cn wcel vx cv cG cfv vx cv cn wcel vx cv cG cfv vx cv cF cfv cre cfv
      cr caucvg3lem.4 vx cv cn wcel vx cv cF cfv cc wcel vx cv cF cfv cre cfv
      cr wcel cn cc vx cv cF caucvg3lem.1 ffvelrni vx cv cF cfv recl syl
      eqeltrd recnd vx cv cn wcel vx cv cR cfv ci vx cv cH cfv cmul co cc
      caucvg3lem.8 ci cc wcel vx cv cH cfv cc wcel ci vx cv cH cfv cmul co cc
      wcel vx cv cn wcel ci vx cv cH cfv mulcl axicn vx cv cn wcel vx cv cH cfv
      vx cv cn wcel vx cv cH cfv vx cv cF cfv cim cfv cr caucvg3lem.6 vx cv cn
      wcel vx cv cF cfv cc wcel vx cv cF cfv cim cfv cr wcel cn cc vx cv cF
      caucvg3lem.1 ffvelrni vx cv cF cfv imcl syl eqeltrd recnd sylancr eqeltrd
      vx cv cn wcel vx cv cF cfv vx cv cF cfv cre cfv ci vx cv cF cfv cim cfv
      cmul co caddc co vx cv cG cfv vx cv cR cfv caddc co vx cv cn wcel vx cv
      cF cfv cc wcel vx cv cF cfv vx cv cF cfv cre cfv ci vx cv cF cfv cim cfv
      cmul co caddc co wceq cn cc vx cv cF caucvg3lem.1 ffvelrni vx cv cF cfv
      replim syl vx cv cn wcel vx cv cG cfv vx cv cF cfv cre cfv vx cv cR cfv
      ci vx cv cF cfv cim cfv cmul co caddc caucvg3lem.4 vx cv cn wcel vx cv cR
      cfv ci vx cv cH cfv cmul co ci vx cv cF cfv cim cfv cmul co caucvg3lem.8
      vx cv cn wcel vx cv cH cfv vx cv cF cfv cim cfv ci cmul caucvg3lem.6
      opreq2d eqtrd opreq12d eqtr4d 3jca sylbir rgen vv cv vu cv vx cG cR cF c1
      cG cn wfn cn cvv wcel cG cvv wcel caucvg3lem.3 nnex cn cvv cG fnex mp2an
      cR cn wfn cn cvv wcel cR cvv wcel caucvg3lem.7 nnex cn cvv cR fnex mp2an
      cn cc cF wf cn cvv wcel cF cvv wcel caucvg3lem.1 nnex cn cc cvv cF fex
      mp2an vv visset vu visset climadd mpanr12 vv cv vu cv caddc co cc wcel cF
      vv cv vu cv caddc co cli wbr cF vx cv cli wbr vx cc wrex vv cv vu cv
      caddc co cvv wcel cF vv cv vu cv caddc co cli wbr vv cv vu cv caddc co cc
      wcel vv cv vu cv caddc oprex vv cv vu cv caddc co cvv cF climcl mpan cF
      vx cv cli wbr cF vv cv vu cv caddc co cli wbr vx vv cv vu cv caddc co cc
      vx cv vv cv vu cv caddc co cF cli breq2 rcla4ev mpancom syl ex a1d
      r19.23adv a1i r19.23aiv mp2 $.
      $( [25-Jul-2008] $) $( [16-Apr-2005] $)
  $}

  ${
    $d x k y j u v t h F $.
    caucvg3.1 $e |- F : NN --> CC $.
    caucvg3.2 $e |- A. y e. RR ( 0 < y -> E. j e. NN A. k e. NN ( j <_ k ->
                      ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < y ) ) $.
    $( A Cauchy sequence of complex numbers converges to a complex number.
       Theorem 12-5.3 of [Gleason] p. 180 (sufficiency part). $)
    caucvg3i $p |- E. x e. CC F ~~> x $=
      vx vk vy vj vt cv cn wcel vh cv ci vt cv vv cv cn wcel vu cv vv cv cF cfv
      cim cfv wceq wa vv vu copab cfv cmul co wceq wa vt vh copab cF vv cv cn
      wcel vu cv vv cv cF cfv cre cfv wceq wa vv vu copab vv cv cn wcel vu cv
      vv cv cF cfv cim cfv wceq wa vv vu copab caucvg3.1 cc0 vy cv clt wbr vj
      cv vk cv cle wbr vk cv cF cfv vj cv cF cfv cmin co cabs cfv vy cv clt wbr
      wi vk cn wral vj cn wrex wi vy cr wral cc0 vy cv clt wbr vj cv vk cv clt
      wbr vk cv cF cfv vj cv cF cfv cmin co cabs cfv vy cv clt wbr wi vk cn
      wral vj cn wrex wi vy cr wral caucvg3.2 cc0 vy cv clt wbr vj cv vk cv cle
      wbr vk cv cF cfv vj cv cF cfv cmin co cabs cfv vy cv clt wbr wi vk cn
      wral vj cn wrex wi cc0 vy cv clt wbr vj cv vk cv clt wbr vk cv cF cfv vj
      cv cF cfv cmin co cabs cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy
      cr vj cv vk cv cle wbr vk cv cF cfv vj cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vk cn wral vj cn wrex vj cv vk cv clt wbr vk cv cF cfv vj cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vk cn wral vj cn wrex cc0 vy cv
      clt wbr vk cv cF cfv vj cv cF cfv cmin co cabs cfv vy cv clt wbr vj vk c1
      cn nnuz cvg1i imim2i r19.20si ax-mp vv vu cn vv cv cF cfv cre cfv vv cv
      cn wcel vu cv vv cv cF cfv cre cfv wceq wa vv vu copab vv cv cF cfv cre
      fvex vv cv cn wcel vu cv vv cv cF cfv cre cfv wceq wa vv vu copab eqid
      fnopab2 vv vu vx cv vv cv cF cfv cre cfv vx cv cF cfv cre cfv cn vv cv cn
      wcel vu cv vv cv cF cfv cre cfv wceq wa vv vu copab vv cv vx cv wceq vv
      cv cF cfv vx cv cF cfv cre vv cv vx cv cF fveq2 fveq2d vv cv cn wcel vu
      cv vv cv cF cfv cre cfv wceq wa vv vu copab eqid vx cv cF cfv cre fvex
      fvopab4 vv vu cn vv cv cF cfv cim cfv vv cv cn wcel vu cv vv cv cF cfv
      cim cfv wceq wa vv vu copab vv cv cF cfv cim fvex vv cv cn wcel vu cv vv
      cv cF cfv cim cfv wceq wa vv vu copab eqid fnopab2 vv vu vx cv vv cv cF
      cfv cim cfv vx cv cF cfv cim cfv cn vv cv cn wcel vu cv vv cv cF cfv cim
      cfv wceq wa vv vu copab vv cv vx cv wceq vv cv cF cfv vx cv cF cfv cim vv
      cv vx cv cF fveq2 fveq2d vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa
      vv vu copab eqid vx cv cF cfv cim fvex fvopab4 vt vh cn ci vt cv vv cv cn
      wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv cmul co vt cv cn
      wcel vh cv ci vt cv vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv
      vu copab cfv cmul co wceq wa vt vh copab ci vt cv vv cv cn wcel vu cv vv
      cv cF cfv cim cfv wceq wa vv vu copab cfv cmul oprex vt cv cn wcel vh cv
      ci vt cv vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv
      cmul co wceq wa vt vh copab eqid fnopab2 vt vh vx cv ci vt cv vv cv cn
      wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv cmul co ci vx cv
      vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv cmul co
      cn vt cv cn wcel vh cv ci vt cv vv cv cn wcel vu cv vv cv cF cfv cim cfv
      wceq wa vv vu copab cfv cmul co wceq wa vt vh copab vt cv vx cv wceq vt
      cv vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv vx cv
      vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv ci cmul
      vt cv vx cv vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab
      fveq2 opreq2d vt cv cn wcel vh cv ci vt cv vv cv cn wcel vu cv vv cv cF
      cfv cim cfv wceq wa vv vu copab cfv cmul co wceq wa vt vh copab eqid ci
      vx cv vv cv cn wcel vu cv vv cv cF cfv cim cfv wceq wa vv vu copab cfv
      cmul oprex fvopab4 caucvg3lem $.
      $( [21-Dec-2006] $) $( [16-Apr-2005] $)
  $}

  ${
    $d t u v w x y z F $.
    $( A Cauchy sequence of complex numbers converges to a complex number.
       Theorem 12-5.3 of [Gleason] p. 180 (sufficiency part).  _Warning:
       The HTML proof page is 0.6 megabyte in size_. $)
    caucvg3 $p |- ( ( F : NN --> CC /\ A. z e. RR ( 0 < z -> E. w e. NN
        A. y e. NN ( w <_ y -> ( abs ` ( ( F ` y ) - ( F ` w ) ) ) < z ) ) ) ->
                   E. x e. CC F ~~> x ) $=
      cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral
      wa cF vx cv cli wbr vx cc wrex cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif vx cv cli wbr vx
      cc wrex cF cn cc0 csn cxp cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq cF vx cv cli
      wbr cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr
      wral wa cF cn cc0 csn cxp cif vx cv cli wbr vx cc cF cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif vx cv cli breq1 rexbidv vx vv vt vu cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cn cc cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif wf cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral cn cc cF wf cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cn cc cn cc
      cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif wf cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral wa cn cc cn cc0
      csn cxp wf cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv
      vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt
      cn wrex wi vv cr wral wa cF cn cc0 csn cxp cF cn cc cF wf cc0 vz cv clt
      wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif
      wceq cn cc cF wf cn cc cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wf cc0 vz cv clt wbr vw cv
      vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi
      vy cn wral vw cn wrex wi vz cr wral cc0 vv cv clt wbr vt cv vu cv cle wbr
      vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr
      vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt
      wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv
      cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral cn
      cc cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral wa cF cn cc0 csn cxp cif feq1 cF cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq cc0
      vv cv clt wbr vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral cc0 vv cv clt
      wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF
      wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn
      wrex wi vv cr wral cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi
      vz cr wral wa cF cn cc0 csn cxp cif wceq cc0 vv cv clt wbr vt cv vu cv
      cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn
      wral vt cn wrex wi cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF
      wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr cF cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif wceq vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv
      vv cv clt wbr wi vu cn wral vt cn wrex vt cv vu cv cle wbr vu cv cn cc cF
      wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex cc0 vv cv clt wbr cF cn cc cF
      wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif wceq vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin
      co cabs cfv vv cv clt wbr wi vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr
      wi vt vu cn cn cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv cF cfv vt cv cF
      cfv cmin co cabs cfv vv cv clt wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv
      cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral
      wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr vt cv vu cv
      cle wbr cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi
      vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv cF cfv vt cv cF cfv cmin
      co cabs cfv vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv cmin co cabs cfv vv cv clt cF cn cc cF wf cc0 vz cv clt wbr vw cv
      vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi
      vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv
      cF cfv vt cv cF cfv cmin co vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy
      cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy
      cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc
      cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv cmin co cabs cF cn cc cF wf cc0 vz cv clt wbr
      vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt
      wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq
      vu cv cF cfv vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cF cfv vt cv cn cc
      cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv cmin vu cv cF cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif fveq1 vt
      cv cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral wa cF cn cc0 csn cxp cif fveq1 opreq12d fveq2d breq1d imbi2d
      rexralbidv imbi2d ralbidv cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin
      co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vz vv cr vz cv vv
      cv wceq cc0 vz cv clt wbr cc0 vv cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt
      wbr wi vu cn wral vt cn wrex vz cv vv cv cc0 clt breq2 vz cv vv cv wceq
      vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt
      wbr wi vy cn wral vw cn wrex vw cv vu cv cle wbr vu cv cF cfv vw cv cF
      cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vw cn wrex vt cv vu cv
      cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn
      wral vt cn wrex vz cv vv cv wceq vw cv vy cv cle wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cv vu cv cle wbr
      vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vw
      cn vz cv vv cv wceq vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vv cv clt wbr wi vy cn wral vw cv vu cv cle
      wbr vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn
      wral vz cv vv cv wceq vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vw cv vy cv cle wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vv cv clt wbr wi vy cn vz cv vv cv wceq vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vz cv clt wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vv cv clt wbr vw cv vy cv cle wbr vz cv vv cv vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv clt breq2 imbi2d ralbidv vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi vw cv
      vu cv cle wbr vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi
      vy vu cn vy cv vu cv wceq vw cv vy cv cle wbr vw cv vu cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr vu cv cF cfv vw cv cF
      cfv cmin co cabs cfv vv cv clt wbr vy cv vu cv vw cv cle breq2 vy cv vu
      cv wceq vy cv cF cfv vw cv cF cfv cmin co cabs cfv vu cv cF cfv vw cv cF
      cfv cmin co cabs cfv vv cv clt vy cv vu cv wceq vy cv cF cfv vw cv cF cfv
      cmin co vu cv cF cfv vw cv cF cfv cmin co cabs vy cv vu cv wceq vy cv cF
      cfv vu cv cF cfv vw cv cF cfv cmin vy cv vu cv cF fveq2 opreq1d fveq2d
      breq1d imbi12d cbvralv syl6bb rexbidv vw cv vu cv cle wbr vu cv cF cfv vw
      cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cv vu cv cle
      wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn
      wral vw vt cn vw cv vt cv wceq vw cv vu cv cle wbr vu cv cF cfv vw cv cF
      cfv cmin co cabs cfv vv cv clt wbr wi vt cv vu cv cle wbr vu cv cF cfv vt
      cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn vw cv vt cv wceq vw cv
      vu cv cle wbr vt cv vu cv cle wbr vu cv cF cfv vw cv cF cfv cmin co cabs
      cfv vv cv clt wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt
      wbr vw cv vt cv vu cv cle breq1 vw cv vt cv wceq vu cv cF cfv vw cv cF
      cfv cmin co cabs cfv vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt
      vw cv vt cv wceq vu cv cF cfv vw cv cF cfv cmin co vu cv cF cfv vt cv cF
      cfv cmin co cabs vw cv vt cv wceq vw cv cF cfv vt cv cF cfv vu cv cF cfv
      cmin vw cv vt cv cF fveq2 opreq2d fveq2d breq1d imbi12d ralbidv cbvrexv
      syl6bb imbi12d cbvralv syl5bb anbi12d cn cc0 csn cxp cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif wceq cn cc cn cc0 csn cxp wf cn cc cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wf cc0 vv
      cv clt wbr vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn
      cxp cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr
      wral cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv
      clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr
      wi vu cn wral vt cn wrex wi vv cr wral cn cc cn cc0 csn cxp cn cc cF wf
      cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif feq1 cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv
      vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi
      vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq cc0 vv
      cv clt wbr vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn
      cxp cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi cc0 vv
      cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv
      vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi
      vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt
      cn wrex wi vv cr cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vt cv vu cv
      cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex vt cv vu cv cle wbr vu cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex cc0 vv cv clt wbr cn cc0 csn
      cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr
      wral wa cF cn cc0 csn cxp cif wceq vt cv vu cv cle wbr vu cv cn cc0 csn
      cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr wi vt cv
      vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy
      cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv cmin co cabs cfv vv cv clt wbr wi vt vu cn cn cn cc0 csn cxp cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif wceq vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp
      cfv cmin co cabs cfv vv cv clt wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv
      cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral
      wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr vt cv vu cv
      cle wbr cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv cn cc0 csn cxp
      cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vu cv cn cc cF wf cc0 vz cv
      clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt cn
      cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv cn cc0 csn cxp cfv vt
      cv cn cc0 csn cxp cfv cmin co vu cv cn cc cF wf cc0 vz cv clt wbr vw cv
      vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi
      vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv cmin co cabs cn cc0 csn cxp cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif wceq vu cv cn cc0 csn cxp cfv vu cv cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv
      cn cc0 csn cxp cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin vu cv cn
      cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif fveq1 vt cv cn cc0 csn cxp cn cc
      cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif fveq1 opreq12d fveq2d breq1d imbi2d rexralbidv
      imbi2d ralbidv anbi12d cn cc cn cc0 csn cxp wf cc0 vv cv clt wbr vt cv vu
      cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral cn cc0 csn cn
      cc0 csn cxp wf cc0 csn cc wss cn cc cn cc0 csn cxp wf cn cc0 cc0 cc 0cn
      elisseti fconst cc0 cc wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp cn cc0
      csn cc cn cc0 csn cxp fss mp2an cc0 vv cv clt wbr vt cv vu cv cle wbr vu
      cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt
      wbr wi vu cn wral vt cn wrex wi vv cr cc0 vv cv clt wbr vt cv vu cv cle
      wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv
      cv clt wbr wi vu cn wral vt cn wrex wi vv cv cr wcel c1 cn wcel c1 vu cv
      cle wbr vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu
      cn wral vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp
      cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex cc0 vv cv clt
      wbr vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv
      cmin co cabs cfv vv cv clt wbr wi vu cn wral c1 vu cv cle wbr vu cv cn
      cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu cn wral vt c1 cn
      vt cv c1 wceq vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0
      csn cxp cfv cmin co cabs cfv vv cv clt wbr wi c1 vu cv cle wbr vu cv cn
      cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu cn vt cv c1 wceq
      vt cv vu cv cle wbr c1 vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn
      cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr vu cv cn cc0 csn cxp cfv
      cc0 cmin co cabs cfv vv cv clt wbr vt cv c1 vu cv cle breq1 vt cv c1 wceq
      vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vu cv
      cn cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt vt cv c1 wceq vu cv cn
      cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co vu cv cn cc0 csn cxp cfv
      cc0 cmin co cabs vt cv c1 wceq vt cv cn cc0 csn cxp cfv cc0 vu cv cn cc0
      csn cxp cfv cmin vt cv c1 wceq vt cv cn cc0 csn cxp cfv c1 cn cc0 csn cxp
      cfv cc0 vt cv c1 cn cc0 csn cxp fveq2 c1 cn wcel c1 cn cc0 csn cxp cfv
      cc0 wceq 1nn cn cc0 c1 cc0 cc 0cn elisseti fvconst2 ax-mp syl6eq opreq2d
      fveq2d breq1d imbi12d ralbidv rcla4ev 1nn cc0 vv cv clt wbr c1 vu cv cle
      wbr vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu cn
      cc0 vv cv clt wbr vu cv cn wcel wa vu cv cn cc0 csn cxp cfv cc0 cmin co
      cabs cfv vv cv clt wbr c1 vu cv cle wbr vu cv cn wcel vu cv cn cc0 csn
      cxp cfv cc0 cmin co cabs cfv vv cv clt wbr cc0 vv cv clt wbr vu cv cn
      wcel vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv cc0 vv cv clt vu cv cn
      wcel vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv cc0 cabs cfv cc0 vu cv
      cn wcel vu cv cn cc0 csn cxp cfv cc0 cmin co cc0 cabs vu cv cn wcel vu cv
      cn cc0 csn cxp cfv cc0 cmin co cc0 cc0 cmin co cc0 vu cv cn wcel vu cv cn
      cc0 csn cxp cfv cc0 cc0 cmin cn cc0 vu cv cc0 cc 0cn elisseti fvconst2
      opreq1d cc0 0cn subidi syl6eq fveq2d abs0 syl6eq breq1d biimparc a1d
      r19.21aiva sylancr a1i rgen pm3.2i elimhyp pm3.26i cn cc cn cc cF wf cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn
      cxp cif wf cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr
      wi vu cn wral vt cn wrex wi vv cr wral cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cn cc cn cc cF wf cc0 vz cv clt
      wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif
      wf cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt
      wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif
      cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv
      vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi
      vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi
      vu cn wral vt cn wrex wi vv cr wral wa cn cc cn cc0 csn cxp wf cc0 vv cv
      clt wbr vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp
      cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral
      wa cF cn cc0 csn cxp cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq cn cc cF wf cn cc cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn
      cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv
      clt wbr wi vu cn wral vt cn wrex wi vv cr wral cn cc cF cn cc cF wf cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn
      cxp cif feq1 cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq cc0 vv cv clt wbr vt cv
      vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi
      vu cn wral vt cn wrex wi vv cr wral cc0 vv cv clt wbr vt cv vu cv cle wbr
      vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr
      vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt
      wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv
      cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral cF cn cc cF wf
      cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif wceq cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cF cfv
      vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi
      cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr
      vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt
      wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv
      vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi vu
      cn wral vt cn wrex wi vv cr cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vt cv vu cv
      cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn
      wral vt cn wrex vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr
      vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt
      wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv
      vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw
      cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz
      cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi vu
      cn wral vt cn wrex cc0 vv cv clt wbr cF cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vt
      cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr
      wi vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF
      wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi vt vu cn cn cF cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif wceq vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv
      cv clt wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv cmin co cabs cfv vv cv clt wbr vt cv vu cv cle wbr cF cn cc cF wf
      cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif wceq vu cv cF cfv vt cv cF cfv cmin co cabs cfv vu cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs
      cfv vv cv clt cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv cF cfv vt cv cF
      cfv cmin co vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv cmin co cabs cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv cF cfv vu cv cn
      cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv vt cv cF cfv vt cv cn cc cF wf cc0 vz cv clt
      wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif
      cfv cmin vu cv cF cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif fveq1 vt cv cF cn cc cF wf
      cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif fveq1 opreq12d fveq2d breq1d imbi2d rexralbidv imbi2d
      ralbidv cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi cc0 vv cv clt
      wbr vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv
      clt wbr wi vu cn wral vt cn wrex wi vz vv cr vz cv vv cv wceq cc0 vz cv
      clt wbr cc0 vv cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex vt cv vu cv cle
      wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn
      wral vt cn wrex vz cv vv cv cc0 clt breq2 vz cv vv cv wceq vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex vw cv vu cv cle wbr vu cv cF cfv vw cv cF cfv cmin co
      cabs cfv vv cv clt wbr wi vu cn wral vw cn wrex vt cv vu cv cle wbr vu cv
      cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn
      wrex vz cv vv cv wceq vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cv vu cv cle wbr vu cv cF cfv
      vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vw cn vz cv vv
      cv wceq vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vv cv clt wbr wi vy cn wral vw cv vu cv cle wbr vu cv cF
      cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vz cv vv cv
      wceq vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv
      clt wbr wi vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vv cv clt wbr wi vy cn vz cv vv cv wceq vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vz cv clt wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv
      clt wbr vw cv vy cv cle wbr vz cv vv cv vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv clt breq2 imbi2d ralbidv vw cv vy cv cle wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vv cv clt wbr wi vw cv vu cv cle wbr vu cv cF cfv
      vw cv cF cfv cmin co cabs cfv vv cv clt wbr wi vy vu cn vy cv vu cv wceq
      vw cv vy cv cle wbr vw cv vu cv cle wbr vy cv cF cfv vw cv cF cfv cmin co
      cabs cfv vv cv clt wbr vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv
      clt wbr vy cv vu cv vw cv cle breq2 vy cv vu cv wceq vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv
      clt vy cv vu cv wceq vy cv cF cfv vw cv cF cfv cmin co vu cv cF cfv vw cv
      cF cfv cmin co cabs vy cv vu cv wceq vy cv cF cfv vu cv cF cfv vw cv cF
      cfv cmin vy cv vu cv cF fveq2 opreq1d fveq2d breq1d imbi12d cbvralv
      syl6bb rexbidv vw cv vu cv cle wbr vu cv cF cfv vw cv cF cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cv vu cv cle wbr vu cv cF cfv vt cv cF
      cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vw vt cn vw cv vt cv
      wceq vw cv vu cv cle wbr vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv
      clt wbr wi vt cv vu cv cle wbr vu cv cF cfv vt cv cF cfv cmin co cabs cfv
      vv cv clt wbr wi vu cn vw cv vt cv wceq vw cv vu cv cle wbr vt cv vu cv
      cle wbr vu cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr vu cv cF
      cfv vt cv cF cfv cmin co cabs cfv vv cv clt wbr vw cv vt cv vu cv cle
      breq1 vw cv vt cv wceq vu cv cF cfv vw cv cF cfv cmin co cabs cfv vu cv
      cF cfv vt cv cF cfv cmin co cabs cfv vv cv clt vw cv vt cv wceq vu cv cF
      cfv vw cv cF cfv cmin co vu cv cF cfv vt cv cF cfv cmin co cabs vw cv vt
      cv wceq vw cv cF cfv vt cv cF cfv vu cv cF cfv cmin vw cv vt cv cF fveq2
      opreq2d fveq2d breq1d imbi12d ralbidv cbvrexv syl6bb imbi12d cbvralv
      syl5bb anbi12d cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq cn cc cn cc0
      csn cxp wf cn cc cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif wf cc0 vv cv clt wbr vt cv vu
      cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr wral cc0 vv cv clt
      wbr vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv
      cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF
      wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin
      co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn
      cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn
      wrex wi vv cr wral cn cc cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw
      cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr
      wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif feq1 cn
      cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif wceq cc0 vv cv clt wbr vt cv vu cv
      cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex wi cc0 vv cv clt wbr vt cv vu
      cv cle wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cn wrex wi vv cr
      cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif wceq vt cv vu cv cle wbr vu cv cn
      cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr
      wi vu cn wral vt cn wrex vt cv vu cv cle wbr vu cv cn cc cF wf cc0 vz cv
      clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF
      cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex
      wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt wbr
      wi vu cn wral vt cn wrex cc0 vv cv clt wbr cn cc0 csn cxp cn cc cF wf cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn
      cxp cif wceq vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0
      csn cxp cfv cmin co cabs cfv vv cv clt wbr wi vt cv vu cv cle wbr vu cv
      cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral
      wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy
      cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy
      cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin co
      cabs cfv vv cv clt wbr wi vt vu cn cn cn cc0 csn cxp cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif wceq vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr
      vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw
      cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0
      vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs
      cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn
      cxp cif cfv cmin co cabs cfv vv cv clt wbr vt cv vu cv cle wbr cn cc0 csn
      cxp cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv
      cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr
      wral wa cF cn cc0 csn cxp cif wceq vu cv cn cc0 csn cxp cfv vt cv cn cc0
      csn cxp cfv cmin co cabs cfv vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy
      cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy
      cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc
      cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif cfv cmin co cabs cfv vv cv clt cn cc0 csn cxp cn cc
      cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv
      cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa
      cF cn cc0 csn cxp cif wceq vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp
      cfv cmin co vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc cF wf cc0 vz
      cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv
      vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif cfv cmin co cabs cn cc0 csn cxp cn cc cF wf cc0 vz cv clt wbr vw cv
      vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi
      vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif wceq vu cv
      cn cc0 csn cxp cfv vu cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle
      wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn
      wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv vt cv cn cc0
      csn cxp cfv vt cv cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv
      cF cfv vw cv cF cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn
      wrex wi vz cr wral wa cF cn cc0 csn cxp cif cfv cmin vu cv cn cc0 csn cxp
      cn cc cF wf cc0 vz cv clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF
      cfv cmin co cabs cfv vz cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral
      wa cF cn cc0 csn cxp cif fveq1 vt cv cn cc0 csn cxp cn cc cF wf cc0 vz cv
      clt wbr vw cv vy cv cle wbr vy cv cF cfv vw cv cF cfv cmin co cabs cfv vz
      cv clt wbr wi vy cn wral vw cn wrex wi vz cr wral wa cF cn cc0 csn cxp
      cif fveq1 opreq12d fveq2d breq1d imbi2d rexralbidv imbi2d ralbidv anbi12d
      cn cc cn cc0 csn cxp wf cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn
      cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr
      wi vu cn wral vt cn wrex wi vv cr wral cn cc0 csn cn cc0 csn cxp wf cc0
      csn cc wss cn cc cn cc0 csn cxp wf cn cc0 cc0 cc 0cn elisseti fconst cc0
      cc wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp cn cc0 csn cc cn cc0 csn
      cxp fss mp2an cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc0 csn cxp
      cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr wi vu cn wral
      vt cn wrex wi vv cr cc0 vv cv clt wbr vt cv vu cv cle wbr vu cv cn cc0
      csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vv cv clt wbr wi vu
      cn wral vt cn wrex wi vv cv cr wcel c1 cn wcel c1 vu cv cle wbr vu cv cn
      cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu cn wral vt cv vu
      cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral vt cn wrex cc0 vv cv clt wbr vt cv vu cv
      cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs
      cfv vv cv clt wbr wi vu cn wral c1 vu cv cle wbr vu cv cn cc0 csn cxp cfv
      cc0 cmin co cabs cfv vv cv clt wbr wi vu cn wral vt c1 cn vt cv c1 wceq
      vt cv vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv
      cmin co cabs cfv vv cv clt wbr wi c1 vu cv cle wbr vu cv cn cc0 csn cxp
      cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu cn vt cv c1 wceq vt cv vu cv
      cle wbr c1 vu cv cle wbr vu cv cn cc0 csn cxp cfv vt cv cn cc0 csn cxp
      cfv cmin co cabs cfv vv cv clt wbr vu cv cn cc0 csn cxp cfv cc0 cmin co
      cabs cfv vv cv clt wbr vt cv c1 vu cv cle breq1 vt cv c1 wceq vu cv cn
      cc0 csn cxp cfv vt cv cn cc0 csn cxp cfv cmin co cabs cfv vu cv cn cc0
      csn cxp cfv cc0 cmin co cabs cfv vv cv clt vt cv c1 wceq vu cv cn cc0 csn
      cxp cfv vt cv cn cc0 csn cxp cfv cmin co vu cv cn cc0 csn cxp cfv cc0
      cmin co cabs vt cv c1 wceq vt cv cn cc0 csn cxp cfv cc0 vu cv cn cc0 csn
      cxp cfv cmin vt cv c1 wceq vt cv cn cc0 csn cxp cfv c1 cn cc0 csn cxp cfv
      cc0 vt cv c1 cn cc0 csn cxp fveq2 c1 cn wcel c1 cn cc0 csn cxp cfv cc0
      wceq 1nn cn cc0 c1 cc0 cc 0cn elisseti fvconst2 ax-mp syl6eq opreq2d
      fveq2d breq1d imbi12d ralbidv rcla4ev 1nn cc0 vv cv clt wbr c1 vu cv cle
      wbr vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv vv cv clt wbr wi vu cn
      cc0 vv cv clt wbr vu cv cn wcel wa vu cv cn cc0 csn cxp cfv cc0 cmin co
      cabs cfv vv cv clt wbr c1 vu cv cle wbr vu cv cn wcel vu cv cn cc0 csn
      cxp cfv cc0 cmin co cabs cfv vv cv clt wbr cc0 vv cv clt wbr vu cv cn
      wcel vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv cc0 vv cv clt vu cv cn
      wcel vu cv cn cc0 csn cxp cfv cc0 cmin co cabs cfv cc0 cabs cfv cc0 vu cv
      cn wcel vu cv cn cc0 csn cxp cfv cc0 cmin co cc0 cabs vu cv cn wcel vu cv
      cn cc0 csn cxp cfv cc0 cmin co cc0 cc0 cmin co cc0 vu cv cn wcel vu cv cn
      cc0 csn cxp cfv cc0 cc0 cmin cn cc0 vu cv cc0 cc 0cn elisseti fvconst2
      opreq1d cc0 0cn subidi syl6eq fveq2d abs0 syl6eq breq1d biimparc a1d
      r19.21aiva sylancr a1i rgen pm3.2i elimhyp pm3.27i caucvg3i dedth $.
      $( [23-Dec-2006] $) $( [20-Dec-2006] $)
  $}

  ${
    $d h j k m n x F $.  $d h m n A $.  $d h j k m n x M $.
    serzf0.1 $e |- F e. _V $.
    serzf0.2 $e |- M e. ZZ $.
    serzf0.3 $e |- ( k e. ( ZZ>= ` M ) -> ( F ` k ) e. CC ) $.
    serzf0.4 $e |- A e. _V $.
    serzf0.5 $e |- ( <. M , + >. seq F ) ~~> A $.
    $( If an infinite series converges, its underlying sequence converges to
       zero.  _Warning:  The HTML proof page is 0.6 megabyte in size_. $)
    serzf0i $p |- F ~~> 0 $=
      cF cc0 cli wbr cc0 vx cv clt wbr vj cv vh cv cle wbr vh cv cF cfv cc0
      cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc co cuz cfv wral vj cz
      wrex wi vx cr cM c1 caddc co cz wcel cc0 cc wcel vh cv cF cfv cc wcel vh
      cM c1 caddc co cuz cfv wral cF cc0 cli wbr cc0 vx cv clt wbr vj cv vh cv
      cle wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc
      co cuz cfv wral vj cz wrex wi vx cr wral wb cM cz wcel cM c1 caddc co cz
      wcel serzf0.2 cM peano2z ax-mp 0cn vh cv cF cfv cc wcel vh cM c1 caddc co
      cuz cfv vh cv cM c1 caddc co cuz cfv wcel vh cv cM cuz cfv wcel vh cv cF
      cfv cc wcel cM c1 caddc co cuz cfv cM cuz cfv vh cv cM c1 caddc co cM cuz
      cfv wcel cM c1 caddc co cuz cfv cM cuz cfv wss cM cM cuz cfv wcel cM c1
      caddc co cM cuz cfv wcel cM cz wcel cM cM cuz cfv wcel serzf0.2 cM uzid
      ax-mp cM cM peano2uz ax-mp cM cM c1 caddc co uzss ax-mp sseli vk cv cF
      cfv cc wcel vh cv cF cfv cc wcel vk vh cv cM cuz cfv vk cv vh cv wceq vk
      cv cF cfv vh cv cF cfv cc vk cv vh cv cF fveq2 eleq1d serzf0.3 vtoclga
      syl rgen vx cc0 vj vh cF cM c1 caddc co serzf0.1 clm4a mp3an vx cv cr
      wcel cc0 vx cv clt wbr vj cv vh cv cle wbr vh cv cF cfv cc0 cmin co cabs
      cfv vx cv clt wbr wi vh cM c1 caddc co cuz cfv wral vj cz wrex vx cv cr
      wcel cc0 vx cv clt wbr wa vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz
      co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral vm cz
      wrex vj cv vh cv cle wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr
      wi vh cM c1 caddc co cuz cfv wral vj cz wrex vx cv c2 cdiv co cr wcel cc0
      vx cv c2 cdiv co clt wbr vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz
      co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral vm cz
      wrex vx cv cr wcel cc0 vx cv clt wbr wa cA cvv wcel cM caddc cop cF cseqz
      co cA cli wbr vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr wa vm
      cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv
      vx cv c2 cdiv co clt wbr wi vn cz wral vm cz wrex serzf0.4 serzf0.5 cA vx
      cv c2 cdiv co cvv vm vn cM caddc cop cF cseqz co cc0 cz cz 0z cc0 uzssz
      cz ssid clmi2i mpanl12 vx cv cr wcel vx cv c2 cdiv co cr wcel cc0 vx cv
      clt wbr vx cv rehalfcl adantr vx cv cr wcel cc0 vx cv clt wbr cc0 vx cv
      c2 cdiv co clt wbr vx cv halfpos2 biimpa sylanc vx cv cr wcel vm cv vn cv
      cle wbr vn cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vn cz wral vm cz wrex vj cv vh cv cle wbr vh cv cF cfv
      cc0 cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc co cuz cfv wral vj
      cz wrex wi cc0 vx cv clt wbr vx cv cr wcel vm cv vn cv cle wbr vn cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi
      vn cz wral vj cv vh cv cle wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv
      clt wbr wi vh cM c1 caddc co cuz cfv wral vj cz wrex vm cz vx cv cr wcel
      vm cv cz wcel vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral vj cv vh cv cle
      wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc co
      cuz cfv wral vj cz wrex vm cv c1 caddc co cz wcel vm cv c1 caddc co vh cv
      cle wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc
      co cuz cfv wral vj cv vh cv cle wbr vh cv cF cfv cc0 cmin co cabs cfv vx
      cv clt wbr wi vh cM c1 caddc co cuz cfv wral vj cz wrex vx cv cr wcel vm
      cv cz wcel vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral wa wa vj cv vh cv cle
      wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc co
      cuz cfv wral vm cv c1 caddc co vh cv cle wbr vh cv cF cfv cc0 cmin co
      cabs cfv vx cv clt wbr wi vh cM c1 caddc co cuz cfv wral vj vm cv c1
      caddc co cz vj cv vm cv c1 caddc co wceq vj cv vh cv cle wbr vh cv cF cfv
      cc0 cmin co cabs cfv vx cv clt wbr wi vm cv c1 caddc co vh cv cle wbr vh
      cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc co cuz cfv
      vj cv vm cv c1 caddc co wceq vj cv vh cv cle wbr vm cv c1 caddc co vh cv
      cle wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr vj cv vm cv c1
      caddc co vh cv cle breq1 imbi1d ralbidv rcla4ev vm cv cz wcel vm cv c1
      caddc co cz wcel vx cv cr wcel vm cv vn cv cle wbr vn cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral
      vm cv peano2z ad2antrl vx cv cr wcel vm cv cz wcel vm cv vn cv cle wbr vn
      cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vn cz wral wa wa vm cv c1 caddc co vh cv cle wbr vh cv cF cfv cc0
      cmin co cabs cfv vx cv clt wbr wi vh cM c1 caddc co cuz cfv vh cv cM c1
      caddc co cuz cfv wcel vx cv cr wcel vm cv cz wcel vm cv vn cv cle wbr vn
      cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vn cz wral wa wa vm cv c1 caddc co vh cv cle wbr vh cv cF cfv cc0
      cmin co cabs cfv vx cv clt wbr wi vh cv cM c1 caddc co cuz cfv wcel vx cv
      cr wcel vm cv cz wcel vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co
      cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral wa wa wa
      vm cv c1 caddc co vh cv cle wbr vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr vh cv c1 cmin co cM caddc cop
      cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wa vh cv cF
      cfv cc0 cmin co cabs cfv vx cv clt wbr vh cv cM c1 caddc co cuz cfv wcel
      vm cv cz wcel vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral wa vm cv c1 caddc
      co vh cv cle wbr vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv
      vx cv c2 cdiv co clt wbr vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wa wi vx cv cr wcel vh cv cz
      wcel vm cv cz wcel vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv
      cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral wa vm cv c1
      caddc co vh cv cle wbr vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr vh cv c1 cmin co cM caddc cop cF cseqz co
      cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wa wi vh cv cM c1 caddc
      co cuz cfv wcel vh cv cz wcel vm cv cz wcel vm cv vn cv cle wbr vn cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi
      vn cz wral wa wa vm cv c1 caddc co vh cv cle wbr vh cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vh cv c1 cmin
      co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr vh cv cz wcel vm cv cz wcel vm cv vn cv cle wbr vn cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral
      wa wa vm cv c1 caddc co vh cv cle wbr vm cv vh cv cle wbr vh cv cM caddc
      cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vh cv cz
      wcel vm cv cz wcel vm cv c1 caddc co vh cv cle wbr vm cv vh cv cle wbr wi
      vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wi vn cz wral vm cv cz wcel vh cv cz wcel vm
      cv c1 caddc co vh cv cle wbr vm cv vh cv cle wbr wi vm cv cr wcel vh cv
      cr wcel vm cv c1 caddc co vh cv cle wbr vm cv vh cv cle wbr wi vm cv cz
      wcel vh cv cz wcel vm cv cr wcel vh cv cr wcel vm cv c1 caddc co vh cv
      cle wbr vm cv vh cv cle wbr vm cv vh cv p1le 3expia vm cv zre vh cv zre
      syl2an ancoms adantrr vh cv cz wcel vm cv vn cv cle wbr vn cv cM caddc
      cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi vn cz
      wral vm cv vh cv cle wbr vh cv cM caddc cop cF cseqz co cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vm cv cz wcel vm cv vn cv cle wbr vn
      cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vm cv vh cv cle wbr vh cv cM caddc cop cF cseqz co cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vn vh cv cz vn cv vh cv wceq vm cv
      vn cv cle wbr vm cv vh cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr vh cv cM caddc cop cF cseqz co
      cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vn cv vh cv vm cv cle
      breq2 vn cv vh cv wceq vn cv cM caddc cop cF cseqz co cfv cA cmin co cabs
      cfv vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv
      co clt vn cv vh cv wceq vn cv cM caddc cop cF cseqz co cfv cA cmin co vh
      cv cM caddc cop cF cseqz co cfv cA cmin co cabs vn cv vh cv wceq vn cv cM
      caddc cop cF cseqz co cfv vh cv cM caddc cop cF cseqz co cfv cA cmin vn
      cv vh cv cM caddc cop cF cseqz co fveq2 opreq1d fveq2d breq1d imbi12d
      rcla4va adantrl syld vh cv cz wcel vm cv cz wcel vm cv vn cv cle wbr vn
      cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr wi vn cz wral wa wa vm cv c1 caddc co vh cv cle wbr vm cv vh cv c1
      cmin co cle wbr vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr vh cv cz wcel vm cv cz wcel vm cv c1
      caddc co vh cv cle wbr vm cv vh cv c1 cmin co cle wbr wb vm cv vn cv cle
      wbr vn cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv
      co clt wbr wi vn cz wral vm cv cz wcel vh cv cz wcel vm cv c1 caddc co vh
      cv cle wbr vm cv vh cv c1 cmin co cle wbr wb vm cv cr wcel vh cv cr wcel
      vm cv c1 caddc co vh cv cle wbr vm cv vh cv c1 cmin co cle wbr wb vm cv
      cz wcel vh cv cz wcel vm cv cr wcel c1 cr wcel vh cv cr wcel vm cv c1
      caddc co vh cv cle wbr vm cv vh cv c1 cmin co cle wbr wb 1re vm cv c1 vh
      cv leaddsub mp3an2 vm cv zre vh cv zre syl2an ancoms adantrr vh cv cz
      wcel vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA cmin co
      cabs cfv vx cv c2 cdiv co clt wbr wi vn cz wral vm cv vh cv c1 cmin co
      cle wbr vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv
      vx cv c2 cdiv co clt wbr wi vm cv cz wcel vh cv cz wcel vm cv vn cv cle
      wbr vn cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv
      co clt wbr wi vn cz wral vm cv vh cv c1 cmin co cle wbr vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr
      wi vh cv cz wcel vh cv c1 cmin co cz wcel vm cv vn cv cle wbr vn cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi
      vn cz wral vm cv vh cv c1 cmin co cle wbr vh cv c1 cmin co cM caddc cop
      cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi wi vh cv
      peano2zm vm cv vn cv cle wbr vn cv cM caddc cop cF cseqz co cfv cA cmin
      co cabs cfv vx cv c2 cdiv co clt wbr wi vm cv vh cv c1 cmin co cle wbr vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wi vn vh cv c1 cmin co cz vn cv vh cv c1 cmin co wceq vm
      cv vn cv cle wbr vm cv vh cv c1 cmin co cle wbr vn cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vh cv c1 cmin
      co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt
      wbr vn cv vh cv c1 cmin co vm cv cle breq2 vn cv vh cv c1 cmin co wceq vn
      cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt vn cv
      vh cv c1 cmin co wceq vn cv cM caddc cop cF cseqz co cfv cA cmin co vh cv
      c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs vn cv vh cv c1
      cmin co wceq vn cv cM caddc cop cF cseqz co cfv vh cv c1 cmin co cM caddc
      cop cF cseqz co cfv cA cmin vn cv vh cv c1 cmin co cM caddc cop cF cseqz
      co fveq2 opreq1d fveq2d breq1d imbi12d rcla4v syl imp adantrl sylbid jcad
      cM c1 caddc co vh cv eluzelz sylan adantrl vh cv cM c1 caddc co cuz cfv
      wcel vx cv cr wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv
      vx cv c2 cdiv co clt wbr vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vx cv c2 cdiv co clt wbr wa vh cv cF cfv cc0 cmin co
      cabs cfv vx cv clt wbr wi vm cv cz wcel vm cv vn cv cle wbr vn cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wi
      vn cz wral wa vh cv cM c1 caddc co cuz cfv wcel vx cv cr wcel wa vh cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2
      cdiv co clt wbr wa vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv
      cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv caddc
      co vx cv clt wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr vh cv cM
      c1 caddc co cuz cfv wcel vx cv cr wcel wa vh cv cM caddc cop cF cseqz co
      cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv co clt wbr wa
      vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cA cmin co cabs cfv caddc co vx cv clt wbr
      vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin
      co cM caddc cop cF cseqz co cfv cmin co cabs cfv caddc co vx cv clt wbr
      vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cr wcel vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cr wcel vx cv cr
      wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv c2 cdiv
      co clt wbr vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs
      cfv vx cv c2 cdiv co clt wbr wa vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co
      cabs cfv caddc co vx cv clt wbr wi vh cv cM c1 caddc co cuz cfv wcel vx
      cv cr wcel wa vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vx cv
      lt2halves vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz
      co cfv cA cmin co cabs cfv cr wcel vx cv cr wcel vh cv cM c1 caddc co cuz
      cfv wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cc wcel vh cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv cr wcel vh cv cM caddc cop
      cF cseqz co cfv cc wcel cA cc wcel vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cc wcel vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF
      cseqz co cfv cA subcl vh cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral vh cv cM caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc
      co cuz cfv wcel vk cF cM vh cv serzf0.1 serzcl2 cM c1 caddc co cuz cfv cM
      cuz cfv vh cv cM c1 caddc co cM cuz cfv wcel cM c1 caddc co cuz cfv cM
      cuz cfv wss cM cM cuz cfv wcel cM c1 caddc co cM cuz cfv wcel cM cz wcel
      cM cM cuz cfv wcel serzf0.2 cM uzid ax-mp cM cM peano2uz ax-mp cM cM c1
      caddc co uzss ax-mp sseli vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3
      rgen sylancl cA cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel
      serzf0.4 serzf0.5 cA cvv cM caddc cop cF cseqz co climcl mp2an sylancl vh
      cv cM caddc cop cF cseqz co cfv cA cmin co abscl syl adantr vh cv cM c1
      caddc co cuz cfv wcel vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv cr wcel vx cv cr wcel vh cv cM c1 caddc co cuz cfv wcel
      vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cc wcel vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cr wcel vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cc wcel cA cc wcel vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cA cmin co cc wcel vh cv cM c1 caddc co cuz
      cfv wcel vh cv c1 cmin co cM caddc cop cF cseqz co cfv cA subcl vh cv c1
      cmin co cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv
      wcel vk cF cM vh cv c1 cmin co serzf0.1 serzcl2 cM cz wcel vh cv cM c1
      caddc co cuz cfv wcel vh cv c1 cmin co cM cuz cfv wcel serzf0.2 cM vh cv
      eluzp1m1 mpan vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl cA
      cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4 serzf0.5
      cA cvv cM caddc cop cF cseqz co climcl mp2an sylancl vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cA cmin co abscl syl adantr vh cv cM c1 caddc
      co cuz cfv wcel vx cv cr wcel pm3.27 syl3anc vh cv cM c1 caddc co cuz cfv
      wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv vh cv c1 cmin
      co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv caddc co vx cv clt
      wbr vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv caddc co vx cv clt
      wbr wb vx cv cr wcel vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop
      cF cseqz co cfv cA cmin co cabs cfv vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv caddc co vh cv cM caddc cop cF cseqz co
      cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv
      cmin co cabs cfv caddc co vx cv clt vh cv cM c1 caddc co cuz cfv wcel vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh cv
      c1 cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv vh cv cM caddc
      cop cF cseqz co cfv cA cmin co cabs cfv caddc vh cv c1 cmin co cM caddc
      cop cF cseqz co cfv cc wcel cA cc wcel vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cmin co cabs cfv wceq vh cv cM c1 caddc co cuz cfv wcel vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cA abssub vh cv c1 cmin co cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF
      cM vh cv c1 cmin co serzf0.1 serzcl2 cM cz wcel vh cv cM c1 caddc co cuz
      cfv wcel vh cv c1 cmin co cM cuz cfv wcel serzf0.2 cM vh cv eluzp1m1 mpan
      vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl cA cvv wcel cM
      caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4 serzf0.5 cA cvv cM
      caddc cop cF cseqz co climcl mp2an sylancl opreq2d breq1d adantr sylibd
      vh cv cM c1 caddc co cuz cfv wcel vx cv cr wcel wa vh cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cmin co cabs cfv caddc co vx cv clt wbr vh cv cM caddc cop
      cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz co
      cfv cmin co caddc co cabs cfv vx cv clt wbr vh cv cF cfv cc0 cmin co cabs
      cfv vx cv clt wbr vh cv cM c1 caddc co cuz cfv wcel vx cv cr wcel wa vh
      cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM caddc
      cop cF cseqz co cfv cmin co caddc co cabs cfv vh cv cM caddc cop cF cseqz
      co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF cseqz co
      cfv cmin co cabs cfv caddc co cle wbr vh cv cM caddc cop cF cseqz co cfv
      cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin
      co cabs cfv caddc co vx cv clt wbr vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co caddc co
      cabs cfv vx cv clt wbr vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc
      cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz
      co cfv cmin co caddc co cabs cfv vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co
      cabs cfv caddc co cle wbr vx cv cr wcel vh cv cM caddc cop cF cseqz co
      cfv cA cmin co cc wcel cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv
      cmin co cc wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co caddc co cabs cfv vh cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co cabs cfv caddc co cle wbr vh cv cM c1
      caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co abstri vh cv cM caddc
      cop cF cseqz co cfv cc wcel cA cc wcel vh cv cM caddc cop cF cseqz co cfv
      cA cmin co cc wcel vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop
      cF cseqz co cfv cA subcl vh cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral vh cv cM caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc
      co cuz cfv wcel vk cF cM vh cv serzf0.1 serzcl2 cM c1 caddc co cuz cfv cM
      cuz cfv vh cv cM c1 caddc co cM cuz cfv wcel cM c1 caddc co cuz cfv cM
      cuz cfv wss cM cM cuz cfv wcel cM c1 caddc co cM cuz cfv wcel cM cz wcel
      cM cM cuz cfv wcel serzf0.2 cM uzid ax-mp cM cM peano2uz ax-mp cM cM c1
      caddc co uzss ax-mp sseli vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3
      rgen sylancl cA cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel
      serzf0.4 serzf0.5 cA cvv cM caddc cop cF cseqz co climcl mp2an sylancl cA
      cc wcel vh cv c1 cmin co cM caddc cop cF cseqz co cfv cc wcel cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cc wcel vh cv cM c1 caddc co
      cuz cfv wcel cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv subcl cA
      cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4 serzf0.5
      cA cvv cM caddc cop cF cseqz co climcl mp2an vh cv c1 cmin co cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv c1 cmin co cM caddc
      cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF cM vh
      cv c1 cmin co serzf0.1 serzcl2 cM cz wcel vh cv cM c1 caddc co cuz cfv
      wcel vh cv c1 cmin co cM cuz cfv wcel serzf0.2 cM vh cv eluzp1m1 mpan vk
      cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl sylancr sylanc
      adantr vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cmin co caddc co cabs cfv cr wcel vh cv cM
      caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co cabs cfv caddc co cr wcel vx cv cr wcel
      vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co caddc co cabs cfv vh cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cmin co cabs cfv caddc co cle wbr vh cv cM caddc cop cF
      cseqz co cfv cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cmin co cabs cfv caddc co vx cv clt wbr wa vh cv cM caddc
      cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz
      co cfv cmin co caddc co cabs cfv vx cv clt wbr wi vh cv cM c1 caddc co
      cuz cfv wcel vx cv cr wcel wa vh cv cM caddc cop cF cseqz co cfv cA cmin
      co cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co caddc co cabs
      cfv vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv caddc co vx cv
      lelttr vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co
      cfv cA cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co
      caddc co cabs cfv cr wcel vx cv cr wcel vh cv cM c1 caddc co cuz cfv wcel
      vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cmin co caddc co cc wcel vh cv cM caddc cop cF
      cseqz co cfv cA cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv
      cmin co caddc co cabs cfv cr wcel vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cc wcel cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co
      cc wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cmin co caddc co cc wcel vh cv cM c1 caddc
      co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co addcl vh cv cM caddc cop cF
      cseqz co cfv cc wcel cA cc wcel vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cc wcel vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF
      cseqz co cfv cA subcl vh cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral vh cv cM caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc
      co cuz cfv wcel vk cF cM vh cv serzf0.1 serzcl2 cM c1 caddc co cuz cfv cM
      cuz cfv vh cv cM c1 caddc co cM cuz cfv wcel cM c1 caddc co cuz cfv cM
      cuz cfv wss cM cM cuz cfv wcel cM c1 caddc co cM cuz cfv wcel cM cz wcel
      cM cM cuz cfv wcel serzf0.2 cM uzid ax-mp cM cM peano2uz ax-mp cM cM c1
      caddc co uzss ax-mp sseli vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3
      rgen sylancl cA cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel
      serzf0.4 serzf0.5 cA cvv cM caddc cop cF cseqz co climcl mp2an sylancl cA
      cc wcel vh cv c1 cmin co cM caddc cop cF cseqz co cfv cc wcel cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cc wcel vh cv cM c1 caddc co
      cuz cfv wcel cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv subcl cA
      cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4 serzf0.5
      cA cvv cM caddc cop cF cseqz co climcl mp2an vh cv c1 cmin co cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv c1 cmin co cM caddc
      cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF cM vh
      cv c1 cmin co serzf0.1 serzcl2 cM cz wcel vh cv cM c1 caddc co cuz cfv
      wcel vh cv c1 cmin co cM cuz cfv wcel serzf0.2 cM vh cv eluzp1m1 mpan vk
      cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl sylancr sylanc vh
      cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co cM caddc
      cop cF cseqz co cfv cmin co caddc co abscl syl adantr vh cv cM c1 caddc
      co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cA
      vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv caddc co
      cr wcel vx cv cr wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs
      cfv cr wcel cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co cabs
      cfv cr wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cabs cfv cA vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv caddc co cr
      wcel vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv
      cA cmin co cabs cfv cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin
      co cabs cfv readdcl vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop
      cF cseqz co cfv cA cmin co cc wcel vh cv cM caddc cop cF cseqz co cfv cA
      cmin co cabs cfv cr wcel vh cv cM caddc cop cF cseqz co cfv cc wcel cA cc
      wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cc wcel vh cv cM c1
      caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv cA subcl vh cv
      cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv cM caddc
      cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF cM vh
      cv serzf0.1 serzcl2 cM c1 caddc co cuz cfv cM cuz cfv vh cv cM c1 caddc
      co cM cuz cfv wcel cM c1 caddc co cuz cfv cM cuz cfv wss cM cM cuz cfv
      wcel cM c1 caddc co cM cuz cfv wcel cM cz wcel cM cM cuz cfv wcel
      serzf0.2 cM uzid ax-mp cM cM peano2uz ax-mp cM cM c1 caddc co uzss ax-mp
      sseli vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl cA cvv
      wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4 serzf0.5 cA
      cvv cM caddc cop cF cseqz co climcl mp2an sylancl vh cv cM caddc cop cF
      cseqz co cfv cA cmin co abscl syl vh cv cM c1 caddc co cuz cfv wcel cA vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co cc wcel cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co cabs cfv cr wcel cA cc wcel
      vh cv c1 cmin co cM caddc cop cF cseqz co cfv cc wcel cA vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cmin co cc wcel vh cv cM c1 caddc co cuz cfv
      wcel cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv subcl cA cvv wcel
      cM caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4 serzf0.5 cA cvv
      cM caddc cop cF cseqz co climcl mp2an vh cv c1 cmin co cM cuz cfv wcel vk
      cv cF cfv cc wcel vk cM cuz cfv wral vh cv c1 cmin co cM caddc cop cF
      cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF cM vh cv c1
      cmin co serzf0.1 serzcl2 cM cz wcel vh cv cM c1 caddc co cuz cfv wcel vh
      cv c1 cmin co cM cuz cfv wcel serzf0.2 cM vh cv eluzp1m1 mpan vk cv cF
      cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl sylancr cA vh cv c1 cmin
      co cM caddc cop cF cseqz co cfv cmin co abscl syl sylanc adantr vh cv cM
      c1 caddc co cuz cfv wcel vx cv cr wcel pm3.27 syl3anc mpand vh cv cM c1
      caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co caddc co cabs cfv vx
      cv clt wbr vh cv cF cfv cc0 cmin co cabs cfv vx cv clt wbr wb vx cv cr
      wcel vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv
      cA cmin co cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co caddc
      co cabs cfv vh cv cF cfv cc0 cmin co cabs cfv vx cv clt vh cv cM c1 caddc
      co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co caddc co vh cv cF cfv cc0
      cmin co cabs vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF
      cseqz co cfv vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co vh cv
      cF cfv vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv cmin co caddc co vh cv cF cfv cc0 cmin co vh
      cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv vh cv
      c1 cmin co cM caddc cop cF cseqz co cfv cmin co vh cv cF cfv wceq vh cv
      c1 cmin co cM caddc cop cF cseqz co cfv vh cv cF cfv caddc co vh cv cM
      caddc cop cF cseqz co cfv wceq vh cv cM c1 caddc co cuz cfv wcel vh cv cM
      caddc cop cF cseqz co cfv vh cv c1 cmin co cM caddc cop cF cseqz co cfv
      vh cv cF cfv caddc co vh cv cz wcel cM vh cv clt wbr vh cv cM caddc cop
      cF cseqz co cfv vh cv c1 cmin co cM caddc cop cF cseqz co cfv vh cv cF
      cfv caddc co wceq vh cv cM c1 caddc co cuz cfv wcel cM cz wcel vh cv cz
      wcel cM vh cv clt wbr vh cv cM caddc cop cF cseqz co cfv vh cv c1 cmin co
      cM caddc cop cF cseqz co cfv vh cv cF cfv caddc co wceq serzf0.2 caddc cF
      cM vh cv addex serzf0.1 seqzm1 mp3an1 cM c1 caddc co vh cv eluzelz cM cz
      wcel vh cv cM c1 caddc co cuz cfv wcel cM vh cv clt wbr serzf0.2 cM vh cv
      eluzp1l mpan sylanc eqcomd vh cv cM caddc cop cF cseqz co cfv cc wcel vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cc wcel vh cv cF cfv cc wcel
      vh cv cM caddc cop cF cseqz co cfv vh cv c1 cmin co cM caddc cop cF cseqz
      co cfv cmin co vh cv cF cfv wceq vh cv c1 cmin co cM caddc cop cF cseqz
      co cfv vh cv cF cfv caddc co vh cv cM caddc cop cF cseqz co cfv wceq wb
      vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF cseqz co cfv vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv vh cv cF cfv subadd vh cv cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv cM caddc cop
      cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF cM vh cv
      serzf0.1 serzcl2 cM c1 caddc co cuz cfv cM cuz cfv vh cv cM c1 caddc co
      cM cuz cfv wcel cM c1 caddc co cuz cfv cM cuz cfv wss cM cM cuz cfv wcel
      cM c1 caddc co cM cuz cfv wcel cM cz wcel cM cM cuz cfv wcel serzf0.2 cM
      uzid ax-mp cM cM peano2uz ax-mp cM cM c1 caddc co uzss ax-mp sseli vk cv
      cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl vh cv c1 cmin co cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh cv c1 cmin co cM
      caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel vk cF
      cM vh cv c1 cmin co serzf0.1 serzcl2 cM cz wcel vh cv cM c1 caddc co cuz
      cfv wcel vh cv c1 cmin co cM cuz cfv wcel serzf0.2 cM vh cv eluzp1m1 mpan
      vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl vh cv cM c1
      caddc co cuz cfv wcel vh cv cM cuz cfv wcel vh cv cF cfv cc wcel cM c1
      caddc co cuz cfv cM cuz cfv vh cv cM c1 caddc co cM cuz cfv wcel cM c1
      caddc co cuz cfv cM cuz cfv wss cM cM cuz cfv wcel cM c1 caddc co cM cuz
      cfv wcel cM cz wcel cM cM cuz cfv wcel serzf0.2 cM uzid ax-mp cM cM
      peano2uz ax-mp cM cM c1 caddc co uzss ax-mp sseli vk cv cF cfv cc wcel vh
      cv cF cfv cc wcel vk vh cv cM cuz cfv vk cv vh cv wceq vk cv cF cfv vh cv
      cF cfv cc vk cv vh cv cF fveq2 eleq1d serzf0.3 vtoclga syl syl3anc mpbird
      vh cv cM caddc cop cF cseqz co cfv cc wcel vh cv c1 cmin co cM caddc cop
      cF cseqz co cfv cc wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA
      vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co caddc co vh cv cM
      caddc cop cF cseqz co cfv vh cv c1 cmin co cM caddc cop cF cseqz co cfv
      cmin co wceq vh cv cM c1 caddc co cuz cfv wcel vh cv cM caddc cop cF
      cseqz co cfv cc wcel cA cc wcel vh cv c1 cmin co cM caddc cop cF cseqz co
      cfv cc wcel vh cv cM caddc cop cF cseqz co cfv cA cmin co cA vh cv c1
      cmin co cM caddc cop cF cseqz co cfv cmin co caddc co vh cv cM caddc cop
      cF cseqz co cfv vh cv c1 cmin co cM caddc cop cF cseqz co cfv cmin co
      wceq cA cvv wcel cM caddc cop cF cseqz co cA cli wbr cA cc wcel serzf0.4
      serzf0.5 cA cvv cM caddc cop cF cseqz co climcl mp2an vh cv cM caddc cop
      cF cseqz co cfv cA vh cv c1 cmin co cM caddc cop cF cseqz co cfv npncan
      mp3an2 vh cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh
      cv cM caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co cuz cfv wcel
      vk cF cM vh cv serzf0.1 serzcl2 cM c1 caddc co cuz cfv cM cuz cfv vh cv
      cM c1 caddc co cM cuz cfv wcel cM c1 caddc co cuz cfv cM cuz cfv wss cM
      cM cuz cfv wcel cM c1 caddc co cM cuz cfv wcel cM cz wcel cM cM cuz cfv
      wcel serzf0.2 cM uzid ax-mp cM cM peano2uz ax-mp cM cM c1 caddc co uzss
      ax-mp sseli vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen sylancl vh
      cv c1 cmin co cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz cfv wral vh
      cv c1 cmin co cM caddc cop cF cseqz co cfv cc wcel vh cv cM c1 caddc co
      cuz cfv wcel vk cF cM vh cv c1 cmin co serzf0.1 serzcl2 cM cz wcel vh cv
      cM c1 caddc co cuz cfv wcel vh cv c1 cmin co cM cuz cfv wcel serzf0.2 cM
      vh cv eluzp1m1 mpan vk cv cF cfv cc wcel vk cM cuz cfv serzf0.3 rgen
      sylancl sylanc vh cv cM c1 caddc co cuz cfv wcel vh cv cF cfv cc wcel vh
      cv cF cfv cc0 cmin co vh cv cF cfv wceq vh cv cM c1 caddc co cuz cfv wcel
      vh cv cM cuz cfv wcel vh cv cF cfv cc wcel cM c1 caddc co cuz cfv cM cuz
      cfv vh cv cM c1 caddc co cM cuz cfv wcel cM c1 caddc co cuz cfv cM cuz
      cfv wss cM cM cuz cfv wcel cM c1 caddc co cM cuz cfv wcel cM cz wcel cM
      cM cuz cfv wcel serzf0.2 cM uzid ax-mp cM cM peano2uz ax-mp cM cM c1
      caddc co uzss ax-mp sseli vk cv cF cfv cc wcel vh cv cF cfv cc wcel vk vh
      cv cM cuz cfv vk cv vh cv wceq vk cv cF cfv vh cv cF cfv cc vk cv vh cv
      cF fveq2 eleq1d serzf0.3 vtoclga syl vh cv cF cfv subid1 syl 3eqtr4d
      fveq2d breq1d adantr sylibd syld adantrr syld expcom r19.21aiv sylanc
      exp32 r19.23adv adantr mpd ex mprgbir $.
      $( [13-Dec-2006] $) $( [2-Sep-2005] $)
  $}

  ${
    $d j k m n x F $.  $d k m n A $.
    ser1f0.1 $e |- F : NN --> CC $.
    ser1f0.2 $e |- A e. CC $.
    ser1f0.3 $e |- ( + seq1 F ) ~~> A $.
    $( If an infinite series converges, its underlying sequence converges to
       zero. (Proof shortened by Eric Schmidt, 31-Oct-2009.) $)
    ser1f0i $p |- F ~~> 0 $=
      cA vk cF c1 cn cc cF wf cn cvv wcel cF cvv wcel ser1f0.1 nnex cn cc cvv
      cF fex mp2an 1z vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cF cfv cc wcel
      vk cv elnnuz cn cc vk cv cF ser1f0.1 ffvelrni sylbir cA cc ser1f0.2
      elisseti caddc cF cseq1 co c1 caddc cop cF cseqz co cA cli caddc cF addex
      cn cc cF wf cn cvv wcel cF cvv wcel ser1f0.1 nnex cn cc cvv cF fex mp2an
      seq1seqz ser1f0.3 eqbrtrri serzf0i $.
      $( [1-Nov-2009] $) $( [29-Aug-2005] $)
  $}

  ${
    $d j k A $.  $d j N $.
    ser1const.1 $e |- A e. CC $.
    $( Value of the partial series sum of a constant function. $)
    ser1consti $p |- ( N e. NN ->
                   ( ( + seq1 ( NN X. { A } ) ) ` N ) = ( N x. A ) ) $=
      vj cv caddc cn cA csn cxp cseq1 co cfv vj cv cA cmul co wceq c1 caddc cn
      cA csn cxp cseq1 co cfv c1 cA cmul co wceq vk cv caddc cn cA csn cxp
      cseq1 co cfv vk cv cA cmul co wceq vk cv c1 caddc co caddc cn cA csn cxp
      cseq1 co cfv vk cv c1 caddc co cA cmul co wceq cN caddc cn cA csn cxp
      cseq1 co cfv cN cA cmul co wceq vj vk cN vj cv c1 wceq vj cv caddc cn cA
      csn cxp cseq1 co cfv c1 caddc cn cA csn cxp cseq1 co cfv vj cv cA cmul co
      c1 cA cmul co vj cv c1 caddc cn cA csn cxp cseq1 co fveq2 vj cv c1 cA
      cmul opreq1 eqeq12d vj cv vk cv wceq vj cv caddc cn cA csn cxp cseq1 co
      cfv vk cv caddc cn cA csn cxp cseq1 co cfv vj cv cA cmul co vk cv cA cmul
      co vj cv vk cv caddc cn cA csn cxp cseq1 co fveq2 vj cv vk cv cA cmul
      opreq1 eqeq12d vj cv vk cv c1 caddc co wceq vj cv caddc cn cA csn cxp
      cseq1 co cfv vk cv c1 caddc co caddc cn cA csn cxp cseq1 co cfv vj cv cA
      cmul co vk cv c1 caddc co cA cmul co vj cv vk cv c1 caddc co caddc cn cA
      csn cxp cseq1 co fveq2 vj cv vk cv c1 caddc co cA cmul opreq1 eqeq12d vj
      cv cN wceq vj cv caddc cn cA csn cxp cseq1 co cfv cN caddc cn cA csn cxp
      cseq1 co cfv vj cv cA cmul co cN cA cmul co vj cv cN caddc cn cA csn cxp
      cseq1 co fveq2 vj cv cN cA cmul opreq1 eqeq12d c1 cn cA csn cxp cfv cA c1
      caddc cn cA csn cxp cseq1 co cfv c1 cA cmul co c1 cn wcel c1 cn cA csn
      cxp cfv cA wceq 1nn cn cA c1 cA cc ser1const.1 elisseti fvconst2 ax-mp
      caddc cn cA csn cxp addex cn cA csn nnex cA snex xpex seq11 cA
      ser1const.1 mulid2i 3eqtr4i vk cv cn wcel vk cv caddc cn cA csn cxp cseq1
      co cfv vk cv cA cmul co wceq vk cv c1 caddc co caddc cn cA csn cxp cseq1
      co cfv vk cv c1 caddc co cA cmul co wceq vk cv cn wcel vk cv caddc cn cA
      csn cxp cseq1 co cfv vk cv cA cmul co wceq wa vk cv c1 caddc co caddc cn
      cA csn cxp cseq1 co cfv vk cv caddc cn cA csn cxp cseq1 co cfv cA caddc
      co vk cv c1 caddc co cA cmul co vk cv cn wcel vk cv c1 caddc co caddc cn
      cA csn cxp cseq1 co cfv vk cv caddc cn cA csn cxp cseq1 co cfv cA caddc
      co wceq vk cv caddc cn cA csn cxp cseq1 co cfv vk cv cA cmul co wceq vk
      cv cn wcel vk cv c1 caddc co caddc cn cA csn cxp cseq1 co cfv vk cv caddc
      cn cA csn cxp cseq1 co cfv vk cv c1 caddc co cn cA csn cxp cfv caddc co
      vk cv caddc cn cA csn cxp cseq1 co cfv cA caddc co vk cv caddc cn cA csn
      cxp addex cn cA csn nnex cA snex xpex seq1p1 vk cv cn wcel vk cv c1 caddc
      co cn cA csn cxp cfv cA vk cv caddc cn cA csn cxp cseq1 co cfv caddc vk
      cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cn cA csn cxp cfv
      cA wceq vk cv peano2nn cn cA vk cv c1 caddc co cA cc ser1const.1 elisseti
      fvconst2 syl opreq2d eqtrd adantr vk cv caddc cn cA csn cxp cseq1 co cfv
      vk cv cA cmul co wceq vk cv cn wcel vk cv caddc cn cA csn cxp cseq1 co
      cfv cA caddc co vk cv cA cmul co cA caddc co vk cv c1 caddc co cA cmul co
      vk cv caddc cn cA csn cxp cseq1 co cfv vk cv cA cmul co cA caddc opreq1
      vk cv cn wcel vk cv c1 caddc co cA cmul co vk cv cA cmul co c1 cA cmul co
      caddc co vk cv cA cmul co cA caddc co vk cv cn wcel vk cv cc wcel vk cv
      c1 caddc co cA cmul co vk cv cA cmul co c1 cA cmul co caddc co wceq vk cv
      nncn vk cv cc wcel c1 cc wcel cA cc wcel vk cv c1 caddc co cA cmul co vk
      cv cA cmul co c1 cA cmul co caddc co wceq ax1cn ser1const.1 vk cv c1 cA
      adddir mp3an23 syl c1 cA cmul co cA vk cv cA cmul co caddc cA ser1const.1
      mulid2i opreq2i syl6req sylan9eqr eqtrd ex nnind $.
      $( [10-Aug-2005] $) $( [8-Aug-2005] $)
  $}

  $( The value of the zero series. $)
  ser10 $p |- ( N e. NN -> ( ( + seq1 ( NN X. { 0 } ) ) ` N ) = 0 ) $=
    cN cn wcel cN caddc cn cc0 csn cxp cseq1 co cfv cN cc0 cmul co cc0 cc0 cN
    0cn ser1consti cN cn wcel cN cc wcel cN cc0 cmul co cc0 wceq cN nncn cN
    mul01 syl eqtrd $.
    $( [25-Apr-2005] $) $( [22-Apr-2005] $)

  ${
    $d j k x $.
    $( The zero series converges to zero. $)
    ser1clim0 $p |- ( + seq1 ( NN X. { 0 } ) ) ~~> 0 $=
      caddc cn cc0 csn cxp cseq1 co cc0 cli wbr cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co cabs cfv vx
      cv clt wbr wi vk cn wral vj cn wrex wi vx cr cn cc caddc cn cc0 csn cxp
      cseq1 co wf cc0 cc wcel caddc cn cc0 csn cxp cseq1 co cc0 cli wbr cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv
      cc0 cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral
      wb cn cc0 csn cxp cn cc0 csn cn cc0 csn cxp wf cc0 csn cc wss cn cc cn
      cc0 csn cxp wf cn cc0 cc0 cc 0cn elisseti fconst cc0 cc wcel cc0 csn cc
      wss 0cn cc0 cc snssi ax-mp cn cc0 csn cc cn cc0 csn cxp fss mp2an ser1fi
      0cn vx cc0 vj vk caddc cn cc0 csn cxp cseq1 co climfnn mp2an cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0
      cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cv cr wcel
      c1 cn wcel c1 vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0
      cmin co cabs cfv vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr vk cv
      caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co cabs cfv vx cv clt wbr wi
      vk cn wral vj cn wrex cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv caddc
      cn cc0 csn cxp cseq1 co cfv cc0 cmin co cabs cfv vx cv clt wbr wi vk cn
      wral c1 vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co
      cabs cfv vx cv clt wbr wi vk cn wral vj c1 cn vj cv c1 wceq vj cv vk cv
      cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co cabs cfv vx
      cv clt wbr wi c1 vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv
      cc0 cmin co cabs cfv vx cv clt wbr wi vk cn vj cv c1 wceq vj cv vk cv cle
      wbr c1 vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co
      cabs cfv vx cv clt wbr vj cv c1 vk cv cle breq1 imbi1d ralbidv rcla4ev
      1nn cc0 vx cv clt wbr c1 vk cv cle wbr vk cv caddc cn cc0 csn cxp cseq1
      co cfv cc0 cmin co cabs cfv vx cv clt wbr wi vk cn cc0 vx cv clt wbr vk
      cv cn wcel vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co cabs cfv
      vx cv clt wbr c1 vk cv cle wbr vk cv cn wcel vk cv caddc cn cc0 csn cxp
      cseq1 co cfv cc0 cmin co cabs cfv vx cv clt wbr cc0 vx cv clt wbr vk cv
      cn wcel vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin co cabs cfv cc0
      vx cv clt vk cv cn wcel vk cv caddc cn cc0 csn cxp cseq1 co cfv cc0 cmin
      co cabs cfv cc0 cabs cfv cc0 vk cv cn wcel vk cv caddc cn cc0 csn cxp
      cseq1 co cfv cc0 cmin co cc0 cabs vk cv cn wcel vk cv caddc cn cc0 csn
      cxp cseq1 co cfv cc0 cmin co cc0 cc0 cmin co cc0 vk cv cn wcel vk cv
      caddc cn cc0 csn cxp cseq1 co cfv cc0 cc0 cmin vk cv ser10 opreq1d cc0
      0cn subidi syl6eq fveq2d abs0 syl6eq breq1d biimprcd a1dd r19.21aiv
      sylancr a1i mprgbir $.
      $( [7-Jun-2006] $) $( [19-Apr-2005] $)
  $}

  ${
    $d y A $.  $d x y z F $.  $d x y z G $.
    ser1cmp.1 $e |- F : NN --> RR $.
    ser1cmp.2 $e |- G : NN --> RR $.
    ser1cmp.3 $e |- ( x e. NN -> ( G ` x ) <_ ( F ` x ) ) $.
    $( Comparison of partial sums of two infinite series of reals. $)
    ser1cmpi $p |- ( A e. NN -> ( ( + seq1 G ) ` A ) <_
                  ( ( + seq1 F ) ` A ) ) $=
      vy cv caddc cG cseq1 co cfv vy cv caddc cF cseq1 co cfv cle wbr c1 caddc
      cG cseq1 co cfv c1 caddc cF cseq1 co cfv cle wbr vz cv caddc cG cseq1 co
      cfv vz cv caddc cF cseq1 co cfv cle wbr vz cv c1 caddc co caddc cG cseq1
      co cfv vz cv c1 caddc co caddc cF cseq1 co cfv cle wbr cA caddc cG cseq1
      co cfv cA caddc cF cseq1 co cfv cle wbr vy vz cA vy cv c1 wceq vy cv
      caddc cG cseq1 co cfv c1 caddc cG cseq1 co cfv vy cv caddc cF cseq1 co
      cfv c1 caddc cF cseq1 co cfv cle vy cv c1 caddc cG cseq1 co fveq2 vy cv
      c1 caddc cF cseq1 co fveq2 breq12d vy cv vz cv wceq vy cv caddc cG cseq1
      co cfv vz cv caddc cG cseq1 co cfv vy cv caddc cF cseq1 co cfv vz cv
      caddc cF cseq1 co cfv cle vy cv vz cv caddc cG cseq1 co fveq2 vy cv vz cv
      caddc cF cseq1 co fveq2 breq12d vy cv vz cv c1 caddc co wceq vy cv caddc
      cG cseq1 co cfv vz cv c1 caddc co caddc cG cseq1 co cfv vy cv caddc cF
      cseq1 co cfv vz cv c1 caddc co caddc cF cseq1 co cfv cle vy cv vz cv c1
      caddc co caddc cG cseq1 co fveq2 vy cv vz cv c1 caddc co caddc cF cseq1
      co fveq2 breq12d vy cv cA wceq vy cv caddc cG cseq1 co cfv cA caddc cG
      cseq1 co cfv vy cv caddc cF cseq1 co cfv cA caddc cF cseq1 co cfv cle vy
      cv cA caddc cG cseq1 co fveq2 vy cv cA caddc cF cseq1 co fveq2 breq12d c1
      cG cfv c1 cF cfv c1 caddc cG cseq1 co cfv c1 caddc cF cseq1 co cfv cle c1
      cn wcel c1 cG cfv c1 cF cfv cle wbr 1nn vx cv cG cfv vx cv cF cfv cle wbr
      c1 cG cfv c1 cF cfv cle wbr vx c1 cn vx cv c1 wceq vx cv cG cfv c1 cG cfv
      vx cv cF cfv c1 cF cfv cle vx cv c1 cG fveq2 vx cv c1 cF fveq2 breq12d
      ser1cmp.3 vtoclga ax-mp caddc cG addex cn cr cG wf cn cvv wcel cG cvv
      wcel ser1cmp.2 nnex cn cr cvv cG fex mp2an seq11 caddc cF addex cn cr cF
      wf cn cvv wcel cF cvv wcel ser1cmp.1 nnex cn cr cvv cF fex mp2an seq11
      3brtr4i vz cv cn wcel vz cv caddc cG cseq1 co cfv vz cv caddc cF cseq1 co
      cfv cle wbr vz cv c1 caddc co caddc cG cseq1 co cfv vz cv c1 caddc co
      caddc cF cseq1 co cfv cle wbr vz cv cn wcel vz cv caddc cG cseq1 co cfv
      vz cv caddc cF cseq1 co cfv cle wbr wa vz cv caddc cG cseq1 co cfv vz cv
      c1 caddc co cG cfv caddc co vz cv caddc cF cseq1 co cfv vz cv c1 caddc co
      cF cfv caddc co vz cv c1 caddc co caddc cG cseq1 co cfv vz cv c1 caddc co
      caddc cF cseq1 co cfv cle vz cv cn wcel vz cv caddc cG cseq1 co cfv vz cv
      caddc cF cseq1 co cfv cle wbr wa vz cv caddc cG cseq1 co cfv vz cv c1
      caddc co cG cfv caddc co vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cG
      cfv caddc co vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cF cfv caddc
      co vz cv cn wcel vz cv caddc cG cseq1 co cfv vz cv c1 caddc co cG cfv
      caddc co cr wcel vz cv caddc cG cseq1 co cfv vz cv caddc cF cseq1 co cfv
      cle wbr vz cv caddc cG cseq1 co cfv cr wcel vz cv c1 caddc co cG cfv cr
      wcel vz cv caddc cG cseq1 co cfv vz cv c1 caddc co cG cfv caddc co cr
      wcel vz cv cn wcel vz cv caddc cG cseq1 co cfv vz cv c1 caddc co cG cfv
      readdcl vz cv cG ser1cmp.2 ser1recli vz cv cn wcel vz cv c1 caddc co cn
      wcel vz cv c1 caddc co cG cfv cr wcel vz cv peano2nn cn cr vz cv c1 caddc
      co cG ser1cmp.2 ffvelrni syl sylanc adantr vz cv cn wcel vz cv caddc cF
      cseq1 co cfv vz cv c1 caddc co cG cfv caddc co cr wcel vz cv caddc cG
      cseq1 co cfv vz cv caddc cF cseq1 co cfv cle wbr vz cv caddc cF cseq1 co
      cfv cr wcel vz cv c1 caddc co cG cfv cr wcel vz cv caddc cF cseq1 co cfv
      vz cv c1 caddc co cG cfv caddc co cr wcel vz cv cn wcel vz cv caddc cF
      cseq1 co cfv vz cv c1 caddc co cG cfv readdcl vz cv cF ser1cmp.1
      ser1recli vz cv cn wcel vz cv c1 caddc co cn wcel vz cv c1 caddc co cG
      cfv cr wcel vz cv peano2nn cn cr vz cv c1 caddc co cG ser1cmp.2 ffvelrni
      syl sylanc adantr vz cv cn wcel vz cv caddc cF cseq1 co cfv vz cv c1
      caddc co cF cfv caddc co cr wcel vz cv caddc cG cseq1 co cfv vz cv caddc
      cF cseq1 co cfv cle wbr vz cv caddc cF cseq1 co cfv cr wcel vz cv c1
      caddc co cF cfv cr wcel vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cF
      cfv caddc co cr wcel vz cv cn wcel vz cv caddc cF cseq1 co cfv vz cv c1
      caddc co cF cfv readdcl vz cv cF ser1cmp.1 ser1recli vz cv cn wcel vz cv
      c1 caddc co cn wcel vz cv c1 caddc co cF cfv cr wcel vz cv peano2nn cn cr
      vz cv c1 caddc co cF ser1cmp.1 ffvelrni syl sylanc adantr vz cv cn wcel
      vz cv caddc cG cseq1 co cfv vz cv caddc cF cseq1 co cfv cle wbr vz cv
      caddc cG cseq1 co cfv vz cv c1 caddc co cG cfv caddc co vz cv caddc cF
      cseq1 co cfv vz cv c1 caddc co cG cfv caddc co cle wbr vz cv caddc cG
      cseq1 co cfv cr wcel vz cv caddc cF cseq1 co cfv cr wcel vz cv c1 caddc
      co cG cfv cr wcel vz cv caddc cG cseq1 co cfv vz cv caddc cF cseq1 co cfv
      cle wbr vz cv caddc cG cseq1 co cfv vz cv c1 caddc co cG cfv caddc co vz
      cv caddc cF cseq1 co cfv vz cv c1 caddc co cG cfv caddc co cle wbr wb vz
      cv cn wcel vz cv caddc cG cseq1 co cfv vz cv caddc cF cseq1 co cfv vz cv
      c1 caddc co cG cfv leadd1 vz cv cG ser1cmp.2 ser1recli vz cv cF ser1cmp.1
      ser1recli vz cv cn wcel vz cv c1 caddc co cn wcel vz cv c1 caddc co cG
      cfv cr wcel vz cv peano2nn cn cr vz cv c1 caddc co cG ser1cmp.2 ffvelrni
      syl syl3anc biimpa vz cv cn wcel vz cv caddc cF cseq1 co cfv vz cv c1
      caddc co cG cfv caddc co vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cF
      cfv caddc co cle wbr vz cv caddc cG cseq1 co cfv vz cv caddc cF cseq1 co
      cfv cle wbr vz cv cn wcel vz cv c1 caddc co cG cfv vz cv c1 caddc co cF
      cfv cle wbr vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cG cfv caddc co
      vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cF cfv caddc co cle wbr vz
      cv cn wcel vz cv c1 caddc co cn wcel vz cv c1 caddc co cG cfv vz cv c1
      caddc co cF cfv cle wbr vz cv peano2nn vx cv cG cfv vx cv cF cfv cle wbr
      vz cv c1 caddc co cG cfv vz cv c1 caddc co cF cfv cle wbr vx vz cv c1
      caddc co cn vx cv vz cv c1 caddc co wceq vx cv cG cfv vz cv c1 caddc co
      cG cfv vx cv cF cfv vz cv c1 caddc co cF cfv cle vx cv vz cv c1 caddc co
      cG fveq2 vx cv vz cv c1 caddc co cF fveq2 breq12d ser1cmp.3 vtoclga syl
      vz cv c1 caddc co cG cfv cr wcel vz cv c1 caddc co cF cfv cr wcel vz cv
      caddc cF cseq1 co cfv cr wcel vz cv c1 caddc co cG cfv vz cv c1 caddc co
      cF cfv cle wbr vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cG cfv caddc
      co vz cv caddc cF cseq1 co cfv vz cv c1 caddc co cF cfv caddc co cle wbr
      wb vz cv cn wcel vz cv c1 caddc co cG cfv vz cv c1 caddc co cF cfv vz cv
      caddc cF cseq1 co cfv leadd2 vz cv cn wcel vz cv c1 caddc co cn wcel vz
      cv c1 caddc co cG cfv cr wcel vz cv peano2nn cn cr vz cv c1 caddc co cG
      ser1cmp.2 ffvelrni syl vz cv cn wcel vz cv c1 caddc co cn wcel vz cv c1
      caddc co cF cfv cr wcel vz cv peano2nn cn cr vz cv c1 caddc co cF
      ser1cmp.1 ffvelrni syl vz cv cF ser1cmp.1 ser1recli syl3anc mpbid adantr
      letrd vz cv cn wcel vz cv c1 caddc co caddc cG cseq1 co cfv vz cv caddc
      cG cseq1 co cfv vz cv c1 caddc co cG cfv caddc co wceq vz cv caddc cG
      cseq1 co cfv vz cv caddc cF cseq1 co cfv cle wbr vz cv caddc cG addex cn
      cr cG wf cn cvv wcel cG cvv wcel ser1cmp.2 nnex cn cr cvv cG fex mp2an
      seq1p1 adantr vz cv cn wcel vz cv c1 caddc co caddc cF cseq1 co cfv vz cv
      caddc cF cseq1 co cfv vz cv c1 caddc co cF cfv caddc co wceq vz cv caddc
      cG cseq1 co cfv vz cv caddc cF cseq1 co cfv cle wbr vz cv caddc cF addex
      cn cr cF wf cn cvv wcel cF cvv wcel ser1cmp.1 nnex cn cr cvv cF fex mp2an
      seq1p1 adantr 3brtr4d ex nnind $.
      $( [5-Apr-2005] $) $( [18-Mar-2005] $)
  $}

  ${
    $d y A $.  $d x y z F $.  $d x y z G $.
    ser1cmp0.1 $e |- F : NN --> RR $.
    ser1cmp0.2 $e |- ( x e. NN -> 0 <_ ( F ` x ) ) $.
    $( A partial sum of an infinite series of nonnegative reals is
       nonnegative. $)
    ser1cmp0i $p |- ( A e. NN -> 0 <_ ( ( + seq1 F ) ` A ) ) $=
      cA cn wcel cA caddc cn cc0 csn cxp cseq1 co cfv cc0 cA caddc cF cseq1 co
      cfv cle cA ser10 vx cA cF cn cc0 csn cxp ser1cmp0.1 cn cc0 csn cn cc0 csn
      cxp wf cc0 csn cr wss cn cr cn cc0 csn cxp wf cn cc0 cc0 cr 0re elisseti
      fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp cn cc0 csn cr cn
      cc0 csn cxp fss mp2an vx cv cn wcel vx cv cn cc0 csn cxp cfv cc0 vx cv cF
      cfv cle cn cc0 vx cv cc0 cr 0re elisseti fvconst2 ser1cmp0.2 eqbrtrd
      ser1cmpi eqbrtrrd $.
      $( [26-Apr-2005] $) $( [22-Apr-2005] $)
  $}

  ${
    $d z A $.  $d x y w z B $.  $d x w z F $.  $d x w z G $.  $d w z S $.
    ser1cmp2.1 $e |- F : NN --> RR $.
    ser1cmp2.2 $e |- G : NN --> RR $.
    ser1cmp2.3 $e |- ( x e. NN -> 0 <_ ( F ` x ) ) $.
    ser1cmp2.4 $e |- ( ( x e. NN /\ B < x ) ->
                    ( G ` x ) <_ ( F ` x ) ) $.
    ser1cmp2.5 $e |- S =
               sup ( ran ( ( + seq1 G ) |` { y e. NN | y <_ B } ) , RR , < ) $.
    $( Lemma for ~ ser1cmp2i . $)
    ser1cmp2lem $p |- ( ( A e. NN /\ B e. NN ) -> ( A <_ B -> ( ( + seq1 G ) `
          A ) <_ ( S + ( ( + seq1 F ) ` A ) ) ) ) $=
      cA cn wcel cB cn wcel wa cA cB cle wbr cA caddc cG cseq1 co cfv cS cle
      wbr cA caddc cG cseq1 co cfv cS cA caddc cF cseq1 co cfv caddc co cle wbr
      cA cn wcel cB cn wcel cA cB cle wbr cA caddc cG cseq1 co cfv cS cle wbr
      cA cn wcel cB cn wcel cA cB cle wbr w3a cA caddc cG cseq1 co cfv caddc cG
      cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup cS cle vy cA cB
      caddc cG cseq1 co cG ser1cmp2.2 ser1refi seq1ubi ser1cmp2.5 syl6breqr
      3expia cA cn wcel cB cn wcel wa cA caddc cG cseq1 co cfv cS cle wbr cS cS
      cA caddc cF cseq1 co cfv caddc co cle wbr cA caddc cG cseq1 co cfv cS cA
      caddc cF cseq1 co cfv caddc co cle wbr cS cr wcel cA caddc cF cseq1 co
      cfv cr wcel cc0 cA caddc cF cseq1 co cfv cle wbr cS cS cA caddc cF cseq1
      co cfv caddc co cle wbr cA cn wcel cB cn wcel wa cS cr wcel cA caddc cF
      cseq1 co cfv cr wcel cc0 cA caddc cF cseq1 co cfv cle wbr cS cS cA caddc
      cF cseq1 co cfv caddc co cle wbr cS cA caddc cF cseq1 co cfv addge01
      biimp3a cB cn wcel cS cr wcel cA cn wcel cB cn wcel caddc cG cseq1 co vy
      cv cB cle wbr vy cn crab cres crn cr clt csup cr cS cB cn wcel caddc cG
      cseq1 co vy cv cB cle wbr vy cn crab cres crn cr wss caddc cG cseq1 co vy
      cv cB cle wbr vy cn crab cres crn c0 wne vz cv vx cv cle wbr vz caddc cG
      cseq1 co vy cv cB cle wbr vy cn crab cres crn wral vx cr wrex w3a caddc
      cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr wcel vy
      vx vz cB caddc cG cseq1 co cG ser1cmp2.2 ser1refi seq1ublem vx vz caddc
      cG cseq1 co vy cv cB cle wbr vy cn crab cres crn suprcl syl ser1cmp2.5
      syl5eqel adantl cA cn wcel cA caddc cF cseq1 co cfv cr wcel cB cn wcel cA
      cF ser1cmp2.1 ser1recli adantr cA cn wcel cc0 cA caddc cF cseq1 co cfv
      cle wbr cB cn wcel vx cA cF ser1cmp2.1 ser1cmp2.3 ser1cmp0i adantr
      syl3anc cA caddc cG cseq1 co cfv cr wcel cS cr wcel cS cA caddc cF cseq1
      co cfv caddc co cr wcel cA caddc cG cseq1 co cfv cS cle wbr cS cS cA
      caddc cF cseq1 co cfv caddc co cle wbr wa cA caddc cG cseq1 co cfv cS cA
      caddc cF cseq1 co cfv caddc co cle wbr wi cA cn wcel cB cn wcel wa cA
      caddc cG cseq1 co cfv cS cS cA caddc cF cseq1 co cfv caddc co letr cA cn
      wcel cA caddc cG cseq1 co cfv cr wcel cB cn wcel cA cG ser1cmp2.2
      ser1recli adantr cB cn wcel cS cr wcel cA cn wcel cB cn wcel caddc cG
      cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr cS cB cn
      wcel caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr wss caddc
      cG cseq1 co vy cv cB cle wbr vy cn crab cres crn c0 wne vz cv vx cv cle
      wbr vz caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn wral vx cr
      wrex w3a caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt
      csup cr wcel vy vx vz cB caddc cG cseq1 co cG ser1cmp2.2 ser1refi
      seq1ublem vx vz caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
      suprcl syl ser1cmp2.5 syl5eqel adantl cB cn wcel cA cn wcel cS cA caddc
      cF cseq1 co cfv caddc co cr wcel cS cr wcel cA caddc cF cseq1 co cfv cr
      wcel cS cA caddc cF cseq1 co cfv caddc co cr wcel cB cn wcel cA cn wcel
      cS cA caddc cF cseq1 co cfv readdcl cB cn wcel caddc cG cseq1 co vy cv cB
      cle wbr vy cn crab cres crn cr clt csup cr cS cB cn wcel caddc cG cseq1
      co vy cv cB cle wbr vy cn crab cres crn cr wss caddc cG cseq1 co vy cv cB
      cle wbr vy cn crab cres crn c0 wne vz cv vx cv cle wbr vz caddc cG cseq1
      co vy cv cB cle wbr vy cn crab cres crn wral vx cr wrex w3a caddc cG
      cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr wcel vy vx
      vz cB caddc cG cseq1 co cG ser1cmp2.2 ser1refi seq1ublem vx vz caddc cG
      cseq1 co vy cv cB cle wbr vy cn crab cres crn suprcl syl ser1cmp2.5
      syl5eqel cA cF ser1cmp2.1 ser1recli syl2an ancoms syl3anc mpan2d syld $.
      $( [25-Jul-2006] $) $( [23-Apr-2005] $)

    $( Comparison of partial sums of two infinite series of reals that
       excludes an initial segment. $)
    ser1cmp2i $p |- ( ( A e. NN /\ B e. NN ) -> ( ( + seq1 G ) ` A ) <_
            ( S + ( ( + seq1 F ) ` A ) ) ) $=
      cA cn wcel cB cn wcel cA caddc cG cseq1 co cfv cS cA caddc cF cseq1 co
      cfv caddc co cle wbr cB cn wcel vz cv caddc cG cseq1 co cfv cS vz cv
      caddc cF cseq1 co cfv caddc co cle wbr wi cB cn wcel c1 caddc cG cseq1 co
      cfv cS c1 caddc cF cseq1 co cfv caddc co cle wbr wi cB cn wcel vw cv
      caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr wi
      cB cn wcel vw cv c1 caddc co caddc cG cseq1 co cfv cS vw cv c1 caddc co
      caddc cF cseq1 co cfv caddc co cle wbr wi cB cn wcel cA caddc cG cseq1 co
      cfv cS cA caddc cF cseq1 co cfv caddc co cle wbr wi vz vw cA vz cv c1
      wceq vz cv caddc cG cseq1 co cfv cS vz cv caddc cF cseq1 co cfv caddc co
      cle wbr c1 caddc cG cseq1 co cfv cS c1 caddc cF cseq1 co cfv caddc co cle
      wbr cB cn wcel vz cv c1 wceq vz cv caddc cG cseq1 co cfv c1 caddc cG
      cseq1 co cfv cS vz cv caddc cF cseq1 co cfv caddc co cS c1 caddc cF cseq1
      co cfv caddc co cle vz cv c1 caddc cG cseq1 co fveq2 vz cv c1 wceq vz cv
      caddc cF cseq1 co cfv c1 caddc cF cseq1 co cfv cS caddc vz cv c1 caddc cF
      cseq1 co fveq2 opreq2d breq12d imbi2d vz cv vw cv wceq vz cv caddc cG
      cseq1 co cfv cS vz cv caddc cF cseq1 co cfv caddc co cle wbr vw cv caddc
      cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr cB cn
      wcel vz cv vw cv wceq vz cv caddc cG cseq1 co cfv vw cv caddc cG cseq1 co
      cfv cS vz cv caddc cF cseq1 co cfv caddc co cS vw cv caddc cF cseq1 co
      cfv caddc co cle vz cv vw cv caddc cG cseq1 co fveq2 vz cv vw cv wceq vz
      cv caddc cF cseq1 co cfv vw cv caddc cF cseq1 co cfv cS caddc vz cv vw cv
      caddc cF cseq1 co fveq2 opreq2d breq12d imbi2d vz cv vw cv c1 caddc co
      wceq vz cv caddc cG cseq1 co cfv cS vz cv caddc cF cseq1 co cfv caddc co
      cle wbr vw cv c1 caddc co caddc cG cseq1 co cfv cS vw cv c1 caddc co
      caddc cF cseq1 co cfv caddc co cle wbr cB cn wcel vz cv vw cv c1 caddc co
      wceq vz cv caddc cG cseq1 co cfv vw cv c1 caddc co caddc cG cseq1 co cfv
      cS vz cv caddc cF cseq1 co cfv caddc co cS vw cv c1 caddc co caddc cF
      cseq1 co cfv caddc co cle vz cv vw cv c1 caddc co caddc cG cseq1 co fveq2
      vz cv vw cv c1 caddc co wceq vz cv caddc cF cseq1 co cfv vw cv c1 caddc
      co caddc cF cseq1 co cfv cS caddc vz cv vw cv c1 caddc co caddc cF cseq1
      co fveq2 opreq2d breq12d imbi2d vz cv cA wceq vz cv caddc cG cseq1 co cfv
      cS vz cv caddc cF cseq1 co cfv caddc co cle wbr cA caddc cG cseq1 co cfv
      cS cA caddc cF cseq1 co cfv caddc co cle wbr cB cn wcel vz cv cA wceq vz
      cv caddc cG cseq1 co cfv cA caddc cG cseq1 co cfv cS vz cv caddc cF cseq1
      co cfv caddc co cS cA caddc cF cseq1 co cfv caddc co cle vz cv cA caddc
      cG cseq1 co fveq2 vz cv cA wceq vz cv caddc cF cseq1 co cfv cA caddc cF
      cseq1 co cfv cS caddc vz cv cA caddc cF cseq1 co fveq2 opreq2d breq12d
      imbi2d cB cn wcel c1 cB cle wbr c1 caddc cG cseq1 co cfv cS c1 caddc cF
      cseq1 co cfv caddc co cle wbr cB nnge1 c1 cn wcel cB cn wcel c1 cB cle
      wbr c1 caddc cG cseq1 co cfv cS c1 caddc cF cseq1 co cfv caddc co cle wbr
      wi 1nn vx vy c1 cB cS cF cG ser1cmp2.1 ser1cmp2.2 ser1cmp2.3 ser1cmp2.4
      ser1cmp2.5 ser1cmp2lem mpan mpd vw cv cn wcel cB cn wcel vw cv caddc cG
      cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr vw cv c1
      caddc co caddc cG cseq1 co cfv cS vw cv c1 caddc co caddc cF cseq1 co cfv
      caddc co cle wbr vw cv cn wcel cB cn wcel vw cv caddc cG cseq1 co cfv cS
      vw cv caddc cF cseq1 co cfv caddc co cle wbr vw cv c1 caddc co caddc cG
      cseq1 co cfv cS vw cv c1 caddc co caddc cF cseq1 co cfv caddc co cle wbr
      wi vw cv cn wcel cB cn wcel wa vw cv c1 caddc co cB cle wbr cB vw cv c1
      caddc co clt wbr wo vw cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1
      co cfv caddc co cle wbr vw cv c1 caddc co caddc cG cseq1 co cfv cS vw cv
      c1 caddc co caddc cF cseq1 co cfv caddc co cle wbr wi vw cv c1 caddc co
      cr wcel cB cr wcel vw cv c1 caddc co cB cle wbr cB vw cv c1 caddc co clt
      wbr wo vw cv cn wcel cB cn wcel vw cv c1 caddc co cB lelttric vw cv cn
      wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cr wcel vw cv peano2nn
      vw cv c1 caddc co nnre syl cB nnre syl2an vw cv cn wcel cB cn wcel wa vw
      cv c1 caddc co cB cle wbr vw cv caddc cG cseq1 co cfv cS vw cv caddc cF
      cseq1 co cfv caddc co cle wbr vw cv c1 caddc co caddc cG cseq1 co cfv cS
      vw cv c1 caddc co caddc cF cseq1 co cfv caddc co cle wbr wi cB vw cv c1
      caddc co clt wbr vw cv cn wcel cB cn wcel wa vw cv c1 caddc co cB cle wbr
      vw cv c1 caddc co caddc cG cseq1 co cfv cS vw cv c1 caddc co caddc cF
      cseq1 co cfv caddc co cle wbr vw cv caddc cG cseq1 co cfv cS vw cv caddc
      cF cseq1 co cfv caddc co cle wbr vw cv c1 caddc co cn wcel cB cn wcel vw
      cv c1 caddc co cB cle wbr vw cv c1 caddc co caddc cG cseq1 co cfv cS vw
      cv c1 caddc co caddc cF cseq1 co cfv caddc co cle wbr wi vw cv cn wcel vx
      vy vw cv c1 caddc co cB cS cF cG ser1cmp2.1 ser1cmp2.2 ser1cmp2.3
      ser1cmp2.4 ser1cmp2.5 ser1cmp2lem vw cv peano2nn sylan a1dd vw cv cn wcel
      cB cn wcel wa cB vw cv c1 caddc co clt wbr vw cv caddc cG cseq1 co cfv cS
      vw cv caddc cF cseq1 co cfv caddc co cle wbr vw cv c1 caddc co caddc cG
      cseq1 co cfv cS vw cv c1 caddc co caddc cF cseq1 co cfv caddc co cle wbr
      wi vw cv cn wcel cB cn wcel cB vw cv c1 caddc co clt wbr vw cv caddc cG
      cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr vw cv c1
      caddc co caddc cG cseq1 co cfv cS vw cv c1 caddc co caddc cF cseq1 co cfv
      caddc co cle wbr wi vw cv cn wcel cB cn wcel cB vw cv c1 caddc co clt wbr
      wa wa vw cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co
      cle wbr vw cv c1 caddc co caddc cG cseq1 co cfv cS vw cv c1 caddc co
      caddc cF cseq1 co cfv caddc co cle wbr vw cv cn wcel cB cn wcel cB vw cv
      c1 caddc co clt wbr wa wa vw cv caddc cG cseq1 co cfv cS vw cv caddc cF
      cseq1 co cfv caddc co cle wbr wa vw cv caddc cG cseq1 co cfv vw cv c1
      caddc co cG cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1
      caddc co cF cfv caddc co vw cv c1 caddc co caddc cG cseq1 co cfv cS vw cv
      c1 caddc co caddc cF cseq1 co cfv caddc co cle vw cv cn wcel cB cn wcel
      cB vw cv c1 caddc co clt wbr wa wa vw cv caddc cG cseq1 co cfv cS vw cv
      caddc cF cseq1 co cfv caddc co cle wbr wa vw cv caddc cG cseq1 co cfv vw
      cv c1 caddc co cG cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw
      cv c1 caddc co cG cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw
      cv c1 caddc co cF cfv caddc co vw cv cn wcel vw cv caddc cG cseq1 co cfv
      vw cv c1 caddc co cG cfv caddc co cr wcel cB cn wcel cB vw cv c1 caddc co
      clt wbr wa vw cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv
      caddc co cle wbr vw cv caddc cG cseq1 co cfv cr wcel vw cv c1 caddc co cG
      cfv cr wcel vw cv caddc cG cseq1 co cfv vw cv c1 caddc co cG cfv caddc co
      cr wcel vw cv cn wcel vw cv caddc cG cseq1 co cfv vw cv c1 caddc co cG
      cfv readdcl vw cv cG ser1cmp2.2 ser1recli vw cv cn wcel vw cv c1 caddc co
      cn wcel vw cv c1 caddc co cG cfv cr wcel vw cv peano2nn cn cr vw cv c1
      caddc co cG ser1cmp2.2 ffvelrni syl sylanc ad2antrr vw cv cn wcel cB cn
      wcel cB vw cv c1 caddc co clt wbr wa wa cS vw cv caddc cF cseq1 co cfv
      caddc co vw cv c1 caddc co cG cfv caddc co cr wcel vw cv caddc cG cseq1
      co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr vw cv cn wcel cB
      cn wcel cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cG cfv
      caddc co cr wcel cB vw cv c1 caddc co clt wbr cS vw cv caddc cF cseq1 co
      cfv caddc co cr wcel vw cv c1 caddc co cG cfv cr wcel cS vw cv caddc cF
      cseq1 co cfv caddc co vw cv c1 caddc co cG cfv caddc co cr wcel vw cv cn
      wcel cB cn wcel wa cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc
      co cG cfv readdcl cB cn wcel vw cv cn wcel cS vw cv caddc cF cseq1 co cfv
      caddc co cr wcel cS cr wcel vw cv caddc cF cseq1 co cfv cr wcel cS vw cv
      caddc cF cseq1 co cfv caddc co cr wcel cB cn wcel vw cv cn wcel cS vw cv
      caddc cF cseq1 co cfv readdcl cB cn wcel caddc cG cseq1 co vy cv cB cle
      wbr vy cn crab cres crn cr clt csup cr cS cB cn wcel caddc cG cseq1 co vy
      cv cB cle wbr vy cn crab cres crn cr wss caddc cG cseq1 co vy cv cB cle
      wbr vy cn crab cres crn c0 wne vw cv vz cv cle wbr vw caddc cG cseq1 co
      vy cv cB cle wbr vy cn crab cres crn wral vz cr wrex w3a caddc cG cseq1
      co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr wcel vy vz vw cB
      caddc cG cseq1 co cG ser1cmp2.2 ser1refi seq1ublem vz vw caddc cG cseq1
      co vy cv cB cle wbr vy cn crab cres crn suprcl syl ser1cmp2.5 syl5eqel vw
      cv cF ser1cmp2.1 ser1recli syl2an ancoms vw cv cn wcel vw cv c1 caddc co
      cG cfv cr wcel cB cn wcel vw cv cn wcel vw cv c1 caddc co cn wcel vw cv
      c1 caddc co cG cfv cr wcel vw cv peano2nn cn cr vw cv c1 caddc co cG
      ser1cmp2.2 ffvelrni syl adantr sylanc adantrr adantr vw cv cn wcel cB cn
      wcel cB vw cv c1 caddc co clt wbr wa wa cS vw cv caddc cF cseq1 co cfv
      caddc co vw cv c1 caddc co cF cfv caddc co cr wcel vw cv caddc cG cseq1
      co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr vw cv cn wcel cB
      cn wcel cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cF cfv
      caddc co cr wcel cB vw cv c1 caddc co clt wbr cS vw cv caddc cF cseq1 co
      cfv caddc co cr wcel vw cv c1 caddc co cF cfv cr wcel cS vw cv caddc cF
      cseq1 co cfv caddc co vw cv c1 caddc co cF cfv caddc co cr wcel vw cv cn
      wcel cB cn wcel wa cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc
      co cF cfv readdcl cB cn wcel vw cv cn wcel cS vw cv caddc cF cseq1 co cfv
      caddc co cr wcel cS cr wcel vw cv caddc cF cseq1 co cfv cr wcel cS vw cv
      caddc cF cseq1 co cfv caddc co cr wcel cB cn wcel vw cv cn wcel cS vw cv
      caddc cF cseq1 co cfv readdcl cB cn wcel caddc cG cseq1 co vy cv cB cle
      wbr vy cn crab cres crn cr clt csup cr cS cB cn wcel caddc cG cseq1 co vy
      cv cB cle wbr vy cn crab cres crn cr wss caddc cG cseq1 co vy cv cB cle
      wbr vy cn crab cres crn c0 wne vw cv vz cv cle wbr vw caddc cG cseq1 co
      vy cv cB cle wbr vy cn crab cres crn wral vz cr wrex w3a caddc cG cseq1
      co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr wcel vy vz vw cB
      caddc cG cseq1 co cG ser1cmp2.2 ser1refi seq1ublem vz vw caddc cG cseq1
      co vy cv cB cle wbr vy cn crab cres crn suprcl syl ser1cmp2.5 syl5eqel vw
      cv cF ser1cmp2.1 ser1recli syl2an ancoms vw cv cn wcel vw cv c1 caddc co
      cF cfv cr wcel cB cn wcel vw cv cn wcel vw cv c1 caddc co cn wcel vw cv
      c1 caddc co cF cfv cr wcel vw cv peano2nn cn cr vw cv c1 caddc co cF
      ser1cmp2.1 ffvelrni syl adantr sylanc adantrr adantr vw cv cn wcel cB cn
      wcel vw cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co
      cle wbr vw cv caddc cG cseq1 co cfv vw cv c1 caddc co cG cfv caddc co cS
      vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cG cfv caddc co
      cle wbr cB vw cv c1 caddc co clt wbr vw cv cn wcel cB cn wcel wa vw cv
      caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co cle wbr vw
      cv caddc cG cseq1 co cfv vw cv c1 caddc co cG cfv caddc co cS vw cv caddc
      cF cseq1 co cfv caddc co vw cv c1 caddc co cG cfv caddc co cle wbr vw cv
      caddc cG cseq1 co cfv cr wcel cS vw cv caddc cF cseq1 co cfv caddc co cr
      wcel vw cv c1 caddc co cG cfv cr wcel vw cv caddc cG cseq1 co cfv cS vw
      cv caddc cF cseq1 co cfv caddc co cle wbr vw cv caddc cG cseq1 co cfv vw
      cv c1 caddc co cG cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw
      cv c1 caddc co cG cfv caddc co cle wbr wb vw cv cn wcel cB cn wcel wa vw
      cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1
      caddc co cG cfv leadd1 vw cv cn wcel vw cv caddc cG cseq1 co cfv cr wcel
      cB cn wcel vw cv cG ser1cmp2.2 ser1recli adantr cB cn wcel vw cv cn wcel
      cS vw cv caddc cF cseq1 co cfv caddc co cr wcel cS cr wcel vw cv caddc cF
      cseq1 co cfv cr wcel cS vw cv caddc cF cseq1 co cfv caddc co cr wcel cB
      cn wcel vw cv cn wcel cS vw cv caddc cF cseq1 co cfv readdcl cB cn wcel
      caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr cS
      cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr wss
      caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn c0 wne vw cv vz cv
      cle wbr vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn wral vz
      cr wrex w3a caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt
      csup cr wcel vy vz vw cB caddc cG cseq1 co cG ser1cmp2.2 ser1refi
      seq1ublem vz vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
      suprcl syl ser1cmp2.5 syl5eqel vw cv cF ser1cmp2.1 ser1recli syl2an
      ancoms vw cv cn wcel vw cv c1 caddc co cG cfv cr wcel cB cn wcel vw cv cn
      wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cG cfv cr wcel vw cv
      peano2nn cn cr vw cv c1 caddc co cG ser1cmp2.2 ffvelrni syl adantr
      syl3anc biimpa adantlrr vw cv cn wcel cB cn wcel cB vw cv c1 caddc co clt
      wbr wa wa cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cG
      cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cF
      cfv caddc co cle wbr vw cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1
      co cfv caddc co cle wbr vw cv cn wcel cB cn wcel cB vw cv c1 caddc co clt
      wbr wa wa vw cv c1 caddc co cG cfv vw cv c1 caddc co cF cfv cle wbr cS vw
      cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cG cfv caddc co cS vw
      cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cF cfv caddc co cle
      wbr vw cv cn wcel cB vw cv c1 caddc co clt wbr vw cv c1 caddc co cG cfv
      vw cv c1 caddc co cF cfv cle wbr cB cn wcel vw cv c1 caddc co cn wcel cB
      vw cv c1 caddc co clt wbr vw cv c1 caddc co cG cfv vw cv c1 caddc co cF
      cfv cle wbr vw cv cn wcel vw cv c1 caddc co cn wcel cB vw cv c1 caddc co
      clt wbr vw cv c1 caddc co cG cfv vw cv c1 caddc co cF cfv cle wbr cB vx
      cv clt wbr vx cv cG cfv vx cv cF cfv cle wbr wi cB vw cv c1 caddc co clt
      wbr vw cv c1 caddc co cG cfv vw cv c1 caddc co cF cfv cle wbr wi vx vw cv
      c1 caddc co cn vx cv vw cv c1 caddc co wceq cB vx cv clt wbr cB vw cv c1
      caddc co clt wbr vx cv cG cfv vx cv cF cfv cle wbr vw cv c1 caddc co cG
      cfv vw cv c1 caddc co cF cfv cle wbr vx cv vw cv c1 caddc co cB clt breq2
      vx cv vw cv c1 caddc co wceq vx cv cG cfv vw cv c1 caddc co cG cfv vx cv
      cF cfv vw cv c1 caddc co cF cfv cle vx cv vw cv c1 caddc co cG fveq2 vx
      cv vw cv c1 caddc co cF fveq2 breq12d imbi12d vx cv cn wcel cB vx cv clt
      wbr vx cv cG cfv vx cv cF cfv cle wbr ser1cmp2.4 ex vtoclga imp vw cv
      peano2nn sylan adantrl vw cv cn wcel cB cn wcel vw cv c1 caddc co cG cfv
      vw cv c1 caddc co cF cfv cle wbr cS vw cv caddc cF cseq1 co cfv caddc co
      vw cv c1 caddc co cG cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co
      vw cv c1 caddc co cF cfv caddc co cle wbr wb cB vw cv c1 caddc co clt wbr
      vw cv c1 caddc co cG cfv cr wcel vw cv c1 caddc co cF cfv cr wcel cS vw
      cv caddc cF cseq1 co cfv caddc co cr wcel vw cv c1 caddc co cG cfv vw cv
      c1 caddc co cF cfv cle wbr cS vw cv caddc cF cseq1 co cfv caddc co vw cv
      c1 caddc co cG cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw cv
      c1 caddc co cF cfv caddc co cle wbr wb vw cv cn wcel cB cn wcel wa vw cv
      c1 caddc co cG cfv vw cv c1 caddc co cF cfv cS vw cv caddc cF cseq1 co
      cfv caddc co leadd2 vw cv cn wcel vw cv c1 caddc co cG cfv cr wcel cB cn
      wcel vw cv cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cG cfv cr
      wcel vw cv peano2nn cn cr vw cv c1 caddc co cG ser1cmp2.2 ffvelrni syl
      adantr vw cv cn wcel vw cv c1 caddc co cF cfv cr wcel cB cn wcel vw cv cn
      wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cF cfv cr wcel vw cv
      peano2nn cn cr vw cv c1 caddc co cF ser1cmp2.1 ffvelrni syl adantr cB cn
      wcel vw cv cn wcel cS vw cv caddc cF cseq1 co cfv caddc co cr wcel cS cr
      wcel vw cv caddc cF cseq1 co cfv cr wcel cS vw cv caddc cF cseq1 co cfv
      caddc co cr wcel cB cn wcel vw cv cn wcel cS vw cv caddc cF cseq1 co cfv
      readdcl cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
      cr clt csup cr cS cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn
      crab cres crn cr wss caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres
      crn c0 wne vw cv vz cv cle wbr vw caddc cG cseq1 co vy cv cB cle wbr vy
      cn crab cres crn wral vz cr wrex w3a caddc cG cseq1 co vy cv cB cle wbr
      vy cn crab cres crn cr clt csup cr wcel vy vz vw cB caddc cG cseq1 co cG
      ser1cmp2.2 ser1refi seq1ublem vz vw caddc cG cseq1 co vy cv cB cle wbr vy
      cn crab cres crn suprcl syl ser1cmp2.5 syl5eqel vw cv cF ser1cmp2.1
      ser1recli syl2an ancoms syl3anc adantrr mpbid adantr letrd vw cv cn wcel
      vw cv c1 caddc co caddc cG cseq1 co cfv vw cv caddc cG cseq1 co cfv vw cv
      c1 caddc co cG cfv caddc co wceq cB cn wcel cB vw cv c1 caddc co clt wbr
      wa vw cv caddc cG cseq1 co cfv cS vw cv caddc cF cseq1 co cfv caddc co
      cle wbr vw cv caddc cG addex cn cr cG wf cn cvv wcel cG cvv wcel
      ser1cmp2.2 nnex cn cr cvv cG fex mp2an seq1p1 ad2antrr vw cv cn wcel cB
      cn wcel cB vw cv c1 caddc co clt wbr wa wa cS vw cv c1 caddc co caddc cF
      cseq1 co cfv caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1
      caddc co cF cfv caddc co wceq vw cv caddc cG cseq1 co cfv cS vw cv caddc
      cF cseq1 co cfv caddc co cle wbr vw cv cn wcel cB cn wcel cS vw cv c1
      caddc co caddc cF cseq1 co cfv caddc co cS vw cv caddc cF cseq1 co cfv
      caddc co vw cv c1 caddc co cF cfv caddc co wceq cB vw cv c1 caddc co clt
      wbr vw cv cn wcel cB cn wcel wa cS vw cv c1 caddc co caddc cF cseq1 co
      cfv caddc co cS vw cv caddc cF cseq1 co cfv vw cv c1 caddc co cF cfv
      caddc co caddc co cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc
      co cF cfv caddc co vw cv cn wcel cS vw cv c1 caddc co caddc cF cseq1 co
      cfv caddc co cS vw cv caddc cF cseq1 co cfv vw cv c1 caddc co cF cfv
      caddc co caddc co wceq cB cn wcel vw cv cn wcel vw cv c1 caddc co caddc
      cF cseq1 co cfv vw cv caddc cF cseq1 co cfv vw cv c1 caddc co cF cfv
      caddc co cS caddc vw cv caddc cF addex cn cr cF wf cn cvv wcel cF cvv
      wcel ser1cmp2.1 nnex cn cr cvv cF fex mp2an seq1p1 opreq2d adantr cS cc
      wcel vw cv caddc cF cseq1 co cfv cc wcel vw cv c1 caddc co cF cfv cc wcel
      cS vw cv caddc cF cseq1 co cfv caddc co vw cv c1 caddc co cF cfv caddc co
      cS vw cv caddc cF cseq1 co cfv vw cv c1 caddc co cF cfv caddc co caddc co
      wceq vw cv cn wcel cB cn wcel wa cS vw cv caddc cF cseq1 co cfv vw cv c1
      caddc co cF cfv addass cB cn wcel cS cc wcel vw cv cn wcel cB cn wcel cS
      cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt
      csup cr cS cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres
      crn cr wss caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn c0 wne
      vw cv vz cv cle wbr vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres
      crn wral vz cr wrex w3a caddc cG cseq1 co vy cv cB cle wbr vy cn crab
      cres crn cr clt csup cr wcel vy vz vw cB caddc cG cseq1 co cG ser1cmp2.2
      ser1refi seq1ublem vz vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab
      cres crn suprcl syl ser1cmp2.5 syl5eqel recnd adantl vw cv cn wcel vw cv
      caddc cF cseq1 co cfv cc wcel cB cn wcel vw cv cn wcel vw cv caddc cF
      cseq1 co cfv vw cv cF ser1cmp2.1 ser1recli recnd adantr vw cv cn wcel vw
      cv c1 caddc co cF cfv cc wcel cB cn wcel vw cv cn wcel vw cv c1 caddc co
      cF cfv vw cv cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cF cfv
      cr wcel vw cv peano2nn cn cr vw cv c1 caddc co cF ser1cmp2.1 ffvelrni syl
      recnd adantr syl3anc eqtr4d adantrr adantr 3brtr4d ex anassrs ex jaod mpd
      ex a2d nnind imp $.
      $( [30-Apr-2005] $) $( [23-Apr-2005] $)
  $}

  ${
    $d A n $.  $d F k $.  $d G k $.  $d M k n $.  $d S n $.  $d T n $.
    $d U n $.
    iserzabslem.1 $e |- A e. _V $.
    iserzabslem.2 $e |- B e. _V $.
    iserzabslem.3 $e |- F e. _V $.
    iserzabslem.4 $e |- G e. _V $.
    iserzabslem.5 $e |- ( k e. ( ZZ>= ` M ) ->
                    ( ( F ` k ) e. CC /\ ( G ` k ) = ( abs ` ( F ` k ) ) ) ) $.
    iserzabslem.6 $e |- S ~~> A $.
    iserzabslem.7 $e |- T ~~> B $.
    iserzabslem.8 $e |- M e. ZZ $.
    iserzabslem.9 $e |- U e. _V $.
    iserzabslem.10 $e |- ( n e. ( ZZ>= ` M ) ->
                        ( U ` n ) = ( abs ` ( S ` n ) ) ) $.
    iserzabslem.11 $e |- S = ( <. M , + >. seq F ) $.
    iserzabslem.12 $e |- T = ( <. M , + >. seq G ) $.
    $( Lemma for ~ iserzabsi . $)
    iserzabslem $p |- ( abs ` A ) <_ B $=
      cM cz wcel vn cv cU cfv cr wcel vn cv cT cfv cr wcel vn cv cU cfv vn cv
      cT cfv cle wbr w3a vn cM cuz cfv wral cA cabs cfv cB cle wbr
      iserzabslem.8 vn cv cU cfv cr wcel vn cv cT cfv cr wcel vn cv cU cfv vn
      cv cT cfv cle wbr w3a vn cM cuz cfv vn cv cM cuz cfv wcel vn cv cU cfv cr
      wcel vn cv cT cfv cr wcel vn cv cU cfv vn cv cT cfv cle wbr vn cv cM cuz
      cfv wcel vn cv cU cfv vn cv cS cfv cabs cfv cr iserzabslem.10 vn cv cM
      cuz cfv wcel vn cv cS cfv cc wcel vn cv cS cfv cabs cfv cr wcel vn cv cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cM vn cv cfz co wral vn cv cS cfv cc
      wcel vk cv cF cfv cc wcel vk cM vn cv cfz co vk cv cM vn cv cfz co wcel
      vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cM vn cv elfzuz vk cv cM
      cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cabs cfv wceq
      iserzabslem.5 pm3.26d syl rgen vn cv cM cuz cfv wcel vk cv cF cfv cc wcel
      vk cM vn cv cfz co wral wa vn cv cM caddc cop cF cseqz co cfv cc vn cv cS
      cfv vk cF cM vn cv iserzabslem.3 serzcl vn cv cS cM caddc cop cF cseqz co
      iserzabslem.11 fveq1i syl5eqel mpan2 vn cv cS cfv abscl syl eqeltrd vn cv
      cM cuz cfv wcel vk cv cG cfv cr wcel vk cM vn cv cfz co wral vn cv cT cfv
      cr wcel vk cv cG cfv cr wcel vk cM vn cv cfz co vk cv cM vn cv cfz co
      wcel vk cv cM cuz cfv wcel vk cv cG cfv cr wcel vk cv cM vn cv elfzuz vk
      cv cM cuz cfv wcel vk cv cG cfv vk cv cF cfv cabs cfv cr vk cv cM cuz cfv
      wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cabs cfv wceq
      iserzabslem.5 pm3.27d vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cF
      cfv cabs cfv cr wcel vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG
      cfv vk cv cF cfv cabs cfv wceq iserzabslem.5 pm3.26d vk cv cF cfv abscl
      syl eqeltrd syl rgen vn cv cM cuz cfv wcel vk cv cG cfv cr wcel vk cM vn
      cv cfz co wral wa vn cv cM caddc cop cG cseqz co cfv cr vn cv cT cfv vk
      cG cM vn cv iserzabslem.4 serzrecl vn cv cT cM caddc cop cG cseqz co
      iserzabslem.12 fveq1i syl5eqel mpan2 vn cv cM cuz cfv wcel cM vn cv cfz
      co vk cv cF cfv vk csu cabs cfv cM vn cv cfz co vk cv cF cfv cabs cfv vk
      csu vn cv cU cfv vn cv cT cfv cle vn cv cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM vn cv cfz co wral cM vn cv cfz co vk cv cF cfv vk csu cabs cfv
      cM vn cv cfz co vk cv cF cfv cabs cfv vk csu cle wbr vk cv cF cfv cc wcel
      vk cM vn cv cfz co vk cv cM vn cv cfz co wcel vk cv cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cv cM vn cv elfzuz vk cv cM cuz cfv wcel vk cv cF cfv
      cc wcel vk cv cG cfv vk cv cF cfv cabs cfv wceq iserzabslem.5 pm3.26d syl
      rgen vk cv cF cfv vk cM vn cv fsumabs mpan2 vn cv cM cuz cfv wcel cM vn
      cv cfz co vk cv cF cfv vk csu cabs cfv vn cv cS cfv cabs cfv vn cv cU cfv
      vn cv cM cuz cfv wcel cM vn cv cfz co vk cv cF cfv vk csu vn cv cS cfv
      cabs vn cv cM cuz cfv wcel cM vn cv cfz co vk cv cF cfv vk csu vn cv cM
      caddc cop cF cseqz co cfv vn cv cS cfv vk cF cM vn cv iserzabslem.3
      fsumserz vn cv cS cM caddc cop cF cseqz co iserzabslem.11 fveq1i syl6eqr
      fveq2d iserzabslem.10 eqtr4d vn cv cM cuz cfv wcel cM vn cv cfz co vk cv
      cG cfv vk csu vn cv cT cfv cM vn cv cfz co vk cv cF cfv cabs cfv vk csu
      vn cv cM cuz cfv wcel cM vn cv cfz co vk cv cG cfv vk csu vn cv cM caddc
      cop cG cseqz co cfv vn cv cT cfv vk cG cM vn cv iserzabslem.4 fsumserz vn
      cv cT cM caddc cop cG cseqz co iserzabslem.12 fveq1i syl6eqr cM vn cv cfz
      co vk cv cG cfv vk cv cF cfv cabs cfv vk vk cv cM vn cv cfz co wcel vk cv
      cM cuz cfv wcel vk cv cG cfv vk cv cF cfv cabs cfv wceq vk cv cM vn cv
      elfzuz vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF
      cfv cabs cfv wceq iserzabslem.5 pm3.27d syl sumeq2i syl5eqr 3brtr3d 3jca
      rgen cU cA cabs cfv cli wbr cT cB cli wbr cM cz wcel vn cv cU cfv cr wcel
      vn cv cT cfv cr wcel vn cv cU cfv vn cv cT cfv cle wbr w3a vn cM cuz cfv
      wral wa cA cabs cfv cB cle wbr cA vn cS cU cM iserzabslem.1 iserzabslem.9
      iserzabslem.8 iserzabslem.6 vn cv cM cuz cfv wcel vn cv cS cfv cc wcel vn
      cv cU cfv vn cv cS cfv cabs cfv wceq vn cv cM cuz cfv wcel vk cv cF cfv
      cc wcel vk cM vn cv cfz co wral vn cv cS cfv cc wcel vk cv cF cfv cc wcel
      vk cM vn cv cfz co vk cv cM vn cv cfz co wcel vk cv cM cuz cfv wcel vk cv
      cF cfv cc wcel vk cv cM vn cv elfzuz vk cv cM cuz cfv wcel vk cv cF cfv
      cc wcel vk cv cG cfv vk cv cF cfv cabs cfv wceq iserzabslem.5 pm3.26d syl
      rgen vn cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cM vn cv cfz co wral
      wa vn cv cM caddc cop cF cseqz co cfv cc vn cv cS cfv vk cF cM vn cv
      iserzabslem.3 serzcl vn cv cS cM caddc cop cF cseqz co iserzabslem.11
      fveq1i syl5eqel mpan2 iserzabslem.10 jca climabsi iserzabslem.7 cA cabs
      cfv cB vn cU cT cM iserzabslem.9 cT cM caddc cop cG cseqz co cvv
      iserzabslem.12 cM caddc cop cG cseqz oprex eqeltri cA cabs fvex
      iserzabslem.2 climcmp mpanl12 mp2an $.
      $( [11-Sep-2007] $) $( [10-Sep-2007] $)
  $}

  ${
    $d A n $.  $d F j n y $.  $d F k n $.  $d G k n $.  $d M j n y $.
    $d M k n $.
    iserzabs.1 $e |- A e. _V $.
    iserzabs.2 $e |- B e. _V $.
    iserzabs.3 $e |- F e. _V $.
    iserzabs.4 $e |- G e. _V $.
    iserzabs.5 $e |- M e. ZZ $.
    iserzabs.6 $e |- ( k e. ( ZZ>= ` M ) ->
                    ( ( F ` k ) e. CC /\ ( G ` k ) = ( abs ` ( F ` k ) ) ) ) $.
    iserzabs.7 $e |- ( <. M , + >. seq F ) ~~> A $.
    iserzabs.8 $e |- ( <. M , + >. seq G ) ~~> B $.
    $( Generalized triangle inequality:  the absolute value of an infinite sum
       is less than or equal to the sum of absolute values.  (Contributed by
       Paul Chapman, 10-Sep-2007.) $)
    iserzabsi $p |- ( abs ` A ) <_ B $=
      cA cB cM caddc cop cF cseqz co cM caddc cop cG cseqz co vj cv cM cuz cfv
      wcel vy cv vj cv cM caddc cop cF cseqz co cfv cabs cfv wceq wa vj vy
      copab vk vn cF cG cM iserzabs.1 iserzabs.2 iserzabs.3 iserzabs.4
      iserzabs.6 iserzabs.7 iserzabs.8 iserzabs.5 vj vy cM cuz cfv vj cv cM
      caddc cop cF cseqz co cfv cabs cfv cM cuz fvex opabex2 vj vy vn cv vj cv
      cM caddc cop cF cseqz co cfv cabs cfv vn cv cM caddc cop cF cseqz co cfv
      cabs cfv cM cuz cfv vj cv cM cuz cfv wcel vy cv vj cv cM caddc cop cF
      cseqz co cfv cabs cfv wceq wa vj vy copab vj cv vn cv wceq vj cv cM caddc
      cop cF cseqz co cfv vn cv cM caddc cop cF cseqz co cfv cabs vj cv vn cv
      cM caddc cop cF cseqz co fveq2 fveq2d vj cv cM cuz cfv wcel vy cv vj cv
      cM caddc cop cF cseqz co cfv cabs cfv wceq wa vj vy copab eqid vn cv cM
      caddc cop cF cseqz co cfv cabs fvex fvopab4 cM caddc cop cF cseqz co eqid
      cM caddc cop cG cseqz co eqid iserzabslem $.
      $( [11-Sep-2007] $) $( [10-Sep-2007] $)
  $}

  ${
    $d x z A $.  $d x y z w B $.  $d x z w F $.  $d x z w G $.
    $d x z w S $.  $d x z H $.  $d x z w C $.
    cvgcmp2.1 $e |- A e. _V $.
    cvgcmp2.2 $e |- F : NN --> RR $.
    cvgcmp2.3 $e |- G : NN --> RR $.
    cvgcmp2.4 $e |- ( x e. NN -> 0 <_ ( F ` x ) ) $.
    cvgcmp2.5 $e |- ( x e. NN -> 0 <_ ( G ` x ) ) $.
    cvgcmp2.6 $e |- ( + seq1 F ) ~~> A $.
    cvgcmp2.7 $e |- B e. NN $.
    ${
      cvgcmp2.8 $e |- ( ( x e. NN /\ B < x ) -> ( G ` x ) <_ ( F ` x ) ) $.
      ${
        cvgcmp2lem.9 $e |- S =
               sup ( ran ( ( + seq1 G ) |` { y e. NN | y <_ B } ) , RR , < ) $.
        cvgcmp2lem.10 $e |- H Fn NN $.
        cvgcmp2lem.11 $e |- ( x e. NN ->
                            ( H ` x ) = ( S + ( ( + seq1 F ) ` x ) ) ) $.
        $( Lemma for ~ cvgcmp2i . $)
        cvgcmp2lem $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G )
                       , RR , < ) $=
          vz vx caddc cG cseq1 co cG cvgcmp2.3 ser1refi vx vx cv cG cvgcmp2.3
          cvgcmp2.5 ser1monoi cS cA caddc co cr wcel vx cv caddc cG cseq1 co
          cfv cS cA caddc co cle wbr vx cn wral vx cv caddc cG cseq1 co cfv vz
          cv cle wbr vx cn wral vz cr wrex cS cA cS caddc cG cseq1 co vy cv cB
          cle wbr vy cn crab cres crn cr clt csup cr cvgcmp2lem.9 vz vw caddc
          cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cB cn wcel caddc cG
          cseq1 co vy cv cB cle wbr vy cn crab cres crn cr wss caddc cG cseq1
          co vy cv cB cle wbr vy cn crab cres crn c0 wne vw cv vz cv cle wbr vw
          caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn wral vz cr
          wrex w3a cvgcmp2.7 vy vz vw cB caddc cG cseq1 co cG cvgcmp2.3
          ser1refi seq1ublem ax-mp suprclii eqeltri cA caddc cF cseq1 co
          cvgcmp2.1 cF cvgcmp2.2 ser1refi cvgcmp2.6 climfnrcli readdcli vx cv
          caddc cG cseq1 co cfv cS cA caddc co cle wbr vx cn vx cv cn wcel vx
          cv caddc cG cseq1 co cfv vx cv cH cfv cS cA caddc co vx cv cG
          cvgcmp2.3 ser1recli vx cv cn wcel vx cv cH cfv cS vx cv caddc cF
          cseq1 co cfv caddc co cr cvgcmp2lem.11 cS cr wcel vx cv caddc cF
          cseq1 co cfv cr wcel cS vx cv caddc cF cseq1 co cfv caddc co cr wcel
          vx cv cn wcel cS vx cv caddc cF cseq1 co cfv readdcl cS caddc cG
          cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup cr
          cvgcmp2lem.9 vz vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres
          crn cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
          cr wss caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn c0 wne
          vw cv vz cv cle wbr vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab
          cres crn wral vz cr wrex w3a cvgcmp2.7 vy vz vw cB caddc cG cseq1 co
          cG cvgcmp2.3 ser1refi seq1ublem ax-mp suprclii eqeltri vx cv cF
          cvgcmp2.2 ser1recli sylancr eqeltrd cS cA caddc co cr wcel vx cv cn
          wcel cS cA cS caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
          cr clt csup cr cvgcmp2lem.9 vz vw caddc cG cseq1 co vy cv cB cle wbr
          vy cn crab cres crn cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy
          cn crab cres crn cr wss caddc cG cseq1 co vy cv cB cle wbr vy cn crab
          cres crn c0 wne vw cv vz cv cle wbr vw caddc cG cseq1 co vy cv cB cle
          wbr vy cn crab cres crn wral vz cr wrex w3a cvgcmp2.7 vy vz vw cB
          caddc cG cseq1 co cG cvgcmp2.3 ser1refi seq1ublem ax-mp suprclii
          eqeltri cA caddc cF cseq1 co cvgcmp2.1 cF cvgcmp2.2 ser1refi
          cvgcmp2.6 climfnrcli readdcli a1i vx cv cn wcel vx cv caddc cG cseq1
          co cfv cS vx cv caddc cF cseq1 co cfv caddc co vx cv cH cfv cle vx cv
          cn wcel cB cn wcel vx cv caddc cG cseq1 co cfv cS vx cv caddc cF
          cseq1 co cfv caddc co cle wbr cvgcmp2.7 vx vy vx cv cB cS cF cG
          cvgcmp2.2 cvgcmp2.3 cvgcmp2.4 cvgcmp2.8 cvgcmp2lem.9 ser1cmp2i mpan2
          cvgcmp2lem.11 breqtrrd cS cA caddc co vz cH vx cv cS cA caddc oprex
          cn cr cH wf cH cn wfn vx cv cH cfv cr wcel vx cn wral vx cn cr cH
          ffnfv cvgcmp2lem.10 vx cv cH cfv cr wcel vx cn vx cv cn wcel vx cv cH
          cfv cS vx cv caddc cF cseq1 co cfv caddc co cr cvgcmp2lem.11 cS cr
          wcel vx cv caddc cF cseq1 co cfv cr wcel cS vx cv caddc cF cseq1 co
          cfv caddc co cr wcel vx cv cn wcel cS vx cv caddc cF cseq1 co cfv
          readdcl cS caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr
          clt csup cr cvgcmp2lem.9 vz vw caddc cG cseq1 co vy cv cB cle wbr vy
          cn crab cres crn cB cn wcel caddc cG cseq1 co vy cv cB cle wbr vy cn
          crab cres crn cr wss caddc cG cseq1 co vy cv cB cle wbr vy cn crab
          cres crn c0 wne vw cv vz cv cle wbr vw caddc cG cseq1 co vy cv cB cle
          wbr vy cn crab cres crn wral vz cr wrex w3a cvgcmp2.7 vy vz vw cB
          caddc cG cseq1 co cG cvgcmp2.3 ser1refi seq1ublem ax-mp suprclii
          eqeltri vx cv cF cvgcmp2.2 ser1recli sylancr eqeltrd rgen mpbir2an vz
          cv cn wcel cS vz cv caddc cF cseq1 co cfv caddc co cS vz cv c1 caddc
          co caddc cF cseq1 co cfv caddc co vz cv cH cfv vz cv c1 caddc co cH
          cfv cle vz cv cn wcel vz cv caddc cF cseq1 co cfv vz cv c1 caddc co
          caddc cF cseq1 co cfv cle wbr cS vz cv caddc cF cseq1 co cfv caddc co
          cS vz cv c1 caddc co caddc cF cseq1 co cfv caddc co cle wbr vx vz cv
          cF cvgcmp2.2 cvgcmp2.4 ser1monoi vz cv caddc cF cseq1 co cfv cr wcel
          vz cv c1 caddc co caddc cF cseq1 co cfv cr wcel vz cv caddc cF cseq1
          co cfv vz cv c1 caddc co caddc cF cseq1 co cfv cle wbr cS vz cv caddc
          cF cseq1 co cfv caddc co cS vz cv c1 caddc co caddc cF cseq1 co cfv
          caddc co cle wbr wb vz cv cn wcel vz cv caddc cF cseq1 co cfv cr wcel
          vz cv c1 caddc co caddc cF cseq1 co cfv cr wcel cS cr wcel vz cv
          caddc cF cseq1 co cfv vz cv c1 caddc co caddc cF cseq1 co cfv cle wbr
          cS vz cv caddc cF cseq1 co cfv caddc co cS vz cv c1 caddc co caddc cF
          cseq1 co cfv caddc co cle wbr wb cS caddc cG cseq1 co vy cv cB cle
          wbr vy cn crab cres crn cr clt csup cr cvgcmp2lem.9 vz vw caddc cG
          cseq1 co vy cv cB cle wbr vy cn crab cres crn cB cn wcel caddc cG
          cseq1 co vy cv cB cle wbr vy cn crab cres crn cr wss caddc cG cseq1
          co vy cv cB cle wbr vy cn crab cres crn c0 wne vw cv vz cv cle wbr vw
          caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn wral vz cr
          wrex w3a cvgcmp2.7 vy vz vw cB caddc cG cseq1 co cG cvgcmp2.3
          ser1refi seq1ublem ax-mp suprclii eqeltri vz cv caddc cF cseq1 co cfv
          vz cv c1 caddc co caddc cF cseq1 co cfv cS leadd2 mp3an3 vz cv cF
          cvgcmp2.2 ser1recli vz cv cn wcel vz cv c1 caddc co cn wcel vz cv c1
          caddc co caddc cF cseq1 co cfv cr wcel vz cv peano2nn vz cv c1 caddc
          co cF cvgcmp2.2 ser1recli syl sylanc mpbid vx cv cH cfv cS vx cv
          caddc cF cseq1 co cfv caddc co wceq vz cv cH cfv cS vz cv caddc cF
          cseq1 co cfv caddc co wceq vx vz cv cn vx cv vz cv wceq vx cv cH cfv
          vz cv cH cfv cS vx cv caddc cF cseq1 co cfv caddc co cS vz cv caddc
          cF cseq1 co cfv caddc co vx cv vz cv cH fveq2 vx cv vz cv wceq vx cv
          caddc cF cseq1 co cfv vz cv caddc cF cseq1 co cfv cS caddc vx cv vz
          cv caddc cF cseq1 co fveq2 opreq2d eqeq12d cvgcmp2lem.11 vtoclga vz
          cv cn wcel vz cv c1 caddc co cn wcel vz cv c1 caddc co cH cfv cS vz
          cv c1 caddc co caddc cF cseq1 co cfv caddc co wceq vz cv peano2nn vx
          cv cH cfv cS vx cv caddc cF cseq1 co cfv caddc co wceq vz cv c1 caddc
          co cH cfv cS vz cv c1 caddc co caddc cF cseq1 co cfv caddc co wceq vx
          vz cv c1 caddc co cn vx cv vz cv c1 caddc co wceq vx cv cH cfv vz cv
          c1 caddc co cH cfv cS vx cv caddc cF cseq1 co cfv caddc co cS vz cv
          c1 caddc co caddc cF cseq1 co cfv caddc co vx cv vz cv c1 caddc co cH
          fveq2 vx cv vz cv c1 caddc co wceq vx cv caddc cF cseq1 co cfv vz cv
          c1 caddc co caddc cF cseq1 co cfv cS caddc vx cv vz cv c1 caddc co
          caddc cF cseq1 co fveq2 opreq2d eqeq12d cvgcmp2lem.11 vtoclga syl
          3brtr4d cS cA vx caddc cF cseq1 co cH cS cS caddc cG cseq1 co vy cv
          cB cle wbr vy cn crab cres crn cr clt csup cr cvgcmp2lem.9 vz vw
          caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cB cn wcel
          caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr wss caddc
          cG cseq1 co vy cv cB cle wbr vy cn crab cres crn c0 wne vw cv vz cv
          cle wbr vw caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
          wral vz cr wrex w3a cvgcmp2.7 vy vz vw cB caddc cG cseq1 co cG
          cvgcmp2.3 ser1refi seq1ublem ax-mp suprclii eqeltri recni cvgcmp2.1
          cvgcmp2.6 cvgcmp2lem.10 vx cv cn wcel vx cv caddc cF cseq1 co cfv cc
          wcel vx cv cH cfv cS vx cv caddc cF cseq1 co cfv caddc co wceq vx cv
          cn wcel vx cv caddc cF cseq1 co cfv vx cv cF cvgcmp2.2 ser1recli
          recnd cvgcmp2lem.11 jca climaddci climubi letrd rgen vx cv caddc cG
          cseq1 co cfv vz cv cle wbr vx cn wral vx cv caddc cG cseq1 co cfv cS
          cA caddc co cle wbr vx cn wral vz cS cA caddc co cr vz cv cS cA caddc
          co wceq vx cv caddc cG cseq1 co cfv vz cv cle wbr vx cv caddc cG
          cseq1 co cfv cS cA caddc co cle wbr vx cn vz cv cS cA caddc co vx cv
          caddc cG cseq1 co cfv cle breq2 ralbidv rcla4ev mp2an climsupi $.
          $( [14-Jun-2006] $) $( [23-Apr-2005] $)
      $}

      $( MAY BE REVISED - clean up cvgcmp stuff - see 6/30/2006 2:40PM email $)
      $( A comparison test for convergence of a real infinite series.  This
         version allows us to ignore the initial segment before the ` B ` -th
         term. $)
      cvgcmp2i $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G ) , RR , < ) $=
        vx vy cA cB caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr
        clt csup cF cG vz cv cn wcel vw cv caddc cG cseq1 co vy cv cB cle wbr
        vy cn crab cres crn cr clt csup vz cv caddc cF cseq1 co cfv caddc co
        wceq wa vz vw copab cvgcmp2.1 cvgcmp2.2 cvgcmp2.3 cvgcmp2.4 cvgcmp2.5
        cvgcmp2.6 cvgcmp2.7 cvgcmp2.8 caddc cG cseq1 co vy cv cB cle wbr vy cn
        crab cres crn cr clt csup eqid vz vw cn caddc cG cseq1 co vy cv cB cle
        wbr vy cn crab cres crn cr clt csup vz cv caddc cF cseq1 co cfv caddc
        co vz cv cn wcel vw cv caddc cG cseq1 co vy cv cB cle wbr vy cn crab
        cres crn cr clt csup vz cv caddc cF cseq1 co cfv caddc co wceq wa vz vw
        copab caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt
        csup vz cv caddc cF cseq1 co cfv caddc oprex vz cv cn wcel vw cv caddc
        cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup vz cv
        caddc cF cseq1 co cfv caddc co wceq wa vz vw copab eqid fnopab2 vz vw
        vx cv caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt
        csup vz cv caddc cF cseq1 co cfv caddc co caddc cG cseq1 co vy cv cB
        cle wbr vy cn crab cres crn cr clt csup vx cv caddc cF cseq1 co cfv
        caddc co cn vz cv cn wcel vw cv caddc cG cseq1 co vy cv cB cle wbr vy
        cn crab cres crn cr clt csup vz cv caddc cF cseq1 co cfv caddc co wceq
        wa vz vw copab vz cv vx cv wceq vz cv caddc cF cseq1 co cfv vx cv caddc
        cF cseq1 co cfv caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn
        cr clt csup caddc vz cv vx cv caddc cF cseq1 co fveq2 opreq2d vz cv cn
        wcel vw cv caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr
        clt csup vz cv caddc cF cseq1 co cfv caddc co wceq wa vz vw copab eqid
        caddc cG cseq1 co vy cv cB cle wbr vy cn crab cres crn cr clt csup vx
        cv caddc cF cseq1 co cfv caddc oprex fvopab4 cvgcmp2lem $.
        $( [14-Jun-2006] $) $( [23-Apr-2005] $)
    $}

    ${
      cvgcmp2c.9 $e |- C e. RR $.
      cvgcmp2c.10 $e |- 0 <_ C $.
      cvgcmp2c.11 $e |- ( ( x e. NN /\ B < x ) ->
                        ( G ` x ) <_ ( C x. ( F ` x ) ) ) $.
      ${
        cvgcmp2clem.12 $e |- S Fn NN $.
        cvgcmp2clem.13 $e |- ( x e. NN -> ( S ` x ) = ( C x. ( F ` x ) ) ) $.
        $( Lemma for ~ cvgcmp2ci . $)
        cvgcmp2clem $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G ) , RR ,
                < ) $=
          vx cC cA cmul co cB cS cG cC cA cmul oprex cn cr cS wf cS cn wfn vx
          cv cS cfv cr wcel vx cn wral vx cn cr cS ffnfv cvgcmp2clem.12 vx cv
          cS cfv cr wcel vx cn vx cv cn wcel vx cv cS cfv cC vx cv cF cfv cmul
          co cr cvgcmp2clem.13 cC cr wcel vx cv cF cfv cr wcel cC vx cv cF cfv
          cmul co cr wcel vx cv cn wcel cC vx cv cF cfv remulcl cvgcmp2c.9 cn
          cr vx cv cF cvgcmp2.2 ffvelrni sylancr eqeltrd rgen mpbir2an
          cvgcmp2.3 vx cv cn wcel cc0 cC vx cv cF cfv cmul co vx cv cS cfv cle
          vx cv cF cfv cr wcel cc0 vx cv cF cfv cle wbr cc0 cC vx cv cF cfv
          cmul co cle wbr vx cv cn wcel cC cr wcel cc0 cC cle wbr vx cv cF cfv
          cr wcel cc0 vx cv cF cfv cle wbr wa cc0 cC vx cv cF cfv cmul co cle
          wbr cvgcmp2c.9 cvgcmp2c.10 cC vx cv cF cfv mulge0 mpanl12 cn cr vx cv
          cF cvgcmp2.2 ffvelrni cvgcmp2.4 sylanc cvgcmp2clem.13 breqtrrd
          cvgcmp2.5 cC cA vx caddc cF cseq1 co caddc cS cseq1 co cC cvgcmp2c.9
          recni cvgcmp2.1 cvgcmp2.6 caddc cS addex cS cn wfn cn cvv wcel cS cvv
          wcel cvgcmp2clem.12 nnex cn cvv cS fnex mp2an seq1fn vx cv cn wcel vx
          cv caddc cF cseq1 co cfv cc wcel vx cv caddc cS cseq1 co cfv cC vx cv
          caddc cF cseq1 co cfv cmul co wceq vx cv cF cn cr cF wf cr cc wss cn
          cc cF wf cvgcmp2.2 axresscn cn cr cc cF fss mp2an ser1cl1i cC vx cF
          cS vx cv cC cvgcmp2c.9 recni cn cr cF wf cr cc wss cn cc cF wf
          cvgcmp2.2 axresscn cn cr cc cF fss mp2an cS cn wfn cn cvv wcel cS cvv
          wcel cvgcmp2clem.12 nnex cn cvv cS fnex mp2an cvgcmp2clem.13
          ser1mulci jca climmulci cvgcmp2.7 vx cv cn wcel cB vx cv clt wbr wa
          vx cv cG cfv cC vx cv cF cfv cmul co vx cv cS cfv cle cvgcmp2c.11 vx
          cv cn wcel vx cv cS cfv cC vx cv cF cfv cmul co wceq cB vx cv clt wbr
          cvgcmp2clem.13 adantr breqtrrd cvgcmp2i $.
          $( [25-Jul-2009] $) $( [24-Apr-2005] $)

        $( Lemma for ~ cvgcmp2ci . $)
        cvgcmp2clemOLD $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G ) , RR ,
                < ) $=
          vx cC cA cmul co cB cS cG cC cA cmul oprex cn cr cS wf cS cn wfn vx
          cv cS cfv cr wcel vx cn wral vx cn cr cS ffnfv cvgcmp2clem.12 vx cv
          cS cfv cr wcel vx cn vx cv cn wcel vx cv cS cfv cC vx cv cF cfv cmul
          co cr cvgcmp2clem.13 cC cr wcel vx cv cF cfv cr wcel cC vx cv cF cfv
          cmul co cr wcel vx cv cn wcel cC vx cv cF cfv remulcl cvgcmp2c.9 cn
          cr vx cv cF cvgcmp2.2 ffvelrni sylancr eqeltrd rgen mpbir2an
          cvgcmp2.3 vx cv cn wcel cc0 cC vx cv cF cfv cmul co vx cv cS cfv cle
          vx cv cF cfv cr wcel cc0 cC cle wbr cc0 vx cv cF cfv cle wbr wa cc0
          cC vx cv cF cfv cmul co cle wbr vx cv cn wcel cC cr wcel vx cv cF cfv
          cr wcel cc0 cC cle wbr cc0 vx cv cF cfv cle wbr wa cc0 cC vx cv cF
          cfv cmul co cle wbr cvgcmp2c.9 cC vx cv cF cfv mulge0OLD mpanl1 cn cr
          vx cv cF cvgcmp2.2 ffvelrni vx cv cn wcel cc0 vx cv cF cfv cle wbr
          cc0 cC cle wbr cvgcmp2.4 cvgcmp2c.10 jctil sylanc cvgcmp2clem.13
          breqtrrd cvgcmp2.5 cC cA vx caddc cF cseq1 co caddc cS cseq1 co cC
          cvgcmp2c.9 recni cvgcmp2.1 cvgcmp2.6 caddc cS addex cS cn wfn cn cvv
          wcel cS cvv wcel cvgcmp2clem.12 nnex cn cvv cS fnex mp2an seq1fn vx
          cv cn wcel vx cv caddc cF cseq1 co cfv cc wcel vx cv caddc cS cseq1
          co cfv cC vx cv caddc cF cseq1 co cfv cmul co wceq vx cv cF cn cr cF
          wf cr cc wss cn cc cF wf cvgcmp2.2 axresscn cn cr cc cF fss mp2an
          ser1cl1i cC vx cF cS vx cv cC cvgcmp2c.9 recni cn cr cF wf cr cc wss
          cn cc cF wf cvgcmp2.2 axresscn cn cr cc cF fss mp2an cS cn wfn cn cvv
          wcel cS cvv wcel cvgcmp2clem.12 nnex cn cvv cS fnex mp2an
          cvgcmp2clem.13 ser1mulci jca climmulci cvgcmp2.7 vx cv cn wcel cB vx
          cv clt wbr wa vx cv cG cfv cC vx cv cF cfv cmul co vx cv cS cfv cle
          cvgcmp2c.11 vx cv cn wcel vx cv cS cfv cC vx cv cF cfv cmul co wceq
          cB vx cv clt wbr cvgcmp2clem.13 adantr breqtrrd cvgcmp2i $.
          $( [17-Jun-2006] $) $( [24-Apr-2005] $)
      $}

      $( A comparison test for convergence of a real infinite series.  This
         version of ~ cvgcmp2i allows the reference sequence ` F ` (whose
         infinite series converges) to be multiplied by a nonnegative constant
         ` C ` before the comparison. $)
      cvgcmp2ci $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G ) , RR ,
                      < ) $=
        vx cA cB cC vz cv cn wcel vw cv cC vz cv cF cfv cmul co wceq wa vz vw
        copab cF cG cvgcmp2.1 cvgcmp2.2 cvgcmp2.3 cvgcmp2.4 cvgcmp2.5 cvgcmp2.6
        cvgcmp2.7 cvgcmp2c.9 cvgcmp2c.10 cvgcmp2c.11 vz vw cn cC vz cv cF cfv
        cmul co vz cv cn wcel vw cv cC vz cv cF cfv cmul co wceq wa vz vw copab
        cC vz cv cF cfv cmul oprex vz cv cn wcel vw cv cC vz cv cF cfv cmul co
        wceq wa vz vw copab eqid fnopab2 vz vw vx cv cC vz cv cF cfv cmul co cC
        vx cv cF cfv cmul co cn vz cv cn wcel vw cv cC vz cv cF cfv cmul co
        wceq wa vz vw copab vz cv vx cv wceq vz cv cF cfv vx cv cF cfv cC cmul
        vz cv vx cv cF fveq2 opreq2d vz cv cn wcel vw cv cC vz cv cF cfv cmul
        co wceq wa vz vw copab eqid cC vx cv cF cfv cmul oprex fvopab4
        cvgcmp2clem $.
        $( [18-Jun-2006] $) $( [24-Apr-2005] $)
    $}
  $}

  ${
    $d x y z w A $.  $d x F $.  $d x y z w G $.
    cvgcmp.1 $e |- A e. _V $.
    cvgcmp.2 $e |- F : NN --> RR $.
    cvgcmp.3 $e |- G : NN --> RR $.
    cvgcmp.4 $e |- ( x e. NN ->
                   ( 0 <_ ( G ` x ) /\ ( G ` x ) <_ ( F ` x ) ) ) $.
    cvgcmp.5 $e |- ( + seq1 F ) ~~> A $.
    $( A comparison test for convergence of a real infinite series.  Similar
       to Exercise 3 of [Gleason] p. 182, except that we show the explicit
       limit rather than just its existence. $)
    cvgcmpi $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G ) , RR , < ) $=
      vx cA c1 cF cG cvgcmp.1 cvgcmp.2 cvgcmp.3 vx cv cG cfv cr wcel vx cv cF
      cfv cr wcel wa cc0 vx cv cG cfv cle wbr vx cv cG cfv vx cv cF cfv cle wbr
      wa cc0 vx cv cF cfv cle wbr vx cv cn wcel cc0 cr wcel vx cv cG cfv cr
      wcel vx cv cF cfv cr wcel cc0 vx cv cG cfv cle wbr vx cv cG cfv vx cv cF
      cfv cle wbr wa cc0 vx cv cF cfv cle wbr wi 0re cc0 vx cv cG cfv vx cv cF
      cfv letr mp3an1 vx cv cn wcel vx cv cG cfv cr wcel vx cv cF cfv cr wcel
      cn cr vx cv cG cvgcmp.3 ffvelrni cn cr vx cv cF cvgcmp.2 ffvelrni jca
      cvgcmp.4 sylc vx cv cn wcel cc0 vx cv cG cfv cle wbr vx cv cG cfv vx cv
      cF cfv cle wbr cvgcmp.4 pm3.26d cvgcmp.5 1nn vx cv cn wcel vx cv cG cfv
      vx cv cF cfv cle wbr c1 vx cv clt wbr vx cv cn wcel cc0 vx cv cG cfv cle
      wbr vx cv cG cfv vx cv cF cfv cle wbr cvgcmp.4 pm3.27d adantr cvgcmp2i $.
      $( [29-Jun-2006] $) $( [1-May-2005] $)

    ${
      cvgcmpub.6 $e |- B e. _V $.
      cvgcmpub.7 $e |- ( + seq1 G ) ~~> B $.
      $( An upper bound for the limit of a real infinite series.  This theorem
         can also be used to compare two infinite series. $)
      cvgcmpubi $p |- B <_ A $=
        cB caddc cG cseq1 co crn cr clt csup cA cle cB caddc cG cseq1 co crn cr
        clt csup caddc cG cseq1 co cvgcmpub.6 caddc cG cseq1 co crn cr clt csup
        cr vy vz caddc cG cseq1 co crn caddc cG cseq1 co crn cr wss caddc cG
        cseq1 co crn c0 wne vz cv vy cv cle wbr vz caddc cG cseq1 co crn wral
        vy cr wrex cn cr caddc cG cseq1 co wf caddc cG cseq1 co crn cr wss cG
        cvgcmp.3 ser1refi cn cr caddc cG cseq1 co frn ax-mp cn c0 wne caddc cG
        cseq1 co crn c0 wne c1 cn wcel cn c0 wne 1nn cn c1 ne0i ax-mp cn c0
        caddc cG cseq1 co crn c0 cn c0 wceq caddc cG cseq1 co cdm c0 wceq caddc
        cG cseq1 co crn c0 wceq caddc cG cseq1 co cdm cn c0 cn cr caddc cG
        cseq1 co cG cvgcmp.3 ser1refi fdmi eqeq1i caddc cG cseq1 co dm0rn0
        bitr3i necon3bii mpbi cA cr wcel vz cv cA cle wbr vz caddc cG cseq1 co
        crn wral vz cv vy cv cle wbr vz caddc cG cseq1 co crn wral vy cr wrex
        cA caddc cF cseq1 co cvgcmp.1 cF cvgcmp.2 ser1refi cvgcmp.5 climfnrcli
        vz cv cA cle wbr vz caddc cG cseq1 co crn vz cv caddc cG cseq1 co crn
        wcel vx cv caddc cG cseq1 co cfv vz cv wceq vx cn wrex vz cv cA cle wbr
        caddc cG cseq1 co cn wfn vz cv caddc cG cseq1 co crn wcel vx cv caddc
        cG cseq1 co cfv vz cv wceq vx cn wrex wb cn cr caddc cG cseq1 co wf
        caddc cG cseq1 co cn wfn cG cvgcmp.3 ser1refi cn cr caddc cG cseq1 co
        ffn ax-mp vx cn vz cv caddc cG cseq1 co fvelrnb ax-mp vx cv caddc cG
        cseq1 co cfv vz cv wceq vz cv cA cle wbr vx cn vx cv caddc cG cseq1 co
        cfv vz cv wceq vx cv caddc cG cseq1 co cfv cA cle wbr vz cv cA cle wbr
        vx cv cn wcel vx cv caddc cG cseq1 co cfv vz cv cA cle breq1 vx cv cn
        wcel vx cv caddc cG cseq1 co cfv vx cv caddc cF cseq1 co cfv cA vx cv
        cG cvgcmp.3 ser1recli vx cv cF cvgcmp.2 ser1recli cA cr wcel vx cv cn
        wcel cA caddc cF cseq1 co cvgcmp.1 cF cvgcmp.2 ser1refi cvgcmp.5
        climfnrcli a1i vx vx cv cF cG cvgcmp.2 cvgcmp.3 vx cv cn wcel cc0 vx cv
        cG cfv cle wbr vx cv cG cfv vx cv cF cfv cle wbr cvgcmp.4 pm3.27d
        ser1cmpi cA vx caddc cF cseq1 co vx cv cvgcmp.1 cF cvgcmp.2 ser1refi vx
        vx cv cF cvgcmp.2 vx cv cG cfv cr wcel vx cv cF cfv cr wcel wa cc0 vx
        cv cG cfv cle wbr vx cv cG cfv vx cv cF cfv cle wbr wa cc0 vx cv cF cfv
        cle wbr vx cv cn wcel cc0 cr wcel vx cv cG cfv cr wcel vx cv cF cfv cr
        wcel cc0 vx cv cG cfv cle wbr vx cv cG cfv vx cv cF cfv cle wbr wa cc0
        vx cv cF cfv cle wbr wi 0re cc0 vx cv cG cfv vx cv cF cfv letr mp3an1
        vx cv cn wcel vx cv cG cfv cr wcel vx cv cF cfv cr wcel cn cr vx cv cG
        cvgcmp.3 ffvelrni cn cr vx cv cF cvgcmp.2 ffvelrni jca cvgcmp.4 sylc
        ser1monoi cvgcmp.5 climubi letrd syl5cbi r19.23aiv sylbi rgen vz cv vy
        cv cle wbr vz caddc cG cseq1 co crn wral vz cv cA cle wbr vz caddc cG
        cseq1 co crn wral vy cA cr vy cv cA wceq vz cv vy cv cle wbr vz cv cA
        cle wbr vz caddc cG cseq1 co crn vy cv cA vz cv cle breq2 ralbidv
        rcla4ev mp2an 3pm3.2i suprclii elisseti caddc cG cseq1 co cB cli wbr
        caddc cG cseq1 co caddc cG cseq1 co crn cr clt csup cli wbr cvgcmpub.7
        vx cA cF cG cvgcmp.1 cvgcmp.2 cvgcmp.3 cvgcmp.4 cvgcmp.5 cvgcmpi pm3.2i
        climunii cA cr wcel vw cv cA cle wbr vw caddc cG cseq1 co crn wral
        caddc cG cseq1 co crn cr clt csup cA cle wbr cA caddc cF cseq1 co
        cvgcmp.1 cF cvgcmp.2 ser1refi cvgcmp.5 climfnrcli vw cv cA cle wbr vw
        caddc cG cseq1 co crn vw cv caddc cG cseq1 co crn wcel vx cv caddc cG
        cseq1 co cfv vw cv wceq vx cn wrex vw cv cA cle wbr caddc cG cseq1 co
        cn wfn vw cv caddc cG cseq1 co crn wcel vx cv caddc cG cseq1 co cfv vw
        cv wceq vx cn wrex wb cn cr caddc cG cseq1 co wf caddc cG cseq1 co cn
        wfn cG cvgcmp.3 ser1refi cn cr caddc cG cseq1 co ffn ax-mp vx cn vw cv
        caddc cG cseq1 co fvelrnb ax-mp vx cv caddc cG cseq1 co cfv vw cv wceq
        vw cv cA cle wbr vx cn vx cv caddc cG cseq1 co cfv vw cv wceq vx cv
        caddc cG cseq1 co cfv cA cle wbr vw cv cA cle wbr vx cv cn wcel vx cv
        caddc cG cseq1 co cfv vw cv cA cle breq1 vx cv cn wcel vx cv caddc cG
        cseq1 co cfv vx cv caddc cF cseq1 co cfv cA vx cv cG cvgcmp.3 ser1recli
        vx cv cF cvgcmp.2 ser1recli cA cr wcel vx cv cn wcel cA caddc cF cseq1
        co cvgcmp.1 cF cvgcmp.2 ser1refi cvgcmp.5 climfnrcli a1i vx vx cv cF cG
        cvgcmp.2 cvgcmp.3 vx cv cn wcel cc0 vx cv cG cfv cle wbr vx cv cG cfv
        vx cv cF cfv cle wbr cvgcmp.4 pm3.27d ser1cmpi cA vx caddc cF cseq1 co
        vx cv cvgcmp.1 cF cvgcmp.2 ser1refi vx vx cv cF cvgcmp.2 vx cv cG cfv
        cr wcel vx cv cF cfv cr wcel wa cc0 vx cv cG cfv cle wbr vx cv cG cfv
        vx cv cF cfv cle wbr wa cc0 vx cv cF cfv cle wbr vx cv cn wcel cc0 cr
        wcel vx cv cG cfv cr wcel vx cv cF cfv cr wcel cc0 vx cv cG cfv cle wbr
        vx cv cG cfv vx cv cF cfv cle wbr wa cc0 vx cv cF cfv cle wbr wi 0re
        cc0 vx cv cG cfv vx cv cF cfv letr mp3an1 vx cv cn wcel vx cv cG cfv cr
        wcel vx cv cF cfv cr wcel cn cr vx cv cG cvgcmp.3 ffvelrni cn cr vx cv
        cF cvgcmp.2 ffvelrni jca cvgcmp.4 sylc ser1monoi cvgcmp.5 climubi letrd
        syl5cbi r19.23aiv sylbi rgen vy vz vw caddc cG cseq1 co crn cA caddc cG
        cseq1 co crn cr wss caddc cG cseq1 co crn c0 wne vz cv vy cv cle wbr vz
        caddc cG cseq1 co crn wral vy cr wrex cn cr caddc cG cseq1 co wf caddc
        cG cseq1 co crn cr wss cG cvgcmp.3 ser1refi cn cr caddc cG cseq1 co frn
        ax-mp cn c0 wne caddc cG cseq1 co crn c0 wne c1 cn wcel cn c0 wne 1nn
        cn c1 ne0i ax-mp cn c0 caddc cG cseq1 co crn c0 cn c0 wceq caddc cG
        cseq1 co cdm c0 wceq caddc cG cseq1 co crn c0 wceq caddc cG cseq1 co
        cdm cn c0 cn cr caddc cG cseq1 co cG cvgcmp.3 ser1refi fdmi eqeq1i
        caddc cG cseq1 co dm0rn0 bitr3i necon3bii mpbi cA cr wcel vz cv cA cle
        wbr vz caddc cG cseq1 co crn wral vz cv vy cv cle wbr vz caddc cG cseq1
        co crn wral vy cr wrex cA caddc cF cseq1 co cvgcmp.1 cF cvgcmp.2
        ser1refi cvgcmp.5 climfnrcli vz cv cA cle wbr vz caddc cG cseq1 co crn
        vz cv caddc cG cseq1 co crn wcel vx cv caddc cG cseq1 co cfv vz cv wceq
        vx cn wrex vz cv cA cle wbr caddc cG cseq1 co cn wfn vz cv caddc cG
        cseq1 co crn wcel vx cv caddc cG cseq1 co cfv vz cv wceq vx cn wrex wb
        cn cr caddc cG cseq1 co wf caddc cG cseq1 co cn wfn cG cvgcmp.3
        ser1refi cn cr caddc cG cseq1 co ffn ax-mp vx cn vz cv caddc cG cseq1
        co fvelrnb ax-mp vx cv caddc cG cseq1 co cfv vz cv wceq vz cv cA cle
        wbr vx cn vx cv caddc cG cseq1 co cfv vz cv wceq vx cv caddc cG cseq1
        co cfv cA cle wbr vz cv cA cle wbr vx cv cn wcel vx cv caddc cG cseq1
        co cfv vz cv cA cle breq1 vx cv cn wcel vx cv caddc cG cseq1 co cfv vx
        cv caddc cF cseq1 co cfv cA vx cv cG cvgcmp.3 ser1recli vx cv cF
        cvgcmp.2 ser1recli cA cr wcel vx cv cn wcel cA caddc cF cseq1 co
        cvgcmp.1 cF cvgcmp.2 ser1refi cvgcmp.5 climfnrcli a1i vx vx cv cF cG
        cvgcmp.2 cvgcmp.3 vx cv cn wcel cc0 vx cv cG cfv cle wbr vx cv cG cfv
        vx cv cF cfv cle wbr cvgcmp.4 pm3.27d ser1cmpi cA vx caddc cF cseq1 co
        vx cv cvgcmp.1 cF cvgcmp.2 ser1refi vx vx cv cF cvgcmp.2 vx cv cG cfv
        cr wcel vx cv cF cfv cr wcel wa cc0 vx cv cG cfv cle wbr vx cv cG cfv
        vx cv cF cfv cle wbr wa cc0 vx cv cF cfv cle wbr vx cv cn wcel cc0 cr
        wcel vx cv cG cfv cr wcel vx cv cF cfv cr wcel cc0 vx cv cG cfv cle wbr
        vx cv cG cfv vx cv cF cfv cle wbr wa cc0 vx cv cF cfv cle wbr wi 0re
        cc0 vx cv cG cfv vx cv cF cfv letr mp3an1 vx cv cn wcel vx cv cG cfv cr
        wcel vx cv cF cfv cr wcel cn cr vx cv cG cvgcmp.3 ffvelrni cn cr vx cv
        cF cvgcmp.2 ffvelrni jca cvgcmp.4 sylc ser1monoi cvgcmp.5 climubi letrd
        syl5cbi r19.23aiv sylbi rgen vz cv vy cv cle wbr vz caddc cG cseq1 co
        crn wral vz cv cA cle wbr vz caddc cG cseq1 co crn wral vy cA cr vy cv
        cA wceq vz cv vy cv cle wbr vz cv cA cle wbr vz caddc cG cseq1 co crn
        vy cv cA vz cv cle breq2 ralbidv rcla4ev mp2an 3pm3.2i suprleubii mp2an
        eqbrtri $.
        $( [1-Jul-2006] $) $( [18-Mar-2005] $)
    $}
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x y z w v u G $.  $d x z w v u H $.
    $d x y u T $.  $d x z w R $.  $d z w S $.  $d x y u D $.
    $d x y z w v u C $.
    cvgcmp3.1 $e |- F : NN --> RR $.
    cvgcmp3.2 $e |- T : NN --> CC $.
    cvgcmp3.3 $e |- ( x e. NN -> 0 <_ ( F ` x ) ) $.
    cvgcmp3.6 $e |- A e. _V $.
    cvgcmp3.7 $e |- ( + seq1 F ) ~~> A $.
    cvgcmp3.8 $e |- H Fn NN $.
    cvgcmp3.9 $e |- ( x e. NN -> ( H ` x ) = ( abs ` ( T ` x ) ) ) $.
    cvgcmp3.10 $e |- G Fn NN $.
    cvgcmp3.11 $e |- ( x e. NN ->
                        ( G ` x ) = ( Re ` ( ( + seq1 T ) ` x ) ) ) $.
    cvgcmp3.12 $e |- R = { u e. RR | E. y e. NN A. v e. NN (
                      y <_ v -> u < ( G ` v ) ) } $.
    cvgcmp3.13 $e |- C Fn NN $.
    cvgcmp3.14 $e |- ( x e. NN ->
                         ( C ` x ) = ( Im ` ( ( + seq1 T ) ` x ) ) ) $.
    cvgcmp3.15 $e |- S = { u e. RR | E. y e. NN A. v e. NN (
                      y <_ v -> u < ( C ` v ) ) } $.
    cvgcmp3.16 $e |- D Fn NN $.
    cvgcmp3.17 $e |- ( x e. NN -> ( D ` x ) = ( _i x. ( C ` x ) ) ) $.
    cvgcmp3.4 $e |- B e. NN $.
    ${
      $d x Q $.
      cvgcmp3c.18 $e |- Q e. RR $.
      cvgcmp3c.19 $e |- 0 <_ Q $.
      cvgcmp3c.5 $e |- ( ( x e. NN /\ B < x ) ->
                     ( abs ` ( T ` x ) ) <_ ( Q x. ( F ` x ) ) ) $.
      $( A comparison test for convergence of a complex infinite series, where
        the reference sequence is multiplied by a constant.  This version of
        ~ cvgcmp3cei shows the explicit value of the limit (which is why we
        need all the hypotheses). $)
      cvgcmp3ci $p |- ( + seq1 T ) ~~>
                       ( sup ( R , RR , < ) + ( _i x. sup ( S , RR , < ) ) ) $=
        vx vv vz vw vy vu cD cR cS caddc cT cseq1 co cG cC cT cvgcmp3.2 ser1fi
        cc0 vz cv clt wbr vw cv vv cv clt wbr vv cv caddc cH cseq1 co cfv vw cv
        caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr wi vv cn wral vw
        cn wrex wi vz cr wral cc0 vz cv clt wbr vw cv vv cv clt wbr vv cv caddc
        cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv vz cv clt
        wbr wi vv cn wral vw cn wrex wi vz cr wral vz vw vv caddc cH cseq1 co
        crn cr clt csup caddc cH cseq1 co cr caddc cH cseq1 co crn clt ltso
        supex vx cA cB cQ cF cH cvgcmp3.6 cvgcmp3.1 cn cr cH wf cH cn wfn vx cv
        cH cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv cH cfv cr
        wcel vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv cr
        cvgcmp3.9 vx cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv cr
        wcel cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl eqeltrd
        rgen mpbir2an cvgcmp3.3 vx cv cn wcel cc0 vx cv cT cfv cabs cfv vx cv
        cH cfv cle vx cv cn wcel vx cv cT cfv cc wcel cc0 vx cv cT cfv cabs cfv
        cle wbr cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv absge0 syl
        cvgcmp3.9 breqtrrd cvgcmp3.7 cvgcmp3.4 cvgcmp3c.18 cvgcmp3c.19 vx cv cn
        wcel cB vx cv clt wbr wa vx cv cH cfv vx cv cT cfv cabs cfv cQ vx cv cF
        cfv cmul co cle vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv wceq
        cB vx cv clt wbr cvgcmp3.9 adantr cvgcmp3c.5 eqbrtrd cvgcmp2ci cH cn cr
        cH wf cr cc wss cn cc cH wf cn cr cH wf cH cn wfn vx cv cH cfv cr wcel
        vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv cH cfv cr wcel vx cn vx cv
        cn wcel vx cv cH cfv vx cv cT cfv cabs cfv cr cvgcmp3.9 vx cv cn wcel
        vx cv cT cfv cc wcel vx cv cT cfv cabs cfv cr wcel cn cc vx cv cT
        cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl eqeltrd rgen mpbir2an
        axresscn cn cr cc cH fss mp2an ser1fi climcaui cc0 vz cv clt wbr vw cv
        vv cv clt wbr vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv
        cmin co cabs cfv vz cv clt wbr wi vv cn wral vw cn wrex wi cc0 vz cv
        clt wbr vw cv vv cv clt wbr vv cv caddc cT cseq1 co cfv vw cv caddc cT
        cseq1 co cfv cmin co cabs cfv vz cv clt wbr wi vv cn wral vw cn wrex wi
        vz cr vz cv cr wcel vw cv vv cv clt wbr vv cv caddc cH cseq1 co cfv vw
        cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr wi vv cn wral
        vw cn wrex vw cv vv cv clt wbr vv cv caddc cT cseq1 co cfv vw cv caddc
        cT cseq1 co cfv cmin co cabs cfv vz cv clt wbr wi vv cn wral vw cn wrex
        cc0 vz cv clt wbr vz cv cr wcel vw cv vv cv clt wbr vv cv caddc cH
        cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr
        wi vv cn wral vw cv vv cv clt wbr vv cv caddc cT cseq1 co cfv vw cv
        caddc cT cseq1 co cfv cmin co cabs cfv vz cv clt wbr wi vv cn wral vw
        cn vz cv cr wcel vw cv cn wcel wa vw cv vv cv clt wbr vv cv caddc cH
        cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr
        wi vw cv vv cv clt wbr vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1
        co cfv cmin co cabs cfv vz cv clt wbr wi vv cn vz cv cr wcel vw cv cn
        wcel wa vv cv cn wcel wa vw cv vv cv clt wbr vv cv caddc cH cseq1 co
        cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr vv cv
        caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv vz
        cv clt wbr vz cv cr wcel vv cv cn wcel vw cv cn wcel vw cv vv cv clt
        wbr vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co
        cabs cfv vz cv clt wbr vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1
        co cfv cmin co cabs cfv vz cv clt wbr wi wi vz cv cr wcel vv cv cn wcel
        wa vw cv cn wcel wa vw cv vv cv clt wbr vv cv caddc cH cseq1 co cfv vw
        cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr vv cv caddc cT
        cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv vz cv clt wbr
        wi vz cv cr wcel vv cv cn wcel wa vw cv cn wcel wa vw cv vv cv clt wbr
        wa vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs
        cfv vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co
        cabs cfv cle wbr vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co
        cfv cmin co cabs cfv vz cv clt wbr vv cv caddc cT cseq1 co cfv vw cv
        caddc cT cseq1 co cfv cmin co cabs cfv vz cv clt wbr vv cv cn wcel vw
        cv cn wcel vw cv vv cv clt wbr vv cv caddc cT cseq1 co cfv vw cv caddc
        cT cseq1 co cfv cmin co cabs cfv vv cv caddc cH cseq1 co cfv vw cv
        caddc cH cseq1 co cfv cmin co cabs cfv cle wbr vz cv cr wcel vv cv cn
        wcel vw cv cn wcel wa vw cv vv cv clt wbr wa vv cv caddc cT cseq1 co
        cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv vv cv caddc cH cseq1
        co cfv vw cv caddc cH cseq1 co cfv cmin co vv cv caddc cH cseq1 co cfv
        vw cv caddc cH cseq1 co cfv cmin co cabs cfv vv cv cn wcel vw cv cn
        wcel wa vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co
        cabs cfv cr wcel vw cv vv cv clt wbr vv cv cn wcel vw cv cn wcel wa vv
        cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cc wcel vv
        cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv
        cr wcel vv cv caddc cT cseq1 co cfv cc wcel vw cv caddc cT cseq1 co cfv
        cc wcel vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co
        cc wcel vv cv cn wcel vw cv cn wcel vv cv caddc cT cseq1 co cfv vw cv
        caddc cT cseq1 co cfv subcl vv cv cT cvgcmp3.2 ser1cl1i vw cv cT
        cvgcmp3.2 ser1cl1i syl2an vv cv caddc cT cseq1 co cfv vw cv caddc cT
        cseq1 co cfv cmin co abscl syl adantr vv cv cn wcel vw cv cn wcel wa vv
        cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cr wcel vw
        cv vv cv clt wbr vv cv caddc cH cseq1 co cfv cr wcel vw cv caddc cH
        cseq1 co cfv cr wcel vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1
        co cfv cmin co cr wcel vv cv cn wcel vw cv cn wcel vv cv caddc cH cseq1
        co cfv vw cv caddc cH cseq1 co cfv resubcl vv cv cH cn cr cH wf cH cn
        wfn vx cv cH cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv
        cH cfv cr wcel vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv
        cr cvgcmp3.9 vx cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv
        cr wcel cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl
        eqeltrd rgen mpbir2an ser1recli vw cv cH cn cr cH wf cH cn wfn vx cv cH
        cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv cH cfv cr wcel
        vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv cr cvgcmp3.9 vx
        cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv cr wcel cn cc vx
        cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl eqeltrd rgen mpbir2an
        ser1recli syl2an adantr vv cv cn wcel vw cv cn wcel wa vv cv caddc cH
        cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv cr wcel vw cv
        vv cv clt wbr vv cv cn wcel vw cv cn wcel wa vv cv caddc cH cseq1 co
        cfv vw cv caddc cH cseq1 co cfv cmin co cc wcel vv cv caddc cH cseq1 co
        cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv cr wcel vv cv cn wcel
        vw cv cn wcel wa vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co
        cfv cmin co vv cv caddc cH cseq1 co cfv cr wcel vw cv caddc cH cseq1 co
        cfv cr wcel vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv
        cmin co cr wcel vv cv cn wcel vw cv cn wcel vv cv caddc cH cseq1 co cfv
        vw cv caddc cH cseq1 co cfv resubcl vv cv cH cn cr cH wf cH cn wfn vx
        cv cH cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv cH cfv
        cr wcel vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv cr
        cvgcmp3.9 vx cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv cr
        wcel cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl eqeltrd
        rgen mpbir2an ser1recli vw cv cH cn cr cH wf cH cn wfn vx cv cH cfv cr
        wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv cH cfv cr wcel vx cn
        vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv cr cvgcmp3.9 vx cv cn
        wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv cr wcel cn cc vx cv cT
        cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl eqeltrd rgen mpbir2an
        ser1recli syl2an recnd vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1
        co cfv cmin co abscl syl adantr vv cv cn wcel vw cv cn wcel vw cv vv cv
        clt wbr vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co
        cabs cfv vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin
        co cle wbr vw cv cn wcel vv cv cn wcel vw cv vv cv clt wbr vv cv caddc
        cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv vv cv
        caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cle wbr vx vw
        cv vv cv cT cH cvgcmp3.2 cvgcmp3.8 cvgcmp3.9 ser1absdifi 3com12 3expa
        vv cv cn wcel vw cv cn wcel wa vv cv caddc cH cseq1 co cfv vw cv caddc
        cH cseq1 co cfv cmin co vv cv caddc cH cseq1 co cfv vw cv caddc cH
        cseq1 co cfv cmin co cabs cfv cle wbr vw cv vv cv clt wbr vv cv cn wcel
        vw cv cn wcel wa vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co
        cfv cmin co cr wcel vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co
        cfv cmin co vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv
        cmin co cabs cfv cle wbr vv cv caddc cH cseq1 co cfv cr wcel vw cv
        caddc cH cseq1 co cfv cr wcel vv cv caddc cH cseq1 co cfv vw cv caddc
        cH cseq1 co cfv cmin co cr wcel vv cv cn wcel vw cv cn wcel vv cv caddc
        cH cseq1 co cfv vw cv caddc cH cseq1 co cfv resubcl vv cv cH cn cr cH
        wf cH cn wfn vx cv cH cfv cr wcel vx cn wral vx cn cr cH ffnfv
        cvgcmp3.8 vx cv cH cfv cr wcel vx cn vx cv cn wcel vx cv cH cfv vx cv
        cT cfv cabs cfv cr cvgcmp3.9 vx cv cn wcel vx cv cT cfv cc wcel vx cv
        cT cfv cabs cfv cr wcel cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv
        abscl syl eqeltrd rgen mpbir2an ser1recli vw cv cH cn cr cH wf cH cn
        wfn vx cv cH cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv
        cH cfv cr wcel vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv
        cr cvgcmp3.9 vx cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv
        cr wcel cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl
        eqeltrd rgen mpbir2an ser1recli syl2an vv cv caddc cH cseq1 co cfv vw
        cv caddc cH cseq1 co cfv cmin co leabs syl adantr letrd adantlll vz cv
        cr wcel vv cv cn wcel wa vw cv cn wcel wa vv cv caddc cT cseq1 co cfv
        vw cv caddc cT cseq1 co cfv cmin co cabs cfv vv cv caddc cH cseq1 co
        cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv cle wbr vv cv caddc cH
        cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv clt wbr
        wa vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs
        cfv vz cv clt wbr wi vw cv vv cv clt wbr vv cv caddc cT cseq1 co cfv vw
        cv caddc cT cseq1 co cfv cmin co cabs cfv cr wcel vv cv caddc cH cseq1
        co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv cr wcel vz cv cr
        wcel vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co
        cabs cfv vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin
        co cabs cfv cle wbr vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co
        cfv cmin co cabs cfv vz cv clt wbr wa vv cv caddc cT cseq1 co cfv vw cv
        caddc cT cseq1 co cfv cmin co cabs cfv vz cv clt wbr wi vz cv cr wcel
        vv cv cn wcel wa vw cv cn wcel wa vv cv caddc cT cseq1 co cfv vw cv
        caddc cT cseq1 co cfv cmin co cabs cfv vv cv caddc cH cseq1 co cfv vw
        cv caddc cH cseq1 co cfv cmin co cabs cfv vz cv lelttr vv cv cn wcel vw
        cv cn wcel vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin
        co cabs cfv cr wcel vz cv cr wcel vv cv cn wcel vw cv cn wcel wa vv cv
        caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cc wcel vv cv
        caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cabs cfv cr
        wcel vv cv caddc cT cseq1 co cfv cc wcel vw cv caddc cT cseq1 co cfv cc
        wcel vv cv caddc cT cseq1 co cfv vw cv caddc cT cseq1 co cfv cmin co cc
        wcel vv cv cn wcel vw cv cn wcel vv cv caddc cT cseq1 co cfv vw cv
        caddc cT cseq1 co cfv subcl vv cv cT cvgcmp3.2 ser1cl1i vw cv cT
        cvgcmp3.2 ser1cl1i syl2an vv cv caddc cT cseq1 co cfv vw cv caddc cT
        cseq1 co cfv cmin co abscl syl adantll vv cv cn wcel vw cv cn wcel vv
        cv caddc cH cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv
        cr wcel vz cv cr wcel vv cv cn wcel vw cv cn wcel wa vv cv caddc cH
        cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cc wcel vv cv caddc cH
        cseq1 co cfv vw cv caddc cH cseq1 co cfv cmin co cabs cfv cr wcel vv cv
        cn wcel vw cv cn wcel wa vv cv caddc cH cseq1 co cfv vw cv caddc cH
        cseq1 co cfv cmin co vv cv caddc cH cseq1 co cfv cr wcel vw cv caddc cH
        cseq1 co cfv cr wcel vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1
        co cfv cmin co cr wcel vv cv cn wcel vw cv cn wcel vv cv caddc cH cseq1
        co cfv vw cv caddc cH cseq1 co cfv resubcl vv cv cH cn cr cH wf cH cn
        wfn vx cv cH cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv
        cH cfv cr wcel vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv
        cr cvgcmp3.9 vx cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv
        cr wcel cn cc vx cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl
        eqeltrd rgen mpbir2an ser1recli vw cv cH cn cr cH wf cH cn wfn vx cv cH
        cfv cr wcel vx cn wral vx cn cr cH ffnfv cvgcmp3.8 vx cv cH cfv cr wcel
        vx cn vx cv cn wcel vx cv cH cfv vx cv cT cfv cabs cfv cr cvgcmp3.9 vx
        cv cn wcel vx cv cT cfv cc wcel vx cv cT cfv cabs cfv cr wcel cn cc vx
        cv cT cvgcmp3.2 ffvelrni vx cv cT cfv abscl syl eqeltrd rgen mpbir2an
        ser1recli syl2an recnd vv cv caddc cH cseq1 co cfv vw cv caddc cH cseq1
        co cfv cmin co abscl syl adantll vz cv cr wcel vv cv cn wcel vw cv cn
        wcel simpll syl3anc adantr mpand ex an1rs a2d r19.20dva r19.22dva
        imim2d r19.20i ax-mp cvgcmp3.10 cvgcmp3.11 cvgcmp3.12 cvgcmp3.13
        cvgcmp3.14 cvgcmp3.15 cvgcmp3.16 cvgcmp3.17 caucvg3ai $.
        $( [20-Jun-2006] $) $( [24-Apr-2005] $)
    $}
  $}

  ${
    cvgcmp3ce.1 $e |- A e. _V $.
    cvgcmp3ce.2 $e |- B e. NN $.
    cvgcmp3ce.3 $e |- F : NN --> RR $.
    cvgcmp3ce.4 $e |- ( x e. NN -> 0 <_ ( F ` x ) ) $.
    cvgcmp3ce.5 $e |- ( + seq1 F ) ~~> A $.
    ${
      $d x A $.
      $d x B $.  $d x F $.
      $d x y z w v u t h g G $.  $d x C $.
      cvgcmp3ce.6 $e |- C e. RR $.
      cvgcmp3ce.7 $e |- 0 <_ C $.
      cvgcmp3ce.8 $e |- G : NN --> CC $.
      cvgcmp3ce.9 $e |- ( ( x e. NN /\ B < x ) ->
                           ( abs ` ( G ` x ) ) <_ ( C x. ( F ` x ) ) ) $.
      $( A comparison test for convergence of a complex infinite series.
         If, beyond a certain index ` B ` , the absolute value of sequence
         ` G ` is smaller than a constant ` C ` times a convergent reference
         sequence ` F ` , then ` G ` converges to a complex number.  This
         version of ~ cvgcmp3ci shows just the existence of the limit rather
         than its explicit value. $)
      cvgcmp3cei $p |- E. y ( + seq1 G ) ~~> y $=
        caddc cG cseq1 co vw cv vv cv cle wbr vz cv vv cv vu cv cn wcel vt cv
        vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt copab cfv clt wbr wi
        vv cn wral vw cn wrex vz cr crab cr clt csup ci vw cv vv cv cle wbr vz
        cv vv cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq
        wa vu vt copab cfv clt wbr wi vv cn wral vw cn wrex vz cr crab cr clt
        csup cmul co caddc co cli wbr caddc cG cseq1 co vy cv cli wbr vy wex vx
        vw vv vz cA cB vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv
        wceq wa vu vt copab vh cv cn wcel vg cv ci vh cv vu cv cn wcel vt cv vu
        cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab cfv cmul co wceq
        wa vh vg copab cC vw cv vv cv cle wbr vz cv vv cv vu cv cn wcel vt cv
        vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt copab cfv clt wbr wi
        vv cn wral vw cn wrex vz cr crab vw cv vv cv cle wbr vz cv vv cv vu cv
        cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab
        cfv clt wbr wi vv cn wral vw cn wrex vz cr crab cG cF vu cv cn wcel vt
        cv vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt copab vu cv cn
        wcel vt cv vu cv cG cfv cabs cfv wceq wa vu vt copab cvgcmp3ce.3
        cvgcmp3ce.8 cvgcmp3ce.4 cvgcmp3ce.1 cvgcmp3ce.5 vu vt cn vu cv cG cfv
        cabs cfv vu cv cn wcel vt cv vu cv cG cfv cabs cfv wceq wa vu vt copab
        vu cv cG cfv cabs fvex vu cv cn wcel vt cv vu cv cG cfv cabs cfv wceq
        wa vu vt copab eqid fnopab2 vu vt vx cv vu cv cG cfv cabs cfv vx cv cG
        cfv cabs cfv cn vu cv cn wcel vt cv vu cv cG cfv cabs cfv wceq wa vu vt
        copab vu cv vx cv wceq vu cv cG cfv vx cv cG cfv cabs vu cv vx cv cG
        fveq2 fveq2d vu cv cn wcel vt cv vu cv cG cfv cabs cfv wceq wa vu vt
        copab eqid vx cv cG cfv cabs fvex fvopab4 vu vt cn vu cv caddc cG cseq1
        co cfv cre cfv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cre cfv
        wceq wa vu vt copab vu cv caddc cG cseq1 co cfv cre fvex vu cv cn wcel
        vt cv vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt copab eqid
        fnopab2 vu vt vx cv vu cv caddc cG cseq1 co cfv cre cfv vx cv caddc cG
        cseq1 co cfv cre cfv cn vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv
        cre cfv wceq wa vu vt copab vu cv vx cv wceq vu cv caddc cG cseq1 co
        cfv vx cv caddc cG cseq1 co cfv cre vu cv vx cv caddc cG cseq1 co fveq2
        fveq2d vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cre cfv wceq wa
        vu vt copab eqid vx cv caddc cG cseq1 co cfv cre fvex fvopab4 vw cv vv
        cv cle wbr vz cv vv cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv
        cre cfv wceq wa vu vt copab cfv clt wbr wi vv cn wral vw cn wrex vz cr
        crab eqid vu vt cn vu cv caddc cG cseq1 co cfv cim cfv vu cv cn wcel vt
        cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab vu cv caddc
        cG cseq1 co cfv cim fvex vu cv cn wcel vt cv vu cv caddc cG cseq1 co
        cfv cim cfv wceq wa vu vt copab eqid fnopab2 vu vt vx cv vu cv caddc cG
        cseq1 co cfv cim cfv vx cv caddc cG cseq1 co cfv cim cfv cn vu cv cn
        wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab vu
        cv vx cv wceq vu cv caddc cG cseq1 co cfv vx cv caddc cG cseq1 co cfv
        cim vu cv vx cv caddc cG cseq1 co fveq2 fveq2d vu cv cn wcel vt cv vu
        cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab eqid vx cv caddc
        cG cseq1 co cfv cim fvex fvopab4 vw cv vv cv cle wbr vz cv vv cv vu cv
        cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab
        cfv clt wbr wi vv cn wral vw cn wrex vz cr crab eqid vh vg cn ci vh cv
        vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt
        copab cfv cmul co vh cv cn wcel vg cv ci vh cv vu cv cn wcel vt cv vu
        cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab cfv cmul co wceq
        wa vh vg copab ci vh cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv
        cim cfv wceq wa vu vt copab cfv cmul oprex vh cv cn wcel vg cv ci vh cv
        vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt
        copab cfv cmul co wceq wa vh vg copab eqid fnopab2 vh vg vx cv ci vh cv
        vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt
        copab cfv cmul co ci vx cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co
        cfv cim cfv wceq wa vu vt copab cfv cmul co cn vh cv cn wcel vg cv ci
        vh cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa
        vu vt copab cfv cmul co wceq wa vh vg copab vh cv vx cv wceq vh cv vu
        cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt
        copab cfv vx cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv
        wceq wa vu vt copab cfv ci cmul vh cv vx cv vu cv cn wcel vt cv vu cv
        caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab fveq2 opreq2d vh cv
        cn wcel vg cv ci vh cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv
        cim cfv wceq wa vu vt copab cfv cmul co wceq wa vh vg copab eqid ci vx
        cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu
        vt copab cfv cmul oprex fvopab4 cvgcmp3ce.2 cvgcmp3ce.6 cvgcmp3ce.7
        cvgcmp3ce.9 cvgcmp3ci caddc cG cseq1 co vy cv cli wbr caddc cG cseq1 co
        vw cv vv cv cle wbr vz cv vv cv vu cv cn wcel vt cv vu cv caddc cG
        cseq1 co cfv cre cfv wceq wa vu vt copab cfv clt wbr wi vv cn wral vw
        cn wrex vz cr crab cr clt csup ci vw cv vv cv cle wbr vz cv vv cv vu cv
        cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq wa vu vt copab
        cfv clt wbr wi vv cn wral vw cn wrex vz cr crab cr clt csup cmul co
        caddc co cli wbr vy vw cv vv cv cle wbr vz cv vv cv vu cv cn wcel vt cv
        vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt copab cfv clt wbr wi
        vv cn wral vw cn wrex vz cr crab cr clt csup ci vw cv vv cv cle wbr vz
        cv vv cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv wceq
        wa vu vt copab cfv clt wbr wi vv cn wral vw cn wrex vz cr crab cr clt
        csup cmul co caddc co vw cv vv cv cle wbr vz cv vv cv vu cv cn wcel vt
        cv vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt copab cfv clt wbr
        wi vv cn wral vw cn wrex vz cr crab cr clt csup ci vw cv vv cv cle wbr
        vz cv vv cv vu cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cim cfv
        wceq wa vu vt copab cfv clt wbr wi vv cn wral vw cn wrex vz cr crab cr
        clt csup cmul co caddc oprex vy cv vw cv vv cv cle wbr vz cv vv cv vu
        cv cn wcel vt cv vu cv caddc cG cseq1 co cfv cre cfv wceq wa vu vt
        copab cfv clt wbr wi vv cn wral vw cn wrex vz cr crab cr clt csup ci vw
        cv vv cv cle wbr vz cv vv cv vu cv cn wcel vt cv vu cv caddc cG cseq1
        co cfv cim cfv wceq wa vu vt copab cfv clt wbr wi vv cn wral vw cn wrex
        vz cr crab cr clt csup cmul co caddc co caddc cG cseq1 co cli breq2
        cla4ev ax-mp $.
        $( [21-Jun-2006] $) $( [24-Apr-2005] $)
    $}

    ${
      $d z A $.  $d x z B $.  $d x z F $.  $d x y z G $.  $d x z C $.
      $d y z ph $.
      cvgcmp3cetlem1.6 $e |- ( ph <->
                               ( ( C e. RR /\ 0 <_ C ) /\ ( G : NN --> CC
  /\ A. x e. NN ( B < x -> ( abs ` ( G ` x ) ) <_ ( C x. ( F ` x ) ) ) ) ) ) $.
      $( Lemma for ~ cvgcmp3ce . $)
      cvgcmp3cetlem1 $p |- ( ph -> E. y ( + seq1 G ) ~~> y ) $=
        wph caddc cG cseq1 co vy cv cli wbr vy wex caddc wph cG cn cc0 csn cxp
        cif cseq1 co vy cv cli wbr vy wex cG cn cc0 csn cxp cG wph cG cn cc0
        csn cxp cif wceq caddc cG cseq1 co vy cv cli wbr caddc wph cG cn cc0
        csn cxp cif cseq1 co vy cv cli wbr vy cG wph cG cn cc0 csn cxp cif wceq
        caddc cG cseq1 co caddc wph cG cn cc0 csn cxp cif cseq1 co vy cv cli cG
        wph cG cn cc0 csn cxp cif caddc cseq1 opreq2 breq1d exbidv vz vy cA cB
        wph cC cc0 cif cF wph cG cn cc0 csn cxp cif cvgcmp3ce.1 cvgcmp3ce.2
        cvgcmp3ce.3 cc0 vx cv cF cfv cle wbr cc0 vz cv cF cfv cle wbr vx vz cv
        cn vx cv vz cv wceq vx cv cF cfv vz cv cF cfv cc0 cle vx cv vz cv cF
        fveq2 breq2d cvgcmp3ce.4 vtoclga cvgcmp3ce.5 wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wph cC cc0 cif cr wcel cc0 wph cC cc0 cif cle
        wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle
        wbr wi vz cn wral wa wph cC cr wcel cc0 cC cle wbr wa cn cc wph cG cn
        cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv
        cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa wph cC cc0
        cif cr wcel cc0 wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp
        cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa cc0 cr
        wcel cc0 cc0 cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv
        cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn
        wral wa wa cG cC cn cc0 csn cxp cc0 cc0 cr wcel cc0 cc0 cle wbr wa cn
        cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral
        wa wa cG wph cG cn cc0 csn cxp cif wceq cC cr wcel cc0 cC cle wbr wa cn
        cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr wi vz cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa wph cG
        wph cG cn cc0 csn cxp cif wceq cn cc cG wf cB vz cv clt wbr vz cv cG
        cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph
        cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp
        cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC cr
        wcel cc0 cC cle wbr wa cG wph cG cn cc0 csn cxp cif wceq cn cc cG wf cn
        cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv cG cfv cabs cfv
        cC vz cv cF cfv cmul co cle wbr wi vz cn wral cB vz cv clt wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr
        wi vz cn wral cn cc cG wph cG cn cc0 csn cxp cif feq1 cG wph cG cn cc0
        csn cxp cif wceq cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv
        cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn cG wph cG cn cc0 csn
        cxp cif wceq vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vz
        cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle
        wbr cB vz cv clt wbr cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv
        cabs cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv
        cmul co cle cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv vz cv wph cG
        cn cc0 csn cxp cif cfv cabs vz cv cG wph cG cn cc0 csn cxp cif fveq1
        fveq2d breq1d imbi2d ralbidv anbi12d anbi2d wph cC cr wcel cc0 cC cle
        wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF
        cfv cmul co cle wbr wi vx cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn
        cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr wi vz cn wral wa wa cvgcmp3cetlem1.6 cn cc cG wf cB vx cv clt
        wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral
        wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cC cr wcel cc0 cC cle wbr wa cB vx cv
        clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn
        wral cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle
        wbr wi vz cn wral cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC
        vx cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz cv cG cfv cabs cfv
        cC vz cv cF cfv cmul co cle wbr wi vx vz cn vx cv vz cv wceq cB vx cv
        clt wbr cB vz cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co
        cle wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vx cv vz
        cv cB clt breq2 vx cv vz cv wceq vx cv cG cfv cabs cfv vz cv cG cfv
        cabs cfv cC vx cv cF cfv cmul co cC vz cv cF cfv cmul co cle vx cv vz
        cv wceq vx cv cG cfv vz cv cG cfv cabs vx cv vz cv cG fveq2 fveq2d vx
        cv vz cv wceq vx cv cF cfv vz cv cF cfv cC cmul vx cv vz cv cF fveq2
        opreq2d breq12d imbi12d cbvralv anbi2i anbi2i bitri syl5bb cC wph cC
        cc0 cif wceq cC cr wcel cc0 cC cle wbr wa wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC wph cC cc0 cif
        wceq cC cr wcel wph cC cc0 cif cr wcel cc0 cC cle wbr cc0 wph cC cc0
        cif cle wbr cC wph cC cc0 cif cr eleq1 cC wph cC cc0 cif cc0 cle breq2
        anbi12d cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn cc0 csn
        cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG cn cc0 csn
        cxp cif wf cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr wi vz cn cC wph cC cc0 cif wceq vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul
        co cle wbr cB vz cv clt wbr cC wph cC cc0 cif wceq cC vz cv cF cfv cmul
        co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cle cC wph cC cc0 cif vz cv cF cfv cmul opreq1 breq2d
        imbi2d ralbidv anbi2d anbi12d cn cc0 csn cxp wph cG cn cc0 csn cxp cif
        wceq cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0 cr
        wcel cc0 cc0 cle wbr wa cn cc0 csn cxp wph cG cn cc0 csn cxp cif wceq
        cn cc cn cc0 csn cxp wf cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt
        wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr
        wi vz cn wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc cn cc0 csn cxp
        wph cG cn cc0 csn cxp cif feq1 cn cc0 csn cxp wph cG cn cc0 csn cxp cif
        wceq cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF
        cfv cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn cn cc0 csn cxp
        wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz
        cv cF cfv cmul co cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr cn cc0 csn cxp wph cG
        cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv cabs cfv vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle cn cc0 csn
        cxp wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv vz cv wph
        cG cn cc0 csn cxp cif cfv cabs vz cv cn cc0 csn cxp wph cG cn cc0 csn
        cxp cif fveq1 fveq2d breq1d imbi2d ralbidv anbi12d anbi2d cc0 wph cC
        cc0 cif wceq cc0 cr wcel cc0 cc0 cle wbr wa wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0 wph cC cc0 cif
        wceq cc0 cr wcel wph cC cc0 cif cr wcel cc0 cc0 cle wbr cc0 wph cC cc0
        cif cle wbr cc0 wph cC cc0 cif cr eleq1 cc0 wph cC cc0 cif cc0 cle
        breq2 anbi12d cc0 wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn
        wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph
        cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG cn
        cc0 csn cxp cif wf cc0 wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph
        cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi
        cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC
        cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn cc0 wph cC cc0 cif wceq
        vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co
        cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr cB vz cv clt wbr cc0 wph cC cc0 cif wceq cc0
        vz cv cF cfv cmul co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cle cc0 wph cC cc0 cif vz cv cF cfv
        cmul opreq1 breq2d imbi2d ralbidv anbi2d anbi12d cc0 cr wcel cc0 cc0
        cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn
        cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0
        cr wcel cc0 cc0 cle wbr 0re cc0 0re leidi pm3.2i cn cc cn cc0 csn cxp
        wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle wbr wi vz cn wral cn cc0 csn cn cc0 csn cxp wf cc0 csn cc
        wss cn cc cn cc0 csn cxp wf cn cc0 cc0 cc 0cn elisseti fconst cc0 cc
        wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp cn cc0 csn cc cn cc0 csn cxp
        fss mp2an cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv
        cF cfv cmul co cle wbr wi vz cn vz cv cn wcel vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr vz cv cn
        wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cc0 vz cv cF cfv cmul co cle
        vz cv cn wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cabs cfv cc0 vz cv
        cn wcel vz cv cn cc0 csn cxp cfv cc0 cabs cn cc0 vz cv cc0 cc 0cn
        elisseti fvconst2 fveq2d abs0 syl6eq vz cv cn wcel cc0 cc0 vz cv cF cfv
        cmul co cc0 cle vz cv cn wcel vz cv cF cfv cc wcel cc0 vz cv cF cfv
        cmul co cc0 wceq vz cv cn wcel vz cv cF cfv cn cr vz cv cF cvgcmp3ce.3
        ffvelrni recnd vz cv cF cfv mul02 syl cc0 0re leidi syl5breqr eqbrtrd
        a1d rgen pm3.2i pm3.2i elimhyp2v pm3.26i pm3.26i wph cC cc0 cif cr wcel
        cc0 wph cC cc0 cif cle wbr wph cC cc0 cif cr wcel cc0 wph cC cc0 cif
        cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul
        co cle wbr wi vz cn wral wa wph cC cr wcel cc0 cC cle wbr wa cn cc wph
        cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp
        cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa
        wph cC cc0 cif cr wcel cc0 wph cC cc0 cif cle wbr wa cn cc wph cG cn
        cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv
        cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa
        wa cc0 cr wcel cc0 cc0 cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt
        wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr
        wi vz cn wral wa wa cG cC cn cc0 csn cxp cc0 cc0 cr wcel cc0 cc0 cle
        wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz
        cn wral wa wa cG wph cG cn cc0 csn cxp cif wceq cC cr wcel cc0 cC cle
        wbr wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF
        cfv cmul co cle wbr wi vz cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn
        cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral
        wa wa wph cG wph cG cn cc0 csn cxp cif wceq cn cc cG wf cB vz cv clt
        wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral
        wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn
        wral wa cC cr wcel cc0 cC cle wbr wa cG wph cG cn cc0 csn cxp cif wceq
        cn cc cG wf cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv
        cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral cn cc cG wph cG cn cc0 csn cxp cif feq1
        cG wph cG cn cc0 csn cxp cif wceq cB vz cv clt wbr vz cv cG cfv cabs
        cfv cC vz cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn
        cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv
        cF cfv cmul co cle wbr cB vz cv clt wbr cG wph cG cn cc0 csn cxp cif
        wceq vz cv cG cfv cabs cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        cC vz cv cF cfv cmul co cle cG wph cG cn cc0 csn cxp cif wceq vz cv cG
        cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs vz cv cG wph cG cn cc0 csn
        cxp cif fveq1 fveq2d breq1d imbi2d ralbidv anbi12d anbi2d wph cC cr
        wcel cc0 cC cle wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs
        cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa cC cr wcel cc0
        cC cle wbr wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz
        cv cF cfv cmul co cle wbr wi vz cn wral wa wa cvgcmp3cetlem1.6 cn cc cG
        wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle
        wbr wi vx cn wral wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv
        cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC cr wcel cc0 cC cle
        wbr wa cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co
        cle wbr wi vx cn wral cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv
        cF cfv cmul co cle wbr wi vz cn wral cn cc cG wf cB vx cv clt wbr vx cv
        cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz
        cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vx vz cn vx cv vz
        cv wceq cB vx cv clt wbr cB vz cv clt wbr vx cv cG cfv cabs cfv cC vx
        cv cF cfv cmul co cle wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr vx cv vz cv cB clt breq2 vx cv vz cv wceq vx cv cG cfv cabs cfv
        vz cv cG cfv cabs cfv cC vx cv cF cfv cmul co cC vz cv cF cfv cmul co
        cle vx cv vz cv wceq vx cv cG cfv vz cv cG cfv cabs vx cv vz cv cG
        fveq2 fveq2d vx cv vz cv wceq vx cv cF cfv vz cv cF cfv cC cmul vx cv
        vz cv cF fveq2 opreq2d breq12d imbi12d cbvralv anbi2i anbi2i bitri
        syl5bb cC wph cC cc0 cif wceq cC cr wcel cc0 cC cle wbr wa wph cC cc0
        cif cr wcel cc0 wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp
        cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn
        cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC wph
        cC cc0 cif wceq cC cr wcel wph cC cc0 cif cr wcel cc0 cC cle wbr cc0
        wph cC cc0 cif cle wbr cC wph cC cc0 cif cr eleq1 cC wph cC cc0 cif cc0
        cle breq2 anbi12d cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz
        cn wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG
        cn cc0 csn cxp cif wf cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph
        cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi
        cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC
        cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn cC wph cC cc0 cif wceq vz
        cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle
        wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv
        cF cfv cmul co cle wbr cB vz cv clt wbr cC wph cC cc0 cif wceq cC vz cv
        cF cfv cmul co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cle cC wph cC cc0 cif vz cv cF cfv cmul opreq1
        breq2d imbi2d ralbidv anbi2d anbi12d cn cc0 csn cxp wph cG cn cc0 csn
        cxp cif wceq cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn
        cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn
        cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral
        wa cc0 cr wcel cc0 cc0 cle wbr wa cn cc0 csn cxp wph cG cn cc0 csn cxp
        cif wceq cn cc cn cc0 csn cxp wf cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul
        co cle wbr wi vz cn wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp
        cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc
        cn cc0 csn cxp wph cG cn cc0 csn cxp cif feq1 cn cc0 csn cxp wph cG cn
        cc0 csn cxp cif wceq cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv
        cc0 vz cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn
        cn cc0 csn cxp wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr vz cv wph cG cn cc0 csn cxp
        cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr cn
        cc0 csn cxp wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv
        cabs cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle cn cc0 csn cxp wph cG cn cc0 csn cxp cif wceq vz cv cn cc0
        csn cxp cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs vz cv cn cc0 csn
        cxp wph cG cn cc0 csn cxp cif fveq1 fveq2d breq1d imbi2d ralbidv
        anbi12d anbi2d cc0 wph cC cc0 cif wceq cc0 cr wcel cc0 cc0 cle wbr wa
        wph cC cc0 cif cr wcel cc0 wph cC cc0 cif cle wbr wa cn cc wph cG cn
        cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral
        wa cc0 wph cC cc0 cif wceq cc0 cr wcel wph cC cc0 cif cr wcel cc0 cc0
        cle wbr cc0 wph cC cc0 cif cle wbr cc0 wph cC cc0 cif cr eleq1 cc0 wph
        cC cc0 cif cc0 cle breq2 anbi12d cc0 wph cC cc0 cif wceq cB vz cv clt
        wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul
        co cle wbr wi vz cn wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp
        cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn
        wral cn cc wph cG cn cc0 csn cxp cif wf cc0 wph cC cc0 cif wceq cB vz
        cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF
        cfv cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn cc0
        wph cC cc0 cif wceq vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz
        cv cF cfv cmul co cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        wph cC cc0 cif vz cv cF cfv cmul co cle wbr cB vz cv clt wbr cc0 wph cC
        cc0 cif wceq cc0 vz cv cF cfv cmul co wph cC cc0 cif vz cv cF cfv cmul
        co vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cle cc0 wph cC cc0 cif
        vz cv cF cfv cmul opreq1 breq2d imbi2d ralbidv anbi2d anbi12d cc0 cr
        wcel cc0 cc0 cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv
        cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn
        wral wa cc0 cr wcel cc0 cc0 cle wbr 0re cc0 0re leidi pm3.2i cn cc cn
        cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0
        vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc0 csn cn cc0 csn cxp wf
        cc0 csn cc wss cn cc cn cc0 csn cxp wf cn cc0 cc0 cc 0cn elisseti
        fconst cc0 cc wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp cn cc0 csn cc
        cn cc0 csn cxp fss mp2an cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs
        cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn vz cv cn wcel vz cv cn
        cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt
        wbr vz cv cn wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cc0 vz cv cF
        cfv cmul co cle vz cv cn wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0
        cabs cfv cc0 vz cv cn wcel vz cv cn cc0 csn cxp cfv cc0 cabs cn cc0 vz
        cv cc0 cc 0cn elisseti fvconst2 fveq2d abs0 syl6eq vz cv cn wcel cc0
        cc0 vz cv cF cfv cmul co cc0 cle vz cv cn wcel vz cv cF cfv cc wcel cc0
        vz cv cF cfv cmul co cc0 wceq vz cv cn wcel vz cv cF cfv cn cr vz cv cF
        cvgcmp3ce.3 ffvelrni recnd vz cv cF cfv mul02 syl cc0 0re leidi
        syl5breqr eqbrtrd a1d rgen pm3.2i pm3.2i elimhyp2v pm3.26i pm3.27i cn
        cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi
        vz cn wral wph cC cc0 cif cr wcel cc0 wph cC cc0 cif cle wbr wa cn cc
        wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn
        cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz
        cn wral wa wph cC cr wcel cc0 cC cle wbr wa cn cc wph cG cn cc0 csn cxp
        cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa wph cC cc0 cif cr wcel
        cc0 wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz
        cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa cc0 cr wcel cc0 cc0
        cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn
        cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa
        cG cC cn cc0 csn cxp cc0 cc0 cr wcel cc0 cc0 cle wbr wa cn cc wph cG cn
        cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa cG wph cG
        cn cc0 csn cxp cif wceq cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vz
        cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz
        cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn cc wph cG cn cc0 csn cxp
        cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa wph cG wph cG cn cc0
        csn cxp cif wceq cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn
        cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC cr wcel cc0 cC
        cle wbr wa cG wph cG cn cc0 csn cxp cif wceq cn cc cG wf cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv
        cF cfv cmul co cle wbr wi vz cn wral cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn
        wral cn cc cG wph cG cn cc0 csn cxp cif feq1 cG wph cG cn cc0 csn cxp
        cif wceq cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cC vz cv cF cfv cmul co cle wbr wi vz cn cG wph cG cn cc0 csn cxp
        cif wceq vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr
        cB vz cv clt wbr cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv cabs
        cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul
        co cle cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv vz cv wph cG cn
        cc0 csn cxp cif cfv cabs vz cv cG wph cG cn cc0 csn cxp cif fveq1
        fveq2d breq1d imbi2d ralbidv anbi12d anbi2d wph cC cr wcel cc0 cC cle
        wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF
        cfv cmul co cle wbr wi vx cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn
        cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr wi vz cn wral wa wa cvgcmp3cetlem1.6 cn cc cG wf cB vx cv clt
        wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral
        wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cC cr wcel cc0 cC cle wbr wa cB vx cv
        clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn
        wral cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle
        wbr wi vz cn wral cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC
        vx cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz cv cG cfv cabs cfv
        cC vz cv cF cfv cmul co cle wbr wi vx vz cn vx cv vz cv wceq cB vx cv
        clt wbr cB vz cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co
        cle wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vx cv vz
        cv cB clt breq2 vx cv vz cv wceq vx cv cG cfv cabs cfv vz cv cG cfv
        cabs cfv cC vx cv cF cfv cmul co cC vz cv cF cfv cmul co cle vx cv vz
        cv wceq vx cv cG cfv vz cv cG cfv cabs vx cv vz cv cG fveq2 fveq2d vx
        cv vz cv wceq vx cv cF cfv vz cv cF cfv cC cmul vx cv vz cv cF fveq2
        opreq2d breq12d imbi12d cbvralv anbi2i anbi2i bitri syl5bb cC wph cC
        cc0 cif wceq cC cr wcel cc0 cC cle wbr wa wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC wph cC cc0 cif
        wceq cC cr wcel wph cC cc0 cif cr wcel cc0 cC cle wbr cc0 wph cC cc0
        cif cle wbr cC wph cC cc0 cif cr eleq1 cC wph cC cc0 cif cc0 cle breq2
        anbi12d cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn cc0 csn
        cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG cn cc0 csn
        cxp cif wf cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr wi vz cn cC wph cC cc0 cif wceq vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul
        co cle wbr cB vz cv clt wbr cC wph cC cc0 cif wceq cC vz cv cF cfv cmul
        co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cle cC wph cC cc0 cif vz cv cF cfv cmul opreq1 breq2d
        imbi2d ralbidv anbi2d anbi12d cn cc0 csn cxp wph cG cn cc0 csn cxp cif
        wceq cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0 cr
        wcel cc0 cc0 cle wbr wa cn cc0 csn cxp wph cG cn cc0 csn cxp cif wceq
        cn cc cn cc0 csn cxp wf cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt
        wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr
        wi vz cn wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc cn cc0 csn cxp
        wph cG cn cc0 csn cxp cif feq1 cn cc0 csn cxp wph cG cn cc0 csn cxp cif
        wceq cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF
        cfv cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn cn cc0 csn cxp
        wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz
        cv cF cfv cmul co cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr cn cc0 csn cxp wph cG
        cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv cabs cfv vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle cn cc0 csn
        cxp wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv vz cv wph
        cG cn cc0 csn cxp cif cfv cabs vz cv cn cc0 csn cxp wph cG cn cc0 csn
        cxp cif fveq1 fveq2d breq1d imbi2d ralbidv anbi12d anbi2d cc0 wph cC
        cc0 cif wceq cc0 cr wcel cc0 cc0 cle wbr wa wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0 wph cC cc0 cif
        wceq cc0 cr wcel wph cC cc0 cif cr wcel cc0 cc0 cle wbr cc0 wph cC cc0
        cif cle wbr cc0 wph cC cc0 cif cr eleq1 cc0 wph cC cc0 cif cc0 cle
        breq2 anbi12d cc0 wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn
        wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph
        cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG cn
        cc0 csn cxp cif wf cc0 wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph
        cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi
        cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC
        cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn cc0 wph cC cc0 cif wceq
        vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co
        cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr cB vz cv clt wbr cc0 wph cC cc0 cif wceq cc0
        vz cv cF cfv cmul co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cle cc0 wph cC cc0 cif vz cv cF cfv
        cmul opreq1 breq2d imbi2d ralbidv anbi2d anbi12d cc0 cr wcel cc0 cc0
        cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn
        cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0
        cr wcel cc0 cc0 cle wbr 0re cc0 0re leidi pm3.2i cn cc cn cc0 csn cxp
        wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle wbr wi vz cn wral cn cc0 csn cn cc0 csn cxp wf cc0 csn cc
        wss cn cc cn cc0 csn cxp wf cn cc0 cc0 cc 0cn elisseti fconst cc0 cc
        wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp cn cc0 csn cc cn cc0 csn cxp
        fss mp2an cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv
        cF cfv cmul co cle wbr wi vz cn vz cv cn wcel vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr vz cv cn
        wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cc0 vz cv cF cfv cmul co cle
        vz cv cn wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cabs cfv cc0 vz cv
        cn wcel vz cv cn cc0 csn cxp cfv cc0 cabs cn cc0 vz cv cc0 cc 0cn
        elisseti fvconst2 fveq2d abs0 syl6eq vz cv cn wcel cc0 cc0 vz cv cF cfv
        cmul co cc0 cle vz cv cn wcel vz cv cF cfv cc wcel cc0 vz cv cF cfv
        cmul co cc0 wceq vz cv cn wcel vz cv cF cfv cn cr vz cv cF cvgcmp3ce.3
        ffvelrni recnd vz cv cF cfv mul02 syl cc0 0re leidi syl5breqr eqbrtrd
        a1d rgen pm3.2i pm3.2i elimhyp2v pm3.27i pm3.26i vz cv cn wcel cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp
        cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn
        cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi
        vz cn wral wph cC cc0 cif cr wcel cc0 wph cC cc0 cif cle wbr wa cn cc
        wph cG cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn
        cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz
        cn wral wa wph cC cr wcel cc0 cC cle wbr wa cn cc wph cG cn cc0 csn cxp
        cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa wph cC cc0 cif cr wcel
        cc0 wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz
        cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa cc0 cr wcel cc0 cc0
        cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn
        cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa
        cG cC cn cc0 csn cxp cc0 cc0 cr wcel cc0 cc0 cle wbr wa cn cc wph cG cn
        cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa cG wph cG
        cn cc0 csn cxp cif wceq cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vz
        cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz
        cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn cc wph cG cn cc0 csn cxp
        cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa wa wph cG wph cG cn cc0
        csn cxp cif wceq cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC
        vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn
        cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC cr wcel cc0 cC
        cle wbr wa cG wph cG cn cc0 csn cxp cif wceq cn cc cG wf cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv
        cF cfv cmul co cle wbr wi vz cn wral cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn
        wral cn cc cG wph cG cn cc0 csn cxp cif feq1 cG wph cG cn cc0 csn cxp
        cif wceq cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cC vz cv cF cfv cmul co cle wbr wi vz cn cG wph cG cn cc0 csn cxp
        cif wceq vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr
        cB vz cv clt wbr cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv cabs
        cfv vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul
        co cle cG wph cG cn cc0 csn cxp cif wceq vz cv cG cfv vz cv wph cG cn
        cc0 csn cxp cif cfv cabs vz cv cG wph cG cn cc0 csn cxp cif fveq1
        fveq2d breq1d imbi2d ralbidv anbi12d anbi2d wph cC cr wcel cc0 cC cle
        wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF
        cfv cmul co cle wbr wi vx cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn
        cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co
        cle wbr wi vz cn wral wa wa cvgcmp3cetlem1.6 cn cc cG wf cB vx cv clt
        wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral
        wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cC cr wcel cc0 cC cle wbr wa cB vx cv
        clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn
        wral cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle
        wbr wi vz cn wral cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC
        vx cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz cv cG cfv cabs cfv
        cC vz cv cF cfv cmul co cle wbr wi vx vz cn vx cv vz cv wceq cB vx cv
        clt wbr cB vz cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co
        cle wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vx cv vz
        cv cB clt breq2 vx cv vz cv wceq vx cv cG cfv cabs cfv vz cv cG cfv
        cabs cfv cC vx cv cF cfv cmul co cC vz cv cF cfv cmul co cle vx cv vz
        cv wceq vx cv cG cfv vz cv cG cfv cabs vx cv vz cv cG fveq2 fveq2d vx
        cv vz cv wceq vx cv cF cfv vz cv cF cfv cC cmul vx cv vz cv cF fveq2
        opreq2d breq12d imbi12d cbvralv anbi2i anbi2i bitri syl5bb cC wph cC
        cc0 cif wceq cC cr wcel cc0 cC cle wbr wa wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cC wph cC cc0 cif
        wceq cC cr wcel wph cC cc0 cif cr wcel cc0 cC cle wbr cc0 wph cC cc0
        cif cle wbr cC wph cC cc0 cif cr eleq1 cC wph cC cc0 cif cc0 cle breq2
        anbi12d cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn cc0 csn
        cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG cn cc0 csn
        cxp cif wf cC wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn cc0
        csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr wi vz cn cC wph cC cc0 cif wceq vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cC vz cv cF cfv cmul co cle wbr vz cv
        wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz cv cF cfv cmul
        co cle wbr cB vz cv clt wbr cC wph cC cc0 cif wceq cC vz cv cF cfv cmul
        co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cle cC wph cC cc0 cif vz cv cF cfv cmul opreq1 breq2d
        imbi2d ralbidv anbi2d anbi12d cn cc0 csn cxp wph cG cn cc0 csn cxp cif
        wceq cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc wph cG
        cn cc0 csn cxp cif wf cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0 cr
        wcel cc0 cc0 cle wbr wa cn cc0 csn cxp wph cG cn cc0 csn cxp cif wceq
        cn cc cn cc0 csn cxp wf cn cc wph cG cn cc0 csn cxp cif wf cB vz cv clt
        wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr
        wi vz cn wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs
        cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc cn cc0 csn cxp
        wph cG cn cc0 csn cxp cif feq1 cn cc0 csn cxp wph cG cn cc0 csn cxp cif
        wceq cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF
        cfv cmul co cle wbr wi cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif
        cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn cn cc0 csn cxp
        wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz
        cv cF cfv cmul co cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv
        cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr cn cc0 csn cxp wph cG
        cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv cabs cfv vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle cn cc0 csn
        cxp wph cG cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv vz cv wph
        cG cn cc0 csn cxp cif cfv cabs vz cv cn cc0 csn cxp wph cG cn cc0 csn
        cxp cif fveq1 fveq2d breq1d imbi2d ralbidv anbi12d anbi2d cc0 wph cC
        cc0 cif wceq cc0 cr wcel cc0 cc0 cle wbr wa wph cC cc0 cif cr wcel cc0
        wph cC cc0 cif cle wbr wa cn cc wph cG cn cc0 csn cxp cif wf cB vz cv
        clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle wbr wi vz cn wral wa cn cc wph cG cn cc0 csn cxp cif wf cB
        vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0
        cif vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0 wph cC cc0 cif
        wceq cc0 cr wcel wph cC cc0 cif cr wcel cc0 cc0 cle wbr cc0 wph cC cc0
        cif cle wbr cc0 wph cC cc0 cif cr eleq1 cc0 wph cC cc0 cif cc0 cle
        breq2 anbi12d cc0 wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph cG cn
        cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn
        wral cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph
        cC cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc wph cG cn
        cc0 csn cxp cif wf cc0 wph cC cc0 cif wceq cB vz cv clt wbr vz cv wph
        cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi
        cB vz cv clt wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC
        cc0 cif vz cv cF cfv cmul co cle wbr wi vz cn cc0 wph cC cc0 cif wceq
        vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv cc0 vz cv cF cfv cmul co
        cle wbr vz cv wph cG cn cc0 csn cxp cif cfv cabs cfv wph cC cc0 cif vz
        cv cF cfv cmul co cle wbr cB vz cv clt wbr cc0 wph cC cc0 cif wceq cc0
        vz cv cF cfv cmul co wph cC cc0 cif vz cv cF cfv cmul co vz cv wph cG
        cn cc0 csn cxp cif cfv cabs cfv cle cc0 wph cC cc0 cif vz cv cF cfv
        cmul opreq1 breq2d imbi2d ralbidv anbi2d anbi12d cc0 cr wcel cc0 cc0
        cle wbr wa cn cc cn cc0 csn cxp wf cB vz cv clt wbr vz cv cn cc0 csn
        cxp cfv cabs cfv cc0 vz cv cF cfv cmul co cle wbr wi vz cn wral wa cc0
        cr wcel cc0 cc0 cle wbr 0re cc0 0re leidi pm3.2i cn cc cn cc0 csn cxp
        wf cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv cF cfv
        cmul co cle wbr wi vz cn wral cn cc0 csn cn cc0 csn cxp wf cc0 csn cc
        wss cn cc cn cc0 csn cxp wf cn cc0 cc0 cc 0cn elisseti fconst cc0 cc
        wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp cn cc0 csn cc cn cc0 csn cxp
        fss mp2an cB vz cv clt wbr vz cv cn cc0 csn cxp cfv cabs cfv cc0 vz cv
        cF cfv cmul co cle wbr wi vz cn vz cv cn wcel vz cv cn cc0 csn cxp cfv
        cabs cfv cc0 vz cv cF cfv cmul co cle wbr cB vz cv clt wbr vz cv cn
        wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cc0 vz cv cF cfv cmul co cle
        vz cv cn wcel vz cv cn cc0 csn cxp cfv cabs cfv cc0 cabs cfv cc0 vz cv
        cn wcel vz cv cn cc0 csn cxp cfv cc0 cabs cn cc0 vz cv cc0 cc 0cn
        elisseti fvconst2 fveq2d abs0 syl6eq vz cv cn wcel cc0 cc0 vz cv cF cfv
        cmul co cc0 cle vz cv cn wcel vz cv cF cfv cc wcel cc0 vz cv cF cfv
        cmul co cc0 wceq vz cv cn wcel vz cv cF cfv cn cr vz cv cF cvgcmp3ce.3
        ffvelrni recnd vz cv cF cfv mul02 syl cc0 0re leidi syl5breqr eqbrtrd
        a1d rgen pm3.2i pm3.2i elimhyp2v pm3.27i pm3.27i rspec imp cvgcmp3cei
        dedth $.
        $( [21-Jun-2006] $) $( [24-Apr-2005] $)
    $}

  $}

  ${
    $d x y z B $.  $d x y z F $.  $d x y z G $.  $d x y z C $.  $d ph y z $.
    cvgcmp3cetlem2.1 $e |- A e. _V $.
    cvgcmp3cetlem2.2 $e |- B e. NN $.
    cvgcmp3cetlem2.3 $e |- ( ph <-> ( ( F : NN --> RR /\
  A. x e. NN 0 <_ ( F ` x ) ) /\ ( + seq1 F ) ~~> A ) ) $.
    $( Lemma for ~ cvgcmp3ce . $)
    cvgcmp3cetlem2 $p |- ( ( ph /\ ( ( C e. RR /\ 0 <_ C ) /\
               ( G : NN --> CC /\ A. x e. NN ( B < x -> ( abs ` ( G ` x ) ) <_
                  ( C x. ( F ` x ) ) ) ) ) ) -> E. y ( + seq1 G ) ~~> y ) $=
      wph cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG
      cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa caddc cG
      cseq1 co vy cv cli wbr vy wex wph cC cr wcel cc0 cC cle wbr wa cn cc cG
      wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr
      wi vz cn wral wa wa caddc cG cseq1 co vy cv cli wbr vy wex cC cr wcel cc0
      cC cle wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv
      cF cfv cmul co cle wbr wi vx cn wral wa wa wph cC cr wcel cc0 cC cle wbr
      wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
      cmul co cle wbr wi vz cn wral wa wa caddc cG cseq1 co vy cv cli wbr vy
      wex wi cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vz cv clt wbr vz cv cG
      cfv cabs cfv cC vz cv wph cF cn cc0 csn cxp cif cfv cmul co cle wbr wi vz
      cn wral wa wa caddc cG cseq1 co vy cv cli wbr vy wex wi cF cn cc0 csn cxp
      cF wph cF cn cc0 csn cxp cif wceq cC cr wcel cc0 cC cle wbr wa cn cc cG
      wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr
      wi vz cn wral wa wa cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vz cv clt
      wbr vz cv cG cfv cabs cfv cC vz cv wph cF cn cc0 csn cxp cif cfv cmul co
      cle wbr wi vz cn wral wa wa caddc cG cseq1 co vy cv cli wbr vy wex cF wph
      cF cn cc0 csn cxp cif wceq cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs
      cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral wa cn cc cG wf cB vz cv
      clt wbr vz cv cG cfv cabs cfv cC vz cv wph cF cn cc0 csn cxp cif cfv cmul
      co cle wbr wi vz cn wral wa cC cr wcel cc0 cC cle wbr wa cF wph cF cn cc0
      csn cxp cif wceq cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
      cmul co cle wbr wi vz cn wral cB vz cv clt wbr vz cv cG cfv cabs cfv cC
      vz cv wph cF cn cc0 csn cxp cif cfv cmul co cle wbr wi vz cn wral cn cc
      cG wf cF wph cF cn cc0 csn cxp cif wceq cB vz cv clt wbr vz cv cG cfv
      cabs cfv cC vz cv cF cfv cmul co cle wbr wi cB vz cv clt wbr vz cv cG cfv
      cabs cfv cC vz cv wph cF cn cc0 csn cxp cif cfv cmul co cle wbr wi vz cn
      cF wph cF cn cc0 csn cxp cif wceq vz cv cG cfv cabs cfv cC vz cv cF cfv
      cmul co cle wbr vz cv cG cfv cabs cfv cC vz cv wph cF cn cc0 csn cxp cif
      cfv cmul co cle wbr cB vz cv clt wbr cF wph cF cn cc0 csn cxp cif wceq cC
      vz cv cF cfv cmul co cC vz cv wph cF cn cc0 csn cxp cif cfv cmul co vz cv
      cG cfv cabs cfv cle cF wph cF cn cc0 csn cxp cif wceq vz cv cF cfv vz cv
      wph cF cn cc0 csn cxp cif cfv cC cmul vz cv cF wph cF cn cc0 csn cxp cif
      fveq1 opreq2d breq2d imbi2d ralbidv anbi2d anbi2d imbi1d cC cr wcel cc0
      cC cle wbr wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv
      wph cF cn cc0 csn cxp cif cfv cmul co cle wbr wi vz cn wral wa wa vz vy
      wph cA cc0 cif cB cC wph cF cn cc0 csn cxp cif cG wph cA cc0
      cvgcmp3cetlem2.1 cc0 cr 0re elisseti ifex cvgcmp3cetlem2.2 cn cr wph cF
      cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz
      cn wral cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn
      cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn cc0 csn cxp cif cseq1
      co wph cA cc0 cif cli wbr wph cn cr wph cF cn cc0 csn cxp cif wf cc0 vz
      cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn
      cc0 csn cxp cif cseq1 co cA cli wbr wa cn cr wph cF cn cc0 csn cxp cif wf
      cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph
      cF cn cc0 csn cxp cif cseq1 co wph cA cc0 cif cli wbr wa cn cr cn cc0 csn
      cxp wf cc0 vz cv cn cc0 csn cxp cfv cle wbr vz cn wral wa caddc cn cc0
      csn cxp cseq1 co cc0 cli wbr wa cF cA cn cc0 csn cxp cc0 cn cr wph cF cn
      cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn
      wral wa caddc wph cF cn cc0 csn cxp cif cseq1 co cc0 cli wbr wa cF wph cF
      cn cc0 csn cxp cif wceq cn cr cF wf cc0 vz cv cF cfv cle wbr vz cn wral
      wa caddc cF cseq1 co cA cli wbr wa cn cr wph cF cn cc0 csn cxp cif wf cc0
      vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn
      cc0 csn cxp cif cseq1 co cA cli wbr wa wph cF wph cF cn cc0 csn cxp cif
      wceq cn cr cF wf cc0 vz cv cF cfv cle wbr vz cn wral wa cn cr wph cF cn
      cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn
      wral wa caddc cF cseq1 co cA cli wbr caddc wph cF cn cc0 csn cxp cif
      cseq1 co cA cli wbr cF wph cF cn cc0 csn cxp cif wceq cn cr cF wf cn cr
      wph cF cn cc0 csn cxp cif wf cc0 vz cv cF cfv cle wbr vz cn wral cc0 vz
      cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral cn cr cF wph cF cn
      cc0 csn cxp cif feq1 cF wph cF cn cc0 csn cxp cif wceq cc0 vz cv cF cfv
      cle wbr cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn cF wph cF
      cn cc0 csn cxp cif wceq vz cv cF cfv vz cv wph cF cn cc0 csn cxp cif cfv
      cc0 cle vz cv cF wph cF cn cc0 csn cxp cif fveq1 breq2d ralbidv anbi12d
      cF wph cF cn cc0 csn cxp cif wceq caddc cF cseq1 co caddc wph cF cn cc0
      csn cxp cif cseq1 co cA cli cF wph cF cn cc0 csn cxp cif caddc cseq1
      opreq2 breq1d anbi12d wph cn cr cF wf cc0 vx cv cF cfv cle wbr vx cn wral
      wa caddc cF cseq1 co cA cli wbr wa cn cr cF wf cc0 vz cv cF cfv cle wbr
      vz cn wral wa caddc cF cseq1 co cA cli wbr wa cvgcmp3cetlem2.3 cn cr cF
      wf cc0 vx cv cF cfv cle wbr vx cn wral wa cn cr cF wf cc0 vz cv cF cfv
      cle wbr vz cn wral wa caddc cF cseq1 co cA cli wbr cc0 vx cv cF cfv cle
      wbr vx cn wral cc0 vz cv cF cfv cle wbr vz cn wral cn cr cF wf cc0 vx cv
      cF cfv cle wbr cc0 vz cv cF cfv cle wbr vx vz cn vx cv vz cv wceq vx cv
      cF cfv vz cv cF cfv cc0 cle vx cv vz cv cF fveq2 breq2d cbvralv anbi2i
      anbi1i bitri syl5bb cA wph cA cc0 cif wceq caddc wph cF cn cc0 csn cxp
      cif cseq1 co cA cli wbr caddc wph cF cn cc0 csn cxp cif cseq1 co wph cA
      cc0 cif cli wbr cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn
      cc0 csn cxp cif cfv cle wbr vz cn wral wa cA wph cA cc0 cif caddc wph cF
      cn cc0 csn cxp cif cseq1 co cli breq2 anbi2d cn cc0 csn cxp wph cF cn cc0
      csn cxp cif wceq cn cr cn cc0 csn cxp wf cc0 vz cv cn cc0 csn cxp cfv cle
      wbr vz cn wral wa cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn
      cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc cn cc0 csn cxp cseq1 co
      cc0 cli wbr caddc wph cF cn cc0 csn cxp cif cseq1 co cc0 cli wbr cn cc0
      csn cxp wph cF cn cc0 csn cxp cif wceq cn cr cn cc0 csn cxp wf cn cr wph
      cF cn cc0 csn cxp cif wf cc0 vz cv cn cc0 csn cxp cfv cle wbr vz cn wral
      cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral cn cr cn cc0
      csn cxp wph cF cn cc0 csn cxp cif feq1 cn cc0 csn cxp wph cF cn cc0 csn
      cxp cif wceq cc0 vz cv cn cc0 csn cxp cfv cle wbr cc0 vz cv wph cF cn cc0
      csn cxp cif cfv cle wbr vz cn cn cc0 csn cxp wph cF cn cc0 csn cxp cif
      wceq vz cv cn cc0 csn cxp cfv vz cv wph cF cn cc0 csn cxp cif cfv cc0 cle
      vz cv cn cc0 csn cxp wph cF cn cc0 csn cxp cif fveq1 breq2d ralbidv
      anbi12d cn cc0 csn cxp wph cF cn cc0 csn cxp cif wceq caddc cn cc0 csn
      cxp cseq1 co caddc wph cF cn cc0 csn cxp cif cseq1 co cc0 cli cn cc0 csn
      cxp wph cF cn cc0 csn cxp cif caddc cseq1 opreq2 breq1d anbi12d cc0 wph
      cA cc0 cif wceq caddc wph cF cn cc0 csn cxp cif cseq1 co cc0 cli wbr
      caddc wph cF cn cc0 csn cxp cif cseq1 co wph cA cc0 cif cli wbr cn cr wph
      cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr
      vz cn wral wa cc0 wph cA cc0 cif caddc wph cF cn cc0 csn cxp cif cseq1 co
      cli breq2 anbi2d cn cr cn cc0 csn cxp wf cc0 vz cv cn cc0 csn cxp cfv cle
      wbr vz cn wral wa caddc cn cc0 csn cxp cseq1 co cc0 cli wbr cn cr cn cc0
      csn cxp wf cc0 vz cv cn cc0 csn cxp cfv cle wbr vz cn wral cn cc0 csn cn
      cc0 csn cxp wf cc0 csn cr wss cn cr cn cc0 csn cxp wf cn cc0 cc0 cr 0re
      elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp cn cc0
      csn cr cn cc0 csn cxp fss mp2an cc0 vz cv cn cc0 csn cxp cfv cle wbr vz
      cn vz cv cn wcel cc0 vz cv cn cc0 csn cxp cfv cc0 cle cn cc0 vz cv cc0 cr
      0re elisseti fvconst2 cc0 0re leidi syl5breqr rgen pm3.2i ser1clim0
      pm3.2i elimhyp2v pm3.26i pm3.26i cc0 vz cv wph cF cn cc0 csn cxp cif cfv
      cle wbr vz cn cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0
      csn cxp cif cfv cle wbr vz cn wral cn cr wph cF cn cc0 csn cxp cif wf cc0
      vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn
      cc0 csn cxp cif cseq1 co wph cA cc0 cif cli wbr wph cn cr wph cF cn cc0
      csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral
      wa caddc wph cF cn cc0 csn cxp cif cseq1 co cA cli wbr wa cn cr wph cF cn
      cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn
      wral wa caddc wph cF cn cc0 csn cxp cif cseq1 co wph cA cc0 cif cli wbr
      wa cn cr cn cc0 csn cxp wf cc0 vz cv cn cc0 csn cxp cfv cle wbr vz cn
      wral wa caddc cn cc0 csn cxp cseq1 co cc0 cli wbr wa cF cA cn cc0 csn cxp
      cc0 cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp
      cif cfv cle wbr vz cn wral wa caddc wph cF cn cc0 csn cxp cif cseq1 co
      cc0 cli wbr wa cF wph cF cn cc0 csn cxp cif wceq cn cr cF wf cc0 vz cv cF
      cfv cle wbr vz cn wral wa caddc cF cseq1 co cA cli wbr wa cn cr wph cF cn
      cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn
      wral wa caddc wph cF cn cc0 csn cxp cif cseq1 co cA cli wbr wa wph cF wph
      cF cn cc0 csn cxp cif wceq cn cr cF wf cc0 vz cv cF cfv cle wbr vz cn
      wral wa cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn
      cxp cif cfv cle wbr vz cn wral wa caddc cF cseq1 co cA cli wbr caddc wph
      cF cn cc0 csn cxp cif cseq1 co cA cli wbr cF wph cF cn cc0 csn cxp cif
      wceq cn cr cF wf cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv cF cfv cle
      wbr vz cn wral cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral
      cn cr cF wph cF cn cc0 csn cxp cif feq1 cF wph cF cn cc0 csn cxp cif wceq
      cc0 vz cv cF cfv cle wbr cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr
      vz cn cF wph cF cn cc0 csn cxp cif wceq vz cv cF cfv vz cv wph cF cn cc0
      csn cxp cif cfv cc0 cle vz cv cF wph cF cn cc0 csn cxp cif fveq1 breq2d
      ralbidv anbi12d cF wph cF cn cc0 csn cxp cif wceq caddc cF cseq1 co caddc
      wph cF cn cc0 csn cxp cif cseq1 co cA cli cF wph cF cn cc0 csn cxp cif
      caddc cseq1 opreq2 breq1d anbi12d wph cn cr cF wf cc0 vx cv cF cfv cle
      wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa cn cr cF wf cc0 vz cv
      cF cfv cle wbr vz cn wral wa caddc cF cseq1 co cA cli wbr wa
      cvgcmp3cetlem2.3 cn cr cF wf cc0 vx cv cF cfv cle wbr vx cn wral wa cn cr
      cF wf cc0 vz cv cF cfv cle wbr vz cn wral wa caddc cF cseq1 co cA cli wbr
      cc0 vx cv cF cfv cle wbr vx cn wral cc0 vz cv cF cfv cle wbr vz cn wral
      cn cr cF wf cc0 vx cv cF cfv cle wbr cc0 vz cv cF cfv cle wbr vx vz cn vx
      cv vz cv wceq vx cv cF cfv vz cv cF cfv cc0 cle vx cv vz cv cF fveq2
      breq2d cbvralv anbi2i anbi1i bitri syl5bb cA wph cA cc0 cif wceq caddc
      wph cF cn cc0 csn cxp cif cseq1 co cA cli wbr caddc wph cF cn cc0 csn cxp
      cif cseq1 co wph cA cc0 cif cli wbr cn cr wph cF cn cc0 csn cxp cif wf
      cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa cA wph cA
      cc0 cif caddc wph cF cn cc0 csn cxp cif cseq1 co cli breq2 anbi2d cn cc0
      csn cxp wph cF cn cc0 csn cxp cif wceq cn cr cn cc0 csn cxp wf cc0 vz cv
      cn cc0 csn cxp cfv cle wbr vz cn wral wa cn cr wph cF cn cc0 csn cxp cif
      wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc cn
      cc0 csn cxp cseq1 co cc0 cli wbr caddc wph cF cn cc0 csn cxp cif cseq1 co
      cc0 cli wbr cn cc0 csn cxp wph cF cn cc0 csn cxp cif wceq cn cr cn cc0
      csn cxp wf cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv cn cc0 csn cxp
      cfv cle wbr vz cn wral cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz
      cn wral cn cr cn cc0 csn cxp wph cF cn cc0 csn cxp cif feq1 cn cc0 csn
      cxp wph cF cn cc0 csn cxp cif wceq cc0 vz cv cn cc0 csn cxp cfv cle wbr
      cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn cn cc0 csn cxp wph
      cF cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv vz cv wph cF cn cc0
      csn cxp cif cfv cc0 cle vz cv cn cc0 csn cxp wph cF cn cc0 csn cxp cif
      fveq1 breq2d ralbidv anbi12d cn cc0 csn cxp wph cF cn cc0 csn cxp cif
      wceq caddc cn cc0 csn cxp cseq1 co caddc wph cF cn cc0 csn cxp cif cseq1
      co cc0 cli cn cc0 csn cxp wph cF cn cc0 csn cxp cif caddc cseq1 opreq2
      breq1d anbi12d cc0 wph cA cc0 cif wceq caddc wph cF cn cc0 csn cxp cif
      cseq1 co cc0 cli wbr caddc wph cF cn cc0 csn cxp cif cseq1 co wph cA cc0
      cif cli wbr cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0
      csn cxp cif cfv cle wbr vz cn wral wa cc0 wph cA cc0 cif caddc wph cF cn
      cc0 csn cxp cif cseq1 co cli breq2 anbi2d cn cr cn cc0 csn cxp wf cc0 vz
      cv cn cc0 csn cxp cfv cle wbr vz cn wral wa caddc cn cc0 csn cxp cseq1 co
      cc0 cli wbr cn cr cn cc0 csn cxp wf cc0 vz cv cn cc0 csn cxp cfv cle wbr
      vz cn wral cn cc0 csn cn cc0 csn cxp wf cc0 csn cr wss cn cr cn cc0 csn
      cxp wf cn cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0 csn cr wss 0re
      cc0 cr snssi ax-mp cn cc0 csn cr cn cc0 csn cxp fss mp2an cc0 vz cv cn
      cc0 csn cxp cfv cle wbr vz cn vz cv cn wcel cc0 vz cv cn cc0 csn cxp cfv
      cc0 cle cn cc0 vz cv cc0 cr 0re elisseti fvconst2 cc0 0re leidi syl5breqr
      rgen pm3.2i ser1clim0 pm3.2i elimhyp2v pm3.26i pm3.27i rspec cn cr wph cF
      cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz
      cn wral wa caddc wph cF cn cc0 csn cxp cif cseq1 co wph cA cc0 cif cli
      wbr wph cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn
      cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn cc0 csn cxp cif cseq1
      co cA cli wbr wa cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn
      cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn cc0 csn cxp cif
      cseq1 co wph cA cc0 cif cli wbr wa cn cr cn cc0 csn cxp wf cc0 vz cv cn
      cc0 csn cxp cfv cle wbr vz cn wral wa caddc cn cc0 csn cxp cseq1 co cc0
      cli wbr wa cF cA cn cc0 csn cxp cc0 cn cr wph cF cn cc0 csn cxp cif wf
      cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph
      cF cn cc0 csn cxp cif cseq1 co cc0 cli wbr wa cF wph cF cn cc0 csn cxp
      cif wceq cn cr cF wf cc0 vz cv cF cfv cle wbr vz cn wral wa caddc cF
      cseq1 co cA cli wbr wa cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph
      cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa caddc wph cF cn cc0 csn
      cxp cif cseq1 co cA cli wbr wa wph cF wph cF cn cc0 csn cxp cif wceq cn
      cr cF wf cc0 vz cv cF cfv cle wbr vz cn wral wa cn cr wph cF cn cc0 csn
      cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa
      caddc cF cseq1 co cA cli wbr caddc wph cF cn cc0 csn cxp cif cseq1 co cA
      cli wbr cF wph cF cn cc0 csn cxp cif wceq cn cr cF wf cn cr wph cF cn cc0
      csn cxp cif wf cc0 vz cv cF cfv cle wbr vz cn wral cc0 vz cv wph cF cn
      cc0 csn cxp cif cfv cle wbr vz cn wral cn cr cF wph cF cn cc0 csn cxp cif
      feq1 cF wph cF cn cc0 csn cxp cif wceq cc0 vz cv cF cfv cle wbr cc0 vz cv
      wph cF cn cc0 csn cxp cif cfv cle wbr vz cn cF wph cF cn cc0 csn cxp cif
      wceq vz cv cF cfv vz cv wph cF cn cc0 csn cxp cif cfv cc0 cle vz cv cF
      wph cF cn cc0 csn cxp cif fveq1 breq2d ralbidv anbi12d cF wph cF cn cc0
      csn cxp cif wceq caddc cF cseq1 co caddc wph cF cn cc0 csn cxp cif cseq1
      co cA cli cF wph cF cn cc0 csn cxp cif caddc cseq1 opreq2 breq1d anbi12d
      wph cn cr cF wf cc0 vx cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co
      cA cli wbr wa cn cr cF wf cc0 vz cv cF cfv cle wbr vz cn wral wa caddc cF
      cseq1 co cA cli wbr wa cvgcmp3cetlem2.3 cn cr cF wf cc0 vx cv cF cfv cle
      wbr vx cn wral wa cn cr cF wf cc0 vz cv cF cfv cle wbr vz cn wral wa
      caddc cF cseq1 co cA cli wbr cc0 vx cv cF cfv cle wbr vx cn wral cc0 vz
      cv cF cfv cle wbr vz cn wral cn cr cF wf cc0 vx cv cF cfv cle wbr cc0 vz
      cv cF cfv cle wbr vx vz cn vx cv vz cv wceq vx cv cF cfv vz cv cF cfv cc0
      cle vx cv vz cv cF fveq2 breq2d cbvralv anbi2i anbi1i bitri syl5bb cA wph
      cA cc0 cif wceq caddc wph cF cn cc0 csn cxp cif cseq1 co cA cli wbr caddc
      wph cF cn cc0 csn cxp cif cseq1 co wph cA cc0 cif cli wbr cn cr wph cF cn
      cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn
      wral wa cA wph cA cc0 cif caddc wph cF cn cc0 csn cxp cif cseq1 co cli
      breq2 anbi2d cn cc0 csn cxp wph cF cn cc0 csn cxp cif wceq cn cr cn cc0
      csn cxp wf cc0 vz cv cn cc0 csn cxp cfv cle wbr vz cn wral wa cn cr wph
      cF cn cc0 csn cxp cif wf cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr
      vz cn wral wa caddc cn cc0 csn cxp cseq1 co cc0 cli wbr caddc wph cF cn
      cc0 csn cxp cif cseq1 co cc0 cli wbr cn cc0 csn cxp wph cF cn cc0 csn cxp
      cif wceq cn cr cn cc0 csn cxp wf cn cr wph cF cn cc0 csn cxp cif wf cc0
      vz cv cn cc0 csn cxp cfv cle wbr vz cn wral cc0 vz cv wph cF cn cc0 csn
      cxp cif cfv cle wbr vz cn wral cn cr cn cc0 csn cxp wph cF cn cc0 csn cxp
      cif feq1 cn cc0 csn cxp wph cF cn cc0 csn cxp cif wceq cc0 vz cv cn cc0
      csn cxp cfv cle wbr cc0 vz cv wph cF cn cc0 csn cxp cif cfv cle wbr vz cn
      cn cc0 csn cxp wph cF cn cc0 csn cxp cif wceq vz cv cn cc0 csn cxp cfv vz
      cv wph cF cn cc0 csn cxp cif cfv cc0 cle vz cv cn cc0 csn cxp wph cF cn
      cc0 csn cxp cif fveq1 breq2d ralbidv anbi12d cn cc0 csn cxp wph cF cn cc0
      csn cxp cif wceq caddc cn cc0 csn cxp cseq1 co caddc wph cF cn cc0 csn
      cxp cif cseq1 co cc0 cli cn cc0 csn cxp wph cF cn cc0 csn cxp cif caddc
      cseq1 opreq2 breq1d anbi12d cc0 wph cA cc0 cif wceq caddc wph cF cn cc0
      csn cxp cif cseq1 co cc0 cli wbr caddc wph cF cn cc0 csn cxp cif cseq1 co
      wph cA cc0 cif cli wbr cn cr wph cF cn cc0 csn cxp cif wf cc0 vz cv wph
      cF cn cc0 csn cxp cif cfv cle wbr vz cn wral wa cc0 wph cA cc0 cif caddc
      wph cF cn cc0 csn cxp cif cseq1 co cli breq2 anbi2d cn cr cn cc0 csn cxp
      wf cc0 vz cv cn cc0 csn cxp cfv cle wbr vz cn wral wa caddc cn cc0 csn
      cxp cseq1 co cc0 cli wbr cn cr cn cc0 csn cxp wf cc0 vz cv cn cc0 csn cxp
      cfv cle wbr vz cn wral cn cc0 csn cn cc0 csn cxp wf cc0 csn cr wss cn cr
      cn cc0 csn cxp wf cn cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0 csn
      cr wss 0re cc0 cr snssi ax-mp cn cc0 csn cr cn cc0 csn cxp fss mp2an cc0
      vz cv cn cc0 csn cxp cfv cle wbr vz cn vz cv cn wcel cc0 vz cv cn cc0 csn
      cxp cfv cc0 cle cn cc0 vz cv cc0 cr 0re elisseti fvconst2 cc0 0re leidi
      syl5breqr rgen pm3.2i ser1clim0 pm3.2i elimhyp2v pm3.27i cC cr wcel cc0
      cC cle wbr wa cn cc cG wf cB vz cv clt wbr vz cv cG cfv cabs cfv cC vz cv
      wph cF cn cc0 csn cxp cif cfv cmul co cle wbr wi vz cn wral wa wa biid
      cvgcmp3cetlem1 dedth cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv
      cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa cn cc cG wf cB vz cv clt
      wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral
      wa cC cr wcel cc0 cC cle wbr wa cB vx cv clt wbr vx cv cG cfv cabs cfv cC
      vx cv cF cfv cmul co cle wbr wi vx cn wral cB vz cv clt wbr vz cv cG cfv
      cabs cfv cC vz cv cF cfv cmul co cle wbr wi vz cn wral cn cc cG wf cB vx
      cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi cB vz
      cv clt wbr vz cv cG cfv cabs cfv cC vz cv cF cfv cmul co cle wbr wi vx vz
      cn vx cv vz cv wceq cB vx cv clt wbr cB vz cv clt wbr vx cv cG cfv cabs
      cfv cC vx cv cF cfv cmul co cle wbr vz cv cG cfv cabs cfv cC vz cv cF cfv
      cmul co cle wbr vx cv vz cv cB clt breq2 vx cv vz cv wceq vx cv cG cfv
      cabs cfv vz cv cG cfv cabs cfv cC vx cv cF cfv cmul co cC vz cv cF cfv
      cmul co cle vx cv vz cv wceq vx cv cG cfv vz cv cG cfv cabs vx cv vz cv
      cG fveq2 fveq2d vx cv vz cv wceq vx cv cF cfv vz cv cF cfv cC cmul vx cv
      vz cv cF fveq2 opreq2d breq12d imbi12d cbvralv anbi2i anbi2i syl5ib imp
      $.
      $( [21-Jun-2006] $) $( [25-Apr-2005] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d x y F $.  $d x y G $.  $d x y C $.
    cvgcmp3cet.6 $e |- A e. _V $.
    $( A comparison test for convergence of a complex infinite series.  Closed
       theorem form of ~ cvgcmp3cei . $)
    cvgcmp3ce $p |- ( ( B e. NN /\ ( ( ( F : NN --> RR /\ A. x e. NN
      0 <_ ( F ` x ) ) /\ ( + seq1 F ) ~~> A ) /\ ( ( C e. RR /\ 0 <_ C ) /\
                ( G : NN --> CC /\ A. x e. NN ( B < x -> ( abs ` ( G ` x ) ) <_
                ( C x. ( F ` x ) ) ) ) ) ) ) -> E. y ( + seq1 G ) ~~> y ) $=
      cB cn wcel cn cr cF wf cc0 vx cv cF cfv cle wbr vx cn wral wa caddc cF
      cseq1 co cA cli wbr wa cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vx cv
      clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn
      wral wa wa wa caddc cG cseq1 co vy cv cli wbr vy wex cB cn wcel cn cr cF
      wf cc0 vx cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa
      cC cr wcel cc0 cC cle wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv
      cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa wa caddc cG
      cseq1 co vy cv cli wbr vy wex wi cn cr cF wf cc0 vx cv cF cfv cle wbr vx
      cn wral wa caddc cF cseq1 co cA cli wbr wa cC cr wcel cc0 cC cle wbr wa
      cn cc cG wf cB cn wcel cB c1 cif vx cv clt wbr vx cv cG cfv cabs cfv cC
      vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa wa caddc cG cseq1 co vy
      cv cli wbr vy wex wi cB c1 cB cB cn wcel cB c1 cif wceq cn cr cF wf cc0
      vx cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa cC cr
      wcel cc0 cC cle wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv
      cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa wa cn cr cF wf cc0 vx
      cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa cC cr
      wcel cc0 cC cle wbr wa cn cc cG wf cB cn wcel cB c1 cif vx cv clt wbr vx
      cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa wa
      caddc cG cseq1 co vy cv cli wbr vy wex cB cB cn wcel cB c1 cif wceq cC cr
      wcel cc0 cC cle wbr wa cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv
      cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa cC cr wcel cc0 cC cle
      wbr wa cn cc cG wf cB cn wcel cB c1 cif vx cv clt wbr vx cv cG cfv cabs
      cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa wa cn cr cF wf cc0
      vx cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa cB cB
      cn wcel cB c1 cif wceq cn cc cG wf cB vx cv clt wbr vx cv cG cfv cabs cfv
      cC vx cv cF cfv cmul co cle wbr wi vx cn wral wa cn cc cG wf cB cn wcel
      cB c1 cif vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle
      wbr wi vx cn wral wa cC cr wcel cc0 cC cle wbr wa cB cB cn wcel cB c1 cif
      wceq cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF cfv cmul co cle
      wbr wi vx cn wral cB cn wcel cB c1 cif vx cv clt wbr vx cv cG cfv cabs
      cfv cC vx cv cF cfv cmul co cle wbr wi vx cn wral cn cc cG wf cB cB cn
      wcel cB c1 cif wceq cB vx cv clt wbr vx cv cG cfv cabs cfv cC vx cv cF
      cfv cmul co cle wbr wi cB cn wcel cB c1 cif vx cv clt wbr vx cv cG cfv
      cabs cfv cC vx cv cF cfv cmul co cle wbr wi vx cn cB cB cn wcel cB c1 cif
      wceq cB vx cv clt wbr cB cn wcel cB c1 cif vx cv clt wbr vx cv cG cfv
      cabs cfv cC vx cv cF cfv cmul co cle wbr cB cB cn wcel cB c1 cif vx cv
      clt breq1 imbi1d ralbidv anbi2d anbi2d anbi2d imbi1d cn cr cF wf cc0 vx
      cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa vx vy cA
      cB cn wcel cB c1 cif cC cF cG cvgcmp3cet.6 cB c1 cn 1nn elimel cn cr cF
      wf cc0 vx cv cF cfv cle wbr vx cn wral wa caddc cF cseq1 co cA cli wbr wa
      biid cvgcmp3cetlem2 dedth imp $.
      $( [22-Jun-2006] $) $( [25-Apr-2005] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Infinite sums (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d m n x y A $.  $d m n x y M $.  $d m n x y k $.
    $( Series sum with an infinite index set (i.e. an infinite series). $)
    dfisum $p |- ( M e. ZZ -> sum_ k e. ( ZZ>= ` M ) A =
       U. { x |
    ( <. M , + >. seq ( { <. k , y >. | y = A } |` ZZ ) ) ~~> x } ) $=
      cM cz wcel cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop
      vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vx cab cM cuz cfv vm cv cuz cfv wceq vm cv caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni
      cun cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv cli wbr
      vx cab cuni cM cuz cfv cA vk csu cM cz wcel cM cuz cfv vm cv vn cv cfz co
      wceq vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cab cM cuz cfv vm cv cuz
      cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv
      cli wbr wa vm cz wrex vx cab cuni cun c0 cM caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz co vx cv cli wbr vx cab cuni cun cM caddc cop vy cv
      cA wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cab cuni cM cz wcel
      cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab c0 cM cuz cfv vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq
      vk vy copab cz cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cuni cM
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cab
      cuni cM cz wcel cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm cv
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex vx wex wn cM cuz cfv vm cv vn cv cfz co wceq vx cv vn
      cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa
      vn vm cv cuz cfv wrex vm wex vx cab c0 wceq cM cz wcel cM cuz cfv vm cv
      vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab
      cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cM cz wcel
      cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm cM
      cz wcel cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc cop vy
      cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv cM
      cz wcel vn cv vm cv cuz cfv wcel wa cM cuz cfv vm cv vn cv cfz co wceq vx
      cv vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv
      wcel vn cv vm cv cuz cfv wcel cM cz wcel cM cuz cfv vm cv vn cv cfz co
      wceq wn vn cv vm cv cuz cfv wcel cM cz wcel wa vm cv vn cv cfz co cM cuz
      cfv wceq wn cM cuz cfv vm cv vn cv cfz co wceq wn cM vm cv vn cv fzneuz
      vm cv vn cv cfz co cM cuz cfv wceq cM cuz cfv vm cv vn cv cfz co wceq vm
      cv vn cv cfz co cM cuz cfv eqcom notbii sylib ancoms intnanrd nrexdv
      nexdv nexdv cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm cv caddc
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm wex vx wex cM cuz cfv vm cv vn cv cfz co wceq vx cv vn cv vm
      cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm
      cv cuz cfv wrex vm wex vx cab c0 cM cuz cfv vm cv vn cv cfz co wceq vx cv
      vn cv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel
      wa vn vm cv cuz cfv wrex vm wex vx abn0 necon1bbii sylib cM cz wcel cM
      cuz cfv vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr wa vm cz wrex vx cab cM caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cab cM cz wcel cM cuz
      cfv vm cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co vx cv cli wbr wa vm cz wrex cM caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz co vx cv cli wbr vx cM cz wcel cM cuz cfv vm cv cuz
      cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv
      cli wbr wa vm cz wrex vm cv cM wceq vm cv caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz co vx cv cli wbr wa vm cz wrex cM caddc cop vy cv cA
      wceq vk vy copab cz cres cseqz co vx cv cli wbr cM cz wcel cM cuz cfv vm
      cv cuz cfv wceq vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz
      co vx cv cli wbr wa vm cv cM wceq vm cv caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz co vx cv cli wbr wa vm cz cM cz wcel cM cuz cfv vm cv
      cuz cfv wceq vm cv cM wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co vx cv cli wbr cM cz wcel cM cuz cfv vm cv cuz cfv wceq cM
      vm cv wceq vm cv cM wceq cM vm cv uz11 cM vm cv eqcom syl6bb anbi1d
      rexbidv vm cv caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv
      cli wbr cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv cli
      wbr vm cM cz vm cv cM wceq vm cv caddc cop vy cv cA wceq vk vy copab cz
      cres cseqz co cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx
      cv cli vm cv cM wceq vm cv caddc cop cM caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz vm cv cM caddc opeq1 opreq1d breq1d ceqsrexv bitrd
      abbidv unieqd uneq12d c0 cM caddc cop vy cv cA wceq vk vy copab cz cres
      cseqz co vx cv cli wbr vx cab cuni cun cM caddc cop vy cv cA wceq vk vy
      copab cz cres cseqz co vx cv cli wbr vx cab cuni c0 cun cM caddc cop vy
      cv cA wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cab cuni c0 cM
      caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cab
      cuni uncom cM caddc cop vy cv cA wceq vk vy copab cz cres cseqz co vx cv
      cli wbr vx cab cuni un0 eqtri syl6eq vx vy cM cuz cfv cA vk vm vn df-sum
      syl5eq $.
      $( [25-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d k x y F $.  $d x y M $.
    isumvalt.1 $e |- F e. _V $.
    $( The value of the sum of a series ` F ` from ` M ` to infinity is the
      unique (by ~ climuni ) value it converges to (if it converges).  The sum
      evaluates to the empty set when it doesn't converge, but this shouldn't
      be depended on to indicate non-convergence (because it would presuppose a
      construction-dependent property of complex numbers, i.e. that no complex
      number equals the empty set, which, although by ~ 0ncn is true for our
      specific construction, is not specified by their axioms and may fail for
      some other construction).  Instead, use
      ` -. E. x e. CC ( <. M , + >. seq F ) ~~> x ` to indicate
      non-convergence. $)
    isumval $p |- ( M e. ZZ ->
            sum_ k e. ( ZZ>= ` M ) ( F ` k ) =
                   U. { x | ( <. M , + >. seq F ) ~~> x } ) $=
      cM cz wcel cM cuz cfv vk cv cF cfv vk csu cM caddc cop vy cv vk cv cF cfv
      wceq vk vy copab cz cres cseqz co vx cv cli wbr vx cab cuni cM caddc cop
      cF cseqz co vx cv cli wbr vx cab cuni vx vy vk cv cF cfv vk cM dfisum cM
      cz wcel cM caddc cop vy cv vk cv cF cfv wceq vk vy copab cz cres cseqz co
      vx cv cli wbr vx cab cM caddc cop cF cseqz co vx cv cli wbr vx cab cM cz
      wcel cM caddc cop vy cv vk cv cF cfv wceq vk vy copab cz cres cseqz co vx
      cv cli wbr cM caddc cop cF cseqz co vx cv cli wbr vx cM cz wcel cM caddc
      cop vy cv vk cv cF cfv wceq vk vy copab cz cres cseqz co cM caddc cop cF
      cseqz co vx cv cli vy caddc vk cF cM addex isumvalt.1 seqzres2 breq1d
      abbidv unieqd eqtrd $.
      $( [28-Dec-2005] $) $( [11-Dec-2005] $)
  $}

  ${
    $d j x y z F $.  $d x z M $.  $d j k y z $.
    isumvaltf.1 $e |- F e. _V $.
    isumvaltf.2 $e |- ( y e. F -> A. k y e. F ) $.
    $( Version of ~ isumval with a bound-variable hypothesis instead of a
       distinct variable condition. $)
    isumvaltfi $p |- ( M e. ZZ ->
            sum_ k e. ( ZZ>= ` M ) ( F ` k ) =
                   U. { x | ( <. M , + >. seq F ) ~~> x } ) $=
      cM cz wcel cM cuz cfv vj cv cF cfv vj csu cM caddc cop cF cseqz co vx cv
      cli wbr vx cab cuni cM cuz cfv vk cv cF cfv vk csu vx vj cF cM
      isumvaltf.1 isumval vz cM cuz cfv vk cv cF cfv vj cv cF cfv vk vj vz cv
      vk cv cF cfv wcel vj ax-17 vk vz vj cv cF vk vy vz cF isumvaltf.2 hblem
      vz cv vj cv wcel vk ax-17 hbfv vk cv vj cv cF fveq2 cbvsumi syl5eq $.
      $( [12-May-2006] $) $( [13-Dec-2005] $)
  $}

  ${
    $d y A $.  $d x z F $.  $d k x y z M $.
    isumval2t.1 $e |- A e. _V $.
    isumval2t.2 $e |- F = { <. k , y >. | ( k e. ( ZZ>= ` M ) /\ y = A ) } $.
    $( Sum of ` A ( k ) ` from ` M ` to infinity. $)
    isumval2 $p |- ( M e. ZZ ->
            sum_ k e. ( ZZ>= ` M ) A =
                   U. { x | ( <. M , + >. seq F ) ~~> x } ) $=
      cM cz wcel cM cuz cfv vk cv cF cfv vk csu cM caddc cop cF cseqz co vx cv
      cli wbr vx cab cuni cM cuz cfv cA vk csu vx vz vk cF cM vk vy cM cuz cfv
      cA cF cM cuz fvex isumval2t.2 fopabex2 vk vz cF vk cv cM cuz cfv wcel vy
      cv cA wceq wa vk vy copab isumval2t.2 vk cv cM cuz cfv wcel vy cv cA wceq
      wa vk vy vz hbopab1 hbxfr isumvaltfi cM cuz cfv vk cv cF cfv cA vk vk cv
      cM cuz cfv wcel vk cv vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy copab
      cfv cA vk cv cF cfv vk cv cM cuz cfv wcel cA cvv wcel vk cv vk cv cM cuz
      cfv wcel vy cv cA wceq wa vk vy copab cfv cA wceq isumval2t.1 vk vy cM
      cuz cfv cA cvv fvopab2 mpan2 vk cv cF vk cv cM cuz cfv wcel vy cv cA wceq
      wa vk vy copab isumval2t.2 fveq1i syl5eq sumeq2i syl5eqr $.
      $( [31-Mar-2008] $) $( [2-Jan-2006] $)
  $}

  ${
    $d x A $.  $d x y F $.  $d x M $.  $d k y $.
    isumclimtf.1 $e |- ( y e. F -> A. k y e. F ) $.
    isumclimtf.2 $e |- F e. _V $.
    isumclimtf.3 $e |- A e. _V $.
    $( Version of ~ isumclim with a bound-variable hypothesis instead of a
       distinct variable condition. $)
    isumclimtfi $p |- ( ( M e. ZZ /\ ( <. M , + >. seq F ) ~~> A ) ->
                   sum_ k e. ( ZZ>= ` M ) ( F ` k ) = A ) $=
      cM cz wcel cM caddc cop cF cseqz co cA cli wbr cM cuz cfv vk cv cF cfv vk
      csu cM caddc cop cF cseqz co vx cv cli wbr vx cvv crab cuni cA cM cz wcel
      cM cuz cfv vk cv cF cfv vk csu cM caddc cop cF cseqz co vx cv cli wbr vx
      cab cuni cM caddc cop cF cseqz co vx cv cli wbr vx cvv crab cuni vx vy vk
      cF cM isumclimtf.2 isumclimtf.1 isumvaltfi cM caddc cop cF cseqz co vx cv
      cli wbr vx cvv crab cM caddc cop cF cseqz co vx cv cli wbr vx cab cM
      caddc cop cF cseqz co vx cv cli wbr vx rabab unieqi syl6eqr cM caddc cop
      cF cseqz co cA cli wbr cM caddc cop cF cseqz co vx cv cli wbr vx cvv crab
      cuni cA wceq cA cvv wcel cM caddc cop cF cseqz co vx cv cli wbr vx cvv
      wreu cM caddc cop cF cseqz co cA cli wbr cM caddc cop cF cseqz co vx cv
      cli wbr vx cvv crab cuni cA wceq wb cM caddc cop cF cseqz co cA cli wbr
      cM caddc cop cF cseqz co vx cv cli wbr cM caddc cop cF cseqz co cA cli
      wbr vx cvv cA vx cv cA cM caddc cop cF cseqz co cli breq2 reuuni2
      isumclimtf.3 cM caddc cop cF cseqz co cA cli wbr cM caddc cop cF cseqz co
      vx cv cli wbr vx weu cM caddc cop cF cseqz co vx cv cli wbr vx cvv wreu
      vx cA cM caddc cop cF cseqz co isumclimtf.3 climeu cM caddc cop cF cseqz
      co vx cv cli wbr vx cvv wreu vx cv cvv wcel cM caddc cop cF cseqz co vx
      cv cli wbr wa vx weu cM caddc cop cF cseqz co vx cv cli wbr vx weu cM
      caddc cop cF cseqz co vx cv cli wbr vx cvv df-reu cM caddc cop cF cseqz
      co vx cv cli wbr vx cv cvv wcel cM caddc cop cF cseqz co vx cv cli wbr wa
      vx vx cv cvv wcel cM caddc cop cF cseqz co vx cv cli wbr vx visset
      biantrur eubii bitr4i sylibr sylancr ibi sylan9eq $.
      $( [12-May-2006] $) $( [10-May-2006] $)
  $}

  ${
    $d x k F $.
    isumclimt.1 $e |- F e. _V $.
    isumclimt.2 $e |- A e. _V $.
    $( An infinite sum equals the value its series converges to. $)
    isumclim $p |- ( ( M e. ZZ /\ ( <. M , + >. seq F ) ~~> A ) ->
                   sum_ k e. ( ZZ>= ` M ) ( F ` k ) = A ) $=
      vx cA vk cF cM vx cv cF wcel vk ax-17 isumclimt.1 isumclimt.2 isumclimtfi
      $.
      $( [10-Jan-2006] $) $( [25-Dec-2005] $)

    $( An infinite sum equals the value its series converges to. $)
    isum1clim $p |- ( ( + seq1 F ) ~~> A -> sum_ k e. NN ( F ` k ) = A ) $=
      caddc cF cseq1 co cA cli wbr c1 cuz cfv vk cv cF cfv vk csu cA cn vk cv
      cF cfv vk csu caddc cF cseq1 co cA cli wbr c1 caddc cop cF cseqz co cA
      cli wbr c1 cuz cfv vk cv cF cfv vk csu cA wceq caddc cF cseq1 co c1 caddc
      cop cF cseqz co cA cli caddc cF addex isumclimt.1 seq1seqz breq1i c1 cz
      wcel c1 caddc cop cF cseqz co cA cli wbr c1 cuz cfv vk cv cF cfv vk csu
      cA wceq 1z cA vk cF c1 isumclimt.1 isumclimt.2 isumclim mpan sylbi cn c1
      cuz cfv vk cv cF cfv vk nnuz sumeq1i syl5eq $.
      $( [5-Aug-2008] $) $( [10-Jul-2008] $)
  $}

  ${
    $d x y F $.  $d x M $.  $d k x y $.
    isumclim2tf.1 $e |- ( y e. F -> A. k y e. F ) $.
    isumclim2tf.2 $e |- F e. _V $.
    $( Version of ~ isumclim2 with a bound-variable hypothesis instead of a
       distinct variable condition. $)
    isumclim2f $p |- ( ( M e. ZZ /\ E. x ( <. M , + >. seq F ) ~~> x ) ->
              ( <. M , + >. seq F ) ~~> sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $=
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cF
      cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM cz wcel cM caddc cop
      cF cseqz co vx cv cli wbr cM caddc cop cF cseqz co cM cuz cfv vk cv cF
      cfv vk csu cli wbr vx cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr
      cM caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM cz
      wcel cM caddc cop cF cseqz co vx cv cli wbr wa cM caddc cop cF cseqz co
      vx cv cM cuz cfv vk cv cF cfv vk csu cli cM cz wcel cM caddc cop cF cseqz
      co vx cv cli wbr pm3.27 vy vx cv vk cF cM isumclim2tf.1 isumclim2tf.2 vx
      visset isumclimtfi breqtrrd ex 19.23adv imp $.
      $( [17-Feb-2006] $) $( [9-Jan-2006] $)
  $}

  ${
    $d k x y F $.  $d x M $.
    isumclim2t.1 $e |- F e. _V $.
    $( A converging series converges to its infinite sum. $)
    isumclim2 $p |- ( ( M e. ZZ /\ E. x ( <. M , + >. seq F ) ~~> x ) ->
              ( <. M , + >. seq F ) ~~> sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $=
      vx vy vk cF cM vy cv cF wcel vk ax-17 isumclim2t.1 isumclim2f $.
      $( [10-Jan-2006] $) $( [2-Jan-2006] $)
  $}

  ${
    $d x y z A $.  $d k x y z M $.  $d z F $.
    isumclim3t.1 $e |- A e. _V $.
    isumclim3t.2 $e |- F = { <. k , y >. | ( k e. ( ZZ>= ` M ) /\ y = A ) } $.
    $( A converging series converges to its infinite sum. $)
    isumclim3 $p |- ( ( M e. ZZ /\ E. x ( <. M , + >. seq F ) ~~> x ) ->
                     ( <. M , + >. seq F ) ~~> sum_ k e. ( ZZ>= ` M ) A ) $=
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM caddc cop
      vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy copab cseqz co cM cuz cfv cA
      vk csu cM caddc cop cF cseqz co cli cM cz wcel cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cM caddc cop vk cv cM cuz cfv wcel vy cv cA wceq
      wa vk vy copab cseqz co cM cuz cfv vk cv vk cv cM cuz cfv wcel vy cv cA
      wceq wa vk vy copab cfv vk csu cM cuz cfv cA vk csu cli cM cz wcel cM
      caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop vk cv cM cuz cfv
      wcel vy cv cA wceq wa vk vy copab cseqz co vx cv cli wbr vx wex cM caddc
      cop vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy copab cseqz co cM cuz
      cfv vk cv vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy copab cfv vk csu
      cli wbr cM cz wcel cM caddc cop vk cv cM cuz cfv wcel vy cv cA wceq wa vk
      vy copab cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co vx cv cli
      wbr vx wex cM cz wcel cM caddc cop vk cv cM cuz cfv wcel vy cv cA wceq wa
      vk vy copab cseqz co vx cv cli wbr cM caddc cop cF cseqz co vx cv cli wbr
      vx cM cz wcel cM caddc cop vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy
      copab cseqz co cM caddc cop cF cseqz co vx cv cli cM cz wcel cM caddc cop
      cF cseqz co cM caddc cop vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy
      copab cseqz co cM caddc cop cF cseqz co cM caddc cop vk cv cM cuz cfv
      wcel vy cv cA wceq wa vk vy copab cseqz co wceq cM cz wcel cF vk cv cM
      cuz cfv wcel vy cv cA wceq wa vk vy copab cM caddc cop cseqz isumclim3t.2
      opreq2i a1i eqcomd breq1d exbidv biimpar vx vz vk vk cv cM cuz cfv wcel
      vy cv cA wceq wa vk vy copab cM vk cv cM cuz cfv wcel vy cv cA wceq wa vk
      vy vz hbopab1 vk vy cM cuz cfv cA cM cuz fvex opabex2 isumclim2f syldan
      cM cuz cfv vk cv vk cv cM cuz cfv wcel vy cv cA wceq wa vk vy copab cfv
      cA vk vk cv cM cuz cfv wcel cA cvv wcel vk cv vk cv cM cuz cfv wcel vy cv
      cA wceq wa vk vy copab cfv cA wceq isumclim3t.1 vk vy cM cuz cfv cA cvv
      fvopab2 mpan2 sumeq2i syl6breq cF vk cv cM cuz cfv wcel vy cv cA wceq wa
      vk vy copab cM caddc cop cseqz isumclim3t.2 opreq2i syl5eqbr $.
      $( [17-Feb-2006] $) $( [9-Jan-2006] $)

    ${
      isumclim4t.3 $e |- B e. _V $.
      $( An infinite sum equals the value its series converges to. $)
      isumclim4 $p |- ( ( M e. ZZ /\ ( <. M , + >. seq F ) ~~> B ) ->
                     sum_ k e. ( ZZ>= ` M ) A = B ) $=
        cM cz wcel cM caddc cop cF cseqz co cB cli wbr wa cM cuz cfv vk cv cF
        cfv vk csu cB cM cuz cfv cA vk csu vz cB vk cF cM vk vz cF vk cv cM cuz
        cfv wcel vy cv cA wceq wa vk vy copab isumclim3t.2 vk cv cM cuz cfv
        wcel vy cv cA wceq wa vk vy vz hbopab1 hbxfr vk vy cM cuz cfv cA cF cM
        cuz fvex isumclim3t.2 fopabex2 isumclim4t.3 isumclimtfi cM cuz cfv cM
        cuz cfv wss cM cuz cfv vk cv cF cfv vk csu cM cuz cfv cA vk csu wceq cM
        cuz cfv ssid vy cA cM cuz cfv cM cuz cfv vk cF isumclim3t.1
        isumclim3t.2 sumeqfv ax-mp syl5eqr $.
        $( [9-Jun-2006] $) $( [10-May-2006] $)
    $}
  $}

  ${
    $d j x y z A $.  $d j k x y z M $.
    isumclim5t.1 $e |- A e. _V $.
    isumclim5t.2 $e |- F = { <. j , y >. | ( j e. ( ZZ>= ` M ) /\ y =
                      sum_ k e. ( M ... j ) A ) } $.
    $( The sequence of partial finite sums of a converging infinite series
       converge to the infinite sum of the series.  Note that ` j ` must not
       occur in ` A ` . $)
    isumclim5 $p |- ( ( M e. ZZ /\ E. x F ~~> x ) ->
                     F ~~> sum_ k e. ( ZZ>= ` M ) A ) $=
      cM cz wcel cF vx cv cli wbr vx wex wa cM caddc cop vk cv cM cuz cfv wcel
      vz cv cA wceq wa vk vz copab cseqz co cF cM cuz cfv cA vk csu cli cM cz
      wcel cM caddc cop vk cv cM cuz cfv wcel vz cv cA wceq wa vk vz copab
      cseqz co cF wceq cF vx cv cli wbr vx wex vz vy cA vk vj vk cv cM cuz cfv
      wcel vz cv cA wceq wa vk vz copab cF cM isumclim5t.1 vk cv cM cuz cfv
      wcel vz cv cA wceq wa vk vz copab eqid isumclim5t.2 serzfsum adantr cM cz
      wcel cF vx cv cli wbr vx wex cM caddc cop vk cv cM cuz cfv wcel vz cv cA
      wceq wa vk vz copab cseqz co vx cv cli wbr vx wex cM caddc cop vk cv cM
      cuz cfv wcel vz cv cA wceq wa vk vz copab cseqz co cM cuz cfv cA vk csu
      cli wbr cM cz wcel cM caddc cop vk cv cM cuz cfv wcel vz cv cA wceq wa vk
      vz copab cseqz co vx cv cli wbr vx wex cF vx cv cli wbr vx wex cM cz wcel
      cM caddc cop vk cv cM cuz cfv wcel vz cv cA wceq wa vk vz copab cseqz co
      vx cv cli wbr cF vx cv cli wbr vx cM cz wcel cM caddc cop vk cv cM cuz
      cfv wcel vz cv cA wceq wa vk vz copab cseqz co cF vx cv cli vz vy cA vk
      vj vk cv cM cuz cfv wcel vz cv cA wceq wa vk vz copab cF cM isumclim5t.1
      vk cv cM cuz cfv wcel vz cv cA wceq wa vk vz copab eqid isumclim5t.2
      serzfsum breq1d exbidv biimpar vx vz cA vk vk cv cM cuz cfv wcel vz cv cA
      wceq wa vk vz copab cM isumclim5t.1 vk cv cM cuz cfv wcel vz cv cA wceq
      wa vk vz copab eqid isumclim3 syldan eqbrtrrd $.
      $( [17-Feb-2006] $) $( [9-Jan-2006] $)
  $}

  ${
    $d F k x $.  $d M x $.
    isumnul.1 $e |- F e. _V $.
    $( The sum of a non-convergent infinite series evaluates to the empty set.
       (Contributed by Paul Chapman, 04-Nov-2007.) $)
    isumnul $p |- ( ( M e. ZZ /\ -. E. x ( <. M , + >. seq F ) ~~> x ) ->
                  sum_ k e. ( ZZ>= ` M ) ( F ` k ) = (/) ) $=
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex wn wa cM cuz cfv
      vk cv cF cfv vk csu cM caddc cop cF cseqz co vx cv cli wbr vx cab cuni c0
      cuni c0 cM cz wcel cM cuz cfv vk cv cF cfv vk csu cM caddc cop cF cseqz
      co vx cv cli wbr vx cab cuni wceq cM caddc cop cF cseqz co vx cv cli wbr
      vx wex wn vx vk cF cM isumnul.1 isumval adantr cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wn cM caddc cop cF cseqz co vx cv cli wbr vx cab
      cuni c0 cuni wceq cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx
      wex wn cM caddc cop cF cseqz co vx cv cli wbr vx cab c0 cM caddc cop cF
      cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co vx cv cli wbr vx
      cab c0 cM caddc cop cF cseqz co vx cv cli wbr vx cab c0 wne cM caddc cop
      cF cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co vx cv cli wbr
      vx abn0 biimpi necon1bi unieqd adantl c0 cuni c0 wceq cM cz wcel cM caddc
      cop cF cseqz co vx cv cli wbr vx wex wn wa uni0 a1i 3eqtrd $.
      $( [4-Nov-2007] $) $( [4-Nov-2007] $)
  $}

  ${
    $d F k x $.  $d K k x $.  $d M k x $.  $d N k x $.
    isumshft.1 $e |- F e. _V $.
    isumshft.2 $e |- K e. ZZ $.
    isumshft.3 $e |- M e. ZZ $.
    isumshft.4 $e |- N = ( M + K ) $.
    $( Index shift of an infinite sum.  (Contributed by Paul Chapman,
       31-Oct-2007.) $)
    isumshfti $p |- sum_ k e. ( ZZ>= ` M ) ( F ` k ) =
                      sum_ k e. ( ZZ>= ` N ) ( F ` ( k - K ) ) $=
      cM caddc cop cF cseqz co vx cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk
      csu cN cuz cfv vk cv cK cmin co cF cfv vk csu wceq cM caddc cop cF cseqz
      co vx cv cli wbr cM cuz cfv vk cv cF cfv vk csu cN cuz cfv vk cv cK cmin
      co cF cfv vk csu wceq vx cM caddc cop cF cseqz co vx cv cli wbr cM cuz
      cfv vk cv cF cfv vk csu vx cv cN cuz cfv vk cv cK cmin co cF cfv vk csu
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr cM cuz cfv vk cv cF cfv
      vk csu vx cv wceq isumshft.3 vx cv vk cF cM isumshft.1 vx visset isumclim
      mpan cM caddc cop cF cseqz co vx cv cli wbr cN cuz cfv vk cv cF cK cshi
      co cfv vk csu vx cv cN cuz cfv vk cv cK cmin co cF cfv vk csu cM caddc
      cop cF cseqz co vx cv cli wbr cN caddc cop cF cK cshi co cseqz co vx cv
      cli wbr cN cuz cfv vk cv cF cK cshi co cfv vk csu vx cv wceq vx cv cvv
      wcel cM caddc cop cF cseqz co vx cv cli wbr cN caddc cop cF cK cshi co
      cseqz co vx cv cli wbr wb vx visset vx cv cvv cF cF cK cshi co cK cM cN
      isumshft.1 isumshft.3 isumshft.2 isumshft.4 cF cK cshi co eqid iserzshfti
      ax-mp cN cz wcel cN caddc cop cF cK cshi co cseqz co vx cv cli wbr cN cuz
      cfv vk cv cF cK cshi co cfv vk csu vx cv wceq cN cM cK caddc co cz
      isumshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel isumshft.3
      isumshft.2 cM cK zaddcl mp2an eqeltri vx cv vk cF cK cshi co cN cF cK
      cshi oprex vx visset isumclim mpan sylbi cN cuz cfv vk cv cF cK cshi co
      cfv vk cv cK cmin co cF cfv vk cK cz wcel vk cv cc wcel vk cv cF cK cshi
      co cfv vk cv cK cmin co cF cfv wceq vk cv cN cuz cfv wcel cK vk cv cz cF
      isumshft.1 shftval isumshft.2 vk cv cN cuz cfv wcel vk cv cz wcel vk cv
      cc wcel cN vk cv eluzelz vk cv zcn syl sylancr sumeq2i syl5eqr eqtr4d
      19.23aiv cM caddc cop cF cseqz co vx cv cli wbr vx wex wn cM cuz cfv vk
      cv cF cfv vk csu cN cuz cfv vk cv cF cK cshi co cfv vk csu cN cuz cfv vk
      cv cK cmin co cF cfv vk csu cM caddc cop cF cseqz co vx cv cli wbr vx wex
      wn cM cuz cfv vk cv cF cfv vk csu c0 cN cuz cfv vk cv cF cK cshi co cfv
      vk csu cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex wn cM cuz
      cfv vk cv cF cfv vk csu c0 wceq isumshft.3 vx vk cF cM isumshft.1 isumnul
      mpan cM caddc cop cF cseqz co vx cv cli wbr vx wex wn cN caddc cop cF cK
      cshi co cseqz co vx cv cli wbr vx wex wn cN cuz cfv vk cv cF cK cshi co
      cfv vk csu c0 wceq cM caddc cop cF cseqz co vx cv cli wbr vx wex cN caddc
      cop cF cK cshi co cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co
      vx cv cli wbr cN caddc cop cF cK cshi co cseqz co vx cv cli wbr vx vx cv
      cvv wcel cM caddc cop cF cseqz co vx cv cli wbr cN caddc cop cF cK cshi
      co cseqz co vx cv cli wbr wb vx visset vx cv cvv cF cF cK cshi co cK cM
      cN isumshft.1 isumshft.3 isumshft.2 isumshft.4 cF cK cshi co eqid
      iserzshfti ax-mp exbii notbii cN cz wcel cN caddc cop cF cK cshi co cseqz
      co vx cv cli wbr vx wex wn cN cuz cfv vk cv cF cK cshi co cfv vk csu c0
      wceq cN cM cK caddc co cz isumshft.4 cM cz wcel cK cz wcel cM cK caddc co
      cz wcel isumshft.3 isumshft.2 cM cK zaddcl mp2an eqeltri vx vk cF cK cshi
      co cN cF cK cshi oprex isumnul mpan sylbi eqtr4d cN cuz cfv vk cv cF cK
      cshi co cfv vk cv cK cmin co cF cfv vk cK cz wcel vk cv cc wcel vk cv cF
      cK cshi co cfv vk cv cK cmin co cF cfv wceq vk cv cN cuz cfv wcel cK vk
      cv cz cF isumshft.1 shftval isumshft.2 vk cv cN cuz cfv wcel vk cv cz
      wcel vk cv cc wcel cN vk cv eluzelz vk cv zcn syl sylancr sumeq2i syl6eq
      pm2.61i $.
      $( [4-Nov-2007] $) $( [31-Oct-2007] $)

    $( Index shift of an infinite sum.  (Contributed by Paul Chapman,
       31-Oct-2007.) $)
    isumshft2i $p |- sum_ k e. ( ZZ>= ` N ) ( F ` k ) =
                       sum_ k e. ( ZZ>= ` M ) ( F ` ( K + k ) ) $=
      cN caddc cop cF cseqz co vx cv cli wbr vx wex cN cuz cfv vk cv cF cfv vk
      csu cM cuz cfv cK vk cv caddc co cF cfv vk csu wceq cN caddc cop cF cseqz
      co vx cv cli wbr cN cuz cfv vk cv cF cfv vk csu cM cuz cfv cK vk cv caddc
      co cF cfv vk csu wceq vx cN caddc cop cF cseqz co vx cv cli wbr cN cuz
      cfv vk cv cF cfv vk csu vx cv cM cuz cfv cK vk cv caddc co cF cfv vk csu
      cN cz wcel cN caddc cop cF cseqz co vx cv cli wbr cN cuz cfv vk cv cF cfv
      vk csu vx cv wceq cN cM cK caddc co cz isumshft.4 cM cz wcel cK cz wcel
      cM cK caddc co cz wcel isumshft.3 isumshft.2 cM cK zaddcl mp2an eqeltri
      vx cv vk cF cN isumshft.1 vx visset isumclim mpan cN caddc cop cF cseqz
      co vx cv cli wbr cM cuz cfv vk cv cF cK cneg cshi co cfv vk csu vx cv cM
      cuz cfv cK vk cv caddc co cF cfv vk csu cN caddc cop cF cseqz co vx cv
      cli wbr cM caddc cop cF cK cneg cshi co cseqz co vx cv cli wbr cM cuz cfv
      vk cv cF cK cneg cshi co cfv vk csu vx cv wceq vx cv cvv wcel cN caddc
      cop cF cseqz co vx cv cli wbr cM caddc cop cF cK cneg cshi co cseqz co vx
      cv cli wbr wb vx visset vx cv cvv cF cF cK cneg cshi co cK cneg cN cM
      isumshft.1 cN cM cK caddc co cz isumshft.4 cM cz wcel cK cz wcel cM cK
      caddc co cz wcel isumshft.3 isumshft.2 cM cK zaddcl mp2an eqeltri cK cz
      wcel cK cneg cz wcel isumshft.2 cK znegcl ax-mp cN cK cneg caddc co cN cK
      cmin co cM cN cK cN cz wcel cN cc wcel cN cM cK caddc co cz isumshft.4 cM
      cz wcel cK cz wcel cM cK caddc co cz wcel isumshft.3 isumshft.2 cM cK
      zaddcl mp2an eqeltri cN zcn ax-mp cK cz wcel cK cc wcel isumshft.2 cK zcn
      ax-mp negsubi cN cK cmin co cM wceq cM cK caddc co cN wceq cN cM cK caddc
      co isumshft.4 eqcomi cN cK cM cN cz wcel cN cc wcel cN cM cK caddc co cz
      isumshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel isumshft.3
      isumshft.2 cM cK zaddcl mp2an eqeltri cN zcn ax-mp cK cz wcel cK cc wcel
      isumshft.2 cK zcn ax-mp cM cz wcel cM cc wcel isumshft.3 cM zcn ax-mp
      subadd2i mpbir eqtr2i cF cK cneg cshi co eqid iserzshfti ax-mp cM cz wcel
      cM caddc cop cF cK cneg cshi co cseqz co vx cv cli wbr cM cuz cfv vk cv
      cF cK cneg cshi co cfv vk csu vx cv wceq isumshft.3 vx cv vk cF cK cneg
      cshi co cM cF cK cneg cshi oprex vx visset isumclim mpan sylbi cM cuz cfv
      vk cv cF cK cneg cshi co cfv cK vk cv caddc co cF cfv vk cK cc wcel vk cv
      cc wcel vk cv cF cK cneg cshi co cfv cK vk cv caddc co cF cfv wceq vk cv
      cM cuz cfv wcel cK vk cv cF isumshft.1 shftval4 cK cz wcel cK cc wcel
      isumshft.2 cK zcn ax-mp vk cv cM cuz cfv wcel vk cv cz wcel vk cv cc wcel
      cM vk cv eluzelz vk cv zcn syl sylancr sumeq2i syl5eqr eqtr4d 19.23aiv cN
      caddc cop cF cseqz co vx cv cli wbr vx wex wn cN cuz cfv vk cv cF cfv vk
      csu cM cuz cfv vk cv cF cK cneg cshi co cfv vk csu cM cuz cfv cK vk cv
      caddc co cF cfv vk csu cN caddc cop cF cseqz co vx cv cli wbr vx wex wn
      cN cuz cfv vk cv cF cfv vk csu c0 cM cuz cfv vk cv cF cK cneg cshi co cfv
      vk csu cN cz wcel cN caddc cop cF cseqz co vx cv cli wbr vx wex wn cN cuz
      cfv vk cv cF cfv vk csu c0 wceq cN cM cK caddc co cz isumshft.4 cM cz
      wcel cK cz wcel cM cK caddc co cz wcel isumshft.3 isumshft.2 cM cK zaddcl
      mp2an eqeltri vx vk cF cN isumshft.1 isumnul mpan cN caddc cop cF cseqz
      co vx cv cli wbr vx wex wn cM caddc cop cF cK cneg cshi co cseqz co vx cv
      cli wbr vx wex wn cM cuz cfv vk cv cF cK cneg cshi co cfv vk csu c0 wceq
      cN caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cF cK cneg
      cshi co cseqz co vx cv cli wbr vx wex cN caddc cop cF cseqz co vx cv cli
      wbr cM caddc cop cF cK cneg cshi co cseqz co vx cv cli wbr vx vx cv cvv
      wcel cN caddc cop cF cseqz co vx cv cli wbr cM caddc cop cF cK cneg cshi
      co cseqz co vx cv cli wbr wb vx visset vx cv cvv cF cF cK cneg cshi co cK
      cneg cN cM isumshft.1 cN cM cK caddc co cz isumshft.4 cM cz wcel cK cz
      wcel cM cK caddc co cz wcel isumshft.3 isumshft.2 cM cK zaddcl mp2an
      eqeltri cK cz wcel cK cneg cz wcel isumshft.2 cK znegcl ax-mp cN cK cneg
      caddc co cN cK cmin co cM cN cK cN cz wcel cN cc wcel cN cM cK caddc co
      cz isumshft.4 cM cz wcel cK cz wcel cM cK caddc co cz wcel isumshft.3
      isumshft.2 cM cK zaddcl mp2an eqeltri cN zcn ax-mp cK cz wcel cK cc wcel
      isumshft.2 cK zcn ax-mp negsubi cN cK cmin co cM wceq cM cK caddc co cN
      wceq cN cM cK caddc co isumshft.4 eqcomi cN cK cM cN cz wcel cN cc wcel
      cN cM cK caddc co cz isumshft.4 cM cz wcel cK cz wcel cM cK caddc co cz
      wcel isumshft.3 isumshft.2 cM cK zaddcl mp2an eqeltri cN zcn ax-mp cK cz
      wcel cK cc wcel isumshft.2 cK zcn ax-mp cM cz wcel cM cc wcel isumshft.3
      cM zcn ax-mp subadd2i mpbir eqtr2i cF cK cneg cshi co eqid iserzshfti
      ax-mp exbii notbii cM cz wcel cM caddc cop cF cK cneg cshi co cseqz co vx
      cv cli wbr vx wex wn cM cuz cfv vk cv cF cK cneg cshi co cfv vk csu c0
      wceq isumshft.3 vx vk cF cK cneg cshi co cM cF cK cneg cshi oprex isumnul
      mpan sylbi eqtr4d cM cuz cfv vk cv cF cK cneg cshi co cfv cK vk cv caddc
      co cF cfv vk cK cc wcel vk cv cc wcel vk cv cF cK cneg cshi co cfv cK vk
      cv caddc co cF cfv wceq vk cv cM cuz cfv wcel cK vk cv cF isumshft.1
      shftval4 cK cz wcel cK cc wcel isumshft.2 cK zcn ax-mp vk cv cM cuz cfv
      wcel vk cv cz wcel vk cv cc wcel cM vk cv eluzelz vk cv zcn syl sylancr
      sumeq2i syl6eq pm2.61i $.
      $( [4-Nov-2007] $) $( [31-Oct-2007] $)
  $}

  ${
    $d j k n x F $.  $d j k n x M $.
    isum1p.1 $e |- F e. _V $.
    $( The infinite sum of a converging infinite series equals the first term
       plus the infinite sum of the rest of it. $)
    isum1p $p |- ( ( M e. ZZ /\ A. k e. ( ZZ>= ` M ) ( F ` k ) e. CC /\
  E. x ( <. ( M + 1 ) , + >. seq F ) ~~> x ) -> sum_ k e. ( ZZ>= ` M )
   ( F ` k ) = ( ( F ` M ) + sum_ k e. ( ZZ>= ` ( M + 1 ) ) ( F ` k ) ) ) $=
      cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral cM c1 caddc co caddc
      cop cF cseqz co vx cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk csu cM cF
      cfv cM c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co wceq vk cv cF cfv
      cc wcel vk cM cuz cfv wral cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv
      wral cM c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cM cuz cfv
      vk cv cF cfv vk csu cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk csu
      caddc co wceq cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral wa cM c1
      caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cM c1 caddc co caddc
      cop cF cseqz co cM c1 caddc co cuz cfv vk cv cF cfv vk csu cli wbr cM cuz
      cfv vk cv cF cfv vk csu cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk
      csu caddc co wceq cM cz wcel cM c1 caddc co caddc cop cF cseqz co vx cv
      cli wbr vx wex cM c1 caddc co caddc cop cF cseqz co cM c1 caddc co cuz
      cfv vk cv cF cfv vk csu cli wbr vj cv cF cfv cc wcel vj cM cuz cfv wral
      cM c1 caddc co cz wcel cM c1 caddc co caddc cop cF cseqz co vx cv cli wbr
      vx wex cM c1 caddc co caddc cop cF cseqz co cM c1 caddc co cuz cfv vk cv
      cF cfv vk csu cli wbr cM cz wcel vx vk cF cM c1 caddc co isum1p.1
      isumclim2 cM peano2z sylan adantlr cM cz wcel cM caddc cop cF cseqz co cM
      cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co cli wbr cM cuz
      cfv vk cv cF cfv vk csu cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk
      csu caddc co wceq cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral wa
      cM c1 caddc co caddc cop cF cseqz co cM c1 caddc co cuz cfv vk cv cF cfv
      vk csu cli wbr wa cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk csu
      caddc co vk cF cM isum1p.1 cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv
      vk csu caddc oprex isumclim cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv
      wral cM c1 caddc co caddc cop cF cseqz co cM c1 caddc co cuz cfv vk cv cF
      cfv vk csu cli wbr simpll cM c1 caddc co caddc cop cF cseqz co cM c1
      caddc co cuz cfv vk cv cF cfv vk csu cli wbr cM cF cfv cc wcel cM c1
      caddc co cz wcel vn cv cM c1 caddc co caddc cop cF cseqz co cfv cc wcel
      vn cv cM caddc cop cF cseqz co cfv cM cF cfv vn cv cM c1 caddc co caddc
      cop cF cseqz co cfv caddc co wceq wa vn cM c1 caddc co cuz cfv wral cM
      caddc cop cF cseqz co cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk
      csu caddc co cli wbr cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral
      wa cM c1 caddc co caddc cop cF cseqz co cM c1 caddc co cuz cfv vk cv cF
      cfv vk csu cli wbr wa cM c1 caddc co cuz cfv vk cv cF cfv vk csu cM cF
      cfv vn cM c1 caddc co caddc cop cF cseqz co cM caddc cop cF cseqz co cM
      c1 caddc co cM c1 caddc co caddc cop cF cseqz oprex cM caddc cop cF cseqz
      oprex cM c1 caddc co cuz cfv vk cv cF cfv vk sumex cM cF fvex climaddc2
      cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral wa cM c1 caddc co
      caddc cop cF cseqz co cM c1 caddc co cuz cfv vk cv cF cfv vk csu cli wbr
      pm3.27 cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral wa cM cF cfv cc
      wcel cM c1 caddc co caddc cop cF cseqz co cM c1 caddc co cuz cfv vk cv cF
      cfv vk csu cli wbr cM cM cuz cfv wcel vj cv cF cfv cc wcel vj cM cuz cfv
      wral cM cF cfv cc wcel cM cz wcel vj cv cF cfv cc wcel cM cF cfv cc wcel
      vj cM cM cuz cfv vj cv cM wceq vj cv cF cfv cM cF cfv cc vj cv cM cF
      fveq2 eleq1d rcla4va cM uzid sylan adantr cM cz wcel cM c1 caddc co cz
      wcel vj cv cF cfv cc wcel vj cM cuz cfv wral cM c1 caddc co caddc cop cF
      cseqz co cM c1 caddc co cuz cfv vk cv cF cfv vk csu cli wbr cM peano2z
      ad2antrr cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral wa vn cv cM
      c1 caddc co caddc cop cF cseqz co cfv cc wcel vn cv cM caddc cop cF cseqz
      co cfv cM cF cfv vn cv cM c1 caddc co caddc cop cF cseqz co cfv caddc co
      wceq wa vn cM c1 caddc co cuz cfv wral cM c1 caddc co caddc cop cF cseqz
      co cM c1 caddc co cuz cfv vk cv cF cfv vk csu cli wbr cM cz wcel vj cv cF
      cfv cc wcel vj cM cuz cfv wral wa vn cv cM c1 caddc co caddc cop cF cseqz
      co cfv cc wcel vn cv cM caddc cop cF cseqz co cfv cM cF cfv vn cv cM c1
      caddc co caddc cop cF cseqz co cfv caddc co wceq wa vn cM c1 caddc co cuz
      cfv cM cz wcel vj cv cF cfv cc wcel vj cM cuz cfv wral wa vn cv cM c1
      caddc co cuz cfv wcel wa vn cv cM c1 caddc co caddc cop cF cseqz co cfv
      cc wcel vn cv cM caddc cop cF cseqz co cfv cM cF cfv vn cv cM c1 caddc co
      caddc cop cF cseqz co cfv caddc co wceq vn cv cM c1 caddc co cuz cfv wcel
      vj cv cF cfv cc wcel vj cM c1 caddc co vn cv cfz co wral vn cv cM c1
      caddc co caddc cop cF cseqz co cfv cc wcel cM cz wcel vj cv cF cfv cc
      wcel vj cM cuz cfv wral wa vn cv cM c1 caddc co cuz cfv wcel wa vj cF cM
      c1 caddc co vn cv isum1p.1 serzcl cM cz wcel vj cv cF cfv cc wcel vj cM
      cuz cfv wral wa vn cv cM c1 caddc co cuz cfv wcel pm3.27 cM cz wcel vj cv
      cF cfv cc wcel vj cM cuz cfv wral vn cv cM c1 caddc co cuz cfv wcel vj cv
      cF cfv cc wcel vj cM c1 caddc co vn cv cfz co wral cM cz wcel vj cv cF
      cfv cc wcel vj cM cuz cfv wral vj cv cF cfv cc wcel vj cM c1 caddc co vn
      cv cfz co wral vn cv cM c1 caddc co cuz cfv wcel cM cz wcel vj cv cF cfv
      cc wcel vj cv cF cfv cc wcel vj cM cuz cfv cM c1 caddc co vn cv cfz co cM
      cz wcel vj cv cM c1 caddc co vn cv cfz co wcel vj cv cM cuz cfv wcel vj
      cv cF cfv cc wcel cM cz wcel vj cv cM c1 caddc co cuz cfv wcel vj cv cM
      cuz cfv wcel vj cv cM c1 caddc co vn cv cfz co wcel cM cz wcel vj cv cM
      c1 caddc co cuz cfv wcel vj cv cM cuz cfv wcel cM vj cv peano2uzr ex vj
      cv cM c1 caddc co vn cv elfzuz syl5 imim1d r19.20dv2 a1dd imp31 sylanc cM
      cz wcel vj cv cF cfv cc wcel vj cM vn cv cfz co wral vn cv cM c1 caddc co
      cuz cfv wcel vn cv cM caddc cop cF cseqz co cfv cM cF cfv vn cv cM c1
      caddc co caddc cop cF cseqz co cfv caddc co wceq vj cv cF cfv cc wcel vj
      cM cuz cfv wral cM cz wcel vn cv cM c1 caddc co cuz cfv wcel vj cv cF cfv
      cc wcel vj cM vn cv cfz co wral vn cv cM caddc cop cF cseqz co cfv cM cF
      cfv vn cv cM c1 caddc co caddc cop cF cseqz co cfv caddc co wceq vn cv cM
      cuz cfv wcel cM vn cv clt wbr wa vj cv cF cfv cc wcel vj cM vn cv cfz co
      wral vn cv cM caddc cop cF cseqz co cfv cM cF cfv vn cv cM c1 caddc co
      caddc cop cF cseqz co cfv caddc co wceq cM cz wcel vn cv cM c1 caddc co
      cuz cfv wcel wa vn cv cM cuz cfv wcel cM vn cv clt wbr vj cv cF cfv cc
      wcel vj cM vn cv cfz co wral vn cv cM caddc cop cF cseqz co cfv cM cF cfv
      vn cv cM c1 caddc co caddc cop cF cseqz co cfv caddc co wceq vj cF cM vn
      cv isum1p.1 serz1p 3expa cM cz wcel vn cv cM c1 caddc co cuz cfv wcel wa
      vn cv cM cuz cfv wcel cM vn cv clt wbr cM vn cv peano2uzr cM vn cv
      eluzp1l jca sylan an1rs vj cv cF cfv cc wcel vj cv cF cfv cc wcel vj cM
      cuz cfv cM vn cv cfz co vj cv cM vn cv cfz co wcel vj cv cM cuz cfv wcel
      vj cv cF cfv cc wcel vj cv cM vn cv elfzuz imim1i r19.20i2 sylanl2 jca
      r19.21aiva adantr syl2anc sylanc syldan 3impa vk cv cF cfv cc wcel vj cv
      cF cfv cc wcel vk vj cM cuz cfv vk cv vj cv wceq vk cv cF cfv vj cv cF
      cfv cc vk cv vj cv cF fveq2 eleq1d cbvralv syl3an2b $.
      $( [10-Jan-2006] $) $( [2-Jan-2006] $)
  $}

  ${
    $d x k F $.
    isumnn0nn.1 $e |- F e. _V $.
    $( Sum from 0 to infinity in terms of sum from 1 to infinity. $)
    isumnn0nn $p |- ( ( A. k e. NN0 ( F ` k ) e. CC /\
  E. x ( + seq1 F ) ~~> x ) -> sum_ k e. NN0 ( F ` k )
                 = ( ( F ` 0 ) + sum_ k e. NN ( F ` k ) ) ) $=
      vk cv cF cfv cc wcel vk cn0 wral caddc cF cseq1 co vx cv cli wbr vx wex
      wa cc0 cuz cfv vk cv cF cfv vk csu cc0 cF cfv cc0 c1 caddc co cuz cfv vk
      cv cF cfv vk csu caddc co cn0 vk cv cF cfv vk csu cc0 cF cfv cn vk cv cF
      cfv vk csu caddc co vk cv cF cfv cc wcel vk cc0 cuz cfv wral cc0 c1 caddc
      co caddc cop cF cseqz co vx cv cli wbr vx wex cc0 cuz cfv vk cv cF cfv vk
      csu cc0 cF cfv cc0 c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co wceq
      vk cv cF cfv cc wcel vk cn0 wral caddc cF cseq1 co vx cv cli wbr vx wex
      cc0 cz wcel vk cv cF cfv cc wcel vk cc0 cuz cfv wral cc0 c1 caddc co
      caddc cop cF cseqz co vx cv cli wbr vx wex cc0 cuz cfv vk cv cF cfv vk
      csu cc0 cF cfv cc0 c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co wceq
      0z vx vk cF cc0 isumnn0nn.1 isum1p mp3an1 cn0 cc0 cuz cfv wceq vk cv cF
      cfv cc wcel vk cn0 wral vk cv cF cfv cc wcel vk cc0 cuz cfv wral wb nn0uz
      vk cv cF cfv cc wcel vk cn0 cc0 cuz cfv raleq1 ax-mp caddc cF cseq1 co vx
      cv cli wbr cc0 c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx caddc
      cF cseq1 co cc0 c1 caddc co caddc cop cF cseqz co vx cv cli caddc cF
      cseq1 co c1 caddc cop cF cseqz co cc0 c1 caddc co caddc cop cF cseqz co
      caddc cF addex isumnn0nn.1 seq1seqz cc0 c1 caddc co caddc cop c1 caddc
      cop cF cseqz cc0 c1 caddc co c1 caddc c1 ax1cn addid2i opeq1i opreq1i
      eqtr4i breq1i exbii syl2anb cn0 cc0 cuz cfv vk cv cF cfv vk nn0uz sumeq1i
      cn vk cv cF cfv vk csu cc0 c1 caddc co cuz cfv vk cv cF cfv vk csu cc0 cF
      cfv caddc cn cc0 c1 caddc co cuz cfv vk cv cF cfv vk cn c1 cuz cfv cc0 c1
      caddc co cuz cfv nnuz cc0 c1 caddc co c1 cuz c1 ax1cn addid2i fveq2i
      eqtr4i sumeq1i opreq2i 3eqtr4g $.
      $( [10-Jan-2006] $) $( [2-Jan-2006] $)
  $}

  ${
    $d z A $.  $d j x y F $.  $d j k y z $.
    isumnn0nna.1 $e |- A e. _V $.
    isumnn0nna.3 $e |- F e. _V $.
    isumnn0nna.4 $e |- ( y e. F -> A. k y e. F ) $.
    isumnn0nna.5 $e |- ( k e. NN0 -> ( F ` k ) = A ) $.
    $( Sum from 0 to infinity in terms of sum from 1 to infinity of a class
       term ` A ( k ) ` . $)
    isumnn0nnai $p |- ( ( A. k e. NN0 A e. CC /\ E. x ( + seq1 F ) ~~> x ) ->
                     sum_ k e. NN0 A = ( [_ 0 / k ]_ A + sum_ k e. NN A ) ) $=
      vj cv cF cfv cc wcel vj cn0 wral caddc cF cseq1 co vx cv cli wbr vx wex
      cn0 cA vk csu vk cc0 cA csb cn cA vk csu caddc co wceq cA cc wcel vk cn0
      wral vj cv cF cfv cc wcel vj cn0 wral caddc cF cseq1 co vx cv cli wbr vx
      wex wa cn0 vj cv cF cfv vj csu cc0 cF cfv cn vj cv cF cfv vj csu caddc co
      cn0 cA vk csu vk cc0 cA csb cn cA vk csu caddc co vx vj cF isumnn0nna.3
      isumnn0nn cn0 vk cv cF cfv vk csu cn0 cA vk csu cn0 vj cv cF cfv vj csu
      cn0 vk cv cF cfv cA vk isumnn0nna.5 sumeq2i vy cn0 vk cv cF cfv vj cv cF
      cfv vk vj vy cv vk cv cF cfv wcel vj ax-17 vk vy vj cv cF isumnn0nna.4 vy
      cv vj cv wcel vk ax-17 hbfv vk cv vj cv cF fveq2 cbvsumi eqtr3i cc0 cF
      cfv cn vj cv cF cfv vj csu caddc co vk cc0 cA csb cn cA vk csu caddc co
      cc0 cF cfv vk cc0 cA csb cn vj cv cF cfv vj csu cn cA vk csu caddc cc0
      cn0 wcel cc0 cF cfv vk cc0 cA csb wceq 0nn0 vk cv cF cfv cA wceq cc0 cF
      cfv vk cc0 cA csb wceq vk vz cc0 cn0 vz cv cc0 wcel vk ax-17 vk vy vz cc0
      cF cfv vk cc0 cA csb vk vy cc0 cF isumnn0nna.4 vy cv cc0 wcel vk ax-17
      hbfv vk vz cc0 cA cc0 cn0 0nn0 elisseti vz cv cc0 wcel vk ax-17 hbcsb1
      hbeq vk cv cc0 wceq vk cv cF cfv cc0 cF cfv cA vk cc0 cA csb vk cv cc0 cF
      fveq2 vk cc0 cA csbeq1a eqeq12d isumnn0nna.5 vtoclgaf ax-mp cn vj cv cF
      cfv vj csu cn vk cv cF cfv vk csu cn cA vk csu cn vk cv cF cfv vk csu cn
      vj cv cF cfv vj csu vy cn vk cv cF cfv vj cv cF cfv vk vj vy cv vk cv cF
      cfv wcel vj ax-17 vk vy vj cv cF isumnn0nna.4 vy cv vj cv wcel vk ax-17
      hbfv vk cv vj cv cF fveq2 cbvsumi eqcomi cn vk cv cF cfv cA vk vk cv cn
      wcel vk cv cn0 wcel vk cv cF cfv cA wceq vk cv nnnn0 isumnn0nna.5 syl
      sumeq2i eqtri opreq12i eqcomi 3eqtr4g cA cc wcel vk cn0 wral vk cv cF cfv
      cc wcel vk cn0 wral vj cv cF cfv cc wcel vj cn0 wral vk cv cF cfv cc wcel
      cA cc wcel vk cn0 vk cv cn0 wcel vk cv cF cfv cA cc isumnn0nna.5 eleq1d
      ralbiia vk cv cF cfv cc wcel vj cv cF cfv cc wcel vk vj cn0 vk cv cF cfv
      cc wcel vj ax-17 vk vy vz vj cv cF cfv cc vk vy vj cv cF isumnn0nna.4 vy
      cv vj cv wcel vk ax-17 hbfv vz cv cc wcel vk ax-17 hbel vk cv vj cv wceq
      vk cv cF cfv vj cv cF cfv cc vk cv vj cv cF fveq2 eleq1d cbvral bitr3i
      sylanb $.
      $( [9-Feb-2007] $) $( [2-Nov-2007] $)
  $}

$(
  @{
    @d x A @.  @d k x F @.  @d x N @.
    isumadd.1 @e |- F e. _V @.
    isumadd.2 @e |- G e. _V @.
    @( Infinite sum of the sum of two converging sequences. @)
    isumadd @p |- ( ( N e. ZZ /\ E. x ( <. N , + >. seq F ) ~~> x /\
                    E. y ( <. N , + >. seq G ) ~~> y ) ->
               sum_ k e. ( ZZ>= ` N ) ( ( F ` k ) + ( G ` k ) ) =
   ( sum_ k e. ( ZZ>= ` N ) ( F ` k ) + sum_ k e. ( ZZ>= ` N ) ( G ` k ) ) ) @=
      ? @.
      @( [ ?] @) @( [2-Jan-2006] @)
  @}
$)

  ${
    $d j k x F $.  $d j x M $.
    isumclt.1 $e |- F e. _V $.
    $( The sum of a converging infinite series is a complex number. $)
    isumcl $p |- ( ( M e. ZZ /\ E. x ( <. M , + >. seq F ) ~~> x ) ->
                    sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. CC ) $=
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM cuz cfv vk cv
      cF cfv vk csu cc wcel cM cz wcel cM cuz cfv vk cv cF cfv vk csu cc wcel
      cM caddc cop cF cseqz co vx cv cli wbr vx cab cuni cc wcel cM caddc cop
      cF cseqz co vx cv cli wbr vx wex cM cz wcel cM cuz cfv vk cv cF cfv vk
      csu cM caddc cop cF cseqz co vx cv cli wbr vx cab cuni cc vx vk cF cM
      isumclt.1 isumval eleq1d cM caddc cop cF cseqz co vx cv cli wbr vx wex cM
      caddc cop cF cseqz co vx cv cli wbr vx cc crab cuni cc cM caddc cop cF
      cseqz co vx cv cli wbr vx cab cuni cM caddc cop cF cseqz co vx cv cli wbr
      vx wex cM caddc cop cF cseqz co vx cv cli wbr vx cc wreu cM caddc cop cF
      cseqz co vx cv cli wbr vx cc crab cuni cc wcel cM caddc cop cF cseqz co
      vx cv cli wbr cM caddc cop cF cseqz co vx cv cli wbr vx cc wreu vx cM
      caddc cop cF cseqz co vx cv cli wbr vx cc hbreu1 vx vx cv cM caddc cop cF
      cseqz co vx visset climreu 19.23ai cM caddc cop cF cseqz co vx cv cli wbr
      vx cc reucl syl cM caddc cop cF cseqz co vx cv cli wbr vx cab cM caddc
      cop cF cseqz co vx cv cli wbr vx cc crab cM caddc cop cF cseqz co vx cv
      cli wbr vx cab vx cv cc wcel cM caddc cop cF cseqz co vx cv cli wbr wa vx
      cab cM caddc cop cF cseqz co vx cv cli wbr vx cc crab cM caddc cop cF
      cseqz co vx cv cli wbr vx cv cc wcel cM caddc cop cF cseqz co vx cv cli
      wbr wa vx cM caddc cop cF cseqz co vx cv cli wbr vx cv cc wcel vx cv cvv
      wcel cM caddc cop cF cseqz co vx cv cli wbr vx cv cc wcel vx visset vx cv
      cvv cM caddc cop cF cseqz co climcl mpan pm4.71ri abbii cM caddc cop cF
      cseqz co vx cv cli wbr vx cc df-rab eqtr4i unieqi syl5eqel syl5bir imp $.
      $( [1-Feb-2006] $) $( [13-Dec-2005] $)
  $}

  ${
    $d j k x F $.  $d j k x M $.
    isumreclt.1 $e |- F e. _V $.
    $( The sum of a converging real infinite series is a real number. $)
    isumrecl $p |- ( ( M e. ZZ /\ A. k e. ( ZZ>= ` M ) ( F ` k ) e. RR /\
                       E. x ( <. M , + >. seq F ) ~~> x ) ->
                    sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. RR ) $=
      cM cz wcel vk cv cF cfv cr wcel vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk csu cr wcel cM cz wcel
      vk cv cF cfv cr wcel vk cM cuz cfv wral wa cM caddc cop cF cseqz co vx cv
      cli wbr cM cuz cfv vk cv cF cfv vk csu cr wcel vx cM cz wcel vk cv cF cfv
      cr wcel vk cM cuz cfv wral wa cM caddc cop cF cseqz co vx cv cli wbr cM
      cuz cfv vk cv cF cfv vk csu cr wcel cM cz wcel vk cv cF cfv cr wcel vk cM
      cuz cfv wral wa cM caddc cop cF cseqz co vx cv cli wbr wa cM cuz cfv vk
      cv cF cfv vk csu vx cv cr cM cz wcel cM caddc cop cF cseqz co vx cv cli
      wbr cM cuz cfv vk cv cF cfv vk csu vx cv wceq vk cv cF cfv cr wcel vk cM
      cuz cfv wral vx cv vk cF cM isumreclt.1 vx visset isumclim adantlr cM cz
      wcel cM caddc cop cF cseqz co vx cv cli wbr vk cv cF cfv cr wcel vk cM
      cuz cfv wral vx cv cr wcel cM cz wcel cM caddc cop cF cseqz co vx cv cli
      wbr wa vk cv cF cfv cr wcel vk cM cuz cfv wral vj cv cM caddc cop cF
      cseqz co cfv cr wcel vj cM cuz cfv wral vx cv cr wcel cM cz wcel vk cv cF
      cfv cr wcel vk cM cuz cfv wral vj cv cM caddc cop cF cseqz co cfv cr wcel
      vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr cM cz wcel vk
      cv cF cfv cr wcel vk cM cuz cfv wral wa vj cv cM caddc cop cF cseqz co
      cfv cr wcel vj cM cuz cfv vk cv cF cfv cr wcel vk cM cuz cfv wral vj cv
      cM cuz cfv wcel vj cv cM caddc cop cF cseqz co cfv cr wcel wi cM cz wcel
      vj cv cM cuz cfv wcel vk cv cF cfv cr wcel vk cM cuz cfv wral vj cv cM
      caddc cop cF cseqz co cfv cr wcel vj cv cM cuz cfv wcel vk cv cF cfv cr
      wcel vk cM vj cv cfz co wral vj cv cM caddc cop cF cseqz co cfv cr wcel
      vk cv cF cfv cr wcel vk cM cuz cfv wral vk cF cM vj cv isumreclt.1
      serzrecl vk cv cF cfv cr wcel vk cv cF cfv cr wcel vk cM cuz cfv cM vj cv
      cfz co vk cv cM vj cv cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cr
      wcel vk cv cM vj cv elfzuz imim1i r19.20i2 sylan2 expcom adantl r19.21aiv
      adantlr cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vj cv cM caddc
      cop cF cseqz co cfv cr wcel vj cM cuz cfv wral vx cv cr wcel vx cv vj cM
      caddc cop cF cseqz co cM vx visset climrecl 3expa syldan an1rs eqeltrd ex
      19.23adv 3impia $.
      $( [28-Jun-2006] $) $( [25-Dec-2005] $)
  $}

  ${
    $d F k x $.  $d M k x $.  $d N k x $.
    iserzgt0.1 $e |- F e. _V $.
    $( The infinite sum of positive reals is positive.  (Contributed by Paul
       Chapman, 9-Feb-2008.) $)
    iserzgt0 $p |- ( ( N e. ( ZZ>= ` M ) /\
              A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. RR /\ 0 < ( F ` k ) ) /\
              E. x ( <. M , + >. seq F ) ~~> x ) ->
            0 < sum_ k e. ( ZZ>= ` N ) ( F ` k ) ) $=
      cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cc0 cN cF
      cfv cN c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co cN cuz cfv vk cv
      cF cfv vk csu clt cN cF cfv cr wcel cc0 cN cF cfv clt wbr wa cN c1 caddc
      co cuz cfv vk cv cF cfv vk csu cr wcel cc0 cN c1 caddc co cuz cfv vk cv
      cF cfv vk csu cle wbr wa cc0 cN cF cfv cN c1 caddc co cuz cfv vk cv cF
      cfv vk csu caddc co clt wbr cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0
      vk cv cF cfv clt wbr wa vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cN cF cfv cr wcel cN c1 caddc co cuz cfv vk cv cF cfv
      vk csu cr wcel cc0 cN cF cfv clt wbr cc0 cN c1 caddc co cuz cfv vk cv cF
      cfv vk csu cle wbr cc0 cN cF cfv cN c1 caddc co cuz cfv vk cv cF cfv vk
      csu caddc co clt wbr cN cF cfv cN c1 caddc co cuz cfv vk cv cF cfv vk csu
      addgtge0 an4s cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv
      clt wbr wa vk cM cuz cfv wral cN cF cfv cr wcel cc0 cN cF cfv clt wbr wa
      cM caddc cop cF cseqz co vx cv cli wbr vx wex vk cv cF cfv cr wcel cc0 vk
      cv cF cfv clt wbr wa cN cF cfv cr wcel cc0 cN cF cfv clt wbr wa vk cN cM
      cuz cfv vk cv cN wceq vk cv cF cfv cr wcel cN cF cfv cr wcel cc0 vk cv cF
      cfv clt wbr cc0 cN cF cfv clt wbr vk cv cN wceq vk cv cF cfv cN cF cfv cr
      vk cv cN cF fveq2 eleq1d vk cv cN wceq vk cv cF cfv cN cF cfv cc0 clt vk
      cv cN cF fveq2 breq2d anbi12d rcla4va 3adant3 cN cM cuz cfv wcel vk cv cF
      cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cN c1 caddc co cuz cfv vk cv cF cfv
      vk csu cr wcel cc0 cN c1 caddc co cuz cfv vk cv cF cfv vk csu cle wbr cN
      c1 caddc co cz wcel vk cv cF cfv cr wcel vk cN c1 caddc co cuz cfv wral
      cN c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cN c1 caddc co
      cuz cfv vk cv cF cfv vk csu cr wcel cN cM cuz cfv wcel vk cv cF cfv cr
      wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a vx vk cF cN c1 caddc co iserzgt0.1 isumrecl
      cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM
      cuz cfv wral cN c1 caddc co cz wcel cM caddc cop cF cseqz co vx cv cli
      wbr vx wex cN cM cuz cfv wcel cN cM cN eluzelz peano2zdi 3ad2ant1 cN cM
      cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz
      cfv wral vk cv cF cfv cr wcel vk cN c1 caddc co cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex cN cM cuz cfv wcel vk cv cF cfv cr wcel
      cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral vk cv cF cfv cr wcel vk cN
      c1 caddc co cuz cfv wral cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk
      cv cF cfv clt wbr wa vk cv cF cfv cr wcel vk cM cuz cfv cN c1 caddc co
      cuz cfv cN cM cuz cfv wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel cc0
      vk cv cF cfv clt wbr wa wi vk cv cN c1 caddc co cuz cfv wcel vk cv cF cfv
      cr wcel cc0 vk cv cF cfv clt wbr wa vk cv cF cfv cr wcel cN cM cuz cfv
      wcel vk cv cN c1 caddc co cuz cfv wcel vk cv cM cuz cfv wcel vk cv cF cfv
      cr wcel cc0 vk cv cF cfv clt wbr wa cN cM cuz cfv wcel cN c1 caddc co cM
      cuz cfv wcel vk cv cN c1 caddc co cuz cfv wcel vk cv cM cuz cfv wcel wi
      cM cN peano2uz vk cv cN c1 caddc co cuz cfv wcel cN c1 caddc co cM cuz
      cfv wcel vk cv cM cuz cfv wcel cN c1 caddc co vk cv cM uztrn expcom syl
      imim1d vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr pm3.26 syl8
      r19.20dv2 imp 3adant3 cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cN c1 caddc co
      caddc cop cF cseqz co vx cv cli wbr vx wex vk cv cF cfv cr wcel cc0 vk cv
      cF cfv clt wbr wa vk cM cuz cfv wral vx vk cF cM cN iserzgt0.1 iserzex vk
      cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cv cF cfv cc wcel vk cM
      cuz cfv vk cv cF cfv cr wcel vk cv cF cfv cc wcel cc0 vk cv cF cfv clt
      wbr vk cv cF cfv recn adantr r19.20si syl3an2 syl3anc cN c1 caddc co cz
      wcel cN c1 caddc co caddc cop cF cseqz co cN c1 caddc co cuz cfv vk cv cF
      cfv vk csu cli wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cN
      c1 caddc co cuz cfv wral cc0 cN c1 caddc co cuz cfv vk cv cF cfv vk csu
      cle wbr cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr
      wa vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cN c1 caddc co cuz cfv vk cv cF cfv vk csu vk cF cN c1 caddc co cN c1
      caddc co cuz cfv vk cv cF cfv vk sumex iserzgt0.1 iserzcmp0 cN cM cuz cfv
      wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral
      cN c1 caddc co cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cN
      cM cuz cfv wcel cN cM cN eluzelz peano2zdi 3ad2ant1 cN c1 caddc co cz
      wcel cN c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cN c1
      caddc co caddc cop cF cseqz co cN c1 caddc co cuz cfv vk cv cF cfv vk csu
      cli wbr cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr
      wa vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      vx vk cF cN c1 caddc co iserzgt0.1 isumclim2 cN cM cuz cfv wcel vk cv cF
      cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral cN c1 caddc co
      cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cN cM cuz cfv wcel
      cN cM cN eluzelz peano2zdi 3ad2ant1 cN cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cN
      c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex vk cv cF cfv cr
      wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral vx vk cF cM cN
      iserzgt0.1 iserzex vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cv
      cF cfv cc wcel vk cM cuz cfv vk cv cF cfv cr wcel vk cv cF cfv cc wcel
      cc0 vk cv cF cfv clt wbr vk cv cF cfv recn adantr r19.20si syl3an2 sylanc
      cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM
      cuz cfv wral vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cN c1
      caddc co cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cN cM
      cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz
      cfv wral vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cN c1 caddc
      co cuz cfv wral cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv
      clt wbr wa vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk cM cuz cfv
      cN c1 caddc co cuz cfv cN cM cuz cfv wcel vk cv cM cuz cfv wcel vk cv cF
      cfv cr wcel cc0 vk cv cF cfv clt wbr wa wi vk cv cN c1 caddc co cuz cfv
      wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cv cF cfv cr
      wcel cc0 vk cv cF cfv cle wbr wa cN cM cuz cfv wcel vk cv cN c1 caddc co
      cuz cfv wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv
      clt wbr wa cN cM cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vk cv cN c1
      caddc co cuz cfv wcel vk cv cM cuz cfv wcel wi cM cN peano2uz vk cv cN c1
      caddc co cuz cfv wcel cN c1 caddc co cM cuz cfv wcel vk cv cM cuz cfv
      wcel cN c1 caddc co vk cv cM uztrn expcom syl imim1d vk cv cF cfv cr wcel
      cc0 vk cv cF cfv clt wbr cc0 vk cv cF cfv cle wbr cc0 cr wcel vk cv cF
      cfv cr wcel cc0 vk cv cF cfv clt wbr cc0 vk cv cF cfv cle wbr wi 0re cc0
      vk cv cF cfv ltle mpan imdistani syl8 r19.20dv2 imp 3adant3 syl3anc jca
      sylanc cN cz wcel vk cv cF cfv cc wcel vk cN cuz cfv wral cN c1 caddc co
      caddc cop cF cseqz co vx cv cli wbr vx wex cN cuz cfv vk cv cF cfv vk csu
      cN cF cfv cN c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co wceq cN cM
      cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a vx vk cF cN
      iserzgt0.1 isum1p cN cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF
      cfv clt wbr wa vk cM cuz cfv wral cN cz wcel cM caddc cop cF cseqz co vx
      cv cli wbr vx wex cM cN eluzelz 3ad2ant1 cN cM cuz cfv wcel vk cv cF cfv
      cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv wral vk cv cF cfv cc
      wcel vk cN cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cN
      cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM
      cuz cfv wral vk cv cF cfv cc wcel vk cN cuz cfv wral cN cM cuz cfv wcel
      vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cv cF cfv cc wcel vk
      cM cuz cfv cN cuz cfv cN cM cuz cfv wcel vk cv cM cuz cfv wcel vk cv cF
      cfv cr wcel cc0 vk cv cF cfv clt wbr wa wi vk cv cN cuz cfv wcel vk cv cF
      cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cv cF cfv cc wcel cN cM cuz
      cfv wcel vk cv cN cuz cfv wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel
      cc0 vk cv cF cfv clt wbr wa vk cv cN cuz cfv wcel cN cM cuz cfv wcel vk
      cv cM cuz cfv wcel cN vk cv cM uztrn expcom imim1d vk cv cF cfv cr wcel
      vk cv cF cfv cc wcel cc0 vk cv cF cfv clt wbr vk cv cF cfv recn adantr
      syl8 r19.20dv2 imp 3adant3 cN cM cuz cfv wcel vk cv cF cfv cc wcel vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cN c1 caddc co
      caddc cop cF cseqz co vx cv cli wbr vx wex vk cv cF cfv cr wcel cc0 vk cv
      cF cfv clt wbr wa vk cM cuz cfv wral vx vk cF cM cN iserzgt0.1 iserzex vk
      cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cv cF cfv cc wcel vk cM
      cuz cfv vk cv cF cfv cr wcel vk cv cF cfv cc wcel cc0 vk cv cF cfv clt
      wbr vk cv cF cfv recn adantr r19.20si syl3an2 syl3anc breqtrrd $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d j k m n x y C $.  $d j k m n x y F $.  $d j k m n x y M $.
    isummulc1.1 $e |- F e. _V $.
    $( Distribute a constant multiplier into an infinite sum (function value
       version).  See ~ isummulc1ai for class term version. $)
    isummulc1 $p |- ( ( ( M e. ZZ /\ C e. CC ) /\ ( A. k e. ( ZZ>= ` M )
        ( F ` k ) e. CC /\ E. x ( <. M , + >. seq F ) ~~> x ) )
                   -> ( C x. sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) =
                      sum_ k e. ( ZZ>= ` M ) ( C x. ( F ` k ) ) ) $=
      cM cz wcel cC cc wcel wa vk cv cF cfv cc wcel vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex wa wa cM cuz cfv cC vj cv cF cfv
      cmul co vj csu cC cM cuz cfv vk cv cF cfv vk csu cmul co cM cuz cfv cC vk
      cv cF cfv cmul co vk csu cM cz wcel cC cc wcel wa vk cv cF cfv cc wcel vk
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex wa wa cM
      caddc cop vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj
      vy copab cseqz co cC cM cuz cfv vk cv cF cfv vk csu cmul co cli wbr cM
      cuz cfv cC vj cv cF cfv cmul co vj csu cC cM cuz cfv vk cv cF cfv vk csu
      cmul co wceq cM cz wcel cC cc wcel wa vk cv cF cfv cc wcel vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop vj cv cM
      cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab cseqz co
      cC cM cuz cfv vk cv cF cfv vk csu cmul co cli wbr cM cz wcel cC cc wcel
      vk cv cF cfv cc wcel vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex cM caddc cop vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv
      cmul co wceq wa vj vy copab cseqz co cC cM cuz cfv vk cv cF cfv vk csu
      cmul co cli wbr wi cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz
      cfv wral w3a cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop
      cF cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM caddc cop vj cv cM
      cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab cseqz co
      cC cM cuz cfv vk cv cF cfv vk csu cmul co cli wbr cM cz wcel cC cc wcel
      cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co cM
      cuz cfv vk cv cF cfv vk csu cli wbr wi vk cv cF cfv cc wcel vk cM cuz cfv
      wral cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc
      cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr vx vk cF cM
      isummulc1.1 isumclim2 ex 3ad2ant1 cM cz wcel cC cc wcel vk cv cF cfv cc
      wcel vk cv vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj
      vy copab cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral cM caddc
      cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM caddc cop vj cv
      cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab cseqz
      co cC cM cuz cfv vk cv cF cfv vk csu cmul co cli wbr wi vk cv cF cfv cc
      wcel vk cM cuz cfv wral cM cuz cfv vk cv cF cfv vk csu cC vk cF vj cv cM
      cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab cM cM cuz
      cfv vk cv cF cfv vk sumex isummulc1.1 vj vy cM cuz cfv cC vj cv cF cfv
      cmul co cM cuz fvex opabex2 iserzmulc1 vk cv cF cfv cc wcel vk cv vj cv
      cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab cfv cC
      vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral vk cv cF cfv cc wcel vk
      cM cuz cfv wral vk cv vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co
      wceq wa vj vy copab cfv cC vk cv cF cfv cmul co wceq vk cM cuz cfv wral
      vk cv cF cfv cc wcel vk cv vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv
      cmul co wceq wa vj vy copab cfv cC vk cv cF cfv cmul co wceq vk cM cuz
      cfv r19.26 vk cv vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq
      wa vj vy copab cfv cC vk cv cF cfv cmul co wceq vk cM cuz cfv vj vy vk cv
      cC vj cv cF cfv cmul co cC vk cv cF cfv cmul co cM cuz cfv vj cv cM cuz
      cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab vj cv vk cv
      wceq vj cv cF cfv vk cv cF cfv cC cmul vj cv vk cv cF fveq2 opreq2d vj cv
      cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy copab eqid cC
      vk cv cF cfv cmul oprex fvopab4 rgen mpbiran2 syl3an3br syld 3expia imp32
      cM cz wcel cM caddc cop vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul
      co wceq wa vj vy copab cseqz co cC cM cuz cfv vk cv cF cfv vk csu cmul co
      cli wbr cM cuz cfv cC vj cv cF cfv cmul co vj csu cC cM cuz cfv vk cv cF
      cfv vk csu cmul co wceq wi cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cz wcel cM caddc
      cop vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy
      copab cseqz co cC cM cuz cfv vk cv cF cfv vk csu cmul co cli wbr cM cuz
      cfv cC vj cv cF cfv cmul co vj csu cC cM cuz cfv vk cv cF cfv vk csu cmul
      co wceq vy cC vj cv cF cfv cmul co cC cM cuz cfv vk cv cF cfv vk csu cmul
      co vj vj cv cM cuz cfv wcel vy cv cC vj cv cF cfv cmul co wceq wa vj vy
      copab cM cC vj cv cF cfv cmul oprex vj cv cM cuz cfv wcel vy cv cC vj cv
      cF cfv cmul co wceq wa vj vy copab eqid cC cM cuz cfv vk cv cF cfv vk csu
      cmul oprex isumclim4 ex ad2antrr mpd vx cM cuz cfv cC vj cv cF cfv cmul
      co cC vk cv cF cfv cmul co vj vk vx cv cC vj cv cF cfv cmul co wcel vk
      ax-17 vx cv cC vk cv cF cfv cmul co wcel vj ax-17 vj cv vk cv wceq vj cv
      cF cfv vk cv cF cfv cC cmul vj cv vk cv cF fveq2 opreq2d cbvsumi syl5reqr
      $.
      $( [16-Nov-2007] $) $( [1-Nov-2007] $)
  $}

  ${
    $d k m n x y C $.  $d k m n x y F $.  $d k m n x y M $.
    isummulc1iALT.1 $e |- F e. _V $.
    $( Older ~ isummulc1 proved without using ~ iserzmulc1 . $)
    isummulc1iALT $p |- ( ( ( M e. ZZ /\ C e. CC ) /\ ( A. k e. ( ZZ>= ` M )
        ( F ` k ) e. CC /\ E. x ( <. M , + >. seq F ) ~~> x ) )
                   -> ( C x. sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) =
                      sum_ k e. ( ZZ>= ` M ) ( C x. ( F ` k ) ) ) $=
      cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex cC cM cuz cfv vk cv cF cfv vk csu
      cmul co cM cuz cfv cC vk cv cF cfv cmul co vk csu wceq cM cz wcel cC cc
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex cC cM cuz cfv vk cv cF cfv vk csu cmul co cM cuz cfv cC
      vk cv cF cfv cmul co vk csu wceq wi cM cz wcel cC cc wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral w3a cM caddc cop cF cseqz co vx cv cli wbr cC cM
      cuz cfv vk cv cF cfv vk csu cmul co cM cuz cfv cC vk cv cF cfv cmul co vk
      csu wceq vx cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral
      w3a cM caddc cop cF cseqz co vx cv cli wbr cC cM cuz cfv vk cv cF cfv vk
      csu cmul co cM cuz cfv cC vk cv cF cfv cmul co vk csu wceq cM cz wcel cC
      cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral w3a cM caddc cop cF cseqz
      co vx cv cli wbr wa cC cM cuz cfv vk cv cF cfv vk csu cmul co cC vx cv
      cmul co cM cuz cfv cC vk cv cF cfv cmul co vk csu cM cz wcel cC cc wcel
      cM caddc cop cF cseqz co vx cv cli wbr cC cM cuz cfv vk cv cF cfv vk csu
      cmul co cC vx cv cmul co wceq vk cv cF cfv cc wcel vk cM cuz cfv wral cM
      cz wcel cM caddc cop cF cseqz co vx cv cli wbr wa cM cuz cfv vk cv cF cfv
      vk csu vx cv cC cmul vx cv vk cF cM isummulc1iALT.1 vx visset isumclim
      opreq2d 3ad2antl1 cM cz wcel cM caddc cop vk cv cM cuz cfv wcel vy cv cC
      vk cv cF cfv cmul co wceq wa vk vy copab cseqz co cC vx cv cmul co cli
      wbr cM cuz cfv cC vk cv cF cfv cmul co vk csu cC vx cv cmul co wceq cM cz
      wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral w3a cM caddc cop
      cF cseqz co vx cv cli wbr wa vy cC vk cv cF cfv cmul co cC vx cv cmul co
      vk vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk vy
      copab cM cC vk cv cF cfv cmul oprex vk cv cM cuz cfv wcel vy cv cC vk cv
      cF cfv cmul co wceq wa vk vy copab eqid cC vx cv cmul oprex isumclim4 cM
      cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr 3simpl1 cC cc wcel cM caddc cop cF cseqz co vx
      cv cli wbr wa cM cz wcel vn cv cM caddc cop cF cseqz co cfv cc wcel vn cv
      cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa
      vk vy copab cseqz co cfv cC vn cv cM caddc cop cF cseqz co cfv cmul co
      wceq wa vn cM cuz cfv wral wa cM caddc cop vk cv cM cuz cfv wcel vy cv cC
      vk cv cF cfv cmul co wceq wa vk vy copab cseqz co cC vx cv cmul co cli
      wbr cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral w3a cM
      caddc cop cF cseqz co vx cv cli wbr wa vx cv cC vn cM caddc cop cF cseqz
      co cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq
      wa vk vy copab cseqz co cM cM caddc cop cF cseqz oprex cM caddc cop vk cv
      cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk vy copab cseqz
      oprex vx visset climmulc2 cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk
      cM cuz cfv wral w3a cC cc wcel cM caddc cop cF cseqz co vx cv cli wbr cM
      cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral 3simp2 anim1i
      cM cz wcel cC cc wcel vk cv cF cfv cc wcel vk cM cuz cfv wral w3a cM cz
      wcel vn cv cM caddc cop cF cseqz co cfv cc wcel vn cv cM caddc cop vk cv
      cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk vy copab cseqz
      co cfv cC vn cv cM caddc cop cF cseqz co cfv cmul co wceq wa vn cM cuz
      cfv wral wa cM caddc cop cF cseqz co vx cv cli wbr cM cz wcel cC cc wcel
      vk cv cF cfv cc wcel vk cM cuz cfv wral cM cz wcel vn cv cM caddc cop cF
      cseqz co cfv cc wcel vn cv cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk
      cv cF cfv cmul co wceq wa vk vy copab cseqz co cfv cC vn cv cM caddc cop
      cF cseqz co cfv cmul co wceq wa vn cM cuz cfv wral wa cC cc wcel vk cv cF
      cfv cc wcel vk cM cuz cfv wral wa vn cv cM caddc cop cF cseqz co cfv cc
      wcel vn cv cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul
      co wceq wa vk vy copab cseqz co cfv cC vn cv cM caddc cop cF cseqz co cfv
      cmul co wceq wa vn cM cuz cfv wral cM cz wcel cC cc wcel vm cv cF cfv cc
      wcel vm cM cuz cfv wral vn cv cM caddc cop cF cseqz co cfv cc wcel vn cv
      cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa
      vk vy copab cseqz co cfv cC vn cv cM caddc cop cF cseqz co cfv cmul co
      wceq wa vn cM cuz cfv wral vk cv cF cfv cc wcel vk cM cuz cfv wral cC cc
      wcel vm cv cF cfv cc wcel vm cM cuz cfv wral wa vn cv cM caddc cop cF
      cseqz co cfv cc wcel vn cv cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk
      cv cF cfv cmul co wceq wa vk vy copab cseqz co cfv cC vn cv cM caddc cop
      cF cseqz co cfv cmul co wceq wa vn cM cuz cfv cC cc wcel vm cv cF cfv cc
      wcel vm cM cuz cfv wral vn cv cM cuz cfv wcel vn cv cM caddc cop cF cseqz
      co cfv cc wcel vn cv cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF
      cfv cmul co wceq wa vk vy copab cseqz co cfv cC vn cv cM caddc cop cF
      cseqz co cfv cmul co wceq wa vn cv cM cuz cfv wcel cC cc wcel vm cv cF
      cfv cc wcel vm cM cuz cfv wral vn cv cM caddc cop cF cseqz co cfv cc wcel
      vn cv cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co
      wceq wa vk vy copab cseqz co cfv cC vn cv cM caddc cop cF cseqz co cfv
      cmul co wceq wa vn cv cM cuz cfv wcel cC cc wcel vm cv cF cfv cc wcel vm
      cM cuz cfv wral w3a vn cv cM caddc cop cF cseqz co cfv cc wcel vn cv cM
      caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk
      vy copab cseqz co cfv cC vn cv cM caddc cop cF cseqz co cfv cmul co wceq
      vn cv cM cuz cfv wcel vm cv cF cfv cc wcel vm cM cuz cfv wral vn cv cM
      caddc cop cF cseqz co cfv cc wcel cC cc wcel vm cF cM vn cv
      isummulc1iALT.1 serzcl2 3adant2 vn cv cM cuz cfv wcel cC cc wcel vm cv cF
      cfv cc wcel vm cM cuz cfv wral w3a cC vn cv cM caddc cop cF cseqz co cfv
      cmul co vn cv cM caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv
      cmul co wceq wa vk vy copab cseqz co cfv vn cv cM cuz cfv wcel cC cc wcel
      vm cv cF cfv cc wcel vm cv vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv
      cmul co wceq wa vk vy copab cfv cC vm cv cF cfv cmul co wceq wa vm cM vn
      cv cfz co wral cC vn cv cM caddc cop cF cseqz co cfv cmul co vn cv cM
      caddc cop vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk
      vy copab cseqz co cfv wceq vm cv cF cfv cc wcel vm cM cuz cfv wral cC vm
      cF vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk vy
      copab cM vn cv isummulc1iALT.1 vk vy cM cuz cfv cC vk cv cF cfv cmul co
      cM cuz fvex opabex2 serzmulc1 vm cv cF cfv cc wcel vm cv cF cfv cc wcel
      vm cv vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk vy
      copab cfv cC vm cv cF cfv cmul co wceq wa vm cM cuz cfv cM vn cv cfz co
      vm cv cM cuz cfv wcel vm cv cF cfv cc wcel wi vm cv cM cuz cfv wcel vm cv
      cF cfv cc wcel vm cv vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co
      wceq wa vk vy copab cfv cC vm cv cF cfv cmul co wceq wa vm cv cM vn cv
      cfz co wcel vm cv cM cuz cfv wcel vm cv cF cfv cc wcel vm cv cF cfv cc
      wcel vm cv vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk
      vy copab cfv cC vm cv cF cfv cmul co wceq wa vm cv cF cfv cc wcel vm cv
      cM cuz cfv wcel vm cv cF cfv cc wcel vm cv vk cv cM cuz cfv wcel vy cv cC
      vk cv cF cfv cmul co wceq wa vk vy copab cfv cC vm cv cF cfv cmul co wceq
      wa vm cv cM cuz cfv wcel vm cv vk cv cM cuz cfv wcel vy cv cC vk cv cF
      cfv cmul co wceq wa vk vy copab cfv cC vm cv cF cfv cmul co wceq vm cv cF
      cfv cc wcel vk vy vm cv cC vk cv cF cfv cmul co cC vm cv cF cfv cmul co
      cM cuz cfv vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq wa vk
      vy copab vk cv vm cv wceq vk cv cF cfv vm cv cF cfv cC cmul vk cv vm cv
      cF fveq2 opreq2d vk cv cM cuz cfv wcel vy cv cC vk cv cF cfv cmul co wceq
      wa vk vy copab eqid cC vm cv cF cfv cmul oprex fvopab4 anim2i expcom a2i
      vm cv cM vn cv elfzuz syl5 r19.20i2 syl3an3 eqcomd jca 3coml 3expa
      r19.21aiva vk cv cF cfv cc wcel vm cv cF cfv cc wcel vk vm cM cuz cfv vk
      cv vm cv wceq vk cv cF cfv vm cv cF cfv cc vk cv vm cv cF fveq2 eleq1d
      cbvralv sylan2b anim2i 3impb adantr sylanc sylanc eqtr4d ex 19.23adv 3exp
      imp43 $.
      $( [2-Nov-2007] $) $( [1-Nov-2007] $)
  $}

  ${
    $d j k x y C $.  $d j x y F $.  $d j k x y M $.
    isummulc1a.1 $e |- A e. _V $.
    isummulc1a.2 $e |- F e. _V $.
    isummulc1a.3 $e |- ( y e. F -> A. k y e. F ) $.
    isummulc1a.4 $e |- ( k e. ( ZZ>= ` M ) -> ( F ` k ) = A ) $.
    $( Distribute a constant multiplier into an infinite sum of a class term
       ` A ( k ) ` .  See ~ isummulc1 for function value version. $)
    isummulc1ai $p |- ( ( ( M e. ZZ /\ C e. CC ) /\ ( A. k e. ( ZZ>= ` M )
        A e. CC /\ E. x ( <. M , + >. seq F ) ~~> x ) ) ->
     ( C x. sum_ k e. ( ZZ>= ` M ) A ) = sum_ k e. ( ZZ>= ` M ) ( C x. A ) ) $=
      cM cz wcel cC cc wcel wa vj cv cF cfv cc wcel vj cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex wa cC cM cuz cfv cA vk csu cmul co
      cM cuz cfv cC cA cmul co vk csu wceq cA cc wcel vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cz wcel cC cc wcel wa vj
      cv cF cfv cc wcel vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa wa cC cM cuz cfv vj cv cF cfv vj csu cmul co cM cuz cfv cC
      vj cv cF cfv cmul co vj csu cC cM cuz cfv cA vk csu cmul co cM cuz cfv cC
      cA cmul co vk csu vx cC vj cF cM isummulc1a.2 isummulc1 cM cuz cfv cA vk
      csu cM cuz cfv vj cv cF cfv vj csu cC cmul cM cuz cfv vk cv cF cfv vk csu
      cM cuz cfv cA vk csu cM cuz cfv vj cv cF cfv vj csu cM cuz cfv vk cv cF
      cfv cA vk isummulc1a.4 sumeq2i vy cM cuz cfv vk cv cF cfv vj cv cF cfv vk
      vj vy cv vk cv cF cfv wcel vj ax-17 vk vy vj cv cF isummulc1a.3 vy cv vj
      cv wcel vk ax-17 hbfv vk cv vj cv cF fveq2 cbvsumi eqtr3i opreq2i cM cuz
      cfv cC vk cv cF cfv cmul co vk csu cM cuz cfv cC cA cmul co vk csu cM cuz
      cfv cC vj cv cF cfv cmul co vj csu cM cuz cfv cC vk cv cF cfv cmul co cC
      cA cmul co vk vk cv cM cuz cfv wcel vk cv cF cfv cA cC cmul isummulc1a.4
      opreq2d sumeq2i vy cM cuz cfv cC vk cv cF cfv cmul co cC vj cv cF cfv
      cmul co vk vj vy cv cC vk cv cF cfv cmul co wcel vj ax-17 vk vy cC vj cv
      cF cfv cmul vy cv cC wcel vk ax-17 vy cv cmul wcel vk ax-17 vk vy vj cv
      cF isummulc1a.3 vy cv vj cv wcel vk ax-17 hbfv hbopr vk cv vj cv wceq vk
      cv cF cfv vj cv cF cfv cC cmul vk cv vj cv cF fveq2 opreq2d cbvsumi
      eqtr3i 3eqtr4g cA cc wcel vk cM cuz cfv wral vj cv cF cfv cc wcel vj cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cA cc wcel vk
      cM cuz cfv wral vk cv cF cfv cc wcel vk cM cuz cfv wral vj cv cF cfv cc
      wcel vj cM cuz cfv wral vk cv cF cfv cc wcel cA cc wcel vk cM cuz cfv vk
      cv cM cuz cfv wcel vk cv cF cfv cA cc isummulc1a.4 eleq1d ralbiia vk cv
      cF cfv cc wcel vj cv cF cfv cc wcel vk vj cM cuz cfv vk cv cF cfv cc wcel
      vj ax-17 vk vy vy vj cv cF cfv cc vk vy vj cv cF isummulc1a.3 vy cv vj cv
      wcel vk ax-17 hbfv vy cv cc wcel vk ax-17 hbel vk cv vj cv wceq vk cv cF
      cfv vj cv cF cfv cc vk cv vj cv cF fveq2 eleq1d cbvral bitr3i anbi1i
      sylan2b $.
      $( [2-Nov-2007] $) $( [2-Nov-2007] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d k x F $.  $d k x G $.  $d j k x y M $.
    isumcmpi.1 $e |- A e. _V $.
    isumcmpi.2 $e |- B e. _V $.
    isumcmpi.3 $e |- F = { <. j , y >. | ( j e. ( ZZ>= ` M ) /\ y = A ) } $.
    isumcmpi.4 $e |- G = { <. j , y >. | ( j e. ( ZZ>= ` M ) /\ y = B ) } $.
    isumcmpi.5 $e |- ( j e. ( ZZ>= ` M ) ->
               ( A e. RR /\ B e. RR /\ A <_ B ) ) $.
    $( Comparison of two infinite sums.  (Contributed by Paul Chapman,
       13-Nov-2007.) $)
    isumcmpii $p |- ( ( M e. ZZ /\ ( E. x ( <. M , + >. seq F ) ~~> x /\
                       E. x ( <. M , + >. seq G ) ~~> x ) ) ->
                     sum_ j e. ( ZZ>= ` M ) A <_ sum_ j e. ( ZZ>= ` M ) B ) $=
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cG
      cseqz co vx cv cli wbr vx wex wa cM cuz cfv cA vj csu cM cuz cfv cB vj
      csu cle wbr cM cz wcel cM caddc cop cF cseqz co cM cuz cfv cA vj csu cli
      wbr cM caddc cop cG cseqz co cM cuz cfv cB vj csu cli wbr cM cuz cfv cA
      vj csu cM cuz cfv cB vj csu cle wbr cM caddc cop cF cseqz co vx cv cli
      wbr vx wex cM caddc cop cG cseqz co vx cv cli wbr vx wex cM caddc cop cF
      cseqz co cM cuz cfv cA vj csu cli wbr cM caddc cop cG cseqz co cM cuz cfv
      cB vj csu cli wbr wa cM cz wcel cM cuz cfv cA vj csu cM cuz cfv cB vj csu
      cle wbr cM caddc cop cF cseqz co cM cuz cfv cA vj csu cli wbr cM caddc
      cop cG cseqz co cM cuz cfv cB vj csu cli wbr wa cM cz wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cM
      cuz cfv wral cM cuz cfv cA vj csu cM cuz cfv cB vj csu cle wbr vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk
      cM cuz cfv wral vk cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cv cF cfv
      vk cv cG cfv cle wbr wa vk cM cuz cfv wral vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr wa vk cM cuz cfv wral vk
      cv cF cfv cr wcel vk cv cG cfv cr wcel wa vk cM cuz cfv wral vk cv cF cfv
      vk cv cG cfv cle wbr vk cM cuz cfv wral vk cv cF cfv cr wcel vk cv cG cfv
      cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr vk cM cuz cfv r19.26 vk cv
      cF cfv cr wcel vk cv cG cfv cr wcel wa vk cM cuz cfv wral vk cv cF cfv cr
      wcel vk cM cuz cfv wral vk cv cG cfv cr wcel vk cM cuz cfv wral vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel vk cM cuz cfv r19.26 vj cv cF cfv cr
      wcel vj cM cuz cfv wral vk cv cF cfv cr wcel vk cM cuz cfv wral vj cv cF
      cfv cr wcel vj cM cuz cfv vj cv cM cuz cfv wcel vj cv cF cfv cA cr vj cv
      cM cuz cfv wcel cA cr wcel vj cv cF cfv cA wceq vj cv cM cuz cfv wcel cA
      cr wcel cB cr wcel cA cB cle wbr isumcmpi.5 3simp1d vj cv cM cuz cfv wcel
      cA cr wcel wa vj cv vj cv cM cuz cfv wcel vy cv cA wceq wa vj vy copab
      cfv cA vj cv cF cfv vj vy cM cuz cfv cA cr fvopab2 vj cv cF vj cv cM cuz
      cfv wcel vy cv cA wceq wa vj vy copab isumcmpi.3 fveq1i syl5eq mpdan vj
      cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr isumcmpi.5 3simp1d
      eqeltrd rgen vj cv cF cfv cr wcel vk cv cF cfv cr wcel vj vk cM cuz cfv
      vj cv cF cfv cr wcel vk ax-17 vj vx vx vk cv cF cfv cr vj vx vk cv cF vj
      vx cF vj cv cM cuz cfv wcel vy cv cA wceq wa vj vy copab isumcmpi.3 vj cv
      cM cuz cfv wcel vy cv cA wceq wa vj vy vx hbopab1 hbxfr vx cv vk cv wcel
      vj ax-17 hbfv vx cv cr wcel vj ax-17 hbel vj cv vk cv wceq vj cv cF cfv
      vk cv cF cfv cr vj cv vk cv cF fveq2 eleq1d cbvral mpbi vj cv cG cfv cr
      wcel vj cM cuz cfv wral vk cv cG cfv cr wcel vk cM cuz cfv wral vj cv cG
      cfv cr wcel vj cM cuz cfv vj cv cM cuz cfv wcel vj cv cG cfv cB cr vj cv
      cM cuz cfv wcel cB cr wcel vj cv cG cfv cB wceq vj cv cM cuz cfv wcel cA
      cr wcel cB cr wcel cA cB cle wbr isumcmpi.5 3simp2d vj cv cM cuz cfv wcel
      cB cr wcel wa vj cv vj cv cM cuz cfv wcel vy cv cB wceq wa vj vy copab
      cfv cB vj cv cG cfv vj vy cM cuz cfv cB cr fvopab2 vj cv cG vj cv cM cuz
      cfv wcel vy cv cB wceq wa vj vy copab isumcmpi.4 fveq1i syl5eq mpdan vj
      cv cM cuz cfv wcel cA cr wcel cB cr wcel cA cB cle wbr isumcmpi.5 3simp2d
      eqeltrd rgen vj cv cG cfv cr wcel vk cv cG cfv cr wcel vj vk cM cuz cfv
      vj cv cG cfv cr wcel vk ax-17 vj vx vx vk cv cG cfv cr vj vx vk cv cG vj
      vx cG vj cv cM cuz cfv wcel vy cv cB wceq wa vj vy copab isumcmpi.4 vj cv
      cM cuz cfv wcel vy cv cB wceq wa vj vy vx hbopab1 hbxfr vx cv vk cv wcel
      vj ax-17 hbfv vx cv cr wcel vj ax-17 hbel vj cv vk cv wceq vj cv cG cfv
      vk cv cG cfv cr vj cv vk cv cG fveq2 eleq1d cbvral mpbi mpbir2an vj cv cF
      cfv vj cv cG cfv cle wbr vj cM cuz cfv wral vk cv cF cfv vk cv cG cfv cle
      wbr vk cM cuz cfv wral vj cv cF cfv vj cv cG cfv cle wbr vj cM cuz cfv vj
      cv cM cuz cfv wcel cA cB vj cv cF cfv vj cv cG cfv cle vj cv cM cuz cfv
      wcel cA cr wcel cB cr wcel cA cB cle wbr isumcmpi.5 3simp3d vj cv cM cuz
      cfv wcel cA cr wcel vj cv cF cfv cA wceq vj cv cM cuz cfv wcel cA cr wcel
      cB cr wcel cA cB cle wbr isumcmpi.5 3simp1d vj cv cM cuz cfv wcel cA cr
      wcel wa vj cv vj cv cM cuz cfv wcel vy cv cA wceq wa vj vy copab cfv cA
      vj cv cF cfv vj vy cM cuz cfv cA cr fvopab2 vj cv cF vj cv cM cuz cfv
      wcel vy cv cA wceq wa vj vy copab isumcmpi.3 fveq1i syl5eq mpdan vj cv cM
      cuz cfv wcel cB cr wcel vj cv cG cfv cB wceq vj cv cM cuz cfv wcel cA cr
      wcel cB cr wcel cA cB cle wbr isumcmpi.5 3simp2d vj cv cM cuz cfv wcel cB
      cr wcel wa vj cv vj cv cM cuz cfv wcel vy cv cB wceq wa vj vy copab cfv
      cB vj cv cG cfv vj vy cM cuz cfv cB cr fvopab2 vj cv cG vj cv cM cuz cfv
      wcel vy cv cB wceq wa vj vy copab isumcmpi.4 fveq1i syl5eq mpdan 3brtr4d
      rgen vj cv cF cfv vj cv cG cfv cle wbr vk cv cF cfv vk cv cG cfv cle wbr
      vj vk cM cuz cfv vj cv cF cfv vj cv cG cfv cle wbr vk ax-17 vj vx vk cv
      cF cfv vk cv cG cfv cle vj vx vk cv cF vj vx cF vj cv cM cuz cfv wcel vy
      cv cA wceq wa vj vy copab isumcmpi.3 vj cv cM cuz cfv wcel vy cv cA wceq
      wa vj vy vx hbopab1 hbxfr vx cv vk cv wcel vj ax-17 hbfv vx cv cle wcel
      vj ax-17 vj vx vk cv cG vj vx cG vj cv cM cuz cfv wcel vy cv cB wceq wa
      vj vy copab isumcmpi.4 vj cv cM cuz cfv wcel vy cv cB wceq wa vj vy vx
      hbopab1 hbxfr vx cv vk cv wcel vj ax-17 hbfv hbbr vj cv vk cv wceq vj cv
      cF cfv vk cv cF cfv vj cv cG cfv vk cv cG cfv cle vj cv vk cv cF fveq2 vj
      cv vk cv cG fveq2 breq12d cbvral mpbi mpbir2an vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cv cF cfv cr wcel
      vk cv cG cfv cr wcel wa vk cv cF cfv vk cv cG cfv cle wbr wa vk cM cuz
      cfv vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv
      cle wbr df-3an ralbii mpbir cM cuz cfv cA vj csu cM cuz cfv cB vj csu vk
      cF cG cM cM cuz cfv cA vj sumex cM cuz cfv cB vj sumex vj vy cM cuz cfv
      cA cF cM cuz fvex isumcmpi.3 fopabex2 vj vy cM cuz cfv cB cG cM cuz fvex
      isumcmpi.4 fopabex2 iserzcmp mpanr2 expcom cM cz wcel cM caddc cop cF
      cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co cM cuz cfv cA vj
      csu cli wbr vx vy cA vj cF cM isumcmpi.1 isumcmpi.3 isumclim3 ex cM cz
      wcel cM caddc cop cG cseqz co vx cv cli wbr vx wex cM caddc cop cG cseqz
      co cM cuz cfv cB vj csu cli wbr vx vy cB vj cG cM isumcmpi.2 isumcmpi.4
      isumclim3 ex syl2and imp $.
      $( [13-Nov-2007] $) $( [13-Nov-2007] $)
  $}

  ${
    $d F k x $.  $d M k x $.  $d N k x $.
    isumsplit.1 $e |- M e. ZZ $.
    isumsplit.2 $e |- N e. ( ZZ>= ` M ) $.
    isumsplit.3 $e |- F : ( ZZ>= ` M ) --> CC $.
    isumsplit.4 $e |- E. x ( <. M , + >. seq F ) ~~> x $.
    $( Split off the first ` N ` terms of an infinite sum.  (Contributed by
       Paul Chapman, 9-Feb-2007.) $)
    isumspliti $p |- sum_ k e. ( ZZ>= ` M ) ( F ` k ) =
                    ( sum_ k e. ( M ... N ) ( F ` k ) +
                      sum_ k e. ( ZZ>= ` ( N + 1 ) ) ( F ` k ) ) $=
      cM cN cfz co vk cv cF cfv vk csu cN c1 caddc co cuz cfv vk cv cF cfv vk
      csu caddc co cM cuz cfv vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk
      csu cM cN cfz co vk cv cF cfv vk csu cmin co cN c1 caddc co cuz cfv vk cv
      cF cfv vk csu wceq cM cN cfz co vk cv cF cfv vk csu cN c1 caddc co cuz
      cfv vk cv cF cfv vk csu caddc co cM cuz cfv vk cv cF cfv vk csu wceq cN
      c1 caddc co cuz cfv vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu cM
      cN cfz co vk cv cF cfv vk csu cmin co cN c1 caddc co cz wcel cN c1 caddc
      co caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cM cN cfz co vk
      cv cF cfv vk csu cmin co cli wbr cN c1 caddc co cuz cfv vk cv cF cfv vk
      csu cM cuz cfv vk cv cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cmin
      co wceq cN cz wcel cN c1 caddc co cz wcel cN cz wcel cM cN cle wbr cN cM
      cuz cfv wcel cN cz wcel cM cN cle wbr wa isumsplit.2 cM cN isumsplit.1
      eluz1i mpbi pm3.26i cN peano2z ax-mp cN c1 caddc co caddc cop cF cseqz co
      cM cuz cfv vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv cmin co cM
      cuz cfv vk cv cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cmin co cli
      cN cM cuz cfv wcel cN c1 caddc co caddc cop cF cseqz co cM cuz cfv vk cv
      cF cfv vk csu cN cM caddc cop cF cseqz co cfv cmin co cli wbr isumsplit.2
      cM cuz cfv vk cv cF cfv vk csu cF cM cN cM cuz cfv cc cF wf cM cuz cfv
      cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex cM cuz cfv cc cvv cF fex
      mp2an cM cuz cfv vk cv cF cfv vk sumex cM cz wcel cM caddc cop cF cseqz
      co vx cv cli wbr vx wex cM caddc cop cF cseqz co cM cuz cfv vk cv cF cfv
      vk csu cli wbr isumsplit.1 isumsplit.4 vx vk cF cM cM cuz cfv cc cF wf cM
      cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex cM cuz cfv cc cvv cF
      fex mp2an isumclim2 mp2an isumsplit.3 clim2serzi ax-mp cM cN cfz co vk cv
      cF cfv vk csu cN cM caddc cop cF cseqz co cfv cM cuz cfv vk cv cF cfv vk
      csu cmin cN cM cuz cfv wcel cM cN cfz co vk cv cF cfv vk csu cN cM caddc
      cop cF cseqz co cfv wceq isumsplit.2 vk cF cM cN cM cuz cfv cc cF wf cM
      cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex cM cuz cfv cc cvv cF
      fex mp2an fsumserz ax-mp opreq2i breqtrri cM cuz cfv vk cv cF cfv vk csu
      cM cN cfz co vk cv cF cfv vk csu cmin co vk cF cN c1 caddc co cM cuz cfv
      cc cF wf cM cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex cM cuz
      cfv cc cvv cF fex mp2an cM cuz cfv vk cv cF cfv vk csu cM cN cfz co vk cv
      cF cfv vk csu cmin oprex isumclim mp2an eqcomi cM cuz cfv vk cv cF cfv vk
      csu cM cN cfz co vk cv cF cfv vk csu cN c1 caddc co cuz cfv vk cv cF cfv
      vk csu cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM cuz
      cfv vk cv cF cfv vk csu cc wcel isumsplit.1 isumsplit.4 vx vk cF cM cM
      cuz cfv cc cF wf cM cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex
      cM cuz cfv cc cvv cF fex mp2an isumcl mp2an cN cM cuz cfv wcel vk cv cF
      cfv cc wcel vk cM cN cfz co wral cM cN cfz co vk cv cF cfv vk csu cc wcel
      isumsplit.2 vk cv cF cfv cc wcel vk cM cN cfz co vk cv cM cN cfz co wcel
      vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cM cN elfzuz cM cuz cfv
      cc vk cv cF isumsplit.3 ffvelrni syl rgen vk cv cF cfv vk cM cN fsumcl
      mp2an cN c1 caddc co cz wcel cN c1 caddc co caddc cop cF cseqz co vx cv
      cli wbr vx wex cN c1 caddc co cuz cfv vk cv cF cfv vk csu cc wcel cN cz
      wcel cN c1 caddc co cz wcel cN cz wcel cM cN cle wbr cN cM cuz cfv wcel
      cN cz wcel cM cN cle wbr wa isumsplit.2 cM cN isumsplit.1 eluz1i mpbi
      pm3.26i cN peano2z ax-mp cN c1 caddc co caddc cop cF cseqz co cM cuz cfv
      vk cv cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cmin co cli wbr cN
      c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cN c1 caddc co
      caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cN cM caddc cop cF
      cseqz co cfv cmin co cM cuz cfv vk cv cF cfv vk csu cM cN cfz co vk cv cF
      cfv vk csu cmin co cli cN cM cuz cfv wcel cN c1 caddc co caddc cop cF
      cseqz co cM cuz cfv vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv
      cmin co cli wbr isumsplit.2 cM cuz cfv vk cv cF cfv vk csu cF cM cN cM
      cuz cfv cc cF wf cM cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex
      cM cuz cfv cc cvv cF fex mp2an cM cuz cfv vk cv cF cfv vk sumex cM cz
      wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz
      co cM cuz cfv vk cv cF cfv vk csu cli wbr isumsplit.1 isumsplit.4 vx vk
      cF cM cM cuz cfv cc cF wf cM cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM
      cuz fvex cM cuz cfv cc cvv cF fex mp2an isumclim2 mp2an isumsplit.3
      clim2serzi ax-mp cM cN cfz co vk cv cF cfv vk csu cN cM caddc cop cF
      cseqz co cfv cM cuz cfv vk cv cF cfv vk csu cmin cN cM cuz cfv wcel cM cN
      cfz co vk cv cF cfv vk csu cN cM caddc cop cF cseqz co cfv wceq
      isumsplit.2 vk cF cM cN cM cuz cfv cc cF wf cM cuz cfv cvv wcel cF cvv
      wcel isumsplit.3 cM cuz fvex cM cuz cfv cc cvv cF fex mp2an fsumserz
      ax-mp opreq2i breqtrri cN c1 caddc co caddc cop cF cseqz co vx cv cli wbr
      cN c1 caddc co caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cM cN
      cfz co vk cv cF cfv vk csu cmin co cli wbr vx cM cuz cfv vk cv cF cfv vk
      csu cM cN cfz co vk cv cF cfv vk csu cmin co cM cuz cfv vk cv cF cfv vk
      csu cM cN cfz co vk cv cF cfv vk csu cmin oprex vx cv cM cuz cfv vk cv cF
      cfv vk csu cM cN cfz co vk cv cF cfv vk csu cmin co cN c1 caddc co caddc
      cop cF cseqz co cli breq2 cla4ev ax-mp vx vk cF cN c1 caddc co cM cuz cfv
      cc cF wf cM cuz cfv cvv wcel cF cvv wcel isumsplit.3 cM cuz fvex cM cuz
      cfv cc cvv cF fex mp2an isumcl mp2an subaddi mpbi eqcomi $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d F k x $.  $d N k x $.
    isum0split.1 $e |- N e. NN0 $.
    isum0split.2 $e |- F : NN0 --> CC $.
    isum0split.3 $e |- E. x ( + seq0 F ) ~~> x $.
    $( Split off the first ` N ` terms of a 0-based infinite sum.
       (Contributed by Paul Chapman, 9-Feb-2007.) $)
    isum0spliti $p |- sum_ k e. NN0 ( F ` k ) =
                     ( sum_ k e. ( 0 ... N ) ( F ` k ) +
                       sum_ k e. ( ZZ>= ` ( N + 1 ) ) ( F ` k ) ) $=
      cn0 vk cv cF cfv vk csu cc0 cuz cfv vk cv cF cfv vk csu cc0 cN cfz co vk
      cv cF cfv vk csu cN c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co cn0
      cc0 cuz cfv vk cv cF cfv vk nn0uz sumeq1i vx vk cF cc0 cN 0z cN cn0 cc0
      cuz cfv isum0split.1 nn0uz eleqtri cn0 cc cF wf cc0 cuz cfv cc cF wf
      isum0split.2 cn0 cc0 cuz cfv wceq cn0 cc cF wf cc0 cuz cfv cc cF wf wb
      nn0uz cn0 cc0 cuz cfv cc cF feq2 ax-mp mpbi caddc cF cseq0 co vx cv cli
      wbr vx wex cc0 caddc cop cF cseqz co vx cv cli wbr vx wex isum0split.3
      caddc cF cseq0 co vx cv cli wbr cc0 caddc cop cF cseqz co vx cv cli wbr
      vx caddc cF cseq0 co cc0 caddc cop cF cseqz co vx cv cli caddc cF addex
      cn0 cc cF wf cn0 cvv wcel cF cvv wcel isum0split.2 nn0ex cn0 cc cvv cF
      fex mp2an seq0seqz breq1i exbii mpbi isumspliti eqtri $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

$(
  @{
    fsumisumt.1 @e |- F e. _V @.
    fsumisumt.2 @e |- A e. _V @.
    @( A finite sum of nonnegative numbers is less than its limit. @)
    fsumisumt @p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( ZZ>= ` M )
      ( ( F ` k ) e. RR /\ 0 <_ ( F ` k ) ) /\ ( <. M , + >. seq F ) ~~> A ) ->
                   sum_ k e. ( M ... N ) ( F ` k ) <_ A ) @=
      (  ) ? @.
      @( [ ?] @) @( [25-Dec-2005] @)
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Miscellaneous converging sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k x F $.
    reccnv.1 $e |- F e. _V $.
    $( The sequence of reciprocals of natural numbers converges to zero. $)
    reccnv $p |- ( A. k e. NN ( F ` k ) = ( 1 / k ) -> F ~~> 0 ) $=
      vk cv cF cfv c1 vk cv cdiv co wceq vk cn wral cF cc0 cli wbr cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex wi vx cr wral vk cv cF cfv c1 vk cv cdiv co wceq vk cn
      wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr vk cv cF cfv c1 vk cv cdiv co
      wceq vk cn wral vx cv cr wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vk cv cF cfv c1 vk
      cv cdiv co wceq vk cn wral vx cv cr wcel cc0 vx cv clt wbr wa wa c1 vj cv
      cdiv co vx cv clt wbr vj cn wrex vj cv vk cv cle wbr vk cv cF cfv cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex vx cv cr wcel cc0 vx cv clt
      wbr wa c1 vj cv cdiv co vx cv clt wbr vj cn wrex vk cv cF cfv c1 vk cv
      cdiv co wceq vk cn wral vx cv vj nnrecl adantl vk cv cF cfv c1 vk cv cdiv
      co wceq vk cn wral vx cv cr wcel cc0 vx cv clt wbr wa wa c1 vj cv cdiv co
      vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi
      vk cn wral vj cn vk cv cF cfv c1 vk cv cdiv co wceq vk cn wral vx cv cr
      wcel cc0 vx cv clt wbr wa vj cv cn wcel c1 vj cv cdiv co vx cv clt wbr vj
      cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral wi wi
      vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn wcel c1 vj cv cdiv co vx cv
      clt wbr vk cv cF cfv c1 vk cv cdiv co wceq vk cn wral vj cv vk cv cle wbr
      vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vx cv cr wcel cc0 vx cv
      clt wbr wa vj cv cn wcel c1 vj cv cdiv co vx cv clt wbr vk cv cF cfv c1
      vk cv cdiv co wceq vk cn wral vj cv vk cv cle wbr vk cv cF cfv cabs cfv
      vx cv clt wbr wi vk cn wral wi vx cv cr wcel cc0 vx cv clt wbr wa vj cv
      cn wcel c1 vj cv cdiv co vx cv clt wbr wa wa vk cv cF cfv c1 vk cv cdiv
      co wceq vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn
      vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn wcel c1 vj cv cdiv co vx cv
      clt wbr wa wa vk cv cn wcel wa vj cv vk cv cle wbr c1 vk cv cdiv co cabs
      cfv vx cv clt wbr vk cv cF cfv c1 vk cv cdiv co wceq vk cv cF cfv cabs
      cfv vx cv clt wbr vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn wcel c1 vj
      cv cdiv co vx cv clt wbr vk cv cn wcel vj cv vk cv cle wbr c1 vk cv cdiv
      co cabs cfv vx cv clt wbr wi vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn
      wcel c1 vj cv cdiv co vx cv clt wbr vk cv cn wcel vj cv vk cv cle wbr c1
      vk cv cdiv co cabs cfv vx cv clt wbr wi wi wi vx cv cr wcel cc0 vx cv clt
      wbr wa vj cv cn wcel wa vj cv vk cv cle wbr vk cv cn wcel c1 vj cv cdiv
      co vx cv clt wbr c1 vk cv cdiv co cabs cfv vx cv clt wbr vx cv cr wcel
      cc0 vx cv clt wbr wa vj cv cn wcel wa vk cv cn wcel vj cv vk cv cle wbr
      c1 vj cv cdiv co vx cv clt wbr c1 vk cv cdiv co cabs cfv vx cv clt wbr wi
      vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn wcel wa vk cv cn wcel vj cv
      vk cv cle wbr c1 vj cv cdiv co vx cv clt wbr c1 vk cv cdiv co cabs cfv vx
      cv clt wbr wi vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn wcel wa vk cv
      cn wcel wa vj cv vk cv cle wbr wa c1 vk cv cdiv co cabs cfv c1 vj cv cdiv
      co cle wbr c1 vj cv cdiv co vx cv clt wbr c1 vk cv cdiv co cabs cfv vx cv
      clt wbr vj cv cn wcel vk cv cn wcel vj cv vk cv cle wbr c1 vk cv cdiv co
      cabs cfv c1 vj cv cdiv co cle wbr vx cv cr wcel cc0 vx cv clt wbr wa vj
      cv cn wcel vk cv cn wcel wa vj cv vk cv cle wbr wa c1 vk cv cdiv co cabs
      cfv c1 vk cv cdiv co c1 vj cv cdiv co cle vk cv cn wcel c1 vk cv cdiv co
      cabs cfv c1 vk cv cdiv co wceq vj cv cn wcel vj cv vk cv cle wbr c1 vk cv
      cdiv co cr wcel cc0 c1 vk cv cdiv co cle wbr c1 vk cv cdiv co cabs cfv c1
      vk cv cdiv co wceq vk cv cn wcel c1 vk cv cdiv co absid vk cv nnrecre c1
      vk cv cdiv co cr wcel cc0 c1 vk cv cdiv co clt wbr cc0 c1 vk cv cdiv co
      cle wbr vk cv cn wcel cc0 cr wcel c1 vk cv cdiv co cr wcel cc0 c1 vk cv
      cdiv co clt wbr cc0 c1 vk cv cdiv co cle wbr wi 0re cc0 c1 vk cv cdiv co
      ltle mpan vk cv nnrecre vk cv nnrecgt0 sylc sylanc ad2antlr vj cv cn wcel
      vk cv cn wcel wa vj cv vk cv cle wbr c1 vk cv cdiv co c1 vj cv cdiv co
      cle wbr vj cv cr wcel cc0 vj cv clt wbr wa vk cv cr wcel cc0 vk cv clt
      wbr wa vj cv vk cv cle wbr c1 vk cv cdiv co c1 vj cv cdiv co cle wbr wb
      vj cv cn wcel vk cv cn wcel vj cv vk cv lerec vj cv cn wcel vj cv cr wcel
      cc0 vj cv clt wbr vj cv nnre vj cv nngt0 jca vk cv cn wcel vk cv cr wcel
      cc0 vk cv clt wbr vk cv nnre vk cv nngt0 jca syl2an biimpa eqbrtrd
      adantlll vx cv cr wcel cc0 vx cv clt wbr wa vj cv cn wcel wa vk cv cn
      wcel wa c1 vk cv cdiv co cabs cfv c1 vj cv cdiv co cle wbr c1 vj cv cdiv
      co vx cv clt wbr wa c1 vk cv cdiv co cabs cfv vx cv clt wbr wi vj cv vk
      cv cle wbr vx cv cr wcel vj cv cn wcel vk cv cn wcel c1 vk cv cdiv co
      cabs cfv c1 vj cv cdiv co cle wbr c1 vj cv cdiv co vx cv clt wbr wa c1 vk
      cv cdiv co cabs cfv vx cv clt wbr wi cc0 vx cv clt wbr c1 vk cv cdiv co
      cabs cfv cr wcel c1 vj cv cdiv co cr wcel vx cv cr wcel c1 vk cv cdiv co
      cabs cfv c1 vj cv cdiv co cle wbr c1 vj cv cdiv co vx cv clt wbr wa c1 vk
      cv cdiv co cabs cfv vx cv clt wbr wi vx cv cr wcel vj cv cn wcel wa vk cv
      cn wcel wa c1 vk cv cdiv co cabs cfv c1 vj cv cdiv co vx cv lelttr vk cv
      cn wcel c1 vk cv cdiv co cabs cfv cr wcel vx cv cr wcel vj cv cn wcel wa
      vk cv cn wcel c1 vk cv cdiv co cc wcel c1 vk cv cdiv co cabs cfv cr wcel
      vk cv cn wcel c1 vk cv cdiv co vk cv nnrecre recnd c1 vk cv cdiv co abscl
      syl adantl vj cv cn wcel c1 vj cv cdiv co cr wcel vx cv cr wcel vk cv cn
      wcel vj cv nnrecre ad2antlr vx cv cr wcel vj cv cn wcel vk cv cn wcel
      simpll syl3anc adantllr adantr mpand exp31 com23 com24 ex imp42 vk cv cF
      cfv c1 vk cv cdiv co wceq vk cv cF cfv cabs cfv vx cv clt wbr c1 vk cv
      cdiv co cabs cfv vx cv clt wbr vk cv cF cfv c1 vk cv cdiv co wceq vk cv
      cF cfv cabs cfv c1 vk cv cdiv co cabs cfv vx cv clt vk cv cF cfv c1 vk cv
      cdiv co cabs fveq2 breq1d biimprd syl9 r19.20dva exp32 com4r imp r19.22dv
      mpd exp32 r19.21aiv vk cv cF cfv c1 vk cv cdiv co wceq vk cn wral vk cv
      cF cfv cc wcel vk cn wral cF cc0 cli wbr cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi
      vx cr wral wb vk cv cF cfv c1 vk cv cdiv co wceq vk cv cF cfv cc wcel vk
      cn vk cv cF cfv c1 vk cv cdiv co wceq vk cv cF cfv cc wcel c1 vk cv cdiv
      co cc wcel vk cv cn wcel vk cv cF cfv c1 vk cv cdiv co cc eleq1 vk cv cn
      wcel c1 vk cv cdiv co vk cv nnrecre recnd syl5cbir r19.20i vx vj vk cF c1
      c1 cn cn 1z cn c1 cuz cfv nnuz eqimss2i nnssz 1z cn c1 cuz cfv nnuz
      eqimss2i nnssz reccnv.1 clm0i syl mpbird $.
      $( [6-Feb-2008] $) $( [6-Feb-2008] $)
  $}

  ${
    $d f u v x A $.  $d u x y B $.  $d y C $.  $d k F $.  $d k G $.  $d k H $.
    $d v w z R $.  $d f j k u v S $.  $d f k u v x y X $.  $d u x y Z $.
    infcvg.1 $e |- R = { x | E. y e. X x = -u A } $.
    infcvg.2 $e |- ( y e. X -> A e. RR ) $.
    infcvg.3 $e |- Z e. X $.
    infcvg.4 $e |- E. z e. RR A. w e. R w <_ z $.
    $( Auxilliary theorem for applications of ~ infcvgi .  Hypothesis for
       several supremum theorems. $)
    infcvgaux1i $p |- ( R C_ RR /\ R =/= (/)
           /\ E. z e. RR A. w e. R w <_ z ) $=
      cR cr wss cR c0 wne vw cv vz cv cle wbr vw cR wral vz cr wrex cR vx cv cA
      cneg wceq vy cX wrex vx cab cr infcvg.1 vx cv cA cneg wceq vy cX wrex vx
      cr vx cv cA cneg wceq vx cv cr wcel vy cX vx cv cA cneg wceq vx cv cr
      wcel cA cneg cr wcel vy cv cX wcel vx cv cA cneg cr eleq1 vy cv cX wcel
      cA cr wcel cA cneg cr wcel infcvg.2 cA renegcl syl syl5cbir r19.23aiv
      abssi eqsstri vy cZ cA csb cneg cR wcel cR c0 wne vy cZ cA csb cneg vx cv
      cA cneg wceq vy cX wrex vx cab cR vy cZ cA csb cneg vx cv cA cneg wceq vy
      cX wrex vx cab wcel vy cZ cA csb cneg cA cneg wceq vy cX wrex cZ cX wcel
      vy cZ cA csb cneg vy cZ cA csb cneg wceq vy cZ cA csb cneg cA cneg wceq
      vy cX wrex infcvg.3 vy cZ cA csb cneg eqid vy cZ cA csb cneg cA cneg wceq
      vy cZ cA csb cneg vy cZ cA csb cneg wceq vy cZ cX vy cZ cA csb cneg vy cZ
      cA csb cneg wceq vy vy cZ cA csb cneg eqid hbth vy cv cZ wceq cA cneg vy
      cZ cA csb cneg vy cZ cA csb cneg vy cv cZ wceq cA vy cZ cA csb vy cZ cA
      csbeq1a negeqd eqeq2d rcla4e mp2an vx cv cA cneg wceq vy cX wrex vy cZ cA
      csb cneg cA cneg wceq vy cX wrex vx vy cZ cA csb cneg vy cZ cA csb negex
      vx cv vy cZ cA csb cneg wceq vx cv cA cneg wceq vy cZ cA csb cneg cA cneg
      wceq vy cX vy vu vu vx cv vy cZ cA csb cneg vu cv vx cv wcel vy ax-17 vy
      vu vy cZ cA csb vy vu cZ cA cZ cX infcvg.3 elisseti vu cv cZ wcel vy
      ax-17 hbcsb1 hbneg hbeq vx cv vy cZ cA csb cneg cA cneg eqeq1 rexbid elab
      mpbir infcvg.1 eleqtrri cR vy cZ cA csb cneg ne0i ax-mp infcvg.4 3pm3.2i
      $.
      $( [29-Feb-2008] $) $( [8-Feb-2008] $)

    ${
      infcvg.5a $e |- S = -u sup ( R , RR , < ) $.
      infcvg.13 $e |- ( y = C -> A = B ) $.
      $( Auxilliary theorem for applications of ~ infcvgi . $)
      infcvgaux2i $p |- ( C e. X -> S <_ B ) $=
        cC cX wcel cR cr clt csup cneg cB cS cle cC cX wcel cB cneg cR cr clt
        csup cle wbr cR cr clt csup cneg cB cle wbr cC cX wcel cB cneg cR wcel
        cB cneg cR cr clt csup cle wbr cC cX wcel cB cneg cA cneg wceq vy cX
        wrex cB cneg cR wcel cC cX wcel cB cneg cB cneg wceq cB cneg cA cneg
        wceq vy cX wrex cB cneg eqid cB cneg cA cneg wceq cB cneg cB cneg wceq
        vy cC cX vy cv cC wceq cA cneg cB cneg cB cneg vy cv cC wceq cA cB
        infcvg.13 negeqd eqeq2d rcla4ev mpan2 vx cv cA cneg wceq vy cX wrex cB
        cneg cA cneg wceq vy cX wrex vx cB cneg cR cB negex vx cv cB cneg wceq
        vx cv cA cneg wceq cB cneg cA cneg wceq vy cX vx cv cB cneg cA cneg
        eqeq1 rexbidv infcvg.1 elab2 sylibr vz vw cR cB cneg vx vy vz vw cA cR
        cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvgaux1i suprubii syl cB
        cr wcel cR cr clt csup cr wcel cB cneg cR cr clt csup cle wbr cR cr clt
        csup cneg cB cle wbr wb cC cX wcel cB cR cr clt csup lenegcon1 cC cX
        wcel cB cr wcel vy cv cX wcel cA cr wcel wi cC cX wcel cB cr wcel wi vy
        cC cX vy cv cC wceq vy cv cX wcel cC cX wcel cA cr wcel cB cr wcel vy
        cv cC cX eleq1 vy cv cC wceq cA cB cr infcvg.13 eleq1d imbi12d infcvg.2
        vtoclg pm2.43i vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2
        infcvg.3 infcvg.4 infcvgaux1i suprclii sylancl mpbid infcvg.5a syl5eqbr
        $.
        $( [14-Mar-2008] $) $( [4-Mar-2008] $)
    $}

    ${
      $d y S $.
      infcvg.5b $e |- S = -u sup ( R , RR , < ) $.
      infcvg.14 $e |- ( y = ( f ` k ) -> A = B ) $.
      $( Lemma for ~ infcvgi .  Use ~ ac6s to show the existence of a sequence
         ` f ` with values extracted from ` R ` . $)
      infcvglem1 $p |- E. f ( f : NN --> X /\ A. k e. NN B <
                   ( S + ( 1 / k ) ) ) $=
        cA cS c1 vk cv cdiv co caddc co clt wbr vy cX wrex cn cX vf cv wf cB cS
        c1 vk cv cdiv co caddc co clt wbr vk cn wral wa vf wex vk cn cA cS c1
        vk cv cdiv co caddc co clt wbr cB cS c1 vk cv cdiv co caddc co clt wbr
        vk vy cn cX vf nnex vy cv vk cv vf cv cfv wceq cA cB cS c1 vk cv cdiv
        co caddc co clt infcvg.14 breq1d ac6s vk cv cn wcel cA cS c1 vk cv cdiv
        co caddc co clt wbr vy cX wrex cS c1 vk cv cdiv co caddc co cneg cA
        cneg clt wbr vy cX wrex vk cv cn wcel cS c1 vk cv cdiv co caddc co cneg
        vv cv clt wbr vv cR wrex cS c1 vk cv cdiv co caddc co cneg cA cneg clt
        wbr vy cX wrex cS c1 vk cv cdiv co caddc co cneg cr wcel cS c1 vk cv
        cdiv co caddc co cneg cR cr clt csup clt wbr cS c1 vk cv cdiv co caddc
        co cneg vv cv clt wbr vv cR wrex vk cv cn wcel vz vw vv cR cS c1 vk cv
        cdiv co caddc co cneg vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2
        infcvg.3 infcvg.4 infcvgaux1i suprlubii vk cv cn wcel cS c1 vk cv cdiv
        co caddc co cr wcel cS c1 vk cv cdiv co caddc co cneg cr wcel cS cr
        wcel c1 vk cv cdiv co cr wcel cS c1 vk cv cdiv co caddc co cr wcel vk
        cv cn wcel cS c1 vk cv cdiv co readdcl cS cR cr clt csup cneg cr
        infcvg.5b cR cr clt csup vz vw cR vx vy vz vw cA cR cX cZ infcvg.1
        infcvg.2 infcvg.3 infcvg.4 infcvgaux1i suprclii renegcli eqeltri vk cv
        nnrecre sylancr cS c1 vk cv cdiv co caddc co renegcl syl vk cv cn wcel
        cS c1 vk cv cdiv co caddc co cneg cS cneg cR cr clt csup clt vk cv cn
        wcel cS cS c1 vk cv cdiv co caddc co clt wbr cS c1 vk cv cdiv co caddc
        co cneg cS cneg clt wbr vk cv cn wcel cc0 c1 vk cv cdiv co clt wbr cS
        cS c1 vk cv cdiv co caddc co clt wbr vk cv nnrecgt0 c1 vk cv cdiv co cr
        wcel cS cr wcel cc0 c1 vk cv cdiv co clt wbr cS cS c1 vk cv cdiv co
        caddc co clt wbr wb vk cv cn wcel c1 vk cv cdiv co cS ltaddpos vk cv
        nnrecre cS cR cr clt csup cneg cr infcvg.5b cR cr clt csup vz vw cR vx
        vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvgaux1i
        suprclii renegcli eqeltri sylancl mpbid cS cr wcel cS c1 vk cv cdiv co
        caddc co cr wcel cS cS c1 vk cv cdiv co caddc co clt wbr cS c1 vk cv
        cdiv co caddc co cneg cS cneg clt wbr wb vk cv cn wcel cS cS c1 vk cv
        cdiv co caddc co ltneg cS cR cr clt csup cneg cr infcvg.5b cR cr clt
        csup vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3
        infcvg.4 infcvgaux1i suprclii renegcli eqeltri cS cr wcel c1 vk cv cdiv
        co cr wcel cS c1 vk cv cdiv co caddc co cr wcel vk cv cn wcel cS c1 vk
        cv cdiv co readdcl cS cR cr clt csup cneg cr infcvg.5b cR cr clt csup
        vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4
        infcvgaux1i suprclii renegcli eqeltri vk cv nnrecre sylancr sylancr
        mpbid cS cR cr clt csup cneg wceq cR cr clt csup cS cneg wceq infcvg.5b
        cS cR cr clt csup cS cS cR cr clt csup cneg cr infcvg.5b cR cr clt csup
        vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4
        infcvgaux1i suprclii renegcli eqeltri recni cR cr clt csup vz vw cR vx
        vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvgaux1i
        suprclii recni negcon2i mpbi syl6breqr sylanc cS c1 vk cv cdiv co caddc
        co cneg vv cv clt wbr vv cR wrex vv cv cA cneg wceq cS c1 vk cv cdiv co
        caddc co cneg cA cneg clt wbr wa vv wex vy cX wrex cS c1 vk cv cdiv co
        caddc co cneg cA cneg clt wbr vy cX wrex vv cv cR wcel cS c1 vk cv cdiv
        co caddc co cneg vv cv clt wbr wa vv wex vv cv cA cneg wceq cS c1 vk cv
        cdiv co caddc co cneg cA cneg clt wbr wa vy cX wrex vv wex cS c1 vk cv
        cdiv co caddc co cneg vv cv clt wbr vv cR wrex vv cv cA cneg wceq cS c1
        vk cv cdiv co caddc co cneg cA cneg clt wbr wa vv wex vy cX wrex vv cv
        cR wcel cS c1 vk cv cdiv co caddc co cneg vv cv clt wbr wa vv cv cA
        cneg wceq cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr wa vy cX
        wrex vv vv cv cR wcel cS c1 vk cv cdiv co caddc co cneg vv cv clt wbr
        wa vv cv cA cneg wceq vy cX wrex cS c1 vk cv cdiv co caddc co cneg vv
        cv clt wbr wa vv cv cA cneg wceq cS c1 vk cv cdiv co caddc co cneg vv
        cv clt wbr wa vy cX wrex vv cv cA cneg wceq cS c1 vk cv cdiv co caddc
        co cneg cA cneg clt wbr wa vy cX wrex vv cv cR wcel vv cv cA cneg wceq
        vy cX wrex cS c1 vk cv cdiv co caddc co cneg vv cv clt wbr vx cv cA
        cneg wceq vy cX wrex vv cv cA cneg wceq vy cX wrex vx vv cv cR vv
        visset vx cv vv cv wceq vx cv cA cneg wceq vv cv cA cneg wceq vy cX vx
        cv vv cv cA cneg eqeq1 rexbidv infcvg.1 elab2 anbi1i vv cv cA cneg wceq
        cS c1 vk cv cdiv co caddc co cneg vv cv clt wbr vy cX r19.41v vv cv cA
        cneg wceq cS c1 vk cv cdiv co caddc co cneg vv cv clt wbr wa vv cv cA
        cneg wceq cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr wa vy cX vv
        cv cA cneg wceq cS c1 vk cv cdiv co caddc co cneg vv cv clt wbr cS c1
        vk cv cdiv co caddc co cneg cA cneg clt wbr vv cv cA cneg cS c1 vk cv
        cdiv co caddc co cneg clt breq2 pm5.32i rexbii 3bitr2i exbii cS c1 vk
        cv cdiv co caddc co cneg vv cv clt wbr vv cR df-rex vv cv cA cneg wceq
        cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr wa vy vv cX rexcom4
        3bitr4i cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr vv cv cA cneg
        wceq cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr wa vv wex vy cX
        cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr vv cv cA cneg wceq vv
        wex cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr wa vv cv cA cneg
        wceq cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr wa vv wex vv cv
        cA cneg wceq vv wex cS c1 vk cv cdiv co caddc co cneg cA cneg clt wbr
        vv cA cneg cA negex isseti biantrur vv cv cA cneg wceq cS c1 vk cv cdiv
        co caddc co cneg cA cneg clt wbr vv 19.41v bitr4i rexbii bitr4i sylib
        vk cv cn wcel cA cS c1 vk cv cdiv co caddc co clt wbr cS c1 vk cv cdiv
        co caddc co cneg cA cneg clt wbr vy cX vy cv cX wcel vk cv cn wcel cA
        cS c1 vk cv cdiv co caddc co clt wbr cS c1 vk cv cdiv co caddc co cneg
        cA cneg clt wbr wb cA cr wcel cS c1 vk cv cdiv co caddc co cr wcel cA
        cS c1 vk cv cdiv co caddc co clt wbr cS c1 vk cv cdiv co caddc co cneg
        cA cneg clt wbr wb vy cv cX wcel vk cv cn wcel cA cS c1 vk cv cdiv co
        caddc co ltneg infcvg.2 cS cr wcel c1 vk cv cdiv co cr wcel cS c1 vk cv
        cdiv co caddc co cr wcel vk cv cn wcel cS c1 vk cv cdiv co readdcl cS
        cR cr clt csup cneg cr infcvg.5b cR cr clt csup vz vw cR vx vy vz vw cA
        cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvgaux1i suprclii
        renegcli eqeltri vk cv nnrecre sylancr syl2an ancoms rexbidva mpbird
        mprg $.
        $( [14-Mar-2008] $) $( [5-Mar-2008] $)
    $}

    ${
      infcvg.5c $e |- S = -u sup ( R , RR , < ) $.
      infcvg.9 $e |- G e. _V $.
      infcvg.10 $e |- ( k e. NN -> ( G ` k ) = ( S + ( 1 / k ) ) ) $.
      infcvg.11 $e |- H e. _V $.
      infcvg.12 $e |- ( k e. NN -> ( H ` k ) = ( 1 / k ) ) $.
      $( Lemma for ~ infcvgi .  Show that ` G ` converges to the infimum. $)
      infcvglem2 $p |- G ~~> S $=
        cG cS cc0 caddc co cS cli cH cc0 cli wbr cS cc wcel wa c1 cz wcel vk cv
        cH cfv cc wcel vk cv cG cfv cS vk cv cH cfv caddc co wceq wa vk c1 cuz
        cfv wral wa cG cS cc0 caddc co cli wbr cH cc0 cli wbr cS cc wcel vk cv
        cH cfv c1 vk cv cdiv co wceq cH cc0 cli wbr vk cn vk cH infcvg.11
        reccnv infcvg.12 mprg cS cS cR cr clt csup cneg cr infcvg.5c cR cr clt
        csup vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3
        infcvg.4 infcvgaux1i suprclii renegcli eqeltri recni pm3.2i c1 cz wcel
        vk cv cH cfv cc wcel vk cv cG cfv cS vk cv cH cfv caddc co wceq wa vk
        c1 cuz cfv wral 1z vk cv cH cfv cc wcel vk cv cG cfv cS vk cv cH cfv
        caddc co wceq wa vk c1 cuz cfv vk cv c1 cuz cfv wcel vk cv cn wcel vk
        cv cH cfv cc wcel vk cv cG cfv cS vk cv cH cfv caddc co wceq wa vk cv
        elnnuz vk cv cn wcel vk cv cH cfv cc wcel vk cv cG cfv cS vk cv cH cfv
        caddc co wceq vk cv cn wcel vk cv cH cfv c1 vk cv cdiv co cc infcvg.12
        vk cv cn wcel c1 vk cv cdiv co vk cv nnrecre recnd eqeltrd vk cv cn
        wcel vk cv cG cfv cS c1 vk cv cdiv co caddc co cS vk cv cH cfv caddc co
        infcvg.10 vk cv cn wcel vk cv cH cfv c1 vk cv cdiv co cS caddc
        infcvg.12 opreq2d eqtr4d jca sylbir rgen pm3.2i cc0 cS vk cH cG c1
        infcvg.11 infcvg.9 cc0 cc 0cn elisseti cS cr cS cR cr clt csup cneg cr
        infcvg.5c cR cr clt csup vz vw cR vx vy vz vw cA cR cX cZ infcvg.1
        infcvg.2 infcvg.3 infcvg.4 infcvgaux1i suprclii renegcli eqeltri
        elisseti climaddc2 mp2an cS cS cS cR cr clt csup cneg cr infcvg.5c cR
        cr clt csup vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3
        infcvg.4 infcvgaux1i suprclii renegcli eqeltri recni addid1i breqtri $.
        $( [14-Mar-2008] $) $( [6-Feb-2008] $)

      ${
        $d y S $.
        infcvg.6a $e |- F e. _V $.
        infcvg.7a $e |- ( y = ( f ` k ) -> A = B ) $.
        infcvg.8a $e |- ( k e. NN -> ( F ` k ) = B ) $.
        $( Lemma for ~ infcvgi .  Using ~ climsqueeze , show that sequence
           ` F ` , constructed from ` f ` , converges to the supremum. $)
        infcvglem3 $p |- E. f ( f : NN --> X /\ F ~~> S ) $=
          cn cX vf cv wf cB cS c1 vk cv cdiv co caddc co clt wbr vk cn wral wa
          vf wex cn cX vf cv wf cF cS cli wbr wa vf wex vx vy vz vw cA cB cR cS
          vf vk cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvg.5c infcvg.7a
          infcvglem1 cn cX vf cv wf cB cS c1 vk cv cdiv co caddc co clt wbr vk
          cn wral wa cn cX vf cv wf cF cS cli wbr wa vf cn cX vf cv wf cB cS c1
          vk cv cdiv co caddc co clt wbr vk cn wral wa cn cX vf cv wf cF cS cli
          wbr cn cX vf cv wf cB cS c1 vk cv cdiv co caddc co clt wbr vk cn wral
          pm3.26 cn cX vf cv wf cB cS c1 vk cv cdiv co caddc co clt wbr vk cn
          wral wa vk cv cG cfv cr wcel vk cv cF cfv cr wcel wa cS vk cv cF cfv
          cle wbr vk cv cF cfv vk cv cG cfv cle wbr wa wa vk c1 cuz cfv wral cF
          cS cli wbr cn cX vf cv wf cB cS c1 vk cv cdiv co caddc co clt wbr vk
          cn wral wa vk cv cG cfv cr wcel vk cv cF cfv cr wcel wa cS vk cv cF
          cfv cle wbr vk cv cF cfv vk cv cG cfv cle wbr wa wa vk cn wral vk cv
          cG cfv cr wcel vk cv cF cfv cr wcel wa cS vk cv cF cfv cle wbr vk cv
          cF cfv vk cv cG cfv cle wbr wa wa vk c1 cuz cfv wral cn cX vf cv wf
          cB cS c1 vk cv cdiv co caddc co clt wbr vk cn wral vk cv cG cfv cr
          wcel vk cv cF cfv cr wcel wa cS vk cv cF cfv cle wbr vk cv cF cfv vk
          cv cG cfv cle wbr wa wa vk cn wral cn cX vf cv wf cB cS c1 vk cv cdiv
          co caddc co clt wbr vk cv cG cfv cr wcel vk cv cF cfv cr wcel wa cS
          vk cv cF cfv cle wbr vk cv cF cfv vk cv cG cfv cle wbr wa wa vk cn cn
          cX vf cv wf vk cv cn wcel wa cB cS c1 vk cv cdiv co caddc co clt wbr
          vk cv cF cfv vk cv cG cfv cle wbr vk cv cG cfv cr wcel vk cv cF cfv
          cr wcel wa cS vk cv cF cfv cle wbr vk cv cF cfv vk cv cG cfv cle wbr
          wa wa cn cX vf cv wf vk cv cn wcel wa cB cS c1 vk cv cdiv co caddc co
          clt wbr vk cv cF cfv vk cv cG cfv clt wbr vk cv cF cfv vk cv cG cfv
          cle wbr vk cv cn wcel vk cv cF cfv vk cv cG cfv clt wbr cB cS c1 vk
          cv cdiv co caddc co clt wbr wb cn cX vf cv wf vk cv cn wcel vk cv cF
          cfv cB vk cv cG cfv cS c1 vk cv cdiv co caddc co clt infcvg.8a
          infcvg.10 breq12d adantl vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk
          cv cF cfv vk cv cG cfv clt wbr vk cv cF cfv vk cv cG cfv cle wbr wi
          cn cX vf cv wf vk cv cn wcel wa vk cv cF cfv vk cv cG cfv ltle cn cX
          vf cv wf vk cv cn wcel wa vk cv cF cfv cB cr vk cv cn wcel vk cv cF
          cfv cB wceq cn cX vf cv wf infcvg.8a adantl cn cX vf cv wf vk cv cn
          wcel wa vk cv vf cv cfv cX wcel cB cr wcel cn cX vk cv vf cv ffvelrn
          cA cr wcel cB cr wcel vy vk cv vf cv cfv cX vy cv vk cv vf cv cfv
          wceq cA cB cr infcvg.7a eleq1d infcvg.2 vtoclga syl eqeltrd vk cv cn
          wcel vk cv cG cfv cr wcel cn cX vf cv wf vk cv cn wcel vk cv cG cfv
          cS c1 vk cv cdiv co caddc co cr infcvg.10 cS cr wcel c1 vk cv cdiv co
          cr wcel cS c1 vk cv cdiv co caddc co cr wcel vk cv cn wcel cS c1 vk
          cv cdiv co readdcl cS cR cr clt csup cneg cr infcvg.5c cR cr clt csup
          vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4
          infcvgaux1i suprclii renegcli eqeltri vk cv nnrecre sylancr eqeltrd
          adantl sylanc sylbird cn cX vf cv wf vk cv cn wcel wa vk cv cF cfv vk
          cv cG cfv cle wbr cS vk cv cF cfv cle wbr vk cv cF cfv vk cv cG cfv
          cle wbr wa vk cv cG cfv cr wcel vk cv cF cfv cr wcel wa cn cX vf cv
          wf vk cv cn wcel wa vk cv cF cfv vk cv cG cfv cle wbr cS vk cv cF cfv
          cle wbr cn cX vf cv wf vk cv cn wcel wa cS vk cv cF cfv cle wbr vk cv
          cF cfv vk cv cG cfv cle wbr cn cX vf cv wf vk cv cn wcel wa cS cB vk
          cv cF cfv cle cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cX wcel
          cS cB cle wbr cn cX vk cv vf cv ffvelrn vx vy vz vw cA cB vk cv vf cv
          cfv cR cS cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvg.5c
          infcvg.7a infcvgaux2i syl vk cv cn wcel vk cv cF cfv cB wceq cn cX vf
          cv wf infcvg.8a adantl breqtrrd a1d ancrd cn cX vf cv wf vk cv cn
          wcel wa vk cv cG cfv cr wcel vk cv cF cfv cr wcel vk cv cn wcel vk cv
          cG cfv cr wcel cn cX vf cv wf vk cv cn wcel vk cv cG cfv cS c1 vk cv
          cdiv co caddc co cr infcvg.10 cS cr wcel c1 vk cv cdiv co cr wcel cS
          c1 vk cv cdiv co caddc co cr wcel vk cv cn wcel cS c1 vk cv cdiv co
          readdcl cS cR cr clt csup cneg cr infcvg.5c cR cr clt csup vz vw cR
          vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4
          infcvgaux1i suprclii renegcli eqeltri vk cv nnrecre sylancr eqeltrd
          adantl cn cX vf cv wf vk cv cn wcel wa vk cv cF cfv cB cr vk cv cn
          wcel vk cv cF cfv cB wceq cn cX vf cv wf infcvg.8a adantl cn cX vf cv
          wf vk cv cn wcel wa vk cv vf cv cfv cX wcel cB cr wcel cn cX vk cv vf
          cv ffvelrn cA cr wcel cB cr wcel vy vk cv vf cv cfv cX vy cv vk cv vf
          cv cfv wceq cA cB cr infcvg.7a eleq1d infcvg.2 vtoclga syl eqeltrd
          jca jctild syld r19.20dva imp cn c1 cuz cfv wceq vk cv cG cfv cr wcel
          vk cv cF cfv cr wcel wa cS vk cv cF cfv cle wbr vk cv cF cfv vk cv cG
          cfv cle wbr wa wa vk cn wral vk cv cG cfv cr wcel vk cv cF cfv cr
          wcel wa cS vk cv cF cfv cle wbr vk cv cF cfv vk cv cG cfv cle wbr wa
          wa vk c1 cuz cfv wral wb nnuz vk cv cG cfv cr wcel vk cv cF cfv cr
          wcel wa cS vk cv cF cfv cle wbr vk cv cF cfv vk cv cG cfv cle wbr wa
          wa vk cn c1 cuz cfv raleq1 ax-mp sylib cG cS cli wbr c1 cz wcel vk cv
          cG cfv cr wcel vk cv cF cfv cr wcel wa cS vk cv cF cfv cle wbr vk cv
          cF cfv vk cv cG cfv cle wbr wa wa vk c1 cuz cfv wral cF cS cli wbr vx
          vy vz vw cA cR cS vk cG cH cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4
          infcvg.5c infcvg.9 infcvg.10 infcvg.11 infcvg.12 infcvglem2 1z cS vk
          cG cF c1 infcvg.9 infcvg.6a cS cr cS cR cr clt csup cneg cr infcvg.5c
          cR cr clt csup vz vw cR vx vy vz vw cA cR cX cZ infcvg.1 infcvg.2
          infcvg.3 infcvg.4 infcvgaux1i suprclii renegcli eqeltri elisseti
          climsqueeze2 mp3an12 syl jca 19.22i ax-mp $.
          $( [14-Mar-2008] $) $( [2-Mar-2008] $)
      $}
    $}

    ${
      $d y S $.
      infcvgi.5 $e |- S = -u sup ( R , RR , < ) $.
      infcvgi.6 $e |- F e. _V $.
      infcvgi.7 $e |- ( y = ( f ` k ) -> A = B ) $.
      infcvgi.8 $e |- ( k e. NN -> ( F ` k ) = B ) $.
      $( Extract a sequence that converges to the infimum ` S ` of a set of
         reals ` A ( y ) ` .  The sequence ` F ` is built using values of a
         sequence ` f ` that converges when its values are mapped to reals via
         ` A ( y ) ` .  Equation 4 of [Kreyszig] p. 144. $)
      infcvgi $p |- E. f ( f : NN --> X /\ F ~~> S ) $=
        vx vy vz vw cA cB cR cS vf vk cF vj cv cn wcel vv cv cS c1 vj cv cdiv
        co caddc co wceq wa vj vv copab vj cv cn wcel vv cv c1 vj cv cdiv co
        wceq wa vj vv copab cX cZ infcvg.1 infcvg.2 infcvg.3 infcvg.4 infcvgi.5
        vj vv cn cS c1 vj cv cdiv co caddc co nnex opabex2 vj vv vk cv cS c1 vj
        cv cdiv co caddc co cS c1 vk cv cdiv co caddc co cn vj cv cn wcel vv cv
        cS c1 vj cv cdiv co caddc co wceq wa vj vv copab vj cv vk cv wceq c1 vj
        cv cdiv co c1 vk cv cdiv co cS caddc vj cv vk cv c1 cdiv opreq2 opreq2d
        vj cv cn wcel vv cv cS c1 vj cv cdiv co caddc co wceq wa vj vv copab
        eqid cS c1 vk cv cdiv co caddc oprex fvopab4 vj vv cn c1 vj cv cdiv co
        nnex opabex2 vj vv vk cv c1 vj cv cdiv co c1 vk cv cdiv co cn vj cv cn
        wcel vv cv c1 vj cv cdiv co wceq wa vj vv copab vj cv vk cv c1 cdiv
        opreq2 vj cv cn wcel vv cv c1 vj cv cdiv co wceq wa vj vv copab eqid c1
        vk cv cdiv oprex fvopab4 infcvgi.6 infcvgi.7 infcvgi.8 infcvglem3 $.
        $( [14-Mar-2008] $) $( [2-Mar-2008] $)
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Arithmetic series
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d N j $.  $d N k $.  $d j k $.
    arisumilem.1 $e |- N e. NN $.
    $( Lemma for ~ arisumi . $)
    arisumilem $p |- sum_ j e. ( 0 ... N ) ( ( j + 1 ) ^ 2 ) =
         sum_ k e. ( 1 ... ( N + 1 ) ) ( k ^ 2 ) $=
      cc0 cN cfz co vj cv c1 caddc co c2 cexp co vj csu cc0 c1 caddc co cN c1
      caddc co cfz co vj vk cv c1 cmin co vj cv c1 caddc co c2 cexp co csb vk
      csu c1 cN c1 caddc co cfz co vk cv c2 cexp co vk csu cN cc0 cuz cfv wcel
      c1 cz wcel vj cv c1 caddc co c2 cexp co cc wcel vj cc0 cN cfz co wral cc0
      cN cfz co vj cv c1 caddc co c2 cexp co vj csu cc0 c1 caddc co cN c1 caddc
      co cfz co vj vk cv c1 cmin co vj cv c1 caddc co c2 cexp co csb vk csu
      wceq cN cn0 wcel cN cc0 cuz cfv wcel cN arisumilem.1 nnnn0i cN elnn0uz
      mpbi 1z vj cv c1 caddc co c2 cexp co cc wcel vj cc0 cN cfz co vj cv cc0
      cN cfz co wcel vj cv cc wcel vj cv c1 caddc co cc wcel vj cv c1 caddc co
      c2 cexp co cc wcel vj cv cc0 cN cfz co wcel vj cv cz wcel vj cv cc wcel
      vj cv cc0 cN elfzelz vj cv zcn syl vj cv peano2cn vj cv c1 caddc co sqcl
      3syl rgen vj cv c1 caddc co c2 cexp co vj vk c1 cc0 cN fsumshft mp3an cc0
      c1 caddc co cN c1 caddc co cfz co c1 cN c1 caddc co cfz co vj vk cv c1
      cmin co vj cv c1 caddc co c2 cexp co csb vk cv c2 cexp co vk cc0 c1 caddc
      co c1 cN c1 caddc co cfz c1 ax1cn addid2i opreq1i vk cv cc0 c1 caddc co
      cN c1 caddc co cfz co wcel vj vk cv c1 cmin co vj cv c1 caddc co c2 cexp
      co csb vj vk cv c1 cmin co vj cv c1 caddc co csb c2 cexp co vk cv c2 cexp
      co vk cv cc0 c1 caddc co cN c1 caddc co cfz co wcel vk cv cz wcel vk cv
      c1 cmin co cq wcel vj vk cv c1 cmin co vj cv c1 caddc co c2 cexp co csb
      vj vk cv c1 cmin co vj cv c1 caddc co csb c2 cexp co wceq vk cv cc0 c1
      caddc co cN c1 caddc co elfzelz vk cv cq wcel c1 cq wcel vk cv c1 cmin co
      cq wcel vk cv cz wcel vk cv c1 qsubcl vk cv zq c1 cz wcel c1 cq wcel 1z
      c1 zq ax-mp sylancl vj vk cv c1 cmin co vj cv c1 caddc co c2 cq cexp
      csbopr1g 3syl vk cv cc0 c1 caddc co cN c1 caddc co cfz co wcel vj vk cv
      c1 cmin co vj cv c1 caddc co csb vk cv c2 cexp vk cv cc0 c1 caddc co cN
      c1 caddc co cfz co wcel vj vk cv c1 cmin co vj cv c1 caddc co csb vj vk
      cv c1 cmin co vj cv csb c1 caddc co vk cv c1 cmin co c1 caddc co vk cv vk
      cv cc0 c1 caddc co cN c1 caddc co cfz co wcel vk cv cq wcel c1 cq wcel wa
      vk cv c1 cmin co cq wcel vj vk cv c1 cmin co vj cv c1 caddc co csb vj vk
      cv c1 cmin co vj cv csb c1 caddc co wceq vk cv cc0 c1 caddc co cN c1
      caddc co cfz co wcel vk cv cq wcel c1 cq wcel vk cv cc0 c1 caddc co cN c1
      caddc co cfz co wcel vk cv cz wcel vk cv cq wcel vk cv cc0 c1 caddc co cN
      c1 caddc co elfzelz vk cv zq syl c1 cz wcel c1 cq wcel 1z c1 zq ax-mp
      jctir vk cv c1 qsubcl vj vk cv c1 cmin co vj cv c1 cq caddc csbopr1g 3syl
      vk cv cc0 c1 caddc co cN c1 caddc co cfz co wcel vj vk cv c1 cmin co vj
      cv csb vk cv c1 cmin co c1 caddc vk cv cc0 c1 caddc co cN c1 caddc co cfz
      co wcel vk cv cz wcel vk cv c1 cmin co cq wcel vj vk cv c1 cmin co vj cv
      csb vk cv c1 cmin co wceq vk cv cc0 c1 caddc co cN c1 caddc co elfzelz vk
      cv cq wcel c1 cq wcel vk cv c1 cmin co cq wcel vk cv cz wcel vk cv c1
      qsubcl vk cv zq c1 cz wcel c1 cq wcel 1z c1 zq ax-mp sylancl vj vk cv c1
      cmin co cq csbvarg 3syl opreq1d vk cv cc wcel c1 cc wcel vk cv c1 cmin co
      c1 caddc co vk cv wceq vk cv cc0 c1 caddc co cN c1 caddc co cfz co wcel
      vk cv c1 npcan vk cv cc0 c1 caddc co cN c1 caddc co cfz co wcel vk cv cz
      wcel vk cv cc wcel vk cv cc0 c1 caddc co cN c1 caddc co elfzelz vk cv zcn
      syl ax1cn sylancl 3eqtrd opreq1d eqtrd sumeq12i eqtri $.
      $( [10-Dec-2006] $) $( [9-Dec-2006] $)
  $}

  ${
    $d N k x j $.
    arisumi.1 $e |- N e. NN $.
    $( Arithmetic series sum of the first ` ( N + 1 ) ` non-negative integers.
       (Contributed by FL, 10-Dec-2006.) $)
    arisumi $p |- sum_ k e. ( 0 ... N ) k = ( ( ( ( N + 1 ) ^ 2 ) -
       ( N + 1 ) ) / 2 ) $=
      cN c1 caddc co c2 cexp co cN c1 caddc co cmin co c2 cdiv co cc0 cN cfz co
      vk cv vk csu cN c1 caddc co c2 cexp co cN c1 caddc co cmin co c2 cdiv co
      cc0 cN cfz co vk cv vk csu wceq c2 cc0 cN cfz co vk cv vk csu cmul co cN
      c1 caddc co c2 cexp co cN c1 caddc co cmin co wceq cN c1 caddc co c2 cexp
      co cN c1 caddc co cmin co c2 cc0 cN cfz co vk cv vk csu cmul co cN c1
      caddc co c2 cexp co cN c1 caddc co cmin co c2 cc0 cN cfz co vk cv vk csu
      cmul co wceq c2 cc0 cN cfz co vk cv vk csu cmul co cN c1 caddc co caddc
      co cN c1 caddc co c2 cexp co wceq c2 cc0 cN cfz co vk cv vk csu cmul co
      cN c1 caddc co caddc co c2 cc0 cN cfz co vk cv vk csu cmul co cc0 cN cfz
      co c1 vk csu caddc co cc0 cN cfz co c2 vk cv cmul co vk csu cc0 cN cfz co
      c1 vk csu caddc co cN c1 caddc co c2 cexp co cN c1 caddc co cc0 cN cfz co
      c1 vk csu c2 cc0 cN cfz co vk cv vk csu cmul co caddc cc0 cN cfz co c1 vk
      csu cN cc0 cmin co c1 caddc co c1 cmul co cN cc0 cmin co c1 caddc co cN
      c1 caddc co cN cc0 cuz cfv wcel c1 cc wcel cc0 cN cfz co c1 vk csu cN cc0
      cmin co c1 caddc co c1 cmul co wceq cN cn0 wcel cN cc0 cuz cfv wcel cN
      arisumi.1 nnnn0i cN elnn0uz mpbi ax1cn c1 vk cc0 cN fsumconst mp2an cN
      cc0 cmin co c1 caddc co cN cc0 cmin co c1 cN cc0 cN arisumi.1 nncni 0cn
      subcli ax1cn addcli mulid1i cN cc0 cmin co cN c1 caddc cN cN arisumi.1
      nncni subid1i opreq1i 3eqtrri opreq2i c2 cc0 cN cfz co vk cv vk csu cmul
      co cc0 cN cfz co c2 vk cv cmul co vk csu cc0 cN cfz co c1 vk csu caddc cN
      cc0 cuz cfv wcel c2 cc wcel vk cv cc wcel vk cc0 cN cfz co wral c2 cc0 cN
      cfz co vk cv vk csu cmul co cc0 cN cfz co c2 vk cv cmul co vk csu wceq cN
      cn0 wcel cN cc0 cuz cfv wcel cN arisumi.1 nnnn0i cN elnn0uz mpbi 2cn vk
      cv cc wcel vk cc0 cN cfz co vk cv cc0 cN cfz co wcel vk cv cz wcel vk cv
      cc wcel vk cv cc0 cN elfzelz vk cv zcn syl rgen vk cv c2 vk cc0 cN
      fsummulc1 mp3an opreq1i cc0 cN c1 caddc co cfz co vk cv c2 cexp co vk csu
      cc0 cN cfz co vk cv c2 cexp co vk csu cmin co cc0 cN cfz co c2 vk cv cmul
      co vk csu cc0 cN cfz co c1 vk csu caddc co cN c1 caddc co c2 cexp co cc0
      cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc0 cN cfz co vk cv c2 cexp
      co vk csu cc0 cN cfz co c2 vk cv cmul co vk csu cc0 cN cfz co c1 vk csu
      caddc co cN c1 caddc co cn0 wcel vk cv c2 cexp co cc wcel vk cc0 cN c1
      caddc co cfz co wral cc0 cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc
      wcel cN c1 caddc co cN cn wcel cN c1 caddc co cn wcel arisumi.1 cN
      peano2nn ax-mp nnnn0i vk cv c2 cexp co cc wcel vk cc0 cN c1 caddc co cfz
      co vk cv cc0 cN c1 caddc co cfz co wcel vk cv cn0 wcel vk cv cc wcel vk
      cv c2 cexp co cc wcel vk cv cN c1 caddc co elfznn0 vk cv nn0cn vk cv sqcl
      3syl rgen vk cv c2 cexp co vk cN c1 caddc co fsum0cl mp2an cN cn0 wcel vk
      cv c2 cexp co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co vk cv c2 cexp
      co vk csu cc wcel cN arisumi.1 nnnn0i vk cv c2 cexp co cc wcel vk cc0 cN
      cfz co vk cv cc0 cN cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv c2
      cexp co cc wcel vk cv cN elfznn0 vk cv nn0cn vk cv sqcl 3syl rgen vk cv
      c2 cexp co vk cN fsum0cl mp2an cc0 cN cfz co c2 vk cv cmul co vk csu cc0
      cN cfz co c1 vk csu cN cn0 wcel c2 vk cv cmul co cc wcel vk cc0 cN cfz co
      wral cc0 cN cfz co c2 vk cv cmul co vk csu cc wcel cN arisumi.1 nnnn0i c2
      vk cv cmul co cc wcel vk cc0 cN cfz co c2 cc wcel vk cv cc wcel c2 vk cv
      cmul co cc wcel vk cv cc0 cN cfz co wcel c2 vk cv mulcl 2cn vk cv cc0 cN
      cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv cN elfznn0 vk cv nn0cn syl
      sylancr rgen c2 vk cv cmul co vk cN fsum0cl mp2an cN cn0 wcel c1 cc wcel
      vk cc0 cN cfz co wral cc0 cN cfz co c1 vk csu cc wcel cN arisumi.1 nnnn0i
      c1 cc wcel vk cc0 cN cfz co c1 cc wcel vk cv cc0 cN cfz co wcel ax1cn a1i
      rgen c1 vk cN fsum0cl mp2an addcli cc0 cN cfz co vk cv c1 caddc co c2
      cexp co vk csu cc0 cN cfz co vk cv c2 cexp co vk csu cc0 cN cfz co c2 vk
      cv cmul co vk csu caddc co cc0 cN cfz co c1 vk csu caddc co cc0 cN c1
      caddc co cfz co vk cv c2 cexp co vk csu cc0 cN cfz co vk cv c2 cexp co vk
      csu cc0 cN cfz co c2 vk cv cmul co vk csu cc0 cN cfz co c1 vk csu caddc
      co caddc co cc0 cN cfz co vk cv c1 caddc co c2 cexp co vk csu cc0 cN cfz
      co vk cv c2 cexp co c2 vk cv cmul co caddc co c1 caddc co vk csu cc0 cN
      cfz co vk cv c2 cexp co c2 vk cv cmul co caddc co vk csu cc0 cN cfz co c1
      vk csu caddc co cc0 cN cfz co vk cv c2 cexp co vk csu cc0 cN cfz co c2 vk
      cv cmul co vk csu caddc co cc0 cN cfz co c1 vk csu caddc co cc0 cN cfz co
      vk cv c1 caddc co c2 cexp co vk cv c2 cexp co c2 vk cv cmul co caddc co
      c1 caddc co vk vk cv cc0 cN cfz co wcel vk cv cn0 wcel vk cv cc wcel vk
      cv c1 caddc co c2 cexp co vk cv c2 cexp co c2 vk cv cmul co caddc co c1
      caddc co wceq vk cv cN elfznn0 vk cv nn0cn vk cv cc wcel vk cv c1 caddc
      co c2 cexp co vk cv c2 cexp co c2 vk cv c1 cmul co cmul co caddc co c1 c2
      cexp co caddc co vk cv c2 cexp co c2 vk cv cmul co caddc co c1 caddc co
      vk cv cc wcel c1 cc wcel vk cv c1 caddc co c2 cexp co vk cv c2 cexp co c2
      vk cv c1 cmul co cmul co caddc co c1 c2 cexp co caddc co wceq ax1cn vk cv
      c1 binom2 mpan2 vk cv cc wcel vk cv c2 cexp co c2 vk cv c1 cmul co cmul
      co caddc co vk cv c2 cexp co c2 vk cv cmul co caddc co c1 c2 cexp co c1
      caddc vk cv cc wcel c2 vk cv c1 cmul co cmul co c2 vk cv cmul co vk cv c2
      cexp co caddc vk cv cc wcel vk cv c1 cmul co vk cv c2 cmul vk cv ax1id
      opreq2d opreq2d c1 c2 cexp co c1 wceq vk cv cc wcel sq1 a1i opreq12d
      eqtrd 3syl sumeq2i cN cc0 cuz cfv wcel vk cv c2 cexp co c2 vk cv cmul co
      caddc co cc wcel c1 cc wcel wa vk cc0 cN cfz co wral cc0 cN cfz co vk cv
      c2 cexp co c2 vk cv cmul co caddc co c1 caddc co vk csu cc0 cN cfz co vk
      cv c2 cexp co c2 vk cv cmul co caddc co vk csu cc0 cN cfz co c1 vk csu
      caddc co wceq cN cn0 wcel cN cc0 cuz cfv wcel cN arisumi.1 nnnn0i cN
      elnn0uz mpbi vk cv c2 cexp co c2 vk cv cmul co caddc co cc wcel c1 cc
      wcel wa vk cc0 cN cfz co vk cv cc0 cN cfz co wcel vk cv c2 cexp co c2 vk
      cv cmul co caddc co cc wcel c1 cc wcel vk cv c2 cexp co cc wcel c2 vk cv
      cmul co cc wcel vk cv c2 cexp co c2 vk cv cmul co caddc co cc wcel vk cv
      cc0 cN cfz co wcel vk cv c2 cexp co c2 vk cv cmul co addcl vk cv cc0 cN
      cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv c2 cexp co cc wcel vk cv
      cN elfznn0 vk cv nn0cn vk cv sqcl 3syl c2 cc wcel vk cv cc wcel c2 vk cv
      cmul co cc wcel vk cv cc0 cN cfz co wcel c2 vk cv mulcl 2cn vk cv cc0 cN
      cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv cN elfznn0 vk cv nn0cn syl
      sylancr sylanc ax1cn jctir rgen vk cv c2 cexp co c2 vk cv cmul co caddc
      co c1 vk cc0 cN fsumadd mp2an cN cc0 cuz cfv wcel vk cv c2 cexp co cc
      wcel c2 vk cv cmul co cc wcel wa vk cc0 cN cfz co wral cc0 cN cfz co vk
      cv c2 cexp co c2 vk cv cmul co caddc co vk csu cc0 cN cfz co c1 vk csu
      caddc co cc0 cN cfz co vk cv c2 cexp co vk csu cc0 cN cfz co c2 vk cv
      cmul co vk csu caddc co cc0 cN cfz co c1 vk csu caddc co wceq cN cn0 wcel
      cN cc0 cuz cfv wcel cN arisumi.1 nnnn0i cN elnn0uz mpbi vk cv c2 cexp co
      cc wcel c2 vk cv cmul co cc wcel wa vk cc0 cN cfz co vk cv cc0 cN cfz co
      wcel vk cv c2 cexp co cc wcel c2 vk cv cmul co cc wcel vk cv cc0 cN cfz
      co wcel vk cv cn0 wcel vk cv cc wcel vk cv c2 cexp co cc wcel vk cv cN
      elfznn0 vk cv nn0cn vk cv sqcl 3syl c2 cc wcel vk cv cc wcel c2 vk cv
      cmul co cc wcel vk cv cc0 cN cfz co wcel c2 vk cv mulcl 2cn vk cv cc0 cN
      cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv cN elfznn0 vk cv nn0cn syl
      sylancr jca rgen cN cc0 cuz cfv wcel vk cv c2 cexp co cc wcel c2 vk cv
      cmul co cc wcel wa vk cc0 cN cfz co wral wa cc0 cN cfz co vk cv c2 cexp
      co c2 vk cv cmul co caddc co vk csu cc0 cN cfz co vk cv c2 cexp co vk csu
      cc0 cN cfz co c2 vk cv cmul co vk csu caddc co cc0 cN cfz co c1 vk csu
      caddc vk cv c2 cexp co c2 vk cv cmul co vk cc0 cN fsumadd opreq1d mp2an
      3eqtri cc0 cc0 c1 caddc co cN c1 caddc co cfz co vk cv c2 cexp co vk csu
      caddc co cc0 c1 caddc co cN c1 caddc co cfz co vk cv c2 cexp co vk csu
      cc0 cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc0 cN cfz co vk cv c1
      caddc co c2 cexp co vk csu cc0 c1 caddc co cN c1 caddc co cfz co vk cv c2
      cexp co vk csu cN c1 caddc co cc0 c1 caddc co cuz cfv wcel vk cv c2 cexp
      co cc wcel vk cc0 c1 caddc co cN c1 caddc co cfz co wral cc0 c1 caddc co
      cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc wcel cN c1 caddc co cc0
      c1 caddc co cuz cfv wcel cN c1 caddc co cz wcel cc0 c1 caddc co cN c1
      caddc co cle wbr cc0 c1 caddc co cN c1 caddc co cc0 cz wcel c1 cz wcel
      cc0 c1 caddc co cz wcel 0z 1z cc0 c1 zaddcl mp2an eluz1i cN cz wcel c1 cz
      wcel cN c1 caddc co cz wcel cN cn wcel cN cz wcel arisumi.1 cN nnz ax-mp
      1z cN c1 zaddcl mp2an cc0 cN cle wbr cc0 c1 caddc co cN c1 caddc co cle
      wbr cN cn wcel cc0 cN cle wbr arisumi.1 cN cn wcel cc0 cN clt wbr cc0 cN
      cle wbr cN nngt0 cc0 cN 0re cN arisumi.1 nnrei ltlei syl ax-mp cc0 cN c1
      0re cN arisumi.1 nnrei 1re leadd1i mpbi mpbir2an vk cv c2 cexp co cc wcel
      vk cc0 c1 caddc co cN c1 caddc co cfz co vk cv cc0 c1 caddc co cN c1
      caddc co cfz co wcel vk cv cz wcel vk cv cc wcel vk cv c2 cexp co cc wcel
      vk cv cc0 c1 caddc co cN c1 caddc co elfzelz vk cv zcn vk cv sqcl 3syl
      rgen vk cv c2 cexp co vk cc0 c1 caddc co cN c1 caddc co fsumcl mp2an
      addid2i cN c1 caddc co cc0 cuz cfv wcel cc0 cN c1 caddc co clt wbr vk cv
      c2 cexp co cc wcel vk cc0 cN c1 caddc co cfz co wral cc0 cN c1 caddc co
      cfz co vk cv c2 cexp co vk csu cc0 cc0 c1 caddc co cN c1 caddc co cfz co
      vk cv c2 cexp co vk csu caddc co wceq cN c1 caddc co cn0 wcel cN c1 caddc
      co cc0 cuz cfv wcel cN cn wcel cN c1 caddc co cn0 wcel arisumi.1 cN cn
      wcel cN c1 caddc co cn wcel cN c1 caddc co cn0 wcel cN peano2nn cN c1
      caddc co nnnn0 syl ax-mp cN c1 caddc co elnn0uz mpbi cN c1 cN arisumi.1
      nnrei 1re cN arisumi.1 nngt0i lt01 addgt0ii vk cv c2 cexp co cc wcel vk
      cc0 cN c1 caddc co cfz co vk cv cc0 cN c1 caddc co cfz co wcel vk cv cn0
      wcel vk cv cc wcel vk cv c2 cexp co cc wcel vk cv cN c1 caddc co elfznn0
      vk cv nn0cn vk cv sqcl 3syl rgen vk cv c2 cexp co cc0 vk cc0 cN c1 caddc
      co vk cv sq0i fsum1p mp3an cc0 cN cfz co vk cv c1 caddc co c2 cexp co vk
      csu c1 cN c1 caddc co cfz co vj cv c2 cexp co vj csu c1 cN c1 caddc co
      cfz co vk cv c2 cexp co vk csu cc0 c1 caddc co cN c1 caddc co cfz co vk
      cv c2 cexp co vk csu vk vj cN arisumi.1 arisumilem vx c1 cN c1 caddc co
      cfz co vj cv c2 cexp co vk cv c2 cexp co vj vk vx cv vj cv c2 cexp co
      wcel vk ax-17 vx cv vk cv c2 cexp co wcel vj ax-17 vj cv vk cv c2 cexp
      opreq1 cbvsumi c1 cN c1 caddc co cfz co cc0 c1 caddc co cN c1 caddc co
      cfz co vk cv c2 cexp co vk c1 cc0 c1 caddc co cN c1 caddc co cfz cc0 c1
      caddc co c1 c1 ax1cn addid2i eqcomi opreq1i sumeq1i 3eqtri 3eqtr4ri cc0
      cN cfz co vk cv c2 cexp co vk csu cc0 cN cfz co c2 vk cv cmul co vk csu
      cc0 cN cfz co c1 vk csu cN cn0 wcel vk cv c2 cexp co cc wcel vk cc0 cN
      cfz co wral cc0 cN cfz co vk cv c2 cexp co vk csu cc wcel cN arisumi.1
      nnnn0i vk cv c2 cexp co cc wcel vk cc0 cN cfz co vk cv cc0 cN cfz co wcel
      vk cv cn0 wcel vk cv cc wcel vk cv c2 cexp co cc wcel vk cv cN elfznn0 vk
      cv nn0cn vk cv sqcl 3syl rgen vk cv c2 cexp co vk cN fsum0cl mp2an cN cn0
      wcel c2 vk cv cmul co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co c2 vk
      cv cmul co vk csu cc wcel cN arisumi.1 nnnn0i c2 vk cv cmul co cc wcel vk
      cc0 cN cfz co c2 cc wcel vk cv cc wcel c2 vk cv cmul co cc wcel vk cv cc0
      cN cfz co wcel c2 vk cv mulcl 2cn vk cv cc0 cN cfz co wcel vk cv cn0 wcel
      vk cv cc wcel vk cv cN elfznn0 vk cv nn0cn syl sylancr rgen c2 vk cv cmul
      co vk cN fsum0cl mp2an cN cn0 wcel c1 cc wcel vk cc0 cN cfz co wral cc0
      cN cfz co c1 vk csu cc wcel cN arisumi.1 nnnn0i c1 cc wcel vk cc0 cN cfz
      co c1 cc wcel vk cv cc0 cN cfz co wcel ax1cn a1i rgen c1 vk cN fsum0cl
      mp2an addassi 3eqtr3ri subaddrii cc0 cN c1 caddc co cfz co vk cv c2 cexp
      co vk csu cc0 cN cfz co vk cv c2 cexp co vk csu cN c1 caddc co c2 cexp co
      cN c1 caddc co cn0 wcel vk cv c2 cexp co cc wcel vk cc0 cN c1 caddc co
      cfz co wral cc0 cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc wcel cN
      c1 caddc co cN cn wcel cN c1 caddc co cn wcel arisumi.1 cN peano2nn ax-mp
      nnnn0i vk cv c2 cexp co cc wcel vk cc0 cN c1 caddc co cfz co vk cv cc0 cN
      c1 caddc co cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv c2 cexp co cc
      wcel vk cv cN c1 caddc co elfznn0 vk cv nn0cn vk cv sqcl 3syl rgen vk cv
      c2 cexp co vk cN c1 caddc co fsum0cl mp2an cN cn0 wcel vk cv c2 cexp co
      cc wcel vk cc0 cN cfz co wral cc0 cN cfz co vk cv c2 cexp co vk csu cc
      wcel cN arisumi.1 nnnn0i vk cv c2 cexp co cc wcel vk cc0 cN cfz co vk cv
      cc0 cN cfz co wcel vk cv cn0 wcel vk cv cc wcel vk cv c2 cexp co cc wcel
      vk cv cN elfznn0 vk cv nn0cn vk cv sqcl 3syl rgen vk cv c2 cexp co vk cN
      fsum0cl mp2an cN c1 caddc co cN c1 cN arisumi.1 nncni ax1cn addcli sqcli
      cc0 cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc0 cN cfz co vk cv c2
      cexp co vk csu cN c1 caddc co c2 cexp co caddc co cN cc0 cuz cfv wcel cc0
      cN c1 caddc co cfz co vk cv c2 cexp co vk csu cc0 cN cfz co vk cv c2 cexp
      co vk csu cN c1 caddc co c2 cexp co caddc co wceq cN cn0 wcel cN cc0 cuz
      cfv wcel cN arisumi.1 nnnn0i cN elnn0uz mpbi vk cv c2 cexp co cN c1 caddc
      co c2 cexp co vk cc0 cN vk cv c2 cexp oprex cN c1 caddc co c2 cexp oprex
      vk cv cN c1 caddc co c2 cexp opreq1 fsump1i ax-mp eqcomi subaddrii eqtr3i
      3eqtri cN c1 caddc co c2 cexp co cN c1 caddc co c2 cc0 cN cfz co vk cv vk
      csu cmul co cN c1 caddc co cN c1 cN arisumi.1 nncni ax1cn addcli sqcli cN
      c1 cN arisumi.1 nncni ax1cn addcli c2 cc0 cN cfz co vk cv vk csu 2cn cN
      cn0 wcel vk cv cc wcel vk cc0 cN cfz co wral cc0 cN cfz co vk cv vk csu
      cc wcel cN arisumi.1 nnnn0i vk cv cc wcel vk cc0 cN cfz co vk cv cc0 cN
      cfz co wcel vk cv cz wcel vk cv cc wcel vk cv cc0 cN elfzelz vk cv zcn
      syl rgen vk cv vk cN fsum0cl mp2an mulcli subadd2i mpbir eqcomi cN c1
      caddc co c2 cexp co cN c1 caddc co cmin co c2 cc0 cN cfz co vk cv vk csu
      cN c1 caddc co c2 cexp co cN c1 caddc co cN c1 caddc co cN c1 cN
      arisumi.1 nncni ax1cn addcli sqcli cN c1 cN arisumi.1 nncni ax1cn addcli
      subcli c2 2re recni cN cn0 wcel vk cv cc wcel vk cc0 cN cfz co wral cc0
      cN cfz co vk cv vk csu cc wcel cN arisumi.1 nnnn0i vk cv cc wcel vk cc0
      cN cfz co vk cv cc0 cN cfz co wcel vk cv cz wcel vk cv cc wcel vk cv cc0
      cN elfzelz vk cv zcn syl rgen vk cv vk cN fsum0cl mp2an 2ne0 divmuli
      mpbir eqcomi $.
      $( [10-Dec-2006] $) $( [16-Nov-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Geometric series
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x ph $.  $d x y A $.
    expcnvlem1.1 $e |- A e. RR $.
    expcnvlem1.2 $e |- ( y e. NN -> ( A < y -> ph ) ) $.
    $( Lemma for ~ expcnv .  Convert an antecedent from a comparison with a
       real into comparison with a natural number. $)
    expcnvlem1 $p |- E. x e. NN A. y e. NN ( x <_ y -> ph ) $=
      cA cfl cfv cabs cfv c1 caddc co cn wcel cA cfl cfv cabs cfv c1 caddc co
      vy cv cle wbr wph wi vy cn wral vx cv vy cv cle wbr wph wi vy cn wral vx
      cn wrex cA cfl cfv cabs cfv cn0 wcel cA cfl cfv cabs cfv c1 caddc co cn
      wcel cA cfl cfv cz wcel cA cfl cfv cabs cfv cn0 wcel cA cr wcel cA cfl
      cfv cz wcel expcnvlem1.1 cA flcl ax-mp cA cfl cfv nn0abscl ax-mp cA cfl
      cfv cabs cfv nn0p1nn ax-mp cA vy cv clt wbr wph wi cA cfl cfv cabs cfv c1
      caddc co vy cv cle wbr wph wi vy cn wral vy cn cA vy cv clt wbr wph wi cA
      cfl cfv cabs cfv c1 caddc co vy cv cle wbr wph wi vy cn vy cv cn wcel cA
      cfl cfv cabs cfv c1 caddc co vy cv cle wbr cA vy cv clt wbr wph vy cv cn
      wcel vy cv cr wcel cA cfl cfv cabs cfv c1 caddc co vy cv cle wbr cA vy cv
      clt wbr wi vy cv nnre vy cv cr wcel cA cA cfl cfv cabs cfv c1 caddc co
      clt wbr cA cfl cfv cabs cfv c1 caddc co vy cv cle wbr cA vy cv clt wbr cA
      cA cfl cfv c1 caddc co clt wbr cA cfl cfv c1 caddc co cA cfl cfv cabs cfv
      c1 caddc co cle wbr cA cA cfl cfv cabs cfv c1 caddc co clt wbr cA cr wcel
      cA cA cfl cfv c1 caddc co clt wbr expcnvlem1.1 cA flltp1 ax-mp cA cfl cfv
      cA cfl cfv cabs cfv cle wbr cA cfl cfv c1 caddc co cA cfl cfv cabs cfv c1
      caddc co cle wbr cA cfl cfv cA cr wcel cA cfl cfv cr wcel expcnvlem1.1 cA
      reflcl ax-mp leabsi cA cfl cfv cA cfl cfv cabs cfv c1 cA cr wcel cA cfl
      cfv cr wcel expcnvlem1.1 cA reflcl ax-mp cA cfl cfv cA cfl cfv cA cr wcel
      cA cfl cfv cr wcel expcnvlem1.1 cA reflcl ax-mp recni abscli 1re leadd1i
      mpbi cA cA cfl cfv c1 caddc co cA cfl cfv cabs cfv c1 caddc co
      expcnvlem1.1 cA cfl cfv c1 cA cr wcel cA cfl cfv cr wcel expcnvlem1.1 cA
      reflcl ax-mp 1re readdcli cA cfl cfv cabs cfv c1 cA cfl cfv cA cfl cfv cA
      cr wcel cA cfl cfv cr wcel expcnvlem1.1 cA reflcl ax-mp recni abscli 1re
      readdcli ltletri mp2an cA cr wcel cA cfl cfv cabs cfv c1 caddc co cr wcel
      vy cv cr wcel cA cA cfl cfv cabs cfv c1 caddc co clt wbr cA cfl cfv cabs
      cfv c1 caddc co vy cv cle wbr wa cA vy cv clt wbr wi expcnvlem1.1 cA cfl
      cfv cabs cfv c1 cA cfl cfv cA cfl cfv cA cr wcel cA cfl cfv cr wcel
      expcnvlem1.1 cA reflcl ax-mp recni abscli 1re readdcli cA cA cfl cfv cabs
      cfv c1 caddc co vy cv ltletr mp3an12 mpani syl imim1d r19.20i
      expcnvlem1.2 mprg vx cv vy cv cle wbr wph wi vy cn wral cA cfl cfv cabs
      cfv c1 caddc co vy cv cle wbr wph wi vy cn wral vx cA cfl cfv cabs cfv c1
      caddc co cn vx cv cA cfl cfv cabs cfv c1 caddc co wceq vx cv vy cv cle
      wbr wph wi cA cfl cfv cabs cfv c1 caddc co vy cv cle wbr wph wi vy cn vx
      cv cA cfl cfv cabs cfv c1 caddc co wceq vx cv vy cv cle wbr cA cfl cfv
      cabs cfv c1 caddc co vy cv cle wbr wph vx cv cA cfl cfv cabs cfv c1 caddc
      co vy cv cle breq1 imbi1d ralbidv rcla4ev mp2an $.
      $( [20-Mar-2005] $) $( [27-Feb-2005] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    expcnvlem.1 $e |- ( A e. RR /\ 0 < A /\ A < 1 ) $.
    expcnvlem.2 $e |- ( B e. RR /\ 0 < B ) $.
    ${
      expcnvlem.3 $e |- C e. NN $.
      $( Lemma for ~ expcnv .  Compute an upper bound for exponentiation
         using Bernoulli's inequality ~ bernneq . $)
      expcnvlem2 $p |- ( ( ( ( 1 / B ) - 1 ) / ( ( 1 / A ) - 1 ) ) < C
                      -> ( A ^ C ) < B ) $=
        c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin co cdiv co cC clt wbr c1
        c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co cdiv co cB clt wbr cA
        cC cexp co cB clt wbr c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin co
        cdiv co cC clt wbr c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin co cC
        cmul co clt wbr c1 cB cdiv co c1 cA cdiv co c1 cmin co cC cmul co c1
        caddc co clt wbr c1 c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co
        cdiv co cB clt wbr c1 cB cdiv co c1 cmin co cr wcel c1 cA cdiv co c1
        cmin co cr wcel cC cr wcel c1 cB cdiv co c1 cmin co c1 cA cdiv co c1
        cmin co cdiv co cC clt wbr c1 cB cdiv co c1 cmin co c1 cA cdiv co c1
        cmin co cC cmul co clt wbr wb c1 cB cdiv co c1 cB cB cr wcel cc0 cB clt
        wbr expcnvlem.2 pm3.26i cB cB cr wcel cc0 cB clt wbr expcnvlem.2
        pm3.26i cB cr wcel cc0 cB clt wbr expcnvlem.2 pm3.27i gt0ne0ii rereccli
        1re resubcli c1 cA cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp2i gt0ne0ii rereccli 1re resubcli cC expcnvlem.3 nnrei c1 cB cdiv
        co c1 cmin co cr wcel c1 cA cdiv co c1 cmin co cr wcel cC cr wcel w3a
        cc0 c1 cA cdiv co c1 cmin co clt wbr c1 cB cdiv co c1 cmin co c1 cA
        cdiv co c1 cmin co cdiv co cC clt wbr c1 cB cdiv co c1 cmin co c1 cA
        cdiv co c1 cmin co cC cmul co clt wbr wb c1 c1 cA cdiv co clt wbr cc0
        c1 cA cdiv co c1 cmin co clt wbr cA c1 clt wbr c1 c1 cA cdiv co clt wbr
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp3i cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr c1 c1 cA cdiv co clt wbr wb cA cr wcel cc0
        cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr
        cA c1 clt wbr expcnvlem.1 3simp2i cA reclt1 mp2an mpbi c1 c1 cA cdiv co
        1re cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli
        posdifi mpbi c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin co cC
        ltdivmulOLD mpan2 mp3an c1 cB cdiv co c1 c1 cA cdiv co c1 cmin co cC
        cmul co cB cB cr wcel cc0 cB clt wbr expcnvlem.2 pm3.26i cB cB cr wcel
        cc0 cB clt wbr expcnvlem.2 pm3.26i cB cr wcel cc0 cB clt wbr
        expcnvlem.2 pm3.27i gt0ne0ii rereccli 1re c1 cA cdiv co c1 cmin co cC
        c1 cA cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii
        rereccli 1re resubcli cC expcnvlem.3 nnrei remulcli ltsubaddi c1 cB c1
        cA cdiv co c1 cmin co cC cmul co c1 caddc co 1re cB cr wcel cc0 cB clt
        wbr expcnvlem.2 pm3.26i c1 cA cdiv co c1 cmin co cC cmul co c1 c1 cA
        cdiv co c1 cmin co cC c1 cA cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA
        c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp2i gt0ne0ii rereccli 1re resubcli cC expcnvlem.3 nnrei
        remulcli 1re readdcli cB cr wcel cc0 cB clt wbr expcnvlem.2 pm3.27i c1
        cA cdiv co c1 cmin co cC cmul co c1 c1 cA cdiv co c1 cmin co cC c1 cA
        cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii
        rereccli 1re resubcli cC expcnvlem.3 nnrei remulcli 1re c1 cA cdiv co
        c1 cmin co cC c1 cA cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp2i gt0ne0ii rereccli 1re resubcli cC expcnvlem.3 nnrei c1 c1 cA
        cdiv co clt wbr cc0 c1 cA cdiv co c1 cmin co clt wbr cA c1 clt wbr c1
        c1 cA cdiv co clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp3i cA cr wcel cc0 cA clt wbr cA c1 clt wbr c1 c1 cA
        cdiv co clt wbr wb cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i cA
        reclt1 mp2an mpbi c1 c1 cA cdiv co 1re cA cA cr wcel cc0 cA clt wbr cA
        c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp2i gt0ne0ii rereccli posdifi mpbi cC expcnvlem.3
        nngt0i mulgt0ii lt01 addgt0ii ltdiv23ii 3bitri cA cC cexp co c1 c1 cA
        cdiv co c1 cmin co cC cmul co c1 caddc co cdiv co cle wbr c1 c1 cA cdiv
        co c1 cmin co cC cmul co c1 caddc co cdiv co cB clt wbr cA cC cexp co
        cB clt wbr c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co c1 cA cC
        cexp co cdiv co cle wbr cA cC cexp co c1 c1 cA cdiv co c1 cmin co cC
        cmul co c1 caddc co cdiv co cle wbr c1 cA cdiv co c1 cmin co cC cmul co
        c1 caddc co c1 cA cdiv co cC cexp co c1 cA cC cexp co cdiv co cle c1 cA
        cdiv co cr wcel cC cn0 wcel cc0 c1 cA cdiv co cle wbr c1 cA cdiv co c1
        cmin co cC cmul co c1 caddc co c1 cA cdiv co cC cexp co cle wbr cA cA
        cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt
        wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli cC expcnvlem.3
        nnnn0i cc0 c1 cA cdiv co 0re cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp2i gt0ne0ii rereccli cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp2i recgt0ii ltleii c1 cA cdiv co cC bernneq2 mp3an cA cc wcel cC
        cn wcel cA cc0 wne c1 cA cdiv co cC cexp co c1 cA cC cexp co cdiv co
        wceq cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i
        recni expcnvlem.3 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp2i gt0ne0ii cA cc wcel cC cn0 wcel cA cc0 wne c1 cA cdiv co cC
        cexp co c1 cA cC cexp co cdiv co wceq cC cn wcel cA cC exprecOLD cC
        nnnn0 syl3an2 mp3an breqtri c1 cA cdiv co c1 cmin co cC cmul co c1
        caddc co cr wcel cc0 c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co
        clt wbr wa cA cC cexp co cr wcel cc0 cA cC cexp co clt wbr wa c1 cA
        cdiv co c1 cmin co cC cmul co c1 caddc co c1 cA cC cexp co cdiv co cle
        wbr cA cC cexp co c1 c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co
        cdiv co cle wbr wb c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co cr
        wcel cc0 c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co clt wbr c1 cA
        cdiv co c1 cmin co cC cmul co c1 c1 cA cdiv co c1 cmin co cC c1 cA cdiv
        co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re
        resubcli cC expcnvlem.3 nnrei remulcli 1re readdcli c1 cA cdiv co c1
        cmin co cC cmul co c1 c1 cA cdiv co c1 cmin co cC c1 cA cdiv co c1 cA
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr
        wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA
        clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re
        resubcli cC expcnvlem.3 nnrei remulcli 1re c1 cA cdiv co c1 cmin co cC
        c1 cA cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii
        rereccli 1re resubcli cC expcnvlem.3 nnrei c1 c1 cA cdiv co clt wbr cc0
        c1 cA cdiv co c1 cmin co clt wbr cA c1 clt wbr c1 c1 cA cdiv co clt wbr
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp3i cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr c1 c1 cA cdiv co clt wbr wb cA cr wcel cc0
        cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr
        cA c1 clt wbr expcnvlem.1 3simp2i cA reclt1 mp2an mpbi c1 c1 cA cdiv co
        1re cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli
        posdifi mpbi cC expcnvlem.3 nngt0i mulgt0ii lt01 addgt0ii pm3.2i cA cC
        cexp co cr wcel cc0 cA cC cexp co clt wbr cA cr wcel cC cn0 wcel cA cC
        cexp co cr wcel cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp1i cC expcnvlem.3 nnnn0i cA cC reexpcl mp2an cA cr wcel cC cn0
        wcel cc0 cA clt wbr cc0 cA cC cexp co clt wbr cA cr wcel cc0 cA clt wbr
        cA c1 clt wbr expcnvlem.1 3simp1i cC expcnvlem.3 nnnn0i cA cr wcel cc0
        cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i cA cC expgt0 mp3an pm3.2i
        c1 cA cdiv co c1 cmin co cC cmul co c1 caddc co cA cC cexp co lerec2
        mp2an mpbi cA cC cexp co c1 c1 cA cdiv co c1 cmin co cC cmul co c1
        caddc co cdiv co cB cA cr wcel cC cn0 wcel cA cC cexp co cr wcel cA cr
        wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cC expcnvlem.3
        nnnn0i cA cC reexpcl mp2an c1 cA cdiv co c1 cmin co cC cmul co c1 caddc
        co c1 cA cdiv co c1 cmin co cC cmul co c1 c1 cA cdiv co c1 cmin co cC
        c1 cA cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii
        rereccli 1re resubcli cC expcnvlem.3 nnrei remulcli 1re readdcli c1 cA
        cdiv co c1 cmin co cC cmul co c1 caddc co c1 cA cdiv co c1 cmin co cC
        cmul co c1 c1 cA cdiv co c1 cmin co cC c1 cA cdiv co c1 cA cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA
        clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA
        c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re resubcli cC
        expcnvlem.3 nnrei remulcli 1re readdcli c1 cA cdiv co c1 cmin co cC
        cmul co c1 c1 cA cdiv co c1 cmin co cC c1 cA cdiv co c1 cA cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA
        clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA
        c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re resubcli cC
        expcnvlem.3 nnrei remulcli 1re c1 cA cdiv co c1 cmin co cC c1 cA cdiv
        co c1 cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re
        resubcli cC expcnvlem.3 nnrei c1 c1 cA cdiv co clt wbr cc0 c1 cA cdiv
        co c1 cmin co clt wbr cA c1 clt wbr c1 c1 cA cdiv co clt wbr cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp3i cA cr wcel cc0 cA clt
        wbr cA c1 clt wbr c1 c1 cA cdiv co clt wbr wb cA cr wcel cc0 cA clt wbr
        cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp2i cA reclt1 mp2an mpbi c1 c1 cA cdiv co 1re cA cA
        cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel
        cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt
        wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli posdifi mpbi cC
        expcnvlem.3 nngt0i mulgt0ii lt01 addgt0ii gt0ne0ii rereccli cB cr wcel
        cc0 cB clt wbr expcnvlem.2 pm3.26i lelttri mpan sylbi $.
        $( [28-Jul-2006] $) $( [24-Feb-2005] $)
      $}

      $( Lemma for ~ expcnv .  Apply weak deduction theorem. $)
      expcnvlem3 $p |- ( C e. NN -> ( ( ( ( 1 / B ) - 1 ) /
                       ( ( 1 / A ) - 1 ) ) < C -> ( A ^ C ) < B ) ) $=
        cC cn wcel c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin co cdiv co cC
        clt wbr cA cC cexp co cB clt wbr wi c1 cB cdiv co c1 cmin co c1 cA cdiv
        co c1 cmin co cdiv co cC cn wcel cC c1 cif clt wbr cA cC cn wcel cC c1
        cif cexp co cB clt wbr wi cC c1 cC cC cn wcel cC c1 cif wceq c1 cB cdiv
        co c1 cmin co c1 cA cdiv co c1 cmin co cdiv co cC clt wbr c1 cB cdiv co
        c1 cmin co c1 cA cdiv co c1 cmin co cdiv co cC cn wcel cC c1 cif clt
        wbr cA cC cexp co cB clt wbr cA cC cn wcel cC c1 cif cexp co cB clt wbr
        cC cC cn wcel cC c1 cif c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin
        co cdiv co clt breq2 cC cC cn wcel cC c1 cif wceq cA cC cexp co cA cC
        cn wcel cC c1 cif cexp co cB clt cC cC cn wcel cC c1 cif cA cexp opreq2
        breq1d imbi12d cA cB cC cn wcel cC c1 cif expcnvlem.1 expcnvlem.2 cC c1
        cn 1nn elimel expcnvlem2 dedth $.
        $( [20-Mar-2005] $) $( [27-Feb-2005] $)

      $( Lemma for ~ expcnv .  Combine ~ expcnvlem1 and ~ expcnvlem3 . $)
      expcnvlem4 $p |- E. x e. NN A. y e. NN ( x <_ y -> ( A ^ y ) < B ) $=
        cA vy cv cexp co cB clt wbr vx vy c1 cB cdiv co c1 cmin co c1 cA cdiv
        co c1 cmin co cdiv co c1 cB cdiv co c1 cmin co c1 cA cdiv co c1 cmin co
        c1 cB cdiv co c1 cB cB cr wcel cc0 cB clt wbr expcnvlem.2 pm3.26i cB cB
        cr wcel cc0 cB clt wbr expcnvlem.2 pm3.26i cB cr wcel cc0 cB clt wbr
        expcnvlem.2 pm3.27i gt0ne0ii rereccli 1re resubcli c1 cA cdiv co c1 cA
        cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr
        wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA
        clt wbr cA c1 clt wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re
        resubcli c1 cA cdiv co c1 cmin co c1 cA cdiv co c1 cA cA cr wcel cc0 cA
        clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr
        cA c1 clt wbr expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp2i gt0ne0ii rereccli 1re resubcli c1 c1 cA cdiv co
        clt wbr cc0 c1 cA cdiv co c1 cmin co clt wbr cA c1 clt wbr c1 c1 cA
        cdiv co clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp3i cA cr wcel cc0 cA clt wbr cA c1 clt wbr c1 c1 cA cdiv co clt
        wbr wb cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp1i cA
        cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1 3simp2i cA reclt1
        mp2an mpbi c1 c1 cA cdiv co 1re cA cA cr wcel cc0 cA clt wbr cA c1 clt
        wbr expcnvlem.1 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr
        expcnvlem.1 3simp1i cA cr wcel cc0 cA clt wbr cA c1 clt wbr expcnvlem.1
        3simp2i gt0ne0ii rereccli posdifi mpbi gt0ne0ii redivcli cA cB vy cv
        expcnvlem.1 expcnvlem.2 expcnvlem3 expcnvlem1 $.
        $( [20-Mar-2005] $) $( [25-Feb-2005] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Lemma for ~ expcnv .  Apply weak deduction theorem. $)
    expcnvlem5 $p |- ( ( ( A e. RR /\ 0 < A /\ A < 1 ) /\ ( B e. RR
        /\ 0 < B ) ) -> E. x e. NN A. y e. NN ( x <_ y -> ( A ^ y ) < B ) ) $=
      cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cB cr wcel cc0 cB clt wbr wa
      vx cv vy cv cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex
      vx cv vy cv cle wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2
      cdiv co cif vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex vx cv vy cv
      cle wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif
      vy cv cexp co cB cr wcel cc0 cB clt wbr wa cB c1 cif clt wbr wi vy cn
      wral vx cn wrex cA cB c1 c2 cdiv co c1 cA cA cr wcel cc0 cA clt wbr cA c1
      clt wbr w3a cA c1 c2 cdiv co cif wceq vx cv vy cv cle wbr cA vy cv cexp
      co cB clt wbr wi vx cv vy cv cle wbr cA cr wcel cc0 cA clt wbr cA c1 clt
      wbr w3a cA c1 c2 cdiv co cif vy cv cexp co cB clt wbr wi vx vy cn cn cA
      cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif wceq cA
      vy cv cexp co cB clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA
      c1 c2 cdiv co cif vy cv cexp co cB clt wbr vx cv vy cv cle wbr cA cA cr
      wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif wceq cA vy cv
      cexp co cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif
      vy cv cexp co cB clt cA cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1
      c2 cdiv co cif vy cv cexp opreq1 breq1d imbi2d rexralbidv cB cB cr wcel
      cc0 cB clt wbr wa cB c1 cif wceq vx cv vy cv cle wbr cA cr wcel cc0 cA
      clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif vy cv cexp co cB clt wbr
      wi vx cv vy cv cle wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1
      c2 cdiv co cif vy cv cexp co cB cr wcel cc0 cB clt wbr wa cB c1 cif clt
      wbr wi vx vy cn cn cB cB cr wcel cc0 cB clt wbr wa cB c1 cif wceq cA cr
      wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif vy cv cexp co
      cB clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co
      cif vy cv cexp co cB cr wcel cc0 cB clt wbr wa cB c1 cif clt wbr vx cv vy
      cv cle wbr cB cB cr wcel cc0 cB clt wbr wa cB c1 cif cA cr wcel cc0 cA
      clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif vy cv cexp co clt breq2
      imbi2d rexralbidv vx vy cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1
      c2 cdiv co cif cB cr wcel cc0 cB clt wbr wa cB c1 cif cA cr wcel cc0 cA
      clt wbr cA c1 clt wbr w3a cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA
      c1 c2 cdiv co cif cr wcel cc0 cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a
      cA c1 c2 cdiv co cif clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a
      cA c1 c2 cdiv co cif c1 clt wbr w3a c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv
      co clt wbr c1 c2 cdiv co c1 clt wbr w3a cA c1 c2 cdiv co cA cA cr wcel
      cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif wceq cA cr wcel cA
      cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif cr wcel cc0
      cA clt wbr cc0 cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv
      co cif clt wbr cA c1 clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a
      cA c1 c2 cdiv co cif c1 clt wbr cA cA cr wcel cc0 cA clt wbr cA c1 clt
      wbr w3a cA c1 c2 cdiv co cif cr eleq1 cA cA cr wcel cc0 cA clt wbr cA c1
      clt wbr w3a cA c1 c2 cdiv co cif cc0 clt breq2 cA cA cr wcel cc0 cA clt
      wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif c1 clt breq1 3anbi123d c1 c2
      cdiv co cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif
      wceq c1 c2 cdiv co cr wcel cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA
      c1 c2 cdiv co cif cr wcel cc0 c1 c2 cdiv co clt wbr cc0 cA cr wcel cc0 cA
      clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif clt wbr c1 c2 cdiv co c1
      clt wbr cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif
      c1 clt wbr c1 c2 cdiv co cA cr wcel cc0 cA clt wbr cA c1 clt wbr w3a cA
      c1 c2 cdiv co cif cr eleq1 c1 c2 cdiv co cA cr wcel cc0 cA clt wbr cA c1
      clt wbr w3a cA c1 c2 cdiv co cif cc0 clt breq2 c1 c2 cdiv co cA cr wcel
      cc0 cA clt wbr cA c1 clt wbr w3a cA c1 c2 cdiv co cif c1 clt breq1
      3anbi123d c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co clt wbr c1 c2 cdiv co
      c1 clt wbr c2 2re 2ne0 rereccli halfgt0 halflt1 3pm3.2i elimhyp cB cr
      wcel cc0 cB clt wbr wa cB cr wcel cc0 cB clt wbr wa cB c1 cif cr wcel cc0
      cB cr wcel cc0 cB clt wbr wa cB c1 cif clt wbr wa c1 cr wcel cc0 c1 clt
      wbr wa cB c1 cB cB cr wcel cc0 cB clt wbr wa cB c1 cif wceq cB cr wcel cB
      cr wcel cc0 cB clt wbr wa cB c1 cif cr wcel cc0 cB clt wbr cc0 cB cr wcel
      cc0 cB clt wbr wa cB c1 cif clt wbr cB cB cr wcel cc0 cB clt wbr wa cB c1
      cif cr eleq1 cB cB cr wcel cc0 cB clt wbr wa cB c1 cif cc0 clt breq2
      anbi12d c1 cB cr wcel cc0 cB clt wbr wa cB c1 cif wceq c1 cr wcel cB cr
      wcel cc0 cB clt wbr wa cB c1 cif cr wcel cc0 c1 clt wbr cc0 cB cr wcel
      cc0 cB clt wbr wa cB c1 cif clt wbr c1 cB cr wcel cc0 cB clt wbr wa cB c1
      cif cr eleq1 c1 cB cr wcel cc0 cB clt wbr wa cB c1 cif cc0 clt breq2
      anbi12d c1 cr wcel cc0 c1 clt wbr 1re lt01 pm3.2i elimhyp expcnvlem4
      dedth2h $.
      $( [20-Mar-2005] $) $( [27-Feb-2005] $)

    $( Lemma for ~ expcnv .  Add in the case of ` A = 0 ` . $)
    expcnvlem6 $p |- ( ( ( A e. RR /\ 0 <_ A /\ A < 1 ) /\ ( B e. RR
        /\ 0 < B ) ) -> E. x e. NN A. y e. NN ( x <_ y -> ( A ^ y ) < B ) ) $=
      cA cr wcel cc0 cA cle wbr cA c1 clt wbr cB cr wcel cc0 cB clt wbr wa vx
      cv vy cv cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex cA
      cr wcel cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cA c1 clt wbr cB cr
      wcel cc0 cB clt wbr wa vx cv vy cv cle wbr cA vy cv cexp co cB clt wbr wi
      vy cn wral vx cn wrex wi wi cc0 cr wcel cA cr wcel cc0 cA cle wbr cc0 cA
      clt wbr cc0 cA wceq wo wb 0re cc0 cA leloe mpan cA cr wcel cc0 cA clt wbr
      cA c1 clt wbr cB cr wcel cc0 cB clt wbr wa vx cv vy cv cle wbr cA vy cv
      cexp co cB clt wbr wi vy cn wral vx cn wrex wi wi cc0 cA wceq cA cr wcel
      cc0 cA clt wbr cA c1 clt wbr cB cr wcel cc0 cB clt wbr wa vx cv vy cv cle
      wbr cA vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex vx vy cA cB
      expcnvlem5 3exp1 cc0 cA wceq cA c1 clt wbr cB cr wcel cc0 cB clt wbr wa
      vx cv vy cv cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex
      wi wi wi cA cr wcel cc0 cA wceq cB cr wcel cc0 cB clt wbr wa vx cv vy cv
      cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex wi cA c1 clt
      wbr cc0 cA wceq cc0 cB clt wbr vx cv vy cv cle wbr cA vy cv cexp co cB
      clt wbr wi vy cn wral vx cn wrex cB cr wcel cc0 cA wceq cc0 cB clt wbr c1
      cn wcel c1 vy cv cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral wa vx
      cv vy cv cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral vx cn wrex cc0
      cA wceq cc0 cB clt wbr c1 cn wcel c1 vy cv cle wbr cA vy cv cexp co cB
      clt wbr wi vy cn wral cc0 cA wceq cc0 cB clt wbr c1 cn wcel 1nn a1i12 cc0
      cA wceq cc0 cB clt wbr c1 vy cv cle wbr cA vy cv cexp co cB clt wbr wi vy
      cn cc0 cA wceq c1 vy cv cle wbr vy cv cn wcel cc0 cB clt wbr cA vy cv
      cexp co cB clt wbr cc0 cA wceq vy cv cn wcel cc0 cB clt wbr cA vy cv cexp
      co cB clt wbr wi wi c1 vy cv cle wbr cc0 cA wceq vy cv cn wcel cc0 cB clt
      wbr cA vy cv cexp co cB clt wbr wi cc0 cA wceq vy cv cn wcel wa cc0 cB
      clt wbr cA vy cv cexp co cB clt wbr cc0 cA wceq vy cv cn wcel wa cc0 vy
      cv cexp co cB clt wbr cc0 cB clt wbr cA vy cv cexp co cB clt wbr vy cv cn
      wcel cc0 vy cv cexp co cB clt wbr cc0 cB clt wbr wb cc0 cA wceq vy cv cn
      wcel cc0 vy cv cexp co cc0 cB clt vy cv 0exp breq1d adantl cc0 cA wceq
      cc0 vy cv cexp co cB clt wbr cA vy cv cexp co cB clt wbr wb vy cv cn wcel
      cc0 cA wceq cc0 vy cv cexp co cA vy cv cexp co cB clt cc0 cA vy cv cexp
      opreq1 breq1d adantr bitr3d biimpd ex a1d com24 r19.21adv jcad vx cv vy
      cv cle wbr cA vy cv cexp co cB clt wbr wi vy cn wral c1 vy cv cle wbr cA
      vy cv cexp co cB clt wbr wi vy cn wral vx c1 cn vx cv c1 wceq vx cv vy cv
      cle wbr cA vy cv cexp co cB clt wbr wi c1 vy cv cle wbr cA vy cv cexp co
      cB clt wbr wi vy cn vx cv c1 wceq vx cv vy cv cle wbr c1 vy cv cle wbr cA
      vy cv cexp co cB clt wbr vx cv c1 vy cv cle breq1 imbi1d ralbidv rcla4ev
      syl6 adantld a1d a1i jaod sylbid 3imp1 $.
      $( [20-Mar-2005] $) $( [27-Feb-2005] $)
  $}

  ${
    $d j k x A $.  $d j x k F $.
    expcnv.1 $e |- F e. _V $.
    $( A sequence of powers of a complex number ` A ` with absolute value
       smaller than 1 converges to zero. $)
    expcnv $p |- ( ( A e. CC /\ A. k e. NN ( F ` k ) = ( A ^ k ) /\
                 ( abs ` A ) < 1 ) -> F ~~> 0 ) $=
      cA cc wcel vk cv cF cfv cA vk cv cexp co wceq vk cn wral cA cabs cfv c1
      clt wbr w3a cF cc0 cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral cA cc
      wcel vk cv cF cfv cA vk cv cexp co wceq vk cn wral cA cabs cfv c1 clt wbr
      w3a cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr cA cc wcel vk cv cF cfv cA vk cv
      cexp co wceq vk cn wral cA cabs cfv c1 clt wbr vx cv cr wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex wi wi cA cc wcel vk cv cF cfv cA vk cv cexp co wceq vk cn
      wral wa cA cabs cfv c1 clt wbr wa vx cv cr wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn
      wrex cA cc wcel vk cv cF cfv cA vk cv cexp co wceq vk cn wral wa cA cabs
      cfv c1 clt wbr wa vx cv cr wcel cc0 vx cv clt wbr wa wa vj cv vk cv cle
      wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex vj cv vk
      cv cle wbr cA cabs cfv vk cv cexp co vx cv clt wbr wi vk cn wral vj cn
      wrex cA cc wcel cA cabs cfv c1 clt wbr vx cv cr wcel cc0 vx cv clt wbr wa
      vj cv vk cv cle wbr cA cabs cfv vk cv cexp co vx cv clt wbr wi vk cn wral
      vj cn wrex vk cv cF cfv cA vk cv cexp co wceq vk cn wral cA cabs cfv cr
      wcel cc0 cA cabs cfv cle wbr cA cabs cfv c1 clt wbr w3a vx cv cr wcel cc0
      vx cv clt wbr wa vj cv vk cv cle wbr cA cabs cfv vk cv cexp co vx cv clt
      wbr wi vk cn wral vj cn wrex cA cc wcel cA cabs cfv c1 clt wbr wa vj vk
      cA cabs cfv vx cv expcnvlem6 cA cc wcel cA cabs cfv c1 clt wbr wa cA cabs
      cfv cr wcel cc0 cA cabs cfv cle wbr cA cabs cfv c1 clt wbr cA cc wcel cA
      cabs cfv cr wcel cA cabs cfv c1 clt wbr cA abscl adantr cA cc wcel cc0 cA
      cabs cfv cle wbr cA cabs cfv c1 clt wbr cA absge0 adantr cA cc wcel cA
      cabs cfv c1 clt wbr pm3.27 3jca sylan adantllr cA cc wcel vk cv cF cfv cA
      vk cv cexp co wceq vk cn wral wa vj cv vk cv cle wbr vk cv cF cfv cabs
      cfv vx cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr cA cabs
      cfv vk cv cexp co vx cv clt wbr wi vk cn wral vj cn wrex wb cA cabs cfv
      c1 clt wbr vx cv cr wcel cc0 vx cv clt wbr wa cA cc wcel vk cv cF cfv cA
      vk cv cexp co wceq vk cn wral wa vj cv vk cv cle wbr vk cv cF cfv cabs
      cfv vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr cA cabs cfv vk cv
      cexp co vx cv clt wbr wi vk cn wral vj cn cA cc wcel vk cv cF cfv cA vk
      cv cexp co wceq vk cn wral wa vj cv vk cv cle wbr vk cv cF cfv cabs cfv
      vx cv clt wbr wi vj cv vk cv cle wbr cA cabs cfv vk cv cexp co vx cv clt
      wbr wi wb vk cn wral vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt
      wbr wi vk cn wral vj cv vk cv cle wbr cA cabs cfv vk cv cexp co vx cv clt
      wbr wi vk cn wral wb cA cc wcel vk cv cF cfv cA vk cv cexp co wceq vk cn
      wral vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vj cv vk
      cv cle wbr cA cabs cfv vk cv cexp co vx cv clt wbr wi wb vk cn wral cA cc
      wcel vk cv cF cfv cA vk cv cexp co wceq vj cv vk cv cle wbr vk cv cF cfv
      cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr cA cabs cfv vk cv cexp co
      vx cv clt wbr wi wb vk cn cA cc wcel vk cv cn wcel wa vk cv cF cfv cA vk
      cv cexp co wceq vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr
      wi vj cv vk cv cle wbr cA cabs cfv vk cv cexp co vx cv clt wbr wi wb cA
      cc wcel vk cv cn wcel wa vk cv cF cfv cA vk cv cexp co wceq wa vk cv cF
      cfv cabs cfv vx cv clt wbr cA cabs cfv vk cv cexp co vx cv clt wbr vj cv
      vk cv cle wbr cA cc wcel vk cv cn wcel wa vk cv cF cfv cA vk cv cexp co
      wceq wa vk cv cF cfv cabs cfv cA cabs cfv vk cv cexp co vx cv clt vk cv
      cF cfv cA vk cv cexp co wceq cA cc wcel vk cv cn wcel wa vk cv cF cfv
      cabs cfv cA vk cv cexp co cabs cfv cA cabs cfv vk cv cexp co vk cv cF cfv
      cA vk cv cexp co cabs fveq2 cA cc wcel vk cv cn0 wcel cA vk cv cexp co
      cabs cfv cA cabs cfv vk cv cexp co wceq vk cv cn wcel cA vk cv absexp vk
      cv nnnn0 sylan2 sylan9eqr breq1d imbi2d ex r19.20dva imp vj cv vk cv cle
      wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vj cv vk cv cle wbr cA cabs
      cfv vk cv cexp co vx cv clt wbr wi vk cn r19.15 syl rexbidv ad2antrr
      mpbird exp32 3impa r19.21aiv cA cc wcel vk cv cF cfv cA vk cv cexp co
      wceq vk cn wral cF cc0 cli wbr cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv cF cfv cabs cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral
      wb cA cabs cfv c1 clt wbr cA cc wcel vk cv cF cfv cA vk cv cexp co wceq
      vk cn wral wa vk cv cF cfv cc wcel vk cn wral cF cc0 cli wbr cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cabs cfv vx cv clt wbr wi vk cn
      wral vj cn wrex wi vx cr wral wb cA cc wcel vk cv cF cfv cA vk cv cexp co
      wceq vk cn wral vk cv cF cfv cc wcel vk cn wral cA cc wcel vk cv cF cfv
      cA vk cv cexp co wceq vk cv cF cfv cc wcel vk cn vk cv cF cfv cA vk cv
      cexp co wceq vk cv cF cfv cc wcel cA vk cv cexp co cc wcel cA cc wcel vk
      cv cn wcel wa vk cv cF cfv cA vk cv cexp co cc eleq1 cA cc wcel vk cv cn0
      wcel cA vk cv cexp co cc wcel vk cv cn wcel cA vk cv expcl vk cv nnnn0
      sylan2 syl5cbir r19.20dva imp vx vj vk cF c1 c1 cn cn 1z cn c1 cuz cfv
      nnuz eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz expcnv.1 clm0i
      syl 3adant3 mpbird $.
      $( [9-May-2006] $) $( [8-May-2006] $)

    $( A sequence of terms converges to zero when it is less than powers of a
       number ` A ` whose absolute value is smaller than 1. $)
    explecnv $p |- ( ( A e. RR /\ ( abs ` A ) < 1 /\ A. k e. NN
      ( ( F ` k ) e. CC /\ ( abs ` ( F ` k ) ) <_ ( A ^ k ) ) ) -> F ~~> 0 ) $=
      cA cr wcel cA cabs cfv c1 clt wbr vk cv cF cfv cc wcel vk cv cF cfv cabs
      cfv cA vk cv cexp co cle wbr wa vk cn wral w3a cF cc0 cli wbr vj cv cn
      wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cc0 cli wbr vj cv cn
      wcel vx cv cA vj cv cexp co wceq wa vj vx copab cc0 cli wbr vk cv vj cv
      cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj
      cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa
      cc0 vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab
      cfv cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab
      cfv cle wbr wa wa vk cn wral vj cv cn wcel vx cv vj cv cF cfv cabs cfv
      wceq wa vj vx copab cc0 cli wbr cA cr wcel cA cabs cfv c1 clt wbr vk cv
      cF cfv cc wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa vk cn
      wral w3a vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cc0 cli
      wbr vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cr
      wcel vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab
      cfv cr wcel wa cc0 vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq
      wa vj vx copab cfv cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv cabs
      cfv wceq wa vj vx copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp co
      wceq wa vj vx copab cfv cle wbr wa wa vk c1 cuz cfv wral vj cv cn wcel vx
      cv vj cv cF cfv cabs cfv wceq wa vj vx copab cc0 cli wbr vk cv vj cv cn
      wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv
      cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa
      cc0 vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab
      cfv cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab
      cfv cle wbr wa wa vk cn wral vj cv cn wcel vx cv cA vj cv cexp co wceq wa
      vj vx copab cc0 cli wbr c1 cz wcel vk cv vj cv cn wcel vx cv cA vj cv
      cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv cn wcel vx cv vj cv
      cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa cc0 vk cv vj cv cn
      wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr vk cv vj
      cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv vk cv vj
      cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cle wbr wa wa
      vk c1 cuz cfv wral vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj
      vx copab cc0 cli wbr 1z cc0 vk vj cv cn wcel vx cv cA vj cv cexp co wceq
      wa vj vx copab vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab c1 vj vx cn cA vj cv cexp co nnex opabex2 vj vx cn vj cv cF cfv
      cabs cfv nnex opabex2 cc0 cc 0cn elisseti climsqueeze2 mp3an2 cn c1 cuz
      cfv wceq vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab
      cfv cr wcel vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab cfv cr wcel wa cc0 vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv
      wceq wa vj vx copab cfv cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv
      cabs cfv wceq wa vj vx copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp
      co wceq wa vj vx copab cfv cle wbr wa wa vk cn wral vk cv vj cv cn wcel
      vx cv cA vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv cn
      wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa cc0
      vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv
      cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab
      cfv cle wbr wa wa vk c1 cuz cfv wral wb nnuz vk cv vj cv cn wcel vx cv cA
      vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv cn wcel vx cv
      vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa cc0 vk cv vj cv
      cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr vk cv
      vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv vk cv
      vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cle wbr wa
      wa vk cn c1 cuz cfv raleq1 ax-mp sylan2b cA cr wcel cA cabs cfv c1 clt
      wbr vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cc0 cli wbr
      vk cv cF cfv cc wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa vk
      cn wral cA cc wcel cA cabs cfv c1 clt wbr vj cv cn wcel vx cv cA vj cv
      cexp co wceq wa vj vx copab cc0 cli wbr cA cr wcel cA cc wcel vk cv vj cv
      cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cA vk cv cexp co
      wceq vk cn wral cA cabs cfv c1 clt wbr vj cv cn wcel vx cv cA vj cv cexp
      co wceq wa vj vx copab cc0 cli wbr vk cv vj cv cn wcel vx cv cA vj cv
      cexp co wceq wa vj vx copab cfv cA vk cv cexp co wceq vk cn vj vx vk cv
      cA vj cv cexp co cA vk cv cexp co cn vj cv cn wcel vx cv cA vj cv cexp co
      wceq wa vj vx copab vj cv vk cv cA cexp opreq2 vj cv cn wcel vx cv cA vj
      cv cexp co wceq wa vj vx copab eqid cA vk cv cexp oprex fvopab4 rgen cA
      vk vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab vj vx cn cA
      vj cv cexp co nnex opabex2 expcnv mp3an2 cA recn sylan 3adant3 cA cr wcel
      cA cabs cfv c1 clt wbr vk cv cF cfv cc wcel vk cv cF cfv cabs cfv cA vk
      cv cexp co cle wbr wa vk cn wral vk cv vj cv cn wcel vx cv cA vj cv cexp
      co wceq wa vj vx copab cfv cr wcel vk cv vj cv cn wcel vx cv vj cv cF cfv
      cabs cfv wceq wa vj vx copab cfv cr wcel wa cc0 vk cv vj cv cn wcel vx cv
      vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr vk cv vj cv cn wcel
      vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv vk cv vj cv cn wcel
      vx cv cA vj cv cexp co wceq wa vj vx copab cfv cle wbr wa wa vk cn wral
      cA cr wcel cA cabs cfv c1 clt wbr wa vk cv cF cfv cc wcel vk cv cF cfv
      cabs cfv cA vk cv cexp co cle wbr wa vk cv vj cv cn wcel vx cv cA vj cv
      cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv cn wcel vx cv vj cv
      cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa cc0 vk cv vj cv cn
      wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr vk cv vj
      cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv vk cv vj
      cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cle wbr wa wa
      vk cn cA cr wcel cA cabs cfv c1 clt wbr wa vk cv cn wcel wa vk cv cF cfv
      cc wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa cA vk cv cexp
      co cr wcel vk cv cF cfv cabs cfv cr wcel wa cc0 vk cv cF cfv cabs cfv cle
      wbr vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa wa vk cv vj cv cn
      wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv
      cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa
      cc0 vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab
      cfv cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab
      cfv cle wbr wa wa cA cr wcel cA cabs cfv c1 clt wbr wa vk cv cn wcel wa
      vk cv cF cfv cc wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa cA
      vk cv cexp co cr wcel vk cv cF cfv cabs cfv cr wcel wa cc0 vk cv cF cfv
      cabs cfv cle wbr vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa cA cr
      wcel cA cabs cfv c1 clt wbr wa vk cv cn wcel wa vk cv cF cfv cc wcel vk
      cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa vk cv cF cfv cabs cfv cr
      wcel cA vk cv cexp co cr wcel vk cv cF cfv cc wcel vk cv cF cfv cabs cfv
      cA vk cv cexp co cle wbr wa vk cv cF cfv cabs cfv cr wcel wi cA cr wcel
      cA cabs cfv c1 clt wbr wa vk cv cn wcel wa vk cv cF cfv cc wcel vk cv cF
      cfv cabs cfv cr wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr vk cv
      cF cfv abscl adantr a1i cA cr wcel vk cv cn wcel cA vk cv cexp co cr wcel
      cA cabs cfv c1 clt wbr cA cr wcel vk cv cn0 wcel cA vk cv cexp co cr wcel
      vk cv cn wcel cA vk cv reexpcl vk cv nnnn0 sylan2 adantlr jctild cA cr
      wcel cA cabs cfv c1 clt wbr wa vk cv cn wcel wa vk cv cF cfv cc wcel vk
      cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa cc0 vk cv cF cfv cabs cfv
      cle wbr vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr vk cv cF cfv cc
      wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa cc0 vk cv cF cfv
      cabs cfv cle wbr wi cA cr wcel cA cabs cfv c1 clt wbr wa vk cv cn wcel wa
      vk cv cF cfv cc wcel cc0 vk cv cF cfv cabs cfv cle wbr vk cv cF cfv cabs
      cfv cA vk cv cexp co cle wbr vk cv cF cfv absge0 adantr a1i vk cv cF cfv
      cc wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa vk cv cF cfv
      cabs cfv cA vk cv cexp co cle wbr wi cA cr wcel cA cabs cfv c1 clt wbr wa
      vk cv cn wcel wa vk cv cF cfv cc wcel vk cv cF cfv cabs cfv cA vk cv cexp
      co cle wbr pm3.27 a1i jcad jcad vk cv cn wcel vk cv vj cv cn wcel vx cv
      cA vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv cn wcel vx
      cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa cc0 vk cv vj
      cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr vk
      cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv vk
      cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cle wbr
      wa wa cA vk cv cexp co cr wcel vk cv cF cfv cabs cfv cr wcel wa cc0 vk cv
      cF cfv cabs cfv cle wbr vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa
      wa wb cA cr wcel cA cabs cfv c1 clt wbr wa vk cv cn wcel vk cv vj cv cn
      wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cr wcel vk cv vj cv
      cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel wa cA
      vk cv cexp co cr wcel vk cv cF cfv cabs cfv cr wcel wa cc0 vk cv vj cv cn
      wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr vk cv vj
      cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv vk cv vj
      cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx copab cfv cle wbr wa cc0
      vk cv cF cfv cabs cfv cle wbr vk cv cF cfv cabs cfv cA vk cv cexp co cle
      wbr wa vk cv cn wcel vk cv vj cv cn wcel vx cv cA vj cv cexp co wceq wa
      vj vx copab cfv cr wcel cA vk cv cexp co cr wcel vk cv vj cv cn wcel vx
      cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cr wcel vk cv cF cfv
      cabs cfv cr wcel vk cv cn wcel vk cv vj cv cn wcel vx cv cA vj cv cexp co
      wceq wa vj vx copab cfv cA vk cv cexp co cr vj vx vk cv cA vj cv cexp co
      cA vk cv cexp co cn vj cv cn wcel vx cv cA vj cv cexp co wceq wa vj vx
      copab vj cv vk cv cA cexp opreq2 vj cv cn wcel vx cv cA vj cv cexp co
      wceq wa vj vx copab eqid cA vk cv cexp oprex fvopab4 eleq1d vk cv cn wcel
      vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv
      vk cv cF cfv cabs cfv cr vj vx vk cv vj cv cF cfv cabs cfv vk cv cF cfv
      cabs cfv cn vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab
      vj cv vk cv wceq vj cv cF cfv vk cv cF cfv cabs vj cv vk cv cF fveq2
      fveq2d vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab eqid
      vk cv cF cfv cabs fvex fvopab4 eleq1d anbi12d vk cv cn wcel cc0 vk cv vj
      cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab cfv cle wbr
      cc0 vk cv cF cfv cabs cfv cle wbr vk cv vj cv cn wcel vx cv vj cv cF cfv
      cabs cfv wceq wa vj vx copab cfv vk cv vj cv cn wcel vx cv cA vj cv cexp
      co wceq wa vj vx copab cfv cle wbr vk cv cF cfv cabs cfv cA vk cv cexp co
      cle wbr vk cv cn wcel vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv
      wceq wa vj vx copab cfv vk cv cF cfv cabs cfv cc0 cle vj vx vk cv vj cv
      cF cfv cabs cfv vk cv cF cfv cabs cfv cn vj cv cn wcel vx cv vj cv cF cfv
      cabs cfv wceq wa vj vx copab vj cv vk cv wceq vj cv cF cfv vk cv cF cfv
      cabs vj cv vk cv cF fveq2 fveq2d vj cv cn wcel vx cv vj cv cF cfv cabs
      cfv wceq wa vj vx copab eqid vk cv cF cfv cabs fvex fvopab4 breq2d vk cv
      cn wcel vk cv vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx
      copab cfv vk cv cF cfv cabs cfv vk cv vj cv cn wcel vx cv cA vj cv cexp
      co wceq wa vj vx copab cfv cA vk cv cexp co cle vj vx vk cv vj cv cF cfv
      cabs cfv vk cv cF cfv cabs cfv cn vj cv cn wcel vx cv vj cv cF cfv cabs
      cfv wceq wa vj vx copab vj cv vk cv wceq vj cv cF cfv vk cv cF cfv cabs
      vj cv vk cv cF fveq2 fveq2d vj cv cn wcel vx cv vj cv cF cfv cabs cfv
      wceq wa vj vx copab eqid vk cv cF cfv cabs fvex fvopab4 vj vx vk cv cA vj
      cv cexp co cA vk cv cexp co cn vj cv cn wcel vx cv cA vj cv cexp co wceq
      wa vj vx copab vj cv vk cv cA cexp opreq2 vj cv cn wcel vx cv cA vj cv
      cexp co wceq wa vj vx copab eqid cA vk cv cexp oprex fvopab4 breq12d
      anbi12d anbi12d adantl sylibrd r19.20dva 3impia sylanc vk cv cF cfv cc
      wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr wa vk cn wral cA cr
      wcel cF cc0 cli wbr vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj
      vx copab cc0 cli wbr wb cA cabs cfv c1 clt wbr vk cv cF cfv cc wcel vk cv
      cF cfv cabs cfv cA vk cv cexp co cle wbr wa vk cn wral vk cv cF cfv cc
      wcel vk cn wral cF cc0 cli wbr vj cv cn wcel vx cv vj cv cF cfv cabs cfv
      wceq wa vj vx copab cc0 cli wbr wb vk cv cF cfv cc wcel vk cv cF cfv cabs
      cfv cA vk cv cexp co cle wbr wa vk cv cF cfv cc wcel vk cn vk cv cF cfv
      cc wcel vk cv cF cfv cabs cfv cA vk cv cexp co cle wbr pm3.26 r19.20si vk
      cF vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa vj vx copab expcnv.1
      vj vx cn vj cv cF cfv cabs cfv nnex opabex2 vj vx vk cv vj cv cF cfv cabs
      cfv vk cv cF cfv cabs cfv cn vj cv cn wcel vx cv vj cv cF cfv cabs cfv
      wceq wa vj vx copab vj cv vk cv wceq vj cv cF cfv vk cv cF cfv cabs vj cv
      vk cv cF fveq2 fveq2d vj cv cn wcel vx cv vj cv cF cfv cabs cfv wceq wa
      vj vx copab eqid vk cv cF cfv cabs fvex fvopab4 climabs0i syl 3ad2ant3
      mpbird $.
      $( [18-Mar-2009] $) $( [19-Jul-2008] $)
  $}

  ${
    $d j k m n y z A $.  $d j m n z F $.  $d j N $.  $d n G $.
    geoser.1 $e |- F = { <. k , y >. | ( k e. NN0 /\ y = ( A ^ k ) ) } $.
    geoser.2 $e |- A e. CC $.
    $( The value of the finite geometric series ` 1 + A ^ 1 + A ^ 2 + ` ...
       ` + A ^ N ` . $)
    geoseri $p |- ( ( N e. NN0 /\ A =/= 1 ) -> ( ( + seq0 F ) ` N ) =
                 ( ( 1 - ( A ^ ( N + 1 ) ) ) / ( 1 - A ) ) ) $=
      cN cn0 wcel cA c1 wne wa cN caddc cF cseq0 co cfv c1 cA cmin co cmul co
      c1 cA cmin co cdiv co cN caddc cF cseq0 co cfv c1 cA cN c1 caddc co cexp
      co cmin co c1 cA cmin co cdiv co cN caddc cF cseq0 co cfv cc wcel c1 cA
      cmin co cc0 wne cN caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA cmin
      co cdiv co cN caddc cF cseq0 co cfv wceq cN cn0 wcel cA c1 wne cN caddc
      cF cseq0 co cfv cc wcel c1 cA cmin co cc wcel c1 cA cmin co cc0 wne cN
      caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA cmin co cdiv co cN
      caddc cF cseq0 co cfv wceq c1 cA ax1cn geoser.2 subcli cN caddc cF cseq0
      co cfv c1 cA cmin co divcan4 mp3an2 cF cN vk vy cn0 cc cA vk cv cexp co
      cF geoser.1 cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel geoser.2
      cA vk cv expcl mpan fopab ser0cl1i cA c1 wne c1 cA cmin co cc0 wne cA c1
      c1 cA cmin co cc0 cA cA cmin co c1 cA cmin co wceq cc0 c1 cA cmin co wceq
      cA c1 wceq c1 cA cmin co cc0 wceq cA cA cmin co cc0 c1 cA cmin co cA
      geoser.2 subidi eqeq1i cA c1 cA geoser.2 ax1cn geoser.2 subcan2i cc0 c1
      cA cmin co eqcom 3bitr3i necon3bii biimpi syl2an cN cn0 wcel cN caddc cF
      cseq0 co cfv c1 cA cmin co cmul co c1 cA cmin co cdiv co c1 cA cN c1
      caddc co cexp co cmin co c1 cA cmin co cdiv co wceq cA c1 wne cN cn0 wcel
      cN caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA cN c1 caddc co cexp
      co cmin co c1 cA cmin co cdiv vj cv caddc cF cseq0 co cfv c1 cA cmin co
      cmul co c1 cA vj cv c1 caddc co cexp co cmin co wceq cc0 caddc cF cseq0
      co cfv c1 cA cmin co cmul co c1 cA cc0 c1 caddc co cexp co cmin co wceq
      vm cv caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA vm cv c1 caddc co
      cexp co cmin co wceq vm cv c1 caddc co caddc cF cseq0 co cfv c1 cA cmin
      co cmul co c1 cA vm cv c1 caddc co c1 caddc co cexp co cmin co wceq cN
      caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA cN c1 caddc co cexp co
      cmin co wceq vj vm cN vm cv cn0 wcel vm cv caddc cF cseq0 co cfv c1 cA
      cmin co cmul co c1 cA vm cv c1 caddc co cexp co cmin co wceq vm cv c1
      caddc co caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA vm cv c1 caddc
      co c1 caddc co cexp co cmin co wceq vm cv cn0 wcel vm cv caddc cF cseq0
      co cfv c1 cA cmin co cmul co c1 cA vm cv c1 caddc co cexp co cmin co wceq
      wa vm cv c1 caddc co caddc cF cseq0 co cfv c1 cA cmin co cmul co vm cv
      caddc cF cseq0 co cfv c1 cA cmin co cmul co cA vm cv c1 caddc co cexp co
      c1 cA cmin co cmul co caddc co c1 cA vm cv c1 caddc co c1 caddc co cexp
      co cmin co vm cv cn0 wcel vm cv c1 caddc co caddc cF cseq0 co cfv c1 cA
      cmin co cmul co vm cv caddc cF cseq0 co cfv c1 cA cmin co cmul co cA vm
      cv c1 caddc co cexp co c1 cA cmin co cmul co caddc co wceq vm cv caddc cF
      cseq0 co cfv c1 cA cmin co cmul co c1 cA vm cv c1 caddc co cexp co cmin
      co wceq vm cv cn0 wcel vm cv c1 caddc co caddc cF cseq0 co cfv c1 cA cmin
      co cmul co vm cv caddc cF cseq0 co cfv cA vm cv c1 caddc co cexp co caddc
      co c1 cA cmin co cmul co vm cv caddc cF cseq0 co cfv c1 cA cmin co cmul
      co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co caddc co vm cv cn0
      wcel vm cv c1 caddc co caddc cF cseq0 co cfv vm cv caddc cF cseq0 co cfv
      cA vm cv c1 caddc co cexp co caddc co c1 cA cmin co cmul vy cA vk cv cexp
      co cA vm cv c1 caddc co cexp co vk cF vm cv geoser.1 cA vm cv c1 caddc co
      cexp oprex vk cv vm cv c1 caddc co cA cexp opreq2 ser0p1i opreq1d vm cv
      caddc cF cseq0 co cfv cc wcel cA vm cv c1 caddc co cexp co cc wcel vm cv
      caddc cF cseq0 co cfv cA vm cv c1 caddc co cexp co caddc co c1 cA cmin co
      cmul co vm cv caddc cF cseq0 co cfv c1 cA cmin co cmul co cA vm cv c1
      caddc co cexp co c1 cA cmin co cmul co caddc co wceq vm cv cn0 wcel vm cv
      caddc cF cseq0 co cfv cc wcel cA vm cv c1 caddc co cexp co cc wcel c1 cA
      cmin co cc wcel vm cv caddc cF cseq0 co cfv cA vm cv c1 caddc co cexp co
      caddc co c1 cA cmin co cmul co vm cv caddc cF cseq0 co cfv c1 cA cmin co
      cmul co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co caddc co wceq
      c1 cA ax1cn geoser.2 subcli vm cv caddc cF cseq0 co cfv cA vm cv c1 caddc
      co cexp co c1 cA cmin co adddir mp3an3 cF vm cv vk vy cn0 cc cA vk cv
      cexp co cF geoser.1 cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel
      geoser.2 cA vk cv expcl mpan fopab ser0cl1i cA cc wcel vm cv c1 caddc co
      cn0 wcel cA vm cv c1 caddc co cexp co cc wcel vm cv cn0 wcel cA vm cv c1
      caddc co expcl geoser.2 vm cv peano2nn0 sylancr sylanc eqtrd adantr vm cv
      caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA vm cv c1 caddc co cexp
      co cmin co wceq vm cv cn0 wcel vm cv caddc cF cseq0 co cfv c1 cA cmin co
      cmul co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co caddc co c1 cA
      vm cv c1 caddc co cexp co cmin co cA vm cv c1 caddc co cexp co c1 cA cmin
      co cmul co caddc co c1 cA vm cv c1 caddc co c1 caddc co cexp co cmin co
      vm cv caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA vm cv c1 caddc co
      cexp co cmin co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co caddc
      opreq1 vm cv cn0 wcel c1 cA vm cv c1 caddc co c1 caddc co cexp co cmin co
      c1 cA vm cv c1 caddc co cexp co cA cmul co cmin co c1 cA vm cv c1 caddc
      co cexp co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co cmin co
      cmin co c1 cA vm cv c1 caddc co cexp co cmin co cA vm cv c1 caddc co cexp
      co c1 cA cmin co cmul co caddc co vm cv cn0 wcel cA vm cv c1 caddc co c1
      caddc co cexp co cA vm cv c1 caddc co cexp co cA cmul co c1 cmin cA cc
      wcel vm cv c1 caddc co cn0 wcel cA vm cv c1 caddc co c1 caddc co cexp co
      cA vm cv c1 caddc co cexp co cA cmul co wceq vm cv cn0 wcel cA vm cv c1
      caddc co expp1 geoser.2 vm cv peano2nn0 sylancr opreq2d vm cv cn0 wcel cA
      vm cv c1 caddc co cexp co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul
      co cmin co cA vm cv c1 caddc co cexp co cA cmul co c1 cmin vm cv cn0 wcel
      cA vm cv c1 caddc co cexp co c1 cmul co cA vm cv c1 caddc co cexp co c1
      cA cmin co cmul co cmin co cA vm cv c1 caddc co cexp co cA vm cv c1 caddc
      co cexp co c1 cA cmin co cmul co cmin co cA vm cv c1 caddc co cexp co cA
      cmul co vm cv cn0 wcel cA vm cv c1 caddc co cexp co c1 cmul co cA vm cv
      c1 caddc co cexp co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co
      cmin vm cv cn0 wcel cA vm cv c1 caddc co cexp co cc wcel cA vm cv c1
      caddc co cexp co c1 cmul co cA vm cv c1 caddc co cexp co wceq cA cc wcel
      vm cv c1 caddc co cn0 wcel cA vm cv c1 caddc co cexp co cc wcel vm cv cn0
      wcel cA vm cv c1 caddc co expcl geoser.2 vm cv peano2nn0 sylancr cA vm cv
      c1 caddc co cexp co ax1id syl opreq1d vm cv cn0 wcel cA vm cv c1 caddc co
      cexp co c1 c1 cA cmin co cmin co cmul co cA vm cv c1 caddc co cexp co c1
      cmul co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co cmin co cA vm
      cv c1 caddc co cexp co cA cmul co vm cv cn0 wcel cA vm cv c1 caddc co
      cexp co cc wcel cA vm cv c1 caddc co cexp co c1 c1 cA cmin co cmin co
      cmul co cA vm cv c1 caddc co cexp co c1 cmul co cA vm cv c1 caddc co cexp
      co c1 cA cmin co cmul co cmin co wceq cA cc wcel vm cv c1 caddc co cn0
      wcel cA vm cv c1 caddc co cexp co cc wcel vm cv cn0 wcel cA vm cv c1
      caddc co expcl geoser.2 vm cv peano2nn0 sylancr cA vm cv c1 caddc co cexp
      co cc wcel c1 cc wcel c1 cA cmin co cc wcel cA vm cv c1 caddc co cexp co
      c1 c1 cA cmin co cmin co cmul co cA vm cv c1 caddc co cexp co c1 cmul co
      cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co cmin co wceq ax1cn c1
      cA ax1cn geoser.2 subcli cA vm cv c1 caddc co cexp co c1 c1 cA cmin co
      subdi mp3an23 syl c1 c1 cA cmin co cmin co cA cA vm cv c1 caddc co cexp
      co cmul c1 cc wcel cA cc wcel c1 c1 cA cmin co cmin co cA wceq ax1cn
      geoser.2 c1 cA nncan mp2an opreq2i syl5reqr eqtr3d opreq2d cA vm cv c1
      caddc co cexp co cc wcel cA vm cv c1 caddc co cexp co c1 cA cmin co cmul
      co cc wcel c1 cA vm cv c1 caddc co cexp co cA vm cv c1 caddc co cexp co
      c1 cA cmin co cmul co cmin co cmin co c1 cA vm cv c1 caddc co cexp co
      cmin co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co caddc co wceq
      vm cv cn0 wcel c1 cc wcel cA vm cv c1 caddc co cexp co cc wcel cA vm cv
      c1 caddc co cexp co c1 cA cmin co cmul co cc wcel c1 cA vm cv c1 caddc co
      cexp co cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co cmin co cmin
      co c1 cA vm cv c1 caddc co cexp co cmin co cA vm cv c1 caddc co cexp co
      c1 cA cmin co cmul co caddc co wceq ax1cn c1 cA vm cv c1 caddc co cexp co
      cA vm cv c1 caddc co cexp co c1 cA cmin co cmul co subsub mp3an1 cA cc
      wcel vm cv c1 caddc co cn0 wcel cA vm cv c1 caddc co cexp co cc wcel vm
      cv cn0 wcel cA vm cv c1 caddc co expcl geoser.2 vm cv peano2nn0 sylancr
      cA vm cv c1 caddc co cexp co cc wcel c1 cA cmin co cc wcel cA vm cv c1
      caddc co cexp co c1 cA cmin co cmul co cc wcel vm cv cn0 wcel cA vm cv c1
      caddc co cexp co c1 cA cmin co mulcl cA cc wcel vm cv c1 caddc co cn0
      wcel cA vm cv c1 caddc co cexp co cc wcel vm cv cn0 wcel cA vm cv c1
      caddc co expcl geoser.2 vm cv peano2nn0 sylancr c1 cA ax1cn geoser.2
      subcli sylancl sylanc 3eqtr2rd sylan9eqr eqtrd ex cA cc0 cexp co c1 cA
      cmin co cmul co c1 cA cmin co cc0 caddc cF cseq0 co cfv c1 cA cmin co
      cmul co c1 cA cc0 c1 caddc co cexp co cmin co cA cc0 cexp co c1 cA cmin
      co cmul co c1 c1 cA cmin co cmul co c1 cA cmin co cA cc0 cexp co c1 c1 cA
      cmin co cmul cA cc wcel cA cc0 cexp co c1 wceq geoser.2 cA exp0 ax-mp
      opreq1i c1 cA cmin co c1 cA ax1cn geoser.2 subcli mulid2i eqtri cc0 caddc
      cF cseq0 co cfv cA cc0 cexp co c1 cA cmin co cmul vy cA vk cv cexp co cA
      cc0 cexp co vk cF geoser.1 cA cc0 cexp oprex vk cv cc0 cA cexp opreq2
      ser00i opreq1i cA cc0 c1 caddc co cexp co cA c1 cmin cA cc0 c1 caddc co
      cexp co cA c1 cexp co cA cc0 c1 caddc co c1 cA cexp c1 ax1cn addid2i
      opreq2i cA cc wcel cA c1 cexp co cA wceq geoser.2 cA exp1 ax-mp eqtri
      opreq2i 3eqtr4i vj cv cc0 wceq vj cv caddc cF cseq0 co cfv c1 cA cmin co
      cmul co cc0 caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA vj cv c1
      caddc co cexp co cmin co c1 cA cc0 c1 caddc co cexp co cmin co vj cv cc0
      wceq vj cv caddc cF cseq0 co cfv cc0 caddc cF cseq0 co cfv c1 cA cmin co
      cmul vj cv cc0 caddc cF cseq0 co fveq2 opreq1d vj cv cc0 wceq cA vj cv c1
      caddc co cexp co cA cc0 c1 caddc co cexp co c1 cmin vj cv cc0 wceq vj cv
      c1 caddc co cc0 c1 caddc co cA cexp vj cv cc0 c1 caddc opreq1 opreq2d
      opreq2d eqeq12d vj cv vm cv wceq vj cv caddc cF cseq0 co cfv c1 cA cmin
      co cmul co vm cv caddc cF cseq0 co cfv c1 cA cmin co cmul co c1 cA vj cv
      c1 caddc co cexp co cmin co c1 cA vm cv c1 caddc co cexp co cmin co vj cv
      vm cv wceq vj cv caddc cF cseq0 co cfv vm cv caddc cF cseq0 co cfv c1 cA
      cmin co cmul vj cv vm cv caddc cF cseq0 co fveq2 opreq1d vj cv vm cv wceq
      cA vj cv c1 caddc co cexp co cA vm cv c1 caddc co cexp co c1 cmin vj cv
      vm cv wceq vj cv c1 caddc co vm cv c1 caddc co cA cexp vj cv vm cv c1
      caddc opreq1 opreq2d opreq2d eqeq12d vj cv vm cv c1 caddc co wceq vj cv
      caddc cF cseq0 co cfv c1 cA cmin co cmul co vm cv c1 caddc co caddc cF
      cseq0 co cfv c1 cA cmin co cmul co c1 cA vj cv c1 caddc co cexp co cmin
      co c1 cA vm cv c1 caddc co c1 caddc co cexp co cmin co vj cv vm cv c1
      caddc co wceq vj cv caddc cF cseq0 co cfv vm cv c1 caddc co caddc cF
      cseq0 co cfv c1 cA cmin co cmul vj cv vm cv c1 caddc co caddc cF cseq0 co
      fveq2 opreq1d vj cv vm cv c1 caddc co wceq cA vj cv c1 caddc co cexp co
      cA vm cv c1 caddc co c1 caddc co cexp co c1 cmin vj cv vm cv c1 caddc co
      wceq vj cv c1 caddc co vm cv c1 caddc co c1 caddc co cA cexp vj cv vm cv
      c1 caddc co c1 caddc opreq1 opreq2d opreq2d eqeq12d vj cv cN wceq vj cv
      caddc cF cseq0 co cfv c1 cA cmin co cmul co cN caddc cF cseq0 co cfv c1
      cA cmin co cmul co c1 cA vj cv c1 caddc co cexp co cmin co c1 cA cN c1
      caddc co cexp co cmin co vj cv cN wceq vj cv caddc cF cseq0 co cfv cN
      caddc cF cseq0 co cfv c1 cA cmin co cmul vj cv cN caddc cF cseq0 co fveq2
      opreq1d vj cv cN wceq cA vj cv c1 caddc co cexp co cA cN c1 caddc co cexp
      co c1 cmin vj cv cN wceq vj cv c1 caddc co cN c1 caddc co cA cexp vj cv
      cN c1 caddc opreq1 opreq2d opreq2d eqeq12d nn0indALT opreq1d adantr
      eqtr3d $.
      $( [15-May-2006] $) $( [12-May-2006] $)

    ${
      geolimilem.3 $e |- ( abs ` A ) < 1 $.
      geolimilem.4 $e |- G Fn NN0 $.
      geolimilem.5 $e |- ( n e. NN0 ->
               ( G ` n ) = ( -u ( A x. ( F ` n ) ) / ( 1 - A ) ) ) $.
      $( Lemma for ~ geolimi . $)
      geolimilem $p |- ( + seq0 F ) ~~> ( 1 / ( 1 - A ) ) $=
        caddc cF cseq0 co c1 c1 cA cmin co cdiv co cc0 caddc co c1 c1 cA cmin
        co cdiv co cli cG cc0 cli wbr c1 c1 cA cmin co cdiv co cc wcel wa cc0
        cz wcel vn cv cG cfv cc wcel vn cv caddc cF cseq0 co cfv c1 c1 cA cmin
        co cdiv co vn cv cG cfv caddc co wceq wa vn cc0 cuz cfv wral wa caddc
        cF cseq0 co c1 c1 cA cmin co cdiv co cc0 caddc co cli wbr cG cc0 cli
        wbr c1 c1 cA cmin co cdiv co cc wcel cG c1 c1 cA cmin co cdiv co cneg
        cA cmul co cc0 cmul co cc0 cli c1 c1 cA cmin co cdiv co cneg cA cmul co
        cc wcel cF cc0 cli wbr wa cc0 cz wcel vn cv cF cfv cc wcel vn cv cG cfv
        c1 c1 cA cmin co cdiv co cneg cA cmul co vn cv cF cfv cmul co wceq wa
        vn cc0 cuz cfv wral wa cG c1 c1 cA cmin co cdiv co cneg cA cmul co cc0
        cmul co cli wbr c1 c1 cA cmin co cdiv co cneg cA cmul co cc wcel cF cc0
        cli wbr c1 c1 cA cmin co cdiv co cneg cA c1 c1 cA cmin co cdiv co c1 cA
        cmin co c1 cA ax1cn geoser.2 subcli cA cc wcel c1 cr wcel cA cabs cfv
        c1 clt wbr c1 cA cmin co cc0 wne geoser.2 1re geolimilem.3 cA c1
        abssubne0 mp3an reccli negcli geoser.2 mulcli cA cc wcel vn cv cF cfv
        cA vn cv cexp co wceq vn cn wral cA cabs cfv c1 clt wbr cF cc0 cli wbr
        geoser.2 vn cv cF cfv cA vn cv cexp co wceq vn cn vn cv cn wcel vn cv
        cn0 wcel vn cv cF cfv cA vn cv cexp co wceq vn cv nnnn0 vk vy vn cv cA
        vk cv cexp co cA vn cv cexp co cn0 cF vk cv vn cv cA cexp opreq2
        geoser.1 cA vn cv cexp oprex fvopab4 syl rgen geolimilem.3 cA vn cF vk
        vy cn0 cA vk cv cexp co cF nn0ex geoser.1 fopabex2 expcnv mp3an pm3.2i
        cc0 cz wcel vn cv cF cfv cc wcel vn cv cG cfv c1 c1 cA cmin co cdiv co
        cneg cA cmul co vn cv cF cfv cmul co wceq wa vn cc0 cuz cfv wral 0z vn
        cv cF cfv cc wcel vn cv cG cfv c1 c1 cA cmin co cdiv co cneg cA cmul co
        vn cv cF cfv cmul co wceq wa vn cc0 cuz cfv vn cv cc0 cuz cfv wcel vn
        cv cn0 wcel vn cv cF cfv cc wcel vn cv cG cfv c1 c1 cA cmin co cdiv co
        cneg cA cmul co vn cv cF cfv cmul co wceq wa vn cv elnn0uz vn cv cn0
        wcel vn cv cF cfv cc wcel vn cv cG cfv c1 c1 cA cmin co cdiv co cneg cA
        cmul co vn cv cF cfv cmul co wceq cn0 cc vn cv cF vk vy cn0 cc cA vk cv
        cexp co cF geoser.1 cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel
        geoser.2 cA vk cv expcl mpan fopab ffvelrni vn cv cn0 wcel vn cv cG cfv
        cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv co c1 c1 cA cmin co
        cdiv co cneg cA cmul co vn cv cF cfv cmul co geolimilem.5 vn cv cn0
        wcel cA cneg vn cv cF cfv cmul co c1 cA cmin co cdiv co cA cneg c1 cA
        cmin co cdiv co vn cv cF cfv cmul co cA vn cv cF cfv cmul co cneg c1 cA
        cmin co cdiv co c1 c1 cA cmin co cdiv co cneg cA cmul co vn cv cF cfv
        cmul co vn cv cn0 wcel vn cv cF cfv cc wcel cA cneg vn cv cF cfv cmul
        co c1 cA cmin co cdiv co cA cneg c1 cA cmin co cdiv co vn cv cF cfv
        cmul co wceq cn0 cc vn cv cF vk vy cn0 cc cA vk cv cexp co cF geoser.1
        cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel geoser.2 cA vk cv
        expcl mpan fopab ffvelrni cA cneg cc wcel vn cv cF cfv cc wcel c1 cA
        cmin co cc wcel c1 cA cmin co cc0 wne wa cA cneg vn cv cF cfv cmul co
        c1 cA cmin co cdiv co cA cneg c1 cA cmin co cdiv co vn cv cF cfv cmul
        co wceq cA geoser.2 negcli c1 cA cmin co cc wcel c1 cA cmin co cc0 wne
        c1 cA ax1cn geoser.2 subcli cA cc wcel c1 cr wcel cA cabs cfv c1 clt
        wbr c1 cA cmin co cc0 wne geoser.2 1re geolimilem.3 cA c1 abssubne0
        mp3an pm3.2i cA cneg vn cv cF cfv c1 cA cmin co div23 mp3an13 syl vn cv
        cn0 wcel cA cneg vn cv cF cfv cmul co cA vn cv cF cfv cmul co cneg c1
        cA cmin co cdiv cA cc wcel vn cv cF cfv cc wcel cA cneg vn cv cF cfv
        cmul co cA vn cv cF cfv cmul co cneg wceq vn cv cn0 wcel cA vn cv cF
        cfv mulneg1 geoser.2 cn0 cc vn cv cF vk vy cn0 cc cA vk cv cexp co cF
        geoser.1 cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel geoser.2 cA
        vk cv expcl mpan fopab ffvelrni sylancr opreq1d cA cneg c1 cA cmin co
        cdiv co vn cv cF cfv cmul co c1 c1 cA cmin co cdiv co cneg cA cmul co
        vn cv cF cfv cmul co wceq vn cv cn0 wcel c1 c1 cA cmin co cdiv co cneg
        cA cmul co vn cv cF cfv cmul co cA cneg c1 cA cmin co cdiv co vn cv cF
        cfv cmul co c1 c1 cA cmin co cdiv co cneg cA cmul co cA cneg c1 cA cmin
        co cdiv co vn cv cF cfv cmul c1 c1 cA cmin co cdiv co cneg cA cmul co
        c1 c1 cA cmin co cdiv co cA cneg cmul co cA cneg c1 cA cmin co cdiv co
        c1 c1 cA cmin co cdiv co cc wcel cA cc wcel c1 c1 cA cmin co cdiv co
        cneg cA cmul co c1 c1 cA cmin co cdiv co cA cneg cmul co wceq c1 cA
        cmin co c1 cA ax1cn geoser.2 subcli cA cc wcel c1 cr wcel cA cabs cfv
        c1 clt wbr c1 cA cmin co cc0 wne geoser.2 1re geolimilem.3 cA c1
        abssubne0 mp3an reccli geoser.2 c1 c1 cA cmin co cdiv co cA mulneg12
        mp2an cA cneg cc wcel c1 cA cmin co cc wcel c1 cA cmin co cc0 wne cA
        cneg c1 cA cmin co cdiv co c1 c1 cA cmin co cdiv co cA cneg cmul co
        wceq cA geoser.2 negcli c1 cA ax1cn geoser.2 subcli cA cc wcel c1 cr
        wcel cA cabs cfv c1 clt wbr c1 cA cmin co cc0 wne geoser.2 1re
        geolimilem.3 cA c1 abssubne0 mp3an cA cneg c1 cA cmin co divrec2 mp3an
        eqtr4i opreq1i eqcomi a1i 3eqtr3d eqtrd jca sylbir rgen pm3.2i cc0 c1
        c1 cA cmin co cdiv co cneg cA cmul co vn cF cG cc0 vk vy cn0 cA vk cv
        cexp co cF nn0ex geoser.1 fopabex2 cG cn0 wfn cn0 cvv wcel cG cvv wcel
        geolimilem.4 nn0ex cn0 cvv cG fnex mp2an cc0 cz 0z elisseti climmulc2
        mp2an c1 c1 cA cmin co cdiv co cneg cA cmul co c1 c1 cA cmin co cdiv co
        cneg cA c1 c1 cA cmin co cdiv co c1 cA cmin co c1 cA ax1cn geoser.2
        subcli cA cc wcel c1 cr wcel cA cabs cfv c1 clt wbr c1 cA cmin co cc0
        wne geoser.2 1re geolimilem.3 cA c1 abssubne0 mp3an reccli negcli
        geoser.2 mulcli mul01i breqtri c1 cA cmin co c1 cA ax1cn geoser.2
        subcli cA cc wcel c1 cr wcel cA cabs cfv c1 clt wbr c1 cA cmin co cc0
        wne geoser.2 1re geolimilem.3 cA c1 abssubne0 mp3an reccli pm3.2i cc0
        cz wcel vn cv cG cfv cc wcel vn cv caddc cF cseq0 co cfv c1 c1 cA cmin
        co cdiv co vn cv cG cfv caddc co wceq wa vn cc0 cuz cfv wral 0z vn cv
        cG cfv cc wcel vn cv caddc cF cseq0 co cfv c1 c1 cA cmin co cdiv co vn
        cv cG cfv caddc co wceq wa vn cc0 cuz cfv vn cv cc0 cuz cfv wcel vn cv
        cn0 wcel vn cv cG cfv cc wcel vn cv caddc cF cseq0 co cfv c1 c1 cA cmin
        co cdiv co vn cv cG cfv caddc co wceq wa vn cv elnn0uz vn cv cn0 wcel
        vn cv cG cfv cc wcel vn cv caddc cF cseq0 co cfv c1 c1 cA cmin co cdiv
        co vn cv cG cfv caddc co wceq vn cv cn0 wcel vn cv cG cfv cA vn cv cF
        cfv cmul co cneg c1 cA cmin co cdiv co cc geolimilem.5 vn cv cn0 wcel
        cA vn cv cF cfv cmul co cneg cc wcel cA vn cv cF cfv cmul co cneg c1 cA
        cmin co cdiv co cc wcel vn cv cn0 wcel cA vn cv cF cfv cmul co cc wcel
        cA vn cv cF cfv cmul co cneg cc wcel cA cc wcel vn cv cF cfv cc wcel cA
        vn cv cF cfv cmul co cc wcel vn cv cn0 wcel cA vn cv cF cfv mulcl
        geoser.2 cn0 cc vn cv cF vk vy cn0 cc cA vk cv cexp co cF geoser.1 cA
        cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel geoser.2 cA vk cv expcl
        mpan fopab ffvelrni sylancr cA vn cv cF cfv cmul co negcl syl cA vn cv
        cF cfv cmul co cneg cc wcel c1 cA cmin co cc wcel c1 cA cmin co cc0 wne
        cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv co cc wcel c1 cA ax1cn
        geoser.2 subcli cA cc wcel c1 cr wcel cA cabs cfv c1 clt wbr c1 cA cmin
        co cc0 wne geoser.2 1re geolimilem.3 cA c1 abssubne0 mp3an cA vn cv cF
        cfv cmul co cneg c1 cA cmin co divcl mp3an23 syl eqeltrd vn cv cn0 wcel
        c1 cA vn cv c1 caddc co cexp co cmin co c1 cA cmin co cdiv co c1 c1 cA
        cmin co cdiv co cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv co
        caddc co vn cv caddc cF cseq0 co cfv c1 c1 cA cmin co cdiv co vn cv cG
        cfv caddc co vn cv cn0 wcel c1 cA vn cv c1 caddc co cexp co cmin co c1
        cA cmin co cdiv co c1 cA vn cv cF cfv cmul co cneg caddc co c1 cA cmin
        co cdiv co c1 c1 cA cmin co cdiv co cA vn cv cF cfv cmul co cneg c1 cA
        cmin co cdiv co caddc co vn cv cn0 wcel c1 cA vn cv c1 caddc co cexp co
        cmin co c1 cA vn cv cF cfv cmul co cneg caddc co c1 cA cmin co cdiv vn
        cv cn0 wcel c1 cA vn cv c1 caddc co cexp co cmin co c1 cA vn cv cF cfv
        cmul co cmin co c1 cA vn cv cF cfv cmul co cneg caddc co vn cv cn0 wcel
        cA vn cv c1 caddc co cexp co cA vn cv cF cfv cmul co c1 cmin vn cv cn0
        wcel cA cA vn cv cexp co cmul co cA vn cv cexp co cA cmul co cA vn cv
        cF cfv cmul co cA vn cv c1 caddc co cexp co cA cc wcel cA vn cv cexp co
        cc wcel cA cA vn cv cexp co cmul co cA vn cv cexp co cA cmul co wceq vn
        cv cn0 wcel cA cA vn cv cexp co mulcom geoser.2 cA cc wcel vn cv cn0
        wcel cA vn cv cexp co cc wcel geoser.2 cA vn cv expcl mpan sylancr vn
        cv cn0 wcel vn cv cF cfv cA vn cv cexp co cA cmul vk vy vn cv cA vk cv
        cexp co cA vn cv cexp co cn0 cF vk cv vn cv cA cexp opreq2 geoser.1 cA
        vn cv cexp oprex fvopab4 opreq2d cA cc wcel vn cv cn0 wcel cA vn cv c1
        caddc co cexp co cA vn cv cexp co cA cmul co wceq geoser.2 cA vn cv
        expp1 mpan 3eqtr4rd opreq2d c1 cc wcel cA vn cv cF cfv cmul co cc wcel
        c1 cA vn cv cF cfv cmul co cneg caddc co c1 cA vn cv cF cfv cmul co
        cmin co wceq vn cv cn0 wcel c1 cA vn cv cF cfv cmul co negsub ax1cn cA
        cc wcel vn cv cF cfv cc wcel cA vn cv cF cfv cmul co cc wcel vn cv cn0
        wcel cA vn cv cF cfv mulcl geoser.2 cn0 cc vn cv cF vk vy cn0 cc cA vk
        cv cexp co cF geoser.1 cA cc wcel vk cv cn0 wcel cA vk cv cexp co cc
        wcel geoser.2 cA vk cv expcl mpan fopab ffvelrni sylancr sylancr eqtr4d
        opreq1d vn cv cn0 wcel cA vn cv cF cfv cmul co cneg cc wcel c1 cA vn cv
        cF cfv cmul co cneg caddc co c1 cA cmin co cdiv co c1 c1 cA cmin co
        cdiv co cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv co caddc co
        wceq vn cv cn0 wcel cA vn cv cF cfv cmul co cc wcel cA vn cv cF cfv
        cmul co cneg cc wcel cA cc wcel vn cv cF cfv cc wcel cA vn cv cF cfv
        cmul co cc wcel vn cv cn0 wcel cA vn cv cF cfv mulcl geoser.2 cn0 cc vn
        cv cF vk vy cn0 cc cA vk cv cexp co cF geoser.1 cA cc wcel vk cv cn0
        wcel cA vk cv cexp co cc wcel geoser.2 cA vk cv expcl mpan fopab
        ffvelrni sylancr cA vn cv cF cfv cmul co negcl syl c1 cc wcel cA vn cv
        cF cfv cmul co cneg cc wcel c1 cA cmin co cc wcel c1 cA cmin co cc0 wne
        wa c1 cA vn cv cF cfv cmul co cneg caddc co c1 cA cmin co cdiv co c1 c1
        cA cmin co cdiv co cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv co
        caddc co wceq ax1cn c1 cA cmin co cc wcel c1 cA cmin co cc0 wne c1 cA
        ax1cn geoser.2 subcli cA cc wcel c1 cr wcel cA cabs cfv c1 clt wbr c1
        cA cmin co cc0 wne geoser.2 1re geolimilem.3 cA c1 abssubne0 mp3an
        pm3.2i c1 cA vn cv cF cfv cmul co cneg c1 cA cmin co divdir mp3an13 syl
        eqtrd vn cv cn0 wcel cA c1 wne vn cv caddc cF cseq0 co cfv c1 cA vn cv
        c1 caddc co cexp co cmin co c1 cA cmin co cdiv co wceq c1 cA wne cA c1
        wne c1 cA cmin co cc0 wne c1 cA wne cA cc wcel c1 cr wcel cA cabs cfv
        c1 clt wbr c1 cA cmin co cc0 wne geoser.2 1re geolimilem.3 cA c1
        abssubne0 mp3an c1 cA cmin co cc0 c1 cA c1 cA ax1cn geoser.2 subeq0i
        necon3bii mpbi c1 cA necom mpbi vy cA vk cF vn cv geoser.1 geoser.2
        geoseri mpan2 vn cv cn0 wcel vn cv cG cfv cA vn cv cF cfv cmul co cneg
        c1 cA cmin co cdiv co c1 c1 cA cmin co cdiv co caddc geolimilem.5
        opreq2d 3eqtr4d jca sylbir rgen pm3.2i cc0 c1 c1 cA cmin co cdiv co vn
        cG caddc cF cseq0 co cc0 cG cn0 wfn cn0 cvv wcel cG cvv wcel
        geolimilem.4 nn0ex cn0 cvv cG fnex mp2an caddc cF cseq0 oprex cc0 cz 0z
        elisseti c1 c1 cA cmin co cdiv oprex climaddc2 mp2an c1 c1 cA cmin co
        cdiv co c1 cA cmin co c1 cA ax1cn geoser.2 subcli cA cc wcel c1 cr wcel
        cA cabs cfv c1 clt wbr c1 cA cmin co cc0 wne geoser.2 1re geolimilem.3
        cA c1 abssubne0 mp3an reccli addid1i breqtri $.
        $( [17-May-2006] $) $( [15-May-2006] $)
    $}

    ${
      geolimi.3 $e |- ( abs ` A ) < 1 $.
      $( The partial sums in the infinite series ` 1 + A ^ 1 + A ^ 2 ` ...
         converge to ` ( 1 / ( 1 - A ) ) ` . $)
      geolimi $p |- ( + seq0 F ) ~~> ( 1 / ( 1 - A ) ) $=
        vy cA vk vn cF vj cv cn0 wcel vz cv cA vj cv cF cfv cmul co cneg c1 cA
        cmin co cdiv co wceq wa vj vz copab geoser.1 geoser.2 geolimi.3 vj vz
        cn0 cA vj cv cF cfv cmul co cneg c1 cA cmin co cdiv co vj cv cn0 wcel
        vz cv cA vj cv cF cfv cmul co cneg c1 cA cmin co cdiv co wceq wa vj vz
        copab cA vj cv cF cfv cmul co cneg c1 cA cmin co cdiv oprex vj cv cn0
        wcel vz cv cA vj cv cF cfv cmul co cneg c1 cA cmin co cdiv co wceq wa
        vj vz copab eqid fnopab2 vj vz vn cv cA vj cv cF cfv cmul co cneg c1 cA
        cmin co cdiv co cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv co cn0
        vj cv cn0 wcel vz cv cA vj cv cF cfv cmul co cneg c1 cA cmin co cdiv co
        wceq wa vj vz copab vj cv vn cv wceq cA vj cv cF cfv cmul co cneg cA vn
        cv cF cfv cmul co cneg c1 cA cmin co cdiv vj cv vn cv wceq cA vj cv cF
        cfv cmul co cA vn cv cF cfv cmul co vj cv vn cv wceq vj cv cF cfv vn cv
        cF cfv cA cmul vj cv vn cv cF fveq2 opreq2d negeqd opreq1d vj cv cn0
        wcel vz cv cA vj cv cF cfv cmul co cneg c1 cA cmin co cdiv co wceq wa
        vj vz copab eqid cA vn cv cF cfv cmul co cneg c1 cA cmin co cdiv oprex
        fvopab4 geolimilem $.
        $( [17-May-2006] $) $( [15-May-2006] $)
    $}
  $}

  ${
    $d k y A $.
    geolim.1 $e |- F = { <. k , y >. | ( k e. NN0 /\ y = ( A ^ k ) ) } $.
    $( The partial sums in the infinite series ` 1 + A ^ 1 + A ^ 2 ` ...
       converge to ` ( 1 / ( 1 - A ) ) ` . $)
    geolim $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
                  ( + seq0 F ) ~~> ( 1 / ( 1 - A ) ) ) $=
      cA cc wcel cA cabs cfv c1 clt wbr wa caddc vk cv cn0 wcel vy cv cA vk cv
      cexp co wceq wa vk vy copab cseq0 co c1 c1 cA cmin co cdiv co caddc cF
      cseq0 co cli cA cc wcel cA cabs cfv c1 clt wbr wa caddc vk cv cn0 wcel vy
      cv cA vk cv cexp co wceq wa vk vy copab cseq0 co c1 c1 cA cmin co cdiv co
      cli wbr caddc vk cv cn0 wcel vy cv cA cc wcel cA cabs cfv c1 clt wbr wa
      cA cc0 cif vk cv cexp co wceq wa vk vy copab cseq0 co c1 c1 cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif cmin co cdiv co cli wbr cA cc0 cA cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq caddc vk cv cn0 wcel vy cv
      cA vk cv cexp co wceq wa vk vy copab cseq0 co caddc vk cv cn0 wcel vy cv
      cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp co wceq wa vk
      vy copab cseq0 co c1 c1 cA cmin co cdiv co c1 c1 cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif cmin co cdiv co cli cA cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif wceq vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa
      vk vy copab vk cv cn0 wcel vy cv cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif vk cv cexp co wceq wa vk vy copab caddc cseq0 cA cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif wceq vk cv cn0 wcel vy cv cA vk cv cexp
      co wceq wa vk cv cn0 wcel vy cv cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif vk cv cexp co wceq wa vk vy cA cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif wceq vy cv cA vk cv cexp co wceq vy cv cA cc wcel cA cabs
      cfv c1 clt wbr wa cA cc0 cif vk cv cexp co wceq vk cv cn0 wcel cA cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cA vk cv cexp co cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp co vy cv cA cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp opreq1 eqeq2d anbi2d
      opabbidv opreq2d cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq
      c1 cA cmin co c1 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cmin co
      c1 cdiv cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif c1 cmin opreq2
      opreq2d breq12d vy cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk vk
      cv cn0 wcel vy cv cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv
      cexp co wceq wa vk vy copab vk cv cn0 wcel vy cv cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif vk cv cexp co wceq wa vk vy copab eqid cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif cabs cfv c1 clt wbr cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt wbr wa cc0 cc
      wcel cc0 cabs cfv c1 clt wbr wa cA cc0 cA cA cc wcel cA cabs cfv c1 clt
      wbr wa cA cc0 cif wceq cA cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif cc wcel cA cabs cfv c1 clt wbr cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif cabs cfv c1 clt wbr cA cA cc wcel cA cabs cfv c1 clt wbr wa
      cA cc0 cif cc eleq1 cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif
      wceq cA cabs cfv cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv
      c1 clt cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs fveq2
      breq1d anbi12d cc0 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq
      cc0 cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cc0
      cabs cfv c1 clt wbr cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs
      cfv c1 clt wbr cc0 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc
      eleq1 cc0 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cc0 cabs
      cfv cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt cc0
      cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs fveq2 breq1d anbi12d
      cc0 cc wcel cc0 cabs cfv c1 clt wbr 0cn cc0 cabs cfv cc0 c1 clt abs0 lt01
      eqbrtri pm3.2i elimhyp pm3.26i cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv
      c1 clt wbr cA cc wcel cA cabs cfv c1 clt wbr wa cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0
      cif cabs cfv c1 clt wbr wa cc0 cc wcel cc0 cabs cfv c1 clt wbr wa cA cc0
      cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cA cc wcel cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cA cabs cfv c1 clt wbr
      cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt wbr cA cA
      cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc eleq1 cA cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif wceq cA cabs cfv cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif cabs cfv c1 clt cA cA cc wcel cA cabs cfv c1 clt
      wbr wa cA cc0 cif cabs fveq2 breq1d anbi12d cc0 cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif wceq cc0 cc wcel cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif cc wcel cc0 cabs cfv c1 clt wbr cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif cabs cfv c1 clt wbr cc0 cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif cc eleq1 cc0 cA cc wcel cA cabs cfv c1 clt wbr wa
      cA cc0 cif wceq cc0 cabs cfv cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0
      cif cabs cfv c1 clt cc0 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif
      cabs fveq2 breq1d anbi12d cc0 cc wcel cc0 cabs cfv c1 clt wbr 0cn cc0
      cabs cfv cc0 c1 clt abs0 lt01 eqbrtri pm3.2i elimhyp pm3.27i geolimi
      dedth cF vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab caddc
      cseq0 geolim.1 opreq2i syl5eqbr $.
      $( [19-Oct-2006] $) $( [15-May-2006] $)
  $}

  ${
    $d k y A $.
    geolim1i.1 $e |- F = { <. k , y >. | ( k e. NN /\ y = ( A ^ k ) ) } $.
    geolim1i.2 $e |- A e. CC $.
    geolim1i.3 $e |- ( abs ` A ) < 1 $.
    $( The partial sums in the geometric series ` A ^ 1 + A ^ 2 ` ... converge
       to ` ( A / ( 1 - A ) ) ` . $)
    geolim1i $p |- ( + seq1 F ) ~~> ( A / ( 1 - A ) ) $=
      cc0 c1 caddc co caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa
      vk vy copab cseqz co c1 c1 cA cmin co cdiv co cc0 cc0 caddc cop vk cv cn0
      wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co cfv cmin co
      caddc cF cseq1 co cA c1 cA cmin co cdiv co cli cc0 cc0 cuz cfv wcel cc0
      c1 caddc co caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy
      copab cseqz co c1 c1 cA cmin co cdiv co cc0 cc0 caddc cop vk cv cn0 wcel
      vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co cfv cmin co cli wbr
      cc0 cz wcel cc0 cc0 cuz cfv wcel 0z cc0 uzid ax-mp c1 c1 cA cmin co cdiv
      co vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cc0 cc0 vk
      vy cn0 cA vk cv cexp co nn0ex opabex2 c1 c1 cA cmin co cdiv oprex caddc
      vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseq0 co cc0
      caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz
      co c1 c1 cA cmin co cdiv co cli caddc vk cv cn0 wcel vy cv cA vk cv cexp
      co wceq wa vk vy copab addex vk vy cn0 cA vk cv cexp co nn0ex opabex2
      seq0seqz vy cA vk vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy
      copab vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab eqid
      geolim1i.2 geolim1i.3 geolimi eqbrtrri cn0 cc vk cv cn0 wcel vy cv cA vk
      cv cexp co wceq wa vk vy copab wf cc0 cuz cfv cc vk cv cn0 wcel vy cv cA
      vk cv cexp co wceq wa vk vy copab wf vk vy cn0 cc cA vk cv cexp co vk cv
      cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab vk cv cn0 wcel vy cv
      cA vk cv cexp co wceq wa vk vy copab eqid cA cc wcel vk cv cn0 wcel cA vk
      cv cexp co cc wcel geolim1i.2 cA vk cv expcl mpan fopab cn0 cc0 cuz cfv
      wceq cn0 cc vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab wf
      cc0 cuz cfv cc vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab
      wf wb nn0uz cn0 cc0 cuz cfv cc vk cv cn0 wcel vy cv cA vk cv cexp co wceq
      wa vk vy copab feq2 ax-mp mpbi clim2serzi ax-mp c1 caddc cop cF cseqz co
      c1 caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab
      cseqz co caddc cF cseq1 co cc0 c1 caddc co caddc cop vk cv cn0 wcel vy cv
      cA vk cv cexp co wceq wa vk vy copab cseqz co c1 caddc cop cF cseqz co c1
      caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab c1
      cuz cfv cres cseqz co c1 caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co
      wceq wa vk vy copab cseqz co cF vk cv cn0 wcel vy cv cA vk cv cexp co
      wceq wa vk vy copab c1 cuz cfv cres c1 caddc cop cseqz cF vk cv cn wcel
      vy cv cA vk cv cexp co wceq wa vk vy copab vk cv cn0 wcel vy cv cA vk cv
      cexp co wceq wa vk vy copab cn cres vk cv cn0 wcel vy cv cA vk cv cexp co
      wceq wa vk vy copab c1 cuz cfv cres geolim1i.1 cn cn0 wss vk cv cn0 wcel
      vy cv cA vk cv cexp co wceq wa vk vy copab cn cres vk cv cn wcel vy cv cA
      vk cv cexp co wceq wa vk vy copab wceq nnssnn0 vy cv cA vk cv cexp co
      wceq vk vy cn cn0 resopab2 ax-mp cn c1 cuz cfv wceq vk cv cn0 wcel vy cv
      cA vk cv cexp co wceq wa vk vy copab cn cres vk cv cn0 wcel vy cv cA vk
      cv cexp co wceq wa vk vy copab c1 cuz cfv cres wceq nnuz cn c1 cuz cfv vk
      cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab reseq2 ax-mp
      3eqtr2i opreq2i c1 cz wcel c1 caddc cop vk cv cn0 wcel vy cv cA vk cv
      cexp co wceq wa vk vy copab c1 cuz cfv cres cseqz co c1 caddc cop vk cv
      cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co wceq 1z
      caddc vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab c1 addex
      vk vy cn0 cA vk cv cexp co nn0ex opabex2 seqzres ax-mp eqtri caddc cF
      addex vk vy cn cA vk cv cexp co cF nnex geolim1i.1 fopabex2 seq1seqz cc0
      c1 caddc co caddc cop c1 caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co
      wceq wa vk vy copab cseqz cc0 c1 caddc co c1 caddc c1 ax1cn addid2i
      opeq1i opreq1i 3eqtr4i cA c1 cA cmin co cdiv co c1 c1 cA cmin co cdiv co
      c1 cmin co c1 c1 cA cmin co cdiv co cc0 cc0 caddc cop vk cv cn0 wcel vy
      cv cA vk cv cexp co wceq wa vk vy copab cseqz co cfv cmin co c1 c1 cA
      cmin co cmin co c1 cA cmin co cdiv co c1 c1 cA cmin co cdiv co c1 cA cmin
      co c1 cA cmin co cdiv co cmin co cA c1 cA cmin co cdiv co c1 c1 cA cmin
      co cdiv co c1 cmin co c1 cc wcel c1 cA cmin co cc wcel c1 cA cmin co cc
      wcel c1 cA cmin co cc0 wne wa c1 c1 cA cmin co cmin co c1 cA cmin co cdiv
      co c1 c1 cA cmin co cdiv co c1 cA cmin co c1 cA cmin co cdiv co cmin co
      wceq ax1cn c1 cA ax1cn geolim1i.2 subcli c1 cA cmin co cc wcel c1 cA cmin
      co cc0 wne c1 cA ax1cn geolim1i.2 subcli cA cc wcel c1 cr wcel cA cabs
      cfv c1 clt wbr c1 cA cmin co cc0 wne geolim1i.2 1re geolim1i.3 cA c1
      abssubne0 mp3an pm3.2i c1 c1 cA cmin co c1 cA cmin co divsubdir mp3an c1
      c1 cA cmin co cmin co cA c1 cA cmin co cdiv c1 cc wcel cA cc wcel c1 c1
      cA cmin co cmin co cA wceq ax1cn geolim1i.2 c1 cA nncan mp2an opreq1i c1
      cA cmin co c1 cA cmin co cdiv co c1 c1 c1 cA cmin co cdiv co cmin c1 cA
      cmin co c1 cA ax1cn geolim1i.2 subcli cA cc wcel c1 cr wcel cA cabs cfv
      c1 clt wbr c1 cA cmin co cc0 wne geolim1i.2 1re geolim1i.3 cA c1
      abssubne0 mp3an dividi opreq2i 3eqtr3i cc0 cc0 caddc cop vk cv cn0 wcel
      vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co cfv c1 c1 c1 cA cmin
      co cdiv co cmin cc0 cc0 caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co
      wceq wa vk vy copab cseqz co cfv cc0 vk cv cn0 wcel vy cv cA vk cv cexp
      co wceq wa vk vy copab cfv cA cc0 cexp co c1 cc0 cz wcel cc0 cc0 caddc
      cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co
      cfv cc0 vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cfv
      wceq 0z caddc vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab
      cc0 addex vk vy cn0 cA vk cv cexp co nn0ex opabex2 seqz1 ax-mp cc0 cn0
      wcel cc0 vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cfv cA
      cc0 cexp co wceq 0nn0 vk vy cc0 cA vk cv cexp co cA cc0 cexp co cn0 vk cv
      cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab vk cv cc0 cA cexp
      opreq2 vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab eqid cA
      cc0 cexp oprex fvopab4 ax-mp cA cc wcel cA cc0 cexp co c1 wceq geolim1i.2
      cA exp0 ax-mp 3eqtri opreq2i eqtr4i 3brtr4i $.
      $( [16-Jun-2006] $) $( [6-Jun-2006] $)
  $}

  ${
    $d k y A $.
    geolim1.1 $e |- F = { <. k , y >. | ( k e. NN /\ y = ( A ^ k ) ) } $.
    $( The partial sums in the infinite series ` A ^ 1 + A ^ 2 ` ... converge
       to ` ( A / ( 1 - A ) ) ` . $)
    geolim1 $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
                  ( + seq1 F ) ~~> ( A / ( 1 - A ) ) ) $=
      cA cc wcel cA cabs cfv c1 clt wbr wa caddc vk cv cn wcel vy cv cA vk cv
      cexp co wceq wa vk vy copab cseq1 co cA c1 cA cmin co cdiv co caddc cF
      cseq1 co cli cA cc wcel cA cabs cfv c1 clt wbr wa caddc vk cv cn wcel vy
      cv cA vk cv cexp co wceq wa vk vy copab cseq1 co cA c1 cA cmin co cdiv co
      cli wbr caddc vk cv cn wcel vy cv cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif vk cv cexp co wceq wa vk vy copab cseq1 co cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif c1 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0
      cif cmin co cdiv co cli wbr cA cc0 cA cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif wceq caddc vk cv cn wcel vy cv cA vk cv cexp co wceq wa vk
      vy copab cseq1 co caddc vk cv cn wcel vy cv cA cc wcel cA cabs cfv c1 clt
      wbr wa cA cc0 cif vk cv cexp co wceq wa vk vy copab cseq1 co cA c1 cA
      cmin co cdiv co cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif c1 cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cmin co cdiv co cli cA cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq vk cv cn wcel vy cv cA vk
      cv cexp co wceq wa vk vy copab vk cv cn wcel vy cv cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif vk cv cexp co wceq wa vk vy copab caddc cseq1 cA
      cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq vk cv cn wcel vy cv
      cA vk cv cexp co wceq wa vk cv cn wcel vy cv cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif vk cv cexp co wceq wa vk vy cA cA cc wcel cA cabs
      cfv c1 clt wbr wa cA cc0 cif wceq vy cv cA vk cv cexp co wceq vy cv cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp co wceq vk cv cn
      wcel cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cA vk cv
      cexp co cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp co vy
      cv cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp opreq1
      eqeq2d anbi2d opabbidv opreq2d cA cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif wceq cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif c1 cA
      cmin co c1 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cmin co cdiv
      cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq id cA cA cc wcel
      cA cabs cfv c1 clt wbr wa cA cc0 cif c1 cmin opreq2 opreq12d breq12d vy
      cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk vk cv cn wcel vy cv cA
      cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif vk cv cexp co wceq wa vk vy
      copab vk cv cn wcel vy cv cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif
      vk cv cexp co wceq wa vk vy copab eqid cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif
      cabs cfv c1 clt wbr cA cc wcel cA cabs cfv c1 clt wbr wa cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cA cc wcel cA cabs cfv c1 clt
      wbr wa cA cc0 cif cabs cfv c1 clt wbr wa cc0 cc wcel cc0 cabs cfv c1 clt
      wbr wa cA cc0 cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cA
      cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cA cabs
      cfv c1 clt wbr cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv
      c1 clt wbr cA cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc eleq1 cA
      cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cA cabs cfv cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt cA cA cc wcel
      cA cabs cfv c1 clt wbr wa cA cc0 cif cabs fveq2 breq1d anbi12d cc0 cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif wceq cc0 cc wcel cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cc0 cabs cfv c1 clt wbr cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt wbr cc0 cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc eleq1 cc0 cA cc wcel cA cabs
      cfv c1 clt wbr wa cA cc0 cif wceq cc0 cabs cfv cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif cabs cfv c1 clt cc0 cA cc wcel cA cabs cfv c1 clt
      wbr wa cA cc0 cif cabs fveq2 breq1d anbi12d cc0 cc wcel cc0 cabs cfv c1
      clt wbr 0cn cc0 cabs cfv cc0 c1 clt abs0 lt01 eqbrtri pm3.2i elimhyp
      pm3.26i cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cc wcel cA cc
      wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt wbr cA cc wcel
      cA cabs cfv c1 clt wbr wa cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif
      cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt
      wbr wa cc0 cc wcel cc0 cabs cfv c1 clt wbr wa cA cc0 cA cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif wceq cA cc wcel cA cc wcel cA cabs cfv
      c1 clt wbr wa cA cc0 cif cc wcel cA cabs cfv c1 clt wbr cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif cabs cfv c1 clt wbr cA cA cc wcel cA
      cabs cfv c1 clt wbr wa cA cc0 cif cc eleq1 cA cA cc wcel cA cabs cfv c1
      clt wbr wa cA cc0 cif wceq cA cabs cfv cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif cabs cfv c1 clt cA cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif cabs fveq2 breq1d anbi12d cc0 cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif wceq cc0 cc wcel cA cc wcel cA cabs cfv c1 clt wbr wa cA
      cc0 cif cc wcel cc0 cabs cfv c1 clt wbr cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif cabs cfv c1 clt wbr cc0 cA cc wcel cA cabs cfv c1 clt wbr
      wa cA cc0 cif cc eleq1 cc0 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0
      cif wceq cc0 cabs cfv cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif
      cabs cfv c1 clt cc0 cA cc wcel cA cabs cfv c1 clt wbr wa cA cc0 cif cabs
      fveq2 breq1d anbi12d cc0 cc wcel cc0 cabs cfv c1 clt wbr 0cn cc0 cabs cfv
      cc0 c1 clt abs0 lt01 eqbrtri pm3.2i elimhyp pm3.27i geolim1i dedth cF vk
      cv cn wcel vy cv cA vk cv cexp co wceq wa vk vy copab caddc cseq1
      geolim1.1 opreq2i syl5eqbr $.
      $( [19-Jun-2006] $) $( [6-Jun-2006] $)
  $}

  ${
    $d A j y $.
    georeclim.1 $e |- F = { <. j , y >. |
                            ( j e. NN0 /\ y = ( ( 1 / A ) ^ j ) ) } $.
    $( The limit of a geometric series of reciprocals.  (Contributed by Paul
       Chapman, 28-Dec-2007.) $)
    georeclim $p |- ( ( A e. CC /\ 1 < ( abs ` A ) ) ->
                      ( + seq0 F ) ~~> ( A / ( A - 1 ) ) ) $=
      cA cc wcel c1 cA cabs cfv clt wbr wa caddc cF cseq0 co c1 c1 c1 cA cdiv
      co cmin co cdiv co cA cA c1 cmin co cdiv co cli c1 cA cdiv co cc wcel c1
      cA cdiv co cabs cfv c1 clt wbr caddc cF cseq0 co c1 c1 c1 cA cdiv co cmin
      co cdiv co cli wbr cA cc wcel c1 cA cabs cfv clt wbr wa vy c1 cA cdiv co
      vj cF georeclim.1 geolim cA cc wcel c1 cA cabs cfv clt wbr cA cc0 wne c1
      cA cdiv co cc wcel cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0
      wne cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv
      cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc
      wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc
      wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt
      wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA
      cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv
      clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt
      wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1
      cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv
      cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0
      cA cc0 cA abs00 necon3bid adantr mpbid cA reccl syldan cA cc wcel c1 cA
      cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cA cabs cfv cdiv co c1 clt
      cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cabs cfv
      cA cabs cfv cdiv co c1 cA cabs cfv cdiv co cA cc wcel c1 cA cabs cfv clt
      wbr cA cc0 wne c1 cA cdiv co cabs cfv c1 cabs cfv cA cabs cfv cdiv co
      wceq cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0 wne cA cc0 wne
      cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv cc0 wne cA cc
      wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc wcel cA cabs cfv
      cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr wcel cc0
      c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi cA abscl
      cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv axlttrn
      mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv cc0 wne cA cc0 wne wb
      c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0 cA cc0 cA abs00
      necon3bid adantr mpbid c1 cc wcel cA cc wcel cA cc0 wne c1 cA cdiv co
      cabs cfv c1 cabs cfv cA cabs cfv cdiv co wceq ax1cn c1 cA absdiv mp3an1
      syldan c1 cabs cfv c1 cA cabs cfv cdiv c1 cr wcel cc0 c1 cle wbr c1 cabs
      cfv c1 wceq 1re cc0 c1 0re 1re lt01 ltleii c1 absid mp2an opreq1i syl6eq
      cA cc wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr cA cc
      wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr cA cc wcel
      c1 cA cabs cfv clt wbr c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1
      clt wbr wi cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cabs cfv clt wbr c1
      cA cabs cfv cdiv co c1 clt wbr cA cabs cfv cr wcel cc0 cA cabs cfv clt
      wbr c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr wb cA cc
      wcel c1 cA cabs cfv clt wbr wa cA cabs cfv recgt1 cA cc wcel cA cabs cfv
      cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr wcel cc0
      c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi cA abscl
      cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv axlttrn
      mp3an12 syl mpani imp sylanc biimpd ex pm2.43d imp eqbrtrd sylanc cA cc
      wcel c1 cA cabs cfv clt wbr wa c1 c1 c1 cA cdiv co cmin co cdiv co c1 cA
      cmul co c1 c1 cA cdiv co cmin co cA cmul co cdiv co cA cA c1 cmin co cdiv
      co cA cc wcel c1 cA cabs cfv clt wbr wa c1 c1 c1 cA cdiv co cmin co cdiv
      co cA cA cdiv co cdiv co c1 c1 c1 cA cdiv co cmin co cdiv co c1 cdiv co
      c1 cA cmul co c1 c1 cA cdiv co cmin co cA cmul co cdiv co c1 c1 c1 cA
      cdiv co cmin co cdiv co cA cc wcel c1 cA cabs cfv clt wbr wa cA cA cdiv
      co c1 c1 c1 c1 cA cdiv co cmin co cdiv co cdiv cA cc wcel c1 cA cabs cfv
      clt wbr cA cc0 wne cA cA cdiv co c1 wceq cA cc wcel c1 cA cabs cfv clt
      wbr wa cA cabs cfv cc0 wne cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv
      clt wbr cA cabs cfv cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs
      cfv gt0ne0 cA cc wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl
      adantr cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01
      cA cc wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa
      cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc
      wcel cA cabs cfv cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel
      cA cabs cfv cc0 cA cc0 cA abs00 necon3bid adantr mpbid cA divid syldan
      opreq2d c1 cc wcel c1 c1 cA cdiv co cmin co cc wcel c1 c1 cA cdiv co cmin
      co cc0 wne wa cA cc wcel cA cc0 wne wa cA cc wcel cA cc0 wne wa c1 c1 c1
      cA cdiv co cmin co cdiv co cA cA cdiv co cdiv co c1 cA cmul co c1 c1 cA
      cdiv co cmin co cA cmul co cdiv co wceq cA cc wcel c1 cA cabs cfv clt wbr
      wa c1 c1 c1 cA cdiv co cmin co cA cA divdivdiv c1 cc wcel cA cc wcel c1
      cA cabs cfv clt wbr wa ax1cn a1i cA cc wcel c1 cA cabs cfv clt wbr wa c1
      c1 cA cdiv co cmin co cc wcel c1 c1 cA cdiv co cmin co cc0 wne c1 cc wcel
      c1 cA cdiv co cc wcel c1 c1 cA cdiv co cmin co cc wcel cA cc wcel c1 cA
      cabs cfv clt wbr wa c1 c1 cA cdiv co subcl ax1cn cA cc wcel c1 cA cabs
      cfv clt wbr cA cc0 wne c1 cA cdiv co cc wcel cA cc wcel c1 cA cabs cfv
      clt wbr wa cA cabs cfv cc0 wne cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs
      cfv clt wbr cA cabs cfv cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa cA
      cabs cfv gt0ne0 cA cc wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA
      abscl adantr cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA
      cc wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr
      lt01 cA cc wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr
      wa cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv
      cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr
      wi 0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc
      wcel cA cabs cfv cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel
      cA cabs cfv cc0 cA cc0 cA abs00 necon3bid adantr mpbid cA reccl syldan
      sylancr c1 cA cdiv co cc wcel c1 cA cdiv co cabs cfv c1 clt wbr c1 c1 cA
      cdiv co cmin co cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv
      co cc wcel c1 cr wcel c1 cA cdiv co cabs cfv c1 clt wbr c1 c1 cA cdiv co
      cmin co cc0 wne 1re c1 cA cdiv co c1 abssubne0 mp3an2 cA cc wcel c1 cA
      cabs cfv clt wbr cA cc0 wne c1 cA cdiv co cc wcel cA cc wcel c1 cA cabs
      cfv clt wbr wa cA cabs cfv cc0 wne cA cc0 wne cA cabs cfv cr wcel cc0 cA
      cabs cfv clt wbr cA cabs cfv cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa
      cA cabs cfv gt0ne0 cA cc wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr
      cA abscl adantr cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr
      cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr
      lt01 cA cc wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr
      wa cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv
      cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr
      wi 0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc
      wcel cA cabs cfv cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel
      cA cabs cfv cc0 cA cc0 cA abs00 necon3bid adantr mpbid cA reccl syldan cA
      cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cA cabs cfv
      cdiv co c1 clt cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co cabs
      cfv c1 cabs cfv cA cabs cfv cdiv co c1 cA cabs cfv cdiv co cA cc wcel c1
      cA cabs cfv clt wbr cA cc0 wne c1 cA cdiv co cabs cfv c1 cabs cfv cA cabs
      cfv cdiv co wceq cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0 wne
      cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv cc0
      wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc wcel cA
      cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv
      axlttrn mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv cc0 wne cA
      cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0 cA cc0 cA
      abs00 necon3bid adantr mpbid c1 cc wcel cA cc wcel cA cc0 wne c1 cA cdiv
      co cabs cfv c1 cabs cfv cA cabs cfv cdiv co wceq ax1cn c1 cA absdiv
      mp3an1 syldan c1 cabs cfv c1 cA cabs cfv cdiv c1 cr wcel cc0 c1 cle wbr
      c1 cabs cfv c1 wceq 1re cc0 c1 0re 1re lt01 ltleii c1 absid mp2an opreq1i
      syl6eq cA cc wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt
      wbr cA cc wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr
      cA cc wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv clt wbr c1 cA cabs cfv
      cdiv co c1 clt wbr wi cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cabs cfv
      clt wbr c1 cA cabs cfv cdiv co c1 clt wbr cA cabs cfv cr wcel cc0 cA cabs
      cfv clt wbr c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr wb
      cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv recgt1 cA cc wcel cA
      cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv
      axlttrn mp3an12 syl mpani imp sylanc biimpd ex pm2.43d imp eqbrtrd sylanc
      jca cA cc wcel c1 cA cabs cfv clt wbr wa cA cc wcel cA cc0 wne cA cc wcel
      c1 cA cabs cfv clt wbr pm3.26 cA cc wcel c1 cA cabs cfv clt wbr wa cA
      cabs cfv cc0 wne cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr
      cA cabs cfv cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv
      gt0ne0 cA cc wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl
      adantr cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01
      cA cc wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa
      cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc
      wcel cA cabs cfv cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel
      cA cabs cfv cc0 cA cc0 cA abs00 necon3bid adantr mpbid jca cA cc wcel c1
      cA cabs cfv clt wbr wa cA cc wcel cA cc0 wne cA cc wcel c1 cA cabs cfv
      clt wbr pm3.26 cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0 wne
      cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv cc0
      wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc wcel cA
      cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv
      axlttrn mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv cc0 wne cA
      cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0 cA cc0 cA
      abs00 necon3bid adantr mpbid jca syl2anc cA cc wcel c1 cA cabs cfv clt
      wbr wa c1 c1 c1 cA cdiv co cmin co cdiv co cc wcel c1 c1 c1 cA cdiv co
      cmin co cdiv co c1 cdiv co c1 c1 c1 cA cdiv co cmin co cdiv co wceq c1 c1
      cA cdiv co cmin co cc wcel c1 c1 cA cdiv co cmin co cc0 wne c1 c1 c1 cA
      cdiv co cmin co cdiv co cc wcel cA cc wcel c1 cA cabs cfv clt wbr wa c1
      c1 cA cdiv co cmin co reccl c1 cc wcel c1 cA cdiv co cc wcel c1 c1 cA
      cdiv co cmin co cc wcel cA cc wcel c1 cA cabs cfv clt wbr wa c1 c1 cA
      cdiv co subcl ax1cn cA cc wcel c1 cA cabs cfv clt wbr cA cc0 wne c1 cA
      cdiv co cc wcel cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0 wne
      cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv cc0
      wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc wcel cA
      cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv
      axlttrn mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv cc0 wne cA
      cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0 cA cc0 cA
      abs00 necon3bid adantr mpbid cA reccl syldan sylancr c1 cA cdiv co cc
      wcel c1 cA cdiv co cabs cfv c1 clt wbr c1 c1 cA cdiv co cmin co cc0 wne
      cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co cc wcel c1 cr wcel c1
      cA cdiv co cabs cfv c1 clt wbr c1 c1 cA cdiv co cmin co cc0 wne 1re c1 cA
      cdiv co c1 abssubne0 mp3an2 cA cc wcel c1 cA cabs cfv clt wbr cA cc0 wne
      c1 cA cdiv co cc wcel cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv
      cc0 wne cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs
      cfv cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc
      wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc
      wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt
      wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA
      cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv
      clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt
      wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1
      cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv
      cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0
      cA cc0 cA abs00 necon3bid adantr mpbid cA reccl syldan cA cc wcel c1 cA
      cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cA cabs cfv cdiv co c1 clt
      cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cabs cfv
      cA cabs cfv cdiv co c1 cA cabs cfv cdiv co cA cc wcel c1 cA cabs cfv clt
      wbr cA cc0 wne c1 cA cdiv co cabs cfv c1 cabs cfv cA cabs cfv cdiv co
      wceq cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0 wne cA cc0 wne
      cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv cc0 wne cA cc
      wcel c1 cA cabs cfv clt wbr wa cA cabs cfv gt0ne0 cA cc wcel cA cabs cfv
      cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr wcel cc0
      c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi cA abscl
      cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv axlttrn
      mp3an12 syl mpani imp sylanc cA cc wcel cA cabs cfv cc0 wne cA cc0 wne wb
      c1 cA cabs cfv clt wbr cA cc wcel cA cabs cfv cc0 cA cc0 cA abs00
      necon3bid adantr mpbid c1 cc wcel cA cc wcel cA cc0 wne c1 cA cdiv co
      cabs cfv c1 cabs cfv cA cabs cfv cdiv co wceq ax1cn c1 cA absdiv mp3an1
      syldan c1 cabs cfv c1 cA cabs cfv cdiv c1 cr wcel cc0 c1 cle wbr c1 cabs
      cfv c1 wceq 1re cc0 c1 0re 1re lt01 ltleii c1 absid mp2an opreq1i syl6eq
      cA cc wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr cA cc
      wcel c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr cA cc wcel
      c1 cA cabs cfv clt wbr c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1
      clt wbr wi cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cabs cfv clt wbr c1
      cA cabs cfv cdiv co c1 clt wbr cA cabs cfv cr wcel cc0 cA cabs cfv clt
      wbr c1 cA cabs cfv clt wbr c1 cA cabs cfv cdiv co c1 clt wbr wb cA cc
      wcel c1 cA cabs cfv clt wbr wa cA cabs cfv recgt1 cA cc wcel cA cabs cfv
      cr wcel c1 cA cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr wcel cc0
      c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi cA abscl
      cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv
      clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv axlttrn
      mp3an12 syl mpani imp sylanc biimpd ex pm2.43d imp eqbrtrd sylanc sylanc
      c1 c1 c1 cA cdiv co cmin co cdiv co div1 syl 3eqtr3rd cA cc wcel c1 cA
      cabs cfv clt wbr wa c1 cA cmul co cA c1 c1 cA cdiv co cmin co cA cmul co
      cA c1 cmin co cdiv cA cc wcel c1 cA cmul co cA wceq c1 cA cabs cfv clt
      wbr cA mulid2 adantr cA cc wcel c1 cA cabs cfv clt wbr wa c1 c1 cA cdiv
      co cmin co cA cmul co c1 cA cmul co c1 cA cdiv co cA cmul co cmin co cA
      c1 cmin co c1 cc wcel c1 cA cdiv co cc wcel cA cc wcel c1 c1 cA cdiv co
      cmin co cA cmul co c1 cA cmul co c1 cA cdiv co cA cmul co cmin co wceq cA
      cc wcel c1 cA cabs cfv clt wbr wa c1 c1 cA cdiv co cA subdir c1 cc wcel
      cA cc wcel c1 cA cabs cfv clt wbr wa ax1cn a1i cA cc wcel c1 cA cabs cfv
      clt wbr cA cc0 wne c1 cA cdiv co cc wcel cA cc wcel c1 cA cabs cfv clt
      wbr wa cA cabs cfv cc0 wne cA cc0 wne cA cabs cfv cr wcel cc0 cA cabs cfv
      clt wbr cA cabs cfv cc0 wne cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs
      cfv gt0ne0 cA cc wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA abscl
      adantr cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01
      cA cc wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa
      cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12 syl mpani imp sylanc cA cc
      wcel cA cabs cfv cc0 wne cA cc0 wne wb c1 cA cabs cfv clt wbr cA cc wcel
      cA cabs cfv cc0 cA cc0 cA abs00 necon3bid adantr mpbid cA reccl syldan cA
      cc wcel c1 cA cabs cfv clt wbr pm3.26 syl3anc cA cc wcel c1 cA cabs cfv
      clt wbr wa c1 cA cmul co cA c1 cA cdiv co cA cmul co c1 cmin cA cc wcel
      c1 cA cmul co cA wceq c1 cA cabs cfv clt wbr cA mulid2 adantr cA cc wcel
      c1 cA cabs cfv clt wbr cA cc0 wne c1 cA cdiv co cA cmul co c1 wceq cA cc
      wcel c1 cA cabs cfv clt wbr wa cA cabs cfv cc0 wne cA cc0 wne cA cabs cfv
      cr wcel cc0 cA cabs cfv clt wbr cA cabs cfv cc0 wne cA cc wcel c1 cA cabs
      cfv clt wbr wa cA cabs cfv gt0ne0 cA cc wcel cA cabs cfv cr wcel c1 cA
      cabs cfv clt wbr cA abscl adantr cA cc wcel c1 cA cabs cfv clt wbr cc0 cA
      cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA
      cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr wcel c1 cr
      wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA
      cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12 syl mpani
      imp sylanc cA cc wcel cA cabs cfv cc0 wne cA cc0 wne wb c1 cA cabs cfv
      clt wbr cA cc wcel cA cabs cfv cc0 cA cc0 cA abs00 necon3bid adantr mpbid
      cA recid2 syldan opreq12d eqtrd opreq12d eqtrd breqtrd $.
      $( [29-Dec-2007] $) $( [28-Dec-2007] $)
  $}

  ${
    $d k y A $.  $d y k N $.
    geosum.1 $e |- A e. CC $.
    $( The value of the finite geometric series ` 1 + A ^ 1 + A ^ 2 + ` ...
       ` + A ^ N ` . $)
    geosumi $p |- ( ( N e. NN0 /\ A =/= 1 ) -> sum_ k e. ( 0 ... N ) ( A ^ k )
               = ( ( 1 - ( A ^ ( N + 1 ) ) ) / ( 1 - A ) ) ) $=
      cN cn0 wcel cA c1 wne wa cc0 cN cfz co cA vk cv cexp co vk csu cN caddc
      vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseq0 co cfv c1
      cA cN c1 caddc co cexp co cmin co c1 cA cmin co cdiv co cN cn0 wcel cc0
      cN cfz co cA vk cv cexp co vk csu cN caddc vk cv cn0 wcel vy cv cA vk cv
      cexp co wceq wa vk vy copab cseq0 co cfv wceq cA c1 wne cN cn0 wcel cc0
      cN cfz co cA vk cv cexp co vk csu cN cc0 caddc cop vk cv cn0 wcel vy cv
      cA vk cv cexp co wceq wa vk vy copab cseqz co cfv cN caddc vk cv cn0 wcel
      vy cv cA vk cv cexp co wceq wa vk vy copab cseq0 co cfv cN cn0 wcel cN
      cc0 cuz cfv wcel cc0 cN cfz co cA vk cv cexp co vk csu cN cc0 caddc cop
      vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co cfv
      wceq cN elnn0uz vy cA vk cv cexp co vk vk cv cn0 wcel vy cv cA vk cv cexp
      co wceq wa vk vy copab cc0 cN cA vk cv cexp oprex vk cv cn0 wcel vy cv cA
      vk cv cexp co wceq wa vk cv cc0 cuz cfv wcel vy cv cA vk cv cexp co wceq
      wa vk vy vk cv cn0 wcel vk cv cc0 cuz cfv wcel vy cv cA vk cv cexp co
      wceq vk cv elnn0uz anbi1i opabbii fsumserz2 sylbi cN caddc vk cv cn0 wcel
      vy cv cA vk cv cexp co wceq wa vk vy copab cseq0 co cc0 caddc cop vk cv
      cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co caddc vk cv
      cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab addex vk vy cn0 cA vk
      cv cexp co nn0ex opabex2 seq0seqz fveq1i syl6eqr adantr vy cA vk vk cv
      cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cN vk cv cn0 wcel vy
      cv cA vk cv cexp co wceq wa vk vy copab eqid geosum.1 geoseri eqtrd $.
      $( [9-May-2006] $) $( [9-May-2006] $)
  $}

  ${
    $d k x y z A $.  $d k x y z R $.
    $( The infinite sum of ` 1 + A ^ 1 + A ^ 2 ` ... is
       ` ( 1 / ( 1 - A ) ) ` . $)
    geoisum $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
                  sum_ k e. NN0 ( A ^ k ) = ( 1 / ( 1 - A ) ) ) $=
      cA cc wcel cA cabs cfv c1 clt wbr wa cc0 cuz cfv cA vk cv cexp co vk csu
      c1 c1 cA cmin co cdiv co cn0 cA vk cv cexp co vk csu cc0 cz wcel cc0
      caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz
      co c1 c1 cA cmin co cdiv co cli wbr cc0 cuz cfv cA vk cv cexp co vk csu
      c1 c1 cA cmin co cdiv co wceq cA cc wcel cA cabs cfv c1 clt wbr wa vy cA
      vk cv cexp co c1 c1 cA cmin co cdiv co vk vk cv cn0 wcel vy cv cA vk cv
      cexp co wceq wa vk vy copab cc0 cA vk cv cexp oprex vk cv cn0 wcel vy cv
      cA vk cv cexp co wceq wa vk cv cc0 cuz cfv wcel vy cv cA vk cv cexp co
      wceq wa vk vy vk cv cn0 wcel vk cv cc0 cuz cfv wcel vy cv cA vk cv cexp
      co wceq vk cv elnn0uz anbi1i opabbii c1 c1 cA cmin co cdiv oprex
      isumclim4 0z cA cc wcel cA cabs cfv c1 clt wbr wa caddc vk cv cn0 wcel vy
      cv cA vk cv cexp co wceq wa vk vy copab cseq0 co c1 c1 cA cmin co cdiv co
      cc0 caddc cop vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab
      cseqz co cli vy cA vk vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy
      copab vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab eqid
      geolim caddc vk cv cn0 wcel vy cv cA vk cv cexp co wceq wa vk vy copab
      addex vk vy cn0 cA vk cv cexp co nn0ex opabex2 seq0seqz syl5eqbrr sylancr
      cn0 cc0 cuz cfv cA vk cv cexp co vk nn0uz sumeq1i syl5eq $.
      $( [4-Jan-2007] $) $( [15-May-2006] $)

    $( The infinite sum of reciprocals ` 1 + ( 1 / A ) ^ 1 + ( 1 / A ) ^ 2 `
       ... is ` A / ( A - 1 ) ` .  (Contributed by rpenner, 3-Nov-2007.) $)
    geoisumr $p |- ( ( A e. CC /\ 1 < ( abs ` A ) ) ->
              sum_ k e. NN0 ( ( 1 / A ) ^ k ) = ( A / ( A - 1 ) ) ) $=
      cA cc wcel c1 cA cabs cfv clt wbr wa cn0 c1 cA cdiv co vk cv cexp co vk
      csu c1 c1 c1 cA cdiv co cmin co cdiv co c1 cA c1 cmin co cA cdiv co cdiv
      co cA cA c1 cmin co cdiv co c1 cA cdiv co cc wcel c1 cA cdiv co cabs cfv
      c1 clt wbr cn0 c1 cA cdiv co vk cv cexp co vk csu c1 c1 c1 cA cdiv co
      cmin co cdiv co wceq cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co
      vk geoisum cA cc wcel c1 cA cabs cfv clt wbr cA cc0 wne c1 cA cdiv co cc
      wcel cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc0 wne
      cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0
      c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel
      cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs
      cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1
      clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0
      c1 cA cabs cfv axlttrn mp3an12 syl mpani imp cA cc wcel cA cc0 wne cc0 cA
      cabs cfv clt wbr cA absgt0 biimpar syldan cA reccl syldan cA cc wcel c1
      cA cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cA cabs cfv cdiv co c1
      clt cA cc wcel c1 cA cabs cfv clt wbr wa c1 cA cdiv co cabs cfv c1 cabs
      cfv cA cabs cfv cdiv co c1 cA cabs cfv cdiv co cA cc wcel c1 cA cabs cfv
      clt wbr cA cc0 wne c1 cA cdiv co cabs cfv c1 cabs cfv cA cabs cfv cdiv co
      wceq cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc0 wne
      cA cc wcel c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0
      c1 clt wbr c1 cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel
      cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs
      cfv clt wbr wi cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1
      clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0
      c1 cA cabs cfv axlttrn mp3an12 syl mpani imp cA cc wcel cA cc0 wne cc0 cA
      cabs cfv clt wbr cA absgt0 biimpar syldan c1 cc wcel cA cc wcel cA cc0
      wne c1 cA cdiv co cabs cfv c1 cabs cfv cA cabs cfv cdiv co wceq ax1cn c1
      cA absdiv mp3an1 syldan c1 cabs cfv c1 cA cabs cfv cdiv cc0 c1 cle wbr c1
      cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp opreq1i
      syl6eq cA cc wcel c1 cA cabs cfv clt wbr wa cc0 c1 cA cabs cfv cdiv co
      clt wbr c1 cA cabs cfv cdiv co c1 clt wbr cA cabs cfv cr wcel c1 cA cabs
      cfv clt wbr cc0 c1 cA cabs cfv cdiv co clt wbr c1 cA cabs cfv cdiv co c1
      clt wbr wa cA cc wcel cA cabs cfv recgt1i cA abscl sylan pm3.27d eqbrtrd
      sylanc cA cc wcel c1 cA cabs cfv clt wbr wa c1 c1 cA cdiv co cmin co cA
      c1 cmin co cA cdiv co c1 cdiv cA cc wcel c1 cA cabs cfv clt wbr cA cc0
      wne c1 c1 cA cdiv co cmin co cA c1 cmin co cA cdiv co wceq cA cc wcel c1
      cA cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc0 wne cA cc wcel c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr
      wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi
      cA abscl cc0 cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA
      cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv
      axlttrn mp3an12 syl mpani imp cA cc wcel cA cc0 wne cc0 cA cabs cfv clt
      wbr cA absgt0 biimpar syldan cA cc wcel cA cc0 wne wa cA c1 cmin co cA
      cdiv co cA cA cdiv co c1 cA cdiv co cmin co c1 c1 cA cdiv co cmin co cA
      cc wcel cA cc0 wne cA c1 cmin co cA cdiv co cA cA cdiv co c1 cA cdiv co
      cmin co wceq cA cc wcel c1 cc wcel cA cc wcel cA cc0 wne wa cA c1 cmin co
      cA cdiv co cA cA cdiv co c1 cA cdiv co cmin co wceq ax1cn cA c1 cA
      divsubdir mp3an2 anabss5 cA cc wcel cA cc0 wne wa cA cA cdiv co c1 c1 cA
      cdiv co cmin cA divid opreq1d eqtr2d syldan opreq2d cA c1 cmin co cc wcel
      cA c1 cmin co cc0 wne cA cc wcel cA cc0 wne c1 cA c1 cmin co cA cdiv co
      cdiv co cA cA c1 cmin co cdiv co wceq cA cc wcel c1 cA cabs cfv clt wbr
      wa cA c1 cmin co cA recdiv cA cc wcel cA c1 cmin co cc wcel c1 cA cabs
      cfv clt wbr cA cc wcel c1 cc wcel cA c1 cmin co cc wcel ax1cn cA c1 subcl
      mpan2 adantr cA cc wcel c1 cA cabs cfv clt wbr wa cA cabs cfv c1 wne cA
      c1 cmin co cc0 wne cA cabs cfv cr wcel c1 cA cabs cfv clt wbr cA cabs cfv
      c1 wne cA cc wcel c1 cr wcel cA cabs cfv cr wcel c1 cA cabs cfv clt wbr
      cA cabs cfv c1 wne 1re c1 cA cabs cfv ltne mp3an1 cA abscl sylan cA cc
      wcel cA cabs cfv c1 wne cA c1 cmin co cc0 wne wi c1 cA cabs cfv clt wbr
      cA cc wcel cA c1 cmin co cc0 cA cabs cfv c1 cA cc wcel cA c1 cmin co cc0
      wceq cA c1 wceq cA cabs cfv c1 wceq cA cc wcel c1 cc wcel cA c1 cmin co
      cc0 wceq cA c1 wceq wb ax1cn cA c1 subeq0 mpan2 cA c1 wceq cA cabs cfv c1
      cabs cfv c1 cA c1 cabs fveq2 cc0 c1 cle wbr c1 cabs cfv c1 wceq cc0 c1
      0re 1re lt01 ltleii c1 1re absidi ax-mp syl6eq syl6bi necon3d adantr mpd
      cA cc wcel c1 cA cabs cfv clt wbr pm3.26 cA cc wcel c1 cA cabs cfv clt
      wbr cc0 cA cabs cfv clt wbr cA cc0 wne cA cc wcel c1 cA cabs cfv clt wbr
      cc0 cA cabs cfv clt wbr cA cc wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr
      cc0 cA cabs cfv clt wbr lt01 cA cc wcel cA cabs cfv cr wcel cc0 c1 clt
      wbr c1 cA cabs cfv clt wbr wa cc0 cA cabs cfv clt wbr wi cA abscl cc0 cr
      wcel c1 cr wcel cA cabs cfv cr wcel cc0 c1 clt wbr c1 cA cabs cfv clt wbr
      wa cc0 cA cabs cfv clt wbr wi 0re 1re cc0 c1 cA cabs cfv axlttrn mp3an12
      syl mpani imp cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr cA absgt0
      biimpar syldan syl2anc 3eqtrd $.
      $( [24-Apr-2008] $) $( [3-Nov-2007] $)

    $( The infinite sum of ` A ^ 1 + A ^ 2 ` ... is ` ( A / ( 1 - A ) ) ` . $)
    geoisum1 $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
                  sum_ k e. NN ( A ^ k ) = ( A / ( 1 - A ) ) ) $=
      cA cc wcel cA cabs cfv c1 clt wbr wa c1 cuz cfv cA vk cv cexp co vk csu
      cA c1 cA cmin co cdiv co cn cA vk cv cexp co vk csu c1 cz wcel c1 caddc
      cop vk cv cn wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co cA
      c1 cA cmin co cdiv co cli wbr c1 cuz cfv cA vk cv cexp co vk csu cA c1 cA
      cmin co cdiv co wceq cA cc wcel cA cabs cfv c1 clt wbr wa vy cA vk cv
      cexp co cA c1 cA cmin co cdiv co vk vk cv cn wcel vy cv cA vk cv cexp co
      wceq wa vk vy copab c1 cA vk cv cexp oprex vk cv cn wcel vy cv cA vk cv
      cexp co wceq wa vk cv c1 cuz cfv wcel vy cv cA vk cv cexp co wceq wa vk
      vy vk cv cn wcel vk cv c1 cuz cfv wcel vy cv cA vk cv cexp co wceq vk cv
      elnnuz anbi1i opabbii cA c1 cA cmin co cdiv oprex isumclim4 1z cA cc wcel
      cA cabs cfv c1 clt wbr wa caddc vk cv cn wcel vy cv cA vk cv cexp co wceq
      wa vk vy copab cseq1 co cA c1 cA cmin co cdiv co c1 caddc cop vk cv cn
      wcel vy cv cA vk cv cexp co wceq wa vk vy copab cseqz co cli vy cA vk vk
      cv cn wcel vy cv cA vk cv cexp co wceq wa vk vy copab vk cv cn wcel vy cv
      cA vk cv cexp co wceq wa vk vy copab eqid geolim1 caddc vk cv cn wcel vy
      cv cA vk cv cexp co wceq wa vk vy copab addex vk vy cn cA vk cv cexp co
      nnex opabex2 seq1seqz syl5eqbrr sylancr cn c1 cuz cfv cA vk cv cexp co vk
      nnuz sumeq1i syl5eq $.
      $( [6-Nov-2007] $) $( [1-Nov-2007] $)

    $( The infinite sum of ` A x. ( R ^ 1 ) + A x. ( R ^ 2 ) ` ... is
       ` ( A x. R ) / ( 1 - R ) ` . $)
    geoisum1c $p |- ( ( A e. CC /\ R e. CC /\ ( abs ` R ) < 1 ) ->
          sum_ k e. NN ( A x. ( R ^ k ) ) = ( ( A x. R ) / ( 1 - R ) ) ) $=
      cA cc wcel cR cc wcel cR cabs cfv c1 clt wbr w3a cA cR cmul co c1 cR cmin
      co cdiv co cA cR c1 cR cmin co cdiv co cmul co cA c1 cuz cfv cR vk cv
      cexp co vk csu cmul co cn cA cR vk cv cexp co cmul co vk csu cA cc wcel
      cR cc wcel c1 cR cmin co cc wcel c1 cR cmin co cc0 wne wa cA cR cmul co
      c1 cR cmin co cdiv co cA cR c1 cR cmin co cdiv co cmul co wceq cR cabs
      cfv c1 clt wbr cA cR c1 cR cmin co divass cA cc wcel cR cc wcel cR cabs
      cfv c1 clt wbr w3a c1 cR cmin co cc wcel c1 cR cmin co cc0 wne cR cc wcel
      cA cc wcel c1 cR cmin co cc wcel cR cabs cfv c1 clt wbr c1 cc wcel cR cc
      wcel c1 cR cmin co cc wcel ax1cn c1 cR subcl mpan 3ad2ant2 cR cc wcel cR
      cabs cfv c1 clt wbr c1 cR cmin co cc0 wne cA cc wcel cR cc wcel c1 cr
      wcel cR cabs cfv c1 clt wbr c1 cR cmin co cc0 wne 1re cR c1 abssubne0
      mp3an2 3adant1 jca syld3an3 cA cc wcel cR cc wcel cR cabs cfv c1 clt wbr
      w3a c1 cuz cfv cR vk cv cexp co vk csu cR c1 cR cmin co cdiv co cA cmul
      cR cc wcel cR cabs cfv c1 clt wbr c1 cuz cfv cR vk cv cexp co vk csu cR
      c1 cR cmin co cdiv co wceq cA cc wcel cR cc wcel cR cabs cfv c1 clt wbr
      wa cn cR vk cv cexp co vk csu cR c1 cR cmin co cdiv co c1 cuz cfv cR vk
      cv cexp co vk csu cR vk geoisum1 cn c1 cuz cfv cR vk cv cexp co vk nnuz
      sumeq1i syl5eqr 3adant1 opreq2d cA cc wcel cR cc wcel cR cabs cfv c1 clt
      wbr w3a cA c1 cuz cfv cR vk cv cexp co vk csu cmul co c1 cuz cfv cA cR vk
      cv cexp co cmul co vk csu cn cA cR vk cv cexp co cmul co vk csu cA cc
      wcel cR cc wcel cR cabs cfv c1 clt wbr cA c1 cuz cfv cR vk cv cexp co vk
      csu cmul co c1 cuz cfv cA cR vk cv cexp co cmul co vk csu wceq cA cc wcel
      cR vk cv cexp co cc wcel vk c1 cuz cfv wral c1 caddc cop vk cv cn wcel vy
      cv cR vk cv cexp co wceq wa vk vy copab cseqz co vx cv cli wbr vx wex wa
      cA c1 cuz cfv cR vk cv cexp co vk csu cmul co c1 cuz cfv cA cR vk cv cexp
      co cmul co vk csu wceq cR cc wcel cR cabs cfv c1 clt wbr wa c1 cz wcel cA
      cc wcel cR vk cv cexp co cc wcel vk c1 cuz cfv wral c1 caddc cop vk cv cn
      wcel vy cv cR vk cv cexp co wceq wa vk vy copab cseqz co vx cv cli wbr vx
      wex wa cA c1 cuz cfv cR vk cv cexp co vk csu cmul co c1 cuz cfv cA cR vk
      cv cexp co cmul co vk csu wceq 1z vx vz cR vk cv cexp co cA vk vk cv cn
      wcel vy cv cR vk cv cexp co wceq wa vk vy copab c1 cR vk cv cexp oprex vk
      vy cn cR vk cv cexp co nnex opabex2 vk cv cn wcel vy cv cR vk cv cexp co
      wceq wa vk vy vz hbopab1 vk cv c1 cuz cfv wcel vk cv cn wcel vk cv vk cv
      cn wcel vy cv cR vk cv cexp co wceq wa vk vy copab cfv cR vk cv cexp co
      wceq vk cv elnnuz vk cv cn wcel cR vk cv cexp co cvv wcel vk cv vk cv cn
      wcel vy cv cR vk cv cexp co wceq wa vk vy copab cfv cR vk cv cexp co wceq
      cR vk cv cexp oprex vk vy cn cR vk cv cexp co cvv fvopab2 mpan2 sylbir
      isummulc1ai mpanl1 cR cc wcel cR cabs cfv c1 clt wbr wa cR vk cv cexp co
      cc wcel vk c1 cuz cfv wral c1 caddc cop vk cv cn wcel vy cv cR vk cv cexp
      co wceq wa vk vy copab cseqz co vx cv cli wbr vx wex cR cc wcel cR vk cv
      cexp co cc wcel vk c1 cuz cfv wral cR cabs cfv c1 clt wbr cR cc wcel cR
      vk cv cexp co cc wcel vk c1 cuz cfv cR cc wcel vk cv cn0 wcel cR vk cv
      cexp co cc wcel vk cv c1 cuz cfv wcel cR vk cv expcl vk cv c1 cuz cfv
      wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir sylan2
      r19.21aiva adantr cR cc wcel cR cabs cfv c1 clt wbr wa caddc vk cv cn
      wcel vy cv cR vk cv cexp co wceq wa vk vy copab cseq1 co cR c1 cR cmin co
      cdiv co cli wbr c1 caddc cop vk cv cn wcel vy cv cR vk cv cexp co wceq wa
      vk vy copab cseqz co vx cv cli wbr vx wex vy cR vk vk cv cn wcel vy cv cR
      vk cv cexp co wceq wa vk vy copab vk cv cn wcel vy cv cR vk cv cexp co
      wceq wa vk vy copab eqid geolim1 c1 caddc cop vk cv cn wcel vy cv cR vk
      cv cexp co wceq wa vk vy copab cseqz co vx cv cli wbr caddc vk cv cn wcel
      vy cv cR vk cv cexp co wceq wa vk vy copab cseq1 co cR c1 cR cmin co cdiv
      co cli wbr vx cR c1 cR cmin co cdiv co cR c1 cR cmin co cdiv oprex vx cv
      cR c1 cR cmin co cdiv co wceq caddc vk cv cn wcel vy cv cR vk cv cexp co
      wceq wa vk vy copab cseq1 co vx cv cli wbr caddc vk cv cn wcel vy cv cR
      vk cv cexp co wceq wa vk vy copab cseq1 co cR c1 cR cmin co cdiv co cli
      wbr c1 caddc cop vk cv cn wcel vy cv cR vk cv cexp co wceq wa vk vy copab
      cseqz co vx cv cli wbr vx cv cR c1 cR cmin co cdiv co caddc vk cv cn wcel
      vy cv cR vk cv cexp co wceq wa vk vy copab cseq1 co cli breq2 caddc vk cv
      cn wcel vy cv cR vk cv cexp co wceq wa vk vy copab cseq1 co c1 caddc cop
      vk cv cn wcel vy cv cR vk cv cexp co wceq wa vk vy copab cseqz co vx cv
      cli caddc vk cv cn wcel vy cv cR vk cv cexp co wceq wa vk vy copab addex
      vk vy cn cR vk cv cexp co nnex opabex2 seq1seqz breq1i syl5bbr cla4ev syl
      jca sylan2 3impb cn c1 cuz cfv cA cR vk cv cexp co cmul co vk nnuz
      sumeq1i syl6eqr 3eqtr2rd $.
      $( [2-Nov-2007] $) $( [2-Nov-2007] $)
  $}

  $( The recurring decimal 0.999..., which is defined as the infinite sum 0.9 +
     0.09 + 0.009 + ... i.e. ` 9 / 10 ^ 1 + 9 / 10 ^ 2 + 9 / 10 ^ 3 + ... ` ,
     is exactly equal to 1, according to ZF set theory.  Interestingly, about
     40% of the people responding to a poll at
     ~ http://forum.physorg.com/index.php?showtopic=13177 disagree. $)
  0.999... $p |- sum_ k e. NN ( 9 / ( 10 ^ k ) ) = 1 $=
    cn c9 c10 vk cv cexp co cdiv co vk csu cn c9 c1 c10 cdiv co vk cv cexp co
    cmul co vk csu c9 c1 c10 cdiv co cmul co c1 c1 c10 cdiv co cmin co cdiv co
    c1 cn c9 c10 vk cv cexp co cdiv co c9 c1 c10 cdiv co vk cv cexp co cmul co
    vk vk cv cn wcel vk cv cn0 wcel c9 c10 vk cv cexp co cdiv co c9 c1 c10 cdiv
    co vk cv cexp co cmul co wceq vk cv nnnn0 vk cv cn0 wcel c9 c10 vk cv cexp
    co cdiv co c9 c1 c10 vk cv cexp co cdiv co cmul co c9 c1 c10 cdiv co vk cv
    cexp co cmul co c10 vk cv cexp co cc wcel c10 vk cv cexp co cc0 wne c9 c10
    vk cv cexp co cdiv co c9 c1 c10 vk cv cexp co cdiv co cmul co wceq vk cv
    cn0 wcel c9 cc wcel c10 vk cv cexp co cc wcel c10 vk cv cexp co cc0 wne c9
    c10 vk cv cexp co cdiv co c9 c1 c10 vk cv cexp co cdiv co cmul co wceq c9
    9re recni c9 c10 vk cv cexp co divrec mp3an1 c10 cc wcel vk cv cn0 wcel c10
    vk cv cexp co cc wcel c10 10re recni c10 vk cv expcl mpan c10 cc wcel c10
    cc0 wne vk cv cn0 wcel c10 vk cv cexp co cc0 wne c10 10re recni c10 10re
    10pos gt0ne0ii c10 vk cv expne0i mp3an12 sylanc vk cv cn0 wcel c1 c10 cdiv
    co vk cv cexp co c1 c10 vk cv cexp co cdiv co c9 cmul c10 cc wcel vk cv cn0
    wcel c10 cc0 wne c1 c10 cdiv co vk cv cexp co c1 c10 vk cv cexp co cdiv co
    wceq c10 10re recni c10 10re 10pos gt0ne0ii c10 vk cv exprecOLD mp3an13
    opreq2d eqtr4d syl sumeq2i c9 cc wcel c1 c10 cdiv co cc wcel c1 c10 cdiv co
    cabs cfv c1 clt wbr cn c9 c1 c10 cdiv co vk cv cexp co cmul co vk csu c9 c1
    c10 cdiv co cmul co c1 c1 c10 cdiv co cmin co cdiv co wceq c9 9re recni c1
    c10 cdiv co c10 10re c10 10re 10pos gt0ne0ii rereccli recni c1 c10 cdiv co
    cabs cfv c1 c10 cdiv co c1 clt cc0 c1 c10 cdiv co cle wbr c1 c10 cdiv co
    cabs cfv c1 c10 cdiv co wceq cc0 c1 c10 cdiv co 0re c10 10re c10 10re 10pos
    gt0ne0ii rereccli c10 10re 10pos recgt0ii ltleii c1 c10 cdiv co c10 10re
    c10 10re 10pos gt0ne0ii rereccli absidi ax-mp c1 c10 clt wbr c1 c10 cdiv co
    c1 clt wbr c1 c9 c1 caddc co c10 clt cc0 c9 clt wbr c1 c9 c1 caddc co clt
    wbr 9pos c9 cr wcel c1 cr wcel cc0 c9 clt wbr c1 c9 c1 caddc co clt wbr wb
    9re 1re c9 c1 ltaddpos2 mp2an mpbi df-10 breqtrri c10 cr wcel cc0 c10 clt
    wbr c1 c10 clt wbr c1 c10 cdiv co c1 clt wbr wb 10re 10pos c10 recgt1 mp2an
    mpbi eqbrtri c9 c1 c10 cdiv co vk geoisum1c mp3an c9 c10 cdiv co c9 c10
    cdiv co cdiv co c9 c1 c10 cdiv co cmul co c1 c1 c10 cdiv co cmin co cdiv co
    c1 c9 c10 cdiv co c9 c1 c10 cdiv co cmul co c9 c10 cdiv co c1 c1 c10 cdiv
    co cmin co cdiv c9 c10 c9 9re recni c10 10re recni c10 10re 10pos gt0ne0ii
    divreci c10 c9 c10 cdiv co cmul co c10 c1 c1 c10 cdiv co cmin co cmul co
    wceq c9 c10 cdiv co c1 c1 c10 cdiv co cmin co wceq c10 c9 c10 cdiv co cmul
    co c9 c10 c1 c1 c10 cdiv co cmin co cmul co c9 c10 c9 9re recni c10 10re
    recni c10 10re 10pos gt0ne0ii divcan2i c10 c1 c1 c10 cdiv co cmin co cmul
    co c10 c1 cmul co c10 c1 c10 cdiv co cmul co cmin co c10 c1 cmin co c9 c10
    c1 c1 c10 cdiv co c10 10re recni ax1cn c1 c10 cdiv co c10 10re c10 10re
    10pos gt0ne0ii rereccli recni subdii c10 c1 cmul co c10 c10 c1 c10 cdiv co
    cmul co c1 cmin c10 c10 10re recni mulid1i c10 c10 10re recni c10 10re
    10pos gt0ne0ii recidi opreq12i c10 c1 c9 c10 10re recni ax1cn c9 9re recni
    c1 c9 caddc co c9 c1 caddc co c10 c1 c9 ax1cn c9 9re recni addcomi df-10
    eqtr4i subaddrii 3eqtrri eqtri c9 c10 cdiv co c1 c1 c10 cdiv co cmin co c10
    c9 c10 cdiv co c9 c10 9re 10re c10 10re 10pos gt0ne0ii redivcli recni c1 c1
    c10 cdiv co ax1cn c1 c10 cdiv co c10 10re c10 10re 10pos gt0ne0ii rereccli
    recni subcli c10 10re recni c10 10re 10pos gt0ne0ii mulcani mpbi opreq12i
    c9 c10 cdiv co c9 c10 cdiv co c9 c10 9re 10re c10 10re 10pos gt0ne0ii
    redivcli recni c9 c10 cdiv co c9 c10 9re 10re c10 10re 10pos gt0ne0ii
    redivcli c9 c10 9re 10re 9pos 10pos divgt0ii gt0ne0ii dividi eqtr3i 3eqtri
    $.
    $( [2-Nov-2007] $) $( [2-Nov-2007] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ratio test for infinite series convergence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d x y z $.  $d x y z A $.  $d x y z B $.  $d y C $.  $d x y z F $.
    cvgratlem1ALT.1 $e |- F : NN --> RR $.
    cvgratlem1ALT.2 $e |- A e. RR $.
    cvgratlem1ALT.3 $e |- B e. NN $.
    cvgratlem1ALT.4 $e |- C e. NN $.
    $( Lemma for ~ cvgrati .  Establish, by induction, an exponential upper
       bound for the terms of a real series, given that the ratio of successive
       terms is less than some positive constant ` A ` beyond a starting index
       ` B ` . $)
    cvgratlem1ALT $p |- ( ( 0 < A /\
       A. x e. NN ( B <_ x -> ( F ` ( x + 1 ) ) < ( A x. ( F ` x ) ) ) ) ->
                     ( F ` ( B + C ) ) <_ ( ( A ^ C ) x. ( F ` B ) ) ) $=
      cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv
      cmul co clt wbr wi vx cn wral wa cB cC caddc co cF cfv cA cC cexp co cB
      cF cfv cmul co clt wbr cB cC caddc co cF cfv cA cC cexp co cB cF cfv cmul
      co cle wbr cC cn wcel cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co
      cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa cB cC caddc co cF
      cfv cA cC cexp co cB cF cfv cmul co clt wbr wi cvgratlem1ALT.4 cc0 cA clt
      wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt
      wbr wi vx cn wral wa cB vy cv caddc co cF cfv cA vy cv cexp co cB cF cfv
      cmul co clt wbr wi cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF
      cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa cB c1 caddc co cF
      cfv cA c1 cexp co cB cF cfv cmul co clt wbr wi cc0 cA clt wbr cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral wa cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt
      wbr wi cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv
      cF cfv cmul co clt wbr wi vx cn wral wa cB vz cv c1 caddc co caddc co cF
      cfv cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr wi cc0 cA clt
      wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt
      wbr wi vx cn wral wa cB cC caddc co cF cfv cA cC cexp co cB cF cfv cmul
      co clt wbr wi vy vz cC vy cv c1 wceq cB vy cv caddc co cF cfv cA vy cv
      cexp co cB cF cfv cmul co clt wbr cB c1 caddc co cF cfv cA c1 cexp co cB
      cF cfv cmul co clt wbr cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co
      cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa vy cv c1 wceq cB
      vy cv caddc co cF cfv cB c1 caddc co cF cfv cA vy cv cexp co cB cF cfv
      cmul co cA c1 cexp co cB cF cfv cmul co clt vy cv c1 wceq cB vy cv caddc
      co cB c1 caddc co cF vy cv c1 cB caddc opreq2 fveq2d vy cv c1 wceq cA vy
      cv cexp co cA c1 cexp co cB cF cfv cmul vy cv c1 cA cexp opreq2 opreq1d
      breq12d imbi2d vy cv vz cv wceq cB vy cv caddc co cF cfv cA vy cv cexp co
      cB cF cfv cmul co clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF
      cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa vy cv vz cv wceq cB
      vy cv caddc co cF cfv cB vz cv caddc co cF cfv cA vy cv cexp co cB cF cfv
      cmul co cA vz cv cexp co cB cF cfv cmul co clt vy cv vz cv wceq cB vy cv
      caddc co cB vz cv caddc co cF vy cv vz cv cB caddc opreq2 fveq2d vy cv vz
      cv wceq cA vy cv cexp co cA vz cv cexp co cB cF cfv cmul vy cv vz cv cA
      cexp opreq2 opreq1d breq12d imbi2d vy cv vz cv c1 caddc co wceq cB vy cv
      caddc co cF cfv cA vy cv cexp co cB cF cfv cmul co clt wbr cB vz cv c1
      caddc co caddc co cF cfv cA vz cv c1 caddc co cexp co cB cF cfv cmul co
      clt wbr cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv
      cF cfv cmul co clt wbr wi vx cn wral wa vy cv vz cv c1 caddc co wceq cB
      vy cv caddc co cF cfv cB vz cv c1 caddc co caddc co cF cfv cA vy cv cexp
      co cB cF cfv cmul co cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt
      vy cv vz cv c1 caddc co wceq cB vy cv caddc co cB vz cv c1 caddc co caddc
      co cF vy cv vz cv c1 caddc co cB caddc opreq2 fveq2d vy cv vz cv c1 caddc
      co wceq cA vy cv cexp co cA vz cv c1 caddc co cexp co cB cF cfv cmul vy
      cv vz cv c1 caddc co cA cexp opreq2 opreq1d breq12d imbi2d vy cv cC wceq
      cB vy cv caddc co cF cfv cA vy cv cexp co cB cF cfv cmul co clt wbr cB cC
      caddc co cF cfv cA cC cexp co cB cF cfv cmul co clt wbr cc0 cA clt wbr cB
      vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi
      vx cn wral wa vy cv cC wceq cB vy cv caddc co cF cfv cB cC caddc co cF
      cfv cA vy cv cexp co cB cF cfv cmul co cA cC cexp co cB cF cfv cmul co
      clt vy cv cC wceq cB vy cv caddc co cB cC caddc co cF vy cv cC cB caddc
      opreq2 fveq2d vy cv cC wceq cA vy cv cexp co cA cC cexp co cB cF cfv cmul
      vy cv cC cA cexp opreq2 opreq1d breq12d imbi2d cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB c1 caddc
      co cF cfv cA c1 cexp co cB cF cfv cmul co clt wbr cc0 cA clt wbr cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral cB c1 caddc co cF cfv cA cB cF cfv cmul co cA c1 cexp co cB cF cfv
      cmul co clt cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv
      cmul co clt wbr wi vx cn wral cB cB cle wbr cB c1 caddc co cF cfv cA cB
      cF cfv cmul co clt wbr cB cB cvgratlem1ALT.3 nnrei leidi cB cn wcel cB vx
      cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx
      cn wral cB cB cle wbr cB c1 caddc co cF cfv cA cB cF cfv cmul co clt wbr
      wi wi cvgratlem1ALT.3 cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv
      cF cfv cmul co clt wbr wi cB cB cle wbr cB c1 caddc co cF cfv cA cB cF
      cfv cmul co clt wbr wi vx cB cn vx cv cB wceq cB vx cv cle wbr cB cB cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr cB c1 caddc
      co cF cfv cA cB cF cfv cmul co clt wbr vx cv cB cB cle breq2 vx cv cB
      wceq vx cv c1 caddc co cF cfv cB c1 caddc co cF cfv cA vx cv cF cfv cmul
      co cA cB cF cfv cmul co clt vx cv cB wceq vx cv c1 caddc co cB c1 caddc
      co cF vx cv cB c1 caddc opreq1 fveq2d vx cv cB wceq vx cv cF cfv cB cF
      cfv cA cmul vx cv cB cF fveq2 opreq2d breq12d imbi12d rcla4v ax-mp mpi cA
      c1 cexp co cA cB cF cfv cmul cA cc wcel cA c1 cexp co cA wceq cA
      cvgratlem1ALT.2 recni cA exp1 ax-mp opreq1i syl6breqr adantl vz cv cn
      wcel cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF
      cfv cmul co clt wbr wi vx cn wral wa cB vz cv caddc co cF cfv cA vz cv
      cexp co cB cF cfv cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv cA
      vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr vz cv cn wcel cc0 cA
      clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co
      clt wbr wi vx cn wral wa cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv cA vz cv c1
      caddc co cexp co cB cF cfv cmul co clt wbr wi vz cv cn wcel cc0 cA clt
      wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt
      wbr wi vx cn wral wa wa cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp
      co cB cF cfv cmul co cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv
      cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr vz cv cn wcel cc0
      cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul
      co clt wbr wi vx cn wral cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp
      co cB cF cfv cmul co cmul co clt wbr wi vz cv cn wcel cB vx cv cle wbr vx
      cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cc0
      cA clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co
      clt wbr cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp co cB cF
      cfv cmul co cmul co clt wbr wi vz cv cn wcel cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cc0 cA clt
      wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr
      cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul
      co cmul co clt wbr vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cA
      cB vz cv caddc co cF cfv cmul co clt wbr cA cB vz cv caddc co cF cfv cmul
      co cA cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr cB vz cv caddc
      co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul co cmul co clt
      wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt
      wbr wi vx cn wral cc0 cA clt wbr cB vz cv caddc co cF cfv cA vz cv cexp
      co cB cF cfv cmul co clt wbr wa cB vz cv caddc co c1 caddc co cF cfv cr
      wcel cA cB vz cv caddc co cF cfv cmul co cr wcel cA cA vz cv cexp co cB
      cF cfv cmul co cmul co cr wcel cB vz cv caddc co c1 caddc co cF cfv cA cB
      vz cv caddc co cF cfv cmul co clt wbr cA cB vz cv caddc co cF cfv cmul co
      cA cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr wa cB vz cv caddc
      co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul co cmul co clt
      wbr wi vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv
      caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co
      axlttrn vz cv cn wcel cB vz cv caddc co c1 caddc co cn wcel cB vz cv
      caddc co c1 caddc co cF cfv cr wcel vz cv cn wcel cB vz cv caddc co cn
      wcel cB vz cv caddc co c1 caddc co cn wcel cB cn wcel vz cv cn wcel cB vz
      cv caddc co cn wcel cvgratlem1ALT.3 cB vz cv nnaddcl mpan cB vz cv caddc
      co peano2nn syl cn cr cB vz cv caddc co c1 caddc co cF cvgratlem1ALT.1
      ffvelrni syl cA cr wcel cB vz cv caddc co cF cfv cr wcel cA cB vz cv
      caddc co cF cfv cmul co cr wcel vz cv cn wcel cA cB vz cv caddc co cF cfv
      remulcl cvgratlem1ALT.2 vz cv cn wcel cB vz cv caddc co cn wcel cB vz cv
      caddc co cF cfv cr wcel cB cn wcel vz cv cn wcel cB vz cv caddc co cn
      wcel cvgratlem1ALT.3 cB vz cv nnaddcl mpan cn cr cB vz cv caddc co cF
      cvgratlem1ALT.1 ffvelrni syl sylancr cA cr wcel cA vz cv cexp co cB cF
      cfv cmul co cr wcel cA cA vz cv cexp co cB cF cfv cmul co cmul co cr wcel
      vz cv cn wcel cA cA vz cv cexp co cB cF cfv cmul co remulcl
      cvgratlem1ALT.2 cA vz cv cexp co cr wcel cB cF cfv cr wcel cA vz cv cexp
      co cB cF cfv cmul co cr wcel vz cv cn wcel cA vz cv cexp co cB cF cfv
      remulcl cA cr wcel vz cv cn0 wcel cA vz cv cexp co cr wcel vz cv cn wcel
      cA vz cv reexpcl cvgratlem1ALT.2 vz cv nnnn0 sylancr cB cn wcel cB cF cfv
      cr wcel cvgratlem1ALT.3 cn cr cB cF cvgratlem1ALT.1 ffvelrni ax-mp
      sylancl sylancr syl3anc vz cv cn wcel cB vx cv cle wbr vx cv c1 caddc co
      cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB cB vz cv caddc co
      cle wbr cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc co cF cfv
      cmul co clt wbr cB cr wcel vz cv cn0 wcel cB cB vz cv caddc co cle wbr vz
      cv cn wcel cB vz cv nn0addge1 cB cvgratlem1ALT.3 nnrei vz cv nnnn0
      sylancr vz cv cn wcel cB vz cv caddc co cn wcel cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB cB vz cv
      caddc co cle wbr cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc
      co cF cfv cmul co clt wbr wi wi cB cn wcel vz cv cn wcel cB vz cv caddc
      co cn wcel cvgratlem1ALT.3 cB vz cv nnaddcl mpan cB vx cv cle wbr vx cv
      c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi cB cB vz cv caddc
      co cle wbr cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc co cF
      cfv cmul co clt wbr wi vx cB vz cv caddc co cn vx cv cB vz cv caddc co
      wceq cB vx cv cle wbr cB cB vz cv caddc co cle wbr vx cv c1 caddc co cF
      cfv cA vx cv cF cfv cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv
      cA cB vz cv caddc co cF cfv cmul co clt wbr vx cv cB vz cv caddc co cB
      cle breq2 vx cv cB vz cv caddc co wceq vx cv c1 caddc co cF cfv cB vz cv
      caddc co c1 caddc co cF cfv cA vx cv cF cfv cmul co cA cB vz cv caddc co
      cF cfv cmul co clt vx cv cB vz cv caddc co wceq vx cv c1 caddc co cB vz
      cv caddc co c1 caddc co cF vx cv cB vz cv caddc co c1 caddc opreq1 fveq2d
      vx cv cB vz cv caddc co wceq vx cv cF cfv cB vz cv caddc co cF cfv cA
      cmul vx cv cB vz cv caddc co cF fveq2 opreq2d breq12d imbi12d rcla4v syl
      mpid vz cv cn wcel cc0 cA clt wbr cB vz cv caddc co cF cfv cA vz cv cexp
      co cB cF cfv cmul co clt wbr cA cB vz cv caddc co cF cfv cmul co cA cA vz
      cv cexp co cB cF cfv cmul co cmul co clt wbr cB vz cv caddc co cF cfv cr
      wcel cA vz cv cexp co cB cF cfv cmul co cr wcel cA cr wcel cc0 cA clt wbr
      cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cA cB
      vz cv caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul
      co clt wbr wi wi vz cv cn wcel cB vz cv caddc co cF cfv cr wcel cA vz cv
      cexp co cB cF cfv cmul co cr wcel cA cr wcel w3a cc0 cA clt wbr cB vz cv
      caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cA cB vz cv
      caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co clt
      wbr wi cB vz cv caddc co cF cfv cr wcel cA vz cv cexp co cB cF cfv cmul
      co cr wcel cA cr wcel w3a cc0 cA clt wbr wa cB vz cv caddc co cF cfv cA
      vz cv cexp co cB cF cfv cmul co clt wbr cA cB vz cv caddc co cF cfv cmul
      co cA cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr cB vz cv caddc
      co cF cfv cA vz cv cexp co cB cF cfv cmul co cA ltmul2OLD biimpd ex vz cv
      cn wcel cB vz cv caddc co cn wcel cB vz cv caddc co cF cfv cr wcel cB cn
      wcel vz cv cn wcel cB vz cv caddc co cn wcel cvgratlem1ALT.3 cB vz cv
      nnaddcl mpan cn cr cB vz cv caddc co cF cvgratlem1ALT.1 ffvelrni syl cA
      vz cv cexp co cr wcel cB cF cfv cr wcel cA vz cv cexp co cB cF cfv cmul
      co cr wcel vz cv cn wcel cA vz cv cexp co cB cF cfv remulcl cA cr wcel vz
      cv cn0 wcel cA vz cv cexp co cr wcel vz cv cn wcel cA vz cv reexpcl
      cvgratlem1ALT.2 vz cv nnnn0 sylancr cB cn wcel cB cF cfv cr wcel
      cvgratlem1ALT.3 cn cr cB cF cvgratlem1ALT.1 ffvelrni ax-mp sylancl cA cr
      wcel vz cv cn wcel cvgratlem1ALT.2 a1i syl3anc imp3a syl2and exp4d com23
      imp32 vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp
      co cB cF cfv cmul co cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv
      cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr wb cc0 cA clt wbr
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr
      wi vx cn wral wa vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cB vz
      cv c1 caddc co caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul co cmul
      co cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt vz cv cn wcel cB vz
      cv caddc co c1 caddc co cB vz cv c1 caddc co caddc co cF vz cv cn wcel vz
      cv cc wcel cB vz cv caddc co c1 caddc co cB vz cv c1 caddc co caddc co
      wceq vz cv nncn cB cc wcel vz cv cc wcel c1 cc wcel cB vz cv caddc co c1
      caddc co cB vz cv c1 caddc co caddc co wceq cB cvgratlem1ALT.3 nncni
      ax1cn cB vz cv c1 addass mp3an13 syl fveq2d vz cv cn wcel cA vz cv c1
      caddc co cexp co cB cF cfv cmul co cA cA vz cv cexp co cmul co cB cF cfv
      cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co vz cv cn wcel cA vz
      cv c1 caddc co cexp co cA cA vz cv cexp co cmul co cB cF cfv cmul vz cv
      cn wcel cA vz cv c1 caddc co cexp co cA vz cv cexp co cA cmul co cA cA vz
      cv cexp co cmul co cA cc wcel vz cv cn0 wcel cA vz cv c1 caddc co cexp co
      cA vz cv cexp co cA cmul co wceq vz cv cn wcel cA vz cv expp1 cA
      cvgratlem1ALT.2 recni vz cv nnnn0 sylancr cA vz cv cexp co cc wcel cA cc
      wcel cA vz cv cexp co cA cmul co cA cA vz cv cexp co cmul co wceq vz cv
      cn wcel cA vz cv cexp co cA mulcom cA cc wcel vz cv cn0 wcel cA vz cv
      cexp co cc wcel vz cv cn wcel cA vz cv expcl cA cvgratlem1ALT.2 recni vz
      cv nnnn0 sylancr cA cvgratlem1ALT.2 recni sylancl eqtrd opreq1d vz cv cn
      wcel cA vz cv cexp co cc wcel cA cA vz cv cexp co cmul co cB cF cfv cmul
      co cA cA vz cv cexp co cB cF cfv cmul co cmul co wceq cA cc wcel vz cv
      cn0 wcel cA vz cv cexp co cc wcel vz cv cn wcel cA vz cv expcl cA
      cvgratlem1ALT.2 recni vz cv nnnn0 sylancr cA cc wcel cA vz cv cexp co cc
      wcel cB cF cfv cc wcel cA cA vz cv cexp co cmul co cB cF cfv cmul co cA
      cA vz cv cexp co cB cF cfv cmul co cmul co wceq cA cvgratlem1ALT.2 recni
      cB cF cfv cB cn wcel cB cF cfv cr wcel cvgratlem1ALT.3 cn cr cB cF
      cvgratlem1ALT.1 ffvelrni ax-mp recni cA cA vz cv cexp co cB cF cfv mulass
      mp3an13 syl eqtr2d breq12d adantr sylibd ex a2d nnind ax-mp cB cC caddc
      co cF cfv cA cC cexp co cB cF cfv cmul co cB cC caddc co cn wcel cB cC
      caddc co cF cfv cr wcel cB cn wcel cC cn wcel cB cC caddc co cn wcel
      cvgratlem1ALT.3 cvgratlem1ALT.4 cB cC nnaddcl mp2an cn cr cB cC caddc co
      cF cvgratlem1ALT.1 ffvelrni ax-mp cA cC cexp co cB cF cfv cA cr wcel cC
      cn wcel cA cC cexp co cr wcel cvgratlem1ALT.2 cvgratlem1ALT.4 cA cr wcel
      cC cn0 wcel cA cC cexp co cr wcel cC cn wcel cA cC reexpcl cC nnnn0
      sylan2 mp2an cB cn wcel cB cF cfv cr wcel cvgratlem1ALT.3 cn cr cB cF
      cvgratlem1ALT.1 ffvelrni ax-mp remulcli ltlei syl $.
      $( [17-Aug-2005] $) $( [28-May-2005] $)

    $( Lemma for ~ cvgrati .  Using ~ expsub , restate ~ cvgratlem1ALT with an
       absolute index ` C ` instead of just an offset from the starting index
       ` B ` . $)
    cvgratlem2ALT $p |- ( ( 0 < A /\
         A. x e. NN ( B <_ x -> ( F ` ( x + 1 ) ) < ( A x. ( F ` x ) ) ) ) ->
                     ( B < C ->
                 ( F ` C ) <_ ( ( ( F ` B ) / ( A ^ B ) ) x. ( A ^ C ) ) ) ) $=
      cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv
      cmul co clt wbr wi vx cn wral wa cB cC clt wbr cC cF cfv cB cF cfv cA cB
      cexp co cdiv co cA cC cexp co cmul co cle wbr cc0 cA clt wbr cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral wa cB cC clt wbr wa cC cF cfv cA cC cB cmin co cexp co cB cF cfv
      cmul co cB cF cfv cA cB cexp co cdiv co cA cC cexp co cmul co cle cB cC
      clt wbr cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv
      cF cfv cmul co clt wbr wi vx cn wral wa cC cF cfv cA cC cB cmin co cexp
      co cB cF cfv cmul co cle wbr cB cC clt wbr cC cB cmin co cn wcel cc0 cA
      clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co
      clt wbr wi vx cn wral wa cC cF cfv cA cC cB cmin co cexp co cB cF cfv
      cmul co cle wbr wi cB cC cvgratlem1ALT.3 cvgratlem1ALT.4 nnsubi cC cB
      cmin co cn wcel cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv
      cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa cB cC cB cmin co caddc
      co cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle wbr cC cF cfv cA
      cC cB cmin co cexp co cB cF cfv cmul co cle wbr cC cB cmin co cn wcel cc0
      cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul
      co clt wbr wi vx cn wral wa cB cC cB cmin co caddc co cF cfv cA cC cB
      cmin co cexp co cB cF cfv cmul co cle wbr wi cc0 cA clt wbr cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral wa cB cC cB cmin co cn wcel cC cB cmin co c1 cif caddc co cF cfv cA
      cC cB cmin co cn wcel cC cB cmin co c1 cif cexp co cB cF cfv cmul co cle
      wbr wi cC cB cmin co c1 cC cB cmin co cC cB cmin co cn wcel cC cB cmin co
      c1 cif wceq cB cC cB cmin co caddc co cF cfv cA cC cB cmin co cexp co cB
      cF cfv cmul co cle wbr cB cC cB cmin co cn wcel cC cB cmin co c1 cif
      caddc co cF cfv cA cC cB cmin co cn wcel cC cB cmin co c1 cif cexp co cB
      cF cfv cmul co cle wbr cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co
      cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa cC cB cmin co cC
      cB cmin co cn wcel cC cB cmin co c1 cif wceq cB cC cB cmin co caddc co cF
      cfv cB cC cB cmin co cn wcel cC cB cmin co c1 cif caddc co cF cfv cA cC
      cB cmin co cexp co cB cF cfv cmul co cA cC cB cmin co cn wcel cC cB cmin
      co c1 cif cexp co cB cF cfv cmul co cle cC cB cmin co cC cB cmin co cn
      wcel cC cB cmin co c1 cif wceq cB cC cB cmin co caddc co cB cC cB cmin co
      cn wcel cC cB cmin co c1 cif caddc co cF cC cB cmin co cC cB cmin co cn
      wcel cC cB cmin co c1 cif cB caddc opreq2 fveq2d cC cB cmin co cC cB cmin
      co cn wcel cC cB cmin co c1 cif wceq cA cC cB cmin co cexp co cA cC cB
      cmin co cn wcel cC cB cmin co c1 cif cexp co cB cF cfv cmul cC cB cmin co
      cC cB cmin co cn wcel cC cB cmin co c1 cif cA cexp opreq2 opreq1d breq12d
      imbi2d vx cA cB cC cB cmin co cn wcel cC cB cmin co c1 cif cF
      cvgratlem1ALT.1 cvgratlem1ALT.2 cvgratlem1ALT.3 cC cB cmin co c1 cn 1nn
      elimel cvgratlem1ALT dedth cB cC cB cmin co caddc co cF cfv cC cF cfv cA
      cC cB cmin co cexp co cB cF cfv cmul co cle cB cC cB cmin co caddc co cC
      cF cB cC cB cvgratlem1ALT.3 nncni cC cvgratlem1ALT.4 nncni pncan3i fveq2i
      breq1i syl6ib sylbi impcom cc0 cA clt wbr cB cC clt wbr cA cC cB cmin co
      cexp co cB cF cfv cmul co cB cF cfv cA cB cexp co cdiv co cA cC cexp co
      cmul co wceq cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv
      cmul co clt wbr wi vx cn wral cc0 cA clt wbr cB cC clt wbr wa cA cC cB
      cmin co cexp co cB cF cfv cmul co cA cC cexp co cA cB cexp co cdiv co cB
      cF cfv cmul co cB cF cfv cA cB cexp co cdiv co cA cC cexp co cmul co cc0
      cA clt wbr cB cC clt wbr wa cA cC cB cmin co cexp co cA cC cexp co cA cB
      cexp co cdiv co cB cF cfv cmul cA cc0 wne cB cC clt wbr cA cC cB cmin co
      cexp co cA cC cexp co cA cB cexp co cdiv co wceq cc0 cA clt wbr cA cc
      wcel cC cn wcel cB cn wcel w3a cA cc0 wne cB cC clt wbr wa cA cC cB cmin
      co cexp co cA cC cexp co cA cB cexp co cdiv co wceq cA cc wcel cC cn wcel
      cB cn wcel cA cvgratlem1ALT.2 recni cvgratlem1ALT.4 cvgratlem1ALT.3
      3pm3.2i cA cc wcel cA cc0 wne wa cC cn0 wcel cB cn0 wcel w3a cB cC cle
      wbr cA cC cB cmin co cexp co cA cC cexp co cA cB cexp co cdiv co wceq cA
      cc wcel cC cn wcel cB cn wcel w3a cA cc0 wne cB cC clt wbr wa wa cA cC cB
      expsub cA cc wcel cC cn wcel cB cn wcel w3a cA cc0 wne cA cc wcel cA cc0
      wne wa cC cn0 wcel cB cn0 wcel w3a cB cC clt wbr cA cc wcel cC cn wcel cB
      cn wcel w3a cA cc0 wne wa cA cc wcel cA cc0 wne wa cC cn0 wcel cB cn0
      wcel cA cc wcel cC cn wcel cB cn wcel w3a cA cc0 wne wa cA cc0 wne cA cc
      wcel cA cc wcel cC cn wcel cB cn wcel w3a cA cc0 wne pm3.27 cA
      cvgratlem1ALT.2 recni jctil cA cc wcel cC cn wcel cB cn wcel w3a cC cn0
      wcel cA cc0 wne cC cn wcel cA cc wcel cC cn0 wcel cB cn wcel cC nnnn0
      3ad2ant2 adantr cA cc wcel cC cn wcel cB cn wcel w3a cB cn0 wcel cA cc0
      wne cB cn wcel cA cc wcel cB cn0 wcel cC cn wcel cB nnnn0 3ad2ant3 adantr
      3jca adantrr cA cc wcel cC cn wcel cB cn wcel w3a cB cC clt wbr cB cC cle
      wbr cA cc0 wne cC cn wcel cB cn wcel cB cC clt wbr cB cC cle wbr cA cc
      wcel cC cn wcel cB cn wcel wa cB cC clt wbr cB cC cle wbr cB cn wcel cC
      cn wcel cB cC clt wbr cB cC cle wbr wi cB cr wcel cC cr wcel cB cC clt
      wbr cB cC cle wbr wi cB cn wcel cC cn wcel cB cC ltle cB nnre cC nnre
      syl2an ancoms imp 3adantl1 adantrl sylanc mpan cA cvgratlem1ALT.2 gt0ne0i
      sylan opreq1d cc0 cA clt wbr cB cF cfv cA cB cexp co cdiv co cA cC cexp
      co cmul co cA cC cexp co cA cB cexp co cdiv co cB cF cfv cmul co wceq cB
      cC clt wbr cA cB cexp co cc wcel cA cB cexp co cc0 wne cB cF cfv cA cB
      cexp co cdiv co cA cC cexp co cmul co cA cC cexp co cA cB cexp co cdiv co
      cB cF cfv cmul co wceq cc0 cA clt wbr cB cF cfv cc wcel cA cB cexp co cc
      wcel cA cB cexp co cc0 wne wa cA cC cexp co cc wcel cB cF cfv cA cB cexp
      co cdiv co cA cC cexp co cmul co cA cC cexp co cA cB cexp co cdiv co cB
      cF cfv cmul co wceq cB cF cfv cB cn wcel cB cF cfv cr wcel
      cvgratlem1ALT.3 cn cr cB cF cvgratlem1ALT.1 ffvelrni ax-mp recni cA cc
      wcel cC cn wcel cA cC cexp co cc wcel cA cvgratlem1ALT.2 recni
      cvgratlem1ALT.4 cA cc wcel cC cn0 wcel cA cC cexp co cc wcel cC cn wcel
      cA cC expcl cC nnnn0 sylan2 mp2an cB cF cfv cA cB cexp co cA cC cexp co
      div13 mp3an13 cA cB cexp co cA cr wcel cB cn wcel cA cB cexp co cr wcel
      cvgratlem1ALT.2 cvgratlem1ALT.3 cA cr wcel cB cn0 wcel cA cB cexp co cr
      wcel cB cn wcel cA cB reexpcl cB nnnn0 sylan2 mp2an recni cc0 cA clt wbr
      cc0 cA cB cexp co clt wbr cA cB cexp co cc0 wne cA cr wcel cB cn wcel cc0
      cA clt wbr cc0 cA cB cexp co clt wbr cvgratlem1ALT.2 cvgratlem1ALT.3 cA
      cr wcel cB cn0 wcel cc0 cA clt wbr cc0 cA cB cexp co clt wbr cB cn wcel
      cA cB expgt0 cB nnnn0 syl3an2 mp3an12 cA cB cexp co cA cr wcel cB cn wcel
      cA cB cexp co cr wcel cvgratlem1ALT.2 cvgratlem1ALT.3 cA cr wcel cB cn0
      wcel cA cB cexp co cr wcel cB cn wcel cA cB reexpcl cB nnnn0 sylan2 mp2an
      gt0ne0i syl sylancr adantr eqtr4d adantlr breqtrd ex $.
      $( [17-Aug-2005] $) $( [28-May-2005] $)
  $}

  ${
    $d x A $.  $d x y z B $.  $d x y z F $.  $d y z C $.
    cvgratlem3ALT.1 $e |- F : NN --> CC $.
    $d G x $.
    cvgratlem3ALT.2 $e |- G =
                    { <. y , z >. | ( y e. NN /\ z = ( abs ` ( F ` y ) ) ) } $.
    cvgratlem3ALT.3 $e |- A e. RR $.
    cvgratlem3ALT.4 $e |- B e. NN $.
    cvgratlem3ALT.5 $e |- C e. NN $.
    $( Lemma for ~ cvgrati .  Restate ~ cvgratlem2ALT (which was for a real
       function) in terms of the absolute values of the terms of a complex
       function ` F ` , with the help of an auxiliary function ` G ` . $)
    cvgratlem3ALT $p |- ( ( 0 < A /\ A. x e. NN ( B <_ x ->
  ( abs ` ( F ` ( x + 1 ) ) ) < ( A x. ( abs ` ( F ` x ) ) ) ) ) ->
  ( B < C -> ( abs ` ( F ` C ) ) <_ ( ( ( abs ` ( F ` B ) )
                       / ( A ^ B ) ) x. ( A ^ C ) ) ) ) $=
      cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG cfv
      cmul co clt wbr wi vx cn wral cB cC clt wbr cC cF cfv cabs cfv cB cF cfv
      cabs cfv cA cB cexp co cdiv co cA cC cexp co cmul co cle wbr wi cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv cabs cfv cmul
      co clt wbr wi vx cn wral cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc
      co cG cfv cA vx cv cG cfv cmul co clt wbr wi vx cn wral wa cB cC clt wbr
      cC cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv co cA cC cexp co
      cmul co cle wbr cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cG cfv
      cA vx cv cG cfv cmul co clt wbr wi vx cn wral wa cB cC clt wbr wa cC cG
      cfv cB cG cfv cA cB cexp co cdiv co cA cC cexp co cmul co cC cF cfv cabs
      cfv cB cF cfv cabs cfv cA cB cexp co cdiv co cA cC cexp co cmul co cle
      cc0 cA clt wbr cB vx cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG cfv
      cmul co clt wbr wi vx cn wral wa cB cC clt wbr cC cG cfv cB cG cfv cA cB
      cexp co cdiv co cA cC cexp co cmul co cle wbr vx cA cB cC cG vy vz cn cr
      vy cv cF cfv cabs cfv cG cvgratlem3ALT.2 vy cv cn wcel vy cv cF cfv cc
      wcel vy cv cF cfv cabs cfv cr wcel cn cc vy cv cF cvgratlem3ALT.1
      ffvelrni vy cv cF cfv abscl syl fopab cvgratlem3ALT.3 cvgratlem3ALT.4
      cvgratlem3ALT.5 cvgratlem2ALT imp cC cn wcel cC cG cfv cC cF cfv cabs cfv
      wceq cvgratlem3ALT.5 vy vz cC vy cv cF cfv cabs cfv cC cF cfv cabs cfv cn
      cG vy cv cC wceq vy cv cF cfv cC cF cfv cabs vy cv cC cF fveq2 fveq2d
      cvgratlem3ALT.2 cC cF cfv cabs fvex fvopab4 ax-mp cB cG cfv cA cB cexp co
      cdiv co cB cF cfv cabs cfv cA cB cexp co cdiv co cA cC cexp co cmul cB cG
      cfv cB cF cfv cabs cfv cA cB cexp co cdiv cB cn wcel cB cG cfv cB cF cfv
      cabs cfv wceq cvgratlem3ALT.4 vy vz cB vy cv cF cfv cabs cfv cB cF cfv
      cabs cfv cn cG vy cv cB wceq vy cv cF cfv cB cF cfv cabs vy cv cB cF
      fveq2 fveq2d cvgratlem3ALT.2 cB cF cfv cabs fvex fvopab4 ax-mp opreq1i
      opreq1i 3brtr3g ex cB vx cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG
      cfv cmul co clt wbr wi cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv
      cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn vx cv cn wcel vx cv c1
      caddc co cG cfv cA vx cv cG cfv cmul co clt wbr vx cv c1 caddc co cF cfv
      cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr cB vx cv cle wbr vx cv
      cn wcel vx cv c1 caddc co cG cfv vx cv c1 caddc co cF cfv cabs cfv cA vx
      cv cG cfv cmul co cA vx cv cF cfv cabs cfv cmul co clt vx cv cn wcel vx
      cv c1 caddc co cn wcel vx cv c1 caddc co cG cfv vx cv c1 caddc co cF cfv
      cabs cfv wceq vx cv peano2nn vy vz vx cv c1 caddc co vy cv cF cfv cabs
      cfv vx cv c1 caddc co cF cfv cabs cfv cn cG vy cv vx cv c1 caddc co wceq
      vy cv cF cfv vx cv c1 caddc co cF cfv cabs vy cv vx cv c1 caddc co cF
      fveq2 fveq2d cvgratlem3ALT.2 vx cv c1 caddc co cF cfv cabs fvex fvopab4
      syl vx cv cn wcel vx cv cG cfv vx cv cF cfv cabs cfv cA cmul vy vz vx cv
      vy cv cF cfv cabs cfv vx cv cF cfv cabs cfv cn cG vy cv vx cv wceq vy cv
      cF cfv vx cv cF cfv cabs vy cv vx cv cF fveq2 fveq2d cvgratlem3ALT.2 vx
      cv cF cfv cabs fvex fvopab4 opreq2d breq12d imbi2d ralbiia sylan2br $.
      $( [17-Aug-2005] $) $( [28-May-2005] $)
  $}

  ${
    $d x y z $.  $d x y z A $.  $d x y z B $.  $d y C $.  $d x y z F $.
    cvgratlem1.1 $e |- F : NN --> RR $.
    $( Lemma for ~ cvgrati .  Establish, by induction, an exponential upper
       bound for the terms of a real series, given that the ratio of successive
       terms is less than some positive constant ` A ` beyond a starting index
       ` B ` . $)
    cvgratlem1 $p |- ( ( C e. NN /\ ( ( A e. RR /\ 0 < A ) /\ ( B e. NN /\
       A. x e. NN ( B <_ x -> ( F ` ( x + 1 ) ) < ( A x. ( F ` x ) ) ) ) ) ) ->
                     ( F ` ( B + C ) ) <_ ( ( A ^ C ) x. ( F ` B ) ) ) $=
      cC cn wcel cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv
      c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa wa
      cB cC caddc co cF cfv cA cC cexp co cB cF cfv cmul co clt wbr cB cC caddc
      co cF cfv cA cC cexp co cB cF cfv cmul co cle wbr cC cn wcel cA cr wcel
      cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA
      vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa cB cC caddc co cF cfv cA
      cC cexp co cB cF cfv cmul co clt wbr cA cr wcel cc0 cA clt wbr wa cB cn
      wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co
      clt wbr wi vx cn wral wa wa cB vy cv caddc co cF cfv cA vy cv cexp co cB
      cF cfv cmul co clt wbr wi cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx
      cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx
      cn wral wa wa cB c1 caddc co cF cfv cA c1 cexp co cB cF cfv cmul co clt
      wbr wi cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa cB vz
      cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr wi cA cr
      wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF
      cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa cB vz cv c1 caddc
      co caddc co cF cfv cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr
      wi cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa cB cC
      caddc co cF cfv cA cC cexp co cB cF cfv cmul co clt wbr wi vy vz cC vy cv
      c1 wceq cB vy cv caddc co cF cfv cA vy cv cexp co cB cF cfv cmul co clt
      wbr cB c1 caddc co cF cfv cA c1 cexp co cB cF cfv cmul co clt wbr cA cr
      wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF
      cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa vy cv c1 wceq cB
      vy cv caddc co cF cfv cB c1 caddc co cF cfv cA vy cv cexp co cB cF cfv
      cmul co cA c1 cexp co cB cF cfv cmul co clt vy cv c1 wceq cB vy cv caddc
      co cB c1 caddc co cF vy cv c1 cB caddc opreq2 fveq2d vy cv c1 wceq cA vy
      cv cexp co cA c1 cexp co cB cF cfv cmul vy cv c1 cA cexp opreq2 opreq1d
      breq12d imbi2d vy cv vz cv wceq cB vy cv caddc co cF cfv cA vy cv cexp co
      cB cF cfv cmul co clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral wa wa vy cv vz cv wceq cB vy cv caddc co cF cfv cB vz cv caddc co cF
      cfv cA vy cv cexp co cB cF cfv cmul co cA vz cv cexp co cB cF cfv cmul co
      clt vy cv vz cv wceq cB vy cv caddc co cB vz cv caddc co cF vy cv vz cv
      cB caddc opreq2 fveq2d vy cv vz cv wceq cA vy cv cexp co cA vz cv cexp co
      cB cF cfv cmul vy cv vz cv cA cexp opreq2 opreq1d breq12d imbi2d vy cv vz
      cv c1 caddc co wceq cB vy cv caddc co cF cfv cA vy cv cexp co cB cF cfv
      cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv cA vz cv c1 caddc co
      cexp co cB cF cfv cmul co clt wbr cA cr wcel cc0 cA clt wbr wa cB cn wcel
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr
      wi vx cn wral wa wa vy cv vz cv c1 caddc co wceq cB vy cv caddc co cF cfv
      cB vz cv c1 caddc co caddc co cF cfv cA vy cv cexp co cB cF cfv cmul co
      cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt vy cv vz cv c1 caddc
      co wceq cB vy cv caddc co cB vz cv c1 caddc co caddc co cF vy cv vz cv c1
      caddc co cB caddc opreq2 fveq2d vy cv vz cv c1 caddc co wceq cA vy cv
      cexp co cA vz cv c1 caddc co cexp co cB cF cfv cmul vy cv vz cv c1 caddc
      co cA cexp opreq2 opreq1d breq12d imbi2d vy cv cC wceq cB vy cv caddc co
      cF cfv cA vy cv cexp co cB cF cfv cmul co clt wbr cB cC caddc co cF cfv
      cA cC cexp co cB cF cfv cmul co clt wbr cA cr wcel cc0 cA clt wbr wa cB
      cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co
      clt wbr wi vx cn wral wa wa vy cv cC wceq cB vy cv caddc co cF cfv cB cC
      caddc co cF cfv cA vy cv cexp co cB cF cfv cmul co cA cC cexp co cB cF
      cfv cmul co clt vy cv cC wceq cB vy cv caddc co cB cC caddc co cF vy cv
      cC cB caddc opreq2 fveq2d vy cv cC wceq cA vy cv cexp co cA cC cexp co cB
      cF cfv cmul vy cv cC cA cexp opreq2 opreq1d breq12d imbi2d cA cr wcel cc0
      cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx
      cv cF cfv cmul co clt wbr wi vx cn wral wa wa cB c1 caddc co cF cfv cA cB
      cF cfv cmul co cA c1 cexp co cB cF cfv cmul co clt cB cn wcel cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral wa cB c1 caddc co cF cfv cA cB cF cfv cmul co clt wbr cA cr wcel cc0
      cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx
      cv cF cfv cmul co clt wbr wi vx cn wral cB c1 caddc co cF cfv cA cB cF
      cfv cmul co clt wbr cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv
      cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB cB cle wbr cB c1 caddc
      co cF cfv cA cB cF cfv cmul co clt wbr cB cn wcel cB cr wcel cB cB cle
      wbr cB nnre cB leid syl cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx
      cv cF cfv cmul co clt wbr wi cB cB cle wbr cB c1 caddc co cF cfv cA cB cF
      cfv cmul co clt wbr wi vx cB cn vx cv cB wceq cB vx cv cle wbr cB cB cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr cB c1 caddc
      co cF cfv cA cB cF cfv cmul co clt wbr vx cv cB cB cle breq2 vx cv cB
      wceq vx cv c1 caddc co cF cfv cB c1 caddc co cF cfv cA vx cv cF cfv cmul
      co cA cB cF cfv cmul co clt vx cv cB wceq vx cv c1 caddc co cB c1 caddc
      co cF vx cv cB c1 caddc opreq1 fveq2d vx cv cB wceq vx cv cF cfv cB cF
      cfv cA cmul vx cv cB cF fveq2 opreq2d breq12d imbi12d rcla4v mpid imp
      adantl cA cr wcel cc0 cA clt wbr wa cA c1 cexp co cB cF cfv cmul co cA cB
      cF cfv cmul co wceq cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv
      cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa cA cr wcel cc0 cA clt
      wbr wa cA c1 cexp co cA cB cF cfv cmul cA cr wcel cA c1 cexp co cA wceq
      cc0 cA clt wbr cA cr wcel cA cc wcel cA c1 cexp co cA wceq cA recn cA
      exp1 syl adantr opreq1d adantr breqtrrd vz cv cn wcel cA cr wcel cc0 cA
      clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv
      cF cfv cmul co clt wbr wi vx cn wral wa wa cB vz cv caddc co cF cfv cA vz
      cv cexp co cB cF cfv cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv
      cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr vz cv cn wcel cA
      cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co
      cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa cB vz cv caddc
      co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cB vz cv c1 caddc co
      caddc co cF cfv cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr wi
      vz cv cn wcel cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx
      cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa
      wa cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cB
      vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul co
      cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv cA vz cv c1 caddc co
      cexp co cB cF cfv cmul co clt wbr vz cv cn wcel cA cr wcel cc0 cA clt wbr
      cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul
      co clt wbr wi vx cn wral wa cB vz cv caddc co cF cfv cA vz cv cexp co cB
      cF cfv cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv
      cexp co cB cF cfv cmul co cmul co clt wbr wi vz cv cn wcel cA cr wcel cB
      cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co
      clt wbr wi vx cn wral wa cc0 cA clt wbr cB vz cv caddc co cF cfv cA vz cv
      cexp co cB cF cfv cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv cA
      cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr wi cA cr wcel vz cv cn
      wcel cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv
      cmul co clt wbr wi vx cn wral wa cc0 cA clt wbr cB vz cv caddc co cF cfv
      cA vz cv cexp co cB cF cfv cmul co clt wbr cB vz cv caddc co c1 caddc co
      cF cfv cA cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr wi wi wi cA
      cr wcel vz cv cn wcel cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF
      cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cc0 cA clt wbr cB vz cv
      caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cB vz cv caddc
      co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul co cmul co clt
      wbr wi wi cA cr wcel vz cv cn wcel cB cn wcel cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cc0 cA clt
      wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr
      cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul
      co cmul co clt wbr wi wi wi cA cr wcel vz cv cn wcel wa cB cn wcel wa cB
      vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi
      vx cn wral cc0 cA clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp
      co cB cF cfv cmul co cmul co clt wbr cA cr wcel vz cv cn wcel wa cB cn
      wcel wa cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc co cF cfv
      cmul co clt wbr cA cB vz cv caddc co cF cfv cmul co cA cA vz cv cexp co
      cB cF cfv cmul co cmul co clt wbr cB vz cv caddc co c1 caddc co cF cfv cA
      cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr cB vx cv cle wbr vx cv
      c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cc0 cA
      clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt
      wbr wa cB vz cv caddc co c1 caddc co cF cfv cr wcel cA cB vz cv caddc co
      cF cfv cmul co cr wcel cA cA vz cv cexp co cB cF cfv cmul co cmul co cr
      wcel cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc co cF cfv
      cmul co clt wbr cA cB vz cv caddc co cF cfv cmul co cA cA vz cv cexp co
      cB cF cfv cmul co cmul co clt wbr wa cB vz cv caddc co c1 caddc co cF cfv
      cA cA vz cv cexp co cB cF cfv cmul co cmul co clt wbr wi cA cr wcel vz cv
      cn wcel wa cB cn wcel wa cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv
      caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co
      axlttrn vz cv cn wcel cB cn wcel cB vz cv caddc co c1 caddc co cF cfv cr
      wcel cA cr wcel vz cv cn wcel cB cn wcel wa cB vz cv caddc co c1 caddc co
      cn wcel cB vz cv caddc co c1 caddc co cF cfv cr wcel vz cv cn wcel cB cn
      wcel wa cB vz cv caddc co cn wcel cB vz cv caddc co c1 caddc co cn wcel
      cB cn wcel vz cv cn wcel cB vz cv caddc co cn wcel cB vz cv nnaddcl
      ancoms cB vz cv caddc co peano2nn syl cn cr cB vz cv caddc co c1 caddc co
      cF cvgratlem1.1 ffvelrni syl adantll cA cr wcel vz cv cn wcel cB cn wcel
      cA cB vz cv caddc co cF cfv cmul co cr wcel cA cr wcel cB vz cv caddc co
      cF cfv cr wcel cA cB vz cv caddc co cF cfv cmul co cr wcel vz cv cn wcel
      cB cn wcel wa cA cB vz cv caddc co cF cfv remulcl vz cv cn wcel cB cn
      wcel wa cB vz cv caddc co cn wcel cB vz cv caddc co cF cfv cr wcel cB cn
      wcel vz cv cn wcel cB vz cv caddc co cn wcel cB vz cv nnaddcl ancoms cn
      cr cB vz cv caddc co cF cvgratlem1.1 ffvelrni syl sylan2 anassrs cA cr
      wcel cA vz cv cexp co cB cF cfv cmul co cr wcel cA cA vz cv cexp co cB cF
      cfv cmul co cmul co cr wcel cA cr wcel vz cv cn wcel wa cB cn wcel wa cA
      cA vz cv cexp co cB cF cfv cmul co remulcl cA cr wcel vz cv cn wcel cB cn
      wcel simpll cA vz cv cexp co cr wcel cB cF cfv cr wcel cA vz cv cexp co
      cB cF cfv cmul co cr wcel cA cr wcel vz cv cn wcel wa cB cn wcel cA vz cv
      cexp co cB cF cfv remulcl cA cr wcel vz cv cn0 wcel cA vz cv cexp co cr
      wcel vz cv cn wcel cA vz cv reexpcl vz cv nnnn0 sylan2 cn cr cB cF
      cvgratlem1.1 ffvelrni syl2an sylanc syl3anc vz cv cn wcel cB cn wcel cB
      vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi
      vx cn wral cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc co cF
      cfv cmul co clt wbr wi cA cr wcel cB cn wcel vz cv cn wcel cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc co cF cfv
      cmul co clt wbr wi cB cn wcel vz cv cn wcel wa cB vx cv cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB cB vz cv
      caddc co cle wbr cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv caddc
      co cF cfv cmul co clt wbr cB cr wcel vz cv cn0 wcel cB cB vz cv caddc co
      cle wbr cB cn wcel vz cv cn wcel cB vz cv nn0addge1 cB nnre vz cv nnnn0
      syl2an cB cn wcel vz cv cn wcel wa cB vz cv caddc co cn wcel cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral cB cB vz cv caddc co cle wbr cB vz cv caddc co c1 caddc co cF cfv cA
      cB vz cv caddc co cF cfv cmul co clt wbr wi wi cB vz cv nnaddcl cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi cB cB
      vz cv caddc co cle wbr cB vz cv caddc co c1 caddc co cF cfv cA cB vz cv
      caddc co cF cfv cmul co clt wbr wi vx cB vz cv caddc co cn vx cv cB vz cv
      caddc co wceq cB vx cv cle wbr cB cB vz cv caddc co cle wbr vx cv c1
      caddc co cF cfv cA vx cv cF cfv cmul co clt wbr cB vz cv caddc co c1
      caddc co cF cfv cA cB vz cv caddc co cF cfv cmul co clt wbr vx cv cB vz
      cv caddc co cB cle breq2 vx cv cB vz cv caddc co wceq vx cv c1 caddc co
      cF cfv cB vz cv caddc co c1 caddc co cF cfv cA vx cv cF cfv cmul co cA cB
      vz cv caddc co cF cfv cmul co clt vx cv cB vz cv caddc co wceq vx cv c1
      caddc co cB vz cv caddc co c1 caddc co cF vx cv cB vz cv caddc co c1
      caddc opreq1 fveq2d vx cv cB vz cv caddc co wceq vx cv cF cfv cB vz cv
      caddc co cF cfv cA cmul vx cv cB vz cv caddc co cF fveq2 opreq2d breq12d
      imbi12d rcla4v syl mpid ancoms adantll cA cr wcel vz cv cn wcel wa cB cn
      wcel wa cc0 cA clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF
      cfv cmul co clt wbr cA cB vz cv caddc co cF cfv cmul co cA cA vz cv cexp
      co cB cF cfv cmul co cmul co clt wbr cB vz cv caddc co cF cfv cr wcel cA
      vz cv cexp co cB cF cfv cmul co cr wcel cA cr wcel cc0 cA clt wbr cB vz
      cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cA cB vz cv
      caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co clt
      wbr wi wi cA cr wcel vz cv cn wcel wa cB cn wcel wa cB vz cv caddc co cF
      cfv cr wcel cA vz cv cexp co cB cF cfv cmul co cr wcel cA cr wcel w3a cc0
      cA clt wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co
      clt wbr cA cB vz cv caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv
      cmul co cmul co clt wbr wi cB vz cv caddc co cF cfv cr wcel cA vz cv cexp
      co cB cF cfv cmul co cr wcel cA cr wcel w3a cc0 cA clt wbr wa cB vz cv
      caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co clt wbr cA cB vz cv
      caddc co cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co clt
      wbr cB vz cv caddc co cF cfv cA vz cv cexp co cB cF cfv cmul co cA
      ltmul2OLD biimpd ex cA cr wcel vz cv cn wcel wa cB cn wcel wa cB vz cv
      caddc co cn wcel cB vz cv caddc co cF cfv cr wcel vz cv cn wcel cB cn
      wcel cB vz cv caddc co cn wcel cA cr wcel cB cn wcel vz cv cn wcel cB vz
      cv caddc co cn wcel cB vz cv nnaddcl ancoms adantll cn cr cB vz cv caddc
      co cF cvgratlem1.1 ffvelrni syl cA vz cv cexp co cr wcel cB cF cfv cr
      wcel cA vz cv cexp co cB cF cfv cmul co cr wcel cA cr wcel vz cv cn wcel
      wa cB cn wcel cA vz cv cexp co cB cF cfv remulcl cA cr wcel vz cv cn0
      wcel cA vz cv cexp co cr wcel vz cv cn wcel cA vz cv reexpcl vz cv nnnn0
      sylan2 cn cr cB cF cvgratlem1.1 ffvelrni syl2an cA cr wcel vz cv cn wcel
      cB cn wcel simpll syl3anc imp3a syl2and exp4d exp31 imp4a com12 com34
      imp44 vz cv cn wcel cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vz cv
      caddc co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv cmul co cmul co
      clt wbr cB vz cv c1 caddc co caddc co cF cfv cA vz cv c1 caddc co cexp co
      cB cF cfv cmul co clt wbr wb cB vx cv cle wbr vx cv c1 caddc co cF cfv cA
      vx cv cF cfv cmul co clt wbr wi vx cn wral vz cv cn wcel cA cr wcel cB cn
      wcel cB vz cv caddc co c1 caddc co cF cfv cA cA vz cv cexp co cB cF cfv
      cmul co cmul co clt wbr cB vz cv c1 caddc co caddc co cF cfv cA vz cv c1
      caddc co cexp co cB cF cfv cmul co clt wbr wb cc0 cA clt wbr cA cr wcel
      cB cn wcel wa vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cA cA vz
      cv cexp co cB cF cfv cmul co cmul co clt wbr cB vz cv c1 caddc co caddc
      co cF cfv cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr wb cA cc
      wcel cB cn wcel vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cA cA
      vz cv cexp co cB cF cfv cmul co cmul co clt wbr cB vz cv c1 caddc co
      caddc co cF cfv cA vz cv c1 caddc co cexp co cB cF cfv cmul co clt wbr wb
      cA cr wcel cA cc wcel cB cn wcel wa vz cv cn wcel wa cB vz cv caddc co c1
      caddc co cF cfv cB vz cv c1 caddc co caddc co cF cfv cA cA vz cv cexp co
      cB cF cfv cmul co cmul co cA vz cv c1 caddc co cexp co cB cF cfv cmul co
      clt cB cn wcel vz cv cn wcel cB vz cv caddc co c1 caddc co cF cfv cB vz
      cv c1 caddc co caddc co cF cfv wceq cA cc wcel cB cn wcel vz cv cn wcel
      wa cB vz cv caddc co c1 caddc co cB vz cv c1 caddc co caddc co cF cB cc
      wcel vz cv cc wcel cB vz cv caddc co c1 caddc co cB vz cv c1 caddc co
      caddc co wceq cB cn wcel vz cv cn wcel cB cc wcel vz cv cc wcel c1 cc
      wcel cB vz cv caddc co c1 caddc co cB vz cv c1 caddc co caddc co wceq
      ax1cn cB vz cv c1 addass mp3an3 cB nncn vz cv nncn syl2an fveq2d adantll
      cA cc wcel cB cn wcel wa vz cv cn wcel wa cA vz cv c1 caddc co cexp co cB
      cF cfv cmul co cA cA vz cv cexp co cmul co cB cF cfv cmul co cA cA vz cv
      cexp co cB cF cfv cmul co cmul co cA cc wcel cB cn wcel wa vz cv cn wcel
      wa cA vz cv c1 caddc co cexp co cA cA vz cv cexp co cmul co cB cF cfv
      cmul cA cc wcel vz cv cn wcel cA vz cv c1 caddc co cexp co cA cA vz cv
      cexp co cmul co wceq cB cn wcel cA cc wcel vz cv cn wcel wa cA vz cv c1
      caddc co cexp co cA vz cv cexp co cA cmul co cA cA vz cv cexp co cmul co
      cA cc wcel vz cv cn0 wcel cA vz cv c1 caddc co cexp co cA vz cv cexp co
      cA cmul co wceq vz cv cn wcel cA vz cv expp1 vz cv nnnn0 sylan2 cA vz cv
      cexp co cc wcel cA cc wcel cA vz cv cexp co cA cmul co cA cA vz cv cexp
      co cmul co wceq cA cc wcel vz cv cn wcel wa cA vz cv cexp co cA mulcom cA
      cc wcel vz cv cn0 wcel cA vz cv cexp co cc wcel vz cv cn wcel cA vz cv
      expcl vz cv nnnn0 sylan2 cA cc wcel vz cv cn wcel pm3.26 sylanc eqtrd
      adantlr opreq1d cA cc wcel vz cv cn wcel cB cn wcel cA cA vz cv cexp co
      cmul co cB cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co
      wceq cA cc wcel cA vz cv cexp co cc wcel wa cB cF cfv cc wcel cA cA vz cv
      cexp co cmul co cB cF cfv cmul co cA cA vz cv cexp co cB cF cfv cmul co
      cmul co wceq cA cc wcel vz cv cn wcel wa cB cn wcel cA cc wcel cA vz cv
      cexp co cc wcel cB cF cfv cc wcel cA cA vz cv cexp co cmul co cB cF cfv
      cmul co cA cA vz cv cexp co cB cF cfv cmul co cmul co wceq cA cA vz cv
      cexp co cB cF cfv mulass 3expa cA cc wcel vz cv cn wcel wa cA cc wcel cA
      vz cv cexp co cc wcel cA cc wcel vz cv cn wcel pm3.26 cA cc wcel vz cv
      cn0 wcel cA vz cv cexp co cc wcel vz cv cn wcel cA vz cv expcl vz cv
      nnnn0 sylan2 jca cB cn wcel cB cF cfv cn cr cB cF cvgratlem1.1 ffvelrni
      recnd syl2an an1rs eqtr2d breq12d cA recn sylanl1 ancoms adantrlr
      adantrrr sylibd ex a2d nnind imp cC cn wcel cA cr wcel cc0 cA clt wbr wa
      cB cn wcel cB cC caddc co cF cfv cA cC cexp co cB cF cfv cmul co clt wbr
      cB cC caddc co cF cfv cA cC cexp co cB cF cfv cmul co cle wbr wi cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral cC cn wcel cA cr wcel cB cn wcel cB cC caddc co cF cfv cA cC cexp co
      cB cF cfv cmul co clt wbr cB cC caddc co cF cfv cA cC cexp co cB cF cfv
      cmul co cle wbr wi cc0 cA clt wbr cB cC caddc co cF cfv cr wcel cA cC
      cexp co cB cF cfv cmul co cr wcel cB cC caddc co cF cfv cA cC cexp co cB
      cF cfv cmul co clt wbr cB cC caddc co cF cfv cA cC cexp co cB cF cfv cmul
      co cle wbr wi cC cn wcel cA cr wcel cB cn wcel wa wa cB cC caddc co cF
      cfv cA cC cexp co cB cF cfv cmul co ltle cC cn wcel cB cn wcel cB cC
      caddc co cF cfv cr wcel cA cr wcel cC cn wcel cB cn wcel wa cB cC caddc
      co cn wcel cB cC caddc co cF cfv cr wcel cB cn wcel cC cn wcel cB cC
      caddc co cn wcel cB cC nnaddcl ancoms cn cr cB cC caddc co cF
      cvgratlem1.1 ffvelrni syl adantrl cC cn wcel cA cr wcel cB cn wcel cA cC
      cexp co cB cF cfv cmul co cr wcel cA cC cexp co cr wcel cB cF cfv cr wcel
      cA cC cexp co cB cF cfv cmul co cr wcel cC cn wcel cA cr wcel wa cB cn
      wcel cA cC cexp co cB cF cfv remulcl cA cr wcel cC cn wcel cA cC cexp co
      cr wcel cA cr wcel cC cn0 wcel cA cC cexp co cr wcel cC cn wcel cA cC
      reexpcl cC nnnn0 sylan2 ancoms cn cr cB cF cvgratlem1.1 ffvelrni syl2an
      anasss sylanc adantrlr adantrrr mpd $.
      $( [28-Jul-2006] $) $( [26-Apr-2005] $)

    $( Lemma for ~ cvgrati .  Using ~ expsubOLD , restate ~ cvgratlem1
       with an
       absolute index ` C ` instead of just an offset from the starting index
       ` B ` . $)
    cvgratlem2 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. NN /\
         A. x e. NN ( B <_ x -> ( F ` ( x + 1 ) ) < ( A x. ( F ` x ) ) ) ) ) ->
                     ( ( C e. NN /\ B < C ) ->
                 ( F ` C ) <_ ( ( ( F ` B ) / ( A ^ B ) ) x. ( A ^ C ) ) ) ) $=
      cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc
      co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa wa cC cn wcel
      cB cC clt wbr wa cC cF cfv cB cF cfv cA cB cexp co cdiv co cA cC cexp co
      cmul co cle wbr cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr
      vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa
      wa cC cn wcel cB cC clt wbr wa wa cC cF cfv cA cC cB cmin co cexp co cB
      cF cfv cmul co cB cF cfv cA cB cexp co cdiv co cA cC cexp co cmul co cle
      cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc
      co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cC cn wcel cB cC
      clt wbr wa cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle wbr
      cB cn wcel cA cr wcel cc0 cA clt wbr wa cB vx cv cle wbr vx cv c1 caddc
      co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cC cn wcel cB cC
      clt wbr wa cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle wbr
      wi wi cC cn wcel cB cC clt wbr wa cB cn wcel cA cr wcel cc0 cA clt wbr wa
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr
      wi vx cn wral cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle
      wbr cB cn wcel cC cn wcel cB cC clt wbr wa cA cr wcel cc0 cA clt wbr wa
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr
      wi vx cn wral cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle
      wbr wi wi cB cn wcel cC cn wcel cB cC clt wbr wa cA cr wcel cc0 cA clt
      wbr wa cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co
      clt wbr wi vx cn wral cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul
      co cle wbr cB cn wcel cC cn wcel cB cC clt wbr cA cr wcel cc0 cA clt wbr
      wa cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt
      wbr wi vx cn wral wa cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co
      cle wbr wi cB cn wcel cC cn wcel wa cB cC clt wbr cC cB cmin co cn wcel
      cA cr wcel cc0 cA clt wbr wa cB vx cv cle wbr vx cv c1 caddc co cF cfv cA
      vx cv cF cfv cmul co clt wbr wi vx cn wral wa cC cF cfv cA cC cB cmin co
      cexp co cB cF cfv cmul co cle wbr wi cB cC nnsub cB cn wcel cC cn wcel wa
      cC cB cmin co cn wcel cA cr wcel cc0 cA clt wbr wa cB vx cv cle wbr vx cv
      c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral wa cC cF
      cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle wbr cB cn wcel cC cn
      wcel wa cC cB cmin co cn wcel cA cr wcel cc0 cA clt wbr wa cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral wa wa cB cC cB cmin co caddc co cF cfv cA cC cB cmin co cexp co cB
      cF cfv cmul co cle wbr cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul
      co cle wbr cB cn wcel cC cB cmin co cn wcel cA cr wcel cc0 cA clt wbr wa
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr
      wi vx cn wral wa wa cB cC cB cmin co caddc co cF cfv cA cC cB cmin co
      cexp co cB cF cfv cmul co cle wbr wi cC cn wcel cB cn wcel cC cB cmin co
      cn wcel cA cr wcel cc0 cA clt wbr wa cB vx cv cle wbr vx cv c1 caddc co
      cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB cC cB cmin co
      caddc co cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co cle wbr cC cB
      cmin co cn wcel cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr
      vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn wral cB
      cC cB cmin co caddc co cF cfv cA cC cB cmin co cexp co cB cF cfv cmul co
      cle wbr wi cC cB cmin co cn wcel cA cr wcel cc0 cA clt wbr wa cB cn wcel
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr
      wi vx cn wral cB cC cB cmin co caddc co cF cfv cA cC cB cmin co cexp co
      cB cF cfv cmul co cle wbr vx cA cB cC cB cmin co cF cvgratlem1.1
      cvgratlem1 exp45 com3r imp4d adantr cB cn wcel cC cn wcel wa cB cC cB
      cmin co caddc co cF cfv cC cF cfv cA cC cB cmin co cexp co cB cF cfv cmul
      co cle cB cn wcel cC cn wcel wa cB cC cB cmin co caddc co cC cF cB cc
      wcel cC cc wcel cB cC cB cmin co caddc co cC wceq cB cn wcel cC cn wcel
      cB cC pncan3 cB nncn cC nncn syl2an fveq2d breq1d sylibd exp3a sylbid
      expimpd exp4a com12 com4l com12 imp42 cA cr wcel cc0 cA clt wbr wa cB cn
      wcel cC cn wcel cB cC clt wbr wa cA cC cB cmin co cexp co cB cF cfv cmul
      co cB cF cfv cA cB cexp co cdiv co cA cC cexp co cmul co wceq cB vx cv
      cle wbr vx cv c1 caddc co cF cfv cA vx cv cF cfv cmul co clt wbr wi vx cn
      wral cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cC cn wcel cB cC clt wbr
      wa wa cA cC cB cmin co cexp co cB cF cfv cmul co cA cC cexp co cA cB cexp
      co cdiv co cB cF cfv cmul co cB cF cfv cA cB cexp co cdiv co cA cC cexp
      co cmul co cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cC cn wcel cB cC
      clt wbr wa wa cA cC cB cmin co cexp co cA cC cexp co cA cB cexp co cdiv
      co cB cF cfv cmul cA cc wcel cC cn wcel cB cn wcel w3a cA cc0 wne cB cC
      clt wbr wa cA cC cB cmin co cexp co cA cC cexp co cA cB cexp co cdiv co
      wceq cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cC cn wcel cB cC clt wbr
      wa wa cA cc wcel cA cc0 wne wa cC cn0 wcel cB cn0 wcel w3a cB cC cle wbr
      cA cC cB cmin co cexp co cA cC cexp co cA cB cexp co cdiv co wceq cA cc
      wcel cC cn wcel cB cn wcel w3a cA cc0 wne cB cC clt wbr wa wa cA cC cB
      expsub cA cc wcel cC cn wcel cB cn wcel w3a cA cc0 wne cA cc wcel cA cc0
      wne wa cC cn0 wcel cB cn0 wcel w3a cB cC clt wbr cA cc wcel cC cn wcel cB
      cn wcel w3a cA cc0 wne wa cA cc wcel cA cc0 wne wa cC cn0 wcel cB cn0
      wcel cA cc wcel cC cn wcel cA cc0 wne cA cc wcel cA cc0 wne wa cB cn wcel
      cA cc wcel cA cc0 wne wa id 3ad2antl1 cA cc wcel cC cn wcel cB cn wcel
      w3a cC cn0 wcel cA cc0 wne cC cn wcel cA cc wcel cC cn0 wcel cB cn wcel
      cC nnnn0 3ad2ant2 adantr cA cc wcel cC cn wcel cB cn wcel w3a cB cn0 wcel
      cA cc0 wne cB cn wcel cA cc wcel cB cn0 wcel cC cn wcel cB nnnn0 3ad2ant3
      adantr 3jca adantrr cA cc wcel cC cn wcel cB cn wcel w3a cB cC clt wbr cB
      cC cle wbr cA cc0 wne cC cn wcel cB cn wcel cB cC clt wbr cB cC cle wbr
      cA cc wcel cC cn wcel cB cn wcel wa cB cC clt wbr cB cC cle wbr cC cr
      wcel cB cr wcel cB cC clt wbr cB cC cle wbr wi cC cn wcel cB cn wcel cB
      cr wcel cC cr wcel cB cC clt wbr cB cC cle wbr wi cB cC ltle ancoms cC
      nnre cB nnre syl2an imp 3adantl1 adantrl sylanc cA cr wcel cc0 cA clt wbr
      wa cB cn wcel wa cC cn wcel cA cc wcel cC cn wcel cB cn wcel w3a cB cC
      clt wbr cA cr wcel cB cn wcel cC cn wcel cA cc wcel cC cn wcel cB cn wcel
      w3a cc0 cA clt wbr cA cr wcel cC cn wcel cB cn wcel cA cc wcel cC cn wcel
      cB cn wcel w3a cA cr wcel cC cn wcel cB cn wcel cA cc wcel cC cn wcel cB
      cn wcel w3a cA cr wcel cA cc wcel cC cn wcel cC cn wcel cB cn wcel cB cn
      wcel cA recn cC cn wcel id cB cn wcel id 3anim123i 3expa an1rs adantllr
      adantrr cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cA cc0 wne cC cn wcel
      cB cC clt wbr wa cB cC clt wbr cA cr wcel cc0 cA clt wbr wa cA cc0 wne cB
      cn wcel cA gt0ne0 adantr cC cn wcel cB cC clt wbr pm3.27 anim12i sylanc
      opreq1d cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cC cn wcel cB cF cfv
      cA cB cexp co cdiv co cA cC cexp co cmul co cA cC cexp co cA cB cexp co
      cdiv co cB cF cfv cmul co wceq cB cC clt wbr cB cF cfv cc wcel cA cB cexp
      co cc wcel cA cB cexp co cc0 wne wa cA cC cexp co cc wcel cB cF cfv cA cB
      cexp co cdiv co cA cC cexp co cmul co cA cC cexp co cA cB cexp co cdiv co
      cB cF cfv cmul co wceq cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cC cn
      wcel wa cB cF cfv cA cB cexp co cA cC cexp co div13 cB cn wcel cB cF cfv
      cc wcel cA cr wcel cc0 cA clt wbr wa cC cn wcel cB cn wcel cB cF cfv cn
      cr cB cF cvgratlem1.1 ffvelrni recnd ad2antlr cA cr wcel cc0 cA clt wbr
      wa cB cn wcel wa cC cn wcel wa cA cB cexp co cc wcel cA cB cexp co cc0
      wne cA cr wcel cc0 cA clt wbr wa cB cn wcel wa cA cB cexp co cc wcel cC
      cn wcel cA cr wcel cB cn wcel cA cB cexp co cc wcel cc0 cA clt wbr cA cr
      wcel cB cn wcel wa cA cB cexp co cA cr wcel cB cn0 wcel cA cB cexp co cr
      wcel cB cn wcel cA cB reexpcl cB nnnn0 sylan2 recnd adantlr adantr cA cr
      wcel cc0 cA clt wbr wa cB cn wcel wa cA cB cexp co cc0 wne cC cn wcel cA
      cB cexp co cr wcel cc0 cA cB cexp co clt wbr cA cB cexp co cc0 wne cA cr
      wcel cc0 cA clt wbr wa cB cn wcel wa cA cB cexp co gt0ne0 cA cr wcel cB
      cn wcel cA cB cexp co cr wcel cc0 cA clt wbr cA cr wcel cB cn0 wcel cA cB
      cexp co cr wcel cB cn wcel cA cB reexpcl cB nnnn0 sylan2 adantlr cA cr
      wcel cB cn wcel cc0 cA clt wbr cc0 cA cB cexp co clt wbr cA cr wcel cB cn
      wcel cc0 cA clt wbr cc0 cA cB cexp co clt wbr cA cr wcel cB cn0 wcel cc0
      cA clt wbr cc0 cA cB cexp co clt wbr cB cn wcel cA cB expgt0 cB nnnn0
      syl3an2 3expa an1rs sylanc adantr jca cA cr wcel cc0 cA clt wbr wa cC cn
      wcel cA cC cexp co cc wcel cB cn wcel cA cr wcel cC cn wcel cA cC cexp co
      cc wcel cc0 cA clt wbr cA cr wcel cC cn wcel wa cA cC cexp co cA cr wcel
      cC cn0 wcel cA cC cexp co cr wcel cC cn wcel cA cC reexpcl cC nnnn0
      sylan2 recnd adantlr adantlr syl3anc adantrr eqtr4d adantlrr breqtrd ex
      $.
      $( [28-Jul-2006] $) $( [22-Apr-2005] $)
  $}

  ${
    $d x A $.  $d x y z B $.  $d x y z F $.  $d y z C $.
    cvgratlem3.1 $e |- F : NN --> CC $.
    $d G x $.
    cvgratlem3.2 $e |- G =
                    { <. y , z >. | ( y e. NN /\ z = ( abs ` ( F ` y ) ) ) } $.
    $( Lemma for ~ cvgrati .  Restate ~ cvgratlem2 (which was for a real
       function) in terms of the absolute values of the terms of a complex
       function ` F ` , with the help of an auxiliary function ` G ` . $)
    cvgratlem3 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. NN /\
       A. x e. NN ( B <_ x ->
  ( abs ` ( F ` ( x + 1 ) ) ) < ( A x. ( abs ` ( F ` x ) ) ) ) ) ) ->
  ( ( C e. NN /\ B < C ) -> ( abs ` ( F ` C ) ) <_ ( ( ( abs ` ( F ` B ) )
                       / ( A ^ B ) ) x. ( A ^ C ) ) ) ) $=
      cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc
      co cG cfv cA vx cv cG cfv cmul co clt wbr wi vx cn wral wa cC cn wcel cB
      cC clt wbr wa cC cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv co
      cA cC cexp co cmul co cle wbr wi cB cn wcel cB vx cv cle wbr vx cv c1
      caddc co cF cfv cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx
      cn wral wa cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv
      c1 caddc co cG cfv cA vx cv cG cfv cmul co clt wbr wi vx cn wral wa wa cC
      cn wcel cB cC clt wbr wa cC cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp
      co cdiv co cA cC cexp co cmul co cle wbr cA cr wcel cc0 cA clt wbr wa cB
      cn wcel cB vx cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG cfv cmul co
      clt wbr wi vx cn wral wa wa cC cn wcel cB cC clt wbr wa wa cC cG cfv cB
      cG cfv cA cB cexp co cdiv co cA cC cexp co cmul co cC cF cfv cabs cfv cB
      cF cfv cabs cfv cA cB cexp co cdiv co cA cC cexp co cmul co cle cA cr
      wcel cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cG
      cfv cA vx cv cG cfv cmul co clt wbr wi vx cn wral wa wa cC cn wcel cB cC
      clt wbr wa cC cG cfv cB cG cfv cA cB cexp co cdiv co cA cC cexp co cmul
      co cle wbr vx cA cB cC cG vy vz cn cr vy cv cF cfv cabs cfv cG
      cvgratlem3.2 vy cv cn wcel vy cv cF cfv cc wcel vy cv cF cfv cabs cfv cr
      wcel cn cc vy cv cF cvgratlem3.1 ffvelrni vy cv cF cfv abscl syl fopab
      cvgratlem2 imp cC cn wcel cC cG cfv cC cF cfv cabs cfv wceq cA cr wcel
      cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cG cfv cA
      vx cv cG cfv cmul co clt wbr wi vx cn wral wa wa cB cC clt wbr vy vz cC
      vy cv cF cfv cabs cfv cC cF cfv cabs cfv cn cG vy cv cC wceq vy cv cF cfv
      cC cF cfv cabs vy cv cC cF fveq2 fveq2d cvgratlem3.2 cC cF cfv cabs fvex
      fvopab4 ad2antrl cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cG cfv cA
      vx cv cG cfv cmul co clt wbr wi vx cn wral wa cB cG cfv cA cB cexp co
      cdiv co cA cC cexp co cmul co cB cF cfv cabs cfv cA cB cexp co cdiv co cA
      cC cexp co cmul co wceq cA cr wcel cc0 cA clt wbr wa cC cn wcel cB cC clt
      wbr wa cB cn wcel cB cG cfv cA cB cexp co cdiv co cA cC cexp co cmul co
      cB cF cfv cabs cfv cA cB cexp co cdiv co cA cC cexp co cmul co wceq cB vx
      cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG cfv cmul co clt wbr wi vx
      cn wral cB cn wcel cB cG cfv cA cB cexp co cdiv co cB cF cfv cabs cfv cA
      cB cexp co cdiv co cA cC cexp co cmul cB cn wcel cB cG cfv cB cF cfv cabs
      cfv cA cB cexp co cdiv vy vz cB vy cv cF cfv cabs cfv cB cF cfv cabs cfv
      cn cG vy cv cB wceq vy cv cF cfv cB cF cfv cabs vy cv cB cF fveq2 fveq2d
      cvgratlem3.2 cB cF cfv cabs fvex fvopab4 opreq1d opreq1d adantr ad2antlr
      3brtr3d ex cB vx cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG cfv cmul
      co clt wbr wi vx cn wral cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs
      cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral cB cn wcel cB
      vx cv cle wbr vx cv c1 caddc co cG cfv cA vx cv cG cfv cmul co clt wbr wi
      cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv cabs
      cfv cmul co clt wbr wi vx cn vx cv cn wcel vx cv c1 caddc co cG cfv cA vx
      cv cG cfv cmul co clt wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF
      cfv cabs cfv cmul co clt wbr cB vx cv cle wbr vx cv cn wcel vx cv c1
      caddc co cG cfv vx cv c1 caddc co cF cfv cabs cfv cA vx cv cG cfv cmul co
      cA vx cv cF cfv cabs cfv cmul co clt vx cv cn wcel vx cv c1 caddc co cn
      wcel vx cv c1 caddc co cG cfv vx cv c1 caddc co cF cfv cabs cfv wceq vx
      cv peano2nn vy vz vx cv c1 caddc co vy cv cF cfv cabs cfv vx cv c1 caddc
      co cF cfv cabs cfv cn cG vy cv vx cv c1 caddc co wceq vy cv cF cfv vx cv
      c1 caddc co cF cfv cabs vy cv vx cv c1 caddc co cF fveq2 fveq2d
      cvgratlem3.2 vx cv c1 caddc co cF cfv cabs fvex fvopab4 syl vx cv cn wcel
      vx cv cG cfv vx cv cF cfv cabs cfv cA cmul vy vz vx cv vy cv cF cfv cabs
      cfv vx cv cF cfv cabs cfv cn cG vy cv vx cv wceq vy cv cF cfv vx cv cF
      cfv cabs vy cv vx cv cF fveq2 fveq2d cvgratlem3.2 vx cv cF cfv cabs fvex
      fvopab4 opreq2d breq12d imbi2d ralbiia anbi2i sylan2br $.
      $( [28-May-2005] $) $( [25-Apr-2005] $)
  $}

  ${
    $d x y z w v A $.  $d x y v u B $.  $d x y v u F $.  $d y v G $.
    cvgrat.1 $e |- F : NN --> CC $.
    $( Lemma for ~ cvgrati .  The ratio of successive terms meeting the ratio
       test criterion is positive. $)
    cvgratlem4 $p |- ( ( A e. RR /\ ( B e. NN /\ A. x e. NN ( B <_ x ->
 ( abs ` ( F ` ( x + 1 ) ) ) < ( A x. ( abs ` ( F ` x ) ) ) ) ) ) -> 0 < A ) $=
      cA cr wcel cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv
      cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral cc0 cA clt wbr cA
      cr wcel cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA
      vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral cc0 cA clt wbr wi cA
      cr wcel cB cn wcel wa cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv
      cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral cB c1 caddc co cF
      cfv cabs cfv cA cB cF cfv cabs cfv cmul co clt wbr cc0 cB cF cfv cabs cfv
      cle wbr cc0 cA cB cF cfv cabs cfv cmul co clt wbr wa cc0 cA clt wbr cB cn
      wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv
      cabs cfv cmul co clt wbr wi vx cn wral cB c1 caddc co cF cfv cabs cfv cA
      cB cF cfv cabs cfv cmul co clt wbr wi cA cr wcel cB cn wcel cB vx cv cle
      wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv cabs cfv cmul co
      clt wbr wi vx cn wral cB cB cle wbr cB c1 caddc co cF cfv cabs cfv cA cB
      cF cfv cabs cfv cmul co clt wbr cB cn wcel cB cr wcel cB cB cle wbr cB
      nnre cB leid syl cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx
      cv cF cfv cabs cfv cmul co clt wbr wi cB cB cle wbr cB c1 caddc co cF cfv
      cabs cfv cA cB cF cfv cabs cfv cmul co clt wbr wi vx cB cn vx cv cB wceq
      cB vx cv cle wbr cB cB cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv
      cF cfv cabs cfv cmul co clt wbr cB c1 caddc co cF cfv cabs cfv cA cB cF
      cfv cabs cfv cmul co clt wbr vx cv cB cB cle breq2 vx cv cB wceq vx cv c1
      caddc co cF cfv cabs cfv cB c1 caddc co cF cfv cabs cfv cA vx cv cF cfv
      cabs cfv cmul co cA cB cF cfv cabs cfv cmul co clt vx cv cB wceq vx cv c1
      caddc co cF cfv cB c1 caddc co cF cfv cabs vx cv cB wceq vx cv c1 caddc
      co cB c1 caddc co cF vx cv cB c1 caddc opreq1 fveq2d fveq2d vx cv cB wceq
      vx cv cF cfv cabs cfv cB cF cfv cabs cfv cA cmul vx cv cB wceq vx cv cF
      cfv cB cF cfv cabs vx cv cB cF fveq2 fveq2d opreq2d breq12d imbi12d
      rcla4v mpid adantl cA cr wcel cB cn wcel wa cB c1 caddc co cF cfv cabs
      cfv cA cB cF cfv cabs cfv cmul co clt wbr cc0 cA cB cF cfv cabs cfv cmul
      co clt wbr cc0 cB cF cfv cabs cfv cle wbr cA cr wcel cB cn wcel wa cc0 cB
      c1 caddc co cF cfv cabs cfv cle wbr cB c1 caddc co cF cfv cabs cfv cA cB
      cF cfv cabs cfv cmul co clt wbr cc0 cA cB cF cfv cabs cfv cmul co clt wbr
      cB cn wcel cc0 cB c1 caddc co cF cfv cabs cfv cle wbr cA cr wcel cB cn
      wcel cB c1 caddc co cn wcel cB c1 caddc co cF cfv cc wcel cc0 cB c1 caddc
      co cF cfv cabs cfv cle wbr cB peano2nn cn cc cB c1 caddc co cF cvgrat.1
      ffvelrni cB c1 caddc co cF cfv absge0 3syl adantl cB c1 caddc co cF cfv
      cabs cfv cr wcel cA cB cF cfv cabs cfv cmul co cr wcel cc0 cB c1 caddc co
      cF cfv cabs cfv cle wbr cB c1 caddc co cF cfv cabs cfv cA cB cF cfv cabs
      cfv cmul co clt wbr wa cc0 cA cB cF cfv cabs cfv cmul co clt wbr wi cA cr
      wcel cB cn wcel wa cc0 cr wcel cB c1 caddc co cF cfv cabs cfv cr wcel cA
      cB cF cfv cabs cfv cmul co cr wcel cc0 cB c1 caddc co cF cfv cabs cfv cle
      wbr cB c1 caddc co cF cfv cabs cfv cA cB cF cfv cabs cfv cmul co clt wbr
      wa cc0 cA cB cF cfv cabs cfv cmul co clt wbr wi 0re cc0 cB c1 caddc co cF
      cfv cabs cfv cA cB cF cfv cabs cfv cmul co lelttr mp3an1 cB cn wcel cB c1
      caddc co cF cfv cabs cfv cr wcel cA cr wcel cB cn wcel cB c1 caddc co cn
      wcel cB c1 caddc co cF cfv cc wcel cB c1 caddc co cF cfv cabs cfv cr wcel
      cB peano2nn cn cc cB c1 caddc co cF cvgrat.1 ffvelrni cB c1 caddc co cF
      cfv abscl 3syl adantl cA cr wcel cB cF cfv cabs cfv cr wcel cA cB cF cfv
      cabs cfv cmul co cr wcel cB cn wcel cA cB cF cfv cabs cfv remulcl cB cn
      wcel cB cF cfv cc wcel cB cF cfv cabs cfv cr wcel cn cc cB cF cvgrat.1
      ffvelrni cB cF cfv abscl syl sylan2 sylanc mpand cB cn wcel cc0 cB cF cfv
      cabs cfv cle wbr cA cr wcel cB cn wcel cB cF cfv cc wcel cc0 cB cF cfv
      cabs cfv cle wbr cn cc cB cF cvgrat.1 ffvelrni cB cF cfv absge0 syl
      adantl jctild cA cr wcel cB cF cfv cabs cfv cr wcel cc0 cB cF cfv cabs
      cfv cle wbr cc0 cA cB cF cfv cabs cfv cmul co clt wbr wa cc0 cA clt wbr
      wi cB cn wcel cA cr wcel cB cF cfv cabs cfv cr wcel wa cc0 cB cF cfv cabs
      cfv cle wbr cc0 cA cB cF cfv cabs cfv cmul co clt wbr wa cc0 cA clt wbr
      cA cB cF cfv cabs cfv prodgt02 ex cB cn wcel cB cF cfv cc wcel cB cF cfv
      cabs cfv cr wcel cn cc cB cF cvgrat.1 ffvelrni cB cF cfv abscl syl sylan2
      3syld ex imp32 $.
      $( [28-May-2005] $) $( [25-Apr-2005] $)

    ${
      cvgratlem5.2 $e |- G = { <. z , w >. | ( z e. NN /\ w = ( A ^ z ) ) } $.
      $( Lemma for ~ cvgrati .  A complex infinite series ` F ` meeting the
         ratio test criterion converges.  We show that the partial sums of
         ` F ` are smaller than the partial sums of a geometric series (which
         converges by ~ geolimi ), so by the comparison test
         ~ cvgcmp3ce , ` F ` also converges. $)
      cvgratlem5 $p |- ( ( ( A e. RR /\ A < 1 ) /\ ( B e. NN /\
           A. x e. NN ( B <_ x ->
  ( abs ` ( F ` ( x + 1 ) ) ) < ( A x. ( abs ` ( F ` x ) ) ) ) ) ) ->
                    E. y ( + seq1 F ) ~~> y ) $=
        cB cn wcel cn cr cG wf cc0 vv cv cG cfv cle wbr vv cn wral wa caddc cG
        cseq1 co cA c1 cA cmin co cdiv co cli wbr wa cB cF cfv cabs cfv cA cB
        cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB cexp co cdiv co
        cle wbr wa cn cc cF wf cB vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv
        cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul co cle wbr wi vv cn
        wral wa wa wa caddc cF cseq1 co vy cv cli wbr vy wex cA cr wcel cA c1
        clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs
        cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa vv vy
        cA c1 cA cmin co cdiv co cB cB cF cfv cabs cfv cA cB cexp co cdiv co cG
        cF cA c1 cA cmin co cdiv oprex cvgcmp3ce cA cr wcel cA c1 clt wbr wa cB
        cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF
        cfv cabs cfv cmul co clt wbr wi vx cn wral simprl cA cr wcel cA c1 clt
        wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA
        vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa cc0 cA clt
        wbr cn cr cG wf cc0 vv cv cG cfv cle wbr vv cn wral wa caddc cG cseq1
        co cA c1 cA cmin co cdiv co cli wbr wa cB cF cfv cabs cfv cA cB cexp co
        cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB cexp co cdiv co cle wbr wa
        cn cc cF wf cB vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv cabs cfv
        cA cB cexp co cdiv co vv cv cG cfv cmul co cle wbr wi vv cn wral wa wa
        wa cA cr wcel cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs
        cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa cc0 cA
        clt wbr cA c1 clt wbr vx cA cB cF cvgrat.1 cvgratlem4 adantlr cA cr
        wcel cA c1 clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF
        cfv cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa
        cc0 cA clt wbr cn cr cG wf cc0 vv cv cG cfv cle wbr vv cn wral wa caddc
        cG cseq1 co cA c1 cA cmin co cdiv co cli wbr wa cB cF cfv cabs cfv cA
        cB cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB cexp co cdiv co
        cle wbr wa cn cc cF wf cB vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv
        cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul co cle wbr wi vv cn
        wral wa wa wa wi cA cr wcel cA c1 clt wbr wa cc0 cA clt wbr cB cn wcel
        cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv cabs
        cfv cmul co clt wbr wi vx cn wral wa cn cr cG wf cc0 vv cv cG cfv cle
        wbr vv cn wral wa caddc cG cseq1 co cA c1 cA cmin co cdiv co cli wbr wa
        cB cF cfv cabs cfv cA cB cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv
        cA cB cexp co cdiv co cle wbr wa cn cc cF wf cB vv cv clt wbr vv cv cF
        cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul
        co cle wbr wi vv cn wral wa wa wa cA cr wcel cA c1 clt wbr wa cc0 cA
        clt wbr cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv
        cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa cn cr cG wf
        cc0 vv cv cG cfv cle wbr vv cn wral wa caddc cG cseq1 co cA c1 cA cmin
        co cdiv co cli wbr wa cB cF cfv cabs cfv cA cB cexp co cdiv co cr wcel
        cc0 cB cF cfv cabs cfv cA cB cexp co cdiv co cle wbr wa cn cc cF wf cB
        vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co
        cdiv co vv cv cG cfv cmul co cle wbr wi vv cn wral wa wa wa cA cr wcel
        cA c1 clt wbr wa cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1
        caddc co cF cfv cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx
        cn wral wa wa cn cr cG wf cc0 vv cv cG cfv cle wbr vv cn wral wa caddc
        cG cseq1 co cA c1 cA cmin co cdiv co cli wbr wa cB cF cfv cabs cfv cA
        cB cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB cexp co cdiv co
        cle wbr wa cn cc cF wf cB vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv
        cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul co cle wbr wi vv cn
        wral wa wa cA cr wcel cA c1 clt wbr wa cc0 cA clt wbr wa cn cr cG wf
        cc0 vv cv cG cfv cle wbr vv cn wral wa caddc cG cseq1 co cA c1 cA cmin
        co cdiv co cli wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF
        cfv cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa
        cA cr wcel cA c1 clt wbr wa cc0 cA clt wbr cc0 cA cle wbr cn cr cG wf
        cc0 vv cv cG cfv cle wbr vv cn wral wa caddc cG cseq1 co cA c1 cA cmin
        co cdiv co cli wbr wa cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cA c1
        clt wbr cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cc0 cr wcel cA cr wcel
        cc0 cA clt wbr cc0 cA cle wbr wi 0re cc0 cA ltle mpan imp adantlr cA cr
        wcel cA c1 clt wbr wa cc0 cA cle wbr wa cn cr cG wf cc0 vv cv cG cfv
        cle wbr vv cn wral wa caddc cG cseq1 co cA c1 cA cmin co cdiv co cli
        wbr cA cr wcel cc0 cA cle wbr cn cr cG wf cc0 vv cv cG cfv cle wbr vv
        cn wral wa cA c1 clt wbr cA cr wcel cc0 cA cle wbr wa cn cr cG wf cc0
        vv cv cG cfv cle wbr vv cn wral cA cr wcel cn cr cG wf cc0 cA cle wbr
        cA cr wcel cA vz cv cexp co cr wcel vz cn wral cn cr cG wf cA cr wcel
        cA vz cv cexp co cr wcel vz cn cA cr wcel vz cv cn0 wcel cA vz cv cexp
        co cr wcel vz cv cn wcel cA vz cv reexpcl vz cv nnnn0 sylan2 r19.21aiva
        vz vw cn cr cA vz cv cexp co cG cvgratlem5.2 fopab2 sylib adantr cA cr
        wcel cc0 cA cle wbr wa cc0 vv cv cG cfv cle wbr vv cn cA cr wcel cc0 cA
        cle wbr wa vv cv cn wcel wa cc0 cA vv cv cexp co vv cv cG cfv cle cA cr
        wcel vv cv cn wcel cc0 cA cle wbr cc0 cA vv cv cexp co cle wbr cA cr
        wcel vv cv cn wcel cc0 cA cle wbr cc0 cA vv cv cexp co cle wbr cA cr
        wcel vv cv cn0 wcel cc0 cA cle wbr cc0 cA vv cv cexp co cle wbr vv cv
        cn wcel cA vv cv expge0 vv cv nnnn0 syl3an2 3expa an1rs vv cv cn wcel
        vv cv cG cfv cA vv cv cexp co wceq cA cr wcel cc0 cA cle wbr wa vz vw
        vv cv cA vz cv cexp co cA vv cv cexp co cn cG vz cv vv cv cA cexp
        opreq2 cvgratlem5.2 cA vv cv cexp oprex fvopab4 adantl breqtrrd
        r19.21aiva jca adantlr cA cc wcel cA cabs cfv c1 clt wbr caddc cG cseq1
        co cA c1 cA cmin co cdiv co cli wbr cA cr wcel cA c1 clt wbr wa cc0 cA
        cle wbr wa vw cA vz cG cvgratlem5.2 geolim1 cA cr wcel cA cc wcel cA c1
        clt wbr cc0 cA cle wbr cA recn ad2antrr cA cr wcel cA c1 clt wbr wa cc0
        cA cle wbr wa cA cabs cfv cA c1 clt cA cr wcel cc0 cA cle wbr cA cabs
        cfv cA wceq cA c1 clt wbr cA absid adantlr cA cr wcel cA c1 clt wbr cc0
        cA cle wbr simplr eqbrtrd sylanc jca syldan adantr cA cr wcel cc0 cA
        clt wbr cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv
        cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa cB cF cfv
        cabs cfv cA cB cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB
        cexp co cdiv co cle wbr wa cn cc cF wf cB vv cv clt wbr vv cv cF cfv
        cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul co
        cle wbr wi vv cn wral wa wa cA c1 clt wbr cA cr wcel cc0 cA clt wbr wa
        cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv
        cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa cB cF cfv cabs cfv
        cA cB cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB cexp co cdiv
        co cle wbr wa cn cc cF wf cB vv cv clt wbr vv cv cF cfv cabs cfv cB cF
        cfv cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul co cle wbr wi vv
        cn wral wa cA cr wcel cc0 cA clt wbr wa cB cn wcel cB cF cfv cabs cfv
        cA cB cexp co cdiv co cr wcel cc0 cB cF cfv cabs cfv cA cB cexp co cdiv
        co cle wbr wa cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx
        cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral cA cr wcel cB cn wcel
        cc0 cA clt wbr cB cF cfv cabs cfv cA cB cexp co cdiv co cr wcel cc0 cB
        cF cfv cabs cfv cA cB cexp co cdiv co cle wbr wa cA cr wcel cB cn wcel
        cc0 cA clt wbr cB cF cfv cabs cfv cA cB cexp co cdiv co cr wcel cc0 cB
        cF cfv cabs cfv cA cB cexp co cdiv co cle wbr wa cA cr wcel cB cn wcel
        cc0 cA clt wbr w3a cB cF cfv cabs cfv cA cB cexp co cdiv co cr wcel cc0
        cB cF cfv cabs cfv cA cB cexp co cdiv co cle wbr cB cF cfv cabs cfv cr
        wcel cA cB cexp co cr wcel cA cB cexp co cc0 wne cB cF cfv cabs cfv cA
        cB cexp co cdiv co cr wcel cA cr wcel cB cn wcel cc0 cA clt wbr w3a cB
        cF cfv cabs cfv cA cB cexp co redivcl cB cn wcel cA cr wcel cB cF cfv
        cabs cfv cr wcel cc0 cA clt wbr cB cn wcel cB cF cfv cc wcel cB cF cfv
        cabs cfv cr wcel cn cc cB cF cvgrat.1 ffvelrni cB cF cfv abscl syl
        3ad2ant2 cA cr wcel cB cn wcel cA cB cexp co cr wcel cc0 cA clt wbr cA
        cr wcel cB cn0 wcel cA cB cexp co cr wcel cB cn wcel cA cB reexpcl cB
        nnnn0 sylan2 3adant3 cA cr wcel cB cn wcel cc0 cA clt wbr w3a cA cB
        cexp co cc0 wne cA cc0 wne cA cr wcel cc0 cA clt wbr cA cc0 wne cB cn
        wcel cA gt0ne0 3adant2 cA cr wcel cB cn wcel cA cB cexp co cc0 wne cA
        cc0 wne wb cc0 cA clt wbr cA cc wcel cB cn wcel cA cB cexp co cc0 wne
        cA cc0 wne wb cA cr wcel cA cB expne0 cA recn sylan 3adant3 mpbird
        syl3anc cB cF cfv cabs cfv cr wcel cc0 cB cF cfv cabs cfv cle wbr cA cB
        cexp co cr wcel cc0 cA cB cexp co clt wbr cc0 cB cF cfv cabs cfv cA cB
        cexp co cdiv co cle wbr cA cr wcel cB cn wcel cc0 cA clt wbr w3a cB cF
        cfv cabs cfv cA cB cexp co divge0 cB cn wcel cA cr wcel cB cF cfv cabs
        cfv cr wcel cc0 cA clt wbr cB cn wcel cB cF cfv cc wcel cB cF cfv cabs
        cfv cr wcel cn cc cB cF cvgrat.1 ffvelrni cB cF cfv abscl syl 3ad2ant2
        cB cn wcel cA cr wcel cc0 cB cF cfv cabs cfv cle wbr cc0 cA clt wbr cB
        cn wcel cB cF cfv cc wcel cc0 cB cF cfv cabs cfv cle wbr cn cc cB cF
        cvgrat.1 ffvelrni cB cF cfv absge0 syl 3ad2ant2 cA cr wcel cB cn wcel
        cA cB cexp co cr wcel cc0 cA clt wbr cA cr wcel cB cn0 wcel cA cB cexp
        co cr wcel cB cn wcel cA cB reexpcl cB nnnn0 sylan2 3adant3 cA cr wcel
        cB cn0 wcel cc0 cA clt wbr cc0 cA cB cexp co clt wbr cB cn wcel cA cB
        expgt0 cB nnnn0 syl3an2 syl2anc jca 3expa an1rs adantrr cA cr wcel cc0
        cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs
        cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa cB vv
        cv clt wbr vv cv cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv
        co vv cv cG cfv cmul co cle wbr wi vv cn wral cn cc cF wf cA cr wcel
        cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv
        cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa
        cB vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co
        cdiv co vv cv cG cfv cmul co cle wbr wi vv cn cA cr wcel cc0 cA clt wbr
        wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx
        cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa vv cv cn wcel cB
        vv cv clt wbr vv cv cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co
        cdiv co vv cv cG cfv cmul co cle wbr cA cr wcel cc0 cA clt wbr wa cB cn
        wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv
        cabs cfv cmul co clt wbr wi vx cn wral wa wa vv cv cn wcel cB vv cv clt
        wbr wa wa vv cv cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv
        co cA vv cv cexp co cmul co cB cF cfv cabs cfv cA cB cexp co cdiv co vv
        cv cG cfv cmul co cle cA cr wcel cc0 cA clt wbr wa cB cn wcel cB vx cv
        cle wbr vx cv c1 caddc co cF cfv cabs cfv cA vx cv cF cfv cabs cfv cmul
        co clt wbr wi vx cn wral wa wa vv cv cn wcel cB vv cv clt wbr wa vv cv
        cF cfv cabs cfv cB cF cfv cabs cfv cA cB cexp co cdiv co cA vv cv cexp
        co cmul co cle wbr vx vy vu cA cB vv cv cF vy cv cn wcel vu cv vy cv cF
        cfv cabs cfv wceq wa vy vu copab cvgrat.1 vy cv cn wcel vu cv vy cv cF
        cfv cabs cfv wceq wa vy vu copab eqid cvgratlem3 imp vv cv cn wcel cB
        cF cfv cabs cfv cA cB cexp co cdiv co vv cv cG cfv cmul co cB cF cfv
        cabs cfv cA cB cexp co cdiv co cA vv cv cexp co cmul co wceq cA cr wcel
        cc0 cA clt wbr wa cB cn wcel cB vx cv cle wbr vx cv c1 caddc co cF cfv
        cabs cfv cA vx cv cF cfv cabs cfv cmul co clt wbr wi vx cn wral wa wa
        cB vv cv clt wbr vv cv cn wcel vv cv cG cfv cA vv cv cexp co cB cF cfv
        cabs cfv cA cB cexp co cdiv co cmul vz vw vv cv cA vz cv cexp co cA vv
        cv cexp co cn cG vz cv vv cv cA cexp opreq2 cvgratlem5.2 cA vv cv cexp
        oprex fvopab4 opreq2d ad2antrl breqtrrd exp32 r19.21aiv cvgrat.1 jctil
        jca adantllr jca exp31 com23 imp mpd sylanc $.
        $( [25-Jun-2006] $) $( [26-Apr-2005] $)
    $}

    $( Ratio test for convergence of a complex infinite series.  If the ratio
       ` A ` of the absolute values of of successive terms in an infinite
       sequence ` F ` is less than 1 for all terms beyond some index ` B ` ,
       then the infinite sum of the terms of ` F ` converges to a complex
       number.  Equivalent to first part of Exercise 4 of [Gleason] p. 182. $)
    cvgrati $p |- ( ( ( A e. RR /\ A < 1 ) /\ ( B e. NN /\ A. x e. NN (
  B <_ x -> ( abs ` ( F ` ( x + 1 ) ) ) < ( A x. ( abs ` ( F ` x ) ) ) ) ) ) ->
                 E. y ( + seq1 F ) ~~> y ) $=
      vx vy vz vw cA cB cF vz cv cn wcel vw cv cA vz cv cexp co wceq wa vz vw
      copab cvgrat.1 vz cv cn wcel vw cv cA vz cv cexp co wceq wa vz vw copab
      eqid cvgratlem5 $.
      $( [25-Jun-2006] $) $( [26-Apr-2005] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The product of two finite sums
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for ~ fsum0diag . $)
  fsum0diaglem1 $p |- ( ( N e. A /\ K e. ( 0 ... N ) ) ->
                      ( 0 ... ( N - K ) ) C_ ( 0 ... N ) ) $=
    cN cN cK cmin co cuz cfv wcel cc0 cz wcel cc0 cN cK cmin co cfz co cc0 cN
    cfz co wss cN cA wcel cK cc0 cN cfz co wcel wa cN cK cmin co cc0 cN fzss2
    cN cA wcel cK cc0 cN cfz co wcel wa cN cN cK cmin co cuz cfv wcel cN cK
    cmin co cN cle wbr cN cA wcel cK cc0 cN cfz co wcel wa cc0 cK cle wbr cN cK
    cmin co cN cle wbr cK cc0 cN cfz co wcel cc0 cK cle wbr cN cA wcel cK cc0
    cN elfzle1 adantl cN cr wcel cK cr wcel cc0 cK cle wbr cN cK cmin co cN cle
    wbr wb cN cA wcel cK cc0 cN cfz co wcel wa cN cK subge02 cN cA wcel cK cc0
    cN cfz co wcel wa cN cz wcel cN cr wcel cA cK cc0 cN elfzel2g cN zre syl cN
    cA wcel cK cc0 cN cfz co wcel wa cK cz wcel cK cr wcel cK cc0 cN cfz co
    wcel cK cz wcel cN cA wcel cK cc0 cN elfzelz adantl cK zre syl sylanc mpbid
    cN cK cmin co cz wcel cN cz wcel cN cN cK cmin co cuz cfv wcel cN cK cmin
    co cN cle wbr wb cN cA wcel cK cc0 cN cfz co wcel wa cN cK cmin co cN eluz
    cN cz wcel cK cz wcel cN cK cmin co cz wcel cN cA wcel cK cc0 cN cfz co
    wcel wa cN cK zsubcl cA cK cc0 cN elfzel2g cK cc0 cN cfz co wcel cK cz wcel
    cN cA wcel cK cc0 cN elfzelz adantl sylanc cA cK cc0 cN elfzel2g sylanc
    mpbird 0z sylancl $.
    $( [8-Feb-2006] $) $( [3-Dec-2005] $)

  ${
    $d k m n x A $.  $d j m n x B $.  $d j k m n x N $.
    $( Lemma for ~ fsum0diag that provides its induction hypothesis.  _Warning:
       The HTML proof page is 0.8 megabyte in size_. $)
    fsum0diaglem2 $p |- ( n e. NN0 -> ( ( ( A. j e. ( 0 ... n ) A e. CC /\ A.
      k e. ( 0 ... n ) B e. CC ) -> sum_ j e. ( 0 ... n ) sum_ k e. ( 0
      ... ( n - j ) ) ( A x. B ) = sum_ k e. ( 0 ... n ) sum_ j e. ( 0 ... k
     ) ( A x. [_ ( k - j ) / k ]_ B ) ) -> ( ( A. j e. ( 0 ... ( n + 1 ) ) A e.
     CC /\ A. k e. ( 0 ... ( n + 1 ) ) B e. CC ) -> sum_ j e. ( 0 ... ( n + 1 )
   ) sum_ k e. ( 0 ... ( ( n + 1 ) - j ) ) ( A x. B ) = sum_ k e. ( 0 ... ( n +
      1 ) ) sum_ j e. ( 0 ... k ) ( A x. [_ ( k - j ) / k ]_ B ) ) ) ) $=
      vn cv cn0 wcel cA cc wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc wcel
      vk cc0 vn cv c1 caddc co cfz co wral wa cc0 vn cv cfz co cc0 vn cv vj cv
      cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz
      co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq wi cA cc
      wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral wa cc0 vn cv c1 caddc co cfz co cc0 vn cv c1 caddc
      co vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv c1 caddc co
      cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu
      vk csu wceq wi cA cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0 vn
      cv cfz co wral wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB
      cmul co vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv
      cmin co cB csb cmul co vj csu vk csu wceq wi vn cv cn0 wcel cA cc wcel vj
      cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz
      co wral wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co
      cB csb cmul co vj csu vk csu wceq cc0 vn cv c1 caddc co cfz co cc0 vn cv
      c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv c1
      caddc co cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co
      vj csu vk csu wceq vn cv cn0 wcel vn cv cc0 cuz cfv wcel cA cc wcel vj
      cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz
      co wral wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co
      cB csb cmul co vj csu vk csu wceq cc0 vn cv c1 caddc co cfz co cc0 vn cv
      c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv c1
      caddc co cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co
      vj csu vk csu wceq wi wi vn cv elnn0uz vn cv cc0 cuz cfv wcel cA cc wcel
      vj cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co
      cfz co wral wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul
      co vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin
      co cB csb cmul co vj csu vk csu wceq cc0 vn cv c1 caddc co cfz co cc0 vn
      cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv
      c1 caddc co cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul
      co vj csu vk csu wceq vn cv cc0 cuz cfv wcel cA cc wcel vj cc0 vn cv c1
      caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa
      wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu
      vj csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb
      cmul co vj csu vk csu wceq wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co
      cfz co cA cB cmul co vk csu cA vk vn cv vj cv cmin co c1 caddc co cB csb
      cmul co caddc co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul co
      caddc co cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB
      csb cmul co vj csu vk csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1
      caddc co cB csb cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb
      cmul co caddc co caddc co cc0 vn cv c1 caddc co cfz co cc0 vn cv c1 caddc
      co vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv c1 caddc co
      cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu
      vk csu vn cv cc0 cuz cfv wcel cA cc wcel vj cc0 vn cv c1 caddc co cfz co
      wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa wa cc0 vn cv cfz
      co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv
      cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu
      vk csu wceq cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co
      vk csu cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co caddc co vj
      csu vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul co caddc co cc0 vn cv
      cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn
      cv cfz co cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co vj csu vj
      vn cv c1 caddc co cA csb vk cc0 cB csb cmul co caddc co caddc co cc0 vn
      cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj
      csu vk csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1 caddc co cB csb
      cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul co caddc co
      caddc co vn cv cc0 cuz cfv wcel cA cc wcel vj cc0 vn cv c1 caddc co cfz
      co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa wa cc0 vn cv
      cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cA vk vn cv vj
      cv cmin co c1 caddc co cB csb cmul co caddc co vj csu vj vn cv c1 caddc
      co cA csb vk cc0 cB csb cmul co caddc co cc0 vn cv cfz co cc0 vn cv vj cv
      cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz co cA vk vn cv
      vj cv cmin co c1 caddc co cB csb cmul co vj csu caddc co vj vn cv c1
      caddc co cA csb vk cc0 cB csb cmul co caddc co cc0 vn cv cfz co cc0 vn cv
      vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz co cA vk
      vn cv vj cv cmin co c1 caddc co cB csb cmul co vj csu vj vn cv c1 caddc
      co cA csb vk cc0 cB csb cmul co caddc co caddc co vn cv cc0 cuz cfv wcel
      cA cc wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv
      c1 caddc co cfz co wral wa wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co
      cfz co cA cB cmul co vk csu cA vk vn cv vj cv cmin co c1 caddc co cB csb
      cmul co caddc co vj csu cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co
      cA cB cmul co vk csu vj csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1
      caddc co cB csb cmul co vj csu caddc co vj vn cv c1 caddc co cA csb vk
      cc0 cB csb cmul co caddc vn cv cc0 cuz cfv wcel cA cc wcel vj cc0 vn cv
      c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral
      wa cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cc wcel cA vk vn
      cv vj cv cmin co c1 caddc co cB csb cmul co cc wcel wa vj cc0 vn cv cfz
      co wral cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk
      csu cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co caddc co vj csu
      cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co
      vj csu caddc co wceq cA cc wcel vj cc0 vn cv c1 caddc co cfz co wral vn
      cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral cc0
      vn cv vj cv cmin co cfz co cA cB cmul co vk csu cc wcel cA vk vn cv vj cv
      cmin co c1 caddc co cB csb cmul co cc wcel wa vj cc0 vn cv cfz co wral vn
      cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa cA
      cc wcel vj cc0 vn cv c1 caddc co cfz co wral cc0 vn cv vj cv cmin co cfz
      co cA cB cmul co vk csu cc wcel cA vk vn cv vj cv cmin co c1 caddc co cB
      csb cmul co cc wcel wa vj cc0 vn cv cfz co wral vn cv cc0 cuz cfv wcel cB
      cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa cA cc wcel cc0 vn cv vj
      cv cmin co cfz co cA cB cmul co vk csu cc wcel cA vk vn cv vj cv cmin co
      c1 caddc co cB csb cmul co cc wcel wa vj cc0 vn cv c1 caddc co cfz co cc0
      vn cv cfz co vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co
      cfz co wral wa vj cv cc0 vn cv cfz co wcel cA cc wcel wi vj cv cc0 vn cv
      cfz co wcel cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cc wcel
      cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co cc wcel wa wi vj cv
      cc0 vn cv c1 caddc co cfz co wcel cA cc wcel wi vn cv cc0 cuz cfv wcel cB
      cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa vj cv cc0 vn cv cfz co
      wcel cA cc wcel cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cc
      wcel cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co cc wcel wa vn
      cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa vj
      cv cc0 vn cv cfz co wcel cA cc wcel cc0 vn cv vj cv cmin co cfz co cA cB
      cmul co vk csu cc wcel cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul
      co cc wcel wa vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co
      cfz co wral wa vj cv cc0 vn cv cfz co wcel cA cc wcel wa wa cc0 vn cv vj
      cv cmin co cfz co cA cB cmul co vk csu cc wcel cA vk vn cv vj cv cmin co
      c1 caddc co cB csb cmul co cc wcel vn cv vj cv cmin co cc0 cuz cfv wcel
      cA cB cmul co cc wcel vk cc0 vn cv vj cv cmin co cfz co wral cc0 vn cv vj
      cv cmin co cfz co cA cB cmul co vk csu cc wcel vn cv cc0 cuz cfv wcel cB
      cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa vj cv cc0 vn cv cfz co
      wcel cA cc wcel wa wa cA cB cmul co vk cc0 vn cv vj cv cmin co fsumcl vn
      cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel vn cv vj cv cmin co cc0
      cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral cA cc wcel
      vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel wa vn cv vj cv cmin co
      cn0 cc0 cuz cfv cc0 cuz cfv vj cv cc0 vn cv fznn0sub nn0uz syl6eleq
      ad2ant2r vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel cA cc wcel wa
      cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral cA cB cmul co cc wcel vk
      cc0 vn cv vj cv cmin co cfz co wral vn cv cc0 cuz cfv wcel vj cv cc0 vn
      cv cfz co wcel cA cc wcel wa wa cB cc wcel vk cc0 vn cv c1 caddc co cfz
      co wral cA cB cmul co cc wcel vk cc0 vn cv vj cv cmin co cfz co wral vn
      cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel cA cc wcel wa wa cB cc
      wcel cA cB cmul co cc wcel vk cc0 vn cv c1 caddc co cfz co cc0 vn cv vj
      cv cmin co cfz co vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel cA
      cc wcel wa wa vk cv cc0 vn cv vj cv cmin co cfz co wcel vk cv cc0 vn cv
      c1 caddc co cfz co wcel cB cc wcel cA cB cmul co cc wcel vn cv cc0 cuz
      cfv wcel vj cv cc0 vn cv cfz co wcel vk cv cc0 vn cv vj cv cmin co cfz co
      wcel vk cv cc0 vn cv c1 caddc co cfz co wcel wi cA cc wcel vn cv cc0 cuz
      cfv wcel vj cv cc0 vn cv cfz co wcel wa vk cv cc0 vn cv vj cv cmin co cfz
      co wcel vk cv cc0 vn cv cfz co wcel vk cv cc0 vn cv c1 caddc co cfz co
      wcel vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel wa cc0 vn cv vj
      cv cmin co cfz co cc0 vn cv cfz co vk cv cc0 cuz cfv vj cv vn cv
      fsum0diaglem1 sseld vk cv cc0 vn cv vn visset fzelp1i syl6 adantrr cA cc
      wcel cB cc wcel cA cB cmul co cc wcel wi vn cv cc0 cuz cfv wcel vj cv cc0
      vn cv cfz co wcel cA cc wcel cB cc wcel cA cB cmul co cc wcel cA cB mulcl
      ex ad2antll imim12d r19.20dv2 imp an1rs sylanc cA cc wcel vk vn cv vj cv
      cmin co c1 caddc co cB csb cc wcel cA vk vn cv vj cv cmin co c1 caddc co
      cB csb cmul co cc wcel vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral wa vj cv cc0 vn cv cfz co wcel cA cc wcel wa wa cA
      vk vn cv vj cv cmin co c1 caddc co cB csb mulcl vn cv cc0 cuz cfv wcel cB
      cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa vj cv cc0 vn cv cfz co
      wcel cA cc wcel simprr vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral wa vj cv cc0 vn cv cfz co wcel vk vn cv vj cv cmin
      co c1 caddc co cB csb cc wcel cA cc wcel vn cv cc0 cuz cfv wcel vj cv cc0
      vn cv cfz co wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral vk vn
      cv vj cv cmin co c1 caddc co cB csb cc wcel vn cv vj cv cmin co c1 caddc
      co cc0 vn cv c1 caddc co cfz co wcel cB cc wcel vk cc0 vn cv c1 caddc co
      cfz co wral vk vn cv vj cv cmin co c1 caddc co cB csb cc wcel vn cv cc0
      cuz cfv wcel vj cv cc0 vn cv cfz co wcel wa vk vn cv vj cv cmin co c1
      caddc co cc0 vn cv c1 caddc co cfz co cB cc ra4csbela vn cv cc0 cuz cfv
      wcel vj cv cc0 vn cv cfz co wcel wa vn cv c1 caddc co vj cv cmin co vn cv
      vj cv cmin co c1 caddc co cc0 vn cv c1 caddc co cfz co vn cv cc wcel vj
      cv cc wcel vn cv c1 caddc co vj cv cmin co vn cv vj cv cmin co c1 caddc
      co wceq vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel vn cv cc wcel
      c1 cc wcel vj cv cc wcel vn cv c1 caddc co vj cv cmin co vn cv vj cv cmin
      co c1 caddc co wceq ax1cn vn cv c1 vj cv addsub mp3an2 vn cv cc0 cuz cfv
      wcel vn cv cz wcel vn cv cc wcel cc0 vn cv eluzelz vn cv zcn syl vj cv
      cc0 vn cv cfz co wcel vj cv cz wcel vj cv cc wcel vj cv cc0 vn cv elfzelz
      vj cv zcn syl syl2an vn cv c1 caddc co cc0 cuz cfv wcel vj cv cc0 vn cv
      c1 caddc co cfz co wcel vn cv c1 caddc co vj cv cmin co cc0 vn cv c1
      caddc co cfz co wcel vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel
      cc0 cuz cfv vj cv vn cv c1 caddc co fznn0sub2 cc0 vn cv peano2uz vj cv
      cc0 vn cv vn visset fzelp1i syl2an eqeltrrd sylan an1rs adantrr sylanc
      jca exp32 a2d vj cv cc0 vn cv cfz co wcel vj cv cc0 vn cv c1 caddc co cfz
      co wcel cA cc wcel vj cv cc0 vn cv vn visset fzelp1i imim1i syl5
      r19.20dv2 impcom an1s cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu
      cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co vj cc0 vn cv fsumadd
      syldan opreq1d cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul
      co vk csu vj csu cc wcel cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1
      caddc co cB csb cmul co vj csu cc wcel vj vn cv c1 caddc co cA csb vk cc0
      cB csb cmul co cc wcel cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA
      cB cmul co vk csu vj csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1
      caddc co cB csb cmul co vj csu caddc co vj vn cv c1 caddc co cA csb vk
      cc0 cB csb cmul co caddc co cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz
      co cA cB cmul co vk csu vj csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co
      c1 caddc co cB csb cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB
      csb cmul co caddc co caddc co wceq vn cv cc0 cuz cfv wcel cA cc wcel vj
      cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz
      co wral wa wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul
      co vk csu vj csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1 caddc co
      cB csb cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul co
      addass vn cv cc0 cuz cfv wcel cc0 vn cv vj cv cmin co cfz co cA cB cmul
      co vk csu cc wcel vj cc0 vn cv cfz co wral cc0 vn cv cfz co cc0 vn cv vj
      cv cmin co cfz co cA cB cmul co vk csu vj csu cc wcel cA cc wcel vj cc0
      vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co
      wral wa cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj cc0 vn cv
      fsumcl cA cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0 vn cv cfz co
      wral cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cc wcel vj cc0
      vn cv cfz co wral cA cc wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc
      wcel vk cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv cfz co
      wral cA cc wcel vj cc0 vn cv cfz co wral cc0 vn cv vj cv cmin co cfz co
      cA cB cmul co vk csu cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0
      vn cv cfz co wral cA cc wcel cc0 vn cv vj cv cmin co cfz co cA cB cmul co
      vk csu cc wcel vj cc0 vn cv cfz co cB cc wcel vk cc0 vn cv cfz co wral vj
      cv cc0 vn cv cfz co wcel wa cA cc wcel cc0 vn cv vj cv cmin co cfz co cA
      cB cmul co vk csu cc wcel vn cv vj cv cmin co cc0 cuz cfv wcel cA cB cmul
      co cc wcel vk cc0 vn cv vj cv cmin co cfz co wral cc0 vn cv vj cv cmin co
      cfz co cA cB cmul co vk csu cc wcel cB cc wcel vk cc0 vn cv cfz co wral
      vj cv cc0 vn cv cfz co wcel wa cA cc wcel wa cA cB cmul co vk cc0 vn cv
      vj cv cmin co fsumcl vj cv cc0 vn cv cfz co wcel vn cv vj cv cmin co cc0
      cuz cfv wcel cB cc wcel vk cc0 vn cv cfz co wral cA cc wcel vj cv cc0 vn
      cv cfz co wcel vn cv vj cv cmin co cn0 cc0 cuz cfv vn cv cvv wcel vj cv
      cc0 vn cv cfz co wcel vn cv vj cv cmin co cn0 wcel vn visset cvv vj cv
      cc0 vn cv fznn0sub mpan nn0uz syl6eleq ad2antlr cB cc wcel vk cc0 vn cv
      cfz co wral vj cv cc0 vn cv cfz co wcel cA cc wcel cA cB cmul co cc wcel
      vk cc0 vn cv vj cv cmin co cfz co wral vj cv cc0 vn cv cfz co wcel cA cc
      wcel wa cB cc wcel vk cc0 vn cv cfz co wral cA cB cmul co cc wcel vk cc0
      vn cv vj cv cmin co cfz co wral vj cv cc0 vn cv cfz co wcel cA cc wcel wa
      cB cc wcel cA cB cmul co cc wcel vk cc0 vn cv cfz co cc0 vn cv vj cv cmin
      co cfz co vj cv cc0 vn cv cfz co wcel cA cc wcel wa vk cv cc0 vn cv cfz
      co wcel cB cc wcel wi vk cv cc0 vn cv vj cv cmin co cfz co wcel cB cc
      wcel cA cB cmul co cc wcel vj cv cc0 vn cv cfz co wcel vk cv cc0 vn cv
      cfz co wcel cB cc wcel wi vk cv cc0 vn cv vj cv cmin co cfz co wcel cB cc
      wcel wi wi cA cc wcel vj cv cc0 vn cv cfz co wcel vk cv cc0 vn cv vj cv
      cmin co cfz co wcel vk cv cc0 vn cv cfz co wcel cB cc wcel vj cv cc0 vn
      cv cfz co wcel cc0 vn cv vj cv cmin co cfz co cc0 vn cv cfz co vk cv vn
      cv cvv wcel vj cv cc0 vn cv cfz co wcel cc0 vn cv vj cv cmin co cfz co
      cc0 vn cv cfz co wss vn visset cvv vj cv vn cv fsum0diaglem1 mpan sseld
      imim1d adantr cA cc wcel cB cc wcel cA cB cmul co cc wcel wi vj cv cc0 vn
      cv cfz co wcel cA cc wcel cB cc wcel cA cB cmul co cc wcel cA cB mulcl ex
      adantl syl6d r19.20dv2 impcom anassrs sylanc ex r19.20dva impcom cA cc
      wcel cA cc wcel vj cc0 vn cv c1 caddc co cfz co cc0 vn cv cfz co vj cv
      cc0 vn cv cfz co wcel vj cv cc0 vn cv c1 caddc co cfz co wcel cA cc wcel
      vj cv cc0 vn cv vn visset fzelp1i imim1i r19.20i2 cB cc wcel cB cc wcel
      vk cc0 vn cv c1 caddc co cfz co cc0 vn cv cfz co vk cv cc0 vn cv cfz co
      wcel vk cv cc0 vn cv c1 caddc co cfz co wcel cB cc wcel vk cv cc0 vn cv
      vn visset fzelp1i imim1i r19.20i2 syl2an sylan2 vn cv cc0 cuz cfv wcel cA
      cc wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral wa cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul
      co cc wcel vj cc0 vn cv cfz co wral cc0 vn cv cfz co cA vk vn cv vj cv
      cmin co c1 caddc co cB csb cmul co vj csu cc wcel cA cc wcel vj cc0 vn cv
      c1 caddc co cfz co wral vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co
      cc wcel vj cc0 vn cv cfz co wral vn cv cc0 cuz cfv wcel cB cc wcel vk cc0
      vn cv c1 caddc co cfz co wral wa cA cc wcel vj cc0 vn cv c1 caddc co cfz
      co wral cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co cc wcel vj
      cc0 vn cv cfz co wral vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral wa cA cc wcel cA vk vn cv vj cv cmin co c1 caddc co
      cB csb cmul co cc wcel vj cc0 vn cv c1 caddc co cfz co cc0 vn cv cfz co
      vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa
      vj cv cc0 vn cv cfz co wcel cA cc wcel wi vj cv cc0 vn cv cfz co wcel cA
      vk vn cv vj cv cmin co c1 caddc co cB csb cmul co cc wcel wi vj cv cc0 vn
      cv c1 caddc co cfz co wcel cA cc wcel wi vn cv cc0 cuz cfv wcel cB cc
      wcel vk cc0 vn cv c1 caddc co cfz co wral wa vj cv cc0 vn cv cfz co wcel
      cA cc wcel cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co cc wcel
      vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa
      vj cv cc0 vn cv cfz co wcel cA cc wcel cA vk vn cv vj cv cmin co c1 caddc
      co cB csb cmul co cc wcel cA cc wcel vk vn cv vj cv cmin co c1 caddc co
      cB csb cc wcel cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co cc
      wcel vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co
      wral wa vj cv cc0 vn cv cfz co wcel cA cc wcel wa wa cA vk vn cv vj cv
      cmin co c1 caddc co cB csb mulcl vn cv cc0 cuz cfv wcel cB cc wcel vk cc0
      vn cv c1 caddc co cfz co wral wa vj cv cc0 vn cv cfz co wcel cA cc wcel
      simprr vn cv cc0 cuz cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co
      wral wa vj cv cc0 vn cv cfz co wcel vk vn cv vj cv cmin co c1 caddc co cB
      csb cc wcel cA cc wcel vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel
      cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral vk vn cv vj cv cmin co c1
      caddc co cB csb cc wcel vn cv vj cv cmin co c1 caddc co cc0 vn cv c1
      caddc co cfz co wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral vk
      vn cv vj cv cmin co c1 caddc co cB csb cc wcel vn cv cc0 cuz cfv wcel vj
      cv cc0 vn cv cfz co wcel wa vk vn cv vj cv cmin co c1 caddc co cc0 vn cv
      c1 caddc co cfz co cB cc ra4csbela vn cv cc0 cuz cfv wcel vj cv cc0 vn cv
      cfz co wcel wa vn cv c1 caddc co vj cv cmin co vn cv vj cv cmin co c1
      caddc co cc0 vn cv c1 caddc co cfz co vn cv cc wcel vj cv cc wcel vn cv
      c1 caddc co vj cv cmin co vn cv vj cv cmin co c1 caddc co wceq vn cv cc0
      cuz cfv wcel vj cv cc0 vn cv cfz co wcel vn cv cc wcel c1 cc wcel vj cv
      cc wcel vn cv c1 caddc co vj cv cmin co vn cv vj cv cmin co c1 caddc co
      wceq ax1cn vn cv c1 vj cv addsub mp3an2 vn cv cc0 cuz cfv wcel vn cv cz
      wcel vn cv cc wcel cc0 vn cv eluzelz vn cv zcn syl vj cv cc0 vn cv cfz co
      wcel vj cv cz wcel vj cv cc wcel vj cv cc0 vn cv elfzelz vj cv zcn syl
      syl2an vn cv c1 caddc co cc0 cuz cfv wcel vj cv cc0 vn cv c1 caddc co cfz
      co wcel vn cv c1 caddc co vj cv cmin co cc0 vn cv c1 caddc co cfz co wcel
      vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel cc0 cuz cfv vj cv vn
      cv c1 caddc co fznn0sub2 cc0 vn cv peano2uz vj cv cc0 vn cv vn visset
      fzelp1i syl2an eqeltrrd sylan an1rs adantrr sylanc exp32 a2d vj cv cc0 vn
      cv cfz co wcel vj cv cc0 vn cv c1 caddc co cfz co wcel cA cc wcel vj cv
      cc0 vn cv vn visset fzelp1i imim1i syl5 r19.20dv2 impcom an1s cA vk vn cv
      vj cv cmin co c1 caddc co cB csb cmul co vj cc0 vn cv fsumcl syldan vn cv
      cc0 cuz cfv wcel cA cc wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc
      wcel vk cc0 vn cv c1 caddc co cfz co wral wa wa vj vn cv c1 caddc co cA
      csb cc wcel vk cc0 cB csb cc wcel wa vj vn cv c1 caddc co cA csb vk cc0
      cB csb cmul co cc wcel vn cv c1 caddc co cc0 cuz cfv wcel cA cc wcel vj
      cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz
      co wral wa vj vn cv c1 caddc co cA csb cc wcel vk cc0 cB csb cc wcel wa
      vn cv cc0 cuz cfv wcel vn cv c1 caddc co cc0 cuz cfv wcel cA cc wcel vj
      cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz
      co wral vj vn cv c1 caddc co cA csb cc wcel vk cc0 cB csb cc wcel wa vn
      cv c1 caddc co cc0 cuz cfv wcel cA cc wcel vj cc0 vn cv c1 caddc co cfz
      co wral wa vj vn cv c1 caddc co cA csb cc wcel vn cv c1 caddc co cc0 cuz
      cfv wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa vk cc0 cB csb
      cc wcel vn cv c1 caddc co cc0 vn cv c1 caddc co cfz co wcel cA cc wcel vj
      cc0 vn cv c1 caddc co cfz co wral vj vn cv c1 caddc co cA csb cc wcel vn
      cv c1 caddc co cc0 cuz cfv wcel vj vn cv c1 caddc co cc0 vn cv c1 caddc
      co cfz co cA cc ra4csbela cc0 vn cv c1 caddc co eluzfz2 sylan cc0 cc0 vn
      cv c1 caddc co cfz co wcel cB cc wcel vk cc0 vn cv c1 caddc co cfz co
      wral vk cc0 cB csb cc wcel vn cv c1 caddc co cc0 cuz cfv wcel vk cc0 cc0
      vn cv c1 caddc co cfz co cB cc ra4csbela cc0 vn cv c1 caddc co eluzfz1
      sylan anim12i anandis cc0 vn cv peano2uz sylan vj vn cv c1 caddc co cA
      csb vk cc0 cB csb mulcl syl syl3anc eqtrd cc0 vn cv cfz co cc0 vn cv vj
      cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz co cc0 vk cv
      cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu cc0 vn cv
      cfz co cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co vj csu vj vn
      cv c1 caddc co cA csb vk cc0 cB csb cmul co caddc co caddc opreq1
      sylan9eq vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc co cfz co cc0 vn cv c1
      caddc co vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz
      co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cA vk vn cv vj cv
      cmin co c1 caddc co cB csb cmul co caddc co vj csu vj vn cv c1 caddc co
      cA csb vk cc0 cB csb cmul co caddc co wceq cA cc wcel vj cc0 vn cv c1
      caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa
      cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb
      cmul co vj csu vk csu wceq vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc co
      cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cc0 vn cv cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB
      cmul co vk csu vj csu cc0 vn cv c1 caddc co vn cv c1 caddc co cmin co cfz
      co vj vn cv c1 caddc co cA csb cB cmul co vk csu caddc co cc0 vn cv cfz
      co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu cA vk vn cv vj cv
      cmin co c1 caddc co cB csb cmul co caddc co vj csu vj vn cv c1 caddc co
      cA csb vk cc0 cB csb cmul co caddc co vm cc0 vn cv c1 caddc co vj cv cmin
      co cfz co cA cB cmul co vk csu cc0 vn cv c1 caddc co vn cv c1 caddc co
      cmin co cfz co vj vn cv c1 caddc co cA csb cB cmul co vk csu vj cc0 vn cv
      cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk sumex cc0 vn
      cv c1 caddc co vn cv c1 caddc co cmin co cfz co vj vn cv c1 caddc co cA
      csb cB cmul co vk sumex vj vm cc0 vn cv c1 caddc co vn cv c1 caddc co
      cmin co cfz co vj vn cv c1 caddc co cA csb cB cmul co vk vm cv cc0 vn cv
      c1 caddc co vn cv c1 caddc co cmin co cfz co wcel vj ax-17 vj vm vj vn cv
      c1 caddc co cA csb cB cmul vj vm vn cv c1 caddc co cA vn cv c1 caddc
      oprex vm cv vn cv c1 caddc co wcel vj ax-17 hbcsb1 vm cv cmul wcel vj
      ax-17 vm cv cB wcel vj ax-17 hbopr hbsum vj cv vn cv c1 caddc co wceq cc0
      vn cv c1 caddc co vj cv cmin co cfz co cc0 vn cv c1 caddc co vn cv c1
      caddc co cmin co cfz co cA cB cmul co vj vn cv c1 caddc co cA csb cB cmul
      co vk vj cv vn cv c1 caddc co wceq vn cv c1 caddc co vj cv cmin co vn cv
      c1 caddc co vn cv c1 caddc co cmin co cc0 cfz vj cv vn cv c1 caddc co vn
      cv c1 caddc co cmin opreq2 opreq2d vj cv vn cv c1 caddc co wceq cA cB
      cmul co vj vn cv c1 caddc co cA csb cB cmul co wceq vk cv cc0 vn cv c1
      caddc co vn cv c1 caddc co cmin co cfz co wcel vj cv vn cv c1 caddc co
      wceq cA vj vn cv c1 caddc co cA csb cB cmul vj vn cv c1 caddc co cA
      csbeq1a opreq1d adantr sumeq12rdv fsump1fi vn cv cc0 cuz cfv wcel cc0 vn
      cv cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu
      vj csu cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk
      csu cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co caddc co vj csu
      cc0 vn cv c1 caddc co vn cv c1 caddc co cmin co cfz co vj vn cv c1 caddc
      co cA csb cB cmul co vk csu vj vn cv c1 caddc co cA csb vk cc0 cB csb
      cmul co caddc vn cv cc0 cuz cfv wcel cc0 vn cv cfz co cc0 vn cv c1 caddc
      co vj cv cmin co cfz co cA cB cmul co vk csu cc0 vn cv vj cv cmin co cfz
      co cA cB cmul co vk csu cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul
      co caddc co vj vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel wa cc0
      vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu cc0 vn cv vj
      cv cmin co c1 caddc co cfz co cA cB cmul co vk csu cc0 vn cv vj cv cmin
      co cfz co cA cB cmul co vk csu cA vk vn cv vj cv cmin co c1 caddc co cB
      csb cmul co caddc co vn cv cc wcel vj cv cc wcel cc0 vn cv c1 caddc co vj
      cv cmin co cfz co cA cB cmul co vk csu cc0 vn cv vj cv cmin co c1 caddc
      co cfz co cA cB cmul co vk csu wceq vn cv cc0 cuz cfv wcel vj cv cc0 vn
      cv cfz co wcel vn cv cc wcel vj cv cc wcel wa cc0 vn cv c1 caddc co vj cv
      cmin co cfz co cc0 vn cv vj cv cmin co c1 caddc co cfz co cA cB cmul co
      vk vn cv cc wcel vj cv cc wcel wa vn cv c1 caddc co vj cv cmin co vn cv
      vj cv cmin co c1 caddc co cc0 cfz vn cv cc wcel c1 cc wcel vj cv cc wcel
      vn cv c1 caddc co vj cv cmin co vn cv vj cv cmin co c1 caddc co wceq
      ax1cn vn cv c1 vj cv addsub mp3an2 opreq2d sumeq1d vn cv cc0 cuz cfv wcel
      vn cv cz wcel vn cv cc wcel cc0 vn cv eluzelz vn cv zcn syl vj cv cc0 vn
      cv cfz co wcel vj cv cz wcel vj cv cc wcel vj cv cc0 vn cv elfzelz vj cv
      zcn syl syl2an vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel wa vn
      cv vj cv cmin co cc0 cuz cfv wcel cc0 vn cv vj cv cmin co c1 caddc co cfz
      co cA cB cmul co vk csu cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk
      csu cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co caddc co wceq vn
      cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel wa vn cv vj cv cmin co
      cn0 cc0 cuz cfv cc0 cuz cfv vj cv cc0 vn cv fznn0sub nn0uz syl6eleq vm cA
      cB cmul co cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul co vk cc0 vn
      cv vj cv cmin co cA cB cmul oprex cA vk vn cv vj cv cmin co c1 caddc co
      cB csb cmul oprex vk vm cA vk vn cv vj cv cmin co c1 caddc co cB csb cmul
      vm cv cA wcel vk ax-17 vm cv cmul wcel vk ax-17 vk vm vn cv vj cv cmin co
      c1 caddc co cB vn cv vj cv cmin co c1 caddc oprex vm cv vn cv vj cv cmin
      co c1 caddc co wcel vk ax-17 hbcsb1 hbopr vk cv vn cv vj cv cmin co c1
      caddc co wceq cB vk vn cv vj cv cmin co c1 caddc co cB csb cA cmul vk vn
      cv vj cv cmin co c1 caddc co cB csbeq1a opreq2d fsump1fi syl eqtrd
      sumeq2dv vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc co vn cv c1 caddc co
      cmin co cfz co vj vn cv c1 caddc co cA csb cB cmul co vk csu cc0 cc0 cfz
      co vj vn cv c1 caddc co cA csb cB cmul co vk csu vj vn cv c1 caddc co cA
      csb vk cc0 cB csb cmul co vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc co vn
      cv c1 caddc co cmin co cfz co cc0 cc0 cfz co vj vn cv c1 caddc co cA csb
      cB cmul co vk vn cv cc0 cuz cfv wcel vn cv c1 caddc co vn cv c1 caddc co
      cmin co cc0 cc0 cfz vn cv cc0 cuz cfv wcel vn cv c1 caddc co cc wcel vn
      cv c1 caddc co vn cv c1 caddc co cmin co cc0 wceq vn cv cc0 cuz cfv wcel
      vn cv cc wcel vn cv c1 caddc co cc wcel vn cv cc0 cuz cfv wcel vn cv cz
      wcel vn cv cc wcel cc0 vn cv eluzelz vn cv zcn syl vn cv peano2cn syl vn
      cv c1 caddc co subid syl opreq2d sumeq1d vj vn cv c1 caddc co cA csb vk
      cc0 cB csb cmul co cvv wcel cc0 cz wcel cc0 cc0 cfz co vj vn cv c1 caddc
      co cA csb cB cmul co vk csu vj vn cv c1 caddc co cA csb vk cc0 cB csb
      cmul co wceq vn cv cc0 cuz cfv wcel vm vj vn cv c1 caddc co cA csb cB
      cmul co vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul co cvv vk cc0 vk
      vm vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul vm cv vj vn cv c1 caddc
      co cA csb wcel vk ax-17 vm cv cmul wcel vk ax-17 cc0 cz wcel vm cv vk cc0
      cB csb wcel vm cv vk cc0 cB csb wcel vk wal wi 0z vk vm cc0 cB cz vm cv
      cc0 wcel vk ax-17 hbcsb1g ax-mp hbopr vk cv cc0 wceq cB vk cc0 cB csb vj
      vn cv c1 caddc co cA csb cmul vk cc0 cB csbeq1a opreq2d fsum1fi vj vn cv
      c1 caddc co cA csb vk cc0 cB csb cmul oprex cc0 vn cv eluzel2 sylancr
      eqtrd opreq12d eqtrd ad2antrr vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc
      co cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj
      csu vk csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB
      csb cmul co vj csu vk csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1
      caddc co cB csb cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb
      cmul co caddc co caddc co wceq cA cc wcel vj cc0 vn cv c1 caddc co cfz co
      wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa cc0 vn cv cfz co
      cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz
      co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk
      csu wceq vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc co cfz co cc0 vk cv
      cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu cc0 vn cv
      cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu
      vk csu cc0 vn cv c1 caddc co cfz co cA vk vn cv c1 caddc co vj cv cmin co
      cB csb cmul co vj csu caddc co cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk
      cv vj cv cmin co cB csb cmul co vj csu vk csu cc0 vn cv cfz co cA vk vn
      cv vj cv cmin co c1 caddc co cB csb cmul co vj csu vj vn cv c1 caddc co
      cA csb vk cc0 cB csb cmul co caddc co caddc co vm cc0 vk cv cfz co cA vk
      vk cv vj cv cmin co cB csb cmul co vj csu cc0 vn cv c1 caddc co cfz co cA
      vk vn cv c1 caddc co vj cv cmin co cB csb cmul co vj csu vk cc0 vn cv cc0
      vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj sumex cc0 vn cv
      c1 caddc co cfz co cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul co
      vj sumex vk vm cc0 vn cv c1 caddc co cfz co cA vk vn cv c1 caddc co vj cv
      cmin co cB csb cmul co vj vm cv cc0 vn cv c1 caddc co cfz co wcel vk
      ax-17 vk vm cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul vm cv cA
      wcel vk ax-17 vm cv cmul wcel vk ax-17 vk vm vn cv c1 caddc co vj cv cmin
      co cB vn cv c1 caddc co vj cv cmin oprex vm cv vn cv c1 caddc co vj cv
      cmin co wcel vk ax-17 hbcsb1 hbopr hbsum vk cv vn cv c1 caddc co wceq cc0
      vk cv cfz co cc0 vn cv c1 caddc co cfz co cA vk vk cv vj cv cmin co cB
      csb cmul co cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul co vj vk cv
      vn cv c1 caddc co cc0 cfz opreq2 vk cv vn cv c1 caddc co wceq cA vk vk cv
      vj cv cmin co cB csb cmul co cA vk vn cv c1 caddc co vj cv cmin co cB csb
      cmul co wceq vj cv cc0 vn cv c1 caddc co cfz co wcel vk cv vn cv c1 caddc
      co wceq vk vk cv vj cv cmin co cB csb vk vn cv c1 caddc co vj cv cmin co
      cB csb cA cmul vk cv vn cv c1 caddc co wceq vk vk cv vj cv cmin co vn cv
      c1 caddc co vj cv cmin co cB vk cv vn cv c1 caddc co vj cv cmin opreq1
      csbeq1d opreq2d adantr sumeq12rdv fsump1fi vn cv cc0 cuz cfv wcel cc0 vn
      cv c1 caddc co cfz co cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul
      co vj csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1 caddc co cB csb
      cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul co caddc co
      cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul
      co vj csu vk csu caddc vn cv cc0 cuz cfv wcel cc0 vn cv c1 caddc co cfz
      co cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul co vj csu cc0 vn cv
      cfz co cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul co vj csu vj vn
      cv c1 caddc co cA csb vk vn cv c1 caddc co vn cv c1 caddc co cmin co cB
      csb cmul co caddc co cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1 caddc
      co cB csb cmul co vj csu vj vn cv c1 caddc co cA csb vk cc0 cB csb cmul
      co caddc co vm cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul co vj vn
      cv c1 caddc co cA csb vk vn cv c1 caddc co vn cv c1 caddc co cmin co cB
      csb cmul co vj cc0 vn cv cA vk vn cv c1 caddc co vj cv cmin co cB csb
      cmul oprex vj vn cv c1 caddc co cA csb vk vn cv c1 caddc co vn cv c1
      caddc co cmin co cB csb cmul oprex vj vm vj vn cv c1 caddc co cA csb vk
      vn cv c1 caddc co vn cv c1 caddc co cmin co cB csb cmul vj vm vn cv c1
      caddc co cA vn cv c1 caddc oprex vm cv vn cv c1 caddc co wcel vj ax-17
      hbcsb1 vm cv cmul wcel vj ax-17 vm cv vk vn cv c1 caddc co vn cv c1 caddc
      co cmin co cB csb wcel vj ax-17 hbopr vj cv vn cv c1 caddc co wceq cA vj
      vn cv c1 caddc co cA csb vk vn cv c1 caddc co vj cv cmin co cB csb vk vn
      cv c1 caddc co vn cv c1 caddc co cmin co cB csb cmul vj vn cv c1 caddc co
      cA csbeq1a vj cv vn cv c1 caddc co wceq vk vn cv c1 caddc co vj cv cmin
      co vn cv c1 caddc co vn cv c1 caddc co cmin co cB vj cv vn cv c1 caddc co
      vn cv c1 caddc co cmin opreq2 csbeq1d opreq12d fsump1fi vn cv cc0 cuz cfv
      wcel cc0 vn cv cfz co cA vk vn cv c1 caddc co vj cv cmin co cB csb cmul
      co vj csu cc0 vn cv cfz co cA vk vn cv vj cv cmin co c1 caddc co cB csb
      cmul co vj csu vj vn cv c1 caddc co cA csb vk vn cv c1 caddc co vn cv c1
      caddc co cmin co cB csb cmul co vj vn cv c1 caddc co cA csb vk cc0 cB csb
      cmul co caddc vn cv cc0 cuz cfv wcel cc0 vn cv cfz co cA vk vn cv c1
      caddc co vj cv cmin co cB csb cmul co cA vk vn cv vj cv cmin co c1 caddc
      co cB csb cmul co vj vn cv cc wcel vj cv cc wcel cA vk vn cv c1 caddc co
      vj cv cmin co cB csb cmul co cA vk vn cv vj cv cmin co c1 caddc co cB csb
      cmul co wceq vn cv cc0 cuz cfv wcel vj cv cc0 vn cv cfz co wcel vn cv cc
      wcel vj cv cc wcel wa vk vn cv c1 caddc co vj cv cmin co cB csb vk vn cv
      vj cv cmin co c1 caddc co cB csb cA cmul vn cv cc wcel vj cv cc wcel wa
      vk vn cv c1 caddc co vj cv cmin co vn cv vj cv cmin co c1 caddc co cB vn
      cv cc wcel c1 cc wcel vj cv cc wcel vn cv c1 caddc co vj cv cmin co vn cv
      vj cv cmin co c1 caddc co wceq ax1cn vn cv c1 vj cv addsub mp3an2 csbeq1d
      opreq2d vn cv cc0 cuz cfv wcel vn cv cz wcel vn cv cc wcel cc0 vn cv
      eluzelz vn cv zcn syl vj cv cc0 vn cv cfz co wcel vj cv cz wcel vj cv cc
      wcel vj cv cc0 vn cv elfzelz vj cv zcn syl syl2an sumeq2dv vn cv cc0 cuz
      cfv wcel vk vn cv c1 caddc co vn cv c1 caddc co cmin co cB csb vk cc0 cB
      csb vj vn cv c1 caddc co cA csb cmul vn cv cc0 cuz cfv wcel vk vn cv c1
      caddc co vn cv c1 caddc co cmin co cc0 cB vn cv cc0 cuz cfv wcel vn cv c1
      caddc co cc wcel vn cv c1 caddc co vn cv c1 caddc co cmin co cc0 wceq vn
      cv cc0 cuz cfv wcel vn cv cc wcel vn cv c1 caddc co cc wcel vn cv cc0 cuz
      cfv wcel vn cv cz wcel vn cv cc wcel cc0 vn cv eluzelz vn cv zcn syl vn
      cv peano2cn syl vn cv c1 caddc co subid syl csbeq1d opreq2d opreq12d
      eqtrd opreq2d eqtrd ad2antrr 3eqtr4d exp31 sylbi a2d cA cc wcel vj cc0 vn
      cv c1 caddc co cfz co wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co
      wral wa cA cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0 vn cv cfz
      co wral wa cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co
      cB csb cmul co vj csu vk csu wceq cA cc wcel vj cc0 vn cv c1 caddc co cfz
      co wral cA cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0 vn cv c1
      caddc co cfz co wral cB cc wcel vk cc0 vn cv cfz co wral cA cc wcel cA cc
      wcel vj cc0 vn cv c1 caddc co cfz co cc0 vn cv cfz co vj cv cc0 vn cv cfz
      co wcel vj cv cc0 vn cv c1 caddc co cfz co wcel cA cc wcel vj cv cc0 vn
      cv vn visset fzelp1i imim1i r19.20i2 cB cc wcel cB cc wcel vk cc0 vn cv
      c1 caddc co cfz co cc0 vn cv cfz co vk cv cc0 vn cv cfz co wcel vk cv cc0
      vn cv c1 caddc co cfz co wcel cB cc wcel vk cv cc0 vn cv vn visset
      fzelp1i imim1i r19.20i2 anim12i imim1i syl5 $.
      $( [8-Feb-2006] $) $( [31-Dec-2005] $)

    $( Two ways to express "the sum of ` A ( j ) x. B ( k ) ` where
       ` j + k <_ N ` ." $)
    fsum0diag $p |- ( ( N e. NN0 /\
      A. j e. ( 0 ...  N ) A e. CC /\ A. k e. ( 0 ... N ) B e. CC ) ->
        sum_ j e. ( 0 ...  N ) sum_ k e. ( 0 ... ( N - j ) ) ( A x. B ) =
  sum_ k e. ( 0 ...  N ) sum_ j e. ( 0 ... k ) ( A x. [_ ( k - j ) / k ]_ B )
                       ) $=
      cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co
      wral cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cc0 cN cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul
      co vj csu vk csu wceq cA cc wcel vj cc0 vm cv cfz co wral cB cc wcel vk
      cc0 vm cv cfz co wral wa cc0 vm cv cfz co cc0 vm cv vj cv cmin co cfz co
      cA cB cmul co vk csu vj csu cc0 vm cv cfz co cc0 vk cv cfz co cA vk vk cv
      vj cv cmin co cB csb cmul co vj csu vk csu wceq wi cA cc wcel vj cc0 cc0
      cfz co wral cB cc wcel vk cc0 cc0 cfz co wral wa cc0 cc0 cfz co cc0 cc0
      vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 cc0 cfz co cc0 vk cv
      cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq wi cA
      cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0 vn cv cfz co wral wa
      cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb
      cmul co vj csu vk csu wceq wi cA cc wcel vj cc0 vn cv c1 caddc co cfz co
      wral cB cc wcel vk cc0 vn cv c1 caddc co cfz co wral wa cc0 vn cv c1
      caddc co cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vn cv c1 caddc co cfz co cc0 vk cv cfz co cA vk vk cv
      vj cv cmin co cB csb cmul co vj csu vk csu wceq wi cA cc wcel vj cc0 cN
      cfz co wral cB cc wcel vk cc0 cN cfz co wral wa cc0 cN cfz co cc0 cN vj
      cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 cN cfz co cc0 vk cv cfz
      co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq wi vm vn
      cN cA cB vj vk vn fsum0diaglem2 cc0 cc0 cfz co cc0 cc0 vj cv cmin co cfz
      co cA cB cmul co vk csu vj csu cc0 cc0 cfz co cc0 vk cv cfz co cA vk vk
      cv vj cv cmin co cB csb cmul co vj csu vk csu wceq cA cc wcel vj cc0 cc0
      cfz co wral cB cc wcel vk cc0 cc0 cfz co wral wa cc0 cc0 cfz co cA vk cc0
      cB csb cmul co vj csu vj cc0 cA csb vk cc0 cB csb cmul co cc0 cc0 cfz co
      cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu
      cc0 cc0 cfz co cc0 cc0 vj cv cmin co cfz co cA cB cmul co vk csu vj csu
      vj cc0 cA csb vk cc0 cB csb cmul co cvv wcel cc0 cz wcel cc0 cc0 cfz co
      cA vk cc0 cB csb cmul co vj csu vj cc0 cA csb vk cc0 cB csb cmul co wceq
      vj cc0 cA csb vk cc0 cB csb cmul oprex 0z vm cA vk cc0 cB csb cmul co vj
      cc0 cA csb vk cc0 cB csb cmul co cvv vj cc0 vj vm vj cc0 cA csb vk cc0 cB
      csb cmul cc0 cz wcel vm cv vj cc0 cA csb wcel vm cv vj cc0 cA csb wcel vj
      wal wi 0z vj vm cc0 cA cz vm cv cc0 wcel vj ax-17 hbcsb1g ax-mp vm cv
      cmul wcel vj ax-17 vm cv vk cc0 cB csb wcel vj ax-17 hbopr vj cv cc0 wceq
      cA vj cc0 cA csb vk cc0 cB csb cmul vj cc0 cA csbeq1a opreq1d fsum1fi
      mp2an cc0 cc0 cfz co cA vk cc0 cB csb cmul co vj csu cvv wcel cc0 cz wcel
      cc0 cc0 cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co
      vj csu vk csu cc0 cc0 cfz co cA vk cc0 cB csb cmul co vj csu wceq cc0 cc0
      cfz co cA vk cc0 cB csb cmul co vj sumex 0z vm cc0 vk cv cfz co cA vk vk
      cv vj cv cmin co cB csb cmul co vj csu cc0 cc0 cfz co cA vk cc0 cB csb
      cmul co vj csu cvv vk cc0 vk vm cc0 cc0 cfz co cA vk cc0 cB csb cmul co
      vj vm cv cc0 cc0 cfz co wcel vk ax-17 vk vm cA vk cc0 cB csb cmul vm cv
      cA wcel vk ax-17 vm cv cmul wcel vk ax-17 cc0 cz wcel vm cv vk cc0 cB csb
      wcel vm cv vk cc0 cB csb wcel vk wal wi 0z vk vm cc0 cB cz vm cv cc0 wcel
      vk ax-17 hbcsb1g ax-mp hbopr hbsum vk cv cc0 wceq cc0 vk cv cfz co cc0
      cc0 cfz co cA vk vk cv vj cv cmin co cB csb cmul co cA vk cc0 cB csb cmul
      co vj vk cv cc0 cc0 cfz opreq2 vk cv cc0 wceq vj cv cc0 wceq cA vk vk cv
      vj cv cmin co cB csb cmul co cA vk cc0 cB csb cmul co wceq vj cv cc0 cc0
      cfz co wcel vk cv cc0 wceq vj cv cc0 wceq wa vk vk cv vj cv cmin co cB
      csb vk cc0 cB csb cA cmul vk cv cc0 wceq vj cv cc0 wceq wa vk vk cv vj cv
      cmin co cc0 cB vk cv cc0 wceq vj cv cc0 wceq wa vk cv vj cv cmin co cc0
      cc0 cmin co cc0 vk cv cc0 vj cv cc0 cmin opreq12 cc0 0cn subidi syl6eq
      csbeq1d opreq2d vj cv cc0 elfz1eq sylan2 sumeq12rdv fsum1fi mp2an cc0 cc0
      cfz co cc0 cc0 vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 cc0
      cfz co vj cc0 cA csb cB cmul co vk csu vj cc0 cA csb vk cc0 cB csb cmul
      co cc0 cc0 cfz co vj cc0 cA csb cB cmul co vk csu cvv wcel cc0 cz wcel
      cc0 cc0 cfz co cc0 cc0 vj cv cmin co cfz co cA cB cmul co vk csu vj csu
      cc0 cc0 cfz co vj cc0 cA csb cB cmul co vk csu wceq cc0 cc0 cfz co vj cc0
      cA csb cB cmul co vk sumex 0z vm cc0 cc0 vj cv cmin co cfz co cA cB cmul
      co vk csu cc0 cc0 cfz co vj cc0 cA csb cB cmul co vk csu cvv vj cc0 vj vm
      cc0 cc0 cfz co vj cc0 cA csb cB cmul co vk vm cv cc0 cc0 cfz co wcel vj
      ax-17 vj vm vj cc0 cA csb cB cmul cc0 cz wcel vm cv vj cc0 cA csb wcel vm
      cv vj cc0 cA csb wcel vj wal wi 0z vj vm cc0 cA cz vm cv cc0 wcel vj
      ax-17 hbcsb1g ax-mp vm cv cmul wcel vj ax-17 vm cv cB wcel vj ax-17 hbopr
      hbsum vj cv cc0 wceq cc0 cc0 vj cv cmin co cfz co cc0 cc0 cfz co cA cB
      cmul co vj cc0 cA csb cB cmul co vk vj cv cc0 wceq cc0 vj cv cmin co cc0
      cc0 cfz vj cv cc0 wceq cc0 vj cv cmin co cc0 cc0 cmin co cc0 vj cv cc0
      cc0 cmin opreq2 cc0 0cn subidi syl6eq opreq2d vj cv cc0 wceq cA cB cmul
      co vj cc0 cA csb cB cmul co wceq vk cv cc0 cc0 cfz co wcel vj cv cc0 wceq
      cA vj cc0 cA csb cB cmul vj cc0 cA csbeq1a opreq1d adantr sumeq12rdv
      fsum1fi mp2an vj cc0 cA csb vk cc0 cB csb cmul co cvv wcel cc0 cz wcel
      cc0 cc0 cfz co vj cc0 cA csb cB cmul co vk csu vj cc0 cA csb vk cc0 cB
      csb cmul co wceq vj cc0 cA csb vk cc0 cB csb cmul oprex 0z vm vj cc0 cA
      csb cB cmul co vj cc0 cA csb vk cc0 cB csb cmul co cvv vk cc0 vk vm vj
      cc0 cA csb vk cc0 cB csb cmul vm cv vj cc0 cA csb wcel vk ax-17 vm cv
      cmul wcel vk ax-17 cc0 cz wcel vm cv vk cc0 cB csb wcel vm cv vk cc0 cB
      csb wcel vk wal wi 0z vk vm cc0 cB cz vm cv cc0 wcel vk ax-17 hbcsb1g
      ax-mp hbopr vk cv cc0 wceq cB vk cc0 cB csb vj cc0 cA csb cmul vk cc0 cB
      csbeq1a opreq2d fsum1fi mp2an eqtri 3eqtr4ri a1i vm cv cc0 wceq cA cc
      wcel vj cc0 vm cv cfz co wral cB cc wcel vk cc0 vm cv cfz co wral wa cA
      cc wcel vj cc0 cc0 cfz co wral cB cc wcel vk cc0 cc0 cfz co wral wa cc0
      vm cv cfz co cc0 vm cv vj cv cmin co cfz co cA cB cmul co vk csu vj csu
      cc0 vm cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul
      co vj csu vk csu wceq cc0 cc0 cfz co cc0 cc0 vj cv cmin co cfz co cA cB
      cmul co vk csu vj csu cc0 cc0 cfz co cc0 vk cv cfz co cA vk vk cv vj cv
      cmin co cB csb cmul co vj csu vk csu wceq vm cv cc0 wceq cA cc wcel vj
      cc0 vm cv cfz co wral cA cc wcel vj cc0 cc0 cfz co wral cB cc wcel vk cc0
      vm cv cfz co wral cB cc wcel vk cc0 cc0 cfz co wral vm cv cc0 wceq cA cc
      wcel vj cc0 vm cv cfz co cc0 cc0 cfz co vm cv cc0 cc0 cfz opreq2 raleq1d
      vm cv cc0 wceq cB cc wcel vk cc0 vm cv cfz co cc0 cc0 cfz co vm cv cc0
      cc0 cfz opreq2 raleq1d anbi12d vm cv cc0 wceq cc0 vm cv cfz co cc0 vm cv
      vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 cc0 cfz co cc0 cc0
      vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vm cv cfz co cc0 vk
      cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu cc0 cc0
      cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu
      vk csu vm cv cc0 wceq cc0 vm cv cfz co cc0 cc0 cfz co cc0 vm cv vj cv
      cmin co cfz co cA cB cmul co vk csu cc0 cc0 vj cv cmin co cfz co cA cB
      cmul co vk csu vj vm cv cc0 cc0 cfz opreq2 vm cv cc0 wceq cc0 vm cv vj cv
      cmin co cfz co cA cB cmul co vk csu cc0 cc0 vj cv cmin co cfz co cA cB
      cmul co vk csu wceq vj cv cc0 vm cv cfz co wcel vm cv cc0 wceq cc0 vm cv
      vj cv cmin co cfz co cc0 cc0 vj cv cmin co cfz co cA cB cmul co vk vm cv
      cc0 wceq vm cv vj cv cmin co cc0 vj cv cmin co cc0 cfz vm cv cc0 vj cv
      cmin opreq1 opreq2d sumeq1d adantr sumeq12dv vm cv cc0 wceq cc0 vm cv cfz
      co cc0 cc0 cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul
      co vj csu vk vm cv cc0 cc0 cfz opreq2 sumeq1d eqeq12d imbi12d vm cv vn cv
      wceq cA cc wcel vj cc0 vm cv cfz co wral cB cc wcel vk cc0 vm cv cfz co
      wral wa cA cc wcel vj cc0 vn cv cfz co wral cB cc wcel vk cc0 vn cv cfz
      co wral wa cc0 vm cv cfz co cc0 vm cv vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vm cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co
      cB csb cmul co vj csu vk csu wceq cc0 vn cv cfz co cc0 vn cv vj cv cmin
      co cfz co cA cB cmul co vk csu vj csu cc0 vn cv cfz co cc0 vk cv cfz co
      cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq vm cv vn cv
      wceq cA cc wcel vj cc0 vm cv cfz co wral cA cc wcel vj cc0 vn cv cfz co
      wral cB cc wcel vk cc0 vm cv cfz co wral cB cc wcel vk cc0 vn cv cfz co
      wral vm cv vn cv wceq cA cc wcel vj cc0 vm cv cfz co cc0 vn cv cfz co vm
      cv vn cv cc0 cfz opreq2 raleq1d vm cv vn cv wceq cB cc wcel vk cc0 vm cv
      cfz co cc0 vn cv cfz co vm cv vn cv cc0 cfz opreq2 raleq1d anbi12d vm cv
      vn cv wceq cc0 vm cv cfz co cc0 vm cv vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vn cv cfz co cc0 vn cv vj cv cmin co cfz co cA cB cmul
      co vk csu vj csu cc0 vm cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin
      co cB csb cmul co vj csu vk csu cc0 vn cv cfz co cc0 vk cv cfz co cA vk
      vk cv vj cv cmin co cB csb cmul co vj csu vk csu vm cv vn cv wceq cc0 vm
      cv cfz co cc0 vn cv cfz co cc0 vm cv vj cv cmin co cfz co cA cB cmul co
      vk csu cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu vj vm cv vn cv
      cc0 cfz opreq2 vm cv vn cv wceq cc0 vm cv vj cv cmin co cfz co cA cB cmul
      co vk csu cc0 vn cv vj cv cmin co cfz co cA cB cmul co vk csu wceq vj cv
      cc0 vm cv cfz co wcel vm cv vn cv wceq cc0 vm cv vj cv cmin co cfz co cc0
      vn cv vj cv cmin co cfz co cA cB cmul co vk vm cv vn cv wceq vm cv vj cv
      cmin co vn cv vj cv cmin co cc0 cfz vm cv vn cv vj cv cmin opreq1 opreq2d
      sumeq1d adantr sumeq12dv vm cv vn cv wceq cc0 vm cv cfz co cc0 vn cv cfz
      co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk vm
      cv vn cv cc0 cfz opreq2 sumeq1d eqeq12d imbi12d vm cv vn cv c1 caddc co
      wceq cA cc wcel vj cc0 vm cv cfz co wral cB cc wcel vk cc0 vm cv cfz co
      wral wa cA cc wcel vj cc0 vn cv c1 caddc co cfz co wral cB cc wcel vk cc0
      vn cv c1 caddc co cfz co wral wa cc0 vm cv cfz co cc0 vm cv vj cv cmin co
      cfz co cA cB cmul co vk csu vj csu cc0 vm cv cfz co cc0 vk cv cfz co cA
      vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq cc0 vn cv c1
      caddc co cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co
      vk csu vj csu cc0 vn cv c1 caddc co cfz co cc0 vk cv cfz co cA vk vk cv
      vj cv cmin co cB csb cmul co vj csu vk csu wceq vm cv vn cv c1 caddc co
      wceq cA cc wcel vj cc0 vm cv cfz co wral cA cc wcel vj cc0 vn cv c1 caddc
      co cfz co wral cB cc wcel vk cc0 vm cv cfz co wral cB cc wcel vk cc0 vn
      cv c1 caddc co cfz co wral vm cv vn cv c1 caddc co wceq cA cc wcel vj cc0
      vm cv cfz co cc0 vn cv c1 caddc co cfz co vm cv vn cv c1 caddc co cc0 cfz
      opreq2 raleq1d vm cv vn cv c1 caddc co wceq cB cc wcel vk cc0 vm cv cfz
      co cc0 vn cv c1 caddc co cfz co vm cv vn cv c1 caddc co cc0 cfz opreq2
      raleq1d anbi12d vm cv vn cv c1 caddc co wceq cc0 vm cv cfz co cc0 vm cv
      vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 vn cv c1 caddc co
      cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cc0 vm cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb
      cmul co vj csu vk csu cc0 vn cv c1 caddc co cfz co cc0 vk cv cfz co cA vk
      vk cv vj cv cmin co cB csb cmul co vj csu vk csu vm cv vn cv c1 caddc co
      wceq cc0 vm cv cfz co cc0 vn cv c1 caddc co cfz co cc0 vm cv vj cv cmin
      co cfz co cA cB cmul co vk csu cc0 vn cv c1 caddc co vj cv cmin co cfz co
      cA cB cmul co vk csu vj vm cv vn cv c1 caddc co cc0 cfz opreq2 vm cv vn
      cv c1 caddc co wceq cc0 vm cv vj cv cmin co cfz co cA cB cmul co vk csu
      cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co vk csu wceq vj
      cv cc0 vm cv cfz co wcel vm cv vn cv c1 caddc co wceq cc0 vm cv vj cv
      cmin co cfz co cc0 vn cv c1 caddc co vj cv cmin co cfz co cA cB cmul co
      vk vm cv vn cv c1 caddc co wceq vm cv vj cv cmin co vn cv c1 caddc co vj
      cv cmin co cc0 cfz vm cv vn cv c1 caddc co vj cv cmin opreq1 opreq2d
      sumeq1d adantr sumeq12dv vm cv vn cv c1 caddc co wceq cc0 vm cv cfz co
      cc0 vn cv c1 caddc co cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co
      cB csb cmul co vj csu vk vm cv vn cv c1 caddc co cc0 cfz opreq2 sumeq1d
      eqeq12d imbi12d vm cv cN wceq cA cc wcel vj cc0 vm cv cfz co wral cB cc
      wcel vk cc0 vm cv cfz co wral wa cA cc wcel vj cc0 cN cfz co wral cB cc
      wcel vk cc0 cN cfz co wral wa cc0 vm cv cfz co cc0 vm cv vj cv cmin co
      cfz co cA cB cmul co vk csu vj csu cc0 vm cv cfz co cc0 vk cv cfz co cA
      vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq cc0 cN cfz co
      cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0 cN cfz co cc0
      vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj csu vk csu wceq
      vm cv cN wceq cA cc wcel vj cc0 vm cv cfz co wral cA cc wcel vj cc0 cN
      cfz co wral cB cc wcel vk cc0 vm cv cfz co wral cB cc wcel vk cc0 cN cfz
      co wral vm cv cN wceq cA cc wcel vj cc0 vm cv cfz co cc0 cN cfz co vm cv
      cN cc0 cfz opreq2 raleq1d vm cv cN wceq cB cc wcel vk cc0 vm cv cfz co
      cc0 cN cfz co vm cv cN cc0 cfz opreq2 raleq1d anbi12d vm cv cN wceq cc0
      vm cv cfz co cc0 vm cv vj cv cmin co cfz co cA cB cmul co vk csu vj csu
      cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu vj csu cc0
      vm cv cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb cmul co vj
      csu vk csu cc0 cN cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB
      csb cmul co vj csu vk csu vm cv cN wceq cc0 vm cv cfz co cc0 cN cfz co
      cc0 vm cv vj cv cmin co cfz co cA cB cmul co vk csu cc0 cN vj cv cmin co
      cfz co cA cB cmul co vk csu vj vm cv cN cc0 cfz opreq2 vm cv cN wceq cc0
      vm cv vj cv cmin co cfz co cA cB cmul co vk csu cc0 cN vj cv cmin co cfz
      co cA cB cmul co vk csu wceq vj cv cc0 vm cv cfz co wcel vm cv cN wceq
      cc0 vm cv vj cv cmin co cfz co cc0 cN vj cv cmin co cfz co cA cB cmul co
      vk vm cv cN wceq vm cv vj cv cmin co cN vj cv cmin co cc0 cfz vm cv cN vj
      cv cmin opreq1 opreq2d sumeq1d adantr sumeq12dv vm cv cN wceq cc0 vm cv
      cfz co cc0 cN cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb
      cmul co vj csu vk vm cv cN cc0 cfz opreq2 sumeq1d eqeq12d imbi12d
      nn0indALT 3impib $.
      $( [8-Feb-2006] $) $( [31-Dec-2005] $)

    $( Two ways to express "the sum of ` A ( j ) x. B ( k ) ` where
       ` j + k <_ N ` ." $)
    fsum0diag2 $p |- ( ( N e. NN0 /\
      A. j e. ( 0 ...  N ) A e. CC /\ A. k e. ( 0 ... N ) B e. CC ) ->
       sum_ j e. ( 0 ...  N ) sum_ k e. ( 0 ... ( N - j ) ) ( A x. B ) =
  sum_ j e. ( 0 ...  N ) sum_ k e. ( 0 ... j ) ( [_ ( j - k ) / j ]_ A x. B )
          ) $=
      cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co
      wral w3a cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu
      vj csu cc0 cN cfz co cc0 vk cv cfz co cA vk vk cv vj cv cmin co cB csb
      cmul co vj csu vk csu cc0 cN cfz co cc0 vj cv cfz co vj vj cv vk cv cmin
      co cA csb cB cmul co vk csu vj csu cA cB vj vk cN fsum0diag cN cn0 wcel
      cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral w3a cc0
      cN cfz co cc0 vm cv cfz co cA vk vm cv vj cv cmin co cB csb cmul co vj
      csu vm csu cc0 cN cfz co cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb
      cB cmul co vk csu vm csu cc0 cN cfz co cc0 vk cv cfz co cA vk vk cv vj cv
      cmin co cB csb cmul co vj csu vk csu cc0 cN cfz co cc0 vj cv cfz co vj vj
      cv vk cv cmin co cA csb cB cmul co vk csu vj csu cN cn0 wcel cA cc wcel
      vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral w3a cc0 cN cfz co
      cc0 vm cv cfz co cA vk vm cv vj cv cmin co cB csb cmul co vj csu cc0 vm
      cv cfz co vj vm cv vk cv cmin co cA csb cB cmul co vk csu vm cN cn0 wcel
      cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral w3a cc0
      vm cv cfz co cA vk vm cv vj cv cmin co cB csb cmul co vj csu cc0 vm cv
      cfz co vj vm cv vk cv cmin co cA csb cB cmul co vk csu wceq vm cc0 cN cfz
      co cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz
      co wral vm cv cc0 cN cfz co wcel cc0 vm cv cfz co cA vk vm cv vj cv cmin
      co cB csb cmul co vj csu cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb
      cB cmul co vk csu wceq wi cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB
      cc wcel vk cc0 cN cfz co wral wa wa vm cv cc0 cN cfz co wcel cc0 vm cv
      cfz co cA vk vm cv vj cv cmin co cB csb cmul co vj csu cc0 vm cv cfz co
      vj vm cv vk cv cmin co cA csb cB cmul co vk csu wceq cN cn0 wcel cA cc
      wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral wa wa vm cv
      cc0 cN cfz co wcel wa cc0 vm cv cfz co cA vk vm cv vj cv cmin co cB csb
      cmul co vj csu cc0 vm cv cfz co vj vm cv vn cv cmin co cA csb vk vn cv cB
      csb cmul co vn csu cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB cmul
      co vk csu cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0
      cN cfz co wral wa wa vm cv cc0 cN cfz co wcel wa cc0 vm cv cfz co cA vk
      vm cv vj cv cmin co cB csb cmul co vj csu vm cv vm cv cmin co vm cv cc0
      cmin co cfz co vj vm cv vn cv cmin co cA vk vm cv vj cv cmin co cB csb
      cmul co csb vn csu cc0 vm cv cfz co vj vm cv vn cv cmin co cA csb vk vn
      cv cB csb cmul co vn csu vm cv cc0 cuz cfv wcel vm cv cz wcel cA vk vm cv
      vj cv cmin co cB csb cmul co cc wcel vj cc0 vm cv cfz co wral cc0 vm cv
      cfz co cA vk vm cv vj cv cmin co cB csb cmul co vj csu vm cv vm cv cmin
      co vm cv cc0 cmin co cfz co vj vm cv vn cv cmin co cA vk vm cv vj cv cmin
      co cB csb cmul co csb vn csu wceq cN cn0 wcel cA cc wcel vj cc0 cN cfz co
      wral cB cc wcel vk cc0 cN cfz co wral wa wa vm cv cc0 cN cfz co wcel wa
      cA vk vm cv vj cv cmin co cB csb cmul co vj vn vm cv cc0 vm cv fsumrev vm
      cv cc0 cN cfz co wcel vm cv cc0 cuz cfv wcel cN cn0 wcel cA cc wcel vj
      cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral wa wa vm cv cc0 cN
      elfzuz adantl vm cv cc0 cN cfz co wcel vm cv cz wcel cN cn0 wcel cA cc
      wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral wa wa vm cv
      cc0 cN elfzelz adantl cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc
      wcel vk cc0 cN cfz co wral vm cv cc0 cN cfz co wcel cA vk vm cv vj cv
      cmin co cB csb cmul co cc wcel vj cc0 vm cv cfz co wral cN cn0 wcel vm cv
      cc0 cN cfz co wcel cB cc wcel vk cc0 cN cfz co wral cA cc wcel vj cc0 cN
      cfz co wral cA vk vm cv vj cv cmin co cB csb cmul co cc wcel vj cc0 vm cv
      cfz co wral cN cn0 wcel vm cv cc0 cN cfz co wcel cB cc wcel vk cc0 cN cfz
      co wral cA cc wcel vj cc0 cN cfz co wral cA vk vm cv vj cv cmin co cB csb
      cmul co cc wcel vj cc0 vm cv cfz co wral wi cN cn0 wcel vm cv cc0 cN cfz
      co wcel wa cB cc wcel vk cc0 cN cfz co wral wa cA cc wcel cA vk vm cv vj
      cv cmin co cB csb cmul co cc wcel vj cc0 cN cfz co cc0 vm cv cfz co cN
      cn0 wcel vm cv cc0 cN cfz co wcel wa cB cc wcel vk cc0 cN cfz co wral wa
      vj cv cc0 cN cfz co wcel cA cc wcel wi vj cv cc0 vm cv cfz co wcel cA cc
      wcel wi vj cv cc0 vm cv cfz co wcel cA vk vm cv vj cv cmin co cB csb cmul
      co cc wcel wi cN cn0 wcel vm cv cc0 cN cfz co wcel wa vj cv cc0 cN cfz co
      wcel cA cc wcel wi vj cv cc0 vm cv cfz co wcel cA cc wcel wi wi cB cc
      wcel vk cc0 cN cfz co wral cN cn0 wcel vm cv cc0 cN cfz co wcel wa vj cv
      cc0 vm cv cfz co wcel vj cv cc0 cN cfz co wcel cA cc wcel cN cn0 wcel vm
      cv cc0 cN cfz co wcel wa cc0 vm cv cfz co cc0 cN cfz co vj cv cN vm cv
      cuz cfv wcel cc0 cz wcel cc0 vm cv cfz co cc0 cN cfz co wss cN cn0 wcel
      vm cv cc0 cN cfz co wcel wa vm cv cc0 cN fzss2 cn0 vm cv cc0 cN elfzuz3
      0z sylancl sseld imim1d adantr cN cn0 wcel vm cv cc0 cN cfz co wcel wa cB
      cc wcel vk cc0 cN cfz co wral wa vj cv cc0 vm cv cfz co wcel cA cc wcel
      cA vk vm cv vj cv cmin co cB csb cmul co cc wcel cA cc wcel cN cn0 wcel
      vm cv cc0 cN cfz co wcel wa cB cc wcel vk cc0 cN cfz co wral wa vj cv cc0
      vm cv cfz co wcel cA vk vm cv vj cv cmin co cB csb cmul co cc wcel cA cc
      wcel cN cn0 wcel vm cv cc0 cN cfz co wcel wa cB cc wcel vk cc0 cN cfz co
      wral wa vj cv cc0 vm cv cfz co wcel cA vk vm cv vj cv cmin co cB csb cmul
      co cc wcel cA cc wcel vk vm cv vj cv cmin co cB csb cc wcel cA vk vm cv
      vj cv cmin co cB csb cmul co cc wcel cN cn0 wcel vm cv cc0 cN cfz co wcel
      wa cB cc wcel vk cc0 cN cfz co wral wa vj cv cc0 vm cv cfz co wcel wa cA
      vk vm cv vj cv cmin co cB csb mulcl cN cn0 wcel vm cv cc0 cN cfz co wcel
      wa vj cv cc0 vm cv cfz co wcel cB cc wcel vk cc0 cN cfz co wral vk vm cv
      vj cv cmin co cB csb cc wcel vm cv vj cv cmin co cc0 cN cfz co wcel cB cc
      wcel vk cc0 cN cfz co wral vk vm cv vj cv cmin co cB csb cc wcel cN cn0
      wcel vm cv cc0 cN cfz co wcel wa vj cv cc0 vm cv cfz co wcel wa vk vm cv
      vj cv cmin co cc0 cN cfz co cB cc ra4csbela cN cn0 wcel vm cv cc0 cN cfz
      co wcel wa vj cv cc0 vm cv cfz co wcel wa cc0 vm cv cfz co cc0 cN cfz co
      vm cv vj cv cmin co cN cn0 wcel vm cv cc0 cN cfz co wcel wa cc0 vm cv cfz
      co cc0 cN cfz co wss vj cv cc0 vm cv cfz co wcel cN vm cv cuz cfv wcel
      cc0 cz wcel cc0 vm cv cfz co cc0 cN cfz co wss cN cn0 wcel vm cv cc0 cN
      cfz co wcel wa vm cv cc0 cN fzss2 cn0 vm cv cc0 cN elfzuz3 0z sylancl
      adantr vj cv cc0 vm cv cfz co wcel vm cv vj cv cmin co cc0 vm cv cfz co
      wcel cN cn0 wcel vm cv cc0 cN cfz co wcel wa vm cv cvv wcel vj cv cc0 vm
      cv cfz co wcel vm cv vj cv cmin co cc0 vm cv cfz co wcel vm visset cvv vj
      cv vm cv fznn0sub2 mpan adantl sseldd sylan an1rs sylan2 exp32 com3l a2d
      syld r19.20dv2 exp31 com24 imp42 syl3anc cN cn0 wcel vm cv cc0 cN cfz co
      wcel vm cv vm cv cmin co vm cv cc0 cmin co cfz co vj vm cv vn cv cmin co
      cA vk vm cv vj cv cmin co cB csb cmul co csb vn csu cc0 vm cv cfz co vj
      vm cv vn cv cmin co cA csb vk vn cv cB csb cmul co vn csu wceq cA cc wcel
      vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral wa cN cn0 wcel vm
      cv cc0 cN cfz co wcel wa vm cv vm cv cmin co vm cv cc0 cmin co cfz co cc0
      vm cv cfz co vj vm cv vn cv cmin co cA vk vm cv vj cv cmin co cB csb cmul
      co csb vj vm cv vn cv cmin co cA csb vk vn cv cB csb cmul co vn vm cv cc0
      cN cfz co wcel vm cv vm cv cmin co vm cv cc0 cmin co cfz co cc0 vm cv cfz
      co wceq cN cn0 wcel vm cv cc0 cN cfz co wcel vm cv cc wcel vm cv vm cv
      cmin co vm cv cc0 cmin co cfz co cc0 vm cv cfz co wceq vm cv cc0 cN cfz
      co wcel vm cv cz wcel vm cv cc wcel vm cv cc0 cN elfzelz vm cv zcn syl vm
      cv cc wcel vm cv vm cv cmin co cc0 vm cv cc0 cmin co vm cv cfz vm cv
      subid vm cv subid1 opreq12d syl adantl cN cn0 wcel vm cv cc0 cN cfz co
      wcel wa vn cv cc0 vm cv cfz co wcel wa vj vm cv vn cv cmin co cA csb vk
      vm cv vm cv vn cv cmin co cmin co cB csb cmul co vj vm cv vn cv cmin co
      cA csb vk vn cv cB csb cmul co vj vm cv vn cv cmin co cA vk vm cv vj cv
      cmin co cB csb cmul co csb vn cv cc0 vm cv cfz co wcel vj vm cv vn cv
      cmin co cA csb vk vm cv vm cv vn cv cmin co cmin co cB csb cmul co vj vm
      cv vn cv cmin co cA csb vk vn cv cB csb cmul co wceq cN cn0 wcel vm cv
      cc0 cN cfz co wcel wa vn cv cc0 vm cv cfz co wcel vk vm cv vm cv vn cv
      cmin co cmin co cB csb vk vn cv cB csb vj vm cv vn cv cmin co cA csb cmul
      vn cv cc0 vm cv cfz co wcel vk vm cv vm cv vn cv cmin co cmin co vn cv cB
      vm cv cc wcel vn cv cc wcel vm cv vm cv vn cv cmin co cmin co vn cv wceq
      vn cv cc0 vm cv cfz co wcel vm cv vn cv nncan vn cv cc0 vm cv cfz co wcel
      vm cv cz wcel vm cv cc wcel vn cv cc0 vm cv vm visset elfzel2i vm cv zcn
      syl vn cv cc0 vm cv cfz co wcel vn cv cz wcel vn cv cc wcel vn cv cc0 vm
      cv elfzelz vn cv zcn syl sylanc csbeq1d opreq2d adantl vj vm cv vn cv
      cmin co cA vk vm cv vj cv cmin co cB csb cmul co csb vj vm cv vn cv cmin
      co cA csb vj vm cv vn cv cmin co vk vm cv vj cv cmin co cB csb csb cmul
      co vj vm cv vn cv cmin co cA csb vk vm cv vm cv vn cv cmin co cmin co cB
      csb cmul co vm cv vn cv cmin co cvv wcel vj vm cv vn cv cmin co cA vk vm
      cv vj cv cmin co cB csb cmul co csb vj vm cv vn cv cmin co cA csb vj vm
      cv vn cv cmin co vk vm cv vj cv cmin co cB csb csb cmul co wceq vm cv vn
      cv cmin oprex vj vm cv vn cv cmin co cA vk vm cv vj cv cmin co cB csb cvv
      cmul csbopr12g ax-mp vj vm cv vn cv cmin co vk vm cv vj cv cmin co cB csb
      csb vk vm cv vm cv vn cv cmin co cmin co cB csb vj vm cv vn cv cmin co cA
      csb cmul vm cv vn cv cmin co cvv wcel vm cv vj cv cmin co cvv wcel vj wal
      vj vm cv vn cv cmin co vk vm cv vj cv cmin co cB csb csb vk vm cv vm cv
      vn cv cmin co cmin co cB csb wceq vm cv vn cv cmin oprex vm cv vj cv cmin
      co cvv wcel vj vm cv vj cv cmin oprex ax-gen vj vk vm cv vn cv cmin co vm
      cv vj cv cmin co cB vm cv vm cv vn cv cmin co cmin co cvv cvv vj cv vm cv
      vn cv cmin co vm cv cmin opreq2 csbco3g mp2an opreq2i eqtri syl5eq
      sumeq12rdv adantlr eqtrd vx cc0 vm cv cfz co vj vm cv vk cv cmin co cA
      csb cB cmul co vj vm cv vn cv cmin co cA csb vk vn cv cB csb cmul co vk
      vn vx cv vj vm cv vk cv cmin co cA csb cB cmul co wcel vn ax-17 vk vx vj
      vm cv vn cv cmin co cA csb vk vn cv cB csb cmul vx cv vj vm cv vn cv cmin
      co cA csb wcel vk ax-17 vx cv cmul wcel vk ax-17 vk vx vn cv cB vn visset
      vx cv vn cv wcel vk ax-17 hbcsb1 hbopr vk cv vn cv wceq vj vm cv vk cv
      cmin co cA csb vj vm cv vn cv cmin co cA csb cB vk vn cv cB csb cmul vk
      cv vn cv wceq vj vm cv vk cv cmin co vm cv vn cv cmin co cA vk cv vn cv
      vm cv cmin opreq2 csbeq1d vk vn cv cB csbeq1a opreq12d cbvsumi syl6eqr ex
      3impb r19.21aiv sumeq2d vx cc0 cN cfz co cc0 vk cv cfz co cA vk vk cv vj
      cv cmin co cB csb cmul co vj csu cc0 vm cv cfz co cA vk vm cv vj cv cmin
      co cB csb cmul co vj csu vk vm vx cv cc0 vk cv cfz co cA vk vk cv vj cv
      cmin co cB csb cmul co vj csu wcel vm ax-17 vk vx cc0 vm cv cfz co cA vk
      vm cv vj cv cmin co cB csb cmul co vj vx cv cc0 vm cv cfz co wcel vk
      ax-17 vk vx cA vk vm cv vj cv cmin co cB csb cmul vx cv cA wcel vk ax-17
      vx cv cmul wcel vk ax-17 vk vx vm cv vj cv cmin co cB vm cv vj cv cmin
      oprex vx cv vm cv vj cv cmin co wcel vk ax-17 hbcsb1 hbopr hbsum vk cv vm
      cv wceq cc0 vk cv cfz co cc0 vm cv cfz co cA vk vk cv vj cv cmin co cB
      csb cmul co cA vk vm cv vj cv cmin co cB csb cmul co vj vk cv vm cv cc0
      cfz opreq2 vk cv vm cv wceq cA vk vk cv vj cv cmin co cB csb cmul co cA
      vk vm cv vj cv cmin co cB csb cmul co wceq vj cv cc0 vm cv cfz co wcel vk
      cv vm cv wceq vk vk cv vj cv cmin co cB csb vk vm cv vj cv cmin co cB csb
      cA cmul vk cv vm cv wceq vk vk cv vj cv cmin co vm cv vj cv cmin co cB vk
      cv vm cv vj cv cmin opreq1 csbeq1d opreq2d adantr sumeq12rdv cbvsumi vx
      cc0 cN cfz co cc0 vj cv cfz co vj vj cv vk cv cmin co cA csb cB cmul co
      vk csu cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB cmul co vk csu
      vj vm vx cv cc0 vj cv cfz co vj vj cv vk cv cmin co cA csb cB cmul co vk
      csu wcel vm ax-17 vj vx cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB
      cmul co vk vx cv cc0 vm cv cfz co wcel vj ax-17 vj vx vj vm cv vk cv cmin
      co cA csb cB cmul vj vx vm cv vk cv cmin co cA vm cv vk cv cmin oprex vx
      cv vm cv vk cv cmin co wcel vj ax-17 hbcsb1 vx cv cmul wcel vj ax-17 vx
      cv cB wcel vj ax-17 hbopr hbsum vj cv vm cv wceq cc0 vj cv cfz co cc0 vm
      cv cfz co vj vj cv vk cv cmin co cA csb cB cmul co vj vm cv vk cv cmin co
      cA csb cB cmul co vk vj cv vm cv cc0 cfz opreq2 vj cv vm cv wceq vj vj cv
      vk cv cmin co cA csb cB cmul co vj vm cv vk cv cmin co cA csb cB cmul co
      wceq vk cv cc0 vm cv cfz co wcel vj cv vm cv wceq vj vj cv vk cv cmin co
      cA csb vj vm cv vk cv cmin co cA csb cB cmul vj cv vm cv wceq vj vj cv vk
      cv cmin co vm cv vk cv cmin co cA vj cv vm cv vk cv cmin opreq1 csbeq1d
      opreq1d adantr sumeq12rdv cbvsumi 3eqtr4g eqtrd $.
      $( [14-Feb-2006] $) $( [31-Dec-2005] $)

    $( Two ways to express "the sum of ` A ( j ) x. B ( k ) ` where
       ` j + k <_ N ` ." $)
    fsum0diag3 $p |- ( ( N e. NN0 /\
      A. j e. ( 0 ...  N ) A e. CC /\ A. k e. ( 0 ... N ) B e. CC ) ->
       sum_ j e. ( 0 ...  N ) sum_ k e. ( 0 ... ( N - j ) ) ( A x. B ) =
         sum_ j e. ( 0 ...  N ) ( A x. sum_ k e. ( 0 ... ( N - j ) ) B ) ) $=
      cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co
      wral w3a cc0 cN cfz co cA cc0 cN vj cv cmin co cfz co cB vk csu cmul co
      vj csu cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu vj
      csu cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz
      co wral w3a cc0 cN cfz co cA cc0 cN vj cv cmin co cfz co cB vk csu cmul
      co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu vj cN cn0 wcel cA cc
      wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co wral cA cc0 cN vj
      cv cmin co cfz co cB vk csu cmul co cc0 cN vj cv cmin co cfz co cA cB
      cmul co vk csu wceq vj cc0 cN cfz co wral cN cn0 wcel cB cc wcel vk cc0
      cN cfz co wral cA cc wcel vj cc0 cN cfz co wral cA cc0 cN vj cv cmin co
      cfz co cB vk csu cmul co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu
      wceq vj cc0 cN cfz co wral cN cn0 wcel cB cc wcel vk cc0 cN cfz co wral
      cA cc wcel vj cc0 cN cfz co wral cA cc0 cN vj cv cmin co cfz co cB vk csu
      cmul co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu wceq vj cc0 cN
      cfz co wral wi cN cn0 wcel cB cc wcel vk cc0 cN cfz co wral wa cA cc wcel
      cA cc0 cN vj cv cmin co cfz co cB vk csu cmul co cc0 cN vj cv cmin co cfz
      co cA cB cmul co vk csu wceq vj cc0 cN cfz co cN cn0 wcel cB cc wcel vk
      cc0 cN cfz co wral wa vj cv cc0 cN cfz co wcel wa cA cc wcel cA cc0 cN vj
      cv cmin co cfz co cB vk csu cmul co cc0 cN vj cv cmin co cfz co cA cB
      cmul co vk csu wceq cN vj cv cmin co cc0 cuz cfv wcel cA cc wcel cB cc
      wcel vk cc0 cN vj cv cmin co cfz co wral cA cc0 cN vj cv cmin co cfz co
      cB vk csu cmul co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu wceq
      cN cn0 wcel cB cc wcel vk cc0 cN cfz co wral wa vj cv cc0 cN cfz co wcel
      wa cA cc wcel wa cB cA vk cc0 cN vj cv cmin co fsummulc1 cN cn0 wcel vj
      cv cc0 cN cfz co wcel cA cc wcel cN vj cv cmin co cc0 cuz cfv wcel cB cc
      wcel vk cc0 cN cfz co wral cN cn0 wcel vj cv cc0 cN cfz co wcel wa cN vj
      cv cmin co cc0 cuz cfv wcel cA cc wcel cN cn0 wcel vj cv cc0 cN cfz co
      wcel wa cN vj cv cmin co cn0 cc0 cuz cfv cn0 vj cv cc0 cN fznn0sub nn0uz
      syl6eleq adantr adantllr cN cn0 wcel cB cc wcel vk cc0 cN cfz co wral wa
      vj cv cc0 cN cfz co wcel wa cA cc wcel pm3.27 cN cn0 wcel cB cc wcel vk
      cc0 cN cfz co wral wa vj cv cc0 cN cfz co wcel wa cB cc wcel vk cc0 cN vj
      cv cmin co cfz co wral cA cc wcel cN cn0 wcel vj cv cc0 cN cfz co wcel cB
      cc wcel vk cc0 cN cfz co wral cB cc wcel vk cc0 cN vj cv cmin co cfz co
      wral cN cn0 wcel vj cv cc0 cN cfz co wcel wa cB cc wcel vk cc0 cN cfz co
      wral cB cc wcel vk cc0 cN vj cv cmin co cfz co wral cN cn0 wcel vj cv cc0
      cN cfz co wcel wa cB cc wcel cB cc wcel vk cc0 cN cfz co cc0 cN vj cv
      cmin co cfz co cN cn0 wcel vj cv cc0 cN cfz co wcel wa vk cv cc0 cN vj cv
      cmin co cfz co wcel vk cv cc0 cN cfz co wcel cB cc wcel cN cn0 wcel vj cv
      cc0 cN cfz co wcel wa cc0 cN vj cv cmin co cfz co cc0 cN cfz co vk cv cn0
      vj cv cN fsum0diaglem1 sseld imim1d r19.20dv2 imp an1rs adantr syl3anc ex
      r19.20dva ex com23 3imp sumeq2d eqcomd $.
      $( [18-Oct-2006] $) $( [31-Dec-2005] $)

    $( Two ways to express "the sum of ` A ( j ) x. B ( k ) ` where
       ` j + k <_ N ` ." $)
    fsum0diag4 $p |- ( ( N e. NN0 /\
      A. j e. ( 0 ...  N ) A e. CC /\ A. k e. ( 0 ... N ) B e. CC ) ->
       sum_ j e. ( 0 ...  N ) sum_ k e. ( 0 ... ( N - j ) ) ( A x. B ) =
          sum_ k e. ( 0 ...  N ) ( B x. sum_ j e. ( 0 ... ( N - k ) ) A ) ) $=
      cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co
      wral w3a cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA cB cmul co vk csu
      vj csu cc0 cN cfz co cc0 cN vk cv cmin co cfz co cB cA cmul co vj csu vk
      csu cc0 cN cfz co cB cc0 cN vk cv cmin co cfz co cA vj csu cmul co vk csu
      cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN cfz co
      wral w3a cc0 cN cfz co cc0 vj cv cfz co vj vj cv vk cv cmin co cA csb cB
      cmul co vk csu vj csu cc0 cN cfz co cc0 vj cv cfz co cB vj vj cv vk cv
      cmin co cA csb cmul co vk csu vj csu cc0 cN cfz co cc0 cN vj cv cmin co
      cfz co cA cB cmul co vk csu vj csu cc0 cN cfz co cc0 cN vk cv cmin co cfz
      co cB cA cmul co vj csu vk csu cN cn0 wcel cA cc wcel vj cc0 cN cfz co
      wral cB cc wcel vk cc0 cN cfz co wral w3a cc0 cN cfz co cc0 vj cv cfz co
      vj vj cv vk cv cmin co cA csb cB cmul co vk csu cc0 vj cv cfz co cB vj vj
      cv vk cv cmin co cA csb cmul co vk csu vj cN cn0 wcel cA cc wcel vj cc0
      cN cfz co wral cB cc wcel vk cc0 cN cfz co wral w3a cc0 vm cv cfz co vj
      vm cv vk cv cmin co cA csb cB cmul co vk csu cc0 vm cv cfz co cB vj vm cv
      vk cv cmin co cA csb cmul co vk csu wceq vm cc0 cN cfz co wral cc0 vj cv
      cfz co vj vj cv vk cv cmin co cA csb cB cmul co vk csu cc0 vj cv cfz co
      cB vj vj cv vk cv cmin co cA csb cmul co vk csu wceq vj cc0 cN cfz co
      wral cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc wcel vk cc0 cN
      cfz co wral w3a cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB cmul co
      vk csu cc0 vm cv cfz co cB vj vm cv vk cv cmin co cA csb cmul co vk csu
      wceq vm cc0 cN cfz co cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral cB cc
      wcel vk cc0 cN cfz co wral vm cv cc0 cN cfz co wcel cc0 vm cv cfz co vj
      vm cv vk cv cmin co cA csb cB cmul co vk csu cc0 vm cv cfz co cB vj vm cv
      vk cv cmin co cA csb cmul co vk csu wceq wi cN cn0 wcel cA cc wcel vj cc0
      cN cfz co wral wa cB cc wcel vk cc0 cN cfz co wral wa vm cv cc0 cN cfz co
      wcel cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB cmul co vk csu cc0
      vm cv cfz co cB vj vm cv vk cv cmin co cA csb cmul co vk csu wceq cN cn0
      wcel cA cc wcel vj cc0 cN cfz co wral wa vm cv cc0 cN cfz co wcel cB cc
      wcel vk cc0 cN cfz co wral cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb
      cB cmul co vk csu cc0 vm cv cfz co cB vj vm cv vk cv cmin co cA csb cmul
      co vk csu wceq cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral wa vm cv cc0
      cN cfz co wcel wa cB cc wcel vk cc0 cN cfz co wral wa cc0 vm cv cfz co vj
      vm cv vk cv cmin co cA csb cB cmul co cB vj vm cv vk cv cmin co cA csb
      cmul co vk cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral wa vm cv cc0 cN
      cfz co wcel wa cB cc wcel vk cc0 cN cfz co wral vj vm cv vk cv cmin co cA
      csb cB cmul co cB vj vm cv vk cv cmin co cA csb cmul co wceq vk cc0 vm cv
      cfz co wral cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral wa vm cv cc0 cN
      cfz co wcel wa cB cc wcel vj vm cv vk cv cmin co cA csb cB cmul co cB vj
      vm cv vk cv cmin co cA csb cmul co wceq vk cc0 cN cfz co cc0 vm cv cfz co
      cN cn0 wcel cA cc wcel vj cc0 cN cfz co wral wa vm cv cc0 cN cfz co wcel
      wa vk cv cc0 cN cfz co wcel cB cc wcel wi vk cv cc0 vm cv cfz co wcel cB
      cc wcel wi vk cv cc0 vm cv cfz co wcel vj vm cv vk cv cmin co cA csb cB
      cmul co cB vj vm cv vk cv cmin co cA csb cmul co wceq wi cN cn0 wcel vm
      cv cc0 cN cfz co wcel vk cv cc0 cN cfz co wcel cB cc wcel wi vk cv cc0 vm
      cv cfz co wcel cB cc wcel wi wi cA cc wcel vj cc0 cN cfz co wral cN cn0
      wcel vm cv cc0 cN cfz co wcel wa vk cv cc0 vm cv cfz co wcel vk cv cc0 cN
      cfz co wcel cB cc wcel cN cn0 wcel vm cv cc0 cN cfz co wcel wa cc0 vm cv
      cfz co cc0 cN cfz co vk cv cN vm cv cuz cfv wcel cc0 cz wcel cc0 vm cv
      cfz co cc0 cN cfz co wss cN cn0 wcel vm cv cc0 cN cfz co wcel wa vm cv
      cc0 cN fzss2 cn0 vm cv cc0 cN elfzuz3 0z sylancl sseld imim1d adantlr cN
      cn0 wcel cA cc wcel vj cc0 cN cfz co wral wa vm cv cc0 cN cfz co wcel wa
      vk cv cc0 vm cv cfz co wcel cB cc wcel vj vm cv vk cv cmin co cA csb cB
      cmul co cB vj vm cv vk cv cmin co cA csb cmul co wceq cN cn0 wcel cA cc
      wcel vj cc0 cN cfz co wral wa vm cv cc0 cN cfz co wcel wa vk cv cc0 vm cv
      cfz co wcel cB cc wcel vj vm cv vk cv cmin co cA csb cB cmul co cB vj vm
      cv vk cv cmin co cA csb cmul co wceq vj vm cv vk cv cmin co cA csb cc
      wcel cB cc wcel vj vm cv vk cv cmin co cA csb cB cmul co cB vj vm cv vk
      cv cmin co cA csb cmul co wceq cN cn0 wcel cA cc wcel vj cc0 cN cfz co
      wral wa vm cv cc0 cN cfz co wcel wa vk cv cc0 vm cv cfz co wcel wa vj vm
      cv vk cv cmin co cA csb cB mulcom cN cn0 wcel cA cc wcel vj cc0 cN cfz co
      wral vm cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz co wcel vj vm cv vk cv
      cmin co cA csb cc wcel cN cn0 wcel vk cv cc0 vm cv cfz co wcel vm cv cc0
      cN cfz co wcel cA cc wcel vj cc0 cN cfz co wral vj vm cv vk cv cmin co cA
      csb cc wcel cN cn0 wcel vm cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz co
      wcel cA cc wcel vj cc0 cN cfz co wral vj vm cv vk cv cmin co cA csb cc
      wcel wi cN cn0 wcel vm cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz co wcel
      cA cc wcel vj cc0 cN cfz co wral vj vm cv vk cv cmin co cA csb cc wcel vm
      cv vk cv cmin co cc0 cN cfz co wcel cA cc wcel vj cc0 cN cfz co wral vj
      vm cv vk cv cmin co cA csb cc wcel cN cn0 wcel vm cv cc0 cN cfz co wcel
      wa vk cv cc0 vm cv cfz co wcel wa vj vm cv vk cv cmin co cc0 cN cfz co cA
      cc ra4csbela cN cn0 wcel vm cv cc0 cN cfz co wcel wa vk cv cc0 vm cv cfz
      co wcel wa vm cv vk cv cmin co cc0 cN cfz co wcel cc0 vm cv vk cv cmin co
      cle wbr vm cv vk cv cmin co cN cle wbr wa cN cn0 wcel vm cv cc0 cN cfz co
      wcel wa vk cv cc0 vm cv cfz co wcel wa cc0 vm cv vk cv cmin co cle wbr vm
      cv vk cv cmin co cN cle wbr vm cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz
      co wcel cc0 vm cv vk cv cmin co cle wbr cN cn0 wcel vm cv cc0 cN cfz co
      wcel vk cv cc0 vm cv cfz co wcel wa cc0 vm cv vk cv cmin co cle wbr vk cv
      vm cv cle wbr vk cv cc0 vm cv cfz co wcel vk cv vm cv cle wbr vm cv cc0
      cN cfz co wcel vk cv cc0 vm cv elfzle2 adantl vm cv cr wcel vk cv cr wcel
      cc0 vm cv vk cv cmin co cle wbr vk cv vm cv cle wbr wb vm cv cc0 cN cfz
      co wcel vk cv cc0 vm cv cfz co wcel vm cv vk cv subge0 vm cv cc0 cN cfz
      co wcel vm cv cz wcel vm cv cr wcel vm cv cc0 cN elfzelz vm cv zre syl vk
      cv cc0 vm cv cfz co wcel vk cv cz wcel vk cv cr wcel vk cv cc0 vm cv
      elfzelz vk cv zre syl syl2an mpbird adantll cN cn0 wcel vm cv cc0 cN cfz
      co wcel wa vk cv cc0 vm cv cfz co wcel wa vm cv vk cv cmin co vm cv cN vm
      cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz co wcel vm cv vk cv cmin co cr
      wcel cN cn0 wcel vm cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz co wcel wa
      vm cv vk cv cmin co cz wcel vm cv vk cv cmin co cr wcel vm cv cz wcel vk
      cv cz wcel vm cv vk cv cmin co cz wcel vm cv cc0 cN cfz co wcel vk cv cc0
      vm cv cfz co wcel vm cv vk cv zsubcl vm cv cc0 cN elfzelz vk cv cc0 vm cv
      elfzelz syl2an vm cv vk cv cmin co zre syl adantll vm cv cc0 cN cfz co
      wcel vm cv cr wcel cN cn0 wcel vk cv cc0 vm cv cfz co wcel vm cv cc0 cN
      cfz co wcel vm cv cz wcel vm cv cr wcel vm cv cc0 cN elfzelz vm cv zre
      syl ad2antlr cN cn0 wcel cN cr wcel vm cv cc0 cN cfz co wcel vk cv cc0 vm
      cv cfz co wcel cN nn0re ad2antrr vm cv cc0 cN cfz co wcel vk cv cc0 vm cv
      cfz co wcel vm cv vk cv cmin co vm cv cle wbr cN cn0 wcel vm cv cc0 cN
      cfz co wcel vk cv cc0 vm cv cfz co wcel wa cc0 vk cv cle wbr vm cv vk cv
      cmin co vm cv cle wbr vk cv cc0 vm cv cfz co wcel cc0 vk cv cle wbr vm cv
      cc0 cN cfz co wcel vk cv cc0 vm cv elfzle1 adantl vm cv cr wcel vk cv cr
      wcel cc0 vk cv cle wbr vm cv vk cv cmin co vm cv cle wbr wb vm cv cc0 cN
      cfz co wcel vk cv cc0 vm cv cfz co wcel vm cv vk cv subge02 vm cv cc0 cN
      cfz co wcel vm cv cz wcel vm cv cr wcel vm cv cc0 cN elfzelz vm cv zre
      syl vk cv cc0 vm cv cfz co wcel vk cv cz wcel vk cv cr wcel vk cv cc0 vm
      cv elfzelz vk cv zre syl syl2an mpbid adantll vm cv cc0 cN cfz co wcel vm
      cv cN cle wbr cN cn0 wcel vk cv cc0 vm cv cfz co wcel vm cv cc0 cN
      elfzle2 ad2antlr letrd jca cN cn0 wcel vm cv cc0 cN cfz co wcel vk cv cc0
      vm cv cfz co wcel vm cv vk cv cmin co cc0 cN cfz co wcel cc0 vm cv vk cv
      cmin co cle wbr vm cv vk cv cmin co cN cle wbr wa wb vm cv cc0 cN cfz co
      wcel vk cv cc0 vm cv cfz co wcel wa cN cn0 wcel vm cv vk cv cmin co cc0
      cN cfz co wcel cc0 vm cv vk cv cmin co cle wbr vm cv vk cv cmin co cN cle
      wbr wa wb vm cv vk cv cmin co cz wcel cN cz wcel vm cv vk cv cmin co cc0
      cN cfz co wcel cc0 vm cv vk cv cmin co cle wbr vm cv vk cv cmin co cN cle
      wbr wa wb vm cv cc0 cN cfz co wcel vk cv cc0 vm cv cfz co wcel wa cN cn0
      wcel vm cv vk cv cmin co cz wcel cc0 cz wcel cN cz wcel vm cv vk cv cmin
      co cc0 cN cfz co wcel cc0 vm cv vk cv cmin co cle wbr vm cv vk cv cmin co
      cN cle wbr wa wb 0z vm cv vk cv cmin co cc0 cN elfz mp3an2 vm cv cz wcel
      vk cv cz wcel vm cv vk cv cmin co cz wcel vm cv cc0 cN cfz co wcel vk cv
      cc0 vm cv cfz co wcel vm cv vk cv zsubcl vm cv cc0 cN elfzelz vk cv cc0
      vm cv elfzelz syl2an cN nn0z syl2an ancoms anassrs mpbird sylan exp41
      com23 com24 imp41 sylan exp31 a2d syld r19.20dv2 imp sumeq2d an1rs ex
      3impa r19.21aiv cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB cmul co
      vk csu cc0 vm cv cfz co cB vj vm cv vk cv cmin co cA csb cmul co vk csu
      wceq cc0 vj cv cfz co vj vj cv vk cv cmin co cA csb cB cmul co vk csu cc0
      vj cv cfz co cB vj vj cv vk cv cmin co cA csb cmul co vk csu wceq vm vj
      cc0 cN cfz co vj vx vx cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB
      cmul co vk csu cc0 vm cv cfz co cB vj vm cv vk cv cmin co cA csb cmul co
      vk csu vj vx cc0 vm cv cfz co vj vm cv vk cv cmin co cA csb cB cmul co vk
      vx cv cc0 vm cv cfz co wcel vj ax-17 vj vx vj vm cv vk cv cmin co cA csb
      cB cmul vj vx vm cv vk cv cmin co cA vm cv vk cv cmin oprex vx cv vm cv
      vk cv cmin co wcel vj ax-17 hbcsb1 vx cv cmul wcel vj ax-17 vx cv cB wcel
      vj ax-17 hbopr hbsum vj vx cc0 vm cv cfz co cB vj vm cv vk cv cmin co cA
      csb cmul co vk vx cv cc0 vm cv cfz co wcel vj ax-17 vj vx cB vj vm cv vk
      cv cmin co cA csb cmul vx cv cB wcel vj ax-17 vx cv cmul wcel vj ax-17 vj
      vx vm cv vk cv cmin co cA vm cv vk cv cmin oprex vx cv vm cv vk cv cmin
      co wcel vj ax-17 hbcsb1 hbopr hbsum hbeq cc0 vj cv cfz co vj vj cv vk cv
      cmin co cA csb cB cmul co vk csu cc0 vj cv cfz co cB vj vj cv vk cv cmin
      co cA csb cmul co vk csu wceq vm ax-17 vm cv vj cv wceq cc0 vm cv cfz co
      vj vm cv vk cv cmin co cA csb cB cmul co vk csu cc0 vj cv cfz co vj vj cv
      vk cv cmin co cA csb cB cmul co vk csu cc0 vm cv cfz co cB vj vm cv vk cv
      cmin co cA csb cmul co vk csu cc0 vj cv cfz co cB vj vj cv vk cv cmin co
      cA csb cmul co vk csu vm cv vj cv wceq cc0 vm cv cfz co cc0 vj cv cfz co
      vj vm cv vk cv cmin co cA csb cB cmul co vj vj cv vk cv cmin co cA csb cB
      cmul co vk vm cv vj cv cc0 cfz opreq2 vm cv vj cv wceq vj vm cv vk cv
      cmin co cA csb cB cmul co vj vj cv vk cv cmin co cA csb cB cmul co wceq
      vk cv cc0 vj cv cfz co wcel vm cv vj cv wceq vj vm cv vk cv cmin co cA
      csb vj vj cv vk cv cmin co cA csb cB cmul vm cv vj cv wceq vj vm cv vk cv
      cmin co vj cv vk cv cmin co cA vm cv vj cv vk cv cmin opreq1 csbeq1d
      opreq1d adantr sumeq12rdv vm cv vj cv wceq cc0 vm cv cfz co cc0 vj cv cfz
      co cB vj vm cv vk cv cmin co cA csb cmul co cB vj vj cv vk cv cmin co cA
      csb cmul co vk vm cv vj cv cc0 cfz opreq2 vm cv vj cv wceq cB vj vm cv vk
      cv cmin co cA csb cmul co cB vj vj cv vk cv cmin co cA csb cmul co wceq
      vk cv cc0 vj cv cfz co wcel vm cv vj cv wceq vj vm cv vk cv cmin co cA
      csb vj vj cv vk cv cmin co cA csb cB cmul vm cv vj cv wceq vj vm cv vk cv
      cmin co vj cv vk cv cmin co cA vm cv vj cv vk cv cmin opreq1 csbeq1d
      opreq2d adantr sumeq12rdv eqeq12d cbvral sylib sumeq2d cA cB vj vk cN
      fsum0diag2 cN cn0 wcel cB cc wcel vk cc0 cN cfz co wral cA cc wcel vj cc0
      cN cfz co wral cc0 cN cfz co cc0 cN vk cv cmin co cfz co cB cA cmul co vj
      csu vk csu cc0 cN cfz co cc0 vj cv cfz co cB vj vj cv vk cv cmin co cA
      csb cmul co vk csu vj csu wceq cB cA vk vj cN fsum0diag 3com23 3eqtr4d cN
      cn0 wcel cB cc wcel vk cc0 cN cfz co wral cA cc wcel vj cc0 cN cfz co
      wral cc0 cN cfz co cc0 cN vk cv cmin co cfz co cB cA cmul co vj csu vk
      csu cc0 cN cfz co cB cc0 cN vk cv cmin co cfz co cA vj csu cmul co vk csu
      wceq cB cA vk vj cN fsum0diag3 3com23 eqtrd $.
      $( [10-May-2007] $) $( [31-Dec-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Continuous complex functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the new symbol needed for continuous complex functions. $)
  $c -cn-> $.

  $( Extend class notation to include the operation which returns a class
     of continuous complex functions. $)
  ccncf $a class -cn-> $.

  ${
    $d a b f s x y z w $.
    $( Define the operation whose value is a class of continuous complex
       functions. $)
    df-cncf $a |- -cn-> = { <. <. a , b >. , s >. | ( ( a C_ CC /\ b C_ CC ) /\
      s = { f | ( f : a --> b /\ A. x e. a A. y e. RR+
      E. z e. RR+ A. w e. a ( ( abs ` ( x - w ) ) < z ->
      ( abs ` ( ( f ` x ) - ( f ` w ) ) ) < y ) ) } ) } $.
  $}

  ${
    $d A a b f s w x y z $.  $d B a b f s $.  $d F f w x y z $.
    $d w x y z P $.
    $( The value of the continuous complex function operation is the set of
       continuous functions from ` A ` to ` B ` .  (Contributed by Paul
       Chapman, 11-Oct-2007.) $)
    cncfval $p |- ( ( A C_ CC /\ B C_ CC ) ->
      ( A -cn-> B ) = { f | ( f : A --> B /\ A. x e. A A. y e. RR+
      E. z e. RR+ A. w e. A ( ( abs ` ( x - w ) ) < z ->
      ( abs ` ( ( f ` x ) - ( f ` w ) ) ) < y ) ) } ) $=
      cA cc wss cB cc wss wa cA cc cpw wcel cB cc cpw wcel wa cA cB ccncf co cA
      cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy
      crp wral vx cA wral wa vf cab wceq cc cvv wcel cA cc cpw wcel cB cc cpw
      wcel wa cA cc wss cB cc wss wa wb axcnex cc cvv wcel cA cc cpw wcel cA cc
      wss cB cc cpw wcel cB cc wss cA cc cvv elpw2g cB cc cvv elpw2g anbi12d
      ax-mp cA cc cpw wcel cB cc cpw wcel cA cB vf cv wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa vf cab
      cvv wcel cA cB ccncf co cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral vz crp wrex vy crp wral vx cA wral wa vf cab wceq cA cB vf cv
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa vf cab cA cB vf cv wf vf cab wss cA cB vf cv wf vf cab cvv
      wcel cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa vf cab cvv wcel cA cc cpw wcel cB cc
      cpw wcel wa cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral
      vz crp wrex vy crp wral vx cA wral wa vf cab cA cB vf cv wf vf cab cvv
      ssexg cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa cA cB vf cv wf vf cA cB vf cv wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA
      wral pm3.26 ss2abi cA cB cc cpw cc cpw vf mapex sylancr va vb vs cA cB cc
      cpw cc cpw va cv vb cv vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw
      va cv wral vz crp wrex vy crp wral vx va cv wral wa vf cab cA cB vf cv wf
      vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa vf cab ccncf cA vb cv vf cv wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa vf cab cvv va cv
      cA wceq va cv vb cv vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw va
      cv wral vz crp wrex vy crp wral vx va cv wral wa cA vb cv vf cv wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA
      wral wa vf va cv cA wceq va cv vb cv vf cv wf cA vb cv vf cv wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co
      cabs cfv vy cv clt wbr wi vw va cv wral vz crp wrex vy crp wral vx va cv
      wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf
      cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp
      wral vx cA wral va cv cA vb cv vf cv feq2 vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr
      wi vw va cv wral vz crp wrex vy crp wral vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr
      wi vw cA wral vz crp wrex vy crp wral vx va cv cA va cv cA wceq vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co
      cabs cfv vy cv clt wbr wi vw va cv wral vz crp wrex vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex vy crp va cv cA wceq vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co
      cabs cfv vy cv clt wbr wi vw va cv wral vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr
      wi vw cA wral vz crp vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw va cv cA
      raleq1 rexbidv ralbidv raleqd anbi12d abbidv vb cv cB wceq cA vb cv vf cv
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral wa vf vb cv cB wceq cA vb cv vf
      cv wf cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral vb cv cB cA vf cv feq3 anbi1d abbidv
      ccncf va cv cc wss vb cv cc wss wa vs cv va cv vb cv vf cv wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co
      cabs cfv vy cv clt wbr wi vw va cv wral vz crp wrex vy crp wral vx va cv
      wral wa vf cab wceq wa va vb vs copab2 va cv cc cpw wcel vb cv cc cpw
      wcel wa vs cv va cv vb cv vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw
      va cv wral vz crp wrex vy crp wral vx va cv wral wa vf cab wceq wa va vb
      vs copab2 vx vy vz vw vf vs va vb df-cncf va cv cc cpw wcel vb cv cc cpw
      wcel wa vs cv va cv vb cv vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw
      va cv wral vz crp wrex vy crp wral vx va cv wral wa vf cab wceq wa va cv
      cc wss vb cv cc wss wa vs cv va cv vb cv vf cv wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv
      vy cv clt wbr wi vw va cv wral vz crp wrex vy crp wral vx va cv wral wa
      vf cab wceq wa va vb vs va cv cc cpw wcel vb cv cc cpw wcel wa va cv cc
      wss vb cv cc wss wa vs cv va cv vb cv vf cv wf vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv
      clt wbr wi vw va cv wral vz crp wrex vy crp wral vx va cv wral wa vf cab
      wceq cc cvv wcel va cv cc cpw wcel vb cv cc cpw wcel wa va cv cc wss vb
      cv cc wss wa wb axcnex cc cvv wcel va cv cc cpw wcel va cv cc wss vb cv
      cc cpw wcel vb cv cc wss va cv cc cvv elpw2g vb cv cc cvv elpw2g anbi12d
      ax-mp anbi1i oprabbii eqtr4i oprabval2g mpd3an3 sylbir $.
      $( [27-Nov-2007] $) $( [11-Oct-2007] $)

    $( Membership in the set of continuous complex functions from ` A ` to
       ` B ` .  (Contributed by Paul Chapman, 11-Oct-2007.) $)
    elcncf $p |- ( ( A C_ CC /\ B C_ CC ) ->
     ( F e. ( A -cn-> B ) <-> ( F : A --> B /\ A. x e. A A. y e. RR+
     E. z e. RR+ A. w e. A ( ( abs ` ( x - w ) ) < z ->
     ( abs ` ( ( F ` x ) - ( F ` w ) ) ) < y ) ) ) ) $=
      cA cc wss cB cc wss wa cF cvv wcel cF cA cB ccncf co wcel cA cB cF wf vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral
      wa wb cA cc wss cB cc wss wa cF cvv wcel cF cA cB ccncf co wcel cA cB cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx
      cA wral wa wb cA cc wss cB cc wss wa cF cA cB ccncf co wcel cF cA cB vf
      cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf
      cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp
      wral vx cA wral wa vf cab wcel cF cvv wcel cA cB cF wf vx cv vw cv cmin
      co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy
      cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cA cc wss
      cB cc wss wa cA cB ccncf co cA cB vf cv wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa vf cab cF vx vy
      vz vw cA cB vf cncfval eleq2d cA cB vf cv wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cA cB cF wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral
      wa vf cF cvv vf cv cF wceq cA cB vf cv wf cA cB cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral cA cB
      vf cv cF feq1 vf cv cF wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral
      vz crp wrex vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vx vy cA
      crp vf cv cF wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv
      cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vz vw crp cA vf cv cF wceq vx cv vf cv cfv vw cv vf cv cfv
      cmin co cabs cfv vy cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vf cv cF wceq vx
      cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt vf cv cF wceq vx cv vf cv cfv vw cv vf cv cfv
      cmin co vx cv cF cfv vw cv cF cfv cmin co cabs vf cv cF wceq vx cv vf cv
      cfv vx cv cF cfv vw cv vf cv cfv vw cv cF cfv cmin vx cv vf cv cF fveq1
      vw cv vf cv cF fveq1 opreq12d fveq2d breq1d imbi2d rexralbidv 2ralbidv
      anbi12d elabg sylan9bb ex cA cc wss cB cc wss wa cF cvv wcel wn cF cA cB
      ccncf co wcel cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa wo wn cF cA cB ccncf co wcel cA cB cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx
      cA wral wa wb cA cc wss cB cc wss wa cF cA cB ccncf co wcel cA cB cF wf
      vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA
      wral wa wo cF cvv wcel cA cc wss cB cc wss wa cF cA cB ccncf co wcel cA
      cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa wo cF cvv wcel cA cc wss cB cc wss wa cF cA cB ccncf co
      wcel cF cvv wcel cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa cF cA cB ccncf co wcel cF cvv wcel cA
      cc wss cB cc wss wa cF cA cB ccncf co elisset adantl cA cc wss cB cc wss
      wa cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw
      cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp
      wral vx cA wral wa cF cvv wcel cA cc wss cA cB cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cF cvv wcel
      wi cB cc wss cA cc wss cA cvv wcel cA cB cF wf vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cF cvv wcel wi cA
      cc axcnex ssex cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa cA cvv wcel cF cvv wcel cA cB cF wf cA
      cvv wcel cF cvv wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex
      vy crp wral vx cA wral cA cB cvv cF fex adantlr expcom syl adantr imp
      jaodan ex con3d cF cA cB ccncf co wcel cA cB cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa wo wn cF cA
      cB ccncf co wcel wn cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral wa wn wa cF cA cB ccncf co wcel
      cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp
      wral vx cA wral wa wb cF cA cB ccncf co wcel cA cB cF wf vx cv vw cv cmin
      co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy
      cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa ioran cF
      cA cB ccncf co wcel cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral wa pm5.21 sylbi syl6 pm2.61d $.
      $( [27-Nov-2007] $) $( [11-Oct-2007] $)

    $( A continuous complex function's domain and codomain.  (Contributed by
       Paul Chapman, 17-Jan-2008.) $)
    cncff $p |- ( ( P C_ CC /\ Q C_ CC /\ F e. ( P -cn-> Q ) ) ->
                  F : P --> Q ) $=
      cP cc wss cQ cc wss cF cP cQ ccncf co wcel w3a cP cQ cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cP wral vz crp wrex vy crp wral vx cP wral cP cc wss
      cQ cc wss cF cP cQ ccncf co wcel cP cQ cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cP wral vz crp wrex vy crp wral vx cP wral wa vx vy vz vw cP cQ cF
      elcncf biimp3a pm3.26d $.
      $( [17-Jan-2008] $) $( [17-Jan-2008] $)

    $( MAY BE REVISED - don't delete this until we decide to keep cnff $)
    $( A continuous complex function's value belongs to its codomain.
       (Contributed by Paul Chapman, 21-Jan-2008.) $)
    cncffvelrnOLD $p |- ( ( A C_ CC /\ B C_ CC /\ F e. ( A -cn-> B ) ) ->
                        ( C e. A -> ( F ` C ) e. B ) ) $=
      cA cc wss cB cc wss cF cA cB ccncf co wcel w3a cA cB cF wf cC cA wcel cC
      cF cfv cB wcel wi cA cc wss cB cc wss cF cA cB ccncf co wcel w3a cA cB cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx
      cA wral cA cc wss cB cc wss cF cA cB ccncf co wcel cA cB cF wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cA
      cc wss cB cc wss wa cF cA cB ccncf co wcel cA cB cF wf vx cv vw cv cmin
      co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy
      cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa vx vy vz
      vw cA cB cF elcncf biimpd 3impia pm3.26d cA cB cF wf cC cA wcel cC cF cfv
      cB wcel cA cB cC cF ffvelrn ex syl $.
      $( [21-Jan-2008] $) $( [21-Jan-2008] $)
  $}

  $( A continuous complex function's value belongs to its codomain.
     (Contributed by Paul Chapman, 21-Jan-2008.) $)
  cncffvelrn $p |- ( ( A C_ CC /\ B C_ CC /\ F e. ( A -cn-> B ) ) ->
                      ( C e. A -> ( F ` C ) e. B ) ) $=
    cA cc wss cB cc wss cF cA cB ccncf co wcel w3a cA cB cF wf cC cA wcel cC cF
    cfv cB wcel wi cA cB cF cncff cA cB cF wf cC cA wcel cC cF cfv cB wcel cA
    cB cC cF ffvelrn ex syl $.
    $( [21-Jan-2008] $) $( [21-Jan-2008] $)


  ${
    $d A a b w x $.  $d A w x y z $.  $d F a b w x $.  $d F w x y z $.
    $d G w x y z $.
    negfcncf.1 $e |- A C_ CC $.
    negfcncf.2 $e |- F e. ( A -cn-> CC ) $.
    negfcncf.3 $e |- G = { <. a , b >. | ( a e. A /\ b = -u ( F ` a ) ) } $.
    $( The negative of a continuous complex function is continuous.
       (Contributed by Paul Chapman, 21-Jan-2008.) $)
    negfcncfi $p |- G e. ( A -cn-> CC ) $=
      cG cA cc ccncf co wcel cA cc cG wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral cA cc wss cc cc wss cG cA cc
      ccncf co wcel cA cc cG wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA
      cc cG elcncf mp2an va cv cF cfv cneg cc wcel va cA wral cA cc cG wf vx cv
      cF cfv cneg cc wcel vx cA wral va cv cF cfv cneg cc wcel va cA wral vx cv
      cF cfv cneg cc wcel vx cA vx cv cA wcel vx cv cF cfv cc wcel vx cv cF cfv
      cneg cc wcel cA cc vx cv cF cA cc cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cA wral cF cA cc ccncf co wcel cA cc
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa negfcncf.2 cA cc wss cc cc wss cF cA cc ccncf co wcel cA cc
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA cc cF elcncf mp2an
      mpbi pm3.26i ffvelrni vx cv cF cfv negcl syl rgen vx cv cF cfv cneg cc
      wcel va cv cF cfv cneg cc wcel vx va cA vx cv va cv wceq vx cv cF cfv
      cneg va cv cF cfv cneg cc vx cv va cv wceq vx cv cF cfv va cv cF cfv vx
      cv va cv cF fveq2 negeqd eleq1d cbvralv mpbi va vb cA cc va cv cF cfv
      cneg cG negfcncf.3 fopab2 mpbi vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral cA cc cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral cF cA cc ccncf
      co wcel cA cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex
      vy crp wral vx cA wral wa negfcncf.2 cA cc wss cc cc wss cF cA cc ccncf
      co wcel cA cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex
      vy crp wral vx cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA cc cF
      elcncf mp2an mpbi pm3.27i vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex
      vy crp wral vx cA vx cv cA wcel vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy
      crp vx cv cA wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cG cfv
      vw cv cG cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp vx cv cA wcel vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt
      wbr wi vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA vx cv cA wcel vw cv cA wcel
      wa vx cv cG cfv vw cv cG cfv cmin co cabs cfv vy cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cA wcel vw cv cA wcel wa vx cv cG cfv vw cv cG cfv
      cmin co cabs cfv vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt vx
      cv cA wcel vw cv cA wcel wa vx cv cG cfv vw cv cG cfv cmin co cabs cfv vw
      cv cF cfv vx cv cF cfv cmin co cabs cfv vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv cA wcel vw cv cA wcel wa vx cv cG cfv vw cv cG cfv cmin co
      vw cv cF cfv vx cv cF cfv cmin co cabs vx cv cA wcel vw cv cA wcel wa vx
      cv cG cfv vw cv cG cfv cmin co vx cv cF cfv cneg vw cv cF cfv cneg cmin
      co vw cv cF cfv vx cv cF cfv cmin co vx cv cA wcel vw cv cA wcel vx cv cG
      cfv vx cv cF cfv cneg vw cv cG cfv vw cv cF cfv cneg cmin va vb vx cv va
      cv cF cfv cneg vx cv cF cfv cneg cA cG va cv vx cv wceq va cv cF cfv vx
      cv cF cfv va cv vx cv cF fveq2 negeqd negfcncf.3 vx cv cF cfv negex
      fvopab4 va vb vw cv va cv cF cfv cneg vw cv cF cfv cneg cA cG va cv vw cv
      wceq va cv cF cfv vw cv cF cfv va cv vw cv cF fveq2 negeqd negfcncf.3 vw
      cv cF cfv negex fvopab4 opreqan12d vx cv cF cfv cc wcel vw cv cF cfv cc
      wcel vx cv cF cfv cneg vw cv cF cfv cneg cmin co vw cv cF cfv vx cv cF
      cfv cmin co wceq vx cv cA wcel vw cv cA wcel vx cv cF cfv vw cv cF cfv
      neg2sub cA cc vx cv cF cA cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral cF cA cc ccncf co wcel cA cc cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx
      cA wral wa negfcncf.2 cA cc wss cc cc wss cF cA cc ccncf co wcel cA cc cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx
      cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA cc cF elcncf mp2an mpbi
      pm3.26i ffvelrni cA cc vw cv cF cA cc cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral vz crp wrex vy crp wral vx cA wral cF cA cc ccncf co wcel cA
      cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa negfcncf.2 cA cc wss cc cc wss cF cA cc ccncf co wcel cA cc
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA cc cF elcncf mp2an
      mpbi pm3.26i ffvelrni syl2an eqtrd fveq2d vx cv cF cfv cc wcel vw cv cF
      cfv cc wcel vx cv cF cfv vw cv cF cfv cmin co cabs cfv vw cv cF cfv vx cv
      cF cfv cmin co cabs cfv wceq vx cv cA wcel vw cv cA wcel vx cv cF cfv vw
      cv cF cfv abssub cA cc vx cv cF cA cc cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral vz crp wrex vy crp wral vx cA wral cF cA cc ccncf co wcel cA
      cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa negfcncf.2 cA cc wss cc cc wss cF cA cc ccncf co wcel cA cc
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA cc cF elcncf mp2an
      mpbi pm3.26i ffvelrni cA cc vw cv cF cA cc cF wf vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral cF cA cc ccncf co
      wcel cA cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy
      crp wral vx cA wral wa negfcncf.2 cA cc wss cc cc wss cF cA cc ccncf co
      wcel cA cc cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy
      crp wral vx cA wral wa wb negfcncf.1 cc ssid vx vy vz vw cA cc cF elcncf
      mp2an mpbi pm3.26i ffvelrni syl2an eqtr4d breq1d imbi2d ralbidva rexbidv
      ralbidv ralbiia mpbir mpbir2an $.
      $( [21-Jan-2008] $) $( [21-Jan-2008] $)
  $}

  ${
    $d A w x y z $.  $d F w x y z $.  $d Z w z $.  $d ph w x y $.
    elcncf1d.1 $e |- ( ph -> F : A --> B ) $.
    elcncf1d.2 $e |- ( ph -> ( ( x e. A /\ y e. RR+ ) -> Z e. RR+ ) ) $.
    elcncf1d.3 $e |- ( ph -> ( ( ( x e. A /\ w e. A ) /\ y e. RR+ ) ->
                       ( ( abs ` ( x - w ) ) < Z ->
                         ( abs ` ( ( F ` x ) - ( F ` w ) ) ) < y ) ) ) $.
    $( Membership in the set of continuous complex functions from ` A ` to
       ` B ` .  (Contributed by Paul Chapman, 26-Nov-2007.) $)
    elcncf1di $p |- ( ph ->
                   ( ( A C_ CC /\ B C_ CC ) -> F e. ( A -cn-> B ) ) ) $=
      cA cc wss cB cc wss wa cF cA cB ccncf co wcel cA cB cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa wph vx
      vy vz vw cA cB cF elcncf wph cA cB cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cA wral elcncf1d.1 wph vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wph vx cv cA
      wcel wa vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wph
      vx cv cA wcel vy cv crp wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex cZ crp wcel vx cv vw cv cmin co cabs cfv cZ clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex wph vx cv cA wcel vy cv crp wcel
      wa wa vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vx cv vw cv cmin co cabs
      cfv cZ clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr
      wi vw cA wral vz cZ crp vz cv cZ wceq vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vx cv
      vw cv cmin co cabs cfv cZ clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA vz cv cZ wceq vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv vw cv cmin co cabs cfv cZ clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr vz cv cZ vx cv vw cv cmin co cabs cfv
      clt breq2 imbi1d ralbidv rcla4ev wph vx cv cA wcel vy cv crp wcel wa cZ
      crp wcel elcncf1d.2 imp wph vx cv cA wcel vy cv crp wcel wa wa vx cv vw
      cv cmin co cabs cfv cZ clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wph vx cv cA wcel vy cv crp wcel wa wa vw cv cA
      wcel wa wph vx cv cA wcel vw cv cA wcel wa vy cv crp wcel wa wa vx cv vw
      cv cmin co cabs cfv cZ clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi wph vx cv cA wcel vw cv cA wcel wa vy cv crp wcel wa wa
      wph vx cv cA wcel vy cv crp wcel wa vw cv cA wcel wa wa wph vx cv cA wcel
      vy cv crp wcel wa wa vw cv cA wcel wa vx cv cA wcel vw cv cA wcel wa vy
      cv crp wcel wa vx cv cA wcel vy cv crp wcel wa vw cv cA wcel wa wph vx cv
      cA wcel vw cv cA wcel vy cv crp wcel an23 anbi2i wph vx cv cA wcel vy cv
      crp wcel wa vw cv cA wcel anass bitr4i wph vx cv cA wcel vw cv cA wcel wa
      vy cv crp wcel wa vx cv vw cv cmin co cabs cfv cZ clt wbr vx cv cF cfv vw
      cv cF cfv cmin co cabs cfv vy cv clt wbr wi elcncf1d.3 imp sylbir
      r19.21aiva sylanc anassrs r19.21aiva r19.21aiva jca syl5cbir $.
      $( [27-Nov-2007] $) $( [26-Nov-2007] $)
  $}

  ${
    $d A w x y $.  $d F w x y $.  $d Z w $.  $d ph w x y $.
    elcncf1i.1 $e |- F : A --> B $.
    elcncf1i.2 $e |- ( ( x e. A /\ y e. RR+ ) -> Z e. RR+ ) $.
    elcncf1i.3 $e |- ( ( ( x e. A /\ w e. A ) /\ y e. RR+ ) ->
                       ( ( abs ` ( x - w ) ) < Z ->
                         ( abs ` ( ( F ` x ) - ( F ` w ) ) ) < y ) ) $.
    $( Membership in the set of continuous complex functions from ` A ` to
       ` B ` .  (Contributed by Paul Chapman, 26-Nov-2007.) $)
    elcncf1ii $p  |- ( ( A C_ CC /\ B C_ CC ) -> F e. ( A -cn-> B ) ) $=
      wph wph wi cA cc wss cB cc wss wa cF cA cB ccncf co wcel wi wph id wph
      wph wi vx vy vw cA cB cF cZ cA cB cF wf wph wph wi elcncf1i.1 a1i vx cv
      cA wcel vy cv crp wcel wa cZ crp wcel wi wph wph wi elcncf1i.2 a1i vx cv
      cA wcel vw cv cA wcel wa vy cv crp wcel wa vx cv vw cv cmin co cabs cfv
      cZ clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi wi
      wph wph wi elcncf1i.3 a1i elcncf1di ax-mp $.
      $( [27-Nov-2007] $) $( [26-Nov-2007] $)
  $}

  ${
    $d A w x y z $.  $d C w x y z $.  $d F w x y z $.
    $( A continuous complex function restricted to a subset is continuous.
       (Contributed by Paul Chapman, 18-Oct-2007.) $)
    rescncf $p |- ( ( A C_ CC /\ B C_ CC /\ C C_ A ) ->
            ( F e. ( A -cn-> B ) -> ( F |` C ) e. ( C -cn-> B ) ) ) $=
      cA cc wss cB cc wss cC cA wss w3a cA cB cF wf vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cC cB cF cC cres
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw cv
      cF cC cres cfv cmin co cabs cfv vy cv clt wbr wi vw cC wral vz crp wrex
      vy crp wral vx cC wral wa cF cA cB ccncf co wcel cF cC cres cC cB ccncf
      co wcel cC cA wss cA cc wss cA cB cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cA wral wa cC cB cF cC cres wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw cv cF cC
      cres cfv cmin co cabs cfv vy cv clt wbr wi vw cC wral vz crp wrex vy crp
      wral vx cC wral wa wi cB cc wss cC cA wss cA cB cF wf cC cB cF cC cres wf
      vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA
      wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw
      cv cF cC cres cfv cmin co cabs cfv vy cv clt wbr wi vw cC wral vz crp
      wrex vy crp wral vx cC wral cA cB cF wf cC cA wss cC cB cF cC cres wf cA
      cB cC cF fssres expcom cC cA wss vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cC wral vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cC cres cfv vw cv cF cC cres cfv cmin co cabs cfv
      vy cv clt wbr wi vw cC wral vz crp wrex vy crp wral vx cC wral vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cC cA ssralv
      cC cA wss vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp
      wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw
      cv cF cC cres cfv cmin co cabs cfv vy cv clt wbr wi vw cC wral vz crp
      wrex vy crp wral vx cC cC cA wss vx cv cC wcel wa vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cC cres cfv vw cv cF cC cres cfv cmin co cabs cfv vy cv clt
      wbr wi vw cC wral vz crp wrex vy crp cC cA wss vx cv cC wcel wa vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA wral vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cC cres cfv vw cv cF cC cres cfv cmin co cabs cfv vy cv clt
      wbr wi vw cC wral vz crp cC cA wss vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cC wral vx cv cC wcel vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw cv cF cC cres cfv
      cmin co cabs cfv vy cv clt wbr wi vw cC wral vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cC cA ssralv vx cv cC wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw cv cF cC cres cfv
      cmin co cabs cfv vy cv clt wbr wi vw cC vx cv cC wcel vw cv cC wcel wa vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw cv cF cC
      cres cfv cmin co cabs cfv vy cv clt wbr wi vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vx cv cC wcel vw cv cC wcel wa vx cv cF cC cres cfv vw cv cF cC cres cfv
      cmin co cabs cfv vy cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cC wcel vw
      cv cC wcel wa vx cv cF cC cres cfv vw cv cF cC cres cfv cmin co cabs cfv
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt vx cv cC wcel vw cv
      cC wcel wa vx cv cF cC cres cfv vw cv cF cC cres cfv cmin co vx cv cF cfv
      vw cv cF cfv cmin co cabs vx cv cC wcel vw cv cC wcel vx cv cF cC cres
      cfv vx cv cF cfv vw cv cF cC cres cfv vw cv cF cfv cmin vx cv cC cF fvres
      vw cv cC cF fvres opreqan12d fveq2d breq1d imbi2d biimprd r19.20dva
      sylan9 r19.22sdv r19.20sdv r19.20dva syld anim12d 3ad2ant3 cA cc wss cB
      cc wss cF cA cB ccncf co wcel cA cB cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cA wral wa wb cC cA wss vx vy vz vw cA
      cB cF elcncf 3adant3 cA cc wss cB cc wss cC cA wss w3a cC cc wss cB cc
      wss wa cF cC cres cC cB ccncf co wcel cC cB cF cC cres wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cC cres cfv vw cv cF cC cres cfv
      cmin co cabs cfv vy cv clt wbr wi vw cC wral vz crp wrex vy crp wral vx
      cC wral wa wb cC cA wss cA cc wss cB cc wss cC cc wss cB cc wss wa cC cA
      wss cA cc wss cB cc wss cC cc wss cB cc wss wa cC cA wss cA cc wss wa cC
      cc wss cB cc wss cC cA cc sstr anim1i 3impa 3coml vx vy vz vw cC cB cF cC
      cres elcncf syl 3imtr4d $.
      $( [27-Nov-2007] $) $( [18-Oct-2007] $)

    $( Change the codomain of a continuous complex function.  (Contributed by
       Paul Chapman, 18-Oct-2007.) $)
    cncffvrn $p |- ( ( ( A C_ CC /\ B C_ CC /\ C C_ CC ) /\
      A. x e. A ( F ` x ) e. C ) ->
      ( F e. ( A -cn-> B ) -> F e. ( A -cn-> C ) ) ) $=
      cA cc wss cB cc wss cC cc wss w3a vx cv cF cfv cC wcel vx cA wral wa cA
      cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa cA cC cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa cF cA cB ccncf co wcel cF cA cC ccncf
      co wcel vx cv cF cfv cC wcel vx cA wral cA cB cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA wral wa cA cC cF wf
      vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral vx cA
      wral wa wi cA cc wss cB cc wss cC cc wss w3a vx cv cF cfv cC wcel vx cA
      wral cA cB cF wf cA cC cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral cA cB cF wf vx cv cF cfv cC wcel vx cA
      wral cA cC cF wf cA cB cF wf vx cv cF cfv cC wcel vx cA wral cF crn cC
      wss cA cC cF wf cF cA wfn vx cv cF cfv cC wcel vx cA wral cF crn cC wss
      cA cB cF wf vx cA cC cF fnfvrnss cA cB cF ffn sylan cA cF crn cF wf cF
      crn cC wss cA cC cF wf cA cB cF wf cA cF crn cC cF fss cA cB cF wf cF cA
      wfn cA cF crn cF wf cA cB cF ffn cA cF dffn3 sylib sylan syldan expcom
      anim1d adantl cA cc wss cB cc wss cC cc wss w3a cF cA cB ccncf co wcel cA
      cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral
      vx cA wral wa wb vx cv cF cfv cC wcel vx cA wral cA cc wss cB cc wss cF
      cA cB ccncf co wcel cA cB cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral vx cA wral wa wb cC cc wss vx vy vz vw cA cB
      cF elcncf 3adant3 adantr cA cc wss cB cc wss cC cc wss w3a cF cA cC ccncf
      co wcel cA cC cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex
      vy crp wral vx cA wral wa wb vx cv cF cfv cC wcel vx cA wral cA cc wss cC
      cc wss cF cA cC ccncf co wcel cA cC cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cA wral wa wb cB cc wss vx vy vz vw cA
      cC cF elcncf 3adant2 adantr 3imtr4d $.
      $( [27-Nov-2007] $) $( [18-Oct-2007] $)
  $}

  ${
    $d F w x y $.
    abscncflem.1 $e |- A C_ CC $.
    abscncflem.2 $e |- F : CC --> A $.
    abscncflem.3 $e |- ( ( x e. CC /\ w e. CC ) ->
      ( abs ` ( ( F ` x ) - ( F ` w ) ) ) <_ ( abs ` ( x - w ) ) ) $.
    $( Lemma for ~ abscncf , ~ recncf , ~ imcncf , and ~ cjcncf . $)
    abscncflem $p |- F e. ( CC -cn-> A ) $=
      cc cc wss cA cc wss cF cc cA ccncf co wcel cc ssid abscncflem.1 vx vy vw
      cc cA cF vy cv abscncflem.2 vx cv cc wcel vy cv crp wcel pm3.27 vy cv crp
      wcel vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cabs cfv vy cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vy cv
      crp wcel vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cabs cfv vy
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr vy cv
      crp wcel vx cv cc wcel vw cv cc wcel wa vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vx cv vw cv cmin co cabs cfv cle wbr vx cv vw cv cmin co cabs
      cfv vy cv clt wbr wa wa vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cabs cfv vy cv
      clt wbr wa vy cv crp wcel vx cv cc wcel vw cv cc wcel wa vx cv cF cfv vw
      cv cF cfv cmin co cabs cfv vx cv vw cv cmin co cabs cfv cle wbr vx cv vw
      cv cmin co cabs cfv vy cv clt wbr wa vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr vx cv cc wcel vw cv cc wcel wa vy cv crp wcel vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv vw cv cmin co cabs cfv cle
      wbr vx cv vw cv cmin co cabs cfv vy cv clt wbr wa vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vx cv cc wcel vw cv cc wcel wa vy
      cv crp wcel vx cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv vw cv cmin
      co cabs cfv cle wbr vx cv vw cv cmin co cabs cfv vy cv clt wbr wa vx cv
      cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv cr wcel vx cv vw cv cmin co cabs cfv cr wcel vy
      cv cr wcel vx cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv vw cv cmin co
      cabs cfv cle wbr vx cv vw cv cmin co cabs cfv vy cv clt wbr wa vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vx cv cc wcel vw cv cc
      wcel wa vx cv cc wcel vw cv cc wcel wa vy cv crp wcel vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv vx cv vw cv cmin co cabs cfv vy cv lelttr vx cv
      cc wcel vw cv cc wcel wa vx cv cF cfv cc wcel vw cv cF cfv cc wcel wa vx
      cv cF cfv vw cv cF cfv cmin co cc wcel vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv cr wcel vx cv cc wcel vx cv cF cfv cc wcel vw cv cc wcel vw cv
      cF cfv cc wcel cc cc vx cv cF cc cA cF wf cA cc wss cc cc cF wf
      abscncflem.2 abscncflem.1 cc cA cc cF fss mp2an ffvelrni cc cc vw cv cF
      cc cA cF wf cA cc wss cc cc cF wf abscncflem.2 abscncflem.1 cc cA cc cF
      fss mp2an ffvelrni anim12i vx cv cF cfv vw cv cF cfv subcl vx cv cF cfv
      vw cv cF cfv cmin co abscl 3syl vx cv cc wcel vw cv cc wcel wa vx cv vw
      cv cmin co cc wcel vx cv vw cv cmin co cabs cfv cr wcel vx cv vw cv subcl
      vx cv vw cv cmin co abscl syl vy cv rpre syl3an 3anidm12 expcom imp3a vx
      cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cabs cfv vy cv clt wbr wa
      vx cv cc wcel vw cv cc wcel wa vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vx cv vw cv cmin co cabs cfv cle wbr wa vx cv vw cv cmin co cabs cfv vy
      cv clt wbr wa vx cv cc wcel vw cv cc wcel wa vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vx cv vw cv cmin co cabs cfv cle wbr vx cv vw cv cmin co
      cabs cfv vy cv clt wbr wa wa vx cv cc wcel vw cv cc wcel wa vx cv cc wcel
      vw cv cc wcel wa vx cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv vw cv
      cmin co cabs cfv cle wbr wa vx cv vw cv cmin co cabs cfv vy cv clt wbr vx
      cv cc wcel vw cv cc wcel wa vx cv cF cfv vw cv cF cfv cmin co cabs cfv vx
      cv vw cv cmin co cabs cfv cle wbr abscncflem.3 ancli anim1i vx cv cc wcel
      vw cv cc wcel wa vx cv cF cfv vw cv cF cfv cmin co cabs cfv vx cv vw cv
      cmin co cabs cfv cle wbr vx cv vw cv cmin co cabs cfv vy cv clt wbr anass
      sylib syl5 exp3a impcom elcncf1ii mp2an $.
      $( [26-Nov-2007] $) $( [21-Oct-2007] $)
  $}

  ${
    $d w x y z $.
    $( Absolute value is continuous.  (Contributed by Paul Chapman,
       21-Oct-2007.) $)
    abscncf $p |- abs e. ( CC -cn-> RR ) $=
      vx vw cr cabs axresscn absf vx cv vw cv abs2difabs abscncflem $.
      $( [21-Oct-2007] $) $( [21-Oct-2007] $)

    $( Real part is continuous. (Contributed by Paul Chapman, 21-Oct-2007.) $)
    recncf $p |- Re e. ( CC -cn-> RR ) $=
      vx vw cr cre axresscn ref vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin
      co cre cfv cabs cfv vx cv cre cfv vw cv cre cfv cmin co cabs cfv vx cv vw
      cv cmin co cabs cfv cle vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin
      co cre cfv vx cv cre cfv vw cv cre cfv cmin co cabs vx cv vw cv resub
      fveq2d vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cc wcel vx cv
      vw cv cmin co cre cfv cabs cfv vx cv vw cv cmin co cabs cfv cle wbr vx cv
      vw cv subcl vx cv vw cv cmin co absrele syl eqbrtrrd abscncflem $.
      $( [22-Oct-2007] $) $( [21-Oct-2007] $)

    $( Imaginary part is continuous. (Contributed by Paul Chapman,
       21-Oct-2007.) $)
    imcncf $p |- Im e. ( CC -cn-> RR ) $=
      vx vw cr cim axresscn imf vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin
      co cim cfv cabs cfv vx cv cim cfv vw cv cim cfv cmin co cabs cfv vx cv vw
      cv cmin co cabs cfv cle vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin
      co cim cfv vx cv cim cfv vw cv cim cfv cmin co cabs vx cv vw cv imsub
      fveq2d vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cc wcel vx cv
      vw cv cmin co cim cfv cabs cfv vx cv vw cv cmin co cabs cfv cle wbr vx cv
      vw cv subcl vx cv vw cv cmin co absimle syl eqbrtrrd abscncflem $.
      $( [22-Oct-2007] $) $( [21-Oct-2007] $)

    $( Complex conjugate is continuous.  (Contributed by Paul Chapman,
       21-Oct-2007.) $)
    cjcncf $p |- * e. ( CC -cn-> CC ) $=
      vx vw cc ccj cc ssid vx vy cc cc vx cv cre cfv ci vx cv cim cfv cmul co
      cmin co ccj vx vy df-cj vx cv cc wcel vx cv ccj cfv vx cv cre cfv ci vx
      cv cim cfv cmul co cmin co cc vx cv cjval vx cv cjcl eqeltrrd fopab vx cv
      ccj cfv vw cv ccj cfv cmin co cabs cfv cr wcel vx cv ccj cfv vw cv ccj
      cfv cmin co cabs cfv vx cv vw cv cmin co cabs cfv wceq vx cv ccj cfv vw
      cv ccj cfv cmin co cabs cfv vx cv vw cv cmin co cabs cfv cle wbr vx cv cc
      wcel vw cv cc wcel wa vx cv ccj cfv vw cv ccj cfv cmin co cabs cfv vx cv
      vw cv cmin co cabs cfv eqle vx cv cc wcel vw cv cc wcel wa vx cv ccj cfv
      cc wcel vw cv ccj cfv cc wcel wa vx cv ccj cfv vw cv ccj cfv cmin co cc
      wcel vx cv ccj cfv vw cv ccj cfv cmin co cabs cfv cr wcel vx cv cc wcel
      vx cv ccj cfv cc wcel vw cv cc wcel vw cv ccj cfv cc wcel vx cv cjcl vw
      cv cjcl anim12i vx cv ccj cfv vw cv ccj cfv subcl vx cv ccj cfv vw cv ccj
      cfv cmin co abscl 3syl vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co
      ccj cfv cabs cfv vx cv ccj cfv vw cv ccj cfv cmin co cabs cfv vx cv vw cv
      cmin co cabs cfv vx cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co ccj
      cfv vx cv ccj cfv vw cv ccj cfv cmin co cabs vx cv vw cv cjsub fveq2d vx
      cv cc wcel vw cv cc wcel wa vx cv vw cv cmin co cc wcel vx cv vw cv cmin
      co ccj cfv cabs cfv vx cv vw cv cmin co cabs cfv wceq vx cv vw cv subcl
      vx cv vw cv cmin co abscj syl eqtr3d sylanc abscncflem $.
      $( [21-Oct-2007] $) $( [21-Oct-2007] $)
  $}

  ${
    $d A v w z $.  $d A w x y z $.  $d F v w z $.
    mulc1cncf.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( A x. x ) ) } $.
    $( Multiplication by a constant is continuous.  (Contributed by Paul
       Chapman, 28-Nov-2007.) $)
    mulc1cncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      cA cc wcel cc cc wss cc cc wss cF cc cc ccncf co wcel cc ssid cc ssid cA
      cc wcel cc cc wss cc cc wss wa cF cc cc ccncf co wcel wi wi cA cc0 cA cc
      wcel cA cc0 wceq cc cc wss cc cc wss wa cF cc cc ccncf co wcel wi cA cc
      wcel cA cc0 wceq wa vz vv vw cc cc cF c1 cA cc wcel cc cc cF wf cA cc0
      wceq cA cc wcel cA vx cv cmul co cc wcel vx cc wral cc cc cF wf cA cc
      wcel cA vx cv cmul co cc wcel vx cc cA vx cv mulcl r19.21aiva vx vy cc cc
      cA vx cv cmul co cF mulc1cncf.1 fopab2 sylib adantr cA cc wcel cA cc0
      wceq wa vz cv cc wcel vv cv crp wcel wa c1 crp wcel 1rp a1i12 cA cc wcel
      cA cc0 wceq wa vz cv cc wcel vw cv cc wcel wa vv cv crp wcel vz cv vw cv
      cmin co cabs cfv c1 clt wbr vz cv cF cfv vw cv cF cfv cmin co cabs cfv vv
      cv clt wbr wi cA cc0 wceq vz cv cc wcel vw cv cc wcel wa vv cv crp wcel
      vz cv vw cv cmin co cabs cfv c1 clt wbr vz cv cF cfv vw cv cF cfv cmin co
      cabs cfv vv cv clt wbr wi cA cc wcel cA cc0 wceq vz cv cc wcel vw cv cc
      wcel wa vv cv crp wcel w3a vz cv cF cfv vw cv cF cfv cmin co cabs cfv vv
      cv clt wbr vz cv vw cv cmin co cabs cfv c1 clt wbr cA cc0 wceq vz cv cc
      wcel vw cv cc wcel wa vv cv crp wcel w3a vz cv cF cfv vw cv cF cfv cmin
      co cabs cfv cc0 vv cv clt cA cc0 wceq vz cv cc wcel vw cv cc wcel wa vz
      cv cF cfv vw cv cF cfv cmin co cabs cfv cc0 wceq vv cv crp wcel cA cc0
      wceq vz cv cc wcel vw cv cc wcel wa wa cA vz cv vw cv cmin co cmul co
      cabs cfv cc0 vz cv vw cv cmin co cmul co cabs cfv vz cv cF cfv vw cv cF
      cfv cmin co cabs cfv cc0 cA cc0 wceq cA vz cv vw cv cmin co cmul co cabs
      cfv cc0 vz cv vw cv cmin co cmul co cabs cfv wceq vz cv cc wcel vw cv cc
      wcel wa cA cc0 wceq cA vz cv vw cv cmin co cmul co cc0 vz cv vw cv cmin
      co cmul co cabs cA cc0 vz cv vw cv cmin co cmul opreq1 fveq2d adantr cA
      cc wcel vz cv cc wcel vw cv cc wcel wa cA vz cv vw cv cmin co cmul co
      cabs cfv vz cv cF cfv vw cv cF cfv cmin co cabs cfv wceq cA cc0 wceq cA
      cc wcel vz cv cc wcel vw cv cc wcel wa wa cA vz cv vw cv cmin co cmul co
      vz cv cF cfv vw cv cF cfv cmin co cabs cA cc wcel vz cv cc wcel vw cv cc
      wcel wa wa cA vz cv vw cv cmin co cmul co cA vz cv cmul co cA vw cv cmul
      co cmin co vz cv cF cfv vw cv cF cfv cmin co cA cc wcel vz cv cc wcel vw
      cv cc wcel cA vz cv vw cv cmin co cmul co cA vz cv cmul co cA vw cv cmul
      co cmin co wceq cA vz cv vw cv subdi 3expb cA cc wcel vz cv cc wcel vw cv
      cc wcel wa wa vz cv cF cfv cA vz cv cmul co vw cv cF cfv cA vw cv cmul co
      cmin cA cc wcel vz cv cc wcel vz cv cF cfv cA vz cv cmul co wceq vw cv cc
      wcel cA cc wcel vz cv cc wcel vz cv cF cfv cA vz cv cmul co wceq vz cv cc
      wcel cA vz cv cmul co cc wcel vz cv cF cfv cA vz cv cmul co wceq cA cc
      wcel vz cv cc wcel wa vx vy vz cv cA vx cv cmul co cA vz cv cmul co cc cc
      cF vx cv vz cv cA cmul opreq2 mulc1cncf.1 fvopab4g cA vz cv mulcl sylan2
      anabss7 adantrr cA cc wcel vw cv cc wcel vw cv cF cfv cA vw cv cmul co
      wceq vz cv cc wcel cA cc wcel vw cv cc wcel vw cv cF cfv cA vw cv cmul co
      wceq vw cv cc wcel cA vw cv cmul co cc wcel vw cv cF cfv cA vw cv cmul co
      wceq cA cc wcel vw cv cc wcel wa vx vy vw cv cA vx cv cmul co cA vw cv
      cmul co cc cc cF vx cv vw cv cA cmul opreq2 mulc1cncf.1 fvopab4g cA vw cv
      mulcl sylan2 anabss7 adantrl opreq12d eqtr4d fveq2d cA cc0 wceq cA cc
      wcel cc0 cc wcel 0cn cA cc0 cc eleq1 mpbiri sylan vz cv cc wcel vw cv cc
      wcel wa cc0 vz cv vw cv cmin co cmul co cabs cfv cc0 wceq cA cc0 wceq vz
      cv cc wcel vw cv cc wcel wa cc0 vz cv vw cv cmin co cmul co cabs cfv cc0
      cabs cfv cc0 vz cv cc wcel vw cv cc wcel wa cc0 vz cv vw cv cmin co cmul
      co cc0 cabs vz cv cc wcel vw cv cc wcel wa vz cv vw cv cmin co cc wcel
      cc0 vz cv vw cv cmin co cmul co cc0 wceq vz cv vw cv subcl vz cv vw cv
      cmin co mul02 syl fveq2d abs0 syl6eq adantl 3eqtr3d 3adant3 vv cv crp
      wcel cA cc0 wceq cc0 vv cv clt wbr vz cv cc wcel vw cv cc wcel wa vv cv
      crp wcel vv cv cr wcel cc0 vv cv clt wbr vv cv elrp pm3.27bi 3ad2ant3
      eqbrtrd a1d 3adant1l 3expib elcncf1di expcom cA cc wcel cA cc0 wne cc cc
      wss cc cc wss wa cF cc cc ccncf co wcel wi cA cc wcel cA cc0 wne wa vz vv
      vw cc cc cF vv cv cA cabs cfv cdiv co cA cc wcel cc cc cF wf cA cc0 wne
      cA cc wcel cA vx cv cmul co cc wcel vx cc wral cc cc cF wf cA cc wcel cA
      vx cv cmul co cc wcel vx cc cA vx cv mulcl r19.21aiva vx vy cc cc cA vx
      cv cmul co cF mulc1cncf.1 fopab2 sylib adantr cA cc wcel cA cc0 wne wa vv
      cv crp wcel vv cv cA cabs cfv cdiv co crp wcel vz cv cc wcel vv cv crp
      wcel cA cc wcel cA cc0 wne wa vv cv cA cabs cfv cdiv co crp wcel vv cv cA
      cabs cfv cdiv co crp wcel vv cv cA cabs cfv cdiv co cr wcel cc0 vv cv cA
      cabs cfv cdiv co clt wbr vv cv crp wcel cA cc wcel cA cc0 wne wa wa vv cv
      cA cabs cfv cdiv co elrp vv cv cr wcel cA cabs cfv cr wcel cA cabs cfv
      cc0 wne wa vv cv cA cabs cfv cdiv co cr wcel vv cv crp wcel cA cc wcel cA
      cc0 wne wa vv cv cr wcel cA cabs cfv cr wcel cA cabs cfv cc0 wne vv cv cA
      cabs cfv cdiv co cr wcel vv cv cA cabs cfv redivcl 3expb vv cv crp wcel
      vv cv cr wcel cc0 vv cv clt wbr vv cv elrp pm3.26bi cA cc wcel cA cc0 wne
      wa cA cabs cfv cr wcel cA cabs cfv cc0 wne cA cc wcel cA cabs cfv cr wcel
      cA cc0 wne cA abscl adantr cA cc wcel cA cabs cfv cc0 wne cA cc0 wne cA
      cc wcel cA cabs cfv cc0 cA cc0 cA abs00 necon3bid biimpar jca syl2an vv
      cv crp wcel cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr wa cc0 vv cv cA
      cabs cfv cdiv co clt wbr cA cc wcel cA cc0 wne wa vv cv cr wcel cc0 vv cv
      clt wbr wa cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr wa cc0 vv cv cA
      cabs cfv cdiv co clt wbr vv cv crp wcel vv cv cA cabs cfv divgt0 vv cv
      elrp sylanb cA cc wcel cA cc0 wne wa cA cc wcel cc0 cA cabs cfv clt wbr
      wa cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr wa cA cc wcel cA cc0 wne
      cc0 cA cabs cfv clt wbr cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr cA
      absgt0 biimpd imdistani cA cc wcel cA cabs cfv cr wcel cc0 cA cabs cfv
      clt wbr cA abscl anim1i syl sylan2 sylanbrc expcom adantld cA cc wcel cA
      cc0 wne wa vz cv cc wcel vw cv cc wcel wa vv cv crp wcel wa vz cv vw cv
      cmin co cabs cfv vv cv cA cabs cfv cdiv co clt wbr vz cv cF cfv vw cv cF
      cfv cmin co cabs cfv vv cv clt wbr wi cA cc wcel cA cc0 wne wa vz cv cc
      wcel vw cv cc wcel wa vv cv crp wcel wa wa vz cv cF cfv vw cv cF cfv cmin
      co cabs cfv vv cv clt wbr vz cv vw cv cmin co cabs cfv vv cv cA cabs cfv
      cdiv co clt wbr cA cc wcel cA cc0 wne wa vz cv cc wcel vw cv cc wcel wa
      vv cv crp wcel wa wa cA cabs cfv vz cv vw cv cmin co cabs cfv cmul co vv
      cv clt wbr vz cv cF cfv vw cv cF cfv cmin co cabs cfv vv cv clt wbr vz cv
      vw cv cmin co cabs cfv vv cv cA cabs cfv cdiv co clt wbr cA cc wcel cA
      cc0 wne wa vz cv cc wcel vw cv cc wcel wa vv cv crp wcel wa wa cA cabs
      cfv vz cv vw cv cmin co cabs cfv cmul co vz cv cF cfv vw cv cF cfv cmin
      co cabs cfv vv cv clt cA cc wcel vz cv cc wcel vw cv cc wcel wa cA cabs
      cfv vz cv vw cv cmin co cabs cfv cmul co vz cv cF cfv vw cv cF cfv cmin
      co cabs cfv wceq cA cc0 wne vv cv crp wcel cA cc wcel vz cv cc wcel vw cv
      cc wcel wa wa cA vz cv vw cv cmin co cmul co cabs cfv cA cabs cfv vz cv
      vw cv cmin co cabs cfv cmul co vz cv cF cfv vw cv cF cfv cmin co cabs cfv
      cA cc wcel vz cv vw cv cmin co cc wcel cA vz cv vw cv cmin co cmul co
      cabs cfv cA cabs cfv vz cv vw cv cmin co cabs cfv cmul co wceq vz cv cc
      wcel vw cv cc wcel wa cA vz cv vw cv cmin co absmul vz cv vw cv subcl
      sylan2 cA cc wcel vz cv cc wcel vw cv cc wcel wa wa cA vz cv vw cv cmin
      co cmul co vz cv cF cfv vw cv cF cfv cmin co cabs cA cc wcel vz cv cc
      wcel vw cv cc wcel wa wa cA vz cv vw cv cmin co cmul co cA vz cv cmul co
      cA vw cv cmul co cmin co vz cv cF cfv vw cv cF cfv cmin co cA cc wcel vz
      cv cc wcel vw cv cc wcel cA vz cv vw cv cmin co cmul co cA vz cv cmul co
      cA vw cv cmul co cmin co wceq cA vz cv vw cv subdi 3expb cA cc wcel vz cv
      cc wcel vw cv cc wcel wa wa vz cv cF cfv cA vz cv cmul co vw cv cF cfv cA
      vw cv cmul co cmin cA cc wcel vz cv cc wcel vz cv cF cfv cA vz cv cmul co
      wceq vw cv cc wcel cA cc wcel vz cv cc wcel vz cv cF cfv cA vz cv cmul co
      wceq vz cv cc wcel cA vz cv cmul co cc wcel vz cv cF cfv cA vz cv cmul co
      wceq cA cc wcel vz cv cc wcel wa vx vy vz cv cA vx cv cmul co cA vz cv
      cmul co cc cc cF vx cv vz cv cA cmul opreq2 mulc1cncf.1 fvopab4g cA vz cv
      mulcl sylan2 anabss7 adantrr cA cc wcel vw cv cc wcel vw cv cF cfv cA vw
      cv cmul co wceq vz cv cc wcel cA cc wcel vw cv cc wcel vw cv cF cfv cA vw
      cv cmul co wceq vw cv cc wcel cA vw cv cmul co cc wcel vw cv cF cfv cA vw
      cv cmul co wceq cA cc wcel vw cv cc wcel wa vx vy vw cv cA vx cv cmul co
      cA vw cv cmul co cc cc cF vx cv vw cv cA cmul opreq2 mulc1cncf.1 fvopab4g
      cA vw cv mulcl sylan2 anabss7 adantrl opreq12d eqtr4d fveq2d eqtr3d
      ad2ant2r breq1d vz cv cc wcel vw cv cc wcel wa vv cv crp wcel wa cA cc
      wcel cA cc0 wne wa cA cabs cfv vz cv vw cv cmin co cabs cfv cmul co vv cv
      clt wbr vz cv vw cv cmin co cabs cfv vv cv cA cabs cfv cdiv co clt wbr wb
      vz cv cc wcel vw cv cc wcel wa vv cv crp wcel wa cA cc wcel cc0 cA cabs
      cfv clt wbr wa cA cabs cfv vz cv vw cv cmin co cabs cfv cmul co vv cv clt
      wbr vz cv vw cv cmin co cabs cfv vv cv cA cabs cfv cdiv co clt wbr wb cA
      cc wcel cA cc0 wne wa vz cv cc wcel vw cv cc wcel wa vv cv crp wcel wa cA
      cc wcel cc0 cA cabs cfv clt wbr cA cabs cfv vz cv vw cv cmin co cabs cfv
      cmul co vv cv clt wbr vz cv vw cv cmin co cabs cfv vv cv cA cabs cfv cdiv
      co clt wbr wb cA cc wcel vz cv cc wcel vw cv cc wcel wa vv cv crp wcel
      w3a cc0 cA cabs cfv clt wbr cA cabs cfv vz cv vw cv cmin co cabs cfv cmul
      co vv cv clt wbr vz cv vw cv cmin co cabs cfv vv cv cA cabs cfv cdiv co
      clt wbr wb vz cv cc wcel vw cv cc wcel wa vv cv crp wcel wa cA cc wcel wa
      cA cabs cfv cr wcel vz cv vw cv cmin co cabs cfv cr wcel vv cv cr wcel
      cc0 cA cabs cfv clt wbr cA cabs cfv vz cv vw cv cmin co cabs cfv cmul co
      vv cv clt wbr vz cv vw cv cmin co cabs cfv vv cv cA cabs cfv cdiv co clt
      wbr wb cA cc wcel vz cv cc wcel vw cv cc wcel wa vv cv crp wcel cA cabs
      cfv vz cv vw cv cmin co cabs cfv vv cv ltmuldiv2OLD cA abscl vz cv cc
      wcel vw cv cc wcel wa vz cv vw cv cmin co cc wcel vz cv vw cv cmin co
      cabs cfv cr wcel vz cv vw cv subcl vz cv vw cv cmin co abscl syl vv cv
      crp wcel vv cv cr wcel cc0 vv cv clt wbr vv cv elrp pm3.26bi syl3anl cA
      cc wcel vz cv cc wcel vw cv cc wcel wa vv cv crp wcel w3a vz cv cc wcel
      vw cv cc wcel wa vv cv crp wcel cA cc wcel w3a vz cv cc wcel vw cv cc
      wcel wa vv cv crp wcel wa cA cc wcel wa cA cc wcel vz cv cc wcel vw cv cc
      wcel wa vv cv crp wcel 3anrot vz cv cc wcel vw cv cc wcel wa vv cv crp
      wcel cA cc wcel df-3an bitri sylanbr anasss cA cc wcel cA cc0 wne cc0 cA
      cabs cfv clt wbr cA cc wcel cA cc0 wne cc0 cA cabs cfv clt wbr cA absgt0
      biimpd imdistani sylan2 ancoms bitr3d biimprd ex elcncf1di expcom
      pm2.61ine mp2ani $.
      $( [28-Nov-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    $d A x y $.
    divccncf.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( x / A ) ) } $.
    $( Division by a constant is continuous.  (Contributed by Paul Chapman,
       28-Nov-2007.) $)
    divccncf $p |- ( ( A e. CC /\ A =/= 0 ) -> F e. ( CC -cn-> CC ) ) $=
      cA cc wcel cA cc0 wne wa cF vx cv cc wcel vy cv c1 cA cdiv co vx cv cmul
      co wceq wa vx vy copab cc cc ccncf co cA cc wcel cA cc0 wne wa vx cv cc
      wcel vy cv vx cv cA cdiv co wceq wa vx vy copab vx cv cc wcel vy cv c1 cA
      cdiv co vx cv cmul co wceq wa vx vy copab cF cA cc wcel cA cc0 wne wa vx
      cv cc wcel vy cv vx cv cA cdiv co wceq wa vx cv cc wcel vy cv c1 cA cdiv
      co vx cv cmul co wceq wa vx vy cA cc wcel cA cc0 wne wa vx cv cc wcel vy
      cv vx cv cA cdiv co wceq vy cv c1 cA cdiv co vx cv cmul co wceq vx cv cc
      wcel cA cc wcel cA cc0 wne wa vy cv vx cv cA cdiv co wceq vy cv c1 cA
      cdiv co vx cv cmul co wceq wb vx cv cc wcel cA cc wcel cA cc0 wne vy cv
      vx cv cA cdiv co wceq vy cv c1 cA cdiv co vx cv cmul co wceq wb vx cv cc
      wcel cA cc wcel cA cc0 wne w3a vx cv cA cdiv co c1 cA cdiv co vx cv cmul
      co vy cv vx cv cA divrec2 eqeq2d 3expb expcom pm5.32d opabbidv divccncf.1
      syl5eq cA cc wcel cA cc0 wne wa c1 cA cdiv co cc wcel vx cv cc wcel vy cv
      c1 cA cdiv co vx cv cmul co wceq wa vx vy copab cc cc ccncf co wcel cA
      reccl vx vy c1 cA cdiv co vx cv cc wcel vy cv c1 cA cdiv co vx cv cmul co
      wceq wa vx vy copab vx cv cc wcel vy cv c1 cA cdiv co vx cv cmul co wceq
      wa vx vy copab eqid mulc1cncf syl eqeltrd $.
      $( [28-Nov-2007] $) $( [28-Nov-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Intermediate value theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d y H $.  $d w y z P $.  $d y R $.  $d w y z U $.  $d y W $.
    ivthlem1.1 $e |- U e. RR $.
    ivthlem1.2 $e |- P e. RR $.
    $( Lemma for ~ isupivthi . $)
    ivthlem1 $p |- ( ( Q e. RR -> ( ( abs ` ( P - Q ) ) < ( P - U ) -> U < Q )
         ) /\ ( Q e. RR -> ( ( abs ` ( P - Q ) ) < ( U - P ) -> Q < U ) ) ) $=
      cQ cr wcel cP cQ cmin co cabs cfv cP cU cmin co clt wbr cU cQ clt wbr wi
      wi cQ cr wcel cP cQ cmin co cabs cfv cU cP cmin co clt wbr cQ cU clt wbr
      wi wi cQ cr wcel cP cQ cmin co cabs cfv cP cU cmin co clt wbr cQ cP cmin
      co cabs cfv cP cU cmin co clt wbr cU cQ clt wbr cQ cr wcel cP cQ cmin co
      cabs cfv cQ cP cmin co cabs cfv cP cU cmin co clt cP cc wcel cQ cc wcel
      cP cQ cmin co cabs cfv cQ cP cmin co cabs cfv wceq cQ cr wcel cP cQ
      abssub cP ivthlem1.2 recni cQ recn sylancr breq1d cQ cr wcel cQ cP cmin
      co cabs cfv cP cU cmin co clt wbr cU cQ clt wbr cQ cr wcel cQ cP cmin co
      cabs cfv cP cU cmin co clt wbr wa cP cP cU cmin co cmin co cQ cU clt cQ
      cr wcel cQ cP cmin co cabs cfv cP cU cmin co clt wbr cP cP cU cmin co
      cmin co cQ clt wbr cQ cP cP cU cmin co caddc co clt wbr cQ cr wcel cP cr
      wcel cP cU cmin co cr wcel cQ cP cmin co cabs cfv cP cU cmin co clt wbr
      cP cP cU cmin co cmin co cQ clt wbr cQ cP cP cU cmin co caddc co clt wbr
      wa wb ivthlem1.2 cP cU ivthlem1.2 ivthlem1.1 resubcli cQ cP cP cU cmin co
      absdiflt mp3an23 pm3.26bda cP cc wcel cU cc wcel cP cP cU cmin co cmin co
      cU wceq cP ivthlem1.2 recni cU ivthlem1.1 recni cP cU nncan mp2an
      syl5eqbrr ex sylbid cQ cr wcel cP cQ cmin co cabs cfv cU cP cmin co clt
      wbr cQ cP cmin co cabs cfv cU cP cmin co clt wbr cQ cU clt wbr cQ cr wcel
      cP cQ cmin co cabs cfv cQ cP cmin co cabs cfv cU cP cmin co clt cP cc
      wcel cQ cc wcel cP cQ cmin co cabs cfv cQ cP cmin co cabs cfv wceq cQ cr
      wcel cP cQ abssub cP ivthlem1.2 recni cQ recn sylancr breq1d cQ cr wcel
      cQ cP cmin co cabs cfv cU cP cmin co clt wbr cQ cU clt wbr cQ cr wcel cQ
      cP cmin co cabs cfv cU cP cmin co clt wbr wa cQ cP cU cP cmin co caddc co
      cU clt cQ cr wcel cQ cP cmin co cabs cfv cU cP cmin co clt wbr cP cU cP
      cmin co cmin co cQ clt wbr cQ cP cU cP cmin co caddc co clt wbr cQ cr
      wcel cP cr wcel cU cP cmin co cr wcel cQ cP cmin co cabs cfv cU cP cmin
      co clt wbr cP cU cP cmin co cmin co cQ clt wbr cQ cP cU cP cmin co caddc
      co clt wbr wa wb ivthlem1.2 cU cP ivthlem1.1 ivthlem1.2 resubcli cQ cP cU
      cP cmin co absdiflt mp3an23 pm3.27bda cP cU cP ivthlem1.2 recni cU
      ivthlem1.1 recni pncan3i syl6breq ex sylbid pm3.2i $.
      $( [26-Nov-2007] $) $( [8-Oct-2007] $)

    ${
      ivthlem2.3 $e |- A. y e. RR+ E. z e. RR+ A. w e. R ( W < z -> H < y ) $.
      $( Lemma for ~ isupivthi . $)
      ivthlem2 $p |- ( U < P ->
            E. z e. RR+ A. w e. R ( W < z -> H < ( P - U ) ) ) $=
        cU cP clt wbr cP cU cmin co crp wcel cW vz cv clt wbr cH cP cU cmin co
        clt wbr wi vw cR wral vz crp wrex cU cP clt wbr cc0 cP cU cmin co clt
        wbr cP cU cmin co crp wcel cU cP ivthlem1.1 ivthlem1.2 posdifi cP cU
        cmin co cr wcel cc0 cP cU cmin co clt wbr cP cU cmin co crp wcel cP cU
        ivthlem1.2 ivthlem1.1 resubcli cP cU cmin co crp wcel cP cU cmin co cr
        wcel cc0 cP cU cmin co clt wbr wa cP cU cmin co elrp biimpri mpan sylbi
        cW vz cv clt wbr cH vy cv clt wbr wi vw cR wral vz crp wrex cW vz cv
        clt wbr cH cP cU cmin co clt wbr wi vw cR wral vz crp wrex vy cP cU
        cmin co crp vy cv cP cU cmin co wceq cW vz cv clt wbr cH vy cv clt wbr
        wi cW vz cv clt wbr cH cP cU cmin co clt wbr wi vz vw crp cR vy cv cP
        cU cmin co wceq cH vy cv clt wbr cH cP cU cmin co clt wbr cW vz cv clt
        wbr vy cv cP cU cmin co cH clt breq2 imbi2d rexralbidv ivthlem2.3
        vtoclri syl $.
        $( [26-Nov-2007] $) $( [8-Oct-2007] $)
    $}
  $}

  ${
    ivthlem3.1 $e |- ( ph -> E. z e. RR+ A. w e. A ( ps -> th ) ) $.
    ivthlem3.2 $e |- ( w e. A -> ( th -> ta ) ) $.
    $( Lemma for ~ isupivthi . $)
    ivthlem3 $p |- ( ph -> E. z ( z e. RR+ /\ A. w e. A ( ps -> ta ) ) ) $=
      wph wps wth wi vw cA wral vz crp wrex vz cv crp wcel wps wta wi vw cA
      wral wa vz wex ivthlem3.1 wps wth wi vw cA wral vz crp wrex wps wta wi vw
      cA wral vz crp wrex vz cv crp wcel wps wta wi vw cA wral wa vz wex wps
      wth wi vw cA wral wps wta wi vw cA wral vz crp wps wth wi vw cA wral wth
      wta wi vw cA wral wps wta wi vw cA wral wth wta wi vw cA ivthlem3.2 rgen
      wps wth wi wth wta wi wps wta wi vw cA wps wth wta imim1 r19.20sii mpi
      r19.22si wps wta wi vw cA wral vz crp df-rex sylib syl $.
      $( [26-Nov-2007] $) $( [8-Oct-2007] $)
  $}

  ${
    $d A c d v w x y z $.  $d B c d v w x y z $.  $d C d v w x y z $.
    $d F c d v w x y z $.  $d S v w x y $.  $d T v w x $.  $d U c d w y z $.
    ivthlem4.1 $e |- A e. RR $.
    ivthlem4.2 $e |- B e. RR $.
    ivthlem4.3 $e |- U e. RR $.
    ivthlem4.4 $e |- A < B $.
    ivthlem4.5 $e |- ( ( F ` A ) < U /\ U < ( F ` B ) ) $.
    ivthlem4.6 $e |- C = sup ( S , RR , < ) $.
    ivthlem4.7 $e |- S = { c e. ( A [,] B ) | ( F ` c ) <_ U } $.
    ivthlem4.8 $e |- F e. ( ( A [,] B ) -cn-> RR ) $.

    $( Lemma for ~ isupivthi . $)
    ivthlem4 $p |- ( ( S C_ RR /\ S =/= (/) /\
                        E. x e. RR A. y e. S y <_ x ) /\ A e. S ) $=
      cS cr wss cS c0 wne vy cv vx cv cle wbr vy cS wral vx cr wrex w3a cA cS
      wcel cA cr wcel cB cr wcel cS cr wss cS c0 wne vy cv vx cv cle wbr vy cS
      wral vx cr wrex w3a ivthlem4.1 ivthlem4.2 cA cr wcel cB cr wcel wa cS cA
      cB cicc co wss cA cS wcel cS cr wss cS c0 wne vy cv vx cv cle wbr vy cS
      wral vx cr wrex w3a cS vc cv cF cfv cU cle wbr vc cA cB cicc co crab cA
      cB cicc co ivthlem4.7 vc cv cF cfv cU cle wbr vc cA cB cicc co ssrab2
      eqsstri cA cS wcel cA cA cB cicc co wcel cA cF cfv cU cle wbr vc cv cF
      cfv cU cle wbr cA cF cfv cU cle wbr vc cA cA cB cicc co cS vc cv cA wceq
      vc cv cF cfv cA cF cfv cU cle vc cv cA cF fveq2 breq1d ivthlem4.7 elrab2
      cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel ivthlem4.1
      ivthlem4.2 cA cB ivthlem4.1 ivthlem4.2 ivthlem4.4 ltleii cA cB lbicc2
      mp3an cA cF cfv cU cA cA cB cicc co wcel cA cF cfv cr wcel cA cr wcel cB
      cr wcel cA cB cle wbr cA cA cB cicc co wcel ivthlem4.1 ivthlem4.2 cA cB
      ivthlem4.1 ivthlem4.2 ivthlem4.4 ltleii cA cB lbicc2 mp3an cA cB cicc co
      cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cA cB cicc co wcel
      cA cF cfv cr wcel wi cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc
      co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri
      axresscn ivthlem4.8 cA cB cicc co cr cA cF cncffvelrn mp3an ax-mp
      ivthlem4.3 cA cF cfv cU clt wbr cU cB cF cfv clt wbr ivthlem4.5 pm3.26i
      ltleii mpbir2an vx vy cA cB cA cS iccsupr mp3an23 mp2an cA cS wcel cA cA
      cB cicc co wcel cA cF cfv cU cle wbr vc cv cF cfv cU cle wbr cA cF cfv cU
      cle wbr vc cA cA cB cicc co cS vc cv cA wceq vc cv cF cfv cA cF cfv cU
      cle vc cv cA cF fveq2 breq1d ivthlem4.7 elrab2 cA cr wcel cB cr wcel cA
      cB cle wbr cA cA cB cicc co wcel ivthlem4.1 ivthlem4.2 cA cB ivthlem4.1
      ivthlem4.2 ivthlem4.4 ltleii cA cB lbicc2 mp3an cA cF cfv cU cA cA cB
      cicc co wcel cA cF cfv cr wcel cA cr wcel cB cr wcel cA cB cle wbr cA cA
      cB cicc co wcel ivthlem4.1 ivthlem4.2 cA cB ivthlem4.1 ivthlem4.2
      ivthlem4.4 ltleii cA cB lbicc2 mp3an cA cB cicc co cc wss cr cc wss cF cA
      cB cicc co cr ccncf co wcel cA cA cB cicc co wcel cA cF cfv cr wcel wi cA
      cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn ivthlem4.8 cA cB
      cicc co cr cA cF cncffvelrn mp3an ax-mp ivthlem4.3 cA cF cfv cU clt wbr
      cU cB cF cfv clt wbr ivthlem4.5 pm3.26i ltleii mpbir2an pm3.2i $.
      $( [22-Jan-2008] $) $( [8-Oct-2007] $)

    $( Lemma for ~ isupivthi . $)
    ivthlem5 $p |- C e. ( A [,] B ) $=
      cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cC cr
      wcel cA cC cle wbr cC cB cle wbr cC cS cr clt csup cr ivthlem4.6 vx vy cS
      cS cr wss cS c0 wne vy cv vx cv cle wbr vy cS wral vx cr wrex w3a cA cS
      wcel vx vy cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
      ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem4 pm3.26i
      suprclii eqeltri cA cS cr clt csup cC cle cS cr wss cS c0 wne vy cv vx cv
      cle wbr vy cS wral vx cr wrex w3a cA cS wcel wa cA cS cr clt csup cle wbr
      vx vy cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
      ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem4 vx vy cS cA suprub
      ax-mp ivthlem4.6 breqtrri cC cS cr clt csup cB cle ivthlem4.6 cB cr wcel
      vv cv cB cle wbr vv cS wral cS cr clt csup cB cle wbr ivthlem4.2 vv cv cB
      cle wbr vv cS vv cv cS wcel vv cv cr wcel cA vv cv cle wbr vv cv cB cle
      wbr vv cv cS wcel vv cv cA cB cicc co wcel vv cv cr wcel cA vv cv cle wbr
      vv cv cB cle wbr w3a cS cA cB cicc co vv cv cS vc cv cF cfv cU cle wbr vc
      cA cB cicc co crab cA cB cicc co ivthlem4.7 vc cv cF cfv cU cle wbr vc cA
      cB cicc co ssrab2 eqsstri sseli cA cr wcel cB cr wcel vv cv cA cB cicc co
      wcel vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wb ivthlem4.1
      ivthlem4.2 cA cB vv cv elicc2 mp2an sylib 3simp3d rgen vx vy vv cS cB cS
      cr wss cS c0 wne vy cv vx cv cle wbr vy cS wral vx cr wrex w3a cA cS wcel
      vx vy cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
      ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem4 pm3.26i suprleubii
      mp2an eqbrtri 3pm3.2i cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC
      elicc2 mp2an mpbir $.
      $( [22-Jan-2008] $) $( [8-Oct-2007] $)

    ${
      $d C w x $.  $d D w x $.  $d P x $.  $d ph x $.  $d ps x $.  $d ch x $.
      ivthlem6.9 $e |- ( ph <-> D e. RR+ ) $.
      ivthlem6.10 $e |- ( ps <-> A. w e. ( A [,] B )
                           ( ( abs ` ( C - w ) ) < D -> U < ( F ` w ) ) ) $.
      ivthlem6.11 $e |- ( ch <-> A. w e. ( A [,] B )
                           ( ( abs ` ( C - w ) ) < D -> ( F ` w ) < U ) ) $.
      ivthlem6.12 $e |- P = if ( B <_ ( C + D ) , B , ( C + D ) ) $.

      $( Lemma for ~ isupivthi : modus tollens case 1. $)
      ivthlem6 $p |- -. ( ph /\ ps ) $=
        wph wps wa wn vx wex wph wps wa wn wph wps wa wn vx cS wrex wph wps wa
        wn vx wex cC cD cmin co vx cv clt wbr wph wps wa wn wi cC cD cmin co vx
        cv clt wbr wn wph wps wa wn wi wa vx cS wrex wph wps wa wn vx cS wrex
        cC cD cmin co vx cv clt wbr wph wps wa wn wi vx cS wral cC cD cmin co
        vx cv clt wbr wn wph wps wa wn wi vx cS wrex cC cD cmin co vx cv clt
        wbr wph wps wa wn wi cC cD cmin co vx cv clt wbr wn wph wps wa wn wi wa
        vx cS wrex cC cD cmin co vx cv clt wbr wph wps wa wn wi vx cS vx cv cS
        wcel wph wps wa cC cD cmin co vx cv clt wbr vx cv cS wcel wph wps cC cD
        cmin co vx cv clt wbr wn vx cv cS wcel wph wps w3a cC cD cmin co vx cv
        clt wbr cU vx cv cF cfv clt wbr vx cv cS wcel wph cU vx cv cF cfv clt
        wbr wn wps vx cv cS wcel vx cv cF cfv cU cle wbr cU vx cv cF cfv clt
        wbr wn vx cv cS wcel vx cv cA cB cicc co wcel vx cv cF cfv cU cle wbr
        vc cv cF cfv cU cle wbr vx cv cF cfv cU cle wbr vc vx cv cA cB cicc co
        cS vc cv vx cv wceq vc cv cF cfv vx cv cF cfv cU cle vc cv vx cv cF
        fveq2 breq1d ivthlem4.7 elrab2 pm3.27bi vx cv cF cfv cr wcel cU cr wcel
        vx cv cF cfv cU cle wbr cU vx cv cF cfv clt wbr wn wb vx cv cS wcel vx
        cv cF cfv cU lenlt vx cv cS wcel vx cv cA cB cicc co wcel vx cv cF cfv
        cr wcel vx cv cS wcel vx cv cA cB cicc co wcel vx cv cF cfv cU cle wbr
        vc cv cF cfv cU cle wbr vx cv cF cfv cU cle wbr vc vx cv cA cB cicc co
        cS vc cv vx cv wceq vc cv cF cfv vx cv cF cfv cU cle vc cv vx cv cF
        fveq2 breq1d ivthlem4.7 elrab2 pm3.26bi cA cB cicc co cc wss cr cc wss
        cF cA cB cicc co cr ccncf co wcel vx cv cA cB cicc co wcel vx cv cF cfv
        cr wcel wi cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr
        wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn
        ivthlem4.8 cA cB cicc co cr vx cv cF cncffvelrn mp3an syl ivthlem4.3
        sylancl mpbid 3ad2ant1 vx cv cS wcel wph wps w3a cC cD cmin co vx cv
        clt wbr vx cv cC cD caddc co clt wbr cU vx cv cF cfv clt wbr vx cv cS
        wcel wph vx cv cC cD caddc co clt wbr wps vx cv cS wcel wph wa vx cv cC
        cle wbr cC cC cD caddc co clt wbr vx cv cC cD caddc co clt wbr vx cv cS
        wcel vx cv cC cle wbr wph vx cv cS wcel vx cv cS cr clt csup cC cle vv
        vy cS vx cv cS cr wss cS c0 wne vy cv vv cv cle wbr vy cS wral vv cr
        wrex w3a cA cS wcel vv vy cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2
        ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8
        ivthlem4 pm3.26i suprubii ivthlem4.6 syl6breqr adantr wph cC cC cD
        caddc co clt wbr vx cv cS wcel wph cC cD cmin co cC clt wbr cC cC cD
        caddc co clt wbr wph cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC
        clt wbr cC cC cD caddc co clt wbr wa wph cc0 cD cC cC cmin co cabs cfv
        clt wph cD crp wcel cc0 cD clt wbr ivthlem6.9 cD rpgt0 sylbi cC cC cmin
        co cabs cfv cc0 cabs cfv cc0 cC cC cmin co cc0 cabs cC cC cC cr wcel cA
        cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr
        cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        recni subidi fveq2i abs0 eqtri syl5eqbr cC cr wcel cC cr wcel cD cr
        wcel cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC cC
        cD caddc co clt wbr wa wb wph cC cC cD absdiflt cC cr wcel wph cC cr
        wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2
        ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8
        ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2
        mp2an mpbi 3simp1i a1i cC cr wcel wph cC cr wcel cA cC cle wbr cC cB
        cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr
        w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr
        wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i a1i wph cD
        crp wcel cD cr wcel ivthlem6.9 cD rpre sylbi syl3anc mpbid pm3.27d
        adantl vx cv cr wcel cC cD caddc co cr wcel vx cv cC cle wbr cC cC cD
        caddc co clt wbr wa vx cv cC cD caddc co clt wbr wi vx cv cS wcel wph
        vx cv cr wcel cC cr wcel cC cD caddc co cr wcel vx cv cC cle wbr cC cC
        cD caddc co clt wbr wa vx cv cC cD caddc co clt wbr wi cC cr wcel cA cC
        cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC
        cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        vx cv cC cC cD caddc co lelttr mp3an2 vx cv cS wcel vx cv cr wcel cA vx
        cv cle wbr vx cv cB cle wbr vx cv cS wcel vx cv cA cB cicc co wcel vx
        cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cS wcel vx cv cA
        cB cicc co wcel vx cv cF cfv cU cle wbr vc cv cF cfv cU cle wbr vx cv
        cF cfv cU cle wbr vc vx cv cA cB cicc co cS vc cv vx cv wceq vc cv cF
        cfv vx cv cF cfv cU cle vc cv vx cv cF fveq2 breq1d ivthlem4.7 elrab2
        pm3.26bi cA cr wcel cB cr wcel vx cv cA cB cicc co wcel vx cv cr wcel
        cA vx cv cle wbr vx cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB vx
        cv elicc2 mp2an sylib 3simp1d cC cr wcel cD cr wcel cC cD caddc co cr
        wcel wph cC cD readdcl cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB
        cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i wph cD crp wcel cD cr
        wcel ivthlem6.9 cD rpre sylbi sylancr syl2an mp2and 3adant3 vx cv cA cB
        cicc co wcel wph wps cC cD cmin co vx cv clt wbr vx cv cC cD caddc co
        clt wbr wa cU vx cv cF cfv clt wbr wi vx cv cS wcel vx cv cA cB cicc co
        wcel wph wps w3a cC vx cv cmin co cabs cfv cD clt wbr cU vx cv cF cfv
        clt wbr wi cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr wa
        cU vx cv cF cfv clt wbr wi vx cv cA cB cicc co wcel wph wps cC vx cv
        cmin co cabs cfv cD clt wbr cU vx cv cF cfv clt wbr wi vx cv cA cB cicc
        co wcel wps cC vx cv cmin co cabs cfv cD clt wbr cU vx cv cF cfv clt
        wbr wi wi wph vx cv cA cB cicc co wcel cC vw cv cmin co cabs cfv cD clt
        wbr cU vw cv cF cfv clt wbr wi vw cA cB cicc co wral cC vx cv cmin co
        cabs cfv cD clt wbr cU vx cv cF cfv clt wbr wi wps cC vw cv cmin co
        cabs cfv cD clt wbr cU vw cv cF cfv clt wbr wi cC vx cv cmin co cabs
        cfv cD clt wbr cU vx cv cF cfv clt wbr wi vw vx cv cA cB cicc co vw cv
        vx cv wceq cC vw cv cmin co cabs cfv cD clt wbr cC vx cv cmin co cabs
        cfv cD clt wbr cU vw cv cF cfv clt wbr cU vx cv cF cfv clt wbr vw cv vx
        cv wceq cC vw cv cmin co cabs cfv cC vx cv cmin co cabs cfv cD clt vw
        cv vx cv wceq cC vw cv cmin co cC vx cv cmin co cabs vw cv vx cv cC
        cmin opreq2 fveq2d breq1d vw cv vx cv wceq vw cv cF cfv vx cv cF cfv cU
        clt vw cv vx cv cF fveq2 breq2d imbi12d rcla4v ivthlem6.10 syl5ib
        adantr 3impia vx cv cA cB cicc co wcel wph cC vx cv cmin co cabs cfv cD
        clt wbr cU vx cv cF cfv clt wbr wi cC cD cmin co vx cv clt wbr vx cv cC
        cD caddc co clt wbr wa cU vx cv cF cfv clt wbr wi wi wps vx cv cA cB
        cicc co wcel wph wa cC vx cv cmin co cabs cfv cD clt wbr cU vx cv cF
        cfv clt wbr wi cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr
        wa cU vx cv cF cfv clt wbr wi vx cv cA cB cicc co wcel wph wa cC vx cv
        cmin co cabs cfv cD clt wbr cC cD cmin co vx cv clt wbr vx cv cC cD
        caddc co clt wbr wa cU vx cv cF cfv clt wbr vx cv cA cB cicc co wcel
        wph wa vx cv cC cmin co cabs cfv cD clt wbr cC vx cv cmin co cabs cfv
        cD clt wbr cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr wa
        vx cv cA cB cicc co wcel wph wa vx cv cC cmin co cabs cfv cC vx cv cmin
        co cabs cfv cD clt vx cv cA cB cicc co wcel vx cv cC cmin co cabs cfv
        cC vx cv cmin co cabs cfv wceq wph vx cv cc wcel cC cc wcel vx cv cC
        cmin co cabs cfv cC vx cv cmin co cabs cfv wceq vx cv cA cB cicc co
        wcel vx cv cC abssub vx cv cA cB cicc co wcel vx cv vx cv cA cB cicc co
        wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr vx cv cA cB cicc
        co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel
        cB cr wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx
        cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB vx cv elicc2 mp2an
        biimpi 3simp1d recnd cC cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB
        cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i recni sylancl adantr
        breq1d vx cv cr wcel cD cr wcel vx cv cC cmin co cabs cfv cD clt wbr cC
        cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr wa wb vx cv cA cB
        cicc co wcel wph vx cv cr wcel cC cr wcel cD cr wcel vx cv cC cmin co
        cabs cfv cD clt wbr cC cD cmin co vx cv clt wbr vx cv cC cD caddc co
        clt wbr wa wb cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i vx cv cC cD absdiflt
        mp3an2 vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
        cle wbr vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv
        cB cle wbr w3a cA cr wcel cB cr wcel vx cv cA cB cicc co wcel vx cv cr
        wcel cA vx cv cle wbr vx cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA
        cB vx cv elicc2 mp2an biimpi 3simp1d wph cD crp wcel cD cr wcel
        ivthlem6.9 cD rpre sylbi syl2an bitr3d imbi1d biimpd 3adant3 mpd vx cv
        cS wcel vx cv cA cB cicc co wcel vx cv cF cfv cU cle wbr vc cv cF cfv
        cU cle wbr vx cv cF cfv cU cle wbr vc vx cv cA cB cicc co cS vc cv vx
        cv wceq vc cv cF cfv vx cv cF cfv cU cle vc cv vx cv cF fveq2 breq1d
        ivthlem4.7 elrab2 pm3.26bi syl3an1 mpan2d mtod 3expib con2d rgen wph cC
        cD cmin co vx cv clt wbr wi vx cS wrex cC cD cmin co vx cv clt wbr wn
        wph wps wa wn wi vx cS wrex wph cC cD cmin co vx cv clt wbr wi vx cS
        wrex wph cC cD cmin co vx cv clt wbr vx cS wrex wi cC cD cmin co cr
        wcel cC cD cmin co cS cr clt csup clt wbr cC cD cmin co vx cv clt wbr
        vx cS wrex wph vv vy vx cS cC cD cmin co cS cr wss cS c0 wne vy cv vv
        cv cle wbr vy cS wral vv cr wrex w3a cA cS wcel vv vy cA cB cC cS cU cF
        vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem4 pm3.26i suprlubii cC cr wcel cD cr wcel
        cC cD cmin co cr wcel wph cC cD resubcl cC cr wcel cA cC cle wbr cC cB
        cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr
        w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr
        wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i wph cD crp
        wcel cD cr wcel ivthlem6.9 cD rpre sylbi sylancr wph cC cD cmin co cC
        cS cr clt csup clt wph cC cD cmin co cC clt wbr cC cC cD caddc co clt
        wbr wph cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC
        cC cD caddc co clt wbr wa wph cc0 cD cC cC cmin co cabs cfv clt wph cD
        crp wcel cc0 cD clt wbr ivthlem6.9 cD rpgt0 sylbi cC cC cmin co cabs
        cfv cc0 cabs cfv cc0 cC cC cmin co cc0 cabs cC cC cC cr wcel cA cC cle
        wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        recni subidi fveq2i abs0 eqtri syl5eqbr cC cr wcel cC cr wcel cD cr
        wcel cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC cC
        cD caddc co clt wbr wa wb wph cC cC cD absdiflt cC cr wcel wph cC cr
        wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2
        ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8
        ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2
        mp2an mpbi 3simp1i a1i cC cr wcel wph cC cr wcel cA cC cle wbr cC cB
        cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr
        w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr
        wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i a1i wph cD
        crp wcel cD cr wcel ivthlem6.9 cD rpre sylbi syl3anc mpbid pm3.26d
        ivthlem4.6 syl6breq sylanc cS c0 wne wph cC cD cmin co vx cv clt wbr wi
        vx cS wrex wph cC cD cmin co vx cv clt wbr vx cS wrex wi wb cS cr wss
        cS c0 wne vy cv vv cv cle wbr vy cS wral vv cr wrex cS cr wss cS c0 wne
        vy cv vv cv cle wbr vy cS wral vv cr wrex w3a cA cS wcel vv vy cA cB cC
        cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
        ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem4 pm3.26i 3simp2i wph cC cD
        cmin co vx cv clt wbr vx cS r19.37zv ax-mp mpbir wph cC cD cmin co vx
        cv clt wbr wi cC cD cmin co vx cv clt wbr wn wph wps wa wn wi vx cS wph
        cC cD cmin co vx cv clt wbr wi wph wps wa cC cD cmin co vx cv clt wbr
        wph wps cC cD cmin co vx cv clt wbr pm3.41 con3d r19.22si ax-mp cC cD
        cmin co vx cv clt wbr wph wps wa wn wi cC cD cmin co vx cv clt wbr wn
        wph wps wa wn wi vx cS r19.29 mp2an cC cD cmin co vx cv clt wbr wph wps
        wa wn wi cC cD cmin co vx cv clt wbr wn wph wps wa wn wi wa wph wps wa
        wn vx cS cC cD cmin co vx cv clt wbr wph wps wa wn pm4.83 rexbii mpbi
        wph wps wa wn vx cS rexex ax-mp wph wps wa wn vx 19.9v mpbi $.
        $( [22-Jan-2008] $) $( [8-Oct-2007] $)

      $( Lemma for ~ isupivthi : modus tollens case 2. $)
      ivthlem7 $p |- -. ( ph /\ ch ) $=
        wph wch wa wn vx wex wph wch wa wn wph wch wa wn vx cA cB cicc co wrex
        wph wch wa wn vx wex wph wch wa cC vx cv clt wbr vx cv cP clt wbr wa wn
        wi cC vx cv clt wbr vx cv cP clt wbr wa wn wph wch wa wn wi wa vx cA cB
        cicc co wrex wph wch wa wn vx cA cB cicc co wrex wph wch wa cC vx cv
        clt wbr vx cv cP clt wbr wa wn wi vx cA cB cicc co wral cC vx cv clt
        wbr vx cv cP clt wbr wa wn wph wch wa wn wi vx cA cB cicc co wrex wph
        wch wa cC vx cv clt wbr vx cv cP clt wbr wa wn wi cC vx cv clt wbr vx
        cv cP clt wbr wa wn wph wch wa wn wi wa vx cA cB cicc co wrex wph wch
        wa cC vx cv clt wbr vx cv cP clt wbr wa wn wi vx cA cB cicc co vx cv cA
        cB cicc co wcel wph wch cC vx cv clt wbr vx cv cP clt wbr wa wn vx cv
        cA cB cicc co wcel wph wch w3a cC vx cv clt wbr vx cv cP clt wbr wa cC
        vx cv clt wbr cC vx cv clt wbr vx cv cP clt wbr wa cC vx cv clt wbr wi
        vx cv cA cB cicc co wcel wph wch w3a cC vx cv clt wbr vx cv cP clt wbr
        pm3.26 a1i vx cv cA cB cicc co wcel wph wch w3a cC vx cv clt wbr vx cv
        cP clt wbr wa vx cv cS wcel cC vx cv clt wbr wn vx cv cA cB cicc co
        wcel wph wch w3a cC vx cv clt wbr vx cv cP clt wbr wa vx cv cF cfv cU
        clt wbr vx cv cF cfv cU cle wbr vx cv cS wcel vx cv cA cB cicc co wcel
        wph wch w3a cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr vx
        cv cF cfv cU clt wbr cC vx cv clt wbr vx cv cP clt wbr vx cv cA cB cicc
        co wcel wph wch w3a cC vx cv cmin co cabs cfv cD clt wbr vx cv cF cfv
        cU clt wbr wi cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr
        wa vx cv cF cfv cU clt wbr wi vx cv cA cB cicc co wcel wph wch cC vx cv
        cmin co cabs cfv cD clt wbr vx cv cF cfv cU clt wbr wi vx cv cA cB cicc
        co wcel wch cC vx cv cmin co cabs cfv cD clt wbr vx cv cF cfv cU clt
        wbr wi wi wph vx cv cA cB cicc co wcel cC vw cv cmin co cabs cfv cD clt
        wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral cC vx cv cmin co
        cabs cfv cD clt wbr vx cv cF cfv cU clt wbr wi wch cC vw cv cmin co
        cabs cfv cD clt wbr vw cv cF cfv cU clt wbr wi cC vx cv cmin co cabs
        cfv cD clt wbr vx cv cF cfv cU clt wbr wi vw vx cv cA cB cicc co vw cv
        vx cv wceq cC vw cv cmin co cabs cfv cD clt wbr cC vx cv cmin co cabs
        cfv cD clt wbr vw cv cF cfv cU clt wbr vx cv cF cfv cU clt wbr vw cv vx
        cv wceq cC vw cv cmin co cabs cfv cC vx cv cmin co cabs cfv cD clt vw
        cv vx cv wceq cC vw cv cmin co cC vx cv cmin co cabs vw cv vx cv cC
        cmin opreq2 fveq2d breq1d vw cv vx cv wceq vw cv cF cfv vx cv cF cfv cU
        clt vw cv vx cv cF fveq2 breq1d imbi12d rcla4v ivthlem6.11 syl5ib
        adantr 3impia vx cv cA cB cicc co wcel wph cC vx cv cmin co cabs cfv cD
        clt wbr vx cv cF cfv cU clt wbr wi cC cD cmin co vx cv clt wbr vx cv cC
        cD caddc co clt wbr wa vx cv cF cfv cU clt wbr wi wi wch vx cv cA cB
        cicc co wcel wph wa cC vx cv cmin co cabs cfv cD clt wbr vx cv cF cfv
        cU clt wbr wi cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr
        wa vx cv cF cfv cU clt wbr wi vx cv cA cB cicc co wcel wph wa cC vx cv
        cmin co cabs cfv cD clt wbr cC cD cmin co vx cv clt wbr vx cv cC cD
        caddc co clt wbr wa vx cv cF cfv cU clt wbr vx cv cA cB cicc co wcel
        wph wa vx cv cC cmin co cabs cfv cD clt wbr cC vx cv cmin co cabs cfv
        cD clt wbr cC cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr wa
        vx cv cA cB cicc co wcel wph wa vx cv cC cmin co cabs cfv cC vx cv cmin
        co cabs cfv cD clt vx cv cA cB cicc co wcel vx cv cC cmin co cabs cfv
        cC vx cv cmin co cabs cfv wceq wph vx cv cc wcel cC cc wcel vx cv cC
        cmin co cabs cfv cC vx cv cmin co cabs cfv wceq vx cv cA cB cicc co
        wcel vx cv cC abssub vx cv cA cB cicc co wcel vx cv vx cv cA cB cicc co
        wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr vx cv cA cB cicc
        co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel
        cB cr wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx
        cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB vx cv elicc2 mp2an
        biimpi 3simp1d recnd cC cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB
        cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i recni sylancl adantr
        breq1d vx cv cr wcel cD cr wcel vx cv cC cmin co cabs cfv cD clt wbr cC
        cD cmin co vx cv clt wbr vx cv cC cD caddc co clt wbr wa wb vx cv cA cB
        cicc co wcel wph vx cv cr wcel cC cr wcel cD cr wcel vx cv cC cmin co
        cabs cfv cD clt wbr cC cD cmin co vx cv clt wbr vx cv cC cD caddc co
        clt wbr wa wb cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i vx cv cC cD absdiflt
        mp3an2 vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
        cle wbr vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv
        cB cle wbr w3a cA cr wcel cB cr wcel vx cv cA cB cicc co wcel vx cv cr
        wcel cA vx cv cle wbr vx cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA
        cB vx cv elicc2 mp2an biimpi 3simp1d wph cD crp wcel cD cr wcel
        ivthlem6.9 cD rpre sylbi syl2an bitr3d imbi1d biimpd 3adant3 mpd vx cv
        cA cB cicc co wcel wph cC vx cv clt wbr cC cD cmin co vx cv clt wbr wi
        wch vx cv cA cB cicc co wcel wph wa cC cD cmin co cC clt wbr cC vx cv
        clt wbr cC cD cmin co vx cv clt wbr wph cC cD cmin co cC clt wbr vx cv
        cA cB cicc co wcel wph cC cD cmin co cC clt wbr cC cC cD caddc co clt
        wbr wph cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC
        cC cD caddc co clt wbr wa wph cc0 cD cC cC cmin co cabs cfv clt wph cD
        crp wcel cc0 cD clt wbr ivthlem6.9 cD rpgt0 sylbi cC cC cmin co cabs
        cfv cc0 cabs cfv cc0 cC cC cmin co cc0 cabs cC cC cC cr wcel cA cC cle
        wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        recni subidi fveq2i abs0 eqtri syl5eqbr cC cr wcel cC cr wcel cD cr
        wcel cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC cC
        cD caddc co clt wbr wa wb wph cC cC cD absdiflt cC cr wcel wph cC cr
        wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2
        ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8
        ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2
        mp2an mpbi 3simp1i a1i cC cr wcel wph cC cr wcel cA cC cle wbr cC cB
        cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr
        w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr
        wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i a1i wph cD
        crp wcel cD cr wcel ivthlem6.9 cD rpre sylbi syl3anc mpbid pm3.26d
        adantl wph vx cv cA cB cicc co wcel cC cD cmin co cC clt wbr cC vx cv
        clt wbr wa cC cD cmin co vx cv clt wbr wi cC cD cmin co cr wcel vx cv
        cr wcel cC cD cmin co cC clt wbr cC vx cv clt wbr wa cC cD cmin co vx
        cv clt wbr wi wph vx cv cA cB cicc co wcel cC cD cmin co cr wcel cC cr
        wcel vx cv cr wcel cC cD cmin co cC clt wbr cC vx cv clt wbr wa cC cD
        cmin co vx cv clt wbr wi cC cr wcel cA cC cle wbr cC cB cle wbr cC cA
        cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS
        cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
        ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA
        cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb
        ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i cC cD cmin co
        cC vx cv axlttrn mp3an2 cC cr wcel cD cr wcel cC cD cmin co cr wcel wph
        cC cD resubcl cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i wph cD crp wcel cD cr
        wcel ivthlem6.9 cD rpre sylbi sylancr vx cv cA cB cicc co wcel vx cv cr
        wcel cA vx cv cle wbr vx cv cB cle wbr vx cv cA cB cicc co wcel vx cv
        cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel vx
        cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
        w3a wb ivthlem4.1 ivthlem4.2 cA cB vx cv elicc2 mp2an biimpi 3simp1d
        syl2an ancoms mpand 3adant3 vx cv cA cB cicc co wcel wph vx cv cP clt
        wbr vx cv cC cD caddc co clt wbr wi wch vx cv cA cB cicc co wcel wph wa
        vx cv cP clt wbr vx cv cB clt wbr wi vx cv cP clt wbr vx cv cC cD caddc
        co clt wbr wi vx cv cA cB cicc co wcel wph wa vx cv cP clt wbr vx cv cB
        clt wbr vx cv cC cD caddc co clt wbr wa wi vx cv cP clt wbr vx cv cB
        clt wbr wi vx cv cP clt wbr vx cv cC cD caddc co clt wbr wi wa vx cv cA
        cB cicc co wcel wph wa vx cv cP clt wbr vx cv cB clt wbr vx cv cC cD
        caddc co clt wbr wa vx cv cr wcel cC cD caddc co cr wcel vx cv cP clt
        wbr vx cv cB clt wbr vx cv cC cD caddc co clt wbr wa wb vx cv cA cB
        cicc co wcel wph vx cv cr wcel cB cr wcel cC cD caddc co cr wcel vx cv
        cP clt wbr vx cv cB clt wbr vx cv cC cD caddc co clt wbr wa wb
        ivthlem4.2 vx cv cr wcel cB cr wcel cC cD caddc co cr wcel w3a vx cv cB
        cC cD caddc co cle wbr cB cC cD caddc co cif clt wbr vx cv cB clt wbr
        vx cv cC cD caddc co clt wbr wa vx cv cP clt wbr vx cv cB cC cD caddc
        co ltmin cP cB cC cD caddc co cle wbr cB cC cD caddc co cif vx cv clt
        ivthlem6.12 breq2i syl5bb mp3an2 vx cv cA cB cicc co wcel vx cv cr wcel
        cA vx cv cle wbr vx cv cB cle wbr vx cv cA cB cicc co wcel vx cv cr
        wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel vx cv
        cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB vx cv elicc2 mp2an biimpi 3simp1d cC cr
        wcel cD cr wcel cC cD caddc co cr wcel wph cC cD readdcl cC cr wcel cA
        cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr
        cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        wph cD crp wcel cD cr wcel ivthlem6.9 cD rpre sylbi sylancr syl2an
        biimpd vx cv cP clt wbr vx cv cB clt wbr vx cv cC cD caddc co clt wbr
        jcab sylib pm3.27d 3adant3 syl2and vx cv cA cB cicc co wcel wph vx cv
        cF cfv cU clt wbr vx cv cF cfv cU cle wbr wi wch vx cv cF cfv cr wcel
        cU cr wcel vx cv cF cfv cU clt wbr vx cv cF cfv cU cle wbr wi vx cv cA
        cB cicc co wcel vx cv cF cfv cU ltle cA cB cicc co cc wss cr cc wss cF
        cA cB cicc co cr ccncf co wcel vx cv cA cB cicc co wcel vx cv cF cfv cr
        wcel wi cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss
        ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn
        ivthlem4.8 cA cB cicc co cr vx cv cF cncffvelrn mp3an ivthlem4.3
        sylancl 3ad2ant1 vx cv cA cB cicc co wcel wph vx cv cF cfv cU cle wbr
        vx cv cS wcel wi wch vx cv cA cB cicc co wcel vx cv cF cfv cU cle wbr
        vx cv cS wcel vx cv cS wcel vx cv cA cB cicc co wcel vx cv cF cfv cU
        cle wbr wa vc cv cF cfv cU cle wbr vx cv cF cfv cU cle wbr vc vx cv cA
        cB cicc co cS vc cv vx cv wceq vc cv cF cfv vx cv cF cfv cU cle vc cv
        vx cv cF fveq2 breq1d ivthlem4.7 elrab2 biimpri ex 3ad2ant1 3syld vx cv
        cS wcel vx cv cC cle wbr cC vx cv clt wbr wn vx cv cS wcel vx cv cS cr
        clt csup cC cle vv vw cS vx cv cS cr wss cS c0 wne vw cv vv cv cle wbr
        vw cS wral vv cr wrex w3a cA cS wcel vv vw cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem4 pm3.26i suprubii ivthlem4.6 syl6breqr vx
        cv cr wcel cC cr wcel vx cv cC cle wbr cC vx cv clt wbr wn wb vx cv cS
        wcel vx cv cC lenlt vx cv cS wcel vx cv cr wcel cA vx cv cle wbr vx cv
        cB cle wbr vx cv cS wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx
        cv cle wbr vx cv cB cle wbr w3a vx cv cS wcel vx cv cA cB cicc co wcel
        vx cv cF cfv cU cle wbr vc cv cF cfv cU cle wbr vx cv cF cfv cU cle wbr
        vc vx cv cA cB cicc co cS vc cv vx cv wceq vc cv cF cfv vx cv cF cfv cU
        cle vc cv vx cv cF fveq2 breq1d ivthlem4.7 elrab2 pm3.26bi cA cr wcel
        cB cr wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx
        cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB vx cv elicc2 mp2an
        sylib 3simp1d cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i sylancl mpbid syl6
        pm2.65d 3expib rgen wph wch wa cC vx cv clt wbr vx cv cP clt wbr wa wi
        vx cA cB cicc co wrex cC vx cv clt wbr vx cv cP clt wbr wa wn wph wch
        wa wn wi vx cA cB cicc co wrex wph wch wa cC vx cv clt wbr vx cv cP clt
        wbr wa wi vx cA cB cicc co wrex wph wch wa cC vx cv clt wbr vx cv cP
        clt wbr wa vx cA cB cicc co wrex wi wph wch wa vx cv cA cB cicc co wcel
        cC vx cv clt wbr vx cv cP clt wbr wa wa vx wex cC vx cv clt wbr vx cv
        cP clt wbr wa vx cA cB cicc co wrex wph wch wa vx cv cr wcel cC vx cv
        clt wbr vx cv cP clt wbr wa wa vx wex vx cv cA cB cicc co wcel cC vx cv
        clt wbr vx cv cP clt wbr wa wa vx wex wph wch wa cC vx cv clt wbr vx cv
        cP clt wbr wa vx cr wrex vx cv cr wcel cC vx cv clt wbr vx cv cP clt
        wbr wa wa vx wex wph wch wa cC vx cv clt wbr vx cv cP clt wbr wa vx cq
        wrex cC vx cv clt wbr vx cv cP clt wbr wa vx cr wrex cC cr wcel cP cr
        wcel cC cP clt wbr cC vx cv clt wbr vx cv cP clt wbr wa vx cq wrex wph
        wch wa vx cC cP qbtwnre cC cr wcel wph wch wa cC cr wcel cA cC cle wbr
        cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle
        wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        a1i wph cP cr wcel wch wph cB cC cD caddc co cle wbr cB cC cD caddc co
        cif cr cP cB cr wcel cC cD caddc co cr wcel cB cC cD caddc co cle wbr
        cB cC cD caddc co cif cr wcel wph cB cC cD caddc co cle wbr cB cC cD
        caddc co cr ifcl ivthlem4.2 cC cr wcel cD cr wcel cC cD caddc co cr
        wcel wph cC cD readdcl cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB
        cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i wph cD crp wcel cD cr
        wcel ivthlem6.9 cD rpre sylbi sylancr sylancr ivthlem6.12 syl5eqel
        adantr wph wch wa cC cB cC cD caddc co cle wbr cB cC cD caddc co cif cP
        clt wph wch wa cC cB cC cD caddc co cle wbr cB cC cD caddc co cif clt
        wbr cC cB clt wbr cC cC cD caddc co clt wbr wa wph wch wa cC cB clt wbr
        cC cC cD caddc co clt wbr wph wch wa cC cB wceq cC cB clt wbr cC cB
        wceq cC cF cfv cU clt wbr wph wch wa cC cB wceq cC cF cfv cU clt wbr cB
        cF cfv cU clt wbr cU cB cF cfv clt wbr cB cF cfv cU clt wbr wn cA cF
        cfv cU clt wbr cU cB cF cfv clt wbr ivthlem4.5 pm3.27i cU cB cF cfv
        ivthlem4.3 cB cA cB cicc co wcel cB cF cfv cr wcel cA cr wcel cB cr
        wcel cA cB cle wbr cB cA cB cicc co wcel ivthlem4.1 ivthlem4.2 cA cB
        ivthlem4.1 ivthlem4.2 ivthlem4.4 ltleii cA cB ubicc2 mp3an cA cB cicc
        co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cB cA cB cicc co
        wcel cB cF cfv cr wcel wi cA cB cicc co cr cc cA cr wcel cB cr wcel cA
        cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn
        sstri axresscn ivthlem4.8 cA cB cicc co cr cB cF cncffvelrn mp3an ax-mp
        ltnsymi ax-mp cC cB wceq cC cF cfv cB cF cfv cU clt cC cB cF fveq2
        breq1d mtbiri cC cC cmin co cabs cfv cD clt wbr wch cC cF cfv cU clt
        wbr wph wch cC cC cmin co cabs cfv cD clt wbr cC cF cfv cU clt wbr wch
        cC vw cv cmin co cabs cfv cD clt wbr vw cv cF cfv cU clt wbr wi vw cA
        cB cicc co wral cC cC cmin co cabs cfv cD clt wbr cC cF cfv cU clt wbr
        wi ivthlem6.11 cC cA cB cicc co wcel cC vw cv cmin co cabs cfv cD clt
        wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral cC cC cmin co cabs
        cfv cD clt wbr cC cF cfv cU clt wbr wi wi cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cC vw cv cmin co cabs cfv cD clt wbr vw
        cv cF cfv cU clt wbr wi cC cC cmin co cabs cfv cD clt wbr cC cF cfv cU
        clt wbr wi vw cC cA cB cicc co vw cv cC wceq cC vw cv cmin co cabs cfv
        cD clt wbr cC cC cmin co cabs cfv cD clt wbr vw cv cF cfv cU clt wbr cC
        cF cfv cU clt wbr vw cv cC wceq cC vw cv cmin co cabs cfv cC cC cmin co
        cabs cfv cD clt vw cv cC wceq cC vw cv cmin co cC cC cmin co cabs vw cv
        cC cC cmin opreq2 fveq2d breq1d vw cv cC wceq vw cv cF cfv cC cF cfv cU
        clt vw cv cC cF fveq2 breq1d imbi12d rcla4v ax-mp sylbi impcom wph cc0
        cD cC cC cmin co cabs cfv clt wph cD crp wcel cc0 cD clt wbr ivthlem6.9
        cD rpgt0 sylbi cC cC cmin co cabs cfv cc0 cabs cfv cc0 cC cC cmin co
        cc0 cabs cC cC cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i recni subidi fveq2i abs0
        eqtri syl5eqbr sylan nsyl3 cC cB wceq cC cB clt wbr wn cC cB wceq cC cB
        cle wbr cC cB clt wbr wn cC cr wcel cB cr wcel cC cB wceq cC cB cle wbr
        cC cB clt wbr wn wa wb cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB
        cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i ivthlem4.2 cC cB eqlelt
        mp2an cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC
        cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1
        ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
        ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr
        wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC
        elicc2 mp2an mpbi 3simp3i mpbiran biimpri nsyl2 wph cC cC cD caddc co
        clt wbr wch wph cC cD cmin co cC clt wbr cC cC cD caddc co clt wbr wph
        cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC cC cD
        caddc co clt wbr wa wph cc0 cD cC cC cmin co cabs cfv clt wph cD crp
        wcel cc0 cD clt wbr ivthlem6.9 cD rpgt0 sylbi cC cC cmin co cabs cfv
        cc0 cabs cfv cc0 cC cC cmin co cc0 cabs cC cC cC cr wcel cA cC cle wbr
        cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle
        wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        recni subidi fveq2i abs0 eqtri syl5eqbr cC cr wcel cC cr wcel cD cr
        wcel cC cC cmin co cabs cfv cD clt wbr cC cD cmin co cC clt wbr cC cC
        cD caddc co clt wbr wa wb wph cC cC cD absdiflt cC cr wcel wph cC cr
        wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2
        ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8
        ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC
        cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2
        mp2an mpbi 3simp1i a1i cC cr wcel wph cC cr wcel cA cC cle wbr cC cB
        cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr
        w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr
        wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i a1i wph cD
        crp wcel cD cr wcel ivthlem6.9 cD rpre sylbi syl3anc mpbid pm3.27d
        adantr jca wph cC cB cC cD caddc co cle wbr cB cC cD caddc co cif clt
        wbr cC cB clt wbr cC cC cD caddc co clt wbr wa wb wch cC cr wcel cB cr
        wcel cC cD caddc co cr wcel cC cB cC cD caddc co cle wbr cB cC cD caddc
        co cif clt wbr cC cB clt wbr cC cC cD caddc co clt wbr wa wb wph cC cB
        cC cD caddc co ltmin cC cr wcel wph cC cr wcel cA cC cle wbr cC cB cle
        wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA
        cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr
        wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
        wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i a1i cB cr
        wcel wph ivthlem4.2 a1i cC cr wcel cD cr wcel cC cD caddc co cr wcel
        wph cC cD readdcl cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc
        co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i wph cD crp wcel cD cr
        wcel ivthlem6.9 cD rpre sylbi sylancr syl3anc adantr mpbird ivthlem6.12
        syl6breqr syl3anc cq cr wss cC vx cv clt wbr vx cv cP clt wbr wa vx cq
        wrex cC vx cv clt wbr vx cv cP clt wbr wa vx cr wrex wi qssre cC vx cv
        clt wbr vx cv cP clt wbr wa vx cq cr ssrexv ax-mp syl cC vx cv clt wbr
        vx cv cP clt wbr wa vx cr df-rex sylib wph wch wa vx cv cr wcel cC vx
        cv clt wbr vx cv cP clt wbr wa wa vx cv cA cB cicc co wcel cC vx cv clt
        wbr vx cv cP clt wbr wa wa vx wph vx cv cr wcel cC vx cv clt wbr vx cv
        cP clt wbr wa wa vx cv cA cB cicc co wcel cC vx cv clt wbr vx cv cP clt
        wbr wa wa wi wch wph vx cv cr wcel cC vx cv clt wbr vx cv cP clt wbr wa
        wa vx cv cA cB cicc co wcel cC vx cv clt wbr vx cv cP clt wbr wa wph vx
        cv cr wcel cC vx cv clt wbr vx cv cP clt wbr wa vx cv cA cB cicc co
        wcel vx cv cr wcel wph cC vx cv clt wbr vx cv cP clt wbr wa vx cv cA cB
        cicc co wcel wi vx cv cr wcel wph wa cA vx cv cle wbr vx cv cB cle wbr
        vx cv cA cB cicc co wcel cC vx cv clt wbr vx cv cP clt wbr vx cv cr
        wcel cA vx cv cle wbr vx cv cB cle wbr wa vx cv cA cB cicc co wcel wi
        wph vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr vx cv cA cB cicc co
        wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
        cle wbr w3a cA cr wcel cB cr wcel vx cv cA cB cicc co wcel vx cv cr
        wcel cA vx cv cle wbr vx cv cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA
        cB vx cv elicc2 mp2an biimpri 3expib adantr vx cv cr wcel cC vx cv clt
        wbr cA vx cv cle wbr wi wph vx cv cr wcel cC vx cv clt wbr cA vx cv clt
        wbr cA vx cv cle wbr vx cv cr wcel cA cC cle wbr cC vx cv clt wbr cA vx
        cv clt wbr cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel
        cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp2i cA cr wcel cC cr wcel vx
        cv cr wcel cA cC cle wbr cC vx cv clt wbr wa cA vx cv clt wbr wi
        ivthlem4.1 cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel
        cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i cA cC vx cv lelttr
        mp3an12 mpani cA cr wcel vx cv cr wcel cA vx cv clt wbr cA vx cv cle
        wbr wi ivthlem4.1 cA vx cv ltle mpan syld adantr vx cv cr wcel wph wa
        vx cv cP clt wbr vx cv cB clt wbr vx cv cB cle wbr vx cv cr wcel wph wa
        vx cv cP clt wbr cP cB cle wbr vx cv cB clt wbr wph cP cB cle wbr vx cv
        cr wcel wph cB cC cD caddc co cle wbr cB cC cD caddc co cif cB cP cle
        cB cr wcel cC cD caddc co cr wcel cB cC cD caddc co cle wbr cB cC cD
        caddc co cif cB cle wbr wph cB cC cD caddc co min1 ivthlem4.2 cC cr
        wcel cD cr wcel cC cD caddc co cr wcel wph cC cD readdcl cC cr wcel cA
        cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr
        cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
        ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr
        wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
        cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i
        wph cD crp wcel cD cr wcel ivthlem6.9 cD rpre sylbi sylancr sylancr
        ivthlem6.12 syl5eqbr adantl vx cv cr wcel cP cr wcel vx cv cP clt wbr
        cP cB cle wbr wa vx cv cB clt wbr wi wph vx cv cr wcel cP cr wcel cB cr
        wcel vx cv cP clt wbr cP cB cle wbr wa vx cv cB clt wbr wi ivthlem4.2
        vx cv cP cB ltletr mp3an3 wph cB cC cD caddc co cle wbr cB cC cD caddc
        co cif cr cP cB cr wcel cC cD caddc co cr wcel cB cC cD caddc co cle
        wbr cB cC cD caddc co cif cr wcel wph cB cC cD caddc co cle wbr cB cC
        cD caddc co cr ifcl ivthlem4.2 cC cr wcel cD cr wcel cC cD caddc co cr
        wcel wph cC cD readdcl cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB
        cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
        wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
        ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i wph cD crp wcel cD cr
        wcel ivthlem6.9 cD rpre sylbi sylancr sylancr ivthlem6.12 syl5eqel
        sylan2 mpan2d vx cv cr wcel vx cv cB clt wbr vx cv cB cle wbr wi wph vx
        cv cr wcel cB cr wcel vx cv cB clt wbr vx cv cB cle wbr wi ivthlem4.2
        vx cv cB ltle mpan2 adantr syld syl2and expcom imp3a vx cv cr wcel cC
        vx cv clt wbr vx cv cP clt wbr wa wa cC vx cv clt wbr vx cv cP clt wbr
        wa wi wph vx cv cr wcel cC vx cv clt wbr vx cv cP clt wbr wa pm3.27 a1i
        jcad adantr 19.22dv mpd cC vx cv clt wbr vx cv cP clt wbr wa vx cA cB
        cicc co df-rex sylibr cA cB cicc co c0 wne wph wch wa cC vx cv clt wbr
        vx cv cP clt wbr wa wi vx cA cB cicc co wrex wph wch wa cC vx cv clt
        wbr vx cv cP clt wbr wa vx cA cB cicc co wrex wi wb cS cA cB cicc co
        wss cS c0 wne cA cB cicc co c0 wne cS vc cv cF cfv cU cle wbr vc cA cB
        cicc co crab cA cB cicc co ivthlem4.7 vc cv cF cfv cU cle wbr vc cA cB
        cicc co ssrab2 eqsstri cS cr wss cS c0 wne vw cv vv cv cle wbr vw cS
        wral vv cr wrex cS cr wss cS c0 wne vw cv vv cv cle wbr vw cS wral vv
        cr wrex w3a cA cS wcel vv vw cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2
        ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8
        ivthlem4 pm3.26i 3simp2i cS cA cB cicc co ssn0 mp2an wph wch wa cC vx
        cv clt wbr vx cv cP clt wbr wa vx cA cB cicc co r19.37zv ax-mp mpbir
        wph wch wa cC vx cv clt wbr vx cv cP clt wbr wa wi cC vx cv clt wbr vx
        cv cP clt wbr wa wn wph wch wa wn wi vx cA cB cicc co wph wch wa cC vx
        cv clt wbr vx cv cP clt wbr wa con3 r19.22si ax-mp wph wch wa cC vx cv
        clt wbr vx cv cP clt wbr wa wn wi cC vx cv clt wbr vx cv cP clt wbr wa
        wn wph wch wa wn wi vx cA cB cicc co r19.29 mp2an wph wch wa cC vx cv
        clt wbr vx cv cP clt wbr wa wn wi cC vx cv clt wbr vx cv cP clt wbr wa
        wn wph wch wa wn wi wa wph wch wa wn vx cA cB cicc co wph wch wa cC vx
        cv clt wbr vx cv cP clt wbr wa wn wi cC vx cv clt wbr vx cv cP clt wbr
        wa wn wph wch wa wn wi wa wph wch wa wph wch wa cC vx cv clt wbr vx cv
        cP clt wbr wa wn wph wch wa wn pm3.33 pm2.01d r19.22si ax-mp wph wch wa
        wn vx cA cB cicc co rexex ax-mp wph wch wa wn vx 19.9v mpbi $.
        $( [22-Jan-2008] $) $( [8-Oct-2007] $)
    $}

    $( Lemma for ~ isupivthi . $)
    ivthlem8 $p |- ( C e. ( A (,) B ) /\ ( F ` C ) = U ) $=
      cC cA cB cioo co wcel cC cF cfv cU wceq cC cr wcel cA cC clt wbr cC cB
      clt wbr cC cA cB cioo co wcel cC cr wcel cA cC cle wbr cC cB cle wbr cC
      cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS
      cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB
      cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
      ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp1i cA cC clt wbr cC cA wne cU
      cA cF cfv wne cC cA wne cA cF cfv cU clt wbr cU cA cF cfv wne cA cF cfv
      cU clt wbr cU cB cF cfv clt wbr ivthlem4.5 pm3.26i cA cF cfv cU cA cA cB
      cicc co wcel cA cF cfv cr wcel cA cr wcel cB cr wcel cA cB cle wbr cA cA
      cB cicc co wcel ivthlem4.1 ivthlem4.2 cA cB ivthlem4.1 ivthlem4.2
      ivthlem4.4 ltleii cA cB lbicc2 mp3an cA cB cicc co cr cA cF cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc
      wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA
      cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn
      sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp ivthlem4.3 ltnei ax-mp cC cA cU cA cF cfv cC cA wceq cC cF
      cfv cA cF cfv cU cC cA cF fveq2 cC cF cfv cU wceq cC cF cfv cU clt wbr wn
      cU cC cF cfv clt wbr wn cC cF cfv cU cC cA cB cicc co wcel cC cF cfv cr
      wcel cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
      ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC
      cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr
      ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.26i ffvelrni ax-mp ivthlem4.3 lttri3i cC cF cfv cU
      clt wbr vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr vw cv cF
      cfv cU clt wbr wi vw cA cB cicc co wral wa vz wex vz cv crp wcel cC vw cv
      cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc
      co wral wa vz vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU
      vw cv cF cfv clt wbr wi vw cA cB cicc co wral cC vw cv cmin co cabs cfv
      vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral vw cA cB
      cC vz cv cB cC vz cv caddc co cle wbr cB cC vz cv caddc co cif cS cU cF
      vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 vz cv crp wcel biid cC vw cv cmin co cabs cfv vz cv
      clt wbr cU vw cv cF cfv clt wbr wi vw cA cB cicc co wral biid cC vw cv
      cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc
      co wral biid cB cC vz cv caddc co cle wbr cB cC vz cv caddc co cif eqid
      ivthlem7 nex cC cF cfv cU clt wbr cC vw cv cmin co cabs cfv vz cv clt wbr
      cC cF cfv vw cv cF cfv cmin co cabs cfv cU cC cF cfv cmin co clt wbr vw
      cv cF cfv cU clt wbr vz vw cA cB cicc co vy vz vw cU cA cB cicc co cC cF
      cfv cC cF cfv vw cv cF cfv cmin co cabs cfv cC vw cv cmin co cabs cfv cC
      cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr
      cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA
      cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB
      cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri
      axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp ivthlem4.3 cC cA cB cicc co wcel cC vw cv cmin co cabs cfv
      vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA cB cicc co wral vz crp wrex vy crp wral cA cB cC cS cU cF vc
      ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 ivthlem5 vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc
      co wral vz crp wrex vy crp wral cC vw cv cmin co cabs cfv vz cv clt wbr
      cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cC cA cB cicc co vx cv cC wceq vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex cC vw cv cmin co
      cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA cB cicc co wral vz crp wrex vy crp vx cv cC wceq vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vz vw crp cA cB cicc co vx cv cC
      wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr cC vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr cC
      cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr vx cv cC wceq vx cv vw
      cv cmin co cabs cfv cC vw cv cmin co cabs cfv vz cv clt vx cv cC wceq vx
      cv vw cv cmin co cC vw cv cmin co cabs vx cv cC vw cv cmin opreq1 fveq2d
      breq1d vx cv cC wceq vx cv cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt vx cv cC wceq vx cv cF cfv vw cv
      cF cfv cmin co cC cF cfv vw cv cF cfv cmin co cabs vx cv cC wceq vx cv cF
      cfv cC cF cfv vw cv cF cfv cmin vx cv cC cF fveq2 opreq1d fveq2d breq1d
      imbi12d rexralbidv ralbidv cA cB cicc co cr cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB
      cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb
      cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.27i vtoclri ax-mp ivthlem2 vw cv cA
      cB cicc co wcel vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs
      cfv cU cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr wi cA cB cicc co
      cr vw cv cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.26i ffvelrni vw cv cF cfv cr wcel cC cF cfv vw cv
      cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt
      wbr wi wi vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU
      cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr wi wi cC cF cfv vw cv
      cF cfv cU ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS
      cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB
      cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB
      cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an
      axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi
      pm3.26i ffvelrni ax-mp ivthlem1 pm3.27i syl ivthlem3 mto cU cC cF cfv clt
      wbr vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF
      cfv clt wbr wi vw cA cB cicc co wral wa vz wex vz cv crp wcel cC vw cv
      cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt wbr wi vw cA cB cicc
      co wral wa vz vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU
      vw cv cF cfv clt wbr wi vw cA cB cicc co wral cC vw cv cmin co cabs cfv
      vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral vw cA cB
      cC vz cv cB cC vz cv caddc co cle wbr cB cC vz cv caddc co cif cS cU cF
      vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 vz cv crp wcel biid cC vw cv cmin co cabs cfv vz cv
      clt wbr cU vw cv cF cfv clt wbr wi vw cA cB cicc co wral biid cC vw cv
      cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc
      co wral biid cB cC vz cv caddc co cle wbr cB cC vz cv caddc co cif eqid
      ivthlem6 nex cU cC cF cfv clt wbr cC vw cv cmin co cabs cfv vz cv clt wbr
      cC cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU
      vw cv cF cfv clt wbr vz vw cA cB cicc co vy vz vw cC cF cfv cA cB cicc co
      cU cC cF cfv vw cv cF cfv cmin co cabs cfv cC vw cv cmin co cabs cfv
      ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc
      ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy
      crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc
      wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA
      cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn
      sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp cC cA cB cicc co wcel cC vw cv cmin co cabs cfv vz cv clt
      wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral
      vz crp wrex vy crp wral cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cC cA cB cicc co vx cv cC wceq vx cv vw cv cmin
      co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy
      cv clt wbr wi vw cA cB cicc co wral vz crp wrex cC vw cv cmin co cabs cfv
      vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA cB cicc co wral vz crp wrex vy crp vx cv cC wceq vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vz vw crp cA cB cicc co vx cv cC wceq
      vx cv vw cv cmin co cabs cfv vz cv clt wbr cC vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr cC cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr vx cv cC wceq vx cv vw cv
      cmin co cabs cfv cC vw cv cmin co cabs cfv vz cv clt vx cv cC wceq vx cv
      vw cv cmin co cC vw cv cmin co cabs vx cv cC vw cv cmin opreq1 fveq2d
      breq1d vx cv cC wceq vx cv cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt vx cv cC wceq vx cv cF cfv vw cv
      cF cfv cmin co cC cF cfv vw cv cF cfv cmin co cabs vx cv cC wceq vx cv cF
      cfv cC cF cfv vw cv cF cfv cmin vx cv cC cF fveq2 opreq1d fveq2d breq1d
      imbi12d rexralbidv ralbidv cA cB cicc co cr cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB
      cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb
      cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.27i vtoclri ax-mp ivthlem2 vw cv cA
      cB cicc co wcel vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs
      cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt wbr wi cA cB cicc co
      cr vw cv cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.26i ffvelrni vw cv cF cfv cr wcel cC cF cfv vw cv
      cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt
      wbr wi wi vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU
      cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr wi wi cC cF cfv vw cv
      cF cfv cU ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS
      cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB
      cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB
      cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an
      axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi
      pm3.26i ffvelrni ax-mp ivthlem1 pm3.26i syl ivthlem3 mto mpbir2an syl5eqr
      necon3i ax-mp cA cr wcel cC cr wcel cA cC cle wbr cA cC clt wbr cC cA wne
      wb ivthlem4.1 cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
      wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc
      ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co
      wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2
      cA cB cC elicc2 mp2an mpbi 3simp1i cC cr wcel cA cC cle wbr cC cB cle wbr
      cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC
      cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB
      cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
      ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp2i cA cC leltne mp3an mpbir cC
      cB clt wbr cB cC wne cB cF cfv cU wne cB cC wne cU cB cF cfv clt wbr cB
      cF cfv cU wne cA cF cfv cU clt wbr cU cB cF cfv clt wbr ivthlem4.5
      pm3.27i cU cB cF cfv ivthlem4.3 cB cA cB cicc co wcel cB cF cfv cr wcel
      cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co wcel ivthlem4.1
      ivthlem4.2 cA cB ivthlem4.1 ivthlem4.2 ivthlem4.4 ltleii cA cB ubicc2
      mp3an cA cB cicc co cr cB cF cA cB cicc co cr cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB
      cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb
      cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.26i ffvelrni ax-mp ltnei ax-mp cB cC
      cB cF cfv cU cB cC wceq cB cF cfv cC cF cfv cU cB cC cF fveq2 cC cF cfv
      cU wceq cC cF cfv cU clt wbr wn cU cC cF cfv clt wbr wn cC cF cfv cU cC
      cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr
      cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA
      cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB
      cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri
      axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp ivthlem4.3 lttri3i cC cF cfv cU clt wbr vz cv crp wcel cC
      vw cv cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB
      cicc co wral wa vz wex vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt
      wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral wa vz vz cv crp wcel
      cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt wbr wi vw cA
      cB cicc co wral cC vw cv cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU
      clt wbr wi vw cA cB cicc co wral vw cA cB cC vz cv cB cC vz cv caddc co
      cle wbr cB cC vz cv caddc co cif cS cU cF vc ivthlem4.1 ivthlem4.2
      ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 vz cv
      crp wcel biid cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt
      wbr wi vw cA cB cicc co wral biid cC vw cv cmin co cabs cfv vz cv clt wbr
      vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral biid cB cC vz cv caddc
      co cle wbr cB cC vz cv caddc co cif eqid ivthlem7 nex cC cF cfv cU clt
      wbr cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin
      co cabs cfv cU cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr vz vw cA
      cB cicc co vy vz vw cU cA cB cicc co cC cF cfv cC cF cfv vw cv cF cfv
      cmin co cabs cfv cC vw cv cmin co cabs cfv cC cA cB cicc co wcel cC cF
      cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
      ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB
      cicc co cr cC cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB
      cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr
      ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB
      cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.26i ffvelrni ax-mp ivthlem4.3 cC cA
      cB cicc co wcel cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp
      wrex vy crp wral cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
      ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral cC vw
      cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cC cA
      cB cicc co vx cv cC wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv
      cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp
      wrex vy crp vx cv cC wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi cC vw cv cmin co
      cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vz vw crp cA cB cicc co vx cv cC wceq vx cv vw cv cmin co cabs cfv
      vz cv clt wbr cC vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr vx cv cC wceq vx cv vw cv cmin co cabs cfv cC vw cv
      cmin co cabs cfv vz cv clt vx cv cC wceq vx cv vw cv cmin co cC vw cv
      cmin co cabs vx cv cC vw cv cmin opreq1 fveq2d breq1d vx cv cC wceq vx cv
      cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt vx cv cC wceq vx cv cF cfv vw cv cF cfv cmin co cC cF cfv
      vw cv cF cfv cmin co cabs vx cv cC wceq vx cv cF cfv cC cF cfv vw cv cF
      cfv cmin vx cv cC cF fveq2 opreq1d fveq2d breq1d imbi12d rexralbidv
      ralbidv cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc
      co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr
      ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.27i vtoclri ax-mp ivthlem2 vw cv cA cB cicc co wcel
      vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU cC cF cfv
      cmin co clt wbr vw cv cF cfv cU clt wbr wi cA cB cicc co cr vw cv cF cA
      cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral
      vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf
      co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc
      co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB
      cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB
      cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an
      axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi
      pm3.26i ffvelrni vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs
      cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt wbr wi wi vw cv cF
      cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU cC cF cfv cmin co
      clt wbr vw cv cF cfv cU clt wbr wi wi cC cF cfv vw cv cF cfv cU
      ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc
      ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy
      crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc
      wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA
      cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn
      sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp ivthlem1 pm3.27i syl ivthlem3 mto cU cC cF cfv clt wbr vz
      cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt
      wbr wi vw cA cB cicc co wral wa vz wex vz cv crp wcel cC vw cv cmin co
      cabs cfv vz cv clt wbr cU vw cv cF cfv clt wbr wi vw cA cB cicc co wral
      wa vz vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF
      cfv clt wbr wi vw cA cB cicc co wral cC vw cv cmin co cabs cfv vz cv clt
      wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral vw cA cB cC vz cv cB
      cC vz cv caddc co cle wbr cB cC vz cv caddc co cif cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 vz cv crp wcel biid cC vw cv cmin co cabs cfv vz cv clt wbr cU
      vw cv cF cfv clt wbr wi vw cA cB cicc co wral biid cC vw cv cmin co cabs
      cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral biid
      cB cC vz cv caddc co cle wbr cB cC vz cv caddc co cif eqid ivthlem6 nex
      cU cC cF cfv clt wbr cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw
      cv cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv
      clt wbr vz vw cA cB cicc co vy vz vw cC cF cfv cA cB cicc co cU cC cF cfv
      vw cv cF cfv cmin co cabs cfv cC vw cv cmin co cabs cfv ivthlem4.3 cC cA
      cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr
      cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA
      cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB
      cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri
      axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp cC cA cB cicc co wcel cC vw cv cmin co cabs cfv vz cv clt
      wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral
      vz crp wrex vy crp wral cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cC cA cB cicc co vx cv cC wceq vx cv vw cv cmin
      co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy
      cv clt wbr wi vw cA cB cicc co wral vz crp wrex cC vw cv cmin co cabs cfv
      vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA cB cicc co wral vz crp wrex vy crp vx cv cC wceq vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vz vw crp cA cB cicc co vx cv cC wceq
      vx cv vw cv cmin co cabs cfv vz cv clt wbr cC vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr cC cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr vx cv cC wceq vx cv vw cv
      cmin co cabs cfv cC vw cv cmin co cabs cfv vz cv clt vx cv cC wceq vx cv
      vw cv cmin co cC vw cv cmin co cabs vx cv cC vw cv cmin opreq1 fveq2d
      breq1d vx cv cC wceq vx cv cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt vx cv cC wceq vx cv cF cfv vw cv
      cF cfv cmin co cC cF cfv vw cv cF cfv cmin co cabs vx cv cC wceq vx cv cF
      cfv cC cF cfv vw cv cF cfv cmin vx cv cC cF fveq2 opreq1d fveq2d breq1d
      imbi12d rexralbidv ralbidv cA cB cicc co cr cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB
      cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb
      cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.27i vtoclri ax-mp ivthlem2 vw cv cA
      cB cicc co wcel vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs
      cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt wbr wi cA cB cicc co
      cr vw cv cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.26i ffvelrni vw cv cF cfv cr wcel cC cF cfv vw cv
      cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt
      wbr wi wi vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU
      cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr wi wi cC cF cfv vw cv
      cF cfv cU ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS
      cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB
      cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB
      cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an
      axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi
      pm3.26i ffvelrni ax-mp ivthlem1 pm3.26i syl ivthlem3 mto mpbir2an syl6eq
      necon3i ax-mp cC cr wcel cB cr wcel cC cB cle wbr cC cB clt wbr cB cC wne
      wb cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co wcel cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1 ivthlem4.2 cA cB cC
      elicc2 mp2an mpbi 3simp1i ivthlem4.2 cC cr wcel cA cC cle wbr cC cB cle
      wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA
      cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cr wcel cB cr wcel cC cA cB
      cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a wb ivthlem4.1
      ivthlem4.2 cA cB cC elicc2 mp2an mpbi 3simp3i cC cB leltne mp3an mpbir cC
      cA cB cioo co wcel cC cr wcel cA cC clt wbr cC cB clt wbr w3a cA cr wcel
      cB cr wcel cC cA cB cioo co wcel cC cr wcel cA cC clt wbr cC cB clt wbr
      w3a wb ivthlem4.1 ivthlem4.2 cA cxr wcel cB cxr wcel cC cA cB cioo co
      wcel cC cr wcel cA cC clt wbr cC cB clt wbr w3a wb cA cr wcel cB cr wcel
      cA cB cC elioo2 cA rexr cB rexr syl2an mp2an biimpri mp3an cC cF cfv cU
      wceq cC cF cfv cU clt wbr wn cU cC cF cfv clt wbr wn cC cF cfv cU cC cA
      cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr
      cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA
      cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB
      cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri
      axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp ivthlem4.3 lttri3i cC cF cfv cU clt wbr vz cv crp wcel cC
      vw cv cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB
      cicc co wral wa vz wex vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt
      wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral wa vz vz cv crp wcel
      cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt wbr wi vw cA
      cB cicc co wral cC vw cv cmin co cabs cfv vz cv clt wbr vw cv cF cfv cU
      clt wbr wi vw cA cB cicc co wral vw cA cB cC vz cv cB cC vz cv caddc co
      cle wbr cB cC vz cv caddc co cif cS cU cF vc ivthlem4.1 ivthlem4.2
      ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 vz cv
      crp wcel biid cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt
      wbr wi vw cA cB cicc co wral biid cC vw cv cmin co cabs cfv vz cv clt wbr
      vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral biid cB cC vz cv caddc
      co cle wbr cB cC vz cv caddc co cif eqid ivthlem7 nex cC cF cfv cU clt
      wbr cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin
      co cabs cfv cU cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr vz vw cA
      cB cicc co vy vz vw cU cA cB cicc co cC cF cfv cC cF cfv vw cv cF cfv
      cmin co cabs cfv cC vw cv cmin co cabs cfv cC cA cB cicc co wcel cC cF
      cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
      ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB
      cicc co cr cC cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB
      cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr
      ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB
      cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.26i ffvelrni ax-mp ivthlem4.3 cC cA
      cB cicc co wcel cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp
      wrex vy crp wral cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3
      ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral cC vw
      cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cC cA
      cB cicc co vx cv cC wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv
      cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp
      wrex vy crp vx cv cC wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi cC vw cv cmin co
      cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt
      wbr wi vz vw crp cA cB cicc co vx cv cC wceq vx cv vw cv cmin co cabs cfv
      vz cv clt wbr cC vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cmin co cabs cfv vy cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr vx cv cC wceq vx cv vw cv cmin co cabs cfv cC vw cv
      cmin co cabs cfv vz cv clt vx cv cC wceq vx cv vw cv cmin co cC vw cv
      cmin co cabs vx cv cC vw cv cmin opreq1 fveq2d breq1d vx cv cC wceq vx cv
      cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt vx cv cC wceq vx cv cF cfv vw cv cF cfv cmin co cC cF cfv
      vw cv cF cfv cmin co cabs vx cv cC wceq vx cv cF cfv cC cF cfv vw cv cF
      cfv cmin vx cv cC cF fveq2 opreq1d fveq2d breq1d imbi12d rexralbidv
      ralbidv cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc
      co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr
      ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.27i vtoclri ax-mp ivthlem2 vw cv cA cB cicc co wcel
      vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU cC cF cfv
      cmin co clt wbr vw cv cF cfv cU clt wbr wi cA cB cicc co cr vw cv cF cA
      cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral
      vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf
      co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc
      co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB
      cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB
      cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an
      axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi
      pm3.26i ffvelrni vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs
      cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt wbr wi wi vw cv cF
      cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU cC cF cfv cmin co
      clt wbr vw cv cF cfv cU clt wbr wi wi cC cF cfv vw cv cF cfv cU
      ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc
      ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
      ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF
      wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy
      crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc
      wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA
      cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn
      sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp ivthlem1 pm3.27i syl ivthlem3 mto cU cC cF cfv clt wbr vz
      cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF cfv clt
      wbr wi vw cA cB cicc co wral wa vz wex vz cv crp wcel cC vw cv cmin co
      cabs cfv vz cv clt wbr cU vw cv cF cfv clt wbr wi vw cA cB cicc co wral
      wa vz vz cv crp wcel cC vw cv cmin co cabs cfv vz cv clt wbr cU vw cv cF
      cfv clt wbr wi vw cA cB cicc co wral cC vw cv cmin co cabs cfv vz cv clt
      wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral vw cA cB cC vz cv cB
      cC vz cv caddc co cle wbr cB cC vz cv caddc co cif cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 vz cv crp wcel biid cC vw cv cmin co cabs cfv vz cv clt wbr cU
      vw cv cF cfv clt wbr wi vw cA cB cicc co wral biid cC vw cv cmin co cabs
      cfv vz cv clt wbr vw cv cF cfv cU clt wbr wi vw cA cB cicc co wral biid
      cB cC vz cv caddc co cle wbr cB cC vz cv caddc co cif eqid ivthlem6 nex
      cU cC cF cfv clt wbr cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw
      cv cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv
      clt wbr vz vw cA cB cicc co vy vz vw cC cF cfv cA cB cicc co cU cC cF cfv
      vw cv cF cfv cmin co cabs cfv cC vw cv cmin co cabs cfv ivthlem4.3 cC cA
      cB cicc co wcel cC cF cfv cr wcel cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB cicc co cr cF wf vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral
      vx cA cB cicc co wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr
      cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr
      cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs
      cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA
      cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB
      cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an axresscn sstri
      axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi pm3.26i
      ffvelrni ax-mp cC cA cB cicc co wcel cC vw cv cmin co cabs cfv vz cv clt
      wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral cA cB cC cS cU cF vc ivthlem4.1
      ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6 ivthlem4.7
      ivthlem4.8 ivthlem5 vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral
      vz crp wrex vy crp wral cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cC cA cB cicc co vx cv cC wceq vx cv vw cv cmin
      co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy
      cv clt wbr wi vw cA cB cicc co wral vz crp wrex cC vw cv cmin co cabs cfv
      vz cv clt wbr cC cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA cB cicc co wral vz crp wrex vy crp vx cv cC wceq vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi cC vw cv cmin co cabs cfv vz cv clt wbr cC cF cfv vw cv cF cfv
      cmin co cabs cfv vy cv clt wbr wi vz vw crp cA cB cicc co vx cv cC wceq
      vx cv vw cv cmin co cabs cfv vz cv clt wbr cC vw cv cmin co cabs cfv vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr cC cF
      cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr vx cv cC wceq vx cv vw cv
      cmin co cabs cfv cC vw cv cmin co cabs cfv vz cv clt vx cv cC wceq vx cv
      vw cv cmin co cC vw cv cmin co cabs vx cv cC vw cv cmin opreq1 fveq2d
      breq1d vx cv cC wceq vx cv cF cfv vw cv cF cfv cmin co cabs cfv cC cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt vx cv cC wceq vx cv cF cfv vw cv
      cF cfv cmin co cC cF cfv vw cv cF cfv cmin co cabs vx cv cC wceq vx cv cF
      cfv cC cF cfv vw cv cF cfv cmin vx cv cC cF fveq2 opreq1d fveq2d breq1d
      imbi12d rexralbidv ralbidv cA cB cicc co cr cF wf vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co
      wral cF cA cB cicc co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv
      cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB
      cicc co wral wa ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb
      cA cB cicc co cr cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1
      ivthlem4.2 cA cB iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB
      cicc co cr cF elcncf mp2an mpbi pm3.27i vtoclri ax-mp ivthlem2 vw cv cA
      cB cicc co wcel vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs
      cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt wbr wi cA cB cicc co
      cr vw cv cF cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB
      cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc
      co cr ccncf co wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA cB cicc co wral vz crp wrex vy crp wral vx cA cB cicc co wral wa
      ivthlem4.8 cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr
      cc cA cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
      iccssre mp2an axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF
      elcncf mp2an mpbi pm3.26i ffvelrni vw cv cF cfv cr wcel cC cF cfv vw cv
      cF cfv cmin co cabs cfv cC cF cfv cU cmin co clt wbr cU vw cv cF cfv clt
      wbr wi wi vw cv cF cfv cr wcel cC cF cfv vw cv cF cfv cmin co cabs cfv cU
      cC cF cfv cmin co clt wbr vw cv cF cfv cU clt wbr wi wi cC cF cfv vw cv
      cF cfv cU ivthlem4.3 cC cA cB cicc co wcel cC cF cfv cr wcel cA cB cC cS
      cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
      ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 cA cB cicc co cr cC cF cA cB
      cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz
      crp wrex vy crp wral vx cA cB cicc co wral cF cA cB cicc co cr ccncf co
      wcel cA cB cicc co cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co
      wral vz crp wrex vy crp wral vx cA cB cicc co wral wa ivthlem4.8 cA cB
      cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel cA cB cicc co
      cr cF wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA cB cicc co wral vz crp wrex
      vy crp wral vx cA cB cicc co wral wa wb cA cB cicc co cr cc cA cr wcel cB
      cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an
      axresscn sstri axresscn vx vy vz vw cA cB cicc co cr cF elcncf mp2an mpbi
      pm3.26i ffvelrni ax-mp ivthlem1 pm3.26i syl ivthlem3 mto mpbir2an pm3.2i
      $.
      $( [22-Jan-2008] $) $( [8-Oct-2007] $)

    ${
      ivthlem9.9 $e |- T = { d e. ( A [,] B ) | ( F ` d ) = U } $.
      ivthlem9.10 $e |- ( F ` C ) = U $.
      $( Lemma for ~ isupivthi . $)
      ivthlem9 $p |- C = sup ( T , RR , < ) $=
        cC cT cr clt csup wceq cC cT cr clt csup cle wbr cT cr clt csup cC cle
        wbr cC cT cr clt csup cA cB cicc co cr cC cA cr wcel cB cr wcel cA cB
        cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre mp2an cA cB cC cS cU
        cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 sselii vv vw cT cA cr wcel cB cr wcel cT
        cr wss cT c0 wne vw cv vv cv cle wbr vw cT wral vv cr wrex w3a
        ivthlem4.1 ivthlem4.2 cA cr wcel cB cr wcel wa cT cA cB cicc co wss cC
        cT wcel cT cr wss cT c0 wne vw cv vv cv cle wbr vw cT wral vv cr wrex
        w3a cT vd cv cF cfv cU wceq vd cA cB cicc co crab cA cB cicc co
        ivthlem9.9 vd cv cF cfv cU wceq vd cA cB cicc co ssrab2 eqsstri cC cT
        wcel cC cA cB cicc co wcel cC cF cfv cU wceq vd cv cF cfv cU wceq cC cF
        cfv cU wceq vd cC cA cB cicc co cT vd cv cC wceq vd cv cF cfv cC cF cfv
        cU vd cv cC cF fveq2 eqeq1d ivthlem9.9 elrab2 cA cB cC cS cU cF vc
        ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 ivthlem9.10 mpbir2an vv vw cA cB cC cT
        iccsupr mp3an23 mp2an suprclii letri3i cC cT wcel cC cT cr clt csup cle
        wbr cC cT wcel cC cA cB cicc co wcel cC cF cfv cU wceq vd cv cF cfv cU
        wceq cC cF cfv cU wceq vd cC cA cB cicc co cT vd cv cC wceq vd cv cF
        cfv cC cF cfv cU vd cv cC cF fveq2 eqeq1d ivthlem9.9 elrab2 cA cB cC cS
        cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
        ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 ivthlem9.10 mpbir2an vv vw cT
        cC cA cr wcel cB cr wcel cT cr wss cT c0 wne vw cv vv cv cle wbr vw cT
        wral vv cr wrex w3a ivthlem4.1 ivthlem4.2 cA cr wcel cB cr wcel wa cT
        cA cB cicc co wss cC cT wcel cT cr wss cT c0 wne vw cv vv cv cle wbr vw
        cT wral vv cr wrex w3a cT vd cv cF cfv cU wceq vd cA cB cicc co crab cA
        cB cicc co ivthlem9.9 vd cv cF cfv cU wceq vd cA cB cicc co ssrab2
        eqsstri cC cT wcel cC cA cB cicc co wcel cC cF cfv cU wceq vd cv cF cfv
        cU wceq cC cF cfv cU wceq vd cC cA cB cicc co cT vd cv cC wceq vd cv cF
        cfv cC cF cfv cU vd cv cC cF fveq2 eqeq1d ivthlem9.9 elrab2 cA cB cC cS
        cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5
        ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 ivthlem9.10 mpbir2an vv vw cA
        cB cC cT iccsupr mp3an23 mp2an suprubii ax-mp cC cr wcel vx cv cC cle
        wbr vx cT wral cT cr clt csup cC cle wbr cA cB cicc co cr cC cA cr wcel
        cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB iccssre
        mp2an cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem5 sselii vx cv cC
        cle wbr vx cT vx cv cT wcel vx cv cA cB cicc co wcel vx cv cF cfv cU
        wceq wa vx cv cC cle wbr vd cv cF cfv cU wceq vx cv cF cfv cU wceq vd
        vx cv cA cB cicc co cT vd cv vx cv wceq vd cv cF cfv vx cv cF cfv cU vd
        cv vx cv cF fveq2 eqeq1d ivthlem9.9 elrab2 vx cv cA cB cicc co wcel vx
        cv cF cfv cU wceq vx cv cC cle wbr vx cv cA cB cicc co wcel vx cv cF
        cfv cU wceq vx cv cF cfv cU cle wbr vx cv cC cle wbr vx cv cA cB cicc
        co wcel vx cv cF cfv cr wcel vx cv cF cfv cU wceq vx cv cF cfv cU cle
        wbr wi cA cB cicc co cc wss cr cc wss cF cA cB cicc co cr ccncf co wcel
        vx cv cA cB cicc co wcel vx cv cF cfv cr wcel wi cA cB cicc co cr cc cA
        cr wcel cB cr wcel cA cB cicc co cr wss ivthlem4.1 ivthlem4.2 cA cB
        iccssre mp2an axresscn sstri axresscn ivthlem4.8 cA cB cicc co cr vx cv
        cF cncffvelrn mp3an vx cv cF cfv cr wcel vx cv cF cfv cU wceq vx cv cF
        cfv cU cle wbr vx cv cF cfv cU eqle ex syl vx cv cA cB cicc co wcel vx
        cv cF cfv cU cle wbr vx cv cC cle wbr vx cv cA cB cicc co wcel vx cv cF
        cfv cU cle wbr wa vx cv cS wcel vx cv cC cle wbr vc cv cF cfv cU cle
        wbr vx cv cF cfv cU cle wbr vc vx cv cA cB cicc co cS vc cv vx cv wceq
        vc cv cF cfv vx cv cF cfv cU cle vc cv vx cv cF fveq2 breq1d ivthlem4.7
        elrab2 vx cv cS wcel vx cv cS cr clt csup cC cle vv vw cS vx cv cS cr
        wss cS c0 wne vw cv vv cv cle wbr vw cS wral vv cr wrex w3a cA cS wcel
        vv vw cA cB cC cS cU cF vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4
        ivthlem4.5 ivthlem4.6 ivthlem4.7 ivthlem4.8 ivthlem4 pm3.26i suprubii
        ivthlem4.6 syl6breqr sylbir ex syld imp sylbi rgen vv vw vx cT cC cA cr
        wcel cB cr wcel cT cr wss cT c0 wne vw cv vv cv cle wbr vw cT wral vv
        cr wrex w3a ivthlem4.1 ivthlem4.2 cA cr wcel cB cr wcel wa cT cA cB
        cicc co wss cC cT wcel cT cr wss cT c0 wne vw cv vv cv cle wbr vw cT
        wral vv cr wrex w3a cT vd cv cF cfv cU wceq vd cA cB cicc co crab cA cB
        cicc co ivthlem9.9 vd cv cF cfv cU wceq vd cA cB cicc co ssrab2 eqsstri
        cC cT wcel cC cA cB cicc co wcel cC cF cfv cU wceq vd cv cF cfv cU wceq
        cC cF cfv cU wceq vd cC cA cB cicc co cT vd cv cC wceq vd cv cF cfv cC
        cF cfv cU vd cv cC cF fveq2 eqeq1d ivthlem9.9 elrab2 cA cB cC cS cU cF
        vc ivthlem4.1 ivthlem4.2 ivthlem4.3 ivthlem4.4 ivthlem4.5 ivthlem4.6
        ivthlem4.7 ivthlem4.8 ivthlem5 ivthlem9.10 mpbir2an vv vw cA cB cC cT
        iccsupr mp3an23 mp2an suprleubii mp2an mpbir2an $.
        $( [22-Jan-2008] $) $( [22-Jan-2008] $)
    $}
  $}

  ${
    isupivth.1 $e |- A e. RR $.
    isupivth.2 $e |- B e. RR $.
    isupivth.3 $e |- U e. RR $.
    isupivth.4 $e |- A < B $.
    isupivth.5 $e |- ( A [,] B ) C_ D $.
    isupivth.6 $e |- D C_ CC $.
    isupivth.7 $e |- F e. ( D -cn-> CC ) $.
    isupivth.8 $e |- ( x e. ( A [,] B ) -> ( F ` x ) e. RR ) $.
    isupivth.9 $e |- S = { x e. ( A [,] B ) | ( F ` x ) = U } $.
    ${
      $d A c x $.  $d B c x $.  $d F c x $.  $d U c x $.
      isupivth.10 $e |- ( ( F ` A ) < U /\ U < ( F ` B ) ) $.
      isupivth.11 $e |- C = sup ( S , RR , < ) $.
      $( The intermediate value theorem, increasing case with supremum
         solution.  (Contributed by Paul Chapman, 22-Jan-2008.) $)
      isupivthi $p |- ( C e. ( A (,) B ) /\ ( F ` C ) = U ) $=
        cC cA cB cioo co wcel cC cF cfv cU wceq cC vc cv cF cfv cU cle wbr vc
        cA cB cicc co crab cr clt csup cA cB cioo co cC cS cr clt csup vc cv cF
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup isupivth.11 cA cB vc
        cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cA cB cicc co crab cS cU cF cA cB cicc
        co cres vc vx isupivth.1 isupivth.2 isupivth.3 isupivth.4 cA cF cA cB
        cicc co cres cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt wbr wa
        cA cF cfv cU clt wbr cU cB cF cfv clt wbr wa isupivth.10 cA cF cA cB
        cicc co cres cfv cU clt wbr cA cF cfv cU clt wbr cU cB cF cA cB cicc co
        cres cfv clt wbr cU cB cF cfv clt wbr cA cF cA cB cicc co cres cfv cA
        cF cfv cU clt cA cA cB cicc co wcel cA cF cA cB cicc co cres cfv cA cF
        cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel
        isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA
        cB lbicc2 mp3an cA cA cB cicc co cF fvres ax-mp breq1i cB cF cA cB cicc
        co cres cfv cB cF cfv cU clt cB cA cB cicc co wcel cB cF cA cB cicc co
        cres cfv cB cF cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cB cA cB
        cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2
        isupivth.4 ltleii cA cB ubicc2 mp3an cB cA cB cicc co cF fvres ax-mp
        breq2i anbi12i mpbir vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA
        cB cicc co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab wceq vc cv
        cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc co crab cr clt csup
        vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup wceq vc cv cF
        cA cB cicc co cres cfv cU cle wbr vc cv cF cfv cU cle wbr vc cA cB cicc
        co vc cv cA cB cicc co wcel vc cv cF cA cB cicc co cres cfv vc cv cF
        cfv cU cle vc cv cA cB cicc co cF fvres breq1d rabbii cr vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle
        wbr vc cA cB cicc co crab clt supeq1 ax-mp eqcomi vc cv cF cA cB cicc
        co cres cfv cU cle wbr vc cA cB cicc co crab eqid cF cA cB cicc co cres
        cA cB cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr
        ccncf co wcel cF cD cc ccncf co wcel cF cA cB cicc co cres cA cB cicc
        co cc ccncf co wcel isupivth.7 cD cc wss cc cc wss cA cB cicc co cD wss
        cF cD cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cc ccncf co
        wcel wi isupivth.6 cc ssid isupivth.5 cD cc cA cB cicc co cF rescncf
        mp3an ax-mp cA cB cicc co cc wss cc cc wss cr cc wss w3a vx cv cF cA cB
        cicc co cres cfv cr wcel vx cA cB cicc co wral cF cA cB cicc co cres cA
        cB cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr
        ccncf co wcel wi cA cB cicc co cc wss cc cc wss cr cc wss cA cB cicc co
        cD cc isupivth.5 isupivth.6 sstri cc ssid axresscn 3pm3.2i vx cv cF cA
        cB cicc co cres cfv cr wcel vx cA cB cicc co vx cv cA cB cicc co wcel
        vx cv cF cA cB cicc co cres cfv vx cv cF cfv cr vx cv cA cB cicc co cF
        fvres isupivth.8 eqeltrd rgen vx cA cB cicc co cc cr cF cA cB cicc co
        cres cncffvrn mp2an ax-mp cS vx cv cF cfv cU wceq vx cA cB cicc co crab
        vx cv cF cA cB cicc co cres cfv cU wceq vx cA cB cicc co crab
        isupivth.9 vx cv cF cA cB cicc co cres cfv cU wceq vx cv cF cfv cU wceq
        vx cA cB cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres
        cfv vx cv cF cfv cU vx cv cA cB cicc co cF fvres eqeq1d rabbii eqtr4i
        vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup cA cB cioo co
        wcel vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup cF cA cB
        cicc co cres cfv cU wceq cA cB vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab cU cF cA cB cicc co cres vc isupivth.1 isupivth.2
        isupivth.3 isupivth.4 cA cF cA cB cicc co cres cfv cU clt wbr cU cB cF
        cA cB cicc co cres cfv clt wbr wa cA cF cfv cU clt wbr cU cB cF cfv clt
        wbr wa isupivth.10 cA cF cA cB cicc co cres cfv cU clt wbr cA cF cfv cU
        clt wbr cU cB cF cA cB cicc co cres cfv clt wbr cU cB cF cfv clt wbr cA
        cF cA cB cicc co cres cfv cA cF cfv cU clt cA cA cB cicc co wcel cA cF
        cA cB cicc co cres cfv cA cF cfv wceq cA cr wcel cB cr wcel cA cB cle
        wbr cA cA cB cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1
        isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an cA cA cB cicc co cF
        fvres ax-mp breq1i cB cF cA cB cicc co cres cfv cB cF cfv cU clt cB cA
        cB cicc co wcel cB cF cA cB cicc co cres cfv cB cF cfv wceq cA cr wcel
        cB cr wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA
        cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an cB cA cB
        cicc co cF fvres ax-mp breq2i anbi12i mpbir vc cv cF cA cB cicc co cres
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cfv cU cle
        wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc co cres cfv
        cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc
        co crab wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cv cF cfv
        cU cle wbr vc cA cB cicc co vc cv cA cB cicc co wcel vc cv cF cA cB
        cicc co cres cfv vc cv cF cfv cU cle vc cv cA cB cicc co cF fvres
        breq1d rabbii cr vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab clt supeq1
        ax-mp eqcomi vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab eqid cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA
        cB cicc co cres cA cB cicc co cr ccncf co wcel cF cD cc ccncf co wcel
        cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel isupivth.7 cD cc
        wss cc cc wss cA cB cicc co cD wss cF cD cc ccncf co wcel cF cA cB cicc
        co cres cA cB cicc co cc ccncf co wcel wi isupivth.6 cc ssid isupivth.5
        cD cc cA cB cicc co cF rescncf mp3an ax-mp cA cB cicc co cc wss cc cc
        wss cr cc wss w3a vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB cicc
        co wral cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA cB
        cicc co cres cA cB cicc co cr ccncf co wcel wi cA cB cicc co cc wss cc
        cc wss cr cc wss cA cB cicc co cD cc isupivth.5 isupivth.6 sstri cc
        ssid axresscn 3pm3.2i vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB
        cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres cfv vx cv
        cF cfv cr vx cv cA cB cicc co cF fvres isupivth.8 eqeltrd rgen vx cA cB
        cicc co cc cr cF cA cB cicc co cres cncffvrn mp2an ax-mp ivthlem8
        pm3.27i ivthlem9 eqtr4i vc cv cF cfv cU cle wbr vc cA cB cicc co crab
        cr clt csup cA cB cioo co wcel vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup cF cA cB cicc co cres cfv cU wceq cA cB vc cv cF cfv
        cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc co
        cres cfv cU cle wbr vc cA cB cicc co crab cU cF cA cB cicc co cres vc
        isupivth.1 isupivth.2 isupivth.3 isupivth.4 cA cF cA cB cicc co cres
        cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt wbr wa cA cF cfv cU
        clt wbr cU cB cF cfv clt wbr wa isupivth.10 cA cF cA cB cicc co cres
        cfv cU clt wbr cA cF cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt
        wbr cU cB cF cfv clt wbr cA cF cA cB cicc co cres cfv cA cF cfv cU clt
        cA cA cB cicc co wcel cA cF cA cB cicc co cres cfv cA cF cfv wceq cA cr
        wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel isupivth.1
        isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB lbicc2
        mp3an cA cA cB cicc co cF fvres ax-mp breq1i cB cF cA cB cicc co cres
        cfv cB cF cfv cU clt cB cA cB cicc co wcel cB cF cA cB cicc co cres cfv
        cB cF cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co
        wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4
        ltleii cA cB ubicc2 mp3an cB cA cB cicc co cF fvres ax-mp breq2i
        anbi12i mpbir vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc co
        crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab wceq vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup wceq vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cv cF cfv cU cle wbr vc cA cB cicc co vc
        cv cA cB cicc co wcel vc cv cF cA cB cicc co cres cfv vc cv cF cfv cU
        cle vc cv cA cB cicc co cF fvres breq1d rabbii cr vc cv cF cA cB cicc
        co cres cfv cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc
        cA cB cicc co crab clt supeq1 ax-mp eqcomi vc cv cF cA cB cicc co cres
        cfv cU cle wbr vc cA cB cicc co crab eqid cF cA cB cicc co cres cA cB
        cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr ccncf
        co wcel cF cD cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cc
        ccncf co wcel isupivth.7 cD cc wss cc cc wss cA cB cicc co cD wss cF cD
        cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel
        wi isupivth.6 cc ssid isupivth.5 cD cc cA cB cicc co cF rescncf mp3an
        ax-mp cA cB cicc co cc wss cc cc wss cr cc wss w3a vx cv cF cA cB cicc
        co cres cfv cr wcel vx cA cB cicc co wral cF cA cB cicc co cres cA cB
        cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr ccncf
        co wcel wi cA cB cicc co cc wss cc cc wss cr cc wss cA cB cicc co cD cc
        isupivth.5 isupivth.6 sstri cc ssid axresscn 3pm3.2i vx cv cF cA cB
        cicc co cres cfv cr wcel vx cA cB cicc co vx cv cA cB cicc co wcel vx
        cv cF cA cB cicc co cres cfv vx cv cF cfv cr vx cv cA cB cicc co cF
        fvres isupivth.8 eqeltrd rgen vx cA cB cicc co cc cr cF cA cB cicc co
        cres cncffvrn mp2an ax-mp ivthlem8 pm3.26i eqeltri cC cF cA cB cicc co
        cres cfv vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup cF
        cA cB cicc co cres cfv cC cF cfv cU cC vc cv cF cfv cU cle wbr vc cA cB
        cicc co crab cr clt csup cF cA cB cicc co cres cC cS cr clt csup vc cv
        cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup isupivth.11 cA cB
        vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cA
        cB cicc co cres cfv cU cle wbr vc cA cB cicc co crab cS cU cF cA cB
        cicc co cres vc vx isupivth.1 isupivth.2 isupivth.3 isupivth.4 cA cF cA
        cB cicc co cres cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt wbr
        wa cA cF cfv cU clt wbr cU cB cF cfv clt wbr wa isupivth.10 cA cF cA cB
        cicc co cres cfv cU clt wbr cA cF cfv cU clt wbr cU cB cF cA cB cicc co
        cres cfv clt wbr cU cB cF cfv clt wbr cA cF cA cB cicc co cres cfv cA
        cF cfv cU clt cA cA cB cicc co wcel cA cF cA cB cicc co cres cfv cA cF
        cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel
        isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA
        cB lbicc2 mp3an cA cA cB cicc co cF fvres ax-mp breq1i cB cF cA cB cicc
        co cres cfv cB cF cfv cU clt cB cA cB cicc co wcel cB cF cA cB cicc co
        cres cfv cB cF cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cB cA cB
        cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2
        isupivth.4 ltleii cA cB ubicc2 mp3an cB cA cB cicc co cF fvres ax-mp
        breq2i anbi12i mpbir vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA
        cB cicc co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab wceq vc cv
        cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc co crab cr clt csup
        vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup wceq vc cv cF
        cA cB cicc co cres cfv cU cle wbr vc cv cF cfv cU cle wbr vc cA cB cicc
        co vc cv cA cB cicc co wcel vc cv cF cA cB cicc co cres cfv vc cv cF
        cfv cU cle vc cv cA cB cicc co cF fvres breq1d rabbii cr vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle
        wbr vc cA cB cicc co crab clt supeq1 ax-mp eqcomi vc cv cF cA cB cicc
        co cres cfv cU cle wbr vc cA cB cicc co crab eqid cF cA cB cicc co cres
        cA cB cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr
        ccncf co wcel cF cD cc ccncf co wcel cF cA cB cicc co cres cA cB cicc
        co cc ccncf co wcel isupivth.7 cD cc wss cc cc wss cA cB cicc co cD wss
        cF cD cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cc ccncf co
        wcel wi isupivth.6 cc ssid isupivth.5 cD cc cA cB cicc co cF rescncf
        mp3an ax-mp cA cB cicc co cc wss cc cc wss cr cc wss w3a vx cv cF cA cB
        cicc co cres cfv cr wcel vx cA cB cicc co wral cF cA cB cicc co cres cA
        cB cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr
        ccncf co wcel wi cA cB cicc co cc wss cc cc wss cr cc wss cA cB cicc co
        cD cc isupivth.5 isupivth.6 sstri cc ssid axresscn 3pm3.2i vx cv cF cA
        cB cicc co cres cfv cr wcel vx cA cB cicc co vx cv cA cB cicc co wcel
        vx cv cF cA cB cicc co cres cfv vx cv cF cfv cr vx cv cA cB cicc co cF
        fvres isupivth.8 eqeltrd rgen vx cA cB cicc co cc cr cF cA cB cicc co
        cres cncffvrn mp2an ax-mp cS vx cv cF cfv cU wceq vx cA cB cicc co crab
        vx cv cF cA cB cicc co cres cfv cU wceq vx cA cB cicc co crab
        isupivth.9 vx cv cF cA cB cicc co cres cfv cU wceq vx cv cF cfv cU wceq
        vx cA cB cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres
        cfv vx cv cF cfv cU vx cv cA cB cicc co cF fvres eqeq1d rabbii eqtr4i
        vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup cA cB cioo co
        wcel vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup cF cA cB
        cicc co cres cfv cU wceq cA cB vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab cU cF cA cB cicc co cres vc isupivth.1 isupivth.2
        isupivth.3 isupivth.4 cA cF cA cB cicc co cres cfv cU clt wbr cU cB cF
        cA cB cicc co cres cfv clt wbr wa cA cF cfv cU clt wbr cU cB cF cfv clt
        wbr wa isupivth.10 cA cF cA cB cicc co cres cfv cU clt wbr cA cF cfv cU
        clt wbr cU cB cF cA cB cicc co cres cfv clt wbr cU cB cF cfv clt wbr cA
        cF cA cB cicc co cres cfv cA cF cfv cU clt cA cA cB cicc co wcel cA cF
        cA cB cicc co cres cfv cA cF cfv wceq cA cr wcel cB cr wcel cA cB cle
        wbr cA cA cB cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1
        isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an cA cA cB cicc co cF
        fvres ax-mp breq1i cB cF cA cB cicc co cres cfv cB cF cfv cU clt cB cA
        cB cicc co wcel cB cF cA cB cicc co cres cfv cB cF cfv wceq cA cr wcel
        cB cr wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA
        cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an cB cA cB
        cicc co cF fvres ax-mp breq2i anbi12i mpbir vc cv cF cA cB cicc co cres
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cfv cU cle
        wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc co cres cfv
        cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc
        co crab wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cv cF cfv
        cU cle wbr vc cA cB cicc co vc cv cA cB cicc co wcel vc cv cF cA cB
        cicc co cres cfv vc cv cF cfv cU cle vc cv cA cB cicc co cF fvres
        breq1d rabbii cr vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab clt supeq1
        ax-mp eqcomi vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab eqid cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA
        cB cicc co cres cA cB cicc co cr ccncf co wcel cF cD cc ccncf co wcel
        cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel isupivth.7 cD cc
        wss cc cc wss cA cB cicc co cD wss cF cD cc ccncf co wcel cF cA cB cicc
        co cres cA cB cicc co cc ccncf co wcel wi isupivth.6 cc ssid isupivth.5
        cD cc cA cB cicc co cF rescncf mp3an ax-mp cA cB cicc co cc wss cc cc
        wss cr cc wss w3a vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB cicc
        co wral cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA cB
        cicc co cres cA cB cicc co cr ccncf co wcel wi cA cB cicc co cc wss cc
        cc wss cr cc wss cA cB cicc co cD cc isupivth.5 isupivth.6 sstri cc
        ssid axresscn 3pm3.2i vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB
        cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres cfv vx cv
        cF cfv cr vx cv cA cB cicc co cF fvres isupivth.8 eqeltrd rgen vx cA cB
        cicc co cc cr cF cA cB cicc co cres cncffvrn mp2an ax-mp ivthlem8
        pm3.27i ivthlem9 eqtr4i fveq2i cC cA cB cicc co wcel cC cF cA cB cicc
        co cres cfv cC cF cfv wceq cA cB cioo co cA cB cicc co cC cA cB
        ioossicc cC vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup
        cA cB cioo co cC cS cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup isupivth.11 cA cB vc cv cF cfv cU cle wbr vc cA cB
        cicc co crab cr clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc
        cA cB cicc co crab cS cU cF cA cB cicc co cres vc vx isupivth.1
        isupivth.2 isupivth.3 isupivth.4 cA cF cA cB cicc co cres cfv cU clt
        wbr cU cB cF cA cB cicc co cres cfv clt wbr wa cA cF cfv cU clt wbr cU
        cB cF cfv clt wbr wa isupivth.10 cA cF cA cB cicc co cres cfv cU clt
        wbr cA cF cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt wbr cU cB
        cF cfv clt wbr cA cF cA cB cicc co cres cfv cA cF cfv cU clt cA cA cB
        cicc co wcel cA cF cA cB cicc co cres cfv cA cF cfv wceq cA cr wcel cB
        cr wcel cA cB cle wbr cA cA cB cicc co wcel isupivth.1 isupivth.2 cA cB
        isupivth.1 isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an cA cA cB
        cicc co cF fvres ax-mp breq1i cB cF cA cB cicc co cres cfv cB cF cfv cU
        clt cB cA cB cicc co wcel cB cF cA cB cicc co cres cfv cB cF cfv wceq
        cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1
        isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2
        mp3an cB cA cB cicc co cF fvres ax-mp breq2i anbi12i mpbir vc cv cF cA
        cB cicc co cres cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv
        cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc
        co cres cfv cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc
        cA cB cicc co crab wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc
        cA cB cicc co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cv
        cF cfv cU cle wbr vc cA cB cicc co vc cv cA cB cicc co wcel vc cv cF cA
        cB cicc co cres cfv vc cv cF cfv cU cle vc cv cA cB cicc co cF fvres
        breq1d rabbii cr vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab clt supeq1
        ax-mp eqcomi vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab eqid cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA
        cB cicc co cres cA cB cicc co cr ccncf co wcel cF cD cc ccncf co wcel
        cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel isupivth.7 cD cc
        wss cc cc wss cA cB cicc co cD wss cF cD cc ccncf co wcel cF cA cB cicc
        co cres cA cB cicc co cc ccncf co wcel wi isupivth.6 cc ssid isupivth.5
        cD cc cA cB cicc co cF rescncf mp3an ax-mp cA cB cicc co cc wss cc cc
        wss cr cc wss w3a vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB cicc
        co wral cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA cB
        cicc co cres cA cB cicc co cr ccncf co wcel wi cA cB cicc co cc wss cc
        cc wss cr cc wss cA cB cicc co cD cc isupivth.5 isupivth.6 sstri cc
        ssid axresscn 3pm3.2i vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB
        cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres cfv vx cv
        cF cfv cr vx cv cA cB cicc co cF fvres isupivth.8 eqeltrd rgen vx cA cB
        cicc co cc cr cF cA cB cicc co cres cncffvrn mp2an ax-mp cS vx cv cF
        cfv cU wceq vx cA cB cicc co crab vx cv cF cA cB cicc co cres cfv cU
        wceq vx cA cB cicc co crab isupivth.9 vx cv cF cA cB cicc co cres cfv
        cU wceq vx cv cF cfv cU wceq vx cA cB cicc co vx cv cA cB cicc co wcel
        vx cv cF cA cB cicc co cres cfv vx cv cF cfv cU vx cv cA cB cicc co cF
        fvres eqeq1d rabbii eqtr4i vc cv cF cfv cU cle wbr vc cA cB cicc co
        crab cr clt csup cA cB cioo co wcel vc cv cF cfv cU cle wbr vc cA cB
        cicc co crab cr clt csup cF cA cB cicc co cres cfv cU wceq cA cB vc cv
        cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc
        co cres cfv cU cle wbr vc cA cB cicc co crab cU cF cA cB cicc co cres
        vc isupivth.1 isupivth.2 isupivth.3 isupivth.4 cA cF cA cB cicc co cres
        cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt wbr wa cA cF cfv cU
        clt wbr cU cB cF cfv clt wbr wa isupivth.10 cA cF cA cB cicc co cres
        cfv cU clt wbr cA cF cfv cU clt wbr cU cB cF cA cB cicc co cres cfv clt
        wbr cU cB cF cfv clt wbr cA cF cA cB cicc co cres cfv cA cF cfv cU clt
        cA cA cB cicc co wcel cA cF cA cB cicc co cres cfv cA cF cfv wceq cA cr
        wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel isupivth.1
        isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB lbicc2
        mp3an cA cA cB cicc co cF fvres ax-mp breq1i cB cF cA cB cicc co cres
        cfv cB cF cfv cU clt cB cA cB cicc co wcel cB cF cA cB cicc co cres cfv
        cB cF cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co
        wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4
        ltleii cA cB ubicc2 mp3an cB cA cB cicc co cF fvres ax-mp breq2i
        anbi12i mpbir vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc co
        crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab wceq vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup wceq vc cv cF cA cB
        cicc co cres cfv cU cle wbr vc cv cF cfv cU cle wbr vc cA cB cicc co vc
        cv cA cB cicc co wcel vc cv cF cA cB cicc co cres cfv vc cv cF cfv cU
        cle vc cv cA cB cicc co cF fvres breq1d rabbii cr vc cv cF cA cB cicc
        co cres cfv cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc
        cA cB cicc co crab clt supeq1 ax-mp eqcomi vc cv cF cA cB cicc co cres
        cfv cU cle wbr vc cA cB cicc co crab eqid cF cA cB cicc co cres cA cB
        cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr ccncf
        co wcel cF cD cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cc
        ccncf co wcel isupivth.7 cD cc wss cc cc wss cA cB cicc co cD wss cF cD
        cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel
        wi isupivth.6 cc ssid isupivth.5 cD cc cA cB cicc co cF rescncf mp3an
        ax-mp cA cB cicc co cc wss cc cc wss cr cc wss w3a vx cv cF cA cB cicc
        co cres cfv cr wcel vx cA cB cicc co wral cF cA cB cicc co cres cA cB
        cicc co cc ccncf co wcel cF cA cB cicc co cres cA cB cicc co cr ccncf
        co wcel wi cA cB cicc co cc wss cc cc wss cr cc wss cA cB cicc co cD cc
        isupivth.5 isupivth.6 sstri cc ssid axresscn 3pm3.2i vx cv cF cA cB
        cicc co cres cfv cr wcel vx cA cB cicc co vx cv cA cB cicc co wcel vx
        cv cF cA cB cicc co cres cfv vx cv cF cfv cr vx cv cA cB cicc co cF
        fvres isupivth.8 eqeltrd rgen vx cA cB cicc co cc cr cF cA cB cicc co
        cres cncffvrn mp2an ax-mp ivthlem8 pm3.27i ivthlem9 eqtr4i vc cv cF cfv
        cU cle wbr vc cA cB cicc co crab cr clt csup cA cB cioo co wcel vc cv
        cF cfv cU cle wbr vc cA cB cicc co crab cr clt csup cF cA cB cicc co
        cres cfv cU wceq cA cB vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc co
        crab cU cF cA cB cicc co cres vc isupivth.1 isupivth.2 isupivth.3
        isupivth.4 cA cF cA cB cicc co cres cfv cU clt wbr cU cB cF cA cB cicc
        co cres cfv clt wbr wa cA cF cfv cU clt wbr cU cB cF cfv clt wbr wa
        isupivth.10 cA cF cA cB cicc co cres cfv cU clt wbr cA cF cfv cU clt
        wbr cU cB cF cA cB cicc co cres cfv clt wbr cU cB cF cfv clt wbr cA cF
        cA cB cicc co cres cfv cA cF cfv cU clt cA cA cB cicc co wcel cA cF cA
        cB cicc co cres cfv cA cF cfv wceq cA cr wcel cB cr wcel cA cB cle wbr
        cA cA cB cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2
        isupivth.4 ltleii cA cB lbicc2 mp3an cA cA cB cicc co cF fvres ax-mp
        breq1i cB cF cA cB cicc co cres cfv cB cF cfv cU clt cB cA cB cicc co
        wcel cB cF cA cB cicc co cres cfv cB cF cfv wceq cA cr wcel cB cr wcel
        cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA cB
        isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an cB cA cB
        cicc co cF fvres ax-mp breq2i anbi12i mpbir vc cv cF cA cB cicc co cres
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cfv cU cle
        wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc co cres cfv
        cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc
        co crab wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cv cF cfv
        cU cle wbr vc cA cB cicc co vc cv cA cB cicc co wcel vc cv cF cA cB
        cicc co cres cfv vc cv cF cfv cU cle vc cv cA cB cicc co cF fvres
        breq1d rabbii cr vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab clt supeq1
        ax-mp eqcomi vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab eqid cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA
        cB cicc co cres cA cB cicc co cr ccncf co wcel cF cD cc ccncf co wcel
        cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel isupivth.7 cD cc
        wss cc cc wss cA cB cicc co cD wss cF cD cc ccncf co wcel cF cA cB cicc
        co cres cA cB cicc co cc ccncf co wcel wi isupivth.6 cc ssid isupivth.5
        cD cc cA cB cicc co cF rescncf mp3an ax-mp cA cB cicc co cc wss cc cc
        wss cr cc wss w3a vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB cicc
        co wral cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA cB
        cicc co cres cA cB cicc co cr ccncf co wcel wi cA cB cicc co cc wss cc
        cc wss cr cc wss cA cB cicc co cD cc isupivth.5 isupivth.6 sstri cc
        ssid axresscn 3pm3.2i vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB
        cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres cfv vx cv
        cF cfv cr vx cv cA cB cicc co cF fvres isupivth.8 eqeltrd rgen vx cA cB
        cicc co cc cr cF cA cB cicc co cres cncffvrn mp2an ax-mp ivthlem8
        pm3.26i eqeltri sselii cC cA cB cicc co cF fvres ax-mp vc cv cF cfv cU
        cle wbr vc cA cB cicc co crab cr clt csup cA cB cioo co wcel vc cv cF
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup cF cA cB cicc co cres
        cfv cU wceq cA cB vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr clt
        csup vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc co crab
        cU cF cA cB cicc co cres vc isupivth.1 isupivth.2 isupivth.3 isupivth.4
        cA cF cA cB cicc co cres cfv cU clt wbr cU cB cF cA cB cicc co cres cfv
        clt wbr wa cA cF cfv cU clt wbr cU cB cF cfv clt wbr wa isupivth.10 cA
        cF cA cB cicc co cres cfv cU clt wbr cA cF cfv cU clt wbr cU cB cF cA
        cB cicc co cres cfv clt wbr cU cB cF cfv clt wbr cA cF cA cB cicc co
        cres cfv cA cF cfv cU clt cA cA cB cicc co wcel cA cF cA cB cicc co
        cres cfv cA cF cfv wceq cA cr wcel cB cr wcel cA cB cle wbr cA cA cB
        cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2
        isupivth.4 ltleii cA cB lbicc2 mp3an cA cA cB cicc co cF fvres ax-mp
        breq1i cB cF cA cB cicc co cres cfv cB cF cfv cU clt cB cA cB cicc co
        wcel cB cF cA cB cicc co cres cfv cB cF cfv wceq cA cr wcel cB cr wcel
        cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA cB
        isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an cB cA cB
        cicc co cF fvres ax-mp breq2i anbi12i mpbir vc cv cF cA cB cicc co cres
        cfv cU cle wbr vc cA cB cicc co crab cr clt csup vc cv cF cfv cU cle
        wbr vc cA cB cicc co crab cr clt csup vc cv cF cA cB cicc co cres cfv
        cU cle wbr vc cA cB cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc
        co crab wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab cr clt csup vc cv cF cfv cU cle wbr vc cA cB cicc co crab cr
        clt csup wceq vc cv cF cA cB cicc co cres cfv cU cle wbr vc cv cF cfv
        cU cle wbr vc cA cB cicc co vc cv cA cB cicc co wcel vc cv cF cA cB
        cicc co cres cfv vc cv cF cfv cU cle vc cv cA cB cicc co cF fvres
        breq1d rabbii cr vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB
        cicc co crab vc cv cF cfv cU cle wbr vc cA cB cicc co crab clt supeq1
        ax-mp eqcomi vc cv cF cA cB cicc co cres cfv cU cle wbr vc cA cB cicc
        co crab eqid cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA
        cB cicc co cres cA cB cicc co cr ccncf co wcel cF cD cc ccncf co wcel
        cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel isupivth.7 cD cc
        wss cc cc wss cA cB cicc co cD wss cF cD cc ccncf co wcel cF cA cB cicc
        co cres cA cB cicc co cc ccncf co wcel wi isupivth.6 cc ssid isupivth.5
        cD cc cA cB cicc co cF rescncf mp3an ax-mp cA cB cicc co cc wss cc cc
        wss cr cc wss w3a vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB cicc
        co wral cF cA cB cicc co cres cA cB cicc co cc ccncf co wcel cF cA cB
        cicc co cres cA cB cicc co cr ccncf co wcel wi cA cB cicc co cc wss cc
        cc wss cr cc wss cA cB cicc co cD cc isupivth.5 isupivth.6 sstri cc
        ssid axresscn 3pm3.2i vx cv cF cA cB cicc co cres cfv cr wcel vx cA cB
        cicc co vx cv cA cB cicc co wcel vx cv cF cA cB cicc co cres cfv vx cv
        cF cfv cr vx cv cA cB cicc co cF fvres isupivth.8 eqeltrd rgen vx cA cB
        cicc co cc cr cF cA cB cicc co cres cncffvrn mp2an ax-mp ivthlem8
        pm3.27i 3eqtr3i pm3.2i $.
        $( [22-Jan-2008] $) $( [22-Jan-2008] $)
    $}

    ${
      $d A a b x $.  $d B a b x $.  $d C a b $.  $d D a b x $.  $d F a b x $.
      $d G x $.  $d U x $.
      dsupivth.10 $e |- ( ( F ` B ) < U /\ U < ( F ` A ) ) $.
      dsupivth.11 $e |- C = sup ( S , RR , < ) $.

      ${
        dsupivthlem.12 $e |- G = { <. a , b >. |
                                   ( a e. D /\ b = -u ( F ` a ) ) } $.
        $( Lemma for ~ dsupivthi . $)
        dsupivthlem $p |- ( C e. ( A (,) B ) /\ ( F ` C ) = U ) $=
          cC cA cB cioo co wcel cC cF cfv cU wceq cC cA cB cioo co wcel cC cG
          cfv cU cneg wceq vx cA cB cC cD cS cU cneg cG isupivth.1 isupivth.2
          cU isupivth.3 renegcli isupivth.4 isupivth.5 isupivth.6 cD cF cG va
          vb isupivth.6 isupivth.7 dsupivthlem.12 negfcncfi vx cv cA cB cicc co
          wcel vx cv cG cfv vx cv cF cfv cneg cr vx cv cA cB cicc co wcel vx cv
          cD wcel vx cv cG cfv vx cv cF cfv cneg wceq cA cB cicc co cD vx cv
          isupivth.5 sseli va vb vx cv va cv cF cfv cneg vx cv cF cfv cneg cD
          cG va cv vx cv wceq va cv cF cfv vx cv cF cfv va cv vx cv cF fveq2
          negeqd dsupivthlem.12 vx cv cF cfv negex fvopab4 syl vx cv cA cB cicc
          co wcel vx cv cF cfv cr wcel vx cv cF cfv cneg cr wcel isupivth.8 vx
          cv cF cfv renegcl syl eqeltrd cS vx cv cF cfv cU wceq vx cA cB cicc
          co crab vx cv cG cfv cU cneg wceq vx cA cB cicc co crab isupivth.9 vx
          cv cF cfv cU wceq vx cv cG cfv cU cneg wceq vx cA cB cicc co vx cv cA
          cB cicc co wcel vx cv cG cfv cU cneg wceq vx cv cF cfv cneg cU cneg
          wceq vx cv cF cfv cU wceq vx cv cA cB cicc co wcel vx cv cG cfv vx cv
          cF cfv cneg cU cneg vx cv cA cB cicc co wcel vx cv cD wcel vx cv cG
          cfv vx cv cF cfv cneg wceq cA cB cicc co cD vx cv isupivth.5 sseli va
          vb vx cv va cv cF cfv cneg vx cv cF cfv cneg cD cG va cv vx cv wceq
          va cv cF cfv vx cv cF cfv va cv vx cv cF fveq2 negeqd dsupivthlem.12
          vx cv cF cfv negex fvopab4 syl eqeq1d vx cv cF cfv cc wcel cU cc wcel
          vx cv cF cfv cneg cU cneg wceq vx cv cF cfv cU wceq wb vx cv cA cB
          cicc co wcel vx cv cF cfv cU neg11 vx cv cA cB cicc co wcel vx cv cF
          cfv isupivth.8 recnd cU isupivth.3 recni sylancl bitr2d rabbii eqtri
          cA cG cfv cU cneg clt wbr cU cneg cB cG cfv clt wbr cA cG cfv cA cF
          cfv cneg cU cneg clt cA cD wcel cA cG cfv cA cF cfv cneg wceq cA cB
          cicc co cD cA isupivth.5 cA cr wcel cB cr wcel cA cB cle wbr cA cA cB
          cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2
          isupivth.4 ltleii cA cB lbicc2 mp3an sselii va vb cA va cv cF cfv
          cneg cA cF cfv cneg cD cG va cv cA wceq va cv cF cfv cA cF cfv va cv
          cA cF fveq2 negeqd dsupivthlem.12 cA cF cfv negex fvopab4 ax-mp cU cA
          cF cfv clt wbr cA cF cfv cneg cU cneg clt wbr cB cF cfv cU clt wbr cU
          cA cF cfv clt wbr dsupivth.10 pm3.27i cU cA cF cfv isupivth.3 cA cA
          cB cicc co wcel vx cv cF cfv cr wcel vx cA cB cicc co wral cA cF cfv
          cr wcel cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel
          isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii
          cA cB lbicc2 mp3an vx cv cF cfv cr wcel vx cA cB cicc co isupivth.8
          rgen vx cv cF cfv cr wcel cA cF cfv cr wcel vx cA cA cB cicc co vx cv
          cA wceq vx cv cF cfv cA cF cfv cr vx cv cA cF fveq2 eleq1d rcla4v mp2
          ltnegi mpbi eqbrtri cU cneg cB cF cfv cneg cB cG cfv clt cB cF cfv cU
          clt wbr cU cneg cB cF cfv cneg clt wbr cB cF cfv cU clt wbr cU cA cF
          cfv clt wbr dsupivth.10 pm3.26i cB cF cfv cU cB cA cB cicc co wcel vx
          cv cF cfv cr wcel vx cA cB cicc co wral cB cF cfv cr wcel cA cr wcel
          cB cr wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2
          cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an vx
          cv cF cfv cr wcel vx cA cB cicc co isupivth.8 rgen vx cv cF cfv cr
          wcel cB cF cfv cr wcel vx cB cA cB cicc co vx cv cB wceq vx cv cF cfv
          cB cF cfv cr vx cv cB cF fveq2 eleq1d rcla4v mp2 isupivth.3 ltnegi
          mpbi cB cD wcel cB cG cfv cB cF cfv cneg wceq cA cB cicc co cD cB
          isupivth.5 cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co wcel
          isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii
          cA cB ubicc2 mp3an sselii va vb cB va cv cF cfv cneg cB cF cfv cneg
          cD cG va cv cB wceq va cv cF cfv cB cF cfv va cv cB cF fveq2 negeqd
          dsupivthlem.12 cB cF cfv negex fvopab4 ax-mp breqtrri pm3.2i
          dsupivth.11 isupivthi pm3.26i cC cF cfv cneg cU cneg wceq cC cF cfv
          cU wceq cC cG cfv cC cF cfv cneg cU cneg cC cA cB cicc co wcel cC cG
          cfv cC cF cfv cneg wceq cA cB cioo co cA cB cicc co cC cA cB ioossicc
          cC cA cB cioo co wcel cC cG cfv cU cneg wceq vx cA cB cC cD cS cU
          cneg cG isupivth.1 isupivth.2 cU isupivth.3 renegcli isupivth.4
          isupivth.5 isupivth.6 cD cF cG va vb isupivth.6 isupivth.7
          dsupivthlem.12 negfcncfi vx cv cA cB cicc co wcel vx cv cG cfv vx cv
          cF cfv cneg cr vx cv cA cB cicc co wcel vx cv cD wcel vx cv cG cfv vx
          cv cF cfv cneg wceq cA cB cicc co cD vx cv isupivth.5 sseli va vb vx
          cv va cv cF cfv cneg vx cv cF cfv cneg cD cG va cv vx cv wceq va cv
          cF cfv vx cv cF cfv va cv vx cv cF fveq2 negeqd dsupivthlem.12 vx cv
          cF cfv negex fvopab4 syl vx cv cA cB cicc co wcel vx cv cF cfv cr
          wcel vx cv cF cfv cneg cr wcel isupivth.8 vx cv cF cfv renegcl syl
          eqeltrd cS vx cv cF cfv cU wceq vx cA cB cicc co crab vx cv cG cfv cU
          cneg wceq vx cA cB cicc co crab isupivth.9 vx cv cF cfv cU wceq vx cv
          cG cfv cU cneg wceq vx cA cB cicc co vx cv cA cB cicc co wcel vx cv
          cG cfv cU cneg wceq vx cv cF cfv cneg cU cneg wceq vx cv cF cfv cU
          wceq vx cv cA cB cicc co wcel vx cv cG cfv vx cv cF cfv cneg cU cneg
          vx cv cA cB cicc co wcel vx cv cD wcel vx cv cG cfv vx cv cF cfv cneg
          wceq cA cB cicc co cD vx cv isupivth.5 sseli va vb vx cv va cv cF cfv
          cneg vx cv cF cfv cneg cD cG va cv vx cv wceq va cv cF cfv vx cv cF
          cfv va cv vx cv cF fveq2 negeqd dsupivthlem.12 vx cv cF cfv negex
          fvopab4 syl eqeq1d vx cv cF cfv cc wcel cU cc wcel vx cv cF cfv cneg
          cU cneg wceq vx cv cF cfv cU wceq wb vx cv cA cB cicc co wcel vx cv
          cF cfv cU neg11 vx cv cA cB cicc co wcel vx cv cF cfv isupivth.8
          recnd cU isupivth.3 recni sylancl bitr2d rabbii eqtri cA cG cfv cU
          cneg clt wbr cU cneg cB cG cfv clt wbr cA cG cfv cA cF cfv cneg cU
          cneg clt cA cD wcel cA cG cfv cA cF cfv cneg wceq cA cB cicc co cD cA
          isupivth.5 cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel
          isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii
          cA cB lbicc2 mp3an sselii va vb cA va cv cF cfv cneg cA cF cfv cneg
          cD cG va cv cA wceq va cv cF cfv cA cF cfv va cv cA cF fveq2 negeqd
          dsupivthlem.12 cA cF cfv negex fvopab4 ax-mp cU cA cF cfv clt wbr cA
          cF cfv cneg cU cneg clt wbr cB cF cfv cU clt wbr cU cA cF cfv clt wbr
          dsupivth.10 pm3.27i cU cA cF cfv isupivth.3 cA cA cB cicc co wcel vx
          cv cF cfv cr wcel vx cA cB cicc co wral cA cF cfv cr wcel cA cr wcel
          cB cr wcel cA cB cle wbr cA cA cB cicc co wcel isupivth.1 isupivth.2
          cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an vx
          cv cF cfv cr wcel vx cA cB cicc co isupivth.8 rgen vx cv cF cfv cr
          wcel cA cF cfv cr wcel vx cA cA cB cicc co vx cv cA wceq vx cv cF cfv
          cA cF cfv cr vx cv cA cF fveq2 eleq1d rcla4v mp2 ltnegi mpbi eqbrtri
          cU cneg cB cF cfv cneg cB cG cfv clt cB cF cfv cU clt wbr cU cneg cB
          cF cfv cneg clt wbr cB cF cfv cU clt wbr cU cA cF cfv clt wbr
          dsupivth.10 pm3.26i cB cF cfv cU cB cA cB cicc co wcel vx cv cF cfv
          cr wcel vx cA cB cicc co wral cB cF cfv cr wcel cA cr wcel cB cr wcel
          cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA cB
          isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an vx cv cF
          cfv cr wcel vx cA cB cicc co isupivth.8 rgen vx cv cF cfv cr wcel cB
          cF cfv cr wcel vx cB cA cB cicc co vx cv cB wceq vx cv cF cfv cB cF
          cfv cr vx cv cB cF fveq2 eleq1d rcla4v mp2 isupivth.3 ltnegi mpbi cB
          cD wcel cB cG cfv cB cF cfv cneg wceq cA cB cicc co cD cB isupivth.5
          cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1
          isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2
          mp3an sselii va vb cB va cv cF cfv cneg cB cF cfv cneg cD cG va cv cB
          wceq va cv cF cfv cB cF cfv va cv cB cF fveq2 negeqd dsupivthlem.12
          cB cF cfv negex fvopab4 ax-mp breqtrri pm3.2i dsupivth.11 isupivthi
          pm3.26i sselii cC cA cB cicc co wcel cC cD wcel cC cG cfv cC cF cfv
          cneg wceq cA cB cicc co cD cC isupivth.5 sseli va vb cC va cv cF cfv
          cneg cC cF cfv cneg cD cG va cv cC wceq va cv cF cfv cC cF cfv va cv
          cC cF fveq2 negeqd dsupivthlem.12 cC cF cfv negex fvopab4 syl ax-mp
          cC cA cB cioo co wcel cC cG cfv cU cneg wceq vx cA cB cC cD cS cU
          cneg cG isupivth.1 isupivth.2 cU isupivth.3 renegcli isupivth.4
          isupivth.5 isupivth.6 cD cF cG va vb isupivth.6 isupivth.7
          dsupivthlem.12 negfcncfi vx cv cA cB cicc co wcel vx cv cG cfv vx cv
          cF cfv cneg cr vx cv cA cB cicc co wcel vx cv cD wcel vx cv cG cfv vx
          cv cF cfv cneg wceq cA cB cicc co cD vx cv isupivth.5 sseli va vb vx
          cv va cv cF cfv cneg vx cv cF cfv cneg cD cG va cv vx cv wceq va cv
          cF cfv vx cv cF cfv va cv vx cv cF fveq2 negeqd dsupivthlem.12 vx cv
          cF cfv negex fvopab4 syl vx cv cA cB cicc co wcel vx cv cF cfv cr
          wcel vx cv cF cfv cneg cr wcel isupivth.8 vx cv cF cfv renegcl syl
          eqeltrd cS vx cv cF cfv cU wceq vx cA cB cicc co crab vx cv cG cfv cU
          cneg wceq vx cA cB cicc co crab isupivth.9 vx cv cF cfv cU wceq vx cv
          cG cfv cU cneg wceq vx cA cB cicc co vx cv cA cB cicc co wcel vx cv
          cG cfv cU cneg wceq vx cv cF cfv cneg cU cneg wceq vx cv cF cfv cU
          wceq vx cv cA cB cicc co wcel vx cv cG cfv vx cv cF cfv cneg cU cneg
          vx cv cA cB cicc co wcel vx cv cD wcel vx cv cG cfv vx cv cF cfv cneg
          wceq cA cB cicc co cD vx cv isupivth.5 sseli va vb vx cv va cv cF cfv
          cneg vx cv cF cfv cneg cD cG va cv vx cv wceq va cv cF cfv vx cv cF
          cfv va cv vx cv cF fveq2 negeqd dsupivthlem.12 vx cv cF cfv negex
          fvopab4 syl eqeq1d vx cv cF cfv cc wcel cU cc wcel vx cv cF cfv cneg
          cU cneg wceq vx cv cF cfv cU wceq wb vx cv cA cB cicc co wcel vx cv
          cF cfv cU neg11 vx cv cA cB cicc co wcel vx cv cF cfv isupivth.8
          recnd cU isupivth.3 recni sylancl bitr2d rabbii eqtri cA cG cfv cU
          cneg clt wbr cU cneg cB cG cfv clt wbr cA cG cfv cA cF cfv cneg cU
          cneg clt cA cD wcel cA cG cfv cA cF cfv cneg wceq cA cB cicc co cD cA
          isupivth.5 cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel
          isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii
          cA cB lbicc2 mp3an sselii va vb cA va cv cF cfv cneg cA cF cfv cneg
          cD cG va cv cA wceq va cv cF cfv cA cF cfv va cv cA cF fveq2 negeqd
          dsupivthlem.12 cA cF cfv negex fvopab4 ax-mp cU cA cF cfv clt wbr cA
          cF cfv cneg cU cneg clt wbr cB cF cfv cU clt wbr cU cA cF cfv clt wbr
          dsupivth.10 pm3.27i cU cA cF cfv isupivth.3 cA cA cB cicc co wcel vx
          cv cF cfv cr wcel vx cA cB cicc co wral cA cF cfv cr wcel cA cr wcel
          cB cr wcel cA cB cle wbr cA cA cB cicc co wcel isupivth.1 isupivth.2
          cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an vx
          cv cF cfv cr wcel vx cA cB cicc co isupivth.8 rgen vx cv cF cfv cr
          wcel cA cF cfv cr wcel vx cA cA cB cicc co vx cv cA wceq vx cv cF cfv
          cA cF cfv cr vx cv cA cF fveq2 eleq1d rcla4v mp2 ltnegi mpbi eqbrtri
          cU cneg cB cF cfv cneg cB cG cfv clt cB cF cfv cU clt wbr cU cneg cB
          cF cfv cneg clt wbr cB cF cfv cU clt wbr cU cA cF cfv clt wbr
          dsupivth.10 pm3.26i cB cF cfv cU cB cA cB cicc co wcel vx cv cF cfv
          cr wcel vx cA cB cicc co wral cB cF cfv cr wcel cA cr wcel cB cr wcel
          cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA cB
          isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an vx cv cF
          cfv cr wcel vx cA cB cicc co isupivth.8 rgen vx cv cF cfv cr wcel cB
          cF cfv cr wcel vx cB cA cB cicc co vx cv cB wceq vx cv cF cfv cB cF
          cfv cr vx cv cB cF fveq2 eleq1d rcla4v mp2 isupivth.3 ltnegi mpbi cB
          cD wcel cB cG cfv cB cF cfv cneg wceq cA cB cicc co cD cB isupivth.5
          cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1
          isupivth.2 cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2
          mp3an sselii va vb cB va cv cF cfv cneg cB cF cfv cneg cD cG va cv cB
          wceq va cv cF cfv cB cF cfv va cv cB cF fveq2 negeqd dsupivthlem.12
          cB cF cfv negex fvopab4 ax-mp breqtrri pm3.2i dsupivth.11 isupivthi
          pm3.27i eqtr3i cC cA cB cicc co wcel cC cF cfv cneg cU cneg wceq cC
          cF cfv cU wceq wb cA cB cioo co cA cB cicc co cC cA cB ioossicc cC cA
          cB cioo co wcel cC cG cfv cU cneg wceq vx cA cB cC cD cS cU cneg cG
          isupivth.1 isupivth.2 cU isupivth.3 renegcli isupivth.4 isupivth.5
          isupivth.6 cD cF cG va vb isupivth.6 isupivth.7 dsupivthlem.12
          negfcncfi vx cv cA cB cicc co wcel vx cv cG cfv vx cv cF cfv cneg cr
          vx cv cA cB cicc co wcel vx cv cD wcel vx cv cG cfv vx cv cF cfv cneg
          wceq cA cB cicc co cD vx cv isupivth.5 sseli va vb vx cv va cv cF cfv
          cneg vx cv cF cfv cneg cD cG va cv vx cv wceq va cv cF cfv vx cv cF
          cfv va cv vx cv cF fveq2 negeqd dsupivthlem.12 vx cv cF cfv negex
          fvopab4 syl vx cv cA cB cicc co wcel vx cv cF cfv cr wcel vx cv cF
          cfv cneg cr wcel isupivth.8 vx cv cF cfv renegcl syl eqeltrd cS vx cv
          cF cfv cU wceq vx cA cB cicc co crab vx cv cG cfv cU cneg wceq vx cA
          cB cicc co crab isupivth.9 vx cv cF cfv cU wceq vx cv cG cfv cU cneg
          wceq vx cA cB cicc co vx cv cA cB cicc co wcel vx cv cG cfv cU cneg
          wceq vx cv cF cfv cneg cU cneg wceq vx cv cF cfv cU wceq vx cv cA cB
          cicc co wcel vx cv cG cfv vx cv cF cfv cneg cU cneg vx cv cA cB cicc
          co wcel vx cv cD wcel vx cv cG cfv vx cv cF cfv cneg wceq cA cB cicc
          co cD vx cv isupivth.5 sseli va vb vx cv va cv cF cfv cneg vx cv cF
          cfv cneg cD cG va cv vx cv wceq va cv cF cfv vx cv cF cfv va cv vx cv
          cF fveq2 negeqd dsupivthlem.12 vx cv cF cfv negex fvopab4 syl eqeq1d
          vx cv cF cfv cc wcel cU cc wcel vx cv cF cfv cneg cU cneg wceq vx cv
          cF cfv cU wceq wb vx cv cA cB cicc co wcel vx cv cF cfv cU neg11 vx
          cv cA cB cicc co wcel vx cv cF cfv isupivth.8 recnd cU isupivth.3
          recni sylancl bitr2d rabbii eqtri cA cG cfv cU cneg clt wbr cU cneg
          cB cG cfv clt wbr cA cG cfv cA cF cfv cneg cU cneg clt cA cD wcel cA
          cG cfv cA cF cfv cneg wceq cA cB cicc co cD cA isupivth.5 cA cr wcel
          cB cr wcel cA cB cle wbr cA cA cB cicc co wcel isupivth.1 isupivth.2
          cA cB isupivth.1 isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an
          sselii va vb cA va cv cF cfv cneg cA cF cfv cneg cD cG va cv cA wceq
          va cv cF cfv cA cF cfv va cv cA cF fveq2 negeqd dsupivthlem.12 cA cF
          cfv negex fvopab4 ax-mp cU cA cF cfv clt wbr cA cF cfv cneg cU cneg
          clt wbr cB cF cfv cU clt wbr cU cA cF cfv clt wbr dsupivth.10 pm3.27i
          cU cA cF cfv isupivth.3 cA cA cB cicc co wcel vx cv cF cfv cr wcel vx
          cA cB cicc co wral cA cF cfv cr wcel cA cr wcel cB cr wcel cA cB cle
          wbr cA cA cB cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1
          isupivth.2 isupivth.4 ltleii cA cB lbicc2 mp3an vx cv cF cfv cr wcel
          vx cA cB cicc co isupivth.8 rgen vx cv cF cfv cr wcel cA cF cfv cr
          wcel vx cA cA cB cicc co vx cv cA wceq vx cv cF cfv cA cF cfv cr vx
          cv cA cF fveq2 eleq1d rcla4v mp2 ltnegi mpbi eqbrtri cU cneg cB cF
          cfv cneg cB cG cfv clt cB cF cfv cU clt wbr cU cneg cB cF cfv cneg
          clt wbr cB cF cfv cU clt wbr cU cA cF cfv clt wbr dsupivth.10 pm3.26i
          cB cF cfv cU cB cA cB cicc co wcel vx cv cF cfv cr wcel vx cA cB cicc
          co wral cB cF cfv cr wcel cA cr wcel cB cr wcel cA cB cle wbr cB cA
          cB cicc co wcel isupivth.1 isupivth.2 cA cB isupivth.1 isupivth.2
          isupivth.4 ltleii cA cB ubicc2 mp3an vx cv cF cfv cr wcel vx cA cB
          cicc co isupivth.8 rgen vx cv cF cfv cr wcel cB cF cfv cr wcel vx cB
          cA cB cicc co vx cv cB wceq vx cv cF cfv cB cF cfv cr vx cv cB cF
          fveq2 eleq1d rcla4v mp2 isupivth.3 ltnegi mpbi cB cD wcel cB cG cfv
          cB cF cfv cneg wceq cA cB cicc co cD cB isupivth.5 cA cr wcel cB cr
          wcel cA cB cle wbr cB cA cB cicc co wcel isupivth.1 isupivth.2 cA cB
          isupivth.1 isupivth.2 isupivth.4 ltleii cA cB ubicc2 mp3an sselii va
          vb cB va cv cF cfv cneg cB cF cfv cneg cD cG va cv cB wceq va cv cF
          cfv cB cF cfv va cv cB cF fveq2 negeqd dsupivthlem.12 cB cF cfv negex
          fvopab4 ax-mp breqtrri pm3.2i dsupivth.11 isupivthi pm3.26i sselii cC
          cA cB cicc co wcel cC cD wcel cC cF cfv cc wcel cC cF cfv cneg cU
          cneg wceq cC cF cfv cU wceq wb cA cB cicc co cD cC isupivth.5 sseli
          cD cc wss cc cc wss cF cD cc ccncf co wcel cC cD wcel cC cF cfv cc
          wcel wi isupivth.6 cc ssid isupivth.7 cD cc cC cF cncffvelrn mp3an cC
          cF cfv cc wcel cU cc wcel cC cF cfv cneg cU cneg wceq cC cF cfv cU
          wceq wb cU isupivth.3 recni cC cF cfv cU neg11 mpan2 3syl ax-mp mpbi
          pm3.2i $.
          $( [22-Jan-2008] $) $( [22-Jan-2008] $)
      $}

      $( The intermediate value theorem, decreasing case with supremum
         solution.  (Contributed by Paul Chapman, 22-Jan-2008.) $)
      dsupivthi $p |- ( C e. ( A (,) B ) /\ ( F ` C ) = U ) $=
        vx cA cB cC cD cS cU cF va cv cD wcel vb cv va cv cF cfv cneg wceq wa
        va vb copab va vb isupivth.1 isupivth.2 isupivth.3 isupivth.4
        isupivth.5 isupivth.6 isupivth.7 isupivth.8 isupivth.9 dsupivth.10
        dsupivth.11 va cv cD wcel vb cv va cv cF cfv cneg wceq wa va vb copab
        eqid dsupivthlem $.
        $( [22-Jan-2008] $) $( [22-Jan-2008] $)
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The exponential, sine, and cosine functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c exp $. $( Exponential function. $)
  $c _e $. $( Letter e (Euler's constant = 2.71828...) $)
  $c sin $. $( Sine function. $)
  $c cos $. $( Cosine function. $)
  $c pi $. $( Pi = 3.14159... $)

  $( Extend class notation to include the exponential function. $)
  ce $a class exp $.

  $( Extend class notation to include Euler's constant = 2.7182818.... $)
  ceu $a class _e $.

  $( Extend class notation to include the sine function. $)
  csin $a class sin $.

  $( Extend class notation to include the cosine function. $)
  ccos $a class cos $.

  $( Extend class notation to include pi = 3.14159.... $)
  cpi $a class pi $.

  ${
    $d j k x y w $.
    $( Define the exponential function. $)
    df-ef $a |- exp = { <. x , y >. | ( x e. CC /\ y =
                  sum_ k e. NN0 ( ( x ^ k ) / ( ! ` k ) ) ) } $.

    $( Define Euler's constant 2.71828.... $)
    df-e $a |- _e = ( exp ` 1 ) $.

    $( Define the sine function. $)
    df-sin $a |- sin = { <. x , y >. | ( x e. CC /\ y =
 ( ( ( exp ` ( _i x. x ) ) - ( exp ` ( -u _i x. x ) ) ) / ( 2 x. _i ) ) ) } $.

$(
    @( Define the cosine function. @)
    df-cos @a |- cos =
        { <. x , y >. | ( x e. CC /\ y = ( sin ` ( x + ( pi / 2 ) ) ) ) } @.
$)

    $( Define the cosine function. $)
    df-cos $a |- cos = { <. x , y >. | ( x e. CC /\ y =
        ( ( ( exp ` ( _i x. x ) ) + ( exp ` ( -u _i x. x ) ) ) / 2 ) ) } $.

    $( Define pi = 3.14159..., which is the smallest positive number whose sine
       is zero.  Definition of pi in [Gleason] p. 311.  (We use the inverse of
       of less-than, " ` ``' < ` ", to turn supremum into infimum; currently we
       don't have infimum defined separately.) $)
    df-pi $a |- pi =
          sup ( { x e. RR | ( 0 < x /\ ( sin ` x ) = 0 ) } , RR , `' < ) $.
  $}

  $( Closure of a term in the series expansion of the exponential function.
     (Contributed by Paul Chapman, 11-Sep-2007.) $)
  eftcl $p |- ( ( A e. CC /\ K e. NN0 ) ->
                 ( ( A ^ K ) / ( ! ` K ) ) e. CC ) $=
    cA cK cexp co cc wcel cK cfa cfv cc wcel cK cfa cfv cc0 wne cA cK cexp co
    cK cfa cfv cdiv co cc wcel cA cc wcel cK cn0 wcel wa cA cK cexp co cK cfa
    cfv divcl cA cK expcl cK cn0 wcel cK cfa cfv cc wcel cA cc wcel cK cn0 wcel
    cK cfa cfv cn wcel cK cfa cfv cc wcel cK faccl cK cfa cfv nncn syl adantl
    cK cn0 wcel cK cfa cfv cc0 wne cA cc wcel cK facne0 adantl syl3anc $.
    $( [13-Sep-2007] $) $( [11-Sep-2007] $)

  ${
    $d x y z w A $.  $d x w F $.
    efcltlem.1 $e |- F = { <. y , z >. | ( y e. NN /\
                    z = ( ( A ^ y ) / ( ! ` y ) ) ) } $.
    ${
      efcltlem1.2 $e |- A e. CC $.
      efcltlem1.3 $e |- A =/= 0 $.
      $( Lemma for ~ efcl .  The series that defines the exponential
         function converges, in the case where its argument is nonzero.  The
         ratio test ~ cvgrati is used to show convergence. $)
      efcltlem1 $p |- E. x ( + seq1 F ) ~~> x $=
        cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co cr wcel cA cabs cfv
        cA cabs cfv cfl cfv c1 caddc co cdiv co c1 clt wbr wa cA cabs cfv cfl
        cfv c1 caddc co cn wcel cA cabs cfv cfl cfv c1 caddc co vw cv cle wbr
        vw cv c1 caddc co cF cfv cabs cfv cA cabs cfv cA cabs cfv cfl cfv c1
        caddc co cdiv co vw cv cF cfv cabs cfv cmul co clt wbr wi vw cn wral wa
        caddc cF cseq1 co vx cv cli wbr vx wex cA cabs cfv cA cabs cfv cfl cfv
        c1 caddc co cdiv co cr wcel cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
        cdiv co c1 clt wbr cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cA
        efcltlem1.2 abscli cA cabs cfv cfl cfv cr wcel cA cabs cfv cfl cfv c1
        caddc co cr wcel cA cabs cfv cr wcel cA cabs cfv cfl cfv cr wcel cA
        efcltlem1.2 abscli cA cabs cfv reflcl ax-mp cA cabs cfv cfl cfv
        peano2re ax-mp cA cabs cfv cfl cfv c1 caddc co cA cabs cfv cfl cfv cr
        wcel cA cabs cfv cfl cfv c1 caddc co cr wcel cA cabs cfv cr wcel cA
        cabs cfv cfl cfv cr wcel cA efcltlem1.2 abscli cA cabs cfv reflcl ax-mp
        cA cabs cfv cfl cfv peano2re ax-mp cc0 cA cabs cfv cfl cfv cle wbr cc0
        c1 clt wbr cc0 cA cabs cfv cfl cfv c1 caddc co clt wbr cc0 cA cabs cfv
        cle wbr cc0 cA cabs cfv cfl cfv cle wbr cA efcltlem1.2 absge0i cA cabs
        cfv cr wcel cc0 cz wcel cc0 cA cabs cfv cle wbr cc0 cA cabs cfv cfl cfv
        cle wbr wb cA efcltlem1.2 abscli 0z cA cabs cfv cc0 flge mp2an mpbi
        lt01 cA cabs cfv cfl cfv c1 cA cabs cfv cr wcel cA cabs cfv cfl cfv cr
        wcel cA efcltlem1.2 abscli cA cabs cfv reflcl ax-mp 1re addgegt0i mp2an
        gt0ne0ii redivcli cA cabs cfv c1 cdiv co cA cabs cfv cfl cfv c1 caddc
        co clt wbr cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co c1 clt
        wbr cA cabs cfv c1 cdiv co cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
        clt cA cabs cfv cA cabs cfv cA efcltlem1.2 abscli recni div1i cA cabs
        cfv cr wcel cA cabs cfv cA cabs cfv cfl cfv c1 caddc co clt wbr cA
        efcltlem1.2 abscli cA cabs cfv flltp1 ax-mp eqbrtri cA cabs cfv c1 cA
        cabs cfv cfl cfv c1 caddc co cA efcltlem1.2 abscli 1re cA cabs cfv cfl
        cfv cr wcel cA cabs cfv cfl cfv c1 caddc co cr wcel cA cabs cfv cr wcel
        cA cabs cfv cfl cfv cr wcel cA efcltlem1.2 abscli cA cabs cfv reflcl
        ax-mp cA cabs cfv cfl cfv peano2re ax-mp lt01 cc0 cA cabs cfv cfl cfv
        cle wbr cc0 c1 clt wbr cc0 cA cabs cfv cfl cfv c1 caddc co clt wbr cc0
        cA cabs cfv cle wbr cc0 cA cabs cfv cfl cfv cle wbr cA efcltlem1.2
        absge0i cA cabs cfv cr wcel cc0 cz wcel cc0 cA cabs cfv cle wbr cc0 cA
        cabs cfv cfl cfv cle wbr wb cA efcltlem1.2 abscli 0z cA cabs cfv cc0
        flge mp2an mpbi lt01 cA cabs cfv cfl cfv c1 cA cabs cfv cr wcel cA cabs
        cfv cfl cfv cr wcel cA efcltlem1.2 abscli cA cabs cfv reflcl ax-mp 1re
        addgegt0i mp2an ltdiv23ii mpbi pm3.2i cA cabs cfv cfl cfv c1 caddc co
        cn wcel cA cabs cfv cfl cfv c1 caddc co vw cv cle wbr vw cv c1 caddc co
        cF cfv cabs cfv cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co vw
        cv cF cfv cabs cfv cmul co clt wbr wi vw cn wral cA cabs cfv cfl cfv
        cn0 wcel cA cabs cfv cfl cfv c1 caddc co cn wcel cA cabs cfv cr wcel
        cc0 cA cabs cfv cle wbr cA cabs cfv cfl cfv cn0 wcel cA efcltlem1.2
        abscli cA efcltlem1.2 absge0i cA cabs cfv flge0nn0 mp2an cA cabs cfv
        cfl cfv nn0p1nn ax-mp cA cabs cfv cfl cfv c1 caddc co vw cv cle wbr vw
        cv c1 caddc co cF cfv cabs cfv cA cabs cfv cA cabs cfv cfl cfv c1 caddc
        co cdiv co vw cv cF cfv cabs cfv cmul co clt wbr wi vw cn vw cv cn wcel
        cA cabs cfv cfl cfv c1 caddc co vw cv cle wbr vw cv c1 caddc co cF cfv
        cabs cfv cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co vw cv cF
        cfv cabs cfv cmul co clt wbr vw cv cn wcel cA cabs cfv cfl cfv c1 caddc
        co vw cv cle wbr cA cabs cfv cfl cfv c1 caddc co vw cv c1 caddc co clt
        wbr vw cv c1 caddc co cF cfv cabs cfv cA cabs cfv cA cabs cfv cfl cfv
        c1 caddc co cdiv co vw cv cF cfv cabs cfv cmul co clt wbr cA cabs cfv
        cfl cfv c1 caddc co cn wcel vw cv cn wcel cA cabs cfv cfl cfv c1 caddc
        co vw cv cle wbr cA cabs cfv cfl cfv c1 caddc co vw cv c1 caddc co clt
        wbr wb cA cabs cfv cfl cfv cn0 wcel cA cabs cfv cfl cfv c1 caddc co cn
        wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr cA cabs cfv cfl cfv
        cn0 wcel cA efcltlem1.2 abscli cA efcltlem1.2 absge0i cA cabs cfv
        flge0nn0 mp2an cA cabs cfv cfl cfv nn0p1nn ax-mp cA cabs cfv cfl cfv c1
        caddc co vw cv nnleltp1 mpan vw cv cn wcel cA cabs cfv cfl cfv c1 caddc
        co vw cv c1 caddc co cabs cfv clt wbr cA cabs cfv vw cv c1 caddc co
        cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co
        clt wbr cA cabs cfv cfl cfv c1 caddc co vw cv c1 caddc co clt wbr vw cv
        c1 caddc co cF cfv cabs cfv cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
        cdiv co vw cv cF cfv cabs cfv cmul co clt wbr vw cv c1 caddc co cabs
        cfv cr wcel cc0 vw cv c1 caddc co cabs cfv clt wbr cA cabs cfv cfl cfv
        c1 caddc co vw cv c1 caddc co cabs cfv clt wbr cA cabs cfv vw cv c1
        caddc co cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
        cdiv co clt wbr wb vw cv cn wcel cA cabs cfv cfl cfv c1 caddc co cr
        wcel cc0 cA cabs cfv cfl cfv c1 caddc co clt wbr vw cv c1 caddc co cabs
        cfv cr wcel cc0 vw cv c1 caddc co cabs cfv clt wbr wa cA cabs cfv cfl
        cfv c1 caddc co vw cv c1 caddc co cabs cfv clt wbr cA cabs cfv vw cv c1
        caddc co cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
        cdiv co clt wbr wb cA cabs cfv cfl cfv cr wcel cA cabs cfv cfl cfv c1
        caddc co cr wcel cA cabs cfv cr wcel cA cabs cfv cfl cfv cr wcel cA
        efcltlem1.2 abscli cA cabs cfv reflcl ax-mp cA cabs cfv cfl cfv
        peano2re ax-mp cc0 cA cabs cfv cfl cfv cle wbr cc0 c1 clt wbr cc0 cA
        cabs cfv cfl cfv c1 caddc co clt wbr cc0 cA cabs cfv cle wbr cc0 cA
        cabs cfv cfl cfv cle wbr cA efcltlem1.2 absge0i cA cabs cfv cr wcel cc0
        cz wcel cc0 cA cabs cfv cle wbr cc0 cA cabs cfv cfl cfv cle wbr wb cA
        efcltlem1.2 abscli 0z cA cabs cfv cc0 flge mp2an mpbi lt01 cA cabs cfv
        cfl cfv c1 cA cabs cfv cr wcel cA cabs cfv cfl cfv cr wcel cA
        efcltlem1.2 abscli cA cabs cfv reflcl ax-mp 1re addgegt0i mp2an cA cabs
        cfv cfl cfv c1 caddc co cr wcel cc0 cA cabs cfv cfl cfv c1 caddc co clt
        wbr wa vw cv c1 caddc co cabs cfv cr wcel cc0 vw cv c1 caddc co cabs
        cfv clt wbr wa cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr wa cA cabs
        cfv cfl cfv c1 caddc co vw cv c1 caddc co cabs cfv clt wbr cA cabs cfv
        vw cv c1 caddc co cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl cfv c1
        caddc co cdiv co clt wbr wb cA cabs cfv cr wcel cc0 cA cabs cfv clt wbr
        cA efcltlem1.2 abscli cA cc0 wne cc0 cA cabs cfv clt wbr efcltlem1.3 cA
        efcltlem1.2 absgt0i mpbi pm3.2i cA cabs cfv cfl cfv c1 caddc co cr wcel
        cc0 cA cabs cfv cfl cfv c1 caddc co clt wbr wa vw cv c1 caddc co cabs
        cfv cr wcel cc0 vw cv c1 caddc co cabs cfv clt wbr wa cA cabs cfv cr
        wcel cc0 cA cabs cfv clt wbr wa w3a cA cabs cfv cfl cfv c1 caddc co cr
        wcel vw cv c1 caddc co cabs cfv cr wcel cA cabs cfv cr wcel w3a cc0 cA
        cabs cfv cfl cfv c1 caddc co clt wbr cc0 vw cv c1 caddc co cabs cfv clt
        wbr cc0 cA cabs cfv clt wbr w3a wa cA cabs cfv cfl cfv c1 caddc co vw
        cv c1 caddc co cabs cfv clt wbr cA cabs cfv vw cv c1 caddc co cabs cfv
        cdiv co cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co clt wbr wb
        cA cabs cfv cfl cfv c1 caddc co cr wcel vw cv c1 caddc co cabs cfv cr
        wcel cA cabs cfv cr wcel cc0 cA cabs cfv cfl cfv c1 caddc co clt wbr
        cc0 vw cv c1 caddc co cabs cfv clt wbr cc0 cA cabs cfv clt wbr an6 cA
        cabs cfv cfl cfv c1 caddc co vw cv c1 caddc co cabs cfv cA cabs cfv
        ltdiv2 sylbir mp3an3 mpanl12 vw cv cn wcel vw cv c1 caddc co cn wcel vw
        cv c1 caddc co cc wcel vw cv c1 caddc co cabs cfv cr wcel vw cv
        peano2nn vw cv c1 caddc co nncn vw cv c1 caddc co abscl 3syl vw cv cn
        wcel vw cv c1 caddc co cn wcel cc0 vw cv c1 caddc co cabs cfv clt wbr
        vw cv peano2nn vw cv c1 caddc co cn wcel cc0 vw cv c1 caddc co vw cv c1
        caddc co cabs cfv clt vw cv c1 caddc co nngt0 vw cv c1 caddc co cr wcel
        cc0 vw cv c1 caddc co cle wbr vw cv c1 caddc co cabs cfv vw cv c1 caddc
        co wceq vw cv c1 caddc co cn wcel vw cv c1 caddc co absid vw cv c1
        caddc co nnre vw cv c1 caddc co cn wcel vw cv c1 caddc co cn0 wcel cc0
        vw cv c1 caddc co cle wbr vw cv c1 caddc co nnnn0 vw cv c1 caddc co
        nn0ge0 syl sylanc breqtrrd syl sylanc vw cv cn wcel vw cv c1 caddc co
        cabs cfv vw cv c1 caddc co cA cabs cfv cfl cfv c1 caddc co clt vw cv c1
        caddc co cr wcel cc0 vw cv c1 caddc co cle wbr vw cv c1 caddc co cabs
        cfv vw cv c1 caddc co wceq vw cv cn wcel vw cv c1 caddc co absid vw cv
        cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cr wcel vw cv
        peano2nn vw cv c1 caddc co nnre syl vw cv cn wcel vw cv cn0 wcel vw cv
        c1 caddc co cn0 wcel cc0 vw cv c1 caddc co cle wbr vw cv nnnn0 vw cv
        peano2nn0 vw cv c1 caddc co nn0ge0 3syl sylanc breq2d vw cv cn wcel cA
        cabs cfv vw cv c1 caddc co cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl
        cfv c1 caddc co cdiv co clt wbr cA cabs cfv vw cv c1 caddc co cabs cfv
        cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv cmul co cA cabs
        cfv cA cabs cfv cfl cfv c1 caddc co cdiv co cA vw cv cexp co vw cv cfa
        cfv cdiv co cabs cfv cmul co clt wbr vw cv c1 caddc co cF cfv cabs cfv
        cA cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co vw cv cF cfv cabs
        cfv cmul co clt wbr cA cabs cfv vw cv c1 caddc co cabs cfv cdiv co cr
        wcel cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv cr wcel cc0 cA vw
        cv cexp co vw cv cfa cfv cdiv co cabs cfv clt wbr wa cA cabs cfv vw cv
        c1 caddc co cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl cfv c1 caddc
        co cdiv co clt wbr cA cabs cfv vw cv c1 caddc co cabs cfv cdiv co cA vw
        cv cexp co vw cv cfa cfv cdiv co cabs cfv cmul co cA cabs cfv cA cabs
        cfv cfl cfv c1 caddc co cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co
        cabs cfv cmul co clt wbr wb vw cv cn wcel cA cabs cfv vw cv c1 caddc co
        cabs cfv cdiv co cr wcel cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
        cdiv co cr wcel cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv cr wcel
        cc0 cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv clt wbr wa cA cabs
        cfv vw cv c1 caddc co cabs cfv cdiv co cA cabs cfv cA cabs cfv cfl cfv
        c1 caddc co cdiv co clt wbr cA cabs cfv vw cv c1 caddc co cabs cfv cdiv
        co cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv cmul co cA cabs cfv
        cA cabs cfv cfl cfv c1 caddc co cdiv co cA vw cv cexp co vw cv cfa cfv
        cdiv co cabs cfv cmul co clt wbr wb cA cabs cfv cA cabs cfv cfl cfv c1
        caddc co cA efcltlem1.2 abscli cA cabs cfv cfl cfv cr wcel cA cabs cfv
        cfl cfv c1 caddc co cr wcel cA cabs cfv cr wcel cA cabs cfv cfl cfv cr
        wcel cA efcltlem1.2 abscli cA cabs cfv reflcl ax-mp cA cabs cfv cfl cfv
        peano2re ax-mp cA cabs cfv cfl cfv c1 caddc co cA cabs cfv cfl cfv cr
        wcel cA cabs cfv cfl cfv c1 caddc co cr wcel cA cabs cfv cr wcel cA
        cabs cfv cfl cfv cr wcel cA efcltlem1.2 abscli cA cabs cfv reflcl ax-mp
        cA cabs cfv cfl cfv peano2re ax-mp cc0 cA cabs cfv cfl cfv cle wbr cc0
        c1 clt wbr cc0 cA cabs cfv cfl cfv c1 caddc co clt wbr cc0 cA cabs cfv
        cle wbr cc0 cA cabs cfv cfl cfv cle wbr cA efcltlem1.2 absge0i cA cabs
        cfv cr wcel cc0 cz wcel cc0 cA cabs cfv cle wbr cc0 cA cabs cfv cfl cfv
        cle wbr wb cA efcltlem1.2 abscli 0z cA cabs cfv cc0 flge mp2an mpbi
        lt01 cA cabs cfv cfl cfv c1 cA cabs cfv cr wcel cA cabs cfv cfl cfv cr
        wcel cA efcltlem1.2 abscli cA cabs cfv reflcl ax-mp 1re addgegt0i mp2an
        gt0ne0ii redivcli cA cabs cfv vw cv c1 caddc co cabs cfv cdiv co cA
        cabs cfv cA cabs cfv cfl cfv c1 caddc co cdiv co cA vw cv cexp co vw cv
        cfa cfv cdiv co cabs cfv ltmul1 mp3an2 vw cv c1 caddc co cabs cfv cr
        wcel vw cv c1 caddc co cabs cfv cc0 wne cA cabs cfv vw cv c1 caddc co
        cabs cfv cdiv co cr wcel vw cv cn wcel cA cabs cfv cr wcel vw cv c1
        caddc co cabs cfv cr wcel vw cv c1 caddc co cabs cfv cc0 wne cA cabs
        cfv vw cv c1 caddc co cabs cfv cdiv co cr wcel cA efcltlem1.2 abscli cA
        cabs cfv vw cv c1 caddc co cabs cfv redivcl mp3an1 vw cv cn wcel vw cv
        c1 caddc co cn wcel vw cv c1 caddc co cc wcel vw cv c1 caddc co cabs
        cfv cr wcel vw cv peano2nn vw cv c1 caddc co nncn vw cv c1 caddc co
        abscl 3syl vw cv c1 caddc co cabs cfv cr wcel cc0 vw cv c1 caddc co
        cabs cfv clt wbr vw cv c1 caddc co cabs cfv cc0 wne vw cv cn wcel vw cv
        c1 caddc co cabs cfv gt0ne0 vw cv cn wcel vw cv c1 caddc co cn wcel vw
        cv c1 caddc co cc wcel vw cv c1 caddc co cabs cfv cr wcel vw cv
        peano2nn vw cv c1 caddc co nncn vw cv c1 caddc co abscl 3syl vw cv cn
        wcel vw cv c1 caddc co cn wcel cc0 vw cv c1 caddc co cabs cfv clt wbr
        vw cv peano2nn vw cv c1 caddc co cn wcel cc0 vw cv c1 caddc co vw cv c1
        caddc co cabs cfv clt vw cv c1 caddc co nngt0 vw cv c1 caddc co cr wcel
        cc0 vw cv c1 caddc co cle wbr vw cv c1 caddc co cabs cfv vw cv c1 caddc
        co wceq vw cv c1 caddc co cn wcel vw cv c1 caddc co absid vw cv c1
        caddc co nnre vw cv c1 caddc co cn wcel vw cv c1 caddc co cn0 wcel cc0
        vw cv c1 caddc co cle wbr vw cv c1 caddc co nnnn0 vw cv c1 caddc co
        nn0ge0 syl sylanc breqtrrd syl sylanc sylanc vw cv cn wcel cA vw cv
        cexp co vw cv cfa cfv cdiv co cabs cfv cr wcel cc0 cA vw cv cexp co vw
        cv cfa cfv cdiv co cabs cfv clt wbr vw cv cn wcel cA vw cv cexp co vw
        cv cfa cfv cdiv co cc wcel cA vw cv cexp co vw cv cfa cfv cdiv co cabs
        cfv cr wcel cA cc wcel vw cv cn0 wcel cA vw cv cexp co vw cv cfa cfv
        cdiv co cc wcel vw cv cn wcel cA vw cv eftcl efcltlem1.2 vw cv nnnn0
        sylancr cA vw cv cexp co vw cv cfa cfv cdiv co abscl syl cA vw cv cexp
        co vw cv cfa cfv cdiv co cc wcel cA vw cv cexp co vw cv cfa cfv cdiv co
        cc0 wne cc0 cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv clt wbr vw
        cv cn wcel cA vw cv cexp co vw cv cfa cfv cdiv co cc wcel cA vw cv cexp
        co vw cv cfa cfv cdiv co cc0 wne cc0 cA vw cv cexp co vw cv cfa cfv
        cdiv co cabs cfv clt wbr cA vw cv cexp co vw cv cfa cfv cdiv co absgt0
        biimpa cA cc wcel vw cv cn0 wcel cA vw cv cexp co vw cv cfa cfv cdiv co
        cc wcel vw cv cn wcel cA vw cv eftcl efcltlem1.2 vw cv nnnn0 sylancr cA
        vw cv cexp co cc wcel cA vw cv cexp co cc0 wne vw cv cfa cfv cc wcel vw
        cv cfa cfv cc0 wne cA vw cv cexp co vw cv cfa cfv cdiv co cc0 wne vw cv
        cn wcel cA vw cv cexp co vw cv cfa cfv divne0 cA cc wcel vw cv cn0 wcel
        cA vw cv cexp co cc wcel vw cv cn wcel cA vw cv expcl efcltlem1.2 vw cv
        nnnn0 sylancr vw cv cn wcel cA vw cv cexp co cc0 wne cA cc0 wne
        efcltlem1.3 cA cc wcel vw cv cn wcel cA vw cv cexp co cc0 wne cA cc0
        wne wb efcltlem1.2 cA vw cv expne0 mpan mpbiri vw cv cn wcel vw cv cn0
        wcel vw cv cfa cfv cn wcel vw cv cfa cfv cc wcel vw cv nnnn0 vw cv
        faccl vw cv cfa cfv nncn 3syl vw cv cn wcel vw cv cn0 wcel vw cv cfa
        cfv cn wcel vw cv cfa cfv cc0 wne vw cv nnnn0 vw cv faccl vw cv cfa cfv
        nnne0 3syl syl2anc sylanc jca sylanc vw cv cn wcel vw cv c1 caddc co cF
        cfv cabs cfv cA cabs cfv vw cv c1 caddc co cabs cfv cdiv co cA vw cv
        cexp co vw cv cfa cfv cdiv co cabs cfv cmul co cA cabs cfv cA cabs cfv
        cfl cfv c1 caddc co cdiv co vw cv cF cfv cabs cfv cmul co cA cabs cfv
        cA cabs cfv cfl cfv c1 caddc co cdiv co cA vw cv cexp co vw cv cfa cfv
        cdiv co cabs cfv cmul co clt vw cv cn wcel vw cv c1 caddc co cF cfv
        cabs cfv cA vw cv c1 caddc co cdiv co cA vw cv cexp co vw cv cfa cfv
        cdiv co cmul co cabs cfv cA vw cv c1 caddc co cdiv co cabs cfv cA vw cv
        cexp co vw cv cfa cfv cdiv co cabs cfv cmul co cA cabs cfv vw cv c1
        caddc co cabs cfv cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co cabs
        cfv cmul co vw cv cn wcel vw cv c1 caddc co cF cfv cA vw cv c1 caddc co
        cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co cmul co cabs vw cv cn
        wcel vw cv c1 caddc co cF cfv cA vw cv c1 caddc co cexp co vw cv c1
        caddc co cfa cfv cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co cA vw
        cv c1 caddc co cdiv co cmul co cA vw cv c1 caddc co cdiv co cA vw cv
        cexp co vw cv cfa cfv cdiv co cmul co vw cv cn wcel vw cv c1 caddc co
        cn wcel vw cv c1 caddc co cF cfv cA vw cv c1 caddc co cexp co vw cv c1
        caddc co cfa cfv cdiv co wceq vw cv peano2nn vy vz vw cv c1 caddc co cA
        vy cv cexp co vy cv cfa cfv cdiv co cA vw cv c1 caddc co cexp co vw cv
        c1 caddc co cfa cfv cdiv co cn cF vy cv vw cv c1 caddc co wceq cA vy cv
        cexp co cA vw cv c1 caddc co cexp co vy cv cfa cfv vw cv c1 caddc co
        cfa cfv cdiv vy cv vw cv c1 caddc co cA cexp opreq2 vy cv vw cv c1
        caddc co cfa fveq2 opreq12d efcltlem.1 cA vw cv c1 caddc co cexp co vw
        cv c1 caddc co cfa cfv cdiv oprex fvopab4 syl vw cv cn wcel cA vw cv c1
        caddc co cexp co vw cv c1 caddc co cfa cfv cdiv co cA vw cv cexp co cA
        cmul co vw cv cfa cfv vw cv c1 caddc co cmul co cdiv co cA vw cv cexp
        co vw cv cfa cfv cdiv co cA vw cv c1 caddc co cdiv co cmul co vw cv cn
        wcel cA vw cv c1 caddc co cexp co cA vw cv cexp co cA cmul co vw cv c1
        caddc co cfa cfv vw cv cfa cfv vw cv c1 caddc co cmul co cdiv cA cc
        wcel vw cv cn0 wcel cA vw cv c1 caddc co cexp co cA vw cv cexp co cA
        cmul co wceq vw cv cn wcel cA vw cv expp1 efcltlem1.2 vw cv nnnn0
        sylancr vw cv cn wcel vw cv cn0 wcel vw cv c1 caddc co cfa cfv vw cv
        cfa cfv vw cv c1 caddc co cmul co wceq vw cv nnnn0 vw cv facp1 syl
        opreq12d cA vw cv cexp co cc wcel cA cc wcel vw cv cfa cfv cc wcel vw
        cv cfa cfv cc0 wne wa vw cv c1 caddc co cc wcel vw cv c1 caddc co cc0
        wne wa cA vw cv cexp co vw cv cfa cfv cdiv co cA vw cv c1 caddc co cdiv
        co cmul co cA vw cv cexp co cA cmul co vw cv cfa cfv vw cv c1 caddc co
        cmul co cdiv co wceq vw cv cn wcel cA vw cv cexp co cA vw cv cfa cfv vw
        cv c1 caddc co divmuldiv cA cc wcel vw cv cn0 wcel cA vw cv cexp co cc
        wcel vw cv cn wcel cA vw cv expcl efcltlem1.2 vw cv nnnn0 sylancr cA cc
        wcel vw cv cn wcel efcltlem1.2 a1i vw cv cn wcel vw cv cfa cfv cc wcel
        vw cv cfa cfv cc0 wne vw cv cn wcel vw cv cn0 wcel vw cv cfa cfv cn
        wcel vw cv cfa cfv cc wcel vw cv nnnn0 vw cv faccl vw cv cfa cfv nncn
        3syl vw cv cn wcel vw cv cn0 wcel vw cv cfa cfv cn wcel vw cv cfa cfv
        cc0 wne vw cv nnnn0 vw cv faccl vw cv cfa cfv nnne0 3syl jca vw cv cn
        wcel vw cv c1 caddc co cc wcel vw cv c1 caddc co cc0 wne vw cv cn wcel
        vw cv c1 caddc co cn wcel vw cv c1 caddc co cc wcel vw cv peano2nn vw
        cv c1 caddc co nncn syl vw cv cn wcel vw cv c1 caddc co cn wcel vw cv
        c1 caddc co cc0 wne vw cv peano2nn vw cv c1 caddc co nnne0 syl jca
        syl2anc eqtr4d cA vw cv cexp co vw cv cfa cfv cdiv co cc wcel cA vw cv
        c1 caddc co cdiv co cc wcel cA vw cv cexp co vw cv cfa cfv cdiv co cA
        vw cv c1 caddc co cdiv co cmul co cA vw cv c1 caddc co cdiv co cA vw cv
        cexp co vw cv cfa cfv cdiv co cmul co wceq vw cv cn wcel cA vw cv cexp
        co vw cv cfa cfv cdiv co cA vw cv c1 caddc co cdiv co mulcom cA cc wcel
        vw cv cn0 wcel cA vw cv cexp co vw cv cfa cfv cdiv co cc wcel vw cv cn
        wcel cA vw cv eftcl efcltlem1.2 vw cv nnnn0 sylancr vw cv c1 caddc co
        cc wcel vw cv c1 caddc co cc0 wne cA vw cv c1 caddc co cdiv co cc wcel
        vw cv cn wcel cA cc wcel vw cv c1 caddc co cc wcel vw cv c1 caddc co
        cc0 wne cA vw cv c1 caddc co cdiv co cc wcel efcltlem1.2 cA vw cv c1
        caddc co divcl mp3an1 vw cv cn wcel vw cv c1 caddc co cn wcel vw cv c1
        caddc co cc wcel vw cv peano2nn vw cv c1 caddc co nncn syl vw cv cn
        wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cc0 wne vw cv peano2nn
        vw cv c1 caddc co nnne0 syl sylanc sylanc 3eqtrd fveq2d cA vw cv c1
        caddc co cdiv co cc wcel cA vw cv cexp co vw cv cfa cfv cdiv co cc wcel
        cA vw cv c1 caddc co cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co
        cmul co cabs cfv cA vw cv c1 caddc co cdiv co cabs cfv cA vw cv cexp co
        vw cv cfa cfv cdiv co cabs cfv cmul co wceq vw cv cn wcel cA vw cv c1
        caddc co cdiv co cA vw cv cexp co vw cv cfa cfv cdiv co absmul vw cv c1
        caddc co cc wcel vw cv c1 caddc co cc0 wne cA vw cv c1 caddc co cdiv co
        cc wcel vw cv cn wcel cA cc wcel vw cv c1 caddc co cc wcel vw cv c1
        caddc co cc0 wne cA vw cv c1 caddc co cdiv co cc wcel efcltlem1.2 cA vw
        cv c1 caddc co divcl mp3an1 vw cv cn wcel vw cv c1 caddc co cn wcel vw
        cv c1 caddc co cc wcel vw cv peano2nn vw cv c1 caddc co nncn syl vw cv
        cn wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cc0 wne vw cv
        peano2nn vw cv c1 caddc co nnne0 syl sylanc cA cc wcel vw cv cn0 wcel
        cA vw cv cexp co vw cv cfa cfv cdiv co cc wcel vw cv cn wcel cA vw cv
        eftcl efcltlem1.2 vw cv nnnn0 sylancr sylanc vw cv cn wcel cA vw cv c1
        caddc co cdiv co cabs cfv cA cabs cfv vw cv c1 caddc co cabs cfv cdiv
        co cA vw cv cexp co vw cv cfa cfv cdiv co cabs cfv cmul vw cv c1 caddc
        co cc wcel vw cv c1 caddc co cc0 wne cA vw cv c1 caddc co cdiv co cabs
        cfv cA cabs cfv vw cv c1 caddc co cabs cfv cdiv co wceq vw cv cn wcel
        cA cc wcel vw cv c1 caddc co cc wcel vw cv c1 caddc co cc0 wne cA vw cv
        c1 caddc co cdiv co cabs cfv cA cabs cfv vw cv c1 caddc co cabs cfv
        cdiv co wceq efcltlem1.2 cA vw cv c1 caddc co absdiv mp3an1 vw cv cn
        wcel vw cv c1 caddc co cn wcel vw cv c1 caddc co cc wcel vw cv peano2nn
        vw cv c1 caddc co nncn syl vw cv cn wcel vw cv c1 caddc co cn wcel vw
        cv c1 caddc co cc0 wne vw cv peano2nn vw cv c1 caddc co nnne0 syl
        sylanc opreq1d 3eqtrd vw cv cn wcel vw cv cF cfv cabs cfv cA vw cv cexp
        co vw cv cfa cfv cdiv co cabs cfv cA cabs cfv cA cabs cfv cfl cfv c1
        caddc co cdiv co cmul vw cv cn wcel vw cv cF cfv cA vw cv cexp co vw cv
        cfa cfv cdiv co cabs vy vz vw cv cA vy cv cexp co vy cv cfa cfv cdiv co
        cA vw cv cexp co vw cv cfa cfv cdiv co cn cF vy cv vw cv wceq cA vy cv
        cexp co cA vw cv cexp co vy cv cfa cfv vw cv cfa cfv cdiv vy cv vw cv
        cA cexp opreq2 vy cv vw cv cfa fveq2 opreq12d efcltlem.1 cA vw cv cexp
        co vw cv cfa cfv cdiv oprex fvopab4 fveq2d opreq2d breq12d bitr4d
        3bitr3d bitrd biimpd rgen pm3.2i vw vx cA cabs cfv cA cabs cfv cfl cfv
        c1 caddc co cdiv co cA cabs cfv cfl cfv c1 caddc co cF vy vz cn cc cA
        vy cv cexp co vy cv cfa cfv cdiv co cF efcltlem.1 cA cc wcel vy cv cn0
        wcel cA vy cv cexp co vy cv cfa cfv cdiv co cc wcel vy cv cn wcel cA vy
        cv eftcl efcltlem1.2 vy cv nnnn0 sylancr fopab cvgrati mp2an $.
        $( [26-Jun-2006] $) $( [26-Apr-2005] $)
    $}

    $( Lemma for ~ efcl .  The series defining the exponential function
       converges in the (trivial) case of a zero argument. $)
    efcltlem2 $p |- ( A = 0 -> ( + seq1 F ) ~~> 0 ) $=
      cA cc0 wceq caddc cF cseq1 co caddc cn cc0 csn cxp cseq1 co cc0 cli cA
      cc0 wceq cF cn cc0 csn cxp caddc cseq1 cA cc0 wceq vy cv cn wcel vz cv cA
      vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab vy cv cn wcel vz
      cv cc0 wceq wa vy vz copab cF cn cc0 csn cxp cA cc0 wceq vy cv cn wcel vz
      cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy cv cn wcel vz cv cc0
      wceq wa vy vz cA cc0 wceq vy cv cn wcel vz cv cA vy cv cexp co vy cv cfa
      cfv cdiv co wceq vz cv cc0 wceq cA cc0 wceq vy cv cn wcel cA vy cv cexp
      co vy cv cfa cfv cdiv co cc0 wceq vz cv cA vy cv cexp co vy cv cfa cfv
      cdiv co wceq vz cv cc0 wceq wb cA cc0 wceq cA vy cv cexp co vy cv cfa cfv
      cdiv co cc0 wceq cc0 vy cv cexp co vy cv cfa cfv cdiv co cc0 wceq vy cv
      cn wcel cA cc0 wceq cA vy cv cexp co vy cv cfa cfv cdiv co cc0 vy cv cexp
      co vy cv cfa cfv cdiv co cc0 cA cc0 wceq cA vy cv cexp co cc0 vy cv cexp
      co vy cv cfa cfv cdiv cA cc0 vy cv cexp opreq1 opreq1d eqeq1d vy cv cn
      wcel cc0 vy cv cexp co vy cv cfa cfv cdiv co cc0 vy cv cfa cfv cdiv co
      cc0 vy cv cn wcel cc0 vy cv cexp co cc0 vy cv cfa cfv cdiv vy cv 0exp
      opreq1d vy cv cn wcel vy cv cn0 wcel cc0 vy cv cfa cfv cdiv co cc0 wceq
      vy cv nnnn0 vy cv cfa cfv cc wcel vy cv cfa cfv cc0 wne cc0 vy cv cfa cfv
      cdiv co cc0 wceq vy cv cn0 wcel vy cv cfa cfv div0 vy cv cn0 wcel vy cv
      cfa cfv cn wcel vy cv cfa cfv cc wcel vy cv faccl vy cv cfa cfv nncn syl
      vy cv facne0 sylanc syl eqtrd syl5bir cA vy cv cexp co vy cv cfa cfv cdiv
      co cc0 vz cv eqeq2 syl6 pm5.32d opabbidv efcltlem.1 vy vz cn cc0
      fconstopab 3eqtr4g opreq2d ser1clim0 syl6eqbr $.
      $( [26-Jun-2006] $) $( [28-Apr-2005] $)

    $( The series defining the exponential function converges. $)
    efseq1ex $p |- ( A e. CC -> E. x ( + seq1 F ) ~~> x ) $=
      cA cc wcel cA cc0 wceq caddc cF cseq1 co vx cv cli wbr vx wex cA cc wcel
      cA cc0 wne caddc cF cseq1 co vx cv cli wbr vx wex cA cc0 wceq wn cA cc
      wcel cA cc0 wne caddc cF cseq1 co vx cv cli wbr vx wex cA cc wcel cA cc0
      wne wa caddc vy cv cn wcel vz cv cA vy cv cexp co vy cv cfa cfv cdiv co
      wceq wa vy vz copab cseq1 co vx cv cli wbr vx wex caddc cF cseq1 co vx cv
      cli wbr vx wex cA cc wcel cA cc0 wne wa caddc vy cv cn wcel vz cv cA vy
      cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab cseq1 co vx cv cli
      wbr vx wex caddc vy cv cn wcel vz cv cA cc wcel cA cc0 wne wa cA c1 cif
      vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab cseq1 co vx cv
      cli wbr vx wex cA c1 cA cA cc wcel cA cc0 wne wa cA c1 cif wceq caddc vy
      cv cn wcel vz cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz
      copab cseq1 co vx cv cli wbr caddc vy cv cn wcel vz cv cA cc wcel cA cc0
      wne wa cA c1 cif vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab
      cseq1 co vx cv cli wbr vx cA cA cc wcel cA cc0 wne wa cA c1 cif wceq
      caddc vy cv cn wcel vz cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq wa
      vy vz copab cseq1 co caddc vy cv cn wcel vz cv cA cc wcel cA cc0 wne wa
      cA c1 cif vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab cseq1
      co vx cv cli cA cA cc wcel cA cc0 wne wa cA c1 cif wceq vy cv cn wcel vz
      cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab vy cv cn
      wcel vz cv cA cc wcel cA cc0 wne wa cA c1 cif vy cv cexp co vy cv cfa cfv
      cdiv co wceq wa vy vz copab caddc cseq1 cA cA cc wcel cA cc0 wne wa cA c1
      cif wceq vy cv cn wcel vz cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq
      wa vy cv cn wcel vz cv cA cc wcel cA cc0 wne wa cA c1 cif vy cv cexp co
      vy cv cfa cfv cdiv co wceq wa vy vz cA cA cc wcel cA cc0 wne wa cA c1 cif
      wceq vz cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq vz cv cA cc wcel
      cA cc0 wne wa cA c1 cif vy cv cexp co vy cv cfa cfv cdiv co wceq vy cv cn
      wcel cA cA cc wcel cA cc0 wne wa cA c1 cif wceq cA vy cv cexp co vy cv
      cfa cfv cdiv co cA cc wcel cA cc0 wne wa cA c1 cif vy cv cexp co vy cv
      cfa cfv cdiv co vz cv cA cA cc wcel cA cc0 wne wa cA c1 cif wceq cA vy cv
      cexp co cA cc wcel cA cc0 wne wa cA c1 cif vy cv cexp co vy cv cfa cfv
      cdiv cA cA cc wcel cA cc0 wne wa cA c1 cif vy cv cexp opreq1 opreq1d
      eqeq2d anbi2d opabbidv opreq2d breq1d exbidv vx vy vz cA cc wcel cA cc0
      wne wa cA c1 cif vy cv cn wcel vz cv cA cc wcel cA cc0 wne wa cA c1 cif
      vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab vy cv cn wcel vz
      cv cA cc wcel cA cc0 wne wa cA c1 cif vy cv cexp co vy cv cfa cfv cdiv co
      wceq wa vy vz copab eqid cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA cc
      wcel cA cc0 wne wa cA c1 cif cc0 wne cA cc wcel cA cc0 wne wa cA cc wcel
      cA cc0 wne wa cA c1 cif cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc0
      wne wa c1 cc wcel c1 cc0 wne wa cA c1 cA cA cc wcel cA cc0 wne wa cA c1
      cif wceq cA cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA cc0 wne
      cA cc wcel cA cc0 wne wa cA c1 cif cc0 wne cA cA cc wcel cA cc0 wne wa cA
      c1 cif cc eleq1 cA cA cc wcel cA cc0 wne wa cA c1 cif cc0 neeq1 anbi12d
      c1 cA cc wcel cA cc0 wne wa cA c1 cif wceq c1 cc wcel cA cc wcel cA cc0
      wne wa cA c1 cif cc wcel c1 cc0 wne cA cc wcel cA cc0 wne wa cA c1 cif
      cc0 wne c1 cA cc wcel cA cc0 wne wa cA c1 cif cc eleq1 c1 cA cc wcel cA
      cc0 wne wa cA c1 cif cc0 neeq1 anbi12d c1 cc wcel c1 cc0 wne ax1cn ax1ne0
      pm3.2i elimhyp pm3.26i cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA cc
      wcel cA cc0 wne wa cA c1 cif cc0 wne cA cc wcel cA cc0 wne wa cA cc wcel
      cA cc0 wne wa cA c1 cif cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc0
      wne wa c1 cc wcel c1 cc0 wne wa cA c1 cA cA cc wcel cA cc0 wne wa cA c1
      cif wceq cA cc wcel cA cc wcel cA cc0 wne wa cA c1 cif cc wcel cA cc0 wne
      cA cc wcel cA cc0 wne wa cA c1 cif cc0 wne cA cA cc wcel cA cc0 wne wa cA
      c1 cif cc eleq1 cA cA cc wcel cA cc0 wne wa cA c1 cif cc0 neeq1 anbi12d
      c1 cA cc wcel cA cc0 wne wa cA c1 cif wceq c1 cc wcel cA cc wcel cA cc0
      wne wa cA c1 cif cc wcel c1 cc0 wne cA cc wcel cA cc0 wne wa cA c1 cif
      cc0 wne c1 cA cc wcel cA cc0 wne wa cA c1 cif cc eleq1 c1 cA cc wcel cA
      cc0 wne wa cA c1 cif cc0 neeq1 anbi12d c1 cc wcel c1 cc0 wne ax1cn ax1ne0
      pm3.2i elimhyp pm3.27i efcltlem1 dedth caddc cF cseq1 co vx cv cli wbr
      caddc vy cv cn wcel vz cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq wa
      vy vz copab cseq1 co vx cv cli wbr vx caddc cF cseq1 co caddc vy cv cn
      wcel vz cv cA vy cv cexp co vy cv cfa cfv cdiv co wceq wa vy vz copab
      cseq1 co vx cv cli cF vy cv cn wcel vz cv cA vy cv cexp co vy cv cfa cfv
      cdiv co wceq wa vy vz copab caddc cseq1 efcltlem.1 opreq2i breq1i exbii
      sylibr ex cA cc0 df-ne syl5ibr cA cc0 wceq caddc cF cseq1 co cc0 cli wbr
      caddc cF cseq1 co vx cv cli wbr vx wex vy vz cA cF efcltlem.1 efcltlem2
      caddc cF cseq1 co vx cv cli wbr caddc cF cseq1 co cc0 cli wbr vx cc0 cc0
      cc 0cn elisseti vx cv cc0 caddc cF cseq1 co cli breq2 cla4ev syl pm2.61d2
      $.
      $( [26-Jun-2006] $) $( [27-Apr-2005] $)
  $}

  ${
    $d j k x y A $.
    dfef2.1 $e |- A e. CC $.
    $( Switch between definitions for ~ df-ef that sum over ` NN0 ` or over
       ` NN ` .  (Contributed by Steve Rodriguez, 30-Jun-2006.) $)
    dfef2i $p |- sum_ k e. NN0 ( ( A ^ k ) / ( !  ` k ) ) =
    ( 1 + sum_ k e. NN ( { <. j , y >. | ( j e. NN /\ y = ( ( A ^ j ) / ( !
    ` j ) ) ) } ` k ) ) $=
      cn0 vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cfv vk csu cc0 vj cv cn0 wcel vy cv cA vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cn vk cv vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu
      caddc co cn0 cA vk cv cexp co vk cv cfa cfv cdiv co vk csu c1 cn vk cv vj
      cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cfv vk csu caddc co vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj
      cv cfa cfv cdiv co wceq wa vj vy copab cfv cc wcel vk cn0 wral caddc vj
      cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cseq1 co vx cv cli wbr vx wex cn0 vk cv vj cv cn0 wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cc0 vj cv
      cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cfv cn vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cfv vk csu caddc co wceq vk cv vj cv cn0 wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cc wcel vk
      cn0 vk cv cn0 wcel vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cfv cA vk cv cexp co vk cv cfa cfv cdiv
      co cc vj vy vk cv cA vj cv cexp co vj cv cfa cfv cdiv co cA vk cv cexp co
      vk cv cfa cfv cdiv co cn0 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab vj cv vk cv wceq cA vj cv cexp co cA vk
      cv cexp co vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv cA cexp opreq2 vj
      cv vk cv cfa fveq2 opreq12d vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab eqid cA vk cv cexp co vk cv cfa cfv
      cdiv oprex fvopab4 cA cc wcel vk cv cn0 wcel cA vk cv cexp co vk cv cfa
      cfv cdiv co cc wcel dfef2.1 cA vk cv eftcl mpan eqeltrd rgen caddc vj cv
      cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cseq1 co vx cv cli wbr vx wex caddc vj cv cn0 wcel vy cv cA vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab cseq1 co vx cv cli wbr vx wex
      cA cc wcel caddc vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab cseq1 co vx cv cli wbr vx wex dfef2.1 vx vj vy cA
      vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab eqid efseq1ex ax-mp caddc vj cv cn wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq1 co vx cv cli wbr caddc
      vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cseq1 co vx cv cli wbr vx caddc vj cv cn wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq1 co caddc vj cv cn0
      wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cseq1 co vx cv cli caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cn cres cseq1 co caddc vj cv cn wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq1 co
      caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab cseq1 co vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cn cres vj cv cn wcel vy cv cA vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab caddc cseq1 vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn
      wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cdm
      cres vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab cn cres vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab vj cv cn wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab cdm cn wceq vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cdm cres vj
      cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cn cres wceq vj vy cn cA vj cv cexp co vj cv cfa cfv cdiv co vj cv
      cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cA vj cv cexp co vj cv cfa cfv cdiv oprex vj cv cn wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid dmopab2 vj cv cn
      wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cdm
      cn vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj
      vy copab reseq2 ax-mp vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab wfun vj cv cn wcel vy cv cA vj cv cexp co vj
      cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab wss vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cdm cres vj
      cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab wceq cn0 cc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab wf vj cv cn0 wcel vy cv cA vj cv cexp co vj
      cv cfa cfv cdiv co wceq wa vj vy copab wfun vj vy cn0 cc cA vj cv cexp co
      vj cv cfa cfv cdiv co vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab eqid cA cc wcel vj cv cn0 wcel cA vj
      cv cexp co vj cv cfa cfv cdiv co cc wcel dfef2.1 cA vj cv eftcl mpan
      fopab cn0 cc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab ffun ax-mp vj cv cn wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy vj cv cn wcel vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq vj cv nnnn0 anim1i ssopab2i vj cv cn0
      wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj
      cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab funssres mp2an eqtr3i opreq2i caddc vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab addex vj vy cn0 cA vj
      cv cexp co vj cv cfa cfv cdiv co nn0ex opabex2 seq1res eqtr3i breq1i
      exbii mpbi vx vk vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co
      nn0ex opabex2 isumnn0nn mp2an cn0 vk cv vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA vk cv cexp co vk
      cv cfa cfv cdiv co vk vj vy vk cv cA vj cv cexp co vj cv cfa cfv cdiv co
      cA vk cv cexp co vk cv cfa cfv cdiv co cn0 vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv vk cv wceq cA vj
      cv cexp co cA vk cv cexp co vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv
      cA cexp opreq2 vj cv vk cv cfa fveq2 opreq12d vj cv cn0 wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid cA vk cv cexp
      co vk cv cfa cfv cdiv oprex fvopab4 sumeq2i cc0 vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv c1 cn vk cv
      vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cfv vk csu cn vk cv vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cfv vk csu caddc cc0 cn0 wcel cc0 vj cv
      cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cfv c1 wceq 0nn0 vj vy cc0 cA vj cv cexp co vj cv cfa cfv cdiv co c1 cn0
      vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab vj cv cc0 wceq cA vj cv cexp co vj cv cfa cfv cdiv co c1 c1 cdiv co
      c1 vj cv cc0 wceq cA vj cv cexp co c1 vj cv cfa cfv c1 cdiv vj cv cc0
      wceq cA vj cv cexp co cA cc0 cexp co c1 vj cv cc0 cA cexp opreq2 cA cc
      wcel cA cc0 cexp co c1 wceq dfef2.1 cA exp0 ax-mp syl6eq vj cv cc0 wceq
      vj cv cfa cfv cc0 cfa cfv c1 vj cv cc0 cfa fveq2 fac0 syl6eq opreq12d c1
      ax1cn div1i syl6eq vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab eqid c1 cc ax1cn elisseti fvopab4 ax-mp cn vk
      cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj
      vy copab cfv vk cv vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cfv vk vk cv cn wcel vk cv vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA vk
      cv cexp co vk cv cfa cfv cdiv co vk cv vj cv cn wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk cv cn wcel vk cv cn0
      wcel vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cfv cA vk cv cexp co vk cv cfa cfv cdiv co wceq vk cv
      nnnn0 vj vy vk cv cA vj cv cexp co vj cv cfa cfv cdiv co cA vk cv cexp co
      vk cv cfa cfv cdiv co cn0 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab vj cv vk cv wceq cA vj cv cexp co cA vk
      cv cexp co vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv cA cexp opreq2 vj
      cv vk cv cfa fveq2 opreq12d vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab eqid cA vk cv cexp co vk cv cfa cfv
      cdiv oprex fvopab4 syl vj vy vk cv cA vj cv cexp co vj cv cfa cfv cdiv co
      cA vk cv cexp co vk cv cfa cfv cdiv co cn vj cv cn wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv vk cv wceq cA vj
      cv cexp co cA vk cv cexp co vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv
      cA cexp opreq2 vj cv vk cv cfa fveq2 opreq12d vj cv cn wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid cA vk cv cexp
      co vk cv cfa cfv cdiv oprex fvopab4 eqtr4d sumeq2i opreq12i 3eqtr3i $.
      $( [1-Jul-2006] $) $( [30-Jun-2006] $)
  $}

  ${
    $d x y k A $.
    $( Value of the exponential function. $)
    efval $p |- ( A e. CC ->
                 ( exp ` A ) = sum_ k e. NN0 ( ( A ^ k ) / ( ! ` k ) ) ) $=
      vx vy cA cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu cn0 cA vk
      cv cexp co vk cv cfa cfv cdiv co vk csu cc ce vx cv cA wceq cn0 vx cv vk
      cv cexp co vk cv cfa cfv cdiv co cA vk cv cexp co vk cv cfa cfv cdiv co
      vk vx cv cA wceq vx cv vk cv cexp co cA vk cv cexp co vk cv cfa cfv cdiv
      vx cv cA vk cv cexp opreq1 opreq1d sumeq2sdv vx vy vk df-ef cn0 cA vk cv
      cexp co vk cv cfa cfv cdiv co vk sumex fvopab4 $.
      $( [12-Jan-2006] $) $( [8-Jan-2006] $)
  $}

  $( Value of Euler's constant ` _e ` = 2.71828...  (Contributed by Steve
     Rodriguez, 5-Mar-2006.) $)
  eval $p |- _e = sum_ k e. NN0 ( 1 / ( ! ` k ) ) $=
    ceu c1 ce cfv cn0 c1 vk cv cexp co vk cv cfa cfv cdiv co vk csu cn0 c1 vk
    cv cfa cfv cdiv co vk csu df-e c1 cc wcel c1 ce cfv cn0 c1 vk cv cexp co vk
    cv cfa cfv cdiv co vk csu wceq ax1cn c1 vk efval ax-mp cn0 c1 vk cv cexp co
    vk cv cfa cfv cdiv co c1 vk cv cfa cfv cdiv co vk vk cv cn0 wcel c1 vk cv
    cexp co c1 vk cv cfa cfv cdiv vk cv 1exp opreq1d sumeq2i 3eqtri $.
    $( [29-Jan-2007] $) $( [5-Mar-2006] $)

  ${
    $d j k m w x y A $.  $d k m w x F $.
    ef0lem.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                    y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    $( The series defining the exponential function converges in the (trivial)
       case of a zero argument. $)
    ef0lem $p |- ( A = 0 -> ( + seq0 F ) ~~> 1 ) $=
      c1 cc wcel vm cv caddc cF cseq0 co cfv c1 wceq vm cc0 cuz cfv wral caddc
      cF cseq0 co c1 cli wbr cA cc0 wceq c1 vm caddc cF cseq0 co cc0 caddc cF
      cseq0 oprex 0z climconsti ax1cn cA cc0 wceq vm cv caddc cF cseq0 co cfv
      c1 wceq vm cc0 cuz cfv cA cc0 wceq vm cv cn0 wcel vm cv caddc cF cseq0 co
      cfv c1 wceq vm cv cc0 cuz cfv wcel vm cv cn0 wcel cA cc0 wceq vm cv caddc
      cF cseq0 co cfv c1 wceq cA cc0 wceq vk cv caddc cF cseq0 co cfv c1 wceq
      wi cA cc0 wceq cc0 caddc cF cseq0 co cfv c1 wceq wi cA cc0 wceq vm cv
      caddc cF cseq0 co cfv c1 wceq wi cA cc0 wceq vm cv c1 caddc co caddc cF
      cseq0 co cfv c1 wceq wi cA cc0 wceq vm cv caddc cF cseq0 co cfv c1 wceq
      wi vk vm vm cv vm cv cn0 wcel cA cc0 wceq vm cv caddc cF cseq0 co cfv c1
      wceq vm cv c1 caddc co caddc cF cseq0 co cfv c1 wceq vm cv cn0 wcel cA
      cc0 wceq vm cv caddc cF cseq0 co cfv c1 wceq vm cv c1 caddc co caddc cF
      cseq0 co cfv c1 wceq vm cv cn0 wcel cA cc0 wceq wa vm cv caddc cF cseq0
      co cfv c1 wceq wa vm cv c1 caddc co caddc cF cseq0 co cfv vm cv caddc cF
      cseq0 co cfv cA vm cv c1 caddc co cexp co vm cv c1 caddc co cfa cfv cdiv
      co caddc co c1 vm cv cn0 wcel vm cv c1 caddc co caddc cF cseq0 co cfv vm
      cv caddc cF cseq0 co cfv cA vm cv c1 caddc co cexp co vm cv c1 caddc co
      cfa cfv cdiv co caddc co wceq cA cc0 wceq vm cv caddc cF cseq0 co cfv c1
      wceq vy cA vj cv cexp co vj cv cfa cfv cdiv co cA vm cv c1 caddc co cexp
      co vm cv c1 caddc co cfa cfv cdiv co vj cF vm cv ef0lem.1 cA vm cv c1
      caddc co cexp co vm cv c1 caddc co cfa cfv cdiv oprex vj cv vm cv c1
      caddc co wceq cA vj cv cexp co cA vm cv c1 caddc co cexp co vj cv cfa cfv
      vm cv c1 caddc co cfa cfv cdiv vj cv vm cv c1 caddc co cA cexp opreq2 vj
      cv vm cv c1 caddc co cfa fveq2 opreq12d ser0p1i ad2antrr vm cv caddc cF
      cseq0 co cfv c1 wceq vm cv cn0 wcel cA cc0 wceq wa vm cv caddc cF cseq0
      co cfv cA vm cv c1 caddc co cexp co vm cv c1 caddc co cfa cfv cdiv co
      caddc co c1 cA vm cv c1 caddc co cexp co vm cv c1 caddc co cfa cfv cdiv
      co caddc co c1 vm cv caddc cF cseq0 co cfv c1 cA vm cv c1 caddc co cexp
      co vm cv c1 caddc co cfa cfv cdiv co caddc opreq1 vm cv cn0 wcel cA cc0
      wceq wa c1 cA vm cv c1 caddc co cexp co vm cv c1 caddc co cfa cfv cdiv co
      caddc co c1 cc0 caddc co c1 vm cv cn0 wcel cA cc0 wceq wa cA vm cv c1
      caddc co cexp co vm cv c1 caddc co cfa cfv cdiv co cc0 c1 caddc vm cv cn0
      wcel cA cc0 wceq wa cA vm cv c1 caddc co cexp co vm cv c1 caddc co cfa
      cfv cdiv co cc0 vm cv c1 caddc co cfa cfv cdiv co cc0 vm cv cn0 wcel cA
      cc0 wceq wa cA vm cv c1 caddc co cexp co cc0 vm cv c1 caddc co cfa cfv
      cdiv cA cc0 wceq vm cv cn0 wcel cA vm cv c1 caddc co cexp co cc0 vm cv c1
      caddc co cexp co cc0 cA cc0 vm cv c1 caddc co cexp opreq1 vm cv cn0 wcel
      vm cv c1 caddc co cn wcel cc0 vm cv c1 caddc co cexp co cc0 wceq vm cv
      nn0p1nn vm cv c1 caddc co 0exp syl sylan9eqr opreq1d vm cv cn0 wcel cc0
      vm cv c1 caddc co cfa cfv cdiv co cc0 wceq cA cc0 wceq vm cv c1 caddc co
      cfa cfv cc wcel vm cv c1 caddc co cfa cfv cc0 wne cc0 vm cv c1 caddc co
      cfa cfv cdiv co cc0 wceq vm cv cn0 wcel vm cv c1 caddc co cfa cfv div0 vm
      cv cn0 wcel vm cv c1 caddc co cn0 wcel vm cv c1 caddc co cfa cfv cc wcel
      vm cv peano2nn0 vm cv c1 caddc co cn0 wcel vm cv c1 caddc co cfa cfv cn
      wcel vm cv c1 caddc co cfa cfv cc wcel vm cv c1 caddc co faccl vm cv c1
      caddc co cfa cfv nncn syl syl vm cv cn0 wcel vm cv c1 caddc co cn0 wcel
      vm cv c1 caddc co cfa cfv cc0 wne vm cv peano2nn0 vm cv c1 caddc co
      facne0 syl sylanc adantr eqtrd opreq2d c1 ax1cn addid1i syl6eq sylan9eqr
      eqtrd exp31 a2d cA cc0 wceq cc0 caddc cF cseq0 co cfv cc0 cF cfv cA cc0
      cexp co cc0 cfa cfv cdiv co c1 cc0 caddc cF cseq0 co cfv cc0 cF cfv wceq
      cA cc0 wceq caddc cF addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv
      co cF nn0ex ef0lem.1 fopabex2 seq00 a1i cA cc0 wceq cc0 cn0 wcel cc0 cF
      cfv cA cc0 cexp co cc0 cfa cfv cdiv co wceq cc0 cn0 wcel cA cc0 wceq 0nn0
      a1i vj vy cc0 cA vj cv cexp co vj cv cfa cfv cdiv co cA cc0 cexp co cc0
      cfa cfv cdiv co cn0 cF vj cv cc0 wceq cA vj cv cexp co cA cc0 cexp co vj
      cv cfa cfv cc0 cfa cfv cdiv vj cv cc0 cA cexp opreq2 vj cv cc0 cfa fveq2
      opreq12d ef0lem.1 cA cc0 cexp co cc0 cfa cfv cdiv oprex fvopab4 syl cA
      cc0 wceq cA cc0 cexp co cc0 cfa cfv cdiv co c1 cc0 cfa cfv cdiv co c1 cA
      cc0 wceq cA cc0 cexp co c1 cc0 cfa cfv cdiv cA cc0 wceq cA cc0 cexp co
      cc0 cc0 cexp co c1 cA cc0 cc0 cexp opreq1 cc0 cc wcel cc0 cc0 cexp co c1
      wceq 0cn cc0 exp0 ax-mp syl6eq opreq1d c1 cc0 cfa cfv cdiv co c1 c1 cdiv
      co c1 cc0 cfa cfv c1 c1 cdiv fac0 opreq2i c1 ax1cn div1i eqtri syl6eq
      3eqtrd vk cv cc0 wceq vk cv caddc cF cseq0 co cfv c1 wceq cc0 caddc cF
      cseq0 co cfv c1 wceq cA cc0 wceq vk cv cc0 wceq vk cv caddc cF cseq0 co
      cfv cc0 caddc cF cseq0 co cfv c1 vk cv cc0 caddc cF cseq0 co fveq2 eqeq1d
      imbi2d vk cv vm cv wceq vk cv caddc cF cseq0 co cfv c1 wceq vm cv caddc
      cF cseq0 co cfv c1 wceq cA cc0 wceq vk cv vm cv wceq vk cv caddc cF cseq0
      co cfv vm cv caddc cF cseq0 co cfv c1 vk cv vm cv caddc cF cseq0 co fveq2
      eqeq1d imbi2d vk cv vm cv c1 caddc co wceq vk cv caddc cF cseq0 co cfv c1
      wceq vm cv c1 caddc co caddc cF cseq0 co cfv c1 wceq cA cc0 wceq vk cv vm
      cv c1 caddc co wceq vk cv caddc cF cseq0 co cfv vm cv c1 caddc co caddc
      cF cseq0 co cfv c1 vk cv vm cv c1 caddc co caddc cF cseq0 co fveq2 eqeq1d
      imbi2d vk cv vm cv wceq vk cv caddc cF cseq0 co cfv c1 wceq vm cv caddc
      cF cseq0 co cfv c1 wceq cA cc0 wceq vk cv vm cv wceq vk cv caddc cF cseq0
      co cfv vm cv caddc cF cseq0 co cfv c1 vk cv vm cv caddc cF cseq0 co fveq2
      eqeq1d imbi2d nn0indALT impcom vm cv elnn0uz sylan2br r19.21aiva sylancr
      $.
      $( [27-Jun-2006] $) $( [7-Jun-2006] $)

    $( The series defining the exponential function converges. $)
    efseq0ex $p |- ( A e. CC -> E. x ( + seq0 F ) ~~> x ) $=
      cA cc wcel caddc cF cseq1 co vw cv cli wbr vw wex caddc cF cseq0 co vx cv
      cli wbr vx wex cA cc wcel caddc cF cn cres cseq1 co vw cv cli wbr vw wex
      caddc cF cseq1 co vw cv cli wbr vw wex vw vj vy cA cF cn cres cF cn cres
      vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cn cres vj cv cn wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cF vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab wceq cF cn cres vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cn cres wceq
      ef0lem.1 cF vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cn reseq1 ax-mp cn cn0 wss vj cv cn0 wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cn cres vj cv cn
      wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      wceq nnssnn0 vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq vj vy cn
      cn0 resopab2 ax-mp eqtri efseq1ex caddc cF cn cres cseq1 co vw cv cli wbr
      caddc cF cseq1 co vw cv cli wbr vw caddc cF cn cres cseq1 co caddc cF
      cseq1 co vw cv cli caddc cF addex vj vy cn0 cA vj cv cexp co vj cv cfa
      cfv cdiv co cF nn0ex ef0lem.1 fopabex2 seq1res breq1i exbii sylib cA cc
      wcel caddc cF cseq1 co vw cv cli wbr caddc cF cseq0 co vx cv cli wbr vx
      wex vw cA cc wcel caddc cF cseq1 co vw cv cli wbr caddc cF cseq0 co cc0
      cF cfv vw cv caddc co cli wbr caddc cF cseq0 co vx cv cli wbr vx wex cA
      cc wcel c1 caddc cop cF cseqz co vw cv cli wbr cc0 caddc cop cF cseqz co
      cc0 cF cfv vw cv caddc co cli wbr caddc cF cseq1 co vw cv cli wbr caddc
      cF cseq0 co cc0 cF cfv vw cv caddc co cli wbr cA cc wcel c1 caddc cop cF
      cseqz co vw cv cli wbr cc0 caddc cop cF cseqz co cc0 cF cfv vw cv caddc
      co cli wbr c1 caddc cop cF cseqz co vw cv cli wbr cc0 cF cfv cc wcel wa
      c1 cz wcel vk cv c1 caddc cop cF cseqz co cfv cc wcel vk cv cc0 caddc cop
      cF cseqz co cfv cc0 cF cfv vk cv c1 caddc cop cF cseqz co cfv caddc co
      wceq wa vk c1 cuz cfv wral wa cc0 caddc cop cF cseqz co cc0 cF cfv vw cv
      caddc co cli wbr cA cc wcel c1 caddc cop cF cseqz co vw cv cli wbr wa vw
      cv cc0 cF cfv vk c1 caddc cop cF cseqz co cc0 caddc cop cF cseqz co c1 c1
      caddc cop cF cseqz oprex cc0 caddc cop cF cseqz oprex vw visset cc0 cF
      fvex climaddc2 cA cc wcel c1 caddc cop cF cseqz co vw cv cli wbr wa c1
      caddc cop cF cseqz co vw cv cli wbr cc0 cF cfv cc wcel cA cc wcel c1
      caddc cop cF cseqz co vw cv cli wbr pm3.27 cA cc wcel cc0 cF cfv cc wcel
      c1 caddc cop cF cseqz co vw cv cli wbr cn0 cc cF wf cc0 cn0 wcel cc0 cF
      cfv cc wcel cA cc wcel cn0 cc cc0 cF ffvelrn cA cc wcel cA vj cv cexp co
      vj cv cfa cfv cdiv co cc wcel vj cn0 wral cn0 cc cF wf cA cc wcel cA vj
      cv cexp co vj cv cfa cfv cdiv co cc wcel vj cn0 cA vj cv eftcl r19.21aiva
      vj vy cn0 cc cA vj cv cexp co vj cv cfa cfv cdiv co cF ef0lem.1 fopab2
      sylib 0nn0 sylancl adantr jca cA cc wcel c1 caddc cop cF cseqz co vw cv
      cli wbr wa vk cv c1 caddc cop cF cseqz co cfv cc wcel vk cv cc0 caddc cop
      cF cseqz co cfv cc0 cF cfv vk cv c1 caddc cop cF cseqz co cfv caddc co
      wceq wa vk c1 cuz cfv wral c1 cz wcel cA cc wcel vk cv c1 caddc cop cF
      cseqz co cfv cc wcel vk cv cc0 caddc cop cF cseqz co cfv cc0 cF cfv vk cv
      c1 caddc cop cF cseqz co cfv caddc co wceq wa vk c1 cuz cfv wral c1 caddc
      cop cF cseqz co vw cv cli wbr cA cc wcel vk cv c1 caddc cop cF cseqz co
      cfv cc wcel vk cv cc0 caddc cop cF cseqz co cfv cc0 cF cfv vk cv c1 caddc
      cop cF cseqz co cfv caddc co wceq wa vk c1 cuz cfv cA cc wcel vk cv c1
      cuz cfv wcel wa vk cv c1 caddc cop cF cseqz co cfv cc wcel vk cv cc0
      caddc cop cF cseqz co cfv cc0 cF cfv vk cv c1 caddc cop cF cseqz co cfv
      caddc co wceq vk cv c1 cuz cfv wcel vm cv cF cfv cc wcel vm c1 vk cv cfz
      co wral vk cv c1 caddc cop cF cseqz co cfv cc wcel cA cc wcel vk cv c1
      cuz cfv wcel wa vm cF c1 vk cv vj vy cn0 cA vj cv cexp co vj cv cfa cfv
      cdiv co cF nn0ex ef0lem.1 fopabex2 serzcl cA cc wcel vk cv c1 cuz cfv
      wcel pm3.27 cA cc wcel vm cv cF cfv cc wcel vm c1 vk cv cfz co wral vk cv
      c1 cuz cfv wcel cA cc wcel vm cv cF cfv cc wcel vm c1 vk cv cfz co cn0 cc
      cF wf vm cv cn0 wcel vm cv cF cfv cc wcel cA cc wcel vm cv c1 vk cv cfz
      co wcel cn0 cc vm cv cF ffvelrn cA cc wcel cA vj cv cexp co vj cv cfa cfv
      cdiv co cc wcel vj cn0 wral cn0 cc cF wf cA cc wcel cA vj cv cexp co vj
      cv cfa cfv cdiv co cc wcel vj cn0 cA vj cv eftcl r19.21aiva vj vy cn0 cc
      cA vj cv cexp co vj cv cfa cfv cdiv co cF ef0lem.1 fopab2 sylib vm cv c1
      vk cv cfz co wcel vm cv cn wcel vm cv cn0 wcel vm cv vk cv elfznn vm cv
      nnnn0 syl syl2an r19.21aiva adantr sylanc cA cc wcel vk cv c1 cuz cfv
      wcel wa vk cv cc0 caddc cop cF cseqz co cfv cc0 cF cfv vk cv cc0 c1 caddc
      co caddc cop cF cseqz co cfv caddc co cc0 cF cfv vk cv c1 caddc cop cF
      cseqz co cfv caddc co vk cv cc0 cuz cfv wcel cc0 vk cv clt wbr vm cv cF
      cfv cc wcel vm cc0 vk cv cfz co wral vk cv cc0 caddc cop cF cseqz co cfv
      cc0 cF cfv vk cv cc0 c1 caddc co caddc cop cF cseqz co cfv caddc co wceq
      cA cc wcel vk cv c1 cuz cfv wcel wa vm cF cc0 vk cv vj vy cn0 cA vj cv
      cexp co vj cv cfa cfv cdiv co cF nn0ex ef0lem.1 fopabex2 serz1p vk cv c1
      cuz cfv wcel vk cv cc0 cuz cfv wcel cA cc wcel vk cv cn wcel vk cv cn0
      wcel vk cv c1 cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv nnnn0 vk cv
      elnnuz vk cv elnn0uz 3imtr3i adantl vk cv c1 cuz cfv wcel cc0 vk cv clt
      wbr cA cc wcel vk cv c1 cuz cfv wcel vk cv cn wcel cc0 vk cv clt wbr vk
      cv elnnuz vk cv nngt0 sylbir adantl cA cc wcel vm cv cF cfv cc wcel vm
      cc0 vk cv cfz co wral vk cv c1 cuz cfv wcel cA cc wcel vm cv cF cfv cc
      wcel vm cc0 vk cv cfz co cn0 cc cF wf vm cv cn0 wcel vm cv cF cfv cc wcel
      cA cc wcel vm cv cc0 vk cv cfz co wcel cn0 cc vm cv cF ffvelrn cA cc wcel
      cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj cn0 wral cn0 cc cF wf
      cA cc wcel cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj cn0 cA vj cv
      eftcl r19.21aiva vj vy cn0 cc cA vj cv cexp co vj cv cfa cfv cdiv co cF
      ef0lem.1 fopab2 sylib vm cv vk cv elfznn0 syl2an r19.21aiva adantr
      syl3anc vk cv cc0 c1 caddc co caddc cop cF cseqz co cfv vk cv c1 caddc
      cop cF cseqz co cfv cc0 cF cfv caddc vk cv cc0 c1 caddc co caddc cop cF
      cseqz co c1 caddc cop cF cseqz co cc0 c1 caddc co caddc cop c1 caddc cop
      cF cseqz cc0 c1 caddc co c1 caddc c1 ax1cn addid2i opeq1i opreq1i fveq1i
      opreq2i syl6eq jca r19.21aiva adantr 1z jctil sylanc ex caddc cF cseq1 co
      c1 caddc cop cF cseqz co vw cv cli caddc cF addex vj vy cn0 cA vj cv cexp
      co vj cv cfa cfv cdiv co cF nn0ex ef0lem.1 fopabex2 seq1seqz breq1i caddc
      cF cseq0 co cc0 caddc cop cF cseqz co cc0 cF cfv vw cv caddc co cli caddc
      cF addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex
      ef0lem.1 fopabex2 seq0seqz breq1i 3imtr4g caddc cF cseq0 co vx cv cli wbr
      caddc cF cseq0 co cc0 cF cfv vw cv caddc co cli wbr vx cc0 cF cfv vw cv
      caddc co cc0 cF cfv vw cv caddc oprex vx cv cc0 cF cfv vw cv caddc co
      caddc cF cseq0 co cli breq2 cla4ev syl6 19.23adv mpd $.
      $( [26-Jun-2006] $) $( [9-Jan-2006] $)
  $}

  ${
    $d j k x y A $.
    $( Closure law for the exponential function. $)
    efcl $p |- ( A e. CC -> ( exp ` A ) e. CC ) $=
      cA cc wcel cA ce cfv cn0 cA vk cv cexp co vk cv cfa cfv cdiv co vk csu cc
      cA vk efval cA cc wcel cc0 cuz cfv vk cv vj cv cc0 cuz cfv wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cc cn0
      cA vk cv cexp co vk cv cfa cfv cdiv co vk csu cc0 cz wcel cc0 caddc cop
      vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab cseqz co vx cv cli wbr vx wex cc0 cuz cfv vk cv vj cv cc0
      cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cfv vk csu cc wcel cA cc wcel vx vk vj cv cc0 cuz cfv wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cc0 vj vy cc0 cuz
      cfv cA vj cv cexp co vj cv cfa cfv cdiv co cc0 cuz fvex opabex2 isumcl 0z
      cA cc wcel caddc vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cseq0 co vx cv cli wbr vx wex cc0 caddc
      cop vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cseqz co vx cv cli wbr vx wex vx vy cA vj vj cv cc0
      cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy vj cv cc0 cuz cfv wcel vj cv cn0 wcel vy cv cA vj cv cexp co vj
      cv cfa cfv cdiv co wceq cc0 cuz cfv cn0 vj cv cn0 cc0 cuz cfv nn0uz
      eqcomi eleq2i anbi1i opabbii efseq0ex caddc vj cv cc0 cuz cfv wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq0 co vx cv
      cli wbr cc0 caddc cop vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab cseqz co vx cv cli wbr vx caddc vj cv
      cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj
      vy copab cseq0 co cc0 caddc cop vj cv cc0 cuz cfv wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseqz co vx cv cli
      caddc vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab addex vj vy cc0 cuz cfv cA vj cv cexp co vj cv cfa
      cfv cdiv co cc0 cuz fvex opabex2 seq0seqz breq1i exbii sylib sylancr cn0
      cA vk cv cexp co vk cv cfa cfv cdiv co vk csu cc0 cuz cfv cA vk cv cexp
      co vk cv cfa cfv cdiv co vk csu cc0 cuz cfv vk cv vj cv cc0 cuz cfv wcel
      vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk
      csu cn0 cc0 cuz cfv cA vk cv cexp co vk cv cfa cfv cdiv co vk nn0uz
      sumeq1i cc0 cuz cfv vk cv vj cv cc0 cuz cfv wcel vy cv cA vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA vk cv cexp co vk cv cfa
      cfv cdiv co vk vj vy vk cv cA vj cv cexp co vj cv cfa cfv cdiv co cA vk
      cv cexp co vk cv cfa cfv cdiv co cc0 cuz cfv vj cv cc0 cuz cfv wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv vk cv
      wceq cA vj cv cexp co cA vk cv cexp co vj cv cfa cfv vk cv cfa cfv cdiv
      vj cv vk cv cA cexp opreq2 vj cv vk cv cfa fveq2 opreq12d vj cv cc0 cuz
      cfv wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      eqid cA vk cv cexp co vk cv cfa cfv cdiv oprex fvopab4 sumeq2i eqtr4i
      syl5eqel eqeltrd $.
      $( [23-Feb-2006] $) $( [8-Jan-2006] $)

    $( Domain and codomain of the exponential function. (Contributed by Paul
       Chapman, 22-Oct-2007.) $)
    eff $p |- exp : CC --> CC $=
      cc cc ce wf ce cc wfn vx cv ce cfv cc wcel vx cc wral vx cc cc ce ffnfv
      vx vy cc cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu ce cn0 vx
      cv vk cv cexp co vk cv cfa cfv cdiv co vk sumex vx vy vk df-ef fnopab2 vx
      cv ce cfv cc wcel vx cc vx cv efcl rgen mpbir2an $.
      $( [22-Oct-2007] $) $( [22-Oct-2007] $)
  $}

  ${
    $d A j k x y $.  $d F k x $.
    efcvg.1 $e |- F =
       { <. j , y >. | ( j e. NN0 /\ y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    $( The series that defines the exponential function converges to it. $)
    efcvg $p |- ( A e. CC -> ( + seq0 F ) ~~> ( exp ` A ) ) $=
      cA cc wcel caddc cF cseq0 co cn0 cA vk cv cexp co vk cv cfa cfv cdiv co
      vk csu cA ce cfv cli cA cc wcel cc0 caddc cop cF cseqz co cn0 cA vk cv
      cexp co vk cv cfa cfv cdiv co vk csu caddc cF cseq0 co cli cA cc wcel cc0
      caddc cop cF cseqz co cc0 cuz cfv vk cv cF cfv vk csu cn0 cA vk cv cexp
      co vk cv cfa cfv cdiv co vk csu cli cc0 cz wcel cc0 caddc cop cF cseqz co
      vx cv cli wbr vx wex cc0 caddc cop cF cseqz co cc0 cuz cfv vk cv cF cfv
      vk csu cli wbr cA cc wcel vx vk cF cc0 vj vy cn0 cA vj cv cexp co vj cv
      cfa cfv cdiv co cF nn0ex efcvg.1 fopabex2 isumclim2 0z cA cc wcel caddc
      cF cseq0 co vx cv cli wbr vx wex cc0 caddc cop cF cseqz co vx cv cli wbr
      vx wex vx vy cA vj cF efcvg.1 efseq0ex caddc cF cseq0 co vx cv cli wbr
      cc0 caddc cop cF cseqz co vx cv cli wbr vx caddc cF cseq0 co cc0 caddc
      cop cF cseqz co vx cv cli caddc cF addex vj vy cn0 cA vj cv cexp co vj cv
      cfa cfv cdiv co cF nn0ex efcvg.1 fopabex2 seq0seqz breq1i exbii sylib
      sylancr cn0 vk cv cF cfv vk csu cc0 cuz cfv vk cv cF cfv vk csu cn0 cA vk
      cv cexp co vk cv cfa cfv cdiv co vk csu cn0 cc0 cuz cfv vk cv cF cfv vk
      nn0uz sumeq1i cn0 vk cv cF cfv cA vk cv cexp co vk cv cfa cfv cdiv co vk
      vj vy vk cv cA vj cv cexp co vj cv cfa cfv cdiv co cA vk cv cexp co vk cv
      cfa cfv cdiv co cn0 cF vj cv vk cv wceq cA vj cv cexp co cA vk cv cexp co
      vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv cA cexp opreq2 vj cv vk cv
      cfa fveq2 opreq12d efcvg.1 cA vk cv cexp co vk cv cfa cfv cdiv oprex
      fvopab4 sumeq2i eqtr3i syl6breq caddc cF addex vj vy cn0 cA vj cv cexp co
      vj cv cfa cfv cdiv co cF nn0ex efcvg.1 fopabex2 seq0seqz syl5eqbr cA vk
      efval breqtrrd $.
      $( [27-Jun-2006] $) $( [9-Jan-2006] $)
  $}

  ${
    $d k n x y z A $.
    efcvgfsum.1 $e |- F = { <. n , y >. | ( n e. NN0 /\
                     y = sum_ k e. ( 0 ... n ) ( ( A ^ k ) / ( ! ` k ) ) ) } $.
    $( Exponential function convergence in terms of a sequence of partial
       finite sums. $)
    efcvgfsum $p |- ( A e. CC -> F ~~> ( exp ` A ) ) $=
      cA cc wcel cF cc0 cuz cfv cA vk cv cexp co vk cv cfa cfv cdiv co vk csu
      cA ce cfv cli cc0 cz wcel cF vx cv cli wbr vx wex cF cc0 cuz cfv cA vk cv
      cexp co vk cv cfa cfv cdiv co vk csu cli wbr cA cc wcel vx vy cA vk cv
      cexp co vk cv cfa cfv cdiv co vn vk cF cc0 cA vk cv cexp co vk cv cfa cfv
      cdiv oprex cF vn cv cn0 wcel vy cv cc0 vn cv cfz co cA vk cv cexp co vk
      cv cfa cfv cdiv co vk csu wceq wa vn vy copab vn cv cc0 cuz cfv wcel vy
      cv cc0 vn cv cfz co cA vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa
      vn vy copab efcvgfsum.1 vn cv cn0 wcel vy cv cc0 vn cv cfz co cA vk cv
      cexp co vk cv cfa cfv cdiv co vk csu wceq wa vn cv cc0 cuz cfv wcel vy cv
      cc0 vn cv cfz co cA vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa vn
      vy vn cv cn0 wcel vn cv cc0 cuz cfv wcel vy cv cc0 vn cv cfz co cA vk cv
      cexp co vk cv cfa cfv cdiv co vk csu wceq vn cv elnn0uz anbi1i opabbii
      eqtri isumclim5 0z cA cc wcel caddc vk cv cn0 wcel vz cv cA vk cv cexp co
      vk cv cfa cfv cdiv co wceq wa vk vz copab cseq0 co vx cv cli wbr vx wex
      cF vx cv cli wbr vx wex vx vz cA vk vk cv cn0 wcel vz cv cA vk cv cexp co
      vk cv cfa cfv cdiv co wceq wa vk vz copab vk cv cn0 wcel vz cv cA vk cv
      cexp co vk cv cfa cfv cdiv co wceq wa vk vz copab eqid efseq0ex caddc vk
      cv cn0 wcel vz cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vz
      copab cseq0 co vx cv cli wbr cF vx cv cli wbr vx caddc vk cv cn0 wcel vz
      cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vz copab cseq0 co cF
      vx cv cli caddc vk cv cn0 wcel vz cv cA vk cv cexp co vk cv cfa cfv cdiv
      co wceq wa vk vz copab cseq0 co cc0 caddc cop vk cv cn0 wcel vz cv cA vk
      cv cexp co vk cv cfa cfv cdiv co wceq wa vk vz copab cseqz co cF caddc vk
      cv cn0 wcel vz cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vz
      copab addex vk vz cn0 cA vk cv cexp co vk cv cfa cfv cdiv co nn0ex
      opabex2 seq0seqz cc0 cz wcel cc0 caddc cop vk cv cn0 wcel vz cv cA vk cv
      cexp co vk cv cfa cfv cdiv co wceq wa vk vz copab cseqz co cF wceq 0z vz
      vy cA vk cv cexp co vk cv cfa cfv cdiv co vk vn vk cv cn0 wcel vz cv cA
      vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vz copab cF cc0 cA vk cv
      cexp co vk cv cfa cfv cdiv oprex vk cv cn0 wcel vz cv cA vk cv cexp co vk
      cv cfa cfv cdiv co wceq wa vk cv cc0 cuz cfv wcel vz cv cA vk cv cexp co
      vk cv cfa cfv cdiv co wceq wa vk vz vk cv cn0 wcel vk cv cc0 cuz cfv wcel
      vz cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq vk cv elnn0uz anbi1i
      opabbii cF vn cv cn0 wcel vy cv cc0 vn cv cfz co cA vk cv cexp co vk cv
      cfa cfv cdiv co vk csu wceq wa vn vy copab vn cv cc0 cuz cfv wcel vy cv
      cc0 vn cv cfz co cA vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa vn
      vy copab efcvgfsum.1 vn cv cn0 wcel vy cv cc0 vn cv cfz co cA vk cv cexp
      co vk cv cfa cfv cdiv co vk csu wceq wa vn cv cc0 cuz cfv wcel vy cv cc0
      vn cv cfz co cA vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa vn vy
      vn cv cn0 wcel vn cv cc0 cuz cfv wcel vy cv cc0 vn cv cfz co cA vk cv
      cexp co vk cv cfa cfv cdiv co vk csu wceq vn cv elnn0uz anbi1i opabbii
      eqtri serzfsum ax-mp eqtri breq1i exbii sylib sylancr cA cc wcel cA ce
      cfv cn0 cA vk cv cexp co vk cv cfa cfv cdiv co vk csu cc0 cuz cfv cA vk
      cv cexp co vk cv cfa cfv cdiv co vk csu cA vk efval cn0 cc0 cuz cfv cA vk
      cv cexp co vk cv cfa cfv cdiv co vk nn0uz sumeq1i syl6req breqtrd $.
      $( [17-Feb-2006] $) $( [10-Jan-2006] $)
  $}

  ${
    $d A j y $.  $d N j y $.
    eftval.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                               y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    $( The value of a term in the series expansion of the exponential function.
       (Contributed by Paul Chapman, 21-Aug-2007.) $)
    eftval $p |- ( N e. NN0 ->
                         ( F ` N ) = ( ( A ^ N ) / ( ! ` N ) ) ) $=
      vj vy cN cA vj cv cexp co vj cv cfa cfv cdiv co cA cN cexp co cN cfa cfv
      cdiv co cn0 cF vj cv cN wceq cA vj cv cexp co cA cN cexp co vj cv cfa cfv
      cN cfa cfv cdiv vj cv cN cA cexp opreq2 vj cv cN cfa fveq2 opreq12d
      eftval.1 cA cN cexp co cN cfa cfv cdiv oprex fvopab4 $.
      $( [29-Dec-2007] $) $( [21-Aug-2007] $)
  $}

  ${
    $d j k x y A $.
    reefcl.1 $e |- A e. RR $.
    $( Closure law for the exponential function with a real argument. $)
    reefcli $p |- ( exp ` A ) e. RR $=
      cA ce cfv cc0 cuz cfv vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cr cA ce cfv cn0 cA vk cv
      cexp co vk cv cfa cfv cdiv co vk csu cn0 vk cv vj cv cn0 wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cc0 cuz
      cfv vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cfv vk csu cA cc wcel cA ce cfv cn0 cA vk cv cexp co
      vk cv cfa cfv cdiv co vk csu wceq cA reefcl.1 recni cA vk efval ax-mp cn0
      vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab cfv cA vk cv cexp co vk cv cfa cfv cdiv co vk vy cA vj vj cv
      cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab eqid eftval sumeq2i cn0 cc0 cuz cfv vk cv vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk
      nn0uz sumeq1i 3eqtr2i cc0 cz wcel vk cv vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cr wcel vk cc0 cuz
      cfv wral cc0 caddc cop vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cseqz co vx cv cli wbr vx wex cc0 cuz cfv
      vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab cfv vk csu cr wcel 0z vk cv vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cr wcel vk cc0 cuz
      cfv vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cr wcel vk cv
      elnn0uz vk cv cn0 wcel vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab cfv cA vk cv cexp co vk cv cfa cfv
      cdiv co cr vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab vk cv vj cv cn0 wcel vy cv cA vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab eqid eftval cA vk cv cexp co cr
      wcel vk cv cfa cfv cr wcel vk cv cfa cfv cc0 wne cA vk cv cexp co vk cv
      cfa cfv cdiv co cr wcel vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv
      redivcl cA cr wcel vk cv cn0 wcel cA vk cv cexp co cr wcel reefcl.1 cA vk
      cv reexpcl mpan vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr
      wcel vk cv faccl vk cv cfa cfv nnre syl vk cv facne0 syl3anc eqeltrd
      sylbir rgen caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cseq0 co vx cv cli wbr vx wex cc0 caddc cop
      vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cseqz co vx cv cli wbr vx wex cA cc wcel caddc vj cv cn0 wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq0 co vx cv
      cli wbr vx wex cA reefcl.1 recni vx vy cA vj vj cv cn0 wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid efseq0ex
      ax-mp caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab cseq0 co vx cv cli wbr cc0 caddc cop vj cv cn0 wcel
      vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseqz co
      vx cv cli wbr vx caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cseq0 co cc0 caddc cop vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseqz co vx
      cv cli caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv
      co nn0ex opabex2 seq0seqz breq1i exbii mpbi vx vk vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cc0 vj vy cn0 cA
      vj cv cexp co vj cv cfa cfv cdiv co nn0ex opabex2 isumrecl mp3an eqeltri
      $.
      $( [29-Jun-2006] $) $( [6-Jun-2006] $)
  $}

  $( The exponential function is real if its argument is real. $)
  reefcl $p |- ( A e. RR -> ( exp ` A ) e. RR ) $=
    cA cr wcel cA ce cfv cr wcel cA cr wcel cA cc0 cif ce cfv cr wcel cA cc0 cA
    cA cr wcel cA cc0 cif wceq cA ce cfv cA cr wcel cA cc0 cif ce cfv cr cA cA
    cr wcel cA cc0 cif ce fveq2 eleq1d cA cr wcel cA cc0 cif cA cc0 cr 0re
    elimel reefcli dedth $.
    $( [25-Aug-2007] $) $( [27-Apr-2005] $)

  ${
    $d x y z $.  $d F z $.  $d G z $.
    erelem1.1 $e |- F = { <. x , y >. | ( x e. NN /\
                     y = ( 2 x. ( ( 1 / 2 ) ^ x ) ) ) } $.
    erelem1.2 $e |- G =
              { <. x , y >. | ( x e. NN /\ y = ( 1 / ( ! ` x ) ) ) } $.
    $( Lemma for ~ ereALT . $)
    erelem1 $p |- ( F : NN --> RR /\ G : NN --> RR ) $=
      cn cr cF wf cn cr cG wf vx vy cn cr c2 c1 c2 cdiv co vx cv cexp co cmul
      co cF erelem1.1 c2 cr wcel c1 c2 cdiv co vx cv cexp co cr wcel c2 c1 c2
      cdiv co vx cv cexp co cmul co cr wcel vx cv cn wcel c2 c1 c2 cdiv co vx
      cv cexp co remulcl 2re c1 c2 cdiv co cr wcel vx cv cn0 wcel c1 c2 cdiv co
      vx cv cexp co cr wcel vx cv cn wcel c1 c2 cdiv co vx cv reexpcl c2 2re
      2ne0 rereccli vx cv nnnn0 sylancr sylancr fopab vx vy cn cr c1 vx cv cfa
      cfv cdiv co cG erelem1.2 vx cv cfa cfv cr wcel vx cv cfa cfv cc0 wne c1
      vx cv cfa cfv cdiv co cr wcel vx cv cn wcel vx cv cfa cfv rereccl vx cv
      cn wcel vx cv cfa cfv cn wcel vx cv cfa cfv cr wcel vx cv cn wcel vx cv
      cn0 wcel vx cv cfa cfv cn wcel vx cv nnnn0 vx cv faccl syl vx cv cfa cfv
      nnre syl vx cv cn wcel vx cv cfa cfv cn wcel vx cv cfa cfv cc0 wne vx cv
      cn wcel vx cv cn0 wcel vx cv cfa cfv cn wcel vx cv nnnn0 vx cv faccl syl
      vx cv cfa cfv nnne0 syl sylanc fopab pm3.2i $.
      $( [30-Jun-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ereALT . $)
    erelem2 $p |- ( + seq1 F ) ~~> 2 $=
      caddc cF cseq1 co c2 c1 cmul co c2 cli c2 c1 vz caddc vx cv cn wcel vy cv
      c1 c2 cdiv co vx cv cexp co wceq wa vx vy copab cseq1 co caddc cF cseq1
      co 2cn c1 cc ax1cn elisseti caddc vx cv cn wcel vy cv c1 c2 cdiv co vx cv
      cexp co wceq wa vx vy copab cseq1 co c1 c2 cdiv co c1 c1 c2 cdiv co cmin
      co cdiv co c1 cli vy c1 c2 cdiv co vx vx cv cn wcel vy cv c1 c2 cdiv co
      vx cv cexp co wceq wa vx vy copab vx cv cn wcel vy cv c1 c2 cdiv co vx cv
      cexp co wceq wa vx vy copab eqid c1 c2 cdiv co c2 2re 2ne0 rereccli recni
      c1 c2 cdiv co cabs cfv c1 c2 cdiv co c1 clt cc0 c1 c2 cdiv co cle wbr c1
      c2 cdiv co cabs cfv c1 c2 cdiv co wceq cc0 c1 c2 cdiv co 0re c2 2re 2ne0
      rereccli halfgt0 ltleii c1 c2 cdiv co c2 2re 2ne0 rereccli absidi ax-mp
      halflt1 eqbrtri geolim1i c1 c2 cdiv co c1 c1 c2 cdiv co cmin co cdiv co
      c1 c2 cdiv co c1 c2 cdiv co cdiv co c1 c1 c1 c2 cdiv co cmin co c1 c2
      cdiv co c1 c2 cdiv co cdiv c1 c1 c2 cdiv co c1 c2 cdiv co ax1cn c1 c2
      cdiv co c2 2re 2ne0 rereccli recni c1 c2 cdiv co c2 2re 2ne0 rereccli
      recni c1 cc wcel c1 c2 cdiv co c1 c2 cdiv co caddc co c1 wceq ax1cn c1
      2halves ax-mp subaddrii opreq2i c1 c2 cdiv co c1 c2 cdiv co c2 2re 2ne0
      rereccli recni c1 c2 ax1cn 2cn ax1ne0 2ne0 divne0i dividi eqtri breqtri
      caddc cF addex vx vy cn c2 c1 c2 cdiv co vx cv cexp co cmul co cF nnex
      erelem1.1 fopabex2 seq1fn vz cv cn wcel vz cv caddc vx cv cn wcel vy cv
      c1 c2 cdiv co vx cv cexp co wceq wa vx vy copab cseq1 co cfv cc wcel vz
      cv caddc cF cseq1 co cfv c2 vz cv caddc vx cv cn wcel vy cv c1 c2 cdiv co
      vx cv cexp co wceq wa vx vy copab cseq1 co cfv cmul co wceq vx vy c1 c2
      cdiv co vx cv cexp co vz cv vx cv cn wcel vy cv c1 c2 cdiv co vx cv cexp
      co wceq wa vx vy copab vx cv cn wcel vy cv c1 c2 cdiv co vx cv cexp co
      wceq wa vx vy copab eqid c1 c2 cdiv co vx cv cexp co cc wcel vx cn c1 c2
      cdiv co cc wcel vx cv cn0 wcel c1 c2 cdiv co vx cv cexp co cc wcel vx cv
      cn wcel c1 c2 cdiv co vx cv expcl c1 c2 cdiv co c2 2re 2ne0 rereccli
      recni vx cv nnnn0 sylancr rgen ser1cl2i c2 vz vx cv cn wcel vy cv c1 c2
      cdiv co vx cv cexp co wceq wa vx vy copab cF vz cv 2cn vx vy cn cc c1 c2
      cdiv co vx cv cexp co vx cv cn wcel vy cv c1 c2 cdiv co vx cv cexp co
      wceq wa vx vy copab vx cv cn wcel vy cv c1 c2 cdiv co vx cv cexp co wceq
      wa vx vy copab eqid c1 c2 cdiv co cc wcel vx cv cn0 wcel c1 c2 cdiv co vx
      cv cexp co cc wcel vx cv cn wcel c1 c2 cdiv co vx cv expcl c1 c2 cdiv co
      c2 2re 2ne0 rereccli recni vx cv nnnn0 sylancr fopab vx vy cn c2 c1 c2
      cdiv co vx cv cexp co cmul co cF nnex erelem1.1 fopabex2 vz cv cn wcel vz
      cv cF cfv c2 c1 c2 cdiv co vz cv cexp co cmul co c2 vz cv vx cv cn wcel
      vy cv c1 c2 cdiv co vx cv cexp co wceq wa vx vy copab cfv cmul co vx vy
      vz cv c2 c1 c2 cdiv co vx cv cexp co cmul co c2 c1 c2 cdiv co vz cv cexp
      co cmul co cn cF vx cv vz cv wceq c1 c2 cdiv co vx cv cexp co c1 c2 cdiv
      co vz cv cexp co c2 cmul vx cv vz cv c1 c2 cdiv co cexp opreq2 opreq2d
      erelem1.1 c2 c1 c2 cdiv co vz cv cexp co cmul oprex fvopab4 vz cv cn wcel
      vz cv vx cv cn wcel vy cv c1 c2 cdiv co vx cv cexp co wceq wa vx vy copab
      cfv c1 c2 cdiv co vz cv cexp co c2 cmul vx vy vz cv c1 c2 cdiv co vx cv
      cexp co c1 c2 cdiv co vz cv cexp co cn vx cv cn wcel vy cv c1 c2 cdiv co
      vx cv cexp co wceq wa vx vy copab vx cv vz cv c1 c2 cdiv co cexp opreq2
      vx cv cn wcel vy cv c1 c2 cdiv co vx cv cexp co wceq wa vx vy copab eqid
      c1 c2 cdiv co vz cv cexp oprex fvopab4 opreq2d eqtr4d ser1mulci jca
      climmulci c2 2cn mulid1i breqtri $.
      $( [30-Jun-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ereALT . $)
    erelem3 $p |- ( z e. NN ->
                   ( 0 <_ ( G ` z ) /\ ( G ` z ) <_ ( F ` z ) ) ) $=
      vz cv cn wcel cc0 vz cv cG cfv cle wbr vz cv cG cfv vz cv cF cfv cle wbr
      vz cv cn wcel cc0 c1 vz cv cfa cfv cdiv co vz cv cG cfv cle c1 vz cv cfa
      cfv cdiv co cr wcel cc0 c1 vz cv cfa cfv cdiv co clt wbr cc0 c1 vz cv cfa
      cfv cdiv co cle wbr vz cv cn wcel cc0 cr wcel c1 vz cv cfa cfv cdiv co cr
      wcel cc0 c1 vz cv cfa cfv cdiv co clt wbr cc0 c1 vz cv cfa cfv cdiv co
      cle wbr wi 0re cc0 c1 vz cv cfa cfv cdiv co ltle mpan vz cv cfa cfv cr
      wcel vz cv cfa cfv cc0 wne c1 vz cv cfa cfv cdiv co cr wcel vz cv cn wcel
      vz cv cfa cfv rereccl vz cv cn wcel vz cv cfa cfv cn wcel vz cv cfa cfv
      cr wcel vz cv cn wcel vz cv cn0 wcel vz cv cfa cfv cn wcel vz cv nnnn0 vz
      cv faccl syl vz cv cfa cfv nnre syl vz cv cn wcel vz cv cfa cfv cn wcel
      vz cv cfa cfv cc0 wne vz cv cn wcel vz cv cn0 wcel vz cv cfa cfv cn wcel
      vz cv nnnn0 vz cv faccl syl vz cv cfa cfv nnne0 syl sylanc vz cv cfa cfv
      cr wcel cc0 vz cv cfa cfv clt wbr cc0 c1 vz cv cfa cfv cdiv co clt wbr vz
      cv cn wcel vz cv cfa cfv recgt0 vz cv cn wcel vz cv cfa cfv cn wcel vz cv
      cfa cfv cr wcel vz cv cn wcel vz cv cn0 wcel vz cv cfa cfv cn wcel vz cv
      nnnn0 vz cv faccl syl vz cv cfa cfv nnre syl vz cv cn wcel vz cv cfa cfv
      cn wcel cc0 vz cv cfa cfv clt wbr vz cv cn wcel vz cv cn0 wcel vz cv cfa
      cfv cn wcel vz cv nnnn0 vz cv faccl syl vz cv cfa cfv nngt0 syl sylanc
      sylc vx vy vz cv c1 vx cv cfa cfv cdiv co c1 vz cv cfa cfv cdiv co cn cG
      vx cv vz cv wceq vx cv cfa cfv vz cv cfa cfv c1 cdiv vx cv vz cv cfa
      fveq2 opreq2d erelem1.2 c1 vz cv cfa cfv cdiv oprex fvopab4 breqtrrd vz
      cv cn wcel c1 vz cv cfa cfv cdiv co c2 c1 c2 cdiv co vz cv cexp co cmul
      co vz cv cG cfv vz cv cF cfv cle vz cv cn wcel c1 vz cv cfa cfv cdiv co
      c1 c2 vz cv cexp co c2 cdiv co cdiv co c2 c1 c2 cdiv co vz cv cexp co
      cmul co cle vz cv cn wcel c2 vz cv cexp co c2 cdiv co vz cv cfa cfv cle
      wbr c1 vz cv cfa cfv cdiv co c1 c2 vz cv cexp co c2 cdiv co cdiv co cle
      wbr vz cv cn wcel vz cv cn0 wcel c2 vz cv cexp co c2 cdiv co vz cv cfa
      cfv cle wbr vz cv nnnn0 vz cv faclbnd2 syl c2 vz cv cexp co c2 cdiv co cr
      wcel cc0 c2 vz cv cexp co c2 cdiv co clt wbr vz cv cfa cfv cr wcel cc0 vz
      cv cfa cfv clt wbr c2 vz cv cexp co c2 cdiv co vz cv cfa cfv cle wbr c1
      vz cv cfa cfv cdiv co c1 c2 vz cv cexp co c2 cdiv co cdiv co cle wbr wb
      vz cv cn wcel c2 vz cv cexp co c2 cdiv co vz cv cfa cfv lerec vz cv cn
      wcel c2 vz cv cexp co cr wcel c2 vz cv cexp co c2 cdiv co cr wcel c2 cr
      wcel vz cv cn0 wcel c2 vz cv cexp co cr wcel vz cv cn wcel c2 vz cv
      reexpcl 2re vz cv nnnn0 sylancr c2 vz cv cexp co rehalfcl syl c2 vz cv
      cexp co cr wcel cc0 c2 vz cv cexp co clt wbr cc0 c2 vz cv cexp co c2 cdiv
      co clt wbr vz cv cn wcel c2 vz cv cexp co cr wcel cc0 c2 vz cv cexp co
      clt wbr wa c2 cr wcel cc0 c2 clt wbr cc0 c2 vz cv cexp co c2 cdiv co clt
      wbr 2re 2pos c2 vz cv cexp co c2 divgt0 mpanr12 c2 cr wcel vz cv cn0 wcel
      c2 vz cv cexp co cr wcel vz cv cn wcel c2 vz cv reexpcl 2re vz cv nnnn0
      sylancr c2 cr wcel vz cv cn wcel cc0 c2 clt wbr cc0 c2 vz cv cexp co clt
      wbr 2re 2pos c2 cr wcel vz cv cn0 wcel cc0 c2 clt wbr cc0 c2 vz cv cexp
      co clt wbr vz cv cn wcel c2 vz cv expgt0 vz cv nnnn0 syl3an2 mp3an13
      sylanc vz cv cn wcel vz cv cfa cfv cn wcel vz cv cfa cfv cr wcel vz cv cn
      wcel vz cv cn0 wcel vz cv cfa cfv cn wcel vz cv nnnn0 vz cv faccl syl vz
      cv cfa cfv nnre syl vz cv cn wcel vz cv cfa cfv cn wcel cc0 vz cv cfa cfv
      clt wbr vz cv cn wcel vz cv cn0 wcel vz cv cfa cfv cn wcel vz cv nnnn0 vz
      cv faccl syl vz cv cfa cfv nngt0 syl syl2anc mpbid vz cv cn wcel c2 c2 vz
      cv cexp co cdiv co c2 c1 c2 vz cv cexp co cdiv co cmul co c1 c2 vz cv
      cexp co c2 cdiv co cdiv co c2 c1 c2 cdiv co vz cv cexp co cmul co c2 vz
      cv cexp co cc wcel c2 vz cv cexp co cc0 wne c2 c2 vz cv cexp co cdiv co
      c2 c1 c2 vz cv cexp co cdiv co cmul co wceq vz cv cn wcel c2 cc wcel c2
      vz cv cexp co cc wcel c2 vz cv cexp co cc0 wne c2 c2 vz cv cexp co cdiv
      co c2 c1 c2 vz cv cexp co cdiv co cmul co wceq 2cn c2 c2 vz cv cexp co
      divrec mp3an1 vz cv cn wcel c2 vz cv cexp co c2 cr wcel vz cv cn0 wcel c2
      vz cv cexp co cr wcel vz cv cn wcel c2 vz cv reexpcl 2re vz cv nnnn0
      sylancr recnd c2 vz cv cexp co cr wcel cc0 c2 vz cv cexp co clt wbr c2 vz
      cv cexp co cc0 wne vz cv cn wcel c2 vz cv cexp co gt0ne0 c2 cr wcel vz cv
      cn0 wcel c2 vz cv cexp co cr wcel vz cv cn wcel c2 vz cv reexpcl 2re vz
      cv nnnn0 sylancr c2 cr wcel vz cv cn wcel cc0 c2 clt wbr cc0 c2 vz cv
      cexp co clt wbr 2re 2pos c2 cr wcel vz cv cn0 wcel cc0 c2 clt wbr cc0 c2
      vz cv cexp co clt wbr vz cv cn wcel c2 vz cv expgt0 vz cv nnnn0 syl3an2
      mp3an13 sylanc sylanc c2 vz cv cexp co cc wcel c2 vz cv cexp co cc0 wne
      c1 c2 vz cv cexp co c2 cdiv co cdiv co c2 c2 vz cv cexp co cdiv co wceq
      vz cv cn wcel c2 vz cv cexp co cc wcel c2 vz cv cexp co cc0 wne wa c2 cc
      wcel c2 cc0 wne c1 c2 vz cv cexp co c2 cdiv co cdiv co c2 c2 vz cv cexp
      co cdiv co wceq 2cn 2ne0 c2 vz cv cexp co c2 recdiv mpanr12 vz cv cn wcel
      c2 vz cv cexp co c2 cr wcel vz cv cn0 wcel c2 vz cv cexp co cr wcel vz cv
      cn wcel c2 vz cv reexpcl 2re vz cv nnnn0 sylancr recnd c2 vz cv cexp co
      cr wcel cc0 c2 vz cv cexp co clt wbr c2 vz cv cexp co cc0 wne vz cv cn
      wcel c2 vz cv cexp co gt0ne0 c2 cr wcel vz cv cn0 wcel c2 vz cv cexp co
      cr wcel vz cv cn wcel c2 vz cv reexpcl 2re vz cv nnnn0 sylancr c2 cr wcel
      vz cv cn wcel cc0 c2 clt wbr cc0 c2 vz cv cexp co clt wbr 2re 2pos c2 cr
      wcel vz cv cn0 wcel cc0 c2 clt wbr cc0 c2 vz cv cexp co clt wbr vz cv cn
      wcel c2 vz cv expgt0 vz cv nnnn0 syl3an2 mp3an13 sylanc sylanc vz cv cn
      wcel c1 c2 cdiv co vz cv cexp co c1 c2 vz cv cexp co cdiv co c2 cmul c2
      cc wcel vz cv cn wcel c2 cc0 wne c1 c2 cdiv co vz cv cexp co c1 c2 vz cv
      cexp co cdiv co wceq 2cn 2ne0 c2 cc wcel vz cv cn0 wcel c2 cc0 wne c1 c2
      cdiv co vz cv cexp co c1 c2 vz cv cexp co cdiv co wceq vz cv cn wcel c2
      vz cv exprecOLD vz cv nnnn0 syl3an2 mp3an13 opreq2d 3eqtr4d breqtrd vx vy
      vz cv c1 vx cv cfa cfv cdiv co c1 vz cv cfa cfv cdiv co cn cG vx cv vz cv
      wceq vx cv cfa cfv vz cv cfa cfv c1 cdiv vx cv vz cv cfa fveq2 opreq2d
      erelem1.2 c1 vz cv cfa cfv cdiv oprex fvopab4 vx vy vz cv c2 c1 c2 cdiv
      co vx cv cexp co cmul co c2 c1 c2 cdiv co vz cv cexp co cmul co cn cF vx
      cv vz cv wceq c1 c2 cdiv co vx cv cexp co c1 c2 cdiv co vz cv cexp co c2
      cmul vx cv vz cv c1 c2 cdiv co cexp opreq2 opreq2d erelem1.1 c2 c1 c2
      cdiv co vz cv cexp co cmul oprex fvopab4 3brtr4d jca $.
      $( [28-Jul-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ereALT . $)
    erelem4 $p |- ( + seq1 G ) ~~> sup ( ran ( + seq1 G ) , RR , < ) $=
      vz c2 cF cG c2 cr 2re elisseti cn cr cF wf cn cr cG wf vx vy cF cG
      erelem1.1 erelem1.2 erelem1 pm3.26i cn cr cF wf cn cr cG wf vx vy cF cG
      erelem1.1 erelem1.2 erelem1 pm3.27i vx vy vz cF cG erelem1.1 erelem1.2
      erelem3 vx vy cF cG erelem1.1 erelem1.2 erelem2 cvgcmpi $.
      $( [30-Jun-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ereALT . $)
    erelem5 $p |- sup ( ran ( + seq1 G ) , RR , < ) e. RR $=
      caddc cG cseq1 co crn cr clt csup caddc cG cseq1 co cr caddc cG cseq1 co
      crn clt ltso supex cG cn cr cF wf cn cr cG wf vx vy cF cG erelem1.1
      erelem1.2 erelem1 pm3.27i ser1refi vx vy cF cG erelem1.1 erelem1.2
      erelem4 climfnrcli $.
      $( [30-Jun-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ereALT . $)
    erelem6 $p |- _e = ( 1 + sup ( ran ( + seq1 G ) , RR , < ) ) $=
      ceu cn0 c1 vx cv cfa cfv cdiv co vx csu c1 c1 cuz cfv c1 vx cv cfa cfv
      cdiv co vx csu caddc co c1 caddc cG cseq1 co crn cr clt csup caddc co vx
      eval cn0 c1 vx cv cexp co vx cv cfa cfv cdiv co vx csu c1 cn vx cv vz cv
      cn wcel vy cv c1 vz cv cexp co vz cv cfa cfv cdiv co wceq wa vz vy copab
      cfv vx csu caddc co cn0 c1 vx cv cfa cfv cdiv co vx csu c1 c1 cuz cfv c1
      vx cv cfa cfv cdiv co vx csu caddc co vy c1 vz vx ax1cn dfef2i cn0 c1 vx
      cv cexp co vx cv cfa cfv cdiv co c1 vx cv cfa cfv cdiv co vx vx cv cn0
      wcel c1 vx cv cexp co c1 vx cv cfa cfv cdiv vx cv 1exp opreq1d sumeq2i cn
      vx cv vz cv cn wcel vy cv c1 vz cv cexp co vz cv cfa cfv cdiv co wceq wa
      vz vy copab cfv vx csu c1 cuz cfv c1 vx cv cfa cfv cdiv co vx csu c1
      caddc cn c1 cuz cfv vx cv vz cv cn wcel vy cv c1 vz cv cexp co vz cv cfa
      cfv cdiv co wceq wa vz vy copab cfv c1 vx cv cfa cfv cdiv co vx nnuz vx
      cv cn wcel vx cv vz cv cn wcel vy cv c1 vz cv cexp co vz cv cfa cfv cdiv
      co wceq wa vz vy copab cfv c1 vx cv cexp co vx cv cfa cfv cdiv co c1 vx
      cv cfa cfv cdiv co vz vy vx cv c1 vz cv cexp co vz cv cfa cfv cdiv co c1
      vx cv cexp co vx cv cfa cfv cdiv co cn vz cv cn wcel vy cv c1 vz cv cexp
      co vz cv cfa cfv cdiv co wceq wa vz vy copab vz cv vx cv wceq c1 vz cv
      cexp co c1 vx cv cexp co vz cv cfa cfv vx cv cfa cfv cdiv vz cv vx cv c1
      cexp opreq2 vz cv vx cv cfa fveq2 opreq12d vz cv cn wcel vy cv c1 vz cv
      cexp co vz cv cfa cfv cdiv co wceq wa vz vy copab eqid c1 vx cv cexp co
      vx cv cfa cfv cdiv oprex fvopab4 vx cv cn wcel vx cv cn0 wcel c1 vx cv
      cexp co vx cv cfa cfv cdiv co c1 vx cv cfa cfv cdiv co wceq vx cv nnnn0
      vx cv cn0 wcel c1 vx cv cexp co c1 vx cv cfa cfv cdiv vx cv 1exp opreq1d
      syl eqtrd sumeq12i opreq2i 3eqtr3i c1 cuz cfv c1 vx cv cfa cfv cdiv co vx
      csu caddc cG cseq1 co crn cr clt csup c1 caddc c1 cz wcel c1 caddc cop cG
      cseqz co caddc cG cseq1 co crn cr clt csup cli wbr c1 cuz cfv c1 vx cv
      cfa cfv cdiv co vx csu caddc cG cseq1 co crn cr clt csup wceq 1z caddc cG
      cseq1 co c1 caddc cop cG cseqz co caddc cG cseq1 co crn cr clt csup cli
      caddc cG addex vx vy cn c1 vx cv cfa cfv cdiv co cG nnex erelem1.2
      fopabex2 seq1seqz vx vy cF cG erelem1.1 erelem1.2 erelem4 eqbrtrri vy c1
      vx cv cfa cfv cdiv co caddc cG cseq1 co crn cr clt csup vx cG c1 c1 vx cv
      cfa cfv cdiv oprex cG vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq
      wa vx vy copab vx cv c1 cuz cfv wcel vy cv c1 vx cv cfa cfv cdiv co wceq
      wa vx vy copab erelem1.2 vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co
      wceq wa vx cv c1 cuz cfv wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx
      vy vx cv cn wcel vx cv c1 cuz cfv wcel vy cv c1 vx cv cfa cfv cdiv co
      wceq vx cv elnnuz anbi1i opabbii eqtri cr caddc cG cseq1 co crn clt ltso
      supex isumclim4 mp2an opreq2i 3eqtri $.
      $( [29-Jan-2007] $) $( [20-Mar-2005] $)

    $( Lemma for ~ ereALT . $)
    erelem7 $p |- _e e. RR $=
      ceu c1 caddc cG cseq1 co crn cr clt csup caddc co cr vx vy cF cG
      erelem1.1 erelem1.2 erelem6 c1 caddc cG cseq1 co crn cr clt csup 1re vx
      vy cF cG erelem1.1 erelem1.2 erelem5 readdcli eqeltri $.
      $( [2-Jul-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ele3 . $)
    ele3lem $p |- _e <_ 3 $=
      c1 caddc cG cseq1 co crn cr clt csup caddc co c1 c2 caddc co ceu c3 cle
      caddc cG cseq1 co crn cr clt csup c2 cle wbr c1 caddc cG cseq1 co crn cr
      clt csup caddc co c1 c2 caddc co cle wbr vz c2 caddc cG cseq1 co crn cr
      clt csup cF cG c2 cr 2re elisseti cn cr cF wf cn cr cG wf vx vy cF cG
      erelem1.1 erelem1.2 erelem1 pm3.26i cn cr cF wf cn cr cG wf vx vy cF cG
      erelem1.1 erelem1.2 erelem1 pm3.27i vx vy vz cF cG erelem1.1 erelem1.2
      erelem3 vx vy cF cG erelem1.1 erelem1.2 erelem2 cr caddc cG cseq1 co crn
      clt ltso supex vx vy cF cG erelem1.1 erelem1.2 erelem4 cvgcmpubi caddc cG
      cseq1 co crn cr clt csup c2 c1 vx vy cF cG erelem1.1 erelem1.2 erelem5
      2re 1re leadd2i mpbi vx vy cF cG erelem1.1 erelem1.2 erelem6 c3 c2 c1
      caddc co c1 c2 caddc co df-3 c2 c1 2cn ax1cn addcomi eqtri 3brtr4i $.
      $( [3-Jul-2006] $) $( [19-Mar-2005] $)

    $( Lemma for ~ ege2le3 . $)
    ege2le3lem1 $p |- ( ( + seq1 G ) ` 1 ) <_
                     sup ( ran ( + seq1 G ) , RR , < ) $=
      caddc cG cseq1 co crn cr clt csup vz caddc cG cseq1 co c1 cr caddc cG
      cseq1 co crn clt ltso supex cG cn cr cF wf cn cr cG wf vx vy cF cG
      erelem1.1 erelem1.2 erelem1 pm3.27i ser1refi vz vz cv cG cn cr cF wf cn
      cr cG wf vx vy cF cG erelem1.1 erelem1.2 erelem1 pm3.27i vz cv cn wcel
      cc0 vz cv cG cfv cle wbr vz cv cG cfv vz cv cF cfv cle wbr vx vy vz cF cG
      erelem1.1 erelem1.2 erelem3 pm3.26d ser1monoi vx vy cF cG erelem1.1
      erelem1.2 erelem4 1nn climubii $.
      $( [4-Jul-2006] $) $( [20-Mar-2005] $)

    $( Lemma for ~ ege2 . $)
    ege2lem2 $p |- 2 <_ _e $=
      c1 c1 caddc co c1 caddc cG cseq1 co crn cr clt csup caddc co c2 ceu cle
      c1 caddc cG cseq1 co crn cr clt csup cle wbr c1 c1 caddc co c1 caddc cG
      cseq1 co crn cr clt csup caddc co cle wbr c1 c1 caddc cG cseq1 co cfv
      caddc cG cseq1 co crn cr clt csup cle c1 caddc cG cseq1 co cfv c1 cG cfv
      c1 caddc cG addex vx vy cn c1 vx cv cfa cfv cdiv co cG nnex erelem1.2
      fopabex2 seq11 c1 cG cfv c1 c1 cfa cfv cdiv co c1 c1 cdiv co c1 c1 cn
      wcel c1 cG cfv c1 c1 cfa cfv cdiv co wceq 1nn vx vy c1 c1 vx cv cfa cfv
      cdiv co c1 c1 cfa cfv cdiv co cn cG vx cv c1 wceq vx cv cfa cfv c1 cfa
      cfv c1 cdiv vx cv c1 cfa fveq2 opreq2d erelem1.2 c1 c1 cfa cfv cdiv oprex
      fvopab4 ax-mp c1 cfa cfv c1 c1 cdiv fac1 opreq2i c1 ax1cn div1i 3eqtri
      eqtr2i vx vy cF cG erelem1.1 erelem1.2 ege2le3lem1 eqbrtri c1 caddc cG
      cseq1 co crn cr clt csup c1 1re vx vy cF cG erelem1.1 erelem1.2 erelem5
      1re leadd2i mpbi df-2 vx vy cF cG erelem1.1 erelem1.2 erelem6 3brtr4i $.
      $( [4-Jul-2006] $) $( [20-Mar-2005] $)

    $( Lemma for ~ ege2le3 . $)
    ege2le3lem2 $p |- ( 2 <_ _e /\ _e <_ 3 ) $=
      c2 ceu cle wbr ceu c3 cle wbr c1 c1 caddc co c1 caddc cG cseq1 co crn cr
      clt csup caddc co c2 ceu cle c1 caddc cG cseq1 co crn cr clt csup cle wbr
      c1 c1 caddc co c1 caddc cG cseq1 co crn cr clt csup caddc co cle wbr c1
      c1 caddc cG cseq1 co cfv caddc cG cseq1 co crn cr clt csup cle c1 caddc
      cG cseq1 co cfv c1 cG cfv c1 caddc cG addex vx vy cn c1 vx cv cfa cfv
      cdiv co cG nnex erelem1.2 fopabex2 seq11 c1 cG cfv c1 c1 cfa cfv cdiv co
      c1 c1 cdiv co c1 c1 cn wcel c1 cG cfv c1 c1 cfa cfv cdiv co wceq 1nn vx
      vy c1 c1 vx cv cfa cfv cdiv co c1 c1 cfa cfv cdiv co cn cG vx cv c1 wceq
      vx cv cfa cfv c1 cfa cfv c1 cdiv vx cv c1 cfa fveq2 opreq2d erelem1.2 c1
      c1 cfa cfv cdiv oprex fvopab4 ax-mp c1 cfa cfv c1 c1 cdiv fac1 opreq2i c1
      ax1cn div1i 3eqtri eqtr2i vx vy cF cG erelem1.1 erelem1.2 ege2le3lem1
      eqbrtri c1 caddc cG cseq1 co crn cr clt csup c1 1re vx vy cF cG erelem1.1
      erelem1.2 erelem5 1re leadd2i mpbi df-2 vx vy cF cG erelem1.1 erelem1.2
      erelem6 3brtr4i c1 caddc cG cseq1 co crn cr clt csup caddc co c1 c2 caddc
      co ceu c3 cle caddc cG cseq1 co crn cr clt csup c2 cle wbr c1 caddc cG
      cseq1 co crn cr clt csup caddc co c1 c2 caddc co cle wbr vz c2 caddc cG
      cseq1 co crn cr clt csup cF cG c2 cr 2re elisseti cn cr cF wf cn cr cG wf
      vx vy cF cG erelem1.1 erelem1.2 erelem1 pm3.26i cn cr cF wf cn cr cG wf
      vx vy cF cG erelem1.1 erelem1.2 erelem1 pm3.27i vx vy vz cF cG erelem1.1
      erelem1.2 erelem3 vx vy cF cG erelem1.1 erelem1.2 erelem2 cr caddc cG
      cseq1 co crn clt ltso supex vx vy cF cG erelem1.1 erelem1.2 erelem4
      cvgcmpubi caddc cG cseq1 co crn cr clt csup c2 c1 vx vy cF cG erelem1.1
      erelem1.2 erelem5 2re 1re leadd2i mpbi vx vy cF cG erelem1.1 erelem1.2
      erelem6 c3 c2 c1 caddc co c1 c2 caddc co df-3 c2 c1 2cn ax1cn addcomi
      eqtri 3brtr4i pm3.2i $.
      $( [4-Jul-2006] $) $( [20-Mar-2005] $)
  $}

  ${
    $d x y $.
    $( Euler's constant ` _e ` = 2.71828... is a real number.  (Proof revised
       by Steve Rodriguez, 6-Mar-2006.) $)
    ere $p |- _e e. RR $=
      ceu c1 ce cfv cr df-e c1 1re reefcli eqeltri $.
      $( [8-Mar-2006] $) $( [19-Mar-2005] $)

    $( Euler's constant ` _e ` = 2.71828... is a real number. $)
    ereALT $p |- _e e. RR $=
      vx vy vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx vy
      copab vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab eqid vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx
      vy copab eqid erelem7 $.
      $( [4-Jul-2006] $) $( [19-Mar-2005] $)

    $( MAY BE REVISED - make obsolete and use egt2lt3 instead $)
    $( Euler's constant ` _e ` = 2.71828... has a lower bound of 2. $)
    ege2 $p |- 2 <_ _e $=
      vx vy vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx vy
      copab vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab eqid vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx
      vy copab eqid ege2lem2 $.
      $( [5-Jul-2006] $) $( [20-Mar-2005] $)

    $( MAY BE REVISED - make obsolete and use egt2lt3 instead $)
    $( Euler's constant ` _e ` = 2.71828... has an upper bound of 3. $)
    ele3 $p |- _e <_ 3 $=
      vx vy vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx vy
      copab vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab eqid vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx
      vy copab eqid ele3lem $.
      $( [4-Jul-2006] $) $( [19-Mar-2005] $)

    $( MAY BE REVISED - make obsolete and use egt2lt3 instead $)
    $( Euler's constant ` _e ` = 2.71828... is bounded by 2 and 3. $)
    ege2le3 $p |- ( 2 <_ _e /\ _e <_ 3 ) $=
      vx vy vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx vy
      copab vx cv cn wcel vy cv c2 c1 c2 cdiv co vx cv cexp co cmul co wceq wa
      vx vy copab eqid vx cv cn wcel vy cv c1 vx cv cfa cfv cdiv co wceq wa vx
      vy copab eqid ege2le3lem2 $.
      $( [5-Jul-2006] $) $( [20-Mar-2005] $)
  $}

  ${
    $d j y $.
    $( Value of the exponential function at 0.  Equation 2 of [Gleason]
       p. 308.  (Contributed by Steve Rodriguez, 27-Jun-2006.) $)
    ef0 $p |- ( exp ` 0 ) = 1 $=
      cc0 ce cfv c1 caddc vj cv cn0 wcel vy cv cc0 vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cseq0 co cc0 ce fvex c1 cc ax1cn elisseti
      caddc vj cv cn0 wcel vy cv cc0 vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab cseq0 co cc0 ce cfv cli wbr caddc vj cv cn0 wcel vy cv cc0
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq0 co c1 cli
      wbr cc0 cc wcel caddc vj cv cn0 wcel vy cv cc0 vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cseq0 co cc0 ce cfv cli wbr 0cn vy cc0 vj
      vj cv cn0 wcel vy cv cc0 vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj
      vy copab vj cv cn0 wcel vy cv cc0 vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab eqid efcvg ax-mp cc0 cc0 wceq caddc vj cv cn0 wcel vy
      cv cc0 vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq0 co
      c1 cli wbr cc0 eqid vy cc0 vj vj cv cn0 wcel vy cv cc0 vj cv cexp co vj
      cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv cc0 vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid ef0lem ax-mp
      pm3.2i climunii $.
      $( [28-Jun-2006] $) $( [27-Jun-2006] $)
  $}

$(
      ( vk vy cc0 ce cfv cn0 cv cexp co cfa cdiv csu cuz c1 cc wcel wceq 0cn
      efval ax-mp nn0uz sumeq1i cz caddc cop wa copab cseqz cli wbr 0z cseq0
      addex nn0ex opabex2 seq0seqz eqid ef0lem eqbrtrri oprex elnn0uz
      anbi1i opabbii ax1cn elisseti isumclim4 mp2an
      3eqtri ) CDEZFCAGZHIZVJJEZKIZ
      ALZCMEZVMALZNCOPVIVNQRCASTFVOVMAUAUBCUCPCUDUEVJFPZBGVMQZUFZABUGZUHIZNUIUJ
      VPNQUKUDVTULIZWANUIUDVTUMABFVMUNUOUPCCQWBNUIUJCUQBCAVTVTUQURTUSBVMNAVTCVK
      VLKUTVSVJVOPZVRUFABVQWCVRVJVAVBVCNOVDVEVFVGVH $.
$)

  ${
    $d j k m y A $.
    efcj.1 $e |- A e. CC $.
    $( Exponential function of a complex conjugate.  Equation 3 of [Gleason]
       p. 308. $)
    efcji $p |- ( exp ` ( * ` A ) ) = ( * ` ( exp ` A ) ) $=
      cA ccj cfv ce cfv cn0 cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cc0 cuz cfv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co vk csu cA
      ce cfv ccj cfv cA ccj cfv cc wcel cA ccj cfv ce cfv cn0 cA ccj cfv vk cv
      cexp co vk cv cfa cfv cdiv co vk csu wceq cA efcj.1 cjcli cA ccj cfv vk
      efval ax-mp cn0 cc0 cuz cfv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv
      co vk nn0uz sumeq1i cc0 cz wcel cc0 caddc cop vk cv cn0 wcel vy cv cA ccj
      cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cseqz co cA
      ce cfv ccj cfv cli wbr cc0 cuz cfv cA ccj cfv vk cv cexp co vk cv cfa cfv
      cdiv co vk csu cA ce cfv ccj cfv wceq 0z caddc vk cv cn0 wcel vy cv cA
      ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cseq0 co
      cc0 caddc cop vk cv cn0 wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv
      cdiv co wceq wa vk vy copab cseqz co cA ce cfv ccj cfv cli caddc vk cv
      cn0 wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk
      vy copab addex vk vy cn0 cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co
      nn0ex opabex2 seq0seqz cA ce cfv vj caddc vk cv cn0 wcel vy cv cA vk cv
      cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cseq0 co caddc vk cv
      cn0 wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk
      vy copab cseq0 co cc0 cA ce fvex caddc vk cv cn0 wcel vy cv cA ccj cfv vk
      cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cseq0 oprex 0z cA cc
      wcel caddc vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co
      wceq wa vk vy copab cseq0 co cA ce cfv cli wbr efcj.1 vy cA vk vk cv cn0
      wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab vk
      cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy
      copab eqid efcvg ax-mp vj cv cc0 cuz cfv wcel vj cv cn0 wcel vj cv caddc
      vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy
      copab cseq0 co cfv cc wcel vj cv caddc vk cv cn0 wcel vy cv cA ccj cfv vk
      cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cseq0 co cfv vj cv
      caddc vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa
      vk vy copab cseq0 co cfv ccj cfv wceq wa vj cv elnn0uz vj cv cn0 wcel vj
      cv caddc vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq
      wa vk vy copab cseq0 co cfv cc wcel vj cv caddc vk cv cn0 wcel vy cv cA
      ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cseq0 co
      cfv vj cv caddc vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv
      co wceq wa vk vy copab cseq0 co cfv ccj cfv wceq vk cv cn0 wcel vy cv cA
      vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab vj cv vk vy cn0
      cc cA vk cv cexp co vk cv cfa cfv cdiv co vk cv cn0 wcel vy cv cA vk cv
      cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab vk cv cn0 wcel vy cv cA
      vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab eqid cA cc wcel
      vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv cdiv co cc wcel efcj.1 cA
      vk cv eftcl mpan fopab ser0cl1i vm vk cv cn0 wcel vy cv cA vk cv cexp co
      vk cv cfa cfv cdiv co wceq wa vk vy copab vk cv cn0 wcel vy cv cA ccj cfv
      vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab vj cv vk vy cn0
      cA vk cv cexp co vk cv cfa cfv cdiv co nn0ex opabex2 vk vy cn0 cA ccj cfv
      vk cv cexp co vk cv cfa cfv cdiv co nn0ex opabex2 vm cv cn0 wcel vm cv vk
      cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy
      copab cfv cc wcel vm cv vk cv cn0 wcel vy cv cA ccj cfv vk cv cexp co vk
      cv cfa cfv cdiv co wceq wa vk vy copab cfv vm cv vk cv cn0 wcel vy cv cA
      vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cfv ccj cfv wceq
      vm cv cn0 wcel vm cv vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv
      cdiv co wceq wa vk vy copab cfv cA vm cv cexp co vm cv cfa cfv cdiv co cc
      vy cA vk vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq
      wa vk vy copab vm cv vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv
      cdiv co wceq wa vk vy copab eqid eftval cA cc wcel vm cv cn0 wcel cA vm
      cv cexp co vm cv cfa cfv cdiv co cc wcel efcj.1 cA vm cv eftcl mpan
      eqeltrd vm cv cn0 wcel cA ccj cfv vm cv cexp co vm cv cfa cfv cdiv co cA
      vm cv cexp co vm cv cfa cfv cdiv co ccj cfv vm cv vk cv cn0 wcel vy cv cA
      ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab cfv vm cv
      vk cv cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy
      copab cfv ccj cfv vm cv cn0 wcel cA vm cv cexp co vm cv cfa cfv cdiv co
      ccj cfv cA vm cv cexp co ccj cfv vm cv cfa cfv ccj cfv cdiv co cA ccj cfv
      vm cv cexp co vm cv cfa cfv cdiv co cA vm cv cexp co cc wcel vm cv cfa
      cfv cc wcel vm cv cfa cfv cc0 wne cA vm cv cexp co vm cv cfa cfv cdiv co
      ccj cfv cA vm cv cexp co ccj cfv vm cv cfa cfv ccj cfv cdiv co wceq vm cv
      cn0 wcel cA vm cv cexp co vm cv cfa cfv cjdiv cA cc wcel vm cv cn0 wcel
      cA vm cv cexp co cc wcel efcj.1 cA vm cv expcl mpan vm cv cn0 wcel vm cv
      cfa cfv vm cv cn0 wcel vm cv cfa cfv cn wcel vm cv cfa cfv cr wcel vm cv
      faccl vm cv cfa cfv nnre syl recnd vm cv facne0 syl3anc vm cv cn0 wcel cA
      vm cv cexp co ccj cfv cA ccj cfv vm cv cexp co vm cv cfa cfv ccj cfv vm
      cv cfa cfv cdiv cA cc wcel vm cv cn0 wcel cA vm cv cexp co ccj cfv cA ccj
      cfv vm cv cexp co wceq efcj.1 cA vm cv cjexp mpan vm cv cn0 wcel vm cv
      cfa cfv cr wcel vm cv cfa cfv ccj cfv vm cv cfa cfv wceq vm cv cn0 wcel
      vm cv cfa cfv cn wcel vm cv cfa cfv cr wcel vm cv faccl vm cv cfa cfv
      nnre syl vm cv cfa cfv cjre syl opreq12d eqtr2d vy cA ccj cfv vk vk cv
      cn0 wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk
      vy copab vm cv vk cv cn0 wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa
      cfv cdiv co wceq wa vk vy copab eqid eftval vm cv cn0 wcel vm cv vk cv
      cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab
      cfv cA vm cv cexp co vm cv cfa cfv cdiv co ccj vy cA vk vk cv cn0 wcel vy
      cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab vm cv vk cv
      cn0 wcel vy cv cA vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk vy copab
      eqid eftval fveq2d 3eqtr4d jca ser0cji jca sylbir climcji eqbrtrri vy cA
      ccj cfv vk cv cexp co vk cv cfa cfv cdiv co cA ce cfv ccj cfv vk vk cv
      cn0 wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk
      vy copab cc0 cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv oprex vk cv cn0
      wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co wceq wa vk cv
      cc0 cuz cfv wcel vy cv cA ccj cfv vk cv cexp co vk cv cfa cfv cdiv co
      wceq wa vk vy vk cv cn0 wcel vk cv cc0 cuz cfv wcel vy cv cA ccj cfv vk
      cv cexp co vk cv cfa cfv cdiv co wceq vk cv elnn0uz anbi1i opabbii cA ce
      cfv ccj fvex isumclim4 mp2an 3eqtri $.
      $( [10-Nov-2007] $) $( [7-Jun-2006] $)
  $}

  $( Exponential function of a complex conjugate.  Equation 3 of [Gleason]
     p. 308. $)
  efcj $p |- ( A e. CC -> ( exp ` ( * ` A ) ) = ( * ` ( exp ` A ) ) ) $=
    cA cc wcel cA ccj cfv ce cfv cA ce cfv ccj cfv wceq cA cc wcel cA cc0 cif
    ccj cfv ce cfv cA cc wcel cA cc0 cif ce cfv ccj cfv wceq cA cc0 cA cA cc
    wcel cA cc0 cif wceq cA ccj cfv ce cfv cA cc wcel cA cc0 cif ccj cfv ce cfv
    cA ce cfv ccj cfv cA cc wcel cA cc0 cif ce cfv ccj cfv cA cA cc wcel cA cc0
    cif wceq cA ccj cfv cA cc wcel cA cc0 cif ccj cfv ce cA cA cc wcel cA cc0
    cif ccj fveq2 fveq2d cA cA cc wcel cA cc0 cif wceq cA ce cfv cA cc wcel cA
    cc0 cif ce cfv ccj cA cA cc wcel cA cc0 cif ce fveq2 fveq2d eqeq12d cA cc
    wcel cA cc0 cif cA cc0 cc 0cn elimel efcji dedth $.
    $( [23-Feb-2006] $) $( [29-Apr-2005] $)

  ${
    efaddlem1.1 $e |- N e. NN $.
    $( Lemma for ~ efaddi (exponential function addition law).  Technical
       result for later use.  _Note:  if you want to see these lemmas in the
       Statement List summary, change the first word "Lemma" to "- Lemma" and
       re-run the "write th" command_. $)
    efaddlem1 $p |- ( j e. ( 1 ... N ) ->
                      N e. ( ZZ>= ` ( ( N - j ) + 1 ) ) ) $=
      vj cv c1 cN cfz co wcel cN cN vj cv cmin co c1 caddc co cuz cfv wcel cN
      vj cv cmin co c1 caddc co cN cle wbr vj cv c1 cN cfz co wcel cN vj cv
      cmin co c1 caddc co cN cle wbr cN vj cv cmin co cN c1 cmin co cle wbr vj
      cv c1 cN cfz co wcel c1 vj cv cle wbr cN vj cv cmin co cN c1 cmin co cle
      wbr vj cv c1 cN elfzle1 vj cv c1 cN cfz co wcel vj cv cr wcel c1 vj cv
      cle wbr cN vj cv cmin co cN c1 cmin co cle wbr wb vj cv c1 cN cfz co wcel
      vj cv cz wcel vj cv cr wcel vj cv c1 cN elfzelz vj cv zre syl c1 cr wcel
      vj cv cr wcel cN cr wcel c1 vj cv cle wbr cN vj cv cmin co cN c1 cmin co
      cle wbr wb 1re cN efaddlem1.1 nnrei c1 vj cv cN lesub2 mp3an13 syl mpbid
      vj cv c1 cN cfz co wcel cN vj cv cmin co cr wcel cN vj cv cmin co c1
      caddc co cN cle wbr cN vj cv cmin co cN c1 cmin co cle wbr wb cN cr wcel
      vj cv cr wcel cN vj cv cmin co cr wcel vj cv c1 cN cfz co wcel cN vj cv
      resubcl cN efaddlem1.1 nnrei vj cv c1 cN cfz co wcel vj cv cz wcel vj cv
      cr wcel vj cv c1 cN elfzelz vj cv zre syl sylancr cN vj cv cmin co cr
      wcel c1 cr wcel cN cr wcel cN vj cv cmin co c1 caddc co cN cle wbr cN vj
      cv cmin co cN c1 cmin co cle wbr wb 1re cN efaddlem1.1 nnrei cN vj cv
      cmin co c1 cN leaddsub mp3an23 syl mpbird cN vj cv cmin co c1 caddc co cz
      wcel cN cz wcel cN cN vj cv cmin co c1 caddc co cuz cfv wcel cN vj cv
      cmin co c1 caddc co cN cle wbr wb vj cv c1 cN cfz co wcel cN vj cv cmin
      co c1 caddc co cN eluz vj cv c1 cN cfz co wcel cN vj cv cmin co cN cz
      wcel vj cv cz wcel cN vj cv cmin co cz wcel vj cv c1 cN cfz co wcel cN vj
      cv zsubcl cN cn wcel cN cz wcel efaddlem1.1 cN nnz ax-mp vj cv c1 cN
      elfzelz sylancr peano2zdi cN cn wcel cN cz wcel efaddlem1.1 cN nnz ax-mp
      sylancl mpbird $.
      $( [13-Feb-2006] $) $( [8-Jan-2006] $)

    $( Lemma for ~ efaddi .  For later use, show that the lower bound of a
       summation index range that we will use is greater than zero. $)
    efaddlem2 $p |- ( ( j e. ( 1 ... N ) /\
                   k e. ( ( ( N - j ) + 1 ) ... N ) ) -> k e. NN ) $=
      vk cv cn wcel vk cv cz wcel c1 vk cv cle wbr vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv elnnz1 vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel vk cv cz wcel vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN elfzelz adantl vj cv c1 cN cfz
      co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa c1 cN vj cv
      cmin co c1 caddc co vk cv c1 cr wcel vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa 1re a1i vk cv cN vj cv cmin co
      c1 caddc co cN cfz co wcel cN vj cv cmin co c1 caddc co cr wcel vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel cN vj cv
      cmin co c1 caddc co cz wcel cN vj cv cmin co c1 caddc co cr wcel vk cv cN
      vj cv cmin co c1 caddc co cN elfzel1 cN vj cv cmin co c1 caddc co zre syl
      adantl vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vk cv cr wcel vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vk
      cv cz wcel vk cv cr wcel vk cv cN vj cv cmin co c1 caddc co cN elfzelz vk
      cv zre syl adantl vj cv c1 cN cfz co wcel c1 cN vj cv cmin co c1 caddc co
      cle wbr vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv c1 cN cfz
      co wcel cN vj cv cmin co cn0 wcel cN vj cv cmin co c1 caddc co cn wcel c1
      cN vj cv cmin co c1 caddc co cle wbr cN cn wcel vj cv c1 cN cfz co wcel
      cN vj cv cmin co cn0 wcel efaddlem1.1 cn vj cv c1 cN fznn0sub mpan cN vj
      cv cmin co nn0p1nn cN vj cv cmin co c1 caddc co nnge1 3syl adantr vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel cN vj cv cmin co c1 caddc co
      vk cv cle wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co
      cN elfzle1 adantl letrd sylanbrc $.
      $( [13-Feb-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    $d j k N $.
    efaddlem3.1 $e |- N e. NN $.
    efaddlem3.2 $e |- A e. CC $.
    efaddlem3.3 $e |- B e. CC $.
    $( Lemma for ~ efaddi .  Closure of the right-hand summation of
       ~ efaddlem6 . $)
    efaddlem3 $p |- sum_ j e. ( 1 ... N ) sum_ k e. (
            ( ( N - j ) + 1 ) ... N ) ( ( ( A ^ j ) x. ( B ^ k ) ) / ( ( ! `
            j ) x. ( ! ` k ) ) ) e. CC $=
      cN c1 cuz cfv wcel cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu cc wcel vj c1 cN cfz co wral c1 cN cfz co cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cc wcel cN cn c1 cuz cfv
      efaddlem3.1 nnuz eleqtri cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cc wcel vj c1 cN cfz co cN cN vj cv cmin co c1 caddc co cuz cfv
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co cN cfz co
      wral cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc
      wcel vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cN vj cv cmin co c1 caddc co
      cN fsumcl vj cN efaddlem3.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj cv cn wcel vk cv
      cn wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel wa vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vj cv cn wcel vk cv cn wcel cA vj cv cexp co cB vk cv cexp co
      cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv
      cn0 wcel wa cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel
      cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv
      cn0 wcel cA vj cv cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0
      wcel cA vj cv cexp co cc wcel efaddlem3.2 cA vj cv expcl mpan cB cc wcel
      vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem3.3 cB vk cv expcl mpan
      syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul
      co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv cn
      wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj
      cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv
      faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul co nncn syl vj
      cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel
      vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv cfa cfv cn wcel vk cv
      cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0
      wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv
      faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv
      nnnn0 vk cv nnnn0 syl2an vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel vj cv cN elfznn adantr vj vk cN
      efaddlem3.1 efaddlem2 sylanc r19.21aiva sylanc rgen cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu vj c1 cN fsumcl mp2an $.
      $( [13-Feb-2006] $) $( [12-Jan-2006] $)

    $( Lemma for ~ efaddi .  Real closure of the absolute value of the
       right-hand summation of ~ efaddlem6 . $)
    efaddlem4 $p |- ( abs ` sum_ j e. ( 1 ... N ) sum_ k e. (
            ( ( N - j ) + 1 ) ... N ) ( ( ( A ^ j ) x. ( B ^ k ) ) / ( ( ! `
            j ) x. ( ! ` k ) ) ) ) e. RR $=
      c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      vj csu cA cB vj vk cN efaddlem3.1 efaddlem3.2 efaddlem3.3 efaddlem3
      abscli $.
      $( [13-Feb-2006] $) $( [8-Jan-2006] $)
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k N $.
    efaddlem5.1 $e |- N e. NN $.
    efaddlem5.2 $e |- A e. CC $.
    efaddlem5.3 $e |- B e. CC $.
    $( Lemma for ~ efaddi .  Convert the truncated series for
       ` exp `` ( A + B ) ` to a double summation using the binomial theorem
       ~ binomi and rearranging with ~ fsum0diag2 . $)
    efaddlem5 $p |- sum_ j e. ( 0 ... N ) ( ( ( A + B ) ^ j ) / ( ! ` j ) ) =
                 sum_ j e. ( 0 ... N ) sum_ k e. ( 0 ... ( N - j ) )
               ( ( ( A ^ j ) x. ( B ^ k ) ) / ( ( ! ` j ) x. ( ! ` k ) ) ) $=
      cc0 cN cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu
      cc0 cN cfz co cc0 vj cv cfz co vj vj cv vk cv cmin co cA vj cv cexp co vj
      cv cfa cfv cdiv co csb cB vk cv cexp co vk cv cfa cfv cdiv co cmul co vk
      csu vj csu cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp co vj
      cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co vk csu
      vj csu cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj
      csu cc0 cN cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co cc0
      vj cv cfz co vj vj cv vk cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv
      co csb cB vk cv cexp co vk cv cfa cfv cdiv co cmul co vk csu vj vj cv cc0
      cN cfz co wcel vj cv cn0 wcel cA cB caddc co vj cv cexp co vj cv cfa cfv
      cdiv co cc0 vj cv cfz co vj vj cv vk cv cmin co cA vj cv cexp co vj cv
      cfa cfv cdiv co csb cB vk cv cexp co vk cv cfa cfv cdiv co cmul co vk csu
      wceq vj cv cN elfznn0 vj cv cn0 wcel cA cB caddc co vj cv cexp co vj cv
      cfa cfv cdiv co cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin
      co cexp co cB vk cv cexp co cmul co cmul co vk csu vj cv cfa cfv cdiv co
      cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk
      cv cexp co cmul co cmul co vj cv cfa cfv cdiv co vk csu cc0 vj cv cfz co
      vj vj cv vk cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv co csb cB vk
      cv cexp co vk cv cfa cfv cdiv co cmul co vk csu vj cv cn0 wcel cA cB
      caddc co vj cv cexp co cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu vj cv cfa cfv
      cdiv cA cB vk vj cv efaddlem5.2 efaddlem5.3 binomi opreq1d vj cv cc0 cuz
      cfv wcel vj cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vj cv vk cv cbc co
      cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co cc wcel
      vk cc0 vj cv cfz co wral cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk
      cv cmin co cexp co cB vk cv cexp co cmul co cmul co vk csu vj cv cfa cfv
      cdiv co cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co vj cv cfa cfv cdiv co vk csu wceq vj
      cv cn0 wcel vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vj cv cfa cfv vk cc0 vj cv fsumdivc vj cv cn0
      wcel vj cv cc0 cuz cfv wcel vj cv elnn0uz biimpi vj cv cn0 wcel vj cv cfa
      cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vj
      cv facne0 vj cv cn0 wcel vj cv vk cv cbc co cA vj cv vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul co cc wcel vk cc0 vj cv cfz co vj cv vk
      cv cbc co cc wcel cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cc wcel vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp
      co cmul co cmul co cc wcel vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa
      vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul
      co mulcl vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv cbc co
      cn0 wcel vj cv vk cv cbc co cc wcel vj cv cn0 wcel vk cv cz wcel vj cv vk
      cv cbc co cn0 wcel vk cv cc0 vj cv cfz co wcel vk cv vj cv bccl vk cv cc0
      vj cv elfzelz sylan2 vj cv vk cv cbc co nn0cn syl cA vj cv vk cv cmin co
      cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv vk cv cmin co cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa cA vj cv vk cv cmin co cexp co cB vk cv cexp co mulcl cA cc wcel
      vj cv vk cv cmin co cn0 wcel cA vj cv vk cv cmin co cexp co cc wcel vj cv
      cn0 wcel vk cv cc0 vj cv cfz co wcel wa cA vj cv vk cv cmin co expcl
      efaddlem5.2 cn0 vk cv cc0 vj cv fznn0sub sylancr vk cv cc0 vj cv cfz co
      wcel cB vk cv cexp co cc wcel vj cv cn0 wcel cB cc wcel vk cv cn0 wcel cB
      vk cv cexp co cc wcel vk cv cc0 vj cv cfz co wcel cB vk cv expcl
      efaddlem5.3 vk cv vj cv elfznn0 sylancr adantl sylanc sylanc r19.21aiva
      syl2anc vj cv cn0 wcel cc0 vj cv cfz co vj cv vk cv cbc co cA vj cv vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co vj cv cfa cfv cdiv co vj
      vj cv vk cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv co csb cB vk cv
      cexp co vk cv cfa cfv cdiv co cmul co vk vj cv cn0 wcel vk cv cc0 vj cv
      cfz co wcel wa vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vj cv cfa cfv cdiv co vj cv vk cv cbc co vj cv
      cfa cfv cdiv co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co c1 vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cA
      vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vj vj cv vk
      cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv co csb cB vk cv cexp co vk
      cv cfa cfv cdiv co cmul co vj cv vk cv cbc co cc wcel cA vj cv vk cv cmin
      co cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv cc wcel vj cv
      cfa cfv cc0 wne wa vj cv vk cv cbc co cA vj cv vk cv cmin co cexp co cB
      vk cv cexp co cmul co cmul co vj cv cfa cfv cdiv co vj cv vk cv cbc co vj
      cv cfa cfv cdiv co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul
      co cmul co wceq vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv
      cbc co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv div23 vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv cbc
      co cn0 wcel vj cv vk cv cbc co cc wcel vj cv cn0 wcel vk cv cz wcel vj cv
      vk cv cbc co cn0 wcel vk cv cc0 vj cv cfz co wcel vk cv vj cv bccl vk cv
      cc0 vj cv elfzelz sylan2 vj cv vk cv cbc co nn0cn syl cA vj cv vk cv cmin
      co cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv vk cv cmin co cexp
      co cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa cA vj cv vk cv cmin co cexp co cB vk cv cexp co mulcl cA cc wcel
      vj cv vk cv cmin co cn0 wcel cA vj cv vk cv cmin co cexp co cc wcel vj cv
      cn0 wcel vk cv cc0 vj cv cfz co wcel wa cA vj cv vk cv cmin co expcl
      efaddlem5.2 cn0 vk cv cc0 vj cv fznn0sub sylancr vk cv cc0 vj cv cfz co
      wcel cB vk cv cexp co cc wcel vj cv cn0 wcel cB cc wcel vk cv cn0 wcel cB
      vk cv cexp co cc wcel vk cv cc0 vj cv cfz co wcel cB vk cv expcl
      efaddlem5.3 vk cv vj cv elfznn0 sylancr adantl sylanc vj cv cn0 wcel vj
      cv cfa cfv cc wcel vj cv cfa cfv cc0 wne wa vk cv cc0 vj cv cfz co wcel
      vj cv cn0 wcel vj cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vj cv cn0 wcel
      vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv
      nncn syl vj cv facne0 jca adantr syl3anc vj cv cn0 wcel vk cv cc0 vj cv
      cfz co wcel wa vj cv vk cv cbc co vj cv cfa cfv cdiv co c1 vj cv vk cv
      cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cA vj cv vk cv cmin co cexp
      co cB vk cv cexp co cmul co cmul vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa vj cv vk cv cbc co vj cv cfa cfv cdiv co vj cv cfa cfv vj cv vk
      cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co vj cv cfa cfv cdiv co vj
      cv cfa cfv vj cv cfa cfv cdiv co vj cv vk cv cmin co cfa cfv vk cv cfa
      cfv cmul co cdiv co c1 vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co
      cdiv co vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv cbc co
      vj cv cfa cfv vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co
      vj cv cfa cfv cdiv vk cv vj cv bcval3 opreq1d vj cv cfa cfv cc wcel vj cv
      vk cv cmin co cfa cfv vk cv cfa cfv cmul co cc wcel vj cv vk cv cmin co
      cfa cfv vk cv cfa cfv cmul co cc0 wne wa vj cv cfa cfv cc wcel vj cv cfa
      cfv cc0 wne wa vj cv cfa cfv vj cv vk cv cmin co cfa cfv vk cv cfa cfv
      cmul co cdiv co vj cv cfa cfv cdiv co vj cv cfa cfv vj cv cfa cfv cdiv co
      vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co wceq vj cv cn0
      wcel vk cv cc0 vj cv cfz co wcel wa vj cv cfa cfv vj cv vk cv cmin co cfa
      cfv vk cv cfa cfv cmul co vj cv cfa cfv divdiv23 vj cv cn0 wcel vj cv cfa
      cfv cc wcel vk cv cc0 vj cv cfz co wcel vj cv cn0 wcel vj cv cfa cfv cn
      wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl adantr vj
      cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv cmin co cfa cfv vk
      cv cfa cfv cmul co cn wcel vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul
      co cc wcel vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cc0 wne wa
      vj cv vk cv cmin co cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv vk cv
      cmin co cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cc0 vj
      cv cfz co wcel wa vj cv vk cv cmin co cfa cfv vk cv cfa cfv nnmulcl vj cv
      cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv cmin co cn0 wcel vj
      cv vk cv cmin co cfa cfv cn wcel cn0 vk cv cc0 vj cv fznn0sub vj cv vk cv
      cmin co faccl syl vk cv cc0 vj cv cfz co wcel vk cv cfa cfv cn wcel vj cv
      cn0 wcel vk cv cc0 vj cv cfz co wcel vk cv cn0 wcel vk cv cfa cfv cn wcel
      vk cv vj cv elfznn0 vk cv faccl syl adantl sylanc vj cv vk cv cmin co cfa
      cfv vk cv cfa cfv cmul co cn wcel vj cv vk cv cmin co cfa cfv vk cv cfa
      cfv cmul co cc wcel vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cc0
      wne vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co nncn vj cv vk cv
      cmin co cfa cfv vk cv cfa cfv cmul co nnne0 jca syl vj cv cn0 wcel vj cv
      cfa cfv cc wcel vj cv cfa cfv cc0 wne wa vk cv cc0 vj cv cfz co wcel vj
      cv cn0 wcel vj cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vj cv cn0 wcel vj
      cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn
      syl vj cv facne0 jca adantr syl3anc vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa vj cv cfa cfv vj cv cfa cfv cdiv co c1 vj cv vk cv cmin co cfa
      cfv vk cv cfa cfv cmul co cdiv vj cv cn0 wcel vj cv cfa cfv vj cv cfa cfv
      cdiv co c1 wceq vk cv cc0 vj cv cfz co wcel vj cv cfa cfv cc wcel vj cv
      cfa cfv cc0 wne vj cv cfa cfv vj cv cfa cfv cdiv co c1 wceq vj cv cn0
      wcel vj cv cfa cfv divid vj cv cn0 wcel vj cv cfa cfv cn wcel vj cv cfa
      cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vj cv facne0 sylanc adantr
      opreq1d 3eqtrd opreq1d vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa c1
      cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co vj cv vk
      cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cA vj cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co vj cv vk cv cmin co cfa cfv vk cv cfa
      cfv cmul co cdiv co c1 vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co
      cdiv co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co
      vj vj cv vk cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv co csb cB vk
      cv cexp co vk cv cfa cfv cdiv co cmul co vj cv cn0 wcel vk cv cc0 vj cv
      cfz co wcel wa c1 cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co vj cv vk
      cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv vj cv cn0 wcel vk cv cc0 vj
      cv cfz co wcel wa cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cc wcel c1 cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul
      co cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co wceq cA vj cv
      vk cv cmin co cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv vk cv
      cmin co cexp co cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cc0
      vj cv cfz co wcel wa cA vj cv vk cv cmin co cexp co cB vk cv cexp co
      mulcl cA cc wcel vj cv vk cv cmin co cn0 wcel cA vj cv vk cv cmin co cexp
      co cc wcel vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa cA vj cv vk cv
      cmin co expcl efaddlem5.2 cn0 vk cv cc0 vj cv fznn0sub sylancr vk cv cc0
      vj cv cfz co wcel cB vk cv cexp co cc wcel vj cv cn0 wcel cB cc wcel vk
      cv cn0 wcel cB vk cv cexp co cc wcel vk cv cc0 vj cv cfz co wcel cB vk cv
      expcl efaddlem5.3 vk cv vj cv elfznn0 sylancr adantl sylanc cA vj cv vk
      cv cmin co cexp co cB vk cv cexp co cmul co mulid2 syl opreq1d cA vj cv
      vk cv cmin co cexp co cB vk cv cexp co cmul co cc wcel vj cv vk cv cmin
      co cfa cfv vk cv cfa cfv cmul co cc wcel vj cv vk cv cmin co cfa cfv vk
      cv cfa cfv cmul co cc0 wne wa c1 cA vj cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cmul co vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co
      cdiv co c1 vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cA
      vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co cmul co wceq vj cv
      cn0 wcel vk cv cc0 vj cv cfz co wcel wa c1 cc wcel cA vj cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co cc wcel vj cv vk cv cmin co cfa cfv vk
      cv cfa cfv cmul co cc wcel vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul
      co cc0 wne wa c1 cA vj cv vk cv cmin co cexp co cB vk cv cexp co cmul co
      cmul co vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co c1 vj
      cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cdiv co cA vj cv vk cv
      cmin co cexp co cB vk cv cexp co cmul co cmul co wceq ax1cn c1 cA vj cv
      vk cv cmin co cexp co cB vk cv cexp co cmul co vj cv vk cv cmin co cfa
      cfv vk cv cfa cfv cmul co div23 mp3an1 cA vj cv vk cv cmin co cexp co cc
      wcel cB vk cv cexp co cc wcel cA vj cv vk cv cmin co cexp co cB vk cv
      cexp co cmul co cc wcel vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa cA
      vj cv vk cv cmin co cexp co cB vk cv cexp co mulcl cA cc wcel vj cv vk cv
      cmin co cn0 wcel cA vj cv vk cv cmin co cexp co cc wcel vj cv cn0 wcel vk
      cv cc0 vj cv cfz co wcel wa cA vj cv vk cv cmin co expcl efaddlem5.2 cn0
      vk cv cc0 vj cv fznn0sub sylancr vk cv cc0 vj cv cfz co wcel cB vk cv
      cexp co cc wcel vj cv cn0 wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp co
      cc wcel vk cv cc0 vj cv cfz co wcel cB vk cv expcl efaddlem5.3 vk cv vj
      cv elfznn0 sylancr adantl sylanc vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cn wcel vj cv
      vk cv cmin co cfa cfv vk cv cfa cfv cmul co cc wcel vj cv vk cv cmin co
      cfa cfv vk cv cfa cfv cmul co cc0 wne wa vj cv vk cv cmin co cfa cfv cn
      wcel vk cv cfa cfv cn wcel vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul
      co cn wcel vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj cv vk cv cmin
      co cfa cfv vk cv cfa cfv nnmulcl vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa vj cv vk cv cmin co cn0 wcel vj cv vk cv cmin co cfa cfv cn wcel
      cn0 vk cv cc0 vj cv fznn0sub vj cv vk cv cmin co faccl syl vk cv cc0 vj
      cv cfz co wcel vk cv cfa cfv cn wcel vj cv cn0 wcel vk cv cc0 vj cv cfz
      co wcel vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv vj cv elfznn0 vk cv
      faccl syl adantl sylanc vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co
      cn wcel vj cv vk cv cmin co cfa cfv vk cv cfa cfv cmul co cc wcel vj cv
      vk cv cmin co cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv vk cv cmin co
      cfa cfv vk cv cfa cfv cmul co nncn vj cv vk cv cmin co cfa cfv vk cv cfa
      cfv cmul co nnne0 jca syl sylanc vj cv cn0 wcel vk cv cc0 vj cv cfz co
      wcel wa cA vj cv vk cv cmin co cexp co vj cv vk cv cmin co cfa cfv cdiv
      co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co cA vj cv vk cv cmin co
      cexp co cB vk cv cexp co cmul co vj cv vk cv cmin co cfa cfv vk cv cfa
      cfv cmul co cdiv co vj vj cv vk cv cmin co cA vj cv cexp co vj cv cfa cfv
      cdiv co csb cB vk cv cexp co vk cv cfa cfv cdiv co cmul co cA vj cv vk cv
      cmin co cexp co cc wcel cB vk cv cexp co cc wcel vj cv vk cv cmin co cfa
      cfv cc wcel vj cv vk cv cmin co cfa cfv cc0 wne wa vk cv cfa cfv cc wcel
      vk cv cfa cfv cc0 wne wa cA vj cv vk cv cmin co cexp co vj cv vk cv cmin
      co cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co cA vj
      cv vk cv cmin co cexp co cB vk cv cexp co cmul co vj cv vk cv cmin co cfa
      cfv vk cv cfa cfv cmul co cdiv co wceq vj cv cn0 wcel vk cv cc0 vj cv cfz
      co wcel wa cA vj cv vk cv cmin co cexp co cB vk cv cexp co vj cv vk cv
      cmin co cfa cfv vk cv cfa cfv divmuldiv cA cc wcel vj cv vk cv cmin co
      cn0 wcel cA vj cv vk cv cmin co cexp co cc wcel vj cv cn0 wcel vk cv cc0
      vj cv cfz co wcel wa cA vj cv vk cv cmin co expcl efaddlem5.2 cn0 vk cv
      cc0 vj cv fznn0sub sylancr vk cv cc0 vj cv cfz co wcel cB vk cv cexp co
      cc wcel vj cv cn0 wcel cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      vk cv cc0 vj cv cfz co wcel cB vk cv expcl efaddlem5.3 vk cv vj cv
      elfznn0 sylancr adantl vj cv cn0 wcel vk cv cc0 vj cv cfz co wcel wa vj
      cv vk cv cmin co cn0 wcel vj cv vk cv cmin co cfa cfv cc wcel vj cv vk cv
      cmin co cfa cfv cc0 wne wa cn0 vk cv cc0 vj cv fznn0sub vj cv vk cv cmin
      co cn0 wcel vj cv vk cv cmin co cfa cfv cc wcel vj cv vk cv cmin co cfa
      cfv cc0 wne vj cv vk cv cmin co cn0 wcel vj cv vk cv cmin co cfa cfv cn
      wcel vj cv vk cv cmin co cfa cfv cc wcel vj cv vk cv cmin co faccl vj cv
      vk cv cmin co cfa cfv nncn syl vj cv vk cv cmin co facne0 jca syl vk cv
      cc0 vj cv cfz co wcel vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne wa vj
      cv cn0 wcel vk cv cc0 vj cv cfz co wcel vk cv cn0 wcel vk cv cfa cfv cc
      wcel vk cv cfa cfv cc0 wne wa vk cv vj cv elfznn0 vk cv cn0 wcel vk cv
      cfa cfv cc wcel vk cv cfa cfv cc0 wne vk cv cn0 wcel vk cv cfa cfv cn
      wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl vk cv
      facne0 jca syl adantl syl2anc vj vj cv vk cv cmin co cA vj cv cexp co vj
      cv cfa cfv cdiv co csb cA vj cv vk cv cmin co cexp co vj cv vk cv cmin co
      cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul vj vj cv vk
      cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv co csb vj vj cv vk cv cmin
      co cA vj cv cexp co csb vj vj cv vk cv cmin co vj cv cfa cfv csb cdiv co
      cA vj cv vk cv cmin co cexp co vj cv vk cv cmin co cfa cfv cdiv co vj cv
      vk cv cmin co cvv wcel vj vj cv vk cv cmin co cA vj cv cexp co vj cv cfa
      cfv cdiv co csb vj vj cv vk cv cmin co cA vj cv cexp co csb vj vj cv vk
      cv cmin co vj cv cfa cfv csb cdiv co wceq vj cv vk cv cmin oprex vj vj cv
      vk cv cmin co cA vj cv cexp co vj cv cfa cfv cvv cdiv csbopr12g ax-mp vj
      vj cv vk cv cmin co cA vj cv cexp co csb cA vj cv vk cv cmin co cexp co
      vj vj cv vk cv cmin co vj cv cfa cfv csb vj cv vk cv cmin co cfa cfv cdiv
      vj vj cv vk cv cmin co cA vj cv cexp co csb cA vj vj cv vk cv cmin co vj
      cv csb cexp co cA vj cv vk cv cmin co cexp co vj cv vk cv cmin co cvv
      wcel vj vj cv vk cv cmin co cA vj cv cexp co csb cA vj vj cv vk cv cmin
      co vj cv csb cexp co wceq vj cv vk cv cmin oprex vj vj cv vk cv cmin co
      cA vj cv cvv cexp csbopr2g ax-mp vj vj cv vk cv cmin co vj cv csb vj cv
      vk cv cmin co cA cexp vj cv vk cv cmin co cvv wcel vj vj cv vk cv cmin co
      vj cv csb vj cv vk cv cmin co wceq vj cv vk cv cmin oprex vj vj cv vk cv
      cmin co cvv csbvarg ax-mp opreq2i eqtri vj vj cv vk cv cmin co vj cv cfa
      cfv csb vj vj cv vk cv cmin co vj cv csb cfa cfv vj cv vk cv cmin co cfa
      cfv vj cv vk cv cmin co cvv wcel vj vj cv vk cv cmin co vj cv cfa cfv csb
      vj vj cv vk cv cmin co vj cv csb cfa cfv wceq vj cv vk cv cmin oprex vj
      vj cv vk cv cmin co vj cv cvv cfa csbfv2g ax-mp vj vj cv vk cv cmin co vj
      cv csb vj cv vk cv cmin co cfa vj cv vk cv cmin co cvv wcel vj vj cv vk
      cv cmin co vj cv csb vj cv vk cv cmin co wceq vj cv vk cv cmin oprex vj
      vj cv vk cv cmin co cvv csbvarg ax-mp fveq2i eqtri opreq12i eqtri opreq1i
      syl5req 3eqtr3d 3eqtrd sumeq2dv 3eqtrd syl sumeq2i cN cn0 wcel cA vj cv
      cexp co vj cv cfa cfv cdiv co cc wcel vj cc0 cN cfz co wral cB vk cv cexp
      co vk cv cfa cfv cdiv co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cc0
      cN vj cv cmin co cfz co cA vj cv cexp co vj cv cfa cfv cdiv co cB vk cv
      cexp co vk cv cfa cfv cdiv co cmul co vk csu vj csu cc0 cN cfz co cc0 vj
      cv cfz co vj vj cv vk cv cmin co cA vj cv cexp co vj cv cfa cfv cdiv co
      csb cB vk cv cexp co vk cv cfa cfv cdiv co cmul co vk csu vj csu wceq cN
      efaddlem5.1 nnnn0i cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj cc0
      cN cfz co cA cc wcel vj cv cn0 wcel cA vj cv cexp co vj cv cfa cfv cdiv
      co cc wcel vj cv cc0 cN cfz co wcel cA vj cv eftcl efaddlem5.2 vj cv cN
      elfznn0 sylancr rgen cB vk cv cexp co vk cv cfa cfv cdiv co cc wcel vk
      cc0 cN cfz co cB cc wcel vk cv cn0 wcel cB vk cv cexp co vk cv cfa cfv
      cdiv co cc wcel vk cv cc0 cN cfz co wcel cB vk cv eftcl efaddlem5.3 vk cv
      cN elfznn0 sylancr rgen cA vj cv cexp co vj cv cfa cfv cdiv co cB vk cv
      cexp co vk cv cfa cfv cdiv co vj vk cN fsum0diag2 mp3an cc0 cN cfz co cc0
      cN vj cv cmin co cfz co cA vj cv cexp co vj cv cfa cfv cdiv co cB vk cv
      cexp co vk cv cfa cfv cdiv co cmul co vk csu cc0 cN vj cv cmin co cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj vj cv cc0 cN cfz co wcel cc0 cN vj cv cmin co
      cfz co cA vj cv cexp co vj cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa
      cfv cdiv co cmul co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk vj cv cn0 wcel vk cv cn0 wcel cA vj
      cv cexp co vj cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co
      cmul co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co wceq vj cv cc0 cN cfz co wcel vk cv cc0 cN vj cv cmin
      co cfz co wcel cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel wa vj cv
      cfa cfv cc wcel vj cv cfa cfv cc0 wne wa vk cv cfa cfv cc wcel vk cv cfa
      cfv cc0 wne wa wa cA vj cv cexp co vj cv cfa cfv cdiv co cB vk cv cexp co
      vk cv cfa cfv cdiv co cmul co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co wceq vj cv cn0 wcel vk cv cn0
      wcel wa cA vj cv cexp co cB vk cv cexp co vj cv cfa cfv vk cv cfa cfv
      divmuldiv vj cv cn0 wcel cA vj cv cexp co cc wcel vk cv cn0 wcel cB vk cv
      cexp co cc wcel cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem5.3 cB vk cv expcl mpan anim12i vj cv cn0 wcel vj cv
      cfa cfv cc wcel vj cv cfa cfv cc0 wne wa vk cv cn0 wcel vk cv cfa cfv cc
      wcel vk cv cfa cfv cc0 wne wa vj cv cn0 wcel vj cv cfa cfv cc wcel vj cv
      cfa cfv cc0 wne vj cv cn0 wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc
      wcel vj cv faccl vj cv cfa cfv nncn syl vj cv facne0 jca vk cv cn0 wcel
      vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne vk cv cn0 wcel vk cv cfa cfv
      cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl vk cv
      facne0 jca anim12i sylanc vj cv cN elfznn0 vk cv cN vj cv cmin co elfznn0
      syl2an sumeq2dv sumeq2i 3eqtr2i $.
      $( [14-Feb-2006] $) $( [3-Jan-2006] $)

    $( Lemma for ~ efaddi .  Compute the difference between the truncated
       series for ` ( exp `` A ) x. ( exp `` B ) ` and ` exp `` ( A + B ) ` .
       A main goal of the proof is to show that this difference goes to zero as
       ` N ` approaches infinity; this is finally accomplished in
       ~ efaddlem22 .  _Warning:  The HTML proof page is 0.6 megabyte in
       size_. $)
    efaddlem6 $p |- ( ( sum_ j e. ( 0 ... N ) ( ( A ^ j ) / ( ! ` j ) ) x.
                        sum_ k e. ( 0 ... N ) ( ( B ^ k ) / ( ! ` k ) ) ) -
                sum_ j e. ( 0 ... N ) ( ( ( A + B ) ^ j ) / ( ! ` j ) ) ) =
             sum_ j e. ( 1 ... N ) sum_ k e. ( ( ( N - j ) + 1 ) ... N )
               ( ( ( A ^ j ) x. ( B ^ k ) ) / ( ( ! ` j ) x. ( ! ` k ) ) ) $=
      cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co
      cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cc0 cN cfz co
      c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN
      cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co cc0 cN cfz co c1
      cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN
      cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co
      cmin co c1 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu c1 cN cfz co
      cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cmin co c1 cN cfz
      co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cc0
      cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co cB
      vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co c1 cB vk
      cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz co
      cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu vj csu caddc co cc0 cN cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co c1 cB
      vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz
      co cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co cmin
      cc0 cN cfz co cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co cB vk
      cv cexp co vk cv cfa cfv cdiv co cmul co vk csu vj csu cc0 cN cfz co cA
      vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp co
      vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co c1 cB vk cv cexp co
      cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz co cc0 cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu caddc co cN cc0 cuz cfv wcel cA vj cv cexp
      co vj cv cfa cfv cdiv co cc wcel vj cc0 cN cfz co wral wa cN cc0 cuz cfv
      wcel cB vk cv cexp co vk cv cfa cfv cdiv co cc wcel vk cc0 cN cfz co wral
      wa cc0 cN cfz co cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co cB
      vk cv cexp co vk cv cfa cfv cdiv co cmul co vk csu vj csu cc0 cN cfz co
      cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp
      co vk cv cfa cfv cdiv co vk csu cmul co wceq cN cc0 cuz cfv wcel cA vj cv
      cexp co vj cv cfa cfv cdiv co cc wcel vj cc0 cN cfz co wral cN cn0 cc0
      cuz cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri cA vj cv cexp co vj cv cfa
      cfv cdiv co cc wcel vj cc0 cN cfz co cA cc wcel vj cv cn0 wcel cA vj cv
      cexp co vj cv cfa cfv cdiv co cc wcel vj cv cc0 cN cfz co wcel cA vj cv
      eftcl efaddlem5.2 vj cv cN elfznn0 sylancr rgen pm3.2i cN cc0 cuz cfv
      wcel cB vk cv cexp co vk cv cfa cfv cdiv co cc wcel vk cc0 cN cfz co wral
      cN cn0 cc0 cuz cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri cB vk cv cexp co
      vk cv cfa cfv cdiv co cc wcel vk cc0 cN cfz co cB cc wcel vk cv cn0 wcel
      cB vk cv cexp co vk cv cfa cfv cdiv co cc wcel vk cv cc0 cN cfz co wcel
      cB vk cv eftcl efaddlem5.3 vk cv cN elfznn0 sylancr rgen pm3.2i cA vj cv
      cexp co vj cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co vj
      vk cc0 cN cc0 cN fsum2mul mp2an cc0 cN cfz co cc0 cN cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co
      vk csu vj csu cc0 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cc0
      cN cfz co c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk
      csu cc0 c1 caddc co cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu
      caddc co cc0 cN cfz co c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul
      co cdiv co vk csu c1 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu
      caddc co cc0 cN cfz co cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv
      co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co vk csu cc0 cN cfz co cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co vk csu vj vj cv cc0 cN cfz co wcel cc0 cN cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co vj cv
      cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co wceq vj cv cc0 cN cfz co wcel vk cv cc0 cN cfz co wcel cA vj cv cexp
      co cc wcel cB vk cv cexp co cc wcel wa vj cv cfa cfv cc wcel vj cv cfa
      cfv cc0 wne wa vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne wa wa cA vj cv
      cexp co vj cv cfa cfv cdiv co cB vk cv cexp co vk cv cfa cfv cdiv co cmul
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co wceq vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB
      vk cv cexp co vj cv cfa cfv vk cv cfa cfv divmuldiv vj cv cn0 wcel cA vj
      cv cexp co cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel cA cc wcel vj
      cv cn0 wcel cA vj cv cexp co cc wcel efaddlem5.2 cA vj cv expcl mpan cB
      cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem5.3 cB vk cv
      expcl mpan anim12i vj cv cn0 wcel vj cv cfa cfv cc wcel vj cv cfa cfv cc0
      wne wa vk cv cn0 wcel vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne wa vj
      cv cn0 wcel vj cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vj cv cn0 wcel vj
      cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn
      syl vj cv facne0 jca vk cv cn0 wcel vk cv cfa cfv cc wcel vk cv cfa cfv
      cc0 wne vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv
      faccl vk cv cfa cfv nncn syl vk cv facne0 jca anim12i sylanc vj cv cN
      elfznn0 vk cv cN elfznn0 syl2an sumeq2dv sumeq2i cN cc0 cuz cfv wcel cc0
      cN clt wbr cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj cc0 cN cfz co
      wral cc0 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cc0 cN cfz
      co c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu
      cc0 c1 caddc co cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc
      co wceq cN cn0 cc0 cuz cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri cN
      efaddlem5.1 nngt0i cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj cc0 cN
      cfz co vj cv cc0 cN cfz co wcel vj cv cn0 wcel cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk
      cc0 cN cfz co wral cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj cv cN
      elfznn0 vj cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cc0 cN cfz co vj cv cn0
      wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cv cc0 cN cfz co wcel cA vj
      cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp co cc
      wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co
      cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem5.2 cA
      vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv cc wcel vk cv cfa
      cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cn0 wcel vk
      cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0 wcel vj cv cfa
      cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk
      cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv
      cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv
      cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv cmul co cc0
      wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel vk cv cfa cfv cc0
      wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc wcel vk cv cfa cfv
      cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk
      cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv
      vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn wcel vj cv cfa cfv
      cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0 wcel vk cv cfa cfv
      cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl syl2an
      mpbid syl3anc vk cv cN elfznn0 sylan2 r19.21aiva cN cc0 cuz cfv wcel cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu cc wcel cN cn0 cc0 cuz cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk cc0 cN fsumcl mpan 3syl rgen cc0 cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      cc0 cN cfz co c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv
      co vk csu vj cc0 cN vj cv cc0 wceq cc0 cN cfz co cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co c1 cB vk
      cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk vj cv cc0 wceq cA
      vj cv cexp co cB vk cv cexp co cmul co c1 cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co c1 vk cv cfa cfv cmul co cdiv vj cv cc0
      wceq cA vj cv cexp co c1 cB vk cv cexp co cmul vj cv cc0 wceq cA vj cv
      cexp co cA cc0 cexp co c1 vj cv cc0 cA cexp opreq2 cA cc wcel cA cc0 cexp
      co c1 wceq efaddlem5.2 cA exp0 ax-mp syl6eq opreq1d vj cv cc0 wceq vj cv
      cfa cfv c1 vk cv cfa cfv cmul vj cv cc0 wceq vj cv cfa cfv cc0 cfa cfv c1
      vj cv cc0 cfa fveq2 fac0 syl6eq opreq1d opreq12d sumeq2sdv fsum1p mp3an
      cc0 c1 caddc co cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu c1 cN
      cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cc0 cN cfz co c1 cB vk cv
      cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu caddc cc0 c1
      caddc co cN cfz co c1 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj cc0
      c1 caddc co c1 cN cfz c1 ax1cn addid2i opreq1i sumeq1i opreq2i 3eqtri
      eqtr3i cc0 cN cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co
      vj csu cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj
      csu cc0 cN cc0 cmin co cfz co c1 cB vk cv cexp co cmul co c1 vk cv cfa
      cfv cmul co cdiv co vk csu cc0 c1 caddc co cN cfz co cc0 cN vj cv cmin co
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu vj csu caddc co cc0 cN cfz co c1 cB vk cv cexp
      co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz co cc0 cN vj
      cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv
      vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co cA cB vj vk cN
      efaddlem5.1 efaddlem5.2 efaddlem5.3 efaddlem5 cN cc0 cuz cfv wcel cc0 cN
      clt wbr cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj cc0
      cN cfz co wral cc0 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu vj csu cc0 cN cc0 cmin co cfz co c1 cB vk cv cexp co cmul co c1 vk cv
      cfa cfv cmul co cdiv co vk csu cc0 c1 caddc co cN cfz co cc0 cN vj cv
      cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu vj csu caddc co wceq cN cn0 cc0 cuz cfv
      cN efaddlem5.1 nnnn0i nn0uz eleqtri cN efaddlem5.1 nngt0i cc0 cN vj cv
      cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu cc wcel vj cc0 cN cfz co cN vj cv cmin
      co cc0 cuz cfv wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cc0 cN vj cv cmin co cfz co
      wral cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj cv cc0
      cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk cc0 cN vj cv cmin co fsumcl vj cv cc0 cN
      cfz co wcel cN vj cv cmin co cn0 cc0 cuz cfv cN cn wcel vj cv cc0 cN cfz
      co wcel cN vj cv cmin co cn0 wcel efaddlem5.1 cn vj cv cc0 cN fznn0sub
      mpan nn0uz syl6eleq vj cv cc0 cN cfz co wcel cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk
      cc0 cN vj cv cmin co cfz co vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      cc wcel vj cv cc0 cN cfz co wcel vk cv cc0 cN vj cv cmin co cfz co wcel
      cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa
      cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp
      co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co
      cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv
      cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv cc wcel
      vk cv cfa cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv
      cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0 wcel
      vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv
      nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv
      faccl vk cv cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj
      cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv
      cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel vk cv
      cfa cfv cc0 wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc wcel
      vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj
      cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0 wcel
      vj cv cfa cfv vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn wcel
      vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0 wcel
      vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv
      nncn syl syl2an mpbid syl3anc vj cv cN elfznn0 vk cv cN vj cv cmin co
      elfznn0 syl2an r19.21aiva sylanc rgen cc0 cN vj cv cmin co cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk csu cc0 cN cc0 cmin co cfz co c1 cB vk cv cexp co cmul co c1
      vk cv cfa cfv cmul co cdiv co vk csu vj cc0 cN vj cv cc0 wceq cc0 cN vj
      cv cmin co cfz co cc0 cN cc0 cmin co cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co c1 cB vk cv
      cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk vj cv cc0 wceq cN vj
      cv cmin co cN cc0 cmin co cc0 cfz vj cv cc0 cN cmin opreq2 opreq2d vj cv
      cc0 wceq cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul
      co cdiv co wceq vk cv cc0 cN vj cv cmin co cfz co wcel vj cv cc0 wceq cA
      vj cv cexp co cB vk cv cexp co cmul co c1 cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co c1 vk cv cfa cfv cmul co cdiv vj cv cc0
      wceq cA vj cv cexp co c1 cB vk cv cexp co cmul vj cv cc0 wceq cA vj cv
      cexp co cA cc0 cexp co c1 vj cv cc0 cA cexp opreq2 cA cc wcel cA cc0 cexp
      co c1 wceq efaddlem5.2 cA exp0 ax-mp syl6eq opreq1d vj cv cc0 wceq vj cv
      cfa cfv c1 vk cv cfa cfv cmul vj cv cc0 wceq vj cv cfa cfv cc0 cfa cfv c1
      vj cv cc0 cfa fveq2 fac0 syl6eq opreq1d opreq12d adantr sumeq12dv fsum1p
      mp3an cc0 cN cc0 cmin co cfz co c1 cB vk cv cexp co cmul co c1 vk cv cfa
      cfv cmul co cdiv co vk csu cc0 cN cfz co c1 cB vk cv cexp co cmul co c1
      vk cv cfa cfv cmul co cdiv co vk csu cc0 c1 caddc co cN cfz co cc0 cN vj
      cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv
      vk cv cfa cfv cmul co cdiv co vk csu vj csu c1 cN cfz co cc0 cN vj cv
      cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu vj csu caddc cc0 cN cc0 cmin co cfz co
      cc0 cN cfz co c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv
      co vk cN cc0 cmin co cN cc0 cfz cN cN efaddlem5.1 nncni subid1i opreq2i
      sumeq1i cc0 c1 caddc co cN cfz co c1 cN cfz co cc0 cN vj cv cmin co cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj cc0 c1 caddc co c1 cN cfz c1 ax1cn addid2i
      opreq1i sumeq1i opreq12i 3eqtri opreq12i cc0 cN cfz co c1 cB vk cv cexp
      co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu cc wcel c1 cN cfz co
      cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu vj csu cc wcel c1 cN cfz co cc0 cN vj
      cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv
      vk cv cfa cfv cmul co cdiv co vk csu vj csu cc wcel cc0 cN cfz co c1 cB
      vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz
      co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv
      vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co cc0 cN cfz co c1 cB
      vk cv cexp co cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz
      co cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co cmin
      co c1 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu c1 cN cfz co
      cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cmin co wceq cN
      cc0 cuz cfv wcel c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co
      cdiv co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co c1 cB vk cv cexp co
      cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu cc wcel cN cn0 cc0 cuz
      cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri c1 cB vk cv cexp co cmul co c1 vk
      cv cfa cfv cmul co cdiv co cc wcel vk cc0 cN cfz co vk cv cc0 cN cfz co
      wcel vk cv cn0 wcel c1 cB vk cv cexp co cmul co c1 vk cv cfa cfv cmul co
      cdiv co cc wcel vk cv cN elfznn0 vk cv cn0 wcel c1 cB vk cv cexp co cmul
      co c1 vk cv cfa cfv cmul co cdiv co c1 cB vk cv cexp co cmul co vk cv cfa
      cfv cdiv co cc vk cv cn0 wcel c1 vk cv cfa cfv cmul co vk cv cfa cfv c1
      cB vk cv cexp co cmul co cdiv vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv
      cfa cfv cc wcel c1 vk cv cfa cfv cmul co vk cv cfa cfv wceq vk cv faccl
      vk cv cfa cfv nncn vk cv cfa cfv mulid2 3syl opreq2d c1 cB vk cv cexp co
      cmul co cc wcel vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne c1 cB vk cv
      cexp co cmul co vk cv cfa cfv cdiv co cc wcel vk cv cn0 wcel c1 cB vk cv
      cexp co cmul co vk cv cfa cfv divcl c1 cc wcel cB vk cv cexp co cc wcel
      c1 cB vk cv cexp co cmul co cc wcel vk cv cn0 wcel c1 cB vk cv cexp co
      mulcl ax1cn cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      efaddlem5.3 cB vk cv expcl mpan sylancr vk cv cn0 wcel vk cv cfa cfv cn
      wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl vk cv
      facne0 syl3anc eqeltrd syl rgen c1 cB vk cv cexp co cmul co c1 vk cv cfa
      cfv cmul co cdiv co vk cc0 cN fsumcl mp2an cN c1 cuz cfv wcel cc0 cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu cc wcel vj c1 cN cfz co wral c1 cN cfz co cc0 cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu vj csu cc wcel cN cn c1 cuz cfv efaddlem5.1
      nnuz eleqtri cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj c1 cN cfz co
      cN cc0 cuz cfv wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cc0 cN cfz co wral cc0 cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk cc0 cN fsumcl cN cn0 cc0 cuz cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri
      vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cc0 cN cfz co vj cv cn0
      wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv
      cc0 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv
      cc wcel vk cv cfa cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel
      vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0
      wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa
      cfv nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel
      vk cv faccl vk cv cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel
      wa vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa
      cfv cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel
      vk cv cfa cfv cc0 wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc
      wcel vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa
      vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn
      wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0
      wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa
      cfv nncn syl syl2an mpbid syl3anc vj cv c1 cN cfz co wcel vj cv cn wcel
      vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl vk cv cN elfznn0 syl2an
      r19.21aiva sylancr rgen cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj c1 cN
      fsumcl mp2an cN c1 cuz cfv wcel cc0 cN vj cv cmin co cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu cc wcel vj c1 cN cfz co wral c1 cN cfz co cc0 cN vj cv cmin co cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu cc wcel cN cn c1 cuz cfv efaddlem5.1 nnuz
      eleqtri cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj c1
      cN cfz co cN vj cv cmin co cc0 cuz cfv wcel cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk
      cc0 cN vj cv cmin co cfz co wral cc0 cN vj cv cmin co cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cc0 cN vj cv
      cmin co fsumcl vj cv c1 cN cfz co wcel cN vj cv cmin co cn0 cc0 cuz cfv
      cN cn wcel vj cv c1 cN cfz co wcel cN vj cv cmin co cn0 wcel efaddlem5.1
      cn vj cv c1 cN fznn0sub mpan nn0uz syl6eleq vj cv c1 cN cfz co wcel cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co cc wcel vk cc0 cN vj cv cmin co cfz co vj cv cn0 wcel vk cv cn0
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cc0 cN vj cv
      cmin co cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv
      cc wcel vk cv cfa cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel
      vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0
      wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa
      cfv nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel
      vk cv faccl vk cv cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel
      wa vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa
      cfv cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel
      vk cv cfa cfv cc0 wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc
      wcel vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa
      vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn
      wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0
      wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa
      cfv nncn syl syl2an mpbid syl3anc vj cv c1 cN cfz co wcel vj cv cn wcel
      vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl vk cv cN vj cv cmin co
      elfznn0 syl2an r19.21aiva sylanc rgen cc0 cN vj cv cmin co cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk csu vj c1 cN fsumcl mp2an cc0 cN cfz co c1 cB vk cv cexp co
      cmul co c1 vk cv cfa cfv cmul co cdiv co vk csu c1 cN cfz co cc0 cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu c1 cN cfz co cc0 cN vj cv cmin co cfz co cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co vk csu vj csu pnpcan mp3an c1 cN cfz co cc0 cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu vj csu c1 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu vj csu c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk csu vj csu cN c1 cuz cfv wcel cc0 cN cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu cc wcel vj c1 cN cfz co wral c1 cN cfz co cc0 cN cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu vj csu cc wcel cN cn c1 cuz cfv efaddlem5.1 nnuz eleqtri cc0 cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu cc wcel vj c1 cN cfz co cN cc0 cuz cfv wcel cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cc0 cN fsumcl cN
      cn0 cc0 cuz cfv cN efaddlem5.1 nnnn0i nn0uz eleqtri vj cv c1 cN cfz co
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vk cc0 cN cfz co vj cv cn0 wcel vk cv cn0
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cc0 cN cfz co
      wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk
      cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv
      cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp
      co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk
      cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv cc wcel
      vk cv cfa cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv
      cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0 wcel
      vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv
      nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv
      faccl vk cv cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj
      cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv
      cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel vk cv
      cfa cfv cc0 wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc wcel
      vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj
      cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0 wcel
      vj cv cfa cfv vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn wcel
      vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0 wcel
      vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv
      nncn syl syl2an mpbid syl3anc vj cv c1 cN cfz co wcel vj cv cn wcel vj cv
      cn0 wcel vj cv cN elfznn vj cv nnnn0 syl vk cv cN elfznn0 syl2an
      r19.21aiva sylancr rgen cc0 cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj c1 cN
      fsumcl mp2an cN c1 cuz cfv wcel cc0 cN vj cv cmin co cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu cc wcel vj c1 cN cfz co wral c1 cN cfz co cc0 cN vj cv cmin co cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu cc wcel cN cn c1 cuz cfv efaddlem5.1 nnuz
      eleqtri cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj c1
      cN cfz co cN vj cv cmin co cc0 cuz cfv wcel cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk
      cc0 cN vj cv cmin co cfz co wral cc0 cN vj cv cmin co cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cc0 cN vj cv
      cmin co fsumcl vj cv c1 cN cfz co wcel cN vj cv cmin co cn0 cc0 cuz cfv
      cN cn wcel vj cv c1 cN cfz co wcel cN vj cv cmin co cn0 wcel efaddlem5.1
      cn vj cv c1 cN fznn0sub mpan nn0uz syl6eleq vj cv c1 cN cfz co wcel cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co cc wcel vk cc0 cN vj cv cmin co cfz co vj cv cn0 wcel vk cv cn0
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cc0 cN vj cv
      cmin co cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv
      cc wcel vk cv cfa cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel
      vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0
      wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa
      cfv nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel
      vk cv faccl vk cv cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel
      wa vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa
      cfv cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel
      vk cv cfa cfv cc0 wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc
      wcel vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa
      vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn
      wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0
      wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa
      cfv nncn syl syl2an mpbid syl3anc vj cv c1 cN cfz co wcel vj cv cn wcel
      vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl vk cv cN vj cv cmin co
      elfznn0 syl2an r19.21aiva sylanc rgen cc0 cN vj cv cmin co cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk csu vj c1 cN fsumcl mp2an cA cB vj vk cN efaddlem5.1
      efaddlem5.2 efaddlem5.3 efaddlem3 c1 cN cfz co cc0 cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu vj csu c1 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu caddc
      co vj csu c1 cN cfz co cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj
      csu c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu vj csu caddc co c1 cN cfz co cc0 cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc0 cN
      vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu caddc co vj vj cv c1 cN cfz co wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc0 cN
      vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu caddc co wceq vj cv c1 cN cfz co wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vk cc0 cN cfz co vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      cc wcel vj cv c1 cN cfz co wcel vk cv cc0 cN cfz co wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc
      wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj
      cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp co cc wcel cB vk
      cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co mulcl cA cc
      wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem5.2 cA vj cv expcl
      mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem5.3 cB vk
      cv expcl mpan syl2an vj cv cfa cfv cc wcel vk cv cfa cfv cc wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel vj cv
      cfa cfv vk cv cfa cfv mulcl vj cv cn0 wcel vj cv cfa cfv cn wcel vj cv
      cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0 wcel vk cv
      cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl
      syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv cc0 wne vk cv cfa
      cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv cn0 wcel
      vj cv cfa cfv cc0 wne vk cv cn0 wcel vk cv cfa cfv cc0 wne vj cv facne0
      vk cv facne0 anim12i vj cv cfa cfv cc wcel vk cv cfa cfv cc wcel vj cv
      cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne wb vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv
      muln0b vj cv cn0 wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv
      faccl vj cv cfa cfv nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv
      cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl syl2an mpbid syl3anc
      vj cv c1 cN cfz co wcel vj cv cn wcel vj cv cn0 wcel vj cv cN elfznn vj
      cv nnnn0 syl vk cv cN elfznn0 syl2an r19.21aiva cN cz wcel vj cv c1 cN
      cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vk cc0 cN cfz co wral cc0 cN cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk csu cc0 cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cN vj cv
      cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu caddc co wceq cN cn
      wcel cN cz wcel efaddlem5.1 cN nnz ax-mp cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk vj cv cN
      fsum0split mp3an1 mpdan sumeq2i cN c1 cuz cfv wcel cc0 cN vj cv cmin co
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu cc wcel cN vj cv cmin co c1 caddc co cN cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu cc wcel wa vj c1 cN cfz co wral c1 cN cfz co cc0
      cN vj cv cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cN vj cv cmin co c1 caddc co
      cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co vk csu caddc co vj csu c1 cN cfz co cc0 cN vj cv
      cmin co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu vj csu c1 cN cfz co cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu caddc co wceq cN cn c1
      cuz cfv efaddlem5.1 nnuz eleqtri cc0 cN vj cv cmin co cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cc wcel cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu cc wcel wa vj c1 cN cfz co vj cv c1 cN cfz co wcel cc0 cN vj cv cmin
      co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co vk csu cc wcel cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu cc wcel cN vj cv cmin co cc0 cuz cfv wcel cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co cc wcel vk cc0 cN vj cv cmin co cfz co wral cc0 cN vj cv cmin
      co cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk cc0 cN vj cv cmin co fsumcl vj cv c1 cN cfz co wcel cN vj cv cmin
      co cn0 cc0 cuz cfv cN cn wcel vj cv c1 cN cfz co wcel cN vj cv cmin co
      cn0 wcel efaddlem5.1 cn vj cv c1 cN fznn0sub mpan nn0uz syl6eleq vj cv c1
      cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co cc wcel vk cc0 cN vj cv cmin co cfz co vj cv
      cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk
      cv cc0 cN vj cv cmin co cfz co wcel cA vj cv cexp co cB vk cv cexp co
      cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv
      cn0 wcel wa cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel
      cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv
      cn0 wcel cA vj cv cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0
      wcel cA vj cv cexp co cc wcel efaddlem5.2 cA vj cv expcl mpan cB cc wcel
      vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem5.3 cB vk cv expcl mpan
      syl2an vj cv cfa cfv cc wcel vk cv cfa cfv cc wcel vj cv cfa cfv vk cv
      cfa cfv cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv
      cfa cfv mulcl vj cv cn0 wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel
      vj cv faccl vj cv cfa cfv nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel
      vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv nncn syl syl2an vj cv cn0
      wcel vk cv cn0 wcel wa vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj
      cv cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0
      wne vk cv cn0 wcel vk cv cfa cfv cc0 wne vj cv facne0 vk cv facne0
      anim12i vj cv cfa cfv cc wcel vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne
      vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb
      vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv muln0b vj cv
      cn0 wcel vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv
      cfa cfv nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc
      wcel vk cv faccl vk cv cfa cfv nncn syl syl2an mpbid syl3anc vj cv c1 cN
      cfz co wcel vj cv cn wcel vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl
      vk cv cN vj cv cmin co elfznn0 syl2an r19.21aiva sylanc cN cN vj cv cmin
      co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1
      caddc co cN cfz co wral cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cN vj cv cmin
      co c1 caddc co cN fsumcl vj cN efaddlem5.1 efaddlem1 vj cv c1 cN cfz co
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vk
      cv cn wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj vk cN efaddlem5.1 efaddlem2 vj cv cn0
      wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv
      cn wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj
      cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv
      cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB
      vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem5.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem5.3 cB vk cv expcl mpan syl2an vj cv cfa cfv cc wcel
      vk cv cfa cfv cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv
      cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv mulcl vj cv cn0 wcel
      vj cv cfa cfv cn wcel vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv
      nncn syl vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv
      faccl vk cv cfa cfv nncn syl syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj
      cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj cv cfa cfv vk cv cfa cfv
      cmul co cc0 wne vj cv cn0 wcel vj cv cfa cfv cc0 wne vk cv cn0 wcel vk cv
      cfa cfv cc0 wne vj cv facne0 vk cv facne0 anim12i vj cv cfa cfv cc wcel
      vk cv cfa cfv cc wcel vj cv cfa cfv cc0 wne vk cv cfa cfv cc0 wne wa vj
      cv cfa cfv vk cv cfa cfv cmul co cc0 wne wb vj cv cn0 wcel vk cv cn0 wcel
      vj cv cfa cfv vk cv cfa cfv muln0b vj cv cn0 wcel vj cv cfa cfv cn wcel
      vj cv cfa cfv cc wcel vj cv faccl vj cv cfa cfv nncn syl vk cv cn0 wcel
      vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl vk cv cfa cfv
      nncn syl syl2an mpbid syl3anc vj cv c1 cN cfz co wcel vj cv cn wcel vj cv
      cn0 wcel vj cv cN elfznn vj cv nnnn0 syl vk cv nnnn0 syl2an syldan
      r19.21aiva sylanc jca rgen cc0 cN vj cv cmin co cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj c1 cN
      fsumadd mp2an eqtr2i subaddrii 3eqtri $.
      $( [14-Feb-2006] $) $( [12-Jan-2006] $)
  $}

  ${
    efaddlem7.1 $e |- A e. CC $.
    efaddlem7.2 $e |- B e. CC $.
    efaddlem7.3 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                      ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    $( Lemma for ~ efaddi .  ` T ` is used to compute an upper bound for the
       numerator of the truncated series for ` exp `` ( A + B ) ` . $)
    efaddlem7 $p |- T e. NN $=
      cT cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul
      co c2 cexp co cn efaddlem7.3 cA cabs cfv c1 caddc co cfl cfv cB cabs cfv
      c1 caddc co cfl cfv cmul co cA cabs cfv c1 caddc co cfl cfv cn wcel cB
      cabs cfv c1 caddc co cfl cfv cn wcel cA cabs cfv c1 caddc co cfl cfv cB
      cabs cfv c1 caddc co cfl cfv cmul co cn wcel cA cabs cfv c1 caddc co cr
      wcel c1 cA cabs cfv c1 caddc co cle wbr cA cabs cfv c1 caddc co cfl cfv
      cn wcel cA cabs cfv c1 cA efaddlem7.1 abscli 1re readdcli cc0 cA cabs cfv
      cle wbr c1 cA cabs cfv c1 caddc co cle wbr cA efaddlem7.1 absge0i c1 cr
      wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr c1 cA cabs cfv c1 caddc
      co cle wbr wb 1re cA efaddlem7.1 abscli c1 cA cabs cfv addge02 mp2an mpbi
      cA cabs cfv c1 caddc co flge1nn mp2an cB cabs cfv c1 caddc co cr wcel c1
      cB cabs cfv c1 caddc co cle wbr cB cabs cfv c1 caddc co cfl cfv cn wcel
      cB cabs cfv c1 cB efaddlem7.2 abscli 1re readdcli cc0 cB cabs cfv cle wbr
      c1 cB cabs cfv c1 caddc co cle wbr cB efaddlem7.2 absge0i c1 cr wcel cB
      cabs cfv cr wcel cc0 cB cabs cfv cle wbr c1 cB cabs cfv c1 caddc co cle
      wbr wb 1re cB efaddlem7.2 abscli c1 cB cabs cfv addge02 mp2an mpbi cB
      cabs cfv c1 caddc co flge1nn mp2an cA cabs cfv c1 caddc co cfl cfv cB
      cabs cfv c1 caddc co cfl cfv nnmulcl mp2an nnsqcli eqeltri $.
      $( [14-Feb-2006] $) $( [5-Jan-2006] $)
  $}

  ${
    efaddlem8.1 $e |- N e. NN $.
    efaddlem8.2 $e |- S = ( |_ ` ( ( N + 1 ) / 2 ) ) $.
    $( Lemma for ~ efaddi . ` T ^ S ` is used to compute an upper bound for the
       numerator of the truncated series for ` exp `` ( A + B ) ` . $)
    efaddlem8 $p |- S e. NN $=
      cS cN c1 caddc co c2 cdiv co cfl cfv cn efaddlem8.2 cN c1 caddc co c2
      cdiv co cr wcel c1 cN c1 caddc co c2 cdiv co cle wbr cN c1 caddc co c2
      cdiv co cfl cfv cn wcel cN c1 caddc co c2 cN c1 cN efaddlem8.1 nnrei 1re
      readdcli 2re 2ne0 redivcli c1 cN c1 caddc co c2 cdiv co cle wbr c1 c2
      cmul co cN c1 caddc co c2 cdiv co c2 cmul co cle wbr c1 c1 caddc co cN c1
      caddc co c1 c2 cmul co cN c1 caddc co c2 cdiv co c2 cmul co cle c1 cN cle
      wbr c1 c1 caddc co cN c1 caddc co cle wbr cN cn wcel c1 cN cle wbr
      efaddlem8.1 cN nnge1 ax-mp c1 cN c1 1re cN efaddlem8.1 nnrei 1re leadd1i
      mpbi c1 c2 cmul co c2 c1 c1 caddc co c2 2cn mulid2i df-2 eqtri cN c1
      caddc co c2 cN c1 caddc co cN c1 cN efaddlem8.1 nnrei 1re readdcli recni
      2cn 2ne0 divcan1i 3brtr4i cc0 c2 clt wbr c1 cN c1 caddc co c2 cdiv co cle
      wbr c1 c2 cmul co cN c1 caddc co c2 cdiv co c2 cmul co cle wbr wb 2pos c1
      cN c1 caddc co c2 cdiv co c2 1re cN c1 caddc co c2 cN c1 cN efaddlem8.1
      nnrei 1re readdcli 2re 2ne0 redivcli 2re lemul1i ax-mp mpbir cN c1 caddc
      co c2 cdiv co flge1nn mp2an eqeltri $.
      $( [15-Feb-2006] $) $( [12-Jan-2006] $)
  $}

  ${
    efaddlem9.1 $e |- N e. NN $.
    $( Lemma for ~ efaddi .  Properties of the index range for the summation
       on the right-hand side of ~ efaddlem6 . $)
    efaddlem9 $p |- ( ( j e. ( 1 ... N ) /\ k e.
       ( ( ( N - j ) + 1 ) ... N ) ) -> ( ( j e. NN0 /\ j <_ N ) /\
                     ( k e. NN0 /\ k <_ N ) ) ) $=
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa vj cv cn0 wcel vj cv cN cle wbr wa vk cv cn0 wcel vk cv cN cle wbr vj
      cv c1 cN cfz co wcel vj cv cn0 wcel vj cv cN cle wbr wa vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel vj cv c1 cN cfz co wcel vj cv cn0 wcel
      vj cv cN cle wbr vj cv c1 cN cfz co wcel vj cv cn wcel vj cv cn0 wcel vj
      cv cN elfznn vj cv nnnn0 syl vj cv c1 cN elfzle2 jca adantr vj cv c1 cN
      cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn
      wcel vk cv cn0 wcel vj vk cN efaddlem9.1 efaddlem2 vk cv nnnn0 syl vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel vk cv cN cle wbr vj cv c1 cN
      cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN elfzle2 adantl jca32 $.
      $( [14-Feb-2006] $) $( [5-Jan-2006] $)
  $}

  ${
    efaddlem10.1 $e |- N e. NN $.
    efaddlem10.2 $e |- A e. CC $.
    $( Lemma for ~ efaddi .  Properties of ` A ` (or ` B ` ) in the summation
       terms on the right-hand side of ~ efaddlem6 . $)
    efaddlem10 $p |- ( ( j e. NN0 /\ j <_ N ) -> ( ( ( abs `
         ( A ^ j ) ) e. RR /\ ( ( |_ ` ( ( abs ` A ) + 1 ) ) ^ N ) e. RR )
        /\ ( 0 <_ ( abs ` ( A ^ j ) ) /\
       ( abs ` ( A ^ j ) ) <_ ( ( |_ ` ( ( abs ` A ) + 1 ) ) ^ N ) ) ) ) $=
      vj cv cn0 wcel vj cv cN cle wbr wa cA vj cv cexp co cabs cfv cr wcel cA
      cabs cfv c1 caddc co cfl cfv cN cexp co cr wcel wa cc0 cA vj cv cexp co
      cabs cfv cle wbr cA vj cv cexp co cabs cfv cA cabs cfv c1 caddc co cfl
      cfv cN cexp co cle wbr vj cv cn0 wcel cA vj cv cexp co cabs cfv cr wcel
      cA cabs cfv c1 caddc co cfl cfv cN cexp co cr wcel wa vj cv cN cle wbr vj
      cv cn0 wcel cA vj cv cexp co cabs cfv cr wcel cA cabs cfv c1 caddc co cfl
      cfv cN cexp co cr wcel vj cv cn0 wcel cA vj cv cexp co cc wcel cA vj cv
      cexp co cabs cfv cr wcel cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc
      wcel efaddlem10.2 cA vj cv expcl mpan cA vj cv cexp co abscl syl cA cabs
      cfv c1 caddc co cfl cfv cr wcel cN cn0 wcel cA cabs cfv c1 caddc co cfl
      cfv cN cexp co cr wcel cA cabs cfv c1 caddc co cr wcel cA cabs cfv c1
      caddc co cfl cfv cr wcel cA cabs cfv c1 cA efaddlem10.2 abscli 1re
      readdcli cA cabs cfv c1 caddc co reflcl ax-mp cN efaddlem10.1 nnnn0i cA
      cabs cfv c1 caddc co cfl cfv cN reexpcl mp2an jctir adantr vj cv cn0 wcel
      cc0 cA vj cv cexp co cabs cfv cle wbr vj cv cN cle wbr vj cv cn0 wcel cA
      vj cv cexp co cc wcel cc0 cA vj cv cexp co cabs cfv cle wbr cA cc wcel vj
      cv cn0 wcel cA vj cv cexp co cc wcel efaddlem10.2 cA vj cv expcl mpan cA
      vj cv cexp co absge0 syl adantr vj cv cn0 wcel vj cv cN cle wbr wa cA vj
      cv cexp co cabs cfv cA cabs cfv vj cv cexp co cA cabs cfv c1 caddc co cfl
      cfv cN cexp co cle vj cv cn0 wcel cA vj cv cexp co cabs cfv cA cabs cfv
      vj cv cexp co wceq vj cv cN cle wbr cA cc wcel vj cv cn0 wcel cA vj cv
      cexp co cabs cfv cA cabs cfv vj cv cexp co wceq efaddlem10.2 cA vj cv
      absexp mpan adantr vj cv cn0 wcel vj cv cN cle wbr wa cA cabs cfv vj cv
      cexp co cA cabs cfv c1 caddc co cfl cfv vj cv cexp co cA cabs cfv c1
      caddc co cfl cfv cN cexp co vj cv cn0 wcel cA cabs cfv vj cv cexp co cr
      wcel vj cv cN cle wbr cA cabs cfv cr wcel vj cv cn0 wcel cA cabs cfv vj
      cv cexp co cr wcel cA efaddlem10.2 abscli cA cabs cfv vj cv reexpcl mpan
      adantr vj cv cn0 wcel cA cabs cfv c1 caddc co cfl cfv vj cv cexp co cr
      wcel vj cv cN cle wbr cA cabs cfv c1 caddc co cfl cfv cr wcel vj cv cn0
      wcel cA cabs cfv c1 caddc co cfl cfv vj cv cexp co cr wcel cA cabs cfv c1
      caddc co cr wcel cA cabs cfv c1 caddc co cfl cfv cr wcel cA cabs cfv c1
      cA efaddlem10.2 abscli 1re readdcli cA cabs cfv c1 caddc co reflcl ax-mp
      cA cabs cfv c1 caddc co cfl cfv vj cv reexpcl mpan adantr cA cabs cfv c1
      caddc co cfl cfv cN cexp co cr wcel vj cv cn0 wcel vj cv cN cle wbr wa cA
      cabs cfv c1 caddc co cfl cfv cr wcel cN cn0 wcel cA cabs cfv c1 caddc co
      cfl cfv cN cexp co cr wcel cA cabs cfv c1 caddc co cr wcel cA cabs cfv c1
      caddc co cfl cfv cr wcel cA cabs cfv c1 cA efaddlem10.2 abscli 1re
      readdcli cA cabs cfv c1 caddc co reflcl ax-mp cN efaddlem10.1 nnnn0i cA
      cabs cfv c1 caddc co cfl cfv cN reexpcl mp2an a1i vj cv cn0 wcel cA cabs
      cfv vj cv cexp co cA cabs cfv c1 caddc co cfl cfv vj cv cexp co cle wbr
      vj cv cN cle wbr cA cabs cfv cr wcel cA cabs cfv c1 caddc co cfl cfv cr
      wcel vj cv cn0 wcel w3a cc0 cA cabs cfv cle wbr cA cabs cfv cA cabs cfv
      c1 caddc co cfl cfv cle wbr wa cA cabs cfv vj cv cexp co cA cabs cfv c1
      caddc co cfl cfv vj cv cexp co cle wbr vj cv cn0 wcel cA cabs cfv cA cabs
      cfv c1 caddc co cfl cfv vj cv expmwordi vj cv cn0 wcel cA cabs cfv cr
      wcel cA cabs cfv c1 caddc co cfl cfv cr wcel vj cv cn0 wcel cA cabs cfv
      cr wcel vj cv cn0 wcel cA efaddlem10.2 abscli a1i cA cabs cfv c1 caddc co
      cfl cfv cr wcel vj cv cn0 wcel cA cabs cfv c1 caddc co cr wcel cA cabs
      cfv c1 caddc co cfl cfv cr wcel cA cabs cfv c1 cA efaddlem10.2 abscli 1re
      readdcli cA cabs cfv c1 caddc co reflcl ax-mp a1i vj cv cn0 wcel id 3jca
      cc0 cA cabs cfv cle wbr cA cabs cfv cA cabs cfv c1 caddc co cfl cfv cle
      wbr cA efaddlem10.2 absge0i cA cabs cfv cA cabs cfv cfl cfv c1 caddc co
      cA cabs cfv c1 caddc co cfl cfv cle cA cabs cfv cA cabs cfv cfl cfv c1
      caddc co cA efaddlem10.2 abscli cA cabs cfv cfl cfv c1 cA cabs cfv cr
      wcel cA cabs cfv cfl cfv cr wcel cA efaddlem10.2 abscli cA cabs cfv
      reflcl ax-mp 1re readdcli cA cabs cfv cr wcel cA cabs cfv cA cabs cfv cfl
      cfv c1 caddc co clt wbr cA efaddlem10.2 abscli cA cabs cfv flltp1 ax-mp
      ltleii cA cabs cfv cr wcel c1 cz wcel cA cabs cfv c1 caddc co cfl cfv cA
      cabs cfv cfl cfv c1 caddc co wceq cA efaddlem10.2 abscli 1z cA cabs cfv
      c1 fladdz mp2an breqtrri pm3.2i sylancl adantr cA cabs cfv c1 caddc co
      cfl cfv cr wcel vj cv cn0 wcel wa c1 cA cabs cfv c1 caddc co cfl cfv cle
      wbr vj cv cN cle wbr wa cA cabs cfv c1 caddc co cfl cfv vj cv cexp co cA
      cabs cfv c1 caddc co cfl cfv cN cexp co cle wbr vj cv cn0 wcel vj cv cN
      cle wbr wa cA cabs cfv c1 caddc co cfl cfv cr wcel vj cv cn0 wcel cN cn0
      wcel c1 cA cabs cfv c1 caddc co cfl cfv cle wbr vj cv cN cle wbr wa cA
      cabs cfv c1 caddc co cfl cfv vj cv cexp co cA cabs cfv c1 caddc co cfl
      cfv cN cexp co cle wbr cN efaddlem10.1 nnnn0i cA cabs cfv c1 caddc co cfl
      cfv vj cv cN expwordi mp3anl3 vj cv cn0 wcel vj cv cN cle wbr wa vj cv
      cn0 wcel cA cabs cfv c1 caddc co cfl cfv cr wcel vj cv cn0 wcel vj cv cN
      cle wbr pm3.26 cA cabs cfv c1 caddc co cr wcel cA cabs cfv c1 caddc co
      cfl cfv cr wcel cA cabs cfv c1 cA efaddlem10.2 abscli 1re readdcli cA
      cabs cfv c1 caddc co reflcl ax-mp jctil vj cv cn0 wcel vj cv cN cle wbr
      wa vj cv cN cle wbr c1 cA cabs cfv c1 caddc co cfl cfv cle wbr vj cv cn0
      wcel vj cv cN cle wbr pm3.27 c1 cA cabs cfv c1 caddc co cle wbr c1 cA
      cabs cfv c1 caddc co cfl cfv cle wbr cc0 cA cabs cfv cle wbr c1 cA cabs
      cfv c1 caddc co cle wbr cA efaddlem10.2 absge0i c1 cr wcel cA cabs cfv cr
      wcel cc0 cA cabs cfv cle wbr c1 cA cabs cfv c1 caddc co cle wbr wb 1re cA
      efaddlem10.2 abscli c1 cA cabs cfv addge02 mp2an mpbi cA cabs cfv c1
      caddc co cr wcel c1 cz wcel c1 cA cabs cfv c1 caddc co cle wbr c1 cA cabs
      cfv c1 caddc co cfl cfv cle wbr wb cA cabs cfv c1 cA efaddlem10.2 abscli
      1re readdcli 1z cA cabs cfv c1 caddc co c1 flge mp2an mpbi jctil sylanc
      letrd eqbrtrd jca32 $.
      $( [15-Feb-2006] $) $( [5-Jan-2006] $)
  $}

  ${
    efaddlem11.1 $e |- N e. NN $.
    efaddlem11.2 $e |- A e. CC $.
    efaddlem11.3 $e |- B e. CC $.
    $( Lemma for ~ efaddi .  An upper bound for the numerator of the summation
       terms on the right-hand side of ~ efaddlem6 . $)
    efaddlem11 $p |- ( ( j e. ( 1 ... N ) /\
  k e. ( ( ( N - j ) + 1 ) ... N ) ) -> ( abs ` ( ( A ^ j ) x. ( B ^ k ) ) ) <_
         ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) ^ N )
              x. ( ( |_ ` ( ( abs ` B ) + 1 ) ) ^ N ) ) ) $=
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa vj cv cn0 wcel vj cv cN cle wbr wa vk cv cn0 wcel vk cv cN cle wbr wa
      wa cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cA cabs cfv c1
      caddc co cfl cfv cN cexp co cB cabs cfv c1 caddc co cfl cfv cN cexp co
      cmul co cle wbr vj vk cN efaddlem11.1 efaddlem9 vj cv cn0 wcel vj cv cN
      cle wbr wa vk cv cn0 wcel vk cv cN cle wbr wa wa cA vj cv cexp co cB vk
      cv cexp co cmul co cabs cfv cA vj cv cexp co cabs cfv cB vk cv cexp co
      cabs cfv cmul co cA cabs cfv c1 caddc co cfl cfv cN cexp co cB cabs cfv
      c1 caddc co cfl cfv cN cexp co cmul co cle vj cv cn0 wcel vk cv cn0 wcel
      cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cA vj cv cexp co cabs
      cfv cB vk cv cexp co cabs cfv cmul co wceq vj cv cN cle wbr vk cv cN cle
      wbr cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB
      vk cv cexp co cmul co cabs cfv cA vj cv cexp co cabs cfv cB vk cv cexp co
      cabs cfv cmul co wceq vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB
      vk cv cexp co absmul cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem11.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem11.3 cB vk cv expcl mpan syl2an ad2ant2r cA vj cv cexp
      co cabs cfv cr wcel cA cabs cfv c1 caddc co cfl cfv cN cexp co cr wcel wa
      cc0 cA vj cv cexp co cabs cfv cle wbr cA vj cv cexp co cabs cfv cA cabs
      cfv c1 caddc co cfl cfv cN cexp co cle wbr wa wa cB vk cv cexp co cabs
      cfv cr wcel cB cabs cfv c1 caddc co cfl cfv cN cexp co cr wcel wa cc0 cB
      vk cv cexp co cabs cfv cle wbr cB vk cv cexp co cabs cfv cB cabs cfv c1
      caddc co cfl cfv cN cexp co cle wbr wa wa cA vj cv cexp co cabs cfv cB vk
      cv cexp co cabs cfv cmul co cA cabs cfv c1 caddc co cfl cfv cN cexp co cB
      cabs cfv c1 caddc co cfl cfv cN cexp co cmul co cle wbr vj cv cn0 wcel vj
      cv cN cle wbr wa vk cv cn0 wcel vk cv cN cle wbr wa cA vj cv cexp co cabs
      cfv cA cabs cfv c1 caddc co cfl cfv cN cexp co cB vk cv cexp co cabs cfv
      cB cabs cfv c1 caddc co cfl cfv cN cexp co lemul12aOLD cA vj cN
      efaddlem11.1 efaddlem11.2 efaddlem10 cB vk cN efaddlem11.1 efaddlem11.3
      efaddlem10 syl2an eqbrtrd syl $.
      $( [15-Feb-2006] $) $( [5-Jan-2006] $)
  $}

  ${
    efaddlem12.1 $e |- N e. NN $.
    efaddlem12.2 $e |- A e. CC $.
    efaddlem12.3 $e |- B e. CC $.
    efaddlem12.4 $e |- S = ( |_ ` ( ( N + 1 ) / 2 ) ) $.
    efaddlem12.5 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                      ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    $( Lemma for ~ efaddi .  Further upper bound for the numerator of the
       summation terms on the right-hand side of ~ efaddlem6 . $)
    efaddlem12 $p |- ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) ^ N )
                x. ( ( |_ ` ( ( abs ` B ) + 1 ) ) ^ N ) ) <_ ( T ^ S ) $=
      cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co
      cN cexp co cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl
      cfv cmul co c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co cexp co cA cabs
      cfv c1 caddc co cfl cfv cN cexp co cB cabs cfv c1 caddc co cfl cfv cN
      cexp co cmul co cT cS cexp co cle cA cabs cfv c1 caddc co cfl cfv cB cabs
      cfv c1 caddc co cfl cfv cmul co cr wcel cN cn0 wcel c2 cN c1 caddc co c2
      cdiv co cfl cfv cmul co cn0 wcel w3a c1 cA cabs cfv c1 caddc co cfl cfv
      cB cabs cfv c1 caddc co cfl cfv cmul co cle wbr cN c2 cN c1 caddc co c2
      cdiv co cfl cfv cmul co cle wbr wa cA cabs cfv c1 caddc co cfl cfv cB
      cabs cfv c1 caddc co cfl cfv cmul co cN cexp co cA cabs cfv c1 caddc co
      cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co c2 cN c1 caddc co c2 cdiv
      co cfl cfv cmul co cexp co cle wbr cA cabs cfv c1 caddc co cfl cfv cB
      cabs cfv c1 caddc co cfl cfv cmul co cr wcel cN cn0 wcel c2 cN c1 caddc
      co c2 cdiv co cfl cfv cmul co cn0 wcel cA cabs cfv c1 caddc co cfl cfv cB
      cabs cfv c1 caddc co cfl cfv cA cabs cfv c1 caddc co cr wcel cA cabs cfv
      c1 caddc co cfl cfv cr wcel cA cabs cfv c1 cA efaddlem12.2 abscli 1re
      readdcli cA cabs cfv c1 caddc co reflcl ax-mp cB cabs cfv c1 caddc co cr
      wcel cB cabs cfv c1 caddc co cfl cfv cr wcel cB cabs cfv c1 cB
      efaddlem12.3 abscli 1re readdcli cB cabs cfv c1 caddc co reflcl ax-mp
      remulcli cN efaddlem12.1 nnnn0i c2 cN c1 caddc co c2 cdiv co cfl cfv 2nn0
      cN c1 caddc co c2 cdiv co cr wcel cc0 cN c1 caddc co c2 cdiv co cle wbr
      cN c1 caddc co c2 cdiv co cfl cfv cn0 wcel cN c1 caddc co c2 cN c1 cN
      efaddlem12.1 nnrei 1re readdcli 2re 2ne0 redivcli cc0 cN c1 caddc co c2
      cdiv co cle wbr cc0 c2 cmul co cN c1 caddc co c2 cdiv co c2 cmul co cle
      wbr cc0 cN c1 caddc co cc0 c2 cmul co cN c1 caddc co c2 cdiv co c2 cmul
      co cle cc0 cr wcel cN cr wcel cc0 cN cle wbr cc0 cN c1 caddc co cle wbr
      0re cN efaddlem12.1 nnrei cN cN efaddlem12.1 nnnn0i nn0ge0i cc0 cN letrp1
      mp3an c2 2cn mul02i cN c1 caddc co c2 cN c1 caddc co cN c1 cN
      efaddlem12.1 nnrei 1re readdcli recni 2cn 2ne0 divcan1i 3brtr4i cc0 c2
      clt wbr cc0 cN c1 caddc co c2 cdiv co cle wbr cc0 c2 cmul co cN c1 caddc
      co c2 cdiv co c2 cmul co cle wbr wb 2pos cc0 cN c1 caddc co c2 cdiv co c2
      0re cN c1 caddc co c2 cN c1 cN efaddlem12.1 nnrei 1re readdcli 2re 2ne0
      redivcli 2re lemul1i ax-mp mpbir cN c1 caddc co c2 cdiv co flge0nn0 mp2an
      nn0mulcli 3pm3.2i c1 cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc
      co cfl cfv cmul co cle wbr cN c2 cN c1 caddc co c2 cdiv co cfl cfv cmul
      co cle wbr cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl
      cfv cmul co cn wcel c1 cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1
      caddc co cfl cfv cmul co cle wbr cA cabs cfv c1 caddc co cfl cfv cn wcel
      cB cabs cfv c1 caddc co cfl cfv cn wcel cA cabs cfv c1 caddc co cfl cfv
      cB cabs cfv c1 caddc co cfl cfv cmul co cn wcel cA cabs cfv c1 caddc co
      cfl cfv cn wcel cA cabs cfv c1 caddc co cfl cfv cz wcel c1 cA cabs cfv c1
      caddc co cfl cfv cle wbr cA cabs cfv c1 caddc co cfl cfv elnnz1 cA cabs
      cfv c1 caddc co cr wcel cA cabs cfv c1 caddc co cfl cfv cz wcel cA cabs
      cfv c1 cA efaddlem12.2 abscli 1re readdcli cA cabs cfv c1 caddc co flcl
      ax-mp c1 cA cabs cfv c1 caddc co cle wbr c1 cA cabs cfv c1 caddc co cfl
      cfv cle wbr cc0 cA cabs cfv cle wbr c1 cA cabs cfv c1 caddc co cle wbr cA
      efaddlem12.2 absge0i c1 cr wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle
      wbr c1 cA cabs cfv c1 caddc co cle wbr wb 1re cA efaddlem12.2 abscli c1
      cA cabs cfv addge02 mp2an mpbi cA cabs cfv c1 caddc co cr wcel c1 cz wcel
      c1 cA cabs cfv c1 caddc co cle wbr c1 cA cabs cfv c1 caddc co cfl cfv cle
      wbr wb cA cabs cfv c1 cA efaddlem12.2 abscli 1re readdcli 1z cA cabs cfv
      c1 caddc co c1 flge mp2an mpbi mpbir2an cB cabs cfv c1 caddc co cfl cfv
      cn wcel cB cabs cfv c1 caddc co cfl cfv cz wcel c1 cB cabs cfv c1 caddc
      co cfl cfv cle wbr cB cabs cfv c1 caddc co cfl cfv elnnz1 cB cabs cfv c1
      caddc co cr wcel cB cabs cfv c1 caddc co cfl cfv cz wcel cB cabs cfv c1
      cB efaddlem12.3 abscli 1re readdcli cB cabs cfv c1 caddc co flcl ax-mp c1
      cB cabs cfv c1 caddc co cle wbr c1 cB cabs cfv c1 caddc co cfl cfv cle
      wbr cc0 cB cabs cfv cle wbr c1 cB cabs cfv c1 caddc co cle wbr cB
      efaddlem12.3 absge0i c1 cr wcel cB cabs cfv cr wcel cc0 cB cabs cfv cle
      wbr c1 cB cabs cfv c1 caddc co cle wbr wb 1re cB efaddlem12.3 abscli c1
      cB cabs cfv addge02 mp2an mpbi cB cabs cfv c1 caddc co cr wcel c1 cz wcel
      c1 cB cabs cfv c1 caddc co cle wbr c1 cB cabs cfv c1 caddc co cfl cfv cle
      wbr wb cB cabs cfv c1 cB efaddlem12.3 abscli 1re readdcli 1z cB cabs cfv
      c1 caddc co c1 flge mp2an mpbi mpbir2an cA cabs cfv c1 caddc co cfl cfv
      cB cabs cfv c1 caddc co cfl cfv nnmulcl mp2an cA cabs cfv c1 caddc co cfl
      cfv cB cabs cfv c1 caddc co cfl cfv cmul co nnge1 ax-mp cN cz wcel cN c2
      cN c1 caddc co c2 cdiv co cfl cfv cmul co cle wbr cN cn wcel cN cz wcel
      efaddlem12.1 cN nnz ax-mp cN flhalf ax-mp pm3.2i cA cabs cfv c1 caddc co
      cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co cN c2 cN c1 caddc co c2
      cdiv co cfl cfv cmul co expwordi mp2an cA cabs cfv c1 caddc co cfl cfv cc
      wcel cB cabs cfv c1 caddc co cfl cfv cc wcel cN cn0 wcel cA cabs cfv c1
      caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co cN cexp co cA
      cabs cfv c1 caddc co cfl cfv cN cexp co cB cabs cfv c1 caddc co cfl cfv
      cN cexp co cmul co wceq cA cabs cfv c1 caddc co cfl cfv cA cabs cfv c1
      caddc co cr wcel cA cabs cfv c1 caddc co cfl cfv cr wcel cA cabs cfv c1
      cA efaddlem12.2 abscli 1re readdcli cA cabs cfv c1 caddc co reflcl ax-mp
      recni cB cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cr wcel cB
      cabs cfv c1 caddc co cfl cfv cr wcel cB cabs cfv c1 cB efaddlem12.3
      abscli 1re readdcli cB cabs cfv c1 caddc co reflcl ax-mp recni cN
      efaddlem12.1 nnnn0i cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc
      co cfl cfv cN mulexp mp3an cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1
      caddc co cfl cfv cmul co c2 cN c1 caddc co c2 cdiv co cfl cfv cmul co
      cexp co cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv
      cmul co c2 cexp co cN c1 caddc co c2 cdiv co cfl cfv cexp co cT cS cexp
      co cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul
      co cc wcel c2 cn0 wcel cN c1 caddc co c2 cdiv co cfl cfv cn0 wcel cA cabs
      cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co c2 cN c1
      caddc co c2 cdiv co cfl cfv cmul co cexp co cA cabs cfv c1 caddc co cfl
      cfv cB cabs cfv c1 caddc co cfl cfv cmul co c2 cexp co cN c1 caddc co c2
      cdiv co cfl cfv cexp co wceq cA cabs cfv c1 caddc co cfl cfv cB cabs cfv
      c1 caddc co cfl cfv cmul co cA cabs cfv c1 caddc co cfl cfv cB cabs cfv
      c1 caddc co cfl cfv cA cabs cfv c1 caddc co cr wcel cA cabs cfv c1 caddc
      co cfl cfv cr wcel cA cabs cfv c1 cA efaddlem12.2 abscli 1re readdcli cA
      cabs cfv c1 caddc co reflcl ax-mp cB cabs cfv c1 caddc co cr wcel cB cabs
      cfv c1 caddc co cfl cfv cr wcel cB cabs cfv c1 cB efaddlem12.3 abscli 1re
      readdcli cB cabs cfv c1 caddc co reflcl ax-mp remulcli recni 2nn0 cN c1
      caddc co c2 cdiv co cr wcel cc0 cN c1 caddc co c2 cdiv co cle wbr cN c1
      caddc co c2 cdiv co cfl cfv cn0 wcel cN c1 caddc co c2 cN c1 cN
      efaddlem12.1 nnrei 1re readdcli 2re 2ne0 redivcli cc0 cN c1 caddc co c2
      cdiv co cle wbr cc0 c2 cmul co cN c1 caddc co c2 cdiv co c2 cmul co cle
      wbr cc0 cN c1 caddc co cc0 c2 cmul co cN c1 caddc co c2 cdiv co c2 cmul
      co cle cc0 cr wcel cN cr wcel cc0 cN cle wbr cc0 cN c1 caddc co cle wbr
      0re cN efaddlem12.1 nnrei cN cN efaddlem12.1 nnnn0i nn0ge0i cc0 cN letrp1
      mp3an c2 2cn mul02i cN c1 caddc co c2 cN c1 caddc co cN c1 cN
      efaddlem12.1 nnrei 1re readdcli recni 2cn 2ne0 divcan1i 3brtr4i cc0 c2
      clt wbr cc0 cN c1 caddc co c2 cdiv co cle wbr cc0 c2 cmul co cN c1 caddc
      co c2 cdiv co c2 cmul co cle wbr wb 2pos cc0 cN c1 caddc co c2 cdiv co c2
      0re cN c1 caddc co c2 cN c1 cN efaddlem12.1 nnrei 1re readdcli 2re 2ne0
      redivcli 2re lemul1i ax-mp mpbir cN c1 caddc co c2 cdiv co flge0nn0 mp2an
      cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co
      c2 cN c1 caddc co c2 cdiv co cfl cfv expmul mp3an cT cA cabs cfv c1 caddc
      co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co c2 cexp co cS cN c1
      caddc co c2 cdiv co cfl cfv cexp efaddlem12.5 efaddlem12.4 opreq12i
      eqtr4i 3brtr3i $.
      $( [14-Feb-2006] $) $( [4-Jan-2006] $)

    $( Lemma for ~ efaddi .  Combine the bounds of ~ efaddlem11 and
       ~ efaddlem12 . $)
    efaddlem13 $p |- ( ( j e. ( 1 ... N ) /\
                     k e. ( ( ( N - j ) + 1 ) ... N ) ) ->
                     ( abs ` ( ( A ^ j ) x. ( B ^ k ) ) ) <_ ( T ^ S ) ) $=
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cA cabs cfv c1
      caddc co cfl cfv cN cexp co cB cabs cfv c1 caddc co cfl cfv cN cexp co
      cmul co cT cS cexp co vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv cn0 wcel vj cv cN cle wbr wa vk cv cn0
      wcel vk cv cN cle wbr wa wa cA vj cv cexp co cB vk cv cexp co cmul co cc
      wcel cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cr wcel vj vk cN
      efaddlem12.1 efaddlem9 vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB
      vk cv cexp co cmul co cc wcel vj cv cN cle wbr vk cv cN cle wbr cA vj cv
      cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp
      co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk
      cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem12.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem12.3 cB vk cv expcl mpan syl2an ad2ant2r cA vj cv cexp
      co cB vk cv cexp co cmul co abscl 3syl cA cabs cfv c1 caddc co cfl cfv cN
      cexp co cB cabs cfv c1 caddc co cfl cfv cN cexp co cmul co cr wcel vj cv
      c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA
      cabs cfv c1 caddc co cfl cfv cN cexp co cB cabs cfv c1 caddc co cfl cfv
      cN cexp co cA cabs cfv c1 caddc co cfl cfv cr wcel cN cn0 wcel cA cabs
      cfv c1 caddc co cfl cfv cN cexp co cr wcel cA cabs cfv c1 caddc co cr
      wcel cA cabs cfv c1 caddc co cfl cfv cr wcel cA cabs cfv c1 cA
      efaddlem12.2 abscli 1re readdcli cA cabs cfv c1 caddc co reflcl ax-mp cN
      efaddlem12.1 nnnn0i cA cabs cfv c1 caddc co cfl cfv cN reexpcl mp2an cB
      cabs cfv c1 caddc co cfl cfv cr wcel cN cn0 wcel cB cabs cfv c1 caddc co
      cfl cfv cN cexp co cr wcel cB cabs cfv c1 caddc co cr wcel cB cabs cfv c1
      caddc co cfl cfv cr wcel cB cabs cfv c1 cB efaddlem12.3 abscli 1re
      readdcli cB cabs cfv c1 caddc co reflcl ax-mp cN efaddlem12.1 nnnn0i cB
      cabs cfv c1 caddc co cfl cfv cN reexpcl mp2an remulcli a1i cT cS cexp co
      cr wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel wa cT cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT
      efaddlem12.2 efaddlem12.3 efaddlem12.5 efaddlem7 nnrei cS cS cN
      efaddlem12.1 efaddlem12.4 efaddlem8 nnnn0i cT cS reexpcl mp2an a1i cA cB
      vj vk cN efaddlem12.1 efaddlem12.2 efaddlem12.3 efaddlem11 cA cabs cfv c1
      caddc co cfl cfv cN cexp co cB cabs cfv c1 caddc co cfl cfv cN cexp co
      cmul co cT cS cexp co cle wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel wa cA cB cS cT cN efaddlem12.1 efaddlem12.2
      efaddlem12.3 efaddlem12.4 efaddlem12.5 efaddlem12 a1i letrd $.
      $( [15-Feb-2006] $) $( [5-Jan-2006] $)
  $}

  ${
    efaddlem14.1 $e |- N e. NN $.
    $( Lemma for ~ efaddi .  Importantly, the sum of the indices ` j ` and
       ` k ` of the double summation on the right-hand side of ~ efaddlem6 is
       larger than ` N ` .  This will be used to find a lower bound on the
       factorials in the denominator of the summation terms. $)
    efaddlem14 $p |- ( ( j e. ( 1 ... N ) /\
              k e. ( ( ( N - j ) + 1 ) ... N ) ) -> ( N + 1 ) <_ ( j + k ) ) $=
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa cN vj cv cmin co c1 caddc co vj cv caddc co vk cv vj cv caddc co cN c1
      caddc co vj cv vk cv caddc co cle vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa cN vj cv cmin co c1 caddc co vk cv
      cle wbr cN vj cv cmin co c1 caddc co vj cv caddc co vk cv vj cv caddc co
      cle wbr vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel cN vj cv cmin
      co c1 caddc co vk cv cle wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin
      co c1 caddc co cN elfzle1 adantl cN vj cv cmin co c1 caddc co cz wcel vk
      cv cz wcel vj cv cz wcel cN vj cv cmin co c1 caddc co vk cv cle wbr cN vj
      cv cmin co c1 caddc co vj cv caddc co vk cv vj cv caddc co cle wbr wb vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      cN vj cv cmin co c1 caddc co cr wcel vk cv cr wcel vj cv cr wcel cN vj cv
      cmin co c1 caddc co vk cv cle wbr cN vj cv cmin co c1 caddc co vj cv
      caddc co vk cv vj cv caddc co cle wbr wb cN vj cv cmin co c1 caddc co cz
      wcel vk cv cz wcel vj cv cz wcel cN vj cv cmin co c1 caddc co vk cv vj cv
      leadd1 cN vj cv cmin co c1 caddc co zre vk cv zre vj cv zre syl3an vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel cN vj cv cmin co c1 caddc co
      cz wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      elfzel1 adantl vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vk cv cz
      wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      elfzelz adantl vj cv c1 cN cfz co wcel vj cv cz wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel vj cv c1 cN elfzelz adantr syl3anc mpbid vj
      cv c1 cN cfz co wcel cN c1 caddc co cN vj cv cmin co c1 caddc co vj cv
      caddc co wceq vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv c1
      cN cfz co wcel cN vj cv cmin co c1 caddc co vj cv caddc co cN c1 caddc co
      vj cv c1 cN cfz co wcel vj cv cz wcel vj cv cc wcel cN vj cv cmin co c1
      caddc co vj cv caddc co cN c1 caddc co wceq vj cv c1 cN elfzelz vj cv zcn
      cN cc wcel vj cv cc wcel c1 cc wcel cN vj cv cmin co c1 caddc co vj cv
      caddc co cN c1 caddc co wceq cN efaddlem14.1 nncni ax1cn cN vj cv c1
      nppcan mp3an13 3syl eqcomd adantr vj cv cz wcel vk cv cz wcel vj cv vk cv
      caddc co vk cv vj cv caddc co wceq vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel vj cv cc wcel vk cv cc wcel vj cv vk
      cv caddc co vk cv vj cv caddc co wceq vj cv cz wcel vk cv cz wcel vj cv
      vk cv addcom vj cv zcn vk cv zcn syl2an vj cv c1 cN elfzelz vk cv cN vj
      cv cmin co c1 caddc co cN elfzelz syl2an 3brtr4d $.
      $( [14-Feb-2006] $) $( [6-Jan-2006] $)
  $}

  ${
    efaddlem15.1 $e |- N e. NN $.
    efaddlem15.2 $e |- S = ( |_ ` ( ( N + 1 ) / 2 ) ) $.
    $( Lemma for ~ efaddi .  A lower bound on the factorial product in the
       denominator of the summation terms on the right-hand side of
       ~ efaddlem6 .  The key theorem used is ~ facavg , which says that the
       factorial of the average of two numbers is less than the product of
       their factorials. $)
    efaddlem15 $p |- ( ( j e. ( 1 ... N ) /\
                    k e. ( ( ( N - j ) + 1 ) ... N ) ) ->
         ( ! ` S ) <_ ( ( ! ` j ) x. ( ! ` k ) ) ) $=
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa cS cfa cfv vj cv vk cv caddc co c2 cdiv co cfl cfv cfa cfv vj cv cfa
      cfv vk cv cfa cfv cmul co cS cfa cfv cr wcel vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cS cfa cfv cS cn0 wcel
      cS cfa cfv cn wcel cS cS cN efaddlem15.1 efaddlem15.2 efaddlem8 nnnn0i cS
      faccl ax-mp nnrei a1i vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv vk cv caddc co cn0 wcel vj cv vk cv
      caddc co c2 cdiv co cfl cfv cfa cfv cr wcel vj cv cn0 wcel vk cv cn0 wcel
      vj cv vk cv caddc co cn0 wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel wa vj cv vk cv nn0addcl vj cv c1 cN cfz co
      wcel vj cv cn0 wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj
      cv c1 cN cfz co wcel vj cv cn wcel vj cv cn0 wcel vj cv cN elfznn vj cv
      nnnn0 syl adantr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc
      co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN efaddlem15.1
      efaddlem2 vk cv nnnn0 syl sylanc vj cv vk cv caddc co cn0 wcel vj cv vk
      cv caddc co c2 cdiv co cfl cfv cfa cfv cn wcel vj cv vk cv caddc co c2
      cdiv co cfl cfv cfa cfv cr wcel vj cv vk cv caddc co cn0 wcel vj cv vk cv
      caddc co c2 cdiv co cfl cfv cn0 wcel vj cv vk cv caddc co c2 cdiv co cfl
      cfv cfa cfv cn wcel vj cv vk cv caddc co c2 cdiv co cr wcel cc0 vj cv vk
      cv caddc co c2 cdiv co cle wbr vj cv vk cv caddc co c2 cdiv co cfl cfv
      cn0 wcel vj cv vk cv caddc co cn0 wcel vj cv vk cv caddc co c2 cdiv co
      flge0nn0 vj cv vk cv caddc co cn0 wcel vj cv vk cv caddc co cr wcel vj cv
      vk cv caddc co c2 cdiv co cr wcel vj cv vk cv caddc co nn0re vj cv vk cv
      caddc co rehalfcl syl vj cv vk cv caddc co cn0 wcel cc0 vj cv vk cv caddc
      co cle wbr cc0 vj cv vk cv caddc co c2 cdiv co cle wbr vj cv vk cv caddc
      co nn0ge0 vj cv vk cv caddc co cn0 wcel vj cv vk cv caddc co cr wcel cc0
      vj cv vk cv caddc co cle wbr cc0 vj cv vk cv caddc co c2 cdiv co cle wbr
      wb vj cv vk cv caddc co nn0re vj cv vk cv caddc co halfnneg2 syl mpbid
      sylanc vj cv vk cv caddc co c2 cdiv co cfl cfv faccl syl vj cv vk cv
      caddc co c2 cdiv co cfl cfv cfa cfv nnre syl syl vj cv c1 cN cfz co wcel
      vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv
      cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cr wcel vj cv
      cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co
      cn wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel wa vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn0 wcel vj cv
      cfa cfv cn wcel vj cv c1 cN cfz co wcel vj cv cn0 wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel vj cv c1 cN cfz co wcel vj cv cn wcel
      vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl adantr vj cv faccl syl vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      vk cv cn0 wcel vk cv cfa cfv cn wcel vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj
      vk cN efaddlem15.1 efaddlem2 vk cv nnnn0 syl vk cv faccl syl sylanc vj cv
      cfa cfv vk cv cfa cfv cmul co nnre syl vj cv vk cv caddc co c2 cdiv co
      cfl cfv cn0 wcel cS vj cv vk cv caddc co c2 cdiv co cfl cfv cle wbr cS
      cfa cfv vj cv vk cv caddc co c2 cdiv co cfl cfv cfa cfv cle wbr vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cS
      cn0 wcel vj cv vk cv caddc co c2 cdiv co cfl cfv cn0 wcel cS vj cv vk cv
      caddc co c2 cdiv co cfl cfv cle wbr cS cfa cfv vj cv vk cv caddc co c2
      cdiv co cfl cfv cfa cfv cle wbr cS cS cN efaddlem15.1 efaddlem15.2
      efaddlem8 nnnn0i cS vj cv vk cv caddc co c2 cdiv co cfl cfv facwordi
      mp3an1 vj cv vk cv caddc co c2 cdiv co cr wcel cc0 vj cv vk cv caddc co
      c2 cdiv co cle wbr vj cv vk cv caddc co c2 cdiv co cfl cfv cn0 wcel vj cv
      c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj
      cv vk cv caddc co c2 cdiv co flge0nn0 vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv caddc co cr wcel vj
      cv vk cv caddc co c2 cdiv co cr wcel vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv caddc co cn0 wcel vj
      cv vk cv caddc co cr wcel vj cv cn0 wcel vk cv cn0 wcel vj cv vk cv caddc
      co cn0 wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa vj cv vk cv nn0addcl vj cv c1 cN cfz co wcel vj cv cn0
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv c1 cN cfz co
      wcel vj cv cn wcel vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl adantr
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa vk cv cn wcel vk cv cn0 wcel vj vk cN efaddlem15.1 efaddlem2 vk cv
      nnnn0 syl sylanc vj cv vk cv caddc co nn0re syl vj cv vk cv caddc co
      rehalfcl syl vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co
      cN cfz co wcel wa cc0 vj cv vk cv caddc co cle wbr cc0 vj cv vk cv caddc
      co c2 cdiv co cle wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv vk cv caddc co cn0 wcel cc0 vj cv vk cv
      caddc co cle wbr vj cv cn0 wcel vk cv cn0 wcel vj cv vk cv caddc co cn0
      wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co
      wcel wa vj cv vk cv nn0addcl vj cv c1 cN cfz co wcel vj cv cn0 wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv c1 cN cfz co wcel vj cv
      cn wcel vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl adantr vj cv c1 cN
      cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn
      wcel vk cv cn0 wcel vj vk cN efaddlem15.1 efaddlem2 vk cv nnnn0 syl
      sylanc vj cv vk cv caddc co nn0ge0 syl vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv caddc co cr wcel
      cc0 vj cv vk cv caddc co cle wbr cc0 vj cv vk cv caddc co c2 cdiv co cle
      wbr wb vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel wa vj cv vk cv caddc co cn0 wcel vj cv vk cv caddc co cr wcel vj
      cv cn0 wcel vk cv cn0 wcel vj cv vk cv caddc co cn0 wcel vj cv c1 cN cfz
      co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv
      nn0addcl vj cv c1 cN cfz co wcel vj cv cn0 wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel vj cv c1 cN cfz co wcel vj cv cn wcel vj cv cn0
      wcel vj cv cN elfznn vj cv nnnn0 syl adantr vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0
      wcel vj vk cN efaddlem15.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv vk cv
      caddc co nn0re syl vj cv vk cv caddc co halfnneg2 syl mpbid sylanc vj cv
      c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cN
      c1 caddc co c2 cdiv co cfl cfv vj cv vk cv caddc co c2 cdiv co cfl cfv cS
      cle vj cv vk cv caddc co c2 cdiv co cr wcel cN c1 caddc co c2 cdiv co vj
      cv vk cv caddc co c2 cdiv co cle wbr cN c1 caddc co c2 cdiv co cfl cfv vj
      cv vk cv caddc co c2 cdiv co cfl cfv cle wbr vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cN c1 caddc co c2 cdiv
      co cr wcel vj cv vk cv caddc co c2 cdiv co cr wcel cN c1 caddc co c2 cdiv
      co vj cv vk cv caddc co c2 cdiv co cle wbr cN c1 caddc co c2 cdiv co cfl
      cfv vj cv vk cv caddc co c2 cdiv co cfl cfv cle wbr cN c1 caddc co c2 cN
      c1 cN efaddlem15.1 nnrei 1re readdcli 2re 2ne0 redivcli cN c1 caddc co c2
      cdiv co vj cv vk cv caddc co c2 cdiv co flwordi mp3an1 vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv
      caddc co cr wcel vj cv vk cv caddc co c2 cdiv co cr wcel vj cv c1 cN cfz
      co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv
      caddc co cn0 wcel vj cv vk cv caddc co cr wcel vj cv cn0 wcel vk cv cn0
      wcel vj cv vk cv caddc co cn0 wcel vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv nn0addcl vj cv c1 cN
      cfz co wcel vj cv cn0 wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co
      wcel vj cv c1 cN cfz co wcel vj cv cn wcel vj cv cn0 wcel vj cv cN elfznn
      vj cv nnnn0 syl adantr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN
      efaddlem15.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv vk cv caddc co nn0re
      syl vj cv vk cv caddc co rehalfcl syl vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa cN c1 caddc co vj cv vk cv caddc
      co cle wbr cN c1 caddc co c2 cdiv co vj cv vk cv caddc co c2 cdiv co cle
      wbr vj vk cN efaddlem15.1 efaddlem14 vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv caddc co cr wcel cN
      c1 caddc co vj cv vk cv caddc co cle wbr cN c1 caddc co c2 cdiv co vj cv
      vk cv caddc co c2 cdiv co cle wbr wb vj cv c1 cN cfz co wcel vk cv cN vj
      cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv caddc co cn0 wcel vj
      cv vk cv caddc co cr wcel vj cv cn0 wcel vk cv cn0 wcel vj cv vk cv caddc
      co cn0 wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa vj cv vk cv nn0addcl vj cv c1 cN cfz co wcel vj cv cn0
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv c1 cN cfz co
      wcel vj cv cn wcel vj cv cn0 wcel vj cv cN elfznn vj cv nnnn0 syl adantr
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa vk cv cn wcel vk cv cn0 wcel vj vk cN efaddlem15.1 efaddlem2 vk cv
      nnnn0 syl sylanc vj cv vk cv caddc co nn0re syl cN c1 caddc co cr wcel vj
      cv vk cv caddc co cr wcel c2 cr wcel cN c1 caddc co vj cv vk cv caddc co
      cle wbr cN c1 caddc co c2 cdiv co vj cv vk cv caddc co c2 cdiv co cle wbr
      wb cN c1 cN efaddlem15.1 nnrei 1re readdcli 2re cN c1 caddc co cr wcel vj
      cv vk cv caddc co cr wcel c2 cr wcel w3a cc0 c2 clt wbr cN c1 caddc co vj
      cv vk cv caddc co cle wbr cN c1 caddc co c2 cdiv co vj cv vk cv caddc co
      c2 cdiv co cle wbr wb 2pos cN c1 caddc co vj cv vk cv caddc co c2
      lediv1OLD mpan2 mp3an13 syl mpbid sylanc efaddlem15.2 syl5eqbr sylanc vj
      cv cn0 wcel vk cv cn0 wcel vj cv vk cv caddc co c2 cdiv co cfl cfv cfa
      cfv vj cv cfa cfv vk cv cfa cfv cmul co cle wbr vj cv c1 cN cfz co wcel
      vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv vk cv facavg
      vj cv c1 cN cfz co wcel vj cv cn0 wcel vk cv cN vj cv cmin co c1 caddc co
      cN cfz co wcel vj cv c1 cN cfz co wcel vj cv cn wcel vj cv cn0 wcel vj cv
      cN elfznn vj cv nnnn0 syl adantr vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk
      cN efaddlem15.1 efaddlem2 vk cv nnnn0 syl sylanc letrd $.
      $( [15-Feb-2006] $) $( [4-Jan-2006] $)
  $}

  ${
    $d j k N $.  $d j k C $.
    efaddlem16.1 $e |- N e. NN $.
    efaddlem16.2 $e |- C e. RR $.
    efaddlem16.3 $e |- 0 <_ C $.
    $( Lemma for ~ efaddi .  The double summation of a constant ` C ` (that is
       independent of ` j ` and ` k ` ) has an upper bound that grows as the
       square of ` N ` . $)
    efaddlem16 $p |- sum_ j e. ( 1 ... N )
               sum_ k e. ( ( ( N - j ) + 1 ) ... N ) C <_ ( ( N ^ 2 ) x. C ) $=
      c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cC vk csu vj csu c1
      cN cfz co cN cC cmul co vj csu cN c2 cexp co cC cmul co cle cN c1 cuz cfv
      wcel cN vj cv cmin co c1 caddc co cN cfz co cC vk csu cr wcel cN cC cmul
      co cr wcel cN vj cv cmin co c1 caddc co cN cfz co cC vk csu cN cC cmul co
      cle wbr w3a vj c1 cN cfz co wral c1 cN cfz co cN vj cv cmin co c1 caddc
      co cN cfz co cC vk csu vj csu c1 cN cfz co cN cC cmul co vj csu cle wbr
      cN cn c1 cuz cfv efaddlem16.1 nnuz eleqtri cN vj cv cmin co c1 caddc co
      cN cfz co cC vk csu cr wcel cN cC cmul co cr wcel cN vj cv cmin co c1
      caddc co cN cfz co cC vk csu cN cC cmul co cle wbr w3a vj c1 cN cfz co vj
      cv c1 cN cfz co wcel cN vj cv cmin co c1 caddc co cN cfz co cC vk csu cr
      wcel cN cC cmul co cr wcel cN vj cv cmin co c1 caddc co cN cfz co cC vk
      csu cN cC cmul co cle wbr cN cN vj cv cmin co c1 caddc co cuz cfv wcel cC
      cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co wral cN vj cv cmin co
      c1 caddc co cN cfz co cC vk csu cr wcel vj cv c1 cN cfz co wcel cC vk cN
      vj cv cmin co c1 caddc co cN fsumrecl vj cN efaddlem16.1 efaddlem1 vj cv
      c1 cN cfz co wcel cC cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co cC
      cr wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel wa efaddlem16.2 a1i r19.21aiva sylanc cN cC cmul co cr wcel vj cv
      c1 cN cfz co wcel cN cC cN efaddlem16.1 nnrei efaddlem16.2 remulcli a1i
      vj cv c1 cN cfz co wcel cN vj cv cmin co c1 caddc co cN cfz co cC vk csu
      vj cv cC cmul co cN cC cmul co cle vj cv c1 cN cfz co wcel cN vj cv cmin
      co c1 caddc co cN cfz co cC vk csu cN cN vj cv cmin co c1 caddc co cmin
      co c1 caddc co cC cmul co vj cv cC cmul co cN cN vj cv cmin co c1 caddc
      co cuz cfv wcel cC cc wcel cN vj cv cmin co c1 caddc co cN cfz co cC vk
      csu cN cN vj cv cmin co c1 caddc co cmin co c1 caddc co cC cmul co wceq
      vj cv c1 cN cfz co wcel cC vk cN vj cv cmin co c1 caddc co cN fsumconst
      vj cN efaddlem16.1 efaddlem1 cC efaddlem16.2 recni sylancl vj cv c1 cN
      cfz co wcel cN cN vj cv cmin co c1 caddc co cmin co c1 caddc co vj cv cC
      cmul vj cv c1 cN cfz co wcel vj cv cz wcel vj cv cc wcel cN cN vj cv cmin
      co c1 caddc co cmin co c1 caddc co vj cv wceq vj cv c1 cN elfzelz vj cv
      zcn vj cv cc wcel cN cN vj cv cmin co c1 caddc co cmin co c1 caddc co cN
      cN vj cv cmin co cmin co vj cv vj cv cc wcel cN vj cv cmin co cc wcel cN
      cN vj cv cmin co c1 caddc co cmin co c1 caddc co cN cN vj cv cmin co cmin
      co wceq cN cc wcel vj cv cc wcel cN vj cv cmin co cc wcel cN efaddlem16.1
      nncni cN vj cv subcl mpan cN cc wcel cN vj cv cmin co cc wcel c1 cc wcel
      cN cN vj cv cmin co c1 caddc co cmin co c1 caddc co cN cN vj cv cmin co
      cmin co wceq cN efaddlem16.1 nncni ax1cn cN cN vj cv cmin co c1 nppcan2
      mp3an13 syl cN cc wcel vj cv cc wcel cN cN vj cv cmin co cmin co vj cv
      wceq cN efaddlem16.1 nncni cN vj cv nncan mpan eqtrd 3syl opreq1d eqtrd
      vj cv cr wcel vj cv cN cle wbr vj cv cC cmul co cN cC cmul co cle wbr vj
      cv c1 cN cfz co wcel vj cv cr wcel cc0 cC cle wbr vj cv cN cle wbr vj cv
      cC cmul co cN cC cmul co cle wbr efaddlem16.3 vj cv cr wcel cN cr wcel cC
      cr wcel cc0 cC cle wbr vj cv cN cle wbr wa vj cv cC cmul co cN cC cmul co
      cle wbr wi cN efaddlem16.1 nnrei efaddlem16.2 vj cv cr wcel cN cr wcel cC
      cr wcel w3a cc0 cC cle wbr vj cv cN cle wbr wa vj cv cC cmul co cN cC
      cmul co cle wbr vj cv cN cC lemul1aOLD ex mp3an23 mpani vj cv c1 cN cfz
      co wcel vj cv cz wcel vj cv cr wcel vj cv c1 cN elfzelz vj cv zre syl vj
      cv c1 cN elfzle2 sylc eqbrtrd 3jca rgen cN vj cv cmin co c1 caddc co cN
      cfz co cC vk csu cN cC cmul co vj c1 cN fsumcmp mp2an c1 cN cfz co cN cC
      cmul co vj csu cN c1 cmin co c1 caddc co cN cC cmul co cmul co cN cN cC
      cmul co cmul co cN c2 cexp co cC cmul co cN c1 cuz cfv wcel cN cC cmul co
      cc wcel c1 cN cfz co cN cC cmul co vj csu cN c1 cmin co c1 caddc co cN cC
      cmul co cmul co wceq cN cn c1 cuz cfv efaddlem16.1 nnuz eleqtri cN cC
      cmul co cN cC cN efaddlem16.1 nnrei efaddlem16.2 remulcli recni cN cC
      cmul co vj c1 cN fsumconst mp2an cN c1 cmin co c1 caddc co cN cN cC cmul
      co cmul cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN
      efaddlem16.1 nncni ax1cn cN c1 npcan mp2an opreq1i cN c2 cexp co cC cmul
      co cN cN cmul co cC cmul co cN cN cC cmul co cmul co cN c2 cexp co cN cN
      cmul co cC cmul cN cN efaddlem16.1 nncni sqvali opreq1i cN cN cC cN
      efaddlem16.1 nncni cN efaddlem16.1 nncni cC efaddlem16.2 recni mulassi
      eqtr2i 3eqtri breqtri $.
      $( [14-Feb-2006] $) $( [8-Jan-2006] $)
  $}

  ${
    $d j k N $.
    efaddlem17.1 $e |- N e. NN $.
    efaddlem17.2 $e |- A e. CC $.
    efaddlem17.3 $e |- B e. CC $.
    efaddlem17.4 $e |- S = ( |_ ` ( ( N + 1 ) / 2 ) ) $.
    efaddlem17.5 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                      ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    $( Lemma for ~ efaddi .  An upper bound for the summation terms on the
       right-hand side of ~ efaddlem6 that is independent of ` j ` and
       ` k ` . $)
    efaddlem17 $p |- ( ( j e. ( 1 ... N ) /\
   k e. ( ( ( N - j ) + 1 ) ... N ) ) -> ( abs ` ( ( ( A ^ j ) x. ( B ^ k ) ) /
               ( ( ! ` j ) x. ( ! ` k ) ) ) ) <_ ( ( T ^ S ) / ( ! ` S ) ) ) $=
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv cA vj cv cexp co cB vk cv cexp co cmul co cabs
      cfv vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cT cS cexp co cS cfa cfv
      cdiv co cle vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co cabs cfv cA vj cv cexp co cB vk cv cexp co
      cmul co cabs cfv vj cv cfa cfv vk cv cfa cfv cmul co cabs cfv cdiv co cA
      vj cv cexp co cB vk cv cexp co cmul co cabs cfv vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cabs cfv cA vj cv cexp co cB vk cv cexp co cmul
      co cabs cfv vj cv cfa cfv vk cv cfa cfv cmul co cabs cfv cdiv co wceq vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co absdiv vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv
      cexp co cmul co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa cA vj cv cexp co cc wcel cB vk cv cexp co cc
      wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk
      cv cn0 wcel cA vj cv cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0
      wcel cA vj cv cexp co cc wcel efaddlem17.2 cA vj cv expcl mpan cB cc wcel
      vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem17.3 cB vk cv expcl mpan
      syl2an vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz co wcel vj cv cn
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv cN elfznn
      adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN
      efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa
      cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cn0
      wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv
      cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co
      cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl
      vj cv faccl vk cv faccl syl2an vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv
      c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0
      wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv cfa cfv
      vk cv cfa cfv cmul co nncn syl vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa cfv cmul co
      cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv cn0 wcel vk cv
      cn0 wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv
      cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel
      vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv
      faccl vk cv faccl syl2an vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co
      c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN
      cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co
      wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0
      wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv cfa cfv
      vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa cfv
      cmul co cabs cfv vj cv cfa cfv vk cv cfa cfv cmul co cA vj cv cexp co cB
      vk cv cexp co cmul co cabs cfv cdiv vj cv cfa cfv vk cv cfa cfv cmul co
      cr wcel cc0 vj cv cfa cfv vk cv cfa cfv cmul co cle wbr vj cv cfa cfv vk
      cv cfa cfv cmul co cabs cfv vj cv cfa cfv vk cv cfa cfv cmul co wceq vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      vj cv cfa cfv vk cv cfa cfv cmul co absid vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa
      cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cr wcel vj cv cn0
      wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv
      cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co
      cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl
      vj cv faccl vk cv faccl syl2an vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv
      c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0
      wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv cfa cfv
      vk cv cfa cfv cmul co nnre syl vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa cfv cmul co
      cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn0 wcel cc0 vj cv cfa cfv vk
      cv cfa cfv cmul co cle wbr vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk
      cv cfa cfv cmul co cn wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co
      c1 caddc co cN cfz co wcel wa vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel
      vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel
      vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv
      c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj
      cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv
      nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1
      efaddlem2 vk cv nnnn0 syl sylanc vj cv cfa cfv vk cv cfa cfv cmul co
      nnnn0 vj cv cfa cfv vk cv cfa cfv cmul co nn0ge0 3syl sylanc opreq2d
      eqtrd cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cr wcel cT cS
      cexp co cr wcel wa cc0 cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv
      cle wbr cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cT cS cexp co
      cle wbr wa cS cfa cfv cr wcel vj cv cfa cfv vk cv cfa cfv cmul co cr wcel
      wa cc0 cS cfa cfv clt wbr cS cfa cfv vj cv cfa cfv vk cv cfa cfv cmul co
      cle wbr wa cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cT cS cexp co cS cfa cfv cdiv co cle
      wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co
      wcel wa cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cT cS cexp co
      cS cfa cfv vj cv cfa cfv vk cv cfa cfv cmul co lediv12a vj cv c1 cN cfz
      co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co cabs cfv cr wcel cT cS cexp co cr wcel
      vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      wa cA vj cv cexp co cB vk cv cexp co cmul co cc wcel cA vj cv cexp co cB
      vk cv cexp co cmul co cabs cfv cr wcel vj cv cn0 wcel vk cv cn0 wcel cA
      vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv c1 cN cfz co wcel vk
      cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp co cc
      wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co
      cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem17.2 cA
      vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      efaddlem17.3 cB vk cv expcl mpan syl2an vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel
      vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co
      cN cfz co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel
      vk cv cn0 wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc cA
      vj cv cexp co cB vk cv cexp co cmul co abscl syl cT cr wcel cS cn0 wcel
      cT cS cexp co cr wcel cT cA cB cT efaddlem17.2 efaddlem17.3 efaddlem17.5
      efaddlem7 nnrei cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS
      reexpcl mp2an jctir vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa cc0 cA vj cv cexp co cB vk cv cexp co cmul co
      cabs cfv cle wbr cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cT cS
      cexp co cle wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc
      co cN cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co cc wcel
      cc0 cA vj cv cexp co cB vk cv cexp co cmul co cabs cfv cle wbr vj cv cn0
      wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk
      cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co
      cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel
      efaddlem17.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp
      co cc wcel efaddlem17.3 cB vk cv expcl mpan syl2an vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel
      vj cv cn0 wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      vk cv cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0
      syl sylanc cA vj cv cexp co cB vk cv cexp co cmul co absge0 syl cA cB cS
      cT vj vk cN efaddlem17.1 efaddlem17.2 efaddlem17.3 efaddlem17.4
      efaddlem17.5 efaddlem13 jca vj cv c1 cN cfz co wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cr
      wcel cS cfa cfv cr wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cr wcel vj cv cn0 wcel vk cv cn0 wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cfa cfv cn wcel vk cv
      cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0
      wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv
      faccl syl2an vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co
      cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz co wcel vj
      cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv cN
      elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN vj cv cmin
      co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN
      efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc vj cv cfa cfv vk cv cfa cfv
      cmul co nnre syl cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei jctil vj
      cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa
      cS cfa cfv vj cv cfa cfv vk cv cfa cfv cmul co cle wbr cc0 cS cfa cfv clt
      wbr cS vj vk cN efaddlem17.1 efaddlem17.4 efaddlem15 cS cfa cfv cS cn0
      wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i cS faccl ax-mp nngt0i jctil syl2anc eqbrtrd $.
      $( [16-Feb-2006] $) $( [7-Jan-2006] $)

    $( Lemma for ~ efaddi .  Closure of the double summation of the constant
       upper bound of ~ efaddlem17 . $)
    efaddlem18 $p |- sum_ j e. ( 1 ... N )
     sum_ k e. ( ( ( N - j ) + 1 ) ... N ) ( ( T ^ S ) / ( ! ` S ) ) e. RR $=
      cN c1 cuz cfv wcel cN vj cv cmin co c1 caddc co cN cfz co cT cS cexp co
      cS cfa cfv cdiv co vk csu cr wcel vj c1 cN cfz co wral c1 cN cfz co cN vj
      cv cmin co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu
      vj csu cr wcel cN cn c1 cuz cfv efaddlem17.1 nnuz eleqtri cN vj cv cmin
      co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu cr wcel
      vj c1 cN cfz co cN cN vj cv cmin co c1 caddc co cuz cfv wcel cT cS cexp
      co cS cfa cfv cdiv co cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co
      wral cN vj cv cmin co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv
      co vk csu cr wcel vj cv c1 cN cfz co wcel cT cS cexp co cS cfa cfv cdiv
      co vk cN vj cv cmin co c1 caddc co cN fsumrecl vj cN efaddlem17.1
      efaddlem1 vj cv c1 cN cfz co wcel cT cS cexp co cS cfa cfv cdiv co cr
      wcel vk cN vj cv cmin co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv
      cdiv co cr wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc
      co cN cfz co wcel wa cT cS cexp co cS cfa cfv cT cr wcel cS cn0 wcel cT
      cS cexp co cr wcel cT cA cB cT efaddlem17.2 efaddlem17.3 efaddlem17.5
      efaddlem7 nnrei cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS
      reexpcl mp2an cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei cS cn0
      wcel cS cfa cfv cc0 wne cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i cS facne0 ax-mp redivcli a1i r19.21aiva sylanc rgen cN vj cv cmin
      co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu vj c1 cN
      fsumrecl mp2an $.
      $( [16-Feb-2006] $) $( [8-Jan-2006] $)

    $( Lemma for ~ efaddi .  Upper bound for the summation terms on the
       right-hand side of ~ efaddlem6 . $)
    efaddlem19 $p |- ( abs ` sum_ j e. ( 1 ... N )
         sum_ k e. ( ( ( N - j ) + 1 ) ... N )
     ( ( ( A ^ j ) x. ( B ^ k ) ) / ( ( ! ` j ) x. ( ! ` k ) ) ) ) <_
             sum_ j e. ( 1 ... N ) sum_ k e. ( ( ( N - j ) + 1 ) ... N )
             ( ( T ^ S ) / ( ! ` S ) ) $=
      c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co cabs cfv vk csu vj csu cle wbr c1 cN cfz co cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj csu c1 cN cfz co cN
      vj cv cmin co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk
      csu vj csu cle wbr c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co vk csu vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc
      co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu vj csu cle wbr c1 cN
      cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu
      cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cabs cfv vj csu cle wbr c1 cN cfz co cN vj cv cmin co c1 caddc
      co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co vk csu cabs cfv vj csu c1 cN cfz co cN vj cv
      cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj csu cle
      wbr c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      csu vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv vk csu vj csu cle wbr cN c1 cuz cfv wcel cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel vj c1 cN
      cfz co wral c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu cabs cfv vj csu cle wbr cN cn c1 cuz cfv
      efaddlem17.1 nnuz eleqtri cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cc wcel vj c1 cN cfz co cN cN vj cv cmin co c1 caddc co cuz cfv
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co cN cfz co
      wral cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc
      wcel vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cN vj cv cmin co c1 caddc co
      cN fsumcl vj cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj cv cn0 wcel vk cv
      cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv
      cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp co cB vk cv cexp co
      cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv
      cn0 wcel wa cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel
      cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv
      cn0 wcel cA vj cv cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0
      wcel cA vj cv cexp co cc wcel efaddlem17.2 cA vj cv expcl mpan cB cc wcel
      vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem17.3 cB vk cv expcl mpan
      syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul
      co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv cn
      wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj
      cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv
      faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul co nncn syl vj
      cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel
      vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv cfa cfv cn wcel vk cv
      cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0
      wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv
      faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv
      c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj
      cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv
      nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1
      efaddlem2 vk cv nnnn0 syl sylanc r19.21aiva sylanc rgen cN vj cv cmin co
      c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu vj c1 cN fsumabs mp2an cN c1 cuz
      cfv wcel cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs
      cfv cr wcel cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv
      vk csu cr wcel cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      cabs cfv cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk
      csu cle wbr w3a vj c1 cN cfz co wral c1 cN cfz co cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv vj csu c1 cN cfz co cN
      vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj
      csu cle wbr cN cn c1 cuz cfv efaddlem17.1 nnuz eleqtri cN vj cv cmin co
      c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv cr wcel cN vj cv cmin
      co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel cN vj cv
      cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv cN vj cv cmin
      co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cle wbr w3a vj c1
      cN cfz co vj cv c1 cN cfz co wcel cN vj cv cmin co c1 caddc co cN cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu cabs cfv cr wcel cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cabs cfv vk csu cr wcel cN vj cv cmin co c1 caddc co
      cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co vk csu cabs cfv cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cabs cfv vk csu cle wbr vj cv c1 cN cfz co wcel cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel cN vj cv
      cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv cr wcel cN cN
      vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cN vj cv
      cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1 caddc co cN cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      cN vj cv cmin co c1 caddc co cN fsumcl vj cN efaddlem17.1 efaddlem1 vj cv
      c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv
      vk cv cfa cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co cN
      cfz co vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN
      cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc
      wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp co cc
      wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co
      cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem17.2 cA
      vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel vk cv cn0 wcel wa
      vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv
      vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv
      cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv
      vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne
      vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv
      nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul
      co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz
      co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel
      vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc r19.21aiva sylanc
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu abscl syl cN
      cN vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp
      co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv cr wcel
      vk cN vj cv cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1 caddc
      co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel vj cv c1 cN cfz co
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cabs cfv vk cN vj cv cmin co c1 caddc co cN fsumrecl
      vj cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs
      cfv cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      cc wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cabs cfv cr wcel vj cv cn0 wcel vk cv cn0 wcel cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc
      co cN cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem17.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel
      vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa
      cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn
      wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an
      vj cv cfa cfv vk cv cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0
      wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv
      cfa cfv cmul co cc0 wne vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv
      cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa
      cfv vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0
      wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv
      cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl
      sylanc cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co abscl syl r19.21aiva sylanc cN cN vj cv cmin co c1
      caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co
      cN cfz co wral cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      cabs cfv cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk
      csu cle wbr vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk cN vj cv cmin co
      c1 caddc co cN fsumabs vj cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co
      wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj
      cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN cfz co wcel
      vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp co cB
      vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel
      vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv
      cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp co cc wcel cB vk cv
      cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv
      cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co mulcl cA cc
      wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem17.2 cA vj cv expcl
      mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel efaddlem17.3 cB
      vk cv expcl mpan syl2an vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv vk
      cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc wcel vj
      cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv
      nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul
      co nncn syl vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv
      cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne vj cv cfa cfv
      cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel
      vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv
      faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul co nnne0 syl
      syl3anc vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz
      co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz co wcel vj cv cn
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel vj cv cN elfznn
      adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel vj vk cN
      efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc r19.21aiva sylanc 3jca rgen
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj c1 cN
      fsumcmp mp2an c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co vk csu vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc co
      cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co vk csu cabs cfv vj csu c1 cN cfz co cN vj cv cmin
      co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj csu cA cB vj vk
      cN efaddlem17.1 efaddlem17.2 efaddlem17.3 efaddlem4 cN c1 cuz cfv wcel cN
      vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv cr
      wcel vj c1 cN cfz co wral c1 cN cfz co cN vj cv cmin co c1 caddc co cN
      cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co vk csu cabs cfv vj csu cr wcel cN cn c1 cuz cfv
      efaddlem17.1 nnuz eleqtri cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu cabs cfv cr wcel vj c1 cN cfz co vj cv c1 cN cfz co wcel cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cc wcel cN vj cv
      cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv cr wcel cN cN
      vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vk cN vj cv
      cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1 caddc co cN cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu cc wcel vj cv c1 cN cfz co wcel cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk
      cN vj cv cmin co c1 caddc co cN fsumcl vj cN efaddlem17.1 efaddlem1 vj cv
      c1 cN cfz co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv
      vk cv cfa cfv cmul co cdiv co cc wcel vk cN vj cv cmin co c1 caddc co cN
      cfz co vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN
      cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc
      wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp co cc
      wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co
      cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem17.2 cA
      vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel vk cv cn0 wcel wa
      vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv
      vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv
      cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv
      vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne
      vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv
      nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul
      co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz
      co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel
      vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc r19.21aiva sylanc
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu abscl syl rgen
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu cabs cfv vj c1
      cN fsumrecl mp2an cN c1 cuz cfv wcel cN vj cv cmin co c1 caddc co cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv vk csu cr wcel vj c1 cN cfz co wral c1 cN cfz co
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj
      csu cr wcel cN cn c1 cuz cfv efaddlem17.1 nnuz eleqtri cN vj cv cmin co
      c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel vj c1 cN cfz co
      cN cN vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv cr
      wcel vk cN vj cv cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel vj cv c1 cN cfz
      co wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cabs cfv vk cN vj cv cmin co c1 caddc co cN fsumrecl
      vj cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs
      cfv cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      cc wcel cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cabs cfv cr wcel vj cv cn0 wcel vk cv cn0 wcel cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc
      co cN cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj
      cv cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem17.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel
      vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa
      cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn
      wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an
      vj cv cfa cfv vk cv cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0
      wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv
      cfa cfv cmul co cc0 wne vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv
      cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa
      cfv vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0
      wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv
      cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl
      sylanc cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co abscl syl r19.21aiva sylanc rgen cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj c1 cN fsumrecl mp2an
      letri mp2an cN c1 cuz cfv wcel cN vj cv cmin co c1 caddc co cN cfz co cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co cabs cfv vk csu cr wcel cN vj cv cmin co c1 caddc co cN cfz co
      cT cS cexp co cS cfa cfv cdiv co vk csu cr wcel cN vj cv cmin co c1 caddc
      co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co cabs cfv vk csu cN vj cv cmin co c1 caddc co
      cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu cle wbr w3a vj c1 cN
      cfz co wral c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cabs cfv vk csu vj csu c1 cN cfz co cN vj cv cmin co c1 caddc co cN
      cfz co cT cS cexp co cS cfa cfv cdiv co vk csu vj csu cle wbr cN cn c1
      cuz cfv efaddlem17.1 nnuz eleqtri cN vj cv cmin co c1 caddc co cN cfz co
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv vk csu cr wcel cN vj cv cmin co c1 caddc co cN
      cfz co cT cS cexp co cS cfa cfv cdiv co vk csu cr wcel cN vj cv cmin co
      c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cN vj cv cmin co c1
      caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu cle wbr w3a vj
      c1 cN cfz co vj cv c1 cN cfz co wcel cN vj cv cmin co c1 caddc co cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv vk csu cr wcel cN vj cv cmin co c1 caddc co cN
      cfz co cT cS cexp co cS cfa cfv cdiv co vk csu cr wcel cN vj cv cmin co
      c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cN vj cv cmin co c1
      caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu cle wbr cN cN
      vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv cr wcel vk
      cN vj cv cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1 caddc co
      cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel vj cv c1 cN cfz co wcel
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv vk cN vj cv cmin co c1 caddc co cN fsumrecl vj
      cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv
      cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj cv c1 cN cfz co wcel
      vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv cr wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co
      cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem17.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel
      vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa
      cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn
      wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an
      vj cv cfa cfv vk cv cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0
      wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv
      cfa cfv cmul co cc0 wne vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv
      cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa
      cfv vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0
      wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv
      cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl
      sylanc cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co abscl syl r19.21aiva sylanc cN cN vj cv cmin co c1
      caddc co cuz cfv wcel cT cS cexp co cS cfa cfv cdiv co cr wcel vk cN vj
      cv cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1 caddc co cN cfz
      co cT cS cexp co cS cfa cfv cdiv co vk csu cr wcel vj cv c1 cN cfz co
      wcel cT cS cexp co cS cfa cfv cdiv co vk cN vj cv cmin co c1 caddc co cN
      fsumrecl vj cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cT cS cexp
      co cS cfa cfv cdiv co cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co
      cT cS cexp co cS cfa cfv cdiv co cr wcel vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa cT cS cexp co cS cfa cfv cT
      cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT efaddlem17.2
      efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an cS cfa cfv cS cn0 wcel
      cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS
      faccl ax-mp nnrei cS cn0 wcel cS cfa cfv cc0 wne cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cS facne0 ax-mp redivcli a1i r19.21aiva
      sylanc cN cN vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs
      cfv cr wcel cT cS cexp co cS cfa cfv cdiv co cr wcel cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs
      cfv cT cS cexp co cS cfa cfv cdiv co cle wbr w3a vk cN vj cv cmin co c1
      caddc co cN cfz co wral cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cabs cfv vk csu cN vj cv cmin co c1 caddc co cN cfz co cT cS cexp co
      cS cfa cfv cdiv co vk csu cle wbr vj cv c1 cN cfz co wcel cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      cabs cfv cT cS cexp co cS cfa cfv cdiv co vk cN vj cv cmin co c1 caddc co
      cN fsumcmp vj cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cabs cfv cr wcel cT cS cexp co cS cfa cfv cdiv co cr wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cabs cfv cT cS cexp co cS cfa cfv cdiv co cle wbr w3a vk cN vj cv cmin
      co c1 caddc co cN cfz co vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co
      c1 caddc co cN cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv cr wcel cT cS cexp
      co cS cfa cfv cdiv co cr wcel cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv cT cS cexp co cS cfa
      cfv cdiv co cle wbr vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co vj
      cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv
      cr wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel vj cv c1 cN
      cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul
      co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc
      wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co divcl cA vj cv cexp co cc
      wcel cB vk cv cexp co cc wcel cA vj cv cexp co cB vk cv cexp co cmul co
      cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv cexp co cB vk cv cexp co
      mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co cc wcel efaddlem17.2 cA
      vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel
      efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel vk cv cn0 wcel wa
      vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv
      vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv
      vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv
      cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0 wcel wa vj cv cfa cfv
      vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv cfa cfv cmul co cc0 wne
      vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv cfa cfv vk cv cfa cfv
      cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv cfa cfv vk cv cfa cfv
      nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa cfv vk cv cfa cfv cmul
      co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0 wcel vj cv c1 cN cfz
      co wcel vj cv cn wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel
      vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1 cN cfz co wcel vk cv cN
      vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv cn wcel vk cv cn0 wcel
      vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl sylanc cA vj cv cexp co
      cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      abscl syl cT cS cexp co cS cfa cfv cdiv co cr wcel vj cv c1 cN cfz co
      wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cT cS cexp co
      cS cfa cfv cT cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT
      efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an cS cfa cfv
      cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnnn0i cS faccl ax-mp nnrei cS cn0 wcel cS cfa cfv cc0 wne cS
      cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS facne0 ax-mp redivcli
      a1i cA cB cS cT vj vk cN efaddlem17.1 efaddlem17.2 efaddlem17.3
      efaddlem17.4 efaddlem17.5 efaddlem17 3jca r19.21aiva sylanc 3jca rgen cN
      vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu cN vj
      cv cmin co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu
      vj c1 cN fsumcmp mp2an c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj csu c1 cN cfz co cN
      vj cv cmin co c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk
      csu vj csu cA cB vj vk cN efaddlem17.1 efaddlem17.2 efaddlem17.3
      efaddlem4 cN c1 cuz cfv wcel cN vj cv cmin co c1 caddc co cN cfz co cA vj
      cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      cdiv co cabs cfv vk csu cr wcel vj c1 cN cfz co wral c1 cN cfz co cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj csu cr
      wcel cN cn c1 cuz cfv efaddlem17.1 nnuz eleqtri cN vj cv cmin co c1 caddc
      co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk
      cv cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel vj c1 cN cfz co cN cN
      vj cv cmin co c1 caddc co cuz cfv wcel cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv cr wcel vk
      cN vj cv cmin co c1 caddc co cN cfz co wral cN vj cv cmin co c1 caddc co
      cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv
      cfa cfv cmul co cdiv co cabs cfv vk csu cr wcel vj cv c1 cN cfz co wcel
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv vk cN vj cv cmin co c1 caddc co cN fsumrecl vj
      cN efaddlem17.1 efaddlem1 vj cv c1 cN cfz co wcel cA vj cv cexp co cB vk
      cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cabs cfv
      cr wcel vk cN vj cv cmin co c1 caddc co cN cfz co vj cv c1 cN cfz co wcel
      vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co cc wcel
      cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co cabs cfv cr wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co cc wcel vj cv c1 cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN
      cfz co wcel wa cA vj cv cexp co cB vk cv cexp co cmul co cc wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv vk cv cfa cfv cmul co
      cc0 wne cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co cc wcel vj cv cn0 wcel vk cv cn0 wcel wa cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co
      divcl cA vj cv cexp co cc wcel cB vk cv cexp co cc wcel cA vj cv cexp co
      cB vk cv cexp co cmul co cc wcel vj cv cn0 wcel vk cv cn0 wcel cA vj cv
      cexp co cB vk cv cexp co mulcl cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      cc wcel efaddlem17.2 cA vj cv expcl mpan cB cc wcel vk cv cn0 wcel cB vk
      cv cexp co cc wcel efaddlem17.3 cB vk cv expcl mpan syl2an vj cv cn0 wcel
      vk cv cn0 wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa
      cfv vk cv cfa cfv cmul co cc wcel vj cv cfa cfv cn wcel vk cv cfa cfv cn
      wcel vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0
      wcel vj cv cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an
      vj cv cfa cfv vk cv cfa cfv cmul co nncn syl vj cv cn0 wcel vk cv cn0
      wcel wa vj cv cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cfa cfv vk cv
      cfa cfv cmul co cc0 wne vj cv cfa cfv cn wcel vk cv cfa cfv cn wcel vj cv
      cfa cfv vk cv cfa cfv cmul co cn wcel vj cv cn0 wcel vk cv cn0 wcel vj cv
      cfa cfv vk cv cfa cfv nnmulcl vj cv faccl vk cv faccl syl2an vj cv cfa
      cfv vk cv cfa cfv cmul co nnne0 syl syl3anc vj cv c1 cN cfz co wcel vk cv
      cN vj cv cmin co c1 caddc co cN cfz co wcel wa vj cv cn wcel vj cv cn0
      wcel vj cv c1 cN cfz co wcel vj cv cn wcel vk cv cN vj cv cmin co c1
      caddc co cN cfz co wcel vj cv cN elfznn adantr vj cv nnnn0 syl vj cv c1
      cN cfz co wcel vk cv cN vj cv cmin co c1 caddc co cN cfz co wcel wa vk cv
      cn wcel vk cv cn0 wcel vj vk cN efaddlem17.1 efaddlem2 vk cv nnnn0 syl
      sylanc cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa
      cfv cmul co cdiv co abscl syl r19.21aiva sylanc rgen cN vj cv cmin co c1
      caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa
      cfv vk cv cfa cfv cmul co cdiv co cabs cfv vk csu vj c1 cN fsumrecl mp2an
      cA cB cS cT vj vk cN efaddlem17.1 efaddlem17.2 efaddlem17.3 efaddlem17.4
      efaddlem17.5 efaddlem18 letri mp2an $.
      $( [16-Feb-2006] $) $( [8-Jan-2006] $)

    $( Lemma for ~ efaddi .  Further upper bound for the summation terms on the
       right-hand side of ~ efaddlem6 . $)
    efaddlem20 $p |- ( ( N ^ 2 ) x. ( ( T ^ S ) / ( ! ` S ) ) ) <_
                     ( ( ( S ^ 2 ) x. ( ( 4 x. T ) ^ S ) ) / ( ! ` S ) ) $=
      cN c2 cexp co cT cS cexp co cS cfa cfv cdiv co cmul co c2 cS cmul co c2
      cexp co cT cS cexp co cmul co cS cfa cfv cdiv co cle wbr c2 cS cmul co c2
      cexp co cT cS cexp co cmul co cS cfa cfv cdiv co cS c2 cexp co c4 cT cmul
      co cS cexp co cmul co cS cfa cfv cdiv co cle wbr cN c2 cexp co cT cS cexp
      co cS cfa cfv cdiv co cmul co cS c2 cexp co c4 cT cmul co cS cexp co cmul
      co cS cfa cfv cdiv co cle wbr cN c2 cexp co cT cS cexp co cS cfa cfv cdiv
      co cmul co c2 cS cmul co c2 cexp co cT cS cexp co cS cfa cfv cdiv co cmul
      co c2 cS cmul co c2 cexp co cT cS cexp co cmul co cS cfa cfv cdiv co cle
      cN c2 cexp co cr wcel c2 cS cmul co c2 cexp co cr wcel cT cS cexp co cS
      cfa cfv cdiv co cr wcel w3a cc0 cT cS cexp co cS cfa cfv cdiv co cle wbr
      cN c2 cexp co c2 cS cmul co c2 cexp co cle wbr wa cN c2 cexp co cT cS
      cexp co cS cfa cfv cdiv co cmul co c2 cS cmul co c2 cexp co cT cS cexp co
      cS cfa cfv cdiv co cmul co cle wbr cN c2 cexp co cr wcel c2 cS cmul co c2
      cexp co cr wcel cT cS cexp co cS cfa cfv cdiv co cr wcel cN c2 cexp co cN
      efaddlem17.1 nnsqcli nnrei c2 cS cmul co c2 cS 2re cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnrei remulcli resqcli cT cS cexp co cS cfa cfv cT
      cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT efaddlem17.2
      efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an cS cfa cfv cS cn0 wcel
      cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS
      faccl ax-mp nnrei cS cn0 wcel cS cfa cfv cc0 wne cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cS facne0 ax-mp redivcli 3pm3.2i cc0 cT cS
      cexp co cS cfa cfv cdiv co cle wbr cN c2 cexp co c2 cS cmul co c2 cexp co
      cle wbr cc0 cT cS cexp co cle wbr cc0 cS cfa cfv clt wbr cc0 cT cS cexp
      co cS cfa cfv cdiv co cle wbr cT cS cexp co cT cn0 wcel cS cn0 wcel cT cS
      cexp co cn0 wcel cT cA cB cT efaddlem17.2 efaddlem17.3 efaddlem17.5
      efaddlem7 nnnn0i cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT
      cS nn0expcl mp2an nn0ge0i cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS
      cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS faccl ax-mp nngt0i cT cS
      cexp co cS cfa cfv cT cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB
      cT efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an cS cfa cfv
      cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnnn0i cS faccl ax-mp nnrei divge0i mp2an cN cr wcel cc0 cN cle
      wbr wa c2 cS cmul co cr wcel cN c2 cS cmul co cle wbr wa cN c2 cexp co c2
      cS cmul co c2 cexp co cle wbr cN cr wcel cc0 cN cle wbr cN efaddlem17.1
      nnrei cc0 cN 0re cN efaddlem17.1 nnrei cN efaddlem17.1 nngt0i ltleii
      pm3.2i c2 cS cmul co cr wcel cN c2 cS cmul co cle wbr c2 cS 2re cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnrei remulcli cN c2 cN c1 caddc co
      c2 cdiv co cfl cfv cmul co c2 cS cmul co cle cN cz wcel cN c2 cN c1 caddc
      co c2 cdiv co cfl cfv cmul co cle wbr cN cn wcel cN cz wcel efaddlem17.1
      cN nnz ax-mp cN flhalf ax-mp cS cN c1 caddc co c2 cdiv co cfl cfv c2 cmul
      efaddlem17.4 opreq2i breqtrri pm3.2i cN c2 cS cmul co le2sq2 mp2an pm3.2i
      cN c2 cexp co c2 cS cmul co c2 cexp co cT cS cexp co cS cfa cfv cdiv co
      lemul1aOLD mp2an c2 cS cmul co c2 cexp co cT cS cexp co cS cfa cfv c2 cS
      cmul co c2 cexp co c2 cS cmul co c2 cS 2re cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnrei remulcli resqcli recni cT cS cexp co cT cr
      wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT efaddlem17.2
      efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an recni cS cfa cfv cS cn0
      wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i cS faccl ax-mp nncni cS cn0 wcel cS cfa cfv cc0 wne cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS facne0 ax-mp divassi
      breqtrri c2 cS cmul co c2 cexp co cT cS cexp co cmul co cS c2 cexp co c4
      cT cmul co cS cexp co cmul co cle wbr c2 cS cmul co c2 cexp co cT cS cexp
      co cmul co cS cfa cfv cdiv co cS c2 cexp co c4 cT cmul co cS cexp co cmul
      co cS cfa cfv cdiv co cle wbr c2 cS cmul co c2 cexp co cT cS cexp co cmul
      co cS c2 cexp co c2 c2 cexp co cT cS cexp co cmul co cmul co cS c2 cexp
      co c4 cT cmul co cS cexp co cmul co cle c2 cS cmul co c2 cexp co cT cS
      cexp co cmul co cS c2 cexp co c2 c2 cexp co cmul co cT cS cexp co cmul co
      cS c2 cexp co c2 c2 cexp co cT cS cexp co cmul co cmul co c2 cS cmul co
      c2 cexp co cS c2 cexp co c2 c2 cexp co cmul co cT cS cexp co cmul c2 cS
      cmul co c2 cexp co c2 c2 cexp co cS c2 cexp co cmul co cS c2 cexp co c2
      c2 cexp co cmul co c2 cS 2cn cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nncni sqmuli c2 c2 cexp co cS c2 cexp co c2 2cn sqcli cS c2 cexp co cS cS
      cN efaddlem17.1 efaddlem17.4 efaddlem8 nnsqcli nncni mulcomi eqtri
      opreq1i cS c2 cexp co c2 c2 cexp co cT cS cexp co cS c2 cexp co cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnsqcli nncni c2 2cn sqcli cT cS cexp
      co cT cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT efaddlem17.2
      efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an recni mulassi eqtri c2
      c2 cexp co cT cS cexp co cmul co cr wcel c4 cT cmul co cS cexp co cr wcel
      cS c2 cexp co cr wcel w3a cc0 cS c2 cexp co cle wbr c2 c2 cexp co cT cS
      cexp co cmul co c4 cT cmul co cS cexp co cle wbr wa cS c2 cexp co c2 c2
      cexp co cT cS cexp co cmul co cmul co cS c2 cexp co c4 cT cmul co cS cexp
      co cmul co cle wbr c2 c2 cexp co cT cS cexp co cmul co cr wcel c4 cT cmul
      co cS cexp co cr wcel cS c2 cexp co cr wcel c2 c2 cexp co cT cS cexp co
      c2 2re resqcli cT cr wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT
      efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an remulcli
      c4 cT cmul co cr wcel cS cn0 wcel c4 cT cmul co cS cexp co cr wcel c4 cT
      4re cT cA cB cT efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7 nnrei
      remulcli cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i c4 cT cmul
      co cS reexpcl mp2an cS c2 cexp co cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnsqcli nnrei 3pm3.2i cc0 cS c2 cexp co cle wbr c2 c2 cexp co
      cT cS cexp co cmul co c4 cT cmul co cS cexp co cle wbr cc0 cS c2 cexp co
      0re cS c2 cexp co cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnsqcli
      nnrei cS c2 cexp co cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnsqcli
      nngt0i ltleii c2 c2 cexp co cT cS cexp co cmul co c4 cS cexp co cT cS
      cexp co cmul co c4 cT cmul co cS cexp co cle c2 c2 cexp co cr wcel c4 cS
      cexp co cr wcel cT cS cexp co cr wcel w3a cc0 cT cS cexp co cle wbr c2 c2
      cexp co c4 cS cexp co cle wbr wa c2 c2 cexp co cT cS cexp co cmul co c4
      cS cexp co cT cS cexp co cmul co cle wbr c2 c2 cexp co cr wcel c4 cS cexp
      co cr wcel cT cS cexp co cr wcel c2 2re resqcli c4 cr wcel cS cn0 wcel c4
      cS cexp co cr wcel 4re cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i c4 cS reexpcl mp2an cT cr wcel cS cn0 wcel cT cS cexp co cr wcel
      cT cA cB cT efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS
      cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an 3pm3.2i
      cc0 cT cS cexp co cle wbr c2 c2 cexp co c4 cS cexp co cle wbr cT cS cexp
      co cT cn0 wcel cS cn0 wcel cT cS cexp co cn0 wcel cT cA cB cT
      efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7 nnnn0i cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS nn0expcl mp2an nn0ge0i
      c2 c2 cexp co c4 c1 cexp co c4 cS cexp co cle c2 c2 cexp co c4 c4 c1 cexp
      co sq2 c4 cc wcel c4 c1 cexp co c4 wceq c4 4re recni c4 exp1 ax-mp eqtr4i
      c4 cr wcel c1 cn0 wcel cS cn0 wcel w3a c1 c4 cle wbr c1 cS cle wbr wa c4
      c1 cexp co c4 cS cexp co cle wbr c4 cr wcel c1 cn0 wcel cS cn0 wcel 4re
      1nn0 cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i 3pm3.2i c1 c4
      cle wbr c1 cS cle wbr c1 c3 c1 caddc co c4 cle cc0 c3 cle wbr c1 c3 c1
      caddc co cle wbr cc0 c3 0re 3re 3pos ltleii c1 cr wcel c3 cr wcel cc0 c3
      cle wbr c1 c3 c1 caddc co cle wbr wb 1re 3re c1 c3 addge02 mp2an mpbi
      df-4 breqtrri cS cn wcel c1 cS cle wbr cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 cS nnge1 ax-mp pm3.2i c4 c1 cS expwordi mp2an eqbrtri pm3.2i c2
      c2 cexp co c4 cS cexp co cT cS cexp co lemul1aOLD mp2an c4 cc wcel cT cc
      wcel cS cn0 wcel c4 cT cmul co cS cexp co c4 cS cexp co cT cS cexp co
      cmul co wceq c4 4re recni cT cA cB cT efaddlem17.2 efaddlem17.3
      efaddlem17.5 efaddlem7 nncni cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i c4 cT cS mulexp mp3an breqtrri pm3.2i c2 c2 cexp co cT cS cexp co
      cmul co c4 cT cmul co cS cexp co cS c2 cexp co lemul2aOLD mp2an eqbrtri
      c2 cS cmul co c2 cexp co cT cS cexp co cmul co cr wcel cS c2 cexp co c4
      cT cmul co cS cexp co cmul co cr wcel cS cfa cfv cr wcel c2 cS cmul co c2
      cexp co cT cS cexp co cmul co cS c2 cexp co c4 cT cmul co cS cexp co cmul
      co cle wbr c2 cS cmul co c2 cexp co cT cS cexp co cmul co cS cfa cfv cdiv
      co cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cle
      wbr wb c2 cS cmul co c2 cexp co cT cS cexp co c2 cS cmul co c2 cS 2re cS
      cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnrei remulcli resqcli cT cr
      wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT efaddlem17.2
      efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an remulcli cS c2 cexp co
      c4 cT cmul co cS cexp co cS c2 cexp co cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnsqcli nnrei c4 cT cmul co cr wcel cS cn0 wcel c4 cT cmul co
      cS cexp co cr wcel c4 cT 4re cT cA cB cT efaddlem17.2 efaddlem17.3
      efaddlem17.5 efaddlem7 nnrei remulcli cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnnn0i c4 cT cmul co cS reexpcl mp2an remulcli cS cfa cfv cS
      cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i cS faccl ax-mp nnrei c2 cS cmul co c2 cexp co cT cS cexp co cmul
      co cr wcel cS c2 cexp co c4 cT cmul co cS cexp co cmul co cr wcel cS cfa
      cfv cr wcel w3a cc0 cS cfa cfv clt wbr c2 cS cmul co c2 cexp co cT cS
      cexp co cmul co cS c2 cexp co c4 cT cmul co cS cexp co cmul co cle wbr c2
      cS cmul co c2 cexp co cT cS cexp co cmul co cS cfa cfv cdiv co cS c2 cexp
      co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cle wbr wb cS cfa
      cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnnn0i cS faccl ax-mp nngt0i c2 cS cmul co c2 cexp co cT cS
      cexp co cmul co cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv
      lediv1OLD mpan2 mp3an mpbi cN c2 cexp co cT cS cexp co cS cfa cfv cdiv co
      cmul co c2 cS cmul co c2 cexp co cT cS cexp co cmul co cS cfa cfv cdiv co
      cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cN c2
      cexp co cT cS cexp co cS cfa cfv cdiv co cN c2 cexp co cN efaddlem17.1
      nnsqcli nnrei cT cS cexp co cS cfa cfv cT cr wcel cS cn0 wcel cT cS cexp
      co cr wcel cT cA cB cT efaddlem17.2 efaddlem17.3 efaddlem17.5 efaddlem7
      nnrei cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl
      mp2an cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei cS cn0 wcel cS cfa cfv
      cc0 wne cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS facne0
      ax-mp redivcli remulcli c2 cS cmul co c2 cexp co cT cS cexp co cmul co cS
      cfa cfv c2 cS cmul co c2 cexp co cT cS cexp co c2 cS cmul co c2 cS 2re cS
      cS cN efaddlem17.1 efaddlem17.4 efaddlem8 nnrei remulcli resqcli cT cr
      wcel cS cn0 wcel cT cS cexp co cr wcel cT cA cB cT efaddlem17.2
      efaddlem17.3 efaddlem17.5 efaddlem7 nnrei cS cS cN efaddlem17.1
      efaddlem17.4 efaddlem8 nnnn0i cT cS reexpcl mp2an remulcli cS cfa cfv cS
      cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i cS faccl ax-mp nnrei cS cn0 wcel cS cfa cfv cc0 wne cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS facne0 ax-mp redivcli cS c2
      cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cS c2 cexp co c4 cT
      cmul co cS cexp co cS c2 cexp co cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnsqcli nnrei c4 cT cmul co cr wcel cS cn0 wcel c4 cT cmul co
      cS cexp co cr wcel c4 cT 4re cT cA cB cT efaddlem17.2 efaddlem17.3
      efaddlem17.5 efaddlem7 nnrei remulcli cS cS cN efaddlem17.1 efaddlem17.4
      efaddlem8 nnnn0i c4 cT cmul co cS reexpcl mp2an remulcli cS cfa cfv cS
      cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem17.1 efaddlem17.4 efaddlem8
      nnnn0i cS faccl ax-mp nnrei cS cn0 wcel cS cfa cfv cc0 wne cS cS cN
      efaddlem17.1 efaddlem17.4 efaddlem8 nnnn0i cS facne0 ax-mp redivcli letri
      mp2an $.
      $( [15-Feb-2006] $) $( [8-Jan-2006] $)
  $}

  ${
    efaddlem21.1 $e |- A e. CC $.
    efaddlem21.2 $e |- B e. CC $.
    efaddlem21.3 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                     ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    efaddlem21.4 $e |- R = ( 2 x. ( ( 2 ^ ( 3 ^ 2 ) ) x.
                      ( ( 4 x. T ) ^ ( ( 4 x. T ) + 3 ) ) ) ) $.
    $( Lemma for ~ efaddi .  ` R ` will be part of our final upper bound for
       the summation on the right-hand side of ~ efaddlem6 ; importantly, ` R `
       is independent of ` N ` . $)
    efaddlem21 $p |- R e. NN $=
      cR c2 c2 c3 c2 cexp co cexp co c4 cT cmul co c4 cT cmul co c3 caddc co
      cexp co cmul co cmul co cn efaddlem21.4 c2 cn wcel c2 c3 c2 cexp co cexp
      co c4 cT cmul co c4 cT cmul co c3 caddc co cexp co cmul co cn wcel c2 c2
      c3 c2 cexp co cexp co c4 cT cmul co c4 cT cmul co c3 caddc co cexp co
      cmul co cmul co cn wcel 2nn c2 c3 c2 cexp co cexp co cn wcel c4 cT cmul
      co c4 cT cmul co c3 caddc co cexp co cn wcel c2 c3 c2 cexp co cexp co c4
      cT cmul co c4 cT cmul co c3 caddc co cexp co cmul co cn wcel c2 cn wcel
      c3 c2 cexp co cn0 wcel c2 c3 c2 cexp co cexp co cn wcel 2nn c3 c2 cexp co
      c3 3nn nnsqcli nnnn0i c2 c3 c2 cexp co nnexpcl mp2an c4 cT cmul co cn
      wcel c4 cT cmul co c3 caddc co cn0 wcel c4 cT cmul co c4 cT cmul co c3
      caddc co cexp co cn wcel c4 cn wcel cT cn wcel c4 cT cmul co cn wcel 4nn
      cA cB cT efaddlem21.1 efaddlem21.2 efaddlem21.3 efaddlem7 c4 cT nnmulcl
      mp2an c4 cT cmul co c3 c4 cT cmul co c4 cn wcel cT cn wcel c4 cT cmul co
      cn wcel 4nn cA cB cT efaddlem21.1 efaddlem21.2 efaddlem21.3 efaddlem7 c4
      cT nnmulcl mp2an nnnn0i c3 3nn nnnn0i nn0addcli c4 cT cmul co c4 cT cmul
      co c3 caddc co nnexpcl mp2an c2 c3 c2 cexp co cexp co c4 cT cmul co c4 cT
      cmul co c3 caddc co cexp co nnmulcl mp2an c2 c2 c3 c2 cexp co cexp co c4
      cT cmul co c4 cT cmul co c3 caddc co cexp co cmul co nnmulcl mp2an
      eqeltri $.
      $( [16-Feb-2006] $) $( [8-Jan-2006] $)
  $}

  ${
    $d j k N $.  $d j k S $.  $d j k T $.
    efaddlem22.1 $e |- N e. NN $.
    efaddlem22.2 $e |- A e. CC $.
    efaddlem22.3 $e |- B e. CC $.
    efaddlem22.4 $e |- S = ( |_ ` ( ( N + 1 ) / 2 ) ) $.
    efaddlem22.5 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                     ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    efaddlem22.6 $e |- R = ( 2 x. ( ( 2 ^ ( 3 ^ 2 ) ) x.
                      ( ( 4 x. T ) ^ ( ( 4 x. T ) + 3 ) ) ) ) $.
    $( Lemma for ~ efaddi .  The final upper bound for the summation on the
       right-hand side of ~ efaddlem6 .  The key theorem used is ~ faclbnd5 ,
       which shows that the factorial grows faster than powers.  As the number
       of terms ` N ` grows to infinity, the sum shrinks to zero, since ` R `
       is independent of ` N ` . $)
    efaddlem22 $p |- ( abs ` sum_ j e. ( 1 ... N ) sum_ k e.
    ( ( ( N - j ) + 1 ) ... N ) ( ( ( A ^ j ) x. ( B ^ k ) ) / ( ( ! ` j ) x.
                     ( ! ` k ) ) ) ) < ( ( 2 x. R ) / N ) $=
      c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      vj csu cabs cfv cR cS cdiv co clt wbr cR cS cdiv co c2 cR cmul co cN cdiv
      co cle wbr c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv
      cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv
      co vk csu vj csu cabs cfv c2 cR cmul co cN cdiv co clt wbr c1 cN cfz co
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs
      cfv cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cle
      wbr cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cR
      cS cdiv co clt wbr c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA
      vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul
      co cdiv co vk csu vj csu cabs cfv cR cS cdiv co clt wbr c1 cN cfz co cN
      vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs
      cfv cN c2 cexp co cT cS cexp co cS cfa cfv cdiv co cmul co cle wbr cN c2
      cexp co cT cS cexp co cS cfa cfv cdiv co cmul co cS c2 cexp co c4 cT cmul
      co cS cexp co cmul co cS cfa cfv cdiv co cle wbr c1 cN cfz co cN vj cv
      cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co
      vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs cfv cS c2
      cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cle wbr c1 cN
      cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv
      cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu
      cabs cfv c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cT cS cexp
      co cS cfa cfv cdiv co vk csu vj csu cle wbr c1 cN cfz co cN vj cv cmin co
      c1 caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu vj csu cN
      c2 cexp co cT cS cexp co cS cfa cfv cdiv co cmul co cle wbr c1 cN cfz co
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs
      cfv cN c2 cexp co cT cS cexp co cS cfa cfv cdiv co cmul co cle wbr cA cB
      cS cT vj vk cN efaddlem22.1 efaddlem22.2 efaddlem22.3 efaddlem22.4
      efaddlem22.5 efaddlem19 cT cS cexp co cS cfa cfv cdiv co vj vk cN
      efaddlem22.1 cT cS cexp co cS cfa cfv cT cr wcel cS cn0 wcel cT cS cexp
      co cr wcel cT cA cB cT efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem7
      nnrei cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cT cS reexpcl
      mp2an cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1
      efaddlem22.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei cS cfa cfv cS cn0 wcel
      cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS
      faccl ax-mp nnne0i redivcli cc0 cT cS cexp co cle wbr cc0 cS cfa cfv clt
      wbr cc0 cT cS cexp co cS cfa cfv cdiv co cle wbr cT cS cexp co cT cn0
      wcel cS cn0 wcel cT cS cexp co cn0 wcel cT cA cB cT efaddlem22.2
      efaddlem22.3 efaddlem22.5 efaddlem7 nnnn0i cS cS cN efaddlem22.1
      efaddlem22.4 efaddlem8 nnnn0i cT cS nn0expcl mp2an nn0ge0i cS cfa cfv cS
      cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i cS faccl ax-mp nngt0i cT cS cexp co cS cfa cfv cT cr wcel cS cn0
      wcel cT cS cexp co cr wcel cT cA cB cT efaddlem22.2 efaddlem22.3
      efaddlem22.5 efaddlem7 nnrei cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i cT cS reexpcl mp2an cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS
      cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei
      divge0i mp2an efaddlem16 c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu cabs cfv c1 cN cfz co cN vj cv cmin co c1
      caddc co cN cfz co cT cS cexp co cS cfa cfv cdiv co vk csu vj csu cN c2
      cexp co cT cS cexp co cS cfa cfv cdiv co cmul co cA cB vj vk cN
      efaddlem22.1 efaddlem22.2 efaddlem22.3 efaddlem4 cA cB cS cT vj vk cN
      efaddlem22.1 efaddlem22.2 efaddlem22.3 efaddlem22.4 efaddlem22.5
      efaddlem18 cN c2 cexp co cT cS cexp co cS cfa cfv cdiv co cN c2 cexp co
      cN efaddlem22.1 nnsqcli nnrei cT cS cexp co cS cfa cfv cT cr wcel cS cn0
      wcel cT cS cexp co cr wcel cT cA cB cT efaddlem22.2 efaddlem22.3
      efaddlem22.5 efaddlem7 nnrei cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i cT cS reexpcl mp2an cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS
      cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei cS
      cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4
      efaddlem8 nnnn0i cS faccl ax-mp nnne0i redivcli remulcli letri mp2an cA
      cB cS cT cN efaddlem22.1 efaddlem22.2 efaddlem22.3 efaddlem22.4
      efaddlem22.5 efaddlem20 c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu cabs cfv cN c2 cexp co cT cS cexp co cS cfa
      cfv cdiv co cmul co cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa
      cfv cdiv co cA cB vj vk cN efaddlem22.1 efaddlem22.2 efaddlem22.3
      efaddlem4 cN c2 cexp co cT cS cexp co cS cfa cfv cdiv co cN c2 cexp co cN
      efaddlem22.1 nnsqcli nnrei cT cS cexp co cS cfa cfv cT cr wcel cS cn0
      wcel cT cS cexp co cr wcel cT cA cB cT efaddlem22.2 efaddlem22.3
      efaddlem22.5 efaddlem7 nnrei cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i cT cS reexpcl mp2an cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS
      cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei cS
      cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4
      efaddlem8 nnnn0i cS faccl ax-mp nnne0i redivcli remulcli cS c2 cexp co c4
      cT cmul co cS cexp co cmul co cS cfa cfv cS c2 cexp co c4 cT cmul co cS
      cexp co cS cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnrei resqcli c4
      cT cmul co cr wcel cS cn0 wcel c4 cT cmul co cS cexp co cr wcel c4 cT 4re
      cT cA cB cT efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem7 nnrei
      remulcli cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i c4 cT cmul
      co cS reexpcl mp2an remulcli cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS
      cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS faccl ax-mp nnrei cS
      cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4
      efaddlem8 nnnn0i cS faccl ax-mp nnne0i redivcli letri mp2an cS c2 cexp co
      c4 cT cmul co cS cexp co cmul co cS cmul co cR cS cfa cfv cmul co clt wbr
      cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cR cS
      cdiv co clt wbr cS c3 cexp co c4 cT cmul co cS cexp co cmul co c2 c2 c3
      c2 cexp co cexp co c4 cT cmul co c4 cT cmul co c3 caddc co cexp co cmul
      co cmul co cS cfa cfv cmul co cS c2 cexp co c4 cT cmul co cS cexp co cmul
      co cS cmul co cR cS cfa cfv cmul co clt cS cn0 wcel c3 cn0 wcel c4 cT
      cmul co cn wcel cS c3 cexp co c4 cT cmul co cS cexp co cmul co c2 c2 c3
      c2 cexp co cexp co c4 cT cmul co c4 cT cmul co c3 caddc co cexp co cmul
      co cmul co cS cfa cfv cmul co clt wbr cS cS cN efaddlem22.1 efaddlem22.4
      efaddlem8 nnnn0i c3 3nn nnnn0i c4 cn wcel cT cn wcel c4 cT cmul co cn
      wcel 4nn cA cB cT efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem7 c4 cT
      nnmulcl mp2an c3 c4 cT cmul co cS faclbnd5 mp3an cS c2 cexp co c4 cT cmul
      co cS cexp co cmul co cS cmul co cS c2 cexp co cS cmul co c4 cT cmul co
      cS cexp co cmul co cS c3 cexp co c4 cT cmul co cS cexp co cmul co cS c2
      cexp co c4 cT cmul co cS cexp co cS cS c2 cexp co cS cS cS cN
      efaddlem22.1 efaddlem22.4 efaddlem8 nnrei resqcli recni c4 cT cmul co cS
      cexp co c4 cT cmul co cr wcel cS cn0 wcel c4 cT cmul co cS cexp co cr
      wcel c4 cT 4re cT cA cB cT efaddlem22.2 efaddlem22.3 efaddlem22.5
      efaddlem7 nnrei remulcli cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i c4 cT cmul co cS reexpcl mp2an recni cS cS cN efaddlem22.1
      efaddlem22.4 efaddlem8 nncni mul23i cS c3 cexp co cS c2 cexp co cS cmul
      co c4 cT cmul co cS cexp co cmul cS c3 cexp co cS c2 c1 caddc co cexp co
      cS c2 cexp co cS cmul co c3 c2 c1 caddc co cS cexp df-3 opreq2i cS cc
      wcel c2 cn0 wcel cS c2 c1 caddc co cexp co cS c2 cexp co cS cmul co wceq
      cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nncni 2nn0 cS c2 expp1 mp2an
      eqtri opreq1i eqtr4i cR c2 c2 c3 c2 cexp co cexp co c4 cT cmul co c4 cT
      cmul co c3 caddc co cexp co cmul co cmul co cS cfa cfv cmul efaddlem22.6
      opreq1i 3brtr4i cS c2 cexp co c4 cT cmul co cS cexp co cmul co cr wcel cS
      cr wcel wa cR cr wcel cS cfa cfv cr wcel wa cc0 cS clt wbr cc0 cS cfa cfv
      clt wbr wa cS c2 cexp co c4 cT cmul co cS cexp co cmul co cS cmul co cR
      cS cfa cfv cmul co clt wbr cS c2 cexp co c4 cT cmul co cS cexp co cmul co
      cS cfa cfv cdiv co cR cS cdiv co clt wbr wb cS c2 cexp co c4 cT cmul co
      cS cexp co cmul co cr wcel cS cr wcel cS c2 cexp co c4 cT cmul co cS cexp
      co cS cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnrei resqcli c4 cT
      cmul co cr wcel cS cn0 wcel c4 cT cmul co cS cexp co cr wcel c4 cT 4re cT
      cA cB cT efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem7 nnrei remulcli
      cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i c4 cT cmul co cS
      reexpcl mp2an remulcli cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnrei
      pm3.2i cR cr wcel cS cfa cfv cr wcel cR cA cB cR cT efaddlem22.2
      efaddlem22.3 efaddlem22.5 efaddlem22.6 efaddlem21 nnrei cS cfa cfv cS cn0
      wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i cS faccl ax-mp nnrei pm3.2i cc0 cS clt wbr cc0 cS cfa cfv clt wbr
      cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nngt0i cS cfa cfv cS cn0
      wcel cS cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i cS faccl ax-mp nngt0i pm3.2i cS c2 cexp co c4 cT cmul co cS cexp
      co cmul co cS cR cS cfa cfv lt2mul2divOLD mp3an mpbi c1 cN cfz co cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs cfv cS
      c2 cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cdiv co cR cS cdiv
      co cA cB vj vk cN efaddlem22.1 efaddlem22.2 efaddlem22.3 efaddlem4 cS c2
      cexp co c4 cT cmul co cS cexp co cmul co cS cfa cfv cS c2 cexp co c4 cT
      cmul co cS cexp co cS cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnrei
      resqcli c4 cT cmul co cr wcel cS cn0 wcel c4 cT cmul co cS cexp co cr
      wcel c4 cT 4re cT cA cB cT efaddlem22.2 efaddlem22.3 efaddlem22.5
      efaddlem7 nnrei remulcli cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8
      nnnn0i c4 cT cmul co cS reexpcl mp2an remulcli cS cfa cfv cS cn0 wcel cS
      cfa cfv cn wcel cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS
      faccl ax-mp nnrei cS cfa cfv cS cn0 wcel cS cfa cfv cn wcel cS cS cN
      efaddlem22.1 efaddlem22.4 efaddlem8 nnnn0i cS faccl ax-mp nnne0i redivcli
      cR cS cR cA cB cR cT efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem22.6
      efaddlem21 nnrei cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnrei cS cS
      cN efaddlem22.1 efaddlem22.4 efaddlem8 nnne0i redivcli lelttri mp2an c2
      cR cmul co c2 cS cmul co cdiv co cR cS cdiv co c2 cR cmul co cN cdiv co
      cle cR cc wcel cS cc wcel cS cc0 wne wa c2 cc wcel c2 cc0 wne wa c2 cR
      cmul co c2 cS cmul co cdiv co cR cS cdiv co wceq cR cA cB cR cT
      efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem22.6 efaddlem21 nncni cS
      cc wcel cS cc0 wne cS cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nncni cS
      cS cN efaddlem22.1 efaddlem22.4 efaddlem8 nnne0i pm3.2i c2 cc wcel c2 cc0
      wne 2cn 2ne0 pm3.2i cR cS c2 divcan5 mp3an cN c2 cS cmul co cle wbr c2 cR
      cmul co c2 cS cmul co cdiv co c2 cR cmul co cN cdiv co cle wbr cN c2 cN
      c1 caddc co c2 cdiv co cfl cfv cmul co c2 cS cmul co cle cN cz wcel cN c2
      cN c1 caddc co c2 cdiv co cfl cfv cmul co cle wbr cN cn wcel cN cz wcel
      efaddlem22.1 cN nnz ax-mp cN flhalf ax-mp cS cN c1 caddc co c2 cdiv co
      cfl cfv c2 cmul efaddlem22.4 opreq2i breqtrri cN cr wcel cc0 cN clt wbr
      wa c2 cS cmul co cr wcel cc0 c2 cS cmul co clt wbr wa c2 cR cmul co cr
      wcel cc0 c2 cR cmul co clt wbr wa cN c2 cS cmul co cle wbr c2 cR cmul co
      c2 cS cmul co cdiv co c2 cR cmul co cN cdiv co cle wbr wb cN cr wcel cc0
      cN clt wbr cN efaddlem22.1 nnrei cN efaddlem22.1 nngt0i pm3.2i c2 cS cmul
      co cr wcel cc0 c2 cS cmul co clt wbr c2 cS 2re cS cS cN efaddlem22.1
      efaddlem22.4 efaddlem8 nnrei remulcli c2 cS cmul co c2 cn wcel cS cn wcel
      c2 cS cmul co cn wcel 2nn cS cN efaddlem22.1 efaddlem22.4 efaddlem8 c2 cS
      nnmulcl mp2an nngt0i pm3.2i c2 cR cmul co cr wcel cc0 c2 cR cmul co clt
      wbr c2 cR 2re cR cA cB cR cT efaddlem22.2 efaddlem22.3 efaddlem22.5
      efaddlem22.6 efaddlem21 nnrei remulcli c2 cR cmul co c2 cn wcel cR cn
      wcel c2 cR cmul co cn wcel 2nn cA cB cR cT efaddlem22.2 efaddlem22.3
      efaddlem22.5 efaddlem22.6 efaddlem21 c2 cR nnmulcl mp2an nngt0i pm3.2i cN
      c2 cS cmul co c2 cR cmul co lediv2 mp3an mpbi eqbrtrri c1 cN cfz co cN vj
      cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul
      co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs cfv cR
      cS cdiv co c2 cR cmul co cN cdiv co cA cB vj vk cN efaddlem22.1
      efaddlem22.2 efaddlem22.3 efaddlem4 cR cS cR cA cB cR cT efaddlem22.2
      efaddlem22.3 efaddlem22.5 efaddlem22.6 efaddlem21 nnrei cS cS cN
      efaddlem22.1 efaddlem22.4 efaddlem8 nnrei cS cS cN efaddlem22.1
      efaddlem22.4 efaddlem8 nnne0i redivcli c2 cR cmul co cN c2 cR 2re cR cA
      cB cR cT efaddlem22.2 efaddlem22.3 efaddlem22.5 efaddlem22.6 efaddlem21
      nnrei remulcli cN efaddlem22.1 nnrei cN efaddlem22.1 nnne0i redivcli
      ltletri mp2an $.
      $( [16-Feb-2006] $) $( [9-Jan-2006] $)
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k N $.  $d j k T $.
    efaddlem23.1 $e |- N e. NN $.
    efaddlem23.2 $e |- A e. CC $.
    efaddlem23.3 $e |- B e. CC $.
    efaddlem23.4 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                      ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    efaddlem23.5 $e |- R = ( 2 x. ( ( 2 ^ ( 3 ^ 2 ) ) x.
                      ( ( 4 x. T ) ^ ( ( 4 x. T ) + 3 ) ) ) ) $.
    $( Lemma for ~ efaddi .  Given any positive ` x ` , no matter how small,
       there is an ` N ` such that the difference between the truncated series
       for ` ( exp `` A ) x. ( exp `` B ) ` and ` exp `` ( A + B ) ` is less
       than ` x ` .  Here we show an explicit lower bound for ` N ` . $)
    efaddlem23 $p |- ( ( ( x e. RR /\ 0 < x ) /\ ( ( |_ `
           ( ( 2 x. R ) / x ) ) + 1 ) <_ N ) ->
               ( abs ` ( ( sum_ j e. ( 0 ... N ) ( ( A ^ j ) / ( ! ` j ) ) x.
                        sum_ k e. ( 0 ... N ) ( ( B ^ k ) / ( ! ` k ) ) ) -
           sum_ j e. ( 0 ... N ) ( ( ( A + B ) ^ j ) / ( ! ` j ) ) ) ) < x ) $=
      vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1
      caddc co cN cle wbr wa c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz
      co cA vj cv cexp co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv
      cmul co cdiv co vk csu vj csu cabs cfv vx cv cc0 cN cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk csu cmul co cc0 cN cfz co cA cB caddc co vj cv cexp co vj
      cv cfa cfv cdiv co vj csu cmin co cabs cfv clt vx cv cr wcel cc0 vx cv
      clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN cle wbr wa
      c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB
      vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu
      vj csu cabs cfv c2 cR cmul co cN cdiv co vx cv c1 cN cfz co cN vj cv cmin
      co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co cmul co vj cv
      cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs cfv cr wcel vx
      cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1
      caddc co cN cle wbr wa cA cB vj vk cN efaddlem23.1 efaddlem23.2
      efaddlem23.3 efaddlem4 a1i c2 cR cmul co cN cdiv co cr wcel vx cv cr wcel
      cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN
      cle wbr wa c2 cR cmul co cN c2 cR 2re cR cA cB cR cT efaddlem23.2
      efaddlem23.3 efaddlem23.4 efaddlem23.5 efaddlem21 nnrei remulcli cN
      efaddlem23.1 nnrei cN efaddlem23.1 nnne0i redivcli a1i vx cv cr wcel cc0
      vx cv clt wbr c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN cle wbr
      simpll c1 cN cfz co cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp
      co cB vk cv cexp co cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co
      vk csu vj csu cabs cfv c2 cR cmul co cN cdiv co clt wbr vx cv cr wcel cc0
      vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN cle
      wbr wa cA cB cR cN c1 caddc co c2 cdiv co cfl cfv cT vj vk cN
      efaddlem23.1 efaddlem23.2 efaddlem23.3 cN c1 caddc co c2 cdiv co cfl cfv
      eqid efaddlem23.4 efaddlem23.5 efaddlem22 a1i vx cv cr wcel cc0 vx cv clt
      wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN cle wbr wa c2
      cR cmul co vx cv cdiv co cN clt wbr c2 cR cmul co cN cdiv co vx cv clt
      wbr vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl
      cfv c1 caddc co cN cle wbr c2 cR cmul co vx cv cdiv co cN clt wbr vx cv
      cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co c2 cR cmul co vx
      cv cdiv co cfl cfv c1 caddc co clt wbr c2 cR cmul co vx cv cdiv co cfl
      cfv c1 caddc co cN cle wbr c2 cR cmul co vx cv cdiv co cN clt wbr vx cv
      cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cr wcel c2 cR
      cmul co vx cv cdiv co c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co clt
      wbr c2 cR cmul co cr wcel vx cv cr wcel vx cv cc0 wne c2 cR cmul co vx cv
      cdiv co cr wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv
      redivcl c2 cR cmul co cr wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR
      2re cR cA cB cR cT efaddlem23.2 efaddlem23.3 efaddlem23.4 efaddlem23.5
      efaddlem21 nnrei remulcli a1i vx cv cr wcel cc0 vx cv clt wbr pm3.26 vx
      cv gt0ne0 syl3anc c2 cR cmul co vx cv cdiv co flltp1 syl c2 cR cmul co vx
      cv cdiv co cr wcel c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cr
      wcel cN cr wcel c2 cR cmul co vx cv cdiv co c2 cR cmul co vx cv cdiv co
      cfl cfv c1 caddc co clt wbr c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc
      co cN cle wbr wa c2 cR cmul co vx cv cdiv co cN clt wbr wi vx cv cr wcel
      cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co c2 cR cmul co vx cv cdiv
      co cfl cfv c1 caddc co cN ltletr c2 cR cmul co cr wcel vx cv cr wcel vx
      cv cc0 wne c2 cR cmul co vx cv cdiv co cr wcel vx cv cr wcel cc0 vx cv
      clt wbr wa c2 cR cmul co vx cv redivcl c2 cR cmul co cr wcel vx cv cr
      wcel cc0 vx cv clt wbr wa c2 cR 2re cR cA cB cR cT efaddlem23.2
      efaddlem23.3 efaddlem23.4 efaddlem23.5 efaddlem21 nnrei remulcli a1i vx
      cv cr wcel cc0 vx cv clt wbr pm3.26 vx cv gt0ne0 syl3anc vx cv cr wcel
      cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv cr wcel c2 cR
      cmul co vx cv cdiv co cfl cfv c1 caddc co cr wcel vx cv cr wcel cc0 vx cv
      clt wbr wa c2 cR cmul co vx cv cdiv co cr wcel c2 cR cmul co vx cv cdiv
      co cfl cfv cr wcel c2 cR cmul co cr wcel vx cv cr wcel vx cv cc0 wne c2
      cR cmul co vx cv cdiv co cr wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR
      cmul co vx cv redivcl c2 cR cmul co cr wcel vx cv cr wcel cc0 vx cv clt
      wbr wa c2 cR 2re cR cA cB cR cT efaddlem23.2 efaddlem23.3 efaddlem23.4
      efaddlem23.5 efaddlem21 nnrei remulcli a1i vx cv cr wcel cc0 vx cv clt
      wbr pm3.26 vx cv gt0ne0 syl3anc c2 cR cmul co vx cv cdiv co reflcl syl c2
      cR cmul co vx cv cdiv co cfl cfv peano2re syl cN cr wcel vx cv cr wcel
      cc0 vx cv clt wbr wa cN efaddlem23.1 nnrei a1i syl3anc mpand imp vx cv cr
      wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cN clt wbr c2 cR
      cmul co cN cdiv co vx cv clt wbr wb c2 cR cmul co vx cv cdiv co cfl cfv
      c1 caddc co cN cle wbr c2 cR cmul co cr wcel vx cv cr wcel cc0 vx cv clt
      wbr wa c2 cR cmul co vx cv cdiv co cN clt wbr c2 cR cmul co cN cdiv co vx
      cv clt wbr wb vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co cr wcel vx
      cv cr wcel cc0 vx cv clt wbr wa cN cr wcel cc0 cN clt wbr wa c2 cR cmul
      co vx cv cdiv co cN clt wbr c2 cR cmul co cN cdiv co vx cv clt wbr wb cN
      cr wcel cc0 cN clt wbr cN efaddlem23.1 nnrei cN efaddlem23.1 nngt0i
      pm3.2i c2 cR cmul co vx cv cN ltdiv23 mp3an3 c2 cR 2re cR cA cB cR cT
      efaddlem23.2 efaddlem23.3 efaddlem23.4 efaddlem23.5 efaddlem21 nnrei
      remulcli vx cv cr wcel cc0 vx cv clt wbr wa id sylancr adantr mpbid lttrd
      cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co
      cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co c1 cN cfz co
      cN vj cv cmin co c1 caddc co cN cfz co cA vj cv cexp co cB vk cv cexp co
      cmul co vj cv cfa cfv vk cv cfa cfv cmul co cdiv co vk csu vj csu cabs cA
      cB vj vk cN efaddlem23.1 efaddlem23.2 efaddlem23.3 efaddlem6 fveq2i
      syl5eqbr $.
      $( [16-Feb-2006] $) $( [13-Jan-2006] $)
  $}

  ${
    $d j k m A $.  $d j k m B $.  $d j k N $.  $d m n R $.  $d j k T $.
    $d m n j k x $.
    efaddlem24.1 $e |- A e. CC $.
    efaddlem24.2 $e |- B e. CC $.
    efaddlem24.3 $e |- T = ( ( ( |_ ` ( ( abs ` A ) + 1 ) ) x.
                       ( |_ ` ( ( abs ` B ) + 1 ) ) ) ^ 2 ) $.
    efaddlem24.4 $e |- R = ( 2 x. ( ( 2 ^ ( 3 ^ 2 ) ) x.
                      ( ( 4 x. T ) ^ ( ( 4 x. T ) + 3 ) ) ) ) $.
    $( Lemma for ~ efaddi .  Apply the Weak Deduction Theorem to ~ efaddlem23
       to make ` N ` an antecedent. $)
    efaddlem24 $p |- ( ( ( x e. RR /\ 0 < x ) /\ N e. NN /\ ( ( |_ `
   ( ( 2 x. R ) / x ) ) + 1 ) <_ N ) ->
               ( abs ` ( ( sum_ j e. ( 0 ... N ) ( ( A ^ j ) / ( ! ` j ) ) x.
                        sum_ k e. ( 0 ... N ) ( ( B ^ k ) / ( ! ` k ) ) ) -
           sum_ j e. ( 0 ... N ) ( ( ( A + B ) ^ j ) / ( ! ` j ) ) ) ) < x ) $=
      cN cn wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co
      cfl cfv c1 caddc co cN cle wbr cc0 cN cfz co cA vj cv cexp co vj cv cfa
      cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp co vk cv cfa cfv cdiv co
      vk csu cmul co cc0 cN cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cmin co cabs cfv vx cv clt wbr cN cn wcel vx cv cr wcel
      cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN
      cle wbr cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0
      cN cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN
      cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co
      cabs cfv vx cv clt wbr cN cn wcel vx cv cr wcel cc0 vx cv clt wbr wa c2
      cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN cle wbr wa cc0 cN cfz co
      cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp
      co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co cA cB caddc co vj
      cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi
      vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1
      caddc co cN cn wcel cN c1 cif cle wbr wa cc0 cN cn wcel cN c1 cif cfz co
      cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cn wcel cN c1 cif
      cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cn
      wcel cN c1 cif cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co
      vj csu cmin co cabs cfv vx cv clt wbr wi cN c1 cN cN cn wcel cN c1 cif
      wceq vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co cfl
      cfv c1 caddc co cN cle wbr wa vx cv cr wcel cc0 vx cv clt wbr wa c2 cR
      cmul co vx cv cdiv co cfl cfv c1 caddc co cN cn wcel cN c1 cif cle wbr wa
      cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cfz co
      cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx
      cv clt wbr cc0 cN cn wcel cN c1 cif cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc0 cN cn wcel cN c1 cif cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk csu cmul co cc0 cN cn wcel cN c1 cif cfz co cA cB caddc co
      vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr
      cN cN cn wcel cN c1 cif wceq c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc
      co cN cle wbr c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cN cn wcel
      cN c1 cif cle wbr vx cv cr wcel cc0 vx cv clt wbr wa cN cN cn wcel cN c1
      cif c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cle breq2 anbi2d cN
      cN cn wcel cN c1 cif wceq cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc0 cN cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cmul co cc0 cN cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv
      co vj csu cmin co cabs cfv cc0 cN cn wcel cN c1 cif cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj csu cc0 cN cn wcel cN c1 cif cfz co cB vk cv
      cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cn wcel cN c1 cif cfz
      co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs
      cfv vx cv clt cN cN cn wcel cN c1 cif wceq cc0 cN cfz co cA vj cv cexp co
      vj cv cfa cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp co vk cv cfa cfv
      cdiv co vk csu cmul co cc0 cN cfz co cA cB caddc co vj cv cexp co vj cv
      cfa cfv cdiv co vj csu cmin co cc0 cN cn wcel cN c1 cif cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cn wcel cN c1 cif cfz co cB
      vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cn wcel cN c1
      cif cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin
      co cabs cN cN cn wcel cN c1 cif wceq cc0 cN cfz co cA vj cv cexp co vj cv
      cfa cfv cdiv co vj csu cc0 cN cfz co cB vk cv cexp co vk cv cfa cfv cdiv
      co vk csu cmul co cc0 cN cn wcel cN c1 cif cfz co cA vj cv cexp co vj cv
      cfa cfv cdiv co vj csu cc0 cN cn wcel cN c1 cif cfz co cB vk cv cexp co
      vk cv cfa cfv cdiv co vk csu cmul co cc0 cN cfz co cA cB caddc co vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 cN cn wcel cN c1 cif cfz co cA
      cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin cN cN cn wcel
      cN c1 cif wceq cc0 cN cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cc0 cN cn wcel cN c1 cif cfz co cA vj cv cexp co vj cv cfa cfv cdiv
      co vj csu cc0 cN cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cc0
      cN cn wcel cN c1 cif cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu
      cmul cN cN cn wcel cN c1 cif wceq cc0 cN cfz co cc0 cN cn wcel cN c1 cif
      cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj cN cN cn wcel cN c1 cif
      cc0 cfz opreq2 sumeq1d cN cN cn wcel cN c1 cif wceq cc0 cN cfz co cc0 cN
      cn wcel cN c1 cif cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk cN cN
      cn wcel cN c1 cif cc0 cfz opreq2 sumeq1d opreq12d cN cN cn wcel cN c1 cif
      wceq cc0 cN cfz co cc0 cN cn wcel cN c1 cif cfz co cA cB caddc co vj cv
      cexp co vj cv cfa cfv cdiv co vj cN cN cn wcel cN c1 cif cc0 cfz opreq2
      sumeq1d opreq12d fveq2d breq1d imbi12d vx cA cB cR cT vj vk cN cn wcel cN
      c1 cif cN c1 cn 1nn elimel efaddlem24.1 efaddlem24.2 efaddlem24.3
      efaddlem24.4 efaddlem23 dedth 3impib 3com12 $.
      $( [16-Feb-2006] $) $( [13-Jan-2006] $)

    $( Lemma for ~ efaddi .  Convert from the explicit bound for ` N ` in
       ~ efaddlem24 to the existence of a bound ` m ` . $)
    efaddlem25 $p |- ( ( x e. RR /\ 0 < x ) -> E. m e. NN A. n e. NN
     ( m <_ n -> ( abs ` ( ( sum_ j e. ( 0 ... n ) ( ( A ^ j ) / ( ! ` j ) ) x.
                        sum_ k e. ( 0 ... n ) ( ( B ^ k ) / ( ! ` k ) ) ) -
         sum_ j e. ( 0 ... n ) ( ( ( A + B ) ^ j ) / ( ! ` j ) ) ) ) < x ) ) $=
      c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co cn wcel c2 cR cmul co vx
      cv cdiv co cfl cfv c1 caddc co vn cv cle wbr cc0 vn cv cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cmul co cc0 vn cv cfz co cA cB caddc co vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi vn
      cn wral vm cv vn cv cle wbr cc0 vn cv cfz co cA vj cv cexp co vj cv cfa
      cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv
      co vk csu cmul co cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj cv cfa
      cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi vn cn wral vm cn
      wrex vx cv cr wcel cc0 vx cv clt wbr wa vm cv vn cv cle wbr cc0 vn cv cfz
      co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk
      cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vn cv cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx
      cv clt wbr wi vn cn wral c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co
      vn cv cle wbr cc0 vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul
      co cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cmin co cabs cfv vx cv clt wbr wi vn cn wral vm c2 cR cmul co vx cv
      cdiv co cfl cfv c1 caddc co cn vm cv c2 cR cmul co vx cv cdiv co cfl cfv
      c1 caddc co wceq vm cv vn cv cle wbr cc0 vn cv cfz co cA vj cv cexp co vj
      cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv
      cdiv co vk csu cmul co cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj
      cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi c2 cR cmul co
      vx cv cdiv co cfl cfv c1 caddc co vn cv cle wbr cc0 vn cv cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cmul co cc0 vn cv cfz co cA cB caddc co vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi vn
      cn vm cv c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co wceq vm cv vn cv
      cle wbr c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co vn cv cle wbr cc0
      vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz
      co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vn cv cfz co
      cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs
      cfv vx cv clt wbr vm cv c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co
      vn cv cle breq1 imbi1d ralbidv rcla4ev vx cv cr wcel cc0 vx cv clt wbr wa
      c2 cR cmul co vx cv cdiv co cfl cfv cn0 wcel c2 cR cmul co vx cv cdiv co
      cfl cfv c1 caddc co cn wcel c2 cR cmul co vx cv cdiv co cr wcel cc0 c2 cR
      cmul co vx cv cdiv co cle wbr c2 cR cmul co vx cv cdiv co cfl cfv cn0
      wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv cdiv co
      flge0nn0 c2 cR cmul co cr wcel vx cv cr wcel vx cv cc0 wne c2 cR cmul co
      vx cv cdiv co cr wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx
      cv redivcl c2 cR cmul co cr wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR
      2re cR cA cB cR cT efaddlem24.1 efaddlem24.2 efaddlem24.3 efaddlem24.4
      efaddlem21 nnrei remulcli a1i vx cv cr wcel cc0 vx cv clt wbr pm3.26 vx
      cv gt0ne0 syl3anc c2 cR cmul co vx cv cdiv co cr wcel cc0 c2 cR cmul co
      vx cv cdiv co clt wbr cc0 c2 cR cmul co vx cv cdiv co cle wbr vx cv cr
      wcel cc0 vx cv clt wbr wa cc0 cr wcel c2 cR cmul co vx cv cdiv co cr wcel
      cc0 c2 cR cmul co vx cv cdiv co clt wbr cc0 c2 cR cmul co vx cv cdiv co
      cle wbr wi 0re cc0 c2 cR cmul co vx cv cdiv co ltle mpan c2 cR cmul co cr
      wcel vx cv cr wcel vx cv cc0 wne c2 cR cmul co vx cv cdiv co cr wcel vx
      cv cr wcel cc0 vx cv clt wbr wa c2 cR cmul co vx cv redivcl c2 cR cmul co
      cr wcel vx cv cr wcel cc0 vx cv clt wbr wa c2 cR 2re cR cA cB cR cT
      efaddlem24.1 efaddlem24.2 efaddlem24.3 efaddlem24.4 efaddlem21 nnrei
      remulcli a1i vx cv cr wcel cc0 vx cv clt wbr pm3.26 vx cv gt0ne0 syl3anc
      c2 cR cmul co cr wcel cc0 c2 cR cmul co clt wbr vx cv cr wcel cc0 vx cv
      clt wbr wa cc0 c2 cR cmul co vx cv cdiv co clt wbr c2 cR 2re cR cA cB cR
      cT efaddlem24.1 efaddlem24.2 efaddlem24.3 efaddlem24.4 efaddlem21 nnrei
      remulcli c2 cR cmul co c2 cn wcel cR cn wcel c2 cR cmul co cn wcel 2nn cA
      cB cR cT efaddlem24.1 efaddlem24.2 efaddlem24.3 efaddlem24.4 efaddlem21
      c2 cR nnmulcl mp2an nngt0i c2 cR cmul co vx cv divgt0 mpanl12 sylc sylanc
      c2 cR cmul co vx cv cdiv co cfl cfv nn0p1nn syl vx cv cr wcel cc0 vx cv
      clt wbr wa c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co vn cv cle wbr
      cc0 vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv
      cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vn cv
      cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co
      cabs cfv vx cv clt wbr wi vn cn vx cv cr wcel cc0 vx cv clt wbr wa vn cv
      cn wcel c2 cR cmul co vx cv cdiv co cfl cfv c1 caddc co vn cv cle wbr cc0
      vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz
      co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vn cv cfz co
      cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs
      cfv vx cv clt wbr vx cA cB cR cT vj vk vn cv efaddlem24.1 efaddlem24.2
      efaddlem24.3 efaddlem24.4 efaddlem24 3expia r19.21aiva sylanc $.
      $( [16-Feb-2006] $) $( [13-Jan-2006] $)
  $}

  ${
    $d j n y A $.  $d k n y B $.  $d m F $.  $d m G $.  $d m H $.
    $d j k m n y $.
    efaddlem26.1 $e |- A e. CC $.
    efaddlem26.2 $e |- B e. CC $.
    efaddlem26.3 $e |- F = { <. n , y >. | ( n e. NN0 /\
                   y = sum_ j e. ( 0 ... n ) ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    efaddlem26.4 $e |- G = { <. n , y >. | ( n e. NN0 /\
                   y = sum_ k e. ( 0 ... n ) ( ( B ^ k ) / ( ! ` k ) ) ) } $.
    efaddlem26.5 $e |- H = { <. n , y >. | ( n e. NN0 /\
                    y = ( sum_ j e. ( 0 ... n ) ( ( A ^ j ) / ( ! ` j ) )
                    x. sum_ k e. ( 0 ... n ) ( ( B ^ k ) / ( ! ` k ) ) ) ) } $.
    $( Lemma for ~ efaddi .  Show that the sequence of partial sum products
       ` H ` converges to the product of exponentiations.  The key theorem used
      is ~ climmul . $)
    efaddlem26 $p |- H ~~> ( ( exp ` A ) x. ( exp ` B ) ) $=
      cF cA ce cfv cli wbr cG cB ce cfv cli wbr wa cc0 cz wcel vm cv cF cfv cc
      wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv vm cv cG cfv cmul co
      wceq w3a vm cc0 cuz cfv wral wa cH cA ce cfv cB ce cfv cmul co cli wbr cF
      cA ce cfv cli wbr cG cB ce cfv cli wbr cA cc wcel cF cA ce cfv cli wbr
      efaddlem26.1 vy cA vj vn cF efaddlem26.3 efcvgfsum ax-mp cB cc wcel cG cB
      ce cfv cli wbr efaddlem26.2 vy cB vk vn cG efaddlem26.4 efcvgfsum ax-mp
      pm3.2i cc0 cz wcel vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv
      vm cv cF cfv vm cv cG cfv cmul co wceq w3a vm cc0 cuz cfv wral 0z vm cv
      cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv vm cv cG
      cfv cmul co wceq w3a vm cc0 cuz cfv vm cv cc0 cuz cfv wcel vm cv cn0 wcel
      vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv vm cv
      cG cfv cmul co wceq w3a vm cv elnn0uz vm cv cn0 wcel vm cv cF cfv cc wcel
      vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv vm cv cG cfv cmul co wceq
      vm cv cn0 wcel vm cv cF cfv cc0 vm cv cfz co cA vj cv cexp co vj cv cfa
      cfv cdiv co vj csu cc vn vy vm cv cc0 vn cv cfz co cA vj cv cexp co vj cv
      cfa cfv cdiv co vj csu cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cn0 cF vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co
      cA vj cv cexp co vj cv cfa cfv cdiv co vj vn cv vm cv cc0 cfz opreq2
      sumeq1d efaddlem26.3 cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv
      co vj sumex fvopab4 vm cv cn0 wcel vm cv cc0 cuz cfv wcel cc0 vm cv cfz
      co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc wcel vm cv elnn0uz vm
      cv cc0 cuz cfv wcel cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj cc0
      vm cv cfz co wral cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co
      vj csu cc wcel cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj cc0 vm
      cv cfz co cA cc wcel vj cv cn0 wcel cA vj cv cexp co vj cv cfa cfv cdiv
      co cc wcel vj cv cc0 vm cv cfz co wcel cA vj cv eftcl efaddlem26.1 vj cv
      vm cv elfznn0 sylancr rgen cA vj cv cexp co vj cv cfa cfv cdiv co vj cc0
      vm cv fsumcl mpan2 sylbi eqeltrd vm cv cn0 wcel vm cv cG cfv cc0 vm cv
      cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cc vn vy vm cv cc0
      vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cc0 vm cv cfz
      co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cn0 cG vn cv vm cv wceq
      cc0 vn cv cfz co cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co
      vk vn cv vm cv cc0 cfz opreq2 sumeq1d efaddlem26.4 cc0 vm cv cfz co cB vk
      cv cexp co vk cv cfa cfv cdiv co vk sumex fvopab4 vm cv cn0 wcel vm cv
      cc0 cuz cfv wcel cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co
      vk csu cc wcel vm cv elnn0uz vm cv cc0 cuz cfv wcel cB vk cv cexp co vk
      cv cfa cfv cdiv co cc wcel vk cc0 vm cv cfz co wral cc0 vm cv cfz co cB
      vk cv cexp co vk cv cfa cfv cdiv co vk csu cc wcel cB vk cv cexp co vk cv
      cfa cfv cdiv co cc wcel vk cc0 vm cv cfz co cB cc wcel vk cv cn0 wcel cB
      vk cv cexp co vk cv cfa cfv cdiv co cc wcel vk cv cc0 vm cv cfz co wcel
      cB vk cv eftcl efaddlem26.2 vk cv vm cv elfznn0 sylancr rgen cB vk cv
      cexp co vk cv cfa cfv cdiv co vk cc0 vm cv fsumcl mpan2 sylbi eqeltrd vm
      cv cn0 wcel vm cv cH cfv cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cmul co vm cv cF cfv vm cv cG cfv cmul co vn vy vm cv cc0 vn cv cfz
      co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk
      cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cmul co cn0 cH vn cv vm cv wceq cc0 vn cv cfz
      co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cA vj
      cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co
      vk cv cfa cfv cdiv co vk csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk csu cmul vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz
      co cA vj cv cexp co vj cv cfa cfv cdiv co vj vn cv vm cv cc0 cfz opreq2
      sumeq1d vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cB vk cv cexp
      co vk cv cfa cfv cdiv co vk vn cv vm cv cc0 cfz opreq2 sumeq1d opreq12d
      efaddlem26.5 cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul
      oprex fvopab4 vm cv cn0 wcel vm cv cF cfv cc0 vm cv cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj csu vm cv cG cfv cc0 vm cv cfz co cB vk cv
      cexp co vk cv cfa cfv cdiv co vk csu cmul vn vy vm cv cc0 vn cv cfz co cA
      vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj csu cn0 cF vn cv vm cv wceq cc0 vn cv cfz co
      cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj vn cv vm cv
      cc0 cfz opreq2 sumeq1d efaddlem26.3 cc0 vm cv cfz co cA vj cv cexp co vj
      cv cfa cfv cdiv co vj sumex fvopab4 vn vy vm cv cc0 vn cv cfz co cB vk cv
      cexp co vk cv cfa cfv cdiv co vk csu cc0 vm cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cn0 cG vn cv vm cv wceq cc0 vn cv cfz co cc0 vm
      cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk vn cv vm cv cc0 cfz
      opreq2 sumeq1d efaddlem26.4 cc0 vm cv cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk sumex fvopab4 opreq12d eqtr4d 3jca sylbir rgen pm3.2i cA
      ce cfv cB ce cfv vm cF cG cH cc0 vn vy cn0 cc0 vn cv cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj csu cF nn0ex efaddlem26.3 fopabex2 vn vy cn0
      cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cG nn0ex
      efaddlem26.4 fopabex2 vn vy cn0 cc0 vn cv cfz co cA vj cv cexp co vj cv
      cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv
      cdiv co vk csu cmul co cH nn0ex efaddlem26.5 fopabex2 cA ce fvex cB ce
      fvex climmul mp2an $.
      $( [17-Feb-2006] $) $( [10-Jan-2006] $)
  $}

  ${
    $d f j k m n x y A $.  $d f j k m n x y B $.  $d f m x F $.  $d f m x H $.
    efaddlem27.1 $e |- A e. CC $.
    efaddlem27.2 $e |- B e. CC $.
    efaddlem27.3 $e |- F = { <. n , y >. | ( n e. NN0 /\
            y = sum_ j e. ( 0 ... n ) ( ( ( A + B ) ^ j ) / ( ! ` j ) ) ) } $.
    efaddlem27.4 $e |- H = { <. n , y >. | ( n e. NN0 /\
                    y = ( sum_ j e. ( 0 ... n ) ( ( A ^ j ) / ( ! ` j ) )
                    x. sum_ k e. ( 0 ... n ) ( ( B ^ k ) / ( ! ` k ) ) ) ) } $.
    $( Lemma for ~ efaddi .  Show that the convergence of the sequence of
       partial sum products ` H ` to ` exp `` ( A + B ) ` .  The key theorem
       used is ~ 2climnn . $)
    efaddlem27 $p |- H ~~> ( exp ` ( A + B ) ) $=
      cA cB caddc co ce cfv cc wcel vm cv cF cfv cc wcel vm cv cH cfv cc wcel
      wa vm cn wral wa cc0 vx cv clt wbr vf cv vm cv cle wbr vm cv cH cfv vm cv
      cF cfv cmin co cabs cfv vx cv clt wbr wi vm cn wral vf cn wrex wi vx cr
      wral cF cA cB caddc co ce cfv cli wbr wa cH cA cB caddc co ce cfv cli wbr
      cA cB caddc co ce cfv cc wcel vm cv cF cfv cc wcel vm cv cH cfv cc wcel
      wa vm cn wral cA cB caddc co cc wcel cA cB caddc co ce cfv cc wcel cA cB
      efaddlem27.1 efaddlem27.2 addcli cA cB caddc co efcl ax-mp vm cv cF cfv
      cc wcel vm cv cH cfv cc wcel wa vm cn vm cv cn wcel vm cv cn0 wcel vm cv
      cF cfv cc wcel vm cv cH cfv cc wcel wa vm cv nnnn0 vm cv cn0 wcel vm cv
      cF cfv cc wcel vm cv cH cfv cc wcel vm cv cn0 wcel vm cv cF cfv cc0 vm cv
      cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cc vn vy
      vm cv cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co
      vj csu cc0 vm cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv
      co vj csu cn0 cF vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj vn cv vm cv cc0 cfz
      opreq2 sumeq1d efaddlem27.3 cc0 vm cv cfz co cA cB caddc co vj cv cexp co
      vj cv cfa cfv cdiv co vj sumex fvopab4 vm cv cn0 wcel cA cB caddc co vj
      cv cexp co vj cv cfa cfv cdiv co cc wcel vj cc0 vm cv cfz co wral cc0 vm
      cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cc
      wcel cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj cc0 vm
      cv cfz co cA cB caddc co cc wcel vj cv cn0 wcel cA cB caddc co vj cv cexp
      co vj cv cfa cfv cdiv co cc wcel vj cv cc0 vm cv cfz co wcel cA cB caddc
      co vj cv eftcl cA cB efaddlem27.1 efaddlem27.2 addcli vj cv vm cv elfznn0
      sylancr rgen cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj vm cv
      fsum0cl mpan2 eqeltrd vm cv cn0 wcel vm cv cH cfv cc0 vm cv cfz co cA vj
      cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co
      vk cv cfa cfv cdiv co vk csu cmul co cc vn vy vm cv cc0 vn cv cfz co cA
      vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp
      co vk cv cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA vj cv cexp co
      vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk csu cmul co cn0 cH vn cv vm cv wceq cc0 vn cv cfz co cA vj
      cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cA vj cv cexp co
      vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv
      co vk csu cmul vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cA vj
      cv cexp co vj cv cfa cfv cdiv co vj vn cv vm cv cc0 cfz opreq2 sumeq1d vn
      cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cB vk cv cexp co vk cv
      cfa cfv cdiv co vk vn cv vm cv cc0 cfz opreq2 sumeq1d opreq12d
      efaddlem27.4 cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul
      oprex fvopab4 cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cc wcel cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cc wcel cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj
      csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul
      co cc wcel vm cv cn0 wcel cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu mulcl vm cv cn0 wcel cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel
      vj cc0 vm cv cfz co wral cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc wcel cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel vj
      cc0 vm cv cfz co cA cc wcel vj cv cn0 wcel cA vj cv cexp co vj cv cfa cfv
      cdiv co cc wcel vj cv cc0 vm cv cfz co wcel cA vj cv eftcl efaddlem27.1
      vj cv vm cv elfznn0 sylancr rgen cA vj cv cexp co vj cv cfa cfv cdiv co
      vj vm cv fsum0cl mpan2 vm cv cn0 wcel cB vk cv cexp co vk cv cfa cfv cdiv
      co cc wcel vk cc0 vm cv cfz co wral cc0 vm cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cc wcel cB vk cv cexp co vk cv cfa cfv cdiv co
      cc wcel vk cc0 vm cv cfz co cB cc wcel vk cv cn0 wcel cB vk cv cexp co vk
      cv cfa cfv cdiv co cc wcel vk cv cc0 vm cv cfz co wcel cB vk cv eftcl
      efaddlem27.2 vk cv vm cv elfznn0 sylancr rgen cB vk cv cexp co vk cv cfa
      cfv cdiv co vk vm cv fsum0cl mpan2 sylanc eqeltrd jca syl rgen pm3.2i cc0
      vx cv clt wbr vf cv vm cv cle wbr vm cv cH cfv vm cv cF cfv cmin co cabs
      cfv vx cv clt wbr wi vm cn wral vf cn wrex wi vx cr wral cF cA cB caddc
      co ce cfv cli wbr cc0 vx cv clt wbr vf cv vm cv cle wbr vm cv cH cfv vm
      cv cF cfv cmin co cabs cfv vx cv clt wbr wi vm cn wral vf cn wrex wi vx
      cr vx cv cr wcel cc0 vx cv clt wbr vf cv vm cv cle wbr vm cv cH cfv vm cv
      cF cfv cmin co cabs cfv vx cv clt wbr wi vm cn wral vf cn wrex vx cv cr
      wcel cc0 vx cv clt wbr wa vf cv vm cv cle wbr cc0 vm cv cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA cB caddc co vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi vm
      cn wral vf cn wrex vf cv vm cv cle wbr vm cv cH cfv vm cv cF cfv cmin co
      cabs cfv vx cv clt wbr wi vm cn wral vf cn wrex vx cA cB c2 c2 c3 c2 cexp
      co cexp co c4 cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl
      cfv cmul co c2 cexp co cmul co c4 cA cabs cfv c1 caddc co cfl cfv cB cabs
      cfv c1 caddc co cfl cfv cmul co c2 cexp co cmul co c3 caddc co cexp co
      cmul co cmul co cA cabs cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co
      cfl cfv cmul co c2 cexp co vj vk vf vm efaddlem27.1 efaddlem27.2 cA cabs
      cfv c1 caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co c2 cexp
      co eqid c2 c2 c3 c2 cexp co cexp co c4 cA cabs cfv c1 caddc co cfl cfv cB
      cabs cfv c1 caddc co cfl cfv cmul co c2 cexp co cmul co c4 cA cabs cfv c1
      caddc co cfl cfv cB cabs cfv c1 caddc co cfl cfv cmul co c2 cexp co cmul
      co c3 caddc co cexp co cmul co cmul co eqid efaddlem25 vf cv vm cv cle
      wbr vm cv cH cfv vm cv cF cfv cmin co cabs cfv vx cv clt wbr wi vm cn
      wral vf cv vm cv cle wbr cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cmul co cc0 vm cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cmin co cabs cfv vx cv clt wbr wi vm cn wral vf cn vf cv
      vm cv cle wbr vm cv cH cfv vm cv cF cfv cmin co cabs cfv vx cv clt wbr wi
      vf cv vm cv cle wbr cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv
      co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu
      cmul co cc0 vm cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv
      co vj csu cmin co cabs cfv vx cv clt wbr wi vm cn vm cv cn wcel vm cv cH
      cfv vm cv cF cfv cmin co cabs cfv vx cv clt wbr cc0 vm cv cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk
      cv cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA cB caddc co vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs cfv vx cv clt wbr vf cv
      vm cv cle wbr vm cv cn wcel vm cv cH cfv vm cv cF cfv cmin co cabs cfv
      cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv
      cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vm cv
      cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co
      cabs cfv vx cv clt vm cv cn wcel vm cv cH cfv vm cv cF cfv cmin co cc0 vm
      cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co
      cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA
      cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co cabs vm cv
      cn wcel vm cv cn0 wcel vm cv cH cfv vm cv cF cfv cmin co cc0 vm cv cfz co
      cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv
      cexp co vk cv cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA cB caddc
      co vj cv cexp co vj cv cfa cfv cdiv co vj csu cmin co wceq vm cv nnnn0 vm
      cv cn0 wcel vm cv cH cfv cc0 vm cv cfz co cA vj cv cexp co vj cv cfa cfv
      cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cmul co vm cv cF cfv cc0 vm cv cfz co cA cB caddc co vj cv cexp co vj
      cv cfa cfv cdiv co vj csu cmin vn vy vm cv cc0 vn cv cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv
      cfa cfv cdiv co vk csu cmul co cc0 vm cv cfz co cA vj cv cexp co vj cv
      cfa cfv cdiv co vj csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv
      cdiv co vk csu cmul co cn0 cH vn cv vm cv wceq cc0 vn cv cfz co cA vj cv
      cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz co cA vj cv cexp co vj
      cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv
      cdiv co vk csu cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk
      csu cmul vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cA vj cv cexp
      co vj cv cfa cfv cdiv co vj vn cv vm cv cc0 cfz opreq2 sumeq1d vn cv vm
      cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cB vk cv cexp co vk cv cfa cfv
      cdiv co vk vn cv vm cv cc0 cfz opreq2 sumeq1d opreq12d efaddlem27.4 cc0
      vm cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu cc0 vm cv cfz
      co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul oprex fvopab4 vn vy
      vm cv cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co
      vj csu cc0 vm cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv
      co vj csu cn0 cF vn cv vm cv wceq cc0 vn cv cfz co cc0 vm cv cfz co cA cB
      caddc co vj cv cexp co vj cv cfa cfv cdiv co vj vn cv vm cv cc0 cfz
      opreq2 sumeq1d efaddlem27.3 cc0 vm cv cfz co cA cB caddc co vj cv cexp co
      vj cv cfa cfv cdiv co vj sumex fvopab4 opreq12d syl fveq2d breq1d imbi2d
      ralbiia rexbii sylibr ex rgen cA cB caddc co cc wcel cF cA cB caddc co ce
      cfv cli wbr cA cB efaddlem27.1 efaddlem27.2 addcli vy cA cB caddc co vj
      vn cF efaddlem27.3 efcvgfsum ax-mp pm3.2i vx cA cB caddc co ce cfv vf vm
      cF cH vn vy cn0 cc0 vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co
      vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu
      cmul co cH nn0ex efaddlem27.4 fopabex2 2climnn mp2an $.
      $( [17-Feb-2006] $) $( [13-Jan-2006] $)
  $}

  ${
    $d j k n y A $.  $d j k n y B $.
    efaddlem28.1 $e |- A e. CC $.
    efaddlem28.2 $e |- B e. CC $.
    efaddlem28.4 $e |- H = { <. n , y >. | ( n e. NN0 /\
                   y = ( sum_ j e. ( 0 ... n ) ( ( A ^ j ) / ( ! ` j ) )
                    x. sum_ k e. ( 0 ... n ) ( ( B ^ k ) / ( ! ` k ) ) ) ) } $.
    $( Lemma for ~ efaddi .  The two expressions that ` H ` converges to are
       equal, since the limit of a converging series is unique by
       ~ climunii .  The result is independent of ` H ` , which can therefore
       be eliminated with ~ equid in the final theorem. $)
    efaddlem28 $p |- ( exp ` ( A + B ) ) = ( ( exp ` A ) x. ( exp ` B ) ) $=
      cA cB caddc co ce cfv cA ce cfv cB ce cfv cmul co cH cA cB caddc co ce
      fvex cA ce cfv cB ce cfv cmul oprex cH cA cB caddc co ce cfv cli wbr cH
      cA ce cfv cB ce cfv cmul co cli wbr vy cA cB vj vk vn vn cv cn0 wcel vy
      cv cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj
      csu wceq wa vn vy copab cH efaddlem28.1 efaddlem28.2 vn cv cn0 wcel vy cv
      cc0 vn cv cfz co cA cB caddc co vj cv cexp co vj cv cfa cfv cdiv co vj
      csu wceq wa vn vy copab eqid efaddlem28.4 efaddlem27 vy cA cB vj vk vn vn
      cv cn0 wcel vy cv cc0 vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co
      vj csu wceq wa vn vy copab vn cv cn0 wcel vy cv cc0 vn cv cfz co cB vk cv
      cexp co vk cv cfa cfv cdiv co vk csu wceq wa vn vy copab cH efaddlem28.1
      efaddlem28.2 vn cv cn0 wcel vy cv cc0 vn cv cfz co cA vj cv cexp co vj cv
      cfa cfv cdiv co vj csu wceq wa vn vy copab eqid vn cv cn0 wcel vy cv cc0
      vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa vn vy
      copab eqid efaddlem28.4 efaddlem26 pm3.2i climunii $.
      $( [17-Feb-2006] $) $( [10-Jan-2006] $)
  $}

  ${
    $d j k n y A $.  $d j k n y B $.
    efadd.1 $e |- A e. CC $.
    efadd.2 $e |- B e. CC $.
    $( Sum of exponents law for exponential function.  Equation 26 of [Rudin]
       p. 164. $)
    efaddi $p |- ( exp ` ( A + B ) ) = ( ( exp ` A ) x. ( exp ` B ) ) $=
      vy cA cB vj vk vn vn cv cn0 wcel vy cv cc0 vn cv cfz co cA vj cv cexp co
      vj cv cfa cfv cdiv co vj csu cc0 vn cv cfz co cB vk cv cexp co vk cv cfa
      cfv cdiv co vk csu cmul co wceq wa vn vy copab efadd.1 efadd.2 vn cv cn0
      wcel vy cv cc0 vn cv cfz co cA vj cv cexp co vj cv cfa cfv cdiv co vj csu
      cc0 vn cv cfz co cB vk cv cexp co vk cv cfa cfv cdiv co vk csu cmul co
      wceq wa vn vy copab eqid efaddlem28 $.
      $( [17-Feb-2006] $) $( [10-Jan-2006] $)
  $}

  $( Sum of exponents law for exponential function. $)
  efadd $p |- ( ( A e. CC /\ B e. CC ) ->
               ( exp ` ( A + B ) ) = ( ( exp ` A ) x. ( exp ` B ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co ce cfv cA ce cfv cB ce cfv cmul co
    wceq cA cc wcel cA cc0 cif cB caddc co ce cfv cA cc wcel cA cc0 cif ce cfv
    cB ce cfv cmul co wceq cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co
    ce cfv cA cc wcel cA cc0 cif ce cfv cB cc wcel cB cc0 cif ce cfv cmul co
    wceq cA cB cc0 cc0 cA cA cc wcel cA cc0 cif wceq cA cB caddc co ce cfv cA
    cc wcel cA cc0 cif cB caddc co ce cfv cA ce cfv cB ce cfv cmul co cA cc
    wcel cA cc0 cif ce cfv cB ce cfv cmul co cA cA cc wcel cA cc0 cif wceq cA
    cB caddc co cA cc wcel cA cc0 cif cB caddc co ce cA cA cc wcel cA cc0 cif
    cB caddc opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA ce cfv cA cc wcel
    cA cc0 cif ce cfv cB ce cfv cmul cA cA cc wcel cA cc0 cif ce fveq2 opreq1d
    eqeq12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co ce
    cfv cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co ce cfv cA cc wcel
    cA cc0 cif ce cfv cB ce cfv cmul co cA cc wcel cA cc0 cif ce cfv cB cc wcel
    cB cc0 cif ce cfv cmul co cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0
    cif cB caddc co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co ce cB
    cB cc wcel cB cc0 cif cA cc wcel cA cc0 cif caddc opreq2 fveq2d cB cB cc
    wcel cB cc0 cif wceq cB ce cfv cB cc wcel cB cc0 cif ce cfv cA cc wcel cA
    cc0 cif ce cfv cmul cB cB cc wcel cB cc0 cif ce fveq2 opreq2d eqeq12d cA cc
    wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel efaddi dedth2h $.
    $( [8-Mar-2006] $) $( [10-Jan-2006] $)

  $( Cancellation of law for exponential function.  Equation 27 of [Rudin]
     p. 164. $)
  efcan $p |- ( A e. CC -> ( ( exp ` A ) x. ( exp ` -u A ) ) = 1 ) $=
    cA cc wcel cA cA cneg caddc co ce cfv cA ce cfv cA cneg ce cfv cmul co c1
    cA cc wcel cA cneg cc wcel cA cA cneg caddc co ce cfv cA ce cfv cA cneg ce
    cfv cmul co wceq cA negcl cA cA cneg efadd mpdan cA cc wcel cA cA cneg
    caddc co ce cfv cc0 ce cfv c1 cA cc wcel cA cA cneg caddc co cc0 ce cA
    negid fveq2d ef0 syl6eq eqtr3d $.
    $( [8-Mar-2006] $) $( [13-Jan-2006] $)

  $( The exponential function never vanishes.  Corollary 15-4.3 of [Gleason]
     p. 309. $)
  efne0 $p |- ( A e. CC -> ( exp ` A ) =/= 0 ) $=
    cA cc wcel cA ce cfv cc0 wceq wn cA ce cfv cc0 wne cA cc wcel cA ce cfv cc0
    wceq c1 cc0 wceq c1 cc0 wne c1 cc0 wceq wn ax1ne0 c1 cc0 df-ne mpbi cA cc
    wcel cA ce cfv cc0 wceq c1 cc0 wceq cA cc wcel cA ce cfv cc0 wceq wa cA ce
    cfv cA cneg ce cfv cmul co cc0 cA cneg ce cfv cmul co c1 cc0 cA ce cfv cc0
    wceq cA ce cfv cA cneg ce cfv cmul co cc0 cA cneg ce cfv cmul co wceq cA cc
    wcel cA ce cfv cc0 cA cneg ce cfv cmul opreq1 adantl cA cc wcel cA ce cfv
    cA cneg ce cfv cmul co c1 wceq cA ce cfv cc0 wceq cA efcan adantr cA cc
    wcel cc0 cA cneg ce cfv cmul co cc0 wceq cA ce cfv cc0 wceq cA cc wcel cA
    cneg cc wcel cA cneg ce cfv cc wcel cc0 cA cneg ce cfv cmul co cc0 wceq cA
    negcl cA cneg efcl cA cneg ce cfv mul02 3syl adantr 3eqtr3d ex mtoi cA ce
    cfv cc0 df-ne sylibr $.
    $( [13-Mar-2006] $) $( [13-Jan-2006] $)

  $( The exponential function maps the complex numbers to the nonzero complex
     numbers. (Contributed by Paul Chapman, 16-Apr-2008.) $)
  eff2 $p |- exp : CC --> ( CC \ { 0 } ) $=
    cc cc cc0 csn cdif ce wf ce cc wfn vx cv ce cfv cc cc0 csn cdif wcel vx cc
    wral vx cc cc cc0 csn cdif ce ffnfv cc cc ce wf ce cc wfn eff cc cc ce ffn
    ax-mp vx cv ce cfv cc cc0 csn cdif wcel vx cc vx cv ce cfv cc cc0 csn cdif
    wcel vx cv ce cfv cc wcel vx cv ce cfv cc0 wne vx cv cc wcel vx cv ce cfv
    cc cc0 eldifsn vx cv efcl vx cv efne0 sylanbrc rgen mpbir2an $.
    $( [21-Apr-2008] $) $( [16-Apr-2008] $)

  $( Difference of exponents law for exponential function.  (Contributed by
     Steve Rodriguez, 25-Nov-2007.) $)
  efsub $p |- ( ( A e. CC /\ B e. CC ) ->
               ( exp ` ( A - B ) ) = ( ( exp ` A ) / ( exp ` B ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cmin co ce cfv cA ce cfv c1 cB ce cfv cdiv
    co cmul co cA ce cfv cB ce cfv cdiv co cA cc wcel cB cc wcel wa cA ce cfv
    c1 cB ce cfv cdiv co cmul co cA ce cfv cB cneg ce cfv cmul co cA cB cneg
    caddc co ce cfv cA cB cmin co ce cfv cB cc wcel cA ce cfv c1 cB ce cfv cdiv
    co cmul co cA ce cfv cB cneg ce cfv cmul co wceq cA cc wcel cB cc wcel c1
    cB ce cfv cdiv co cB cneg ce cfv cA ce cfv cmul cB cc wcel c1 cB ce cfv
    cdiv co cB cneg ce cfv wceq c1 cB ce cfv cB cneg ce cfv cmul co wceq cB cc
    wcel cB ce cfv cB cneg ce cfv cmul co c1 cB efcan eqcomd cB cneg ce cfv cc
    wcel cB ce cfv cc wcel cB ce cfv cc0 wne wa c1 cB ce cfv cdiv co cB cneg ce
    cfv wceq c1 cB ce cfv cB cneg ce cfv cmul co wceq wb cB cc wcel c1 cc wcel
    cB cneg ce cfv cc wcel cB ce cfv cc wcel cB ce cfv cc0 wne wa c1 cB ce cfv
    cdiv co cB cneg ce cfv wceq c1 cB ce cfv cB cneg ce cfv cmul co wceq wb
    ax1cn c1 cB cneg ce cfv cB ce cfv divmul2 mp3an1 cB cc wcel cB cneg cc wcel
    cB cneg ce cfv cc wcel cB negcl cB cneg efcl syl cB cc wcel cB ce cfv cc
    wcel cB ce cfv cc0 wne cB efcl cB efne0 jca sylanc mpbird opreq2d adantl cA
    cc wcel cB cneg cc wcel cA cB cneg caddc co ce cfv cA ce cfv cB cneg ce cfv
    cmul co wceq cB cc wcel cA cB cneg efadd cB negcl sylan2 cA cc wcel cB cc
    wcel wa cA cB cneg caddc co cA cB cmin co ce cA cB negsub fveq2d 3eqtr2rd
    cA cc wcel cB cc wcel cA ce cfv cB ce cfv cdiv co cA ce cfv c1 cB ce cfv
    cdiv co cmul co wceq cA ce cfv cc wcel cB ce cfv cc wcel cB ce cfv cc0 wne
    cA ce cfv cB ce cfv cdiv co cA ce cfv c1 cB ce cfv cdiv co cmul co wceq cA
    cc wcel cB cc wcel cB cc wcel cA ce cfv cB ce cfv divrec cA efcl cB efcl cB
    efne0 syl3an 3anidm23 eqtr4d $.
    $( [25-Nov-2007] $) $( [25-Nov-2007] $)

  ${
    $d j N $.  $d j k A $.
    $( Exponential function to a nonnegative integer power.  Corollary 15-4.4
       of [Gleason] p. 309, restricted to nonnegative integers. $)
    efexp $p |- ( ( A e. CC /\ N e. NN0 ) ->
                 ( exp ` ( N x. A ) ) = ( ( exp ` A ) ^ N ) ) $=
      cA cc wcel cN cn0 wcel wa cA cN cmul co ce cfv cN cA cmul co ce cfv cA ce
      cfv cN cexp co cA cc wcel cN cn0 wcel wa cA cN cmul co cN cA cmul co ce
      cA cc wcel cN cc wcel cA cN cmul co cN cA cmul co wceq cN cn0 wcel cA cN
      mulcom cN nn0cn sylan2 fveq2d cN cn0 wcel cA cc wcel cA cN cmul co ce cfv
      cA ce cfv cN cexp co wceq cA cc wcel cA vj cv cmul co ce cfv cA ce cfv vj
      cv cexp co wceq wi cA cc wcel cA cc0 cmul co ce cfv cA ce cfv cc0 cexp co
      wceq wi cA cc wcel cA vk cv cmul co ce cfv cA ce cfv vk cv cexp co wceq
      wi cA cc wcel cA vk cv c1 caddc co cmul co ce cfv cA ce cfv vk cv c1
      caddc co cexp co wceq wi cA cc wcel cA cN cmul co ce cfv cA ce cfv cN
      cexp co wceq wi vj vk cN vk cv cn0 wcel cA cc wcel cA vk cv cmul co ce
      cfv cA ce cfv vk cv cexp co wceq cA vk cv c1 caddc co cmul co ce cfv cA
      ce cfv vk cv c1 caddc co cexp co wceq cA cc wcel vk cv cn0 wcel cA vk cv
      cmul co ce cfv cA ce cfv vk cv cexp co wceq cA vk cv c1 caddc co cmul co
      ce cfv cA ce cfv vk cv c1 caddc co cexp co wceq wi cA cc wcel vk cv cn0
      wcel wa cA vk cv cmul co ce cfv cA ce cfv vk cv cexp co wceq cA vk cv c1
      caddc co cmul co ce cfv cA ce cfv vk cv c1 caddc co cexp co wceq cA cc
      wcel vk cv cn0 wcel wa cA vk cv cmul co ce cfv cA ce cfv vk cv cexp co
      wceq wa cA vk cv cmul co ce cfv cA ce cfv cmul co cA ce cfv vk cv cexp co
      cA ce cfv cmul co cA vk cv c1 caddc co cmul co ce cfv cA ce cfv vk cv c1
      caddc co cexp co cA vk cv cmul co ce cfv cA ce cfv vk cv cexp co wceq cA
      vk cv cmul co ce cfv cA ce cfv cmul co cA ce cfv vk cv cexp co cA ce cfv
      cmul co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv cmul co ce cfv cA ce
      cfv vk cv cexp co cA ce cfv cmul opreq1 adantl cA cc wcel vk cv cn0 wcel
      wa cA vk cv c1 caddc co cmul co ce cfv cA vk cv cmul co ce cfv cA ce cfv
      cmul co wceq cA vk cv cmul co ce cfv cA ce cfv vk cv cexp co wceq cA cc
      wcel vk cv cn0 wcel wa cA vk cv c1 caddc co cmul co ce cfv cA vk cv cmul
      co cA caddc co ce cfv cA vk cv cmul co ce cfv cA ce cfv cmul co cA cc
      wcel vk cv cn0 wcel wa cA vk cv c1 caddc co cmul co cA vk cv cmul co cA
      caddc co ce cA cc wcel vk cv cc wcel cA vk cv c1 caddc co cmul co cA vk
      cv cmul co cA caddc co wceq vk cv cn0 wcel cA cc wcel vk cv cc wcel wa cA
      vk cv c1 caddc co cmul co cA vk cv cmul co cA c1 cmul co caddc co cA vk
      cv cmul co cA caddc co cA cc wcel vk cv cc wcel c1 cc wcel cA vk cv c1
      caddc co cmul co cA vk cv cmul co cA c1 cmul co caddc co wceq ax1cn cA vk
      cv c1 adddi mp3an3 cA cc wcel vk cv cc wcel wa cA c1 cmul co cA cA vk cv
      cmul co caddc cA cc wcel cA c1 cmul co cA wceq vk cv cc wcel cA ax1id
      adantr opreq2d eqtrd vk cv nn0cn sylan2 fveq2d cA vk cv cmul co cc wcel
      cA cc wcel cA vk cv cmul co cA caddc co ce cfv cA vk cv cmul co ce cfv cA
      ce cfv cmul co wceq cA cc wcel vk cv cn0 wcel wa cA vk cv cmul co cA
      efadd cA cc wcel vk cv cc wcel cA vk cv cmul co cc wcel vk cv cn0 wcel cA
      vk cv mulcl vk cv nn0cn sylan2 cA cc wcel vk cv cn0 wcel pm3.26 sylanc
      eqtrd adantr cA cc wcel vk cv cn0 wcel wa cA ce cfv vk cv c1 caddc co
      cexp co cA ce cfv vk cv cexp co cA ce cfv cmul co wceq cA vk cv cmul co
      ce cfv cA ce cfv vk cv cexp co wceq cA ce cfv cc wcel vk cv cn0 wcel cA
      ce cfv vk cv c1 caddc co cexp co cA ce cfv vk cv cexp co cA ce cfv cmul
      co wceq cA cc wcel cA ce cfv vk cv expp1 cA efcl sylan adantr 3eqtr4d ex
      expcom a2d cA cc wcel cc0 ce cfv c1 cA cc0 cmul co ce cfv cA ce cfv cc0
      cexp co ef0 cA cc wcel cA cc0 cmul co cc0 ce cA mul01 fveq2d cA cc wcel
      cA ce cfv cc wcel cA ce cfv cc0 cexp co c1 wceq cA efcl cA ce cfv exp0
      syl 3eqtr4a vj cv cc0 wceq cA vj cv cmul co ce cfv cA ce cfv vj cv cexp
      co wceq cA cc0 cmul co ce cfv cA ce cfv cc0 cexp co wceq cA cc wcel vj cv
      cc0 wceq cA vj cv cmul co ce cfv cA cc0 cmul co ce cfv cA ce cfv vj cv
      cexp co cA ce cfv cc0 cexp co vj cv cc0 wceq cA vj cv cmul co cA cc0 cmul
      co ce vj cv cc0 cA cmul opreq2 fveq2d vj cv cc0 cA ce cfv cexp opreq2
      eqeq12d imbi2d vj cv vk cv wceq cA vj cv cmul co ce cfv cA ce cfv vj cv
      cexp co wceq cA vk cv cmul co ce cfv cA ce cfv vk cv cexp co wceq cA cc
      wcel vj cv vk cv wceq cA vj cv cmul co ce cfv cA vk cv cmul co ce cfv cA
      ce cfv vj cv cexp co cA ce cfv vk cv cexp co vj cv vk cv wceq cA vj cv
      cmul co cA vk cv cmul co ce vj cv vk cv cA cmul opreq2 fveq2d vj cv vk cv
      cA ce cfv cexp opreq2 eqeq12d imbi2d vj cv vk cv c1 caddc co wceq cA vj
      cv cmul co ce cfv cA ce cfv vj cv cexp co wceq cA vk cv c1 caddc co cmul
      co ce cfv cA ce cfv vk cv c1 caddc co cexp co wceq cA cc wcel vj cv vk cv
      c1 caddc co wceq cA vj cv cmul co ce cfv cA vk cv c1 caddc co cmul co ce
      cfv cA ce cfv vj cv cexp co cA ce cfv vk cv c1 caddc co cexp co vj cv vk
      cv c1 caddc co wceq cA vj cv cmul co cA vk cv c1 caddc co cmul co ce vj
      cv vk cv c1 caddc co cA cmul opreq2 fveq2d vj cv vk cv c1 caddc co cA ce
      cfv cexp opreq2 eqeq12d imbi2d vj cv cN wceq cA vj cv cmul co ce cfv cA
      ce cfv vj cv cexp co wceq cA cN cmul co ce cfv cA ce cfv cN cexp co wceq
      cA cc wcel vj cv cN wceq cA vj cv cmul co ce cfv cA cN cmul co ce cfv cA
      ce cfv vj cv cexp co cA ce cfv cN cexp co vj cv cN wceq cA vj cv cmul co
      cA cN cmul co ce vj cv cN cA cmul opreq2 fveq2d vj cv cN cA ce cfv cexp
      opreq2 eqeq12d imbi2d nn0indALT impcom eqtr3d $.
      $( [10-Aug-2007] $) $( [13-Jan-2006] $)
  $}

  $( Value of the exponential function for nonnegative integers.  Special
     case of ~ efval .  Equation 30 of [Rudin] p. 164.  (Contributed by
     Steve Rodriguez, 16-Sep-2006.) $)
  efnn0val $p |- ( N e. NN0 -> ( exp ` N ) = ( _e ^ N ) ) $=
    cN cn0 wcel cN ce cfv c1 ce cfv cN cexp co ceu cN cexp co cN cn0 wcel cN c1
    cmul co ce cfv cN ce cfv c1 ce cfv cN cexp co cN cn0 wcel cN c1 cmul co cN
    ce cN cn0 wcel cN cc wcel cN c1 cmul co cN wceq cN nn0cn cN ax1id syl
    fveq2d c1 cc wcel cN cn0 wcel cN c1 cmul co ce cfv c1 ce cfv cN cexp co
    wceq ax1cn c1 cN efexp mpan eqtr3d ceu c1 ce cfv cN cexp df-e opreq1i
    syl6eqr $.
    $( [16-Sep-2006] $) $( [15-Sep-2006] $)

  $( The terms of the series expansion of the exponential function of a real
     number are real.  (Contributed by Paul Chapman, 15-Jan-2008.) $)
  reeftcl $p |- ( ( A e. RR /\ K e. NN0 ) ->
                   ( ( A ^ K ) / ( ! ` K ) ) e. RR ) $=
    cA cK cexp co cr wcel cK cfa cfv cr wcel cK cfa cfv cc0 wne cA cK cexp co
    cK cfa cfv cdiv co cr wcel cA cr wcel cK cn0 wcel wa cA cK cexp co cK cfa
    cfv redivcl cA cK reexpcl cK cn0 wcel cK cfa cfv cr wcel cA cr wcel cK cn0
    wcel cK cfa cfv cn wcel cK cfa cfv cr wcel cK faccl cK cfa cfv nnre syl
    adantl cK cn0 wcel cK cfa cfv cc0 wne cA cr wcel cK facne0 adantl syl3anc
    $.
    $( [15-Jan-2008] $) $( [15-Jan-2008] $)

  ${
    eftabsi.1 $e |- A e. CC $.
    $( The absolute value of a term in the series expansion of the exponential
       function.  (Contributed by Paul Chapman, 23-Nov-2007.) $)
    eftabsi $p |- ( K e. NN0 -> ( abs ` ( ( A ^ K ) / ( ! ` K ) ) ) =
                                  ( ( ( abs ` A ) ^ K ) / ( ! ` K ) ) ) $=
      cK cn0 wcel cA cK cexp co cK cfa cfv cdiv co cabs cfv cA cK cexp co cabs
      cfv cK cfa cfv cabs cfv cdiv co cA cabs cfv cK cexp co cK cfa cfv cdiv co
      cA cK cexp co cc wcel cK cfa cfv cc wcel cK cfa cfv cc0 wne cA cK cexp co
      cK cfa cfv cdiv co cabs cfv cA cK cexp co cabs cfv cK cfa cfv cabs cfv
      cdiv co wceq cK cn0 wcel cA cK cexp co cK cfa cfv absdiv cA cc wcel cK
      cn0 wcel cA cK cexp co cc wcel eftabsi.1 cA cK expcl mpan cK cn0 wcel cK
      cfa cfv cn wcel cK cfa cfv cr wcel cK cfa cfv cc wcel cK faccl cK cfa cfv
      nnre cK cfa cfv recn 3syl cK facne0 syl3anc cK cn0 wcel cA cK cexp co
      cabs cfv cA cabs cfv cK cexp co cK cfa cfv cabs cfv cK cfa cfv cdiv cA cc
      wcel cK cn0 wcel cA cK cexp co cabs cfv cA cabs cfv cK cexp co wceq
      eftabsi.1 cA cK absexp mpan cK cfa cfv cr wcel cc0 cK cfa cfv cle wbr cK
      cfa cfv cabs cfv cK cfa cfv wceq cK cn0 wcel cK cfa cfv absid cK cn0 wcel
      cK cfa cfv cn wcel cK cfa cfv cr wcel cK faccl cK cfa cfv nnre syl cK cfa
      cfv cr wcel cc0 cK cfa cfv clt wbr cc0 cK cfa cfv cle wbr cK cn0 wcel cc0
      cr wcel cK cfa cfv cr wcel cc0 cK cfa cfv clt wbr cc0 cK cfa cfv cle wbr
      wi 0re cc0 cK cfa cfv ltle mpan cK cn0 wcel cK cfa cfv cn wcel cK cfa cfv
      cr wcel cK faccl cK cfa cfv nnre syl cK cn0 wcel cK cfa cfv cn wcel cc0
      cK cfa cfv clt wbr cK faccl cK cfa cfv nngt0 syl sylc sylanc opreq12d
      eqtrd $.
      $( [23-Nov-2007] $) $( [23-Nov-2007] $)
  $}

  $( Closure of the upper bound of an infinite tail of the series defining the
     exponential function.  (Contributed by Paul Chapman, 17-Jan-2008.) $)
  eftlubcl $p |- ( M e. NN -> ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) e. RR ) $=
    cM c1 caddc co cr wcel cM cfa cfv cM cmul co cr wcel cM cfa cfv cM cmul co
    cc0 wne cM c1 caddc co cM cfa cfv cM cmul co cdiv co cr wcel cM cn wcel cM
    c1 caddc co cM cfa cfv cM cmul co redivcl cM cn wcel cM cr wcel cM c1 caddc
    co cr wcel cM nnre cM peano2re syl cM cn wcel cM cfa cfv cM cmul co cn wcel
    cM cfa cfv cM cmul co cr wcel cM cfa cfv cn wcel cM cn wcel cM cfa cfv cM
    cmul co cn wcel cM cn wcel cM cn0 wcel cM cfa cfv cn wcel cM nnnn0 cM faccl
    syl cM cfa cfv cM nnmulcl mpancom cM cfa cfv cM cmul co nnre syl cM cn wcel
    cM cfa cfv cM cmul co cn wcel cM cfa cfv cM cmul co cc0 wne cM cfa cfv cn
    wcel cM cn wcel cM cfa cfv cM cmul co cn wcel cM cn wcel cM cn0 wcel cM cfa
    cfv cn wcel cM nnnn0 cM faccl syl cM cfa cfv cM nnmulcl mpancom cM cfa cfv
    cM cmul co nnne0 syl syl3anc $.
    $( [17-Jan-2008] $) $( [17-Jan-2008] $)

  ${
    $d A j y $.  $d A x $.  $d F x $.  $d N x $.
    eftlexiOLD.1 $e |- F = { <. j , y >. |
                     ( j e. NN0 /\ y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    eftlexiOLD.2 $e |- A e. CC $.
    $( An upper part of the series defining the exponential function
       converges.  (Contributed by Paul Chapman, 23-Nov-2007.) $)
    eftlexiOLD $p |- ( N e. NN -> E. x ( <. N , + >. seq F ) ~~> x ) $=
      cN cn wcel cN cz wcel cc0 cN clt wbr wa cN caddc cop cF cseqz co vx cv
      cli wbr vx wex cN elnnz vx cA ce cfv cF cc0 cN vj vy cn0 cA vj cv cexp co
      vj cv cfa cfv cdiv co cF nn0ex eftlexiOLD.1 fopabex2 cA ce fvex 0z cn0 cc
      cF wf cc0 cuz cfv cc cF wf vj vy cn0 cc cA vj cv cexp co vj cv cfa cfv
      cdiv co cF eftlexiOLD.1 cA cc wcel vj cv cn0 wcel cA vj cv cexp co vj cv
      cfa cfv cdiv co cc wcel eftlexiOLD.2 cA vj cv eftcl mpan fopab cn0 cc0
      cuz cfv wceq cn0 cc cF wf cc0 cuz cfv cc cF wf wb nn0uz cn0 cc0 cuz cfv
      cc cF feq2 ax-mp mpbi caddc cF cseq0 co cc0 caddc cop cF cseqz co cA ce
      cfv cli caddc cF addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co
      cF nn0ex eftlexiOLD.1 fopabex2 seq0seqz cA cc wcel caddc cF cseq0 co cA
      ce cfv cli wbr eftlexiOLD.2 vy cA vj cF eftlexiOLD.1 efcvg ax-mp eqbrtrri
      iserzexi sylbi $.
      $( [23-Nov-2007] $) $( [23-Nov-2007] $)
  $}

  ${
    $d A j k x y $.  $d F k x $.  $d M k x $.
    eftlex.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                          y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    $( An infinite tail of the series defining the exponential function
       converges.  (Contributed by Paul Chapman, 17-Jan-2008.) $)
    eftlex $p |- ( ( A e. CC /\ M e. NN ) ->
                    E. x ( <. M , + >. seq F ) ~~> x ) $=
      cA cc wcel cM cn wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cA cc
      wcel cM cn wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex wi cM cn
      wcel cM caddc cop vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab cseqz co vx cv cli wbr vx wex
      wi cA c1 cA cA cc wcel cA c1 cif wceq cM caddc cop cF cseqz co vx cv cli
      wbr vx wex cM caddc cop vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseqz co vx cv cli wbr
      vx wex cM cn wcel cA cA cc wcel cA c1 cif wceq cM caddc cop cF cseqz co
      vx cv cli wbr cM caddc cop vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseqz co vx cv cli
      wbr vx cA cA cc wcel cA c1 cif wceq cM caddc cop cF cseqz co cM caddc cop
      vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cseqz co vx cv cli cA cA cc wcel cA c1 cif
      wceq cF vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cM caddc cop cseqz cA cA cc wcel cA c1
      cif wceq vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj cv cexp co vj
      cv cfa cfv cdiv co wceq wa vj vy copab cF cA cA cc wcel cA c1 cif wceq vj
      cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj cv
      cn0 wcel vy cv cA cc wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy cA cA cc wcel cA c1 cif wceq vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq vy cv cA cc wcel cA c1 cif vj cv cexp co vj cv cfa
      cfv cdiv co wceq vj cv cn0 wcel cA cA cc wcel cA c1 cif wceq cA vj cv
      cexp co vj cv cfa cfv cdiv co cA cc wcel cA c1 cif vj cv cexp co vj cv
      cfa cfv cdiv co vy cv cA cA cc wcel cA c1 cif wceq cA vj cv cexp co cA cc
      wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv cA cA cc wcel cA c1 cif
      vj cv cexp opreq1 opreq1d eqeq2d anbi2d opabbidv eftlex.1 syl5eq opreq2d
      breq1d exbidv imbi2d vx vy cA cc wcel cA c1 cif vj vj cv cn0 wcel vy cv
      cA cc wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cM vj cv cn0 wcel vy cv cA cc wcel cA c1 cif vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab eqid cA c1 cc ax1cn elimel eftlexiOLD
      dedth imp $.
      $( [17-Jan-2008] $) $( [17-Jan-2008] $)

    $( Closure of the sum of an infinite tail of the series defining the
       exponential function.  (Contributed by Paul Chapman, 17-Jan-2008.) $)
    eftlcl $p |- ( ( A e. CC /\ M e. NN ) ->
                    sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. CC ) $=
      cA cc wcel cM cn wcel wa cM caddc cop cF cseqz co vx cv cli wbr vx wex cM
      cuz cfv vk cv cF cfv vk csu cc wcel vx vy cA vj cF cM eftlex.1 eftlex cM
      cn wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM cuz cfv vk cv cF
      cfv vk csu cc wcel wi cA cc wcel cM cn wcel cM caddc cop cF cseqz co vx
      cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk csu cc wcel cM cz wcel cM
      caddc cop cF cseqz co vx cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk csu
      cc wcel cM cn wcel vx vk cF cM vj vy cn0 cA vj cv cexp co vj cv cfa cfv
      cdiv co cF nn0ex eftlex.1 fopabex2 isumcl cM nnz sylan ex adantl mpd $.
      $( [17-Jan-2008] $) $( [17-Jan-2008] $)

    $( Closure of the sum of an infinite tail of the series defining the
       exponential function.  (Contributed by Paul Chapman, 17-Jan-2008.) $)
    reeftlcl $p |- ( ( A e. RR /\ M e. NN ) ->
                      sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. RR ) $=
      cM cz wcel vk cv cF cfv cr wcel vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk csu cr wcel cA cr wcel
      cM cn wcel wa vx vk cF cM vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv
      co cF nn0ex eftlex.1 fopabex2 isumrecl cM cn wcel cM cz wcel cA cr wcel
      cM nnz adantl cA cr wcel cM cn wcel wa vk cv cF cfv cr wcel vk cM cuz cfv
      cA cr wcel cM cn wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel cA cr
      wcel cM cn wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel cA cr wcel vk
      cv cn0 wcel vk cv cF cfv cr wcel cM cn wcel vk cv cM cuz cfv wcel wa cA
      cr wcel vk cv cn0 wcel wa vk cv cF cfv cA vk cv cexp co vk cv cfa cfv
      cdiv co cr vk cv cn0 wcel vk cv cF cfv cA vk cv cexp co vk cv cfa cfv
      cdiv co wceq cA cr wcel vy cA vj cF vk cv eftlex.1 eftval adantl cA vk cv
      reeftcl eqeltrd vk cv cM cuz cfv wcel cM cn wcel vk cv cn0 wcel vk cv cM
      cuz cfv wcel cM cn wcel wa vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM
      cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn wcel cM vk
      cv cc0 uztrn cM cn wcel cM cn0 wcel cM cc0 cuz cfv wcel cM nnnn0 cM
      elnn0uz sylib sylan2 vk cv elnn0uz sylibr ancoms sylan2 3impb 3expia
      r19.21aiv cA cc wcel cM cn wcel cM caddc cop cF cseqz co vx cv cli wbr vx
      wex cA cr wcel vx vy cA vj cF cM eftlex.1 eftlex cA recn sylan syl3anc $.
      $( [17-Jan-2008] $) $( [17-Jan-2008] $)
  $}

  ${
    ef1tllem.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                           y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    ${
      $d A j x y $.  $d F k x $.  $d G k $.  $d H k $.  $d M j k x y $.
      $d P k $.
      ef1tllem.2 $e |- G = { <. j , y >. | ( j e. NN0 /\
                             y = ( ( 1 / ( M + 1 ) ) ^ j ) ) } $.
      ef1tllem.3 $e |- H = { <. j , y >. | ( j e. NN0 /\ y =
                      ( ( 1 / ( ! ` M ) ) x. ( ( 1 / ( M + 1 ) ) ^ j ) ) ) } $.
      ef1tllem.4 $e |- P = { <. j , y >. | ( j e. NN0 /\ y =
                             ( 1 / ( ! ` ( M + j ) ) ) ) } $.
      ef1tllem.5 $e |- M e. NN $.
      ef1tllem.6 $e |- A = 1 $.
      $( Lemma for ~ ef1tlubi . $)
      ef1tllem $p |- sum_ k e. ( ZZ>= ` M ) ( F ` k ) <_
                     ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) $=
        cM cuz cfv vk cv cF cfv vk csu c1 cM cfa cfv cdiv co cM c1 caddc co cM
        cdiv co cmul co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cle cc0 cz
        wcel vk cv cP cfv cr wcel vk cv cH cfv cr wcel vk cv cP cfv vk cv cH
        cfv cle wbr w3a vk cc0 cuz cfv wral cM cuz cfv vk cv cF cfv vk csu c1
        cM cfa cfv cdiv co cM c1 caddc co cM cdiv co cmul co cle wbr 0z vk cv
        cP cfv cr wcel vk cv cH cfv cr wcel vk cv cP cfv vk cv cH cfv cle wbr
        w3a vk cc0 cuz cfv vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cP cfv
        cr wcel vk cv cH cfv cr wcel vk cv cP cfv vk cv cH cfv cle wbr w3a vk
        cv elnn0uz vk cv cn0 wcel vk cv cP cfv cr wcel vk cv cH cfv cr wcel vk
        cv cP cfv vk cv cH cfv cle wbr vk cv cn0 wcel vk cv cP cfv c1 cM vk cv
        caddc co cfa cfv cdiv co cr vj vy vk cv c1 cM vj cv caddc co cfa cfv
        cdiv co c1 cM vk cv caddc co cfa cfv cdiv co cn0 cP vj cv vk cv wceq cM
        vj cv caddc co cfa cfv cM vk cv caddc co cfa cfv c1 cdiv vj cv vk cv
        wceq cM vj cv caddc co cM vk cv caddc co cfa vj cv vk cv cM caddc
        opreq2 fveq2d opreq2d ef1tllem.4 c1 cM vk cv caddc co cfa cfv cdiv
        oprex fvopab4 cM vk cv caddc co cfa cfv cr wcel cM vk cv caddc co cfa
        cfv cc0 wne c1 cM vk cv caddc co cfa cfv cdiv co cr wcel vk cv cn0 wcel
        cM vk cv caddc co cfa cfv rereccl vk cv cn0 wcel cM vk cv caddc co cfa
        cfv cn wcel cM vk cv caddc co cfa cfv cr wcel vk cv cn0 wcel cM vk cv
        caddc co cn0 wcel cM vk cv caddc co cfa cfv cn wcel cM cn0 wcel vk cv
        cn0 wcel cM vk cv caddc co cn0 wcel cM ef1tllem.5 nnnn0i cM vk cv
        nn0addcl mpan cM vk cv caddc co faccl syl cM vk cv caddc co cfa cfv
        nnre syl vk cv cn0 wcel cM vk cv caddc co cfa cfv cn wcel cM vk cv
        caddc co cfa cfv cc0 wne vk cv cn0 wcel cM vk cv caddc co cn0 wcel cM
        vk cv caddc co cfa cfv cn wcel cM cn0 wcel vk cv cn0 wcel cM vk cv
        caddc co cn0 wcel cM ef1tllem.5 nnnn0i cM vk cv nn0addcl mpan cM vk cv
        caddc co faccl syl cM vk cv caddc co cfa cfv nnne0 syl sylanc eqeltrd
        vk cv cn0 wcel vk cv cH cfv c1 cM cfa cfv cdiv co c1 cM c1 caddc co
        cdiv co vk cv cexp co cmul co cr vj vy vk cv c1 cM cfa cfv cdiv co c1
        cM c1 caddc co cdiv co vj cv cexp co cmul co c1 cM cfa cfv cdiv co c1
        cM c1 caddc co cdiv co vk cv cexp co cmul co cn0 cH vj cv vk cv wceq c1
        cM c1 caddc co cdiv co vj cv cexp co c1 cM c1 caddc co cdiv co vk cv
        cexp co c1 cM cfa cfv cdiv co cmul vj cv vk cv c1 cM c1 caddc co cdiv
        co cexp opreq2 opreq2d ef1tllem.3 c1 cM cfa cfv cdiv co c1 cM c1 caddc
        co cdiv co vk cv cexp co cmul oprex fvopab4 vk cv cn0 wcel c1 cM cfa
        cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp co cmul co c1 cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co cdiv co cr vk cv cn0 wcel c1
        cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp co cmul co c1
        cM cfa cfv cdiv co c1 cM c1 caddc co vk cv cexp co cdiv co cmul co c1
        cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cdiv co vk cv cn0 wcel
        c1 cM c1 caddc co cdiv co vk cv cexp co c1 cM c1 caddc co vk cv cexp co
        cdiv co c1 cM cfa cfv cdiv co cmul cM c1 caddc co cc wcel vk cv cn0
        wcel cM c1 caddc co cc0 wne c1 cM c1 caddc co cdiv co vk cv cexp co c1
        cM c1 caddc co vk cv cexp co cdiv co wceq cM c1 caddc co cM cn wcel cM
        c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp nncni cM c1 caddc co
        cM cn wcel cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp nnne0i
        cM c1 caddc co vk cv exprecOLD mp3an13 opreq2d vk cv cn0 wcel c1 cM cfa
        cfv cdiv co c1 cM c1 caddc co vk cv cexp co cdiv co cmul co c1 c1 cmul
        co cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cdiv co c1 cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co cdiv co cM c1 caddc co vk cv
        cexp co cc wcel cM c1 caddc co vk cv cexp co cc0 wne c1 cM cfa cfv cdiv
        co c1 cM c1 caddc co vk cv cexp co cdiv co cmul co c1 c1 cmul co cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co cdiv co wceq vk cv cn0 wcel cM
        cfa cfv cc wcel cM cfa cfv cc0 wne cM c1 caddc co vk cv cexp co cc wcel
        cM c1 caddc co vk cv cexp co cc0 wne wa c1 cM cfa cfv cdiv co c1 cM c1
        caddc co vk cv cexp co cdiv co cmul co c1 c1 cmul co cM cfa cfv cM c1
        caddc co vk cv cexp co cmul co cdiv co wceq cM cfa cfv cM cn0 wcel cM
        cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl ax-mp nncni cM cfa cfv cM
        cn0 wcel cM cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl ax-mp nnne0i
        c1 cc wcel c1 cc wcel cM cfa cfv cc wcel cM cfa cfv cc0 wne wa cM c1
        caddc co vk cv cexp co cc wcel cM c1 caddc co vk cv cexp co cc0 wne wa
        wa c1 cM cfa cfv cdiv co c1 cM c1 caddc co vk cv cexp co cdiv co cmul
        co c1 c1 cmul co cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cdiv
        co wceq ax1cn ax1cn c1 c1 cM cfa cfv cM c1 caddc co vk cv cexp co
        divmuldiv mpanl12 mpanl12 vk cv cn0 wcel cM c1 caddc co vk cv cexp co
        vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM c1 caddc co vk
        cv cexp co cr wcel cM c1 caddc co cn wcel vk cv cn0 wcel cM c1 caddc co
        vk cv cexp co cn wcel cM cn wcel cM c1 caddc co cn wcel ef1tllem.5 cM
        peano2nn ax-mp cM c1 caddc co vk cv nnexpcl mpan cM c1 caddc co vk cv
        cexp co nnre syl recnd vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn
        wcel cM c1 caddc co vk cv cexp co cc0 wne cM c1 caddc co cn wcel vk cv
        cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM cn wcel cM c1 caddc co
        cn wcel ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk cv nnexpcl mpan
        cM c1 caddc co vk cv cexp co nnne0 syl sylanc c1 c1 cmul co c1 cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co cdiv c1 ax1cn mulid1i opreq1i
        syl6eq eqtrd cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cr wcel cM
        cfa cfv cM c1 caddc co vk cv cexp co cmul co cc0 wne c1 cM cfa cfv cM
        c1 caddc co vk cv cexp co cmul co cdiv co cr wcel vk cv cn0 wcel cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co rereccl vk cv cn0 wcel cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co cn wcel cM cfa cfv cM c1 caddc
        co vk cv cexp co cmul co cr wcel cM cfa cfv cn wcel cM c1 caddc co vk
        cv cexp co cn wcel cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cn
        wcel vk cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp co nnmulcl cM
        cn0 wcel cM cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl ax-mp cM c1
        caddc co cn wcel vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM
        cn wcel cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp cM c1 caddc
        co vk cv nnexpcl mpan sylancr cM cfa cfv cM c1 caddc co vk cv cexp co
        cmul co nnre syl vk cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp co
        cmul co cn wcel cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cc0 wne
        cM cfa cfv cn wcel cM c1 caddc co vk cv cexp co cn wcel cM cfa cfv cM
        c1 caddc co vk cv cexp co cmul co cn wcel vk cv cn0 wcel cM cfa cfv cM
        c1 caddc co vk cv cexp co nnmulcl cM cn0 wcel cM cfa cfv cn wcel cM
        ef1tllem.5 nnnn0i cM faccl ax-mp cM c1 caddc co cn wcel vk cv cn0 wcel
        cM c1 caddc co vk cv cexp co cn wcel cM cn wcel cM c1 caddc co cn wcel
        ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk cv nnexpcl mpan sylancr
        cM cfa cfv cM c1 caddc co vk cv cexp co cmul co nnne0 syl sylanc
        eqeltrd eqeltrd vk cv cn0 wcel c1 cM vk cv caddc co cfa cfv cdiv co c1
        cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp co cmul co vk
        cv cP cfv vk cv cH cfv cle vk cv cn0 wcel c1 cM vk cv caddc co cfa cfv
        cdiv co c1 cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cdiv co c1
        cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp co cmul co cle
        vk cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cM vk cv
        caddc co cfa cfv cle wbr c1 cM vk cv caddc co cfa cfv cdiv co c1 cM cfa
        cfv cM c1 caddc co vk cv cexp co cmul co cdiv co cle wbr cM cn0 wcel vk
        cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cM vk cv
        caddc co cfa cfv cle wbr cM ef1tllem.5 nnnn0i vk cv cM faclbnd6 mpan cM
        cfa cfv cM c1 caddc co vk cv cexp co cmul co cr wcel cc0 cM cfa cfv cM
        c1 caddc co vk cv cexp co cmul co clt wbr cM vk cv caddc co cfa cfv cr
        wcel cc0 cM vk cv caddc co cfa cfv clt wbr cM cfa cfv cM c1 caddc co vk
        cv cexp co cmul co cM vk cv caddc co cfa cfv cle wbr c1 cM vk cv caddc
        co cfa cfv cdiv co c1 cM cfa cfv cM c1 caddc co vk cv cexp co cmul co
        cdiv co cle wbr wb vk cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp
        co cmul co cM vk cv caddc co cfa cfv lerec vk cv cn0 wcel cM cfa cfv cM
        c1 caddc co vk cv cexp co cmul co cn wcel cM cfa cfv cM c1 caddc co vk
        cv cexp co cmul co cr wcel cM cfa cfv cn wcel cM c1 caddc co vk cv cexp
        co cn wcel cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cn wcel vk
        cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp co nnmulcl cM cn0 wcel
        cM cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl ax-mp cM c1 caddc co
        cn wcel vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM cn wcel
        cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk
        cv nnexpcl mpan sylancr cM cfa cfv cM c1 caddc co vk cv cexp co cmul co
        nnre syl vk cv cn0 wcel cM cfa cfv cM c1 caddc co vk cv cexp co cmul co
        cn wcel cc0 cM cfa cfv cM c1 caddc co vk cv cexp co cmul co clt wbr cM
        cfa cfv cn wcel cM c1 caddc co vk cv cexp co cn wcel cM cfa cfv cM c1
        caddc co vk cv cexp co cmul co cn wcel vk cv cn0 wcel cM cfa cfv cM c1
        caddc co vk cv cexp co nnmulcl cM cn0 wcel cM cfa cfv cn wcel cM
        ef1tllem.5 nnnn0i cM faccl ax-mp cM c1 caddc co cn wcel vk cv cn0 wcel
        cM c1 caddc co vk cv cexp co cn wcel cM cn wcel cM c1 caddc co cn wcel
        ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk cv nnexpcl mpan sylancr
        cM cfa cfv cM c1 caddc co vk cv cexp co cmul co nngt0 syl vk cv cn0
        wcel cM vk cv caddc co cfa cfv cn wcel cM vk cv caddc co cfa cfv cr
        wcel vk cv cn0 wcel cM vk cv caddc co cn0 wcel cM vk cv caddc co cfa
        cfv cn wcel cM cn0 wcel vk cv cn0 wcel cM vk cv caddc co cn0 wcel cM
        ef1tllem.5 nnnn0i cM vk cv nn0addcl mpan cM vk cv caddc co faccl syl cM
        vk cv caddc co cfa cfv nnre syl vk cv cn0 wcel cM vk cv caddc co cfa
        cfv cn wcel cc0 cM vk cv caddc co cfa cfv clt wbr vk cv cn0 wcel cM vk
        cv caddc co cn0 wcel cM vk cv caddc co cfa cfv cn wcel cM cn0 wcel vk
        cv cn0 wcel cM vk cv caddc co cn0 wcel cM ef1tllem.5 nnnn0i cM vk cv
        nn0addcl mpan cM vk cv caddc co faccl syl cM vk cv caddc co cfa cfv
        nngt0 syl syl2anc mpbid vk cv cn0 wcel c1 cM cfa cfv cdiv co c1 cM c1
        caddc co cdiv co vk cv cexp co cmul co c1 cM cfa cfv cdiv co c1 cM c1
        caddc co vk cv cexp co cdiv co cmul co c1 cM cfa cfv cM c1 caddc co vk
        cv cexp co cmul co cdiv co vk cv cn0 wcel c1 cM c1 caddc co cdiv co vk
        cv cexp co c1 cM c1 caddc co vk cv cexp co cdiv co c1 cM cfa cfv cdiv
        co cmul cM c1 caddc co cc wcel vk cv cn0 wcel cM c1 caddc co cc0 wne c1
        cM c1 caddc co cdiv co vk cv cexp co c1 cM c1 caddc co vk cv cexp co
        cdiv co wceq cM c1 caddc co cM cn wcel cM c1 caddc co cn wcel
        ef1tllem.5 cM peano2nn ax-mp nncni cM c1 caddc co cM cn wcel cM c1
        caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp nnne0i cM c1 caddc co vk
        cv exprecOLD mp3an13 opreq2d vk cv cn0 wcel c1 cM cfa cfv cdiv co c1 cM
        c1 caddc co vk cv cexp co cdiv co cmul co c1 c1 cmul co cM cfa cfv cM
        c1 caddc co vk cv cexp co cmul co cdiv co c1 cM cfa cfv cM c1 caddc co
        vk cv cexp co cmul co cdiv co cM c1 caddc co vk cv cexp co cc wcel cM
        c1 caddc co vk cv cexp co cc0 wne c1 cM cfa cfv cdiv co c1 cM c1 caddc
        co vk cv cexp co cdiv co cmul co c1 c1 cmul co cM cfa cfv cM c1 caddc
        co vk cv cexp co cmul co cdiv co wceq vk cv cn0 wcel cM cfa cfv cc wcel
        cM cfa cfv cc0 wne cM c1 caddc co vk cv cexp co cc wcel cM c1 caddc co
        vk cv cexp co cc0 wne wa c1 cM cfa cfv cdiv co c1 cM c1 caddc co vk cv
        cexp co cdiv co cmul co c1 c1 cmul co cM cfa cfv cM c1 caddc co vk cv
        cexp co cmul co cdiv co wceq cM cfa cfv cM cn0 wcel cM cfa cfv cn wcel
        cM ef1tllem.5 nnnn0i cM faccl ax-mp nncni cM cfa cfv cM cn0 wcel cM cfa
        cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl ax-mp nnne0i c1 cc wcel c1 cc
        wcel cM cfa cfv cc wcel cM cfa cfv cc0 wne wa cM c1 caddc co vk cv cexp
        co cc wcel cM c1 caddc co vk cv cexp co cc0 wne wa wa c1 cM cfa cfv
        cdiv co c1 cM c1 caddc co vk cv cexp co cdiv co cmul co c1 c1 cmul co
        cM cfa cfv cM c1 caddc co vk cv cexp co cmul co cdiv co wceq ax1cn
        ax1cn c1 c1 cM cfa cfv cM c1 caddc co vk cv cexp co divmuldiv mpanl12
        mpanl12 vk cv cn0 wcel cM c1 caddc co vk cv cexp co vk cv cn0 wcel cM
        c1 caddc co vk cv cexp co cn wcel cM c1 caddc co vk cv cexp co cr wcel
        cM c1 caddc co cn wcel vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn
        wcel cM cn wcel cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp cM
        c1 caddc co vk cv nnexpcl mpan cM c1 caddc co vk cv cexp co nnre syl
        recnd vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM c1 caddc
        co vk cv cexp co cc0 wne cM c1 caddc co cn wcel vk cv cn0 wcel cM c1
        caddc co vk cv cexp co cn wcel cM cn wcel cM c1 caddc co cn wcel
        ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk cv nnexpcl mpan cM c1
        caddc co vk cv cexp co nnne0 syl sylanc c1 c1 cmul co c1 cM cfa cfv cM
        c1 caddc co vk cv cexp co cmul co cdiv c1 ax1cn mulid1i opreq1i syl6eq
        eqtrd breqtrrd vj vy vk cv c1 cM vj cv caddc co cfa cfv cdiv co c1 cM
        vk cv caddc co cfa cfv cdiv co cn0 cP vj cv vk cv wceq cM vj cv caddc
        co cfa cfv cM vk cv caddc co cfa cfv c1 cdiv vj cv vk cv wceq cM vj cv
        caddc co cM vk cv caddc co cfa vj cv vk cv cM caddc opreq2 fveq2d
        opreq2d ef1tllem.4 c1 cM vk cv caddc co cfa cfv cdiv oprex fvopab4 vj
        vy vk cv c1 cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vj cv cexp co
        cmul co c1 cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp co
        cmul co cn0 cH vj cv vk cv wceq c1 cM c1 caddc co cdiv co vj cv cexp co
        c1 cM c1 caddc co cdiv co vk cv cexp co c1 cM cfa cfv cdiv co cmul vj
        cv vk cv c1 cM c1 caddc co cdiv co cexp opreq2 opreq2d ef1tllem.3 c1 cM
        cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp co cmul oprex
        fvopab4 3brtr4d 3jca sylbir rgen cc0 caddc cop cP cseqz co cM cuz cfv
        vk cv cF cfv vk csu cli wbr cc0 caddc cop cH cseqz co c1 cM cfa cfv
        cdiv co cM c1 caddc co cM cdiv co cmul co cli wbr cc0 cz wcel vk cv cP
        cfv cr wcel vk cv cH cfv cr wcel vk cv cP cfv vk cv cH cfv cle wbr w3a
        vk cc0 cuz cfv wral wa cM cuz cfv vk cv cF cfv vk csu c1 cM cfa cfv
        cdiv co cM c1 caddc co cM cdiv co cmul co cle wbr cc0 caddc cop cP
        cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM caddc cop cF cseqz
        co cM cuz cfv vk cv cF cfv vk csu cli wbr cM cz wcel cM caddc cop cF
        cseqz co vx cv cli wbr vx wex cM caddc cop cF cseqz co cM cuz cfv vk cv
        cF cfv vk csu cli wbr cM cn wcel cM cz wcel ef1tllem.5 cM nnz ax-mp cA
        cc wcel cM cn wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cA c1
        cc ef1tllem.6 ax1cn eqeltri ef1tllem.5 vx vy cA vj cF cM ef1tllem.1
        eftlex mp2an vx vk cF cM vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv
        co cF nn0ex ef1tllem.1 fopabex2 isumclim2 mp2an cc0 caddc cop cP cseqz
        co cM cuz cfv vk cv cF cfv vk csu cli wbr cc0 cM caddc co caddc cop cF
        cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM caddc cop cF cseqz
        co cM cuz cfv vk cv cF cfv vk csu cli wbr cM cuz cfv vk cv cF cfv vk
        csu cvv wcel vk cv cP cfv cc wcel vk cv cM caddc co cF cfv vk cv cP cfv
        wceq wa vk cc0 cuz cfv wral cc0 caddc cop cP cseqz co cM cuz cfv vk cv
        cF cfv vk csu cli wbr cc0 cM caddc co caddc cop cF cseqz co cM cuz cfv
        vk cv cF cfv vk csu cli wbr wb cM cuz cfv vk cv cF cfv vk sumex vk cv
        cP cfv cc wcel vk cv cM caddc co cF cfv vk cv cP cfv wceq wa vk cc0 cuz
        cfv vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cP cfv cc wcel vk cv cM
        caddc co cF cfv vk cv cP cfv wceq wa vk cv elnn0uz vk cv cn0 wcel vk cv
        cP cfv cc wcel vk cv cM caddc co cF cfv vk cv cP cfv wceq vk cv cn0
        wcel vk cv cP cfv vk cv cn0 wcel vk cv cP cfv c1 cM vk cv caddc co cfa
        cfv cdiv co cr vj vy vk cv c1 cM vj cv caddc co cfa cfv cdiv co c1 cM
        vk cv caddc co cfa cfv cdiv co cn0 cP vj cv vk cv wceq cM vj cv caddc
        co cfa cfv cM vk cv caddc co cfa cfv c1 cdiv vj cv vk cv wceq cM vj cv
        caddc co cM vk cv caddc co cfa vj cv vk cv cM caddc opreq2 fveq2d
        opreq2d ef1tllem.4 c1 cM vk cv caddc co cfa cfv cdiv oprex fvopab4 cM
        vk cv caddc co cfa cfv cr wcel cM vk cv caddc co cfa cfv cc0 wne c1 cM
        vk cv caddc co cfa cfv cdiv co cr wcel vk cv cn0 wcel cM vk cv caddc co
        cfa cfv rereccl vk cv cn0 wcel cM vk cv caddc co cfa cfv cn wcel cM vk
        cv caddc co cfa cfv cr wcel vk cv cn0 wcel cM vk cv caddc co cn0 wcel
        cM vk cv caddc co cfa cfv cn wcel cM cn0 wcel vk cv cn0 wcel cM vk cv
        caddc co cn0 wcel cM ef1tllem.5 nnnn0i cM vk cv nn0addcl mpan cM vk cv
        caddc co faccl syl cM vk cv caddc co cfa cfv nnre syl vk cv cn0 wcel cM
        vk cv caddc co cfa cfv cn wcel cM vk cv caddc co cfa cfv cc0 wne vk cv
        cn0 wcel cM vk cv caddc co cn0 wcel cM vk cv caddc co cfa cfv cn wcel
        cM cn0 wcel vk cv cn0 wcel cM vk cv caddc co cn0 wcel cM ef1tllem.5
        nnnn0i cM vk cv nn0addcl mpan cM vk cv caddc co faccl syl cM vk cv
        caddc co cfa cfv nnne0 syl sylanc eqeltrd recnd vk cv cn0 wcel vk cv cP
        cfv c1 cM vk cv caddc co cfa cfv cdiv co cM vk cv caddc co cF cfv vk cv
        cM caddc co cF cfv vj vy vk cv c1 cM vj cv caddc co cfa cfv cdiv co c1
        cM vk cv caddc co cfa cfv cdiv co cn0 cP vj cv vk cv wceq cM vj cv
        caddc co cfa cfv cM vk cv caddc co cfa cfv c1 cdiv vj cv vk cv wceq cM
        vj cv caddc co cM vk cv caddc co cfa vj cv vk cv cM caddc opreq2 fveq2d
        opreq2d ef1tllem.4 c1 cM vk cv caddc co cfa cfv cdiv oprex fvopab4 vk
        cv cn0 wcel cM vk cv caddc co cF cfv c1 cM vk cv caddc co cexp co cM vk
        cv caddc co cfa cfv cdiv co c1 cM vk cv caddc co cfa cfv cdiv co vk cv
        cn0 wcel cM vk cv caddc co cF cfv cA cM vk cv caddc co cexp co cM vk cv
        caddc co cfa cfv cdiv co c1 cM vk cv caddc co cexp co cM vk cv caddc co
        cfa cfv cdiv co vk cv cn0 wcel cM vk cv caddc co cn0 wcel cM vk cv
        caddc co cF cfv cA cM vk cv caddc co cexp co cM vk cv caddc co cfa cfv
        cdiv co wceq cM cn0 wcel vk cv cn0 wcel cM vk cv caddc co cn0 wcel cM
        ef1tllem.5 nnnn0i cM vk cv nn0addcl mpan vy cA vj cF cM vk cv caddc co
        ef1tllem.1 eftval syl cA cM vk cv caddc co cexp co c1 cM vk cv caddc co
        cexp co cM vk cv caddc co cfa cfv cdiv cA c1 cM vk cv caddc co cexp
        ef1tllem.6 opreq1i opreq1i syl6eq vk cv cn0 wcel c1 cM vk cv caddc co
        cexp co c1 cM vk cv caddc co cfa cfv cdiv vk cv cn0 wcel cM vk cv caddc
        co cn0 wcel c1 cM vk cv caddc co cexp co c1 wceq cM cn0 wcel vk cv cn0
        wcel cM vk cv caddc co cn0 wcel cM ef1tllem.5 nnnn0i cM vk cv nn0addcl
        mpan cM vk cv caddc co 1exp syl opreq1d eqtrd vk cv cn0 wcel cM vk cv
        caddc co vk cv cM caddc co cF cM cc wcel vk cv cc wcel cM vk cv caddc
        co vk cv cM caddc co wceq vk cv cn0 wcel cM vk cv addcom cM ef1tllem.5
        nncni vk cv nn0cn sylancr fveq2d 3eqtr2rd jca sylbir rgen cM cuz cfv vk
        cv cF cfv vk csu cvv vk cP cF cM cc0 vj vy cn0 c1 cM vj cv caddc co cfa
        cfv cdiv co cP nn0ex ef1tllem.4 fopabex2 vj vy cn0 cA vj cv cexp co vj
        cv cfa cfv cdiv co cF nn0ex ef1tllem.1 fopabex2 0z cM cn wcel cM cz
        wcel ef1tllem.5 cM nnz ax-mp iserzshft2i mp2an cc0 cM caddc co caddc
        cop cF cseqz co cM caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu
        cli cc0 cM caddc co caddc cop cM caddc cop cF cseqz cc0 cM caddc co cM
        caddc cM cM ef1tllem.5 nncni addid2i opeq1i opreq1i breq1i bitri mpbir
        cc0 caddc cop cG cseqz co cM c1 caddc co cM cdiv co cli wbr cc0 caddc
        cop cH cseqz co c1 cM cfa cfv cdiv co cM c1 caddc co cM cdiv co cmul co
        cli wbr caddc cG cseq0 co cM c1 caddc co cM c1 caddc co c1 cmin co cdiv
        co cc0 caddc cop cG cseqz co cM c1 caddc co cM cdiv co cli cM c1 caddc
        co cc wcel c1 cM c1 caddc co cabs cfv clt wbr caddc cG cseq0 co cM c1
        caddc co cM c1 caddc co c1 cmin co cdiv co cli wbr cM c1 caddc co cM cn
        wcel cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp nncni c1 cM c1
        caddc co cM c1 caddc co cabs cfv clt c1 cM cle wbr c1 cM c1 caddc co
        clt wbr cM cn wcel c1 cM cle wbr ef1tllem.5 cM nnge1 ax-mp c1 cn wcel
        cM cn wcel c1 cM cle wbr c1 cM c1 caddc co clt wbr wb 1nn ef1tllem.5 c1
        cM nnleltp1 mp2an mpbi cM c1 caddc co cr wcel cc0 cM c1 caddc co cle
        wbr cM c1 caddc co cabs cfv cM c1 caddc co wceq cM c1 caddc co cM cn
        wcel cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp nnrei cM c1
        caddc co cM c1 caddc co cM cn wcel cM c1 caddc co cn wcel ef1tllem.5 cM
        peano2nn ax-mp nnnn0i nn0ge0i cM c1 caddc co absid mp2an breqtrri vy cM
        c1 caddc co vj cG ef1tllem.2 georeclim mp2an caddc cG addex vj vy cn0
        c1 cM c1 caddc co cdiv co vj cv cexp co cG nn0ex ef1tllem.2 fopabex2
        seq0seqz cM c1 caddc co c1 cmin co cM cM c1 caddc co cdiv cM cc wcel c1
        cc wcel cM c1 caddc co c1 cmin co cM wceq cM ef1tllem.5 nncni ax1cn cM
        c1 pncan mp2an opreq2i 3brtr3i cc0 cz wcel c1 cM cfa cfv cdiv co cc
        wcel vk cv cG cfv cc wcel vk cv cH cfv c1 cM cfa cfv cdiv co vk cv cG
        cfv cmul co wceq wa vk cc0 cuz cfv wral cc0 caddc cop cG cseqz co cM c1
        caddc co cM cdiv co cli wbr cc0 caddc cop cH cseqz co c1 cM cfa cfv
        cdiv co cM c1 caddc co cM cdiv co cmul co cli wbr wi 0z cM cfa cfv cM
        cfa cfv cM cn0 wcel cM cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl
        ax-mp nncni cM cfa cfv cM cn0 wcel cM cfa cfv cn wcel cM ef1tllem.5
        nnnn0i cM faccl ax-mp nnne0i reccli vk cv cG cfv cc wcel vk cv cH cfv
        c1 cM cfa cfv cdiv co vk cv cG cfv cmul co wceq wa vk cc0 cuz cfv vk cv
        cc0 cuz cfv wcel vk cv cn0 wcel vk cv cG cfv cc wcel vk cv cH cfv c1 cM
        cfa cfv cdiv co vk cv cG cfv cmul co wceq wa vk cv elnn0uz vk cv cn0
        wcel vk cv cG cfv cc wcel vk cv cH cfv c1 cM cfa cfv cdiv co vk cv cG
        cfv cmul co wceq vk cv cn0 wcel vk cv cG cfv c1 cM c1 caddc co vk cv
        cexp co cdiv co cc vk cv cn0 wcel vk cv cG cfv c1 cM c1 caddc co cdiv
        co vk cv cexp co c1 cM c1 caddc co vk cv cexp co cdiv co vj vy vk cv c1
        cM c1 caddc co cdiv co vj cv cexp co c1 cM c1 caddc co cdiv co vk cv
        cexp co cn0 cG vj cv vk cv c1 cM c1 caddc co cdiv co cexp opreq2
        ef1tllem.2 c1 cM c1 caddc co cdiv co vk cv cexp oprex fvopab4 cM c1
        caddc co cc wcel vk cv cn0 wcel cM c1 caddc co cc0 wne c1 cM c1 caddc
        co cdiv co vk cv cexp co c1 cM c1 caddc co vk cv cexp co cdiv co wceq
        cM c1 caddc co cM cn wcel cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn
        ax-mp nncni cM c1 caddc co cM cn wcel cM c1 caddc co cn wcel ef1tllem.5
        cM peano2nn ax-mp nnne0i cM c1 caddc co vk cv exprecOLD mp3an13 eqtrd
        cM c1 caddc co vk cv cexp co cc wcel cM c1 caddc co vk cv cexp co cc0
        wne c1 cM c1 caddc co vk cv cexp co cdiv co cc wcel vk cv cn0 wcel cM
        c1 caddc co vk cv cexp co reccl vk cv cn0 wcel cM c1 caddc co vk cv
        cexp co vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM c1 caddc
        co vk cv cexp co cr wcel cM c1 caddc co cn wcel vk cv cn0 wcel cM c1
        caddc co vk cv cexp co cn wcel cM cn wcel cM c1 caddc co cn wcel
        ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk cv nnexpcl mpan cM c1
        caddc co vk cv cexp co nnre syl recnd vk cv cn0 wcel cM c1 caddc co vk
        cv cexp co cn wcel cM c1 caddc co vk cv cexp co cc0 wne cM c1 caddc co
        cn wcel vk cv cn0 wcel cM c1 caddc co vk cv cexp co cn wcel cM cn wcel
        cM c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp cM c1 caddc co vk
        cv nnexpcl mpan cM c1 caddc co vk cv cexp co nnne0 syl sylanc eqeltrd
        vk cv cn0 wcel vk cv cH cfv c1 cM cfa cfv cdiv co c1 cM c1 caddc co
        cdiv co vk cv cexp co cmul co c1 cM cfa cfv cdiv co vk cv cG cfv cmul
        co vj vy vk cv c1 cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vj cv
        cexp co cmul co c1 cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv
        cexp co cmul co cn0 cH vj cv vk cv wceq c1 cM c1 caddc co cdiv co vj cv
        cexp co c1 cM c1 caddc co cdiv co vk cv cexp co c1 cM cfa cfv cdiv co
        cmul vj cv vk cv c1 cM c1 caddc co cdiv co cexp opreq2 opreq2d
        ef1tllem.3 c1 cM cfa cfv cdiv co c1 cM c1 caddc co cdiv co vk cv cexp
        co cmul oprex fvopab4 vk cv cn0 wcel vk cv cG cfv c1 cM c1 caddc co
        cdiv co vk cv cexp co c1 cM cfa cfv cdiv co cmul vj vy vk cv c1 cM c1
        caddc co cdiv co vj cv cexp co c1 cM c1 caddc co cdiv co vk cv cexp co
        cn0 cG vj cv vk cv c1 cM c1 caddc co cdiv co cexp opreq2 ef1tllem.2 c1
        cM c1 caddc co cdiv co vk cv cexp oprex fvopab4 opreq2d eqtr4d jca
        sylbir rgen cM c1 caddc co cM cdiv co c1 cM cfa cfv cdiv co vk cG cH
        cc0 cM c1 caddc co cM cdiv oprex vj vy cn0 c1 cM c1 caddc co cdiv co vj
        cv cexp co cG nn0ex ef1tllem.2 fopabex2 vj vy cn0 c1 cM cfa cfv cdiv co
        c1 cM c1 caddc co cdiv co vj cv cexp co cmul co cH nn0ex ef1tllem.3
        fopabex2 iserzmulc1 mp3an ax-mp cM cuz cfv vk cv cF cfv vk csu c1 cM
        cfa cfv cdiv co cM c1 caddc co cM cdiv co cmul co vk cP cH cc0 cM cuz
        cfv vk cv cF cfv vk sumex c1 cM cfa cfv cdiv co cM c1 caddc co cM cdiv
        co cmul oprex vj vy cn0 c1 cM vj cv caddc co cfa cfv cdiv co cP nn0ex
        ef1tllem.4 fopabex2 vj vy cn0 c1 cM cfa cfv cdiv co c1 cM c1 caddc co
        cdiv co vj cv cexp co cmul co cH nn0ex ef1tllem.3 fopabex2 iserzcmp
        mpanl12 mp2an c1 cM cfa cfv cdiv co cM c1 caddc co cM cdiv co cmul co
        c1 cM c1 caddc co cmul co cM cfa cfv cM cmul co cdiv co cM c1 caddc co
        cM cfa cfv cM cmul co cdiv co c1 cM cfa cfv cM c1 caddc co cM ax1cn cM
        cfa cfv cM cn0 wcel cM cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl
        ax-mp nncni cM c1 caddc co cM cn wcel cM c1 caddc co cn wcel ef1tllem.5
        cM peano2nn ax-mp nncni cM ef1tllem.5 nncni cM cfa cfv cM cn0 wcel cM
        cfa cfv cn wcel cM ef1tllem.5 nnnn0i cM faccl ax-mp nnne0i cM
        ef1tllem.5 nnne0i divmuldivi c1 cM c1 caddc co cmul co cM c1 caddc co
        cM cfa cfv cM cmul co cdiv cM c1 caddc co cM c1 caddc co cM cn wcel cM
        c1 caddc co cn wcel ef1tllem.5 cM peano2nn ax-mp nncni mulid2i opreq1i
        eqtri breqtri $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    ${
      $d A j k y $.  $d M j k y $.
      $( An upper bound on the infinite tail of the series expansion of the
         exponential function at 1.  (Contributed by Paul Chapman,
         19-Jan-2008.) $)
      ef1tlubi $p |- ( ( M e. NN /\ A = 1 ) ->
                      sum_ k e. ( ZZ>= ` M ) ( F ` k ) <_
                      ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) $=
        cM cn wcel cA c1 wceq cM cuz cfv vk cv cF cfv vk csu cM c1 caddc co cM
        cfa cfv cM cmul co cdiv co cle wbr cM cn wcel cM c1 cif cuz cfv vk cv
        cF cfv vk csu cM cn wcel cM c1 cif c1 caddc co cM cn wcel cM c1 cif cfa
        cfv cM cn wcel cM c1 cif cmul co cdiv co cle wbr cM cn wcel cM c1 cif
        cuz cfv vk cv vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co
        vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cM cn wcel cM c1
        cif c1 caddc co cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif cmul
        co cdiv co cle wbr cM cA c1 c1 cM cM cn wcel cM c1 cif wceq cM cuz cfv
        vk cv cF cfv vk csu cM cn wcel cM c1 cif cuz cfv vk cv cF cfv vk csu cM
        c1 caddc co cM cfa cfv cM cmul co cdiv co cM cn wcel cM c1 cif c1 caddc
        co cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif cmul co cdiv co
        cle cM cM cn wcel cM c1 cif wceq cM cuz cfv cM cn wcel cM c1 cif cuz
        cfv vk cv cF cfv vk cM cM cn wcel cM c1 cif cuz fveq2 sumeq1d cM cM cn
        wcel cM c1 cif wceq cM c1 caddc co cM cn wcel cM c1 cif c1 caddc co cM
        cfa cfv cM cmul co cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif
        cmul co cdiv cM cM cn wcel cM c1 cif c1 caddc opreq1 cM cM cn wcel cM
        c1 cif wceq cM cfa cfv cM cn wcel cM c1 cif cfa cfv cM cM cn wcel cM c1
        cif cmul cM cM cn wcel cM c1 cif cfa fveq2 cM cM cn wcel cM c1 cif wceq
        id opreq12d opreq12d breq12d cA cA c1 wceq cA c1 cif wceq cM cn wcel cM
        c1 cif cuz cfv vk cv cF cfv vk csu cM cn wcel cM c1 cif cuz cfv vk cv
        vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa cfv
        cdiv co wceq wa vj vy copab cfv vk csu cM cn wcel cM c1 cif c1 caddc co
        cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif cmul co cdiv co cle
        cA cA c1 wceq cA c1 cif wceq cM cn wcel cM c1 cif cuz cfv vk cv cF cfv
        vk cv vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa
        cfv cdiv co wceq wa vj vy copab cfv vk cA cA c1 wceq cA c1 cif wceq vk
        cv cF vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa
        cfv cdiv co wceq wa vj vy copab cA cA c1 wceq cA c1 cif wceq vj cv cn0
        wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
        vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa cfv
        cdiv co wceq wa vj vy copab cF cA cA c1 wceq cA c1 cif wceq vj cv cn0
        wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj cv cn0
        wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co
        wceq wa vj vy cA cA c1 wceq cA c1 cif wceq vy cv cA vj cv cexp co vj cv
        cfa cfv cdiv co wceq vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa
        cfv cdiv co wceq vj cv cn0 wcel cA cA c1 wceq cA c1 cif wceq cA vj cv
        cexp co vj cv cfa cfv cdiv co cA c1 wceq cA c1 cif vj cv cexp co vj cv
        cfa cfv cdiv co vy cv cA cA c1 wceq cA c1 cif wceq cA vj cv cexp co cA
        c1 wceq cA c1 cif vj cv cexp co vj cv cfa cfv cdiv cA cA c1 wceq cA c1
        cif vj cv cexp opreq1 opreq1d eqeq2d anbi2d opabbidv ef1tllem.1 syl5eq
        fveq1d sumeq2sdv breq1d vy cA c1 wceq cA c1 cif vj cv cn0 wcel vy cv c1
        cM cn wcel cM c1 cif vj cv caddc co cfa cfv cdiv co wceq wa vj vy copab
        vj vk vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co vj cv cfa
        cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv c1 cM cn wcel cM
        c1 cif c1 caddc co cdiv co vj cv cexp co wceq wa vj vy copab vj cv cn0
        wcel vy cv c1 cM cn wcel cM c1 cif cfa cfv cdiv co c1 cM cn wcel cM c1
        cif c1 caddc co cdiv co vj cv cexp co cmul co wceq wa vj vy copab cM cn
        wcel cM c1 cif vj cv cn0 wcel vy cv cA c1 wceq cA c1 cif vj cv cexp co
        vj cv cfa cfv cdiv co wceq wa vj vy copab eqid vj cv cn0 wcel vy cv c1
        cM cn wcel cM c1 cif c1 caddc co cdiv co vj cv cexp co wceq wa vj vy
        copab eqid vj cv cn0 wcel vy cv c1 cM cn wcel cM c1 cif cfa cfv cdiv co
        c1 cM cn wcel cM c1 cif c1 caddc co cdiv co vj cv cexp co cmul co wceq
        wa vj vy copab eqid vj cv cn0 wcel vy cv c1 cM cn wcel cM c1 cif vj cv
        caddc co cfa cfv cdiv co wceq wa vj vy copab eqid cM c1 cn 1nn elimel
        cA c1 wceq cA c1 wceq cA c1 cif c1 wceq c1 c1 wceq cA c1 cA cA c1 wceq
        cA c1 cif c1 eqeq1 c1 cA c1 wceq cA c1 cif c1 eqeq1 c1 eqid elimhyp
        ef1tllem dedth2h $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    ${
      $d A j k x y $.  $d F k x $.  $d G k $.  $d M j k x y $.
      ef01tllem1.2 $e |- G = { <. j , y >. | ( j e. NN0 /\
                               y = ( ( A ^ ( j - M ) ) / ( ! ` j ) ) ) } $.
      ef01tllem1.3 $e |- M e. NN $.
      ef01tllem1.4 $e |- A e. RR $.
      ef01tllem1.5 $e |- A =/= 0 $.
      $( Lemma for ~ ef01tlubi . $)
      ef01tllem1 $p |- ( <. M , + >. seq G ) ~~>
                       ( sum_ k e. ( ZZ>= ` M ) ( F ` k ) / ( A ^ M ) ) $=
        cM caddc cop cG cseqz co c1 cA cM cexp co cdiv co cM cuz cfv vk cv cF
        cfv vk csu cmul co cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co
        cli cM caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM
        caddc cop cG cseqz co c1 cA cM cexp co cdiv co cM cuz cfv vk cv cF cfv
        vk csu cmul co cli wbr cM cz wcel cM caddc cop cF cseqz co vx cv cli
        wbr vx wex cM caddc cop cF cseqz co cM cuz cfv vk cv cF cfv vk csu cli
        wbr cM cn wcel cM cz wcel ef01tllem1.3 cM nnz ax-mp cA cc wcel cM cn
        wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cA ef01tllem1.4
        recni ef01tllem1.3 vx vy cA vj cF cM ef1tllem.1 eftlex mp2an vx vk cF
        cM vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex ef1tllem.1
        fopabex2 isumclim2 mp2an cM cz wcel c1 cA cM cexp co cdiv co cc wcel vk
        cv cF cfv cc wcel vk cv cG cfv c1 cA cM cexp co cdiv co vk cv cF cfv
        cmul co wceq wa vk cM cuz cfv wral cM caddc cop cF cseqz co cM cuz cfv
        vk cv cF cfv vk csu cli wbr cM caddc cop cG cseqz co c1 cA cM cexp co
        cdiv co cM cuz cfv vk cv cF cfv vk csu cmul co cli wbr wi cM cn wcel cM
        cz wcel ef01tllem1.3 cM nnz ax-mp cA cM cexp co cA cc wcel cM cn0 wcel
        cA cM cexp co cc wcel cA ef01tllem1.4 recni cM ef01tllem1.3 nnnn0i cA
        cM expcl mp2an cA cM cexp co cc0 wne cA cc0 wne ef01tllem1.5 cA cc wcel
        cM cn wcel cA cM cexp co cc0 wne cA cc0 wne wb cA ef01tllem1.4 recni
        ef01tllem1.3 cA cM expne0 mp2an mpbir reccli vk cv cF cfv cc wcel vk cv
        cG cfv c1 cA cM cexp co cdiv co vk cv cF cfv cmul co wceq wa vk cM cuz
        cfv vk cv cM cuz cfv wcel vk cv cF cfv cc wcel vk cv cG cfv c1 cA cM
        cexp co cdiv co vk cv cF cfv cmul co wceq vk cv cM cuz cfv wcel vk cv
        cn0 wcel vk cv cF cfv cc wcel vk cv cM cuz cfv wcel vk cv cc0 cuz cfv
        wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0
        cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem1.3 nnnn0i cM
        elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0
        wcel vk cv cF cfv cA vk cv cexp co vk cv cfa cfv cdiv co cc vy cA vj cF
        vk cv ef1tllem.1 eftval cA cc wcel vk cv cn0 wcel cA vk cv cexp co vk
        cv cfa cfv cdiv co cc wcel cA ef01tllem1.4 recni cA vk cv eftcl mpan
        eqeltrd syl vk cv cM cuz cfv wcel vk cv cG cfv cA vk cv cexp co vk cv
        cfa cfv cdiv co cA cM cexp co cdiv co c1 cA cM cexp co cdiv co vk cv cF
        cfv cmul co vk cv cM cuz cfv wcel vk cv cG cfv cA vk cv cM cmin co cexp
        co vk cv cfa cfv cdiv co cA vk cv cexp co cA cM cexp co cdiv co vk cv
        cfa cfv cdiv co cA vk cv cexp co vk cv cfa cfv cdiv co cA cM cexp co
        cdiv co vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cG cfv cA vk cv cM
        cmin co cexp co vk cv cfa cfv cdiv co wceq vk cv cM cuz cfv wcel vk cv
        cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv
        wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem1.3 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr vj vy vk cv cA vj cv cM cmin co cexp co vj cv cfa cfv
        cdiv co cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co cn0 cG vj cv
        vk cv wceq cA vj cv cM cmin co cexp co cA vk cv cM cmin co cexp co vj
        cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv wceq vj cv cM cmin co vk cv
        cM cmin co cA cexp vj cv vk cv cM cmin opreq1 opreq2d vj cv vk cv cfa
        fveq2 opreq12d ef01tllem1.2 cA vk cv cM cmin co cexp co vk cv cfa cfv
        cdiv oprex fvopab4 syl vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp
        co cA vk cv cexp co cA cM cexp co cdiv co vk cv cfa cfv cdiv cA cc wcel
        vk cv cn0 wcel cM cn0 wcel w3a cA cc0 wne cM vk cv cle wbr wa cA vk cv
        cM cmin co cexp co cA vk cv cexp co cA cM cexp co cdiv co wceq vk cv cM
        cuz cfv wcel cA vk cv cM expsubOLD vk cv cM cuz cfv wcel cA cc wcel vk
        cv cn0 wcel cM cn0 wcel cA cc wcel vk cv cM cuz cfv wcel cA
        ef01tllem1.4 recni a1i vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk
        cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv
        wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem1.3 nnnn0i cM elnn0uz
        mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr cM cn0 wcel vk cv cM
        cuz cfv wcel cM ef01tllem1.3 nnnn0i a1i 3jca vk cv cM cuz cfv wcel cM
        vk cv cle wbr cA cc0 wne cM vk cv eluzle ef01tllem1.5 jctil sylanc
        opreq1d vk cv cM cuz cfv wcel vk cv cn0 wcel cA vk cv cexp co cA cM
        cexp co cdiv co vk cv cfa cfv cdiv co cA vk cv cexp co vk cv cfa cfv
        cdiv co cA cM cexp co cdiv co wceq vk cv cM cuz cfv wcel vk cv cc0 cuz
        cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv
        cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem1.3 nnnn0i
        cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr cA vk cv
        cexp co cc wcel vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne wa cA vk cv
        cexp co cA cM cexp co cdiv co vk cv cfa cfv cdiv co cA vk cv cexp co vk
        cv cfa cfv cdiv co cA cM cexp co cdiv co wceq vk cv cn0 wcel cA vk cv
        cexp co cc wcel cA cM cexp co cc wcel cA cM cexp co cc0 wne wa vk cv
        cfa cfv cc wcel vk cv cfa cfv cc0 wne wa cA vk cv cexp co cA cM cexp co
        cdiv co vk cv cfa cfv cdiv co cA vk cv cexp co vk cv cfa cfv cdiv co cA
        cM cexp co cdiv co wceq cA cM cexp co cc wcel cA cM cexp co cc0 wne cA
        cc wcel cM cn0 wcel cA cM cexp co cc wcel cA ef01tllem1.4 recni cM
        ef01tllem1.3 nnnn0i cA cM expcl mp2an cA cM cexp co cc0 wne cA cc0 wne
        ef01tllem1.5 cA cc wcel cM cn wcel cA cM cexp co cc0 wne cA cc0 wne wb
        cA ef01tllem1.4 recni ef01tllem1.3 cA cM expne0 mp2an mpbir pm3.2i cA
        vk cv cexp co cA cM cexp co vk cv cfa cfv divdiv23 mp3an2 cA cc wcel vk
        cv cn0 wcel cA vk cv cexp co cc wcel cA ef01tllem1.4 recni cA vk cv
        expcl mpan vk cv cn0 wcel vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne
        vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc wcel vk cv faccl
        vk cv cfa cfv nncn syl vk cv facne0 jca sylanc syl 3eqtrd vk cv cM cuz
        cfv wcel vk cv cn0 wcel c1 cA cM cexp co cdiv co vk cv cF cfv cmul co
        cA vk cv cexp co vk cv cfa cfv cdiv co cA cM cexp co cdiv co wceq vk cv
        cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv
        wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz
        cfv wcel cM ef01tllem1.3 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn
        mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel c1 cA cM cexp co cdiv co vk
        cv cF cfv cmul co c1 cA cM cexp co cdiv co cA vk cv cexp co vk cv cfa
        cfv cdiv co cmul co cA vk cv cexp co vk cv cfa cfv cdiv co cA cM cexp
        co cdiv co vk cv cn0 wcel vk cv cF cfv cA vk cv cexp co vk cv cfa cfv
        cdiv co c1 cA cM cexp co cdiv co cmul vy cA vj cF vk cv ef1tllem.1
        eftval opreq2d cA vk cv cexp co vk cv cfa cfv cdiv co cc wcel cA cM
        cexp co cc wcel cA cM cexp co cc0 wne cA vk cv cexp co vk cv cfa cfv
        cdiv co cA cM cexp co cdiv co c1 cA cM cexp co cdiv co cA vk cv cexp co
        vk cv cfa cfv cdiv co cmul co wceq vk cv cn0 wcel cA vk cv cexp co vk
        cv cfa cfv cdiv co cA cM cexp co divrec2 cA vk cv cexp co cc wcel vk cv
        cfa cfv cc wcel vk cv cfa cfv cc0 wne cA vk cv cexp co vk cv cfa cfv
        cdiv co cc wcel vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv divcl cA
        cc wcel vk cv cn0 wcel cA vk cv cexp co cc wcel cA ef01tllem1.4 recni
        cA vk cv expcl mpan vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv
        cc wcel vk cv faccl vk cv cfa cfv nncn syl vk cv facne0 syl3anc cA cM
        cexp co cc wcel vk cv cn0 wcel cA cc wcel cM cn0 wcel cA cM cexp co cc
        wcel cA ef01tllem1.4 recni cM ef01tllem1.3 nnnn0i cA cM expcl mp2an a1i
        cA cM cexp co cc0 wne vk cv cn0 wcel cA cM cexp co cc0 wne cA cc0 wne
        ef01tllem1.5 cA cc wcel cM cn wcel cA cM cexp co cc0 wne cA cc0 wne wb
        cA ef01tllem1.4 recni ef01tllem1.3 cA cM expne0 mp2an mpbir a1i syl3anc
        eqtr4d syl eqtr4d jca rgen cM cuz cfv vk cv cF cfv vk csu c1 cA cM cexp
        co cdiv co vk cF cG cM cM cuz cfv vk cv cF cfv vk sumex vj vy cn0 cA vj
        cv cexp co vj cv cfa cfv cdiv co cF nn0ex ef1tllem.1 fopabex2 vj vy cn0
        cA vj cv cM cmin co cexp co vj cv cfa cfv cdiv co cG nn0ex ef01tllem1.2
        fopabex2 iserzmulc1 mp3an ax-mp cM cuz cfv vk cv cF cfv vk csu cc wcel
        cA cM cexp co cc wcel cA cM cexp co cc0 wne cM cuz cfv vk cv cF cfv vk
        csu cA cM cexp co cdiv co c1 cA cM cexp co cdiv co cM cuz cfv vk cv cF
        cfv vk csu cmul co wceq cA cc wcel cM cn wcel cM cuz cfv vk cv cF cfv
        vk csu cc wcel cA ef01tllem1.4 recni ef01tllem1.3 vy cA vj vk cF cM
        ef1tllem.1 eftlcl mp2an cA cc wcel cM cn0 wcel cA cM cexp co cc wcel cA
        ef01tllem1.4 recni cM ef01tllem1.3 nnnn0i cA cM expcl mp2an cA cM cexp
        co cc0 wne cA cc0 wne ef01tllem1.5 cA cc wcel cM cn wcel cA cM cexp co
        cc0 wne cA cc0 wne wb cA ef01tllem1.4 recni ef01tllem1.3 cA cM expne0
        mp2an mpbir cM cuz cfv vk cv cF cfv vk csu cA cM cexp co divrec2 mp3an
        breqtrri $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    ${
      $d A j k x y $.  $d F k x $.  $d G k $.  $d H k x $.  $d M j k x y $.
      ef01tllem2.2 $e |- G = { <. j , y >. | ( j e. NN0 /\
                               y = ( ( A ^ ( j - M ) ) / ( ! ` j ) ) ) } $.
      ef01tllem2.3 $e |- H = { <. j , y >. | ( j e. NN0 /\
                               y = ( ( 1 ^ j ) / ( ! ` j ) ) ) } $.
      ef01tllem2.4 $e |- M e. NN $.
      ef01tllem2.5 $e |- A e. ( 0 (,] 1 ) $.
      $( Lemma for ~ ef01tlubi . $)
      ef01tllem2 $p |- sum_ k e. ( ZZ>= ` M ) ( F ` k ) <_
                     ( ( A ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) $=
        cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co cM c1 caddc co cM
        cfa cfv cM cmul co cdiv co cle wbr cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr cM
        cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co cM cuz cfv vk cv cH
        cfv vk csu cle wbr cM cuz cfv vk cv cH cfv vk csu cM c1 caddc co cM cfa
        cfv cM cmul co cdiv co cle wbr cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cdiv co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cle wbr cM
        caddc cop cG cseqz co cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv
        co cli wbr cM caddc cop cH cseqz co cM cuz cfv vk cv cH cfv vk csu cli
        wbr wa cM cz wcel vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk cv cG
        cfv vk cv cH cfv cle wbr w3a vk cM cuz cfv wral wa cM cuz cfv vk cv cF
        cfv vk csu cA cM cexp co cdiv co cM cuz cfv vk cv cH cfv vk csu cle wbr
        cM caddc cop cG cseqz co cM cuz cfv vk cv cF cfv vk csu cA cM cexp co
        cdiv co cli wbr cM caddc cop cH cseqz co cM cuz cfv vk cv cH cfv vk csu
        cli wbr vy cA vj vk cF cG cM ef1tllem.1 ef01tllem2.2 ef01tllem2.4 cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
        cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re
        cc0 c1 cA elioc2 mp2an mpbi 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1
        cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
        mpbi 3simp1i cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
        wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr
        wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
        cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp2i gt0ne0ii
        ef01tllem1 cM cz wcel cM caddc cop cH cseqz co vx cv cli wbr vx wex cM
        caddc cop cH cseqz co cM cuz cfv vk cv cH cfv vk csu cli wbr cM cn wcel
        cM cz wcel ef01tllem2.4 cM nnz ax-mp c1 cc wcel cM cn wcel cM caddc cop
        cH cseqz co vx cv cli wbr vx wex ax1cn ef01tllem2.4 vx vy c1 vj cH cM
        ef01tllem2.3 eftlex mp2an vx vk cH cM vj vy cn0 c1 vj cv cexp co vj cv
        cfa cfv cdiv co cH nn0ex ef01tllem2.3 fopabex2 isumclim2 mp2an pm3.2i
        cM cz wcel vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk cv cG cfv vk cv
        cH cfv cle wbr w3a vk cM cuz cfv wral cM cn wcel cM cz wcel
        ef01tllem2.4 cM nnz ax-mp vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk
        cv cG cfv vk cv cH cfv cle wbr w3a vk cM cuz cfv vk cv cM cuz cfv wcel
        vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk cv cG cfv vk cv cH cfv cle
        wbr vk cv cM cuz cfv wcel vk cv cG cfv cA vk cv cM cmin co cexp co vk
        cv cfa cfv cdiv co cr vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cG cfv
        cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co wceq vk cv cM cuz cfv
        wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0
        cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr vj vy vk cv cA vj cv cM cmin co cexp co vj cv cfa cfv
        cdiv co cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co cn0 cG vj cv
        vk cv wceq cA vj cv cM cmin co cexp co cA vk cv cM cmin co cexp co vj
        cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv wceq vj cv cM cmin co vk cv
        cM cmin co cA cexp vj cv vk cv cM cmin opreq1 opreq2d vj cv vk cv cfa
        fveq2 opreq12d ef01tllem2.2 cA vk cv cM cmin co cexp co vk cv cfa cfv
        cdiv oprex fvopab4 syl cA vk cv cM cmin co cexp co cr wcel vk cv cfa
        cfv cr wcel vk cv cfa cfv cc0 wne cA vk cv cM cmin co cexp co vk cv cfa
        cfv cdiv co cr wcel vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp co
        vk cv cfa cfv redivcl cA cr wcel vk cv cM cmin co cn0 wcel cA vk cv cM
        cmin co cexp co cr wcel vk cv cM cuz cfv wcel cA vk cv cM cmin co
        reexpcl cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel
        cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1
        cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp1i vk cv cn0 wcel cM vk
        cv cle wbr vk cv cM cmin co cn0 wcel vk cv cM cuz cfv wcel cM cn0 wcel
        vk cv cn0 wcel cM vk cv cle wbr vk cv cM cmin co cn0 wcel cM
        ef01tllem2.4 nnnn0i cM vk cv nn0sub2 mp3an1 vk cv cM cuz cfv wcel vk cv
        cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv
        wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr cM vk cv eluzle sylanc sylancr vk cv cM cuz cfv wcel vk
        cv cn0 wcel vk cv cfa cfv cr wcel vk cv cM cuz cfv wcel vk cv cc0 cuz
        cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv
        cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i
        cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0
        wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa
        cfv nnre syl syl vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cfa cfv cc0
        wne vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv
        cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel
        cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0
        uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cfa cfv cn wcel
        vk cv cfa cfv cc0 wne vk cv faccl vk cv cfa cfv nnne0 syl syl syl3anc
        eqeltrd vk cv cM cuz cfv wcel vk cv cH cfv c1 vk cv cfa cfv cdiv co cr
        vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cH cfv c1 vk cv cfa cfv cdiv
        co wceq vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk
        cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0
        wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk
        cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cH cfv c1
        vk cv cexp co vk cv cfa cfv cdiv co c1 vk cv cfa cfv cdiv co vy c1 vj
        cH vk cv ef01tllem2.3 eftval vk cv cn0 wcel c1 vk cv cexp co c1 vk cv
        cfa cfv cdiv vk cv 1exp opreq1d eqtrd syl vk cv cfa cfv cr wcel vk cv
        cfa cfv cc0 wne c1 vk cv cfa cfv cdiv co cr wcel vk cv cM cuz cfv wcel
        vk cv cfa cfv rereccl vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cfa
        cfv cr wcel vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel
        vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0
        wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk
        cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cfa cfv cn
        wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl syl vk cv
        cM cuz cfv wcel vk cv cn0 wcel vk cv cfa cfv cc0 wne vk cv cM cuz cfv
        wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0
        cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc0
        wne vk cv faccl vk cv cfa cfv nnne0 syl syl sylanc eqeltrd vk cv cM cuz
        cfv wcel cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co c1 vk cv cfa
        cfv cdiv co vk cv cG cfv vk cv cH cfv cle vk cv cM cuz cfv wcel cA vk
        cv cM cmin co cexp co c1 cle wbr cA vk cv cM cmin co cexp co vk cv cfa
        cfv cdiv co c1 vk cv cfa cfv cdiv co cle wbr cA cr wcel cc0 cA cle wbr
        cA c1 cle wbr w3a vk cv cM cmin co cn0 wcel cA vk cv cM cmin co cexp co
        c1 cle wbr vk cv cM cuz cfv wcel cA vk cv cM cmin co exple1 cA cr wcel
        cc0 cA cle wbr cA c1 cle wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
        cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i cc0 cA 0re cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
        cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5
        cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
        cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp1i cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
        cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re
        cc0 c1 cA elioc2 mp2an mpbi 3simp2i ltleii cA cr wcel cc0 cA clt wbr cA
        c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
        wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA
        cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2
        mp2an mpbi 3simp3i 3pm3.2i vk cv cn0 wcel cM vk cv cle wbr vk cv cM
        cmin co cn0 wcel vk cv cM cuz cfv wcel cM cn0 wcel vk cv cn0 wcel cM vk
        cv cle wbr vk cv cM cmin co cn0 wcel cM ef01tllem2.4 nnnn0i cM vk cv
        nn0sub2 mp3an1 vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0
        wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel
        cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi
        cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr cM vk cv eluzle sylanc
        sylancr cA vk cv cM cmin co cexp co cr wcel c1 cr wcel vk cv cfa cfv cr
        wcel w3a cc0 vk cv cfa cfv clt wbr cA vk cv cM cmin co cexp co c1 cle
        wbr cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co c1 vk cv cfa cfv
        cdiv co cle wbr wb vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp co c1
        vk cv cfa cfv lediv1OLD vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp
        co cr wcel c1 cr wcel vk cv cfa cfv cr wcel cA cr wcel vk cv cM cmin co
        cn0 wcel cA vk cv cM cmin co cexp co cr wcel vk cv cM cuz cfv wcel cA
        vk cv cM cmin co reexpcl cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i vk cv cn0 wcel cM vk cv cle wbr vk cv cM cmin co cn0 wcel vk cv
        cM cuz cfv wcel cM cn0 wcel vk cv cn0 wcel cM vk cv cle wbr vk cv cM
        cmin co cn0 wcel cM ef01tllem2.4 nnnn0i cM vk cv nn0sub2 mp3an1 vk cv
        cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv
        wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz
        cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn
        mpan2 vk cv elnn0uz sylibr cM vk cv eluzle sylanc sylancr c1 cr wcel vk
        cv cM cuz cfv wcel 1re a1i vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv
        cfa cfv cr wcel vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0
        wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel
        cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi
        cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cfa
        cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl
        syl 3jca vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cfa cfv cn wcel cc0
        vk cv cfa cfv clt wbr vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk
        cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv
        wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz
        mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv faccl vk cv
        cfa cfv nngt0 3syl sylanc mpbid vk cv cM cuz cfv wcel vk cv cn0 wcel vk
        cv cG cfv cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co wceq vk cv
        cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv
        wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz
        cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn
        mpan2 vk cv elnn0uz sylibr vj vy vk cv cA vj cv cM cmin co cexp co vj
        cv cfa cfv cdiv co cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co
        cn0 cG vj cv vk cv wceq cA vj cv cM cmin co cexp co cA vk cv cM cmin co
        cexp co vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv wceq vj cv cM cmin
        co vk cv cM cmin co cA cexp vj cv vk cv cM cmin opreq1 opreq2d vj cv vk
        cv cfa fveq2 opreq12d ef01tllem2.2 cA vk cv cM cmin co cexp co vk cv
        cfa cfv cdiv oprex fvopab4 syl vk cv cM cuz cfv wcel vk cv cn0 wcel vk
        cv cH cfv c1 vk cv cfa cfv cdiv co wceq vk cv cM cuz cfv wcel vk cv cc0
        cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel
        vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4
        nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk
        cv cn0 wcel vk cv cH cfv c1 vk cv cexp co vk cv cfa cfv cdiv co c1 vk
        cv cfa cfv cdiv co vy c1 vj cH vk cv ef01tllem2.3 eftval vk cv cn0 wcel
        c1 vk cv cexp co c1 vk cv cfa cfv cdiv vk cv 1exp opreq1d eqtrd syl
        3brtr4d 3jca rgen pm3.2i cM cuz cfv vk cv cF cfv vk csu cA cM cexp co
        cdiv co cM cuz cfv vk cv cH cfv vk csu vk cG cH cM cM cuz cfv vk cv cF
        cfv vk csu cA cM cexp co cdiv oprex cM cuz cfv vk cv cH cfv vk sumex vj
        vy cn0 cA vj cv cM cmin co cexp co vj cv cfa cfv cdiv co cG nn0ex
        ef01tllem2.2 fopabex2 vj vy cn0 c1 vj cv cexp co vj cv cfa cfv cdiv co
        cH nn0ex ef01tllem2.3 fopabex2 iserzcmp mp2an cM cn wcel c1 c1 wceq cM
        cuz cfv vk cv cH cfv vk csu cM c1 caddc co cM cfa cfv cM cmul co cdiv
        co cle wbr ef01tllem2.4 c1 eqid vy c1 vj vk cH cM ef01tllem2.3 ef1tlubi
        mp2an cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co cM cuz cfv
        vk cv cH cfv vk csu cM c1 caddc co cM cfa cfv cM cmul co cdiv co cM cuz
        cfv vk cv cF cfv vk csu cA cM cexp co cA cr wcel cM cn wcel cM cuz cfv
        vk cv cF cfv vk csu cr wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
        cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i ef01tllem2.4 vy cA vj vk cF cM ef1tllem.1 reeftlcl mp2an cA cr
        wcel cM cn0 wcel cA cM cexp co cr wcel cA cr wcel cc0 cA clt wbr cA c1
        cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
        mpbi 3simp1i cM ef01tllem2.4 nnnn0i cA cM reexpcl mp2an cA cM cexp co
        cc0 wne cA cc0 wne cA cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
        cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5
        cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
        cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp1i cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
        cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re
        cc0 c1 cA elioc2 mp2an mpbi 3simp2i gt0ne0ii cA cc wcel cM cn wcel cA
        cM cexp co cc0 wne cA cc0 wne wb cA cA cr wcel cc0 cA clt wbr cA c1 cle
        wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i recni ef01tllem2.4 cA cM expne0 mp2an mpbir redivcli c1 cr wcel
        cM cn wcel cM cuz cfv vk cv cH cfv vk csu cr wcel 1re ef01tllem2.4 vy
        c1 vj vk cH cM ef01tllem2.3 reeftlcl mp2an cM cn wcel cM c1 caddc co cM
        cfa cfv cM cmul co cdiv co cr wcel ef01tllem2.4 cM eftlubcl ax-mp letri
        mp2an cM cuz cfv vk cv cF cfv vk csu cr wcel cA cM cexp co cr wcel cM
        c1 caddc co cM cfa cfv cM cmul co cdiv co cr wcel cM cuz cfv vk cv cF
        cfv vk csu cA cM cexp co cdiv co cM c1 caddc co cM cfa cfv cM cmul co
        cdiv co cle wbr cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cM c1
        caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr wb cA cr wcel cM
        cn wcel cM cuz cfv vk cv cF cfv vk csu cr wcel cA cr wcel cc0 cA clt
        wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
        c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
        wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
        elioc2 mp2an mpbi 3simp1i ef01tllem2.4 vy cA vj vk cF cM ef1tllem.1
        reeftlcl mp2an cA cr wcel cM cn0 wcel cA cM cexp co cr wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
        clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1
        cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
        c1 cA elioc2 mp2an mpbi 3simp1i cM ef01tllem2.4 nnnn0i cA cM reexpcl
        mp2an cM cn wcel cM c1 caddc co cM cfa cfv cM cmul co cdiv co cr wcel
        ef01tllem2.4 cM eftlubcl ax-mp cM cuz cfv vk cv cF cfv vk csu cr wcel
        cA cM cexp co cr wcel cM c1 caddc co cM cfa cfv cM cmul co cdiv co cr
        wcel w3a cc0 cA cM cexp co clt wbr cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cdiv co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cle wbr cM
        cuz cfv vk cv cF cfv vk csu cA cM cexp co cM c1 caddc co cM cfa cfv cM
        cmul co cdiv co cmul co cle wbr wb cA cr wcel cM cn0 wcel cc0 cA clt
        wbr cc0 cA cM cexp co clt wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i cM ef01tllem2.4 nnnn0i cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp2i cA cM expgt0 mp3an cM cuz cfv vk cv cF cfv vk csu cA cM cexp co
        cM c1 caddc co cM cfa cfv cM cmul co cdiv co ledivmulOLD mpan2 mp3an
        mpbi $.
        $( [10-Aug-2008] $) $( [19-Jan-2008] $)

      $( MAY BE REVISED - why is compressed proof shorter than new version? $)
      $( Lemma for ~ ef01tlubi . $)
      ef01tllem2OLD $p |- sum_ k e. ( ZZ>= ` M ) ( F ` k ) <_
                     ( ( A ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) $=
        cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co cM c1 caddc co cM
        cfa cfv cM cmul co cdiv co cle wbr cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr cM
        cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co cM cuz cfv vk cv cH
        cfv vk csu cle wbr cM cuz cfv vk cv cH cfv vk csu cM c1 caddc co cM cfa
        cfv cM cmul co cdiv co cle wbr cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cdiv co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cle wbr cM
        caddc cop cG cseqz co cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv
        co cli wbr cM caddc cop cH cseqz co cM cuz cfv vk cv cH cfv vk csu cli
        wbr wa cM cz wcel vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk cv cG
        cfv vk cv cH cfv cle wbr w3a vk cM cuz cfv wral wa cM cuz cfv vk cv cF
        cfv vk csu cA cM cexp co cdiv co cM cuz cfv vk cv cH cfv vk csu cle wbr
        cM caddc cop cG cseqz co cM cuz cfv vk cv cF cfv vk csu cA cM cexp co
        cdiv co cli wbr cM caddc cop cH cseqz co cM cuz cfv vk cv cH cfv vk csu
        cli wbr vy cA vj vk cF cG cM ef1tllem.1 ef01tllem2.2 ef01tllem2.4 cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
        cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re
        cc0 c1 cA elioc2 mp2an mpbi 3simp1i cA cA cr wcel cc0 cA clt wbr cA c1
        cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
        mpbi 3simp1i cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
        wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr
        wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
        cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp2i gt0ne0ii
        ef01tllem1 cM cz wcel cM caddc cop cH cseqz co vx cv cli wbr vx wex cM
        caddc cop cH cseqz co cM cuz cfv vk cv cH cfv vk csu cli wbr cM cn wcel
        cM cz wcel ef01tllem2.4 cM nnz ax-mp c1 cc wcel cM cn wcel cM caddc cop
        cH cseqz co vx cv cli wbr vx wex ax1cn ef01tllem2.4 vx vy c1 vj cH cM
        ef01tllem2.3 eftlex mp2an vx vk cH cM vj vy cn0 c1 vj cv cexp co vj cv
        cfa cfv cdiv co cH nn0ex ef01tllem2.3 fopabex2 isumclim2 mp2an pm3.2i
        cM cz wcel vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk cv cG cfv vk cv
        cH cfv cle wbr w3a vk cM cuz cfv wral cM cn wcel cM cz wcel
        ef01tllem2.4 cM nnz ax-mp vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk
        cv cG cfv vk cv cH cfv cle wbr w3a vk cM cuz cfv vk cv cM cuz cfv wcel
        vk cv cG cfv cr wcel vk cv cH cfv cr wcel vk cv cG cfv vk cv cH cfv cle
        wbr vk cv cM cuz cfv wcel vk cv cG cfv cA vk cv cM cmin co cexp co vk
        cv cfa cfv cdiv co cr vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cG cfv
        cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co wceq vk cv cM cuz cfv
        wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0
        cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr vj vy vk cv cA vj cv cM cmin co cexp co vj cv cfa cfv
        cdiv co cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co cn0 cG vj cv
        vk cv wceq cA vj cv cM cmin co cexp co cA vk cv cM cmin co cexp co vj
        cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv wceq vj cv cM cmin co vk cv
        cM cmin co cA cexp vj cv vk cv cM cmin opreq1 opreq2d vj cv vk cv cfa
        fveq2 opreq12d ef01tllem2.2 cA vk cv cM cmin co cexp co vk cv cfa cfv
        cdiv oprex fvopab4 syl cA vk cv cM cmin co cexp co cr wcel vk cv cfa
        cfv cr wcel vk cv cfa cfv cc0 wne cA vk cv cM cmin co cexp co vk cv cfa
        cfv cdiv co cr wcel vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp co
        vk cv cfa cfv redivcl cA cr wcel vk cv cM cmin co cn0 wcel cA vk cv cM
        cmin co cexp co cr wcel vk cv cM cuz cfv wcel cA vk cv cM cmin co
        reexpcl cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel
        cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1
        cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp1i vk cv cn0 wcel cM vk
        cv cle wbr vk cv cM cmin co cn0 wcel vk cv cM cuz cfv wcel cM cn0 wcel
        vk cv cn0 wcel cM vk cv cle wbr vk cv cM cmin co cn0 wcel cM
        ef01tllem2.4 nnnn0i cM vk cv nn0sub2 mp3an1 vk cv cM cuz cfv wcel vk cv
        cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv
        wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr cM vk cv eluzle sylanc sylancr vk cv cM cuz cfv wcel vk
        cv cn0 wcel vk cv cfa cfv cr wcel vk cv cM cuz cfv wcel vk cv cc0 cuz
        cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv
        cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i
        cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0
        wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa
        cfv nnre syl syl vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cfa cfv cc0
        wne vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv
        cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel
        cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0
        uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cfa cfv cn wcel
        vk cv cfa cfv cc0 wne vk cv faccl vk cv cfa cfv nnne0 syl syl syl3anc
        eqeltrd vk cv cM cuz cfv wcel vk cv cH cfv c1 vk cv cfa cfv cdiv co cr
        vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cH cfv c1 vk cv cfa cfv cdiv
        co wceq vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk
        cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0
        wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk
        cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cH cfv c1
        vk cv cexp co vk cv cfa cfv cdiv co c1 vk cv cfa cfv cdiv co vy c1 vj
        cH vk cv ef01tllem2.3 eftval vk cv cn0 wcel c1 vk cv cexp co c1 vk cv
        cfa cfv cdiv vk cv 1exp opreq1d eqtrd syl vk cv cfa cfv cr wcel vk cv
        cfa cfv cc0 wne c1 vk cv cfa cfv cdiv co cr wcel vk cv cM cuz cfv wcel
        vk cv cfa cfv rereccl vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cfa
        cfv cr wcel vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel
        vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0
        wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk
        cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cfa cfv cn
        wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl syl vk cv
        cM cuz cfv wcel vk cv cn0 wcel vk cv cfa cfv cc0 wne vk cv cM cuz cfv
        wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0
        cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM
        ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv
        elnn0uz sylibr vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cc0
        wne vk cv faccl vk cv cfa cfv nnne0 syl syl sylanc eqeltrd vk cv cM cuz
        cfv wcel cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co c1 vk cv cfa
        cfv cdiv co vk cv cG cfv vk cv cH cfv cle vk cv cM cuz cfv wcel cA vk
        cv cM cmin co cexp co c1 cle wbr cA vk cv cM cmin co cexp co vk cv cfa
        cfv cdiv co c1 vk cv cfa cfv cdiv co cle wbr cA cr wcel cc0 cA cle wbr
        cA c1 cle wbr w3a vk cv cM cmin co cn0 wcel cA vk cv cM cmin co cexp co
        c1 cle wbr vk cv cM cuz cfv wcel cA vk cv cM cmin co exple1 cA cr wcel
        cc0 cA cle wbr cA c1 cle wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
        cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i cc0 cA 0re cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
        cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5
        cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
        cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp1i cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
        cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re
        cc0 c1 cA elioc2 mp2an mpbi 3simp2i ltleii cA cr wcel cc0 cA clt wbr cA
        c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
        wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA
        cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2
        mp2an mpbi 3simp3i 3pm3.2i vk cv cn0 wcel cM vk cv cle wbr vk cv cM
        cmin co cn0 wcel vk cv cM cuz cfv wcel cM cn0 wcel vk cv cn0 wcel cM vk
        cv cle wbr vk cv cM cmin co cn0 wcel cM ef01tllem2.4 nnnn0i cM vk cv
        nn0sub2 mp3an1 vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0
        wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel
        cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi
        cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr cM vk cv eluzle sylanc
        sylancr cA vk cv cM cmin co cexp co cr wcel c1 cr wcel vk cv cfa cfv cr
        wcel w3a cc0 vk cv cfa cfv clt wbr cA vk cv cM cmin co cexp co c1 cle
        wbr cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co c1 vk cv cfa cfv
        cdiv co cle wbr wb vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp co c1
        vk cv cfa cfv lediv1OLD vk cv cM cuz cfv wcel cA vk cv cM cmin co cexp
        co cr wcel c1 cr wcel vk cv cfa cfv cr wcel cA cr wcel vk cv cM cmin co
        cn0 wcel cA vk cv cM cmin co cexp co cr wcel vk cv cM cuz cfv wcel cA
        vk cv cM cmin co reexpcl cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i vk cv cn0 wcel cM vk cv cle wbr vk cv cM cmin co cn0 wcel vk cv
        cM cuz cfv wcel cM cn0 wcel vk cv cn0 wcel cM vk cv cle wbr vk cv cM
        cmin co cn0 wcel cM ef01tllem2.4 nnnn0i cM vk cv nn0sub2 mp3an1 vk cv
        cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv
        wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz
        cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn
        mpan2 vk cv elnn0uz sylibr cM vk cv eluzle sylanc sylancr c1 cr wcel vk
        cv cM cuz cfv wcel 1re a1i vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv
        cfa cfv cr wcel vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0
        wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel
        cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi
        cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cfa
        cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl
        syl 3jca vk cv cM cuz cfv wcel vk cv cn0 wcel vk cv cfa cfv cn wcel cc0
        vk cv cfa cfv clt wbr vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk
        cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv
        wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz
        mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk cv faccl vk cv
        cfa cfv nngt0 3syl sylanc mpbid vk cv cM cuz cfv wcel vk cv cn0 wcel vk
        cv cG cfv cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co wceq vk cv
        cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv
        wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz
        cfv wcel cM ef01tllem2.4 nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn
        mpan2 vk cv elnn0uz sylibr vj vy vk cv cA vj cv cM cmin co cexp co vj
        cv cfa cfv cdiv co cA vk cv cM cmin co cexp co vk cv cfa cfv cdiv co
        cn0 cG vj cv vk cv wceq cA vj cv cM cmin co cexp co cA vk cv cM cmin co
        cexp co vj cv cfa cfv vk cv cfa cfv cdiv vj cv vk cv wceq vj cv cM cmin
        co vk cv cM cmin co cA cexp vj cv vk cv cM cmin opreq1 opreq2d vj cv vk
        cv cfa fveq2 opreq12d ef01tllem2.2 cA vk cv cM cmin co cexp co vk cv
        cfa cfv cdiv oprex fvopab4 syl vk cv cM cuz cfv wcel vk cv cn0 wcel vk
        cv cH cfv c1 vk cv cfa cfv cdiv co wceq vk cv cM cuz cfv wcel vk cv cc0
        cuz cfv wcel vk cv cn0 wcel vk cv cM cuz cfv wcel cM cc0 cuz cfv wcel
        vk cv cc0 cuz cfv wcel cM cn0 wcel cM cc0 cuz cfv wcel cM ef01tllem2.4
        nnnn0i cM elnn0uz mpbi cM vk cv cc0 uztrn mpan2 vk cv elnn0uz sylibr vk
        cv cn0 wcel vk cv cH cfv c1 vk cv cexp co vk cv cfa cfv cdiv co c1 vk
        cv cfa cfv cdiv co vy c1 vj cH vk cv ef01tllem2.3 eftval vk cv cn0 wcel
        c1 vk cv cexp co c1 vk cv cfa cfv cdiv vk cv 1exp opreq1d eqtrd syl
        3brtr4d 3jca rgen pm3.2i cM cuz cfv vk cv cF cfv vk csu cA cM cexp co
        cdiv co cM cuz cfv vk cv cH cfv vk csu vk cG cH cM cM cuz cfv vk cv cF
        cfv vk csu cA cM cexp co cdiv oprex cM cuz cfv vk cv cH cfv vk sumex vj
        vy cn0 cA vj cv cM cmin co cexp co vj cv cfa cfv cdiv co cG nn0ex
        ef01tllem2.2 fopabex2 vj vy cn0 c1 vj cv cexp co vj cv cfa cfv cdiv co
        cH nn0ex ef01tllem2.3 fopabex2 iserzcmp mp2an cM cn wcel c1 c1 wceq cM
        cuz cfv vk cv cH cfv vk csu cM c1 caddc co cM cfa cfv cM cmul co cdiv
        co cle wbr ef01tllem2.4 c1 eqid vy c1 vj vk cH cM ef01tllem2.3 ef1tlubi
        mp2an cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cdiv co cM cuz cfv
        vk cv cH cfv vk csu cM c1 caddc co cM cfa cfv cM cmul co cdiv co cM cuz
        cfv vk cv cF cfv vk csu cA cM cexp co cA cr wcel cM cn wcel cM cuz cfv
        vk cv cF cfv vk csu cr wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
        cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i ef01tllem2.4 vy cA vj vk cF cM ef1tllem.1 reeftlcl mp2an cA cr
        wcel cM cn0 wcel cA cM cexp co cr wcel cA cr wcel cc0 cA clt wbr cA c1
        cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
        mpbi 3simp1i cM ef01tllem2.4 nnnn0i cA cM reexpcl mp2an cA cc0 wne cA
        cM cexp co cc0 wne cA cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
        cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a ef01tllem2.5
        cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
        cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi 3simp1i cA cr
        wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
        cA clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0
        c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re
        cc0 c1 cA elioc2 mp2an mpbi 3simp2i gt0ne0ii cA cc wcel cM cn wcel cA
        cc0 wne cA cM cexp co cc0 wne wb cA cA cr wcel cc0 cA clt wbr cA c1 cle
        wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i recni ef01tllem2.4 cA cc wcel cM cn wcel wa cA cM cexp co cc0
        wne cA cc0 wne cA cM expne0 bicomd mp2an mpbi redivcli c1 cr wcel cM cn
        wcel cM cuz cfv vk cv cH cfv vk csu cr wcel 1re ef01tllem2.4 vy c1 vj
        vk cH cM ef01tllem2.3 reeftlcl mp2an cM cn wcel cM c1 caddc co cM cfa
        cfv cM cmul co cdiv co cr wcel ef01tllem2.4 cM eftlubcl ax-mp letri
        mp2an cM cuz cfv vk cv cF cfv vk csu cr wcel cA cM cexp co cr wcel cM
        c1 caddc co cM cfa cfv cM cmul co cdiv co cr wcel cM cuz cfv vk cv cF
        cfv vk csu cA cM cexp co cdiv co cM c1 caddc co cM cfa cfv cM cmul co
        cdiv co cle wbr cM cuz cfv vk cv cF cfv vk csu cA cM cexp co cM c1
        caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr wb cA cr wcel cM
        cn wcel cM cuz cfv vk cv cF cfv vk csu cr wcel cA cr wcel cc0 cA clt
        wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
        c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
        wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
        elioc2 mp2an mpbi 3simp1i ef01tllem2.4 vy cA vj vk cF cM ef1tllem.1
        reeftlcl mp2an cA cr wcel cM cn0 wcel cA cM cexp co cr wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
        clt wbr cA c1 cle wbr w3a ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1
        cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
        c1 cA elioc2 mp2an mpbi 3simp1i cM ef01tllem2.4 nnnn0i cA cM reexpcl
        mp2an cM cn wcel cM c1 caddc co cM cfa cfv cM cmul co cdiv co cr wcel
        ef01tllem2.4 cM eftlubcl ax-mp cM cuz cfv vk cv cF cfv vk csu cr wcel
        cA cM cexp co cr wcel cM c1 caddc co cM cfa cfv cM cmul co cdiv co cr
        wcel w3a cc0 cA cM cexp co clt wbr cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cdiv co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cle wbr cM
        cuz cfv vk cv cF cfv vk csu cA cM cexp co cM c1 caddc co cM cfa cfv cM
        cmul co cdiv co cmul co cle wbr wb cA cr wcel cM cn0 wcel cc0 cA clt
        wbr cc0 cA cM cexp co clt wbr cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp1i cM ef01tllem2.4 nnnn0i cA cr wcel cc0 cA clt wbr cA c1 cle wbr
        cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
        ef01tllem2.5 cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
        cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an mpbi
        3simp2i cA cM expgt0 mp3an cM cuz cfv vk cv cF cfv vk csu cA cM cexp co
        cM c1 caddc co cM cfa cfv cM cmul co cdiv co ledivmulOLD mpan2 mp3an
        mpbi $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    ${
      $d A j k y $.  $d M j k y $.
      $( An upper bound on the infinite tail of the series expansion of the
         exponential function on the positive reals less than or equal to 1.
         (Contributed by Paul Chapman, 19-Jan-2008.) $)
      ef01tlubi $p |- ( ( A e. ( 0 (,] 1 ) /\ M e. NN ) ->
          sum_ k e. ( ZZ>= ` M ) ( F ` k ) <_
          ( ( A ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) ) $=
        cA cc0 c1 cioc co wcel cM cn wcel cM cuz cfv vk cv cF cfv vk csu cA cM
        cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr cM
        cuz cfv vk cv vj cv cn0 wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj
        cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cA cc0
        c1 cioc co wcel cA c1 cif cM cexp co cM c1 caddc co cM cfa cfv cM cmul
        co cdiv co cmul co cle wbr cM cn wcel cM c1 cif cuz cfv vk cv vj cv cn0
        wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv cexp co vj cv cfa cfv
        cdiv co wceq wa vj vy copab cfv vk csu cA cc0 c1 cioc co wcel cA c1 cif
        cM cn wcel cM c1 cif cexp co cM cn wcel cM c1 cif c1 caddc co cM cn
        wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif cmul co cdiv co cmul co cle
        wbr cA cM c1 c1 cA cA cc0 c1 cioc co wcel cA c1 cif wceq cM cuz cfv vk
        cv cF cfv vk csu cM cuz cfv vk cv vj cv cn0 wcel vy cv cA cc0 c1 cioc
        co wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
        copab cfv vk csu cA cM cexp co cM c1 caddc co cM cfa cfv cM cmul co
        cdiv co cmul co cA cc0 c1 cioc co wcel cA c1 cif cM cexp co cM c1 caddc
        co cM cfa cfv cM cmul co cdiv co cmul co cle cA cA cc0 c1 cioc co wcel
        cA c1 cif wceq cM cuz cfv vk cv cF cfv vk cv vj cv cn0 wcel vy cv cA
        cc0 c1 cioc co wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq
        wa vj vy copab cfv vk cA cA cc0 c1 cioc co wcel cA c1 cif wceq vk cv cF
        vj cv cn0 wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv cexp co vj
        cv cfa cfv cdiv co wceq wa vj vy copab cA cA cc0 c1 cioc co wcel cA c1
        cif wceq vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
        wceq wa vj vy copab vj cv cn0 wcel vy cv cA cc0 c1 cioc co wcel cA c1
        cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cF cA cA
        cc0 c1 cioc co wcel cA c1 cif wceq vj cv cn0 wcel vy cv cA vj cv cexp
        co vj cv cfa cfv cdiv co wceq wa vj cv cn0 wcel vy cv cA cc0 c1 cioc co
        wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy cA cA
        cc0 c1 cioc co wcel cA c1 cif wceq vy cv cA vj cv cexp co vj cv cfa cfv
        cdiv co wceq vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv cexp co vj cv
        cfa cfv cdiv co wceq vj cv cn0 wcel cA cA cc0 c1 cioc co wcel cA c1 cif
        wceq cA vj cv cexp co vj cv cfa cfv cdiv co cA cc0 c1 cioc co wcel cA
        c1 cif vj cv cexp co vj cv cfa cfv cdiv co vy cv cA cA cc0 c1 cioc co
        wcel cA c1 cif wceq cA vj cv cexp co cA cc0 c1 cioc co wcel cA c1 cif
        vj cv cexp co vj cv cfa cfv cdiv cA cA cc0 c1 cioc co wcel cA c1 cif vj
        cv cexp opreq1 opreq1d eqeq2d anbi2d opabbidv ef1tllem.1 syl5eq fveq1d
        sumeq2sdv cA cA cc0 c1 cioc co wcel cA c1 cif wceq cA cM cexp co cA cc0
        c1 cioc co wcel cA c1 cif cM cexp co cM c1 caddc co cM cfa cfv cM cmul
        co cdiv co cmul cA cA cc0 c1 cioc co wcel cA c1 cif cM cexp opreq1
        opreq1d breq12d cM cM cn wcel cM c1 cif wceq cM cuz cfv vk cv vj cv cn0
        wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv cexp co vj cv cfa cfv
        cdiv co wceq wa vj vy copab cfv vk csu cM cn wcel cM c1 cif cuz cfv vk
        cv vj cv cn0 wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv cexp co
        vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cA cc0 c1 cioc co
        wcel cA c1 cif cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co
        cmul co cA cc0 c1 cioc co wcel cA c1 cif cM cn wcel cM c1 cif cexp co
        cM cn wcel cM c1 cif c1 caddc co cM cn wcel cM c1 cif cfa cfv cM cn
        wcel cM c1 cif cmul co cdiv co cmul co cle cM cM cn wcel cM c1 cif wceq
        cM cuz cfv cM cn wcel cM c1 cif cuz cfv vk cv vj cv cn0 wcel vy cv cA
        cc0 c1 cioc co wcel cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq
        wa vj vy copab cfv vk cM cM cn wcel cM c1 cif cuz fveq2 sumeq1d cM cM
        cn wcel cM c1 cif wceq cA cc0 c1 cioc co wcel cA c1 cif cM cexp co cA
        cc0 c1 cioc co wcel cA c1 cif cM cn wcel cM c1 cif cexp co cM c1 caddc
        co cM cfa cfv cM cmul co cdiv co cM cn wcel cM c1 cif c1 caddc co cM cn
        wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif cmul co cdiv co cmul cM cM
        cn wcel cM c1 cif cA cc0 c1 cioc co wcel cA c1 cif cexp opreq2 cM cM cn
        wcel cM c1 cif wceq cM c1 caddc co cM cn wcel cM c1 cif c1 caddc co cM
        cfa cfv cM cmul co cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif
        cmul co cdiv cM cM cn wcel cM c1 cif c1 caddc opreq1 cM cM cn wcel cM
        c1 cif wceq cM cfa cfv cM cn wcel cM c1 cif cfa cfv cM cM cn wcel cM c1
        cif cmul cM cM cn wcel cM c1 cif cfa fveq2 cM cM cn wcel cM c1 cif wceq
        id opreq12d opreq12d opreq12d breq12d vy cA cc0 c1 cioc co wcel cA c1
        cif vj vk vj cv cn0 wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv
        cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv
        cA cc0 c1 cioc co wcel cA c1 cif vj cv cM cn wcel cM c1 cif cmin co
        cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv
        c1 vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cM cn wcel
        cM c1 cif vj cv cn0 wcel vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv
        cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid vj cv cn0 wcel
        vy cv cA cc0 c1 cioc co wcel cA c1 cif vj cv cM cn wcel cM c1 cif cmin
        co cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid vj cv cn0
        wcel vy cv c1 vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
        eqid cM c1 cn 1nn elimel cA c1 cc0 c1 cioc co c1 cr wcel cc0 c1 clt wbr
        c1 c1 cle wbr c1 cc0 c1 cioc co wcel 1re lt01 c1 1re leidi c1 cc0 c1
        cioc co wcel c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr w3a cc0 cr wcel c1
        cr wcel c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr
        w3a wb 0re 1re cc0 c1 c1 elioc2 mp2an biimpri mp3an elimel ef01tllem2
        dedth2h $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    ${
      $d A j k x y $.  $d F k x $.  $d G k x $.  $d M j k x y $.
      absef01tllem.2 $e |- G = { <. j , y >. | ( j e. NN0 /\
                                 y = ( ( ( abs ` A ) ^ j ) / ( ! ` j ) ) ) } $.
      absef01tllem.3 $e |- A e. CC $.
      absef01tllem.4 $e |- ( abs ` A ) e. ( 0 (,] 1 ) $.
      absef01tllem.5 $e |- M e. NN $.
      $( Lemma for ~ absef01tlubi . $)
      absef01tllem $p |- ( abs ` sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) <_
              ( ( ( abs ` A ) ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) $=
        cM cuz cfv vk cv cF cfv vk csu cabs cfv cM cuz cfv vk cv cG cfv vk csu
        cle wbr cM cuz cfv vk cv cG cfv vk csu cA cabs cfv cM cexp co cM c1
        caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr cM cuz cfv vk cv
        cF cfv vk csu cabs cfv cA cabs cfv cM cexp co cM c1 caddc co cM cfa cfv
        cM cmul co cdiv co cmul co cle wbr cM cuz cfv vk cv cF cfv vk csu cM
        cuz cfv vk cv cG cfv vk csu vk cF cG cM cM cuz cfv vk cv cF cfv vk
        sumex cM cuz cfv vk cv cG cfv vk sumex vj vy cn0 cA vj cv cexp co vj cv
        cfa cfv cdiv co cF nn0ex ef1tllem.1 fopabex2 vj vy cn0 cA cabs cfv vj
        cv cexp co vj cv cfa cfv cdiv co cG nn0ex absef01tllem.2 fopabex2 cM cn
        wcel cM cz wcel absef01tllem.5 cM nnz ax-mp vk cv cM cuz cfv wcel vk cv
        cn0 wcel vk cv cF cfv cc wcel vk cv cG cfv vk cv cF cfv cabs cfv wceq
        wa vk cv cM cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cM
        cuz cfv wcel cM cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cM cn0 wcel cM
        cc0 cuz cfv wcel cM absef01tllem.5 nnnn0i cM elnn0uz mpbi cM vk cv cc0
        uztrn mpan2 vk cv elnn0uz sylibr vk cv cn0 wcel vk cv cF cfv cc wcel vk
        cv cG cfv vk cv cF cfv cabs cfv wceq vk cv cn0 wcel vk cv cF cfv cA vk
        cv cexp co vk cv cfa cfv cdiv co cc vy cA vj cF vk cv ef1tllem.1 eftval
        cA cc wcel vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv cdiv co cc
        wcel absef01tllem.3 cA vk cv eftcl mpan eqeltrd vk cv cn0 wcel cA vk cv
        cexp co vk cv cfa cfv cdiv co cabs cfv cA cabs cfv vk cv cexp co vk cv
        cfa cfv cdiv co vk cv cF cfv cabs cfv vk cv cG cfv cA vk cv
        absef01tllem.3 eftabsi vk cv cn0 wcel vk cv cF cfv cA vk cv cexp co vk
        cv cfa cfv cdiv co cabs vy cA vj cF vk cv ef1tllem.1 eftval fveq2d vy
        cA cabs cfv vj cG vk cv absef01tllem.2 eftval 3eqtr4rd jca syl cM cz
        wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cF
        cseqz co cM cuz cfv vk cv cF cfv vk csu cli wbr cM cn wcel cM cz wcel
        absef01tllem.5 cM nnz ax-mp cA cc wcel cM cn wcel cM caddc cop cF cseqz
        co vx cv cli wbr vx wex absef01tllem.3 absef01tllem.5 vx vy cA vj cF cM
        ef1tllem.1 eftlex mp2an vx vk cF cM vj vy cn0 cA vj cv cexp co vj cv
        cfa cfv cdiv co cF nn0ex ef1tllem.1 fopabex2 isumclim2 mp2an cM cz wcel
        cM caddc cop cG cseqz co vx cv cli wbr vx wex cM caddc cop cG cseqz co
        cM cuz cfv vk cv cG cfv vk csu cli wbr cM cn wcel cM cz wcel
        absef01tllem.5 cM nnz ax-mp cA cabs cfv cc wcel cM cn wcel cM caddc cop
        cG cseqz co vx cv cli wbr vx wex cA cabs cfv cA absef01tllem.3 abscli
        recni absef01tllem.5 vx vy cA cabs cfv vj cG cM absef01tllem.2 eftlex
        mp2an vx vk cG cM vj vy cn0 cA cabs cfv vj cv cexp co vj cv cfa cfv
        cdiv co cG nn0ex absef01tllem.2 fopabex2 isumclim2 mp2an iserzabsi cA
        cabs cfv cc0 c1 cioc co wcel cM cn wcel cM cuz cfv vk cv cG cfv vk csu
        cA cabs cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co
        cmul co cle wbr absef01tllem.4 absef01tllem.5 vy cA cabs cfv vj vk cG
        cM absef01tllem.2 ef01tlubi mp2an cM cuz cfv vk cv cF cfv vk csu cabs
        cfv cM cuz cfv vk cv cG cfv vk csu cA cabs cfv cM cexp co cM c1 caddc
        co cM cfa cfv cM cmul co cdiv co cmul co cM cuz cfv vk cv cF cfv vk csu
        cA cc wcel cM cn wcel cM cuz cfv vk cv cF cfv vk csu cc wcel
        absef01tllem.3 absef01tllem.5 vy cA vj vk cF cM ef1tllem.1 eftlcl mp2an
        abscli cA cabs cfv cr wcel cM cn wcel cM cuz cfv vk cv cG cfv vk csu cr
        wcel cA absef01tllem.3 abscli absef01tllem.5 vy cA cabs cfv vj vk cG cM
        absef01tllem.2 reeftlcl mp2an cA cabs cfv cM cexp co cM c1 caddc co cM
        cfa cfv cM cmul co cdiv co cA cabs cfv cr wcel cM cn0 wcel cA cabs cfv
        cM cexp co cr wcel cA absef01tllem.3 abscli cM absef01tllem.5 nnnn0i cA
        cabs cfv cM reexpcl mp2an cM cn wcel cM c1 caddc co cM cfa cfv cM cmul
        co cdiv co cr wcel absef01tllem.5 cM eftlubcl ax-mp remulcli letri
        mp2an $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    ${
      $d A j k y $.  $d M j k y $.
      $( An upper bound on the absolute value of the infinite tail of the
         series expansion of the exponential function on the punctured closed
         unit disk.  (Contributed by Paul Chapman, 19-Jan-2008.) $)
      absef01tlubi $p |- ( ( A e. CC /\ ( abs ` A ) e. ( 0 (,] 1 ) /\ M e. NN )
            -> ( abs ` sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) <_
            ( ( ( abs ` A ) ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) ) $=
        cA cc wcel cA cabs cfv cc0 c1 cioc co wcel cM cn wcel cM cuz cfv vk cv
        cF cfv vk csu cabs cfv cA cabs cfv cM cexp co cM c1 caddc co cM cfa cfv
        cM cmul co cdiv co cmul co cle wbr cA cc wcel cA cabs cfv cc0 c1 cioc
        co wcel wa cM cn wcel cM cuz cfv vk cv cF cfv vk csu cabs cfv cA cabs
        cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle
        wbr cM cuz cfv vk cv vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0 c1
        cioc co wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa
        vj vy copab cfv vk csu cabs cfv cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif cabs cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul
        co cdiv co cmul co cle wbr cM cn wcel cM c1 cif cuz cfv vk cv vj cv cn0
        wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj
        cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cabs
        cfv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cM
        cn wcel cM c1 cif cexp co cM cn wcel cM c1 cif c1 caddc co cM cn wcel
        cM c1 cif cfa cfv cM cn wcel cM c1 cif cmul co cdiv co cmul co cle wbr
        cA cM c1 c1 cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif
        wceq cM cuz cfv vk cv cF cfv vk csu cabs cfv cM cuz cfv vk cv vj cv cn0
        wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj
        cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cabs
        cfv cA cabs cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co
        cmul co cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs
        cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle
        cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq cM cuz
        cfv vk cv cF cfv vk csu cM cuz cfv vk cv vj cv cn0 wcel vy cv cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv cexp co vj cv
        cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cabs cA cA cc wcel cA
        cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq cM cuz cfv vk cv cF cfv
        vk cv vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel
        wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
        cfv vk cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq
        vk cv cF vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
        copab cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq
        vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj
        vy copab vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
        copab cF cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif
        wceq vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
        wa vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy cA cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq vy cv cA vj cv
        cexp co vj cv cfa cfv cdiv co wceq vy cv cA cc wcel cA cabs cfv cc0 c1
        cioc co wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq vj
        cv cn0 wcel cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif
        wceq cA vj cv cexp co vj cv cfa cfv cdiv co cA cc wcel cA cabs cfv cc0
        c1 cioc co wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co vy cv
        cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq cA vj
        cv cexp co cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj
        cv cexp co vj cv cfa cfv cdiv cA cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif vj cv cexp opreq1 opreq1d eqeq2d anbi2d opabbidv
        ef1tllem.1 syl5eq fveq1d sumeq2sdv fveq2d cA cA cc wcel cA cabs cfv cc0
        c1 cioc co wcel wa cA c1 cif wceq cA cabs cfv cM cexp co cA cc wcel cA
        cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cM cexp co cM c1
        caddc co cM cfa cfv cM cmul co cdiv co cmul cA cA cc wcel cA cabs cfv
        cc0 c1 cioc co wcel wa cA c1 cif wceq cA cabs cfv cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cM cexp cA cA cc wcel cA
        cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs fveq2 opreq1d opreq1d
        breq12d cM cM cn wcel cM c1 cif wceq cM cuz cfv vk cv vj cv cn0 wcel vy
        cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv cexp
        co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cabs cfv cM cn
        wcel cM c1 cif cuz cfv vk cv vj cv cn0 wcel vy cv cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv
        co wceq wa vj vy copab cfv vk csu cabs cfv cA cc wcel cA cabs cfv cc0
        c1 cioc co wcel wa cA c1 cif cabs cfv cM cexp co cM c1 caddc co cM cfa
        cfv cM cmul co cdiv co cmul co cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif cabs cfv cM cn wcel cM c1 cif cexp co cM cn wcel cM
        c1 cif c1 caddc co cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif
        cmul co cdiv co cmul co cle cM cM cn wcel cM c1 cif wceq cM cuz cfv vk
        cv vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv
        vk csu cM cn wcel cM c1 cif cuz cfv vk cv vj cv cn0 wcel vy cv cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv cexp co vj cv
        cfa cfv cdiv co wceq wa vj vy copab cfv vk csu cabs cM cM cn wcel cM c1
        cif wceq cM cuz cfv cM cn wcel cM c1 cif cuz cfv vk cv vj cv cn0 wcel
        vy cv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv
        cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk cM cM cn wcel
        cM c1 cif cuz fveq2 sumeq1d fveq2d cM cM cn wcel cM c1 cif wceq cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cM cexp co
        cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cM cn
        wcel cM c1 cif cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cM
        cn wcel cM c1 cif c1 caddc co cM cn wcel cM c1 cif cfa cfv cM cn wcel
        cM c1 cif cmul co cdiv co cmul cM cM cn wcel cM c1 cif cA cc wcel cA
        cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cexp opreq2 cM cM cn
        wcel cM c1 cif wceq cM c1 caddc co cM cn wcel cM c1 cif c1 caddc co cM
        cfa cfv cM cmul co cM cn wcel cM c1 cif cfa cfv cM cn wcel cM c1 cif
        cmul co cdiv cM cM cn wcel cM c1 cif c1 caddc opreq1 cM cM cn wcel cM
        c1 cif wceq cM cfa cfv cM cn wcel cM c1 cif cfa cfv cM cM cn wcel cM c1
        cif cmul cM cM cn wcel cM c1 cif cfa fveq2 cM cM cn wcel cM c1 cif wceq
        id opreq12d opreq12d opreq12d breq12d vy cA cc wcel cA cabs cfv cc0 c1
        cioc co wcel wa cA c1 cif vj vk vj cv cn0 wcel vy cv cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv cexp co vj cv cfa cfv cdiv
        co wceq wa vj vy copab vj cv cn0 wcel vy cv cA cc wcel cA cabs cfv cc0
        c1 cioc co wcel wa cA c1 cif cabs cfv vj cv cexp co vj cv cfa cfv cdiv
        co wceq wa vj vy copab cM cn wcel cM c1 cif vj cv cn0 wcel vy cv cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif vj cv cexp co vj cv
        cfa cfv cdiv co wceq wa vj vy copab eqid vj cv cn0 wcel vy cv cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv vj cv cexp
        co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif cc wcel cA cc wcel cA cabs cfv cc0
        c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1 cioc co wcel cA cc wcel cA
        cabs cfv cc0 c1 cioc co wcel wa cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif cc wcel cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif cabs cfv cc0 c1 cioc co wcel wa c1 cc wcel c1 cabs cfv cc0 c1
        cioc co wcel wa cA c1 cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif wceq cA cc wcel cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif cc wcel cA cabs cfv cc0 c1 cioc co wcel cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1 cioc co wcel cA cA
        cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cc eleq1 cA cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq cA cabs cfv cA
        cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1
        cioc co cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs
        fveq2 eleq1d anbi12d c1 cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif wceq c1 cc wcel cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa
        cA c1 cif cc wcel c1 cabs cfv cc0 c1 cioc co wcel cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1 cioc co wcel c1 cA
        cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cc eleq1 c1 cA cc
        wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif wceq c1 cabs cfv cA
        cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1
        cioc co c1 cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs
        fveq2 eleq1d anbi12d c1 cc wcel c1 cabs cfv cc0 c1 cioc co wcel ax1cn
        c1 cabs cfv c1 cc0 c1 cioc co cc0 c1 cle wbr c1 cabs cfv c1 wceq cc0 c1
        0re 1re lt01 ltleii c1 1re absidi ax-mp c1 cr wcel cc0 c1 clt wbr c1 c1
        cle wbr c1 cc0 c1 cioc co wcel 1re lt01 c1 1re leidi c1 cc0 c1 cioc co
        wcel c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr w3a cc0 cr wcel c1 cr wcel
        c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr w3a wb
        0re 1re cc0 c1 c1 elioc2 mp2an biimpri mp3an eqeltri pm3.2i elimhyp
        pm3.26i cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cc wcel
        cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1
        cioc co wcel cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA cc wcel
        cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cc wcel cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv cc0 c1 cioc co wcel wa c1
        cc wcel c1 cabs cfv cc0 c1 cioc co wcel wa cA c1 cA cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif wceq cA cc wcel cA cc wcel cA cabs
        cfv cc0 c1 cioc co wcel wa cA c1 cif cc wcel cA cabs cfv cc0 c1 cioc co
        wcel cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv
        cc0 c1 cioc co wcel cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA
        c1 cif cc eleq1 cA cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1
        cif wceq cA cabs cfv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA
        c1 cif cabs cfv cc0 c1 cioc co cA cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif cabs fveq2 eleq1d anbi12d c1 cA cc wcel cA cabs cfv
        cc0 c1 cioc co wcel wa cA c1 cif wceq c1 cc wcel cA cc wcel cA cabs cfv
        cc0 c1 cioc co wcel wa cA c1 cif cc wcel c1 cabs cfv cc0 c1 cioc co
        wcel cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1 cif cabs cfv
        cc0 c1 cioc co wcel c1 cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA
        c1 cif cc eleq1 c1 cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA c1
        cif wceq c1 cabs cfv cA cc wcel cA cabs cfv cc0 c1 cioc co wcel wa cA
        c1 cif cabs cfv cc0 c1 cioc co c1 cA cc wcel cA cabs cfv cc0 c1 cioc co
        wcel wa cA c1 cif cabs fveq2 eleq1d anbi12d c1 cc wcel c1 cabs cfv cc0
        c1 cioc co wcel ax1cn c1 cabs cfv c1 cc0 c1 cioc co cc0 c1 cle wbr c1
        cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp c1 cr
        wcel cc0 c1 clt wbr c1 c1 cle wbr c1 cc0 c1 cioc co wcel 1re lt01 c1
        1re leidi c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1 clt wbr c1 c1 cle
        wbr w3a cc0 cr wcel c1 cr wcel c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1
        clt wbr c1 c1 cle wbr w3a wb 0re 1re cc0 c1 c1 elioc2 mp2an biimpri
        mp3an eqeltri pm3.2i elimhyp pm3.27i cM c1 cn 1nn elimel absef01tllem
        dedth2h 3impa $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          _e is irrational
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    eirrlem1.1 $e |- N e. NN $.
    $( Lemma for ~ eirr . $)
    eirrlem1 $p |- ( ( N + 2 ) / ( ( N + 1 ) ^ 2 ) ) < 1 $=
      cN c2 caddc co cN c1 caddc co c2 cexp co cdiv co c1 clt wbr c1 cN cN c1
      caddc co cmul co clt wbr c1 cN cle wbr cN cN cN c1 caddc co cmul co clt
      wbr c1 cN cN c1 caddc co cmul co clt wbr cN cn wcel c1 cN cle wbr
      eirrlem1.1 cN nnge1 ax-mp c1 cN c1 caddc co clt wbr cN cN cN c1 caddc co
      cmul co clt wbr c1 cN cle wbr c1 cN c1 caddc co clt wbr cN cn wcel c1 cN
      cle wbr eirrlem1.1 cN nnge1 ax-mp c1 cn0 wcel cN cn0 wcel c1 cN cle wbr
      c1 cN c1 caddc co clt wbr wb 1nn0 cN eirrlem1.1 nnnn0i c1 cN nn0leltp1
      mp2an mpbi cN cr wcel cN c1 caddc co cr wcel cc0 cN clt wbr c1 cN c1
      caddc co clt wbr cN cN cN c1 caddc co cmul co clt wbr wb cN eirrlem1.1
      nnrei cN c1 caddc co cN cn wcel cN c1 caddc co cn wcel eirrlem1.1 cN
      peano2nn ax-mp nnrei cN eirrlem1.1 nngt0i cN cN c1 caddc co ltmulgt11
      mp3an mpbi c1 cN cN cN c1 caddc co cmul co 1re cN eirrlem1.1 nnrei cN cN
      c1 caddc co cN eirrlem1.1 nnrei cN c1 caddc co cN cn wcel cN c1 caddc co
      cn wcel eirrlem1.1 cN peano2nn ax-mp nnrei remulcli lelttri mp2an cN c2
      caddc co cN c1 caddc co c2 cexp co cdiv co c1 clt wbr cN c2 caddc co cN
      c1 caddc co c2 cexp co c1 cmul co clt wbr c1 cN cN c1 caddc co cmul co
      clt wbr cN c2 caddc co cr wcel cN c1 caddc co c2 cexp co cr wcel c1 cr
      wcel cN c2 caddc co cN c1 caddc co c2 cexp co cdiv co c1 clt wbr cN c2
      caddc co cN c1 caddc co c2 cexp co c1 cmul co clt wbr wb cN c2 cN
      eirrlem1.1 nnrei 2re readdcli cN c1 caddc co cN c1 caddc co cN cn wcel cN
      c1 caddc co cn wcel eirrlem1.1 cN peano2nn ax-mp nnrei resqcli 1re cN c2
      caddc co cr wcel cN c1 caddc co c2 cexp co cr wcel c1 cr wcel w3a cc0 cN
      c1 caddc co c2 cexp co clt wbr cN c2 caddc co cN c1 caddc co c2 cexp co
      cdiv co c1 clt wbr cN c2 caddc co cN c1 caddc co c2 cexp co c1 cmul co
      clt wbr wb cN c1 caddc co cc0 wne cc0 cN c1 caddc co c2 cexp co clt wbr
      cN c1 caddc co cN cn wcel cN c1 caddc co cn wcel eirrlem1.1 cN peano2nn
      ax-mp nnne0i cN c1 caddc co cN c1 caddc co cN cn wcel cN c1 caddc co cn
      wcel eirrlem1.1 cN peano2nn ax-mp nnrei sqgt0i ax-mp cN c2 caddc co cN c1
      caddc co c2 cexp co c1 ltdivmulOLD mpan2 mp3an cN c2 caddc co cN c1 caddc
      co c2 cexp co c1 cmul co clt wbr cN c2 caddc co cN cN c1 caddc co cmul co
      cN c1 caddc co caddc co clt wbr cN c2 caddc co cN c1 caddc co cmin co cN
      cN c1 caddc co cmul co clt wbr c1 cN cN c1 caddc co cmul co clt wbr cN c1
      caddc co c2 cexp co c1 cmul co cN cN c1 caddc co cmul co cN c1 caddc co
      caddc co cN c2 caddc co clt cN c1 caddc co c2 cexp co c1 cmul co cN c1
      caddc co c2 cexp co cN cN c1 caddc co cmul co cN c1 caddc co caddc co cN
      c1 caddc co c2 cexp co cN c1 caddc co c2 cexp co cN c1 caddc co cN c1
      caddc co cN cn wcel cN c1 caddc co cn wcel eirrlem1.1 cN peano2nn ax-mp
      nnrei resqcli recni mulid1i cN c1 caddc co c2 cexp co cN c1 caddc co cN
      c1 caddc co cmul co cN cN c1 caddc co cmul co c1 cN c1 caddc co cmul co
      caddc co cN cN c1 caddc co cmul co cN c1 caddc co caddc co cN c1 caddc co
      cN c1 caddc co cN cn wcel cN c1 caddc co cn wcel eirrlem1.1 cN peano2nn
      ax-mp nncni sqvali cN c1 cN c1 caddc co cN eirrlem1.1 nncni ax1cn cN c1
      caddc co cN cn wcel cN c1 caddc co cn wcel eirrlem1.1 cN peano2nn ax-mp
      nncni adddiri c1 cN c1 caddc co cmul co cN c1 caddc co cN cN c1 caddc co
      cmul co caddc cN c1 caddc co cN c1 caddc co cN cn wcel cN c1 caddc co cn
      wcel eirrlem1.1 cN peano2nn ax-mp nncni mulid2i opreq2i 3eqtri eqtri
      breq2i cN c2 caddc co cN c1 caddc co cN cN c1 caddc co cmul co cN c2 cN
      eirrlem1.1 nnrei 2re readdcli cN c1 caddc co cN cn wcel cN c1 caddc co cn
      wcel eirrlem1.1 cN peano2nn ax-mp nnrei cN cN c1 caddc co cN eirrlem1.1
      nnrei cN c1 caddc co cN cn wcel cN c1 caddc co cn wcel eirrlem1.1 cN
      peano2nn ax-mp nnrei remulcli ltsubaddi cN c2 caddc co cN c1 caddc co
      cmin co c1 cN cN c1 caddc co cmul co clt cN c2 caddc co cN c1 caddc co
      cmin co c2 c1 cmin co c1 cN cc wcel c2 cc wcel c1 cc wcel cN c2 caddc co
      cN c1 caddc co cmin co c2 c1 cmin co wceq cN eirrlem1.1 nncni 2cn ax1cn
      cN c2 c1 pnpcan mp3an c2 c1 c1 2cn ax1cn ax1cn c2 c1 c1 caddc co df-2
      eqcomi subaddrii eqtri breq1i 3bitr2i bitri mpbir $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d F k x z $.  $d Q j k x y z $.
    eirrlem2.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                           y = ( ( 1 ^ j ) / ( ! ` j ) ) ) } $.
    eirrlem2.2 $e |- P e. ZZ $.
    eirrlem2.3 $e |- Q e. NN $.

    $( Lemma for ~ eirr . $)
    eirrlem2 $p |- ( ( ! ` Q ) x.
                     ( ( P / Q ) - sum_ k e. ( 0 ... Q ) ( F ` k ) ) ) e. ZZ $=
      cQ cfa cfv cP cQ cdiv co cc0 cQ cfz co vk cv cF cfv vk csu cmin co cmul
      co cQ cfa cfv cP cQ cdiv co cmul co cQ cfa cfv cc0 cQ cfz co vk cv cF cfv
      vk csu cmul co cmin co cz cQ cfa cfv cP cQ cdiv co cc0 cQ cfz co vk cv cF
      cfv vk csu cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i
      cQ faccl ax-mp nncni cP cQ cP cz wcel cP cc wcel eirrlem2.2 cP zcn ax-mp
      cQ eirrlem2.3 nncni cQ eirrlem2.3 nnne0i divcli cQ cc0 cuz cfv wcel vk cv
      cF cfv cc wcel vk cc0 cQ cfz co wral cc0 cQ cfz co vk cv cF cfv vk csu cc
      wcel cQ cn0 cc0 cuz cfv cQ eirrlem2.3 nnnn0i nn0uz eleqtri cc0 cQ cfz co
      cc0 cuz cfv wss vk cv cF cfv cc wcel vk cc0 cuz cfv wral vk cv cF cfv cc
      wcel vk cc0 cQ cfz co wral cc0 cQ fzssuz vk cv cF cfv cc wcel vk cc0 cuz
      cfv vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cF cfv cc wcel vk cv
      elnn0uz vk cv cn0 wcel vk cv cF cfv c1 vk cv cexp co vk cv cfa cfv cdiv
      co cc vy c1 vj cF vk cv eirrlem2.1 eftval c1 cc wcel vk cv cn0 wcel c1 vk
      cv cexp co vk cv cfa cfv cdiv co cc wcel ax1cn c1 vk cv eftcl mpan
      eqeltrd sylbir rgen vk cv cF cfv cc wcel vk cc0 cQ cfz co cc0 cuz cfv
      ssralv mp2 vk cv cF cfv vk cc0 cQ fsumcl mp2an subdii cQ cfa cfv cP cQ
      cdiv co cmul co cz wcel cQ cfa cfv cc0 cQ cfz co vk cv cF cfv vk csu cmul
      co cz wcel cQ cfa cfv cP cQ cdiv co cmul co cQ cfa cfv cc0 cQ cfz co vk
      cv cF cfv vk csu cmul co cmin co cz wcel cQ cfa cfv cP cQ cdiv co cmul co
      cQ c1 cmin co cfa cfv cP cmul co cz cQ cfa cfv cQ c1 cmin co cfa cfv cP
      cmul co cQ cfa cfv cdiv co cmul co cQ cfa cfv cP cQ cdiv co cmul co cQ c1
      cmin co cfa cfv cP cmul co cQ c1 cmin co cfa cfv cP cmul co cQ cfa cfv
      cdiv co cP cQ cdiv co cQ cfa cfv cmul cQ c1 cmin co cfa cfv cP cmul co cQ
      cfa cfv cdiv co cQ c1 cmin co cfa cfv cP cmul co cQ c1 cmin co cfa cfv cQ
      cmul co cdiv co cP cQ cdiv co cQ cfa cfv cQ c1 cmin co cfa cfv cQ cmul co
      cQ c1 cmin co cfa cfv cP cmul co cdiv cQ cn wcel cQ cfa cfv cQ c1 cmin co
      cfa cfv cQ cmul co wceq eirrlem2.3 cQ facnn2 ax-mp opreq2i cP cc wcel cQ
      cc wcel cQ cc0 wne wa cQ c1 cmin co cfa cfv cc wcel cQ c1 cmin co cfa cfv
      cc0 wne wa cQ c1 cmin co cfa cfv cP cmul co cQ c1 cmin co cfa cfv cQ cmul
      co cdiv co cP cQ cdiv co wceq cP cz wcel cP cc wcel eirrlem2.2 cP zcn
      ax-mp cQ cc wcel cQ cc0 wne cQ eirrlem2.3 nncni cQ eirrlem2.3 nnne0i
      pm3.2i cQ cn wcel cQ c1 cmin co cfa cfv cc wcel cQ c1 cmin co cfa cfv cc0
      wne wa eirrlem2.3 cQ cn wcel cQ c1 cmin co cn0 wcel cQ c1 cmin co cfa cfv
      cn wcel cQ c1 cmin co cfa cfv cc wcel cQ c1 cmin co cfa cfv cc0 wne wa cQ
      nnm1nn0 cQ c1 cmin co faccl cQ c1 cmin co cfa cfv cn wcel cQ c1 cmin co
      cfa cfv cc wcel cQ c1 cmin co cfa cfv cc0 wne cQ c1 cmin co cfa cfv nncn
      cQ c1 cmin co cfa cfv nnne0 jca 3syl ax-mp cP cQ cQ c1 cmin co cfa cfv
      divcan5 mp3an eqtri opreq2i cQ c1 cmin co cfa cfv cP cmul co cQ cfa cfv
      cQ c1 cmin co cfa cfv cP cQ c1 cmin co cfa cfv cc wcel cQ c1 cmin co cfa
      cfv cc0 wne cQ cn wcel cQ c1 cmin co cfa cfv cc wcel cQ c1 cmin co cfa
      cfv cc0 wne wa eirrlem2.3 cQ cn wcel cQ c1 cmin co cn0 wcel cQ c1 cmin co
      cfa cfv cn wcel cQ c1 cmin co cfa cfv cc wcel cQ c1 cmin co cfa cfv cc0
      wne wa cQ nnm1nn0 cQ c1 cmin co faccl cQ c1 cmin co cfa cfv cn wcel cQ c1
      cmin co cfa cfv cc wcel cQ c1 cmin co cfa cfv cc0 wne cQ c1 cmin co cfa
      cfv nncn cQ c1 cmin co cfa cfv nnne0 jca 3syl ax-mp pm3.26i cP cz wcel cP
      cc wcel eirrlem2.2 cP zcn ax-mp mulcli cQ cfa cfv cQ cn0 wcel cQ cfa cfv
      cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nncni cQ cfa cfv cQ cn0 wcel
      cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nnne0i divcan2i
      eqtr3i cQ c1 cmin co cfa cfv cz wcel cP cz wcel cQ c1 cmin co cfa cfv cP
      cmul co cz wcel cQ cn wcel cQ c1 cmin co cfa cfv cz wcel eirrlem2.3 cQ cn
      wcel cQ c1 cmin co cn0 wcel cQ c1 cmin co cfa cfv cn wcel cQ c1 cmin co
      cfa cfv cz wcel cQ nnm1nn0 cQ c1 cmin co faccl cQ c1 cmin co cfa cfv nnz
      3syl ax-mp eirrlem2.2 cQ c1 cmin co cfa cfv cP zmulcl mp2an eqeltri cQ
      cfa cfv cc0 cQ cfz co vk cv cF cfv vk csu cmul co cc0 cQ cfz co cQ cfa
      cfv vk cv cF cfv cmul co vk csu cz cQ cc0 cuz cfv wcel cQ cfa cfv cc wcel
      vk cv cF cfv cc wcel vk cc0 cQ cfz co wral cQ cfa cfv cc0 cQ cfz co vk cv
      cF cfv vk csu cmul co cc0 cQ cfz co cQ cfa cfv vk cv cF cfv cmul co vk
      csu wceq cQ cn0 cc0 cuz cfv cQ eirrlem2.3 nnnn0i nn0uz eleqtri cQ cfa cfv
      cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nncni
      cc0 cQ cfz co cc0 cuz cfv wss vk cv cF cfv cc wcel vk cc0 cuz cfv wral vk
      cv cF cfv cc wcel vk cc0 cQ cfz co wral cc0 cQ fzssuz vk cv cF cfv cc
      wcel vk cc0 cuz cfv vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cF cfv cc
      wcel vk cv elnn0uz vk cv cn0 wcel vk cv cF cfv c1 vk cv cexp co vk cv cfa
      cfv cdiv co cc vy c1 vj cF vk cv eirrlem2.1 eftval c1 cc wcel vk cv cn0
      wcel c1 vk cv cexp co vk cv cfa cfv cdiv co cc wcel ax1cn c1 vk cv eftcl
      mpan eqeltrd sylbir rgen vk cv cF cfv cc wcel vk cc0 cQ cfz co cc0 cuz
      cfv ssralv mp2 vk cv cF cfv cQ cfa cfv vk cc0 cQ fsummulc1 mp3an cQ cc0
      cuz cfv wcel cQ cfa cfv vk cv cF cfv cmul co cz wcel vk cc0 cQ cfz co
      wral cc0 cQ cfz co cQ cfa cfv vk cv cF cfv cmul co vk csu cz wcel cQ cn0
      cc0 cuz cfv cQ eirrlem2.3 nnnn0i nn0uz eleqtri cQ cfa cfv vk cv cF cfv
      cmul co cz wcel vk cc0 cQ cfz co vk cv cc0 cQ cfz co wcel cQ cfa cfv vk
      cv cF cfv cmul co cn wcel cQ cfa cfv vk cv cF cfv cmul co cz wcel vk cv
      cc0 cQ cfz co wcel cQ cfa cfv vk cv cF cfv cmul co cQ cfa cfv vk cv cfa
      cfv cdiv co cn vk cv cc0 cQ cfz co wcel vk cv cn0 wcel cQ cfa cfv vk cv
      cF cfv cmul co cQ cfa cfv vk cv cfa cfv cdiv co wceq vk cv cQ elfznn0 vk
      cv cn0 wcel cQ cfa cfv vk cv cF cfv cmul co cQ cfa cfv c1 vk cv cfa cfv
      cdiv co cmul co cQ cfa cfv vk cv cfa cfv cdiv co vk cv cn0 wcel vk cv cF
      cfv c1 vk cv cfa cfv cdiv co cQ cfa cfv cmul vk cv cn0 wcel vk cv cF cfv
      c1 vk cv cexp co vk cv cfa cfv cdiv co c1 vk cv cfa cfv cdiv co vy c1 vj
      cF vk cv eirrlem2.1 eftval vk cv cn0 wcel c1 vk cv cexp co c1 vk cv cfa
      cfv cdiv vk cv 1exp opreq1d eqtrd opreq2d vk cv cn0 wcel vk cv cfa cfv cn
      wcel cQ cfa cfv cc wcel vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne w3a
      cQ cfa cfv vk cv cfa cfv cdiv co cQ cfa cfv c1 vk cv cfa cfv cdiv co cmul
      co wceq vk cv faccl vk cv cfa cfv cn wcel cQ cfa cfv cc wcel vk cv cfa
      cfv cc wcel vk cv cfa cfv cc0 wne cQ cfa cfv cc wcel vk cv cfa cfv cn
      wcel cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ
      faccl ax-mp nncni a1i vk cv cfa cfv nncn vk cv cfa cfv nnne0 3jca cQ cfa
      cfv vk cv cfa cfv divrec 3syl eqtr4d syl cQ cn0 wcel vk cv cc0 cQ cfz co
      wcel cQ cfa cfv vk cv cfa cfv cdiv co cn wcel cQ eirrlem2.3 nnnn0i vk cv
      cQ permnn mpan eqeltrd cQ cfa cfv vk cv cF cfv cmul co nnz syl rgen vx vz
      cQ cfa cfv vk cv cF cfv cmul co cz vk cc0 cQ vx cv vz cv zaddcl fsumcllem
      mp2an eqeltri cQ cfa cfv cP cQ cdiv co cmul co cQ cfa cfv cc0 cQ cfz co
      vk cv cF cfv vk csu cmul co zsubcl mp2an eqeltri $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)

    $( Lemma for ~ eirr . $)
    eirrlem3 $p |- ( ( ! ` Q ) x.
                     sum_ k e. ( ZZ>= ` ( Q + 1 ) ) ( F ` k ) ) < 1 $=
      cQ cfa cfv cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cmul co cQ c2 caddc
      co cQ c1 caddc co c2 cexp co cdiv co cle wbr cQ c2 caddc co cQ c1 caddc
      co c2 cexp co cdiv co c1 clt wbr cQ cfa cfv cQ c1 caddc co cuz cfv vk cv
      cF cfv vk csu cmul co c1 clt wbr cQ cfa cfv cQ c1 caddc co cuz cfv vk cv
      cF cfv vk csu cmul co cQ cfa cfv cQ c2 caddc co cQ cfa cfv cQ c1 caddc co
      c2 cexp co cmul co cdiv co cmul co cQ c2 caddc co cQ c1 caddc co c2 cexp
      co cdiv co cle cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cQ c2 caddc co
      cQ cfa cfv cQ c1 caddc co c2 cexp co cmul co cdiv co cle wbr cQ cfa cfv
      cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cmul co cQ cfa cfv cQ c2 caddc
      co cQ cfa cfv cQ c1 caddc co c2 cexp co cmul co cdiv co cmul co cle wbr
      cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cQ c1 caddc co c1 caddc co cQ
      c1 caddc co cfa cfv cQ c1 caddc co cmul co cdiv co cQ c2 caddc co cQ cfa
      cfv cQ c1 caddc co c2 cexp co cmul co cdiv co cle cQ c1 caddc co cn wcel
      c1 c1 wceq cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cQ c1 caddc co c1
      caddc co cQ c1 caddc co cfa cfv cQ c1 caddc co cmul co cdiv co cle wbr cQ
      cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp c1 eqid vy c1
      vj vk cF cQ c1 caddc co eirrlem2.1 ef1tlubi mp2an cQ c1 caddc co c1 caddc
      co cQ c2 caddc co cQ c1 caddc co cfa cfv cQ c1 caddc co cmul co cQ cfa
      cfv cQ c1 caddc co c2 cexp co cmul co cdiv cQ c1 caddc co c1 caddc co cQ
      c1 c1 caddc co caddc co cQ c2 caddc co cQ c1 c1 cQ eirrlem2.3 nncni ax1cn
      ax1cn addassi c2 c1 c1 caddc co cQ caddc df-2 opreq2i eqtr4i cQ cfa cfv
      cQ c1 caddc co cmul co cQ c1 caddc co cmul co cQ cfa cfv cQ c1 caddc co
      cQ c1 caddc co cmul co cmul co cQ c1 caddc co cfa cfv cQ c1 caddc co cmul
      co cQ cfa cfv cQ c1 caddc co c2 cexp co cmul co cQ cfa cfv cQ c1 caddc co
      cQ c1 caddc co cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3
      nnnn0i cQ faccl ax-mp nncni cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn
      wcel eirrlem2.3 cQ peano2nn ax-mp nncni cQ c1 caddc co cQ cn wcel cQ c1
      caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nncni mulassi cQ c1 caddc
      co cfa cfv cQ cfa cfv cQ c1 caddc co cmul co cQ c1 caddc co cmul cQ cn0
      wcel cQ c1 caddc co cfa cfv cQ cfa cfv cQ c1 caddc co cmul co wceq cQ
      eirrlem2.3 nnnn0i cQ facp1 ax-mp opreq1i cQ c1 caddc co c2 cexp co cQ c1
      caddc co cQ c1 caddc co cmul co cQ cfa cfv cmul cQ c1 caddc co cQ c1
      caddc co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp
      nncni sqvali opreq2i 3eqtr4i opreq12i breqtri cc0 cQ cfa cfv clt wbr cQ
      c1 caddc co cuz cfv vk cv cF cfv vk csu cQ c2 caddc co cQ cfa cfv cQ c1
      caddc co c2 cexp co cmul co cdiv co cle wbr cQ cfa cfv cQ c1 caddc co cuz
      cfv vk cv cF cfv vk csu cmul co cQ cfa cfv cQ c2 caddc co cQ cfa cfv cQ
      c1 caddc co c2 cexp co cmul co cdiv co cmul co cle wbr wb cQ cfa cfv cQ
      cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nngt0i cQ
      c1 caddc co cuz cfv vk cv cF cfv vk csu cQ c2 caddc co cQ cfa cfv cQ c1
      caddc co c2 cexp co cmul co cdiv co cQ cfa cfv cQ c1 caddc co cz wcel vk
      cv cF cfv cr wcel vk cQ c1 caddc co cuz cfv wral cQ c1 caddc co caddc cop
      cF cseqz co vx cv cli wbr vx wex cQ c1 caddc co cuz cfv vk cv cF cfv vk
      csu cr wcel cQ c1 caddc co cn wcel cQ c1 caddc co cz wcel cQ cn wcel cQ
      c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp cQ c1 caddc co nnz ax-mp
      vk cv cF cfv cr wcel vk cQ c1 caddc co cuz cfv vk cv cQ c1 caddc co cuz
      cfv wcel vk cv cn0 wcel vk cv cF cfv cr wcel vk cv cQ c1 caddc co cuz cfv
      wcel cQ c1 caddc co cc0 cuz cfv wcel vk cv cn0 wcel cQ c1 caddc co cn0
      cc0 cuz cfv cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3
      cQ peano2nn ax-mp nnnn0i nn0uz eleqtri vk cv cQ c1 caddc co cuz cfv wcel
      cQ c1 caddc co cc0 cuz cfv wcel wa vk cv cc0 cuz cfv wcel vk cv cn0 wcel
      cQ c1 caddc co vk cv cc0 uztrn vk cv elnn0uz sylibr mpan2 vk cv cn0 wcel
      vk cv cF cfv c1 vk cv cexp co vk cv cfa cfv cdiv co cr vy c1 vj cF vk cv
      eirrlem2.1 eftval c1 cr wcel vk cv cn0 wcel c1 vk cv cexp co vk cv cfa
      cfv cdiv co cr wcel 1re c1 vk cv reeftcl mpan eqeltrd syl rgen c1 cc wcel
      cQ c1 caddc co cn wcel cQ c1 caddc co caddc cop cF cseqz co vx cv cli wbr
      vx wex ax1cn cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn
      ax-mp vx vy c1 vj cF cQ c1 caddc co eirrlem2.1 eftlex mp2an vx vk cF cQ
      c1 caddc co vj vy cn0 c1 vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex
      eirrlem2.1 fopabex2 isumrecl mp3an cQ c2 caddc co cQ cfa cfv cQ c1 caddc
      co c2 cexp co cmul co cQ c2 cQ eirrlem2.3 nnrei 2re readdcli cQ cfa cfv
      cQ c1 caddc co c2 cexp co cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ
      eirrlem2.3 nnnn0i cQ faccl ax-mp nnrei cQ c1 caddc co cQ c1 caddc co cQ
      cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nnrei resqcli
      remulcli cQ cfa cfv cQ c1 caddc co c2 cexp co cQ cfa cfv cQ cn0 wcel cQ
      cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nncni cQ c1 caddc co
      cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn
      ax-mp nncni sqcli cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3
      nnnn0i cQ faccl ax-mp nnne0i cQ c1 caddc co c2 cexp co cc0 wne cQ c1
      caddc co cc0 wne cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel
      eirrlem2.3 cQ peano2nn ax-mp nnne0i cQ c1 caddc co cc wcel cQ c1 caddc co
      c2 cexp co cc0 wne cQ c1 caddc co cc0 wne wb cQ c1 caddc co cQ cn wcel cQ
      c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nncni cQ c1 caddc co
      sqne0 ax-mp mpbir muln0i redivcli cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn
      wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nnrei lemul2i ax-mp mpbi cQ cfa
      cfv cQ c2 caddc co cmul co cQ cfa cfv cQ c1 caddc co c2 cexp co cmul co
      cdiv co cQ cfa cfv cQ c2 caddc co cQ cfa cfv cQ c1 caddc co c2 cexp co
      cmul co cdiv co cmul co cQ c2 caddc co cQ c1 caddc co c2 cexp co cdiv co
      cQ cfa cfv cQ c2 caddc co cQ cfa cfv cQ c1 caddc co c2 cexp co cmul co cQ
      cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl
      ax-mp nncni cQ c2 caddc co cQ c2 cQ eirrlem2.3 nnrei 2re readdcli recni
      cQ cfa cfv cQ c1 caddc co c2 cexp co cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn
      wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nncni cQ c1 caddc co cQ c1 caddc
      co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nncni
      sqcli mulcli cQ cfa cfv cQ c1 caddc co c2 cexp co cQ cfa cfv cQ cn0 wcel
      cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nncni cQ c1 caddc
      co cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ
      peano2nn ax-mp nncni sqcli cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ
      eirrlem2.3 nnnn0i cQ faccl ax-mp nnne0i cQ c1 caddc co c2 cexp co cc0 wne
      cQ c1 caddc co cc0 wne cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel
      eirrlem2.3 cQ peano2nn ax-mp nnne0i cQ c1 caddc co cc wcel cQ c1 caddc co
      c2 cexp co cc0 wne cQ c1 caddc co cc0 wne wb cQ c1 caddc co cQ cn wcel cQ
      c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nncni cQ c1 caddc co
      sqne0 ax-mp mpbir muln0i divassi cQ c2 caddc co cc wcel cQ c1 caddc co c2
      cexp co cc wcel cQ c1 caddc co c2 cexp co cc0 wne wa cQ cfa cfv cc wcel
      cQ cfa cfv cc0 wne wa cQ cfa cfv cQ c2 caddc co cmul co cQ cfa cfv cQ c1
      caddc co c2 cexp co cmul co cdiv co cQ c2 caddc co cQ c1 caddc co c2 cexp
      co cdiv co wceq cQ c2 caddc co cQ c2 cQ eirrlem2.3 nnrei 2re readdcli
      recni cQ c1 caddc co c2 cexp co cc wcel cQ c1 caddc co c2 cexp co cc0 wne
      cQ c1 caddc co cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel
      eirrlem2.3 cQ peano2nn ax-mp nncni sqcli cQ c1 caddc co c2 cexp co cc0
      wne cQ c1 caddc co cc0 wne cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn
      wcel eirrlem2.3 cQ peano2nn ax-mp nnne0i cQ c1 caddc co cc wcel cQ c1
      caddc co c2 cexp co cc0 wne cQ c1 caddc co cc0 wne wb cQ c1 caddc co cQ
      cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nncni cQ c1
      caddc co sqne0 ax-mp mpbir pm3.2i cQ cfa cfv cc wcel cQ cfa cfv cc0 wne
      cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl
      ax-mp nncni cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3
      nnnn0i cQ faccl ax-mp nnne0i pm3.2i cQ c2 caddc co cQ c1 caddc co c2 cexp
      co cQ cfa cfv divcan5 mp3an eqtr3i breqtri cQ eirrlem2.3 eirrlem1 cQ cfa
      cfv cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cmul co cQ c2 caddc co cQ
      c1 caddc co c2 cexp co cdiv co c1 cQ cfa cfv cQ c1 caddc co cuz cfv vk cv
      cF cfv vk csu cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3
      nnnn0i cQ faccl ax-mp nnrei cQ c1 caddc co cz wcel vk cv cF cfv cr wcel
      vk cQ c1 caddc co cuz cfv wral cQ c1 caddc co caddc cop cF cseqz co vx cv
      cli wbr vx wex cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cr wcel cQ c1
      caddc co cn wcel cQ c1 caddc co cz wcel cQ cn wcel cQ c1 caddc co cn wcel
      eirrlem2.3 cQ peano2nn ax-mp cQ c1 caddc co nnz ax-mp vk cv cF cfv cr
      wcel vk cQ c1 caddc co cuz cfv vk cv cQ c1 caddc co cuz cfv wcel vk cv
      cn0 wcel vk cv cF cfv cr wcel vk cv cQ c1 caddc co cuz cfv wcel cQ c1
      caddc co cc0 cuz cfv wcel vk cv cn0 wcel cQ c1 caddc co cn0 cc0 cuz cfv
      cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn
      ax-mp nnnn0i nn0uz eleqtri vk cv cQ c1 caddc co cuz cfv wcel cQ c1 caddc
      co cc0 cuz cfv wcel wa vk cv cc0 cuz cfv wcel vk cv cn0 wcel cQ c1 caddc
      co vk cv cc0 uztrn vk cv elnn0uz sylibr mpan2 vk cv cn0 wcel vk cv cF cfv
      c1 vk cv cexp co vk cv cfa cfv cdiv co cr vy c1 vj cF vk cv eirrlem2.1
      eftval c1 cr wcel vk cv cn0 wcel c1 vk cv cexp co vk cv cfa cfv cdiv co
      cr wcel 1re c1 vk cv reeftcl mpan eqeltrd syl rgen c1 cc wcel cQ c1 caddc
      co cn wcel cQ c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex
      ax1cn cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp vx
      vy c1 vj cF cQ c1 caddc co eirrlem2.1 eftlex mp2an vx vk cF cQ c1 caddc
      co vj vy cn0 c1 vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex eirrlem2.1
      fopabex2 isumrecl mp3an remulcli cQ c2 caddc co cQ c1 caddc co c2 cexp co
      cQ c2 cQ eirrlem2.3 nnrei 2re readdcli cQ c1 caddc co cQ c1 caddc co cQ
      cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nnrei resqcli
      cQ c1 caddc co c2 cexp co cc0 wne cQ c1 caddc co cc0 wne cQ c1 caddc co
      cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp nnne0i cQ
      c1 caddc co cc wcel cQ c1 caddc co c2 cexp co cc0 wne cQ c1 caddc co cc0
      wne wb cQ c1 caddc co cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ
      peano2nn ax-mp nncni cQ c1 caddc co sqne0 ax-mp mpbir redivcli 1re
      lelttri mp2an $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)

    $( Lemma for ~ eirr . $)
    eirrlem4 $p |- 0 < ( ( ! ` Q ) x.
                         sum_ k e. ( ZZ>= ` ( Q + 1 ) ) ( F ` k ) ) $=
      cQ cfa cfv cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cQ cfa cfv cQ cn0
      wcel cQ cfa cfv cn wcel cQ eirrlem2.3 nnnn0i cQ faccl ax-mp nnrei cQ c1
      caddc co cz wcel vk cv cF cfv cr wcel vk cQ c1 caddc co cuz cfv wral cQ
      c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cQ c1 caddc co cuz
      cfv vk cv cF cfv vk csu cr wcel cQ c1 caddc co cn0 wcel cQ c1 caddc co cz
      wcel cQ c1 caddc co cQ cn0 wcel cQ c1 caddc co cn wcel cQ eirrlem2.3
      nnnn0i cQ nn0p1nn ax-mp nnnn0i cQ c1 caddc co nn0z ax-mp vk cv cF cfv cr
      wcel vk cQ c1 caddc co cuz cfv vk cv cQ c1 caddc co cuz cfv wcel vk cv
      cc0 cuz cfv wcel vk cv cF cfv cr wcel vk cv cQ c1 caddc co cuz cfv wcel
      cQ c1 caddc co cc0 cuz cfv wcel vk cv cc0 cuz cfv wcel cQ c1 caddc co cn0
      cc0 cuz cfv cQ c1 caddc co cQ cn0 wcel cQ c1 caddc co cn wcel cQ
      eirrlem2.3 nnnn0i cQ nn0p1nn ax-mp nnnn0i nn0uz eleqtri cQ c1 caddc co vk
      cv cc0 uztrn mpan2 vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cF cfv cr
      wcel vk cv elnn0uz vk cv cn0 wcel vk cv cF cfv c1 vk cv cexp co vk cv cfa
      cfv cdiv co cr vy c1 vj cF vk cv eirrlem2.1 eftval c1 cr wcel vk cv cn0
      wcel c1 vk cv cexp co vk cv cfa cfv cdiv co cr wcel 1re c1 vk cv reeftcl
      mpan eqeltrd sylbir syl rgen c1 cc wcel cQ c1 caddc co cn wcel cQ c1
      caddc co caddc cop cF cseqz co vx cv cli wbr vx wex ax1cn cQ cn0 wcel cQ
      c1 caddc co cn wcel cQ eirrlem2.3 nnnn0i cQ nn0p1nn ax-mp vx vy c1 vj cF
      cQ c1 caddc co eirrlem2.1 eftlex mp2an vx vk cF cQ c1 caddc co vj vy cn0
      c1 vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex eirrlem2.1 fopabex2
      isumrecl mp3an cQ cfa cfv cQ cn0 wcel cQ cfa cfv cn wcel cQ eirrlem2.3
      nnnn0i cQ faccl ax-mp nngt0i cQ c1 caddc co cc0 cuz cfv wcel vk cv cF cfv
      cr wcel cc0 vk cv cF cfv clt wbr wa vk cc0 cuz cfv wral cc0 caddc cop cF
      cseqz co vx cv cli wbr vx wex cc0 cQ c1 caddc co cuz cfv vk cv cF cfv vk
      csu clt wbr cQ c1 caddc co cn0 cc0 cuz cfv cQ c1 caddc co cQ cn0 wcel cQ
      c1 caddc co cn wcel cQ eirrlem2.3 nnnn0i cQ nn0p1nn ax-mp nnnn0i nn0uz
      eleqtri vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cc0 cuz cfv
      vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cF cfv cr wcel cc0 vk cv cF
      cfv clt wbr wa vk cv elnn0uz vk cv cn0 wcel vk cv cF cfv cr wcel cc0 vk
      cv cF cfv clt wbr vk cv cn0 wcel vk cv cF cfv c1 vk cv cexp co vk cv cfa
      cfv cdiv co cr vy c1 vj cF vk cv eirrlem2.1 eftval c1 cr wcel vk cv cn0
      wcel c1 vk cv cexp co vk cv cfa cfv cdiv co cr wcel 1re c1 vk cv reeftcl
      mpan eqeltrd vk cv cn0 wcel cc0 c1 vk cv cexp co vk cv cfa cfv cdiv co vk
      cv cF cfv clt c1 vk cv cexp co cr wcel cc0 c1 vk cv cexp co clt wbr wa vk
      cv cfa cfv cr wcel cc0 vk cv cfa cfv clt wbr wa cc0 c1 vk cv cexp co vk
      cv cfa cfv cdiv co clt wbr vk cv cn0 wcel c1 vk cv cexp co vk cv cfa cfv
      divgt0 vk cv cn0 wcel c1 vk cv cexp co cr wcel cc0 c1 vk cv cexp co clt
      wbr vk cv cn0 wcel c1 vk cv cexp co c1 cr vk cv 1exp 1re syl6eqel vk cv
      cn0 wcel c1 c1 vk cv cexp co cc0 clt vk cv 1exp lt01 syl5breqr jca vk cv
      cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel cc0 vk cv cfa cfv
      clt wbr wa vk cv faccl vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel cc0 vk
      cv cfa cfv clt wbr vk cv cfa cfv nnre vk cv cfa cfv nngt0 jca syl sylanc
      vy c1 vj cF vk cv eirrlem2.1 eftval breqtrrd jca sylbir rgen caddc cF
      cseq0 co vx cv cli wbr vx wex cc0 caddc cop cF cseqz co vx cv cli wbr vx
      wex c1 cc wcel caddc cF cseq0 co vx cv cli wbr vx wex ax1cn vx vy c1 vj
      cF eirrlem2.1 efseq0ex ax-mp caddc cF cseq0 co vx cv cli wbr cc0 caddc
      cop cF cseqz co vx cv cli wbr vx caddc cF cseq0 co cc0 caddc cop cF cseqz
      co vx cv cli caddc cF addex vj vy cn0 c1 vj cv cexp co vj cv cfa cfv cdiv
      co cF nn0ex eirrlem2.1 fopabex2 seq0seqz breq1i exbii mpbi vx vk cF cc0
      cQ c1 caddc co vj vy cn0 c1 vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex
      eirrlem2.1 fopabex2 iserzgt0 mp3an mulgt0ii $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)

    $( Lemma for ~ eirr . $)
    eirrlem5 $p |- -. _e = ( P / Q ) $=
      ceu cP cQ cdiv co wceq cQ cfa cfv cQ c1 caddc co cuz cfv vk cv cF cfv vk
      csu cmul co cz wcel cc0 cz wcel cc0 cQ cfa cfv cQ c1 caddc co cuz cfv vk
      cv cF cfv vk csu cmul co clt wbr cQ cfa cfv cQ c1 caddc co cuz cfv vk cv
      cF cfv vk csu cmul co cc0 c1 caddc co clt wbr cQ cfa cfv cQ c1 caddc co
      cuz cfv vk cv cF cfv vk csu cmul co cz wcel wn 0z vy cP cQ vj vk cF
      eirrlem2.1 eirrlem2.2 eirrlem2.3 eirrlem4 cQ cfa cfv cQ c1 caddc co cuz
      cfv vk cv cF cfv vk csu cmul co c1 cc0 c1 caddc co clt vy cP cQ vj vk cF
      eirrlem2.1 eirrlem2.2 eirrlem2.3 eirrlem3 c1 ax1cn addid2i breqtrri cc0
      cQ cfa cfv cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cmul co btwnnz
      mp3an ceu cP cQ cdiv co wceq cQ cfa cfv cQ c1 caddc co cuz cfv vk cv cF
      cfv vk csu cmul co cQ cfa cfv cP cQ cdiv co cc0 cQ cfz co vk cv cF cfv vk
      csu cmin co cmul co cz ceu cP cQ cdiv co wceq cQ cfa cfv cn0 vk cv cF cfv
      vk csu cc0 cQ cfz co vk cv cF cfv vk csu cmin co cmul co cQ cfa cfv cP cQ
      cdiv co cc0 cQ cfz co vk cv cF cfv vk csu cmin co cmul co cQ cfa cfv cQ
      c1 caddc co cuz cfv vk cv cF cfv vk csu cmul co ceu cP cQ cdiv co wceq
      cn0 vk cv cF cfv vk csu cc0 cQ cfz co vk cv cF cfv vk csu cmin co cP cQ
      cdiv co cc0 cQ cfz co vk cv cF cfv vk csu cmin co cQ cfa cfv cmul ceu cP
      cQ cdiv co wceq cn0 vk cv cF cfv vk csu cP cQ cdiv co cc0 cQ cfz co vk cv
      cF cfv vk csu cmin ceu cP cQ cdiv co wceq cn0 vk cv cF cfv vk csu cP cQ
      cdiv co wceq ceu cn0 vk cv cF cfv vk csu cP cQ cdiv co c1 ce cfv cn0 c1
      vk cv cexp co vk cv cfa cfv cdiv co vk csu ceu cn0 vk cv cF cfv vk csu c1
      cc wcel c1 ce cfv cn0 c1 vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq
      ax1cn c1 vk efval ax-mp df-e cn0 vk cv cF cfv c1 vk cv cexp co vk cv cfa
      cfv cdiv co vk vy c1 vj cF vk cv eirrlem2.1 eftval sumeq2i 3eqtr4i eqeq1i
      biimpi opreq1d opreq2d cn0 vk cv cF cfv vk csu cc0 cQ cfz co vk cv cF cfv
      vk csu cmin co cQ c1 caddc co cuz cfv vk cv cF cfv vk csu cQ cfa cfv cmul
      cn0 vk cv cF cfv vk csu cc0 cQ cfz co vk cv cF cfv vk csu cQ c1 caddc co
      cuz cfv vk cv cF cfv vk csu cn0 vk cv cF cfv vk csu ceu cn0 vk cv cF cfv
      vk csu cr c1 ce cfv cn0 c1 vk cv cexp co vk cv cfa cfv cdiv co vk csu ceu
      cn0 vk cv cF cfv vk csu c1 cc wcel c1 ce cfv cn0 c1 vk cv cexp co vk cv
      cfa cfv cdiv co vk csu wceq ax1cn c1 vk efval ax-mp df-e cn0 vk cv cF cfv
      c1 vk cv cexp co vk cv cfa cfv cdiv co vk vy c1 vj cF vk cv eirrlem2.1
      eftval sumeq2i 3eqtr4i ere eqeltrri recni cQ cc0 cuz cfv wcel vk cv cF
      cfv cc wcel vk cc0 cQ cfz co wral cc0 cQ cfz co vk cv cF cfv vk csu cc
      wcel cQ cn0 cc0 cuz cfv cQ eirrlem2.3 nnnn0i nn0uz eleqtri cc0 cQ cfz co
      cc0 cuz cfv wss vk cv cF cfv cc wcel vk cc0 cuz cfv wral vk cv cF cfv cc
      wcel vk cc0 cQ cfz co wral cc0 cQ fzssuz vk cv cF cfv cc wcel vk cc0 cuz
      cfv vk cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv cF cfv cc wcel vk cv
      elnn0uz vk cv cn0 wcel vk cv cF cfv c1 vk cv cexp co vk cv cfa cfv cdiv
      co cc vy c1 vj cF vk cv eirrlem2.1 eftval c1 cc wcel vk cv cn0 wcel c1 vk
      cv cexp co vk cv cfa cfv cdiv co cc wcel ax1cn c1 vk cv eftcl mpan
      eqeltrd sylbir rgen vk cv cF cfv cc wcel vk cc0 cQ cfz co cc0 cuz cfv
      ssralv mp2 vk cv cF cfv vk cc0 cQ fsumcl mp2an cQ c1 caddc co cz wcel cQ
      c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cQ c1 caddc co cuz
      cfv vk cv cF cfv vk csu cc wcel cQ c1 caddc co cn wcel cQ c1 caddc co cz
      wcel cQ cn wcel cQ c1 caddc co cn wcel eirrlem2.3 cQ peano2nn ax-mp cQ c1
      caddc co nnz ax-mp c1 cc wcel cQ c1 caddc co cn wcel cQ c1 caddc co caddc
      cop cF cseqz co vx cv cli wbr vx wex ax1cn cQ cn wcel cQ c1 caddc co cn
      wcel eirrlem2.3 cQ peano2nn ax-mp vx vy c1 vj cF cQ c1 caddc co
      eirrlem2.1 eftlex mp2an vx vk cF cQ c1 caddc co vj vy cn0 c1 vj cv cexp
      co vj cv cfa cfv cdiv co cF nn0ex eirrlem2.1 fopabex2 isumcl mp2an cn0 vk
      cv cF cfv vk csu cc0 cQ cfz co vk cv cF cfv vk csu cQ c1 caddc co cuz cfv
      vk cv cF cfv vk csu caddc co vx vk cF cQ cQ eirrlem2.3 nnnn0i vj vy cn0
      cc c1 vj cv cexp co vj cv cfa cfv cdiv co cF eirrlem2.1 c1 cc wcel vj cv
      cn0 wcel c1 vj cv cexp co vj cv cfa cfv cdiv co cc wcel ax1cn c1 vj cv
      eftcl mpan fopab c1 cc wcel caddc cF cseq0 co vx cv cli wbr vx wex ax1cn
      vx vy c1 vj cF eirrlem2.1 efseq0ex ax-mp isum0spliti eqcomi subaddrii
      opreq2i syl5eqr vy cP cQ vj vk cF eirrlem2.1 eirrlem2.2 eirrlem2.3
      eirrlem2 syl6eqel mto $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d j q y $.  $d p q $.
    $( ` _e ` is irrational.  (Contributed by Paul Chapman, 9-Feb-2008.) $)
    eirr $p |- _e e/ QQ $=
      ceu cq wnel ceu cq wcel wn ceu cq wcel ceu vp cv vq cv cdiv co wceq vq cn
      wrex vp cz wrex ceu vp cv vq cv cdiv co wceq vq cn wrex vp cz vp cv cz
      wcel ceu vp cv vq cv cdiv co wceq vq cn vp cv cz wcel vq cv cn wcel ceu
      vp cv vq cv cdiv co wceq wn ceu vp cv cz wcel vp cv cc0 cif vq cv cdiv co
      wceq wn ceu vp cv cz wcel vp cv cc0 cif vq cv cn wcel vq cv c1 cif cdiv
      co wceq wn vp cv vq cv cc0 c1 vp cv vp cv cz wcel vp cv cc0 cif wceq ceu
      vp cv vq cv cdiv co wceq ceu vp cv cz wcel vp cv cc0 cif vq cv cdiv co
      wceq vp cv vp cv cz wcel vp cv cc0 cif wceq vp cv vq cv cdiv co vp cv cz
      wcel vp cv cc0 cif vq cv cdiv co ceu vp cv vp cv cz wcel vp cv cc0 cif vq
      cv cdiv opreq1 eqeq2d notbid vq cv vq cv cn wcel vq cv c1 cif wceq ceu vp
      cv cz wcel vp cv cc0 cif vq cv cdiv co wceq ceu vp cv cz wcel vp cv cc0
      cif vq cv cn wcel vq cv c1 cif cdiv co wceq vq cv vq cv cn wcel vq cv c1
      cif wceq vp cv cz wcel vp cv cc0 cif vq cv cdiv co vp cv cz wcel vp cv
      cc0 cif vq cv cn wcel vq cv c1 cif cdiv co ceu vq cv vq cv cn wcel vq cv
      c1 cif vp cv cz wcel vp cv cc0 cif cdiv opreq2 eqeq2d notbid vy vp cv cz
      wcel vp cv cc0 cif vq cv cn wcel vq cv c1 cif vj vj cv cn0 wcel vy cv c1
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy
      cv c1 vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid vp cv
      cc0 cz 0z elimel vq cv c1 cn 1nn elimel eirrlem5 dedth2h nrexdv nrex vp
      vq ceu elq mtbir ceu cq df-nel mpbir $.
      $( [9-Feb-2008] $) $( [9-Feb-2008] $)
  $}

  $( MAY BE REVISED - make obsolete and use egt2lt3 instead $)
  $( Euler's constant ` _e ` = 2.71828... is greater than 2. $)
  egt2OLD $p |- 2 < _e $=
    c2 ceu clt wbr c2 ceu cle wbr ceu c2 wne c2 ceu 2re ere ltleni ege2 ceu c2
    wne ceu c2 wceq wn ceu c2 wceq ceu cq wcel ceu cq wnel ceu cq wcel wn eirr
    ceu cq df-nel mpbi ceu c2 wceq ceu cq wcel c2 cq wcel c2 cn wcel c2 cq wcel
    2nn c2 nnq ax-mp ceu c2 cq eleq1 mpbiri mto ceu c2 df-ne mpbir mpbir2an $.
    $( [2-Dec-2008] $) $( [28-Nov-2008] $)

  $( MAY BE REVISED - make obsolete and use egt2lt3 instead $)
  $( Euler's constant ` _e ` = 2.71828... is less than 3. $)
  elt3OLD $p |- _e < 3 $=
    ceu c3 clt wbr ceu c3 cle wbr c3 ceu wne ceu c3 ere 3re ltleni ele3 c3 ceu
    wne c3 ceu wceq wn c3 ceu wceq ceu cq wcel ceu cq wnel ceu cq wcel wn eirr
    ceu cq df-nel mpbi c3 ceu wceq c3 cq wcel ceu cq wcel c3 cn wcel c3 cq wcel
    3nn c3 nnq ax-mp c3 ceu cq eleq1 mpbii mto c3 ceu df-ne mpbir mpbir2an $.
    $( [30-Apr-2009] $) $( [28-Nov-2008] $)

  $( Euler's constant ` _e ` = 2.71828... is bounded by 2 and 3. $)
  egt2lt3 $p |- ( 2 < _e /\ _e < 3 ) $=
    c2 ceu clt wbr ceu c3 clt wbr c2 ceu clt wbr c2 ceu cle wbr ceu c2 wne c2
    ceu 2re ere ltleni c2 ceu cle wbr ceu c3 cle wbr ege2le3 pm3.26i ceu c2 wne
    ceu c2 wceq wn ceu c2 wceq ceu cq wcel ceu cq wnel ceu cq wcel wn eirr ceu
    cq df-nel mpbi ceu c2 wceq ceu cq wcel c2 cq wcel c2 cn wcel c2 cq wcel 2nn
    c2 nnq ax-mp ceu c2 cq eleq1 mpbiri mto ceu c2 df-ne mpbir mpbir2an ceu c3
    clt wbr ceu c3 cle wbr c3 ceu wne ceu c3 ere 3re ltleni c2 ceu cle wbr ceu
    c3 cle wbr ege2le3 pm3.27i c3 ceu wne c3 ceu wceq wn c3 ceu wceq ceu cq
    wcel ceu cq wnel ceu cq wcel wn eirr ceu cq df-nel mpbi c3 ceu wceq c3 cq
    wcel ceu cq wcel c3 cn wcel c3 cq wcel 3nn c3 nnq ax-mp c3 ceu cq eleq1
    mpbii mto c3 ceu df-ne mpbir mpbir2an pm3.2i $.
    $( [17-May-2009] $) $( [28-Nov-2008] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The exponential, sine, and cosine functions (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A j k x y $.  $d F k x $.  $d M j k x y $.
    abspef01tlub.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                               y = ( ( ( _i x. A ) ^ j ) / ( ! ` j ) ) ) } $.
    abspef01tlub.2 $e |- ( P = Re \/ P = Im ) $.
    $( An upper bound on the absolute value of the infinite tail of the series
       expansion of the exponential function on the punctured closed unit disc
       projected onto the real or imaginary axis.  (Contributed by Paul
       Chapman, 19-Jan-2008.) $)
    abspef01tlubi $p |- ( ( A e. ( 0 (,] 1 ) /\ M e. NN ) ->
                       ( abs ` ( P ` sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) ) <_
                       ( ( A ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) ) $=
      cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cP
      cfv cabs cfv cM cuz cfv vk cv cF cfv vk csu cabs cfv cA cM cexp co cM c1
      caddc co cM cfa cfv cM cmul co cdiv co cmul co cA cc0 c1 cioc co wcel cM
      cn wcel wa cM cuz cfv vk cv cF cfv vk csu cP cfv cc wcel cM cuz cfv vk cv
      cF cfv vk csu cP cfv cabs cfv cr wcel cA cc0 c1 cioc co wcel cM cn wcel
      wa cM cuz cfv vk cv cF cfv vk csu cP cfv cP cre wceq cP cim wceq wo cA
      cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cP cfv
      cr wcel wi abspef01tlub.2 cP cre wceq cA cc0 c1 cioc co wcel cM cn wcel
      wa cM cuz cfv vk cv cF cfv vk csu cP cfv cr wcel wi cP cim wceq cP cre
      wceq cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu
      cP cfv cr wcel cP cre wceq cA cc0 c1 cioc co wcel cM cn wcel wa wa cM cuz
      cfv vk cv cF cfv vk csu cP cfv cM cuz cfv vk cv cF cfv vk csu cre cfv cr
      cP cre wceq cM cuz cfv vk cv cF cfv vk csu cP cfv cM cuz cfv vk cv cF cfv
      vk csu cre cfv wceq cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv
      cF cfv vk csu cP cre fveq1 adantr cA cc0 c1 cioc co wcel cM cn wcel wa cM
      cuz cfv vk cv cF cfv vk csu cre cfv cr wcel cP cre wceq cA cc0 c1 cioc co
      wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cc wcel cM cuz cfv vk
      cv cF cfv vk csu cre cfv cr wcel ci cA cmul co cc wcel cM cn wcel cM cuz
      cfv vk cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co
      vj vk cF cM abspef01tlub.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc
      wcel cA cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr sylan
      cM cuz cfv vk cv cF cfv vk csu recl syl adantl eqeltrd ex cP cim wceq cA
      cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cP cfv
      cr wcel cP cim wceq cA cc0 c1 cioc co wcel cM cn wcel wa wa cM cuz cfv vk
      cv cF cfv vk csu cP cfv cM cuz cfv vk cv cF cfv vk csu cim cfv cr cP cim
      wceq cM cuz cfv vk cv cF cfv vk csu cP cfv cM cuz cfv vk cv cF cfv vk csu
      cim cfv wceq cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv
      vk csu cP cim fveq1 adantr cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz
      cfv vk cv cF cfv vk csu cim cfv cr wcel cP cim wceq cA cc0 c1 cioc co
      wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cc wcel cM cuz cfv vk
      cv cF cfv vk csu cim cfv cr wcel ci cA cmul co cc wcel cM cn wcel cM cuz
      cfv vk cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co
      vj vk cF cM abspef01tlub.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc
      wcel cA cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr sylan
      cM cuz cfv vk cv cF cfv vk csu imcl syl adantl eqeltrd ex jaoi ax-mp
      recnd cM cuz cfv vk cv cF cfv vk csu cP cfv abscl syl cA cc0 c1 cioc co
      wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cc wcel cM cuz cfv vk
      cv cF cfv vk csu cabs cfv cr wcel ci cA cmul co cc wcel cM cn wcel cM cuz
      cfv vk cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co
      vj vk cF cM abspef01tlub.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc
      wcel cA cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr sylan
      cM cuz cfv vk cv cF cfv vk csu abscl syl cA cM cexp co cr wcel cM c1
      caddc co cM cfa cfv cM cmul co cdiv co cr wcel cA cM cexp co cM c1 caddc
      co cM cfa cfv cM cmul co cdiv co cmul co cr wcel cA cc0 c1 cioc co wcel
      cM cn wcel wa cA cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co
      remulcl cA cr wcel cM cn0 wcel cA cM cexp co cr wcel cA cc0 c1 cioc co
      wcel cM cn wcel cA cM reexpcl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cM nnnn0 syl2an cM cn wcel cM c1 caddc co cM cfa cfv cM cmul co
      cdiv co cr wcel cA cc0 c1 cioc co wcel cM eftlubcl adantl sylanc cP cre
      wceq cP cim wceq wo cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv
      cF cfv vk csu cP cfv cabs cfv cM cuz cfv vk cv cF cfv vk csu cabs cfv cle
      wbr wi abspef01tlub.2 cP cre wceq cA cc0 c1 cioc co wcel cM cn wcel wa cM
      cuz cfv vk cv cF cfv vk csu cP cfv cabs cfv cM cuz cfv vk cv cF cfv vk
      csu cabs cfv cle wbr wi cP cim wceq cP cre wceq cM cuz cfv vk cv cF cfv
      vk csu cP cfv cabs cfv cM cuz cfv vk cv cF cfv vk csu cabs cfv cle wbr cM
      cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cM cuz cfv vk cv cF cfv vk
      csu cabs cfv cle wbr cA cc0 c1 cioc co wcel cM cn wcel wa cP cre wceq cM
      cuz cfv vk cv cF cfv vk csu cP cfv cabs cfv cM cuz cfv vk cv cF cfv vk
      csu cre cfv cabs cfv cM cuz cfv vk cv cF cfv vk csu cabs cfv cle cP cre
      wceq cM cuz cfv vk cv cF cfv vk csu cP cfv cM cuz cfv vk cv cF cfv vk csu
      cre cfv cabs cM cuz cfv vk cv cF cfv vk csu cP cre fveq1 fveq2d breq1d cA
      cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cc wcel
      cM cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cM cuz cfv vk cv cF cfv
      vk csu cabs cfv cle wbr ci cA cmul co cc wcel cM cn wcel cM cuz cfv vk cv
      cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF cM
      abspef01tlub.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cc0
      c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr sylan cM cuz cfv
      vk cv cF cfv vk csu absrele syl syl5bir cP cim wceq cM cuz cfv vk cv cF
      cfv vk csu cP cfv cabs cfv cM cuz cfv vk cv cF cfv vk csu cabs cfv cle
      wbr cM cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cM cuz cfv vk cv cF
      cfv vk csu cabs cfv cle wbr cA cc0 c1 cioc co wcel cM cn wcel wa cP cim
      wceq cM cuz cfv vk cv cF cfv vk csu cP cfv cabs cfv cM cuz cfv vk cv cF
      cfv vk csu cim cfv cabs cfv cM cuz cfv vk cv cF cfv vk csu cabs cfv cle
      cP cim wceq cM cuz cfv vk cv cF cfv vk csu cP cfv cM cuz cfv vk cv cF cfv
      vk csu cim cfv cabs cM cuz cfv vk cv cF cfv vk csu cP cim fveq1 fveq2d
      breq1d cA cc0 c1 cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk
      csu cc wcel cM cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cM cuz cfv vk
      cv cF cfv vk csu cabs cfv cle wbr ci cA cmul co cc wcel cM cn wcel cM cuz
      cfv vk cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co
      vj vk cF cM abspef01tlub.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc
      wcel cA cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr sylan
      cM cuz cfv vk cv cF cfv vk csu absimle syl syl5bir jaoi ax-mp cA cc0 c1
      cioc co wcel cM cn wcel wa cM cuz cfv vk cv cF cfv vk csu cabs cfv ci cA
      cmul co cabs cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co
      cmul co cle wbr cM cuz cfv vk cv cF cfv vk csu cabs cfv cA cM cexp co cM
      c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr ci cA cmul co
      cc wcel ci cA cmul co cabs cfv cc0 c1 cioc co wcel wa cM cn wcel cM cuz
      cfv vk cv cF cfv vk csu cabs cfv ci cA cmul co cabs cfv cM cexp co cM c1
      caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr cA cc0 c1 cioc co
      wcel ci cA cmul co cc wcel ci cA cmul co cabs cfv cc0 c1 cioc co wcel cM
      cn wcel cM cuz cfv vk cv cF cfv vk csu cabs cfv ci cA cmul co cabs cfv cM
      cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr vy
      ci cA cmul co vj vk cF cM abspef01tlub.1 absef01tlubi 3expa cA cc0 c1
      cioc co wcel ci cA cmul co cc wcel ci cA cmul co cabs cfv cc0 c1 cioc co
      wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cc0 c1 cioc co wcel
      ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d recnd sylancr cA cc0 c1 cioc co wcel ci cA
      cmul co cabs cfv cA cc0 c1 cioc co cA cc0 c1 cioc co wcel ci cA cmul co
      cabs cfv cA cabs cfv cA cA cc0 c1 cioc co wcel ci cA cmul co cabs cfv ci
      cabs cfv cA cabs cfv cmul co c1 cA cabs cfv cmul co cA cabs cfv ci cc
      wcel cA cc wcel ci cA cmul co cabs cfv ci cabs cfv cA cabs cfv cmul co
      wceq cA cc0 c1 cioc co wcel ci cA absmul axicn cA cc0 c1 cioc co wcel cA
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr ci
      cabs cfv cA cabs cfv cmul co c1 cA cabs cfv cmul co wceq cA cc0 c1 cioc
      co wcel ci cabs cfv c1 cA cabs cfv cmul absi opreq1i a1i cA cc0 c1 cioc
      co wcel cA cabs cfv cc wcel c1 cA cabs cfv cmul co cA cabs cfv wceq cA
      cc0 c1 cioc co wcel cA cabs cfv cA cc cA cr wcel cc0 cA cle wbr cA cabs
      cfv cA wceq cA cc0 c1 cioc co wcel cA absid cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cA
      cc0 c1 cioc co wcel cc0 cr wcel cA cr wcel cc0 cA clt wbr cc0 cA cle wbr
      wi 0re cc0 cA ltle mpan cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp2d sylc sylanc
      cA cc0 c1 cioc co wcel cA cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d recnd eqeltrd cA cabs cfv mulid2 syl 3eqtrd cA cr wcel cc0 cA cle
      wbr cA cabs cfv cA wceq cA cc0 c1 cioc co wcel cA absid cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel cc0 cA clt wbr cc0 cA cle
      wbr cA cc0 c1 cioc co wcel cc0 cr wcel cA cr wcel cc0 cA clt wbr cc0 cA
      cle wbr wi 0re cc0 cA ltle mpan cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp2d sylc sylanc
      eqtrd cA cc0 c1 cioc co wcel id eqeltrd jca sylan cA cc0 c1 cioc co wcel
      cM cuz cfv vk cv cF cfv vk csu cabs cfv ci cA cmul co cabs cfv cM cexp co
      cM c1 caddc co cM cfa cfv cM cmul co cdiv co cmul co cle wbr cM cuz cfv
      vk cv cF cfv vk csu cabs cfv cA cM cexp co cM c1 caddc co cM cfa cfv cM
      cmul co cdiv co cmul co cle wbr wb cM cn wcel cA cc0 c1 cioc co wcel ci
      cA cmul co cabs cfv cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv
      co cmul co cA cM cexp co cM c1 caddc co cM cfa cfv cM cmul co cdiv co
      cmul co cM cuz cfv vk cv cF cfv vk csu cabs cfv cle cA cc0 c1 cioc co
      wcel ci cA cmul co cabs cfv cM cexp co cA cM cexp co cM c1 caddc co cM
      cfa cfv cM cmul co cdiv co cmul cA cc0 c1 cioc co wcel ci cA cmul co cabs
      cfv cA cM cexp cA cc0 c1 cioc co wcel ci cA cmul co cabs cfv cA cabs cfv
      cA cA cc0 c1 cioc co wcel ci cA cmul co cabs cfv ci cabs cfv cA cabs cfv
      cmul co c1 cA cabs cfv cmul co cA cabs cfv ci cc wcel cA cc wcel ci cA
      cmul co cabs cfv ci cabs cfv cA cabs cfv cmul co wceq cA cc0 c1 cioc co
      wcel ci cA absmul axicn cA cc0 c1 cioc co wcel cA cA cc0 c1 cioc co wcel
      cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d recnd sylancr ci cabs cfv cA cabs cfv cmul co
      c1 cA cabs cfv cmul co wceq cA cc0 c1 cioc co wcel ci cabs cfv c1 cA cabs
      cfv cmul absi opreq1i a1i cA cc0 c1 cioc co wcel cA cabs cfv cc wcel c1
      cA cabs cfv cmul co cA cabs cfv wceq cA cc0 c1 cioc co wcel cA cabs cfv
      cA cc cA cr wcel cc0 cA cle wbr cA cabs cfv cA wceq cA cc0 c1 cioc co
      wcel cA absid cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
      cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cr
      wcel cc0 cA clt wbr cc0 cA cle wbr cA cc0 c1 cioc co wcel cc0 cr wcel cA
      cr wcel cc0 cA clt wbr cc0 cA cle wbr wi 0re cc0 cA ltle mpan cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp2d sylc sylanc cA cc0 c1 cioc co wcel cA cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd eqeltrd cA cabs cfv
      mulid2 syl 3eqtrd cA cr wcel cc0 cA cle wbr cA cabs cfv cA wceq cA cc0 c1
      cioc co wcel cA absid cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA
      cr wcel cc0 cA clt wbr cc0 cA cle wbr cA cc0 c1 cioc co wcel cc0 cr wcel
      cA cr wcel cc0 cA clt wbr cc0 cA cle wbr wi 0re cc0 cA ltle mpan cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp2d sylc sylanc eqtrd opreq1d opreq1d breq2d
      adantr mpbid letrd $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)
  $}

  ${
    $d A j x y $.  $d F k x $.  $d M k x $.
    efsep.1 $e |- F = { <. j , y >. |
                    ( j e. NN0 /\ y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    efsep.2 $e |- A e. CC $.
    efsep.3 $e |- M e. NN0 $.
    efsep.4 $e |- B e. CC $.
    efsep.5 $e |- ( exp ` A ) = ( B + sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $.
    efsep.6 $e |- ( F ` M ) = C $.
    efsep.7 $e |- N = ( M + 1 ) $.
    efsep.8 $e |- D = ( B + C ) $.
    $( Separate out the next term of the power series expansion of the
       exponential function.  The last hypothesis allows the separated terms to
       be rearranged as desired.  (Contributed by Paul Chapman,
       23-Nov-2007.) $)
    efsepi $p |- ( exp ` A ) = ( D + sum_ k e. ( ZZ>= ` N ) ( F ` k ) ) $=
      cA ce cfv cB cM cF cfv caddc co cM c1 caddc co cuz cfv vk cv cF cfv vk
      csu caddc co cD cN cuz cfv vk cv cF cfv vk csu caddc co cB cM cuz cfv vk
      cv cF cfv vk csu caddc co cB cM cF cfv cM c1 caddc co cuz cfv vk cv cF
      cfv vk csu caddc co caddc co cA ce cfv cB cM cF cfv caddc co cM c1 caddc
      co cuz cfv vk cv cF cfv vk csu caddc co cM cuz cfv vk cv cF cfv vk csu cM
      cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co cB caddc cM cz
      wcel vk cv cF cfv cc wcel vk cM cuz cfv wral cM c1 caddc co caddc cop cF
      cseqz co vx cv cli wbr vx wex cM cuz cfv vk cv cF cfv vk csu cM cF cfv cM
      c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co wceq cM cn0 wcel cM cz
      wcel efsep.3 cM nn0z ax-mp vk cv cF cfv cc wcel vk cM cuz cfv vk cv cM
      cuz cfv wcel vk cv cc0 cuz cfv wcel vk cv cF cfv cc wcel cM cuz cfv cc0
      cuz cfv vk cv cM cc0 cuz cfv wcel cM cuz cfv cc0 cuz cfv wss cM cn0 cc0
      cuz cfv efsep.3 nn0uz eleqtri cc0 cM uzss ax-mp sseli cc0 cuz cfv cc vk
      cv cF cn0 cc cF wf cc0 cuz cfv cc cF wf vj vy cn0 cc cA vj cv cexp co vj
      cv cfa cfv cdiv co cF efsep.1 cA cc wcel vj cv cn0 wcel cA vj cv cexp co
      vj cv cfa cfv cdiv co cc wcel efsep.2 cA vj cv eftcl mpan fopab cn0 cc0
      cuz cfv wceq cn0 cc cF wf cc0 cuz cfv cc cF wf wb nn0uz cn0 cc0 cuz cfv
      cc cF feq2 ax-mp mpbi ffvelrni syl rgen cA cc wcel cM c1 caddc co cn wcel
      cM c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex efsep.2 cM cn0
      wcel cM c1 caddc co cn wcel efsep.3 cM nn0p1nn ax-mp vx vy cA vj cF cM c1
      caddc co efsep.1 eftlex mp2an vx vk cF cM vj vy cn0 cA vj cv cexp co vj
      cv cfa cfv cdiv co cF nn0ex efsep.1 fopabex2 isum1p mp3an opreq2i efsep.5
      cB cM cF cfv cM c1 caddc co cuz cfv vk cv cF cfv vk csu efsep.4 cM cc0
      cuz cfv wcel cM cF cfv cc wcel cM cn0 cc0 cuz cfv efsep.3 nn0uz eleqtri
      cc0 cuz cfv cc cM cF cn0 cc cF wf cc0 cuz cfv cc cF wf vj vy cn0 cc cA vj
      cv cexp co vj cv cfa cfv cdiv co cF efsep.1 cA cc wcel vj cv cn0 wcel cA
      vj cv cexp co vj cv cfa cfv cdiv co cc wcel efsep.2 cA vj cv eftcl mpan
      fopab cn0 cc0 cuz cfv wceq cn0 cc cF wf cc0 cuz cfv cc cF wf wb nn0uz cn0
      cc0 cuz cfv cc cF feq2 ax-mp mpbi ffvelrni ax-mp cM c1 caddc co cz wcel
      cM c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cM c1 caddc co
      cuz cfv vk cv cF cfv vk csu cc wcel cM c1 caddc co cn wcel cM c1 caddc co
      cz wcel cM cn0 wcel cM c1 caddc co cn wcel efsep.3 cM nn0p1nn ax-mp cM c1
      caddc co nnz ax-mp cA cc wcel cM c1 caddc co cn wcel cM c1 caddc co caddc
      cop cF cseqz co vx cv cli wbr vx wex efsep.2 cM cn0 wcel cM c1 caddc co
      cn wcel efsep.3 cM nn0p1nn ax-mp vx vy cA vj cF cM c1 caddc co efsep.1
      eftlex mp2an vx vk cF cM c1 caddc co vj vy cn0 cA vj cv cexp co vj cv cfa
      cfv cdiv co cF nn0ex efsep.1 fopabex2 isumcl mp2an addassi 3eqtr4i cD cB
      cM cF cfv caddc co cN cuz cfv vk cv cF cfv vk csu cM c1 caddc co cuz cfv
      vk cv cF cfv vk csu caddc cD cB cC caddc co cB cM cF cfv caddc co efsep.8
      cC cM cF cfv cB caddc cM cF cfv cC efsep.6 eqcomi opreq2i eqtri cN cuz
      cfv cM c1 caddc co cuz cfv vk cv cF cfv vk cN cM c1 caddc co cuz efsep.7
      fveq2i sumeq1i opreq12i eqtr4i $.
      $( [23-Nov-2007] $) $( [23-Nov-2007] $)
  $}

  ${
    $d A j k y $.  $d F k $.  $d N k $.
    effsumle.1 $e |- F =
             { <. j , y >. | ( j e. NN0 /\ y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    effsumle.2 $e |- A e. RR $.
    effsumle.3 $e |- N e. NN0 $.
    $( The partial sums of the series expansion of the exponential function of
       a nonnegative real number are bounded by the value of the function.
       (Contributed by Paul Chapman, 21-Aug-2007.) $)
    effsumlei $p |- ( 0 <_ A -> ( ( + seq0 F ) ` N ) <_ ( exp ` A ) ) $=
      cc0 cA cle wbr cc0 vk cv cF cfv cle wbr vk cc0 cuz cfv wral cN caddc cF
      cseq0 co cfv cA ce cfv cle wbr cc0 cA cle wbr cc0 vk cv cF cfv cle wbr vk
      cc0 cuz cfv vk cv cc0 cuz cfv wcel cc0 cA cle wbr cc0 vk cv cF cfv cle
      wbr vk cv cn0 wcel cc0 cA cle wbr cc0 vk cv cF cfv cle wbr vk cv cc0 cuz
      cfv wcel vk cv cn0 wcel cc0 cA cle wbr wa cc0 cA vk cv cexp co vk cv cfa
      cfv cdiv co vk cv cF cfv cle cA vk cv cexp co cr wcel cc0 cA vk cv cexp
      co cle wbr vk cv cfa cfv cr wcel cc0 vk cv cfa cfv clt wbr cc0 cA vk cv
      cexp co vk cv cfa cfv cdiv co cle wbr vk cv cn0 wcel cc0 cA cle wbr wa cA
      vk cv cexp co vk cv cfa cfv divge0 vk cv cn0 wcel cA vk cv cexp co cr
      wcel cc0 cA cle wbr cA cr wcel vk cv cn0 wcel cA vk cv cexp co cr wcel
      effsumle.2 cA vk cv reexpcl mpan adantr cA cr wcel vk cv cn0 wcel cc0 cA
      cle wbr cc0 cA vk cv cexp co cle wbr effsumle.2 cA vk cv expge0 mp3an1 vk
      cv cn0 wcel vk cv cfa cfv cr wcel cc0 cA cle wbr vk cv cn0 wcel vk cv cfa
      cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk cv cfa cfv nnre syl
      adantr vk cv cn0 wcel cc0 vk cv cfa cfv clt wbr cc0 cA cle wbr vk cv cn0
      wcel vk cv cfa cfv cn wcel cc0 vk cv cfa cfv clt wbr vk cv faccl vk cv
      cfa cfv nngt0 syl adantr syl2anc vk cv cn0 wcel vk cv cF cfv cA vk cv
      cexp co vk cv cfa cfv cdiv co wceq cc0 cA cle wbr vy cA vj cF vk cv
      effsumle.1 eftval adantr breqtrrd vk cv elnn0uz sylanbr expcom r19.21aiv
      cc0 vk cv cF cfv cle wbr vk cc0 cuz cfv wral cN cc0 caddc cop cF cseqz co
      cfv cA ce cfv cN caddc cF cseq0 co cfv cle cN cc0 cuz cfv wcel cc0 vk cv
      cF cfv cle wbr vk cc0 cuz cfv wral cN cc0 caddc cop cF cseqz co cfv cA ce
      cfv cle wbr cN cn0 cc0 cuz cfv effsumle.3 nn0uz eleqtri cA ce cfv vk cF
      cc0 cN vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex
      effsumle.1 fopabex2 cA ce fvex caddc cF cseq0 co cc0 caddc cop cF cseqz
      co cA ce cfv cli caddc cF addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv
      cdiv co cF nn0ex effsumle.1 fopabex2 seq0seqz cA cc wcel caddc cF cseq0
      co cA ce cfv cli wbr cA effsumle.2 recni vy cA vj cF effsumle.1 efcvg
      ax-mp eqbrtrri cn0 cr cF wf cc0 cuz cfv cr cF wf vj vy cn0 cr cA vj cv
      cexp co vj cv cfa cfv cdiv co cF effsumle.1 cA cr wcel vj cv cn0 wcel cA
      vj cv cexp co vj cv cfa cfv cdiv co cr wcel effsumle.2 cA vj cv reeftcl
      mpan fopab cn0 cc0 cuz cfv wceq cn0 cr cF wf cc0 cuz cfv cr cF wf wb
      nn0uz cn0 cc0 cuz cfv cr cF feq2 ax-mp mpbi climserzlei mpan cN caddc cF
      cseq0 co cc0 caddc cop cF cseqz co caddc cF addex vj vy cn0 cA vj cv cexp
      co vj cv cfa cfv cdiv co cF nn0ex effsumle.1 fopabex2 seq0seqz fveq1i
      syl5eqbr syl $.
      $( [8-Jan-2008] $) $( [21-Aug-2007] $)
  $}

  ${
    $d A j y $.
    eft0val.1 $e |- F =
             { <. j , y >. | ( j e. NN0 /\ y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    eft0val.2 $e |- A e. CC $.
    $( The value of the first term of the series expansion of the exponential
       function is 1.  (Contributed by Paul Chapman, 21-Aug-2007.) $)
    eft0vali $p |- ( F ` 0 ) = 1 $=
      cc0 cF cfv cA cc0 cexp co cc0 cfa cfv cdiv co c1 c1 cdiv co c1 cc0 cn0
      wcel cc0 cF cfv cA cc0 cexp co cc0 cfa cfv cdiv co wceq 0nn0 vy cA vj cF
      cc0 eft0val.1 eftval ax-mp cA cc0 cexp co c1 cc0 cfa cfv c1 cdiv cA cc
      wcel cA cc0 cexp co c1 wceq eft0val.2 cA exp0 ax-mp fac0 opreq12i c1
      ax1cn div1i 3eqtri $.
      $( [8-Jan-2008] $) $( [21-Aug-2007] $)
  $}

  ${
    $d A j k x y $.  $d F k $.
    ef4p.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                       y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.

    ${
      ef4p.2 $e |- A e. CC $.
      $( Separate out the first four terms of the infinite series expansion of
         the exponential function. (Contributed by Paul Chapman,
         19-Jan-2008.) $)
      ef4pi $p |- ( exp ` A ) = ( ( ( ( 1 + A ) + ( ( A ^ 2 ) / 2 ) ) +
                 ( ( A ^ 3 ) / 6 ) ) + sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) $=
        vy cA c1 cA caddc co cA c2 cexp co c2 cdiv co caddc co cA c3 cexp co c6
        cdiv co c1 cA caddc co cA c2 cexp co c2 cdiv co caddc co cA c3 cexp co
        c6 cdiv co caddc co vj vk cF c3 c4 ef4p.1 ef4p.2 c3 3nn nnnn0i c1 cA
        caddc co cA c2 cexp co c2 cdiv co c1 cA ax1cn ef4p.2 addcli cA c2 cexp
        co c2 cA ef4p.2 sqcli 2cn 2ne0 divcli addcli vy cA c1 cA caddc co cA c2
        cexp co c2 cdiv co c1 cA caddc co cA c2 cexp co c2 cdiv co caddc co vj
        vk cF c2 c3 ef4p.1 ef4p.2 2nn0 c1 cA ax1cn ef4p.2 addcli vy cA c1 cA c1
        cA caddc co vj vk cF c1 c2 ef4p.1 ef4p.2 1nn0 ax1cn vy cA cc0 c1 c1 vj
        vk cF cc0 c1 ef4p.1 ef4p.2 0nn0 0cn cA ce cfv cc0 cuz cfv vk cv cF cfv
        vk csu cc0 cc0 cuz cfv vk cv cF cfv vk csu caddc co cA ce cfv cn0 cA vk
        cv cexp co vk cv cfa cfv cdiv co vk csu cn0 vk cv cF cfv vk csu cc0 cuz
        cfv vk cv cF cfv vk csu cA cc wcel cA ce cfv cn0 cA vk cv cexp co vk cv
        cfa cfv cdiv co vk csu wceq ef4p.2 cA vk efval ax-mp cn0 vk cv cF cfv
        cA vk cv cexp co vk cv cfa cfv cdiv co vk vy cA vj cF vk cv ef4p.1
        eftval sumeq2i cn0 cc0 cuz cfv vk cv cF cfv vk nn0uz sumeq1i 3eqtr2i
        cc0 cuz cfv vk cv cF cfv vk csu cA ce cfv cc0 cuz cfv vk cv cF cfv vk
        csu cc cA ce cfv cn0 cA vk cv cexp co vk cv cfa cfv cdiv co vk csu cn0
        vk cv cF cfv vk csu cc0 cuz cfv vk cv cF cfv vk csu cA cc wcel cA ce
        cfv cn0 cA vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq ef4p.2 cA vk
        efval ax-mp cn0 vk cv cF cfv cA vk cv cexp co vk cv cfa cfv cdiv co vk
        vy cA vj cF vk cv ef4p.1 eftval sumeq2i cn0 cc0 cuz cfv vk cv cF cfv vk
        nn0uz sumeq1i 3eqtr2i cA cc wcel cA ce cfv cc wcel ef4p.2 cA efcl ax-mp
        eqeltrri addid2i eqtr4i vy cA vj cF ef4p.1 ef4p.2 eft0vali cc0 c1 caddc
        co c1 c1 ax1cn addid2i eqcomi cc0 c1 caddc co c1 c1 ax1cn addid2i
        eqcomi efsepi c1 cF cfv cA c1 cexp co c1 cfa cfv cdiv co cA c1 cdiv co
        cA c1 cn0 wcel c1 cF cfv cA c1 cexp co c1 cfa cfv cdiv co wceq 1nn0 vy
        cA vj cF c1 ef4p.1 eftval ax-mp cA c1 cexp co cA c1 cfa cfv c1 cdiv cA
        cc wcel cA c1 cexp co cA wceq ef4p.2 cA exp1 ax-mp fac1 opreq12i cA
        ef4p.2 div1i 3eqtri df-2 c1 cA caddc co eqid efsepi c2 cF cfv cA c2
        cexp co c2 cfa cfv cdiv co cA c2 cexp co c2 cdiv co c2 cn0 wcel c2 cF
        cfv cA c2 cexp co c2 cfa cfv cdiv co wceq 2nn0 vy cA vj cF c2 ef4p.1
        eftval ax-mp c2 cfa cfv c2 cA c2 cexp co cdiv fac2 opreq2i eqtri df-3
        c1 cA caddc co cA c2 cexp co c2 cdiv co caddc co eqid efsepi c3 cF cfv
        cA c3 cexp co c3 cfa cfv cdiv co cA c3 cexp co c6 cdiv co c3 cn0 wcel
        c3 cF cfv cA c3 cexp co c3 cfa cfv cdiv co wceq c3 3nn nnnn0i vy cA vj
        cF c3 ef4p.1 eftval ax-mp c3 cfa cfv c6 cA c3 cexp co cdiv fac3 opreq2i
        eqtri df-4 c1 cA caddc co cA c2 cexp co c2 cdiv co caddc co cA c3 cexp
        co c6 cdiv co caddc co eqid efsepi $.
        $( [19-Jan-2008] $) $( [19-Jan-2008] $)
    $}

    $( Separate out the first four terms of the infinite series expansion of
       the exponential function.  (Contributed by Paul Chapman,
       19-Jan-2008.) $)
    ef4p $p |- ( A e. CC -> ( exp ` A ) =
                ( ( ( ( 1 + A ) + ( ( A ^ 2 ) / 2 ) ) + ( ( A ^ 3 ) / 6 ) ) +
                  sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) $=
      cA cc wcel cA ce cfv c1 cA caddc co cA c2 cexp co c2 cdiv co caddc co cA
      c3 cexp co c6 cdiv co caddc co c4 cuz cfv vk cv cF cfv vk csu caddc co
      wceq cA cc wcel cA cc0 cif ce cfv c1 cA cc wcel cA cc0 cif caddc co cA cc
      wcel cA cc0 cif c2 cexp co c2 cdiv co caddc co cA cc wcel cA cc0 cif c3
      cexp co c6 cdiv co caddc co c4 cuz cfv vk cv vj cv cn0 wcel vy cv cA cc
      wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cfv vk csu caddc co wceq cA cc0 cA cA cc wcel cA cc0 cif wceq cA ce cfv
      cA cc wcel cA cc0 cif ce cfv c1 cA caddc co cA c2 cexp co c2 cdiv co
      caddc co cA c3 cexp co c6 cdiv co caddc co c4 cuz cfv vk cv cF cfv vk csu
      caddc co c1 cA cc wcel cA cc0 cif caddc co cA cc wcel cA cc0 cif c2 cexp
      co c2 cdiv co caddc co cA cc wcel cA cc0 cif c3 cexp co c6 cdiv co caddc
      co c4 cuz cfv vk cv vj cv cn0 wcel vy cv cA cc wcel cA cc0 cif vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk csu caddc co cA cA cc
      wcel cA cc0 cif ce fveq2 cA cA cc wcel cA cc0 cif wceq c1 cA caddc co cA
      c2 cexp co c2 cdiv co caddc co cA c3 cexp co c6 cdiv co caddc co c1 cA cc
      wcel cA cc0 cif caddc co cA cc wcel cA cc0 cif c2 cexp co c2 cdiv co
      caddc co cA cc wcel cA cc0 cif c3 cexp co c6 cdiv co caddc co c4 cuz cfv
      vk cv cF cfv vk csu c4 cuz cfv vk cv vj cv cn0 wcel vy cv cA cc wcel cA
      cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk
      csu caddc cA cA cc wcel cA cc0 cif wceq c1 cA caddc co cA c2 cexp co c2
      cdiv co caddc co c1 cA cc wcel cA cc0 cif caddc co cA cc wcel cA cc0 cif
      c2 cexp co c2 cdiv co caddc co cA c3 cexp co c6 cdiv co cA cc wcel cA cc0
      cif c3 cexp co c6 cdiv co caddc cA cA cc wcel cA cc0 cif wceq c1 cA caddc
      co c1 cA cc wcel cA cc0 cif caddc co cA c2 cexp co c2 cdiv co cA cc wcel
      cA cc0 cif c2 cexp co c2 cdiv co caddc cA cA cc wcel cA cc0 cif c1 caddc
      opreq2 cA cA cc wcel cA cc0 cif wceq cA c2 cexp co cA cc wcel cA cc0 cif
      c2 cexp co c2 cdiv cA cA cc wcel cA cc0 cif c2 cexp opreq1 opreq1d
      opreq12d cA cA cc wcel cA cc0 cif wceq cA c3 cexp co cA cc wcel cA cc0
      cif c3 cexp co c6 cdiv cA cA cc wcel cA cc0 cif c3 cexp opreq1 opreq1d
      opreq12d cA cA cc wcel cA cc0 cif wceq c4 cuz cfv vk cv cF cfv vk cv vj
      cv cn0 wcel vy cv cA cc wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab cfv vk cA cA cc wcel cA cc0 cif wceq vk cv cF vj
      cv cn0 wcel vy cv cA cc wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab cA cA cc wcel cA cc0 cif wceq vj cv cn0 wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel
      vy cv cA cc wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa
      vj vy copab cF cA cA cc wcel cA cc0 cif wceq vj cv cn0 wcel vy cv cA vj
      cv cexp co vj cv cfa cfv cdiv co wceq wa vj cv cn0 wcel vy cv cA cc wcel
      cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy cA cA cc
      wcel cA cc0 cif wceq vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq vy
      cv cA cc wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq vj cv
      cn0 wcel cA cA cc wcel cA cc0 cif wceq cA vj cv cexp co vj cv cfa cfv
      cdiv co cA cc wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv co vy cv
      cA cA cc wcel cA cc0 cif wceq cA vj cv cexp co cA cc wcel cA cc0 cif vj
      cv cexp co vj cv cfa cfv cdiv cA cA cc wcel cA cc0 cif vj cv cexp opreq1
      opreq1d eqeq2d anbi2d opabbidv ef4p.1 syl5eq fveq1d sumeq2sdv opreq12d
      eqeq12d vy cA cc wcel cA cc0 cif vj vk vj cv cn0 wcel vy cv cA cc wcel cA
      cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0
      wcel vy cv cA cc wcel cA cc0 cif vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab eqid cA cc0 cc 0cn elimel ef4pi dedth $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)
  $}

  ${
    $d A j y $.
    efge1.1 $e |- A e. RR $.
    $( The exponential function of a nonnegative real number is greater than or
       equal to 1.  (Contributed by Paul Chapman, 21-Aug-2007.) $)
    efge1i $p |- ( 0 <_ A -> 1 <_ ( exp ` A ) ) $=
      cc0 cA cle wbr cc0 caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cseq0 co cfv cA ce cfv c1 cle vy cA vj vj
      cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cc0 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab eqid efge1.1 0nn0 effsumlei cc0 caddc vj cv cn0 wcel
      vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cseq0 co
      cfv cc0 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab cfv c1 caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab addex vj vy cn0 cA vj cv cexp co vj
      cv cfa cfv cdiv co nn0ex opabex2 seq00 vy cA vj vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid cA
      efge1.1 recni eft0vali eqtr2i syl5eqbr $.
      $( [8-Jan-2008] $) $( [21-Aug-2007] $)

    $( The exponential function of a nonnegative real number is greater than
       or equal to 1 plus that number.  (Contributed by Paul Chapman,
       18-Oct-2007.) $)
    efge1pi $p |- ( 0 <_ A -> ( 1 + A ) <_ ( exp ` A ) ) $=
      cc0 cA cle wbr c1 caddc vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cseq0 co cfv cA ce cfv c1 cA caddc co cle
      vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab c1 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab eqid efge1.1 1nn0 effsumlei c1 caddc vj cv
      cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      cseq0 co cfv cc0 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab cfv c1 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab cfv caddc co c1 cA caddc co caddc vj
      cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co nn0ex
      opabex2 seq01 cc0 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cfv c1 c1 vj cv cn0 wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA caddc vy cA vj vj cv
      cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab
      vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab eqid cA efge1.1 recni eft0vali c1 vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA c1 cexp co c1
      cfa cfv cdiv co cA c1 cdiv co cA c1 cn0 wcel c1 vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA c1 cexp co
      c1 cfa cfv cdiv co wceq 1nn0 vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab c1 vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid eftval ax-mp
      cA c1 cexp co cA c1 cfa cfv c1 cdiv cA cc wcel cA c1 cexp co cA wceq cA
      efge1.1 recni cA exp1 ax-mp fac1 opreq12i cA cA efge1.1 recni div1i
      3eqtri opreq12i eqtr2i syl5eqbr $.
      $( [8-Jan-2008] $) $( [18-Oct-2007] $)

    $( The exponential function of a positive real number is greater than 1.
       (Contributed by Paul Chapman, 21-Aug-2007.) $)
    efgt1i $p |- ( 0 < A -> 1 < ( exp ` A ) ) $=
      c1 c1 cA caddc co clt wbr c1 cA caddc co cA ce cfv cle wbr c1 cA ce cfv
      clt wbr cc0 cA clt wbr c1 c1 cA caddc co cA ce cfv 1re c1 cA 1re efge1.1
      readdcli cA efge1.1 reefcli ltletri cc0 cA clt wbr c1 c1 cA caddc co clt
      wbr cA c1 efge1.1 1re ltaddposi biimpi cc0 cA clt wbr cc0 cA cle wbr c1
      cA caddc co cA ce cfv cle wbr cc0 cA 0re efge1.1 ltlei cA efge1.1 efge1pi
      syl sylanc $.
      $( [21-Aug-2007] $) $( [21-Aug-2007] $)

    $( The exponential function of a real number is greater than 0.
       (Contributed by Paul Chapman, 21-Aug-2007.) $)
    efgt0i $p |- 0 < ( exp ` A ) $=
      cc0 cA clt wbr cc0 cA wceq wo cA cc0 clt wbr wo cc0 cA ce cfv clt wbr cc0
      cA cle wbr cA cc0 clt wbr wo cc0 cA clt wbr cc0 cA wceq wo cA cc0 clt wbr
      wo cc0 cr wcel cA cr wcel cc0 cA cle wbr cA cc0 clt wbr wo 0re efge1.1
      cc0 cA lelttric mp2an cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cA cc0
      clt wbr cc0 cA 0re efge1.1 leloei orbi1i mpbi cc0 cA clt wbr cc0 cA wceq
      wo cc0 cA ce cfv clt wbr cA cc0 clt wbr cc0 cA clt wbr cc0 cA ce cfv clt
      wbr cc0 cA wceq cc0 c1 clt wbr c1 cA ce cfv clt wbr cc0 cA ce cfv clt wbr
      cc0 cA clt wbr cc0 c1 cA ce cfv 0re 1re cA efge1.1 reefcli lttri lt01 cA
      efge1.1 efgt1i sylancr cc0 cA ce cfv clt wbr cA cc0 cA cc0 wceq c1 cA ce
      cfv cc0 clt cA cc0 wceq cA ce cfv cc0 ce cfv c1 cA cc0 ce fveq2 ef0
      syl6eq lt01 syl5breqr eqcoms jaoi cA cc0 clt wbr cc0 cA cneg clt wbr cc0
      cA ce cfv clt wbr cA cr wcel cA cc0 clt wbr cc0 cA cneg clt wbr wb
      efge1.1 cA lt0neg1 ax-mp cc0 cA cneg ce cfv cle wbr cc0 cA ce cfv cA cneg
      ce cfv cmul co clt wbr cc0 cA ce cfv clt wbr cc0 cA cneg clt wbr cA ce
      cfv cr wcel cA cneg ce cfv cr wcel cc0 cA cneg ce cfv cle wbr cc0 cA ce
      cfv cA cneg ce cfv cmul co clt wbr wa cc0 cA ce cfv clt wbr cA efge1.1
      reefcli cA cneg cA efge1.1 renegcli reefcli cA ce cfv cA cneg ce cfv
      prodgt02 mpanl12 cc0 cA cneg clt wbr cc0 c1 clt wbr c1 cA cneg ce cfv clt
      wbr wa cc0 cA cneg ce cfv clt wbr cc0 cA cneg ce cfv cle wbr cc0 cA cneg
      clt wbr c1 cA cneg ce cfv clt wbr cc0 c1 clt wbr cA cneg cA efge1.1
      renegcli efgt1i lt01 jctil cc0 c1 cA cneg ce cfv 0re 1re cA cneg cA
      efge1.1 renegcli reefcli lttri cc0 cA cneg ce cfv 0re cA cneg cA efge1.1
      renegcli reefcli ltlei 3syl cc0 c1 cA ce cfv cA cneg ce cfv cmul co clt
      lt01 cA cc wcel cA ce cfv cA cneg ce cfv cmul co c1 wceq cA efge1.1 recni
      cA efcan ax-mp breqtrri sylancl sylbi jaoi ax-mp $.
      $( [21-Aug-2007] $) $( [21-Aug-2007] $)
  $}

  $( The exponential function of a real number is greater than 0.
     (Contributed by Paul Chapman, 13-Sep-2007.) $)
  efgt0 $p |- ( A e. RR -> 0 < ( exp ` A ) ) $=
    cA cr wcel cc0 cA ce cfv clt wbr cc0 cA cr wcel cA cc0 cif ce cfv clt wbr
    cA cc0 cA cA cr wcel cA cc0 cif wceq cA ce cfv cA cr wcel cA cc0 cif ce cfv
    cc0 clt cA cA cr wcel cA cc0 cif ce fveq2 breq2d cA cr wcel cA cc0 cif cA
    cc0 cr 0re elimel efgt0i dedth $.
    $( [14-Sep-2007] $) $( [13-Sep-2007] $)

  ${
    eflt.1 $e |- A e. RR $.
    eflt.2 $e |- B e. RR $.
    $( The exponential function on the reals is strictly monotonic.
       (Contributed by Paul Chapman, 21-Aug-2007.) $)
    eflti $p |- ( A < B -> ( exp ` A ) < ( exp ` B ) ) $=
      cA cB clt wbr cc0 cB cA cmin co clt wbr cA ce cfv cB ce cfv clt wbr cA cB
      eflt.1 eflt.2 posdifi cc0 cB cA cmin co clt wbr cA ce cfv c1 cmul co cB
      ce cfv cA ce cfv clt cc0 cB cA cmin co clt wbr cA ce cfv c1 cmul co cA ce
      cfv cB cA cmin co ce cfv cmul co cB ce cfv clt cc0 cB cA cmin co clt wbr
      c1 cB cA cmin co ce cfv clt wbr cA ce cfv c1 cmul co cA ce cfv cB cA cmin
      co ce cfv cmul co clt wbr cB cA cmin co cB cA eflt.2 eflt.1 resubcli
      efgt1i c1 cr wcel cB cA cmin co ce cfv cr wcel cA ce cfv cr wcel w3a cc0
      cA ce cfv clt wbr c1 cB cA cmin co ce cfv clt wbr cA ce cfv c1 cmul co cA
      ce cfv cB cA cmin co ce cfv cmul co clt wbr wb c1 cr wcel cB cA cmin co
      ce cfv cr wcel cA ce cfv cr wcel 1re cB cA cmin co cB cA eflt.2 eflt.1
      resubcli reefcli cA eflt.1 reefcli 3pm3.2i cA eflt.1 efgt0i c1 cB cA cmin
      co ce cfv cA ce cfv ltmul2OLD mp2an sylib cA cB cA cmin co caddc co ce
      cfv cB ce cfv cA ce cfv cB cA cmin co ce cfv cmul co cA cB cA cmin co
      caddc co cB ce cA cB cA eflt.1 recni cB eflt.2 recni pncan3i fveq2i cA cB
      cA cmin co cA eflt.1 recni cB cA cmin co cB cA eflt.2 eflt.1 resubcli
      recni efaddi eqtr3i syl6breqr cA ce cfv cA ce cfv cA eflt.1 reefcli recni
      mulid1i syl5eqbrr sylbi $.
      $( [21-Aug-2007] $) $( [21-Aug-2007] $)

    $( The exponential function on the reals is strictly monotonic.
       (Contributed by Steve Rodriguez, 22-Aug-2007.) $)
    efltbi $p |- ( A < B <-> ( exp ` A ) < ( exp ` B ) ) $=
      cA cB clt wbr cA ce cfv cB ce cfv clt wbr cA cB eflt.1 eflt.2 eflti cA cB
      clt wbr cA ce cfv cB ce cfv clt wbr cB cA cle wbr cB ce cfv cA ce cfv cle
      wbr cA cB clt wbr wn cA ce cfv cB ce cfv clt wbr wn cB cA clt wbr cB cA
      wceq wo cB ce cfv cA ce cfv clt wbr cB ce cfv cA ce cfv wceq wo cB cA cle
      wbr cB ce cfv cA ce cfv cle wbr cB cA clt wbr cB ce cfv cA ce cfv clt wbr
      cB cA wceq cB ce cfv cA ce cfv wceq cB cA eflt.2 eflt.1 eflti cB cA ce
      fveq2 orim12i cB cA eflt.2 eflt.1 leloei cB ce cfv cA ce cfv cB eflt.2
      reefcli cA eflt.1 reefcli leloei 3imtr4i cB cA eflt.2 eflt.1 lenlti cB ce
      cfv cA ce cfv cB eflt.2 reefcli cA eflt.1 reefcli lenlti 3imtr3i con4i
      impbii $.
      $( [22-Aug-2007] $) $( [21-Aug-2007] $)

    $( The exponential function on real numbers is one-to-one.  (Contributed by
       Steve Rodriguez, 25-Aug-2007.) $)
    reef11i $p |- ( ( exp ` A ) = ( exp ` B ) <-> A = B ) $=
      cA cB clt wbr wn cB cA clt wbr wn wa cA ce cfv cB ce cfv clt wbr wn cB ce
      cfv cA ce cfv clt wbr wn wa cA cB wceq cA ce cfv cB ce cfv wceq cA cB clt
      wbr wn cA ce cfv cB ce cfv clt wbr wn cB cA clt wbr wn cB ce cfv cA ce
      cfv clt wbr wn cA cB clt wbr cA ce cfv cB ce cfv clt wbr cA cB eflt.1
      eflt.2 efltbi notbii cB cA clt wbr cB ce cfv cA ce cfv clt wbr cB cA
      eflt.2 eflt.1 efltbi notbii anbi12i cA cB eflt.1 eflt.2 lttri3i cA ce cfv
      cB ce cfv cA eflt.1 reefcli cB eflt.2 reefcli lttri3i 3bitr4ri $.
      $( [25-Aug-2007] $) $( [24-Aug-2007] $)
  $}

  $( The exponential function on real numbers is one-to-one. $)
  reef11 $p |- ( ( A e. RR /\ B e. RR )
        -> ( ( exp ` A ) = ( exp ` B ) <-> A = B ) ) $=
    cA cr wcel cB cr wcel cA ce cfv cB ce cfv wceq cA cB wceq wb cA cr wcel cA
    cc0 cif ce cfv cB ce cfv wceq cA cr wcel cA cc0 cif cB wceq wb cA cr wcel
    cA cc0 cif ce cfv cB cr wcel cB cc0 cif ce cfv wceq cA cr wcel cA cc0 cif
    cB cr wcel cB cc0 cif wceq wb cA cB cc0 cc0 cA cA cr wcel cA cc0 cif wceq
    cA ce cfv cB ce cfv wceq cA cr wcel cA cc0 cif ce cfv cB ce cfv wceq cA cB
    wceq cA cr wcel cA cc0 cif cB wceq cA cA cr wcel cA cc0 cif wceq cA ce cfv
    cA cr wcel cA cc0 cif ce cfv cB ce cfv cA cA cr wcel cA cc0 cif ce fveq2
    eqeq1d cA cA cr wcel cA cc0 cif cB eqeq1 bibi12d cB cB cr wcel cB cc0 cif
    wceq cA cr wcel cA cc0 cif ce cfv cB ce cfv wceq cA cr wcel cA cc0 cif ce
    cfv cB cr wcel cB cc0 cif ce cfv wceq cA cr wcel cA cc0 cif cB wceq cA cr
    wcel cA cc0 cif cB cr wcel cB cc0 cif wceq cB cB cr wcel cB cc0 cif wceq cB
    ce cfv cB cr wcel cB cc0 cif ce cfv cA cr wcel cA cc0 cif ce cfv cB cB cr
    wcel cB cc0 cif ce fveq2 eqeq2d cB cB cr wcel cB cc0 cif cA cr wcel cA cc0
    cif eqeq2 bibi12d cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re
    elimel cB cc0 cr 0re elimel reef11i dedth2h $.
    $( [22-Aug-2008] $) $( [21-Aug-2008] $)

  ${
    $d k x y $.
    $( The exponential function maps real arguments one-to-one to positive
       reals.  (Contributed by Steve Rodriguez, 25-Aug-2007.) $)
    reeff1 $p |- ( exp |` RR ) : RR -1-1-> ( 0 (,) +oo ) $=
      cr cc0 cpnf cioo co ce cr cres wf1 cr cc0 cpnf cioo co ce cr cres wf vx
      cv ce cr cres cfv vy cv ce cr cres cfv wceq vx cv vy cv wceq wi vy cr
      wral vx cr wral vx vy cr cc0 cpnf cioo co ce cr cres dff13 vx vy cr cc0
      cpnf cioo co cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu ce cr
      cres ce cr cres vx cv cc wcel vy cv cn0 vx cv vk cv cexp co vk cv cfa cfv
      cdiv co vk csu wceq wa vx vy copab cr cres vx cv cr wcel vy cv cn0 vx cv
      vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa vx vy copab ce vx cv
      cc wcel vy cv cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq
      wa vx vy copab wceq ce cr cres vx cv cc wcel vy cv cn0 vx cv vk cv cexp
      co vk cv cfa cfv cdiv co vk csu wceq wa vx vy copab cr cres wceq vx vy vk
      df-ef ce vx cv cc wcel vy cv cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv
      co vk csu wceq wa vx vy copab cr reseq1 ax-mp cr cc wss vx cv cc wcel vy
      cv cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq wa vx vy
      copab cr cres vx cv cr wcel vy cv cn0 vx cv vk cv cexp co vk cv cfa cfv
      cdiv co vk csu wceq wa vx vy copab wceq axresscn vy cv cn0 vx cv vk cv
      cexp co vk cv cfa cfv cdiv co vk csu wceq vx vy cr cc resopab2 ax-mp
      eqtri cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu cc0 cpnf cioo
      co wcel cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu cr wcel cc0
      cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu clt wbr vx cv cr
      wcel cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu repos vx cv cr
      wcel vx cv ce cfv cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu cr
      vx cv cr wcel vx cv cc wcel vx cv ce cfv cn0 vx cv vk cv cexp co vk cv
      cfa cfv cdiv co vk csu wceq vx cv recn vx cv vk efval syl vx cv reefcl
      eqeltrrd vx cv cr wcel cc0 vx cv ce cfv cn0 vx cv vk cv cexp co vk cv cfa
      cfv cdiv co vk csu clt vx cv efgt0 vx cv cr wcel vx cv cc wcel vx cv ce
      cfv cn0 vx cv vk cv cexp co vk cv cfa cfv cdiv co vk csu wceq vx cv recn
      vx cv vk efval syl breqtrd sylanbrc fopab vx cv ce cr cres cfv vy cv ce
      cr cres cfv wceq vx cv vy cv wceq wi vx vy cr vx cv cr wcel vy cv cr wcel
      wa vx cv ce cr cres cfv vy cv ce cr cres cfv wceq vx cv ce cfv vy cv ce
      cfv wceq vx cv vy cv wceq vx cv cr wcel vy cv cr wcel vx cv ce cr cres
      cfv vx cv ce cfv vy cv ce cr cres cfv vy cv ce cfv vx cv cr ce fvres vy
      cv cr ce fvres eqeqan12d vx cv cr wcel vy cv cr wcel wa vx cv ce cfv vy
      cv ce cfv wceq vx cv vy cv wceq vx cv vy cv reef11 biimpd sylbid rgen2a
      mpbir2an $.
      $( [25-Aug-2007] $) $( [25-Aug-2007] $)
  $}

  ${
    $d A j y $.
    efm1lim.1 $e |- F = { <. j , y >. |
                          ( j e. NN0 /\ y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    efm1lim.2 $e |- A e. CC $.
    $( Series convergence to the exponential function minus 1.  (Contributed
       by Paul Chapman, 11-Sep-2007.) $)
    efm1limi $p |- ( <. 1 , + >. seq F ) ~~> ( ( exp ` A ) - 1 ) $=
      cc0 c1 caddc co caddc cop cF cseqz co cA ce cfv cc0 cc0 caddc cop cF
      cseqz co cfv cmin co c1 caddc cop cF cseqz co cA ce cfv c1 cmin co cli
      cc0 cc0 cuz cfv wcel cc0 c1 caddc co caddc cop cF cseqz co cA ce cfv cc0
      cc0 caddc cop cF cseqz co cfv cmin co cli wbr cc0 cn0 cc0 cuz cfv 0nn0
      nn0uz eleqtri cA ce cfv cF cc0 cc0 vj vy cn0 cA vj cv cexp co vj cv cfa
      cfv cdiv co cF nn0ex efm1lim.1 fopabex2 cA ce fvex caddc cF cseq0 co cc0
      caddc cop cF cseqz co cA ce cfv cli caddc cF addex vj vy cn0 cA vj cv
      cexp co vj cv cfa cfv cdiv co cF nn0ex efm1lim.1 fopabex2 seq0seqz cA cc
      wcel caddc cF cseq0 co cA ce cfv cli wbr efm1lim.2 vy cA vj cF efm1lim.1
      efcvg ax-mp eqbrtrri cn0 cc cF wf cc0 cuz cfv cc cF wf vj vy cn0 cc cA vj
      cv cexp co vj cv cfa cfv cdiv co cF efm1lim.1 cA cc wcel vj cv cn0 wcel
      cA vj cv cexp co vj cv cfa cfv cdiv co cc wcel efm1lim.2 cA vj cv eftcl
      mpan fopab cn0 cc0 cuz cfv wceq cn0 cc cF wf cc0 cuz cfv cc cF wf wb
      nn0uz cn0 cc0 cuz cfv cc cF feq2 ax-mp mpbi clim2serzi ax-mp cc0 c1 caddc
      co caddc cop c1 caddc cop cF cseqz cc0 c1 caddc co c1 caddc c1 ax1cn
      addid2i opeq1i opreq1i cc0 cc0 caddc cop cF cseqz co cfv c1 cA ce cfv
      cmin cc0 cc0 caddc cop cF cseqz co cfv cc0 cF cfv c1 cc0 cz wcel cc0 cc0
      caddc cop cF cseqz co cfv cc0 cF cfv wceq 0z caddc cF cc0 addex vj vy cn0
      cA vj cv cexp co vj cv cfa cfv cdiv co cF nn0ex efm1lim.1 fopabex2 seqz1
      ax-mp vy cA vj cF efm1lim.1 efm1lim.2 eft0vali eqtri opreq2i 3brtr3i $.
      $( [8-Jan-2008] $) $( [11-Sep-2007] $)
  $}

  ${
    $d A j k y $.
    absefm1le.1 $e |- A e. CC $.
    $( The absolute value of the exponential function minus 1 is less than or
       equal to the exponential function minus 1 of the absolute value.
       (Contributed by Paul Chapman, 11-Sep-2007.) $)
    absefm1lei $p |- ( abs ` ( ( exp ` A ) - 1 ) ) <_
                    ( ( exp ` ( abs ` A ) ) - 1 ) $=
      cA ce cfv c1 cmin co cA cabs cfv ce cfv c1 cmin co vk vj cv cn0 wcel vy
      cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab vj cv cn0
      wcel vy cv cA cabs cfv vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab c1 cA ce cfv c1 cmin oprex cA cabs cfv ce cfv c1 cmin oprex vj vy
      cn0 cA vj cv cexp co vj cv cfa cfv cdiv co nn0ex opabex2 vj vy cn0 cA
      cabs cfv vj cv cexp co vj cv cfa cfv cdiv co nn0ex opabex2 1z vk cv c1
      cuz cfv wcel vk cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab cfv cc wcel vk cv vj cv cn0 wcel vy cv cA
      cabs cfv vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv vk
      cv vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj
      vy copab cfv cabs cfv wceq vk cv c1 cuz cfv wcel vk cv cn0 wcel vk cv vj
      cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy
      copab cfv cc wcel vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk
      cv elnnuz vk cv nnnn0 sylbir vk cv cn0 wcel vk cv vj cv cn0 wcel vy cv cA
      vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA vk cv cexp
      co vk cv cfa cfv cdiv co cc vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab vk cv vj cv cn0 wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid eftval cA
      cc wcel vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv cdiv co cc wcel
      absefm1le.1 cA vk cv eftcl mpan eqeltrd syl vk cv c1 cuz cfv wcel vk cv
      cn0 wcel vk cv vj cv cn0 wcel vy cv cA cabs cfv vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab cfv vk cv vj cv cn0 wcel vy cv cA vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cabs cfv wceq vk cv
      c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0
      sylbir vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv cdiv co cabs cfv cA
      cabs cfv vk cv cexp co vk cv cfa cfv cdiv co vk cv vj cv cn0 wcel vy cv
      cA vj cv cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cabs cfv
      vk cv vj cv cn0 wcel vy cv cA cabs cfv vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab cfv vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv
      cdiv co cabs cfv cA vk cv cexp co cabs cfv vk cv cfa cfv cabs cfv cdiv co
      cA cabs cfv vk cv cexp co vk cv cfa cfv cdiv co cA vk cv cexp co cc wcel
      vk cv cfa cfv cc wcel vk cv cfa cfv cc0 wne cA vk cv cexp co vk cv cfa
      cfv cdiv co cabs cfv cA vk cv cexp co cabs cfv vk cv cfa cfv cabs cfv
      cdiv co wceq vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv absdiv cA cc
      wcel vk cv cn0 wcel cA vk cv cexp co cc wcel absefm1le.1 cA vk cv expcl
      mpan vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel vk cv cfa
      cfv cc wcel vk cv faccl vk cv cfa cfv nnre vk cv cfa cfv recn 3syl vk cv
      facne0 syl3anc vk cv cn0 wcel cA vk cv cexp co cabs cfv cA cabs cfv vk cv
      cexp co vk cv cfa cfv cabs cfv vk cv cfa cfv cdiv cA cc wcel vk cv cn0
      wcel cA vk cv cexp co cabs cfv cA cabs cfv vk cv cexp co wceq absefm1le.1
      cA vk cv absexp mpan vk cv cfa cfv cr wcel cc0 vk cv cfa cfv cle wbr vk
      cv cfa cfv cabs cfv vk cv cfa cfv wceq vk cv cn0 wcel vk cv cfa cfv absid
      vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel vk cv faccl vk
      cv cfa cfv nnre syl vk cv cfa cfv cr wcel cc0 vk cv cfa cfv clt wbr cc0
      vk cv cfa cfv cle wbr vk cv cn0 wcel cc0 cr wcel vk cv cfa cfv cr wcel
      cc0 vk cv cfa cfv clt wbr cc0 vk cv cfa cfv cle wbr wi 0re cc0 vk cv cfa
      cfv ltle mpan vk cv cn0 wcel vk cv cfa cfv cn wcel vk cv cfa cfv cr wcel
      vk cv faccl vk cv cfa cfv nnre syl vk cv cn0 wcel vk cv cfa cfv cn wcel
      cc0 vk cv cfa cfv clt wbr vk cv faccl vk cv cfa cfv nngt0 syl sylc sylanc
      opreq12d eqtrd vk cv cn0 wcel vk cv vj cv cn0 wcel vy cv cA vj cv cexp co
      vj cv cfa cfv cdiv co wceq wa vj vy copab cfv cA vk cv cexp co vk cv cfa
      cfv cdiv co cabs vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab vk cv vj cv cn0 wcel vy cv cA vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid eftval fveq2d vy cA
      cabs cfv vj vj cv cn0 wcel vy cv cA cabs cfv vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab vk cv vj cv cn0 wcel vy cv cA cabs cfv vj cv
      cexp co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid eftval 3eqtr4rd
      syl jca vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv
      co wceq wa vj vy copab vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa
      cfv cdiv co wceq wa vj vy copab eqid absefm1le.1 efm1limi vy cA cabs cfv
      vj vj cv cn0 wcel vy cv cA cabs cfv vj cv cexp co vj cv cfa cfv cdiv co
      wceq wa vj vy copab vj cv cn0 wcel vy cv cA cabs cfv vj cv cexp co vj cv
      cfa cfv cdiv co wceq wa vj vy copab eqid cA cabs cfv cA absefm1le.1
      abscli recni efm1limi iserzabsi $.
      $( [8-Jan-2008] $) $( [11-Sep-2007] $)
  $}

  ${
    eflegeolem1.1 $e |- A e. RR $.
    eflegeolem1.2 $e |- 0 <_ A $.
    $( Lemma for ~ eflegeoi . $)
    eflegeolem1 $p |- ( K e. NN0 -> ( ( A ^ K ) / ( ! ` K ) ) <_ ( A ^ K ) ) $=
      cK cn0 wcel cA cK cexp co cK cfa cfv cdiv co cA cK cexp co cle wbr cA cK
      cexp co cA cK cexp co cK cfa cfv cmul co cle wbr cA cK cexp co cr wcel cK
      cfa cfv cr wcel cc0 cA cK cexp co cle wbr c1 cK cfa cfv cle wbr cA cK
      cexp co cA cK cexp co cK cfa cfv cmul co cle wbr cK cn0 wcel cA cK cexp
      co cK cfa cfv lemulge11 cA cr wcel cK cn0 wcel cA cK cexp co cr wcel
      eflegeolem1.1 cA cK reexpcl mpan cK cn0 wcel cK cfa cfv cn wcel cK cfa
      cfv cr wcel cK faccl cK cfa cfv nnre syl cA cr wcel cK cn0 wcel cc0 cA
      cle wbr cc0 cA cK cexp co cle wbr eflegeolem1.1 eflegeolem1.2 cA cK
      expge0 mp3an13 cK cn0 wcel cK cfa cfv cn wcel c1 cK cfa cfv cle wbr cK
      faccl cK cfa cfv nnge1 syl syl2anc cA cK cexp co cr wcel cK cfa cfv cr
      wcel cA cK cexp co cr wcel w3a cc0 cK cfa cfv clt wbr cA cK cexp co cK
      cfa cfv cdiv co cA cK cexp co cle wbr cA cK cexp co cA cK cexp co cK cfa
      cfv cmul co cle wbr wb cK cn0 wcel cA cK cexp co cK cfa cfv cA cK cexp co
      ledivmul2OLD cK cn0 wcel cA cK cexp co cr wcel cK cfa cfv cr wcel cA cK
      cexp co cr wcel cA cr wcel cK cn0 wcel cA cK cexp co cr wcel
      eflegeolem1.1 cA cK reexpcl mpan cK cn0 wcel cK cfa cfv cn wcel cK cfa
      cfv cr wcel cK faccl cK cfa cfv nnre syl cA cr wcel cK cn0 wcel cA cK
      cexp co cr wcel eflegeolem1.1 cA cK reexpcl mpan 3jca cK cn0 wcel cK cfa
      cfv cn wcel cc0 cK cfa cfv clt wbr cK faccl cK cfa cfv nngt0 syl sylanc
      mpbird $.
      $( [13-Sep-2007] $) $( [11-Sep-2007] $)
  $}

  ${
    $d A j y $.  $d F k n $.  $d G k n $.  $d j k y $.
    eflegeolem2.1 $e |- A e. RR $.
    eflegeolem2.2 $e |- ( 0 <_ A /\ A < 1 ) $.
    eflegeolem2.3 $e |- F = { <. j , y >. | ( j e. NN0 /\
                           y = ( ( A ^ j ) / ( ! ` j ) ) ) } $.
    eflegeolem2.4 $e |- G = { <. j , y >. | ( j e. NN0 /\
                           y = ( A ^ j ) ) } $.
    $( Lemma for ~ eflegeoi . $)
    eflegeolem2 $p |- ( exp ` A ) <_ ( 1 / ( 1 - A ) ) $=
      cc0 caddc cop cF cseqz co cA ce cfv cli wbr cc0 caddc cop cG cseqz co c1
      c1 cA cmin co cdiv co cli wbr wa cc0 cz wcel vn cv cc0 caddc cop cF cseqz
      co cfv cr wcel vn cv cc0 caddc cop cG cseqz co cfv cr wcel vn cv cc0
      caddc cop cF cseqz co cfv vn cv cc0 caddc cop cG cseqz co cfv cle wbr w3a
      vn cc0 cuz cfv wral wa cA ce cfv c1 c1 cA cmin co cdiv co cle wbr cc0
      caddc cop cF cseqz co cA ce cfv cli wbr cc0 caddc cop cG cseqz co c1 c1
      cA cmin co cdiv co cli wbr caddc cF cseq0 co cc0 caddc cop cF cseqz co cA
      ce cfv cli caddc cF addex vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv
      co cF nn0ex eflegeolem2.3 fopabex2 seq0seqz cA cc wcel caddc cF cseq0 co
      cA ce cfv cli wbr cA eflegeolem2.1 recni vy cA vj cF eflegeolem2.3 efcvg
      ax-mp eqbrtrri caddc cG cseq0 co cc0 caddc cop cG cseqz co c1 c1 cA cmin
      co cdiv co cli caddc cG addex vj vy cn0 cA vj cv cexp co cG nn0ex
      eflegeolem2.4 fopabex2 seq0seqz vy cA vj cG eflegeolem2.4 cA
      eflegeolem2.1 recni cA cabs cfv c1 clt wbr c1 cneg cA clt wbr cA c1 clt
      wbr cA c1 eflegeolem2.1 1re abslti c1 cneg cc0 clt wbr cc0 cA cle wbr c1
      cneg cA clt wbr cc0 c1 clt wbr c1 cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1
      clt wbr c1 cneg cc0 clt wbr wb 1re c1 lt0neg2 ax-mp mpbi cc0 cA cle wbr
      cA c1 clt wbr eflegeolem2.2 pm3.26i c1 cneg cc0 cA c1 1re renegcli 0re
      eflegeolem2.1 ltletri mp2an cc0 cA cle wbr cA c1 clt wbr eflegeolem2.2
      pm3.27i mpbir2an geolimi eqbrtrri pm3.2i cc0 cz wcel vn cv cc0 caddc cop
      cF cseqz co cfv cr wcel vn cv cc0 caddc cop cG cseqz co cfv cr wcel vn cv
      cc0 caddc cop cF cseqz co cfv vn cv cc0 caddc cop cG cseqz co cfv cle wbr
      w3a vn cc0 cuz cfv wral 0z vn cv cc0 caddc cop cF cseqz co cfv cr wcel vn
      cv cc0 caddc cop cG cseqz co cfv cr wcel vn cv cc0 caddc cop cF cseqz co
      cfv vn cv cc0 caddc cop cG cseqz co cfv cle wbr w3a vn cc0 cuz cfv vn cv
      cc0 cuz cfv wcel vn cv cc0 caddc cop cF cseqz co cfv cr wcel vn cv cc0
      caddc cop cG cseqz co cfv cr wcel vn cv cc0 caddc cop cF cseqz co cfv vn
      cv cc0 caddc cop cG cseqz co cfv cle wbr vn cv cc0 cuz cfv wcel vk cv cF
      cfv cr wcel vk cc0 vn cv cfz co wral vn cv cc0 caddc cop cF cseqz co cfv
      cr wcel vk cv cF cfv cr wcel vk cc0 vn cv cfz co vk cv cc0 vn cv cfz co
      wcel vk cv cn0 wcel vk cv cF cfv cr wcel vk cv vn cv elfznn0 vk cv cn0
      wcel vk cv cF cfv cA vk cv cexp co vk cv cfa cfv cdiv co cr vy cA vj cF
      vk cv eflegeolem2.3 eftval cA cr wcel vk cv cn0 wcel cA vk cv cexp co vk
      cv cfa cfv cdiv co cr wcel eflegeolem2.1 cA vk cv reeftcl mpan eqeltrd
      syl rgen vk cF cc0 vn cv vj vy cn0 cA vj cv cexp co vj cv cfa cfv cdiv co
      cF nn0ex eflegeolem2.3 fopabex2 serzrecl mpan2 vn cv cc0 cuz cfv wcel vk
      cv cG cfv cr wcel vk cc0 vn cv cfz co wral vn cv cc0 caddc cop cG cseqz
      co cfv cr wcel vk cv cG cfv cr wcel vk cc0 vn cv cfz co vk cv cc0 vn cv
      cfz co wcel vk cv cn0 wcel vk cv cG cfv cr wcel vk cv vn cv elfznn0 vk cv
      cn0 wcel vk cv cG cfv cA vk cv cexp co cr vj vy vk cv cA vj cv cexp co cA
      vk cv cexp co cn0 cG vj cv vk cv cA cexp opreq2 eflegeolem2.4 cA vk cv
      cexp oprex fvopab4 cA cr wcel vk cv cn0 wcel cA vk cv cexp co cr wcel
      eflegeolem2.1 cA vk cv reexpcl mpan eqeltrd syl rgen vk cG cc0 vn cv vj
      vy cn0 cA vj cv cexp co cG nn0ex eflegeolem2.4 fopabex2 serzrecl mpan2 vn
      cv cc0 cuz cfv wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF
      cfv vk cv cG cfv cle wbr w3a vk cc0 vn cv cfz co wral vn cv cc0 caddc cop
      cF cseqz co cfv vn cv cc0 caddc cop cG cseqz co cfv cle wbr vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr w3a vk cc0
      vn cv cfz co vk cv cc0 vn cv cfz co wcel vk cv cF cfv cr wcel vk cv cG
      cfv cr wcel vk cv cF cfv vk cv cG cfv cle wbr vk cv cc0 vn cv cfz co wcel
      vk cv cn0 wcel vk cv cF cfv cr wcel vk cv vn cv elfznn0 vk cv cn0 wcel vk
      cv cF cfv cA vk cv cexp co vk cv cfa cfv cdiv co cr vy cA vj cF vk cv
      eflegeolem2.3 eftval cA cr wcel vk cv cn0 wcel cA vk cv cexp co vk cv cfa
      cfv cdiv co cr wcel eflegeolem2.1 cA vk cv reeftcl mpan eqeltrd syl vk cv
      cc0 vn cv cfz co wcel vk cv cn0 wcel vk cv cG cfv cr wcel vk cv vn cv
      elfznn0 vk cv cn0 wcel vk cv cG cfv cA vk cv cexp co cr vj vy vk cv cA vj
      cv cexp co cA vk cv cexp co cn0 cG vj cv vk cv cA cexp opreq2
      eflegeolem2.4 cA vk cv cexp oprex fvopab4 cA cr wcel vk cv cn0 wcel cA vk
      cv cexp co cr wcel eflegeolem2.1 cA vk cv reexpcl mpan eqeltrd syl vk cv
      cc0 vn cv cfz co wcel vk cv cn0 wcel vk cv cF cfv vk cv cG cfv cle wbr vk
      cv vn cv elfznn0 vk cv cn0 wcel cA vk cv cexp co vk cv cfa cfv cdiv co cA
      vk cv cexp co vk cv cF cfv vk cv cG cfv cle cA vk cv eflegeolem2.1 cc0 cA
      cle wbr cA c1 clt wbr eflegeolem2.2 pm3.26i eflegeolem1 vy cA vj cF vk cv
      eflegeolem2.3 eftval vj vy vk cv cA vj cv cexp co cA vk cv cexp co cn0 cG
      vj cv vk cv cA cexp opreq2 eflegeolem2.4 cA vk cv cexp oprex fvopab4
      3brtr4d syl 3jca rgen vk cF cG cc0 vn cv vj vy cn0 cA vj cv cexp co vj cv
      cfa cfv cdiv co cF nn0ex eflegeolem2.3 fopabex2 vj vy cn0 cA vj cv cexp
      co cG nn0ex eflegeolem2.4 fopabex2 serzcmp mpan2 3jca rgen pm3.2i cA ce
      cfv c1 c1 cA cmin co cdiv co vn cc0 caddc cop cF cseqz co cc0 caddc cop
      cG cseqz co cc0 cc0 caddc cop cF cseqz oprex cc0 caddc cop cG cseqz oprex
      cA ce fvex c1 c1 cA cmin co cdiv oprex climcmp mp2an $.
      $( [8-Jan-2008] $) $( [11-Sep-2007] $)
  $}

  ${
    $d A j y $.
    eflegeo.1 $e |- A e. RR $.
    eflegeo.2 $e |- ( 0 <_ A /\ A < 1 ) $.
    $( The exponential function on the reals between 0 and 1 lies below
       the comparable geometric series sum.  (Contributed by Paul Chapman,
       11-Sep-2007.) $)
    eflegeoi $p |- ( exp ` A ) <_ ( 1 / ( 1 - A ) ) $=
      vy cA vj vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv cdiv co wceq
      wa vj vy copab vj cv cn0 wcel vy cv cA vj cv cexp co wceq wa vj vy copab
      eflegeo.1 eflegeo.2 vj cv cn0 wcel vy cv cA vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab eqid vj cv cn0 wcel vy cv cA vj cv cexp co
      wceq wa vj vy copab eqid eflegeolem2 $.
      $( [13-Sep-2007] $) $( [11-Sep-2007] $)
  $}

  $( The exponential function on the reals between 0 and 1 lies below
     the comparable geometric series sum.  (Contributed by Paul Chapman,
     11-Sep-2007.) $)
  eflegeo $p |- ( ( A e. RR /\ 0 <_ A /\ A < 1 ) ->
                   ( exp ` A ) <_ ( 1 / ( 1 - A ) ) ) $=
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA ce cfv c1 c1 cA cmin co cdiv
    co cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif ce cfv c1
    c1 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cmin co cdiv co
    cle wbr cA cc0 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    wceq cA ce cfv cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif ce
    cfv c1 c1 cA cmin co cdiv co c1 c1 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cmin co cdiv co cle cA cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cc0 cif ce fveq2 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a
    cA cc0 cif wceq c1 cA cmin co c1 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cmin co c1 cdiv cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif c1 cmin opreq2 opreq2d breq12d cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA
    cc0 cif cr wcel cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif c1 clt wbr w3a cc0 cr wcel cc0 cc0 cle wbr cc0 c1 clt wbr w3a cA cc0 cA
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif wceq cA cr wcel cA
    cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cle wbr
    cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA c1
    clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr
    cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr eleq1 cA cA cr
    wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cc0 cle breq2 cA cA cr
    wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt breq1 3anbi123d cc0
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif wceq cc0 cr wcel cA
    cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cc0 cle wbr
    cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cc0 c1
    clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr
    cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr eleq1 cc0 cA
    cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cc0 cle breq2 cc0 cA cr
    wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt breq1 3anbi123d cc0
    cr wcel cc0 cc0 cle wbr cc0 c1 clt wbr 0re cc0 0re leidi lt01 3pm3.2i
    elimhyp 3simp1i cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cr
    wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel cc0 cA
    cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cr wcel cc0 cA cle wbr
    cA c1 clt wbr w3a cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr
    wcel cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA
    cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr w3a cc0 cr
    wcel cc0 cc0 cle wbr cc0 c1 clt wbr w3a cA cc0 cA cA cr wcel cc0 cA cle wbr
    cA c1 clt wbr w3a cA cc0 cif wceq cA cr wcel cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cle wbr cc0 cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA c1 clt wbr cA cr wcel cc0 cA
    cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif cr eleq1 cA cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cc0 cle breq2 cA cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif c1 clt breq1 3anbi123d cc0 cA cr wcel cc0 cA cle wbr
    cA c1 clt wbr w3a cA cc0 cif wceq cc0 cr wcel cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cr wcel cc0 cc0 cle wbr cc0 cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cc0 c1 clt wbr cA cr wcel cc0 cA
    cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cc0 cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif cr eleq1 cc0 cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cc0 cle breq2 cc0 cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif c1 clt breq1 3anbi123d cc0 cr wcel cc0 cc0 cle wbr
    cc0 c1 clt wbr 0re cc0 0re leidi lt01 3pm3.2i elimhyp 3simp2i cA cr wcel
    cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel cc0 cA
    cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel
    cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr w3a cc0 cr wcel cc0
    cc0 cle wbr cc0 c1 clt wbr w3a cA cc0 cA cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif wceq cA cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cc0 cif cr wcel cc0 cA cle wbr cc0 cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cle wbr cA c1 clt wbr cA cr wcel cc0 cA cle wbr
    cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr eleq1 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cc0 cle breq2 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a
    cA cc0 cif c1 clt breq1 3anbi123d cc0 cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cc0 cif wceq cc0 cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cr wcel cc0 cc0 cle wbr cc0 cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cle wbr cc0 c1 clt wbr cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif c1 clt wbr cc0 cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr eleq1 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cc0 cle breq2 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif c1 clt breq1 3anbi123d cc0 cr wcel cc0 cc0 cle wbr cc0 c1
    clt wbr 0re cc0 0re leidi lt01 3pm3.2i elimhyp 3simp3i pm3.2i eflegeoi
    dedth $.
    $( [13-Sep-2007] $) $( [11-Sep-2007] $)

  ${
    efm1legeo.1 $e |- A e. RR $.
    efm1legeo.2 $e |- ( 0 <_ A /\ A < 1 ) $.
    $( One less than the exponential function on the reals between 0 and 1
       lies below the comparable geometric series sum.  (Contributed by Paul
       Chapman, 15-Sep-2007.)  $)
    efm1legeoi $p |- ( ( exp ` A ) - 1 ) <_ ( A / ( 1 - A ) ) $=
      cA ce cfv c1 cmin co c1 c1 cA cmin co cdiv co c1 cmin co cA c1 cA cmin co
      cdiv co cle cA ce cfv c1 c1 cA cmin co cdiv co cle wbr cA ce cfv c1 cmin
      co c1 c1 cA cmin co cdiv co c1 cmin co cle wbr cA efm1legeo.1 efm1legeo.2
      eflegeoi cA ce cfv cr wcel c1 c1 cA cmin co cdiv co cr wcel c1 cr wcel cA
      ce cfv c1 c1 cA cmin co cdiv co cle wbr cA ce cfv c1 cmin co c1 c1 cA
      cmin co cdiv co c1 cmin co cle wbr wb cA efm1legeo.1 reefcli c1 cA cmin
      co c1 cA 1re efm1legeo.1 resubcli c1 cA cmin co c1 cA 1re efm1legeo.1
      resubcli c1 c1 cmin co cc0 c1 cA cmin co clt c1 ax1cn subidi cA c1 clt
      wbr c1 c1 cmin co c1 cA cmin co clt wbr cc0 cA cle wbr cA c1 clt wbr
      efm1legeo.2 pm3.27i cA cr wcel c1 cr wcel c1 cr wcel cA c1 clt wbr c1 c1
      cmin co c1 cA cmin co clt wbr wb efm1legeo.1 1re 1re cA c1 c1 ltsub2
      mp3an mpbi eqbrtrri gt0ne0ii rereccli 1re cA ce cfv c1 c1 cA cmin co cdiv
      co c1 lesub1 mp3an mpbi c1 c1 cA cmin co cmin co c1 cA cmin co cdiv co c1
      c1 cA cmin co cdiv co c1 cA cmin co c1 cA cmin co cdiv co cmin co cA c1
      cA cmin co cdiv co c1 c1 cA cmin co cdiv co c1 cmin co c1 cc wcel c1 cA
      cmin co cc wcel c1 cA cmin co cc wcel c1 cA cmin co cc0 wne wa c1 c1 cA
      cmin co cmin co c1 cA cmin co cdiv co c1 c1 cA cmin co cdiv co c1 cA cmin
      co c1 cA cmin co cdiv co cmin co wceq ax1cn c1 cA cmin co c1 cA 1re
      efm1legeo.1 resubcli recni c1 cA cmin co cc wcel c1 cA cmin co cc0 wne c1
      cA cmin co c1 cA 1re efm1legeo.1 resubcli recni c1 cA cmin co c1 cA 1re
      efm1legeo.1 resubcli c1 c1 cmin co cc0 c1 cA cmin co clt c1 ax1cn subidi
      cA c1 clt wbr c1 c1 cmin co c1 cA cmin co clt wbr cc0 cA cle wbr cA c1
      clt wbr efm1legeo.2 pm3.27i cA cr wcel c1 cr wcel c1 cr wcel cA c1 clt
      wbr c1 c1 cmin co c1 cA cmin co clt wbr wb efm1legeo.1 1re 1re cA c1 c1
      ltsub2 mp3an mpbi eqbrtrri gt0ne0ii pm3.2i c1 c1 cA cmin co c1 cA cmin co
      divsubdir mp3an c1 c1 cA cmin co cmin co cA c1 cA cmin co cdiv c1 cc wcel
      cA cc wcel c1 c1 cA cmin co cmin co cA wceq ax1cn cA efm1legeo.1 recni c1
      cA nncan mp2an opreq1i c1 cA cmin co c1 cA cmin co cdiv co c1 c1 c1 cA
      cmin co cdiv co cmin c1 cA cmin co c1 cA cmin co c1 cA 1re efm1legeo.1
      resubcli recni c1 cA cmin co c1 cA 1re efm1legeo.1 resubcli c1 c1 cmin co
      cc0 c1 cA cmin co clt c1 ax1cn subidi cA c1 clt wbr c1 c1 cmin co c1 cA
      cmin co clt wbr cc0 cA cle wbr cA c1 clt wbr efm1legeo.2 pm3.27i cA cr
      wcel c1 cr wcel c1 cr wcel cA c1 clt wbr c1 c1 cmin co c1 cA cmin co clt
      wbr wb efm1legeo.1 1re 1re cA c1 c1 ltsub2 mp3an mpbi eqbrtrri gt0ne0ii
      dividi opreq2i 3eqtr3i breqtrri $.
      $( [15-Sep-2007] $) $( [15-Sep-2007] $)
  $}

  $( One less than the exponential function on the reals between 0 and 1
     lies below the comparable geometric series sum.  (Contributed by Paul
     Chapman, 15-Sep-2007.) $)
  efm1legeo $p |- ( ( A e. RR /\ 0 <_ A /\ A < 1 ) ->
                     ( ( exp ` A ) - 1 ) <_ ( A / ( 1 - A ) ) ) $=
    cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA ce cfv c1 cmin co cA c1 cA
    cmin co cdiv co cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif ce cfv c1 cmin co cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif c1 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cmin co cdiv
    co cle wbr cA cc0 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    wceq cA ce cfv c1 cmin co cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA
    cc0 cif ce cfv c1 cmin co cA c1 cA cmin co cdiv co cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif c1 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cmin co cdiv co cle cA cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cc0 cif wceq cA ce cfv cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif ce cfv c1 cmin cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif ce fveq2 opreq1d cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif wceq cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif c1 cA cmin co c1 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    cmin co cdiv cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif wceq
    id cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 cmin opreq2
    opreq12d breq12d cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cA
    cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel
    cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel
    cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr
    wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr w3a cc0 cr wcel
    cc0 cc0 cle wbr cc0 c1 clt wbr w3a cA cc0 cA cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif wceq cA cr wcel cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr wcel cc0 cA cle wbr cc0 cA cr wcel cc0 cA cle wbr
    cA c1 clt wbr w3a cA cc0 cif cle wbr cA c1 clt wbr cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cr eleq1 cA cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cc0 cif cc0 cle breq2 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif c1 clt breq1 3anbi123d cc0 cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif wceq cc0 cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt
    wbr w3a cA cc0 cif cr wcel cc0 cc0 cle wbr cc0 cA cr wcel cc0 cA cle wbr cA
    c1 clt wbr w3a cA cc0 cif cle wbr cc0 c1 clt wbr cA cr wcel cc0 cA cle wbr
    cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cc0 cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr eleq1 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cc0 cle breq2 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif c1 clt breq1 3anbi123d cc0 cr wcel cc0 cc0 cle wbr cc0 c1
    clt wbr 0reALT cc0 0reALT leidi lt01 3pm3.2i elimhyp 3simp1i cc0 cA cr wcel
    cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cr wcel cc0
    cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif c1 clt wbr w3a cc0 cr wcel cc0 cc0 cle wbr cc0 c1
    clt wbr w3a cA cc0 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif wceq cA cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    cr wcel cc0 cA cle wbr cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA
    cc0 cif cle wbr cA c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a
    cA cc0 cif c1 clt wbr cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif cr eleq1 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cc0
    cle breq2 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt
    breq1 3anbi123d cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    wceq cc0 cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr
    wcel cc0 cc0 cle wbr cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif cle wbr cc0 c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA
    cc0 cif c1 clt wbr cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif cr eleq1 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cc0
    cle breq2 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt
    breq1 3anbi123d cc0 cr wcel cc0 cc0 cle wbr cc0 c1 clt wbr 0reALT cc0
    0reALT leidi lt01 3pm3.2i elimhyp 3simp2i cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr
    w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cr wcel cc0
    cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr wcel cc0 cA cr wcel cc0 cA cle
    wbr cA c1 clt wbr w3a cA cc0 cif cle wbr cA cr wcel cc0 cA cle wbr cA c1
    clt wbr w3a cA cc0 cif c1 clt wbr w3a cc0 cr wcel cc0 cc0 cle wbr cc0 c1
    clt wbr w3a cA cc0 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif wceq cA cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    cr wcel cc0 cA cle wbr cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA
    cc0 cif cle wbr cA c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a
    cA cc0 cif c1 clt wbr cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif cr eleq1 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cc0
    cle breq2 cA cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt
    breq1 3anbi123d cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif
    wceq cc0 cr wcel cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cr
    wcel cc0 cc0 cle wbr cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif cle wbr cc0 c1 clt wbr cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA
    cc0 cif c1 clt wbr cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0
    cif cr eleq1 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif cc0
    cle breq2 cc0 cA cr wcel cc0 cA cle wbr cA c1 clt wbr w3a cA cc0 cif c1 clt
    breq1 3anbi123d cc0 cr wcel cc0 cc0 cle wbr cc0 c1 clt wbr 0reALT cc0
    0reALT leidi lt01 3pm3.2i elimhyp 3simp3i pm3.2i efm1legeoi dedth $.
    $( [15-Sep-2007] $) $( [15-Sep-2007] $)

  ${
    efcnlem1.1 $e |- A e. RR $.
    efcnlem1.2 $e |- X e. RR $.
    efcnlem1.3 $e |- Y e. RR $.
    efcnlem1.4 $e |- 0 < X $.
    efcnlem1.5 $e |- 0 < Y $.
    $( Lemma for ~ efcn . $)
    efcnlem1 $p |- ( A < ( Y / ( X + Y ) ) -> ( A < 1 /\ ( 1 - A ) =/= 0 /\
                       ( X x. ( A / ( 1 - A ) ) ) < Y ) ) $=
      cA cY cX cY caddc co cdiv co clt wbr cA c1 clt wbr c1 cA cmin co cc0 wne
      cX cA c1 cA cmin co cdiv co cmul co cY clt wbr cA cY cX cY caddc co cdiv
      co clt wbr cY cX cY caddc co cdiv co c1 clt wbr cA c1 clt wbr cc0 cX clt
      wbr cY cX cY caddc co cdiv co c1 clt wbr efcnlem1.4 cY cX cY caddc co c1
      cmul co clt wbr cY cX cY caddc co clt wbr cY cX cY caddc co cdiv co c1
      clt wbr cc0 cX clt wbr cX cY caddc co c1 cmul co cX cY caddc co cY clt cX
      cY caddc co cX cY caddc co cX cY efcnlem1.2 efcnlem1.3 readdcli recni
      mulid1i breq2i cY cr wcel cX cY caddc co cr wcel c1 cr wcel cY cX cY
      caddc co cdiv co c1 clt wbr cY cX cY caddc co c1 cmul co clt wbr wb
      efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli 1re cY cr wcel cX cY
      caddc co cr wcel c1 cr wcel w3a cc0 cX cY caddc co clt wbr cY cX cY caddc
      co cdiv co c1 clt wbr cY cX cY caddc co c1 cmul co clt wbr wb cX cY
      efcnlem1.2 efcnlem1.3 efcnlem1.4 efcnlem1.5 addgt0ii cY cX cY caddc co c1
      ltdivmulOLD mpan2 mp3an cX cr wcel cY cr wcel cc0 cX clt wbr cY cX cY
      caddc co clt wbr wb efcnlem1.2 efcnlem1.3 cX cY ltaddpos2 mp2an 3bitr4ri
      mpbi cA cY cX cY caddc co cdiv co c1 efcnlem1.1 cY cX cY caddc co
      efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli cX cY caddc co cX cY
      efcnlem1.2 efcnlem1.3 readdcli cX cY efcnlem1.2 efcnlem1.3 efcnlem1.4
      efcnlem1.5 addgt0ii gt0ne0ii redivcli 1re lttri mpan2 cA cY cX cY caddc
      co cdiv co clt wbr cc0 c1 cA cmin co clt wbr c1 cA cmin co cc0 wne cA cY
      cX cY caddc co cdiv co clt wbr cA c1 clt wbr cc0 c1 cA cmin co clt wbr cA
      cY cX cY caddc co cdiv co clt wbr cY cX cY caddc co cdiv co c1 clt wbr cA
      c1 clt wbr cc0 cX clt wbr cY cX cY caddc co cdiv co c1 clt wbr efcnlem1.4
      cY cX cY caddc co c1 cmul co clt wbr cY cX cY caddc co clt wbr cY cX cY
      caddc co cdiv co c1 clt wbr cc0 cX clt wbr cX cY caddc co c1 cmul co cX
      cY caddc co cY clt cX cY caddc co cX cY caddc co cX cY efcnlem1.2
      efcnlem1.3 readdcli recni mulid1i breq2i cY cr wcel cX cY caddc co cr
      wcel c1 cr wcel cY cX cY caddc co cdiv co c1 clt wbr cY cX cY caddc co c1
      cmul co clt wbr wb efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli 1re cY
      cr wcel cX cY caddc co cr wcel c1 cr wcel w3a cc0 cX cY caddc co clt wbr
      cY cX cY caddc co cdiv co c1 clt wbr cY cX cY caddc co c1 cmul co clt wbr
      wb cX cY efcnlem1.2 efcnlem1.3 efcnlem1.4 efcnlem1.5 addgt0ii cY cX cY
      caddc co c1 ltdivmulOLD mpan2 mp3an cX cr wcel cY cr wcel cc0 cX clt wbr
      cY cX cY caddc co clt wbr wb efcnlem1.2 efcnlem1.3 cX cY ltaddpos2 mp2an
      3bitr4ri mpbi cA cY cX cY caddc co cdiv co c1 efcnlem1.1 cY cX cY caddc
      co efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli cX cY caddc co cX cY
      efcnlem1.2 efcnlem1.3 readdcli cX cY efcnlem1.2 efcnlem1.3 efcnlem1.4
      efcnlem1.5 addgt0ii gt0ne0ii redivcli 1re lttri mpan2 cc0 c1 cA cmin co
      clt wbr cc0 cA caddc co c1 clt wbr cA c1 clt wbr cc0 cA c1 0reALT
      efcnlem1.1 1re ltaddsubi cc0 cA caddc co cA c1 clt cA cA efcnlem1.1 recni
      addid2i breq1i bitr3i sylibr c1 cA cmin co c1 cA 1re efcnlem1.1 resubcli
      gt0ne0i syl cA cY cX cY caddc co cdiv co clt wbr cX cA cmul co c1 cA cmin
      co cdiv co cX cA c1 cA cmin co cdiv co cmul co cY clt cA cY cX cY caddc
      co cdiv co clt wbr c1 cA cmin co cc0 wne cX cA cmul co c1 cA cmin co cdiv
      co cX cA c1 cA cmin co cdiv co cmul co wceq cA cY cX cY caddc co cdiv co
      clt wbr cc0 c1 cA cmin co clt wbr c1 cA cmin co cc0 wne cA cY cX cY caddc
      co cdiv co clt wbr cA c1 clt wbr cc0 c1 cA cmin co clt wbr cA cY cX cY
      caddc co cdiv co clt wbr cY cX cY caddc co cdiv co c1 clt wbr cA c1 clt
      wbr cc0 cX clt wbr cY cX cY caddc co cdiv co c1 clt wbr efcnlem1.4 cY cX
      cY caddc co c1 cmul co clt wbr cY cX cY caddc co clt wbr cY cX cY caddc
      co cdiv co c1 clt wbr cc0 cX clt wbr cX cY caddc co c1 cmul co cX cY
      caddc co cY clt cX cY caddc co cX cY caddc co cX cY efcnlem1.2 efcnlem1.3
      readdcli recni mulid1i breq2i cY cr wcel cX cY caddc co cr wcel c1 cr
      wcel cY cX cY caddc co cdiv co c1 clt wbr cY cX cY caddc co c1 cmul co
      clt wbr wb efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli 1re cY cr wcel
      cX cY caddc co cr wcel c1 cr wcel w3a cc0 cX cY caddc co clt wbr cY cX cY
      caddc co cdiv co c1 clt wbr cY cX cY caddc co c1 cmul co clt wbr wb cX cY
      efcnlem1.2 efcnlem1.3 efcnlem1.4 efcnlem1.5 addgt0ii cY cX cY caddc co c1
      ltdivmulOLD mpan2 mp3an cX cr wcel cY cr wcel cc0 cX clt wbr cY cX cY
      caddc co clt wbr wb efcnlem1.2 efcnlem1.3 cX cY ltaddpos2 mp2an 3bitr4ri
      mpbi cA cY cX cY caddc co cdiv co c1 efcnlem1.1 cY cX cY caddc co
      efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli cX cY caddc co cX cY
      efcnlem1.2 efcnlem1.3 readdcli cX cY efcnlem1.2 efcnlem1.3 efcnlem1.4
      efcnlem1.5 addgt0ii gt0ne0ii redivcli 1re lttri mpan2 cc0 c1 cA cmin co
      clt wbr cc0 cA caddc co c1 clt wbr cA c1 clt wbr cc0 cA c1 0reALT
      efcnlem1.1 1re ltaddsubi cc0 cA caddc co cA c1 clt cA cA efcnlem1.1 recni
      addid2i breq1i bitr3i sylibr c1 cA cmin co c1 cA 1re efcnlem1.1 resubcli
      gt0ne0i syl cX cA c1 cA cmin co cX efcnlem1.2 recni cA efcnlem1.1 recni
      c1 cA cmin co c1 cA 1re efcnlem1.1 resubcli recni divasszi syl cA cY cX
      cY caddc co cdiv co clt wbr cX cA cmul co c1 cA cmin co cdiv co cY clt
      wbr cX cA cmul co c1 cA cmin co cY cmul co clt wbr cA cY cX cY caddc co
      cdiv co clt wbr cA cX cmul co c1 cA cmin co cY cmul co cX cA cmul co clt
      cA cY cX cY caddc co cdiv co clt wbr cA cX cmul co c1 cY cmul co cA cY
      cmul co cmin co c1 cA cmin co cY cmul co clt cA cY cX cY caddc co cdiv co
      clt wbr cA cX cmul co cA cY cmul co caddc co c1 cY cmul co clt wbr cA cX
      cmul co c1 cY cmul co cA cY cmul co cmin co clt wbr cA cY cX cY caddc co
      cdiv co clt wbr cA cX cmul co cA cY cmul co caddc co cY c1 cY cmul co clt
      cA cY cX cY caddc co cdiv co clt wbr cA cX cY caddc co cmul co cY cA cX
      cmul co cA cY cmul co caddc co clt cA cX cY caddc co cmul co cY clt wbr
      cA cY cX cY caddc co cdiv co clt wbr cc0 cX cY caddc co clt wbr cA cX cY
      caddc co cmul co cY clt wbr cA cY cX cY caddc co cdiv co clt wbr wb cX cY
      efcnlem1.2 efcnlem1.3 efcnlem1.4 efcnlem1.5 addgt0ii cA cY cX cY caddc co
      efcnlem1.1 efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3 readdcli ltmuldivi
      ax-mp biimpri cA cX cY cA efcnlem1.1 recni cX efcnlem1.2 recni cY
      efcnlem1.3 recni adddii syl5eqbrr cY cY efcnlem1.3 recni mulid2i
      syl6breqr cA cX cmul co cA cY cmul co c1 cY cmul co cA cX efcnlem1.1
      efcnlem1.2 remulcli cA cY efcnlem1.1 efcnlem1.3 remulcli c1 cY 1re
      efcnlem1.3 remulcli ltaddsubi sylib c1 cA cY ax1cn cA efcnlem1.1 recni cY
      efcnlem1.3 recni subdiri syl6breqr cA cX cA efcnlem1.1 recni cX
      efcnlem1.2 recni mulcomi syl5eqbrr cX cA cmul co cr wcel c1 cA cmin co cr
      wcel cY cr wcel w3a cc0 c1 cA cmin co clt wbr cX cA cmul co c1 cA cmin co
      cdiv co cY clt wbr cX cA cmul co c1 cA cmin co cY cmul co clt wbr wb cA
      cY cX cY caddc co cdiv co clt wbr cX cA cmul co c1 cA cmin co cY
      ltdivmulOLD cX cA cmul co cr wcel c1 cA cmin co cr wcel cY cr wcel cX cA
      efcnlem1.2 efcnlem1.1 remulcli c1 cA 1re efcnlem1.1 resubcli efcnlem1.3
      3pm3.2i cA cY cX cY caddc co cdiv co clt wbr cA c1 clt wbr cc0 c1 cA cmin
      co clt wbr cA cY cX cY caddc co cdiv co clt wbr cY cX cY caddc co cdiv co
      c1 clt wbr cA c1 clt wbr cc0 cX clt wbr cY cX cY caddc co cdiv co c1 clt
      wbr efcnlem1.4 cY cX cY caddc co c1 cmul co clt wbr cY cX cY caddc co clt
      wbr cY cX cY caddc co cdiv co c1 clt wbr cc0 cX clt wbr cX cY caddc co c1
      cmul co cX cY caddc co cY clt cX cY caddc co cX cY caddc co cX cY
      efcnlem1.2 efcnlem1.3 readdcli recni mulid1i breq2i cY cr wcel cX cY
      caddc co cr wcel c1 cr wcel cY cX cY caddc co cdiv co c1 clt wbr cY cX cY
      caddc co c1 cmul co clt wbr wb efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3
      readdcli 1re cY cr wcel cX cY caddc co cr wcel c1 cr wcel w3a cc0 cX cY
      caddc co clt wbr cY cX cY caddc co cdiv co c1 clt wbr cY cX cY caddc co
      c1 cmul co clt wbr wb cX cY efcnlem1.2 efcnlem1.3 efcnlem1.4 efcnlem1.5
      addgt0ii cY cX cY caddc co c1 ltdivmulOLD mpan2 mp3an cX cr wcel cY cr
      wcel cc0 cX clt wbr cY cX cY caddc co clt wbr wb efcnlem1.2 efcnlem1.3 cX
      cY ltaddpos2 mp2an 3bitr4ri mpbi cA cY cX cY caddc co cdiv co c1
      efcnlem1.1 cY cX cY caddc co efcnlem1.3 cX cY efcnlem1.2 efcnlem1.3
      readdcli cX cY caddc co cX cY efcnlem1.2 efcnlem1.3 readdcli cX cY
      efcnlem1.2 efcnlem1.3 efcnlem1.4 efcnlem1.5 addgt0ii gt0ne0ii redivcli
      1re lttri mpan2 cc0 c1 cA cmin co clt wbr cc0 cA caddc co c1 clt wbr cA
      c1 clt wbr cc0 cA c1 0reALT efcnlem1.1 1re ltaddsubi cc0 cA caddc co cA
      c1 clt cA cA efcnlem1.1 recni addid2i breq1i bitr3i sylibr sylancr mpbird
      eqbrtrrd 3jca $.
      $( [15-Sep-2007] $) $( [15-Sep-2007] $)
  $}

  ${
    efcnlem2.1 $e |- X e. CC $.
    efcnlem2.2 $e |- W e. CC $.
    efcnlem2.3 $e |- Y e. RR $.
    efcnlem2.4 $e |- 0 < Y $.
    efcnlem2.5 $e |- S = ( abs ` ( exp ` X ) ) $.
    efcnlem2.6 $e |- H = ( abs ` ( X - W ) ) $.
    efcnlem2.7 $e |- G = ( H / ( 1 - H ) ) $.
    efcnlem2.8 $e |- D = ( Y / ( S + Y ) ) $.
    $( Lemma for ~ efcn . $)
    efcnlem2 $p |- ( H < D -> ( abs ` ( ( exp ` X ) - ( exp ` W ) ) ) < Y ) $=
      cH cD clt wbr cW ce cfv cX ce cfv cmin co cabs cfv cY cX ce cfv cW ce cfv
      cmin co cabs cfv clt cH cD clt wbr cS cW cX cmin co ce cfv c1 cmin co
      cabs cfv cmul co cY cW ce cfv cX ce cfv cmin co cabs cfv clt cH cD clt
      wbr cS cW cX cmin co ce cfv c1 cmin co cabs cfv cmul co cS cG cmul co cY
      cS cW cX cmin co ce cfv c1 cmin co cabs cfv cmul co cr wcel cH cD clt wbr
      cS cW cX cmin co ce cfv c1 cmin co cabs cfv cS cX ce cfv cabs cfv cr
      efcnlem2.5 cX ce cfv cX cc wcel cX ce cfv cc wcel efcnlem2.1 cX efcl
      ax-mp abscli eqeltri cW cX cmin co ce cfv c1 cmin co cW cX cmin co ce cfv
      c1 cW cX cmin co cc wcel cW cX cmin co ce cfv cc wcel cW cX efcnlem2.2
      efcnlem2.1 subcli cW cX cmin co efcl ax-mp ax1cn subcli abscli remulcli
      a1i cS cr wcel cG cr wcel cS cG cmul co cr wcel cH cD clt wbr cS cG
      remulcl cS cX ce cfv cabs cfv cr efcnlem2.5 cX ce cfv cX cc wcel cX ce
      cfv cc wcel efcnlem2.1 cX efcl ax-mp abscli eqeltri cH cD clt wbr c1 cH
      cmin co cc0 wne cG cr wcel cH cD clt wbr cH c1 clt wbr c1 cH cmin co cc0
      wne cS cH c1 cH cmin co cdiv co cmul co cY clt wbr cH cD clt wbr cH cY cS
      cY caddc co cdiv co clt wbr cH c1 clt wbr c1 cH cmin co cc0 wne cS cH c1
      cH cmin co cdiv co cmul co cY clt wbr w3a cD cY cS cY caddc co cdiv co cH
      clt efcnlem2.8 breq2i cH cS cY cH cW cX cmin co cabs cfv cr cH cX cW cmin
      co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6
      cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2 efcnlem2.1
      negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli
      absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli abscli
      eqeltri cS cX ce cfv cabs cfv cr efcnlem2.5 cX ce cfv cX cc wcel cX ce
      cfv cc wcel efcnlem2.1 cX efcl ax-mp abscli eqeltri efcnlem2.3 cc0 cX ce
      cfv cabs cfv cS clt cX ce cfv cc0 wne cc0 cX ce cfv cabs cfv clt wbr cX
      cc wcel cX ce cfv cc0 wne efcnlem2.1 cX efne0 ax-mp cX ce cfv cX cc wcel
      cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp absgt0i mpbi efcnlem2.5
      breqtrri efcnlem2.4 efcnlem1 sylbi 3simp2d c1 cH cmin co cc0 wne cH c1 cH
      cmin co cdiv co cr cG cH c1 cH cmin co cH cW cX cmin co cabs cfv cr cH cX
      cW cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv
      efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2
      efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1
      subcli absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli
      abscli eqeltri c1 cH 1re cH cW cX cmin co cabs cfv cr cH cX cW cmin co
      cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW
      cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i
      fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i
      cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli abscli eqeltri resubcli
      redivclzi efcnlem2.7 syl5eqel syl sylancr cY cr wcel cH cD clt wbr
      efcnlem2.3 a1i cH cD clt wbr cW cX cmin co ce cfv c1 cmin co cabs cfv cG
      cle wbr cS cW cX cmin co ce cfv c1 cmin co cabs cfv cmul co cS cG cmul co
      cle wbr cH cD clt wbr cW cX cmin co ce cfv c1 cmin co cabs cfv cH ce cfv
      c1 cmin co cG cW cX cmin co ce cfv c1 cmin co cabs cfv cr wcel cH cD clt
      wbr cW cX cmin co ce cfv c1 cmin co cW cX cmin co ce cfv c1 cW cX cmin co
      cc wcel cW cX cmin co ce cfv cc wcel cW cX efcnlem2.2 efcnlem2.1 subcli
      cW cX cmin co efcl ax-mp ax1cn subcli abscli a1i cH ce cfv c1 cmin co cr
      wcel cH cD clt wbr cH ce cfv c1 cH cH cW cX cmin co cabs cfv cr cH cX cW
      cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv
      efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2
      efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1
      subcli absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli
      abscli eqeltri reefcli 1re resubcli a1i cH cD clt wbr c1 cH cmin co cc0
      wne cG cr wcel cH cD clt wbr cH c1 clt wbr c1 cH cmin co cc0 wne cS cH c1
      cH cmin co cdiv co cmul co cY clt wbr cH cD clt wbr cH cY cS cY caddc co
      cdiv co clt wbr cH c1 clt wbr c1 cH cmin co cc0 wne cS cH c1 cH cmin co
      cdiv co cmul co cY clt wbr w3a cD cY cS cY caddc co cdiv co cH clt
      efcnlem2.8 breq2i cH cS cY cH cW cX cmin co cabs cfv cr cH cX cW cmin co
      cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW
      cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i
      fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i
      cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli abscli eqeltri cS cX ce
      cfv cabs cfv cr efcnlem2.5 cX ce cfv cX cc wcel cX ce cfv cc wcel
      efcnlem2.1 cX efcl ax-mp abscli eqeltri efcnlem2.3 cc0 cX ce cfv cabs cfv
      cS clt cX ce cfv cc0 wne cc0 cX ce cfv cabs cfv clt wbr cX cc wcel cX ce
      cfv cc0 wne efcnlem2.1 cX efne0 ax-mp cX ce cfv cX cc wcel cX ce cfv cc
      wcel efcnlem2.1 cX efcl ax-mp absgt0i mpbi efcnlem2.5 breqtrri efcnlem2.4
      efcnlem1 sylbi 3simp2d c1 cH cmin co cc0 wne cH c1 cH cmin co cdiv co cr
      cG cH c1 cH cmin co cH cW cX cmin co cabs cfv cr cH cX cW cmin co cabs
      cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW cX
      cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i
      fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i
      cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli abscli eqeltri c1 cH 1re
      cH cW cX cmin co cabs cfv cr cH cX cW cmin co cabs cfv cW cX cmin co cneg
      cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW cX cmin co cneg cX cW cmin
      co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX
      efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i cW cX cmin co cW cX
      efcnlem2.2 efcnlem2.1 subcli abscli eqeltri resubcli redivclzi efcnlem2.7
      syl5eqel syl cW cX cmin co ce cfv c1 cmin co cabs cfv cH ce cfv c1 cmin
      co cle wbr cH cD clt wbr cW cX cmin co ce cfv c1 cmin co cabs cfv cW cX
      cmin co cabs cfv ce cfv c1 cmin co cH ce cfv c1 cmin co cle cW cX cmin co
      cW cX efcnlem2.2 efcnlem2.1 subcli absefm1lei cH ce cfv cW cX cmin co
      cabs cfv ce cfv c1 cmin cH cW cX cmin co cabs cfv ce cH cX cW cmin co
      cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW
      cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i
      fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i
      fveq2i opreq1i breqtrri a1i cH cD clt wbr cH ce cfv c1 cmin co cH c1 cH
      cmin co cdiv co cG cle cH cD clt wbr cH c1 clt wbr cH ce cfv c1 cmin co
      cH c1 cH cmin co cdiv co cle wbr cH cD clt wbr cH c1 clt wbr c1 cH cmin
      co cc0 wne cS cH c1 cH cmin co cdiv co cmul co cY clt wbr cH cD clt wbr
      cH cY cS cY caddc co cdiv co clt wbr cH c1 clt wbr c1 cH cmin co cc0 wne
      cS cH c1 cH cmin co cdiv co cmul co cY clt wbr w3a cD cY cS cY caddc co
      cdiv co cH clt efcnlem2.8 breq2i cH cS cY cH cW cX cmin co cabs cfv cr cH
      cX cW cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv
      efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2
      efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1
      subcli absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli
      abscli eqeltri cS cX ce cfv cabs cfv cr efcnlem2.5 cX ce cfv cX cc wcel
      cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp abscli eqeltri efcnlem2.3 cc0
      cX ce cfv cabs cfv cS clt cX ce cfv cc0 wne cc0 cX ce cfv cabs cfv clt
      wbr cX cc wcel cX ce cfv cc0 wne efcnlem2.1 cX efne0 ax-mp cX ce cfv cX
      cc wcel cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp absgt0i mpbi
      efcnlem2.5 breqtrri efcnlem2.4 efcnlem1 sylbi 3simp1d cH cr wcel cc0 cH
      cle wbr cH c1 clt wbr cH ce cfv c1 cmin co cH c1 cH cmin co cdiv co cle
      wbr cH cW cX cmin co cabs cfv cr cH cX cW cmin co cabs cfv cW cX cmin co
      cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW cX cmin co cneg cX cW
      cmin co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i fveq2i cW cX cmin co
      cW cX efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i cW cX cmin co cW cX
      efcnlem2.2 efcnlem2.1 subcli abscli eqeltri cc0 cW cX cmin co cabs cfv cH
      cle cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli absge0i cH cX cW
      cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv
      efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2
      efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1
      subcli absnegi 3eqtr2i breqtrri cH efm1legeo mp3an12 syl efcnlem2.7
      syl6breqr letrd cW cX cmin co ce cfv c1 cmin co cabs cfv cr wcel cG cr
      wcel cS cr wcel cW cX cmin co ce cfv c1 cmin co cabs cfv cG cle wbr cS cW
      cX cmin co ce cfv c1 cmin co cabs cfv cmul co cS cG cmul co cle wbr wb cH
      cD clt wbr cW cX cmin co ce cfv c1 cmin co cabs cfv cr wcel cG cr wcel cS
      cr wcel w3a cc0 cS clt wbr cW cX cmin co ce cfv c1 cmin co cabs cfv cG
      cle wbr cS cW cX cmin co ce cfv c1 cmin co cabs cfv cmul co cS cG cmul co
      cle wbr wb cc0 cX ce cfv cabs cfv cS clt cX ce cfv cc0 wne cc0 cX ce cfv
      cabs cfv clt wbr cX cc wcel cX ce cfv cc0 wne efcnlem2.1 cX efne0 ax-mp
      cX ce cfv cX cc wcel cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp absgt0i
      mpbi efcnlem2.5 breqtrri cW cX cmin co ce cfv c1 cmin co cabs cfv cG cS
      lemul2OLD mpan2 cW cX cmin co ce cfv c1 cmin co cabs cfv cr wcel cH cD
      clt wbr cW cX cmin co ce cfv c1 cmin co cW cX cmin co ce cfv c1 cW cX
      cmin co cc wcel cW cX cmin co ce cfv cc wcel cW cX efcnlem2.2 efcnlem2.1
      subcli cW cX cmin co efcl ax-mp ax1cn subcli abscli a1i cH cD clt wbr c1
      cH cmin co cc0 wne cG cr wcel cH cD clt wbr cH c1 clt wbr c1 cH cmin co
      cc0 wne cS cH c1 cH cmin co cdiv co cmul co cY clt wbr cH cD clt wbr cH
      cY cS cY caddc co cdiv co clt wbr cH c1 clt wbr c1 cH cmin co cc0 wne cS
      cH c1 cH cmin co cdiv co cmul co cY clt wbr w3a cD cY cS cY caddc co cdiv
      co cH clt efcnlem2.8 breq2i cH cS cY cH cW cX cmin co cabs cfv cr cH cX
      cW cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs cfv
      efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2
      efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1
      subcli absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli
      abscli eqeltri cS cX ce cfv cabs cfv cr efcnlem2.5 cX ce cfv cX cc wcel
      cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp abscli eqeltri efcnlem2.3 cc0
      cX ce cfv cabs cfv cS clt cX ce cfv cc0 wne cc0 cX ce cfv cabs cfv clt
      wbr cX cc wcel cX ce cfv cc0 wne efcnlem2.1 cX efne0 ax-mp cX ce cfv cX
      cc wcel cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp absgt0i mpbi
      efcnlem2.5 breqtrri efcnlem2.4 efcnlem1 sylbi 3simp2d c1 cH cmin co cc0
      wne cH c1 cH cmin co cdiv co cr cG cH c1 cH cmin co cH cW cX cmin co cabs
      cfv cr cH cX cW cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin
      co cabs cfv efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX
      efcnlem2.2 efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2
      efcnlem2.1 subcli absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2
      efcnlem2.1 subcli abscli eqeltri c1 cH 1re cH cW cX cmin co cabs cfv cr
      cH cX cW cmin co cabs cfv cW cX cmin co cneg cabs cfv cW cX cmin co cabs
      cfv efcnlem2.6 cW cX cmin co cneg cX cW cmin co cabs cW cX efcnlem2.2
      efcnlem2.1 negsubdi2i fveq2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1
      subcli absnegi 3eqtr2i cW cX cmin co cW cX efcnlem2.2 efcnlem2.1 subcli
      abscli eqeltri resubcli redivclzi efcnlem2.7 syl5eqel syl cS cr wcel cH
      cD clt wbr cS cX ce cfv cabs cfv cr efcnlem2.5 cX ce cfv cX cc wcel cX ce
      cfv cc wcel efcnlem2.1 cX efcl ax-mp abscli eqeltri a1i syl3anc mpbid cH
      cD clt wbr cS cH c1 cH cmin co cdiv co cmul co cY cS cG cmul co clt cH cD
      clt wbr cH c1 clt wbr c1 cH cmin co cc0 wne cS cH c1 cH cmin co cdiv co
      cmul co cY clt wbr cH cD clt wbr cH cY cS cY caddc co cdiv co clt wbr cH
      c1 clt wbr c1 cH cmin co cc0 wne cS cH c1 cH cmin co cdiv co cmul co cY
      clt wbr w3a cD cY cS cY caddc co cdiv co cH clt efcnlem2.8 breq2i cH cS
      cY cH cW cX cmin co cabs cfv cr cH cX cW cmin co cabs cfv cW cX cmin co
      cneg cabs cfv cW cX cmin co cabs cfv efcnlem2.6 cW cX cmin co cneg cX cW
      cmin co cabs cW cX efcnlem2.2 efcnlem2.1 negsubdi2i fveq2i cW cX cmin co
      cW cX efcnlem2.2 efcnlem2.1 subcli absnegi 3eqtr2i cW cX cmin co cW cX
      efcnlem2.2 efcnlem2.1 subcli abscli eqeltri cS cX ce cfv cabs cfv cr
      efcnlem2.5 cX ce cfv cX cc wcel cX ce cfv cc wcel efcnlem2.1 cX efcl
      ax-mp abscli eqeltri efcnlem2.3 cc0 cX ce cfv cabs cfv cS clt cX ce cfv
      cc0 wne cc0 cX ce cfv cabs cfv clt wbr cX cc wcel cX ce cfv cc0 wne
      efcnlem2.1 cX efne0 ax-mp cX ce cfv cX cc wcel cX ce cfv cc wcel
      efcnlem2.1 cX efcl ax-mp absgt0i mpbi efcnlem2.5 breqtrri efcnlem2.4
      efcnlem1 sylbi 3simp3d cG cH c1 cH cmin co cdiv co cS cmul efcnlem2.7
      opreq2i syl5eqbr lelttrd cX ce cfv cW cX cmin co ce cfv c1 cmin co cmul
      co cabs cfv cX ce cfv cabs cfv cW cX cmin co ce cfv c1 cmin co cabs cfv
      cmul co cW ce cfv cX ce cfv cmin co cabs cfv cS cW cX cmin co ce cfv c1
      cmin co cabs cfv cmul co cX ce cfv cW cX cmin co ce cfv c1 cmin co cX cc
      wcel cX ce cfv cc wcel efcnlem2.1 cX efcl ax-mp cW cX cmin co ce cfv c1
      cW cX cmin co cc wcel cW cX cmin co ce cfv cc wcel cW cX efcnlem2.2
      efcnlem2.1 subcli cW cX cmin co efcl ax-mp ax1cn subcli absmuli cW ce cfv
      cX ce cfv cmin co cX ce cfv cW cX cmin co ce cfv c1 cmin co cmul co cabs
      cX ce cfv cW cX cmin co ce cfv c1 cmin co cmul co cX ce cfv cW cX cmin co
      ce cfv cmul co cX ce cfv c1 cmul co cmin co cW ce cfv cX ce cfv cmin co
      cX ce cfv cW cX cmin co ce cfv c1 cX cc wcel cX ce cfv cc wcel efcnlem2.1
      cX efcl ax-mp cW cX cmin co cc wcel cW cX cmin co ce cfv cc wcel cW cX
      efcnlem2.2 efcnlem2.1 subcli cW cX cmin co efcl ax-mp ax1cn subdii cX ce
      cfv cW cX cmin co ce cfv cmul co cW ce cfv cX ce cfv c1 cmul co cX ce cfv
      cmin cX cW cX cmin co caddc co ce cfv cX ce cfv cW cX cmin co ce cfv cmul
      co cW ce cfv cX cW cX cmin co efcnlem2.1 cW cX efcnlem2.2 efcnlem2.1
      subcli efaddi cX cW cX cmin co caddc co cW ce cX cW efcnlem2.1 efcnlem2.2
      pncan3i fveq2i eqtr3i cX ce cfv cX cc wcel cX ce cfv cc wcel efcnlem2.1
      cX efcl ax-mp mulid1i opreq12i eqtr2i fveq2i cS cX ce cfv cabs cfv cW cX
      cmin co ce cfv c1 cmin co cabs cfv cmul efcnlem2.5 opreq1i 3eqtr4i
      syl5eqbr cX ce cfv cW ce cfv cX cc wcel cX ce cfv cc wcel efcnlem2.1 cX
      efcl ax-mp cW cc wcel cW ce cfv cc wcel efcnlem2.2 cW efcl ax-mp abssubi
      syl5eqbr $.
      $( [15-Sep-2007] $) $( [15-Sep-2007] $)
  $}

  ${
    efcnlem3.1 $e |- X e. CC $.
    efcnlem3.2 $e |- W e. CC $.
    efcnlem3.3 $e |- Y e. RR $.
    efcnlem3.4 $e |- 0 < Y $.
    $( Lemma for ~ efcn . $)
    efcnlem3 $p |- ( ( abs ` ( X - W ) ) < ( Y / ( ( abs ` ( exp ` X ) ) + Y )
            ) -> ( abs ` ( ( exp ` X ) - ( exp ` W ) ) ) < Y ) $=
      cY cX ce cfv cabs cfv cY caddc co cdiv co cX ce cfv cabs cfv cX cW cmin
      co cabs cfv c1 cX cW cmin co cabs cfv cmin co cdiv co cX cW cmin co cabs
      cfv cW cX cY efcnlem3.1 efcnlem3.2 efcnlem3.3 efcnlem3.4 cX ce cfv cabs
      cfv eqid cX cW cmin co cabs cfv eqid cX cW cmin co cabs cfv c1 cX cW cmin
      co cabs cfv cmin co cdiv co eqid cY cX ce cfv cabs cfv cY caddc co cdiv
      co eqid efcnlem2 $.
      $( [15-Sep-2007] $) $( [15-Sep-2007] $)
  $}

  $( Lemma for ~ efcn . $)
  efcnlem4 $p |- ( ( X e. CC /\ W e. CC /\ ( Y e. RR /\ 0 < Y ) ) ->
             ( ( abs ` ( X - W ) ) < ( Y / ( ( abs ` ( exp ` X ) ) + Y ) ) ->
                     ( abs ` ( ( exp ` X ) - ( exp ` W ) ) ) < Y ) ) $=
    cX cc wcel cW cc wcel cY cr wcel cc0 cY clt wbr wa cX cW cmin co cabs cfv
    cY cX ce cfv cabs cfv cY caddc co cdiv co clt wbr cX ce cfv cW ce cfv cmin
    co cabs cfv cY clt wbr wi cX cc wcel cX cc0 cif cW cmin co cabs cfv cY cX
    cc wcel cX cc0 cif ce cfv cabs cfv cY caddc co cdiv co clt wbr cX cc wcel
    cX cc0 cif ce cfv cW ce cfv cmin co cabs cfv cY clt wbr wi cX cW cY cc0 cc0
    c1 cX cc wcel cX cc0 cif cW cc wcel cW cc0 cif cmin co cabs cfv cY cX cc
    wcel cX cc0 cif ce cfv cabs cfv cY caddc co cdiv co clt wbr cX cc wcel cX
    cc0 cif ce cfv cW cc wcel cW cc0 cif ce cfv cmin co cabs cfv cY clt wbr wi
    cX cc wcel cX cc0 cif cW cc wcel cW cc0 cif cmin co cabs cfv cY cr wcel cc0
    cY clt wbr wa cY c1 cif cX cc wcel cX cc0 cif ce cfv cabs cfv cY cr wcel
    cc0 cY clt wbr wa cY c1 cif caddc co cdiv co clt wbr cX cc wcel cX cc0 cif
    ce cfv cW cc wcel cW cc0 cif ce cfv cmin co cabs cfv cY cr wcel cc0 cY clt
    wbr wa cY c1 cif clt wbr wi cX cX cc wcel cX cc0 cif wceq cX cW cmin co
    cabs cfv cY cX ce cfv cabs cfv cY caddc co cdiv co clt wbr cX cc wcel cX
    cc0 cif cW cmin co cabs cfv cY cX cc wcel cX cc0 cif ce cfv cabs cfv cY
    caddc co cdiv co clt wbr cX ce cfv cW ce cfv cmin co cabs cfv cY clt wbr cX
    cc wcel cX cc0 cif ce cfv cW ce cfv cmin co cabs cfv cY clt wbr cX cX cc
    wcel cX cc0 cif wceq cX cW cmin co cabs cfv cX cc wcel cX cc0 cif cW cmin
    co cabs cfv cY cX ce cfv cabs cfv cY caddc co cdiv co cY cX cc wcel cX cc0
    cif ce cfv cabs cfv cY caddc co cdiv co clt cX cX cc wcel cX cc0 cif wceq
    cX cW cmin co cX cc wcel cX cc0 cif cW cmin co cabs cX cX cc wcel cX cc0
    cif cW cmin opreq1 fveq2d cX cX cc wcel cX cc0 cif wceq cX ce cfv cabs cfv
    cY caddc co cX cc wcel cX cc0 cif ce cfv cabs cfv cY caddc co cY cdiv cX cX
    cc wcel cX cc0 cif wceq cX ce cfv cX cc wcel cX cc0 cif ce cfv wceq cX ce
    cfv cabs cfv cX cc wcel cX cc0 cif ce cfv cabs cfv wceq cX ce cfv cabs cfv
    cY caddc co cX cc wcel cX cc0 cif ce cfv cabs cfv cY caddc co wceq cX cX cc
    wcel cX cc0 cif ce fveq2 cX ce cfv cX cc wcel cX cc0 cif ce cfv cabs fveq2
    cX ce cfv cabs cfv cX cc wcel cX cc0 cif ce cfv cabs cfv cY caddc opreq1
    3syl opreq2d breq12d cX cX cc wcel cX cc0 cif wceq cX ce cfv cW ce cfv cmin
    co cabs cfv cX cc wcel cX cc0 cif ce cfv cW ce cfv cmin co cabs cfv cY clt
    cX cX cc wcel cX cc0 cif wceq cX ce cfv cX cc wcel cX cc0 cif ce cfv wceq
    cX ce cfv cW ce cfv cmin co cX cc wcel cX cc0 cif ce cfv cW ce cfv cmin co
    wceq cX ce cfv cW ce cfv cmin co cabs cfv cX cc wcel cX cc0 cif ce cfv cW
    ce cfv cmin co cabs cfv wceq cX cX cc wcel cX cc0 cif ce fveq2 cX ce cfv cX
    cc wcel cX cc0 cif ce cfv cW ce cfv cmin opreq1 cX ce cfv cW ce cfv cmin co
    cX cc wcel cX cc0 cif ce cfv cW ce cfv cmin co cabs fveq2 3syl breq1d
    imbi12d cW cW cc wcel cW cc0 cif wceq cX cc wcel cX cc0 cif cW cmin co cabs
    cfv cY cX cc wcel cX cc0 cif ce cfv cabs cfv cY caddc co cdiv co clt wbr cX
    cc wcel cX cc0 cif cW cc wcel cW cc0 cif cmin co cabs cfv cY cX cc wcel cX
    cc0 cif ce cfv cabs cfv cY caddc co cdiv co clt wbr cX cc wcel cX cc0 cif
    ce cfv cW ce cfv cmin co cabs cfv cY clt wbr cX cc wcel cX cc0 cif ce cfv
    cW cc wcel cW cc0 cif ce cfv cmin co cabs cfv cY clt wbr cW cW cc wcel cW
    cc0 cif wceq cX cc wcel cX cc0 cif cW cmin co cabs cfv cX cc wcel cX cc0
    cif cW cc wcel cW cc0 cif cmin co cabs cfv cY cX cc wcel cX cc0 cif ce cfv
    cabs cfv cY caddc co cdiv co clt cW cW cc wcel cW cc0 cif wceq cX cc wcel
    cX cc0 cif cW cmin co cX cc wcel cX cc0 cif cW cc wcel cW cc0 cif cmin co
    cabs cW cW cc wcel cW cc0 cif cX cc wcel cX cc0 cif cmin opreq2 fveq2d
    breq1d cW cW cc wcel cW cc0 cif wceq cX cc wcel cX cc0 cif ce cfv cW ce cfv
    cmin co cabs cfv cX cc wcel cX cc0 cif ce cfv cW cc wcel cW cc0 cif ce cfv
    cmin co cabs cfv cY clt cW cW cc wcel cW cc0 cif wceq cW ce cfv cW cc wcel
    cW cc0 cif ce cfv wceq cX cc wcel cX cc0 cif ce cfv cW ce cfv cmin co cX cc
    wcel cX cc0 cif ce cfv cW cc wcel cW cc0 cif ce cfv cmin co wceq cX cc wcel
    cX cc0 cif ce cfv cW ce cfv cmin co cabs cfv cX cc wcel cX cc0 cif ce cfv
    cW cc wcel cW cc0 cif ce cfv cmin co cabs cfv wceq cW cW cc wcel cW cc0 cif
    ce fveq2 cW ce cfv cW cc wcel cW cc0 cif ce cfv cX cc wcel cX cc0 cif ce
    cfv cmin opreq2 cX cc wcel cX cc0 cif ce cfv cW ce cfv cmin co cX cc wcel
    cX cc0 cif ce cfv cW cc wcel cW cc0 cif ce cfv cmin co cabs fveq2 3syl
    breq1d imbi12d cY cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq cX cc wcel cX
    cc0 cif cW cc wcel cW cc0 cif cmin co cabs cfv cY cX cc wcel cX cc0 cif ce
    cfv cabs cfv cY caddc co cdiv co clt wbr cX cc wcel cX cc0 cif cW cc wcel
    cW cc0 cif cmin co cabs cfv cY cr wcel cc0 cY clt wbr wa cY c1 cif cX cc
    wcel cX cc0 cif ce cfv cabs cfv cY cr wcel cc0 cY clt wbr wa cY c1 cif
    caddc co cdiv co clt wbr cX cc wcel cX cc0 cif ce cfv cW cc wcel cW cc0 cif
    ce cfv cmin co cabs cfv cY clt wbr cX cc wcel cX cc0 cif ce cfv cW cc wcel
    cW cc0 cif ce cfv cmin co cabs cfv cY cr wcel cc0 cY clt wbr wa cY c1 cif
    clt wbr cY cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq cY cX cc wcel cX cc0
    cif ce cfv cabs cfv cY caddc co cdiv co cY cr wcel cc0 cY clt wbr wa cY c1
    cif cX cc wcel cX cc0 cif ce cfv cabs cfv cY cr wcel cc0 cY clt wbr wa cY
    c1 cif caddc co cdiv co cX cc wcel cX cc0 cif cW cc wcel cW cc0 cif cmin co
    cabs cfv clt cY cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq cY cY cr wcel
    cc0 cY clt wbr wa cY c1 cif cX cc wcel cX cc0 cif ce cfv cabs cfv cY caddc
    co cX cc wcel cX cc0 cif ce cfv cabs cfv cY cr wcel cc0 cY clt wbr wa cY c1
    cif caddc co cdiv cY cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq id cY cY
    cr wcel cc0 cY clt wbr wa cY c1 cif cX cc wcel cX cc0 cif ce cfv cabs cfv
    caddc opreq2 opreq12d breq2d cY cY cr wcel cc0 cY clt wbr wa cY c1 cif cX
    cc wcel cX cc0 cif ce cfv cW cc wcel cW cc0 cif ce cfv cmin co cabs cfv clt
    breq2 imbi12d cW cc wcel cW cc0 cif cX cc wcel cX cc0 cif cY cr wcel cc0 cY
    clt wbr wa cY c1 cif cX cc0 cc 0cn elimel cW cc0 cc 0cn elimel cY cr wcel
    cc0 cY clt wbr wa cY c1 cif cr wcel cc0 cY cr wcel cc0 cY clt wbr wa cY c1
    cif clt wbr cY cr wcel cc0 cY clt wbr wa cY cr wcel cc0 cY clt wbr wa cY c1
    cif cr wcel cc0 cY cr wcel cc0 cY clt wbr wa cY c1 cif clt wbr wa c1 cr
    wcel cc0 c1 clt wbr wa cY c1 cY cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq
    cY cr wcel cY cr wcel cc0 cY clt wbr wa cY c1 cif cr wcel cc0 cY clt wbr
    cc0 cY cr wcel cc0 cY clt wbr wa cY c1 cif clt wbr cY cY cr wcel cc0 cY clt
    wbr wa cY c1 cif cr eleq1 cY cY cr wcel cc0 cY clt wbr wa cY c1 cif cc0 clt
    breq2 anbi12d c1 cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq c1 cr wcel cY
    cr wcel cc0 cY clt wbr wa cY c1 cif cr wcel cc0 c1 clt wbr cc0 cY cr wcel
    cc0 cY clt wbr wa cY c1 cif clt wbr c1 cY cr wcel cc0 cY clt wbr wa cY c1
    cif cr eleq1 c1 cY cr wcel cc0 cY clt wbr wa cY c1 cif cc0 clt breq2
    anbi12d c1 cr wcel cc0 c1 clt wbr 1re lt01 pm3.2i elimhyp pm3.26i cY cr
    wcel cc0 cY clt wbr wa cY c1 cif cr wcel cc0 cY cr wcel cc0 cY clt wbr wa
    cY c1 cif clt wbr cY cr wcel cc0 cY clt wbr wa cY cr wcel cc0 cY clt wbr wa
    cY c1 cif cr wcel cc0 cY cr wcel cc0 cY clt wbr wa cY c1 cif clt wbr wa c1
    cr wcel cc0 c1 clt wbr wa cY c1 cY cY cr wcel cc0 cY clt wbr wa cY c1 cif
    wceq cY cr wcel cY cr wcel cc0 cY clt wbr wa cY c1 cif cr wcel cc0 cY clt
    wbr cc0 cY cr wcel cc0 cY clt wbr wa cY c1 cif clt wbr cY cY cr wcel cc0 cY
    clt wbr wa cY c1 cif cr eleq1 cY cY cr wcel cc0 cY clt wbr wa cY c1 cif cc0
    clt breq2 anbi12d c1 cY cr wcel cc0 cY clt wbr wa cY c1 cif wceq c1 cr wcel
    cY cr wcel cc0 cY clt wbr wa cY c1 cif cr wcel cc0 c1 clt wbr cc0 cY cr
    wcel cc0 cY clt wbr wa cY c1 cif clt wbr c1 cY cr wcel cc0 cY clt wbr wa cY
    c1 cif cr eleq1 c1 cY cr wcel cc0 cY clt wbr wa cY c1 cif cc0 clt breq2
    anbi12d c1 cr wcel cc0 c1 clt wbr 1re lt01 pm3.2i elimhyp pm3.27i efcnlem3
    dedth3h $.
    $( [15-Sep-2007] $) $( [15-Sep-2007] $)

  ${
    $d w x y z $.
    $( The exponential function is continuous.  (Contributed by Paul Chapman,
       15-Sep-2007.) $)
    efcn $p |- exp e. ( CC -cn-> CC ) $=
      ce cc cc ccncf co wcel cc cc ce wf vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc
      wral vz crp wrex vy crp wral vx cc wral cc cc wss cc cc wss ce cc cc
      ccncf co wcel cc cc ce wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc wral vz
      crp wrex vy crp wral vx cc wral wa wb cc ssid cc ssid vx vy vz vw cc cc
      ce elcncf mp2an eff vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv ce
      cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc wral vz crp wrex
      vx vy cc crp vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co crp wcel
      vx cv vw cv cmin co cabs cfv vy cv vx cv ce cfv cabs cfv vy cv caddc co
      cdiv co clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr
      wi vw cc wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv ce cfv vw
      cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc wral vz crp wrex vx cv
      cc wcel vy cv crp wcel wa vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc wral vx cv
      vw cv cmin co cabs cfv vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co
      clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc
      wral vz vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co crp vz cv vy
      cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co wceq vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv
      clt wbr wi vx cv vw cv cmin co cabs cfv vy cv vx cv ce cfv cabs cfv vy cv
      caddc co cdiv co clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv
      clt wbr wi vw cc cc vz cv vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv
      co wceq vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vw cv cmin co
      cabs cfv vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co clt wbr wb vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv ce cfv vw cv ce cfv cmin co
      cabs cfv vy cv clt wbr wi vx cv vw cv cmin co cabs cfv vy cv vx cv ce cfv
      cabs cfv vy cv caddc co cdiv co clt wbr vx cv ce cfv vw cv ce cfv cmin co
      cabs cfv vy cv clt wbr wi wb vw cv cc wcel vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi
      wi vw cv cc wcel vx cv vw cv cmin co cabs cfv vy cv vx cv ce cfv cabs cfv
      vy cv caddc co cdiv co clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv
      vy cv clt wbr wi wi wb vz cv vy cv vx cv ce cfv cabs cfv vy cv caddc co
      cdiv co vx cv vw cv cmin co cabs cfv clt breq2 vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vw cv cmin co cabs cfv vy cv vx cv ce cfv cabs
      cfv vy cv caddc co cdiv co clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs
      cfv vy cv clt wbr imbi1 vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv
      ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vx cv vw cv cmin co
      cabs cfv vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co clt wbr vx cv
      ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cv cc wcel imbi2
      3syl ralbidv2 rcla4ev vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co
      crp wcel vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co cr wcel cc0
      vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co clt wbr vx cv cc wcel
      vy cv crp wcel wa vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co elrp
      vy cv cr wcel vx cv ce cfv cabs cfv vy cv caddc co cr wcel vx cv ce cfv
      cabs cfv vy cv caddc co cc0 wne vy cv vx cv ce cfv cabs cfv vy cv caddc
      co cdiv co cr wcel vx cv cc wcel vy cv crp wcel wa vy cv vx cv ce cfv
      cabs cfv vy cv caddc co redivcl vx cv cc wcel vy cv crp wcel wa vy cv cr
      wcel cc0 vy cv clt wbr vx cv cc wcel vy cv crp wcel wa vy cv crp wcel vy
      cv cr wcel cc0 vy cv clt wbr wa vx cv cc wcel vy cv crp wcel pm3.27 vy cv
      elrp sylib pm3.26d vx cv ce cfv cabs cfv cr wcel vy cv cr wcel vx cv ce
      cfv cabs cfv vy cv caddc co cr wcel vx cv cc wcel vy cv crp wcel wa vx cv
      ce cfv cabs cfv vy cv readdcl vx cv cc wcel vx cv ce cfv cabs cfv cr wcel
      vy cv crp wcel vx cv cc wcel vx cv ce cfv cc wcel vx cv ce cfv cabs cfv
      cr wcel vx cv efcl vx cv ce cfv abscl syl adantr vx cv cc wcel vy cv crp
      wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv cc wcel vy cv crp wcel wa
      vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv cc wcel vy cv crp
      wcel pm3.27 vy cv elrp sylib pm3.26d sylanc vx cv ce cfv cabs cfv vy cv
      caddc co cr wcel cc0 vx cv ce cfv cabs cfv vy cv caddc co clt wbr vx cv
      ce cfv cabs cfv vy cv caddc co cc0 wne vx cv cc wcel vy cv crp wcel wa vx
      cv ce cfv cabs cfv vy cv caddc co gt0ne0 vx cv ce cfv cabs cfv cr wcel vy
      cv cr wcel vx cv ce cfv cabs cfv vy cv caddc co cr wcel vx cv cc wcel vy
      cv crp wcel wa vx cv ce cfv cabs cfv vy cv readdcl vx cv cc wcel vx cv ce
      cfv cabs cfv cr wcel vy cv crp wcel vx cv cc wcel vx cv ce cfv cc wcel vx
      cv ce cfv cabs cfv cr wcel vx cv efcl vx cv ce cfv abscl syl adantr vx cv
      cc wcel vy cv crp wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv cc wcel
      vy cv crp wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv
      cc wcel vy cv crp wcel pm3.27 vy cv elrp sylib pm3.26d sylanc vx cv ce
      cfv cabs cfv cr wcel vy cv cr wcel cc0 vx cv ce cfv cabs cfv clt wbr cc0
      vy cv clt wbr cc0 vx cv ce cfv cabs cfv vy cv caddc co clt wbr vx cv cc
      wcel vy cv crp wcel wa vx cv ce cfv cabs cfv vy cv addgt0 vx cv cc wcel
      vx cv ce cfv cabs cfv cr wcel vy cv crp wcel vx cv cc wcel vx cv ce cfv
      cc wcel vx cv ce cfv cabs cfv cr wcel vx cv efcl vx cv ce cfv abscl syl
      adantr vx cv cc wcel vy cv crp wcel wa vy cv cr wcel cc0 vy cv clt wbr vx
      cv cc wcel vy cv crp wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt
      wbr wa vx cv cc wcel vy cv crp wcel pm3.27 vy cv elrp sylib pm3.26d vx cv
      cc wcel cc0 vx cv ce cfv cabs cfv clt wbr vy cv crp wcel vx cv cc wcel vx
      cv ce cfv cc0 wne cc0 vx cv ce cfv cabs cfv clt wbr vx cv efne0 vx cv cc
      wcel vx cv ce cfv cc wcel vx cv ce cfv cc0 wne cc0 vx cv ce cfv cabs cfv
      clt wbr wb vx cv efcl vx cv ce cfv absgt0 syl mpbid adantr vx cv cc wcel
      vy cv crp wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv cc wcel vy cv crp
      wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv cc wcel
      vy cv crp wcel pm3.27 vy cv elrp sylib pm3.27d syl2anc sylanc syl3anc vy
      cv cr wcel cc0 vy cv clt wbr wa vx cv ce cfv cabs cfv vy cv caddc co cr
      wcel cc0 vx cv ce cfv cabs cfv vy cv caddc co clt wbr wa cc0 vy cv vx cv
      ce cfv cabs cfv vy cv caddc co cdiv co clt wbr vx cv cc wcel vy cv crp
      wcel wa vy cv vx cv ce cfv cabs cfv vy cv caddc co divgt0 vx cv cc wcel
      vy cv crp wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv
      cc wcel vy cv crp wcel pm3.27 vy cv elrp sylib vx cv cc wcel vy cv crp
      wcel wa vx cv ce cfv cabs cfv vy cv caddc co cr wcel cc0 vx cv ce cfv
      cabs cfv vy cv caddc co clt wbr vx cv ce cfv cabs cfv cr wcel vy cv cr
      wcel vx cv ce cfv cabs cfv vy cv caddc co cr wcel vx cv cc wcel vy cv crp
      wcel wa vx cv ce cfv cabs cfv vy cv readdcl vx cv cc wcel vx cv ce cfv
      cabs cfv cr wcel vy cv crp wcel vx cv cc wcel vx cv ce cfv cc wcel vx cv
      ce cfv cabs cfv cr wcel vx cv efcl vx cv ce cfv abscl syl adantr vx cv cc
      wcel vy cv crp wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv cc wcel vy
      cv crp wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv cc
      wcel vy cv crp wcel pm3.27 vy cv elrp sylib pm3.26d sylanc vx cv ce cfv
      cabs cfv cr wcel vy cv cr wcel cc0 vx cv ce cfv cabs cfv clt wbr cc0 vy
      cv clt wbr cc0 vx cv ce cfv cabs cfv vy cv caddc co clt wbr vx cv cc wcel
      vy cv crp wcel wa vx cv ce cfv cabs cfv vy cv addgt0 vx cv cc wcel vx cv
      ce cfv cabs cfv cr wcel vy cv crp wcel vx cv cc wcel vx cv ce cfv cc wcel
      vx cv ce cfv cabs cfv cr wcel vx cv efcl vx cv ce cfv abscl syl adantr vx
      cv cc wcel vy cv crp wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv cc
      wcel vy cv crp wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa
      vx cv cc wcel vy cv crp wcel pm3.27 vy cv elrp sylib pm3.26d vx cv cc
      wcel cc0 vx cv ce cfv cabs cfv clt wbr vy cv crp wcel vx cv cc wcel vx cv
      ce cfv cc0 wne cc0 vx cv ce cfv cabs cfv clt wbr vx cv efne0 vx cv cc
      wcel vx cv ce cfv cc wcel vx cv ce cfv cc0 wne cc0 vx cv ce cfv cabs cfv
      clt wbr wb vx cv efcl vx cv ce cfv absgt0 syl mpbid adantr vx cv cc wcel
      vy cv crp wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv cc wcel vy cv crp
      wcel wa vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv cc wcel
      vy cv crp wcel pm3.27 vy cv elrp sylib pm3.27d syl2anc jca sylanc
      sylanbrc vx cv cc wcel vy cv crp wcel wa vx cv vw cv cmin co cabs cfv vy
      cv vx cv ce cfv cabs cfv vy cv caddc co cdiv co clt wbr vx cv ce cfv vw
      cv ce cfv cmin co cabs cfv vy cv clt wbr wi vw cc vw cv cc wcel vx cv cc
      wcel vy cv crp wcel wa vx cv vw cv cmin co cabs cfv vy cv vx cv ce cfv
      cabs cfv vy cv caddc co cdiv co clt wbr vx cv ce cfv vw cv ce cfv cmin co
      cabs cfv vy cv clt wbr wi vw cv cc wcel vx cv cc wcel vy cv crp wcel wa
      wa vx cv cc wcel vw cv cc wcel vy cv cr wcel cc0 vy cv clt wbr wa w3a vx
      cv vw cv cmin co cabs cfv vy cv vx cv ce cfv cabs cfv vy cv caddc co cdiv
      co clt wbr vx cv ce cfv vw cv ce cfv cmin co cabs cfv vy cv clt wbr wi vx
      cv cc wcel vw cv cc wcel vy cv crp wcel w3a vw cv cc wcel vx cv cc wcel
      vy cv crp wcel w3a vx cv cc wcel vw cv cc wcel vy cv cr wcel cc0 vy cv
      clt wbr wa w3a vw cv cc wcel vx cv cc wcel vy cv crp wcel wa wa vx cv cc
      wcel vw cv cc wcel vy cv crp wcel 3ancoma vy cv crp wcel vy cv cr wcel
      cc0 vy cv clt wbr wa vx cv cc wcel vw cv cc wcel vy cv elrp 3anbi3i vw cv
      cc wcel vx cv cc wcel vy cv crp wcel 3anass 3bitr3i vw cv vx cv vy cv
      efcnlem4 sylbir expcom r19.21aiv sylanc rgen2 mpbir2an $.
      $( [27-Nov-2007] $) $( [15-Sep-2007] $)
  $}

  ${
    $d C y $.  $d U x y $.
    reeff1olem1.1 $e |- U e. RR $.
    reeff1olem1.2 $e |- 1 < U $.
    reeff1olem1.3 $e |- S = { x e. ( 0 [,] U ) | ( exp ` x ) = U } $.
    reeff1olem1.4 $e |- C = sup ( S , RR , < ) $.
    $( Lemma for ~ reeff1o . $)
    reeff1olem1 $p |- E. y e. RR ( exp ` y ) = U $=
      cC cr wcel cC ce cfv cU wceq wa vy cv ce cfv cU wceq vy cr wrex cC cc0 cU
      cioo co wcel cC ce cfv cU wceq wa cC cr wcel cC ce cfv cU wceq wa vx cc0
      cU cC cc cS cU ce 0re reeff1olem1.1 reeff1olem1.1 cc0 c1 clt wbr c1 cU
      clt wbr cc0 cU clt wbr lt01 reeff1olem1.2 cc0 c1 cU 0re 1re reeff1olem1.1
      lttri mp2an cc0 cU cicc co cr cc vx cc0 cU cicc co cr vx cv cc0 cU cicc
      co wcel vx cv cr wcel cc0 vx cv cle wbr vx cv cU cle wbr vx cv cc0 cU
      cicc co wcel vx cv cr wcel cc0 vx cv cle wbr vx cv cU cle wbr w3a cc0 cr
      wcel cU cr wcel vx cv cc0 cU cicc co wcel vx cv cr wcel cc0 vx cv cle wbr
      vx cv cU cle wbr w3a wb 0re reeff1olem1.1 cc0 cU vx cv elicc2 mp2an
      biimpi 3simp1d ssriv axresscn sstri cc ssid efcn vx cv cc0 cU cicc co
      wcel vx cv cr wcel vx cv ce cfv cr wcel vx cv cc0 cU cicc co wcel vx cv
      cr wcel cc0 vx cv cle wbr vx cv cU cle wbr vx cv cc0 cU cicc co wcel vx
      cv cr wcel cc0 vx cv cle wbr vx cv cU cle wbr w3a cc0 cr wcel cU cr wcel
      vx cv cc0 cU cicc co wcel vx cv cr wcel cc0 vx cv cle wbr vx cv cU cle
      wbr w3a wb 0re reeff1olem1.1 cc0 cU vx cv elicc2 mp2an biimpi 3simp1d vx
      cv reefcl syl reeff1olem1.3 cc0 ce cfv cU clt wbr cU cU ce cfv clt wbr
      cc0 ce cfv c1 cU clt ef0 reeff1olem1.2 eqbrtri cU cU c1 caddc co clt wbr
      cU c1 caddc co cU ce cfv cle wbr cU cU ce cfv clt wbr cU reeff1olem1.1
      ltp1i c1 cU caddc co cU c1 caddc co cU ce cfv cle c1 cU ax1cn cU
      reeff1olem1.1 recni addcomi cc0 cU cle wbr c1 cU caddc co cU ce cfv cle
      wbr cc0 cU 0re reeff1olem1.1 cc0 c1 clt wbr c1 cU clt wbr cc0 cU clt wbr
      lt01 reeff1olem1.2 cc0 c1 cU 0re 1re reeff1olem1.1 lttri mp2an ltleii cU
      reeff1olem1.1 efge1pi ax-mp eqbrtrri cU cU c1 caddc co cU ce cfv
      reeff1olem1.1 cU c1 reeff1olem1.1 1re readdcli cU reeff1olem1.1 reefcli
      ltletri mp2an pm3.2i reeff1olem1.4 isupivthi cC cc0 cU cioo co wcel cC cr
      wcel cC ce cfv cU wceq cC cc0 cU elioore anim1i ax-mp vy cv ce cfv cU
      wceq cC ce cfv cU wceq vy cC cr vy cv cC wceq vy cv ce cfv cC ce cfv cU
      vy cv cC ce fveq2 eqeq1d rcla4ev ax-mp $.
      $( [22-Jan-2008] $) $( [18-Oct-2007] $)
  $}

  ${
    $d U x y $.
    $( Lemma for ~ reeff1o . $)
    reeff1olem2 $p |- ( ( U e. RR /\ 1 < U ) -> E. x e. RR ( exp ` x ) = U ) $=
      cU cr wcel c1 cU clt wbr wa vx cv ce cfv cU wceq vx cr wrex vx cv ce cfv
      cU cr wcel c1 cU clt wbr wa cU c2 cif wceq vx cr wrex cU c2 cU cU cr wcel
      c1 cU clt wbr wa cU c2 cif wceq vx cv ce cfv cU wceq vx cv ce cfv cU cr
      wcel c1 cU clt wbr wa cU c2 cif wceq vx cr cU cU cr wcel c1 cU clt wbr wa
      cU c2 cif vx cv ce cfv eqeq2 rexbidv vy vx vy cv ce cfv cU cr wcel c1 cU
      clt wbr wa cU c2 cif wceq vy cc0 cU cr wcel c1 cU clt wbr wa cU c2 cif
      cicc co crab cr clt csup vy cv ce cfv cU cr wcel c1 cU clt wbr wa cU c2
      cif wceq vy cc0 cU cr wcel c1 cU clt wbr wa cU c2 cif cicc co crab cU cr
      wcel c1 cU clt wbr wa cU c2 cif cU cr wcel c1 cU clt wbr wa cU c2 cif cr
      wcel c1 cU cr wcel c1 cU clt wbr wa cU c2 cif clt wbr cU cr wcel c1 cU
      clt wbr wa cU cr wcel c1 cU clt wbr wa cU c2 cif cr wcel c1 cU cr wcel c1
      cU clt wbr wa cU c2 cif clt wbr wa c2 cr wcel c1 c2 clt wbr wa cU c2 cU
      cU cr wcel c1 cU clt wbr wa cU c2 cif wceq cU cr wcel cU cr wcel c1 cU
      clt wbr wa cU c2 cif cr wcel c1 cU clt wbr c1 cU cr wcel c1 cU clt wbr wa
      cU c2 cif clt wbr cU cU cr wcel c1 cU clt wbr wa cU c2 cif cr eleq1 cU cU
      cr wcel c1 cU clt wbr wa cU c2 cif c1 clt breq2 anbi12d c2 cU cr wcel c1
      cU clt wbr wa cU c2 cif wceq c2 cr wcel cU cr wcel c1 cU clt wbr wa cU c2
      cif cr wcel c1 c2 clt wbr c1 cU cr wcel c1 cU clt wbr wa cU c2 cif clt
      wbr c2 cU cr wcel c1 cU clt wbr wa cU c2 cif cr eleq1 c2 cU cr wcel c1 cU
      clt wbr wa cU c2 cif c1 clt breq2 anbi12d c2 cr wcel c1 c2 clt wbr 2re
      1lt2 pm3.2i elimhyp pm3.26i cU cr wcel c1 cU clt wbr wa cU c2 cif cr wcel
      c1 cU cr wcel c1 cU clt wbr wa cU c2 cif clt wbr cU cr wcel c1 cU clt wbr
      wa cU cr wcel c1 cU clt wbr wa cU c2 cif cr wcel c1 cU cr wcel c1 cU clt
      wbr wa cU c2 cif clt wbr wa c2 cr wcel c1 c2 clt wbr wa cU c2 cU cU cr
      wcel c1 cU clt wbr wa cU c2 cif wceq cU cr wcel cU cr wcel c1 cU clt wbr
      wa cU c2 cif cr wcel c1 cU clt wbr c1 cU cr wcel c1 cU clt wbr wa cU c2
      cif clt wbr cU cU cr wcel c1 cU clt wbr wa cU c2 cif cr eleq1 cU cU cr
      wcel c1 cU clt wbr wa cU c2 cif c1 clt breq2 anbi12d c2 cU cr wcel c1 cU
      clt wbr wa cU c2 cif wceq c2 cr wcel cU cr wcel c1 cU clt wbr wa cU c2
      cif cr wcel c1 c2 clt wbr c1 cU cr wcel c1 cU clt wbr wa cU c2 cif clt
      wbr c2 cU cr wcel c1 cU clt wbr wa cU c2 cif cr eleq1 c2 cU cr wcel c1 cU
      clt wbr wa cU c2 cif c1 clt breq2 anbi12d c2 cr wcel c1 c2 clt wbr 2re
      1lt2 pm3.2i elimhyp pm3.27i vy cv ce cfv cU cr wcel c1 cU clt wbr wa cU
      c2 cif wceq vy cc0 cU cr wcel c1 cU clt wbr wa cU c2 cif cicc co crab
      eqid vy cv ce cfv cU cr wcel c1 cU clt wbr wa cU c2 cif wceq vy cc0 cU cr
      wcel c1 cU clt wbr wa cU c2 cif cicc co crab cr clt csup eqid reeff1olem1
      dedth $.
      $( [22-Jan-2008] $) $( [18-Oct-2007] $)
  $}

  ${
    $d k p q $.  $d x y z $.
    $( The real exponential function is one-to-one onto.  (Contributed by Paul
       Chapman, 18-Oct-2007.) $)
    reeff1o $p |- ( exp |` RR ) : RR -1-1-onto-> ( 0 (,) +oo ) $=
      cr cc0 cpnf cioo co ce cr cres wf1o cr cc0 cpnf cioo co ce cr cres wf1 cr
      cc0 cpnf cioo co ce cr cres wfo cr cc0 cpnf cioo co ce cr cres df-f1o
      reeff1 cr cc0 cpnf cioo co ce cr cres wfo ce cr cres cr wfn ce cr cres
      crn cc0 cpnf cioo co wceq cr cc0 cpnf cioo co ce cr cres df-fo ce cr cres
      cr wfn cr cc wss axresscn ce cc wfn ce cr cres cr wfn cr cc wss wb vp vq
      cc cn0 vp cv vk cv cexp co vk cv cfa cfv cdiv co vk csu ce cn0 vp cv vk
      cv cexp co vk cv cfa cfv cdiv co vk sumex vp vq vk df-ef fnopab2 cc cr ce
      fnssresb ax-mp mpbir ce cr cres crn cc0 cpnf cioo co ce cr cres cr wfn ce
      cr cres crn cc0 cpnf cioo co wss cr cc0 cpnf cioo co ce cr cres wf ce cr
      cres cr wfn ce cr cres crn cc0 cpnf cioo co wss wa cr cc0 cpnf cioo co ce
      cr cres wf ce cr cres ccnv wfun cr cc0 cpnf cioo co ce cr cres wf1 cr cc0
      cpnf cioo co ce cr cres wf ce cr cres ccnv wfun wa reeff1 cr cc0 cpnf
      cioo co ce cr cres df-f1 mpbi pm3.26i cr cc0 cpnf cioo co ce cr cres df-f
      mpbi pm3.27i vz cc0 cpnf cioo co ce cr cres crn vz cv cc0 cpnf cioo co
      wcel vx cv ce cr cres cfv vz cv wceq vx cr wrex vz cv ce cr cres crn wcel
      vz cv cr wcel cc0 vz cv clt wbr wa vx cv ce cfv vz cv wceq vx cr wrex vz
      cv cc0 cpnf cioo co wcel vx cv ce cr cres cfv vz cv wceq vx cr wrex vz cv
      cr wcel cc0 vz cv clt wbr wa vz cv c1 clt wbr vz cv c1 wceq wo c1 vz cv
      clt wbr wo vx cv ce cfv vz cv wceq vx cr wrex vz cv cr wcel vz cv c1 clt
      wbr vz cv c1 wceq wo c1 vz cv clt wbr wo cc0 vz cv clt wbr vz cv cr wcel
      c1 cr wcel vz cv c1 clt wbr vz cv c1 wceq wo c1 vz cv clt wbr wo 1re vz
      cv cr wcel c1 cr wcel wa vz cv c1 cle wbr c1 vz cv clt wbr wo vz cv c1
      clt wbr vz cv c1 wceq wo c1 vz cv clt wbr wo vz cv c1 lelttric vz cv cr
      wcel c1 cr wcel wa vz cv c1 cle wbr vz cv c1 clt wbr vz cv c1 wceq wo c1
      vz cv clt wbr vz cv c1 leloe orbi1d mpbid mpan2 adantr vz cv cr wcel cc0
      vz cv clt wbr wa vz cv c1 clt wbr vz cv c1 wceq wo vx cv ce cfv vz cv
      wceq vx cr wrex c1 vz cv clt wbr vz cv cr wcel cc0 vz cv clt wbr wa vz cv
      c1 clt wbr vx cv ce cfv vz cv wceq vx cr wrex vz cv c1 wceq vz cv cr wcel
      cc0 vz cv clt wbr wa vz cv c1 clt wbr vx cv ce cfv vz cv wceq vx cr wrex
      vz cv cr wcel cc0 vz cv clt wbr wa vz cv c1 clt wbr c1 c1 vz cv cdiv co
      clt wbr vx cv ce cfv vz cv wceq vx cr wrex vz cv reclt1 vz cv cr wcel cc0
      vz cv clt wbr wa c1 c1 vz cv cdiv co clt wbr vx cv ce cfv vz cv wceq vx
      cr wrex vz cv cr wcel cc0 vz cv clt wbr wa c1 c1 vz cv cdiv co clt wbr wa
      vy cv cneg ce cfv vz cv wceq vy cr wrex vx cv ce cfv vz cv wceq vx cr
      wrex vz cv cr wcel cc0 vz cv clt wbr wa c1 c1 vz cv cdiv co clt wbr wa vy
      cv ce cfv c1 vz cv cdiv co wceq vy cr wrex vy cv cneg ce cfv vz cv wceq
      vy cr wrex c1 vz cv cdiv co cr wcel c1 c1 vz cv cdiv co clt wbr vy cv ce
      cfv c1 vz cv cdiv co wceq vy cr wrex vz cv cr wcel cc0 vz cv clt wbr wa
      vy c1 vz cv cdiv co reeff1olem2 vz cv cr wcel cc0 vz cv clt wbr vz cv cc0
      wne c1 vz cv cdiv co cr wcel vz cv gt0ne0 vz cv rereccl syldan sylan vz
      cv cr wcel cc0 vz cv clt wbr wa vy cv ce cfv c1 vz cv cdiv co wceq vy cr
      wrex vy cv cneg ce cfv vz cv wceq vy cr wrex wi c1 c1 vz cv cdiv co clt
      wbr vz cv cr wcel cc0 vz cv clt wbr wa vy cv ce cfv c1 vz cv cdiv co wceq
      vy cv cneg ce cfv vz cv wceq vy cr vz cv cr wcel cc0 vz cv clt wbr wa vy
      cv cr wcel wa vy cv ce cfv c1 vz cv cdiv co wceq vy cv cneg ce cfv vz cv
      wceq vz cv cr wcel cc0 vz cv clt wbr wa vy cv cr wcel wa c1 vz cv cdiv co
      vy cv ce cfv wceq vy cv cneg ce cfv vz cv wceq vy cv ce cfv c1 vz cv cdiv
      co wceq vz cv cr wcel cc0 vz cv clt wbr wa vy cv cr wcel wa c1 vz cv cdiv
      co vy cv ce cfv wceq c1 vy cv ce cfv cdiv co vz cv wceq vy cv cneg ce cfv
      vz cv wceq vz cv cc wcel vz cv cc0 wne wa vy cv ce cfv cc wcel vy cv ce
      cfv cc0 wne wa c1 vz cv cdiv co vy cv ce cfv wceq c1 vy cv ce cfv cdiv co
      vz cv wceq wb vz cv cr wcel cc0 vz cv clt wbr wa vy cv cr wcel vz cv vy
      cv ce cfv rec11r vz cv cr wcel cc0 vz cv clt wbr wa vz cv cc wcel vz cv
      cc0 wne vz cv cr wcel vz cv cc wcel cc0 vz cv clt wbr vz cv recn adantr
      vz cv gt0ne0 jca vy cv cr wcel vy cv ce cfv cc wcel vy cv ce cfv cc0 wne
      vy cv cr wcel vy cv cc wcel vy cv ce cfv cc wcel vy cv recn vy cv efcl
      syl vy cv cr wcel vy cv cc wcel vy cv ce cfv cc0 wne vy cv recn vy cv
      efne0 syl jca syl2an vy cv cr wcel c1 vy cv ce cfv cdiv co vz cv wceq vy
      cv cneg ce cfv vz cv wceq wb vz cv cr wcel cc0 vz cv clt wbr wa vy cv cr
      wcel c1 vy cv ce cfv cdiv co vy cv cneg ce cfv vz cv vy cv cr wcel vy cv
      cc wcel c1 vy cv ce cfv cdiv co vy cv cneg ce cfv wceq vy cv recn vy cv
      cc wcel c1 vy cv ce cfv cdiv co vy cv cneg ce cfv wceq c1 vy cv ce cfv vy
      cv cneg ce cfv cmul co wceq vy cv cc wcel vy cv ce cfv vy cv cneg ce cfv
      cmul co c1 vy cv efcan eqcomd vy cv cneg ce cfv cc wcel vy cv ce cfv cc
      wcel vy cv ce cfv cc0 wne wa c1 vy cv ce cfv cdiv co vy cv cneg ce cfv
      wceq c1 vy cv ce cfv vy cv cneg ce cfv cmul co wceq wb vy cv cc wcel c1
      cc wcel vy cv cneg ce cfv cc wcel vy cv ce cfv cc wcel vy cv ce cfv cc0
      wne wa c1 vy cv ce cfv cdiv co vy cv cneg ce cfv wceq c1 vy cv ce cfv vy
      cv cneg ce cfv cmul co wceq wb ax1cn c1 vy cv cneg ce cfv vy cv ce cfv
      divmul2 mp3an1 vy cv cc wcel vy cv cneg cc wcel vy cv cneg ce cfv cc wcel
      vy cv negcl vy cv cneg efcl syl vy cv cc wcel vy cv ce cfv cc wcel vy cv
      ce cfv cc0 wne vy cv efcl vy cv efne0 jca sylanc mpbird syl eqeq1d adantl
      bitrd c1 vz cv cdiv co vy cv ce cfv eqcom syl5bbr biimpd r19.22dva adantr
      mpd vx cv ce cfv vz cv wceq vy cv cneg ce cfv vz cv wceq vx vy vy cv cneg
      cr vy cv renegcl vx vy infm3lem vx cv vy cv cneg wceq vx cv ce cfv vy cv
      cneg ce cfv vz cv vx cv vy cv cneg ce fveq2 eqeq1d rexxfr sylibr ex
      sylbid imp vz cv c1 wceq vx cv ce cfv vz cv wceq vx cr wrex vz cv cr wcel
      cc0 vz cv clt wbr wa vz cv c1 wceq vz cv cc0 ce cfv wceq vx cv ce cfv vz
      cv wceq vx cr wrex cc0 ce cfv c1 vz cv ef0 eqeq2i vx cv ce cfv vz cv wceq
      vx cr wrex cc0 ce cfv vz cv cc0 cr wcel cc0 ce cfv vz cv wceq vx cv ce
      cfv vz cv wceq vx cr wrex 0re vx cv ce cfv vz cv wceq cc0 ce cfv vz cv
      wceq vx cc0 cr vx cv cc0 wceq vx cv ce cfv cc0 ce cfv vz cv vx cv cc0 ce
      fveq2 eqeq1d rcla4ev mpan eqcoms sylbir adantl jaodan vz cv cr wcel c1 vz
      cv clt wbr vx cv ce cfv vz cv wceq vx cr wrex cc0 vz cv clt wbr vx vz cv
      reeff1olem2 adantlr jaodan mpdan vz cv repos vx cv ce cr cres cfv vz cv
      wceq vx cv ce cfv vz cv wceq vx cr vx cv cr wcel vx cv ce cr cres cfv vx
      cv ce cfv vz cv vx cv cr ce fvres eqeq1d rexbiia 3imtr4i ce cr cres cr
      wfn vz cv ce cr cres crn wcel vx cv ce cr cres cfv vz cv wceq vx cr wrex
      wb ce cr cres cr wfn cr cc wss axresscn ce cc wfn ce cr cres cr wfn cr cc
      wss wb vp vq cc cn0 vp cv vk cv cexp co vk cv cfa cfv cdiv co vk csu ce
      cn0 vp cv vk cv cexp co vk cv cfa cfv cdiv co vk sumex vp vq vk df-ef
      fnopab2 cc cr ce fnssresb ax-mp mpbir vx cr vz cv ce cr cres fvelrnb
      ax-mp sylibr ssriv eqssi mpbir2an mpbir2an $.
      $( [18-Oct-2007] $) $( [18-Oct-2007] $)
  $}

  $( The real exponential function is one-to-one onto.  (Contributed by Steve
     Rodriguez, 25-Nov-2007.) $)
  reeff1o2 $p |- ( exp |` RR ) : RR -1-1-onto-> RR+ $=
    cr cc0 cpnf cioo co ce cr cres wf1o cr crp ce cr cres wf1o reeff1o cc0 cpnf
    cioo co crp wceq cr cc0 cpnf cioo co ce cr cres wf1o cr crp ce cr cres wf1o
    wb ioorp cc0 cpnf cioo co crp cr ce cr cres f1oeq3 ax-mp mpbi $.
    $( [25-Nov-2007] $) $( [25-Nov-2007] $)

  ${
    $d x y $.
    $( The exponential function on the reals determines an isomorphism from
       reals onto positive reals.  (Contributed by Steve Rodriguez,
       25-Nov-2007.) $)
    reefiso $p |- ( exp |` RR ) Isom < , < ( RR , RR+ ) $=
      cr crp clt clt ce cr cres wiso cr crp ce cr cres wf1o vx cv vy cv clt wbr
      vx cv ce cr cres cfv vy cv ce cr cres cfv clt wbr wb vy cr wral vx cr
      wral vx vy cr crp clt clt ce cr cres df-iso reeff1o2 vx cv vy cv clt wbr
      vx cv ce cr cres cfv vy cv ce cr cres cfv clt wbr wb vx vy cr vx cv cr
      wcel vy cv cr wcel vx cv vy cv clt wbr vx cv ce cr cres cfv vy cv ce cr
      cres cfv clt wbr wb vx cv cr wcel vx cv cc0 cif vy cv clt wbr vx cv cr
      wcel vx cv cc0 cif ce cr cres cfv vy cv ce cr cres cfv clt wbr wb vx cv
      cr wcel vx cv cc0 cif vy cv cr wcel vy cv cc0 cif clt wbr vx cv cr wcel
      vx cv cc0 cif ce cr cres cfv vy cv cr wcel vy cv cc0 cif ce cr cres cfv
      clt wbr wb vx cv vy cv cc0 cc0 vx cv vx cv cr wcel vx cv cc0 cif wceq vx
      cv vy cv clt wbr vx cv cr wcel vx cv cc0 cif vy cv clt wbr vx cv ce cr
      cres cfv vy cv ce cr cres cfv clt wbr vx cv cr wcel vx cv cc0 cif ce cr
      cres cfv vy cv ce cr cres cfv clt wbr vx cv vx cv cr wcel vx cv cc0 cif
      vy cv clt breq1 vx cv vx cv cr wcel vx cv cc0 cif wceq vx cv ce cr cres
      cfv vx cv cr wcel vx cv cc0 cif ce cr cres cfv vy cv ce cr cres cfv clt
      vx cv vx cv cr wcel vx cv cc0 cif ce cr cres fveq2 breq1d bibi12d vy cv
      vy cv cr wcel vy cv cc0 cif wceq vx cv cr wcel vx cv cc0 cif vy cv clt
      wbr vx cv cr wcel vx cv cc0 cif vy cv cr wcel vy cv cc0 cif clt wbr vx cv
      cr wcel vx cv cc0 cif ce cr cres cfv vy cv ce cr cres cfv clt wbr vx cv
      cr wcel vx cv cc0 cif ce cr cres cfv vy cv cr wcel vy cv cc0 cif ce cr
      cres cfv clt wbr vy cv vy cv cr wcel vy cv cc0 cif vx cv cr wcel vx cv
      cc0 cif clt breq2 vy cv vy cv cr wcel vy cv cc0 cif wceq vy cv ce cr cres
      cfv vy cv cr wcel vy cv cc0 cif ce cr cres cfv vx cv cr wcel vx cv cc0
      cif ce cr cres cfv clt vy cv vy cv cr wcel vy cv cc0 cif ce cr cres fveq2
      breq2d bibi12d vx cv cr wcel vx cv cc0 cif vy cv cr wcel vy cv cc0 cif
      clt wbr vx cv cr wcel vx cv cc0 cif ce cfv vy cv cr wcel vy cv cc0 cif ce
      cfv clt wbr vx cv cr wcel vx cv cc0 cif ce cr cres cfv vy cv cr wcel vy
      cv cc0 cif ce cr cres cfv clt wbr vx cv cr wcel vx cv cc0 cif vy cv cr
      wcel vy cv cc0 cif vx cv cc0 cr 0re elimel vy cv cc0 cr 0re elimel efltbi
      vx cv cr wcel vx cv cc0 cif ce cr cres cfv vx cv cr wcel vx cv cc0 cif ce
      cfv vy cv cr wcel vy cv cc0 cif ce cr cres cfv vy cv cr wcel vy cv cc0
      cif ce cfv clt vx cv cr wcel vx cv cc0 cif cr wcel vx cv cr wcel vx cv
      cc0 cif ce cr cres cfv vx cv cr wcel vx cv cc0 cif ce cfv wceq vx cv cc0
      cr 0re elimel vx cv cr wcel vx cv cc0 cif cr ce fvres ax-mp vy cv cr wcel
      vy cv cc0 cif cr wcel vy cv cr wcel vy cv cc0 cif ce cr cres cfv vy cv cr
      wcel vy cv cc0 cif ce cfv wceq vy cv cc0 cr 0re elimel vy cv cr wcel vy
      cv cc0 cif cr ce fvres ax-mp breq12i bitr4i dedth2h rgen2a mpbir2an $.
      $( [25-Nov-2007] $) $( [25-Nov-2007] $)
  $}

  ${
    $d x y A $.
    $( Value of the sine function. $)
    sinval $p |- ( A e. CC -> ( sin ` A ) =
    ( ( ( exp ` ( _i x. A ) ) - ( exp ` ( -u _i x. A ) ) ) / ( 2 x. _i ) ) ) $=
      vx vy cA ci vx cv cmul co ce cfv ci cneg vx cv cmul co ce cfv cmin co c2
      ci cmul co cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co
      c2 ci cmul co cdiv co cc csin vx cv cA wceq ci vx cv cmul co ce cfv ci
      cneg vx cv cmul co ce cfv cmin co ci cA cmul co ce cfv ci cneg cA cmul co
      ce cfv cmin co c2 ci cmul co cdiv vx cv cA wceq ci vx cv cmul co ce cfv
      ci cA cmul co ce cfv ci cneg vx cv cmul co ce cfv ci cneg cA cmul co ce
      cfv cmin vx cv cA wceq ci vx cv cmul co ci cA cmul co ce vx cv cA ci cmul
      opreq2 fveq2d vx cv cA wceq ci cneg vx cv cmul co ci cneg cA cmul co ce
      vx cv cA ci cneg cmul opreq2 fveq2d opreq12d opreq1d vx vy df-sin ci cA
      cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci cmul co cdiv oprex
      fvopab4 $.
      $( [28-Mar-2005] $) $( [14-Mar-2005] $)

    $( Value of the cosine function. $)
    cosval $p |- ( A e. CC -> ( cos ` A ) =
       ( ( ( exp ` ( _i x. A ) ) + ( exp ` ( -u _i x. A ) ) ) / 2 ) ) $=
      vx vy cA ci vx cv cmul co ce cfv ci cneg vx cv cmul co ce cfv caddc co c2
      cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2 cdiv
      co cc ccos vx cv cA wceq ci vx cv cmul co ce cfv ci cneg vx cv cmul co ce
      cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2
      cdiv vx cv cA wceq ci vx cv cmul co ce cfv ci cA cmul co ce cfv ci cneg
      vx cv cmul co ce cfv ci cneg cA cmul co ce cfv caddc vx cv cA wceq ci vx
      cv cmul co ci cA cmul co ce vx cv cA ci cmul opreq2 fveq2d vx cv cA wceq
      ci cneg vx cv cmul co ci cneg cA cmul co ce vx cv cA ci cneg cmul opreq2
      fveq2d opreq12d opreq1d vx vy df-cos ci cA cmul co ce cfv ci cneg cA cmul
      co ce cfv caddc co c2 cdiv oprex fvopab4 $.
      $( [9-Jun-2005] $) $( [14-Mar-2005] $)
  $}

  $( Closure of the sine function. $)
  sincl $p |- ( A e. CC -> ( sin ` A ) e. CC ) $=
    cA cc wcel cA csin cfv ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin
    co c2 ci cmul co cdiv co cc cA sinval cA cc wcel ci cA cmul co ce cfv cc
    wcel ci cneg cA cmul co ce cfv cc wcel wa ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv cmin co cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co c2 ci cmul co cdiv co cc wcel cA cc wcel ci cA cmul co ce cfv
    cc wcel ci cneg cA cmul co ce cfv cc wcel cA cc wcel ci cA cmul co cc wcel
    ci cA cmul co ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel
    axicn ci cA mulcl mpan ci cA cmul co efcl syl cA cc wcel ci cneg cA cmul co
    cc wcel ci cneg cA cmul co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci
    cneg cA cmul co cc wcel ci axicn negcli ci cneg cA mulcl mpan ci cneg cA
    cmul co efcl syl jca ci cA cmul co ce cfv ci cneg cA cmul co ce cfv subcl
    ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc wcel c2 ci cmul
    co cc wcel c2 ci cmul co cc0 wne ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co c2 ci cmul co cdiv co cc wcel c2 ci 2cn axicn mulcli c2 ci 2cn
    axicn 2ne0 ine0 muln0i ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin
    co c2 ci cmul co divcl mp3an23 3syl eqeltrd $.
    $( [3-Jun-2005] $) $( [28-Apr-2005] $)

  $( Closure of the cosine function with a complex argument. $)
  coscl $p |- ( A e. CC -> ( cos ` A ) e. CC ) $=
    cA cc wcel cA ccos cfv ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc
    co c2 cdiv co cc cA cosval cA cc wcel ci cA cmul co ce cfv cc wcel ci cneg
    cA cmul co ce cfv cc wcel wa ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    caddc co cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2
    cdiv co cc wcel cA cc wcel ci cA cmul co ce cfv cc wcel ci cneg cA cmul co
    ce cfv cc wcel cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc
    wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci
    cA cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA cmul
    co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci
    axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl jca ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv addcl ci cA cmul co ce cfv ci cneg
    cA cmul co ce cfv caddc co halfcl 3syl eqeltrd $.
    $( [1-Sep-2005] $) $( [28-Apr-2005] $)

  $( The sine of a real number in terms of the exponential function. $)
  resinval $p |- ( A e. RR -> ( sin ` A ) = ( Im ` ( exp ` ( _i x. A ) ) ) ) $=
    cA cr wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci
    cmul co cdiv co ci cA cmul co ce cfv ci cA cmul co ce cfv ccj cfv cmin co
    c2 ci cmul co cdiv co cA csin cfv ci cA cmul co ce cfv cim cfv cA cr wcel
    ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co ci cA cmul co ce cfv
    ci cA cmul co ce cfv ccj cfv cmin co c2 ci cmul co cdiv cA cr wcel ci cneg
    cA cmul co ce cfv ci cA cmul co ce cfv ccj cfv ci cA cmul co ce cfv cmin cA
    cr wcel ci cA cmul co ccj cfv ce cfv ci cneg cA cmul co ce cfv ci cA cmul
    co ce cfv ccj cfv cA cr wcel ci cA cmul co ccj cfv ci cneg cA cmul co ce cA
    cr wcel ci cA cmul co ccj cfv ci ccj cfv cA ccj cfv cmul co ci cneg cA cmul
    co ci cc wcel cA cc wcel ci cA cmul co ccj cfv ci ccj cfv cA ccj cfv cmul
    co wceq cA cr wcel ci cA cjmul axicn cA recn sylancr cA cr wcel ci cneg cA
    ccj cfv cmul co ci cneg cA cmul co ci ccj cfv cA ccj cfv cmul co cA cr wcel
    cA ccj cfv cA ci cneg cmul cA cjre opreq2d ci ccj cfv ci cneg cA ccj cfv
    cmul cji opreq1i syl5eq eqtrd fveq2d cA cr wcel ci cA cmul co cc wcel ci cA
    cmul co ccj cfv ce cfv ci cA cmul co ce cfv ccj cfv wceq ci cc wcel cA cc
    wcel ci cA cmul co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr ci
    cA cmul co efcj syl eqtr3d opreq2d opreq1d cA cr wcel cA cc wcel cA csin
    cfv ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci cmul co
    cdiv co wceq cA recn cA sinval syl cA cr wcel ci cA cmul co ce cfv cc wcel
    ci cA cmul co ce cfv cim cfv ci cA cmul co ce cfv ci cA cmul co ce cfv ccj
    cfv cmin co c2 ci cmul co cdiv co wceq cA cr wcel ci cA cmul co cc wcel ci
    cA cmul co ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cr
    wcel ci cA mulcl axicn cA recn sylancr ci cA cmul co efcl syl ci cA cmul co
    ce cfv imcj syl 3eqtr4d $.
    $( [23-Feb-2006] $) $( [30-Apr-2005] $)

  $( The cosine of a real number in terms of the exponential function. $)
  recosval $p |- ( A e. RR -> ( cos ` A ) = ( Re ` ( exp ` ( _i x. A ) ) ) ) $=
    cA cr wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2 cdiv
    co ci cA cmul co ce cfv ci cA cmul co ce cfv ccj cfv caddc co c2 cdiv co cA
    ccos cfv ci cA cmul co ce cfv cre cfv cA cr wcel ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv caddc co ci cA cmul co ce cfv ci cA cmul co ce cfv
    ccj cfv caddc co c2 cdiv cA cr wcel ci cneg cA cmul co ce cfv ci cA cmul co
    ce cfv ccj cfv ci cA cmul co ce cfv caddc cA cr wcel ci cA cmul co ccj cfv
    ce cfv ci cneg cA cmul co ce cfv ci cA cmul co ce cfv ccj cfv cA cr wcel ci
    cA cmul co ccj cfv ci cneg cA cmul co ce cA cr wcel ci cA cmul co ccj cfv
    ci ccj cfv cA ccj cfv cmul co ci cneg cA cmul co ci cc wcel cA cc wcel ci
    cA cmul co ccj cfv ci ccj cfv cA ccj cfv cmul co wceq cA cr wcel ci cA
    cjmul axicn cA recn sylancr cA cr wcel ci cneg cA ccj cfv cmul co ci cneg
    cA cmul co ci ccj cfv cA ccj cfv cmul co cA cr wcel cA ccj cfv cA ci cneg
    cmul cA cjre opreq2d ci ccj cfv ci cneg cA ccj cfv cmul cji opreq1i syl5eq
    eqtrd fveq2d cA cr wcel ci cA cmul co cc wcel ci cA cmul co ccj cfv ce cfv
    ci cA cmul co ce cfv ccj cfv wceq ci cc wcel cA cc wcel ci cA cmul co cc
    wcel cA cr wcel ci cA mulcl axicn cA recn sylancr ci cA cmul co efcj syl
    eqtr3d opreq2d opreq1d cA cr wcel cA cc wcel cA ccos cfv ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv caddc co c2 cdiv co wceq cA recn cA cosval
    syl cA cr wcel ci cA cmul co ce cfv cc wcel ci cA cmul co ce cfv cre cfv ci
    cA cmul co ce cfv ci cA cmul co ce cfv ccj cfv caddc co c2 cdiv co wceq cA
    cr wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel ci cc wcel cA cc
    wcel ci cA cmul co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr ci
    cA cmul co efcl syl ci cA cmul co ce cfv recj syl 3eqtr4d $.
    $( [27-Feb-2006] $) $( [30-Apr-2005] $)

  ${
    $d A j k x y $.  $d F k x $.
    efit4pt.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                          y = ( ( ( _i x. A ) ^ j ) / ( ! ` j ) ) ) } $.
    $( Separate out the first four terms of the infinite series expansion of
       the exponential function of a pure imaginary number.  (Contributed by
       Paul Chapman, 19-Jan-2008.) $)
    efi4p $p |- ( A e. RR -> ( exp ` ( _i x. A ) ) =
        ( ( ( 1 - ( ( A ^ 2 ) / 2 ) ) + ( _i x. ( A - ( ( A ^ 3 ) / 6 ) ) ) ) +
          sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) $=
      cA cr wcel ci cA cmul co ce cfv c1 ci cA cmul co caddc co ci cA cmul co
      c2 cexp co c2 cdiv co caddc co ci cA cmul co c3 cexp co c6 cdiv co caddc
      co c4 cuz cfv vk cv cF cfv vk csu caddc co c1 cA c2 cexp co c2 cdiv co
      cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz
      cfv vk cv cF cfv vk csu caddc co cA cr wcel ci cA cmul co cc wcel ci cA
      cmul co ce cfv c1 ci cA cmul co caddc co ci cA cmul co c2 cexp co c2 cdiv
      co caddc co ci cA cmul co c3 cexp co c6 cdiv co caddc co c4 cuz cfv vk cv
      cF cfv vk csu caddc co wceq ci cc wcel cA cc wcel ci cA cmul co cc wcel
      cA cr wcel ci cA mulcl axicn cA recn sylancr vy ci cA cmul co vj vk cF
      efit4pt.1 ef4p syl cA cr wcel c1 ci cA cmul co caddc co ci cA cmul co c2
      cexp co c2 cdiv co caddc co ci cA cmul co c3 cexp co c6 cdiv co caddc co
      c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv co cmin
      co cmul co caddc co c4 cuz cfv vk cv cF cfv vk csu caddc cA cr wcel c1 ci
      cA cmul co caddc co ci cA cmul co c2 cexp co c2 cdiv co caddc co ci cA
      cmul co c3 cexp co c6 cdiv co caddc co c1 ci cA cmul co caddc co ci cA
      cmul co c2 cexp co c2 cdiv co ci cA cmul co c3 cexp co c6 cdiv co caddc
      co caddc co c1 ci cA cmul co c2 cexp co c2 cdiv co caddc co ci cA cmul co
      ci cA cmul co c3 cexp co c6 cdiv co caddc co caddc co c1 cA c2 cexp co c2
      cdiv co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co
      c1 ci cA cmul co caddc co cc wcel ci cA cmul co c2 cexp co c2 cdiv co cc
      wcel ci cA cmul co c3 cexp co c6 cdiv co cc wcel c1 ci cA cmul co caddc
      co ci cA cmul co c2 cexp co c2 cdiv co caddc co ci cA cmul co c3 cexp co
      c6 cdiv co caddc co c1 ci cA cmul co caddc co ci cA cmul co c2 cexp co c2
      cdiv co ci cA cmul co c3 cexp co c6 cdiv co caddc co caddc co wceq cA cr
      wcel c1 ci cA cmul co caddc co ci cA cmul co c2 cexp co c2 cdiv co ci cA
      cmul co c3 cexp co c6 cdiv co addass c1 cc wcel ci cA cmul co cc wcel c1
      ci cA cmul co caddc co cc wcel cA cr wcel c1 ci cA cmul co addcl ax1cn ci
      cc wcel cA cc wcel ci cA cmul co cc wcel cA cr wcel ci cA mulcl axicn cA
      recn sylancr sylancr cA cr wcel ci cA cmul co c2 cexp co cc wcel ci cA
      cmul co c2 cexp co c2 cdiv co cc wcel cA cr wcel ci cA cmul co cc wcel ci
      cA cmul co c2 cexp co cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel
      cA cr wcel ci cA mulcl axicn cA recn sylancr ci cA cmul co sqcl syl ci cA
      cmul co c2 cexp co cc wcel c2 cc wcel c2 cc0 wne ci cA cmul co c2 cexp co
      c2 cdiv co cc wcel 2cn 2ne0 ci cA cmul co c2 cexp co c2 divcl mp3an23 syl
      cA cr wcel ci cA cmul co c3 cexp co cc wcel ci cA cmul co c3 cexp co c6
      cdiv co cc wcel ci cA cmul co cc wcel c3 cn0 wcel ci cA cmul co c3 cexp
      co cc wcel cA cr wcel ci cA cmul co c3 expcl ci cc wcel cA cc wcel ci cA
      cmul co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr c3 3nn
      nnnn0i sylancl ci cA cmul co c3 cexp co cc wcel c6 cc wcel c6 cc0 wne ci
      cA cmul co c3 cexp co c6 cdiv co cc wcel c6 6re recni c6 6re 6pos
      gt0ne0ii ci cA cmul co c3 cexp co c6 divcl mp3an23 syl syl3anc c1 cc wcel
      ci cA cmul co cc wcel wa ci cA cmul co c2 cexp co c2 cdiv co cc wcel ci
      cA cmul co c3 cexp co c6 cdiv co cc wcel wa c1 ci cA cmul co caddc co ci
      cA cmul co c2 cexp co c2 cdiv co ci cA cmul co c3 cexp co c6 cdiv co
      caddc co caddc co c1 ci cA cmul co c2 cexp co c2 cdiv co caddc co ci cA
      cmul co ci cA cmul co c3 cexp co c6 cdiv co caddc co caddc co wceq cA cr
      wcel c1 ci cA cmul co ci cA cmul co c2 cexp co c2 cdiv co ci cA cmul co
      c3 cexp co c6 cdiv co add4 cA cr wcel c1 cc wcel ci cA cmul co cc wcel c1
      cc wcel cA cr wcel ax1cn a1i ci cc wcel cA cc wcel ci cA cmul co cc wcel
      cA cr wcel ci cA mulcl axicn cA recn sylancr jca cA cr wcel ci cA cmul co
      c2 cexp co c2 cdiv co cc wcel ci cA cmul co c3 cexp co c6 cdiv co cc wcel
      cA cr wcel ci cA cmul co c2 cexp co cc wcel ci cA cmul co c2 cexp co c2
      cdiv co cc wcel cA cr wcel ci cA cmul co cc wcel ci cA cmul co c2 cexp co
      cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cr wcel ci cA
      mulcl axicn cA recn sylancr ci cA cmul co sqcl syl ci cA cmul co c2 cexp
      co cc wcel c2 cc wcel c2 cc0 wne ci cA cmul co c2 cexp co c2 cdiv co cc
      wcel 2cn 2ne0 ci cA cmul co c2 cexp co c2 divcl mp3an23 syl cA cr wcel ci
      cA cmul co c3 cexp co cc wcel ci cA cmul co c3 cexp co c6 cdiv co cc wcel
      ci cA cmul co cc wcel c3 cn0 wcel ci cA cmul co c3 cexp co cc wcel cA cr
      wcel ci cA cmul co c3 expcl ci cc wcel cA cc wcel ci cA cmul co cc wcel
      cA cr wcel ci cA mulcl axicn cA recn sylancr c3 3nn nnnn0i sylancl ci cA
      cmul co c3 cexp co cc wcel c6 cc wcel c6 cc0 wne ci cA cmul co c3 cexp co
      c6 cdiv co cc wcel c6 6re recni c6 6re 6pos gt0ne0ii ci cA cmul co c3
      cexp co c6 divcl mp3an23 syl jca sylanc cA cr wcel c1 ci cA cmul co c2
      cexp co c2 cdiv co caddc co c1 cA c2 cexp co c2 cdiv co cmin co ci cA
      cmul co ci cA cmul co c3 cexp co c6 cdiv co caddc co ci cA cA c3 cexp co
      c6 cdiv co cmin co cmul co caddc cA cr wcel c1 ci cA cmul co c2 cexp co
      c2 cdiv co caddc co c1 cA c2 cexp co c2 cdiv co cneg caddc co c1 cA c2
      cexp co c2 cdiv co cmin co cA cr wcel ci cA cmul co c2 cexp co c2 cdiv co
      cA c2 cexp co c2 cdiv co cneg c1 caddc cA cr wcel ci cA cmul co c2 cexp
      co c2 cdiv co cA c2 cexp co cneg c2 cdiv co cA c2 cexp co c2 cdiv co cneg
      cA cr wcel ci cA cmul co c2 cexp co cA c2 cexp co cneg c2 cdiv cA cr wcel
      ci cA cmul co c2 cexp co ci c2 cexp co cA c2 cexp co cmul co c1 cneg cA
      c2 cexp co cmul co cA c2 cexp co cneg cA cr wcel cA cc wcel ci cA cmul co
      c2 cexp co ci c2 cexp co cA c2 cexp co cmul co wceq cA recn ci cc wcel cA
      cc wcel c2 cn0 wcel ci cA cmul co c2 cexp co ci c2 cexp co cA c2 cexp co
      cmul co wceq axicn 2nn0 ci cA c2 mulexp mp3an13 syl ci c2 cexp co cA c2
      cexp co cmul co c1 cneg cA c2 cexp co cmul co wceq cA cr wcel ci c2 cexp
      co c1 cneg cA c2 cexp co cmul i2 opreq1i a1i cA cr wcel cA c2 cexp co cc
      wcel c1 cneg cA c2 cexp co cmul co cA c2 cexp co cneg wceq cA cr wcel cA
      cc wcel cA c2 cexp co cc wcel cA recn cA sqcl syl cA c2 cexp co mulm1 syl
      3eqtrd opreq1d cA cr wcel cA c2 cexp co cc wcel cA c2 cexp co c2 cdiv co
      cneg cA c2 cexp co cneg c2 cdiv co wceq cA cr wcel cA cc wcel cA c2 cexp
      co cc wcel cA recn cA sqcl syl cA c2 cexp co cc wcel c2 cc wcel c2 cc0
      wne cA c2 cexp co c2 cdiv co cneg cA c2 cexp co cneg c2 cdiv co wceq 2cn
      2ne0 cA c2 cexp co c2 divneg mp3an23 syl eqtr4d opreq2d c1 cc wcel cA c2
      cexp co c2 cdiv co cc wcel c1 cA c2 cexp co c2 cdiv co cneg caddc co c1
      cA c2 cexp co c2 cdiv co cmin co wceq cA cr wcel c1 cA c2 cexp co c2 cdiv
      co negsub ax1cn cA cr wcel cA c2 cexp co cc wcel cA c2 cexp co c2 cdiv co
      cc wcel cA cr wcel cA cc wcel cA c2 cexp co cc wcel cA recn cA sqcl syl
      cA c2 cexp co cc wcel c2 cc wcel c2 cc0 wne cA c2 cexp co c2 cdiv co cc
      wcel 2cn 2ne0 cA c2 cexp co c2 divcl mp3an23 syl sylancr eqtrd cA cr wcel
      ci cA cmul co ci cA cmul co c3 cexp co c6 cdiv co caddc co ci cA cmul co
      ci cA c3 cexp co c6 cdiv co cneg cmul co caddc co ci cA cA c3 cexp co c6
      cdiv co cneg caddc co cmul co ci cA cA c3 cexp co c6 cdiv co cmin co cmul
      co cA cr wcel ci cA cmul co c3 cexp co c6 cdiv co ci cA c3 cexp co c6
      cdiv co cneg cmul co ci cA cmul co caddc cA cr wcel ci cA cmul co c3 cexp
      co c6 cdiv co ci cneg cA c3 cexp co cmul co c6 cdiv co ci cneg cA c3 cexp
      co c6 cdiv co cmul co ci cA c3 cexp co c6 cdiv co cneg cmul co cA cr wcel
      ci cA cmul co c3 cexp co ci cneg cA c3 cexp co cmul co c6 cdiv cA cr wcel
      ci cA cmul co c3 cexp co ci c3 cexp co cA c3 cexp co cmul co ci cneg cA
      c3 cexp co cmul co cA cr wcel cA cc wcel ci cA cmul co c3 cexp co ci c3
      cexp co cA c3 cexp co cmul co wceq cA recn ci cc wcel cA cc wcel c3 cn0
      wcel ci cA cmul co c3 cexp co ci c3 cexp co cA c3 cexp co cmul co wceq
      axicn c3 3nn nnnn0i ci cA c3 mulexp mp3an13 syl ci c3 cexp co cA c3 cexp
      co cmul co ci cneg cA c3 cexp co cmul co wceq cA cr wcel ci c3 cexp co ci
      cneg cA c3 cexp co cmul i3 opreq1i a1i eqtrd opreq1d cA cr wcel cA c3
      cexp co cc wcel ci cneg cA c3 cexp co cmul co c6 cdiv co ci cneg cA c3
      cexp co c6 cdiv co cmul co wceq cA cc wcel c3 cn0 wcel cA c3 cexp co cc
      wcel cA cr wcel cA c3 expcl cA recn c3 3nn nnnn0i sylancl ci cneg cc wcel
      cA c3 cexp co cc wcel c6 cc wcel c6 cc0 wne wa ci cneg cA c3 cexp co cmul
      co c6 cdiv co ci cneg cA c3 cexp co c6 cdiv co cmul co wceq ci axicn
      negcli c6 cc wcel c6 cc0 wne c6 6re recni c6 6re 6pos gt0ne0ii pm3.2i ci
      cneg cA c3 cexp co c6 divass mp3an13 syl ci cc wcel cA c3 cexp co c6 cdiv
      co cc wcel ci cneg cA c3 cexp co c6 cdiv co cmul co ci cA c3 cexp co c6
      cdiv co cneg cmul co wceq cA cr wcel ci cA c3 cexp co c6 cdiv co mulneg12
      axicn cA cr wcel cA c3 cexp co cc wcel cA c3 cexp co c6 cdiv co cc wcel
      cA cc wcel c3 cn0 wcel cA c3 cexp co cc wcel cA cr wcel cA c3 expcl cA
      recn c3 3nn nnnn0i sylancl cA c3 cexp co cc wcel c6 cc wcel c6 cc0 wne cA
      c3 cexp co c6 cdiv co cc wcel c6 6re recni c6 6re 6pos gt0ne0ii cA c3
      cexp co c6 divcl mp3an23 syl sylancr 3eqtrd opreq2d cA cc wcel cA c3 cexp
      co c6 cdiv co cneg cc wcel ci cA cA c3 cexp co c6 cdiv co cneg caddc co
      cmul co ci cA cmul co ci cA c3 cexp co c6 cdiv co cneg cmul co caddc co
      wceq cA cr wcel ci cc wcel cA cc wcel cA c3 cexp co c6 cdiv co cneg cc
      wcel ci cA cA c3 cexp co c6 cdiv co cneg caddc co cmul co ci cA cmul co
      ci cA c3 cexp co c6 cdiv co cneg cmul co caddc co wceq axicn ci cA cA c3
      cexp co c6 cdiv co cneg adddi mp3an1 cA recn cA cr wcel cA c3 cexp co c6
      cdiv co cc wcel cA c3 cexp co c6 cdiv co cneg cc wcel cA cr wcel cA c3
      cexp co cc wcel cA c3 cexp co c6 cdiv co cc wcel cA cc wcel c3 cn0 wcel
      cA c3 cexp co cc wcel cA cr wcel cA c3 expcl cA recn c3 3nn nnnn0i
      sylancl cA c3 cexp co cc wcel c6 cc wcel c6 cc0 wne cA c3 cexp co c6 cdiv
      co cc wcel c6 6re recni c6 6re 6pos gt0ne0ii cA c3 cexp co c6 divcl
      mp3an23 syl cA c3 cexp co c6 cdiv co negcl syl sylanc cA cr wcel cA cA c3
      cexp co c6 cdiv co cneg caddc co cA cA c3 cexp co c6 cdiv co cmin co ci
      cmul cA cc wcel cA c3 cexp co c6 cdiv co cc wcel cA cA c3 cexp co c6 cdiv
      co cneg caddc co cA cA c3 cexp co c6 cdiv co cmin co wceq cA cr wcel cA
      cA c3 cexp co c6 cdiv co negsub cA recn cA cr wcel cA c3 cexp co cc wcel
      cA c3 cexp co c6 cdiv co cc wcel cA cc wcel c3 cn0 wcel cA c3 cexp co cc
      wcel cA cr wcel cA c3 expcl cA recn c3 3nn nnnn0i sylancl cA c3 cexp co
      cc wcel c6 cc wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cc wcel c6 6re
      recni c6 6re 6pos gt0ne0ii cA c3 cexp co c6 divcl mp3an23 syl sylanc
      opreq2d 3eqtr2d opreq12d 3eqtrd opreq1d eqtrd $.
      $( [11-Mar-2008] $) $( [19-Jan-2008] $)

    $( Separate out the first four terms of the infinite series expansion of
       the sine of a real number.  (Contributed by Paul Chapman,
       19-Jan-2008.) $)
    resin4p $p |- ( A e. RR -> ( sin ` A ) = ( ( A - ( ( A ^ 3 ) / 6 ) ) +
                       ( Im ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) ) $=
      cA cr wcel cA csin cfv ci cA cmul co ce cfv cim cfv cA cA c3 cexp co c6
      cdiv co cmin co c4 cuz cfv vk cv cF cfv vk csu cim cfv caddc co cA
      resinval cA cr wcel ci cA cmul co ce cfv cim cfv c1 cA c2 cexp co c2 cdiv
      co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz
      cfv vk cv cF cfv vk csu caddc co cim cfv c1 cA c2 cexp co c2 cdiv co cmin
      co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co cim cfv c4 cuz
      cfv vk cv cF cfv vk csu cim cfv caddc co cA cA c3 cexp co c6 cdiv co cmin
      co c4 cuz cfv vk cv cF cfv vk csu cim cfv caddc co cA cr wcel ci cA cmul
      co ce cfv c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv
      co cmin co cmul co caddc co c4 cuz cfv vk cv cF cfv vk csu caddc co cim
      vy cA vj vk cF efit4pt.1 efi4p fveq2d c1 cA c2 cexp co c2 cdiv co cmin co
      ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co cc wcel c4 cuz
      cfv vk cv cF cfv vk csu cc wcel c1 cA c2 cexp co c2 cdiv co cmin co ci cA
      cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz cfv vk cv cF cfv
      vk csu caddc co cim cfv c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3
      cexp co c6 cdiv co cmin co cmul co caddc co cim cfv c4 cuz cfv vk cv cF
      cfv vk csu cim cfv caddc co wceq cA cr wcel c1 cA c2 cexp co c2 cdiv co
      cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz
      cfv vk cv cF cfv vk csu imadd c1 cA c2 cexp co c2 cdiv co cmin co cc wcel
      ci cA cA c3 cexp co c6 cdiv co cmin co cmul co cc wcel c1 cA c2 cexp co
      c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc
      co cc wcel cA cr wcel c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3
      cexp co c6 cdiv co cmin co cmul co addcl cA cr wcel c1 cA c2 cexp co c2
      cdiv co cmin co c1 cr wcel cA c2 cexp co c2 cdiv co cr wcel c1 cA c2 cexp
      co c2 cdiv co cmin co cr wcel cA cr wcel c1 cA c2 cexp co c2 cdiv co
      resubcl 1re cA cr wcel cA c2 cexp co cr wcel cA c2 cexp co c2 cdiv co cr
      wcel cA resqcl cA c2 cexp co rehalfcl syl sylancr recnd ci cc wcel cA cA
      c3 cexp co c6 cdiv co cmin co cc wcel ci cA cA c3 cexp co c6 cdiv co cmin
      co cmul co cc wcel cA cr wcel ci cA cA c3 cexp co c6 cdiv co cmin co
      mulcl axicn cA cr wcel cA cA c3 cexp co c6 cdiv co cmin co cA cr wcel cA
      c3 cexp co c6 cdiv co cr wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel
      cA cr wcel cA c3 cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA cr
      wcel c3 cn0 wcel cA c3 cexp co cr wcel c3 3nn nnnn0i cA c3 reexpcl mpan2
      cA c3 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr
      wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cA
      c3 cexp co c6 cdiv co resubcl mpdan recnd sylancr sylanc ci cA cmul co cc
      wcel c4 cn wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel cA cr wcel vy ci
      cA cmul co vj vk cF c4 efit4pt.1 eftlcl ci cc wcel cA cc wcel ci cA cmul
      co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr 4nn sylancl
      sylanc cA cr wcel c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co
      c6 cdiv co cmin co cmul co caddc co cim cfv cA cA c3 cexp co c6 cdiv co
      cmin co c4 cuz cfv vk cv cF cfv vk csu cim cfv caddc c1 cA c2 cexp co c2
      cdiv co cmin co cr wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel c1 cA
      c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul
      co caddc co cim cfv cA cA c3 cexp co c6 cdiv co cmin co wceq cA cr wcel
      c1 cA c2 cexp co c2 cdiv co cmin co cA cA c3 cexp co c6 cdiv co cmin co
      crim c1 cr wcel cA c2 cexp co c2 cdiv co cr wcel c1 cA c2 cexp co c2 cdiv
      co cmin co cr wcel cA cr wcel c1 cA c2 cexp co c2 cdiv co resubcl 1re cA
      cr wcel cA c2 cexp co cr wcel cA c2 cexp co c2 cdiv co cr wcel cA resqcl
      cA c2 cexp co rehalfcl syl sylancr cA cr wcel cA c3 cexp co c6 cdiv co cr
      wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel cA cr wcel cA c3 cexp co
      cr wcel cA c3 cexp co c6 cdiv co cr wcel cA cr wcel c3 cn0 wcel cA c3
      cexp co cr wcel c3 3nn nnnn0i cA c3 reexpcl mpan2 cA c3 cexp co cr wcel
      c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos
      gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cA c3 cexp co c6 cdiv co
      resubcl mpdan sylanc opreq1d 3eqtrd eqtrd $.
      $( [15-Mar-2008] $) $( [19-Jan-2008] $)

    $( Separate out the first four terms of the infinite series expansion of
       the cosine of a real number.  (Contributed by Paul Chapman,
       19-Jan-2008.) $)
    recos4p $p |- ( A e. RR -> ( cos ` A ) = ( ( 1 - ( ( A ^ 2 ) / 2 ) ) +
                       ( Re ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) ) $=
      cA cr wcel cA ccos cfv ci cA cmul co ce cfv cre cfv c1 cA c2 cexp co c2
      cdiv co cmin co c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc co cA
      recosval cA cr wcel ci cA cmul co ce cfv cre cfv c1 cA c2 cexp co c2 cdiv
      co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz
      cfv vk cv cF cfv vk csu caddc co cre cfv c1 cA c2 cexp co c2 cdiv co cmin
      co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co cre cfv c4 cuz
      cfv vk cv cF cfv vk csu cre cfv caddc co c1 cA c2 cexp co c2 cdiv co cmin
      co c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc co cA cr wcel ci cA cmul
      co ce cfv c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv
      co cmin co cmul co caddc co c4 cuz cfv vk cv cF cfv vk csu caddc co cre
      vy cA vj vk cF efit4pt.1 efi4p fveq2d c1 cA c2 cexp co c2 cdiv co cmin co
      ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co cc wcel c4 cuz
      cfv vk cv cF cfv vk csu cc wcel c1 cA c2 cexp co c2 cdiv co cmin co ci cA
      cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz cfv vk cv cF cfv
      vk csu caddc co cre cfv c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3
      cexp co c6 cdiv co cmin co cmul co caddc co cre cfv c4 cuz cfv vk cv cF
      cfv vk csu cre cfv caddc co wceq cA cr wcel c1 cA c2 cexp co c2 cdiv co
      cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc co c4 cuz
      cfv vk cv cF cfv vk csu readd c1 cA c2 cexp co c2 cdiv co cmin co cc wcel
      ci cA cA c3 cexp co c6 cdiv co cmin co cmul co cc wcel c1 cA c2 cexp co
      c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul co caddc
      co cc wcel cA cr wcel c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3
      cexp co c6 cdiv co cmin co cmul co addcl cA cr wcel c1 cA c2 cexp co c2
      cdiv co cmin co c1 cr wcel cA c2 cexp co c2 cdiv co cr wcel c1 cA c2 cexp
      co c2 cdiv co cmin co cr wcel cA cr wcel c1 cA c2 cexp co c2 cdiv co
      resubcl 1re cA cr wcel cA c2 cexp co cr wcel cA c2 cexp co c2 cdiv co cr
      wcel cA resqcl cA c2 cexp co rehalfcl syl sylancr recnd ci cc wcel cA cA
      c3 cexp co c6 cdiv co cmin co cc wcel ci cA cA c3 cexp co c6 cdiv co cmin
      co cmul co cc wcel cA cr wcel ci cA cA c3 cexp co c6 cdiv co cmin co
      mulcl axicn cA cr wcel cA cA c3 cexp co c6 cdiv co cmin co cA cr wcel cA
      c3 cexp co c6 cdiv co cr wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel
      cA cr wcel cA c3 cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA cr
      wcel c3 cn0 wcel cA c3 cexp co cr wcel c3 3nn nnnn0i cA c3 reexpcl mpan2
      cA c3 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr
      wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cA
      c3 cexp co c6 cdiv co resubcl mpdan recnd sylancr sylanc ci cA cmul co cc
      wcel c4 cn wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel cA cr wcel vy ci
      cA cmul co vj vk cF c4 efit4pt.1 eftlcl ci cc wcel cA cc wcel ci cA cmul
      co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr 4nn sylancl
      sylanc cA cr wcel c1 cA c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co
      c6 cdiv co cmin co cmul co caddc co cre cfv c1 cA c2 cexp co c2 cdiv co
      cmin co c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc c1 cA c2 cexp co c2
      cdiv co cmin co cr wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel c1 cA
      c2 cexp co c2 cdiv co cmin co ci cA cA c3 cexp co c6 cdiv co cmin co cmul
      co caddc co cre cfv c1 cA c2 cexp co c2 cdiv co cmin co wceq cA cr wcel
      c1 cA c2 cexp co c2 cdiv co cmin co cA cA c3 cexp co c6 cdiv co cmin co
      crre c1 cr wcel cA c2 cexp co c2 cdiv co cr wcel c1 cA c2 cexp co c2 cdiv
      co cmin co cr wcel cA cr wcel c1 cA c2 cexp co c2 cdiv co resubcl 1re cA
      cr wcel cA c2 cexp co cr wcel cA c2 cexp co c2 cdiv co cr wcel cA resqcl
      cA c2 cexp co rehalfcl syl sylancr cA cr wcel cA c3 cexp co c6 cdiv co cr
      wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel cA cr wcel cA c3 cexp co
      cr wcel cA c3 cexp co c6 cdiv co cr wcel cA cr wcel c3 cn0 wcel cA c3
      cexp co cr wcel c3 3nn nnnn0i cA c3 reexpcl mpan2 cA c3 cexp co cr wcel
      c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos
      gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cA c3 cexp co c6 cdiv co
      resubcl mpdan sylanc opreq1d 3eqtrd eqtrd $.
      $( [15-Mar-2008] $) $( [19-Jan-2008] $)
  $}

  $( The sine of a real number is real. $)
  resincl $p |- ( A e. RR -> ( sin ` A ) e. RR ) $=
    cA cr wcel cA csin cfv ci cA cmul co ce cfv cim cfv cr cA resinval cA cr
    wcel ci cA cmul co ce cfv cc wcel ci cA cmul co ce cfv cim cfv cr wcel cA
    cr wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel ci cc wcel cA cc
    wcel ci cA cmul co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr ci
    cA cmul co efcl syl ci cA cmul co ce cfv imcl syl eqeltrd $.
    $( [24-Feb-2006] $) $( [30-Apr-2005] $)

  $( The cosine of a real number is real. $)
  recoscl $p |- ( A e. RR -> ( cos ` A ) e. RR ) $=
    cA cr wcel cA ccos cfv ci cA cmul co ce cfv cre cfv cr cA recosval cA cr
    wcel ci cA cmul co ce cfv cc wcel ci cA cmul co ce cfv cre cfv cr wcel cA
    cr wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel ci cc wcel cA cc
    wcel ci cA cmul co cc wcel cA cr wcel ci cA mulcl axicn cA recn sylancr ci
    cA cmul co efcl syl ci cA cmul co ce cfv recl syl eqeltrd $.
    $( [28-Feb-2006] $) $( [30-Apr-2005] $)

  ${
    $d x y $.
    $( Domain and codomain of the sine function. (Contributed by Paul Chapman,
       22-Oct-2007.) $)
    sinf $p |- sin : CC --> CC $=
      cc cc csin wf csin cc wfn vx cv csin cfv cc wcel vx cc wral vx cc cc csin
      ffnfv vx vy cc ci vx cv cmul co ce cfv ci cneg vx cv cmul co ce cfv cmin
      co c2 ci cmul co cdiv co csin ci vx cv cmul co ce cfv ci cneg vx cv cmul
      co ce cfv cmin co c2 ci cmul co cdiv oprex vx vy df-sin fnopab2 vx cv
      csin cfv cc wcel vx cc vx cv sincl rgen mpbir2an $.
      $( [22-Oct-2007] $) $( [22-Oct-2007] $)

    $( Domain and codomain of the sine function. (Contributed by Paul Chapman,
       22-Oct-2007.) $)
    cosf $p |- cos : CC --> CC $=
      cc cc ccos wf ccos cc wfn vx cv ccos cfv cc wcel vx cc wral vx cc cc ccos
      ffnfv vx vy cc ci vx cv cmul co ce cfv ci cneg vx cv cmul co ce cfv caddc
      co c2 cdiv co ccos ci vx cv cmul co ce cfv ci cneg vx cv cmul co ce cfv
      caddc co c2 cdiv oprex vx vy df-cos fnopab2 vx cv ccos cfv cc wcel vx cc
      vx cv coscl rgen mpbir2an $.
      $( [22-Oct-2007] $) $( [22-Oct-2007] $)
  $}

  $( The sine of a negative is the negative of the sine. $)
  sinneg $p |- ( A e. CC -> ( sin ` -u A ) = -u ( sin ` A ) ) $=
    cA cc wcel ci cA cneg cmul co ce cfv ci cneg cA cneg cmul co ce cfv cmin co
    c2 ci cmul co cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin
    co cneg c2 ci cmul co cdiv co cA cneg csin cfv cA csin cfv cneg cA cc wcel
    ci cA cneg cmul co ce cfv ci cneg cA cneg cmul co ce cfv cmin co ci cA cmul
    co ce cfv ci cneg cA cmul co ce cfv cmin co cneg c2 ci cmul co cdiv cA cc
    wcel ci cA cneg cmul co ce cfv ci cneg cA cneg cmul co ce cfv cmin co ci
    cneg cA cmul co ce cfv ci cA cmul co ce cfv cmin co ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co cneg cA cc wcel ci cA cneg cmul co ce cfv ci
    cneg cA cmul co ce cfv ci cneg cA cneg cmul co ce cfv ci cA cmul co ce cfv
    cmin cA cc wcel ci cA cneg cmul co ci cneg cA cmul co ce cA cc wcel ci cneg
    cA cmul co ci cA cneg cmul co ci cc wcel cA cc wcel ci cneg cA cmul co ci
    cA cneg cmul co wceq axicn ci cA mulneg12 mpan eqcomd fveq2d cA cc wcel ci
    cneg cA cneg cmul co ci cA cmul co ce ci cc wcel cA cc wcel ci cneg cA cneg
    cmul co ci cA cmul co wceq axicn ci cA mul2neg mpan fveq2d opreq12d ci cA
    cmul co ce cfv cc wcel ci cneg cA cmul co ce cfv cc wcel ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv cmin co cneg ci cneg cA cmul co ce cfv ci cA
    cmul co ce cfv cmin co wceq cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv negsubdi2 cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv
    cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan
    ci cA cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA
    cmul co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc
    wcel ci axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl
    sylanc eqtr4d opreq1d cA cc wcel cA cneg cc wcel cA cneg csin cfv ci cA
    cneg cmul co ce cfv ci cneg cA cneg cmul co ce cfv cmin co c2 ci cmul co
    cdiv co wceq cA negcl cA cneg sinval syl cA cc wcel cA csin cfv cneg ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci cmul co cdiv co cneg
    ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cneg c2 ci cmul co
    cdiv co cA cc wcel cA csin cfv ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co c2 ci cmul co cdiv co cA sinval negeqd cA cc wcel ci cA cmul co
    ce cfv ci cneg cA cmul co ce cfv cmin co cc wcel ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co c2 ci cmul co cdiv co cneg ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv cmin co cneg c2 ci cmul co cdiv co wceq ci cA
    cmul co ce cfv cc wcel ci cneg cA cmul co ce cfv cc wcel ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv cmin co cc wcel cA cc wcel ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv subcl cA cc wcel ci cA cmul co cc wcel ci cA
    cmul co ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci
    cA mulcl mpan ci cA cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel
    ci cneg cA cmul co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA
    cmul co cc wcel ci axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co
    efcl syl sylanc ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc
    wcel c2 ci cmul co cc wcel c2 ci cmul co cc0 wne ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co c2 ci cmul co cdiv co cneg ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv cmin co cneg c2 ci cmul co cdiv co wceq c2 ci
    2cn axicn mulcli c2 ci 2cn axicn 2ne0 ine0 muln0i ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co c2 ci cmul co divneg mp3an23 syl eqtrd
    3eqtr4d $.
    $( [9-Jul-2005] $) $( [30-Apr-2005] $)

  $( The cosines of a number and its negative are the same. $)
  cosneg $p |- ( A e. CC -> ( cos ` -u A ) = ( cos ` A ) ) $=
    cA cc wcel ci cA cneg cmul co ce cfv ci cneg cA cneg cmul co ce cfv caddc
    co c2 cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2
    cdiv co cA cneg ccos cfv cA ccos cfv cA cc wcel ci cA cneg cmul co ce cfv
    ci cneg cA cneg cmul co ce cfv caddc co ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv caddc co c2 cdiv cA cc wcel ci cA cneg cmul co ce cfv ci
    cneg cA cneg cmul co ce cfv caddc co ci cneg cA cmul co ce cfv ci cA cmul
    co ce cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co
    cA cc wcel ci cA cneg cmul co ce cfv ci cneg cA cmul co ce cfv ci cneg cA
    cneg cmul co ce cfv ci cA cmul co ce cfv caddc cA cc wcel ci cA cneg cmul
    co ci cneg cA cmul co ce cA cc wcel ci cneg cA cmul co ci cA cneg cmul co
    ci cc wcel cA cc wcel ci cneg cA cmul co ci cA cneg cmul co wceq axicn ci
    cA mulneg12 mpan eqcomd fveq2d cA cc wcel ci cneg cA cneg cmul co ci cA
    cmul co ce ci cc wcel cA cc wcel ci cneg cA cneg cmul co ci cA cmul co wceq
    axicn ci cA mul2neg mpan fveq2d opreq12d ci cneg cA cmul co ce cfv cc wcel
    ci cA cmul co ce cfv cc wcel ci cneg cA cmul co ce cfv ci cA cmul co ce cfv
    caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co wceq cA cc
    wcel ci cneg cA cmul co ce cfv ci cA cmul co ce cfv addcom cA cc wcel ci
    cneg cA cmul co cc wcel ci cneg cA cmul co ce cfv cc wcel ci cneg cc wcel
    cA cc wcel ci cneg cA cmul co cc wcel ci axicn negcli ci cneg cA mulcl mpan
    ci cneg cA cmul co efcl syl cA cc wcel ci cA cmul co cc wcel ci cA cmul co
    ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA
    mulcl mpan ci cA cmul co efcl syl sylanc eqtrd opreq1d cA cc wcel cA cneg
    cc wcel cA cneg ccos cfv ci cA cneg cmul co ce cfv ci cneg cA cneg cmul co
    ce cfv caddc co c2 cdiv co wceq cA negcl cA cneg cosval syl cA cosval
    3eqtr4d $.
    $( [20-Feb-2006] $) $( [30-Apr-2005] $)

  $( Value of the sine function at 0.  (Contributed by Steve Rodriguez,
     5-Jul-2006.) $)
  sin0 $p |- ( sin ` 0 ) = 0 $=
    cc0 csin cfv ci cc0 cmul co ce cfv cim cfv c1 cim cfv cc0 cc0 cr wcel cc0
    csin cfv ci cc0 cmul co ce cfv cim cfv wceq 0re cc0 resinval ax-mp ci cc0
    cmul co ce cfv c1 cim ci cc0 cmul co ce cfv cc0 ce cfv c1 ci cc0 cmul co
    cc0 ce ci axicn mul01i fveq2i ef0 eqtri fveq2i im1 3eqtri $.
    $( [5-Jul-2006] $) $( [5-Jul-2006] $)

  $( Value of the sine function at 0. $)
  sin0ALT $p |- ( sin ` 0 ) = 0 $=
    cc0 csin cfv cc0 csin cfv cneg wceq cc0 csin cfv cc0 wceq cc0 cneg csin cfv
    cc0 csin cfv cc0 csin cfv cneg cc0 cneg cc0 csin neg0 fveq2i cc0 cc wcel
    cc0 cneg csin cfv cc0 csin cfv cneg wceq 0cn cc0 sinneg ax-mp eqtr3i cc0
    csin cfv cc0 cc wcel cc0 csin cfv cc wcel 0cn cc0 sincl ax-mp eqnegi mpbi
    $.
    $( [26-Apr-2008] $) $( [14-Mar-2005] $)

  $( Value of the cosine function at 0. $)
  cos0 $p |- ( cos ` 0 ) = 1 $=
    cc0 ccos cfv ci cc0 cmul co ce cfv cre cfv c1 cre cfv c1 cc0 cr wcel cc0
    ccos cfv ci cc0 cmul co ce cfv cre cfv wceq 0re cc0 recosval ax-mp ci cc0
    cmul co ce cfv c1 cre ci cc0 cmul co ce cfv cc0 ce cfv c1 ci cc0 cmul co
    cc0 ce ci axicn mul01i fveq2i ef0 eqtri fveq2i re1 3eqtri $.
    $( [28-Feb-2006] $) $( [30-Apr-2005] $)

  $( The exponential function in terms of sine and cosine. $)
  efival $p |- ( A e. CC -> ( exp ` ( _i x. A ) ) =
                ( ( cos ` A ) + ( _i x. ( sin ` A ) ) ) ) $=
    cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc co c2 cdiv co ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2 cdiv co ci cA cmul co
    ce cfv ci cneg cA cmul co ce cfv cmin co c2 cdiv co caddc co ci cA cmul co
    ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv caddc co cc wcel ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv cmin co cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc
    co c2 cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2
    cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 cdiv co
    caddc co wceq cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    caddc co cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc
    wcel c2 cc wcel c2 cc0 wne wa ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc
    co c2 cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2
    cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 cdiv co
    caddc co wceq c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co c2 divdir mp3an3 ci cA cmul co ce cfv cc wcel ci cneg cA cmul
    co ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co
    cc wcel cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv addcl cA
    cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel ci cc wcel cA cc
    wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA cmul co efcl syl cA
    cc wcel ci cneg cA cmul co cc wcel ci cneg cA cmul co ce cfv cc wcel ci
    cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci axicn negcli ci cneg
    cA mulcl mpan ci cneg cA cmul co efcl syl sylanc ci cA cmul co ce cfv cc
    wcel ci cneg cA cmul co ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmin co cc wcel cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv subcl cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc
    wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci
    cA cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA cmul
    co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci
    axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl sylanc
    sylanc cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co
    ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc co c2 cdiv co
    c2 ci cA cmul co ce cfv cmul co c2 cdiv co ci cA cmul co ce cfv cA cc wcel
    ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv cmin co caddc co c2 ci cA cmul co ce cfv cmul
    co c2 cdiv cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc co caddc co ci cA
    cmul co ce cfv ci cA cmul co ce cfv caddc co ci cA cmul co ce cfv ci cneg
    cA cmul co ce cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    cmin co caddc co c2 ci cA cmul co ce cfv cmul co cA cc wcel ci cneg cA cmul
    co ce cfv ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc co
    ci cA cmul co ce cfv ci cA cmul co ce cfv caddc ci cneg cA cmul co ce cfv
    cc wcel ci cA cmul co ce cfv cc wcel ci cneg cA cmul co ce cfv ci cA cmul
    co ce cfv ci cneg cA cmul co ce cfv cmin co caddc co ci cA cmul co ce cfv
    wceq cA cc wcel ci cneg cA cmul co ce cfv ci cA cmul co ce cfv pncan3 cA cc
    wcel ci cneg cA cmul co cc wcel ci cneg cA cmul co ce cfv cc wcel ci cneg
    cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci axicn negcli ci cneg cA
    mulcl mpan ci cneg cA cmul co efcl syl cA cc wcel ci cA cmul co cc wcel ci
    cA cmul co ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn
    ci cA mulcl mpan ci cA cmul co efcl syl sylanc opreq2d ci cA cmul co ce cfv
    cc wcel ci cneg cA cmul co ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv cmin co cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv caddc co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co caddc
    co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co caddc co caddc co wceq cA cc wcel ci cA cmul
    co ce cfv ci cneg cA cmul co ce cfv ci cA cmul co ce cfv ci cneg cA cmul co
    ce cfv cmin co addass cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv
    cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan
    ci cA cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA
    cmul co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc
    wcel ci axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl ci
    cA cmul co ce cfv cc wcel ci cneg cA cmul co ce cfv cc wcel ci cA cmul co
    ce cfv ci cneg cA cmul co ce cfv cmin co cc wcel cA cc wcel ci cA cmul co
    ce cfv ci cneg cA cmul co ce cfv subcl cA cc wcel ci cA cmul co cc wcel ci
    cA cmul co ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn
    ci cA mulcl mpan ci cA cmul co efcl syl cA cc wcel ci cneg cA cmul co cc
    wcel ci cneg cA cmul co ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg
    cA cmul co cc wcel ci axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co
    efcl syl sylanc syl3anc cA cc wcel ci cA cmul co ce cfv cc wcel c2 ci cA
    cmul co ce cfv cmul co ci cA cmul co ce cfv ci cA cmul co ce cfv caddc co
    wceq cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel ci cc
    wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA cmul co
    efcl syl ci cA cmul co ce cfv 2times syl 3eqtr4d opreq1d cA cc wcel ci cA
    cmul co ce cfv cc wcel c2 ci cA cmul co ce cfv cmul co c2 cdiv co ci cA
    cmul co ce cfv wceq cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv
    cc wcel ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan
    ci cA cmul co efcl syl ci cA cmul co ce cfv cc wcel c2 cc wcel c2 cc0 wne
    c2 ci cA cmul co ce cfv cmul co c2 cdiv co ci cA cmul co ce cfv wceq 2cn
    2ne0 ci cA cmul co ce cfv c2 divcan3 mp3an23 syl eqtr2d cA cc wcel cA ccos
    cfv ci cA cmul co ce cfv ci cneg cA cmul co ce cfv caddc co c2 cdiv co ci
    cA csin cfv cmul co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co
    c2 cdiv co caddc cA cosval cA cc wcel ci ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv cmin co c2 ci cmul co cdiv co cmul co ci cA cmul co ce cfv
    ci cneg cA cmul co ce cfv cmin co ci c2 ci cmul co cdiv co cmul co ci cA
    csin cfv cmul co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2
    cdiv co cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co
    cc wcel ci ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci
    cmul co cdiv co cmul co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin
    co ci c2 ci cmul co cdiv co cmul co wceq ci cA cmul co ce cfv cc wcel ci
    cneg cA cmul co ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co cc wcel cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv subcl cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel ci
    cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA cmul
    co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA cmul co ce cfv
    cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci axicn
    negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl sylanc ci cc wcel
    ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc wcel c2 ci cmul
    co cc wcel c2 ci cmul co cc0 wne wa ci ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmin co c2 ci cmul co cdiv co cmul co ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co ci c2 ci cmul co cdiv co cmul co wceq axicn
    c2 ci cmul co cc wcel c2 ci cmul co cc0 wne c2 ci 2cn axicn mulcli c2 ci
    2cn axicn 2ne0 ine0 muln0i pm3.2i ci ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmin co c2 ci cmul co div12 mp3an13 syl cA cc wcel cA csin cfv ci
    cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci cmul co cdiv co
    ci cmul cA sinval opreq2d cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmin co c2 cdiv co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    cmin co c1 c2 cdiv co cmul co ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co ci c2 ci cmul co cdiv co cmul co cA cc wcel ci cA cmul co ce
    cfv ci cneg cA cmul co ce cfv cmin co cc wcel ci cA cmul co ce cfv ci cneg
    cA cmul co ce cfv cmin co c2 cdiv co ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmin co c1 c2 cdiv co cmul co wceq ci cA cmul co ce cfv cc wcel
    ci cneg cA cmul co ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA cmul co
    ce cfv cmin co cc wcel cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co
    ce cfv subcl cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel
    ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA
    cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA cmul co
    ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci
    axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl sylanc ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc wcel c2 cc wcel c2 cc0
    wne ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 cdiv co ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c1 c2 cdiv co cmul co wceq
    2cn 2ne0 ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 divrec
    mp3an23 syl ci c2 ci cmul co cdiv co c1 c2 cdiv co ci cA cmul co ce cfv ci
    cneg cA cmul co ce cfv cmin co cmul c1 ci cmul co c2 ci cmul co cdiv co ci
    c2 ci cmul co cdiv co c1 c2 cdiv co c1 ci cmul co ci c2 ci cmul co cdiv ci
    axicn mulid2i opreq1i c1 c2 cdiv co ci ci cdiv co cmul co c1 c2 cdiv co c1
    cmul co c1 ci cmul co c2 ci cmul co cdiv co c1 c2 cdiv co ci ci cdiv co c1
    c1 c2 cdiv co cmul ci axicn ine0 dividi opreq2i c1 c2 ci ci ax1cn 2cn axicn
    axicn 2ne0 ine0 divmuldivi c1 c2 cdiv co c2 2cn 2ne0 reccli mulid1i 3eqtr3i
    eqtr3i opreq2i syl6eqr 3eqtr4d opreq12d 3eqtr4d $.
    $( [15-Sep-2005] $) $( [30-Apr-2005] $)

  $( The exponential function in terms of sine and cosine. $)
  efmival $p |- ( A e. CC -> ( exp ` ( -u _i x. A ) ) =
                ( ( cos ` A ) - ( _i x. ( sin ` A ) ) ) ) $=
    cA cc wcel ci cneg cA cmul co ce cfv ci cA cneg cmul co ce cfv cA cneg ccos
    cfv ci cA cneg csin cfv cmul co caddc co cA ccos cfv ci cA csin cfv cmul co
    cmin co cA cc wcel ci cneg cA cmul co ci cA cneg cmul co ce ci cc wcel cA
    cc wcel ci cneg cA cmul co ci cA cneg cmul co wceq axicn ci cA mulneg12
    mpan fveq2d cA cc wcel cA cneg cc wcel ci cA cneg cmul co ce cfv cA cneg
    ccos cfv ci cA cneg csin cfv cmul co caddc co wceq cA negcl cA cneg efival
    syl cA cc wcel cA cneg ccos cfv ci cA cneg csin cfv cmul co caddc co cA
    ccos cfv ci cA csin cfv cmul co cneg caddc co cA ccos cfv ci cA csin cfv
    cmul co cmin co cA cc wcel cA cneg ccos cfv cA ccos cfv ci cA cneg csin cfv
    cmul co ci cA csin cfv cmul co cneg caddc cA cosneg cA cc wcel ci cA cneg
    csin cfv cmul co ci cA csin cfv cneg cmul co ci cA csin cfv cmul co cneg cA
    cc wcel cA cneg csin cfv cA csin cfv cneg ci cmul cA sinneg opreq2d ci cc
    wcel cA csin cfv cc wcel ci cA csin cfv cneg cmul co ci cA csin cfv cmul co
    cneg wceq cA cc wcel ci cA csin cfv mulneg2 axicn cA sincl sylancr eqtrd
    opreq12d cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel cA ccos cfv ci
    cA csin cfv cmul co cneg caddc co cA ccos cfv ci cA csin cfv cmul co cmin
    co wceq cA cc wcel cA ccos cfv ci cA csin cfv cmul co negsub cA coscl ci cc
    wcel cA csin cfv cc wcel ci cA csin cfv cmul co cc wcel cA cc wcel ci cA
    csin cfv mulcl axicn cA sincl sylancr sylanc eqtrd 3eqtrd $.
    $( [20-Feb-2006] $) $( [14-Jan-2006] $)

  $( Eulerian representation of the complex exponential.  (Suggested by
     Jeffrey Hankins, 3-Jul-2006.) $)
  efeul $p |- ( A e. CC -> ( exp ` A ) = ( ( exp ` ( Re ` A ) ) x.
               ( ( cos ` ( Im ` A ) ) + ( _i x. ( sin ` ( Im ` A ) ) ) ) ) ) $=
    cA cc wcel cA ce cfv cA cre cfv ci cA cim cfv cmul co caddc co ce cfv cA
    cre cfv ce cfv ci cA cim cfv cmul co ce cfv cmul co cA cre cfv ce cfv cA
    cim cfv ccos cfv ci cA cim cfv csin cfv cmul co caddc co cmul co cA cc wcel
    cA cA cre cfv ci cA cim cfv cmul co caddc co ce cA replim fveq2d cA cre cfv
    cc wcel ci cA cim cfv cmul co cc wcel cA cre cfv ci cA cim cfv cmul co
    caddc co ce cfv cA cre cfv ce cfv ci cA cim cfv cmul co ce cfv cmul co wceq
    cA cc wcel cA cre cfv ci cA cim cfv cmul co efadd cA cc wcel cA cre cfv cA
    recl recnd ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA
    cc wcel ci cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd
    sylancr sylanc cA cc wcel ci cA cim cfv cmul co ce cfv cA cim cfv ccos cfv
    ci cA cim cfv csin cfv cmul co caddc co cA cre cfv ce cfv cmul cA cc wcel
    cA cim cfv cc wcel ci cA cim cfv cmul co ce cfv cA cim cfv ccos cfv ci cA
    cim cfv csin cfv cmul co caddc co wceq cA cc wcel cA cim cfv cA imcl recnd
    cA cim cfv efival syl opreq2d 3eqtrd $.
    $( [25-Jul-2008] $) $( [4-Jul-2006] $)

  $( The exponentials of two imaginary numbers are equal iff their sine and
     cosine components are equal.  (Contributed by Paul Chapman,
     15-Mar-2008.) $)
  efieq $p |- ( ( A e. RR /\ B e. RR ) ->
       ( ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) <->
         ( ( cos ` A ) = ( cos ` B ) /\ ( sin ` A ) = ( sin ` B ) ) ) ) $=
    cA cr wcel cB cr wcel wa ci cA cmul co ce cfv ci cB cmul co ce cfv wceq cA
    ccos cfv ci cA csin cfv cmul co caddc co cB ccos cfv ci cB csin cfv cmul co
    caddc co wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa
    cA cc wcel cB cc wcel ci cA cmul co ce cfv ci cB cmul co ce cfv wceq cA
    ccos cfv ci cA csin cfv cmul co caddc co cB ccos cfv ci cB csin cfv cmul co
    caddc co wceq wb cA cr wcel cB cr wcel cA cc wcel cB cc wcel ci cA cmul co
    ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co ci cB cmul co ce cfv cB
    ccos cfv ci cB csin cfv cmul co caddc co cA efival cB efival eqeqan12d cA
    recn cB recn syl2an cA ccos cfv cr wcel cA csin cfv cr wcel wa cB ccos cfv
    cr wcel cB csin cfv cr wcel wa cA ccos cfv ci cA csin cfv cmul co caddc co
    cB ccos cfv ci cB csin cfv cmul co caddc co wceq cA ccos cfv cB ccos cfv
    wceq cA csin cfv cB csin cfv wceq wa wb cA cr wcel cB cr wcel cA ccos cfv
    cA csin cfv cB ccos cfv cB csin cfv cru cA cr wcel cA ccos cfv cr wcel cA
    csin cfv cr wcel cA recoscl cA resincl jca cB cr wcel cB ccos cfv cr wcel
    cB csin cfv cr wcel cB recoscl cB resincl jca syl2an bitrd $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  ${
    sinadd.1 $e |- A e. CC $.
    sinadd.2 $e |- B e. CC $.
    $( Sine addition formula for complex arguments.  Equation 14 of [Gleason]
       p. 310. $)
    sinaddi $p |- ( sin ` ( A + B ) ) =
       ( ( ( sin ` A ) x. ( cos ` B ) ) + ( ( cos ` A ) x. ( sin ` B ) ) ) $=
      cA cB caddc co csin cfv ci cA cB caddc co cmul co ce cfv ci cneg cA cB
      caddc co cmul co ce cfv cmin co c2 ci cmul co cdiv co c2 cA ccos cfv ci
      cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co
      caddc co cmul co c2 ci cmul co cdiv co cA csin cfv cB ccos cfv cmul co cA
      ccos cfv cB csin cfv cmul co caddc co cA cB caddc co cc wcel cA cB caddc
      co csin cfv ci cA cB caddc co cmul co ce cfv ci cneg cA cB caddc co cmul
      co ce cfv cmin co c2 ci cmul co cdiv co wceq cA cB sinadd.1 sinadd.2
      addcli cA cB caddc co sinval ax-mp ci cA cB caddc co cmul co ce cfv ci
      cneg cA cB caddc co cmul co ce cfv cmin co c2 cA ccos cfv ci cB csin cfv
      cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cmul
      co c2 ci cmul co cdiv cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul
      co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv
      cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co caddc
      co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv
      cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co cB
      ccos cfv ci cA csin cfv cmul co cmul co caddc co cmin co cmin co cA ccos
      cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co
      cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv
      ci cA csin cfv cmul co cmul co caddc co caddc co ci cA cB caddc co cmul
      co ce cfv ci cneg cA cB caddc co cmul co ce cfv cmin co c2 cA ccos cfv ci
      cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co
      caddc co cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co
      ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul
      co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cA ccos
      cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co
      cmul co caddc co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co
      ci cA csin cfv cmul co cmul co cA ccos cfv cB ccos cfv cA cc wcel cA ccos
      cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB ccos cfv cc wcel
      sinadd.2 cB coscl ax-mp mulcli ci cB csin cfv cmul co ci cA csin cfv cmul
      co ci cB csin cfv axicn cB cc wcel cB csin cfv cc wcel sinadd.2 cB sincl
      ax-mp mulcli ci cA csin cfv axicn cA cc wcel cA csin cfv cc wcel sinadd.1
      cA sincl ax-mp mulcli mulcli addcli cA ccos cfv ci cB csin cfv cmul co
      cmul co cB ccos cfv ci cA csin cfv cmul co cmul co cA ccos cfv ci cB csin
      cfv cmul co cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cB
      csin cfv axicn cB cc wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp
      mulcli mulcli cB ccos cfv ci cA csin cfv cmul co cB cc wcel cB ccos cfv
      cc wcel sinadd.2 cB coscl ax-mp ci cA csin cfv axicn cA cc wcel cA csin
      cfv cc wcel sinadd.1 cA sincl ax-mp mulcli mulcli addcli cA ccos cfv ci
      cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co cA
      ccos cfv ci cB csin cfv cmul co cA cc wcel cA ccos cfv cc wcel sinadd.1
      cA coscl ax-mp ci cB csin cfv axicn cB cc wcel cB csin cfv cc wcel
      sinadd.2 cB sincl ax-mp mulcli mulcli cB ccos cfv ci cA csin cfv cmul co
      cB cc wcel cB ccos cfv cc wcel sinadd.2 cB coscl ax-mp ci cA csin cfv
      axicn cA cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mulcli
      mulcli addcli pnncani ci cA cB caddc co cmul co ce cfv cA ccos cfv cB
      ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co
      caddc co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA
      csin cfv cmul co cmul co caddc co caddc co ci cneg cA cB caddc co cmul co
      ce cfv cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin
      cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co
      cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cmin co cmin ci cA cB
      caddc co cmul co ce cfv ci cA cmul co ci cB cmul co caddc co ce cfv ci cA
      cmul co ce cfv ci cB cmul co ce cfv cmul co cA ccos cfv cB ccos cfv cmul
      co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos
      cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co
      cmul co caddc co caddc co ci cA cB caddc co cmul co ci cA cmul co ci cB
      cmul co caddc co ce ci cA cB axicn sinadd.1 sinadd.2 adddii fveq2i ci cA
      cmul co ci cB cmul co ci cA axicn sinadd.1 mulcli ci cB axicn sinadd.2
      mulcli efaddi ci cA cmul co ce cfv ci cB cmul co ce cfv cmul co cA ccos
      cfv ci cA csin cfv cmul co caddc co cB ccos cfv ci cB csin cfv cmul co
      caddc co cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co
      ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul
      co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co caddc co
      ci cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co ci cB
      cmul co ce cfv cB ccos cfv ci cB csin cfv cmul co caddc co cmul cA cc
      wcel ci cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co
      wceq sinadd.1 cA efival ax-mp cB cc wcel ci cB cmul co ce cfv cB ccos cfv
      ci cB csin cfv cmul co caddc co wceq sinadd.2 cB efival ax-mp opreq12i cA
      ccos cfv ci cA csin cfv cmul co cB ccos cfv ci cB csin cfv cmul co cA cc
      wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cA csin cfv axicn cA
      cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mulcli cB cc wcel cB
      ccos cfv cc wcel sinadd.2 cB coscl ax-mp ci cB csin cfv axicn cB cc wcel
      cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli muladdi eqtri 3eqtri
      ci cneg cA cB caddc co cmul co ce cfv ci cneg cA cmul co ci cneg cB cmul
      co caddc co ce cfv ci cneg cA cmul co ce cfv ci cneg cB cmul co ce cfv
      cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin
      cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co
      cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cmin co ci cneg cA cB
      caddc co cmul co ci cneg cA cmul co ci cneg cB cmul co caddc co ce ci
      cneg cA cB ci axicn negcli sinadd.1 sinadd.2 adddii fveq2i ci cneg cA
      cmul co ci cneg cB cmul co ci cneg cA ci axicn negcli sinadd.1 mulcli ci
      cneg cB ci axicn negcli sinadd.2 mulcli efaddi ci cneg cA cmul co ce cfv
      ci cneg cB cmul co ce cfv cmul co cA ccos cfv ci cA csin cfv cmul co cmin
      co cB ccos cfv ci cB csin cfv cmul co cmin co cmul co cA ccos cfv cB ccos
      cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc
      co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv
      cmul co cmul co caddc co cmin co ci cneg cA cmul co ce cfv cA ccos cfv ci
      cA csin cfv cmul co cmin co ci cneg cB cmul co ce cfv cB ccos cfv ci cB
      csin cfv cmul co cmin co cmul cA cc wcel ci cneg cA cmul co ce cfv cA
      ccos cfv ci cA csin cfv cmul co cmin co wceq sinadd.1 cA efmival ax-mp cB
      cc wcel ci cneg cB cmul co ce cfv cB ccos cfv ci cB csin cfv cmul co cmin
      co wceq sinadd.2 cB efmival ax-mp opreq12i cA ccos cfv cc wcel ci cA csin
      cfv cmul co cc wcel wa cB ccos cfv cc wcel ci cB csin cfv cmul co cc wcel
      wa cA ccos cfv ci cA csin cfv cmul co cmin co cB ccos cfv ci cB csin cfv
      cmul co cmin co cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv
      cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin
      cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co
      cmin co wceq cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel cA cc
      wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cA csin cfv axicn cA
      cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mulcli pm3.2i cB ccos
      cfv cc wcel ci cB csin cfv cmul co cc wcel cB cc wcel cB ccos cfv cc wcel
      sinadd.2 cB coscl ax-mp ci cB csin cfv axicn cB cc wcel cB csin cfv cc
      wcel sinadd.2 cB sincl ax-mp mulcli pm3.2i cA ccos cfv ci cA csin cfv
      cmul co cB ccos cfv ci cB csin cfv cmul co mulsub mp2an eqtri 3eqtri
      opreq12i cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA
      csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul
      co cB ccos cfv ci cA csin cfv cmul co cmul co cA ccos cfv ci cB csin cfv
      cmul co cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cB csin
      cfv axicn cB cc wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli
      mulcli cB ccos cfv ci cA csin cfv cmul co cB cc wcel cB ccos cfv cc wcel
      sinadd.2 cB coscl ax-mp ci cA csin cfv axicn cA cc wcel cA csin cfv cc
      wcel sinadd.1 cA sincl ax-mp mulcli mulcli addcli 2timesi 3eqtr4i opreq1i
      c2 cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv
      cmul co cmul co caddc co cmul co c2 ci cmul co cdiv co cA ccos cfv cB
      csin cfv cmul co cA csin cfv cB ccos cfv cmul co caddc co cA csin cfv cB
      ccos cfv cmul co cA ccos cfv cB csin cfv cmul co caddc co c2 cA ccos cfv
      ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co
      caddc co cmul co c2 ci cmul co cdiv co cA ccos cfv cB csin cfv cmul co cA
      csin cfv cB ccos cfv cmul co caddc co wceq c2 ci cmul co cA ccos cfv cB
      csin cfv cmul co cA csin cfv cB ccos cfv cmul co caddc co cmul co c2 cA
      ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul
      co cmul co caddc co cmul co wceq c2 ci cmul co cA ccos cfv cB csin cfv
      cmul co cA csin cfv cB ccos cfv cmul co caddc co cmul co c2 ci cA ccos
      cfv cB csin cfv cmul co cA csin cfv cB ccos cfv cmul co caddc co cmul co
      cmul co c2 cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA
      csin cfv cmul co cmul co caddc co cmul co c2 ci cA ccos cfv cB csin cfv
      cmul co cA csin cfv cB ccos cfv cmul co caddc co 2cn axicn cA ccos cfv cB
      csin cfv cmul co cA csin cfv cB ccos cfv cmul co cA ccos cfv cB csin cfv
      cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB csin
      cfv cc wcel sinadd.2 cB sincl ax-mp mulcli cA csin cfv cB ccos cfv cA cc
      wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp cB cc wcel cB ccos cfv
      cc wcel sinadd.2 cB coscl ax-mp mulcli addcli mulassi ci cA ccos cfv cB
      csin cfv cmul co cA csin cfv cB ccos cfv cmul co caddc co cmul co cA ccos
      cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co
      cmul co caddc co c2 cmul ci cA ccos cfv cB csin cfv cmul co cA csin cfv
      cB ccos cfv cmul co caddc co cmul co ci cA ccos cfv cB csin cfv cmul co
      cmul co ci cA csin cfv cB ccos cfv cmul co cmul co caddc co cA ccos cfv
      ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co
      caddc co ci cA ccos cfv cB csin cfv cmul co cA csin cfv cB ccos cfv cmul
      co axicn cA ccos cfv cB csin cfv cA cc wcel cA ccos cfv cc wcel sinadd.1
      cA coscl ax-mp cB cc wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp
      mulcli cA csin cfv cB ccos cfv cA cc wcel cA csin cfv cc wcel sinadd.1 cA
      sincl ax-mp cB cc wcel cB ccos cfv cc wcel sinadd.2 cB coscl ax-mp mulcli
      adddii ci cA ccos cfv cB csin cfv cmul co cmul co cA ccos cfv ci cB csin
      cfv cmul co cmul co ci cA csin cfv cB ccos cfv cmul co cmul co cB ccos
      cfv ci cA csin cfv cmul co cmul co caddc ci cA ccos cfv cB csin cfv axicn
      cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB csin
      cfv cc wcel sinadd.2 cB sincl ax-mp mul12i ci cA csin cfv cB ccos cfv
      cmul co cmul co ci cB ccos cfv cA csin cfv cmul co cmul co cB ccos cfv ci
      cA csin cfv cmul co cmul co cA csin cfv cB ccos cfv cmul co cB ccos cfv
      cA csin cfv cmul co ci cmul cA csin cfv cB ccos cfv cA cc wcel cA csin
      cfv cc wcel sinadd.1 cA sincl ax-mp cB cc wcel cB ccos cfv cc wcel
      sinadd.2 cB coscl ax-mp mulcomi opreq2i ci cB ccos cfv cA csin cfv axicn
      cB cc wcel cB ccos cfv cc wcel sinadd.2 cB coscl ax-mp cA cc wcel cA csin
      cfv cc wcel sinadd.1 cA sincl ax-mp mul12i eqtri opreq12i eqtri opreq2i
      eqtri c2 cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA
      csin cfv cmul co cmul co caddc co cmul co c2 ci cmul co cA ccos cfv cB
      csin cfv cmul co cA csin cfv cB ccos cfv cmul co caddc co c2 cA ccos cfv
      ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co
      caddc co 2cn cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA
      csin cfv cmul co cmul co cA ccos cfv ci cB csin cfv cmul co cA cc wcel cA
      ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cB csin cfv axicn cB cc wcel
      cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli mulcli cB ccos cfv ci
      cA csin cfv cmul co cB cc wcel cB ccos cfv cc wcel sinadd.2 cB coscl
      ax-mp ci cA csin cfv axicn cA cc wcel cA csin cfv cc wcel sinadd.1 cA
      sincl ax-mp mulcli mulcli addcli mulcli c2 ci 2cn axicn mulcli cA ccos
      cfv cB csin cfv cmul co cA csin cfv cB ccos cfv cmul co cA ccos cfv cB
      csin cfv cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc
      wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli cA csin cfv cB
      ccos cfv cA cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp cB cc
      wcel cB ccos cfv cc wcel sinadd.2 cB coscl ax-mp mulcli addcli c2 ci 2cn
      axicn 2ne0 ine0 muln0i divmuli mpbir cA csin cfv cB ccos cfv cmul co cA
      ccos cfv cB csin cfv cmul co cA csin cfv cB ccos cfv cA cc wcel cA csin
      cfv cc wcel sinadd.1 cA sincl ax-mp cB cc wcel cB ccos cfv cc wcel
      sinadd.2 cB coscl ax-mp mulcli cA ccos cfv cB csin cfv cA cc wcel cA ccos
      cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB csin cfv cc wcel
      sinadd.2 cB sincl ax-mp mulcli addcomi eqtr4i 3eqtri $.
      $( [20-Feb-2006] $) $( [14-Jan-2006] $)

    $( Addition formula for cosine.  Equation 15 of [Gleason] p. 310. $)
    cosaddi $p |- ( cos ` ( A + B ) ) =
         ( ( ( cos ` A ) x. ( cos ` B ) ) - ( ( sin ` A ) x. ( sin ` B ) ) ) $=
      cA cB caddc co ccos cfv ci cA cB caddc co cmul co ce cfv ci cneg cA cB
      caddc co cmul co ce cfv caddc co c2 cdiv co c2 cA ccos cfv cB ccos cfv
      cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co
      cmul co c2 cdiv co cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin
      cfv cmul co cmin co cA cB caddc co cc wcel cA cB caddc co ccos cfv ci cA
      cB caddc co cmul co ce cfv ci cneg cA cB caddc co cmul co ce cfv caddc co
      c2 cdiv co wceq cA cB sinadd.1 sinadd.2 addcli cA cB caddc co cosval
      ax-mp ci cA cB caddc co cmul co ce cfv ci cneg cA cB caddc co cmul co ce
      cfv caddc co c2 cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci
      cA csin cfv cmul co cmul co caddc co cmul co c2 cdiv cA ccos cfv cB ccos
      cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc
      co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv
      cmul co cmul co caddc co caddc co cA ccos cfv cB ccos cfv cmul co ci cB
      csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci
      cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co
      caddc co cmin co caddc co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv
      cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv cB ccos cfv
      cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co
      caddc co ci cA cB caddc co cmul co ce cfv ci cneg cA cB caddc co cmul co
      ce cfv caddc co c2 cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co
      ci cA csin cfv cmul co cmul co caddc co cmul co cA ccos cfv cB ccos cfv
      cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co cc
      wcel cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin
      cfv cmul co cmul co caddc co cc wcel cA ccos cfv cB ccos cfv cmul co ci
      cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co cc wcel cA
      ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul
      co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos
      cfv ci cA csin cfv cmul co cmul co caddc co caddc co cA ccos cfv cB ccos
      cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc
      co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv
      cmul co cmul co caddc co cmin co caddc co cA ccos cfv cB ccos cfv cmul co
      ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos
      cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co
      cmul co caddc co caddc co wceq cA ccos cfv cB ccos cfv cmul co ci cB csin
      cfv cmul co ci cA csin cfv cmul co cmul co cA ccos cfv cB ccos cfv cA cc
      wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB ccos cfv
      cc wcel sinadd.2 cB coscl ax-mp mulcli ci cB csin cfv cmul co ci cA csin
      cfv cmul co ci cB csin cfv axicn cB cc wcel cB csin cfv cc wcel sinadd.2
      cB sincl ax-mp mulcli ci cA csin cfv axicn cA cc wcel cA csin cfv cc wcel
      sinadd.1 cA sincl ax-mp mulcli mulcli addcli cA ccos cfv ci cB csin cfv
      cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co cA ccos cfv ci
      cB csin cfv cmul co cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl
      ax-mp ci cB csin cfv axicn cB cc wcel cB csin cfv cc wcel sinadd.2 cB
      sincl ax-mp mulcli mulcli cB ccos cfv ci cA csin cfv cmul co cB cc wcel
      cB ccos cfv cc wcel sinadd.2 cB coscl ax-mp ci cA csin cfv axicn cA cc
      wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mulcli mulcli addcli cA
      ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul
      co cmul co cA ccos cfv cB ccos cfv cA cc wcel cA ccos cfv cc wcel
      sinadd.1 cA coscl ax-mp cB cc wcel cB ccos cfv cc wcel sinadd.2 cB coscl
      ax-mp mulcli ci cB csin cfv cmul co ci cA csin cfv cmul co ci cB csin cfv
      axicn cB cc wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli ci cA
      csin cfv axicn cA cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp
      mulcli mulcli addcli cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul
      co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv
      cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cA
      ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul
      co cmul co caddc co ppncan mp3an ci cA cB caddc co cmul co ce cfv cA ccos
      cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co
      cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv
      ci cA csin cfv cmul co cmul co caddc co caddc co ci cneg cA cB caddc co
      cmul co ce cfv cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci
      cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co
      cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cmin co caddc
      ci cA cB caddc co cmul co ce cfv ci cA cmul co ci cB cmul co caddc co ce
      cfv ci cA cmul co ce cfv ci cB cmul co ce cfv cmul co cA ccos cfv cB ccos
      cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc
      co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv
      cmul co cmul co caddc co caddc co ci cA cB caddc co cmul co ci cA cmul co
      ci cB cmul co caddc co ce ci cA cB axicn sinadd.1 sinadd.2 adddii fveq2i
      ci cA cmul co ci cB cmul co ci cA axicn sinadd.1 mulcli ci cB axicn
      sinadd.2 mulcli efaddi ci cA cmul co ce cfv ci cB cmul co ce cfv cmul co
      cA ccos cfv ci cA csin cfv cmul co caddc co cB ccos cfv ci cB csin cfv
      cmul co caddc co cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv
      cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin
      cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co
      caddc co ci cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co
      ci cB cmul co ce cfv cB ccos cfv ci cB csin cfv cmul co caddc co cmul cA
      cc wcel ci cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co
      wceq sinadd.1 cA efival ax-mp cB cc wcel ci cB cmul co ce cfv cB ccos cfv
      ci cB csin cfv cmul co caddc co wceq sinadd.2 cB efival ax-mp opreq12i cA
      ccos cfv ci cA csin cfv cmul co cB ccos cfv ci cB csin cfv cmul co cA cc
      wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cA csin cfv axicn cA
      cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mulcli cB cc wcel cB
      ccos cfv cc wcel sinadd.2 cB coscl ax-mp ci cB csin cfv axicn cB cc wcel
      cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli muladdi eqtri 3eqtri
      ci cneg cA cB caddc co cmul co ce cfv ci cneg cA cmul co ci cneg cB cmul
      co caddc co ce cfv ci cneg cA cmul co ce cfv ci cneg cB cmul co ce cfv
      cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin
      cfv cmul co cmul co caddc co cA ccos cfv ci cB csin cfv cmul co cmul co
      cB ccos cfv ci cA csin cfv cmul co cmul co caddc co cmin co ci cneg cA cB
      caddc co cmul co ci cneg cA cmul co ci cneg cB cmul co caddc co ce ci
      cneg cA cB ci axicn negcli sinadd.1 sinadd.2 adddii fveq2i ci cneg cA
      cmul co ci cneg cB cmul co ci cneg cA ci axicn negcli sinadd.1 mulcli ci
      cneg cB ci axicn negcli sinadd.2 mulcli efaddi ci cneg cA cmul co ce cfv
      ci cneg cB cmul co ce cfv cmul co cA ccos cfv ci cA csin cfv cmul co cmin
      co cB ccos cfv ci cB csin cfv cmul co cmin co cmul co cA ccos cfv cB ccos
      cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc
      co cA ccos cfv ci cB csin cfv cmul co cmul co cB ccos cfv ci cA csin cfv
      cmul co cmul co caddc co cmin co ci cneg cA cmul co ce cfv cA ccos cfv ci
      cA csin cfv cmul co cmin co ci cneg cB cmul co ce cfv cB ccos cfv ci cB
      csin cfv cmul co cmin co cmul cA cc wcel ci cneg cA cmul co ce cfv cA
      ccos cfv ci cA csin cfv cmul co cmin co wceq sinadd.1 cA efmival ax-mp cB
      cc wcel ci cneg cB cmul co ce cfv cB ccos cfv ci cB csin cfv cmul co cmin
      co wceq sinadd.2 cB efmival ax-mp opreq12i cA ccos cfv cc wcel ci cA csin
      cfv cmul co cc wcel wa cB ccos cfv cc wcel ci cB csin cfv cmul co cc wcel
      wa cA ccos cfv ci cA csin cfv cmul co cmin co cB ccos cfv ci cB csin cfv
      cmul co cmin co cmul co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv
      cmul co ci cA csin cfv cmul co cmul co caddc co cA ccos cfv ci cB csin
      cfv cmul co cmul co cB ccos cfv ci cA csin cfv cmul co cmul co caddc co
      cmin co wceq cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel cA cc
      wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp ci cA csin cfv axicn cA
      cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mulcli pm3.2i cB ccos
      cfv cc wcel ci cB csin cfv cmul co cc wcel cB cc wcel cB ccos cfv cc wcel
      sinadd.2 cB coscl ax-mp ci cB csin cfv axicn cB cc wcel cB csin cfv cc
      wcel sinadd.2 cB sincl ax-mp mulcli pm3.2i cA ccos cfv ci cA csin cfv
      cmul co cB ccos cfv ci cB csin cfv cmul co mulsub mp2an eqtri 3eqtri
      opreq12i cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA
      csin cfv cmul co cmul co caddc co cA ccos cfv cB ccos cfv cmul co ci cB
      csin cfv cmul co ci cA csin cfv cmul co cmul co cA ccos cfv cB ccos cfv
      cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB ccos
      cfv cc wcel sinadd.2 cB coscl ax-mp mulcli ci cB csin cfv cmul co ci cA
      csin cfv cmul co ci cB csin cfv axicn cB cc wcel cB csin cfv cc wcel
      sinadd.2 cB sincl ax-mp mulcli ci cA csin cfv axicn cA cc wcel cA csin
      cfv cc wcel sinadd.1 cA sincl ax-mp mulcli mulcli addcli 2timesi 3eqtr4i
      opreq1i c2 cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA
      csin cfv cmul co cmul co caddc co cmul co c2 cdiv co cA ccos cfv cB ccos
      cfv cmul co ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co caddc
      co cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin cfv cmul co cneg
      caddc co cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin cfv cmul co
      cmin co cA ccos cfv cB ccos cfv cmul co ci cB csin cfv cmul co ci cA csin
      cfv cmul co cmul co caddc co c2 cA ccos cfv cB ccos cfv cmul co ci cB
      csin cfv cmul co ci cA csin cfv cmul co cmul co cA ccos cfv cB ccos cfv
      cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc wcel cB ccos
      cfv cc wcel sinadd.2 cB coscl ax-mp mulcli ci cB csin cfv cmul co ci cA
      csin cfv cmul co ci cB csin cfv axicn cB cc wcel cB csin cfv cc wcel
      sinadd.2 cB sincl ax-mp mulcli ci cA csin cfv axicn cA cc wcel cA csin
      cfv cc wcel sinadd.1 cA sincl ax-mp mulcli mulcli addcli 2cn 2ne0
      divcan3i ci cB csin cfv cmul co ci cA csin cfv cmul co cmul co cA csin
      cfv cB csin cfv cmul co cneg cA ccos cfv cB ccos cfv cmul co caddc ci cB
      csin cfv cmul co ci cA csin cfv cmul co cmul co ci ci cmul co cB csin cfv
      cA csin cfv cmul co cmul co c1 cneg cA csin cfv cB csin cfv cmul co cmul
      co cA csin cfv cB csin cfv cmul co cneg ci cB csin cfv ci cA csin cfv
      axicn cB cc wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp axicn cA cc
      wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp mul4i ci ci cmul co c1
      cneg cB csin cfv cA csin cfv cmul co cA csin cfv cB csin cfv cmul co cmul
      ixi cB csin cfv cA csin cfv cB cc wcel cB csin cfv cc wcel sinadd.2 cB
      sincl ax-mp cA cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp
      mulcomi opreq12i cA csin cfv cB csin cfv cmul co cA csin cfv cB csin cfv
      cA cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp cB cc wcel cB csin
      cfv cc wcel sinadd.2 cB sincl ax-mp mulcli mulm1i 3eqtri opreq2i cA ccos
      cfv cB ccos cfv cmul co cA csin cfv cB csin cfv cmul co cA ccos cfv cB
      ccos cfv cA cc wcel cA ccos cfv cc wcel sinadd.1 cA coscl ax-mp cB cc
      wcel cB ccos cfv cc wcel sinadd.2 cB coscl ax-mp mulcli cA csin cfv cB
      csin cfv cA cc wcel cA csin cfv cc wcel sinadd.1 cA sincl ax-mp cB cc
      wcel cB csin cfv cc wcel sinadd.2 cB sincl ax-mp mulcli negsubi 3eqtri
      3eqtri $.
      $( [24-Feb-2006] $) $( [15-Jan-2006] $)
  $}

  $( Addition formula for sine.  Equation 14 of [Gleason] p. 310.  (Contributed
     by Steve Rodriguez, 10-Nov-2006.) $)
  sinadd $p |- ( ( A e. CC /\ B e. CC ) -> ( sin ` ( A + B ) ) =
       ( ( ( sin ` A ) x. ( cos ` B ) ) + ( ( cos ` A ) x. ( sin ` B ) ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co csin cfv cA csin cfv cB ccos cfv cmul
    co cA ccos cfv cB csin cfv cmul co caddc co wceq cA cc wcel cA cc0 cif cB
    caddc co csin cfv cA cc wcel cA cc0 cif csin cfv cB ccos cfv cmul co cA cc
    wcel cA cc0 cif ccos cfv cB csin cfv cmul co caddc co wceq cA cc wcel cA
    cc0 cif cB cc wcel cB cc0 cif caddc co csin cfv cA cc wcel cA cc0 cif csin
    cfv cB cc wcel cB cc0 cif ccos cfv cmul co cA cc wcel cA cc0 cif ccos cfv
    cB cc wcel cB cc0 cif csin cfv cmul co caddc co wceq cA cB cc0 cc0 cA cA cc
    wcel cA cc0 cif wceq cA cB caddc co csin cfv cA cc wcel cA cc0 cif cB caddc
    co csin cfv cA csin cfv cB ccos cfv cmul co cA ccos cfv cB csin cfv cmul co
    caddc co cA cc wcel cA cc0 cif csin cfv cB ccos cfv cmul co cA cc wcel cA
    cc0 cif ccos cfv cB csin cfv cmul co caddc co cA cA cc wcel cA cc0 cif wceq
    cA cB caddc co cA cc wcel cA cc0 cif cB caddc co csin cA cA cc wcel cA cc0
    cif cB caddc opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA csin cfv cB
    ccos cfv cmul co cA cc wcel cA cc0 cif csin cfv cB ccos cfv cmul co cA ccos
    cfv cB csin cfv cmul co cA cc wcel cA cc0 cif ccos cfv cB csin cfv cmul co
    caddc cA cA cc wcel cA cc0 cif wceq cA csin cfv cA cc wcel cA cc0 cif csin
    cfv cB ccos cfv cmul cA cA cc wcel cA cc0 cif csin fveq2 opreq1d cA cA cc
    wcel cA cc0 cif wceq cA ccos cfv cA cc wcel cA cc0 cif ccos cfv cB csin cfv
    cmul cA cA cc wcel cA cc0 cif ccos fveq2 opreq1d opreq12d eqeq12d cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co csin cfv cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif caddc co csin cfv cA cc wcel cA cc0 cif
    csin cfv cB ccos cfv cmul co cA cc wcel cA cc0 cif ccos cfv cB csin cfv
    cmul co caddc co cA cc wcel cA cc0 cif csin cfv cB cc wcel cB cc0 cif ccos
    cfv cmul co cA cc wcel cA cc0 cif ccos cfv cB cc wcel cB cc0 cif csin cfv
    cmul co caddc co cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB
    caddc co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co csin cB cB cc
    wcel cB cc0 cif cA cc wcel cA cc0 cif caddc opreq2 fveq2d cB cB cc wcel cB
    cc0 cif wceq cA cc wcel cA cc0 cif csin cfv cB ccos cfv cmul co cA cc wcel
    cA cc0 cif csin cfv cB cc wcel cB cc0 cif ccos cfv cmul co cA cc wcel cA
    cc0 cif ccos cfv cB csin cfv cmul co cA cc wcel cA cc0 cif ccos cfv cB cc
    wcel cB cc0 cif csin cfv cmul co caddc cB cB cc wcel cB cc0 cif wceq cB
    ccos cfv cB cc wcel cB cc0 cif ccos cfv cA cc wcel cA cc0 cif csin cfv cmul
    cB cB cc wcel cB cc0 cif ccos fveq2 opreq2d cB cB cc wcel cB cc0 cif wceq
    cB csin cfv cB cc wcel cB cc0 cif csin cfv cA cc wcel cA cc0 cif ccos cfv
    cmul cB cB cc wcel cB cc0 cif csin fveq2 opreq2d opreq12d eqeq12d cA cc
    wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
    elimel sinaddi dedth2h $.
    $( [10-Nov-2006] $) $( [10-Nov-2006] $)

  $( Addition formula for cosine.  Equation 15 of [Gleason] p. 310. $)
  cosadd $p |- ( ( A e. CC /\ B e. CC ) -> ( cos ` ( A + B ) ) =
       ( ( ( cos ` A ) x. ( cos ` B ) ) - ( ( sin ` A ) x. ( sin ` B ) ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co ccos cfv cA ccos cfv cB ccos cfv cmul
    co cA csin cfv cB csin cfv cmul co cmin co wceq cA cc wcel cA cc0 cif cB
    caddc co ccos cfv cA cc wcel cA cc0 cif ccos cfv cB ccos cfv cmul co cA cc
    wcel cA cc0 cif csin cfv cB csin cfv cmul co cmin co wceq cA cc wcel cA cc0
    cif cB cc wcel cB cc0 cif caddc co ccos cfv cA cc wcel cA cc0 cif ccos cfv
    cB cc wcel cB cc0 cif ccos cfv cmul co cA cc wcel cA cc0 cif csin cfv cB cc
    wcel cB cc0 cif csin cfv cmul co cmin co wceq cA cB cc0 cc0 cA cA cc wcel
    cA cc0 cif wceq cA cB caddc co ccos cfv cA cc wcel cA cc0 cif cB caddc co
    ccos cfv cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin cfv cmul co
    cmin co cA cc wcel cA cc0 cif ccos cfv cB ccos cfv cmul co cA cc wcel cA
    cc0 cif csin cfv cB csin cfv cmul co cmin co cA cA cc wcel cA cc0 cif wceq
    cA cB caddc co cA cc wcel cA cc0 cif cB caddc co ccos cA cA cc wcel cA cc0
    cif cB caddc opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA ccos cfv cB
    ccos cfv cmul co cA cc wcel cA cc0 cif ccos cfv cB ccos cfv cmul co cA csin
    cfv cB csin cfv cmul co cA cc wcel cA cc0 cif csin cfv cB csin cfv cmul co
    cmin cA cA cc wcel cA cc0 cif wceq cA ccos cfv cA cc wcel cA cc0 cif ccos
    cfv cB ccos cfv cmul cA cA cc wcel cA cc0 cif ccos fveq2 opreq1d cA cA cc
    wcel cA cc0 cif wceq cA csin cfv cA cc wcel cA cc0 cif csin cfv cB csin cfv
    cmul cA cA cc wcel cA cc0 cif csin fveq2 opreq1d opreq12d eqeq12d cB cB cc
    wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB caddc co ccos cfv cA cc wcel
    cA cc0 cif cB cc wcel cB cc0 cif caddc co ccos cfv cA cc wcel cA cc0 cif
    ccos cfv cB ccos cfv cmul co cA cc wcel cA cc0 cif csin cfv cB csin cfv
    cmul co cmin co cA cc wcel cA cc0 cif ccos cfv cB cc wcel cB cc0 cif ccos
    cfv cmul co cA cc wcel cA cc0 cif csin cfv cB cc wcel cB cc0 cif csin cfv
    cmul co cmin co cB cB cc wcel cB cc0 cif wceq cA cc wcel cA cc0 cif cB
    caddc co cA cc wcel cA cc0 cif cB cc wcel cB cc0 cif caddc co ccos cB cB cc
    wcel cB cc0 cif cA cc wcel cA cc0 cif caddc opreq2 fveq2d cB cB cc wcel cB
    cc0 cif wceq cA cc wcel cA cc0 cif ccos cfv cB ccos cfv cmul co cA cc wcel
    cA cc0 cif ccos cfv cB cc wcel cB cc0 cif ccos cfv cmul co cA cc wcel cA
    cc0 cif csin cfv cB csin cfv cmul co cA cc wcel cA cc0 cif csin cfv cB cc
    wcel cB cc0 cif csin cfv cmul co cmin cB cB cc wcel cB cc0 cif wceq cB ccos
    cfv cB cc wcel cB cc0 cif ccos cfv cA cc wcel cA cc0 cif ccos cfv cmul cB
    cB cc wcel cB cc0 cif ccos fveq2 opreq2d cB cB cc wcel cB cc0 cif wceq cB
    csin cfv cB cc wcel cB cc0 cif csin cfv cA cc wcel cA cc0 cif csin cfv cmul
    cB cB cc wcel cB cc0 cif csin fveq2 opreq2d opreq12d eqeq12d cA cc wcel cA
    cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn elimel
    cosaddi dedth2h $.
    $( [1-Mar-2006] $) $( [15-Jan-2006] $)

  $( Sine of difference.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  sinsub $p |- ( ( A e. CC /\ B e. CC ) -> ( sin ` ( A - B ) ) =
                  ( ( ( sin ` A ) x. ( cos ` B ) ) -
                    ( ( cos ` A ) x. ( sin ` B ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg caddc co csin cfv cA csin cfv cB cneg
    ccos cfv cmul co cA ccos cfv cB cneg csin cfv cmul co caddc co cA cB cmin
    co csin cfv cA csin cfv cB ccos cfv cmul co cA ccos cfv cB csin cfv cmul co
    cmin co cA cc wcel cB cneg cc wcel cA cB cneg caddc co csin cfv cA csin cfv
    cB cneg ccos cfv cmul co cA ccos cfv cB cneg csin cfv cmul co caddc co wceq
    cB cc wcel cA cB cneg sinadd cB negcl sylan2 cA cc wcel cB cc wcel wa cA cB
    cneg caddc co cA cB cmin co csin cA cB negsub fveq2d cA cc wcel cB cc wcel
    wa cA csin cfv cB cneg ccos cfv cmul co cA ccos cfv cB cneg csin cfv cmul
    co caddc co cA csin cfv cB ccos cfv cmul co cA ccos cfv cB csin cfv cmul co
    cneg caddc co cA csin cfv cB ccos cfv cmul co cA ccos cfv cB csin cfv cmul
    co cmin co cA cc wcel cB cc wcel wa cA csin cfv cB cneg ccos cfv cmul co cA
    csin cfv cB ccos cfv cmul co cA ccos cfv cB cneg csin cfv cmul co cA ccos
    cfv cB csin cfv cmul co cneg caddc cA cc wcel cB cc wcel wa cB cneg ccos
    cfv cB ccos cfv cA csin cfv cmul cB cc wcel cB cneg ccos cfv cB ccos cfv
    wceq cA cc wcel cB cosneg adantl opreq2d cA cc wcel cB cc wcel wa cA ccos
    cfv cB cneg csin cfv cmul co cA ccos cfv cB csin cfv cneg cmul co cA ccos
    cfv cB csin cfv cmul co cneg cA cc wcel cB cc wcel wa cB cneg csin cfv cB
    csin cfv cneg cA ccos cfv cmul cB cc wcel cB cneg csin cfv cB csin cfv cneg
    wceq cA cc wcel cB sinneg adantl opreq2d cA ccos cfv cc wcel cB csin cfv cc
    wcel cA ccos cfv cB csin cfv cneg cmul co cA ccos cfv cB csin cfv cmul co
    cneg wceq cA cc wcel cB cc wcel cA ccos cfv cB csin cfv mulneg2 cA coscl cB
    sincl syl2an eqtrd opreq12d cA csin cfv cB ccos cfv cmul co cc wcel cA ccos
    cfv cB csin cfv cmul co cc wcel cA csin cfv cB ccos cfv cmul co cA ccos cfv
    cB csin cfv cmul co cneg caddc co cA csin cfv cB ccos cfv cmul co cA ccos
    cfv cB csin cfv cmul co cmin co wceq cA cc wcel cB cc wcel wa cA csin cfv
    cB ccos cfv cmul co cA ccos cfv cB csin cfv cmul co negsub cA csin cfv cc
    wcel cB ccos cfv cc wcel cA csin cfv cB ccos cfv cmul co cc wcel cA cc wcel
    cB cc wcel cA csin cfv cB ccos cfv mulcl cA sincl cB coscl syl2an cA ccos
    cfv cc wcel cB csin cfv cc wcel cA ccos cfv cB csin cfv cmul co cc wcel cA
    cc wcel cB cc wcel cA ccos cfv cB csin cfv mulcl cA coscl cB sincl syl2an
    sylanc eqtrd 3eqtr3d $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Cosine of difference.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  cossub $p |- ( ( A e. CC /\ B e. CC ) -> ( cos ` ( A - B ) ) =
                  ( ( ( cos ` A ) x. ( cos ` B ) ) +
                    ( ( sin ` A ) x. ( sin ` B ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA cB cneg caddc co ccos cfv cA ccos cfv cB cneg
    ccos cfv cmul co cA csin cfv cB cneg csin cfv cmul co cmin co cA cB cmin co
    ccos cfv cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin cfv cmul co
    caddc co cA cc wcel cB cneg cc wcel cA cB cneg caddc co ccos cfv cA ccos
    cfv cB cneg ccos cfv cmul co cA csin cfv cB cneg csin cfv cmul co cmin co
    wceq cB cc wcel cA cB cneg cosadd cB negcl sylan2 cA cc wcel cB cc wcel wa
    cA cB cneg caddc co cA cB cmin co ccos cA cB negsub fveq2d cA cc wcel cB cc
    wcel wa cA ccos cfv cB cneg ccos cfv cmul co cA csin cfv cB cneg csin cfv
    cmul co cmin co cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin cfv
    cmul co cneg cmin co cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin
    cfv cmul co caddc co cA cc wcel cB cc wcel wa cA ccos cfv cB cneg ccos cfv
    cmul co cA ccos cfv cB ccos cfv cmul co cA csin cfv cB cneg csin cfv cmul
    co cA csin cfv cB csin cfv cmul co cneg cmin cA cc wcel cB cc wcel wa cB
    cneg ccos cfv cB ccos cfv cA ccos cfv cmul cB cc wcel cB cneg ccos cfv cB
    ccos cfv wceq cA cc wcel cB cosneg adantl opreq2d cA cc wcel cB cc wcel wa
    cA csin cfv cB cneg csin cfv cmul co cA csin cfv cB csin cfv cneg cmul co
    cA csin cfv cB csin cfv cmul co cneg cA cc wcel cB cc wcel wa cB cneg csin
    cfv cB csin cfv cneg cA csin cfv cmul cB cc wcel cB cneg csin cfv cB csin
    cfv cneg wceq cA cc wcel cB sinneg adantl opreq2d cA csin cfv cc wcel cB
    csin cfv cc wcel cA csin cfv cB csin cfv cneg cmul co cA csin cfv cB csin
    cfv cmul co cneg wceq cA cc wcel cB cc wcel cA csin cfv cB csin cfv mulneg2
    cA sincl cB sincl syl2an eqtrd opreq12d cA ccos cfv cB ccos cfv cmul co cc
    wcel cA csin cfv cB csin cfv cmul co cc wcel cA ccos cfv cB ccos cfv cmul
    co cA csin cfv cB csin cfv cmul co cneg cmin co cA ccos cfv cB ccos cfv
    cmul co cA csin cfv cB csin cfv cmul co caddc co wceq cA cc wcel cB cc wcel
    wa cA ccos cfv cB ccos cfv cmul co cA csin cfv cB csin cfv cmul co subneg
    cA ccos cfv cc wcel cB ccos cfv cc wcel cA ccos cfv cB ccos cfv cmul co cc
    wcel cA cc wcel cB cc wcel cA ccos cfv cB ccos cfv mulcl cA coscl cB coscl
    syl2an cA csin cfv cc wcel cB csin cfv cc wcel cA csin cfv cB csin cfv cmul
    co cc wcel cA cc wcel cB cc wcel cA csin cfv cB csin cfv mulcl cA sincl cB
    sincl syl2an sylanc eqtrd 3eqtr3d $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Sum of sines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  addsin $p |- ( ( A e. CC /\ B e. CC ) -> ( ( sin ` A ) + ( sin ` B ) ) =
                    ( 2 x. ( ( sin ` ( ( A + B ) / 2 ) ) x.
                             ( cos ` ( ( A - B ) / 2 ) ) ) ) ) $=
    cA cc wcel cB cc wcel wa c2 cA cB caddc co c2 cdiv co csin cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cmul co cA cB caddc co c2 cdiv co csin cfv
    cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin
    cfv cA cB cmin co c2 cdiv co ccos cfv cmul co caddc co cA cB caddc co c2
    cdiv co cA cB cmin co c2 cdiv co caddc co csin cfv cA cB caddc co c2 cdiv
    co cA cB cmin co c2 cdiv co cmin co csin cfv caddc co cA csin cfv cB csin
    cfv caddc co cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co csin cfv cA
    cB cmin co c2 cdiv co ccos cfv cmul co cc wcel c2 cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cmul co cA cB caddc co
    c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co caddc co
    wceq cA cB caddc co c2 cdiv co csin cfv cc wcel cA cB cmin co c2 cdiv co
    ccos cfv cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv
    co ccos cfv cmul co cc wcel cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv
    co csin cfv cA cB cmin co c2 cdiv co ccos cfv mulcl cA cc wcel cB cc wcel
    wa cA cB caddc co c2 cdiv co cc wcel cA cB caddc co c2 cdiv co csin cfv cc
    wcel cA cc wcel cB cc wcel wa cA cB caddc co cc wcel cA cB caddc co c2 cdiv
    co cc wcel cA cB addcl cA cB caddc co halfcl syl cA cB caddc co c2 cdiv co
    sincl syl cA cc wcel cB cc wcel wa cA cB cmin co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co ccos cfv cc wcel cA cc wcel cB cc wcel wa cA cB cmin co
    cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB subcl cA cB cmin co halfcl
    syl cA cB cmin co c2 cdiv co coscl syl sylanc cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co 2times syl cA cc wcel cB
    cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co csin
    cfv cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co csin cfv
    caddc co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos
    cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co
    csin cfv cmul co caddc co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co csin cfv cmul co cmin co caddc co cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv
    co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co caddc co cA cc wcel
    cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co
    csin cfv cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos
    cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co
    csin cfv cmul co caddc co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv
    co cmin co csin cfv cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2
    cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co csin cfv cmul co cmin co caddc cA cB caddc co c2 cdiv co cc wcel
    cA cB cmin co c2 cdiv co cc wcel cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co caddc co csin cfv cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co csin cfv cmul co caddc co wceq cA cc wcel cB cc wcel wa cA cB
    caddc co c2 cdiv co cA cB cmin co c2 cdiv co sinadd cA cc wcel cB cc wcel
    wa cA cB caddc co cc wcel cA cB caddc co c2 cdiv co cc wcel cA cB addcl cA
    cB caddc co halfcl syl cA cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cB
    cmin co c2 cdiv co cc wcel cA cB subcl cA cB cmin co halfcl syl sylanc cA
    cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB caddc
    co c2 cdiv co cA cB cmin co c2 cdiv co cmin co csin cfv cA cB caddc co c2
    cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmin co wceq
    cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    sinsub cA cc wcel cB cc wcel wa cA cB caddc co cc wcel cA cB caddc co c2
    cdiv co cc wcel cA cB addcl cA cB caddc co halfcl syl cA cc wcel cB cc wcel
    wa cA cB cmin co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB subcl cA cB
    cmin co halfcl syl sylanc opreq12d cA cB caddc co c2 cdiv co csin cfv cA cB
    cmin co c2 cdiv co ccos cfv cmul co cc wcel cA cB caddc co c2 cdiv co ccos
    cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co c2
    cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc wcel cA cB
    caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co
    caddc co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos
    cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co
    csin cfv cmul co cmin co caddc co cA cB caddc co c2 cdiv co csin cfv cA cB
    cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA
    cB cmin co c2 cdiv co ccos cfv cmul co caddc co wceq cA cc wcel cB cc wcel
    wa cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv
    cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co
    ccos cfv cmul co ppncan cA cB caddc co c2 cdiv co csin cfv cc wcel cA cB
    cmin co c2 cdiv co ccos cfv cc wcel cA cB caddc co c2 cdiv co csin cfv cA
    cB cmin co c2 cdiv co ccos cfv cmul co cc wcel cA cc wcel cB cc wcel wa cA
    cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv mulcl cA
    cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB caddc co c2
    cdiv co csin cfv cc wcel cA cc wcel cB cc wcel wa cA cB caddc co cc wcel cA
    cB caddc co c2 cdiv co cc wcel cA cB addcl cA cB caddc co halfcl syl cA cB
    caddc co c2 cdiv co sincl syl cA cc wcel cB cc wcel wa cA cB cmin co c2
    cdiv co cc wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA cc wcel cB cc
    wcel wa cA cB cmin co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB subcl
    cA cB cmin co halfcl syl cA cB cmin co c2 cdiv co coscl syl sylanc cA cB
    caddc co c2 cdiv co ccos cfv cc wcel cA cB cmin co c2 cdiv co csin cfv cc
    wcel cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co cc wcel cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co ccos cfv
    cA cB cmin co c2 cdiv co csin cfv mulcl cA cc wcel cB cc wcel wa cA cB
    caddc co c2 cdiv co cc wcel cA cB caddc co c2 cdiv co ccos cfv cc wcel cA
    cc wcel cB cc wcel wa cA cB caddc co cc wcel cA cB caddc co c2 cdiv co cc
    wcel cA cB addcl cA cB caddc co halfcl syl cA cB caddc co c2 cdiv co coscl
    syl cA cc wcel cB cc wcel wa cA cB cmin co c2 cdiv co cc wcel cA cB cmin co
    c2 cdiv co csin cfv cc wcel cA cc wcel cB cc wcel wa cA cB cmin co cc wcel
    cA cB cmin co c2 cdiv co cc wcel cA cB subcl cA cB cmin co halfcl syl cA cB
    cmin co c2 cdiv co sincl syl sylanc cA cB caddc co c2 cdiv co csin cfv cc
    wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc wcel cA cc wcel cB cc
    wcel wa cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos
    cfv mulcl cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB
    caddc co c2 cdiv co csin cfv cc wcel cA cc wcel cB cc wcel wa cA cB caddc
    co cc wcel cA cB caddc co c2 cdiv co cc wcel cA cB addcl cA cB caddc co
    halfcl syl cA cB caddc co c2 cdiv co sincl syl cA cc wcel cB cc wcel wa cA
    cB cmin co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA
    cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cB cmin co c2 cdiv co cc
    wcel cA cB subcl cA cB cmin co halfcl syl cA cB cmin co c2 cdiv co coscl
    syl sylanc syl3anc eqtrd cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co
    cA cB cmin co c2 cdiv co caddc co csin cfv cA csin cfv cA cB caddc co c2
    cdiv co cA cB cmin co c2 cdiv co cmin co csin cfv cB csin cfv caddc cA cc
    wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc
    co cA csin cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co
    c2 cdiv co caddc co cA wceq cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv
    co cmin co cB wceq cA cB halfaddsub pm3.26d fveq2d cA cc wcel cB cc wcel wa
    cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB csin cA cc
    wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc
    co cA wceq cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB
    wceq cA cB halfaddsub pm3.27d fveq2d opreq12d 3eqtr2rd $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Difference of sines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  subsin $p |- ( ( A e. CC /\ B e. CC ) -> ( ( sin ` A ) - ( sin ` B ) ) =
                    ( 2 x. ( ( cos ` ( ( A + B ) / 2 ) ) x.
                             ( sin ` ( ( A - B ) / 2 ) ) ) ) ) $=
    cA cc wcel cB cc wcel wa c2 cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co csin cfv cmul co cmul co cA cB caddc co c2 cdiv co ccos cfv
    cA cB cmin co c2 cdiv co csin cfv cmul co cA cB caddc co c2 cdiv co ccos
    cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co cA cB caddc co c2
    cdiv co cA cB cmin co c2 cdiv co caddc co csin cfv cA cB caddc co c2 cdiv
    co cA cB cmin co c2 cdiv co cmin co csin cfv cmin co cA csin cfv cB csin
    cfv cmin co cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA
    cB cmin co c2 cdiv co csin cfv cmul co cc wcel c2 cA cB caddc co c2 cdiv co
    ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmul co cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cA cB caddc
    co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co
    wceq cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin
    co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co csin cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2
    cdiv co ccos cfv cc wcel cA cB cmin co c2 cdiv co csin cfv cc wcel cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc
    wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv mulcl cA
    cB caddc co c2 cdiv co coscl cA cB cmin co c2 cdiv co sincl syl2an syl cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co
    2times syl cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co
    c2 cdiv co caddc co csin cfv cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co cmin co csin cfv cmin co cA cB caddc co c2 cdiv co csin cfv cA cB
    cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA
    cB cmin co c2 cdiv co csin cfv cmul co caddc co cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv
    co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmin co cmin co cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co
    caddc co cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co caddc co csin cfv cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv
    co cmin co csin cfv cmin co cA cB caddc co c2 cdiv co csin cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB
    cmin co c2 cdiv co csin cfv cmul co caddc co cA cB caddc co c2 cdiv co csin
    cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co
    ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmin co cmin co wceq cA
    cB halfaddsubcl cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co
    cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co csin
    cfv cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv
    cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co caddc co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    cmin co csin cfv cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv
    co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2
    cdiv co csin cfv cmul co cmin co cmin cA cB caddc co c2 cdiv co cA cB cmin
    co c2 cdiv co sinadd cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    sinsub opreq12d syl cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2
    cdiv co ccos cfv cmul co cc wcel cA cB caddc co c2 cdiv co ccos cfv cA cB
    cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co c2 cdiv co ccos
    cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co c2
    cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co cA
    cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co
    cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul
    co cmin co cmin co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv
    co csin cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2
    cdiv co csin cfv cmul co caddc co wceq cA cc wcel cB cc wcel wa cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co
    pnncan cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co csin cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2
    cdiv co csin cfv cc wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA cB
    caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc
    wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA
    cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co ccos cfv mulcl cA
    cB caddc co c2 cdiv co sincl cA cB cmin co c2 cdiv co coscl syl2an syl cA
    cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2
    cdiv co cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv
    co csin cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2 cdiv co
    ccos cfv cc wcel cA cB cmin co c2 cdiv co csin cfv cc wcel cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB
    caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv mulcl cA cB caddc co
    c2 cdiv co coscl cA cB cmin co c2 cdiv co sincl syl2an syl cA cc wcel cB cc
    wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel
    wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2 cdiv co ccos cfv cc
    wcel cA cB cmin co c2 cdiv co csin cfv cc wcel cA cB caddc co c2 cdiv co
    ccos cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co
    c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB caddc co c2 cdiv
    co ccos cfv cA cB cmin co c2 cdiv co csin cfv mulcl cA cB caddc co c2 cdiv
    co coscl cA cB cmin co c2 cdiv co sincl syl2an syl syl3anc eqtrd cA cc wcel
    cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co
    csin cfv cA csin cfv cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    cmin co csin cfv cB csin cfv cmin cA cc wcel cB cc wcel wa cA cB caddc co
    c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA csin cA cc wcel cB cc wcel
    wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA wceq cA
    cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB wceq cA cB
    halfaddsub pm3.26d fveq2d cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv
    co cA cB cmin co c2 cdiv co cmin co cB csin cA cc wcel cB cc wcel wa cA cB
    caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA wceq cA cB caddc
    co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB wceq cA cB halfaddsub
    pm3.27d fveq2d opreq12d 3eqtr2rd $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Sum of cosines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  addcos $p |- ( ( A e. CC /\ B e. CC ) -> ( ( cos ` A ) + ( cos ` B ) ) =
                    ( 2 x. ( ( cos ` ( ( A + B ) / 2 ) ) x.
                             ( cos ` ( ( A - B ) / 2 ) ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA ccos cfv cB ccos cfv caddc co cB ccos cfv cA
    ccos cfv caddc co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin
    co ccos cfv cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co
    ccos cfv caddc co c2 cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2
    cdiv co ccos cfv cmul co cmul co cA ccos cfv cc wcel cB ccos cfv cc wcel cA
    ccos cfv cB ccos cfv caddc co cB ccos cfv cA ccos cfv caddc co wceq cA cc
    wcel cB cc wcel cA ccos cfv cB ccos cfv addcom cA coscl cB coscl syl2an cA
    cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    cmin co ccos cfv cB ccos cfv cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co caddc co ccos cfv cA ccos cfv caddc cA cc wcel cB cc wcel wa cA cB
    caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB ccos cA cc wcel cB
    cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA
    wceq cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB wceq cA
    cB halfaddsub pm3.27d fveq2d cA cc wcel cB cc wcel wa cA cB caddc co c2
    cdiv co cA cB cmin co c2 cdiv co caddc co cA ccos cA cc wcel cB cc wcel wa
    cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA wceq cA cB
    caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB wceq cA cB
    halfaddsub pm3.26d fveq2d opreq12d cA cc wcel cB cc wcel wa cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co
    cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul
    co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co cmin co caddc co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co caddc co cA cB caddc co c2 cdiv co cA cB
    cmin co c2 cdiv co cmin co ccos cfv cA cB caddc co c2 cdiv co cA cB cmin co
    c2 cdiv co caddc co ccos cfv caddc co c2 cA cB caddc co c2 cdiv co ccos cfv
    cA cB cmin co c2 cdiv co ccos cfv cmul co cmul co cA cB caddc co c2 cdiv co
    ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc wcel cA cB caddc co
    c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc
    wcel cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv
    cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co caddc co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2
    cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co csin cfv cmul co cmin co caddc co cA cB caddc co c2 cdiv co ccos
    cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co
    ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co caddc co wceq cA cc wcel
    cB cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co
    ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv
    co csin cfv cmul co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2
    cdiv co ccos cfv cmul co ppncan cA cc wcel cB cc wcel wa cA cB caddc co c2
    cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv
    co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc wcel cA cB
    halfaddsubcl cA cB caddc co c2 cdiv co ccos cfv cc wcel cA cB cmin co c2
    cdiv co ccos cfv cc wcel cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co ccos cfv cmul co cc wcel cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co ccos cfv mulcl cA cB caddc co c2 cdiv co coscl cA cB cmin co c2
    cdiv co coscl syl2an syl cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co
    cc wcel cA cB cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co csin
    cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB halfaddsubcl cA
    cB caddc co c2 cdiv co csin cfv cc wcel cA cB cmin co c2 cdiv co csin cfv
    cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co cc wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv
    co cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv mulcl cA cB caddc co c2 cdiv co sincl cA cB cmin co c2 cdiv co sincl
    syl2an syl cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2
    cdiv co ccos cfv cc wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc
    wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv mulcl cA
    cB caddc co c2 cdiv co coscl cA cB cmin co c2 cdiv co coscl syl2an syl
    syl3anc cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co cmin co ccos cfv cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    caddc co ccos cfv caddc co cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin
    co c2 cdiv co csin cfv cmul co caddc co cA cB caddc co c2 cdiv co ccos cfv
    cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin
    cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmin co caddc co wceq cA cB
    halfaddsubcl cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc
    wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co ccos cfv
    cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul
    co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co caddc co cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc
    co ccos cfv cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co
    ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv
    co csin cfv cmul co cmin co caddc cA cB caddc co c2 cdiv co cA cB cmin co
    c2 cdiv co cossub cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cosadd
    opreq12d syl cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA
    cB cmin co c2 cdiv co ccos cfv cmul co cc wcel c2 cA cB caddc co c2 cdiv co
    ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cmul co cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc
    co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co caddc co
    wceq cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin
    co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co
    c2 cdiv co ccos cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2
    cdiv co ccos cfv cc wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc
    wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv mulcl cA
    cB caddc co c2 cdiv co coscl cA cB cmin co c2 cdiv co coscl syl2an syl cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co
    2times syl 3eqtr4d 3eqtr2d $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Difference of cosines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  subcos $p |- ( ( A e. CC /\ B e. CC ) -> ( ( cos ` A ) - ( cos ` B ) ) =
                  ( -u 2 x. ( ( sin ` ( ( A + B ) / 2 ) ) x.
                              ( sin ` ( ( A - B ) / 2 ) ) ) ) ) $=
    cA cc wcel cB cc wcel wa cA ccos cfv cB ccos cfv cmin co c2 cA cB caddc co
    c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmul co cneg
    c2 cneg cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co cmul co cA cc wcel cB cc wcel wa c2 cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmul co cA ccos cfv cB
    ccos cfv cmin co cneg wceq cA ccos cfv cB ccos cfv cmin co c2 cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmul co
    cneg wceq cA cc wcel cB cc wcel wa c2 cA cB caddc co c2 cdiv co csin cfv cA
    cB cmin co c2 cdiv co csin cfv cmul co cmul co cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cA cB caddc co c2 cdiv
    co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co cA cB caddc
    co c2 cdiv co cA cB cmin co c2 cdiv co cmin co ccos cfv cA cB caddc co c2
    cdiv co cA cB cmin co c2 cdiv co caddc co ccos cfv cmin co cA ccos cfv cB
    ccos cfv cmin co cneg cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel c2 cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmul co cA
    cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co
    cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul
    co caddc co wceq cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel
    cA cB cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co csin cfv cA
    cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB halfaddsubcl cA cB
    caddc co c2 cdiv co csin cfv cc wcel cA cB cmin co c2 cdiv co csin cfv cc
    wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co cc wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co
    cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv mulcl cA cB caddc co c2 cdiv co sincl cA cB cmin co c2 cdiv co sincl
    syl2an syl cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co 2times syl cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co
    cA cB cmin co c2 cdiv co cmin co ccos cfv cA cB caddc co c2 cdiv co cA cB
    cmin co c2 cdiv co caddc co ccos cfv cmin co cA cB caddc co c2 cdiv co ccos
    cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmin co
    cmin co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co
    csin cfv cmul co caddc co cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv
    co cc wcel cA cB cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co cA
    cB cmin co c2 cdiv co cmin co ccos cfv cA cB caddc co c2 cdiv co cA cB cmin
    co c2 cdiv co caddc co ccos cfv cmin co cA cB caddc co c2 cdiv co ccos cfv
    cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin
    cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co cA cB caddc co c2
    cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc co
    c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmin co cmin
    co wceq cA cB halfaddsubcl cA cB caddc co c2 cdiv co cc wcel cA cB cmin co
    c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co
    cmin co ccos cfv cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv
    co ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2
    cdiv co csin cfv cmul co caddc co cA cB caddc co c2 cdiv co cA cB cmin co
    c2 cdiv co caddc co ccos cfv cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB
    cmin co c2 cdiv co csin cfv cmul co cmin co cmin cA cB caddc co c2 cdiv co
    cA cB cmin co c2 cdiv co cossub cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co cosadd opreq12d syl cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cc wcel cA cB caddc co c2 cdiv co csin cfv
    cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co
    c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co caddc co
    cA cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul
    co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co cmin co cmin co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2
    cdiv co csin cfv cmul co cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co csin cfv cmul co caddc co wceq cA cc wcel cB cc wcel wa cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cA
    cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co
    cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul
    co pnncan cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel wa cA cB caddc co c2 cdiv co ccos cfv cA cB cmin
    co c2 cdiv co ccos cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2
    cdiv co ccos cfv cc wcel cA cB cmin co c2 cdiv co ccos cfv cc wcel cA cB
    caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv cmul co cc
    wcel cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA
    cB caddc co c2 cdiv co ccos cfv cA cB cmin co c2 cdiv co ccos cfv mulcl cA
    cB caddc co c2 cdiv co coscl cA cB cmin co c2 cdiv co coscl syl2an syl cA
    cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2
    cdiv co cc wcel wa cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv
    co csin cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2 cdiv co
    csin cfv cc wcel cA cB cmin co c2 cdiv co csin cfv cc wcel cA cB caddc co
    c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB
    caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB caddc co
    c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv mulcl cA cB caddc co
    c2 cdiv co sincl cA cB cmin co c2 cdiv co sincl syl2an syl cA cc wcel cB cc
    wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel
    wa cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv
    cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2 cdiv co csin cfv cc
    wcel cA cB cmin co c2 cdiv co csin cfv cc wcel cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co
    c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB caddc co c2 cdiv
    co csin cfv cA cB cmin co c2 cdiv co csin cfv mulcl cA cB caddc co c2 cdiv
    co sincl cA cB cmin co c2 cdiv co sincl syl2an syl syl3anc eqtrd cA cc wcel
    cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co
    ccos cfv cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co ccos
    cfv cmin co cB ccos cfv cA ccos cfv cmin co cA ccos cfv cB ccos cfv cmin co
    cneg cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2
    cdiv co cmin co ccos cfv cB ccos cfv cA cB caddc co c2 cdiv co cA cB cmin
    co c2 cdiv co caddc co ccos cfv cA ccos cfv cmin cA cc wcel cB cc wcel wa
    cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB ccos cA cc
    wcel cB cc wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc
    co cA wceq cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB
    wceq cA cB halfaddsub pm3.27d fveq2d cA cc wcel cB cc wcel wa cA cB caddc
    co c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA ccos cA cc wcel cB cc
    wcel wa cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co caddc co cA wceq
    cA cB caddc co c2 cdiv co cA cB cmin co c2 cdiv co cmin co cB wceq cA cB
    halfaddsub pm3.26d fveq2d opreq12d cA ccos cfv cc wcel cB ccos cfv cc wcel
    cA ccos cfv cB ccos cfv cmin co cneg cB ccos cfv cA ccos cfv cmin co wceq
    cA cc wcel cB cc wcel cA ccos cfv cB ccos cfv negsubdi2 cA coscl cB coscl
    syl2an eqtr4d 3eqtr2d c2 cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co csin cfv cmul co cmul co cc wcel cA ccos cfv cB ccos cfv cmin co
    cc wcel c2 cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co cmul co cA ccos cfv cB ccos cfv cmin co cneg wceq cA ccos cfv
    cB ccos cfv cmin co c2 cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2
    cdiv co csin cfv cmul co cmul co cneg wceq wb cA cc wcel cB cc wcel wa c2
    cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul
    co cmul co cA ccos cfv cB ccos cfv cmin co negcon2 c2 cc wcel cA cB caddc
    co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel c2
    cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul
    co cmul co cc wcel cA cc wcel cB cc wcel wa c2 cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co mulcl 2cn cA cc wcel cB
    cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc
    wcel wa cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv co csin
    cfv cmul co cc wcel cA cB halfaddsubcl cA cB caddc co c2 cdiv co csin cfv
    cc wcel cA cB cmin co c2 cdiv co csin cfv cc wcel cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co
    c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB caddc co c2 cdiv
    co csin cfv cA cB cmin co c2 cdiv co csin cfv mulcl cA cB caddc co c2 cdiv
    co sincl cA cB cmin co c2 cdiv co sincl syl2an syl sylancr cA ccos cfv cc
    wcel cB ccos cfv cc wcel cA ccos cfv cB ccos cfv cmin co cc wcel cA cc wcel
    cB cc wcel cA ccos cfv cB ccos cfv subcl cA coscl cB coscl syl2an sylanc
    mpbid c2 cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2 cdiv
    co csin cfv cmul co cc wcel c2 cneg cA cB caddc co c2 cdiv co csin cfv cA
    cB cmin co c2 cdiv co csin cfv cmul co cmul co c2 cA cB caddc co c2 cdiv co
    csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cmul co cneg wceq cA cc
    wcel cB cc wcel wa c2 cA cB caddc co c2 cdiv co csin cfv cA cB cmin co c2
    cdiv co csin cfv cmul co mulneg1 2cn cA cc wcel cB cc wcel wa cA cB caddc
    co c2 cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel wa cA cB caddc co c2
    cdiv co csin cfv cA cB cmin co c2 cdiv co csin cfv cmul co cc wcel cA cB
    halfaddsubcl cA cB caddc co c2 cdiv co csin cfv cc wcel cA cB cmin co c2
    cdiv co csin cfv cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co csin cfv cmul co cc wcel cA cB caddc co c2 cdiv co cc wcel cA cB
    cmin co c2 cdiv co cc wcel cA cB caddc co c2 cdiv co csin cfv cA cB cmin co
    c2 cdiv co csin cfv mulcl cA cB caddc co c2 cdiv co sincl cA cB cmin co c2
    cdiv co sincl syl2an syl sylancr eqtr4d $.
    $( [13-Oct-2007] $) $( [12-Oct-2007] $)

  $( Sine squared plus cosine squared is 1.  Equation 17 of [Gleason]
     p. 311.  Note that this holds for non-real arguments, even though
     individually each term is unbounded. $)
  sincossq $p |- ( A e. CC ->
                  ( ( ( sin ` A ) ^ 2 ) + ( ( cos ` A ) ^ 2 ) ) = 1 ) $=
    cA cc wcel cA cA cneg caddc co ccos cfv cA ccos cfv cA cneg ccos cfv cmul
    co cA csin cfv cA cneg csin cfv cmul co cmin co c1 cA csin cfv c2 cexp co
    cA ccos cfv c2 cexp co caddc co cA cc wcel cA cneg cc wcel cA cA cneg caddc
    co ccos cfv cA ccos cfv cA cneg ccos cfv cmul co cA csin cfv cA cneg csin
    cfv cmul co cmin co wceq cA negcl cA cA cneg cosadd mpdan cA cc wcel cA cA
    cneg caddc co ccos cfv cc0 ccos cfv c1 cA cc wcel cA cA cneg caddc co cc0
    ccos cA negid fveq2d cos0 syl6eq cA cc wcel cA csin cfv c2 cexp co cA ccos
    cfv c2 cexp co caddc co cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc
    co cA ccos cfv cA cneg ccos cfv cmul co cA csin cfv cA cneg csin cfv cmul
    co cneg caddc co cA ccos cfv cA cneg ccos cfv cmul co cA csin cfv cA cneg
    csin cfv cmul co cmin co cA csin cfv c2 cexp co cc wcel cA ccos cfv c2 cexp
    co cc wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co cA ccos
    cfv c2 cexp co cA csin cfv c2 cexp co caddc co wceq cA cc wcel cA csin cfv
    c2 cexp co cA ccos cfv c2 cexp co addcom cA cc wcel cA csin cfv cc wcel cA
    csin cfv c2 cexp co cc wcel cA sincl cA csin cfv sqcl syl cA cc wcel cA
    ccos cfv cc wcel cA ccos cfv c2 cexp co cc wcel cA coscl cA ccos cfv sqcl
    syl sylanc cA cc wcel cA ccos cfv c2 cexp co cA ccos cfv cA cneg ccos cfv
    cmul co cA csin cfv c2 cexp co cA csin cfv cA cneg csin cfv cmul co cneg
    caddc cA cc wcel cA ccos cfv c2 cexp co cA ccos cfv cA ccos cfv cmul co cA
    ccos cfv cA cneg ccos cfv cmul co cA cc wcel cA ccos cfv cc wcel cA ccos
    cfv c2 cexp co cA ccos cfv cA ccos cfv cmul co wceq cA coscl cA ccos cfv
    sqval syl cA cc wcel cA cneg ccos cfv cA ccos cfv cA ccos cfv cmul cA
    cosneg opreq2d eqtr4d cA cc wcel cA csin cfv c2 cexp co cA csin cfv cA csin
    cfv cmul co cA csin cfv cA cneg csin cfv cneg cmul co cA csin cfv cA cneg
    csin cfv cmul co cneg cA cc wcel cA csin cfv cc wcel cA csin cfv c2 cexp co
    cA csin cfv cA csin cfv cmul co wceq cA sincl cA csin cfv sqval syl cA cc
    wcel cA cneg csin cfv cneg cA csin cfv cA csin cfv cmul cA cc wcel cA cneg
    csin cfv cneg cA csin cfv cneg cneg cA csin cfv cA cc wcel cA cneg csin cfv
    cA csin cfv cneg cA sinneg negeqd cA cc wcel cA csin cfv cc wcel cA csin
    cfv cneg cneg cA csin cfv wceq cA sincl cA csin cfv negneg syl eqtrd
    opreq2d cA csin cfv cc wcel cA cneg csin cfv cc wcel cA csin cfv cA cneg
    csin cfv cneg cmul co cA csin cfv cA cneg csin cfv cmul co cneg wceq cA cc
    wcel cA csin cfv cA cneg csin cfv mulneg2 cA sincl cA cc wcel cA cneg cc
    wcel cA cneg csin cfv cc wcel cA negcl cA cneg sincl syl sylanc 3eqtr2d
    opreq12d cA ccos cfv cA cneg ccos cfv cmul co cc wcel cA csin cfv cA cneg
    csin cfv cmul co cc wcel cA ccos cfv cA cneg ccos cfv cmul co cA csin cfv
    cA cneg csin cfv cmul co cneg caddc co cA ccos cfv cA cneg ccos cfv cmul co
    cA csin cfv cA cneg csin cfv cmul co cmin co wceq cA cc wcel cA ccos cfv cA
    cneg ccos cfv cmul co cA csin cfv cA cneg csin cfv cmul co negsub cA ccos
    cfv cc wcel cA cneg ccos cfv cc wcel cA ccos cfv cA cneg ccos cfv cmul co
    cc wcel cA cc wcel cA ccos cfv cA cneg ccos cfv mulcl cA coscl cA cc wcel
    cA cneg cc wcel cA cneg ccos cfv cc wcel cA negcl cA cneg coscl syl sylanc
    cA csin cfv cc wcel cA cneg csin cfv cc wcel cA csin cfv cA cneg csin cfv
    cmul co cc wcel cA cc wcel cA csin cfv cA cneg csin cfv mulcl cA sincl cA
    cc wcel cA cneg cc wcel cA cneg csin cfv cc wcel cA negcl cA cneg sincl syl
    sylanc sylanc 3eqtrrd 3eqtr3rd $.
    $( [2-Mar-2006] $) $( [15-Jan-2006] $)

  $( Double-angle formula for sine.  (Contributed by Paul Chapman,
     17-Jan-2008.) $)
  sin2t $p |- ( A e. CC ->
      ( sin ` ( 2 x. A ) ) = ( 2 x. ( ( sin ` A ) x. ( cos ` A ) ) ) ) $=
    cA cc wcel c2 cA cmul co csin cfv cA cA caddc co csin cfv c2 cA csin cfv cA
    ccos cfv cmul co cmul co cA cc wcel c2 cA cmul co cA cA caddc co csin cA
    2times fveq2d cA cc wcel cA csin cfv cA ccos cfv cmul co cA ccos cfv cA
    csin cfv cmul co caddc co cA csin cfv cA ccos cfv cmul co cA csin cfv cA
    ccos cfv cmul co caddc co cA cA caddc co csin cfv c2 cA csin cfv cA ccos
    cfv cmul co cmul co cA cc wcel cA ccos cfv cA csin cfv cmul co cA csin cfv
    cA ccos cfv cmul co cA csin cfv cA ccos cfv cmul co caddc cA ccos cfv cc
    wcel cA csin cfv cc wcel cA ccos cfv cA csin cfv cmul co cA csin cfv cA
    ccos cfv cmul co wceq cA cc wcel cA ccos cfv cA csin cfv mulcom cA coscl cA
    sincl sylanc opreq2d cA cc wcel cA cA caddc co csin cfv cA csin cfv cA ccos
    cfv cmul co cA ccos cfv cA csin cfv cmul co caddc co wceq cA cA sinadd
    anidms cA cc wcel cA csin cfv cA ccos cfv cmul co cc wcel c2 cA csin cfv cA
    ccos cfv cmul co cmul co cA csin cfv cA ccos cfv cmul co cA csin cfv cA
    ccos cfv cmul co caddc co wceq cA csin cfv cc wcel cA ccos cfv cc wcel cA
    csin cfv cA ccos cfv cmul co cc wcel cA cc wcel cA csin cfv cA ccos cfv
    mulcl cA sincl cA coscl sylanc cA csin cfv cA ccos cfv cmul co 2times syl
    3eqtr4d eqtrd $.
    $( [17-Jan-2008] $) $( [17-Jan-2008] $)

  $( Double-angle formula for cosine.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  cos2t $p |- ( A e. CC -> ( cos ` ( 2 x. A ) ) =
                           ( ( 2 x. ( ( cos ` A ) ^ 2 ) ) - 1 ) ) $=
    cA cc wcel cA ccos cfv c2 cexp co c1 cA ccos cfv c2 cexp co cmin co cmin co
    cA ccos cfv c2 cexp co cA csin cfv c2 cexp co cmin co c2 cA ccos cfv c2
    cexp co cmul co c1 cmin co c2 cA cmul co ccos cfv cA cc wcel c1 cA ccos cfv
    c2 cexp co cmin co cA csin cfv c2 cexp co cA ccos cfv c2 cexp co cmin cA cc
    wcel c1 cA ccos cfv c2 cexp co cmin co cA csin cfv c2 cexp co wceq cA ccos
    cfv c2 cexp co cA csin cfv c2 cexp co caddc co c1 wceq cA cc wcel cA csin
    cfv c2 cexp co cA ccos cfv c2 cexp co caddc co cA ccos cfv c2 cexp co cA
    csin cfv c2 cexp co caddc co c1 cA csin cfv c2 cexp co cc wcel cA ccos cfv
    c2 cexp co cc wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co
    cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc co wceq cA cc wcel cA
    csin cfv c2 cexp co cA ccos cfv c2 cexp co addcom cA cc wcel cA csin cfv cc
    wcel cA csin cfv c2 cexp co cc wcel cA sincl cA csin cfv sqcl syl cA cc
    wcel cA ccos cfv cc wcel cA ccos cfv c2 cexp co cc wcel cA coscl cA ccos
    cfv sqcl syl sylanc cA sincossq eqtr3d cA ccos cfv c2 cexp co cc wcel cA
    csin cfv c2 cexp co cc wcel c1 cA ccos cfv c2 cexp co cmin co cA csin cfv
    c2 cexp co wceq cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc co c1
    wceq wb cA cc wcel c1 cc wcel cA ccos cfv c2 cexp co cc wcel cA csin cfv c2
    cexp co cc wcel c1 cA ccos cfv c2 cexp co cmin co cA csin cfv c2 cexp co
    wceq cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc co c1 wceq wb
    ax1cn c1 cA ccos cfv c2 cexp co cA csin cfv c2 cexp co subadd mp3an1 cA cc
    wcel cA ccos cfv cc wcel cA ccos cfv c2 cexp co cc wcel cA coscl cA ccos
    cfv sqcl syl cA cc wcel cA csin cfv cc wcel cA csin cfv c2 cexp co cc wcel
    cA sincl cA csin cfv sqcl syl sylanc mpbird opreq2d cA cc wcel c2 cA ccos
    cfv c2 cexp co cmul co c1 cmin co cA ccos cfv c2 cexp co cA ccos cfv c2
    cexp co caddc co c1 cmin co cA ccos cfv c2 cexp co c1 cA ccos cfv c2 cexp
    co cmin co cmin co cA cc wcel c2 cA ccos cfv c2 cexp co cmul co cA ccos cfv
    c2 cexp co cA ccos cfv c2 cexp co caddc co c1 cmin cA cc wcel cA ccos cfv
    c2 cexp co cc wcel c2 cA ccos cfv c2 cexp co cmul co cA ccos cfv c2 cexp co
    cA ccos cfv c2 cexp co caddc co wceq cA cc wcel cA ccos cfv cc wcel cA ccos
    cfv c2 cexp co cc wcel cA coscl cA ccos cfv sqcl syl cA ccos cfv c2 cexp co
    2times syl opreq1d cA ccos cfv c2 cexp co cc wcel cA ccos cfv c2 cexp co cc
    wcel cA ccos cfv c2 cexp co c1 cA ccos cfv c2 cexp co cmin co cmin co cA
    ccos cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 cmin co wceq cA cc
    wcel cA ccos cfv c2 cexp co cc wcel c1 cc wcel cA ccos cfv c2 cexp co cc
    wcel cA ccos cfv c2 cexp co c1 cA ccos cfv c2 cexp co cmin co cmin co cA
    ccos cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 cmin co wceq ax1cn
    cA ccos cfv c2 cexp co c1 cA ccos cfv c2 cexp co subsub3 mp3an2 cA cc wcel
    cA ccos cfv cc wcel cA ccos cfv c2 cexp co cc wcel cA coscl cA ccos cfv
    sqcl syl cA cc wcel cA ccos cfv cc wcel cA ccos cfv c2 cexp co cc wcel cA
    coscl cA ccos cfv sqcl syl sylanc eqtr4d cA cc wcel cA cA caddc co ccos cfv
    cA ccos cfv cA ccos cfv cmul co cA csin cfv cA csin cfv cmul co cmin co c2
    cA cmul co ccos cfv cA ccos cfv c2 cexp co cA csin cfv c2 cexp co cmin co
    cA cc wcel cA cA caddc co ccos cfv cA ccos cfv cA ccos cfv cmul co cA csin
    cfv cA csin cfv cmul co cmin co wceq cA cA cosadd anidms cA cc wcel c2 cA
    cmul co cA cA caddc co ccos cA 2times fveq2d cA cc wcel cA ccos cfv c2 cexp
    co cA ccos cfv cA ccos cfv cmul co cA csin cfv c2 cexp co cA csin cfv cA
    csin cfv cmul co cmin cA cc wcel cA ccos cfv cc wcel cA ccos cfv c2 cexp co
    cA ccos cfv cA ccos cfv cmul co wceq cA coscl cA ccos cfv sqval syl cA cc
    wcel cA csin cfv cc wcel cA csin cfv c2 cexp co cA csin cfv cA csin cfv
    cmul co wceq cA sincl cA csin cfv sqval syl opreq12d 3eqtr4d 3eqtr4rd $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( Double-angle formula for cosine in terms of sine. $)
  cos2tsin $p |- ( A e. CC -> ( cos ` ( 2 x. A ) ) =
                           ( 1 - ( 2 x. ( ( sin ` A ) ^ 2 ) ) ) ) $=
    cA cc wcel c2 cA cmul co ccos cfv c2 cA ccos cfv c2 cexp co cmul co c1 cmin
    co c2 c2 cA csin cfv c2 cexp co cmul co cmin co c1 cmin co c1 c2 cA csin
    cfv c2 cexp co cmul co cmin co cA cos2t cA cc wcel c2 c2 cA csin cfv c2
    cexp co cmul co cmin co c2 cA ccos cfv c2 cexp co cmul co c1 cmin cA cc
    wcel c2 c2 cA csin cfv c2 cexp co cmul co cmin co c2 cA ccos cfv c2 cexp co
    cmul co wceq c2 cA csin cfv c2 cexp co cmul co c2 cA ccos cfv c2 cexp co
    cmul co caddc co c2 wceq cA cc wcel c2 cA csin cfv c2 cexp co cmul co c2 cA
    ccos cfv c2 cexp co cmul co caddc co c2 c1 cmul co c2 cA cc wcel c2 cA csin
    cfv c2 cexp co cA ccos cfv c2 cexp co caddc co cmul co c2 cA csin cfv c2
    cexp co cmul co c2 cA ccos cfv c2 cexp co cmul co caddc co c2 c1 cmul co cA
    csin cfv c2 cexp co cc wcel cA ccos cfv c2 cexp co cc wcel c2 cA csin cfv
    c2 cexp co cA ccos cfv c2 cexp co caddc co cmul co c2 cA csin cfv c2 cexp
    co cmul co c2 cA ccos cfv c2 cexp co cmul co caddc co wceq cA cc wcel c2 cc
    wcel cA csin cfv c2 cexp co cc wcel cA ccos cfv c2 cexp co cc wcel c2 cA
    csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co cmul co c2 cA csin cfv
    c2 cexp co cmul co c2 cA ccos cfv c2 cexp co cmul co caddc co wceq 2cn c2
    cA csin cfv c2 cexp co cA ccos cfv c2 cexp co adddi mp3an1 cA cc wcel cA
    csin cfv cc wcel cA csin cfv c2 cexp co cc wcel cA sincl cA csin cfv sqcl
    syl cA cc wcel cA ccos cfv cc wcel cA ccos cfv c2 cexp co cc wcel cA coscl
    cA ccos cfv sqcl syl sylanc cA cc wcel cA csin cfv c2 cexp co cA ccos cfv
    c2 cexp co caddc co c1 c2 cmul cA sincossq opreq2d eqtr3d c2 2cn mulid1i
    syl6eq c2 cA csin cfv c2 cexp co cmul co cc wcel c2 cA ccos cfv c2 cexp co
    cmul co cc wcel c2 c2 cA csin cfv c2 cexp co cmul co cmin co c2 cA ccos cfv
    c2 cexp co cmul co wceq c2 cA csin cfv c2 cexp co cmul co c2 cA ccos cfv c2
    cexp co cmul co caddc co c2 wceq wb cA cc wcel c2 cc wcel c2 cA csin cfv c2
    cexp co cmul co cc wcel c2 cA ccos cfv c2 cexp co cmul co cc wcel c2 c2 cA
    csin cfv c2 cexp co cmul co cmin co c2 cA ccos cfv c2 cexp co cmul co wceq
    c2 cA csin cfv c2 cexp co cmul co c2 cA ccos cfv c2 cexp co cmul co caddc
    co c2 wceq wb 2cn c2 c2 cA csin cfv c2 cexp co cmul co c2 cA ccos cfv c2
    cexp co cmul co subadd mp3an1 c2 cc wcel cA csin cfv c2 cexp co cc wcel c2
    cA csin cfv c2 cexp co cmul co cc wcel cA cc wcel c2 cA csin cfv c2 cexp co
    mulcl 2cn cA cc wcel cA csin cfv cc wcel cA csin cfv c2 cexp co cc wcel cA
    sincl cA csin cfv sqcl syl sylancr c2 cc wcel cA ccos cfv c2 cexp co cc
    wcel c2 cA ccos cfv c2 cexp co cmul co cc wcel cA cc wcel c2 cA ccos cfv c2
    cexp co mulcl 2cn cA cc wcel cA ccos cfv cc wcel cA ccos cfv c2 cexp co cc
    wcel cA coscl cA ccos cfv sqcl syl sylancr sylanc mpbird opreq1d cA cc wcel
    c2 c2 cA csin cfv c2 cexp co cmul co cmin co c1 cmin co c2 c1 cmin co c2 cA
    csin cfv c2 cexp co cmul co cmin co c1 c2 cA csin cfv c2 cexp co cmul co
    cmin co cA cc wcel c2 cA csin cfv c2 cexp co cmul co cc wcel c2 c2 cA csin
    cfv c2 cexp co cmul co cmin co c1 cmin co c2 c1 cmin co c2 cA csin cfv c2
    cexp co cmul co cmin co wceq c2 cc wcel cA csin cfv c2 cexp co cc wcel c2
    cA csin cfv c2 cexp co cmul co cc wcel cA cc wcel c2 cA csin cfv c2 cexp co
    mulcl 2cn cA cc wcel cA csin cfv cc wcel cA csin cfv c2 cexp co cc wcel cA
    sincl cA csin cfv sqcl syl sylancr c2 cc wcel c2 cA csin cfv c2 cexp co
    cmul co cc wcel c1 cc wcel c2 c2 cA csin cfv c2 cexp co cmul co cmin co c1
    cmin co c2 c1 cmin co c2 cA csin cfv c2 cexp co cmul co cmin co wceq 2cn
    ax1cn c2 c2 cA csin cfv c2 cexp co cmul co c1 sub23 mp3an13 syl c2 c1 cmin
    co c1 c2 cA csin cfv c2 cexp co cmul co cmin c2 c1 c1 2cn ax1cn ax1cn c2 c1
    c1 caddc co df-2 eqcomi subaddrii opreq1i syl6eq 3eqtr2d $.
    $( [12-Sep-2008] $) $( [12-Sep-2008] $)

  ${
    sin2t.1 $e |- A e. CC $.
    $( Double-angle formula for cosine.  (Contributed by Paul Chapman,
       25-Nov-2007.) $)
    cos2OLD $p |- ( cos ` ( 2 x. A ) ) =
                ( ( 2 x. ( ( cos ` A ) ^ 2 ) ) - 1 ) $=
      c2 cA cmul co ccos cfv cA ccos cfv c2 cexp co cA csin cfv c2 cexp co cmin
      co cA ccos cfv c2 cexp co c1 cA ccos cfv c2 cexp co cmin co cmin co c2 cA
      ccos cfv c2 cexp co cmul co c1 cmin co cA cA caddc co ccos cfv cA ccos
      cfv cA ccos cfv cmul co cA csin cfv cA csin cfv cmul co cmin co c2 cA
      cmul co ccos cfv cA ccos cfv c2 cexp co cA csin cfv c2 cexp co cmin co cA
      cA sin2t.1 sin2t.1 cosaddi c2 cA cmul co cA cA caddc co ccos cA sin2t.1
      2timesi fveq2i cA ccos cfv c2 cexp co cA ccos cfv cA ccos cfv cmul co cA
      csin cfv c2 cexp co cA csin cfv cA csin cfv cmul co cmin cA ccos cfv cA
      cc wcel cA ccos cfv cc wcel sin2t.1 cA coscl ax-mp sqvali cA csin cfv cA
      cc wcel cA csin cfv cc wcel sin2t.1 cA sincl ax-mp sqvali opreq12i
      3eqtr4i c1 cA ccos cfv c2 cexp co cmin co cA csin cfv c2 cexp co cA ccos
      cfv c2 cexp co cmin c1 cA ccos cfv c2 cexp co cmin co cA csin cfv c2 cexp
      co wceq cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 wceq cA
      cc wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 wceq
      sin2t.1 cA sincossq ax-mp c1 cA ccos cfv c2 cexp co cA csin cfv c2 cexp
      co ax1cn cA ccos cfv cA cc wcel cA ccos cfv cc wcel sin2t.1 cA coscl
      ax-mp sqcli cA csin cfv cA cc wcel cA csin cfv cc wcel sin2t.1 cA sincl
      ax-mp sqcli subadd2i mpbir opreq2i cA ccos cfv c2 cexp co c1 cA ccos cfv
      c2 cexp co cmin co cmin co cA ccos cfv c2 cexp co cA ccos cfv c2 cexp co
      caddc co c1 cmin co c2 cA ccos cfv c2 cexp co cmul co c1 cmin co cA ccos
      cfv c2 cexp co cc wcel c1 cc wcel cA ccos cfv c2 cexp co cc wcel cA ccos
      cfv c2 cexp co c1 cA ccos cfv c2 cexp co cmin co cmin co cA ccos cfv c2
      cexp co cA ccos cfv c2 cexp co caddc co c1 cmin co wceq cA ccos cfv cA cc
      wcel cA ccos cfv cc wcel sin2t.1 cA coscl ax-mp sqcli ax1cn cA ccos cfv
      cA cc wcel cA ccos cfv cc wcel sin2t.1 cA coscl ax-mp sqcli cA ccos cfv
      c2 cexp co c1 cA ccos cfv c2 cexp co subsub3 mp3an c2 cA ccos cfv c2 cexp
      co cmul co cA ccos cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 cmin
      cA ccos cfv c2 cexp co cA ccos cfv cA cc wcel cA ccos cfv cc wcel sin2t.1
      cA coscl ax-mp sqcli 2timesi opreq1i eqtr4i 3eqtr2i $.
      $( [25-Nov-2007] $) $( [25-Nov-2007] $)
  $}

  $( The sine of a real number lies between -1 and 1.  Equation 18 of [Gleason]
     p. 311. $)
  sinbnd $p |- ( A e. RR -> ( -u 1 <_ ( sin ` A ) /\ ( sin ` A ) <_ 1 ) ) $=
    cA cr wcel cA csin cfv c1 cle wbr c1 cneg cA csin cfv cle wbr cA cr wcel cA
    csin cfv c2 cexp co c1 c2 cexp co cle wbr cA csin cfv c1 cle wbr c1 cneg cA
    csin cfv cle wbr wa cA cr wcel cA csin cfv c2 cexp co cA csin cfv c2 cexp
    co cA ccos cfv c2 cexp co caddc co c1 c2 cexp co cle cA cr wcel cc0 cA ccos
    cfv c2 cexp co cle wbr cA csin cfv c2 cexp co cA csin cfv c2 cexp co cA
    ccos cfv c2 cexp co caddc co cle wbr cA cr wcel cA ccos cfv cr wcel cc0 cA
    ccos cfv c2 cexp co cle wbr cA recoscl cA ccos cfv sqge0 syl cA csin cfv c2
    cexp co cr wcel cA ccos cfv c2 cexp co cr wcel cc0 cA ccos cfv c2 cexp co
    cle wbr cA csin cfv c2 cexp co cA csin cfv c2 cexp co cA ccos cfv c2 cexp
    co caddc co cle wbr wb cA cr wcel cA csin cfv c2 cexp co cA ccos cfv c2
    cexp co addge01 cA cr wcel cA csin cfv cr wcel cA csin cfv c2 cexp co cr
    wcel cA resincl cA csin cfv resqcl syl cA cr wcel cA ccos cfv cr wcel cA
    ccos cfv c2 cexp co cr wcel cA recoscl cA ccos cfv resqcl syl sylanc mpbid
    cA cr wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 c1 c2
    cexp co cA cr wcel cA cc wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co
    caddc co c1 wceq cA recn cA sincossq syl sq1 syl6eqr breqtrd cA cr wcel cA
    csin cfv cr wcel cA csin cfv c2 cexp co c1 c2 cexp co cle wbr cA csin cfv
    c1 cle wbr c1 cneg cA csin cfv cle wbr wa wb cA resincl cA csin cfv cr wcel
    cA csin cfv c1 cle wbr cA csin cfv cneg c1 cle wbr wa cA csin cfv c2 cexp
    co c1 c2 cexp co cle wbr cA csin cfv c1 cle wbr c1 cneg cA csin cfv cle wbr
    wa cA csin cfv cr wcel c1 cr wcel cc0 c1 cle wbr cA csin cfv c1 cle wbr cA
    csin cfv cneg c1 cle wbr wa cA csin cfv c2 cexp co c1 c2 cexp co cle wbr wb
    1re cc0 c1 0re 1re lt01 ltleii cA csin cfv c1 lenegsq mp3an23 cA csin cfv
    cr wcel cA csin cfv cneg c1 cle wbr c1 cneg cA csin cfv cle wbr cA csin cfv
    c1 cle wbr cA csin cfv cr wcel c1 cr wcel cA csin cfv cneg c1 cle wbr c1
    cneg cA csin cfv cle wbr wb 1re cA csin cfv c1 lenegcon1 mpan2 anbi2d
    bitr3d syl mpbid ancomd $.
    $( [3-Mar-2006] $) $( [16-Jan-2006] $)

  $( The cosine of a real number lies between -1 and 1.  Equation 18 of
     [Gleason] p. 311. $)
  cosbnd $p |- ( A e. RR -> ( -u 1 <_ ( cos ` A ) /\ ( cos ` A ) <_ 1 ) ) $=
    cA cr wcel cA ccos cfv c1 cle wbr c1 cneg cA ccos cfv cle wbr cA cr wcel cA
    ccos cfv c2 cexp co c1 c2 cexp co cle wbr cA ccos cfv c1 cle wbr c1 cneg cA
    ccos cfv cle wbr wa cA cr wcel cA ccos cfv c2 cexp co cA csin cfv c2 cexp
    co cA ccos cfv c2 cexp co caddc co c1 c2 cexp co cle cA cr wcel cc0 cA csin
    cfv c2 cexp co cle wbr cA ccos cfv c2 cexp co cA csin cfv c2 cexp co cA
    ccos cfv c2 cexp co caddc co cle wbr cA cr wcel cA csin cfv cr wcel cc0 cA
    csin cfv c2 cexp co cle wbr cA resincl cA csin cfv sqge0 syl cA ccos cfv c2
    cexp co cr wcel cA csin cfv c2 cexp co cr wcel cc0 cA csin cfv c2 cexp co
    cle wbr cA ccos cfv c2 cexp co cA csin cfv c2 cexp co cA ccos cfv c2 cexp
    co caddc co cle wbr wb cA cr wcel cA ccos cfv c2 cexp co cA csin cfv c2
    cexp co addge02 cA cr wcel cA ccos cfv cr wcel cA ccos cfv c2 cexp co cr
    wcel cA recoscl cA ccos cfv resqcl syl cA cr wcel cA csin cfv cr wcel cA
    csin cfv c2 cexp co cr wcel cA resincl cA csin cfv resqcl syl sylanc mpbid
    cA cr wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1 c1 c2
    cexp co cA cr wcel cA cc wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co
    caddc co c1 wceq cA recn cA sincossq syl sq1 syl6eqr breqtrd cA cr wcel cA
    ccos cfv cr wcel cA ccos cfv c2 cexp co c1 c2 cexp co cle wbr cA ccos cfv
    c1 cle wbr c1 cneg cA ccos cfv cle wbr wa wb cA recoscl cA ccos cfv cr wcel
    cA ccos cfv c1 cle wbr cA ccos cfv cneg c1 cle wbr wa cA ccos cfv c2 cexp
    co c1 c2 cexp co cle wbr cA ccos cfv c1 cle wbr c1 cneg cA ccos cfv cle wbr
    wa cA ccos cfv cr wcel c1 cr wcel cc0 c1 cle wbr cA ccos cfv c1 cle wbr cA
    ccos cfv cneg c1 cle wbr wa cA ccos cfv c2 cexp co c1 c2 cexp co cle wbr wb
    1re cc0 c1 0re 1re lt01 ltleii cA ccos cfv c1 lenegsq mp3an23 cA ccos cfv
    cr wcel cA ccos cfv cneg c1 cle wbr c1 cneg cA ccos cfv cle wbr cA ccos cfv
    c1 cle wbr cA ccos cfv cr wcel c1 cr wcel cA ccos cfv cneg c1 cle wbr c1
    cneg cA ccos cfv cle wbr wb 1re cA ccos cfv c1 lenegcon1 mpan2 anbi2d
    bitr3d syl mpbid ancomd $.
    $( [10-Feb-2007] $) $( [16-Jan-2006] $)

  $( Lemma for ~ sin01bnd and ~ cos01bnd . $)
  sin01bndlem1 $p |- ( 5 / ( ( ! ` 4 ) x. 4 ) ) < ( 1 / 6 ) $=
    c5 c6 c2 c4 cexp co cmul co cdiv co c2 c4 cexp co c6 c2 c4 cexp co cmul co
    cdiv co c5 c4 cfa cfv c4 cmul co cdiv co c1 c6 cdiv co clt c5 c2 c4 cexp co
    clt wbr c5 c6 c2 c4 cexp co cmul co cdiv co c2 c4 cexp co c6 c2 c4 cexp co
    cmul co cdiv co clt wbr c5 c2 c3 cexp co clt wbr c2 c3 cexp co c2 c4 cexp
    co cle wbr c5 c2 c4 cexp co clt wbr cc0 c5 caddc co c3 c5 caddc co c5 c2 c3
    cexp co clt cc0 c3 clt wbr cc0 c5 caddc co c3 c5 caddc co clt wbr 3pos cc0
    c3 c5 0re 3re 5re ltadd1i mpbi c5 c5 5re recni addid2i c2 c3 cexp co c8 c5
    c3 caddc co c3 c5 caddc co cu2 5p3e8 c5 c3 c5 5re recni c3 3nn nncni
    addcomi 3eqtr2ri 3brtr3i c1 c2 cle wbr c3 c4 cle wbr c2 c3 cexp co c2 c4
    cexp co cle wbr c2 cn wcel c1 c2 cle wbr 2nn c2 nnge1 ax-mp c3 c3 c1 caddc
    co c4 cle c3 cr wcel c3 c3 c1 caddc co cle wbr 3re c3 lep1 ax-mp df-4
    breqtrri c2 cr wcel c3 cn0 wcel c4 cn0 wcel w3a c1 c2 cle wbr c3 c4 cle wbr
    wa c2 c3 cexp co c2 c4 cexp co cle wbr c2 cr wcel c3 cn0 wcel c4 cn0 wcel
    2re c3 3nn nnnn0i c4 4nn nnnn0i 3pm3.2i c2 c3 c4 expwordi mpan mp2an c5 c2
    c3 cexp co c2 c4 cexp co 5re c2 c3 cexp co c8 cr cu2 8re eqeltri c2 c4 cexp
    co c2 cn wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn nnnn0i c2 c4
    nnexpcl mp2an nnrei ltletri mp2an c5 c2 c4 cexp co c6 c2 c4 cexp co cmul co
    5re c2 c4 cexp co c2 cn wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn
    nnnn0i c2 c4 nnexpcl mp2an nnrei c6 c2 c4 cexp co 6re c2 c4 cexp co c2 cn
    wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn nnnn0i c2 c4 nnexpcl
    mp2an nnrei remulcli c6 c2 c4 cexp co 6re c2 c4 cexp co c2 cn wcel c4 cn0
    wcel c2 c4 cexp co cn wcel 2nn c4 4nn nnnn0i c2 c4 nnexpcl mp2an nnrei 6pos
    c2 c4 cexp co c2 cn wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn
    nnnn0i c2 c4 nnexpcl mp2an nngt0i mulgt0ii ltdiv1ii mpbi c4 cfa cfv c4 cmul
    co c6 c2 c4 cexp co cmul co c5 cdiv c4 cfa cfv c4 cmul co c3 cfa cfv c2 c2
    cexp co c2 c2 cexp co cmul co cmul co c3 cfa cfv c2 c4 cexp co cmul co c6
    c2 c4 cexp co cmul co c4 cfa cfv c2 c2 cexp co cmul co c3 cfa cfv c2 c2
    cexp co cmul co c2 c2 cexp co cmul co c4 cfa cfv c4 cmul co c3 cfa cfv c2
    c2 cexp co c2 c2 cexp co cmul co cmul co c4 cfa cfv c3 cfa cfv c2 c2 cexp
    co cmul co c2 c2 cexp co cmul c4 cfa cfv c3 c1 caddc co cfa cfv c3 cfa cfv
    c3 c1 caddc co cmul co c3 cfa cfv c2 c2 cexp co cmul co c4 c3 c1 caddc co
    cfa df-4 fveq2i c3 cn0 wcel c3 c1 caddc co cfa cfv c3 cfa cfv c3 c1 caddc
    co cmul co wceq c3 3nn nnnn0i c3 facp1 ax-mp c3 c1 caddc co c2 c2 cexp co
    c3 cfa cfv cmul c2 c2 cexp co c4 c3 c1 caddc co sq2 df-4 eqtr2i opreq2i
    3eqtri opreq1i c2 c2 cexp co c4 c4 cfa cfv cmul sq2 opreq2i c3 cfa cfv c2
    c2 cexp co c2 c2 cexp co c3 cfa cfv c6 cc fac3 c6 6re recni eqeltri c2 c2
    cexp co c4 cc sq2 c4 4re recni eqeltri c2 c2 cexp co c4 cc sq2 c4 4re recni
    eqeltri mulassi 3eqtr3i c2 c4 cexp co c2 c2 cexp co c2 c2 cexp co cmul co
    c3 cfa cfv cmul c2 c2 c2 caddc co cexp co c2 c4 cexp co c2 c2 cexp co c2 c2
    cexp co cmul co c2 c2 caddc co c4 c2 cexp 2p2e4 opreq2i c2 cc wcel c2 cn0
    wcel c2 cn0 wcel c2 c2 c2 caddc co cexp co c2 c2 cexp co c2 c2 cexp co cmul
    co wceq 2cn 2nn0 2nn0 c2 c2 c2 expadd mp3an eqtr3i opreq2i c3 cfa cfv c6 c2
    c4 cexp co cmul fac3 opreq1i 3eqtr2i opreq2i c1 c2 c4 cexp co cmul co c6 c2
    c4 cexp co cmul co cdiv co c1 c6 cdiv co c2 c4 cexp co c6 c2 c4 cexp co
    cmul co cdiv co c1 c6 cdiv co c2 c4 cexp co c2 c4 cexp co cdiv co cmul co
    c1 c6 cdiv co c1 cmul co c1 c2 c4 cexp co cmul co c6 c2 c4 cexp co cmul co
    cdiv co c1 c6 cdiv co c2 c4 cexp co c2 c4 cexp co cdiv co c1 c1 c6 cdiv co
    cmul c2 c4 cexp co c2 c4 cexp co c2 cn wcel c4 cn0 wcel c2 c4 cexp co cn
    wcel 2nn c4 4nn nnnn0i c2 c4 nnexpcl mp2an nncni c2 c4 cexp co c2 cn wcel
    c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn nnnn0i c2 c4 nnexpcl mp2an
    nnne0i dividi opreq2i c1 c6 c2 c4 cexp co c2 c4 cexp co ax1cn c6 6re recni
    c2 c4 cexp co c2 cn wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn
    nnnn0i c2 c4 nnexpcl mp2an nncni c2 c4 cexp co c2 cn wcel c4 cn0 wcel c2 c4
    cexp co cn wcel 2nn c4 4nn nnnn0i c2 c4 nnexpcl mp2an nncni c6 6re 6pos
    gt0ne0ii c2 c4 cexp co c2 cn wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4
    4nn nnnn0i c2 c4 nnexpcl mp2an nnne0i divmuldivi c1 c6 cdiv co c6 c6 6re
    recni c6 6re 6pos gt0ne0ii reccli mulid1i 3eqtr3i c1 c2 c4 cexp co cmul co
    c2 c4 cexp co c6 c2 c4 cexp co cmul co cdiv c2 c4 cexp co c2 c4 cexp co c2
    cn wcel c4 cn0 wcel c2 c4 cexp co cn wcel 2nn c4 4nn nnnn0i c2 c4 nnexpcl
    mp2an nncni mulid2i opreq1i eqtr3i 3brtr4i $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  ${
    $d A j k x y $.  $d F k x $.
    sin01bndlem2.1 $e |- F = { <. j , y >. | ( j e. NN0 /\
                               y = ( ( ( _i x. A ) ^ j ) / ( ! ` j ) ) ) } $.

    $( Lemma for ~ sin01bnd . $)
    sin01bndlem2 $p |- ( A e. ( 0 (,] 1 ) ->
                         ( abs ` ( Im ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) <
                         ( ( A ^ 3 ) / 6 ) ) $=
      cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cA
      c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cA c3 cexp co c6 cdiv
      co cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz
      cfv vk cv cF cfv vk csu cim cfv cc wcel c4 cuz cfv vk cv cF cfv vk csu
      cim cfv cabs cfv cr wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv vk
      cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF
      c4 sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA
      cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr 4nn sylancl c4
      cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk csu cim
      cfv c4 cuz cfv vk cv cF cfv vk csu imcl recnd c4 cuz cfv vk cv cF cfv vk
      csu cim cfv abscl 3syl cA cc0 c1 cioc co wcel cA cr wcel cA c4 cexp co cr
      wcel cA c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cr wcel cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel c4 cn0
      wcel cA c4 cexp co cr wcel c4 4nn nnnn0i cA c4 reexpcl mpan2 cA c4 cexp
      co cr wcel c5 c4 cfa cfv c4 cmul co cdiv co cr wcel cA c4 cexp co c5 c4
      cfa cfv c4 cmul co cdiv co cmul co cr wcel c5 c4 cfa cfv c4 cmul co cdiv
      co c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co cr c5 c4 c1 caddc co c4
      cfa cfv c4 cmul co cdiv df-5 opreq1i c4 cn wcel c4 c1 caddc co c4 cfa cfv
      c4 cmul co cdiv co cr wcel 4nn c4 eftlubcl ax-mp eqeltri cA c4 cexp co c5
      c4 cfa cfv c4 cmul co cdiv co remulcl mpan2 3syl cA cc0 c1 cioc co wcel
      cA cr wcel cA c3 cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel c3 cn0 wcel cA c3
      cexp co cr wcel c3 3nn nnnn0i cA c3 reexpcl mpan2 cA c3 cexp co cr wcel
      c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos
      gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 3syl cA cc0 c1 cioc co wcel c4
      cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cA c4 cexp co c4 c1 caddc co
      c4 cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co c5 c4 cfa cfv c4 cmul
      co cdiv co cmul co cle cA cc0 c1 cioc co wcel c4 cn wcel c4 cuz cfv vk cv
      cF cfv vk csu cim cfv cabs cfv cA c4 cexp co c4 c1 caddc co c4 cfa cfv c4
      cmul co cdiv co cmul co cle wbr 4nn vy cA cim vj vk cF c4 sin01bndlem2.1
      cim cim wceq cim cre wceq cim eqid olci abspef01tlubi mpan2 c5 c4 cfa cfv
      c4 cmul co cdiv co c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co cA c4
      cexp co cmul c5 c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv df-5 opreq1i
      opreq2i syl6breqr cA cc0 c1 cioc co wcel cA c4 cexp co c5 c4 cfa cfv c4
      cmul co cdiv co cmul co cA c4 cexp co c1 c6 cdiv co cmul co cA c3 cexp co
      c6 cdiv co cA cc0 c1 cioc co wcel cA cr wcel cA c4 cexp co cr wcel cA c4
      cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cr wcel cA cc0 c1 cioc
      co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA
      cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel c4 cn0 wcel cA c4 cexp co cr
      wcel c4 4nn nnnn0i cA c4 reexpcl mpan2 cA c4 cexp co cr wcel c5 c4 cfa
      cfv c4 cmul co cdiv co cr wcel cA c4 cexp co c5 c4 cfa cfv c4 cmul co
      cdiv co cmul co cr wcel c5 c4 cfa cfv c4 cmul co cdiv co c4 c1 caddc co
      c4 cfa cfv c4 cmul co cdiv co cr c5 c4 c1 caddc co c4 cfa cfv c4 cmul co
      cdiv df-5 opreq1i c4 cn wcel c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co
      cr wcel 4nn c4 eftlubcl ax-mp eqeltri cA c4 cexp co c5 c4 cfa cfv c4 cmul
      co cdiv co remulcl mpan2 3syl cA c4 cexp co cr wcel c1 c6 cdiv co cr wcel
      cA c4 cexp co c1 c6 cdiv co cmul co cr wcel cA cc0 c1 cioc co wcel cA c4
      cexp co c1 c6 cdiv co remulcl cA cr wcel c4 cn0 wcel cA c4 cexp co cr
      wcel cA cc0 c1 cioc co wcel cA c4 reexpcl cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d c4 4nn nnnn0i sylancl c6 6re c6 6re 6pos
      gt0ne0ii rereccli sylancl cA cc0 c1 cioc co wcel cA cr wcel cA c3 cexp co
      cr wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d cA cr wcel c3 cn0 wcel cA c3 cexp co cr wcel
      c3 3nn nnnn0i cA c3 reexpcl mpan2 cA c3 cexp co cr wcel c6 cr wcel c6 cc0
      wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp
      co c6 redivcl mp3an23 3syl cA c4 cexp co cr wcel cc0 cA c4 cexp co clt
      wbr cA c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co
      c1 c6 cdiv co cmul co clt wbr cA cc0 c1 cioc co wcel c5 c4 cfa cfv c4
      cmul co cdiv co cr wcel c1 c6 cdiv co cr wcel cA c4 cexp co cr wcel cc0
      cA c4 cexp co clt wbr cA c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul
      co cA c4 cexp co c1 c6 cdiv co cmul co clt wbr wi c5 c4 cfa cfv c4 cmul
      co cdiv co c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co cr c5 c4 c1 caddc
      co c4 cfa cfv c4 cmul co cdiv df-5 opreq1i c4 cn wcel c4 c1 caddc co c4
      cfa cfv c4 cmul co cdiv co cr wcel 4nn c4 eftlubcl ax-mp eqeltri c6 6re
      c6 6re 6pos gt0ne0ii rereccli c5 c4 cfa cfv c4 cmul co cdiv co cr wcel c1
      c6 cdiv co cr wcel cA c4 cexp co cr wcel w3a cc0 cA c4 cexp co clt wbr cA
      c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co c1 c6
      cdiv co cmul co clt wbr c5 c4 cfa cfv c4 cmul co cdiv co cr wcel c1 c6
      cdiv co cr wcel cA c4 cexp co cr wcel w3a cc0 cA c4 cexp co clt wbr wa c5
      c4 cfa cfv c4 cmul co cdiv co c1 c6 cdiv co clt wbr cA c4 cexp co c5 c4
      cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co c1 c6 cdiv co cmul co
      clt wbr sin01bndlem1 c5 c4 cfa cfv c4 cmul co cdiv co c1 c6 cdiv co cA c4
      cexp co ltmul2OLD mpbii ex mp3an12 cA cr wcel c4 cn0 wcel cA c4 cexp co
      cr wcel cA cc0 c1 cioc co wcel cA c4 reexpcl cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d c4 4nn nnnn0i sylancl cA cr wcel cc0 cA clt
      wbr cc0 cA c4 cexp co clt wbr cA cc0 c1 cioc co wcel cA cr wcel c4 cn0
      wcel cc0 cA clt wbr cc0 cA c4 cexp co clt wbr c4 4nn nnnn0i cA c4 expgt0
      mp3an2 cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp2d sylanc sylc cA cc0 c1 cioc co
      wcel cA c4 cexp co c1 c6 cdiv co cmul co cA c3 cexp co c1 c6 cdiv co cmul
      co cA c3 cexp co c6 cdiv co cle cA cc0 c1 cioc co wcel cA c4 cexp co cA
      c3 cexp co cle wbr cA c4 cexp co c1 c6 cdiv co cmul co cA c3 cexp co c1
      c6 cdiv co cmul co cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr w3a cA c4 cexp co cA c3 cexp co cle wbr cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr cA c4 cexp co cA c3 cexp co cle wbr cA cr wcel c3 cn0 wcel c4 cn0
      wcel cc0 cA clt wbr cA c1 cle wbr wa cA c4 cexp co cA c3 cexp co cle wbr
      wi c3 3nn nnnn0i c4 4nn nnnn0i cc0 cA clt wbr cA c1 cle wbr wa cA cr wcel
      c3 cn0 wcel c4 cn0 wcel w3a cA c4 cexp co cA c3 cexp co cle wbr cc0 cA
      clt wbr cA c1 cle wbr c3 c4 clt wbr cA cr wcel c3 cn0 wcel c4 cn0 wcel
      w3a cA c4 cexp co cA c3 cexp co cle wbr wi c3 c3 c1 caddc co c4 clt c3
      3re ltp1i df-4 breqtrri cA cr wcel c3 cn0 wcel c4 cn0 wcel w3a cc0 cA clt
      wbr cA c1 cle wbr c3 c4 clt wbr w3a cA c4 cexp co cA c3 cexp co cle wbr
      cA c3 c4 expword2i expcom mp3an3 com12 mp3an23 3impib sylbi cA cc0 c1
      cioc co wcel cA c4 cexp co cr wcel cA c3 cexp co cr wcel wa cA c4 cexp co
      cA c3 cexp co cle wbr cA c4 cexp co c1 c6 cdiv co cmul co cA c3 cexp co
      c1 c6 cdiv co cmul co cle wbr wb cA cc0 c1 cioc co wcel cA cr wcel cA c4
      cexp co cr wcel cA c3 cexp co cr wcel wa cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d cA cr wcel cA c4 cexp co cr wcel cA c3 cexp
      co cr wcel cA cr wcel c4 cn0 wcel cA c4 cexp co cr wcel c4 4nn nnnn0i cA
      c4 reexpcl mpan2 cA cr wcel c3 cn0 wcel cA c3 cexp co cr wcel c3 3nn
      nnnn0i cA c3 reexpcl mpan2 jca syl cA c4 cexp co cr wcel cA c3 cexp co cr
      wcel c1 c6 cdiv co cr wcel cA c4 cexp co cA c3 cexp co cle wbr cA c4 cexp
      co c1 c6 cdiv co cmul co cA c3 cexp co c1 c6 cdiv co cmul co cle wbr wb
      c6 6re c6 6re 6pos gt0ne0ii rereccli cA c4 cexp co cr wcel cA c3 cexp co
      cr wcel c1 c6 cdiv co cr wcel w3a cc0 c1 c6 cdiv co clt wbr cA c4 cexp co
      cA c3 cexp co cle wbr cA c4 cexp co c1 c6 cdiv co cmul co cA c3 cexp co
      c1 c6 cdiv co cmul co cle wbr wb c6 6re 6pos recgt0ii cA c4 cexp co cA c3
      cexp co c1 c6 cdiv co lemul1OLD mpan2 mp3an3 syl mpbid cA cc0 c1 cioc co
      wcel cA cr wcel cA c3 cexp co cc wcel cA c3 cexp co c6 cdiv co cA c3 cexp
      co c1 c6 cdiv co cmul co wceq cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cA cr wcel cA c3 cexp co cA cr wcel c3 cn0 wcel cA c3 cexp co cr
      wcel c3 3nn nnnn0i cA c3 reexpcl mpan2 recnd cA c3 cexp co cc wcel c6 cc
      wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cA c3 cexp co c1 c6 cdiv co cmul
      co wceq c6 6re recni c6 6re 6pos gt0ne0ii cA c3 cexp co c6 divrec mp3an23
      3syl breqtrrd ltletrd lelttrd $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)

    $( Lemma for ~ sin01bnd . $)
    sin01bndlem3 $p |- ( A e. ( 0 (,] 1 ) ->
        ( ( A - ( ( A ^ 3 ) / 3 ) ) < ( sin ` A ) /\ ( sin ` A ) < A ) ) $=
      cA cc0 c1 cioc co wcel cA cA c3 cexp co c3 cdiv co cmin co cA csin cfv
      clt wbr cA csin cfv cA clt wbr cA cc0 c1 cioc co wcel cA cA c3 cexp co c6
      cdiv co cmin co cA c3 cexp co c6 cdiv co cneg caddc co cA cA c3 cexp co
      c3 cdiv co cmin co cA csin cfv clt cA cc0 c1 cioc co wcel cA cA c3 cexp
      co c6 cdiv co cA c3 cexp co c6 cdiv co cneg cmin co cmin co cA cA c3 cexp
      co c6 cdiv co cmin co cA c3 cexp co c6 cdiv co cneg caddc co cA cA c3
      cexp co c3 cdiv co cmin co cA cc wcel cA c3 cexp co c6 cdiv co cc wcel cA
      c3 cexp co c6 cdiv co cneg cc wcel cA cA c3 cexp co c6 cdiv co cA c3 cexp
      co c6 cdiv co cneg cmin co cmin co cA cA c3 cexp co c6 cdiv co cmin co cA
      c3 cexp co c6 cdiv co cneg caddc co wceq cA cc0 c1 cioc co wcel cA cA c3
      cexp co c6 cdiv co cA c3 cexp co c6 cdiv co cneg subsub cA cc0 c1 cioc co
      wcel cA cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd cA cc0
      c1 cioc co wcel cA c3 cexp co c6 cdiv co cA cr wcel c3 cn0 wcel cA c3
      cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel
      wa cA c3 cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl
      cA c3 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr
      wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl recnd cA
      cc0 c1 cioc co wcel cA c3 cexp co c6 cdiv co cneg cA cc0 c1 cioc co wcel
      cA c3 cexp co c6 cdiv co cr wcel cA c3 cexp co c6 cdiv co cneg cr wcel cA
      cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co cr wcel cA c3 cexp co c6
      cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr wcel c6 cr wcel c6 cc0 wne
      cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp co
      c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d c3 3nn nnnn0i sylancl cA c3 cexp co c6 cdiv co renegcl syl recnd
      syl3anc cA cc0 c1 cioc co wcel cA c3 cexp co c6 cdiv co cA c3 cexp co c6
      cdiv co cneg cmin co cA c3 cexp co c3 cdiv co cA cmin cA cc0 c1 cioc co
      wcel cA c3 cexp co c6 cdiv co cA c3 cexp co c6 cdiv co cneg cmin co cA c3
      cexp co c6 cdiv co cA c3 cexp co c6 cdiv co caddc co c2 cA c3 cexp co c6
      cdiv co cmul co cA c3 cexp co c3 cdiv co cA c3 cexp co c6 cdiv co cc wcel
      cA c3 cexp co c6 cdiv co cc wcel cA c3 cexp co c6 cdiv co cA c3 cexp co
      c6 cdiv co cneg cmin co cA c3 cexp co c6 cdiv co cA c3 cexp co c6 cdiv co
      caddc co wceq cA cc0 c1 cioc co wcel cA c3 cexp co c6 cdiv co cA c3 cexp
      co c6 cdiv co subneg cA cc0 c1 cioc co wcel cA c3 cexp co c6 cdiv co cA
      cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co cr wcel cA c3 cexp co c6
      cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr wcel c6 cr wcel c6 cc0 wne
      cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp co
      c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d c3 3nn nnnn0i sylancl recnd cA cc0 c1 cioc co wcel cA c3 cexp co
      c6 cdiv co cA cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0
      c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co cr wcel cA c3
      cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr wcel c6 cr wcel
      c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA
      c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
      biimpi 3simp1d c3 3nn nnnn0i sylancl recnd sylanc cA cc0 c1 cioc co wcel
      cA c3 cexp co c6 cdiv co cc wcel c2 cA c3 cexp co c6 cdiv co cmul co cA
      c3 cexp co c6 cdiv co cA c3 cexp co c6 cdiv co caddc co wceq cA cc0 c1
      cioc co wcel cA c3 cexp co c6 cdiv co cA cr wcel c3 cn0 wcel cA c3 cexp
      co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA
      c3 cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3
      cexp co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel
      6re c6 6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl recnd cA
      c3 cexp co c6 cdiv co 2times syl cA cc0 c1 cioc co wcel cA c3 cexp co c2
      c6 cdiv co cmul co cA c3 cexp co c1 c3 cdiv co cmul co c2 cA c3 cexp co
      c6 cdiv co cmul co cA c3 cexp co c3 cdiv co c2 c6 cdiv co c1 c3 cdiv co
      cA c3 cexp co cmul c2 c1 cmul co c2 c3 cmul co cdiv co c2 c6 cdiv co c1
      c3 cdiv co c2 c1 cmul co c2 c2 c3 cmul co c6 cdiv c2 2cn mulid1i c3 c2
      cmul co c2 c3 cmul co c6 c3 c2 c3 3re recni 2cn mulcomi 3t2e6 eqtr3i
      opreq12i c2 cc wcel c2 cc0 wne c2 c1 cmul co c2 c3 cmul co cdiv co c1 c3
      cdiv co wceq 2cn 2ne0 c3 cc wcel c3 cc0 wne c2 cc wcel c2 cc0 wne wa c2
      c1 cmul co c2 c3 cmul co cdiv co c1 c3 cdiv co wceq c3 3re recni c3 3re
      3pos gt0ne0ii c1 cc wcel c3 cc wcel c3 cc0 wne wa c2 cc wcel c2 cc0 wne
      wa c2 c1 cmul co c2 c3 cmul co cdiv co c1 c3 cdiv co wceq ax1cn c1 c3 c2
      divcan5 mp3an1 mpanl12 mp2an eqtr3i opreq2i cA cc0 c1 cioc co wcel cA c3
      cexp co cc wcel c2 cA c3 cexp co c6 cdiv co cmul co cA c3 cexp co c2 c6
      cdiv co cmul co wceq cA cc0 c1 cioc co wcel cA c3 cexp co cA cr wcel c3
      cn0 wcel cA c3 cexp co cr wcel cA cc0 c1 cioc co wcel cA c3 reexpcl cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i
      sylancl recnd c2 cc wcel cA c3 cexp co cc wcel c6 cc wcel c6 cc0 wne wa
      c2 cA c3 cexp co c6 cdiv co cmul co cA c3 cexp co c2 c6 cdiv co cmul co
      wceq 2cn c6 cc wcel c6 cc0 wne c6 6re recni c6 6re 6pos gt0ne0ii pm3.2i
      c2 cA c3 cexp co c6 div12 mp3an13 syl cA cc0 c1 cioc co wcel cA c3 cexp
      co cc wcel cA c3 cexp co c3 cdiv co cA c3 cexp co c1 c3 cdiv co cmul co
      wceq cA cc0 c1 cioc co wcel cA c3 cexp co cA cr wcel c3 cn0 wcel cA c3
      cexp co cr wcel cA cc0 c1 cioc co wcel cA c3 reexpcl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl recnd cA c3 cexp
      co cc wcel c3 cc wcel c3 cc0 wne cA c3 cexp co c3 cdiv co cA c3 cexp co
      c1 c3 cdiv co cmul co wceq c3 3re recni c3 3re 3pos gt0ne0ii cA c3 cexp
      co c3 divrec mp3an23 syl 3eqtr4a 3eqtr2d opreq2d eqtr3d cA cc0 c1 cioc co
      wcel cA cA c3 cexp co c6 cdiv co cmin co cA c3 cexp co c6 cdiv co cneg
      caddc co cA cA c3 cexp co c6 cdiv co cmin co c4 cuz cfv vk cv cF cfv vk
      csu cim cfv caddc co cA csin cfv clt cA cc0 c1 cioc co wcel cA c3 cexp co
      c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cim cfv clt wbr cA cA c3
      cexp co c6 cdiv co cmin co cA c3 cexp co c6 cdiv co cneg caddc co cA cA
      c3 cexp co c6 cdiv co cmin co c4 cuz cfv vk cv cF cfv vk csu cim cfv
      caddc co clt wbr cA cc0 c1 cioc co wcel cA c3 cexp co c6 cdiv co cneg c4
      cuz cfv vk cv cF cfv vk csu cim cfv clt wbr c4 cuz cfv vk cv cF cfv vk
      csu cim cfv cA c3 cexp co c6 cdiv co clt wbr cA cc0 c1 cioc co wcel c4
      cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cA c3 cexp co c6 cdiv co clt
      wbr cA c3 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cim cfv
      clt wbr c4 cuz cfv vk cv cF cfv vk csu cim cfv cA c3 cexp co c6 cdiv co
      clt wbr wa vy cA vj vk cF sin01bndlem2.1 sin01bndlem2 c4 cuz cfv vk cv cF
      cfv vk csu cim cfv cr wcel cA c3 cexp co c6 cdiv co cr wcel c4 cuz cfv vk
      cv cF cfv vk csu cim cfv cabs cfv cA c3 cexp co c6 cdiv co clt wbr cA c3
      cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cim cfv clt wbr c4
      cuz cfv vk cv cF cfv vk csu cim cfv cA c3 cexp co c6 cdiv co clt wbr wa
      wb cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cA c3
      cexp co c6 cdiv co abslt cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv
      vk csu cc wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cr wcel ci cA cmul
      co cc wcel c4 cn wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel cA cc0 c1
      cioc co wcel vy ci cA cmul co vj vk cF c4 sin01bndlem2.1 eftlcl ci cc
      wcel cA cc wcel ci cA cmul co cc wcel cA cc0 c1 cioc co wcel ci cA mulcl
      axicn cA cc0 c1 cioc co wcel cA cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d recnd sylancr 4nn sylancl c4 cuz cfv vk cv cF cfv vk csu imcl syl
      cA cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co cr wcel cA c3 cexp co c6
      cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr wcel c6 cr wcel c6 cc0 wne
      cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c3 cexp co
      c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d c3 3nn nnnn0i sylancl sylanc mpbid pm3.26d cA c3 cexp co c6 cdiv
      co cneg cr wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cr wcel cA cA c3
      cexp co c6 cdiv co cmin co cr wcel cA c3 cexp co c6 cdiv co cneg c4 cuz
      cfv vk cv cF cfv vk csu cim cfv clt wbr cA cA c3 cexp co c6 cdiv co cmin
      co cA c3 cexp co c6 cdiv co cneg caddc co cA cA c3 cexp co c6 cdiv co
      cmin co c4 cuz cfv vk cv cF cfv vk csu cim cfv caddc co clt wbr wb cA cc0
      c1 cioc co wcel cA c3 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk
      csu cim cfv cA cA c3 cexp co c6 cdiv co cmin co ltadd2 cA cc0 c1 cioc co
      wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 cexp co c6 cdiv co cneg cr
      wcel cA cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv co cr wcel cA cc0 c1
      cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co cr wcel cA c3 cexp
      co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr wcel c6 cr wcel c6
      cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c3
      cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d c3 3nn nnnn0i sylancl cA c3 cexp co c6 cdiv co renegcl syl cA cc0
      c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv
      cF cfv vk csu cim cfv cr wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv
      vk cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk
      cF c4 sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel
      cA cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr 4nn sylancl c4
      cuz cfv vk cv cF cfv vk csu imcl syl cA cr wcel cA c3 cexp co c6 cdiv co
      cr wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel cA cc0 c1 cioc co
      wcel cA cA c3 cexp co c6 cdiv co resubcl cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d cA cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv
      co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co
      cr wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr
      wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re
      6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel
      cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl sylanc syl3anc mpbid cA
      cc0 c1 cioc co wcel cA cr wcel cA csin cfv cA cA c3 cexp co c6 cdiv co
      cmin co c4 cuz cfv vk cv cF cfv vk csu cim cfv caddc co wceq cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d vy cA vj vk cF sin01bndlem2.1
      resin4p syl breqtrrd eqbrtrrd cA cc0 c1 cioc co wcel cA csin cfv cA cA c3
      cexp co c6 cdiv co cmin co cA c3 cexp co c6 cdiv co caddc co cA clt cA
      cc0 c1 cioc co wcel cA csin cfv cA cA c3 cexp co c6 cdiv co cmin co c4
      cuz cfv vk cv cF cfv vk csu cim cfv caddc co cA cA c3 cexp co c6 cdiv co
      cmin co cA c3 cexp co c6 cdiv co caddc co clt cA cc0 c1 cioc co wcel cA
      cr wcel cA csin cfv cA cA c3 cexp co c6 cdiv co cmin co c4 cuz cfv vk cv
      cF cfv vk csu cim cfv caddc co wceq cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
      biimpi 3simp1d vy cA vj vk cF sin01bndlem2.1 resin4p syl cA cc0 c1 cioc
      co wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cA c3 cexp co c6 cdiv co
      clt wbr cA cA c3 cexp co c6 cdiv co cmin co c4 cuz cfv vk cv cF cfv vk
      csu cim cfv caddc co cA cA c3 cexp co c6 cdiv co cmin co cA c3 cexp co c6
      cdiv co caddc co clt wbr cA cc0 c1 cioc co wcel cA c3 cexp co c6 cdiv co
      cneg c4 cuz cfv vk cv cF cfv vk csu cim cfv clt wbr c4 cuz cfv vk cv cF
      cfv vk csu cim cfv cA c3 cexp co c6 cdiv co clt wbr cA cc0 c1 cioc co
      wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cA c3 cexp co c6
      cdiv co clt wbr cA c3 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk
      csu cim cfv clt wbr c4 cuz cfv vk cv cF cfv vk csu cim cfv cA c3 cexp co
      c6 cdiv co clt wbr wa vy cA vj vk cF sin01bndlem2.1 sin01bndlem2 c4 cuz
      cfv vk cv cF cfv vk csu cim cfv cr wcel cA c3 cexp co c6 cdiv co cr wcel
      c4 cuz cfv vk cv cF cfv vk csu cim cfv cabs cfv cA c3 cexp co c6 cdiv co
      clt wbr cA c3 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cim
      cfv clt wbr c4 cuz cfv vk cv cF cfv vk csu cim cfv cA c3 cexp co c6 cdiv
      co clt wbr wa wb cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu
      cim cfv cA c3 cexp co c6 cdiv co abslt cA cc0 c1 cioc co wcel c4 cuz cfv
      vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cr
      wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv vk cv cF cfv vk csu cc
      wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF c4 sin01bndlem2.1
      eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cc0 c1 cioc co wcel
      ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d recnd sylancr 4nn sylancl c4 cuz cfv vk cv cF
      cfv vk csu imcl syl cA cr wcel c3 cn0 wcel cA c3 cexp co c6 cdiv co cr
      wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3 cexp co cr
      wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp co cr wcel
      c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos
      gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA
      cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl sylanc mpbid pm3.27d c4
      cuz cfv vk cv cF cfv vk csu cim cfv cr wcel cA c3 cexp co c6 cdiv co cr
      wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel c4 cuz cfv vk cv cF cfv
      vk csu cim cfv cA c3 cexp co c6 cdiv co clt wbr cA cA c3 cexp co c6 cdiv
      co cmin co c4 cuz cfv vk cv cF cfv vk csu cim cfv caddc co cA cA c3 cexp
      co c6 cdiv co cmin co cA c3 cexp co c6 cdiv co caddc co clt wbr wb cA cc0
      c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cim cfv cA c3 cexp co c6
      cdiv co cA cA c3 cexp co c6 cdiv co cmin co ltadd2 cA cc0 c1 cioc co wcel
      c4 cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk csu cim
      cfv cr wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv vk cv cF cfv vk
      csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF c4
      sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cc0
      c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr 4nn sylancl c4
      cuz cfv vk cv cF cfv vk csu imcl syl cA cr wcel c3 cn0 wcel cA c3 cexp co
      c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3
      cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp
      co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6
      6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl cA cr wcel cA c3
      cexp co c6 cdiv co cr wcel cA cA c3 cexp co c6 cdiv co cmin co cr wcel cA
      cc0 c1 cioc co wcel cA cA c3 cexp co c6 cdiv co resubcl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel c3 cn0 wcel cA c3 cexp co c6
      cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3
      cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp
      co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6
      6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl sylanc syl3anc
      mpbid eqbrtrd cA cc wcel cA c3 cexp co c6 cdiv co cc wcel cA cA c3 cexp
      co c6 cdiv co cmin co cA c3 cexp co c6 cdiv co caddc co cA wceq cA cc0 c1
      cioc co wcel cA cA c3 cexp co c6 cdiv co npcan cA cc0 c1 cioc co wcel cA
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd cA cc0 c1 cioc
      co wcel cA c3 cexp co c6 cdiv co cA cr wcel c3 cn0 wcel cA c3 cexp co c6
      cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c3 cn0 wcel wa cA c3
      cexp co cr wcel cA c3 cexp co c6 cdiv co cr wcel cA c3 reexpcl cA c3 cexp
      co cr wcel c6 cr wcel c6 cc0 wne cA c3 cexp co c6 cdiv co cr wcel 6re c6
      6re 6pos gt0ne0ii cA c3 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl recnd sylanc
      breqtrd jca $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)

    $( Lemma for ~ cos01bnd . $)
    cos01bndlem2 $p |- ( A e. ( 0 (,] 1 ) ->
                         ( abs ` ( Re ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) <
                         ( ( A ^ 2 ) / 6 ) ) $=
      cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cA
      c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cA c2 cexp co c6 cdiv
      co cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz
      cfv vk cv cF cfv vk csu cre cfv cc wcel c4 cuz cfv vk cv cF cfv vk csu
      cre cfv cabs cfv cr wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv vk
      cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF
      c4 sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA
      cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd sylancr 4nn sylancl c4
      cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk csu cre
      cfv c4 cuz cfv vk cv cF cfv vk csu recl recnd c4 cuz cfv vk cv cF cfv vk
      csu cre cfv abscl 3syl cA cc0 c1 cioc co wcel cA cr wcel cA c4 cexp co cr
      wcel cA c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cr wcel cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel c4 cn0
      wcel cA c4 cexp co cr wcel c4 4nn nnnn0i cA c4 reexpcl mpan2 cA c4 cexp
      co cr wcel c5 c4 cfa cfv c4 cmul co cdiv co cr wcel cA c4 cexp co c5 c4
      cfa cfv c4 cmul co cdiv co cmul co cr wcel c5 c4 cfa cfv c4 cmul co cdiv
      co c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co cr c5 c4 c1 caddc co c4
      cfa cfv c4 cmul co cdiv df-5 opreq1i c4 cn wcel c4 c1 caddc co c4 cfa cfv
      c4 cmul co cdiv co cr wcel 4nn c4 eftlubcl ax-mp eqeltri cA c4 cexp co c5
      c4 cfa cfv c4 cmul co cdiv co remulcl mpan2 3syl cA cc0 c1 cioc co wcel
      cA cr wcel cA c2 cexp co cr wcel cA c2 cexp co c6 cdiv co cr wcel cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA resqcl cA c2 cexp co cr wcel
      c6 cr wcel c6 cc0 wne cA c2 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos
      gt0ne0ii cA c2 cexp co c6 redivcl mp3an23 3syl cA cc0 c1 cioc co wcel c4
      cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cA c4 cexp co c4 c1 caddc co
      c4 cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co c5 c4 cfa cfv c4 cmul
      co cdiv co cmul co cle cA cc0 c1 cioc co wcel c4 cn wcel c4 cuz cfv vk cv
      cF cfv vk csu cre cfv cabs cfv cA c4 cexp co c4 c1 caddc co c4 cfa cfv c4
      cmul co cdiv co cmul co cle wbr 4nn vy cA cre vj vk cF c4 sin01bndlem2.1
      cre cre wceq cre cim wceq cre eqid orci abspef01tlubi mpan2 c5 c4 cfa cfv
      c4 cmul co cdiv co c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co cA c4
      cexp co cmul c5 c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv df-5 opreq1i
      opreq2i syl6breqr cA cc0 c1 cioc co wcel cA c4 cexp co c5 c4 cfa cfv c4
      cmul co cdiv co cmul co cA c4 cexp co c1 c6 cdiv co cmul co cA c2 cexp co
      c6 cdiv co cA cc0 c1 cioc co wcel cA cr wcel cA c4 cexp co cr wcel cA c4
      cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cr wcel cA cc0 c1 cioc
      co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA
      cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel c4 cn0 wcel cA c4 cexp co cr
      wcel c4 4nn nnnn0i cA c4 reexpcl mpan2 cA c4 cexp co cr wcel c5 c4 cfa
      cfv c4 cmul co cdiv co cr wcel cA c4 cexp co c5 c4 cfa cfv c4 cmul co
      cdiv co cmul co cr wcel c5 c4 cfa cfv c4 cmul co cdiv co c4 c1 caddc co
      c4 cfa cfv c4 cmul co cdiv co cr c5 c4 c1 caddc co c4 cfa cfv c4 cmul co
      cdiv df-5 opreq1i c4 cn wcel c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co
      cr wcel 4nn c4 eftlubcl ax-mp eqeltri cA c4 cexp co c5 c4 cfa cfv c4 cmul
      co cdiv co remulcl mpan2 3syl cA c4 cexp co cr wcel c1 c6 cdiv co cr wcel
      cA c4 cexp co c1 c6 cdiv co cmul co cr wcel cA cc0 c1 cioc co wcel cA c4
      cexp co c1 c6 cdiv co remulcl cA cr wcel c4 cn0 wcel cA c4 cexp co cr
      wcel cA cc0 c1 cioc co wcel cA c4 reexpcl cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d c4 4nn nnnn0i sylancl c6 6re c6 6re 6pos
      gt0ne0ii rereccli sylancl cA cc0 c1 cioc co wcel cA cr wcel cA c2 cexp co
      cr wcel cA c2 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d cA resqcl cA c2 cexp co cr wcel c6 cr wcel c6
      cc0 wne cA c2 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c2
      cexp co c6 redivcl mp3an23 3syl cA c4 cexp co cr wcel cc0 cA c4 cexp co
      clt wbr cA c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp
      co c1 c6 cdiv co cmul co clt wbr cA cc0 c1 cioc co wcel c5 c4 cfa cfv c4
      cmul co cdiv co cr wcel c1 c6 cdiv co cr wcel cA c4 cexp co cr wcel cc0
      cA c4 cexp co clt wbr cA c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul
      co cA c4 cexp co c1 c6 cdiv co cmul co clt wbr wi c5 c4 cfa cfv c4 cmul
      co cdiv co c4 c1 caddc co c4 cfa cfv c4 cmul co cdiv co cr c5 c4 c1 caddc
      co c4 cfa cfv c4 cmul co cdiv df-5 opreq1i c4 cn wcel c4 c1 caddc co c4
      cfa cfv c4 cmul co cdiv co cr wcel 4nn c4 eftlubcl ax-mp eqeltri c6 6re
      c6 6re 6pos gt0ne0ii rereccli c5 c4 cfa cfv c4 cmul co cdiv co cr wcel c1
      c6 cdiv co cr wcel cA c4 cexp co cr wcel w3a cc0 cA c4 cexp co clt wbr cA
      c4 cexp co c5 c4 cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co c1 c6
      cdiv co cmul co clt wbr c5 c4 cfa cfv c4 cmul co cdiv co cr wcel c1 c6
      cdiv co cr wcel cA c4 cexp co cr wcel w3a cc0 cA c4 cexp co clt wbr wa c5
      c4 cfa cfv c4 cmul co cdiv co c1 c6 cdiv co clt wbr cA c4 cexp co c5 c4
      cfa cfv c4 cmul co cdiv co cmul co cA c4 cexp co c1 c6 cdiv co cmul co
      clt wbr sin01bndlem1 c5 c4 cfa cfv c4 cmul co cdiv co c1 c6 cdiv co cA c4
      cexp co ltmul2OLD mpbii ex mp3an12 cA cr wcel c4 cn0 wcel cA c4 cexp co
      cr wcel cA cc0 c1 cioc co wcel cA c4 reexpcl cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d c4 4nn nnnn0i sylancl cA cr wcel cc0 cA clt
      wbr cc0 cA c4 cexp co clt wbr cA cc0 c1 cioc co wcel cA cr wcel c4 cn0
      wcel cc0 cA clt wbr cc0 cA c4 cexp co clt wbr c4 4nn nnnn0i cA c4 expgt0
      mp3an2 cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp2d sylanc sylc cA cc0 c1 cioc co
      wcel cA c4 cexp co c1 c6 cdiv co cmul co cA c2 cexp co c1 c6 cdiv co cmul
      co cA c2 cexp co c6 cdiv co cle cA cc0 c1 cioc co wcel cA c4 cexp co cA
      c2 cexp co cle wbr cA c4 cexp co c1 c6 cdiv co cmul co cA c2 cexp co c1
      c6 cdiv co cmul co cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr w3a cA c4 cexp co cA c2 cexp co cle wbr cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr cA c4 cexp co cA c2 cexp co cle wbr cA cr wcel c2 cn0 wcel c4 cn0
      wcel cc0 cA clt wbr cA c1 cle wbr wa cA c4 cexp co cA c2 cexp co cle wbr
      wi 2nn0 c4 4nn nnnn0i cc0 cA clt wbr cA c1 cle wbr wa cA cr wcel c2 cn0
      wcel c4 cn0 wcel w3a cA c4 cexp co cA c2 cexp co cle wbr cc0 cA clt wbr
      cA c1 cle wbr c2 c4 clt wbr cA cr wcel c2 cn0 wcel c4 cn0 wcel w3a cA c4
      cexp co cA c2 cexp co cle wbr wi cc0 c2 caddc co c2 c2 caddc co c2 c4 clt
      cc0 c2 clt wbr cc0 c2 caddc co c2 c2 caddc co clt wbr 2pos cc0 c2 c2 0re
      2re 2re ltadd1i mpbi c2 2cn addid2i 2p2e4 3brtr3i cA cr wcel c2 cn0 wcel
      c4 cn0 wcel w3a cc0 cA clt wbr cA c1 cle wbr c2 c4 clt wbr w3a cA c4 cexp
      co cA c2 cexp co cle wbr cA c2 c4 expword2i expcom mp3an3 com12 mp3an23
      3impib sylbi cA cc0 c1 cioc co wcel cA c4 cexp co cr wcel cA c2 cexp co
      cr wcel wa cA c4 cexp co cA c2 cexp co cle wbr cA c4 cexp co c1 c6 cdiv
      co cmul co cA c2 cexp co c1 c6 cdiv co cmul co cle wbr wb cA cc0 c1 cioc
      co wcel cA cr wcel cA c4 cexp co cr wcel cA c2 cexp co cr wcel wa cA cc0
      c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel cA c4 cexp co cr
      wcel cA c2 cexp co cr wcel cA cr wcel c4 cn0 wcel cA c4 cexp co cr wcel
      c4 4nn nnnn0i cA c4 reexpcl mpan2 cA resqcl jca syl cA c4 cexp co cr wcel
      cA c2 cexp co cr wcel c1 c6 cdiv co cr wcel cA c4 cexp co cA c2 cexp co
      cle wbr cA c4 cexp co c1 c6 cdiv co cmul co cA c2 cexp co c1 c6 cdiv co
      cmul co cle wbr wb c6 6re c6 6re 6pos gt0ne0ii rereccli cA c4 cexp co cr
      wcel cA c2 cexp co cr wcel c1 c6 cdiv co cr wcel w3a cc0 c1 c6 cdiv co
      clt wbr cA c4 cexp co cA c2 cexp co cle wbr cA c4 cexp co c1 c6 cdiv co
      cmul co cA c2 cexp co c1 c6 cdiv co cmul co cle wbr wb c6 6re 6pos
      recgt0ii cA c4 cexp co cA c2 cexp co c1 c6 cdiv co lemul1OLD mpan2 mp3an3
      syl mpbid cA cc0 c1 cioc co wcel cA cr wcel cA c2 cexp co cc wcel cA c2
      cexp co c6 cdiv co cA c2 cexp co c1 c6 cdiv co cmul co wceq cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cr wcel cA c2 cexp co cA
      resqcl recnd cA c2 cexp co cc wcel c6 cc wcel c6 cc0 wne cA c2 cexp co c6
      cdiv co cA c2 cexp co c1 c6 cdiv co cmul co wceq c6 6re recni c6 6re 6pos
      gt0ne0ii cA c2 cexp co c6 divrec mp3an23 3syl breqtrrd ltletrd lelttrd $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)

    $( Lemma for ~ cos01bnd . $)
    cos01bndlem3 $p |- ( A e. ( 0 (,] 1 ) ->
                         ( ( 1 - ( 2 x. ( ( A ^ 2 ) / 3 ) ) ) < ( cos ` A ) /\
                           ( cos ` A ) < ( 1 - ( ( A ^ 2 ) / 3 ) ) ) ) $=
      cA cc0 c1 cioc co wcel c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co cA
      ccos cfv clt wbr cA ccos cfv c1 cA c2 cexp co c3 cdiv co cmin co clt wbr
      cA cc0 c1 cioc co wcel c1 cA c2 cexp co c2 cdiv co cmin co cA c2 cexp co
      c6 cdiv co cneg caddc co c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co
      cA ccos cfv clt cA cc0 c1 cioc co wcel c1 cA c2 cexp co c2 cdiv co cA c2
      cexp co c6 cdiv co cneg cmin co cmin co c1 cA c2 cexp co c2 cdiv co cmin
      co cA c2 cexp co c6 cdiv co cneg caddc co c1 c2 cA c2 cexp co c3 cdiv co
      cmul co cmin co cA c2 cexp co c2 cdiv co cc wcel cA c2 cexp co c6 cdiv co
      cneg cc wcel c1 cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cneg
      cmin co cmin co c1 cA c2 cexp co c2 cdiv co cmin co cA c2 cexp co c6 cdiv
      co cneg caddc co wceq cA cc0 c1 cioc co wcel c1 cc wcel cA c2 cexp co c2
      cdiv co cc wcel cA c2 cexp co c6 cdiv co cneg cc wcel c1 cA c2 cexp co c2
      cdiv co cA c2 cexp co c6 cdiv co cneg cmin co cmin co c1 cA c2 cexp co c2
      cdiv co cmin co cA c2 cexp co c6 cdiv co cneg caddc co wceq ax1cn c1 cA
      c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cneg subsub mp3an1 cA cc0
      c1 cioc co wcel cA c2 cexp co c2 cdiv co cA cc0 c1 cioc co wcel cA c2
      cexp co cr wcel cA c2 cexp co c2 cdiv co cr wcel cA cc0 c1 cioc co wcel
      cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cA resqcl syl cA c2 cexp co rehalfcl syl recnd cA cc0 c1 cioc co
      wcel cA c2 cexp co c6 cdiv co cneg cA cc0 c1 cioc co wcel cA c2 cexp co
      c6 cdiv co cr wcel cA c2 cexp co c6 cdiv co cneg cr wcel cA cr wcel c2
      cn0 wcel cA c2 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel c2 cn0 wcel wa cA c2 cexp co cr wcel cA c2 cexp co c6 cdiv co cr
      wcel cA c2 reexpcl cA c2 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c2 cexp
      co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c2 cexp co c6 redivcl
      mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
      cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d 2nn0
      sylancl cA c2 cexp co c6 cdiv co renegcl syl recnd sylanc cA cc0 c1 cioc
      co wcel cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cneg cmin co c2
      cA c2 cexp co c3 cdiv co cmul co c1 cmin cA cc0 c1 cioc co wcel cA c2
      cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cneg cmin co cA c2 cexp co c2
      cdiv co cA c2 cexp co c6 cdiv co caddc co c2 cA c2 cexp co c3 cdiv co
      cmul co cA c2 cexp co c2 cdiv co cc wcel cA c2 cexp co c6 cdiv co cc wcel
      cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cneg cmin co cA c2 cexp
      co c2 cdiv co cA c2 cexp co c6 cdiv co caddc co wceq cA cc0 c1 cioc co
      wcel cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co subneg cA cc0 c1
      cioc co wcel cA c2 cexp co c2 cdiv co cA cc0 c1 cioc co wcel cA c2 cexp
      co cr wcel cA c2 cexp co c2 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cA resqcl syl cA c2 cexp co rehalfcl syl recnd cA cc0 c1 cioc co
      wcel cA c2 cexp co c6 cdiv co cA cr wcel c2 cn0 wcel cA c2 cexp co c6
      cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c2 cn0 wcel wa cA c2
      cexp co cr wcel cA c2 cexp co c6 cdiv co cr wcel cA c2 reexpcl cA c2 cexp
      co cr wcel c6 cr wcel c6 cc0 wne cA c2 cexp co c6 cdiv co cr wcel 6re c6
      6re 6pos gt0ne0ii cA c2 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d 2nn0 sylancl recnd sylanc cA cc0 c1
      cioc co wcel cA c2 cexp co cc wcel cA c2 cexp co c2 cdiv co cA c2 cexp co
      c6 cdiv co caddc co c2 cA c2 cexp co c3 cdiv co cmul co wceq cA cc0 c1
      cioc co wcel cA c2 cexp co cA cc0 c1 cioc co wcel cA cr wcel cA c2 cexp
      co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA resqcl
      syl recnd cA c2 cexp co cc wcel cA c2 cexp co c2 cdiv co cA c2 cexp co c6
      cdiv co caddc co cA c2 cexp co c1 c2 cdiv co cmul co cA c2 cexp co c1 c6
      cdiv co cmul co caddc co cA c2 cexp co c2 c3 cdiv co cmul co c2 cA c2
      cexp co c3 cdiv co cmul co cA c2 cexp co cc wcel cA c2 cexp co c2 cdiv co
      cA c2 cexp co c1 c2 cdiv co cmul co cA c2 cexp co c6 cdiv co cA c2 cexp
      co c1 c6 cdiv co cmul co caddc cA c2 cexp co cc wcel c2 cc wcel c2 cc0
      wne cA c2 cexp co c2 cdiv co cA c2 cexp co c1 c2 cdiv co cmul co wceq 2cn
      2ne0 cA c2 cexp co c2 divrec mp3an23 cA c2 cexp co cc wcel c6 cc wcel c6
      cc0 wne cA c2 cexp co c6 cdiv co cA c2 cexp co c1 c6 cdiv co cmul co wceq
      c6 6re recni c6 6re 6pos gt0ne0ii cA c2 cexp co c6 divrec mp3an23
      opreq12d cA c2 cexp co cc wcel cA c2 cexp co c1 c2 cdiv co c1 c6 cdiv co
      caddc co cmul co cA c2 cexp co c1 c2 cdiv co cmul co cA c2 cexp co c1 c6
      cdiv co cmul co caddc co cA c2 cexp co c2 c3 cdiv co cmul co cA c2 cexp
      co cc wcel c1 c2 cdiv co cc wcel c1 c6 cdiv co cc wcel cA c2 cexp co c1
      c2 cdiv co c1 c6 cdiv co caddc co cmul co cA c2 cexp co c1 c2 cdiv co
      cmul co cA c2 cexp co c1 c6 cdiv co cmul co caddc co wceq c2 2cn 2ne0
      reccli c6 c6 6re recni c6 6re 6pos gt0ne0ii reccli cA c2 cexp co c1 c2
      cdiv co c1 c6 cdiv co adddi mp3an23 c1 c2 cdiv co c1 c6 cdiv co caddc co
      c2 c3 cdiv co cA c2 cexp co cmul c1 c2 cdiv co c1 c6 cdiv co cmin co c1
      c3 cdiv co wceq c1 c2 cdiv co c1 c6 cdiv co caddc co c2 c3 cdiv co wceq
      halfpm6th pm3.27i opreq2i syl5eqr cA c2 cexp co cc wcel c2 cc wcel c3 cc
      wcel c3 cc0 wne wa cA c2 cexp co c2 c3 cdiv co cmul co c2 cA c2 cexp co
      c3 cdiv co cmul co wceq 2cn c3 cc wcel c3 cc0 wne c3 3re recni c3 3re
      3pos gt0ne0ii pm3.2i cA c2 cexp co c2 c3 div12 mp3an23 3eqtr2d syl eqtrd
      opreq2d eqtr3d cA cc0 c1 cioc co wcel c1 cA c2 cexp co c2 cdiv co cmin co
      cA c2 cexp co c6 cdiv co cneg caddc co c1 cA c2 cexp co c2 cdiv co cmin
      co c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc co cA ccos cfv clt cA cc0
      c1 cioc co wcel cA c2 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk
      csu cre cfv clt wbr c1 cA c2 cexp co c2 cdiv co cmin co cA c2 cexp co c6
      cdiv co cneg caddc co c1 cA c2 cexp co c2 cdiv co cmin co c4 cuz cfv vk
      cv cF cfv vk csu cre cfv caddc co clt wbr cA cc0 c1 cioc co wcel cA c2
      cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cre cfv clt wbr c4
      cuz cfv vk cv cF cfv vk csu cre cfv cA c2 cexp co c6 cdiv co clt wbr cA
      cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cA c2
      cexp co c6 cdiv co clt wbr cA c2 cexp co c6 cdiv co cneg c4 cuz cfv vk cv
      cF cfv vk csu cre cfv clt wbr c4 cuz cfv vk cv cF cfv vk csu cre cfv cA
      c2 cexp co c6 cdiv co clt wbr wa vy cA vj vk cF sin01bndlem2.1
      cos01bndlem2 c4 cuz cfv vk cv cF cfv vk csu cre cfv cr wcel cA c2 cexp co
      c6 cdiv co cr wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cA c2
      cexp co c6 cdiv co clt wbr cA c2 cexp co c6 cdiv co cneg c4 cuz cfv vk cv
      cF cfv vk csu cre cfv clt wbr c4 cuz cfv vk cv cF cfv vk csu cre cfv cA
      c2 cexp co c6 cdiv co clt wbr wa wb cA cc0 c1 cioc co wcel c4 cuz cfv vk
      cv cF cfv vk csu cre cfv cA c2 cexp co c6 cdiv co abslt cA cc0 c1 cioc co
      wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk
      csu cre cfv cr wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv vk cv cF
      cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF c4
      sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cc0
      c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cr wcel cA cc
      wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA recn syl
      sylancr 4nn sylancl c4 cuz cfv vk cv cF cfv vk csu recl syl cA cr wcel c2
      cn0 wcel cA c2 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel c2 cn0 wcel wa cA c2 cexp co cr wcel cA c2 cexp co c6 cdiv co cr
      wcel cA c2 reexpcl cA c2 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c2 cexp
      co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c2 cexp co c6 redivcl
      mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
      cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d 2nn0
      sylancl sylanc mpbid pm3.26d cA c2 cexp co c6 cdiv co cneg cr wcel c4 cuz
      cfv vk cv cF cfv vk csu cre cfv cr wcel c1 cA c2 cexp co c2 cdiv co cmin
      co cr wcel cA c2 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu
      cre cfv clt wbr c1 cA c2 cexp co c2 cdiv co cmin co cA c2 cexp co c6 cdiv
      co cneg caddc co c1 cA c2 cexp co c2 cdiv co cmin co c4 cuz cfv vk cv cF
      cfv vk csu cre cfv caddc co clt wbr wb cA cc0 c1 cioc co wcel cA c2 cexp
      co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cre cfv c1 cA c2 cexp
      co c2 cdiv co cmin co ltadd2 cA cc0 c1 cioc co wcel cA c2 cexp co c6 cdiv
      co cr wcel cA c2 cexp co c6 cdiv co cneg cr wcel cA cr wcel c2 cn0 wcel
      cA c2 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c2 cn0
      wcel wa cA c2 cexp co cr wcel cA c2 cexp co c6 cdiv co cr wcel cA c2
      reexpcl cA c2 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c2 cexp co c6 cdiv
      co cr wcel 6re c6 6re 6pos gt0ne0ii cA c2 cexp co c6 redivcl mp3an23 syl
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1
      cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d 2nn0 sylancl cA c2
      cexp co c6 cdiv co renegcl syl cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF
      cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cr wcel ci cA
      cmul co cc wcel c4 cn wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel cA cc0
      c1 cioc co wcel vy ci cA cmul co vj vk cF c4 sin01bndlem2.1 eftlcl ci cc
      wcel cA cc wcel ci cA cmul co cc wcel cA cc0 c1 cioc co wcel ci cA mulcl
      axicn cA cc0 c1 cioc co wcel cA cr wcel cA cc wcel cA cc0 c1 cioc co wcel
      cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
      elioc2 mp2an biimpi 3simp1d cA recn syl sylancr 4nn sylancl c4 cuz cfv vk
      cv cF cfv vk csu recl syl c1 cr wcel cA c2 cexp co c2 cdiv co cr wcel c1
      cA c2 cexp co c2 cdiv co cmin co cr wcel cA cc0 c1 cioc co wcel c1 cA c2
      cexp co c2 cdiv co resubcl 1re cA cc0 c1 cioc co wcel cA c2 cexp co cr
      wcel cA c2 cexp co c2 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA
      resqcl syl cA c2 cexp co rehalfcl syl sylancr syl3anc mpbid cA cc0 c1
      cioc co wcel cA cr wcel cA ccos cfv c1 cA c2 cexp co c2 cdiv co cmin co
      c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc co wceq cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d vy cA vj vk cF sin01bndlem2.1 recos4p
      syl breqtrrd eqbrtrrd cA cc0 c1 cioc co wcel cA ccos cfv c1 cA c2 cexp co
      c2 cdiv co cmin co cA c2 cexp co c6 cdiv co caddc co c1 cA c2 cexp co c3
      cdiv co cmin co clt cA cc0 c1 cioc co wcel cA ccos cfv c1 cA c2 cexp co
      c2 cdiv co cmin co c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc co c1 cA
      c2 cexp co c2 cdiv co cmin co cA c2 cexp co c6 cdiv co caddc co clt cA
      cc0 c1 cioc co wcel cA cr wcel cA ccos cfv c1 cA c2 cexp co c2 cdiv co
      cmin co c4 cuz cfv vk cv cF cfv vk csu cre cfv caddc co wceq cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
      cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
      1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d vy cA vj vk cF sin01bndlem2.1
      recos4p syl cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv
      cA c2 cexp co c6 cdiv co clt wbr c1 cA c2 cexp co c2 cdiv co cmin co c4
      cuz cfv vk cv cF cfv vk csu cre cfv caddc co c1 cA c2 cexp co c2 cdiv co
      cmin co cA c2 cexp co c6 cdiv co caddc co clt wbr cA cc0 c1 cioc co wcel
      cA c2 cexp co c6 cdiv co cneg c4 cuz cfv vk cv cF cfv vk csu cre cfv clt
      wbr c4 cuz cfv vk cv cF cfv vk csu cre cfv cA c2 cexp co c6 cdiv co clt
      wbr cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cabs
      cfv cA c2 cexp co c6 cdiv co clt wbr cA c2 cexp co c6 cdiv co cneg c4 cuz
      cfv vk cv cF cfv vk csu cre cfv clt wbr c4 cuz cfv vk cv cF cfv vk csu
      cre cfv cA c2 cexp co c6 cdiv co clt wbr wa vy cA vj vk cF sin01bndlem2.1
      cos01bndlem2 c4 cuz cfv vk cv cF cfv vk csu cre cfv cr wcel cA c2 cexp co
      c6 cdiv co cr wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cabs cfv cA c2
      cexp co c6 cdiv co clt wbr cA c2 cexp co c6 cdiv co cneg c4 cuz cfv vk cv
      cF cfv vk csu cre cfv clt wbr c4 cuz cfv vk cv cF cfv vk csu cre cfv cA
      c2 cexp co c6 cdiv co clt wbr wa wb cA cc0 c1 cioc co wcel c4 cuz cfv vk
      cv cF cfv vk csu cre cfv cA c2 cexp co c6 cdiv co abslt cA cc0 c1 cioc co
      wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel c4 cuz cfv vk cv cF cfv vk
      csu cre cfv cr wcel ci cA cmul co cc wcel c4 cn wcel c4 cuz cfv vk cv cF
      cfv vk csu cc wcel cA cc0 c1 cioc co wcel vy ci cA cmul co vj vk cF c4
      sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel ci cA cmul co cc wcel cA cc0
      c1 cioc co wcel ci cA mulcl axicn cA cc0 c1 cioc co wcel cA cr wcel cA cc
      wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA
      cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr
      wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
      cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA recn syl
      sylancr 4nn sylancl c4 cuz cfv vk cv cF cfv vk csu recl syl cA cr wcel c2
      cn0 wcel cA c2 cexp co c6 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel c2 cn0 wcel wa cA c2 cexp co cr wcel cA c2 cexp co c6 cdiv co cr
      wcel cA c2 reexpcl cA c2 cexp co cr wcel c6 cr wcel c6 cc0 wne cA c2 cexp
      co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA c2 cexp co c6 redivcl
      mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
      wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
      cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d 2nn0
      sylancl sylanc mpbid pm3.27d c4 cuz cfv vk cv cF cfv vk csu cre cfv cr
      wcel cA c2 cexp co c6 cdiv co cr wcel c1 cA c2 cexp co c2 cdiv co cmin co
      cr wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cA c2 cexp co c6 cdiv co
      clt wbr c1 cA c2 cexp co c2 cdiv co cmin co c4 cuz cfv vk cv cF cfv vk
      csu cre cfv caddc co c1 cA c2 cexp co c2 cdiv co cmin co cA c2 cexp co c6
      cdiv co caddc co clt wbr wb cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF
      cfv vk csu cre cfv cA c2 cexp co c6 cdiv co c1 cA c2 cexp co c2 cdiv co
      cmin co ltadd2 cA cc0 c1 cioc co wcel c4 cuz cfv vk cv cF cfv vk csu cc
      wcel c4 cuz cfv vk cv cF cfv vk csu cre cfv cr wcel ci cA cmul co cc wcel
      c4 cn wcel c4 cuz cfv vk cv cF cfv vk csu cc wcel cA cc0 c1 cioc co wcel
      vy ci cA cmul co vj vk cF c4 sin01bndlem2.1 eftlcl ci cc wcel cA cc wcel
      ci cA cmul co cc wcel cA cc0 c1 cioc co wcel ci cA mulcl axicn cA cc0 c1
      cioc co wcel cA cr wcel cA cc wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
      biimpi 3simp1d cA recn syl sylancr 4nn sylancl c4 cuz cfv vk cv cF cfv vk
      csu recl syl cA cr wcel c2 cn0 wcel cA c2 cexp co c6 cdiv co cr wcel cA
      cc0 c1 cioc co wcel cA cr wcel c2 cn0 wcel wa cA c2 cexp co cr wcel cA c2
      cexp co c6 cdiv co cr wcel cA c2 reexpcl cA c2 cexp co cr wcel c6 cr wcel
      c6 cc0 wne cA c2 cexp co c6 cdiv co cr wcel 6re c6 6re 6pos gt0ne0ii cA
      c2 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0
      cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
      cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
      biimpi 3simp1d 2nn0 sylancl c1 cr wcel cA c2 cexp co c2 cdiv co cr wcel
      c1 cA c2 cexp co c2 cdiv co cmin co cr wcel cA cc0 c1 cioc co wcel c1 cA
      c2 cexp co c2 cdiv co resubcl 1re cA cc0 c1 cioc co wcel cA c2 cexp co cr
      wcel cA c2 cexp co c2 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
      w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA
      resqcl syl cA c2 cexp co rehalfcl syl sylancr syl3anc mpbid eqbrtrd cA
      cc0 c1 cioc co wcel c1 cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co
      cmin co cmin co c1 cA c2 cexp co c2 cdiv co cmin co cA c2 cexp co c6 cdiv
      co caddc co c1 cA c2 cexp co c3 cdiv co cmin co cA c2 cexp co c2 cdiv co
      cc wcel cA c2 cexp co c6 cdiv co cc wcel c1 cA c2 cexp co c2 cdiv co cA
      c2 cexp co c6 cdiv co cmin co cmin co c1 cA c2 cexp co c2 cdiv co cmin co
      cA c2 cexp co c6 cdiv co caddc co wceq cA cc0 c1 cioc co wcel c1 cc wcel
      cA c2 cexp co c2 cdiv co cc wcel cA c2 cexp co c6 cdiv co cc wcel c1 cA
      c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cmin co cmin co c1 cA c2
      cexp co c2 cdiv co cmin co cA c2 cexp co c6 cdiv co caddc co wceq ax1cn
      c1 cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co subsub mp3an1 cA cc0
      c1 cioc co wcel cA c2 cexp co c2 cdiv co cA cc0 c1 cioc co wcel cA c2
      cexp co cr wcel cA c2 cexp co c2 cdiv co cr wcel cA cc0 c1 cioc co wcel
      cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
      clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
      c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
      3simp1d cA resqcl syl cA c2 cexp co rehalfcl syl recnd cA cc0 c1 cioc co
      wcel cA c2 cexp co c6 cdiv co cA cr wcel c2 cn0 wcel cA c2 cexp co c6
      cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel c2 cn0 wcel wa cA c2
      cexp co cr wcel cA c2 cexp co c6 cdiv co cr wcel cA c2 reexpcl cA c2 cexp
      co cr wcel c6 cr wcel c6 cc0 wne cA c2 cexp co c6 cdiv co cr wcel 6re c6
      6re 6pos gt0ne0ii cA c2 cexp co c6 redivcl mp3an23 syl cA cc0 c1 cioc co
      wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
      cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
      c1 cA elioc2 mp2an biimpi 3simp1d 2nn0 sylancl recnd sylanc cA cc0 c1
      cioc co wcel cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cmin co cA
      c2 cexp co c3 cdiv co c1 cmin cA cc0 c1 cioc co wcel cA c2 cexp co cc
      wcel cA c2 cexp co c2 cdiv co cA c2 cexp co c6 cdiv co cmin co cA c2 cexp
      co c3 cdiv co wceq cA cc0 c1 cioc co wcel cA c2 cexp co cA cc0 c1 cioc co
      wcel cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel
      cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
      wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr
      wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
      biimpi 3simp1d cA resqcl syl recnd cA c2 cexp co cc wcel cA c2 cexp co c1
      c3 cdiv co cmul co cA c2 cexp co c1 c2 cdiv co cmul co cA c2 cexp co c1
      c6 cdiv co cmul co cmin co cA c2 cexp co c3 cdiv co cA c2 cexp co c2 cdiv
      co cA c2 cexp co c6 cdiv co cmin co cA c2 cexp co cc wcel cA c2 cexp co
      c1 c2 cdiv co c1 c6 cdiv co cmin co cmul co cA c2 cexp co c1 c2 cdiv co
      cmul co cA c2 cexp co c1 c6 cdiv co cmul co cmin co cA c2 cexp co c1 c3
      cdiv co cmul co cA c2 cexp co cc wcel c1 c2 cdiv co cc wcel c1 c6 cdiv co
      cc wcel cA c2 cexp co c1 c2 cdiv co c1 c6 cdiv co cmin co cmul co cA c2
      cexp co c1 c2 cdiv co cmul co cA c2 cexp co c1 c6 cdiv co cmul co cmin co
      wceq c2 2cn 2ne0 reccli c6 c6 6re recni c6 6re 6pos gt0ne0ii reccli cA c2
      cexp co c1 c2 cdiv co c1 c6 cdiv co subdi mp3an23 c1 c2 cdiv co c1 c6
      cdiv co cmin co c1 c3 cdiv co cA c2 cexp co cmul c1 c2 cdiv co c1 c6 cdiv
      co cmin co c1 c3 cdiv co wceq c1 c2 cdiv co c1 c6 cdiv co caddc co c2 c3
      cdiv co wceq halfpm6th pm3.26i opreq2i syl5eqr cA c2 cexp co cc wcel c3
      cc wcel c3 cc0 wne cA c2 cexp co c3 cdiv co cA c2 cexp co c1 c3 cdiv co
      cmul co wceq c3 3re recni c3 3re 3pos gt0ne0ii cA c2 cexp co c3 divrec
      mp3an23 cA c2 cexp co cc wcel cA c2 cexp co c2 cdiv co cA c2 cexp co c1
      c2 cdiv co cmul co cA c2 cexp co c6 cdiv co cA c2 cexp co c1 c6 cdiv co
      cmul co cmin cA c2 cexp co cc wcel c2 cc wcel c2 cc0 wne cA c2 cexp co c2
      cdiv co cA c2 cexp co c1 c2 cdiv co cmul co wceq 2cn 2ne0 cA c2 cexp co
      c2 divrec mp3an23 cA c2 cexp co cc wcel c6 cc wcel c6 cc0 wne cA c2 cexp
      co c6 cdiv co cA c2 cexp co c1 c6 cdiv co cmul co wceq c6 6re recni c6
      6re 6pos gt0ne0ii cA c2 cexp co c6 divrec mp3an23 opreq12d 3eqtr4rd syl
      opreq2d eqtr3d breqtrd jca $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)
  $}

  ${
    $d A j y $.

    $( Bounds on the sine of a positive real number less than or equal to 1.
       (Contributed by Paul Chapman, 19-Jan-2008.) $)
    sin01bnd $p |- ( A e. ( 0 (,] 1 ) ->
        ( ( A - ( ( A ^ 3 ) / 3 ) ) < ( sin ` A ) /\ ( sin ` A ) < A ) ) $=
      vy cA vj vj cv cn0 wcel vy cv ci cA cmul co vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv ci cA cmul co vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid sin01bndlem3 $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)

    $( Bounds on the cosine of a positive real number less than or equal to 1.
       (Contributed by Paul Chapman, 19-Jan-2008.) $)
    cos01bnd $p |- ( A e. ( 0 (,] 1 ) ->
                     ( ( 1 - ( 2 x. ( ( A ^ 2 ) / 3 ) ) ) < ( cos ` A ) /\
                       ( cos ` A ) < ( 1 - ( ( A ^ 2 ) / 3 ) ) ) ) $=
      vy cA vj vj cv cn0 wcel vy cv ci cA cmul co vj cv cexp co vj cv cfa cfv
      cdiv co wceq wa vj vy copab vj cv cn0 wcel vy cv ci cA cmul co vj cv cexp
      co vj cv cfa cfv cdiv co wceq wa vj vy copab eqid cos01bndlem3 $.
      $( [19-Jan-2008] $) $( [19-Jan-2008] $)
  $}

  $( Bounds on the cosine of 1.  (Contributed by Paul Chapman, 19-Jan-2008.) $)
  cos1bnd $p |- ( ( 1 / 3 ) < ( cos ` 1 ) /\ ( cos ` 1 ) < ( 2 / 3 ) ) $=
    c1 c3 cdiv co c1 ccos cfv clt wbr c1 ccos cfv c2 c3 cdiv co clt wbr c1 c2
    c1 c2 cexp co c3 cdiv co cmul co cmin co c1 c3 cdiv co c1 ccos cfv clt c1
    c2 c1 c2 cexp co c3 cdiv co cmul co cmin co c1 c2 c3 cdiv co cmin co c1 c3
    cdiv co c2 c1 c2 cexp co c3 cdiv co cmul co c2 c3 cdiv co c1 cmin c2 c1 c2
    cexp co c3 cdiv co cmul co c2 c1 c3 cdiv co cmul co c2 c3 cdiv co c1 c2
    cexp co c3 cdiv co c1 c3 cdiv co c2 cmul c1 c2 cexp co c1 c3 cdiv sq1
    opreq1i opreq2i c2 c3 2cn c3 3nn nncni c3 3nn nnne0i divreci eqtr4i opreq2i
    c1 c2 c3 cdiv co c1 c3 cdiv co ax1cn c2 c3 2cn c3 3nn nncni c3 3nn nnne0i
    divcli c3 c3 3nn nncni c3 3nn nnne0i reccli c3 c3 cdiv co c2 c1 caddc co c3
    cdiv co c1 c2 c3 cdiv co c1 c3 cdiv co caddc co c3 c2 c1 caddc co c3 cdiv
    df-3 opreq1i c3 c3 3nn nncni c3 3nn nnne0i dividi c2 c1 c3 2cn ax1cn c3 3nn
    nncni c3 3nn nnne0i divdiri 3eqtr3ri subaddrii eqtri c1 c2 c1 c2 cexp co c3
    cdiv co cmul co cmin co c1 ccos cfv clt wbr c1 ccos cfv c1 c1 c2 cexp co c3
    cdiv co cmin co clt wbr c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr c1 c2 c1 c2
    cexp co c3 cdiv co cmul co cmin co c1 ccos cfv clt wbr c1 ccos cfv c1 c1 c2
    cexp co c3 cdiv co cmin co clt wbr wa 1re lt01 c1 1re leidi c1 cr wcel cc0
    c1 clt wbr c1 c1 cle wbr w3a c1 cc0 c1 cioc co wcel c1 c2 c1 c2 cexp co c3
    cdiv co cmul co cmin co c1 ccos cfv clt wbr c1 ccos cfv c1 c1 c2 cexp co c3
    cdiv co cmin co clt wbr wa cc0 cr wcel c1 cr wcel c1 cc0 c1 cioc co wcel c1
    cr wcel cc0 c1 clt wbr c1 c1 cle wbr w3a wb 0re 1re cc0 c1 c1 elioc2 mp2an
    c1 cos01bnd sylbir mp3an pm3.26i eqbrtrri c1 ccos cfv c1 c1 c2 cexp co c3
    cdiv co cmin co c2 c3 cdiv co clt c1 c2 c1 c2 cexp co c3 cdiv co cmul co
    cmin co c1 ccos cfv clt wbr c1 ccos cfv c1 c1 c2 cexp co c3 cdiv co cmin co
    clt wbr c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr c1 c2 c1 c2 cexp co c3 cdiv
    co cmul co cmin co c1 ccos cfv clt wbr c1 ccos cfv c1 c1 c2 cexp co c3 cdiv
    co cmin co clt wbr wa 1re lt01 c1 1re leidi c1 cr wcel cc0 c1 clt wbr c1 c1
    cle wbr w3a c1 cc0 c1 cioc co wcel c1 c2 c1 c2 cexp co c3 cdiv co cmul co
    cmin co c1 ccos cfv clt wbr c1 ccos cfv c1 c1 c2 cexp co c3 cdiv co cmin co
    clt wbr wa cc0 cr wcel c1 cr wcel c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1
    clt wbr c1 c1 cle wbr w3a wb 0re 1re cc0 c1 c1 elioc2 mp2an c1 cos01bnd
    sylbir mp3an pm3.27i c1 c1 c2 cexp co c3 cdiv co cmin co c1 c1 c3 cdiv co
    cmin co c2 c3 cdiv co c1 c2 cexp co c3 cdiv co c1 c3 cdiv co c1 cmin c1 c2
    cexp co c1 c3 cdiv sq1 opreq1i opreq2i c1 c1 c3 cdiv co cmin co c2 c3 cdiv
    co wceq c2 c3 cdiv co c1 c3 cdiv co caddc co c1 wceq c3 c3 cdiv co c2 c1
    caddc co c3 cdiv co c1 c2 c3 cdiv co c1 c3 cdiv co caddc co c3 c2 c1 caddc
    co c3 cdiv df-3 opreq1i c3 c3 3nn nncni c3 3nn nnne0i dividi c2 c1 c3 2cn
    ax1cn c3 3nn nncni c3 3nn nnne0i divdiri 3eqtr3ri c1 c1 c3 cdiv co c2 c3
    cdiv co ax1cn c3 c3 3nn nncni c3 3nn nnne0i reccli c2 c3 2cn c3 3nn nncni
    c3 3nn nnne0i divcli subadd2i mpbir eqtri breqtri pm3.2i $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( Bounds on the cosine of 2.  (Contributed by Paul Chapman, 19-Jan-2008.) $)
  cos2bnd $p |- ( -u ( 7 / 9 ) < ( cos ` 2 ) /\
                     ( cos ` 2 ) < -u ( 1 / 9 ) ) $=
    c7 c9 cdiv co cneg c2 ccos cfv clt wbr c2 ccos cfv c1 c9 cdiv co cneg clt
    wbr c7 c9 cdiv co cneg c2 c1 ccos cfv c2 cexp co cmul co c1 cmin co c2 ccos
    cfv clt c2 c9 cdiv co c1 cmin co c7 c9 cdiv co cneg c2 c1 ccos cfv c2 cexp
    co cmul co c1 cmin co clt c2 c9 cdiv co c1 cmin co c7 cneg c9 cdiv co c7 c9
    cdiv co cneg c2 c9 cmin co c9 cdiv co c2 c9 cdiv co c9 c9 cdiv co cmin co
    c7 cneg c9 cdiv co c2 c9 cdiv co c1 cmin co c2 cc wcel c9 cc wcel c9 cc
    wcel c9 cc0 wne wa c2 c9 cmin co c9 cdiv co c2 c9 cdiv co c9 c9 cdiv co
    cmin co wceq 2cn c9 9re recni c9 cc wcel c9 cc0 wne c9 9re recni c9 9re
    9pos gt0ne0ii pm3.2i c2 c9 c9 divsubdir mp3an c2 c9 cmin co c7 cneg c9 cdiv
    c9 c2 cmin co cneg c2 c9 cmin co c7 cneg c9 c2 c9 9re recni 2cn negsubdi2i
    c9 c2 cmin co c7 c9 c2 cmin co c7 wceq c7 c2 caddc co c9 wceq c7 c2 caddc
    co c8 c1 caddc co c9 c7 c1 caddc co c1 caddc co c7 c1 c1 caddc co caddc co
    c8 c1 caddc co c7 c2 caddc co c7 c1 c1 c7 7re recni ax1cn ax1cn addassi c8
    c7 c1 caddc co c1 caddc df-8 opreq1i c2 c1 c1 caddc co c7 caddc df-2
    opreq2i 3eqtr4ri df-9 eqtr4i c9 c2 c7 c9 9re recni 2cn c7 7re recni
    subadd2i mpbir negeqi eqtr3i opreq1i c9 c9 cdiv co c1 c2 c9 cdiv co cmin c9
    c9 9re recni c9 9re 9pos gt0ne0ii dividi opreq2i 3eqtr3ri c7 cc wcel c9 cc
    wcel c9 cc0 wne c7 c9 cdiv co cneg c7 cneg c9 cdiv co wceq c7 7re recni c9
    9re recni c9 9re 9pos gt0ne0ii c7 c9 divneg mp3an eqtr4i c2 c9 cdiv co c2
    c1 ccos cfv c2 cexp co cmul co clt wbr c2 c9 cdiv co c1 cmin co c2 c1 ccos
    cfv c2 cexp co cmul co c1 cmin co clt wbr c2 c1 c9 cdiv co cmul co c2 c9
    cdiv co c2 c1 ccos cfv c2 cexp co cmul co clt c2 c1 cmul co c9 cdiv co c2
    c1 c9 cdiv co cmul co c2 c9 cdiv co c2 c1 c9 2cn ax1cn c9 9re recni c9 9re
    9pos gt0ne0ii divassi c2 c1 cmul co c2 c9 cdiv c2 2cn mulid1i opreq1i
    eqtr3i c1 c9 cdiv co c1 ccos cfv c2 cexp co clt wbr c2 c1 c9 cdiv co cmul
    co c2 c1 ccos cfv c2 cexp co cmul co clt wbr c1 c3 cdiv co c2 cexp co c1 c9
    cdiv co c1 ccos cfv c2 cexp co clt c1 c3 cdiv co c2 cexp co c1 c2 cexp co
    c3 c2 cexp co cdiv co c1 c9 cdiv co c1 c3 ax1cn c3 3re recni c3 3nn nnne0i
    sqdivi c1 c2 cexp co c1 c3 c2 cexp co c9 cdiv sq1 sq3 opreq12i eqtri c1 c3
    cdiv co c1 ccos cfv clt wbr c1 c3 cdiv co c2 cexp co c1 ccos cfv c2 cexp co
    clt wbr c1 c3 cdiv co c1 ccos cfv clt wbr c1 ccos cfv c2 c3 cdiv co clt wbr
    cos1bnd pm3.26i cc0 c1 c3 cdiv co cle wbr cc0 c1 ccos cfv cle wbr c1 c3
    cdiv co c1 ccos cfv clt wbr c1 c3 cdiv co c2 cexp co c1 ccos cfv c2 cexp co
    clt wbr wb cc0 c1 cle wbr cc0 c3 clt wbr cc0 c1 c3 cdiv co cle wbr c1 1nn0
    nn0ge0i c3 3nn nngt0i c1 c3 1re 3re divge0i mp2an cc0 c1 ccos cfv 0re c1 cr
    wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp cc0 c1 c3 cdiv co cle wbr c1
    c3 cdiv co c1 ccos cfv clt wbr cc0 c1 ccos cfv clt wbr cc0 c1 cle wbr cc0
    c3 clt wbr cc0 c1 c3 cdiv co cle wbr c1 1nn0 nn0ge0i c3 3nn nngt0i c1 c3
    1re 3re divge0i mp2an c1 c3 cdiv co c1 ccos cfv clt wbr c1 ccos cfv c2 c3
    cdiv co clt wbr cos1bnd pm3.26i cc0 c1 c3 cdiv co c1 ccos cfv 0re c3 3re c3
    3nn nnne0i rereccli c1 cr wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp
    lelttri mp2an ltleii c1 c3 cdiv co c1 ccos cfv c3 3re c3 3nn nnne0i
    rereccli c1 cr wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp lt2sqi mp2an
    mpbi eqbrtrri cc0 c2 clt wbr c1 c9 cdiv co c1 ccos cfv c2 cexp co clt wbr
    c2 c1 c9 cdiv co cmul co c2 c1 ccos cfv c2 cexp co cmul co clt wbr wb 2pos
    c1 c9 cdiv co c1 ccos cfv c2 cexp co c2 c9 9re c9 9re 9pos gt0ne0ii
    rereccli c1 ccos cfv c1 cr wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp
    resqcli 2re ltmul2i ax-mp mpbi eqbrtrri c2 c9 cdiv co cr wcel c2 c1 ccos
    cfv c2 cexp co cmul co cr wcel c1 cr wcel c2 c9 cdiv co c2 c1 ccos cfv c2
    cexp co cmul co clt wbr c2 c9 cdiv co c1 cmin co c2 c1 ccos cfv c2 cexp co
    cmul co c1 cmin co clt wbr wb c2 c9 2re 9re c9 9re 9pos gt0ne0ii redivcli
    c2 c1 ccos cfv c2 cexp co 2re c1 ccos cfv c1 cr wcel c1 ccos cfv cr wcel
    1re c1 recoscl ax-mp resqcli remulcli 1re c2 c9 cdiv co c2 c1 ccos cfv c2
    cexp co cmul co c1 ltsub1 mp3an mpbi eqbrtrri c2 c1 cmul co ccos cfv c2
    ccos cfv c2 c1 ccos cfv c2 cexp co cmul co c1 cmin co c2 c1 cmul co c2 ccos
    c2 2cn mulid1i fveq2i c1 ax1cn cos2OLD eqtr3i breqtrri c2 ccos cfv c2 c1
    ccos cfv c2 cexp co cmul co c1 cmin co c1 c9 cdiv co cneg clt c2 c1 cmul co
    ccos cfv c2 ccos cfv c2 c1 ccos cfv c2 cexp co cmul co c1 cmin co c2 c1
    cmul co c2 ccos c2 2cn mulid1i fveq2i c1 ax1cn cos2OLD eqtr3i c2 c1 ccos
    cfv c2 cexp co cmul co c1 cmin co c8 c9 cdiv co c1 cmin co c1 c9 cdiv co
    cneg clt c2 c1 ccos cfv c2 cexp co cmul co c8 c9 cdiv co clt wbr c2 c1 ccos
    cfv c2 cexp co cmul co c1 cmin co c8 c9 cdiv co c1 cmin co clt wbr c2 c1
    ccos cfv c2 cexp co cmul co c2 c4 c9 cdiv co cmul co c8 c9 cdiv co clt c1
    ccos cfv c2 cexp co c4 c9 cdiv co clt wbr c2 c1 ccos cfv c2 cexp co cmul co
    c2 c4 c9 cdiv co cmul co clt wbr c1 ccos cfv c2 cexp co c2 c3 cdiv co c2
    cexp co c4 c9 cdiv co clt c1 ccos cfv c2 c3 cdiv co clt wbr c1 ccos cfv c2
    cexp co c2 c3 cdiv co c2 cexp co clt wbr c1 c3 cdiv co c1 ccos cfv clt wbr
    c1 ccos cfv c2 c3 cdiv co clt wbr cos1bnd pm3.27i cc0 c1 ccos cfv cle wbr
    cc0 c2 c3 cdiv co cle wbr c1 ccos cfv c2 c3 cdiv co clt wbr c1 ccos cfv c2
    cexp co c2 c3 cdiv co c2 cexp co clt wbr wb cc0 c1 ccos cfv 0re c1 cr wcel
    c1 ccos cfv cr wcel 1re c1 recoscl ax-mp cc0 c1 c3 cdiv co cle wbr c1 c3
    cdiv co c1 ccos cfv clt wbr cc0 c1 ccos cfv clt wbr cc0 c1 cle wbr cc0 c3
    clt wbr cc0 c1 c3 cdiv co cle wbr c1 1nn0 nn0ge0i c3 3nn nngt0i c1 c3 1re
    3re divge0i mp2an c1 c3 cdiv co c1 ccos cfv clt wbr c1 ccos cfv c2 c3 cdiv
    co clt wbr cos1bnd pm3.26i cc0 c1 c3 cdiv co c1 ccos cfv 0re c3 3re c3 3nn
    nnne0i rereccli c1 cr wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp lelttri
    mp2an ltleii cc0 c2 cle wbr cc0 c3 clt wbr cc0 c2 c3 cdiv co cle wbr c2
    2nn0 nn0ge0i c3 3nn nngt0i c2 c3 2re 3re divge0i mp2an c1 ccos cfv c2 c3
    cdiv co c1 cr wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp c2 c3 2re 3re
    c3 3nn nnne0i redivcli lt2sqi mp2an mpbi c2 c3 cdiv co c2 cexp co c2 c2
    cexp co c3 c2 cexp co cdiv co c4 c9 cdiv co c2 c3 2cn c3 3re recni c3 3nn
    nnne0i sqdivi c2 c2 cexp co c4 c3 c2 cexp co c9 cdiv sq2 sq3 opreq12i eqtri
    breqtri cc0 c2 clt wbr c1 ccos cfv c2 cexp co c4 c9 cdiv co clt wbr c2 c1
    ccos cfv c2 cexp co cmul co c2 c4 c9 cdiv co cmul co clt wbr wb 2pos c1
    ccos cfv c2 cexp co c4 c9 cdiv co c2 c1 ccos cfv c1 cr wcel c1 ccos cfv cr
    wcel 1re c1 recoscl ax-mp resqcli c4 c9 4re 9re c9 9re 9pos gt0ne0ii
    redivcli 2re ltmul2i ax-mp mpbi c2 c4 cmul co c9 cdiv co c2 c4 c9 cdiv co
    cmul co c8 c9 cdiv co c2 c4 c9 2cn c4 4re recni c9 9re recni c9 9re 9pos
    gt0ne0ii divassi c2 c4 cmul co c8 c9 cdiv c2 c4 cmul co c4 c2 cmul co c8 c2
    c4 2cn c4 4re recni mulcomi 4t2e8 eqtri opreq1i eqtr3i breqtri c2 c1 ccos
    cfv c2 cexp co cmul co cr wcel c8 c9 cdiv co cr wcel c1 cr wcel c2 c1 ccos
    cfv c2 cexp co cmul co c8 c9 cdiv co clt wbr c2 c1 ccos cfv c2 cexp co cmul
    co c1 cmin co c8 c9 cdiv co c1 cmin co clt wbr wb c2 c1 ccos cfv c2 cexp co
    2re c1 ccos cfv c1 cr wcel c1 ccos cfv cr wcel 1re c1 recoscl ax-mp resqcli
    remulcli c8 c9 8re 9re c9 9re 9pos gt0ne0ii redivcli 1re c2 c1 ccos cfv c2
    cexp co cmul co c8 c9 cdiv co c1 ltsub1 mp3an mpbi c8 c9 cdiv co c9 c9 cdiv
    co cmin co c8 c9 cdiv co c1 cmin co c1 c9 cdiv co cneg c9 c9 cdiv co c1 c8
    c9 cdiv co cmin c9 c9 9re recni c9 9re 9pos gt0ne0ii dividi opreq2i c1 c9
    cdiv co cneg c1 cneg c9 cdiv co c8 c9 cmin co c9 cdiv co c8 c9 cdiv co c9
    c9 cdiv co cmin co c1 cc wcel c9 cc wcel c9 cc0 wne c1 c9 cdiv co cneg c1
    cneg c9 cdiv co wceq ax1cn c9 9re recni c9 9re 9pos gt0ne0ii c1 c9 divneg
    mp3an c8 c9 cmin co c1 cneg c9 cdiv c9 c8 cmin co cneg c8 c9 cmin co c1
    cneg c9 c8 c9 9re recni c8 8re recni negsubdi2i c9 c8 cmin co c1 c9 c8 cmin
    co c1 wceq c8 c1 caddc co c9 wceq c9 c8 c1 caddc co df-9 eqcomi c9 c8 c1 c9
    9re recni c8 8re recni ax1cn subaddi mpbir negeqi eqtr3i opreq1i c8 cc wcel
    c9 cc wcel c9 cc wcel c9 cc0 wne wa c8 c9 cmin co c9 cdiv co c8 c9 cdiv co
    c9 c9 cdiv co cmin co wceq c8 8re recni c9 9re recni c9 cc wcel c9 cc0 wne
    c9 9re recni c9 9re 9pos gt0ne0ii pm3.2i c8 c9 c9 divsubdir mp3an 3eqtr2ri
    eqtr3i breqtri eqbrtri pm3.2i $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The sine of a positive real number less than or equal to 1 is positive.
     (Contributed by Paul Chapman, 19-Jan-2008.) $)
  sin01gt0 $p |- ( A e. ( 0 (,] 1 ) -> 0 < ( sin ` A ) ) $=
    cA cc0 c1 cioc co wcel cc0 cA cA c3 cexp co c3 cdiv co cmin co clt wbr cA
    cA c3 cexp co c3 cdiv co cmin co cA csin cfv clt wbr cc0 cA csin cfv clt
    wbr cA cc0 c1 cioc co wcel cA c3 cexp co c3 cdiv co cA clt wbr cc0 cA cA c3
    cexp co c3 cdiv co cmin co clt wbr cA cc0 c1 cioc co wcel cA c3 cexp co c3
    cdiv co cA c3 cexp co cA cA cc0 c1 cioc co wcel cA c3 cexp co cr wcel cA c3
    cexp co c3 cdiv co cr wcel cA cr wcel c3 cn0 wcel cA c3 cexp co cr wcel cA
    cc0 c1 cioc co wcel cA c3 reexpcl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
    clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
    3simp1d c3 3nn nnnn0i sylancl cA c3 cexp co cr wcel c3 cr wcel c3 cc0 wne
    cA c3 cexp co c3 cdiv co cr wcel 3re c3 3nn nnne0i cA c3 cexp co c3 redivcl
    mp3an23 syl cA cr wcel c3 cn0 wcel cA c3 cexp co cr wcel cA cc0 c1 cioc co
    wcel cA c3 reexpcl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
    cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
    cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn
    nnnn0i sylancl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
    wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0
    cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
    cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA cc0 c1 cioc
    co wcel cA c3 cexp co c3 cdiv co cA c3 cexp co c1 cdiv co cA c3 cexp co clt
    cA c3 cexp co cr wcel cc0 cA c3 cexp co clt wbr cA c3 cexp co c3 cdiv co cA
    c3 cexp co c1 cdiv co clt wbr cA cc0 c1 cioc co wcel c1 cr wcel c3 cr wcel
    cA c3 cexp co cr wcel cc0 cA c3 cexp co clt wbr cA c3 cexp co c3 cdiv co cA
    c3 cexp co c1 cdiv co clt wbr wi 1re 3re cc0 cA c3 cexp co clt wbr c1 cr
    wcel c3 cr wcel cA c3 cexp co cr wcel w3a cA c3 cexp co c3 cdiv co cA c3
    cexp co c1 cdiv co clt wbr cc0 c1 clt wbr cc0 c3 clt wbr cc0 cA c3 cexp co
    clt wbr c1 cr wcel c3 cr wcel cA c3 cexp co cr wcel w3a cA c3 cexp co c3
    cdiv co cA c3 cexp co c1 cdiv co clt wbr wi lt01 3pos c1 cr wcel c3 cr wcel
    cA c3 cexp co cr wcel w3a cc0 c1 clt wbr cc0 c3 clt wbr cc0 cA c3 cexp co
    clt wbr w3a cA c3 cexp co c3 cdiv co cA c3 cexp co c1 cdiv co clt wbr c1 cr
    wcel c3 cr wcel cA c3 cexp co cr wcel w3a cc0 c1 clt wbr cc0 c3 clt wbr cc0
    cA c3 cexp co clt wbr w3a wa c1 c3 clt wbr cA c3 cexp co c3 cdiv co cA c3
    cexp co c1 cdiv co clt wbr cc0 c1 caddc co c2 c1 caddc co c1 c3 clt cc0 c2
    clt wbr cc0 c1 caddc co c2 c1 caddc co clt wbr 2pos cc0 c2 c1 0re 2re 1re
    ltadd1i mpbi c1 ax1cn addid2i c3 c2 c1 caddc co df-3 eqcomi 3brtr3i c1 c3
    cA c3 cexp co ltdiv2 mpbii expcom mp3an12 com12 mp3an12 cA cr wcel c3 cn0
    wcel cA c3 cexp co cr wcel cA cc0 c1 cioc co wcel cA c3 reexpcl cA cc0 c1
    cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel
    cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0
    c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0
    c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl cA cc0 c1 cioc co
    wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cA c3 cexp co clt wbr
    cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an cA cr wcel cc0 cA clt wbr
    cc0 cA c3 cexp co clt wbr cA c1 cle wbr cA cr wcel c3 cn0 wcel cc0 cA clt
    wbr cc0 cA c3 cexp co clt wbr c3 3nn nnnn0i cA c3 expgt0 mp3an2 3adant3
    sylbi sylc cA cc0 c1 cioc co wcel cA c3 cexp co cc wcel cA c3 cexp co c1
    cdiv co cA c3 cexp co wceq cA cc0 c1 cioc co wcel cA c3 cexp co cA cr wcel
    c3 cn0 wcel cA c3 cexp co cr wcel cA cc0 c1 cioc co wcel cA c3 reexpcl cA
    cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
    cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
    1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl recnd cA c3
    cexp co div1 syl breqtrd cA cc0 c1 cioc co wcel cA c3 cexp co cA c1 cexp co
    cA cle cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
    cA c3 cexp co cA c1 cexp co cle wbr cc0 cr wcel c1 cr wcel cA cc0 c1 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
    elioc2 mp2an cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA c3 cexp co cA c1
    cexp co cle wbr cA cr wcel c1 cn0 wcel c3 cn0 wcel cc0 cA clt wbr cA c1 cle
    wbr wa cA c3 cexp co cA c1 cexp co cle wbr wi 1nn0 c3 3nn nnnn0i cc0 cA clt
    wbr cA c1 cle wbr wa cA cr wcel c1 cn0 wcel c3 cn0 wcel w3a cA c3 cexp co
    cA c1 cexp co cle wbr cc0 cA clt wbr cA c1 cle wbr c1 c3 clt wbr cA cr wcel
    c1 cn0 wcel c3 cn0 wcel w3a cA c3 cexp co cA c1 cexp co cle wbr wi cc0 c1
    caddc co c2 c1 caddc co c1 c3 clt cc0 c2 clt wbr cc0 c1 caddc co c2 c1
    caddc co clt wbr 2pos cc0 c2 c1 0re 2re 1re ltadd1i mpbi c1 ax1cn addid2i
    c3 c2 c1 caddc co df-3 eqcomi 3brtr3i cA cr wcel c1 cn0 wcel c3 cn0 wcel
    w3a cc0 cA clt wbr cA c1 cle wbr c1 c3 clt wbr w3a cA c3 cexp co cA c1 cexp
    co cle wbr cA c1 c3 expword2i expcom mp3an3 com12 mp3an23 3impib sylbi cA
    cc0 c1 cioc co wcel cA cc wcel cA c1 cexp co cA wceq cA cc0 c1 cioc co wcel
    cA cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1
    cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr
    wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb
    0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d recnd cA exp1 syl breqtrd
    ltletrd cA c3 cexp co c3 cdiv co cr wcel cA cr wcel cA c3 cexp co c3 cdiv
    co cA clt wbr cc0 cA cA c3 cexp co c3 cdiv co cmin co clt wbr wb cA cc0 c1
    cioc co wcel cA c3 cexp co c3 cdiv co cA posdif cA cc0 c1 cioc co wcel cA
    c3 cexp co cr wcel cA c3 cexp co c3 cdiv co cr wcel cA cr wcel c3 cn0 wcel
    cA c3 cexp co cr wcel cA cc0 c1 cioc co wcel cA c3 reexpcl cA cc0 c1 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA
    cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
    cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1
    cA elioc2 mp2an biimpi 3simp1d c3 3nn nnnn0i sylancl cA c3 cexp co cr wcel
    c3 cr wcel c3 cc0 wne cA c3 cexp co c3 cdiv co cr wcel 3re c3 3nn nnne0i cA
    c3 cexp co c3 redivcl mp3an23 syl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
    clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
    3simp1d sylanc mpbid cA cc0 c1 cioc co wcel cA cA c3 cexp co c3 cdiv co
    cmin co cA csin cfv clt wbr cA csin cfv cA clt wbr cA sin01bnd pm3.26d cA
    cA c3 cexp co c3 cdiv co cmin co cr wcel cA csin cfv cr wcel cc0 cA cA c3
    cexp co c3 cdiv co cmin co clt wbr cA cA c3 cexp co c3 cdiv co cmin co cA
    csin cfv clt wbr wa cc0 cA csin cfv clt wbr wi cA cc0 c1 cioc co wcel cc0
    cr wcel cA cA c3 cexp co c3 cdiv co cmin co cr wcel cA csin cfv cr wcel cc0
    cA cA c3 cexp co c3 cdiv co cmin co clt wbr cA cA c3 cexp co c3 cdiv co
    cmin co cA csin cfv clt wbr wa cc0 cA csin cfv clt wbr wi 0re cc0 cA cA c3
    cexp co c3 cdiv co cmin co cA csin cfv axlttrn mp3an1 cA cr wcel cA c3 cexp
    co c3 cdiv co cr wcel cA cA c3 cexp co c3 cdiv co cmin co cr wcel cA cc0 c1
    cioc co wcel cA cA c3 cexp co c3 cdiv co resubcl cA cc0 c1 cioc co wcel cA
    cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel
    cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2
    mp2an biimpi 3simp1d cA cc0 c1 cioc co wcel cA c3 cexp co cr wcel cA c3
    cexp co c3 cdiv co cr wcel cA cr wcel c3 cn0 wcel cA c3 cexp co cr wcel cA
    cc0 c1 cioc co wcel cA c3 reexpcl cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
    clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
    3simp1d c3 3nn nnnn0i sylancl cA c3 cexp co cr wcel c3 cr wcel c3 cc0 wne
    cA c3 cexp co c3 cdiv co cr wcel 3re c3 3nn nnne0i cA c3 cexp co c3 redivcl
    mp3an23 syl sylanc cA cc0 c1 cioc co wcel cA cr wcel cA csin cfv cr wcel cA
    cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel
    cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re
    1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA resincl syl sylanc mp2and $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The cosine of a positive real number less than or equal to 1 is positive.
     (Contributed by Paul Chapman, 19-Jan-2008.) $)
  cos01gt0 $p |- ( A e. ( 0 (,] 1 ) -> 0 < ( cos ` A ) ) $=
    cA cc0 c1 cioc co wcel cc0 c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co
    clt wbr c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co cA ccos cfv clt wbr
    cc0 cA ccos cfv clt wbr cA cc0 c1 cioc co wcel c2 cA c2 cexp co c3 cdiv co
    cmul co c1 clt wbr cc0 c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co clt
    wbr cA cc0 c1 cioc co wcel c2 cA c2 cexp co c3 cdiv co cmul co cA c2 cexp
    co clt wbr cA c2 cexp co c1 cle wbr c2 cA c2 cexp co c3 cdiv co cmul co c1
    clt wbr cA cc0 c1 cioc co wcel c2 cA c2 cexp co c3 cdiv co cmul co cA c2
    cexp co c2 c3 cdiv co cmul co cA c2 cexp co clt cA cc0 c1 cioc co wcel cA
    c2 cexp co cc wcel c2 cA c2 cexp co c3 cdiv co cmul co cA c2 cexp co c2 c3
    cdiv co cmul co wceq cA cc0 c1 cioc co wcel cA c2 cexp co cA cc0 c1 cioc co
    wcel cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
    cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel
    cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi
    3simp1d cA resqcl syl recnd c2 cc wcel cA c2 cexp co cc wcel c3 cc wcel c3
    cc0 wne wa c2 cA c2 cexp co c3 cdiv co cmul co cA c2 cexp co c2 c3 cdiv co
    cmul co wceq 2cn c3 cc wcel c3 cc0 wne c3 3re recni c3 3nn nnne0i pm3.2i c2
    cA c2 cexp co c3 div12 mp3an13 syl cA cc0 c1 cioc co wcel cA c2 cexp co c2
    c3 cdiv co cmul co cA c2 cexp co c1 cmul co cA c2 cexp co clt cA c2 cexp co
    cr wcel cc0 cA c2 cexp co clt wbr cA c2 cexp co c2 c3 cdiv co cmul co cA c2
    cexp co c1 cmul co clt wbr cA cc0 c1 cioc co wcel cA c2 cexp co cr wcel cc0
    cA c2 cexp co clt wbr cA c2 cexp co c2 c3 cdiv co cmul co cA c2 cexp co c1
    cmul co clt wbr cA c2 cexp co cr wcel cc0 cA c2 cexp co clt wbr wa c2 c3
    cdiv co c1 clt wbr cA c2 cexp co c2 c3 cdiv co cmul co cA c2 cexp co c1
    cmul co clt wbr c2 c3 cdiv co c3 c3 cdiv co c1 clt c2 c3 clt wbr c2 c3 cdiv
    co c3 c3 cdiv co clt wbr c2 c2 c1 caddc co c3 clt c2 2re ltp1i df-3
    breqtrri c2 c3 c3 2re 3re 3re 3pos ltdiv1ii mpbi c3 c3 3re recni c3 3nn
    nnne0i dividi breqtri c2 c3 cdiv co cr wcel c1 cr wcel cA c2 cexp co cr
    wcel cc0 cA c2 cexp co clt wbr wa c2 c3 cdiv co c1 clt wbr cA c2 cexp co c2
    c3 cdiv co cmul co cA c2 cexp co c1 cmul co clt wbr wb c2 c3 2re 3re c3 3nn
    nnne0i redivcli 1re c2 c3 cdiv co c1 cA c2 cexp co ltmul2 mp3an12 mpbii ex
    cA cc0 c1 cioc co wcel cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co
    wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr
    wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA
    elioc2 mp2an biimpi 3simp1d cA resqcl syl cA cc0 c1 cioc co wcel cA cr wcel
    cc0 cA clt wbr cA c1 cle wbr w3a cc0 cA c2 cexp co clt wbr cc0 cr wcel c1
    cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
    wb 0re 1re cc0 c1 cA elioc2 mp2an cA cr wcel cc0 cA clt wbr cc0 cA c2 cexp
    co clt wbr cA c1 cle wbr cA cr wcel c2 cn0 wcel cc0 cA clt wbr cc0 cA c2
    cexp co clt wbr 2nn0 cA c2 expgt0 mp3an2 3adant3 sylbi sylc cA cc0 c1 cioc
    co wcel cA c2 cexp co cc wcel cA c2 cexp co c1 cmul co cA c2 cexp co wceq
    cA cc0 c1 cioc co wcel cA c2 cexp co cA cc0 c1 cioc co wcel cA cr wcel cA
    c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
    cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a
    cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA resqcl
    syl recnd cA c2 cexp co ax1id syl breqtrd eqbrtrd cA cc0 c1 cioc co wcel cA
    c2 cexp co c1 c2 cexp co c1 cle cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
    clt wbr cA c1 cle wbr w3a cA c2 cexp co c1 c2 cexp co cle wbr cc0 cr wcel
    c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr
    w3a wb 0re 1re cc0 c1 cA elioc2 mp2an cA cr wcel cc0 cA clt wbr cA c1 cle
    wbr cA c2 cexp co c1 c2 cexp co cle wbr cA cr wcel cc0 cA cle wbr wa cA c1
    cle wbr cA c2 cexp co c1 c2 cexp co cle wbr cA cr wcel cc0 cA clt wbr wa cA
    cr wcel cc0 cA cle wbr wa c1 cr wcel cA c1 cle wbr cA c2 cexp co c1 c2 cexp
    co cle wbr 1re cA c1 le2sq2 mpanr1 cA cr wcel cc0 cA clt wbr cc0 cA cle wbr
    cc0 cr wcel cA cr wcel cc0 cA clt wbr cc0 cA cle wbr wi 0re cc0 cA ltle
    mpan imdistani sylan 3impa sylbi sq1 syl6breq c2 cA c2 cexp co c3 cdiv co
    cmul co cr wcel cA c2 cexp co cr wcel c2 cA c2 cexp co c3 cdiv co cmul co
    cA c2 cexp co clt wbr cA c2 cexp co c1 cle wbr wa c2 cA c2 cexp co c3 cdiv
    co cmul co c1 clt wbr wi cA cc0 c1 cioc co wcel c2 cA c2 cexp co c3 cdiv co
    cmul co cr wcel cA c2 cexp co cr wcel c1 cr wcel c2 cA c2 cexp co c3 cdiv
    co cmul co cA c2 cexp co clt wbr cA c2 cexp co c1 cle wbr wa c2 cA c2 cexp
    co c3 cdiv co cmul co c1 clt wbr wi 1re c2 cA c2 cexp co c3 cdiv co cmul co
    cA c2 cexp co c1 ltletr mp3an3 c2 cr wcel cA c2 cexp co c3 cdiv co cr wcel
    c2 cA c2 cexp co c3 cdiv co cmul co cr wcel cA cc0 c1 cioc co wcel c2 cA c2
    cexp co c3 cdiv co remulcl 2re cA cc0 c1 cioc co wcel cA c2 cexp co cr wcel
    cA c2 cexp co c3 cdiv co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cA c2
    cexp co cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
    wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0
    cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1
    cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA resqcl syl
    cA c2 cexp co cr wcel c3 cr wcel c3 cc0 wne cA c2 cexp co c3 cdiv co cr
    wcel 3re c3 3nn nnne0i cA c2 cexp co c3 redivcl mp3an23 syl sylancr cA cc0
    c1 cioc co wcel cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA
    cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel
    cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2
    mp2an biimpi 3simp1d cA resqcl syl sylanc mp2and c2 cA c2 cexp co c3 cdiv
    co cmul co cr wcel c1 cr wcel c2 cA c2 cexp co c3 cdiv co cmul co c1 clt
    wbr cc0 c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co clt wbr wb cA cc0 c1
    cioc co wcel c2 cA c2 cexp co c3 cdiv co cmul co c1 posdif c2 cr wcel cA c2
    cexp co c3 cdiv co cr wcel c2 cA c2 cexp co c3 cdiv co cmul co cr wcel cA
    cc0 c1 cioc co wcel c2 cA c2 cexp co c3 cdiv co remulcl 2re cA cc0 c1 cioc
    co wcel cA c2 cexp co cr wcel cA c2 cexp co c3 cdiv co cr wcel cA cc0 c1
    cioc co wcel cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc co wcel cA cr
    wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA
    clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA
    cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an
    biimpi 3simp1d cA resqcl syl cA c2 cexp co cr wcel c3 cr wcel c3 cc0 wne cA
    c2 cexp co c3 cdiv co cr wcel 3re c3 3nn nnne0i cA c2 cexp co c3 redivcl
    mp3an23 syl sylancr 1re sylancl mpbid cA cc0 c1 cioc co wcel c1 c2 cA c2
    cexp co c3 cdiv co cmul co cmin co cA ccos cfv clt wbr cA ccos cfv c1 cA c2
    cexp co c3 cdiv co cmin co clt wbr cA cos01bnd pm3.26d c1 c2 cA c2 cexp co
    c3 cdiv co cmul co cmin co cr wcel cA ccos cfv cr wcel cc0 c1 c2 cA c2 cexp
    co c3 cdiv co cmul co cmin co clt wbr c1 c2 cA c2 cexp co c3 cdiv co cmul
    co cmin co cA ccos cfv clt wbr wa cc0 cA ccos cfv clt wbr wi cA cc0 c1 cioc
    co wcel cc0 cr wcel c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co cr wcel
    cA ccos cfv cr wcel cc0 c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co clt
    wbr c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co cA ccos cfv clt wbr wa
    cc0 cA ccos cfv clt wbr wi 0re cc0 c1 c2 cA c2 cexp co c3 cdiv co cmul co
    cmin co cA ccos cfv axlttrn mp3an1 c1 cr wcel c2 cA c2 cexp co c3 cdiv co
    cmul co cr wcel c1 c2 cA c2 cexp co c3 cdiv co cmul co cmin co cr wcel cA
    cc0 c1 cioc co wcel c1 c2 cA c2 cexp co c3 cdiv co cmul co resubcl 1re c2
    cr wcel cA c2 cexp co c3 cdiv co cr wcel c2 cA c2 cexp co c3 cdiv co cmul
    co cr wcel cA cc0 c1 cioc co wcel c2 cA c2 cexp co c3 cdiv co remulcl 2re
    cA cc0 c1 cioc co wcel cA c2 cexp co cr wcel cA c2 cexp co c3 cdiv co cr
    wcel cA cc0 c1 cioc co wcel cA cr wcel cA c2 cexp co cr wcel cA cc0 c1 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr cA cc0 c1 cioc co wcel cA
    cr wcel cc0 cA clt wbr cA c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1
    cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1
    cA elioc2 mp2an biimpi 3simp1d cA resqcl syl cA c2 cexp co cr wcel c3 cr
    wcel c3 cc0 wne cA c2 cexp co c3 cdiv co cr wcel 3re c3 3nn nnne0i cA c2
    cexp co c3 redivcl mp3an23 syl sylancr sylancr cA cc0 c1 cioc co wcel cA cr
    wcel cA ccos cfv cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr
    cA c1 cle wbr cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c1 cle
    wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
    wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elioc2 mp2an biimpi 3simp1d cA
    recoscl syl sylanc mp2and $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The sine of a positive real number less than or equal to 2 is positive.
     (Contributed by Paul Chapman, 19-Jan-2008.) $)
  sin02gt0 $p |- ( A e. ( 0 (,] 2 ) -> 0 < ( sin ` A ) ) $=
    cA cc0 c2 cioc co wcel cc0 c2 cA c2 cdiv co cmul co csin cfv cA csin cfv
    clt cA cc0 c2 cioc co wcel cc0 c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos
    cfv cmul co cmul co c2 cA c2 cdiv co cmul co csin cfv clt cA cc0 c2 cioc co
    wcel cc0 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co clt wbr cc0
    c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cmul co clt wbr cA
    cc0 c2 cioc co wcel cc0 cA c2 cdiv co csin cfv clt wbr cc0 cA c2 cdiv co
    ccos cfv clt wbr cc0 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co
    clt wbr cA cc0 c2 cioc co wcel cA c2 cdiv co cc0 c1 cioc co wcel cc0 cA c2
    cdiv co csin cfv clt wbr cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a cA c2
    cdiv co cr wcel cc0 cA c2 cdiv co clt wbr cA c2 cdiv co c1 cle wbr w3a cA
    cc0 c2 cioc co wcel cA c2 cdiv co cc0 c1 cioc co wcel cA cr wcel cc0 cA clt
    wbr cA c2 cle wbr w3a cA c2 cdiv co cr wcel cc0 cA c2 cdiv co clt wbr cA c2
    cdiv co c1 cle wbr cA cr wcel cc0 cA clt wbr cA c2 cdiv co cr wcel cA c2
    cle wbr cA rehalfcl 3ad2ant1 cA cr wcel cc0 cA clt wbr cc0 cA c2 cdiv co
    clt wbr cA c2 cle wbr cA cr wcel cc0 cA clt wbr wa c2 cr wcel cc0 c2 clt
    wbr cc0 cA c2 cdiv co clt wbr 2re 2pos cA c2 divgt0 mpanr12 3adant3 cA cr
    wcel cA c2 cle wbr cA c2 cdiv co c1 cle wbr cc0 cA clt wbr cA cr wcel cA c2
    cle wbr wa cA c2 cdiv co c2 c2 cdiv co c1 cle cA cr wcel cA c2 cle wbr cA
    c2 cdiv co c2 c2 cdiv co cle wbr cA cr wcel c2 cr wcel c2 cr wcel cA c2 cle
    wbr cA c2 cdiv co c2 c2 cdiv co cle wbr wb 2re 2re cA cr wcel c2 cr wcel c2
    cr wcel w3a cc0 c2 clt wbr cA c2 cle wbr cA c2 cdiv co c2 c2 cdiv co cle
    wbr wb 2pos cA c2 c2 lediv1OLD mpan2 mp3an23 biimpa c2 2cn 2ne0 dividi
    syl6breq 3adant2 3jca cc0 cr wcel c2 cr wcel cA cc0 c2 cioc co wcel cA cr
    wcel cc0 cA clt wbr cA c2 cle wbr w3a wb 0re 2re cc0 c2 cA elioc2 mp2an cc0
    cr wcel c1 cr wcel cA c2 cdiv co cc0 c1 cioc co wcel cA c2 cdiv co cr wcel
    cc0 cA c2 cdiv co clt wbr cA c2 cdiv co c1 cle wbr w3a wb 0re 1re cc0 c1 cA
    c2 cdiv co elioc2 mp2an 3imtr4i cA c2 cdiv co sin01gt0 syl cA cc0 c2 cioc
    co wcel cA c2 cdiv co cc0 c1 cioc co wcel cc0 cA c2 cdiv co ccos cfv clt
    wbr cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a cA c2 cdiv co cr wcel cc0
    cA c2 cdiv co clt wbr cA c2 cdiv co c1 cle wbr w3a cA cc0 c2 cioc co wcel
    cA c2 cdiv co cc0 c1 cioc co wcel cA cr wcel cc0 cA clt wbr cA c2 cle wbr
    w3a cA c2 cdiv co cr wcel cc0 cA c2 cdiv co clt wbr cA c2 cdiv co c1 cle
    wbr cA cr wcel cc0 cA clt wbr cA c2 cdiv co cr wcel cA c2 cle wbr cA
    rehalfcl 3ad2ant1 cA cr wcel cc0 cA clt wbr cc0 cA c2 cdiv co clt wbr cA c2
    cle wbr cA cr wcel cc0 cA clt wbr wa c2 cr wcel cc0 c2 clt wbr cc0 cA c2
    cdiv co clt wbr 2re 2pos cA c2 divgt0 mpanr12 3adant3 cA cr wcel cA c2 cle
    wbr cA c2 cdiv co c1 cle wbr cc0 cA clt wbr cA cr wcel cA c2 cle wbr wa cA
    c2 cdiv co c2 c2 cdiv co c1 cle cA cr wcel cA c2 cle wbr cA c2 cdiv co c2
    c2 cdiv co cle wbr cA cr wcel c2 cr wcel c2 cr wcel cA c2 cle wbr cA c2
    cdiv co c2 c2 cdiv co cle wbr wb 2re 2re cA cr wcel c2 cr wcel c2 cr wcel
    w3a cc0 c2 clt wbr cA c2 cle wbr cA c2 cdiv co c2 c2 cdiv co cle wbr wb
    2pos cA c2 c2 lediv1OLD mpan2 mp3an23 biimpa c2 2cn 2ne0 dividi syl6breq
    3adant2 3jca cc0 cr wcel c2 cr wcel cA cc0 c2 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c2 cle wbr w3a wb 0re 2re cc0 c2 cA elioc2 mp2an cc0 cr wcel
    c1 cr wcel cA c2 cdiv co cc0 c1 cioc co wcel cA c2 cdiv co cr wcel cc0 cA
    c2 cdiv co clt wbr cA c2 cdiv co c1 cle wbr w3a wb 0re 1re cc0 c1 cA c2
    cdiv co elioc2 mp2an 3imtr4i cA c2 cdiv co cos01gt0 syl cA cc0 c2 cioc co
    wcel cA c2 cdiv co cr wcel cc0 cA c2 cdiv co csin cfv clt wbr cc0 cA c2
    cdiv co ccos cfv clt wbr wa cc0 cA c2 cdiv co csin cfv cA c2 cdiv co ccos
    cfv cmul co clt wbr wi cA cc0 c2 cioc co wcel cA cr wcel cc0 cA clt wbr cA
    c2 cle wbr w3a cA c2 cdiv co cr wcel cc0 cr wcel c2 cr wcel cA cc0 c2 cioc
    co wcel cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a wb 0re 2re cc0 c2 cA
    elioc2 mp2an cA cr wcel cc0 cA clt wbr cA c2 cdiv co cr wcel cA c2 cle wbr
    cA rehalfcl 3ad2ant1 sylbi cA c2 cdiv co csin cfv cr wcel cA c2 cdiv co
    ccos cfv cr wcel cc0 cA c2 cdiv co csin cfv clt wbr cc0 cA c2 cdiv co ccos
    cfv clt wbr wa cc0 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co
    clt wbr wi cA c2 cdiv co cr wcel cA c2 cdiv co csin cfv cA c2 cdiv co ccos
    cfv axmulgt0 cA c2 cdiv co resincl cA c2 cdiv co recoscl sylanc syl mp2and
    cA cc0 c2 cioc co wcel cA c2 cdiv co cr wcel cA c2 cdiv co csin cfv cA c2
    cdiv co ccos cfv cmul co cr wcel cc0 cA c2 cdiv co csin cfv cA c2 cdiv co
    ccos cfv cmul co clt wbr cc0 c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos
    cfv cmul co cmul co clt wbr wi cA cc0 c2 cioc co wcel cA cr wcel cc0 cA clt
    wbr cA c2 cle wbr w3a cA c2 cdiv co cr wcel cc0 cr wcel c2 cr wcel cA cc0
    c2 cioc co wcel cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a wb 0re 2re cc0
    c2 cA elioc2 mp2an cA cr wcel cc0 cA clt wbr cA c2 cdiv co cr wcel cA c2
    cle wbr cA rehalfcl 3ad2ant1 sylbi cA c2 cdiv co csin cfv cr wcel cA c2
    cdiv co ccos cfv cr wcel cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul
    co cr wcel cA c2 cdiv co cr wcel cA c2 cdiv co csin cfv cA c2 cdiv co ccos
    cfv remulcl cA c2 cdiv co resincl cA c2 cdiv co recoscl sylanc cA c2 cdiv
    co csin cfv cA c2 cdiv co ccos cfv cmul co cr wcel cc0 c2 clt wbr cc0 cA c2
    cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co clt wbr cc0 c2 cA c2 cdiv
    co csin cfv cA c2 cdiv co ccos cfv cmul co cmul co clt wbr 2pos c2 cr wcel
    cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cr wcel cc0 c2 clt
    wbr cc0 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co clt wbr wa
    cc0 c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cmul co clt
    wbr wi 2re c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co
    axmulgt0 mpan mpani 3syl mpd cA cc0 c2 cioc co wcel cA c2 cdiv co cc wcel
    c2 cA c2 cdiv co cmul co csin cfv c2 cA c2 cdiv co csin cfv cA c2 cdiv co
    ccos cfv cmul co cmul co wceq cA cc0 c2 cioc co wcel cA c2 cdiv co cA cc0
    c2 cioc co wcel cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a cA c2 cdiv co
    cr wcel cc0 cr wcel c2 cr wcel cA cc0 c2 cioc co wcel cA cr wcel cc0 cA clt
    wbr cA c2 cle wbr w3a wb 0re 2re cc0 c2 cA elioc2 mp2an cA cr wcel cc0 cA
    clt wbr cA c2 cdiv co cr wcel cA c2 cle wbr cA rehalfcl 3ad2ant1 sylbi
    recnd cA c2 cdiv co sin2t syl breqtrrd cA cc0 c2 cioc co wcel c2 cA c2 cdiv
    co cmul co cA csin cA cc0 c2 cioc co wcel cA cc wcel c2 cA c2 cdiv co cmul
    co cA wceq cA cc0 c2 cioc co wcel cA cA cc0 c2 cioc co wcel cA cr wcel cc0
    cA clt wbr cA c2 cle wbr cA cc0 c2 cioc co wcel cA cr wcel cc0 cA clt wbr
    cA c2 cle wbr w3a cc0 cr wcel c2 cr wcel cA cc0 c2 cioc co wcel cA cr wcel
    cc0 cA clt wbr cA c2 cle wbr w3a wb 0re 2re cc0 c2 cA elioc2 mp2an biimpi
    3simp1d recnd cA cc wcel c2 cc wcel c2 cc0 wne c2 cA c2 cdiv co cmul co cA
    wceq 2cn 2ne0 cA c2 divcan2 mp3an23 syl fveq2d breqtrd $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The signs of the sine and cosine of 1. (Contributed by Paul Chapman,
     19-Jan-2008.) $)
  sincos1sgn $p |- ( 0 < ( sin ` 1 ) /\ 0 < ( cos ` 1 ) ) $=
    c1 cc0 c1 cioc co wcel cc0 c1 csin cfv clt wbr cc0 c1 ccos cfv clt wbr wa
    c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr c1 cc0 c1 cioc co wcel 1re lt01 c1
    1re leidi c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1 clt wbr c1 c1 cle wbr
    w3a cc0 cr wcel c1 cr wcel c1 cc0 c1 cioc co wcel c1 cr wcel cc0 c1 clt wbr
    c1 c1 cle wbr w3a wb 0re 1re cc0 c1 c1 elioc2 mp2an biimpri mp3an c1 cc0 c1
    cioc co wcel cc0 c1 csin cfv clt wbr cc0 c1 ccos cfv clt wbr c1 sin01gt0 c1
    cos01gt0 jca ax-mp $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The signs of the sine and cosine of 2. (Contributed by Paul Chapman,
     19-Jan-2008.) $)
  sincos2sgn $p |- ( 0 < ( sin ` 2 ) /\ ( cos ` 2 ) < 0 ) $=
    cc0 c2 csin cfv clt wbr c2 ccos cfv cc0 clt wbr c2 cc0 c2 cioc co wcel cc0
    c2 csin cfv clt wbr c2 cr wcel cc0 c2 clt wbr c2 c2 cle wbr c2 cc0 c2 cioc
    co wcel 2re 2pos c2 2re leidi c2 cc0 c2 cioc co wcel c2 cr wcel cc0 c2 clt
    wbr c2 c2 cle wbr w3a cc0 cr wcel c2 cr wcel c2 cc0 c2 cioc co wcel c2 cr
    wcel cc0 c2 clt wbr c2 c2 cle wbr w3a wb 0re 2re cc0 c2 c2 elioc2 mp2an
    biimpri mp3an c2 sin02gt0 ax-mp c2 ccos cfv c1 c9 cdiv co cneg clt wbr c1
    c9 cdiv co cneg cc0 clt wbr c2 ccos cfv cc0 clt wbr c7 c9 cdiv co cneg c2
    ccos cfv clt wbr c2 ccos cfv c1 c9 cdiv co cneg clt wbr cos2bnd pm3.27i cc0
    c1 c9 cdiv co clt wbr c1 c9 cdiv co cneg cc0 clt wbr c9 9re 9pos recgt0ii
    c1 c9 cdiv co cr wcel cc0 c1 c9 cdiv co clt wbr c1 c9 cdiv co cneg cc0 clt
    wbr wb c9 9re c9 9re 9pos gt0ne0ii rereccli c1 c9 cdiv co lt0neg2 ax-mp
    mpbi c2 ccos cfv c1 c9 cdiv co cneg cc0 c2 cr wcel c2 ccos cfv cr wcel 2re
    c2 recoscl ax-mp c1 c9 cdiv co c9 9re c9 9re 9pos gt0ne0ii rereccli
    renegcli 0re lttri mp2an pm3.2i $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The sine of 4 is negative. (Contributed by Paul Chapman, 19-Jan-2008.) $)
  sin4lt0 $p |- ( sin ` 4 ) < 0 $=
    c4 csin cfv c2 c2 csin cfv c2 ccos cfv cmul co cmul co cc0 clt c2 c2 cmul
    co csin cfv c4 csin cfv c2 c2 csin cfv c2 ccos cfv cmul co cmul co c2 c2
    cmul co c4 csin 2t2e4 fveq2i c2 cc wcel c2 c2 cmul co csin cfv c2 c2 csin
    cfv c2 ccos cfv cmul co cmul co wceq 2cn c2 sin2t ax-mp eqtr3i c2 c2 csin
    cfv c2 ccos cfv cmul co cmul co c2 cc0 cmul co cc0 clt c2 csin cfv c2 ccos
    cfv cmul co cc0 clt wbr c2 c2 csin cfv c2 ccos cfv cmul co cmul co c2 cc0
    cmul co clt wbr c2 csin cfv c2 ccos cfv cmul co c2 csin cfv cc0 cmul co cc0
    clt c2 ccos cfv cc0 clt wbr c2 csin cfv c2 ccos cfv cmul co c2 csin cfv cc0
    cmul co clt wbr cc0 c2 csin cfv clt wbr c2 ccos cfv cc0 clt wbr sincos2sgn
    pm3.27i c2 ccos cfv cr wcel cc0 cr wcel c2 csin cfv cr wcel c2 ccos cfv cc0
    clt wbr c2 csin cfv c2 ccos cfv cmul co c2 csin cfv cc0 cmul co clt wbr wb
    c2 cr wcel c2 ccos cfv cr wcel 2re c2 recoscl ax-mp 0re c2 cr wcel c2 csin
    cfv cr wcel 2re c2 resincl ax-mp c2 ccos cfv cr wcel cc0 cr wcel c2 csin
    cfv cr wcel w3a cc0 c2 csin cfv clt wbr c2 ccos cfv cc0 clt wbr c2 csin cfv
    c2 ccos cfv cmul co c2 csin cfv cc0 cmul co clt wbr wb cc0 c2 csin cfv clt
    wbr c2 ccos cfv cc0 clt wbr sincos2sgn pm3.26i c2 ccos cfv cc0 c2 csin cfv
    ltmul2OLD mpan2 mp3an mpbi c2 csin cfv c2 csin cfv c2 cr wcel c2 csin cfv
    cr wcel 2re c2 resincl ax-mp recni mul01i breqtri c2 csin cfv c2 ccos cfv
    cmul co cr wcel cc0 cr wcel c2 cr wcel c2 csin cfv c2 ccos cfv cmul co cc0
    clt wbr c2 c2 csin cfv c2 ccos cfv cmul co cmul co c2 cc0 cmul co clt wbr
    wb c2 csin cfv c2 ccos cfv c2 cr wcel c2 csin cfv cr wcel 2re c2 resincl
    ax-mp c2 cr wcel c2 ccos cfv cr wcel 2re c2 recoscl ax-mp remulcli 0re 2re
    c2 csin cfv c2 ccos cfv cmul co cr wcel cc0 cr wcel c2 cr wcel w3a cc0 c2
    clt wbr c2 csin cfv c2 ccos cfv cmul co cc0 clt wbr c2 c2 csin cfv c2 ccos
    cfv cmul co cmul co c2 cc0 cmul co clt wbr wb 2pos c2 csin cfv c2 ccos cfv
    cmul co cc0 c2 ltmul2OLD mpan2 mp3an mpbi c2 2cn mul01i breqtri eqbrtri $.
    $( [19-Jan-2008] $) $( [19-Jan-2008] $)

  $( The absolute value of the exponential function of an imaginary number is
     one.  Equation 48 of [Rudin] p. 167.  (Contributed by Jason Orendorff,
     9-Feb-2007.) $)
  absefi $p |- ( A e. RR -> ( abs ` ( exp ` ( _i x. A ) ) ) = 1 ) $=
    cA cr wcel ci cA cmul co ce cfv cabs cfv cA ccos cfv ci cA csin cfv cmul co
    caddc co cabs cfv cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc co
    csqr cfv c1 cA cr wcel ci cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul
    co caddc co cabs cA cr wcel cA cc wcel ci cA cmul co ce cfv cA ccos cfv ci
    cA csin cfv cmul co caddc co wceq cA recn cA efival syl fveq2d cA ccos cfv
    cr wcel cA csin cfv cr wcel cA ccos cfv ci cA csin cfv cmul co caddc co
    cabs cfv cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc co csqr cfv
    wceq cA cr wcel cA ccos cfv cA csin cfv absreim cA recoscl cA resincl
    sylanc cA cr wcel cA ccos cfv c2 cexp co cA csin cfv c2 cexp co caddc co
    csqr cfv c1 csqr cfv c1 cA cr wcel cA ccos cfv c2 cexp co cA csin cfv c2
    cexp co caddc co c1 csqr cA cr wcel cA ccos cfv c2 cexp co cA csin cfv c2
    cexp co caddc co cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc co c1
    cA ccos cfv c2 cexp co cc wcel cA csin cfv c2 cexp co cc wcel cA ccos cfv
    c2 cexp co cA csin cfv c2 cexp co caddc co cA csin cfv c2 cexp co cA ccos
    cfv c2 cexp co caddc co wceq cA cr wcel cA ccos cfv c2 cexp co cA csin cfv
    c2 cexp co addcom cA cr wcel cA ccos cfv c2 cexp co cA cr wcel cA ccos cfv
    cr wcel cA ccos cfv c2 cexp co cr wcel cA recoscl cA ccos cfv resqcl syl
    recnd cA cr wcel cA csin cfv c2 cexp co cA cr wcel cA csin cfv cr wcel cA
    csin cfv c2 cexp co cr wcel cA resincl cA csin cfv resqcl syl recnd sylanc
    cA cr wcel cA cc wcel cA csin cfv c2 cexp co cA ccos cfv c2 cexp co caddc
    co c1 wceq cA recn cA sincossq syl eqtrd fveq2d sqr1 syl6eq 3eqtrd $.
    $( [10-Feb-2007] $) $( [9-Feb-2007] $)

  $( The absolute value of the exponential function is the exponential
     function of the real part.  (Contributed by Paul Chapman,
     13-Sep-2007.) $)
  absef $p |- ( A e. CC -> ( abs ` ( exp ` A ) ) = ( exp ` ( Re ` A ) ) ) $=
    cA cc wcel cA ce cfv cabs cfv cA cre cfv ce cfv cabs cfv cA cre cfv ce cfv
    cA cc wcel cA ce cfv cabs cfv cA cre cfv ce cfv cabs cfv c1 cmul co cA cre
    cfv ce cfv cabs cfv cA cc wcel cA ce cfv cabs cfv cA cre cfv ce cfv cabs
    cfv ci cA cim cfv cmul co ce cfv cabs cfv cmul co cA cre cfv ce cfv cabs
    cfv c1 cmul co cA cc wcel cA ce cfv cabs cfv cA cre cfv ce cfv ci cA cim
    cfv cmul co ce cfv cmul co cabs cfv cA cre cfv ce cfv cabs cfv ci cA cim
    cfv cmul co ce cfv cabs cfv cmul co cA cc wcel cA ce cfv cA cre cfv ce cfv
    ci cA cim cfv cmul co ce cfv cmul co wceq cA ce cfv cabs cfv cA cre cfv ce
    cfv ci cA cim cfv cmul co ce cfv cmul co cabs cfv wceq cA cc wcel cA ce cfv
    cA cre cfv ci cA cim cfv cmul co caddc co ce cfv cA cre cfv ce cfv ci cA
    cim cfv cmul co ce cfv cmul co cA cc wcel cA cA cre cfv ci cA cim cfv cmul
    co caddc co wceq cA ce cfv cA cre cfv ci cA cim cfv cmul co caddc co ce cfv
    wceq cA replim cA cA cre cfv ci cA cim cfv cmul co caddc co ce fveq2 syl cA
    cre cfv cc wcel ci cA cim cfv cmul co cc wcel cA cre cfv ci cA cim cfv cmul
    co caddc co ce cfv cA cre cfv ce cfv ci cA cim cfv cmul co ce cfv cmul co
    wceq cA cc wcel cA cre cfv ci cA cim cfv cmul co efadd cA cc wcel cA cre
    cfv cr wcel cA cre cfv cc wcel cA recl cA cre cfv recn syl ci cc wcel cA
    cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci cA cim cfv
    mulcl axicn cA cc wcel cA cim cfv cr wcel cA cim cfv cc wcel cA imcl cA cim
    cfv recn syl sylancr sylanc eqtrd cA ce cfv cA cre cfv ce cfv ci cA cim cfv
    cmul co ce cfv cmul co cabs fveq2 syl cA cre cfv ce cfv cc wcel ci cA cim
    cfv cmul co ce cfv cc wcel cA cre cfv ce cfv ci cA cim cfv cmul co ce cfv
    cmul co cabs cfv cA cre cfv ce cfv cabs cfv ci cA cim cfv cmul co ce cfv
    cabs cfv cmul co wceq cA cc wcel cA cre cfv ce cfv ci cA cim cfv cmul co ce
    cfv absmul cA cc wcel cA cre cfv ce cfv cr wcel cA cre cfv ce cfv cc wcel
    cA cc wcel cA cre cfv cr wcel cA cre cfv ce cfv cr wcel cA recl cA cre cfv
    reefcl syl cA cre cfv ce cfv recn syl cA cc wcel ci cA cim cfv cmul co cc
    wcel ci cA cim cfv cmul co ce cfv cc wcel ci cc wcel cA cim cfv cc wcel ci
    cA cim cfv cmul co cc wcel cA cc wcel ci cA cim cfv mulcl axicn cA cc wcel
    cA cim cfv cr wcel cA cim cfv cc wcel cA imcl cA cim cfv recn syl sylancr
    ci cA cim cfv cmul co efcl syl sylanc eqtrd cA cc wcel ci cA cim cfv cmul
    co ce cfv cabs cfv c1 wceq cA cre cfv ce cfv cabs cfv ci cA cim cfv cmul co
    ce cfv cabs cfv cmul co cA cre cfv ce cfv cabs cfv c1 cmul co wceq cA cc
    wcel cA cim cfv cr wcel ci cA cim cfv cmul co ce cfv cabs cfv c1 wceq cA
    imcl cA cim cfv absefi syl ci cA cim cfv cmul co ce cfv cabs cfv c1 cA cre
    cfv ce cfv cabs cfv cmul opreq2 syl eqtrd cA cc wcel cA cre cfv ce cfv cabs
    cfv cc wcel cA cre cfv ce cfv cabs cfv c1 cmul co cA cre cfv ce cfv cabs
    cfv wceq cA cc wcel cA cre cfv ce cfv cc wcel cA cre cfv ce cfv cabs cfv cr
    wcel cA cre cfv ce cfv cabs cfv cc wcel cA cc wcel cA cre cfv ce cfv cr
    wcel cA cre cfv ce cfv cc wcel cA cc wcel cA cre cfv cr wcel cA cre cfv ce
    cfv cr wcel cA recl cA cre cfv reefcl syl cA cre cfv ce cfv recn syl cA cre
    cfv ce cfv abscl cA cre cfv ce cfv cabs cfv recn 3syl cA cre cfv ce cfv
    cabs cfv ax1id syl eqtrd cA cre cfv ce cfv cr wcel cc0 cA cre cfv ce cfv
    cle wbr cA cre cfv ce cfv cabs cfv cA cre cfv ce cfv wceq cA cc wcel cA cre
    cfv ce cfv absid cA cc wcel cA cre cfv cr wcel cA cre cfv ce cfv cr wcel cA
    recl cA cre cfv reefcl syl cA cc wcel cc0 cA cre cfv ce cfv clt wbr cc0 cA
    cre cfv ce cfv cle wbr cA cc wcel cA cre cfv cr wcel cc0 cA cre cfv ce cfv
    clt wbr cA recl cA cre cfv efgt0 syl cc0 cr wcel cA cre cfv ce cfv cr wcel
    cc0 cA cre cfv ce cfv clt wbr cc0 cA cre cfv ce cfv cle wbr wi cA cc wcel
    cc0 cA cre cfv ce cfv ltle 0reALT cA cc wcel cA cre cfv cr wcel cA cre cfv
    ce cfv cr wcel cA recl cA cre cfv reefcl syl sylancr mpd sylanc eqtrd $.
    $( [15-Mar-2008] $) $( [13-Sep-2007] $)

  $( A number is real iff its imaginary exponential has absolute value one. $)
  absefib $p |- ( A e. CC
          -> ( A e. RR <-> ( abs ` ( exp ` ( _i x. A ) ) ) = 1 ) ) $=
    cA cc wcel ci cA cmul co ce cfv cabs cfv c1 wceq cA cim cfv cneg ce cfv c1
    wceq cA cr wcel cA cc wcel ci cA cmul co ce cfv cabs cfv cA cim cfv cneg ce
    cfv c1 cA cc wcel ci cA cmul co ce cfv cabs cfv ci cA cmul co cre cfv ce
    cfv cA cim cfv cneg ce cfv cA cc wcel ci cA cmul co cc wcel ci cA cmul co
    ce cfv cabs cfv ci cA cmul co cre cfv ce cfv wceq ci cc wcel cA cc wcel ci
    cA cmul co cc wcel axicn ci cA mulcl mpan ci cA cmul co absef syl cA cc
    wcel ci cA cmul co cre cfv cA cim cfv cneg ce cA cc wcel ci cA cmul co cre
    cfv cA cim cfv cneg ci cA cre cfv cmul co caddc co cre cfv cA cim cfv cneg
    cA cc wcel ci cA cmul co cA cim cfv cneg ci cA cre cfv cmul co caddc co cre
    cA cc wcel ci cA cmul co ci ci cA cim cfv cmul co cA cre cfv caddc co cmul
    co ci ci cA cim cfv cmul co cmul co ci cA cre cfv cmul co caddc co cA cim
    cfv cneg ci cA cre cfv cmul co caddc co cA cc wcel cA ci cA cim cfv cmul co
    cA cre cfv caddc co ci cmul cA cc wcel cA cA cre cfv ci cA cim cfv cmul co
    caddc co ci cA cim cfv cmul co cA cre cfv caddc co cA replim cA cre cfv cc
    wcel ci cA cim cfv cmul co cc wcel cA cre cfv ci cA cim cfv cmul co caddc
    co ci cA cim cfv cmul co cA cre cfv caddc co wceq cA cc wcel cA cre cfv ci
    cA cim cfv cmul co addcom cA cc wcel cA cre cfv cA recl recnd ci cc wcel cA
    cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci cA cim cfv
    mulcl axicn cA cc wcel cA cim cfv cA imcl recnd sylancr sylanc eqtrd
    opreq2d ci cA cim cfv cmul co cc wcel cA cre cfv cc wcel ci ci cA cim cfv
    cmul co cA cre cfv caddc co cmul co ci ci cA cim cfv cmul co cmul co ci cA
    cre cfv cmul co caddc co wceq cA cc wcel ci cc wcel ci cA cim cfv cmul co
    cc wcel cA cre cfv cc wcel ci ci cA cim cfv cmul co cA cre cfv caddc co
    cmul co ci ci cA cim cfv cmul co cmul co ci cA cre cfv cmul co caddc co
    wceq axicn ci ci cA cim cfv cmul co cA cre cfv adddi mp3an1 ci cc wcel cA
    cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci cA cim cfv
    mulcl axicn cA cc wcel cA cim cfv cA imcl recnd sylancr cA cc wcel cA cre
    cfv cA recl recnd sylanc cA cc wcel ci ci cA cim cfv cmul co cmul co cA cim
    cfv cneg ci cA cre cfv cmul co caddc cA cc wcel ci ci cmul co cA cim cfv
    cmul co ci ci cA cim cfv cmul co cmul co cA cim cfv cneg cA cc wcel cA cim
    cfv cc wcel ci ci cmul co cA cim cfv cmul co ci ci cA cim cfv cmul co cmul
    co wceq cA cc wcel cA cim cfv cA imcl recnd ci cc wcel ci cc wcel cA cim
    cfv cc wcel ci ci cmul co cA cim cfv cmul co ci ci cA cim cfv cmul co cmul
    co wceq axicn axicn ci ci cA cim cfv mulass mp3an12 syl cA cc wcel c1 cneg
    cA cim cfv cmul co cA cim cfv cneg ci ci cmul co cA cim cfv cmul co cA cc
    wcel cA cim cfv cc wcel c1 cneg cA cim cfv cmul co cA cim cfv cneg wceq cA
    cc wcel cA cim cfv cA imcl recnd cA cim cfv mulm1 syl ci ci cmul co c1 cneg
    cA cim cfv cmul ixi opreq1i syl5eq eqtr3d opreq1d 3eqtrd fveq2d cA cim cfv
    cneg cr wcel cA cre cfv cr wcel cA cim cfv cneg ci cA cre cfv cmul co caddc
    co cre cfv cA cim cfv cneg wceq cA cc wcel cA cim cfv cneg cA cre cfv crre
    cA cc wcel cA cim cfv cr wcel cA cim cfv cneg cr wcel cA imcl cA cim cfv
    renegcl syl cA recl sylanc eqtrd fveq2d eqtrd eqeq1d cA cc wcel cA cim cfv
    cc0 wceq cA cim cfv cneg cc0 wceq cA cr wcel cA cim cfv cneg ce cfv c1 wceq
    cA cc wcel cA cim cfv cc wcel cA cim cfv cc0 wceq cA cim cfv cneg cc0 wceq
    wb cA cc wcel cA cim cfv cA imcl recnd cA cim cfv negeq0 syl cA reim0b cA
    cc wcel cA cim cfv cneg ce cfv cc0 ce cfv wceq cA cim cfv cneg cc0 wceq cA
    cim cfv cneg ce cfv c1 wceq cA cim cfv cneg cr wcel cc0 cr wcel cA cim cfv
    cneg ce cfv cc0 ce cfv wceq cA cim cfv cneg cc0 wceq wb cA cc wcel cA cim
    cfv cneg cc0 reef11 cA cc wcel cA cim cfv cr wcel cA cim cfv cneg cr wcel
    cA imcl cA cim cfv renegcl syl 0re sylancl cc0 ce cfv c1 cA cim cfv cneg ce
    cfv ef0 eqeq2i syl5bbr 3bitr4rd bitr2d $.
    $( [25-Mar-2009] $) $( [21-Aug-2008] $)

  $( MAY BE REVISED - make obsolete $)
  $( A number whose imaginary exponential is one is real. $)
  efieq1re $p |- ( ( A e. CC /\ ( exp ` ( _i x. A ) ) = 1 ) -> A e. RR ) $=
    cA cc wcel ci cA cmul co ce cfv c1 wceq cA cr wcel cA cc wcel ci cA cmul co
    ce cfv c1 wceq cA cim cfv cneg ce cfv c1 cabs cfv wceq cA cr wcel cA cc
    wcel ci cA cmul co ce cfv c1 wceq ci cA cre cfv cmul co ce cfv cA cim cfv
    cneg ce cfv cmul co c1 wceq cA cim cfv cneg ce cfv c1 cabs cfv wceq cA cc
    wcel ci cA cmul co ce cfv ci cA cre cfv cmul co ce cfv cA cim cfv cneg ce
    cfv cmul co c1 cA cc wcel ci cA cmul co ce cfv ci cA cre cfv cmul co cA cim
    cfv cneg caddc co ce cfv ci cA cre cfv cmul co ce cfv cA cim cfv cneg ce
    cfv cmul co cA cc wcel ci cA cmul co ci cA cre cfv cmul co cA cim cfv cneg
    caddc co ce cA cc wcel ci cA cmul co ci cA cre cfv ci cA cim cfv cmul co
    caddc co cmul co ci cA cre cfv cmul co ci ci cA cim cfv cmul co cmul co
    caddc co ci cA cre cfv cmul co cA cim cfv cneg caddc co cA cc wcel cA cA
    cre cfv ci cA cim cfv cmul co caddc co ci cmul cA replim opreq2d cA cre cfv
    cc wcel ci cA cim cfv cmul co cc wcel ci cA cre cfv ci cA cim cfv cmul co
    caddc co cmul co ci cA cre cfv cmul co ci ci cA cim cfv cmul co cmul co
    caddc co wceq cA cc wcel ci cc wcel cA cre cfv cc wcel ci cA cim cfv cmul
    co cc wcel ci cA cre cfv ci cA cim cfv cmul co caddc co cmul co ci cA cre
    cfv cmul co ci ci cA cim cfv cmul co cmul co caddc co wceq axicn ci cA cre
    cfv ci cA cim cfv cmul co adddi mp3an1 cA cc wcel cA cre cfv cA recl recnd
    ci cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel cA cc wcel ci
    cA cim cfv mulcl axicn cA cc wcel cA cim cfv cA imcl recnd sylancr sylanc
    cA cc wcel ci ci cA cim cfv cmul co cmul co cA cim cfv cneg ci cA cre cfv
    cmul co caddc cA cc wcel ci ci cmul co cA cim cfv cmul co ci ci cA cim cfv
    cmul co cmul co cA cim cfv cneg cA cc wcel cA cim cfv cc wcel ci ci cmul co
    cA cim cfv cmul co ci ci cA cim cfv cmul co cmul co wceq cA cc wcel cA cim
    cfv cA imcl recnd ci cc wcel ci cc wcel cA cim cfv cc wcel ci ci cmul co cA
    cim cfv cmul co ci ci cA cim cfv cmul co cmul co wceq axicn axicn ci ci cA
    cim cfv mulass mp3an12 syl cA cc wcel c1 cneg cA cim cfv cmul co cA cim cfv
    cneg ci ci cmul co cA cim cfv cmul co cA cc wcel cA cim cfv cc wcel c1 cneg
    cA cim cfv cmul co cA cim cfv cneg wceq cA cc wcel cA cim cfv cA imcl recnd
    cA cim cfv mulm1 syl ci ci cmul co c1 cneg cA cim cfv cmul ixi opreq1i
    syl5eq eqtr3d opreq2d 3eqtrd fveq2d ci cA cre cfv cmul co cc wcel cA cim
    cfv cneg cc wcel ci cA cre cfv cmul co cA cim cfv cneg caddc co ce cfv ci
    cA cre cfv cmul co ce cfv cA cim cfv cneg ce cfv cmul co wceq cA cc wcel ci
    cA cre cfv cmul co cA cim cfv cneg efadd ci cc wcel cA cre cfv cc wcel ci
    cA cre cfv cmul co cc wcel cA cc wcel ci cA cre cfv mulcl axicn cA cc wcel
    cA cre cfv cA recl recnd sylancr cA cc wcel cA cim cfv cneg cA cc wcel cA
    cim cfv cr wcel cA cim cfv cneg cr wcel cA imcl cA cim cfv renegcl syl
    recnd sylanc eqtrd eqeq1d cA cc wcel ci cA cre cfv cmul co ce cfv cA cim
    cfv cneg ce cfv cmul co c1 wceq cA cim cfv cneg ce cfv c1 cabs cfv wceq cA
    cc wcel ci cA cre cfv cmul co ce cfv cA cim cfv cneg ce cfv cmul co c1 wceq
    cA cim cfv cneg ce cfv ci cA cre cfv cmul co ce cfv cA cim cfv cneg ce cfv
    cmul co cabs cfv c1 cabs cfv cA cc wcel ci cA cre cfv cmul co ce cfv cA cim
    cfv cneg ce cfv cmul co cabs cfv ci cA cre cfv cmul co ce cfv cabs cfv cA
    cim cfv cneg ce cfv cabs cfv cmul co c1 cA cim cfv cneg ce cfv cmul co cA
    cim cfv cneg ce cfv ci cA cre cfv cmul co ce cfv cc wcel cA cim cfv cneg ce
    cfv cc wcel ci cA cre cfv cmul co ce cfv cA cim cfv cneg ce cfv cmul co
    cabs cfv ci cA cre cfv cmul co ce cfv cabs cfv cA cim cfv cneg ce cfv cabs
    cfv cmul co wceq cA cc wcel ci cA cre cfv cmul co ce cfv cA cim cfv cneg ce
    cfv absmul cA cc wcel ci cA cre cfv cmul co cc wcel ci cA cre cfv cmul co
    ce cfv cc wcel ci cc wcel cA cre cfv cc wcel ci cA cre cfv cmul co cc wcel
    cA cc wcel ci cA cre cfv mulcl axicn cA cc wcel cA cre cfv cA recl recnd
    sylancr ci cA cre cfv cmul co efcl syl cA cc wcel cA cim cfv cneg cc wcel
    cA cim cfv cneg ce cfv cc wcel cA cc wcel cA cim cfv cneg cA cc wcel cA cim
    cfv cr wcel cA cim cfv cneg cr wcel cA imcl cA cim cfv renegcl syl recnd cA
    cim cfv cneg efcl syl sylanc cA cc wcel ci cA cre cfv cmul co ce cfv cabs
    cfv c1 cA cim cfv cneg ce cfv cabs cfv cA cim cfv cneg ce cfv cmul cA cc
    wcel cA cre cfv cr wcel ci cA cre cfv cmul co ce cfv cabs cfv c1 wceq cA
    recl cA cre cfv absefi syl cA cim cfv cneg ce cfv cr wcel cc0 cA cim cfv
    cneg ce cfv cle wbr cA cim cfv cneg ce cfv cabs cfv cA cim cfv cneg ce cfv
    wceq cA cc wcel cA cim cfv cneg ce cfv absid cA cc wcel cA cim cfv cneg cr
    wcel cA cim cfv cneg ce cfv cr wcel cA cc wcel cA cim cfv cr wcel cA cim
    cfv cneg cr wcel cA imcl cA cim cfv renegcl syl cA cim cfv cneg reefcl syl
    cA cim cfv cneg ce cfv cr wcel cc0 cA cim cfv cneg ce cfv clt wbr cc0 cA
    cim cfv cneg ce cfv cle wbr cA cc wcel cc0 cr wcel cA cim cfv cneg ce cfv
    cr wcel cc0 cA cim cfv cneg ce cfv clt wbr cc0 cA cim cfv cneg ce cfv cle
    wbr wi 0re cc0 cA cim cfv cneg ce cfv ltle mpan cA cc wcel cA cim cfv cneg
    cr wcel cA cim cfv cneg ce cfv cr wcel cA cc wcel cA cim cfv cr wcel cA cim
    cfv cneg cr wcel cA imcl cA cim cfv renegcl syl cA cim cfv cneg reefcl syl
    cA cc wcel cA cim cfv cneg cr wcel cc0 cA cim cfv cneg ce cfv clt wbr cA cc
    wcel cA cim cfv cr wcel cA cim cfv cneg cr wcel cA imcl cA cim cfv renegcl
    syl cA cim cfv cneg efgt0 syl sylc sylanc opreq12d cA cc wcel cA cim cfv
    cneg ce cfv cc wcel c1 cA cim cfv cneg ce cfv cmul co cA cim cfv cneg ce
    cfv wceq cA cc wcel cA cim cfv cneg cc wcel cA cim cfv cneg ce cfv cc wcel
    cA cc wcel cA cim cfv cneg cA cc wcel cA cim cfv cr wcel cA cim cfv cneg cr
    wcel cA imcl cA cim cfv renegcl syl recnd cA cim cfv cneg efcl syl cA cim
    cfv cneg ce cfv mulid2 syl 3eqtrrd ci cA cre cfv cmul co ce cfv cA cim cfv
    cneg ce cfv cmul co c1 cabs fveq2 sylan9eq ex sylbid cA cc wcel cA cim cfv
    cc0 wceq cA cim cfv cneg cc0 wceq cA cr wcel cA cim cfv cneg ce cfv c1 cabs
    cfv wceq cA cc wcel cA cim cfv cc wcel cA cim cfv cc0 wceq cA cim cfv cneg
    cc0 wceq wb cA cc wcel cA cim cfv cA imcl recnd cA cim cfv negeq0 syl cA
    reim0b cA cc wcel cA cim cfv cneg ce cfv cc0 ce cfv wceq cA cim cfv cneg
    cc0 wceq cA cim cfv cneg ce cfv c1 cabs cfv wceq cA cim cfv cneg cr wcel
    cc0 cr wcel cA cim cfv cneg ce cfv cc0 ce cfv wceq cA cim cfv cneg cc0 wceq
    wb cA cc wcel cA cim cfv cneg cc0 reef11 cA cc wcel cA cim cfv cr wcel cA
    cim cfv cneg cr wcel cA imcl cA cim cfv renegcl syl 0re sylancl cc0 ce cfv
    c1 cabs cfv cA cim cfv cneg ce cfv cc0 ce cfv c1 c1 cabs cfv ef0 cc0 c1 cle
    wbr c1 cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp
    eqtr4i eqeq2i syl5bbr 3bitr4rd sylibd imp $.
    $( [25-Mar-2009] $) $( [21-Aug-2008] $)

  ${
    $d x k $.  $d x N $.  $d A x $.  $d A k $.
    $( De Moivre's Formula.  Proof by induction given at
       ~ http://en.wikipedia.org/wiki/De&#x5F;Moivre&#x27;s&#x5F;formula , but
       restricted to nonnegative integer powers.  (Contributed by Steve
       Rodriguez, 10-Nov-2006.)  _Warning:  The HTML proof page is 0.6 megabyte
       in size_. $)
    demoivre $p |- ( ( A e. CC /\ N e. NN0 ) ->
                  ( ( ( cos ` A ) + ( _i x. ( sin ` A ) ) ) ^ N ) =
                 ( ( cos ` ( N x. A ) ) + ( _i x. ( sin ` ( N x. A ) ) ) ) ) $=
      cN cn0 wcel cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co cN
      cexp co cN cA cmul co ccos cfv ci cN cA cmul co csin cfv cmul co caddc co
      wceq cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co vx cv cexp co
      vx cv cA cmul co ccos cfv ci vx cv cA cmul co csin cfv cmul co caddc co
      wceq wi cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co cc0 cexp
      co cc0 cA cmul co ccos cfv ci cc0 cA cmul co csin cfv cmul co caddc co
      wceq wi cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co vk cv cexp
      co vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc
      co wceq wi cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co vk cv
      c1 caddc co cexp co vk cv c1 caddc co cA cmul co ccos cfv ci vk cv c1
      caddc co cA cmul co csin cfv cmul co caddc co wceq wi cA cc wcel cA ccos
      cfv ci cA csin cfv cmul co caddc co cN cexp co cN cA cmul co ccos cfv ci
      cN cA cmul co csin cfv cmul co caddc co wceq wi vx vk cN vx cv cc0 wceq
      cA ccos cfv ci cA csin cfv cmul co caddc co vx cv cexp co vx cv cA cmul
      co ccos cfv ci vx cv cA cmul co csin cfv cmul co caddc co wceq cA ccos
      cfv ci cA csin cfv cmul co caddc co cc0 cexp co cc0 cA cmul co ccos cfv
      ci cc0 cA cmul co csin cfv cmul co caddc co wceq cA cc wcel vx cv cc0
      wceq cA ccos cfv ci cA csin cfv cmul co caddc co vx cv cexp co cA ccos
      cfv ci cA csin cfv cmul co caddc co cc0 cexp co vx cv cA cmul co ccos cfv
      ci vx cv cA cmul co csin cfv cmul co caddc co cc0 cA cmul co ccos cfv ci
      cc0 cA cmul co csin cfv cmul co caddc co vx cv cc0 cA ccos cfv ci cA csin
      cfv cmul co caddc co cexp opreq2 vx cv cc0 wceq vx cv cA cmul co ccos cfv
      cc0 cA cmul co ccos cfv ci vx cv cA cmul co csin cfv cmul co ci cc0 cA
      cmul co csin cfv cmul co caddc vx cv cc0 wceq vx cv cA cmul co cc0 cA
      cmul co ccos vx cv cc0 cA cmul opreq1 fveq2d vx cv cc0 wceq vx cv cA cmul
      co csin cfv cc0 cA cmul co csin cfv ci cmul vx cv cc0 wceq vx cv cA cmul
      co cc0 cA cmul co csin vx cv cc0 cA cmul opreq1 fveq2d opreq2d opreq12d
      eqeq12d imbi2d vx cv vk cv wceq cA ccos cfv ci cA csin cfv cmul co caddc
      co vx cv cexp co vx cv cA cmul co ccos cfv ci vx cv cA cmul co csin cfv
      cmul co caddc co wceq cA ccos cfv ci cA csin cfv cmul co caddc co vk cv
      cexp co vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co
      caddc co wceq cA cc wcel vx cv vk cv wceq cA ccos cfv ci cA csin cfv cmul
      co caddc co vx cv cexp co cA ccos cfv ci cA csin cfv cmul co caddc co vk
      cv cexp co vx cv cA cmul co ccos cfv ci vx cv cA cmul co csin cfv cmul co
      caddc co vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co
      caddc co vx cv vk cv cA ccos cfv ci cA csin cfv cmul co caddc co cexp
      opreq2 vx cv vk cv wceq vx cv cA cmul co ccos cfv vk cv cA cmul co ccos
      cfv ci vx cv cA cmul co csin cfv cmul co ci vk cv cA cmul co csin cfv
      cmul co caddc vx cv vk cv wceq vx cv cA cmul co vk cv cA cmul co ccos vx
      cv vk cv cA cmul opreq1 fveq2d vx cv vk cv wceq vx cv cA cmul co csin cfv
      vk cv cA cmul co csin cfv ci cmul vx cv vk cv wceq vx cv cA cmul co vk cv
      cA cmul co csin vx cv vk cv cA cmul opreq1 fveq2d opreq2d opreq12d
      eqeq12d imbi2d vx cv vk cv c1 caddc co wceq cA ccos cfv ci cA csin cfv
      cmul co caddc co vx cv cexp co vx cv cA cmul co ccos cfv ci vx cv cA cmul
      co csin cfv cmul co caddc co wceq cA ccos cfv ci cA csin cfv cmul co
      caddc co vk cv c1 caddc co cexp co vk cv c1 caddc co cA cmul co ccos cfv
      ci vk cv c1 caddc co cA cmul co csin cfv cmul co caddc co wceq cA cc wcel
      vx cv vk cv c1 caddc co wceq cA ccos cfv ci cA csin cfv cmul co caddc co
      vx cv cexp co cA ccos cfv ci cA csin cfv cmul co caddc co vk cv c1 caddc
      co cexp co vx cv cA cmul co ccos cfv ci vx cv cA cmul co csin cfv cmul co
      caddc co vk cv c1 caddc co cA cmul co ccos cfv ci vk cv c1 caddc co cA
      cmul co csin cfv cmul co caddc co vx cv vk cv c1 caddc co cA ccos cfv ci
      cA csin cfv cmul co caddc co cexp opreq2 vx cv vk cv c1 caddc co wceq vx
      cv cA cmul co ccos cfv vk cv c1 caddc co cA cmul co ccos cfv ci vx cv cA
      cmul co csin cfv cmul co ci vk cv c1 caddc co cA cmul co csin cfv cmul co
      caddc vx cv vk cv c1 caddc co wceq vx cv cA cmul co vk cv c1 caddc co cA
      cmul co ccos vx cv vk cv c1 caddc co cA cmul opreq1 fveq2d vx cv vk cv c1
      caddc co wceq vx cv cA cmul co csin cfv vk cv c1 caddc co cA cmul co csin
      cfv ci cmul vx cv vk cv c1 caddc co wceq vx cv cA cmul co vk cv c1 caddc
      co cA cmul co csin vx cv vk cv c1 caddc co cA cmul opreq1 fveq2d opreq2d
      opreq12d eqeq12d imbi2d vx cv cN wceq cA ccos cfv ci cA csin cfv cmul co
      caddc co vx cv cexp co vx cv cA cmul co ccos cfv ci vx cv cA cmul co csin
      cfv cmul co caddc co wceq cA ccos cfv ci cA csin cfv cmul co caddc co cN
      cexp co cN cA cmul co ccos cfv ci cN cA cmul co csin cfv cmul co caddc co
      wceq cA cc wcel vx cv cN wceq cA ccos cfv ci cA csin cfv cmul co caddc co
      vx cv cexp co cA ccos cfv ci cA csin cfv cmul co caddc co cN cexp co vx
      cv cA cmul co ccos cfv ci vx cv cA cmul co csin cfv cmul co caddc co cN
      cA cmul co ccos cfv ci cN cA cmul co csin cfv cmul co caddc co vx cv cN
      cA ccos cfv ci cA csin cfv cmul co caddc co cexp opreq2 vx cv cN wceq vx
      cv cA cmul co ccos cfv cN cA cmul co ccos cfv ci vx cv cA cmul co csin
      cfv cmul co ci cN cA cmul co csin cfv cmul co caddc vx cv cN wceq vx cv
      cA cmul co cN cA cmul co ccos vx cv cN cA cmul opreq1 fveq2d vx cv cN
      wceq vx cv cA cmul co csin cfv cN cA cmul co csin cfv ci cmul vx cv cN
      wceq vx cv cA cmul co cN cA cmul co csin vx cv cN cA cmul opreq1 fveq2d
      opreq2d opreq12d eqeq12d imbi2d cA cc wcel cA ccos cfv ci cA csin cfv
      cmul co caddc co cc0 cexp co c1 cc0 cA cmul co ccos cfv ci cc0 cA cmul co
      csin cfv cmul co caddc co cA cc wcel cA ccos cfv ci cA csin cfv cmul co
      caddc co cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co cc0 cexp co
      c1 wceq cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel cA ccos cfv ci
      cA csin cfv cmul co caddc co cc wcel cA cc wcel cA ccos cfv ci cA csin
      cfv cmul co addcl cA coscl ci cc wcel cA csin cfv cc wcel ci cA csin cfv
      cmul co cc wcel cA cc wcel ci cA csin cfv mulcl axicn cA sincl sylancr
      sylanc cA ccos cfv ci cA csin cfv cmul co caddc co exp0 syl cA cc wcel
      cc0 cA cmul co ccos cfv ci cc0 cA cmul co csin cfv cmul co caddc co c1
      cc0 caddc co c1 cA cc wcel cc0 cA cmul co ccos cfv c1 ci cc0 cA cmul co
      csin cfv cmul co cc0 caddc cA cc wcel cc0 cA cmul co ccos cfv cc0 ccos
      cfv c1 cA cc wcel cc0 cA cmul co cc0 ccos cA mul02 fveq2d cos0 syl6eq cA
      cc wcel ci cc0 cA cmul co csin cfv cmul co ci cc0 cmul co cc0 cA cc wcel
      cc0 cA cmul co csin cfv cc0 ci cmul cA cc wcel cc0 cA cmul co csin cfv
      cc0 csin cfv cc0 cA cc wcel cc0 cA cmul co cc0 csin cA mul02 fveq2d sin0
      syl6eq opreq2d ci axicn mul01i syl6eq opreq12d c1 ax1cn addid1i syl6eq
      eqtr4d vk cv cn0 wcel cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc
      co vk cv cexp co vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv
      cmul co caddc co wceq cA ccos cfv ci cA csin cfv cmul co caddc co vk cv
      c1 caddc co cexp co vk cv c1 caddc co cA cmul co ccos cfv ci vk cv c1
      caddc co cA cmul co csin cfv cmul co caddc co wceq vk cv cn0 wcel cA cc
      wcel cA ccos cfv ci cA csin cfv cmul co caddc co vk cv cexp co vk cv cA
      cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co wceq cA
      ccos cfv ci cA csin cfv cmul co caddc co vk cv c1 caddc co cexp co vk cv
      c1 caddc co cA cmul co ccos cfv ci vk cv c1 caddc co cA cmul co csin cfv
      cmul co caddc co wceq vk cv cn0 wcel cA cc wcel wa cA ccos cfv ci cA csin
      cfv cmul co caddc co vk cv cexp co vk cv cA cmul co ccos cfv ci vk cv cA
      cmul co csin cfv cmul co caddc co wceq wa cA ccos cfv ci cA csin cfv cmul
      co caddc co vk cv c1 caddc co cexp co cA ccos cfv ci cA csin cfv cmul co
      caddc co vk cv cexp co cA ccos cfv ci cA csin cfv cmul co caddc co cmul
      co vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc
      co cA ccos cfv ci cA csin cfv cmul co caddc co cmul co vk cv c1 caddc co
      cA cmul co ccos cfv ci vk cv c1 caddc co cA cmul co csin cfv cmul co
      caddc co vk cv cn0 wcel cA cc wcel wa cA ccos cfv ci cA csin cfv cmul co
      caddc co vk cv c1 caddc co cexp co cA ccos cfv ci cA csin cfv cmul co
      caddc co vk cv cexp co cA ccos cfv ci cA csin cfv cmul co caddc co cmul
      co wceq cA ccos cfv ci cA csin cfv cmul co caddc co vk cv cexp co vk cv
      cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co wceq cA
      cc wcel vk cv cn0 wcel cA ccos cfv ci cA csin cfv cmul co caddc co vk cv
      c1 caddc co cexp co cA ccos cfv ci cA csin cfv cmul co caddc co vk cv
      cexp co cA ccos cfv ci cA csin cfv cmul co caddc co cmul co wceq cA ccos
      cfv ci cA csin cfv cmul co caddc co cc wcel vk cv cn0 wcel cA ccos cfv ci
      cA csin cfv cmul co caddc co vk cv c1 caddc co cexp co cA ccos cfv ci cA
      csin cfv cmul co caddc co vk cv cexp co cA ccos cfv ci cA csin cfv cmul
      co caddc co cmul co wceq cA cc wcel cA ccos cfv ci cA csin cfv cmul co
      caddc co vk cv expp1 cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel
      cA ccos cfv ci cA csin cfv cmul co caddc co cc wcel cA cc wcel cA ccos
      cfv ci cA csin cfv cmul co addcl cA coscl ci cc wcel cA csin cfv cc wcel
      ci cA csin cfv cmul co cc wcel cA cc wcel ci cA csin cfv mulcl axicn cA
      sincl sylancr sylanc sylan ancoms adantr cA ccos cfv ci cA csin cfv cmul
      co caddc co vk cv cexp co vk cv cA cmul co ccos cfv ci vk cv cA cmul co
      csin cfv cmul co caddc co wceq cA ccos cfv ci cA csin cfv cmul co caddc
      co vk cv cexp co cA ccos cfv ci cA csin cfv cmul co caddc co cmul co vk
      cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co cA
      ccos cfv ci cA csin cfv cmul co caddc co cmul co wceq vk cv cn0 wcel cA
      cc wcel wa cA ccos cfv ci cA csin cfv cmul co caddc co vk cv cexp co vk
      cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co cA
      ccos cfv ci cA csin cfv cmul co caddc co cmul opreq1 adantl vk cv cn0
      wcel cA cc wcel wa vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv
      cmul co caddc co cA ccos cfv ci cA csin cfv cmul co caddc co cmul co vk
      cv c1 caddc co cA cmul co ccos cfv ci vk cv c1 caddc co cA cmul co csin
      cfv cmul co caddc co wceq cA ccos cfv ci cA csin cfv cmul co caddc co vk
      cv cexp co vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co
      caddc co wceq vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cA caddc co
      ccos cfv ci vk cv cA cmul co cA caddc co csin cfv cmul co caddc co vk cv
      cA cmul co cA caddc co ccos cfv ci vk cv cA cmul co ccos cfv cA csin cfv
      cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul co caddc co cmul co
      caddc co vk cv c1 caddc co cA cmul co ccos cfv ci vk cv c1 caddc co cA
      cmul co csin cfv cmul co caddc co vk cv cA cmul co ccos cfv ci vk cv cA
      cmul co csin cfv cmul co caddc co cA ccos cfv ci cA csin cfv cmul co
      caddc co cmul co vk cv cn0 wcel cA cc wcel wa ci vk cv cA cmul co cA
      caddc co csin cfv cmul co ci vk cv cA cmul co ccos cfv cA csin cfv cmul
      co cA ccos cfv vk cv cA cmul co csin cfv cmul co caddc co cmul co vk cv
      cA cmul co cA caddc co ccos cfv caddc vk cv cn0 wcel cA cc wcel wa vk cv
      cA cmul co cA caddc co csin cfv vk cv cA cmul co ccos cfv cA csin cfv
      cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul co caddc co ci cmul vk
      cv cn0 wcel cA cc wcel wa vk cv cA cmul co cA caddc co csin cfv vk cv cA
      cmul co csin cfv cA ccos cfv cmul co vk cv cA cmul co ccos cfv cA csin
      cfv cmul co caddc co cA ccos cfv vk cv cA cmul co csin cfv cmul co vk cv
      cA cmul co ccos cfv cA csin cfv cmul co caddc co vk cv cA cmul co ccos
      cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul co
      caddc co vk cv cn0 wcel cA cc wcel vk cv cA cmul co cc wcel vk cv cA cmul
      co cA caddc co csin cfv vk cv cA cmul co csin cfv cA ccos cfv cmul co vk
      cv cA cmul co ccos cfv cA csin cfv cmul co caddc co wceq vk cv cc wcel cA
      cc wcel vk cv cA cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv
      nn0cn sylan vk cv cA cmul co cA sinadd sylancom vk cv cn0 wcel cA cc wcel
      wa cA ccos cfv vk cv cA cmul co csin cfv cmul co vk cv cA cmul co csin
      cfv cA ccos cfv cmul co vk cv cA cmul co ccos cfv cA csin cfv cmul co
      caddc cA ccos cfv cc wcel vk cv cA cmul co csin cfv cc wcel cA ccos cfv
      vk cv cA cmul co csin cfv cmul co vk cv cA cmul co csin cfv cA ccos cfv
      cmul co wceq vk cv cn0 wcel cA cc wcel wa cA ccos cfv vk cv cA cmul co
      csin cfv mulcom cA cc wcel cA ccos cfv cc wcel vk cv cn0 wcel cA coscl
      adantl vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel vk cv cA
      cmul co csin cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul co cc
      wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co
      sincl syl sylanc opreq1d cA ccos cfv vk cv cA cmul co csin cfv cmul co cc
      wcel vk cv cA cmul co ccos cfv cA csin cfv cmul co cc wcel cA ccos cfv vk
      cv cA cmul co csin cfv cmul co vk cv cA cmul co ccos cfv cA csin cfv cmul
      co caddc co vk cv cA cmul co ccos cfv cA csin cfv cmul co cA ccos cfv vk
      cv cA cmul co csin cfv cmul co caddc co wceq vk cv cn0 wcel cA cc wcel wa
      cA ccos cfv vk cv cA cmul co csin cfv cmul co vk cv cA cmul co ccos cfv
      cA csin cfv cmul co addcom cA ccos cfv cc wcel vk cv cA cmul co csin cfv
      cc wcel cA ccos cfv vk cv cA cmul co csin cfv cmul co cc wcel vk cv cn0
      wcel cA cc wcel wa cA ccos cfv vk cv cA cmul co csin cfv mulcl cA cc wcel
      cA ccos cfv cc wcel vk cv cn0 wcel cA coscl adantl vk cv cn0 wcel cA cc
      wcel wa vk cv cA cmul co cc wcel vk cv cA cmul co csin cfv cc wcel vk cv
      cc wcel cA cc wcel vk cv cA cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl
      vk cv nn0cn sylan vk cv cA cmul co sincl syl sylanc vk cv cA cmul co ccos
      cfv cc wcel cA csin cfv cc wcel vk cv cA cmul co ccos cfv cA csin cfv
      cmul co cc wcel vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co ccos cfv cA
      csin cfv mulcl vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel vk
      cv cA cmul co ccos cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul co
      cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co
      coscl syl cA cc wcel cA csin cfv cc wcel vk cv cn0 wcel cA sincl adantl
      sylanc sylanc 3eqtr2d opreq2d opreq2d vk cv cn0 wcel cA cc wcel wa vk cv
      c1 caddc co cA cmul co ccos cfv vk cv cA cmul co cA caddc co ccos cfv ci
      vk cv c1 caddc co cA cmul co csin cfv cmul co ci vk cv cA cmul co cA
      caddc co csin cfv cmul co caddc vk cv cn0 wcel cA cc wcel wa vk cv c1
      caddc co cA cmul co vk cv cA cmul co cA caddc co ccos vk cv cn0 wcel c1
      cc wcel cA cc wcel vk cv c1 caddc co cA cmul co vk cv cA cmul co cA caddc
      co wceq ax1cn vk cv cc wcel c1 cc wcel cA cc wcel vk cv c1 caddc co cA
      cmul co vk cv cA cmul co cA caddc co wceq vk cv cn0 wcel vk cv cc wcel c1
      cc wcel cA cc wcel w3a vk cv c1 caddc co cA cmul co vk cv cA cmul co c1
      cA cmul co caddc co vk cv cA cmul co cA caddc co vk cv c1 cA adddir cA cc
      wcel vk cv cc wcel vk cv cA cmul co c1 cA cmul co caddc co vk cv cA cmul
      co cA caddc co wceq c1 cc wcel cA cc wcel c1 cA cmul co cA vk cv cA cmul
      co caddc cA mulid2 opreq2d 3ad2ant3 eqtrd vk cv nn0cn syl3an1 mp3an2
      fveq2d vk cv cn0 wcel cA cc wcel wa vk cv c1 caddc co cA cmul co csin cfv
      vk cv cA cmul co cA caddc co csin cfv ci cmul vk cv cn0 wcel cA cc wcel
      wa vk cv c1 caddc co cA cmul co vk cv cA cmul co cA caddc co csin vk cv
      cn0 wcel c1 cc wcel cA cc wcel vk cv c1 caddc co cA cmul co vk cv cA cmul
      co cA caddc co wceq ax1cn vk cv cc wcel c1 cc wcel cA cc wcel vk cv c1
      caddc co cA cmul co vk cv cA cmul co cA caddc co wceq vk cv cn0 wcel vk
      cv cc wcel c1 cc wcel cA cc wcel w3a vk cv c1 caddc co cA cmul co vk cv
      cA cmul co c1 cA cmul co caddc co vk cv cA cmul co cA caddc co vk cv c1
      cA adddir cA cc wcel vk cv cc wcel vk cv cA cmul co c1 cA cmul co caddc
      co vk cv cA cmul co cA caddc co wceq c1 cc wcel cA cc wcel c1 cA cmul co
      cA vk cv cA cmul co caddc cA mulid2 opreq2d 3ad2ant3 eqtrd vk cv nn0cn
      syl3an1 mp3an2 fveq2d opreq2d opreq12d vk cv cn0 wcel cA cc wcel wa vk cv
      cA cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co cA ccos
      cfv ci cA csin cfv cmul co caddc co cmul co vk cv cA cmul co ccos cfv cA
      ccos cfv cmul co cA csin cfv vk cv cA cmul co csin cfv cmul co cmin co ci
      vk cv cA cmul co ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul
      co csin cfv cmul co caddc co cmul co caddc co vk cv cA cmul co cA caddc
      co ccos cfv ci vk cv cA cmul co ccos cfv cA csin cfv cmul co cA ccos cfv
      vk cv cA cmul co csin cfv cmul co caddc co cmul co caddc co vk cv cn0
      wcel cA cc wcel wa vk cv cA cmul co ccos cfv ci vk cv cA cmul co csin cfv
      cmul co caddc co cA ccos cfv ci cA csin cfv cmul co caddc co cmul co vk
      cv cA cmul co ccos cfv cA ccos cfv cmul co c1 cneg cA csin cfv vk cv cA
      cmul co csin cfv cmul co cmul co caddc co ci vk cv cA cmul co ccos cfv cA
      csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul co caddc co
      cmul co caddc co vk cv cA cmul co ccos cfv cA ccos cfv cmul co cA csin
      cfv vk cv cA cmul co csin cfv cmul co cneg caddc co ci vk cv cA cmul co
      ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul
      co caddc co cmul co caddc co vk cv cA cmul co ccos cfv cA ccos cfv cmul
      co cA csin cfv vk cv cA cmul co csin cfv cmul co cmin co ci vk cv cA cmul
      co ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv
      cmul co caddc co cmul co caddc co vk cv cn0 wcel cA cc wcel wa vk cv cA
      cmul co ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co cA ccos
      cfv ci cA csin cfv cmul co caddc co cmul co vk cv cA cmul co ccos cfv cA
      ccos cfv cmul co ci cA csin cfv cmul co ci vk cv cA cmul co csin cfv cmul
      co cmul co caddc co vk cv cA cmul co ccos cfv ci cA csin cfv cmul co cmul
      co cA ccos cfv ci vk cv cA cmul co csin cfv cmul co cmul co caddc co
      caddc co vk cv cA cmul co ccos cfv cA ccos cfv cmul co c1 cneg cA csin
      cfv vk cv cA cmul co csin cfv cmul co cmul co caddc co vk cv cA cmul co
      ccos cfv ci cA csin cfv cmul co cmul co cA ccos cfv ci vk cv cA cmul co
      csin cfv cmul co cmul co caddc co caddc co vk cv cA cmul co ccos cfv cA
      ccos cfv cmul co c1 cneg cA csin cfv vk cv cA cmul co csin cfv cmul co
      cmul co caddc co ci vk cv cA cmul co ccos cfv cA csin cfv cmul co cA ccos
      cfv vk cv cA cmul co csin cfv cmul co caddc co cmul co caddc co vk cv cA
      cmul co ccos cfv cc wcel ci vk cv cA cmul co csin cfv cmul co cc wcel wa
      cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel wa vk cv cA cmul co
      ccos cfv ci vk cv cA cmul co csin cfv cmul co caddc co cA ccos cfv ci cA
      csin cfv cmul co caddc co cmul co vk cv cA cmul co ccos cfv cA ccos cfv
      cmul co ci cA csin cfv cmul co ci vk cv cA cmul co csin cfv cmul co cmul
      co caddc co vk cv cA cmul co ccos cfv ci cA csin cfv cmul co cmul co cA
      ccos cfv ci vk cv cA cmul co csin cfv cmul co cmul co caddc co caddc co
      wceq vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co ccos cfv ci vk cv cA
      cmul co csin cfv cmul co cA ccos cfv ci cA csin cfv cmul co muladd vk cv
      cn0 wcel cA cc wcel wa vk cv cA cmul co ccos cfv cc wcel ci vk cv cA cmul
      co csin cfv cmul co cc wcel vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co
      cc wcel vk cv cA cmul co ccos cfv cc wcel vk cv cc wcel cA cc wcel vk cv
      cA cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv
      cA cmul co coscl syl vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc
      wcel vk cv cA cmul co csin cfv cc wcel ci vk cv cA cmul co csin cfv cmul
      co cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul co cc wcel vk cv cn0
      wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co sincl ci cc wcel
      vk cv cA cmul co csin cfv cc wcel ci vk cv cA cmul co csin cfv cmul co cc
      wcel axicn ci vk cv cA cmul co csin cfv mulcl mpan 3syl jca cA cc wcel cA
      ccos cfv cc wcel ci cA csin cfv cmul co cc wcel wa vk cv cn0 wcel cA cc
      wcel cA ccos cfv cc wcel ci cA csin cfv cmul co cc wcel cA coscl ci cc
      wcel cA csin cfv cc wcel ci cA csin cfv cmul co cc wcel cA cc wcel ci cA
      csin cfv mulcl axicn cA sincl sylancr jca adantl sylanc vk cv cn0 wcel cA
      cc wcel wa vk cv cA cmul co ccos cfv cA ccos cfv cmul co ci cA csin cfv
      cmul co ci vk cv cA cmul co csin cfv cmul co cmul co caddc co vk cv cA
      cmul co ccos cfv cA ccos cfv cmul co c1 cneg cA csin cfv vk cv cA cmul co
      csin cfv cmul co cmul co caddc co vk cv cA cmul co ccos cfv ci cA csin
      cfv cmul co cmul co cA ccos cfv ci vk cv cA cmul co csin cfv cmul co cmul
      co caddc co caddc vk cv cn0 wcel cA cc wcel wa ci cA csin cfv cmul co ci
      vk cv cA cmul co csin cfv cmul co cmul co c1 cneg cA csin cfv vk cv cA
      cmul co csin cfv cmul co cmul co vk cv cA cmul co ccos cfv cA ccos cfv
      cmul co caddc ci cc wcel cA csin cfv cc wcel wa ci cc wcel vk cv cA cmul
      co csin cfv cc wcel wa ci cA csin cfv cmul co ci vk cv cA cmul co csin
      cfv cmul co cmul co c1 cneg cA csin cfv vk cv cA cmul co csin cfv cmul co
      cmul co wceq vk cv cn0 wcel cA cc wcel wa ci cc wcel cA csin cfv cc wcel
      wa ci cc wcel vk cv cA cmul co csin cfv cc wcel wa wa ci cA csin cfv cmul
      co ci vk cv cA cmul co csin cfv cmul co cmul co ci ci cmul co cA csin cfv
      vk cv cA cmul co csin cfv cmul co cmul co c1 cneg cA csin cfv vk cv cA
      cmul co csin cfv cmul co cmul co ci cA csin cfv ci vk cv cA cmul co csin
      cfv mul4 ci ci cmul co c1 cneg cA csin cfv vk cv cA cmul co csin cfv cmul
      co cmul ixi opreq1i syl6eq vk cv cn0 wcel cA cc wcel wa cA csin cfv cc
      wcel ci cc wcel cA cc wcel cA csin cfv cc wcel vk cv cn0 wcel cA sincl
      adantl axicn jctil vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co csin cfv
      cc wcel ci cc wcel vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel
      vk cv cA cmul co csin cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul
      co cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul
      co sincl syl axicn jctil sylanc opreq2d opreq1d vk cv cn0 wcel cA cc wcel
      wa vk cv cA cmul co ccos cfv ci cA csin cfv cmul co cmul co cA ccos cfv
      ci vk cv cA cmul co csin cfv cmul co cmul co caddc co ci vk cv cA cmul co
      ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul
      co caddc co cmul co vk cv cA cmul co ccos cfv cA ccos cfv cmul co c1 cneg
      cA csin cfv vk cv cA cmul co csin cfv cmul co cmul co caddc co caddc vk
      cv cn0 wcel cA cc wcel wa vk cv cA cmul co ccos cfv ci cA csin cfv cmul
      co cmul co cA ccos cfv ci vk cv cA cmul co csin cfv cmul co cmul co caddc
      co ci vk cv cA cmul co ccos cfv cA csin cfv cmul co cmul co ci cA ccos
      cfv vk cv cA cmul co csin cfv cmul co cmul co caddc co ci vk cv cA cmul
      co ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv
      cmul co caddc co cmul co vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co
      ccos cfv ci cA csin cfv cmul co cmul co ci vk cv cA cmul co ccos cfv cA
      csin cfv cmul co cmul co cA ccos cfv ci vk cv cA cmul co csin cfv cmul co
      cmul co ci cA ccos cfv vk cv cA cmul co csin cfv cmul co cmul co caddc vk
      cv cA cmul co ccos cfv cc wcel cA csin cfv cc wcel vk cv cA cmul co ccos
      cfv ci cA csin cfv cmul co cmul co ci vk cv cA cmul co ccos cfv cA csin
      cfv cmul co cmul co wceq vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co
      ccos cfv cc wcel ci cc wcel cA csin cfv cc wcel vk cv cA cmul co ccos cfv
      ci cA csin cfv cmul co cmul co ci vk cv cA cmul co ccos cfv cA csin cfv
      cmul co cmul co wceq axicn vk cv cA cmul co ccos cfv ci cA csin cfv mul12
      mp3an2 vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel vk cv cA
      cmul co ccos cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul co cc
      wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co
      coscl syl cA cc wcel cA csin cfv cc wcel vk cv cn0 wcel cA sincl adantl
      sylanc cA ccos cfv cc wcel vk cv cA cmul co csin cfv cc wcel cA ccos cfv
      ci vk cv cA cmul co csin cfv cmul co cmul co ci cA ccos cfv vk cv cA cmul
      co csin cfv cmul co cmul co wceq vk cv cn0 wcel cA cc wcel wa cA ccos cfv
      cc wcel ci cc wcel vk cv cA cmul co csin cfv cc wcel cA ccos cfv ci vk cv
      cA cmul co csin cfv cmul co cmul co ci cA ccos cfv vk cv cA cmul co csin
      cfv cmul co cmul co wceq axicn cA ccos cfv ci vk cv cA cmul co csin cfv
      mul12 mp3an2 cA cc wcel cA ccos cfv cc wcel vk cv cn0 wcel cA coscl
      adantl vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel vk cv cA
      cmul co csin cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul co cc
      wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co
      sincl syl sylanc opreq12d vk cv cA cmul co ccos cfv cA csin cfv cmul co
      cc wcel cA ccos cfv vk cv cA cmul co csin cfv cmul co cc wcel ci vk cv cA
      cmul co ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin
      cfv cmul co caddc co cmul co ci vk cv cA cmul co ccos cfv cA csin cfv
      cmul co cmul co ci cA ccos cfv vk cv cA cmul co csin cfv cmul co cmul co
      caddc co wceq vk cv cn0 wcel cA cc wcel wa ci cc wcel vk cv cA cmul co
      ccos cfv cA csin cfv cmul co cc wcel cA ccos cfv vk cv cA cmul co csin
      cfv cmul co cc wcel ci vk cv cA cmul co ccos cfv cA csin cfv cmul co cA
      ccos cfv vk cv cA cmul co csin cfv cmul co caddc co cmul co ci vk cv cA
      cmul co ccos cfv cA csin cfv cmul co cmul co ci cA ccos cfv vk cv cA cmul
      co csin cfv cmul co cmul co caddc co wceq axicn ci vk cv cA cmul co ccos
      cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul co
      adddi mp3an1 vk cv cA cmul co ccos cfv cc wcel cA csin cfv cc wcel vk cv
      cA cmul co ccos cfv cA csin cfv cmul co cc wcel vk cv cn0 wcel cA cc wcel
      wa vk cv cA cmul co ccos cfv cA csin cfv mulcl vk cv cn0 wcel cA cc wcel
      wa vk cv cA cmul co cc wcel vk cv cA cmul co ccos cfv cc wcel vk cv cc
      wcel cA cc wcel vk cv cA cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl vk
      cv nn0cn sylan vk cv cA cmul co coscl syl cA cc wcel cA csin cfv cc wcel
      vk cv cn0 wcel cA sincl adantl sylanc cA ccos cfv cc wcel vk cv cA cmul
      co csin cfv cc wcel cA ccos cfv vk cv cA cmul co csin cfv cmul co cc wcel
      vk cv cn0 wcel cA cc wcel wa cA ccos cfv vk cv cA cmul co csin cfv mulcl
      cA cc wcel cA ccos cfv cc wcel vk cv cn0 wcel cA coscl adantl vk cv cn0
      wcel cA cc wcel wa vk cv cA cmul co cc wcel vk cv cA cmul co csin cfv cc
      wcel vk cv cc wcel cA cc wcel vk cv cA cmul co cc wcel vk cv cn0 wcel vk
      cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co sincl syl sylanc sylanc
      eqtr4d opreq2d 3eqtrd vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co ccos
      cfv cA ccos cfv cmul co c1 cneg cA csin cfv vk cv cA cmul co csin cfv
      cmul co cmul co caddc co vk cv cA cmul co ccos cfv cA ccos cfv cmul co cA
      csin cfv vk cv cA cmul co csin cfv cmul co cneg caddc co ci vk cv cA cmul
      co ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv
      cmul co caddc co cmul co caddc vk cv cn0 wcel cA cc wcel wa c1 cneg cA
      csin cfv vk cv cA cmul co csin cfv cmul co cmul co cA csin cfv vk cv cA
      cmul co csin cfv cmul co cneg vk cv cA cmul co ccos cfv cA ccos cfv cmul
      co caddc vk cv cn0 wcel cA cc wcel wa cA csin cfv vk cv cA cmul co csin
      cfv cmul co cc wcel c1 cneg cA csin cfv vk cv cA cmul co csin cfv cmul co
      cmul co cA csin cfv vk cv cA cmul co csin cfv cmul co cneg wceq cA csin
      cfv cc wcel vk cv cA cmul co csin cfv cc wcel cA csin cfv vk cv cA cmul
      co csin cfv cmul co cc wcel vk cv cn0 wcel cA cc wcel wa cA csin cfv vk
      cv cA cmul co csin cfv mulcl cA cc wcel cA csin cfv cc wcel vk cv cn0
      wcel cA sincl adantl vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc
      wcel vk cv cA cmul co csin cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA
      cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA
      cmul co sincl syl sylanc cA csin cfv vk cv cA cmul co csin cfv cmul co
      mulm1 syl opreq2d opreq1d vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co
      ccos cfv cA ccos cfv cmul co cA csin cfv vk cv cA cmul co csin cfv cmul
      co cneg caddc co vk cv cA cmul co ccos cfv cA ccos cfv cmul co cA csin
      cfv vk cv cA cmul co csin cfv cmul co cmin co ci vk cv cA cmul co ccos
      cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul co csin cfv cmul co
      caddc co cmul co caddc vk cv cA cmul co ccos cfv cA ccos cfv cmul co cc
      wcel cA csin cfv vk cv cA cmul co csin cfv cmul co cc wcel vk cv cA cmul
      co ccos cfv cA ccos cfv cmul co cA csin cfv vk cv cA cmul co csin cfv
      cmul co cneg caddc co vk cv cA cmul co ccos cfv cA ccos cfv cmul co cA
      csin cfv vk cv cA cmul co csin cfv cmul co cmin co wceq vk cv cn0 wcel cA
      cc wcel wa vk cv cA cmul co ccos cfv cA ccos cfv cmul co cA csin cfv vk
      cv cA cmul co csin cfv cmul co negsub vk cv cA cmul co ccos cfv cc wcel
      cA ccos cfv cc wcel vk cv cA cmul co ccos cfv cA ccos cfv cmul co cc wcel
      vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co ccos cfv cA ccos cfv mulcl
      vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel vk cv cA cmul co
      ccos cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul co cc wcel vk cv
      cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul co coscl syl cA
      cc wcel cA ccos cfv cc wcel vk cv cn0 wcel cA coscl adantl sylanc cA csin
      cfv cc wcel vk cv cA cmul co csin cfv cc wcel cA csin cfv vk cv cA cmul
      co csin cfv cmul co cc wcel vk cv cn0 wcel cA cc wcel wa cA csin cfv vk
      cv cA cmul co csin cfv mulcl cA cc wcel cA csin cfv cc wcel vk cv cn0
      wcel cA sincl adantl vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc
      wcel vk cv cA cmul co csin cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA
      cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA
      cmul co sincl syl sylanc sylanc opreq1d 3eqtrd vk cv cn0 wcel cA cc wcel
      wa vk cv cA cmul co cA caddc co ccos cfv vk cv cA cmul co ccos cfv cA
      ccos cfv cmul co cA csin cfv vk cv cA cmul co csin cfv cmul co cmin co ci
      vk cv cA cmul co ccos cfv cA csin cfv cmul co cA ccos cfv vk cv cA cmul
      co csin cfv cmul co caddc co cmul co caddc vk cv cn0 wcel cA cc wcel wa
      vk cv cA cmul co cA caddc co ccos cfv vk cv cA cmul co ccos cfv cA ccos
      cfv cmul co vk cv cA cmul co csin cfv cA csin cfv cmul co cmin co vk cv
      cA cmul co ccos cfv cA ccos cfv cmul co cA csin cfv vk cv cA cmul co csin
      cfv cmul co cmin co vk cv cn0 wcel cA cc wcel vk cv cA cmul co cc wcel vk
      cv cA cmul co cA caddc co ccos cfv vk cv cA cmul co ccos cfv cA ccos cfv
      cmul co vk cv cA cmul co csin cfv cA csin cfv cmul co cmin co wceq vk cv
      cc wcel cA cc wcel vk cv cA cmul co cc wcel vk cv cn0 wcel vk cv cA mulcl
      vk cv nn0cn sylan vk cv cA cmul co cA cosadd sylancom vk cv cn0 wcel cA
      cc wcel wa vk cv cA cmul co csin cfv cA csin cfv cmul co cA csin cfv vk
      cv cA cmul co csin cfv cmul co vk cv cA cmul co ccos cfv cA ccos cfv cmul
      co cmin vk cv cA cmul co csin cfv cc wcel cA csin cfv cc wcel vk cv cA
      cmul co csin cfv cA csin cfv cmul co cA csin cfv vk cv cA cmul co csin
      cfv cmul co wceq vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co csin cfv
      cA csin cfv mulcom vk cv cn0 wcel cA cc wcel wa vk cv cA cmul co cc wcel
      vk cv cA cmul co csin cfv cc wcel vk cv cc wcel cA cc wcel vk cv cA cmul
      co cc wcel vk cv cn0 wcel vk cv cA mulcl vk cv nn0cn sylan vk cv cA cmul
      co sincl syl cA cc wcel cA csin cfv cc wcel vk cv cn0 wcel cA sincl
      adantl sylanc opreq2d eqtrd opreq1d eqtr4d 3eqtr4rd adantr 3eqtrd exp31
      a2d nn0ind impcom $.
      $( [10-Nov-2006] $) $( [9-Nov-2006] $)

    $( Shorter proof of ~ demoivre using the exponential function. $)
    demoivreALT $p |- ( ( A e. CC /\ N e. NN0 ) ->
                  ( ( ( cos ` A ) + ( _i x. ( sin ` A ) ) ) ^ N ) =
                 ( ( cos ` ( N x. A ) ) + ( _i x. ( sin ` ( N x. A ) ) ) ) ) $=
      cA cc wcel cN cn0 wcel wa cN ci cA cmul co cmul co ce cfv ci cA cmul co
      ce cfv cN cexp co cN cA cmul co ccos cfv ci cN cA cmul co csin cfv cmul
      co caddc co cA ccos cfv ci cA csin cfv cmul co caddc co cN cexp co ci cA
      cmul co cc wcel cN cn0 wcel cN ci cA cmul co cmul co ce cfv ci cA cmul co
      ce cfv cN cexp co wceq cA cc wcel ci cA cmul co cN efexp ci cc wcel cA cc
      wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan sylan cA cc wcel cN cc
      wcel cN ci cA cmul co cmul co ce cfv cN cA cmul co ccos cfv ci cN cA cmul
      co csin cfv cmul co caddc co wceq cN cn0 wcel cN cc wcel cA cc wcel cN ci
      cA cmul co cmul co ce cfv cN cA cmul co ccos cfv ci cN cA cmul co csin
      cfv cmul co caddc co wceq cN cc wcel cA cc wcel wa cN ci cA cmul co cmul
      co ce cfv ci cN cA cmul co cmul co ce cfv cN cA cmul co ccos cfv ci cN cA
      cmul co csin cfv cmul co caddc co cN cc wcel cA cc wcel wa cN ci cA cmul
      co cmul co ci cN cA cmul co cmul co ce cN cc wcel ci cc wcel cA cc wcel
      cN ci cA cmul co cmul co ci cN cA cmul co cmul co wceq axicn cN ci cA
      mul12 mp3an2 fveq2d cN cc wcel cA cc wcel wa cN cA cmul co cc wcel ci cN
      cA cmul co cmul co ce cfv cN cA cmul co ccos cfv ci cN cA cmul co csin
      cfv cmul co caddc co wceq cN cA mulcl cN cA cmul co efival syl eqtrd
      ancoms cN nn0cn sylan2 cA cc wcel ci cA cmul co ce cfv cN cexp co cA ccos
      cfv ci cA csin cfv cmul co caddc co cN cexp co wceq cN cn0 wcel cA cc
      wcel ci cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co cN
      cexp cA efival opreq1d adantr 3eqtr3rd $.
      $( [18-Aug-2007] $) $( [24-Jul-2007] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
              Axiom of dependent choice
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  ${
    $d k s t u v x y z A $.  $d k s t u v x y z F $.  $d u v x y z G $.
    $d s t S $.  $d k s t x y z c $.  $d k s t u v x y z r $.
    acdc3lem.1 $e |- A e. _V $.
    acdc3lem.2 $e |- S = { <. <. x , y >. , z >. |
               ( ( x e. A /\ y e. A ) /\ z = U. { v e. ( F ` x ) |
                        A. u e. ( F ` x ) -. u r v } ) } $.
    acdc3lem.3 $e |- G = ( S seq1 ( NN X. { c } ) ) $.
    $( Lemma for ~ acdc3 .  Build a sequence ` G ` starting at value ` c ` , as
       follows.  Given a previous value ` x ` of ` G ` , we construct, for the
       next value of ` G ` , the ` v ` such that
       ` A. u e. ( F `` x ) -. u r v ` , which is unique when ` r ` is a
       well-ordering on ` A ` . $)
    acdc3lem $p |- ( ( r We A /\ ( c e. A /\ F : A --> ( ~P A \ { (/) } ) ) )
                 -> ( G : NN --> A /\ ( G ` 1 ) = c /\
       A. k e. NN ( G ` ( k + 1 ) ) e. ( F ` ( G ` k ) ) ) ) $=
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cn cA cG wf
      c1 cG cfv vc cv wceq vk cv c1 caddc co cG cfv vk cv cG cfv cF cfv wcel vk
      cn wral cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cn
      cA cS cn vc cv csn cxp cseq1 co wf cn cA cG wf cn cA cn vc cv csn cxp wf
      cA cA cxp cA cS wf cn cA cS cn vc cv csn cxp cseq1 co wf cA vr cv wwe vc
      cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cA cS cn vc cv csn cxp vx vy
      vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS acdc3lem.1 acdc3lem.1 acdc3lem.2 oprabex2 cn vc cv csn nnex
      vc cv snex xpex seq1f vc cv cA wcel cn cA cn vc cv csn cxp wf cA vr cv
      wwe cA cA cpw c0 csn cdif cF wf cn vc cv csn cn vc cv csn cxp wf vc cv
      csn cA wss cn cA cn vc cv csn cxp wf vc cv cA wcel cn vc cv csn cA cn vc
      cv csn cxp fss cn vc cv vc visset fconst vc cv cA snssi sylancr ad2antrl
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cS cA cA cxp
      wfn vs cv vt cv cS co cA wcel vt cA wral vs cA wral wa cA cA cxp cA cS wf
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv
      cS co cA wcel vt cA wral vs cA wral cS cA cA cxp wfn cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vs vt
      cA cA cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv
      cA wcel vt cv cA wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv cA wcel wa wa
      vs cv vt cv cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv
      cF cfv crab cuni cA vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co vu
      cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni wceq
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vx vy vz vs
      cv vt cv cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni cS vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv
      cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv
      cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv
      vs cv cF fvex rabex uniex vx cv vs cv wceq vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab vx cv vs cv wceq vx cv cF cfv vs cv cF cfv
      wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab wceq
      vx cv vs cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr
      wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu
      vx cv cF cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv
      cF cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF cfv vs cv cF cfv wceq vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vs
      cv cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      vs cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv vt cv wceq vu cv vv
      cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni eqidd
      acdc3lem.2 oprabval2 adantl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA wcel vt cv cA wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv cA wcel cA vr cv wwe cA
      cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs cv cF cfv cA wss vs cv
      cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs cv cF fvex wereucl cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel simpll cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 wne cA cA
      cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn cdif wcel vs
      cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA cpw c0 csn
      eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv c0 wceq vs
      cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi
      syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd ex r19.21aivv vx
      vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vx
      cv cF fvex rabex uniex acdc3lem.2 fnoprab2 jctil vs vt cA cA cA cS
      ffnoprv sylibr sylanc cG cS cn vc cv csn cxp cseq1 co wceq cn cA cG wf cn
      cA cS cn vc cv csn cxp cseq1 co wf wb acdc3lem.3 cn cA cG cS cn vc cv csn
      cxp cseq1 co feq1 ax-mp sylibr c1 cG cfv vc cv wceq cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa c1 cG cfv c1 cS cn vc cv csn cxp
      cseq1 co cfv vc cv c1 cG cS cn vc cv csn cxp cseq1 co acdc3lem.3 fveq1i
      c1 cS cn vc cv csn cxp cseq1 co cfv c1 cn vc cv csn cxp cfv vc cv cS cn
      vc cv csn cxp vx vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab cuni cS acdc3lem.1 acdc3lem.1 acdc3lem.2
      oprabex2 cn vc cv csn nnex vc cv snex xpex seq11 c1 cn wcel c1 cn vc cv
      csn cxp cfv vc cv wceq 1nn cn vc cv c1 vc visset fvconst2 ax-mp eqtri
      eqtri a1i cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk
      cv c1 caddc co cG cfv vk cv cG cfv cF cfv wcel vk cn cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv c1 caddc
      co cG cfv vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv
      cG cfv cF cfv crab cuni vk cv cG cfv cF cfv cA vr cv wwe vc cv cA wcel cA
      cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv c1 caddc co cS cn
      vc cv csn cxp cseq1 co cfv vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF
      cfv wral vv vk cv cG cfv cF cfv crab cuni vk cv c1 caddc co cG cfv cA vr
      cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa
      vk cv c1 caddc co cS cn vc cv csn cxp cseq1 co cfv vk cv cS cn vc cv csn
      cxp cseq1 co cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS co vu cv vv cv
      vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv crab cuni
      vk cv cn wcel vk cv c1 caddc co cS cn vc cv csn cxp cseq1 co cfv vk cv cS
      cn vc cv csn cxp cseq1 co cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS
      co wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk
      cv cS cn vc cv csn cxp vx vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv
      cF cfv wral vv vx cv cF cfv crab cuni cS acdc3lem.1 acdc3lem.1 acdc3lem.2
      oprabex2 cn vc cv csn nnex vc cv snex xpex seq1p1 adantl cA vr cv wwe vc
      cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cG
      cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS co vu cv vv cv vr cv wbr wn
      vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv crab cuni vk cv cS cn
      vc cv csn cxp cseq1 co cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS co
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn
      wcel wa vk cv cG cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS co vk cv
      cG cfv vc cv cS co vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral
      vv vk cv cG cfv cF cfv crab cuni vk cv cn wcel vk cv cG cfv vk cv c1
      caddc co cn vc cv csn cxp cfv cS co vk cv cG cfv vc cv cS co wceq cA vr
      cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel vk
      cv c1 caddc co cn vc cv csn cxp cfv vc cv vk cv cG cfv cS vk cv cn wcel
      vk cv c1 caddc co cn wcel vk cv c1 caddc co cn vc cv csn cxp cfv vc cv
      wceq vk cv peano2nn cn vc cv vk cv c1 caddc co vc visset fvconst2 syl
      opreq2d adantl vk cv cG cfv cA wcel vc cv cA wcel vk cv cG cfv vc cv cS
      co vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv
      cF cfv crab cuni wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF
      wf wa wa vk cv cn wcel wa vx vy vz vk cv cG cfv vc cv cA cA vu cv vv cv
      vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni vu cv vv cv
      vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv crab cuni
      cS vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv
      cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv
      vk cv cG cfv cF cfv crab vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv
      wral vv vk cv cG cfv cF cfv vk cv cG cfv cF fvex rabex uniex vx cv vk cv
      cG cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv
      cF cfv crab vx cv vk cv cG cfv wceq vx cv cF cfv vk cv cG cfv cF cfv wceq
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv
      crab wceq vx cv vk cv cG cfv cF fveq2 vx cv cF cfv vk cv cG cfv cF cfv
      wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vk cv cG cfv cF cfv crab
      vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vk
      cv cG cfv cF cfv rabeq vx cv cF cfv vk cv cG cfv cF cfv wceq vu cv vv cv
      vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vk cv cG
      cfv cF cfv wral vv vk cv cG cfv cF cfv vu cv vv cv vr cv wbr wn vu vx cv
      cF cfv vk cv cG cfv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv vc cv
      wceq vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv
      cF cfv crab cuni eqidd acdc3lem.2 oprabval2 cA vr cv wwe vc cv cA wcel cA
      cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cS cn vc cv csn cxp
      cseq1 co cfv cA vk cv cG cfv vk cv cn wcel cn cA cn vc cv csn cxp wf cA
      cA cxp cA cS wf vk cv cS cn vc cv csn cxp cseq1 co cfv cA wcel cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk
      cv cA cS cn vc cv csn cxp vx vy vz cA cA vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vv vx cv cF cfv crab cuni cS acdc3lem.1 acdc3lem.1
      acdc3lem.2 oprabex2 cn vc cv csn nnex vc cv snex xpex seq1cl cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel pm3.27 vc
      cv cA wcel cA cA cpw c0 csn cdif cF wf wa cn cA cn vc cv csn cxp wf cA vr
      cv wwe vk cv cn wcel vc cv cA wcel cn cA cn vc cv csn cxp wf cA cA cpw c0
      csn cdif cF wf cn vc cv csn cn vc cv csn cxp wf vc cv csn cA wss cn cA cn
      vc cv csn cxp wf vc cv cA wcel cn vc cv csn cA cn vc cv csn cxp fss cn vc
      cv vc visset fconst vc cv cA snssi sylancr adantr ad2antlr cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cA cA cxp cA cS wf vk cv
      cn wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cS
      cA cA cxp wfn vs cv vt cv cS co cA wcel vt cA wral vs cA wral wa cA cA
      cxp cA cS wf cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa
      vs cv vt cv cS co cA wcel vt cA wral vs cA wral cS cA cA cxp wfn cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA
      wcel vs vt cA cA cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf
      wa wa vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co cA wcel cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv
      cA wcel wa wa vs cv vt cv cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA vs cv cA wcel vt cv cA wcel wa vs cv vt
      cv cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv
      crab cuni wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa
      wa vx vy vz vs cv vt cv cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cS vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv vs cv cF fvex rabex uniex vx cv vs cv wceq vu cv vv
      cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr
      cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vx cv vs cv wceq vx
      cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral
      vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs
      cv cF cfv crab wceq vx cv vs cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vv vs cv cF cfv crab vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF
      cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv
      vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv vs cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy
      cv vt cv wceq vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni eqidd acdc3lem.2 oprabval2 adantl cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv
      wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA wcel vt cv cA
      wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv
      cA wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs
      cv cF cfv cA vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel
      wa vs cv cF cfv cA cpw wcel vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF
      wf vs cv cA wcel vs cv cF cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn
      cdif cF wf vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF
      cfv cA cpw wcel cA cA cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA
      cpw c0 csn eldifi syl adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs
      cv cF cfv cA wss vs cv cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs
      cv cF fvex wereucl cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel
      simpll cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv
      cF cfv cA cpw wcel vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel vs cv cF cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw
      wcel cA cA cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn
      eldifi syl adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf
      vs cv cA wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF
      wf vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0
      wne cA cA cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn
      cdif wcel vs cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA
      cpw c0 csn eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv
      c0 wceq vs cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid
      syl6eqel necon3bi syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd
      ex r19.21aivv vx vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv vx cv cF fvex rabex uniex acdc3lem.2 fnoprab2 jctil
      vs vt cA cA cA cS ffnoprv sylibr adantr syl3anc vk cv cG cS cn vc cv csn
      cxp cseq1 co acdc3lem.3 fveq1i syl5eqel cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf vk cv cn wcel simplrl sylanc eqtrd vk cv cG cfv vk
      cv cS cn vc cv csn cxp cseq1 co cfv vk cv c1 caddc co cn vc cv csn cxp
      cfv cS vk cv cG cS cn vc cv csn cxp cseq1 co acdc3lem.3 fveq1i opreq1i
      syl5eqr eqtrd vk cv c1 caddc co cG cS cn vc cv csn cxp cseq1 co
      acdc3lem.3 fveq1i syl5eq cA vr cv wwe vk cv cG cfv cF cfv cA wss vk cv cG
      cfv cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv
      vk cv cG cfv cF cfv crab cuni vk cv cG cfv cF cfv wcel cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vv vu cA vk cv
      cG cfv cF cfv vr cv vk cv cG cfv cF fvex wereucl cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa vk cv cn wcel simpll cA vr cv wwe vc
      cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cG
      cfv cF cfv cA cpw wcel vk cv cG cfv cF cfv cA wss cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cG cfv cF
      cfv cA cpw c0 csn cdif wcel vk cv cG cfv cF cfv cA cpw wcel cA cA cpw c0
      csn cdif cF wf vk cv cG cfv cA wcel vk cv cG cfv cF cfv cA cpw c0 csn
      cdif wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk
      cv cn wcel wa cA cA cpw c0 csn cdif vk cv cG cfv cF ffvelrn cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf vk cv cn wcel simplrr cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk
      cv cS cn vc cv csn cxp cseq1 co cfv cA vk cv cG cfv vk cv cn wcel cn cA
      cn vc cv csn cxp wf cA cA cxp cA cS wf vk cv cS cn vc cv csn cxp cseq1 co
      cfv cA wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa
      vk cv cn wcel wa vk cv cA cS cn vc cv csn cxp vx vy vz cA cA vu cv vv cv
      vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni cS acdc3lem.1
      acdc3lem.1 acdc3lem.2 oprabex2 cn vc cv csn nnex vc cv snex xpex seq1cl
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn
      wcel pm3.27 vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa cn cA cn vc cv
      csn cxp wf cA vr cv wwe vk cv cn wcel vc cv cA wcel cn cA cn vc cv csn
      cxp wf cA cA cpw c0 csn cdif cF wf cn vc cv csn cn vc cv csn cxp wf vc cv
      csn cA wss cn cA cn vc cv csn cxp wf vc cv cA wcel cn vc cv csn cA cn vc
      cv csn cxp fss cn vc cv vc visset fconst vc cv cA snssi sylancr adantr
      ad2antlr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cA
      cA cxp cA cS wf vk cv cn wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa cS cA cA cxp wfn vs cv vt cv cS co cA wcel vt cA wral vs
      cA wral wa cA cA cxp cA cS wf cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vs cv vt cv cS co cA wcel vt cA wral vs cA wral cS cA cA
      cxp wfn cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs
      cv vt cv cS co cA wcel vs vt cA cA cA vr cv wwe vc cv cA wcel cA cA cpw
      c0 csn cdif cF wf wa wa vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co
      cA wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs
      cv cA wcel vt cv cA wcel wa wa vs cv vt cv cS co vu cv vv cv vr cv wbr wn
      vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA vs cv cA wcel vt cv cA
      wcel wa vs cv vt cv cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral
      vv vs cv cF cfv crab cuni wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vx vy vz vs cv vt cv cA cA vu cv vv cv vr cv wbr wn
      vu vx cv cF cfv wral vv vx cv cF cfv crab cuni vu cv vv cv vr cv wbr wn
      vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cS vu cv vv cv vr cv wbr
      wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni vu cv vv cv vr cv wbr
      wn vu vs cv cF cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu
      vs cv cF cfv wral vv vs cv cF cfv vs cv cF fvex rabex uniex vx cv vs cv
      wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vx cv
      vs cv wceq vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab wceq vx cv vs cv cF fveq2 vx cv cF cfv vs
      cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vs cv cF cfv
      crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vs cv cF
      cfv rabeq vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv vu cv vv cv vr cv wbr wn vu vx cv cF cfv vs cv cF cfv raleq1 rabbisdv
      eqtrd syl unieqd vy cv vt cv wceq vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni eqidd acdc3lem.2 oprabval2 adantl cA
      vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      cA wcel vt cv cA wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab
      cuni cA wcel vc cv cA wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs
      cv cA wcel wa vs cv cF cfv cA vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel vs cv cF cfv cA wss cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF cfv cA cpw wcel cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn
      cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw c0 csn cdif vs cv cF ffvelrn
      vs cv cF cfv cA cpw c0 csn eldifi syl adantll vs cv cF cfv cA elpwi syl
      cA vr cv wwe vs cv cF cfv cA wss vs cv cF cfv c0 wne vu cv vv cv vr cv
      wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni vs cv cF cfv wcel
      cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vv vu cA vs
      cv cF cfv vr cv vs cv cF fvex wereucl cA vr cv wwe cA cA cpw c0 csn cdif
      cF wf vs cv cA wcel simpll cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs
      cv cA wcel wa vs cv cF cfv cA cpw wcel vs cv cF cfv cA wss cA cA cpw c0
      csn cdif cF wf vs cv cA wcel vs cv cF cfv cA cpw wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn cdif
      wcel vs cv cF cfv cA cpw wcel cA cA cpw c0 csn cdif vs cv cF ffvelrn vs
      cv cF cfv cA cpw c0 csn eldifi syl adantll vs cv cF cfv cA elpwi syl cA
      cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF cfv c0 wne cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn
      cdif wcel vs cv cF cfv c0 wne cA cA cpw c0 csn cdif vs cv cF ffvelrn vs
      cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 csn wcel wn vs cv cF
      cfv c0 wne vs cv cF cfv cA cpw c0 csn eldifn vs cv cF cfv c0 csn wcel vs
      cv cF cfv c0 vs cv cF cfv c0 wceq vs cv cF cfv c0 c0 csn vs cv cF cfv c0
      wceq id c0 0ex snid syl6eqel necon3bi syl syl adantll syl3anc sseldd
      adantlrl adantrr eqeltrd ex r19.21aivv vx vy vz cA cA vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni cS vu cv vv cv vr
      cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr
      wn vu vx cv cF cfv wral vv vx cv cF cfv vx cv cF fvex rabex uniex
      acdc3lem.2 fnoprab2 jctil vs vt cA cA cA cS ffnoprv sylibr adantr syl3anc
      vk cv cG cS cn vc cv csn cxp cseq1 co acdc3lem.3 fveq1i syl5eqel sylanc
      vk cv cG cfv cF cfv cA cpw c0 csn eldifi syl vk cv cG cfv cF cfv cA elpwi
      syl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn
      wcel wa vk cv cG cfv cF cfv cA cpw c0 csn cdif wcel vk cv cG cfv cF cfv
      c0 wne cA cA cpw c0 csn cdif cF wf vk cv cG cfv cA wcel vk cv cG cfv cF
      cfv cA cpw c0 csn cdif wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vk cv cn wcel wa cA cA cpw c0 csn cdif vk cv cG cfv cF
      ffvelrn cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf vk cv cn
      wcel simplrr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa
      vk cv cn wcel wa vk cv cS cn vc cv csn cxp cseq1 co cfv cA vk cv cG cfv
      vk cv cn wcel cn cA cn vc cv csn cxp wf cA cA cxp cA cS wf vk cv cS cn vc
      cv csn cxp cseq1 co cfv cA wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vk cv cn wcel wa vk cv cA cS cn vc cv csn cxp vx vy
      vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS acdc3lem.1 acdc3lem.1 acdc3lem.2 oprabex2 cn vc cv csn nnex
      vc cv snex xpex seq1cl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif
      cF wf wa wa vk cv cn wcel pm3.27 vc cv cA wcel cA cA cpw c0 csn cdif cF
      wf wa cn cA cn vc cv csn cxp wf cA vr cv wwe vk cv cn wcel vc cv cA wcel
      cn cA cn vc cv csn cxp wf cA cA cpw c0 csn cdif cF wf cn vc cv csn cn vc
      cv csn cxp wf vc cv csn cA wss cn cA cn vc cv csn cxp wf vc cv cA wcel cn
      vc cv csn cA cn vc cv csn cxp fss cn vc cv vc visset fconst vc cv cA
      snssi sylancr adantr ad2antlr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa cA cA cxp cA cS wf vk cv cn wcel cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa cS cA cA cxp wfn vs cv vt cv cS co
      cA wcel vt cA wral vs cA wral wa cA cA cxp cA cS wf cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vt cA
      wral vs cA wral cS cA cA cxp wfn cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vs vt cA cA cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv cA
      wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vs cv cA wcel vt cv cA wcel wa wa vs cv vt cv cS co
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      cA vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co vu cv vv cv vr cv wbr
      wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni wceq cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vx vy vz vs cv vt cv cA cA vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni vu
      cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cS
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv vs cv cF fvex
      rabex uniex vx cv vs cv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral
      vv vs cv cF cfv crab vx cv vs cv wceq vx cv cF cfv vs cv cF cfv wceq vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv
      cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab wceq vx cv vs
      cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral
      vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF cfv vs cv cF cfv wceq vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vs cv
      cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv wbr wn vu vx cv cF cfv vs
      cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv vt cv wceq vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni eqidd
      acdc3lem.2 oprabval2 adantl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA wcel vt cv cA wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv cA wcel cA vr cv wwe cA
      cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs cv cF cfv cA wss vs cv
      cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs cv cF fvex wereucl cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel simpll cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 wne cA cA
      cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn cdif wcel vs
      cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA cpw c0 csn
      eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv c0 wceq vs
      cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi
      syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd ex r19.21aivv vx
      vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vx
      cv cF fvex rabex uniex acdc3lem.2 fnoprab2 jctil vs vt cA cA cA cS
      ffnoprv sylibr adantr syl3anc vk cv cG cS cn vc cv csn cxp cseq1 co
      acdc3lem.3 fveq1i syl5eqel sylanc vk cv cG cfv cF cfv cA cpw c0 csn cdif
      wcel vk cv cG cfv cF cfv c0 csn wcel wn vk cv cG cfv cF cfv c0 wne vk cv
      cG cfv cF cfv cA cpw c0 csn eldifn vk cv cG cfv cF cfv c0 csn wcel vk cv
      cG cfv cF cfv c0 vk cv cG cfv cF cfv c0 wceq vk cv cG cfv cF cfv c0 c0
      csn vk cv cG cfv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi syl syl
      syl3anc eqeltrd r19.21aiva 3jca $.
      $( [25-Nov-2007] $) $( [8-Oct-2007] $)
  $}

  ${
    $d a b c d g k r u v x y z A $.  $d c g C $.
    $d a b c d f g h k r u v x y z F $.
    acdc3.1 $e |- A e. _V $.
    $( MAY BE REVISED - to do:  clean up acdc* stuff. $)
    $( Dependent Choice.  Axiom DC1 of [Schechter] p. 149, with the addition
       of an initial value ` C ` .  This theorem is weaker than the Axiom of
       Choice but is stronger than Countable Choice.  It shows the existence of
       a sequence whose values can only be shown to exist (but cannot be
       constructed explicitly) and also depend on earlier values in the
       sequence. $)
    acdc3 $p |- ( ( F : A --> ( ~P A \ { (/) } ) /\ C e. A ) ->
                E. g ( g : NN --> A /\ ( g ` 1 ) = C /\
                  A. k e. NN ( g ` ( k + 1 ) ) e. ( F ` ( g ` k ) ) ) ) $=
      cC cA wcel cA cA cpw c0 csn cdif cF wf cn cA vg cv wf c1 vg cv cfv cC
      wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral
      w3a vg wex cA cA cpw c0 csn cdif cF wf cn cA vg cv wf c1 vg cv cfv vc cv
      wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral
      w3a vg wex wi cA cA cpw c0 csn cdif cF wf cn cA vg cv wf c1 vg cv cfv cC
      wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral
      w3a vg wex wi vc cC cA vc cv cC wceq cn cA vg cv wf c1 vg cv cfv vc cv
      wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral
      w3a vg wex cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv
      cfv vk cv vg cv cfv cF cfv wcel vk cn wral w3a vg wex cA cA cpw c0 csn
      cdif cF wf vc cv cC wceq cn cA vg cv wf c1 vg cv cfv vc cv wceq vk cv c1
      caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral w3a cn cA vg cv
      wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF
      cfv wcel vk cn wral w3a vg vc cv cC wceq c1 vg cv cfv vc cv wceq c1 vg cv
      cfv cC wceq cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF
      cfv wcel vk cn wral vc cv cC c1 vg cv cfv eqeq2 3anbi2d exbidv imbi2d cA
      vr cv wwe vr wex vc cv cA wcel cA cA cpw c0 csn cdif cF wf cn cA vg cv wf
      c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF
      cfv wcel vk cn wral w3a vg wex wi wi vr cA acdc3.1 weth cA vr cv wwe vc
      cv cA wcel cA cA cpw c0 csn cdif cF wf cn cA vg cv wf c1 vg cv cfv vc cv
      wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral
      w3a vg wex wi wi vr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF
      wf cn cA vg cv wf c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk
      cv vg cv cfv cF cfv wcel vk cn wral w3a vg wex cA vr cv wwe vc cv cA wcel
      cA cA cpw c0 csn cdif cF wf wa wa cn cA va cv cA wcel vb cv cA wcel wa vd
      cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab
      cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wf c1 va cv cA
      wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1
      co cfv vc cv wceq vk cv c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni
      wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv vk cv va cv cA wcel
      vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf
      va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co
      cfv cF cfv wcel vk cn wral w3a cn cA vg cv wf c1 vg cv cfv vc cv wceq vk
      cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral w3a vg
      wex vx vy vz vv vu cA va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr
      cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd
      copab2 vk cF va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2
      cn vc cv csn cxp cseq1 co vr vc acdc3.1 va cv cA wcel vb cv cA wcel wa vd
      cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab
      cuni wceq wa va vb vd copab2 vx cv cA wcel vy cv cA wcel wa vd cv vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq wa
      vx vy vd copab2 vx cv cA wcel vy cv cA wcel wa vz cv vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq wa vx vy vz
      copab2 va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa vx cv cA wcel vy cv
      cA wcel wa vd cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv
      cF cfv crab cuni wceq wa va vb vd vx vy va cv vx cv wceq vb cv vy cv wceq
      wa va cv cA wcel vb cv cA wcel wa vx cv cA wcel vy cv cA wcel wa vd cv vh
      cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq
      vd cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      cuni wceq va cv vx cv wceq va cv cA wcel vx cv cA wcel vb cv vy cv wceq
      vb cv cA wcel vy cv cA wcel va cv vx cv cA eleq1 vb cv vy cv cA eleq1
      bi2anan9 va cv vx cv wceq vb cv vy cv wceq wa vh cv vf cv vr cv wbr wn vh
      va cv cF cfv wral vf va cv cF cfv crab cuni vu cv vv cv vr cv wbr wn vu
      vx cv cF cfv wral vv vx cv cF cfv crab cuni vd cv va cv vx cv wceq vb cv
      vy cv wceq wa vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab va cv vx cv wceq vb cv vy cv wceq wa vh cv vf cv vr cv wbr wn vh va
      cv cF cfv wral vf va cv cF cfv crab vh cv vf cv vr cv wbr wn vh vx cv cF
      cfv wral vf vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab va cv vx cv wceq vh cv vf cv vr cv wbr wn vh va
      cv cF cfv wral vf va cv cF cfv crab vh cv vf cv vr cv wbr wn vh vx cv cF
      cfv wral vf vx cv cF cfv crab wceq vb cv vy cv wceq va cv vx cv wceq va
      cv cF cfv vx cv cF cfv wceq vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv crab vh cv vf cv vr cv wbr wn vh vx cv cF cfv wral vf vx
      cv cF cfv crab wceq va cv vx cv cF fveq2 va cv cF cfv vx cv cF cfv wceq
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab vh cv
      vf cv vr cv wbr wn vh va cv cF cfv wral vf vx cv cF cfv crab vh cv vf cv
      vr cv wbr wn vh vx cv cF cfv wral vf vx cv cF cfv crab vh cv vf cv vr cv
      wbr wn vh va cv cF cfv wral vf va cv cF cfv vx cv cF cfv rabeq va cv cF
      cfv vx cv cF cfv wceq vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vh cv
      vf cv vr cv wbr wn vh vx cv cF cfv wral vf vx cv cF cfv vh cv vf cv vr cv
      wbr wn vh va cv cF cfv vx cv cF cfv raleq1 rabbisdv eqtrd syl adantr vh
      cv vf cv vr cv wbr wn vh vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vf vv vx cv cF cfv vf cv vv cv wceq vh cv vf cv vr cv wbr
      wn vh vx cv cF cfv wral vh cv vv cv vr cv wbr wn vh vx cv cF cfv wral vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vf cv vv cv wceq vh cv vf cv
      vr cv wbr wn vh cv vv cv vr cv wbr wn vh vx cv cF cfv vf cv vv cv wceq vh
      cv vf cv vr cv wbr vh cv vv cv vr cv wbr vf cv vv cv vh cv vr cv breq2
      notbid ralbidv vh cv vv cv vr cv wbr wn vu cv vv cv vr cv wbr wn vh vu vx
      cv cF cfv vh cv vu cv wceq vh cv vv cv vr cv wbr vu cv vv cv vr cv wbr vh
      cv vu cv vv cv vr cv breq1 notbid cbvralv syl6bb cbvrabv syl6eq unieqd
      eqeq2d anbi12d cbvoprab12v vx cv cA wcel vy cv cA wcel wa vd cv vu cv vv
      cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq wa vx
      cv cA wcel vy cv cA wcel wa vz cv vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vx cv cF cfv crab cuni wceq wa vx vy vd vz vd cv vz cv wceq
      vd cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      cuni wceq vz cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab cuni wceq vx cv cA wcel vy cv cA wcel wa vd cv vz cv vu cv vv cv
      vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni eqeq1 anbi2d
      cbvoprab3v eqtri va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv
      wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd
      copab2 cn vc cv csn cxp cseq1 co eqid acdc3lem cn cA vg cv wf c1 vg cv
      cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk
      cn wral w3a cn cA va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv
      wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd
      copab2 cn vc cv csn cxp cseq1 co wf c1 va cv cA wcel vb cv cA wcel wa vd
      cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab
      cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv vc cv wceq vk
      cv c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2
      cn vc cv csn cxp cseq1 co cfv vk cv va cv cA wcel vb cv cA wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni
      wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv wcel vk cn
      wral w3a vg va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn
      vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn
      vc cv csn cxp cseq1 co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb
      vd copab2 cn vc cv csn cxp cseq1 oprex vg cv va cv cA wcel vb cv cA wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wceq cn cA vg
      cv wf cn cA va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn
      vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn
      vc cv csn cxp cseq1 co wf c1 vg cv cfv vc cv wceq c1 va cv cA wcel vb cv
      cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv
      cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv vc
      cv wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn
      wral vk cv c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb
      vd copab2 cn vc cv csn cxp cseq1 co cfv vk cv va cv cA wcel vb cv cA wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv
      wcel vk cn wral cn cA vg cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf
      cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va
      vb vd copab2 cn vc cv csn cxp cseq1 co feq1 vg cv va cv cA wcel vb cv cA
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF
      cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wceq c1
      vg cv cfv c1 va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2
      cn vc cv csn cxp cseq1 co cfv vc cv c1 vg cv va cv cA wcel vb cv cA wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co fveq1 eqeq1d
      vg cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va
      cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv
      csn cxp cseq1 co wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv
      wcel vk cv c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb
      vd copab2 cn vc cv csn cxp cseq1 co cfv vk cv va cv cA wcel vb cv cA wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv
      wcel vk cn vg cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv
      wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd
      copab2 cn vc cv csn cxp cseq1 co wceq vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn
      vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn
      vc cv csn cxp cseq1 co cfv vk cv vg cv cfv cF cfv vk cv va cv cA wcel vb
      cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va
      cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv
      cF cfv vk cv c1 caddc co vg cv va cv cA wcel vb cv cA wcel wa vd cv vh cv
      vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa
      va vb vd copab2 cn vc cv csn cxp cseq1 co fveq1 vg cv va cv cA wcel vb cv
      cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv
      cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wceq
      vk cv vg cv cfv vk cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr
      cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd
      copab2 cn vc cv csn cxp cseq1 co cfv cF vk cv vg cv va cv cA wcel vb cv
      cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv
      cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co fveq1
      fveq2d eleq12d ralbidv 3anbi123d cla4ev syl exp32 19.23aiv ax-mp vtoclga
      impcom $.
      $( [25-Nov-2007] $) $( [8-Oct-2007] $)
  $}

  ${
    $d a b c d h g j k r u v x y z A $.  $d a b c d f g h j k r u v x y z F $.
    $d h k B $.  $d g h k C $.  $d h k G $.
    acdc4lem.1 $e |- A e. _V $.
    acdc4lem.2 $e |- G = { <. <. j , y >. , z >. | ( ( j e. NN /\ y e. A ) /\
                  z = ( { ( j + 1 ) } X. ( ( j + 1 ) F y ) ) ) } $.
    acdc4lem.3 $e |- B = ( NN X. A ) $.
    acdc4lem.4 $e |- H = ( 1st o. h ) $.
    $( Lemma for ~ acdc4 . $)
    acdc4lem1 $p |- ( ( G : B --> ( ~P B \ { (/) } ) /\ C e. A ) ->
                E. h ( h : NN --> B /\ ( h ` 1 ) = <. 1 , C >. /\
                  A. k e. NN ( h ` ( k + 1 ) ) e. ( G ` ( h ` k ) ) ) ) $=
      cB cB cpw c0 csn cdif cG wf c1 cC cop cB wcel cn cB vh cv wf c1 vh cv cfv
      c1 cC cop wceq vk cv c1 caddc co vh cv cfv vk cv vh cv cfv cG cfv wcel vk
      cn wral w3a vh wex cC cA wcel cB c1 cC cop vh vk cG cB cn cA cxp cvv
      acdc4lem.3 cn cA nnex acdc4lem.1 xpex eqeltri acdc3 cC cA wcel c1 cC cop
      cn cA cxp cB c1 cn wcel cC cA wcel c1 cC cop cn cA cxp wcel 1nn c1 cC cn
      cA opelxpi mpan cC cA wcel cB cn cA cxp cB cn cA cxp wceq cC cA wcel
      acdc4lem.3 a1i eqcomd eleqtrd sylan2 $.
      $( [24-May-2009] $)

  $}

  ${
    $d a b c d g k r u v x y z A $.  $d a b c d f g h k r u v x y z F $.
    acdc4.1 $e |- A e. _V $.
  $}

  ${
    $d k s t u v x y z A $.  $d k s t u v x y z F $.  $d u v x y z G $.
    $d s t S $.  $d k s t x y z c $.  $d k s t u v x y z r $.
    $d u v x y z K $.  $d u v x y z X $.
    acdc2lem.1 $e |- A e. _V $.
    acdc2lem.2 $e |- S = { <. <. x , y >. , z >. |
               ( ( x e. A /\ y e. NN ) /\ z = U. { v e. ( y F x ) |
                        A. u e. ( y F x ) -. u r v } ) } $.
    acdc2lem.3 $e |- G =
              ( S seq1 ( { <. 1 , c >. } u. ( _I |` ( NN \ { 1 } ) ) ) ) $.
    $( Lemma for ~ acdc2 . $)
    acdc2lem1 $p |- ( ( ( r We A /\ F : ( NN X. A ) --> ( ~P A \ { (/) } ) )
                  /\ ( X e. A /\ K e. NN ) ) ->
             ( ( X S K ) e. ( K F X ) /\ ( X S K ) e. A ) ) $=
      cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cX cA wcel cK cn wcel
      wa wa cX cK cS co cK cX cF co wcel cX cK cS co cA wcel cA vr cv wwe cn cA
      cxp cA cpw c0 csn cdif cF wf wa cX cA wcel cK cn wcel wa wa cX cK cS co
      vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni cK
      cX cF co cX cA wcel cK cn wcel wa cX cK cS co vu cv vv cv vr cv wbr wn vu
      cK cX cF co wral vv cK cX cF co crab cuni wceq cA vr cv wwe cn cA cxp cA
      cpw c0 csn cdif cF wf wa vx vy vz cX cK cA cn vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni vu cv vv cv vr cv
      wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni cS vu cv vv cv vr cv
      wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab cuni vu cv vv cv vr
      cv wbr wn vu cK cX cF co wral vv cK cX cF co crab vu cv vv cv vr cv wbr
      wn vu cK cX cF co wral vv cK cX cF co cK cX cF oprex rabex uniex vx cv cX
      wceq vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF
      co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co
      crab vx cv cX wceq vy cv vx cv cF co vy cv cX cF co wceq vu cv vv cv vr
      cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv
      vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab wceq vx cv cX
      vy cv cF opreq2 vy cv vx cv cF co vy cv cX cF co wceq vu cv vv cv vr cv
      wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv vr
      cv wbr wn vu vy cv vx cv cF co wral vv vy cv cX cF co crab vu cv vv cv vr
      cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv vr cv
      wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co vy cv cX cF co
      rabeq vy cv vx cv cF co vy cv cX cF co wceq vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co wral vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv
      vy cv cX cF co vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co vy cv cX cF
      co raleq1 rabbisdv eqtrd syl unieqd vy cv cK wceq vu cv vv cv vr cv wbr
      wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv vr cv wbr wn
      vu cK cX cF co wral vv cK cX cF co crab vy cv cK wceq vy cv cX cF co cK
      cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX
      cF co crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co
      crab wceq vy cv cK cX cF opreq1 vy cv cX cF co cK cX cF co wceq vu cv vv
      cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv
      vr cv wbr wn vu vy cv cX cF co wral vv cK cX cF co crab vu cv vv cv vr cv
      wbr wn vu cK cX cF co wral vv cK cX cF co crab vu cv vv cv vr cv wbr wn
      vu vy cv cX cF co wral vv vy cv cX cF co cK cX cF co rabeq vy cv cX cF co
      cK cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vu cv vv
      cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co vu cv vv cv vr cv wbr
      wn vu vy cv cX cF co cK cX cF co raleq1 rabbisdv eqtrd syl unieqd
      acdc2lem.2 oprabval2 adantl cA vr cv wwe cK cX cF co cA wss cK cX cF co
      c0 wne vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab
      cuni cK cX cF co wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa
      cX cA wcel cK cn wcel wa wa vv vu cA cK cX cF co vr cv cK cX cF oprex
      wereucl cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn
      wcel wa simpll cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel
      wa cK cX cF co cA wss cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cX
      cA wcel cK cn wcel wa wa cK cX cF co cA cpw wcel cK cX cF co cA wss cn cA
      cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa wa cK cX cF co cA
      cpw c0 csn cdif wcel cK cX cF co cA cpw wcel cn cA cxp cA cpw c0 csn cdif
      cF wf cX cA wcel cK cn wcel cK cX cF co cA cpw c0 csn cdif wcel cn cA cxp
      cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel cK cX cF co cA cpw c0 csn
      cdif wcel cK cX cA cpw c0 csn cdif cn cA cF foprrn 3com23 3expb cK cX cF
      co cA cpw c0 csn eldifi syl cK cX cF co cA elpwi syl adantll cn cA cxp cA
      cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa cK cX cF co c0 wne cA vr
      cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa wa cK
      cX cF co cA cpw c0 csn cdif wcel cK cX cF co c0 wne cn cA cxp cA cpw c0
      csn cdif cF wf cX cA wcel cK cn wcel cK cX cF co cA cpw c0 csn cdif wcel
      cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel cK cX cF co cA
      cpw c0 csn cdif wcel cK cX cA cpw c0 csn cdif cn cA cF foprrn 3com23
      3expb cK cX cF co cA cpw c0 csn cdif wcel cK cX cF co c0 csn wcel wn cK
      cX cF co c0 wne cK cX cF co cA cpw c0 csn eldifn cK cX cF co c0 csn wcel
      cK cX cF co c0 cK cX cF co c0 wceq cK cX cF co c0 c0 csn cK cX cF co c0
      wceq id c0 0ex snid syl6eqel necon3bi syl syl adantll syl3anc eqeltrd cA
      vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cX cA wcel cK cn wcel wa
      wa cK cX cF co cA cX cK cS co cn cA cxp cA cpw c0 csn cdif cF wf cX cA
      wcel cK cn wcel wa cK cX cF co cA wss cA vr cv wwe cn cA cxp cA cpw c0
      csn cdif cF wf cX cA wcel cK cn wcel wa wa cK cX cF co cA cpw wcel cK cX
      cF co cA wss cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa
      wa cK cX cF co cA cpw c0 csn cdif wcel cK cX cF co cA cpw wcel cn cA cxp
      cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel cK cX cF co cA cpw c0 csn
      cdif wcel cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel cK cX
      cF co cA cpw c0 csn cdif wcel cK cX cA cpw c0 csn cdif cn cA cF foprrn
      3com23 3expb cK cX cF co cA cpw c0 csn eldifi syl cK cX cF co cA elpwi
      syl adantll cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cX cA wcel
      cK cn wcel wa wa cX cK cS co vu cv vv cv vr cv wbr wn vu cK cX cF co wral
      vv cK cX cF co crab cuni cK cX cF co cX cA wcel cK cn wcel wa cX cK cS co
      vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni
      wceq cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vx vy vz cX cK cA
      cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF
      co crab cuni vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co
      crab cuni cS vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX
      cF co crab cuni vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF
      co crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co cK cX
      cF oprex rabex uniex vx cv cX wceq vu cv vv cv vr cv wbr wn vu vy cv vx
      cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv
      cX cF co wral vv vy cv cX cF co crab vx cv cX wceq vy cv vx cv cF co vy
      cv cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy
      cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy
      cv cX cF co crab wceq vx cv cX vy cv cF opreq2 vy cv vx cv cF co vy cv cX
      cF co wceq vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx
      cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv
      cX cF co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX
      cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx
      cv cF co vy cv cX cF co rabeq vy cv vx cv cF co vy cv cX cF co wceq vu cv
      vv cv vr cv wbr wn vu vy cv vx cv cF co wral vu cv vv cv vr cv wbr wn vu
      vy cv cX cF co wral vv vy cv cX cF co vu cv vv cv vr cv wbr wn vu vy cv
      vx cv cF co vy cv cX cF co raleq1 rabbisdv eqtrd syl unieqd vy cv cK wceq
      vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu
      cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab vy cv cK
      wceq vy cv cX cF co cK cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX
      cF co wral vv vy cv cX cF co crab vu cv vv cv vr cv wbr wn vu cK cX cF co
      wral vv cK cX cF co crab wceq vy cv cK cX cF opreq1 vy cv cX cF co cK cX
      cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF
      co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv cK cX cF co
      crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab vu
      cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co cK cX cF
      co rabeq vy cv cX cF co cK cX cF co wceq vu cv vv cv vr cv wbr wn vu vy
      cv cX cF co wral vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF
      co vu cv vv cv vr cv wbr wn vu vy cv cX cF co cK cX cF co raleq1 rabbisdv
      eqtrd syl unieqd acdc2lem.2 oprabval2 adantl cA vr cv wwe cK cX cF co cA
      wss cK cX cF co c0 wne vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK
      cX cF co crab cuni cK cX cF co wcel cA vr cv wwe cn cA cxp cA cpw c0 csn
      cdif cF wf wa cX cA wcel cK cn wcel wa wa vv vu cA cK cX cF co vr cv cK
      cX cF oprex wereucl cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cX cA
      wcel cK cn wcel wa simpll cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel
      cK cn wcel wa cK cX cF co cA wss cA vr cv wwe cn cA cxp cA cpw c0 csn
      cdif cF wf cX cA wcel cK cn wcel wa wa cK cX cF co cA cpw wcel cK cX cF
      co cA wss cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa wa
      cK cX cF co cA cpw c0 csn cdif wcel cK cX cF co cA cpw wcel cn cA cxp cA
      cpw c0 csn cdif cF wf cX cA wcel cK cn wcel cK cX cF co cA cpw c0 csn
      cdif wcel cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel cK cX
      cF co cA cpw c0 csn cdif wcel cK cX cA cpw c0 csn cdif cn cA cF foprrn
      3com23 3expb cK cX cF co cA cpw c0 csn eldifi syl cK cX cF co cA elpwi
      syl adantll cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa
      cK cX cF co c0 wne cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cX cA
      wcel cK cn wcel wa wa cK cX cF co cA cpw c0 csn cdif wcel cK cX cF co c0
      wne cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel cK cX cF co
      cA cpw c0 csn cdif wcel cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX
      cA wcel cK cX cF co cA cpw c0 csn cdif wcel cK cX cA cpw c0 csn cdif cn
      cA cF foprrn 3com23 3expb cK cX cF co cA cpw c0 csn cdif wcel cK cX cF co
      c0 csn wcel wn cK cX cF co c0 wne cK cX cF co cA cpw c0 csn eldifn cK cX
      cF co c0 csn wcel cK cX cF co c0 cK cX cF co c0 wceq cK cX cF co c0 c0
      csn cK cX cF co c0 wceq id c0 0ex snid syl6eqel necon3bi syl syl adantll
      syl3anc eqeltrd sseldd jca $.
      $( [26-Oct-2007] $) $( [30-Sep-2007] $)

    $( Lemma for ~ acdc2 .  Build a sequence ` G ` starting at value ` c ` , as
       follows.  Given a previous value ` x ` of ` G ` , we construct, for the
       next value of ` G ` , the ` v ` such that
       ` A. u e. ( y F x ) -. u r v ` , which is unique when ` r ` is a
       well-ordering on ` A ` . $)
    acdc2lem2 $p |- ( ( r We A /\ ( c e. A /\
     F : ( NN X. A ) --> ( ~P A \ { (/) } ) ) ) -> ( G : NN --> A /\
          A. k e. NN ( G ` ( k + 1 ) ) e. ( ( k + 1 ) F ( G ` k ) ) ) ) $=
      cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa cn cA
      cG wf vk cv c1 caddc co cG cfv vk cv c1 caddc co vk cv cG cfv cF co wcel
      vk cn wral cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf
      wa wa cn cA cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf
      cn cA cG wf c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv cA wcel
      cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn
      cdif cres wf wa cA cn cxp cA cS wf cn cA cS c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co wf cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw
      c0 csn cdif cF wf wa wa c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cfv cA wcel cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres
      cun cn c1 csn cdif cres wf cA cn cxp cA cS wf cn cA cS c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cseq1 co wf cA cn cS c1 vc cv cop csn cid cn
      c1 csn cdif cres cun vx vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx
      cv cF co wral vv vy cv vx cv cF co crab cuni cS acdc2lem.1 nnex
      acdc2lem.2 oprabex2 c1 vc cv cop csn cid cn c1 csn cdif cres c1 vc cv cop
      snex cn c1 csn cdif cvv wcel cid cn c1 csn cdif cres cvv wcel cn cvv wcel
      cn c1 csn cdif cvv wcel nnex cn c1 csn cvv difexg ax-mp cn c1 csn cdif
      cvv resiexg ax-mp unex seq1f2 3expa cA vr cv wwe vc cv cA wcel cn cA cxp
      cA cpw c0 csn cdif cF wf wa wa c1 c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cfv cA wcel cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cn c1 csn cdif cres wf vc cv cA wcel c1 c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cfv cA wcel cA vr cv wwe cn cA cxp cA cpw c0
      csn cdif cF wf vc cv cA wcel vc cv cA c1 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cfv vc cv cA wcel id c1 vc cv cn cid c1 vc cv cop csn cid
      cn c1 csn cdif cres cun c1 cn 1nn elisseti vc visset c1 vc cv cop csn cid
      cn c1 csn cdif cres cun eqid fvsnun1 syl5eqel ad2antrl cn c1 csn cdif cn
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cn c1
      csn cdif cn cid cn c1 csn cdif cres wf cn c1 csn cdif cn c1 csn cdif cid
      cn c1 csn cdif cres wf cn c1 csn cdif cn wss cn c1 csn cdif cn cid cn c1
      csn cdif cres wf cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres
      wf1o cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres wf cn c1 csn
      cdif f1oi cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres f1of
      ax-mp cn c1 csn difss cn c1 csn cdif cn c1 csn cdif cn cid cn c1 csn cdif
      cres fss mp2an c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn
      cdif cres cid cn c1 csn cdif cres wceq cn c1 csn cdif cn c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cn c1 csn cdif cn cid
      cn c1 csn cdif cres wf wb c1 vc cv cop csn cid cn c1 csn cdif cres cun cn
      c1 csn cdif cres c1 vc cv cop csn cn c1 csn cdif cres cid cn c1 csn cdif
      cres cn c1 csn cdif cres cun c0 cid cn c1 csn cdif cres cun cid cn c1 csn
      cdif cres c1 vc cv cop csn cid cn c1 csn cdif cres cn c1 csn cdif
      resundir c1 vc cv cop csn cn c1 csn cdif cres c0 cid cn c1 csn cdif cres
      cn c1 csn cdif cres cid cn c1 csn cdif cres c1 csn cn c1 csn cdif cin c0
      wceq c1 vc cv cop csn cn c1 csn cdif cres c0 wceq c1 csn cn difdisj c1 vc
      cv cop csn c1 csn wfn c1 csn cn c1 csn cdif cin c0 wceq c1 vc cv cop csn
      cn c1 csn cdif cres c0 wceq wb c1 csn vc cv csn c1 vc cv cop csn wf1o c1
      vc cv cop csn c1 csn wfn c1 vc cv c1 cn 1nn elisseti vc visset f1osn c1
      csn vc cv csn c1 vc cv cop csn f1ofn ax-mp c1 csn cn c1 csn cdif c1 vc cv
      cop csn fnresdisj ax-mp mpbi cid cn c1 csn cdif residm uneq12i cid cn c1
      csn cdif cres c0 cun c0 cid cn c1 csn cdif cres cun cid cn c1 csn cdif
      cres cid cn c1 csn cdif cres c0 uncom cid cn c1 csn cdif cres un0 eqtr3i
      3eqtri cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn
      c1 csn cdif cres cid cn c1 csn cdif cres feq1 ax-mp mpbir jctir cA vr cv
      wwe cn cA cxp cA cpw c0 csn cdif cF wf cA cn cxp cA cS wf vc cv cA wcel
      cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cS cA cn cxp wfn vs cv
      vt cv cS co cA wcel vt cn wral vs cA wral wa cA cn cxp cA cS wf cA vr cv
      wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv vt cv cS co cA wcel vt cn
      wral vs cA wral cS cA cn cxp wfn cA vr cv wwe cn cA cxp cA cpw c0 csn
      cdif cF wf wa vs cv vt cv cS co cA wcel vs vt cA cn cA vr cv wwe cn cA
      cxp cA cpw c0 csn cdif cF wf wa vs cv cA wcel vt cv cn wcel wa vs cv vt
      cv cS co cA wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv
      cA wcel vt cv cn wcel wa wa vs cv vt cv cS co vt cv vs cv cF co wcel vs
      cv vt cv cS co cA wcel vx vy vz vv vu cA cS cF cG vt cv vs cv vr vc
      acdc2lem.1 acdc2lem.2 acdc2lem.3 acdc2lem1 pm3.27d ex r19.21aivv vx vy vz
      cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv
      cF co crab cuni cS vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv
      vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral
      vv vy cv vx cv cF co vy cv vx cv cF oprex rabex uniex acdc2lem.2 fnoprab2
      jctil vs vt cA cn cA cS ffnoprv sylibr adantrl sylanc cG cS c1 vc cv cop
      csn cid cn c1 csn cdif cres cun cseq1 co wceq cn cA cG wf cn cA cS c1 vc
      cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf wb acdc2lem.3 cn cA cG
      cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co feq1 ax-mp
      sylibr cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa
      wa vk cv c1 caddc co cG cfv vk cv c1 caddc co vk cv cG cfv cF co wcel vk
      cn cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk
      cv cn wcel wa vk cv c1 caddc co cG cfv vk cv cG cfv vk cv c1 caddc co cS
      co vk cv c1 caddc co vk cv cG cfv cF co vk cv cn wcel vk cv c1 caddc co
      cG cfv vk cv cG cfv vk cv c1 caddc co cS co wceq cA vr cv wwe vc cv cA
      wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel vk cv c1
      caddc co cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk
      cv cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1
      caddc co cS co vk cv c1 caddc co cG cfv vk cv cG cfv vk cv c1 caddc co cS
      co vk cv cn wcel vk cv c1 caddc co cS c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co cfv vk cv cS c1 vc cv cop csn cid cn c1 csn cdif cres
      cun cseq1 co cfv vk cv c1 caddc co c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cfv cS co vk cv cS c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co cfv vk cv c1 caddc co cS co vk cv cS c1 vc cv cop csn cid cn c1
      csn cdif cres cun vx vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv
      cF co wral vv vy cv vx cv cF co crab cuni cS acdc2lem.1 nnex acdc2lem.2
      oprabex2 c1 vc cv cop csn cid cn c1 csn cdif cres c1 vc cv cop snex cn c1
      csn cdif cvv wcel cid cn c1 csn cdif cres cvv wcel cn cvv wcel cn c1 csn
      cdif cvv wcel nnex cn c1 csn cvv difexg ax-mp cn c1 csn cdif cvv resiexg
      ax-mp unex seq1p1 vk cv cn wcel vk cv c1 caddc co c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cfv vk cv c1 caddc co vk cv cS c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co cfv cS vk cv cn wcel vk cv c1 caddc co
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv vk cv c1 caddc co cid
      cfv vk cv c1 caddc co vk cv cn wcel vk cv c1 caddc co cn c1 csn cdif wcel
      vk cv c1 caddc co c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv vk cv
      c1 caddc co cid cfv wceq vk cv seq1lem2 c1 vc cv cn vk cv c1 caddc co cid
      c1 vc cv cop csn cid cn c1 csn cdif cres cun c1 cn 1nn elisseti vc visset
      c1 vc cv cop csn cid cn c1 csn cdif cres cun eqid fvsnun2 syl vk cv c1
      caddc co cvv wcel vk cv c1 caddc co cid cfv vk cv c1 caddc co wceq vk cv
      c1 caddc oprex vk cv c1 caddc co cvv fvi ax-mp syl6eq opreq2d eqtrd vk cv
      c1 caddc co cG cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co
      acdc2lem.3 fveq1i vk cv cG cfv vk cv cS c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co cfv vk cv c1 caddc co cS vk cv cG cS c1 vc cv cop
      csn cid cn c1 csn cdif cres cun cseq1 co acdc2lem.3 fveq1i opreq1i
      3eqtr4g adantl cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf vk cv cG
      cfv cA wcel vk cv c1 caddc co cn wcel vk cv cG cfv vk cv c1 caddc co cS
      co vk cv c1 caddc co vk cv cG cfv cF co wcel cA vr cv wwe vc cv cA wcel
      cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa cA vr cv wwe cn
      cA cxp cA cpw c0 csn cdif cF wf wa vk cv cG cfv cA wcel vk cv c1 caddc co
      cn wcel wa wa vk cv cG cfv vk cv c1 caddc co cS co vk cv c1 caddc co vk
      cv cG cfv cF co wcel vk cv cG cfv vk cv c1 caddc co cS co cA wcel vx vy
      vz vv vu cA cS cF cG vk cv c1 caddc co vk cv cG cfv vr vc acdc2lem.1
      acdc2lem.2 acdc2lem.3 acdc2lem1 pm3.26d cA vr cv wwe vc cv cA wcel cn cA
      cxp cA cpw c0 csn cdif cF wf wa vk cv cn wcel simpll cA vr cv wwe vc cv
      cA wcel cn cA cxp cA cpw c0 csn cdif cF wf vk cv cn wcel simplrr cA vr cv
      wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel
      wa vk cv cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cA
      vk cv cG cfv vk cv cn wcel vc cv cA wcel cA cn cxp cA cS wf vk cv cS c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cA wcel cA vr cv
      wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel
      wa c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv cA wcel cn c1 csn
      cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres
      wf cA cn cxp cA cS wf w3a vk cv cn wcel vk cv cS c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cseq1 co cfv cA wcel vk cv cn wcel vc cv cA wcel cA
      cn cxp cA cS wf w3a vk cv cA cn cS c1 vc cv cop csn cid cn c1 csn cdif
      cres cun vx vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co
      wral vv vy cv vx cv cF co crab cuni cS acdc2lem.1 nnex acdc2lem.2
      oprabex2 c1 vc cv cop csn cid cn c1 csn cdif cres c1 vc cv cop snex cn c1
      csn cdif cvv wcel cid cn c1 csn cdif cres cvv wcel cn cvv wcel cn c1 csn
      cdif cvv wcel nnex cn c1 csn cvv difexg ax-mp cn c1 csn cdif cvv resiexg
      ax-mp unex seq1cl2 vk cv cn wcel vc cv cA wcel cA cn cxp cA cS wf w3a c1
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv cA wcel cn c1 csn cdif
      cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cA
      cn cxp cA cS wf vk cv cn wcel vc cv cA wcel cA cn cxp cA cS wf w3a vc cv
      cA c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv vk cv cn wcel vc
      cv cA wcel cA cn cxp cA cS wf 3simp2 c1 vc cv cn cid c1 vc cv cop csn cid
      cn c1 csn cdif cres cun c1 cn 1nn elisseti vc visset c1 vc cv cop csn cid
      cn c1 csn cdif cres cun eqid fvsnun1 syl5eqel cn c1 csn cdif cn c1 vc cv
      cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf vk cv cn wcel
      vc cv cA wcel cA cn cxp cA cS wf w3a cn c1 csn cdif cn c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cn c1 csn cdif cn cid
      cn c1 csn cdif cres wf cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif
      cres wf cn c1 csn cdif cn wss cn c1 csn cdif cn cid cn c1 csn cdif cres
      wf cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres wf1o cn c1 csn
      cdif cn c1 csn cdif cid cn c1 csn cdif cres wf cn c1 csn cdif f1oi cn c1
      csn cdif cn c1 csn cdif cid cn c1 csn cdif cres f1of ax-mp cn c1 csn
      difss cn c1 csn cdif cn c1 csn cdif cn cid cn c1 csn cdif cres fss mp2an
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres cid cn
      c1 csn cdif cres wceq cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cn c1 csn cdif cres wf cn c1 csn cdif cn cid cn c1 csn cdif
      cres wf wb c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif
      cres c1 vc cv cop csn cn c1 csn cdif cres cid cn c1 csn cdif cres cn c1
      csn cdif cres cun c0 cid cn c1 csn cdif cres cun cid cn c1 csn cdif cres
      c1 vc cv cop csn cid cn c1 csn cdif cres cn c1 csn cdif resundir c1 vc cv
      cop csn cn c1 csn cdif cres c0 cid cn c1 csn cdif cres cn c1 csn cdif
      cres cid cn c1 csn cdif cres c1 csn cn c1 csn cdif cin c0 wceq c1 vc cv
      cop csn cn c1 csn cdif cres c0 wceq c1 csn cn difdisj c1 vc cv cop csn c1
      csn wfn c1 csn cn c1 csn cdif cin c0 wceq c1 vc cv cop csn cn c1 csn cdif
      cres c0 wceq wb c1 csn vc cv csn c1 vc cv cop csn wf1o c1 vc cv cop csn
      c1 csn wfn c1 vc cv c1 cn 1nn elisseti vc visset f1osn c1 csn vc cv csn
      c1 vc cv cop csn f1ofn ax-mp c1 csn cn c1 csn cdif c1 vc cv cop csn
      fnresdisj ax-mp mpbi cid cn c1 csn cdif residm uneq12i cid cn c1 csn cdif
      cres c0 cun c0 cid cn c1 csn cdif cres cun cid cn c1 csn cdif cres cid cn
      c1 csn cdif cres c0 uncom cid cn c1 csn cdif cres un0 eqtr3i 3eqtri cn c1
      csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif
      cres cid cn c1 csn cdif cres feq1 ax-mp mpbir a1i vk cv cn wcel vc cv cA
      wcel cA cn cxp cA cS wf 3simp3 3jca vk cv cn wcel vc cv cA wcel cA cn cxp
      cA cS wf 3simp1 sylanc cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn
      cdif cF wf wa wa vk cv cn wcel pm3.27 cA vr cv wwe vc cv cA wcel cn cA
      cxp cA cpw c0 csn cdif cF wf vk cv cn wcel simplrl cA vr cv wwe vc cv cA
      wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa cA cn cxp cA cS wf vk cv cn
      wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cA cn cxp cA cS wf
      vc cv cA wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cS cA cn
      cxp wfn vs cv vt cv cS co cA wcel vt cn wral vs cA wral wa cA cn cxp cA
      cS wf cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv vt cv cS
      co cA wcel vt cn wral vs cA wral cS cA cn cxp wfn cA vr cv wwe cn cA cxp
      cA cpw c0 csn cdif cF wf wa vs cv vt cv cS co cA wcel vs vt cA cn cA vr
      cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv cA wcel vt cv cn wcel
      wa vs cv vt cv cS co cA wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF
      wf wa vs cv cA wcel vt cv cn wcel wa wa vs cv vt cv cS co vt cv vs cv cF
      co wcel vs cv vt cv cS co cA wcel vx vy vz vv vu cA cS cF cG vt cv vs cv
      vr vc acdc2lem.1 acdc2lem.2 acdc2lem.3 acdc2lem1 pm3.27d ex r19.21aivv vx
      vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv
      vx cv cF co crab cuni cS vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co
      wral vv vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF
      co wral vv vy cv vx cv cF co vy cv vx cv cF oprex rabex uniex acdc2lem.2
      fnoprab2 jctil vs vt cA cn cA cS ffnoprv sylibr adantrl adantr syl3anc vk
      cv cG cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co acdc2lem.3
      fveq1i syl5eqel vk cv cn wcel vk cv c1 caddc co cn wcel cA vr cv wwe vc
      cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv peano2nn adantl
      syl2anc eqeltrd r19.21aiva jca $.
      $( [26-Oct-2007] $) $( [23-Sep-2007] $)
  $}

  ${
    $d a b c d g k r u v x y z A $.  $d a b c d f g h k r u v x y z F $.
    acdc2.1 $e |- A e. _V $.
    $( A more general version of ~ acdc that allows the function ` F ` to
       vary with ` k ` . $)
    acdc2 $p |- ( ( A =/= (/) /\ F : ( NN X. A ) --> ( ~P A \ { (/) } ) ) ->
               E. g ( g : NN --> A /\
           A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) $=
      cA vr cv wwe vr wex cA c0 wne cn cA cxp cA cpw c0 csn cdif cF wf wa cn cA
      vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa vg wex wi vr cA acdc2.1 weth cA vr cv wwe cA c0 wne
      cn cA cxp cA cpw c0 csn cdif cF wf wa cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vg wex
      wi vr cA vr cv wwe cA c0 wne cn cA cxp cA cpw c0 csn cdif cF wf cn cA vg
      cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa vg wex cA vr cv wwe vc cv cA wcel vc wex cn cA cxp cA
      cpw c0 csn cdif cF wf cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vg wex wi cA c0 wne cA
      vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf cn cA vg cv wf
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral wa vg wex wi vc cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0
      csn cdif cF wf cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vg wex cA vr cv wwe vc cv cA
      wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa cn cA va cv cA wcel vb cv
      cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb
      cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cseq1 co wf vk cv c1 caddc co va cv cA wcel vb cv cn
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv
      va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co cfv vk cv c1 caddc co vk cv va cv cA wcel vb
      cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co cfv cF co wcel vk cn wral wa cn cA vg cv
      wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa vg wex vx vy vz vv vu cA va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 vk cF va cv cA wcel vb cv cn
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv
      va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co vr vc acdc2.1 va cv cA wcel vb cv cn wcel wa
      vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv
      cF co crab cuni wceq wa va vb vd copab2 vx cv cA wcel vy cv cn wcel wa vd
      cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF
      co crab cuni wceq wa vx vy vd copab2 vx cv cA wcel vy cv cn wcel wa vz cv
      vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co
      crab cuni wceq wa vx vy vz copab2 va cv cA wcel vb cv cn wcel wa vd cv vh
      cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab
      cuni wceq wa vx cv cA wcel vy cv cn wcel wa vd cv vu cv vv cv vr cv wbr
      wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni wceq wa va vb
      vd vx vy va cv vx cv wceq vb cv vy cv wceq wa va cv cA wcel vb cv cn wcel
      wa vx cv cA wcel vy cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv
      va cv cF co wral vf vb cv va cv cF co crab cuni wceq vd cv vu cv vv cv vr
      cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni wceq
      va cv vx cv wceq va cv cA wcel vx cv cA wcel vb cv vy cv wceq vb cv cn
      wcel vy cv cn wcel va cv vx cv cA eleq1 vb cv vy cv cn eleq1 bi2anan9 va
      cv vx cv wceq vb cv vy cv wceq wa vh cv vf cv vr cv wbr wn vh vb cv va cv
      cF co wral vf vb cv va cv cF co crab cuni vu cv vv cv vr cv wbr wn vu vy
      cv vx cv cF co wral vv vy cv vx cv cF co crab cuni vd cv va cv vx cv wceq
      vb cv vy cv wceq wa vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral
      vv vy cv vx cv cF co crab va cv vx cv wceq vb cv vy cv wceq wa vh cv vf
      cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab vh cv
      vf cv vr cv wbr wn vh vy cv vx cv cF co wral vf vy cv vx cv cF co crab vu
      cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab
      va cv vx cv wceq vb cv vy cv wceq wa vb cv va cv cF co vy cv vx cv cF co
      wceq vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF
      co crab vh cv vf cv vr cv wbr wn vh vy cv vx cv cF co wral vf vy cv vx cv
      cF co crab wceq vb cv vy cv wceq va cv vx cv wceq vb cv va cv cF co vy cv
      vx cv cF co wceq vb cv vy cv va cv vx cv cF opreq12 ancoms vb cv va cv cF
      co vy cv vx cv cF co wceq vh cv vf cv vr cv wbr wn vh vb cv va cv cF co
      wral vf vb cv va cv cF co crab vh cv vf cv vr cv wbr wn vh vb cv va cv cF
      co wral vf vy cv vx cv cF co crab vh cv vf cv vr cv wbr wn vh vy cv vx cv
      cF co wral vf vy cv vx cv cF co crab vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co vy cv vx cv cF co rabeq vb cv va cv cF
      co vy cv vx cv cF co wceq vh cv vf cv vr cv wbr wn vh vb cv va cv cF co
      wral vh cv vf cv vr cv wbr wn vh vy cv vx cv cF co wral vf vy cv vx cv cF
      co vh cv vf cv vr cv wbr wn vh vb cv va cv cF co vy cv vx cv cF co raleq1
      rabbisdv eqtrd syl vh cv vf cv vr cv wbr wn vh vy cv vx cv cF co wral vu
      cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vf vv vy cv vx cv cF co
      vf cv vv cv wceq vh cv vf cv vr cv wbr wn vh vy cv vx cv cF co wral vh cv
      vv cv vr cv wbr wn vh vy cv vx cv cF co wral vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co wral vf cv vv cv wceq vh cv vf cv vr cv wbr wn vh cv vv
      cv vr cv wbr wn vh vy cv vx cv cF co vf cv vv cv wceq vh cv vf cv vr cv
      wbr vh cv vv cv vr cv wbr vf cv vv cv vh cv vr cv breq2 notbid ralbidv vh
      cv vv cv vr cv wbr wn vu cv vv cv vr cv wbr wn vh vu vy cv vx cv cF co vh
      cv vu cv wceq vh cv vv cv vr cv wbr vu cv vv cv vr cv wbr vh cv vu cv vv
      cv vr cv breq1 notbid cbvralv syl6bb cbvrabv syl6eq unieqd eqeq2d anbi12d
      cbvoprab12v vx cv cA wcel vy cv cn wcel wa vd cv vu cv vv cv vr cv wbr wn
      vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni wceq wa vx cv cA
      wcel vy cv cn wcel wa vz cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co
      wral vv vy cv vx cv cF co crab cuni wceq wa vx vy vd vz vd cv vz cv wceq
      vd cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv
      cF co crab cuni wceq vz cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co
      wral vv vy cv vx cv cF co crab cuni wceq vx cv cA wcel vy cv cn wcel wa
      vd cv vz cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv
      vx cv cF co crab cuni eqeq1 anbi2d cbvoprab3v eqtri va cv cA wcel vb cv
      cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb
      cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cseq1 co eqid acdc2lem2 cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa cn cA va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb
      vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf vk cv
      c1 caddc co va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn
      vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd
      copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1
      caddc co vk cv va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb
      vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cF co
      wcel vk cn wral wa vg va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr
      cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq
      wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co
      va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 oprex vg cv va cv cA wcel
      vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral
      vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cseq1 co wceq cn cA vg cv wf cn cA va cv cA
      wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co
      wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop
      csn cid cn c1 csn cdif cres cun cseq1 co wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral vk cv c1 caddc co
      va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1 caddc co
      vk cv va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb
      cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd
      copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cF co
      wcel vk cn wral cn cA vg cv va cv cA wcel vb cv cn wcel wa vd cv vh cv vf
      cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni
      wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co feq1 vg cv va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr
      cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq
      wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cv c1 caddc co va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni
      wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co cfv vk cv c1 caddc co vk cv va cv cA wcel vb cv cn wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co
      crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co cfv cF co wcel vk cn vg cv va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co vk cv c1 caddc co vk cv va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co cfv cF co vk cv c1 caddc co vg cv va cv cA wcel vb
      cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co fveq1 vg cv va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co wceq vk cv vg cv cfv vk cv va cv cA wcel vb cv cn
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv
      va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co cfv vk cv c1 caddc co cF vk cv vg cv va cv cA
      wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co
      wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop
      csn cid cn c1 csn cdif cres cun cseq1 co fveq1 opreq2d eleq12d ralbidv
      anbi12d cla4ev syl exp32 19.23adv vc cA n0 syl5ib imp3a 19.23aiv ax-mp $.
      $( [26-Oct-2007] $) $( [29-Sep-2007] $)
  $}

  ${
    $d k s t u v x y z A $.  $d k s t u v x y z F $.  $d u v x y z G $.
    $d s t S $.  $d k s t x y z c $.  $d k s t u v x y z r $.
    $d u v x y z K $.  $d u v x y z X $.
    acdc5lem.1 $e |- A e. _V $.
    acdc5lem.2 $e |- S = { <. <. x , y >. , z >. |
               ( ( x e. A /\ y e. NN ) /\ z = U. { v e. ( y F x ) |
                        A. u e. ( y F x ) -. u r v } ) } $.
    acdc5lem.3 $e |- G =
              ( S seq1 ( { <. 1 , c >. } u. ( _I |` ( NN \ { 1 } ) ) ) ) $.
    $( Lemma for ~ acdc5 . $)
    acdc5lem1 $p |- ( ( ( r We A /\ F : ( NN X. A ) --> ( ~P A \ { (/) } ) )
                  /\ ( X e. A /\ K e. NN ) ) ->
             ( ( X S K ) e. ( K F X ) /\ ( X S K ) e. A ) ) $=
      cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cX cA wcel cK cn wcel
      wa wa cX cK cS co cK cX cF co wcel cX cK cS co cA wcel cA vr cv wwe cn cA
      cxp cA cpw c0 csn cdif cF wf wa cX cA wcel cK cn wcel wa wa cX cK cS co
      vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni cK
      cX cF co cX cA wcel cK cn wcel wa cX cK cS co vu cv vv cv vr cv wbr wn vu
      cK cX cF co wral vv cK cX cF co crab cuni wceq cA vr cv wwe cn cA cxp cA
      cpw c0 csn cdif cF wf wa vx vy vz cX cK cA cn vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni vu cv vv cv vr cv
      wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni cS vu cv vv cv vr cv
      wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab cuni vu cv vv cv vr
      cv wbr wn vu cK cX cF co wral vv cK cX cF co crab vu cv vv cv vr cv wbr
      wn vu cK cX cF co wral vv cK cX cF co cK cX cF oprex rabex uniex vx cv cX
      wceq vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF
      co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co
      crab vx cv cX wceq vy cv vx cv cF co vy cv cX cF co wceq vu cv vv cv vr
      cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv
      vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab wceq vx cv cX
      vy cv cF opreq2 vy cv vx cv cF co vy cv cX cF co wceq vu cv vv cv vr cv
      wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv vr
      cv wbr wn vu vy cv vx cv cF co wral vv vy cv cX cF co crab vu cv vv cv vr
      cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv vr cv
      wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co vy cv cX cF co
      rabeq vy cv vx cv cF co vy cv cX cF co wceq vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co wral vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv
      vy cv cX cF co vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co vy cv cX cF
      co raleq1 rabbisdv eqtrd syl unieqd vy cv cK wceq vu cv vv cv vr cv wbr
      wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv vr cv wbr wn
      vu cK cX cF co wral vv cK cX cF co crab vy cv cK wceq vy cv cX cF co cK
      cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX
      cF co crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co
      crab wceq vy cv cK cX cF opreq1 vy cv cX cF co cK cX cF co wceq vu cv vv
      cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv
      vr cv wbr wn vu vy cv cX cF co wral vv cK cX cF co crab vu cv vv cv vr cv
      wbr wn vu cK cX cF co wral vv cK cX cF co crab vu cv vv cv vr cv wbr wn
      vu vy cv cX cF co wral vv vy cv cX cF co cK cX cF co rabeq vy cv cX cF co
      cK cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vu cv vv
      cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co vu cv vv cv vr cv wbr
      wn vu vy cv cX cF co cK cX cF co raleq1 rabbisdv eqtrd syl unieqd
      acdc5lem.2 oprabval2 adantl cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF
      wf cX cA wcel cK cn wcel wa vu cv vv cv vr cv wbr wn vu cK cX cF co wral
      vv cK cX cF co crab cuni cK cX cF co wcel cA vr cv wwe cK cX cF co cA wss
      cK cX cF co c0 wne wa vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK
      cX cF co crab cuni cK cX cF co wcel cn cA cxp cA cpw c0 csn cdif cF wf cX
      cA wcel cK cn wcel wa wa cA vr cv wwe cK cX cF co cA wss cK cX cF co c0
      wne vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni
      cK cX cF co wcel vv vu cA cK cX cF co vr cv cK cX cF oprex wereucl 3expb
      cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel cK cX cF co cA
      wss cK cX cF co c0 wne wa cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel
      cX cA wcel cK cX cF co cA wss cK cX cF co c0 wne wa cn cA cxp cA cpw c0
      csn cdif cF wf cK cn wcel cX cA wcel w3a cK cX cF co cA cpw wcel cK cX cF
      co c0 wne wa cK cX cF co cA wss cK cX cF co c0 wne wa cn cA cxp cA cpw c0
      csn cdif cF wf cK cn wcel cX cA wcel w3a cK cX cF co cA cpw c0 csn cdif
      wcel cK cX cF co cA cpw wcel cK cX cF co c0 wne wa cK cX cA cpw c0 csn
      cdif cn cA cF foprrn cK cX cF co cA cpw c0 eldifsn sylib cK cX cF co cA
      cpw wcel cK cX cF co cA wss cK cX cF co c0 wne cK cX cF co cA elpwi
      anim1i syl 3com23 3expb sylan2 anassrs eqeltrd cA vr cv wwe cn cA cxp cA
      cpw c0 csn cdif cF wf wa cX cA wcel cK cn wcel wa wa cK cX cF co cA cX cK
      cS co cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa cK cX
      cF co cA wss cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cX cA wcel
      cK cn wcel wa wa cK cX cF co cA wss cK cX cF co c0 wne cn cA cxp cA cpw
      c0 csn cdif cF wf cX cA wcel cK cn wcel cK cX cF co cA wss cK cX cF co c0
      wne wa cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel cK cX cF
      co cA wss cK cX cF co c0 wne wa cn cA cxp cA cpw c0 csn cdif cF wf cK cn
      wcel cX cA wcel w3a cK cX cF co cA cpw wcel cK cX cF co c0 wne wa cK cX
      cF co cA wss cK cX cF co c0 wne wa cn cA cxp cA cpw c0 csn cdif cF wf cK
      cn wcel cX cA wcel w3a cK cX cF co cA cpw c0 csn cdif wcel cK cX cF co cA
      cpw wcel cK cX cF co c0 wne wa cK cX cA cpw c0 csn cdif cn cA cF foprrn
      cK cX cF co cA cpw c0 eldifsn sylib cK cX cF co cA cpw wcel cK cX cF co
      cA wss cK cX cF co c0 wne cK cX cF co cA elpwi anim1i syl 3com23 3expb
      pm3.26d adantll cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cX cA
      wcel cK cn wcel wa wa cX cK cS co vu cv vv cv vr cv wbr wn vu cK cX cF co
      wral vv cK cX cF co crab cuni cK cX cF co cX cA wcel cK cn wcel wa cX cK
      cS co vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab
      cuni wceq cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vx vy vz cX
      cK cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx
      cv cF co crab cuni vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX
      cF co crab cuni cS vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy
      cv cX cF co crab cuni vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK
      cX cF co crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co
      cK cX cF oprex rabex uniex vx cv cX wceq vu cv vv cv vr cv wbr wn vu vy
      cv vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu
      vy cv cX cF co wral vv vy cv cX cF co crab vx cv cX wceq vy cv vx cv cF
      co vy cv cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral
      vv vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral
      vv vy cv cX cF co crab wceq vx cv cX vy cv cF opreq2 vy cv vx cv cF co vy
      cv cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy
      cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv
      vy cv cX cF co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy
      cv cX cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy
      cv vx cv cF co vy cv cX cF co rabeq vy cv vx cv cF co vy cv cX cF co wceq
      vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vu cv vv cv vr cv wbr
      wn vu vy cv cX cF co wral vv vy cv cX cF co vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co vy cv cX cF co raleq1 rabbisdv eqtrd syl unieqd vy cv
      cK wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co
      crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab vy
      cv cK wceq vy cv cX cF co cK cX cF co wceq vu cv vv cv vr cv wbr wn vu vy
      cv cX cF co wral vv vy cv cX cF co crab vu cv vv cv vr cv wbr wn vu cK cX
      cF co wral vv cK cX cF co crab wceq vy cv cK cX cF opreq1 vy cv cX cF co
      cK cX cF co wceq vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv
      cX cF co crab vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv cK cX cF
      co crab vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX cF co crab
      vu cv vv cv vr cv wbr wn vu vy cv cX cF co wral vv vy cv cX cF co cK cX
      cF co rabeq vy cv cX cF co cK cX cF co wceq vu cv vv cv vr cv wbr wn vu
      vy cv cX cF co wral vu cv vv cv vr cv wbr wn vu cK cX cF co wral vv cK cX
      cF co vu cv vv cv vr cv wbr wn vu vy cv cX cF co cK cX cF co raleq1
      rabbisdv eqtrd syl unieqd acdc5lem.2 oprabval2 adantl cA vr cv wwe cn cA
      cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa vu cv vv cv vr cv
      wbr wn vu cK cX cF co wral vv cK cX cF co crab cuni cK cX cF co wcel cA
      vr cv wwe cK cX cF co cA wss cK cX cF co c0 wne wa vu cv vv cv vr cv wbr
      wn vu cK cX cF co wral vv cK cX cF co crab cuni cK cX cF co wcel cn cA
      cxp cA cpw c0 csn cdif cF wf cX cA wcel cK cn wcel wa wa cA vr cv wwe cK
      cX cF co cA wss cK cX cF co c0 wne vu cv vv cv vr cv wbr wn vu cK cX cF
      co wral vv cK cX cF co crab cuni cK cX cF co wcel vv vu cA cK cX cF co vr
      cv cK cX cF oprex wereucl 3expb cn cA cxp cA cpw c0 csn cdif cF wf cX cA
      wcel cK cn wcel cK cX cF co cA wss cK cX cF co c0 wne wa cn cA cxp cA cpw
      c0 csn cdif cF wf cK cn wcel cX cA wcel cK cX cF co cA wss cK cX cF co c0
      wne wa cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel w3a cK cX
      cF co cA cpw wcel cK cX cF co c0 wne wa cK cX cF co cA wss cK cX cF co c0
      wne wa cn cA cxp cA cpw c0 csn cdif cF wf cK cn wcel cX cA wcel w3a cK cX
      cF co cA cpw c0 csn cdif wcel cK cX cF co cA cpw wcel cK cX cF co c0 wne
      wa cK cX cA cpw c0 csn cdif cn cA cF foprrn cK cX cF co cA cpw c0 eldifsn
      sylib cK cX cF co cA cpw wcel cK cX cF co cA wss cK cX cF co c0 wne cK cX
      cF co cA elpwi anim1i syl 3com23 3expb sylan2 anassrs eqeltrd sseldd jca
      $.
      $( [11-Nov-2007] $) $( [30-Sep-2007] $)

    $( Lemma for ~ acdc5 .  Build a sequence ` G ` starting at value ` c ` , as
       follows.  Given a previous value ` x ` of ` G ` , we construct, for the
       next value of ` G ` , the ` v ` such that
       ` A. u e. ( y F x ) -. u r v ` , which is unique when ` r ` is a
       well-ordering on ` A ` . $)
    acdc5lem2 $p |- ( ( r We A /\ ( c e. A /\
     F : ( NN X. A ) --> ( ~P A \ { (/) } ) ) ) -> ( G : NN --> A /\
       ( G ` 1 ) = c /\
               A. k e. NN ( G ` ( k + 1 ) ) e. ( ( k + 1 ) F ( G ` k ) ) ) ) $=
      cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa cn cA
      cG wf c1 cG cfv vc cv wceq vk cv c1 caddc co cG cfv vk cv c1 caddc co vk
      cv cG cfv cF co wcel vk cn wral cA vr cv wwe vc cv cA wcel cn cA cxp cA
      cpw c0 csn cdif cF wf wa wa cn cA cS c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co wf cn cA cG wf c1 c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cfv cA wcel cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cn c1 csn cdif cres wf wa cA cn cxp cA cS wf cn cA cS c1 vc
      cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf cA vr cv wwe vc cv cA
      wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa c1 c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cfv cA wcel cn c1 csn cdif cn c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cn c1 csn cdif cres wf cA cn cxp cA cS wf cn cA
      cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf cA cn cS c1
      vc cv cop csn cid cn c1 csn cdif cres cun vx vy vz cA cn vu cv vv cv vr
      cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni cS
      acdc5lem.1 nnex acdc5lem.2 oprabex2 c1 vc cv cop csn cid cn c1 csn cdif
      cres c1 vc cv cop snex cn c1 csn cdif cvv wcel cid cn c1 csn cdif cres
      cvv wcel cn cvv wcel cn c1 csn cdif cvv wcel nnex cn c1 csn cvv difexg
      ax-mp cn c1 csn cdif cvv resiexg ax-mp unex seq1f2 3expa cA vr cv wwe vc
      cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa c1 c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cfv cA wcel cn c1 csn cdif cn c1 vc cv cop
      csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf vc cv cA wcel c1
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv cA wcel cA vr cv wwe cn
      cA cxp cA cpw c0 csn cdif cF wf vc cv cA wcel vc cv cA c1 c1 vc cv cop
      csn cid cn c1 csn cdif cres cun cfv vc cv cA wcel id c1 vc cv cn cid c1
      vc cv cop csn cid cn c1 csn cdif cres cun c1 cn 1nn elisseti vc visset c1
      vc cv cop csn cid cn c1 csn cdif cres cun eqid fvsnun1 syl5eqel ad2antrl
      cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn
      cdif cres wf cn c1 csn cdif cn cid cn c1 csn cdif cres wf cn c1 csn cdif
      cn c1 csn cdif cid cn c1 csn cdif cres wf cn c1 csn cdif cn wss cn c1 csn
      cdif cn cid cn c1 csn cdif cres wf cn c1 csn cdif cn c1 csn cdif cid cn
      c1 csn cdif cres wf1o cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif
      cres wf cn c1 csn cdif f1oi cn c1 csn cdif cn c1 csn cdif cid cn c1 csn
      cdif cres f1of ax-mp cn c1 csn difss cn c1 csn cdif cn c1 csn cdif cn cid
      cn c1 csn cdif cres fss mp2an c1 vc cv cop csn cid cn c1 csn cdif cres
      cun cn c1 csn cdif cres cid cn c1 csn cdif cres wceq cn c1 csn cdif cn c1
      vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cn c1
      csn cdif cn cid cn c1 csn cdif cres wf wb c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cn c1 csn cdif cres c1 vc cv cop csn cn c1 csn cdif cres
      cid cn c1 csn cdif cres cn c1 csn cdif cres cun c0 cid cn c1 csn cdif
      cres cun cid cn c1 csn cdif cres c1 vc cv cop csn cid cn c1 csn cdif cres
      cn c1 csn cdif resundir c1 vc cv cop csn cn c1 csn cdif cres c0 cid cn c1
      csn cdif cres cn c1 csn cdif cres cid cn c1 csn cdif cres c1 csn cn c1
      csn cdif cin c0 wceq c1 vc cv cop csn cn c1 csn cdif cres c0 wceq c1 csn
      cn difdisj c1 vc cv cop csn c1 csn wfn c1 csn cn c1 csn cdif cin c0 wceq
      c1 vc cv cop csn cn c1 csn cdif cres c0 wceq wb c1 csn vc cv csn c1 vc cv
      cop csn wf1o c1 vc cv cop csn c1 csn wfn c1 vc cv c1 cn 1nn elisseti vc
      visset f1osn c1 csn vc cv csn c1 vc cv cop csn f1ofn ax-mp c1 csn cn c1
      csn cdif c1 vc cv cop csn fnresdisj ax-mp mpbi cid cn c1 csn cdif residm
      uneq12i cid cn c1 csn cdif cres c0 cun c0 cid cn c1 csn cdif cres cun cid
      cn c1 csn cdif cres cid cn c1 csn cdif cres c0 uncom cid cn c1 csn cdif
      cres un0 eqtr3i 3eqtri cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cn c1 csn cdif cres cid cn c1 csn cdif cres feq1 ax-mp
      mpbir jctir cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cA cn cxp cA
      cS wf vc cv cA wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa cS
      cA cn cxp wfn vs cv vt cv cS co cA wcel vt cn wral vs cA wral wa cA cn
      cxp cA cS wf cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv vt
      cv cS co cA wcel vt cn wral vs cA wral cS cA cn cxp wfn cA vr cv wwe cn
      cA cxp cA cpw c0 csn cdif cF wf wa vs cv vt cv cS co cA wcel vs vt cA cn
      cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv cA wcel vt cv cn
      wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe cn cA cxp cA cpw c0 csn
      cdif cF wf wa vs cv cA wcel vt cv cn wcel wa wa vs cv vt cv cS co vt cv
      vs cv cF co wcel vs cv vt cv cS co cA wcel vx vy vz vv vu cA cS cF cG vt
      cv vs cv vr vc acdc5lem.1 acdc5lem.2 acdc5lem.3 acdc5lem1 pm3.27d ex
      r19.21aivv vx vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co
      wral vv vy cv vx cv cF co crab cuni cS vu cv vv cv vr cv wbr wn vu vy cv
      vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy
      cv vx cv cF co wral vv vy cv vx cv cF co vy cv vx cv cF oprex rabex uniex
      acdc5lem.2 fnoprab2 jctil vs vt cA cn cA cS ffnoprv sylibr adantrl sylanc
      cG cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wceq cn cA cG
      wf cn cA cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf wb
      acdc5lem.3 cn cA cG cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1
      co feq1 ax-mp sylibr c1 cG cfv vc cv wceq cA vr cv wwe vc cv cA wcel cn
      cA cxp cA cpw c0 csn cdif cF wf wa wa c1 cG cfv c1 cS c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cseq1 co cfv c1 c1 vc cv cop csn cid cn c1
      csn cdif cres cun cfv vc cv c1 cG cS c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co acdc5lem.3 fveq1i cS c1 vc cv cop csn cid cn c1 csn
      cdif cres cun vx vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF
      co wral vv vy cv vx cv cF co crab cuni cS acdc5lem.1 nnex acdc5lem.2
      oprabex2 c1 vc cv cop csn cid cn c1 csn cdif cres c1 vc cv cop snex cn c1
      csn cdif cvv wcel cid cn c1 csn cdif cres cvv wcel cn cvv wcel cn c1 csn
      cdif cvv wcel nnex cn c1 csn cvv difexg ax-mp cn c1 csn cdif cvv resiexg
      ax-mp unex seq11 c1 vc cv cn cid c1 vc cv cop csn cid cn c1 csn cdif cres
      cun c1 cn 1nn elisseti vc visset c1 vc cv cop csn cid cn c1 csn cdif cres
      cun eqid fvsnun1 3eqtri a1i cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw
      c0 csn cdif cF wf wa wa vk cv c1 caddc co cG cfv vk cv c1 caddc co vk cv
      cG cfv cF co wcel vk cn cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0
      csn cdif cF wf wa wa vk cv cn wcel wa vk cv c1 caddc co cG cfv vk cv cG
      cfv vk cv c1 caddc co cS co vk cv c1 caddc co vk cv cG cfv cF co vk cv cn
      wcel vk cv c1 caddc co cG cfv vk cv cG cfv vk cv c1 caddc co cS co wceq
      cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv
      cn wcel vk cv c1 caddc co cS c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co cfv vk cv cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1
      co cfv vk cv c1 caddc co cS co vk cv c1 caddc co cG cfv vk cv cG cfv vk
      cv c1 caddc co cS co vk cv cn wcel vk cv c1 caddc co cS c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cseq1 co cfv vk cv cS c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cseq1 co cfv vk cv c1 caddc co c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cfv cS co vk cv cS c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co cfv vk cv c1 caddc co cS co vk cv cS c1 vc cv cop
      csn cid cn c1 csn cdif cres cun vx vy vz cA cn vu cv vv cv vr cv wbr wn
      vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni cS acdc5lem.1
      nnex acdc5lem.2 oprabex2 c1 vc cv cop csn cid cn c1 csn cdif cres c1 vc
      cv cop snex cn c1 csn cdif cvv wcel cid cn c1 csn cdif cres cvv wcel cn
      cvv wcel cn c1 csn cdif cvv wcel nnex cn c1 csn cvv difexg ax-mp cn c1
      csn cdif cvv resiexg ax-mp unex seq1p1 vk cv cn wcel vk cv c1 caddc co c1
      vc cv cop csn cid cn c1 csn cdif cres cun cfv vk cv c1 caddc co vk cv cS
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cS vk cv cn
      wcel vk cv c1 caddc co c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv
      vk cv c1 caddc co cid cfv vk cv c1 caddc co vk cv cn wcel vk cv c1 caddc
      co cn c1 csn cdif wcel vk cv c1 caddc co c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cfv vk cv c1 caddc co cid cfv wceq vk cv seq1lem2 c1 vc cv
      cn vk cv c1 caddc co cid c1 vc cv cop csn cid cn c1 csn cdif cres cun c1
      cn 1nn elisseti vc visset c1 vc cv cop csn cid cn c1 csn cdif cres cun
      eqid fvsnun2 syl vk cv c1 caddc co cvv wcel vk cv c1 caddc co cid cfv vk
      cv c1 caddc co wceq vk cv c1 caddc oprex vk cv c1 caddc co cvv fvi ax-mp
      syl6eq opreq2d eqtrd vk cv c1 caddc co cG cS c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co acdc5lem.3 fveq1i vk cv cG cfv vk cv cS c1 vc
      cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1 caddc co cS
      vk cv cG cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co
      acdc5lem.3 fveq1i opreq1i 3eqtr4g adantl cA vr cv wwe cn cA cxp cA cpw c0
      csn cdif cF wf vk cv cG cfv cA wcel vk cv c1 caddc co cn wcel vk cv cG
      cfv vk cv c1 caddc co cS co vk cv c1 caddc co vk cv cG cfv cF co wcel cA
      vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv cn
      wcel wa cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vk cv cG cfv
      cA wcel vk cv c1 caddc co cn wcel wa wa vk cv cG cfv vk cv c1 caddc co cS
      co vk cv c1 caddc co vk cv cG cfv cF co wcel vk cv cG cfv vk cv c1 caddc
      co cS co cA wcel vx vy vz vv vu cA cS cF cG vk cv c1 caddc co vk cv cG
      cfv vr vc acdc5lem.1 acdc5lem.2 acdc5lem.3 acdc5lem1 pm3.26d cA vr cv wwe
      vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa vk cv cn wcel simpll
      cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf vk cv cn
      wcel simplrr cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF
      wf wa wa vk cv cn wcel wa vk cv cS c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co cfv cA vk cv cG cfv vk cv cn wcel vc cv cA wcel cA cn
      cxp cA cS wf vk cv cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1
      co cfv cA wcel cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF
      wf wa wa vk cv cn wcel wa c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cfv cA wcel cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres
      cun cn c1 csn cdif cres wf cA cn cxp cA cS wf w3a vk cv cn wcel vk cv cS
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cA wcel vk cv
      cn wcel vc cv cA wcel cA cn cxp cA cS wf w3a vk cv cA cn cS c1 vc cv cop
      csn cid cn c1 csn cdif cres cun vx vy vz cA cn vu cv vv cv vr cv wbr wn
      vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni cS acdc5lem.1
      nnex acdc5lem.2 oprabex2 c1 vc cv cop csn cid cn c1 csn cdif cres c1 vc
      cv cop snex cn c1 csn cdif cvv wcel cid cn c1 csn cdif cres cvv wcel cn
      cvv wcel cn c1 csn cdif cvv wcel nnex cn c1 csn cvv difexg ax-mp cn c1
      csn cdif cvv resiexg ax-mp unex seq1cl2 vk cv cn wcel vc cv cA wcel cA cn
      cxp cA cS wf w3a c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv cA
      wcel cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1
      csn cdif cres wf cA cn cxp cA cS wf vk cv cn wcel vc cv cA wcel cA cn cxp
      cA cS wf w3a vc cv cA c1 c1 vc cv cop csn cid cn c1 csn cdif cres cun cfv
      vk cv cn wcel vc cv cA wcel cA cn cxp cA cS wf 3simp2 c1 vc cv cn cid c1
      vc cv cop csn cid cn c1 csn cdif cres cun c1 cn 1nn elisseti vc visset c1
      vc cv cop csn cid cn c1 csn cdif cres cun eqid fvsnun1 syl5eqel cn c1 csn
      cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres
      wf vk cv cn wcel vc cv cA wcel cA cn cxp cA cS wf w3a cn c1 csn cdif cn
      c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cn c1
      csn cdif cn cid cn c1 csn cdif cres wf cn c1 csn cdif cn c1 csn cdif cid
      cn c1 csn cdif cres wf cn c1 csn cdif cn wss cn c1 csn cdif cn cid cn c1
      csn cdif cres wf cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres
      wf1o cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres wf cn c1 csn
      cdif f1oi cn c1 csn cdif cn c1 csn cdif cid cn c1 csn cdif cres f1of
      ax-mp cn c1 csn difss cn c1 csn cdif cn c1 csn cdif cn cid cn c1 csn cdif
      cres fss mp2an c1 vc cv cop csn cid cn c1 csn cdif cres cun cn c1 csn
      cdif cres cid cn c1 csn cdif cres wceq cn c1 csn cdif cn c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cn c1 csn cdif cres wf cn c1 csn cdif cn cid
      cn c1 csn cdif cres wf wb c1 vc cv cop csn cid cn c1 csn cdif cres cun cn
      c1 csn cdif cres c1 vc cv cop csn cn c1 csn cdif cres cid cn c1 csn cdif
      cres cn c1 csn cdif cres cun c0 cid cn c1 csn cdif cres cun cid cn c1 csn
      cdif cres c1 vc cv cop csn cid cn c1 csn cdif cres cn c1 csn cdif
      resundir c1 vc cv cop csn cn c1 csn cdif cres c0 cid cn c1 csn cdif cres
      cn c1 csn cdif cres cid cn c1 csn cdif cres c1 csn cn c1 csn cdif cin c0
      wceq c1 vc cv cop csn cn c1 csn cdif cres c0 wceq c1 csn cn difdisj c1 vc
      cv cop csn c1 csn wfn c1 csn cn c1 csn cdif cin c0 wceq c1 vc cv cop csn
      cn c1 csn cdif cres c0 wceq wb c1 csn vc cv csn c1 vc cv cop csn wf1o c1
      vc cv cop csn c1 csn wfn c1 vc cv c1 cn 1nn elisseti vc visset f1osn c1
      csn vc cv csn c1 vc cv cop csn f1ofn ax-mp c1 csn cn c1 csn cdif c1 vc cv
      cop csn fnresdisj ax-mp mpbi cid cn c1 csn cdif residm uneq12i cid cn c1
      csn cdif cres c0 cun c0 cid cn c1 csn cdif cres cun cid cn c1 csn cdif
      cres cid cn c1 csn cdif cres c0 uncom cid cn c1 csn cdif cres un0 eqtr3i
      3eqtri cn c1 csn cdif cn c1 vc cv cop csn cid cn c1 csn cdif cres cun cn
      c1 csn cdif cres cid cn c1 csn cdif cres feq1 ax-mp mpbir a1i vk cv cn
      wcel vc cv cA wcel cA cn cxp cA cS wf 3simp3 3jca vk cv cn wcel vc cv cA
      wcel cA cn cxp cA cS wf 3simp1 sylanc cA vr cv wwe vc cv cA wcel cn cA
      cxp cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel pm3.27 cA vr cv wwe vc
      cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf vk cv cn wcel simplrl cA vr
      cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa cA cn cxp
      cA cS wf vk cv cn wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf cA
      cn cxp cA cS wf vc cv cA wcel cA vr cv wwe cn cA cxp cA cpw c0 csn cdif
      cF wf wa cS cA cn cxp wfn vs cv vt cv cS co cA wcel vt cn wral vs cA wral
      wa cA cn cxp cA cS wf cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa
      vs cv vt cv cS co cA wcel vt cn wral vs cA wral cS cA cn cxp wfn cA vr cv
      wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv vt cv cS co cA wcel vs vt
      cA cn cA vr cv wwe cn cA cxp cA cpw c0 csn cdif cF wf wa vs cv cA wcel vt
      cv cn wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe cn cA cxp cA cpw c0
      csn cdif cF wf wa vs cv cA wcel vt cv cn wcel wa wa vs cv vt cv cS co vt
      cv vs cv cF co wcel vs cv vt cv cS co cA wcel vx vy vz vv vu cA cS cF cG
      vt cv vs cv vr vc acdc5lem.1 acdc5lem.2 acdc5lem.3 acdc5lem1 pm3.27d ex
      r19.21aivv vx vy vz cA cn vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co
      wral vv vy cv vx cv cF co crab cuni cS vu cv vv cv vr cv wbr wn vu vy cv
      vx cv cF co wral vv vy cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy
      cv vx cv cF co wral vv vy cv vx cv cF co vy cv vx cv cF oprex rabex uniex
      acdc5lem.2 fnoprab2 jctil vs vt cA cn cA cS ffnoprv sylibr adantrl adantr
      syl3anc vk cv cG cS c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co
      acdc5lem.3 fveq1i syl5eqel vk cv cn wcel vk cv c1 caddc co cn wcel cA vr
      cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa vk cv
      peano2nn adantl syl2anc eqeltrd r19.21aiva 3jca $.
      $( [11-Nov-2007] $) $( [9-Oct-2007] $)
  $}

  ${
    $d a b c d g k r u v x y z A $.  $d a b c d f g h k r u v x y z F $.
    $d c g C $.
    acdc5.1 $e |- A e. _V $.
    $( A more general version of ~ acdc that has an initial value and where the
       function ` F ` depends on ` k ` . $)
    acdc5 $p |- ( ( F : ( NN X. A ) --> ( ~P A \ { (/) } ) /\ C e. A ) ->
               E. g ( g : NN --> A /\ ( g ` 1 ) = C /\
           A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) $=
      cC cA wcel cn cA cxp cA cpw c0 csn cdif cF wf cn cA vg cv wf c1 vg cv cfv
      cC wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral w3a vg wex cn cA cxp cA cpw c0 csn cdif cF wf cn cA vg
      cv wf c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex wi cn cA cxp cA cpw
      c0 csn cdif cF wf cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral w3a vg
      wex wi vc cC cA vc cv cC wceq cn cA vg cv wf c1 vg cv cfv vc cv wceq vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral w3a vg wex cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral w3a vg
      wex cn cA cxp cA cpw c0 csn cdif cF wf vc cv cC wceq cn cA vg cv wf c1 vg
      cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co wcel vk cn wral w3a cn cA vg cv wf c1 vg cv cfv cC wceq vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral w3a vg vc cv cC wceq c1 vg cv cfv vc cv wceq c1 vg cv cfv cC wceq
      cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral vc cv cC c1 vg cv cfv eqeq2 3anbi2d exbidv
      imbi2d cA vr cv wwe vr wex vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF
      wf cn cA vg cv wf c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex wi wi vr
      cA acdc5.1 weth cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif
      cF wf cn cA vg cv wf c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex wi wi
      vr cA vr cv wwe vc cv cA wcel cn cA cxp cA cpw c0 csn cdif cF wf cn cA vg
      cv wf c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex cA vr cv wwe vc cv cA
      wcel cn cA cxp cA cpw c0 csn cdif cF wf wa wa cn cA va cv cA wcel vb cv
      cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb
      cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cseq1 co wf c1 va cv cA wcel vb cv cn wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co
      crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co cfv vc cv wceq vk cv c1 caddc co va cv cA wcel vb cv cn
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv
      va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co cfv vk cv c1 caddc co vk cv va cv cA wcel vb
      cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co cfv cF co wcel vk cn wral w3a cn cA vg
      cv wf c1 vg cv cfv vc cv wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex vx vy vz vv vu cA va
      cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv
      cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 vk cF
      va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co vr vc acdc5.1 va cv cA
      wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co
      wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 vx cv cA wcel
      vy cv cn wcel wa vd cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral
      vv vy cv vx cv cF co crab cuni wceq wa vx vy vd copab2 vx cv cA wcel vy
      cv cn wcel wa vz cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv
      vy cv vx cv cF co crab cuni wceq wa vx vy vz copab2 va cv cA wcel vb cv
      cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb
      cv va cv cF co crab cuni wceq wa vx cv cA wcel vy cv cn wcel wa vd cv vu
      cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab
      cuni wceq wa va vb vd vx vy va cv vx cv wceq vb cv vy cv wceq wa va cv cA
      wcel vb cv cn wcel wa vx cv cA wcel vy cv cn wcel wa vd cv vh cv vf cv vr
      cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq
      vd cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv
      cF co crab cuni wceq va cv vx cv wceq va cv cA wcel vx cv cA wcel vb cv
      vy cv wceq vb cv cn wcel vy cv cn wcel va cv vx cv cA eleq1 vb cv vy cv
      cn eleq1 bi2anan9 va cv vx cv wceq vb cv vy cv wceq wa vh cv vf cv vr cv
      wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni vu cv vv
      cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni
      vd cv va cv vx cv wceq vb cv vy cv wceq wa vh cv vf cv vr cv wbr wn vh vb
      cv va cv cF co wral vf vb cv va cv cF co crab vu cv vv cv vr cv wbr wn vu
      vy cv vx cv cF co wral vv vy cv vx cv cF co crab va cv vx cv wceq vb cv
      vy cv wceq wa vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv
      va cv cF co crab vh cv vf cv vr cv wbr wn vh vy cv vx cv cF co wral vf vy
      cv vx cv cF co crab vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv
      vy cv vx cv cF co crab va cv vx cv wceq vb cv vy cv wceq wa vb cv va cv
      cF co vy cv vx cv cF co wceq vh cv vf cv vr cv wbr wn vh vb cv va cv cF
      co wral vf vb cv va cv cF co crab vh cv vf cv vr cv wbr wn vh vy cv vx cv
      cF co wral vf vy cv vx cv cF co crab wceq vb cv vy cv wceq va cv vx cv
      wceq vb cv va cv cF co vy cv vx cv cF co wceq vb cv vy cv va cv vx cv cF
      opreq12 ancoms vb cv va cv cF co vy cv vx cv cF co wceq vh cv vf cv vr cv
      wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab vh cv vf cv vr
      cv wbr wn vh vb cv va cv cF co wral vf vy cv vx cv cF co crab vh cv vf cv
      vr cv wbr wn vh vy cv vx cv cF co wral vf vy cv vx cv cF co crab vh cv vf
      cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co vy cv vx
      cv cF co rabeq vb cv va cv cF co vy cv vx cv cF co wceq vh cv vf cv vr cv
      wbr wn vh vb cv va cv cF co wral vh cv vf cv vr cv wbr wn vh vy cv vx cv
      cF co wral vf vy cv vx cv cF co vh cv vf cv vr cv wbr wn vh vb cv va cv
      cF co vy cv vx cv cF co raleq1 rabbisdv eqtrd syl vh cv vf cv vr cv wbr
      wn vh vy cv vx cv cF co wral vu cv vv cv vr cv wbr wn vu vy cv vx cv cF
      co wral vf vv vy cv vx cv cF co vf cv vv cv wceq vh cv vf cv vr cv wbr wn
      vh vy cv vx cv cF co wral vh cv vv cv vr cv wbr wn vh vy cv vx cv cF co
      wral vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vf cv vv cv wceq
      vh cv vf cv vr cv wbr wn vh cv vv cv vr cv wbr wn vh vy cv vx cv cF co vf
      cv vv cv wceq vh cv vf cv vr cv wbr vh cv vv cv vr cv wbr vf cv vv cv vh
      cv vr cv breq2 notbid ralbidv vh cv vv cv vr cv wbr wn vu cv vv cv vr cv
      wbr wn vh vu vy cv vx cv cF co vh cv vu cv wceq vh cv vv cv vr cv wbr vu
      cv vv cv vr cv wbr vh cv vu cv vv cv vr cv breq1 notbid cbvralv syl6bb
      cbvrabv syl6eq unieqd eqeq2d anbi12d cbvoprab12v vx cv cA wcel vy cv cn
      wcel wa vd cv vu cv vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv
      vx cv cF co crab cuni wceq wa vx cv cA wcel vy cv cn wcel wa vz cv vu cv
      vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab
      cuni wceq wa vx vy vd vz vd cv vz cv wceq vd cv vu cv vv cv vr cv wbr wn
      vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni wceq vz cv vu cv
      vv cv vr cv wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab
      cuni wceq vx cv cA wcel vy cv cn wcel wa vd cv vz cv vu cv vv cv vr cv
      wbr wn vu vy cv vx cv cF co wral vv vy cv vx cv cF co crab cuni eqeq1
      anbi2d cbvoprab3v eqtri va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni
      wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co eqid acdc5lem2 cn cA vg cv wf c1 vg cv cfv vc cv wceq vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral w3a cn cA va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb
      vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf c1 va
      cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv
      cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc
      cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vc cv wceq vk cv c1
      caddc co va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd
      copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1
      caddc co vk cv va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb
      vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv cF co
      wcel vk cn wral w3a vg va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab cuni
      wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd
      copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 oprex vg cv va
      cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv
      cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc
      cv cop csn cid cn c1 csn cdif cres cun cseq1 co wceq cn cA vg cv wf cn cA
      va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co wf c1 vg cv cfv vc cv
      wceq c1 va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd
      copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vc cv
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral vk cv c1 caddc co va cv cA wcel vb cv cn wcel wa vd cv vh
      cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co crab
      cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun
      cseq1 co cfv vk cv c1 caddc co vk cv va cv cA wcel vb cv cn wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv cF co
      crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn cdif
      cres cun cseq1 co cfv cF co wcel vk cn wral cn cA vg cv va cv cA wcel vb
      cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co feq1 vg cv va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co wceq c1 vg cv cfv c1 va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co cfv vc cv c1 vg cv va cv cA wcel vb cv cn wcel wa
      vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv
      cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co fveq1 eqeq1d vg cv va cv cA wcel vb cv cn wcel wa
      vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va cv
      cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cv c1 caddc co va cv cA wcel vb cv cn wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv va
      cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1 csn
      cdif cres cun cseq1 co cfv vk cv c1 caddc co vk cv va cv cA wcel vb cv cn
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb cv
      va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn c1
      csn cdif cres cun cseq1 co cfv cF co wcel vk cn vg cv va cv cA wcel vb cv
      cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf vb
      cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid cn
      c1 csn cdif cres cun cseq1 co wceq vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      vb cv va cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd
      copab2 c1 vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1
      caddc co vk cv vg cv cfv cF co vk cv c1 caddc co vk cv va cv cA wcel vb
      cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co cfv cF co vk cv c1 caddc co vg cv va cv
      cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF
      co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv
      cop csn cid cn c1 csn cdif cres cun cseq1 co fveq1 vg cv va cv cA wcel vb
      cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral vf
      vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn cid
      cn c1 csn cdif cres cun cseq1 co wceq vk cv vg cv cfv vk cv va cv cA wcel
      vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va cv cF co wral
      vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1 vc cv cop csn
      cid cn c1 csn cdif cres cun cseq1 co cfv vk cv c1 caddc co cF vk cv vg cv
      va cv cA wcel vb cv cn wcel wa vd cv vh cv vf cv vr cv wbr wn vh vb cv va
      cv cF co wral vf vb cv va cv cF co crab cuni wceq wa va vb vd copab2 c1
      vc cv cop csn cid cn c1 csn cdif cres cun cseq1 co fveq1 opreq2d eleq12d
      ralbidv 3anbi123d cla4ev syl exp32 19.23aiv ax-mp vtoclga impcom $.
      $( [11-Nov-2007] $) $( [11-Oct-2007] $)
  $}

  ${
    $d k s t u v x y z A $.  $d k s t u v x y z F $.  $d u v x y z G $.
    $d s t S $.  $d k s t x y z c $.  $d k s t u v x y z r $.
    acdclem.1 $e |- A e. _V $.
    acdclem.2 $e |- S = { <. <. x , y >. , z >. |
               ( ( x e. A /\ y e. A ) /\ z = U. { v e. ( F ` x ) |
                        A. u e. ( F ` x ) -. u r v } ) } $.
    acdclem.3 $e |- G = ( S seq1 ( NN X. { c } ) ) $.
    $( Lemma for ~ acdc .  Build a sequence ` G ` starting at value ` c ` , as
       follows.  Given a previous value ` x ` of ` G ` , we construct, for the
       next value of ` G ` , the ` v ` such that
       ` A. u e. ( F `` x ) -. u r v ` , which is unique when ` r ` is a
       well-ordering on ` A ` . $)
    acdclem $p |- ( ( r We A /\ ( c e. A /\ F : A --> ( ~P A \ { (/) } ) ) )
  -> ( G : NN --> A /\ A. k e. NN ( G ` ( k + 1 ) ) e. ( F ` ( G ` k ) ) ) ) $=
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cn cA cG wf
      vk cv c1 caddc co cG cfv vk cv cG cfv cF cfv wcel vk cn wral cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cn cA cS cn vc cv csn cxp
      cseq1 co wf cn cA cG wf cn cA cn vc cv csn cxp wf cA cA cxp cA cS wf cn
      cA cS cn vc cv csn cxp cseq1 co wf cA vr cv wwe vc cv cA wcel cA cA cpw
      c0 csn cdif cF wf wa wa cA cS cn vc cv csn cxp vx vy vz cA cA vu cv vv cv
      vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni cS acdclem.1
      acdclem.1 acdclem.2 oprabex2 cn vc cv csn nnex vc cv snex xpex seq1f vc
      cv cA wcel cn cA cn vc cv csn cxp wf cA vr cv wwe cA cA cpw c0 csn cdif
      cF wf cn vc cv csn cn vc cv csn cxp wf vc cv csn cA wss cn cA cn vc cv
      csn cxp wf vc cv cA wcel cn vc cv csn cA cn vc cv csn cxp fss cn vc cv vc
      visset fconst vc cv cA snssi sylancr ad2antrl cA vr cv wwe vc cv cA wcel
      cA cA cpw c0 csn cdif cF wf wa wa cS cA cA cxp wfn vs cv vt cv cS co cA
      wcel vt cA wral vs cA wral wa cA cA cxp cA cS wf cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vt cA
      wral vs cA wral cS cA cA cxp wfn cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vs vt cA cA cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv cA
      wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vs cv cA wcel vt cv cA wcel wa wa vs cv vt cv cS co
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      cA vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co vu cv vv cv vr cv wbr
      wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni wceq cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vx vy vz vs cv vt cv cA cA vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni vu
      cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cS
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv vs cv cF fvex
      rabex uniex vx cv vs cv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral
      vv vs cv cF cfv crab vx cv vs cv wceq vx cv cF cfv vs cv cF cfv wceq vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv
      cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab wceq vx cv vs
      cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral
      vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF cfv vs cv cF cfv wceq vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vs cv
      cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv wbr wn vu vx cv cF cfv vs
      cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv vt cv wceq vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni eqidd
      acdclem.2 oprabval2 adantl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA wcel vt cv cA wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv cA wcel cA vr cv wwe cA
      cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs cv cF cfv cA wss vs cv
      cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs cv cF fvex wereucl cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel simpll cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 wne cA cA
      cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn cdif wcel vs
      cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA cpw c0 csn
      eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv c0 wceq vs
      cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi
      syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd ex r19.21aivv vx
      vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vx
      cv cF fvex rabex uniex acdclem.2 fnoprab2 jctil vs vt cA cA cA cS ffnoprv
      sylibr sylanc cG cS cn vc cv csn cxp cseq1 co wceq cn cA cG wf cn cA cS
      cn vc cv csn cxp cseq1 co wf wb acdclem.3 cn cA cG cS cn vc cv csn cxp
      cseq1 co feq1 ax-mp sylibr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vk cv c1 caddc co cG cfv vk cv cG cfv cF cfv wcel vk cn
      cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn
      wcel wa vk cv c1 caddc co cG cfv vu cv vv cv vr cv wbr wn vu vk cv cG cfv
      cF cfv wral vv vk cv cG cfv cF cfv crab cuni vk cv cG cfv cF cfv cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk
      cv c1 caddc co cS cn vc cv csn cxp cseq1 co cfv vu cv vv cv vr cv wbr wn
      vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv crab cuni vk cv c1
      caddc co cG cfv cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa
      wa vk cv cn wcel wa vk cv c1 caddc co cS cn vc cv csn cxp cseq1 co cfv vk
      cv cS cn vc cv csn cxp cseq1 co cfv vk cv c1 caddc co cn vc cv csn cxp
      cfv cS co vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv
      cG cfv cF cfv crab cuni vk cv cn wcel vk cv c1 caddc co cS cn vc cv csn
      cxp cseq1 co cfv vk cv cS cn vc cv csn cxp cseq1 co cfv vk cv c1 caddc co
      cn vc cv csn cxp cfv cS co wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vk cv cS cn vc cv csn cxp vx vy vz cA cA vu cv vv cv
      vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni cS acdclem.1
      acdclem.1 acdclem.2 oprabex2 cn vc cv csn nnex vc cv snex xpex seq1p1
      adantl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv
      cn wcel wa vk cv cG cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS co vu
      cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv
      crab cuni vk cv cS cn vc cv csn cxp cseq1 co cfv vk cv c1 caddc co cn vc
      cv csn cxp cfv cS co cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF
      wf wa wa vk cv cn wcel wa vk cv cG cfv vk cv c1 caddc co cn vc cv csn cxp
      cfv cS co vk cv cG cfv vc cv cS co vu cv vv cv vr cv wbr wn vu vk cv cG
      cfv cF cfv wral vv vk cv cG cfv cF cfv crab cuni vk cv cn wcel vk cv cG
      cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS co vk cv cG cfv vc cv cS co
      wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv
      cn wcel vk cv c1 caddc co cn vc cv csn cxp cfv vc cv vk cv cG cfv cS vk
      cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cn vc cv csn cxp
      cfv vc cv wceq vk cv peano2nn cn vc cv vk cv c1 caddc co vc visset
      fvconst2 syl opreq2d adantl vk cv cG cfv cA wcel vc cv cA wcel vk cv cG
      cfv vc cv cS co vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv
      vk cv cG cfv cF cfv crab cuni wceq cA vr cv wwe vc cv cA wcel cA cA cpw
      c0 csn cdif cF wf wa wa vk cv cn wcel wa vx vy vz vk cv cG cfv vc cv cA
      cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      cuni vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv
      cF cfv crab cuni cS vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral
      vv vk cv cG cfv cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vk cv cG cfv
      cF cfv wral vv vk cv cG cfv cF cfv crab vu cv vv cv vr cv wbr wn vu vk cv
      cG cfv cF cfv wral vv vk cv cG cfv cF cfv vk cv cG cfv cF fvex rabex
      uniex vx cv vk cv cG cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv
      wral vv vk cv cG cfv cF cfv crab vx cv vk cv cG cfv wceq vx cv cF cfv vk
      cv cG cfv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx
      cv cF cfv crab vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk
      cv cG cfv cF cfv crab wceq vx cv vk cv cG cfv cF fveq2 vx cv cF cfv vk cv
      cG cfv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv
      cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vk cv cG cfv
      cF cfv crab vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv
      cG cfv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv
      cF cfv vk cv cG cfv cF cfv rabeq vx cv cF cfv vk cv cG cfv cF cfv wceq vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vk
      cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv vu cv vv cv vr cv wbr wn vu
      vx cv cF cfv vk cv cG cfv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv
      vc cv wceq vu cv vv cv vr cv wbr wn vu vk cv cG cfv cF cfv wral vv vk cv
      cG cfv cF cfv crab cuni eqidd acdclem.2 oprabval2 cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cS cn vc cv
      csn cxp cseq1 co cfv cA vk cv cG cfv vk cv cn wcel cn cA cn vc cv csn cxp
      wf cA cA cxp cA cS wf vk cv cS cn vc cv csn cxp cseq1 co cfv cA wcel cA
      vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel
      wa vk cv cA cS cn vc cv csn cxp vx vy vz cA cA vu cv vv cv vr cv wbr wn
      vu vx cv cF cfv wral vv vx cv cF cfv crab cuni cS acdclem.1 acdclem.1
      acdclem.2 oprabex2 cn vc cv csn nnex vc cv snex xpex seq1cl cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel pm3.27 vc
      cv cA wcel cA cA cpw c0 csn cdif cF wf wa cn cA cn vc cv csn cxp wf cA vr
      cv wwe vk cv cn wcel vc cv cA wcel cn cA cn vc cv csn cxp wf cA cA cpw c0
      csn cdif cF wf cn vc cv csn cn vc cv csn cxp wf vc cv csn cA wss cn cA cn
      vc cv csn cxp wf vc cv cA wcel cn vc cv csn cA cn vc cv csn cxp fss cn vc
      cv vc visset fconst vc cv cA snssi sylancr adantr ad2antlr cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cA cA cxp cA cS wf vk cv
      cn wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cS
      cA cA cxp wfn vs cv vt cv cS co cA wcel vt cA wral vs cA wral wa cA cA
      cxp cA cS wf cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa
      vs cv vt cv cS co cA wcel vt cA wral vs cA wral cS cA cA cxp wfn cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA
      wcel vs vt cA cA cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf
      wa wa vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co cA wcel cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv
      cA wcel wa wa vs cv vt cv cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA vs cv cA wcel vt cv cA wcel wa vs cv vt
      cv cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv
      crab cuni wceq cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa
      wa vx vy vz vs cv vt cv cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cS vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv vs cv cF fvex rabex uniex vx cv vs cv wceq vu cv vv
      cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr
      cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vx cv vs cv wceq vx
      cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral
      vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs
      cv cF cfv crab wceq vx cv vs cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vv vs cv cF cfv crab vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF
      cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv
      vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv vs cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy
      cv vt cv wceq vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni eqidd acdclem.2 oprabval2 adantl cA vr cv wwe vc cv cA wcel
      cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv wbr wn
      vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA wcel vt cv cA wcel cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv vr cv wbr
      wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv cA wcel
      cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv
      cA vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab
      cuni cA vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv
      cF cfv cA cpw wcel vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel vs cv cF cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      vs cv cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw
      wcel cA cA cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn
      eldifi syl adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs cv cF cfv cA
      wss vs cv cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv
      vs cv cF cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA cpw c0 csn
      cdif cF wf wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs cv cF fvex
      wereucl cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel simpll cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA
      cpw wcel vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs
      cv cF cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA
      cA cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 wne cA cA
      cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn cdif wcel vs
      cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA cpw c0 csn
      eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv c0 wceq vs
      cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi
      syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd ex r19.21aivv vx
      vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vx
      cv cF fvex rabex uniex acdclem.2 fnoprab2 jctil vs vt cA cA cA cS ffnoprv
      sylibr adantr syl3anc vk cv cG cS cn vc cv csn cxp cseq1 co acdclem.3
      fveq1i syl5eqel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf vk
      cv cn wcel simplrl sylanc eqtrd vk cv cG cfv vk cv cS cn vc cv csn cxp
      cseq1 co cfv vk cv c1 caddc co cn vc cv csn cxp cfv cS vk cv cG cS cn vc
      cv csn cxp cseq1 co acdclem.3 fveq1i opreq1i syl5eqr eqtrd vk cv c1 caddc
      co cG cS cn vc cv csn cxp cseq1 co acdclem.3 fveq1i syl5eq cA vr cv wwe
      vk cv cG cfv cF cfv cA wss vk cv cG cfv cF cfv c0 wne vu cv vv cv vr cv
      wbr wn vu vk cv cG cfv cF cfv wral vv vk cv cG cfv cF cfv crab cuni vk cv
      cG cfv cF cfv wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf
      wa wa vk cv cn wcel wa vv vu cA vk cv cG cfv cF cfv vr cv vk cv cG cfv cF
      fvex wereucl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa vk
      cv cn wcel simpll cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf
      wa wa vk cv cn wcel wa vk cv cG cfv cF cfv cA cpw wcel vk cv cG cfv cF
      cfv cA wss cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa
      vk cv cn wcel wa vk cv cG cfv cF cfv cA cpw c0 csn cdif wcel vk cv cG cfv
      cF cfv cA cpw wcel cA cA cpw c0 csn cdif cF wf vk cv cG cfv cA wcel vk cv
      cG cfv cF cfv cA cpw c0 csn cdif wcel cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa cA cA cpw c0 csn cdif vk cv
      cG cfv cF ffvelrn cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf
      vk cv cn wcel simplrr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF
      wf wa wa vk cv cn wcel wa vk cv cS cn vc cv csn cxp cseq1 co cfv cA vk cv
      cG cfv vk cv cn wcel cn cA cn vc cv csn cxp wf cA cA cxp cA cS wf vk cv
      cS cn vc cv csn cxp cseq1 co cfv cA wcel cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cA cS cn vc cv csn cxp
      vx vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab cuni cS acdclem.1 acdclem.1 acdclem.2 oprabex2 cn vc cv csn nnex
      vc cv snex xpex seq1cl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn cdif
      cF wf wa wa vk cv cn wcel pm3.27 vc cv cA wcel cA cA cpw c0 csn cdif cF
      wf wa cn cA cn vc cv csn cxp wf cA vr cv wwe vk cv cn wcel vc cv cA wcel
      cn cA cn vc cv csn cxp wf cA cA cpw c0 csn cdif cF wf cn vc cv csn cn vc
      cv csn cxp wf vc cv csn cA wss cn cA cn vc cv csn cxp wf vc cv cA wcel cn
      vc cv csn cA cn vc cv csn cxp fss cn vc cv vc visset fconst vc cv cA
      snssi sylancr adantr ad2antlr cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa cA cA cxp cA cS wf vk cv cn wcel cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa cS cA cA cxp wfn vs cv vt cv cS co
      cA wcel vt cA wral vs cA wral wa cA cA cxp cA cS wf cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vt cA
      wral vs cA wral cS cA cA cxp wfn cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vs vt cA cA cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv cA
      wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vs cv cA wcel vt cv cA wcel wa wa vs cv vt cv cS co
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      cA vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co vu cv vv cv vr cv wbr
      wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni wceq cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vx vy vz vs cv vt cv cA cA vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni vu
      cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cS
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni
      vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv vs cv cF fvex
      rabex uniex vx cv vs cv wceq vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral
      vv vs cv cF cfv crab vx cv vs cv wceq vx cv cF cfv vs cv cF cfv wceq vu
      cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv
      cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab wceq vx cv vs
      cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral
      vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF cfv vs cv cF cfv wceq vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vs cv
      cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv wbr wn vu vx cv cF cfv vs
      cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv vt cv wceq vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni eqidd
      acdclem.2 oprabval2 adantl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA wcel vt cv cA wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv cA wcel cA vr cv wwe cA
      cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs cv cF cfv cA wss vs cv
      cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs cv cF fvex wereucl cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel simpll cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 wne cA cA
      cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn cdif wcel vs
      cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA cpw c0 csn
      eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv c0 wceq vs
      cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi
      syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd ex r19.21aivv vx
      vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vx
      cv cF fvex rabex uniex acdclem.2 fnoprab2 jctil vs vt cA cA cA cS ffnoprv
      sylibr adantr syl3anc vk cv cG cS cn vc cv csn cxp cseq1 co acdclem.3
      fveq1i syl5eqel sylanc vk cv cG cfv cF cfv cA cpw c0 csn eldifi syl vk cv
      cG cfv cF cfv cA elpwi syl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vk cv cn wcel wa vk cv cG cfv cF cfv cA cpw c0 csn cdif
      wcel vk cv cG cfv cF cfv c0 wne cA cA cpw c0 csn cdif cF wf vk cv cG cfv
      cA wcel vk cv cG cfv cF cfv cA cpw c0 csn cdif wcel cA vr cv wwe vc cv cA
      wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa cA cA cpw c0 csn
      cdif vk cv cG cfv cF ffvelrn cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf vk cv cn wcel simplrr cA vr cv wwe vc cv cA wcel cA cA cpw c0
      csn cdif cF wf wa wa vk cv cn wcel wa vk cv cS cn vc cv csn cxp cseq1 co
      cfv cA vk cv cG cfv vk cv cn wcel cn cA cn vc cv csn cxp wf cA cA cxp cA
      cS wf vk cv cS cn vc cv csn cxp cseq1 co cfv cA wcel cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf wa wa vk cv cn wcel wa vk cv cA cS cn
      vc cv csn cxp vx vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab cuni cS acdclem.1 acdclem.1 acdclem.2 oprabex2
      cn vc cv csn nnex vc cv snex xpex seq1cl cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf wa wa vk cv cn wcel pm3.27 vc cv cA wcel cA cA cpw
      c0 csn cdif cF wf wa cn cA cn vc cv csn cxp wf cA vr cv wwe vk cv cn wcel
      vc cv cA wcel cn cA cn vc cv csn cxp wf cA cA cpw c0 csn cdif cF wf cn vc
      cv csn cn vc cv csn cxp wf vc cv csn cA wss cn cA cn vc cv csn cxp wf vc
      cv cA wcel cn vc cv csn cA cn vc cv csn cxp fss cn vc cv vc visset fconst
      vc cv cA snssi sylancr adantr ad2antlr cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf wa wa cA cA cxp cA cS wf vk cv cn wcel cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cS cA cA cxp wfn vs cv vt
      cv cS co cA wcel vt cA wral vs cA wral wa cA cA cxp cA cS wf cA vr cv wwe
      vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA wcel
      vt cA wral vs cA wral cS cA cA cxp wfn cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf wa wa vs cv vt cv cS co cA wcel vs vt cA cA cA vr
      cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt
      cv cA wcel wa vs cv vt cv cS co cA wcel cA vr cv wwe vc cv cA wcel cA cA
      cpw c0 csn cdif cF wf wa wa vs cv cA wcel vt cv cA wcel wa wa vs cv vt cv
      cS co vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab
      cuni cA vs cv cA wcel vt cv cA wcel wa vs cv vt cv cS co vu cv vv cv vr
      cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni wceq cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa vx vy vz vs cv vt cv
      cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      cuni vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab
      cuni cS vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv
      crab cuni vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv
      crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv vs cv
      cF fvex rabex uniex vx cv vs cv wceq vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab vx cv vs cv wceq vx cv cF cfv vs cv cF cfv wceq
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab vu cv
      vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab wceq vx cv
      vs cv cF fveq2 vx cv cF cfv vs cv cF cfv wceq vu cv vv cv vr cv wbr wn vu
      vx cv cF cfv wral vv vx cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv
      cF cfv wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral
      vv vx cv cF cfv vs cv cF cfv rabeq vx cv cF cfv vs cv cF cfv wceq vu cv
      vv cv vr cv wbr wn vu vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vs cv
      cF cfv wral vv vs cv cF cfv vu cv vv cv vr cv wbr wn vu vx cv cF cfv vs
      cv cF cfv raleq1 rabbisdv eqtrd syl unieqd vy cv vt cv wceq vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni eqidd
      acdclem.2 oprabval2 adantl cA vr cv wwe vc cv cA wcel cA cA cpw c0 csn
      cdif cF wf wa wa vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF cfv
      wral vv vs cv cF cfv crab cuni cA wcel vt cv cA wcel cA vr cv wwe cA cA
      cpw c0 csn cdif cF wf vs cv cA wcel vu cv vv cv vr cv wbr wn vu vs cv cF
      cfv wral vv vs cv cF cfv crab cuni cA wcel vc cv cA wcel cA vr cv wwe cA
      cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA vu cv vv cv
      vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF cfv crab cuni cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA vr cv wwe vs cv cF cfv cA wss vs cv
      cF cfv c0 wne vu cv vv cv vr cv wbr wn vu vs cv cF cfv wral vv vs cv cF
      cfv crab cuni vs cv cF cfv wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf
      wa vs cv cA wcel wa vv vu cA vs cv cF cfv vr cv vs cv cF fvex wereucl cA
      vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel simpll cA vr cv wwe
      cA cA cpw c0 csn cdif cF wf wa vs cv cA wcel wa vs cv cF cfv cA cpw wcel
      vs cv cF cfv cA wss cA cA cpw c0 csn cdif cF wf vs cv cA wcel vs cv cF
      cfv cA cpw wcel cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv cA wcel wa
      vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv cA cpw wcel cA cA cpw
      c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn eldifi syl
      adantll vs cv cF cfv cA elpwi syl cA cA cpw c0 csn cdif cF wf vs cv cA
      wcel vs cv cF cfv c0 wne cA vr cv wwe cA cA cpw c0 csn cdif cF wf vs cv
      cA wcel wa vs cv cF cfv cA cpw c0 csn cdif wcel vs cv cF cfv c0 wne cA cA
      cpw c0 csn cdif vs cv cF ffvelrn vs cv cF cfv cA cpw c0 csn cdif wcel vs
      cv cF cfv c0 csn wcel wn vs cv cF cfv c0 wne vs cv cF cfv cA cpw c0 csn
      eldifn vs cv cF cfv c0 csn wcel vs cv cF cfv c0 vs cv cF cfv c0 wceq vs
      cv cF cfv c0 c0 csn vs cv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi
      syl syl adantll syl3anc sseldd adantlrl adantrr eqeltrd ex r19.21aivv vx
      vy vz cA cA vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni cS vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF
      cfv crab vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv vx
      cv cF fvex rabex uniex acdclem.2 fnoprab2 jctil vs vt cA cA cA cS ffnoprv
      sylibr adantr syl3anc vk cv cG cS cn vc cv csn cxp cseq1 co acdclem.3
      fveq1i syl5eqel sylanc vk cv cG cfv cF cfv cA cpw c0 csn cdif wcel vk cv
      cG cfv cF cfv c0 csn wcel wn vk cv cG cfv cF cfv c0 wne vk cv cG cfv cF
      cfv cA cpw c0 csn eldifn vk cv cG cfv cF cfv c0 csn wcel vk cv cG cfv cF
      cfv c0 vk cv cG cfv cF cfv c0 wceq vk cv cG cfv cF cfv c0 c0 csn vk cv cG
      cfv cF cfv c0 wceq id c0 0ex snid syl6eqel necon3bi syl syl syl3anc
      eqeltrd r19.21aiva jca $.
      $( [22-Sep-2007] $) $( [21-Sep-2007] $)
  $}

  ${
    $d a b c d g k r u v x y z A $.  $d a b c d f g h k r u v x y z F $.
    acdc.1 $e |- A e. _V $.
    $( Dependent Choice.  Axiom DC1 of [Schechter] p. 149.  This theorem is
       weaker than the Axiom of Choice but is stronger than Countable Choice.
       It shows the existence of a sequence whose values can only be shown to
       exist (but cannot be constructed explicitly) and also depend on earlier
       values in the sequence. $)
    acdc $p |- ( ( A =/= (/) /\ F : A --> ( ~P A \ { (/) } ) ) -> E. g
     ( g : NN --> A /\ A. k e. NN ( g ` ( k + 1 ) ) e. ( F ` ( g ` k ) ) ) ) $=
      cA vr cv wwe vr wex cA c0 wne cA cA cpw c0 csn cdif cF wf wa cn cA vg cv
      wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa
      vg wex wi vr cA acdc.1 weth cA vr cv wwe cA c0 wne cA cA cpw c0 csn cdif
      cF wf wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF
      cfv wcel vk cn wral wa vg wex wi vr cA vr cv wwe cA c0 wne cA cA cpw c0
      csn cdif cF wf cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv
      cF cfv wcel vk cn wral wa vg wex cA vr cv wwe vc cv cA wcel vc wex cA cA
      cpw c0 csn cdif cF wf cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg
      cv cfv cF cfv wcel vk cn wral wa vg wex wi cA c0 wne cA vr cv wwe vc cv
      cA wcel cA cA cpw c0 csn cdif cF wf cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg wex wi vc cA vr cv
      wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg wex cA vr
      cv wwe vc cv cA wcel cA cA cpw c0 csn cdif cF wf wa wa cn cA va cv cA
      wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1
      co wf vk cv c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb
      vd copab2 cn vc cv csn cxp cseq1 co cfv vk cv va cv cA wcel vb cv cA wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv
      wcel vk cn wral wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv
      cfv cF cfv wcel vk cn wral wa vg wex vx vy vz vv vu cA va cv cA wcel vb
      cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va
      cv cF cfv crab cuni wceq wa va vb vd copab2 vk cF va cv cA wcel vb cv cA
      wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF
      cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co vr vc
      acdc.1 va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 vx cv
      cA wcel vy cv cA wcel wa vd cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv
      wral vv vx cv cF cfv crab cuni wceq wa vx vy vd copab2 vx cv cA wcel vy
      cv cA wcel wa vz cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx
      cv cF cfv crab cuni wceq wa vx vy vz copab2 va cv cA wcel vb cv cA wcel
      wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni wceq wa vx cv cA wcel vy cv cA wcel wa vd cv vu cv vv cv vr cv
      wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq wa va vb vd vx
      vy va cv vx cv wceq vb cv vy cv wceq wa va cv cA wcel vb cv cA wcel wa vx
      cv cA wcel vy cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF
      cfv wral vf va cv cF cfv crab cuni wceq vd cv vu cv vv cv vr cv wbr wn vu
      vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq va cv vx cv wceq va cv
      cA wcel vx cv cA wcel vb cv vy cv wceq vb cv cA wcel vy cv cA wcel va cv
      vx cv cA eleq1 vb cv vy cv cA eleq1 bi2anan9 va cv vx cv wceq vb cv vy cv
      wceq wa vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab cuni vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv
      crab cuni vd cv va cv vx cv wceq vb cv vy cv wceq wa vh cv vf cv vr cv
      wbr wn vh va cv cF cfv wral vf va cv cF cfv crab vu cv vv cv vr cv wbr wn
      vu vx cv cF cfv wral vv vx cv cF cfv crab va cv vx cv wceq vb cv vy cv
      wceq wa vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab vh cv vf cv vr cv wbr wn vh vx cv cF cfv wral vf vx cv cF cfv crab
      vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab va cv
      vx cv wceq vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv
      crab vh cv vf cv vr cv wbr wn vh vx cv cF cfv wral vf vx cv cF cfv crab
      wceq vb cv vy cv wceq va cv vx cv wceq va cv cF cfv vx cv cF cfv wceq vh
      cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab vh cv vf
      cv vr cv wbr wn vh vx cv cF cfv wral vf vx cv cF cfv crab wceq va cv vx
      cv cF fveq2 va cv cF cfv vx cv cF cfv wceq vh cv vf cv vr cv wbr wn vh va
      cv cF cfv wral vf va cv cF cfv crab vh cv vf cv vr cv wbr wn vh va cv cF
      cfv wral vf vx cv cF cfv crab vh cv vf cv vr cv wbr wn vh vx cv cF cfv
      wral vf vx cv cF cfv crab vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv vx cv cF cfv rabeq va cv cF cfv vx cv cF cfv wceq vh cv
      vf cv vr cv wbr wn vh va cv cF cfv wral vh cv vf cv vr cv wbr wn vh vx cv
      cF cfv wral vf vx cv cF cfv vh cv vf cv vr cv wbr wn vh va cv cF cfv vx
      cv cF cfv raleq1 rabbisdv eqtrd syl adantr vh cv vf cv vr cv wbr wn vh vx
      cv cF cfv wral vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vf vv vx cv
      cF cfv vf cv vv cv wceq vh cv vf cv vr cv wbr wn vh vx cv cF cfv wral vh
      cv vv cv vr cv wbr wn vh vx cv cF cfv wral vu cv vv cv vr cv wbr wn vu vx
      cv cF cfv wral vf cv vv cv wceq vh cv vf cv vr cv wbr wn vh cv vv cv vr
      cv wbr wn vh vx cv cF cfv vf cv vv cv wceq vh cv vf cv vr cv wbr vh cv vv
      cv vr cv wbr vf cv vv cv vh cv vr cv breq2 notbid ralbidv vh cv vv cv vr
      cv wbr wn vu cv vv cv vr cv wbr wn vh vu vx cv cF cfv vh cv vu cv wceq vh
      cv vv cv vr cv wbr vu cv vv cv vr cv wbr vh cv vu cv vv cv vr cv breq1
      notbid cbvralv syl6bb cbvrabv syl6eq unieqd eqeq2d anbi12d cbvoprab12v vx
      cv cA wcel vy cv cA wcel wa vd cv vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vx cv cF cfv crab cuni wceq wa vx cv cA wcel vy cv cA wcel wa
      vz cv vu cv vv cv vr cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab
      cuni wceq wa vx vy vd vz vd cv vz cv wceq vd cv vu cv vv cv vr cv wbr wn
      vu vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq vz cv vu cv vv cv vr
      cv wbr wn vu vx cv cF cfv wral vv vx cv cF cfv crab cuni wceq vx cv cA
      wcel vy cv cA wcel wa vd cv vz cv vu cv vv cv vr cv wbr wn vu vx cv cF
      cfv wral vv vx cv cF cfv crab cuni eqeq1 anbi2d cbvoprab3v eqtri va cv cA
      wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1
      co eqid acdclem cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv
      cfv cF cfv wcel vk cn wral wa cn cA va cv cA wcel vb cv cA wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni
      wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wf vk cv c1 caddc co va
      cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF
      cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn
      cxp cseq1 co cfv vk cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv
      vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb
      vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv wcel vk cn wral wa vg va
      cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF
      cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn
      cxp cseq1 co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2
      cn vc cv csn cxp cseq1 oprex vg cv va cv cA wcel vb cv cA wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni
      wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wceq cn cA vg cv wf cn
      cA va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv
      cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv
      csn cxp cseq1 co wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv
      wcel vk cn wral vk cv c1 caddc co va cv cA wcel vb cv cA wcel wa vd cv vh
      cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq
      wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv vk cv va cv cA wcel vb
      cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va
      cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv
      cF cfv wcel vk cn wral cn cA vg cv va cv cA wcel vb cv cA wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni
      wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co feq1 vg cv va cv cA
      wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1
      co wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cv c1
      caddc co va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh
      va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc
      cv csn cxp cseq1 co cfv vk cv va cv cA wcel vb cv cA wcel wa vd cv vh cv
      vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa
      va vb vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv wcel vk cn vg cv va
      cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF
      cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn
      cxp cseq1 co wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co va cv cA
      wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral
      vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1
      co cfv vk cv vg cv cfv cF cfv vk cv va cv cA wcel vb cv cA wcel wa vd cv
      vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab cuni
      wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co cfv cF cfv vk cv c1
      caddc co vg cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr
      wn vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2
      cn vc cv csn cxp cseq1 co fveq1 vg cv va cv cA wcel vb cv cA wcel wa vd
      cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab
      cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co wceq vk cv vg cv
      cfv vk cv va cv cA wcel vb cv cA wcel wa vd cv vh cv vf cv vr cv wbr wn
      vh va cv cF cfv wral vf va cv cF cfv crab cuni wceq wa va vb vd copab2 cn
      vc cv csn cxp cseq1 co cfv cF vk cv vg cv va cv cA wcel vb cv cA wcel wa
      vd cv vh cv vf cv vr cv wbr wn vh va cv cF cfv wral vf va cv cF cfv crab
      cuni wceq wa va vb vd copab2 cn vc cv csn cxp cseq1 co fveq1 fveq2d
      eleq12d ralbidv anbi12d cla4ev syl exp32 19.23adv vc cA n0 syl5ib imp3a
      19.23aiv ax-mp $.
      $( [22-Sep-2007] $) $( [21-Sep-2007] $)
  $}

  ${
    $d g k x y z A $.  $d g k x y z F $.
    acdcALT.1 $e |- A e. _V $.
    $( Dependent Choice.  Axiom DC1 of [Schechter] p. 149.  This theorem is
       weaker than the Axiom of Choice but is stronger than Countable Choice.
       It shows the existence of a sequence whose values can only be shown to
       exist (but cannot be constructed explicitly) and also depend on earlier
       values in the sequence. $)
    acdcALT $p |- ( ( A =/= (/) /\ F : A --> ( ~P A \ { (/) } ) ) -> E. g
     ( g : NN --> A /\ A. k e. NN ( g ` ( k + 1 ) ) e. ( F ` ( g ` k ) ) ) ) $=
      cA c0 wne cA cA cpw c0 csn cdif cF wf wa cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv vx cv cn wcel vy cv cA wcel
      wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 co wcel vk cn wral wa vg
      wex cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv
      wcel vk cn wral wa vg wex cA c0 wne cn cA cxp cA cpw c0 csn cdif vx cv cn
      wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 wf cn cA
      vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv vx
      cv cn wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 co
      wcel vk cn wral wa vg wex cA cA cpw c0 csn cdif cF wf cA vg vk vx cv cn
      wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2
      acdcALT.1 acdc2 cA cA cpw c0 csn cdif cF wf vy cv cF cfv cA cpw c0 csn
      cdif wcel vy cA wral vx cn wral cn cA cxp cA cpw c0 csn cdif vx cv cn
      wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 wf cA cA
      cpw c0 csn cdif cF wf vy cv cF cfv cA cpw c0 csn cdif wcel vx vy cn cA cA
      cA cpw c0 csn cdif cF wf vy cv cA wcel vy cv cF cfv cA cpw c0 csn cdif
      wcel vx cv cn wcel cA cA cpw c0 csn cdif cF wf vy cv cA wcel vy cv cF cfv
      cA cpw c0 csn cdif wcel cA cA cpw c0 csn cdif vy cv cF ffvelrn ex adantld
      r19.21aivv vx vy vz cn cA vy cv cF cfv cA cpw c0 csn cdif vx cv cn wcel
      vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 vx cv cn wcel
      vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 eqid foprab2
      sylib sylan2 cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv vx cv cn wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa
      vx vy vz copab2 co wcel vk cn wral wa cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg cn cA vg cv wf vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv vx cv cn wcel vy
      cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 co wcel vk cn
      wral vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral
      cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv vx cv cn wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz
      copab2 co wcel vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk
      cn cn cA vg cv wf vk cv cn wcel wa vk cv c1 caddc co vk cv vg cv cfv vx
      cv cn wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 co
      vk cv vg cv cfv cF cfv vk cv c1 caddc co vg cv cfv vk cv c1 caddc co cn
      wcel vk cv vg cv cfv cA wcel vk cv c1 caddc co vk cv vg cv cfv vx cv cn
      wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 co vk cv
      vg cv cfv cF cfv wceq cn cA vg cv wf vk cv cn wcel wa vx vy vz vk cv c1
      caddc co vk cv vg cv cfv cn cA vy cv cF cfv vk cv vg cv cfv cF cfv vx cv
      cn wcel vy cv cA wcel wa vz cv vy cv cF cfv wceq wa vx vy vz copab2 vy cv
      cF cfv vk cv vg cv cfv cF fvex vx cv vk cv c1 caddc co wceq vy cv cF cfv
      eqidd vy cv vk cv vg cv cfv cF fveq2 vx cv cn wcel vy cv cA wcel wa vz cv
      vy cv cF cfv wceq wa vx vy vz copab2 eqid oprabval2 vk cv cn wcel vk cv
      c1 caddc co cn wcel cn cA vg cv wf vk cv peano2nn adantl cn cA vk cv vg
      cv ffvelrn sylanc eleq2d ralbidva pm5.32i exbii sylib $.
      $( [31-Mar-2008] $) $( [1-Oct-2007] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
              Cardinality and cardinal arithmetic (cont.)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Countability of integers and rationals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( The nonnegative integers are equinumerous to the natural numbers. $)
    nn0ennn $p |- NN0 ~~ NN $=
      vx vy cn0 cn vx cv c1 caddc co vy cv c1 cmin co nn0ex vx cv nn0p1nn vy cv
      nnm1nn0 vy cv cn wcel vx cv cn0 wcel vx cv vy cv c1 cmin co wceq vy cv vx
      cv c1 caddc co wceq wb vy cv cc wcel vx cv cc wcel vx cv vy cv c1 cmin co
      wceq vy cv vx cv c1 caddc co wceq wb vy cv cn wcel vx cv cn0 wcel vy cv
      cc wcel vx cv cc wcel wa vx cv vy cv c1 cmin co wceq vy cv c1 vx cv caddc
      co wceq vy cv vx cv c1 caddc co wceq vy cv cc wcel vx cv cc wcel wa vy cv
      c1 cmin co vx cv wceq c1 vx cv caddc co vy cv wceq vx cv vy cv c1 cmin co
      wceq vy cv c1 vx cv caddc co wceq vy cv cc wcel c1 cc wcel vx cv cc wcel
      vy cv c1 cmin co vx cv wceq c1 vx cv caddc co vy cv wceq wb ax1cn vy cv
      c1 vx cv subadd mp3an2 vx cv vy cv c1 cmin co eqcom vy cv c1 vx cv caddc
      co eqcom 3bitr4g vx cv cc wcel vy cv c1 vx cv caddc co wceq vy cv vx cv
      c1 caddc co wceq wb vy cv cc wcel vx cv cc wcel c1 vx cv caddc co vx cv
      c1 caddc co vy cv c1 cc wcel vx cv cc wcel c1 vx cv caddc co vx cv c1
      caddc co wceq ax1cn c1 vx cv addcom mpan eqeq2d adantl bitrd vy cv nncn
      vx cv nn0cn syl2an ancoms en3 $.
      $( [2-Oct-2004] $) $( [19-Jul-2004] $)

    $( The set of natural numbers (as a subset of complex numbers) is
       equinumerous to omega (the set of finite ordinal numbers). $)
    nnenom $p |- NN ~~ om $=
      com cn0 cn nnex com cn0 vy cv vx cv c1 caddc co wceq vx vy copab cc0 crdg
      com cres wf1o com cn0 cen wbr com cn0 vy cv vx cv c1 caddc co wceq vx vy
      copab cc0 crdg com cres wf1o com cc0 vz cv cle wbr vz cz crab vy cv vx cv
      c1 caddc co wceq vx vy copab cc0 crdg com cres wf1o vx vy vz cc0 vy cv vx
      cv c1 caddc co wceq vx vy copab cc0 crdg com cres 0z vy cv vx cv c1 caddc
      co wceq vx vy copab cc0 crdg com cres eqid om2uzf1oi cn0 cc0 vz cv cle
      wbr vz cz crab wceq com cn0 vy cv vx cv c1 caddc co wceq vx vy copab cc0
      crdg com cres wf1o com cc0 vz cv cle wbr vz cz crab vy cv vx cv c1 caddc
      co wceq vx vy copab cc0 crdg com cres wf1o wb vz nn0zrab cn0 cc0 vz cv
      cle wbr vz cz crab com vy cv vx cv c1 caddc co wceq vx vy copab cc0 crdg
      com cres f1oeq3 ax-mp mpbir com cn0 vy cv vx cv c1 caddc co wceq vx vy
      copab cc0 crdg com cres omex f1oen ax-mp nn0ennn entr2i $.
      $( [2-Oct-2004] $) $( [31-Jul-2004] $)
  $}

  ${
    $d x y z w v u $.
    $( The cross product of the set of natural numbers with itself is
       equinumerous to the set of natural numbers.  The key idea is to
       use ~ nn0opth2 to show that the mapping from natural numbers ` z `
       and ` w ` to ` ( ( z + w ) ^ 2 ) + w ` is one-to-one. $)
    xpnnen $p |- ( NN X. NN ) ~~ NN $=
      cn cn cxp cn cdom wbr cn cn cn cxp cdom wbr cn cn cxp cn cen wbr cn cn
      cxp cvv wcel cn cn cxp cn cdom wbr cn cn nnex nnex xpex vx vy cn cn cxp
      cn vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn crn
      cuni caddc co vy cv cint cint vy cv csn crn cuni caddc co c2 cexp co vy
      cv csn crn cuni caddc co cvv vx cv cn cn cxp wcel vx cv vx cv cint cint
      vx cv csn crn cuni cop wceq vx cv cint cint cn wcel vx cv csn crn cuni cn
      wcel wa wa vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv
      csn crn cuni caddc co cn wcel vx cv cn cn elxp5 vx cv cint cint cn wcel
      vx cv csn crn cuni cn wcel wa vx cv cint cint vx cv csn crn cuni caddc co
      c2 cexp co vx cv csn crn cuni caddc co cn wcel vx cv vx cv cint cint vx
      cv csn crn cuni cop wceq vx cv cint cint cn wcel vx cv csn crn cuni cn
      wcel vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co cn wcel vx cv
      cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn crn cuni caddc
      co cn wcel vx cv cint cint vx cv csn crn cuni caddc co cn wcel c2 cn0
      wcel vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co cn wcel vx cv
      cint cint cn wcel vx cv csn crn cuni cn wcel wa vx cv cint cint vx cv csn
      crn cuni caddc co c2 nnexpcl vx cv cint cint vx cv csn crn cuni nnaddcl
      2nn0 sylancl vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv
      csn crn cuni nnaddcl sylancom adantl sylbi vx cv vz cv vw cv cop wceq vw
      cn wrex vz cn wrex vy cv vv cv vu cv cop wceq vu cn wrex vv cn wrex vx cv
      cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn crn cuni caddc
      co vy cv cint cint vy cv csn crn cuni caddc co c2 cexp co vy cv csn crn
      cuni caddc co wceq vx cv vy cv wceq wb vx cv cn cn cxp wcel vy cv cn cn
      cxp wcel vx cv vz cv vw cv cop wceq vw cn wrex vz cn wrex vy cv vv cv vu
      cv cop wceq vu cn wrex vv cn wrex vx cv cint cint vx cv csn crn cuni
      caddc co c2 cexp co vx cv csn crn cuni caddc co vy cv cint cint vy cv csn
      crn cuni caddc co c2 cexp co vy cv csn crn cuni caddc co wceq vx cv vy cv
      wceq wb vx cv vz cv vw cv cop wceq vw cn wrex vz cn wrex vy cv vv cv vu
      cv cop wceq vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv
      csn crn cuni caddc co vy cv cint cint vy cv csn crn cuni caddc co c2 cexp
      co vy cv csn crn cuni caddc co wceq vx cv vy cv wceq wb vv vu cn cn vx cv
      vz cv vw cv cop wceq vv cv cn wcel vu cv cn wcel wa vy cv vv cv vu cv cop
      wceq vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn crn
      cuni caddc co vy cv cint cint vy cv csn crn cuni caddc co c2 cexp co vy
      cv csn crn cuni caddc co wceq vx cv vy cv wceq wb wi wi vz vw cn cn vz cv
      cn wcel vw cv cn wcel wa vv cv cn wcel vu cv cn wcel wa vx cv vz cv vw cv
      cop wceq vy cv vv cv vu cv cop wceq vx cv cint cint vx cv csn crn cuni
      caddc co c2 cexp co vx cv csn crn cuni caddc co vy cv cint cint vy cv csn
      crn cuni caddc co c2 cexp co vy cv csn crn cuni caddc co wceq vx cv vy cv
      wceq wb wi vz cv cn wcel vw cv cn wcel wa vv cv cn wcel vu cv cn wcel wa
      vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq vx cv cint cint vx
      cv csn crn cuni caddc co c2 cexp co vx cv csn crn cuni caddc co vy cv
      cint cint vy cv csn crn cuni caddc co c2 cexp co vy cv csn crn cuni caddc
      co wceq vx cv vy cv wceq wb vz cv cn wcel vw cv cn wcel wa vv cv cn wcel
      vu cv cn wcel wa wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq
      wa wa vx cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn
      crn cuni caddc co vy cv cint cint vy cv csn crn cuni caddc co c2 cexp co
      vy cv csn crn cuni caddc co wceq vz cv vv cv wceq vw cv vu cv wceq wa vx
      cv vy cv wceq vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq wa vx
      cv cint cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn crn cuni
      caddc co vy cv cint cint vy cv csn crn cuni caddc co c2 cexp co vy cv csn
      crn cuni caddc co wceq vz cv vw cv caddc co c2 cexp co vw cv caddc co vv
      cv vu cv caddc co c2 cexp co vu cv caddc co wceq vz cv cn wcel vw cv cn
      wcel wa vv cv cn wcel vu cv cn wcel wa wa vz cv vv cv wceq vw cv vu cv
      wceq wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq vx cv cint
      cint vx cv csn crn cuni caddc co c2 cexp co vx cv csn crn cuni caddc co
      vz cv vw cv caddc co c2 cexp co vw cv caddc co vy cv cint cint vy cv csn
      crn cuni caddc co c2 cexp co vy cv csn crn cuni caddc co vv cv vu cv
      caddc co c2 cexp co vu cv caddc co vx cv vz cv vw cv cop wceq vx cv cint
      cint vx cv csn crn cuni caddc co c2 cexp co vz cv vw cv caddc co c2 cexp
      co vx cv csn crn cuni vw cv caddc vx cv vz cv vw cv cop wceq vx cv cint
      cint vx cv csn crn cuni caddc co vz cv vw cv caddc co c2 cexp vx cv vz cv
      vw cv cop wceq vx cv cint cint vz cv vx cv csn crn cuni vw cv caddc vx cv
      vz cv vw cv cop wceq vx cv cint cint vz cv vw cv cop cint cint vz cv vx
      cv vz cv vw cv cop wceq vx cv cint vz cv vw cv cop cint vx cv vz cv vw cv
      cop inteq inteqd vz cv vw cv vz visset op1stb syl6eq vx cv vz cv vw cv
      cop wceq vx cv csn crn cuni vz cv vw cv cop csn crn cuni vw cv vx cv vz
      cv vw cv cop wceq vx cv csn crn vz cv vw cv cop csn crn vx cv vz cv vw cv
      cop wceq vx cv csn vz cv vw cv cop csn vx cv vz cv vw cv cop sneq rneqd
      unieqd vz cv vw cv vz visset vw visset op2nda syl6eq opreq12d opreq1d vx
      cv vz cv vw cv cop wceq vx cv csn crn cuni vz cv vw cv cop csn crn cuni
      vw cv vx cv vz cv vw cv cop wceq vx cv csn crn vz cv vw cv cop csn crn vx
      cv vz cv vw cv cop wceq vx cv csn vz cv vw cv cop csn vx cv vz cv vw cv
      cop sneq rneqd unieqd vz cv vw cv vz visset vw visset op2nda syl6eq
      opreq12d vy cv vv cv vu cv cop wceq vy cv cint cint vy cv csn crn cuni
      caddc co c2 cexp co vv cv vu cv caddc co c2 cexp co vy cv csn crn cuni vu
      cv caddc vy cv vv cv vu cv cop wceq vy cv cint cint vy cv csn crn cuni
      caddc co vv cv vu cv caddc co c2 cexp vy cv vv cv vu cv cop wceq vy cv
      cint cint vv cv vy cv csn crn cuni vu cv caddc vy cv vv cv vu cv cop wceq
      vy cv cint cint vv cv vu cv cop cint cint vv cv vy cv vv cv vu cv cop
      wceq vy cv cint vv cv vu cv cop cint vy cv vv cv vu cv cop inteq inteqd
      vv cv vu cv vv visset op1stb syl6eq vy cv vv cv vu cv cop wceq vy cv csn
      crn cuni vv cv vu cv cop csn crn cuni vu cv vy cv vv cv vu cv cop wceq vy
      cv csn crn vv cv vu cv cop csn crn vy cv vv cv vu cv cop wceq vy cv csn
      vv cv vu cv cop csn vy cv vv cv vu cv cop sneq rneqd unieqd vv cv vu cv
      vv visset vu visset op2nda syl6eq opreq12d opreq1d vy cv vv cv vu cv cop
      wceq vy cv csn crn cuni vv cv vu cv cop csn crn cuni vu cv vy cv vv cv vu
      cv cop wceq vy cv csn crn vv cv vu cv cop csn crn vy cv vv cv vu cv cop
      wceq vy cv csn vv cv vu cv cop csn vy cv vv cv vu cv cop sneq rneqd
      unieqd vv cv vu cv vv visset vu visset op2nda syl6eq opreq12d eqeqan12d
      vz cv cn0 wcel vw cv cn0 wcel wa vv cv cn0 wcel vu cv cn0 wcel wa vz cv
      vw cv caddc co c2 cexp co vw cv caddc co vv cv vu cv caddc co c2 cexp co
      vu cv caddc co wceq vz cv vv cv wceq vw cv vu cv wceq wa wb vz cv cn wcel
      vw cv cn wcel wa vv cv cn wcel vu cv cn wcel wa vz cv vw cv vv cv vu cv
      nn0opth2 vz cv cn wcel vz cv cn0 wcel vw cv cn wcel vw cv cn0 wcel vz cv
      nnnn0 vw cv nnnn0 anim12i vv cv cn wcel vv cv cn0 wcel vu cv cn wcel vu
      cv cn0 wcel vv cv nnnn0 vu cv nnnn0 anim12i syl2an sylan9bbr vx cv vz cv
      vw cv cop wceq vy cv vv cv vu cv cop wceq wa vx cv vy cv wceq vz cv vv cv
      wceq vw cv vu cv wceq wa wb vz cv cn wcel vw cv cn wcel wa vv cv cn wcel
      vu cv cn wcel wa wa vx cv vz cv vw cv cop wceq vy cv vv cv vu cv cop wceq
      wa vx cv vy cv wceq vz cv vw cv cop vv cv vu cv cop wceq vz cv vv cv wceq
      vw cv vu cv wceq wa vx cv vz cv vw cv cop vy cv vv cv vu cv cop eqeq12 vz
      cv vw cv vv cv vu cv vz visset vw visset vu visset opth syl6bb adantl
      bitr4d exp43 com23 r19.23aivv r19.23advv imp vz vw vx cv cn cn elxp2 vv
      vu vy cv cn cn elxp2 syl2anb dom2 ax-mp cn cn c1 csn cxp cen wbr cn c1
      csn cxp cn cn cxp cdom wbr cn cn cn cxp cdom wbr cn c1 csn cxp cn nnex cn
      c1 nnex c1 cn 1nn elisseti xpsnen ensymi cn cn cxp cvv wcel cn c1 csn cxp
      cn cn cxp wss cn c1 csn cxp cn cn cxp cdom wbr cn cn nnex nnex xpex cn cn
      wss c1 csn cn wss cn c1 csn cxp cn cn cxp wss cn ssid c1 cn wcel c1 csn
      cn wss 1nn c1 cn snssi ax-mp cn cn c1 csn cn ssxp mp2an cn c1 csn cxp cn
      cn cxp cvv ssdom2g mp2 cn cn c1 csn cxp cn cn cxp endomtr mp2an cn cn cxp
      cn sbth mp2an $.
      $( [2-Oct-2004] $) $( [1-Aug-2004] $)
  $}

  $( The cross product of omega (the set of ordinal natural numbers) with
     itself is equinumerous to omega.  Exercise 1 of [Enderton] p. 133 (which
     proves this with a direct, but longer, proof; ours uses instead the
     Schroeder-Bernstein Theorem ~ sbth in ~ xpnnen ). $)
  xpomen $p |- ( om X. om ) ~~ om $=
    com com cxp cn com cn cn cxp com com cxp cn com com omex omex xpex cn com
    cen wbr cn com cen wbr cn cn cxp com com cxp cen wbr nnenom nnenom cn com
    cn com nnex omex nnex omex xpen mp2an xpnnen entr3i nnenom entri $.
    $( [2-Oct-2004] $) $( [23-Jul-2004] $)

  $( Lemma for ~ znnen . $)
  znnenlem $p |- ( ( ( 0 <_ x /\ -. 0 <_ y ) /\ ( x e. ZZ /\ y e. ZZ ) ) ->
                  ( x = y <-> ( 2 x. x ) = ( ( -u 2 x. y ) + 1 ) ) ) $=
    cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx cv cz wcel vy cv cz wcel wa wa
    vx cv vy cv c2 vx cv cmul co c2 cneg vy cv cmul co c1 caddc co vx cv vy cv
    wne c2 vx cv cmul co c2 cneg vy cv cmul co c1 caddc co wne vx cv vy cv wne
    c2 vx cv cmul co c2 cneg vy cv cmul co c1 caddc co wne wb cc0 vx cv cle wbr
    cc0 vy cv cle wbr wn wa vx cv cz wcel vy cv cz wcel wa wa vx cv vy cv wne
    c2 vx cv cmul co c2 cneg vy cv cmul co c1 caddc co wne pm5.1 vx cv cz wcel
    vy cv cz wcel wa cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx cv vy cv wne
    vx cv cr wcel vy cv cr wcel cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx cv
    vy cv wne wi vx cv cz wcel vy cv cz wcel vx cv cr wcel vy cv cr wcel cc0 vx
    cv cle wbr cc0 vy cv cle wbr wn wa vx cv vy cv wne vy cv cr wcel vx cv cr
    wcel cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx cv vy cv wne vy cv cr
    wcel vx cv cr wcel vy cv vx cv clt wbr vx cv vy cv wne cc0 vx cv cle wbr
    cc0 vy cv cle wbr wn wa vy cv vx cv ltne vy cv cr wcel vx cv cr wcel cc0 vx
    cv cle wbr cc0 vy cv cle wbr wn wa vy cv vx cv clt wbr vy cv cr wcel vx cv
    cr wcel wa cc0 vy cv cle wbr wn cc0 vx cv cle wbr vy cv vx cv clt wbr vy cv
    cr wcel vx cv cr wcel wa cc0 vy cv cle wbr wn cc0 vx cv cle wbr wa vy cv
    cc0 clt wbr cc0 vx cv cle wbr wa vy cv vx cv clt wbr vy cv cr wcel vx cv cr
    wcel wa vy cv cc0 clt wbr cc0 vy cv cle wbr wn cc0 vx cv cle wbr vy cv cr
    wcel vy cv cc0 clt wbr cc0 vy cv cle wbr wn wb vx cv cr wcel vy cv cr wcel
    cc0 cr wcel vy cv cc0 clt wbr cc0 vy cv cle wbr wn wb 0re vy cv cc0 ltnle
    mpan2 adantr anbi1d vy cv cr wcel cc0 cr wcel vx cv cr wcel vy cv cc0 clt
    wbr cc0 vx cv cle wbr wa vy cv vx cv clt wbr wi 0re vy cv cc0 vx cv ltletr
    mp3an2 sylbird ancomsd 3impia syld3an3 3com12 3expia vx cv zre vy cv zre
    syl2an impcom vx cv cz wcel vy cv cz wcel wa c2 vx cv cmul co c2 cneg vy cv
    cmul co c1 caddc co wne cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx cv cz
    wcel vy cv cz wcel wa c2 vx cv cmul co c2 cneg vy cv cmul co c1 caddc co
    wne c2 vx cv cmul co c2 vy cv cneg cmul co c1 caddc co wne vx cv cz wcel vy
    cv cneg cz wcel c2 vx cv cmul co c2 vy cv cneg cmul co c1 caddc co wne vy
    cv cz wcel vx cv vy cv cneg zneo vy cv znegcl sylan2 vx cv cz wcel vy cv cz
    wcel wa c2 cneg vy cv cmul co c1 caddc co c2 vy cv cneg cmul co c1 caddc co
    c2 vx cv cmul co vx cv cz wcel vy cv cz wcel wa c2 cneg vy cv cmul co c2 vy
    cv cneg cmul co c1 caddc vy cv cz wcel c2 cneg vy cv cmul co c2 vy cv cneg
    cmul co wceq vx cv cz wcel c2 cc wcel vy cv cc wcel c2 cneg vy cv cmul co
    c2 vy cv cneg cmul co wceq vy cv cz wcel c2 vy cv mulneg12 2cn vy cv zcn
    sylancr adantl opreq1d neeq2d mpbird adantl sylanc necon4bid $.
    $( [11-Jan-2008] $) $( [31-Jul-2004] $)

  ${
    $d x y $.
    $( The set of integers and the set of natural numbers are equinumerous.
       Exercise 1 of [Gleason] p. 140. $)
    znnen $p |- ZZ ~~ NN $=
      cz cn0 cn cz cn0 cdom wbr cn0 cz cdom wbr cz cn0 cen wbr cz cvv wcel cz
      cn0 cdom wbr zex vx vy cz cn0 cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg
      vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg
      vy cv cmul co c1 caddc co cif cvv vx cv cz wcel cc0 vx cv cle wbr cc0 vx
      cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif cn0
      wcel vx cv cz wcel cc0 vx cv cle wbr wa cc0 vx cv cle wbr c2 vx cv cmul
      co c2 cneg vx cv cmul co c1 caddc co cif cn0 wcel c2 vx cv cmul co cn0
      wcel vx cv cz wcel cc0 vx cv cle wbr wa vx cv cn0 wcel c2 vx cv cmul co
      cn0 wcel vx cv elnn0z c2 cn0 wcel vx cv cn0 wcel c2 vx cv cmul co cn0
      wcel 2nn0 c2 vx cv nn0mulcl mpan sylbir cc0 vx cv cle wbr cc0 vx cv cle
      wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif cn0 wcel c2 vx
      cv cmul co cn0 wcel wb vx cv cz wcel cc0 vx cv cle wbr cc0 vx cv cle wbr
      c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif c2 vx cv cmul co
      cn0 cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co
      iftrue eleq1d adantl mpbird vx cv cz wcel cc0 vx cv cle wbr wn wa cc0 vx
      cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif cn0
      wcel c2 cneg vx cv cmul co c1 caddc co cn0 wcel vx cv cz wcel cc0 vx cv
      cle wbr wn wa c2 cneg vx cv cmul co cz wcel cc0 c2 cneg vx cv cmul co cle
      wbr wa c2 cneg vx cv cmul co cn0 wcel c2 cneg vx cv cmul co c1 caddc co
      cn0 wcel vx cv cz wcel cc0 vx cv cle wbr wn wa c2 cneg vx cv cmul co cz
      wcel cc0 c2 cneg vx cv cmul co cle wbr vx cv cz wcel c2 cneg vx cv cmul
      co cz wcel cc0 vx cv cle wbr wn c2 cneg cz wcel vx cv cz wcel c2 cneg vx
      cv cmul co cz wcel c2 cz wcel c2 cneg cz wcel 2z c2 znegcl ax-mp c2 cneg
      vx cv zmulcl mpan adantr vx cv cz wcel cc0 vx cv cle wbr wn cc0 c2 cneg
      vx cv cmul co cle wbr vx cv cz wcel vx cv cr wcel cc0 vx cv cle wbr wn
      cc0 c2 cneg vx cv cmul co cle wbr wi vx cv zre vx cv cr wcel cc0 vx cv
      cle wbr wn cc0 c2 cneg vx cv cmul co clt wbr cc0 c2 cneg vx cv cmul co
      cle wbr vx cv cr wcel cc0 vx cv cneg clt wbr cc0 c2 vx cv cneg cmul co
      clt wbr cc0 vx cv cle wbr wn cc0 c2 cneg vx cv cmul co clt wbr vx cv cr
      wcel vx cv cneg cr wcel cc0 vx cv cneg clt wbr cc0 c2 vx cv cneg cmul co
      clt wbr wi vx cv renegcl vx cv cneg cr wcel cc0 c2 clt wbr cc0 vx cv cneg
      clt wbr cc0 c2 vx cv cneg cmul co clt wbr 2pos c2 cr wcel vx cv cneg cr
      wcel cc0 c2 clt wbr cc0 vx cv cneg clt wbr wa cc0 c2 vx cv cneg cmul co
      clt wbr wi 2re c2 vx cv cneg axmulgt0 mpan mpani syl vx cv cr wcel vx cv
      cc0 clt wbr cc0 vx cv cle wbr wn cc0 vx cv cneg clt wbr vx cv cr wcel cc0
      cr wcel vx cv cc0 clt wbr cc0 vx cv cle wbr wn wb 0re vx cv cc0 ltnle
      mpan2 vx cv lt0neg1 bitr3d vx cv cr wcel c2 cneg vx cv cmul co c2 vx cv
      cneg cmul co cc0 clt c2 cc wcel vx cv cc wcel c2 cneg vx cv cmul co c2 vx
      cv cneg cmul co wceq vx cv cr wcel c2 vx cv mulneg12 2cn vx cv recn
      sylancr breq2d 3imtr4d cc0 cr wcel c2 cneg vx cv cmul co cr wcel cc0 c2
      cneg vx cv cmul co clt wbr cc0 c2 cneg vx cv cmul co cle wbr wi vx cv cr
      wcel cc0 c2 cneg vx cv cmul co ltle 0re c2 cneg cr wcel vx cv cr wcel c2
      cneg vx cv cmul co cr wcel c2 2re renegcli c2 cneg vx cv remulcl mpan
      sylancr syld syl imp jca c2 cneg vx cv cmul co cn0 wcel c2 cneg vx cv
      cmul co cz wcel cc0 c2 cneg vx cv cmul co cle wbr wa c2 cneg vx cv cmul
      co elnn0z biimpri c2 cneg vx cv cmul co peano2nn0 3syl cc0 vx cv cle wbr
      wn cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co
      cif cn0 wcel c2 cneg vx cv cmul co c1 caddc co cn0 wcel wb vx cv cz wcel
      cc0 vx cv cle wbr wn cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv
      cmul co c1 caddc co cif c2 cneg vx cv cmul co c1 caddc co cn0 cc0 vx cv
      cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co iffalse eleq1d
      adantl mpbird pm2.61dan vx cv cz wcel vy cv cz wcel wa vx cv vy cv wceq
      cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif
      cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc co cif
      wceq cc0 vx cv cle wbr cc0 vy cv cle wbr vx cv cz wcel vy cv cz wcel wa
      vx cv vy cv wceq cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co
      c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul co
      c1 caddc co cif wceq wb wi cc0 vx cv cle wbr cc0 vy cv cle wbr wa vx cv
      cz wcel vy cv cz wcel wa vx cv vy cv wceq cc0 vx cv cle wbr c2 vx cv cmul
      co c2 cneg vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul
      co c2 cneg vy cv cmul co c1 caddc co cif wceq wb cc0 vx cv cle wbr cc0 vy
      cv cle wbr wa vx cv cz wcel vy cv cz wcel wa wa cc0 vx cv cle wbr c2 vx
      cv cmul co c2 cneg vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy
      cv cmul co c2 cneg vy cv cmul co c1 caddc co cif wceq vx cv vy cv wceq
      cc0 vx cv cle wbr cc0 vy cv cle wbr wa cc0 vx cv cle wbr c2 vx cv cmul co
      c2 cneg vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co
      c2 cneg vy cv cmul co c1 caddc co cif wceq c2 vx cv cmul co c2 vy cv cmul
      co wceq vx cv cz wcel vy cv cz wcel wa vx cv vy cv wceq cc0 vx cv cle wbr
      cc0 vy cv cle wbr cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul
      co c1 caddc co cif c2 vx cv cmul co cc0 vy cv cle wbr c2 vy cv cmul co c2
      cneg vy cv cmul co c1 caddc co cif c2 vy cv cmul co cc0 vx cv cle wbr c2
      vx cv cmul co c2 cneg vx cv cmul co c1 caddc co iftrue cc0 vy cv cle wbr
      c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc co iftrue eqeqan12d vx cv
      cc wcel vy cv cc wcel c2 vx cv cmul co c2 vy cv cmul co wceq vx cv vy cv
      wceq wb vx cv cz wcel vy cv cz wcel vx cv cc wcel vy cv cc wcel c2 cc
      wcel c2 vx cv cmul co c2 vy cv cmul co wceq vx cv vy cv wceq wb 2cn vx cv
      vy cv c2 2ne0 mulcant2i mp3an3 vx cv zcn vy cv zcn syl2an sylan9bb bicomd
      ex cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx cv cz wcel vy cv cz wcel
      wa vx cv vy cv wceq cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul
      co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul
      co c1 caddc co cif wceq wb cc0 vx cv cle wbr cc0 vy cv cle wbr wn wa vx
      cv cz wcel vy cv cz wcel wa wa vx cv vy cv wceq c2 vx cv cmul co c2 cneg
      vy cv cmul co c1 caddc co wceq cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg
      vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg
      vy cv cmul co c1 caddc co cif wceq vx vy znnenlem cc0 vx cv cle wbr cc0
      vy cv cle wbr wn wa cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul
      co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul
      co c1 caddc co cif wceq c2 vx cv cmul co c2 cneg vy cv cmul co c1 caddc
      co wceq wb vx cv cz wcel vy cv cz wcel wa cc0 vx cv cle wbr cc0 vy cv cle
      wbr wn cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc
      co cif c2 vx cv cmul co cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv
      cmul co c1 caddc co cif c2 cneg vy cv cmul co c1 caddc co cc0 vx cv cle
      wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co iftrue cc0 vy cv
      cle wbr c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc co iffalse
      eqeqan12d adantr bitr4d ex cc0 vx cv cle wbr wn cc0 vy cv cle wbr wa vx
      cv cz wcel vy cv cz wcel wa vx cv vy cv wceq cc0 vx cv cle wbr c2 vx cv
      cmul co c2 cneg vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv
      cmul co c2 cneg vy cv cmul co c1 caddc co cif wceq wb cc0 vx cv cle wbr
      wn cc0 vy cv cle wbr wa vx cv cz wcel vy cv cz wcel wa wa vx cv vy cv
      wceq c2 cneg vx cv cmul co c1 caddc co c2 vy cv cmul co wceq cc0 vx cv
      cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif cc0 vy cv
      cle wbr c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc co cif wceq cc0
      vy cv cle wbr cc0 vx cv cle wbr wn vx cv cz wcel vy cv cz wcel wa vx cv
      vy cv wceq c2 cneg vx cv cmul co c1 caddc co c2 vy cv cmul co wceq wb cc0
      vy cv cle wbr cc0 vx cv cle wbr wn wa vy cv cz wcel vx cv cz wcel vx cv
      vy cv wceq c2 cneg vx cv cmul co c1 caddc co c2 vy cv cmul co wceq wb cc0
      vy cv cle wbr cc0 vx cv cle wbr wn wa vy cv cz wcel vx cv cz wcel wa wa
      vy cv vx cv wceq c2 vy cv cmul co c2 cneg vx cv cmul co c1 caddc co wceq
      vx cv vy cv wceq c2 cneg vx cv cmul co c1 caddc co c2 vy cv cmul co wceq
      vy vx znnenlem vx vy equcom c2 cneg vx cv cmul co c1 caddc co c2 vy cv
      cmul co eqcom 3bitr4g ancom2s ancom1s cc0 vx cv cle wbr wn cc0 vy cv cle
      wbr wa cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc
      co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc
      co cif wceq c2 cneg vx cv cmul co c1 caddc co c2 vy cv cmul co wceq wb vx
      cv cz wcel vy cv cz wcel wa cc0 vx cv cle wbr wn cc0 vy cv cle wbr cc0 vx
      cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif c2 cneg
      vx cv cmul co c1 caddc co cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy
      cv cmul co c1 caddc co cif c2 vy cv cmul co cc0 vx cv cle wbr c2 vx cv
      cmul co c2 cneg vx cv cmul co c1 caddc co iffalse cc0 vy cv cle wbr c2 vy
      cv cmul co c2 cneg vy cv cmul co c1 caddc co iftrue eqeqan12d adantr
      bitr4d ex cc0 vx cv cle wbr wn cc0 vy cv cle wbr wn wa vx cv cz wcel vy
      cv cz wcel wa vx cv vy cv wceq cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg
      vx cv cmul co c1 caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg
      vy cv cmul co c1 caddc co cif wceq wb vx cv cz wcel vy cv cz wcel wa vx
      cv vy cv wceq c2 cneg vx cv cmul co c1 caddc co c2 cneg vy cv cmul co c1
      caddc co wceq cc0 vx cv cle wbr wn cc0 vy cv cle wbr wn wa cc0 vx cv cle
      wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif cc0 vy cv cle
      wbr c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc co cif wceq vx cv cc
      wcel vy cv cc wcel vx cv vy cv wceq c2 cneg vx cv cmul co c1 caddc co c2
      cneg vy cv cmul co c1 caddc co wceq wb vx cv cz wcel vy cv cz wcel vx cv
      cc wcel vy cv cc wcel wa c2 cneg vx cv cmul co c1 caddc co c2 cneg vy cv
      cmul co c1 caddc co wceq c2 cneg vx cv cmul co c2 cneg vy cv cmul co wceq
      vx cv vy cv wceq c2 cneg vx cv cmul co cc wcel c2 cneg vy cv cmul co cc
      wcel c2 cneg vx cv cmul co c1 caddc co c2 cneg vy cv cmul co c1 caddc co
      wceq c2 cneg vx cv cmul co c2 cneg vy cv cmul co wceq wb vx cv cc wcel vy
      cv cc wcel c2 cneg vx cv cmul co cc wcel c2 cneg vy cv cmul co cc wcel c1
      cc wcel c2 cneg vx cv cmul co c1 caddc co c2 cneg vy cv cmul co c1 caddc
      co wceq c2 cneg vx cv cmul co c2 cneg vy cv cmul co wceq wb ax1cn c2 cneg
      vx cv cmul co c2 cneg vy cv cmul co c1 addcan2 mp3an3 c2 cneg cc wcel vx
      cv cc wcel c2 cneg vx cv cmul co cc wcel c2 2cn negcli c2 cneg vx cv
      mulcl mpan c2 cneg cc wcel vy cv cc wcel c2 cneg vy cv cmul co cc wcel c2
      2cn negcli c2 cneg vy cv mulcl mpan syl2an vx cv cc wcel vy cv cc wcel c2
      cneg cc wcel c2 cneg vx cv cmul co c2 cneg vy cv cmul co wceq vx cv vy cv
      wceq wb c2 2cn negcli vx cv vy cv c2 cneg c2 2cn 2ne0 negne0i mulcant2i
      mp3an3 bitr2d vx cv zcn vy cv zcn syl2an cc0 vx cv cle wbr wn cc0 vy cv
      cle wbr wn wa cc0 vx cv cle wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1
      caddc co cif cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul co c1
      caddc co cif wceq c2 cneg vx cv cmul co c1 caddc co c2 cneg vy cv cmul co
      c1 caddc co wceq cc0 vx cv cle wbr wn cc0 vy cv cle wbr wn cc0 vx cv cle
      wbr c2 vx cv cmul co c2 cneg vx cv cmul co c1 caddc co cif c2 cneg vx cv
      cmul co c1 caddc co cc0 vy cv cle wbr c2 vy cv cmul co c2 cneg vy cv cmul
      co c1 caddc co cif c2 cneg vy cv cmul co c1 caddc co cc0 vx cv cle wbr c2
      vx cv cmul co c2 cneg vx cv cmul co c1 caddc co iffalse cc0 vy cv cle wbr
      c2 vy cv cmul co c2 cneg vy cv cmul co c1 caddc co iffalse eqeqan12d
      bicomd sylan9bbr ex 4cases bicomd dom2 ax-mp cn0 cvv wcel cn0 cz wss cn0
      cz cdom wbr nn0ex nn0ssz cn0 cz cvv ssdomg mp2 cz cn0 sbth mp2an nn0ennn
      entri $.
      $( [19-Oct-2004] $) $( [31-Jul-2004] $)
  $}

  ${
    $d x y z w $.
    $( The rational numbers are countable.  (This unusual proof uses the Axiom
       of Choice via ~ fodom to make it much shorter, but this theorem can also
       be proved without it.  See, for example, Exercise 2 of [Enderton]
       p. 133.) $)
    qnnen $p |- QQ ~~ NN $=
      cq cn cdom wbr cn cq cdom wbr cq cn cen wbr cq cz cn cxp cdom wbr cz cn
      cxp cn cen wbr cq cn cdom wbr cz cn cxp cq vx cv cz wcel vy cv cn wcel wa
      vz cv vx cv vy cv cdiv co wceq wa vx vy vz copab2 wfo cq cz cn cxp cdom
      wbr cz cn cxp cq vx cv cz wcel vy cv cn wcel wa vz cv vx cv vy cv cdiv co
      wceq wa vx vy vz copab2 wfo vx cv cz wcel vy cv cn wcel wa vz cv vx cv vy
      cv cdiv co wceq wa vx vy vz copab2 cz cn cxp wfn vx cv cz wcel vy cv cn
      wcel wa vz cv vx cv vy cv cdiv co wceq wa vx vy vz copab2 crn cq wceq cz
      cn cxp cq vx cv cz wcel vy cv cn wcel wa vz cv vx cv vy cv cdiv co wceq
      wa vx vy vz copab2 df-fo vx vy vz cz cn vx cv vy cv cdiv co vx cv cz wcel
      vy cv cn wcel wa vz cv vx cv vy cv cdiv co wceq wa vx vy vz copab2 vx cv
      vy cv cdiv oprex vx cv cz wcel vy cv cn wcel wa vz cv vx cv vy cv cdiv co
      wceq wa vx vy vz copab2 eqid fnoprab2 vw vx cv cz wcel vy cv cn wcel wa
      vz cv vx cv vy cv cdiv co wceq wa vx vy vz copab2 crn cq vw cv vx cv cz
      wcel vy cv cn wcel wa vz cv vx cv vy cv cdiv co wceq wa vx vy vz copab2
      crn wcel vw cv vx cv vy cv cdiv co wceq vy cn wrex vx cz wrex vw cv cq
      wcel vx vy vz cz cn vx cv vy cv cdiv co vw cv vx cv cz wcel vy cv cn wcel
      wa vz cv vx cv vy cv cdiv co wceq wa vx vy vz copab2 vx cv vy cv cdiv
      oprex vx cv cz wcel vy cv cn wcel wa vz cv vx cv vy cv cdiv co wceq wa vx
      vy vz copab2 eqid elrnoprab vx vy vw cv elq bitr4i eqriv mpbir2an cz cn
      cxp cq vx cv cz wcel vy cv cn wcel wa vz cv vx cv vy cv cdiv co wceq wa
      vx vy vz copab2 cz cn zex nnex xpex fodom ax-mp cz cn cxp cn cn cxp cn cz
      cn cen wbr cn cn cen wbr cz cn cxp cn cn cxp cen wbr znnen cn nnex enref
      cz cn cn cn zex nnex nnex nnex xpen mp2an xpnnen entri cq cz cn cxp cn
      domentr mp2an cn cvv wcel cn cq wss cn cq cdom wbr nnex nnssq cn cq cvv
      ssdomg mp2 cq cn sbth mp2an $.
      $( [20-Oct-2004] $) $( [31-Jul-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Infinite primes theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d m n z w v u t A $.  $d m n v u t G $.
    unbenlem.1 $e |- G =
                     ( rec ( { <. z , w >. | w = ( z + 1 ) } , 1 ) |` om ) $.
    $( Lemma for ~ unben . $)
    unbenlem $p |- ( ( A C_ NN /\ A. m e. NN E. n e. A m < n ) -> A ~~ om ) $=
      cA cG ccnv cA cima cen wbr cG ccnv cA cima com cen wbr cA com cen wbr cA
      cn wss vm cv vn cv clt wbr vn cA wrex vm cn wral wa cA cG ccnv cA cima
      com entr cA cn wss cA cG ccnv cA cima cen wbr vm cv vn cv clt wbr vn cA
      wrex vm cn wral cA cvv wcel cA cG ccnv cA cima cG ccnv cA cres wf1o cA cG
      ccnv cA cima cen wbr cA cn wss cA cG ccnv cA cima cvv cG ccnv cA cres
      f1oeng cA cn nnex ssex cn com cG ccnv wf1 cA cn wss cA cG ccnv cA cima cG
      ccnv cA cres wf1o cn com cG ccnv wf1o cn com cG ccnv wf1 com cn cG wf1o
      cn com cG ccnv wf1o com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG
      wf1o vz vw vt c1 cG 1z unbenlem.1 om2uzf1oi cn c1 vt cv cle wbr vt cz
      crab wceq com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG wf1o wb vt
      nnzrab cn c1 vt cv cle wbr vt cz crab com cG f1oeq3 ax-mp mpbir com cn cG
      f1ocnv ax-mp cn com cG ccnv f1of1 ax-mp cn com cA cG ccnv f1ores mpan
      sylanc adantr cG ccnv cA cima com wss vv cv vu cv wcel vu cG ccnv cA cima
      wrex vv com wral cG ccnv cA cima com cen wbr cA cn wss vm cv vn cv clt
      wbr vn cA wrex vm cn wral wa vv vu cG ccnv cA cima unbnn3 cG ccnv cA cima
      cG ccnv crn com cG ccnv cA imassrn cG cdm cG ccnv crn com cG dfdm4 com cn
      cG com cn cG wf1o com cn cG wf com cn cG wf1o com c1 vt cv cle wbr vt cz
      crab cG wf1o vz vw vt c1 cG 1z unbenlem.1 om2uzf1oi cn c1 vt cv cle wbr
      vt cz crab wceq com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG wf1o wb
      vt nnzrab cn c1 vt cv cle wbr vt cz crab com cG f1oeq3 ax-mp mpbir com cn
      cG f1of ax-mp fdmi eqtr3i sseqtri cA cn wss vm cv vn cv clt wbr vn cA
      wrex vm cn wral wa vv cv vu cv wcel vu cG ccnv cA cima wrex vv com cA cn
      wss vm cv vn cv clt wbr vn cA wrex vm cn wral vv cv com wcel vv cv vu cv
      wcel vu cG ccnv cA cima wrex wi vv cv com wcel cA cn wss vm cv vn cv clt
      wbr vn cA wrex vm cn wral vv cv vu cv wcel vu cG ccnv cA cima wrex vv cv
      com wcel cA cn wss vm cv vn cv clt wbr vn cA wrex vm cn wral vv cv vu cv
      wcel vu cG ccnv cA cima wrex wi vv cv com wcel cA cn wss wa vm cv vn cv
      clt wbr vn cA wrex vm cn wral vv cv cG cfv vn cv clt wbr vn cA wrex vv cv
      vu cv wcel vu cG ccnv cA cima wrex vv cv com wcel vm cv vn cv clt wbr vn
      cA wrex vm cn wral vv cv cG cfv vn cv clt wbr vn cA wrex wi cA cn wss vv
      cv com wcel vv cv cG cfv cn wcel vm cv vn cv clt wbr vn cA wrex vm cn
      wral vv cv cG cfv vn cv clt wbr vn cA wrex wi vv cv com wcel vv cv cG cfv
      c1 vt cv cle wbr vt cz crab cn vz vw vt vv cv c1 cG 1z unbenlem.1
      om2uzuzi vt nnzrab syl6eleqr vm cv vn cv clt wbr vn cA wrex vv cv cG cfv
      vn cv clt wbr vn cA wrex vm vv cv cG cfv cn vm cv vv cv cG cfv wceq vm cv
      vn cv clt wbr vv cv cG cfv vn cv clt wbr vn cA vm cv vv cv cG cfv vn cv
      clt breq1 rexbidv rcla4v syl adantr vv cv com wcel cA cn wss wa vv cv cG
      cfv vn cv clt wbr vv cv vu cv wcel vu cG ccnv cA cima wrex vn cA vv cv
      com wcel cA cn wss vn cv cA wcel vv cv cG cfv vn cv clt wbr vv cv vu cv
      wcel vu cG ccnv cA cima wrex wi wi vv cv cG cfv vn cv clt wbr vv cv com
      wcel cA cn wss vn cv cA wcel vv cv vu cv wcel vu cG ccnv cA cima wrex vv
      cv cG cfv vn cv clt wbr vv cv com wcel cA cn wss vn cv cA wcel vv cv vu
      cv wcel vu cG ccnv cA cima wrex vv cv cG cfv vn cv clt wbr vv cv com wcel
      wa vu cv cG cG ccnv cA cima cres cfv vn cv wceq vu cG ccnv cA cima wrex
      vv cv vu cv wcel vu cG ccnv cA cima wrex cA cn wss vn cv cA wcel wa vv cv
      cG cfv vn cv clt wbr vv cv com wcel wa vu cv cG cG ccnv cA cima cres cfv
      vn cv wceq vv cv vu cv wcel vu cG ccnv cA cima vv cv cG cfv vn cv clt wbr
      vv cv com wcel vu cv cG ccnv cA cima wcel vu cv cG cG ccnv cA cima cres
      cfv vn cv wceq vv cv vu cv wcel wi vv cv cG cfv vn cv clt wbr vv cv com
      wcel vu cv cG ccnv cA cima wcel vu cv cG cG ccnv cA cima cres cfv vn cv
      wceq vv cv vu cv wcel vv cv com wcel vu cv cG ccnv cA cima wcel wa vu cv
      cG cG ccnv cA cima cres cfv vn cv wceq wa vv cv vu cv wcel vv cv cG cfv
      vn cv clt wbr vv cv com wcel vu cv cG ccnv cA cima wcel wa vu cv cG cG
      ccnv cA cima cres cfv vn cv wceq vu cv cG cfv vn cv wceq vv cv vu cv wcel
      vv cv cG cfv vn cv clt wbr wb vu cv cG ccnv cA cima wcel vu cv cG cG ccnv
      cA cima cres cfv vn cv wceq vu cv cG cfv vn cv wceq vv cv com wcel vu cv
      cG ccnv cA cima wcel vu cv cG cG ccnv cA cima cres cfv vn cv wceq vu cv
      cG cfv vn cv wceq vu cv cG ccnv cA cima wcel vu cv cG cG ccnv cA cima
      cres cfv vu cv cG cfv vn cv vu cv cG ccnv cA cima cG fvres eqeq1d biimpa
      adantll vv cv com wcel vu cv cG ccnv cA cima wcel wa vv cv vu cv wcel vv
      cv cG cfv vu cv cG cfv clt wbr vu cv cG cfv vn cv wceq vv cv cG cfv vn cv
      clt wbr vv cv com wcel vu cv com wcel vv cv vu cv wcel vv cv cG cfv vu cv
      cG cfv clt wbr wb vu cv cG ccnv cA cima wcel vz vw vv cv vu cv c1 cG 1z
      unbenlem.1 om2uzlt2i cG ccnv cA cima com vu cv cG ccnv cA cima cG ccnv
      crn com cG ccnv cA imassrn cG cdm cG ccnv crn com cG dfdm4 com cn cG com
      cn cG wf1o com cn cG wf com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG
      wf1o vz vw vt c1 cG 1z unbenlem.1 om2uzf1oi cn c1 vt cv cle wbr vt cz
      crab wceq com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG wf1o wb vt
      nnzrab cn c1 vt cv cle wbr vt cz crab com cG f1oeq3 ax-mp mpbir com cn cG
      f1of ax-mp fdmi eqtr3i sseqtri sseli sylan2 vu cv cG cfv vn cv vv cv cG
      cfv clt breq2 sylan9bb syldan biimparc exp44 imp31 r19.22dva cA cn wss vn
      cv cA wcel vu cv cG cG ccnv cA cima cres cfv vn cv wceq vu cG ccnv cA
      cima wrex cA cn wss cG ccnv cA cima cA cG cG ccnv cA cima cres wf1o vn cv
      cA wcel vu cv cG cG ccnv cA cima cres cfv vn cv wceq vu cG ccnv cA cima
      wrex wb cA cn wss cG ccnv cA cima cA cG ccnv cA cres ccnv wf1o cG ccnv cA
      cima cA cG cG ccnv cA cima cres wf1o cA cn wss cA cG ccnv cA cima cG ccnv
      cA cres wf1o cG ccnv cA cima cA cG ccnv cA cres ccnv wf1o cn com cG ccnv
      wf1 cA cn wss cA cG ccnv cA cima cG ccnv cA cres wf1o cn com cG ccnv wf1o
      cn com cG ccnv wf1 com cn cG wf1o cn com cG ccnv wf1o com cn cG wf1o com
      c1 vt cv cle wbr vt cz crab cG wf1o vz vw vt c1 cG 1z unbenlem.1
      om2uzf1oi cn c1 vt cv cle wbr vt cz crab wceq com cn cG wf1o com c1 vt cv
      cle wbr vt cz crab cG wf1o wb vt nnzrab cn c1 vt cv cle wbr vt cz crab
      com cG f1oeq3 ax-mp mpbir com cn cG f1ocnv ax-mp cn com cG ccnv f1of1
      ax-mp cn com cA cG ccnv f1ores mpan cA cG ccnv cA cima cG ccnv cA cres
      f1ocnv syl cG ccnv cA cres ccnv cG cG ccnv cA cima cres wceq cG ccnv cA
      cima cA cG ccnv cA cres ccnv wf1o cG ccnv cA cima cA cG cG ccnv cA cima
      cres wf1o wb cG wfun cG ccnv cA cres ccnv cG cG ccnv cA cima cres wceq
      com cn cG wf1o cG wfun com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG
      wf1o vz vw vt c1 cG 1z unbenlem.1 om2uzf1oi cn c1 vt cv cle wbr vt cz
      crab wceq com cn cG wf1o com c1 vt cv cle wbr vt cz crab cG wf1o wb vt
      nnzrab cn c1 vt cv cle wbr vt cz crab com cG f1oeq3 ax-mp mpbir com cn cG
      f1ofun ax-mp cA cG funcnvres2 ax-mp cG ccnv cA cima cA cG ccnv cA cres
      ccnv cG cG ccnv cA cima cres f1oeq1 ax-mp sylib cG ccnv cA cima cA cG cG
      ccnv cA cima cres wf1o vn cv cG cG ccnv cA cima cres crn wcel vn cv cA
      wcel vu cv cG cG ccnv cA cima cres cfv vn cv wceq vu cG ccnv cA cima wrex
      cG ccnv cA cima cA cG cG ccnv cA cima cres wf1o cG cG ccnv cA cima cres
      crn cA vn cv cG ccnv cA cima cA cG cG ccnv cA cima cres wf1o cG ccnv cA
      cima cA cG cG ccnv cA cima cres wfo cG cG ccnv cA cima cres crn cA wceq
      cG ccnv cA cima cA cG cG ccnv cA cima cres f1ofo cG ccnv cA cima cA cG cG
      ccnv cA cima cres forn syl eleq2d cG ccnv cA cima cA cG cG ccnv cA cima
      cres wf1o cG cG ccnv cA cima cres cG ccnv cA cima wfn vn cv cG cG ccnv cA
      cima cres crn wcel vu cv cG cG ccnv cA cima cres cfv vn cv wceq vu cG
      ccnv cA cima wrex wb cG ccnv cA cima cA cG cG ccnv cA cima cres f1ofn vu
      cG ccnv cA cima vn cv cG cG ccnv cA cima cres fvelrnb syl bitr3d syl
      biimpa syl5 exp4b com4l imp r19.23adv syld ex com3l imp r19.21aiv sylancr
      sylanc $.
      $( [7-May-2005] $) $( [5-May-2005] $)
  $}

  ${
    $d m n x y A $.
    $( An unbounded set of natural numbers is infinite. $)
    unben $p |- ( ( A C_ NN /\ A. m e. NN E. n e. A m < n ) -> A ~~ NN ) $=
      cA com cen wbr com cn cen wbr cA cn cen wbr cA cn wss vm cv vn cv clt wbr
      vn cA wrex vm cn wral wa cA com cn entr vx vy cA vm vn vy cv vx cv c1
      caddc co wceq vx vy copab c1 crdg com cres vy cv vx cv c1 caddc co wceq
      vx vy copab c1 crdg com cres eqid unbenlem cn com omex nnenom ensymi
      sylancl $.
      $( [8-May-2005] $) $( [5-May-2005] $)
  $}

  ${
    $d j k N $.  $d j M $.  $d j k K $.
    infpnlem.1 $e |- K = ( ( ! ` N ) + 1 ) $.
    $( Lemma for ~ infpn .  The smallest divisor (greater than 1) ` M ` of
       ` N ! + 1 ` is a prime greater than ` N ` . $)
    infpnlem1 $p |- ( ( N e. NN /\ M e. NN ) ->
                        ( ( ( 1 < M /\ ( K / M ) e. NN ) /\
                  A. j e. NN ( ( 1 < j /\ ( K / j ) e. NN ) -> M <_ j ) ) ->
       ( N < M /\ A. j e. NN ( ( M / j ) e. NN -> ( j = 1 \/ j = M ) ) ) ) ) $=
      cN cn wcel cM cn wcel wa c1 cM clt wbr cK cM cdiv co cn wcel wa c1 vj cv
      clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cn wral wa cN
      cM clt wbr cM vj cv cdiv co cn wcel vj cv c1 wceq vj cv cM wceq wo wi vj
      cn wral cN cn wcel cM cn wcel wa c1 cM clt wbr cK cM cdiv co cn wcel wa
      cN cM clt wbr c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle
      wbr wi vj cn wral cN cn wcel cM cn wcel wa c1 cM clt wbr cK cM cdiv co cn
      wcel cN cM clt wbr cN cn wcel cM cn wcel wa c1 cM clt wbr wa cN cM clt
      wbr cK cM cdiv co cn wcel cN cn wcel cM cn wcel wa c1 cM clt wbr wa cN cM
      clt wbr wn cM cN cle wbr cK cM cdiv co cn wcel wn cN cn wcel cM cn wcel
      wa cM cN cle wbr cN cM clt wbr wn wb c1 cM clt wbr cM cn wcel cN cn wcel
      cM cN cle wbr cN cM clt wbr wn wb cM cr wcel cN cr wcel cM cN cle wbr cN
      cM clt wbr wn wb cM cn wcel cN cn wcel cM cN lenlt cM nnre cN nnre syl2an
      ancoms adantr cN cn wcel cM cn wcel wa c1 cM clt wbr cM cN cle wbr cK cM
      cdiv co cn wcel wn wi cN cn wcel cM cn wcel wa c1 cM clt wbr cM cN cle
      wbr cK cM cdiv co cn wcel wn cN cn0 wcel cM cn wcel c1 cM clt wbr cM cN
      cle wbr wa cK cM cdiv co cn wcel wn cN cn wcel cN cn0 wcel cM cn wcel wa
      c1 cM clt wbr cM cN cle wbr wa wa cN cfa cfv c1 caddc co cM cdiv co cz
      wcel cK cM cdiv co cn wcel cN cM facndiv cK cM cdiv co cn wcel cK cM cdiv
      co cz cN cfa cfv c1 caddc co cM cdiv co cK cM cdiv co nnz cK cN cfa cfv
      c1 caddc co cM cdiv infpnlem.1 opreq1i syl5eqelr nsyl cN nnnn0 sylanl1
      exp32 imp sylbird con4d expimpd adantrd cN cn wcel cM cn wcel wa c1 cM
      clt wbr cK cM cdiv co cn wcel wa c1 vj cv clt wbr cK vj cv cdiv co cn
      wcel wa cM vj cv cle wbr wi vj cn wral wa c1 vj cv clt wbr vj cv cM cle
      wbr cM vj cv cdiv co cn wcel w3a vj cv cM wceq wi vj cn wral cM vj cv
      cdiv co cn wcel vj cv c1 wceq vj cv cM wceq wo wi vj cn wral cN cn wcel
      cM cn wcel wa c1 cM clt wbr cK cM cdiv co cn wcel wa c1 vj cv clt wbr cK
      vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cn wral c1 vj cv clt wbr
      vj cv cM cle wbr cM vj cv cdiv co cn wcel w3a vj cv cM wceq wi vj cn wral
      cN cn wcel cM cn wcel wa cK cM cdiv co cn wcel c1 vj cv clt wbr cK vj cv
      cdiv co cn wcel wa cM vj cv cle wbr wi vj cn wral c1 vj cv clt wbr vj cv
      cM cle wbr cM vj cv cdiv co cn wcel w3a vj cv cM wceq wi vj cn wral wi c1
      cM clt wbr cN cn wcel cM cn wcel wa cK cM cdiv co cn wcel c1 vj cv clt
      wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cn wral c1 vj cv
      clt wbr vj cv cM cle wbr cM vj cv cdiv co cn wcel w3a vj cv cM wceq wi vj
      cn wral wi cN cn wcel cM cn wcel wa cK cM cdiv co cn wcel wa c1 vj cv clt
      wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi c1 vj cv clt wbr vj
      cv cM cle wbr cM vj cv cdiv co cn wcel w3a vj cv cM wceq wi vj cn c1 vj
      cv clt wbr vj cv cM cle wbr cM vj cv cdiv co cn wcel w3a cN cn wcel cM cn
      wcel wa cK cM cdiv co cn wcel wa vj cv cn wcel wa c1 vj cv clt wbr cK vj
      cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cv cM wceq c1 vj cv clt wbr
      vj cv cM cle wbr cM vj cv cdiv co cn wcel cN cn wcel cM cn wcel wa cK cM
      cdiv co cn wcel wa vj cv cn wcel wa c1 vj cv clt wbr cK vj cv cdiv co cn
      wcel wa cM vj cv cle wbr wi vj cv cM wceq wi wi cN cn wcel cM cn wcel wa
      cK cM cdiv co cn wcel wa vj cv cn wcel wa vj cv cM cle wbr cM vj cv cdiv
      co cn wcel c1 vj cv clt wbr c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa
      cM vj cv cle wbr wi vj cv cM wceq wi cN cn wcel cM cn wcel wa cK cM cdiv
      co cn wcel vj cv cn wcel vj cv cM cle wbr cM vj cv cdiv co cn wcel c1 vj
      cv clt wbr c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr
      wi vj cv cM wceq wi wi wi wi cN cn wcel cM cn wcel wa vj cv cM cle wbr vj
      cv cn wcel cK cM cdiv co cn wcel cM vj cv cdiv co cn wcel c1 vj cv clt
      wbr c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj
      cv cM wceq wi wi wi cN cn wcel cM cn wcel wa vj cv cM cle wbr vj cv cn
      wcel cK cM cdiv co cn wcel cM vj cv cdiv co cn wcel c1 vj cv clt wbr c1
      vj cv clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cv cM
      wceq wi wi wi wi cN cn wcel cM cn wcel wa vj cv cM cle wbr vj cv cn wcel
      wa wa c1 vj cv clt wbr cM vj cv cdiv co cn wcel cK cM cdiv co cn wcel c1
      vj cv clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cv cM
      wceq wi cN cn wcel cM cn wcel wa vj cv cM cle wbr vj cv cn wcel wa wa c1
      vj cv clt wbr cM vj cv cdiv co cn wcel cK cM cdiv co cn wcel c1 vj cv clt
      wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi vj cv cM wceq wi cN
      cn wcel cM cn wcel wa vj cv cM cle wbr vj cv cn wcel wa wa c1 vj cv clt
      wbr cK vj cv cdiv co cn wcel c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa
      cM vj cv cle wbr wi vj cv cM wceq wi cM vj cv cdiv co cn wcel cK cM cdiv
      co cn wcel wa cN cn wcel cM cn wcel wa vj cv cM cle wbr vj cv cn wcel wa
      wa c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa cM vj cv cle wbr wi c1 vj
      cv clt wbr cK vj cv cdiv co cn wcel wa vj cv cM wceq cN cn wcel cM cn
      wcel wa vj cv cM cle wbr vj cv cn wcel wa wa cM vj cv cle wbr vj cv cM
      wceq c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa cM cn wcel vj cv cM cle
      wbr vj cv cn wcel wa cM vj cv cle wbr vj cv cM wceq wi cN cn wcel cM cn
      wcel vj cv cM cle wbr vj cv cn wcel cM vj cv cle wbr vj cv cM wceq wi vj
      cv cn wcel cM cn wcel vj cv cM cle wbr cM vj cv cle wbr vj cv cM wceq wi
      vj cv cn wcel cM cn wcel vj cv cM cle wbr cM vj cv cle wbr vj cv cM wceq
      vj cv cn wcel cM cn wcel wa vj cv cM wceq vj cv cM cle wbr cM vj cv cle
      wbr wa vj cv cr wcel cM cr wcel vj cv cM wceq vj cv cM cle wbr cM vj cv
      cle wbr wa wb vj cv cn wcel cM cn wcel vj cv cM letri3 vj cv nnre cM nnre
      syl2an biimprd exp4b com3l imp32 adantll imim2d com23 cN cn wcel cM cn
      wcel wa vj cv cn wcel cM vj cv cdiv co cn wcel cK cM cdiv co cn wcel wa
      cK vj cv cdiv co cn wcel wi vj cv cM cle wbr cK cc wcel cM cn wcel vj cv
      cn wcel cM vj cv cdiv co cn wcel cK cM cdiv co cn wcel wa cK vj cv cdiv
      co cn wcel wi cN cn wcel cK cc wcel cM cn wcel vj cv cn wcel cM vj cv
      cdiv co cn wcel cK cM cdiv co cn wcel wa cK vj cv cdiv co cn wcel wi vj
      cv cn wcel cM cn wcel cK cc wcel cM vj cv cdiv co cn wcel cK cM cdiv co
      cn wcel wa cK vj cv cdiv co cn wcel wi vj cv cn wcel cM cn wcel cK cc
      wcel w3a cM vj cv cdiv co cn wcel cK cM cdiv co cn wcel wa cK vj cv cdiv
      co cn wcel vj cv cM cK nndivtr ex 3com13 3expa cN cn wcel cK cn wcel cK
      cc wcel cN cn wcel cN cfa cfv c1 caddc co cn cK cN cn wcel cN cfa cfv cn
      wcel cN cfa cfv c1 caddc co cn wcel cN cn wcel cN cn0 wcel cN cfa cfv cn
      wcel cN nnnn0 cN faccl syl cN cfa cfv peano2nn syl infpnlem.1 syl5eqel cK
      nncn syl sylanl1 adantrl sylan2d exp4d com24 exp32 com24 imp31 com14 3imp
      com3l r19.20dva ex adantld imp3a cM cn wcel cM vj cv cdiv co cn wcel vj
      cv c1 wceq vj cv cM wceq wo wi vj cn wral c1 vj cv clt wbr vj cv cM cle
      wbr cM vj cv cdiv co cn wcel w3a vj cv cM wceq wi vj cn wral wb cN cn
      wcel vj cM prime adantl sylibrd jcad $.
      $( [8-May-2005] $) $( [5-May-2005] $)

    $( Lemma for ~ infpn .  For any natural number ` N ` , there exists a
       prime number ` j ` greater than ` N ` . $)
    infpnlem2 $p |- ( N e. NN -> E. j e. NN ( N < j /\
                    A. k e. NN ( ( j / k ) e. NN -> ( k = 1 \/ k = j ) ) ) ) $=
      cN cn wcel c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa c1 vk cv clt wbr
      cK vk cv cdiv co cn wcel wa vj cv vk cv cle wbr wi vk cn wral wa vj cn
      wrex cN vj cv clt wbr vj cv vk cv cdiv co cn wcel vk cv c1 wceq vk cv vj
      cv wceq wo wi vk cn wral wa vj cn wrex cN cn wcel c1 vj cv clt wbr cK vj
      cv cdiv co cn wcel wa vj cn wrex c1 vj cv clt wbr cK vj cv cdiv co cn
      wcel wa c1 vk cv clt wbr cK vk cv cdiv co cn wcel wa vj cv vk cv cle wbr
      wi vk cn wral wa vj cn wrex cK cn wcel c1 cK clt wbr cK cK cdiv co cn
      wcel wa c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa vj cn wrex cN cn
      wcel c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa c1 cK clt wbr cK cK
      cdiv co cn wcel wa vj cK cn vj cv cK wceq c1 vj cv clt wbr c1 cK clt wbr
      cK vj cv cdiv co cn wcel cK cK cdiv co cn wcel vj cv cK c1 clt breq2 vj
      cv cK wceq cK vj cv cdiv co cK cK cdiv co cn vj cv cK cK cdiv opreq2
      eleq1d anbi12d rcla4ev cN cn wcel cN cfa cfv c1 caddc co cn cK cN cn wcel
      cN cfa cfv cn wcel cN cfa cfv c1 caddc co cn wcel cN cn wcel cN cn0 wcel
      cN cfa cfv cn wcel cN nnnn0 cN faccl syl cN cfa cfv peano2nn syl
      infpnlem.1 syl5eqel cN cn wcel c1 cK clt wbr cK cK cdiv co cn wcel cN cn
      wcel c1 cN cfa cfv c1 caddc co cK clt cN cn wcel c1 cN cfa cfv cle wbr c1
      cN cfa cfv c1 caddc co clt wbr cN cn wcel cN cfa cfv cn wcel c1 cN cfa
      cfv cle wbr cN cn wcel cN cn0 wcel cN cfa cfv cn wcel cN nnnn0 cN faccl
      syl cN cfa cfv nnge1 syl c1 cn wcel cN cfa cfv cn wcel c1 cN cfa cfv cle
      wbr c1 cN cfa cfv c1 caddc co clt wbr wb cN cn wcel c1 cN cfa cfv
      nnleltp1 1nn cN cn wcel cN cn0 wcel cN cfa cfv cn wcel cN nnnn0 cN faccl
      syl sylancr mpbid infpnlem.1 syl6breqr cN cn wcel cK cK cdiv co c1 cn cN
      cn wcel cK cc wcel cK cc0 wne wa cK cK cdiv co c1 wceq cN cn wcel cK cn
      wcel cK cc wcel cK cc0 wne wa cN cn wcel cN cfa cfv c1 caddc co cn cK cN
      cn wcel cN cfa cfv cn wcel cN cfa cfv c1 caddc co cn wcel cN cn wcel cN
      cn0 wcel cN cfa cfv cn wcel cN nnnn0 cN faccl syl cN cfa cfv peano2nn syl
      infpnlem.1 syl5eqel cK cn wcel cK cc wcel cK cc0 wne cK nncn cK nnne0 jca
      syl cK divid syl 1nn syl6eqel jca sylanc c1 vj cv clt wbr cK vj cv cdiv
      co cn wcel wa c1 vk cv clt wbr cK vk cv cdiv co cn wcel wa vj vk vj cv vk
      cv wceq c1 vj cv clt wbr c1 vk cv clt wbr cK vj cv cdiv co cn wcel cK vk
      cv cdiv co cn wcel vj cv vk cv c1 clt breq2 vj cv vk cv wceq cK vj cv
      cdiv co cK vk cv cdiv co cn vj cv vk cv cK cdiv opreq2 eleq1d anbi12d
      nnwos syl cN cn wcel c1 vj cv clt wbr cK vj cv cdiv co cn wcel wa c1 vk
      cv clt wbr cK vk cv cdiv co cn wcel wa vj cv vk cv cle wbr wi vk cn wral
      wa cN vj cv clt wbr vj cv vk cv cdiv co cn wcel vk cv c1 wceq vk cv vj cv
      wceq wo wi vk cn wral wa vj cn vk cK vj cv cN infpnlem.1 infpnlem1
      r19.22dva mpd $.
      $( [8-May-2005] $) $( [5-May-2005] $)
  $}

  ${
    $d j k N $.
    $( There exist infinitely many prime numbers:  for any natural number
       ` N ` , there exists a prime number ` j ` greater than ` N ` .
       (See ~ infpn2 for the equinumerosity version.) $)
    infpn $p |- ( N e. NN -> E. j e. NN ( N < j /\
                    A. k e. NN ( ( j / k ) e. NN -> ( k = 1 \/ k = j ) ) ) ) $=
      vj vk cN cfa cfv c1 caddc co cN cN cfa cfv c1 caddc co eqid infpnlem2 $.
      $( [1-Jun-2006] $) $( [1-Jun-2006] $)
  $}

  ${
    $d j k n m A $.  $d j k S $.
    infpn2.1 $e |- S = { n e. NN | ( 1 < n /\
                A. m e. NN ( ( n / m ) e. NN -> ( m = 1 \/ m = n ) ) ) } $.
    $( There exist infinitely many prime numbers:  the set of all primes ` S `
       is unbounded by ~ infpn , so by ~ unben it is infinite. $)
    infpn2 $p |- S ~~ NN $=
      cS cn wss vj cv vk cv clt wbr vk cS wrex vj cn wral cS cn cen wbr cS c1
      vn cv clt wbr vn cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vn cv wceq
      wo wi vm cn wral wa vn cn crab cn infpn2.1 c1 vn cv clt wbr vn cv vm cv
      cdiv co cn wcel vm cv c1 wceq vm cv vn cv wceq wo wi vm cn wral wa vn cn
      ssrab2 eqsstri vj cv vk cv clt wbr vk cS wrex vj cn vj cv cn wcel vj cv
      vk cv clt wbr c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq
      vm cv vk cv wceq wo wi vm cn wral wa wa vk cn wrex vj cv vk cv clt wbr vk
      cS wrex vj cv cn wcel vj cv vk cv clt wbr vk cv vm cv cdiv co cn wcel vm
      cv c1 wceq vm cv vk cv wceq wo wi vm cn wral wa vk cn wrex vj cv vk cv
      clt wbr c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv
      vk cv wceq wo wi vm cn wral wa wa vk cn wrex vk vm vj cv infpn vj cv cn
      wcel vj cv vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv
      vk cv wceq wo wi vm cn wral wa vj cv vk cv clt wbr c1 vk cv clt wbr vk cv
      vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk cv wceq wo wi vm cn wral wa
      wa vk cn vj cv cn wcel vk cv cn wcel wa vj cv vk cv clt wbr vk cv vm cv
      cdiv co cn wcel vm cv c1 wceq vm cv vk cv wceq wo wi vm cn wral wa vj cv
      vk cv clt wbr c1 vk cv clt wbr wa vk cv vm cv cdiv co cn wcel vm cv c1
      wceq vm cv vk cv wceq wo wi vm cn wral wa vj cv vk cv clt wbr c1 vk cv
      clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk cv wceq wo wi
      vm cn wral wa wa vj cv cn wcel vk cv cn wcel wa vj cv vk cv clt wbr vj cv
      vk cv clt wbr c1 vk cv clt wbr wa vk cv vm cv cdiv co cn wcel vm cv c1
      wceq vm cv vk cv wceq wo wi vm cn wral vj cv cn wcel vk cv cn wcel wa vj
      cv vk cv clt wbr c1 vk cv clt wbr vj cv cn wcel vk cv cn wcel wa c1 vj cv
      cle wbr vj cv vk cv clt wbr c1 vk cv clt wbr vj cv cn wcel c1 vj cv cle
      wbr vk cv cn wcel vj cv nnge1 adantr vj cv cr wcel vk cv cr wcel c1 vj cv
      cle wbr vj cv vk cv clt wbr wa c1 vk cv clt wbr wi vj cv cn wcel vk cv cn
      wcel c1 cr wcel vj cv cr wcel vk cv cr wcel c1 vj cv cle wbr vj cv vk cv
      clt wbr wa c1 vk cv clt wbr wi 1re c1 vj cv vk cv lelttr mp3an1 vj cv
      nnre vk cv nnre syl2an mpand ancld anim1d vj cv vk cv clt wbr c1 vk cv
      clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk cv wceq wo wi
      vm cn wral anass syl6ib r19.22dva mpd vj cv vk cv clt wbr vj cv vk cv clt
      wbr c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk
      cv wceq wo wi vm cn wral wa wa vk cS cn vk cv cS wcel vj cv vk cv clt wbr
      wa vk cv cn wcel c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1
      wceq vm cv vk cv wceq wo wi vm cn wral wa wa vj cv vk cv clt wbr wa vk cv
      cn wcel c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv
      vk cv wceq wo wi vm cn wral wa vj cv vk cv clt wbr wa wa vk cv cn wcel vj
      cv vk cv clt wbr c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1
      wceq vm cv vk cv wceq wo wi vm cn wral wa wa wa vk cv cS wcel vk cv cn
      wcel c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk
      cv wceq wo wi vm cn wral wa wa vj cv vk cv clt wbr c1 vn cv clt wbr vn cv
      vm cv cdiv co cn wcel vm cv c1 wceq vm cv vn cv wceq wo wi vm cn wral wa
      c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk cv
      wceq wo wi vm cn wral wa vn vk cv cn cS vn cv vk cv wceq c1 vn cv clt wbr
      c1 vk cv clt wbr vn cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vn cv
      wceq wo wi vm cn wral vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk
      cv wceq wo wi vm cn wral vn cv vk cv c1 clt breq2 vn cv vk cv wceq vn cv
      vm cv cdiv co cn wcel vm cv c1 wceq vm cv vn cv wceq wo wi vk cv vm cv
      cdiv co cn wcel vm cv c1 wceq vm cv vk cv wceq wo wi vm cn vn cv vk cv
      wceq vn cv vm cv cdiv co cn wcel vk cv vm cv cdiv co cn wcel vm cv c1
      wceq vm cv vn cv wceq wo vm cv c1 wceq vm cv vk cv wceq wo vn cv vk cv
      wceq vn cv vm cv cdiv co vk cv vm cv cdiv co cn vn cv vk cv vm cv cdiv
      opreq1 eleq1d vn cv vk cv wceq vm cv vn cv wceq vm cv vk cv wceq vm cv c1
      wceq vn cv vk cv vm cv eqeq2 orbi2d imbi12d ralbidv anbi12d infpn2.1
      elrab2 anbi1i vk cv cn wcel c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel
      vm cv c1 wceq vm cv vk cv wceq wo wi vm cn wral wa vj cv vk cv clt wbr
      anass c1 vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk
      cv wceq wo wi vm cn wral wa vj cv vk cv clt wbr wa vj cv vk cv clt wbr c1
      vk cv clt wbr vk cv vm cv cdiv co cn wcel vm cv c1 wceq vm cv vk cv wceq
      wo wi vm cn wral wa wa vk cv cn wcel c1 vk cv clt wbr vk cv vm cv cdiv co
      cn wcel vm cv c1 wceq vm cv vk cv wceq wo wi vm cn wral wa vj cv vk cv
      clt wbr ancom anbi2i 3bitri rexbii2 sylibr rgen cS vj vk unben mp2an $.
      $( [8-May-2005] $) $( [5-May-2005] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The reals are uncountable
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    ruclem1.a $e |- A e. RR $.
    ruclem1.b $e |- B e. RR $.
    $( Lemma for ~ ruc (the reals are uncountable).  This is an arithmetic fact
       that will be used to compute ordering relations. $)
    ruclem1 $p |- ( A < B <-> A < ( ( ( 2 x. A ) + B ) / 3 ) ) $=
      cA cB clt wbr c3 cA cmul co c2 cA cmul co cB caddc co clt wbr c3 cA cmul
      co c3 cdiv co c2 cA cmul co cB caddc co c3 cdiv co clt wbr cA c2 cA cmul
      co cB caddc co c3 cdiv co clt wbr cA cB clt wbr c2 cA cmul co cA caddc co
      c2 cA cmul co cB caddc co clt wbr c3 cA cmul co c2 cA cmul co cB caddc co
      clt wbr cA cB c2 cA cmul co ruclem1.a ruclem1.b c2 cA 2re ruclem1.a
      remulcli ltadd2i c2 cA cmul co cA caddc co c3 cA cmul co c2 cA cmul co cB
      caddc co clt c3 cA cmul co c2 c1 caddc co cA cmul co c2 cA cmul co c1 cA
      cmul co caddc co c2 cA cmul co cA caddc co c3 c2 c1 caddc co cA cmul df-3
      opreq1i c2 c1 cA 2cn ax1cn cA ruclem1.a recni adddiri c1 cA cmul co cA c2
      cA cmul co caddc cA cA ruclem1.a recni mulid2i opreq2i 3eqtrri breq1i
      bitri c3 cA cmul co c2 cA cmul co cB caddc co c3 c3 cA 3re ruclem1.a
      remulcli c2 cA cmul co cB c2 cA 2re ruclem1.a remulcli ruclem1.b readdcli
      3re 3pos ltdiv1ii c3 cA cmul co c3 cdiv co cA c2 cA cmul co cB caddc co
      c3 cdiv co clt cA c3 cA ruclem1.a recni c3 3re recni c3 3re 3pos gt0ne0ii
      divcan3i breq1i 3bitri $.
      $( [18-Oct-2004] $) $( [14-Oct-2004] $)

    $( Lemma for ~ ruc .  Arithmetic fact that will be used to compute
       ordering relations. $)
    ruclem2 $p |- ( A < B <->
                  ( ( ( 2 x. A ) + B ) / 3 ) < ( ( A + ( 2 x. B ) ) / 3 ) ) $=
      cA cB clt wbr cA cA cB caddc co caddc co cB cA cB caddc co caddc co clt
      wbr c2 cA cmul co cB caddc co cA c2 cB cmul co caddc co clt wbr c2 cA
      cmul co cB caddc co c3 cdiv co cA c2 cB cmul co caddc co c3 cdiv co clt
      wbr cA cB cA cB caddc co ruclem1.a ruclem1.b cA cB ruclem1.a ruclem1.b
      readdcli ltadd1i c2 cA cmul co cB caddc co cA cA cB caddc co caddc co cA
      c2 cB cmul co caddc co cB cA cB caddc co caddc co clt c2 cA cmul co cB
      caddc co cA cA caddc co cB caddc co cA cA cB caddc co caddc co c2 cA cmul
      co cA cA caddc co cB caddc cA cA ruclem1.a recni 2timesi opreq1i cA cA cB
      cA ruclem1.a recni cA ruclem1.a recni cB ruclem1.b recni addassi eqtri cA
      c2 cB cmul co caddc co cA cB cB caddc co caddc co cB cA cB caddc co caddc
      co c2 cB cmul co cB cB caddc co cA caddc cB cB ruclem1.b recni 2timesi
      opreq2i cA cB cB cA ruclem1.a recni cB ruclem1.b recni cB ruclem1.b recni
      add12i eqtri breq12i c2 cA cmul co cB caddc co cA c2 cB cmul co caddc co
      c3 c2 cA cmul co cB c2 cA 2re ruclem1.a remulcli ruclem1.b readdcli cA c2
      cB cmul co ruclem1.a c2 cB 2re ruclem1.b remulcli readdcli 3re 3pos
      ltdiv1ii 3bitr2i $.
      $( [18-Oct-2004] $) $( [14-Oct-2004] $)

    $( Lemma for ~ ruc .  Arithmetic fact that will be used to compute
       ordering relations. $)
    ruclem3 $p |- ( A < B <-> ( ( A + ( 2 x. B ) ) / 3 ) < B ) $=
      cA cB clt wbr cA c2 cB cmul co caddc co c3 cB cmul co clt wbr cA c2 cB
      cmul co caddc co c3 cdiv co c3 cB cmul co c3 cdiv co clt wbr cA c2 cB
      cmul co caddc co c3 cdiv co cB clt wbr cA cB clt wbr cA c2 cB cmul co
      caddc co cB c2 cB cmul co caddc co clt wbr cA c2 cB cmul co caddc co c3
      cB cmul co clt wbr cA cB c2 cB cmul co ruclem1.a ruclem1.b c2 cB 2re
      ruclem1.b remulcli ltadd1i cB c2 cB cmul co caddc co c3 cB cmul co cA c2
      cB cmul co caddc co clt c3 cB cmul co c1 c2 caddc co cB cmul co c1 cB
      cmul co c2 cB cmul co caddc co cB c2 cB cmul co caddc co c3 c1 c2 caddc
      co cB cmul c3 c2 c1 caddc co c1 c2 caddc co df-3 c2 c1 2cn ax1cn addcomi
      eqtri opreq1i c1 c2 cB ax1cn 2cn cB ruclem1.b recni adddiri c1 cB cmul co
      cB c2 cB cmul co caddc cB cB ruclem1.b recni mulid2i opreq1i 3eqtrri
      breq2i bitri cA c2 cB cmul co caddc co c3 cB cmul co c3 cA c2 cB cmul co
      ruclem1.a c2 cB 2re ruclem1.b remulcli readdcli c3 cB 3re ruclem1.b
      remulcli 3re 3pos ltdiv1ii c3 cB cmul co c3 cdiv co cB cA c2 cB cmul co
      caddc co c3 cdiv co clt cB c3 cB ruclem1.b recni c3 3re recni c3 3re 3pos
      gt0ne0ii divcan3i breq2i 3bitri $.
      $( [18-Oct-2004] $) $( [14-Oct-2004] $)
  $}

  $( Lemma for ~ ruc .  Helper lemma showing a tedious equality used several
     times. $)
  ruclem4 $p |- ( ( A = C /\ B = D ) ->
                if ( ( ( 1st ` A ) < B /\ B < ( 2nd ` A ) ) ,
                 <. ( ( ( 2 x. B ) + ( 2nd ` A ) ) / 3 ) ,
                    ( ( B + ( 2 x. ( 2nd ` A ) ) ) / 3 ) >. ,
                 <. ( ( ( 2 x. ( 1st ` A ) ) + ( 2nd ` A ) ) / 3 ) ,
                    ( ( ( 1st ` A ) + ( 2 x. ( 2nd ` A ) ) ) / 3 ) >. ) =
                if ( ( ( 1st ` C ) < D /\ D < ( 2nd ` C ) ) ,
                 <. ( ( ( 2 x. D ) + ( 2nd ` C ) ) / 3 ) ,
                    ( ( D + ( 2 x. ( 2nd ` C ) ) ) / 3 ) >. ,
                 <. ( ( ( 2 x. ( 1st ` C ) ) + ( 2nd ` C ) ) / 3 ) ,
                    ( ( ( 1st ` C ) + ( 2 x. ( 2nd ` C ) ) ) / 3 ) >. ) ) $=
    cA cC wceq cB cD wceq cA c1st cfv cB clt wbr cB cA c2nd cfv clt wbr wa c2
    cB cmul co cA c2nd cfv caddc co c3 cdiv co cB c2 cA c2nd cfv cmul co caddc
    co c3 cdiv co cop c2 cA c1st cfv cmul co cA c2nd cfv caddc co c3 cdiv co cA
    c1st cfv c2 cA c2nd cfv cmul co caddc co c3 cdiv co cop cif cC c1st cfv cB
    clt wbr cB cC c2nd cfv clt wbr wa c2 cB cmul co cC c2nd cfv caddc co c3
    cdiv co cB c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop c2 cC c1st cfv
    cmul co cC c2nd cfv caddc co c3 cdiv co cC c1st cfv c2 cC c2nd cfv cmul co
    caddc co c3 cdiv co cop cif cC c1st cfv cD clt wbr cD cC c2nd cfv clt wbr
    wa c2 cD cmul co cC c2nd cfv caddc co c3 cdiv co cD c2 cC c2nd cfv cmul co
    caddc co c3 cdiv co cop c2 cC c1st cfv cmul co cC c2nd cfv caddc co c3 cdiv
    co cC c1st cfv c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop cif cA cC
    wceq cA c1st cfv cB clt wbr cB cA c2nd cfv clt wbr wa c2 cB cmul co cA c2nd
    cfv caddc co c3 cdiv co cB c2 cA c2nd cfv cmul co caddc co c3 cdiv co cop
    c2 cA c1st cfv cmul co cA c2nd cfv caddc co c3 cdiv co cA c1st cfv c2 cA
    c2nd cfv cmul co caddc co c3 cdiv co cop cif cC c1st cfv cB clt wbr cB cC
    c2nd cfv clt wbr wa c2 cB cmul co cA c2nd cfv caddc co c3 cdiv co cB c2 cA
    c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA c1st cfv cmul co cA c2nd cfv
    caddc co c3 cdiv co cA c1st cfv c2 cA c2nd cfv cmul co caddc co c3 cdiv co
    cop cif cC c1st cfv cB clt wbr cB cC c2nd cfv clt wbr wa c2 cB cmul co cC
    c2nd cfv caddc co c3 cdiv co cB c2 cC c2nd cfv cmul co caddc co c3 cdiv co
    cop c2 cC c1st cfv cmul co cC c2nd cfv caddc co c3 cdiv co cC c1st cfv c2
    cC c2nd cfv cmul co caddc co c3 cdiv co cop cif cA cC wceq cA c1st cfv cB
    clt wbr cB cA c2nd cfv clt wbr wa cC c1st cfv cB clt wbr cB cC c2nd cfv clt
    wbr wa c2 cB cmul co cA c2nd cfv caddc co c3 cdiv co cB c2 cA c2nd cfv cmul
    co caddc co c3 cdiv co cop c2 cA c1st cfv cmul co cA c2nd cfv caddc co c3
    cdiv co cA c1st cfv c2 cA c2nd cfv cmul co caddc co c3 cdiv co cop cA cC
    wceq cA c1st cfv cB clt wbr cC c1st cfv cB clt wbr cB cA c2nd cfv clt wbr
    cB cC c2nd cfv clt wbr cA cC wceq cA c1st cfv cC c1st cfv cB clt cA cC c1st
    fveq2 breq1d cA cC wceq cA c2nd cfv cC c2nd cfv cB clt cA cC c2nd fveq2
    breq2d anbi12d ifbid c2 cB cmul co cA c2nd cfv caddc co c3 cdiv co cB c2 cA
    c2nd cfv cmul co caddc co c3 cdiv co cop c2 cB cmul co cC c2nd cfv caddc co
    c3 cdiv co cB c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop wceq c2 cA
    c1st cfv cmul co cA c2nd cfv caddc co c3 cdiv co cA c1st cfv c2 cA c2nd cfv
    cmul co caddc co c3 cdiv co cop c2 cC c1st cfv cmul co cC c2nd cfv caddc co
    c3 cdiv co cC c1st cfv c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop wceq
    cC c1st cfv cB clt wbr cB cC c2nd cfv clt wbr wa c2 cB cmul co cA c2nd cfv
    caddc co c3 cdiv co cB c2 cA c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA
    c1st cfv cmul co cA c2nd cfv caddc co c3 cdiv co cA c1st cfv c2 cA c2nd cfv
    cmul co caddc co c3 cdiv co cop cif cC c1st cfv cB clt wbr cB cC c2nd cfv
    clt wbr wa c2 cB cmul co cC c2nd cfv caddc co c3 cdiv co cB c2 cC c2nd cfv
    cmul co caddc co c3 cdiv co cop c2 cC c1st cfv cmul co cC c2nd cfv caddc co
    c3 cdiv co cC c1st cfv c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop cif
    wceq cA cC wceq cC c1st cfv cB clt wbr cB cC c2nd cfv clt wbr wa c2 cB cmul
    co cA c2nd cfv caddc co c3 cdiv co cB c2 cA c2nd cfv cmul co caddc co c3
    cdiv co cop c2 cB cmul co cC c2nd cfv caddc co c3 cdiv co cB c2 cC c2nd cfv
    cmul co caddc co c3 cdiv co cop c2 cA c1st cfv cmul co cA c2nd cfv caddc co
    c3 cdiv co cA c1st cfv c2 cA c2nd cfv cmul co caddc co c3 cdiv co cop c2 cC
    c1st cfv cmul co cC c2nd cfv caddc co c3 cdiv co cC c1st cfv c2 cC c2nd cfv
    cmul co caddc co c3 cdiv co cop ifeq12 cA cC wceq c2 cB cmul co cA c2nd cfv
    caddc co c3 cdiv co c2 cB cmul co cC c2nd cfv caddc co c3 cdiv co cB c2 cA
    c2nd cfv cmul co caddc co c3 cdiv co cB c2 cC c2nd cfv cmul co caddc co c3
    cdiv co cA cC wceq c2 cB cmul co cA c2nd cfv caddc co c2 cB cmul co cC c2nd
    cfv caddc co c3 cdiv cA cC wceq cA c2nd cfv cC c2nd cfv c2 cB cmul co caddc
    cA cC c2nd fveq2 opreq2d opreq1d cA cC wceq cB c2 cA c2nd cfv cmul co caddc
    co cB c2 cC c2nd cfv cmul co caddc co c3 cdiv cA cC wceq c2 cA c2nd cfv
    cmul co c2 cC c2nd cfv cmul co cB caddc cA cC wceq cA c2nd cfv cC c2nd cfv
    c2 cmul cA cC c2nd fveq2 opreq2d opreq2d opreq1d opeq12d cA cC wceq c2 cA
    c1st cfv cmul co cA c2nd cfv caddc co c3 cdiv co c2 cC c1st cfv cmul co cC
    c2nd cfv caddc co c3 cdiv co cA c1st cfv c2 cA c2nd cfv cmul co caddc co c3
    cdiv co cC c1st cfv c2 cC c2nd cfv cmul co caddc co c3 cdiv co cA cC wceq
    c2 cA c1st cfv cmul co cA c2nd cfv caddc co c2 cC c1st cfv cmul co cC c2nd
    cfv caddc co c3 cdiv cA cC wceq c2 cA c1st cfv cmul co c2 cC c1st cfv cmul
    co cA c2nd cfv cC c2nd cfv caddc cA cC wceq cA c1st cfv cC c1st cfv c2 cmul
    cA cC c1st fveq2 opreq2d cA cC c2nd fveq2 opreq12d opreq1d cA cC wceq cA
    c1st cfv c2 cA c2nd cfv cmul co caddc co cC c1st cfv c2 cC c2nd cfv cmul co
    caddc co c3 cdiv cA cC wceq cA c1st cfv cC c1st cfv c2 cA c2nd cfv cmul co
    c2 cC c2nd cfv cmul co caddc cA cC c1st fveq2 cA cC wceq cA c2nd cfv cC
    c2nd cfv c2 cmul cA cC c2nd fveq2 opreq2d opreq12d opreq1d opeq12d sylanc
    eqtrd cB cD wceq cC c1st cfv cB clt wbr cB cC c2nd cfv clt wbr wa c2 cB
    cmul co cC c2nd cfv caddc co c3 cdiv co cB c2 cC c2nd cfv cmul co caddc co
    c3 cdiv co cop c2 cC c1st cfv cmul co cC c2nd cfv caddc co c3 cdiv co cC
    c1st cfv c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop cif cC c1st cfv cD
    clt wbr cD cC c2nd cfv clt wbr wa c2 cB cmul co cC c2nd cfv caddc co c3
    cdiv co cB c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop c2 cC c1st cfv
    cmul co cC c2nd cfv caddc co c3 cdiv co cC c1st cfv c2 cC c2nd cfv cmul co
    caddc co c3 cdiv co cop cif cC c1st cfv cD clt wbr cD cC c2nd cfv clt wbr
    wa c2 cD cmul co cC c2nd cfv caddc co c3 cdiv co cD c2 cC c2nd cfv cmul co
    caddc co c3 cdiv co cop c2 cC c1st cfv cmul co cC c2nd cfv caddc co c3 cdiv
    co cC c1st cfv c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop cif cB cD
    wceq cC c1st cfv cB clt wbr cB cC c2nd cfv clt wbr wa cC c1st cfv cD clt
    wbr cD cC c2nd cfv clt wbr wa c2 cB cmul co cC c2nd cfv caddc co c3 cdiv co
    cB c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop c2 cC c1st cfv cmul co cC
    c2nd cfv caddc co c3 cdiv co cC c1st cfv c2 cC c2nd cfv cmul co caddc co c3
    cdiv co cop cB cD wceq cC c1st cfv cB clt wbr cC c1st cfv cD clt wbr cB cC
    c2nd cfv clt wbr cD cC c2nd cfv clt wbr cB cD cC c1st cfv clt breq2 cB cD
    cC c2nd cfv clt breq1 anbi12d ifbid cB cD wceq cC c1st cfv cD clt wbr cD cC
    c2nd cfv clt wbr wa c2 cB cmul co cC c2nd cfv caddc co c3 cdiv co cB c2 cC
    c2nd cfv cmul co caddc co c3 cdiv co cop c2 cD cmul co cC c2nd cfv caddc co
    c3 cdiv co cD c2 cC c2nd cfv cmul co caddc co c3 cdiv co cop c2 cC c1st cfv
    cmul co cC c2nd cfv caddc co c3 cdiv co cC c1st cfv c2 cC c2nd cfv cmul co
    caddc co c3 cdiv co cop cB cD wceq c2 cB cmul co cC c2nd cfv caddc co c3
    cdiv co c2 cD cmul co cC c2nd cfv caddc co c3 cdiv co cB c2 cC c2nd cfv
    cmul co caddc co c3 cdiv co cD c2 cC c2nd cfv cmul co caddc co c3 cdiv co
    cB cD wceq c2 cB cmul co cC c2nd cfv caddc co c2 cD cmul co cC c2nd cfv
    caddc co c3 cdiv cB cD wceq c2 cB cmul co c2 cD cmul co cC c2nd cfv caddc
    cB cD c2 cmul opreq2 opreq1d opreq1d cB cD wceq cB c2 cC c2nd cfv cmul co
    caddc co cD c2 cC c2nd cfv cmul co caddc co c3 cdiv cB cD c2 cC c2nd cfv
    cmul co caddc opreq1 opreq1d opeq12d ifeq1d eqtrd sylan9eq $.
    $( [18-Oct-2004] $) $( [9-Oct-2004] $)

  ${
    ruclem5.0 $e |- F : NN --> RR $.
    ruclem5.1 $e |- C = ( { <. 1 , <. ( ( F ` 1 ) + 1 ) ,
                     ( ( F ` 1 ) + 2 ) >. >. } u. ( F |` ( NN \ { 1 } ) ) ) $.
    $( Lemma for ~ ruc .  Helper lemma showing the input function used for our
       recursive sequence builder (defined in ~ ruclem13 ) is a set. $)
    ruclem5 $p |- C e. _V $=
      cC c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn cF cn c1
      csn cdif cres cun cvv ruclem5.1 c1 c1 cF cfv c1 caddc co c1 cF cfv c2
      caddc co cop cop csn cF cn c1 csn cdif cres c1 c1 cF cfv c1 caddc co c1
      cF cfv c2 caddc co cop cop snex cF cvv wcel cF cn c1 csn cdif cres cvv
      wcel cn cr cF wf cn cvv wcel cF cvv wcel ruclem5.0 nnex cn cr cvv cF fex
      mp2an cF cn c1 csn cdif cvv resexg ax-mp unex eqeltri $.
      $( [18-Oct-2004] $) $( [7-Oct-2004] $)

    $( Lemma for ~ ruc .  Helper lemma showing the input function used for our
       recursive sequence builder (defined in ~ ruclem13 ) matches our input
       mapping ` F ` for successor values. $)
    ruclem6 $p |- ( C |` ( NN \ { 1 } ) ) = ( F |` ( NN \ { 1 } ) ) $=
      cC cn c1 csn cdif cres c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop
      cop csn cF cn c1 csn cdif cres cun cn c1 csn cdif cres c1 c1 cF cfv c1
      caddc co c1 cF cfv c2 caddc co cop cop csn cn c1 csn cdif cres cF cn c1
      csn cdif cres cn c1 csn cdif cres cun cF cn c1 csn cdif cres cC c1 c1 cF
      cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn cF cn c1 csn cdif cres
      cun wceq cC cn c1 csn cdif cres c1 c1 cF cfv c1 caddc co c1 cF cfv c2
      caddc co cop cop csn cF cn c1 csn cdif cres cun cn c1 csn cdif cres wceq
      ruclem5.1 cC c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn
      cF cn c1 csn cdif cres cun cn c1 csn cdif reseq1 ax-mp c1 c1 cF cfv c1
      caddc co c1 cF cfv c2 caddc co cop cop csn cF cn c1 csn cdif cres cn c1
      csn cdif resundir c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop
      csn cn c1 csn cdif cres cF cn c1 csn cdif cres cn c1 csn cdif cres cun c0
      cF cn c1 csn cdif cres cun cF cn c1 csn cdif cres c0 cun cF cn c1 csn
      cdif cres c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn cn
      c1 csn cdif cres c0 cF cn c1 csn cdif cres cn c1 csn cdif cres cF cn c1
      csn cdif cres c1 csn cn c1 csn cdif cin c0 wceq c1 c1 cF cfv c1 caddc co
      c1 cF cfv c2 caddc co cop cop csn cn c1 csn cdif cres c0 wceq c1 csn cn
      difdisj c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn c1 csn
      wfn c1 csn cn c1 csn cdif cin c0 wceq c1 c1 cF cfv c1 caddc co c1 cF cfv
      c2 caddc co cop cop csn cn c1 csn cdif cres c0 wceq wb c1 csn c1 cF cfv
      c1 caddc co c1 cF cfv c2 caddc co cop csn c1 c1 cF cfv c1 caddc co c1 cF
      cfv c2 caddc co cop cop csn wf1o c1 c1 cF cfv c1 caddc co c1 cF cfv c2
      caddc co cop cop csn c1 csn wfn c1 c1 cF cfv c1 caddc co c1 cF cfv c2
      caddc co cop c1 cn 1nn elisseti c1 cF cfv c1 caddc co c1 cF cfv c2 caddc
      co opex f1osn c1 csn c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop csn
      c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn f1ofn ax-mp c1
      csn cn c1 csn cdif c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop
      csn fnresdisj ax-mp mpbi cF cn c1 csn cdif residm uneq12i c0 cF cn c1 csn
      cdif cres uncom cF cn c1 csn cdif cres un0 3eqtri 3eqtri $.
      $( [18-Oct-2004] $) $( [9-Oct-2004] $)

    $( Lemma for ~ ruc .  Helper lemma showing the initial value of the input
       function for our recursive sequence builder (defined in ~ ruclem13 ). $)
    ruclem7 $p |- ( C ` 1 ) =
                     <. ( ( F ` 1 ) + 1 ) , ( ( F ` 1 ) + 2 ) >. $=
      c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cn cF cC c1 cn 1nn
      elisseti c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co opex ruclem5.1
      fvsnun1 $.
      $( [18-Oct-2004] $) $( [7-Oct-2004] $)

    ${
      ruclem8.a $e |- A e. NN $.
      $( Lemma for ~ ruc .  Helper lemma showing the successor value of the
         input function for our recursive sequence builder (defined in
         ~ ruclem13 ). $)
      ruclem8 $p |- ( C ` ( A + 1 ) ) = ( F ` ( A + 1 ) ) $=
        cA c1 caddc co cn c1 csn cdif wcel cA c1 caddc co cC cfv cA c1 caddc co
        cF cfv wceq cA c1 caddc co cn c1 csn cdif wcel cA c1 caddc co cn wcel
        cA c1 caddc co c1 wne cA c1 caddc co cn c1 eldifsn cA cn wcel cA c1
        caddc co cn wcel ruclem8.a cA peano2nn ax-mp c1 cA c1 caddc co clt wbr
        cA c1 caddc co c1 wne cc0 cA clt wbr c1 cA c1 caddc co clt wbr cA
        ruclem8.a nngt0i cc0 cA clt wbr cc0 c1 caddc co cA c1 caddc co clt wbr
        c1 cA c1 caddc co clt wbr cc0 cA c1 0re cA ruclem8.a nnrei 1re ltadd1i
        cc0 c1 caddc co c1 cA c1 caddc co clt c1 ax1cn addid2i breq1i bitri
        mpbi cA c1 caddc co cn wcel c1 cA c1 caddc co clt wbr cA c1 caddc co c1
        wne wb cA cn wcel cA c1 caddc co cn wcel ruclem8.a cA peano2nn ax-mp cA
        c1 caddc co nngt1ne1 ax-mp mpbi mpbir2an c1 c1 cF cfv c1 caddc co c1 cF
        cfv c2 caddc co cop cn cA c1 caddc co cF cC c1 cn 1nn elisseti c1 cF
        cfv c1 caddc co c1 cF cfv c2 caddc co opex ruclem5.1 fvsnun2 ax-mp $.
        $( [18-Oct-2004] $) $( [14-Oct-2004] $)
    $}
  $}

  ${
    $d x y z $.  $d z A $.
    ruclem9.2 $e |- D = { <. <. x , y >. , z >. |
             ( ( x e. ( RR X. RR ) /\ y e. RR ) /\ z = A ) } $.
    $( Lemma for ~ ruc .  Helper lemma showing the operation used for our
       recursive sequence builder (defined in ~ ruclem13 ) is a set. $)
    ruclem9 $p |- D e. _V $=
      vx vy vz cr cr cxp cr cA cD cr cr reex reex xpex reex ruclem9.2 oprabex2
      $.
      $( [18-Oct-2004] $) $( [7-Oct-2004] $)
  $}

  ${
    $d x y $.
    ruclem10.a $e |- A e. NN $.
    ruclem.d $e |- D e. _V $.
    ruclem.c $e |- C e. _V $.
    ruclem10.3 $e |- G = ( 1st o. ( D seq1 C ) ) $.
    $( Lemma for ~ ruc .  The values of our recursive sequence builder are
       pairs of real numbers.  The values of our constructed function ` G ` are
       the first of these pairs. $)
    ruclem10 $p |- ( 1st ` ( ( D seq1 C ) ` A ) ) = ( G ` A ) $=
      cA cG cfv cA c1st cD cC cseq1 co ccom cfv cA cD cC cseq1 co cfv c1st cfv
      cA cG c1st cD cC cseq1 co ccom ruclem10.3 fveq1i c1st wfun cD cC cseq1 co
      cn wfn cA cn wcel cA c1st cD cC cseq1 co ccom cfv cA cD cC cseq1 co cfv
      c1st cfv wceq cvv cvv c1st wfo c1st wfun fo1st cvv cvv c1st fofun ax-mp
      cD cC ruclem.d ruclem.c seq1fn ruclem10.a cn cA c1st cD cC cseq1 co fvco2
      mp3an eqtr2i $.
      $( [18-Oct-2004] $) $( [14-Oct-2004] $)
  $}

  ${
    $d x y $.
    ruclem11.a $e |- A e. NN $.
    ruclem11.d $e |- D e. _V $.
    ruclem11.c $e |- C e. _V $.
    ruclem11.4 $e |- H = ( 2nd o. ( D seq1 C ) ) $.
    $( Lemma for ~ ruc .  The values of our recursive sequence builder are
       pairs of real numbers.  The values of our constructed function ` H ` are
       the second of these pairs. $)
    ruclem11 $p |- ( 2nd ` ( ( D seq1 C ) ` A ) ) = ( H ` A ) $=
      cA cH cfv cA c2nd cD cC cseq1 co ccom cfv cA cD cC cseq1 co cfv c2nd cfv
      cA cH c2nd cD cC cseq1 co ccom ruclem11.4 fveq1i c2nd wfun cD cC cseq1 co
      cn wfn cA cn wcel cA c2nd cD cC cseq1 co ccom cfv cA cD cC cseq1 co cfv
      c2nd cfv wceq cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv c2nd fofun ax-mp
      cD cC ruclem11.d ruclem11.c seq1fn ruclem11.a cn cA c2nd cD cC cseq1 co
      fvco2 mp3an eqtr2i $.
      $( [18-Oct-2004] $) $( [14-Oct-2004] $)
  $}

  ${
    $d x y z w v u $.
    ruclem12.2 $e |- D = { <. <. x , y >. , z >. |
             ( ( x e. ( RR X. RR ) /\ y e. RR ) /\
             z = if ( ( ( 1st ` x ) < y /\ y < ( 2nd ` x ) ) ,
                 <. ( ( ( 2 x. y ) + ( 2nd ` x ) ) / 3 ) ,
                    ( ( y + ( 2 x. ( 2nd ` x ) ) ) / 3 ) >. ,
                 <. ( ( ( 2 x. ( 1st ` x ) ) + ( 2nd ` x ) ) / 3 ) ,
                    ( ( ( 1st ` x ) + ( 2 x. ( 2nd ` x ) ) ) / 3 ) >. ) ) } $.
    $( Lemma for ~ ruc .  A helper lemma that changes bound variables. $)
    ruclem12 $p |- D = { <. <. w , v >. , u >. |
             ( ( w e. ( RR X. RR ) /\ v e. RR ) /\
             u = if ( ( ( 1st ` w ) < v /\ v < ( 2nd ` w ) ) ,
                 <. ( ( ( 2 x. v ) + ( 2nd ` w ) ) / 3 ) ,
                    ( ( v + ( 2 x. ( 2nd ` w ) ) ) / 3 ) >. ,
                 <. ( ( ( 2 x. ( 1st ` w ) ) + ( 2nd ` w ) ) / 3 ) ,
                    ( ( ( 1st ` w ) + ( 2 x. ( 2nd ` w ) ) ) / 3 ) >. ) ) } $=
      cD vx cv cr cr cxp wcel vy cv cr wcel wa vz cv vx cv c1st cfv vy cv clt
      wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc
      co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2
      vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv
      c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vx vy vz
      copab2 vw cv cr cr cxp wcel vv cv cr wcel wa vz cv vw cv c1st cfv vv cv
      clt wbr vv cv vw cv c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd cfv
      caddc co c3 cdiv co vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co
      cop c2 vw cv c1st cfv cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv
      c1st cfv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vw
      vv vz copab2 vw cv cr cr cxp wcel vv cv cr wcel wa vu cv vw cv c1st cfv
      vv cv clt wbr vv cv vw cv c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd
      cfv caddc co c3 cdiv co vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vw cv c1st cfv cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv
      c1st cfv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vw
      vv vu copab2 ruclem12.2 vx cv cr cr cxp wcel vy cv cr wcel wa vz cv vx cv
      c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc
      co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop
      cif wceq wa vw cv cr cr cxp wcel vv cv cr wcel wa vz cv vw cv c1st cfv vv
      cv clt wbr vv cv vw cv c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd
      cfv caddc co c3 cdiv co vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vw cv c1st cfv cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv
      c1st cfv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vx
      vy vz vw vv vx cv vw cv wceq vy cv vv cv wceq wa vx cv cr cr cxp wcel vy
      cv cr wcel wa vw cv cr cr cxp wcel vv cv cr wcel wa vz cv vx cv c1st cfv
      vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
      c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq vz cv
      vw cv c1st cfv vv cv clt wbr vv cv vw cv c2nd cfv clt wbr wa c2 vv cv
      cmul co vw cv c2nd cfv caddc co c3 cdiv co vv cv c2 vw cv c2nd cfv cmul
      co caddc co c3 cdiv co cop c2 vw cv c1st cfv cmul co vw cv c2nd cfv caddc
      co c3 cdiv co vw cv c1st cfv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv
      co cop cif wceq vx cv vw cv wceq vx cv cr cr cxp wcel vw cv cr cr cxp
      wcel vy cv vv cv wceq vy cv cr wcel vv cv cr wcel vx cv vw cv cr cr cxp
      eleq1 vy cv vv cv cr eleq1 bi2anan9 vx cv vw cv wceq vy cv vv cv wceq wa
      vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv
      cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc
      co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop cif vw cv c1st cfv vv cv clt wbr vv cv vw cv c2nd cfv clt wbr wa
      c2 vv cv cmul co vw cv c2nd cfv caddc co c3 cdiv co vv cv c2 vw cv c2nd
      cfv cmul co caddc co c3 cdiv co cop c2 vw cv c1st cfv cmul co vw cv c2nd
      cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw cv c2nd cfv cmul co caddc co
      c3 cdiv co cop cif vz cv vx cv vy cv vw cv vv cv ruclem4 eqeq2d anbi12d
      cbvoprab12v vw cv cr cr cxp wcel vv cv cr wcel wa vz cv vw cv c1st cfv vv
      cv clt wbr vv cv vw cv c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd
      cfv caddc co c3 cdiv co vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vw cv c1st cfv cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv
      c1st cfv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vw
      cv cr cr cxp wcel vv cv cr wcel wa vu cv vw cv c1st cfv vv cv clt wbr vv
      cv vw cv c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd cfv caddc co c3
      cdiv co vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vw cv
      c1st cfv cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw
      cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vw vv vz vu vz cv
      vu cv wceq vz cv vw cv c1st cfv vv cv clt wbr vv cv vw cv c2nd cfv clt
      wbr wa c2 vv cv cmul co vw cv c2nd cfv caddc co c3 cdiv co vv cv c2 vw cv
      c2nd cfv cmul co caddc co c3 cdiv co cop c2 vw cv c1st cfv cmul co vw cv
      c2nd cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw cv c2nd cfv cmul co
      caddc co c3 cdiv co cop cif wceq vu cv vw cv c1st cfv vv cv clt wbr vv cv
      vw cv c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd cfv caddc co c3
      cdiv co vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vw cv
      c1st cfv cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw
      cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq vw cv cr cr cxp wcel
      vv cv cr wcel wa vz cv vu cv vw cv c1st cfv vv cv clt wbr vv cv vw cv
      c2nd cfv clt wbr wa c2 vv cv cmul co vw cv c2nd cfv caddc co c3 cdiv co
      vv cv c2 vw cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vw cv c1st cfv
      cmul co vw cv c2nd cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw cv c2nd
      cfv cmul co caddc co c3 cdiv co cop cif eqeq1 anbi2d cbvoprab3v 3eqtri $.
      $( [18-Oct-2004] $) $( [8-Oct-2004] $)
  $}

  ${
    $d x y z w v u $.  $d w v u D $.
    ruclem13.0 $e |- F : NN --> RR $.
    ruclem13.1 $e |- C = ( { <. 1 , <. ( ( F ` 1 ) + 1 ) ,
                     ( ( F ` 1 ) + 2 ) >. >. } u. ( F |` ( NN \ { 1 } ) ) ) $.
    ruclem13.2 $e |- D = { <. <. x , y >. , z >. |
             ( ( x e. ( RR X. RR ) /\ y e. RR ) /\
             z = if ( ( ( 1st ` x ) < y /\ y < ( 2nd ` x ) ) ,
                 <. ( ( ( 2 x. y ) + ( 2nd ` x ) ) / 3 ) ,
                    ( ( y + ( 2 x. ( 2nd ` x ) ) ) / 3 ) >. ,
                 <. ( ( ( 2 x. ( 1st ` x ) ) + ( 2nd ` x ) ) / 3 ) ,
                    ( ( ( 1st ` x ) + ( 2 x. ( 2nd ` x ) ) ) / 3 ) >. ) ) } $.
    $( Lemma for ~ ruc .  A helper lemma showing the recursive sequence builder
       used for our construction maps natural numbers to pairs of reals. $)
    ruclem13 $p |- ( D seq1 C ) : NN --> ( RR X. RR ) $=
      cn cr cr cxp cD cC cseq1 co wf cD cC cseq1 co cn wfn cD cC cseq1 co crn
      cr cr cxp wss cn cr cr cxp cD cC cseq1 co df-f cD cC vx vy vz vx cv c1st
      cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv
      c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3
      cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co
      vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD
      ruclem13.2 ruclem9 cC cF ruclem13.0 ruclem13.1 ruclem5 seq1fn c1 cC cfv
      cr cr cxp wcel cn c1 csn cdif cr cC cn c1 csn cdif cres wf cr cr cxp cr
      cxp cr cr cxp cD wf cD cC cseq1 co crn cr cr cxp wss c1 cC cfv c1 cF cfv
      c1 caddc co c1 cF cfv c2 caddc co cop cr cr cxp cC cF ruclem13.0
      ruclem13.1 ruclem7 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cr cr
      cxp wcel c1 cF cfv c1 caddc co cr wcel c1 cF cfv c2 caddc co cr wcel c1
      cF cfv c1 caddc co c1 cF cfv c2 caddc co cr cr c1 cF cfv c2 caddc oprex
      opelxp c1 cF cfv c1 cn cr cF wf c1 cn wcel c1 cF cfv cr wcel ruclem13.0
      1nn cn cr c1 cF ffvelrn mp2an 1re readdcli c1 cF cfv c2 cn cr cF wf c1 cn
      wcel c1 cF cfv cr wcel ruclem13.0 1nn cn cr c1 cF ffvelrn mp2an 2re
      readdcli mpbir2an eqeltri cn c1 csn cdif cr cC cn c1 csn cdif cres wf cn
      c1 csn cdif cr cF cn c1 csn cdif cres wf cn cr cF wf cn c1 csn cdif cn
      wss cn c1 csn cdif cr cF cn c1 csn cdif cres wf ruclem13.0 cn c1 csn
      difss cn cr cn c1 csn cdif cF fssres mp2an cC cn c1 csn cdif cres cF cn
      c1 csn cdif cres wceq cn c1 csn cdif cr cC cn c1 csn cdif cres wf cn c1
      csn cdif cr cF cn c1 csn cdif cres wf wb cC cF ruclem13.0 ruclem13.1
      ruclem6 cn c1 csn cdif cr cC cn c1 csn cdif cres cF cn c1 csn cdif cres
      feq1 ax-mp mpbir vx vy vz cr cr cxp cr vx cv c1st cfv vy cv clt wbr vy cv
      vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv
      c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx
      cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cr cr cxp cD ruclem13.2
      vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st cfv cr wcel vx cv
      c2nd cfv cr wcel wa wa vy cv cr wcel vx cv c1st cfv vy cv clt wbr vy cv
      vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv
      c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx
      cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cr cr cxp wcel vx cv cr
      cr cxp wcel vx cv c1st cfv cr wcel vx cv c2nd cfv cr wcel wa vy cv cr
      wcel vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy
      cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv
      cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv
      caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3
      cdiv co cop cif cr cr cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop
      wceq vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa vx cv
      c1st cfv cr wcel vx cv c2nd cfv cr wcel wa vy cv cr wcel wa vx cv c1st
      cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv
      c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3
      cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co
      vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cr
      cr cxp wcel wi vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr
      wa vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv
      cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc
      co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop cif cr cr cxp wcel c2 vy cv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cr cr cxp
      wcel vx cv c1st cfv cr wcel vx cv c2nd cfv cr wcel wa vy cv cr wcel wa vx
      cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa vx cv c1st cfv
      vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
      c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif c2 vy cv
      cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop cr cr cxp vx cv c1st cfv vy cv clt wbr vy cv
      vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv
      c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx
      cv c2nd cfv cmul co caddc co c3 cdiv co cop iftrue eleq1d vx cv c2nd cfv
      cr wcel vy cv cr wcel c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co
      vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cr cr cxp wcel vx
      cv c1st cfv cr wcel vy cv cr wcel vx cv c2nd cfv cr wcel c2 vy cv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc
      co c3 cdiv co cop cr cr cxp wcel c2 vy cv cmul co vx cv c2nd cfv caddc co
      c3 cdiv co cr wcel vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cr
      wcel c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv
      c2nd cfv cmul co caddc co c3 cdiv co cop cr cr cxp wcel vy cv cr wcel vx
      cv c2nd cfv cr wcel wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv
      co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cr cr opelxpi vy
      cv cr wcel vx cv c2nd cfv cr wcel wa c2 vy cv cmul co vx cv c2nd cfv
      caddc co cr wcel c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co cr
      wcel c2 vy cv cmul co cr wcel vx cv c2nd cfv cr wcel c2 vy cv cmul co vx
      cv c2nd cfv caddc co cr wcel vy cv cr wcel c2 vy cv cmul co vx cv c2nd
      cfv readdcl c2 cr wcel vy cv cr wcel c2 vy cv cmul co cr wcel 2re c2 vy
      cv remulcl mpan sylan c2 vy cv cmul co vx cv c2nd cfv caddc co cr wcel c3
      cr wcel c3 cc0 wne c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co cr
      wcel 3re c3 3re 3pos gt0ne0ii c2 vy cv cmul co vx cv c2nd cfv caddc co c3
      redivcl mp3an23 syl vy cv cr wcel vx cv c2nd cfv cr wcel wa vy cv c2 vx
      cv c2nd cfv cmul co caddc co cr wcel vy cv c2 vx cv c2nd cfv cmul co
      caddc co c3 cdiv co cr wcel vy cv cr wcel c2 vx cv c2nd cfv cmul co cr
      wcel vy cv c2 vx cv c2nd cfv cmul co caddc co cr wcel vx cv c2nd cfv cr
      wcel vy cv c2 vx cv c2nd cfv cmul co readdcl c2 cr wcel vx cv c2nd cfv cr
      wcel c2 vx cv c2nd cfv cmul co cr wcel 2re c2 vx cv c2nd cfv remulcl mpan
      sylan2 vy cv c2 vx cv c2nd cfv cmul co caddc co cr wcel c3 cr wcel c3 cc0
      wne vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cr wcel 3re c3
      3re 3pos gt0ne0ii vy cv c2 vx cv c2nd cfv cmul co caddc co c3 redivcl
      mp3an23 syl sylanc ancoms adantll syl5bir vx cv c1st cfv vy cv clt wbr vy
      cv vx cv c2nd cfv clt wbr wa wn vx cv c1st cfv cr wcel vx cv c2nd cfv cr
      wcel wa vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2
      vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv
      cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv
      caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3
      cdiv co cop cif cr cr cxp wcel vy cv cr wcel vx cv c1st cfv vy cv clt wbr
      vy cv vx cv c2nd cfv clt wbr wa wn vx cv c1st cfv vy cv clt wbr vy cv vx
      cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv
      co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st
      cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv
      c2nd cfv cmul co caddc co c3 cdiv co cop cif cr cr cxp wcel c2 vx cv c1st
      cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv
      c2nd cfv cmul co caddc co c3 cdiv co cop cr cr cxp wcel vx cv c1st cfv cr
      wcel vx cv c2nd cfv cr wcel wa vx cv c1st cfv vy cv clt wbr vy cv vx cv
      c2nd cfv clt wbr wa wn vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv
      clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2
      vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop cif c2 vx cv c1st cfv cmul co vx cv c2nd cfv
      caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3
      cdiv co cop cr cr cxp vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv
      clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2
      vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop iffalse eleq1d c2 vx cv c1st cfv cmul co vx cv
      c2nd cfv caddc co c3 cdiv co cr wcel vx cv c1st cfv c2 vx cv c2nd cfv
      cmul co caddc co c3 cdiv co cr wcel c2 vx cv c1st cfv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co
      c3 cdiv co cop cr cr cxp wcel vx cv c1st cfv cr wcel vx cv c2nd cfv cr
      wcel wa c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx
      cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cr cr opelxpi
      vx cv c1st cfv cr wcel vx cv c2nd cfv cr wcel wa c2 vx cv c1st cfv cmul
      co vx cv c2nd cfv caddc co cr wcel c2 vx cv c1st cfv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co cr wcel c2 vx cv c1st cfv cmul co cr wcel vx cv
      c2nd cfv cr wcel c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co cr
      wcel vx cv c1st cfv cr wcel c2 vx cv c1st cfv cmul co vx cv c2nd cfv
      readdcl c2 cr wcel vx cv c1st cfv cr wcel c2 vx cv c1st cfv cmul co cr
      wcel 2re c2 vx cv c1st cfv remulcl mpan sylan c2 vx cv c1st cfv cmul co
      vx cv c2nd cfv caddc co cr wcel c3 cr wcel c3 cc0 wne c2 vx cv c1st cfv
      cmul co vx cv c2nd cfv caddc co c3 cdiv co cr wcel 3re c3 3re 3pos
      gt0ne0ii c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 redivcl
      mp3an23 syl vx cv c1st cfv cr wcel vx cv c2nd cfv cr wcel wa vx cv c1st
      cfv c2 vx cv c2nd cfv cmul co caddc co cr wcel vx cv c1st cfv c2 vx cv
      c2nd cfv cmul co caddc co c3 cdiv co cr wcel vx cv c1st cfv cr wcel c2 vx
      cv c2nd cfv cmul co cr wcel vx cv c1st cfv c2 vx cv c2nd cfv cmul co
      caddc co cr wcel vx cv c2nd cfv cr wcel vx cv c1st cfv c2 vx cv c2nd cfv
      cmul co readdcl c2 cr wcel vx cv c2nd cfv cr wcel c2 vx cv c2nd cfv cmul
      co cr wcel 2re c2 vx cv c2nd cfv remulcl mpan sylan2 vx cv c1st cfv c2 vx
      cv c2nd cfv cmul co caddc co cr wcel c3 cr wcel c3 cc0 wne vx cv c1st cfv
      c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cr wcel 3re c3 3re 3pos
      gt0ne0ii vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 redivcl
      mp3an23 syl sylanc syl5bir adantrd pm2.61i adantll vx cv cr cr elxp6
      sylanb foprab cr cr cxp cr cD cC vx vy vz vx cv c1st cfv vy cv clt wbr vy
      cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv
      c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx
      cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD ruclem13.2 ruclem9 cC
      cF ruclem13.0 ruclem13.1 ruclem5 seq1rn2 mp3an mpbir2an $.
      $( [18-Oct-2004] $) $( [14-Oct-2004] $)
  $}

  ${
    $d x y z w v u $.  $d A w v u $.  $d C w v u $.  $d D w v u $.
    $d G w v u $.  $d H w v u $.  $d F z w v u  $.  $d B w v $.
    ruclem.0 $e |- F : NN --> RR $.
    ruclem.1 $e |- C = ( { <. 1 , <. ( ( F ` 1 ) + 1 ) ,
                     ( ( F ` 1 ) + 2 ) >. >. } u. ( F |` ( NN \ { 1 } ) ) ) $.
    ruclem.2 $e |- D = { <. <. x , y >. , z >. |
             ( ( x e. ( RR X. RR ) /\ y e. RR ) /\
             z = if ( ( ( 1st ` x ) < y /\ y < ( 2nd ` x ) ) ,
                 <. ( ( ( 2 x. y ) + ( 2nd ` x ) ) / 3 ) ,
                    ( ( y + ( 2 x. ( 2nd ` x ) ) ) / 3 ) >. ,
                 <. ( ( ( 2 x. ( 1st ` x ) ) + ( 2nd ` x ) ) / 3 ) ,
                    ( ( ( 1st ` x ) + ( 2 x. ( 2nd ` x ) ) ) / 3 ) >. ) ) } $.
    ruclem.3 $e |- G = ( 1st o. ( D seq1 C ) ) $.
    ruclem.4 $e |- H = ( 2nd o. ( D seq1 C ) ) $.
    $( Lemma for ~ ruc .  A helper lemma showing the initial value of the
         recursive sequence builder used for our construction. $)
    ruclem14 $p |- ( ( D seq1 C ) ` 1 ) =
               <. ( ( F ` 1 ) + 1 ) , ( ( F ` 1 ) + 2 ) >. $=
      c1 cD cC cseq1 co cfv c1 cC cfv c1 cF cfv c1 caddc co c1 cF cfv c2 caddc
      co cop cD cC vx vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv
      clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2
      vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0
      ruclem.1 ruclem5 seq11 cC cF ruclem.0 ruclem.1 ruclem7 eqtri $.
      $( [18-Oct-2004] $) $( [8-Oct-2004] $)

    ${
      ruclem15.a $e |- A e. NN $.
      $( Lemma for ~ ruc .  A helper lemma showing the successor value of the
         recursive sequence builder used for our construction. $)
      ruclem15 $p |- ( ( D seq1 C ) ` ( A + 1 ) ) =
  if ( ( ( G ` A ) < ( F ` ( A + 1 ) ) /\
   ( F ` ( A + 1 ) ) < ( H ` A ) ) ,
  <. ( ( ( 2 x. ( F ` ( A + 1 ) ) ) + ( H ` A ) ) / 3 ) ,
    ( ( ( F ` ( A + 1 ) ) + ( 2 x. ( H ` A ) ) ) / 3 ) >. ,
  <. ( ( ( 2 x. ( G ` A ) ) +
      ( H ` A ) ) / 3 ) ,
    ( ( ( G ` A ) +
      ( 2 x. ( H ` A ) ) ) / 3 ) >. ) $=
        cA c1 caddc co cD cC cseq1 co cfv cA cD cC cseq1 co cfv cA c1 caddc co
        cC cfv cD co cA cD cC cseq1 co cfv c1st cfv cA c1 caddc co cC cfv clt
        wbr cA c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa c2
        cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co
        c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul
        co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st cfv cmul co cA
        cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC cseq1 co cfv
        c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co
        cop cif cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv
        cA cH cfv clt wbr wa c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc
        co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3
        cdiv co cop c2 cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co cA cG
        cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop cif cA cn wcel cA c1
        caddc co cD cC cseq1 co cfv cA cD cC cseq1 co cfv cA c1 caddc co cC cfv
        cD co wceq ruclem15.a cA cD cC vx vy vz vx cv c1st cfv vy cv clt wbr vy
        cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co
        c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2
        vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st
        cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD ruclem.2
        ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 seq1p1 ax-mp cA cD cC cseq1 co
        cfv cr cr cxp wcel cA c1 caddc co cC cfv cr wcel cA cD cC cseq1 co cfv
        cA c1 caddc co cC cfv cD co cA cD cC cseq1 co cfv c1st cfv cA c1 caddc
        co cC cfv clt wbr cA c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv
        clt wbr wa c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd
        cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv
        c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st
        cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC
        cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc
        co c3 cdiv co cop cif wceq cn cr cr cxp cD cC cseq1 co wf cA cn wcel cA
        cD cC cseq1 co cfv cr cr cxp wcel vx vy vz cC cD cF ruclem.0 ruclem.1
        ruclem.2 ruclem13 ruclem15.a cn cr cr cxp cA cD cC cseq1 co ffvelrn
        mp2an cA c1 caddc co cC cfv cA c1 caddc co cF cfv cr cA cC cF ruclem.0
        ruclem.1 ruclem15.a ruclem8 cn cr cF wf cA c1 caddc co cn wcel cA c1
        caddc co cF cfv cr wcel ruclem.0 cA cn wcel cA c1 caddc co cn wcel
        ruclem15.a cA peano2nn ax-mp cn cr cA c1 caddc co cF ffvelrn mp2an
        eqeltri vw vv vu cA cD cC cseq1 co cfv cA c1 caddc co cC cfv cr cr cxp
        cr vw cv c1st cfv vv cv clt wbr vv cv vw cv c2nd cfv clt wbr wa c2 vv
        cv cmul co vw cv c2nd cfv caddc co c3 cdiv co vv cv c2 vw cv c2nd cfv
        cmul co caddc co c3 cdiv co cop c2 vw cv c1st cfv cmul co vw cv c2nd
        cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw cv c2nd cfv cmul co caddc
        co c3 cdiv co cop cif cA cD cC cseq1 co cfv c1st cfv cA c1 caddc co cC
        cfv clt wbr cA c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt
        wbr wa c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd cfv
        caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd
        cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st cfv
        cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC
        cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc
        co c3 cdiv co cop cif cD cA cD cC cseq1 co cfv c1st cfv vv cv clt wbr
        vv cv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa c2 vv cv cmul co cA cD
        cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co vv cv c2 cA cD cC cseq1 co
        cfv c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv
        c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA
        cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co
        caddc co c3 cdiv co cop cif cA cD cC cseq1 co cfv c1st cfv cA c1 caddc
        co cC cfv clt wbr cA c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv
        clt wbr wa c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd
        cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv
        c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st
        cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC
        cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc
        co c3 cdiv co cop c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co
        cfv c2nd cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC
        cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co opex c2 cA cD cC
        cseq1 co cfv c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co
        c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd
        cfv cmul co caddc co c3 cdiv co opex ifex vw cv cA cD cC cseq1 co cfv
        wceq vv cv vv cv wceq vw cv c1st cfv vv cv clt wbr vv cv vw cv c2nd cfv
        clt wbr wa c2 vv cv cmul co vw cv c2nd cfv caddc co c3 cdiv co vv cv c2
        vw cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vw cv c1st cfv cmul
        co vw cv c2nd cfv caddc co c3 cdiv co vw cv c1st cfv c2 vw cv c2nd cfv
        cmul co caddc co c3 cdiv co cop cif cA cD cC cseq1 co cfv c1st cfv vv
        cv clt wbr vv cv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa c2 vv cv
        cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co vv cv c2 cA
        cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC
        cseq1 co cfv c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co
        c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd
        cfv cmul co caddc co c3 cdiv co cop cif wceq vv cv eqid vw cv vv cv cA
        cD cC cseq1 co cfv vv cv ruclem4 mpan2 cA cD cC cseq1 co cfv cA cD cC
        cseq1 co cfv wceq vv cv cA c1 caddc co cC cfv wceq cA cD cC cseq1 co
        cfv c1st cfv vv cv clt wbr vv cv cA cD cC cseq1 co cfv c2nd cfv clt wbr
        wa c2 vv cv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co
        vv cv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop
        c2 cA cD cC cseq1 co cfv c1st cfv cmul co cA cD cC cseq1 co cfv c2nd
        cfv caddc co c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC
        cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop cif cA cD cC
        cseq1 co cfv c1st cfv cA c1 caddc co cC cfv clt wbr cA c1 caddc co cC
        cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa c2 cA c1 caddc co cC cfv
        cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA c1 caddc
        co cC cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co
        cop c2 cA cD cC cseq1 co cfv c1st cfv cmul co cA cD cC cseq1 co cfv
        c2nd cfv caddc co c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC
        cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq cA cD cC
        cseq1 co cfv eqid cA cD cC cseq1 co cfv vv cv cA cD cC cseq1 co cfv cA
        c1 caddc co cC cfv ruclem4 mpan vx vy vz vw vv vu cD ruclem.2 ruclem12
        oprabval2 mp2an cA cD cC cseq1 co cfv c1st cfv cA c1 caddc co cC cfv
        clt wbr cA c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa
        c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc
        co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd cfv
        cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st cfv cmul
        co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC cseq1 co
        cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv
        co cop cif cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF
        cfv cA cH cfv clt wbr wa c2 cA c1 caddc co cC cfv cmul co cA cD cC
        cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA
        cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC
        cseq1 co cfv c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co
        c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd
        cfv cmul co caddc co c3 cdiv co cop cif cA cG cfv cA c1 caddc co cF cfv
        clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1 caddc co cF
        cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA
        cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co cA cH cfv
        caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co
        cop cif cA cD cC cseq1 co cfv c1st cfv cA c1 caddc co cC cfv clt wbr cA
        c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa cA cG cfv
        cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr
        wa wb cA cD cC cseq1 co cfv c1st cfv cA c1 caddc co cC cfv clt wbr cA
        c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa c2 cA c1
        caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv
        co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co
        caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st cfv cmul co cA cD
        cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC cseq1 co cfv c1st
        cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop
        cif cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH
        cfv clt wbr wa c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv
        c2nd cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co
        cfv c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv
        c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA
        cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co
        caddc co c3 cdiv co cop cif wceq cA cD cC cseq1 co cfv c1st cfv cA c1
        caddc co cC cfv clt wbr cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1
        caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr cA c1 caddc co
        cF cfv cA cH cfv clt wbr cA cD cC cseq1 co cfv c1st cfv cA cG cfv cA c1
        caddc co cC cfv cA c1 caddc co cF cfv clt cA cC cD cG ruclem15.a vx vy
        vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy
        cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv
        cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd
        cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc
        co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1
        ruclem5 ruclem.3 ruclem10 cA cC cF ruclem.0 ruclem.1 ruclem15.a ruclem8
        breq12i cA c1 caddc co cC cfv cA c1 caddc co cF cfv cA cD cC cseq1 co
        cfv c2nd cfv cA cH cfv clt cA cC cF ruclem.0 ruclem.1 ruclem15.a
        ruclem8 cA cC cD cH ruclem15.a vx vy vz vx cv c1st cfv vy cv clt wbr vy
        cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co
        c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2
        vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st
        cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD ruclem.2
        ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 ruclem.4 ruclem11 breq12i
        anbi12i cA cD cC cseq1 co cfv c1st cfv cA c1 caddc co cC cfv clt wbr cA
        c1 caddc co cC cfv cA cD cC cseq1 co cfv c2nd cfv clt wbr wa cA cG cfv
        cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr
        wa c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd cfv
        caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd
        cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st cfv
        cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC
        cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc
        co c3 cdiv co cop ifbi ax-mp c2 cA c1 caddc co cC cfv cmul co cA cD cC
        cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA
        cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA c1
        caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF
        cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop wceq c2 cA cD cC cseq1
        co cfv c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv
        co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv
        cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co cA cH cfv caddc co
        c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop wceq
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd
        cfv caddc co c3 cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv
        c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cD cC cseq1 co cfv c1st
        cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA cD cC
        cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc
        co c3 cdiv co cop cif cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1
        caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1 caddc co cF cfv cmul co
        cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH cfv cmul
        co caddc co c3 cdiv co cop c2 cA cG cfv cmul co cA cH cfv caddc co c3
        cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop cif wceq
        c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd cfv caddc
        co c3 cdiv co c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3
        cdiv co cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co
        caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co
        c3 cdiv co c2 cA c1 caddc co cC cfv cmul co cA cD cC cseq1 co cfv c2nd
        cfv caddc co c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3
        cdiv c2 cA c1 caddc co cC cfv cmul co c2 cA c1 caddc co cF cfv cmul co
        cA cD cC cseq1 co cfv c2nd cfv cA cH cfv caddc cA c1 caddc co cC cfv cA
        c1 caddc co cF cfv c2 cmul cA cC cF ruclem.0 ruclem.1 ruclem15.a
        ruclem8 opreq2i cA cC cD cH ruclem15.a vx vy vz vx cv c1st cfv vy cv
        clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv
        caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co
        cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
        c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD
        ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 ruclem.4 ruclem11
        opreq12i opreq1i cA c1 caddc co cC cfv c2 cA cD cC cseq1 co cfv c2nd
        cfv cmul co caddc co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc
        co c3 cdiv cA c1 caddc co cC cfv cA c1 caddc co cF cfv c2 cA cD cC
        cseq1 co cfv c2nd cfv cmul co c2 cA cH cfv cmul co caddc cA cC cF
        ruclem.0 ruclem.1 ruclem15.a ruclem8 cA cD cC cseq1 co cfv c2nd cfv cA
        cH cfv c2 cmul cA cC cD cH ruclem15.a vx vy vz vx cv c1st cfv vy cv clt
        wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv
        caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co
        cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
        c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD
        ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 ruclem.4 ruclem11
        opreq2i opreq12i opreq1i opeq12i c2 cA cD cC cseq1 co cfv c1st cfv cmul
        co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co c2 cA cG cfv cmul
        co cA cH cfv caddc co c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA
        cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co cA cG cfv c2 cA
        cH cfv cmul co caddc co c3 cdiv co c2 cA cD cC cseq1 co cfv c1st cfv
        cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c2 cA cG cfv cmul co cA
        cH cfv caddc co c3 cdiv c2 cA cD cC cseq1 co cfv c1st cfv cmul co c2 cA
        cG cfv cmul co cA cD cC cseq1 co cfv c2nd cfv cA cH cfv caddc cA cD cC
        cseq1 co cfv c1st cfv cA cG cfv c2 cmul cA cC cD cG ruclem15.a vx vy vz
        vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv
        cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul
        co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv
        caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co
        c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5
        ruclem.3 ruclem10 opreq2i cA cC cD cH ruclem15.a vx vy vz vx cv c1st
        cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx
        cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc
        co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3
        cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co
        cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 ruclem.4
        ruclem11 opreq12i opreq1i cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC
        cseq1 co cfv c2nd cfv cmul co caddc co cA cG cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv cA cD cC cseq1 co cfv c1st cfv cA cG cfv c2 cA cD cC
        cseq1 co cfv c2nd cfv cmul co c2 cA cH cfv cmul co caddc cA cC cD cG
        ruclem15.a vx vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv
        clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2
        vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul
        co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv
        cmul co caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0
        ruclem.1 ruclem5 ruclem.3 ruclem10 cA cD cC cseq1 co cfv c2nd cfv cA cH
        cfv c2 cmul cA cC cD cH ruclem15.a vx vy vz vx cv c1st cfv vy cv clt
        wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv
        caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co
        cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
        c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif cD
        ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 ruclem.4 ruclem11
        opreq2i opreq12i opreq1i opeq12i cA cG cfv cA c1 caddc co cF cfv clt
        wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1 caddc co cC cfv
        cmul co cA cD cC cseq1 co cfv c2nd cfv caddc co c3 cdiv co cA c1 caddc
        co cC cfv c2 cA cD cC cseq1 co cfv c2nd cfv cmul co caddc co c3 cdiv co
        cop c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA
        c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2 cA
        cD cC cseq1 co cfv c1st cfv cmul co cA cD cC cseq1 co cfv c2nd cfv
        caddc co c3 cdiv co cA cD cC cseq1 co cfv c1st cfv c2 cA cD cC cseq1 co
        cfv c2nd cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co cA cH
        cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv
        co cop ifeq12 mp2an eqtri 3eqtri $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)
    $}

    $( Lemma for ~ ruc .  A helper lemma showing the initial value of our
       constructed ` G ` . $)
    ruclem16 $p |- ( G ` 1 ) = ( ( F ` 1 ) + 1 ) $=
      c1 cD cC cseq1 co cfv c1st cfv c1 cF cfv c1 caddc co c1 cF cfv c2 caddc
      co cop c1st cfv c1 cG cfv c1 cF cfv c1 caddc co c1 cD cC cseq1 co cfv c1
      cF cfv c1 caddc co c1 cF cfv c2 caddc co cop c1st vx vy vz cC cD cF cG cH
      ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem14 fveq2i c1 cC cD cG
      1nn vx vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa
      c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd
      cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co
      c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5
      ruclem.3 ruclem10 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co c1 cF cfv
      c1 caddc oprex op1st 3eqtr3i $.
      $( [18-Oct-2004] $) $( [9-Oct-2004] $)

    $( Lemma for ~ ruc .  A helper lemma showing our constructed function ` G `
       maps ` NN ` to real numbers. $)
    ruclem17 $p |- G : NN --> RR $=
      cn cr c1st cr cr cxp cres cD cC cseq1 co ccom wf cn cr cG wf cr cr cxp cr
      c1st cr cr cxp cres wf cn cr cr cxp cD cC cseq1 co wf cn cr c1st cr cr
      cxp cres cD cC cseq1 co ccom wf cr cr f1stres vx vy vz cC cD cF ruclem.0
      ruclem.1 ruclem.2 ruclem13 cn cr cr cxp cr c1st cr cr cxp cres cD cC
      cseq1 co fco mp2an c1st cr cr cxp cres cD cC cseq1 co ccom cG wceq cn cr
      c1st cr cr cxp cres cD cC cseq1 co ccom wf cn cr cG wf wb c1st cr cr cxp
      cres cD cC cseq1 co ccom c1st cD cC cseq1 co ccom cG cD cC cseq1 co crn
      cr cr cxp wss c1st cr cr cxp cres cD cC cseq1 co ccom c1st cD cC cseq1 co
      ccom wceq cn cr cr cxp cD cC cseq1 co wf cD cC cseq1 co crn cr cr cxp wss
      vx vy vz cC cD cF ruclem.0 ruclem.1 ruclem.2 ruclem13 cn cr cr cxp cD cC
      cseq1 co frn ax-mp c1st cD cC cseq1 co cr cr cxp cores ax-mp ruclem.3
      eqtr4i cn cr c1st cr cr cxp cres cD cC cseq1 co ccom cG feq1 ax-mp mpbi
      $.
      $( [18-Oct-2004] $) $( [15-Oct-2004] $)

    ${
      ruclem18.a $e |- A e. NN $.
      $( Lemma for ~ ruc .  The value of our constructed function ` G ` when
         the value of the input function ` F ` lies between the previous values
         of ` G ` and ` H ` .  This assignment to ` G ` defines a new interval
         between ` G ` and ` H ` (see also ~ ruclem19 ) that avoids the value
         of ` F ` . $)
      ruclem18 $p |- (
       ( ( G ` A ) < ( F ` ( A + 1 ) ) /\ ( F ` ( A + 1 ) ) < ( H ` A ) ) ->
   ( G ` ( A + 1 ) ) = ( ( ( 2 x. ( F ` ( A + 1 ) ) ) + ( H ` A ) ) / 3 ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA c1 caddc co cD cC cseq1 co cfv c1st cfv c2 cA c1 caddc co
        cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2
        cA cH cfv cmul co caddc co c3 cdiv co cop c1st cfv cA c1 caddc co cG
        cfv c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA
        cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA c1 caddc co cD cC cseq1 co cfv c2 cA c1 caddc co cF cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH
        cfv cmul co caddc co c3 cdiv co cop c1st cA cG cfv cA c1 caddc co cF
        cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2
        cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc
        co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv co cop cif c2 cA c1 caddc co cF cfv cmul co cA cH cfv
        caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co
        c3 cdiv co cop cA c1 caddc co cD cC cseq1 co cfv cA cG cfv cA c1 caddc
        co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1
        caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF
        cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co
        cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co
        c3 cdiv co cop iftrue vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem15 syl5eq fveq2d cA c1
        caddc co cC cD cG cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA
        peano2nn ax-mp vx vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd
        cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy
        cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv
        cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd
        cfv cmul co caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF
        ruclem.0 ruclem.1 ruclem5 ruclem.3 ruclem10 c2 cA c1 caddc co cF cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH
        cfv cmul co caddc co c3 cdiv co c2 cA c1 caddc co cF cfv cmul co cA cH
        cfv caddc co c3 cdiv oprex op1st 3eqtr3g $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  The value of our constructed function ` H ` when
         the value of the input function ` F ` lies between the previous values
         of ` G ` and ` H ` .  This assignment to ` H ` defines a new interval
         between ` G ` and ` H ` (see also ~ ruclem18 ) that avoids the value
         of ` F ` . $)
      ruclem19 $p |- (
       ( ( G ` A ) < ( F ` ( A + 1 ) ) /\ ( F ` ( A + 1 ) ) < ( H ` A ) ) ->
   ( H ` ( A + 1 ) ) = ( ( ( F ` ( A + 1 ) ) + ( 2 x. ( H ` A ) ) ) / 3 ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA c1 caddc co cD cC cseq1 co cfv c2nd cfv c2 cA c1 caddc co
        cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2
        cA cH cfv cmul co caddc co c3 cdiv co cop c2nd cfv cA c1 caddc co cH
        cfv cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cA
        cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA c1 caddc co cD cC cseq1 co cfv c2 cA c1 caddc co cF cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH
        cfv cmul co caddc co c3 cdiv co cop c2nd cA cG cfv cA c1 caddc co cF
        cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2
        cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc
        co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv co cop cif c2 cA c1 caddc co cF cfv cmul co cA cH cfv
        caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co
        c3 cdiv co cop cA c1 caddc co cD cC cseq1 co cfv cA cG cfv cA c1 caddc
        co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1
        caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF
        cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co
        cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co
        c3 cdiv co cop iftrue vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem15 syl5eq fveq2d cA c1
        caddc co cC cD cH cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA
        peano2nn ax-mp vx vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd
        cfv clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy
        cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv
        cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd
        cfv cmul co caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF
        ruclem.0 ruclem.1 ruclem5 ruclem.4 ruclem11 c2 cA c1 caddc co cF cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA cH
        cfv cmul co caddc co c3 cdiv co c2 cA c1 caddc co cF cfv cmul co cA cH
        cfv caddc co c3 cdiv oprex cA c1 caddc co cF cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv oprex op2nd 3eqtr3g $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  The value of our constructed function ` G ` when
         the value of the input function ` F ` does not lie between the
         previous values of ` G ` and ` H ` .  This assignment to ` G ` just
         shrinks the interval between ` G ` and ` H ` by some arbitrary
         amount. $)
      ruclem20 $p |- (
    -. ( ( G ` A ) < ( F ` ( A + 1 ) ) /\ ( F ` ( A + 1 ) ) < ( H ` A ) ) ->
   ( G ` ( A + 1 ) ) = ( ( ( 2 x. ( G ` A ) ) + ( H ` A ) ) / 3 ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa wn cA c1 caddc co cD cC cseq1 co cfv c1st cfv c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv co cop c1st cfv cA c1 caddc co cG cfv c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv cA c1 caddc co cF cfv
        clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn cA c1 caddc co cD
        cC cseq1 co cfv c2 cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co cA
        cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c1st cA cG cfv cA
        c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa
        wn cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH
        cfv clt wbr wa c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3
        cdiv co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co
        cop c2 cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA
        cH cfv cmul co caddc co c3 cdiv co cop cif c2 cA cG cfv cmul co cA cH
        cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv
        co cop cA c1 caddc co cD cC cseq1 co cfv cA cG cfv cA c1 caddc co cF
        cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1 caddc
        co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv
        c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co cA cH
        cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv
        co cop iffalse vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem18.a ruclem15 syl5eq fveq2d cA c1 caddc co cC
        cD cG cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA peano2nn ax-mp vx
        vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2
        vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd
        cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv
        c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co
        caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1
        ruclem5 ruclem.3 ruclem10 c2 cA cG cfv cmul co cA cH cfv caddc co c3
        cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv oprex op1st 3eqtr3g $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  The value of our constructed function ` H ` when
         the value of the input function ` F ` does not lie between the
         previous values of ` G ` and ` H ` .  This assignment to ` H ` just
         shrinks the interval between ` G ` and ` H ` by some arbitrary
         amount. $)
      ruclem21 $p |- (
    -. ( ( G ` A ) < ( F ` ( A + 1 ) ) /\ ( F ` ( A + 1 ) ) < ( H ` A ) ) ->
   ( H ` ( A + 1 ) ) = ( ( ( G ` A ) + ( 2 x. ( H ` A ) ) ) / 3 ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa wn cA c1 caddc co cD cC cseq1 co cfv c2nd cfv c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv co cop c2nd cfv cA c1 caddc co cH cfv cA cG cfv c2 cA
        cH cfv cmul co caddc co c3 cdiv co cA cG cfv cA c1 caddc co cF cfv clt
        wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn cA c1 caddc co cD cC
        cseq1 co cfv c2 cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co cA cG
        cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop c2nd cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv
        co cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cop
        c2 cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH
        cfv cmul co caddc co c3 cdiv co cop cif c2 cA cG cfv cmul co cA cH cfv
        caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co
        cop cA c1 caddc co cD cC cseq1 co cfv cA cG cfv cA c1 caddc co cF cfv
        clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2 cA c1 caddc co cF
        cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cF cfv c2 cA
        cH cfv cmul co caddc co c3 cdiv co cop c2 cA cG cfv cmul co cA cH cfv
        caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co
        cop iffalse vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem18.a ruclem15 syl5eq fveq2d cA c1 caddc co cC
        cD cH cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA peano2nn ax-mp vx
        vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2
        vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd
        cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv
        c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co
        caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1
        ruclem5 ruclem.4 ruclem11 c2 cA cG cfv cmul co cA cH cfv caddc co c3
        cdiv co cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co c2 cA cG cfv
        cmul co cA cH cfv caddc co c3 cdiv oprex cA cG cfv c2 cA cH cfv cmul co
        caddc co c3 cdiv oprex op2nd 3eqtr3g $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  Each value of our constructed function ` G ` is a
         real number. $)
      ruclem22 $p |- ( G ` A ) e. RR $=
        cn cr cG wf cA cn wcel cA cG cfv cr wcel vx vy vz cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem17 ruclem18.a cn cr
        cA cG ffvelrn mp2an $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  Each value of our constructed function ` H ` is a
         real number. $)
      ruclem23 $p |- ( H ` A ) e. RR $=
        cA cD cC cseq1 co cfv c2nd cfv cA cH cfv cr cA cC cD cH ruclem18.a vx
        vy vz vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2
        vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd
        cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv
        c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co
        caddc co c3 cdiv co cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1
        ruclem5 ruclem.4 ruclem11 cA cD cC cseq1 co cfv c1st cfv cr wcel cA cD
        cC cseq1 co cfv c2nd cfv cr wcel cA cD cC cseq1 co cfv cr cr cxp wcel
        cA cD cC cseq1 co cfv c1st cfv cr wcel cA cD cC cseq1 co cfv c2nd cfv
        cr wcel wa cn cr cr cxp cD cC cseq1 co wf cA cn wcel cA cD cC cseq1 co
        cfv cr cr cxp wcel vx vy vz cC cD cF ruclem.0 ruclem.1 ruclem.2
        ruclem13 ruclem18.a cn cr cr cxp cA cD cC cseq1 co ffvelrn mp2an cA cD
        cC cseq1 co cfv cr cr cxp wcel cA cD cC cseq1 co cfv cA cD cC cseq1 co
        cfv c1st cfv cA cD cC cseq1 co cfv c2nd cfv cop wceq cA cD cC cseq1 co
        cfv c1st cfv cr wcel cA cD cC cseq1 co cfv c2nd cfv cr wcel wa cA cD cC
        cseq1 co cfv cr cr elxp6 pm3.27bi ax-mp pm3.27i eqeltrri $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  A helper lemma for the induction hypothesis in
         ~ ruclem25 . $)
      ruclem24 $p |- ( ( G ` A ) < ( H ` A ) ->
                       ( G ` ( A + 1 ) ) < ( H ` ( A + 1 ) ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA cG cfv cA cH cfv clt wbr cA c1 caddc co cG cfv cA c1
        caddc co cH cfv clt wbr wi cA cG cfv cA c1 caddc co cF cfv clt wbr cA
        c1 caddc co cF cfv cA cH cfv clt wbr wa cA c1 caddc co cG cfv cA c1
        caddc co cH cfv clt wbr cA cG cfv cA cH cfv clt wbr cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa c2
        cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc
        co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cA c1 caddc co cG
        cfv cA c1 caddc co cH cfv clt cA c1 caddc co cF cfv cA cH cfv clt wbr
        c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1
        caddc co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co clt wbr cA cG
        cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt
        wbr c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co cA
        c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3 cdiv co clt wbr cA
        c1 caddc co cF cfv cA cH cfv cn cr cF wf cA c1 caddc co cn wcel cA c1
        caddc co cF cfv cr wcel ruclem.0 cA cn wcel cA c1 caddc co cn wcel
        ruclem18.a cA peano2nn ax-mp cn cr cA c1 caddc co cF ffvelrn mp2an vx
        vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
        ruclem18.a ruclem23 ruclem2 biimpi adantl vx vy vz cA cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem18 vx vy
        vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
        ruclem18.a ruclem19 3brtr4d a1d cA cG cfv cA c1 caddc co cF cfv clt wbr
        cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn cA cG cfv cA cH cfv clt
        wbr cA c1 caddc co cG cfv cA c1 caddc co cH cfv clt wbr cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn
        cA c1 caddc co cG cfv cA c1 caddc co cH cfv clt wbr c2 cA cG cfv cmul
        co cA cH cfv caddc co c3 cdiv co cA cG cfv c2 cA cH cfv cmul co caddc
        co c3 cdiv co clt wbr cA cG cfv cA cH cfv clt wbr cA cG cfv cA c1 caddc
        co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn cA c1
        caddc co cG cfv c2 cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co cA
        c1 caddc co cH cfv cA cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co
        clt vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
        ruclem.4 ruclem18.a ruclem20 vx vy vz cA cC cD cF cG cH ruclem.0
        ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem21 breq12d cA cG
        cfv cA cH cfv vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem18.a ruclem22 vx vy vz cA cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem23
        ruclem2 syl6rbbr biimpd pm2.61i $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  At any index ` A ` , the value of ` G ` is less
         than the value of ` H ` . $)
      ruclem25 $p |- ( G ` A ) < ( H ` A ) $=
        cA cn wcel cA cG cfv cA cH cfv clt wbr ruclem18.a vw cv cG cfv vw cv cH
        cfv clt wbr c1 cG cfv c1 cH cfv clt wbr vv cv cG cfv vv cv cH cfv clt
        wbr vv cv c1 caddc co cG cfv vv cv c1 caddc co cH cfv clt wbr cA cG cfv
        cA cH cfv clt wbr vw vv cA vw cv c1 wceq vw cv cG cfv c1 cG cfv vw cv
        cH cfv c1 cH cfv clt vw cv c1 cG fveq2 vw cv c1 cH fveq2 breq12d vw cv
        vv cv wceq vw cv cG cfv vv cv cG cfv vw cv cH cfv vv cv cH cfv clt vw
        cv vv cv cG fveq2 vw cv vv cv cH fveq2 breq12d vw cv vv cv c1 caddc co
        wceq vw cv cG cfv vv cv c1 caddc co cG cfv vw cv cH cfv vv cv c1 caddc
        co cH cfv clt vw cv vv cv c1 caddc co cG fveq2 vw cv vv cv c1 caddc co
        cH fveq2 breq12d vw cv cA wceq vw cv cG cfv cA cG cfv vw cv cH cfv cA
        cH cfv clt vw cv cA cG fveq2 vw cv cA cH fveq2 breq12d c1 cF cfv c1
        caddc co c1 cF cfv c2 caddc co c1 cG cfv c1 cH cfv clt c1 c2 clt wbr c1
        cF cfv c1 caddc co c1 cF cfv c2 caddc co clt wbr 1lt2 c1 c2 c1 cF cfv
        1re 2re cn cr cF wf c1 cn wcel c1 cF cfv cr wcel ruclem.0 1nn cn cr c1
        cF ffvelrn mp2an ltadd2i mpbi vx vy vz cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 ruclem16 c1 cD cC cseq1 co cfv c2nd cfv c1
        cF cfv c1 caddc co c1 cF cfv c2 caddc co cop c2nd cfv c1 cH cfv c1 cF
        cfv c2 caddc co c1 cD cC cseq1 co cfv c1 cF cfv c1 caddc co c1 cF cfv
        c2 caddc co cop c2nd vx vy vz cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem14 fveq2i c1 cC cD cH 1nn vx vy vz vx cv c1st
        cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx
        cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc
        co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3
        cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co
        cop cif cD ruclem.2 ruclem9 cC cF ruclem.0 ruclem.1 ruclem5 ruclem.4
        ruclem11 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co c1 cF cfv c1 caddc
        oprex c1 cF cfv c2 caddc oprex op2nd 3eqtr3i 3brtr4i vv cv cn wcel vv
        cv cG cfv vv cv cH cfv clt wbr vv cv c1 caddc co cG cfv vv cv c1 caddc
        co cH cfv clt wbr wi vv cv cn wcel vv cv c1 cif cG cfv vv cv cn wcel vv
        cv c1 cif cH cfv clt wbr vv cv cn wcel vv cv c1 cif c1 caddc co cG cfv
        vv cv cn wcel vv cv c1 cif c1 caddc co cH cfv clt wbr wi vv cv c1 vv cv
        vv cv cn wcel vv cv c1 cif wceq vv cv cG cfv vv cv cH cfv clt wbr vv cv
        cn wcel vv cv c1 cif cG cfv vv cv cn wcel vv cv c1 cif cH cfv clt wbr
        vv cv c1 caddc co cG cfv vv cv c1 caddc co cH cfv clt wbr vv cv cn wcel
        vv cv c1 cif c1 caddc co cG cfv vv cv cn wcel vv cv c1 cif c1 caddc co
        cH cfv clt wbr vv cv vv cv cn wcel vv cv c1 cif wceq vv cv cG cfv vv cv
        cn wcel vv cv c1 cif cG cfv vv cv cH cfv vv cv cn wcel vv cv c1 cif cH
        cfv clt vv cv vv cv cn wcel vv cv c1 cif cG fveq2 vv cv vv cv cn wcel
        vv cv c1 cif cH fveq2 breq12d vv cv vv cv cn wcel vv cv c1 cif wceq vv
        cv c1 caddc co cG cfv vv cv cn wcel vv cv c1 cif c1 caddc co cG cfv vv
        cv c1 caddc co cH cfv vv cv cn wcel vv cv c1 cif c1 caddc co cH cfv clt
        vv cv vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co vv cv cn wcel
        vv cv c1 cif c1 caddc co cG vv cv vv cv cn wcel vv cv c1 cif c1 caddc
        opreq1 fveq2d vv cv vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co
        vv cv cn wcel vv cv c1 cif c1 caddc co cH vv cv vv cv cn wcel vv cv c1
        cif c1 caddc opreq1 fveq2d breq12d imbi12d vx vy vz vv cv cn wcel vv cv
        c1 cif cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 vv
        cv c1 cn 1nn elimel ruclem24 dedth nnind ax-mp $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  Our constructed function ` G ` has an
         ever-increasing set of values. $)
      ruclem26 $p |- ( G ` A ) < ( G ` ( A + 1 ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA cG cfv cA c1 caddc co cG cfv clt wbr cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa cA
        cG cfv c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv co
        cA c1 caddc co cG cfv clt cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1
        caddc co cF cfv c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3
        cdiv co clt wbr cA cG cfv c2 cA c1 caddc co cF cfv cmul co cA cH cfv
        caddc co c3 cdiv co clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr cA
        cG cfv cA c1 caddc co cF cfv c2 cA c1 caddc co cF cfv cmul co cA cH cfv
        caddc co c3 cdiv co vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem22 cn cr cF wf cA c1 caddc
        co cn wcel cA c1 caddc co cF cfv cr wcel ruclem.0 cA cn wcel cA c1
        caddc co cn wcel ruclem18.a cA peano2nn ax-mp cn cr cA c1 caddc co cF
        ffvelrn mp2an c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 c2
        cA c1 caddc co cF cfv cmul co cA cH cfv c2 cA c1 caddc co cF cfv 2re cn
        cr cF wf cA c1 caddc co cn wcel cA c1 caddc co cF cfv cr wcel ruclem.0
        cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA peano2nn ax-mp cn cr cA
        c1 caddc co cF ffvelrn mp2an remulcli vx vy vz cA cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem23
        readdcli 3re c3 3re 3pos gt0ne0ii redivcli lttri cA c1 caddc co cF cfv
        cA cH cfv cn cr cF wf cA c1 caddc co cn wcel cA c1 caddc co cF cfv cr
        wcel ruclem.0 cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA peano2nn
        ax-mp cn cr cA c1 caddc co cF ffvelrn mp2an vx vy vz cA cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem23
        ruclem1 sylan2b vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem18.a ruclem18 breqtrrd cA cG cfv cA c1 caddc co
        cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn c2 cA cG
        cfv cmul co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cG cfv cA cG
        cfv clt vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
        ruclem.4 ruclem18.a ruclem20 cA cG cfv cA cH cfv clt wbr cA cG cfv c2
        cA cG cfv cmul co cA cH cfv caddc co c3 cdiv co clt wbr vx vy vz cA cC
        cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a
        ruclem25 cA cG cfv cA cH cfv vx vy vz cA cC cD cF cG cH ruclem.0
        ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem22 vx vy vz cA cC
        cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a
        ruclem23 ruclem1 mpbi syl5breqr pm2.61i $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  Our constructed function ` H ` has an
         ever-decreasing set of values. $)
      ruclem27 $p |- ( H ` ( A + 1 ) ) < ( H ` A ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA c1 caddc co cH cfv cA cH cfv clt wbr cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa cA
        c1 caddc co cH cfv cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co
        c3 cdiv co cA cH cfv clt vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem19 cA c1 caddc co cF cfv cA
        cH cfv clt wbr cA c1 caddc co cF cfv c2 cA cH cfv cmul co caddc co c3
        cdiv co cA cH cfv clt wbr cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1
        caddc co cF cfv cA cH cfv clt wbr cA c1 caddc co cF cfv c2 cA cH cfv
        cmul co caddc co c3 cdiv co cA cH cfv clt wbr cA c1 caddc co cF cfv cA
        cH cfv cn cr cF wf cA c1 caddc co cn wcel cA c1 caddc co cF cfv cr wcel
        ruclem.0 cA cn wcel cA c1 caddc co cn wcel ruclem18.a cA peano2nn ax-mp
        cn cr cA c1 caddc co cF ffvelrn mp2an vx vy vz cA cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem23
        ruclem3 biimpi adantl eqbrtrd cA cG cfv cA c1 caddc co cF cfv clt wbr
        cA c1 caddc co cF cfv cA cH cfv clt wbr wa wn cA c1 caddc co cH cfv cA
        cG cfv c2 cA cH cfv cmul co caddc co c3 cdiv co cA cH cfv clt vx vy vz
        cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
        ruclem18.a ruclem21 cA cG cfv cA cH cfv clt wbr cA cG cfv c2 cA cH cfv
        cmul co caddc co c3 cdiv co cA cH cfv clt wbr vx vy vz cA cC cD cF cG
        cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem25 cA
        cG cfv cA cH cfv vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem18.a ruclem22 vx vy vz cA cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem18.a ruclem23
        ruclem3 mpbi syl6eqbr pm2.61i $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)
    $}

    ${
      ruclem28.a $e |- A e. NN $.
      $( Lemma for ~ ruc .  A helper lemma for ~ ruclem29 . $)
      ruclem28 $p |- -. ( ( G ` ( A + 1 ) ) < ( F ` ( A + 1 ) ) /\
                      ( F ` ( A + 1 ) ) < ( H ` ( A + 1 ) ) ) $=
        cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv
        clt wbr wa cA c1 caddc co cG cfv cA c1 caddc co cF cfv clt wbr cA c1
        caddc co cF cfv cA c1 caddc co cH cfv clt wbr wa wn cA cG cfv cA c1
        caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr wa cA
        c1 caddc co cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv
        cA c1 caddc co cH cfv clt wbr cA cG cfv cA c1 caddc co cF cfv clt wbr
        cA c1 caddc co cF cfv cA cH cfv clt wbr wa cA c1 caddc co cF cfv cA c1
        caddc co cG cfv clt wbr cA c1 caddc co cG cfv cA c1 caddc co cF cfv clt
        wbr wn cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA
        cH cfv clt wbr wa cA c1 caddc co cF cfv c2 cA c1 caddc co cF cfv cmul
        co cA cH cfv caddc co c3 cdiv co cA c1 caddc co cG cfv clt cA c1 caddc
        co cF cfv cA cH cfv clt wbr cA c1 caddc co cF cfv c2 cA c1 caddc co cF
        cfv cmul co cA cH cfv caddc co c3 cdiv co clt wbr cA cG cfv cA c1 caddc
        co cF cfv clt wbr cA c1 caddc co cF cfv cA cH cfv clt wbr cA c1 caddc
        co cF cfv c2 cA c1 caddc co cF cfv cmul co cA cH cfv caddc co c3 cdiv
        co clt wbr cA c1 caddc co cF cfv cA cH cfv cn cr cF wf cA c1 caddc co
        cn wcel cA c1 caddc co cF cfv cr wcel ruclem.0 cA cn wcel cA c1 caddc
        co cn wcel ruclem28.a cA peano2nn ax-mp cn cr cA c1 caddc co cF ffvelrn
        mp2an vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
        ruclem.4 ruclem28.a ruclem23 ruclem1 biimpi adantl vx vy vz cA cC cD cF
        cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem28.a ruclem18
        breqtrrd cA c1 caddc co cF cfv cA c1 caddc co cG cfv cn cr cF wf cA c1
        caddc co cn wcel cA c1 caddc co cF cfv cr wcel ruclem.0 cA cn wcel cA
        c1 caddc co cn wcel ruclem28.a cA peano2nn ax-mp cn cr cA c1 caddc co
        cF ffvelrn mp2an vx vy vz cA c1 caddc co cC cD cF cG cH ruclem.0
        ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cA c1 caddc co cn wcel
        ruclem28.a cA peano2nn ax-mp ruclem22 ltnsymi syl intnanrd cA c1 caddc
        co cG cfv cA c1 caddc co cF cfv clt wbr cA c1 caddc co cF cfv cA c1
        caddc co cH cfv clt wbr wa cA cG cfv cA c1 caddc co cF cfv clt wbr cA
        c1 caddc co cF cfv cA cH cfv clt wbr wa cA c1 caddc co cG cfv cA c1
        caddc co cF cfv clt wbr cA cG cfv cA c1 caddc co cF cfv clt wbr cA c1
        caddc co cF cfv cA c1 caddc co cH cfv clt wbr cA c1 caddc co cF cfv cA
        cH cfv clt wbr cA cG cfv cA c1 caddc co cG cfv clt wbr cA c1 caddc co
        cG cfv cA c1 caddc co cF cfv clt wbr cA cG cfv cA c1 caddc co cF cfv
        clt wbr vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
        ruclem.4 ruclem28.a ruclem26 cA cG cfv cA c1 caddc co cG cfv cA c1
        caddc co cF cfv vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
        ruclem.3 ruclem.4 ruclem28.a ruclem22 vx vy vz cA c1 caddc co cC cD cF
        cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cA c1
        caddc co cn wcel ruclem28.a cA peano2nn ax-mp ruclem22 cn cr cF wf cA
        c1 caddc co cn wcel cA c1 caddc co cF cfv cr wcel ruclem.0 cA cn wcel
        cA c1 caddc co cn wcel ruclem28.a cA peano2nn ax-mp cn cr cA c1 caddc
        co cF ffvelrn mp2an lttri mpan cA c1 caddc co cF cfv cA c1 caddc co cH
        cfv clt wbr cA c1 caddc co cH cfv cA cH cfv clt wbr cA c1 caddc co cF
        cfv cA cH cfv clt wbr vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 ruclem28.a ruclem27 cA c1 caddc co cF cfv cA
        c1 caddc co cH cfv cA cH cfv cn cr cF wf cA c1 caddc co cn wcel cA c1
        caddc co cF cfv cr wcel ruclem.0 cA cn wcel cA c1 caddc co cn wcel
        ruclem28.a cA peano2nn ax-mp cn cr cA c1 caddc co cF ffvelrn mp2an vx
        vy vz cA c1 caddc co cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
        ruclem.4 cA cn wcel cA c1 caddc co cn wcel ruclem28.a cA peano2nn ax-mp
        ruclem23 vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
        ruclem.4 ruclem28.a ruclem23 lttri mpan2 anim12i con3i pm2.61i $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      $( Lemma for ~ ruc .  At any index ` A ` , the interval between our
         constructed functions ` G ` and ` H ` does not include the
         corresponding value of input function ` F ` .  In other words,
         our constructed functions define, by ~ ruclem26 and ~ ruclem27 , an
         ever-shrinking interval that eventually squeezes out all values
         of ` F ` . $)
      ruclem29 $p |- -. ( ( G ` A ) < ( F ` A ) /\ ( F ` A ) < ( H ` A ) ) $=
        cA cn wcel cA cG cfv cA cF cfv clt wbr cA cF cfv cA cH cfv clt wbr wa
        wn ruclem28.a vw cv cG cfv vw cv cF cfv clt wbr vw cv cF cfv vw cv cH
        cfv clt wbr wa wn c1 cG cfv c1 cF cfv clt wbr c1 cF cfv c1 cH cfv clt
        wbr wa wn vv cv c1 caddc co cG cfv vv cv c1 caddc co cF cfv clt wbr vv
        cv c1 caddc co cF cfv vv cv c1 caddc co cH cfv clt wbr wa wn cA cG cfv
        cA cF cfv clt wbr cA cF cfv cA cH cfv clt wbr wa wn vw vv cA vw cv c1
        wceq vw cv cG cfv vw cv cF cfv clt wbr vw cv cF cfv vw cv cH cfv clt
        wbr wa c1 cG cfv c1 cF cfv clt wbr c1 cF cfv c1 cH cfv clt wbr wa vw cv
        c1 wceq vw cv cG cfv vw cv cF cfv clt wbr c1 cG cfv c1 cF cfv clt wbr
        vw cv cF cfv vw cv cH cfv clt wbr c1 cF cfv c1 cH cfv clt wbr vw cv c1
        wceq vw cv cG cfv c1 cG cfv vw cv cF cfv c1 cF cfv clt vw cv c1 cG
        fveq2 vw cv c1 cF fveq2 breq12d vw cv c1 wceq vw cv cF cfv c1 cF cfv vw
        cv cH cfv c1 cH cfv clt vw cv c1 cF fveq2 vw cv c1 cH fveq2 breq12d
        anbi12d notbid vw cv vv cv c1 caddc co wceq vw cv cG cfv vw cv cF cfv
        clt wbr vw cv cF cfv vw cv cH cfv clt wbr wa vv cv c1 caddc co cG cfv
        vv cv c1 caddc co cF cfv clt wbr vv cv c1 caddc co cF cfv vv cv c1
        caddc co cH cfv clt wbr wa vw cv vv cv c1 caddc co wceq vw cv cG cfv vw
        cv cF cfv clt wbr vv cv c1 caddc co cG cfv vv cv c1 caddc co cF cfv clt
        wbr vw cv cF cfv vw cv cH cfv clt wbr vv cv c1 caddc co cF cfv vv cv c1
        caddc co cH cfv clt wbr vw cv vv cv c1 caddc co wceq vw cv cG cfv vv cv
        c1 caddc co cG cfv vw cv cF cfv vv cv c1 caddc co cF cfv clt vw cv vv
        cv c1 caddc co cG fveq2 vw cv vv cv c1 caddc co cF fveq2 breq12d vw cv
        vv cv c1 caddc co wceq vw cv cF cfv vv cv c1 caddc co cF cfv vw cv cH
        cfv vv cv c1 caddc co cH cfv clt vw cv vv cv c1 caddc co cF fveq2 vw cv
        vv cv c1 caddc co cH fveq2 breq12d anbi12d notbid vw cv cA wceq vw cv
        cG cfv vw cv cF cfv clt wbr vw cv cF cfv vw cv cH cfv clt wbr wa cA cG
        cfv cA cF cfv clt wbr cA cF cfv cA cH cfv clt wbr wa vw cv cA wceq vw
        cv cG cfv vw cv cF cfv clt wbr cA cG cfv cA cF cfv clt wbr vw cv cF cfv
        vw cv cH cfv clt wbr cA cF cfv cA cH cfv clt wbr vw cv cA wceq vw cv cG
        cfv cA cG cfv vw cv cF cfv cA cF cfv clt vw cv cA cG fveq2 vw cv cA cF
        fveq2 breq12d vw cv cA wceq vw cv cF cfv cA cF cfv vw cv cH cfv cA cH
        cfv clt vw cv cA cF fveq2 vw cv cA cH fveq2 breq12d anbi12d notbid c1
        cG cfv c1 cF cfv clt wbr c1 cF cfv c1 cH cfv clt wbr c1 cF cfv c1 cG
        cfv clt wbr c1 cG cfv c1 cF cfv clt wbr wn c1 cF cfv c1 cF cfv c1 caddc
        co c1 cG cfv clt c1 cF cfv cn cr cF wf c1 cn wcel c1 cF cfv cr wcel
        ruclem.0 1nn cn cr c1 cF ffvelrn mp2an ltp1i vx vy vz cC cD cF cG cH
        ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem16 breqtrri c1 cF
        cfv c1 cG cfv cn cr cF wf c1 cn wcel c1 cF cfv cr wcel ruclem.0 1nn cn
        cr c1 cF ffvelrn mp2an vx vy vz c1 cC cD cF cG cH ruclem.0 ruclem.1
        ruclem.2 ruclem.3 ruclem.4 1nn ruclem22 ltnsymi ax-mp intnanr vv cv cn
        wcel vv cv c1 caddc co cG cfv vv cv c1 caddc co cF cfv clt wbr vv cv c1
        caddc co cF cfv vv cv c1 caddc co cH cfv clt wbr wa wn vv cv cn wcel vv
        cv c1 cif c1 caddc co cG cfv vv cv cn wcel vv cv c1 cif c1 caddc co cF
        cfv clt wbr vv cv cn wcel vv cv c1 cif c1 caddc co cF cfv vv cv cn wcel
        vv cv c1 cif c1 caddc co cH cfv clt wbr wa wn vv cv c1 vv cv vv cv cn
        wcel vv cv c1 cif wceq vv cv c1 caddc co cG cfv vv cv c1 caddc co cF
        cfv clt wbr vv cv c1 caddc co cF cfv vv cv c1 caddc co cH cfv clt wbr
        wa vv cv cn wcel vv cv c1 cif c1 caddc co cG cfv vv cv cn wcel vv cv c1
        cif c1 caddc co cF cfv clt wbr vv cv cn wcel vv cv c1 cif c1 caddc co
        cF cfv vv cv cn wcel vv cv c1 cif c1 caddc co cH cfv clt wbr wa vv cv
        vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co cG cfv vv cv c1 caddc
        co cF cfv clt wbr vv cv cn wcel vv cv c1 cif c1 caddc co cG cfv vv cv
        cn wcel vv cv c1 cif c1 caddc co cF cfv clt wbr vv cv c1 caddc co cF
        cfv vv cv c1 caddc co cH cfv clt wbr vv cv cn wcel vv cv c1 cif c1
        caddc co cF cfv vv cv cn wcel vv cv c1 cif c1 caddc co cH cfv clt wbr
        vv cv vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co cG cfv vv cv cn
        wcel vv cv c1 cif c1 caddc co cG cfv vv cv c1 caddc co cF cfv vv cv cn
        wcel vv cv c1 cif c1 caddc co cF cfv clt vv cv vv cv cn wcel vv cv c1
        cif wceq vv cv c1 caddc co vv cv cn wcel vv cv c1 cif c1 caddc co cG vv
        cv vv cv cn wcel vv cv c1 cif c1 caddc opreq1 fveq2d vv cv vv cv cn
        wcel vv cv c1 cif wceq vv cv c1 caddc co vv cv cn wcel vv cv c1 cif c1
        caddc co cF vv cv vv cv cn wcel vv cv c1 cif c1 caddc opreq1 fveq2d
        breq12d vv cv vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co cF cfv
        vv cv cn wcel vv cv c1 cif c1 caddc co cF cfv vv cv c1 caddc co cH cfv
        vv cv cn wcel vv cv c1 cif c1 caddc co cH cfv clt vv cv vv cv cn wcel
        vv cv c1 cif wceq vv cv c1 caddc co vv cv cn wcel vv cv c1 cif c1 caddc
        co cF vv cv vv cv cn wcel vv cv c1 cif c1 caddc opreq1 fveq2d vv cv vv
        cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co vv cv cn wcel vv cv c1
        cif c1 caddc co cH vv cv vv cv cn wcel vv cv c1 cif c1 caddc opreq1
        fveq2d breq12d anbi12d notbid vx vy vz vv cv cn wcel vv cv c1 cif cC cD
        cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 vv cv c1 cn 1nn
        elimel ruclem28 dedth nn1suc ax-mp $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      ${
        ruclem.b $e |- B e. NN $.
        $( Lemma for ~ ruc .  A helper lemma for ~ ruclem32 . $)
        ruclem30 $p |- ( ( G ` A ) < ( G ` ( A + B ) ) ->
                         ( G ` A ) < ( G ` ( A + ( B + 1 ) ) ) ) $=
          cA cG cfv cA cB caddc co cG cfv clt wbr cA cB caddc co cG cfv cA cB
          c1 caddc co caddc co cG cfv clt wbr cA cG cfv cA cB c1 caddc co caddc
          co cG cfv clt wbr cA cB caddc co cG cfv cA cB caddc co c1 caddc co cG
          cfv cA cB c1 caddc co caddc co cG cfv clt vx vy vz cA cB caddc co cC
          cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel
          cB cn wcel cA cB caddc co cn wcel ruclem28.a ruclem.b cA cB nnaddcl
          mp2an ruclem26 cA cB caddc co c1 caddc co cA cB c1 caddc co caddc co
          cG cA cB c1 cA ruclem28.a nncni cB ruclem.b nncni ax1cn addassi
          fveq2i breqtri cA cG cfv cA cB caddc co cG cfv cA cB c1 caddc co
          caddc co cG cfv vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
          ruclem.3 ruclem.4 ruclem28.a ruclem22 vx vy vz cA cB caddc co cC cD
          cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cB
          cn wcel cA cB caddc co cn wcel ruclem28.a ruclem.b cA cB nnaddcl
          mp2an ruclem22 vx vy vz cA cB c1 caddc co caddc co cC cD cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cB c1 caddc
          co cn wcel cA cB c1 caddc co caddc co cn wcel ruclem28.a cB cn wcel
          cB c1 caddc co cn wcel ruclem.b cB peano2nn ax-mp cA cB c1 caddc co
          nnaddcl mp2an ruclem22 lttri mpan2 $.
          $( [18-Oct-2004] $) $( [15-Oct-2004] $)

        $( Lemma for ~ ruc .  A helper lemma for ~ ruclem32 . $)
        ruclem31 $p |- ( ( H ` ( A + B ) ) < ( H ` B ) ->
                         ( H ` ( ( A + 1 ) + B ) ) < ( H ` B ) ) $=
          cA c1 caddc co cB caddc co cH cfv cA cB caddc co cH cfv clt wbr cA cB
          caddc co cH cfv cB cH cfv clt wbr cA c1 caddc co cB caddc co cH cfv
          cB cH cfv clt wbr cA c1 caddc co cB caddc co cH cfv cA cB caddc co c1
          caddc co cH cfv cA cB caddc co cH cfv clt cA c1 caddc co cB caddc co
          cA cB caddc co c1 caddc co cH cA c1 cB cA ruclem28.a nncni ax1cn cB
          ruclem.b nncni add23i fveq2i vx vy vz cA cB caddc co cC cD cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cB cn wcel cA
          cB caddc co cn wcel ruclem28.a ruclem.b cA cB nnaddcl mp2an ruclem27
          eqbrtri cA c1 caddc co cB caddc co cH cfv cA cB caddc co cH cfv cB cH
          cfv vx vy vz cA c1 caddc co cB caddc co cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA c1 caddc co cn wcel cB cn wcel
          cA c1 caddc co cB caddc co cn wcel cA cn wcel cA c1 caddc co cn wcel
          ruclem28.a cA peano2nn ax-mp ruclem.b cA c1 caddc co cB nnaddcl mp2an
          ruclem23 vx vy vz cA cB caddc co cC cD cF cG cH ruclem.0 ruclem.1
          ruclem.2 ruclem.3 ruclem.4 cA cn wcel cB cn wcel cA cB caddc co cn
          wcel ruclem28.a ruclem.b cA cB nnaddcl mp2an ruclem23 vx vy vz cB cC
          cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.b
          ruclem23 lttri mpan $.
          $( [18-Oct-2004] $) $( [15-Oct-2004] $)

        $( Lemma for ~ ruc .  All values of function ` G ` are less than all
           values of function ` H ` . $)
        ruclem32 $p |- ( G ` A ) < ( H ` B ) $=
          cA cG cfv cA cB caddc co cH cfv clt wbr cA cB caddc co cH cfv cB cH
          cfv clt wbr cA cG cfv cB cH cfv clt wbr cA cG cfv cA cB caddc co cG
          cfv clt wbr cA cB caddc co cG cfv cA cB caddc co cH cfv clt wbr cA cG
          cfv cA cB caddc co cH cfv clt wbr cB cn wcel cA cG cfv cA cB caddc co
          cG cfv clt wbr ruclem.b cA cG cfv cA vw cv caddc co cG cfv clt wbr cA
          cG cfv cA c1 caddc co cG cfv clt wbr cA cG cfv cA vv cv caddc co cG
          cfv clt wbr cA cG cfv cA vv cv c1 caddc co caddc co cG cfv clt wbr cA
          cG cfv cA cB caddc co cG cfv clt wbr vw vv cB vw cv c1 wceq cA vw cv
          caddc co cG cfv cA c1 caddc co cG cfv cA cG cfv clt vw cv c1 wceq cA
          vw cv caddc co cA c1 caddc co cG vw cv c1 cA caddc opreq2 fveq2d
          breq2d vw cv vv cv wceq cA vw cv caddc co cG cfv cA vv cv caddc co cG
          cfv cA cG cfv clt vw cv vv cv wceq cA vw cv caddc co cA vv cv caddc
          co cG vw cv vv cv cA caddc opreq2 fveq2d breq2d vw cv vv cv c1 caddc
          co wceq cA vw cv caddc co cG cfv cA vv cv c1 caddc co caddc co cG cfv
          cA cG cfv clt vw cv vv cv c1 caddc co wceq cA vw cv caddc co cA vv cv
          c1 caddc co caddc co cG vw cv vv cv c1 caddc co cA caddc opreq2
          fveq2d breq2d vw cv cB wceq cA vw cv caddc co cG cfv cA cB caddc co
          cG cfv cA cG cfv clt vw cv cB wceq cA vw cv caddc co cA cB caddc co
          cG vw cv cB cA caddc opreq2 fveq2d breq2d vx vy vz cA cC cD cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem28.a ruclem26 vv
          cv cn wcel cA cG cfv cA vv cv caddc co cG cfv clt wbr cA cG cfv cA vv
          cv c1 caddc co caddc co cG cfv clt wbr wi cA cG cfv cA vv cv cn wcel
          vv cv c1 cif caddc co cG cfv clt wbr cA cG cfv cA vv cv cn wcel vv cv
          c1 cif c1 caddc co caddc co cG cfv clt wbr wi vv cv c1 vv cv vv cv cn
          wcel vv cv c1 cif wceq cA cG cfv cA vv cv caddc co cG cfv clt wbr cA
          cG cfv cA vv cv cn wcel vv cv c1 cif caddc co cG cfv clt wbr cA cG
          cfv cA vv cv c1 caddc co caddc co cG cfv clt wbr cA cG cfv cA vv cv
          cn wcel vv cv c1 cif c1 caddc co caddc co cG cfv clt wbr vv cv vv cv
          cn wcel vv cv c1 cif wceq cA vv cv caddc co cG cfv cA vv cv cn wcel
          vv cv c1 cif caddc co cG cfv cA cG cfv clt vv cv vv cv cn wcel vv cv
          c1 cif wceq cA vv cv caddc co cA vv cv cn wcel vv cv c1 cif caddc co
          cG vv cv vv cv cn wcel vv cv c1 cif cA caddc opreq2 fveq2d breq2d vv
          cv vv cv cn wcel vv cv c1 cif wceq cA vv cv c1 caddc co caddc co cG
          cfv cA vv cv cn wcel vv cv c1 cif c1 caddc co caddc co cG cfv cA cG
          cfv clt vv cv vv cv cn wcel vv cv c1 cif wceq cA vv cv c1 caddc co
          caddc co cA vv cv cn wcel vv cv c1 cif c1 caddc co caddc co cG vv cv
          vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co vv cv cn wcel vv cv
          c1 cif c1 caddc co cA caddc vv cv vv cv cn wcel vv cv c1 cif c1 caddc
          opreq1 opreq2d fveq2d breq2d imbi12d vx vy vz cA vv cv cn wcel vv cv
          c1 cif cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
          ruclem28.a vv cv c1 cn 1nn elimel ruclem30 dedth nnind ax-mp vx vy vz
          cA cB caddc co cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
          ruclem.4 cA cn wcel cB cn wcel cA cB caddc co cn wcel ruclem28.a
          ruclem.b cA cB nnaddcl mp2an ruclem25 cA cG cfv cA cB caddc co cG cfv
          cA cB caddc co cH cfv vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1
          ruclem.2 ruclem.3 ruclem.4 ruclem28.a ruclem22 vx vy vz cA cB caddc
          co cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn
          wcel cB cn wcel cA cB caddc co cn wcel ruclem28.a ruclem.b cA cB
          nnaddcl mp2an ruclem22 vx vy vz cA cB caddc co cC cD cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cB cn wcel cA
          cB caddc co cn wcel ruclem28.a ruclem.b cA cB nnaddcl mp2an ruclem23
          lttri mp2an cA cn wcel cA cB caddc co cH cfv cB cH cfv clt wbr
          ruclem28.a vw cv cB caddc co cH cfv cB cH cfv clt wbr c1 cB caddc co
          cH cfv cB cH cfv clt wbr vv cv cB caddc co cH cfv cB cH cfv clt wbr
          vv cv c1 caddc co cB caddc co cH cfv cB cH cfv clt wbr cA cB caddc co
          cH cfv cB cH cfv clt wbr vw vv cA vw cv c1 wceq vw cv cB caddc co cH
          cfv c1 cB caddc co cH cfv cB cH cfv clt vw cv c1 wceq vw cv cB caddc
          co c1 cB caddc co cH vw cv c1 cB caddc opreq1 fveq2d breq1d vw cv vv
          cv wceq vw cv cB caddc co cH cfv vv cv cB caddc co cH cfv cB cH cfv
          clt vw cv vv cv wceq vw cv cB caddc co vv cv cB caddc co cH vw cv vv
          cv cB caddc opreq1 fveq2d breq1d vw cv vv cv c1 caddc co wceq vw cv
          cB caddc co cH cfv vv cv c1 caddc co cB caddc co cH cfv cB cH cfv clt
          vw cv vv cv c1 caddc co wceq vw cv cB caddc co vv cv c1 caddc co cB
          caddc co cH vw cv vv cv c1 caddc co cB caddc opreq1 fveq2d breq1d vw
          cv cA wceq vw cv cB caddc co cH cfv cA cB caddc co cH cfv cB cH cfv
          clt vw cv cA wceq vw cv cB caddc co cA cB caddc co cH vw cv cA cB
          caddc opreq1 fveq2d breq1d c1 cB caddc co cH cfv cB c1 caddc co cH
          cfv cB cH cfv clt c1 cB caddc co cB c1 caddc co cH c1 cB ax1cn cB
          ruclem.b nncni addcomi fveq2i vx vy vz cB cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.b ruclem27 eqbrtri vv cv
          cn wcel vv cv cB caddc co cH cfv cB cH cfv clt wbr vv cv c1 caddc co
          cB caddc co cH cfv cB cH cfv clt wbr wi vv cv cn wcel vv cv c1 cif cB
          caddc co cH cfv cB cH cfv clt wbr vv cv cn wcel vv cv c1 cif c1 caddc
          co cB caddc co cH cfv cB cH cfv clt wbr wi vv cv c1 vv cv vv cv cn
          wcel vv cv c1 cif wceq vv cv cB caddc co cH cfv cB cH cfv clt wbr vv
          cv cn wcel vv cv c1 cif cB caddc co cH cfv cB cH cfv clt wbr vv cv c1
          caddc co cB caddc co cH cfv cB cH cfv clt wbr vv cv cn wcel vv cv c1
          cif c1 caddc co cB caddc co cH cfv cB cH cfv clt wbr vv cv vv cv cn
          wcel vv cv c1 cif wceq vv cv cB caddc co cH cfv vv cv cn wcel vv cv
          c1 cif cB caddc co cH cfv cB cH cfv clt vv cv vv cv cn wcel vv cv c1
          cif wceq vv cv cB caddc co vv cv cn wcel vv cv c1 cif cB caddc co cH
          vv cv vv cv cn wcel vv cv c1 cif cB caddc opreq1 fveq2d breq1d vv cv
          vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co cB caddc co cH cfv
          vv cv cn wcel vv cv c1 cif c1 caddc co cB caddc co cH cfv cB cH cfv
          clt vv cv vv cv cn wcel vv cv c1 cif wceq vv cv c1 caddc co cB caddc
          co vv cv cn wcel vv cv c1 cif c1 caddc co cB caddc co cH vv cv vv cv
          cn wcel vv cv c1 cif wceq vv cv c1 caddc co vv cv cn wcel vv cv c1
          cif c1 caddc co cB caddc vv cv vv cv cn wcel vv cv c1 cif c1 caddc
          opreq1 opreq1d fveq2d breq1d imbi12d vx vy vz vv cv cn wcel vv cv c1
          cif cB cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 vv
          cv c1 cn 1nn elimel ruclem.b ruclem31 dedth nnind ax-mp cA cG cfv cA
          cB caddc co cH cfv cB cH cfv vx vy vz cA cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem28.a ruclem22 vx vy vz cA
          cB caddc co cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
          ruclem.4 cA cn wcel cB cn wcel cA cB caddc co cn wcel ruclem28.a
          ruclem.b cA cB nnaddcl mp2an ruclem23 vx vy vz cB cC cD cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.b ruclem23 lttri
          mp2an $.
          $( [18-Oct-2004] $) $( [15-Oct-2004] $)
      $}
    $}

    $( Lemma for ~ ruc .  The set of values of our constructed function ` G `
       is a non-empty subset of ` RR ` .  This is a helper lemma for theorems
       involving supremum. $)
    ruclem33 $p |- ( ran G C_ RR /\ ran G =/= (/) /\
                     E. w e. RR A. v e. ran G v <_ w ) $=
      cG crn cr wss cG crn c0 wne vv cv vw cv cle wbr vv cG crn wral vw cr wrex
      cn cr cG wf cG crn cr wss vx vy vz cC cD cF cG cH ruclem.0 ruclem.1
      ruclem.2 ruclem.3 ruclem.4 ruclem17 cn cr cG frn ax-mp c1 cG cfv cG crn
      wcel cG crn c0 wne cG cn wfn c1 cn wcel c1 cG cfv cG crn wcel cn cr cG wf
      cG cn wfn vx vy vz cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
      ruclem.4 ruclem17 cn cr cG ffn ax-mp 1nn cn c1 cG fnfvelrn mp2an cG crn
      c1 cG cfv ne0i ax-mp c1 cH cfv cr wcel vv cv c1 cH cfv cle wbr vv cG crn
      wral vv cv vw cv cle wbr vv cG crn wral vw cr wrex vx vy vz c1 cC cD cF
      cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 1nn ruclem23 vv cv c1
      cH cfv cle wbr vv cG crn vv cv cG crn wcel vw cv cG cfv vv cv wceq vw cn
      wrex vv cv c1 cH cfv cle wbr cG cn wfn vv cv cG crn wcel vw cv cG cfv vv
      cv wceq vw cn wrex wb cn cr cG wf cG cn wfn vx vy vz cC cD cF cG cH
      ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem17 cn cr cG ffn ax-mp
      vw cn vv cv cG fvelrnb ax-mp vw cv cG cfv vv cv wceq vv cv c1 cH cfv cle
      wbr vw cn vw cv cG cfv vv cv wceq vw cv cG cfv c1 cH cfv cle wbr vv cv c1
      cH cfv cle wbr vw cv cn wcel vw cv cG cfv vv cv c1 cH cfv cle breq1 vw cv
      cG cfv cr wcel c1 cH cfv cr wcel wa vw cv cG cfv c1 cH cfv clt wbr vw cv
      cG cfv c1 cH cfv cle wbr vw cv cn wcel vw cv cG cfv c1 cH cfv ltle vw cv
      cn wcel vw cv cG cfv cr wcel c1 cH cfv cr wcel vw cv cn wcel vw cv cG cfv
      cr wcel vw cv cn wcel vw cv c1 cif cG cfv cr wcel vw cv c1 vw cv vw cv cn
      wcel vw cv c1 cif wceq vw cv cG cfv vw cv cn wcel vw cv c1 cif cG cfv cr
      vw cv vw cv cn wcel vw cv c1 cif cG fveq2 eleq1d vx vy vz vw cv cn wcel
      vw cv c1 cif cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
      vw cv c1 cn 1nn elimel ruclem22 dedth vx vy vz c1 cC cD cF cG cH ruclem.0
      ruclem.1 ruclem.2 ruclem.3 ruclem.4 1nn ruclem23 jctir vw cv cn wcel vw
      cv cG cfv c1 cH cfv clt wbr vw cv cn wcel vw cv c1 cif cG cfv c1 cH cfv
      clt wbr vw cv c1 vw cv vw cv cn wcel vw cv c1 cif wceq vw cv cG cfv vw cv
      cn wcel vw cv c1 cif cG cfv c1 cH cfv clt vw cv vw cv cn wcel vw cv c1
      cif cG fveq2 breq1d vx vy vz vw cv cn wcel vw cv c1 cif c1 cC cD cF cG cH
      ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 vw cv c1 cn 1nn elimel 1nn
      ruclem32 dedth sylc syl5cbi r19.23aiv sylbi rgen vv cv vw cv cle wbr vv
      cG crn wral vv cv c1 cH cfv cle wbr vv cG crn wral vw c1 cH cfv cr vw cv
      c1 cH cfv wceq vv cv vw cv cle wbr vv cv c1 cH cfv cle wbr vv cG crn vw
      cv c1 cH cfv vv cv cle breq2 ralbidv rcla4ev mp2an 3pm3.2i $.
      $( [17-Jun-2007] $) $( [15-Oct-2004] $)

    ${
      $d w S $.
      ruclem.5 $e |- S = sup ( ran G , RR , < ) $.
      $( Lemma for ~ ruc .  The supremum of the set of values of our
         constructed function ` G ` is a real number. $)
      ruclem34 $p |- S e. RR $=
        cS cG crn cr clt csup cr ruclem.5 vw vv cG crn vx vy vz vw vv cC cD cF
        cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem33 suprclii
        eqeltri $.
        $( [18-Oct-2004] $) $( [15-Oct-2004] $)

      ${
        ruclem.a $e |- A e. NN $.
        $( Lemma for ~ ruc .  The supremum we have constructed lies between
           all values of the ` G ` and ` H ` functions.  Compare ~ ruclem29 ,
           which states the opposite for the input function ` F ` . $)
        ruclem35 $p |- ( ( G ` A ) < S /\ S < ( H ` A ) ) $=
          cA cG cfv cS clt wbr cS cA cH cfv clt wbr cA cG cfv cA c1 caddc co cG
          cfv clt wbr cA c1 caddc co cG cfv cS cle wbr cA cG cfv cS clt wbr vx
          vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
          ruclem.a ruclem26 cA c1 caddc co cG cfv cG crn cr clt csup cS cle cA
          c1 caddc co cG cfv cG crn wcel cA c1 caddc co cG cfv cG crn cr clt
          csup cle wbr cG cn wfn cA c1 caddc co cn wcel cA c1 caddc co cG cfv
          cG crn wcel cn cr cG wf cG cn wfn vx vy vz cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem17 cn cr cG ffn ax-mp cA cn
          wcel cA c1 caddc co cn wcel ruclem.a cA peano2nn ax-mp cn cA c1 caddc
          co cG fnfvelrn mp2an vw vv cG crn cA c1 caddc co cG cfv vx vy vz vw
          vv cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
          ruclem33 suprubii ax-mp ruclem.5 breqtrri cA cG cfv cA c1 caddc co cG
          cfv cS vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
          ruclem.4 ruclem.a ruclem22 vx vy vz cA c1 caddc co cC cD cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cA c1 caddc
          co cn wcel ruclem.a cA peano2nn ax-mp ruclem22 vx vy vz cC cD cS cF
          cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.5 ruclem34
          ltletri mp2an cS cA c1 caddc co cH cfv cle wbr cA c1 caddc co cH cfv
          cA cH cfv clt wbr cS cA cH cfv clt wbr cS cA c1 caddc co cH cfv cle
          wbr cA c1 caddc co cH cfv cS clt wbr wn cA c1 caddc co cH cfv cS clt
          wbr cA c1 caddc co cH cfv cG crn cr clt csup clt wbr cA c1 caddc co
          cH cfv cr wcel cA c1 caddc co cH cfv vu cv clt wbr wn vu cG crn wral
          cA c1 caddc co cH cfv cG crn cr clt csup clt wbr wn vx vy vz cA c1
          caddc co cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
          cA cn wcel cA c1 caddc co cn wcel ruclem.a cA peano2nn ax-mp ruclem23
          cA c1 caddc co cH cfv vu cv clt wbr wn vu cG crn vu cv cG crn wcel vw
          cv cG cfv vu cv wceq vw cn wrex cA c1 caddc co cH cfv vu cv clt wbr
          wn cG cn wfn vu cv cG crn wcel vw cv cG cfv vu cv wceq vw cn wrex wb
          cn cr cG wf cG cn wfn vx vy vz cC cD cF cG cH ruclem.0 ruclem.1
          ruclem.2 ruclem.3 ruclem.4 ruclem17 cn cr cG ffn ax-mp vw cn vu cv cG
          fvelrnb ax-mp vw cv cG cfv vu cv wceq cA c1 caddc co cH cfv vu cv clt
          wbr wn vw cn vw cv cG cfv vu cv wceq cA c1 caddc co cH cfv vw cv cG
          cfv clt wbr wn cA c1 caddc co cH cfv vu cv clt wbr wn vw cv cn wcel
          vw cv cG cfv vu cv wceq cA c1 caddc co cH cfv vw cv cG cfv clt wbr cA
          c1 caddc co cH cfv vu cv clt wbr vw cv cG cfv vu cv cA c1 caddc co cH
          cfv clt breq2 notbid vw cv cG cfv cr wcel cA c1 caddc co cH cfv cr
          wcel wa vw cv cG cfv cA c1 caddc co cH cfv clt wbr cA c1 caddc co cH
          cfv vw cv cG cfv clt wbr wn vw cv cn wcel vw cv cG cfv cA c1 caddc co
          cH cfv ltnsym vw cv cn wcel vw cv cG cfv cr wcel cA c1 caddc co cH
          cfv cr wcel vw cv cn wcel vw cv cG cfv cr wcel vw cv cn wcel vw cv c1
          cif cG cfv cr wcel vw cv c1 vw cv vw cv cn wcel vw cv c1 cif wceq vw
          cv cG cfv vw cv cn wcel vw cv c1 cif cG cfv cr vw cv vw cv cn wcel vw
          cv c1 cif cG fveq2 eleq1d vx vy vz vw cv cn wcel vw cv c1 cif cC cD
          cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 vw cv c1 cn 1nn
          elimel ruclem22 dedth vx vy vz cA c1 caddc co cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cA c1 caddc co cn wcel
          ruclem.a cA peano2nn ax-mp ruclem23 jctir vw cv cn wcel vw cv cG cfv
          cA c1 caddc co cH cfv clt wbr vw cv cn wcel vw cv c1 cif cG cfv cA c1
          caddc co cH cfv clt wbr vw cv c1 vw cv vw cv cn wcel vw cv c1 cif
          wceq vw cv cG cfv vw cv cn wcel vw cv c1 cif cG cfv cA c1 caddc co cH
          cfv clt vw cv vw cv cn wcel vw cv c1 cif cG fveq2 breq1d vx vy vz vw
          cv cn wcel vw cv c1 cif cA c1 caddc co cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 vw cv c1 cn 1nn elimel cA cn wcel
          cA c1 caddc co cn wcel ruclem.a cA peano2nn ax-mp ruclem32 dedth sylc
          syl5cbi r19.23aiv sylbi rgen vw vv vu cG crn cA c1 caddc co cH cfv vx
          vy vz vw vv cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
          ruclem.4 ruclem33 suprnubii mp2an cS cG crn cr clt csup cA c1 caddc
          co cH cfv clt ruclem.5 breq2i mtbir cS cA c1 caddc co cH cfv vx vy vz
          cC cD cS cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
          ruclem.5 ruclem34 vx vy vz cA c1 caddc co cC cD cF cG cH ruclem.0
          ruclem.1 ruclem.2 ruclem.3 ruclem.4 cA cn wcel cA c1 caddc co cn wcel
          ruclem.a cA peano2nn ax-mp ruclem23 lenlti mpbir vx vy vz cA cC cD cF
          cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.a ruclem27
          cS cA c1 caddc co cH cfv cA cH cfv vx vy vz cC cD cS cF cG cH
          ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.5 ruclem34 vx vy
          vz cA c1 caddc co cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
          ruclem.4 cA cn wcel cA c1 caddc co cn wcel ruclem.a cA peano2nn ax-mp
          ruclem23 vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2
          ruclem.3 ruclem.4 ruclem.a ruclem23 lelttri mp2an pm3.2i $.
          $( [18-Oct-2004] $) $( [17-Oct-2004] $)

        $( Lemma for ~ ruc .  No value of ` F ` is equal to the supremum we
           have constructed. $)
        ruclem36 $p |- -. ( F ` A ) = S $=
          cA cF cfv cS wceq cA cG cfv cA cF cfv clt wbr cA cF cfv cA cH cfv clt
          wbr wa vx vy vz cA cC cD cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3
          ruclem.4 ruclem.a ruclem29 cA cF cfv cS wceq cA cG cfv cA cF cfv clt
          wbr cA cF cfv cA cH cfv clt wbr wa cA cG cfv cS clt wbr cS cA cH cfv
          clt wbr wa vx vy vz cA cC cD cS cF cG cH ruclem.0 ruclem.1 ruclem.2
          ruclem.3 ruclem.4 ruclem.5 ruclem.a ruclem35 cA cF cfv cS wceq cA cG
          cfv cA cF cfv clt wbr cA cG cfv cS clt wbr cA cF cfv cA cH cfv clt
          wbr cS cA cH cfv clt wbr cA cF cfv cS cA cG cfv clt breq2 cA cF cfv
          cS cA cH cfv clt breq1 anbi12d mpbiri mto $.
          $( [18-Oct-2004] $) $( [15-Oct-2004] $)
      $}

      $( Lemma for ~ ruc .  If ` F ` is any function that maps ` NN ` into
       ` RR ` , then ` F ` cannot be onto ` RR ` . $)
      ruclem37 $p |- -. F : NN -onto-> RR $=
        cn cr cF wfo cS cF crn wcel cS cF crn wcel vw cv cF cfv cS wceq vw cn
        wrex vw cv cF cfv cS wceq vw cn vw cv cn wcel vw cv cF cfv cS wceq wn
        vw cv cn wcel vw cv c1 cif cF cfv cS wceq wn vw cv c1 vw cv vw cv cn
        wcel vw cv c1 cif wceq vw cv cF cfv cS wceq vw cv cn wcel vw cv c1 cif
        cF cfv cS wceq vw cv vw cv cn wcel vw cv c1 cif wceq vw cv cF cfv vw cv
        cn wcel vw cv c1 cif cF cfv cS vw cv vw cv cn wcel vw cv c1 cif cF
        fveq2 eqeq1d notbid vx vy vz vw cv cn wcel vw cv c1 cif cC cD cS cF cG
        cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4 ruclem.5 vw cv c1 cn
        1nn elimel ruclem36 dedth nrex cF cn wfn cS cF crn wcel vw cv cF cfv cS
        wceq vw cn wrex wb cn cr cF wf cF cn wfn ruclem.0 cn cr cF ffn ax-mp vw
        cn cS cF fvelrnb ax-mp mtbir cn cr cF wfo cr cF crn cS cn cr cF forn vx
        vy vz cC cD cS cF cG cH ruclem.0 ruclem.1 ruclem.2 ruclem.3 ruclem.4
        ruclem.5 ruclem34 syl5eleqr mto $.
        $( [18-Oct-2004] $) $( [13-Oct-2004] $)
    $}
  $}

  ${
    $d F z $.  $d x y z $.
    ruclem38.0 $e |- F : NN --> RR $.
    $( Lemma for ~ ruc .  If ` F ` is any function that maps ` NN ` into
       ` RR ` , then ` F ` cannot be onto ` RR ` .  Using ~ eqid , this lemma
       eliminates those hypotheses of ~ ruclem37 that are no longer needed. $)
    ruclem38 $p |- -. F : NN -onto-> RR $=
      vx vy vz c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn cF cn
      c1 csn cdif cres cun vx cv cr cr cxp wcel vy cv cr wcel wa vz cv vx cv
      c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc
      co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3
      cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop
      cif wceq wa vx vy vz copab2 c1st vx cv cr cr cxp wcel vy cv cr wcel wa vz
      cv vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv
      cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc
      co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop cif wceq wa vx vy vz copab2 c1 c1 cF cfv c1 caddc co c1 cF cfv c2
      caddc co cop cop csn cF cn c1 csn cdif cres cun cseq1 co ccom crn cr clt
      csup cF c1st vx cv cr cr cxp wcel vy cv cr wcel wa vz cv vx cv c1st cfv
      vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
      c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vx
      vy vz copab2 c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn
      cF cn c1 csn cdif cres cun cseq1 co ccom c2nd vx cv cr cr cxp wcel vy cv
      cr wcel wa vz cv vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt
      wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv
      c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv
      c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co
      caddc co c3 cdiv co cop cif wceq wa vx vy vz copab2 c1 c1 cF cfv c1 caddc
      co c1 cF cfv c2 caddc co cop cop csn cF cn c1 csn cdif cres cun cseq1 co
      ccom ruclem38.0 c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop
      csn cF cn c1 csn cdif cres cun eqid vx cv cr cr cxp wcel vy cv cr wcel wa
      vz cv vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy
      cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv
      cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv
      caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3
      cdiv co cop cif wceq wa vx vy vz copab2 eqid c1st vx cv cr cr cxp wcel vy
      cv cr wcel wa vz cv vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv clt
      wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2 vx cv
      c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co vx cv
      c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul co
      caddc co c3 cdiv co cop cif wceq wa vx vy vz copab2 c1 c1 cF cfv c1 caddc
      co c1 cF cfv c2 caddc co cop cop csn cF cn c1 csn cdif cres cun cseq1 co
      ccom eqid c2nd vx cv cr cr cxp wcel vy cv cr wcel wa vz cv vx cv c1st cfv
      vy cv clt wbr vy cv vx cv c2nd cfv clt wbr wa c2 vy cv cmul co vx cv c2nd
      cfv caddc co c3 cdiv co vy cv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv
      co cop c2 vx cv c1st cfv cmul co vx cv c2nd cfv caddc co c3 cdiv co vx cv
      c1st cfv c2 vx cv c2nd cfv cmul co caddc co c3 cdiv co cop cif wceq wa vx
      vy vz copab2 c1 c1 cF cfv c1 caddc co c1 cF cfv c2 caddc co cop cop csn
      cF cn c1 csn cdif cres cun cseq1 co ccom eqid c1st vx cv cr cr cxp wcel
      vy cv cr wcel wa vz cv vx cv c1st cfv vy cv clt wbr vy cv vx cv c2nd cfv
      clt wbr wa c2 vy cv cmul co vx cv c2nd cfv caddc co c3 cdiv co vy cv c2
      vx cv c2nd cfv cmul co caddc co c3 cdiv co cop c2 vx cv c1st cfv cmul co
      vx cv c2nd cfv caddc co c3 cdiv co vx cv c1st cfv c2 vx cv c2nd cfv cmul
      co caddc co c3 cdiv co cop cif wceq wa vx vy vz copab2 c1 c1 cF cfv c1
      caddc co c1 cF cfv c2 caddc co cop cop csn cF cn c1 csn cdif cres cun
      cseq1 co ccom crn cr clt csup eqid ruclem37 $.
      $( [18-Oct-2004] $) $( [13-Oct-2004] $)
  $}

  $( Lemma for ~ ruc .  There is no function that maps ` NN ` onto ` RR ` .
     (Use ~ nex if you want this in the form
     ` -. E. f f : NN -onto-> RR ` .) $)
  ruclem39 $p |- -. F : NN -onto-> RR $=
    cn cr cF wfo cn cr cF wfo wn wi cn cr cF wfo wn cn cr cF wfo cn cr cF wf cn
    cr cF wfo wn cn cr cF fof cn cr cF wf cn cr cF wfo wn cn cr cn cr cF wf cF
    cn cc0 csn cxp cif wfo wn cF cn cc0 csn cxp cF cn cr cF wf cF cn cc0 csn
    cxp cif wceq cn cr cF wfo cn cr cn cr cF wf cF cn cc0 csn cxp cif wfo cn cr
    cF cn cr cF wf cF cn cc0 csn cxp cif foeq1 notbid cn cr cF wf cF cn cc0 csn
    cxp cif cn cr cF cn cc0 csn cxp cn cc0 csn cn cc0 csn cxp wf cc0 csn cr wss
    cn cr cn cc0 csn cxp wf cn cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0
    csn cr wss 0re cc0 cr snssi ax-mp cn cc0 csn cr cn cc0 csn cxp fss mp2an
    elimf ruclem38 dedth syl cn cr cF wfo pm2.01 ax-mp $.
    $( [18-Oct-2004] $) $( [14-Oct-2004] $)

  $( The set of natural numbers is strictly dominated by the set of real
     numbers, i.e. the real numbers are uncountable.  The proof consists of
     lemmas ~ ruclem1 through ~ ruclem39 and this final piece.  Our proof
     is based on the proof of Theorem 5.18 of [Truss] p. 114.  See ~ ruclem39
     for the function existence version of this theorem.  For an informal
     discussion of this proof, see
     ~ http://us.metamath.org/mpegif/mmcomplex.html#uncountable . $)
  ruc $p |- NN ~< RR $=
    cn cr csdm wbr cn cr cdom wbr cn cr cen wbr wn cn cr brsdom cr cvv wcel cn
    cr wss cn cr cdom wbr reex nnssre cn cr cvv ssdom2g mp2 cn cr cen wbr cn cr
    vf cv wf1o vf wex cn cr vf cv wf1o vf cn cr vf cv wf1o cn cr vf cv wfo vf
    cv ruclem39 cn cr vf cv f1ofo mto nex cn cr vf reex bren mtbir mpbir2an $.
    $( [18-Oct-2004] $) $( [13-Oct-2004] $)

  $( The set of rationals is strictly less equinumerous than the set of
     reals ( ` RR ` strictly dominates ` QQ ` ). $)
  resdomq $p |- QQ ~< RR $=
    cq cn cen wbr cn cr csdm wbr cq cr csdm wbr qnnen ruc cq cn cr ensdomtr
    mp2an $.
    $( [20-Dec-2004] $) $( [18-Dec-2004] $)

  $( There are at least aleph-one real numbers. $)
  aleph1re $p |- ( aleph ` 1o ) ~<_ RR $=
    c1o cale cfv cr cdom wbr cr c1o cale cfv csdm wbr wn cr c1o cale cfv csdm
    wbr cr c0 csuc cale cfv csdm wbr c0 cale cfv cr csdm wbr cr c0 csuc cale
    cfv csdm wbr wn c0 cale cfv cn cen wbr cn cr csdm wbr c0 cale cfv cr csdm
    wbr c0 cale cfv com cn cen aleph0 cn com omex nnenom ensymi eqbrtri ruc c0
    cale cfv cn cr ensdomtr mp2an c0 cale cfv cr csdm wbr cr c0 csuc cale cfv
    csdm wbr wn wi c0 cale cfv cr csdm wbr cr c0 csuc cale cfv csdm wbr wa wn
    c0 cr alephnbtwn2 c0 cale cfv cr csdm wbr cr c0 csuc cale cfv csdm wbr
    imnan mpbir ax-mp c1o cale cfv c0 csuc cale cfv cr csdm c1o c0 csuc cale
    df-1o fveq2i breq2i mtbir c1o cale cfv cvv wcel cr cvv wcel c1o cale cfv cr
    cdom wbr cr c1o cale cfv csdm wbr wn wb c1o cale fvex reex c1o cale cfv cr
    cvv cvv domtri mp2an mpbir $.
    $( [3-Feb-2005] $) $( [2-Feb-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Cardinal arithmetic (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    infxpidmlem1.1 $e |- A e. _V $.
    infxpidmlem1.2 $e |- B e. _V $.
    $( Lemma for ~ infxpidm .  An infinite idempotent set ` x ` is equinumerous
       to the union of any two sets ` A ` and ` B ` equinumerous to it. $)
    infxpidmlem1 $p |- ( ( om ~<_ x /\ x ~~ ( x X. x ) ) ->
                     ( ( x ~~ A /\ x ~~ B ) -> x ~~ ( A u. B ) ) ) $=
      c1o vx cv csdm wbr vx cv vx cv vx cv cxp cen wbr vx cv cA cen wbr vx cv
      cB cen wbr wa vx cv cA cB cun cen wbr wi com vx cv cdom wbr c1o vx cv
      csdm wbr vx cv vx cv vx cv cxp cen wbr wa vx cv cA cen wbr vx cv cB cen
      wbr wa vx cv cA cB cun cen wbr vx cv cA cB cun cdom wbr cA cB cun vx cv
      cdom wbr vx cv cA cB cun cen wbr c1o vx cv csdm wbr vx cv vx cv vx cv cxp
      cen wbr wa vx cv cA cen wbr vx cv cB cen wbr wa wa vx cv cA cB cun sbth
      vx cv cA cen wbr vx cv cA cB cun cdom wbr c1o vx cv csdm wbr vx cv vx cv
      vx cv cxp cen wbr wa vx cv cB cen wbr vx cv cA cen wbr cA cA cB cun cdom
      wbr vx cv cA cB cun cdom wbr cA cvv wcel cA cA cB cun wss cA cA cB cun
      cdom wbr infxpidmlem1.1 cA cB ssun1 cA cA cB cun cvv ssdomg mp2 vx cv cA
      cA cB cun endomtr mpan2 ad2antrl cA cB cun cA cB cxp cdom wbr cA cB cxp
      vx cv cen wbr cA cB cun vx cv cdom wbr c1o vx cv csdm wbr vx cv vx cv vx
      cv cxp cen wbr wa vx cv cA cen wbr vx cv cB cen wbr wa wa cA cB cun cA cB
      cxp vx cv domentr c1o vx cv csdm wbr vx cv cA cen wbr vx cv cB cen wbr wa
      cA cB cun cA cB cxp cdom wbr vx cv vx cv vx cv cxp cen wbr c1o vx cv csdm
      wbr vx cv cA cen wbr vx cv cB cen wbr cA cB cun cA cB cxp cdom wbr c1o cA
      csdm wbr c1o cB csdm wbr cA cB cun cA cB cxp cdom wbr c1o vx cv csdm wbr
      vx cv cA cen wbr wa c1o vx cv csdm wbr vx cv cB cen wbr wa cA cB unxpdom
      cA cvv wcel c1o vx cv csdm wbr vx cv cA cen wbr wa c1o cA csdm wbr wi
      infxpidmlem1.1 c1o vx cv cA cvv sdomentr ax-mp cB cvv wcel c1o vx cv csdm
      wbr vx cv cB cen wbr wa c1o cB csdm wbr wi infxpidmlem1.2 c1o vx cv cB
      cvv sdomentr ax-mp syl2an anandis adantlr vx cv vx cv vx cv cxp cen wbr
      vx cv cA cen wbr vx cv cB cen wbr wa cA cB cxp vx cv cen wbr c1o vx cv
      csdm wbr vx cv vx cv vx cv cxp cen wbr vx cv vx cv cxp cA cB cxp cen wbr
      cA cB cxp vx cv cen wbr vx cv cA cen wbr vx cv cB cen wbr wa vx cv vx cv
      vx cv cxp cen wbr vx cv vx cv cxp cA cB cxp cen wbr wa vx cv cA cB cxp
      cen wbr cA cB cxp vx cv cen wbr vx cv vx cv vx cv cxp cA cB cxp entr vx
      cv cA cB cxp cA cB infxpidmlem1.1 infxpidmlem1.2 xpex ensym syl vx cv cA
      vx cv cB vx visset infxpidmlem1.1 vx visset infxpidmlem1.2 xpen sylan2
      adantll sylanc sylanc ex com vx cv cdom wbr c1o com wcel c1o vx cv csdm
      wbr 1onn vx cv c1o vx visset infsdomnn mpan2 sylan $.
      $( [4-Oct-2004] $) $( [15-Sep-2004] $)
  $}

  ${
    $d x y z w f g h v u t A $.  $d x y z w v f g h t B $.
    $d x y z w v f g h t C $.  $d x y z w v u g h H $.
    infxpidmlem.1 $e |- H = { f | ( f = (/) \/ E. t ( ( om ~<_ t /\ t C_ A ) /\
                      f : ( t X. t ) -1-1-onto-> t ) ) } $.
    ${
      infxpidmlem2.2 $e |- B e. _V $.
      $( Lemma for ~ infxpidm .  A necessary and sufficient condition for a
         set ` B ` to belong to ` H ` . $)
      infxpidmlem2 $p |- ( B e. H <-> ( B = (/) \/
        E. x ( ( om ~<_ x /\ x C_ A ) /\ B : ( x X. x ) -1-1-onto-> x ) ) ) $=
        cB cH wcel cB c0 wceq com vt cv cdom wbr vt cv cA wss wa vt cv vt cv
        cxp vt cv cB wf1o wa vt wex wo cB c0 wceq com vx cv cdom wbr vx cv cA
        wss wa vx cv vx cv cxp vx cv cB wf1o wa vx wex wo vf cv c0 wceq com vt
        cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa vt wex
        wo cB c0 wceq com vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv
        cB wf1o wa vt wex wo vf cB cH infxpidmlem2.2 vf cv cB wceq vf cv c0
        wceq cB c0 wceq com vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt
        cv vf cv wf1o wa vt wex com vt cv cdom wbr vt cv cA wss wa vt cv vt cv
        cxp vt cv cB wf1o wa vt wex vf cv cB c0 eqeq1 vf cv cB wceq com vt cv
        cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa com vt cv
        cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv cB wf1o wa vt vf cv cB
        wceq vt cv vt cv cxp vt cv vf cv wf1o vt cv vt cv cxp vt cv cB wf1o com
        vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv cB f1oeq1
        anbi2d exbidv orbi12d infxpidmlem.1 elab2 com vx cv cdom wbr vx cv cA
        wss wa vx cv vx cv cxp vx cv cB wf1o wa vx wex com vt cv cdom wbr vt cv
        cA wss wa vt cv vt cv cxp vt cv cB wf1o wa vt wex cB c0 wceq com vx cv
        cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv cB wf1o wa com vt cv
        cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv cB wf1o wa vx vt vx cv
        vt cv wceq com vx cv cdom wbr vx cv cA wss wa com vt cv cdom wbr vt cv
        cA wss wa vx cv vx cv cxp vx cv cB wf1o vt cv vt cv cxp vt cv cB wf1o
        vx cv vt cv wceq com vx cv cdom wbr com vt cv cdom wbr vx cv cA wss vt
        cv cA wss vx cv vt cv com cdom breq2 vx cv vt cv cA sseq1 anbi12d vx cv
        vt cv wceq vx cv vx cv cxp vx cv cB wf1o vt cv vt cv cxp vx cv cB wf1o
        vt cv vt cv cxp vt cv cB wf1o vx cv vt cv wceq vx cv vx cv cxp vt cv vt
        cv cxp wceq vx cv vx cv cxp vx cv cB wf1o vt cv vt cv cxp vx cv cB wf1o
        wb vx cv vt cv wceq vx cv vx cv cxp vt cv vx cv cxp vt cv vt cv cxp vx
        cv vt cv vx cv xpeq1 vx cv vt cv vt cv xpeq2 eqtrd vx cv vx cv cxp vt
        cv vt cv cxp vx cv cB f1oeq2 syl vx cv vt cv vt cv vt cv cxp cB f1oeq3
        bitrd anbi12d cbvexv orbi2i bitr4i $.
        $( [4-Oct-2004] $) $( [16-Sep-2004] $)

      ${
        $d x D $.
        infxpidmlem3.3 $e |- D e. _V $.
        $( Lemma for ~ infxpidm .  A sufficient condition for a set ` B ` to
           belong to ` H ` . $)
        infxpidmlem3 $p |- ( ( ( om ~<_ D /\ D C_ A ) /\
                         B : ( D X. D ) -1-1-onto-> D ) -> B e. H ) $=
          com cD cdom wbr cD cA wss wa cD cD cxp cD cB wf1o wa com vx cv cdom
          wbr vx cv cA wss wa vx cv vx cv cxp vx cv cB wf1o wa vx wex cB cH
          wcel com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv cB wf1o
          wa com cD cdom wbr cD cA wss wa cD cD cxp cD cB wf1o wa vx cD
          infxpidmlem3.3 vx cv cD wceq com vx cv cdom wbr vx cv cA wss wa com
          cD cdom wbr cD cA wss wa vx cv vx cv cxp vx cv cB wf1o cD cD cxp cD
          cB wf1o vx cv cD wceq com vx cv cdom wbr com cD cdom wbr vx cv cA wss
          cD cA wss vx cv cD com cdom breq2 vx cv cD cA sseq1 anbi12d vx cv cD
          wceq vx cv vx cv cxp vx cv cB wf1o cD cD cxp vx cv cB wf1o cD cD cxp
          cD cB wf1o vx cv cD wceq vx cv vx cv cxp cD cD cxp wceq vx cv vx cv
          cxp vx cv cB wf1o cD cD cxp vx cv cB wf1o wb vx cv cD wceq vx cv vx
          cv cxp cD vx cv cxp cD cD cxp vx cv cD vx cv xpeq1 vx cv cD cD xpeq2
          eqtrd vx cv vx cv cxp cD cD cxp vx cv cB f1oeq2 syl vx cv cD cD cD
          cxp cB f1oeq3 bitrd anbi12d cla4ev com vx cv cdom wbr vx cv cA wss wa
          vx cv vx cv cxp vx cv cB wf1o wa vx wex cB c0 wceq com vx cv cdom wbr
          vx cv cA wss wa vx cv vx cv cxp vx cv cB wf1o wa vx wex wo cB cH wcel
          com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv cB wf1o wa
          vx wex cB c0 wceq olc vx vt cA cB vf cH infxpidmlem.1 infxpidmlem2.2
          infxpidmlem2 sylibr syl $.
          $( [4-Oct-2004] $) $( [16-Sep-2004] $)
      $}
    $}

    $( Lemma for ~ infxpidm .  The domain of a member of ` H` is the cross
       product of its range. $)
    infxpidmlem4 $p |- ( g e. H -> dom g = ( ran g X. ran g ) ) $=
      vg cv cH wcel vg cv c0 wceq com vx cv cdom wbr vx cv cA wss wa vx cv vx
      cv cxp vx cv vg cv wf1o wa vx wex wo vg cv cdm vg cv crn vg cv crn cxp
      wceq vx vt cA vg cv vf cH infxpidmlem.1 vg visset infxpidmlem2 vg cv c0
      wceq vg cv cdm vg cv crn vg cv crn cxp wceq com vx cv cdom wbr vx cv cA
      wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx wex vg cv c0 wceq c0 cdm c0
      vg cv cdm vg cv crn vg cv crn cxp dm0 vg cv c0 dmeq vg cv c0 wceq vg cv
      crn vg cv crn cxp vg cv crn c0 cxp c0 vg cv c0 wceq vg cv crn c0 wceq vg
      cv crn vg cv crn cxp vg cv crn c0 cxp wceq vg cv c0 wceq vg cv crn c0 crn
      c0 vg cv c0 rneq rn0 syl6eq vg cv crn c0 vg cv crn xpeq2 syl vg cv crn
      xp0 syl6eq 3eqtr4a com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx
      cv vg cv wf1o wa vg cv cdm vg cv crn vg cv crn cxp wceq vx vx cv vx cv
      cxp vx cv vg cv wf1o vg cv cdm vg cv crn vg cv crn cxp wceq com vx cv
      cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o vg cv vx cv vx
      cv cxp wfn vg cv ccnv wfun vg cv crn vx cv wceq w3a vg cv cdm vg cv crn
      vg cv crn cxp wceq vx cv vx cv cxp vx cv vg cv dff1o2 vg cv vx cv vx cv
      cxp wfn vg cv crn vx cv wceq vg cv cdm vg cv crn vg cv crn cxp wceq vg cv
      ccnv wfun vg cv vx cv vx cv cxp wfn vg cv crn vx cv wceq vg cv cdm vx cv
      vx cv cxp vg cv crn vg cv crn cxp vx cv vx cv cxp vg cv fndm vg cv crn vx
      cv wceq vg cv crn vg cv crn cxp vx cv vg cv crn cxp vx cv vx cv cxp vg cv
      crn vx cv vg cv crn xpeq1 vg cv crn vx cv vx cv xpeq2 eqtr2d sylan9eq
      3adant2 sylbi adantl 19.23aiv jaoi sylbi $.
      $( [4-Oct-2004] $) $( [11-Sep-2004] $)

    $( Lemma for ~ infxpidm .  Two members in the range of a member of a subset
       of ` H ` form an ordered pair belonging to the domain of the union
       of the subset. $)
    infxpidmlem5 $p |- ( ( C C_ H /\ g e. C ) ->
             ( ( y e. ran g /\ z e. ran g ) -> <. y , z >. e. dom U. C ) ) $=
      cC cH wss vg cv cC wcel wa vy cv vg cv crn wcel vz cv vg cv crn wcel wa
      vy cv vz cv cop vg cv cdm wcel vy cv vz cv cop cC cuni cdm wcel cC cH wss
      vg cv cC wcel wa vy cv vz cv cop vg cv cdm wcel vy cv vz cv cop vg cv crn
      vg cv crn cxp wcel vy cv vg cv crn wcel vz cv vg cv crn wcel wa cC cH wss
      vg cv cC wcel wa vg cv cdm vg cv crn vg cv crn cxp vy cv vz cv cop cC cH
      wss vg cv cC wcel wa vg cv cH wcel vg cv cdm vg cv crn vg cv crn cxp wceq
      cC cH vg cv ssel2 vt cA vf vg cH infxpidmlem.1 infxpidmlem4 syl eleq2d vy
      cv vz cv vg cv crn vg cv crn vz visset opelxp syl6bb vg cv cC wcel vy cv
      vz cv cop vg cv cdm wcel vy cv vz cv cop cC cuni cdm wcel wi cC cH wss vg
      cv cC wcel vg cv cdm cC cuni cdm vy cv vz cv cop vg cv cC wcel vg cv cdm
      vg cC vg cv cdm ciun cC cuni cdm vg cC vg cv cdm ssiun2 vg cC dmuni
      syl6ssr sseld adantl sylbird $.
      $( [4-Oct-2004] $) $( [11-Sep-2004] $)

    ${
      infxpidmlem6.2 $e |- B = ran U. C $.
      $( Lemma for ~ infxpidm .  A simple but frequently used fact. $)
      infxpidmlem6 $p |- ( y e. B <-> E. g e. C y e. ran g ) $=
        vy cv cB wcel vy cv vg cC vg cv crn ciun wcel vy cv vg cv crn wcel vg
        cC wrex cB vg cC vg cv crn ciun vy cv cB cC cuni crn vg cC vg cv crn
        ciun infxpidmlem6.2 vg cC rnuni eqtri eleq2i vg vy cv cC vg cv crn
        eliun bitri $.
        $( [4-Oct-2004] $) $( [12-Sep-2004] $)

      $( Lemma for ~ infxpidm .  The union of a collection ` C ` of chains in
         ` H ` is a bijection. $)
      infxpidmlem7 $p |- ( ( C C_ H /\
                         A. g e. C A. h e. C ( g C_ h \/ h C_ g ) ) ->
                         U. C : ( B X. B ) -1-1-onto-> B ) $=
        cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa
        cC cuni cB cB cxp wfn cC cuni ccnv wfun wa cC cuni crn cB wceq wa cB cB
        cxp cB cC cuni wf1o cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC
        wral vg cC wral wa cC cuni cB cB cxp wfn cC cuni ccnv wfun wa cC cuni
        crn cB wceq cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg
        cC wral wa cC cuni wfun cC cuni ccnv wfun wa cC cuni cdm cB cB cxp wceq
        wa cC cuni cB cB cxp wfn cC cuni ccnv wfun wa cC cH wss vg cv vh cv wss
        vh cv vg cv wss wo vh cC wral vg cC wral wa cC cuni wfun cC cuni ccnv
        wfun wa cC cuni cdm cB cB cxp wceq vg cv wfun vg cv ccnv wfun wa vg cC
        wral vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral cC cuni
        wfun cC cuni ccnv wfun wa cC cH wss vg cv wfun vg cv ccnv wfun wa vg cC
        wral vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa vg cv
        wfun vg cv ccnv wfun wa vg cv vh cv wss vh cv vg cv wss wo vh cC wral
        wa vg cC wral cC cuni wfun cC cuni ccnv wfun wa vg cv wfun vg cv ccnv
        wfun wa vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC r19.26 cC
        vg vh fun11uni sylbir cC cH wss vg cv wfun vg cv ccnv wfun wa vg cC cC
        cH wss vg cv cC wcel vg cv cH wcel vg cv wfun vg cv ccnv wfun wa cC cH
        vg cv ssel vg cv cH wcel vg cv c0 wceq com vx cv cdom wbr vx cv cA wss
        wa vx cv vx cv cxp vx cv vg cv wf1o wa vx wex wo vg cv wfun vg cv ccnv
        wfun wa vx vt cA vg cv vf cH infxpidmlem.1 vg visset infxpidmlem2 vg cv
        c0 wceq vg cv wfun vg cv ccnv wfun wa com vx cv cdom wbr vx cv cA wss
        wa vx cv vx cv cxp vx cv vg cv wf1o wa vx wex vg cv c0 wceq c0 c0 vg cv
        wf1 vg cv wfun vg cv ccnv wfun wa vg cv c0 wceq c0 c0 vg cv wf1 c0 c0
        c0 wf1 c0 f10 c0 c0 vg cv c0 f1eq1 mpbiri c0 c0 vg cv wf1 c0 c0 vg cv
        wf vg cv ccnv wfun wa vg cv wfun vg cv ccnv wfun wa c0 c0 vg cv df-f1
        c0 c0 vg cv wf vg cv wfun vg cv ccnv wfun c0 c0 vg cv ffun anim1i sylbi
        syl com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o
        wa vg cv wfun vg cv ccnv wfun wa vx vx cv vx cv cxp vx cv vg cv wf1o vg
        cv wfun vg cv ccnv wfun wa com vx cv cdom wbr vx cv cA wss wa vx cv vx
        cv cxp vx cv vg cv wf1o vx cv vx cv cxp vx cv vg cv wf1 vg cv wfun vg
        cv ccnv wfun wa vx cv vx cv cxp vx cv vg cv f1of1 vx cv vx cv cxp vx cv
        vg cv wf1 vx cv vx cv cxp vx cv vg cv wf vg cv ccnv wfun wa vg cv wfun
        vg cv ccnv wfun wa vx cv vx cv cxp vx cv vg cv df-f1 vx cv vx cv cxp vx
        cv vg cv wf vg cv wfun vg cv ccnv wfun vx cv vx cv cxp vx cv vg cv ffun
        anim1i sylbi syl adantl 19.23aiv jaoi sylbi syl6 r19.21aiv sylan cC cH
        wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa cC cuni
        cdm cB cB cxp cC cH wss cC cuni cdm cB cB cxp wss vg cv vh cv wss vh cv
        vg cv wss wo vh cC wral vg cC wral cC cH wss vy cC cuni cdm cB cB cxp
        cC cH wss vy cv vg cv cdm wcel vg cC wrex vy cv cB cB cxp wcel vy cv cC
        cuni cdm wcel cC cH wss vy cv vg cv cdm wcel vy cv cB cB cxp wcel vg cC
        cC cH wss vg cv cC wcel wa vg cv cdm cB cB cxp vy cv cC cH wss vg cv cC
        wcel wa vg cv cdm vg cv crn vg cv crn cxp cB cB cxp cC cH wss vg cv cC
        wcel wa vg cv cH wcel vg cv cdm vg cv crn vg cv crn cxp wceq cC cH vg
        cv ssel2 vt cA vf vg cH infxpidmlem.1 infxpidmlem4 syl vg cv cC wcel vg
        cv crn vg cv crn cxp cB cB cxp wss cC cH wss vg cv cC wcel vg cv crn cB
        wss vg cv crn vg cv crn cxp cB cB cxp wss vg cv cC wcel vy vg cv crn cB
        vg cv cC wcel vy cv vg cv crn wcel vy cv cB wcel vg cv cC wcel vy cv vg
        cv crn wcel wa vy cv vg cv crn wcel vg cC wrex vy cv cB wcel vy cv vg
        cv crn wcel vg cC ra4e vy vt cA cB cC vf vg cH infxpidmlem.1
        infxpidmlem6.2 infxpidmlem6 sylibr ex ssrdv vg cv crn cB wss vg cv crn
        vg cv crn cxp cB cB cxp wss vg cv crn cB vg cv crn cB ssxp anidms syl
        adantl eqsstrd sseld r19.23adva vy cv cC cuni cdm wcel vy cv vg cC vg
        cv cdm ciun wcel vy cv vg cv cdm wcel vg cC wrex cC cuni cdm vg cC vg
        cv cdm ciun vy cv vg cC dmuni eleq2i vg vy cv cC vg cv cdm eliun bitri
        syl5ib ssrdv adantr cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC
        wral vg cC wral wa vy vz cB cB cxp cC cuni cdm cB cB cxp wrel cC cH wss
        vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa cB cB relxp
        a1i cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral
        wa vy cv vw cv crn wcel vz cv vv cv crn wcel wa vv cC wrex vw cC wrex
        vy cv vz cv cop cC cuni cdm wcel vy cv vz cv cop cB cB cxp wcel cC cH
        wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa vy cv
        vw cv crn wcel vz cv vv cv crn wcel wa vy cv vz cv cop cC cuni cdm wcel
        vw vv cC cC cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg
        cC wral vw cv cC wcel vv cv cC wcel wa vy cv vw cv crn wcel vz cv vv cv
        crn wcel wa vy cv vz cv cop cC cuni cdm wcel wi wi vw cv cC wcel vv cv
        cC wcel wa vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral cC
        cH wss vy cv vw cv crn wcel vz cv vv cv crn wcel wa vy cv vz cv cop cC
        cuni cdm wcel wi vw cv cC wcel vv cv cC wcel wa vg cv vh cv wss vh cv
        vg cv wss wo vh cC wral vg cC wral vw cv vv cv wss vv cv vw cv wss wo
        cC cH wss vy cv vw cv crn wcel vz cv vv cv crn wcel wa vy cv vz cv cop
        cC cuni cdm wcel wi wi vg cv vh cv wss vh cv vg cv wss wo vw cv vv cv
        wss vv cv vw cv wss wo vw cv vh cv wss vh cv vw cv wss wo vg vh vw cv
        vv cv cC cC vg cv vw cv wceq vg cv vh cv wss vw cv vh cv wss vh cv vg
        cv wss vh cv vw cv wss vg cv vw cv vh cv sseq1 vg cv vw cv vh cv sseq2
        orbi12d vh cv vv cv wceq vw cv vh cv wss vw cv vv cv wss vh cv vw cv
        wss vv cv vw cv wss vh cv vv cv vw cv sseq2 vh cv vv cv vw cv sseq1
        orbi12d rcla42v cC cH wss vw cv cC wcel vv cv cC wcel wa vw cv vv cv
        wss vv cv vw cv wss wo vy cv vw cv crn wcel vz cv vv cv crn wcel wa vy
        cv vz cv cop cC cuni cdm wcel wi cC cH wss vw cv cC wcel vv cv cC wcel
        wa vw cv vv cv wss vv cv vw cv wss wo vy cv vw cv crn wcel vz cv vv cv
        crn wcel wa vy cv vz cv cop cC cuni cdm wcel wi wi cC cH wss vw cv cC
        wcel vv cv cC wcel wa wa vw cv vv cv wss vy cv vw cv crn wcel vz cv vv
        cv crn wcel wa vy cv vz cv cop cC cuni cdm wcel wi vv cv vw cv wss cC
        cH wss vv cv cC wcel vw cv vv cv wss vy cv vw cv crn wcel vz cv vv cv
        crn wcel wa vy cv vz cv cop cC cuni cdm wcel wi wi vw cv cC wcel vw cv
        vv cv wss vy cv vw cv crn wcel vz cv vv cv crn wcel wa vy cv vv cv crn
        wcel vz cv vv cv crn wcel wa cC cH wss vv cv cC wcel wa vy cv vz cv cop
        cC cuni cdm wcel vw cv vv cv wss vy cv vw cv crn wcel vy cv vv cv crn
        wcel vz cv vv cv crn wcel vw cv vv cv wss vw cv crn vv cv crn vy cv vw
        cv vv cv rnss sseld anim1d vy vz vt cA cC vf vv cH infxpidmlem.1
        infxpidmlem5 syl9r adantrl cC cH wss vw cv cC wcel vv cv vw cv wss vy
        cv vw cv crn wcel vz cv vv cv crn wcel wa vy cv vz cv cop cC cuni cdm
        wcel wi wi vv cv cC wcel vv cv vw cv wss vy cv vw cv crn wcel vz cv vv
        cv crn wcel wa vy cv vw cv crn wcel vz cv vw cv crn wcel wa cC cH wss
        vw cv cC wcel wa vy cv vz cv cop cC cuni cdm wcel vv cv vw cv wss vz cv
        vv cv crn wcel vz cv vw cv crn wcel vy cv vw cv crn wcel vv cv vw cv
        wss vv cv crn vw cv crn vz cv vv cv vw cv rnss sseld anim2d vy vz vt cA
        cC vf vw cH infxpidmlem.1 infxpidmlem5 syl9r adantrr jaod ex com3l syld
        com13 imp r19.23advv vy cv cB wcel vz cv cB wcel wa vy cv vw cv crn
        wcel vw cC wrex vz cv vv cv crn wcel vv cC wrex wa vy cv vz cv cop cB
        cB cxp wcel vy cv vw cv crn wcel vz cv vv cv crn wcel wa vv cC wrex vw
        cC wrex vy cv cB wcel vy cv vw cv crn wcel vw cC wrex vz cv cB wcel vz
        cv vv cv crn wcel vv cC wrex vy vt cA cB cC vf vw cH infxpidmlem.1
        infxpidmlem6.2 infxpidmlem6 vz vt cA cB cC vf vv cH infxpidmlem.1
        infxpidmlem6.2 infxpidmlem6 anbi12i vy cv vz cv cB cB vz visset opelxp
        vy cv vw cv crn wcel vz cv vv cv crn wcel vw vv cC cC reeanv 3bitr4i
        syl5ib relssdv eqssd jca cC cuni wfun cC cuni ccnv wfun wa cC cuni cdm
        cB cB cxp wceq wa cC cuni wfun cC cuni cdm cB cB cxp wceq wa cC cuni
        ccnv wfun wa cC cuni cB cB cxp wfn cC cuni ccnv wfun wa cC cuni wfun cC
        cuni ccnv wfun cC cuni cdm cB cB cxp wceq an23 cC cuni cB cB cxp wfn cC
        cuni wfun cC cuni cdm cB cB cxp wceq wa cC cuni ccnv wfun cC cuni cB cB
        cxp df-fn anbi1i bitr4i sylib cB cC cuni crn infxpidmlem6.2 eqcomi
        jctir cB cB cxp cB cC cuni wf1o cC cuni cB cB cxp wfn cC cuni ccnv wfun
        cC cuni crn cB wceq w3a cC cuni cB cB cxp wfn cC cuni ccnv wfun wa cC
        cuni crn cB wceq wa cB cB cxp cB cC cuni dff1o2 cC cuni cB cB cxp wfn
        cC cuni ccnv wfun cC cuni crn cB wceq df-3an bitri sylibr $.
        $( [5-Oct-2004] $) $( [11-Sep-2004] $)

      ${
        infxpidmlem8.3 $e |- C e. _V $.
        $( Lemma for ~ infxpidm .  The union of a collection of chains ` C ` in
           the collection of bijections ` H ` belongs to ` H ` .  This property
           will be needed to apply Zorn's Lemma in ~ infxpidmlem9 . $)
        infxpidmlem8 $p |- ( ( C C_ H /\
                   A. g e. C A. h e. C ( g C_ h \/ h C_ g ) ) -> U. C e. H ) $=
          cC cH wss vg cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa
          cC cuni c0 wceq cC cuni cH wcel cC cH wss vg cv vh cv wss vh cv vg cv
          wss wo vh cC wral vg cC wral wa cC cuni c0 wceq wn com cB cdom wbr cB
          cA wss wa cB cB cxp cB cC cuni wf1o wa cC cuni cH wcel cC cH wss vg
          cv vh cv wss vh cv vg cv wss wo vh cC wral vg cC wral wa cC cuni c0
          wceq wn com cB cdom wbr cB cA wss wa cB cB cxp cB cC cuni wf1o cC cH
          wss cC cuni c0 wceq wn com cB cdom wbr cB cA wss wa wi vg cv vh cv
          wss vh cv vg cv wss wo vh cC wral vg cC wral cC cH wss cC cuni c0
          wceq wn com cB cdom wbr cB cA wss cC cH wss vg cv c0 wceq wn vg cC
          wrex com cB cdom wbr cC cuni c0 wceq wn cC cH wss vg cv c0 wceq wn
          com cB cdom wbr vg cC cC cH wss vg cv cC wcel wa vg cv c0 wceq wn com
          vg cv crn cdom wbr vg cv crn cA wss wa com cB cdom wbr cC cH wss vg
          cv cC wcel wa vg cv cH wcel vg cv c0 wceq wn com vg cv crn cdom wbr
          vg cv crn cA wss wa wi cC cH vg cv ssel2 vg cv cH wcel vg cv c0 wceq
          wn com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv
          wf1o wa vx wex com vg cv crn cdom wbr vg cv crn cA wss wa vg cv cH
          wcel vg cv c0 wceq com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp
          vx cv vg cv wf1o wa vx wex vg cv cH wcel vg cv c0 wceq com vx cv cdom
          wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx wex wo vx
          vt cA vg cv vf cH infxpidmlem.1 vg visset infxpidmlem2 biimpi ord com
          vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx
          wex vx cv vg cv crn wceq com vx cv cdom wbr vx cv cA wss wa wa vx wex
          com vg cv crn cdom wbr vg cv crn cA wss wa com vx cv cdom wbr vx cv
          cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vg cv crn wceq
          com vx cv cdom wbr vx cv cA wss wa wa vx vx cv vx cv cxp vx cv vg cv
          wf1o com vx cv cdom wbr vx cv cA wss wa vx cv vg cv crn wceq com vx
          cv cdom wbr vx cv cA wss wa wa vx cv vx cv cxp vx cv vg cv wf1o vx cv
          vg cv crn wceq com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx
          cv vg cv wf1o vg cv crn vx cv vx cv vx cv cxp vx cv vg cv wf1o vx cv
          vx cv cxp vx cv vg cv wfo vg cv crn vx cv wceq vx cv vx cv cxp vx cv
          vg cv f1ofo vx cv vx cv cxp vx cv vg cv forn syl eqcomd anim1i ancoms
          19.22i com vx cv cdom wbr vx cv cA wss wa com vg cv crn cdom wbr vg
          cv crn cA wss wa vx vg cv crn vg cv vg visset rnex vx cv vg cv crn
          wceq com vx cv cdom wbr com vg cv crn cdom wbr vx cv cA wss vg cv crn
          cA wss vx cv vg cv crn com cdom breq2 vx cv vg cv crn cA sseq1
          anbi12d ceqsexv sylib syl6 syl cC cH wss vg cv cC wcel wa com vg cv
          crn cdom wbr com cB cdom wbr vg cv crn cA wss vg cv cC wcel com vg cv
          crn cdom wbr com cB cdom wbr wi cC cH wss com vg cv crn cdom wbr vg
          cv cC wcel com cB cdom wbr com vg cv crn cdom wbr vg cv crn cB cdom
          wbr com cB cdom wbr vg cv cC wcel com vg cv crn cB domtr vg cv cC
          wcel vg cv crn cB wss vg cv crn cB cdom wbr vg cv cC wcel vy vg cv
          crn cB vg cv cC wcel vy cv vg cv crn wcel vy cv cB wcel vg cv cC wcel
          vy cv vg cv crn wcel wa vy cv vg cv crn wcel vg cC wrex vy cv cB wcel
          vy cv vg cv crn wcel vg cC ra4e vy vt cA cB cC vf vg cH infxpidmlem.1
          infxpidmlem6.2 infxpidmlem6 sylibr ex ssrdv vg cv crn cvv wcel vg cv
          crn cB wss vg cv crn cB cdom wbr wi vg cv vg visset rnex vg cv crn cB
          cvv ssdomg ax-mp syl sylan2 expcom adantl adantrd syld r19.23adva cC
          cuni c0 wceq wn vg cv c0 wceq vg cC wral wn vg cv c0 wceq wn vg cC
          wrex cC cuni c0 wceq vg cv c0 wceq vg cC wral cC cuni c0 wceq cC c0
          csn wss vg cv c0 csn wcel vg cC wral vg cv c0 wceq vg cC wral cC
          uni0b vg cC c0 csn dfss3 vg cv c0 csn wcel vg cv c0 wceq vg cC vg c0
          elsn ralbii 3bitri notbii vg cv c0 wceq vg cC rexnal bitr4i syl5ib cC
          cH wss vy cB cA cC cH wss vy cv vg cv crn wcel vg cC wrex vy cv cA
          wcel vy cv cB wcel cC cH wss vy cv vg cv crn wcel vy cv cA wcel vg cC
          cC cH wss vg cv cC wcel wa vg cv crn cA vy cv cC cH wss vg cv cC wcel
          wa vg cv c0 wceq vg cv crn cA wss cC cH wss vg cv cC wcel wa vg cv c0
          wceq wn com vg cv crn cdom wbr vg cv crn cA wss wa vg cv crn cA wss
          cC cH wss vg cv cC wcel wa vg cv cH wcel vg cv c0 wceq wn com vg cv
          crn cdom wbr vg cv crn cA wss wa wi cC cH vg cv ssel2 vg cv cH wcel
          vg cv c0 wceq wn com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp
          vx cv vg cv wf1o wa vx wex com vg cv crn cdom wbr vg cv crn cA wss wa
          vg cv cH wcel vg cv c0 wceq com vx cv cdom wbr vx cv cA wss wa vx cv
          vx cv cxp vx cv vg cv wf1o wa vx wex vg cv cH wcel vg cv c0 wceq com
          vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx
          wex wo vx vt cA vg cv vf cH infxpidmlem.1 vg visset infxpidmlem2
          biimpi ord com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv
          vg cv wf1o wa vx wex vx cv vg cv crn wceq com vx cv cdom wbr vx cv cA
          wss wa wa vx wex com vg cv crn cdom wbr vg cv crn cA wss wa com vx cv
          cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vg
          cv crn wceq com vx cv cdom wbr vx cv cA wss wa wa vx vx cv vx cv cxp
          vx cv vg cv wf1o com vx cv cdom wbr vx cv cA wss wa vx cv vg cv crn
          wceq com vx cv cdom wbr vx cv cA wss wa wa vx cv vx cv cxp vx cv vg
          cv wf1o vx cv vg cv crn wceq com vx cv cdom wbr vx cv cA wss wa vx cv
          vx cv cxp vx cv vg cv wf1o vg cv crn vx cv vx cv vx cv cxp vx cv vg
          cv wf1o vx cv vx cv cxp vx cv vg cv wfo vg cv crn vx cv wceq vx cv vx
          cv cxp vx cv vg cv f1ofo vx cv vx cv cxp vx cv vg cv forn syl eqcomd
          anim1i ancoms 19.22i com vx cv cdom wbr vx cv cA wss wa com vg cv crn
          cdom wbr vg cv crn cA wss wa vx vg cv crn vg cv vg visset rnex vx cv
          vg cv crn wceq com vx cv cdom wbr com vg cv crn cdom wbr vx cv cA wss
          vg cv crn cA wss vx cv vg cv crn com cdom breq2 vx cv vg cv crn cA
          sseq1 anbi12d ceqsexv sylib syl6 syl com vg cv crn cdom wbr vg cv crn
          cA wss pm3.27 syl6 vg cv c0 wceq vg cv crn c0 cA vg cv c0 wceq vg cv
          crn c0 crn c0 vg cv c0 rneq rn0 syl6eq c0 cA wss vg cv c0 wceq cA 0ss
          a1i eqsstrd pm2.61d2 sseld r19.23adva vy vt cA cB cC vf vg cH
          infxpidmlem.1 infxpidmlem6.2 infxpidmlem6 syl5ib ssrdv jctird adantr
          vt cA cB cC vf vg vh cH infxpidmlem.1 infxpidmlem6.2 infxpidmlem7
          jctird vt cA cC cuni cB vf cH infxpidmlem.1 cC infxpidmlem8.3 uniex
          cB cC cuni crn cvv infxpidmlem6.2 cC cuni cC infxpidmlem8.3 uniex
          rnex eqeltri infxpidmlem3 syl6 cC cuni c0 wceq cC cuni c0 wceq com vx
          cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv cC cuni wf1o wa vx
          wex wo cC cuni cH wcel cC cuni c0 wceq com vx cv cdom wbr vx cv cA
          wss wa vx cv vx cv cxp vx cv cC cuni wf1o wa vx wex orc vx vt cA cC
          cuni vf cH infxpidmlem.1 cC infxpidmlem8.3 uniex infxpidmlem2 sylibr
          pm2.61d2 $.
          $( [5-Oct-2004] $) $( [12-Sep-2004] $)
      $}
    $}

    ${
      infxpidmlem.2 $e |- A e. _V $.
      $( Lemma for ~ infxpidm .  By Zorn's Lemma ~ zorn , the collection ` H `
         (which we show here to be a set) has a maximal element. $)
      infxpidmlem9 $p |- E. g e. H A. h e. H -. g C. h $=
        vz cv cH wss vg cv vh cv wss vh cv vg cv wss wo vh vz cv wral vg vz cv
        wral wa vz cv cuni cH wcel wi vg cv vh cv wpss wn vh cH wral vg cH wrex
        vz vg vh vz cH cH vf cv c0 wceq vf cab com vt cv cdom wbr vt cv cA wss
        wa vt cv vt cv cxp vt cv vf cv wf1o wa vt wex vf cab cun cvv cH vf cv
        c0 wceq com vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv
        wf1o wa vt wex wo vf cab vf cv c0 wceq vf cab com vt cv cdom wbr vt cv
        cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa vt wex vf cab cun
        infxpidmlem.1 vf cv c0 wceq com vt cv cdom wbr vt cv cA wss wa vt cv vt
        cv cxp vt cv vf cv wf1o wa vt wex vf unab eqtr4i vf cv c0 wceq vf cab
        com vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa
        vt wex vf cab c0 csn vf cv c0 wceq vf cab cvv vf c0 df-sn p0ex eqeltrri
        com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa vt cA cpw wrex
        vf cab com vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv
        wf1o wa vt wex vf cab cvv com vt cv cdom wbr vt cv vt cv cxp vt cv vf
        cv wf1o wa vt cA cpw wrex com vt cv cdom wbr vt cv cA wss wa vt cv vt
        cv cxp vt cv vf cv wf1o wa vt wex vf com vt cv cdom wbr vt cv vt cv cxp
        vt cv vf cv wf1o wa vt cA cpw wrex vt cv cA cpw wcel com vt cv cdom wbr
        vt cv vt cv cxp vt cv vf cv wf1o wa wa vt wex com vt cv cdom wbr vt cv
        cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa vt wex com vt cv cdom wbr
        vt cv vt cv cxp vt cv vf cv wf1o wa vt cA cpw df-rex vt cv cA cpw wcel
        com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa wa com vt cv
        cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa vt vt cv
        cA cpw wcel com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa wa
        vt cv cA wss com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa wa
        com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa vt cv cA wss wa
        com vt cv cdom wbr vt cv cA wss wa vt cv vt cv cxp vt cv vf cv wf1o wa
        vt cv cA cpw wcel vt cv cA wss com vt cv cdom wbr vt cv vt cv cxp vt cv
        vf cv wf1o wa vt cv cA vt visset elpw anbi1i vt cv cA wss com vt cv
        cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa ancom com vt cv cdom wbr
        vt cv vt cv cxp vt cv vf cv wf1o vt cv cA wss an23 3bitri exbii bitri
        abbii com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv wf1o wa vt vf cA
        cpw cA infxpidmlem.2 pwex com vt cv cdom wbr vt cv vt cv cxp vt cv vf
        cv wf1o wa vf cab vt cv vt cv cxp vt cv vf cv wf vf cab vt cv vt cv cxp
        cvv wcel vt cv cvv wcel vt cv vt cv cxp vt cv vf cv wf vf cab cvv wcel
        vt cv vt cv vt visset vt visset xpex vt visset vt cv vt cv cxp vt cv
        cvv cvv vf mapex mp2an com vt cv cdom wbr vt cv vt cv cxp vt cv vf cv
        wf1o wa vt cv vt cv cxp vt cv vf cv wf vf vt cv vt cv cxp vt cv vf cv
        wf1o vt cv vt cv cxp vt cv vf cv wf com vt cv cdom wbr vt cv vt cv cxp
        vt cv vf cv f1of adantl ss2abi ssexi abrexex2 eqeltrri unex eqeltri
        zorn vt cA vz cv cuni crn vz cv vf vg vh cH infxpidmlem.1 vz cv cuni
        crn eqid vz visset infxpidmlem8 mpg $.
        $( [5-Oct-2004] $) $( [12-Sep-2004] $)

      $( Lemma for ~ infxpidm .  A maximal bijection ` g ` in ` H ` is
         non-empty. $)
      infxpidmlem10 $p |- ( A. h e. H -. g C. h -> ( om ~<_ A ->
                        g =/= (/) ) ) $=
        vg cv vh cv wpss wn vh cH wral vv cv c0 wne vv cH wrex vg cv c0 wne com
        cA cdom wbr vg cv vh cv wpss wn vh cH wral vv cv c0 wne vg cv c0 wne vv
        cH vg cv vh cv wpss wn vh cH wral vv cv cH wcel wa vg cv c0 vv cv c0 vg
        cv c0 wceq vv cv c0 wceq vg cv vv cv wpss wn vg cv vh cv wpss wn vh cH
        wral vv cv cH wcel wa vg cv c0 wceq vg cv vv cv wpss vv cv c0 vg cv c0
        wceq vg cv vv cv wpss c0 vv cv wpss vv cv c0 wne vg cv c0 vv cv psseq1
        vv cv 0pss syl6bb necon2bbid vg cv vh cv wpss wn vg cv vv cv wpss wn vh
        vv cv cH vh cv vv cv wceq vg cv vh cv wpss vg cv vv cv wpss vh cv vv cv
        vg cv psseq2 notbid rcla4cva syl5cbir necon3d r19.23adva com vy cv cen
        wbr vy cv cA wss wa vy wex vv cv cH wcel vv cv c0 wne wa vv wex com cA
        cdom wbr vv cv c0 wne vv cH wrex com vy cv cen wbr vy cv cA wss wa vv
        cv cH wcel vv cv c0 wne wa vv wex vy com vy cv cdom wbr vy cv vy cv cxp
        vy cv vv cv wf1o vv wex wa vy cv cA wss vv cv cH wcel vv cv c0 wne wa
        vv wex com vy cv cen wbr com vy cv cdom wbr vy cv cA wss vy cv vy cv
        cxp vy cv vv cv wf1o vv wex vv cv cH wcel vv cv c0 wne wa vv wex com vy
        cv cdom wbr vy cv cA wss wa vy cv vy cv cxp vy cv vv cv wf1o vv wex vv
        cv cH wcel vv cv c0 wne wa vv wex com vy cv cdom wbr vy cv cA wss wa vy
        cv vy cv cxp vy cv vv cv wf1o vv cv cH wcel vv cv c0 wne wa vv com vy
        cv cdom wbr vy cv cA wss wa vy cv vy cv cxp vy cv vv cv wf1o vv cv cH
        wcel vv cv c0 wne com vy cv cdom wbr vy cv cA wss wa vy cv vy cv cxp vy
        cv vv cv wf1o vv cv cH wcel vt cA vv cv vy cv vf cH infxpidmlem.1 vv
        visset vy visset infxpidmlem3 ex com vy cv cdom wbr vy cv vy cv cxp vy
        cv vv cv wf1o vv cv c0 wne wi vy cv cA wss vy cv vy cv cxp vy cv vv cv
        wf1o vy cv c0 wne vv cv c0 wne com vy cv cdom wbr vy cv vy cv cxp vy cv
        vv cv wf1o vv cv c0 vy cv c0 vy cv vy cv cxp vy cv vv cv wf1o vv cv c0
        wceq vy cv c0 wceq vy cv vy cv cxp vy cv vv cv wf1o vv cv c0 wceq vy cv
        vv cv crn c0 vy cv vy cv cxp vy cv vv cv wf1o vy cv vy cv cxp vy cv vv
        cv wfo vv cv crn vy cv wceq vy cv vy cv cxp vy cv vv cv f1ofo vy cv vy
        cv cxp vy cv vv cv forn syl vv cv c0 wceq vv cv crn c0 crn c0 vv cv c0
        rneq rn0 syl6eq sylan9req ex necon3d vy cv vy visset infn0 syl5com
        adantr jcad 19.22dv imp an1rs com vy cv cen wbr com vy cv cdom wbr vy
        cv vy cv cxp vy cv vv cv wf1o vv wex com vy cv endom com vy cv cen wbr
        vy cv vy cv cxp vy cv cen wbr vy cv vy cv cxp vy cv vv cv wf1o vv wex
        com vy cv cen wbr vy cv vy cv cxp com cen wbr vy cv vy cv cxp vy cv cen
        wbr com vy cv cen wbr com com cxp vy cv vy cv cxp cen wbr vy cv vy cv
        cxp com cen wbr com vy cv cen wbr com com cxp vy cv vy cv cxp cen wbr
        com vy cv com vy cv omex vy visset omex vy visset xpen anidms com com
        cxp vy cv vy cv cxp cen wbr com com cxp com cen wbr vy cv vy cv cxp com
        cen wbr xpomen vy cv vy cv cxp cvv wcel com com cxp vy cv vy cv cxp cen
        wbr com com cxp com cen wbr vy cv vy cv cxp com cen wbr wb vy cv vy cv
        vy visset vy visset xpex com com cxp vy cv vy cv cxp com cvv enen1 mpan
        mpbii syl vy cv cvv wcel com vy cv cen wbr vy cv vy cv cxp com cen wbr
        vy cv vy cv cxp vy cv cen wbr wb vy visset com vy cv vy cv vy cv cxp
        cvv enen2 mpan mpbid vy cv vy cv cxp vy cv vv vy visset bren sylib jca
        sylan 19.23aiv vy com cA infxpidmlem.2 domen vv cv c0 wne vv cH df-rex
        3imtr4i syl5 $.
        $( [30-Apr-2007] $) $( [16-Sep-2004] $)

      $( Lemma for ~ infxpidm .  We show that the union of a bijection ` g ` in
         ` H ` with a disjoint bijection ` u ` is a member ` h ` of ` H ` that
         is larger than (properly extends) ` g ` .  Thus if the antecedent is
         true then ` g ` cannot be maximal. $)
      infxpidmlem11 $p |- ( ( ( ( ( om ~<_ x /\ x C_ A ) /\
            g : ( x X. x ) -1-1-onto-> x ) /\ ( x ~~ y /\ y C_ ( A \ x ) ) ) /\
          u : ( ( x X. y ) u. ( ( y X. x ) u. ( y X. y ) ) ) -1-1-onto-> y ) ->
                        E. h e. H g C. h ) $=
        com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o vx
        cv vy cv cen wbr vy cv cA vx cv cdif wss wa vx cv vy cv cxp vy cv vx cv
        cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vg cv vh cv wpss vh cH
        wrex com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv
        wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu
        cv wf1o vx cv vy cv cen wbr vy cv cA vx cv cdif wss wa vg cv vh cv wpss
        vh cH wrex com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg
        cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv
        vu cv wf1o vx cv vy cv cen wbr vy cv cA vx cv cdif wss wa vg cv vh cv
        wpss vh cH wrex vg cv vu cv cun cH wcel vg cv vg cv vu cv cun wpss vg
        cv vh cv wpss vh cH wrex com vx cv cdom wbr vx cv cA wss wa vx cv vx cv
        cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun cun vy cv vu cv wf1o wa wa vx cv vy cv cen wbr vy cv cA vx cv cdif
        wss wa wa vg cv vh cv wpss vg cv vg cv vu cv cun wpss vh vg cv vu cv
        cun cH vh cv vg cv vu cv cun vg cv psseq2 rcla4ev com vx cv cdom wbr vx
        cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa wa vy cv cA vx cv
        cdif wss vg cv vu cv cun cH wcel vx cv vy cv cen wbr com vx cv cdom wbr
        vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv
        vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa wa vy cv cA vx cv
        cdif wss wa vx cv vy cv cun vx cv vy cv cun cxp vx cv vy cv cun vg cv
        vu cv cun wf1o vg cv vu cv cun cH wcel vx cv vx cv cxp vx cv vg cv wf1o
        vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv
        wf1o wa vy cv cA vx cv cdif wss vx cv vy cv cun vx cv vy cv cun cxp vx
        cv vy cv cun vg cv vu cv cun wf1o com vx cv cdom wbr vx cv cA wss wa vx
        cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy
        cv cxp cun cun vy cv vu cv wf1o wa vx cv vy cv cin c0 wceq vx cv vy cv
        cun vx cv vy cv cun cxp vx cv vy cv cun vg cv vu cv cun wf1o vy cv cA
        vx cv cdif wss vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv
        vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa vx cv vy cv cin
        c0 wceq wa vx cv vx cv cxp vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv
        cxp cun cun cun vx cv vy cv cun vg cv vu cv cun wf1o vx cv vy cv cun vx
        cv vy cv cun cxp vx cv vy cv cun vg cv vu cv cun wf1o vx cv vx cv cxp
        vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun
        cun vy cv vu cv wf1o wa vx cv vx cv cxp vx cv vy cv cxp vy cv vx cv cxp
        vy cv vy cv cxp cun cun cin c0 wceq vx cv vy cv cin c0 wceq wa vx cv vx
        cv cxp vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun cun vx
        cv vy cv cun vg cv vu cv cun wf1o vx cv vy cv cin c0 wceq vx cv vx cv
        cxp vx cv vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv
        vg cv vu cv f1oun vx cv vy cv cin c0 wceq vx cv vx cv cxp vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun cin c0 wceq vx cv vy cv cin
        c0 wceq vx cv vx cv cxp vx cv vy cv cxp cin c0 wceq vx cv vx cv cxp vy
        cv vx cv cxp vy cv vy cv cxp cun cin c0 wceq wa vx cv vx cv cxp vx cv
        vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun cin c0 wceq vx cv vy
        cv cin c0 wceq vx cv vx cv cxp vx cv vy cv cxp cin c0 wceq vx cv vx cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cin c0 wceq vx cv vy cv vx cv
        vx cv xpdisj2 vx cv vy cv cin c0 wceq vx cv vx cv cxp vy cv vx cv cxp
        cin c0 wceq vx cv vx cv cxp vy cv vy cv cxp cin c0 wceq wa vx cv vx cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cin c0 wceq vx cv vy cv cin c0
        wceq vx cv vx cv cxp vy cv vx cv cxp cin c0 wceq vx cv vx cv cxp vy cv
        vy cv cxp cin c0 wceq vx cv vy cv vx cv vx cv xpdisj1 vx cv vy cv vx cv
        vy cv xpdisj1 jca vx cv vx cv cxp vy cv vx cv cxp vy cv vy cv cxp
        undisj2 sylib jca vx cv vx cv cxp vx cv vy cv cxp vy cv vx cv cxp vy cv
        vy cv cxp cun undisj2 sylib ancri sylan2 vx cv vy cv cun vx cv vy cv
        cun cxp vx cv vx cv cxp vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun cun cun wceq vx cv vy cv cun vx cv vy cv cun cxp vx cv vy cv cun vg
        cv vu cv cun wf1o vx cv vx cv cxp vx cv vy cv cxp vy cv vx cv cxp vy cv
        vy cv cxp cun cun cun vx cv vy cv cun vg cv vu cv cun wf1o wb vx cv vy
        cv cun vx cv vy cv cun cxp vx cv vx cv cxp vx cv vy cv cxp cun vy cv vx
        cv cxp vy cv vy cv cxp cun cun vx cv vx cv cxp vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun cun vx cv vy cv vx cv vy cv xpun vx cv
        vx cv cxp vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun unass
        eqtri vx cv vy cv cun vx cv vy cv cun cxp vx cv vx cv cxp vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun cun vx cv vy cv cun vg cv
        vu cv cun f1oeq2 ax-mp sylibr vy cv cA vx cv cdif wss vx cv vy cv cin
        c0 wss vx cv vy cv cin c0 wceq vy cv cA vx cv cdif wss vx cv vy cv cin
        vx cv cA vx cv cdif cin c0 vy cv cA vx cv cdif vx cv sslin vx cv cA
        difdisj syl6ss vx cv vy cv cin ss0b sylib sylan2 adantll com vx cv cdom
        wbr vx cv cA wss wa vy cv cA vx cv cdif wss vx cv vy cv cun vx cv vy cv
        cun cxp vx cv vy cv cun vg cv vu cv cun wf1o vg cv vu cv cun cH wcel wi
        vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv
        vy cv cxp cun cun vy cv vu cv wf1o wa com vx cv cdom wbr vx cv cA wss
        wa vy cv cA vx cv cdif wss wa vx cv vy cv cun vx cv vy cv cun cxp vx cv
        vy cv cun vg cv vu cv cun wf1o vg cv vu cv cun cH wcel com vx cv vy cv
        cun cdom wbr vx cv vy cv cun cA wss wa vx cv vy cv cun vx cv vy cv cun
        cxp vx cv vy cv cun vg cv vu cv cun wf1o vg cv vu cv cun cH wcel com vx
        cv cdom wbr vx cv cA wss wa vy cv cA vx cv cdif wss wa vt cA vg cv vu
        cv cun vx cv vy cv cun vf cH infxpidmlem.1 vg cv vu cv vg visset vu
        visset unex vx cv vy cv vx visset vy visset unex infxpidmlem3 com vx cv
        cdom wbr vx cv cA wss vy cv cA vx cv cdif wss com vx cv vy cv cun cdom
        wbr vx cv vy cv cun cA wss wa com vx cv cdom wbr com vx cv vy cv cun
        cdom wbr vx cv cA wss vy cv cA vx cv cdif wss wa vx cv vy cv cun cA wss
        com vx cv cdom wbr vx cv vx cv vy cv cun cdom wbr com vx cv vy cv cun
        cdom wbr vx cv cvv wcel vx cv vx cv vy cv cun wss vx cv vx cv vy cv cun
        cdom wbr vx visset vx cv vy cv ssun1 vx cv vx cv vy cv cun cvv ssdomg
        mp2 com vx cv vx cv vy cv cun domtr mpan2 vx cv cA wss vy cv cA vx cv
        cdif wss wa vx cv cA wss vy cv cA wss wa vx cv vy cv cun cA wss vy cv
        cA vx cv cdif wss vy cv cA wss vx cv cA wss vy cv cA vx cv cdif wss cA
        vx cv cdif cA wss vy cv cA wss cA vx cv difss vy cv cA vx cv cdif cA
        sstr mpan2 anim2i vx cv vy cv cA unss sylib anim12i anassrs sylan ex
        adantlr mpd adantrl com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp
        vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun
        cun vy cv vu cv wf1o wa vx cv vy cv cen wbr vy cv cA vx cv cdif wss vg
        cv vg cv vu cv cun wpss com vx cv cdom wbr vx cv vx cv cxp vx cv vg cv
        wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu
        cv wf1o wa vx cv vy cv cen wbr vy cv cA vx cv cdif wss vg cv vg cv vu
        cv cun wpss wi wi wi vx cv cA wss com vx cv cdom wbr vx cv vy cv cen
        wbr vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy
        cv vy cv cxp cun cun vy cv vu cv wf1o wa vy cv cA vx cv cdif wss vg cv
        vg cv vu cv cun wpss wi vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa vy cv
        cA vx cv cdif wss com vx cv cdom wbr vx cv vy cv cen wbr vg cv vg cv vu
        cv cun wpss vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa vx cv vy cv cin c0
        wceq com vx cv cdom wbr vx cv vy cv cen wbr vg cv vg cv vu cv cun wpss
        wi wi vy cv cA vx cv cdif wss vx cv vx cv cxp vx cv vg cv wf1o vx cv vy
        cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa vx
        cv vy cv cin c0 wceq com vx cv cdom wbr vx cv vy cv cen wbr vg cv vg cv
        vu cv cun wpss vg cv vu cv cin c0 wceq vu cv c0 wne vg cv vg cv vu cv
        cun wpss vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv
        cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o wa vx cv vy cv cin c0 wceq
        wa com vx cv cdom wbr vx cv vy cv cen wbr wa wa vg cv vu cv disjpss vx
        cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy
        cv cxp cun cun vy cv vu cv wf1o wa vx cv vy cv cin c0 wceq wa vg cv vu
        cv cin c0 wceq com vx cv cdom wbr vx cv vy cv cen wbr wa vx cv vx cv
        cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun cun vy cv vu cv wf1o wa vx cv vy cv cin c0 wceq vg cv vu cv cin c0
        wceq vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp
        vy cv vy cv cxp cun cun vy cv vu cv wf1o wa vx cv vy cv cin c0 wceq vg
        cv crn vu cv crn cin c0 wceq vg cv vu cv cin c0 wceq vg cv crn vx cv
        wceq vu cv crn vy cv wceq vg cv crn vu cv crn cin c0 wceq vx cv vy cv
        cin c0 wceq wb vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv
        vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vg cv crn vx cv wceq
        vu cv crn vy cv wceq wa vg cv crn vu cv crn cin vx cv vy cv cin c0 vg
        cv crn vx cv vu cv crn vy cv ineq12 eqeq1d vx cv vx cv cxp vx cv vg cv
        wf1o vx cv vx cv cxp vx cv vg cv wfo vg cv crn vx cv wceq vx cv vx cv
        cxp vx cv vg cv f1ofo vx cv vx cv cxp vx cv vg cv forn syl vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vx cv vy
        cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wfo vu cv
        crn vy cv wceq vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun
        vy cv vu cv f1ofo vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun
        cun vy cv vu cv forn syl syl2an vx cv vx cv cxp vx cv vg cv wf1o vg cv
        crn vu cv crn cin c0 wceq vg cv vu cv cin c0 wceq wi vx cv vy cv cxp vy
        cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vx cv vx cv cxp
        vx cv vg cv wf1o vg cv wrel vg cv vu cv cin wrel vg cv crn vu cv crn
        cin c0 wceq vg cv vu cv cin c0 wceq wi vx cv vx cv cxp vx cv vg cv
        f1orel vg cv vu cv relin1 vg cv vu cv cin wrel vg cv vu cv cin c0 wceq
        vg cv vu cv cin crn c0 wceq vg cv crn vu cv crn cin c0 wceq vg cv vu cv
        cin relrn0 vg cv crn vu cv crn cin c0 wceq vg cv vu cv cin crn c0 wss
        vg cv vu cv cin crn c0 wceq vg cv crn vu cv crn cin c0 wceq vg cv vu cv
        cin crn vg cv crn vu cv crn cin wss vg cv vu cv cin crn c0 wss vg cv vu
        cv rnin vg cv crn vu cv crn cin c0 vg cv vu cv cin crn sseq2 mpbii vg
        cv vu cv cin crn ss0 syl syl5bir 3syl adantr sylbird imp adantr vx cv
        vx cv cxp vx cv vg cv wf1o vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv
        cxp cun cun vy cv vu cv wf1o wa com vx cv cdom wbr vx cv vy cv cen wbr
        wa vu cv c0 wne vx cv vy cv cin c0 wceq vx cv vy cv cxp vy cv vx cv cxp
        vy cv vy cv cxp cun cun vy cv vu cv wf1o com vx cv cdom wbr vx cv vy cv
        cen wbr wa vu cv c0 wne vx cv vx cv cxp vx cv vg cv wf1o vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o com vx cv
        cdom wbr vx cv vy cv cen wbr wa vu cv c0 wne vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o com vy cv cdom wbr vu
        cv c0 wne com vx cv cdom wbr vx cv vy cv cen wbr wa vx cv vy cv cxp vy
        cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vu cv c0 wne vy
        cv c0 wne com vy cv cdom wbr vx cv vy cv cxp vy cv vx cv cxp vy cv vy
        cv cxp cun cun vy cv vu cv wf1o vu cv c0 vy cv c0 vx cv vy cv cxp vy cv
        vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vu cv c0 wceq vu cv
        crn c0 wceq vy cv c0 wceq vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv
        cxp cun cun vy cv vu cv wf1o vu cv wrel vu cv c0 wceq vu cv crn c0 wceq
        wb vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv
        f1orel vu cv relrn0 syl vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun cun vy cv vu cv wf1o vu cv crn vy cv c0 vx cv vy cv cxp vy cv vx cv
        cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun vy cv vu cv wfo vu cv crn vy cv wceq vx
        cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv f1ofo
        vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv
        forn syl eqeq1d bitrd necon3bid vy cv vy visset infn0 syl5bir com vx cv
        vy cv domentr syl5 imp adantll adantlr sylanc exp43 vy cv cA vx cv cdif
        wss vx cv vy cv cin c0 wss vx cv vy cv cin c0 wceq vy cv cA vx cv cdif
        wss vx cv vy cv cin vx cv cA vx cv cdif cin c0 vy cv cA vx cv cdif vx
        cv sslin vx cv cA difdisj syl6ss vx cv vy cv cin ss0b sylib syl5 com4t
        com23 adantr imp43 sylanc exp42 com34 imp41 $.
        $( [5-Oct-2004] $) $( [16-Sep-2004] $)

      $( Lemma for ~ infxpidm .  Letting ` x ` be the range of a maximal
         bijection ` g ` in ` H ` , ~ infxpidmlem11 lets us show that assuming
         ` x ~<_ ( A \ x ) ` leads to the contradiction ` E. h e. H g C. h `
         meaning ` g ` is not maximal.  Thus ` ( A \ x ) ~< x ` .  This allows
         us to show that ` x ` is as big as ` A ` .  Since ` x ` is idempotent,
         and ` g ` exists by Zorn's Lemma in ~ infxpidmlem9 , ` A ` is also
         idempotent. $)
      infxpidmlem12 $p |- ( om ~<_ A -> ( A X. A ) ~~ A ) $=
        vg cv vh cv wpss wn vh cH wral vg cH wrex com cA cdom wbr cA cA cxp cA
        cen wbr wi vt cA vf vg vh cH infxpidmlem.1 infxpidmlem.2 infxpidmlem9
        vg cv vh cv wpss wn vh cH wral com cA cdom wbr cA cA cxp cA cen wbr wi
        vg cH vg cv vh cv wpss wn vh cH wral com cA cdom wbr vg cv cH wcel cA
        cA cxp cA cen wbr vg cv vh cv wpss wn vh cH wral com cA cdom wbr vg cv
        c0 wne vg cv cH wcel cA cA cxp cA cen wbr wi vt cA vf vg vh cH
        infxpidmlem.1 infxpidmlem.2 infxpidmlem10 vg cv cH wcel vg cv c0 wne vg
        cv vh cv wpss wn vh cH wral cA cA cxp cA cen wbr vg cv cH wcel vg cv c0
        wne com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o
        wa vx wex wi vg cv c0 wne vg cv vh cv wpss wn vh cH wral cA cA cxp cA
        cen wbr wi wi vg cv cH wcel vg cv c0 wceq com vx cv cdom wbr vx cv cA
        wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx wex wo vg cv c0 wne com
        vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx
        wex wi vx vt cA vg cv vf cH infxpidmlem.1 vg visset infxpidmlem2 com vx
        cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx wex
        vg cv c0 neor bitri com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp
        vx cv vg cv wf1o wa vx wex vg cv vh cv wpss wn vh cH wral cA cA cxp cA
        cen wbr wi vg cv c0 wne com vx cv cdom wbr vx cv cA wss wa vx cv vx cv
        cxp vx cv vg cv wf1o wa vg cv vh cv wpss wn vh cH wral cA cA cxp cA cen
        wbr wi vx com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg
        cv wf1o wa vg cv vh cv wpss wn vh cH wral cA vx cv cdif vx cv csdm wbr
        cA cA cxp cA cen wbr com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp
        vx cv vg cv wf1o wa cA vx cv cdif vx cv csdm wbr vg cv vh cv wpss wn vh
        cH wral com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv
        wf1o wa vx cv cA vx cv cdif cdom wbr vg cv vh cv wpss vh cH wrex cA vx
        cv cdif vx cv csdm wbr wn vg cv vh cv wpss wn vh cH wral wn com vx cv
        cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vy
        cv cen wbr vy cv cA vx cv cdif wss wa vy wex vg cv vh cv wpss vh cH
        wrex vx cv cA vx cv cdif cdom wbr com vx cv cdom wbr vx cv cA wss wa vx
        cv vx cv cxp vx cv vg cv wf1o wa vx cv vy cv cen wbr vy cv cA vx cv
        cdif wss wa vg cv vh cv wpss vh cH wrex vy com vx cv cdom wbr vx cv cA
        wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vy cv cen wbr vy cv cA
        vx cv cdif wss wa vg cv vh cv wpss vh cH wrex com vx cv cdom wbr vx cv
        cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vy cv cen wbr vy cv
        cA vx cv cdif wss wa wa vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun cun vy cv vu cv wf1o vu wex vg cv vh cv wpss vh cH wrex com vx cv
        cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vy
        cv cen wbr vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy
        cv vu cv wf1o vu wex vy cv cA vx cv cdif wss com vx cv cdom wbr vx cv
        vx cv cxp vx cv cen wbr wa vx cv vy cv cen wbr vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vu wex com vx cv cdom
        wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa com vx cv cdom
        wbr vx cv vx cv cxp vx cv cen wbr wa vx cv vy cv cen wbr wa vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv cen wbr vx cv vy cv
        cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vu wex com
        vx cv cdom wbr vx cv vx cv vx cv cxp cen wbr vx cv vy cv cen wbr vx cv
        vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun vy cv cen wbr vx cv
        vx cv cxp vx cv cen wbr com vx cv cdom wbr vx cv vx cv vx cv cxp cen
        wbr wa vx cv vy cv cen wbr vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv
        cxp cun cun vx cv cen wbr vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv
        cxp cun cun vy cv cen wbr com vx cv cdom wbr vx cv vx cv vx cv cxp cen
        wbr wa vx cv vy cv cen wbr wa vx cv vx cv vy cv cxp vy cv vx cv cxp vy
        cv vy cv cxp cun cun cen wbr vx cv vy cv cxp vy cv vx cv cxp vy cv vy
        cv cxp cun cun vx cv cen wbr com vx cv cdom wbr vx cv vx cv vx cv cxp
        cen wbr wa vx cv vy cv cen wbr wa vx cv vx cv vy cv cxp cen wbr vx cv
        vy cv vx cv cxp vy cv vy cv cxp cun cen wbr vx cv vx cv vy cv cxp vy cv
        vx cv cxp vy cv vy cv cxp cun cun cen wbr vx cv vx cv vx cv cxp cen wbr
        vx cv vy cv cen wbr vx cv vx cv vy cv cxp cen wbr com vx cv cdom wbr vx
        cv vx cv vx cv cxp cen wbr vx cv vx cv cxp vx cv vy cv cxp cen wbr vx
        cv vx cv vy cv cxp cen wbr vx cv vy cv cen wbr vx cv vx cv vx cv cxp vx
        cv vy cv cxp entr vx cv vx cv cen wbr vx cv vy cv cen wbr vx cv vx cv
        cxp vx cv vy cv cxp cen wbr vx cv vx visset enref vx cv vx cv vx cv vy
        cv vx visset vx visset vx visset vy visset xpen mpan sylan2 adantll com
        vx cv cdom wbr vx cv vx cv vx cv cxp cen wbr wa vx cv vy cv cen wbr wa
        vx cv vy cv vx cv cxp cen wbr vx cv vy cv vy cv cxp cen wbr wa vx cv vy
        cv vx cv cxp vy cv vy cv cxp cun cen wbr vx cv vx cv vx cv cxp cen wbr
        vx cv vy cv cen wbr vx cv vy cv vx cv cxp cen wbr vx cv vy cv vy cv cxp
        cen wbr wa com vx cv cdom wbr vx cv vx cv vx cv cxp cen wbr vx cv vy cv
        cen wbr wa vx cv vy cv vx cv cxp cen wbr vx cv vy cv vy cv cxp cen wbr
        vx cv vx cv vx cv cxp cen wbr vx cv vx cv cxp vy cv vx cv cxp cen wbr
        vx cv vy cv vx cv cxp cen wbr vx cv vy cv cen wbr vx cv vx cv vx cv cxp
        vy cv vx cv cxp entr vx cv vy cv cen wbr vx cv vx cv cen wbr vx cv vx
        cv cxp vy cv vx cv cxp cen wbr vx cv vx visset enref vx cv vy cv vx cv
        vx cv vx visset vy visset vx visset vx visset xpen mpan2 sylan2 vx cv
        vx cv vx cv cxp cen wbr vx cv vx cv cxp vy cv vy cv cxp cen wbr vx cv
        vy cv vy cv cxp cen wbr vx cv vy cv cen wbr vx cv vx cv vx cv cxp vy cv
        vy cv cxp entr vx cv vy cv cen wbr vx cv vx cv cxp vy cv vy cv cxp cen
        wbr vx cv vy cv vx cv vy cv vx visset vy visset vx visset vy visset
        xpen anidms sylan2 jca adantll com vx cv cdom wbr vx cv vx cv vx cv cxp
        cen wbr wa vx cv vy cv vx cv cxp cen wbr vx cv vy cv vy cv cxp cen wbr
        wa vx cv vy cv vx cv cxp vy cv vy cv cxp cun cen wbr wi vx cv vy cv cen
        wbr vx vy cv vx cv cxp vy cv vy cv cxp vy cv vx cv vy visset vx visset
        xpex vy cv vy cv vy visset vy visset xpex infxpidmlem1 adantr mpd com
        vx cv cdom wbr vx cv vx cv vx cv cxp cen wbr wa vx cv vx cv vy cv cxp
        cen wbr vx cv vy cv vx cv cxp vy cv vy cv cxp cun cen wbr wa vx cv vx
        cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun cun cen wbr wi vx cv
        vy cv cen wbr vx vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp cun vx
        cv vy cv vx visset vy visset xpex vy cv vx cv cxp vy cv vy cv cxp vy cv
        vx cv vy visset vx visset xpex vy cv vy cv vy visset vy visset xpex
        unex infxpidmlem1 adantr mp2and vx cv vx cv vy cv cxp vy cv vx cv cxp
        vy cv vy cv cxp cun cun vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun vx cv vy cv vx visset vy visset xpex vy cv vx cv cxp vy cv vy cv
        cxp vy cv vx cv vy visset vx visset xpex vy cv vy cv vy visset vy
        visset xpex unex unex ensym syl vx cv vy cv cxp vy cv vx cv cxp vy cv
        vy cv cxp cun cun vx cv vy cv entr sylancom vx cv vx cv cxp vx cv vx
        visset ensym sylanl2 vx cv vy cv cxp vy cv vx cv cxp vy cv vy cv cxp
        cun cun vy cv vu vy visset bren sylib com vx cv cdom wbr vx cv vx cv
        cxp vx cv vg cv wf1o com vx cv cdom wbr vx cv vx cv cxp vx cv cen wbr
        wa vx cv cA wss vx cv vx cv cxp vx cv vg cv wf1o vx cv vx cv cxp vx cv
        cen wbr com vx cv cdom wbr vx cv vx cv cxp vx cv vg cv vx cv vx cv vx
        visset vx visset xpex f1oen anim2i adantlr sylan adantrr com vx cv cdom
        wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx cv vy cv cen
        wbr vy cv cA vx cv cdif wss wa wa vx cv vy cv cxp vy cv vx cv cxp vy cv
        vy cv cxp cun cun vy cv vu cv wf1o vg cv vh cv wpss vh cH wrex vu com
        vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv vg cv wf1o wa vx
        cv vy cv cen wbr vy cv cA vx cv cdif wss wa wa vx cv vy cv cxp vy cv vx
        cv cxp vy cv vy cv cxp cun cun vy cv vu cv wf1o vg cv vh cv wpss vh cH
        wrex vx vy vu vt cA vf vg vh cH infxpidmlem.1 infxpidmlem.2
        infxpidmlem11 ex 19.23adv mpd ex 19.23adv vy vx cv cA vx cv cdif cA cvv
        wcel cA vx cv cdif cvv wcel infxpidmlem.2 cA vx cv cvv difexg ax-mp
        domen syl5ib vx cv cvv wcel cA vx cv cdif cvv wcel vx cv cA vx cv cdif
        cdom wbr cA vx cv cdif vx cv csdm wbr wn wb vx visset cA cvv wcel cA vx
        cv cdif cvv wcel infxpidmlem.2 cA vx cv cvv difexg ax-mp vx cv cA vx cv
        cdif cvv cvv domtri mp2an vg cv vh cv wpss vh cH dfrex2 3imtr3g con4d
        com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp vx cv cen wbr cA vx
        cv cdif vx cv csdm wbr cA cA cxp cA cen wbr wi vx cv vx cv cxp vx cv vg
        cv wf1o com vx cv cdom wbr vx cv cA wss vx cv vx cv cxp vx cv cen wbr
        cA vx cv cdif vx cv csdm wbr cA cA cxp cA cen wbr wi com vx cv cdom wbr
        cA vx cv cdif vx cv csdm wbr vx cv vx cv cxp vx cv cen wbr vx cv cA wss
        cA cA cxp cA cen wbr com vx cv cdom wbr cA vx cv cdif vx cv csdm wbr vx
        cv vx cv cxp vx cv cen wbr vx cv cA wss cA cA cxp cA cen wbr com vx cv
        cdom wbr cA vx cv cdif vx cv csdm wbr wa vx cv vx cv cxp vx cv cen wbr
        wa vx cv cA wss wa cA vx cv cen wbr cA cA cxp cA cen wbr cA vx cv cdom
        wbr vx cv cA cdom wbr cA vx cv cen wbr com vx cv cdom wbr cA vx cv cdif
        vx cv csdm wbr wa vx cv vx cv cxp vx cv cen wbr wa vx cv cA wss cA vx
        cv sbth cA vx cv vx cv cxp cdom wbr vx cv vx cv cxp vx cv cen wbr cA vx
        cv cdom wbr com vx cv cdom wbr cA vx cv cdif vx cv csdm wbr wa cA vx cv
        vx cv cxp vx cv domentr c1o vx cv csdm wbr cA vx cv cdif vx cv cdom wbr
        cA vx cv vx cv cxp cdom wbr com vx cv cdom wbr cA vx cv cdif vx cv csdm
        wbr cA vx cv cA vx cv cdif cun cdom wbr vx cv cA vx cv cdif cun vx cv
        vx cv cxp cdom wbr cA vx cv vx cv cxp cdom wbr c1o vx cv csdm wbr cA vx
        cv cdif vx cv cdom wbr wa cA vx cv cA vx cv cdif cun vx cv vx cv cxp
        domtr cA vx cv cA cun vx cv cA vx cv cdif cun cdom cA cvv wcel cA vx cv
        cA cun wss cA vx cv cA cun cdom wbr infxpidmlem.2 cA vx cv ssun2 cA vx
        cv cA cun cvv ssdomg mp2 vx cv cA undif2 breqtrri vx cv cA vx cv cdif
        vx visset cA cvv wcel cA vx cv cdif cvv wcel infxpidmlem.2 cA vx cv cvv
        difexg ax-mp unxpdom2 sylancr com vx cv cdom wbr c1o com wcel c1o vx cv
        csdm wbr 1onn vx cv c1o vx visset infsdomnn mpan2 cA vx cv cdif vx cv
        sdomdom syl2an sylan vx cv cvv wcel vx cv cA wss vx cv cA cdom wbr wi
        vx visset vx cv cA cvv ssdomg ax-mp syl2an vx cv vx cv cxp vx cv cen
        wbr cA vx cv cen wbr cA cA cxp cA cen wbr wi com vx cv cdom wbr cA vx
        cv cdif vx cv csdm wbr wa vx cv cA wss cA vx cv cen wbr vx cv vx cv cxp
        vx cv cen wbr cA cA cxp cA cen wbr cA cA cxp vx cv cen wbr vx cv cA cen
        wbr cA cA cxp cA cen wbr cA vx cv cen wbr vx cv vx cv cxp vx cv cen wbr
        wa cA cA cxp vx cv cA entr cA cA cxp vx cv vx cv cxp cen wbr vx cv vx
        cv cxp vx cv cen wbr cA cA cxp vx cv cen wbr cA vx cv cen wbr cA cA cxp
        vx cv vx cv cxp vx cv entr cA vx cv cen wbr cA cA cxp vx cv vx cv cxp
        cen wbr cA vx cv cA vx cv infxpidmlem.2 vx visset infxpidmlem.2 vx
        visset xpen anidms sylan cA vx cv cen wbr vx cv cA cen wbr vx cv vx cv
        cxp vx cv cen wbr cA vx cv vx visset ensym adantr sylanc expcom
        ad2antlr mpd exp41 com24 imp31 vx cv vx cv cxp vx cv vg cv vx cv vx cv
        vx visset vx visset xpex f1oen sylan2 syld 19.23aiv imim2i sylbi com13
        syld com3r r19.23aiv ax-mp $.
        $( [5-Oct-2004] $) $( [17-Sep-2004] $)
    $}
  $}

  ${
    $d f x A $.
    infxpidm.1 $e |- A e. _V $.
    $( The cross product of an infinite set with itself is idempotent.  This
       theorem provides the basis for infinite cardinal arithmetic.
       Lemma 6R of [Enderton] p. 162, whose proof we follow closely.  The
       main proof consists of ~ infxpidmlem1 through ~ infxpidmlem12 .  This
       final piece eliminates the first hypothesis of ~ infxpidmlem12 . $)
    infxpidm $p |- ( om ~<_ A -> ( A X. A ) ~~ A ) $=
      vx cA vf vf cv c0 wceq com vx cv cdom wbr vx cv cA wss wa vx cv vx cv cxp
      vx cv vf cv wf1o wa vx wex wo vf cab vf cv c0 wceq com vx cv cdom wbr vx
      cv cA wss wa vx cv vx cv cxp vx cv vf cv wf1o wa vx wex wo vf cab eqid
      infxpidm.1 infxpidmlem12 $.
      $( [5-Oct-2004] $) $( [17-Sep-2004] $)
  $}

  ${
    infunabs.1 $e |- A e. _V $.
    infunabs.2 $e |- B e. _V $.
    $( An infinite set is equinumerous to its union with a smaller one. $)
    infunabs $p |- ( ( om ~<_ A /\ B ~<_ A ) -> ( A u. B ) ~~ A ) $=
      cA cB cun cA cdom wbr cA cA cB cun cdom wbr cA cB cun cA cen wbr com cA
      cdom wbr cB cA cdom wbr wa cA cB cun cA sbth cA cB cun cA cB ccda co cdom
      wbr cA cB ccda co cA cen wbr cA cB cun cA cdom wbr com cA cdom wbr cB cA
      cdom wbr wa cA cB cun cA cB ccda co cA domentr cA cB infunabs.1
      infunabs.2 uncdadom cB cA cdom wbr com cA cdom wbr cA cB ccda co cA cen
      wbr cA cB ccda co cA cdom wbr cA cA cB ccda co cdom wbr cA cB ccda co cA
      cen wbr cB cA cdom wbr com cA cdom wbr wa cA cB ccda co cA sbth cA cB
      ccda co cA cA cxp cdom wbr cA cA cxp cA cen wbr cA cB ccda co cA cdom wbr
      cB cA cdom wbr com cA cdom wbr wa cA cB ccda co cA cA cxp cA domentr cA
      cB ccda co cA c2o cxp cdom wbr cA c2o cxp cA cA cxp cdom wbr cA cB ccda
      co cA cA cxp cdom wbr cB cA cdom wbr com cA cdom wbr cA cB ccda co cA c2o
      cxp cA cA cxp domtr cB cA cdom wbr cA cB ccda co cA cA ccda co cA c2o cxp
      cdom cB cA cA infunabs.2 infunabs.1 infunabs.1 cdadom2 cA infunabs.1
      xp2cda syl6breqr com cA cdom wbr c2o cA cdom wbr cA c2o cxp cA cA cxp
      cdom wbr c2o com cdom wbr com cA cdom wbr c2o cA cdom wbr c2o com cdom
      wbr com c2o cen wbr wn c2o com wcel c2o com cdom wbr com c2o cen wbr wn
      wa 2onn c2o omsdomnn ax-mp pm3.26i c2o com cA domtr mpan c2o cA cA
      infunabs.1 infunabs.1 xpdom2 syl syl2an com cA cdom wbr cA cA cxp cA cen
      wbr cB cA cdom wbr cA infunabs.1 infxpidm adantl sylanc cA cB infunabs.1
      infunabs.2 cdadom3 sylancl ancoms sylancr cA cvv wcel cA cA cB cun wss cA
      cA cB cun cdom wbr infunabs.1 cA cB ssun1 cA cA cB cun cvv ssdomg mp2
      sylancl $.
      $( [7-Oct-2004] $) $( [28-Sep-2004] $)

    $( Absorption law for addition to an infinite cardinal. $)
    infcdaabs $p |- ( ( om ~<_ A /\ B ~<_ A ) -> ( A +c B ) ~~ A ) $=
      cB cA cdom wbr com cA cdom wbr cA cB ccda co cA cen wbr cA cB ccda co cA
      cdom wbr cA cA cB ccda co cdom wbr cA cB ccda co cA cen wbr cB cA cdom
      wbr com cA cdom wbr wa cA cB ccda co cA sbth cA cB ccda co cA cA cxp cdom
      wbr cA cA cxp cA cen wbr cA cB ccda co cA cdom wbr cB cA cdom wbr com cA
      cdom wbr wa cA cB ccda co cA cA cxp cA domentr cA cB ccda co cA c2o cxp
      cdom wbr cA c2o cxp cA cA cxp cdom wbr cA cB ccda co cA cA cxp cdom wbr
      cB cA cdom wbr com cA cdom wbr cA cB ccda co cA c2o cxp cA cA cxp domtr
      cB cA cdom wbr cA cB ccda co cA cA ccda co cA c2o cxp cdom cB cA cA
      infunabs.2 infunabs.1 infunabs.1 cdadom2 cA infunabs.1 xp2cda syl6breqr
      com cA cdom wbr c2o cA cdom wbr cA c2o cxp cA cA cxp cdom wbr c2o com
      cdom wbr com cA cdom wbr c2o cA cdom wbr c2o com cdom wbr com c2o cen wbr
      wn c2o com wcel c2o com cdom wbr com c2o cen wbr wn wa 2onn c2o omsdomnn
      ax-mp pm3.26i c2o com cA domtr mpan c2o cA cA infunabs.1 infunabs.1
      xpdom2 syl syl2an com cA cdom wbr cA cA cxp cA cen wbr cB cA cdom wbr cA
      infunabs.1 infxpidm adantl sylanc cA cB infunabs.1 infunabs.2 cdadom3
      sylancl ancoms $.
      $( [23-Oct-2004] $) $( [30-Sep-2004] $)

    $( The sum of two cardinal numbers is their maximum, if one of them is
       infinite.  Proposition 10.41 of [TakeutiZaring] p. 95. $)
    infcda $p |- ( om ~<_ A -> ( A +c B ) ~~ ( A u. B ) ) $=
      com cA cdom wbr cB cA cdom wbr cA cB cdom wbr wo cA cB ccda co cA cB cun
      cen wbr cB cvv wcel cA cvv wcel cB cA cdom wbr cA cB cdom wbr wo
      infunabs.2 infunabs.1 cB cA cvv cvv entri3 mp2an com cA cdom wbr cB cA
      cdom wbr cA cB ccda co cA cB cun cen wbr cA cB cdom wbr com cA cdom wbr
      cB cA cdom wbr cA cB ccda co cA cB cun cen wbr cA cB ccda co cA cen wbr
      cA cA cB cun cen wbr cA cB ccda co cA cB cun cen wbr com cA cdom wbr cB
      cA cdom wbr wa cA cB ccda co cA cA cB cun entr cA cB infunabs.1
      infunabs.2 infcdaabs com cA cdom wbr cB cA cdom wbr wa cA cB cun cA cen
      wbr cA cA cB cun cen wbr cA cB infunabs.1 infunabs.2 infunabs cA cB cun
      cA infunabs.1 ensym syl sylanc ex com cA cdom wbr cA cB cdom wbr cA cB
      ccda co cA cB cun cen wbr com cA cdom wbr cA cB cdom wbr cA cB cdom wbr
      cA cB ccda co cA cB cun cen wbr com cB cdom wbr cA cB cdom wbr cA cB ccda
      co cA cB cun cen wbr com cA cdom wbr cA cB cdom wbr wa com cB cdom wbr cA
      cB cdom wbr wa cA cB ccda co cB cA cun cA cB cun cen cA cB ccda co cB cA
      ccda co cen wbr cB cA ccda co cB cA cun cen wbr cA cB ccda co cB cA cun
      cen wbr com cB cdom wbr cA cB cdom wbr wa cA cB ccda co cB cA ccda co cB
      cA cun entr cA cB infunabs.1 infunabs.2 cdacomen cB cA ccda co cB cen wbr
      cB cB cA cun cen wbr cB cA ccda co cB cA cun cen wbr com cB cdom wbr cA
      cB cdom wbr wa cB cA ccda co cB cB cA cun entr cB cA infunabs.2
      infunabs.1 infcdaabs com cB cdom wbr cA cB cdom wbr wa cB cA cun cB cen
      wbr cB cB cA cun cen wbr cB cA infunabs.2 infunabs.1 infunabs cB cA cun
      cB infunabs.2 ensym syl sylanc sylancr cB cA uncom syl6breq com cA cB
      domtr sylan exp31 pm2.43d jaod mpi $.
      $( [29-Mar-2005] $) $( [28-Sep-2004] $)

    $( The cardinality of an infinite set does not change after subtracting
       a strictly smaller one.  Example in [Enderton] p. 164. $)
    infdif $p |- ( ( om ~<_ A /\ B ~< A ) -> ( A \ B ) ~~ A ) $=
      cA cB cdif cA cdom wbr cA cA cB cdif cdom wbr cA cB cdif cA cen wbr com
      cA cdom wbr cB cA csdm wbr wa cA cB cdif cA sbth cA cvv wcel cA cB cdif
      cA wss cA cB cdif cA cdom wbr infunabs.1 cA cB difss cA cB cdif cA cvv
      ssdom2g mp2 com cA cdom wbr cB cA csdm wbr cA cA cB cdif cA cB cdif ccda
      co cdom wbr cA cA cB cdif cdom wbr cA cA cB cun cen wbr cA cB cun cA cB
      cdif cA cB cdif ccda co cdom wbr cA cA cB cdif cA cB cdif ccda co cdom
      wbr com cA cdom wbr cB cA csdm wbr wa cA cA cB cun cA cB cdif cA cB cdif
      ccda co endomtr com cA cdom wbr cB cA cdom wbr cA cA cB cun cen wbr cB cA
      csdm wbr com cA cdom wbr cB cA cdom wbr wa cA cB cun cA cen wbr cA cA cB
      cun cen wbr cA cB infunabs.1 infunabs.2 infunabs cA cB cun cA infunabs.1
      ensym syl cB cA sdomdom sylan2 com cA cdom wbr cB cA csdm wbr wa cB cA cB
      cdif csdm wbr cB cA cB cdif cdom wbr cA cB cun cA cB cdif cA cB cdif ccda
      co cdom wbr com cA cdom wbr cB cA csdm wbr wa cA cB cdif cB cdom wbr wn
      cB cA cB cdif csdm wbr com cA cdom wbr cB cA csdm wbr wa com cB cdom wbr
      cB com csdm wbr wo cA cB cdif cB cdom wbr wn com cvv wcel cB cvv wcel com
      cB cdom wbr cB com csdm wbr wo omex infunabs.2 com cB cvv cvv entri2
      mp2an com cA cdom wbr cB cA csdm wbr wa com cB cdom wbr cA cB cdif cB
      cdom wbr wn cB com csdm wbr cB cA csdm wbr com cB cdom wbr cA cB cdif cB
      cdom wbr wn wi com cA cdom wbr cB cA csdm wbr com cB cdom wbr cA cB cdif
      cB cdom wbr wn cB cA csdm wbr com cB cdom wbr wa cA cB cdif cB cdom wbr
      cA cB cun cA csdm wbr cA cA cB cun cdom wbr cA cB cun cA csdm wbr wn cA
      cvv wcel cA cA cB cun wss cA cA cB cun cdom wbr infunabs.1 cA cB ssun1 cA
      cA cB cun cvv ssdomg mp2 cA cvv wcel cA cB cun cvv wcel cA cA cB cun cdom
      wbr cA cB cun cA csdm wbr wn wb infunabs.1 cA cB infunabs.1 infunabs.2
      unex cA cA cB cun cvv cvv domtri mp2an mpbi cA cB cdif cB cdom wbr cB cA
      csdm wbr com cB cdom wbr wa cA cB cun cA csdm wbr cA cB cun cB cB ccda co
      cdom wbr cB cB ccda co cA csdm wbr cA cB cun cA csdm wbr cA cB cdif cB
      cdom wbr cB cA csdm wbr com cB cdom wbr wa cA cB cun cB cB ccda co cA
      domsdomtr cA cB cdif cB cdom wbr cA cB cdif cB cun cB cB ccda co cA cB
      cun cdom cA cB cdif cB cun cA cB cdif cB ccda co cdom wbr cA cB cdif cB
      ccda co cB cB ccda co cdom wbr cA cB cdif cB cun cB cB ccda co cdom wbr
      cA cB cdif cB cdom wbr cA cB cdif cB cun cA cB cdif cB ccda co cB cB ccda
      co domtr cA cB cdif cB cA cvv wcel cA cB cdif cvv wcel infunabs.1 cA cB
      cvv difexg ax-mp infunabs.2 uncdadom cA cB cdif cB cB cA cvv wcel cA cB
      cdif cvv wcel infunabs.1 cA cB cvv difexg ax-mp infunabs.2 infunabs.2
      cdadom1 sylancr cA cB undif1 syl5eqbrr com cB cdom wbr cB cA csdm wbr cB
      cB ccda co cA csdm wbr cB cB ccda co cB cen wbr cB cA csdm wbr cB cB ccda
      co cA csdm wbr com cB cdom wbr cB cB ccda co cB cA ensdomtr com cB cdom
      wbr cB cB cdom wbr cB cB ccda co cB cen wbr cB cvv wcel cB cB cdom wbr
      infunabs.2 cB cvv domrefg ax-mp cB cB infunabs.2 infunabs.2 infcdaabs
      mpan2 sylan ancoms syl2an expcom mtoi ex adantl com cA cdom wbr cB cA
      csdm wbr wa cB com csdm wbr cA cB cdif cB cdom wbr wn com cA cdom wbr cB
      cA csdm wbr wa cB com csdm wbr wa com cA cdom wbr cA cB cdif cB cdom wbr
      wn com cA cdom wbr cB cA csdm wbr cB com csdm wbr simpll com cA cdom wbr
      cB cA csdm wbr wa cB com csdm wbr wa cA com csdm wbr wn cA cB cdif cB
      cdom wbr wn com cA cdom wbr com cA cdom wbr cB cA csdm wbr wa cB com csdm
      wbr wa cA cB cdif cB cdom wbr cA com csdm wbr com cA cdom wbr cB cA csdm
      wbr wa cB com csdm wbr wa cA cB cdif cB cdom wbr cA com csdm wbr com cA
      cdom wbr cB cA csdm wbr wa cA cB cdif cB cdom wbr cB com csdm wbr cA com
      csdm wbr cA cB cB ccda co cdom wbr cB cB ccda co com csdm wbr cA com csdm
      wbr com cA cdom wbr cB cA csdm wbr wa cA cB cdif cB cdom wbr wa cB com
      csdm wbr cA cB cB ccda co com domsdomtr cA cA cB cun cen wbr cA cB cun cB
      cB ccda co cdom wbr cA cB cB ccda co cdom wbr com cA cdom wbr cB cA csdm
      wbr wa cA cB cdif cB cdom wbr cA cA cB cun cB cB ccda co endomtr com cA
      cdom wbr cB cA cdom wbr cA cA cB cun cen wbr cB cA csdm wbr com cA cdom
      wbr cB cA cdom wbr wa cA cB cun cA cen wbr cA cA cB cun cen wbr cA cB
      infunabs.1 infunabs.2 infunabs cA cB cun cA infunabs.1 ensym syl cB cA
      sdomdom sylan2 cA cB cdif cB cdom wbr cA cB cdif cB cun cB cB ccda co cA
      cB cun cdom cA cB cdif cB cun cA cB cdif cB ccda co cdom wbr cA cB cdif
      cB ccda co cB cB ccda co cdom wbr cA cB cdif cB cun cB cB ccda co cdom
      wbr cA cB cdif cB cdom wbr cA cB cdif cB cun cA cB cdif cB ccda co cB cB
      ccda co domtr cA cB cdif cB cA cvv wcel cA cB cdif cvv wcel infunabs.1 cA
      cB cvv difexg ax-mp infunabs.2 uncdadom cA cB cdif cB cB cA cvv wcel cA
      cB cdif cvv wcel infunabs.1 cA cB cvv difexg ax-mp infunabs.2 infunabs.2
      cdadom1 sylancr cA cB undif1 syl5eqbrr syl2an cB com csdm wbr cB cB ccda
      co com csdm wbr cB cB cdafi anidms syl2an an1rs ex con3d com cvv wcel cA
      cvv wcel com cA cdom wbr cA com csdm wbr wn wb omex infunabs.1 com cA cvv
      cvv domtri mp2an syl5ib mpd ex jaod mpi cA cB cdif cB cdom wbr cB cA cB
      cdif csdm wbr cA cB cdif cvv wcel cB cvv wcel cA cB cdif cB cdom wbr cB
      cA cB cdif csdm wbr wn wb cA cvv wcel cA cB cdif cvv wcel infunabs.1 cA
      cB cvv difexg ax-mp infunabs.2 cA cB cdif cB cvv cvv domtri mp2an con2bii
      sylibr cB cA cB cdif sdomdom cA cB cun cA cB cdif cB ccda co cdom wbr cA
      cB cdif cB ccda co cA cB cdif cA cB cdif ccda co cdom wbr cA cB cun cA cB
      cdif cA cB cdif ccda co cdom wbr cB cA cB cdif cdom wbr cA cB cun cA cB
      cdif cB ccda co cA cB cdif cA cB cdif ccda co domtr cA cB cdif cB cun cA
      cB cun cA cB cdif cB ccda co cdom cA cB undif1 cA cB cdif cB cA cvv wcel
      cA cB cdif cvv wcel infunabs.1 cA cB cvv difexg ax-mp infunabs.2 uncdadom
      eqbrtrri cB cA cB cdif cA cB cdif infunabs.2 cA cvv wcel cA cB cdif cvv
      wcel infunabs.1 cA cB cvv difexg ax-mp cA cvv wcel cA cB cdif cvv wcel
      infunabs.1 cA cB cvv difexg ax-mp cdadom2 sylancr 3syl sylanc com cA cdom
      wbr cA cA cB cdif cA cB cdif ccda co cdom wbr wa cA cB cdif cA cB cdif
      ccda co cA cB cdif cen wbr cA cA cB cdif cdom wbr com cA cB cdif cdom wbr
      cA cB cdif cA cB cdif cdom wbr cA cB cdif cA cB cdif ccda co cA cB cdif
      cen wbr com cA cdom wbr cA cA cB cdif cA cB cdif ccda co cdom wbr wa cA
      cB cdif cA cB cdif cA cvv wcel cA cB cdif cvv wcel infunabs.1 cA cB cvv
      difexg ax-mp cA cvv wcel cA cB cdif cvv wcel infunabs.1 cA cB cvv difexg
      ax-mp infcdaabs com cA cdom wbr cA cA cB cdif cA cB cdif ccda co cdom wbr
      wa com cA cB cdif cA cB cdif ccda co cdom wbr com cA cB cdif cdom wbr com
      cA cA cB cdif cA cB cdif ccda co domtr cA cB cdif cA cvv wcel cA cB cdif
      cvv wcel infunabs.1 cA cB cvv difexg ax-mp cdainf sylibr cA cB cdif cvv
      wcel cA cB cdif cA cB cdif cdom wbr cA cvv wcel cA cB cdif cvv wcel
      infunabs.1 cA cB cvv difexg ax-mp cA cB cdif cvv domrefg ax-mp sylancl cA
      cA cB cdif cA cB cdif ccda co cdom wbr cA cB cdif cA cB cdif ccda co cA
      cB cdif cen wbr cA cA cB cdif cdom wbr wi com cA cdom wbr cA cA cB cdif
      cA cB cdif ccda co cdom wbr cA cB cdif cA cB cdif ccda co cA cB cdif cen
      wbr cA cA cB cdif cdom wbr cA cA cB cdif cA cB cdif ccda co cA cB cdif
      domentr ex adantl mpd syldan sylancr $.
      $( [23-Oct-2004] $) $( [22-Oct-2004] $)

    $( Cardinality ordering for an infinite set difference. $)
    infdif2 $p |- ( om ~<_ A -> ( ( A \ B ) ~<_ B <-> A ~<_ B ) ) $=
      com cA cdom wbr cA cB cdif cB cdom wbr cA cB cdom wbr com cA cdom wbr cB
      cA cB cdif csdm wbr wn cB cA csdm wbr wn cA cB cdif cB cdom wbr cA cB
      cdom wbr com cA cdom wbr cB cA csdm wbr cB cA cB cdif csdm wbr com cA
      cdom wbr cB cA csdm wbr cB cA cB cdif csdm wbr com cA cdom wbr cB cA csdm
      wbr wa cA cA cB cdif cen wbr cB cA cB cdif csdm wbr com cA cdom wbr cB cA
      csdm wbr wa cA cB cdif cA cen wbr cA cA cB cdif cen wbr cA cB infunabs.1
      infunabs.2 infdif cA cB cdif cA infunabs.1 ensym syl cB cA csdm wbr cA cA
      cB cdif cen wbr cB cA cB cdif csdm wbr wi com cA cdom wbr cB cA csdm wbr
      cA cA cB cdif cen wbr cB cA cB cdif csdm wbr cA cB cdif cvv wcel cB cA
      csdm wbr cA cA cB cdif cen wbr wa cB cA cB cdif csdm wbr wi cA cvv wcel
      cA cB cdif cvv wcel infunabs.1 cA cB cvv difexg ax-mp cB cA cA cB cdif
      cvv sdomentr ax-mp ex adantl mpd ex con3d cA cB cdif cvv wcel cB cvv wcel
      cA cB cdif cB cdom wbr cB cA cB cdif csdm wbr wn wb cA cvv wcel cA cB
      cdif cvv wcel infunabs.1 cA cB cvv difexg ax-mp infunabs.2 cA cB cdif cB
      cvv cvv domtri mp2an cA cvv wcel cB cvv wcel cA cB cdom wbr cB cA csdm
      wbr wn wb infunabs.1 infunabs.2 cA cB cvv cvv domtri mp2an 3imtr4g cA cB
      cdif cA cdom wbr cA cB cdom wbr cA cB cdif cB cdom wbr cA cvv wcel cA cB
      cdif cA wss cA cB cdif cA cdom wbr infunabs.1 cA cB difss cA cB cdif cA
      cvv ssdom2g mp2 cA cB cdif cA cB domtr mpan impbid1 $.
      $( [31-Mar-2007] $) $( [24-Mar-2007] $)

    $( Absorption law for multiplication with an infinite cardinal. $)
    infxpabs $p |- ( ( om ~<_ A /\ B =/= (/) /\ B ~<_ A ) ->
                     ( A X. B ) ~~ A ) $=
      com cA cdom wbr cB cA cdom wbr cB c0 wne cA cB cxp cA cen wbr com cA cdom
      wbr cB cA cdom wbr cB c0 wne cA cB cxp cA cen wbr cA cB cxp cA cdom wbr
      cA cA cB cxp cdom wbr cA cB cxp cA cen wbr com cA cdom wbr cB cA cdom wbr
      wa cB c0 wne cA cB cxp cA sbth cB cA cdom wbr com cA cdom wbr cA cB cxp
      cA cdom wbr cA cB cxp cA cA cxp cdom wbr cA cA cxp cA cen wbr cA cB cxp
      cA cdom wbr cB cA cdom wbr com cA cdom wbr cA cB cxp cA cA cxp cA domentr
      cB cA cA infunabs.1 infunabs.1 xpdom2 cA infunabs.1 infxpidm syl2an
      ancoms cA cB infunabs.1 xpdom3 syl2an 3impa 3com23 $.
      $( [29-Nov-2006] $) $( [30-Sep-2004] $)

    $( Dominance law for multiplication with an infinite cardinal. $)
    infxpdom $p |- ( ( om ~<_ A /\ B ~<_ A ) -> ( A X. B ) ~<_ A ) $=
      com cA cdom wbr cB cA cdom wbr wa cA cB cxp cA cdom wbr cA c0 cxp cA cdom
      wbr cB c0 cB c0 wceq cA cB cxp cA c0 cxp cA cdom cB c0 cA xpeq2 breq1d
      com cA cdom wbr cB cA cdom wbr cB c0 wne cA cB cxp cA cdom wbr com cA
      cdom wbr cB cA cdom wbr cB c0 wne w3a cA cB cxp cA cen wbr cA cB cxp cA
      cdom wbr com cA cdom wbr cB c0 wne cB cA cdom wbr cA cB cxp cA cen wbr cA
      cB infunabs.1 infunabs.2 infxpabs 3com23 cA cB cxp cA endom syl 3expa cA
      c0 cxp cA cdom wbr com cA cdom wbr cB cA cdom wbr wa cA c0 cxp c0 cA cdom
      cA xp0 cA 0dom eqbrtri a1i pm2.61ne $.
      $( [3-Apr-2006] $) $( [26-Mar-2006] $)

    $( Absorption law for multiplication with an infinite cardinal.  Equivalent
       to Proposition 10.41 of [TakeutiZaring] p. 95. $)
    infxp $p |- ( ( om ~<_ A /\ B =/= (/) ) ->
                   ( A X. B ) ~~ ( A u. B ) ) $=
      com cA cdom wbr cB c0 wne wa cB cA cdom wbr cA cB cdom wbr wo cA cB cxp
      cA cB cun cen wbr cB cvv wcel cA cvv wcel cB cA cdom wbr cA cB cdom wbr
      wo infunabs.2 infunabs.1 cB cA cvv cvv entri3 mp2an com cA cdom wbr cB c0
      wne wa cB cA cdom wbr cA cB cxp cA cB cun cen wbr cA cB cdom wbr com cA
      cdom wbr cB c0 wne wa cB cA cdom wbr cA cB cxp cA cB cun cen wbr cA cB
      cxp cA cen wbr cA cA cB cun cen wbr cA cB cxp cA cB cun cen wbr com cA
      cdom wbr cB c0 wne wa cB cA cdom wbr wa cA cB cxp cA cA cB cun entr com
      cA cdom wbr cB c0 wne cB cA cdom wbr cA cB cxp cA cen wbr cA cB
      infunabs.1 infunabs.2 infxpabs 3expa com cA cdom wbr cB cA cdom wbr cA cA
      cB cun cen wbr cB c0 wne com cA cdom wbr cB cA cdom wbr wa cA cB cun cA
      cen wbr cA cA cB cun cen wbr cA cB infunabs.1 infunabs.2 infunabs cA cB
      cun cA infunabs.1 ensym syl adantlr sylanc ex com cA cdom wbr cA cB cdom
      wbr cA cB cxp cA cB cun cen wbr wi cB c0 wne com cA cdom wbr cA cB cdom
      wbr cA cB cxp cA cB cun cen wbr com cA cdom wbr cA cB cdom wbr wa cA cB
      cxp cB cA cun cA cB cun cen com cA cdom wbr cA cB cdom wbr wa com cB cdom
      wbr cA c0 wne cA cB cdom wbr w3a cB cA cxp cB cA cun cen wbr cA cB cxp cB
      cA cun cen wbr com cA cdom wbr cA cB cdom wbr wa com cB cdom wbr cA c0
      wne cA cB cdom wbr com cA cB domtr com cA cdom wbr cA c0 wne cA cB cdom
      wbr cA infunabs.1 infn0 adantr com cA cdom wbr cA cB cdom wbr pm3.27 3jca
      cB cA cxp cB cen wbr cB cB cA cun cen wbr cB cA cxp cB cA cun cen wbr com
      cB cdom wbr cA c0 wne cA cB cdom wbr w3a cB cA cxp cB cB cA cun entr cB
      cA infunabs.2 infunabs.1 infxpabs com cB cdom wbr cA cB cdom wbr cB cB cA
      cun cen wbr cA c0 wne com cB cdom wbr cA cB cdom wbr wa cB cA cun cB cen
      wbr cB cB cA cun cen wbr cB cA infunabs.2 infunabs.1 infunabs cB cA cun
      cB infunabs.2 ensym syl 3adant2 sylanc cA cB cxp cB cA cxp cen wbr cB cA
      cxp cB cA cun cen wbr cA cB cxp cB cA cun cen wbr cA cB infunabs.1
      infunabs.2 xpcomen cA cB cxp cB cA cxp cB cA cun entr mpan 3syl cB cA
      uncom syl6breq ex adantr jaod mpi $.
      $( [1-Dec-2006] $) $( [28-Sep-2004] $)

    $( An exponentiation law for infinite cardinals.  Exercise 34 of [Enderton]
       p. 165. $)
    infmap1 $p |- ( ( ( 2o ~<_ A /\ om ~<_ B ) /\ A ~<_ B ) ->
                  ( A ^m B ) ~~ ( 2o ^m B ) ) $=
      cA cB cdom wbr com cB cdom wbr c2o cA cdom wbr cA cB cm co c2o cB cm co
      cen wbr cA cB cm co c2o cB cm co cdom wbr c2o cB cm co cA cB cm co cdom
      wbr cA cB cm co c2o cB cm co cen wbr cA cB cdom wbr com cB cdom wbr wa
      c2o cA cdom wbr cA cB cm co c2o cB cm co sbth cA cB cm co cB cB cm co
      cdom wbr cB cB cm co c2o cB cm co cdom wbr cA cB cm co c2o cB cm co cdom
      wbr cA cB cdom wbr com cB cdom wbr cA cB cm co cB cB cm co c2o cB cm co
      domtr cA cB cB infunabs.1 infunabs.2 infunabs.2 mapdom1 com cB cdom wbr
      cB cB cxp cB cen wbr c2o cB cB cxp cm co c2o cB cm co cen wbr cB cB cm co
      c2o cB cm co cdom wbr cB infunabs.2 infxpidm c2o c2o cen wbr cB cB cxp cB
      cen wbr c2o cB cB cxp cm co c2o cB cm co cen wbr c2o c2o con0 2on
      elisseti enref c2o c2o cB cB cxp cB c2o con0 2on elisseti c2o con0 2on
      elisseti cB cB infunabs.2 infunabs.2 xpex infunabs.2 mapen mpan cB cB cm
      co c2o cB cB cxp cm co cdom wbr c2o cB cB cxp cm co c2o cB cm co cen wbr
      cB cB cm co c2o cB cm co cdom wbr cB cB cm co c2o cB cm co cB cm co cdom
      wbr c2o cB cm co cB cm co c2o cB cB cxp cm co cen wbr cB cB cm co c2o cB
      cB cxp cm co cdom wbr cB c2o cB cm co cdom wbr cB cB cm co c2o cB cm co
      cB cm co cdom wbr cB cB cpw cdom wbr cB cpw c2o cB cm co cen wbr cB c2o
      cB cm co cdom wbr cB cB cpw csdm wbr cB cB cpw cdom wbr cB infunabs.2
      canth2 cB cB cpw sdomdom ax-mp cB infunabs.2 pw2en cB cB cpw c2o cB cm co
      domentr mp2an cB c2o cB cm co cB infunabs.2 c2o cB cm oprex infunabs.2
      mapdom1 ax-mp c2o cB cB c2o con0 2on elisseti infunabs.2 infunabs.2
      mapxpen cB cB cm co c2o cB cm co cB cm co c2o cB cB cxp cm co domentr
      mp2an cB cB cm co c2o cB cB cxp cm co c2o cB cm co domentr mpan 3syl
      syl2an c2o cA cB c2o con0 2on elisseti infunabs.1 infunabs.2 mapdom1
      syl2an ancom31s $.
      $( [8-Oct-2004] $) $( [30-Sep-2004] $)
  $}

  ${
    $d x y A $.
    infpss.1 $e |- A e. _V $.
    $( Every infinite set has an equinumerous proper subset.  Exercise 7 of
       [TakeutiZaring] p. 91. $)
    infpss $p |- ( om ~<_ A -> E. x ( x C. A /\ x ~~ A ) ) $=
      vy cv cA wcel vy wex com cA cdom wbr vx cv cA wpss vx cv cA cen wbr wa vx
      wex com cA cdom wbr cA c0 wne vy cv cA wcel vy wex cA infpss.1 infn0 vy
      cA n0 sylib vy cv cA wcel com cA cdom wbr vx cv cA wpss vx cv cA cen wbr
      wa vx wex wi vy vy cv cA wcel com cA cdom wbr vx cv cA wpss vx cv cA cen
      wbr wa vx wex cA vy cv csn cdif cA wpss cA vy cv csn cdif cA cen wbr vx
      cv cA wpss vx cv cA cen wbr wa vx wex vy cv cA wcel com cA cdom wbr vx cv
      cA wpss vx cv cA cen wbr wa cA vy cv csn cdif cA wpss cA vy cv csn cdif
      cA cen wbr wa vx cA vy cv csn cdif cA cvv wcel cA vy cv csn cdif cvv wcel
      infpss.1 cA vy cv csn cvv difexg ax-mp vx cv cA vy cv csn cdif wceq vx cv
      cA wpss cA vy cv csn cdif cA wpss vx cv cA cen wbr cA vy cv csn cdif cA
      cen wbr vx cv cA vy cv csn cdif cA psseq1 vx cv cA vy cv csn cdif cA cen
      breq1 anbi12d cla4ev vy cv cA wcel cA vy cv csn cin c0 wceq wn cA vy cv
      csn cdif cA wpss vy cv cA wcel vy cv cA vy cv csn cin wcel cA vy cv csn
      cin c0 wceq wn vy cv cA wcel vy cv cA wcel vy cv vy cv csn wcel wa vy cv
      cA vy cv csn cin wcel vy cv cA wcel vy cv vy cv csn wcel vy cv cA snidg
      ancli vy cv cA vy cv csn elin sylibr cA vy cv csn cin vy cv n0i syl cA vy
      cv csn cin c0 wceq cA vy cv csn cdif cA wpss cA vy cv csn disj4 con2bii
      sylibr com cA cdom wbr vy cv csn cA csdm wbr cA vy cv csn cdif cA cen wbr
      vy cv csn c1o cen wbr c1o cA csdm wbr vy cv csn cA csdm wbr com cA cdom
      wbr vy cv csn c1o cA ensdomtr vy cv vy visset ensn1 com cA cdom wbr c1o
      com wcel c1o cA csdm wbr 1onn cA c1o infpss.1 infsdomnn mpan2 sylancr cA
      vy cv csn infpss.1 vy cv snex infdif mpdan syl2an ex 19.23aiv mpcom $.
      $( [17-Jul-2008] $) $( [23-Oct-2004] $)
  $}

  ${
    $d x A $.
    iunctb.1 $e |- A e. _V $.
    iunctb.2 $e |- B e. _V $.
    $( The countable union of countable sets is countable (indexed union
       version of ~ unictb ). $)
    iunctb $p |- ( ( A ~<_ om /\ A. x e. A B ~<_ om ) ->
                 U_ x e. A B ~<_ om ) $=
      cB com cdom wbr vx cA wral cA com cdom wbr vx cA cB ciun com cdom wbr vx
      cA cB ciun cA com cxp cdom wbr cA com cxp com cdom wbr vx cA cB ciun com
      cdom wbr cB com cdom wbr vx cA wral cA com cdom wbr vx cA cB ciun cA com
      cxp com domtr vx cA com cB iunctb.1 omex iunctb.2 iundom cA com cdom wbr
      com cA cxp com cdom wbr cA com cxp com cdom wbr com com cdom wbr cA com
      cdom wbr com cA cxp com cdom wbr com cvv wcel com com cdom wbr omex com
      cvv domrefg ax-mp com cA omex iunctb.1 infxpdom mpan cA com cxp cvv wcel
      com cA cxp cA com cxp cen wbr com cA cxp com cdom wbr cA com cxp com cdom
      wbr wb cA com iunctb.1 omex xpex com cA omex iunctb.1 xpcomen com cA cxp
      cA com cxp com cvv domen1 mp2an sylib syl2an ancoms $.
      $( [5-Apr-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x A $.
    unictb.1 $e |- A e. _V $.
    $( The countable union of countable sets is countable.  Theorem 6Q of
       [Enderton] p. 159.  See ~ iunctb for indexed union version. $)
    unictb $p |- ( ( A ~<_ om /\ A. x e. A x ~<_ om ) -> U. A ~<_ om ) $=
      cA com cdom wbr vx cv com cdom wbr vx cA wral wa vx cA vx cv ciun com cA
      cuni cdom vx cA vx cv unictb.1 vx visset iunctb vx cA uniiun syl5eqbr $.
      $( [26-Aug-2006] $) $( [26-Mar-2006] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The union of two countable sets is countable.  (Contributed by FL,
       25-Aug-2006.) $)
    unctb $p  |- ( ( A ~<_ om /\ B ~<_ om ) -> ( A u. B ) ~<_ om ) $=
      cA com cdom wbr cB com cdom wbr wa cA cB cpr cuni cA cB cun com cdom cA
      cvv wcel cB cvv wcel cA cB cpr cuni cA cB cun wceq cA com cdom wbr cB com
      cdom wbr cA cB cvv cvv uniprg cA com cdom reldom brrelexi cB com cdom
      reldom brrelexi syl2an cA cB cpr com cdom wbr vx cv com cdom wbr vx cA cB
      cpr wral cA cB cpr cuni com cdom wbr cA com cdom wbr cB com cdom wbr wa
      vx cA cB cpr cA cB prex unictb cA cB cpr com cdom wbr com cA cB cpr cen
      wbr wn cA cB cpr cfn wcel cA cB cpr com cdom wbr com cA cB cpr cen wbr wn
      wa cA cB prfi cA cB cpr isfinite1 ax-mp pm3.26i cA com cdom wbr cB com
      cdom wbr wa vx cv com cdom wbr vx cA cB cpr cA com cdom wbr cB com cdom
      wbr wa vx cv cA wceq vx cv cB wceq wo vx cv com cdom wbr vx cv cA cB cpr
      wcel cA com cdom wbr vx cv cA wceq vx cv com cdom wbr cB com cdom wbr vx
      cv cB wceq vx cv cA wceq vx cv com cdom wbr cA com cdom wbr vx cv cA com
      cdom breq1 biimprcd vx cv cB wceq vx cv com cdom wbr cB com cdom wbr vx
      cv cB com cdom breq1 biimprcd jaao vx cv cA cB vx visset elpr syl5ib
      r19.21aiv sylancr eqbrtrrd $.
      $( [16-Sep-2008] $) $( [25-Aug-2006] $)
  $}

  $( There are at least aleph-one irrationals. $)
  aleph1irr $p |- ( aleph ` 1o ) ~<_ ( RR \ QQ ) $=
    c1o cale cfv cr cdom wbr cr cr cq cdif cen wbr c1o cale cfv cr cq cdif cdom
    wbr aleph1re cr cq cdif cr reex com cr cdom wbr cq cr csdm wbr cr cq cdif
    cr cen wbr com cr csdm wbr com cr cdom wbr com cn cen wbr cn cr csdm wbr
    com cr csdm wbr cn com omex nnenom ensymi ruc com cn cr ensdomtr mp2an com
    cr sdomdom ax-mp resdomq cr cq reex qex infdif mp2an ensymi c1o cale cfv cr
    cr cq cdif domentr mp2an $.
    $( [3-Feb-2005] $) $( [2-Feb-2005] $)

  ${
    $d x y z w v u f A $.  $d x y z w f v u B $.  $d u v f R $.
    infmap2lem.1 $e |- A e. _V $.
    infmap2lem.2 $e |- B e. _V $.
    infmap2lem.3 $e |- R = { <. z , w >. | ( ( z C_ A /\ z ~~ B ) /\
                        w : B -onto-> z ) } $.
      $( Lemma for ~ infmap2 .  Technical result that is used several times. $)
    infmap2lem1 $p |- ( ( f C_ R /\ f Fn dom R ) ->
                       ( v e. { x | ( x C_ A /\ x ~~ B ) } ->
                       ( v C_ A /\ ( f ` v ) : B -onto-> v ) ) ) $=
      vf cv cR wss vf cv cR cdm wfn wa vv cv cR cdm wcel vv cv cA wss cB vv cv
      vv cv vf cv cfv wfo wa vv cv vx cv cA wss vx cv cB cen wbr wa vx cab wcel
      vf cv cR wss vf cv cR cdm wfn vv cv cR cdm wcel vv cv cA wss cB vv cv vv
      cv vf cv cfv wfo wa vf cv cR wss vv cv vv cv vf cv cfv cop vf cv wcel vv
      cv cA wss cB vv cv vv cv vf cv cfv wfo wa vf cv cR cdm wfn vv cv cR cdm
      wcel wa vf cv cR wss vv cv vv cv vf cv cfv cop vf cv wcel vv cv vv cv vf
      cv cfv cop cR wcel vv cv cA wss cB vv cv vv cv vf cv cfv wfo wa vf cv cR
      vv cv vv cv vf cv cfv cop ssel vv cv vv cv vf cv cfv cop cR wcel vv cv cA
      wss vv cv cB cen wbr wa cB vv cv vv cv vf cv cfv wfo wa vv cv cA wss cB
      vv cv vv cv vf cv cfv wfo wa vv cv vv cv vf cv cfv cop cR wcel vv cv vv
      cv vf cv cfv cop vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa
      vz vw copab wcel vv cv cA wss vv cv cB cen wbr wa cB vv cv vv cv vf cv
      cfv wfo wa cR vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vz
      vw copab vv cv vv cv vf cv cfv cop infmap2lem.3 eleq2i vz cv cA wss vz cv
      cB cen wbr wa cB vz cv vw cv wfo wa vv cv cA wss vv cv cB cen wbr wa cB
      vv cv vw cv wfo wa vv cv cA wss vv cv cB cen wbr wa cB vv cv vv cv vf cv
      cfv wfo wa vz vw vv cv vv cv vf cv cfv vv visset vv cv vf cv fvex vz cv
      vv cv wceq vz cv cA wss vz cv cB cen wbr wa vv cv cA wss vv cv cB cen wbr
      wa cB vz cv vw cv wfo cB vv cv vw cv wfo vz cv vv cv wceq vz cv cA wss vv
      cv cA wss vz cv cB cen wbr vv cv cB cen wbr vz cv vv cv cA sseq1 vz cv vv
      cv cB cen breq1 anbi12d vz cv vv cv cB vw cv foeq3 anbi12d vw cv vv cv vf
      cv cfv wceq cB vv cv vw cv wfo cB vv cv vv cv vf cv cfv wfo vv cv cA wss
      vv cv cB cen wbr wa cB vv cv vw cv vv cv vf cv cfv foeq1 anbi2d opelopab
      bitri vv cv cA wss vv cv cB cen wbr wa vv cv cA wss cB vv cv vv cv vf cv
      cfv wfo vv cv cA wss vv cv cB cen wbr pm3.26 anim1i sylbi syl6 cR cdm vv
      cv vf cv fnopfv syl5 expdimp cR cdm vx cv cA wss vx cv cB cen wbr wa vx
      cab vv cv cR cdm vz cv cA wss vz cv cB cen wbr wa vz cab vx cv cA wss vx
      cv cB cen wbr wa vx cab cR cdm vz cv cA wss vz cv cB cen wbr wa cB vz cv
      vw cv wfo wa vz vw copab cdm vz cv cA wss vz cv cB cen wbr wa cB vz cv vw
      cv wfo wa vw wex vz cab vz cv cA wss vz cv cB cen wbr wa vz cab cR vz cv
      cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vz vw copab infmap2lem.3
      dmeqi vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vz vw dmopab
      vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vw wex vz cv cA
      wss vz cv cB cen wbr wa vz vz cv cA wss vz cv cB cen wbr wa cB vz cv vw
      cv wfo vw wex wa vz cv cA wss vz cv cB cen wbr cB vz cv vw cv wfo vw wex
      wa wa vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vw wex vz cv
      cA wss vz cv cB cen wbr wa vz cv cA wss vz cv cB cen wbr cB vz cv vw cv
      wfo vw wex anass vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo vw
      19.42v vz cv cB cen wbr vz cv cB cen wbr cB vz cv vw cv wfo vw wex wa vz
      cv cA wss vz cv cB cen wbr cB vz cv vw cv wfo vw wex vz cv cB cen wbr cB
      vz cv cen wbr cB vz cv vw cv wfo vw wex vz cv cB infmap2lem.2 ensym cB vz
      cv cen wbr cB vz cv vw cv wf1o vw wex cB vz cv vw cv wfo vw wex cB vz cv
      vw vz visset bren cB vz cv vw cv wf1o cB vz cv vw cv wfo vw cB vz cv vw
      cv f1ofo 19.22i sylbi syl pm4.71i anbi2i 3bitr4i abbii 3eqtri vz cv cA
      wss vz cv cB cen wbr wa vx cv cA wss vx cv cB cen wbr wa vz vx vz cv vx
      cv wceq vz cv cA wss vx cv cA wss vz cv cB cen wbr vx cv cB cen wbr vz cv
      vx cv cA sseq1 vz cv vx cv cB cen breq1 anbi12d cbvabv eqtri eleq2i
      syl5ibr $.
      $( [11-Oct-2004] $) $( [1-Oct-2004] $)

    $( Lemma for ~ infmap2 .  Given the relation ` R ` , we use the Axiom of
       Choice ~ ac7g to extract a function ` f ` that provides the one-to-one
       mapping for the dominance relation. $)
    infmap2lem2 $p |- { x | ( x C_ A /\ x ~~ B ) } ~<_ ( A ^m B ) $=
      vf cv cR wss vf cv cR cdm wfn wa vf wex vx cv cA wss vx cv cB cen wbr wa
      vx cab cA cB cm co cdom wbr cR cvv wcel vf cv cR wss vf cv cR cdm wfn wa
      vf wex cR vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vz vw
      copab cvv infmap2lem.3 vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv
      wfo wa vz vw copab vz cv cA cpw wcel vw cv cA cB cm co wcel wa vz vw
      copab cA cpw cA cB cm co cxp vz cv cA cpw wcel vw cv cA cB cm co wcel wa
      vz vw copab cvv vz vw cA cpw cA cB cm co df-xp cA cpw cA cB cm co cA
      infmap2lem.1 pwex cA cB cm oprex xpex eqeltrri vz cv cA wss vz cv cB cen
      wbr wa cB vz cv vw cv wfo wa vz cv cA cpw wcel vw cv cA cB cm co wcel wa
      vz vw vz cv cA wss cB vz cv vw cv wfo vz cv cA cpw wcel vw cv cA cB cm co
      wcel wa vz cv cB cen wbr vz cv cA wss cB vz cv vw cv wfo wa vz cv cA cpw
      wcel vw cv cA cB cm co wcel vz cv cA wss cB vz cv vw cv wfo wa vz cv cA
      wss vz cv cA cpw wcel vz cv cA wss cB vz cv vw cv wfo pm3.26 vz cv cA vz
      visset elpw sylibr vw cv cA cB cm co wcel vw cv cB wfn vw cv crn cA wss
      vz cv cA wss cB vz cv vw cv wfo wa vw cv cA cB cm co wcel cB cA vw cv wf
      vw cv cB wfn vw cv crn cA wss wa cA cB vw cv infmap2lem.1 infmap2lem.2
      elmap cB cA vw cv df-f bitri cB vz cv vw cv wfo vw cv cB wfn vz cv cA wss
      cB vz cv vw cv fofn adantl cB vz cv vw cv wfo vw cv crn cA wss vz cv cA
      wss cB vz cv vw cv wfo vw cv crn vz cv cA cB vz cv vw cv forn sseq1d
      biimparc sylanbrc jca adantlr ssopab2i ssexi eqeltri cvv cR vf ac7g ax-mp
      vf cv cR wss vf cv cR cdm wfn wa vx cv cA wss vx cv cB cen wbr wa vx cab
      cA cB cm co cdom wbr vf vf cv cR wss vf cv cR cdm wfn wa vx cv cA wss vx
      cv cB cen wbr wa vx cab cvv wcel vx cv cA wss vx cv cB cen wbr wa vx cab
      cA cB cm co cdom wbr vx cv cA wss vx cv cB cen wbr wa vx cab vx cv cA wss
      vx cab cA cpw vx cv cA wss vx cab cvv vx cA df-pw cA infmap2lem.1 pwex
      eqeltrri vx cv cA wss vx cv cB cen wbr wa vx cv cA wss vx vx cv cA wss vx
      cv cB cen wbr pm3.26 ss2abi ssexi vf cv cR wss vf cv cR cdm wfn wa vv vu
      vx cv cA wss vx cv cB cen wbr wa vx cab cA cB cm co vv cv vf cv cfv vu cv
      vf cv cfv cvv vf cv cR wss vf cv cR cdm wfn wa vv cv vx cv cA wss vx cv
      cB cen wbr wa vx cab wcel vv cv cA wss cB vv cv vv cv vf cv cfv wfo wa vv
      cv vf cv cfv cA cB cm co wcel vx vz vw vv cA cB cR vf infmap2lem.1
      infmap2lem.2 infmap2lem.3 infmap2lem1 vv cv cA wss cB vv cv vv cv vf cv
      cfv wfo wa cB cA vv cv vf cv cfv wf vv cv vf cv cfv cA cB cm co wcel cB
      vv cv vv cv vf cv cfv wfo vv cv cA wss cB cA vv cv vf cv cfv wf cB vv cv
      vv cv vf cv cfv wf vv cv cA wss cB cA vv cv vf cv cfv wf cB vv cv vv cv
      vf cv cfv wfo cB vv cv cA vv cv vf cv cfv fss cB vv cv vv cv vf cv cfv
      fof sylan ancoms cA cB vv cv vf cv cfv infmap2lem.1 infmap2lem.2 elmap
      sylibr syl6 vf cv cR wss vf cv cR cdm wfn wa vv cv vx cv cA wss vx cv cB
      cen wbr wa vx cab wcel vu cv vx cv cA wss vx cv cB cen wbr wa vx cab wcel
      wa cB vv cv vv cv vf cv cfv wfo cB vu cv vu cv vf cv cfv wfo wa vv cv vf
      cv cfv vu cv vf cv cfv wceq vv cv vu cv wceq wb vf cv cR wss vf cv cR cdm
      wfn wa vv cv vx cv cA wss vx cv cB cen wbr wa vx cab wcel cB vv cv vv cv
      vf cv cfv wfo vu cv vx cv cA wss vx cv cB cen wbr wa vx cab wcel cB vu cv
      vu cv vf cv cfv wfo vf cv cR wss vf cv cR cdm wfn wa vv cv vx cv cA wss
      vx cv cB cen wbr wa vx cab wcel vv cv cA wss cB vv cv vv cv vf cv cfv wfo
      wa cB vv cv vv cv vf cv cfv wfo vx vz vw vv cA cB cR vf infmap2lem.1
      infmap2lem.2 infmap2lem.3 infmap2lem1 vv cv cA wss cB vv cv vv cv vf cv
      cfv wfo pm3.27 syl6 vf cv cR wss vf cv cR cdm wfn wa vu cv vx cv cA wss
      vx cv cB cen wbr wa vx cab wcel vu cv cA wss cB vu cv vu cv vf cv cfv wfo
      wa cB vu cv vu cv vf cv cfv wfo vx vz vw vu cA cB cR vf infmap2lem.1
      infmap2lem.2 infmap2lem.3 infmap2lem1 vu cv cA wss cB vu cv vu cv vf cv
      cfv wfo pm3.27 syl6 anim12d cB vv cv vv cv vf cv cfv wfo cB vu cv vu cv
      vf cv cfv wfo wa vv cv vf cv cfv vu cv vf cv cfv wceq vv cv vu cv wceq cB
      vv cv vv cv vf cv cfv wfo cB vu cv vu cv vf cv cfv wfo wa vv cv vf cv cfv
      crn vu cv vf cv cfv crn wceq vv cv vu cv wceq vv cv vf cv cfv vu cv vf cv
      cfv wceq cB vv cv vv cv vf cv cfv wfo cB vu cv vu cv vf cv cfv wfo vv cv
      vf cv cfv crn vv cv vu cv vf cv cfv crn vu cv cB vv cv vv cv vf cv cfv
      forn cB vu cv vu cv vf cv cfv forn eqeqan12d vv cv vf cv cfv vu cv vf cv
      cfv rneq syl5bi vv cv vu cv vf cv fveq2 impbid1 syl6 dom2d mpi 19.23aiv
      ax-mp $.
      $( [11-Oct-2004] $) $( [30-Sep-2004] $)
  $}

  ${
    $d x z w A $.  $d x z w B $.
    infmap2.1 $e |- A e. _V $.
    infmap2.2 $e |- B e. _V $.
    $( An exponentiation law for infinite cardinals.  Similar to Lemma 6.2 of
       [Jech] p. 43.  We start with ~ infmap2lem2 and also prove the other
       direction of the dominance relation.  We obtain equinumerosity with
       Schroeder-Bernstein ~ sbth and finally eliminate the degenerate case
       ` B = (/) ` . $)
    infmap2 $p |- ( ( om ~<_ A /\ B ~<_ A ) ->
                      ( A ^m B ) ~~ { x | ( x C_ A /\ x ~~ B ) } ) $=
      com cA cdom wbr cB cA cdom wbr wa cA cB cm co vx cv cA wss vx cv cB cen
      wbr wa vx cab cen wbr cA c0 cm co vx cv cA wss vx cv c0 cen wbr wa vx cab
      cen wbr cB c0 cB c0 wceq cA cB cm co cA c0 cm co vx cv cA wss vx cv cB
      cen wbr wa vx cab vx cv cA wss vx cv c0 cen wbr wa vx cab cen cB c0 cA cm
      opreq2 cB c0 wceq vx cv cA wss vx cv cB cen wbr wa vx cv cA wss vx cv c0
      cen wbr wa vx cB c0 wceq vx cv cB cen wbr vx cv c0 cen wbr vx cv cA wss
      cB c0 vx cv cen breq2 anbi2d abbidv breq12d cA cB cm co vx cv cA wss vx
      cv cB cen wbr wa vx cab cdom wbr vx cv cA wss vx cv cB cen wbr wa vx cab
      cA cB cm co cdom wbr cA cB cm co vx cv cA wss vx cv cB cen wbr wa vx cab
      cen wbr com cA cdom wbr cB cA cdom wbr wa cB c0 wne wa cA cB cm co vx cv
      cA wss vx cv cB cen wbr wa vx cab sbth com cA cdom wbr cB cA cdom wbr wa
      cB c0 wne wa cB cA cxp cA cen wbr vx cv cB cA cxp wss vx cv cB cen wbr wa
      vx cab vx cv cA wss vx cv cB cen wbr wa vx cab cen wbr cA cB cm co vx cv
      cA wss vx cv cB cen wbr wa vx cab cdom wbr cB cA cxp cA cB cxp cen wbr cA
      cB cxp cA cen wbr cB cA cxp cA cen wbr com cA cdom wbr cB cA cdom wbr wa
      cB c0 wne wa cB cA cxp cA cB cxp cA entr cB cA infmap2.2 infmap2.1
      xpcomen com cA cdom wbr cB cA cdom wbr cB c0 wne cA cB cxp cA cen wbr com
      cA cdom wbr cB c0 wne cB cA cdom wbr cA cB cxp cA cen wbr cA cB infmap2.1
      infmap2.2 infxpabs 3com23 3expa sylancr vx cB cA cxp cA cB cB cA
      infmap2.2 infmap2.1 xpex infmap2.1 ssenen cA cB cm co vx cv cB cA cxp wss
      vx cv cB cen wbr wa vx cab cdom wbr vx cv cB cA cxp wss vx cv cB cen wbr
      wa vx cab vx cv cA wss vx cv cB cen wbr wa vx cab cen wbr cA cB cm co vx
      cv cA wss vx cv cB cen wbr wa vx cab cdom wbr cA cB cm co cvv wcel cA cB
      cm co vx cv cB cA cxp wss vx cv cB cen wbr wa vx cab wss cA cB cm co vx
      cv cB cA cxp wss vx cv cB cen wbr wa vx cab cdom wbr cA cB cm oprex cA cB
      cm co vx cv cA cB cm co wcel vx cab vx cv cB cA cxp wss vx cv cB cen wbr
      wa vx cab vx cA cB cm co abid2 vx cv cA cB cm co wcel vx cv cB cA cxp wss
      vx cv cB cen wbr wa vx vx cv cA cB cm co wcel cB cA vx cv wf vx cv cB cA
      cxp wss vx cv cB cen wbr wa cA cB vx cv infmap2.1 infmap2.2 elmap cB cA
      vx cv wf vx cv cB cA cxp wss vx cv cB cen wbr cB cA vx cv fssxp cB cA vx
      cv wf vx cv vx cv cdm cB cen cB cA vx cv wf vx cv wfun vx cv cdm vx cv
      cen wbr vx cv vx cv cdm cen wbr cB cA vx cv ffun vx cv vx visset fundmen
      vx cv cdm vx cv vx visset ensym 3syl cB cA vx cv fdm breqtrd jca sylbi
      ss2abi eqsstr3i cA cB cm co vx cv cB cA cxp wss vx cv cB cen wbr wa vx
      cab cvv ssdomg mp2 cA cB cm co vx cv cB cA cxp wss vx cv cB cen wbr wa vx
      cab vx cv cA wss vx cv cB cen wbr wa vx cab domentr mpan 3syl vx vz vw cA
      cB vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo wa vz vw copab
      infmap2.1 infmap2.2 vz cv cA wss vz cv cB cen wbr wa cB vz cv vw cv wfo
      wa vz vw copab eqid infmap2lem2 sylancl cA c0 cm co vx cv cA wss vx cv c0
      cen wbr wa vx cab cen wbr com cA cdom wbr cB cA cdom wbr wa c1o c1o cA c0
      cm co vx cv cA wss vx cv c0 cen wbr wa vx cab cen c1o c1o com 1onn
      elisseti enref cA infmap2.1 map0e c0 csn vx cv c0 wceq vx cab c1o vx cv
      cA wss vx cv c0 cen wbr wa vx cab vx c0 df-sn df1o2 vx cv cA wss vx cv c0
      cen wbr wa vx cv c0 wceq vx vx cv cA wss vx cv c0 cen wbr wa vx cv cA wss
      vx cv c0 wceq wa vx cv c0 wceq vx cv c0 cen wbr vx cv c0 wceq vx cv cA
      wss vx cv en0 anbi2i vx cv c0 wceq vx cv cA wss vx cv c0 wceq vx cv cA
      wss c0 cA wss cA 0ss vx cv c0 cA sseq1 mpbiri pm4.71ri bitr4i abbii
      3eqtr4ri 3brtr4i a1i pm2.61ne $.
      $( [11-Oct-2004] $) $( [1-Oct-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The sum of two alephs is their maximum.  Equation 6.1 of [Jech]
       p. 42. $)
    alephadd $p |- ( ( aleph ` A ) +c ( aleph ` B ) ) ~~
                   ( ( aleph ` A ) u. ( aleph ` B ) ) $=
      cA con0 wcel cB con0 wcel cA cale cfv cB cale cfv ccda co cA cale cfv cB
      cale cfv cun cen wbr cA con0 wcel wn cB con0 wcel wn cA cale cfv cB cale
      cfv ccda co cA cale cfv cB cale cfv cun cen wbr cA con0 wcel wn cB con0
      wcel wn wa cA cale cfv cB cale cfv ccda co cA cale cfv cB cale cfv cun
      wceq cA cale cfv cB cale cfv ccda co cA cale cfv cB cale cfv cun cen wbr
      cA cale cdm wcel wn cB cale cdm wcel wn cA cale cfv cB cale cfv ccda co
      cA cale cfv cB cale cfv cun wceq cA con0 wcel wn cB con0 wcel wn cA cale
      cdm wcel wn cB cale cdm wcel wn wa c0 c0 ccda co c0 cA cale cfv cB cale
      cfv ccda co cA cale cfv cB cale cfv cun c0 c0 ccda co c0 c0 csn cxp c0
      c1o csn cxp cun c0 c0 csn c1o csn cun cxp c0 c0 c0 0ex 0ex cdavali c0 c0
      csn c1o csn xpundi c0 csn c1o csn cun xp0r 3eqtr2i cA cale cdm wcel wn cB
      cale cdm wcel wn cA cale cfv c0 cB cale cfv c0 ccda cA cale ndmfv cB cale
      ndmfv opreqan12d cA cale cdm wcel wn cB cale cdm wcel wn wa cA cale cfv
      cB cale cfv cun c0 c0 cun c0 cA cale cdm wcel wn cB cale cdm wcel wn wa
      cA cale cfv c0 cB cale cfv c0 cA cale cdm wcel wn cA cale cfv c0 wceq cB
      cale cdm wcel wn cA cale ndmfv adantr cB cale cdm wcel wn cB cale cfv c0
      wceq cA cale cdm wcel wn cB cale ndmfv adantl uneq12d c0 un0 syl6eq
      3eqtr4a cA cale cdm wcel cA con0 wcel cale cdm con0 cA cale con0 wfn cale
      cdm con0 wceq alephfnon con0 cale fndm ax-mp eleq2i notbii cB cale cdm
      wcel cB con0 wcel cale cdm con0 cB cale con0 wfn cale cdm con0 wceq
      alephfnon con0 cale fndm ax-mp eleq2i notbii syl2anbr cA cale cfv cB cale
      cfv ccda co cvv wcel cA cale cfv cB cale cfv ccda co cA cale cfv cB cale
      cfv cun wceq cA cale cfv cB cale cfv ccda co cA cale cfv cB cale cfv cun
      cen wbr wi cA cale cfv cB cale cfv ccda oprex cA cale cfv cB cale cfv
      ccda co cA cale cfv cB cale cfv cun cvv eqeng ax-mp syl ex cA con0 wcel
      com cA cale cfv wss cA cale cfv cB cale cfv ccda co cA cale cfv cB cale
      cfv cun cen wbr cA alephgeom com cA cale cfv wss com cA cale cfv cdom wbr
      cA cale cfv cB cale cfv ccda co cA cale cfv cB cale cfv cun cen wbr cA
      cale cfv cvv wcel com cA cale cfv wss com cA cale cfv cdom wbr wi cA cale
      fvex com cA cale cfv cvv ssdom2g ax-mp cA cale cfv cB cale cfv cA cale
      fvex cB cale fvex infcda syl sylbi cB con0 wcel com cB cale cfv wss cA
      cale cfv cB cale cfv ccda co cA cale cfv cB cale cfv cun cen wbr cB
      alephgeom com cB cale cfv wss com cB cale cfv cdom wbr cA cale cfv cB
      cale cfv ccda co cA cale cfv cB cale cfv cun cen wbr cB cale cfv cvv wcel
      com cB cale cfv wss com cB cale cfv cdom wbr wi cB cale fvex com cB cale
      cfv cvv ssdom2g ax-mp com cB cale cfv cdom wbr cA cale cfv cB cale cfv
      ccda co cB cale cfv cA cale cfv cun cA cale cfv cB cale cfv cun cen cA
      cale cfv cB cale cfv ccda co cB cale cfv cA cale cfv ccda co cen wbr cB
      cale cfv cA cale cfv ccda co cB cale cfv cA cale cfv cun cen wbr cA cale
      cfv cB cale cfv ccda co cB cale cfv cA cale cfv cun cen wbr com cB cale
      cfv cdom wbr cA cale cfv cB cale cfv ccda co cB cale cfv cA cale cfv ccda
      co cB cale cfv cA cale cfv cun entr cA cale cfv cB cale cfv cA cale fvex
      cB cale fvex cdacomen cB cale cfv cA cale cfv cB cale fvex cA cale fvex
      infcda sylancr cB cale cfv cA cale cfv uncom syl6breq syl sylbi pm2.61ii
      $.
      $( [30-Mar-2005] $) $( [29-Sep-2004] $)

    $( The product of two alephs is their maximum.  Equation 6.1 of [Jech]
       p. 42. $)
    alephmul $p |- ( ( A e. On /\ B e. On ) ->
  ( ( aleph ` A ) X. ( aleph ` B ) ) ~~ ( ( aleph ` A ) u. ( aleph ` B ) ) ) $=
      com cA cale cfv cdom wbr cB cale cfv c0 wne cA cale cfv cB cale cfv cxp
      cA cale cfv cB cale cfv cun cen wbr cA con0 wcel cB con0 wcel cA cale cfv
      cB cale cfv cA cale fvex cB cale fvex infxp cA con0 wcel com cA cale cfv
      wss com cA cale cfv cdom wbr cA alephgeom cA cale cfv cvv wcel com cA
      cale cfv wss com cA cale cfv cdom wbr wi cA cale fvex com cA cale cfv cvv
      ssdom2g ax-mp sylbi cB con0 wcel com cB cale cfv wss cB cale cfv c0 wne
      cB alephgeom com cB cale cfv wss com cB cale cfv cdom wbr cB cale cfv c0
      wne cB cale cfv cvv wcel com cB cale cfv wss com cB cale cfv cdom wbr wi
      cB cale fvex com cB cale cfv cvv ssdom2g ax-mp cB cale cfv cB cale fvex
      infn0 syl sylbi syl2an $.
      $( [16-Jun-2007] $) $( [29-Sep-2004] $)

    $( An exponentiation law for alephs.  Lemma 6.1 of [Jech] p. 42. $)
    alephexp1 $p |- ( ( ( A e. On /\ B e. On ) /\ A C_ B ) ->
  ( ( aleph ` A ) ^m ( aleph ` B ) ) ~~ ( 2o ^m ( aleph ` B ) ) ) $=
      c2o cA cale cfv cdom wbr com cB cale cfv cdom wbr wa cA cale cfv cB cale
      cfv cdom wbr cA cale cfv cB cale cfv cm co c2o cB cale cfv cm co cen wbr
      cA con0 wcel cB con0 wcel wa cA cB wss wa cA cale cfv cB cale cfv cA cale
      fvex cB cale fvex infmap1 cA con0 wcel cB con0 wcel wa c2o cA cale cfv
      cdom wbr com cB cale cfv cdom wbr wa cA cB wss cA con0 wcel c2o cA cale
      cfv cdom wbr cB con0 wcel com cB cale cfv cdom wbr c2o com cdom wbr com
      cA cale cfv cdom wbr c2o cA cale cfv cdom wbr cA con0 wcel c2o com cA
      cale cfv domtr c2o com csdm wbr c2o com cdom wbr c2o com wcel c2o com
      csdm wbr 2onn c2o nnsdom ax-mp c2o com sdomdom ax-mp cA con0 wcel com cA
      cale cfv wss com cA cale cfv cdom wbr cA alephgeom cA cale cfv cvv wcel
      com cA cale cfv wss com cA cale cfv cdom wbr wi cA cale fvex com cA cale
      cfv cvv ssdom2g ax-mp sylbi sylancr cB con0 wcel com cB cale cfv wss com
      cB cale cfv cdom wbr cB alephgeom cB cale cfv cvv wcel com cB cale cfv
      wss com cB cale cfv cdom wbr wi cB cale fvex com cB cale cfv cvv ssdom2g
      ax-mp sylbi anim12i adantr cA con0 wcel cB con0 wcel wa cA cB wss cA cale
      cfv cB cale cfv cdom wbr cA con0 wcel cB con0 wcel wa cA cB wss cA cale
      cfv cB cale cfv wss cA cale cfv cB cale cfv cdom wbr cA cB alephord3 cA
      cale cfv cvv wcel cA cale cfv cB cale cfv wss cA cale cfv cB cale cfv
      cdom wbr wi cA cale fvex cA cale cfv cB cale cfv cvv ssdomg ax-mp syl6bi
      imp sylanc $.
      $( [8-Oct-2004] $) $( [29-Sep-2004] $)
  $}

  ${
    $d x A $.
    $( An alternate representation of a successor aleph.  Compare ~ alephsuc
       and ~ alephsuc2 .  Equality can be obtained by taking the ` card `
       of the right-hand side then using ~ alephcard and ~ carden . $)
    alephsuc3 $p |- ( A e. On ->
               ( aleph ` suc A ) ~~ { x e. On | x ~~ ( aleph ` A ) } ) $=
      cA con0 wcel vx cv cA cale cfv cen wbr vx con0 crab cA csuc cale cfv cen
      wbr cA csuc cale cfv vx cv cA cale cfv cen wbr vx con0 crab cen wbr cA
      con0 wcel vx cv cA cale cfv cen wbr vx con0 crab cA csuc cale cfv cA cale
      cfv cdif cA csuc cale cfv cen cA con0 wcel cA csuc cale cfv cA cale cfv
      cdif vx cv cA cale cfv cdom wbr vx con0 crab vx cv cA cale cfv csdm wbr
      vx con0 crab cdif vx cv cA cale cfv cen wbr vx con0 crab cA con0 wcel cA
      csuc cale cfv cA cale cfv cdif vx cv cA cale cfv cdom wbr vx con0 crab cA
      cale cfv cdif vx cv cA cale cfv cdom wbr vx con0 crab vx cv cA cale cfv
      csdm wbr vx con0 crab cdif cA con0 wcel cA csuc cale cfv vx cv cA cale
      cfv cdom wbr vx con0 crab cA cale cfv vx cA alephsuc2 difeq1d cA con0
      wcel cA cale cfv vx cv cA cale cfv csdm wbr vx con0 crab vx cv cA cale
      cfv cdom wbr vx con0 crab cA cale cfv vx cv cA cale cfv csdm wbr vx con0
      crab wceq cA con0 wcel cA cale cfv ccrd cfv cA cale cfv vx cv cA cale cfv
      csdm wbr vx con0 crab cA alephcard vx cA cale cfv cardval2 eqtr3i a1i
      difeq2d eqtrd vx cv cA cale cfv cdom wbr vx con0 crab vx cv cA cale cfv
      csdm wbr vx con0 crab cdif vx cv cA cale cfv cdom wbr vx cv cA cale cfv
      csdm wbr wn wa vx con0 crab vx cv cA cale cfv cen wbr vx con0 crab vx cv
      cA cale cfv cdom wbr vx cv cA cale cfv csdm wbr vx con0 difrab vx cv cA
      cale cfv cen wbr vx cv cA cale cfv cdom wbr vx cv cA cale cfv csdm wbr wn
      wa vx con0 vx cv cA cale cfv cen wbr vx cv cA cale cfv cdom wbr vx cv cA
      cale cfv csdm wbr wn wa wb vx cv con0 wcel vx cv cA cale cfv bren2 a1i
      rabbii eqtr4i syl6req com cA csuc cale cfv cdom wbr cA cale cfv cA csuc
      cale cfv csdm wbr cA csuc cale cfv cA cale cfv cdif cA csuc cale cfv cen
      wbr cA con0 wcel cA csuc cale cfv cA cale cfv cA csuc cale fvex cA cale
      fvex infdif cA con0 wcel com cA csuc cale cfv wss com cA csuc cale cfv
      cdom wbr cA con0 wcel cA csuc con0 wcel com cA csuc cale cfv wss cA
      sucelon cA csuc alephgeom bitri cA csuc cale cfv cvv wcel com cA csuc
      cale cfv wss com cA csuc cale cfv cdom wbr wi cA csuc cale fvex com cA
      csuc cale cfv cvv ssdom2g ax-mp sylbi cA alephordlem1 sylanc eqbrtrd vx
      cv cA cale cfv cen wbr vx con0 crab cA csuc cale cfv cA csuc cale fvex
      ensym syl $.
      $( [23-Oct-2004] $) $( [23-Oct-2004] $)

    $( An expression equinumerous to 2 to an aleph power.  The proof equates
       the two laws for cardinal exponentiation ~ alephexp1 (which works if the
       base is less than or equal to the exponent) and ~ infmap2 (which works
       if the exponent is less than or equal to the base).  They can be equated
       only when the base is equal to the exponent, and this is the result. $)
    alephexp2 $p |- ( A e. On -> ( 2o ^m ( aleph ` A ) ) ~~
          { x | ( x C_ ( aleph ` A ) /\ x ~~ ( aleph ` A ) ) } ) $=
      cA con0 wcel cA cale cfv cA cale cfv cm co vx cv cA cale cfv wss vx cv cA
      cale cfv cen wbr wa vx cab cen wbr c2o cA cale cfv cm co vx cv cA cale
      cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr com cA cale cfv cdom
      wbr cA cale cfv cA cale cfv cdom wbr cA cale cfv cA cale cfv cm co vx cv
      cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr cA con0 wcel
      vx cA cale cfv cA cale cfv cA cale fvex cA cale fvex infmap2 cA con0 wcel
      com cA cale cfv wss com cA cale cfv cdom wbr cA alephgeom cA cale cfv cvv
      wcel com cA cale cfv wss com cA cale cfv cdom wbr wi cA cale fvex com cA
      cale cfv cvv ssdom2g ax-mp sylbi cA cale cfv cvv wcel cA cale cfv cA cale
      cfv cdom wbr cA cale fvex cA cale cfv cvv domrefg ax-mp sylancl cA con0
      wcel cA con0 wcel cA con0 wcel wa cA cA wss wa cA cale cfv cA cale cfv cm
      co c2o cA cale cfv cm co cen wbr cA cale cfv cA cale cfv cm co vx cv cA
      cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr c2o cA cale cfv
      cm co vx cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr
      wb cA con0 wcel cA con0 wcel cA con0 wcel wa cA cA wss cA con0 wcel cA
      con0 wcel cA con0 wcel wa cA con0 wcel cA con0 wcel pm3.2 pm2.43i cA ssid
      jctir cA cA alephexp1 c2o cA cale cfv cm co cvv wcel cA cale cfv cA cale
      cfv cm co c2o cA cale cfv cm co cen wbr cA cale cfv cA cale cfv cm co vx
      cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr c2o cA
      cale cfv cm co vx cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab
      cen wbr wb c2o cA cale cfv cm oprex cA cale cfv cA cale cfv cm co c2o cA
      cale cfv cm co vx cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab
      cvv enen1 mpan 3syl mpbid $.
      $( [23-Oct-2004] $) $( [23-Oct-2004] $)

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Continuum Hypothesis
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( The equivalence of two versions of the Generalized Continuum Hypothesis.
       The right-hand side is the standard version in the literature.  The
       left-hand side is a version devised by Kannan Nambiar, which he calls
       the Axiom of Combinatorial Sets.  For the notation and motivation
       behind this axiom, see his paper, "Derivation of Continuum Hypothesis
       from Axiom of Combinatorial Sets," available at
       ~ http://www.e-atheneum.net/science/derivation&#95;ch.pdf .
       The equivalence of the two sides provides a negative answer to Open
       Problem 2 in
       ~ http://www.e-atheneum.net/science/open&#95;problem&#95;print.pdf .
       The key idea in the proof below is to equate both sides of
       ~ alephexp2 to the successor aleph using ~ enen2 . $)
    gch-kn $p |- ( A e. On -> ( ( aleph ` suc A ) ~~
                { x | ( x C_ ( aleph ` A ) /\ x ~~ ( aleph ` A ) ) } <->
                ( aleph ` suc A ) ~~ ( 2o ^m ( aleph ` A ) ) ) ) $=
      cA con0 wcel cA csuc cale cfv c2o cA cale cfv cm co cen wbr cA csuc cale
      cfv vx cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr vx
      cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cvv wcel c2o cA
      cale cfv cm co vx cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab
      cen wbr cA csuc cale cfv c2o cA cale cfv cm co cen wbr cA csuc cale cfv
      vx cv cA cale cfv wss vx cv cA cale cfv cen wbr wa vx cab cen wbr wb cA
      con0 wcel c2o cA cale cfv cm co vx cv cA cale cfv wss vx cv cA cale cfv
      cen wbr wa vx cab cA csuc cale cfv cvv enen2 vx cv cA cale cfv wss vx cv
      cA cale cfv cen wbr wa vx cab vx cv cA cale cfv wss vx cab cA cale cfv
      cpw vx cv cA cale cfv wss vx cab cvv vx cA cale cfv df-pw cA cale cfv cA
      cale fvex pwex eqeltrri vx cv cA cale cfv wss vx cv cA cale cfv cen wbr
      wa vx cv cA cale cfv wss vx vx cv cA cale cfv wss vx cv cA cale cfv cen
      wbr pm3.26 ss2abi ssexi vx cA alephexp2 sylancr bicomd $.
      $( [11-Jan-2006] $) $( [1-Oct-2004] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Topology
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Topological spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols and define their syntactical properties. $)

  $c Top $.
  $c TopSp $.
  $c Bases $.
  $c topGen $.

  $( Extend class notation with the class of all topologies. $)
  ctop $a class Top $.

  $( Extend class notation with the class of all topological spaces. $)
  ctps $a class TopSp $.

  $( Extend class notation with the class of all topological bases. $)
  ctb $a class Bases $.

  $( Extend class notation with a function that converts a basis to its
     corresponding topology. $)
  ctg $a class topGen $.

  ${
    $d x y z w v $.
    $( Define the (proper) class of all topologies.  See ~ istop2g for an
       alternate way to express finite intersection and ~ istps5 for a
       standard definition in terms of both members of a topological space. $)
    df-top $a |- Top = { x | ( A. y ( y C_ x -> U. y e. x ) /\
                           A. y e. x A. z e. x ( y i^i z ) e. x ) } $.

    $( Define the class of all topological spaces, each of which is an
       ordered pair the second of which is a topology on the first.  See
       ~ istps5 for a standard way to express a topological space. $)
    df-topsp $a |- TopSp = { <. x , y >. | ( y e. Top /\ x = U. y ) } $.

    $( Define the class of all topological bases.  Equivalent to definition of
       basis in [Munkres] p. 78 (see ~ isbasis2g ).  Note that "bases" is the
       plural of "basis." $)
    df-bases $a |- Bases = { x | A. y e. x A. z e. x ( y i^i z ) C_
                      U. ( x i^i ~P ( y i^i z ) ) } $.

    $( Define a function that converts a basis to its corresponding
       topology.  Equivalent to the definition of a topology generated by a
       basis in [Munkres] p. 78 (see ~ tgval2 ).  See ~ tgval3 for an
       alternate expression for the value. $)
    df-topgen $a |- topGen = { <. x , y >. | ( x e. Bases /\ y =
       { z | z C_ U. ( x i^i ~P z ) } ) } $.
  $}

  ${
    $d x y z J $.
    $( Express the predicate " ` J ` is a topology."  Note:  In the literature,
       a topology is often represented by a script letter T, which resembles
       the letter J.  This confusion has led to J being used by some authors -
       e.g. K. D. Joshi, _Introduction to General Topology_ (1983), p. 114 -
       and it is convenient for us since we later use ` T ` to represent linear
       transformations (operators).  (Contributed by Stefan Allan,
       3-Mar-2006.) $)
    istopg $p |- ( J e. A -> ( J e. Top <-> ( A. x ( x C_ J -> U. x e. J )
                  /\ A. x e. J A. y e. J ( x i^i y ) e. J ) ) ) $=
      vx cv vz cv wss vx cv cuni vz cv wcel wi vx wal vx cv vy cv cin vz cv
      wcel vy vz cv wral vx vz cv wral wa vx cv cJ wss vx cv cuni cJ wcel wi vx
      wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral wa vz cJ ctop cA vz cv
      cJ wceq vx cv vz cv wss vx cv cuni vz cv wcel wi vx wal vx cv cJ wss vx
      cv cuni cJ wcel wi vx wal vx cv vy cv cin vz cv wcel vy vz cv wral vx vz
      cv wral vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral vz cv cJ wceq vx cv
      vz cv wss vx cv cuni vz cv wcel wi vx cv cJ wss vx cv cuni cJ wcel wi vx
      vz cv cJ wceq vx cv vz cv wss vx cv cJ wss vx cv cuni vz cv wcel vx cv
      cuni cJ wcel vz cv cJ vx cv sseq2 vz cv cJ vx cv cuni eleq2 imbi12d
      albidv vx cv vy cv cin vz cv wcel vy vz cv wral vx cv vy cv cin cJ wcel
      vy cJ wral vx vz cv cJ vx cv vy cv cin vz cv wcel vx cv vy cv cin cJ wcel
      vy vz cv cJ vz cv cJ vx cv vy cv cin eleq2 raleqd raleqd anbi12d vz vx vy
      df-top elab2g $.
      $( [18-Jul-2006] $) $( [3-Mar-2006] $)

    $( Express the predicate " ` J ` is a topology," using "the intersection of
       the elements of any finite subcollection" instead of the intersection of
       any two elements. $)
    istop2g $p |- ( J e. A -> ( J e. Top <-> ( A. x ( x C_ J -> U. x e. J )
         /\ A. x ( ( x C_ J /\ x =/= (/) /\ x e. Fin ) -> |^| x e. J ) ) ) ) $=
      cJ cA wcel cJ ctop wcel vx cv cJ wss vx cv cuni cJ wcel wi vx wal vx cv
      vy cv cin cJ wcel vy cJ wral vx cJ wral wa vx cv cJ wss vx cv cuni cJ
      wcel wi vx wal vx cv cJ wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cJ
      wcel wi vx wal wa vx vy cA cJ istopg vx cv vy cv cin cJ wcel vy cJ wral
      vx cJ wral vx cv cJ wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cJ
      wcel wi vx wal vx cv cJ wss vx cv cuni cJ wcel wi vx wal vx vy cJ fiint
      anbi2i syl6bb $.
      $( [23-Dec-2008] $) $( [19-Jul-2006] $)
  $}

  ${
   $d x y A $.  $d y B $.  $d x y J $.
   $( The union of a subset of a topology is an open set.  (Contributed by
      Stefan Allan, 27-Feb-2006.) $)
    uniopn $p |- ( ( J e. Top /\ A C_ J ) -> U. A e. J ) $=
      cJ ctop wcel cA cJ wss cA cuni cJ wcel cJ ctop wcel cA cJ wss vx cv cJ
      wss vx cv cuni cJ wcel wi vx wal cA cuni cJ wcel cJ ctop wcel vx cv cJ
      wss vx cv cuni cJ wcel wi vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ
      wral cJ ctop wcel vx cv cJ wss vx cv cuni cJ wcel wi vx wal vx cv vy cv
      cin cJ wcel vy cJ wral vx cJ wral wa vx vy ctop cJ istopg ibi pm3.26d cJ
      ctop wcel cA cJ wss vx cv cJ wss vx cv cuni cJ wcel wi vx wal cA cuni cJ
      wcel wi cJ ctop wcel cA cJ wss cA cJ wss vx cv cJ wss vx cv cuni cJ wcel
      wi vx wal cA cuni cJ wcel wi wi cJ ctop wcel cA cJ wss wa vx cv cJ wss vx
      cv cuni cJ wcel wi vx wal cA cJ wss cA cuni cJ wcel cJ ctop wcel cA cJ
      wss wa cA cJ cpw wcel vx cv cJ wss vx cv cuni cJ wcel wi vx wal cA cJ wss
      cA cuni cJ wcel wi wi cJ ctop wcel cA cJ cpw wcel cA cJ wss cA cJ ctop
      elpw2g biimpar vx cv cJ wss vx cv cuni cJ wcel wi cA cJ wss cA cuni cJ
      wcel wi vx cA cJ cpw vx cv cA wceq vx cv cJ wss cA cJ wss vx cv cuni cJ
      wcel cA cuni cJ wcel vx cv cA cJ sseq1 vx cv cA wceq vx cv cuni cA cuni
      cJ vx cv cA unieq eleq1d imbi12d cla4gv syl com23 ex pm2.43d mpid imp $.
      $( [18-Jul-2006] $) $( [27-Feb-2006] $)

   $( The indexed union of a subset of a topology is an open set. $)
    iunopn $p |- ( ( J e. Top /\ A. x e. A B e. J ) -> U_ x e. A B e. J ) $=
      cJ ctop wcel cB cJ wcel vx cA wral wa vx cA cB ciun vy cv cB wceq vx cA
      wrex vy cab cuni cJ cB cJ wcel vx cA wral vx cA cB ciun vy cv cB wceq vx
      cA wrex vy cab cuni wceq cJ ctop wcel vx vy cA cB cJ dfiun2g adantl cJ
      ctop wcel vy cv cB wceq vx cA wrex vy cab cJ wss vy cv cB wceq vx cA wrex
      vy cab cuni cJ wcel cB cJ wcel vx cA wral vy cv cB wceq vx cA wrex vy cab
      cJ uniopn cB cJ wcel vx cA wral vy cv cB wceq vx cA wrex vy cab cJ wss vx
      vy cA cB cJ cJ uniiunlem ibi sylan2 eqeltrd $.
      $( [8-Oct-2006] $) $( [5-Oct-2006] $)

    $( The intersection of two open sets of a topology is also an open set. $)
    inopn $p |- ( ( J e. Top /\ A e. J /\ B e. J ) -> ( A i^i B ) e. J ) $=
      cJ ctop wcel cA cJ wcel cB cJ wcel cA cB cin cJ wcel cA cJ wcel cB cJ
      wcel wa vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral cA cB cin cJ wcel
      cJ ctop wcel vx cv vy cv cin cJ wcel cA cB cin cJ wcel cA vy cv cin cJ
      wcel vx vy cA cB cJ cJ vx cv cA wceq vx cv vy cv cin cA vy cv cin cJ vx
      cv cA vy cv ineq1 eleq1d vy cv cB wceq cA vy cv cin cA cB cin cJ vy cv cB
      cA ineq2 eleq1d rcla42v cJ ctop wcel vx cv cJ wss vx cv cuni cJ wcel wi
      vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral cJ ctop wcel vx cv
      cJ wss vx cv cuni cJ wcel wi vx wal vx cv vy cv cin cJ wcel vy cJ wral vx
      cJ wral wa vx vy ctop cJ istopg ibi pm3.27d syl5com 3impib $.
      $( [18-Jul-2006] $) $( [17-Jul-2006] $)
  $}

  $( The empty set is an open subset of a topology.  (Contributed by Stefan
     Allan, 27-Feb-2006.) $)
  0opn $p |- ( J e. Top -> (/) e. J ) $=
    cJ ctop wcel c0 cuni cJ c0 cJ ctop wcel c0 cJ wss c0 cuni cJ wcel cJ 0ss c0
    cJ uniopn mpan2 uni0 syl5eqelr $.
    $( [18-Jul-2006] $) $( [27-Feb-2006] $)

  ${
    1open.1 $e |- X = U. J $.
    $( The underlying set of a topology is an open set. $)
    topopn $p |- ( J e. Top -> X e. J ) $=
      cJ ctop wcel cJ cuni cJ cX cJ ctop wcel cJ cJ wss cJ cuni cJ wcel cJ ssid
      cJ cJ uniopn mpan2 1open.1 syl5eqel $.
      $( [10-Oct-2006] $) $( [17-Jul-2006] $)

    $( A member of a topology is a subset of its underlying set. $)
    eltopss $p |- ( ( J e. Top /\ A e. J ) -> A C_ X ) $=
      cA cJ wcel cA cX wss cJ ctop wcel cA cJ wcel cA cJ cuni cX cA cJ elssuni
      1open.1 syl6ssr adantl $.
      $( [16-Oct-2006] $) $( [12-Sep-2006] $)
  $}

  ${
    $d x y A $.  $d x y J $.
    $( Construct a topological space from a topology and vice-versa.  We
       say that ` A ` is a topology on ` U. A ` .  (This could be proved more
       efficiently from ~ istps , but the proof here does not require the Axiom
       of Regularity.) $)
    eltopsp $p |- ( <. U. J , J >. e. TopSp <-> J e. Top ) $=
      cJ cuni cJ cop ctps wcel cJ cuni cvv wcel cJ cvv wcel wa cJ ctop wcel cJ
      cuni cJ cop ctps wcel cJ cuni cvv wcel cJ cvv wcel cJ cuni cJ cop ctps
      wcel cJ cuni cJ ctps wbr cJ cuni cvv wcel cJ cuni cJ ctps df-br cJ cuni
      cJ ctps ctps wrel vy cv ctop wcel vx cv vy cv cuni wceq wa vx vy copab
      wrel vy cv ctop wcel vx cv vy cv cuni wceq wa vx vy relopab ctps vy cv
      ctop wcel vx cv vy cv cuni wceq wa vx vy copab vx vy df-topsp releqi
      mpbir brrelexi sylbir cJ cuni cJ cop ctps wcel cJ cuni cvv wcel cJ cvv
      wcel cJ cuni cJ cop ctps wcel cJ cuni cJ ctps wbr cJ cuni cvv wcel cJ
      cuni cJ ctps df-br cJ cuni cJ ctps ctps wrel vy cv ctop wcel vx cv vy cv
      cuni wceq wa vx vy copab wrel vy cv ctop wcel vx cv vy cv cuni wceq wa vx
      vy relopab ctps vy cv ctop wcel vx cv vy cv cuni wceq wa vx vy copab vx
      vy df-topsp releqi mpbir brrelexi sylbir cJ uniexb sylibr jca cJ ctop
      wcel cJ cuni cvv wcel cJ cvv wcel cJ ctop uniexg cJ ctop elisset jca cJ
      cuni cvv wcel cJ cvv wcel wa cJ cuni cJ cop vy cv ctop wcel vx cv vy cv
      cuni wceq wa vx vy copab wcel cJ ctop wcel cJ cuni cJ cuni wceq wa cJ
      cuni cJ cop ctps wcel cJ ctop wcel vy cv ctop wcel vx cv vy cv cuni wceq
      wa vy cv ctop wcel cJ cuni vy cv cuni wceq wa cJ ctop wcel cJ cuni cJ
      cuni wceq wa vx vy cJ cuni cJ cvv cvv vx cv cJ cuni wceq vx cv vy cv cuni
      wceq cJ cuni vy cv cuni wceq vy cv ctop wcel vx cv cJ cuni vy cv cuni
      eqeq1 anbi2d vy cv cJ wceq vy cv ctop wcel cJ ctop wcel cJ cuni vy cv
      cuni wceq cJ cuni cJ cuni wceq vy cv cJ ctop eleq1 vy cv cJ wceq vy cv
      cuni cJ cuni cJ cuni vy cv cJ unieq eqeq2d anbi12d opelopabg ctps vy cv
      ctop wcel vx cv vy cv cuni wceq wa vx vy copab cJ cuni cJ cop vx vy
      df-topsp eleq2i cJ cuni cJ cuni wceq cJ ctop wcel cJ cuni eqid biantru
      3bitr4g pm5.21nii $.
      $( [14-Jul-2006] $) $( [8-Mar-2006] $)

    $( Existence implied by membership in a topological space.  This technical
       lemma, which can help eliminate unnecessary antecedents, uses the Axiom
       of Regularity (via ~ elirr ) along with definitional tricks. $)
    tpsex $p |- ( <. A , J >. e. TopSp -> ( A e. _V /\ J e. _V ) ) $=
      cA cJ cop ctps wcel cA cvv wcel cJ cvv wcel cA cJ cop ctps wcel cA cJ
      ctps wbr cA cvv wcel cA cJ ctps df-br cA cJ ctps ctps wrel vy cv ctop
      wcel vx cv vy cv cuni wceq wa vx vy copab wrel vy cv ctop wcel vx cv vy
      cv cuni wceq wa vx vy relopab ctps vy cv ctop wcel vx cv vy cv cuni wceq
      wa vx vy copab vx vy df-topsp releqi mpbir brrelexi sylbir cJ cvv wcel cA
      cJ cop ctps wcel cJ cvv wcel wn cA cJ cop ctps wcel cA cA cop ctps wcel
      cA cA cop ctps wcel cA ctop wcel cA cA cuni wceq wa cA ctop wcel cA cA
      cuni wceq wa cA cA wcel cA elirr cA ctop wcel cA cA cuni wceq wa cA cA
      cuni cA cA ctop wcel cA cA cuni wceq pm3.27 cA ctop wcel cA cuni cA wcel
      cA cA cuni wceq cA cA cuni cA cuni eqid topopn adantr eqeltrd mto cA cA
      cop ctps wcel cA cvv wcel cA cvv wcel wa cA ctop wcel cA cA cuni wceq wa
      cA cA cop ctps wcel cA cvv wcel cA cvv wcel cA cA cop ctps wcel cA cA
      ctps wbr cA cvv wcel cA cA ctps df-br cA cA ctps ctps wrel vy cv ctop
      wcel vx cv vy cv cuni wceq wa vx vy copab wrel vy cv ctop wcel vx cv vy
      cv cuni wceq wa vx vy relopab ctps vy cv ctop wcel vx cv vy cv cuni wceq
      wa vx vy copab vx vy df-topsp releqi mpbir brrelexi sylbir cA cA cop ctps
      wcel cA cA ctps wbr cA cvv wcel cA cA ctps df-br cA cA ctps ctps wrel vy
      cv ctop wcel vx cv vy cv cuni wceq wa vx vy copab wrel vy cv ctop wcel vx
      cv vy cv cuni wceq wa vx vy relopab ctps vy cv ctop wcel vx cv vy cv cuni
      wceq wa vx vy copab vx vy df-topsp releqi mpbir brrelexi sylbir jca cA
      ctop wcel cA cvv wcel cA cvv wcel wa cA cA cuni wceq cA ctop wcel cA cvv
      wcel cA cvv wcel cA ctop elisset cA ctop elisset jca adantr cA cvv wcel
      cA cvv wcel wa cA cA cop vy cv ctop wcel vx cv vy cv cuni wceq wa vx vy
      copab wcel cA ctop wcel cA cA cuni wceq wa cA cA cop ctps wcel vy cv ctop
      wcel vx cv vy cv cuni wceq wa vy cv ctop wcel cA vy cv cuni wceq wa cA
      ctop wcel cA cA cuni wceq wa vx vy cA cA cvv cvv vx cv cA wceq vx cv vy
      cv cuni wceq cA vy cv cuni wceq vy cv ctop wcel vx cv cA vy cv cuni eqeq1
      anbi2d vy cv cA wceq vy cv ctop wcel cA ctop wcel cA vy cv cuni wceq cA
      cA cuni wceq vy cv cA ctop eleq1 vy cv cA wceq vy cv cuni cA cuni cA vy
      cv cA unieq eqeq2d anbi12d opelopabg ctps vy cv ctop wcel vx cv vy cv
      cuni wceq wa vx vy copab cA cA cop vx vy df-topsp eleq2i syl5bb pm5.21nii
      mtbir cJ cvv wcel wn cA cJ cop cA cA cop ctps cA cJ opprc2 eleq1d mtbiri
      con4i jca $.
      $( [19-Jul-2006] $) $( [18-Jul-2006] $)

    $( Express the predicate "is a topological space." $)
    istps $p |- ( <. A , J >. e. TopSp <-> ( J e. Top /\ A = U. J ) ) $=
      cA cJ cop ctps wcel cA cvv wcel cJ cvv wcel wa cJ ctop wcel cA cJ cuni
      wceq wa cA cJ tpsex cJ ctop wcel cA cJ cuni wceq wa cA cvv wcel cJ cvv
      wcel cJ ctop wcel cA cJ cuni wceq wa cA cJ cuni cvv cJ ctop wcel cA cJ
      cuni wceq pm3.27 cJ ctop wcel cJ cuni cvv wcel cA cJ cuni wceq cJ ctop
      uniexg adantr eqeltrd cJ ctop wcel cJ cvv wcel cA cJ cuni wceq cJ ctop
      elisset adantr jca cA cvv wcel cJ cvv wcel wa cA cJ cop vy cv ctop wcel
      vx cv vy cv cuni wceq wa vx vy copab wcel cJ ctop wcel cA cJ cuni wceq wa
      cA cJ cop ctps wcel vy cv ctop wcel vx cv vy cv cuni wceq wa vy cv ctop
      wcel cA vy cv cuni wceq wa cJ ctop wcel cA cJ cuni wceq wa vx vy cA cJ
      cvv cvv vx cv cA wceq vx cv vy cv cuni wceq cA vy cv cuni wceq vy cv ctop
      wcel vx cv cA vy cv cuni eqeq1 anbi2d vy cv cJ wceq vy cv ctop wcel cJ
      ctop wcel cA vy cv cuni wceq cA cJ cuni wceq vy cv cJ ctop eleq1 vy cv cJ
      wceq vy cv cuni cJ cuni cA vy cv cJ unieq eqeq2d anbi12d opelopabg ctps
      vy cv ctop wcel vx cv vy cv cuni wceq wa vx vy copab cA cJ cop vx vy
      df-topsp eleq2i syl5bb pm5.21nii $.
      $( [20-Jul-2006] $) $( [18-Jul-2006] $)

    $( Express the predicate "is a topological space." $)
    istps2 $p |- ( <. A , J >. e. TopSp <-> ( ( J e. Top /\ J C_ ~P A )
                  /\ ( (/) e. J /\ A e. J ) ) ) $=
      cJ ctop wcel cA cJ cuni wceq wa cJ ctop wcel cJ cA cpw wss c0 cJ wcel cA
      cJ wcel wa wa wa cA cJ cop ctps wcel cJ ctop wcel cJ cA cpw wss wa c0 cJ
      wcel cA cJ wcel wa wa cJ ctop wcel cA cJ cuni wceq cJ cA cpw wss c0 cJ
      wcel cA cJ wcel wa wa cJ ctop wcel cJ cuni cA wceq cJ cuni cA wss c0 cJ
      wcel cA cJ wcel wa wa cA cJ cuni wceq cJ cA cpw wss c0 cJ wcel cA cJ wcel
      wa wa cJ ctop wcel cJ cuni cA wceq cJ cuni cA wss c0 cJ wcel cA cJ wcel
      wa wa cJ ctop wcel cJ cuni cA wceq cJ cuni cA wss c0 cJ wcel cA cJ wcel
      wa wa cJ ctop wcel cJ cuni cA wceq wa cJ cuni cA wss c0 cJ wcel cA cJ
      wcel cJ cuni cA wceq cJ cuni cA wss cJ ctop wcel cJ cuni cA eqimss adantl
      cJ ctop wcel c0 cJ wcel cJ cuni cA wceq cJ 0opn adantr cJ ctop wcel cJ
      cuni cA wceq wa cJ cuni cA cJ cJ ctop wcel cJ cuni cA wceq pm3.27 cJ ctop
      wcel cJ cuni cJ wcel cJ cuni cA wceq cJ cJ cuni cJ cuni eqid topopn
      adantr eqeltrrd jca32 ex cJ cuni cA wss cA cJ wcel cJ cuni cA wceq c0 cJ
      wcel cJ cA unissel adantrl impbid1 cA cJ cuni eqcom cJ cA cpw wss cJ cuni
      cA wss c0 cJ wcel cA cJ wcel wa cJ cA sspwuni anbi1i 3bitr4g pm5.32i cA
      cJ istps cJ ctop wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel wa anass
      3bitr4i $.
      $( [28-Jul-2006] $) $( [18-Jul-2006] $)

    $( A standard textbook definition of a topological space. $)
    istps3 $p |- ( <. A , J >. e. TopSp <-> ( ( J C_ ~P A /\ (/) e. J /\
                 A e. J ) /\ ( A. x ( x C_ J -> U. x e. J ) /\
                 A. x e. J A. y e. J ( x i^i y ) e. J ) ) ) $=
      cA cJ cop ctps wcel cJ ctop wcel cJ cA cpw wss wa c0 cJ wcel cA cJ wcel
      wa wa cJ ctop wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel wa wa wa cJ cA cpw
      wss c0 cJ wcel cA cJ wcel w3a vx cv cJ wss vx cv cuni cJ wcel wi vx wal
      vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral wa wa cA cJ istps2 cJ ctop
      wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel wa anass cJ ctop wcel cJ cA cpw
      wss c0 cJ wcel cA cJ wcel wa wa wa cJ cA cpw wss c0 cJ wcel cA cJ wcel wa
      wa cJ ctop wcel wa cJ cA cpw wss c0 cJ wcel cA cJ wcel w3a cJ ctop wcel
      wa cJ cA cpw wss c0 cJ wcel cA cJ wcel w3a vx cv cJ wss vx cv cuni cJ
      wcel wi vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral wa wa cJ
      ctop wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel wa wa ancom cJ cA cpw wss
      c0 cJ wcel cA cJ wcel w3a cJ cA cpw wss c0 cJ wcel cA cJ wcel wa wa cJ
      ctop wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel 3anass anbi1i cJ cA cpw wss
      c0 cJ wcel cA cJ wcel w3a cJ ctop wcel vx cv cJ wss vx cv cuni cJ wcel wi
      vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral wa cJ cA cpw wss c0
      cJ wcel cA cJ wcel w3a cJ cvv wcel cJ ctop wcel vx cv cJ wss vx cv cuni
      cJ wcel wi vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral wa wb cJ
      cA cpw wss cA cJ wcel cJ cvv wcel c0 cJ wcel cJ cA cpw wss cA cpw cvv
      wcel cJ cvv wcel cA cJ wcel cJ cA cpw cvv ssexg cA cJ pwexg sylan2
      3adant2 vx vy cvv cJ istopg syl pm5.32i 3bitr2i 3bitri $.
      $( [3-Aug-2006] $) $( [18-Jul-2006] $)

    $( A standard textbook definition of a topological space. $)
    istps4 $p |- ( <. A , J >. e. TopSp <-> ( ( J C_ ~P A /\ (/) e. J /\
       A e. J ) /\ ( A. x ( x C_ J -> U. x e. J ) /\ A. x ( ( x C_ J /\
       x =/= (/) /\ x e. Fin ) -> |^| x e. J ) ) ) ) $=
      cA cJ cop ctps wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel w3a vx cv cJ wss
      vx cv cuni cJ wcel wi vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ
      wral wa wa cJ cA cpw wss c0 cJ wcel cA cJ wcel w3a vx cv cJ wss vx cv
      cuni cJ wcel wi vx wal vx cv cJ wss vx cv c0 wne vx cv cfn wcel w3a vx cv
      cint cJ wcel wi vx wal wa wa vx vy cA cJ istps3 vx cv cJ wss vx cv cuni
      cJ wcel wi vx wal vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral wa vx cv
      cJ wss vx cv cuni cJ wcel wi vx wal vx cv cJ wss vx cv c0 wne vx cv cfn
      wcel w3a vx cv cint cJ wcel wi vx wal wa cJ cA cpw wss c0 cJ wcel cA cJ
      wcel w3a vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral vx cv cJ wss vx cv
      c0 wne vx cv cfn wcel w3a vx cv cint cJ wcel wi vx wal vx cv cJ wss vx cv
      cuni cJ wcel wi vx wal vx vy cJ fiint anbi2i anbi2i bitri $.
      $( [30-Dec-2008] $) $( [19-Jul-2006] $)

    $( A standard textbook definition of a topological space ` <. A , J >. ` :
       a topology on ` A ` is a collection ` J ` of subsets of ` A ` such that
       ` (/) ` and ` A ` are in ` J ` and that is closed under union and finite
       intersection.  Definition of topological space in [Munkres] p. 76. $)
    istps5 $p |- ( <. A , J >. e. TopSp <-> ( ( A. x e. J x C_ A /\ (/) e. J
                 /\ A e. J ) /\ ( A. x ( x C_ J -> U. x e. J ) /\
           A. x ( ( x C_ J /\ x =/= (/) /\ x e. Fin ) -> |^| x e. J ) ) ) ) $=
      cA cJ cop ctps wcel cJ cA cpw wss c0 cJ wcel cA cJ wcel w3a vx cv cJ wss
      vx cv cuni cJ wcel wi vx wal vx cv cJ wss vx cv c0 wne vx cv cfn wcel w3a
      vx cv cint cJ wcel wi vx wal wa wa vx cv cA wss vx cJ wral c0 cJ wcel cA
      cJ wcel w3a vx cv cJ wss vx cv cuni cJ wcel wi vx wal vx cv cJ wss vx cv
      c0 wne vx cv cfn wcel w3a vx cv cint cJ wcel wi vx wal wa wa vx cA cJ
      istps4 cJ cA cpw wss c0 cJ wcel cA cJ wcel w3a vx cv cA wss vx cJ wral c0
      cJ wcel cA cJ wcel w3a vx cv cJ wss vx cv cuni cJ wcel wi vx wal vx cv cJ
      wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cJ wcel wi vx wal wa cJ cA
      cpw wss vx cv cA wss vx cJ wral c0 cJ wcel cA cJ wcel vx cJ cA pwssb
      3anbi1i anbi1i bitri $.
      $( [23-Apr-2009] $) $( [19-Jul-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Bases for topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z B $.
    $( Express the predicate " ` B ` is a basis for a topology." $)
    isbasisg $p |- ( B e. C -> ( B e. Bases <->
          A. x e. B A. y e. B ( x i^i y ) C_ U. ( B i^i ~P ( x i^i y ) ) ) ) $=
      vx cv vy cv cin vz cv vx cv vy cv cin cpw cin cuni wss vy vz cv wral vx
      vz cv wral vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni wss vy cB wral
      vx cB wral vz cB ctb cC vx cv vy cv cin vz cv vx cv vy cv cin cpw cin
      cuni wss vy vz cv wral vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni
      wss vy cB wral vx vz cv cB vx cv vy cv cin vz cv vx cv vy cv cin cpw cin
      cuni wss vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni wss vy vz cv cB
      vz cv cB wceq vz cv vx cv vy cv cin cpw cin cuni cB vx cv vy cv cin cpw
      cin cuni vx cv vy cv cin vz cv cB wceq vz cv vx cv vy cv cin cpw cin cB
      vx cv vy cv cin cpw cin vz cv cB vx cv vy cv cin cpw ineq1 unieqd sseq2d
      raleqd raleqd vz vx vy df-bases elab2g $.
      $( [18-Jul-2006] $) $( [17-Jul-2006] $)

    $( Express the predicate " ` B ` is a basis for a topology." $)
    isbasis2g $p |- ( B e. C -> ( B e. Bases <->
           A. x e. B A. y e. B A. z e. ( x i^i y )
              E. w e. B ( z e. w /\ w C_ ( x i^i y ) ) ) ) $=
      cB cC wcel cB ctb wcel vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni
      wss vy cB wral vx cB wral vz cv vw cv wcel vw cv vx cv vy cv cin wss wa
      vw cB wrex vz vx cv vy cv cin wral vy cB wral vx cB wral vx vy cB cC
      isbasisg vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni wss vz cv vw cv
      wcel vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vx
      vy cB cB vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni wss vz cv cB vx
      cv vy cv cin cpw cin cuni wcel vz vx cv vy cv cin wral vz cv vw cv wcel
      vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vz vx cv
      vy cv cin cB vx cv vy cv cin cpw cin cuni dfss3 vz cv cB vx cv vy cv cin
      cpw cin cuni wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB
      wrex vz vx cv vy cv cin vz cv vw cv wcel vw cv cB vx cv vy cv cin cpw cin
      wcel wa vw wex vw cv cB wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss
      wa wa vw wex vz cv cB vx cv vy cv cin cpw cin cuni wcel vz cv vw cv wcel
      vw cv vx cv vy cv cin wss wa vw cB wrex vz cv vw cv wcel vw cv cB vx cv
      vy cv cin cpw cin wcel wa vw cv cB wcel vz cv vw cv wcel vw cv vx cv vy
      cv cin wss wa wa vw vz cv vw cv wcel vw cv cB vx cv vy cv cin cpw cin
      wcel wa vz cv vw cv wcel vw cv cB wcel vw cv vx cv vy cv cin wss wa wa vw
      cv cB wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa wa vw cv cB vx
      cv vy cv cin cpw cin wcel vw cv cB wcel vw cv vx cv vy cv cin wss wa vz
      cv vw cv wcel vw cv cB vx cv vy cv cin cpw cin wcel vw cv cB wcel vw cv
      vx cv vy cv cin cpw wcel wa vw cv cB wcel vw cv vx cv vy cv cin wss wa vw
      cv cB vx cv vy cv cin cpw elin vw cv vx cv vy cv cin cpw wcel vw cv vx cv
      vy cv cin wss vw cv cB wcel vw cv vx cv vy cv cin wss vw vx cv vy cv cin
      cpw vw vx cv vy cv cin df-pw abeq2i anbi2i bitri anbi2i vz cv vw cv wcel
      vw cv cB wcel vw cv vx cv vy cv cin wss an12 bitri exbii vw vz cv cB vx
      cv vy cv cin cpw cin eluni vz cv vw cv wcel vw cv vx cv vy cv cin wss wa
      vw cB df-rex 3bitr4i ralbii bitri 2ralbii syl6bb $.
      $( [18-Jul-2006] $) $( [17-Jul-2006] $)

    $( Express the predicate " ` B ` is a basis for a topology."  Definition of
       basis in [Munkres] p. 78. $)
    isbasis3g $p |- ( B e. C -> ( B e. Bases <-> ( A. x e. B x C_ U. B /\
     A. x e. U. B E. y e. B x e. y /\ A. x e. B A. y e. B A. z e. ( x i^i y )
     E. w e. B ( z e. w /\ w C_ ( x i^i y ) ) ) ) ) $=
      cB cC wcel cB ctb wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw
      cB wrex vz vx cv vy cv cin wral vy cB wral vx cB wral vx cv cB cuni wss
      vx cB wral vx cv vy cv wcel vy cB wrex vx cB cuni wral vz cv vw cv wcel
      vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vy cB
      wral vx cB wral w3a vx vy vz vw cB cC isbasis2g vz cv vw cv wcel vw cv vx
      cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vy cB wral vx cB
      wral vx cv cB cuni wss vx cB wral vx cv vy cv wcel vy cB wrex vx cB cuni
      wral wa vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv
      vy cv cin wral vy cB wral vx cB wral wa vx cv cB cuni wss vx cB wral vx
      cv vy cv wcel vy cB wrex vx cB cuni wral vz cv vw cv wcel vw cv vx cv vy
      cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vy cB wral vx cB wral
      w3a vx cv cB cuni wss vx cB wral vx cv vy cv wcel vy cB wrex vx cB cuni
      wral wa vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv
      vy cv cin wral vy cB wral vx cB wral vx cv cB cuni wss vx cB wral vx cv
      vy cv wcel vy cB wrex vx cB cuni wral vx cv cB cuni wss vx cB vx cv cB
      elssuni rgen vx cv vy cv wcel vy cB wrex vx cB cuni vx cv cB cuni wcel vx
      cv vy cv wcel vy cB wrex vy vx cv cB eluni2 biimpi rgen pm3.2i biantrur
      vx cv cB cuni wss vx cB wral vx cv vy cv wcel vy cB wrex vx cB cuni wral
      vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv
      cin wral vy cB wral vx cB wral df-3an bitr4i syl6bb $.
      $( [18-Jul-2006] $) $( [17-Jul-2006] $)
  $}

  ${
    $d w x A $.  $d w x y z B $.  $d w x y z C $.  $d w x y z D $.
    $( Property of a basis. $)
    basis1 $p |- ( ( B e. Bases /\ C e. B /\ D e. B ) ->
                    ( C i^i D ) C_  U. ( B i^i ~P ( C i^i D ) ) ) $=
      cB ctb wcel cC cB wcel cD cB wcel cC cD cin cB cC cD cin cpw cin cuni wss
      cC cB wcel cD cB wcel wa vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni
      wss vy cB wral vx cB wral cC cD cin cB cC cD cin cpw cin cuni wss cB ctb
      wcel vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni wss cC cD cin cB cC
      cD cin cpw cin cuni wss cC vy cv cin cB cC vy cv cin cpw cin cuni wss vx
      vy cC cD cB cB vx cv cC wceq vx cv vy cv cin cC vy cv cin cB vx cv vy cv
      cin cpw cin cuni cB cC vy cv cin cpw cin cuni vx cv cC vy cv ineq1 vx cv
      cC wceq cB vx cv vy cv cin cpw cin cB cC vy cv cin cpw cin vx cv cC wceq
      vx cv vy cv cin cpw cC vy cv cin cpw cB vx cv cC wceq vx cv vy cv cin cC
      vy cv cin wceq vx cv vy cv cin cpw cC vy cv cin cpw wceq vx cv cC vy cv
      ineq1 vx cv vy cv cin cC vy cv cin pweq syl ineq2d unieqd sseq12d vy cv
      cD wceq cC vy cv cin cC cD cin cB cC vy cv cin cpw cin cuni cB cC cD cin
      cpw cin cuni vy cv cD cC ineq2 vy cv cD wceq cB cC vy cv cin cpw cin cB
      cC cD cin cpw cin vy cv cD wceq cC vy cv cin cpw cC cD cin cpw cB vy cv
      cD wceq cC vy cv cin cC cD cin wceq cC vy cv cin cpw cC cD cin cpw wceq
      vy cv cD cC ineq2 cC vy cv cin cC cD cin pweq syl ineq2d unieqd sseq12d
      rcla42v cB ctb wcel vx cv vy cv cin cB vx cv vy cv cin cpw cin cuni wss
      vy cB wral vx cB wral vx vy cB ctb isbasisg ibi syl5com 3impib $.
      $( [21-Jul-2006] $) $( [16-Jul-2006] $)

    $( Property of a basis. $)
    basis2 $p |- ( ( ( B e. Bases /\ C e. B ) /\ ( D e. B /\
          A e. ( C i^i D ) ) ) -> E. x e. B ( A e. x /\ x C_ ( C i^i D ) ) ) $=
      cB ctb wcel cC cB wcel cD cB wcel cA cC cD cin wcel cA vx cv wcel vx cv
      cC cD cin wss wa vx cB wrex cB ctb wcel cC cB wcel cD cB wcel cA cC cD
      cin wcel cA vx cv wcel vx cv cC cD cin wss wa vx cB wrex wi cB ctb wcel
      vw cv vx cv wcel vx cv vy cv vz cv cin wss wa vx cB wrex vw vy cv vz cv
      cin wral vz cB wral vy cB wral cC cB wcel cD cB wcel wa cA cC cD cin wcel
      cA vx cv wcel vx cv cC cD cin wss wa vx cB wrex wi wi cB ctb wcel vw cv
      vx cv wcel vx cv vy cv vz cv cin wss wa vx cB wrex vw vy cv vz cv cin
      wral vz cB wral vy cB wral vy vz vw vx cB ctb isbasis2g ibi cC cB wcel cD
      cB wcel wa vw cv vx cv wcel vx cv vy cv vz cv cin wss wa vx cB wrex vw vy
      cv vz cv cin wral vz cB wral vy cB wral vw cv vx cv wcel vx cv cC cD cin
      wss wa vx cB wrex vw cC cD cin wral cA cC cD cin wcel cA vx cv wcel vx cv
      cC cD cin wss wa vx cB wrex wi vw cv vx cv wcel vx cv vy cv vz cv cin wss
      wa vx cB wrex vw vy cv vz cv cin wral vw cv vx cv wcel vx cv cC cD cin
      wss wa vx cB wrex vw cC cD cin wral vw cv vx cv wcel vx cv cC vz cv cin
      wss wa vx cB wrex vw cC vz cv cin wral vy vz cC cD cB cB vy cv cC wceq vy
      cv vz cv cin cC vz cv cin wceq vw cv vx cv wcel vx cv vy cv vz cv cin wss
      wa vx cB wrex vw vy cv vz cv cin wral vw cv vx cv wcel vx cv cC vz cv cin
      wss wa vx cB wrex vw cC vz cv cin wral wb vy cv cC vz cv ineq1 vw cv vx
      cv wcel vx cv vy cv vz cv cin wss wa vx cB wrex vw cv vx cv wcel vx cv cC
      vz cv cin wss wa vx cB wrex vw vy cv vz cv cin cC vz cv cin vy cv vz cv
      cin cC vz cv cin wceq vw cv vx cv wcel vx cv vy cv vz cv cin wss wa vw cv
      vx cv wcel vx cv cC vz cv cin wss wa vx cB vy cv vz cv cin cC vz cv cin
      wceq vx cv vy cv vz cv cin wss vx cv cC vz cv cin wss vw cv vx cv wcel vy
      cv vz cv cin cC vz cv cin vx cv sseq2 anbi2d rexbidv raleqd syl vz cv cD
      wceq cC vz cv cin cC cD cin wceq vw cv vx cv wcel vx cv cC vz cv cin wss
      wa vx cB wrex vw cC vz cv cin wral vw cv vx cv wcel vx cv cC cD cin wss
      wa vx cB wrex vw cC cD cin wral wb vz cv cD cC ineq2 vw cv vx cv wcel vx
      cv cC vz cv cin wss wa vx cB wrex vw cv vx cv wcel vx cv cC cD cin wss wa
      vx cB wrex vw cC vz cv cin cC cD cin cC vz cv cin cC cD cin wceq vw cv vx
      cv wcel vx cv cC vz cv cin wss wa vw cv vx cv wcel vx cv cC cD cin wss wa
      vx cB cC vz cv cin cC cD cin wceq vx cv cC vz cv cin wss vx cv cC cD cin
      wss vw cv vx cv wcel cC vz cv cin cC cD cin vx cv sseq2 anbi2d rexbidv
      raleqd syl rcla42v vw cv vx cv wcel vx cv cC cD cin wss wa vx cB wrex cA
      vx cv wcel vx cv cC cD cin wss wa vx cB wrex vw cA cC cD cin vw cv cA
      wceq vw cv vx cv wcel vx cv cC cD cin wss wa cA vx cv wcel vx cv cC cD
      cin wss wa vx cB vw cv cA wceq vw cv vx cv wcel cA vx cv wcel vx cv cC cD
      cin wss vw cv cA vx cv eleq1 anbi1d rexbidv rcla4cv syl6com syl exp3a
      imp43 $.
      $( [24-Jul-2006] $) $( [17-Jul-2006] $)
  $}

  ${
    $d B w x y z $. $d C w x y z $.
    $( If a set is closed under finite intersection, then it is a basis for
       a topology. (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    fiinbas $p |- ( ( B e. C /\ A. x e. B A. y e. B ( x i^i y ) e. B )
                       -> B e. Bases ) $=
      cB cC wcel vx cv vy cv cin cB wcel vy cB wral vx cB wral cB ctb wcel cB
      cC wcel vx cv vy cv cin cB wcel vy cB wral vx cB wral vz cv vw cv wcel vw
      cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vy cB wral
      vx cB wral cB ctb wcel cB cC wcel vx cv vy cv cin cB wcel vy cB wral vz
      cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin
      wral vy cB wral vx cB cB cC wcel vx cv vy cv cin cB wcel vz cv vw cv wcel
      vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin wral vy cB vx
      cv vy cv cin cB wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB
      wrex vz vx cv vy cv cin wral wi cB cC wcel vx cv vy cv cin cB wcel vz cv
      vw cv wcel vw cv vx cv vy cv cin wss wa vw cB wrex vz vx cv vy cv cin vx
      cv vy cv cin cB wcel vz cv vx cv vy cv cin wcel vx cv vy cv cin vx cv vy
      cv cin wss vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cB wrex vx cv
      vy cv cin ssid vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vz cv vx cv
      vy cv cin wcel vx cv vy cv cin vx cv vy cv cin wss wa vw vx cv vy cv cin
      cB vw cv vx cv vy cv cin wceq vz cv vw cv wcel vz cv vx cv vy cv cin wcel
      vw cv vx cv vy cv cin wss vx cv vy cv cin vx cv vy cv cin wss vw cv vx cv
      vy cv cin vz cv eleq2 vw cv vx cv vy cv cin vx cv vy cv cin sseq1 anbi12d
      rcla4ev mpanr2 r19.21aiva a1i r19.20sdv r19.20sdv vx vy vz vw cB cC
      isbasis2g sylibrd imp $.
      $( [18-Apr-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d y x z A $.  $d t u v w x y z B $.  $d x y C $.  $d w x y z J $.
    $( The topology generated by a basis. $)
    tgval $p |- ( B e. Bases -> ( topGen ` B ) =
                  { x | x C_ U. ( B i^i ~P x ) } ) $=
      cB ctb wcel vx cv cB vx cv cpw cin cuni wss vx cab cvv wcel cB ctg cfv vx
      cv cB vx cv cpw cin cuni wss vx cab wceq cB ctb wcel cB cuni cvv wcel vx
      cv cB cuni wss vx cv vx cv cpw cuni wss wa vx cab cvv wcel vx cv cB vx cv
      cpw cin cuni wss vx cab cvv wcel cB ctb uniexg vx cv vx cv cpw cuni wss
      vx cB cuni cvv abssexg vx cv cB vx cv cpw cin cuni wss vx cab vx cv cB
      cuni wss vx cv vx cv cpw cuni wss wa vx cab wss vx cv cB cuni wss vx cv
      vx cv cpw cuni wss wa vx cab cvv wcel vx cv cB vx cv cpw cin cuni wss vx
      cab cvv wcel vx cv cB vx cv cpw cin cuni wss vx cv cB cuni wss vx cv vx
      cv cpw cuni wss wa vx vx cv cB vx cv cpw cin cuni wss vx cv cB cuni vx cv
      cpw cuni cin wss vx cv cB cuni wss vx cv vx cv cpw cuni wss wa vx cv cB
      vx cv cpw cin cuni wss cB vx cv cpw cin cuni cB cuni vx cv cpw cuni cin
      wss vx cv cB cuni vx cv cpw cuni cin wss cB vx cv cpw uniin vx cv cB vx
      cv cpw cin cuni cB cuni vx cv cpw cuni cin sstr mpan2 vx cv cB cuni vx cv
      cpw cuni ssin sylibr ss2abi vx cv cB vx cv cpw cin cuni wss vx cab vx cv
      cB cuni wss vx cv vx cv cpw cuni wss wa vx cab cvv ssexg mpan 3syl vy vz
      cB vx cv vy cv vx cv cpw cin cuni wss vx cab vx cv cB vx cv cpw cin cuni
      wss vx cab ctb cvv ctg vy cv cB wceq vx cv vy cv vx cv cpw cin cuni wss
      vx cv cB vx cv cpw cin cuni wss vx vy cv cB wceq vy cv vx cv cpw cin cuni
      cB vx cv cpw cin cuni vx cv vy cv cB wceq vy cv vx cv cpw cin cB vx cv
      cpw cin vy cv cB vx cv cpw ineq1 unieqd sseq2d abbidv vy vz vx df-topgen
      fvopab4g mpdan $.
      $( [19-Jul-2006] $) $( [16-Jul-2006] $)

    $( Definition of a topology generated by a basis in [Munkres] p. 78.
       Later we show (in ~ tgcl ) that ` ( topGen `` B ) ` is indeed a
       topology (on ` U. B ` ; see ~ unitg ). $)
    tgval2 $p |- ( B e. Bases -> ( topGen ` B ) =
         { x | ( x C_ U. B /\ A. y e. x E. z e. B ( y e. z /\ z C_ x ) ) } ) $=
      cB ctb wcel cB ctg cfv vx cv cB vx cv cpw cin cuni wss vx cab vx cv cB
      cuni wss vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral wa
      vx cab vx cB tgval vx cv cB vx cv cpw cin cuni wss vx cv cB cuni wss vy
      cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral wa vx vx cv cB
      vx cv cpw cin cuni wss vy cv cB cuni wcel vy vx cv wral vy cv cB vx cv
      cpw cin cuni wcel vy vx cv wral wa vx cv cB cuni wss vy cv vz cv wcel vz
      cv vx cv wss wa vz cB wrex vy vx cv wral wa vx cv cB vx cv cpw cin cuni
      wss vy cv cB vx cv cpw cin cuni wcel vy vx cv wral vy cv cB cuni wcel vy
      cv cB vx cv cpw cin cuni wcel wa vy vx cv wral vy cv cB cuni wcel vy vx
      cv wral vy cv cB vx cv cpw cin cuni wcel vy vx cv wral wa vy vx cv cB vx
      cv cpw cin cuni dfss3 vy cv cB vx cv cpw cin cuni wcel vy cv cB cuni wcel
      vy cv cB vx cv cpw cin cuni wcel wa vy vx cv vy cv cB vx cv cpw cin cuni
      wcel vy cv cB cuni wcel cB vx cv cpw cin cuni cB cuni vy cv cB vx cv cpw
      cin cB wss cB vx cv cpw cin cuni cB cuni wss cB vx cv cpw inss1 cB vx cv
      cpw cin cB uniss ax-mp sseli pm4.71ri ralbii vy cv cB cuni wcel vy cv cB
      vx cv cpw cin cuni wcel vy vx cv r19.26 3bitri vx cv cB cuni wss vy cv cB
      cuni wcel vy vx cv wral vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy
      vx cv wral vy cv cB vx cv cpw cin cuni wcel vy vx cv wral vy vx cv cB
      cuni dfss3 vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy cv cB vx cv
      cpw cin cuni wcel vy vx cv vy cv cB vx cv cpw cin cuni wcel vy cv vz cv
      wcel vz cv vx cv cpw wcel wa vz cB wrex vy cv vz cv wcel vz cv vx cv wss
      wa vz cB wrex vy cv vz cv wcel vz cv cB vx cv cpw cin wcel wa vz wex vz
      cv cB wcel vy cv vz cv wcel vz cv vx cv cpw wcel wa wa vz wex vy cv cB vx
      cv cpw cin cuni wcel vy cv vz cv wcel vz cv vx cv cpw wcel wa vz cB wrex
      vy cv vz cv wcel vz cv cB vx cv cpw cin wcel wa vz cv cB wcel vy cv vz cv
      wcel vz cv vx cv cpw wcel wa wa vz vy cv vz cv wcel vz cv cB vx cv cpw
      cin wcel wa vy cv vz cv wcel vz cv cB wcel vz cv vx cv cpw wcel wa wa vz
      cv cB wcel vy cv vz cv wcel vz cv vx cv cpw wcel wa wa vz cv cB vx cv cpw
      cin wcel vz cv cB wcel vz cv vx cv cpw wcel wa vy cv vz cv wcel vz cv cB
      vx cv cpw elin anbi2i vy cv vz cv wcel vz cv cB wcel vz cv vx cv cpw wcel
      an12 bitri exbii vz vy cv cB vx cv cpw cin eluni vy cv vz cv wcel vz cv
      vx cv cpw wcel wa vz cB df-rex 3bitr4i vy cv vz cv wcel vz cv vx cv cpw
      wcel wa vy cv vz cv wcel vz cv vx cv wss wa vz cB vz cv vx cv cpw wcel vz
      cv vx cv wss vy cv vz cv wcel vz cv vx cv vz visset elpw anbi2i rexbii
      bitr2i ralbii anbi12i bitr4i abbii syl6eq $.
      $( [19-Jul-2006] $) $( [15-Jul-2006] $)

    $( Membership in a topology generated by a basis. $)
    eltg $p |- ( B e. Bases -> ( A e. ( topGen ` B ) <->
           A C_ U. ( B i^i ~P A ) ) ) $=
      cB ctb wcel cA cB ctg cfv wcel cA vx cv cB vx cv cpw cin cuni wss vx cab
      wcel cA cB cA cpw cin cuni wss cB ctb wcel cB ctg cfv vx cv cB vx cv cpw
      cin cuni wss vx cab cA vx cB tgval eleq2d cB ctb wcel cA vx cv cB vx cv
      cpw cin cuni wss vx cab wcel cA cB cA cpw cin cuni wss cA cvv wcel cA vx
      cv cB vx cv cpw cin cuni wss vx cab wcel cA cvv wcel cB ctb wcel cA vx cv
      cB vx cv cpw cin cuni wss vx cab elisset adantl cA cB cA cpw cin cuni wss
      cB ctb wcel cA cvv wcel cA cB cA cpw cin cuni wss cB cA cpw cin cuni cvv
      wcel cA cvv wcel cB ctb wcel cA cB cA cpw cin cuni cvv ssexg cB ctb wcel
      cB cA cpw cin cvv wcel cB cA cpw cin cuni cvv wcel cB cA cpw ctb inex1g
      cB cA cpw cin cvv uniexg syl sylan2 ancoms vx cv cB vx cv cpw cin cuni
      wss cA cB cA cpw cin cuni wss vx cA cvv vx cv cA wceq vx cv cA cB vx cv
      cpw cin cuni cB cA cpw cin cuni vx cv cA wceq id vx cv cA wceq cB vx cv
      cpw cin cB cA cpw cin vx cv cA wceq vx cv cpw cA cpw cB vx cv cA pweq
      ineq2d unieqd sseq12d elabg pm5.21nd bitrd $.
      $( [21-Jul-2006] $) $( [16-Jul-2006] $)

    $( Membership in a topology generated by a basis. $)
    eltg2 $p |- ( B e. Bases -> ( A e. ( topGen ` B ) <->
           ( A C_ U. B /\ A. x e. A E. y e. B ( x e. y /\ y C_ A ) ) ) ) $=
      cB ctb wcel cA cB ctg cfv wcel cA vz cv cB cuni wss vx cv vy cv wcel vy
      cv vz cv wss wa vy cB wrex vx vz cv wral wa vz cab wcel cA cB cuni wss vx
      cv vy cv wcel vy cv cA wss wa vy cB wrex vx cA wral wa cB ctb wcel cB ctg
      cfv vz cv cB cuni wss vx cv vy cv wcel vy cv vz cv wss wa vy cB wrex vx
      vz cv wral wa vz cab cA vz vx vy cB tgval2 eleq2d cB ctb wcel cA vz cv cB
      cuni wss vx cv vy cv wcel vy cv vz cv wss wa vy cB wrex vx vz cv wral wa
      vz cab wcel cA cB cuni wss vx cv vy cv wcel vy cv cA wss wa vy cB wrex vx
      cA wral wa cA cvv wcel cA vz cv cB cuni wss vx cv vy cv wcel vy cv vz cv
      wss wa vy cB wrex vx vz cv wral wa vz cab wcel cA cvv wcel cB ctb wcel cA
      vz cv cB cuni wss vx cv vy cv wcel vy cv vz cv wss wa vy cB wrex vx vz cv
      wral wa vz cab elisset adantl cB ctb wcel cA cB cuni wss cA cvv wcel vx
      cv vy cv wcel vy cv cA wss wa vy cB wrex vx cA wral cA cB cuni wss cB ctb
      wcel cA cvv wcel cA cB cuni wss cB cuni cvv wcel cA cvv wcel cB ctb wcel
      cA cB cuni cvv ssexg cB ctb uniexg sylan2 ancoms adantrr vz cv cB cuni
      wss vx cv vy cv wcel vy cv vz cv wss wa vy cB wrex vx vz cv wral wa cA cB
      cuni wss vx cv vy cv wcel vy cv cA wss wa vy cB wrex vx cA wral wa vz cA
      cvv vz cv cA wceq vz cv cB cuni wss cA cB cuni wss vx cv vy cv wcel vy cv
      vz cv wss wa vy cB wrex vx vz cv wral vx cv vy cv wcel vy cv cA wss wa vy
      cB wrex vx cA wral vz cv cA cB cuni sseq1 vx cv vy cv wcel vy cv vz cv
      wss wa vy cB wrex vx cv vy cv wcel vy cv cA wss wa vy cB wrex vx vz cv cA
      vz cv cA wceq vx cv vy cv wcel vy cv vz cv wss wa vx cv vy cv wcel vy cv
      cA wss wa vy cB vz cv cA wceq vy cv vz cv wss vy cv cA wss vx cv vy cv
      wcel vz cv cA vy cv sseq2 anbi2d rexbidv raleqd anbi12d elabg pm5.21nd
      bitrd $.
      $( [25-Jul-2006] $) $( [15-Jul-2006] $)

    $( Property of a member of a topology generated by a basis. $)
    tg1 $p |- ( ( B e. Bases /\ A e. ( topGen ` B ) ) ->
              A C_ U. B ) $=
      cB ctb wcel cA cB ctg cfv wcel cA cB cuni wss vx cv vy cv wcel vy cv cA
      wss wa vy cB wrex vx cA wral vx vy cA cB eltg2 pm3.26bda $.
      $( [26-Jul-2006] $) $( [20-Jul-2006] $)

    $( Property of a member of a topology generated by a basis. $)
    tg2 $p |- ( ( B e. Bases /\ A e. ( topGen ` B ) /\ C e. A ) ->
               E. x e. B ( C e. x /\ x C_ A ) ) $=
      cB ctb wcel cA cB ctg cfv wcel cC cA wcel cC vx cv wcel vx cv cA wss wa
      vx cB wrex cB ctb wcel cA cB ctg cfv wcel cA cB cuni wss vy cv vx cv wcel
      vx cv cA wss wa vx cB wrex vy cA wral wa cC cA wcel cC vx cv wcel vx cv
      cA wss wa vx cB wrex wi vy vx cA cB eltg2 vy cv vx cv wcel vx cv cA wss
      wa vx cB wrex vy cA wral cC cA wcel cC vx cv wcel vx cv cA wss wa vx cB
      wrex wi cA cB cuni wss vy cv vx cv wcel vx cv cA wss wa vx cB wrex cC vx
      cv wcel vx cv cA wss wa vx cB wrex vy cC cA vy cv cC wceq vy cv vx cv
      wcel vx cv cA wss wa cC vx cv wcel vx cv cA wss wa vx cB vy cv cC wceq vy
      cv vx cv wcel cC vx cv wcel vx cv cA wss vy cv cC vx cv eleq1 anbi1d
      rexbidv rcla4cv adantl syl6bi 3imp $.
      $( [26-Jul-2006] $) $( [20-Jul-2006] $)

    $( A member of a basis is a subset of the topology it generates. $)
    bastg $p |- ( B e. Bases -> B C_ ( topGen ` B ) ) $=
      cB ctb wcel vx cB cB ctg cfv cB ctb wcel vx cv cB wcel vx cv cB vx cv cpw
      cin cuni wss vx cv cB ctg cfv wcel cB ctb wcel vx cv cB wcel vx cv cB vx
      cv cpw cin cuni wss cB ctb wcel vx cv cB wcel wa vx cv vx cv cin cB vx cv
      vx cv cin cpw cin cuni vx cv cB vx cv cpw cin cuni cB ctb wcel vx cv cB
      wcel vx cv vx cv cin cB vx cv vx cv cin cpw cin cuni wss cB vx cv vx cv
      basis1 3anidm23 vx cv inidm cB vx cv vx cv cin cpw cin cB vx cv cpw cin
      vx cv vx cv cin cpw vx cv cpw cB vx cv vx cv cin vx cv wceq vx cv vx cv
      cin cpw vx cv cpw wceq vx cv inidm vx cv vx cv cin vx cv pweq ax-mp
      ineq2i unieqi 3sstr3g ex vx cv cB eltg sylibrd ssrdv $.
      $( [23-Jul-2006] $) $( [16-Jul-2006] $)

    $( The topology generated by a basis ` B ` is a topology on ` U. B ` .
       Importantly, this theorem means that we don't have to specify separately
       the base set for the topological space generated by a basis.  In other
       words, any member of the class ` Bases ` completely specifies the basis
       it corresponds to. $)
    unitg $p |- ( B e. Bases -> U. ( topGen ` B ) = U. B ) $=
      cB ctb wcel vx cB ctg cfv cuni cB cuni cB ctb wcel vx cv cB ctg cfv cuni
      wcel vx cv cB cuni wcel cB ctb wcel vx cv vy cv wcel vy cB ctg cfv wrex
      vx cv cB cuni wcel vx cv cB ctg cfv cuni wcel cB ctb wcel vx cv vy cv
      wcel vx cv cB cuni wcel vy cB ctg cfv cB ctb wcel vy cv cB ctg cfv wcel
      vy cv cB vy cv cpw cin cuni wss vx cv vy cv wcel vx cv cB cuni wcel wi vy
      cv cB eltg vy cv cB vy cv cpw cin cuni wss vy cv cB cuni vx cv vy cv cB
      vy cv cpw cin cuni wss cB vy cv cpw cin cuni cB cuni wss vy cv cB cuni
      wss cB vy cv cpw cin cB wss cB vy cv cpw cin cuni cB cuni wss cB vy cv
      cpw inss1 cB vy cv cpw cin cB uniss ax-mp vy cv cB vy cv cpw cin cuni cB
      cuni sstr mpan2 sseld syl6bi r19.23adv vy vx cv cB ctg cfv eluni2 syl5ib
      cB ctb wcel cB cuni cB ctg cfv cuni vx cv cB ctb wcel cB cB ctg cfv wss
      cB cuni cB ctg cfv cuni wss cB bastg cB cB ctg cfv uniss syl sseld impbid
      eqrdv $.
      $( [24-Jul-2006] $) $( [16-Jul-2006] $)

    $( Show that a basis generates a topology.  Remark in [Munkres] p. 79. $)
    tgcl $p |- ( B e. Bases -> ( topGen ` B ) e. Top ) $=
      cB ctg cfv ctop wcel vu cv cB ctg cfv wss vu cv cuni cB ctg cfv wcel wi
      vu wal vu cv vv cv cin cB ctg cfv wcel vv cB ctg cfv wral vu cB ctg cfv
      wral cB ctb wcel cB ctg cfv cvv wcel cB ctg cfv ctop wcel vu cv cB ctg
      cfv wss vu cv cuni cB ctg cfv wcel wi vu wal vu cv vv cv cin cB ctg cfv
      wcel vv cB ctg cfv wral vu cB ctg cfv wral wa wb cB ctg fvex vu vv cvv cB
      ctg cfv istopg ax-mp cB ctb wcel vu cv cB ctg cfv wss vu cv cuni cB ctg
      cfv wcel wi vu cB ctb wcel vu cv cB ctg cfv wss vu cv cuni cB cuni wss vx
      cv vy cv wcel vy cv vu cv cuni wss wa vy cB wrex vx vu cv cuni wral wa vu
      cv cuni cB ctg cfv wcel cB ctb wcel vu cv cB ctg cfv wss vu cv cuni cB
      cuni wss vx cv vy cv wcel vy cv vu cv cuni wss wa vy cB wrex vx vu cv
      cuni wral wa cB ctb wcel vu cv cB ctg cfv wss wa vu cv cuni cB cuni wss
      vx cv vy cv wcel vy cv vu cv cuni wss wa vy cB wrex vx vu cv cuni wral cB
      ctb wcel vu cv cB ctg cfv wss wa vu cv cuni cB ctg cfv cuni cB cuni vu cv
      cB ctg cfv wss vu cv cuni cB ctg cfv cuni wss cB ctb wcel vu cv cB ctg
      cfv uniss adantl cB ctb wcel cB ctg cfv cuni cB cuni wceq vu cv cB ctg
      cfv wss cB unitg adantr sseqtrd cB ctb wcel vu cv cB ctg cfv wss wa vx cv
      vy cv wcel vy cv vu cv cuni wss wa vy cB wrex vx vu cv cuni cB ctb wcel
      vu cv cB ctg cfv wss wa vx cv vt cv wcel vt vu cv wrex vx cv vy cv wcel
      vy cv vu cv cuni wss wa vy cB wrex vx cv vu cv cuni wcel cB ctb wcel vu
      cv cB ctg cfv wss wa vx cv vt cv wcel vx cv vy cv wcel vy cv vu cv cuni
      wss wa vy cB wrex vt vu cv cB ctb wcel vu cv cB ctg cfv wss wa vt cv vu
      cv wcel vx cv vt cv wcel vx cv vy cv wcel vy cv vu cv cuni wss wa vy cB
      wrex cB ctb wcel vu cv cB ctg cfv wss wa vt cv vu cv wcel vx cv vt cv
      wcel wa wa vx cv vy cv wcel vy cv vt cv wss wa vy cB wrex vx cv vy cv
      wcel vy cv vu cv cuni wss wa vy cB wrex cB ctb wcel vx cv vt cv wcel vu
      cv cB ctg cfv wss vt cv vu cv wcel vx cv vy cv wcel vy cv vt cv wss wa vy
      cB wrex cB ctb wcel vx cv vt cv wcel wa vt cv cB ctg cfv wcel vx cv vy cv
      wcel vy cv vt cv wss wa vy cB wrex vu cv cB ctg cfv wss vt cv vu cv wcel
      wa cB ctb wcel vt cv cB ctg cfv wcel vx cv vt cv wcel vx cv vy cv wcel vy
      cv vt cv wss wa vy cB wrex cB ctb wcel vt cv cB ctg cfv wcel vx cv vt cv
      wcel vx cv vy cv wcel vy cv vt cv wss wa vy cB wrex cB ctb wcel vt cv cB
      ctg cfv wcel vx cv vy cv wcel vy cv vt cv wss wa vy cB wrex vx vt cv wral
      vx cv vt cv wcel vx cv vy cv wcel vy cv vt cv wss wa vy cB wrex wi cB ctb
      wcel vt cv cB ctg cfv wcel vt cv cB cuni wss vx cv vy cv wcel vy cv vt cv
      wss wa vy cB wrex vx vt cv wral wa vx cv vy cv wcel vy cv vt cv wss wa vy
      cB wrex vx vt cv wral vx vy vt cv cB eltg2 vt cv cB cuni wss vx cv vy cv
      wcel vy cv vt cv wss wa vy cB wrex vx vt cv wral pm3.27 syl6bi vx cv vy
      cv wcel vy cv vt cv wss wa vy cB wrex vx vt cv ra4 syl6 imp31 an1rs vu cv
      cB ctg cfv vt cv ssel2 sylan2 an42s vt cv vu cv wcel vx cv vy cv wcel vy
      cv vt cv wss wa vy cB wrex vx cv vy cv wcel vy cv vu cv cuni wss wa vy cB
      wrex wi cB ctb wcel vu cv cB ctg cfv wss wa vx cv vt cv wcel vt cv vu cv
      wcel vx cv vy cv wcel vy cv vt cv wss wa vx cv vy cv wcel vy cv vu cv
      cuni wss wa vy cB vt cv vu cv wcel vy cv vt cv wss vy cv vu cv cuni wss
      vx cv vy cv wcel vy cv vt cv wss vt cv vu cv cuni wss vy cv vu cv cuni
      wss vt cv vu cv wcel vy cv vt cv vu cv cuni sstr2 vt cv vu cv elssuni
      syl5com anim2d r19.22sdv ad2antrl mpd exp32 r19.23adv vt vx cv vu cv
      eluni2 syl5ib r19.21aiv jca ex vx vy vu cv cuni cB eltg2 sylibrd 19.21aiv
      cB ctb wcel vu cv vv cv cin cB ctg cfv wcel vu vv cB ctg cfv cB ctg cfv
      cB ctb wcel vu cv cB ctg cfv wcel vv cv cB ctg cfv wcel wa vu cv vv cv
      cin cB cuni wss vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB wrex
      vx vu cv vv cv cin wral wa vu cv vv cv cin cB ctg cfv wcel cB ctb wcel vu
      cv cB ctg cfv wcel vv cv cB ctg cfv wcel wa vu cv vv cv cin cB cuni wss
      vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB wrex vx vu cv vv cv
      cin wral wa cB ctb wcel vu cv cB ctg cfv wcel vv cv cB ctg cfv wcel wa wa
      vu cv vv cv cin cB cuni wss vx cv vt cv wcel vt cv vu cv vv cv cin wss wa
      vt cB wrex vx vu cv vv cv cin wral cB ctb wcel vu cv cB ctg cfv wcel vu
      cv vv cv cin cB cuni wss vv cv cB ctg cfv wcel cB ctb wcel vu cv cB ctg
      cfv wcel wa vu cv cB cuni wss vu cv vv cv cin cB cuni wss vu cv cB tg1 vu
      cv vv cv cB cuni ssinss1 syl adantrr cB ctb wcel vu cv cB ctg cfv wcel vv
      cv cB ctg cfv wcel wa wa vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt
      cB wrex vx vu cv vv cv cin cB ctb wcel vu cv cB ctg cfv wcel vv cv cB ctg
      cfv wcel wa vx cv vu cv vv cv cin wcel vx cv vz cv wcel vz cv vu cv wss
      wa vx cv vw cv wcel vw cv vv cv wss wa wa vw cB wrex vz cB wrex wi vx cv
      vu cv vv cv cin wcel vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB
      wrex wi cB ctb wcel vu cv cB ctg cfv wcel vv cv cB ctg cfv wcel vx cv vu
      cv vv cv cin wcel vx cv vz cv wcel vz cv vu cv wss wa vx cv vw cv wcel vw
      cv vv cv wss wa wa vw cB wrex vz cB wrex wi cB ctb wcel vu cv cB ctg cfv
      wcel wa cB ctb wcel vv cv cB ctg cfv wcel wa wa vx cv vu cv wcel vx cv vv
      cv wcel wa vx cv vz cv wcel vz cv vu cv wss wa vz cB wrex vx cv vw cv
      wcel vw cv vv cv wss wa vw cB wrex wa vx cv vu cv vv cv cin wcel vx cv vz
      cv wcel vz cv vu cv wss wa vx cv vw cv wcel vw cv vv cv wss wa wa vw cB
      wrex vz cB wrex cB ctb wcel vu cv cB ctg cfv wcel wa vx cv vu cv wcel vx
      cv vz cv wcel vz cv vu cv wss wa vz cB wrex cB ctb wcel vv cv cB ctg cfv
      wcel wa vx cv vv cv wcel vx cv vw cv wcel vw cv vv cv wss wa vw cB wrex
      cB ctb wcel vu cv cB ctg cfv wcel wa vx cv vz cv wcel vz cv vu cv wss wa
      vz cB wrex vx vu cv wral vx cv vu cv wcel vx cv vz cv wcel vz cv vu cv
      wss wa vz cB wrex wi cB ctb wcel vu cv cB ctg cfv wcel vu cv cB cuni wss
      vx cv vz cv wcel vz cv vu cv wss wa vz cB wrex vx vu cv wral vx vz vu cv
      cB eltg2 pm3.27bda vx cv vz cv wcel vz cv vu cv wss wa vz cB wrex vx vu
      cv ra4 syl cB ctb wcel vv cv cB ctg cfv wcel wa vx cv vw cv wcel vw cv vv
      cv wss wa vw cB wrex vx vv cv wral vx cv vv cv wcel vx cv vw cv wcel vw
      cv vv cv wss wa vw cB wrex wi cB ctb wcel vv cv cB ctg cfv wcel vv cv cB
      cuni wss vx cv vw cv wcel vw cv vv cv wss wa vw cB wrex vx vv cv wral vx
      vw vv cv cB eltg2 pm3.27bda vx cv vw cv wcel vw cv vv cv wss wa vw cB
      wrex vx vv cv ra4 syl im2anan9 vx cv vu cv vv cv elin vx cv vz cv wcel vz
      cv vu cv wss wa vx cv vw cv wcel vw cv vv cv wss wa vz vw cB cB reeanv
      3imtr4g anandis cB ctb wcel vx cv vu cv vv cv cin wcel vx cv vz cv wcel
      vz cv vu cv wss wa vx cv vw cv wcel vw cv vv cv wss wa wa vw cB wrex vz
      cB wrex wi vx cv vu cv vv cv cin wcel vx cv vt cv wcel vt cv vu cv vv cv
      cin wss wa vt cB wrex wi cB ctb wcel vx cv vu cv vv cv cin wcel vx cv vz
      cv wcel vz cv vu cv wss wa vx cv vw cv wcel vw cv vv cv wss wa wa vw cB
      wrex vz cB wrex vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB wrex
      cB ctb wcel vx cv vu cv vv cv cin wcel vx cv vz cv wcel vz cv vu cv wss
      wa vx cv vw cv wcel vw cv vv cv wss wa wa vw cB wrex vz cB wrex vx cv vt
      cv wcel vt cv vu cv vv cv cin wss wa vt cB wrex wi cB ctb wcel vx cv vu
      cv vv cv cin wcel wa vx cv vz cv wcel vz cv vu cv wss wa vx cv vw cv wcel
      vw cv vv cv wss wa wa vw cB wrex vx cv vt cv wcel vt cv vu cv vv cv cin
      wss wa vt cB wrex vz cB cB ctb wcel vx cv vu cv vv cv cin wcel wa vz cv
      cB wcel wa vx cv vz cv wcel vz cv vu cv wss wa vx cv vw cv wcel vw cv vv
      cv wss wa wa vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB wrex vw
      cB cB ctb wcel vx cv vu cv vv cv cin wcel wa vz cv cB wcel wa vw cv cB
      wcel vx cv vz cv wcel vz cv vu cv wss wa vx cv vw cv wcel vw cv vv cv wss
      wa wa vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB wrex cB ctb
      wcel vx cv vu cv vv cv cin wcel wa vz cv cB wcel wa vw cv cB wcel vx cv
      vz cv vw cv cin wcel vz cv vw cv cin vu cv vv cv cin wss wa vx cv vt cv
      wcel vt cv vu cv vv cv cin wss wa vt cB wrex vx cv vz cv wcel vz cv vu cv
      wss wa vx cv vw cv wcel vw cv vv cv wss wa wa cB ctb wcel vx cv vu cv vv
      cv cin wcel wa vz cv cB wcel wa vw cv cB wcel vx cv vz cv vw cv cin wcel
      vz cv vw cv cin vu cv vv cv cin wss wa wa wa vx cv vt cv wcel vt cv vz cv
      vw cv cin wss wa vt cB wrex vx cv vt cv wcel vt cv vu cv vv cv cin wss wa
      vt cB wrex cB ctb wcel vx cv vu cv vv cv cin wcel wa vz cv cB wcel wa vw
      cv cB wcel vx cv vz cv vw cv cin wcel vx cv vt cv wcel vt cv vz cv vw cv
      cin wss wa vt cB wrex vz cv vw cv cin vu cv vv cv cin wss cB ctb wcel vz
      cv cB wcel vw cv cB wcel vx cv vz cv vw cv cin wcel wa vx cv vt cv wcel
      vt cv vz cv vw cv cin wss wa vt cB wrex vx cv vu cv vv cv cin wcel vt vx
      cv cB vz cv vw cv basis2 adantllr adantrrr vx cv vz cv vw cv cin wcel vz
      cv vw cv cin vu cv vv cv cin wss wa vx cv vt cv wcel vt cv vz cv vw cv
      cin wss wa vt cB wrex vx cv vt cv wcel vt cv vu cv vv cv cin wss wa vt cB
      wrex wi cB ctb wcel vx cv vu cv vv cv cin wcel wa vz cv cB wcel wa vw cv
      cB wcel vz cv vw cv cin vu cv vv cv cin wss vx cv vt cv wcel vt cv vz cv
      vw cv cin wss wa vt cB wrex vx cv vt cv wcel vt cv vu cv vv cv cin wss wa
      vt cB wrex wi vx cv vz cv vw cv cin wcel vz cv vw cv cin vu cv vv cv cin
      wss vx cv vt cv wcel vt cv vz cv vw cv cin wss wa vx cv vt cv wcel vt cv
      vu cv vv cv cin wss wa vt cB vz cv vw cv cin vu cv vv cv cin wss vt cv vz
      cv vw cv cin wss vt cv vu cv vv cv cin wss vx cv vt cv wcel vt cv vz cv
      vw cv cin wss vz cv vw cv cin vu cv vv cv cin wss vt cv vu cv vv cv cin
      wss vt cv vz cv vw cv cin vu cv vv cv cin sstr2 com12 anim2d r19.22sdv
      adantl ad2antll mpd vx cv vz cv wcel vx cv vw cv wcel vz cv vu cv wss vw
      cv vv cv wss vx cv vz cv vw cv cin wcel vz cv vw cv cin vu cv vv cv cin
      wss wa vx cv vz cv wcel vx cv vw cv wcel wa vx cv vz cv vw cv cin wcel vz
      cv vu cv wss vw cv vv cv wss wa vz cv vw cv cin vu cv vv cv cin wss vx cv
      vz cv vw cv cin wcel vx cv vz cv wcel vx cv vw cv wcel wa vx cv vz cv vw
      cv elin biimpri vz cv vu cv vw cv vv cv ss2in anim12i an4s sylanr2 exp32
      r19.23adv r19.23adva ex a2d imp syldan r19.21aiv jca ex vx vt vu cv vv cv
      cin cB eltg2 sylibrd r19.21aivv sylanbrc $.
      $( [25-Jul-2006] $) $( [17-Jul-2006] $)

    $( Alternate expression for the topology generated by a basis.  Lemma 2.1
       of [Munkres] p. 80. $)
    tgval3 $p |- ( B e. Bases ->
               ( topGen ` B ) = { x | E. y ( y C_ B /\ x = U. y ) } ) $=
      cB ctb wcel vy cv cB wss vx cv vy cv cuni wceq wa vy wex vx cB ctg cfv cB
      ctb wcel vx cv cB ctg cfv wcel vy cv cB wss vx cv vy cv cuni wceq wa vy
      wex cB ctb wcel vx cv cB ctg cfv wcel vy cv cB wss vx cv vy cv cuni wceq
      wa vy wex vy cv vx cv wss vy cv cB wcel wa vy cab cB wss vx cv vy cv vx
      cv wss vy cv cB wcel wa vy cab cuni wceq vy cv cB wss vx cv vy cv cuni
      wceq wa vy wex cB ctb wcel vx cv cB ctg cfv wcel wa vy cv vx cv wss vy cv
      cB wcel wa vy cab cvv wcel vy cv vx cv wss vy cv cB wcel wa vy cab cB wss
      vx cv vy cv vx cv wss vy cv cB wcel wa vy cab cuni wceq wa vy cv cB wss
      vx cv vy cv cuni wceq wa vy wex wi vx cv cvv wcel vy cv vx cv wss vy cv
      cB wcel wa vy cab cvv wcel vx visset vy cv cB wcel vy vx cv cvv abssexg
      ax-mp vy cv cB wss vx cv vy cv cuni wceq wa vy cv vx cv wss vy cv cB wcel
      wa vy cab cB wss vx cv vy cv vx cv wss vy cv cB wcel wa vy cab cuni wceq
      wa vy vz vy cv vx cv wss vy cv cB wcel wa vy cab cvv vy cv vx cv wss vy
      cv cB wcel wa vy vz hbab1 vy cv vx cv wss vy cv cB wcel wa vy cab cB wss
      vx cv vy cv vx cv wss vy cv cB wcel wa vy cab cuni wceq vy vy vz vy cv vx
      cv wss vy cv cB wcel wa vy cab cB vy cv vx cv wss vy cv cB wcel wa vy vz
      hbab1 vz cv cB wcel vy ax-17 hbss vy vz vz vx cv vy cv vx cv wss vy cv cB
      wcel wa vy cab cuni vz cv vx cv wcel vy ax-17 vy vz vy cv vx cv wss vy cv
      cB wcel wa vy cab vy cv vx cv wss vy cv cB wcel wa vy vz hbab1 hbuni hbeq
      hban vy cv vy cv vx cv wss vy cv cB wcel wa vy cab wceq vy cv cB wss vy
      cv vx cv wss vy cv cB wcel wa vy cab cB wss vx cv vy cv cuni wceq vx cv
      vy cv vx cv wss vy cv cB wcel wa vy cab cuni wceq vy cv vy cv vx cv wss
      vy cv cB wcel wa vy cab cB sseq1 vy cv vy cv vx cv wss vy cv cB wcel wa
      vy cab wceq vy cv cuni vy cv vx cv wss vy cv cB wcel wa vy cab cuni vx cv
      vy cv vy cv vx cv wss vy cv cB wcel wa vy cab unieq eqeq2d anbi12d
      cla4egf ax-mp vy cv vx cv wss vy cv cB wcel wa vy cB vy cv vx cv wss vy
      cv cB wcel pm3.27 abssi cB ctb wcel vx cv cB ctg cfv wcel wa vz vx cv vy
      cv vx cv wss vy cv cB wcel wa vy cab cuni cB ctb wcel vx cv cB ctg cfv
      wcel wa vz cv vx cv wcel vz cv vy cv wcel vy cv vx cv wss vy cv cB wcel
      wa wa vy wex vz cv vy cv vx cv wss vy cv cB wcel wa vy cab cuni wcel cB
      ctb wcel vx cv cB ctg cfv wcel wa vz cv vx cv wcel vz cv vy cv wcel vy cv
      vx cv wss vy cv cB wcel wa wa vy wex cB ctb wcel vx cv cB ctg cfv wcel wa
      vw cv vy cv wcel vy cv vx cv wss wa vy cB wrex vw vx cv wral vz cv vx cv
      wcel vz cv vy cv wcel vy cv vx cv wss vy cv cB wcel wa wa vy wex wi cB
      ctb wcel vx cv cB ctg cfv wcel vx cv cB cuni wss vw cv vy cv wcel vy cv
      vx cv wss wa vy cB wrex vw vx cv wral vw vy vx cv cB eltg2 pm3.27bda vw
      cv vy cv wcel vy cv vx cv wss wa vy cB wrex vw vx cv wral vz cv vx cv
      wcel vz cv vy cv wcel vy cv vx cv wss wa vy cB wrex vz cv vy cv wcel vy
      cv vx cv wss vy cv cB wcel wa wa vy wex vw cv vy cv wcel vy cv vx cv wss
      wa vy cB wrex vz cv vy cv wcel vy cv vx cv wss wa vy cB wrex vw vz cv vx
      cv vw cv vz cv wceq vw cv vy cv wcel vy cv vx cv wss wa vz cv vy cv wcel
      vy cv vx cv wss wa vy cB vw cv vz cv wceq vw cv vy cv wcel vz cv vy cv
      wcel vy cv vx cv wss vw vz vy elequ1 anbi1d rexbidv rcla4cv vz cv vy cv
      wcel vy cv vx cv wss wa vy cB wrex vy cv cB wcel vz cv vy cv wcel vy cv
      vx cv wss wa wa vy wex vz cv vy cv wcel vy cv vx cv wss vy cv cB wcel wa
      wa vy wex vz cv vy cv wcel vy cv vx cv wss wa vy cB df-rex vy cv cB wcel
      vz cv vy cv wcel vy cv vx cv wss wa wa vz cv vy cv wcel vy cv vx cv wss
      vy cv cB wcel wa wa vy vy cv cB wcel vz cv vy cv wcel vy cv vx cv wss wa
      wa vz cv vy cv wcel vy cv cB wcel vy cv vx cv wss wa wa vz cv vy cv wcel
      vy cv vx cv wss vy cv cB wcel wa wa vy cv cB wcel vz cv vy cv wcel vy cv
      vx cv wss an12 vy cv cB wcel vy cv vx cv wss wa vy cv vx cv wss vy cv cB
      wcel wa vz cv vy cv wcel vy cv cB wcel vy cv vx cv wss ancom anbi2i bitri
      exbii bitri syl6ib syl vz cv vy cv wcel vy cv vx cv wss vy cv cB wcel wa
      wa vz cv vx cv wcel vy vz cv vy cv wcel vy cv vx cv wss vz cv vx cv wcel
      vy cv cB wcel vy cv vx cv wss vz cv vy cv wcel vz cv vx cv wcel vy cv vx
      cv vz cv ssel impcom adantrr 19.23aiv impbid1 vy cv vx cv wss vy cv cB
      wcel wa vy vz cv eluniab syl6bbr eqrdv sylancr ex cB ctb wcel vy cv cB
      wss vx cv vy cv cuni wceq wa vx cv cB ctg cfv wcel vy cB ctb wcel vy cv
      cB wss vx cv vy cv cuni wceq wa vx cv cB ctg cfv wcel cB ctb wcel vy cv
      cB wss vx cv vy cv cuni wceq wa wa vx cv vy cv cuni cB ctg cfv cB ctb
      wcel vy cv cB wss vx cv vy cv cuni wceq simprr cB ctb wcel vy cv cB wss
      vy cv cuni cB ctg cfv wcel vx cv vy cv cuni wceq cB ctg cfv ctop wcel vy
      cv cB ctg cfv wss vy cv cuni cB ctg cfv wcel cB ctb wcel vy cv cB wss wa
      vy cv cB ctg cfv uniopn cB ctb wcel cB ctg cfv ctop wcel vy cv cB wss cB
      tgcl adantr vy cv cB wss cB ctb wcel vy cv cB ctg cfv wss vy cv cB wss cB
      cB ctg cfv wss vy cv cB ctg cfv wss cB ctb wcel vy cv cB cB ctg cfv sstr
      cB bastg sylan2 ancoms sylanc adantrr eqeltrd ex 19.23adv impbid abbi2dv
      $.
      $( [25-Jul-2006] $) $( [17-Jul-2006] $)

    $( Membership in a topology generated by a basis. $)
    eltg3 $p |- ( B e. Bases -> ( A e. ( topGen ` B ) <->
           E. x ( x C_ B /\ A = U. x ) ) ) $=
      cB ctb wcel cA cB ctg cfv wcel cA vx cv cB wss vy cv vx cv cuni wceq wa
      vx wex vy cab wcel vx cv cB wss cA vx cv cuni wceq wa vx wex cB ctb wcel
      cB ctg cfv vx cv cB wss vy cv vx cv cuni wceq wa vx wex vy cab cA vy vx
      cB tgval3 eleq2d vx cv cB wss vy cv vx cv cuni wceq wa vx wex vx cv cB
      wss cA vx cv cuni wceq wa vx wex vy cA vx cv cB wss cA vx cv cuni wceq wa
      cA cvv wcel vx cA vx cv cuni wceq cA cvv wcel vx cv cB wss cA vx cv cuni
      wceq cA cvv wcel vx cv cuni cvv wcel vx cv vx visset uniex cA vx cv cuni
      cvv eleq1 mpbiri adantl 19.23aiv vy cv cA wceq vx cv cB wss vy cv vx cv
      cuni wceq wa vx cv cB wss cA vx cv cuni wceq wa vx vy cv cA wceq vy cv vx
      cv cuni wceq cA vx cv cuni wceq vx cv cB wss vy cv cA vx cv cuni eqeq1
      anbi2d exbidv elab3 syl6bb $.
      $( [26-Jul-2006] $) $( [15-Jul-2006] $)

    $( A topology is its own basis. $)
    topbas $p |- ( J e. Top -> J e. Bases ) $=
      cJ ctop wcel cJ ctb wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw
      cJ wrex vz vx cv vy cv cin wral vy cJ wral vx cJ wral cJ ctop wcel vz cv
      vw cv wcel vw cv vx cv vy cv cin wss wa vw cJ wrex vz vx cv vy cv cin
      wral vx vy cJ cJ cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa vz cv vw cv
      wcel vw cv vx cv vy cv cin wss wa vw cJ wrex vz vx cv vy cv cin cJ ctop
      wcel vx cv cJ wcel vy cv cJ wcel wa vz cv vx cv vy cv cin wcel vz cv vw
      cv wcel vw cv vx cv vy cv cin wss wa vw cJ wrex vx cv vy cv cin cJ wcel
      vz cv vx cv vy cv cin wcel vx cv vy cv cin vx cv vy cv cin wss wa vz cv
      vw cv wcel vw cv vx cv vy cv cin wss wa vw cJ wrex cJ ctop wcel vx cv cJ
      wcel vy cv cJ wcel wa wa vz cv vx cv vy cv cin wcel wa vz cv vw cv wcel
      vw cv vx cv vy cv cin wss wa vz cv vx cv vy cv cin wcel vx cv vy cv cin
      vx cv vy cv cin wss wa vw vx cv vy cv cin cJ vw cv vx cv vy cv cin wceq
      vz cv vw cv wcel vz cv vx cv vy cv cin wcel vw cv vx cv vy cv cin wss vx
      cv vy cv cin vx cv vy cv cin wss vw cv vx cv vy cv cin vz cv eleq2 vw cv
      vx cv vy cv cin vx cv vy cv cin sseq1 anbi12d rcla4ev cJ ctop wcel vx cv
      cJ wcel vy cv cJ wcel wa wa vx cv vy cv cin cJ wcel vz cv vx cv vy cv cin
      wcel cJ ctop wcel vx cv cJ wcel vy cv cJ wcel vx cv vy cv cin cJ wcel vx
      cv vy cv cJ inopn 3expb adantr cJ ctop wcel vx cv cJ wcel vy cv cJ wcel
      wa wa vz cv vx cv vy cv cin wcel wa vz cv vx cv vy cv cin wcel vx cv vy
      cv cin vx cv vy cv cin wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa
      vz cv vx cv vy cv cin wcel pm3.27 vx cv vy cv cin ssid jctir sylanc exp31
      r19.21adv r19.21aivv vx vy vz vw cJ ctop isbasis2g mpbird $.
      $( [22-Jul-2006] $) $( [17-Jul-2006] $)

    $( A topology is its own basis. $)
    tgtop $p |- ( J e. Top -> ( topGen ` J ) = J ) $=
      cJ ctop wcel cJ ctg cfv cJ cJ ctop wcel vx cJ ctg cfv cJ cJ ctop wcel vx
      cv cJ ctg cfv wcel vy cv cJ wss vx cv vy cv cuni wceq wa vy wex vx cv cJ
      wcel cJ ctop wcel cJ ctb wcel vx cv cJ ctg cfv wcel vy cv cJ wss vx cv vy
      cv cuni wceq wa vy wex wb cJ topbas vy vx cv cJ eltg3 syl cJ ctop wcel vy
      cv cJ wss vx cv vy cv cuni wceq wa vx cv cJ wcel vy cJ ctop wcel vy cv cJ
      wss vx cv vy cv cuni wceq wa vx cv cJ wcel cJ ctop wcel vy cv cJ wss vx
      cv vy cv cuni wceq vx cv cJ wcel cJ ctop wcel vy cv cJ wss wa vx cv vy cv
      cuni wceq wa vx cv vy cv cuni cJ cJ ctop wcel vy cv cJ wss wa vx cv vy cv
      cuni wceq pm3.27 cJ ctop wcel vy cv cJ wss wa vy cv cuni cJ wcel vx cv vy
      cv cuni wceq vy cv cJ uniopn adantr eqeltrd anasss ex 19.23adv sylbid
      ssrdv cJ ctop wcel cJ ctb wcel cJ cJ ctg cfv wss cJ topbas cJ bastg syl
      eqssd $.
      $( [27-Jul-2006] $) $( [18-Jul-2006] $)

    $( Membership in a topology, expressed without quantifiers. $)
    eltop $p |- ( J e. Top -> ( A e. J <-> A C_ U. ( J i^i ~P A ) ) ) $=
      cJ ctop wcel cA cJ ctg cfv wcel cA cJ wcel cA cJ cA cpw cin cuni wss cJ
      ctop wcel cJ ctg cfv cJ cA cJ tgtop eleq2d cJ ctop wcel cJ ctb wcel cA cJ
      ctg cfv wcel cA cJ cA cpw cin cuni wss wb cJ topbas cA cJ eltg syl bitr3d
      $.
      $( [2-Jan-2007] $) $( [19-Jul-2006] $)

    $( Membership in a topology. $)
    eltop2 $p |- ( J e. Top -> ( A e. J <->
               ( A C_ U. J /\ A. x e. A E. y e. J ( x e. y /\ y C_ A ) ) ) ) $=
      cJ ctop wcel cA cJ ctg cfv wcel cA cJ wcel cA cJ cuni wss vx cv vy cv
      wcel vy cv cA wss wa vy cJ wrex vx cA wral wa cJ ctop wcel cJ ctg cfv cJ
      cA cJ tgtop eleq2d cJ ctop wcel cJ ctb wcel cA cJ ctg cfv wcel cA cJ cuni
      wss vx cv vy cv wcel vy cv cA wss wa vy cJ wrex vx cA wral wa wb cJ
      topbas vx vy cA cJ eltg2 syl bitr3d $.
      $( [23-Aug-2007] $) $( [19-Jul-2006] $)

    $( Membership in a topology. $)
    eltop3 $p |- ( J e. Top -> ( A e. J <-> E. x ( x C_ J /\ A = U. x ) ) ) $=
      cJ ctop wcel cA cJ ctg cfv wcel cA cJ wcel vx cv cJ wss cA vx cv cuni
      wceq wa vx wex cJ ctop wcel cJ ctg cfv cJ cA cJ tgtop eleq2d cJ ctop wcel
      cJ ctb wcel cA cJ ctg cfv wcel vx cv cJ wss cA vx cv cuni wceq wa vx wex
      wb cJ topbas vx cA cJ eltg3 syl bitr3d $.
      $( [29-Mar-2008] $) $( [19-Jul-2006] $)
  $}

  $( The topology generator function is idempotent. $)
  tgidm $p |- ( B e. Bases ->
               ( topGen ` ( topGen ` B ) ) = ( topGen ` B ) ) $=
    cB ctb wcel cB ctg cfv ctop wcel cB ctg cfv ctg cfv cB ctg cfv wceq cB tgcl
    cB ctg cfv tgtop syl $.
    $( [9-Jan-2007] $) $( [18-Jul-2006] $)

  $( Two ways to express that a basis is a topology. $)
  bastop $p |- ( B e. Bases -> ( B e. Top <-> ( topGen ` B ) = B ) ) $=
    cB ctb wcel cB ctop wcel cB ctg cfv cB wceq cB tgtop cB ctb wcel cB ctg cfv
    cB wceq cB ctop wcel cB ctb wcel cB ctg cfv cB wceq wa cB ctg cfv cB ctop
    cB ctb wcel cB ctg cfv cB wceq pm3.27 cB ctb wcel cB ctg cfv ctop wcel cB
    ctg cfv cB wceq cB tgcl adantr eqeltrrd ex impbid2 $.
    $( [14-Aug-2007] $) $( [18-Jul-2006] $)

  $( The topology generation function is one-to-one when applied to completed
     topologies. $)
  tgtop11 $p |- ( ( J e. Top /\ K e. Top /\ ( topGen ` J ) = ( topGen ` K ) )
                 -> J = K ) $=
    cJ ctop wcel cK ctop wcel cJ ctg cfv cK ctg cfv wceq w3a cJ ctg cfv cK ctg
    cfv cJ cK cJ ctop wcel cK ctop wcel cJ ctg cfv cK ctg cfv wceq 3simp3 cJ
    ctop wcel cK ctop wcel cJ ctg cfv cJ wceq cJ ctg cfv cK ctg cfv wceq cJ
    tgtop 3ad2ant1 cK ctop wcel cJ ctop wcel cK ctg cfv cK wceq cJ ctg cfv cK
    ctg cfv wceq cK tgtop 3ad2ant2 3eqtr3d $.
    $( [11-Jun-2007] $) $( [18-Jul-2006] $)

  $( The singleton of the empty set is the only topology possible for an empty
     underlying set. $)
  0top $p |- ( J e. Top -> ( U. J = (/) <-> J = { (/) } ) ) $=
    cJ ctop wcel cJ c0 csn wceq cJ c0 wceq cJ c0 csn wceq wo cJ cuni c0 wceq cJ
    ctop wcel cJ c0 csn wceq cJ c0 wceq cJ c0 csn wceq wo cJ c0 csn wceq cJ c0
    wceq olc cJ ctop wcel cJ c0 wceq cJ c0 csn wceq cJ c0 csn wceq cJ ctop wcel
    cJ c0 wceq cJ c0 csn wceq cJ ctop wcel c0 cJ wcel cJ c0 wceq wn cJ 0opn cJ
    c0 n0i syl pm2.21d cJ ctop wcel cJ c0 csn wceq idd jaod impbid2 cJ cuni c0
    wceq cJ c0 csn wss cJ c0 wceq cJ c0 csn wceq wo cJ uni0b cJ c0 sssn bitr2i
    syl6rbb $.
    $( [24-Mar-2008] $) $( [9-Sep-2006] $)

  ${
    $d u v w x y z B $.  $d u v w x y z C $.  $d v w x y z J $.
    $( Subset relation for generated topologies. $)
    tgss $p |- ( ( B e. Bases /\ C e. Bases /\ B C_ C ) ->
               ( topGen ` B ) C_ ( topGen ` C ) ) $=
      cB ctb wcel cC ctb wcel cB cC wss w3a vx cB ctg cfv cC ctg cfv cB ctb
      wcel cC ctb wcel cB cC wss w3a vx cv cB vx cv cpw cin cuni wss vx cv cC
      vx cv cpw cin cuni wss vx cv cB ctg cfv wcel vx cv cC ctg cfv wcel cB cC
      wss cB ctb wcel vx cv cB vx cv cpw cin cuni wss vx cv cC vx cv cpw cin
      cuni wss wi cC ctb wcel vx cv cB vx cv cpw cin cuni wss cB vx cv cpw cin
      cuni cC vx cv cpw cin cuni wss vx cv cC vx cv cpw cin cuni wss cB cC wss
      vx cv cB vx cv cpw cin cuni cC vx cv cpw cin cuni sstr2 cB cC wss cB vx
      cv cpw cin cC vx cv cpw cin wss cB vx cv cpw cin cuni cC vx cv cpw cin
      cuni wss cB cC vx cv cpw ssrin cB vx cv cpw cin cC vx cv cpw cin uniss
      syl syl5com 3ad2ant3 cB ctb wcel cC ctb wcel vx cv cB ctg cfv wcel vx cv
      cB vx cv cpw cin cuni wss wb cB cC wss vx cv cB eltg 3ad2ant1 cC ctb wcel
      cB ctb wcel vx cv cC ctg cfv wcel vx cv cC vx cv cpw cin cuni wss wb cB
      cC wss vx cv cC eltg 3ad2ant2 3imtr4d ssrdv $.
      $( [10-May-2007] $) $( [7-May-2007] $)

    $( A criterion for determining whether one topology is finer than another,
       based on a comparison of their bases.  Lemma 2.2 of [Munkres] p. 80. $)
    tgss2 $p |- ( ( B e. Bases /\ C e. Bases /\ U. B = U. C ) ->
                    ( ( topGen ` B ) C_ ( topGen ` C ) <->
     A. x e. U. B A. y e. B ( x e. y -> E. z e. C ( x e. z /\ z C_ y ) ) ) ) $=
      cB ctb wcel cC ctb wcel cB cuni cC cuni wceq w3a cB ctg cfv cC ctg cfv
      wss vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy
      cB wral vx cB cuni wral cB ctb wcel cC ctb wcel cB ctg cfv cC ctg cfv wss
      vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB
      wral vx cB cuni wral wi cB cuni cC cuni wceq cB ctb wcel cC ctb wcel wa
      cB ctg cfv cC ctg cfv wss vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv
      wss wa vz cC wrex wi vx vy cB cuni cB cB ctb wcel cC ctb wcel wa cB ctg
      cfv cC ctg cfv wss vx cv cB cuni wcel vy cv cB wcel wa vx cv vy cv wcel
      vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex cC ctb wcel vy cv cC ctg
      cfv wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex
      cB ctb wcel cC ctb wcel wa cB ctg cfv cC ctg cfv wss wa vx cv cB cuni
      wcel vy cv cB wcel wa vx cv vy cv wcel wa wa vz vy cv cC vx cv tg2 cB ctb
      wcel cC ctb wcel cB ctg cfv cC ctg cfv wss vx cv cB cuni wcel vy cv cB
      wcel wa vx cv vy cv wcel wa simpllr cB ctb wcel cC ctb wcel wa cB ctg cfv
      cC ctg cfv wss wa vx cv cB cuni wcel vy cv cB wcel wa vy cv cC ctg cfv
      wcel vx cv vy cv wcel cB ctb wcel cC ctb wcel wa cB ctg cfv cC ctg cfv
      wss wa vy cv cB wcel vy cv cC ctg cfv wcel vx cv cB cuni wcel cB ctb wcel
      cB ctg cfv cC ctg cfv wss vy cv cB wcel vy cv cC ctg cfv wcel cC ctb wcel
      cB ctb wcel cB ctg cfv cC ctg cfv wss wa vy cv cB wcel vy cv cC ctg cfv
      wcel cB ctb wcel cB ctg cfv cC ctg cfv wss wa cB cC ctg cfv vy cv cB cB
      ctg cfv wss cB ctg cfv cC ctg cfv wss cB cC ctg cfv wss cB ctb wcel cB cB
      ctg cfv cC ctg cfv sstr cB bastg sylan sseld imp adantllr adantrl adantrr
      cB ctb wcel cC ctb wcel wa cB ctg cfv cC ctg cfv wss wa vx cv cB cuni
      wcel vy cv cB wcel wa vx cv vy cv wcel simprr syl3anc exp43 r19.21advv
      3adant3 cB ctb wcel cC ctb wcel cB cuni cC cuni wceq w3a vx cv vy cv wcel
      vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni
      wral cB ctg cfv cC ctg cfv wss cB ctb wcel cC ctb wcel cB cuni cC cuni
      wceq w3a vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex
      wi vy cB wral vx cB cuni wral wa vu cB ctg cfv cC ctg cfv cB ctb wcel cC
      ctb wcel cB cuni cC cuni wceq w3a vx cv vy cv wcel vx cv vz cv wcel vz cv
      vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vu cv cB ctg cfv
      wcel vu cv cC ctg cfv wcel cC ctb wcel cB cuni cC cuni wceq cB ctb wcel
      vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB
      wral vx cB cuni wral vu cv cB ctg cfv wcel wa vu cv cC ctg cfv wcel wi cC
      ctb wcel cB cuni cC cuni wceq cB ctb wcel vx cv vy cv wcel vx cv vz cv
      wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vu cv cB
      ctg cfv wcel wa vu cv cC ctg cfv wcel wi cC ctb wcel cB cuni cC cuni wceq
      cB ctb wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex wi vy cB wral vx cB cuni wral vu cv cB ctg cfv wcel wa vu cv cC ctg
      cfv wcel cC ctb wcel vu cv cC ctg cfv wcel vu cv cC cuni wss vw cv vz cv
      wcel vz cv vu cv wss wa vz cC wrex vw vu cv wral wa cB cuni cC cuni wceq
      cB ctb wcel wa vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex wi vy cB wral vx cB cuni wral vu cv cB ctg cfv wcel wa wa vw vz vu
      cv cC eltg2 cB cuni cC cuni wceq cB ctb wcel wa vx cv vy cv wcel vx cv vz
      cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vu cv
      cB ctg cfv wcel wa wa vu cv cC cuni wss vw cv vz cv wcel vz cv vu cv wss
      wa vz cC wrex vw vu cv wral cB cuni cC cuni wceq cB ctb wcel wa vu cv cB
      ctg cfv wcel vu cv cC cuni wss vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral cB cuni cC cuni wceq
      cB ctb wcel wa vu cv cB ctg cfv wcel wa vu cv cB cuni cC cuni cB ctb wcel
      vu cv cB ctg cfv wcel vu cv cB cuni wss cB cuni cC cuni wceq vu cv cB tg1
      adantll cB cuni cC cuni wceq cB ctb wcel vu cv cB ctg cfv wcel simpll
      sseqtrd adantrl cB ctb wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv
      wss wa vz cC wrex wi vy cB wral vx cB cuni wral vu cv cB ctg cfv wcel wa
      vw cv vz cv wcel vz cv vu cv wss wa vz cC wrex vw vu cv wral cB cuni cC
      cuni wceq cB ctb wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss
      wa vz cC wrex wi vy cB wral vx cB cuni wral vu cv cB ctg cfv wcel wa wa
      vw cv vz cv wcel vz cv vu cv wss wa vz cC wrex vw vu cv cB ctb wcel vx cv
      vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral
      vx cB cuni wral vu cv cB ctg cfv wcel vw cv vu cv wcel vw cv vz cv wcel
      vz cv vu cv wss wa vz cC wrex vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral cB ctb wcel vu cv cB
      ctg cfv wcel vw cv vu cv wcel vw cv vz cv wcel vz cv vu cv wss wa vz cC
      wrex wi wi vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex wi vy cB wral vx cB cuni wral cB ctb wcel vu cv cB ctg cfv wcel vw
      cv vu cv wcel vw cv vz cv wcel vz cv vu cv wss wa vz cC wrex vx cv vy cv
      wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB
      cuni wral vw cv vv cv wcel vv cv vu cv wss wa vv cB wrex vw cv vz cv wcel
      vz cv vu cv wss wa vz cC wrex cB ctb wcel vu cv cB ctg cfv wcel wa vw cv
      vu cv wcel wa vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex wi vy cB wral vx cB cuni wral vw cv vv cv wcel vv cv vu cv wss wa vw
      cv vz cv wcel vz cv vu cv wss wa vz cC wrex vv cB vx cv vy cv wcel vx cv
      vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vv
      cv cB wcel vw cv vv cv wcel vv cv vu cv wss wa vw cv vz cv wcel vz cv vu
      cv wss wa vz cC wrex vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa
      vz cC wrex wi vy cB wral vx cB cuni wral vv cv cB wcel vw cv vv cv wcel
      vv cv vu cv wss wa wa wa vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex
      vw cv vz cv wcel vz cv vu cv wss wa vz cC wrex vv cv cB wcel vx cv vy cv
      wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB
      cuni wral vw cv vv cv wcel vv cv vu cv wss wa vw cv vz cv wcel vz cv vv
      cv wss wa vz cC wrex vv cv cB wcel vx cv vy cv wcel vx cv vz cv wcel vz
      cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vw cv vv cv wcel
      vv cv vu cv wss wa wa wa vw cv cB cuni wcel vw cv vz cv wcel vz cv vv cv
      wss wa vz cC wrex vv cv cB wcel vw cv vv cv wcel vv cv vu cv wss wa vw cv
      cB cuni wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex wi vy cB wral vx cB cuni wral vv cv cB wcel vw cv vv cv wcel vw cv
      cB cuni wcel vv cv vu cv wss vv cv cB wcel vw cv vv cv wcel vw cv cB cuni
      wcel vv cv cB wcel vv cv cB cuni vw cv vv cv cB elssuni sseld imp adantrr
      adantrl vv cv cB wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss
      wa vz cC wrex wi vy cB wral vx cB cuni wral vw cv vv cv wcel vw cv cB
      cuni wcel vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex wi vv cv vu cv
      wss vv cv cB wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz
      cC wrex wi vy cB wral vx cB cuni wral vw cv vv cv wcel vw cv cB cuni wcel
      vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex wi vw cv cB cuni wcel vv
      cv cB wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex wi vy cB wral vx cB cuni wral vw cv vv cv wcel vw cv vz cv wcel vz
      cv vv cv wss wa vz cC wrex vw cv cB cuni wcel vv cv cB wcel vx cv vy cv
      wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB
      cuni wral vw cv vv cv wcel vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex
      wi wi vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi
      vw cv vv cv wcel vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex wi vw cv
      vy cv wcel vw cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vx vy vw cv
      vv cv cB cuni cB vx cv vw cv wceq vx cv vy cv wcel vw cv vy cv wcel vx cv
      vz cv wcel vz cv vy cv wss wa vz cC wrex vw cv vz cv wcel vz cv vy cv wss
      wa vz cC wrex vx vw vy elequ1 vx cv vw cv wceq vx cv vz cv wcel vz cv vy
      cv wss wa vw cv vz cv wcel vz cv vy cv wss wa vz cC vx cv vw cv wceq vx
      cv vz cv wcel vw cv vz cv wcel vz cv vy cv wss vx vw vz elequ1 anbi1d
      rexbidv imbi12d vy cv vv cv wceq vw cv vy cv wcel vw cv vv cv wcel vw cv
      vz cv wcel vz cv vy cv wss wa vz cC wrex vw cv vz cv wcel vz cv vv cv wss
      wa vz cC wrex vy vv vw elequ2 vy cv vv cv wceq vw cv vz cv wcel vz cv vy
      cv wss wa vw cv vz cv wcel vz cv vv cv wss wa vz cC vy cv vv cv wceq vz
      cv vy cv wss vz cv vv cv wss vw cv vz cv wcel vy cv vv cv vz cv sseq2
      anbi2d rexbidv imbi12d rcla42v ex com4l imp32 adantrrr mpd an1s vw cv vv
      cv wcel vv cv vu cv wss wa vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex
      vw cv vz cv wcel vz cv vu cv wss wa vz cC wrex wi vx cv vy cv wcel vx cv
      vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vv
      cv cB wcel vv cv vu cv wss vw cv vz cv wcel vz cv vv cv wss wa vz cC wrex
      vw cv vz cv wcel vz cv vu cv wss wa vz cC wrex wi vw cv vv cv wcel vv cv
      vu cv wss vw cv vz cv wcel vz cv vv cv wss wa vw cv vz cv wcel vz cv vu
      cv wss wa vz cC vv cv vu cv wss vz cv vv cv wss vz cv vu cv wss vw cv vz
      cv wcel vz cv vv cv wss vv cv vu cv wss vz cv vu cv wss vz cv vv cv vu cv
      sstr2 com12 anim2d r19.22sdv adantl ad2antll mpd exp32 r19.23adv cB ctb
      wcel vu cv cB ctg cfv wcel vw cv vu cv wcel vw cv vv cv wcel vv cv vu cv
      wss wa vv cB wrex vv vu cv cB vw cv tg2 3expa syl5 exp4c com12 imp42
      r19.21aiva adantll jca syl5bir exp4c 3imp 3comr expdimp ssrdv ex impbid
      $.
      $( [27-Jul-2006] $) $( [20-Jul-2006] $)

    $( A criterion for determining whether one topology is finer than
       another.  Lemma 2.2 of [Munkres] p. 80 using abbreviations. $)
    tgss3 $p |- ( ( B e. Bases /\ C e. Bases /\ U. B = U. C ) ->
                    ( ( topGen ` B ) C_ ( topGen ` C ) <->
                  A. x e. B ( U. B i^i x ) C_ U. ( C i^i ~P x ) ) ) $=
      cB ctb wcel cC ctb wcel cB cuni cC cuni wceq w3a cB ctg cfv cC ctg cfv
      wss vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi vx
      cB wral vy cB cuni wral cB cuni vx cv cin cC vx cv cpw cin cuni wss vx cB
      wral vy vx vz cB cC tgss2 vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv
      wss wa vz cC wrex wi vx cB wral vy cB cuni wral vy cv vx cv wcel vy cv vz
      cv wcel vz cv vx cv wss wa vz cC wrex wi vy cB cuni wral vx cB wral cB
      cuni vx cv cin cC vx cv cpw cin cuni wss vx cB wral vy cv vx cv wcel vy
      cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi vy vx cB cuni cB ralcom vy
      cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi vy cB
      cuni wral cB cuni vx cv cin cC vx cv cpw cin cuni wss vx cB vy cv cB cuni
      vx cv cin wcel vy cv cC vx cv cpw cin cuni wcel wi vy wal vy cv cB cuni
      wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi
      wi vy wal cB cuni vx cv cin cC vx cv cpw cin cuni wss vy cv vx cv wcel vy
      cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi vy cB cuni wral vy cv cB
      cuni vx cv cin wcel vy cv cC vx cv cpw cin cuni wcel wi vy cv cB cuni
      wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi
      wi vy vy cv cB cuni vx cv cin wcel vy cv cC vx cv cpw cin cuni wcel wi vy
      cv cB cuni wcel vy cv vx cv wcel wa vy cv vz cv wcel vz cv vx cv wss wa
      vz cC wrex wi vy cv cB cuni wcel vy cv vx cv wcel vy cv vz cv wcel vz cv
      vx cv wss wa vz cC wrex wi wi vy cv cB cuni vx cv cin wcel vy cv cB cuni
      wcel vy cv vx cv wcel wa vy cv cC vx cv cpw cin cuni wcel vy cv vz cv
      wcel vz cv vx cv wss wa vz cC wrex vy cv cB cuni vx cv elin vz cv cC wcel
      vy cv vz cv wcel vz cv vx cv wss wa wa vz wex vy cv vz cv wcel vz cv cC
      vx cv cpw cin wcel wa vz wex vy cv vz cv wcel vz cv vx cv wss wa vz cC
      wrex vy cv cC vx cv cpw cin cuni wcel vz cv cC wcel vy cv vz cv wcel vz
      cv vx cv wss wa wa vy cv vz cv wcel vz cv cC vx cv cpw cin wcel wa vz vz
      cv cC wcel vz cv vx cv cpw wcel wa vy cv vz cv wcel wa vz cv cC wcel vz
      cv vx cv cpw wcel vy cv vz cv wcel wa wa vy cv vz cv wcel vz cv cC vx cv
      cpw cin wcel wa vz cv cC wcel vy cv vz cv wcel vz cv vx cv wss wa wa vz
      cv cC wcel vz cv vx cv cpw wcel vy cv vz cv wcel anass vz cv cC wcel vz
      cv vx cv cpw wcel wa vy cv vz cv wcel wa vz cv cC vx cv cpw cin wcel vy
      cv vz cv wcel wa vy cv vz cv wcel vz cv cC vx cv cpw cin wcel wa vz cv cC
      vx cv cpw cin wcel vz cv cC wcel vz cv vx cv cpw wcel wa vy cv vz cv wcel
      vz cv cC vx cv cpw elin anbi1i vz cv cC vx cv cpw cin wcel vy cv vz cv
      wcel ancom bitr3i vz cv vx cv cpw wcel vy cv vz cv wcel wa vy cv vz cv
      wcel vz cv vx cv wss wa vz cv cC wcel vz cv vx cv cpw wcel vy cv vz cv
      wcel wa vy cv vz cv wcel vz cv vx cv cpw wcel wa vy cv vz cv wcel vz cv
      vx cv wss wa vz cv vx cv cpw wcel vy cv vz cv wcel ancom vz cv vx cv cpw
      wcel vz cv vx cv wss vy cv vz cv wcel vz cv vx cv vz visset elpw anbi2i
      bitri anbi2i 3bitr3ri exbii vy cv vz cv wcel vz cv vx cv wss wa vz cC
      df-rex vz vy cv cC vx cv cpw cin eluni 3bitr4ri imbi12i vy cv cB cuni
      wcel vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cC wrex
      impexp bitri albii vy cB cuni vx cv cin cC vx cv cpw cin cuni dfss2 vy cv
      vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cC wrex wi vy cB cuni
      df-ral 3bitr4ri ralbii bitri syl6bb $.
      $( [3-Apr-2008] $) $( [20-Jul-2006] $)

    $( Given a topology ` J ` , show that a subset ` B ` satisfying the
       third antecedent is a basis for it.  Lemma 2.3 of [Munkres] p. 81. $)
    basgen2 $p |- ( ( J e. Top /\ B C_ J /\ A. x e. J A. y e. x E. z e. B
            ( y e. z /\ z C_ x ) ) -> ( B e. Bases /\ ( topGen ` B ) = J ) ) $=
      cJ ctop wcel cB cJ wss vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy
      vx cv wral vx cJ wral cB ctb wcel cB ctg cfv cJ wceq wa cJ ctop wcel cB
      cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx
      cJ wral wa cB ctb wcel cB ctg cfv cJ wceq cJ ctop wcel cB cJ wss wa vy cv
      vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral cB ctb
      wcel cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB
      wrex vy vx cv wral vx cJ wral vy cv vz cv wcel vz cv vw cv vv cv cin wss
      wa vz cB wrex vy vw cv vv cv cin wral vv cB wral vw cB wral cB ctb wcel
      cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex
      vy vx cv wral vx cJ wral vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz
      cB wrex vy vw cv vv cv cin wral vw vv cB cB cJ ctop wcel cB cJ wss wa vw
      cv cB wcel vv cv cB wcel wa wa vw cv vv cv cin cJ wcel vy cv vz cv wcel
      vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral vy cv vz cv wcel
      vz cv vw cv vv cv cin wss wa vz cB wrex vy vw cv vv cv cin wral wi cJ
      ctop wcel cB cJ wss vw cv cB wcel vv cv cB wcel wa vw cv vv cv cin cJ
      wcel cJ ctop wcel vw cv cJ wcel vv cv cJ wcel wa vw cv vv cv cin cJ wcel
      cB cJ wss vw cv cB wcel vv cv cB wcel wa wa cJ ctop wcel vw cv cJ wcel vv
      cv cJ wcel vw cv vv cv cin cJ wcel vw cv vv cv cJ inopn 3expb cB cJ wss
      vw cv cB wcel vv cv cB wcel wa vw cv cJ wcel vv cv cJ wcel wa cB cJ wss
      vw cv cB wcel vw cv cJ wcel vv cv cB wcel vv cv cJ wcel cB cJ vw cv ssel
      cB cJ vv cv ssel anim12d imp sylan2 anassrs vy cv vz cv wcel vz cv vx cv
      wss wa vz cB wrex vy vx cv wral vy cv vz cv wcel vz cv vw cv vv cv cin
      wss wa vz cB wrex vy vw cv vv cv cin wral vx vw cv vv cv cin cJ vy cv vz
      cv wcel vz cv vx cv wss wa vz cB wrex vy cv vz cv wcel vz cv vw cv vv cv
      cin wss wa vz cB wrex vy vx cv vw cv vv cv cin vx cv vw cv vv cv cin wceq
      vy cv vz cv wcel vz cv vx cv wss wa vy cv vz cv wcel vz cv vw cv vv cv
      cin wss wa vz cB vx cv vw cv vv cv cin wceq vz cv vx cv wss vz cv vw cv
      vv cv cin wss vy cv vz cv wcel vx cv vw cv vv cv cin vz cv sseq2 anbi2d
      rexbidv raleqd rcla4v syl r19.21advva cJ ctop wcel cB cJ wss wa cB cvv
      wcel cB ctb wcel vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz cB wrex
      vy vw cv vv cv cin wral vv cB wral vw cB wral wb cB cJ wss cJ ctop wcel
      cB cvv wcel cB cJ ctop ssexg ancoms vw vv vy vz cB cvv isbasis2g syl
      sylibrd imp cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa
      vz cB wrex vy vx cv wral vx cJ wral wa cB ctg cfv cJ cJ ctop wcel cB cJ
      wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ
      wral cB ctb wcel cB ctg cfv cJ wss cJ ctop wcel cB cJ wss wa vy cv vz cv
      wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral cB ctb wcel
      cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex
      vy vx cv wral vx cJ wral vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz
      cB wrex vy vw cv vv cv cin wral vv cB wral vw cB wral cB ctb wcel cJ ctop
      wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv
      wral vx cJ wral vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz cB wrex
      vy vw cv vv cv cin wral vw vv cB cB cJ ctop wcel cB cJ wss wa vw cv cB
      wcel vv cv cB wcel wa wa vw cv vv cv cin cJ wcel vy cv vz cv wcel vz cv
      vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral vy cv vz cv wcel vz cv
      vw cv vv cv cin wss wa vz cB wrex vy vw cv vv cv cin wral wi cJ ctop wcel
      cB cJ wss vw cv cB wcel vv cv cB wcel wa vw cv vv cv cin cJ wcel cJ ctop
      wcel vw cv cJ wcel vv cv cJ wcel wa vw cv vv cv cin cJ wcel cB cJ wss vw
      cv cB wcel vv cv cB wcel wa wa cJ ctop wcel vw cv cJ wcel vv cv cJ wcel
      vw cv vv cv cin cJ wcel vw cv vv cv cJ inopn 3expb cB cJ wss vw cv cB
      wcel vv cv cB wcel wa vw cv cJ wcel vv cv cJ wcel wa cB cJ wss vw cv cB
      wcel vw cv cJ wcel vv cv cB wcel vv cv cJ wcel cB cJ vw cv ssel cB cJ vv
      cv ssel anim12d imp sylan2 anassrs vy cv vz cv wcel vz cv vx cv wss wa vz
      cB wrex vy vx cv wral vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz cB
      wrex vy vw cv vv cv cin wral vx vw cv vv cv cin cJ vy cv vz cv wcel vz cv
      vx cv wss wa vz cB wrex vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz
      cB wrex vy vx cv vw cv vv cv cin vx cv vw cv vv cv cin wceq vy cv vz cv
      wcel vz cv vx cv wss wa vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz
      cB vx cv vw cv vv cv cin wceq vz cv vx cv wss vz cv vw cv vv cv cin wss
      vy cv vz cv wcel vx cv vw cv vv cv cin vz cv sseq2 anbi2d rexbidv raleqd
      rcla4v syl r19.21advva cJ ctop wcel cB cJ wss wa cB cvv wcel cB ctb wcel
      vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz cB wrex vy vw cv vv cv
      cin wral vv cB wral vw cB wral wb cB cJ wss cJ ctop wcel cB cvv wcel cB
      cJ ctop ssexg ancoms vw vv vy vz cB cvv isbasis2g syl sylibrd imp cJ ctop
      wcel cB cJ wss wa cB ctb wcel wa vx cB ctg cfv cJ cJ ctop wcel cB cJ wss
      wa cB ctb wcel wa vx cv cB ctg cfv wcel vy cv cB wss vx cv vy cv cuni
      wceq wa vy wex vx cv cJ wcel cB ctb wcel vx cv cB ctg cfv wcel vy cv cB
      wss vx cv vy cv cuni wceq wa vy wex wb cJ ctop wcel cB cJ wss wa vy vx cv
      cB eltg3 adantl cJ ctop wcel cB cJ wss wa vy cv cB wss vx cv vy cv cuni
      wceq wa vy wex vx cv cJ wcel wi cB ctb wcel cJ ctop wcel cB cJ wss wa vy
      cv cB wss vx cv vy cv cuni wceq wa vx cv cJ wcel vy cJ ctop wcel cB cJ
      wss vy cv cB wss vx cv vy cv cuni wceq vx cv cJ wcel cJ ctop wcel vy cv
      cB wss cB cJ wss vx cv vy cv cuni wceq vx cv cJ wcel wi cJ ctop wcel vy
      cv cB wss cB cJ wss vx cv vy cv cuni wceq vx cv cJ wcel cJ ctop wcel vy
      cv cB wss cB cJ wss wa wa vx cv vy cv cuni wceq wa vx cv vy cv cuni cJ cJ
      ctop wcel vy cv cB wss cB cJ wss wa wa vx cv vy cv cuni wceq pm3.27 cJ
      ctop wcel vy cv cB wss cB cJ wss wa wa vy cv cuni cJ wcel vx cv vy cv
      cuni wceq cJ ctop wcel vy cv cJ wss vy cv cuni cJ wcel vy cv cB wss cB cJ
      wss wa vy cv cJ uniopn vy cv cB cJ sstr sylan2 adantr eqeltrd exp42 com23
      imp4b 19.23adv adantr sylbid ssrdv syldan cJ ctop wcel cB cJ wss wa vy cv
      vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral wa cJ
      cJ ctg cfv cB ctg cfv cJ ctop wcel cJ ctg cfv cJ wceq cB cJ wss vy cv vz
      cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral cJ tgtop
      ad2antrr cJ ctb wcel cB ctb wcel wa cJ cuni cB cuni wceq wa vy cv vx cv
      wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex wi vx cJ wral vy cJ
      cuni wral cJ ctg cfv cB ctg cfv wss cJ ctop wcel cB cJ wss wa vy cv vz cv
      wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral wa cJ ctb
      wcel cB ctb wcel wa cJ cuni cB cuni wceq wa cJ ctg cfv cB ctg cfv wss vy
      cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex wi vx cJ
      wral vy cJ cuni wral cJ ctb wcel cB ctb wcel cJ cuni cB cuni wceq cJ ctg
      cfv cB ctg cfv wss vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa
      vz cB wrex wi vx cJ wral vy cJ cuni wral wb vy vx vz cJ cB tgss2 3expa
      biimpar cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz
      cB wrex vy vx cv wral vx cJ wral wa cJ ctb wcel cB ctb wcel cJ cuni cB
      cuni wceq cJ ctop wcel cJ ctb wcel cB cJ wss vy cv vz cv wcel vz cv vx cv
      wss wa vz cB wrex vy vx cv wral vx cJ wral cJ topbas ad2antrr cJ ctop
      wcel cB cJ wss wa vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv
      wral vx cJ wral cB ctb wcel cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz
      cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral vy cv vz cv wcel vz
      cv vw cv vv cv cin wss wa vz cB wrex vy vw cv vv cv cin wral vv cB wral
      vw cB wral cB ctb wcel cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv
      vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral vy cv vz cv wcel vz cv
      vw cv vv cv cin wss wa vz cB wrex vy vw cv vv cv cin wral vw vv cB cB cJ
      ctop wcel cB cJ wss wa vw cv cB wcel vv cv cB wcel wa wa vw cv vv cv cin
      cJ wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx
      cJ wral vy cv vz cv wcel vz cv vw cv vv cv cin wss wa vz cB wrex vy vw cv
      vv cv cin wral wi cJ ctop wcel cB cJ wss vw cv cB wcel vv cv cB wcel wa
      vw cv vv cv cin cJ wcel cJ ctop wcel vw cv cJ wcel vv cv cJ wcel wa vw cv
      vv cv cin cJ wcel cB cJ wss vw cv cB wcel vv cv cB wcel wa wa cJ ctop
      wcel vw cv cJ wcel vv cv cJ wcel vw cv vv cv cin cJ wcel vw cv vv cv cJ
      inopn 3expb cB cJ wss vw cv cB wcel vv cv cB wcel wa vw cv cJ wcel vv cv
      cJ wcel wa cB cJ wss vw cv cB wcel vw cv cJ wcel vv cv cB wcel vv cv cJ
      wcel cB cJ vw cv ssel cB cJ vv cv ssel anim12d imp sylan2 anassrs vy cv
      vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vy cv vz cv wcel
      vz cv vw cv vv cv cin wss wa vz cB wrex vy vw cv vv cv cin wral vx vw cv
      vv cv cin cJ vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy cv vz cv
      wcel vz cv vw cv vv cv cin wss wa vz cB wrex vy vx cv vw cv vv cv cin vx
      cv vw cv vv cv cin wceq vy cv vz cv wcel vz cv vx cv wss wa vy cv vz cv
      wcel vz cv vw cv vv cv cin wss wa vz cB vx cv vw cv vv cv cin wceq vz cv
      vx cv wss vz cv vw cv vv cv cin wss vy cv vz cv wcel vx cv vw cv vv cv
      cin vz cv sseq2 anbi2d rexbidv raleqd rcla4v syl r19.21advva cJ ctop wcel
      cB cJ wss wa cB cvv wcel cB ctb wcel vy cv vz cv wcel vz cv vw cv vv cv
      cin wss wa vz cB wrex vy vw cv vv cv cin wral vv cB wral vw cB wral wb cB
      cJ wss cJ ctop wcel cB cvv wcel cB cJ ctop ssexg ancoms vw vv vy vz cB
      cvv isbasis2g syl sylibrd imp cJ ctop wcel cB cJ wss wa vy cv vz cv wcel
      vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral wa cJ cuni cB cuni
      cJ ctop wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral
      vx cJ wral cJ cuni cB cuni wss cB cJ wss cJ ctop wcel vy cv vz cv wcel vz
      cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral wa vw cJ cuni cB cuni
      cJ ctop wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral
      vx cJ wral vw cv cJ cuni wcel vw cv cB cuni wcel wi cJ ctop wcel cJ cuni
      cJ wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx
      cJ wral vw cv cJ cuni wcel vw cv cB cuni wcel wi wi cJ cJ cuni cJ cuni
      eqid topopn cJ cuni cJ wcel vy cv vz cv wcel vz cB wrex vy vx cv wral vx
      cJ wral vw cv cJ cuni wcel vw cv cB cuni wcel wi vy cv vz cv wcel vz cv
      vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral cJ cuni cJ wcel vy cv vz
      cv wcel vz cB wrex vy vx cv wral vx cJ wral vy cv vz cv wcel vz cB wrex
      vy cJ cuni wral vw cv cJ cuni wcel vw cv cB cuni wcel wi vy cv vz cv wcel
      vz cB wrex vy vx cv wral vy cv vz cv wcel vz cB wrex vy cJ cuni wral vx
      cJ cuni cJ vy cv vz cv wcel vz cB wrex vy vx cv cJ cuni raleq1 rcla4v vy
      cv vz cv wcel vz cB wrex vy cJ cuni wral vw cv cJ cuni wcel vw cv vz cv
      wcel vz cB wrex vw cv cB cuni wcel vy cv vz cv wcel vz cB wrex vw cv vz
      cv wcel vz cB wrex vy vw cv cJ cuni vy cv vw cv wceq vy cv vz cv wcel vw
      cv vz cv wcel vz cB vy vw vz elequ1 rexbidv rcla4cv vz vw cv cB eluni2
      syl6ibr syl6 vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral
      vy cv vz cv wcel vz cB wrex vy vx cv wral vx cJ vy cv vz cv wcel vz cv vx
      cv wss wa vz cB wrex vy cv vz cv wcel vz cB wrex vy vx cv vy cv vz cv
      wcel vz cv vx cv wss wa vy cv vz cv wcel vz cB vy cv vz cv wcel vz cv vx
      cv wss pm3.26 r19.22si r19.20si r19.20si syl5 syl imp ssrdv adantlr cB cJ
      wss cB cuni cJ cuni wss cJ ctop wcel vy cv vz cv wcel vz cv vx cv wss wa
      vz cB wrex vy vx cv wral vx cJ wral cB cJ uniss ad2antlr eqssd jca31 vy
      cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cJ wral vy
      cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex wi vx cJ
      wral vy cJ cuni wral cJ ctop wcel cB cJ wss wa vy cv vz cv wcel vz cv vx
      cv wss wa vz cB wrex vy vx cv wral vx cJ wral vy cv vx cv wcel vy cv vz
      cv wcel vz cv vx cv wss wa vz cB wrex wi vy cJ cuni wral vx cJ wral vy cv
      vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex wi vx cJ wral
      vy cJ cuni wral vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv
      wral vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex wi
      vy cJ cuni wral vx cJ vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy
      cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex wi vy vx cv
      cJ cuni vy cv vx cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex
      wi vy cv cJ cuni wcel ax-1 r19.20i2 r19.20si vy cv vx cv wcel vy cv vz cv
      wcel vz cv vx cv wss wa vz cB wrex wi vx vy cJ cJ cuni ralcom sylib
      adantl sylanc eqsstr3d eqssd jca 3impa $.
      $( [27-Jul-2006] $) $( [20-Jul-2006] $)

    $( Given a topology ` J ` , show that a subset ` B ` satisfying the
       third antecedent is a basis for it.  Lemma 2.3 of [Munkres] p. 81 using
       abbreviations. $)
    basgen $p |- ( ( J e. Top /\ B C_ J /\ A. x e. J
          x C_ U. ( B i^i ~P x ) ) -> ( B e. Bases /\ ( topGen ` B ) = J ) ) $=
      cJ ctop wcel cB cJ wss vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy
      vx cv wral vx cJ wral cB ctb wcel cB ctg cfv cJ wceq wa vx cv cB vx cv
      cpw cin cuni wss vx cJ wral vx vy vz cB cJ basgen2 vx cv cB vx cv cpw cin
      cuni wss vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx
      cJ vx cv cB vx cv cpw cin cuni wss vy cv cB vx cv cpw cin cuni wcel vy vx
      cv wral vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vy
      vx cv cB vx cv cpw cin cuni dfss3 vy cv cB vx cv cpw cin cuni wcel vy cv
      vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv vy cv vz cv wcel vz cv
      cB vx cv cpw cin wcel wa vz wex vz cv cB wcel vy cv vz cv wcel vz cv vx
      cv wss wa wa vz wex vy cv cB vx cv cpw cin cuni wcel vy cv vz cv wcel vz
      cv vx cv wss wa vz cB wrex vy cv vz cv wcel vz cv cB vx cv cpw cin wcel
      wa vz cv cB wcel vy cv vz cv wcel vz cv vx cv wss wa wa vz vy cv vz cv
      wcel vz cv cB vx cv cpw cin wcel wa vy cv vz cv wcel vz cv cB wcel vz cv
      vx cv wss wa wa vz cv cB wcel vy cv vz cv wcel vz cv vx cv wss wa wa vz
      cv cB vx cv cpw cin wcel vz cv cB wcel vz cv vx cv wss wa vy cv vz cv
      wcel vz cv cB vx cv cpw cin wcel vz cv cB wcel vz cv vx cv cpw wcel wa vz
      cv cB wcel vz cv vx cv wss wa vz cv cB vx cv cpw elin vz cv vx cv cpw
      wcel vz cv vx cv wss vz cv cB wcel vz cv vx cv vz visset elpw anbi2i
      bitri anbi2i vy cv vz cv wcel vz cv cB wcel vz cv vx cv wss an12 bitri
      exbii vz vy cv cB vx cv cpw cin eluni vy cv vz cv wcel vz cv vx cv wss wa
      vz cB df-rex 3bitr4i ralbii bitri ralbii syl3an3b $.
      $( [16-Apr-2008] $) $( [22-Jul-2006] $)

    $( Conditions that determine the equality of two generated topologies. $)
    2basgen $p |- ( ( ( B e. Bases /\ C e. Bases ) /\ ( B C_ C /\ C C_
                  ( topGen ` B ) ) ) -> ( topGen ` B ) = ( topGen ` C ) ) $=
      cB ctb wcel cC ctb wcel wa cB cC wss cC cB ctg cfv wss wa wa cB ctg cfv
      cC ctg cfv cB ctb wcel cC ctb wcel wa cB cC wss cB ctg cfv cC ctg cfv wss
      cC cB ctg cfv wss cB ctb wcel cC ctb wcel cB cC wss cB ctg cfv cC ctg cfv
      wss cB cC tgss 3expa adantrr cB ctb wcel cC ctb wcel wa cB cC wss cC cB
      ctg cfv wss wa wa cC ctg cfv cB ctg cfv ctg cfv cB ctg cfv cB ctb wcel cC
      ctb wcel wa cC cB ctg cfv wss cC ctg cfv cB ctg cfv ctg cfv wss cB cC wss
      cB ctb wcel cC ctb wcel cC cB ctg cfv wss cC ctg cfv cB ctg cfv ctg cfv
      wss cC ctb wcel cB ctb wcel cC cB ctg cfv wss cC ctg cfv cB ctg cfv ctg
      cfv wss cC ctb wcel cB ctg cfv ctb wcel cC cB ctg cfv wss cC ctg cfv cB
      ctg cfv ctg cfv wss cB ctb wcel cC cB ctg cfv tgss cB ctb wcel cB ctg cfv
      ctop wcel cB ctg cfv ctb wcel cB tgcl cB ctg cfv topbas syl syl3an2
      3com12 3expa adantrl cB ctb wcel cB ctg cfv ctg cfv cB ctg cfv wceq cC
      ctb wcel cB cC wss cC cB ctg cfv wss wa cB tgidm ad2antrr sseqtrd eqssd
      $.
      $( [11-May-2007] $) $( [8-May-2007] $)
  $}

  ${
    $d u v w x y z B $.  $d v w x y z J $.
    $( A subset of a topology is a basis for the topology iff every member of
       the topology is a union of members of the basis.  We use the idiom
       " ` B e. Bases /\ ( topGen `` B ) = J ` " to express " ` B ` is a basis
       for topology ` J ` ," since we do not have a separate notation for this.
       Definition 15.35 of [Schechter] p. 428. $)
    bastop1 $p |- ( ( J e. Top /\ B C_ J ) -> ( ( B e. Bases /\
      ( topGen ` B ) = J ) <-> A. x e. J E. y ( y C_ B /\ x = U. y ) ) ) $=
      cJ ctop wcel cB cJ wss wa cB ctb wcel cB ctg cfv cJ wceq wa vy cv cB wss
      vx cv vy cv cuni wceq wa vy wex vx cJ wral cB ctb wcel cB ctg cfv cJ wceq
      wa vy cv cB wss vx cv vy cv cuni wceq wa vy wex vx cJ cB ctb wcel cB ctg
      cfv cJ wceq wa vx cv cJ wcel vy cv cB wss vx cv vy cv cuni wceq wa vy wex
      cB ctg cfv cJ wceq vx cv cJ wcel vx cv cB ctg cfv wcel cB ctb wcel vy cv
      cB wss vx cv vy cv cuni wceq wa vy wex cB ctg cfv cJ wceq vx cv cB ctg
      cfv wcel vx cv cJ wcel cB ctg cfv cJ vx cv eleq2 bicomd vy vx cv cB eltg3
      sylan9bbr biimpd r19.21aiv cJ ctop wcel cB cJ wss wa vz cv vw cv wcel vw
      cv vx cv wss wa vw cB wrex vz vx cv wral vx cJ wral cB ctb wcel cB ctg
      cfv cJ wceq wa vy cv cB wss vx cv vy cv cuni wceq wa vy wex vx cJ wral cJ
      ctop wcel cB cJ wss vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex vz vx
      cv wral vx cJ wral cB ctb wcel cB ctg cfv cJ wceq wa vx vz vw cB cJ
      basgen2 3expia vy cv cB wss vx cv vy cv cuni wceq wa vy wex vz cv vw cv
      wcel vw cv vx cv wss wa vw cB wrex vz vx cv wral vx cJ vy cv cB wss vx cv
      vy cv cuni wceq wa vy wex vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex
      vz vx cv vy cv cB wss vx cv vy cv cuni wceq wa vz cv vx cv wcel vz cv vw
      cv wcel vw cv vx cv wss wa vw cB wrex wi vy vx cv vy cv cuni wceq vz cv
      vx cv wcel vz cv vw cv wcel vw cv vx cv wss wa vw vy cv wrex vy cv cB wss
      vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex vx cv vy cv cuni wceq vz
      cv vx cv wcel vz cv vy cv cuni wcel vz cv vw cv wcel vw cv vx cv wss wa
      vw vy cv wrex vx cv vy cv cuni vz cv eleq2 vx cv vy cv cuni wceq vz cv vw
      cv wcel vw vy cv wrex vz cv vw cv wcel vw cv vx cv wss wa vw vy cv wrex
      vz cv vy cv cuni wcel vx cv vy cv cuni wceq vz cv vw cv wcel vz cv vw cv
      wcel vw cv vx cv wss wa vw vy cv vx cv vy cv cuni wceq vw cv vy cv wcel
      wa vz cv vw cv wcel vw cv vx cv wss vx cv vy cv cuni wceq vw cv vy cv
      wcel wa vw cv vx cv wss vz cv vw cv wcel vx cv vy cv cuni wceq vw cv vy
      cv cuni wss vw cv vx cv wss vw cv vy cv wcel vx cv vy cv cuni wceq vw cv
      vx cv wss vw cv vy cv cuni wss vx cv vy cv cuni vw cv sseq2 biimpar vw cv
      vy cv elssuni sylan2 a1d ancld r19.22dva vw vz cv vy cv eluni2 syl5ib
      sylbid vz cv vw cv wcel vw cv vx cv wss wa vw vy cv cB ssrexv sylan9r
      19.23aiv r19.21aiv r19.20si syl5 impbid2 $.
      $( [3-Feb-2008] $) $( [2-Feb-2008] $)

    $( A version of ~ bastop1 that doesn't have ` B C_ J ` in the
       antecedent. $)
    bastop2 $p |- ( J e. Top -> ( ( B e. Bases /\ ( topGen ` B ) = J ) <->
           ( B C_ J /\ A. x e. J E. y ( y C_ B /\ x = U. y ) ) ) ) $=
      cJ ctop wcel cB cJ wss cB ctb wcel cB ctg cfv cJ wceq wa wa cB cJ wss vy
      cv cB wss vx cv vy cv cuni wceq wa vy wex vx cJ wral wa cB ctb wcel cB
      ctg cfv cJ wceq wa cJ ctop wcel cB cJ wss cB ctb wcel cB ctg cfv cJ wceq
      wa vy cv cB wss vx cv vy cv cuni wceq wa vy wex vx cJ wral vx vy cB cJ
      bastop1 pm5.32da cB ctb wcel cB ctg cfv cJ wceq wa cB cJ wss cB ctb wcel
      cB ctg cfv cJ wceq wa cB cB ctg cfv cJ cB ctb wcel cB cB ctg cfv wss cB
      ctg cfv cJ wceq cB bastg adantr cB ctb wcel cB ctg cfv cJ wceq pm3.27
      sseqtrd pm4.71ri syl5bb $.
      $( [17-Apr-2008] $) $( [3-Feb-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Subbases for topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g x y v w A $.  $d f g t u v w B $.
    subbas.1 $e |- A e. _V $.
    subbas.2 $e |- B = { x | E. y ( y C_ A /\ y e. Fin /\ x = |^| y ) } $.
    $( The collection of finite intersections of the elements of any set
       ` A ` is a basis for a topology (on ` U. A ` by ~ subbas2 ).  The set
       ` A ` is called a subbasis for that topology.  Theorem for subbases in
       [Munkres] p. 82.  See ~ abfii1 through ~ abfii5 for other ways to
       express the collection of finite intersections. $)
    subbas $p |- B e. Bases $=
      cB ctb wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss wa vt cB wrex vu
      vw cv vv cv cin wral vv cB wral vw cB wral vu cv vt cv wcel vt cv vw cv
      vv cv cin wss wa vt cB wrex vu vw cv vv cv cin wral vw vv cB vw cv cB
      wcel vv cv cB wcel wa vu cv vt cv wcel vt cv vw cv vv cv cin wss wa vt cB
      wrex vu vw cv vv cv cin vf cv cA wss vf cv cfn wcel vw cv vf cv cint wceq
      w3a vf wex vg cv cA wss vg cv cfn wcel vv cv vg cv cint wceq w3a vg wex
      vu cv vw cv vv cv cin wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss wa
      vt cB wrex wi vw cv cB wcel vv cv cB wcel vf cv cA wss vf cv cfn wcel vw
      cv vf cv cint wceq w3a vf wex vg cv cA wss vg cv cfn wcel vv cv vg cv
      cint wceq w3a vg wex wa vf cv cA wss vf cv cfn wcel vw cv vf cv cint wceq
      w3a vg cv cA wss vg cv cfn wcel vv cv vg cv cint wceq w3a wa vg wex vf
      wex vu cv vw cv vv cv cin wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss
      wa vt cB wrex wi vf cv cA wss vf cv cfn wcel vw cv vf cv cint wceq w3a vg
      cv cA wss vg cv cfn wcel vv cv vg cv cint wceq w3a vf vg eeanv vf cv cA
      wss vf cv cfn wcel vw cv vf cv cint wceq w3a vg cv cA wss vg cv cfn wcel
      vv cv vg cv cint wceq w3a wa vu cv vw cv vv cv cin wcel vu cv vt cv wcel
      vt cv vw cv vv cv cin wss wa vt cB wrex wi vf vg vf cv cA wss vf cv cfn
      wcel vw cv vf cv cint wceq w3a vg cv cA wss vg cv cfn wcel vv cv vg cv
      cint wceq w3a wa vf cv cA wss vg cv cA wss wa vf cv cfn wcel vg cv cfn
      wcel wa vw cv vf cv cint wceq vv cv vg cv cint wceq wa w3a vu cv vw cv vv
      cv cin wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss wa vt cB wrex wi
      vf cv cA wss vf cv cfn wcel vw cv vf cv cint wceq vg cv cA wss vg cv cfn
      wcel vv cv vg cv cint wceq an6 vf cv cA wss vg cv cA wss wa vf cv cfn
      wcel vg cv cfn wcel wa vw cv vf cv cint wceq vv cv vg cv cint wceq wa w3a
      vu cv vw cv vv cv cin wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss wa
      vt cB wrex vw cv vv cv cin cB wcel vu cv vw cv vv cv cin wcel vw cv vv cv
      cin vw cv vv cv cin wss wa vu cv vt cv wcel vt cv vw cv vv cv cin wss wa
      vt cB wrex vf cv cA wss vg cv cA wss wa vf cv cfn wcel vg cv cfn wcel wa
      vw cv vf cv cint wceq vv cv vg cv cint wceq wa w3a vu cv vw cv vv cv cin
      wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss wa vu cv vw cv vv cv cin
      wcel vw cv vv cv cin vw cv vv cv cin wss wa vt vw cv vv cv cin cB vt cv
      vw cv vv cv cin wceq vu cv vt cv wcel vu cv vw cv vv cv cin wcel vt cv vw
      cv vv cv cin wss vw cv vv cv cin vw cv vv cv cin wss vt cv vw cv vv cv
      cin vu cv eleq2 vt cv vw cv vv cv cin vw cv vv cv cin sseq1 anbi12d
      rcla4ev vf cv cA wss vg cv cA wss wa vf cv cfn wcel vg cv cfn wcel wa vw
      cv vf cv cint wceq vv cv vg cv cint wceq wa w3a vy cv cA wss vy cv cfn
      wcel vw cv vv cv cin vy cv cint wceq w3a vy wex vw cv vv cv cin cB wcel
      vf cv vg cv cun cA wss vf cv vg cv cun cfn wcel vw cv vv cv cin vf cv vg
      cv cun cint wceq vy cv cA wss vy cv cfn wcel vw cv vv cv cin vy cv cint
      wceq w3a vy wex vf cv cA wss vg cv cA wss wa vf cv cfn wcel vg cv cfn
      wcel wa vw cv vf cv cint wceq vv cv vg cv cint wceq wa vy cv cA wss vy cv
      cfn wcel vw cv vv cv cin vy cv cint wceq w3a vf cv vg cv cun cA wss vf cv
      vg cv cun cfn wcel vw cv vv cv cin vf cv vg cv cun cint wceq w3a vy vf cv
      vg cv cun vf cv vg cv vf visset vg visset unex vy cv vf cv vg cv cun wceq
      vy cv cA wss vf cv vg cv cun cA wss vy cv cfn wcel vf cv vg cv cun cfn
      wcel vw cv vv cv cin vy cv cint wceq vw cv vv cv cin vf cv vg cv cun cint
      wceq vy cv vf cv vg cv cun cA sseq1 vy cv vf cv vg cv cun cfn eleq1 vy cv
      vf cv vg cv cun wceq vy cv cint vf cv vg cv cun cint vw cv vv cv cin vy
      cv vf cv vg cv cun inteq eqeq2d 3anbi123d cla4ev vf cv cA wss vg cv cA
      wss wa vf cv vg cv cun cA wss vf cv vg cv cA unss biimpi vf cv vg cv unfi
      vw cv vf cv cint wceq vv cv vg cv cint wceq wa vw cv vv cv cin vf cv cint
      vg cv cint cin vf cv vg cv cun cint vw cv vf cv cint vv cv vg cv cint
      ineq12 vf cv vg cv intun syl6eqr syl3an vw cv vv cv cin cB wcel vw cv vv
      cv cin vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab wcel vy cv cA wss vy cv cfn wcel vw cv vv cv cin vy cv cint wceq w3a
      vy wex cB vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab vw cv vv cv cin subbas.2 eleq2i vy cv cA wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vy cv cA wss vy cv cfn wcel vw cv vv cv cin vy cv
      cint wceq w3a vy wex vx vw cv vv cv cin vw cv vv cv vw visset inex1 vx cv
      vw cv vv cv cin wceq vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy cv cA wss vy cv cfn wcel vw cv vv cv cin vy cv cint wceq w3a vy vx
      cv vw cv vv cv cin wceq vx cv vy cv cint wceq vw cv vv cv cin vy cv cint
      wceq vy cv cA wss vy cv cfn wcel vx cv vw cv vv cv cin vy cv cint eqeq1
      3anbi3d exbidv elab bitr2i sylib vu cv vw cv vv cv cin wcel vw cv vv cv
      cin vw cv vv cv cin wss vw cv vv cv cin ssid jctr syl2an ex sylbi
      19.23aivv sylbir vw cv cB wcel vw cv vy cv cA wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vx cab wcel vy cv cA wss vy cv cfn wcel vw cv vy
      cv cint wceq w3a vy wex vf cv cA wss vf cv cfn wcel vw cv vf cv cint wceq
      w3a vf wex cB vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy
      wex vx cab vw cv subbas.2 eleq2i vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vy cv cA wss vy cv cfn wcel vw cv vy cv cint wceq
      w3a vy wex vx vw cv vw visset vx cv vw cv wceq vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy cv cA wss vy cv cfn wcel vw cv vy cv
      cint wceq w3a vy vx cv vw cv wceq vx cv vy cv cint wceq vw cv vy cv cint
      wceq vy cv cA wss vy cv cfn wcel vx cv vw cv vy cv cint eqeq1 3anbi3d
      exbidv elab vy cv cA wss vy cv cfn wcel vw cv vy cv cint wceq w3a vf cv
      cA wss vf cv cfn wcel vw cv vf cv cint wceq w3a vy vf vy cv vf cv wceq vy
      cv cA wss vf cv cA wss vy cv cfn wcel vf cv cfn wcel vw cv vy cv cint
      wceq vw cv vf cv cint wceq vy cv vf cv cA sseq1 vy cv vf cv cfn eleq1 vy
      cv vf cv wceq vy cv cint vf cv cint vw cv vy cv vf cv inteq eqeq2d
      3anbi123d cbvexv 3bitri vv cv cB wcel vv cv vy cv cA wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cA wss vy cv cfn wcel
      vv cv vy cv cint wceq w3a vy wex vg cv cA wss vg cv cfn wcel vv cv vg cv
      cint wceq w3a vg wex cB vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx cab vv cv subbas.2 eleq2i vy cv cA wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vy cv cA wss vy cv cfn wcel vv cv vy cv cint
      wceq w3a vy wex vx vv cv vv visset vx cv vv cv wceq vy cv cA wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy cv cA wss vy cv cfn wcel vv cv vy
      cv cint wceq w3a vy vx cv vv cv wceq vx cv vy cv cint wceq vv cv vy cv
      cint wceq vy cv cA wss vy cv cfn wcel vx cv vv cv vy cv cint eqeq1
      3anbi3d exbidv elab vy cv cA wss vy cv cfn wcel vv cv vy cv cint wceq w3a
      vg cv cA wss vg cv cfn wcel vv cv vg cv cint wceq w3a vy vg vy cv vg cv
      wceq vy cv cA wss vg cv cA wss vy cv cfn wcel vg cv cfn wcel vv cv vy cv
      cint wceq vv cv vg cv cint wceq vy cv vg cv cA sseq1 vy cv vg cv cfn
      eleq1 vy cv vg cv wceq vy cv cint vg cv cint vv cv vy cv vg cv inteq
      eqeq2d 3anbi123d cbvexv 3bitri syl2anb r19.21aiv rgen2a cB cvv wcel cB
      ctb wcel vu cv vt cv wcel vt cv vw cv vv cv cin wss wa vt cB wrex vu vw
      cv vv cv cin wral vv cB wral vw cB wral wb cB vy cv cA wss vx cv vy cv
      cint wceq wa vy wex vx cab vx cv vy cv cint wceq vy vx cA subbas.1 vy cv
      cint csn vx cv vy cv cint wceq vx cab cvv vx vy cv cint df-sn vy cv cint
      snex eqeltrri abexssex cB vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab vy cv cA wss vx cv vy cv cint wceq wa vy wex vx
      cab subbas.2 vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vy cv cA wss vx cv vy cv cint wceq wa vy wex vx vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy cv cA wss vx cv vy cv cint wceq wa vy
      vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq 3simpb 19.22i ss2abi
      eqsstri ssexi vw vv vu vt cB cvv isbasis2g ax-mp mpbir $.
      $( [13-Mar-2009] $) $( [29-Jul-2006] $)
  $}

  ${
    $d w x y A $.
    subbas2.1 $e |- B =
           { x | E. y ( y C_ A /\ y e. Fin /\ x = |^| y ) } $.
    $( The collection of finite intersections of any set (subbasis) ` A ` is
       a basis for a topology on ` U. A ` .  Justifies the definition of
       subbasis in [Munkres] p. 82 (after using ~ unitg ). $)
    subbas2 $p |- U. B = U. A $=
      cB cuni vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab cuni cA cuni cB vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab subbas2.1 unieqi vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab cuni cA cuni vw vy cv cA wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab cuni cA cuni vw cv vy cv cA wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab cuni wcel vw cv vx
      cv wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex wa
      vx wex vw cv cA cuni wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx vw cv eluniab vw cv vx cv wcel vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex wa vw cv cA cuni wcel vx vw cv vx
      cv wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vw
      cv cA cuni wcel vw cv vx cv wcel vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vw cv cA cuni wcel vy vw cv vx cv wcel vx cv cA cuni wss vw
      cv cA cuni wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vx
      cv cA cuni wss vw cv vx cv wcel vw cv cA cuni wcel vx cv cA cuni vw cv
      ssel com12 vy cv cA wss vx cv vy cv cint wceq vx cv cA cuni wss vy cv cfn
      wcel vy cv cA wss vx cv vy cv cint wceq wa vx cv vy cv cint cA cuni vy cv
      cA wss vx cv vy cv cint wceq pm3.27 vy cv cA wss vy cv c0 wne vy cv cint
      cA cuni wss vx cv vy cv cint wceq vy cv cA intssuni2 vx cv vy cv cint
      wceq vy cv cint cvv wcel vy cv c0 wne vx cv vy cv cint wceq vx cv cvv
      wcel vy cv cint cvv wcel vx visset vx cv vy cv cint cvv eleq1 mpbii vy cv
      intex sylibr sylan2 eqsstrd 3adant2 syl5 19.23adv imp 19.23aiv sylbi
      ssriv cA vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab wss cA cuni vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy
      wex vx cab cuni wss vw cA vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab vw cv cA wcel vy cv cA wss vy cv cfn wcel vw cv vy
      cv cint wceq w3a vy wex vw cv vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel vw cv csn cA wss vw cv csn cfn wcel vw
      cv vw cv csn cint wceq vy cv cA wss vy cv cfn wcel vw cv vy cv cint wceq
      w3a vy wex vw cv cA wcel vy cv cA wss vy cv cfn wcel vw cv vy cv cint
      wceq w3a vw cv csn cA wss vw cv csn cfn wcel vw cv vw cv csn cint wceq
      w3a vy vw cv csn vw cv snex vy cv vw cv csn wceq vy cv cA wss vw cv csn
      cA wss vy cv cfn wcel vw cv csn cfn wcel vw cv vy cv cint wceq vw cv vw
      cv csn cint wceq vy cv vw cv csn cA sseq1 vy cv vw cv csn cfn eleq1 vy cv
      vw cv csn wceq vy cv cint vw cv csn cint vw cv vy cv vw cv csn inteq
      eqeq2d 3anbi123d cla4ev vw cv cA snssi vw cv csn cfn wcel vw cv cA wcel
      vw cv snfi a1i vw cv vw cv csn cint wceq vw cv cA wcel vw cv csn cint vw
      cv vw cv vw visset intsn eqcomi a1i syl3anc vy cv cA wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vy cv cA wss vy cv cfn wcel vw cv vy cv
      cint wceq w3a vy wex vx vw cv vw visset vx cv vw cv wceq vy cv cA wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy cv cA wss vy cv cfn wcel vw cv
      vy cv cint wceq w3a vy vx cv vw cv wceq vx cv vy cv cint wceq vw cv vy cv
      cint wceq vy cv cA wss vy cv cfn wcel vx cv vw cv vy cv cint eqeq1
      3anbi3d exbidv elab sylibr ssriv cA vy cv cA wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vx cab uniss ax-mp eqssi eqtri $.
      $( [2-Apr-2009] $) $( [30-Jul-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Examples of topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d x y z J $.  $d a b c d x y z Y $.
    $( A subspace topology is a topology.  Definition of subspace topology in
       [Munkres] p. 89.  ` Y ` is normally a subset of the base set of
       ` J ` .  (Contributed by FL, 15-Apr-2007.) $)
    subtop $p |- ( J e. Top -> { x | E. y e. J x = ( y i^i Y ) } e. Top ) $=
      cJ ctop wcel vx cv vy cv cY cin wceq vy cJ wrex vx cab ctop wcel va cv vx
      cv vy cv cY cin wceq vy cJ wrex vx cab wss va cv cuni vx cv vy cv cY cin
      wceq vy cJ wrex vx cab wcel wi va wal va cv vb cv cin vx cv vy cv cY cin
      wceq vy cJ wrex vx cab wcel vb vx cv vy cv cY cin wceq vy cJ wrex vx cab
      wral va vx cv vy cv cY cin wceq vy cJ wrex vx cab wral wa cJ ctop wcel va
      cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wss va cv cuni vx cv vy cv
      cY cin wceq vy cJ wrex vx cab wcel wi va wal va cv vb cv cin vx cv vy cv
      cY cin wceq vy cJ wrex vx cab wcel vb vx cv vy cv cY cin wceq vy cJ wrex
      vx cab wral va vx cv vy cv cY cin wceq vy cJ wrex vx cab wral cJ ctop
      wcel va cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wss va cv cuni vx cv
      vy cv cY cin wceq vy cJ wrex vx cab wcel wi va cJ ctop wcel va cv vx cv
      vy cv cY cin wceq vy cJ wrex vx cab wss va cv cuni vx cv vy cv cY cin
      wceq vy cJ wrex vx cab wcel cJ ctop wcel va cv vx cv vy cv cY cin wceq vy
      cJ wrex vx cab wss wa va cv cuni vy cv cY cin wceq vy cJ wrex va cv cuni
      vx cv vy cv cY cin wceq vy cJ wrex vx cab wcel cJ ctop wcel va cv vx cv
      vy cv cY cin wceq vy cJ wrex vx cab wss wa va cv cuni vy cv cY cin wceq
      vy cJ wrex vz cv cJ wss va cv cuni vz cv cuni cY cin wceq wa vz wex cJ
      ctop wcel va cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wss wa vz cv cJ
      wss va cv vx cv vy cv cY cin wceq vy vz cv wrex vx cab wceq wa vz wex vz
      cv cJ wss va cv cuni vz cv cuni cY cin wceq wa vz wex cJ ctop wcel va cv
      vx cv vy cv cY cin wceq vy cJ wrex vx cab wss vz cv cJ wss va cv vx cv vy
      cv cY cin wceq vy vz cv wrex vx cab wceq wa vz wex cJ ctop wcel va cv vy
      cv cJ wcel vx cv vy cv cY cin wceq wa vy vx copab crn wss vz cv cJ wss va
      cv vx cv vy cv cY cin wceq vy vz cv wrex vx cab wceq wa vz wex va cv vx
      cv vy cv cY cin wceq vy cJ wrex vx cab wss cJ ctop wcel va cv vx cv vy cv
      cY cin wceq vy vx copab cJ cima wss vz cv cJ wss va cv vx cv vy cv cY cin
      wceq vy vx copab vz cv cima wceq wa vz wex va cv vy cv cJ wcel vx cv vy
      cv cY cin wceq wa vy vx copab crn wss vz cv cJ wss va cv vx cv vy cv cY
      cin wceq vy vz cv wrex vx cab wceq wa vz wex cJ ctop wcel va cv vx cv vy
      cv cY cin wceq vy vx copab cJ cima wss vz cv cJ wss va cv vx cv vy cv cY
      cin wceq vy vx copab vz cv cima wceq wa vz wex cJ ctop wcel vx cv vy cv
      cY cin wceq vy vx copab wfun va cv vx cv vy cv cY cin wceq vy vx copab cJ
      cima wss vz cv cJ wss va cv vx cv vy cv cY cin wceq vy vx copab vz cv
      cima wceq wa vz wex vy vx vy cv cY cin funopabeq vz cJ va cv ctop vx cv
      vy cv cY cin wceq vy vx copab ssimaexg mp3an2 ex vx cv vy cv cY cin wceq
      vy vx copab cJ cima vy cv cJ wcel vx cv vy cv cY cin wceq wa vy vx copab
      crn va cv vx cv vy cv cY cin wceq vy vx copab cJ cima vx cv vy cv cY cin
      wceq vy vx copab cJ cres crn vy cv cJ wcel vx cv vy cv cY cin wceq wa vy
      vx copab crn vx cv vy cv cY cin wceq vy vx copab cJ df-ima vx cv vy cv cY
      cin wceq vy vx copab cJ cres vy cv cJ wcel vx cv vy cv cY cin wceq wa vy
      vx copab vx cv vy cv cY cin wceq vy vx cJ resopab rneqi eqtri sseq2i vz
      cv cJ wss va cv vx cv vy cv cY cin wceq vy vx copab vz cv cima wceq wa vz
      cv cJ wss va cv vx cv vy cv cY cin wceq vy vz cv wrex vx cab wceq wa vz
      va cv vx cv vy cv cY cin wceq vy vx copab vz cv cima wceq va cv vx cv vy
      cv cY cin wceq vy vz cv wrex vx cab wceq vz cv cJ wss vx cv vy cv cY cin
      wceq vy vx copab vz cv cima vx cv vy cv cY cin wceq vy vz cv wrex vx cab
      va cv vx cv vy cv cY cin wceq vy vx copab vz cv cima vx cv vy cv cY cin
      wceq vy vx copab vz cv cres crn vy cv vz cv wcel vx cv vy cv cY cin wceq
      wa vy vx copab crn vx cv vy cv cY cin wceq vy vz cv wrex vx cab vx cv vy
      cv cY cin wceq vy vx copab vz cv df-ima vx cv vy cv cY cin wceq vy vx
      copab vz cv cres vy cv vz cv wcel vx cv vy cv cY cin wceq wa vy vx copab
      vx cv vy cv cY cin wceq vy vx vz cv resopab rneqi vy vx vz cv vy cv cY
      cin rnopab2 3eqtri eqeq2i anbi2i exbii 3imtr3g vx cv vy cv cY cin wceq vy
      cJ wrex vx cab vy cv cJ wcel vx cv vy cv cY cin wceq wa vy vx copab crn
      va cv vy cv cJ wcel vx cv vy cv cY cin wceq wa vy vx copab crn vx cv vy
      cv cY cin wceq vy cJ wrex vx cab vy vx cJ vy cv cY cin rnopab2 eqcomi
      sseq2i syl5ib imp vz cv cJ wss va cv vx cv vy cv cY cin wceq vy vz cv
      wrex vx cab wceq wa vz cv cJ wss va cv cuni vz cv cuni cY cin wceq wa vz
      va cv vx cv vy cv cY cin wceq vy vz cv wrex vx cab wceq va cv cuni vz cv
      cuni cY cin wceq vz cv cJ wss va cv vx cv vy cv cY cin wceq vy vz cv wrex
      vx cab wceq va cv cuni vx cv vy cv cY cin wceq vy vz cv wrex vx cab cuni
      vz cv cuni cY cin va cv vx cv vy cv cY cin wceq vy vz cv wrex vx cab
      unieq vx cv vy cv cY cin wceq vy vz cv wrex vx cab cuni vy vz cv vy cv cY
      cin ciun vy vz cv cY vy cv cin ciun vz cv cuni cY cin vy cv cY cin cvv
      wcel vx cv vy cv cY cin wceq vy vz cv wrex vx cab cuni vy vz cv vy cv cY
      cin ciun wceq vy vz cv vy cv cY cin cvv wcel vy vz cv wral vy vz cv vy cv
      cY cin ciun vx cv vy cv cY cin wceq vy vz cv wrex vx cab cuni vy vx vz cv
      vy cv cY cin cvv dfiun2g eqcomd vy cv cY vz cv inex1g mprg vy vz cv vy cv
      cY cin cY vy cv cin vy cv cY cin cY vy cv cin wceq vy cv vz cv wcel vy cv
      cY incom a1i iuneq2i vy vz cv cY vy cv cin ciun cY vy vz cv vy cv ciun
      cin cY vz cv cuni cin vz cv cuni cY cin vy vz cv cY vy cv iunin2 vz cv
      cuni vy vz cv vy cv ciun cY vy vz cv uniiun ineq2i cY vz cv cuni incom
      3eqtr2i 3eqtri syl6eq anim2i 19.22i syl cJ ctop wcel va cv cuni vy cv cY
      cin wceq vy cJ wrex vz cv cJ wss va cv cuni vz cv cuni cY cin wceq wa vz
      wex wb va cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wss cJ ctop wcel
      va cv cuni vy cv cY cin wceq vy cJ wrex vz cv cJ wss va cv cuni vz cv
      cuni cY cin wceq wa vz wex va cv cuni vy cv cY cin wceq vz cv cJ wss va
      cv cuni vz cv cuni cY cin wceq wa vz wex vy cJ vy cv csn cJ wss va cv
      cuni vy cv cY cin wceq vz cv cJ wss va cv cuni vz cv cuni cY cin wceq wa
      vz wex vy cv cJ wcel vz cv cJ wss va cv cuni vz cv cuni cY cin wceq wa vy
      cv csn cJ wss va cv cuni vy cv cY cin wceq wa vz vy cv csn vy cv snex vz
      cv vy cv csn wceq vz cv cJ wss vy cv csn cJ wss va cv cuni vz cv cuni cY
      cin wceq va cv cuni vy cv cY cin wceq vz cv vy cv csn cJ sseq1 vz cv vy
      cv csn wceq vz cv cuni cY cin vy cv cY cin va cv cuni vz cv vy cv csn
      wceq vz cv cuni vy cv cY vz cv vy cv csn wceq vz cv cuni vy cv csn cuni
      vy cv vz cv vy cv csn unieq vy cv vy visset unisn syl6eq ineq1d eqeq2d
      anbi12d cla4ev vy cv cJ snssi sylan r19.23aiva cJ ctop wcel vz cv cJ wss
      va cv cuni vz cv cuni cY cin wceq wa va cv cuni vy cv cY cin wceq vy cJ
      wrex vz cJ ctop wcel vz cv cJ wss va cv cuni vz cv cuni cY cin wceq va cv
      cuni vy cv cY cin wceq vy cJ wrex cJ ctop wcel vz cv cJ wss wa vz cv cuni
      cJ wcel va cv cuni vz cv cuni cY cin wceq va cv cuni vy cv cY cin wceq vy
      cJ wrex wi vz cv cJ uniopn vz cv cuni cJ wcel va cv cuni vz cv cuni cY
      cin wceq va cv cuni vy cv cY cin wceq vy cJ wrex va cv cuni vy cv cY cin
      wceq va cv cuni vz cv cuni cY cin wceq vy vz cv cuni cJ vy cv vz cv cuni
      wceq vy cv cY cin vz cv cuni cY cin va cv cuni vy cv vz cv cuni cY ineq1
      eqeq2d rcla4ev ex syl expimpd 19.23adv impbid2 adantr mpbird vx cv vy cv
      cY cin wceq vy cJ wrex va cv cuni vy cv cY cin wceq vy cJ wrex vx va cv
      cuni va cv va visset uniex vx cv va cv cuni wceq vx cv vy cv cY cin wceq
      va cv cuni vy cv cY cin wceq vy cJ vx cv va cv cuni vy cv cY cin eqeq1
      rexbidv elab sylibr ex 19.21aiv cJ ctop wcel va cv vb cv cin vx cv vy cv
      cY cin wceq vy cJ wrex vx cab wcel vb vx cv vy cv cY cin wceq vy cJ wrex
      vx cab wral va vx cv vy cv cY cin wceq vy cJ wrex vx cab cJ ctop wcel va
      cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wcel wa va cv vb cv cin vx
      cv vy cv cY cin wceq vy cJ wrex vx cab wcel vb vx cv vy cv cY cin wceq vy
      cJ wrex vx cab cJ ctop wcel va cv vx cv vy cv cY cin wceq vy cJ wrex vx
      cab wcel wa vb cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wcel wa va cv
      vb cv cin vy cv cY cin wceq vy cJ wrex va cv vb cv cin vx cv vy cv cY cin
      wceq vy cJ wrex vx cab wcel cJ ctop wcel va cv vx cv vy cv cY cin wceq vy
      cJ wrex vx cab wcel wa vb cv vx cv vy cv cY cin wceq vy cJ wrex vx cab
      wcel va cv vb cv cin vy cv cY cin wceq vy cJ wrex cJ ctop wcel va cv vx
      cv vy cv cY cin wceq vy cJ wrex vx cab wcel wa vb cv vy cv cY cin wceq vy
      cJ wrex va cv vb cv cin vy cv cY cin wceq vy cJ wrex vb cv vx cv vy cv cY
      cin wceq vy cJ wrex vx cab wcel cJ ctop wcel va cv vx cv vy cv cY cin
      wceq vy cJ wrex vx cab wcel vb cv vy cv cY cin wceq vy cJ wrex va cv vb
      cv cin vy cv cY cin wceq vy cJ wrex wi cJ ctop wcel vb cv vy cv cY cin
      wceq vy cJ wrex va cv vx cv vy cv cY cin wceq vy cJ wrex vx cab wcel va
      cv vb cv cin vy cv cY cin wceq vy cJ wrex cJ ctop wcel vb cv vy cv cY cin
      wceq vy cJ wrex va cv vc cv cY cin wceq vc cJ wrex va cv vb cv cin vy cv
      cY cin wceq vy cJ wrex va cv vx cv vy cv cY cin wceq vy cJ wrex vx cab
      wcel cJ ctop wcel vb cv vd cv cY cin wceq vd cJ wrex va cv vc cv cY cin
      wceq vc cJ wrex va cv vb cv cin vy cv cY cin wceq vy cJ wrex wi vb cv vy
      cv cY cin wceq vy cJ wrex cJ ctop wcel vb cv vd cv cY cin wceq va cv vc
      cv cY cin wceq vc cJ wrex va cv vb cv cin vy cv cY cin wceq vy cJ wrex wi
      vd cJ cJ ctop wcel va cv vc cv cY cin wceq vc cJ wrex vb cv vd cv cY cin
      wceq vd cv cJ wcel va cv vb cv cin vy cv cY cin wceq vy cJ wrex cJ ctop
      wcel va cv vc cv cY cin wceq vb cv vd cv cY cin wceq vd cv cJ wcel va cv
      vb cv cin vy cv cY cin wceq vy cJ wrex wi wi vc cJ cJ ctop wcel vc cv cJ
      wcel wa vd cv cJ wcel vb cv vd cv cY cin wceq va cv vc cv cY cin wceq va
      cv vb cv cin vy cv cY cin wceq vy cJ wrex cJ ctop wcel vc cv cJ wcel wa
      vd cv cJ wcel vb cv vd cv cY cin wceq va cv vc cv cY cin wceq va cv vb cv
      cin vy cv cY cin wceq vy cJ wrex vc cv vd cv cin cJ wcel va cv vb cv cin
      vc cv vd cv cin cY cin wceq va cv vb cv cin vy cv cY cin wceq vy cJ wrex
      cJ ctop wcel vc cv cJ wcel wa vd cv cJ wcel wa vb cv vd cv cY cin wceq va
      cv vc cv cY cin wceq wa va cv vb cv cin vy cv cY cin wceq va cv vb cv cin
      vc cv vd cv cin cY cin wceq vy vc cv vd cv cin cJ vy cv vc cv vd cv cin
      wceq vy cv cY cin vc cv vd cv cin cY cin va cv vb cv cin vy cv vc cv vd
      cv cin cY ineq1 eqeq2d rcla4ev cJ ctop wcel vc cv cJ wcel vd cv cJ wcel
      vc cv vd cv cin cJ wcel vc cv vd cv cJ inopn 3expa va cv vc cv cY cin
      wceq vb cv vd cv cY cin wceq va cv vb cv cin vc cv vd cv cin cY cin wceq
      va cv vc cv cY cin wceq vb cv vd cv cY cin wceq wa va cv vb cv cin vc cv
      cY cin vd cv cY cin cin vc cv vd cv cin cY cin va cv vc cv cY cin vb cv
      vd cv cY cin ineq12 vc cv vd cv cY inindir syl6eqr ancoms syl2an exp43
      com24 r19.23adva com24 r19.23adv vb cv vy cv cY cin wceq vb cv vd cv cY
      cin wceq vy vd cJ vy cv vd cv wceq vy cv cY cin vd cv cY cin vb cv vy cv
      vd cv cY ineq1 eqeq2d cbvrexv syl5ib va cv vx cv vy cv cY cin wceq vy cJ
      wrex vx cab wcel vx cv va cv wceq vx cv vy cv cY cin wceq vy cJ wrex wa
      vx wex va cv vy cv cY cin wceq vy cJ wrex va cv vc cv cY cin wceq vc cJ
      wrex vx cv vy cv cY cin wceq vy cJ wrex vx va cv clelab vx cv vy cv cY
      cin wceq vy cJ wrex va cv vy cv cY cin wceq vy cJ wrex vx va cv va visset
      vx cv va cv wceq vx cv vy cv cY cin wceq va cv vy cv cY cin wceq vy cJ vx
      cv va cv vy cv cY cin eqeq1 rexbidv ceqsexv va cv vy cv cY cin wceq va cv
      vc cv cY cin wceq vy vc cJ vy cv vc cv wceq vy cv cY cin vc cv cY cin va
      cv vy cv vc cv cY ineq1 eqeq2d cbvrexv 3bitri syl7ib com23 imp vx cv vy
      cv cY cin wceq vy cJ wrex vb cv vy cv cY cin wceq vy cJ wrex vx vb cv vb
      visset vx cv vb cv wceq vx cv vy cv cY cin wceq vb cv vy cv cY cin wceq
      vy cJ vx cv vb cv vy cv cY cin eqeq1 rexbidv elab syl5ib imp vx cv vy cv
      cY cin wceq vy cJ wrex va cv vb cv cin vy cv cY cin wceq vy cJ wrex vx va
      cv vb cv cin va cv vb cv va visset inex1 vx cv va cv vb cv cin wceq vx cv
      vy cv cY cin wceq va cv vb cv cin vy cv cY cin wceq vy cJ vx cv va cv vb
      cv cin vy cv cY cin eqeq1 rexbidv elab sylibr r19.21aiva r19.21aiva jca
      cJ ctop wcel vx cv vy cv cY cin wceq vy cJ wrex vx cab cvv wcel vx cv vy
      cv cY cin wceq vy cJ wrex vx cab ctop wcel va cv vx cv vy cv cY cin wceq
      vy cJ wrex vx cab wss va cv cuni vx cv vy cv cY cin wceq vy cJ wrex vx
      cab wcel wi va wal va cv vb cv cin vx cv vy cv cY cin wceq vy cJ wrex vx
      cab wcel vb vx cv vy cv cY cin wceq vy cJ wrex vx cab wral va vx cv vy cv
      cY cin wceq vy cJ wrex vx cab wral wa wb vy vx cJ vy cv cY cin ctop
      abrexexg va vb cvv vx cv vy cv cY cin wceq vy cJ wrex vx cab istopg syl
      mpbird $.
      $( [17-May-2007] $) $( [8-Apr-2007] $)
  $}

  ${
    $d x y $.
    $( The singleton of the empty set is a topology.  (Contributed by Stefan
       Allan, 3-Mar-2006.) $)
    sn0top $p |- { (/) } e. Top $=
      c0 csn ctop wcel vx cv c0 csn wss vx cv cuni c0 csn wcel wi vx wal vx cv
      vy cv cin c0 csn wcel vy c0 csn wral vx c0 csn wral c0 csn cvv wcel c0
      csn ctop wcel vx cv c0 csn wss vx cv cuni c0 csn wcel wi vx wal vx cv vy
      cv cin c0 csn wcel vy c0 csn wral vx c0 csn wral wa wb p0ex vx vy cvv c0
      csn istopg ax-mp vx cv c0 csn wss vx cv cuni c0 csn wcel wi vx vx cv c0
      csn wss vx cv c0 wceq vx cv c0 csn wceq wo vx cv cuni c0 csn wcel vx cv
      c0 sssn vx cv c0 wceq vx cv cuni c0 csn wcel vx cv c0 csn wceq vx cv c0
      wceq vx cv cuni c0 cuni c0 csn vx cv c0 unieq c0 cuni c0 csn wcel c0 cuni
      c0 wceq uni0 c0 cuni c0 0ex elsnc2 mpbir syl6eqel vx cv c0 csn wceq vx cv
      cuni c0 csn cuni wceq vx cv cuni c0 csn wcel vx cv c0 csn unieq vx cv
      cuni c0 csn cuni wceq vx cv cuni c0 wceq vx cv cuni c0 csn wcel vx cv
      cuni c0 csn cuni wceq c0 csn cuni c0 wceq vx cv cuni c0 wceq c0 0ex unisn
      vx cv cuni c0 csn cuni c0 eqtr mpan2 vx cv cuni c0 vx cv vx visset uniex
      elsnc sylibr syl jaoi sylbi ax-gen vx cv vy cv cin c0 csn wcel vx vy c0
      csn vy cv c0 csn wcel vx cv vy cv cin c0 csn wcel vx cv c0 csn wcel vy cv
      c0 csn wcel vy cv c0 wceq vx cv vy cv cin c0 csn wcel vy c0 elsn vy cv c0
      wceq vx cv vy cv cin c0 wceq vx cv vy cv cin c0 csn wcel vy cv c0 wceq vx
      cv vy cv cin vx cv c0 cin wceq vx cv vy cv cin c0 wceq vy cv c0 vx cv
      ineq2 vx cv vy cv cin vx cv c0 cin wceq vx cv vy cv cin c0 wceq vx cv c0
      cin c0 vx cv vy cv cin vx cv in0 eqeq2i biimpi syl vx cv vy cv cin c0 csn
      wcel vx cv vy cv cin c0 wceq vx cv vy cv cin c0 vx cv vy cv vx visset
      inex1 elsnc biimpri syl sylbi adantl rgen2a mpbir2an $.
      $( [13-Jul-2006] $) $( [3-Mar-2006] $)
  $}

  ${
    $d x y A $.
    $( The indiscrete topology on a set ` A ` .  Part of Example 2 in [Munkres]
       p. 77.  (Contributed by FL, 16-Jul-2006; hypothesis eliminated by Stefan
       Allan, 6-Nov-2008.) $)
    indistop $p |- { (/) , A } e. Top $=
      cA cvv wcel c0 cA cpr ctop wcel cA cvv wcel c0 cA cpr ctop wcel vx cv c0
      cA cpr wss vx cv cuni c0 cA cpr wcel wi vx wal vx cv vy cv cin c0 cA cpr
      wcel vy c0 cA cpr wral vx c0 cA cpr wral wa cA cvv wcel vx cv c0 cA cpr
      wss vx cv cuni c0 cA cpr wcel wi vx wal vx cv vy cv cin c0 cA cpr wcel vy
      c0 cA cpr wral vx c0 cA cpr wral cA cvv wcel vx cv c0 cA cpr wss vx cv
      cuni c0 cA cpr wcel wi vx cA cvv wcel vx cv c0 wceq vx cv c0 csn wceq wo
      vx cv cA csn wceq vx cv c0 cA cpr wceq wo wo vx cv cuni c0 cA cpr wcel vx
      cv c0 cA cpr wss cA cvv wcel vx cv c0 wceq vx cv c0 csn wceq wo vx cv
      cuni c0 cA cpr wcel vx cv cA csn wceq vx cv c0 cA cpr wceq wo cA cvv wcel
      vx cv c0 wceq vx cv cuni c0 cA cpr wcel vx cv c0 csn wceq vx cv c0 wceq
      vx cv cuni c0 cA cpr wcel wi cA cvv wcel vx cv c0 wceq vx cv cuni c0 cuni
      c0 cA cpr vx cv c0 unieq c0 cuni c0 c0 cA cpr uni0 c0 cA 0ex prid1
      eqeltri syl6eqel a1i vx cv c0 csn wceq vx cv cuni c0 cA cpr wcel wi cA
      cvv wcel vx cv c0 csn wceq vx cv cuni c0 csn cuni c0 cA cpr vx cv c0 csn
      unieq c0 csn cuni c0 c0 cA cpr c0 0ex unisn c0 cA 0ex prid1 eqeltri
      syl6eqel a1i jaod cA cvv wcel vx cv cA csn wceq vx cv cuni c0 cA cpr wcel
      vx cv c0 cA cpr wceq cA cvv wcel vx cv cA csn wceq vx cv cuni c0 cA cpr
      wcel cA cvv wcel vx cv cA csn wceq wa vx cv cuni cA c0 cA cpr vx cv cA
      csn wceq cA cvv wcel vx cv cuni cA csn cuni cA vx cv cA csn unieq cA cvv
      unisng sylan9eqr cA cvv wcel cA c0 cA cpr wcel vx cv cA csn wceq c0 cA
      cvv prid2g adantr eqeltrd ex cA cvv wcel vx cv c0 cA cpr wceq vx cv cuni
      c0 cA cpr wcel cA cvv wcel vx cv c0 cA cpr wceq wa vx cv cuni cA c0 cA
      cpr vx cv c0 cA cpr wceq cA cvv wcel vx cv cuni c0 cA cpr cuni cA vx cv
      c0 cA cpr unieq cA cvv wcel c0 cA cpr cuni c0 cA cun cA c0 cvv wcel cA
      cvv wcel c0 cA cpr cuni c0 cA cun wceq 0ex c0 cA cvv cvv uniprg mpan c0
      cA cun cA c0 cun cA c0 cA uncom cA un0 eqtri syl6eq sylan9eqr cA cvv wcel
      cA c0 cA cpr wcel vx cv c0 cA cpr wceq c0 cA cvv prid2g adantr eqeltrd ex
      jaod jaod vx cv c0 cA sspr syl5ib 19.21aiv cA cvv wcel vx cv vy cv cin c0
      cA cpr wcel vy c0 cA cpr wral vx c0 cA cpr cA cvv wcel vx cv c0 wceq vx
      cv cA wceq wo vx cv vy cv cin c0 cA cpr wcel vy c0 cA cpr wral vx cv c0
      cA cpr wcel cA cvv wcel vx cv c0 wceq vx cv cA wceq wo vx cv vy cv cin c0
      cA cpr wcel vy c0 cA cpr wral cA cvv wcel vx cv c0 wceq vx cv cA wceq wo
      wa vx cv vy cv cin c0 cA cpr wcel vy c0 cA cpr cA cvv wcel vx cv c0 wceq
      vx cv cA wceq wo wa vy cv c0 wceq vy cv cA wceq wo vx cv vy cv cin c0 cA
      cpr wcel vy cv c0 cA cpr wcel cA cvv wcel vx cv c0 wceq vx cv cA wceq wo
      vy cv c0 wceq vy cv cA wceq wo vx cv vy cv cin c0 cA cpr wcel cA cvv wcel
      vx cv c0 wceq vy cv c0 wceq vx cv cA wceq vy cv cA wceq vx cv vy cv cin
      c0 cA cpr wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cin c0 cA cpr
      wcel wi cA cvv wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cin c0 c0
      cA cpr vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cin vx cv c0 cin c0 vx
      cv c0 wceq vy cv c0 wceq wa vy cv c0 vx cv vx cv c0 wceq vy cv c0 wceq
      pm3.27 ineq2d vx cv in0 syl6eq c0 cA 0ex prid1 syl6eqel a1i vx cv cA wceq
      vy cv c0 wceq wa vx cv vy cv cin c0 cA cpr wcel wi cA cvv wcel vx cv cA
      wceq vy cv c0 wceq wa vx cv vy cv cin c0 c0 cA cpr vx cv cA wceq vy cv c0
      wceq wa vx cv vy cv cin vx cv c0 cin c0 vx cv cA wceq vy cv c0 wceq wa vy
      cv c0 vx cv vx cv cA wceq vy cv c0 wceq pm3.27 ineq2d vx cv in0 syl6eq c0
      cA 0ex prid1 syl6eqel a1i vx cv c0 wceq vy cv cA wceq wa vx cv vy cv cin
      c0 cA cpr wcel wi cA cvv wcel vx cv c0 wceq vy cv cA wceq wa vx cv vy cv
      cin c0 c0 cA cpr vx cv c0 wceq vy cv cA wceq wa vx cv vy cv cin c0 vy cv
      cin c0 vx cv c0 wceq vy cv cA wceq wa vx cv c0 vy cv vx cv c0 wceq vy cv
      cA wceq pm3.26 ineq1d c0 vy cv cin vy cv c0 cin c0 c0 vy cv incom vy cv
      in0 eqtri syl6eq c0 cA 0ex prid1 syl6eqel a1i cA cvv wcel vx cv cA wceq
      vy cv cA wceq wa vx cv vy cv cin c0 cA cpr wcel cA cvv wcel vx cv cA wceq
      vy cv cA wceq wa wa vx cv vy cv cin cA c0 cA cpr cA cvv wcel vx cv cA
      wceq vy cv cA wceq wa wa vx cv vy cv cin cA cA cin cA vx cv cA wceq vy cv
      cA wceq wa vx cv vy cv cin cA cA cin wceq cA cvv wcel vx cv cA vy cv cA
      ineq12 adantl cA inidm syl6eq cA cvv wcel cA c0 cA cpr wcel vx cv cA wceq
      vy cv cA wceq wa c0 cA cvv prid2g adantr eqeltrd ex ccased expdimp vy cv
      c0 cA vy visset elpr syl5ib r19.21aiv ex vx cv c0 cA vx visset elpr
      syl5ib r19.21aiv jca cA cvv wcel c0 cA cpr cvv wcel c0 cA cpr ctop wcel
      vx cv c0 cA cpr wss vx cv cuni c0 cA cpr wcel wi vx wal vx cv vy cv cin
      c0 cA cpr wcel vy c0 cA cpr wral vx c0 cA cpr wral wa wb c0 cA cpr cvv
      wcel cA cvv wcel c0 cA prex a1i vx vy cvv c0 cA cpr istopg syl mpbird cA
      cvv wcel wn c0 cA cpr c0 csn ctop c0 cA prprc2 sn0top syl6eqel pm2.61i $.
      $( [8-Nov-2008] $) $( [6-Nov-2008] $)
  $}

  ${
    $d x y z A $.
    indistop.1 $e |- A e. _V $.
    $( The discrete topology on a set ` A ` .  Part of Example 2 in [Munkres]
       p. 77.  (Contributed by FL, 18-Jul-2006.) $)
    distop $p |- ~P A e. Top $=
      cA cpw ctop wcel vx cv cA cpw wss vx cv cuni cA cpw wcel wi vx wal vx cv
      vy cv cin cA cpw wcel vy cA cpw wral vx cA cpw wral cA cpw cvv wcel cA
      cpw ctop wcel vx cv cA cpw wss vx cv cuni cA cpw wcel wi vx wal vx cv vy
      cv cin cA cpw wcel vy cA cpw wral vx cA cpw wral wa wb cA indistop.1 pwex
      vx vy cvv cA cpw istopg ax-mp vx cv cA cpw wss vx cv cuni cA cpw wcel wi
      vx vx cv cA cpw wss vx cv cuni cA wss vx cv cuni cA cpw wcel vx cv cA cpw
      wss vx cv cuni cA cpw cuni cA vx cv cA cpw uniss cA unipw syl6ss vx cv
      cuni cA vx cv vx visset uniex elpw sylibr ax-gen vx cv vy cv cin cA cpw
      wcel vy cA cpw wral vx cA cpw vx cv cA cpw wcel vx cv vy cv cin cA cpw
      wcel vy cA cpw vx cv cA cpw wcel vx cv cA wss vy cv cA cpw wcel vx cv vy
      cv cin cA cpw wcel wi vx cv cA vx visset elpw vy cv cA cpw wcel vx cv cA
      wss vx cv vy cv cin cA cpw wcel vy cv cA cpw wcel vy cv cA wss vx cv cA
      wss vx cv vy cv cin cA cpw wcel wi vy cv cA vy visset elpw vy cv cA wss
      vx cv cA wss vx cv vy cv cin cA wss vx cv vy cv cin cA cpw wcel vx cv cA
      wss vx cv vy cv cin cA wss wi vy cv cA wss vx cv vy cv cA ssinss1 a1i vx
      cv vy cv cin cA vy cv vx cv vy visset inex2 elpw syl6ibr sylbi com12
      sylbi r19.21aiv rgen mpbir2an $.
      $( [18-Jul-2006] $)


    $( The countable complement topology on a set ` A ` .  Example 4 in
       [Munkres] p. 77.  (Contributed by FL, 29-Aug-2006.) $)
    cctop $p |- { x | ( x C_ A /\ ( ( A \ x ) ~<_ om \/ x = (/) ) ) } e. Top $=
      vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab ctop
      wcel vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx
      cab wss vy cv cuni vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq
      wo wa vx cab wcel wi vy wal vy cv vz cv cin vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo wa vx cab wcel vz vx cv cA wss cA vx cv
      cdif com cdom wbr vx cv c0 wceq wo wa vx cab wral vy vx cv cA wss cA vx
      cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab wral vx cv cA wss cA vx
      cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab cvv wcel vx cv cA wss cA
      vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab ctop wcel vy cv vx cv
      cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab wss vy cv
      cuni vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab
      wcel wi vy wal vy cv vz cv cin vx cv cA wss cA vx cv cdif com cdom wbr vx
      cv c0 wceq wo wa vx cab wcel vz vx cv cA wss cA vx cv cdif com cdom wbr
      vx cv c0 wceq wo wa vx cab wral vy vx cv cA wss cA vx cv cdif com cdom
      wbr vx cv c0 wceq wo wa vx cab wral wa wb cA cvv wcel vx cv cA wss cA vx
      cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab cvv wcel indistop.1 cA vx
      cv cdif com cdom wbr vx cv c0 wceq wo vx cA cvv abssexg ax-mp vy vz cvv
      vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab istopg
      ax-mp vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa
      vx cab wss vy cv cuni vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vx cab wcel wi vy vy cv cuni vx cv cA wss cA vx cv cdif com
      cdom wbr vx cv c0 wceq wo wa vx cab wcel vy cv cuni cA wss cA vy cv cuni
      cdif com cdom wbr vy cv cuni c0 wceq wo vy cv vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo wa vx cab wss vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo wa vy cv cuni cA wss cA vy cv cuni cdif com
      cdom wbr vy cv cuni c0 wceq wo wa vx vy cv cuni vy cv vy visset uniex vx
      cv vy cv cuni wceq vx cv cA wss vy cv cuni cA wss cA vx cv cdif com cdom
      wbr vx cv c0 wceq wo cA vy cv cuni cdif com cdom wbr vy cv cuni c0 wceq
      wo vx cv vy cv cuni cA sseq1 vx cv vy cv cuni wceq cA vx cv cdif com cdom
      wbr cA vy cv cuni cdif com cdom wbr vx cv c0 wceq vy cv cuni c0 wceq vx
      cv vy cv cuni wceq cA vx cv cdif cA vy cv cuni cdif com cdom vx cv vy cv
      cuni cA difeq2 breq1d vx cv vy cv cuni c0 eqeq1 orbi12d anbi12d elab vy
      cv cuni vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx
      cab cuni wss vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa
      vx cab cuni cA wss vy cv cuni cA wss vy cv vx cv cA wss cA vx cv cdif com
      cdom wbr vx cv c0 wceq wo wa vx cab wss vy cv cuni vx cv cA wss cA vx cv
      cdif com cdom wbr vx cv c0 wceq wo wa vx cab cuni cA sstr vy cv vx cv cA
      wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab uniss vx cv cA
      wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cvv crab cuni vx cv
      cA wss vx cvv crab cuni vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vx cab cuni cA vx cv cA wss cA vx cv cdif com cdom wbr vx cv
      c0 wceq wo wa vx cvv crab vx cv cA wss vx cvv crab wss vx cv cA wss cA vx
      cv cdif com cdom wbr vx cv c0 wceq wo wa vx cvv crab cuni vx cv cA wss vx
      cvv crab cuni wss vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq
      wo wa vx cv cA wss vx cvv vx cv cA wss cA vx cv cdif com cdom wbr vx cv
      c0 wceq wo wa vx cv cA wss wi vx cv cvv wcel vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo pm3.26 a1i ss2rabi vx cv cA wss cA vx cv
      cdif com cdom wbr vx cv c0 wceq wo wa vx cvv crab vx cv cA wss vx cvv
      crab uniss ax-mp vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo
      wa vx cvv crab vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo
      wa vx cab vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx
      rabab unieqi cA cvv wcel vx cv cA wss vx cvv crab cuni cA wceq indistop.1
      vx cA cvv unimax ax-mp 3sstr3i sylancl vy cv vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo wa vx cab wss cA vy cv cuni cdif com cdom
      wbr vy cv cuni c0 wceq vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx
      cv c0 wceq wo wa vx cab wss vy cv cuni c0 wceq cA vy cv cuni cdif com
      cdom wbr vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo
      wa vx cab wss vz cv c0 wceq wn vz vy cv wrex cA vy cv cuni cdif com cdom
      wbr vy cv cuni c0 wceq wn vy cv vx cv cA wss cA vx cv cdif com cdom wbr
      vx cv c0 wceq wo wa vx cab wss vz cv c0 wceq wn cA vy cv cuni cdif com
      cdom wbr vz vy cv vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vx cab wss vz cv vy cv wcel vz cv c0 wceq wn cA vy cv cuni
      cdif com cdom wbr vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vx cab wss vz cv vy cv wcel wa vz cv c0 wceq wn wa cA vz cv
      cdif com cdom wbr cA vy cv cuni cdif com cdom wbr vy cv vx cv cA wss cA
      vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel
      wa vz cv c0 wceq wn cA vz cv cdif com cdom wbr vy cv vx cv cA wss cA vx
      cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel wa
      cA vz cv cdif com cdom wbr vz cv c0 wceq vy cv vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel wa cA vz cv
      cdif com cdom wbr vz cv c0 wceq vy cv vx cv cA wss cA vx cv cdif com cdom
      wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel wa vz cv cA wss cA vz
      cv cdif com cdom wbr vz cv c0 wceq wo vy cv vx cv cA wss cA vx cv cdif
      com cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel wa vz cv vx
      cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab wcel vz
      cv cA wss cA vz cv cdif com cdom wbr vz cv c0 wceq wo wa vy cv vx cv cA
      wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab vz cv ssel2 vx
      cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vz cv cA wss cA
      vz cv cdif com cdom wbr vz cv c0 wceq wo wa vx vz cv vz visset vx cv vz
      cv wceq vx cv cA wss vz cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo cA vz cv cdif com cdom wbr vz cv c0 wceq wo vx cv vz cv cA sseq1
      vx cv vz cv wceq cA vx cv cdif com cdom wbr cA vz cv cdif com cdom wbr vx
      cv c0 wceq vz cv c0 wceq vx cv vz cv wceq cA vx cv cdif cA vz cv cdif com
      cdom vx cv vz cv cA difeq2 breq1d vx cv vz cv c0 eqeq1 orbi12d anbi12d
      elab sylib pm3.27d ord con1d imp vy cv vx cv cA wss cA vx cv cdif com
      cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel wa vz cv c0 wceq
      wn wa cA vz cv cdif com cdom wbr cA vy cv cuni cdif cA vz cv cdif cdom
      wbr cA vy cv cuni cdif com cdom wbr vy cv vx cv cA wss cA vx cv cdif com
      cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel wa vz cv c0 wceq
      wn wa cA vz cv cdif com cdom wbr wa vz cv vy cv cuni wss cA vy cv cuni
      cdif cA vz cv cdif wss cA vy cv cuni cdif cA vz cv cdif cdom wbr vy cv vx
      cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vx cab wss vz cv
      vy cv wcel wa vz cv c0 wceq wn wa cA vz cv cdif com cdom wbr wa vz cv vy
      cv wcel vz cv vy cv cuni wss vy cv vx cv cA wss cA vx cv cdif com cdom
      wbr vx cv c0 wceq wo wa vx cab wss vz cv vy cv wcel vz cv c0 wceq wn cA
      vz cv cdif com cdom wbr simpllr vz cv vy cv elssuni syl vz cv vy cv cuni
      cA sscon cA vz cv cdif cvv wcel cA vy cv cuni cdif cA vz cv cdif wss cA
      vy cv cuni cdif cA vz cv cdif cdom wbr wi cA cvv wcel cA vz cv cdif cvv
      wcel indistop.1 cA vz cv cvv difexg ax-mp cA vy cv cuni cdif cA vz cv
      cdif cvv ssdom2g ax-mp 3syl cA vy cv cuni cdif cA vz cv cdif com domtr
      sylancom mpdan exp31 r19.23adv vy cv cuni c0 wceq wn vz cv c0 wceq vz vy
      cv wral wn vz cv c0 wceq wn vz vy cv wrex vy cv cuni c0 wceq vz cv c0
      wceq vz vy cv wral vy cv cuni c0 wceq vy cv c0 csn wss vz cv c0 csn wcel
      vz vy cv wral vz cv c0 wceq vz vy cv wral vy cv uni0b vz vy cv c0 csn
      dfss3 vz cv c0 csn wcel vz cv c0 wceq vz vy cv vz c0 elsn ralbii 3bitri
      notbii vz cv c0 wceq vz vy cv rexnal bitr4i syl5ib con1d orrd sylanbrc
      ax-gen vy cv vz cv cin vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vx cab wcel vy vz vx cv cA wss cA vx cv cdif com cdom wbr vx
      cv c0 wceq wo wa vx cab vy cv cA wss cA vy cv cdif com cdom wbr vy cv c0
      wceq wo wa vz cv cA wss cA vz cv cdif com cdom wbr vz cv c0 wceq wo wa wa
      vy cv vz cv cin cA wss cA vy cv vz cv cin cdif com cdom wbr vy cv vz cv
      cin c0 wceq wo wa vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vx cab wcel vz cv vx cv cA wss cA vx cv cdif com cdom wbr vx
      cv c0 wceq wo wa vx cab wcel wa vy cv vz cv cin vx cv cA wss cA vx cv
      cdif com cdom wbr vx cv c0 wceq wo wa vx cab wcel vy cv cA wss cA vy cv
      cdif com cdom wbr vy cv c0 wceq wo wa vz cv cA wss cA vz cv cdif com cdom
      wbr vz cv c0 wceq wo wa wa vy cv vz cv cin cA wss cA vy cv vz cv cin cdif
      com cdom wbr vy cv vz cv cin c0 wceq wo vy cv cA wss vy cv vz cv cin cA
      wss cA vy cv cdif com cdom wbr vy cv c0 wceq wo vz cv cA wss cA vz cv
      cdif com cdom wbr vz cv c0 wceq wo wa vy cv vz cv cA ssinss1 ad2antrr cA
      vy cv cdif com cdom wbr vy cv c0 wceq wo cA vz cv cdif com cdom wbr vz cv
      c0 wceq wo cA vy cv vz cv cin cdif com cdom wbr vy cv vz cv cin c0 wceq
      wo vy cv cA wss vz cv cA wss cA vy cv cdif com cdom wbr cA vz cv cdif com
      cdom wbr vy cv c0 wceq vz cv c0 wceq cA vy cv vz cv cin cdif com cdom wbr
      vy cv vz cv cin c0 wceq wo cA vy cv cdif com cdom wbr cA vz cv cdif com
      cdom wbr wa cA vy cv vz cv cin cdif com cdom wbr vy cv vz cv cin c0 wceq
      cA vy cv cdif com cdom wbr cA vz cv cdif com cdom wbr wa cA vy cv cdif cA
      vz cv cdif cun com cA vy cv vz cv cin cdif cdom cA vy cv cdif cA vz cv
      cdif unctb cA vy cv vz cv difindi syl5eqbr orcd vy cv c0 wceq vy cv vz cv
      cin c0 wceq cA vy cv vz cv cin cdif com cdom wbr vy cv c0 wceq vy cv vz
      cv cin c0 vz cv cin c0 vy cv c0 vz cv ineq1 c0 vz cv cin vz cv c0 cin c0
      c0 vz cv incom vz cv in0 eqtri syl6eq olcd vz cv c0 wceq vy cv vz cv cin
      c0 wceq cA vy cv vz cv cin cdif com cdom wbr vz cv c0 wceq vy cv vz cv
      cin vy cv c0 cin c0 vz cv c0 vy cv ineq2 vy cv in0 syl6eq olcd ccase2
      ad2ant2l jca vy cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq
      wo wa vx cab wcel vy cv cA wss cA vy cv cdif com cdom wbr vy cv c0 wceq
      wo wa vz cv vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa
      vx cab wcel vz cv cA wss cA vz cv cdif com cdom wbr vz cv c0 wceq wo wa
      vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vy cv cA wss
      cA vy cv cdif com cdom wbr vy cv c0 wceq wo wa vx vy cv vy visset vx cv
      vy cv wceq vx cv cA wss vy cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo cA vy cv cdif com cdom wbr vy cv c0 wceq wo vx cv vy cv cA sseq1
      vx cv vy cv wceq cA vx cv cdif com cdom wbr cA vy cv cdif com cdom wbr vx
      cv c0 wceq vy cv c0 wceq vx cv vy cv wceq cA vx cv cdif cA vy cv cdif com
      cdom vx cv vy cv cA difeq2 breq1d vx cv vy cv c0 eqeq1 orbi12d anbi12d
      elab vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0 wceq wo wa vz cv cA
      wss cA vz cv cdif com cdom wbr vz cv c0 wceq wo wa vx vz cv vz visset vx
      cv vz cv wceq vx cv cA wss vz cv cA wss cA vx cv cdif com cdom wbr vx cv
      c0 wceq wo cA vz cv cdif com cdom wbr vz cv c0 wceq wo vx cv vz cv cA
      sseq1 vx cv vz cv wceq cA vx cv cdif com cdom wbr cA vz cv cdif com cdom
      wbr vx cv c0 wceq vz cv c0 wceq vx cv vz cv wceq cA vx cv cdif cA vz cv
      cdif com cdom vx cv vz cv cA difeq2 breq1d vx cv vz cv c0 eqeq1 orbi12d
      anbi12d elab anbi12i vx cv cA wss cA vx cv cdif com cdom wbr vx cv c0
      wceq wo wa vy cv vz cv cin cA wss cA vy cv vz cv cin cdif com cdom wbr vy
      cv vz cv cin c0 wceq wo wa vx vy cv vz cv cin vy cv vz cv vy visset inex1
      vx cv vy cv vz cv cin wceq vx cv cA wss vy cv vz cv cin cA wss cA vx cv
      cdif com cdom wbr vx cv c0 wceq wo cA vy cv vz cv cin cdif com cdom wbr
      vy cv vz cv cin c0 wceq wo vx cv vy cv vz cv cin cA sseq1 vx cv vy cv vz
      cv cin wceq cA vx cv cdif com cdom wbr cA vy cv vz cv cin cdif com cdom
      wbr vx cv c0 wceq vy cv vz cv cin c0 wceq vx cv vy cv vz cv cin wceq cA
      vx cv cdif cA vy cv vz cv cin cdif com cdom vx cv vy cv vz cv cin cA
      difeq2 breq1d vx cv vy cv vz cv cin c0 eqeq1 orbi12d anbi12d elab 3imtr4i
      rgen2a mpbir2an $.
      $( [29-Aug-2006] $) $( [23-Aug-2006] $)

    $( The indiscrete topology on a set ` A ` expressed as a topological space.
       (Contributed by FL, 19-Jul-2006.) $)
    indistps $p |- <. A , { (/) , A } >. e. TopSp $=
      c0 cA cpr cuni c0 cA cpr cop cA c0 cA cpr cop ctps c0 cA cpr cuni cA c0
      cA cpr c0 cA cpr cuni c0 cA cun cA c0 cun cA c0 cA 0ex indistop.1 unipr
      c0 cA uncom cA un0 3eqtri opeq1i c0 cA cpr cuni c0 cA cpr cop ctps wcel
      c0 cA cpr ctop wcel cA indistop c0 cA cpr eltopsp mpbir eqeltrri $.
      $( [19-Jul-2006] $) $( [17-Jul-2006] $)

    $( The discrete topology on a set ` A ` expressed as a topological space.
       (Contributed by FL, 20-Aug-2006.) $)
    distps $p |- <. A , ~P A >. e. TopSp $=
      cA cpw cuni cA cpw cop cA cA cpw cop ctps cA cpw cuni cA cA cpw cA unipw
      opeq1i cA cpw cuni cA cpw cop ctps wcel cA cpw ctop wcel cA indistop.1
      distop cA cpw eltopsp mpbir eqeltrri $.
      $( [20-Aug-2006] $) $( [19-Aug-2006] $)
  $}

  ${
    $d x y z w v u t f $.
    $( A basis for the standard topology on the reals. $)
    retopbas $p |- ran (,) e. Bases $=
      cioo crn ctb wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw cioo
      crn wrex vz vx cv vy cv cin wral vy cioo crn wral vx cioo crn wral vz cv
      vw cv wcel vw cv vx cv vy cv cin wss wa vw cioo crn wrex vx vy vz cioo
      crn cioo crn vx cv vy cv cin vx cv cioo crn wcel vy cv cioo crn wcel vz
      cv vx cv vy cv cin wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vw
      cioo crn wrex vx cv vy cv cin cioo crn wcel vz cv vx cv vy cv cin wcel vx
      cv vy cv cin vx cv vy cv cin wss wa vz cv vw cv wcel vw cv vx cv vy cv
      cin wss wa vw cioo crn wrex vx cv cioo crn wcel vy cv cioo crn wcel wa vz
      cv vx cv vy cv cin wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss wa vz
      cv vx cv vy cv cin wcel vx cv vy cv cin vx cv vy cv cin wss wa vw vx cv
      vy cv cin cioo crn vw cv vx cv vy cv cin wceq vz cv vw cv wcel vz cv vx
      cv vy cv cin wcel vw cv vx cv vy cv cin wss vx cv vy cv cin vx cv vy cv
      cin wss vw cv vx cv vy cv cin vz cv eleq2 vw cv vx cv vy cv cin vx cv vy
      cv cin sseq1 anbi12d rcla4ev vz cv vw cv cioo co vx cv wceq vw cxr wrex
      vz cxr wrex vv cv vu cv cioo co vy cv wceq vu cxr wrex vv cxr wrex wa vt
      cv vf cv cioo co vx cv vy cv cin wceq vf cxr wrex vt cxr wrex vx cv cioo
      crn wcel vy cv cioo crn wcel wa vx cv vy cv cin cioo crn wcel vz cv vw cv
      cioo co vx cv wceq vw cxr wrex vz cxr wrex vv cv vu cv cioo co vy cv wceq
      vu cxr wrex vv cxr wrex vt cv vf cv cioo co vx cv vy cv cin wceq vf cxr
      wrex vt cxr wrex vz cv vw cv cioo co vx cv wceq vw cxr wrex vv cv vu cv
      cioo co vy cv wceq vu cxr wrex vv cxr wrex vt cv vf cv cioo co vx cv vy
      cv cin wceq vf cxr wrex vt cxr wrex wi vz cxr vz cv cxr wcel vz cv vw cv
      cioo co vx cv wceq vv cv vu cv cioo co vy cv wceq vu cxr wrex vv cxr wrex
      vt cv vf cv cioo co vx cv vy cv cin wceq vf cxr wrex vt cxr wrex wi vw
      cxr vz cv cxr wcel vw cv cxr wcel vz cv vw cv cioo co vx cv wceq vv cv vu
      cv cioo co vy cv wceq vu cxr wrex vv cxr wrex vt cv vf cv cioo co vx cv
      vy cv cin wceq vf cxr wrex vt cxr wrex wi vz cv cxr wcel vw cv cxr wcel
      wa vz cv vw cv cioo co vx cv wceq wa vv cv vu cv cioo co vy cv wceq vu
      cxr wrex vt cv vf cv cioo co vx cv vy cv cin wceq vf cxr wrex vt cxr wrex
      vv cxr vz cv cxr wcel vw cv cxr wcel wa vz cv vw cv cioo co vx cv wceq wa
      vv cv cxr wcel wa vv cv vu cv cioo co vy cv wceq vt cv vf cv cioo co vx
      cv vy cv cin wceq vf cxr wrex vt cxr wrex vu cxr vz cv cxr wcel vw cv cxr
      wcel wa vz cv vw cv cioo co vx cv wceq vv cv cxr wcel vu cv cxr wcel vv
      cv vu cv cioo co vy cv wceq vt cv vf cv cioo co vx cv vy cv cin wceq vf
      cxr wrex vt cxr wrex wi wi vv cv cxr wcel vu cv cxr wcel vz cv cxr wcel
      vw cv cxr wcel wa vz cv vw cv cioo co vx cv wceq vv cv vu cv cioo co vy
      cv wceq vt cv vf cv cioo co vx cv vy cv cin wceq vf cxr wrex vt cxr wrex
      wi vv cv cxr wcel vu cv cxr wcel vz cv cxr wcel vw cv cxr wcel wa vz cv
      vw cv cioo co vx cv wceq vv cv vu cv cioo co vy cv wceq vt cv vf cv cioo
      co vx cv vy cv cin wceq vf cxr wrex vt cxr wrex wi wi vv cv cxr wcel vu
      cv cxr wcel wa vz cv cxr wcel vw cv cxr wcel wa wa vz cv vw cv cioo co vx
      cv wceq vv cv vu cv cioo co vy cv wceq vt cv vf cv cioo co vx cv vy cv
      cin wceq vf cxr wrex vt cxr wrex vz cv vv cv cle wbr vv cv vz cv cif cxr
      wcel vw cv vu cv cle wbr vw cv vu cv cif cxr wcel vz cv vv cv cle wbr vv
      cv vz cv cif vw cv vu cv cle wbr vw cv vu cv cif cioo co vx cv vy cv cin
      wceq vt cv vf cv cioo co vx cv vy cv cin wceq vf cxr wrex vt cxr wrex vv
      cv cxr wcel vu cv cxr wcel wa vz cv cxr wcel vw cv cxr wcel wa wa vz cv
      vw cv cioo co vx cv wceq vv cv vu cv cioo co vy cv wceq wa wa vt cv vf cv
      cioo co vx cv vy cv cin wceq vz cv vv cv cle wbr vv cv vz cv cif vw cv vu
      cv cle wbr vw cv vu cv cif cioo co vx cv vy cv cin wceq vz cv vv cv cle
      wbr vv cv vz cv cif vf cv cioo co vx cv vy cv cin wceq vt vf vz cv vv cv
      cle wbr vv cv vz cv cif vw cv vu cv cle wbr vw cv vu cv cif cxr cxr vt cv
      vz cv vv cv cle wbr vv cv vz cv cif wceq vt cv vf cv cioo co vz cv vv cv
      cle wbr vv cv vz cv cif vf cv cioo co vx cv vy cv cin vt cv vz cv vv cv
      cle wbr vv cv vz cv cif vf cv cioo opreq1 eqeq1d vf cv vw cv vu cv cle
      wbr vw cv vu cv cif wceq vz cv vv cv cle wbr vv cv vz cv cif vf cv cioo
      co vz cv vv cv cle wbr vv cv vz cv cif vw cv vu cv cle wbr vw cv vu cv
      cif cioo co vx cv vy cv cin vf cv vw cv vu cv cle wbr vw cv vu cv cif vz
      cv vv cv cle wbr vv cv vz cv cif cioo opreq2 eqeq1d rcla42ev vv cv cxr
      wcel vu cv cxr wcel wa vz cv cxr wcel vw cv cxr wcel wa wa vz cv vv cv
      cle wbr vv cv vz cv cif cxr wcel vz cv vw cv cioo co vx cv wceq vv cv vu
      cv cioo co vy cv wceq wa vv cv cxr wcel vz cv cxr wcel vz cv vv cv cle
      wbr vv cv vz cv cif cxr wcel vu cv cxr wcel vw cv cxr wcel vz cv vv cv
      cle wbr vv cv vz cv cxr ifcl ad2ant2r adantr vv cv cxr wcel vu cv cxr
      wcel wa vz cv cxr wcel vw cv cxr wcel wa wa vw cv vu cv cle wbr vw cv vu
      cv cif cxr wcel vz cv vw cv cioo co vx cv wceq vv cv vu cv cioo co vy cv
      wceq wa vu cv cxr wcel vw cv cxr wcel vw cv vu cv cle wbr vw cv vu cv cif
      cxr wcel vv cv cxr wcel vz cv cxr wcel vw cv cxr wcel vu cv cxr wcel vw
      cv vu cv cle wbr vw cv vu cv cif cxr wcel vw cv vu cv cle wbr vw cv vu cv
      cxr ifcl ancoms ad2ant2l adantr vv cv cxr wcel vu cv cxr wcel wa vz cv
      cxr wcel vw cv cxr wcel wa wa vz cv vw cv cioo co vx cv wceq vv cv vu cv
      cioo co vy cv wceq wa vz cv vv cv cle wbr vv cv vz cv cif vw cv vu cv cle
      wbr vw cv vu cv cif cioo co vz cv vw cv cioo co vv cv vu cv cioo co cin
      vx cv vy cv cin vz cv cxr wcel vw cv cxr wcel wa vv cv cxr wcel vu cv cxr
      wcel wa vz cv vw cv cioo co vv cv vu cv cioo co cin vz cv vv cv cle wbr
      vv cv vz cv cif vw cv vu cv cle wbr vw cv vu cv cif cioo co wceq vz cv vw
      cv vv cv vu cv iooin ancoms vz cv vw cv cioo co vx cv vv cv vu cv cioo co
      vy cv ineq12 sylan9req syl3anc exp32 exp31 com4t imp31 r19.23adv
      r19.23adva exp31 r19.23adv r19.23aiv imp cioo cxr cxr cxp wfn vx cv cioo
      crn wcel vy cv cioo crn wcel wa vz cv vw cv cioo co vx cv wceq vw cxr
      wrex vz cxr wrex vv cv vu cv cioo co vy cv wceq vu cxr wrex vv cxr wrex
      wa wb cxr cxr cxp cr cpw cioo wf cioo cxr cxr cxp wfn ioof cxr cxr cxp cr
      cpw cioo ffn ax-mp cioo cxr cxr cxp wfn vx cv cioo crn wcel vz cv vw cv
      cioo co vx cv wceq vw cxr wrex vz cxr wrex vy cv cioo crn wcel vv cv vu
      cv cioo co vy cv wceq vu cxr wrex vv cxr wrex vz vw cxr cxr vx cv cioo
      oprvelrn vv vu cxr cxr vy cv cioo oprvelrn anbi12d ax-mp cioo cxr cxr cxp
      wfn vx cv vy cv cin cioo crn wcel vt cv vf cv cioo co vx cv vy cv cin
      wceq vf cxr wrex vt cxr wrex wb cxr cxr cxp cr cpw cioo wf cioo cxr cxr
      cxp wfn ioof cxr cxr cxp cr cpw cioo ffn ax-mp vt vf cxr cxr vx cv vy cv
      cin cioo oprvelrn ax-mp 3imtr4i vz cv vx cv vy cv cin wcel vx cv vy cv
      cin vx cv vy cv cin wss vx cv vy cv cin ssid jctr syl2an 3impa rgen3 cioo
      crn cvv wcel cioo crn ctb wcel vz cv vw cv wcel vw cv vx cv vy cv cin wss
      wa vw cioo crn wrex vz vx cv vy cv cin wral vy cioo crn wral vx cioo crn
      wral wb cioo iooex rnex vx vy vz vw cioo crn cvv isbasis2g ax-mp mpbir $.
      $( [13-Feb-2007] $) $( [6-Feb-2007] $)
  $}

  $( The standard topology on the reals.  (Contributed by FL, 4-Jun-2007.) $)
  retop $p |- ( topGen ` ran (,) ) e. Top $=
    cioo crn ctb wcel cioo crn ctg cfv ctop wcel retopbas cioo crn tgcl ax-mp
    $.
    $( [22-Jun-2007] $) $( [29-May-2007] $)

  $( The underlying set of the standard topology on the reals is the reals.
     (Contributed by FL, 4-Jun-2007.) $)
  uniretop $p |- U. ( topGen ` ran (,) ) = RR $=
    cioo crn ctg cfv cuni cioo crn cuni cr cioo crn ctb wcel cioo crn ctg cfv
    cuni cioo crn cuni wceq retopbas cioo crn unitg ax-mp unirnioo eqtri $.
    $( [22-Jun-2007] $) $( [29-May-2007] $)

  $( The standard topological space on the reals. $)
  retps $p |- <. RR , ( topGen ` ran (,) ) >. e. TopSp $=
    cr cioo crn ctg cfv cop ctps wcel cioo crn ctg cfv ctop wcel cr cioo crn
    ctg cfv cuni wceq cr cioo crn ctg cfv istps retop cioo crn ctg cfv cuni cr
    uniretop eqcomi mpbir2an $.
    $( [15-Feb-2007] $) $( [10-Feb-2007] $)

  $( Open intervals are open sets of the standard topology on the reals .
     (Contributed by FL, 18-Jun-2007.) $)
  iooretop $p |- ( A (,) B ) e. ( topGen ` ran (,) ) $=
    cA cxr wcel cB cxr wcel wa cA cB cioo co cioo crn ctg cfv wcel cA cxr wcel
    cB cxr wcel wa cioo crn cioo crn ctg cfv cA cB cioo co cioo crn cioo crn
    ctg cfv wss cA cxr wcel cB cxr wcel wa cioo crn ctb wcel cioo crn cioo crn
    ctg cfv wss retopbas cioo crn bastg ax-mp a1i cioo cxr cxr cxp wfn cA cxr
    wcel cB cxr wcel cA cB cioo co cioo crn wcel cxr cxr cxp cr cpw cioo wf
    cioo cxr cxr cxp wfn ioof cxr cxr cxp cr cpw cioo ffn ax-mp cxr cxr cA cB
    cioo fnoprvrn mp3an1 sseldd cA cxr wcel cB cxr wcel wa wn cA cB cioo co c0
    cioo crn ctg cfv cA cB ndmioo cioo crn ctg cfv ctop wcel c0 cioo crn ctg
    cfv wcel retop cioo crn ctg cfv 0opn ax-mp syl6eqel pm2.61i $.
    $( [22-Jun-2007] $) $( [21-Jun-2007] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Product topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c tX $.

  $( Extend class notation with the binary topological product operation. $)
  ctx $a class tX $.

  ${
    $d r s t u v z $.
    $( Define the binary topological product, which is homeomorphic to the
       general topological product over a two element set, but is more
       convenient to use.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    df-tx $a |- tX = { <. <. r , s >. , t >. | ( ( r e. Top /\ s e. Top ) /\
             t = ( topGen ` { z | E. u e. r E. v e. s z = ( u X. v ) } ) ) } $.
  $}

  ${
    $d R r s t u v z $. $d S r s t u v z $.
    $( Value of the binary topological product operation.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    txval $p |- ( ( R e. Top /\ S e. Top ) -> ( R tX S ) =
                  ( topGen ` { z | E. u e. R E. v e. S z = ( u X. v ) } ) ) $=
      vr vs vt cR cS ctop ctop vz cv vu cv vv cv cxp wceq vv vs cv wrex vu vr
      cv wrex vz cab ctg cfv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vz cab ctg cfv ctx vz cv vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz
      cab ctg cfv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg
      fvex vr cv cR wceq vz cv vu cv vv cv cxp wceq vv vs cv wrex vu vr cv wrex
      vz cab vz cv vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz cab ctg vr
      cv cR wceq vz cv vu cv vv cv cxp wceq vv vs cv wrex vu vr cv wrex vz cv
      vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz vz cv vu cv vv cv cxp
      wceq vv vs cv wrex vu vr cv cR rexeq1 abbidv fveq2d vs cv cS wceq vz cv
      vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz cab vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab ctg vs cv cS wceq vz cv vu cv vv cv
      cxp wceq vv vs cv wrex vu cR wrex vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz vs cv cS wceq vz cv vu cv vv cv cxp wceq vv vs cv wrex vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR vz cv vu cv vv cv cxp wceq vv vs
      cv cS rexeq1 rexbidv abbidv fveq2d vz vv vu vt vs vr df-tx oprabval2 $.
      $( [18-Apr-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d R a b c d r s u v x y z $.  $d S a b c d r s u v x y z $.
    $( A lemma for theorems about product topologies.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    txbas $p |- ( ( R e. Top /\ S e. Top ) ->
                  { z | E. u e. R E. v e. S z = ( u X. v ) } e. Bases ) $=
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab cvv wcel vx cv vy
      cv cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel vy vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wral vx vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab wral vz cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vz cab ctb wcel cR ctop wcel cS ctop wcel wa
      vx vy vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab cvv fiinbas
      vz cv vu cv vv cv cxp wceq vv vs cv wrex vu vr cv wrex vz cab cvv wcel vz
      cv vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz cab cvv wcel vz cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab cvv wcel vr vs cR cS ctop
      ctop vr cv cR wceq vz cv vu cv vv cv cxp wceq vv vs cv wrex vu vr cv wrex
      vz cab vz cv vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz cab cvv vr
      cv cR wceq vz cv vu cv vv cv cxp wceq vv vs cv wrex vu vr cv wrex vz cv
      vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz vz cv vu cv vv cv cxp
      wceq vv vs cv wrex vu vr cv cR rexeq1 abbidv eleq1d vs cv cS wceq vz cv
      vu cv vv cv cxp wceq vv vs cv wrex vu cR wrex vz cab vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab cvv vs cv cS wceq vz cv vu cv vv cv
      cxp wceq vv vs cv wrex vu cR wrex vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz vs cv cS wceq vz cv vu cv vv cv cxp wceq vv vs cv wrex vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR vz cv vu cv vv cv cxp wceq vv vs
      cv cS rexeq1 rexbidv abbidv eleq1d vz cv vu cv vv cv cxp wceq vv vs cv
      wrex vu vz vr cv vr visset vv vz vs cv vu cv vv cv cxp vs visset abrexex
      abrexex2 vtocl2g cR ctop wcel cS ctop wcel wa vx cv vy cv cin vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel vx vy vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab cR ctop wcel cS ctop wcel wa vx cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vy cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex wa vx cv vy cv cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vz cab wcel vx cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      wcel vy cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel
      wa cR ctop wcel cS ctop wcel wa vx cv vu cv vv cv cxp wceq vv cS wrex vu
      cR wrex vy cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv vy cv cin
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel cR ctop wcel
      cS ctop wcel wa vx cv va cv vb cv cxp wceq vb cS wrex va cR wrex vy cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv vy cv cin vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab wcel wi vx cv vu cv vv cv cxp wceq
      vv cS wrex vu cR wrex cR ctop wcel cS ctop wcel wa vx cv va cv vb cv cxp
      wceq vy cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv vy cv cin vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel wi va vb cR cS
      cR ctop wcel cS ctop wcel wa vy cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vx cv va cv vb cv cxp wceq va cv cR wcel vb cv cS wcel wa vx cv vy
      cv cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel cR
      ctop wcel cS ctop wcel wa vy cv vc cv vd cv cxp wceq vd cS wrex vc cR
      wrex vx cv va cv vb cv cxp wceq va cv cR wcel vb cv cS wcel wa vx cv vy
      cv cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel wi wi
      vy cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex cR ctop wcel cS ctop
      wcel wa vy cv vc cv vd cv cxp wceq vx cv va cv vb cv cxp wceq va cv cR
      wcel vb cv cS wcel wa vx cv vy cv cin vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab wcel wi wi vc vd cR cS cR ctop wcel cS ctop wcel
      wa vc cv cR wcel vd cv cS wcel wa vy cv vc cv vd cv cxp wceq vx cv va cv
      vb cv cxp wceq va cv cR wcel vb cv cS wcel wa vx cv vy cv cin vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel wi wi wi cR ctop wcel cS
      ctop wcel wa vc cv cR wcel vd cv cS wcel wa wa va cv cR wcel vb cv cS
      wcel wa vx cv va cv vb cv cxp wceq vy cv vc cv vd cv cxp wceq vx cv vy cv
      cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel cR ctop
      wcel cS ctop wcel wa vc cv cR wcel vd cv cS wcel wa wa va cv cR wcel vb
      cv cS wcel wa vx cv va cv vb cv cxp wceq vy cv vc cv vd cv cxp wceq vx cv
      vy cv cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel wi
      wi cR ctop wcel cS ctop wcel wa vc cv cR wcel vd cv cS wcel wa wa va cv
      cR wcel vb cv cS wcel wa wa vx cv va cv vb cv cxp wceq vx cv vc cv vd cv
      cxp cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel vy
      cv vc cv vd cv cxp wceq vx cv vy cv cin vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab wcel wi vx cv va cv vb cv cxp wceq vx cv vc cv vd
      cv cxp cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel
      va cv vb cv cxp vc cv vd cv cxp cin vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz cab wcel cR ctop wcel cS ctop wcel wa vc cv cR wcel vd cv
      cS wcel wa wa va cv cR wcel vb cv cS wcel wa wa vx cv va cv vb cv cxp
      wceq vx cv vc cv vd cv cxp cin va cv vb cv cxp vc cv vd cv cxp cin vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab vx cv va cv vb cv cxp
      vc cv vd cv cxp ineq1 eleq1d cR ctop wcel cS ctop wcel wa vc cv cR wcel
      vd cv cS wcel wa wa va cv cR wcel vb cv cS wcel wa wa va cv vb cv cxp vc
      cv vd cv cxp cin vu cv vv cv cxp wceq vv cS wrex vu cR wrex va cv vb cv
      cxp vc cv vd cv cxp cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vz cab wcel va cv vc cv cin cR wcel vb cv vd cv cin cS wcel va cv vb cv
      cxp vc cv vd cv cxp cin va cv vc cv cin vb cv vd cv cin cxp wceq va cv vb
      cv cxp vc cv vd cv cxp cin vu cv vv cv cxp wceq vv cS wrex vu cR wrex cR
      ctop wcel cS ctop wcel wa vc cv cR wcel vd cv cS wcel wa wa va cv cR wcel
      vb cv cS wcel wa wa va cv vb cv cxp vc cv vd cv cxp cin vu cv vv cv cxp
      wceq va cv vb cv cxp vc cv vd cv cxp cin va cv vc cv cin vb cv vd cv cin
      cxp wceq va cv vb cv cxp vc cv vd cv cxp cin va cv vc cv cin vv cv cxp
      wceq vu vv va cv vc cv cin vb cv vd cv cin cR cS vu cv va cv vc cv cin
      wceq vu cv vv cv cxp va cv vc cv cin vv cv cxp va cv vb cv cxp vc cv vd
      cv cxp cin vu cv va cv vc cv cin vv cv xpeq1 eqeq2d vv cv vb cv vd cv cin
      wceq va cv vc cv cin vv cv cxp va cv vc cv cin vb cv vd cv cin cxp va cv
      vb cv cxp vc cv vd cv cxp cin vv cv vb cv vd cv cin va cv vc cv cin xpeq2
      eqeq2d rcla42ev cR ctop wcel cS ctop wcel wa vc cv cR wcel vd cv cS wcel
      wa wa va cv cR wcel va cv vc cv cin cR wcel vb cv cS wcel cR ctop wcel cS
      ctop wcel wa vc cv cR wcel va cv cR wcel va cv vc cv cin cR wcel vd cv cS
      wcel cR ctop wcel cS ctop wcel wa vc cv cR wcel va cv cR wcel va cv vc cv
      cin cR wcel cR ctop wcel vc cv cR wcel va cv cR wcel wa va cv vc cv cin
      cR wcel cS ctop wcel cR ctop wcel va cv cR wcel vc cv cR wcel va cv vc cv
      cin cR wcel cR ctop wcel va cv cR wcel vc cv cR wcel va cv vc cv cin cR
      wcel va cv vc cv cR inopn 3expb ancom2s adantlr anassrs adantlrr adantrr
      cR ctop wcel cS ctop wcel wa vc cv cR wcel vd cv cS wcel wa wa vb cv cS
      wcel vb cv vd cv cin cS wcel va cv cR wcel cR ctop wcel cS ctop wcel wa
      vd cv cS wcel vb cv cS wcel vb cv vd cv cin cS wcel vc cv cR wcel cR ctop
      wcel cS ctop wcel wa vd cv cS wcel vb cv cS wcel vb cv vd cv cin cS wcel
      cS ctop wcel vd cv cS wcel vb cv cS wcel wa vb cv vd cv cin cS wcel cR
      ctop wcel cS ctop wcel vb cv cS wcel vd cv cS wcel vb cv vd cv cin cS
      wcel cS ctop wcel vb cv cS wcel vd cv cS wcel vb cv vd cv cin cS wcel vb
      cv vd cv cS inopn 3expb ancom2s adantll anassrs adantlrl adantrl va cv vb
      cv cxp vc cv vd cv cxp cin va cv vc cv cin vb cv vd cv cin cxp wceq cR
      ctop wcel cS ctop wcel wa vc cv cR wcel vd cv cS wcel wa wa va cv cR wcel
      vb cv cS wcel wa wa va cv vb cv vc cv vd cv inxp a1i syl3anc vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex va cv vb cv cxp vc cv vd cv cxp cin
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz va cv vb cv cxp vc cv vd cv
      cxp cin va cv vb cv cxp vc cv vd cv cxp va cv vb cv va visset vb visset
      xpex inex1 vz cv va cv vb cv cxp vc cv vd cv cxp cin wceq vz cv vu cv vv
      cv cxp wceq va cv vb cv cxp vc cv vd cv cxp cin vu cv vv cv cxp wceq vu
      vv cR cS vz cv va cv vb cv cxp vc cv vd cv cxp cin vu cv vv cv cxp eqeq1
      2rexbidv elab sylibr syl5cbir vy cv vc cv vd cv cxp wceq vx cv vy cv cin
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel vx cv vc cv
      vd cv cxp cin vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      wcel vy cv vc cv vd cv cxp wceq vx cv vy cv cin vx cv vc cv vd cv cxp cin
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab vy cv vc cv vd cv
      cxp vx cv ineq2 eleq1d biimprcd syl6 ex com24 ex r19.23advv vy cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vy cv vu cv vd cv cxp wceq vd cS
      wrex vu cR wrex vy cv vc cv vd cv cxp wceq vd cS wrex vc cR wrex vy cv vu
      cv vv cv cxp wceq vv cS wrex vy cv vu cv vd cv cxp wceq vd cS wrex vu cR
      vy cv vu cv vv cv cxp wceq vy cv vu cv vd cv cxp wceq vv vd cS vv cv vd
      cv wceq vu cv vv cv cxp vu cv vd cv cxp vy cv vv cv vd cv vu cv xpeq2
      eqeq2d cbvrexv rexbii vy cv vu cv vd cv cxp wceq vd cS wrex vy cv vc cv
      vd cv cxp wceq vd cS wrex vu vc cR vu cv vc cv wceq vy cv vu cv vd cv cxp
      wceq vy cv vc cv vd cv cxp wceq vd cS vu cv vc cv wceq vu cv vd cv cxp vc
      cv vd cv cxp vy cv vu cv vc cv vd cv xpeq1 eqeq2d rexbidv cbvrexv bitri
      syl5ib com24 r19.23advv vx cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vx cv vu cv vb cv cxp wceq vb cS wrex vu cR wrex vx cv va cv vb cv cxp
      wceq vb cS wrex va cR wrex vx cv vu cv vv cv cxp wceq vv cS wrex vx cv vu
      cv vb cv cxp wceq vb cS wrex vu cR vx cv vu cv vv cv cxp wceq vx cv vu cv
      vb cv cxp wceq vv vb cS vv cv vb cv wceq vu cv vv cv cxp vu cv vb cv cxp
      vx cv vv cv vb cv vu cv xpeq2 eqeq2d cbvrexv rexbii vx cv vu cv vb cv cxp
      wceq vb cS wrex vx cv va cv vb cv cxp wceq vb cS wrex vu va cR vu cv va
      cv wceq vx cv vu cv vb cv cxp wceq vx cv va cv vb cv cxp wceq vb cS vu cv
      va cv wceq vu cv vb cv cxp va cv vb cv cxp vx cv vu cv va cv vb cv xpeq1
      eqeq2d rexbidv cbvrexv bitri syl5ib imp3a vx cv vz cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vz cab wcel vx cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vy cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab wcel vy cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vx cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz vx cv vx visset vz cv vx cv wceq vz cv vu cv vv cv cxp wceq
      vx cv vu cv vv cv cxp wceq vu vv cR cS vz cv vx cv vu cv vv cv cxp eqeq1
      2rexbidv elab vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vy cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vz vy cv vy visset vz cv vy cv
      wceq vz cv vu cv vv cv cxp wceq vy cv vu cv vv cv cxp wceq vu vv cR cS vz
      cv vy cv vu cv vv cv cxp eqeq1 2rexbidv elab anbi12i syl5ib r19.21aivv
      sylanc $.
      $( [18-Apr-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d R u v z $.  $d S u v z $.  $d T u v z $.
    txtop.1 $e |- T = ( R tX S ) $.
    $( The product of two topologies is a topology.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    txtop $p |- ( ( R e. Top /\ S e. Top ) -> T e. Top ) $=
      cR ctop wcel cS ctop wcel wa cT vz cv vu cv vv cv cxp wceq vv cS wrex vu
      cR wrex vz cab ctg cfv ctop cR ctop wcel cS ctop wcel wa cR cS ctx co vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv cT vz vv vu
      cR cS txval txtop.1 syl5eq cR ctop wcel cS ctop wcel wa vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab ctb wcel vz cv vu cv vv cv cxp wceq
      vv cS wrex vu cR wrex vz cab ctg cfv ctop wcel vz vv vu cR cS txbas vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab tgcl syl eqeltrd $.
      $( [18-Apr-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d R u v x z $.  $d S u v x z $.  $d T u v x z $.
    $d X u v x z $.  $d Y u v x z $.
    txuni.1 $e |- T = ( R tX S ) $.
    txuni.2 $e |- X = U. R $.
    txuni.3 $e |- Y = U. S $.
    $( The underlying set of the product of two topologies.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    txuni $p |- ( ( R e. Top /\ S e. Top ) -> U. T = ( X X. Y ) ) $=
      cR ctop wcel cS ctop wcel wa cT cuni vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab ctg cfv cuni vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz cab cuni cX cY cxp cR ctop wcel cS ctop wcel wa cT vz cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv cR ctop wcel cS
      ctop wcel wa cR cS ctx co vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab ctg cfv cT vz vv vu cR cS txval txuni.1 syl5eq unieqd cR ctop
      wcel cS ctop wcel wa vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab ctb wcel vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg
      cfv cuni vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab cuni
      wceq vz vv vu cR cS txbas vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab unitg syl cR ctop wcel cS ctop wcel wa vz cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vz cab cuni cX cY cxp cR ctop wcel cS ctop
      wcel wa vx cv cX cY cxp wss vx vz cv vu cv vv cv cxp wceq vv cS wrex vu
      cR wrex vz cab wral vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab cuni cX cY cxp wss cR ctop wcel cS ctop wcel wa vx cv cX cY cxp wss
      vx vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab cR ctop wcel
      cS ctop wcel wa vx cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv cX
      cY cxp wss vx cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      wcel cR ctop wcel cS ctop wcel wa vx cv vu cv vv cv cxp wceq vx cv cX cY
      cxp wss vu vv cR cS cR ctop wcel cS ctop wcel wa vu cv cR wcel vv cv cS
      wcel wa vu cv vv cv cxp cX cY cxp wss vx cv vu cv vv cv cxp wceq vx cv cX
      cY cxp wss wi cR ctop wcel cS ctop wcel wa vu cv cR wcel vv cv cS wcel wa
      vu cv vv cv cxp cX cY cxp wss cR ctop wcel vu cv cR wcel cS ctop wcel vv
      cv cS wcel vu cv vv cv cxp cX cY cxp wss vu cv cX wss vv cv cY wss vu cv
      vv cv cxp cX cY cxp wss cR ctop wcel vu cv cR wcel wa cS ctop wcel vv cv
      cS wcel wa vu cv cX vv cv cY ssxp vu cv cR cX txuni.2 eltopss vv cv cS cY
      txuni.3 eltopss syl2an an4s ex vx cv vu cv vv cv cxp wceq vx cv cX cY cxp
      wss vu cv vv cv cxp cX cY cxp wss vx cv vu cv vv cv cxp cX cY cxp sseq1
      biimprcd syl6 r19.23advv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vx cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz vx cv vx visset vz cv
      vx cv wceq vz cv vu cv vv cv cxp wceq vx cv vu cv vv cv cxp wceq vu vv cR
      cS vz cv vx cv vu cv vv cv cxp eqeq1 2rexbidv elab syl5ib r19.21aiv vx vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab cX cY cxp unissb
      sylibr cR ctop wcel cS ctop wcel wa cX cY cxp vz cv vu cv vv cv cxp wceq
      vv cS wrex vu cR wrex vz cab wcel cX cY cxp vz cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vz cab cuni wss cR ctop wcel cS ctop wcel wa cX cY cxp
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel cX cY cxp vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex cX cR wcel cY cS wcel cX cY cxp
      cX cY cxp wceq cX cY cxp vu cv vv cv cxp wceq vv cS wrex vu cR wrex cR
      ctop wcel cS ctop wcel wa cX cY cxp vu cv vv cv cxp wceq cX cY cxp cX cY
      cxp wceq cX cY cxp cX vv cv cxp wceq vu vv cX cY cR cS vu cv cX wceq vu
      cv vv cv cxp cX vv cv cxp cX cY cxp vu cv cX vv cv xpeq1 eqeq2d vv cv cY
      wceq cX vv cv cxp cX cY cxp cX cY cxp vv cv cY cX xpeq2 eqeq2d rcla42ev
      cR ctop wcel cX cR wcel cS ctop wcel cR cX txuni.2 topopn adantr cS ctop
      wcel cY cS wcel cR ctop wcel cS cY txuni.3 topopn adantl cR ctop wcel cS
      ctop wcel wa cX cY cxp eqidd syl3anc cR ctop wcel cS ctop wcel wa cX cY
      cxp cvv wcel cX cY cxp vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vz cab wcel cX cY cxp vu cv vv cv cxp wceq vv cS wrex vu cR wrex wb cX
      cvv wcel cY cvv wcel cX cY cxp cvv wcel cR ctop wcel cS ctop wcel cX cY
      cvv cvv xpexg cR ctop wcel cR cuni cvv cX cR ctop uniexg txuni.2 syl5eqel
      cS ctop wcel cS cuni cvv cY cS ctop uniexg txuni.3 syl5eqel syl2an vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex cX cY cxp vu cv vv cv cxp wceq
      vv cS wrex vu cR wrex vz cX cY cxp cvv vz cv cX cY cxp wceq vz cv vu cv
      vv cv cxp wceq cX cY cxp vu cv vv cv cxp wceq vu vv cR cS vz cv cX cY cxp
      vu cv vv cv cxp eqeq1 2rexbidv elabg syl mpbird cX cY cxp vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab elssuni syl eqssd 3eqtrd $.
      $( [18-Apr-2010] $)  $( [2-Sep-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Closure and interior
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c int $.
  $c cls $.
  $c Clsd $.

  $( Extend class notation with the set of closed sets of a topology. $)
  ccld $a class Clsd $.

  $( Extend class notation with interior of a subset of a topology base set. $)
  cnt $a class int $.

  $( Extend class notation with closure of a subset of a topology base set. $)
  ccl $a class cls $.

  ${
    $d v w x y z $.
    $( Define a function on topologies whose value is the set of closed
       sets of the topology. $)
    df-cld $a |- Clsd = { <. z , w >. | ( z e. Top /\ w = { x |
                  ( x C_ U. z /\ ( U. z \ x ) e. z ) } ) } $.

    $( Define a function on topologies whose value is the interior function
       on the subsets of the base set.  See ~ ntrval . $)
    df-ntr $a |- int = { <. z , w >. | ( z e. Top /\ w = { <. x , y >. |
                 ( x C_ U. z /\ y = U. { v e. z | v C_ x } ) } ) } $.

    $( Define a function on topologies whose value is the closure function
       on the subsets of the base set.  See ~ clsval . $)
    df-cls $a |- cls = { <. z , w >. | ( z e. Top /\ w = { <. x , y >. |
               ( x C_ U. z /\ y = |^| { v e. ( Clsd ` z ) | x C_ v } ) } ) } $.
  $}

  ${
    $d v w x y z J $.  $d w x y z X $.
    cldval.1 $e |- X = U. J $.
    $( The set of closed sets of a topology.  (Note that the set of open sets
       is just the topology itself, so we don't have a separate definition.) $)
    cldval $p |- ( J e. Top ->
               ( Clsd ` J ) = { x | ( x C_ X /\ ( X \ x ) e. J ) } ) $=
      cJ ctop wcel vx cv cX wss cX vx cv cdif cJ wcel wa vx cab cvv wcel cJ
      ccld cfv vx cv cX wss cX vx cv cdif cJ wcel wa vx cab wceq cJ ctop wcel
      cX cvv wcel vx cv cX wss cX vx cv cdif cJ wcel wa vx cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg cldval.1 syl5eqel cX vx cv cdif cJ
      wcel vx cX cvv abssexg syl vz vw cJ vx cv vz cv cuni wss vz cv cuni vx cv
      cdif vz cv wcel wa vx cab vx cv cX wss cX vx cv cdif cJ wcel wa vx cab
      ctop cvv ccld vz cv cJ wceq vx cv vz cv cuni wss vz cv cuni vx cv cdif vz
      cv wcel wa vx cv cX wss cX vx cv cdif cJ wcel wa vx vz cv cJ wceq vx cv
      vz cv cuni wss vx cv cX wss vz cv cuni vx cv cdif vz cv wcel cX vx cv
      cdif cJ wcel vz cv cJ wceq vz cv cuni cX vx cv vz cv cJ wceq vz cv cuni
      cJ cuni cX vz cv cJ unieq cldval.1 syl6eqr sseq2d vz cv cJ wceq vz cv
      cuni vx cv cdif cX vx cv cdif vz cv cJ vz cv cJ wceq vz cv cuni cX vx cv
      vz cv cJ wceq vz cv cuni cJ cuni cX vz cv cJ unieq cldval.1 syl6eqr
      difeq1d vz cv cJ wceq id eleq12d anbi12d abbidv vx vz vw df-cld fvopab4g
      mpdan $.
      $( [4-Oct-2006] $) $( [2-Oct-2006] $)

    $( The interior function on the subsets of a topology's base set. $)
    ntrfval $p |- ( J e. Top -> ( int ` J ) =  { <. x , y >. | ( x C_ X /\
                     y = U. { v e. J | v C_ x } ) } ) $=
      cJ ctop wcel vx cv cX wss vy cv vv cv vx cv wss vv cJ crab cuni wceq wa
      vx vy copab cvv wcel cJ cnt cfv vx cv cX wss vy cv vv cv vx cv wss vv cJ
      crab cuni wceq wa vx vy copab wceq cJ ctop wcel vx cv cX cpw wcel vy cv
      vv cv vx cv wss vv cJ crab cuni wceq wa vx vy copab cvv vx cv cX wss vy
      cv vv cv vx cv wss vv cJ crab cuni wceq wa vx vy copab cJ ctop wcel cX
      cvv wcel cX cpw cvv wcel vx cv cX cpw wcel vy cv vv cv vx cv wss vv cJ
      crab cuni wceq wa vx vy copab cvv wcel cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg cldval.1 syl5eqel cX cvv pwexg vx vy cX cpw vv cv vx cv wss
      vv cJ crab cuni cvv opabex2g 3syl vx cv cX cpw wcel vy cv vv cv vx cv wss
      vv cJ crab cuni wceq wa vx cv cX wss vy cv vv cv vx cv wss vv cJ crab
      cuni wceq wa vx vy vx cv cX cpw wcel vx cv cX wss vy cv vv cv vx cv wss
      vv cJ crab cuni wceq vx cv cX vx visset elpw anbi1i opabbii syl5eqelr vz
      vw cJ vx cv vz cv cuni wss vy cv vv cv vx cv wss vv vz cv crab cuni wceq
      wa vx vy copab vx cv cX wss vy cv vv cv vx cv wss vv cJ crab cuni wceq wa
      vx vy copab ctop cvv cnt vz cv cJ wceq vx cv vz cv cuni wss vy cv vv cv
      vx cv wss vv vz cv crab cuni wceq wa vx cv cX wss vy cv vv cv vx cv wss
      vv cJ crab cuni wceq wa vx vy vz cv cJ wceq vx cv vz cv cuni wss vx cv cX
      wss vy cv vv cv vx cv wss vv vz cv crab cuni wceq vy cv vv cv vx cv wss
      vv cJ crab cuni wceq vz cv cJ wceq vz cv cuni cX vx cv vz cv cJ wceq vz
      cv cuni cJ cuni cX vz cv cJ unieq cldval.1 syl6eqr sseq2d vz cv cJ wceq
      vv cv vx cv wss vv vz cv crab cuni vv cv vx cv wss vv cJ crab cuni vy cv
      vz cv cJ wceq vv cv vx cv wss vv vz cv crab vv cv vx cv wss vv cJ crab vv
      cv vx cv wss vv vz cv cJ rabeq unieqd eqeq2d anbi12d opabbidv vx vy vz vw
      vv df-ntr fvopab4g mpdan $.
      $( [12-Sep-2006] $) $( [10-Sep-2006] $)

    $( The closure function on the subsets of a topology's base set. $)
    clsfval $p |- ( J e. Top -> ( cls ` J ) =  { <. x , y >. | ( x C_ X /\
                     y = |^| { v e. ( Clsd ` J ) | x C_ v } ) } ) $=
      cJ ctop wcel vx cv cX wss vy cv vx cv vv cv wss vv cJ ccld cfv crab cint
      wceq wa vx vy copab cvv wcel cJ ccl cfv vx cv cX wss vy cv vx cv vv cv
      wss vv cJ ccld cfv crab cint wceq wa vx vy copab wceq cJ ctop wcel vx cv
      cX cpw wcel vy cv vx cv vv cv wss vv cJ ccld cfv crab cint wceq wa vx vy
      copab cvv vx cv cX wss vy cv vx cv vv cv wss vv cJ ccld cfv crab cint
      wceq wa vx vy copab cJ ctop wcel cX cvv wcel cX cpw cvv wcel vx cv cX cpw
      wcel vy cv vx cv vv cv wss vv cJ ccld cfv crab cint wceq wa vx vy copab
      cvv wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg cldval.1 syl5eqel cX
      cvv pwexg vx vy cX cpw vx cv vv cv wss vv cJ ccld cfv crab cint cvv
      opabex2g 3syl vx cv cX cpw wcel vy cv vx cv vv cv wss vv cJ ccld cfv crab
      cint wceq wa vx cv cX wss vy cv vx cv vv cv wss vv cJ ccld cfv crab cint
      wceq wa vx vy vx cv cX cpw wcel vx cv cX wss vy cv vx cv vv cv wss vv cJ
      ccld cfv crab cint wceq vx cv cX vx visset elpw anbi1i opabbii syl5eqelr
      vz vw cJ vx cv vz cv cuni wss vy cv vx cv vv cv wss vv vz cv ccld cfv
      crab cint wceq wa vx vy copab vx cv cX wss vy cv vx cv vv cv wss vv cJ
      ccld cfv crab cint wceq wa vx vy copab ctop cvv ccl vz cv cJ wceq vx cv
      vz cv cuni wss vy cv vx cv vv cv wss vv vz cv ccld cfv crab cint wceq wa
      vx cv cX wss vy cv vx cv vv cv wss vv cJ ccld cfv crab cint wceq wa vx vy
      vz cv cJ wceq vx cv vz cv cuni wss vx cv cX wss vy cv vx cv vv cv wss vv
      vz cv ccld cfv crab cint wceq vy cv vx cv vv cv wss vv cJ ccld cfv crab
      cint wceq vz cv cJ wceq vz cv cuni cX vx cv vz cv cJ wceq vz cv cuni cJ
      cuni cX vz cv cJ unieq cldval.1 syl6eqr sseq2d vz cv cJ wceq vx cv vv cv
      wss vv vz cv ccld cfv crab cint vx cv vv cv wss vv cJ ccld cfv crab cint
      vy cv vz cv cJ wceq vx cv vv cv wss vv vz cv ccld cfv crab vx cv vv cv
      wss vv cJ ccld cfv crab vz cv cJ wceq vz cv ccld cfv cJ ccld cfv wceq vx
      cv vv cv wss vv vz cv ccld cfv crab vx cv vv cv wss vv cJ ccld cfv crab
      wceq vz cv cJ ccld fveq2 vx cv vv cv wss vv vz cv ccld cfv cJ ccld cfv
      rabeq syl inteqd eqeq2d anbi12d opabbidv vx vy vz vw vv df-cls fvopab4g
      mpdan $.
      $( [8-Oct-2006] $) $( [3-Oct-2006] $)
  $}

  ${
    $d x y z J $.  $d x y z S $.  $d x y z X $.  $d x T $.
    iscld.1 $e |- X = U. J $.
    $( The predicate " ` S ` is a closed set." $)
    iscld $p |- ( J e. Top -> ( S e. ( Clsd ` J ) <->
                 ( S C_ X /\ ( X \ S ) e. J ) ) ) $=
      cJ ctop wcel cS cJ ccld cfv wcel cS vx cv cX wss cX vx cv cdif cJ wcel wa
      vx cab wcel cS cX wss cX cS cdif cJ wcel wa cJ ctop wcel cJ ccld cfv vx
      cv cX wss cX vx cv cdif cJ wcel wa vx cab cS vx cJ cX iscld.1 cldval
      eleq2d cJ ctop wcel cS vx cv cX wss cX vx cv cdif cJ wcel wa vx cab wcel
      cS cX wss cX cS cdif cJ wcel wa cS cvv wcel cS vx cv cX wss cX vx cv cdif
      cJ wcel wa vx cab wcel cS cvv wcel cJ ctop wcel cS vx cv cX wss cX vx cv
      cdif cJ wcel wa vx cab elisset adantl cJ ctop wcel cS cX wss cS cvv wcel
      cX cS cdif cJ wcel cX cvv wcel cS cX wss cS cvv wcel cJ ctop wcel cS cX
      wss cX cvv wcel cS cvv wcel cS cX cvv ssexg ancoms cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg iscld.1 syl5eqel sylan adantrr vx cv cX wss cX vx
      cv cdif cJ wcel wa cS cX wss cX cS cdif cJ wcel wa vx cS cvv vx cv cS
      wceq vx cv cX wss cS cX wss cX vx cv cdif cJ wcel cX cS cdif cJ wcel vx
      cv cS cX sseq1 vx cv cS wceq cX vx cv cdif cX cS cdif cJ vx cv cS cX
      difeq2 eleq1d anbi12d elabg pm5.21nd bitrd $.
      $( [4-Oct-2006] $) $( [2-Oct-2006] $)

    $( A subset of the underlying set of a topology is closed iff its
       complement is open. $)
    iscld2 $p |- ( ( J e. Top /\ S C_ X ) ->
                  ( S e. ( Clsd ` J ) <-> ( X \ S ) e. J ) ) $=
      cJ ctop wcel cS cJ ccld cfv wcel cS cX wss cX cS cdif cJ wcel wa cS cX
      wss cX cS cdif cJ wcel cS cJ cX iscld.1 iscld cS cX wss cX cS cdif cJ
      wcel cS cX wss cX cS cdif cJ wcel wa cS cX wss cX cS cdif cJ wcel ibar
      bicomd sylan9bb $.
      $( [5-Oct-2006] $) $( [4-Oct-2006] $)

    $( A closed set is a subset of the underlying set of a topology. $)
    cldss $p |- ( ( J e. Top /\ S e. ( Clsd ` J ) ) -> S C_ X ) $=
      cJ ctop wcel cS cJ ccld cfv wcel cS cX wss cX cS cdif cJ wcel cS cJ cX
      iscld.1 iscld pm3.26bda $.
      $( [15-Oct-2006] $) $( [5-Oct-2006] $)

    $( The complement of a closed set is open. $)
    cldopn $p |- ( ( J e. Top /\ S e. ( Clsd ` J ) ) -> ( X \ S ) e. J ) $=
      cJ ctop wcel cS cJ ccld cfv wcel cS cX wss cX cS cdif cJ wcel cS cJ cX
      iscld.1 iscld pm3.27bda $.
      $( [16-Oct-2006] $) $( [5-Oct-2006] $)

    $( A subset of the underlying set of a topology is open iff its complement
       is closed. $)
    isopn2 $p |- ( ( J e. Top /\ S C_ X ) ->
                  ( S e. J <-> ( X \ S ) e. ( Clsd ` J ) ) ) $=
      cJ ctop wcel cS cX wss wa cX cS cdif cJ ccld cfv wcel cS cJ wcel cJ ctop
      wcel cX cS cdif cJ ccld cfv wcel cX cX cS cdif cdif cJ wcel cS cX wss cS
      cJ wcel cJ ctop wcel cX cS cdif cX wss cX cS cdif cJ ccld cfv wcel cX cX
      cS cdif cdif cJ wcel wb cX cS difss cX cS cdif cJ cX iscld.1 iscld2 mpan2
      cS cX wss cX cX cS cdif cdif cS cJ cS cX wss cX cX cS cdif cdif cS wceq
      cS cX dfss4 biimpi eleq1d sylan9bb bicomd $.
      $( [13-Oct-2006] $) $( [4-Oct-2006] $)

    $( The complement of an open set is closed. $)
    opncld $p |- ( ( J e. Top /\ S e. J ) -> ( X \ S ) e. ( Clsd ` J ) ) $=
      cJ ctop wcel cS cJ wcel wa cS cJ wcel cX cS cdif cJ ccld cfv wcel cJ ctop
      wcel cS cJ wcel pm3.27 cJ ctop wcel cS cJ wcel cS cX wss cS cJ wcel cX cS
      cdif cJ ccld cfv wcel wb cS cJ cX iscld.1 eltopss cS cJ cX iscld.1 isopn2
      syldan mpbid $.
      $( [16-Oct-2006] $) $( [6-Oct-2006] $)

    $( The underlying set of a topology is closed.  Part of Theorem 6.1(1) of
       [Munkres] p. 93. $)
    topcld $p |- ( J e. Top -> X e. ( Clsd ` J ) ) $=
      cJ ctop wcel cX cJ ccld cfv wcel cX cX wss cX cX cdif cJ wcel wa cJ ctop
      wcel cX cX cdif cJ wcel cX cX wss cJ ctop wcel c0 cJ cX cX cdif cJ 0opn
      cX difid syl5eqel cX ssid jctil cX cJ cX iscld.1 iscld mpbird $.
      $( [4-Oct-2006] $) $( [3-Oct-2006] $)

    $( The interior of a subset of a topology's base set is the union of all
       the open sets it includes.  Definition of interior of [Munkres]
       p. 94. $)
    ntrval $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) =
                 U. { x e. J | x C_ S } ) $=
      cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv cS vy cv cX cpw wcel vz cv vx
      cv vy cv wss vx cJ crab cuni wceq wa vy vz copab cfv vx cv cS wss vx cJ
      crab cuni cJ ctop wcel cS cX wss wa cS cJ cnt cfv vy cv cX cpw wcel vz cv
      vx cv vy cv wss vx cJ crab cuni wceq wa vy vz copab cJ ctop wcel cS cX
      wss wa cJ cnt cfv vy cv cX wss vz cv vx cv vy cv wss vx cJ crab cuni wceq
      wa vy vz copab vy cv cX cpw wcel vz cv vx cv vy cv wss vx cJ crab cuni
      wceq wa vy vz copab cJ ctop wcel cJ cnt cfv vy cv cX wss vz cv vx cv vy
      cv wss vx cJ crab cuni wceq wa vy vz copab wceq cS cX wss vy vz vx cJ cX
      iscld.1 ntrfval adantr vy cv cX cpw wcel vz cv vx cv vy cv wss vx cJ crab
      cuni wceq wa vy cv cX wss vz cv vx cv vy cv wss vx cJ crab cuni wceq wa
      vy vz vy cv cX cpw wcel vy cv cX wss vz cv vx cv vy cv wss vx cJ crab
      cuni wceq vy cv cX vy visset elpw anbi1i opabbii syl6eqr fveq1d cS cX cpw
      wcel vx cv cS wss vx cJ crab cuni cvv wcel cS vy cv cX cpw wcel vz cv vx
      cv vy cv wss vx cJ crab cuni wceq wa vy vz copab cfv vx cv cS wss vx cJ
      crab cuni wceq cJ ctop wcel cS cX wss wa vy vz cS vx cv vy cv wss vx cJ
      crab cuni vx cv cS wss vx cJ crab cuni cX cpw cvv vy cv cX cpw wcel vz cv
      vx cv vy cv wss vx cJ crab cuni wceq wa vy vz copab vy cv cS wceq vx cv
      vy cv wss vx cJ crab vx cv cS wss vx cJ crab vy cv cS wceq vx cv vy cv
      wss vx cv cS wss vx cJ vy cv cS vx cv sseq2 rabbisdv unieqd vy cv cX cpw
      wcel vz cv vx cv vy cv wss vx cJ crab cuni wceq wa vy vz copab eqid
      fvopab4g cJ ctop wcel cS cX wss cS cX cpw wcel cJ ctop wcel cX cvv wcel
      cS cX wss cS cX cpw wcel wi cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      iscld.1 syl5eqel cX cvv wcel cS cX cpw wcel cS cX wss cS cX cvv elpw2g
      biimprd syl imp cJ ctop wcel vx cv cS wss vx cJ crab cuni cvv wcel cS cX
      wss cJ ctop wcel vx cv cS wss vx cJ crab cvv wcel vx cv cS wss vx cJ crab
      cuni cvv wcel vx cv cS wss vx cJ ctop rabexg vx cv cS wss vx cJ crab cvv
      uniexg syl adantr sylanc eqtrd $.
      $( [12-Sep-2006] $) $( [10-Sep-2006] $)

    $( The closure of a subset of a topology's base set is the intersection of
       all the closed sets that include it.  Definition of closure of [Munkres]
       p. 94. $)
    clsval $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) =
                 |^| { x e. ( Clsd ` J ) | S C_ x } ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS vy cv cX cpw wcel vz cv vy
      cv vx cv wss vx cJ ccld cfv crab cint wceq wa vy vz copab cfv cS vx cv
      wss vx cJ ccld cfv crab cint cJ ctop wcel cS cX wss wa cS cJ ccl cfv vy
      cv cX cpw wcel vz cv vy cv vx cv wss vx cJ ccld cfv crab cint wceq wa vy
      vz copab cJ ctop wcel cS cX wss wa cJ ccl cfv vy cv cX wss vz cv vy cv vx
      cv wss vx cJ ccld cfv crab cint wceq wa vy vz copab vy cv cX cpw wcel vz
      cv vy cv vx cv wss vx cJ ccld cfv crab cint wceq wa vy vz copab cJ ctop
      wcel cJ ccl cfv vy cv cX wss vz cv vy cv vx cv wss vx cJ ccld cfv crab
      cint wceq wa vy vz copab wceq cS cX wss vy vz vx cJ cX iscld.1 clsfval
      adantr vy cv cX cpw wcel vz cv vy cv vx cv wss vx cJ ccld cfv crab cint
      wceq wa vy cv cX wss vz cv vy cv vx cv wss vx cJ ccld cfv crab cint wceq
      wa vy vz vy cv cX cpw wcel vy cv cX wss vz cv vy cv vx cv wss vx cJ ccld
      cfv crab cint wceq vy cv cX vy visset elpw anbi1i opabbii syl6eqr fveq1d
      cS cX cpw wcel cS vx cv wss vx cJ ccld cfv crab cint cvv wcel cS vy cv cX
      cpw wcel vz cv vy cv vx cv wss vx cJ ccld cfv crab cint wceq wa vy vz
      copab cfv cS vx cv wss vx cJ ccld cfv crab cint wceq cJ ctop wcel cS cX
      wss wa vy vz cS vy cv vx cv wss vx cJ ccld cfv crab cint cS vx cv wss vx
      cJ ccld cfv crab cint cX cpw cvv vy cv cX cpw wcel vz cv vy cv vx cv wss
      vx cJ ccld cfv crab cint wceq wa vy vz copab vy cv cS wceq vy cv vx cv
      wss vx cJ ccld cfv crab cS vx cv wss vx cJ ccld cfv crab vy cv cS wceq vy
      cv vx cv wss cS vx cv wss vx cJ ccld cfv vy cv cS vx cv sseq1 rabbisdv
      inteqd vy cv cX cpw wcel vz cv vy cv vx cv wss vx cJ ccld cfv crab cint
      wceq wa vy vz copab eqid fvopab4g cX cvv wcel cS cX wss cS cX cpw wcel cJ
      ctop wcel cX cvv wcel cS cX cpw wcel cS cX wss cS cX cvv elpw2g biimpar
      cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg iscld.1 syl5eqel sylan cJ ctop
      wcel cS cX wss wa cS vx cv wss vx cJ ccld cfv wrex cS vx cv wss vx cJ
      ccld cfv crab cint cvv wcel cX cJ ccld cfv wcel cS cX wss cS vx cv wss vx
      cJ ccld cfv wrex cJ ctop wcel cS vx cv wss cS cX wss vx cX cJ ccld cfv vx
      cv cX cS sseq2 rcla4ev cJ cX iscld.1 topcld sylan cS vx cv wss vx cJ ccld
      cfv intexrab sylib sylanc eqtrd $.
      $( [9-Oct-2006] $) $( [10-Sep-2006] $)
  $}

  $( The empty set is closed.  Part of Theorem 6.1(1) of [Munkres] p. 93. $)
  0cld $p |- ( J e. Top -> (/) e. ( Clsd ` J ) ) $=
    cJ ctop wcel c0 cJ ccld cfv wcel cJ cuni c0 cdif cJ wcel cJ cJ cuni c0 cdif
    cJ cuni dif0 topopn cJ ctop wcel c0 cJ cuni wss c0 cJ ccld cfv wcel cJ cuni
    c0 cdif cJ wcel wb cJ cuni 0ss c0 cJ cJ cuni cJ cuni eqid iscld2 mpan2
    mpbird $.
    $( [2-Jan-2007] $) $( [4-Oct-2006] $)

  ${
    $d x A $.  $d x J $.  $d x S $.
    $( The indexed intersection of a collection ` B ( x ) ` of closed sets is
       closed.  Theorem 6.1(2) of [Munkres] p. 93. $)
    iincld $p |- ( ( J e. Top /\ A =/= (/) /\ A. x e. A B e. ( Clsd ` J ) ) ->
                  |^|_ x e. A B e. ( Clsd ` J ) ) $=
      cJ ctop wcel cA c0 wne cB cJ ccld cfv wcel vx cA wral w3a vx cA cB ciin
      cJ cuni vx cA cJ cuni cB cdif ciun cdif cJ ccld cfv cJ ctop wcel cA c0
      wne cB cJ ccld cfv wcel vx cA wral w3a vx cA cJ cuni cJ cuni cB cdif cdif
      ciin vx cA cB ciin cJ cuni vx cA cJ cuni cB cdif ciun cdif cJ ctop wcel
      cB cJ ccld cfv wcel vx cA wral vx cA cJ cuni cJ cuni cB cdif cdif ciin vx
      cA cB ciin wceq cA c0 wne cJ ctop wcel cB cJ ccld cfv wcel vx cA wral wa
      cJ cuni cJ cuni cB cdif cdif cB wceq vx cA wral vx cA cJ cuni cJ cuni cB
      cdif cdif ciin vx cA cB ciin wceq cJ ctop wcel cB cJ ccld cfv wcel vx cA
      wral cJ cuni cJ cuni cB cdif cdif cB wceq vx cA wral cJ ctop wcel cB cJ
      ccld cfv wcel cJ cuni cJ cuni cB cdif cdif cB wceq vx cA cJ ctop wcel cB
      cJ ccld cfv wcel cB cJ cuni wss cJ cuni cJ cuni cB cdif cdif cB wceq cJ
      ctop wcel cB cJ ccld cfv wcel cB cJ cuni wss cB cJ cJ cuni cJ cuni eqid
      cldss ex cB cJ cuni dfss4 syl6ib r19.20sdv imp vx cA cJ cuni cJ cuni cB
      cdif cdif cB iineq2 syl 3adant2 cA c0 wne cJ ctop wcel vx cA cJ cuni cJ
      cuni cB cdif cdif ciin cJ cuni vx cA cJ cuni cB cdif ciun cdif wceq cB cJ
      ccld cfv wcel vx cA wral vx cA cJ cuni cJ cuni cB cdif iindif2 3ad2ant2
      eqtr3d cJ ctop wcel cB cJ ccld cfv wcel vx cA wral cJ cuni vx cA cJ cuni
      cB cdif ciun cdif cJ ccld cfv wcel cA c0 wne cJ ctop wcel cB cJ ccld cfv
      wcel vx cA wral wa vx cA cJ cuni cB cdif ciun cJ wcel cJ cuni vx cA cJ
      cuni cB cdif ciun cdif cJ ccld cfv wcel cJ ctop wcel cB cJ ccld cfv wcel
      vx cA wral cJ cuni cB cdif cJ wcel vx cA wral vx cA cJ cuni cB cdif ciun
      cJ wcel cJ ctop wcel cB cJ ccld cfv wcel vx cA wral cJ cuni cB cdif cJ
      wcel vx cA wral cJ ctop wcel cB cJ ccld cfv wcel cJ cuni cB cdif cJ wcel
      vx cA cJ ctop wcel cB cJ ccld cfv wcel cB cJ cuni wss cJ cuni cB cdif cJ
      wcel wa cJ cuni cB cdif cJ wcel cB cJ cJ cuni cJ cuni eqid iscld cB cJ
      cuni wss cJ cuni cB cdif cJ wcel pm3.27 syl6bi r19.20sdv imp vx cA cJ
      cuni cB cdif cJ iunopn syldan cJ ctop wcel vx cA cJ cuni cB cdif ciun cJ
      wcel cJ cuni vx cA cJ cuni cB cdif ciun cdif cJ ccld cfv wcel wb cB cJ
      ccld cfv wcel vx cA wral cJ ctop wcel vx cA cJ cuni cB cdif ciun cJ cuni
      wss vx cA cJ cuni cB cdif ciun cJ wcel cJ cuni vx cA cJ cuni cB cdif ciun
      cdif cJ ccld cfv wcel wb vx cA cJ cuni cB cdif ciun cJ cuni wss cJ cuni
      cB cdif cJ cuni wss vx cA vx cA cJ cuni cB cdif cJ cuni iunss cJ cuni cB
      cdif cJ cuni wss vx cv cA wcel cJ cuni cB difss a1i mprgbir vx cA cJ cuni
      cB cdif ciun cJ cJ cuni cJ cuni eqid isopn2 mpan2 adantr mpbid 3adant2
      eqeltrd $.
      $( [17-Oct-2006] $) $( [5-Oct-2006] $)

    $( The intersection of a set of closed sets is closed. $)
    intcld $p |- ( ( J e. Top /\ A =/= (/) /\ A C_ ( Clsd ` J ) ) ->
                  |^| A e. ( Clsd ` J ) ) $=
      cJ ctop wcel cA c0 wne cA cJ ccld cfv wss w3a vx cA vx cv ciin cJ ccld
      cfv cA cint cJ ctop wcel cA c0 wne vx cv cJ ccld cfv wcel vx cA wral vx
      cA vx cv ciin cJ ccld cfv wcel cA cJ ccld cfv wss vx cA vx cv cJ iincld
      vx cA cJ ccld cfv dfss3 syl3an3b vx cA intiin syl5eqel $.
      $( [17-Oct-2006] $) $( [5-Oct-2006] $)

    $( The union of two closed sets is closed.  Equivalent to Theorem 6.1(3) of
       [Munkres] p. 93. $)
    uncld $p |- ( ( J e. Top /\ A e. ( Clsd ` J ) /\ B e. ( Clsd ` J ) ) ->
                 ( A u. B ) e. ( Clsd ` J ) ) $=
      cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB cun cJ ccld
      cfv wcel cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel wa wa cA cB
      cun cJ ccld cfv wcel cJ cuni cA cB cun cdif cJ wcel cJ ctop wcel cA cJ
      ccld cfv wcel cB cJ ccld cfv wcel wa wa cJ cuni cA cdif cJ cuni cB cdif
      cin cJ cJ cuni cA cB cun cdif cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld
      cfv wcel wa cJ cuni cA cdif cJ wcel cJ cuni cB cdif cJ wcel wa cJ cuni cA
      cdif cJ cuni cB cdif cin cJ wcel cJ ctop wcel cA cJ ccld cfv wcel cB cJ
      ccld cfv wcel cJ cuni cA cdif cJ wcel cJ cuni cB cdif cJ wcel wa cJ ctop
      wcel cA cJ ccld cfv wcel wa cJ cuni cA cdif cJ wcel cJ ctop wcel cB cJ
      ccld cfv wcel wa cJ cuni cB cdif cJ wcel cA cJ cJ cuni cJ cuni eqid
      cldopn cB cJ cJ cuni cJ cuni eqid cldopn anim12i anandis cJ ctop wcel cJ
      cuni cA cdif cJ wcel cJ cuni cB cdif cJ wcel cJ cuni cA cdif cJ cuni cB
      cdif cin cJ wcel cJ cuni cA cdif cJ cuni cB cdif cJ inopn 3expb syldan cJ
      cuni cA cB difundi syl5eqel cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld
      cfv wcel wa cA cB cun cJ cuni wss cA cB cun cJ ccld cfv wcel cJ cuni cA
      cB cun cdif cJ wcel wb cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv
      wcel wa wa cA cJ cuni wss cB cJ cuni wss wa cA cB cun cJ cuni wss cJ ctop
      wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cJ cuni wss cB cJ cuni
      wss wa cJ ctop wcel cA cJ ccld cfv wcel wa cA cJ cuni wss cJ ctop wcel cB
      cJ ccld cfv wcel wa cB cJ cuni wss cA cJ cJ cuni cJ cuni eqid cldss cB cJ
      cJ cuni cJ cuni eqid cldss anim12i anandis cA cB cJ cuni unss sylib cA cB
      cun cJ cJ cuni cJ cuni eqid iscld2 syldan mpbird 3impb $.
      $( [10-Jun-2007] $) $( [5-Oct-2006] $)

    $( A closed subset equals its own closure. $)
    cldcls $p |- ( ( J e. Top /\ S e. ( Clsd ` J ) ) ->
                 ( ( cls ` J ) ` S ) = S ) $=
      cJ ctop wcel cS cJ ccld cfv wcel wa cS cJ cuni wss cS cJ ccl cfv cfv cS
      wceq cS cJ cJ cuni cJ cuni eqid cldss cJ ctop wcel cS cJ cuni wss cS cJ
      ccld cfv wcel cS cJ ccl cfv cfv cS wceq cJ ctop wcel cS cJ cuni wss wa cS
      cJ ccld cfv wcel cS cJ ccl cfv cfv cS vx cv wss vx cJ ccld cfv crab cint
      cS vx cS cJ cJ cuni cJ cuni eqid clsval vx cS cJ ccld cfv intmin sylan9eq
      an1rs mpdan $.
      $( [16-Mar-2007] $) $( [15-Mar-2007] $)
  $}

  ${
    $d x y z J $.  $d x P $.  $d x y z S $.  $d x U $.  $d x y z X $.
    $d x T $.
    clscld.1 $e |- X = U. J $.
    $( The closure of a subset of a topology's underlying set is closed. $)
    clscld $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( ( cls ` J ) ` S ) e. ( Clsd ` J ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS vx cv wss vx cJ ccld cfv
      crab cint cJ ccld cfv vx cS cJ cX clscld.1 clsval cJ ctop wcel cS vx cv
      wss vx cJ ccld cfv crab c0 wne cS vx cv wss vx cJ ccld cfv crab cJ ccld
      cfv wss cS vx cv wss vx cJ ccld cfv crab cint cJ ccld cfv wcel cJ ctop
      wcel cS cX wss wa cS vx cv wss vx cJ ccld cfv crab cJ intcld cJ ctop wcel
      cS cX wss pm3.26 cJ ctop wcel cS cX wss wa cX cS vx cv wss vx cJ ccld cfv
      crab wcel cS vx cv wss vx cJ ccld cfv crab c0 wne cJ ctop wcel cS cX wss
      wa cX cJ ccld cfv wcel cS cX wss wa cX cS vx cv wss vx cJ ccld cfv crab
      wcel cJ ctop wcel cX cJ ccld cfv wcel cS cX wss cJ cX clscld.1 topcld
      anim1i cS vx cv wss cS cX wss vx cX cJ ccld cfv vx cv cX cS sseq2 elrab
      sylibr cS vx cv wss vx cJ ccld cfv crab cX ne0i syl cS vx cv wss vx cJ
      ccld cfv crab cJ ccld cfv wss cJ ctop wcel cS cX wss wa cS vx cv wss vx
      cJ ccld cfv ssrab2 a1i syl3anc eqeltrd $.
      $( [21-Oct-2006] $) $( [4-Oct-2006] $)

    $( The interior of a subset of a topology's underlying set is open. $)
    ntropn $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) e. J ) $=
      cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv vx cv cS wss vx cJ crab cuni
      cJ vx cS cJ cX clscld.1 ntrval cJ ctop wcel vx cv cS wss vx cJ crab cuni
      cJ wcel cS cX wss cJ ctop wcel vx cv cS wss vx cJ crab cJ wss vx cv cS
      wss vx cJ crab cuni cJ wcel vx cv cS wss vx cJ ssrab2 vx cv cS wss vx cJ
      crab cJ uniopn mpan2 adantr eqeltrd $.
      $( [21-Sep-2006] $) $( [11-Sep-2006] $)

    $( Express closure in terms of interior. $)
    clsval2 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) =
                 ( X \ ( ( int ` J ) ` ( X \ S ) ) ) ) $=
      cJ ctop wcel cS cX wss wa cX vy cv cX cS cdif wss vy cJ crab cuni cdif cS
      vz cv wss vz cJ ccld cfv crab cint cX cX cS cdif cJ cnt cfv cfv cdif cS
      cJ ccl cfv cfv cJ ctop wcel cS cX wss wa vx cX vy cv cX cS cdif wss vy cJ
      crab cuni cdif cS vz cv wss vz cJ ccld cfv crab cint cJ ctop wcel cS cX
      wss wa vx cv cX wcel vy cv cX cS cdif wss vx cv vy cv wcel wn wi vy cJ
      wral wa cS vz cv wss vx cv vz cv wcel wi vz cJ ccld cfv wral vx cv cX vy
      cv cX cS cdif wss vy cJ crab cuni cdif wcel vx cv cS vz cv wss vz cJ ccld
      cfv crab cint wcel cJ ctop wcel cS cX wss wa vx cv cX wcel vy cv cX cS
      cdif wss vx cv vy cv wcel wn wi vy cJ wral wa cS vz cv wss vx cv vz cv
      wcel wi vz cJ ccld cfv wral cJ ctop wcel vx cv cX wcel vy cv cX cS cdif
      wss vx cv vy cv wcel wn wi vy cJ wral wa cS vz cv wss vx cv vz cv wcel wi
      vz cJ ccld cfv wral wi cS cX wss cJ ctop wcel vx cv cX wcel vy cv cX cS
      cdif wss vx cv vy cv wcel wn wi vy cJ wral wa cS vz cv wss vx cv vz cv
      wcel wi vz cJ ccld cfv cJ ctop wcel vx cv cX wcel vy cv cX cS cdif wss vx
      cv vy cv wcel wn wi vy cJ wral vz cv cJ ccld cfv wcel cS vz cv wss vx cv
      vz cv wcel wi wi cJ ctop wcel vx cv cX wcel vz cv cJ ccld cfv wcel vy cv
      cX cS cdif wss vx cv vy cv wcel wn wi vy cJ wral cS vz cv wss vx cv vz cv
      wcel wi cJ ctop wcel vx cv cX wcel vz cv cJ ccld cfv wcel vy cv cX cS
      cdif wss vx cv vy cv wcel wn wi vy cJ wral cS vz cv wss vx cv vz cv wcel
      wi wi cJ ctop wcel vx cv cX wcel vz cv cJ ccld cfv wcel wa wa vy cv cX cS
      cdif wss vx cv vy cv wcel wn wi vy cJ wral cX vz cv cdif cX cS cdif wss
      vx cv cX vz cv cdif wcel wn wi cS vz cv wss vx cv vz cv wcel wi cJ ctop
      wcel vz cv cJ ccld cfv wcel vy cv cX cS cdif wss vx cv vy cv wcel wn wi
      vy cJ wral cX vz cv cdif cX cS cdif wss vx cv cX vz cv cdif wcel wn wi wi
      vx cv cX wcel cJ ctop wcel vz cv cJ ccld cfv wcel wa cX vz cv cdif cJ
      wcel vy cv cX cS cdif wss vx cv vy cv wcel wn wi vy cJ wral cX vz cv cdif
      cX cS cdif wss vx cv cX vz cv cdif wcel wn wi wi vz cv cJ cX clscld.1
      cldopn vy cv cX cS cdif wss vx cv vy cv wcel wn wi cX vz cv cdif cX cS
      cdif wss vx cv cX vz cv cdif wcel wn wi vy cX vz cv cdif cJ vy cv cX vz
      cv cdif wceq vy cv cX cS cdif wss cX vz cv cdif cX cS cdif wss vx cv vy
      cv wcel wn vx cv cX vz cv cdif wcel wn vy cv cX vz cv cdif cX cS cdif
      sseq1 vy cv cX vz cv cdif wceq vx cv vy cv wcel vx cv cX vz cv cdif wcel
      vy cv cX vz cv cdif vx cv eleq2 notbid imbi12d rcla4v syl adantrl vx cv
      cX wcel cX vz cv cdif cX cS cdif wss vx cv cX vz cv cdif wcel wn wi cS vz
      cv wss vx cv vz cv wcel wi wi cJ ctop wcel vz cv cJ ccld cfv wcel vx cv
      cX wcel cS vz cv wss cX vz cv cdif cX cS cdif wss vx cv cX vz cv cdif
      wcel wn vx cv vz cv wcel cS vz cv wss cX vz cv cdif cX cS cdif wss wi vx
      cv cX wcel cS vz cv cX sscon a1i vx cv cX wcel vx cv cX vz cv cdif wcel
      wn vx cv vz cv wcel vx cv cX vz cv neldif ex imim12d ad2antrl syld exp32
      com34 imp3a r19.21adv adantr cJ ctop wcel cS cX wss wa cS vz cv wss vx cv
      vz cv wcel wi vz cJ ccld cfv wral vx cv cX wcel vy cv cX cS cdif wss vx
      cv vy cv wcel wn wi vy cJ wral cJ ctop wcel cS cX wss cS vz cv wss vx cv
      vz cv wcel wi vz cJ ccld cfv wral vx cv cX wcel wi cJ ctop wcel cS vz cv
      wss vx cv vz cv wcel wi vz cJ ccld cfv wral cS cX wss vx cv cX wcel cJ
      ctop wcel cX cJ ccld cfv wcel cS vz cv wss vx cv vz cv wcel wi vz cJ ccld
      cfv wral cS cX wss vx cv cX wcel wi wi cJ cX clscld.1 topcld cS vz cv wss
      vx cv vz cv wcel wi cS cX wss vx cv cX wcel wi vz cX cJ ccld cfv vz cv cX
      wceq cS vz cv wss cS cX wss vx cv vz cv wcel vx cv cX wcel vz cv cX cS
      sseq2 vz cv cX vx cv eleq2 imbi12d rcla4v syl com23 imp cJ ctop wcel cS
      cX wss wa cS vz cv wss vx cv vz cv wcel wi vz cJ ccld cfv wral vy cv cX
      cS cdif wss vx cv vy cv wcel wn wi vy cJ cJ ctop wcel cS cX wss wa vy cv
      cJ wcel wa cS vz cv wss vx cv vz cv wcel wi vz cJ ccld cfv wral cS cX vy
      cv cdif wss vx cv cX vy cv cdif wcel wi vy cv cX cS cdif wss vx cv vy cv
      wcel wn wi cJ ctop wcel vy cv cJ wcel cS vz cv wss vx cv vz cv wcel wi vz
      cJ ccld cfv wral cS cX vy cv cdif wss vx cv cX vy cv cdif wcel wi wi cS
      cX wss cJ ctop wcel vy cv cJ wcel wa cX vy cv cdif cJ ccld cfv wcel cS vz
      cv wss vx cv vz cv wcel wi vz cJ ccld cfv wral cS cX vy cv cdif wss vx cv
      cX vy cv cdif wcel wi wi vy cv cJ cX clscld.1 opncld cS vz cv wss vx cv
      vz cv wcel wi cS cX vy cv cdif wss vx cv cX vy cv cdif wcel wi vz cX vy
      cv cdif cJ ccld cfv vz cv cX vy cv cdif wceq cS vz cv wss cS cX vy cv
      cdif wss vx cv vz cv wcel vx cv cX vy cv cdif wcel vz cv cX vy cv cdif cS
      sseq2 vz cv cX vy cv cdif vx cv eleq2 imbi12d rcla4v syl adantlr cJ ctop
      wcel cS cX wss wa vy cv cJ wcel wa vy cv cX cS cdif wss cS cX vy cv cdif
      wss vx cv cX vy cv cdif wcel vx cv vy cv wcel wn cJ ctop wcel vy cv cJ
      wcel cS cX wss vy cv cX cS cdif wss cS cX vy cv cdif wss wi vy cv cX wss
      cS cX wss vy cv cX cS cdif wss cS cX vy cv cdif wss wi cJ ctop wcel vy cv
      cJ wcel wa vy cv cX wss cS cX wss wa vy cv cX cS cdif wss cS cX vy cv
      cdif wss vy cv cS cX ssconb biimpd vy cv cJ cX clscld.1 eltopss sylan
      an1rs vx cv cX vy cv cdif wcel vx cv vy cv wcel wn wi cJ ctop wcel cS cX
      wss wa vy cv cJ wcel wa vx cv cX vy cv eldifn a1i imim12d syld r19.21adva
      jcad impbid vx cv cX vy cv cX cS cdif wss vy cJ crab cuni cdif wcel vx cv
      cX wcel vx cv vy cv cX cS cdif wss vy cJ crab cuni wcel wn wa vx cv cX
      wcel vy cv cX cS cdif wss vx cv vy cv wcel wn wi vy cJ wral wa vx cv cX
      vy cv cX cS cdif wss vy cJ crab cuni eldif vx cv vy cv cX cS cdif wss vy
      cJ crab cuni wcel wn vy cv cX cS cdif wss vx cv vy cv wcel wn wi vy cJ
      wral vx cv cX wcel vx cv vy cv wcel vy cv cX cS cdif wss wa wn vy cJ wral
      vx cv vy cv wcel vy cv cX cS cdif wss wa vy cJ wrex wn vy cv cX cS cdif
      wss vx cv vy cv wcel wn wi vy cJ wral vx cv vy cv cX cS cdif wss vy cJ
      crab cuni wcel wn vx cv vy cv wcel vy cv cX cS cdif wss wa vy cJ ralnex
      vy cv cX cS cdif wss vx cv vy cv wcel wn wi vx cv vy cv wcel vy cv cX cS
      cdif wss wa wn vy cJ vy cv cX cS cdif wss vx cv vy cv wcel wn wi vy cv cX
      cS cdif wss vx cv vy cv wcel wa wn vx cv vy cv wcel vy cv cX cS cdif wss
      wa wn vy cv cX cS cdif wss vx cv vy cv wcel imnan vy cv cX cS cdif wss vx
      cv vy cv wcel wa vx cv vy cv wcel vy cv cX cS cdif wss wa vy cv cX cS
      cdif wss vx cv vy cv wcel ancom notbii bitri ralbii vx cv vy cv cX cS
      cdif wss vy cJ crab cuni wcel vx cv vy cv wcel vy cv cX cS cdif wss wa vy
      cJ wrex vy cv cX cS cdif wss vy vx cv cJ elunirab notbii 3bitr4ri anbi2i
      bitri cS vz cv wss vz vx cv cJ ccld cfv vx visset elintrab 3bitr4g eqrdv
      cJ ctop wcel cS cX wss wa cX cS cdif cJ cnt cfv cfv vy cv cX cS cdif wss
      vy cJ crab cuni cX cJ ctop wcel cX cS cdif cX wss cX cS cdif cJ cnt cfv
      cfv vy cv cX cS cdif wss vy cJ crab cuni wceq cS cX wss vy cX cS cdif cJ
      cX clscld.1 ntrval cX cS cdif cX wss cS cX wss cX cS difss a1i sylan2
      difeq2d vz cS cJ cX clscld.1 clsval 3eqtr4rd $.
      $( [16-Oct-2006] $) $( [10-Sep-2006] $)

    $( Interior expressed in terms of closure. $)
    ntrval2 $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( ( int ` J ) ` S ) = ( X \ ( ( cls ` J ) ` ( X \ S ) ) ) ) $=
      cJ ctop wcel cS cX wss wa cX cX cS cdif cJ ccl cfv cfv cdif cX cX cS cJ
      cnt cfv cfv cdif cdif cS cJ cnt cfv cfv cJ ctop wcel cS cX wss wa cX cS
      cdif cJ ccl cfv cfv cX cS cJ cnt cfv cfv cdif cX cJ ctop wcel cS cX wss
      wa cX cS cdif cJ ccl cfv cfv cX cX cX cS cdif cdif cJ cnt cfv cfv cdif cX
      cS cJ cnt cfv cfv cdif cJ ctop wcel cX cS cdif cJ ccl cfv cfv cX cX cX cS
      cdif cdif cJ cnt cfv cfv cdif wceq cS cX wss cJ ctop wcel cX cS cdif cX
      wss cX cS cdif cJ ccl cfv cfv cX cX cX cS cdif cdif cJ cnt cfv cfv cdif
      wceq cX cS difss cX cS cdif cJ cX clscld.1 clsval2 mpan2 adantr cJ ctop
      wcel cS cX wss wa cX cX cS cdif cdif cJ cnt cfv cfv cS cJ cnt cfv cfv cX
      cS cX wss cX cX cS cdif cdif cJ cnt cfv cfv cS cJ cnt cfv cfv wceq cJ
      ctop wcel cS cX wss cX cX cS cdif cdif cS cJ cnt cfv cS cX wss cX cX cS
      cdif cdif cS wceq cS cX dfss4 biimpi fveq2d adantl difeq2d eqtrd difeq2d
      cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv cX wss cX cX cS cJ cnt cfv
      cfv cdif cdif cS cJ cnt cfv cfv wceq cJ ctop wcel cS cX wss cS cJ cnt cfv
      cfv cJ wcel cS cJ cnt cfv cfv cX wss cS cJ cX clscld.1 ntropn cS cJ cnt
      cfv cfv cJ cX clscld.1 eltopss syldan cS cJ cnt cfv cfv cX dfss4 sylib
      eqtr2d $.
      $( [15-Dec-2007] $) $( [1-Oct-2007] $)

    $( Subset relationship for closure. $)
    clsss $p |- ( ( J e. Top /\ S C_ X /\ T C_ S ) -> ( ( cls ` J ) ` T ) C_
                 ( ( cls ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss cT cS wss w3a cT vx cv wss vx cJ ccld cfv crab
      cint cS vx cv wss vx cJ ccld cfv crab cint cT cJ ccl cfv cfv cS cJ ccl
      cfv cfv cT cS wss cJ ctop wcel cT vx cv wss vx cJ ccld cfv crab cint cS
      vx cv wss vx cJ ccld cfv crab cint wss cS cX wss cT cS wss cS vx cv wss
      vx cJ ccld cfv crab cT vx cv wss vx cJ ccld cfv crab wss cT vx cv wss vx
      cJ ccld cfv crab cint cS vx cv wss vx cJ ccld cfv crab cint wss cT cS wss
      cS vx cv wss cT vx cv wss vx cJ ccld cfv cT cS wss cS vx cv wss cT vx cv
      wss wi vx cv cJ ccld cfv wcel cT cS vx cv sstr2 adantr ss2rabdv cS vx cv
      wss vx cJ ccld cfv crab cT vx cv wss vx cJ ccld cfv crab intss syl
      3ad2ant3 cJ ctop wcel cT cX wss cT cJ ccl cfv cfv cT vx cv wss vx cJ ccld
      cfv crab cint wceq cJ ctop wcel cS cX wss cT cS wss w3a vx cT cJ cX
      clscld.1 clsval cJ ctop wcel cS cX wss cT cS wss 3simp1 cS cX wss cT cS
      wss cT cX wss cJ ctop wcel cT cS wss cS cX wss cT cX wss cT cS cX sstr2
      impcom 3adant1 sylanc cJ ctop wcel cS cX wss cS cJ ccl cfv cfv cS vx cv
      wss vx cJ ccld cfv crab cint wceq cT cS wss vx cS cJ cX clscld.1 clsval
      3adant3 3sstr4d $.
      $( [17-Feb-2007] $) $( [10-Feb-2007] $)

    $( Subset relationship for interior. $)
    ntrss $p |- ( ( J e. Top /\ S C_ X /\ T C_ S ) -> ( ( int ` J ) ` T ) C_
                 ( ( int ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss cT cS wss cT cJ cnt cfv cfv cS cJ cnt cfv cfv wss
      cJ ctop wcel cS cX wss cT cS wss wa wa cX cX cT cdif cJ ccl cfv cfv cdif
      cX cX cS cdif cJ ccl cfv cfv cdif cT cJ cnt cfv cfv cS cJ cnt cfv cfv cJ
      ctop wcel cS cX wss cT cS wss wa wa cX cS cdif cJ ccl cfv cfv cX cT cdif
      cJ ccl cfv cfv wss cX cX cT cdif cJ ccl cfv cfv cdif cX cX cS cdif cJ ccl
      cfv cfv cdif wss cJ ctop wcel cX cT cdif cX wss cX cS cdif cX cT cdif wss
      wa cX cS cdif cJ ccl cfv cfv cX cT cdif cJ ccl cfv cfv wss cS cX wss cT
      cS wss wa cJ ctop wcel cX cT cdif cX wss cX cS cdif cX cT cdif wss cX cS
      cdif cJ ccl cfv cfv cX cT cdif cJ ccl cfv cfv wss cX cT cdif cX cS cdif
      cJ cX clscld.1 clsss 3expb cS cX wss cT cS wss wa cX cS cdif cX cT cdif
      wss cX cT cdif cX wss cT cS wss cX cS cdif cX cT cdif wss cS cX wss cT cS
      cX sscon adantl cX cT difss jctil sylan2 cX cS cdif cJ ccl cfv cfv cX cT
      cdif cJ ccl cfv cfv cX sscon syl cJ ctop wcel cT cX wss cT cJ cnt cfv cfv
      cX cX cT cdif cJ ccl cfv cfv cdif wceq cS cX wss cT cS wss wa cT cJ cX
      clscld.1 ntrval2 cT cS wss cS cX wss cT cX wss cT cS cX sstr2 impcom
      sylan2 cJ ctop wcel cS cX wss cS cJ cnt cfv cfv cX cX cS cdif cJ ccl cfv
      cfv cdif wceq cT cS wss cS cJ cX clscld.1 ntrval2 adantrr 3sstr4d 3impb
      $.
      $( [21-Feb-2008] $) $( [3-Oct-2007] $)

    $( A subset of a topology's underlying set is included in its closure. $)
    sscls $p |- ( ( J e. Top /\ S C_ X ) -> S C_ ( ( cls ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss wa cS cS vx cv wss vx cJ ccld cfv crab cint cS cJ
      ccl cfv cfv cS cS vx cv wss vx cJ ccld cfv crab cint wss cJ ctop wcel cS
      cX wss wa vx cS cJ ccld cfv ssintub a1i vx cS cJ cX clscld.1 clsval
      sseqtr4d $.
      $( [22-Feb-2007] $) $( [22-Feb-2007] $)

    $( A subset includes its interior. $)
    ntrss2 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) C_ S ) $=
      cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv vx cv cS wss vx cJ crab cuni
      cS vx cS cJ cX clscld.1 ntrval vx cv cS wss vx cJ crab cuni cS wss cJ
      ctop wcel cS cX wss wa vy vx cv cS wss vx cJ crab cuni cS vy cv vx cv cS
      wss vx cJ crab cuni wcel vy cv vx cv wcel vx cv cS wss wa vx cJ wrex vy
      cv cS wcel vx cv cS wss vx vy cv cJ elunirab vy cv vx cv wcel vx cv cS
      wss wa vy cv cS wcel vx cJ vy cv vx cv wcel vx cv cS wss wa vy cv cS wcel
      wi vx cv cJ wcel vx cv cS wss vy cv vx cv wcel vy cv cS wcel vx cv cS vy
      cv ssel impcom a1i r19.23aiv sylbi ssriv a1i eqsstrd $.
      $( [18-Jan-2008] $) $( [3-Oct-2007] $)

    $( The closure of a subset of a topological space is included in the
       space. $)
    clsss3 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) C_ X ) $=
      cJ ctop wcel cS cX wss cS cJ ccl cfv cfv cJ ccld cfv wcel cS cJ ccl cfv
      cfv cX wss cS cJ cX clscld.1 clscld cS cJ ccl cfv cfv cJ cX clscld.1
      cldss syldan $.
      $( [1-Mar-2007] $) $( [26-Feb-2007] $)

    $( The interior of a subset of a topological space is included in the
       space. $)
    ntrss3 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) C_ X ) $=
      cJ ctop wcel cS cX wss cS cJ cnt cfv cfv cJ wcel cS cJ cnt cfv cfv cX wss
      cS cJ cX clscld.1 ntropn cS cJ cnt cfv cfv cJ cX clscld.1 eltopss syldan
      $.
      $( [18-Feb-2008] $) $( [1-Oct-2007] $)

    $( The complement of a closure is open. $)
    cmclsopn $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( X \ ( ( cls ` J ) ` S ) ) e. J ) $=
      cJ ctop wcel cS cX wss wa cX cS cJ ccl cfv cfv cdif cX cX cX cS cdif cJ
      cnt cfv cfv cdif cdif cJ cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cX
      cX cS cdif cJ cnt cfv cfv cdif cX cS cJ cX clscld.1 clsval2 difeq2d cJ
      ctop wcel cX cX cX cS cdif cJ cnt cfv cfv cdif cdif cJ wcel cS cX wss cJ
      ctop wcel cX cX cX cS cdif cJ cnt cfv cfv cdif cdif cX cS cdif cJ cnt cfv
      cfv cJ cJ ctop wcel cX cS cdif cJ cnt cfv cfv cX wss cX cX cX cS cdif cJ
      cnt cfv cfv cdif cdif cX cS cdif cJ cnt cfv cfv wceq cJ ctop wcel cX cS
      cdif cJ cnt cfv cfv cJ wcel cX cS cdif cJ cnt cfv cfv cX wss cJ ctop wcel
      cX cS cdif cX wss cX cS cdif cJ cnt cfv cfv cJ wcel cX cS difss cX cS
      cdif cJ cX clscld.1 ntropn mpan2 cX cS cdif cJ cnt cfv cfv cJ cX clscld.1
      eltopss mpdan cX cS cdif cJ cnt cfv cfv cX dfss4 sylib cJ ctop wcel cX cS
      cdif cX wss cX cS cdif cJ cnt cfv cfv cJ wcel cX cS difss cX cS cdif cJ
      cX clscld.1 ntropn mpan2 eqeltrd adantr eqeltrd $.
      $( [27-Feb-2007] $) $( [11-Sep-2006] $)

    $( The complement of an interior is closed. $)
    cmntrcld $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( X \ ( ( int ` J ) ` S ) ) e. ( Clsd ` J ) ) $=
      cJ ctop wcel cS cX wss wa cX cS cJ cnt cfv cfv cdif cX cX cX cS cdif cJ
      ccl cfv cfv cdif cdif cJ ccld cfv cJ ctop wcel cS cX wss wa cS cJ cnt cfv
      cfv cX cX cS cdif cJ ccl cfv cfv cdif cX cS cJ cX clscld.1 ntrval2
      difeq2d cJ ctop wcel cX cX cX cS cdif cJ ccl cfv cfv cdif cdif cJ ccld
      cfv wcel cS cX wss cJ ctop wcel cX cX cX cS cdif cJ ccl cfv cfv cdif cdif
      cX cS cdif cJ ccl cfv cfv cJ ccld cfv cJ ctop wcel cX cS cdif cJ ccl cfv
      cfv cX wss cX cX cX cS cdif cJ ccl cfv cfv cdif cdif cX cS cdif cJ ccl
      cfv cfv wceq cJ ctop wcel cX cS cdif cX wss cX cS cdif cJ ccl cfv cfv cX
      wss cX cS difss cX cS cdif cJ cX clscld.1 clsss3 mpan2 cX cS cdif cJ ccl
      cfv cfv cX dfss4 sylib cJ ctop wcel cX cS cdif cX wss cX cS cdif cJ ccl
      cfv cfv cJ ccld cfv wcel cX cS difss cX cS cdif cJ cX clscld.1 clscld
      mpan2 eqeltrd adantr eqeltrd $.
      $( [22-Apr-2008] $) $( [1-Oct-2007] $)

    $( A subset is closed iff it equals its own closure. $)
    iscld3 $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                 ( ( cls ` J ) ` S ) = S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccld cfv wcel cS cJ ccl cfv cfv cS wceq
      cJ ctop wcel cS cJ ccld cfv wcel cS cJ ccl cfv cfv cS wceq wi cS cX wss
      cJ ctop wcel cS cJ ccld cfv wcel cS cJ ccl cfv cfv cS wceq cS cJ cldcls
      ex adantr cS cJ ccl cfv cfv cS wceq cS cJ ccl cfv cfv cJ ccld cfv wcel cS
      cJ ccld cfv wcel cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS cJ ccld
      cfv eleq1 cS cJ cX clscld.1 clscld syl5cbi impbid $.
      $( [26-Feb-2007] $) $( [2-Oct-2006] $)

    $( A subset is closed iff it contains its own closure. $)
    iscld4 $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                 ( ( cls ` J ) ` S ) C_ S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccld cfv wcel cS cJ ccl cfv cfv cS wceq
      cS cJ ccl cfv cfv cS wss cS cJ cX clscld.1 iscld3 cJ ctop wcel cS cX wss
      wa cS cJ ccl cfv cfv cS wss cS cJ ccl cfv cfv cS wss cS cS cJ ccl cfv cfv
      wss wa cS cJ ccl cfv cfv cS wceq cJ ctop wcel cS cX wss wa cS cS cJ ccl
      cfv cfv wss cS cJ ccl cfv cfv cS wss cS cJ cX clscld.1 sscls biantrud cS
      cJ ccl cfv cfv cS eqss syl6rbbr bitrd $.
      $( [2-Feb-2008] $) $( [31-Jan-2008] $)

    $( A subset is open iff it equals its own interior. $)
    isopn3 $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. J <->
                 ( ( int ` J ) ` S ) = S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ wcel cS cJ cnt cfv cfv cS wceq cJ ctop
      wcel cS cX wss wa cS cJ wcel cS cJ cnt cfv cfv cS wceq cJ ctop wcel cS cX
      wss wa cS cJ wcel cS cJ cnt cfv cfv vx cv cS wss vx cJ crab cuni cS vx cS
      cJ cX clscld.1 ntrval vx cS cJ unimax sylan9eq ex cS cJ cnt cfv cfv cS
      wceq cS cJ cnt cfv cfv cJ wcel cS cJ wcel cJ ctop wcel cS cX wss wa cS cJ
      cnt cfv cfv cS cJ eleq1 cS cJ cX clscld.1 ntropn syl5cbi impbid $.
      $( [10-Oct-2006] $) $( [9-Oct-2006] $)

    $( The closure operation is idempotent. $)
    clsidm $p |- ( ( J e. Top /\ S C_ X ) ->
               ( ( cls ` J ) ` ( ( cls ` J ) ` S ) ) = ( ( cls ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cJ ccld cfv wcel cS cJ ccl
      cfv cfv cJ ccl cfv cfv cS cJ ccl cfv cfv wceq cS cJ cX clscld.1 clscld cJ
      ctop wcel cS cX wss cS cJ ccl cfv cfv cX wss cS cJ ccl cfv cfv cJ ccld
      cfv wcel cS cJ ccl cfv cfv cJ ccl cfv cfv cS cJ ccl cfv cfv wceq wb cS cJ
      cX clscld.1 clsss3 cS cJ ccl cfv cfv cJ cX clscld.1 iscld3 syldan mpbid
      $.
      $( [28-Apr-2008] $) $( [2-Oct-2007] $)

    $( The interior operation is idempotent. $)
    ntridm $p |- ( ( J e. Top /\ S C_ X ) ->
               ( ( int ` J ) ` ( ( int ` J ) ` S ) ) = ( ( int ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv cJ wcel cS cJ cnt cfv cfv cJ
      cnt cfv cfv cS cJ cnt cfv cfv wceq cS cJ cX clscld.1 ntropn cJ ctop wcel
      cS cX wss cS cJ cnt cfv cfv cX wss cS cJ cnt cfv cfv cJ wcel cS cJ cnt
      cfv cfv cJ cnt cfv cfv cS cJ cnt cfv cfv wceq wb cS cJ cX clscld.1 ntrss3
      cS cJ cnt cfv cfv cJ cX clscld.1 isopn3 syldan mpbid $.
      $( [4-May-2008] $) $( [2-Oct-2007] $)

    $( The closure of a topology's underlying set is entire set. $)
    clstop $p |- ( J e. Top -> ( ( cls ` J ) ` X ) = X ) $=
      cJ ctop wcel cX cJ ccld cfv wcel cX cJ ccl cfv cfv cX wceq cJ cX clscld.1
      topcld cJ ctop wcel cX cX wss cX cJ ccld cfv wcel cX cJ ccl cfv cfv cX
      wceq wb cX ssid cX cJ cX clscld.1 iscld3 mpan2 mpbid $.
      $( [18-May-2008] $) $( [5-Oct-2007] $)

    $( The interior of a topology's underlying set is entire set. $)
    ntrtop $p |- ( J e. Top -> ( ( int ` J ) ` X ) = X ) $=
      cJ ctop wcel cX cJ wcel cX cJ cnt cfv cfv cX wceq cJ cX clscld.1 topopn
      cJ ctop wcel cX cX wss cX cJ wcel cX cJ cnt cfv cfv cX wceq wb cX ssid cX
      cJ cX clscld.1 isopn3 mpan2 mpbid $.
      $( [24-Sep-2006] $) $( [12-Sep-2006] $)

    $( A subset with an empty interior cannot cover a whole (nonempty)
       topology. $)
    0ntr $p |- ( ( ( J e. Top /\ X =/= (/) ) /\ ( S C_ X
               /\ ( ( int ` J ) ` S ) = (/) ) ) -> ( X \ S ) =/= (/) ) $=
      cJ ctop wcel cS cX wss cS cJ cnt cfv cfv c0 wceq wa cX c0 wne cX cS cdif
      c0 wne cJ ctop wcel cS cX wss cS cJ cnt cfv cfv c0 wceq wa wa cX c0 wne
      cX cS cdif c0 wne cJ ctop wcel cS cX wss cS cJ cnt cfv cfv c0 wceq wa wa
      cX cS cdif c0 cX c0 cJ ctop wcel cS cX wss cS cJ cnt cfv cfv c0 wceq wa
      wa cX cS wss cX c0 wceq cX cS cdif c0 wceq cJ ctop wcel cS cX wss cS cJ
      cnt cfv cfv c0 wceq cX cS wss cX c0 wceq wi cJ ctop wcel cS cX wss cX cS
      wss cS cJ cnt cfv cfv c0 wceq cX c0 wceq cJ ctop wcel cS cX wss cX cS wss
      cS cJ cnt cfv cfv c0 wceq cX c0 wceq wi cJ ctop wcel cS cX wceq cS cJ cnt
      cfv cfv c0 wceq cX c0 wceq wi cS cX wss cX cS wss wa cJ ctop wcel cS cX
      wceq cS cJ cnt cfv cfv c0 wceq cX c0 wceq wi cJ ctop wcel cS cX wceq wa
      cS cJ cnt cfv cfv c0 wceq cX c0 wceq cJ ctop wcel cS cX wceq wa cS cJ cnt
      cfv cfv cX c0 cS cX wceq cJ ctop wcel cS cJ cnt cfv cfv cX cJ cnt cfv cfv
      cX cS cX cJ cnt cfv fveq2 cJ cX clscld.1 ntrtop sylan9eqr eqeq1d biimpd
      ex cS cX eqss syl5ibr exp3a com34 imp32 cX cS ssdif0 syl5ibr necon3d imp
      an1rs $.
      $( [2-Nov-2006] $) $( [12-Sep-2006] $)

    $( If a subset is included in a closed set, so is the subset's closure. $)
    clsss2 $p |- ( ( J e. Top /\ C e. ( Clsd ` J ) /\ S C_ C ) ->
                 ( ( cls ` J ) ` S ) C_ C ) $=
      cJ ctop wcel cC cJ ccld cfv wcel cS cC wss w3a cS cJ ccl cfv cfv cC cJ
      ccl cfv cfv cC cJ ctop wcel cC cX wss cS cC wss cS cJ ccl cfv cfv cC cJ
      ccl cfv cfv wss cC cJ ccld cfv wcel cC cS cJ cX clscld.1 clsss cJ ctop
      wcel cC cJ ccld cfv wcel cC cX wss cS cC wss cC cJ cX clscld.1 cldss
      3adant3 syld3an2 cJ ctop wcel cC cJ ccld cfv wcel cC cJ ccl cfv cfv cC
      wceq cS cC wss cC cJ cldcls 3adant3 sseqtrd $.
      $( [28-Feb-2007] $) $( [22-Feb-2007] $)

    $( Membership in a closure.  Theorem 6.5(a) of [Munkres] p. 95. $)
    elcls $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) -> ( P e. ( ( cls ` J ) ` S
                ) <-> A. x e. J ( P e. x -> ( x i^i S ) =/= (/) ) ) ) $=
      cJ ctop wcel cS cX wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel cP vx cv
      wcel vx cv cS cin c0 wne wi vx cJ wral cJ ctop wcel cS cX wss cP cX wcel
      w3a cP cS cJ ccl cfv cfv wcel wn cP vx cv wcel vx cv cS cin c0 wne wn wa
      vx cJ wrex cP vx cv wcel vx cv cS cin c0 wne wi vx cJ wral wn cJ ctop
      wcel cS cX wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel wn cP vx cv wcel
      vx cv cS cin c0 wne wn wa vx cJ wrex cX cS cJ ccl cfv cfv cdif cJ wcel cP
      cX cS cJ ccl cfv cfv cdif wcel cX cS cJ ccl cfv cfv cdif cS cin c0 wne wn
      wa cP vx cv wcel vx cv cS cin c0 wne wn wa vx cJ wrex cJ ctop wcel cS cX
      wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel wn wa cP vx cv wcel vx cv cS
      cin c0 wne wn wa cP cX cS cJ ccl cfv cfv cdif wcel cX cS cJ ccl cfv cfv
      cdif cS cin c0 wne wn wa vx cX cS cJ ccl cfv cfv cdif cJ vx cv cX cS cJ
      ccl cfv cfv cdif wceq cP vx cv wcel cP cX cS cJ ccl cfv cfv cdif wcel vx
      cv cS cin c0 wne wn cX cS cJ ccl cfv cfv cdif cS cin c0 wne wn vx cv cX
      cS cJ ccl cfv cfv cdif cP eleq2 vx cv cX cS cJ ccl cfv cfv cdif wceq vx
      cv cS cin c0 wne cX cS cJ ccl cfv cfv cdif cS cin c0 wne vx cv cX cS cJ
      ccl cfv cfv cdif wceq vx cv cS cin cX cS cJ ccl cfv cfv cdif cS cin c0 vx
      cv cX cS cJ ccl cfv cfv cdif cS ineq1 neeq1d notbid anbi12d rcla4ev cJ
      ctop wcel cS cX wss cP cX wcel w3a cX cS cJ ccl cfv cfv cdif cJ wcel cP
      cS cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cX cS cJ ccl cfv cfv
      cdif cJ wcel cP cX wcel cS cJ cX clscld.1 cmclsopn 3adant3 adantr cJ ctop
      wcel cS cX wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel wn wa cP cX cS cJ
      ccl cfv cfv cdif wcel cX cS cJ ccl cfv cfv cdif cS cin c0 wne wn cP cX
      wcel cJ ctop wcel cP cS cJ ccl cfv cfv wcel wn cP cX cS cJ ccl cfv cfv
      cdif wcel cS cX wss cP cX cS cJ ccl cfv cfv cdif wcel cP cX wcel cP cS cJ
      ccl cfv cfv wcel wn wa cP cX cS cJ ccl cfv cfv eldif biimpri 3ad2antl3 cJ
      ctop wcel cS cX wss cP cX wcel w3a cX cS cJ ccl cfv cfv cdif cS cin c0
      wne wn cP cS cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cX cS cJ ccl
      cfv cfv cdif cS cin c0 wne wn cP cX wcel cJ ctop wcel cS cX wss wa cS cX
      cS cJ ccl cfv cfv cdif cin c0 wceq cX cS cJ ccl cfv cfv cdif cS cin c0
      wne wn cJ ctop wcel cS cX wss wa cS cX cS cJ ccl cfv cfv cdif cin c0 wceq
      cS cX cX cS cJ ccl cfv cfv cdif cdif wss cJ ctop wcel cS cX wss wa cS cX
      cS cJ ccl cfv cfv cin cX cX cS cJ ccl cfv cfv cdif cdif cJ ctop wcel cS
      cX wss wa cS cX wss cS cS cJ ccl cfv cfv wss wa cS cX cS cJ ccl cfv cfv
      cin wss cJ ctop wcel cS cX wss wa cS cX wss cS cS cJ ccl cfv cfv wss cJ
      ctop wcel cS cX wss pm3.27 cS cJ cX clscld.1 sscls jca cS cX cS cJ ccl
      cfv cfv ssin sylib cX cS cJ ccl cfv cfv dfin4 syl6ss cS cX wss cS cX cS
      cJ ccl cfv cfv cdif cin c0 wceq cS cX cX cS cJ ccl cfv cfv cdif cdif wss
      wb cJ ctop wcel cS cX cS cJ ccl cfv cfv cdif cX reldisj adantl mpbird cX
      cS cJ ccl cfv cfv cdif cS cin c0 wne wn cX cS cJ ccl cfv cfv cdif cS cin
      c0 wceq cS cX cS cJ ccl cfv cfv cdif cin c0 wceq cX cS cJ ccl cfv cfv
      cdif cS cin c0 nne cX cS cJ ccl cfv cfv cdif cS cin cS cX cS cJ ccl cfv
      cfv cdif cin c0 cX cS cJ ccl cfv cfv cdif cS incom eqeq1i bitri sylibr
      3adant3 adantr jca sylanc cJ ctop wcel cS cX wss cP vx cv wcel vx cv cS
      cin c0 wne wn wa vx cJ wrex cP cS cJ ccl cfv cfv wcel wn cP cX wcel cJ
      ctop wcel cS cX wss wa cP vx cv wcel vx cv cS cin c0 wne wn wa vx cJ wrex
      cP cS cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss wa cP vx cv wcel vx
      cv cS cin c0 wne wn wa cP cS cJ ccl cfv cfv wcel wn vx cJ cJ ctop wcel cS
      cX wss wa vx cv cJ wcel cP vx cv wcel vx cv cS cin c0 wne wn cP cS cJ ccl
      cfv cfv wcel wn cJ ctop wcel cS cX wss wa vx cv cJ wcel vx cv cS cin c0
      wne wn cP vx cv wcel cP cS cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss
      wa vx cv cJ wcel vx cv cS cin c0 wne wn cP vx cv wcel cP cS cJ ccl cfv
      cfv wcel wn wi cJ ctop wcel cS cX wss wa vx cv cJ wcel wa cS vx cv cin c0
      wceq cP vx cv wcel cP cS cJ ccl cfv cfv wcel wn wi vx cv cS cin c0 wne wn
      cJ ctop wcel cS cX wss wa vx cv cJ wcel wa cS vx cv cin c0 wceq wa cP cS
      cJ ccl cfv cfv wcel cP vx cv wcel cJ ctop wcel cS cX wss wa vx cv cJ wcel
      wa cS vx cv cin c0 wceq wa cP cS cJ ccl cfv cfv wcel cP cX vx cv cdif
      wcel cP vx cv wcel wn cJ ctop wcel cS cX wss wa vx cv cJ wcel wa cS vx cv
      cin c0 wceq wa cS cJ ccl cfv cfv cX vx cv cdif cP cJ ctop wcel cX vx cv
      cdif cJ ccld cfv wcel cS cX vx cv cdif wss cS cJ ccl cfv cfv cX vx cv
      cdif wss cJ ctop wcel cS cX wss wa vx cv cJ wcel wa cS vx cv cin c0 wceq
      wa cX vx cv cdif cS cJ cX clscld.1 clsss2 cJ ctop wcel cS cX wss vx cv cJ
      wcel cS vx cv cin c0 wceq simplll cJ ctop wcel cS cX wss wa vx cv cJ wcel
      wa cX vx cv cdif cJ ccld cfv wcel cS vx cv cin c0 wceq cJ ctop wcel vx cv
      cJ wcel cX vx cv cdif cJ ccld cfv wcel cS cX wss vx cv cJ cX clscld.1
      opncld adantlr adantr cJ ctop wcel cS cX wss wa cS vx cv cin c0 wceq cS
      cX vx cv cdif wss vx cv cJ wcel cS cX wss cS vx cv cin c0 wceq cS cX vx
      cv cdif wss cJ ctop wcel cS cX wss cS vx cv cin c0 wceq cS cX vx cv cdif
      wss cS vx cv cX reldisj biimpa adantll adantlr syl3anc sseld cP cX vx cv
      eldifn syl6 con2d cS vx cv cin c0 wceq vx cv cS cin c0 wceq vx cv cS cin
      c0 wne wn cS vx cv cin vx cv cS cin c0 cS vx cv incom eqeq1i vx cv cS cin
      c0 wne vx cv cS cin c0 wceq vx cv cS cin c0 df-ne con2bii bitri sylan2br
      exp31 com34 imp4a r19.23adv imp 3adantl3 impbida cP vx cv wcel vx cv cS
      cin c0 wne vx cJ rexanali syl6bb con4bid $.
      $( [28-Feb-2007] $) $( [22-Feb-2007] $)

    $( Membership in a closure. $)
    elcls2 $p |- ( ( J e. Top /\ S C_ X ) -> ( P e. ( ( cls ` J ) ` S
         ) <-> ( P e. X /\ A. x e. J ( P e. x -> ( x i^i S ) =/= (/) ) ) ) ) $=
      cJ ctop wcel cS cX wss wa cP cS cJ ccl cfv cfv wcel cP cX wcel cP cS cJ
      ccl cfv cfv wcel wa cP cX wcel cP vx cv wcel vx cv cS cin c0 wne wi vx cJ
      wral wa cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cX wss cP cS cJ ccl
      cfv cfv wcel cP cX wcel cP cS cJ ccl cfv cfv wcel wa wb cS cJ cX clscld.1
      clsss3 cS cJ ccl cfv cfv cX wss cP cS cJ ccl cfv cfv wcel cP cX wcel cS
      cJ ccl cfv cfv cX cP ssel pm4.71rd syl cJ ctop wcel cS cX wss wa cP cX
      wcel cP cS cJ ccl cfv cfv wcel cP vx cv wcel vx cv cS cin c0 wne wi vx cJ
      wral cJ ctop wcel cS cX wss cP cX wcel cP cS cJ ccl cfv cfv wcel cP vx cv
      wcel vx cv cS cin c0 wne wi vx cJ wral wb vx cP cS cJ cX clscld.1 elcls
      3expa pm5.32da bitrd $.
      $( [16-Mar-2007] $) $( [5-Mar-2007] $)

    $( Any open set containing a point that belongs to the closure of a subset
       intersects the subset.  One direction of Theorem 6.5(a) of [Munkres]
       p. 95. $)
    clsndisj $p |- ( ( ( J e. Top /\ S C_ X /\ P e. ( ( cls ` J ) ` S ) ) /\
               ( U e. J /\ P e. U ) ) -> ( U i^i S ) =/= (/) ) $=
      cP vx cv wcel vx cv cS cin c0 wne wi vx cJ wral cU cJ wcel cP cU wcel wa
      cU cS cin c0 wne cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel w3a cP
      vx cv wcel vx cv cS cin c0 wne wi vx cJ wral cU cJ wcel cP cU wcel cU cS
      cin c0 wne cP vx cv wcel vx cv cS cin c0 wne wi cP cU wcel cU cS cin c0
      wne wi vx cU cJ vx cv cU wceq cP vx cv wcel cP cU wcel vx cv cS cin c0
      wne cU cS cin c0 wne vx cv cU cP eleq2 vx cv cU wceq vx cv cS cin cU cS
      cin c0 vx cv cU cS ineq1 neeq1d imbi12d rcla4cv imp32 cJ ctop wcel cS cX
      wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel cP vx cv wcel vx cv cS cin
      c0 wne wi vx cJ wral cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel w3a
      cJ ctop wcel cS cX wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel cP vx cv
      wcel vx cv cS cin c0 wne wi vx cJ wral vx cP cS cJ cX clscld.1 elcls
      biimpa cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel w3a cJ ctop wcel
      cS cX wss cP cX wcel cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel
      3simp1 cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel 3simp2 cJ ctop
      wcel cS cX wss cP cS cJ ccl cfv cfv wcel cP cX wcel cJ ctop wcel cS cX
      wss wa cS cJ ccl cfv cfv cX cP cS cJ cX clscld.1 clsss3 sseld 3impia 3jca
      cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel 3simp3 sylanc sylan $.
      $( [2-Mar-2007] $) $( [26-Feb-2007] $)

    $( A subset whose closure has an empty interior also has an empty
       interior. $)
    ntrcls0 $p |- ( ( J e. Top /\ S C_ X /\ ( ( int ` J ) `
                ( ( cls ` J ) ` S ) ) = (/) ) -> ( ( int ` J ) ` S ) = (/) ) $=
      cJ ctop wcel cS cX wss cS cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq w3a cS cJ
      cnt cfv cfv c0 wss cS cJ cnt cfv cfv c0 wceq cJ ctop wcel cS cX wss cS cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq w3a cS cJ cnt cfv cfv cS cJ ccl cfv
      cfv cJ cnt cfv cfv wss cS cJ cnt cfv cfv c0 wss cJ ctop wcel cS cX wss cS
      cJ cnt cfv cfv cS cJ ccl cfv cfv cJ cnt cfv cfv wss cS cJ ccl cfv cfv cJ
      cnt cfv cfv c0 wceq cJ ctop wcel cS cJ ccl cfv cfv cX wss cS cS cJ ccl
      cfv cfv wss cS cJ cnt cfv cfv cS cJ ccl cfv cfv cJ cnt cfv cfv wss cJ
      ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS cJ cX clscld.1 ntrss cJ ctop
      wcel cS cX wss pm3.26 cS cJ cX clscld.1 clsss3 cS cJ cX clscld.1 sscls
      syl3anc 3adant3 cS cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq cJ ctop wcel cS
      cJ cnt cfv cfv cS cJ ccl cfv cfv cJ cnt cfv cfv wss cS cJ cnt cfv cfv c0
      wss wb cS cX wss cS cJ ccl cfv cfv cJ cnt cfv cfv c0 cS cJ cnt cfv cfv
      sseq2 3ad2ant3 mpbid cS cJ cnt cfv cfv ss0 syl $.
      $( [20-May-2008] $) $( [4-Oct-2007] $)

    $( Two ways to say that a subset has an empty interior. $)
    ntreq0 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( ( int ` J ) ` S ) = (/) <->
               A. x e. J ( x C_ S -> x = (/) ) ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv c0 wceq vx cv cS wss vx cJ
      crab cuni c0 wceq vx cv cS wss vx cv c0 wceq wi vx cJ wral cJ ctop wcel
      cS cX wss wa cS cJ cnt cfv cfv vx cv cS wss vx cJ crab cuni c0 vx cS cJ
      cX clscld.1 ntrval eqeq1d vx cv cS wss vx cJ crab cuni c0 wceq vy cv vx
      cv wcel vx cv cS wss wa wn vy wal vx cJ wral vx cv cS wss vx cv c0 wceq
      wi vx cJ wral vy cv vx cv cS wss vx cJ crab cuni wcel vy cv c0 wcel wb vy
      wal vy cv vx cv wcel vx cv cS wss wa wn vx cJ wral vy wal vx cv cS wss vx
      cJ crab cuni c0 wceq vy cv vx cv wcel vx cv cS wss wa wn vy wal vx cJ
      wral vy cv vx cv cS wss vx cJ crab cuni wcel vy cv c0 wcel wb vy cv vx cv
      wcel vx cv cS wss wa wn vx cJ wral vy vy cv vx cv cS wss vx cJ crab cuni
      wcel wn vy cv vx cv wcel vx cv cS wss wa vx cJ wrex wn vy cv vx cv cS wss
      vx cJ crab cuni wcel vy cv c0 wcel wb vy cv vx cv wcel vx cv cS wss wa wn
      vx cJ wral vy cv vx cv cS wss vx cJ crab cuni wcel vy cv vx cv wcel vx cv
      cS wss wa vx cJ wrex vx cv cS wss vx vy cv cJ elunirab notbii vy cv c0
      wcel wn vy cv vx cv cS wss vx cJ crab cuni wcel vy cv c0 wcel wb vy cv vx
      cv cS wss vx cJ crab cuni wcel wn wb vy cv noel vy cv vx cv cS wss vx cJ
      crab cuni wcel vy cv c0 wcel bibif ax-mp vy cv vx cv wcel vx cv cS wss wa
      vx cJ ralnex 3bitr4i albii vy vx cv cS wss vx cJ crab cuni c0 dfcleq vy
      cv vx cv wcel vx cv cS wss wa wn vx vy cJ ralcom4 3bitr4i vy cv vx cv
      wcel vx cv cS wss wa wn vy wal vx cv cS wss vx cv c0 wceq wi vx cJ vy cv
      vx cv wcel vx cv cS wss wa wn vy wal vx cv c0 wceq wn vx cv cS wss wn wi
      vx cv cS wss vx cv c0 wceq wi vx cv c0 wceq wn vx cv cS wss wn wi vy cv
      vx cv wcel vy wex vx cv cS wss wn wi vy cv vx cv wcel vx cv cS wss wn wi
      vy wal vy cv vx cv wcel vx cv cS wss wa wn vy wal vx cv c0 wceq wn vy cv
      vx cv wcel vy wex vx cv cS wss wn vy vx cv neq0 imbi1i vy cv vx cv wcel
      vx cv cS wss wn vy 19.23v vy cv vx cv wcel vx cv cS wss wn wi vy cv vx cv
      wcel vx cv cS wss wa wn vy vy cv vx cv wcel vx cv cS wss imnan albii
      3bitr2ri vx cv cS wss vx cv c0 wceq con34b bitr4i ralbii bitri syl6bb $.
      $( [13-Nov-2007] $) $( [3-Oct-2007] $)
  $}

  $( The closure of the empty set. $)
  cls0 $p |- ( J e. Top -> ( ( cls ` J ) ` (/) ) = (/) ) $=
    cJ ctop wcel c0 cJ ccld cfv wcel c0 cJ ccl cfv cfv c0 wceq cJ 0cld cJ ctop
    wcel c0 cJ cuni wss c0 cJ ccld cfv wcel c0 cJ ccl cfv cfv c0 wceq wb cJ
    cuni 0ss c0 cJ cJ cuni cJ cuni eqid iscld3 mpan2 mpbid $.
    $( [23-May-2008] $) $( [2-Oct-2007] $)

  $( The interior of the empty set. $)
  ntr0 $p |- ( J e. Top -> ( ( int ` J ) ` (/) ) = (/) ) $=
    cJ ctop wcel c0 cJ wcel c0 cJ cnt cfv cfv c0 wceq cJ 0opn cJ ctop wcel c0
    cJ cuni wss c0 cJ wcel c0 cJ cnt cfv cfv c0 wceq wb cJ cuni 0ss c0 cJ cJ
    cuni cJ cuni eqid isopn3 mpan2 mpbid $.
    $( [15-Jun-2008] $) $( [2-Oct-2007] $)

  ${
    $d x y z B $.  $d x J $.  $d x y z P $.  $d x y z S $.  $d x U $.
    $d x X $.
    elcls3.1 $e |- J = ( topGen ` B ) $.
    elcls3.2 $e |- X = U. J $.
    $( Membership in a closure in terms of the members of a basis.  Theorem
       6.5(b) of [Munkres] p. 95. $)
    elcls3 $p |- ( ( B e. Bases /\ S C_ X /\ P e. X ) -> ( P e. ( ( cls ` J ) `
                 S ) <-> A. x e. B ( P e. x -> ( x i^i S ) =/= (/) ) ) ) $=
      cB ctb wcel cS cX wss cP cX wcel w3a cP cS cJ ccl cfv cfv wcel cP vx cv
      wcel vx cv cS cin c0 wne wi vx cJ wral cP vx cv wcel vx cv cS cin c0 wne
      wi vx cB wral cJ ctop wcel cS cX wss cP cX wcel cP cS cJ ccl cfv cfv wcel
      cP vx cv wcel vx cv cS cin c0 wne wi vx cJ wral wb cB ctb wcel vx cP cS
      cJ cX elcls3.2 elcls cB ctb wcel cB ctg cfv ctop cJ cB tgcl elcls3.1
      syl5eqel syl3an1 cB ctb wcel cS cX wss cP cX wcel w3a cP vx cv wcel vx cv
      cS cin c0 wne wi vx cJ wral cP vx cv wcel vx cv cS cin c0 wne wi vx cB
      wral cB ctb wcel cS cX wss cP vx cv wcel vx cv cS cin c0 wne wi vx cJ
      wral cP vx cv wcel vx cv cS cin c0 wne wi vx cB wral wi cP cX wcel cB ctb
      wcel cP vx cv wcel vx cv cS cin c0 wne wi cP vx cv wcel vx cv cS cin c0
      wne wi vx cJ cB cB ctb wcel vx cv cB wcel vx cv cJ wcel cP vx cv wcel vx
      cv cS cin c0 wne wi cB ctb wcel cB cJ vx cv cB ctb wcel cB cB ctg cfv cJ
      cB bastg elcls3.1 syl6ssr sseld imim1d r19.20dv2 3ad2ant1 cB ctb wcel cS
      cX wss cP vx cv wcel vx cv cS cin c0 wne wi vx cB wral cP vx cv wcel vx
      cv cS cin c0 wne wi vx cJ wral wi cP cX wcel cB ctb wcel cP vy cv wcel vy
      cv cS cin c0 wne wi vy cB wral cP vx cv wcel vx cv cS cin c0 wne wi vx cJ
      wral cP vx cv wcel vx cv cS cin c0 wne wi vx cB wral cB ctb wcel cP vy cv
      wcel vy cv cS cin c0 wne wi vy cB wral cP vx cv wcel vx cv cS cin c0 wne
      wi vx cJ cB ctb wcel cP vy cv wcel vy cv cS cin c0 wne wi vy cB wral vx
      cv cJ wcel cP vx cv wcel vx cv cS cin c0 wne cB ctb wcel cP vy cv wcel vy
      cv cS cin c0 wne wi vy cB wral wa vx cv cJ wcel cP vx cv wcel wa wa cP vz
      cv wcel vz cv vx cv wss wa vz cB wrex vx cv cS cin c0 wne cB ctb wcel vx
      cv cJ wcel cP vx cv wcel wa cP vz cv wcel vz cv vx cv wss wa vz cB wrex
      cP vy cv wcel vy cv cS cin c0 wne wi vy cB wral cB ctb wcel vx cv cJ wcel
      cP vx cv wcel cP vz cv wcel vz cv vx cv wss wa vz cB wrex cB ctb wcel vx
      cv cB ctg cfv wcel cP vx cv wcel cP vz cv wcel vz cv vx cv wss wa vz cB
      wrex vx cv cJ wcel vz vx cv cB cP tg2 cJ cB ctg cfv vx cv elcls3.1 eleq2i
      syl3an2b 3expb adantlr cP vy cv wcel vy cv cS cin c0 wne wi vy cB wral cP
      vz cv wcel vz cv vx cv wss wa vz cB wrex vx cv cS cin c0 wne wi cB ctb
      wcel vx cv cJ wcel cP vx cv wcel wa cP vy cv wcel vy cv cS cin c0 wne wi
      vy cB wral cP vz cv wcel vz cv vx cv wss wa vx cv cS cin c0 wne vz cB cP
      vy cv wcel vy cv cS cin c0 wne wi vy cB wral vz cv cB wcel cP vz cv wcel
      vz cv vx cv wss vx cv cS cin c0 wne cP vy cv wcel vy cv cS cin c0 wne wi
      vy cB wral vz cv cB wcel cP vz cv wcel vz cv vx cv wss vx cv cS cin c0
      wne wi vz cv vx cv wss vz cv cS cin c0 wne vx cv cS cin c0 wne cP vy cv
      wcel vy cv cS cin c0 wne wi vy cB wral vz cv cB wcel wa cP vz cv wcel wa
      vz cv vx cv wss vx cv cS cin c0 vz cv cS cin c0 vz cv vx cv wss vx cv cS
      cin c0 wceq vz cv cS cin c0 wceq vz cv vx cv cS ssdisj ex necon3d cP vy
      cv wcel vy cv cS cin c0 wne wi vy cB wral vz cv cB wcel wa cP vz cv wcel
      vz cv cS cin c0 wne cP vy cv wcel vy cv cS cin c0 wne wi cP vz cv wcel vz
      cv cS cin c0 wne wi vy vz cv cB vy cv vz cv wceq cP vy cv wcel cP vz cv
      wcel vy cv cS cin c0 wne vz cv cS cin c0 wne vy cv vz cv cP eleq2 vy cv
      vz cv wceq vy cv cS cin vz cv cS cin c0 vy cv vz cv cS ineq1 neeq1d
      imbi12d rcla4cva imp syl5com exp31 imp4a r19.23adv ad2antlr mpd exp43
      r19.21adv cP vx cv wcel vx cv cS cin c0 wne wi cP vy cv wcel vy cv cS cin
      c0 wne wi vx vy cB vx cv vy cv wceq cP vx cv wcel cP vy cv wcel vx cv cS
      cin c0 wne vy cv cS cin c0 wne vx cv vy cv cP eleq2 vx cv vy cv wceq vx
      cv cS cin vy cv cS cin c0 vx cv vy cv cS ineq1 neeq1d imbi12d cbvralv
      syl5ib 3ad2ant1 impbid bitrd $.
      $( [13-Mar-2007] $) $( [26-Feb-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Neighborhoods
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c nei $.

  $( Extend class notation with neighborhood relation for topologies. $)
  cnei $a class nei $.

  ${
    $d g j y v w z $.
    $( Define a function on topologies whose value is a map from a subset to
       its neighborhoods. $)
    df-nei $a |-  nei = { <. j , y >. | ( j e. Top /\ y = { <. z , v >. |
                         ( z C_ U. j /\ v = { w | ( w C_ U. j /\
                  E. g e. j ( z C_ g /\ g C_ w ) ) } ) } ) } $.
  $}

  ${
    $d g j v w y z J $.  $d g v z N $.  $d g P $.  $d g v w z S $.
    $d g j v w y z X $.
    neifval.1 $e |- X = U. J $.
    $( The neighborhood function on the subsets of a topology's base set. $)
    neifval $p |- ( J e. Top -> ( nei ` J ) =  { <. z , w >. |
                         ( z C_ X /\ w = { v | ( v C_ X /\
                  E. g e. J ( z C_ g /\ g C_ v ) ) } ) } ) $=
      cJ ctop wcel vz cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv
      wss wa vg cJ wrex wa vv cab wceq wa vz vw copab cvv wcel cJ cnei cfv vz
      cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ
      wrex wa vv cab wceq wa vz vw copab wceq cJ ctop wcel vz cv cX cpw wcel vw
      cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab
      wceq wa vz vw copab cvv vz cv cX wss vw cv vv cv cX wss vz cv vg cv wss
      vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab cJ ctop wcel
      cX cvv wcel cX cpw cvv wcel vz cv cX cpw wcel vw cv vv cv cX wss vz cv vg
      cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab cvv
      wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg neifval.1 syl5eqel cX cvv
      pwexg vz vw cX cpw vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ
      wrex wa vv cab cvv opabex2g 3syl vz cv cX cpw wcel vw cv vv cv cX wss vz
      cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz cv cX wss
      vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv
      cab wceq wa vz vw vz cv cX cpw wcel vz cv cX wss vw cv vv cv cX wss vz cv
      vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq vz cv cX vz visset
      elpw anbi1i opabbii syl5eqelr vj vy cJ vz cv vj cv cuni wss vw cv vv cv
      vj cv cuni wss vz cv vg cv wss vg cv vv cv wss wa vg vj cv wrex wa vv cab
      wceq wa vz vw copab vz cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg cv
      vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab ctop cvv cnei vj cv
      cJ wceq vz cv vj cv cuni wss vw cv vv cv vj cv cuni wss vz cv vg cv wss
      vg cv vv cv wss wa vg vj cv wrex wa vv cab wceq wa vz cv cX wss vw cv vv
      cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa
      vz vw vj cv cJ wceq vz cv vj cv cuni wss vz cv cX wss vw cv vv cv vj cv
      cuni wss vz cv vg cv wss vg cv vv cv wss wa vg vj cv wrex wa vv cab wceq
      vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv
      cab wceq vj cv cJ wceq vj cv cuni cX vz cv vj cv cJ wceq vj cv cuni cJ
      cuni cX vj cv cJ unieq neifval.1 syl6eqr sseq2d vj cv cJ wceq vv cv vj cv
      cuni wss vz cv vg cv wss vg cv vv cv wss wa vg vj cv wrex wa vv cab vv cv
      cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab vw cv vj
      cv cJ wceq vv cv vj cv cuni wss vz cv vg cv wss vg cv vv cv wss wa vg vj
      cv wrex wa vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa
      vv vj cv cJ wceq vv cv vj cv cuni wss vv cv cX wss vz cv vg cv wss vg cv
      vv cv wss wa vg vj cv wrex vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex
      vj cv cJ wceq vj cv cuni cX vv cv vj cv cJ wceq vj cv cuni cJ cuni cX vj
      cv cJ unieq neifval.1 syl6eqr sseq2d vz cv vg cv wss vg cv vv cv wss wa
      vg vj cv cJ rexeq1 anbi12d abbidv eqeq2d anbi12d opabbidv vy vz vv vw vg
      vj df-nei fvopab4g mpdan $.
      $( [15-Feb-2007] $) $( [11-Feb-2007] $)

    $( The neighborhood function is a function of the subsets of a topology's
       base set. $)
    neif $p |- ( J e. Top -> ( nei ` J ) Fn ~P X ) $=
      cJ ctop wcel cJ cnei cfv cX cpw wfn vz cv cX wss vw cv vv cv cX wss vz cv
      vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab cX
      cpw wfn cJ ctop wcel vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg
      cJ wrex wa vv cab cvv wcel vz cX cpw wral vz cv cX wss vw cv vv cv cX wss
      vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw
      copab cX cpw wfn cJ ctop wcel vv cv cX wss vz cv vg cv wss vg cv vv cv
      wss wa vg cJ wrex wa vv cab cvv wcel vz cX cpw cJ ctop wcel vv cv cX wss
      vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab cvv wcel vz cv cX
      cpw wcel cJ ctop wcel cX cvv wcel vv cv cX wss vz cv vg cv wss vg cv vv
      cv wss wa vg cJ wrex wa vv cab cvv wcel cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg neifval.1 syl5eqel vz cv vg cv wss vg cv vv cv wss wa vg cJ
      wrex vv cX cvv abssexg syl a1d r19.21aiv vz vw cX cpw vv cv cX wss vz cv
      vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab vz cv cX wss vw cv vv
      cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa
      vz vw copab vz cv cX cpw wcel vw cv vv cv cX wss vz cv vg cv wss vg cv vv
      cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab vz cv cX wss vw cv vv
      cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa
      vz vw copab vz cv cX cpw wcel vw cv vv cv cX wss vz cv vg cv wss vg cv vv
      cv wss wa vg cJ wrex wa vv cab wceq wa vz cv cX wss vw cv vv cv cX wss vz
      cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw vz cv
      cX cpw wcel vz cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv
      wss wa vg cJ wrex wa vv cab wceq vz cv cX vz visset elpw anbi1i opabbii
      eqcomi fnopab2g sylib cJ ctop wcel cJ cnei cfv vz cv cX wss vw cv vv cv
      cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz
      vw copab wceq cJ cnei cfv cX cpw wfn vz cv cX wss vw cv vv cv cX wss vz
      cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab
      cX cpw wfn wb vz vw vv vg cJ cX neifval.1 neifval cX cpw cJ cnei cfv vz
      cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ
      wrex wa vv cab wceq wa vz vw copab fneq1 syl mpbird $.
      $( [15-Feb-2007] $) $( [12-Feb-2007] $)

    $( A set with a neighborhood is a subset of the topology's base set.  (This
       theorem depends on a function's value being empty outside of its domain,
       but it will make later theorems simpler to state.) $)
    neiss2 $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) -> S C_ X ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cS cX cpw wcel cS cX wss cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel wa cS cJ cnei cfv cdm wcel cS cX cpw
      wcel cN cS cJ cnei cfv cfv wcel cS cJ cnei cfv cdm wcel cJ ctop wcel cN
      cS cJ cnei cfv elfvdm adantl cJ ctop wcel cS cJ cnei cfv cdm wcel cS cX
      cpw wcel wb cN cS cJ cnei cfv cfv wcel cJ ctop wcel cJ cnei cfv cdm cX
      cpw cS cJ ctop wcel cJ cnei cfv cX cpw wfn cJ cnei cfv cdm cX cpw wceq cJ
      cX neifval.1 neif cX cpw cJ cnei cfv fndm syl eleq2d adantr mpbid cJ ctop
      wcel cS cX cpw wcel cS cX wss wb cN cS cJ cnei cfv cfv wcel cJ ctop wcel
      cX cvv wcel cS cX cpw wcel cS cX wss wb cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg neifval.1 syl5eqel cS cX cvv elpw2g syl adantr mpbid $.
      $( [15-Feb-2007] $) $( [12-Feb-2007] $)

    $( The set of neighborhoods of a subset of the base set of a topology. $)
    neival $p |- ( ( J e. Top /\ S C_ X ) -> ( ( nei ` J ) ` S ) =
                 { v | ( v C_ X /\ E. g e. J ( S C_ g /\ g C_ v ) ) } ) $=
      cJ ctop wcel cS cX wss wa cS cJ cnei cfv cfv cS vz cv cX cpw wcel vw cv
      vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq
      wa vz vw copab cfv vv cv cX wss cS vg cv wss vg cv vv cv wss wa vg cJ
      wrex wa vv cab cJ ctop wcel cS cX wss wa cS cJ cnei cfv vz cv cX cpw wcel
      vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv
      cab wceq wa vz vw copab cJ ctop wcel cS cX wss wa cJ cnei cfv vz cv cX
      wss vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa
      vv cab wceq wa vz vw copab vz cv cX cpw wcel vw cv vv cv cX wss vz cv vg
      cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab cJ
      ctop wcel cJ cnei cfv vz cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg
      cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz vw copab wceq cS cX wss
      vz vw vv vg cJ cX neifval.1 neifval adantr vz cv cX cpw wcel vw cv vv cv
      cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq wa vz
      cv cX wss vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ
      wrex wa vv cab wceq wa vz vw vz cv cX cpw wcel vz cv cX wss vw cv vv cv
      cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq vz cv
      cX vz visset elpw anbi1i opabbii syl6eqr fveq1d cS cX cpw wcel vv cv cX
      wss cS vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab cvv wcel cS vz
      cv cX cpw wcel vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg
      cJ wrex wa vv cab wceq wa vz vw copab cfv vv cv cX wss cS vg cv wss vg cv
      vv cv wss wa vg cJ wrex wa vv cab wceq cJ ctop wcel cS cX wss wa vz vw cS
      vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab vv
      cv cX wss cS vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab cX cpw cvv
      vz cv cX cpw wcel vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa
      vg cJ wrex wa vv cab wceq wa vz vw copab vz cv cS wceq vv cv cX wss vz cv
      vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cv cX wss cS vg cv wss vg
      cv vv cv wss wa vg cJ wrex wa vv vz cv cS wceq vz cv vg cv wss vg cv vv
      cv wss wa vg cJ wrex cS vg cv wss vg cv vv cv wss wa vg cJ wrex vv cv cX
      wss vz cv cS wceq vz cv vg cv wss vg cv vv cv wss wa cS vg cv wss vg cv
      vv cv wss wa vg cJ vz cv cS wceq vz cv vg cv wss cS vg cv wss vg cv vv cv
      wss vz cv cS vg cv sseq1 anbi1d rexbidv anbi2d abbidv vz cv cX cpw wcel
      vw cv vv cv cX wss vz cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv
      cab wceq wa vz vw copab eqid fvopab4g cX cvv wcel cS cX wss cS cX cpw
      wcel cJ ctop wcel cX cvv wcel cS cX cpw wcel cS cX wss cS cX cvv elpw2g
      biimpar cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg neifval.1 syl5eqel
      sylan cJ ctop wcel vv cv cX wss cS vg cv wss vg cv vv cv wss wa vg cJ
      wrex wa vv cab cvv wcel cS cX wss cJ ctop wcel cX cvv wcel vv cv cX wss
      cS vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg neifval.1 syl5eqel cS vg cv wss vg cv
      vv cv wss wa vg cJ wrex vv cX cvv abssexg syl adantr sylanc eqtrd $.
      $( [16-Feb-2007] $) $( [11-Feb-2007] $)

    $( The predicate " ` N ` is a neighborhood of ` S ` ."  (Contributed
       by FL, 25-Sep-2006.) $)
    isnei $p |- ( ( J e. Top /\ S C_ X ) -> ( N e. ( ( nei ` J ) ` S ) <->
                 ( N C_ X /\ E. g e. J ( S C_ g /\ g C_ N ) ) ) ) $=
      cJ ctop wcel cS cX wss wa cN cS cJ cnei cfv cfv wcel cN vv cv cX wss cS
      vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wcel cN cX wss cS vg cv
      wss vg cv cN wss wa vg cJ wrex wa cJ ctop wcel cS cX wss wa cS cJ cnei
      cfv cfv vv cv cX wss cS vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab
      cN vv cS vg cJ cX neifval.1 neival eleq2d cJ ctop wcel cS cX wss wa cN cX
      wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa cN cvv wcel wi cN vv cv cX
      wss cS vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wcel cN cX wss
      cS vg cv wss vg cv cN wss wa vg cJ wrex wa wb cJ ctop wcel cS cX wss wa
      cN cX wss cN cvv wcel cS vg cv wss vg cv cN wss wa vg cJ wrex cJ ctop
      wcel cN cX wss cN cvv wcel wi cS cX wss cN cX wss cJ ctop wcel cN cvv
      wcel cN cX wss cX cvv wcel cN cvv wcel cJ ctop wcel cN cX cvv ssexg cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg neifval.1 syl5eqel sylan2 expcom
      adantr adantrd vv cv cX wss cS vg cv wss vg cv vv cv wss wa vg cJ wrex wa
      cN cX wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa vv cN cvv vv cv cN
      wceq vv cv cX wss cN cX wss cS vg cv wss vg cv vv cv wss wa vg cJ wrex cS
      vg cv wss vg cv cN wss wa vg cJ wrex vv cv cN cX sseq1 vv cv cN wceq cS
      vg cv wss vg cv vv cv wss wa cS vg cv wss vg cv cN wss wa vg cJ vv cv cN
      wceq vg cv vv cv wss vg cv cN wss cS vg cv wss vv cv cN vg cv sseq2
      anbi2d rexbidv anbi12d elab3g syl bitrd $.
      $( [16-Feb-2007] $) $( [11-Feb-2007] $)

    $( An intuitive definition of a neighborhood in terms of interior.
       (Contributed by Szymon Jaroszewicz, 18-Dec-2007.) $)
    neiint $p |- ( ( J e. Top /\ S C_ X /\ N C_ X ) ->
           ( N e. ( ( nei ` J ) ` S ) <-> S C_ ( ( int ` J ) ` N ) ) ) $=
      cJ ctop wcel cS cX wss cN cX wss w3a cN cX wss cS vv cv wss vv cv cN wss
      wa vv cJ wrex wa cS vg cv cN wss vg cJ crab cuni wss cN cS cJ cnei cfv
      cfv wcel cS cN cJ cnt cfv cfv wss cJ ctop wcel cS cX wss cN cX wss w3a cN
      cX wss cS vv cv wss vv cv cN wss wa vv cJ wrex wa cS vg cv cN wss vg cJ
      crab cuni wss cS vv cv wss vv cv cN wss wa vv cJ wrex cS vg cv cN wss vg
      cJ crab cuni wss cN cX wss cS vv cv wss vv cv cN wss wa cS vg cv cN wss
      vg cJ crab cuni wss vv cJ cS vv cv wss vv cv cJ wcel vv cv cN wss cS vg
      cv cN wss vg cJ crab cuni wss cS vv cv wss vv cv vg cv cN wss vg cJ crab
      wcel cS vg cv cN wss vg cJ crab cuni wss vv cv cJ wcel vv cv cN wss wa cS
      vv cv vg cv cN wss vg cJ crab ssuni vg cv cN wss vv cv cN wss vg vv cv cJ
      vg cv vv cv cN sseq1 elrab sylan2br an1s r19.23aiva adantl cJ ctop wcel
      cS cX wss cN cX wss w3a cS vg cv cN wss vg cJ crab cuni wss cS vv cv wss
      vv cv cN wss wa vv cJ wrex cN cX wss cJ ctop wcel cS cX wss cN cX wss w3a
      cS vg cv cN wss vg cJ crab cuni wss cS vv cv wss vv cv cN wss wa vv cJ
      wrex vg cv cN wss vg cJ crab cuni cJ wcel cS vg cv cN wss vg cJ crab cuni
      wss vg cv cN wss vg cJ crab cuni cN wss wa cS vv cv wss vv cv cN wss wa
      vv cJ wrex cJ ctop wcel cS cX wss cN cX wss w3a cS vg cv cN wss vg cJ
      crab cuni wss cS vv cv wss vv cv cN wss wa cS vg cv cN wss vg cJ crab
      cuni wss vg cv cN wss vg cJ crab cuni cN wss wa vv vg cv cN wss vg cJ
      crab cuni cJ vv cv vg cv cN wss vg cJ crab cuni wceq cS vv cv wss cS vg
      cv cN wss vg cJ crab cuni wss vv cv cN wss vg cv cN wss vg cJ crab cuni
      cN wss vv cv vg cv cN wss vg cJ crab cuni cS sseq2 vv cv vg cv cN wss vg
      cJ crab cuni cN sseq1 anbi12d rcla4ev cJ ctop wcel cS cX wss vg cv cN wss
      vg cJ crab cuni cJ wcel cN cX wss cJ ctop wcel vg cv cN wss vg cJ crab cJ
      wss vg cv cN wss vg cJ crab cuni cJ wcel vg cv cN wss vg cJ ssrab2 vg cv
      cN wss vg cJ crab cJ uniopn mpan2 3ad2ant1 cS vg cv cN wss vg cJ crab
      cuni wss vg cv cN wss vg cJ crab cuni cN wss vg cv cN wss vg cJ crab cuni
      cN wss vz cv cN wss vz vg cv cN wss vg cJ crab vz vg cv cN wss vg cJ crab
      cN unissb vz cv vg cv cN wss vg cJ crab wcel vz cv cJ wcel vz cv cN wss
      vg cv cN wss vz cv cN wss vg vz cv cJ vg cv vz cv cN sseq1 elrab pm3.27bi
      mprgbir jctr syl2an ex cJ ctop wcel cS cX wss cN cX wss 3simp3 jctild
      impbid2 cJ ctop wcel cS cX wss cN cS cJ cnei cfv cfv wcel cN cX wss cS vv
      cv wss vv cv cN wss wa vv cJ wrex wa wb cN cX wss cS vv cJ cN cX
      neifval.1 isnei 3adant3 cJ ctop wcel cS cX wss cN cX wss w3a cN cJ cnt
      cfv cfv vg cv cN wss vg cJ crab cuni cS cJ ctop wcel cN cX wss cN cJ cnt
      cfv cfv vg cv cN wss vg cJ crab cuni wceq cS cX wss vg cN cJ cX neifval.1
      ntrval 3adant2 sseq2d 3bitr4d $.
      $( [18-Dec-2007] $) $( [7-Sep-2007] $)

    $( The predicate " ` N ` is a neighborhood of point ` P ` ." $)
    isneip $p |- ( ( J e. Top /\ P e. X ) -> ( N e. ( ( nei ` J ) ` { P } ) <->
                 ( N C_ X /\ E. g e. J ( P e. g /\ g C_ N ) ) ) ) $=
      cJ ctop wcel cP cX wcel wa cN cP csn cJ cnei cfv cfv wcel cN cX wss cP
      csn vg cv wss vg cv cN wss wa vg cJ wrex wa cN cX wss cP vg cv wcel vg cv
      cN wss wa vg cJ wrex wa cJ ctop wcel cP csn cX wss cN cP csn cJ cnei cfv
      cfv wcel cN cX wss cP csn vg cv wss vg cv cN wss wa vg cJ wrex wa wb cP
      cX wcel cP csn vg cJ cN cX neifval.1 isnei cP cX snssi sylan2 cP cX wcel
      cN cX wss cP vg cv wcel vg cv cN wss wa vg cJ wrex wa cN cX wss cP csn vg
      cv wss vg cv cN wss wa vg cJ wrex wa wb cJ ctop wcel cP cX wcel cP vg cv
      wcel vg cv cN wss wa vg cJ wrex cP csn vg cv wss vg cv cN wss wa vg cJ
      wrex cN cX wss cP cX wcel cP vg cv wcel vg cv cN wss wa cP csn vg cv wss
      vg cv cN wss wa vg cJ cP cX wcel cP vg cv wcel cP csn vg cv wss vg cv cN
      wss cP vg cv cX snssg anbi1d rexbidv anbi2d adantl bitr4d $.
      $( [26-Feb-2007] $) $( [26-Feb-2007] $)

    $( A neighborhood is included in the topology's base set. $)
    neii1 $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) -> N C_ X ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cS cX wss cN cX wss cS cJ cN
      cX neifval.1 neiss2 cJ ctop wcel cN cS cJ cnei cfv cfv wcel cS cX wss cN
      cX wss wi cJ ctop wcel cS cX wss cN cS cJ cnei cfv cfv wcel cN cX wss cJ
      ctop wcel cS cX wss cN cS cJ cnei cfv cfv wcel cN cX wss wi cJ ctop wcel
      cS cX wss wa cN cS cJ cnei cfv cfv wcel cN cX wss cS vg cv wss vg cv cN
      wss wa vg cJ wrex wa cN cX wss cS vg cJ cN cX neifval.1 isnei cN cX wss
      cS vg cv wss vg cv cN wss wa vg cJ wrex pm3.26 syl6bi ex com23 imp mpd $.
      $( [16-Feb-2007] $) $( [12-Feb-2007] $)
  $}

  ${
    $d g J $.  $d g N $.  $d g R $.  $d g S $.
    $( Property of a neighborhood. $)
    neii2 $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) ->
                 E. g e. J ( S C_ g /\ g C_ N ) ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cS cJ cuni wss cS vg cv wss vg
      cv cN wss wa vg cJ wrex cS cJ cN cJ cuni cJ cuni eqid neiss2 cJ ctop wcel
      cN cS cJ cnei cfv cfv wcel cS cJ cuni wss cS vg cv wss vg cv cN wss wa vg
      cJ wrex wi cJ ctop wcel cS cJ cuni wss cN cS cJ cnei cfv cfv wcel cS vg
      cv wss vg cv cN wss wa vg cJ wrex cJ ctop wcel cS cJ cuni wss cN cS cJ
      cnei cfv cfv wcel cS vg cv wss vg cv cN wss wa vg cJ wrex wi cJ ctop wcel
      cS cJ cuni wss wa cN cS cJ cnei cfv cfv wcel cN cJ cuni wss cS vg cv wss
      vg cv cN wss wa vg cJ wrex wa cS vg cv wss vg cv cN wss wa vg cJ wrex cS
      vg cJ cN cJ cuni cJ cuni eqid isnei cN cJ cuni wss cS vg cv wss vg cv cN
      wss wa vg cJ wrex pm3.27 syl6bi ex com23 imp mpd $.
      $( [16-Feb-2007] $) $( [12-Feb-2007] $)

    $( Any neighborhood of a set ` S ` is also a neighborhood of any subset
       ` R C_ S ` .  Bourbaki TG I.2.  (Contributed by FL, 25-Sep-2006.) $)
    neiss $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) /\ R C_ S ) ->
                 N e. ( ( nei ` J ) ` R ) ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel cR cS wss w3a cN cR cJ cnei cfv
      cfv wcel cN cJ cuni wss cR vg cv wss vg cv cN wss wa vg cJ wrex wa cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel cR cS wss w3a cN cJ cuni wss cR vg
      cv wss vg cv cN wss wa vg cJ wrex cJ ctop wcel cN cS cJ cnei cfv cfv wcel
      cN cJ cuni wss cR cS wss cS cJ cN cJ cuni cJ cuni eqid neii1 3adant3 cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel cR cS wss w3a cS vg cv wss vg cv cN
      wss wa vg cJ wrex cR vg cv wss vg cv cN wss wa vg cJ wrex cJ ctop wcel cN
      cS cJ cnei cfv cfv wcel cS vg cv wss vg cv cN wss wa vg cJ wrex cR cS wss
      cS vg cJ cN neii2 3adant3 cR cS wss cJ ctop wcel cS vg cv wss vg cv cN
      wss wa vg cJ wrex cR vg cv wss vg cv cN wss wa vg cJ wrex wi cN cS cJ
      cnei cfv cfv wcel cR cS wss cS vg cv wss vg cv cN wss wa cR vg cv wss vg
      cv cN wss wa vg cJ cR cS wss cS vg cv wss cR vg cv wss vg cv cN wss cR cS
      vg cv sstr2 anim1d r19.22sdv 3ad2ant3 mpd jca cJ ctop wcel cR cJ cuni wss
      cN cR cJ cnei cfv cfv wcel cN cJ cuni wss cR vg cv wss vg cv cN wss wa vg
      cJ wrex wa wb cJ ctop wcel cN cS cJ cnei cfv cfv wcel cR cS wss w3a cR vg
      cJ cN cJ cuni cJ cuni eqid isnei cJ ctop wcel cN cS cJ cnei cfv cfv wcel
      cR cS wss 3simp1 cJ ctop wcel cN cS cJ cnei cfv cfv wcel cR cS wss w3a cR
      cS cJ cuni cJ ctop wcel cN cS cJ cnei cfv cfv wcel cR cS wss 3simp3 cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel cS cJ cuni wss cR cS wss cS cJ cN cJ
      cuni cJ cuni eqid neiss2 3adant3 sstrd sylanc mpbird $.
      $( [1-Mar-2007] $) $( [12-Feb-2007] $)

    $( A set is included in its neighborhoods.  Based on Bourbaki TG I.3 Viii.
       (Contributed by FL, 16-Nov-2006.) $)
    ssnei $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) -> S C_ N ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cS vg cv wss vg cv cN wss wa
      vg cJ wrex cS cN wss cS vg cJ cN neii2 cS vg cv wss vg cv cN wss wa cS cN
      wss vg cJ cS vg cv wss vg cv cN wss wa cS cN wss wi vg cv cJ wcel cS vg
      cv cN sstr a1i r19.23aiv syl $.
      $( [16-Feb-2007] $) $( [11-Feb-2007] $)
  $}

  $( A point belongs to any of its neighborhoods.  Based on Bourbaki TG I.3
     Viii.  (Contributed by FL, 28-Sep-2006.) $)
  elnei $p |- ( ( J e. Top /\ P e. A /\ N e. ( ( nei ` J ) ` { P } ) ) ->
              P e. N ) $=
    cJ ctop wcel cP cA wcel cN cP csn cJ cnei cfv cfv wcel w3a cP cN wcel cP
    csn cN wss cJ ctop wcel cN cP csn cJ cnei cfv cfv wcel cP csn cN wss cP cA
    wcel cP csn cJ cN ssnei 3adant2 cP cA wcel cJ ctop wcel cP cN wcel cP csn
    cN wss wb cN cP csn cJ cnei cfv cfv wcel cP cN cA snssg 3ad2ant2 mpbird $.
    $( [4-Mar-2007] $) $( [11-Feb-2007] $)

  $( The empty set is not a neighborhood of a nonempty set.  (Contributed by
     FL, 18-Sep-2007.) $)
  0nnei $p |- ( ( J e. Top /\ S =/= (/) ) -> -. (/) e. ( ( nei ` J ) ` S ) ) $=
    cJ ctop wcel cS c0 wne c0 cS cJ cnei cfv cfv wcel wn cJ ctop wcel c0 cS cJ
    cnei cfv cfv wcel cS c0 cJ ctop wcel c0 cS cJ cnei cfv cfv wcel cS c0 wceq
    cJ ctop wcel c0 cS cJ cnei cfv cfv wcel wa cS c0 wss cS c0 wceq cS cJ c0
    ssnei cS ss0b sylib ex necon3ad imp $.
    $( [8-Nov-2007] $) $( [18-Sep-2007] $)

  ${
    $d g h p v J $.  $d g M $.  $d g h p v N $.  $d g P $.  $d g h p S $.
    $d g h p X $.
    neips.1 $e |- X = U. J $.
    $( A neighborhood of a set is a neighborhood of every point in the set.
       Bourbaki TG I.2.  (Contributed by FL, 16-Nov-2006.) $)
    neips $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) ->
                ( N e. ( ( nei ` J ) ` S ) <->
                A. p e. S N e. ( ( nei ` J ) ` { p } ) ) ) $=
      cJ ctop wcel cS cX wss cS c0 wne w3a cN cS cJ cnei cfv cfv wcel cN vp cv
      csn cJ cnei cfv cfv wcel vp cS wral cJ ctop wcel cS cX wss cN cS cJ cnei
      cfv cfv wcel cN vp cv csn cJ cnei cfv cfv wcel vp cS wral wi cS c0 wne cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel cN vp cv csn cJ cnei cfv cfv wcel vp
      cS cJ ctop wcel cN cS cJ cnei cfv cfv wcel vp cv cS wcel cN vp cv csn cJ
      cnei cfv cfv wcel cJ ctop wcel cN cS cJ cnei cfv cfv wcel vp cv csn cS
      wss cN vp cv csn cJ cnei cfv cfv wcel vp cv cS wcel vp cv csn cS cJ cN
      neiss vp cv cS snssi syl3an3 3exp r19.21adv 3ad2ant1 cJ ctop wcel cS cX
      wss cS c0 wne w3a cN cX wss vp cv vg cv wcel vg cv cN wss wa vg cJ wrex
      wa vp cS wral cN cX wss cS vh cv wss vh cv cN wss wa vh cJ wrex wa cN vp
      cv csn cJ cnei cfv cfv wcel vp cS wral cN cS cJ cnei cfv cfv wcel cJ ctop
      wcel cS cX wss cS c0 wne w3a cN cX wss vp cv vg cv wcel vg cv cN wss wa
      vg cJ wrex wa vp cS wral cN cX wss vp cv vg cv wcel vg cv cN wss wa vg cJ
      wrex vp cS wral wa cN cX wss cS vh cv wss vh cv cN wss wa vh cJ wrex wa
      cS c0 wne cJ ctop wcel cN cX wss vp cv vg cv wcel vg cv cN wss wa vg cJ
      wrex wa vp cS wral cN cX wss vp cv vg cv wcel vg cv cN wss wa vg cJ wrex
      vp cS wral wa wb cS cX wss cN cX wss vp cv vg cv wcel vg cv cN wss wa vg
      cJ wrex vp cS r19.28zv 3ad2ant3 cJ ctop wcel cS cX wss cN cX wss vp cv vg
      cv wcel vg cv cN wss wa vg cJ wrex vp cS wral wa cN cX wss cS vh cv wss
      vh cv cN wss wa vh cJ wrex wa wi cS c0 wne cJ ctop wcel cS cX wss wa vp
      cv vg cv wcel vg cv cN wss wa vg cJ wrex vp cS wral cS vh cv wss vh cv cN
      wss wa vh cJ wrex cN cX wss cJ ctop wcel cS cX wss wa vp cv vg cv wcel vg
      cv cN wss wa vg cJ wrex vp cS wral cS vh cv wss vh cv cN wss wa vh cJ
      wrex vv cv cN wss vv cJ crab cuni cJ wcel cS vv cv cN wss vv cJ crab cuni
      wss vv cv cN wss vv cJ crab cuni cN wss wa cS vh cv wss vh cv cN wss wa
      vh cJ wrex cJ ctop wcel cS cX wss wa vp cv vg cv wcel vg cv cN wss wa vg
      cJ wrex vp cS wral wa cS vh cv wss vh cv cN wss wa cS vv cv cN wss vv cJ
      crab cuni wss vv cv cN wss vv cJ crab cuni cN wss wa vh vv cv cN wss vv
      cJ crab cuni cJ vh cv vv cv cN wss vv cJ crab cuni wceq cS vh cv wss cS
      vv cv cN wss vv cJ crab cuni wss vh cv cN wss vv cv cN wss vv cJ crab
      cuni cN wss vh cv vv cv cN wss vv cJ crab cuni cS sseq2 vh cv vv cv cN
      wss vv cJ crab cuni cN sseq1 anbi12d rcla4ev cJ ctop wcel vv cv cN wss vv
      cJ crab cuni cJ wcel cS cX wss vp cv vg cv wcel vg cv cN wss wa vg cJ
      wrex vp cS wral cJ ctop wcel vv cv cN wss vv cJ crab cJ wss vv cv cN wss
      vv cJ crab cuni cJ wcel vv cv cN wss vv cJ ssrab2 vv cv cN wss vv cJ crab
      cJ uniopn mpan2 ad2antrr cJ ctop wcel cS cX wss wa vp cv vg cv wcel vg cv
      cN wss wa vg cJ wrex vp cS wral wa cS vv cv cN wss vv cJ crab cuni wss vv
      cv cN wss vv cJ crab cuni cN wss vp cv vg cv wcel vg cv cN wss wa vg cJ
      wrex vp cS wral cS vv cv cN wss vv cJ crab cuni wss cJ ctop wcel cS cX
      wss wa vp cv vg cv wcel vg cv cN wss wa vg cJ wrex vp cS wral vp cv vv cv
      cN wss vv cJ crab cuni wcel vp cS wral cS vv cv cN wss vv cJ crab cuni
      wss vp cv vg cv wcel vg cv cN wss wa vg cJ wrex vp cv vv cv cN wss vv cJ
      crab cuni wcel vp cS vp cv vg cv wcel vg cv cN wss wa vp cv vv cv cN wss
      vv cJ crab cuni wcel vg cJ vp cv vg cv wcel vg cv cJ wcel vg cv cN wss vp
      cv vv cv cN wss vv cJ crab cuni wcel vp cv vg cv wcel vg cv vv cv cN wss
      vv cJ crab wcel vp cv vv cv cN wss vv cJ crab cuni wcel vg cv cJ wcel vg
      cv cN wss wa vp cv vg cv vv cv cN wss vv cJ crab elunii vv cv cN wss vg
      cv cN wss vv vg cv cJ vv cv vg cv cN sseq1 elrab sylan2br an1s r19.23aiva
      r19.20si vp cS vv cv cN wss vv cJ crab cuni dfss3 sylibr adantl vv cv cN
      wss vv cJ crab cuni cN wss vh cv cN wss vh vv cv cN wss vv cJ crab vh vv
      cv cN wss vv cJ crab cN unissb vh cv vv cv cN wss vv cJ crab wcel vh cv
      cJ wcel vh cv cN wss vv cv cN wss vh cv cN wss vv vh cv cJ vv cv vh cv cN
      sseq1 elrab pm3.27bi mprgbir jctir sylanc ex anim2d 3adant3 sylbid cJ
      ctop wcel cS cX wss cN vp cv csn cJ cnei cfv cfv wcel vp cS wral cN cX
      wss vp cv vg cv wcel vg cv cN wss wa vg cJ wrex wa vp cS wral wb cS c0
      wne cJ ctop wcel cS cX wss wa cN vp cv csn cJ cnei cfv cfv wcel cN cX wss
      vp cv vg cv wcel vg cv cN wss wa vg cJ wrex wa vp cS cJ ctop wcel cS cX
      wss vp cv cS wcel cN vp cv csn cJ cnei cfv cfv wcel cN cX wss vp cv vg cv
      wcel vg cv cN wss wa vg cJ wrex wa wb cJ ctop wcel vp cv cX wcel cN vp cv
      csn cJ cnei cfv cfv wcel cN cX wss vp cv vg cv wcel vg cv cN wss wa vg cJ
      wrex wa wb cS cX wss vp cv cS wcel wa vp cv vg cJ cN cX neips.1 isneip cS
      cX vp cv ssel2 sylan2 anassrs ralbidva 3adant3 cJ ctop wcel cS cX wss cN
      cS cJ cnei cfv cfv wcel cN cX wss cS vh cv wss vh cv cN wss wa vh cJ wrex
      wa wb cS c0 wne cS vh cJ cN cX neips.1 isnei 3adant3 3imtr4d impbid $.
      $( [4-Mar-2007] $) $( [11-Feb-2007] $)

    $( An open set is a neighborhood of any of its subsets.  (Contributed by
       FL, 2-Oct-2006.) $)
    opnneissb $p |- ( ( J e. Top /\ N e. J /\ S C_ X ) ->
                   ( S C_ N <-> N e. ( ( nei ` J ) ` S ) ) ) $=
      cJ ctop wcel cN cJ wcel cS cX wss w3a cS cN wss cN cS cJ cnei cfv cfv
      wcel cJ ctop wcel cN cJ wcel cS cX wss cS cN wss cN cS cJ cnei cfv cfv
      wcel wi cJ ctop wcel cN cJ wcel cS cX wss cS cN wss cN cS cJ cnei cfv cfv
      wcel cJ ctop wcel cN cJ wcel wa cS cX wss cS cN wss wa wa cN cS cJ cnei
      cfv cfv wcel cN cX wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa cJ ctop
      wcel cN cJ wcel wa cS cX wss cS cN wss wa wa cN cX wss cS vg cv wss vg cv
      cN wss wa vg cJ wrex cJ ctop wcel cN cJ wcel wa cN cX wss cS cX wss cS cN
      wss wa cN cJ cX neips.1 eltopss adantr cN cJ wcel cS cN wss cS vg cv wss
      vg cv cN wss wa vg cJ wrex cJ ctop wcel cS cX wss cN cJ wcel cS cN wss cN
      cN wss cS vg cv wss vg cv cN wss wa vg cJ wrex cN ssid cS vg cv wss vg cv
      cN wss wa cS cN wss cN cN wss wa vg cN cJ vg cv cN wceq cS vg cv wss cS
      cN wss vg cv cN wss cN cN wss vg cv cN cS sseq2 vg cv cN cN sseq1 anbi12d
      rcla4ev mpanr2 ad2ant2l jca cJ ctop wcel cS cX wss cN cS cJ cnei cfv cfv
      wcel cN cX wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa wb cN cJ wcel
      cS cN wss cS vg cJ cN cX neips.1 isnei ad2ant2r mpbird exp43 3imp cJ ctop
      wcel cN cJ wcel cN cS cJ cnei cfv cfv wcel cS cN wss wi cS cX wss cJ ctop
      wcel cN cS cJ cnei cfv cfv wcel cS cN wss cS cJ cN ssnei ex 3ad2ant1
      impbid $.
      $( [16-Feb-2007] $) $( [12-Feb-2007] $)

    $( Any superset of an open set is a neighborhood of it. $)
    opnssneib $p |- ( ( J e. Top /\ S e. J /\ N C_ X ) ->
                   ( S C_ N <-> N e. ( ( nei ` J ) ` S ) ) ) $=
      cJ ctop wcel cS cJ wcel cN cX wss w3a cS cN wss cN cS cJ cnei cfv cfv
      wcel cJ ctop wcel cS cJ wcel cN cX wss w3a cS cN wss cN cX wss cS vg cv
      wss vg cv cN wss wa vg cJ wrex wa cN cS cJ cnei cfv cfv wcel cS cJ wcel
      cN cX wss cS cN wss cN cX wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa
      wi cJ ctop wcel cS cJ wcel cN cX wss wa cS cN wss cN cX wss cS vg cv wss
      vg cv cN wss wa vg cJ wrex wa cS cJ wcel cN cX wss wa cS cN wss wa cN cX
      wss cS vg cv wss vg cv cN wss wa vg cJ wrex cS cJ wcel cN cX wss cS cN
      wss simplr cS cJ wcel cS cN wss cS vg cv wss vg cv cN wss wa vg cJ wrex
      cN cX wss cS vg cv wss vg cv cN wss wa cS cN wss vg cS cJ vg cv cS wceq
      cS vg cv wss vg cv cN wss wa cS cS wss cS cN wss wa cS cN wss vg cv cS
      wceq cS vg cv wss cS cS wss vg cv cN wss cS cN wss vg cv cS cS sseq2 vg
      cv cS cN sseq1 anbi12d cS cS wss cS cN wss cS ssid biantrur syl6bbr
      rcla4ev adantlr jca ex 3adant1 cJ ctop wcel cS cJ wcel cN cS cJ cnei cfv
      cfv wcel cN cX wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa wb cN cX
      wss cJ ctop wcel cS cJ wcel cS cX wss cN cS cJ cnei cfv cfv wcel cN cX
      wss cS vg cv wss vg cv cN wss wa vg cJ wrex wa wb cS cJ cX neips.1
      eltopss cS vg cJ cN cX neips.1 isnei syldan 3adant3 sylibrd cJ ctop wcel
      cS cJ wcel cN cS cJ cnei cfv cfv wcel cS cN wss wi cN cX wss cJ ctop wcel
      cN cS cJ cnei cfv cfv wcel cS cN wss cS cJ cN ssnei ex 3ad2ant1 impbid $.
      $( [16-Feb-2007] $) $( [14-Feb-2007] $)

    $( Any subset of ` X ` containing a neigborhood of a set is a neighborhood
       of this set.  Based on Bourbaki TG I.3 Vi.  (Contributed by FL,
       2-Oct-2006.) $)
    ssnei2 $p |- ( ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) /\
                 ( N C_ M /\ M C_ X ) ) -> M e. ( ( nei ` J ) ` S ) ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cN cM wss cM cX wss wa wa cM
      cS cJ cnei cfv cfv wcel cM cX wss cS vg cv wss vg cv cM wss wa vg cJ wrex
      wa cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cN cM wss cM cX wss wa wa
      cM cX wss cS vg cv wss vg cv cM wss wa vg cJ wrex cJ ctop wcel cN cS cJ
      cnei cfv cfv wcel wa cN cM wss cM cX wss simprr cJ ctop wcel cN cS cJ
      cnei cfv cfv wcel wa cN cM wss cS vg cv wss vg cv cM wss wa vg cJ wrex cM
      cX wss cS vg cv wss vg cv cN wss wa vg cJ wrex cN cM wss cS vg cv wss vg
      cv cM wss wa vg cJ wrex cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cN cM
      wss cS vg cv wss vg cv cN wss wa vg cJ wrex cS vg cv wss vg cv cM wss wa
      vg cJ wrex cN cM wss cS vg cv wss vg cv cN wss wa cS vg cv wss vg cv cM
      wss wa vg cJ cN cM wss vg cv cN wss vg cv cM wss cS vg cv wss vg cv cN
      wss cN cM wss vg cv cM wss vg cv cN cM sstr2 com12 anim2d r19.22sdv
      impcom cS vg cJ cN neii2 sylan adantrr jca cJ ctop wcel cN cS cJ cnei cfv
      cfv wcel wa cM cS cJ cnei cfv cfv wcel cM cX wss cS vg cv wss vg cv cM
      wss wa vg cJ wrex wa wb cN cM wss cM cX wss wa cJ ctop wcel cN cS cJ cnei
      cfv cfv wcel cS cX wss cM cS cJ cnei cfv cfv wcel cM cX wss cS vg cv wss
      vg cv cM wss wa vg cJ wrex wa wb cS cJ cN cX neips.1 neiss2 cS vg cJ cM
      cX neips.1 isnei syldan adantr mpbird $.
      $( [4-Mar-2007] $) $( [13-Feb-2007] $)

    $( Any neighborhood of an element in the closure of a subset intersects the
       subset.  Part of proof of Theorem 6.6 of [Munkres] p. 97. $)
    neindisj $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( P e. ( ( cls ` J ) ` S ) /\
                   N e. ( ( nei ` J ) ` { P } ) ) ) -> ( N i^i S ) =/= (/) ) $=
      cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel cN cP csn cJ cnei cfv
      cfv wcel cN cS cin c0 wne cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv
      wcel cN cP csn cJ cnei cfv cfv wcel cN cS cin c0 wne wi cJ ctop wcel cS
      cX wss cP cS cJ ccl cfv cfv wcel wa wa cN cP csn cJ cnei cfv cfv wcel cN
      cX wss cP vg cv wcel vg cv cN wss wa vg cJ wrex wa cN cS cin c0 wne cJ
      ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel wa cP cX wcel cN cP csn cJ
      cnei cfv cfv wcel cN cX wss cP vg cv wcel vg cv cN wss wa vg cJ wrex wa
      wb cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel cP cX wcel cJ ctop
      wcel cS cX wss cP cS cJ ccl cfv cfv wcel cP cX wcel wi cJ ctop wcel cS cX
      wss wa cS cJ ccl cfv cfv cX cP cS cJ cX neips.1 clsss3 sseld ex imp32 cP
      vg cJ cN cX neips.1 isneip syldan cJ ctop wcel cS cX wss cP cS cJ ccl cfv
      cfv wcel wa wa cN cX wss cP vg cv wcel vg cv cN wss wa vg cJ wrex cN cS
      cin c0 wne cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel wa wa cN cX
      wss wa cP vg cv wcel vg cv cN wss wa cN cS cin c0 wne vg cJ cJ ctop wcel
      cS cX wss cP cS cJ ccl cfv cfv wcel wa wa cN cX wss wa vg cv cJ wcel wa
      cP vg cv wcel vg cv cN wss wa cN cS cin c0 wne cJ ctop wcel cS cX wss cP
      cS cJ ccl cfv cfv wcel wa wa cN cX wss wa vg cv cJ wcel wa cP vg cv wcel
      vg cv cN wss wa wa vg cv cS cin c0 wne cN cS cin c0 wne cJ ctop wcel cS
      cX wss cP cS cJ ccl cfv cfv wcel wa wa cN cX wss wa vg cv cJ wcel wa cP
      vg cv wcel vg cv cS cin c0 wne vg cv cN wss cJ ctop wcel cS cX wss cP cS
      cJ ccl cfv cfv wcel wa wa vg cv cJ wcel cP vg cv wcel vg cv cS cin c0 wne
      cN cX wss cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel wa wa vg cv cJ
      wcel cP vg cv wcel vg cv cS cin c0 wne cJ ctop wcel cS cX wss cP cS cJ
      ccl cfv cfv wcel w3a vg cv cJ wcel cP vg cv wcel wa vg cv cS cin c0 wne
      cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel wa wa cP cS vg cv cJ cX
      neips.1 clsndisj cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel 3anass
      sylanbr anassrs adantllr adantrr vg cv cN wss vg cv cS cin c0 wne cN cS
      cin c0 wne wi cJ ctop wcel cS cX wss cP cS cJ ccl cfv cfv wcel wa wa cN
      cX wss wa vg cv cJ wcel wa cP vg cv wcel vg cv cN wss cN cS cin c0 vg cv
      cS cin c0 vg cv cN wss cN cS cin c0 wceq vg cv cS cin c0 wceq vg cv cN cS
      ssdisj ex necon3d ad2antll mpd ex r19.23adva expimpd sylbid exp32 imp43
      $.
      $( [2-Mar-2007] $) $( [26-Feb-2007] $)
  $}

  $( An open set is a neighborhood of any of its subsets. $)
  opnneiss $p |- ( ( J e. Top /\ N e. J /\ S C_ N ) ->
                  N e. ( ( nei ` J ) ` S ) ) $=
    cJ ctop wcel cN cJ wcel cS cN wss w3a cS cN wss cN cS cJ cnei cfv cfv wcel
    cJ ctop wcel cN cJ wcel cS cN wss 3simp3 cJ ctop wcel cN cJ wcel cS cJ cuni
    wss cS cN wss cN cS cJ cnei cfv cfv wcel wb cS cN wss cS cJ cN cJ cuni cJ
    cuni eqid opnneissb cJ ctop wcel cN cJ wcel cS cN wss cS cJ cuni wss cN cJ
    cuni wss cS cN wss cS cJ cuni wss cJ ctop wcel cN cJ wcel wa cS cN wss cN
    cJ cuni wss cS cJ cuni wss cS cN cJ cuni sstr ancoms cN cJ cJ cuni cJ cuni
    eqid eltopss sylan 3impa syld3an3 mpbid $.
    $( [16-Feb-2007] $) $( [13-Feb-2007] $)

  $( An open set is a neighborhood of any of its members. $)
  opnneip $p |- ( ( J e. Top /\ N e. J /\ P e. N ) ->
                  N e. ( ( nei ` J ) ` { P } ) ) $=
    cJ ctop wcel cN cJ wcel cP csn cN wss cN cP csn cJ cnei cfv cfv wcel cP cN
    wcel cP csn cJ cN opnneiss cP cN snssi syl3an3 $.
    $( [8-Mar-2007] $) $( [8-Mar-2007] $)

  ${
    $d J x $.  $d S x $.  $d X x $.
    tpnei.1 $e |- X = U. J $.
    $( The underlying set of a topology is a neighborhood of any of its
       subsets.  Special case of ~ opnneiss .  (Contributed by FL,
       2-Oct-2006.) $)
    tpnei $p |- ( J e. Top -> ( S C_ X <-> X e. ( ( nei ` J ) ` S ) ) ) $=
      cJ ctop wcel cS cX wss cX cS cJ cnei cfv cfv wcel cJ ctop wcel cX cJ wcel
      cS cX wss cX cS cJ cnei cfv cfv wcel wi cJ cX tpnei.1 topopn cJ ctop wcel
      cX cJ wcel cS cX wss cX cS cJ cnei cfv cfv wcel cS cJ cX opnneiss 3exp
      mpd cJ ctop wcel cX cS cJ cnei cfv cfv wcel cS cX wss cS cJ cX ssnei ex
      impbid $.
      $( [1-Mar-2007] $) $( [14-Feb-2007] $)

    $( The union of the neighborhoods of a set equals the topology's underlying
       set.  (Contributed by FL, 18-Sep-2007.) $)
    unnei $p |- ( ( J e. Top /\ S C_ X ) -> U. ( ( nei ` J ) ` S ) = X ) $=
      cS cJ cnei cfv cfv cuni cX wss cX cS cJ cnei cfv cfv wcel cS cJ cnei cfv
      cfv cuni cX wceq cJ ctop wcel cS cX wss wa cS cJ cnei cfv cfv cX unissel
      cJ ctop wcel cS cX wss wa vx cv cX wss vx cS cJ cnei cfv cfv wral cS cJ
      cnei cfv cfv cuni cX wss cJ ctop wcel cS cX wss wa vx cv cX wss vx cS cJ
      cnei cfv cfv cJ ctop wcel vx cv cS cJ cnei cfv cfv wcel vx cv cX wss wi
      cS cX wss cJ ctop wcel vx cv cS cJ cnei cfv cfv wcel vx cv cX wss cS cJ
      vx cv cX tpnei.1 neii1 ex adantr r19.21aiv vx cS cJ cnei cfv cfv cX
      unissb sylibr cJ ctop wcel cS cX wss cX cS cJ cnei cfv cfv wcel cS cJ cX
      tpnei.1 tpnei biimpa sylanc $.
      $( [8-Nov-2007] $) $( [18-Sep-2007] $)
  $}

  ${
    $d g h v x y J $.  $d g h v M $.  $d g h v x y N $.  $d g h v x y S $.
    $( The intersection of two neighborhoods of a set is also a neighborhood of
       the set.  Based on Bourbaki TG I.3 Vii.  (Contributed by FL,
       28-Sep-2006.) $)
    innei $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S )
   /\ M e. ( ( nei ` J ) ` S ) ) -> ( N i^i M ) e. ( ( nei ` J ) ` S ) ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel cM cS cJ cnei cfv cfv wcel w3a cN
      cM cin cS cJ cnei cfv cfv wcel cN cM cin cJ cuni wss cS vg cv wss vg cv
      cN cM cin wss wa vg cJ wrex wa cJ ctop wcel cN cS cJ cnei cfv cfv wcel cM
      cS cJ cnei cfv cfv wcel w3a cN cM cin cJ cuni wss cS vg cv wss vg cv cN
      cM cin wss wa vg cJ wrex cJ ctop wcel cN cS cJ cnei cfv cfv wcel cN cM
      cin cJ cuni wss cM cS cJ cnei cfv cfv wcel cJ ctop wcel cN cS cJ cnei cfv
      cfv wcel wa cN cJ cuni wss cN cM cin cJ cuni wss cS cJ cN cJ cuni cJ cuni
      eqid neii1 cN cM cJ cuni ssinss1 syl 3adant3 cJ ctop wcel cN cS cJ cnei
      cfv cfv wcel cM cS cJ cnei cfv cfv wcel cS vg cv wss vg cv cN cM cin wss
      wa vg cJ wrex cJ ctop wcel cN cS cJ cnei cfv cfv wcel cM cS cJ cnei cfv
      cfv wcel wa cS vh cv wss vh cv cN wss wa vh cJ wrex cS vv cv wss vv cv cM
      wss wa vv cJ wrex wa cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel cM cS cJ cnei cfv cfv wcel cS vh cv
      wss vh cv cN wss wa vh cJ wrex cS vv cv wss vv cv cM wss wa vv cJ wrex wa
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cS vh cv wss vh cv cN wss wa
      vh cJ wrex cJ ctop wcel cM cS cJ cnei cfv cfv wcel wa cS vv cv wss vv cv
      cM wss wa vv cJ wrex cS vh cJ cN neii2 cS vv cJ cM neii2 anim12i anandis
      cJ ctop wcel cS vh cv wss vh cv cN wss wa vh cJ wrex cS vv cv wss vv cv
      cM wss wa vv cJ wrex cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex cJ
      ctop wcel cS vh cv wss vh cv cN wss wa cS vv cv wss vv cv cM wss wa vv cJ
      wrex cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex wi vh cJ cJ ctop wcel
      vh cv cJ wcel wa cS vh cv wss vh cv cN wss wa cS vv cv wss vv cv cM wss
      wa vv cJ wrex cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex wi cJ ctop
      wcel vh cv cJ wcel wa cS vh cv wss vh cv cN wss wa wa cS vv cv wss vv cv
      cM wss wa cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex vv cJ cJ ctop
      wcel vh cv cJ wcel wa vv cv cJ wcel cS vh cv wss vh cv cN wss wa cS vv cv
      wss vv cv cM wss wa cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex wi cJ
      ctop wcel vh cv cJ wcel wa vv cv cJ wcel wa cS vh cv wss vh cv cN wss wa
      wa cS vv cv wss vv cv cM wss wa cS vg cv wss vg cv cN cM cin wss wa vg cJ
      wrex cJ ctop wcel vh cv cJ wcel wa vv cv cJ wcel wa cS vh cv wss vh cv cN
      wss wa cS vv cv wss vv cv cM wss wa cS vg cv wss vg cv cN cM cin wss wa
      vg cJ wrex vh cv vv cv cin cJ wcel cS vh cv vv cv cin wss vh cv vv cv cin
      cN cM cin wss wa cS vg cv wss vg cv cN cM cin wss wa vg cJ wrex cJ ctop
      wcel vh cv cJ wcel wa vv cv cJ wcel wa cS vh cv wss vh cv cN wss wa cS vv
      cv wss vv cv cM wss wa wa cS vg cv wss vg cv cN cM cin wss wa cS vh cv vv
      cv cin wss vh cv vv cv cin cN cM cin wss wa vg vh cv vv cv cin cJ vg cv
      vh cv vv cv cin wceq cS vg cv wss cS vh cv vv cv cin wss vg cv cN cM cin
      wss vh cv vv cv cin cN cM cin wss vg cv vh cv vv cv cin cS sseq2 vg cv vh
      cv vv cv cin cN cM cin sseq1 anbi12d rcla4ev cJ ctop wcel vh cv cJ wcel
      vv cv cJ wcel vh cv vv cv cin cJ wcel vh cv vv cv cJ inopn 3expa cS vh cv
      wss cS vv cv wss vh cv cN wss vv cv cM wss cS vh cv vv cv cin wss vh cv
      vv cv cin cN cM cin wss wa cS vh cv wss cS vv cv wss wa cS vh cv vv cv
      cin wss vh cv cN wss vv cv cM wss wa vh cv vv cv cin cN cM cin wss cS vh
      cv wss cS vv cv wss wa cS vh cv vv cv cin wss cS vh cv vv cv ssin biimpi
      vh cv cN vv cv cM ss2in anim12i an4s syl2an anassrs ex an1rs r19.23adva
      ex r19.23adva imp32 syldan 3impb jca cJ ctop wcel cN cS cJ cnei cfv cfv
      wcel cN cM cin cS cJ cnei cfv cfv wcel cN cM cin cJ cuni wss cS vg cv wss
      vg cv cN cM cin wss wa vg cJ wrex wa wb cM cS cJ cnei cfv cfv wcel cJ
      ctop wcel cN cS cJ cnei cfv cfv wcel cS cJ cuni wss cN cM cin cS cJ cnei
      cfv cfv wcel cN cM cin cJ cuni wss cS vg cv wss vg cv cN cM cin wss wa vg
      cJ wrex wa wb cS cJ cN cJ cuni cJ cuni eqid neiss2 cS vg cJ cN cM cin cJ
      cuni cJ cuni eqid isnei syldan 3adant3 mpbird $.
      $( [4-Mar-2007] $) $( [12-Feb-2007] $)

    $( Only an open set is a neighborhood of itself.  (Contributed by FL,
       2-Oct-2006.) $)
    opnneiid $p |- ( J e. Top -> ( N e. ( ( nei ` J ) ` N ) <-> N e. J ) ) $=
      cJ ctop wcel cN cN cJ cnei cfv cfv wcel cN cJ wcel cJ ctop wcel cN cN cJ
      cnei cfv cfv wcel cN cJ wcel cJ ctop wcel cN cN cJ cnei cfv cfv wcel wa
      cN vx cv wss vx cv cN wss wa vx cJ wrex cN cJ wcel cN vx cJ cN neii2 cN
      vx cv wss vx cv cN wss wa cN cJ wcel vx cJ vx cv cJ wcel cN vx cv wceq cN
      cJ wcel cN vx cv wss vx cv cN wss wa vx cv cJ cN eleq1a cN vx cv eqss
      syl5ibr r19.23aiv syl ex cJ ctop wcel cN cJ wcel cN cN wss cN cN cJ cnei
      cfv cfv wcel cN ssid cJ ctop wcel cN cJ wcel cN cN wss cN cN cJ cnei cfv
      cfv wcel cN cJ cN opnneiss 3exp mpii impbid $.
      $( [1-Mar-2007] $) $( [13-Feb-2007] $)

    $( For any neighborhood ` N ` of ` S ` , there is a neighborhood ` x ` of
       ` S ` such that ` N ` is a neighborhood of all subsets of ` x ` .  Based
       on Bourbaki TG I.3 Viv.  (Contributed by FL, 2-Oct-2006.) $)
    neissex $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) ->
   E. x e. ( ( nei ` J ) ` S ) A. y ( y C_ x -> N e. ( ( nei ` J ) ` y ) ) ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cS vx cv wss vx cv cN wss wa
      vx cJ wrex vy cv vx cv wss cN vy cv cJ cnei cfv cfv wcel wi vy wal vx cS
      cJ cnei cfv cfv wrex cS vx cJ cN neii2 cJ ctop wcel cN cS cJ cnei cfv cfv
      wcel wa cS vx cv wss vx cv cN wss wa vy cv vx cv wss cN vy cv cJ cnei cfv
      cfv wcel wi vy wal vx cJ cS cJ cnei cfv cfv cJ ctop wcel cN cS cJ cnei
      cfv cfv wcel wa vx cv cJ wcel cS vx cv wss vx cv cN wss wa wa vx cv cS cJ
      cnei cfv cfv wcel vy cv vx cv wss cN vy cv cJ cnei cfv cfv wcel wi vy wal
      wa cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa vx cv cJ wcel cS vx cv wss
      vx cv cN wss wa wa wa vx cv cS cJ cnei cfv cfv wcel vy cv vx cv wss cN vy
      cv cJ cnei cfv cfv wcel wi vy wal cJ ctop wcel vx cv cJ wcel cS vx cv wss
      vx cv cN wss wa wa vx cv cS cJ cnei cfv cfv wcel cN cS cJ cnei cfv cfv
      wcel cJ ctop wcel vx cv cJ wcel cS vx cv wss vx cv cS cJ cnei cfv cfv
      wcel vx cv cN wss cJ ctop wcel vx cv cJ wcel cS vx cv wss vx cv cS cJ
      cnei cfv cfv wcel cS cJ vx cv opnneiss 3expb adantrrr adantlr cJ ctop
      wcel cN cS cJ cnei cfv cfv wcel wa vx cv cJ wcel cS vx cv wss vx cv cN
      wss wa wa wa vy cv vx cv wss cN vy cv cJ cnei cfv cfv wcel wi vy cJ ctop
      wcel cN cS cJ cnei cfv cfv wcel wa vx cv cJ wcel vx cv cN wss vy cv vx cv
      wss cN vy cv cJ cnei cfv cfv wcel wi cS vx cv wss cJ ctop wcel cN cS cJ
      cnei cfv cfv wcel wa vx cv cJ wcel vx cv cN wss wa wa vy cv vx cv wss cN
      vy cv cJ cnei cfv cfv wcel cJ ctop wcel cN vx cv cJ cnei cfv cfv wcel vy
      cv vx cv wss cN vy cv cJ cnei cfv cfv wcel cJ ctop wcel cN cS cJ cnei cfv
      cfv wcel wa vx cv cJ wcel vx cv cN wss wa wa vy cv vx cv wss wa vy cv vx
      cv cJ cN neiss cJ ctop wcel cN cS cJ cnei cfv cfv wcel vx cv cJ wcel vx
      cv cN wss wa vy cv vx cv wss simplll cJ ctop wcel cN cS cJ cnei cfv cfv
      wcel wa vx cv cJ wcel vx cv cN wss wa wa cN vx cv cJ cnei cfv cfv wcel vy
      cv vx cv wss cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa vx cv cJ wcel vx
      cv cN wss cN vx cv cJ cnei cfv cfv wcel cJ ctop wcel cN cS cJ cnei cfv
      cfv wcel wa vx cv cJ wcel wa vx cv cN wss cN vx cv cJ cnei cfv cfv wcel
      cJ ctop wcel vx cv cJ wcel cN cJ cuni wss vx cv cN wss cN vx cv cJ cnei
      cfv cfv wcel wb cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa vx cv cJ wcel
      wa vx cv cJ cN cJ cuni cJ cuni eqid opnssneib cJ ctop wcel cN cS cJ cnei
      cfv cfv wcel vx cv cJ wcel simpll cJ ctop wcel cN cS cJ cnei cfv cfv wcel
      wa vx cv cJ wcel pm3.27 cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa cN cJ
      cuni wss vx cv cJ wcel cS cJ cN cJ cuni cJ cuni eqid neii1 adantr syl3anc
      biimpa anasss adantr cJ ctop wcel cN cS cJ cnei cfv cfv wcel wa vx cv cJ
      wcel vx cv cN wss wa wa vy cv vx cv wss pm3.27 syl3anc ex adantrrl
      19.21aiv jca ex r19.22dv2 mpd $.
      $( [4-Mar-2007] $) $( [13-Feb-2007] $)
  $}

  $( The empty set is a neighborhood of itself.  (Contributed by FL,
     10-Dec-2006.) $)
  0nei $p |- ( J e. Top -> (/) e. ( ( nei ` J ) ` (/) ) ) $=
    cJ ctop wcel c0 c0 cJ cnei cfv cfv wcel c0 cJ wcel cJ 0opn cJ c0 opnneiid
    mpbird $.
    $( [1-Mar-2007] $) $( [14-Feb-2007] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Limit points
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c limPt $.

  $( Extend class notation with the limit point function for topologies. $)
  clp $a class limPt $.

  ${
    $d v w x y z $.
    $( Define a function on topologies whose value is the set of limit points
       of the subsets of the base set.  See ~ lpval . $)
    df-lp $a |- limPt = { <. z , w >. | ( z e. Top /\ w = { <. x , y >. |
                         ( x C_ U. z /\ y = { v |
                 v e. ( ( cls ` J ) ` ( x \ { v } ) ) } ) } ) } $.
  $}

  ${
    $d n v w x y z J $.  $d n x y z S $.  $d n w x y z X $.  $d n x y P $.
    lpfval.1 $e |- X = U. J $.
    $( The limit point function on the subsets of a topology's base set. $)
    lpfval $p |- ( J e. Top -> ( limPt ` J ) =  { <. x , y >. | ( x C_ X /\
                     y = { v |
                 v e. ( ( cls ` J ) ` ( x \ { v } ) ) } ) } ) $=
      cJ ctop wcel vx cv cX wss vy cv vv cv vx cv vv cv csn cdif cJ ccl cfv cfv
      wcel vv cab wceq wa vx vy copab cvv wcel cJ clp cfv vx cv cX wss vy cv vv
      cv vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv cab wceq wa vx vy copab
      wceq cJ ctop wcel vx cv cX cpw wcel vy cv vv cv vx cv vv cv csn cdif cJ
      ccl cfv cfv wcel vv cab wceq wa vx vy copab cvv vx cv cX wss vy cv vv cv
      vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv cab wceq wa vx vy copab cJ
      ctop wcel cX cvv wcel cX cpw cvv wcel vx cv cX cpw wcel vy cv vv cv vx cv
      vv cv csn cdif cJ ccl cfv cfv wcel vv cab wceq wa vx vy copab cvv wcel cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg lpfval.1 syl5eqel cX cvv pwexg vx
      vy cX cpw vv cv vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv cab cvv
      opabex2g 3syl vx cv cX cpw wcel vy cv vv cv vx cv vv cv csn cdif cJ ccl
      cfv cfv wcel vv cab wceq wa vx cv cX wss vy cv vv cv vx cv vv cv csn cdif
      cJ ccl cfv cfv wcel vv cab wceq wa vx vy vx cv cX cpw wcel vx cv cX wss
      vy cv vv cv vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv cab wceq vx cv cX
      vx visset elpw anbi1i opabbii syl5eqelr vz vw cJ vx cv vz cv cuni wss vy
      cv vv cv vx cv vv cv csn cdif vz cv ccl cfv cfv wcel vv cab wceq wa vx vy
      copab vx cv cX wss vy cv vv cv vx cv vv cv csn cdif cJ ccl cfv cfv wcel
      vv cab wceq wa vx vy copab ctop cvv clp vz cv cJ wceq vx cv vz cv cuni
      wss vy cv vv cv vx cv vv cv csn cdif vz cv ccl cfv cfv wcel vv cab wceq
      wa vx cv cX wss vy cv vv cv vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv
      cab wceq wa vx vy vz cv cJ wceq vx cv vz cv cuni wss vx cv cX wss vy cv
      vv cv vx cv vv cv csn cdif vz cv ccl cfv cfv wcel vv cab wceq vy cv vv cv
      vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv cab wceq vz cv cJ wceq vz cv
      cuni cX vx cv vz cv cJ wceq vz cv cuni cJ cuni cX vz cv cJ unieq lpfval.1
      syl6eqr sseq2d vz cv cJ wceq vv cv vx cv vv cv csn cdif vz cv ccl cfv cfv
      wcel vv cab vv cv vx cv vv cv csn cdif cJ ccl cfv cfv wcel vv cab vy cv
      vz cv cJ wceq vv cv vx cv vv cv csn cdif vz cv ccl cfv cfv wcel vv cv vx
      cv vv cv csn cdif cJ ccl cfv cfv wcel vv vz cv cJ wceq vx cv vv cv csn
      cdif vz cv ccl cfv cfv vx cv vv cv csn cdif cJ ccl cfv cfv vv cv vz cv cJ
      wceq vx cv vv cv csn cdif vz cv ccl cfv cJ ccl cfv vz cv cJ ccl fveq2
      fveq1d eleq2d abbidv eqeq2d anbi12d opabbidv vx vy vz vw vv vz cv df-lp
      fvopab4g mpdan $.
      $( [25-Feb-2007] $) $( [10-Feb-2007] $)

    $( The set of limit points of a subset of the base set of a topology.
       Alternate definition of limit point in [Munkres] p. 97. $)
    lpval $p |- ( ( J e. Top /\ S C_ X ) -> ( ( limPt ` J ) ` S ) =
                 { x | x e. ( ( cls ` J ) ` ( S \ { x } ) ) } ) $=
      cJ ctop wcel cS cX wss wa cS cJ clp cfv cfv cS vy cv cX cpw wcel vz cv vx
      cv vy cv vx cv csn cdif cJ ccl cfv cfv wcel vx cab wceq wa vy vz copab
      cfv vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cab cJ ctop wcel cS cX
      wss wa cS cJ clp cfv vy cv cX cpw wcel vz cv vx cv vy cv vx cv csn cdif
      cJ ccl cfv cfv wcel vx cab wceq wa vy vz copab cJ ctop wcel cS cX wss wa
      cJ clp cfv vy cv cX wss vz cv vx cv vy cv vx cv csn cdif cJ ccl cfv cfv
      wcel vx cab wceq wa vy vz copab vy cv cX cpw wcel vz cv vx cv vy cv vx cv
      csn cdif cJ ccl cfv cfv wcel vx cab wceq wa vy vz copab cJ ctop wcel cJ
      clp cfv vy cv cX wss vz cv vx cv vy cv vx cv csn cdif cJ ccl cfv cfv wcel
      vx cab wceq wa vy vz copab wceq cS cX wss vy vz vx cJ cX lpfval.1 lpfval
      adantr vy cv cX cpw wcel vz cv vx cv vy cv vx cv csn cdif cJ ccl cfv cfv
      wcel vx cab wceq wa vy cv cX wss vz cv vx cv vy cv vx cv csn cdif cJ ccl
      cfv cfv wcel vx cab wceq wa vy vz vy cv cX cpw wcel vy cv cX wss vz cv vx
      cv vy cv vx cv csn cdif cJ ccl cfv cfv wcel vx cab wceq vy cv cX vy
      visset elpw anbi1i opabbii syl6eqr fveq1d cS cX cpw wcel vx cv cS vx cv
      csn cdif cJ ccl cfv cfv wcel vx cab cvv wcel cS vy cv cX cpw wcel vz cv
      vx cv vy cv vx cv csn cdif cJ ccl cfv cfv wcel vx cab wceq wa vy vz copab
      cfv vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cab wceq cJ ctop wcel
      cS cX wss wa vy vz cS vx cv vy cv vx cv csn cdif cJ ccl cfv cfv wcel vx
      cab vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cab cX cpw cvv vy cv
      cX cpw wcel vz cv vx cv vy cv vx cv csn cdif cJ ccl cfv cfv wcel vx cab
      wceq wa vy vz copab vy cv cS wceq vx cv vy cv vx cv csn cdif cJ ccl cfv
      cfv wcel vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx vy cv cS wceq vy
      cv vx cv csn cdif cJ ccl cfv cfv cS vx cv csn cdif cJ ccl cfv cfv vx cv
      vy cv cS wceq vy cv vx cv csn cdif cS vx cv csn cdif cJ ccl cfv vy cv cS
      vx cv csn difeq1 fveq2d eleq2d abbidv vy cv cX cpw wcel vz cv vx cv vy cv
      vx cv csn cdif cJ ccl cfv cfv wcel vx cab wceq wa vy vz copab eqid
      fvopab4g cX cvv wcel cS cX wss cS cX cpw wcel cJ ctop wcel cX cvv wcel cS
      cX cpw wcel cS cX wss cS cX cvv elpw2g biimpar cJ ctop wcel cJ cuni cvv
      cX cJ ctop uniexg lpfval.1 syl5eqel sylan cJ ctop wcel cS cX wss wa vx cv
      cS vx cv csn cdif cJ ccl cfv cfv wcel vx cab vx cv cS cJ ccl cfv cfv wcel
      vx cab wss vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cab cvv wcel cJ
      ctop wcel cS cX wss wa vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cv
      cS cJ ccl cfv cfv wcel wi vx wal vx cv cS vx cv csn cdif cJ ccl cfv cfv
      wcel vx cab vx cv cS cJ ccl cfv cfv wcel vx cab wss cJ ctop wcel cS cX
      wss wa vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cv cS cJ ccl cfv
      cfv wcel wi vx cJ ctop wcel cS cX wss wa cS vx cv csn cdif cJ ccl cfv cfv
      cS cJ ccl cfv cfv vx cv cJ ctop wcel cS cX wss cS vx cv csn cdif cS wss
      cS vx cv csn cdif cJ ccl cfv cfv cS cJ ccl cfv cfv wss cS vx cv csn difss
      cS cS vx cv csn cdif cJ cX lpfval.1 clsss mp3an3 sseld 19.21aiv vx cv cS
      vx cv csn cdif cJ ccl cfv cfv wcel vx cv cS cJ ccl cfv cfv wcel vx ss2ab
      sylibr vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cab vx cv cS cJ ccl
      cfv cfv wcel vx cab vx cv cS cJ ccl cfv cfv wcel vx cab cS cJ ccl cfv cfv
      cvv vx cS cJ ccl cfv cfv abid2 cS cJ ccl cfv fvex eqeltri ssex syl sylanc
      eqtrd $.
      $( [26-Feb-2007] $) $( [10-Feb-2007] $)

    $( The predicate " ` P ` is a limit point of ` S ` ." $)
    islp $p |- ( ( J e. Top /\ S C_ X ) -> ( P e. ( ( limPt ` J ) ` S ) <->
               P e. ( ( cls ` J ) ` ( S \ { P } ) ) ) ) $=
      cJ ctop wcel cS cX wss wa cP cS cJ clp cfv cfv wcel cP vx cv cS vx cv csn
      cdif cJ ccl cfv cfv wcel vx cab wcel cP cS cP csn cdif cJ ccl cfv cfv
      wcel cJ ctop wcel cS cX wss wa cS cJ clp cfv cfv vx cv cS vx cv csn cdif
      cJ ccl cfv cfv wcel vx cab cP vx cS cJ cX lpfval.1 lpval eleq2d vx cv cS
      vx cv csn cdif cJ ccl cfv cfv wcel cP cS cP csn cdif cJ ccl cfv cfv wcel
      vx cP cP cS cP csn cdif cJ ccl cfv cfv elisset vx cv cP wceq vx cv cP cS
      vx cv csn cdif cJ ccl cfv cfv cS cP csn cdif cJ ccl cfv cfv vx cv cP wceq
      id vx cv cP wceq cS vx cv csn cdif cS cP csn cdif cJ ccl cfv vx cv cP
      wceq vx cv csn cP csn cS vx cv cP sneq difeq2d fveq2d eleq12d elab3
      syl6bb $.
      $( [3-Mar-2007] $) $( [10-Feb-2007] $)

    $( The limits points of a subset are included in the subset's closure. $)
    lpsscls $p |- ( ( J e. Top /\ S C_ X ) -> ( ( limPt ` J ) ` S ) C_
               ( ( cls ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ clp cfv cfv vx cv cS vx cv csn cdif cJ
      ccl cfv cfv wcel vx cab cS cJ ccl cfv cfv vx cS cJ cX lpfval.1 lpval cJ
      ctop wcel cS cX wss wa vx cv cS vx cv csn cdif cJ ccl cfv cfv wcel vx cS
      cJ ccl cfv cfv cJ ctop wcel cS cX wss wa cS vx cv csn cdif cJ ccl cfv cfv
      cS cJ ccl cfv cfv vx cv cJ ctop wcel cS cX wss cS vx cv csn cdif cS wss
      cS vx cv csn cdif cJ ccl cfv cfv cS cJ ccl cfv cfv wss cS vx cv csn difss
      cS cS vx cv csn cdif cJ cX lpfval.1 clsss mp3an3 sseld abssdv eqsstrd $.
      $( [6-Mar-2007] $) $( [26-Feb-2007] $)

    $( The limits points of a subset are included in the base set. $)
    lpss $p |- ( ( J e. Top /\ S C_ X ) -> ( ( limPt ` J ) ` S ) C_ X ) $=
      cJ ctop wcel cS cX wss wa cS cJ clp cfv cfv cS cJ ccl cfv cfv cX cS cJ cX
      lpfval.1 lpsscls cS cJ cX lpfval.1 clsss3 sstrd $.
      $( [10-Dec-2007] $) $( [9-Nov-2007] $)

    $( The predicate " ` P ` is a limit point of ` S ` ," in terms of
       neighborhoods.  Definition of limit point in [Munkres] p. 97.  Although
       Munkres uses open neighborhoods, it also works for our more general
       neighborhoods. $)
    islp2 $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) ->
                ( P e. ( ( limPt ` J ) ` S ) <->
         A. n e. ( ( nei ` J ) ` { P } ) ( n i^i ( S \ { P } ) ) =/= (/) ) ) $=
      cJ ctop wcel cS cX wss cP cX wcel w3a cP cS cJ clp cfv cfv wcel cP cS cP
      csn cdif vx cv wss vx cJ ccld cfv crab cint wcel vx cv cX wss cX vx cv
      cdif cJ wcel wa cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx wal vn cv
      cS cP csn cdif cin c0 wne vn cP csn cJ cnei cfv cfv wral cJ ctop wcel cS
      cX wss cP cS cJ clp cfv cfv wcel cP cS cP csn cdif vx cv wss vx cJ ccld
      cfv crab cint wcel wb cP cX wcel cJ ctop wcel cS cX wss wa cP cS cJ clp
      cfv cfv wcel cP cS cP csn cdif cJ ccl cfv cfv wcel cP cS cP csn cdif vx
      cv wss vx cJ ccld cfv crab cint wcel cP cS cJ cX lpfval.1 islp cJ ctop
      wcel cS cX wss wa cS cP csn cdif cJ ccl cfv cfv cS cP csn cdif vx cv wss
      vx cJ ccld cfv crab cint cP cJ ctop wcel cS cP csn cdif cX wss cS cP csn
      cdif cJ ccl cfv cfv cS cP csn cdif vx cv wss vx cJ ccld cfv crab cint
      wceq cS cX wss vx cS cP csn cdif cJ cX lpfval.1 clsval cS cX cP csn
      ssdifss sylan2 eleq2d bitrd 3adant3 cJ ctop wcel cP cX wcel cP cS cP csn
      cdif vx cv wss vx cJ ccld cfv crab cint wcel vx cv cX wss cX vx cv cdif
      cJ wcel wa cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx wal wb cS cX
      wss cP cX wcel cP cS cP csn cdif vx cv wss vx cJ ccld cfv crab cint wcel
      cS cP csn cdif vx cv wss cP vx cv wcel wi vx cJ ccld cfv wral cJ ctop
      wcel vx cv cX wss cX vx cv cdif cJ wcel wa cS cP csn cdif vx cv wss cP vx
      cv wcel wi wi vx wal cS cP csn cdif vx cv wss vx cP cJ ccld cfv cX
      elintrabg cJ ctop wcel vx cv cJ ccld cfv wcel cS cP csn cdif vx cv wss cP
      vx cv wcel wi wi vx wal vx cv cX wss cX vx cv cdif cJ wcel wa cS cP csn
      cdif vx cv wss cP vx cv wcel wi wi vx wal cS cP csn cdif vx cv wss cP vx
      cv wcel wi vx cJ ccld cfv wral cJ ctop wcel vx cv cJ ccld cfv wcel cS cP
      csn cdif vx cv wss cP vx cv wcel wi wi vx cv cX wss cX vx cv cdif cJ wcel
      wa cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx cJ ctop wcel vx cv cJ
      ccld cfv wcel vx cv cX wss cX vx cv cdif cJ wcel wa cS cP csn cdif vx cv
      wss cP vx cv wcel wi vx cv cJ cX lpfval.1 iscld imbi1d albidv cS cP csn
      cdif vx cv wss cP vx cv wcel wi vx cJ ccld cfv df-ral syl5bb sylan9bbr
      3adant2 cJ ctop wcel cS cX wss cP cX wcel w3a vn cv cS cP csn cdif cin c0
      wne vn cP csn cJ cnei cfv cfv wral cX vx cv cdif cJ wcel cS cP csn cdif
      vx cv wss cP vx cv wcel wi wi vx cX cpw wral vx cv cX wss cX vx cv cdif
      cJ wcel wa cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx wal cJ ctop
      wcel cS cX wss cP cX wcel w3a vn cv cS cP csn cdif cin c0 wne vn cP csn
      cJ cnei cfv cfv wral vn cv cX wss cP vy cv wcel vy cv vn cv wss wa vy cJ
      wrex wa vn cv cS cP csn cdif cin c0 wne wi vn wal cX vx cv cdif cJ wcel
      cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx cX cpw wral cJ ctop wcel
      cP cX wcel vn cv cS cP csn cdif cin c0 wne vn cP csn cJ cnei cfv cfv wral
      vn cv cX wss cP vy cv wcel vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP
      csn cdif cin c0 wne wi vn wal wb cS cX wss cJ ctop wcel cP cX wcel wa vn
      cv cP csn cJ cnei cfv cfv wcel vn cv cS cP csn cdif cin c0 wne wi vn wal
      vn cv cX wss cP vy cv wcel vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP
      csn cdif cin c0 wne wi vn wal vn cv cS cP csn cdif cin c0 wne vn cP csn
      cJ cnei cfv cfv wral cJ ctop wcel cP cX wcel wa vn cv cP csn cJ cnei cfv
      cfv wcel vn cv cS cP csn cdif cin c0 wne wi vn cv cX wss cP vy cv wcel vy
      cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn cdif cin c0 wne wi vn cJ
      ctop wcel cP cX wcel wa vn cv cP csn cJ cnei cfv cfv wcel vn cv cX wss cP
      vy cv wcel vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn cdif cin c0
      wne cP vy cJ vn cv cX lpfval.1 isneip imbi1d albidv vn cv cS cP csn cdif
      cin c0 wne vn cP csn cJ cnei cfv cfv df-ral syl5bb 3adant2 cJ ctop wcel
      cS cX wss cP cX wcel w3a vn cv cJ wcel cP vn cv wcel vn cv cS cP csn cdif
      cin c0 wne wi wi vn cX cpw wral cX cX vn cv cdif cdif cJ wcel cS cP csn
      cdif cX vn cv cdif wss cP cX vn cv cdif wcel wi wi vn cX cpw wral vn cv
      cX wss cP vy cv wcel vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn
      cdif cin c0 wne wi vn wal cX vx cv cdif cJ wcel cS cP csn cdif vx cv wss
      cP vx cv wcel wi wi vx cX cpw wral cS cX wss cP cX wcel vn cv cJ wcel cP
      vn cv wcel vn cv cS cP csn cdif cin c0 wne wi wi vn cX cpw wral cX cX vn
      cv cdif cdif cJ wcel cS cP csn cdif cX vn cv cdif wss cP cX vn cv cdif
      wcel wi wi vn cX cpw wral wb cJ ctop wcel cS cX wss cP cX wcel wa vn cv
      cJ wcel cP vn cv wcel vn cv cS cP csn cdif cin c0 wne wi wi cX cX vn cv
      cdif cdif cJ wcel cS cP csn cdif cX vn cv cdif wss cP cX vn cv cdif wcel
      wi wi vn cX cpw cS cX wss cP cX wcel wa vn cv cX cpw wcel wa vn cv cJ
      wcel cX cX vn cv cdif cdif cJ wcel cP vn cv wcel vn cv cS cP csn cdif cin
      c0 wne wi cS cP csn cdif cX vn cv cdif wss cP cX vn cv cdif wcel wi vn cv
      cX cpw wcel vn cv cJ wcel cX cX vn cv cdif cdif cJ wcel wb cS cX wss cP
      cX wcel wa vn cv cX cpw wcel vn cv cX cX vn cv cdif cdif cJ vn cv cX cpw
      wcel cX cX vn cv cdif cdif vn cv vn cv cX cpw wcel vn cv cX wss cX cX vn
      cv cdif cdif vn cv wceq vn cv cX elpwi vn cv cX dfss4 sylib eqcomd eleq1d
      adantl cS cX wss cP cX wcel wa cP vn cv wcel vn cv cS cP csn cdif cin c0
      wne wi cS cP csn cdif cX vn cv cdif wss cP cX vn cv cdif wcel wi wb vn cv
      cX cpw wcel cS cX wss cP cX wcel wa vn cv cS cP csn cdif cin c0 wceq cP
      vn cv wcel wn wi cS cP csn cdif cX vn cv cdif wss cP cX vn cv cdif wcel
      wi cP vn cv wcel vn cv cS cP csn cdif cin c0 wne wi cS cX wss cP cX wcel
      wa vn cv cS cP csn cdif cin c0 wceq cS cP csn cdif cX vn cv cdif wss cP
      vn cv wcel wn cP cX vn cv cdif wcel cS cX wss vn cv cS cP csn cdif cin c0
      wceq cS cP csn cdif cX vn cv cdif wss wb cP cX wcel cS cX wss cS cP csn
      cdif vn cv cin c0 wceq cS cP csn cdif cX vn cv cdif wss vn cv cS cP csn
      cdif cin c0 wceq cS cX wss cS cP csn cdif cX wss cS cP csn cdif vn cv cin
      c0 wceq cS cP csn cdif cX vn cv cdif wss wb cS cX cP csn ssdifss cS cP
      csn cdif vn cv cX reldisj syl vn cv cS cP csn cdif cin cS cP csn cdif vn
      cv cin c0 vn cv cS cP csn cdif incom eqeq1i syl5bb adantr cP cX wcel cP
      vn cv wcel wn cP cX vn cv cdif wcel wb cS cX wss cP cX vn cv cdif wcel cP
      cX wcel cP vn cv wcel wn cP cX vn cv eldif baibr adantl imbi12d cP vn cv
      wcel vn cv cS cP csn cdif cin c0 wne wi cP vn cv wcel vn cv cS cP csn
      cdif cin c0 wceq wn wi vn cv cS cP csn cdif cin c0 wceq cP vn cv wcel wn
      wi vn cv cS cP csn cdif cin c0 wne vn cv cS cP csn cdif cin c0 wceq wn cP
      vn cv wcel vn cv cS cP csn cdif cin c0 df-ne imbi2i cP vn cv wcel vn cv
      cS cP csn cdif cin c0 wceq con2b bitri syl5bb adantr imbi12d ralbidva
      3adant1 cJ ctop wcel cS cX wss cP cX wcel w3a vn cv cX wss cP vy cv wcel
      vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn cdif cin c0 wne wi vn
      wal vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cS cP csn cdif
      cin c0 wne wi vn wal vn cv cJ wcel cP vn cv wcel vn cv cS cP csn cdif cin
      c0 wne wi wi vn cX cpw wral cJ ctop wcel cS cX wss cP cX wcel w3a vn cv
      cX wss cP vy cv wcel vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn
      cdif cin c0 wne wi vn wal vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa
      vn cv cS cP csn cdif cin c0 wne wi vn wal vn cv cX wss cP vy cv wcel vy
      cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn cdif cin c0 wne wi vn cv cX
      wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cS cP csn cdif cin c0 wne wi
      vn vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cX wss cP vy cv
      wcel vy cv vn cv wss wa vy cJ wrex wa vn cv cS cP csn cdif cin c0 wne vn
      cv cX wss vn cv cJ wcel cP vn cv wcel vn cv cX wss cP vy cv wcel vy cv vn
      cv wss wa vy cJ wrex wa vn cv cJ wcel cP vn cv wcel wa cP vy cv wcel vy
      cv vn cv wss wa vy cJ wrex vn cv cX wss cP vy cv wcel vy cv vn cv wss wa
      cP vn cv wcel vy vn cv cJ vy cv vn cv wceq cP vy cv wcel vy cv vn cv wss
      wa cP vn cv wcel vn cv vn cv wss wa cP vn cv wcel vy cv vn cv wceq cP vy
      cv wcel cP vn cv wcel vy cv vn cv wss vn cv vn cv wss vy cv vn cv cP
      eleq2 vy cv vn cv vn cv sseq1 anbi12d vn cv vn cv wss cP vn cv wcel vn cv
      ssid biantru syl6bbr rcla4ev anim2i anassrs imim1i 19.20i cJ ctop wcel cP
      cX wcel vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cS cP csn
      cdif cin c0 wne wi vn wal vn cv cX wss cP vy cv wcel vy cv vn cv wss wa
      vy cJ wrex wa vn cv cS cP csn cdif cin c0 wne wi vn wal wi cS cX wss cJ
      ctop wcel cP cX wcel wa vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn
      cv cS cP csn cdif cin c0 wne wi vn wal vn cv cX wss cP vy cv wcel vy cv
      vn cv wss wa vy cJ wrex wa vn cv cS cP csn cdif cin c0 wne wi vn cJ ctop
      wcel cP cX wcel wa vn ax-17 vn cv cX wss vn cv cJ wcel wa cP vn cv wcel
      wa vn cv cS cP csn cdif cin c0 wne wi vn hba1 cJ ctop wcel cP cX wcel wa
      vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cS cP csn cdif cin
      c0 wne wi vn wal vn cv cX wss cP vy cv wcel vy cv vn cv wss wa vy cJ wrex
      vn cv cS cP csn cdif cin c0 wne cJ ctop wcel cP cX wcel wa vn cv cX wss
      vn cv cJ wcel wa cP vn cv wcel wa vn cv cS cP csn cdif cin c0 wne wi vn
      wal cP vy cv wcel vy cv vn cv wss wa vy cJ wrex vn cv cS cP csn cdif cin
      c0 wne wi vn cv cX wss cJ ctop wcel cP cX wcel wa vn cv cX wss vn cv cJ
      wcel wa cP vn cv wcel wa vn cv cS cP csn cdif cin c0 wne wi vn wal cP vy
      cv wcel vy cv vn cv wss wa vy cJ wrex vn cv cS cP csn cdif cin c0 wne wi
      cJ ctop wcel cP cX wcel wa vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa
      vn cv cS cP csn cdif cin c0 wne wi vn wal wa cP vy cv wcel vy cv vn cv
      wss wa vn cv cS cP csn cdif cin c0 wne vy cJ cJ ctop wcel cP cX wcel wa
      vy cv cX wss vy cv cJ wcel wa cP vy cv wcel wa vy cv cS cP csn cdif cin
      c0 wne wi vy cv cJ wcel cP vy cv wcel vy cv vn cv wss wa vn cv cS cP csn
      cdif cin c0 wne wi wi vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn
      cv cS cP csn cdif cin c0 wne wi vn wal cJ ctop wcel cP cX wcel wa vy cv
      cX wss vy cv cJ wcel wa cP vy cv wcel wa vy cv cS cP csn cdif cin c0 wne
      wi vy cv cJ wcel cP vy cv wcel vy cv vn cv wss wa vn cv cS cP csn cdif
      cin c0 wne wi wi vy cv cJ wcel cP vy cv wcel vy cv vn cv wss wa cJ ctop
      wcel cP cX wcel wa vy cv cX wss vy cv cJ wcel wa cP vy cv wcel wa vy cv
      cS cP csn cdif cin c0 wne wi vn cv cS cP csn cdif cin c0 wne vy cv cJ
      wcel cP vy cv wcel vy cv vn cv wss wa cJ ctop wcel cP cX wcel wa vy cv cX
      wss vy cv cJ wcel wa cP vy cv wcel wa vy cv cS cP csn cdif cin c0 wne wi
      vn cv cS cP csn cdif cin c0 wne wi vy cv cJ wcel cP vy cv wcel vy cv vn
      cv wss wa wa cJ ctop wcel cP cX wcel wa wa vy cv cX wss vy cv cJ wcel wa
      cP vy cv wcel wa vy cv cS cP csn cdif cin c0 wne wi vy cv cX wss vy cv cJ
      wcel wa cP vy cv wcel wa vn cv cS cP csn cdif cin c0 wne vy cv cJ wcel cP
      vy cv wcel cJ ctop wcel cP cX wcel wa vy cv cX wss vy cv cJ wcel wa cP vy
      cv wcel wa vy cv vn cv wss vy cv cJ wcel cJ ctop wcel cP vy cv wcel cP cX
      wcel vy cv cX wss vy cv cJ wcel wa cP vy cv wcel wa vy cv cJ wcel cJ ctop
      wcel wa cP vy cv wcel vy cv cX wss vy cv cJ wcel wa cP vy cv wcel wa cP
      cX wcel vy cv cJ wcel cJ ctop wcel wa vy cv cX wss vy cv cJ wcel wa cP vy
      cv wcel vy cv cJ wcel cJ ctop wcel wa vy cv cX wss vy cv cJ wcel cJ ctop
      wcel vy cv cJ wcel vy cv cX wss vy cv cJ cX lpfval.1 eltopss ancoms vy cv
      cJ wcel cJ ctop wcel pm3.26 jca anim1i adantrr an4s adantlrr vy cv cJ
      wcel cP vy cv wcel vy cv vn cv wss wa wa cJ ctop wcel cP cX wcel wa wa vy
      cv cS cP csn cdif cin c0 wne vn cv cS cP csn cdif cin c0 wne vy cv cX wss
      vy cv cJ wcel wa cP vy cv wcel wa cP vy cv wcel vy cv vn cv wss wa vy cv
      cS cP csn cdif cin c0 wne vn cv cS cP csn cdif cin c0 wne wi vy cv cJ
      wcel cJ ctop wcel cP cX wcel wa vy cv vn cv wss vy cv cS cP csn cdif cin
      c0 wne vn cv cS cP csn cdif cin c0 wne wi cP vy cv wcel vy cv vn cv wss
      vy cv cS cP csn cdif cin vn cv cS cP csn cdif cin wss vy cv cS cP csn
      cdif cin c0 wne vn cv cS cP csn cdif cin c0 wne wi vy cv vn cv cS cP csn
      cdif ssrin vy cv cS cP csn cdif cin vn cv cS cP csn cdif cin wss vy cv cS
      cP csn cdif cin c0 wne vn cv cS cP csn cdif cin c0 wne vy cv cS cP csn
      cdif cin vn cv cS cP csn cdif cin ssn0 ex syl adantl ad2antlr imim2d mpid
      exp31 com4t imp vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cS
      cP csn cdif cin c0 wne wi vy cv cX wss vy cv cJ wcel wa cP vy cv wcel wa
      vy cv cS cP csn cdif cin c0 wne wi vn vy vn cv vy cv wceq vn cv cX wss vn
      cv cJ wcel wa cP vn cv wcel wa vy cv cX wss vy cv cJ wcel wa cP vy cv
      wcel wa vn cv cS cP csn cdif cin c0 wne vy cv cS cP csn cdif cin c0 wne
      vn cv vy cv wceq vn cv cX wss vn cv cJ wcel wa vy cv cX wss vy cv cJ wcel
      wa cP vn cv wcel cP vy cv wcel vn cv vy cv wceq vn cv cX wss vy cv cX wss
      vn cv cJ wcel vy cv cJ wcel vn cv vy cv cX sseq1 vn cv vy cv cJ eleq1
      anbi12d vn cv vy cv cP eleq2 anbi12d vn cv vy cv wceq vn cv cS cP csn
      cdif cin vy cv cS cP csn cdif cin c0 vn cv vy cv cS cP csn cdif ineq1
      neeq1d imbi12d a4v sylan2 r19.23adv ex a1dd imp4a 19.21ad 3adant2 impbid2
      vn cv cJ wcel cP vn cv wcel vn cv cS cP csn cdif cin c0 wne wi wi vn cX
      cpw wral vn cv cX cpw wcel vn cv cJ wcel cP vn cv wcel vn cv cS cP csn
      cdif cin c0 wne wi wi wi vn wal vn cv cX wss vn cv cJ wcel wa cP vn cv
      wcel wa vn cv cS cP csn cdif cin c0 wne wi vn wal vn cv cJ wcel cP vn cv
      wcel vn cv cS cP csn cdif cin c0 wne wi wi vn cX cpw df-ral vn cv cX cpw
      wcel vn cv cJ wcel cP vn cv wcel vn cv cS cP csn cdif cin c0 wne wi wi wi
      vn cv cX wss vn cv cJ wcel wa cP vn cv wcel wa vn cv cS cP csn cdif cin
      c0 wne wi vn vn cv cX wss vn cv cJ wcel wa cP vn cv wcel vn cv cS cP csn
      cdif cin c0 wne wi wi vn cv cX wss vn cv cJ wcel cP vn cv wcel vn cv cS
      cP csn cdif cin c0 wne wi wi wi vn cv cX wss vn cv cJ wcel wa cP vn cv
      wcel wa vn cv cS cP csn cdif cin c0 wne wi vn cv cX cpw wcel vn cv cJ
      wcel cP vn cv wcel vn cv cS cP csn cdif cin c0 wne wi wi wi vn cv cX wss
      vn cv cJ wcel cP vn cv wcel vn cv cS cP csn cdif cin c0 wne wi impexp vn
      cv cX wss vn cv cJ wcel wa cP vn cv wcel vn cv cS cP csn cdif cin c0 wne
      impexp vn cv cX cpw wcel vn cv cX wss vn cv cJ wcel cP vn cv wcel vn cv
      cS cP csn cdif cin c0 wne wi wi vn cv cX vn visset elpw imbi1i 3bitr4ri
      albii bitr2i syl6bb cJ ctop wcel cS cX wss cP cX wcel w3a cX cvv wcel cX
      vx cv cdif cJ wcel cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx cX cpw
      wral cX cX vn cv cdif cdif cJ wcel cS cP csn cdif cX vn cv cdif wss cP cX
      vn cv cdif wcel wi wi vn cX cpw wral wb cJ ctop wcel cS cX wss cX cvv
      wcel cP cX wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg lpfval.1
      syl5eqel 3ad2ant1 cX cvv wcel cX vx cv cdif cJ wcel cS cP csn cdif vx cv
      wss cP vx cv wcel wi wi cX cX vn cv cdif cdif cJ wcel cS cP csn cdif cX
      vn cv cdif wss cP cX vn cv cdif wcel wi wi vx vn cX vn cv cdif cX cpw cX
      cvv wcel cX vn cv cdif cX cpw wcel vn cv cX cpw wcel cX cvv wcel cX vn cv
      cdif cX cpw wcel cX vn cv cdif cX wss cX vn cv difss cX vn cv cdif cX cvv
      elpw2g mpbiri adantr cX vx cv cdif cX cpw wcel vx cv cX cX vx cv cdif
      cdif wceq vx cv cX vn cv cdif wceq vn cX cpw wrex cX cvv wcel vx cv cX
      cpw wcel vx cv cX vn cv cdif wceq vx cv cX cX vx cv cdif cdif wceq vn cX
      vx cv cdif cX cpw vn cv cX vx cv cdif wceq cX vn cv cdif cX cX vx cv cdif
      cdif vx cv vn cv cX vx cv cdif cX difeq2 eqeq2d rcla4ev cX cvv wcel cX vx
      cv cdif cX cpw wcel cX vx cv cdif cX wss cX vx cv difss cX vx cv cdif cX
      cvv elpw2g mpbiri vx cv cX cpw wcel cX cX vx cv cdif cdif vx cv vx cv cX
      cpw wcel vx cv cX wss cX cX vx cv cdif cdif vx cv wceq vx cv cX elpwi vx
      cv cX dfss4 sylib eqcomd syl2an vx cv cX vn cv cdif wceq cX vx cv cdif cJ
      wcel cS cP csn cdif vx cv wss cP vx cv wcel wi wi cX cX vn cv cdif cdif
      cJ wcel cS cP csn cdif cX vn cv cdif wss cP cX vn cv cdif wcel wi wi wb
      cX cvv wcel vx cv cX vn cv cdif wceq cX vx cv cdif cJ wcel cX cX vn cv
      cdif cdif cJ wcel cS cP csn cdif vx cv wss cP vx cv wcel wi cS cP csn
      cdif cX vn cv cdif wss cP cX vn cv cdif wcel wi vx cv cX vn cv cdif wceq
      cX vx cv cdif cX cX vn cv cdif cdif cJ vx cv cX vn cv cdif cX difeq2
      eleq1d vx cv cX vn cv cdif wceq cS cP csn cdif vx cv wss cS cP csn cdif
      cX vn cv cdif wss cP vx cv wcel cP cX vn cv cdif wcel vx cv cX vn cv cdif
      cS cP csn cdif sseq2 vx cv cX vn cv cdif cP eleq2 imbi12d imbi12d adantl
      ralxfrd syl 3bitr4d bitrd cX vx cv cdif cJ wcel cS cP csn cdif vx cv wss
      cP vx cv wcel wi wi vx cX cpw wral vx cv cX cpw wcel cX vx cv cdif cJ
      wcel cS cP csn cdif vx cv wss cP vx cv wcel wi wi wi vx wal vx cv cX wss
      cX vx cv cdif cJ wcel wa cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx
      wal cX vx cv cdif cJ wcel cS cP csn cdif vx cv wss cP vx cv wcel wi wi vx
      cX cpw df-ral vx cv cX cpw wcel cX vx cv cdif cJ wcel cS cP csn cdif vx
      cv wss cP vx cv wcel wi wi wi vx cv cX wss cX vx cv cdif cJ wcel wa cS cP
      csn cdif vx cv wss cP vx cv wcel wi wi vx vx cv cX cpw wcel cX vx cv cdif
      cJ wcel cS cP csn cdif vx cv wss cP vx cv wcel wi wi wi vx cv cX wss cX
      vx cv cdif cJ wcel cS cP csn cdif vx cv wss cP vx cv wcel wi wi wi vx cv
      cX wss cX vx cv cdif cJ wcel wa cS cP csn cdif vx cv wss cP vx cv wcel wi
      wi vx cv cX cpw wcel vx cv cX wss cX vx cv cdif cJ wcel cS cP csn cdif vx
      cv wss cP vx cv wcel wi wi vx cv cX vx visset elpw imbi1i vx cv cX wss cX
      vx cv cdif cJ wcel cS cP csn cdif vx cv wss cP vx cv wcel wi impexp
      bitr4i albii bitri syl6rbb 3bitrd $.
      $( [11-Mar-2007] $) $( [26-Feb-2007] $)

    $( The closure of a subset of a topological space is the subset together
       with its limit points.  Theorem 6.6 of [Munkres] p. 97. $)
    clslp $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) =
                ( S u. ( ( limPt ` J ) ` S ) ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS cS cJ clp cfv cfv cun cJ
      ctop wcel cS cX wss wa vx cS cJ ccl cfv cfv cS cS cJ clp cfv cfv cun cJ
      ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel vx cv cS cS cJ clp
      cfv cfv cun wcel cJ ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel
      wa vx cv cS wcel vx cv cS cJ clp cfv cfv wcel wo vx cv cS cS cJ clp cfv
      cfv cun wcel cJ ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vx
      cv cS wcel vx cv cS cJ clp cfv cfv wcel cJ ctop wcel cS cX wss wa vx cv
      cS cJ ccl cfv cfv wcel wa vx cv cS wcel wn vn cv cS vx cv csn cdif cin c0
      wne vn vx cv csn cJ cnei cfv cfv wral vx cv cS cJ clp cfv cfv wcel cJ
      ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vx cv cS wcel wn
      vn cv cS vx cv csn cdif cin c0 wne vn vx cv csn cJ cnei cfv cfv cJ ctop
      wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vx cv cS wcel wn vn cv
      vx cv csn cJ cnei cfv cfv wcel vn cv cS vx cv csn cdif cin c0 wne wi cJ
      ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vx cv cS wcel wn
      wa vn cv vx cv csn cJ cnei cfv cfv wcel vn cv cS cin c0 wne vn cv cS vx
      cv csn cdif cin c0 wne cJ ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv
      wcel wa vn cv vx cv csn cJ cnei cfv cfv wcel vn cv cS cin c0 wne wi vx cv
      cS wcel wn cJ ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vn
      cv vx cv csn cJ cnei cfv cfv wcel vn cv cS cin c0 wne cJ ctop wcel cS cX
      wss wa vx cv cS cJ ccl cfv cfv wcel vn cv vx cv csn cJ cnei cfv cfv wcel
      vn cv cS cin c0 wne vx cv cS cJ vn cv cX lpfval.1 neindisj anassrs ex
      adantr vx cv cS wcel wn vn cv cS vx cv csn cdif cin c0 wne vn cv cS cin
      c0 wne wb cJ ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vx cv
      cS wcel wn vn cv cS vx cv csn cdif cin vn cv cS cin c0 vx cv cS wcel wn
      cS vx cv csn cdif cS vn cv vx cv cS difsn ineq2d neeq1d adantl sylibrd ex
      r19.21adv cJ ctop wcel cS cX wss vx cv cX wcel vx cv cS cJ clp cfv cfv
      wcel vn cv cS vx cv csn cdif cin c0 wne vn vx cv csn cJ cnei cfv cfv wral
      wb cJ ctop wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel wa vx cv cS vn
      cJ cX lpfval.1 islp2 cJ ctop wcel cS cX wss vx cv cS cJ ccl cfv cfv wcel
      simpll cJ ctop wcel cS cX wss vx cv cS cJ ccl cfv cfv wcel simplr cJ ctop
      wcel cS cX wss wa vx cv cS cJ ccl cfv cfv wcel vx cv cX wcel cJ ctop wcel
      cS cX wss wa cS cJ ccl cfv cfv cX vx cv cS cJ cX lpfval.1 clsss3 sseld
      imp syl3anc sylibrd orrd vx cv cS cS cJ clp cfv cfv elun sylibr ex ssrdv
      cJ ctop wcel cS cX wss wa cS cS cJ ccl cfv cfv wss cS cJ clp cfv cfv cS
      cJ ccl cfv cfv wss wa cS cS cJ clp cfv cfv cun cS cJ ccl cfv cfv wss cJ
      ctop wcel cS cX wss wa cS cS cJ ccl cfv cfv wss cS cJ clp cfv cfv cS cJ
      ccl cfv cfv wss cS cJ cX lpfval.1 sscls cS cJ cX lpfval.1 lpsscls jca cS
      cS cJ clp cfv cfv cS cJ ccl cfv cfv unss sylib eqssd $.
      $( [14-Mar-2007] $) $( [26-Feb-2007] $)

    $( A point belonging to a set's closure but not the set itself is a limit
       point. $)
    islpi $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( P e. ( ( cls ` J ) ` S ) /\
       -. P e. S ) ) -> P e. ( ( limPt ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss wa cP cS cJ ccl cfv cfv wcel cP cS wcel wn cP cS
      cJ clp cfv cfv wcel cJ ctop wcel cS cX wss wa cP cS cJ ccl cfv cfv wcel
      cP cS wcel wn cP cS cJ clp cfv cfv wcel wi cJ ctop wcel cS cX wss wa cP
      cS cJ ccl cfv cfv wcel cP cS cS cJ clp cfv cfv cun wcel cP cS wcel wn cP
      cS cJ clp cfv cfv wcel wi cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS
      cS cJ clp cfv cfv cun cP cS cJ cX lpfval.1 clslp eleq2d cP cS cS cJ clp
      cfv cfv cun wcel cP cS wcel cP cS cJ clp cfv cfv wcel wo cP cS wcel wn cP
      cS cJ clp cfv cfv wcel wi cP cS cS cJ clp cfv cfv elun cP cS wcel cP cS
      cJ clp cfv cfv wcel df-or bitri syl6bb biimpd imp32 $.
      $( [23-Dec-2007] $) $( [8-Nov-2007] $)

    $( A subset of a topological space is closed iff it contains all its limit
       points.  Corollary 6.7 of [Munkres] p. 97. $)
    cldlp $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                 ( ( limPt ` J ) ` S ) C_ S ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ ccld cfv wcel cS cJ ccl cfv cfv cS wceq
      cS cJ clp cfv cfv cS wss cS cJ cX lpfval.1 iscld3 cJ ctop wcel cS cX wss
      wa cS cJ ccl cfv cfv cS wceq cS cS cJ clp cfv cfv cun cS wceq cS cJ clp
      cfv cfv cS wss cJ ctop wcel cS cX wss wa cS cJ ccl cfv cfv cS cS cJ clp
      cfv cfv cun cS cS cJ cX lpfval.1 clslp eqeq1d cS cJ clp cfv cfv cS
      ssequn2 syl6bbr bitrd $.
      $( [16-Jun-2008] $) $( [26-Feb-2007] $)
  $}

  ${
    $d v w x y z $.
    $( ` QQ ` is dense in the standard topology on ` RR ` . $)
    qdensere $p |- ( ( cls ` ( topGen ` ran (,) ) ) ` QQ ) = RR $=
      cq cioo crn ctg cfv ccl cfv cfv cr cioo crn ctg cfv ctop wcel cq cr wss
      cq cioo crn ctg cfv ccl cfv cfv cr wss retop qssre cq cioo crn ctg cfv cr
      cioo crn ctg cfv cuni cr uniretop eqcomi clsss3 mp2an vx cr cq cioo crn
      ctg cfv ccl cfv cfv vx cv cr wcel vx cv cq cioo crn ctg cfv ccl cfv cfv
      wcel vx cv vy cv wcel vy cv cq cin c0 wne wi vy cioo crn wral vx cv vy cv
      wcel vy cv cq cin c0 wne wi vy cioo crn vy cv cioo crn wcel vy cv vz cv
      vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq vw cxr wrex vz cxr
      wrex vx cv vy cv wcel vy cv cq cin c0 wne wi vz vw vx cxr cxr vz cv vv cv
      clt wbr vv cv vw cv clt wbr wa vv cr crab vy cv cioo vz cv vv cv clt wbr
      vv cv vw cv clt wbr wa vv cr reex rabex vz vw vx vv dfioo2 elrnoprab vy
      cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq vx cv vy cv
      wcel vy cv cq cin c0 wne wi vz vw cxr cxr vz cv cxr wcel vw cv cxr wcel
      wa vy cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq vx cv
      vy cv wcel vy cv cq cin c0 wne vz cv cxr wcel vw cv cxr wcel wa vy cv vz
      cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq vx cv vy cv wcel
      wa wa vx cv vy cv wcel vx cq wrex vy cv cq cin c0 wne vz cv cxr wcel vw
      cv cxr wcel wa vy cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr
      crab wceq vx cv vy cv wcel wa wa vx cv vy cv wcel vx cq wrex vz cv vx cv
      clt wbr vx cv vw cv clt wbr wa vx cq wrex vz cv cxr wcel vw cv cxr wcel
      wa vy cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq vx cv
      vy cv wcel wa vz cv vx cv clt wbr vx cv vw cv clt wbr wa vx cq wrex vz cv
      cxr wcel vw cv cxr wcel wa vy cv vz cv vv cv clt wbr vv cv vw cv clt wbr
      wa vv cr crab wceq vx cv vy cv wcel wa vy cv vz cv vw cv cioo co wceq vx
      cv vy cv wcel wa vz cv vx cv clt wbr vx cv vw cv clt wbr wa vx cq wrex vz
      cv cxr wcel vw cv cxr wcel wa vy cv vz cv vw cv cioo co wceq vy cv vz cv
      vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq vx cv vy cv wcel vz
      cv cxr wcel vw cv cxr wcel wa vz cv vw cv cioo co vz cv vv cv clt wbr vv
      cv vw cv clt wbr wa vv cr crab vy cv vv vz cv vw cv iooval2 eqeq2d anbi1d
      vz cv cxr wcel vw cv cxr wcel wa vz cv vw cv cioo co c0 wne vz cv vx cv
      clt wbr vx cv vw cv clt wbr wa vx cq wrex vy cv vz cv vw cv cioo co wceq
      vx cv vy cv wcel wa vz cv cxr wcel vw cv cxr wcel wa vz cv vw cv cioo co
      c0 wne vz cv vw cv clt wbr vz cv vx cv clt wbr vx cv vw cv clt wbr wa vx
      cq wrex vz cv vw cv ioon0 vz cv cxr wcel vw cv cxr wcel vz cv vw cv clt
      wbr vz cv vx cv clt wbr vx cv vw cv clt wbr wa vx cq wrex vx vz cv vw cv
      qbtwnxr 3expia sylbid vy cv vz cv vw cv cioo co wceq vx cv vy cv wcel vz
      cv vw cv cioo co c0 wne vy cv vz cv vw cv cioo co wceq vy cv c0 wne vz cv
      vw cv cioo co c0 wne vx cv vy cv wcel vy cv vz cv vw cv cioo co c0 neeq1
      vy cv vx cv ne0i syl5bi imp syl5 sylbird imp vy cv vz cv vv cv clt wbr vv
      cv vw cv clt wbr wa vv cr crab wceq vx cv vy cv wcel vx cq wrex vz cv vx
      cv clt wbr vx cv vw cv clt wbr wa vx cq wrex wb vz cv cxr wcel vw cv cxr
      wcel wa vx cv vy cv wcel vy cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa
      vv cr crab wceq vx cv vy cv wcel vz cv vx cv clt wbr vx cv vw cv clt wbr
      wa vx cq vy cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab wceq
      vx cv vy cv wcel vx cv vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr
      crab wcel vx cv cq wcel vz cv vx cv clt wbr vx cv vw cv clt wbr wa vy cv
      vz cv vv cv clt wbr vv cv vw cv clt wbr wa vv cr crab vx cv eleq2 vx cv
      cq wcel vz cv vx cv clt wbr vx cv vw cv clt wbr wa vx cv cr wcel vz cv vx
      cv clt wbr vx cv vw cv clt wbr wa wa vx cv vz cv vv cv clt wbr vv cv vw
      cv clt wbr wa vv cr crab wcel vx cv cq wcel vx cv cr wcel vz cv vx cv clt
      wbr vx cv vw cv clt wbr wa vx cv qre biantrurd vz cv vv cv clt wbr vv cv
      vw cv clt wbr wa vz cv vx cv clt wbr vx cv vw cv clt wbr wa vv vx cv cr
      vv cv vx cv wceq vz cv vv cv clt wbr vz cv vx cv clt wbr vv cv vw cv clt
      wbr vx cv vw cv clt wbr vv cv vx cv vz cv clt breq2 vv cv vx cv vw cv clt
      breq1 anbi12d elrab syl6rbbr sylan9bb rexbidva ad2antrl mpbird vx cv vy
      cv wcel vx cq wrex vy cv cq cin c0 vy cv cq cin c0 wceq cq vy cv cin c0
      wceq vx cv vy cv wcel wn vx cq wral vx cv vy cv wcel vx cq wrex wn vy cv
      cq cin cq vy cv cin c0 vy cv cq incom eqeq1i vx cq vy cv disj vx cv vy cv
      wcel vx cq ralnex 3bitri necon2abii sylib exp32 r19.23aivv sylbi rgen
      cioo crn ctb wcel cq cr wss vx cv cr wcel vx cv cq cioo crn ctg cfv ccl
      cfv cfv wcel vx cv vy cv wcel vy cv cq cin c0 wne wi vy cioo crn wral wb
      retopbas qssre vy cioo crn vx cv cq cioo crn ctg cfv cr cioo crn ctg cfv
      eqid cioo crn ctg cfv ctop wcel cr cioo crn ctg cfv cuni wceq cioo crn
      ctg cfv ctop wcel cr cioo crn ctg cfv cuni wceq retop cioo crn ctg cfv
      cuni cr uniretop eqcomi pm3.2i pm3.27i elcls3 mp3an12 mpbiri ssriv eqssi
      $.
      $( [24-Aug-2007] $) $( [1-Mar-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Continuity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Cn $.
  $c CnP $.

  $( Extend class notation with the set of continuous functions between
     topologies. $)
  ccn $a class Cn $.

  $( Extend class notation with the set of functions between topologies
     continuous at a point. $)
  ccnp $a class CnP $.

  ${
    $d f j k v w x y z $.
    $( Define a function on two topologies whose value is the set of continuous
       mappings from the first topology to the second.  Based on definition of
       continuous function in [Munkres] p. 102.  See ~ iscn for the predicate
       form. $)
    df-cn $a |- Cn = { <. <. j , k >. , z >. | ( ( j e. Top /\ k e. Top ) /\
             z = { f e. ( U. k ^m U. j ) | A. y e. k ( `' f " y ) e. j } ) } $.

    $( Define a function on two topologies whose value is the set of continuous
       mappings at a specified point in the first topology.  Based on Theorem
       7.2(g) of [Munkres] p. 107. $)
    df-cnp $a |- CnP = { <. <. j , k >. , z >. | ( ( j e. Top /\ k e. Top ) /\
     z = { <. x , y >. | ( x e. U. j /\ y = { f e. ( U. k ^m U. j ) | A. w e. k
      ( ( f ` x ) e. w -> E. v e. j ( x e. v /\ ( f " v ) C_ w ) ) } ) } ) } $.
  $}

  ${
    $d f j k v w x y z J $.  $d f j k w x y z K $.  $d f j k x y z X $.
    $d f k y z Y $.
    cnfval.1 $e |- X = U. J $.
    cnfval.2 $e |- Y = U. K $.
    $( The set of all continuous functions from topology ` J ` to topology
       ` K ` . $)
    cnfval $p |- ( ( J e. Top /\ K e. Top ) ->
      ( J Cn K ) = { f e. ( Y ^m X ) | A. y e. K ( `' f " y ) e. J } ) $=
      vj vk vz cJ cK ctop ctop vf cv ccnv vy cv cima vj cv wcel vy vk cv wral
      vf vk cv cuni vj cv cuni cm co crab vf cv ccnv vy cv cima cJ wcel vy cK
      wral vf cY cX cm co crab ccn vf cv ccnv vy cv cima cJ wcel vy vk cv wral
      vf vk cv cuni cX cm co crab vf cv ccnv vy cv cima cJ wcel vy cK wral vf
      cY cX cm co cY cX cm oprex rabex vj cv cJ wceq vf cv ccnv vy cv cima vj
      cv wcel vy vk cv wral vf vk cv cuni vj cv cuni cm co crab vf cv ccnv vy
      cv cima vj cv wcel vy vk cv wral vf vk cv cuni cX cm co crab vf cv ccnv
      vy cv cima cJ wcel vy vk cv wral vf vk cv cuni cX cm co crab vj cv cJ
      wceq vk cv cuni vj cv cuni cm co vk cv cuni cX cm co wceq vf cv ccnv vy
      cv cima vj cv wcel vy vk cv wral vf vk cv cuni vj cv cuni cm co crab vf
      cv ccnv vy cv cima vj cv wcel vy vk cv wral vf vk cv cuni cX cm co crab
      wceq vj cv cJ wceq vj cv cuni cX vk cv cuni cm vj cv cJ wceq vj cv cuni
      cJ cuni cX vj cv cJ unieq cnfval.1 syl6eqr opreq2d vf cv ccnv vy cv cima
      vj cv wcel vy vk cv wral vf vk cv cuni vj cv cuni cm co vk cv cuni cX cm
      co rabeq syl vj cv cJ wceq vf cv ccnv vy cv cima vj cv wcel vy vk cv wral
      vf cv ccnv vy cv cima cJ wcel vy vk cv wral vf vk cv cuni cX cm co vj cv
      cJ wceq vf cv ccnv vy cv cima vj cv wcel vf cv ccnv vy cv cima cJ wcel vy
      vk cv vj cv cJ vf cv ccnv vy cv cima eleq2 ralbidv rabbisdv eqtrd vk cv
      cK wceq vf cv ccnv vy cv cima cJ wcel vy vk cv wral vf vk cv cuni cX cm
      co crab vf cv ccnv vy cv cima cJ wcel vy vk cv wral vf cY cX cm co crab
      vf cv ccnv vy cv cima cJ wcel vy cK wral vf cY cX cm co crab vk cv cK
      wceq vk cv cuni cX cm co cY cX cm co wceq vf cv ccnv vy cv cima cJ wcel
      vy vk cv wral vf vk cv cuni cX cm co crab vf cv ccnv vy cv cima cJ wcel
      vy vk cv wral vf cY cX cm co crab wceq vk cv cK wceq vk cv cuni cY cX cm
      vk cv cK wceq vk cv cuni cK cuni cY vk cv cK unieq cnfval.2 syl6eqr
      opreq1d vf cv ccnv vy cv cima cJ wcel vy vk cv wral vf vk cv cuni cX cm
      co cY cX cm co rabeq syl vk cv cK wceq vf cv ccnv vy cv cima cJ wcel vy
      vk cv wral vf cv ccnv vy cv cima cJ wcel vy cK wral vf cY cX cm co vf cv
      ccnv vy cv cima cJ wcel vy vk cv cK raleq1 rabbisdv eqtrd vy vz vf vj vk
      df-cn oprabval2 $.
      $( [17-Oct-2006] $) $( [17-Oct-2006] $)

    $( The function mapping the points in a topology ` J ` to the set of
       all functions from ` J ` to topology ` K ` continuous at that point. $)
    cnpfval $p |- ( ( J e. Top /\ K e. Top ) -> ( J CnP K ) =
         { <. x , y >. | ( x e. X /\ y = { f e. ( Y ^m X ) | A. w e. K
        ( ( f ` x ) e. w -> E. v e. J ( x e. v /\ ( f " v ) C_ w ) ) } ) } ) $=
      cJ ctop wcel cK ctop wcel vx cv cX wcel vy cv vx cv vf cv cfv vw cv wcel
      vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw cK wral
      vf cY cX cm co crab wceq wa vx vy copab cvv wcel cJ cK ccnp co vx cv cX
      wcel vy cv vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima
      vw cv wss wa vv cJ wrex wi vw cK wral vf cY cX cm co crab wceq wa vx vy
      copab wceq cJ ctop wcel vx cv cX wcel vy cv vx cv vf cv cfv vw cv wcel vx
      cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw cK wral vf
      cY cX cm co crab wceq wa vx vy copab cvv wcel cK ctop wcel cJ ctop wcel
      cJ cuni cvv wcel cX cvv wcel vx cv cX wcel vy cv vx cv vf cv cfv vw cv
      wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw cK
      wral vf cY cX cm co crab wceq wa vx vy copab cvv wcel cJ ctop uniexg cX
      cvv wcel cJ cuni cvv wcel cX cJ cuni cvv cnfval.1 eleq1i biimpri vx vy cX
      vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa
      vv cJ wrex wi vw cK wral vf cY cX cm co crab cvv opabex2g 3syl adantr vj
      vk vz cJ cK ctop ctop vx cv vj cv cuni wcel vy cv vx cv vf cv cfv vw cv
      wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv vj cv wrex wi vw
      vk cv wral vf vk cv cuni vj cv cuni cm co crab wceq wa vx vy copab vx cv
      cX wcel vy cv vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv
      cima vw cv wss wa vv cJ wrex wi vw cK wral vf cY cX cm co crab wceq wa vx
      vy copab ccnp vx cv cX wcel vy cv vx cv vf cv cfv vw cv wcel vx cv vv cv
      wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral vf vk cv
      cuni cX cm co crab wceq wa vx vy copab cvv vj cv cJ wceq vx cv vj cv cuni
      wcel vy cv vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima
      vw cv wss wa vv vj cv wrex wi vw vk cv wral vf vk cv cuni vj cv cuni cm
      co crab wceq wa vx cv cX wcel vy cv vx cv vf cv cfv vw cv wcel vx cv vv
      cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral vf vk
      cv cuni cX cm co crab wceq wa vx vy vj cv cJ wceq vx cv vj cv cuni wcel
      vx cv cX wcel vy cv vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv
      cv cima vw cv wss wa vv vj cv wrex wi vw vk cv wral vf vk cv cuni vj cv
      cuni cm co crab wceq vy cv vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf
      cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral vf vk cv cuni cX
      cm co crab wceq vj cv cJ wceq vj cv cuni cX vx cv vj cv cJ wceq vj cv
      cuni cJ cuni cX vj cv cJ unieq cnfval.1 syl6eqr eleq2d vj cv cJ wceq vx
      cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv
      vj cv wrex wi vw vk cv wral vf vk cv cuni vj cv cuni cm co crab vx cv vf
      cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ
      wrex wi vw vk cv wral vf vk cv cuni cX cm co crab vy cv vj cv cJ wceq vx
      cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv
      vj cv wrex wi vw vk cv wral vf vk cv cuni vj cv cuni cm co crab vx cv vf
      cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv vj cv
      wrex wi vw vk cv wral vf vk cv cuni cX cm co crab vx cv vf cv cfv vw cv
      wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk
      cv wral vf vk cv cuni cX cm co crab vj cv cJ wceq vk cv cuni vj cv cuni
      cm co vk cv cuni cX cm co wceq vx cv vf cv cfv vw cv wcel vx cv vv cv
      wcel vf cv vv cv cima vw cv wss wa vv vj cv wrex wi vw vk cv wral vf vk
      cv cuni vj cv cuni cm co crab vx cv vf cv cfv vw cv wcel vx cv vv cv wcel
      vf cv vv cv cima vw cv wss wa vv vj cv wrex wi vw vk cv wral vf vk cv
      cuni cX cm co crab wceq vj cv cJ wceq vj cv cuni cX vk cv cuni cm vj cv
      cJ wceq vj cv cuni cJ cuni cX vj cv cJ unieq cnfval.1 syl6eqr opreq2d vx
      cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv
      vj cv wrex wi vw vk cv wral vf vk cv cuni vj cv cuni cm co vk cv cuni cX
      cm co rabeq syl vj cv cJ wceq vx cv vf cv cfv vw cv wcel vx cv vv cv wcel
      vf cv vv cv cima vw cv wss wa vv vj cv wrex wi vw vk cv wral vx cv vf cv
      cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex
      wi vw vk cv wral vf vk cv cuni cX cm co vj cv cJ wceq vx cv vf cv cfv vw
      cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv vj cv wrex wi
      vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa
      vv cJ wrex wi vw vk cv vj cv cJ wceq vx cv vv cv wcel vf cv vv cv cima vw
      cv wss wa vv vj cv wrex vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv
      cJ wrex vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw
      cv wss wa vv vj cv cJ rexeq1 imbi2d ralbidv rabbisdv eqtrd eqeq2d anbi12d
      opabbidv vk cv cK wceq vx cv cX wcel vy cv vx cv vf cv cfv vw cv wcel vx
      cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral
      vf vk cv cuni cX cm co crab wceq wa vx cv cX wcel vy cv vx cv vf cv cfv
      vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi
      vw cK wral vf cY cX cm co crab wceq wa vx vy vk cv cK wceq vy cv vx cv vf
      cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ
      wrex wi vw vk cv wral vf vk cv cuni cX cm co crab wceq vy cv vx cv vf cv
      cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex
      wi vw cK wral vf cY cX cm co crab wceq vx cv cX wcel vk cv cK wceq vx cv
      vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ
      wrex wi vw vk cv wral vf vk cv cuni cX cm co crab vx cv vf cv cfv vw cv
      wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw cK
      wral vf cY cX cm co crab vy cv vk cv cK wceq vx cv vf cv cfv vw cv wcel
      vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv
      wral vf vk cv cuni cX cm co crab vx cv vf cv cfv vw cv wcel vx cv vv cv
      wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral vf cY cX
      cm co crab vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima
      vw cv wss wa vv cJ wrex wi vw cK wral vf cY cX cm co crab vk cv cK wceq
      vk cv cuni cX cm co cY cX cm co wceq vx cv vf cv cfv vw cv wcel vx cv vv
      cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral vf vk
      cv cuni cX cm co crab vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv
      vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral vf cY cX cm co crab
      wceq vk cv cK wceq vk cv cuni cY cX cm vk cv cK wceq vk cv cuni cK cuni
      cY vk cv cK unieq cnfval.2 syl6eqr opreq1d vx cv vf cv cfv vw cv wcel vx
      cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi vw vk cv wral
      vf vk cv cuni cX cm co cY cX cm co rabeq syl vk cv cK wceq vx cv vf cv
      cfv vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex
      wi vw vk cv wral vx cv vf cv cfv vw cv wcel vx cv vv cv wcel vf cv vv cv
      cima vw cv wss wa vv cJ wrex wi vw cK wral vf cY cX cm co vx cv vf cv cfv
      vw cv wcel vx cv vv cv wcel vf cv vv cv cima vw cv wss wa vv cJ wrex wi
      vw vk cv cK raleq1 rabbisdv eqtrd eqeq2d anbi2d opabbidv vx vy vz vw vv
      vf vj vk df-cnp oprabval2g mpd3an3 $.
      $( [17-Oct-2006] $) $( [17-Oct-2006] $)
  $}

  ${
    $d f x y F $.  $d f v w x y J $.  $d y w v f K $.  $d f v w x y P $.
    $d f v w y X $.  $d f v w y Y $.
    iscn.1 $e |- X = U. J $.
    iscn.2 $e |- Y = U. K $.
    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` ."  Definition of continuous function in [Munkres]
       p. 102. $)
    iscn $p |- ( ( J e. Top /\ K e. Top ) -> ( F e. ( J Cn K ) <->
               ( F : X --> Y /\ A. y e. K ( `' F " y ) e. J ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cF vf cv ccnv vy cv
      cima cJ wcel vy cK wral vf cY cX cm co crab wcel cX cY cF wf cF ccnv vy
      cv cima cJ wcel vy cK wral wa cJ ctop wcel cK ctop wcel wa cJ cK ccn co
      vf cv ccnv vy cv cima cJ wcel vy cK wral vf cY cX cm co crab cF vy vf cJ
      cK cX cY iscn.1 iscn.2 cnfval eleq2d cJ ctop wcel cK ctop wcel wa cF cY
      cX cm co wcel cF ccnv vy cv cima cJ wcel vy cK wral wa cX cY cF wf cF
      ccnv vy cv cima cJ wcel vy cK wral wa cF vf cv ccnv vy cv cima cJ wcel vy
      cK wral vf cY cX cm co crab wcel cJ ctop wcel cK ctop wcel wa cF cY cX cm
      co wcel cX cY cF wf cF ccnv vy cv cima cJ wcel vy cK wral cK ctop wcel cJ
      ctop wcel cF cY cX cm co wcel cX cY cF wf wb cY cvv wcel cX cvv wcel cF
      cY cX cm co wcel cX cY cF wf wb cK ctop wcel cJ ctop wcel cY cX cF cvv
      cvv elmapg cK ctop wcel cK cuni cvv cY cK ctop uniexg iscn.2 syl5eqel cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg iscn.1 syl5eqel syl2an ancoms
      anbi1d vf cv ccnv vy cv cima cJ wcel vy cK wral cF ccnv vy cv cima cJ
      wcel vy cK wral vf cF cY cX cm co vf cv cF wceq vf cv ccnv vy cv cima cJ
      wcel cF ccnv vy cv cima cJ wcel vy cK vf cv cF wceq vf cv ccnv vy cv cima
      cF ccnv vy cv cima cJ vf cv cF wceq vf cv ccnv cF ccnv vy cv vf cv cF
      cnveq imaeq1d eleq1d ralbidv elrab syl5bb bitrd $.
      $( [17-Oct-2006] $) $( [17-Oct-2006] $)

    $( The set of all functions from topology ` J ` to topology ` K ` that are
       continuous at a point ` P ` . $)
    cnpval $p |- ( ( J e. Top /\ K e. Top /\ P e. X ) -> ( ( J CnP K ) ` P ) =
         { f e. ( Y ^m X ) | A. y e. K
            ( ( f ` P ) e. y -> E. x e. J ( P e. x /\ ( f " x ) C_ y ) ) } ) $=
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cP cJ cK ccnp co cfv cP vw cv cX
      wcel vv cv vw cv vf cv cfv vy cv wcel vw cv vx cv wcel vf cv vx cv cima
      vy cv wss wa vx cJ wrex wi vy cK wral vf cY cX cm co crab wceq wa vw vv
      copab cfv cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv
      wss wa vx cJ wrex wi vy cK wral vf cY cX cm co crab cJ ctop wcel cK ctop
      wcel cP cJ cK ccnp co cfv cP vw cv cX wcel vv cv vw cv vf cv cfv vy cv
      wcel vw cv vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK
      wral vf cY cX cm co crab wceq wa vw vv copab cfv wceq cP cX wcel cJ ctop
      wcel cK ctop wcel wa cP cJ cK ccnp co vw cv cX wcel vv cv vw cv vf cv cfv
      vy cv wcel vw cv vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi
      vy cK wral vf cY cX cm co crab wceq wa vw vv copab vw vv vy vx vf cJ cK
      cX cY iscn.1 iscn.2 cnpfval fveq1d 3adant3 cP cX wcel cJ ctop wcel cP vw
      cv cX wcel vv cv vw cv vf cv cfv vy cv wcel vw cv vx cv wcel vf cv vx cv
      cima vy cv wss wa vx cJ wrex wi vy cK wral vf cY cX cm co crab wceq wa vw
      vv copab cfv cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv
      wss wa vx cJ wrex wi vy cK wral vf cY cX cm co crab wceq cK ctop wcel vw
      vv cP vw cv vf cv cfv vy cv wcel vw cv vx cv wcel vf cv vx cv cima vy cv
      wss wa vx cJ wrex wi vy cK wral vf cY cX cm co crab cP vf cv cfv vy cv
      wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral
      vf cY cX cm co crab cX vw cv cX wcel vv cv vw cv vf cv cfv vy cv wcel vw
      cv vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral vf
      cY cX cm co crab wceq wa vw vv copab vw cv cP wceq vw cv vf cv cfv vy cv
      wcel vw cv vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK
      wral cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa
      vx cJ wrex wi vy cK wral vf cY cX cm co vw cv cP wceq vw cv vf cv cfv vy
      cv wcel vw cv vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi cP
      vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ
      wrex wi vy cK vw cv cP wceq vw cv vf cv cfv vy cv wcel cP vf cv cfv vy cv
      wcel vw cv vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex cP vx cv
      wcel vf cv vx cv cima vy cv wss wa vx cJ wrex vw cv cP wceq vw cv vf cv
      cfv cP vf cv cfv vy cv vw cv cP vf cv fveq2 eleq1d vw cv cP wceq vw cv vx
      cv wcel vf cv vx cv cima vy cv wss wa cP vx cv wcel vf cv vx cv cima vy
      cv wss wa vx cJ vw cv cP wceq vw cv vx cv wcel cP vx cv wcel vf cv vx cv
      cima vy cv wss vw cv cP vx cv eleq1 anbi1d rexbidv imbi12d ralbidv
      rabbisdv vw cv cX wcel vv cv vw cv vf cv cfv vy cv wcel vw cv vx cv wcel
      vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral vf cY cX cm co
      crab wceq wa vw vv copab eqid cP vf cv cfv vy cv wcel cP vx cv wcel vf cv
      vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral vf cY cX cm co cY cX cm
      oprex rabex fvopab4 3ad2ant3 eqtrd $.
      $( [17-Oct-2006] $) $( [17-Oct-2006] $)

    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ."  Based on Theorem 7.2(g) of [Munkres]
       p. 107. $)
    iscnp $p |- ( ( J e. Top /\ K e. Top /\ P e. X ) ->
                   ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\ A. y e. K
          ( ( F ` P ) e. y -> E. x e. J ( P e. x /\ ( F " x ) C_ y ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cF
      cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ
      wrex wi vy cK wral vf cY cX cm co crab wcel cX cY cF wf cP cF cfv vy cv
      wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral wa
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cP cJ cK ccnp co cfv cP vf cv
      cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi
      vy cK wral vf cY cX cm co crab cF vx vy cP vf cJ cK cX cY iscn.1 iscn.2
      cnpval eleq2d cJ ctop wcel cK ctop wcel cF cP vf cv cfv vy cv wcel cP vx
      cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral vf cY cX
      cm co crab wcel cX cY cF wf cP cF cfv vy cv wcel cP vx cv wcel cF vx cv
      cima vy cv wss wa vx cJ wrex wi vy cK wral wa wb cP cX wcel cJ ctop wcel
      cK ctop wcel wa cF cY cX cm co wcel cP cF cfv vy cv wcel cP vx cv wcel cF
      vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral wa cX cY cF wf cP cF cfv
      vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ wrex wi vy cK
      wral wa cF cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv
      wss wa vx cJ wrex wi vy cK wral vf cY cX cm co crab wcel cJ ctop wcel cK
      ctop wcel wa cF cY cX cm co wcel cX cY cF wf cP cF cfv vy cv wcel cP vx
      cv wcel cF vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral cK ctop wcel
      cJ ctop wcel cF cY cX cm co wcel cX cY cF wf wb cY cvv wcel cX cvv wcel
      cF cY cX cm co wcel cX cY cF wf wb cK ctop wcel cJ ctop wcel cY cX cF cvv
      cvv elmapg cK ctop wcel cK cuni cvv cY cK ctop uniexg iscn.2 syl5eqel cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg iscn.1 syl5eqel syl2an ancoms
      anbi1d cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss
      wa vx cJ wrex wi vy cK wral cP cF cfv vy cv wcel cP vx cv wcel cF vx cv
      cima vy cv wss wa vx cJ wrex wi vy cK wral vf cF cY cX cm co vf cv cF
      wceq cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa
      vx cJ wrex wi cP cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss
      wa vx cJ wrex wi vy cK vf cv cF wceq cP vf cv cfv vy cv wcel cP cF cfv vy
      cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex cP vx cv
      wcel cF vx cv cima vy cv wss wa vx cJ wrex vf cv cF wceq cP vf cv cfv cP
      cF cfv vy cv cP vf cv cF fveq1 eleq1d vf cv cF wceq cP vx cv wcel vf cv
      vx cv cima vy cv wss wa cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ vf
      cv cF wceq vf cv vx cv cima vy cv wss cF vx cv cima vy cv wss cP vx cv
      wcel vf cv cF wceq vf cv vx cv cima cF vx cv cima vy cv vf cv cF vx cv
      imaeq1 sseq1d anbi2d rexbidv imbi12d ralbidv elrab syl5bb 3adant3 bitrd
      $.
      $( [17-Oct-2006] $) $( [17-Oct-2006] $)
  $}

  ${
    $d x y F $.  $d x y J $.  $d x y K $.  $d x y X $.  $d x y Y $.
    $d P x y $.
    iscnp2.1 $e |- X = U. J $.
    iscnp2.2 $e |- Y = U. K $.
    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ." $)
    iscnp2 $p |- ( ( J e. Top /\ K e. Top /\ P e. X ) ->
                   ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\ A. y e. K
       ( ( F ` P ) e. y -> E. x e. J ( P e. x /\ x C_ ( `' F " y ) ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX
      cY cF wf cP cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx
      cJ wrex wi vy cK wral wa cX cY cF wf cP cF cfv vy cv wcel cP vx cv wcel
      vx cv cF ccnv vy cv cima wss wa vx cJ wrex wi vy cK wral wa vx vy cP cF
      cJ cK cX cY iscnp2.1 iscnp2.2 iscnp cJ ctop wcel cK ctop wcel cX cY cF wf
      cP cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ wrex
      wi vy cK wral wa cX cY cF wf cP cF cfv vy cv wcel cP vx cv wcel vx cv cF
      ccnv vy cv cima wss wa vx cJ wrex wi vy cK wral wa wb cP cX wcel cJ ctop
      wcel cX cY cF wf cP cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv
      wss wa vx cJ wrex wi vy cK wral cP cF cfv vy cv wcel cP vx cv wcel vx cv
      cF ccnv vy cv cima wss wa vx cJ wrex wi vy cK wral cJ ctop wcel cX cY cF
      wf wa cP cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ
      wrex wi cP cF cfv vy cv wcel cP vx cv wcel vx cv cF ccnv vy cv cima wss
      wa vx cJ wrex wi vy cK cJ ctop wcel cX cY cF wf wa cP vx cv wcel cF vx cv
      cima vy cv wss wa vx cJ wrex cP vx cv wcel vx cv cF ccnv vy cv cima wss
      wa vx cJ wrex cP cF cfv vy cv wcel cJ ctop wcel cX cY cF wf wa cP vx cv
      wcel cF vx cv cima vy cv wss wa cP vx cv wcel vx cv cF ccnv vy cv cima
      wss wa vx cJ cJ ctop wcel cX cY cF wf wa vx cv cJ wcel wa cF vx cv cima
      vy cv wss vx cv cF ccnv vy cv cima wss cP vx cv wcel cF wfun vx cv cF cdm
      wss cF vx cv cima vy cv wss vx cv cF ccnv vy cv cima wss wb cJ ctop wcel
      cX cY cF wf wa vx cv cJ wcel wa vx cv vy cv cF funimass3 cX cY cF wf cF
      wfun cJ ctop wcel vx cv cJ wcel cX cY cF ffun ad2antlr cJ ctop wcel cX cY
      cF wf wa vx cv cJ wcel wa vx cv cX cF cdm cJ ctop wcel vx cv cJ wcel vx
      cv cX wss cX cY cF wf vx cv cJ cX iscnp2.1 eltopss adantlr cX cY cF wf cF
      cdm cX wceq cJ ctop wcel vx cv cJ wcel cX cY cF fdm ad2antlr sseqtr4d
      sylanc anbi2d rexbidva imbi2d ralbidv pm5.32da 3ad2ant1 bitrd $.
      $( [21-Jun-2008] $) $( [15-May-2007] $)

    $( A continuous function is a mapping.  (Contributed by FL,
       15-Dec-2006.) $)
    cnf $p |- ( ( J e. Top /\ K e. Top /\ F e. ( J Cn K ) ) ->
                F : X --> Y ) $=
      cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cX cY cF wf cJ ctop wcel
      cK ctop wcel wa cF cJ cK ccn co wcel cX cY cF wf cF ccnv vx cv cima cJ
      wcel vx cK wral vx cF cJ cK cX cY iscnp2.1 iscnp2.2 iscn pm3.26bda 3impa
      $.
      $( [15-Dec-2006] $) $( [8-Dec-2006] $)

    $( A continuous function at point ` P ` is a mapping.  (Contributed by FL,
       31-Dec-2006.) $)
    cnpf $p |- ( ( ( J e. Top /\ K e. Top /\ P e. X ) /\
        F e. ( ( J CnP K ) ` P ) ) -> F : X --> Y ) $=
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX
      cY cF wf cP cF cfv vx cv wcel cP vy cv wcel cF vy cv cima vx cv wss wa vy
      cJ wrex wi vx cK wral vy vx cP cF cJ cK cX cY iscnp2.1 iscnp2.2 iscnp
      pm3.26bda $.
      $( [1-Jan-2007] $) $( [17-Nov-2006] $)

    $( The value of a continuous function from ` J ` to ` K ` at point ` P `
       belongs to the underlying set of topology ` K ` .  (Contributed by FL,
       31-Dec-2006.) $)
    cnpcl $p |- ( ( ( J e. Top /\ K e. Top /\ P e. X ) /\
        ( F e. ( ( J CnP K ) ` P ) /\ A e. X ) ) -> ( F ` A ) e. Y ) $=
      cX cY cF wf cA cX wcel cA cF cfv cY wcel cJ ctop wcel cK ctop wcel cP cX
      wcel w3a cF cP cJ cK ccnp co cfv wcel cA cX wcel wa wa cX cY cA cF
      ffvelrn cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv
      wcel cX cY cF wf cA cX wcel cP cF cJ cK cX cY iscnp2.1 iscnp2.2 cnpf
      adantrr cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv
      wcel cA cX wcel simprr sylanc $.
      $( [1-Jan-2007] $) $( [27-Dec-2006] $)
  $}

  ${
    $d x y A $.  $d F y x $.  $d J x y $.  $d K y $.  $d P x y $.  $d X y $.
    cnpimaex.1 $e |- X = U. J $.
    $( Property of a function continuous at a point.  (Contributed by FL,
       31-Dec-2006.) $)
    cnpimaex $p |- ( ( ( J e. Top /\ K e. Top /\ P e. X ) /\ (
                   F e. ( ( J CnP K ) ` P ) /\ A e. K /\ ( F ` P ) e. A ) ) ->
                    E. x e. J ( P e. x /\ ( F " x ) C_ A ) ) $=
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA
      cK wcel cP cF cfv cA wcel cP vx cv wcel cF vx cv cima cA wss wa vx cJ
      wrex cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv
      wcel cP cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ
      wrex wi vy cK wral cA cK wcel cP cF cfv cA wcel cP vx cv wcel cF vx cv
      cima cA wss wa vx cJ wrex wi wi cJ ctop wcel cK ctop wcel cP cX wcel w3a
      cF cP cJ cK ccnp co cfv wcel cP cF cfv vy cv wcel cP vx cv wcel cF vx cv
      cima vy cv wss wa vx cJ wrex wi vy cK wral cJ ctop wcel cK ctop wcel cP
      cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX cK cuni cF wf cP cF cfv vy cv
      wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral vx
      vy cP cF cJ cK cX cK cuni cnpimaex.1 cK cuni eqid iscnp pm3.27bda ex cP
      cF cfv vy cv wcel cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ wrex wi
      cP cF cfv cA wcel cP vx cv wcel cF vx cv cima cA wss wa vx cJ wrex wi vy
      cA cK vy cv cA wceq cP cF cfv vy cv wcel cP cF cfv cA wcel cP vx cv wcel
      cF vx cv cima vy cv wss wa vx cJ wrex cP vx cv wcel cF vx cv cima cA wss
      wa vx cJ wrex vy cv cA cP cF cfv eleq2 vy cv cA wceq cP vx cv wcel cF vx
      cv cima vy cv wss wa cP vx cv wcel cF vx cv cima cA wss wa vx cJ vy cv cA
      wceq cF vx cv cima vy cv wss cF vx cv cima cA wss cP vx cv wcel vy cv cA
      cF vx cv cima sseq2 anbi2d rexbidv imbi12d rcla4cv syl6 3imp2 $.
      $( [1-Jan-2007] $) $( [22-Dec-2006] $)

    $( A restricted identity function is a continuous function.  (Contributed
       by FL, 31-Dec-2006.) $)
    idcn $p |- ( J e. Top -> ( _I |` X ) e. ( J Cn J ) ) $=
      cJ ctop wcel cid cX cres cJ cJ ccn co wcel cX cX cid cX cres wf cid cX
      cres ccnv vy cv cima cJ wcel vy cJ wral wa cJ ctop wcel cX cX cid cX cres
      wf cid cX cres ccnv vy cv cima cJ wcel vy cJ wral cJ ctop wcel cid cX
      cres cX wfn cid cX cres crn cX wss wa cX cX cid cX cres wf cJ ctop wcel
      cid cX cres crn cX wss cid cX cres cX wfn cid cX cres crn cX wss cJ ctop
      wcel cid cX cres crn cX cX rnresi eqimssi a1i cX fnresi jctil cX cX cid
      cX cres df-f sylibr cJ ctop wcel cid cX cres ccnv vy cv cima cJ wcel vy
      cJ cJ ctop wcel vy cv cJ wcel wa cid cX cres ccnv vy cv cima vy cv cJ cJ
      ctop wcel vy cv cJ wcel wa cid cX cres ccnv vy cv cima cid cX cres vy cv
      cima vy cv cJ ctop wcel vy cv cJ wcel wa cid cX cres ccnv cid cX cres vy
      cv cJ ctop wcel vy cv cJ wcel wa cid cX cres ccnv cid ccnv cX cres cid cX
      cres cJ ctop wcel vy cv cJ wcel wa cid ccnv wfun cid cX cres ccnv cid
      ccnv cX cres wceq cJ ctop wcel vy cv cJ wcel wa cid wfun cid ccnv wfun
      cid wfun cJ ctop wcel vy cv cJ wcel wa funi a1i cid cid ccnv wceq cid
      wfun cid ccnv wfun wb cid ccnv cid cnvi eqcomi cid cid ccnv funeq ax-mp
      sylib cid ccnv wfun cid cX cres ccnv cid ccnv cid cX cima cres cid ccnv
      cX cres cX cid funcnvres cid ccnv wfun cid cX cima cX wceq cid ccnv cid
      cX cima cres cid ccnv cX cres wceq cid cX cima cX wceq cid ccnv wfun cX
      imai a1i cid cX cima cX cid ccnv reseq2 syl eqtrd syl cid ccnv cid wceq
      cid ccnv cX cres cid cX cres wceq cnvi cid ccnv cid cX reseq1 ax-mp
      syl6eq imaeq1d cJ ctop wcel vy cv cJ wcel wa vy cv cX wss cid cX cres vy
      cv cima vy cv wceq vy cv cJ cX cnpimaex.1 eltopss cX vy cv resiima syl
      eqtrd cJ ctop wcel vy cv cJ wcel pm3.27 eqeltrd r19.21aiva jca cJ ctop
      wcel cid cX cres cJ cJ ccn co wcel cX cX cid cX cres wf cid cX cres ccnv
      vy cv cima cJ wcel vy cJ wral wa wb vy cid cX cres cJ cJ cX cX cnpimaex.1
      cnpimaex.1 iscn anidms mpbird $.
      $( [1-Jan-2007] $) $( [27-Dec-2006] $)
  $}

  ${
    $d x A $.  $d x F $.  $d x J $.  $d x K $.
    $( An open subset of the codomain of a continuous function has an open
       pre-image.  (Contributed by FL, 15-Dec-2006.) $)
    cnima $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Cn K ) ) /\ A e. K ) ->
                 ( `' F " A ) e. J ) $=
      cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cK wcel cF ccnv cA
      cima cJ wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cF ccnv
      vx cv cima cJ wcel vx cK wral cA cK wcel cF ccnv cA cima cJ wcel wi cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel cF ccnv vx cv cima cJ wcel vx
      cK wral cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cJ cuni cK cuni
      cF wf cF ccnv vx cv cima cJ wcel vx cK wral vx cF cJ cK cJ cuni cK cuni
      cJ cuni eqid cK cuni eqid iscn pm3.27bda 3impa cF ccnv vx cv cima cJ wcel
      cF ccnv cA cima cJ wcel vx cA cK vx cv cA wceq cF ccnv vx cv cima cF ccnv
      cA cima cJ vx cv cA cF ccnv imaeq2 eleq1d rcla4cv syl imp $.
      $( [15-Dec-2006] $) $( [8-Dec-2006] $)
  $}

  ${
    $d x F $.  $d x G $.  $d x J $.  $d x K $.  $d x L $.
    $( The composition of two continuous functions is a continuous
       function.  (Contributed by FL, 15-Dec-2006.) $)
    cnco $p |- ( ( ( J e. Top /\ K e. Top /\ L e. Top ) /\ ( F e. ( J Cn K )
                  /\ G e.  ( K Cn L ) ) ) -> ( G o. F ) e. ( J Cn L ) ) $=
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK ccn co wcel cG cK cL
      ccn co wcel wa wa cG cF ccom cJ cL ccn co wcel cJ cuni cL cuni cG cF ccom
      wf cG cF ccom ccnv vx cv cima cJ wcel vx cL wral wa cJ ctop wcel cK ctop
      wcel cL ctop wcel w3a cF cJ cK ccn co wcel cG cK cL ccn co wcel wa wa cJ
      cuni cL cuni cG cF ccom wf cG cF ccom ccnv vx cv cima cJ wcel vx cL wral
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK ccn co wcel cG cK cL
      ccn co wcel cJ cuni cL cuni cG cF ccom wf cJ ctop wcel cK ctop wcel cL
      ctop wcel w3a cG cK cL ccn co wcel wa cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cF cJ cK ccn co wcel wa cJ cuni cL cuni cG cF ccom wf cK cuni cL
      cuni cG wf cJ cuni cK cuni cF wf cJ cuni cL cuni cG cF ccom wf cJ ctop
      wcel cK ctop wcel cL ctop wcel w3a cG cK cL ccn co wcel wa cJ ctop wcel
      cK ctop wcel cL ctop wcel w3a cF cJ cK ccn co wcel wa cJ cuni cK cuni cL
      cuni cG cF fco cK ctop wcel cL ctop wcel cG cK cL ccn co wcel cK cuni cL
      cuni cG wf cJ ctop wcel cK ctop wcel cL ctop wcel cG cK cL ccn co wcel cK
      cuni cL cuni cG wf cG cK cL cK cuni cL cuni cK cuni eqid cL cuni eqid cnf
      3expa 3adantl1 cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cJ cuni cK
      cuni cF wf cL ctop wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cJ
      cuni cK cuni cF wf cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid cnf
      3expa 3adantl3 syl2an ancoms anandis cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cF cJ cK ccn co wcel cG cK cL ccn co wcel wa wa cG cF ccom ccnv
      vx cv cima cJ wcel vx cL cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ
      cK ccn co wcel cG cK cL ccn co wcel wa wa vx cv cL wcel wa cF ccnv cG
      ccnv vx cv cima cima cJ cG cF ccom ccnv vx cv cima cJ ctop wcel cK ctop
      wcel cF cJ cK ccn co wcel w3a cG ccnv vx cv cima cK wcel cF ccnv cG ccnv
      vx cv cima cima cJ wcel cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ
      cK ccn co wcel cG cK cL ccn co wcel wa wa vx cv cL wcel wa cG ccnv vx cv
      cima cF cJ cK cnima cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK
      ccn co wcel cG cK cL ccn co wcel wa wa vx cv cL wcel wa cJ ctop wcel cK
      ctop wcel cF cJ cK ccn co wcel cJ ctop wcel cK ctop wcel cL ctop wcel w3a
      cJ ctop wcel cF cJ cK ccn co wcel cG cK cL ccn co wcel wa vx cv cL wcel
      cJ ctop wcel cK ctop wcel cL ctop wcel 3simp1 ad2antrr cJ ctop wcel cK
      ctop wcel cL ctop wcel w3a cK ctop wcel cF cJ cK ccn co wcel cG cK cL ccn
      co wcel wa vx cv cL wcel cJ ctop wcel cK ctop wcel cL ctop wcel 3simp2
      ad2antrr cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK ccn co wcel
      cG cK cL ccn co wcel vx cv cL wcel simplrl 3jca cK ctop wcel cL ctop wcel
      cG cK cL ccn co wcel w3a vx cv cL wcel cG ccnv vx cv cima cK wcel cJ ctop
      wcel cK ctop wcel cL ctop wcel w3a cF cJ cK ccn co wcel cG cK cL ccn co
      wcel wa wa vx cv cG cK cL cnima cJ ctop wcel cK ctop wcel cL ctop wcel
      w3a cF cJ cK ccn co wcel cG cK cL ccn co wcel wa wa cK ctop wcel cL ctop
      wcel cG cK cL ccn co wcel cJ ctop wcel cK ctop wcel cL ctop wcel cF cJ cK
      ccn co wcel cG cK cL ccn co wcel wa 3simpl2 cJ ctop wcel cK ctop wcel cL
      ctop wcel cF cJ cK ccn co wcel cG cK cL ccn co wcel wa 3simpl3 cJ ctop
      wcel cK ctop wcel cL ctop wcel w3a cF cJ cK ccn co wcel cG cK cL ccn co
      wcel simprr 3jca sylan sylanc cG cF ccom ccnv vx cv cima cF ccnv cG ccnv
      ccom vx cv cima cF ccnv cG ccnv vx cv cima cima cG cF ccom ccnv cF ccnv
      cG ccnv ccom vx cv cG cF cnvco imaeq1i cF ccnv cG ccnv vx cv imaco eqtri
      syl5eqel r19.21aiva jca cJ ctop wcel cK ctop wcel cL ctop wcel w3a cG cF
      ccom cJ cL ccn co wcel cJ cuni cL cuni cG cF ccom wf cG cF ccom ccnv vx
      cv cima cJ wcel vx cL wral wa wb cF cJ cK ccn co wcel cG cK cL ccn co
      wcel wa cJ ctop wcel cL ctop wcel cG cF ccom cJ cL ccn co wcel cJ cuni cL
      cuni cG cF ccom wf cG cF ccom ccnv vx cv cima cJ wcel vx cL wral wa wb cK
      ctop wcel vx cG cF ccom cJ cL cJ cuni cL cuni cJ cuni eqid cL cuni eqid
      iscn 3adant2 adantr mpbird $.
      $( [15-Dec-2006] $) $( [8-Dec-2006] $)
  $}

  ${
    $d x y z F $.  $d x y z G $.  $d x y z J $.  $d x y z K $.  $d x y z L $.
    $d x y z P $.  $d x y z X $.
    cnpco.1 $e |- X = U. J $.
    $( MAY BE REVISED - this proof needs to be shortened significantly $)
    $( The composition of two continuous functions at point ` P ` is a
       continuous function at point ` P ` .  Bourbaki TG I.9.  (Contributed by
       FL, 31-Dec-2006.)  _Warning:  The HTML proof page is 0.5MB in
       size_. $)
    cnpco $p |- ( ( ( J e. Top /\ L e. Top /\ P e. X ) /\ ( K e. Top
        /\ F e. ( ( J CnP K ) ` P ) /\ G e.  ( ( K CnP L ) ` ( F ` P ) ) ) )
        -> ( G o. F ) e. ( ( J CnP L ) ` P ) ) $=
      cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cG cF ccom cP cJ cL
      ccnp co cfv wcel cX cL cuni cG cF ccom wf cP cG cF ccom cfv vz cv wcel cP
      vx cv wcel cG cF ccom vx cv cima vz cv wss wa vx cJ wrex wi vz cL wral wa
      cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cX cL cuni cG cF ccom
      wf cP cG cF ccom cfv vz cv wcel cP vx cv wcel cG cF ccom vx cv cima vz cv
      wss wa vx cJ wrex wi vz cL wral cK cuni cL cuni cG wf cX cK cuni cF wf cX
      cL cuni cG cF ccom wf cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa cX cK cuni cL cuni cG cF fco cK ctop wcel cL ctop wcel cP cF cfv cK
      cuni wcel w3a cG cP cF cfv cK cL ccnp co cfv wcel cK cuni cL cuni cG wf
      cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cP cF cfv cG cK cL cK
      cuni cL cuni cK cuni eqid cL cuni eqid cnpf cJ ctop wcel cL ctop wcel cP
      cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa cK ctop wcel cL ctop wcel cP cF cfv cK cuni wcel
      cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel 3simpr1 cJ ctop wcel cL ctop
      wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK
      cL ccnp co cfv wcel w3a 3simpl2 cJ cuni cK cuni cF wf cP cJ cuni wcel cP
      cF cfv cK cuni wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa
      cJ cuni cK cuni cP cF ffvelrn cJ ctop wcel cL ctop wcel cP cX wcel w3a cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a wa cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a cF cP cJ cK
      ccnp co cfv wcel wa cJ cuni cK cuni cF wf cJ ctop wcel cL ctop wcel cP cX
      wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a cF cP cJ cK
      ccnp co cfv wcel wa cJ ctop wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp
      co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop
      wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cL ctop
      wcel cP cX wcel cJ ctop wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG
      cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cJ cuni
      wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cP cX wcel cP cJ cuni wcel cJ
      ctop wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a cF cP
      cJ cK ccnp co cfv wcel wa wi wi cX cJ cuni cP cnpco.1 eleq2i cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ
      ctop wcel cP cJ cuni wcel cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a
      cF cP cJ cK ccnp co cfv wcel wa cK ctop wcel cF cP cJ cK ccnp co cfv wcel
      cG cP cF cfv cK cL ccnp co cfv wcel cJ ctop wcel cP cJ cuni wcel cJ ctop
      wcel cK ctop wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi
      wi cG cP cF cfv cK cL ccnp co cfv wcel cF cP cJ cK ccnp co cfv wcel cK
      ctop wcel cJ ctop wcel cP cJ cuni wcel cJ ctop wcel cK ctop wcel cP cJ
      cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cF cP cJ cK ccnp co
      cfv wcel cK ctop wcel cJ ctop wcel cP cJ cuni wcel cJ ctop wcel cK ctop
      wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi wi wi cG
      cP cF cfv cK cL ccnp co cfv wcel cJ ctop wcel cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cP cJ cuni wcel cJ ctop wcel cK ctop wcel cP cJ cuni
      wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel cK ctop wcel cP
      cJ cuni wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP cJ
      cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop wcel cK ctop wcel
      cP cJ cuni wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP
      cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel cK ctop
      wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel pm3.2 3exp com34
      com13 a1i com13 3imp com13 sylbi com12 a1d 3imp1 cP cF cJ cK cJ cuni cK
      cuni cJ cuni eqid cK cuni eqid cnpf syl cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cP cJ cuni wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP
      cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cP cX cJ cuni cJ ctop wcel cL ctop wcel cP cX wcel 3simp3 cnpco.1
      syl6eleq adantr sylanc 3jca cJ ctop wcel cL ctop wcel cP cX wcel w3a cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel 3simpr3 sylanc cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa
      cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa
      cX cK cuni cF wf cJ ctop wcel cL ctop wcel cP cX wcel cK ctop wcel cF cP
      cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop
      wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop
      wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK
      cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ
      cK ccnp co cfv wcel wa wi wi cL ctop wcel cK ctop wcel cF cP cJ cK ccnp
      co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cP cX wcel cJ ctop
      wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv
      wcel wa cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp
      co cfv wcel cP cX wcel cJ ctop wcel cJ ctop wcel cK ctop wcel cP cX wcel
      w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cG cP cF cfv cK cL ccnp co cfv
      wcel cF cP cJ cK ccnp co cfv wcel cK ctop wcel cP cX wcel cJ ctop wcel cJ
      ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi
      wi cF cP cJ cK ccnp co cfv wcel cK ctop wcel cP cX wcel cJ ctop wcel cJ
      ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi
      wi wi wi cG cP cF cfv cK cL ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP
      cX wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP cX wcel
      w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop wcel cK ctop wcel cP cX wcel
      cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a cF
      cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel cK ctop wcel cP cX wcel w3a
      cF cP cJ cK ccnp co cfv wcel pm3.2 3exp com14 a1i com13 3imp com13 a1d
      3imp1 cP cF cJ cK cX cK cuni cnpco.1 cK cuni eqid cnpf syl sylanc cJ ctop
      wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv
      wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cP cF cfv cG cfv vz cv
      wcel cP vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex wi vz cL
      wral cP cG cF ccom cfv vz cv wcel cP vx cv wcel cG cF ccom vx cv cima vz
      cv wss wa vx cJ wrex wi vz cL wral cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a wa cP cF cfv cG cfv vz cv wcel cP vx cv wcel cG cF vx cv
      cima cima vz cv wss wa vx cJ wrex wi vz cL cJ ctop wcel cL ctop wcel cP
      cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa vz cv cL wcel cP cF cfv cG cfv vz cv wcel cP vx
      cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex cJ ctop wcel cL
      ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP
      cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz
      cv wcel wa cP vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex cP
      vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex vy cK wrex cJ
      ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP
      cF cfv cG cfv vz cv wcel wa cP cF cfv vy cv wcel cG vy cv cima vz cv wss
      wa vy cK wrex cP vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex
      vy cK wrex cK ctop wcel cL ctop wcel cP cF cfv cK cuni wcel w3a cG cP cF
      cfv cK cL ccnp co cfv wcel vz cv cL wcel cP cF cfv cG cfv vz cv wcel w3a
      cP cF cfv vy cv wcel cG vy cv cima vz cv wss wa vy cK wrex cJ ctop wcel
      cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG
      cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv
      vz cv wcel wa vy vz cv cP cF cfv cG cK cL cK cuni cK cuni eqid cnpimaex
      cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP
      cF cfv cG cfv vz cv wcel wa cK ctop wcel cL ctop wcel cP cF cfv cK cuni
      wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cK ctop wcel
      vz cv cL wcel cP cF cfv cG cfv vz cv wcel cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel 3simpr1 ad2antrr cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a wa cL ctop wcel vz cv cL wcel cP cF cfv cG cfv vz cv wcel cJ
      ctop wcel cL ctop wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv
      wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a 3simpl2 ad2antrr cJ cuni cK
      cuni cF wf cP cJ cuni wcel cP cF cfv cK cuni wcel cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv
      wcel wa cJ cuni cK cuni cP cF ffvelrn cJ ctop wcel cK ctop wcel cP cJ
      cuni wcel w3a cF cP cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cJ ctop
      wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv
      wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF
      cfv cG cfv vz cv wcel wa cP cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni
      eqid cnpf cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ
      cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL
      wcel wa cP cF cfv cG cfv vz cv wcel wa cJ ctop wcel cK ctop wcel cP cJ
      cuni wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ
      cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cJ ctop
      wcel vz cv cL wcel cP cF cfv cG cfv vz cv wcel cJ ctop wcel cL ctop wcel
      cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a 3simpl1 ad2antrr cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa cK ctop wcel vz cv cL wcel cP cF cfv cG cfv vz cv
      wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel 3simpr1 ad2antrr cJ
      ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP
      cF cfv cG cfv vz cv wcel wa cP cX cJ cuni cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa cP cX wcel vz cv cL wcel cP cF cfv cG cfv vz cv
      wcel cJ ctop wcel cL ctop wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp
      co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a 3simpl3 ad2antrr
      cnpco.1 syl6eleq 3jca cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa vz cv cL wcel wa cF cP cJ cK ccnp co cfv wcel cP cF cfv cG cfv vz cv
      wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cL ctop wcel cP cX
      wcel w3a vz cv cL wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel 3simp2 ad2antlr adantr sylanc cJ ctop wcel cL
      ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP
      cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz
      cv wcel wa cP cX cJ cuni cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa cP cX wcel vz cv cL wcel cP cF cfv cG cfv vz cv wcel cJ ctop wcel cL
      ctop wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a 3simpl3 ad2antrr cnpco.1 syl6eleq sylanc
      3jca cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel
      wa cP cF cfv cG cfv vz cv wcel wa cG cP cF cfv cK cL ccnp co cfv wcel vz
      cv cL wcel cP cF cfv cG cfv vz cv wcel cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa cG cP cF cfv cK cL ccnp co cfv wcel vz cv cL wcel
      cP cF cfv cG cfv vz cv wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel 3simpr3 ad2antrr cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa vz cv cL wcel cP cF cfv cG cfv vz cv wcel simplr cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv
      wcel pm3.27 3jca sylanc cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa cP cF cfv vy cv wcel
      cG vy cv cima vz cv wss wa cP vx cv wcel cG cF vx cv cima cima vz cv wss
      wa vx cJ wrex vy cK cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa
      vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa vy cv cK wcel wa cP cF
      cfv vy cv wcel cG vy cv cima vz cv wss wa cP vx cv wcel cF vx cv cima vy
      cv wss wa cG vy cv cima vz cv wss wa vx cJ wrex cP vx cv wcel cG cF vx cv
      cima cima vz cv wss wa vx cJ wrex cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa vy cv cK
      wcel wa cP cF cfv vy cv wcel cG vy cv cima vz cv wss wa cP vx cv wcel cF
      vx cv cima vy cv wss wa vx cJ wrex cG vy cv cima vz cv wss wa cP vx cv
      wcel cF vx cv cima vy cv wss wa cG vy cv cima vz cv wss wa vx cJ wrex cJ
      ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP
      cF cfv cG cfv vz cv wcel wa vy cv cK wcel wa cP cF cfv vy cv wcel cP vx
      cv wcel cF vx cv cima vy cv wss wa vx cJ wrex cG vy cv cima vz cv wss cJ
      ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP
      cF cfv cG cfv vz cv wcel wa vy cv cK wcel wa cP cF cfv vy cv wcel cP vx
      cv wcel cF vx cv cima vy cv wss wa vx cJ wrex cJ ctop wcel cK ctop wcel
      cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel vy cv cK wcel cP cF cfv vy cv
      wcel w3a cP vx cv wcel cF vx cv cima vy cv wss wa vx cJ wrex cJ ctop wcel
      cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG
      cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv
      vz cv wcel wa vy cv cK wcel wa cP cF cfv vy cv wcel wa vx vy cv cP cF cJ
      cK cX cnpco.1 cnpimaex cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa vy cv cK wcel wa cP cF
      cfv vy cv wcel wa cJ ctop wcel cK ctop wcel cP cX wcel cJ ctop wcel cL
      ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP
      cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz
      cv wcel wa cJ ctop wcel vy cv cK wcel cP cF cfv vy cv wcel cJ ctop wcel
      cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG
      cP cF cfv cK cL ccnp co cfv wcel w3a wa cJ ctop wcel vz cv cL wcel cP cF
      cfv cG cfv vz cv wcel cJ ctop wcel cL ctop wcel cP cX wcel cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      3simpl1 ad2antrr ad2antrr cJ ctop wcel cL ctop wcel cP cX wcel w3a cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa cK ctop wcel
      vy cv cK wcel cP cF cfv vy cv wcel cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a wa cK ctop wcel vz cv cL wcel cP cF cfv cG cfv vz cv wcel cJ
      ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel 3simpr1 ad2antrr ad2antrr cJ
      ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP
      cF cfv cG cfv vz cv wcel wa cP cX wcel vy cv cK wcel cP cF cfv vy cv wcel
      cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cP cX wcel vz cv cL
      wcel cP cF cfv cG cfv vz cv wcel cJ ctop wcel cL ctop wcel cP cX wcel cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a 3simpl3 ad2antrr ad2antrr 3jca cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa
      vy cv cK wcel wa cP cF cfv vy cv wcel wa cF cP cJ cK ccnp co cfv wcel vy
      cv cK wcel cP cF cfv vy cv wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a
      cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa cF cP cJ cK
      ccnp co cfv wcel vy cv cK wcel cP cF cfv vy cv wcel cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cF cP cJ cK ccnp co
      cfv wcel cP cF cfv cG cfv vz cv wcel cK ctop wcel cF cP cJ cK ccnp co cfv
      wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cF cP cJ cK ccnp co cfv wcel
      cJ ctop wcel cL ctop wcel cP cX wcel w3a vz cv cL wcel cK ctop wcel cF cP
      cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel 3simp2
      ad2antlr adantr ad2antrr cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa vy cv cK wcel cP cF
      cfv vy cv wcel simplr cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa vz cv cL wcel wa cP cF cfv cG cfv vz cv wcel wa vy cv cK wcel wa cP cF
      cfv vy cv wcel pm3.27 3jca sylanc ex anim1d cP vx cv wcel cF vx cv cima
      vy cv wss wa cG vy cv cima vz cv wss vx cJ r19.41v syl6ibr cP vx cv wcel
      cF vx cv cima vy cv wss wa cG vy cv cima vz cv wss wa cP vx cv wcel cG cF
      vx cv cima cima vz cv wss wa vx cJ cP vx cv wcel cF vx cv cima vy cv wss
      cG vy cv cima vz cv wss cP vx cv wcel cG cF vx cv cima cima vz cv wss wa
      cF vx cv cima vy cv wss cG vy cv cima vz cv wss wa cG cF vx cv cima cima
      vz cv wss cP vx cv wcel cG cF vx cv cima cima cG vy cv cima wss cG vy cv
      cima vz cv wss cG cF vx cv cima cima vz cv wss cF vx cv cima vy cv wss cG
      cF vx cv cima cima cG vy cv cima vz cv sstr cF vx cv cima vy cv cG imass2
      sylan anim2i anassrs r19.22si syl6 r19.22dva mpd cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa vz cv cL wcel wa cP cF cfv cG cfv vz cv
      wcel wa cK c0 wne cP vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ
      wrex cP vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex vy cK
      wrex wb cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cK c0 wne vz
      cv cL wcel cP cF cfv cG cfv vz cv wcel cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cK c0 wne cJ ctop wcel
      cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cK
      c0 wne cG cP cF cfv cK cL ccnp co cfv wcel cK ctop wcel c0 cK wcel cK c0
      wne cK 0opn cK c0 ne0i syl 3ad2ant1 adantl ad2antrr cP vx cv wcel cG cF
      vx cv cima cima vz cv wss wa vx cJ wrex vy cK r19.9rzv syl mpbird exp31
      r19.21aiv cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ
      cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cP cF cfv
      cG cfv vz cv wcel cP vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ
      wrex wi cP cG cF ccom cfv vz cv wcel cP vx cv wcel cG cF ccom vx cv cima
      vz cv wss wa vx cJ wrex wi vz cL cJ ctop wcel cL ctop wcel cP cX wcel w3a
      cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a wa cP cG cF ccom cfv vz cv wcel cP cF cfv cG cfv vz cv wcel cP
      vx cv wcel cG cF vx cv cima cima vz cv wss wa vx cJ wrex cP vx cv wcel cG
      cF ccom vx cv cima vz cv wss wa vx cJ wrex cJ ctop wcel cL ctop wcel cP
      cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa cP cG cF ccom cfv vz cv wcel cP cF cfv cG cfv vz
      cv wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cG wfun cF
      wfun cP cF cdm wcel w3a cP cG cF ccom cfv cP cF cfv cG cfv wceq cP cG cF
      ccom cfv vz cv wcel cP cF cfv cG cfv vz cv wcel wb cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa cG wfun cF wfun cP cF cdm wcel cJ ctop
      wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv
      wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cK ctop wcel cL ctop wcel
      cP cF cfv cK cuni wcel w3a cG cP cF cfv cK cL ccnp co cfv wcel wa cK cuni
      cL cuni cG wf cG wfun cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      wa cK ctop wcel cL ctop wcel cP cF cfv cK cuni wcel w3a cG cP cF cfv cK
      cL ccnp co cfv wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa
      cK ctop wcel cL ctop wcel cP cF cfv cK cuni wcel cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel 3simpr1 cJ ctop wcel cL ctop wcel cP cX wcel
      cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a 3simpl2 cJ cuni cK cuni cF wf cP cJ cuni wcel cP cF cfv cK cuni
      wcel cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cJ cuni cK
      cuni cP cF ffvelrn cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa
      cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv
      wcel wa cJ cuni cK cuni cF wf cJ ctop wcel cL ctop wcel cP cX wcel cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp
      co cfv wcel wa cJ ctop wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp co
      cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop
      wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cL ctop
      wcel cP cX wcel cJ ctop wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG
      cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cJ cuni
      wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cP cX wcel cP cJ cuni wcel cJ
      ctop wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a cF cP
      cJ cK ccnp co cfv wcel wa wi wi cX cJ cuni cP cnpco.1 eleq2i cK ctop wcel
      cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ
      ctop wcel cP cJ cuni wcel cJ ctop wcel cK ctop wcel cP cJ cuni wcel w3a
      cF cP cJ cK ccnp co cfv wcel wa cK ctop wcel cF cP cJ cK ccnp co cfv wcel
      cG cP cF cfv cK cL ccnp co cfv wcel cJ ctop wcel cP cJ cuni wcel cJ ctop
      wcel cK ctop wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi
      wi cG cP cF cfv cK cL ccnp co cfv wcel cF cP cJ cK ccnp co cfv wcel cK
      ctop wcel cJ ctop wcel cP cJ cuni wcel cJ ctop wcel cK ctop wcel cP cJ
      cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cF cP cJ cK ccnp co
      cfv wcel cK ctop wcel cJ ctop wcel cP cJ cuni wcel cJ ctop wcel cK ctop
      wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi wi wi cG
      cP cF cfv cK cL ccnp co cfv wcel cJ ctop wcel cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cP cJ cuni wcel cJ ctop wcel cK ctop wcel cP cJ cuni
      wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel cK ctop wcel cP
      cJ cuni wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP cJ
      cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop wcel cK ctop wcel
      cP cJ cuni wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP
      cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel cK ctop
      wcel cP cJ cuni wcel w3a cF cP cJ cK ccnp co cfv wcel pm3.2 3exp com34
      com13 a1i com13 3imp com13 sylbi com12 a1d 3imp1 cP cF cJ cK cJ cuni cK
      cuni cJ cuni eqid cK cuni eqid cnpf syl cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cP cJ cuni wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP
      cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cP cX cJ cuni cJ ctop wcel cL ctop wcel cP cX wcel 3simp3 cnpco.1
      syl6eleq adantr sylanc 3jca cJ ctop wcel cL ctop wcel cP cX wcel w3a cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel 3simpr3 jca cP cF cfv cG cK cL cK cuni cL cuni cK cuni eqid cL cuni
      eqid cnpf cK cuni cL cuni cG ffun 3syl cJ ctop wcel cL ctop wcel cP cX
      wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a wa cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ
      cK ccnp co cfv wcel wa cX cK cuni cF wf cF wfun cJ ctop wcel cL ctop wcel
      cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL
      ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK
      ccnp co cfv wcel wa cJ ctop wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp
      co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop
      wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cL ctop wcel cK
      ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv
      wcel w3a cP cX wcel cJ ctop wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a
      cF cP cJ cK ccnp co cfv wcel wa cK ctop wcel cF cP cJ cK ccnp co cfv wcel
      cG cP cF cfv cK cL ccnp co cfv wcel cP cX wcel cJ ctop wcel cJ ctop wcel
      cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cG cP
      cF cfv cK cL ccnp co cfv wcel cF cP cJ cK ccnp co cfv wcel cK ctop wcel
      cP cX wcel cJ ctop wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ
      cK ccnp co cfv wcel wa wi wi cF cP cJ cK ccnp co cfv wcel cK ctop wcel cP
      cX wcel cJ ctop wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK
      ccnp co cfv wcel wa wi wi wi wi cG cP cF cfv cK cL ccnp co cfv wcel cJ
      ctop wcel cK ctop wcel cP cX wcel cF cP cJ cK ccnp co cfv wcel cJ ctop
      wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop
      wcel cK ctop wcel cP cX wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK
      ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel
      cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel pm3.2 3exp com14
      a1i com13 3imp com13 a1d 3imp1 cP cF cJ cK cX cK cuni cnpco.1 cK cuni
      eqid cnpf cX cK cuni cF ffun 3syl cJ ctop wcel cL ctop wcel cP cX wcel
      w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co
      cfv wcel w3a wa cP cX cF cdm cJ ctop wcel cL ctop wcel cP cX wcel cK ctop
      wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a
      3simpl3 cJ ctop wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK
      ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cJ ctop wcel
      cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa cX cK cuni cF
      wf cX cF cdm wceq cJ ctop wcel cL ctop wcel cP cX wcel cK ctop wcel cF cP
      cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cJ ctop
      wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop
      wcel cP cX wcel cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK
      cL ccnp co cfv wcel w3a cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ
      cK ccnp co cfv wcel wa wi wi cL ctop wcel cK ctop wcel cF cP cJ cK ccnp
      co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a cP cX wcel cJ ctop
      wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv
      wcel wa cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp
      co cfv wcel cP cX wcel cJ ctop wcel cJ ctop wcel cK ctop wcel cP cX wcel
      w3a cF cP cJ cK ccnp co cfv wcel wa wi wi cG cP cF cfv cK cL ccnp co cfv
      wcel cF cP cJ cK ccnp co cfv wcel cK ctop wcel cP cX wcel cJ ctop wcel cJ
      ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi
      wi cF cP cJ cK ccnp co cfv wcel cK ctop wcel cP cX wcel cJ ctop wcel cJ
      ctop wcel cK ctop wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa wi
      wi wi wi cG cP cF cfv cK cL ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP
      cX wcel cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP cX wcel
      w3a cF cP cJ cK ccnp co cfv wcel wa cJ ctop wcel cK ctop wcel cP cX wcel
      cF cP cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cP cX wcel w3a cF
      cP cJ cK ccnp co cfv wcel wa wi cJ ctop wcel cK ctop wcel cP cX wcel w3a
      cF cP cJ cK ccnp co cfv wcel pm3.2 3exp com14 a1i com13 3imp com13 a1d
      3imp1 cP cF cJ cK cX cK cuni cnpco.1 cK cuni eqid cnpf cX cK cuni cF wf
      cF cdm cX cX cK cuni cF fdm eqcomd 3syl eleqtrd 3jca cP cG cF fvco cP cG
      cF ccom cfv cP cF cfv cG cfv vz cv eleq1 3syl biimpd cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa cP vx cv wcel cG cF vx cv cima cima vz
      cv wss wa cP vx cv wcel cG cF ccom vx cv cima vz cv wss wa vx cJ cJ ctop
      wcel cL ctop wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv
      wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a wa cG cF vx cv cima cima vz
      cv wss cG cF ccom vx cv cima vz cv wss cP vx cv wcel cG cF vx cv cima
      cima vz cv wss cG cF ccom vx cv cima vz cv wss wi cJ ctop wcel cL ctop
      wcel cP cX wcel w3a cK ctop wcel cF cP cJ cK ccnp co cfv wcel cG cP cF
      cfv cK cL ccnp co cfv wcel w3a wa cG cF vx cv cima cima vz cv wss cG cF
      ccom vx cv cima vz cv wss cG cF vx cv cima cima cG cF ccom vx cv cima vz
      cv cG cF ccom vx cv cima cG cF vx cv cima cima cG cF vx cv imaco eqcomi
      sseq1i biimpi a1i anim2d r19.22sdv imim12d r19.20sdv mpd jca cJ ctop wcel
      cL ctop wcel cP cX wcel w3a cG cF ccom cP cJ cL ccnp co cfv wcel cX cL
      cuni cG cF ccom wf cP cG cF ccom cfv vz cv wcel cP vx cv wcel cG cF ccom
      vx cv cima vz cv wss wa vx cJ wrex wi vz cL wral wa wb cK ctop wcel cF cP
      cJ cK ccnp co cfv wcel cG cP cF cfv cK cL ccnp co cfv wcel w3a vx vz cP
      cG cF ccom cJ cL cX cL cuni cnpco.1 cL cuni eqid iscnp adantr mpbird $.
      $( [1-Jan-2007] $) $( [16-Nov-2006] $)
  $}

  ${
    $d F x y $.  $d J x y $.  $d K x y $.  $d X x y $.  $d Y x y $.
    iscncl.1 $e |- X = U. J $.
    iscncl.2 $e |- Y = U. K $.
    $( A definition of a continuous function using closed sets.  Bourbaki
       TG I.9 Th. 1 (d).  (Contributed by FL, 30-Jan-2007.) $)
    iscncl $p |- ( ( J e. Top /\ K e. Top ) -> ( F e. ( J Cn K ) <->
    ( F : X --> Y /\ A. y e. ( Clsd ` K ) ( `' F " y ) e. ( Clsd ` J ) ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cX cY cF wf cF ccnv vx
      cv cima cJ wcel vx cK wral wa cX cY cF wf cF ccnv vy cv cima cJ ccld cfv
      wcel vy cK ccld cfv wral wa vx cF cJ cK cX cY iscncl.1 iscncl.2 iscn cJ
      ctop wcel cK ctop wcel wa cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK
      wral cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral cJ ctop wcel
      cK ctop wcel wa cX cY cF wf wa cF ccnv vx cv cima cJ wcel vx cK wral cF
      ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral cJ ctop wcel cK ctop
      wcel wa cX cY cF wf wa cF ccnv vx cv cima cJ wcel vx cK wral wa cF ccnv
      vy cv cima cJ ccld cfv wcel vy cK ccld cfv cJ ctop wcel cK ctop wcel wa
      cX cY cF wf wa cF ccnv vx cv cima cJ wcel vx cK wral wa vy cv cK ccld cfv
      wcel wa cF ccnv vy cv cima cJ ccld cfv wcel cX cF ccnv vy cv cima cdif cJ
      wcel cJ ctop wcel cK ctop wcel wa cX cY cF wf cF ccnv vx cv cima cJ wcel
      vx cK wral vy cv cK ccld cfv wcel cX cF ccnv vy cv cima cdif cJ wcel cK
      ctop wcel cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral vy cv cK ccld
      cfv wcel cX cF ccnv vy cv cima cdif cJ wcel wi wi wi cJ ctop wcel cK ctop
      wcel cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral vy cv cK ccld cfv
      wcel cX cF ccnv vy cv cima cdif cJ wcel cK ctop wcel cX cY cF wf wa cF
      ccnv vx cv cima cJ wcel vx cK wral wa vy cv cK ccld cfv wcel wa cX cF
      ccnv vy cv cima cdif cF ccnv cY vy cv cdif cima cJ cK ctop wcel cX cY cF
      wf cF ccnv vx cv cima cJ wcel vx cK wral vy cv cK ccld cfv wcel cX cF
      ccnv vy cv cima cdif cF ccnv cY vy cv cdif cima wceq cX cY cF wf cF ccnv
      vx cv cima cJ wcel vx cK wral vy cv cK ccld cfv wcel cX cF ccnv vy cv
      cima cdif cF ccnv cY vy cv cdif cima wceq wi wi wi cK ctop wcel vy cv cK
      ccld cfv wcel cF ccnv vx cv cima cJ wcel vx cK wral cX cY cF wf cX cF
      ccnv vy cv cima cdif cF ccnv cY vy cv cdif cima wceq vy cv cK ccld cfv
      wcel cF ccnv vx cv cima cJ wcel vx cK wral cX cY cF wf cX cF ccnv vy cv
      cima cdif cF ccnv cY vy cv cdif cima wceq wi cX cY cF wf cX cF ccnv vy cv
      cima cdif cF ccnv cY cima cF ccnv vy cv cima cdif cF ccnv cY vy cv cdif
      cima cX cY cF wf cX cF ccnv cY cima cF ccnv vy cv cima cX cY cF wf cF
      ccnv cY cima cX cX cY cF fimacnv eqcomd difeq1d cX cY cF wf cF wfun cF
      ccnv ccnv wfun cF ccnv cY vy cv cdif cima cF ccnv cY cima cF ccnv vy cv
      cima cdif wceq cX cY cF ffun cF funcnvcnv cY vy cv cF ccnv imadif 3syl
      eqtr4d a1i12 com13 a1i imp41 cK ctop wcel cF ccnv vx cv cima cJ wcel vx
      cK wral vy cv cK ccld cfv wcel cF ccnv cY vy cv cdif cima cJ wcel cX cY
      cF wf cF ccnv vx cv cima cJ wcel vx cK wral cY vy cv cdif cK wcel cF ccnv
      cY vy cv cdif cima cJ wcel cK ctop wcel cF ccnv vx cv cima cJ wcel vx cK
      wral wa vy cv cK ccld cfv wcel wa cF ccnv vx cv cima cJ wcel cF ccnv cY
      vy cv cdif cima cJ wcel vx cY vy cv cdif cK vx cv cY vy cv cdif wceq cF
      ccnv vx cv cima cF ccnv cY vy cv cdif cima cJ vx cv cY vy cv cdif cF ccnv
      imaeq2 eleq1d rcla4cva cK ctop wcel cF ccnv vx cv cima cJ wcel vx cK wral
      vy cv cK ccld cfv wcel simplr cK ctop wcel vy cv cK ccld cfv wcel cY vy
      cv cdif cK wcel cF ccnv vx cv cima cJ wcel vx cK wral vy cv cK cY
      iscncl.2 cldopn adantlr sylanc adantllr eqeltrd exp41 adantl imp41 cJ
      ctop wcel cK ctop wcel wa cX cY cF wf wa cF ccnv vy cv cima cJ ccld cfv
      wcel cX cF ccnv vy cv cima cdif cJ wcel wb cF ccnv vx cv cima cJ wcel vx
      cK wral vy cv cK ccld cfv wcel cJ ctop wcel cX cY cF wf cF ccnv vy cv
      cima cJ ccld cfv wcel cX cF ccnv vy cv cima cdif cJ wcel wb cK ctop wcel
      cJ ctop wcel cF ccnv vy cv cima cX wss cF ccnv vy cv cima cJ ccld cfv
      wcel cX cF ccnv vy cv cima cdif cJ wcel wb cX cY cF wf cF ccnv vy cv cima
      cJ cX iscncl.1 iscld2 cX cY cF wf cF ccnv vy cv cima cF cdm cX cF ccnv vy
      cv cima cF cdm wss cX cY cF wf cF vy cv cnvimass a1i cX cY cF fdm sseqtrd
      sylan2 adantlr ad2antrr mpbird r19.21aiva cJ ctop wcel cK ctop wcel wa cX
      cY cF wf wa cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral wa cF
      ccnv vx cv cima cJ wcel vx cK cJ ctop wcel cK ctop wcel wa cX cY cF wf wa
      cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral wa vx cv cK wcel
      wa cF ccnv vx cv cima cJ wcel cX cF ccnv vx cv cima cdif cJ ccld cfv wcel
      cJ ctop wcel cK ctop wcel wa cX cY cF wf cF ccnv vy cv cima cJ ccld cfv
      wcel vy cK ccld cfv wral vx cv cK wcel cX cF ccnv vx cv cima cdif cJ ccld
      cfv wcel cK ctop wcel cX cY cF wf cF ccnv vy cv cima cJ ccld cfv wcel vy
      cK ccld cfv wral vx cv cK wcel cX cF ccnv vx cv cima cdif cJ ccld cfv
      wcel wi wi wi cJ ctop wcel cK ctop wcel cX cY cF wf cF ccnv vy cv cima cJ
      ccld cfv wcel vy cK ccld cfv wral vx cv cK wcel cX cF ccnv vx cv cima
      cdif cJ ccld cfv wcel cK ctop wcel cX cY cF wf wa cF ccnv vy cv cima cJ
      ccld cfv wcel vy cK ccld cfv wral wa vx cv cK wcel wa cX cF ccnv vx cv
      cima cdif cF ccnv cY vx cv cdif cima cJ ccld cfv cK ctop wcel cX cY cF wf
      cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral vx cv cK wcel cX
      cF ccnv vx cv cima cdif cF ccnv cY vx cv cdif cima wceq cX cY cF wf cF
      ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral vx cv cK wcel cX cF
      ccnv vx cv cima cdif cF ccnv cY vx cv cdif cima wceq wi wi wi cK ctop
      wcel vx cv cK wcel cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv
      wral cX cY cF wf cX cF ccnv vx cv cima cdif cF ccnv cY vx cv cdif cima
      wceq vx cv cK wcel cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv
      wral cX cY cF wf cX cF ccnv vx cv cima cdif cF ccnv cY vx cv cdif cima
      wceq wi cX cY cF wf cX cF ccnv vx cv cima cdif cF ccnv cY cima cF ccnv vx
      cv cima cdif cF ccnv cY vx cv cdif cima cX cY cF wf cX cF ccnv cY cima cF
      ccnv vx cv cima cX cY cF wf cF ccnv cY cima cX cX cY cF fimacnv eqcomd
      difeq1d cX cY cF wf cF wfun cF ccnv ccnv wfun cF ccnv cY vx cv cdif cima
      cF ccnv cY cima cF ccnv vx cv cima cdif wceq cX cY cF ffun cF funcnvcnv
      cY vx cv cF ccnv imadif 3syl eqtr4d a1i12 com13 a1i imp41 cK ctop wcel cF
      ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral vx cv cK wcel cF
      ccnv cY vx cv cdif cima cJ ccld cfv wcel cX cY cF wf cF ccnv vy cv cima
      cJ ccld cfv wcel vy cK ccld cfv wral cY vx cv cdif cK ccld cfv wcel cF
      ccnv cY vx cv cdif cima cJ ccld cfv wcel cK ctop wcel cF ccnv vy cv cima
      cJ ccld cfv wcel vy cK ccld cfv wral wa vx cv cK wcel wa cF ccnv vy cv
      cima cJ ccld cfv wcel cF ccnv cY vx cv cdif cima cJ ccld cfv wcel vy cY
      vx cv cdif cK ccld cfv vy cv cY vx cv cdif wceq cF ccnv vy cv cima cF
      ccnv cY vx cv cdif cima cJ ccld cfv vy cv cY vx cv cdif cF ccnv imaeq2
      eleq1d rcla4cva cK ctop wcel cF ccnv vy cv cima cJ ccld cfv wcel vy cK
      ccld cfv wral vx cv cK wcel simplr cK ctop wcel vx cv cK wcel cY vx cv
      cdif cK ccld cfv wcel cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv
      wral vx cv cK cY iscncl.2 opncld adantlr sylanc adantllr eqeltrd exp41
      adantl imp41 cJ ctop wcel cK ctop wcel wa cX cY cF wf wa cF ccnv vx cv
      cima cJ wcel cX cF ccnv vx cv cima cdif cJ ccld cfv wcel wb cF ccnv vy cv
      cima cJ ccld cfv wcel vy cK ccld cfv wral vx cv cK wcel cJ ctop wcel cX
      cY cF wf cF ccnv vx cv cima cJ wcel cX cF ccnv vx cv cima cdif cJ ccld
      cfv wcel wb cK ctop wcel cJ ctop wcel cF ccnv vx cv cima cX wss cF ccnv
      vx cv cima cJ wcel cX cF ccnv vx cv cima cdif cJ ccld cfv wcel wb cX cY
      cF wf cF ccnv vx cv cima cJ cX iscncl.1 isopn2 cX cY cF wf cF ccnv vx cv
      cima cF cdm cX cF ccnv vx cv cima cF cdm wss cX cY cF wf cF vx cv
      cnvimass a1i cX cY cF fdm sseqtrd sylan2 adantlr ad2antrr mpbird
      r19.21aiva impbida pm5.32da bitrd $.
      $( [30-Jan-2007] $) $( [19-Nov-2006] $)
  $}

  ${
    $d x A $.  $d x F $.  $d x J $.  $d x K $.
    $( A closed subset of the codomain of a continuous function has a closed
       pre-image. $)
    cnclima $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Cn K ) ) /\
                A e. ( Clsd ` K ) ) -> ( `' F " A ) e. ( Clsd ` J ) ) $=
      cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cK ccld cfv wcel cF
      ccnv cA cima cJ ccld cfv wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co
      wcel w3a cF ccnv vx cv cima cJ ccld cfv wcel vx cK ccld cfv wral cA cK
      ccld cfv wcel cF ccnv cA cima cJ ccld cfv wcel wi cJ ctop wcel cK ctop
      wcel cF cJ cK ccn co wcel cF ccnv vx cv cima cJ ccld cfv wcel vx cK ccld
      cfv wral cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cJ cuni cK
      cuni cF wf cF ccnv vx cv cima cJ ccld cfv wcel vx cK ccld cfv wral vx cF
      cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid iscncl pm3.27bda 3impa cF
      ccnv vx cv cima cJ ccld cfv wcel cF ccnv cA cima cJ ccld cfv wcel vx cA
      cK ccld cfv vx cv cA wceq cF ccnv vx cv cima cF ccnv cA cima cJ ccld cfv
      vx cv cA cF ccnv imaeq2 eleq1d rcla4cv syl imp $.
      $( [14-Apr-2007] $) $( [15-Mar-2007] $)
  $}

  ${
    $d J f x y $.  $d K f y $.  $d X f y $.  $d Y y $.  $d P f x y $.
    cnsscnp.1 $e |- X = U. J $.
    cnsscnp.2 $e |- Y = U. K $.
    $( The set of continuous functions is a subset of the set of continuous
       functions at a point.  (Contributed by Raph Levien, 21-Oct-2006.) $)
    cnsscnp $p |- ( ( J e. Top /\ K e. Top /\ P e. X ) ->
                  ( J Cn K ) C_ ( ( J CnP K ) ` P ) ) $=
      cJ ctop wcel cK ctop wcel cP cX wcel w3a vf cJ cK ccn co cP cJ cK ccnp co
      cfv cJ ctop wcel cK ctop wcel cP cX wcel vf cv cJ cK ccn co wcel vf cv cP
      cJ cK ccnp co cfv wcel wi cJ ctop wcel cK ctop wcel wa cP cX wcel wa cX
      cY vf cv wf vf cv ccnv vy cv cima cJ wcel vy cK wral wa cX cY vf cv wf cP
      vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ
      wrex wi vy cK wral wa vf cv cJ cK ccn co wcel vf cv cP cJ cK ccnp co cfv
      wcel cP cX wcel cX cY vf cv wf vf cv ccnv vy cv cima cJ wcel vy cK wral
      wa cX cY vf cv wf cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima
      vy cv wss wa vx cJ wrex wi vy cK wral wa wi cJ ctop wcel cK ctop wcel wa
      cP cX wcel cX cY vf cv wf vf cv ccnv vy cv cima cJ wcel vy cK wral cP vf
      cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex
      wi vy cK wral cX cY vf cv wf cP cX wcel vf cv ccnv vy cv cima cJ wcel vy
      cK wral cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss
      wa vx cJ wrex wi vy cK wral wi cP vf cv cdm wcel vf cv wfun vf cv ccnv vy
      cv cima cJ wcel vy cK wral cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx
      cv cima vy cv wss wa vx cJ wrex wi vy cK wral wi cX cY vf cv wf cP cX
      wcel wa cP vf cv cdm wcel vf cv wfun wa vf cv ccnv vy cv cima cJ wcel cP
      vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ
      wrex wi vy cK cP vf cv cdm wcel vf cv wfun vf cv ccnv vy cv cima cJ wcel
      cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ
      wrex wi wi vf cv wfun vf cv ccnv vy cv cima cJ wcel cP vf cv cdm wcel cP
      vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ
      wrex wi cP vf cv cdm wcel cP vf cv cfv vy cv wcel vf cv wfun vf cv ccnv
      vy cv cima cJ wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex
      cP vf cv cdm wcel cP vf cv cfv vy cv wcel vf cv wfun vf cv ccnv vy cv
      cima cJ wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi cP
      vf cv cdm wcel cP vf cv cfv vy cv wcel wa vf cv wfun wa vx cv vf cv ccnv
      vy cv cima wceq vx cJ wrex cP vx cv wcel vf cv vx cv cima vy cv wss wa vx
      cJ wrex vf cv ccnv vy cv cima cJ wcel cP vf cv cdm wcel cP vf cv cfv vy
      cv wcel wa vf cv wfun wa vx cv vf cv ccnv vy cv cima wceq cP vx cv wcel
      vf cv vx cv cima vy cv wss wa vx cJ cP vf cv cdm wcel cP vf cv cfv vy cv
      wcel vf cv wfun vx cv vf cv ccnv vy cv cima wceq cP vx cv wcel vf cv vx
      cv cima vy cv wss wa wi cP vf cv cdm wcel vx cv vf cv ccnv vy cv cima
      wceq vf cv wfun cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy
      cv wss wa cP vf cv cdm wcel vx cv vf cv ccnv vy cv cima wceq vf cv wfun
      cP vf cv cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa wi cP
      vf cv cdm wcel vx cv vf cv ccnv vy cv cima wceq vf cv wfun wa wa cP vf cv
      cfv vy cv wcel cP vx cv wcel vf cv vx cv cima vy cv wss cP vf cv cdm wcel
      vx cv vf cv ccnv vy cv cima wceq vf cv wfun cP vf cv cfv vy cv wcel cP vx
      cv wcel wi vx cv vf cv ccnv vy cv cima wceq vf cv wfun cP vf cv cdm wcel
      cP vf cv cfv vy cv wcel cP vx cv wcel wi vf cv wfun cP vf cv cdm wcel cP
      vf cv cfv vy cv wcel vx cv vf cv ccnv vy cv cima wceq cP vx cv wcel vf cv
      wfun cP vf cv cdm wcel cP vf cv cfv vy cv wcel vx cv vf cv ccnv vy cv
      cima wceq cP vx cv wcel wi wi vf cv wfun cP vf cv cdm wcel wa cP vf cv
      cfv vy cv wcel cP vf cv ccnv vy cv cima wcel vx cv vf cv ccnv vy cv cima
      wceq cP vx cv wcel wi cP vy cv vf cv fvimacnv vx cv vf cv ccnv vy cv cima
      wceq cP vx cv wcel cP vf cv ccnv vy cv cima wcel vx cv vf cv ccnv vy cv
      cima cP eleq2 biimprcd syl6bi ex com4r com3r imp32 vx cv vf cv ccnv vy cv
      cima wceq vf cv wfun wa vf cv vx cv cima vy cv wss cP vf cv cdm wcel vx
      cv vf cv ccnv vy cv cima wceq vf cv wfun wa vf cv vx cv cima vy cv wss vy
      cv vf cv crn cin vy cv wss vy cv vf cv crn inss1 vx cv vf cv ccnv vy cv
      cima wceq vf cv wfun wa vf cv vx cv cima vy cv vf cv crn cin vy cv vx cv
      vf cv ccnv vy cv cima wceq vf cv wfun vf cv vx cv cima vf cv vf cv ccnv
      vy cv cima cima vy cv vf cv crn cin vx cv vf cv ccnv vy cv cima vf cv
      imaeq2 vy cv vf cv funimacnv sylan9eq sseq1d mpbiri adantl jctird exp32
      com24 imp31 r19.22sdv vx vf cv ccnv vy cv cima cJ risset syl5ib exp31
      com4t com3r imp r19.20sdv cX cY vf cv wf cP vf cv cdm wcel cP cX wcel cX
      cY vf cv wf vf cv cdm cX cP cX cY vf cv fdm eleq2d biimpar cX cY vf cv wf
      vf cv wfun cP cX wcel cX cY vf cv ffun adantr sylanc expcom imdistand
      adantl cJ ctop wcel cK ctop wcel wa vf cv cJ cK ccn co wcel cX cY vf cv
      wf vf cv ccnv vy cv cima cJ wcel vy cK wral wa wb cP cX wcel vy vf cv cJ
      cK cX cY cnsscnp.1 cnsscnp.2 iscn adantr cJ ctop wcel cK ctop wcel cP cX
      wcel vf cv cP cJ cK ccnp co cfv wcel cX cY vf cv wf cP vf cv cfv vy cv
      wcel cP vx cv wcel vf cv vx cv cima vy cv wss wa vx cJ wrex wi vy cK wral
      wa wb vx vy cP vf cv cJ cK cX cY cnsscnp.1 cnsscnp.2 iscnp 3expa 3imtr4d
      3impa ssrdv $.
      $( [21-Oct-2006] $) $( [18-Oct-2006] $)

    $( A continuous function is continuous at all points.  One direction of
       Theorem 7.2(g) of [Munkres] p. 107.  (Contributed by Raph Levien,
       20-Nov-2006.) $)
    cncnpi $p |- ( ( ( J e. Top /\ K e. Top ) /\
             ( F e. ( J Cn K ) /\ A e. X ) ) -> F e. ( ( J CnP K ) ` A ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cA cX wcel cF cA cJ cK
      ccnp co cfv wcel cJ ctop wcel cK ctop wcel wa cA cX wcel cF cJ cK ccn co
      wcel cF cA cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel cA cX wcel cF
      cJ cK ccn co wcel cF cA cJ cK ccnp co cfv wcel wi cJ ctop wcel cK ctop
      wcel cA cX wcel w3a cJ cK ccn co cA cJ cK ccnp co cfv cF cA cJ cK cX cY
      cnsscnp.1 cnsscnp.2 cnsscnp sseld 3expia com23 imp32 $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)
  $}

  ${
    $d x B $.
    $( MAY BE REVISED - use iscnp2 instead of iscnp to shorten cncnplem1 thru
       cncnplem4 ?  Or prove cncnp directly? $)
    $( Lemma for ~ cncnp2 . $)
    cncnplem1 $p |- U. { x e. A | ( ph /\ x C_ B ) } C_ B $=
      wph vx cv cB wss wa vx cA crab cuni cB cpw cuni cB wph vx cv cB wss wa vx
      cA crab cB cpw wss wph vx cv cB wss wa vx cA crab cuni cB cpw cuni wss vx
      cv cA wcel wph vx cv cB wss wa wa vx cab vx cv cB wss vx cab wph vx cv cB
      wss wa vx cA crab cB cpw vx cv cA wcel wph vx cv cB wss wa wa vx cv cB
      wss vx vx cv cA wcel wph vx cv cB wss simprr ss2abi wph vx cv cB wss wa
      vx cA df-rab vx cB df-pw 3sstr4i wph vx cv cB wss wa vx cA crab cB cpw
      uniss ax-mp cB unipw sseqtri $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)
  $}

  ${
    $d A x y $.  $d B y $.  $d X x $.
    $( Lemma for ~ cncnp2 . $)
    cncnplem2 $p |- ( A. x ( x e. A -> x e. B ) -> A C_ U_ x e. A B ) $=
      vx cv cA wcel vx cv cB wcel wi vx wal vy cA vx cA cB ciun vy cv cA wcel
      vx cv cA wcel vx cv cB wcel wi vx wal vy cv vx cA cB ciun wcel vy cv cA
      wcel vx cv cA wcel vx cv cB wcel wi vx wal vy cv cB wcel vx cA wrex vy cv
      vx cA cB ciun wcel vy cv cA wcel vx cv cA wcel vx cv cB wcel wi vx wal vy
      cv cB wcel vx cA wrex wi wi vx vy cv vy cv cA wcel vx cv cA wcel vx cv cB
      wcel wi vx wal vy cv cB wcel vx cA wrex wi vx vy cv cA wcel vx ax-17 vx
      cv cA wcel vx cv cB wcel wi vx wal vy cv cB wcel vx cA wrex vx vx cv cA
      wcel vx cv cB wcel wi vx hba1 vy cv cB wcel vx cA hbre1 hbim hbim vy
      visset vx cv vy cv wceq vy cv cA wcel vx cv cA wcel vx cv cB wcel wi vx
      wal vy cv cB wcel vx cA wrex vx cv cA wcel vy cv cB wcel vy cv cB wcel vx
      cA wrex vx cv vy cv wceq vy cv cA wcel wa vx cv cA wcel vx cv cB wcel wi
      vx wal wa vy cv cB wcel vx cA ra4e vx cv vy cv wceq vy cv cA wcel wa vx
      cv cA wcel vx cv cA wcel vx cv cB wcel wi vx wal vx cv vy cv wceq vx cv
      cA wcel vy cv cA wcel vx cv vy cv cA eleq1 biimpar adantr vx cv vy cv
      wceq vy cv cA wcel vx cv cA wcel vx cv cB wcel wi vx wal vy cv cB wcel vx
      cv vy cv wceq vy cv cA wcel vx cv cA wcel vx cv cB wcel wi vx wal vx cv
      cB wcel vy cv cB wcel vx cv vy cv wceq vy cv cA wcel vx cv cA wcel vx cv
      cA wcel vx cv cB wcel wi vx wal vx cv cB wcel wi vx cv vy cv cA eleq1 vx
      cv cA wcel vx cv cB wcel wi vx wal vx cv cA wcel vx cv cB wcel vx cv cA
      wcel vx cv cB wcel wi vx ax-4 com12 syl6bir vx cv vy cv wceq vx cv cB
      wcel vy cv cB wcel vx cv vy cv cB eleq1 biimpd syl6d imp31 sylanc exp31
      vtoclef vx vy cv cA cB eliun syl6ibr com12 ssrdv $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)

    $( Lemma for ~ cncnp2 . $)
    cncnplem3 $p |- ( A C_ X -> ( A. x e. X ( x e. A -> x e. B ) ->
                    A C_ U_ x e. A B ) ) $=
      cA cX wss vx cv cA wcel vx cv cB wcel wi vx cX wral vx cv cA wcel vx cv
      cB wcel wi vx wal cA vx cA cB ciun wss cA cX wss vx cv cA wcel vx cv cB
      wcel wi vx wal vx cv cX wcel vx cv cA wcel vx cv cB wcel wi wi vx wal vx
      cv cA wcel vx cv cB wcel wi vx cX wral cA cX wss vx cv cA wcel vx cv cB
      wcel wi vx cv cX wcel vx cv cA wcel vx cv cB wcel wi wi vx cA cX wss vx
      cv cA wcel vx cv cB wcel wi vx cv cX wcel vx cv cA wcel wa vx cv cB wcel
      wi vx cv cX wcel vx cv cA wcel vx cv cB wcel wi wi cA cX wss vx cv cA
      wcel vx cv cX wcel vx cv cA wcel wa vx cv cB wcel cA cX wss vx cv cA wcel
      vx cv cX wcel cA cX vx cv ssel pm4.71rd imbi1d vx cv cX wcel vx cv cA
      wcel vx cv cB wcel impexp syl6bb albidv vx cv cA wcel vx cv cB wcel wi vx
      cX df-ral syl6bbr vx cA cB cncnplem2 syl6bir $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)
  $}

  ${
    $d J x z $.  $d F x z $.  $d X x z $.  $d Y x z $.  $d x y z $.
    cncnplem4.1 $e |- X = U. J $.
    $( Lemma for ~ cncnp2 . $)
    cncnplem4 $p |- ( J e. Top -> ( ( F : X --> Y /\ A. x e. X ( ( F ` x ) e. y
      -> E. z e. J ( x e. z /\ ( F " z ) C_ y ) ) ) -> ( `' F " y ) e. J ) ) $=
      cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv
      wss wa vz cJ wrex wi vx cX wral wa vx cF ccnv vy cv cima vx cv vz cv wcel
      cF vz cv cima vy cv wss wa vz cJ crab cuni ciun cJ wcel cF ccnv vy cv
      cima cJ wcel cJ ctop wcel cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv
      wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX wral wa vx cF ccnv vy
      cv cima vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab cuni ciun
      cF ccnv vy cv cima cJ cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv
      wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX wral wa vx cF ccnv vy
      cv cima vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab cuni ciun
      vx cF ccnv vy cv cima vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz
      cJ crab cuni ciun cF ccnv vy cv cima cX cY cF wf vx cF ccnv vy cv cima vx
      cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab cuni ciun vx cF ccnv
      vy cv cima vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab
      cuni ciun wceq vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy
      cv wss wa vz cJ wrex wi vx cX wral cX cY cF wf vx cF ccnv vy cv cima vx
      cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab cuni vx cv vz cv wcel
      vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni cX cY cF wf vx cv vz cv
      wcel cF vz cv cima vy cv wss wa vz cJ crab cuni vx cv vz cv wcel vz cv cF
      ccnv vy cv cima wss wa vz cJ crab cuni wceq vx cv cF ccnv vy cv cima wcel
      cX cY cF wf vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab vx cv
      vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cX cY cF wf vx cv
      vz cv wcel cF vz cv cima vy cv wss wa vx cv vz cv wcel vz cv cF ccnv vy
      cv cima wss wa vz cJ cX cY cF wf vz cv cJ wcel wa cF vz cv cima vy cv wss
      vz cv cF ccnv vy cv cima wss vx cv vz cv wcel cX cY cF wf vz cv cJ wcel
      cF vz cv cima vy cv wss vz cv cF ccnv vy cv cima wss wb cX cY cF wf vz cv
      cJ wcel vz cv cF cdm wss cF vz cv cima vy cv wss vz cv cF ccnv vy cv cima
      wss wb cX cY cF wf vz cv cF cdm wss vz cv cJ cuni wss vz cv cJ wcel cX cY
      cF wf cF cdm cJ cuni vz cv cX cY cF wf cF cdm cX cJ cuni cX cY cF fdm
      cncnplem4.1 syl6eq sseq2d vz cv cJ elssuni syl5bir cX cY cF wf vz cv cF
      cdm wss cF vz cv cima vy cv wss vz cv cF ccnv vy cv cima wss wb cF wfun
      vz cv cF cdm wss cF vz cv cima vy cv wss vz cv cF ccnv vy cv cima wss wb
      cX cY cF wf vz cv vy cv cF funimass3 cX cY cF ffun sylan ex syld imp
      anbi2d rabbidv unieqd adantr iuneq2dv adantr cX cY cF wf vx cv cF cfv vy
      cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX
      wral wa vx cF ccnv vy cv cima vx cv vz cv wcel vz cv cF ccnv vy cv cima
      wss wa vz cJ crab cuni ciun cF ccnv vy cv cima vx cF ccnv vy cv cima vx
      cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni ciun cF
      ccnv vy cv cima wss cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel
      cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX wral wa vx cF ccnv vy cv
      cima vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni
      ciun cF ccnv vy cv cima wss vx cv vz cv wcel vz cv cF ccnv vy cv cima wss
      wa vz cJ crab cuni cF ccnv vy cv cima wss vx cF ccnv vy cv cima vx cF
      ccnv vy cv cima vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ
      crab cuni cF ccnv vy cv cima iunss vx cv vz cv wcel vz cv cF ccnv vy cv
      cima wss wa vz cJ crab cuni cF ccnv vy cv cima wss vx cv cF ccnv vy cv
      cima wcel vx cv vz cv wcel vz cJ cF ccnv vy cv cima cncnplem1 a1i mprgbir
      a1i cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy
      cv wss wa vz cJ wrex wi vx cX wral cF ccnv vy cv cima vx cF ccnv vy cv
      cima vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni
      ciun wss cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex wi vx cX wral vx cv cF ccnv vy cv cima wcel
      vx cv vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni
      wcel wi vx cX wral cF ccnv vy cv cima vx cF ccnv vy cv cima vx cv vz cv
      wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni ciun wss cX cY cF wf
      vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ
      wrex wi vx cv cF ccnv vy cv cima wcel vx cv vx cv vz cv wcel vz cv cF
      ccnv vy cv cima wss wa vz cJ crab cuni wcel wi vx cX vx cv cF ccnv vy cv
      cima wcel vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv
      wss wa vz cJ wrex wi cX cY cF wf vx cv vx cv vz cv wcel vz cv cF ccnv vy
      cv cima wss wa vz cJ crab cuni wcel vx cv cF ccnv vy cv cima wcel vx cv
      cF cdm wcel vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv
      wss wa vz cJ wrex wi cX cY cF wf vx cv vx cv vz cv wcel vz cv cF ccnv vy
      cv cima wss wa vz cJ crab cuni wcel wi wi cF ccnv vy cv cima cF cdm vx cv
      cF vy cv cnvimass sseli cX cY cF wf vx cv cF cdm wcel vx cv cF cfv vy cv
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cv cF
      ccnv vy cv cima wcel vx cv vx cv vz cv wcel vz cv cF ccnv vy cv cima wss
      wa vz cJ crab cuni wcel cX cY cF wf vx cv cF cdm wcel vx cv cF cfv vy cv
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cv cF
      ccnv vy cv cima wcel vx cv vx cv vz cv wcel vz cv cF ccnv vy cv cima wss
      wa vz cJ crab cuni wcel wi wi cX cY cF wf vx cv cF cdm wcel wa vx cv cF
      ccnv vy cv cima wcel vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex vx cv vx cv vz cv wcel vz cv cF ccnv vy cv
      cima wss wa vz cJ crab cuni wcel cX cY cF wf vx cv cF cdm wcel wa vx cv
      cF cfv vy cv wcel vx cv cF ccnv vy cv cima wcel cF wfun vx cv cF cdm wcel
      vx cv cF cfv vy cv wcel vx cv cF ccnv vy cv cima wcel wb cX cY cF wf vx
      cv vy cv cF fvimacnv cX cY cF ffun sylan biimprd cX cY cF wf vx cv vz cv
      wcel cF vz cv cima vy cv wss wa vz cJ wrex vx cv vx cv vz cv wcel vz cv
      cF ccnv vy cv cima wss wa vz cJ crab cuni wcel wi vx cv cF cdm wcel cX cY
      cF wf vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex vx cv vx cv
      vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni wcel cX cY cF
      wf vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex vx cv vz cv
      wcel vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa wa vz cJ wrex vx cv
      vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni wcel cX
      cY cF wf vx cv vz cv wcel cF vz cv cima vy cv wss wa vx cv vz cv wcel vx
      cv vz cv wcel vz cv cF ccnv vy cv cima wss wa wa vz cJ cX cY cF wf vz cv
      cJ wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vx cv vz cv wcel vx
      cv vz cv wcel vz cv cF ccnv vy cv cima wss wa wa wb cX cY cF wf vz cv cJ
      wcel vz cv cF cdm wss vx cv vz cv wcel cF vz cv cima vy cv wss wa vx cv
      vz cv wcel vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa wa wb cX cY
      cF wf vz cv cF cdm wss vz cv cJ cuni wss vz cv cJ wcel cX cY cF wf cF cdm
      cJ cuni vz cv cX cY cF wf cF cdm cX cJ cuni cX cY cF fdm cncnplem4.1
      syl6eq sseq2d vz cv cJ elssuni syl5bir cX cY cF wf vz cv cF cdm wss vx cv
      vz cv wcel cF vz cv cima vy cv wss wa vx cv vz cv wcel vx cv vz cv wcel
      vz cv cF ccnv vy cv cima wss wa wa wb cX cY cF wf vz cv cF cdm wss wa vx
      cv vz cv wcel cF vz cv cima vy cv wss wa vx cv vz cv wcel vz cv cF ccnv
      vy cv cima wss wa vx cv vz cv wcel vx cv vz cv wcel vz cv cF ccnv vy cv
      cima wss wa wa cX cY cF wf vz cv cF cdm wss wa cF vz cv cima vy cv wss vz
      cv cF ccnv vy cv cima wss vx cv vz cv wcel cF wfun vz cv cF cdm wss cF vz
      cv cima vy cv wss vz cv cF ccnv vy cv cima wss wb cX cY cF wf vz cv vy cv
      cF funimass3 cX cY cF ffun sylan anbi2d vx cv vz cv wcel vz cv cF ccnv vy
      cv cima wss wa vx cv vz cv wcel vx cv vz cv wcel wa vz cv cF ccnv vy cv
      cima wss wa vx cv vz cv wcel vx cv vz cv wcel vz cv cF ccnv vy cv cima
      wss wa wa vx cv vz cv wcel vx cv vz cv wcel vx cv vz cv wcel wa vz cv cF
      ccnv vy cv cima wss vx cv vz cv wcel pm4.24 anbi1i vx cv vz cv wcel vx cv
      vz cv wcel vz cv cF ccnv vy cv cima wss anass bitri syl6bb ex syld imp
      rexbidva vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz vx cv cJ
      elunirab syl6bbr biimpd adantr imim12d ex com14 mpd com13 r19.20sdv cX cY
      cF wf cF ccnv vy cv cima cX wss vx cv cF ccnv vy cv cima wcel vx cv vx cv
      vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni wcel wi vx cX
      wral cF ccnv vy cv cima vx cF ccnv vy cv cima vx cv vz cv wcel vz cv cF
      ccnv vy cv cima wss wa vz cJ crab cuni ciun wss wi cX cY cF wf cF ccnv vy
      cv cima cF cdm wss cF ccnv vy cv cima cX wss cF vy cv cnvimass cX cY cF
      wf cF cdm cX cF ccnv vy cv cima cX cY cF fdm sseq2d mpbii vx cF ccnv vy
      cv cima vx cv vz cv wcel vz cv cF ccnv vy cv cima wss wa vz cJ crab cuni
      cX cncnplem3 syl syld imp eqssd eqtrd eleq1d cJ ctop wcel vx cv vz cv
      wcel cF vz cv cima vy cv wss wa vz cJ crab cuni cJ wcel vx cF ccnv vy cv
      cima wral vx cF ccnv vy cv cima vx cv vz cv wcel cF vz cv cima vy cv wss
      wa vz cJ crab cuni ciun cJ wcel cJ ctop wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ crab cuni cJ wcel vx cF ccnv vy cv cima cJ ctop
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab cuni cJ wcel
      vx cv cF ccnv vy cv cima wcel cJ ctop wcel vx cv vz cv wcel cF vz cv cima
      vy cv wss wa vz cJ crab cJ wss vx cv vz cv wcel cF vz cv cima vy cv wss
      wa vz cJ crab cuni cJ wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz
      cJ ssrab2 vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ crab cJ
      uniopn mpan2 a1d r19.21aiv vx cF ccnv vy cv cima vx cv vz cv wcel cF vz
      cv cima vy cv wss wa vz cJ crab cuni cJ iunopn mpdan syl5cbi $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)
  $}

  ${
    $d J x y z $.  $d K x y $.  $d F x y z $.  $d X x y z $.  $d Y x y z $.
    cncnp.1 $e |- X = U. J $.
    cncnp.2 $e |- Y = U. K $.
    $( A continuous function is continuous at all points.  Theorem 7.2(g) of
       [Munkres] p. 107. $)
    cncnp $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) ->
                ( F e. ( J Cn K ) <-> A. x e. X F e. ( ( J CnP K ) ` x ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cF vx cv
      cJ cK ccnp co cfv wcel vx cX wral cJ ctop wcel cK ctop wcel cF cJ cK ccn
      co wcel cF vx cv cJ cK ccnp co cfv wcel vx cX wral wi cX cY cF wf cJ ctop
      wcel cK ctop wcel wa cF cJ cK ccn co wcel cF vx cv cJ cK ccnp co cfv wcel
      vx cX cJ ctop wcel cK ctop wcel wa vx cv cX wcel cF cJ cK ccn co wcel cF
      vx cv cJ cK ccnp co cfv wcel cJ ctop wcel cK ctop wcel vx cv cX wcel cF
      cJ cK ccn co wcel cF vx cv cJ cK ccnp co cfv wcel wi cJ ctop wcel cK ctop
      wcel vx cv cX wcel w3a cJ cK ccn co vx cv cJ cK ccnp co cfv cF vx cv cJ
      cK cX cY cncnp.1 cncnp.2 cnsscnp sseld 3expia com23 r19.21adv 3adant3 cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cF vx cv cJ cK ccnp co cfv wcel vx
      cX wral cF cJ cK ccn co wcel wi cX cY cF wf vx cv cF cfv vy cv wcel vx cv
      vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vy cK wral wa vx cX
      wral cX cY cF wf cF ccnv vy cv cima cJ wcel vy cK wral wa wi cJ ctop wcel
      cX cY cF wf cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex wi vy cK wral wa vx cX wral cX cY cF wf cF
      ccnv vy cv cima cJ wcel vy cK wral wa wi cK ctop wcel cX cY cF wf cX cY
      cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa
      vz cJ wrex wi vy cK wral wa vx cX wral cX cY cF wf vx cv cF cfv vy cv
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vy cK wral
      vx cX wral wa cJ ctop wcel cX cY cF wf cF ccnv vy cv cima cJ wcel vy cK
      wral wa cX cY cF wf cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel
      cF vz cv cima vy cv wss wa vz cJ wrex wi vy cK wral wa vx cX wral cX cY
      cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa
      vz cJ wrex wi vy cK wral vx cX wral wa cX cY cF wf vx cv cF cfv vy cv
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vy cK wral
      wa vx cX wral vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy
      cv wss wa vz cJ wrex wi vy cK wral vx cX wral cX cY cF wf cX cY cF wf vx
      cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ
      wrex wi vy cK wral wa vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex wi vy cK wral vx cX cX cY cF wf vx cv cF cfv
      vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vy
      cK wral pm3.27 r19.20si anim2i ex cJ ctop wcel cX cY cF wf vx cv cF cfv
      vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx
      cX wral vy cK wral wa cX cY cF wf cF ccnv vy cv cima cJ wcel vy cK wral
      wa cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy
      cv wss wa vz cJ wrex wi vy cK wral vx cX wral wa cJ ctop wcel cX cY cF wf
      vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ
      wrex wi vx cX wral vy cK wral cF ccnv vy cv cima cJ wcel vy cK wral cJ
      ctop wcel cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex wi vx cX wral vy cK wral cF ccnv vy cv cima
      cJ wcel vy cK wral wi cJ ctop wcel cX cY cF wf wa vx cv cF cfv vy cv wcel
      vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX wral cF
      ccnv vy cv cima cJ wcel vy cK cJ ctop wcel cX cY cF wf vx cv cF cfv vy cv
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX wral
      cF ccnv vy cv cima cJ wcel vx vy vz cF cJ cX cY cncnp.1 cncnplem4 expdimp
      r19.20sdv ex imdistand vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex wi vy cK wral vx cX wral vx cv cF cfv vy cv
      wcel vx cv vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vx cX wral
      vy cK wral cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv
      cima vy cv wss wa vz cJ wrex wi vx vy cX cK ralcom anbi2i syl5ib sylan9r
      3adant2 cJ ctop wcel cK ctop wcel cF vx cv cJ cK ccnp co cfv wcel vx cX
      wral cF cJ cK ccn co wcel wi cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz
      cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vy cK wral wa vx cX wral
      cX cY cF wf cF ccnv vy cv cima cJ wcel vy cK wral wa wi wb cX cY cF wf cJ
      ctop wcel cK ctop wcel wa cF vx cv cJ cK ccnp co cfv wcel vx cX wral cX
      cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv wss
      wa vz cJ wrex wi vy cK wral wa vx cX wral cF cJ cK ccn co wcel cX cY cF
      wf cF ccnv vy cv cima cJ wcel vy cK wral wa cJ ctop wcel cK ctop wcel wa
      cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf vx cv cF cfv vy cv wcel vx cv
      vz cv wcel cF vz cv cima vy cv wss wa vz cJ wrex wi vy cK wral wa vx cX
      cJ ctop wcel cK ctop wcel vx cv cX wcel cF vx cv cJ cK ccnp co cfv wcel
      cX cY cF wf vx cv cF cfv vy cv wcel vx cv vz cv wcel cF vz cv cima vy cv
      wss wa vz cJ wrex wi vy cK wral wa wb vz vy vx cv cF cJ cK cX cY cncnp.1
      cncnp.2 iscnp 3expa ralbidva vy cF cJ cK cX cY cncnp.1 cncnp.2 iscn
      imbi12d 3adant3 mpbird impbid $.
      $( [15-May-2007] $) $( [15-May-2007] $)

    $( A continuous function is continuous at all points.  Theorem 7.2(g) of
       [Munkres] p. 107.  (Contributed by Raph Levien, 20-Nov-2006.) $)
    cncnp2 $p |- ( ( J e. Top /\ K e. Top /\ X =/= (/) ) ->
                ( F e. ( J Cn K ) <-> A. x e. X F e. ( ( J CnP K ) ` x ) ) ) $=
      cJ ctop wcel cK ctop wcel cX c0 wne w3a cF cJ cK ccn co wcel cX cY cF wf
      cF vx cv cJ cK ccnp co cfv wcel vx cX wral wa cF vx cv cJ cK ccnp co cfv
      wcel vx cX wral cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cX cY cF
      wf cF vx cv cJ cK ccnp co cfv wcel vx cX wral wa wb cX c0 wne cJ ctop
      wcel cK ctop wcel wa cF cJ cK ccn co wcel cX cY cF wf cF cJ cK ccn co
      wcel wa cX cY cF wf cF vx cv cJ cK ccnp co cfv wcel vx cX wral wa cJ ctop
      wcel cK ctop wcel wa cF cJ cK ccn co wcel cX cY cF wf cJ ctop wcel cK
      ctop wcel cF cJ cK ccn co wcel cX cY cF wf cF cJ cK cX cY cncnp.1 cncnp.2
      cnf 3expia pm4.71rd cJ ctop wcel cK ctop wcel wa cX cY cF wf cF cJ cK ccn
      co wcel cF vx cv cJ cK ccnp co cfv wcel vx cX wral cJ ctop wcel cK ctop
      wcel cX cY cF wf cF cJ cK ccn co wcel cF vx cv cJ cK ccnp co cfv wcel vx
      cX wral wb vx cF cJ cK cX cY cncnp.1 cncnp.2 cncnp 3expa pm5.32da bitrd
      3adant3 cJ ctop wcel cK ctop wcel cX c0 wne cF vx cv cJ cK ccnp co cfv
      wcel vx cX wral cX cY cF wf cF vx cv cJ cK ccnp co cfv wcel vx cX wral wa
      wb cJ ctop wcel cK ctop wcel wa cF vx cv cJ cK ccnp co cfv wcel vx cX
      wral cX cY cF wf cF vx cv cJ cK ccnp co cfv wcel wa vx cX wral cX c0 wne
      cX cY cF wf cF vx cv cJ cK ccnp co cfv wcel vx cX wral wa cJ ctop wcel cK
      ctop wcel wa cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf cF vx cv cJ cK
      ccnp co cfv wcel wa vx cX cJ ctop wcel cK ctop wcel wa vx cv cX wcel wa
      cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf cJ ctop wcel cK ctop wcel vx
      cv cX wcel cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf wi cJ ctop wcel cK
      ctop wcel vx cv cX wcel w3a cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf
      vx cv cF cJ cK cX cY cncnp.1 cncnp.2 cnpf ex 3expa pm4.71rd ralbidva cX
      cY cF wf cF vx cv cJ cK ccnp co cfv wcel vx cX r19.28zv sylan9bb 3impa
      bitr4d $.
      $( [21-Nov-2006] $) $( [20-Nov-2006] $)
  $}

  ${
    $d J x $.  $d B x $.  $d Y x $.  $d F x $.  $d X x $.  $d K x $.
    cnconst.1 $e |- X = U. J $.
    cnconst.2 $e |- Y = U. K $.
    $( A constant function is continuous.  (Contributed by FL, 25-Jan-2007.) $)
    cnconst $p |- ( ( ( J e. Top /\ K e. Top ) /\
      ( B e. Y /\ F : X --> { B } ) ) -> F e. ( J Cn K ) ) $=
      cJ ctop wcel cK ctop wcel wa cB cY wcel cX cB csn cF wf wa wa cF cJ cK
      ccn co wcel cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa cJ ctop
      wcel cB cY wcel cX cB csn cF wf wa cX cY cF wf cF ccnv vx cv cima cJ wcel
      vx cK wral wa cK ctop wcel cJ ctop wcel cB cY wcel cX cB csn cF wf wa wa
      cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral cX cB csn cF wf cB csn
      cY wss cX cY cF wf cJ ctop wcel cB cY wcel cX cB csn cF wf wa wa cX cB
      csn cY cF fss cJ ctop wcel cB cY wcel cX cB csn cF wf simprr cB cY wcel
      cB csn cY wss cJ ctop wcel cX cB csn cF wf cB cY snssi ad2antrl sylanc cJ
      ctop wcel cB cY wcel cX cB csn cF wf wa wa cF ccnv vx cv cima cJ wcel vx
      cK cJ ctop wcel cB cY wcel cX cB csn cF wf wa wa cF ccnv vx cv cima cJ
      wcel vx cv cK wcel cJ ctop wcel cB cY wcel cX cB csn cF wf wa wa cB vx cv
      wcel cF ccnv vx cv cima cJ wcel cJ ctop wcel cB cY wcel cX cB csn cF wf
      cB vx cv wcel cF ccnv vx cv cima cJ wcel wi cJ ctop wcel cX cB csn cF wf
      cB vx cv wcel cF ccnv vx cv cima cJ wcel wi wi cB cY wcel cJ ctop wcel cX
      cB csn cF wf cB vx cv wcel cF ccnv vx cv cima cJ wcel cJ ctop wcel cX cB
      csn cF wf cB vx cv wcel w3a cF c0 wceq cF ccnv vx cv cima cJ wcel cJ ctop
      wcel cX cB csn cF wf cF c0 wceq cF ccnv vx cv cima cJ wcel wi cB vx cv
      wcel cJ ctop wcel cF ccnv c0 ccnv wceq cF ccnv vx cv cima cJ wcel cF c0
      wceq cJ ctop wcel cF ccnv c0 wceq cF ccnv vx cv cima cJ wcel cF ccnv c0
      ccnv wceq cJ ctop wcel cF ccnv vx cv cima c0 vx cv cima wceq cF ccnv vx
      cv cima cJ wcel cF ccnv c0 wceq cJ ctop wcel cF ccnv vx cv cima c0 wceq
      cF ccnv vx cv cima cJ wcel cF ccnv vx cv cima c0 vx cv cima wceq cJ ctop
      wcel c0 cF ccnv vx cv cima wceq cF ccnv vx cv cima cJ wcel cF ccnv vx cv
      cima c0 wceq c0 cF ccnv vx cv cima wceq c0 cJ wcel cF ccnv vx cv cima cJ
      wcel cJ ctop wcel c0 cF ccnv vx cv cima cJ eleq1 cJ 0opn syl5cbi cF ccnv
      vx cv cima c0 eqcom syl5ib cF ccnv vx cv cima c0 vx cv cima wceq c0 vx cv
      cima c0 wceq cF ccnv vx cv cima c0 wceq vx cv 0ima cF ccnv vx cv cima c0
      vx cv cima c0 eqtr mpan2 syl5 cF ccnv c0 vx cv imaeq1 syl5 cF ccnv c0
      ccnv wceq c0 ccnv c0 wceq cF ccnv c0 wceq cnv0 cF ccnv c0 ccnv c0 eqtr
      mpan2 syl5 cF c0 cnveq syl5 3ad2ant1 cJ ctop wcel cX cB csn cF wf cB vx
      cv wcel w3a cF c0 wceq wn cF ccnv vx cv cima cJ wcel cJ ctop wcel cX cB
      csn cF wf cB vx cv wcel w3a cF c0 wceq wn wa cF ccnv vx cv cima cX cJ cJ
      ctop wcel cX cB csn cF wf cB vx cv wcel cF c0 wceq wn cF ccnv vx cv cima
      cX wceq cX cB csn cF wf cB vx cv wcel cF c0 wceq wn cF ccnv vx cv cima cX
      wceq wi wi wi cJ ctop wcel cX cB csn cF wf cB vx cv wcel cF c0 wceq wn cF
      ccnv vx cv cima cX wceq cX cB csn cF wf cB vx cv wcel cF c0 wceq wn w3a
      cF ccnv vx cv cima cX cX cB csn cF wf cB vx cv wcel cF ccnv vx cv cima cX
      wss cF c0 wceq wn cX cB csn cF wf cF ccnv vx cv cima cF ccnv crn cX cF
      ccnv vx cv cima cF ccnv crn wss cX cB csn cF wf cF ccnv vx cv imassrn a1i
      cX cB csn cF wf cF cdm cX cF ccnv crn cX cB csn cF fdm cF dfdm4 syl5eqr
      sseqtrd 3ad2ant1 cX cB csn cF wf cB vx cv wcel cF c0 wceq wn w3a cX cF
      ccnv cB csn cima cF ccnv vx cv cima cX cB csn cF wf cF c0 wceq wn cX cF
      ccnv cB csn cima wceq cB vx cv wcel cX cB csn cF wf cF c0 wceq wn wa cX
      cF cdm cF ccnv cF ccnv cdm cima cF ccnv cB csn cima cX cB csn cF wf cX cF
      cdm wceq cF c0 wceq wn cX cB csn cF wf cF cdm cX cX cB csn cF fdm eqcomd
      adantr cF cdm cF ccnv cF ccnv cdm cima wceq cX cB csn cF wf cF c0 wceq wn
      wa cF cdm cF ccnv crn cF ccnv cF ccnv cdm cima cF dfdm4 cF ccnv imadmrn
      eqtr4i a1i cX cB csn cF wf cF c0 wceq wn wa cF ccnv cdm cB csn cF ccnv cX
      cB csn cF wf cF c0 wceq wn wa cF crn cB csn cF ccnv cdm cX cB csn cF wf
      cF c0 wceq wn wa cX cB csn cF wfo cF crn cB csn wceq cX cB csn cF wf cF
      c0 wne cX cB csn cF wfo cF c0 wceq wn cX cB cF foconst cF c0 df-ne
      sylan2br cX cB csn cF forn syl cF df-rn syl5eqr imaeq2d 3eqtrd 3adant2 cB
      vx cv wcel cX cB csn cF wf cF ccnv cB csn cima cF ccnv vx cv cima wss cF
      c0 wceq wn cB vx cv wcel cB csn vx cv wss cF ccnv cB csn cima cF ccnv vx
      cv cima wss cB vx cv snssi cB csn vx cv cF ccnv imass2 syl 3ad2ant2
      eqsstrd eqssd 3exp a1i 3imp1 cJ ctop wcel cX cB csn cF wf cB vx cv wcel
      w3a cX cJ wcel cF c0 wceq wn cJ ctop wcel cX cB csn cF wf cX cJ wcel cB
      vx cv wcel cJ cX cnconst.1 topopn 3ad2ant1 adantr eqeltrd ex pm2.61d 3exp
      a1d imp32 cJ ctop wcel cB cY wcel cX cB csn cF wf wa wa cB vx cv wcel wn
      cF ccnv vx cv cima cJ wcel cJ ctop wcel cB cY wcel cX cB csn cF wf wa wa
      cB vx cv wcel wn wa cF ccnv vx cv cima c0 cJ cB cY wcel cX cB csn cF wf
      wa cB vx cv wcel wn cF ccnv vx cv cima c0 wceq cJ ctop wcel cX cB csn cF
      wf cB csn vx cv cin c0 wceq cF ccnv vx cv cima c0 wceq cB cY wcel cX cB
      csn cF wf wa cB vx cv wcel wn cX cB csn vx cv cF fimacnvdisj cB cY wcel
      cX cB csn cF wf pm3.27 cB vx cv wcel wn vx cv cB csn cin c0 cB csn vx cv
      cin vx cv cB csn cin c0 wceq cB vx cv wcel wn vx cv cB disjsn biimpri cB
      csn vx cv incom syl5eq syl2an adantll cJ ctop wcel c0 cJ wcel cB cY wcel
      cX cB csn cF wf wa cB vx cv wcel wn cJ 0opn ad2antrr eqeltrd ex pm2.61d
      a1d r19.21aiv jca adantlr cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co
      wcel cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa wb cB cY wcel
      cX cB csn cF wf wa vx cF cJ cK cX cY cnconst.1 cnconst.2 iscn adantr
      mpbird $.
      $( [25-Jan-2007] $) $( [15-Jan-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Hausdorff spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbol for Hausdorff space. $)
  $c Haus $.

  $( Extend class notation with the class of all Hausdorf spaces. $)
  cha $a class Haus $.

  ${
    $d j m n x y w z $.
    $( Define the class of all Hausdorff spaces.  A Hausdorff space is a
       topology in which distinct points have disjoint open neighborhoods.
       Definition of Hausdorff space in [Munkres] p. 98. $)
    df-haus $a |- Haus = { j e. Top | A. x e. U. j A. y e. U. j ( x =/= y ->
           E. n e. j E. m e. j ( x e. n /\ y e. m /\ ( n i^i m ) = (/) ) ) } $.
  $}

  ${
    $d j m n x y J $.  $d j x y X $.  $d m n x y P $.  $d m n y Q $.
    ishaus.1 $e |- X = U. J $.
    $( Express the predicate " ` J ` is a Hausdorff space." $)
    ishaus $p |- ( J e. Haus <-> ( J e. Top /\ A. x e. X A. y e. X ( x =/= y ->
               E. n e. J E. m e. J ( x e. n /\ y e. m /\
                   ( n i^i m ) = (/) ) ) ) ) $=
      vx cv vy cv wne vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq
      w3a vm vj cv wrex vn vj cv wrex wi vy vj cv cuni wral vx vj cv cuni wral
      vx cv vy cv wne vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq
      w3a vm cJ wrex vn cJ wrex wi vy cX wral vx cX wral vj cJ ctop cha vj cv
      cJ wceq vx cv vy cv wne vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin
      c0 wceq w3a vm vj cv wrex vn vj cv wrex wi vy vj cv cuni wral vx cv vy cv
      wne vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ
      wrex vn cJ wrex wi vy cX wral vx vj cv cuni cX vj cv cJ wceq vj cv cuni
      cJ cuni cX vj cv cJ unieq ishaus.1 syl6eqr vj cv cJ wceq vx cv vy cv wne
      vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm vj cv
      wrex vn vj cv wrex wi vx cv vy cv wne vx cv vn cv wcel vy cv vm cv wcel
      vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex wi vy vj cv cuni cX vj
      cv cJ wceq vj cv cuni cJ cuni cX vj cv cJ unieq ishaus.1 syl6eqr vj cv cJ
      wceq vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm vj
      cv wrex vn vj cv wrex vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin
      c0 wceq w3a vm cJ wrex vn cJ wrex vx cv vy cv wne vx cv vn cv wcel vy cv
      vm cv wcel vn cv vm cv cin c0 wceq w3a vm vj cv wrex vx cv vn cv wcel vy
      cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn vj cv cJ vx cv vn
      cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm vj cv cJ rexeq1
      rexeqd imbi2d raleq12d raleq12d vx vy vj vm vn df-haus elrab2 $.
      $( [15-Mar-2007] $) $( [8-Mar-2007] $)

    $( Neighborhood property of a Hausdorff space. $)
    hausnei $p |- ( ( J e. Haus /\ ( P e. X /\ Q e. X /\ P =/= Q ) ) ->
           E. n e. J E. m e. J ( P e. n /\ Q e. m /\
                   ( n i^i m ) = (/) ) ) $=
      cJ cha wcel cP cX wcel cQ cX wcel cP cQ wne cP vn cv wcel cQ vm cv wcel
      vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex cP cX wcel cQ cX wcel
      cJ cha wcel cP cQ wne cP vn cv wcel cQ vm cv wcel vn cv vm cv cin c0 wceq
      w3a vm cJ wrex vn cJ wrex wi cP cX wcel cQ cX wcel cJ cha wcel cP cQ wne
      cP vn cv wcel cQ vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ
      wrex wi wi cP cX wcel cQ cX wcel wa vx cv vy cv wne vx cv vn cv wcel vy
      cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex wi vy cX
      wral vx cX wral cP cQ wne cP vn cv wcel cQ vm cv wcel vn cv vm cv cin c0
      wceq w3a vm cJ wrex vn cJ wrex wi cJ cha wcel vx cv vy cv wne vx cv vn cv
      wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex
      wi cP cQ wne cP vn cv wcel cQ vm cv wcel vn cv vm cv cin c0 wceq w3a vm
      cJ wrex vn cJ wrex wi cP vy cv wne cP vn cv wcel vy cv vm cv wcel vn cv
      vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex wi vx vy cP cQ cX cX vx cv cP
      wceq vx cv vy cv wne cP vy cv wne vx cv vn cv wcel vy cv vm cv wcel vn cv
      vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex cP vn cv wcel vy cv vm cv
      wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex vx cv cP vy cv
      neeq1 vx cv cP wceq vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0
      wceq w3a cP vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vn vm
      cJ cJ vx cv cP wceq vx cv vn cv wcel cP vn cv wcel vy cv vm cv wcel vn cv
      vm cv cin c0 wceq vx cv cP vn cv eleq1 3anbi1d 2rexbidv imbi12d vy cv cQ
      wceq cP vy cv wne cP cQ wne cP vn cv wcel vy cv vm cv wcel vn cv vm cv
      cin c0 wceq w3a vm cJ wrex vn cJ wrex cP vn cv wcel cQ vm cv wcel vn cv
      vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex vy cv cQ cP neeq2 vy cv cQ
      wceq cP vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a cP vn cv
      wcel cQ vm cv wcel vn cv vm cv cin c0 wceq w3a vn vm cJ cJ vy cv cQ wceq
      vy cv vm cv wcel cQ vm cv wcel cP vn cv wcel vn cv vm cv cin c0 wceq vy
      cv cQ vm cv eleq1 3anbi2d 2rexbidv imbi12d rcla42v cJ cha wcel cJ ctop
      wcel vx cv vy cv wne vx cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0
      wceq w3a vm cJ wrex vn cJ wrex wi vy cX wral vx cX wral vx vy vm vn cJ cX
      ishaus.1 ishaus pm3.27bi syl5 ex com3r 3imp2 $.
      $( [23-Apr-2007] $) $( [8-Mar-2007] $)
  $}

  ${
    $d m n x y J $.  $d x y X $.
    ishausi.1 $e |- X = U. J $.
    ishausi.2 $e |- J e. Top $.
    ishausi.3 $e |- ( ( x e. X /\ y e. X /\ x =/= y ) ->
             E. n e. J E. m e. J ( x e. n /\ y e. m /\ ( n i^i m ) = (/) ) ) $.
    $( Properties that determine a Hausdorff space. $)
    ishausi $p |- J e. Haus $=
      cJ cha wcel cJ ctop wcel vx cv vy cv wne vx cv vn cv wcel vy cv vm cv
      wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex wi vy cX wral vx
      cX wral vx vy vm vn cJ cX ishausi.1 ishaus ishausi.2 vx cv vy cv wne vx
      cv vn cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn
      cJ wrex wi vx vy cX vx cv cX wcel vy cv cX wcel vx cv vy cv wne vx cv vn
      cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ
      wrex ishausi.3 3expia rgen2a mpbir2an $.
      $( [18-Apr-2007] $) $( [8-Mar-2007] $)
  $}

  ${
    $d x y m n J $.
    $( A Hausdorff space is a topology. $)
    haustop $p |- ( J e. Haus -> J e. Top ) $=
      cJ cha wcel cJ ctop wcel vx cv vy cv wne vx cv vn cv wcel vy cv vm cv
      wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex wi vy cJ cuni wral
      vx cJ cuni wral vx vy vm vn cJ cJ cuni cJ cuni eqid ishaus pm3.26bi $.
      $( [22-Apr-2007] $) $( [5-Mar-2007] $)
  $}

  ${
    $d n x y J $.  $d n x y P $.  $d x y X $.
    sncld.1 $e |- X = U. J $.
    $( A singleton is closed in a Hausdorff space. $)
    sncld $p |- ( ( J e. Haus /\ P e. X ) -> { P } e. ( Clsd ` J ) ) $=
      cJ cha wcel cP cX wcel wa cP csn cJ ccld cfv wcel cP csn cJ ccl cfv cfv
      cP csn wceq cJ cha wcel cP cX wcel wa vx cP csn cJ ccl cfv cfv cP csn cJ
      cha wcel cP cX wcel wa vx cv cP csn cJ ccl cfv cfv wcel vx cv cX wcel vx
      cv vy cv wcel vy cv cP csn cin c0 wne wi vy cJ wral wa vx cv cP csn wcel
      cJ ctop wcel cP csn cX wss vx cv cP csn cJ ccl cfv cfv wcel vx cv cX wcel
      vx cv vy cv wcel vy cv cP csn cin c0 wne wi vy cJ wral wa wb cJ cha wcel
      cP cX wcel vy vx cv cP csn cJ cX sncld.1 elcls2 cJ haustop cP cX snssi
      syl2an cJ cha wcel cP cX wcel wa vx cv cX wcel vx cv vy cv wcel vy cv cP
      csn cin c0 wne wi vy cJ wral wa vx cv cP wceq vx cv cP csn wcel cJ cha
      wcel cP cX wcel wa vx cv cX wcel vx cv vy cv wcel vy cv cP csn cin c0 wne
      wi vy cJ wral wa vx cv cP wceq cJ cha wcel cP cX wcel wa vx cv cX wcel vx
      cv vy cv wcel vy cv cP csn cin c0 wne wi vy cJ wral vx cv cP wceq cJ cha
      wcel cP cX wcel wa vx cv cX wcel wa vx cv vy cv wcel vy cv cP csn cin c0
      wceq wa vy cJ wrex wn vx cv cP wceq vx cv vy cv wcel vy cv cP csn cin c0
      wne wi vy cJ wral cJ cha wcel cP cX wcel wa vx cv cX wcel wa vx cv vy cv
      wcel vy cv cP csn cin c0 wceq wa vy cJ wrex vx cv cP cJ cha wcel vx cv cX
      wcel cP cX wcel vx cv cP wne vx cv vy cv wcel vy cv cP csn cin c0 wceq wa
      vy cJ wrex wi cJ cha wcel vx cv cX wcel cP cX wcel vx cv cP wne vx cv vy
      cv wcel vy cv cP csn cin c0 wceq wa vy cJ wrex wi cJ cha wcel vx cv cX
      wcel cP cX wcel vx cv cP wne vx cv vy cv wcel vy cv cP csn cin c0 wceq wa
      vy cJ wrex cJ cha wcel vx cv cX wcel cP cX wcel vx cv cP wne w3a wa vx cv
      vy cv wcel cP vn cv wcel vy cv vn cv cin c0 wceq w3a vn cJ wrex vy cJ
      wrex vx cv vy cv wcel vy cv cP csn cin c0 wceq wa vy cJ wrex vx cv cP vn
      vy cJ cX sncld.1 hausnei vx cv vy cv wcel cP vn cv wcel vy cv vn cv cin
      c0 wceq w3a vn cJ wrex vx cv vy cv wcel vy cv cP csn cin c0 wceq wa vy cJ
      vx cv vy cv wcel cP vn cv wcel vy cv vn cv cin c0 wceq w3a vx cv vy cv
      wcel vy cv cP csn cin c0 wceq wa vn cJ vx cv vy cv wcel cP vn cv wcel vy
      cv vn cv cin c0 wceq w3a vx cv vy cv wcel vy cv cP csn cin c0 wceq wa wi
      vn cv cJ wcel vx cv vy cv wcel cP vn cv wcel vy cv vn cv cin c0 wceq vx
      cv vy cv wcel vy cv cP csn cin c0 wceq wa cP vn cv wcel vy cv vn cv cin
      c0 wceq wa vy cv cP csn cin c0 wceq vx cv vy cv wcel vy cv cP csn cin vy
      cv vn cv cin wss vy cv vn cv cin c0 wceq vy cv cP csn cin c0 wceq cP vn
      cv wcel vy cv cP csn cin vy cv vn cv cin sseq0 cP vn cv wcel cP csn vn cv
      wss vy cv cP csn cin vy cv vn cv cin wss cP vn cv snssi cP csn vn cv vy
      cv sslin syl sylan anim2i 3impb a1i r19.23aiv r19.22si syl 3exp2 imp31
      an1rs necon1bd vx cv vy cv wcel vy cv cP csn cin c0 wne wi vy cJ wral vx
      cv vy cv wcel vy cv cP csn cin c0 wceq wn wi vy cJ wral vx cv vy cv wcel
      vy cv cP csn cin c0 wceq wa vy cJ wrex wn vx cv vy cv wcel vy cv cP csn
      cin c0 wne wi vx cv vy cv wcel vy cv cP csn cin c0 wceq wn wi vy cJ vy cv
      cP csn cin c0 wne vy cv cP csn cin c0 wceq wn vx cv vy cv wcel vy cv cP
      csn cin c0 df-ne imbi2i ralbii vx cv vy cv wcel vy cv cP csn cin c0 wceq
      vy cJ ralinexa bitri syl5ib expimpd cJ cha wcel cP cX wcel wa vx cv cP
      wceq vx cv cX wcel vx cv vy cv wcel vy cv cP csn cin c0 wne wi vy cJ wral
      cP cX wcel vx cv cP wceq vx cv cX wcel wi cJ cha wcel cP cX vx cv eleq1a
      adantl vx cv cP wceq vx cv vy cv wcel vy cv cP csn cin c0 wne wi vy cJ
      wral wi cJ cha wcel cP cX wcel wa vx cv cP wceq vx cv vy cv wcel vy cv cP
      csn cin c0 wne wi vy cJ vx cv cP wceq vx cv vy cv wcel vy cv cP csn cin
      c0 wne wi vy cv cJ wcel vx cv cP wceq vx cv vy cv wcel cP vy cv wcel vy
      cv cP csn cin c0 wne vx cv cP wceq vx cv vy cv wcel cP vy cv wcel vx cv
      cP vy cv eleq1 biimpd cP vy cv wcel vy cv cP csn cin c0 vy cv cP disjsn
      necon2abii syl6ib adantr r19.21aiva a1i jcad impbid vx cP elsn syl6bbr
      bitrd eqrdv cJ ctop wcel cP csn cX wss cP csn cJ ccld cfv wcel cP csn cJ
      ccl cfv cfv cP csn wceq wb cJ cha wcel cP cX wcel cP csn cJ cX sncld.1
      iscld3 cJ haustop cP cX snssi syl2an mpbird $.
      $( [25-Apr-2007] $) $( [5-Mar-2007] $)
  $}

  ${
    dnsconst.1 $e |- X = U. J $.
    dnsconst.2 $e |- Y = U. K $.
    $( If a continuous mapping to a Hausdorff space is constant on a dense
       subset, it is constant on the entire space.  Note that
       ` ( ( cls `` J ) `` A ) = X ` means " ` A ` is dense in ` X ` " and
       ` A C_ ( ``' F " { P } ) ` means " ` F ` is constant on ` A ` " (see
       ~ funconstss ). $)
    dnsconst $p |- ( ( ( J e. Top /\ K e. Haus /\ F e. ( J Cn K ) ) /\
  ( P e. Y /\ A C_ ( `' F " { P } ) /\ ( ( cls ` J ) ` A ) = X ) ) ->
        F : X --> { P } ) $=
      cX cP csn cF wf cF cX wfn cX cF ccnv cP csn cima wss cJ ctop wcel cK cha
      wcel cF cJ cK ccn co wcel w3a cP cY wcel cA cF ccnv cP csn cima wss cA cJ
      ccl cfv cfv cX wceq w3a wa cX cP cF fconst3 cJ ctop wcel cK cha wcel cF
      cJ cK ccn co wcel w3a cF cX wfn cP cY wcel cA cF ccnv cP csn cima wss cA
      cJ ccl cfv cfv cX wceq w3a cJ ctop wcel cK cha wcel cF cJ cK ccn co wcel
      w3a cX cY cF wf cF cX wfn cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel
      cX cY cF wf cK cha wcel cF cJ cK cX cY dnsconst.1 dnsconst.2 cnf cK
      haustop syl3an2 cX cY cF ffn syl adantr cJ ctop wcel cK cha wcel cF cJ cK
      ccn co wcel w3a cP cY wcel cA cF ccnv cP csn cima wss cA cJ ccl cfv cfv
      cX wceq w3a wa cF ccnv cP csn cima cJ ccld cfv wcel cX cF ccnv cP csn
      cima wss cJ ctop wcel cK cha wcel cF cJ cK ccn co wcel w3a cA cF ccnv cP
      csn cima wss cP cY wcel cF ccnv cP csn cima cJ ccld cfv wcel cA cJ ccl
      cfv cfv cX wceq cJ ctop wcel cK cha wcel cF cJ cK ccn co wcel w3a cP cY
      wcel cP csn cK ccld cfv wcel cF ccnv cP csn cima cJ ccld cfv wcel cK cha
      wcel cJ ctop wcel cP cY wcel cP csn cK ccld cfv wcel cF cJ cK ccn co wcel
      cP cK cY dnsconst.2 sncld 3ad2antl2 cJ ctop wcel cK ctop wcel cF cJ cK
      ccn co wcel cP csn cK ccld cfv wcel cF ccnv cP csn cima cJ ccld cfv wcel
      cK cha wcel cP csn cF cJ cK cnclima cK haustop syl3anl2 syldan 3ad2antr1
      cJ ctop wcel cK cha wcel cP cY wcel cA cF ccnv cP csn cima wss cA cJ ccl
      cfv cfv cX wceq w3a cF ccnv cP csn cima cJ ccld cfv wcel cX cF ccnv cP
      csn cima wss wi cF cJ cK ccn co wcel cJ ctop wcel cK cha wcel wa cA cF
      ccnv cP csn cima wss cA cJ ccl cfv cfv cX wceq cF ccnv cP csn cima cJ
      ccld cfv wcel cX cF ccnv cP csn cima wss wi cP cY wcel cJ ctop wcel cA cF
      ccnv cP csn cima wss cA cJ ccl cfv cfv cX wceq wa cF ccnv cP csn cima cJ
      ccld cfv wcel cX cF ccnv cP csn cima wss wi cK cha wcel cJ ctop wcel cA
      cF ccnv cP csn cima wss cA cJ ccl cfv cfv cX wceq wa wa cF ccnv cP csn
      cima cJ ccld cfv wcel cA cJ ccl cfv cfv cF ccnv cP csn cima wss cX cF
      ccnv cP csn cima wss cJ ctop wcel cA cF ccnv cP csn cima wss cF ccnv cP
      csn cima cJ ccld cfv wcel cA cJ ccl cfv cfv cF ccnv cP csn cima wss wi cA
      cJ ccl cfv cfv cX wceq cJ ctop wcel cA cF ccnv cP csn cima wss wa cF ccnv
      cP csn cima cJ ccld cfv wcel cA cJ ccl cfv cfv cF ccnv cP csn cima wss cJ
      ctop wcel cA cF ccnv cP csn cima wss wa cF ccnv cP csn cima cJ ccld cfv
      wcel wa cA cJ ccl cfv cfv cF ccnv cP csn cima cJ ccl cfv cfv cF ccnv cP
      csn cima cJ ctop wcel cF ccnv cP csn cima cX wss cA cF ccnv cP csn cima
      wss cA cJ ccl cfv cfv cF ccnv cP csn cima cJ ccl cfv cfv wss cJ ctop wcel
      cA cF ccnv cP csn cima wss wa cF ccnv cP csn cima cJ ccld cfv wcel wa cF
      ccnv cP csn cima cA cJ cX dnsconst.1 clsss cJ ctop wcel cA cF ccnv cP csn
      cima wss cF ccnv cP csn cima cJ ccld cfv wcel simpll cJ ctop wcel cF ccnv
      cP csn cima cJ ccld cfv wcel cF ccnv cP csn cima cX wss cA cF ccnv cP csn
      cima wss cF ccnv cP csn cima cJ cX dnsconst.1 cldss adantlr cJ ctop wcel
      cA cF ccnv cP csn cima wss cF ccnv cP csn cima cJ ccld cfv wcel simplr
      syl3anc cJ ctop wcel cF ccnv cP csn cima cJ ccld cfv wcel cF ccnv cP csn
      cima cJ ccl cfv cfv cF ccnv cP csn cima wceq cA cF ccnv cP csn cima wss
      cF ccnv cP csn cima cJ cldcls adantlr sseqtrd ex adantrr cA cJ ccl cfv
      cfv cX wceq cA cJ ccl cfv cfv cF ccnv cP csn cima wss cX cF ccnv cP csn
      cima wss wb cJ ctop wcel cA cF ccnv cP csn cima wss cA cJ ccl cfv cfv cX
      cF ccnv cP csn cima sseq1 ad2antll sylibd adantlr 3adantr1 3adantl3 mpd
      sylanbrc $.
      $( [28-Apr-2007] $) $( [15-Mar-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Examples of Hausdorff spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Metric spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Basic metric space properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols and define their syntactical properties. $)
  $c Met $.
  $c MetSp $.
  $c ball $.
  $c Open $.

  $( Extend class notation with the class of all metrics. $)
  cme $a class Met $.

  $( Extend class notation with the class of all metric spaces. $)
  cmt $a class MetSp $.

  $( Extend class notation with the metric space ball function. $)
  cbl $a class ball $.

  $( Extend class notation with a function mapping each metric space to the
     family of its open sets. $)
  copn $a class Open $.

  ${
    $d x y z w v u $.
    $( Define the (proper) class of all metrics.  (A metric space is the
       metric's base set paired with the metric; see ~ df-ms .  However, we
       will often also call the metric itself a "metric space.")  Equivalent
       to Definition 14-1.1 of [Gleason] p. 223.  See ~ ismsg for the property
       "is a metric space."  The 4 properties in Gleason's definition are
       shown by ~ met0 , ~ metgt0 , ~ metsym , and ~ mettri . $)
    df-met $a |- Met = { x | E. y ( x : ( y X. y ) --> RR /\
                 A. z e. y A. w e. y ( ( ( z x w ) = 0 <-> z = w ) /\
                 A. v e. y ( z x w ) <_ ( ( v x z ) + ( v x w ) ) ) ) } $.

    $( Define the (proper) class of all metric spaces. $)
    df-ms $a |- MetSp = { <. x , y >. | ( y e. Met /\ x = dom dom y ) } $.

    $( Define the metric space ball function.  See ~ blval for its value. $)
    df-bl $a |- ball = { <. x , y >. | ( x e. Met /\ y =
  { <. <. z , w >. , v >. | ( ( z e. dom dom x /\ w e. RR ) /\ ( 0 < w /\ v =
                { u e. dom dom x | ( z x u ) < w } ) ) } ) } $.

    $( Define a function whose value is the family of open sets of a metric
       space.  See ~ isopn for its main property. $)
    df-opn $a |- Open = { <. x , y >. | ( x e. Met /\ y = { z | ( z C_
            dom dom x /\ A. w e. z E. v e. ran ( ball ` x ) (
            w e. v /\ v C_ z ) ) } ) } $.

    $( The class of all metric spaces is a relation. $)
    msrel $p |- Rel MetSp $=
      cmt wrel vy cv cme wcel vx cv vy cv cdm cdm wceq wa vx vy copab wrel vy
      cv cme wcel vx cv vy cv cdm cdm wceq wa vx vy relopab cmt vy cv cme wcel
      vx cv vy cv cdm cdm wceq wa vx vy copab vx vy df-ms releqi mpbir $.
      $( [28-Aug-2006] $) $( [28-Aug-2006] $)
  $}

  ${
    $d d t x y z D $.  $d t x y z X $.
    ismet.1 $e |- X = dom dom D $.
    $( Express the predicate " ` D ` is a metric." $)
    ismet $p |- ( D e. A -> ( D e. Met <-> ( D : ( X X. X ) --> RR /\
                 A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                 A. z e. X ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) ) ) ) $=
      cD cA wcel cD cme wcel vt cv cD cdm cdm wceq vt cv vt cv cxp cr cD wf vx
      cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv
      cD co vz cv vy cv cD co caddc co cle wbr vz vt cv wral wa vy vt cv wral
      vx vt cv wral wa wa vt wex cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa cD cA wcel cD cme
      wcel vt cv vt cv cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq
      wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr
      vz vt cv wral wa vy vt cv wral vx vt cv wral wa vt wex vt cv cD cdm cdm
      wceq vt cv vt cv cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq
      wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr
      vz vt cv wral wa vy vt cv wral vx vt cv wral wa wa vt wex vt cv vt cv cxp
      cr vd cv wf vx cv vy cv vd cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv
      vd cv co vz cv vx cv vd cv co vz cv vy cv vd cv co caddc co cle wbr vz vt
      cv wral wa vy vt cv wral vx vt cv wral wa vt wex vt cv vt cv cxp cr cD wf
      vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx
      cv cD co vz cv vy cv cD co caddc co cle wbr vz vt cv wral wa vy vt cv
      wral vx vt cv wral wa vt wex vd cD cme cA vd cv cD wceq vt cv vt cv cxp
      cr vd cv wf vx cv vy cv vd cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv
      vd cv co vz cv vx cv vd cv co vz cv vy cv vd cv co caddc co cle wbr vz vt
      cv wral wa vy vt cv wral vx vt cv wral wa vt cv vt cv cxp cr cD wf vx cv
      vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD
      co vz cv vy cv cD co caddc co cle wbr vz vt cv wral wa vy vt cv wral vx
      vt cv wral wa vt vd cv cD wceq vt cv vt cv cxp cr vd cv wf vt cv vt cv
      cxp cr cD wf vx cv vy cv vd cv co cc0 wceq vx cv vy cv wceq wb vx cv vy
      cv vd cv co vz cv vx cv vd cv co vz cv vy cv vd cv co caddc co cle wbr vz
      vt cv wral wa vy vt cv wral vx vt cv wral vx cv vy cv cD co cc0 wceq vx
      cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz vt cv wral wa vy vt cv wral vx vt cv wral vt cv vt cv
      cxp cr vd cv cD feq1 vd cv cD wceq vx cv vy cv vd cv co cc0 wceq vx cv vy
      cv wceq wb vx cv vy cv vd cv co vz cv vx cv vd cv co vz cv vy cv vd cv co
      caddc co cle wbr vz vt cv wral wa vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz vt cv wral wa vx vy vt cv vt cv vd cv cD wceq vx cv vy cv vd
      cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv vd cv co vz cv vx cv vd cv co vz cv vy cv vd cv co
      caddc co cle wbr vz vt cv wral vx cv vy cv cD co vz cv vx cv cD co vz cv
      vy cv cD co caddc co cle wbr vz vt cv wral vd cv cD wceq vx cv vy cv vd
      cv co cc0 wceq vx cv vy cv cD co cc0 wceq vx cv vy cv wceq vd cv cD wceq
      vx cv vy cv vd cv co vx cv vy cv cD co cc0 vx cv vy cv vd cv cD opreq
      eqeq1d bibi1d vd cv cD wceq vx cv vy cv vd cv co vz cv vx cv vd cv co vz
      cv vy cv vd cv co caddc co cle wbr vx cv vy cv cD co vz cv vx cv cD co vz
      cv vy cv cD co caddc co cle wbr vz vt cv vd cv cD wceq vx cv vy cv vd cv
      co vx cv vy cv cD co vz cv vx cv vd cv co vz cv vy cv vd cv co caddc co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle vx cv vy cv vd cv cD
      opreq vd cv cD wceq vz cv vx cv vd cv co vz cv vx cv cD co vz cv vy cv vd
      cv co vz cv vy cv cD co caddc vz cv vx cv vd cv cD opreq vz cv vy cv vd
      cv cD opreq opreq12d breq12d ralbidv anbi12d 2ralbidv anbi12d exbidv vd
      vt vx vy vz df-met elab2g vt cv vt cv cxp cr cD wf vx cv vy cv cD co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv
      cD co caddc co cle wbr vz vt cv wral wa vy vt cv wral vx vt cv wral wa vt
      cv cD cdm cdm wceq vt cv vt cv cxp cr cD wf vx cv vy cv cD co cc0 wceq vx
      cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz vt cv wral wa vy vt cv wral vx vt cv wral wa wa vt vt
      cv vt cv cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx
      cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz vt
      cv wral wa vy vt cv wral vx vt cv wral wa vt cv cD cdm cdm wceq vt cv vt
      cv cxp cr cD wf vt cv cD cdm cdm wceq vx cv vy cv cD co cc0 wceq vx cv vy
      cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz vt cv wral wa vy vt cv wral vx vt cv wral vt cv vt cv cxp cr
      cD wf cD cdm vt cv vt cv cxp wceq vt cv cD cdm cdm wceq vt cv vt cv cxp
      cr cD fdm cD cdm vt cv vt cv cxp wceq cD cdm cdm vt cv vt cv cxp cdm vt
      cv cD cdm vt cv vt cv cxp dmeq vt cv dmxpid syl6req syl adantr pm4.71ri
      exbii syl6bb cD cA wcel cD cdm cvv wcel cD cdm cdm cvv wcel vt cv cD cdm
      cdm wceq vt cv vt cv cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz vt cv wral wa vy vt cv wral vx vt cv wral wa wa vt wex cX cX
      cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv
      cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa
      vy cX wral vx cX wral wa wb cD cA dmexg cD cdm cvv dmexg vt cv vt cv cxp
      cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz vt cv wral wa vy
      vt cv wral vx vt cv wral wa cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa vt cD cdm cdm cvv
      vt cv cD cdm cdm wceq vt cv cX wceq vt cv vt cv cxp cr cD wf vx cv vy cv
      cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz
      cv vy cv cD co caddc co cle wbr vz vt cv wral wa vy vt cv wral vx vt cv
      wral wa cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb
      vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz
      cX wral wa vy cX wral vx cX wral wa wb cX cD cdm cdm vt cv ismet.1 eqeq2i
      vt cv cX wceq vt cv vt cv cxp cr cD wf cX cX cxp cr cD wf vx cv vy cv cD
      co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv
      vy cv cD co caddc co cle wbr vz vt cv wral wa vy vt cv wral vx vt cv wral
      vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx
      cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx
      cX wral vt cv cX wceq vt cv vt cv cxp cX cX cxp wceq vt cv vt cv cxp cr
      cD wf cX cX cxp cr cD wf wb vt cv cX wceq vt cv vt cv cxp cX vt cv cxp cX
      cX cxp vt cv cX vt cv xpeq1 vt cv cX cX xpeq2 eqtrd vt cv vt cv cxp cX cX
      cxp cr cD feq2 syl vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv
      vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz vt cv
      wral wa vy vt cv wral vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx
      cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX
      wral wa vy cX wral vx vt cv cX vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz vt cv wral wa vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb
      vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz
      cX wral wa vy vt cv cX vt cv cX wceq vx cv vy cv cD co vz cv vx cv cD co
      vz cv vy cv cD co caddc co cle wbr vz vt cv wral vx cv vy cv cD co vz cv
      vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral vx cv vy cv cD
      co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv
      vy cv cD co caddc co cle wbr vz vt cv cX raleq1 anbi2d raleqd raleqd
      anbi12d sylbir ceqsexgv 3syl bitrd $.
      $( [4-Sep-2007] $) $( [25-Aug-2006] $)
  $}

  ${
    $d x y z w v u $.
    $( Alternate definition for the class of all metric spaces (replaces old
       version of ~ df-ms ). $)
    dfms2 $p |- MetSp = { <. x , y >. | ( y : ( x X. x ) --> RR /\
                 A. z e. x A. w e. x ( ( ( z y w ) = 0 <-> z = w ) /\
                 A. v e. x ( z y w ) <_ ( ( v y z ) + ( v y w ) ) ) ) } $=
      cmt vy cv cme wcel vx cv vy cv cdm cdm wceq wa vx vy copab vx cv vx cv
      cxp cr vy cv wf vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv
      vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr
      vv vx cv wral wa vw vx cv wral vz vx cv wral wa vx vy copab vx vy df-ms
      vy cv cme wcel vx cv vy cv cdm cdm wceq wa vx cv vx cv cxp cr vy cv wf vz
      cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv cv
      vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr vv vx cv wral wa vw
      vx cv wral vz vx cv wral wa vx vy vx cv vx cv cxp cr vy cv wf vz cv vw cv
      vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy
      cv co vv cv vw cv vy cv co caddc co cle wbr vv vx cv wral wa vw vx cv
      wral vz vx cv wral wa vx cv vy cv cdm cdm wceq wa vy cv cdm cdm vy cv cdm
      cdm cxp cr vy cv wf vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz
      cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle
      wbr vv vy cv cdm cdm wral wa vw vy cv cdm cdm wral vz vy cv cdm cdm wral
      wa vx cv vy cv cdm cdm wceq wa vx cv vx cv cxp cr vy cv wf vz cv vw cv vy
      cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv
      co vv cv vw cv vy cv co caddc co cle wbr vv vx cv wral wa vw vx cv wral
      vz vx cv wral wa vy cv cme wcel vx cv vy cv cdm cdm wceq wa vx cv vy cv
      cdm cdm wceq vx cv vx cv cxp cr vy cv wf vz cv vw cv vy cv co cc0 wceq vz
      cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy
      cv co caddc co cle wbr vv vx cv wral wa vw vx cv wral vz vx cv wral wa vy
      cv cdm cdm vy cv cdm cdm cxp cr vy cv wf vz cv vw cv vy cv co cc0 wceq vz
      cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy
      cv co caddc co cle wbr vv vy cv cdm cdm wral wa vw vy cv cdm cdm wral vz
      vy cv cdm cdm wral wa vx cv vy cv cdm cdm wceq vx cv vx cv cxp cr vy cv
      wf vy cv cdm cdm vy cv cdm cdm cxp cr vy cv wf vz cv vw cv vy cv co cc0
      wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv
      vw cv vy cv co caddc co cle wbr vv vx cv wral wa vw vx cv wral vz vx cv
      wral vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy cv
      co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr vv vy cv
      cdm cdm wral wa vw vy cv cdm cdm wral vz vy cv cdm cdm wral vx cv vy cv
      cdm cdm wceq vx cv vx cv cxp vy cv cdm cdm vy cv cdm cdm cxp wceq vx cv
      vx cv cxp cr vy cv wf vy cv cdm cdm vy cv cdm cdm cxp cr vy cv wf wb vx
      cv vy cv cdm cdm wceq vx cv vx cv cxp vy cv cdm cdm vx cv cxp vy cv cdm
      cdm vy cv cdm cdm cxp vx cv vy cv cdm cdm vx cv xpeq1 vx cv vy cv cdm cdm
      vy cv cdm cdm xpeq2 eqtrd vx cv vx cv cxp vy cv cdm cdm vy cv cdm cdm cxp
      cr vy cv feq2 syl vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv
      vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr
      vv vx cv wral wa vw vx cv wral vz cv vw cv vy cv co cc0 wceq vz cv vw cv
      wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co
      caddc co cle wbr vv vy cv cdm cdm wral wa vw vy cv cdm cdm wral vz vx cv
      vy cv cdm cdm vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw
      cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr vv
      vx cv wral wa vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw
      cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr vv
      vy cv cdm cdm wral wa vw vx cv vy cv cdm cdm vx cv vy cv cdm cdm wceq vz
      cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle
      wbr vv vx cv wral vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv
      vy cv co caddc co cle wbr vv vy cv cdm cdm wral vz cv vw cv vy cv co cc0
      wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv
      vw cv vy cv co caddc co cle wbr vv vx cv vy cv cdm cdm raleq1 anbi2d
      raleqd raleqd anbi12d pm5.32ri vx cv vx cv cxp cr vy cv wf vz cv vw cv vy
      cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv cv vz cv vy cv
      co vv cv vw cv vy cv co caddc co cle wbr vv vx cv wral wa vw vx cv wral
      vz vx cv wral wa vx cv vy cv cdm cdm wceq vx cv vx cv cxp cr vy cv wf vx
      cv vy cv cdm cdm wceq vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb
      vz cv vw cv vy cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co
      cle wbr vv vx cv wral wa vw vx cv wral vz vx cv wral vx cv vx cv cxp cr
      vy cv wf vy cv cdm vx cv vx cv cxp wceq vy cv cdm cdm vx cv vx cv cxp cdm
      wceq vx cv vy cv cdm cdm wceq vx cv vx cv cxp cr vy cv fdm vy cv cdm vx
      cv vx cv cxp dmeq vy cv cdm cdm vx cv vx cv cxp cdm wceq vy cv cdm cdm vx
      cv vy cv cdm cdm vx cv vx cv cxp cdm wceq vy cv cdm cdm vx cv wceq vx cv
      vx cv cxp cdm vx cv vy cv cdm cdm vx cv dmxpid eqeq2i biimpi eqcomd 3syl
      adantr pm4.71i vy cv cme wcel vy cv cdm cdm vy cv cdm cdm cxp cr vy cv wf
      vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy cv co vv
      cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr vv vy cv cdm cdm
      wral wa vw vy cv cdm cdm wral vz vy cv cdm cdm wral wa vx cv vy cv cdm
      cdm wceq vy cv cvv wcel vy cv cme wcel vy cv cdm cdm vy cv cdm cdm cxp cr
      vy cv wf vz cv vw cv vy cv co cc0 wceq vz cv vw cv wceq wb vz cv vw cv vy
      cv co vv cv vz cv vy cv co vv cv vw cv vy cv co caddc co cle wbr vv vy cv
      cdm cdm wral wa vw vy cv cdm cdm wral vz vy cv cdm cdm wral wa wb vy
      visset vz vw vv cvv vy cv vy cv cdm cdm vy cv cdm cdm eqid ismet ax-mp
      anbi1i 3bitr4ri opabbii eqtri $.
      $( [4-Sep-2007] $) $( [26-Aug-2007] $)
  $}

  ${
    $d v w x y z X $.  $d v w x y z D $.
    $( Express the predicate " ` <. X , D >. ` is a metric space" with
       underlying set ` X ` and distance function ` D ` . $)
    ismsg $p |- ( D e. A ->
                 ( <. X , D >. e. MetSp <-> ( D : ( X X. X ) --> RR /\
                 A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                 A. z e. X ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) ) ) ) $=
      cD cA wcel cX cD cop cmt wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv
      cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa cX cvv wcel
      cD cA wcel wa cX cD cop cmt wcel cD cA wcel cX cvv wcel cD cA wcel wa cX
      cD cop cmt wcel cX cvv wcel cD cA wcel cX cD cop cmt wcel cX cD cmt wbr
      cX cvv wcel cX cD cmt df-br cX cD cmt msrel brrelexi sylbir anim1i ancoms
      cD cA wcel cX cX cxp cr cD wf cX cvv wcel cD cA wcel wa vx cv vy cv cD co
      cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
      cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral cD cA wcel
      cX cX cxp cr cD wf wa cX cvv wcel cD cA wcel cD cA wcel cX cX cxp cr cD
      wf wa cX cX cxp cvv wcel cX cvv wcel cX cX cxp cr cA cD dmfex cX cX cxp
      cvv wcel cX cvv wcel cX cvv wcel wo cX cvv wcel cX cX cvv xpexr cX cvv
      wcel oridm sylib syl cD cA wcel cX cX cxp cr cD wf pm3.26 jca adantrr cX
      cvv wcel cD cA wcel wa cX cD cop vw cv vw cv cxp cr vv cv wf vx cv vy cv
      vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv
      cv co vz cv vy cv vv cv co caddc co cle wbr vz vw cv wral wa vy vw cv
      wral vx vw cv wral wa vw vv copab wcel cX cX cxp cr cD wf vx cv vy cv cD
      co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv
      vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa cX cD
      cop cmt wcel vw cv vw cv cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq vx
      cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv
      cv co caddc co cle wbr vz vw cv wral wa vy vw cv wral vx vw cv wral wa cX
      cX cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx
      cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle
      wbr vz cX wral wa vy cX wral vx cX wral wa cX cX cxp cr cD wf vx cv vy cv
      cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz
      cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa vw
      vv cX cD cvv cA vw cv cX wceq vw cv vw cv cxp cr vv cv wf cX cX cxp cr vv
      cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv
      co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz vw cv
      wral wa vy vw cv wral vx vw cv wral vx cv vy cv vv cv co cc0 wceq vx cv
      vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv
      co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral vw cv cX wceq vw
      cv vw cv cxp cX cX cxp wceq vw cv vw cv cxp cr vv cv wf cX cX cxp cr vv
      cv wf wb vw cv cX wceq vw cv vw cv cxp cX vw cv cxp cX cX cxp vw cv cX vw
      cv xpeq1 vw cv cX cX xpeq2 eqtrd vw cv vw cv cxp cX cX cxp cr vv cv feq2
      syl vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv
      co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz vw cv
      wral wa vy vw cv wral vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb
      vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co
      cle wbr vz cX wral wa vy cX wral vx vw cv cX vx cv vy cv vv cv co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv
      vy cv vv cv co caddc co cle wbr vz vw cv wral wa vx cv vy cv vv cv co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv
      vy cv vv cv co caddc co cle wbr vz cX wral wa vy vw cv cX vw cv cX wceq
      vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co
      cle wbr vz vw cv wral vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy
      cv vv cv co caddc co cle wbr vz cX wral vx cv vy cv vv cv co cc0 wceq vx
      cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv
      cv co caddc co cle wbr vz vw cv cX raleq1 anbi2d raleqd raleqd anbi12d vv
      cv cD wceq cX cX cxp cr vv cv wf cX cX cxp cr cD wf vx cv vy cv vv cv co
      cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz
      cv vy cv vv cv co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral vx
      cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv
      cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX
      wral cX cX cxp cr vv cv cD feq1 vv cv cD wceq vx cv vy cv vv cv co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv
      vy cv vv cv co caddc co cle wbr vz cX wral wa vx cv vy cv cD co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral wa vx vy cX cX vv cv cD wceq vx cv vy cv vv
      cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co
      caddc co cle wbr vz cX wral vx cv vy cv cD co vz cv vx cv cD co vz cv vy
      cv cD co caddc co cle wbr vz cX wral vv cv cD wceq vx cv vy cv vv cv co
      cc0 wceq vx cv vy cv cD co cc0 wceq vx cv vy cv wceq vv cv cD wceq vx cv
      vy cv vv cv co vx cv vy cv cD co cc0 vx cv vy cv vv cv cD opreq eqeq1d
      bibi1d vv cv cD wceq vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy
      cv vv cv co caddc co cle wbr vx cv vy cv cD co vz cv vx cv cD co vz cv vy
      cv cD co caddc co cle wbr vz cX vv cv cD wceq vx cv vy cv vv cv co vx cv
      vy cv cD co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co vz cv vx
      cv cD co vz cv vy cv cD co caddc co cle vx cv vy cv vv cv cD opreq vv cv
      cD wceq vz cv vx cv vv cv co vz cv vx cv cD co vz cv vy cv vv cv co vz cv
      vy cv cD co caddc vz cv vx cv vv cv cD opreq vz cv vy cv vv cv cD opreq
      opreq12d breq12d ralbidv anbi12d 2ralbidv anbi12d opelopabg cmt vw cv vw
      cv cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx
      cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle
      wbr vz vw cv wral wa vy vw cv wral vx vw cv wral wa vw vv copab cX cD cop
      vw vv vx vy vz dfms2 eleq2i syl5bb pm5.21nd $.
      $( [28-Aug-2006] $) $( [27-Aug-2006] $)
  $}

  ${
    $d x y z D $.  $d x y z X $.
    ismsi.0 $e |- D e. _V $.
    ismsi.1 $e |- D : ( X X. X ) --> RR $.
    ismsi.2 $e |- ( ( x e. X /\ y e. X ) -> ( ( x D y ) = 0 <-> x = y ) ) $.
    ismsi.3 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                  ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) $.
    ismsi.4 $e |- M = <. X , D >. $.
    $( Properties that determine a metric space. $)
    ismsi $p |- M e. MetSp $=
      cM cX cD cop cmt ismsi.4 cX cD cop cmt wcel cX cX cxp cr cD wf vx cv vy
      cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co
      vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral cD
      cvv wcel cX cD cop cmt wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa wb ismsi.0 vx vy
      vz cvv cD cX ismsg ax-mp ismsi.1 vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vx vy cX vx cv cX wcel vy cv cX wcel wa vx cv vy cv
      cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz
      cv vy cv cD co caddc co cle wbr vz cX wral ismsi.2 vx cv cX wcel vy cv cX
      wcel wa vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX vx cv cX wcel vy cv cX wcel vz cv cX wcel vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr ismsi.3 3expa
      r19.21aiva jca rgen2a mpbir2an eqeltri $.
      $( [17-Nov-2006] $) $( [17-Nov-2006] $)
  $}

  ${
    $d x y z D $.  $d x y z X $.
    ismeti.0 $e |- X e. _V $.
    ismeti.1 $e |- D : ( X X. X ) --> RR $.
    ismeti.2 $e |- ( ( x e. X /\ y e. X ) -> ( ( x D y ) = 0 <-> x = y ) ) $.
    ismeti.3 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                  ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) $.
    $( Properties that determine a metric. $)
    ismeti $p |- D e. Met $=
      cD cme wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vy cX wral vx cX wral cD cvv wcel cD cme wcel cX cX
      cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv
      cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa
      vy cX wral vx cX wral wa wb cX cX cxp cr cD wf cX cX cxp cvv wcel cD cvv
      wcel ismeti.1 cX cX ismeti.0 ismeti.0 xpex cX cX cxp cr cvv cD fex mp2an
      vx vy vz cvv cD cX cD cdm cdm cX cX cxp cdm cX cD cdm cX cX cxp cX cX cxp
      cr cD ismeti.1 fdmi dmeqi cX dmxpid eqtr2i ismet ax-mp ismeti.1 vx cv vy
      cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co
      vz cv vy cv cD co caddc co cle wbr vz cX wral wa vx vy cX vx cv cX wcel
      vy cv cX wcel wa vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy
      cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral
      ismeti.2 vx cv cX wcel vy cv cX wcel wa vx cv vy cv cD co vz cv vx cv cD
      co vz cv vy cv cD co caddc co cle wbr vz cX vx cv cX wcel vy cv cX wcel
      vz cv cX wcel vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc
      co cle wbr ismeti.3 3expa r19.21aiva jca rgen2a mpbir2an $.
      $( [5-Sep-2007] $) $( [17-Nov-2006] $)
  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.  $d v w x y z D $.  $d v w M $.
    $d v w x y z X $.  $d x y z R $.
    msf.1 $e |- X = ( 1st ` M ) $.
    msf.2 $e |- D = ( 2nd ` M ) $.
    $( Lemma for ~ msf and others. $)
    msflem $p |- ( M e. MetSp -> ( D :  ( X X. X ) --> RR /\
                  A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                  A. z e. X ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) ) ) $=
      cM cmt wcel cM vw cv vw cv cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv
      vv cv co caddc co cle wbr vz vw cv wral wa vy vw cv wral vx vw cv wral wa
      vw vv copab wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy
      cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vy cX wral vx cX wral wa cmt vw cv vw cv cxp cr vv
      cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv
      co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz vw cv
      wral wa vy vw cv wral vx vw cv wral wa vw vv copab cM vw vv vx vy vz
      dfms2 eleq2i vw cv vw cv cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq vx
      cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv
      cv co caddc co cle wbr vz vw cv wral wa vy vw cv wral vx vw cv wral wa cX
      cX cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx
      cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle
      wbr vz cX wral wa vy cX wral vx cX wral wa cX cX cxp cr cD wf vx cv vy cv
      cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz
      cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa vw
      vv cM vw cv cM c1st cfv wceq vw cv cX wceq vw cv vw cv cxp cr vv cv wf vx
      cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv
      vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz vw cv wral wa vy
      vw cv wral vx vw cv wral wa cX cX cxp cr vv cv wf vx cv vy cv vv cv co
      cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz
      cv vy cv vv cv co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa
      wb cX cM c1st cfv vw cv msf.1 eqeq2i vw cv cX wceq vw cv vw cv cxp cr vv
      cv wf cX cX cxp cr vv cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co
      caddc co cle wbr vz vw cv wral wa vy vw cv wral vx vw cv wral vx cv vy cv
      vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv
      cv co vz cv vy cv vv cv co caddc co cle wbr vz cX wral wa vy cX wral vx
      cX wral vw cv cX wceq vw cv vw cv cxp cX cX cxp wceq vw cv vw cv cxp cr
      vv cv wf cX cX cxp cr vv cv wf wb vw cv cX wceq vw cv vw cv cxp cX vw cv
      cxp cX cX cxp vw cv cX vw cv xpeq1 vw cv cX cX xpeq2 eqtrd vw cv vw cv
      cxp cX cX cxp cr vv cv feq2 syl vx cv vy cv vv cv co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv vv cv co
      caddc co cle wbr vz vw cv wral wa vy vw cv wral vx cv vy cv vv cv co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv
      vy cv vv cv co caddc co cle wbr vz cX wral wa vy cX wral vx vw cv cX vx
      cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv
      vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz vw cv wral wa vx
      cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv
      vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz cX wral wa vy vw
      cv cX vw cv cX wceq vx cv vy cv vv cv co vz cv vx cv vv cv co vz cv vy cv
      vv cv co caddc co cle wbr vz vw cv wral vx cv vy cv vv cv co vz cv vx cv
      vv cv co vz cv vy cv vv cv co caddc co cle wbr vz cX wral vx cv vy cv vv
      cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv cv
      co vz cv vy cv vv cv co caddc co cle wbr vz vw cv cX raleq1 anbi2d raleqd
      raleqd anbi12d sylbir vv cv cM c2nd cfv wceq vv cv cD wceq cX cX cxp cr
      vv cv wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv
      cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz cX
      wral wa vy cX wral vx cX wral wa cX cX cxp cr cD wf vx cv vy cv cD co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv
      cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa wb cD cM
      c2nd cfv vv cv msf.2 eqeq2i vv cv cD wceq cX cX cxp cr vv cv wf cX cX cxp
      cr cD wf vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv
      cv co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz cX
      wral wa vy cX wral vx cX wral vx cv vy cv cD co cc0 wceq vx cv vy cv wceq
      wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr
      vz cX wral wa vy cX wral vx cX wral cX cX cxp cr vv cv cD feq1 vv cv cD
      wceq vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv
      co vz cv vx cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vz cX wral
      wa vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv
      vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vx vy cX cX
      vv cv cD wceq vx cv vy cv vv cv co cc0 wceq vx cv vy cv wceq wb vx cv vy
      cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv vv cv co vz cv vx cv vv
      cv co vz cv vy cv vv cv co caddc co cle wbr vz cX wral vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral vv cv cD
      wceq vx cv vy cv vv cv co cc0 wceq vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq vv cv cD wceq vx cv vy cv vv cv co vx cv vy cv cD co cc0 vx cv vy cv
      vv cv cD opreq eqeq1d bibi1d vv cv cD wceq vx cv vy cv vv cv co vz cv vx
      cv vv cv co vz cv vy cv vv cv co caddc co cle wbr vx cv vy cv cD co vz cv
      vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX vv cv cD wceq vx cv
      vy cv vv cv co vx cv vy cv cD co vz cv vx cv vv cv co vz cv vy cv vv cv
      co caddc co vz cv vx cv cD co vz cv vy cv cD co caddc co cle vx cv vy cv
      vv cv cD opreq vv cv cD wceq vz cv vx cv vv cv co vz cv vx cv cD co vz cv
      vy cv vv cv co vz cv vy cv cD co caddc vz cv vx cv vv cv cD opreq vz cv
      vy cv vv cv cD opreq opreq12d breq12d ralbidv anbi12d 2ralbidv anbi12d
      sylbir elopabi sylbi $.
      $( [4-Sep-2006] $) $( [30-Aug-2006] $)

    $( Mapping of the distance function of a metric space. $)
    msf $p |- ( M e. MetSp -> D : ( X X. X ) --> RR ) $=
      cM cmt wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vy cX wral vx cX wral vx vy vz cD cM cX msf.1 msf.2
      msflem pm3.26d $.
      $( [4-Sep-2006] $) $( [30-Aug-2006] $)

    $( Closure of the distance function of a metric space. $)
    mscl $p |- ( ( M e. MetSp /\ A e. X /\ B e. X ) -> ( A D B ) e. RR ) $=
      cX cX cxp cr cD wf cA cX wcel cB cX wcel cA cB cD co cr wcel cM cmt wcel
      cA cB cr cX cX cD foprrn cD cM cX msf.1 msf.2 msf syl3an1 $.
      $( [4-Sep-2006] $) $( [30-Aug-2006] $)
  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.  $d x y z D $.  $d x y z X $.
    metf.1 $e |- X = dom dom D $.
    $( Lemma for ~ metf and others. $)
    metflem $p |- ( D e. Met -> ( D : ( X X. X ) --> RR /\
                  A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                  A. z e. X ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) ) ) $=
      cD cme wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vy cX wral vx cX wral wa vx vy vz cme cD cX metf.1
      ismet ibi $.
      $( [4-Sep-2007] $) $( [30-Aug-2006] $)

    $( Mapping of the distance function of a metric space. $)
    metf $p |- ( D e. Met -> D : ( X X. X ) --> RR ) $=
      cD cme wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vy cX wral vx cX wral vx vy vz cD cX metf.1 metflem
      pm3.26d $.
      $( [4-Sep-2007] $) $( [30-Aug-2006] $)

    $( The base set of a metric space in terms of its distance function. $)
    metdmdm $p |- ( D e. Met -> X = dom dom D ) $=
      cX cD cdm cdm wceq cD cme wcel metf.1 a1i $.
      $( [3-Apr-2008] $) $( [29-May-2007] $)

    $( The base set of a metric subspace. $)
    metssba $p |- ( D e. Met -> ( X i^i Y ) = dom dom ( D |` ( Y X. Y ) ) ) $=
      cD cme wcel cD cY cY cxp cres cdm cdm cY cY cxp cX cX cxp cin cdm cX cY
      cin cD cme wcel cD cY cY cxp cres cdm cY cY cxp cX cX cxp cin cD cme wcel
      cY cY cxp cD cdm cin cY cY cxp cX cX cxp cin cD cY cY cxp cres cdm cD cme
      wcel cD cdm cX cX cxp cY cY cxp cD cme wcel cX cX cxp cr cD wf cD cdm cX
      cX cxp wceq cD cX metf.1 metf cX cX cxp cr cD fdm syl ineq2d cD cY cY cxp
      dmres syl5eq dmeqd cY cY cxp cX cX cxp cin cdm cY cX cin cX cY cin cY cX
      dmxpin cY cX incom eqtri syl6req $.
      $( [7-Feb-2008] $) $( [30-Jan-2008] $)

    $( The base set of a metric subspace. $)
    metssba2 $p |- ( ( D e. Met /\ Y C_ X ) ->
                 Y = dom dom ( D |` ( Y X. Y ) ) ) $=
      cY cX wss cD cme wcel cY cX cY cin cD cY cY cxp cres cdm cdm cY cX wss cY
      cY cX cin cX cY cin cY cX wss cY cY cX cin wceq cY cX dfss biimpi cY cX
      incom syl6eq cD cX cY metf.1 metssba sylan9eqr $.
      $( [21-Mar-2008] $) $( [31-Jan-2008] $)

    $( Closure of the distance function of a metric space.  Part of Property
       M1 of [Kreyszig] p. 3. $)
    metcl $p |- ( ( D e. Met /\ A e. X /\ B e. X ) -> ( A D B ) e. RR ) $=
      cX cX cxp cr cD wf cA cX wcel cB cX wcel cA cB cD co cr wcel cD cme wcel
      cA cB cr cX cX cD foprrn cD cX metf.1 metf syl3an1 $.
      $( [5-Sep-2007] $) $( [30-Aug-2006] $)

    $( The value of a metric is zero iff its arguments are equal.  Property
       M2 of [Kreyszig] p. 4. $)
    meteq0 $p |- ( ( D e. Met /\ A e. X /\ B e. X )
                 -> ( ( A D B ) = 0 <-> A = B ) ) $=
      cD cme wcel cA cX wcel cB cX wcel cA cB cD co cc0 wceq cA cB wceq wb cD
      cme wcel vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX
      wral vx cX wral vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vy cX wral
      vx cX wral cA cX wcel cB cX wcel wa cA cB cD co cc0 wceq cA cB wceq wb wi
      cD cme wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral wa vy cX wral vx cX wral vx vy vz cD cX metf.1 metflem
      pm3.27d vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX
      wral vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vy cX wral vx cX vx
      cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv
      cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vx cv vy cv cD co
      cc0 wceq vx cv vy cv wceq wb vy cX vx cv vy cv cD co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
      cle wbr vz cX wral pm3.26 r19.20si r19.20si cA cX wcel cB cX wcel wa vx
      cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vy cX wral vx cX wral cA cB
      cD co cc0 wceq cA cB wceq wb vx cv vy cv cD co cc0 wceq vx cv vy cv wceq
      wb cA cB cD co cc0 wceq cA cB wceq wb cA vy cv cD co cc0 wceq cA vy cv
      wceq wb vx vy cA cB cX cX vx cv cA wceq vx cv vy cv cD co cc0 wceq cA vy
      cv cD co cc0 wceq vx cv vy cv wceq cA vy cv wceq vx cv cA wceq vx cv vy
      cv cD co cA vy cv cD co cc0 vx cv cA vy cv cD opreq1 eqeq1d vx cv cA vy
      cv eqeq1 bibi12d vy cv cB wceq cA vy cv cD co cc0 wceq cA cB cD co cc0
      wceq cA vy cv wceq cA cB wceq vy cv cB wceq cA vy cv cD co cA cB cD co
      cc0 vy cv cB cA cD opreq2 eqeq1d vy cv cB cA eqeq2 bibi12d rcla42v com12
      3syl 3impib $.
      $( [5-Sep-2007] $) $( [30-Aug-2006] $)

    $( Triangle inequality for the distance function of a metric space. $)
    mettri2 $p |- ( ( D e. Met /\ ( C e. X /\ A e. X /\ B e. X ) )
                 -> ( A D B ) <_ ( ( C D A ) + ( C D B ) ) ) $=
      cC cX wcel cA cX wcel cB cX wcel w3a cD cme wcel cA cB cD co cC cA cD co
      cC cB cD co caddc co cle wbr cA cX wcel cB cX wcel cC cX wcel cD cme wcel
      cA cB cD co cC cA cD co cC cB cD co caddc co cle wbr wi cA cX wcel cB cX
      wcel cC cX wcel w3a vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral vy cX wral vx cX wral cA cB cD co cC cA cD co
      cC cB cD co caddc co cle wbr cD cme wcel vx cv vy cv cD co vz cv vx cv cD
      co vz cv vy cv cD co caddc co cle wbr cA cB cD co cC cA cD co cC cB cD co
      caddc co cle wbr cA vy cv cD co vz cv cA cD co vz cv vy cv cD co caddc co
      cle wbr cA cB cD co vz cv cA cD co vz cv cB cD co caddc co cle wbr vx vy
      vz cA cB cC cX cX cX vx cv cA wceq vx cv vy cv cD co cA vy cv cD co vz cv
      vx cv cD co vz cv vy cv cD co caddc co vz cv cA cD co vz cv vy cv cD co
      caddc co cle vx cv cA vy cv cD opreq1 vx cv cA wceq vz cv vx cv cD co vz
      cv cA cD co vz cv vy cv cD co caddc vx cv cA vz cv cD opreq2 opreq1d
      breq12d vy cv cB wceq cA vy cv cD co cA cB cD co vz cv cA cD co vz cv vy
      cv cD co caddc co vz cv cA cD co vz cv cB cD co caddc co cle vy cv cB cA
      cD opreq2 vy cv cB wceq vz cv vy cv cD co vz cv cB cD co vz cv cA cD co
      caddc vy cv cB vz cv cD opreq2 opreq2d breq12d vz cv cC wceq vz cv cA cD
      co vz cv cB cD co caddc co cC cA cD co cC cB cD co caddc co cA cB cD co
      cle vz cv cC wceq vz cv cA cD co cC cA cD co vz cv cB cD co cC cB cD co
      caddc vz cv cC cA cD opreq1 vz cv cC cB cD opreq1 opreq12d breq2d rcla43v
      cD cme wcel vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD
      co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy
      cX wral vx cX wral vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral vy cX wral vx cX wral cD cme wcel cX cX cxp
      cr cD wf vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX
      wral vx cX wral vx vy vz cD cX metf.1 metflem pm3.27d vx cv vy cv cD co
      cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
      cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cv vy cv cD co vz
      cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral vy cX wral
      vx cX vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz
      cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vx cv vy
      cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral
      vy cX vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz
      cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral pm3.27
      r19.20si r19.20si syl syl5 3comr impcom $.
      $( [16-Sep-2007] $) $( [30-Aug-2006] $)

    $( MAY BE REVISED - replace with mettri2 everywhere; make obsolete $)
    $( Triangle inequality for the distance function of a metric space. $)
    mettri4 $p |- ( ( ( D e. Met /\ A e. X ) /\ ( B e. X /\ C e. X ) )
                 -> ( A D B ) <_ ( ( C D A ) + ( C D B ) ) ) $=
      cD cme wcel cA cX wcel cB cX wcel cC cX wcel wa cA cB cD co cC cA cD co
      cC cB cD co caddc co cle wbr cA cX wcel cB cX wcel cC cX wcel wa cD cme
      wcel cA cB cD co cC cA cD co cC cB cD co caddc co cle wbr cA cX wcel cB
      cX wcel cC cX wcel cD cme wcel cA cB cD co cC cA cD co cC cB cD co caddc
      co cle wbr wi cA cX wcel cB cX wcel cC cX wcel w3a vx cv vy cv cD co vz
      cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral vy cX wral
      vx cX wral cA cB cD co cC cA cD co cC cB cD co caddc co cle wbr cD cme
      wcel vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle
      wbr cA cB cD co cC cA cD co cC cB cD co caddc co cle wbr cA vy cv cD co
      vz cv cA cD co vz cv vy cv cD co caddc co cle wbr cA cB cD co vz cv cA cD
      co vz cv cB cD co caddc co cle wbr vx vy vz cA cB cC cX cX cX vx cv cA
      wceq vx cv vy cv cD co cA vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co vz cv cA cD co vz cv vy cv cD co caddc co cle vx cv cA vy cv cD
      opreq1 vx cv cA wceq vz cv vx cv cD co vz cv cA cD co vz cv vy cv cD co
      caddc vx cv cA vz cv cD opreq2 opreq1d breq12d vy cv cB wceq cA vy cv cD
      co cA cB cD co vz cv cA cD co vz cv vy cv cD co caddc co vz cv cA cD co
      vz cv cB cD co caddc co cle vy cv cB cA cD opreq2 vy cv cB wceq vz cv vy
      cv cD co vz cv cB cD co vz cv cA cD co caddc vy cv cB vz cv cD opreq2
      opreq2d breq12d vz cv cC wceq vz cv cA cD co vz cv cB cD co caddc co cC
      cA cD co cC cB cD co caddc co cA cB cD co cle vz cv cC wceq vz cv cA cD
      co cC cA cD co vz cv cB cD co cC cB cD co caddc vz cv cC cA cD opreq1 vz
      cv cC cB cD opreq1 opreq12d breq2d rcla43v cD cme wcel vx cv vy cv cD co
      cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
      cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral vx cv vy cv
      cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral vy
      cX wral vx cX wral cD cme wcel cX cX cxp cr cD wf vx cv vy cv cD co cc0
      wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv
      cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral vx vy vz cD cX
      metf.1 metflem pm3.27d vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx
      cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX
      wral wa vy cX wral vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral vy cX wral vx cX vx cv vy cv cD co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral wa vx cv vy cv cD co vz cv vx cv cD co vz cv
      vy cv cD co caddc co cle wbr vz cX wral vy cX vx cv vy cv cD co cc0 wceq
      vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
      caddc co cle wbr vz cX wral pm3.27 r19.20si r19.20si syl syl5 3expib
      com3r imp31 $.
      $( [15-Sep-2007] $) $( [30-Aug-2006] $)

    $( The distance function of a metric space is zero if its arguments
       are equal.  Definition 14-1.1(a) of [Gleason] p. 223. $)
    met0 $p |- ( ( D e. Met /\ A e. X ) -> ( A D A ) = 0 ) $=
      cD cme wcel cA cX wcel wa cA cA cD co cc0 wceq cA cA wceq cA eqid cD cme
      wcel cA cX wcel cA cA cD co cc0 wceq cA cA wceq wb cA cA cD cX metf.1
      meteq0 3anidm23 mpbiri $.
      $( [7-Sep-2007] $) $( [30-Aug-2006] $)

    $( The distance function of a metric space is symmetric.  Definition
       14-1.1(c) of [Gleason] p. 223. $)
    metsym $p |- ( ( D e. Met /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( B D A ) ) $=
      cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co cB cA cD co wceq cA cB
      cD co cB cA cD co cle wbr cB cA cD co cA cB cD co cle wbr wa cD cme wcel
      cA cX wcel cB cX wcel w3a cA cB cD co cB cA cD co cle wbr cB cA cD co cA
      cB cD co cle wbr cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co cB cA
      cD co cB cB cD co caddc co cB cA cD co cle cD cme wcel cA cX wcel cB cX
      wcel cA cB cD co cB cA cD co cB cB cD co caddc co cle wbr cD cme wcel cA
      cX wcel wa cB cX wcel cA cB cD co cB cA cD co cB cB cD co caddc co cle
      wbr cA cB cB cD cX metf.1 mettri4 anabsan2 3impa cD cme wcel cA cX wcel
      cB cX wcel w3a cB cA cD co cB cB cD co caddc co cB cA cD co cc0 caddc co
      cB cA cD co cD cme wcel cA cX wcel cB cX wcel w3a cB cB cD co cc0 cB cA
      cD co caddc cD cme wcel cB cX wcel cB cB cD co cc0 wceq cA cX wcel cB cD
      cX metf.1 met0 3adant2 opreq2d cD cme wcel cB cX wcel cA cX wcel cB cA cD
      co cc0 caddc co cB cA cD co wceq cD cme wcel cB cX wcel cA cX wcel w3a cB
      cA cD co cc wcel cB cA cD co cc0 caddc co cB cA cD co wceq cD cme wcel cB
      cX wcel cA cX wcel w3a cB cA cD co cB cA cD cX metf.1 metcl recnd cB cA
      cD co addid1 syl 3com23 eqtrd breqtrd cD cme wcel cA cX wcel cB cX wcel
      w3a cB cA cD co cA cB cD co cA cA cD co caddc co cA cB cD co cle cD cme
      wcel cB cX wcel cA cX wcel cB cA cD co cA cB cD co cA cA cD co caddc co
      cle wbr cD cme wcel cB cX wcel cA cX wcel cB cA cD co cA cB cD co cA cA
      cD co caddc co cle wbr cD cme wcel cB cX wcel wa cA cX wcel cB cA cD co
      cA cB cD co cA cA cD co caddc co cle wbr cB cA cA cD cX metf.1 mettri4
      anabsan2 3impa 3com23 cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co
      cA cA cD co caddc co cA cB cD co cc0 caddc co cA cB cD co cD cme wcel cA
      cX wcel cB cX wcel w3a cA cA cD co cc0 cA cB cD co caddc cD cme wcel cA
      cX wcel cA cA cD co cc0 wceq cB cX wcel cA cD cX metf.1 met0 3adant3
      opreq2d cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co cc wcel cA cB
      cD co cc0 caddc co cA cB cD co wceq cD cme wcel cA cX wcel cB cX wcel w3a
      cA cB cD co cA cB cD cX metf.1 metcl recnd cA cB cD co addid1 syl eqtrd
      breqtrd jca cA cB cD co cr wcel cB cA cD co cr wcel cA cB cD co cB cA cD
      co wceq cA cB cD co cB cA cD co cle wbr cB cA cD co cA cB cD co cle wbr
      wa wb cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co cB cA cD co
      letri3 cA cB cD cX metf.1 metcl cD cme wcel cB cX wcel cA cX wcel cB cA
      cD co cr wcel cB cA cD cX metf.1 metcl 3com23 sylanc mpbird $.
      $( [18-Sep-2007] $) $( [27-Aug-2006] $)

    $( Triangle inequality for the distance function of a metric space.
       Definition 14-1.1(d) of [Gleason] p. 223. $)
    mettri $p |- ( ( D e. Met /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) + ( C D B ) ) ) $=
      cD cme wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cD co cC cA cD
      co cC cB cD co caddc co cA cC cD co cC cB cD co caddc co cle cA cX wcel
      cB cX wcel cC cX wcel w3a cD cme wcel cA cB cD co cC cA cD co cC cB cD co
      caddc co cle wbr cC cX wcel cA cX wcel cB cX wcel cD cme wcel cA cB cD co
      cC cA cD co cC cB cD co caddc co cle wbr wi cD cme wcel cC cX wcel cA cX
      wcel cB cX wcel w3a cA cB cD co cC cA cD co cC cB cD co caddc co cle wbr
      cA cB cC cD cX metf.1 mettri2 expcom 3coml impcom cD cme wcel cA cX wcel
      cB cX wcel cC cX wcel w3a wa cA cC cD co cC cA cD co cC cB cD co caddc cD
      cme wcel cA cX wcel cC cX wcel cA cC cD co cC cA cD co wceq cB cX wcel cA
      cC cD cX metf.1 metsym 3adant3r2 opreq1d breqtrrd $.
      $( [12-Nov-2007] $) $( [27-Aug-2006] $)

    $( Triangle inequality for the distance function of a metric space. $)
    mettri3 $p |- ( ( D e. Met /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) + ( B D C ) ) ) $=
      cD cme wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cD co cA cC cD
      co cC cB cD co caddc co cA cC cD co cB cC cD co caddc co cle cA cB cC cD
      cX metf.1 mettri cD cme wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cB
      cC cD co cC cB cD co cA cC cD co caddc cD cme wcel cB cX wcel cC cX wcel
      cB cC cD co cC cB cD co wceq cA cX wcel cB cC cD cX metf.1 metsym
      3adant3r1 opreq2d breqtrrd $.
      $( [29-Jan-2008] $) $( [13-Mar-2007] $)

    $( The distance function of a metric space is nonnegative. $)
    metge0 $p |- ( ( D e. Met /\ A e. X /\ B e. X ) ->
                  0 <_ ( A D B ) ) $=
      cA cB cD co cr wcel cc0 c2 cA cB cD co cmul co cle wbr cc0 cA cB cD co
      cle wbr cD cme wcel cA cX wcel cB cX wcel w3a c2 cr wcel cA cB cD co cr
      wcel cc0 c2 cA cB cD co cmul co cle wbr cc0 cA cB cD co cle wbr 2re c2 cr
      wcel cA cB cD co cr wcel wa cc0 c2 clt wbr cc0 c2 cA cB cD co cmul co cle
      wbr cc0 cA cB cD co cle wbr 2pos c2 cA cB cD co prodge0 mpanr1 mpanl1 cA
      cB cD cX metf.1 metcl cD cme wcel cA cX wcel cB cX wcel w3a cB cB cD co
      cA cB cD co cA cB cD co caddc co cc0 c2 cA cB cD co cmul co cle cD cme
      wcel cA cX wcel cB cX wcel cB cB cD co cA cB cD co cA cB cD co caddc co
      cle wbr cD cme wcel cB cX wcel cA cX wcel cB cB cD co cA cB cD co cA cB
      cD co caddc co cle wbr cD cme wcel cB cX wcel cA cX wcel cB cB cD co cA
      cB cD co cA cB cD co caddc co cle wbr wi cD cme wcel cB cX wcel cB cX
      wcel cA cX wcel cB cB cD co cA cB cD co cA cB cD co caddc co cle wbr cB
      cB cA cD cX metf.1 mettri4 exp43 pm2.43d com23 3imp cD cme wcel cB cX
      wcel cB cB cD co cc0 wceq cA cX wcel cB cD cX metf.1 met0 3adant2 cD cme
      wcel cA cX wcel cB cX wcel w3a c2 cA cB cD co cmul co cA cB cD co cA cB
      cD co caddc co cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co cc wcel
      c2 cA cB cD co cmul co cA cB cD co cA cB cD co caddc co wceq cD cme wcel
      cA cX wcel cB cX wcel w3a cA cB cD co cA cB cD cX metf.1 metcl recnd cA
      cB cD co 2times syl eqcomd 3brtr3d sylanc $.
      $( [26-Sep-2007] $) $( [27-Aug-2006] $)

    $( The distance function of a metric space is positive for unequal
       points.  Definition 14-1.1(b) of [Gleason] p. 223 and its converse. $)
    metgt0 $p |- ( ( D e. Met /\ A e. X /\ B e. X ) ->
                ( A =/= B <-> 0 < ( A D B ) ) ) $=
      cD cme wcel cA cX wcel cB cX wcel w3a cc0 cA cB cD co clt wbr cc0 cA cB
      cD co cle wbr cA cB cD co cc0 wne wa cA cB cD co cc0 wne cA cB wne cc0 cr
      wcel cA cB cD co cr wcel cc0 cA cB cD co clt wbr cc0 cA cB cD co cle wbr
      cA cB cD co cc0 wne wa wb cD cme wcel cA cX wcel cB cX wcel w3a cc0 cA cB
      cD co ltlen 0re cA cB cD cX metf.1 metcl sylancr cD cme wcel cA cX wcel
      cB cX wcel w3a cc0 cA cB cD co cle wbr cA cB cD co cc0 wne cA cB cD cX
      metf.1 metge0 biantrurd cD cme wcel cA cX wcel cB cX wcel w3a cA cB cD co
      cc0 cA cB cA cB cD cX metf.1 meteq0 necon3bid 3bitr2rd $.
      $( [5-Oct-2007] $) $( [27-Aug-2006] $)

    $( A metric space is nonempty iff its base set is nonempty. $)
    metn0 $p |- ( D e. Met -> ( D =/= (/) <-> X =/= (/) ) ) $=
      cD cme wcel cD c0 cX c0 cD cme wcel cD c0 wceq cD cdm cdm c0 wceq cX c0
      wceq cD cme wcel cD c0 wceq cD cdm c0 wceq cD cdm cdm c0 wceq cD cme wcel
      cX cX cxp cr cD wf cD wrel cD c0 wceq cD cdm c0 wceq wb cD cX metf.1 metf
      cX cX cxp cr cD frel cD reldm0 3syl cD cme wcel cX cX cxp cr cD wf cD cdm
      wrel cD cdm c0 wceq cD cdm cdm c0 wceq wb cD cX metf.1 metf cX cX cxp cr
      cD wf cD cdm cX cX cxp wceq cD cdm wrel cX cX cxp cr cD fdm cD cdm cX cX
      cxp wceq cD cdm wrel cX cX cxp wrel cX cX relxp cD cdm cX cX cxp releq
      mpbiri syl cD cdm reldm0 3syl bitrd cX cD cdm cdm c0 metf.1 eqeq1i
      syl6bbr necon3bid $.
      $( [22-Jun-2008] $) $( [4-Oct-2007] $)

    ${
      $d x y z R $.
      metreslem.2 $e |- A = dom dom ( D |` ( R X. R ) ) $.
      $( Lemma for ~ metres .  (Contributed by FL, 10-Nov-2006.) $)
      metreslem $p |- ( ( D e. Met /\ R C_ X ) ->
                     ( D |` ( R X. R ) ) e. Met ) $=
        cD cme wcel cR cX wss wa cD cR cR cxp cres cme wcel cR cR cxp cr cD cR
        cR cxp cres wf vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv
        wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres
        co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cR wral wa vy
        cR wral vx cR wral wa cX cX cxp cr cD wf vx cv vy cv cD co cc0 wceq vx
        cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co
        caddc co cle wbr vz cX wral wa vy cX wral vx cX wral wa cR cX wss cR cR
        cxp cr cD cR cR cxp cres wf vx cv vy cv cD cR cR cxp cres co cc0 wceq
        vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR
        cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cR
        wral wa vy cR wral vx cR wral wa cD cme wcel cX cX cxp cr cD wf vx cv
        vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv
        cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX
        wral cR cX wss cR cR cxp cr cD cR cR cxp cres wf vx cv vy cv cD cR cR
        cxp cres co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres
        co vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co
        caddc co cle wbr vz cR wral wa vy cR wral vx cR wral wa cX cX cxp cr cD
        wf cR cX wss wa cR cR cxp cr cD cR cR cxp cres wf vx cv vy cv cD co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
        cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral cR cX wss
        wa vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb vx cv
        vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv
        cD cR cR cxp cres co caddc co cle wbr vz cR wral wa vy cR wral vx cR
        wral cX cX cxp cr cD wf cR cR cxp cX cX cxp wss cR cR cxp cr cD cR cR
        cxp cres wf cR cX wss cX cX cxp cr cR cR cxp cD fssres cR cX wss cR cR
        cxp cX cX cxp wss cR cX cR cX ssxp anidms sylan2 cR cX wss vx cv vy cv
        cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co
        vz cv vy cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cX wral
        vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb vx cv vy
        cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD
        cR cR cxp cres co caddc co cle wbr vz cR wral wa vy cR wral vx cR wral
        cR cX wss vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD
        co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX wral wa
        vy cX wral vx cX wral vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx
        cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz
        cR wral wa vy cR wral vx cR wral vx cv vy cv cD cR cR cxp cres co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv
        cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr
        vz cR wral wa vy cR wral vx cR wral cR cX wss vx cv vy cv cD co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
        cv cD co caddc co cle wbr vz cX wral wa vy cX wral vx cv vy cv cD co
        cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv
        vy cv cD co caddc co cle wbr vz cR wral wa vy cR wral vx cX cR cR cX
        wss vx cv cR wcel vx cv cX wcel vx cv vy cv cD co cc0 wceq vx cv vy cv
        wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
        cle wbr vz cX wral wa vy cX wral vx cv vy cv cD co cc0 wceq vx cv vy cv
        wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co
        cle wbr vz cR wral wa vy cR wral cR cX vx cv ssel cR cX wss vx cv vy cv
        cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co
        vz cv vy cv cD co caddc co cle wbr vz cX wral wa vx cv vy cv cD co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
        cv cD co caddc co cle wbr vz cR wral wa vy cX cR cR cX wss vy cv cR
        wcel vy cv cX wcel vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv
        vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cX
        wral wa vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD
        co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cR wral wa
        cR cX vy cv ssel cR cX wss vx cv vy cv cD co vz cv vx cv cD co vz cv vy
        cv cD co caddc co cle wbr vz cX wral vx cv vy cv cD co vz cv vx cv cD
        co vz cv vy cv cD co caddc co cle wbr vz cR wral vx cv vy cv cD co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD co vz cv vx cv cD co vz cv vy
        cv cD co caddc co cle wbr vz cR cX ssralv anim2d imim12d r19.20dv2
        imim12d r19.20dv2 vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv
        wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres
        co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cR wral wa vy
        cR wral vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD
        co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cR wral wa
        vy cR wral vx cR vx cv cR wcel vx cv vy cv cD cR cR cxp cres co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv
        cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr
        vz cR wral wa vx cv vy cv cD co cc0 wceq vx cv vy cv wceq wb vx cv vy
        cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cR
        wral wa vy cR vx cv cR wcel vy cv cR wcel wa vx cv vy cv cD cR cR cxp
        cres co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD co cc0 wceq vx cv
        vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp
        cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cR wral vx
        cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz
        cR wral vx cv cR wcel vy cv cR wcel wa vx cv vy cv cD cR cR cxp cres co
        cc0 wceq vx cv vy cv cD co cc0 wceq vx cv vy cv wceq vx cv cR wcel vy
        cv cR wcel wa vx cv vy cv cD cR cR cxp cres co vx cv vy cv cD co cc0 vx
        cv vy cv cR cR cD oprvres eqeq1d bibi1d vx cv cR wcel vy cv cR wcel wa
        vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv
        vy cv cD cR cR cxp cres co caddc co cle wbr vx cv vy cv cD co vz cv vx
        cv cD co vz cv vy cv cD co caddc co cle wbr vz cR vz cv cR wcel vx cv
        cR wcel vy cv cR wcel wa vx cv vy cv cD cR cR cxp cres co vz cv vx cv
        cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr
        vx cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr
        wb vz cv cR wcel vx cv cR wcel vy cv cR wcel wa wa vx cv vy cv cD cR cR
        cxp cres co vx cv vy cv cD co vz cv vx cv cD cR cR cxp cres co vz cv vy
        cv cD cR cR cxp cres co caddc co vz cv vx cv cD co vz cv vy cv cD co
        caddc co cle vx cv cR wcel vy cv cR wcel wa vx cv vy cv cD cR cR cxp
        cres co vx cv vy cv cD co wceq vz cv cR wcel vx cv vy cv cR cR cD
        oprvres adantl vz cv cR wcel vx cv cR wcel vy cv cR wcel vz cv vx cv cD
        cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co vz cv vx cv
        cD co vz cv vy cv cD co caddc co wceq vz cv cR wcel vx cv cR wcel wa vz
        cv cR wcel vy cv cR wcel wa vz cv vx cv cD cR cR cxp cres co vz cv vx
        cv cD co vz cv vy cv cD cR cR cxp cres co vz cv vy cv cD co caddc vz cv
        vx cv cR cR cD oprvres vz cv vy cv cR cR cD oprvres opreqan12d anandis
        breq12d ancoms ralbidva anbi12d ralbidva ralbiia syl6ibr impcom anim12i
        anandirs vx vy vz cD cX metf.1 metflem sylan cD cme wcel cR cX wss wa
        cD cR cR cxp cres cme wcel cA cA cxp cr cD cR cR cxp cres wf vx cv vy
        cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD cR
        cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD cR cR
        cxp cres co caddc co cle wbr vz cA wral wa vy cA wral vx cA wral wa cR
        cR cxp cr cD cR cR cxp cres wf vx cv vy cv cD cR cR cxp cres co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv
        cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr
        vz cR wral wa vy cR wral vx cR wral wa cD cme wcel cR cX wss wa cD cR
        cR cxp cres cvv wcel cD cR cR cxp cres cme wcel cA cA cxp cr cD cR cR
        cxp cres wf vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq
        wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz
        cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cA wral wa vy cA wral
        vx cA wral wa wb cD cme wcel cD cR cR cxp cres cvv wcel cR cX wss cD cR
        cR cxp cme resexg adantr vx vy vz cvv cD cR cR cxp cres cA metreslem.2
        ismet syl cD cme wcel cR cX wss wa cA cR wceq cA cA cxp cr cD cR cR cxp
        cres wf vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb
        vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv
        vy cv cD cR cR cxp cres co caddc co cle wbr vz cA wral wa vy cA wral vx
        cA wral wa cR cR cxp cr cD cR cR cxp cres wf vx cv vy cv cD cR cR cxp
        cres co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres co
        vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc
        co cle wbr vz cR wral wa vy cR wral vx cR wral wa wb cD cme wcel cR cX
        wss wa cD cR cR cxp cres cdm cdm cR cA cX cX cxp cr cD wf cR cX wss cD
        cR cR cxp cres cdm cdm cR wceq cD cme wcel cX cX cxp cr cD wf cR cX wss
        wa cD cR cR cxp cres cdm cdm cR cR cxp cdm cR cX cX cxp cr cD wf cR cX
        wss wa cD cR cR cxp cres cdm cR cR cxp cX cX cxp cr cD wf cR cX wss wa
        cR cR cxp cD cdm wss cD cR cR cxp cres cdm cR cR cxp wceq cX cX cxp cr
        cD wf cR cX wss wa cR cR cxp cX cX cxp cD cdm cR cX wss cR cR cxp cX cX
        cxp wss cX cX cxp cr cD wf cR cX wss cR cR cxp cX cX cxp wss cR cX cR
        cX ssxp anidms adantl cX cX cxp cr cD wf cD cdm cX cX cxp wceq cR cX
        wss cX cX cxp cr cD fdm adantr sseqtr4d cR cR cxp cD ssdmres sylib
        dmeqd cR dmxpid syl6eq cD cX metf.1 metf sylan metreslem.2 syl5eq cA cR
        wceq cA cA cxp cr cD cR cR cxp cres wf cR cR cxp cr cD cR cR cxp cres
        wf vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb vx cv
        vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv
        cD cR cR cxp cres co caddc co cle wbr vz cA wral wa vy cA wral vx cA
        wral vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb vx
        cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy
        cv cD cR cR cxp cres co caddc co cle wbr vz cR wral wa vy cR wral vx cR
        wral cA cR wceq cA cA cxp cR cR cxp wceq cA cA cxp cr cD cR cR cxp cres
        wf cR cR cxp cr cD cR cR cxp cres wf wb cA cR wceq cA cA cxp cR cA cxp
        cR cR cxp cA cR cA xpeq1 cA cR cR xpeq2 eqtrd cA cA cxp cR cR cxp cr cD
        cR cR cxp cres feq2 syl vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv
        vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp
        cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cA wral wa
        vy cA wral vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq
        wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz
        cv vy cv cD cR cR cxp cres co caddc co cle wbr vz cR wral wa vy cR wral
        vx cA cR vx cv vy cv cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb
        vx cv vy cv cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv
        vy cv cD cR cR cxp cres co caddc co cle wbr vz cA wral wa vx cv vy cv
        cD cR cR cxp cres co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR
        cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD cR cR cxp
        cres co caddc co cle wbr vz cR wral wa vy cA cR cA cR wceq vx cv vy cv
        cD cR cR cxp cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD cR
        cR cxp cres co caddc co cle wbr vz cA wral vx cv vy cv cD cR cR cxp
        cres co vz cv vx cv cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres
        co caddc co cle wbr vz cR wral vx cv vy cv cD cR cR cxp cres co cc0
        wceq vx cv vy cv wceq wb vx cv vy cv cD cR cR cxp cres co vz cv vx cv
        cD cR cR cxp cres co vz cv vy cv cD cR cR cxp cres co caddc co cle wbr
        vz cA cR raleq1 anbi2d raleqd raleqd anbi12d syl bitrd mpbird $.
        $( [20-Sep-2007] $) $( [12-Oct-2006] $)
    $}
  $}

  $( A restriction of a metric is a metric. $)
  metres $p |- ( D e. Met -> ( D |` ( R X. R ) ) e. Met ) $=
    cD cme wcel cD cR cR cxp cres cD cR cD cdm cdm cin cR cD cdm cdm cin cxp
    cres cme cD cme wcel cD cdm cdm cD cdm cdm cxp cr cD wf cD cdm cD cdm cdm
    cD cdm cdm cxp wceq cD cR cR cxp cres cD cR cD cdm cdm cin cR cD cdm cdm
    cin cxp cres wceq cD cD cdm cdm cD cdm cdm eqid metf cD cdm cdm cD cdm cdm
    cxp cr cD fdm cD cdm cD cdm cdm cD cdm cdm cxp wceq cD cR cR cxp cD cdm cin
    cres cD cR cD cdm cdm cin cR cD cdm cdm cin cxp cres cD cR cR cxp cres cD
    cdm cD cdm cdm cD cdm cdm cxp wceq cR cR cxp cD cdm cin cR cD cdm cdm cin
    cR cD cdm cdm cin cxp wceq cD cR cR cxp cD cdm cin cres cD cR cD cdm cdm
    cin cR cD cdm cdm cin cxp cres wceq cD cdm cD cdm cdm cD cdm cdm cxp wceq
    cR cR cxp cD cdm cin cR cR cxp cD cdm cdm cD cdm cdm cxp cin cR cD cdm cdm
    cin cR cD cdm cdm cin cxp cD cdm cD cdm cdm cD cdm cdm cxp cR cR cxp ineq2
    cR cR cD cdm cdm cD cdm cdm inxp syl6eq cR cR cxp cD cdm cin cR cD cdm cdm
    cin cR cD cdm cdm cin cxp cD reseq2 syl cD cD cR cR cxp cres cdm cres cD cR
    cR cxp cres cD cR cR cxp cD cdm cin cres cD cR cR cxp resdmres cD cR cR cxp
    cres cdm cR cR cxp cD cdm cin wceq cD cD cR cR cxp cres cdm cres cD cR cR
    cxp cD cdm cin cres wceq cD cR cR cxp dmres cD cR cR cxp cres cdm cR cR cxp
    cD cdm cin cD reseq2 ax-mp eqtr3i syl5eq 3syl cD cme wcel cR cD cdm cdm cin
    cD cdm cdm wss cD cR cD cdm cdm cin cR cD cdm cdm cin cxp cres cme wcel cR
    cD cdm cdm inss2 cD cR cD cdm cdm cin cR cD cdm cdm cin cxp cres cdm cdm cD
    cR cD cdm cdm cin cD cdm cdm cD cdm cdm eqid cD cR cD cdm cdm cin cR cD cdm
    cdm cin cxp cres cdm cdm eqid metreslem mpan2 eqeltrd $.
    $( [20-Sep-2007] $) $( [26-Aug-2007] $)

  ${
    metss.1 $e |- X = dom dom C $.
    metss.2 $e |- Y = dom dom D $.
    $( If two metrics are in a subset relationship, so are their base sets. $)
    metss $p |- ( C C_ D -> X C_ Y ) $=
      cC cD wss cC cdm cdm cD cdm cdm cX cY cC cD wss cC cdm cD cdm wss cC cdm
      cdm cD cdm cdm wss cC cD dmss cC cdm cD cdm dmss syl metss.1 metss.2
      3sstr4g $.
      $( [9-Oct-2007] $) $( [29-May-2007] $)
  $}

  ${
    $d x y z $.
    $( The empty metric. $)
    0met $p |- (/) e. Met $=
      c0 cme wcel c0 c0 cxp cr c0 wf vx cv vy cv c0 co cc0 wceq vx cv vy cv
      wceq wb vx cv vy cv c0 co vz cv vx cv c0 co vz cv vy cv c0 co caddc co
      cle wbr vz c0 wral wa vy c0 wral vx c0 wral c0 cvv wcel c0 cme wcel c0 c0
      cxp cr c0 wf vx cv vy cv c0 co cc0 wceq vx cv vy cv wceq wb vx cv vy cv
      c0 co vz cv vx cv c0 co vz cv vy cv c0 co caddc co cle wbr vz c0 wral wa
      vy c0 wral vx c0 wral wa wb 0ex vx vy vz cvv c0 c0 c0 cdm cdm c0 cdm c0
      c0 cdm c0 dm0 dmeqi dm0 eqtr2i ismet ax-mp c0 c0 cxp cr c0 wf c0 cr c0 wf
      cr f0 c0 c0 cxp c0 wceq c0 c0 cxp cr c0 wf c0 cr c0 wf wb c0 xp0r c0 c0
      cxp c0 cr c0 feq2 ax-mp mpbir vx cv vy cv c0 co cc0 wceq vx cv vy cv wceq
      wb vx cv vy cv c0 co vz cv vx cv c0 co vz cv vy cv c0 co caddc co cle wbr
      vz c0 wral wa vy c0 wral vx ral0 mpbir2an $.
      $( [24-Oct-2007] $) $( [30-Aug-2006] $)
  $}

  ${
    metxplem1.1 $e |- D e. Met $.
    metxplem1.2 $e |- X = dom dom D $.
    ${
      metxplem1.4 $e |- F = ( 1st ` R ) $.
      metxplem1.5 $e |- H = ( 1st ` S ) $.
      $( Lemma for ~ metxp . $)
      metxplem1 $p |- ( ( R e. ( X X. Y ) /\ S e. ( X X. Y ) ) ->
           ( F D H ) e. RR ) $=
        cF cX wcel cH cX wcel cF cH cD co cr wcel cR cX cY cxp wcel cS cX cY
        cxp wcel cD cme wcel cF cX wcel cH cX wcel cF cH cD co cr wcel
        metxplem1.1 cF cH cD cX metxplem1.2 metcl mp3an1 cR cX cY cxp wcel cR
        c1st cfv cX cF cR cX cY cxp wcel cR c1st cfv cX wcel cR c2nd cfv cY
        wcel cR cX cY cxp wcel cR cvv cvv cxp wcel cR c1st cfv cX wcel cR c2nd
        cfv cY wcel wa cR cX cY elxp7 pm3.27bi pm3.26d metxplem1.4 syl5eqel cS
        cX cY cxp wcel cS c1st cfv cX cH cS cX cY cxp wcel cS c1st cfv cX wcel
        cS c2nd cfv cY wcel cS cX cY cxp wcel cS cvv cvv cxp wcel cS c1st cfv
        cX wcel cS c2nd cfv cY wcel wa cS cX cY elxp7 pm3.27bi pm3.26d
        metxplem1.5 syl5eqel syl2an $.
        $( [2-Oct-2007] $) $( [20-Jul-2007] $)
    $}

    ${
      metxplem2.4 $e |- G = ( 2nd ` R ) $.
      metxplem2.5 $e |- J = ( 2nd ` S ) $.
      $( Lemma for ~ metxp . $)
      metxplem2 $p |- ( ( R e. ( Y X. X ) /\ S e. ( Y X. X ) ) ->
                     ( G D J ) e. RR ) $=
        cG cX wcel cJ cX wcel cG cJ cD co cr wcel cR cY cX cxp wcel cS cY cX
        cxp wcel cD cme wcel cG cX wcel cJ cX wcel cG cJ cD co cr wcel
        metxplem1.1 cG cJ cD cX metxplem1.2 metcl mp3an1 cR cY cX cxp wcel cR
        c2nd cfv cX cG cR cY cX cxp wcel cR c1st cfv cY wcel cR c2nd cfv cX
        wcel cR cY cX cxp wcel cR cvv cvv cxp wcel cR c1st cfv cY wcel cR c2nd
        cfv cX wcel wa cR cY cX elxp7 pm3.27bi pm3.27d metxplem2.4 syl5eqel cS
        cY cX cxp wcel cS c2nd cfv cX cJ cS cY cX cxp wcel cS c1st cfv cY wcel
        cS c2nd cfv cX wcel cS cY cX cxp wcel cS cvv cvv cxp wcel cS c1st cfv
        cY wcel cS c2nd cfv cX wcel wa cS cY cX elxp7 pm3.27bi pm3.27d
        metxplem2.5 syl5eqel syl2an $.
        $( [2-Oct-2007] $) $( [20-Jul-2007] $)
    $}

    ${
      metxplem3.4 $e |- ( ph -> F e. RR ) $.
      metxplem3.5 $e |- ( ph -> G e. RR ) $.
      metxplem3.6 $e |- ( ph -> ( C e. X /\ A e. X /\ B e. X ) ) $.
      $( Lemma for ~ metxp . $)
      metxplem3 $p |- ( ph -> ( ( C D A ) <_ F
          -> ( ( C D B ) <_ G -> ( A D B ) <_ ( F + G ) ) ) ) $=
        wph cC cA cD co cF cle wbr cC cB cD co cG cle wbr cA cB cD co cF cG
        caddc co cle wbr wph cC cA cD co cF cle wbr cC cB cD co cG cle wbr wa
        wa cA cB cD co cC cA cD co cC cB cD co caddc co cF cG caddc co wph cA
        cB cD co cr wcel cC cA cD co cF cle wbr cC cB cD co cG cle wbr wa wph
        cC cX wcel cA cX wcel cB cX wcel w3a cA cB cD co cr wcel metxplem3.6 cA
        cX wcel cB cX wcel cA cB cD co cr wcel cC cX wcel cD cme wcel cA cX
        wcel cB cX wcel cA cB cD co cr wcel metxplem1.1 cA cB cD cX metxplem1.2
        metcl mp3an1 3adant1 syl adantr wph cC cA cD co cC cB cD co caddc co cr
        wcel cC cA cD co cF cle wbr cC cB cD co cG cle wbr wa cC cA cD co cr
        wcel cC cB cD co cr wcel cC cA cD co cC cB cD co caddc co cr wcel wph
        cC cA cD co cC cB cD co readdcl wph cC cX wcel cA cX wcel cB cX wcel
        w3a cC cA cD co cr wcel metxplem3.6 cC cX wcel cA cX wcel cC cA cD co
        cr wcel cB cX wcel cD cme wcel cC cX wcel cA cX wcel cC cA cD co cr
        wcel metxplem1.1 cC cA cD cX metxplem1.2 metcl mp3an1 3adant3 syl wph
        cC cX wcel cA cX wcel cB cX wcel w3a cC cB cD co cr wcel metxplem3.6 cC
        cX wcel cB cX wcel cC cB cD co cr wcel cA cX wcel cD cme wcel cC cX
        wcel cB cX wcel cC cB cD co cr wcel metxplem1.1 cC cB cD cX metxplem1.2
        metcl mp3an1 3adant2 syl sylanc adantr wph cF cG caddc co cr wcel cC cA
        cD co cF cle wbr cC cB cD co cG cle wbr wa cF cr wcel cG cr wcel cF cG
        caddc co cr wcel wph cF cG readdcl metxplem3.4 metxplem3.5 sylanc
        adantr wph cA cB cD co cC cA cD co cC cB cD co caddc co cle wbr cC cA
        cD co cF cle wbr cC cB cD co cG cle wbr wa cD cme wcel cC cX wcel cA cX
        wcel cB cX wcel w3a cA cB cD co cC cA cD co cC cB cD co caddc co cle
        wbr wph cA cB cC cD cX metxplem1.2 mettri2 metxplem1.1 metxplem3.6
        sylancr adantr wph cC cA cD co cF cle wbr cC cB cD co cG cle wbr wa cC
        cA cD co cC cB cD co caddc co cF cG caddc co cle wbr cC cA cD co cr
        wcel cC cB cD co cr wcel cF cr wcel cG cr wcel cC cA cD co cF cle wbr
        cC cB cD co cG cle wbr wa cC cA cD co cC cB cD co caddc co cF cG caddc
        co cle wbr wi wph cC cA cD co cC cB cD co cF cG le2add wph cC cX wcel
        cA cX wcel cB cX wcel w3a cC cA cD co cr wcel metxplem3.6 cC cX wcel cA
        cX wcel cC cA cD co cr wcel cB cX wcel cD cme wcel cC cX wcel cA cX
        wcel cC cA cD co cr wcel metxplem1.1 cC cA cD cX metxplem1.2 metcl
        mp3an1 3adant3 syl wph cC cX wcel cA cX wcel cB cX wcel w3a cC cB cD co
        cr wcel metxplem3.6 cC cX wcel cB cX wcel cC cB cD co cr wcel cA cX
        wcel cD cme wcel cC cX wcel cB cX wcel cC cB cD co cr wcel metxplem1.1
        cC cB cD cX metxplem1.2 metcl mp3an1 3adant2 syl metxplem3.4
        metxplem3.5 syl2anc imp letrd exp32 $.
        $( [4-Oct-2007] $) $( [11-Jul-2007] $)
    $}
  $}

  ${
    $d x y z B $.  $d x y z C $.  $d u v w D $.  $d x y z R $.  $d x y z S $.
    $d u v w x y z X $.  $d u v w x y z Y $.
    metxp.1 $e |- X = dom dom B $.
    metxp.3 $e |- Y = dom dom C $.
    metxp.5 $e |- B e. Met $.
    metxp.6 $e |- C e. Met $.
    metxp.7 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( X X. Y )
         /\ y e. ( X X. Y ) ) /\ z = sup ( { ( ( 1st ` x ) B ( 1st ` y )
            ) , ( ( 2nd ` x ) C ( 2nd ` y ) ) } , RR , < ) ) } $.
    ${
      $d x y z F $.  $d x y z G $.  $d y z H $.  $d y z J $.
      metxpval.8 $e |- F = ( 1st ` R ) $.
      metxpval.9 $e |- G = ( 2nd ` R ) $.
      metxpval.10 $e |- H = ( 1st ` S ) $.
      metxpval.11 $e |- J = ( 2nd ` S ) $.
      $( Value of the distance function of the direct product of two metric
         spaces.  Based on Definition 14-1.5 of [Gleason] p. 225. $)
      metxpdval $p |- ( ( R e. ( X X. Y ) /\ S e. ( X X. Y ) ) -> ( R D S ) =
          if ( ( G C J ) < ( F B H
         ) , ( F B H ) , ( G C J ) ) ) $=
        cR cX cY cxp wcel cS cX cY cxp wcel wa cR cS cD co cF cH cB co cG cJ cC
        co cpr cr clt csup cG cJ cC co cF cH cB co clt wbr cF cH cB co cG cJ cC
        co cif vx vy vz cR cS cX cY cxp cX cY cxp vx cv c1st cfv vy cv c1st cfv
        cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup cF cH cB co
        cG cJ cC co cpr cr clt csup cD cF vy cv c1st cfv cB co cG vy cv c2nd
        cfv cC co cpr cr clt csup cr cF cH cB co cG cJ cC co cpr clt ltso supex
        vx cv cR wceq vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv
        c2nd cfv cC co cpr cF vy cv c1st cfv cB co cG vy cv c2nd cfv cC co cpr
        wceq vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv
        cC co cpr cr clt csup cF vy cv c1st cfv cB co cG vy cv c2nd cfv cC co
        cpr cr clt csup wceq vx cv cR wceq vx cv c1st cfv vy cv c1st cfv cB co
        vx cv c2nd cfv vy cv c2nd cfv cC co cpr cF vy cv c1st cfv cB co vx cv
        c2nd cfv vy cv c2nd cfv cC co cpr cF vy cv c1st cfv cB co cG vy cv c2nd
        cfv cC co cpr vx cv cR wceq vx cv c1st cfv vy cv c1st cfv cB co cF vy
        cv c1st cfv cB co wceq vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd
        cfv vy cv c2nd cfv cC co cpr cF vy cv c1st cfv cB co vx cv c2nd cfv vy
        cv c2nd cfv cC co cpr wceq vx cv cR wceq vx cv c1st cfv cF vy cv c1st
        cfv cB vx cv cR wceq vx cv c1st cfv cR c1st cfv cF vx cv cR c1st fveq2
        metxpval.8 syl6eqr opreq1d vx cv c1st cfv vy cv c1st cfv cB co cF vy cv
        c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co preq1 syl vx cv cR
        wceq vx cv c2nd cfv vy cv c2nd cfv cC co cG vy cv c2nd cfv cC co wceq
        cF vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cF vy
        cv c1st cfv cB co cG vy cv c2nd cfv cC co cpr wceq vx cv cR wceq vx cv
        c2nd cfv cG vy cv c2nd cfv cC vx cv cR wceq vx cv c2nd cfv cR c2nd cfv
        cG vx cv cR c2nd fveq2 metxpval.9 syl6eqr opreq1d vx cv c2nd cfv vy cv
        c2nd cfv cC co cG vy cv c2nd cfv cC co cF vy cv c1st cfv cB co preq2
        syl eqtrd cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv
        c2nd cfv cC co cpr cF vy cv c1st cfv cB co cG vy cv c2nd cfv cC co cpr
        clt supeq1 syl vy cv cS wceq cF vy cv c1st cfv cB co cG vy cv c2nd cfv
        cC co cpr cF cH cB co cG cJ cC co cpr wceq cF vy cv c1st cfv cB co cG
        vy cv c2nd cfv cC co cpr cr clt csup cF cH cB co cG cJ cC co cpr cr clt
        csup wceq vy cv cS wceq cF vy cv c1st cfv cB co cG vy cv c2nd cfv cC co
        cpr cF cH cB co cG vy cv c2nd cfv cC co cpr cF cH cB co cG cJ cC co cpr
        vy cv cS wceq cF vy cv c1st cfv cB co cF cH cB co wceq cF vy cv c1st
        cfv cB co cG vy cv c2nd cfv cC co cpr cF cH cB co cG vy cv c2nd cfv cC
        co cpr wceq vy cv cS wceq vy cv c1st cfv cH cF cB vy cv cS wceq vy cv
        c1st cfv cS c1st cfv cH vy cv cS c1st fveq2 metxpval.10 syl6eqr opreq2d
        cF vy cv c1st cfv cB co cF cH cB co cG vy cv c2nd cfv cC co preq1 syl
        vy cv cS wceq cG vy cv c2nd cfv cC co cG cJ cC co wceq cF cH cB co cG
        vy cv c2nd cfv cC co cpr cF cH cB co cG cJ cC co cpr wceq vy cv cS wceq
        vy cv c2nd cfv cJ cG cC vy cv cS wceq vy cv c2nd cfv cS c2nd cfv cJ vy
        cv cS c2nd fveq2 metxpval.11 syl6eqr opreq2d cG vy cv c2nd cfv cC co cG
        cJ cC co cF cH cB co preq2 syl eqtrd cr cF vy cv c1st cfv cB co cG vy
        cv c2nd cfv cC co cpr cF cH cB co cG cJ cC co cpr clt supeq1 syl
        metxp.7 oprabval2 cF cH cB co cr wcel cG cJ cC co cr wcel cF cH cB co
        cG cJ cC co cpr cr clt csup cG cJ cC co cF cH cB co clt wbr cF cH cB co
        cG cJ cC co cif wceq cR cX cY cxp wcel cS cX cY cxp wcel wa cr cF cH cB
        co cG cJ cC co clt ltso suppr cB cR cS cF cH cX cY metxp.5 metxp.1
        metxpval.8 metxpval.10 metxplem1 cC cR cS cG cJ cY cX metxp.6 metxp.3
        metxpval.9 metxpval.11 metxplem2 sylanc eqtrd $.
        $( [2-Oct-2007] $) $( [20-Jul-2007] $)

      $( One case of the value of the distance function of the direct product
         of two metric spaces.  Based on Definition 14-1.5 of [Gleason]
         p. 225. $)
      metxptval $p |- ( ( ( R e. ( X X. Y ) /\ S e. ( X X. Y ) ) /\
              ( G C J ) <_ ( F B H ) ) ->
                 ( R D S ) = ( F B H ) ) $=
        cR cX cY cxp wcel cS cX cY cxp wcel wa cG cJ cC co cF cH cB co cle wbr
        cG cJ cC co cF cH cB co clt wbr cG cJ cC co cF cH cB co wceq wo cR cS
        cD co cF cH cB co wceq cR cX cY cxp wcel cS cX cY cxp wcel wa cG cJ cC
        co cF cH cB co cle wbr cG cJ cC co cF cH cB co clt wbr cG cJ cC co cF
        cH cB co wceq wo cG cJ cC co cr wcel cF cH cB co cr wcel cG cJ cC co cF
        cH cB co cle wbr cG cJ cC co cF cH cB co clt wbr cG cJ cC co cF cH cB
        co wceq wo wb cR cX cY cxp wcel cS cX cY cxp wcel wa cG cJ cC co cF cH
        cB co leloe cC cR cS cG cJ cY cX metxp.6 metxp.3 metxpval.9 metxpval.11
        metxplem2 cB cR cS cF cH cX cY metxp.5 metxp.1 metxpval.8 metxpval.10
        metxplem1 sylanc biimpa cR cX cY cxp wcel cS cX cY cxp wcel wa cG cJ cC
        co cF cH cB co clt wbr cG cJ cC co cF cH cB co wceq wo cR cS cD co cG
        cJ cC co cF cH cB co clt wbr cF cH cB co cG cJ cC co cif cF cH cB co vx
        vy vz cB cC cD cR cS cF cG cH cJ cX cY metxp.1 metxp.3 metxp.5 metxp.6
        metxp.7 metxpval.8 metxpval.9 metxpval.10 metxpval.11 metxpdval cG cJ
        cC co cF cH cB co clt wbr cG cJ cC co cF cH cB co clt wbr cF cH cB co
        cG cJ cC co cif cF cH cB co wceq cG cJ cC co cF cH cB co wceq cG cJ cC
        co cF cH cB co clt wbr cF cH cB co cG cJ cC co iftrue cG cJ cC co cF cH
        cB co wceq cG cJ cC co cF cH cB co clt wbr cF cH cB co cG cJ cC co cif
        cG cJ cC co cF cH cB co clt wbr cF cH cB co cF cH cB co cif cF cH cB co
        cG cJ cC co cF cH cB co clt wbr cG cJ cC co cF cH cB co cF cH cB co
        ifeq2 cG cJ cC co cF cH cB co clt wbr cF cH cB co ifid syl6eq jaoi
        sylan9eq syldan $.
        $( [3-Oct-2007] $) $( [20-Jul-2007] $)

      $( One case of the value of the distance function of the direct product
         of two metric spaces.  Based on Definition 14-1.5 of [Gleason]
         p. 225. $)
      metxpfval $p |- ( ( ( R e. ( X X. Y ) /\ S e. ( X X. Y ) ) /\
           ( F B H ) <_ ( G C J ) ) ->
                 ( R D S ) = ( G C J ) ) $=
        cR cX cY cxp wcel cS cX cY cxp wcel wa cF cH cB co cG cJ cC co cle wbr
        wa cR cS cD co cG cJ cC co cF cH cB co clt wbr cF cH cB co cG cJ cC co
        cif cG cJ cC co cR cX cY cxp wcel cS cX cY cxp wcel wa cR cS cD co cG
        cJ cC co cF cH cB co clt wbr cF cH cB co cG cJ cC co cif wceq cF cH cB
        co cG cJ cC co cle wbr vx vy vz cB cC cD cR cS cF cG cH cJ cX cY
        metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 metxpval.8 metxpval.9
        metxpval.10 metxpval.11 metxpdval adantr cR cX cY cxp wcel cS cX cY cxp
        wcel wa cF cH cB co cG cJ cC co cle wbr wa cG cJ cC co cF cH cB co clt
        wbr wn cG cJ cC co cF cH cB co clt wbr cF cH cB co cG cJ cC co cif cG
        cJ cC co wceq cR cX cY cxp wcel cS cX cY cxp wcel wa cF cH cB co cG cJ
        cC co cle wbr cG cJ cC co cF cH cB co clt wbr wn cF cH cB co cr wcel cG
        cJ cC co cr wcel cF cH cB co cG cJ cC co cle wbr cG cJ cC co cF cH cB
        co clt wbr wn wb cR cX cY cxp wcel cS cX cY cxp wcel wa cF cH cB co cG
        cJ cC co lenlt cB cR cS cF cH cX cY metxp.5 metxp.1 metxpval.8
        metxpval.10 metxplem1 cC cR cS cG cJ cY cX metxp.6 metxp.3 metxpval.9
        metxpval.11 metxplem2 sylanc biimpa cG cJ cC co cF cH cB co clt wbr cF
        cH cB co cG cJ cC co iffalse syl eqtrd $.
        $( [4-Oct-2007] $) $( [20-Jul-2007] $)
    $}

    $( Closure of the distance function of the direct product of two metric
       spaces.  Based on Definition 14-1.5 of [Gleason] p. 225. $)
    metxpcl $p |- ( ( R e. ( X X. Y ) /\ S e. ( X X. Y ) ) ->
               ( R D S ) e. RR ) $=
      cR cX cY cxp wcel cS cX cY cxp wcel wa cR cS cD co cr wcel cR c2nd cfv cS
      c2nd cfv cC co cR c1st cfv cS c1st cfv cB co cC cR cS cR c2nd cfv cS c2nd
      cfv cY cX metxp.6 metxp.3 cR c2nd cfv eqid cS c2nd cfv eqid metxplem2 cB
      cR cS cR c1st cfv cS c1st cfv cX cY metxp.5 metxp.1 cR c1st cfv eqid cS
      c1st cfv eqid metxplem1 cR cX cY cxp wcel cS cX cY cxp wcel wa cR c2nd
      cfv cS c2nd cfv cC co cR c1st cfv cS c1st cfv cB co cle wbr wa cR cS cD
      co cR c1st cfv cS c1st cfv cB co cr vx vy vz cB cC cD cR cS cR c1st cfv
      cR c2nd cfv cS c1st cfv cS c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6
      metxp.7 cR c1st cfv eqid cR c2nd cfv eqid cS c1st cfv eqid cS c2nd cfv
      eqid metxptval cR cX cY cxp wcel cS cX cY cxp wcel wa cR c1st cfv cS c1st
      cfv cB co cr wcel cR c2nd cfv cS c2nd cfv cC co cR c1st cfv cS c1st cfv
      cB co cle wbr cB cR cS cR c1st cfv cS c1st cfv cX cY metxp.5 metxp.1 cR
      c1st cfv eqid cS c1st cfv eqid metxplem1 adantr eqeltrd cR cX cY cxp wcel
      cS cX cY cxp wcel wa cR c1st cfv cS c1st cfv cB co cR c2nd cfv cS c2nd
      cfv cC co cle wbr wa cR cS cD co cR c2nd cfv cS c2nd cfv cC co cr vx vy
      vz cB cC cD cR cS cR c1st cfv cR c2nd cfv cS c1st cfv cS c2nd cfv cX cY
      metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 cR c1st cfv eqid cR c2nd cfv eqid
      cS c1st cfv eqid cS c2nd cfv eqid metxpfval cR cX cY cxp wcel cS cX cY
      cxp wcel wa cR c2nd cfv cS c2nd cfv cC co cr wcel cR c1st cfv cS c1st cfv
      cB co cR c2nd cfv cS c2nd cfv cC co cle wbr cC cR cS cR c2nd cfv cS c2nd
      cfv cY cX metxp.6 metxp.3 cR c2nd cfv eqid cS c2nd cfv eqid metxplem2
      adantr eqeltrd lecasei $.
      $( [4-Oct-2007] $) $( [9-Jul-2007] $)

    $( Lemma for ~ metxp .  Triangle inequality.  _Warning:  The HTML proof
       page is 0.6 megabyte in size_. $)
    metxplem4 $p |- ( ( u e. ( X X. Y ) /\ w e. ( X X. Y ) /\
              v e. ( X X. Y ) ) -> ( w D v ) <_ ( ( u D w ) + ( u D v ) ) ) $=
      vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv
      vv cv cD co vu cv vw cv cD co vu cv vv cv cD co caddc co cle wbr vw cv
      c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co vw cv
      cX cY cxp wcel vv cv cX cY cxp wcel vw cv c2nd cfv vv cv c2nd cfv cC co
      cr wcel vu cv cX cY cxp wcel cC vw cv vv cv vw cv c2nd cfv vv cv c2nd cfv
      cY cX metxp.6 metxp.3 vw cv c2nd cfv eqid vv cv c2nd cfv eqid metxplem2
      3adant1 vw cv cX cY cxp wcel vv cv cX cY cxp wcel vw cv c1st cfv vv cv
      c1st cfv cB co cr wcel vu cv cX cY cxp wcel cB vw cv vv cv vw cv c1st cfv
      vv cv c1st cfv cX cY metxp.5 metxp.1 vw cv c1st cfv eqid vv cv c1st cfv
      eqid metxplem1 3adant1 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX
      cY cxp wcel w3a vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv
      c1st cfv cB co cle wbr wa vw cv vv cv cD co vw cv c1st cfv vv cv c1st cfv
      cB co vu cv vw cv cD co vu cv vv cv cD co caddc co cle vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st
      cfv vv cv c1st cfv cB co cle wbr vw cv vv cv cD co vw cv c1st cfv vv cv
      c1st cfv cB co wceq vu cv cX cY cxp wcel vx vy vz cB cC cD vw cv vv cv vw
      cv c1st cfv vw cv c2nd cfv vv cv c1st cfv vv cv c2nd cfv cX cY metxp.1
      metxp.3 metxp.5 metxp.6 metxp.7 vw cv c1st cfv eqid vw cv c2nd cfv eqid
      vv cv c1st cfv eqid vv cv c2nd cfv eqid metxptval 3adantl1 vu cv cX cY
      cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv c1st cfv vv
      cv c1st cfv cB co vu cv vw cv cD co vu cv vv cv cD co caddc co cle wbr vw
      cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co cle
      wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw
      cv c1st cfv vv cv c1st cfv cB co vu cv vw cv cD co vu cv vv cv cD co
      caddc co cle wbr vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv
      c1st cfv cB co vu cv cX cY cxp wcel vw cv cX cY cxp wcel vu cv c2nd cfv
      vw cv c2nd cfv cC co cr wcel vv cv cX cY cxp wcel cC vu cv vw cv vu cv
      c2nd cfv vw cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vw cv
      c2nd cfv eqid metxplem2 3adant3 vu cv cX cY cxp wcel vw cv cX cY cxp wcel
      vu cv c1st cfv vw cv c1st cfv cB co cr wcel vv cv cX cY cxp wcel cB vu cv
      vw cv vu cv c1st cfv vw cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv
      eqid vw cv c1st cfv eqid metxplem1 3adant3 vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co
      vu cv c1st cfv vw cv c1st cfv cB co cle wbr wa vw cv c1st cfv vv cv c1st
      cfv cB co vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv cD co caddc co
      vu cv vw cv cD co vu cv vv cv cD co caddc co cle vu cv cX cY cxp wcel vw
      cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv c1st cfv vv cv c1st cfv
      cB co vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv cD co caddc co cle
      wbr vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB
      co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel
      w3a vw cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv cB
      co vu cv vv cv cD co caddc co cle wbr vu cv c2nd cfv vv cv c2nd cfv cC co
      vu cv c1st cfv vv cv c1st cfv cB co vu cv cX cY cxp wcel vv cv cX cY cxp
      wcel vu cv c2nd cfv vv cv c2nd cfv cC co cr wcel vw cv cX cY cxp wcel cC
      vu cv vv cv vu cv c2nd cfv vv cv c2nd cfv cY cX metxp.6 metxp.3 vu cv
      c2nd cfv eqid vv cv c2nd cfv eqid metxplem2 3adant2 vu cv cX cY cxp wcel
      vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv cB co cr wcel vw cv cX
      cY cxp wcel cB vu cv vv cv vu cv c1st cfv vv cv c1st cfv cX cY metxp.5
      metxp.1 vu cv c1st cfv eqid vv cv c1st cfv eqid metxplem1 3adant2 vu cv
      cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd
      cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr wa
      vw cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv cB co
      vu cv c1st cfv vv cv c1st cfv cB co caddc co vu cv c1st cfv vw cv c1st
      cfv cB co vu cv vv cv cD co caddc co cle vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vv cv cX cY cxp wcel w3a vw cv c1st cfv vv cv c1st cfv cB co vu
      cv c1st cfv vw cv c1st cfv cB co vu cv c1st cfv vv cv c1st cfv cB co
      caddc co cle wbr vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv
      c1st cfv cB co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX
      cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c1st cfv vw cv
      c1st cfv cB co cle wbr vw cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv
      vw cv c1st cfv cB co vu cv c1st cfv vv cv c1st cfv cB co caddc co cle wbr
      vu cv cX cY cxp wcel vw cv cX cY cxp wcel vu cv c1st cfv vw cv c1st cfv
      cB co vu cv c1st cfv vw cv c1st cfv cB co cle wbr vv cv cX cY cxp wcel vu
      cv cX cY cxp wcel vw cv cX cY cxp wcel wa vu cv c1st cfv vw cv c1st cfv
      cB co cr wcel vu cv c1st cfv vw cv c1st cfv cB co vu cv c1st cfv vw cv
      c1st cfv cB co cle wbr cB vu cv vw cv vu cv c1st cfv vw cv c1st cfv cX cY
      metxp.5 metxp.1 vu cv c1st cfv eqid vw cv c1st cfv eqid metxplem1 vu cv
      c1st cfv vw cv c1st cfv cB co leid syl 3adant3 vu cv cX cY cxp wcel vw cv
      cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB
      co vu cv c1st cfv vw cv c1st cfv cB co cle wbr vu cv c1st cfv vv cv c1st
      cfv cB co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vw cv c1st cfv vv
      cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv cB co vu cv c1st cfv vv
      cv c1st cfv cB co caddc co cle wbr vu cv cX cY cxp wcel vv cv cX cY cxp
      wcel vu cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vv cv c1st cfv cB
      co cle wbr vw cv cX cY cxp wcel vu cv cX cY cxp wcel vv cv cX cY cxp wcel
      wa vu cv c1st cfv vv cv c1st cfv cB co cr wcel vu cv c1st cfv vv cv c1st
      cfv cB co vu cv c1st cfv vv cv c1st cfv cB co cle wbr cB vu cv vv cv vu
      cv c1st cfv vv cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vv
      cv c1st cfv eqid metxplem1 vu cv c1st cfv vv cv c1st cfv cB co leid syl
      3adant2 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel
      w3a vw cv c1st cfv vv cv c1st cfv vu cv c1st cfv cB vu cv c1st cfv vw cv
      c1st cfv cB co vu cv c1st cfv vv cv c1st cfv cB co cX metxp.5 metxp.1 vu
      cv cX cY cxp wcel vw cv cX cY cxp wcel vu cv c1st cfv vw cv c1st cfv cB
      co cr wcel vv cv cX cY cxp wcel cB vu cv vw cv vu cv c1st cfv vw cv c1st
      cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vw cv c1st cfv eqid
      metxplem1 3adant3 vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c1st
      cfv vv cv c1st cfv cB co cr wcel vw cv cX cY cxp wcel cB vu cv vv cv vu
      cv c1st cfv vv cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vv
      cv c1st cfv eqid metxplem1 3adant2 vu cv cX cY cxp wcel vu cv c1st cfv cX
      wcel vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vv cv cX cY cxp wcel vv
      cv c1st cfv cX wcel vu cv cX cY cxp wcel vu cv c1st cfv cX wcel vu cv
      c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv cvv cvv cxp wcel vu cv c1st
      cfv cX wcel vu cv c2nd cfv cY wcel wa vu cv cX cY elxp7 pm3.27bi pm3.26d
      vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel vw cv
      cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd
      cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi pm3.26d vv cv cX cY cxp wcel vv
      cv c1st cfv cX wcel vv cv c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv cvv
      cvv cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel wa vv cv cX cY
      elxp7 pm3.27bi pm3.26d 3anim123i metxplem3 mpid mpd adantr vu cv cX cY
      cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vv
      cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr wa vu cv vv
      cv cD co vu cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vw cv c1st
      cfv cB co caddc vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv
      vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vu cv vv
      cv cD co vu cv c1st cfv vv cv c1st cfv cB co wceq vw cv cX cY cxp wcel vx
      vy vz cB cC cD vu cv vv cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv
      vv cv c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st
      cfv eqid vu cv c2nd cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid
      metxptval 3adantl2 opreq2d breqtrrd vu cv cX cY cxp wcel vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vv cv c2nd cfv cC co cle wbr wa vw cv c1st cfv vv cv c1st cfv cB
      co vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC
      co caddc co vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv cD co caddc
      co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a
      vu cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co
      cle wbr vw cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv
      cB co vu cv c2nd cfv vv cv c2nd cfv cC co caddc co cle wbr vu cv cX cY
      cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vw
      cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv cB co cle wbr vu cv c1st
      cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw
      cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv cB co vu
      cv c2nd cfv vv cv c2nd cfv cC co caddc co cle wbr wi vu cv cX cY cxp wcel
      vw cv cX cY cxp wcel vu cv c1st cfv vw cv c1st cfv cB co vu cv c1st cfv
      vw cv c1st cfv cB co cle wbr vv cv cX cY cxp wcel vu cv cX cY cxp wcel vw
      cv cX cY cxp wcel wa vu cv c1st cfv vw cv c1st cfv cB co cr wcel vu cv
      c1st cfv vw cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv cB co cle wbr
      cB vu cv vw cv vu cv c1st cfv vw cv c1st cfv cX cY metxp.5 metxp.1 vu cv
      c1st cfv eqid vw cv c1st cfv eqid metxplem1 vu cv c1st cfv vw cv c1st cfv
      cB co leid syl 3adant3 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX
      cY cxp wcel w3a vw cv c1st cfv vv cv c1st cfv vu cv c1st cfv cB vu cv
      c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cX
      metxp.5 metxp.1 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vu cv c1st cfv
      vw cv c1st cfv cB co cr wcel vv cv cX cY cxp wcel cB vu cv vw cv vu cv
      c1st cfv vw cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vw cv
      c1st cfv eqid metxplem1 3adant3 vu cv cX cY cxp wcel vv cv cX cY cxp wcel
      vu cv c2nd cfv vv cv c2nd cfv cC co cr wcel vw cv cX cY cxp wcel cC vu cv
      vv cv vu cv c2nd cfv vv cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv
      eqid vv cv c2nd cfv eqid metxplem2 3adant2 vu cv cX cY cxp wcel vu cv
      c1st cfv cX wcel vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vv cv cX cY
      cxp wcel vv cv c1st cfv cX wcel vu cv cX cY cxp wcel vu cv c1st cfv cX
      wcel vu cv c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv cvv cvv cxp wcel
      vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel wa vu cv cX cY elxp7
      pm3.27bi pm3.26d vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vw cv c2nd
      cfv cY wcel vw cv cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv c1st cfv cX
      wcel vw cv c2nd cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi pm3.26d vv cv
      cX cY cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel vv cv cX cY
      cxp wcel vv cv cvv cvv cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY
      wcel wa vv cv cX cY elxp7 pm3.27bi pm3.26d 3anim123i metxplem3 mpd imp vu
      cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv
      c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr
      wa vu cv vv cv cD co vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv
      vw cv c1st cfv cB co caddc vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu
      cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle
      wbr vu cv vv cv cD co vu cv c2nd cfv vv cv c2nd cfv cC co wceq vw cv cX
      cY cxp wcel vx vy vz cB cC cD vu cv vv cv vu cv c1st cfv vu cv c2nd cfv
      vv cv c1st cfv vv cv c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6
      metxp.7 vu cv c1st cfv eqid vu cv c2nd cfv eqid vv cv c1st cfv eqid vv cv
      c2nd cfv eqid metxpfval 3adantl2 opreq2d breqtrrd lecasei adantr vu cv cX
      cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv
      vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr wa vu cv
      vw cv cD co vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv cD co caddc
      vu cv cX cY cxp wcel vw cv cX cY cxp wcel vu cv c2nd cfv vw cv c2nd cfv
      cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr vu cv vw cv cD co vu cv
      c1st cfv vw cv c1st cfv cB co wceq vv cv cX cY cxp wcel vx vy vz cB cC cD
      vu cv vw cv vu cv c1st cfv vu cv c2nd cfv vw cv c1st cfv vw cv c2nd cfv
      cX cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv eqid vu cv
      c2nd cfv eqid vw cv c1st cfv eqid vw cv c2nd cfv eqid metxptval 3adantl3
      opreq1d breqtrrd vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vw cv
      c2nd cfv cC co cle wbr wa vw cv c1st cfv vv cv c1st cfv cB co vu cv c2nd
      cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc co vu cv vw cv cD co vu
      cv vv cv cD co caddc co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv
      cv cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv
      vw cv c2nd cfv cC co cle wbr wa vw cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc co cle wbr vu cv
      c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co vu cv
      cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd
      cfv vv cv c2nd cfv cC co cr wcel vu cv c1st cfv vw cv c1st cfv cB co vu
      cv c2nd cfv vw cv c2nd cfv cC co cle wbr vu cv cX cY cxp wcel vv cv cX cY
      cxp wcel vu cv c2nd cfv vv cv c2nd cfv cC co cr wcel vw cv cX cY cxp wcel
      cC vu cv vv cv vu cv c2nd cfv vv cv c2nd cfv cY cX metxp.6 metxp.3 vu cv
      c2nd cfv eqid vv cv c2nd cfv eqid metxplem2 3adant2 adantr vu cv cX cY
      cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv
      cv c1st cfv cB co cr wcel vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd
      cfv vw cv c2nd cfv cC co cle wbr vu cv cX cY cxp wcel vv cv cX cY cxp
      wcel vu cv c1st cfv vv cv c1st cfv cB co cr wcel vw cv cX cY cxp wcel cB
      vu cv vv cv vu cv c1st cfv vv cv c1st cfv cX cY metxp.5 metxp.1 vu cv
      c1st cfv eqid vv cv c1st cfv eqid metxplem1 3adant2 adantr vu cv cX cY
      cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vw
      cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr wa vu cv
      c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr
      wa vw cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC
      co vu cv c1st cfv vv cv c1st cfv cB co caddc co vu cv c2nd cfv vw cv c2nd
      cfv cC co vu cv vv cv cD co caddc co cle vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu
      cv c2nd cfv vw cv c2nd cfv cC co cle wbr wa vw cv c1st cfv vv cv c1st cfv
      cB co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv
      cB co caddc co cle wbr vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv
      vv cv c1st cfv cB co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv
      cv cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv
      vw cv c2nd cfv cC co cle wbr vw cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co caddc
      co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel
      w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC
      co cle wbr vu cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vv cv c1st
      cfv cB co cle wbr vw cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vw
      cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co caddc co cle wbr vu
      cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv cB
      co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vw cv cX cY cxp wcel vu cv
      cX cY cxp wcel vv cv cX cY cxp wcel wa vu cv c1st cfv vv cv c1st cfv cB
      co cr wcel vu cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vv cv c1st
      cfv cB co cle wbr cB vu cv vv cv vu cv c1st cfv vv cv c1st cfv cX cY
      metxp.5 metxp.1 vu cv c1st cfv eqid vv cv c1st cfv eqid metxplem1 vu cv
      c1st cfv vv cv c1st cfv cB co leid syl 3adant2 vu cv cX cY cxp wcel vw cv
      cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv c1st cfv vv cv c1st cfv vu
      cv c1st cfv cB vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vv cv
      c1st cfv cB co cX metxp.5 metxp.1 vu cv cX cY cxp wcel vw cv cX cY cxp
      wcel vu cv c2nd cfv vw cv c2nd cfv cC co cr wcel vv cv cX cY cxp wcel cC
      vu cv vw cv vu cv c2nd cfv vw cv c2nd cfv cY cX metxp.6 metxp.3 vu cv
      c2nd cfv eqid vw cv c2nd cfv eqid metxplem2 3adant3 vu cv cX cY cxp wcel
      vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv cB co cr wcel vw cv cX
      cY cxp wcel cB vu cv vv cv vu cv c1st cfv vv cv c1st cfv cX cY metxp.5
      metxp.1 vu cv c1st cfv eqid vv cv c1st cfv eqid metxplem1 3adant2 vu cv
      cX cY cxp wcel vu cv c1st cfv cX wcel vw cv cX cY cxp wcel vw cv c1st cfv
      cX wcel vv cv cX cY cxp wcel vv cv c1st cfv cX wcel vu cv cX cY cxp wcel
      vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv
      cvv cvv cxp wcel vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel wa vu cv
      cX cY elxp7 pm3.27bi pm3.26d vw cv cX cY cxp wcel vw cv c1st cfv cX wcel
      vw cv c2nd cfv cY wcel vw cv cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv
      c1st cfv cX wcel vw cv c2nd cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi
      pm3.26d vv cv cX cY cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY
      wcel vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel vv cv c1st cfv cX wcel
      vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7 pm3.27bi pm3.26d 3anim123i
      metxplem3 mpid imp adantr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv
      cX cY cxp wcel w3a vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv
      cv c1st cfv cB co cle wbr vu cv c2nd cfv vw cv c2nd cfv cC co vu cv vv cv
      cD co caddc co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vv cv
      c1st cfv cB co caddc co wceq vu cv c1st cfv vw cv c1st cfv cB co vu cv
      c2nd cfv vw cv c2nd cfv cC co cle wbr vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vv cv c2nd cfv cC co vu
      cv c1st cfv vv cv c1st cfv cB co cle wbr wa vu cv vv cv cD co vu cv c1st
      cfv vv cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC co caddc vu cv
      cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv c2nd cfv cC co
      vu cv c1st cfv vv cv c1st cfv cB co cle wbr vu cv vv cv cD co vu cv c1st
      cfv vv cv c1st cfv cB co wceq vw cv cX cY cxp wcel vx vy vz cB cC cD vu
      cv vv cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv vv cv c2nd cfv cX
      cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv eqid vu cv c2nd
      cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid metxptval 3adantl2
      opreq2d adantlr breqtrrd vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv
      cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vw
      cv c2nd cfv cC co cle wbr wa vu cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vv cv c2nd cfv cC co cle wbr wa vw cv c1st cfv vv cv c1st cfv cB
      co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC
      co caddc co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc
      co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a
      vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC co
      cle wbr vu cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv
      cC co cle wbr vw cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vw cv
      c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC co caddc co cle wbr vu cv
      cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv c1st
      cfv vv cv c1st cfv vu cv c1st cfv cB vu cv c2nd cfv vw cv c2nd cfv cC co
      vu cv c2nd cfv vv cv c2nd cfv cC co cX metxp.5 metxp.1 vu cv cX cY cxp
      wcel vw cv cX cY cxp wcel vu cv c2nd cfv vw cv c2nd cfv cC co cr wcel vv
      cv cX cY cxp wcel cC vu cv vw cv vu cv c2nd cfv vw cv c2nd cfv cY cX
      metxp.6 metxp.3 vu cv c2nd cfv eqid vw cv c2nd cfv eqid metxplem2 3adant3
      vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv c2nd cfv
      cC co cr wcel vw cv cX cY cxp wcel cC vu cv vv cv vu cv c2nd cfv vv cv
      c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vv cv c2nd cfv eqid
      metxplem2 3adant2 vu cv cX cY cxp wcel vu cv c1st cfv cX wcel vw cv cX cY
      cxp wcel vw cv c1st cfv cX wcel vv cv cX cY cxp wcel vv cv c1st cfv cX
      wcel vu cv cX cY cxp wcel vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel
      vu cv cX cY cxp wcel vu cv cvv cvv cxp wcel vu cv c1st cfv cX wcel vu cv
      c2nd cfv cY wcel wa vu cv cX cY elxp7 pm3.27bi pm3.26d vw cv cX cY cxp
      wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel vw cv cX cY cxp wcel
      vw cv cvv cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel wa
      vw cv cX cY elxp7 pm3.27bi pm3.26d vv cv cX cY cxp wcel vv cv c1st cfv cX
      wcel vv cv c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel
      vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7
      pm3.27bi pm3.26d 3anim123i metxplem3 imp31 vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv cv c1st cfv cB co
      vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr vu cv c2nd cfv vw cv c2nd cfv
      cC co vu cv vv cv cD co caddc co vu cv c2nd cfv vw cv c2nd cfv cC co vu
      cv c2nd cfv vv cv c2nd cfv cC co caddc co wceq vu cv c1st cfv vw cv c1st
      cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr vu cv cX cY cxp
      wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv cv
      c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr wa vu cv vv cv
      cD co vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv
      cC co caddc vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv
      cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr vu cv vv cv
      cD co vu cv c2nd cfv vv cv c2nd cfv cC co wceq vw cv cX cY cxp wcel vx vy
      vz cB cC cD vu cv vv cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv vv
      cv c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv
      eqid vu cv c2nd cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid
      metxpfval 3adantl2 opreq2d adantlr breqtrrd lecasei vu cv cX cY cxp wcel
      vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st
      cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr wa vu cv vw cv cD
      co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc vu cv cX
      cY cxp wcel vw cv cX cY cxp wcel vu cv c1st cfv vw cv c1st cfv cB co vu
      cv c2nd cfv vw cv c2nd cfv cC co cle wbr vu cv vw cv cD co vu cv c2nd cfv
      vw cv c2nd cfv cC co wceq vv cv cX cY cxp wcel vx vy vz cB cC cD vu cv vw
      cv vu cv c1st cfv vu cv c2nd cfv vw cv c1st cfv vw cv c2nd cfv cX cY
      metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv eqid vu cv c2nd
      cfv eqid vw cv c1st cfv eqid vw cv c2nd cfv eqid metxpfval 3adantl3
      opreq1d breqtrrd lecasei adantr eqbrtrd vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vv cv cX cY cxp wcel w3a vw cv c1st cfv vv cv c1st cfv cB co vw
      cv c2nd cfv vv cv c2nd cfv cC co cle wbr wa vw cv vv cv cD co vw cv c2nd
      cfv vv cv c2nd cfv cC co vu cv vw cv cD co vu cv vv cv cD co caddc co cle
      vw cv cX cY cxp wcel vv cv cX cY cxp wcel vw cv c1st cfv vv cv c1st cfv
      cB co vw cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv vv cv cD co vw cv
      c2nd cfv vv cv c2nd cfv cC co wceq vu cv cX cY cxp wcel vx vy vz cB cC cD
      vw cv vv cv vw cv c1st cfv vw cv c2nd cfv vv cv c1st cfv vv cv c2nd cfv
      cX cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vw cv c1st cfv eqid vw cv
      c2nd cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid metxpfval 3adantl1
      vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv
      c2nd cfv vv cv c2nd cfv cC co vu cv vw cv cD co vu cv vv cv cD co caddc
      co cle wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd
      cfv cC co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel w3a vw cv c2nd cfv vv cv c2nd cfv cC co vu cv vw cv cD co vu cv
      vv cv cD co caddc co cle wbr vu cv c2nd cfv vw cv c2nd cfv cC co vu cv
      c1st cfv vw cv c1st cfv cB co vu cv cX cY cxp wcel vw cv cX cY cxp wcel
      vu cv c2nd cfv vw cv c2nd cfv cC co cr wcel vv cv cX cY cxp wcel cC vu cv
      vw cv vu cv c2nd cfv vw cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv
      eqid vw cv c2nd cfv eqid metxplem2 3adant3 vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vu cv c1st cfv vw cv c1st cfv cB co cr wcel vv cv cX cY cxp
      wcel cB vu cv vw cv vu cv c1st cfv vw cv c1st cfv cX cY metxp.5 metxp.1
      vu cv c1st cfv eqid vw cv c1st cfv eqid metxplem1 3adant3 vu cv cX cY cxp
      wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vw cv
      c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr wa vw cv c2nd
      cfv vv cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv
      cD co caddc co vu cv vw cv cD co vu cv vv cv cD co caddc co cle vu cv cX
      cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv
      vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr wa vw cv
      c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co vu cv
      vv cv cD co caddc co cle wbr vu cv c2nd cfv vv cv c2nd cfv cC co vu cv
      c1st cfv vv cv c1st cfv cB co vu cv cX cY cxp wcel vw cv cX cY cxp wcel
      vv cv cX cY cxp wcel w3a vu cv c2nd cfv vv cv c2nd cfv cC co cr wcel vu
      cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle
      wbr vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv c2nd
      cfv cC co cr wcel vw cv cX cY cxp wcel cC vu cv vv cv vu cv c2nd cfv vv
      cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vv cv c2nd cfv eqid
      metxplem2 3adant2 adantr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv
      cX cY cxp wcel w3a vu cv c1st cfv vv cv c1st cfv cB co cr wcel vu cv c2nd
      cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr vu
      cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv cB
      co cr wcel vw cv cX cY cxp wcel cB vu cv vv cv vu cv c1st cfv vv cv c1st
      cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vv cv c1st cfv eqid
      metxplem1 3adant2 adantr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv
      cX cY cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw
      cv c1st cfv cB co cle wbr wa vu cv c2nd cfv vv cv c2nd cfv cC co vu cv
      c1st cfv vv cv c1st cfv cB co cle wbr wa vw cv c2nd cfv vv cv c2nd cfv cC
      co vu cv c1st cfv vw cv c1st cfv cB co vu cv c1st cfv vv cv c1st cfv cB
      co caddc co vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv cD co caddc
      co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a
      vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co
      cle wbr vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv
      cB co cle wbr vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vw cv
      c1st cfv cB co vu cv c1st cfv vv cv c1st cfv cB co caddc co cle wbr vu cv
      cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv c2nd
      cfv vv cv c2nd cfv vu cv c2nd cfv cC vu cv c1st cfv vw cv c1st cfv cB co
      vu cv c1st cfv vv cv c1st cfv cB co cY metxp.6 metxp.3 vu cv cX cY cxp
      wcel vw cv cX cY cxp wcel vu cv c1st cfv vw cv c1st cfv cB co cr wcel vv
      cv cX cY cxp wcel cB vu cv vw cv vu cv c1st cfv vw cv c1st cfv cX cY
      metxp.5 metxp.1 vu cv c1st cfv eqid vw cv c1st cfv eqid metxplem1 3adant3
      vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv
      cB co cr wcel vw cv cX cY cxp wcel cB vu cv vv cv vu cv c1st cfv vv cv
      c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vv cv c1st cfv eqid
      metxplem1 3adant2 vu cv cX cY cxp wcel vu cv c2nd cfv cY wcel vw cv cX cY
      cxp wcel vw cv c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv c2nd cfv cY
      wcel vu cv cX cY cxp wcel vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel
      vu cv cX cY cxp wcel vu cv cvv cvv cxp wcel vu cv c1st cfv cX wcel vu cv
      c2nd cfv cY wcel wa vu cv cX cY elxp7 pm3.27bi pm3.27d vw cv cX cY cxp
      wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel vw cv cX cY cxp wcel
      vw cv cvv cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel wa
      vw cv cX cY elxp7 pm3.27bi pm3.27d vv cv cX cY cxp wcel vv cv c1st cfv cX
      wcel vv cv c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel
      vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7
      pm3.27bi pm3.27d 3anim123i metxplem3 imp31 vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vv cv c2nd cfv cC co
      vu cv c1st cfv vv cv c1st cfv cB co cle wbr vu cv c1st cfv vw cv c1st cfv
      cB co vu cv vv cv cD co caddc co vu cv c1st cfv vw cv c1st cfv cB co vu
      cv c1st cfv vv cv c1st cfv cB co caddc co wceq vu cv c2nd cfv vw cv c2nd
      cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr vu cv cX cY cxp
      wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vv cv
      c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr wa vu cv vv cv
      cD co vu cv c1st cfv vv cv c1st cfv cB co vu cv c1st cfv vw cv c1st cfv
      cB co caddc vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv
      cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vu cv vv cv
      cD co vu cv c1st cfv vv cv c1st cfv cB co wceq vw cv cX cY cxp wcel vx vy
      vz cB cC cD vu cv vv cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv vv
      cv c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv
      eqid vu cv c2nd cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid
      metxptval 3adantl2 opreq2d adantlr breqtrrd vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co
      vu cv c1st cfv vw cv c1st cfv cB co cle wbr wa vu cv c1st cfv vv cv c1st
      cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr wa vw cv c2nd cfv
      vv cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv
      vv cv c2nd cfv cC co caddc co vu cv c1st cfv vw cv c1st cfv cB co vu cv
      vv cv cD co caddc co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv
      cX cY cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw
      cv c1st cfv cB co cle wbr wa vw cv c2nd cfv vv cv c2nd cfv cC co vu cv
      c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co caddc
      co cle wbr vu cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd
      cfv cC co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv
      c1st cfv cB co cle wbr vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv
      vw cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co caddc co cle wbr
      vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv
      c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co cle wbr
      vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC co
      cle wbr vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv
      cB co vu cv c2nd cfv vv cv c2nd cfv cC co caddc co cle wbr vu cv cX cY
      cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv c2nd cfv cC co vu cv
      c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv cX cY cxp wcel vu cv cX cY
      cxp wcel vv cv cX cY cxp wcel wa vu cv c2nd cfv vv cv c2nd cfv cC co cr
      wcel vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC
      co cle wbr cC vu cv vv cv vu cv c2nd cfv vv cv c2nd cfv cY cX metxp.6
      metxp.3 vu cv c2nd cfv eqid vv cv c2nd cfv eqid metxplem2 vu cv c2nd cfv
      vv cv c2nd cfv cC co leid syl 3adant2 vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vv cv cX cY cxp wcel w3a vw cv c2nd cfv vv cv c2nd cfv vu cv
      c2nd cfv cC vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd
      cfv cC co cY metxp.6 metxp.3 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vu
      cv c1st cfv vw cv c1st cfv cB co cr wcel vv cv cX cY cxp wcel cB vu cv vw
      cv vu cv c1st cfv vw cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv
      eqid vw cv c1st cfv eqid metxplem1 3adant3 vu cv cX cY cxp wcel vv cv cX
      cY cxp wcel vu cv c2nd cfv vv cv c2nd cfv cC co cr wcel vw cv cX cY cxp
      wcel cC vu cv vv cv vu cv c2nd cfv vv cv c2nd cfv cY cX metxp.6 metxp.3
      vu cv c2nd cfv eqid vv cv c2nd cfv eqid metxplem2 3adant2 vu cv cX cY cxp
      wcel vu cv c2nd cfv cY wcel vw cv cX cY cxp wcel vw cv c2nd cfv cY wcel
      vv cv cX cY cxp wcel vv cv c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv
      c1st cfv cX wcel vu cv c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv cvv
      cvv cxp wcel vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel wa vu cv cX cY
      elxp7 pm3.27bi pm3.27d vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vw cv
      c2nd cfv cY wcel vw cv cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv c1st
      cfv cX wcel vw cv c2nd cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi pm3.27d
      vv cv cX cY cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel vv cv
      cX cY cxp wcel vv cv cvv cvv cxp wcel vv cv c1st cfv cX wcel vv cv c2nd
      cfv cY wcel wa vv cv cX cY elxp7 pm3.27bi pm3.27d 3anim123i metxplem3
      mpid imp adantr vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp
      wcel w3a vu cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd
      cfv cC co cle wbr vu cv c1st cfv vw cv c1st cfv cB co vu cv vv cv cD co
      caddc co vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vv cv c2nd
      cfv cC co caddc co wceq vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st
      cfv vw cv c1st cfv cB co cle wbr vu cv cX cY cxp wcel vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vv cv c2nd cfv cC co cle wbr wa vu cv vv cv cD co vu cv c2nd cfv
      vv cv c2nd cfv cC co vu cv c1st cfv vw cv c1st cfv cB co caddc vu cv cX
      cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv cB co vu
      cv c2nd cfv vv cv c2nd cfv cC co cle wbr vu cv vv cv cD co vu cv c2nd cfv
      vv cv c2nd cfv cC co wceq vw cv cX cY cxp wcel vx vy vz cB cC cD vu cv vv
      cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv vv cv c2nd cfv cX cY
      metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv eqid vu cv c2nd
      cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid metxpfval 3adantl2
      opreq2d adantlr breqtrrd lecasei vu cv cX cY cxp wcel vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co vu cv
      c1st cfv vw cv c1st cfv cB co cle wbr wa vu cv vw cv cD co vu cv c1st cfv
      vw cv c1st cfv cB co vu cv vv cv cD co caddc vu cv cX cY cxp wcel vw cv
      cX cY cxp wcel vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vw cv
      c1st cfv cB co cle wbr vu cv vw cv cD co vu cv c1st cfv vw cv c1st cfv cB
      co wceq vv cv cX cY cxp wcel vx vy vz cB cC cD vu cv vw cv vu cv c1st cfv
      vu cv c2nd cfv vw cv c1st cfv vw cv c2nd cfv cX cY metxp.1 metxp.3
      metxp.5 metxp.6 metxp.7 vu cv c1st cfv eqid vu cv c2nd cfv eqid vw cv
      c1st cfv eqid vw cv c2nd cfv eqid metxptval 3adantl3 opreq1d breqtrrd vu
      cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv
      c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr
      wa vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC
      co vu cv vv cv cD co caddc co vu cv vw cv cD co vu cv vv cv cD co caddc
      co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a
      vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co
      vu cv vv cv cD co caddc co cle wbr vu cv c1st cfv vw cv c1st cfv cB co vu
      cv c2nd cfv vw cv c2nd cfv cC co cle wbr vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vv cv cX cY cxp wcel w3a vw cv c2nd cfv vv cv c2nd cfv cC co vu
      cv c2nd cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc co cle wbr vu cv
      c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co vu cv
      cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv c2nd cfv cC co
      cr wcel vw cv cX cY cxp wcel cC vu cv vv cv vu cv c2nd cfv vv cv c2nd cfv
      cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vv cv c2nd cfv eqid metxplem2
      3adant2 vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv cv
      c1st cfv cB co cr wcel vw cv cX cY cxp wcel cB vu cv vv cv vu cv c1st cfv
      vv cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid vv cv c1st cfv
      eqid metxplem1 3adant2 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX
      cY cxp wcel w3a vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c1st cfv vv cv
      c1st cfv cB co cle wbr wa vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd
      cfv vw cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co caddc co vu
      cv c2nd cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc co cle vu cv cX
      cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv
      vv cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vw cv
      c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv
      c1st cfv vv cv c1st cfv cB co caddc co cle wbr vu cv cX cY cxp wcel vw cv
      cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC
      co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr vu cv c2nd cfv vv cv c2nd
      cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vw cv c2nd cfv vv
      cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c1st cfv vv
      cv c1st cfv cB co caddc co cle wbr wi vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd
      cfv cC co cle wbr vv cv cX cY cxp wcel vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel wa vu cv c2nd cfv vw cv c2nd cfv cC co cr wcel vu cv c2nd cfv vw
      cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr cC vu cv vw
      cv vu cv c2nd cfv vw cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv
      eqid vw cv c2nd cfv eqid metxplem2 vu cv c2nd cfv vw cv c2nd cfv cC co
      leid syl 3adant3 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel w3a vw cv c2nd cfv vv cv c2nd cfv vu cv c2nd cfv cC vu cv c2nd
      cfv vw cv c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cY metxp.6
      metxp.3 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vu cv c2nd cfv vw cv
      c2nd cfv cC co cr wcel vv cv cX cY cxp wcel cC vu cv vw cv vu cv c2nd cfv
      vw cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vw cv c2nd cfv
      eqid metxplem2 3adant3 vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv
      c1st cfv vv cv c1st cfv cB co cr wcel vw cv cX cY cxp wcel cB vu cv vv cv
      vu cv c1st cfv vv cv c1st cfv cX cY metxp.5 metxp.1 vu cv c1st cfv eqid
      vv cv c1st cfv eqid metxplem1 3adant2 vu cv cX cY cxp wcel vu cv c2nd cfv
      cY wcel vw cv cX cY cxp wcel vw cv c2nd cfv cY wcel vv cv cX cY cxp wcel
      vv cv c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv c1st cfv cX wcel vu cv
      c2nd cfv cY wcel vu cv cX cY cxp wcel vu cv cvv cvv cxp wcel vu cv c1st
      cfv cX wcel vu cv c2nd cfv cY wcel wa vu cv cX cY elxp7 pm3.27bi pm3.27d
      vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel vw cv
      cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd
      cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi pm3.27d vv cv cX cY cxp wcel vv
      cv c1st cfv cX wcel vv cv c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv cvv
      cvv cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel wa vv cv cX cY
      elxp7 pm3.27bi pm3.27d 3anim123i metxplem3 mpd imp vu cv cX cY cxp wcel
      vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vv cv c2nd
      cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr wa vu cv vv cv cD
      co vu cv c1st cfv vv cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd cfv cC
      co caddc vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv
      c2nd cfv cC co vu cv c1st cfv vv cv c1st cfv cB co cle wbr vu cv vv cv cD
      co vu cv c1st cfv vv cv c1st cfv cB co wceq vw cv cX cY cxp wcel vx vy vz
      cB cC cD vu cv vv cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv vv cv
      c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv
      eqid vu cv c2nd cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid
      metxptval 3adantl2 opreq2d breqtrrd vu cv cX cY cxp wcel vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vv cv c2nd cfv cC co cle wbr wa vw cv c2nd cfv vv cv c2nd cfv cC
      co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC
      co caddc co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv vv cv cD co caddc
      co cle vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a
      vw cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co
      vu cv c2nd cfv vv cv c2nd cfv cC co caddc co cle wbr vu cv c1st cfv vv cv
      c1st cfv cB co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr vu cv cX cY
      cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vu cv c2nd cfv vw
      cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr vw cv c2nd
      cfv vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c2nd
      cfv vv cv c2nd cfv cC co caddc co cle wbr vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd
      cfv cC co cle wbr vv cv cX cY cxp wcel vu cv cX cY cxp wcel vw cv cX cY
      cxp wcel wa vu cv c2nd cfv vw cv c2nd cfv cC co cr wcel vu cv c2nd cfv vw
      cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co cle wbr cC vu cv vw
      cv vu cv c2nd cfv vw cv c2nd cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv
      eqid vw cv c2nd cfv eqid metxplem2 vu cv c2nd cfv vw cv c2nd cfv cC co
      leid syl 3adant3 vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel w3a vu cv c2nd cfv vw cv c2nd cfv cC co vu cv c2nd cfv vw cv
      c2nd cfv cC co cle wbr vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd cfv
      vv cv c2nd cfv cC co cle wbr vw cv c2nd cfv vv cv c2nd cfv cC co vu cv
      c2nd cfv vw cv c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC co caddc
      co cle wbr vu cv cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv
      c2nd cfv cC co vu cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv cX cY
      cxp wcel vu cv cX cY cxp wcel vv cv cX cY cxp wcel wa vu cv c2nd cfv vv
      cv c2nd cfv cC co cr wcel vu cv c2nd cfv vv cv c2nd cfv cC co vu cv c2nd
      cfv vv cv c2nd cfv cC co cle wbr cC vu cv vv cv vu cv c2nd cfv vv cv c2nd
      cfv cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vv cv c2nd cfv eqid
      metxplem2 vu cv c2nd cfv vv cv c2nd cfv cC co leid syl 3adant2 vu cv cX
      cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY cxp wcel w3a vw cv c2nd cfv
      vv cv c2nd cfv vu cv c2nd cfv cC vu cv c2nd cfv vw cv c2nd cfv cC co vu
      cv c2nd cfv vv cv c2nd cfv cC co cY metxp.6 metxp.3 vu cv cX cY cxp wcel
      vw cv cX cY cxp wcel vu cv c2nd cfv vw cv c2nd cfv cC co cr wcel vv cv cX
      cY cxp wcel cC vu cv vw cv vu cv c2nd cfv vw cv c2nd cfv cY cX metxp.6
      metxp.3 vu cv c2nd cfv eqid vw cv c2nd cfv eqid metxplem2 3adant3 vu cv
      cX cY cxp wcel vv cv cX cY cxp wcel vu cv c2nd cfv vv cv c2nd cfv cC co
      cr wcel vw cv cX cY cxp wcel cC vu cv vv cv vu cv c2nd cfv vv cv c2nd cfv
      cY cX metxp.6 metxp.3 vu cv c2nd cfv eqid vv cv c2nd cfv eqid metxplem2
      3adant2 vu cv cX cY cxp wcel vu cv c2nd cfv cY wcel vw cv cX cY cxp wcel
      vw cv c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv c2nd cfv cY wcel vu cv
      cX cY cxp wcel vu cv c1st cfv cX wcel vu cv c2nd cfv cY wcel vu cv cX cY
      cxp wcel vu cv cvv cvv cxp wcel vu cv c1st cfv cX wcel vu cv c2nd cfv cY
      wcel wa vu cv cX cY elxp7 pm3.27bi pm3.27d vw cv cX cY cxp wcel vw cv
      c1st cfv cX wcel vw cv c2nd cfv cY wcel vw cv cX cY cxp wcel vw cv cvv
      cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel wa vw cv cX cY
      elxp7 pm3.27bi pm3.27d vv cv cX cY cxp wcel vv cv c1st cfv cX wcel vv cv
      c2nd cfv cY wcel vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel vv cv c1st
      cfv cX wcel vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7 pm3.27bi pm3.27d
      3anim123i metxplem3 mpid mpd adantr vu cv cX cY cxp wcel vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel w3a vu cv c1st cfv vv cv c1st cfv cB co vu cv
      c2nd cfv vv cv c2nd cfv cC co cle wbr wa vu cv vv cv cD co vu cv c2nd cfv
      vv cv c2nd cfv cC co vu cv c2nd cfv vw cv c2nd cfv cC co caddc vu cv cX
      cY cxp wcel vv cv cX cY cxp wcel vu cv c1st cfv vv cv c1st cfv cB co vu
      cv c2nd cfv vv cv c2nd cfv cC co cle wbr vu cv vv cv cD co vu cv c2nd cfv
      vv cv c2nd cfv cC co wceq vw cv cX cY cxp wcel vx vy vz cB cC cD vu cv vv
      cv vu cv c1st cfv vu cv c2nd cfv vv cv c1st cfv vv cv c2nd cfv cX cY
      metxp.1 metxp.3 metxp.5 metxp.6 metxp.7 vu cv c1st cfv eqid vu cv c2nd
      cfv eqid vv cv c1st cfv eqid vv cv c2nd cfv eqid metxpfval 3adantl2
      opreq2d breqtrrd lecasei adantr vu cv cX cY cxp wcel vw cv cX cY cxp wcel
      vv cv cX cY cxp wcel w3a vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd
      cfv vw cv c2nd cfv cC co cle wbr wa vu cv vw cv cD co vu cv c2nd cfv vw
      cv c2nd cfv cC co vu cv vv cv cD co caddc vu cv cX cY cxp wcel vw cv cX
      cY cxp wcel vu cv c1st cfv vw cv c1st cfv cB co vu cv c2nd cfv vw cv c2nd
      cfv cC co cle wbr vu cv vw cv cD co vu cv c2nd cfv vw cv c2nd cfv cC co
      wceq vv cv cX cY cxp wcel vx vy vz cB cC cD vu cv vw cv vu cv c1st cfv vu
      cv c2nd cfv vw cv c1st cfv vw cv c2nd cfv cX cY metxp.1 metxp.3 metxp.5
      metxp.6 metxp.7 vu cv c1st cfv eqid vu cv c2nd cfv eqid vw cv c1st cfv
      eqid vw cv c2nd cfv eqid metxpfval 3adantl3 opreq1d breqtrrd lecasei
      adantr eqbrtrd lecasei $.
      $( [4-Oct-2007] $) $( [11-Jul-2007] $)

    $( The direct product of two metric spaces.  Definition 14-1.5 of [Gleason]
       p. 225. $)
    metxp $p |- D e. Met $=
      vw vv vu cD cX cY cxp cX cY cX cB cdm cdm cvv metxp.1 cB cdm cB cme wcel
      cB cdm cvv wcel metxp.5 cB cme dmexg ax-mp dmex eqeltri cY cC cdm cdm cvv
      metxp.3 cC cdm cC cme wcel cC cdm cvv wcel metxp.6 cC cme dmexg ax-mp
      dmex eqeltri xpex cX cY cxp cX cY cxp cxp cr cD wf cD cX cY cxp cX cY cxp
      cxp wfn vw cv vv cv cD co cr wcel vv cX cY cxp wral vw cX cY cxp wral vw
      vv cX cY cxp cX cY cxp cr cD ffnoprv vx vy vz cX cY cxp cX cY cxp vx cv
      c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr
      clt csup cD cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv
      c2nd cfv cC co cpr clt ltso supex metxp.7 fnoprab2 vw cv vv cv cD co cr
      wcel vw vv cX cY cxp vx vy vz cB cC cD vw cv vv cv cX cY metxp.1 metxp.3
      metxp.5 metxp.6 metxp.7 metxpcl rgen2a mpbir2an vw cv cX cY cxp wcel vv
      cv cX cY cxp wcel wa vw cv vv cv cD co cc0 wceq vw cv c2nd cfv vv cv c2nd
      cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv
      cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cif cc0 wceq vw cv
      vv cv wceq vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv vv cv cD co
      vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co
      clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv
      cC co cif cc0 vx vy vz cB cC cD vw cv vv cv vw cv c1st cfv vw cv c2nd cfv
      vv cv c1st cfv vv cv c2nd cfv cX cY metxp.1 metxp.3 metxp.5 metxp.6
      metxp.7 vw cv c1st cfv eqid vw cv c2nd cfv eqid vv cv c1st cfv eqid vv cv
      c2nd cfv eqid metxpdval eqeq1d vw cv cX cY cxp wcel vv cv cX cY cxp wcel
      wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB
      co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd
      cfv cC co cif cc0 wceq vw cv vv cv wceq vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st
      cfv cB co clt wbr vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv
      cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd
      cfv vv cv c2nd cfv cC co cif cc0 wceq vw cv vv cv wceq wi vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv
      c1st cfv vv cv c1st cfv cB co clt wbr wa vw cv c2nd cfv vv cv c2nd cfv cC
      co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st
      cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cif cc0 wceq vw cv c1st cfv
      vv cv c1st cfv cB co cc0 wceq vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd
      cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw cv c2nd cfv vv
      cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st
      cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cif cc0 wceq
      vw cv c1st cfv vv cv c1st cfv cB co cc0 wceq wb vw cv cX cY cxp wcel vv
      cv cX cY cxp wcel wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv
      vv cv c1st cfv cB co clt wbr vw cv c2nd cfv vv cv c2nd cfv cC co vw cv
      c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co
      vw cv c2nd cfv vv cv c2nd cfv cC co cif vw cv c1st cfv vv cv c1st cfv cB
      co cc0 vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv
      cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv
      c2nd cfv cC co iftrue eqeq1d adantl vw cv cX cY cxp wcel vv cv cX cY cxp
      wcel wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv
      cB co clt wbr wa vw cv c1st cfv vv cv c1st cfv cB co cc0 wceq vw cv vv cv
      wceq vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c2nd cfv vv cv
      c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr wa vw cv c1st
      cfv vv cv c1st cfv cB co cc0 wceq wa vw cv c2nd cfv vv cv c2nd cfv cC co
      cc0 clt wbr vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd cfv cC co vw cv
      c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co
      cc0 wceq vw cv c2nd cfv vv cv c2nd cfv cC co cc0 clt wbr vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel wa vw cv c1st cfv vv cv c1st cfv cB co cc0 wceq
      vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co
      clt wbr vw cv c2nd cfv vv cv c2nd cfv cC co cc0 clt wbr vw cv c1st cfv vv
      cv c1st cfv cB co cc0 vw cv c2nd cfv vv cv c2nd cfv cC co clt breq2
      biimpac adantll vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c2nd
      cfv vv cv c2nd cfv cC co cc0 clt wbr vw cv vv cv wceq wi vw cv c2nd cfv
      vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw cv
      c1st cfv vv cv c1st cfv cB co cc0 wceq vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel wa vw cv c2nd cfv vv cv c2nd cfv cC co cc0 clt wbr vw cv vv cv
      wceq vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel vw cv c2nd cfv vv cv
      c2nd cfv cC co cc0 clt wbr wn vw cv cX cY cxp wcel vv cv cX cY cxp wcel
      vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel wa cc0 vw cv c2nd cfv vv cv
      c2nd cfv cC co cle wbr vw cv c2nd cfv vv cv c2nd cfv cC co cc0 clt wbr wn
      cC cme wcel vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel cc0 vw cv c2nd
      cfv vv cv c2nd cfv cC co cle wbr metxp.6 vw cv c2nd cfv vv cv c2nd cfv cC
      cY metxp.3 metge0 mp3an1 cc0 cr wcel vw cv c2nd cfv vv cv c2nd cfv cC co
      cr wcel cc0 vw cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv c2nd cfv vv
      cv c2nd cfv cC co cc0 clt wbr wn wb vw cv c2nd cfv cY wcel vv cv c2nd cfv
      cY wcel wa cc0 vw cv c2nd cfv vv cv c2nd cfv cC co lenlt 0re cC cme wcel
      vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel vw cv c2nd cfv vv cv c2nd
      cfv cC co cr wcel metxp.6 vw cv c2nd cfv vv cv c2nd cfv cC cY metxp.3
      metcl mp3an1 sylancr mpbid vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vw
      cv c2nd cfv cY wcel vw cv cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv
      c1st cfv cX wcel vw cv c2nd cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi
      pm3.27d vv cv cX cY cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY
      wcel vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel vv cv c1st cfv cX wcel
      vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7 pm3.27bi pm3.27d syl2an
      pm2.21d ad2antrr mpd ex sylbid vw cv cX cY cxp wcel vv cv cX cY cxp wcel
      wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB
      co clt wbr wn wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv
      c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv
      vv cv c2nd cfv cC co cif cc0 wceq vw cv c2nd cfv vv cv c2nd cfv cC co cc0
      wceq vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv
      vv cv c1st cfv cB co clt wbr wn vw cv c2nd cfv vv cv c2nd cfv cC co vw cv
      c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co
      vw cv c2nd cfv vv cv c2nd cfv cC co cif cc0 wceq vw cv c2nd cfv vv cv
      c2nd cfv cC co cc0 wceq wb vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa
      vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co
      clt wbr wn vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st
      cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv
      cv c2nd cfv cC co cif vw cv c2nd cfv vv cv c2nd cfv cC co cc0 vw cv c2nd
      cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw
      cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co
      iffalse eqeq1d adantl vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv
      c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr
      wn vw cv c2nd cfv vv cv c2nd cfv cC co cc0 wceq vw cv vv cv wceq wi vw cv
      cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c2nd cfv vv cv c2nd cfv cC
      co vw cv c1st cfv vv cv c1st cfv cB co clt wbr wn vw cv c1st cfv vv cv
      c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv c2nd cfv
      vv cv c2nd cfv cC co cc0 wceq vw cv vv cv wceq wi vw cv c1st cfv vv cv
      c1st cfv cB co cr wcel vw cv c2nd cfv vv cv c2nd cfv cC co cr wcel vw cv
      c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cle wbr
      vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co
      clt wbr wn wb vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c1st cfv
      vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co lenlt cB vw cv
      vv cv vw cv c1st cfv vv cv c1st cfv cX cY metxp.5 metxp.1 vw cv c1st cfv
      eqid vv cv c1st cfv eqid metxplem1 cC vw cv vv cv vw cv c2nd cfv vv cv
      c2nd cfv cY cX metxp.6 metxp.3 vw cv c2nd cfv eqid vv cv c2nd cfv eqid
      metxplem2 sylanc vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c2nd
      cfv vv cv c2nd cfv cC co cc0 wceq vw cv c1st cfv vv cv c1st cfv cB co vw
      cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv vv cv wceq vw cv cX cY cxp
      wcel vv cv cX cY cxp wcel wa vw cv c2nd cfv vv cv c2nd cfv cC co cc0 wceq
      vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co
      cle wbr vw cv vv cv wceq wi vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa
      vw cv c2nd cfv vv cv c2nd cfv cC co cc0 wceq wa vw cv c1st cfv vv cv c1st
      cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cle wbr vw cv c1st cfv vv
      cv c1st cfv cB co cc0 wceq vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd cfv
      cC co cc0 wceq vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv
      c2nd cfv cC co cle wbr vw cv c1st cfv vv cv c1st cfv cB co cc0 cle wbr vw
      cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c1st cfv vv cv c1st cfv
      cB co cc0 wceq vw cv c2nd cfv vv cv c2nd cfv cC co cc0 vw cv c1st cfv vv
      cv c1st cfv cB co cle breq2 vw cv c1st cfv cX wcel vv cv c1st cfv cX wcel
      vw cv c1st cfv vv cv c1st cfv cB co cc0 cle wbr vw cv c1st cfv vv cv c1st
      cfv cB co cc0 wceq wb vw cv cX cY cxp wcel vv cv cX cY cxp wcel vw cv
      c1st cfv cX wcel vv cv c1st cfv cX wcel wa vw cv c1st cfv vv cv c1st cfv
      cB co cc0 cle wbr vw cv c1st cfv vv cv c1st cfv cB co cc0 cle wbr cc0 vw
      cv c1st cfv vv cv c1st cfv cB co cle wbr wa vw cv c1st cfv vv cv c1st cfv
      cB co cc0 wceq vw cv c1st cfv cX wcel vv cv c1st cfv cX wcel wa cc0 vw cv
      c1st cfv vv cv c1st cfv cB co cle wbr vw cv c1st cfv vv cv c1st cfv cB co
      cc0 cle wbr cB cme wcel vw cv c1st cfv cX wcel vv cv c1st cfv cX wcel cc0
      vw cv c1st cfv vv cv c1st cfv cB co cle wbr metxp.5 vw cv c1st cfv vv cv
      c1st cfv cB cX metxp.1 metge0 mp3an1 biantrud vw cv c1st cfv vv cv c1st
      cfv cB co cr wcel cc0 cr wcel vw cv c1st cfv vv cv c1st cfv cB co cc0
      wceq vw cv c1st cfv vv cv c1st cfv cB co cc0 cle wbr cc0 vw cv c1st cfv
      vv cv c1st cfv cB co cle wbr wa wb vw cv c1st cfv cX wcel vv cv c1st cfv
      cX wcel wa vw cv c1st cfv vv cv c1st cfv cB co cc0 letri3 cB cme wcel vw
      cv c1st cfv cX wcel vv cv c1st cfv cX wcel vw cv c1st cfv vv cv c1st cfv
      cB co cr wcel metxp.5 vw cv c1st cfv vv cv c1st cfv cB cX metxp.1 metcl
      mp3an1 0re sylancl bitr4d vw cv cX cY cxp wcel vw cv c1st cfv cX wcel vw
      cv c2nd cfv cY wcel vw cv cX cY cxp wcel vw cv cvv cvv cxp wcel vw cv
      c1st cfv cX wcel vw cv c2nd cfv cY wcel wa vw cv cX cY elxp7 pm3.27bi
      pm3.26d vv cv cX cY cxp wcel vv cv c1st cfv cX wcel vv cv c2nd cfv cY
      wcel vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel vv cv c1st cfv cX wcel
      vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7 pm3.27bi pm3.26d syl2an
      sylan9bbr vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c2nd cfv vv
      cv c2nd cfv cC co cc0 wceq vw cv c1st cfv vv cv c1st cfv cB co cc0 wceq
      vw cv vv cv wceq vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c2nd
      cfv vv cv c2nd cfv cC co cc0 wceq vw cv c1st cfv vv cv c1st cfv cB co cc0
      wceq wa vw cv vv cv wceq vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw
      cv c2nd cfv vv cv c2nd cfv cC co cc0 wceq vw cv c1st cfv vv cv c1st cfv
      cB co cc0 wceq wa vw cv c2nd cfv vv cv c2nd cfv wceq vw cv c1st cfv vv cv
      c1st cfv wceq wa vw cv vv cv wceq vw cv c1st cfv cX wcel vw cv c2nd cfv
      cY wcel wa vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel wa vw cv c2nd
      cfv vv cv c2nd cfv cC co cc0 wceq vw cv c1st cfv vv cv c1st cfv cB co cc0
      wceq wa vw cv c2nd cfv vv cv c2nd cfv wceq vw cv c1st cfv vv cv c1st cfv
      wceq wa wb vw cv cX cY cxp wcel vv cv cX cY cxp wcel vw cv c1st cfv cX
      wcel vv cv c1st cfv cX wcel vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel
      vw cv c2nd cfv vv cv c2nd cfv cC co cc0 wceq vw cv c1st cfv vv cv c1st
      cfv cB co cc0 wceq wa vw cv c2nd cfv vv cv c2nd cfv wceq vw cv c1st cfv
      vv cv c1st cfv wceq wa wb vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel
      wa vw cv c2nd cfv vv cv c2nd cfv cC co cc0 wceq vw cv c2nd cfv vv cv c2nd
      cfv wceq vw cv c1st cfv cX wcel vv cv c1st cfv cX wcel wa vw cv c1st cfv
      vv cv c1st cfv cB co cc0 wceq vw cv c1st cfv vv cv c1st cfv wceq cC cme
      wcel vw cv c2nd cfv cY wcel vv cv c2nd cfv cY wcel vw cv c2nd cfv vv cv
      c2nd cfv cC co cc0 wceq vw cv c2nd cfv vv cv c2nd cfv wceq wb metxp.6 vw
      cv c2nd cfv vv cv c2nd cfv cC cY metxp.3 meteq0 mp3an1 cB cme wcel vw cv
      c1st cfv cX wcel vv cv c1st cfv cX wcel vw cv c1st cfv vv cv c1st cfv cB
      co cc0 wceq vw cv c1st cfv vv cv c1st cfv wceq wb metxp.5 vw cv c1st cfv
      vv cv c1st cfv cB cX metxp.1 meteq0 mp3an1 bi2anan9r an4s vw cv cX cY cxp
      wcel vw cv cvv cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel
      wa vw cv cX cY elxp7 pm3.27bi vv cv cX cY cxp wcel vv cv cvv cvv cxp wcel
      vv cv c1st cfv cX wcel vv cv c2nd cfv cY wcel wa vv cv cX cY elxp7
      pm3.27bi syl2an vw cv cX cY cxp wcel vv cv cX cY cxp wcel wa vw cv c1st
      cfv vv cv c1st cfv wceq vw cv c2nd cfv vv cv c2nd cfv wceq wa vw cv vv cv
      wceq vw cv c2nd cfv vv cv c2nd cfv wceq vw cv c1st cfv vv cv c1st cfv
      wceq wa vw cv vv cv cX cY cX cY xpopth vw cv c2nd cfv vv cv c2nd cfv wceq
      vw cv c1st cfv vv cv c1st cfv wceq ancom syl5bb bitrd biimpd expdimp
      sylbid ex com23 sylbird imp sylbid pm2.61dan vw cv cX cY cxp wcel vw cv
      vv cv wceq vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st
      cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv
      cv c2nd cfv cC co cif cc0 wceq wi vv cv cX cY cxp wcel vw cv cX cY cxp
      wcel vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv
      vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv
      c2nd cfv vv cv c2nd cfv cC co cif cc0 wceq vw cv cX cY cxp wcel vw cv vv
      cv wceq wa vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st
      cfv cB co clt wbr cc0 cc0 cif vw cv c2nd cfv vv cv c2nd cfv cC co vw cv
      c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co
      vw cv c2nd cfv vv cv c2nd cfv cC co cif cc0 vw cv c1st cfv cX wcel vw cv
      c2nd cfv cY wcel wa vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd cfv cC co
      vw cv c1st cfv vv cv c1st cfv cB co clt wbr cc0 cc0 cif vw cv c2nd cfv vv
      cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr vw cv c1st
      cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv c2nd cfv cC co cif wceq vw
      cv cX cY cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY wcel vw cv vv
      cv wceq vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv
      cB co clt wbr cc0 cc0 cif vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st
      cfv vv cv c1st cfv cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw
      cv c2nd cfv vv cv c2nd cfv cC co cif wceq cc0 vw cv c1st cfv vv cv c1st
      cfv cB co wceq cc0 vw cv c2nd cfv vv cv c2nd cfv cC co wceq vw cv c2nd
      cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv cB co clt wbr cc0
      cc0 cif vw cv c2nd cfv vv cv c2nd cfv cC co vw cv c1st cfv vv cv c1st cfv
      cB co clt wbr vw cv c1st cfv vv cv c1st cfv cB co vw cv c2nd cfv vv cv
      c2nd cfv cC co cif wceq vw cv c1st cfv cX wcel vw cv vv cv wceq wa vw cv
      c2nd cfv cY wcel vw cv vv cv wceq wa vw cv c2nd cfv vv cv c2nd cfv cC co
      vw cv c1st cfv vv cv c1st cfv cB co clt wbr cc0 vw cv c1st cfv vv cv c1st
      cfv cB co cc0 vw cv c2nd cfv vv cv c2nd cfv cC co ifeq12 vw cv c1st cfv
      cX wcel vw cv vv cv wceq cc0 vw cv c1st cfv vw cv c1st cfv cB co vw cv
      c1st cfv vv cv c1st cfv cB co cB cme wcel vw cv c1st cfv cX wcel vw cv
      c1st cfv vw cv c1st cfv cB co cc0 wceq metxp.5 vw cv c1st cfv cB cX
      metxp.1 met0 mpan vw cv vv cv wceq vw cv c1st cfv vv cv c1st cfv vw cv
      c1st cfv cB vw cv vv cv c1st fveq2 opreq2d sylan9req vw cv c2nd cfv cY
      wcel vw cv vv cv wceq cc0 vw cv c2nd cfv vw cv c2nd cfv cC co vw cv c2nd
      cfv vv cv c2nd cfv cC co cC cme wcel vw cv c2nd cfv cY wcel vw cv c2nd
      cfv vw cv c2nd cfv cC co cc0 wceq metxp.6 vw cv c2nd cfv cC cY metxp.3
      met0 mpan vw cv vv cv wceq vw cv c2nd cfv vv cv c2nd cfv vw cv c2nd cfv
      cC vw cv vv cv c2nd fveq2 opreq2d sylan9req syl2an anandirs vw cv cX cY
      cxp wcel vw cv cvv cvv cxp wcel vw cv c1st cfv cX wcel vw cv c2nd cfv cY
      wcel wa vw cv cX cY elxp7 pm3.27bi sylan vw cv c2nd cfv vv cv c2nd cfv cC
      co vw cv c1st cfv vv cv c1st cfv cB co clt wbr cc0 ifid syl5reqr ex
      adantr impbid bitrd vu cv cX cY cxp wcel vw cv cX cY cxp wcel vv cv cX cY
      cxp wcel vw cv vv cv cD co vu cv vw cv cD co vu cv vv cv cD co caddc co
      cle wbr vx vy vz vw vv vu cB cC cD cX cY metxp.1 metxp.3 metxp.5 metxp.6
      metxp.7 metxplem4 3coml ismeti $.
      $( [4-Oct-2007] $) $( [20-Jun-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Metric space balls
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u w x y z D $.  $d t u w x y z X $.  $d v y $.
    blfval.1 $e |- X = dom dom D $.
    $( The value of the ball function. $)
    blfval $p |- ( D e. Met -> ( ball ` D ) =
  { <. <. x , y >. , z >. | ( ( x e. X /\ y e. RR ) /\ ( 0 < y /\ z =
                { w e. X | ( x D w ) < y } ) ) } ) $=
      cD cme wcel vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv
      vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx vy vz copab2 cvv wcel
      cD cbl cfv vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv
      vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx vy vz copab2 wceq cD
      cme wcel cX cvv wcel vx cv cX wcel vy cv cr wcel wa vz cv vx cv vw cv cD
      co vy cv clt wbr vw cX crab wceq wa vx vy vz copab2 cvv wcel vx cv cX
      wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv vw cv cD co vy cv clt
      wbr vw cX crab wceq wa wa vx vy vz copab2 cvv wcel cD cme wcel cD cdm cdm
      cvv cX cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD
      cdm cvv dmexg syl blfval.1 syl5eqel cX cvv wcel cr cvv wcel vx cv cX wcel
      vy cv cr wcel wa vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa
      vx vy vz copab2 cvv wcel reex vx vy vz cX cr vx cv vw cv cD co vy cv clt
      wbr vw cX crab cvv cvv vx cv cX wcel vy cv cr wcel wa vz cv vx cv vw cv
      cD co vy cv clt wbr vw cX crab wceq wa vx vy vz copab2 vx cv cX wcel vy
      cv cr wcel wa vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa vx
      vy vz copab2 eqid oprabex2g mpan2 vx cv cX wcel vy cv cr wcel wa cc0 vy
      cv clt wbr vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx
      vy vz copab2 vx cv cX wcel vy cv cr wcel wa vz cv vx cv vw cv cD co vy cv
      clt wbr vw cX crab wceq wa vx vy vz copab2 wss vx cv cX wcel vy cv cr
      wcel wa vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa vx vy vz
      copab2 cvv wcel vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx
      cv vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx vy vz copab2 cvv
      wcel vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv vw cv
      cD co vy cv clt wbr vw cX crab wceq wa wa vx cv cX wcel vy cv cr wcel wa
      vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa vx vy vz cc0 vy
      cv clt wbr vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa vz cv
      vx cv vw cv cD co vy cv clt wbr vw cX crab wceq vx cv cX wcel vy cv cr
      wcel wa cc0 vy cv clt wbr vz cv vx cv vw cv cD co vy cv clt wbr vw cX
      crab wceq pm3.27 anim2i ssoprab2i vx cv cX wcel vy cv cr wcel wa cc0 vy
      cv clt wbr vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx
      vy vz copab2 vx cv cX wcel vy cv cr wcel wa vz cv vx cv vw cv cD co vy cv
      clt wbr vw cX crab wceq wa vx vy vz copab2 cvv ssexg mpan 3syl vt vu cD
      vx cv vt cv cdm cdm wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv
      vw cv vt cv co vy cv clt wbr vw vt cv cdm cdm crab wceq wa wa vx vy vz
      copab2 vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv vw cv
      cD co vy cv clt wbr vw cX crab wceq wa wa vx vy vz copab2 cme cvv cbl vt
      cv cD wceq vx cv vt cv cdm cdm wcel vy cv cr wcel wa cc0 vy cv clt wbr vz
      cv vx cv vw cv vt cv co vy cv clt wbr vw vt cv cdm cdm crab wceq wa wa vx
      cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv vw cv cD co vy
      cv clt wbr vw cX crab wceq wa wa vx vy vz vt cv cD wceq vx cv vt cv cdm
      cdm wcel vy cv cr wcel wa vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt
      wbr vz cv vx cv vw cv vt cv co vy cv clt wbr vw vt cv cdm cdm crab wceq
      wa cc0 vy cv clt wbr vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab
      wceq wa vt cv cD wceq vx cv vt cv cdm cdm wcel vx cv cX wcel vy cv cr
      wcel vt cv cD wceq vt cv cdm cdm cX vx cv vt cv cD wceq vt cv cdm cdm cD
      cdm cdm cX vt cv cD wceq vt cv cdm cD cdm vt cv cD dmeq dmeqd blfval.1
      syl6eqr eleq2d anbi1d vt cv cD wceq vz cv vx cv vw cv vt cv co vy cv clt
      wbr vw vt cv cdm cdm crab wceq vz cv vx cv vw cv cD co vy cv clt wbr vw
      cX crab wceq cc0 vy cv clt wbr vt cv cD wceq vx cv vw cv vt cv co vy cv
      clt wbr vw vt cv cdm cdm crab vx cv vw cv cD co vy cv clt wbr vw cX crab
      vz cv vt cv cD wceq vx cv vw cv vt cv co vy cv clt wbr vw vt cv cdm cdm
      crab vx cv vw cv vt cv co vy cv clt wbr vw cX crab vx cv vw cv cD co vy
      cv clt wbr vw cX crab vt cv cD wceq vt cv cdm cdm cX wceq vx cv vw cv vt
      cv co vy cv clt wbr vw vt cv cdm cdm crab vx cv vw cv vt cv co vy cv clt
      wbr vw cX crab wceq vt cv cD wceq vt cv cdm cdm cD cdm cdm cX vt cv cD
      wceq vt cv cdm cD cdm vt cv cD dmeq dmeqd blfval.1 syl6eqr vx cv vw cv vt
      cv co vy cv clt wbr vw vt cv cdm cdm cX rabeq syl vt cv cD wceq vx cv vw
      cv vt cv co vy cv clt wbr vx cv vw cv cD co vy cv clt wbr vw cX vt cv cD
      wceq vx cv vw cv vt cv co vx cv vw cv cD co vy cv clt vx cv vw cv vt cv
      cD opreq breq1d rabbisdv eqtrd eqeq2d anbi2d anbi12d oprabbidv vt vu vx
      vy vz vw df-bl fvopab4g mpdan $.
      $( [5-Sep-2007] $) $( [30-Aug-2006] $)

    $( Alternate value of the ball function  that simplifies its use with
       operation theorems. $)
    blfval2 $p |- ( D e. Met -> ( ball ` D ) = { <. <. x , y >. , z >. |
                   ( ( x e. X /\ y e. { v e. RR | 0 < v } )
                 /\ z = { w e. X | ( x D w ) < y } ) } ) $=
      cD cme wcel cD cbl cfv vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr
      vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx vy vz
      copab2 vx cv cX wcel vy cv cc0 vv cv clt wbr vv cr crab wcel wa vz cv vx
      cv vw cv cD co vy cv clt wbr vw cX crab wceq wa vx vy vz copab2 vx vy vz
      vw cD cX blfval.1 blfval vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr
      vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx cv cX wcel
      vy cv cc0 vv cv clt wbr vv cr crab wcel wa vz cv vx cv vw cv cD co vy cv
      clt wbr vw cX crab wceq wa vx vy vz vx cv cX wcel vy cv cr wcel wa cc0 vy
      cv clt wbr vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa wa vx
      cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr wa vz cv vx cv vw cv cD co
      vy cv clt wbr vw cX crab wceq wa vx cv cX wcel vy cv cc0 vv cv clt wbr vv
      cr crab wcel wa vz cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq wa
      vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr vz cv vx cv vw cv cD co
      vy cv clt wbr vw cX crab wceq anass vx cv cX wcel vy cv cr wcel wa cc0 vy
      cv clt wbr wa vx cv cX wcel vy cv cc0 vv cv clt wbr vv cr crab wcel wa vz
      cv vx cv vw cv cD co vy cv clt wbr vw cX crab wceq vx cv cX wcel vy cv cr
      wcel wa cc0 vy cv clt wbr wa vx cv cX wcel vy cv cr wcel cc0 vy cv clt
      wbr wa wa vx cv cX wcel vy cv cc0 vv cv clt wbr vv cr crab wcel wa vx cv
      cX wcel vy cv cr wcel cc0 vy cv clt wbr anass vy cv cc0 vv cv clt wbr vv
      cr crab wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv cX wcel cc0 vv cv
      clt wbr cc0 vy cv clt wbr vv vy cv cr vv cv vy cv cc0 clt breq2 elrab
      anbi2i bitr4i anbi1i bitr3i oprabbii syl6eq $.
      $( [16-Sep-2007] $) $( [31-Aug-2006] $)
  $}

  ${
    $d x A $.  $d x y B $.  $d v w x y z D $.  $d w x y z P $.  $d x Q $.
    $d v w x y z R $.  $d v w x y z X $.
    blval.1 $e |- X = dom dom D $.
    $( The ball around a point ` P ` is the set of all points whose distance
       from ` P ` is less than the ball's radius ` R ` . $)
    blval $p |- ( ( ( D e. Met /\ P e. X ) /\
                  ( R e. RR /\ 0 < R ) ) -> ( P ( ball ` D ) R ) =
                  { x e. X | ( P D x ) < R } ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl
      cfv co cP cR vy cv cX wcel vz cv cc0 vv cv clt wbr vv cr crab wcel wa vw
      cv vy cv vx cv cD co vz cv clt wbr vx cX crab wceq wa vy vz vw copab2 co
      cP vx cv cD co cR clt wbr vx cX crab cD cme wcel cP cR cD cbl cfv co cP
      cR vy cv cX wcel vz cv cc0 vv cv clt wbr vv cr crab wcel wa vw cv vy cv
      vx cv cD co vz cv clt wbr vx cX crab wceq wa vy vz vw copab2 co wceq cP
      cX wcel cR cr wcel cc0 cR clt wbr wa cD cme wcel cD cbl cfv vy cv cX wcel
      vz cv cc0 vv cv clt wbr vv cr crab wcel wa vw cv vy cv vx cv cD co vz cv
      clt wbr vx cX crab wceq wa vy vz vw copab2 cP cR vy vz vw vx vv cD cX
      blval.1 blfval2 opreqd ad2antrr cP cX wcel cR cc0 vv cv clt wbr vv cr
      crab wcel cP vx cv cD co cR clt wbr vx cX crab cvv wcel cP cR vy cv cX
      wcel vz cv cc0 vv cv clt wbr vv cr crab wcel wa vw cv vy cv vx cv cD co
      vz cv clt wbr vx cX crab wceq wa vy vz vw copab2 co cP vx cv cD co cR clt
      wbr vx cX crab wceq cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr
      wa wa vy vz vw cP cR cX cc0 vv cv clt wbr vv cr crab vy cv vx cv cD co vz
      cv clt wbr vx cX crab cP vx cv cD co cR clt wbr vx cX crab vy cv cX wcel
      vz cv cc0 vv cv clt wbr vv cr crab wcel wa vw cv vy cv vx cv cD co vz cv
      clt wbr vx cX crab wceq wa vy vz vw copab2 cP vx cv cD co vz cv clt wbr
      vx cX crab cvv vy cv cP wceq vy cv vx cv cD co vz cv clt wbr cP vx cv cD
      co vz cv clt wbr vx cX vy cv cP wceq vy cv vx cv cD co cP vx cv cD co vz
      cv clt vy cv cP vx cv cD opreq1 breq1d rabbisdv vz cv cR wceq cP vx cv cD
      co vz cv clt wbr cP vx cv cD co cR clt wbr vx cX vz cv cR cP vx cv cD co
      clt breq2 rabbisdv vy cv cX wcel vz cv cc0 vv cv clt wbr vv cr crab wcel
      wa vw cv vy cv vx cv cD co vz cv clt wbr vx cX crab wceq wa vy vz vw
      copab2 eqid oprabval2g cD cme wcel cP cX wcel cR cr wcel cc0 cR clt wbr
      wa simplr cR cr wcel cc0 cR clt wbr wa cR cc0 vv cv clt wbr vv cr crab
      wcel cD cme wcel cP cX wcel wa cR cc0 vv cv clt wbr vv cr crab wcel cR cr
      wcel cc0 cR clt wbr wa cc0 vv cv clt wbr cc0 cR clt wbr vv cR cr vv cv cR
      cc0 clt breq2 elrab biimpri adantl cD cme wcel cP vx cv cD co cR clt wbr
      vx cX crab cvv wcel cP cX wcel cR cr wcel cc0 cR clt wbr wa cD cme wcel
      cX cvv wcel cP vx cv cD co cR clt wbr vx cX crab cvv wcel cD cme wcel cD
      cdm cdm cvv cX cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme
      dmexg cD cdm cvv dmexg syl blval.1 syl5eqel cP vx cv cD co cR clt wbr vx
      cX cvv rabexg syl ad2antrr syl3anc eqtrd $.
      $( [16-Sep-2007] $) $( [31-Aug-2006] $)

    $( Membership in a ball. $)
    elbl $p |- ( ( ( D e. Met /\ P e. X ) /\
                  ( R e. RR /\ 0 < R ) ) -> ( A e. ( P ( ball ` D ) R ) <->
                  ( A e. X /\ ( P D A ) < R ) ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cA cP cR cD cbl
      cfv co wcel cA cP vx cv cD co cR clt wbr vx cX crab wcel cA cX wcel cP cA
      cD co cR clt wbr wa cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr
      wa wa cP cR cD cbl cfv co cP vx cv cD co cR clt wbr vx cX crab cA vx cD
      cP cR cX blval.1 blval eleq2d cP vx cv cD co cR clt wbr cP cA cD co cR
      clt wbr vx cA cX vx cv cA wceq cP vx cv cD co cP cA cD co cR clt vx cv cA
      cP cD opreq2 breq1d elrab syl6bb $.
      $( [16-Sep-2007] $) $( [2-Sep-2006] $)

    $( Membership in a ball. $)
    elbl2 $p |- ( ( ( D e. Met /\ P e. X /\ A e. X ) /\
                  ( R e. RR /\ 0 < R ) ) -> ( A e. ( P ( ball ` D ) R ) <->
                  ( P D A ) < R ) ) $=
      cD cme wcel cP cX wcel cA cX wcel w3a cR cr wcel cc0 cR clt wbr wa wa cA
      cP cR cD cbl cfv co wcel cA cX wcel cP cA cD co cR clt wbr wa cP cA cD co
      cR clt wbr cD cme wcel cP cX wcel cR cr wcel cc0 cR clt wbr wa cA cP cR
      cD cbl cfv co wcel cA cX wcel cP cA cD co cR clt wbr wa wb cA cX wcel cA
      cD cP cR cX blval.1 elbl 3adantl3 cD cme wcel cP cX wcel cA cX wcel w3a
      cP cA cD co cR clt wbr cA cX wcel cP cA cD co cR clt wbr wa wb cR cr wcel
      cc0 cR clt wbr wa cA cX wcel cD cme wcel cP cA cD co cR clt wbr cA cX
      wcel cP cA cD co cR clt wbr wa wb cP cX wcel cA cX wcel cP cA cD co cR
      clt wbr ibar 3ad2ant3 adantr bitr4d $.
      $( [26-Sep-2007] $) $( [9-Mar-2007] $)

    $( Membership in a ball, with reversed distance function arguments. $)
    elbl3 $p |- ( ( ( D e. Met /\ P e. X /\ A e. X ) /\
                  ( R e. RR /\ 0 < R ) ) -> ( A e. ( P ( ball ` D ) R ) <->
                  ( A D P ) < R ) ) $=
      cD cme wcel cP cX wcel cA cX wcel w3a cR cr wcel cc0 cR clt wbr wa wa cA
      cP cR cD cbl cfv co wcel cP cA cD co cR clt wbr cA cP cD co cR clt wbr cA
      cD cP cR cX blval.1 elbl2 cD cme wcel cP cX wcel cA cX wcel w3a cP cA cD
      co cR clt wbr cA cP cD co cR clt wbr wb cR cr wcel cc0 cR clt wbr wa cD
      cme wcel cP cX wcel cA cX wcel w3a cP cA cD co cA cP cD co cR clt cP cA
      cD cX blval.1 metsym breq1d adantr bitrd $.
      $( [25-Dec-2007] $) $( [10-Nov-2007] $)

    $( Membership in the range of the ball function.  Note that
       ` ran ( ball `` D ) ` is the collection of all balls for metric
       ` D ` . $)
    blrn $p |- ( D e. Met -> ( B e. ran ( ball ` D ) <->
         E. x e. X E. y e. { w e. RR | 0 < w }
                B = { z e. X | ( x D z ) < y } ) ) $=
      cD cme wcel cB cD cbl cfv crn wcel cB vx cv cX wcel vy cv cc0 vw cv clt
      wbr vw cr crab wcel wa vv cv vx cv vz cv cD co vy cv clt wbr vz cX crab
      wceq wa vx vy vv copab2 crn wcel cB vx cv vz cv cD co vy cv clt wbr vz cX
      crab wceq vy cc0 vw cv clt wbr vw cr crab wrex vx cX wrex cD cme wcel cD
      cbl cfv crn vx cv cX wcel vy cv cc0 vw cv clt wbr vw cr crab wcel wa vv
      cv vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vx vy vv copab2 crn
      cB cD cme wcel cD cbl cfv vx cv cX wcel vy cv cc0 vw cv clt wbr vw cr
      crab wcel wa vv cv vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vx
      vy vv copab2 vx vy vv vz vw cD cX blval.1 blfval2 rneqd eleq2d cD cme
      wcel vx cv vz cv cD co vy cv clt wbr vz cX crab cvv wcel vy cc0 vw cv clt
      wbr vw cr crab wral vx cX wral cB vx cv cX wcel vy cv cc0 vw cv clt wbr
      vw cr crab wcel wa vv cv vx cv vz cv cD co vy cv clt wbr vz cX crab wceq
      wa vx vy vv copab2 crn wcel cB vx cv vz cv cD co vy cv clt wbr vz cX crab
      wceq vy cc0 vw cv clt wbr vw cr crab wrex vx cX wrex wb cD cme wcel vx cv
      vz cv cD co vy cv clt wbr vz cX crab cvv wcel vx vy cX cc0 vw cv clt wbr
      vw cr crab cD cme wcel vx cv vz cv cD co vy cv clt wbr vz cX crab cvv
      wcel vx cv cX wcel vy cv cc0 vw cv clt wbr vw cr crab wcel wa cD cme wcel
      cX cvv wcel vx cv vz cv cD co vy cv clt wbr vz cX crab cvv wcel cD cme
      wcel cD cdm cdm cvv cX cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD
      cme dmexg cD cdm cvv dmexg syl blval.1 syl5eqel vx cv vz cv cD co vy cv
      clt wbr vz cX cvv rabexg syl a1d r19.21aivv vx vy vv cX cc0 vw cv clt wbr
      vw cr crab vx cv vz cv cD co vy cv clt wbr vz cX crab cB cvv vx cv cX
      wcel vy cv cc0 vw cv clt wbr vw cr crab wcel wa vv cv vx cv vz cv cD co
      vy cv clt wbr vz cX crab wceq wa vx vy vv copab2 vx cv cX wcel vy cv cc0
      vw cv clt wbr vw cr crab wcel wa vv cv vx cv vz cv cD co vy cv clt wbr vz
      cX crab wceq wa vx vy vv copab2 eqid elrnoprabg syl bitrd $.
      $( [28-Jul-2008] $) $( [31-Aug-2006] $)

    $( Membership in the range of the ball function.  Note that
       ` ran ( ball `` D ) ` is the collection of all balls for metric
       ` D ` . $)
    blrn2 $p |- ( D e. Met -> ( B e. ran ( ball ` D ) <->
         E. x e. X E. y e. RR ( 0 < y /\
                B = { z e. X | ( x D z ) < y } ) ) ) $=
      cD cme wcel cB cD cbl cfv crn wcel cB vx cv vz cv cD co vy cv clt wbr vz
      cX crab wceq vy cc0 vw cv clt wbr vw cr crab wrex vx cX wrex cc0 vy cv
      clt wbr cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vy cr wrex
      vx cX wrex vx vy vz vw cB cD cX blval.1 blrn cB vx cv vz cv cD co vy cv
      clt wbr vz cX crab wceq vy cc0 vw cv clt wbr vw cr crab wrex cc0 vy cv
      clt wbr cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vy cr wrex
      vx cX cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq cc0 vy cv clt
      wbr cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vy cc0 vw cv
      clt wbr vw cr crab cr vy cv cc0 vw cv clt wbr vw cr crab wcel cB vx cv vz
      cv cD co vy cv clt wbr vz cX crab wceq wa vy cv cr wcel cc0 vy cv clt wbr
      wa cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vy cv cr wcel
      cc0 vy cv clt wbr cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq wa
      wa vy cv cc0 vw cv clt wbr vw cr crab wcel vy cv cr wcel cc0 vy cv clt
      wbr wa cB vx cv vz cv cD co vy cv clt wbr vz cX crab wceq cc0 vw cv clt
      wbr cc0 vy cv clt wbr vw vy cv cr vw cv vy cv cc0 clt breq2 elrab anbi1i
      vy cv cr wcel cc0 vy cv clt wbr cB vx cv vz cv cD co vy cv clt wbr vz cX
      crab wceq anass bitri rexbii2 rexbii syl6bb $.
      $( [18-Sep-2007] $) $( [31-Aug-2006] $)

    $( Two balls are disjoint if they don't overlap. $)
    bl2in $p |- ( ( ( D e. Met /\ P e. X /\ Q e. X ) /\
                ( R e. RR /\ 0 < R /\ R <_ ( ( P D Q ) / 2 ) ) ) ->
                ( ( P ( ball ` D ) R ) i^i ( Q ( ball ` D ) R ) ) = (/) ) $=
      cD cme wcel cP cX wcel cQ cX wcel w3a cR cr wcel cc0 cR clt wbr cR cP cQ
      cD co c2 cdiv co cle wbr w3a wa vx cv cQ cR cD cbl cfv co wcel wn vx cP
      cR cD cbl cfv co wral cP cR cD cbl cfv co cQ cR cD cbl cfv co cin c0 wceq
      cD cme wcel cP cX wcel cQ cX wcel w3a cR cr wcel cc0 cR clt wbr cR cP cQ
      cD co c2 cdiv co cle wbr w3a wa vx cv cQ cR cD cbl cfv co wcel wn vx cP
      cR cD cbl cfv co cD cme wcel cP cX wcel cQ cX wcel w3a cR cr wcel cc0 cR
      clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa vx cv cP cR cD cbl cfv
      co wcel vx cv cX wcel cP vx cv cD co cR clt wbr wa vx cv cQ cR cD cbl cfv
      co wcel wn cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa vx cv
      cP cR cD cbl cfv co wcel vx cv cX wcel cP vx cv cD co cR clt wbr wa wb cD
      cme wcel cP cX wcel cQ cX wcel w3a cR cr wcel cc0 cR clt wbr cR cP cQ cD
      co c2 cdiv co cle wbr w3a vx cv cD cP cR cX blval.1 elbl cD cme wcel cP
      cX wcel cQ cX wcel 3simpa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2
      cdiv co cle wbr 3simpa syl2an cD cme wcel cP cX wcel cQ cX wcel w3a cR cr
      wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa vx cv cX
      wcel cP vx cv cD co cR clt wbr vx cv cQ cR cD cbl cfv co wcel wn cD cme
      wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel cR cr wcel cc0 cR clt wbr cR
      cP cQ cD co c2 cdiv co cle wbr w3a cP vx cv cD co cR clt wbr vx cv cQ cR
      cD cbl cfv co wcel wn wi cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX
      wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a
      wa cP vx cv cD co cR clt wbr cQ vx cv cD co cR clt wbr wn vx cv cQ cR cD
      cbl cfv co wcel wn cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa
      cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa cP vx
      cv cD co cR clt wbr cQ vx cv cD co cR clt wbr wn cD cme wcel cP cX wcel
      cQ cX wcel w3a vx cv cX wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co
      c2 cdiv co cle wbr w3a wa cP vx cv cD co cR clt wbr wa cQ vx cv cD co cR
      clt wbr cP vx cv cD co cQ vx cv cD co caddc co cP cQ cD co clt wbr cD cme
      wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa cR cr wcel cc0 cR clt wbr
      cR cP cQ cD co c2 cdiv co cle wbr w3a wa cP vx cv cD co cR clt wbr wa cQ
      vx cv cD co cR clt wbr cP vx cv cD co cQ vx cv cD co caddc co cP cQ cD co
      clt wbr cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa cR cr wcel
      cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa cP vx cv cD co cR
      clt wbr wa cQ vx cv cD co cR clt wbr wa cP vx cv cD co cQ vx cv cD co
      caddc co c2 cR cmul co cP cQ cD co cD cme wcel cP cX wcel cQ cX wcel w3a
      vx cv cX wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle
      wbr w3a wa cP vx cv cD co cQ vx cv cD co caddc co cr wcel cP vx cv cD co
      cR clt wbr cQ vx cv cD co cR clt wbr cD cme wcel cP cX wcel cQ cX wcel
      w3a vx cv cX wcel wa cP vx cv cD co cQ vx cv cD co caddc co cr wcel cR cr
      wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a cP vx cv cD co
      cr wcel cQ vx cv cD co cr wcel cP vx cv cD co cQ vx cv cD co caddc co cr
      wcel cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa cP vx cv cD
      co cQ vx cv cD co readdcl cD cme wcel cP cX wcel vx cv cX wcel cP vx cv
      cD co cr wcel cQ cX wcel cD cme wcel cP cX wcel vx cv cX wcel cP vx cv cD
      co cr wcel cP vx cv cD cX blval.1 metcl 3expa 3adantl3 cD cme wcel cQ cX
      wcel vx cv cX wcel cQ vx cv cD co cr wcel cP cX wcel cD cme wcel cQ cX
      wcel vx cv cX wcel cQ vx cv cD co cr wcel cQ vx cv cD cX blval.1 metcl
      3expa 3adantl2 sylanc adantr ad2antrr cD cme wcel cP cX wcel cQ cX wcel
      w3a vx cv cX wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co
      cle wbr w3a wa c2 cR cmul co cr wcel cP vx cv cD co cR clt wbr cQ vx cv
      cD co cR clt wbr cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle
      wbr w3a c2 cR cmul co cr wcel cD cme wcel cP cX wcel cQ cX wcel w3a vx cv
      cX wcel wa cR cr wcel cc0 cR clt wbr c2 cR cmul co cr wcel cR cP cQ cD co
      c2 cdiv co cle wbr c2 cr wcel cR cr wcel c2 cR cmul co cr wcel 2re c2 cR
      remulcl mpan 3ad2ant1 adantl ad2antrr cD cme wcel cP cX wcel cQ cX wcel
      w3a vx cv cX wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co
      cle wbr w3a wa cP cQ cD co cr wcel cP vx cv cD co cR clt wbr cQ vx cv cD
      co cR clt wbr cD cme wcel cP cX wcel cQ cX wcel w3a cP cQ cD co cr wcel
      vx cv cX wcel cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr
      w3a cP cQ cD cX blval.1 metcl ad2antrr ad2antrr cD cme wcel cP cX wcel cQ
      cX wcel w3a vx cv cX wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2
      cdiv co cle wbr w3a wa cP vx cv cD co cR clt wbr wa cQ vx cv cD co cR clt
      wbr wa cP vx cv cD co cQ vx cv cD co caddc co cR cR caddc co c2 cR cmul
      co clt cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa cR cr wcel
      cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa cP vx cv cD co cR
      clt wbr cQ vx cv cD co cR clt wbr cP vx cv cD co cQ vx cv cD co caddc co
      cR cR caddc co clt wbr cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX
      wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a
      wa cP vx cv cD co cR clt wbr cQ vx cv cD co cR clt wbr cP vx cv cD co cQ
      vx cv cD co caddc co cR cR caddc co clt wbr cP vx cv cD co cr wcel cQ vx
      cv cD co cr wcel wa cR cr wcel cR cr wcel wa cP vx cv cD co cR clt wbr cQ
      vx cv cD co cR clt wbr wa cP vx cv cD co cQ vx cv cD co caddc co cR cR
      caddc co clt wbr wi cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel
      wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a cP vx
      cv cD co cQ vx cv cD co cR cR lt2add cD cme wcel cP cX wcel cQ cX wcel
      w3a vx cv cX wcel wa cP vx cv cD co cr wcel cQ vx cv cD co cr wcel cD cme
      wcel cP cX wcel vx cv cX wcel cP vx cv cD co cr wcel cQ cX wcel cD cme
      wcel cP cX wcel vx cv cX wcel cP vx cv cD co cr wcel cP vx cv cD cX
      blval.1 metcl 3expa 3adantl3 cD cme wcel cQ cX wcel vx cv cX wcel cQ vx
      cv cD co cr wcel cP cX wcel cD cme wcel cQ cX wcel vx cv cX wcel cQ vx cv
      cD co cr wcel cQ vx cv cD cX blval.1 metcl 3expa 3adantl2 jca cR cr wcel
      cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a cR cr wcel cR cr
      wcel cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr 3simp1
      cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr 3simp1 jca
      syl2an exp3a imp31 cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa
      cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa c2 cR
      cmul co cR cR caddc co wceq cP vx cv cD co cR clt wbr cQ vx cv cD co cR
      clt wbr cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a
      c2 cR cmul co cR cR caddc co wceq cD cme wcel cP cX wcel cQ cX wcel w3a
      vx cv cX wcel wa cR cr wcel cc0 cR clt wbr c2 cR cmul co cR cR caddc co
      wceq cR cP cQ cD co c2 cdiv co cle wbr cR cr wcel cR cc wcel c2 cR cmul
      co cR cR caddc co wceq cR recn cR 2times syl 3ad2ant1 adantl ad2antrr
      breqtrrd cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa cR cr
      wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa c2 cR cmul
      co cP cQ cD co cle wbr cP vx cv cD co cR clt wbr cQ vx cv cD co cR clt
      wbr cD cme wcel cP cX wcel cQ cX wcel w3a cR cr wcel cc0 cR clt wbr cR cP
      cQ cD co c2 cdiv co cle wbr w3a c2 cR cmul co cP cQ cD co cle wbr vx cv
      cX wcel cD cme wcel cP cX wcel cQ cX wcel w3a cR cr wcel cR cP cQ cD co
      c2 cdiv co cle wbr c2 cR cmul co cP cQ cD co cle wbr cc0 cR clt wbr cP cQ
      cD co cr wcel cR cr wcel cR cP cQ cD co c2 cdiv co cle wbr wa c2 cR cmul
      co cP cQ cD co cle wbr cD cme wcel cP cX wcel cQ cX wcel w3a cP cQ cD co
      cr wcel cR cr wcel cR cP cQ cD co c2 cdiv co cle wbr c2 cR cmul co cP cQ
      cD co cle wbr cR cr wcel cP cQ cD co cr wcel cR cP cQ cD co c2 cdiv co
      cle wbr c2 cR cmul co cP cQ cD co cle wbr cR cr wcel cP cQ cD co cr wcel
      wa c2 cR cmul co cP cQ cD co cle wbr cR cP cQ cD co c2 cdiv co cle wbr c2
      cr wcel cR cr wcel cP cQ cD co cr wcel c2 cR cmul co cP cQ cD co cle wbr
      cR cP cQ cD co c2 cdiv co cle wbr wb 2re c2 cr wcel cR cr wcel cP cQ cD
      co cr wcel w3a cc0 c2 clt wbr c2 cR cmul co cP cQ cD co cle wbr cR cP cQ
      cD co c2 cdiv co cle wbr wb 2pos c2 cR cP cQ cD co lemuldiv2OLD mpan2
      mp3an1 biimpar ancom1s anasss cP cQ cD cX blval.1 metcl sylan 3adantr2
      adantlr ad2antrr ltletrd ex cD cme wcel cP cX wcel cQ cX wcel w3a vx cv
      cX wcel wa cQ vx cv cD co cR clt wbr cP vx cv cD co cQ vx cv cD co caddc
      co cP cQ cD co clt wbr wn wi cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2
      cdiv co cle wbr w3a cP vx cv cD co cR clt wbr cD cme wcel cP cX wcel cQ
      cX wcel w3a vx cv cX wcel wa cP vx cv cD co cQ vx cv cD co caddc co cP cQ
      cD co clt wbr wn cQ vx cv cD co cR clt wbr cD cme wcel cP cX wcel cQ cX
      wcel w3a vx cv cX wcel wa cP cQ cD co cP vx cv cD co cQ vx cv cD co caddc
      co cle wbr cP vx cv cD co cQ vx cv cD co caddc co cP cQ cD co clt wbr wn
      cD cme wcel cP cX wcel cQ cX wcel vx cv cX wcel cP cQ cD co cP vx cv cD
      co cQ vx cv cD co caddc co cle wbr cD cme wcel cP cX wcel cQ cX wcel vx
      cv cX wcel cP cQ cD co cP vx cv cD co cQ vx cv cD co caddc co cle wbr cP
      cQ vx cv cD cX blval.1 mettri3 3exp2 3imp1 cP cQ cD co cr wcel cP vx cv
      cD co cQ vx cv cD co caddc co cr wcel cP cQ cD co cP vx cv cD co cQ vx cv
      cD co caddc co cle wbr cP vx cv cD co cQ vx cv cD co caddc co cP cQ cD co
      clt wbr wn wb cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel wa cP
      cQ cD co cP vx cv cD co cQ vx cv cD co caddc co lenlt cD cme wcel cP cX
      wcel cQ cX wcel w3a cP cQ cD co cr wcel vx cv cX wcel cP cQ cD cX blval.1
      metcl adantr cP vx cv cD co cr wcel cQ vx cv cD co cr wcel cP vx cv cD co
      cQ vx cv cD co caddc co cr wcel cD cme wcel cP cX wcel cQ cX wcel w3a vx
      cv cX wcel wa cP vx cv cD co cQ vx cv cD co readdcl cD cme wcel cP cX
      wcel vx cv cX wcel cP vx cv cD co cr wcel cQ cX wcel cD cme wcel cP cX
      wcel vx cv cX wcel cP vx cv cD co cr wcel cP vx cv cD cX blval.1 metcl
      3expa 3adantl3 cD cme wcel cQ cX wcel vx cv cX wcel cQ vx cv cD co cr
      wcel cP cX wcel cD cme wcel cQ cX wcel vx cv cX wcel cQ vx cv cD co cr
      wcel cQ vx cv cD cX blval.1 metcl 3expa 3adantl2 sylanc sylanc mpbid a1d
      ad2antrr pm2.65d ex cD cme wcel cP cX wcel cQ cX wcel w3a vx cv cX wcel
      wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr w3a wa vx
      cv cQ cR cD cbl cfv co wcel cQ vx cv cD co cR clt wbr cD cme wcel cQ cX
      wcel vx cv cX wcel w3a cR cr wcel cc0 cR clt wbr wa vx cv cQ cR cD cbl
      cfv co wcel cQ vx cv cD co cR clt wbr wb cD cme wcel cP cX wcel cQ cX
      wcel w3a vx cv cX wcel wa cR cr wcel cc0 cR clt wbr cR cP cQ cD co c2
      cdiv co cle wbr w3a vx cv cD cQ cR cX blval.1 elbl2 cD cme wcel cQ cX
      wcel vx cv cX wcel cD cme wcel cQ cX wcel vx cv cX wcel w3a cP cX wcel cD
      cme wcel cQ cX wcel vx cv cX wcel w3a cD cme wcel cQ cX wcel wa vx cv cX
      wcel wa cD cme wcel cQ cX wcel vx cv cX wcel df-3an biimpri 3adantl2 cR
      cr wcel cc0 cR clt wbr cR cP cQ cD co c2 cdiv co cle wbr 3simpa syl2an
      notbid sylibrd an1rs expimpd sylbid r19.21aiv vx cP cR cD cbl cfv co cQ
      cR cD cbl cfv co disj sylibr $.
      $( [5-Oct-2007] $) $( [11-Mar-2007] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d v x y z D $.  $d x S $.  $d v x y z X $.
    $d x y P $.  $d x y R $.  $d w y $.
    blf.1 $e |- X = dom dom D $.
    $( Mapping of a ball. $)
    blf $p |- ( D e. Met -> ( ball ` D ) : ( X X. ( 0 (,) +oo ) ) --> ~P X ) $=
      cD cbl cfv vx cv cX wcel vy cv cc0 cpnf cioo co wcel wa vz cv vx cv vv cv
      cD co vy cv clt wbr vv cX crab wceq wa vx vy vz copab2 wceq cD cme wcel
      cX cc0 cpnf cioo co cxp cX cpw cD cbl cfv wf cD cme wcel cD cbl cfv vx cv
      cX wcel vy cv cc0 vw cv clt wbr vw cr crab wcel wa vz cv vx cv vv cv cD
      co vy cv clt wbr vv cX crab wceq wa vx vy vz copab2 vx cv cX wcel vy cv
      cc0 cpnf cioo co wcel wa vz cv vx cv vv cv cD co vy cv clt wbr vv cX crab
      wceq wa vx vy vz copab2 vx vy vz vv vw cD cX blf.1 blfval2 vx cv cX wcel
      vy cv cc0 cpnf cioo co wcel wa vz cv vx cv vv cv cD co vy cv clt wbr vv
      cX crab wceq wa vx cv cX wcel vy cv cc0 vw cv clt wbr vw cr crab wcel wa
      vz cv vx cv vv cv cD co vy cv clt wbr vv cX crab wceq wa vx vy vz vx cv
      cX wcel vy cv cc0 cpnf cioo co wcel wa vx cv cX wcel vy cv cc0 vw cv clt
      wbr vw cr crab wcel wa vz cv vx cv vv cv cD co vy cv clt wbr vv cX crab
      wceq vy cv cc0 cpnf cioo co wcel vy cv cc0 vw cv clt wbr vw cr crab wcel
      vx cv cX wcel cc0 cpnf cioo co cc0 vw cv clt wbr vw cr crab vy cv vw
      ioopos eleq2i anbi2i anbi1i oprabbii syl6eqr cD cbl cfv vx cv cX wcel vy
      cv cc0 cpnf cioo co wcel wa vz cv vx cv vv cv cD co vy cv clt wbr vv cX
      crab wceq wa vx vy vz copab2 wceq cX cc0 cpnf cioo co cxp cX cpw cD cbl
      cfv wf cX cc0 cpnf cioo co cxp cX cpw vx cv cX wcel vy cv cc0 cpnf cioo
      co wcel wa vz cv vx cv vv cv cD co vy cv clt wbr vv cX crab wceq wa vx vy
      vz copab2 wf cD cme wcel cX cc0 cpnf cioo co cxp cX cpw cD cbl cfv vx cv
      cX wcel vy cv cc0 cpnf cioo co wcel wa vz cv vx cv vv cv cD co vy cv clt
      wbr vv cX crab wceq wa vx vy vz copab2 feq1 cD cme wcel vx cv vv cv cD co
      vy cv clt wbr vv cX crab cX cpw wcel vy cc0 cpnf cioo co wral vx cX wral
      cX cc0 cpnf cioo co cxp cX cpw vx cv cX wcel vy cv cc0 cpnf cioo co wcel
      wa vz cv vx cv vv cv cD co vy cv clt wbr vv cX crab wceq wa vx vy vz
      copab2 wf cD cme wcel vx cv vv cv cD co vy cv clt wbr vv cX crab cX cpw
      wcel vx vy cX cc0 cpnf cioo co cD cme wcel vx cv vv cv cD co vy cv clt
      wbr vv cX crab cX cpw wcel vx cv cX wcel vy cv cc0 cpnf cioo co wcel wa
      cD cme wcel cX cvv wcel vx cv vv cv cD co vy cv clt wbr vv cX crab cX cpw
      wcel cD cme wcel cD cdm cdm cvv cX cD cme wcel cD cdm cvv wcel cD cdm cdm
      cvv wcel cD cme dmexg cD cdm cvv dmexg syl blf.1 syl5eqel cX cvv wcel vx
      cv vv cv cD co vy cv clt wbr vv cX crab cX cpw wcel vx cv vv cv cD co vy
      cv clt wbr vv cX crab cX wss vx cv vv cv cD co vy cv clt wbr vv cX ssrab2
      vx cv vv cv cD co vy cv clt wbr vv cX crab cX cvv elpw2g mpbiri syl a1d
      r19.21aivv vx vy vz cX cc0 cpnf cioo co vx cv vv cv cD co vy cv clt wbr
      vv cX crab cX cpw vx cv cX wcel vy cv cc0 cpnf cioo co wcel wa vz cv vx
      cv vv cv cD co vy cv clt wbr vv cX crab wceq wa vx vy vz copab2 vx cv cX
      wcel vy cv cc0 cpnf cioo co wcel wa vz cv vx cv vv cv cD co vy cv clt wbr
      vv cX crab wceq wa vx vy vz copab2 eqid foprab2 sylib syl5bir mpcom $.
      $( [18-Oct-2007] $) $( [7-May-2007] $)

    $( A ball contains its center. $)
    blcntr $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) ) ->
                 P e. ( P ( ball ` D ) R ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cP cR cD cbl
      cfv co wcel cP cX wcel cP cP cD co cR clt wbr wa cD cme wcel cP cX wcel
      wa cR cr wcel cc0 cR clt wbr wa wa cP cX wcel cP cP cD co cR clt wbr cD
      cme wcel cP cX wcel cR cr wcel cc0 cR clt wbr wa simplr cD cme wcel cP cX
      wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cP cD co cc0 cR clt cD cme
      wcel cP cX wcel wa cP cP cD co cc0 wceq cR cr wcel cc0 cR clt wbr wa cP
      cD cX blf.1 met0 adantr cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt
      wbr simprr eqbrtrd jca cP cD cP cR cX blf.1 elbl mpbird $.
      $( [22-Sep-2007] $) $( [2-Sep-2006] $)

    $( A ball is not empty. $)
    bln0 $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) ) ->
                 ( P ( ball ` D ) R ) =/= (/) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cP cR cD cbl
      cfv co wcel cP cR cD cbl cfv co c0 wne cD cP cR cX blf.1 blcntr cP cR cD
      cbl cfv co cP ne0i syl $.
      $( [14-Nov-2007] $) $( [6-Oct-2007] $)

    $( Membership in the range of the ball function.  Note that
       ` ran ( ball `` D ) ` is the collection of all balls for metric
       ` D ` . $)
    blrn3 $p |- ( D e. Met -> ( A e. ran ( ball ` D ) <->
         E. x e. X E. y e. RR ( 0 < y /\ A = ( x ( ball ` D ) y ) ) ) ) $=
      cD cme wcel cA cD cbl cfv crn wcel cc0 vy cv clt wbr cA vx cv vz cv cD co
      vy cv clt wbr vz cX crab wceq wa vy cr wrex vx cX wrex cc0 vy cv clt wbr
      cA vx cv vy cv cD cbl cfv co wceq wa vy cr wrex vx cX wrex vx vy vz cA cD
      cX blf.1 blrn2 cD cme wcel cc0 vy cv clt wbr cA vx cv vy cv cD cbl cfv co
      wceq wa vy cr wrex cc0 vy cv clt wbr cA vx cv vz cv cD co vy cv clt wbr
      vz cX crab wceq wa vy cr wrex vx cX cD cme wcel vx cv cX wcel wa cc0 vy
      cv clt wbr cA vx cv vy cv cD cbl cfv co wceq wa cc0 vy cv clt wbr cA vx
      cv vz cv cD co vy cv clt wbr vz cX crab wceq wa vy cr cD cme wcel vx cv
      cX wcel wa vy cv cr wcel wa cc0 vy cv clt wbr cA vx cv vy cv cD cbl cfv
      co wceq cA vx cv vz cv cD co vy cv clt wbr vz cX crab wceq cD cme wcel vx
      cv cX wcel wa vy cv cr wcel wa cc0 vy cv clt wbr wa vx cv vy cv cD cbl
      cfv co vx cv vz cv cD co vy cv clt wbr vz cX crab cA cD cme wcel vx cv cX
      wcel wa vy cv cr wcel cc0 vy cv clt wbr vx cv vy cv cD cbl cfv co vx cv
      vz cv cD co vy cv clt wbr vz cX crab wceq vz cD vx cv vy cv cX blf.1
      blval anassrs eqeq2d pm5.32da rexbidva rexbidva bitr4d $.
      $( [22-Sep-2007] $) $( [31-Aug-2006] $)

    $( A ball belongs to the set of balls of a metric space. $)
    blelrn $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) ) ->
                    ( P ( ball ` D ) R ) e. ran ( ball ` D ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl
      cfv co cD cbl cfv crn wcel cc0 vy cv clt wbr cP cR cD cbl cfv co vx cv vy
      cv cD cbl cfv co wceq wa vy cr wrex vx cX wrex cP cX wcel cR cr wcel cc0
      cR clt wbr cP cR cD cbl cfv co cP cR cD cbl cfv co wceq wa cc0 vy cv clt
      wbr cP cR cD cbl cfv co vx cv vy cv cD cbl cfv co wceq wa vy cr wrex vx
      cX wrex cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cc0 vy
      cv clt wbr cP cR cD cbl cfv co vx cv vy cv cD cbl cfv co wceq wa cc0 cR
      clt wbr cP cR cD cbl cfv co cP cR cD cbl cfv co wceq wa cc0 vy cv clt wbr
      cP cR cD cbl cfv co cP vy cv cD cbl cfv co wceq wa vx vy cP cR cX cr vx
      cv cP wceq cP cR cD cbl cfv co vx cv vy cv cD cbl cfv co wceq cP cR cD
      cbl cfv co cP vy cv cD cbl cfv co wceq cc0 vy cv clt wbr vx cv cP wceq vx
      cv vy cv cD cbl cfv co cP vy cv cD cbl cfv co cP cR cD cbl cfv co vx cv
      cP vy cv cD cbl cfv opreq1 eqeq2d anbi2d vy cv cR wceq cc0 vy cv clt wbr
      cc0 cR clt wbr cP cR cD cbl cfv co cP vy cv cD cbl cfv co wceq cP cR cD
      cbl cfv co cP cR cD cbl cfv co wceq vy cv cR cc0 clt breq2 vy cv cR wceq
      cP vy cv cD cbl cfv co cP cR cD cbl cfv co cP cR cD cbl cfv co vy cv cR
      cP cD cbl cfv opreq2 eqeq2d anbi12d rcla42ev cD cme wcel cP cX wcel cR cr
      wcel cc0 cR clt wbr wa simplr cD cme wcel cP cX wcel wa cR cr wcel cc0 cR
      clt wbr simprl cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa
      cc0 cR clt wbr cP cR cD cbl cfv co cP cR cD cbl cfv co wceq cD cme wcel
      cP cX wcel wa cR cr wcel cc0 cR clt wbr simprr cP cR cD cbl cfv co eqid
      jctir syl3anc cD cme wcel cP cR cD cbl cfv co cD cbl cfv crn wcel cc0 vy
      cv clt wbr cP cR cD cbl cfv co vx cv vy cv cD cbl cfv co wceq wa vy cr
      wrex vx cX wrex wb cP cX wcel cR cr wcel cc0 cR clt wbr wa vx vy cP cR cD
      cbl cfv co cD cX blf.1 blrn3 ad2antrr mpbird $.
      $( [23-Sep-2007] $) $( [2-Sep-2006] $)

    $( Any point in a metric space has a ball around it. $)
    blex $p |- ( ( D e. Met /\ P e. X ) -> E. x e. ran ( ball ` D ) P e. x ) $=
      cD cme wcel cP cX wcel wa c1 cr wcel cc0 c1 clt wbr cP vx cv wcel vx cD
      cbl cfv crn wrex 1re lt01 cP c1 cD cbl cfv co cD cbl cfv crn wcel cP cP
      c1 cD cbl cfv co wcel cP vx cv wcel vx cD cbl cfv crn wrex cD cme wcel cP
      cX wcel wa c1 cr wcel cc0 c1 clt wbr wa wa cP vx cv wcel cP cP c1 cD cbl
      cfv co wcel vx cP c1 cD cbl cfv co cD cbl cfv crn vx cv cP c1 cD cbl cfv
      co cP eleq2 rcla4ev cD cP c1 cX blf.1 blelrn cD cP c1 cX blf.1 blcntr
      sylanc mpanr12 $.
      $( [28-Jan-2008] $) $( [12-Sep-2006] $)

    $( A ball is a subset of the base set of a metric space. $)
    blssm $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) )
                 -> ( P ( ball ` D ) R ) C_ X ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl
      cfv co cP vx cv cD co cR clt wbr vx cX crab cX vx cD cP cR cX blf.1 blval
      cP vx cv cD co cR clt wbr vx cX crab cX wss cD cme wcel cP cX wcel wa cR
      cr wcel cc0 cR clt wbr wa wa cP vx cv cD co cR clt wbr vx cX ssrab2 a1i
      eqsstrd $.
      $( [20-Sep-2007] $) $( [31-Aug-2006] $)

    $( A ball is a subset of the base set of a metric space. $)
    rnblssm $p |- ( ( D e. Met /\ B e. ran ( ball ` D ) ) -> B C_ X ) $=
      cD cme wcel cB cD cbl cfv crn wcel cB cX wss cD cme wcel cB cD cbl cfv
      crn wcel cc0 vy cv clt wbr cB vx cv vy cv cD cbl cfv co wceq wa vy cr
      wrex vx cX wrex cB cX wss vx vy cB cD cX blf.1 blrn3 cD cme wcel cc0 vy
      cv clt wbr cB vx cv vy cv cD cbl cfv co wceq wa cB cX wss vx vy cX cr cD
      cme wcel vx cv cX wcel vy cv cr wcel wa cc0 vy cv clt wbr cB vx cv vy cv
      cD cbl cfv co wceq cB cX wss cD cme wcel vx cv cX wcel vy cv cr wcel cc0
      vy cv clt wbr cB vx cv vy cv cD cbl cfv co wceq cB cX wss wi wi cD cme
      wcel vx cv cX wcel vy cv cr wcel cc0 vy cv clt wbr cB vx cv vy cv cD cbl
      cfv co wceq cB cX wss wi cD cme wcel vx cv cX wcel wa vy cv cr wcel cc0
      vy cv clt wbr wa wa cB vx cv vy cv cD cbl cfv co wceq cB cX wss cD cme
      wcel vx cv cX wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa cB vx cv vy
      cv cD cbl cfv co wceq wa cB vx cv vy cv cD cbl cfv co cX cD cme wcel vx
      cv cX wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa cB vx cv vy cv cD cbl
      cfv co wceq pm3.27 cD cme wcel vx cv cX wcel wa vy cv cr wcel cc0 vy cv
      clt wbr wa wa vx cv vy cv cD cbl cfv co cX wss cB vx cv vy cv cD cbl cfv
      co wceq cD vx cv vy cv cX blf.1 blssm adantr eqsstrd ex exp43 imp3a imp4a
      r19.23advv sylbid imp $.
      $( [26-Sep-2007] $) $( [12-Sep-2006] $)

    $( The intersection of two balls with the same center is the smaller
       of them. $)
    blin $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) /\
  ( S e. RR /\ 0 < S ) ) -> ( ( P ( ball ` D ) R ) i^i ( P ( ball ` D ) S ) ) =
                  ( P ( ball ` D ) if ( R <_ S , R , S ) ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS
      clt wbr wa w3a cP cR cD cbl cfv co cP cS cD cbl cfv co cin cP vx cv cD co
      cR clt wbr vx cX crab cP vx cv cD co cS clt wbr vx cX crab cin cP cR cS
      cle wbr cR cS cif cD cbl cfv co cD cme wcel cP cX wcel wa cR cr wcel cc0
      cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a cP cR cD cbl cfv co cP vx
      cv cD co cR clt wbr vx cX crab cP cS cD cbl cfv co cP vx cv cD co cS clt
      wbr vx cX crab cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cP
      cR cD cbl cfv co cP vx cv cD co cR clt wbr vx cX crab wceq cS cr wcel cc0
      cS clt wbr wa vx cD cP cR cX blf.1 blval 3adant3 cD cme wcel cP cX wcel
      wa cS cr wcel cc0 cS clt wbr wa cP cS cD cbl cfv co cP vx cv cD co cS clt
      wbr vx cX crab wceq cR cr wcel cc0 cR clt wbr wa vx cD cP cS cX blf.1
      blval 3adant2 ineq12d cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr
      wa cS cr wcel cc0 cS clt wbr wa w3a cP vx cv cD co cR clt wbr cP vx cv cD
      co cS clt wbr wa vx cX crab cP cR cS cle wbr cR cS cif cD cbl cfv co cP
      vx cv cD co cR clt wbr vx cX crab cP vx cv cD co cS clt wbr vx cX crab
      cin cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0
      cS clt wbr wa w3a cP cR cS cle wbr cR cS cif cD cbl cfv co cP vx cv cD co
      cR cS cle wbr cR cS cif clt wbr vx cX crab cP vx cv cD co cR clt wbr cP
      vx cv cD co cS clt wbr wa vx cX crab cD cme wcel cP cX wcel wa cR cr wcel
      cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa cP cR cS cle wbr cR cS cif
      cD cbl cfv co cP vx cv cD co cR cS cle wbr cR cS cif clt wbr vx cX crab
      wceq cD cme wcel cP cX wcel wa cR cS cle wbr cR cS cif cr wcel cc0 cR cS
      cle wbr cR cS cif clt wbr wa cP cR cS cle wbr cR cS cif cD cbl cfv co cP
      vx cv cD co cR cS cle wbr cR cS cif clt wbr vx cX crab wceq cR cr wcel
      cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa wa vx cD cP cR cS cle wbr
      cR cS cif cX blf.1 blval cR cS cle wbr cR cr wcel cc0 cR clt wbr wa cS cr
      wcel cc0 cS clt wbr wa cR cS cle wbr cR cS cif cr wcel cc0 cR cS cle wbr
      cR cS cif clt wbr wa cR cS cR cR cS cle wbr cR cS cif wceq cR cr wcel cR
      cS cle wbr cR cS cif cr wcel cc0 cR clt wbr cc0 cR cS cle wbr cR cS cif
      clt wbr cR cR cS cle wbr cR cS cif cr eleq1 cR cR cS cle wbr cR cS cif
      cc0 clt breq2 anbi12d cS cR cS cle wbr cR cS cif wceq cS cr wcel cR cS
      cle wbr cR cS cif cr wcel cc0 cS clt wbr cc0 cR cS cle wbr cR cS cif clt
      wbr cS cR cS cle wbr cR cS cif cr eleq1 cS cR cS cle wbr cR cS cif cc0
      clt breq2 anbi12d ifboth sylan2 3impb cD cme wcel cP cX wcel wa cR cr
      wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa cP vx cv cD co cR cS
      cle wbr cR cS cif clt wbr vx cX crab cP vx cv cD co cR clt wbr cP vx cv
      cD co cS clt wbr wa vx cX crab wceq cD cme wcel cP cX wcel wa cR cr wcel
      cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa wa wa cP vx cv cD co cR cS
      cle wbr cR cS cif clt wbr cP vx cv cD co cR clt wbr cP vx cv cD co cS clt
      wbr wa vx cX cD cme wcel cP cX wcel wa vx cv cX wcel cR cr wcel cc0 cR
      clt wbr wa cS cr wcel cc0 cS clt wbr wa wa cP vx cv cD co cR cS cle wbr
      cR cS cif clt wbr cP vx cv cD co cR clt wbr cP vx cv cD co cS clt wbr wa
      wb cD cme wcel cP cX wcel wa vx cv cX wcel wa cR cr wcel cc0 cR clt wbr
      wa cS cr wcel cc0 cS clt wbr wa cP vx cv cD co cR cS cle wbr cR cS cif
      clt wbr cP vx cv cD co cR clt wbr cP vx cv cD co cS clt wbr wa wb cP vx
      cv cD co cr wcel cR cr wcel cS cr wcel cP vx cv cD co cR cS cle wbr cR cS
      cif clt wbr cP vx cv cD co cR clt wbr cP vx cv cD co cS clt wbr wa wb cD
      cme wcel cP cX wcel wa vx cv cX wcel wa cR cr wcel cc0 cR clt wbr wa cS
      cr wcel cc0 cS clt wbr wa cP vx cv cD co cR cS ltmin cD cme wcel cP cX
      wcel vx cv cX wcel cP vx cv cD co cr wcel cP vx cv cD cX blf.1 metcl
      3expa cR cr wcel cc0 cR clt wbr pm3.26 cS cr wcel cc0 cS clt wbr pm3.26
      syl3an 3expb an1rs rabbidv 3impb eqtr2d cP vx cv cD co cR clt wbr cP vx
      cv cD co cS clt wbr vx cX inrab syl5eq eqtrd $.
      $( [25-Sep-2007] $) $( [1-Sep-2006] $)
  $}

  ${
    $d w x z B $.  $d v w x z D $.  $d v w x z P $.
    $( Any point ` P ` in a ball ` B ` can be centered in another ball that
       is a subset of ` B ` . $)
    blss $p |- ( ( D e. Met /\ B e. ran ( ball ` D ) /\ P e. B ) ->
                E. x e. RR ( 0 < x /\ ( P ( ball ` D ) x ) C_ B ) ) $=
      cD cme wcel cB cD cbl cfv crn wcel cP cB wcel cc0 vx cv clt wbr cP vx cv
      cD cbl cfv co cB wss wa vx cr wrex cD cme wcel cB cD cbl cfv crn wcel cc0
      vw cv clt wbr cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab wceq
      wa vw cr wrex vz cD cdm cdm wrex cP cB wcel cc0 vx cv clt wbr cP vx cv cD
      cbl cfv co cB wss wa vx cr wrex wi vz vw vv cB cD cD cdm cdm cD cdm cdm
      eqid blrn2 cD cme wcel cc0 vw cv clt wbr cB vz cv vv cv cD co vw cv clt
      wbr vv cD cdm cdm crab wceq wa cP cB wcel cc0 vx cv clt wbr cP vx cv cD
      cbl cfv co cB wss wa vx cr wrex wi vz vw cD cdm cdm cr cD cme wcel vz cv
      cD cdm cdm wcel vw cv cr wcel wa cc0 vw cv clt wbr cB vz cv vv cv cD co
      vw cv clt wbr vv cD cdm cdm crab wceq wa cP cB wcel cc0 vx cv clt wbr cP
      vx cv cD cbl cfv co cB wss wa vx cr wrex cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel wa wa cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm
      crab wceq cP cB wcel cc0 vx cv clt wbr cP vx cv cD cbl cfv co cB wss wa
      vx cr wrex cc0 vw cv clt wbr vw cv vz cv cP cD co cmin co cr wcel cc0 vw
      cv vz cv cP cD co cmin co clt wbr cP vw cv vz cv cP cD co cmin co cD cbl
      cfv co cB wss wa cc0 vx cv clt wbr cP vx cv cD cbl cfv co cB wss wa vx cr
      wrex cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cB vz cv vv cv
      cD co vw cv clt wbr vv cD cdm cdm crab wceq cP cB wcel wa wa cc0 vx cv
      clt wbr cP vx cv cD cbl cfv co cB wss wa cc0 vw cv vz cv cP cD co cmin co
      clt wbr cP vw cv vz cv cP cD co cmin co cD cbl cfv co cB wss wa vx vw cv
      vz cv cP cD co cmin co cr vx cv vw cv vz cv cP cD co cmin co wceq cc0 vx
      cv clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr cP vx cv cD cbl cfv
      co cB wss cP vw cv vz cv cP cD co cmin co cD cbl cfv co cB wss vx cv vw
      cv vz cv cP cD co cmin co cc0 clt breq2 vx cv vw cv vz cv cP cD co cmin
      co wceq cP vx cv cD cbl cfv co cP vw cv vz cv cP cD co cmin co cD cbl cfv
      co cB vx cv vw cv vz cv cP cD co cmin co cP cD cbl cfv opreq2 sseq1d
      anbi12d rcla4ev cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP
      cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa vw cv vz cv cP cD co cmin
      co cr wcel cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab wceq cP
      cB wcel wa cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD
      cdm cdm wcel vw cv vz cv cP cD co cmin co cr wcel vz cv cP cD co vw cv
      clt wbr vw cv cr wcel vz cv cP cD co cr wcel vw cv vz cv cP cD co cmin co
      cr wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm
      cdm wcel wa vw cv vz cv cP cD co resubcl cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel cP cD cdm cdm wcel simplrr cD cme wcel vz cv cD cdm
      cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vw cv cr wcel cD cme
      wcel vz cv cD cdm cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vz
      cv cP cD cD cdm cdm cD cdm cdm eqid metcl 3expa adantlrr sylanc adantrr
      cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab wceq cP cB wcel cP
      cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa cB vz cv vv cv cD co vw
      cv clt wbr vv cD cdm cdm crab wceq cP cB wcel cP vz cv vv cv cD co vw cv
      clt wbr vv cD cdm cdm crab wcel cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr wa cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab cP eleq2
      vz cv vv cv cD co vw cv clt wbr vz cv cP cD co vw cv clt wbr vv cP cD cdm
      cdm vv cv cP wceq vz cv vv cv cD co vz cv cP cD co vw cv clt vv cv cP vz
      cv cD opreq2 breq1d elrab syl6bb biimpa sylan2 cD cme wcel vz cv cD cdm
      cdm wcel vw cv cr wcel wa wa cB vz cv vv cv cD co vw cv clt wbr vv cD cdm
      cdm crab wceq cP cB wcel wa wa cc0 vw cv vz cv cP cD co cmin co clt wbr
      cP vw cv vz cv cP cD co cmin co cD cbl cfv co cB wss cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr wa cc0 vw cv vz cv cP cD co cmin co clt wbr cB vz cv vv cv cD co
      vw cv clt wbr vv cD cdm cdm crab wceq cP cB wcel wa cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr cD cme wcel vz cv cD cdm
      cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel wa vz cv cP cD co vw cv
      clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr vz cv cP cD co cr wcel
      vw cv cr wcel vz cv cP cD co vw cv clt wbr cc0 vw cv vz cv cP cD co cmin
      co clt wbr wb cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD
      cdm cdm wcel wa vz cv cP cD co vw cv posdif cD cme wcel vz cv cD cdm cdm
      wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vw cv cr wcel cD cme wcel
      vz cv cD cdm cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vz cv cP
      cD cD cdm cdm cD cdm cdm eqid metcl 3expa adantlrr cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel cP cD cdm cdm wcel simplrr sylanc biimpa
      anasss cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab wceq cP cB
      wcel cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa cB vz cv vv cv cD
      co vw cv clt wbr vv cD cdm cdm crab wceq cP cB wcel cP vz cv vv cv cD co
      vw cv clt wbr vv cD cdm cdm crab wcel cP cD cdm cdm wcel vz cv cP cD co
      vw cv clt wbr wa cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab cP
      eleq2 vz cv vv cv cD co vw cv clt wbr vz cv cP cD co vw cv clt wbr vv cP
      cD cdm cdm vv cv cP wceq vz cv vv cv cD co vz cv cP cD co vw cv clt vv cv
      cP vz cv cD opreq2 breq1d elrab syl6bb biimpa sylan2 cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cB vz cv vv cv cD co vw cv clt wbr vv cD
      cdm cdm crab wceq cP cB wcel wa wa cP vw cv vz cv cP cD co cmin co cD cbl
      cfv co vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab cB cD cme wcel
      vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD
      co vw cv clt wbr wa cP vw cv vz cv cP cD co cmin co cD cbl cfv co vz cv
      vv cv cD co vw cv clt wbr vv cD cdm cdm crab wss cB vz cv vv cv cD co vw
      cv clt wbr vv cD cdm cdm crab wceq cP cB wcel wa cD cme wcel vz cv cD cdm
      cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt
      wbr wa wa vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm cP vw cv vz cv cP
      cD co cmin co cD cbl cfv co cD cme wcel cP cD cdm cdm wcel wa vw cv vz cv
      cP cD co cmin co cr wcel cc0 vw cv vz cv cP cD co cmin co clt wbr wa cP
      vw cv vz cv cP cD co cmin co cD cbl cfv co cD cdm cdm wss cD cme wcel vz
      cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co
      vw cv clt wbr wa wa cD cP vw cv vz cv cP cD co cmin co cD cdm cdm cD cdm
      cdm eqid blssm cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cD
      cme wcel cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa cP cD cdm cdm
      wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa pm3.26 cP cD cdm
      cdm wcel vz cv cP cD co vw cv clt wbr pm3.26 anim12i cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr wa wa vw cv vz cv cP cD co cmin co cr wcel cc0 vw cv vz cv cP cD
      co cmin co clt wbr cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa
      cP cD cdm cdm wcel vw cv vz cv cP cD co cmin co cr wcel vz cv cP cD co vw
      cv clt wbr vw cv cr wcel vz cv cP cD co cr wcel vw cv vz cv cP cD co cmin
      co cr wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD
      cdm cdm wcel wa vw cv vz cv cP cD co resubcl cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel cP cD cdm cdm wcel simplrr cD cme wcel vz cv cD cdm
      cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vw cv cr wcel cD cme
      wcel vz cv cD cdm cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vz
      cv cP cD cD cdm cdm cD cdm cdm eqid metcl 3expa adantlrr sylanc adantrr
      cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel
      vz cv cP cD co vw cv clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr cD
      cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel wa
      vz cv cP cD co vw cv clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr vz
      cv cP cD co cr wcel vw cv cr wcel vz cv cP cD co vw cv clt wbr cc0 vw cv
      vz cv cP cD co cmin co clt wbr wb cD cme wcel vz cv cD cdm cdm wcel vw cv
      cr wcel wa wa cP cD cdm cdm wcel wa vz cv cP cD co vw cv posdif cD cme
      wcel vz cv cD cdm cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vw
      cv cr wcel cD cme wcel vz cv cD cdm cdm wcel cP cD cdm cdm wcel vz cv cP
      cD co cr wcel vz cv cP cD cD cdm cdm cD cdm cdm eqid metcl 3expa adantlrr
      cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel cP cD cdm cdm wcel
      simplrr sylanc biimpa anasss jca sylanc cD cme wcel vz cv cD cdm cdm wcel
      vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa
      vv cv cP vw cv vz cv cP cD co cmin co cD cbl cfv co wcel vz cv vv cv cD
      co vw cv clt wbr cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP
      cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cP vw cv vz cv
      cP cD co cmin co cD cbl cfv co wcel vv cv cD cdm cdm wcel cP vv cv cD co
      vw cv vz cv cP cD co cmin co clt wbr wa vz cv vv cv cD co vw cv clt wbr
      cD cme wcel cP cD cdm cdm wcel wa vw cv vz cv cP cD co cmin co cr wcel
      cc0 vw cv vz cv cP cD co cmin co clt wbr wa vv cv cP vw cv vz cv cP cD co
      cmin co cD cbl cfv co wcel vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz
      cv cP cD co cmin co clt wbr wa wb cD cme wcel vz cv cD cdm cdm wcel vw cv
      cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv
      cD cP vw cv vz cv cP cD co cmin co cD cdm cdm cD cdm cdm eqid elbl cD cme
      wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cD cme wcel cP cD cdm cdm
      wcel vz cv cP cD co vw cv clt wbr wa cP cD cdm cdm wcel cD cme wcel vz cv
      cD cdm cdm wcel vw cv cr wcel wa pm3.26 cP cD cdm cdm wcel vz cv cP cD co
      vw cv clt wbr pm3.26 anim12i cD cme wcel vz cv cD cdm cdm wcel vw cv cr
      wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vw cv vz
      cv cP cD co cmin co cr wcel cc0 vw cv vz cv cP cD co cmin co clt wbr cD
      cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vw
      cv vz cv cP cD co cmin co cr wcel vz cv cP cD co vw cv clt wbr vw cv cr
      wcel vz cv cP cD co cr wcel vw cv vz cv cP cD co cmin co cr wcel cD cme
      wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel wa vw
      cv vz cv cP cD co resubcl cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel
      cP cD cdm cdm wcel simplrr cD cme wcel vz cv cD cdm cdm wcel cP cD cdm
      cdm wcel vz cv cP cD co cr wcel vw cv cr wcel cD cme wcel vz cv cD cdm
      cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vz cv cP cD cD cdm cdm
      cD cdm cdm eqid metcl 3expa adantlrr sylanc adantrr cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr cD cme wcel vz cv cD cdm
      cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel wa vz cv cP cD co vw cv
      clt wbr cc0 vw cv vz cv cP cD co cmin co clt wbr vz cv cP cD co cr wcel
      vw cv cr wcel vz cv cP cD co vw cv clt wbr cc0 vw cv vz cv cP cD co cmin
      co clt wbr wb cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD
      cdm cdm wcel wa vz cv cP cD co vw cv posdif cD cme wcel vz cv cD cdm cdm
      wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vw cv cr wcel cD cme wcel
      vz cv cD cdm cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vz cv cP
      cD cD cdm cdm cD cdm cdm eqid metcl 3expa adantlrr cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel cP cD cdm cdm wcel simplrr sylanc biimpa
      anasss jca sylanc cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa
      cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm
      wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa vz cv vv cv
      cD co vw cv clt wbr cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa
      cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm
      wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa wa vz cv vv
      cv cD co vz cv cP cD co cP vv cv cD co caddc co vw cv cD cme wcel vz cv
      cD cdm cdm wcel vv cv cD cdm cdm wcel vz cv vv cv cD co cr wcel cD cme
      wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv
      cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm wcel cP vv cv cD co vw cv
      vz cv cP cD co cmin co clt wbr wa wa vz cv vv cv cD cD cdm cdm cD cdm cdm
      eqid metcl cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa cP cD cdm
      cdm wcel vz cv cP cD co vw cv clt wbr wa vv cv cD cdm cdm wcel cP vv cv
      cD co vw cv vz cv cP cD co cmin co clt wbr wa simplll cD cme wcel vz cv
      cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw
      cv clt wbr wa wa vz cv cD cdm cdm wcel vv cv cD cdm cdm wcel cP vv cv cD
      co vw cv vz cv cP cD co cmin co clt wbr wa cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa
      simplrl adantr cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP
      cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm wcel
      cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr simprl syl3anc vz cv
      cP cD co cr wcel cP vv cv cD co cr wcel vz cv cP cD co cP vv cv cD co
      caddc co cr wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP
      cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm wcel
      cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa wa vz cv cP cD co
      cP vv cv cD co readdcl cD cme wcel vz cv cD cdm cdm wcel cP cD cdm cdm
      wcel vz cv cP cD co cr wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr
      wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD
      cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa wa vz
      cv cP cD cD cdm cdm cD cdm cdm eqid metcl cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa
      vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr
      wa simplll cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD
      cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vz cv cD cdm cdm wcel vv
      cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa
      cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel cP cD cdm cdm wcel vz cv
      cP cD co vw cv clt wbr wa simplrl adantr cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr
      vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr
      wa simplrl syl3anc cD cme wcel cP cD cdm cdm wcel vv cv cD cdm cdm wcel
      cP vv cv cD co cr wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa
      wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm
      wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa wa cP vv cv
      cD cD cdm cdm cD cdm cdm eqid metcl cD cme wcel vz cv cD cdm cdm wcel vw
      cv cr wcel wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa vv cv cD
      cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa
      simplll cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm
      cdm wcel vz cv cP cD co vw cv clt wbr vv cv cD cdm cdm wcel cP vv cv cD
      co vw cv vz cv cP cD co cmin co clt wbr wa simplrl cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr wa wa vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co
      cmin co clt wbr simprl syl3anc sylanc cD cme wcel vz cv cD cdm cdm wcel
      vw cv cr wcel wa wa vw cv cr wcel cP cD cdm cdm wcel vz cv cP cD co vw cv
      clt wbr wa vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin
      co clt wbr wa cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel simprr
      ad2antrr cD cme wcel vz cv cD cdm cdm wcel vv cv cD cdm cdm wcel cP cD
      cdm cdm wcel w3a vz cv vv cv cD co vz cv cP cD co cP vv cv cD co caddc co
      cle wbr cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm
      cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm wcel cP vv
      cv cD co vw cv vz cv cP cD co cmin co clt wbr wa wa vz cv vv cv cP cD cD
      cdm cdm cD cdm cdm eqid mettri cD cme wcel vz cv cD cdm cdm wcel vw cv cr
      wcel wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa vv cv cD cdm
      cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa simplll
      cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel
      vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm wcel cP vv cv cD co
      vw cv vz cv cP cD co cmin co clt wbr wa wa vz cv cD cdm cdm wcel vv cv cD
      cdm cdm wcel cP cD cdm cdm wcel cD cme wcel vz cv cD cdm cdm wcel vw cv
      cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vz cv
      cD cdm cdm wcel vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co
      cmin co clt wbr wa cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel cP cD
      cdm cdm wcel vz cv cP cD co vw cv clt wbr wa simplrl adantr cD cme wcel
      vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD
      co vw cv clt wbr wa wa vv cv cD cdm cdm wcel cP vv cv cD co vw cv vz cv
      cP cD co cmin co clt wbr simprl cD cme wcel vz cv cD cdm cdm wcel vw cv
      cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr vv cv cD
      cdm cdm wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr wa
      simplrl 3jca sylanc cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa
      cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm
      wcel cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr vz cv cP cD co
      cP vv cv cD co caddc co vw cv clt wbr cD cme wcel vz cv cD cdm cdm wcel
      vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa wa
      vv cv cD cdm cdm wcel wa vz cv cP cD co cP vv cv cD co caddc co vw cv clt
      wbr cP vv cv cD co vw cv vz cv cP cD co cmin co clt wbr vz cv cP cD co cr
      wcel cP vv cv cD co cr wcel vw cv cr wcel vz cv cP cD co cP vv cv cD co
      caddc co vw cv clt wbr cP vv cv cD co vw cv vz cv cP cD co cmin co clt
      wbr wb cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa cP cD cdm
      cdm wcel vz cv cP cD co vw cv clt wbr wa wa vv cv cD cdm cdm wcel wa vz
      cv cP cD co cP vv cv cD co vw cv ltaddsub2 cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr
      wa wa vz cv cP cD co cr wcel vv cv cD cdm cdm wcel cD cme wcel vz cv cD
      cdm cdm wcel vw cv cr wcel wa wa cP cD cdm cdm wcel vz cv cP cD co cr
      wcel vz cv cP cD co vw cv clt wbr cD cme wcel vz cv cD cdm cdm wcel cP cD
      cdm cdm wcel vz cv cP cD co cr wcel vw cv cr wcel cD cme wcel vz cv cD
      cdm cdm wcel cP cD cdm cdm wcel vz cv cP cD co cr wcel vz cv cP cD cD cdm
      cdm cD cdm cdm eqid metcl 3expa adantlrr adantrr adantr cD cme wcel cP cD
      cdm cdm wcel vz cv cP cD co vw cv clt wbr wa vv cv cD cdm cdm wcel cP vv
      cv cD co cr wcel vz cv cD cdm cdm wcel vw cv cr wcel wa cD cme wcel cP cD
      cdm cdm wcel vv cv cD cdm cdm wcel cP vv cv cD co cr wcel vz cv cP cD co
      vw cv clt wbr cD cme wcel cP cD cdm cdm wcel vv cv cD cdm cdm wcel cP vv
      cv cD co cr wcel cP vv cv cD cD cdm cdm cD cdm cdm eqid metcl 3expa
      adantlrr adantllr cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel wa wa
      vw cv cr wcel cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa vv cv cD
      cdm cdm wcel cD cme wcel vz cv cD cdm cdm wcel vw cv cr wcel simprr
      ad2antrr syl3anc biimpar anasss lelttrd ex sylbid imp ssrabdv cB vz cv vv
      cv cD co vw cv clt wbr vv cD cdm cdm crab wceq cP cB wcel cP cD cdm cdm
      wcel vz cv cP cD co vw cv clt wbr wa cB vz cv vv cv cD co vw cv clt wbr
      vv cD cdm cdm crab wceq cP cB wcel cP vz cv vv cv cD co vw cv clt wbr vv
      cD cdm cdm crab wcel cP cD cdm cdm wcel vz cv cP cD co vw cv clt wbr wa
      cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm crab cP eleq2 vz cv vv
      cv cD co vw cv clt wbr vz cv cP cD co vw cv clt wbr vv cP cD cdm cdm vv
      cv cP wceq vz cv vv cv cD co vz cv cP cD co vw cv clt vv cv cP vz cv cD
      opreq2 breq1d elrab syl6bb biimpa sylan2 cD cme wcel vz cv cD cdm cdm
      wcel vw cv cr wcel wa wa cB vz cv vv cv cD co vw cv clt wbr vv cD cdm cdm
      crab wceq cP cB wcel simprl sseqtr4d jca sylanc adantrll exp43 r19.23advv
      sylbid 3imp $.
      $( [28-Jul-2008] $) $( [31-Aug-2006] $)
  $}

  ${
    $d x y A $.  $d x y D $.  $d x y P $.  $d y X $.
    blssex.1 $e |- X = dom dom D $.
    $( Two ways to express the existence of a ball subset. $)
    blssex $p |- ( ( D e. Met /\ P e. X ) -> ( E. x e. ran ( ball ` D ) ( P e.
     x /\ x C_ A ) <-> E. y e. RR ( 0 < y /\ ( P ( ball ` D ) y ) C_ A ) ) ) $=
      cD cme wcel cP cX wcel wa cP vx cv wcel vx cv cA wss wa vx cD cbl cfv crn
      wrex cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex cD cme
      wcel cP vx cv wcel vx cv cA wss wa vx cD cbl cfv crn wrex cc0 vy cv clt
      wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex wi cP cX wcel cD cme wcel
      cP vx cv wcel vx cv cA wss wa cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA
      wss wa vy cr wrex vx cD cbl cfv crn cD cme wcel vx cv cD cbl cfv crn wcel
      cP vx cv wcel vx cv cA wss cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA
      wss wa vy cr wrex cD cme wcel vx cv cD cbl cfv crn wcel cP vx cv wcel vx
      cv cA wss cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex
      cc0 vy cv clt wbr cP vy cv cD cbl cfv co vx cv wss wa vy cr wrex vx cv cA
      wss cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex cD cme
      wcel vx cv cD cbl cfv crn wcel cP vx cv wcel w3a cc0 vy cv clt wbr cP vy
      cv cD cbl cfv co vx cv wss wa vy cr wrex vx cv cA wss wa cc0 vy cv clt
      wbr cP vy cv cD cbl cfv co vx cv wss wa vx cv cA wss wa vy cr wrex cc0 vy
      cv clt wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex cc0 vy cv clt wbr
      cP vy cv cD cbl cfv co vx cv wss wa vx cv cA wss vy cr r19.41v cc0 vy cv
      clt wbr cP vy cv cD cbl cfv co vx cv wss wa vx cv cA wss wa cc0 vy cv clt
      wbr cP vy cv cD cbl cfv co cA wss wa vy cr cc0 vy cv clt wbr cP vy cv cD
      cbl cfv co vx cv wss vx cv cA wss cc0 vy cv clt wbr cP vy cv cD cbl cfv
      co cA wss wa cP vy cv cD cbl cfv co vx cv wss vx cv cA wss wa cP vy cv cD
      cbl cfv co cA wss cc0 vy cv clt wbr cP vy cv cD cbl cfv co vx cv cA sstr
      anim2i anassrs r19.22si sylbir vy vx cv cD cP blss sylan 3exp1 imp4b
      r19.23adva adantr cD cme wcel cP cX wcel wa cc0 vy cv clt wbr cP vy cv cD
      cbl cfv co cA wss wa cP vx cv wcel vx cv cA wss wa vx cD cbl cfv crn wrex
      vy cr cD cme wcel cP cX wcel wa vy cv cr wcel wa cc0 vy cv clt wbr cP vy
      cv cD cbl cfv co cA wss wa cP vx cv wcel vx cv cA wss wa vx cD cbl cfv
      crn wrex cP vy cv cD cbl cfv co cD cbl cfv crn wcel cP cP vy cv cD cbl
      cfv co wcel cP vy cv cD cbl cfv co cA wss wa cP vx cv wcel vx cv cA wss
      wa vx cD cbl cfv crn wrex cD cme wcel cP cX wcel wa vy cv cr wcel wa cc0
      vy cv clt wbr cP vy cv cD cbl cfv co cA wss wa wa cP vx cv wcel vx cv cA
      wss wa cP cP vy cv cD cbl cfv co wcel cP vy cv cD cbl cfv co cA wss wa vx
      cP vy cv cD cbl cfv co cD cbl cfv crn vx cv cP vy cv cD cbl cfv co wceq
      cP vx cv wcel cP cP vy cv cD cbl cfv co wcel vx cv cA wss cP vy cv cD cbl
      cfv co cA wss vx cv cP vy cv cD cbl cfv co cP eleq2 vx cv cP vy cv cD cbl
      cfv co cA sseq1 anbi12d rcla4ev cD cme wcel cP cX wcel wa vy cv cr wcel
      wa cc0 vy cv clt wbr cP vy cv cD cbl cfv co cD cbl cfv crn wcel cP vy cv
      cD cbl cfv co cA wss cD cme wcel cP cX wcel wa vy cv cr wcel cc0 vy cv
      clt wbr cP vy cv cD cbl cfv co cD cbl cfv crn wcel cD cP vy cv cX
      blssex.1 blelrn anassrs adantrr cD cme wcel cP cX wcel wa vy cv cr wcel
      wa cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA wss cP cP vy cv cD cbl cfv
      co wcel cP vy cv cD cbl cfv co cA wss wa cD cme wcel cP cX wcel wa vy cv
      cr wcel wa cc0 vy cv clt wbr wa cP cP vy cv cD cbl cfv co wcel cP vy cv
      cD cbl cfv co cA wss cD cme wcel cP cX wcel wa vy cv cr wcel cc0 vy cv
      clt wbr cP cP vy cv cD cbl cfv co wcel cD cP vy cv cX blssex.1 blcntr
      anassrs anim1i anasss sylanc ex r19.23adva impbid $.
      $( [27-Sep-2007] $) $( [5-May-2007] $)
  $}

  ${
    $d x D $.  $d x P $.  $d x R $.  $d x S $.  $d x X $.
    ssbl.1 $e |- X = dom dom D $.
    $( The size of a ball increases monotonically with its radius. $)
    ssbl $p |- ( ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) /\
               ( S e. RR /\ 0 < S ) ) /\ R <_ S ) ->
               ( P ( ball ` D ) R ) C_ ( P ( ball ` D ) S ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS
      clt wbr wa w3a cR cS cle wbr wa vx cP cR cD cbl cfv co cP cS cD cbl cfv
      co cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0
      cS clt wbr wa w3a cR cS cle wbr wa vx cv cX wcel cP vx cv cD co cR clt
      wbr wa vx cv cX wcel cP vx cv cD co cS clt wbr wa vx cv cP cR cD cbl cfv
      co wcel vx cv cP cS cD cbl cfv co wcel cD cme wcel cP cX wcel wa cR cr
      wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a cR cS cle wbr vx
      cv cX wcel cP vx cv cD co cR clt wbr wa vx cv cX wcel cP vx cv cD co cS
      clt wbr wa wi cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS
      cr wcel cR cS cle wbr vx cv cX wcel cP vx cv cD co cR clt wbr wa vx cv cX
      wcel cP vx cv cD co cS clt wbr wa wi wi cc0 cS clt wbr cD cme wcel cP cX
      wcel wa cR cr wcel cS cr wcel cR cS cle wbr vx cv cX wcel cP vx cv cD co
      cR clt wbr wa vx cv cX wcel cP vx cv cD co cS clt wbr wa wi wi cc0 cR clt
      wbr cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel cR cS cle wbr vx cv
      cX wcel cP vx cv cD co cR clt wbr wa vx cv cX wcel cP vx cv cD co cS clt
      wbr wa wi wi cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel wa wa cR cS
      cle wbr vx cv cX wcel cP vx cv cD co cR clt wbr wa vx cv cX wcel cP vx cv
      cD co cS clt wbr wa wi cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel wa
      wa cR cS cle wbr wa vx cv cX wcel cP vx cv cD co cR clt wbr cP vx cv cD
      co cS clt wbr cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel wa cR cS
      cle wbr vx cv cX wcel cP vx cv cD co cR clt wbr cP vx cv cD co cS clt wbr
      wi wi vx cv cX wcel cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel wa cR
      cS cle wbr cP vx cv cD co cR clt wbr cP vx cv cD co cS clt wbr wi vx cv
      cX wcel cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel wa cR cS cle wbr
      cP vx cv cD co cR clt wbr cP vx cv cD co cS clt wbr wi wi vx cv cX wcel
      cD cme wcel cP cX wcel wa wa cR cr wcel cS cr wcel cR cS cle wbr cP vx cv
      cD co cR clt wbr cP vx cv cD co cS clt wbr wi wi vx cv cX wcel cD cme
      wcel cP cX wcel wa wa cR cr wcel cS cr wcel w3a cP vx cv cD co cR clt wbr
      cR cS cle wbr cP vx cv cD co cS clt wbr vx cv cX wcel cD cme wcel cP cX
      wcel wa wa cR cr wcel cS cr wcel w3a cP vx cv cD co cR clt wbr cR cS cle
      wbr cP vx cv cD co cS clt wbr cP vx cv cD co cr wcel cR cr wcel cS cr
      wcel cP vx cv cD co cR clt wbr cR cS cle wbr wa cP vx cv cD co cS clt wbr
      wi vx cv cX wcel cD cme wcel cP cX wcel wa wa cP vx cv cD co cR cS ltletr
      cD cme wcel cP cX wcel wa vx cv cX wcel cP vx cv cD co cr wcel cD cme
      wcel cP cX wcel vx cv cX wcel cP vx cv cD co cr wcel cP vx cv cD cX
      ssbl.1 metcl 3expa ancoms syl3an1 exp3a com23 3expb exp31 com4l imp31
      imdistand ex 3impb 3adant2r 3adant3r imp cD cme wcel cP cX wcel wa cR cr
      wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a vx cv cP cR cD
      cbl cfv co wcel vx cv cX wcel cP vx cv cD co cR clt wbr wa wb cR cS cle
      wbr cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa vx cv cP cR cD
      cbl cfv co wcel vx cv cX wcel cP vx cv cD co cR clt wbr wa wb cS cr wcel
      cc0 cS clt wbr wa vx cv cD cP cR cX ssbl.1 elbl 3adant3 adantr cD cme
      wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr
      wa w3a vx cv cP cS cD cbl cfv co wcel vx cv cX wcel cP vx cv cD co cS clt
      wbr wa wb cR cS cle wbr cD cme wcel cP cX wcel wa cS cr wcel cc0 cS clt
      wbr wa vx cv cP cS cD cbl cfv co wcel vx cv cX wcel cP vx cv cD co cS clt
      wbr wa wb cR cr wcel cc0 cR clt wbr wa vx cv cD cP cS cX ssbl.1 elbl
      3adant2 adantr 3imtr4d ssrdv $.
      $( [29-Oct-2007] $) $( [20-Sep-2007] $)
  $}

  ${
    $d x D $.  $d x P $.  $d x R $.  $d x S $.
    ssblex.1 $e |- X = dom dom D $.
    $( A nested ball exists whose radius is less than any desired amount. $)
    ssblex $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) /\
               ( S e. RR /\ 0 < S ) ) -> E. x e. RR ( 0 < x /\ x < R /\
               ( P ( ball ` D ) x ) C_ ( P ( ball ` D ) S ) ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS
      clt wbr wa w3a cR cS cle wbr cS cR clt wbr wo cc0 vx cv clt wbr vx cv cR
      clt wbr cP vx cv cD cbl cfv co cP cS cD cbl cfv co wss w3a vx cr wrex cR
      cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa cR cS cle wbr cS
      cR clt wbr wo cD cme wcel cP cX wcel wa cR cr wcel cS cr wcel cR cS cle
      wbr cS cR clt wbr wo cc0 cR clt wbr cc0 cS clt wbr cR cS lelttric
      ad2ant2r 3adant1 cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa
      cS cr wcel cc0 cS clt wbr wa w3a cR cS cle wbr cc0 vx cv clt wbr vx cv cR
      clt wbr cP vx cv cD cbl cfv co cP cS cD cbl cfv co wss w3a vx cr wrex cS
      cR clt wbr cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr cR c2 cdiv co
      cR clt wbr cP cR c2 cdiv co cD cbl cfv co cP cS cD cbl cfv co wss w3a cc0
      vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cP cS cD cbl cfv co
      wss w3a vx cr wrex cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa
      cS cr wcel cc0 cS clt wbr wa w3a cR cS cle wbr wa cc0 vx cv clt wbr vx cv
      cR clt wbr cP vx cv cD cbl cfv co cP cS cD cbl cfv co wss w3a cc0 cR c2
      cdiv co clt wbr cR c2 cdiv co cR clt wbr cP cR c2 cdiv co cD cbl cfv co
      cP cS cD cbl cfv co wss w3a vx cR c2 cdiv co cr vx cv cR c2 cdiv co wceq
      cc0 vx cv clt wbr cc0 cR c2 cdiv co clt wbr vx cv cR clt wbr cR c2 cdiv
      co cR clt wbr cP vx cv cD cbl cfv co cP cS cD cbl cfv co wss cP cR c2
      cdiv co cD cbl cfv co cP cS cD cbl cfv co wss vx cv cR c2 cdiv co cc0 clt
      breq2 vx cv cR c2 cdiv co cR clt breq1 vx cv cR c2 cdiv co wceq cP vx cv
      cD cbl cfv co cP cR c2 cdiv co cD cbl cfv co cP cS cD cbl cfv co vx cv cR
      c2 cdiv co cP cD cbl cfv opreq2 sseq1d 3anbi123d rcla4ev cR cr wcel cc0
      cR clt wbr wa cD cme wcel cP cX wcel wa cR cS cle wbr cR c2 cdiv co cr
      wcel cS cr wcel cc0 cS clt wbr wa cR cr wcel cR c2 cdiv co cr wcel cc0 cR
      clt wbr cR cS cle wbr cR rehalfcl ad2antrr 3ad2antl2 cD cme wcel cP cX
      wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a cR
      cS cle wbr wa cc0 cR c2 cdiv co clt wbr cR c2 cdiv co cR clt wbr cP cR c2
      cdiv co cD cbl cfv co cP cS cD cbl cfv co wss cR cr wcel cc0 cR clt wbr
      wa cD cme wcel cP cX wcel wa cR cS cle wbr cc0 cR c2 cdiv co clt wbr cS
      cr wcel cc0 cS clt wbr wa cR cr wcel cc0 cR clt wbr wa cc0 cR c2 cdiv co
      clt wbr cR cS cle wbr cR cr wcel cc0 cR clt wbr cc0 cR c2 cdiv co clt wbr
      cR halfpos2 biimpa adantr 3ad2antl2 cR cr wcel cc0 cR clt wbr wa cD cme
      wcel cP cX wcel wa cR cS cle wbr cR c2 cdiv co cR clt wbr cS cr wcel cc0
      cS clt wbr wa cR cr wcel cc0 cR clt wbr wa cR c2 cdiv co cR clt wbr cR cS
      cle wbr cR cr wcel cc0 cR clt wbr cR c2 cdiv co cR clt wbr cR halfpos
      biimpa adantr 3ad2antl2 cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt
      wbr wa cS cr wcel cc0 cS clt wbr wa w3a cR cS cle wbr cR c2 cdiv co cS
      cle wbr cP cR c2 cdiv co cD cbl cfv co cP cS cD cbl cfv co wss cR cr wcel
      cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa cR cS cle wbr cR c2 cdiv
      co cS cle wbr cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS
      cr wcel cR cS cle wbr cR c2 cdiv co cS cle wbr cc0 cS clt wbr cR cr wcel
      cc0 cR clt wbr wa cS cr wcel wa cR cS cle wbr wa cR c2 cdiv co cS clt wbr
      cR c2 cdiv co cS cle wbr cR cr wcel cc0 cR clt wbr wa cS cr wcel wa cR cS
      cle wbr wa cR c2 cdiv co cR cS cR cr wcel cc0 cR clt wbr wa cR c2 cdiv co
      cr wcel cS cr wcel cR cS cle wbr cR cr wcel cR c2 cdiv co cr wcel cc0 cR
      clt wbr cR rehalfcl adantr ad2antrr cR cr wcel cc0 cR clt wbr cS cr wcel
      cR cS cle wbr simplll cR cr wcel cc0 cR clt wbr wa cS cr wcel cR cS cle
      wbr simplr cR cr wcel cc0 cR clt wbr wa cR c2 cdiv co cR clt wbr cS cr
      wcel cR cS cle wbr cR cr wcel cc0 cR clt wbr cR c2 cdiv co cR clt wbr cR
      halfpos biimpa ad2antrr cR cr wcel cc0 cR clt wbr wa cS cr wcel wa cR cS
      cle wbr pm3.27 ltletrd cR cr wcel cc0 cR clt wbr wa cS cr wcel wa cR c2
      cdiv co cS clt wbr cR c2 cdiv co cS cle wbr wi cR cS cle wbr cR cr wcel
      cS cr wcel cR c2 cdiv co cS clt wbr cR c2 cdiv co cS cle wbr wi cc0 cR
      clt wbr cR c2 cdiv co cr wcel cS cr wcel cR c2 cdiv co cS clt wbr cR c2
      cdiv co cS cle wbr wi cR cr wcel cR c2 cdiv co cS ltle cR rehalfcl sylan
      adantlr adantr mpd adantlrr 3adantl1 cD cme wcel cP cX wcel wa cR c2 cdiv
      co cr wcel cc0 cR c2 cdiv co clt wbr wa cS cr wcel cc0 cS clt wbr wa cR
      c2 cdiv co cS cle wbr cP cR c2 cdiv co cD cbl cfv co cP cS cD cbl cfv co
      wss cR cr wcel cc0 cR clt wbr wa cD cP cR c2 cdiv co cS cX ssblex.1 ssbl
      cR cr wcel cc0 cR clt wbr wa cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt
      wbr cR cr wcel cR c2 cdiv co cr wcel cc0 cR clt wbr cR rehalfcl adantr cR
      cr wcel cc0 cR clt wbr cc0 cR c2 cdiv co clt wbr cR halfpos2 biimpa jca
      syl3anl2 syldan 3jca sylanc cS cr wcel cc0 cS clt wbr cS cR clt wbr cP cS
      cD cbl cfv co cP cS cD cbl cfv co wss w3a cc0 vx cv clt wbr vx cv cR clt
      wbr cP vx cv cD cbl cfv co cP cS cD cbl cfv co wss w3a vx cr wrex cD cme
      wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr
      wa w3a cS cR clt wbr wa cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD
      cbl cfv co cP cS cD cbl cfv co wss w3a cc0 cS clt wbr cS cR clt wbr cP cS
      cD cbl cfv co cP cS cD cbl cfv co wss w3a vx cS cr vx cv cS wceq cc0 vx
      cv clt wbr cc0 cS clt wbr vx cv cR clt wbr cS cR clt wbr cP vx cv cD cbl
      cfv co cP cS cD cbl cfv co wss cP cS cD cbl cfv co cP cS cD cbl cfv co
      wss vx cv cS cc0 clt breq2 vx cv cS cR clt breq1 vx cv cS wceq cP vx cv
      cD cbl cfv co cP cS cD cbl cfv co cP cS cD cbl cfv co vx cv cS cP cD cbl
      cfv opreq2 sseq1d 3anbi123d rcla4ev cS cr wcel cc0 cS clt wbr wa cD cme
      wcel cP cX wcel wa cS cR clt wbr cS cr wcel cR cr wcel cc0 cR clt wbr wa
      cS cr wcel cc0 cS clt wbr cS cR clt wbr simpll 3ad2antl3 cD cme wcel cP
      cX wcel wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a
      cS cR clt wbr wa cc0 cS clt wbr cS cR clt wbr cP cS cD cbl cfv co cP cS
      cD cbl cfv co wss cS cr wcel cc0 cS clt wbr wa cD cme wcel cP cX wcel wa
      cS cR clt wbr cc0 cS clt wbr cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0
      cS clt wbr cS cR clt wbr simplr 3ad2antl3 cD cme wcel cP cX wcel wa cR cr
      wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a cS cR clt wbr
      pm3.27 cP cS cD cbl cfv co cP cS cD cbl cfv co wss cD cme wcel cP cX wcel
      wa cR cr wcel cc0 cR clt wbr wa cS cr wcel cc0 cS clt wbr wa w3a cS cR
      clt wbr wa cP cS cD cbl cfv co ssid a1i 3jca sylanc jaodan mpdan $.
      $( [30-Oct-2007] $) $( [20-Sep-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Open sets of a metric space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d v w x y z D $.  $d x y P $.  $d v w x y z X $.
    opnfval.1 $e |- X = dom dom D $.
    opnfval.2 $e |- J = ( Open ` D ) $.
    $( An open set is a subset of a metric space which includes a ball around
       each of its points.  Definition 1.3-2 of [Kreyszig] p. 18.  The
       object ` ( Open `` D ) ` is the family of all open sets in the metric
       space determined by the metric ` D ` .  By ~ opntop , the open sets of a
       metric space form a topology ` J ` , whose base set is ` U. J ` by
       ~ uniopn2 . $)
    opnfval $p |- ( D e. Met -> J = { x | ( x C_ X /\
               A. y e. x E. z e. ran ( ball ` D ) ( y e. z /\ z C_ x ) ) } ) $=
      cD cme wcel cD copn cfv vx cv cX wss vy cv vz cv wcel vz cv vx cv wss wa
      vz cD cbl cfv crn wrex vy vx cv wral wa vx cab cJ cD cme wcel vx cv cX
      wss vy cv vz cv wcel vz cv vx cv wss wa vz cD cbl cfv crn wrex vy vx cv
      wral wa vx cab cvv wcel cD copn cfv vx cv cX wss vy cv vz cv wcel vz cv
      vx cv wss wa vz cD cbl cfv crn wrex vy vx cv wral wa vx cab wceq cD cme
      wcel cX cvv wcel vx cv cX wss vy cv vz cv wcel vz cv vx cv wss wa vz cD
      cbl cfv crn wrex vy vx cv wral wa vx cab cvv wcel cD cme wcel cD cdm cdm
      cvv cX cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD
      cdm cvv dmexg syl opnfval.1 syl5eqel vy cv vz cv wcel vz cv vx cv wss wa
      vz cD cbl cfv crn wrex vy vx cv wral vx cX cvv abssexg syl vw vv cD vx cv
      vw cv cdm cdm wss vy cv vz cv wcel vz cv vx cv wss wa vz vw cv cbl cfv
      crn wrex vy vx cv wral wa vx cab vx cv cX wss vy cv vz cv wcel vz cv vx
      cv wss wa vz cD cbl cfv crn wrex vy vx cv wral wa vx cab cme cvv copn vw
      cv cD wceq vx cv vw cv cdm cdm wss vy cv vz cv wcel vz cv vx cv wss wa vz
      vw cv cbl cfv crn wrex vy vx cv wral wa vx cv cX wss vy cv vz cv wcel vz
      cv vx cv wss wa vz cD cbl cfv crn wrex vy vx cv wral wa vx vw cv cD wceq
      vx cv vw cv cdm cdm wss vx cv cX wss vy cv vz cv wcel vz cv vx cv wss wa
      vz vw cv cbl cfv crn wrex vy vx cv wral vy cv vz cv wcel vz cv vx cv wss
      wa vz cD cbl cfv crn wrex vy vx cv wral vw cv cD wceq vw cv cdm cdm cX vx
      cv vw cv cD wceq vw cv cdm cdm cD cdm cdm cX vw cv cD wceq vw cv cdm cD
      cdm vw cv cD dmeq dmeqd opnfval.1 syl6eqr sseq2d vw cv cD wceq vy cv vz
      cv wcel vz cv vx cv wss wa vz vw cv cbl cfv crn wrex vy cv vz cv wcel vz
      cv vx cv wss wa vz cD cbl cfv crn wrex vy vx cv vw cv cD wceq vy cv vz cv
      wcel vz cv vx cv wss wa vz vw cv cbl cfv crn cD cbl cfv crn vw cv cD wceq
      vw cv cbl cfv cD cbl cfv vw cv cD cbl fveq2 rneqd rexeq1d ralbidv anbi12d
      abbidv vw vv vx vy vz df-opn fvopab4g mpdan opnfval.2 syl5eq $.
      $( [1-Nov-2007] $) $( [1-Sep-2006] $)

    $( The family of open sets of a metric space is a collection of subsets of
       the base set. $)
    opnfss $p |- ( D e. Met -> J C_ ~P X ) $=
      cD cme wcel cJ vx cv cX wss vy cv vz cv wcel vz cv vx cv wss wa vz cD cbl
      cfv crn wrex vy vx cv wral wa vx cab cX cpw vx vy vz cD cJ cX opnfval.1
      opnfval.2 opnfval vx cv cX wss vy cv vz cv wcel vz cv vx cv wss wa vz cD
      cbl cfv crn wrex vy vx cv wral wa vx cab cX cpw wss cD cme wcel vx cv cX
      wss vy cv vz cv wcel vz cv vx cv wss wa vz cD cbl cfv crn wrex vy vx cv
      wral wa vx cab vx cv cX wss vx cab cX cpw vx cv cX wss vy cv vz cv wcel
      vz cv vx cv wss wa vz cD cbl cfv crn wrex vy vx cv wral wa vx cv cX wss
      vx vx cv cX wss vy cv vz cv wcel vz cv vx cv wss wa vz cD cbl cfv crn
      wrex vy vx cv wral pm3.26 ss2abi vx cX df-pw sseqtr4i a1i eqsstrd $.
      $( [1-Nov-2007] $) $( [3-Sep-2006] $)

    $( The defining property of an open set of a metric space. $)
    isopn $p |- ( D e. Met -> ( A e. J <->
   ( A C_ X /\ A. x e. A E. y e. ran ( ball ` D ) ( x e. y /\ y C_ A ) ) ) ) $=
      cD cme wcel cA cJ wcel cA vz cv cX wss vx cv vy cv wcel vy cv vz cv wss
      wa vy cD cbl cfv crn wrex vx vz cv wral wa vz cab wcel cA cX wss vx cv vy
      cv wcel vy cv cA wss wa vy cD cbl cfv crn wrex vx cA wral wa cD cme wcel
      cJ vz cv cX wss vx cv vy cv wcel vy cv vz cv wss wa vy cD cbl cfv crn
      wrex vx vz cv wral wa vz cab cA vz vx vy cD cJ cX opnfval.1 opnfval.2
      opnfval eleq2d cD cme wcel cX cvv wcel cA vz cv cX wss vx cv vy cv wcel
      vy cv vz cv wss wa vy cD cbl cfv crn wrex vx vz cv wral wa vz cab wcel cA
      cX wss vx cv vy cv wcel vy cv cA wss wa vy cD cbl cfv crn wrex vx cA wral
      wa wb cD cme wcel cD cdm cdm cvv cX cD cme wcel cD cdm cvv wcel cD cdm
      cdm cvv wcel cD cme dmexg cD cdm cvv dmexg syl opnfval.1 syl5eqel vx cv
      vy cv wcel vy cv vz cv wss wa vy cD cbl cfv crn wrex vx vz cv wral vx cv
      vy cv wcel vy cv cA wss wa vy cD cbl cfv crn wrex vx cA wral vz cA cX cvv
      vx cv vy cv wcel vy cv vz cv wss wa vy cD cbl cfv crn wrex vx cv vy cv
      wcel vy cv cA wss wa vy cD cbl cfv crn wrex vx vz cv cA vz cv cA wceq vx
      cv vy cv wcel vy cv vz cv wss wa vx cv vy cv wcel vy cv cA wss wa vy cD
      cbl cfv crn vz cv cA wceq vy cv vz cv wss vy cv cA wss vx cv vy cv wcel
      vz cv cA vy cv sseq2 anbi2d rexbidv raleqd elssabg syl bitrd $.
      $( [2-Nov-2007] $) $( [1-Sep-2006] $)

    $( The base set of a metric space is open.  Part of Theorem T1 of
       [Kreyszig] p. 19. $)
    opnm $p |- ( D e. Met -> X e. J ) $=
      cD cme wcel cX cJ wcel cX cX wss vx cv vy cv wcel vy cv cX wss wa vy cD
      cbl cfv crn wrex vx cX wral wa cD cme wcel vx cv vy cv wcel vy cv cX wss
      wa vy cD cbl cfv crn wrex vx cX wral cX cX wss cD cme wcel vx cv vy cv
      wcel vy cv cX wss wa vy cD cbl cfv crn wrex vx cX cD cme wcel vx cv cX
      wcel wa c1 cr wcel cc0 c1 clt wbr vx cv vy cv wcel vy cv cX wss wa vy cD
      cbl cfv crn wrex 1re lt01 vx cv c1 cD cbl cfv co cD cbl cfv crn wcel vx
      cv vx cv c1 cD cbl cfv co wcel vx cv c1 cD cbl cfv co cX wss wa vx cv vy
      cv wcel vy cv cX wss wa vy cD cbl cfv crn wrex cD cme wcel vx cv cX wcel
      wa c1 cr wcel cc0 c1 clt wbr wa wa vx cv vy cv wcel vy cv cX wss wa vx cv
      vx cv c1 cD cbl cfv co wcel vx cv c1 cD cbl cfv co cX wss wa vy vx cv c1
      cD cbl cfv co cD cbl cfv crn vy cv vx cv c1 cD cbl cfv co wceq vx cv vy
      cv wcel vx cv vx cv c1 cD cbl cfv co wcel vy cv cX wss vx cv c1 cD cbl
      cfv co cX wss vy cv vx cv c1 cD cbl cfv co vx cv eleq2 vy cv vx cv c1 cD
      cbl cfv co cX sseq1 anbi12d rcla4ev cD vx cv c1 cX opnfval.1 blelrn cD
      cme wcel vx cv cX wcel wa c1 cr wcel cc0 c1 clt wbr wa wa vx cv vx cv c1
      cD cbl cfv co wcel vx cv c1 cD cbl cfv co cX wss cD vx cv c1 cX opnfval.1
      blcntr cD vx cv c1 cX opnfval.1 blssm jca sylanc mpanr12 r19.21aiva cX
      ssid jctil vx vy cX cD cJ cX opnfval.1 opnfval.2 isopn mpbird $.
      $( [3-Nov-2007] $) $( [4-Sep-2006] $)

    $( The union of all open sets in a metric space is its underlying set. $)
    uniopn2 $p |- ( D e. Met -> U. J = X ) $=
      cD cme wcel cJ cuni cX cD cme wcel cJ cX cpw wss cJ cuni cX wss cD cJ cX
      opnfval.1 opnfval.2 opnfss cJ cX cpw wss cJ cuni cX cpw cuni cX cJ cX cpw
      uniss cX unipw syl6ss syl cD cme wcel cX cJ wcel cX cJ cuni wss cD cJ cX
      opnfval.1 opnfval.2 opnm cX cJ elssuni syl eqssd $.
      $( [3-Nov-2007] $) $( [4-Sep-2006] $)

    $( A defining property of an open set of a metric space. $)
    isopn4 $p |- ( D e. Met -> ( A e. J <-> ( A C_ X /\
           A. x e. A E. y e. RR ( 0 < y /\ ( x ( ball ` D ) y ) C_ A ) ) ) ) $=
      cD cme wcel cA cJ wcel cA cX wss vx cv vz cv wcel vz cv cA wss wa vz cD
      cbl cfv crn wrex vx cA wral wa cA cX wss cc0 vy cv clt wbr vx cv vy cv cD
      cbl cfv co cA wss wa vy cr wrex vx cA wral wa vx vz cA cD cJ cX opnfval.1
      opnfval.2 isopn cD cme wcel cA cX wss vx cv vz cv wcel vz cv cA wss wa vz
      cD cbl cfv crn wrex vx cA wral cc0 vy cv clt wbr vx cv vy cv cD cbl cfv
      co cA wss wa vy cr wrex vx cA wral cD cme wcel cA cX wss wa vx cv vz cv
      wcel vz cv cA wss wa vz cD cbl cfv crn wrex cc0 vy cv clt wbr vx cv vy cv
      cD cbl cfv co cA wss wa vy cr wrex vx cA cD cme wcel cA cX wss vx cv cA
      wcel vx cv vz cv wcel vz cv cA wss wa vz cD cbl cfv crn wrex cc0 vy cv
      clt wbr vx cv vy cv cD cbl cfv co cA wss wa vy cr wrex wb cD cme wcel vx
      cv cX wcel vx cv vz cv wcel vz cv cA wss wa vz cD cbl cfv crn wrex cc0 vy
      cv clt wbr vx cv vy cv cD cbl cfv co cA wss wa vy cr wrex wb cA cX wss vx
      cv cA wcel wa vz vy cA cD vx cv cX opnfval.1 blssex cA cX vx cv ssel2
      sylan2 anassrs ralbidva pm5.32da bitrd $.
      $( [4-Dec-2007] $) $( [5-May-2007] $)

    $( An open set of a metric space is a subspace of its base set. $)
    opnss $p |- ( ( D e. Met /\ A e. J ) -> A C_ X ) $=
      cD cme wcel cA cJ wcel cA cX wss vx cv vy cv wcel vy cv cA wss wa vy cD
      cbl cfv crn wrex vx cA wral vx vy cA cD cJ cX opnfval.1 opnfval.2 isopn
      pm3.26bda $.
      $( [4-Nov-2007] $) $( [3-Sep-2006] $)
  $}

  ${
    $d f g u v w x y z A $.  $d f g u v w x y B $.  $d f g u v w x y z D $.
    $d x y P $.  $d x y R $.  $d u v w J $.
    opni.1 $e |- J = ( Open ` D ) $.
    $( An open set of a metric space includes a ball around each of its
       points. $)
    opni $p |- ( ( D e. Met /\ A e. J /\ P e. A ) ->
                 E. x e. ran ( ball ` D ) ( P e. x /\ x C_ A ) ) $=
      cD cme wcel cA cJ wcel cP cA wcel cP vx cv wcel vx cv cA wss wa vx cD cbl
      cfv crn wrex cD cme wcel cA cJ wcel cA cD cdm cdm wss vy cv vx cv wcel vx
      cv cA wss wa vx cD cbl cfv crn wrex vy cA wral wa cP cA wcel cP vx cv
      wcel vx cv cA wss wa vx cD cbl cfv crn wrex wi vy vx cA cD cJ cD cdm cdm
      cD cdm cdm eqid opni.1 isopn vy cv vx cv wcel vx cv cA wss wa vx cD cbl
      cfv crn wrex vy cA wral cP cA wcel cP vx cv wcel vx cv cA wss wa vx cD
      cbl cfv crn wrex wi cA cD cdm cdm wss vy cv vx cv wcel vx cv cA wss wa vx
      cD cbl cfv crn wrex cP vx cv wcel vx cv cA wss wa vx cD cbl cfv crn wrex
      vy cP cA vy cv cP wceq vy cv vx cv wcel vx cv cA wss wa cP vx cv wcel vx
      cv cA wss wa vx cD cbl cfv crn vy cv cP wceq vy cv vx cv wcel cP vx cv
      wcel vx cv cA wss vy cv cP vx cv eleq1 anbi1d rexbidv rcla4cv adantl
      syl6bi 3imp $.
      $( [7-Nov-2007] $) $( [3-Sep-2006] $)

    $( An open set of a metric space includes a ball around each of its
       points. $)
    opni2 $p |- ( ( D e. Met /\ A e. J /\ P e. A ) ->
                 E. x e. RR ( 0 < x /\ ( P ( ball ` D ) x ) C_ A ) ) $=
      cD cme wcel cA cJ wcel cP cA wcel w3a cP vy cv wcel vy cv cA wss wa vy cD
      cbl cfv crn wrex cc0 vx cv clt wbr cP vx cv cD cbl cfv co cA wss wa vx cr
      wrex vy cA cD cP cJ opni.1 opni cD cme wcel cA cJ wcel cP cA wcel cP vy
      cv wcel vy cv cA wss wa vy cD cbl cfv crn wrex cc0 vx cv clt wbr cP vx cv
      cD cbl cfv co cA wss wa vx cr wrex wb cD cme wcel cA cJ wcel cP cA wcel
      wa cP cD cdm cdm wcel cP vy cv wcel vy cv cA wss wa vy cD cbl cfv crn
      wrex cc0 vx cv clt wbr cP vx cv cD cbl cfv co cA wss wa vx cr wrex wb cD
      cme wcel cA cJ wcel cP cA wcel cP cD cdm cdm wcel cD cme wcel cA cJ wcel
      cP cA wcel cP cD cdm cdm wcel wi cD cme wcel cA cJ wcel wa cA cD cdm cdm
      cP cA cD cJ cD cdm cdm cD cdm cdm eqid opni.1 opnss sseld ex imp32 vy vx
      cA cD cP cD cdm cdm cD cdm cdm eqid blssex syldan 3impb mpbid $.
      $( [14-Nov-2007] $) $( [2-May-2007] $)

    $( An open set of a metric space includes an arbitrarily small ball around
       each of its points. $)
    opni3 $p |- ( ( ( D e. Met /\ A e. J /\ P e. A ) /\ ( R e. RR /\
   0 < R ) ) -> E. x e. RR ( 0 < x /\ x < R /\ ( P ( ball ` D ) x ) C_ A ) ) $=
      cD cme wcel cA cJ wcel cP cA wcel w3a cR cr wcel cc0 cR clt wbr wa wa cc0
      vy cv clt wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex cc0 vx cv clt
      wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cA wss w3a vx cr wrex cD cme
      wcel cA cJ wcel cP cA wcel w3a cc0 vy cv clt wbr cP vy cv cD cbl cfv co
      cA wss wa vy cr wrex cR cr wcel cc0 cR clt wbr wa vy cA cD cP cJ opni.1
      opni2 adantr cD cme wcel cP cD cdm cdm wcel wa cR cr wcel cc0 cR clt wbr
      wa cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA wss wa vy cr wrex cc0 vx
      cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cA wss w3a vx cr wrex
      wi cD cme wcel cA cJ wcel cP cA wcel w3a cD cme wcel cP cD cdm cdm wcel
      wa cR cr wcel cc0 cR clt wbr wa wa cc0 vy cv clt wbr cP vy cv cD cbl cfv
      co cA wss wa cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cA
      wss w3a vx cr wrex vy cr cD cme wcel cP cD cdm cdm wcel wa cR cr wcel cc0
      cR clt wbr wa wa vy cv cr wcel cc0 vy cv clt wbr cP vy cv cD cbl cfv co
      cA wss wa cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cA
      wss w3a vx cr wrex cD cme wcel cP cD cdm cdm wcel wa cR cr wcel cc0 cR
      clt wbr wa wa vy cv cr wcel cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA
      wss wa wa wa cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cP
      vy cv cD cbl cfv co wss w3a vx cr wrex cc0 vx cv clt wbr vx cv cR clt wbr
      cP vx cv cD cbl cfv co cA wss w3a vx cr wrex cD cme wcel cP cD cdm cdm
      wcel wa cR cr wcel cc0 cR clt wbr wa wa vy cv cr wcel cc0 vy cv clt wbr
      cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cP vy cv cD cbl
      cfv co wss w3a vx cr wrex cP vy cv cD cbl cfv co cA wss cD cme wcel cP cD
      cdm cdm wcel wa cR cr wcel cc0 cR clt wbr wa vy cv cr wcel cc0 vy cv clt
      wbr wa cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cP vy cv
      cD cbl cfv co wss w3a vx cr wrex vx cD cP cR vy cv cD cdm cdm cD cdm cdm
      eqid ssblex 3expa adantrrr cc0 vy cv clt wbr cP vy cv cD cbl cfv co cA
      wss wa cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cP vy cv
      cD cbl cfv co wss w3a vx cr wrex cc0 vx cv clt wbr vx cv cR clt wbr cP vx
      cv cD cbl cfv co cA wss w3a vx cr wrex wi cD cme wcel cP cD cdm cdm wcel
      wa cR cr wcel cc0 cR clt wbr wa wa vy cv cr wcel cP vy cv cD cbl cfv co
      cA wss cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv co cP vy cv
      cD cbl cfv co wss w3a vx cr wrex cc0 vx cv clt wbr vx cv cR clt wbr cP vx
      cv cD cbl cfv co cA wss w3a vx cr wrex wi cc0 vy cv clt wbr cP vy cv cD
      cbl cfv co cA wss cc0 vx cv clt wbr vx cv cR clt wbr cP vx cv cD cbl cfv
      co cP vy cv cD cbl cfv co wss w3a cc0 vx cv clt wbr vx cv cR clt wbr cP
      vx cv cD cbl cfv co cA wss w3a vx cr cP vy cv cD cbl cfv co cA wss cc0 vx
      cv clt wbr cc0 vx cv clt wbr vx cv cR clt wbr vx cv cR clt wbr cP vx cv
      cD cbl cfv co cP vy cv cD cbl cfv co wss cP vx cv cD cbl cfv co cA wss cP
      vy cv cD cbl cfv co cA wss cc0 vx cv clt wbr idd cP vy cv cD cbl cfv co
      cA wss vx cv cR clt wbr idd cP vx cv cD cbl cfv co cP vy cv cD cbl cfv co
      wss cP vy cv cD cbl cfv co cA wss cP vx cv cD cbl cfv co cA wss cP vx cv
      cD cbl cfv co cP vy cv cD cbl cfv co cA sstr2 com12 3anim123d r19.22sdv
      adantl ad2antll mpd exp32 r19.23adv cD cme wcel cA cJ wcel cP cA wcel w3a
      cD cme wcel cP cD cdm cdm wcel cD cme wcel cA cJ wcel cP cA wcel 3simp1
      cD cme wcel cA cJ wcel cP cA wcel cP cD cdm cdm wcel cA cD cdm cdm wss cP
      cA wcel cP cD cdm cdm wcel cD cme wcel cA cJ wcel wa cA cD cdm cdm cP
      ssel2 cA cD cJ cD cdm cdm cD cdm cdm eqid opni.1 opnss sylan 3impa jca
      sylan mpd $.
      $( [14-Nov-2007] $) $( [20-Sep-2007] $)

    $( The balls of a metric space are open sets. $)
    blssopn $p |- ( D e. Met -> ran ( ball ` D ) C_ J ) $=
      cD cme wcel vw cD cbl cfv crn cJ cD cme wcel vw cv cD cbl cfv crn wcel vw
      cv cD cdm cdm wss vv cv vu cv wcel vu cv vw cv wss wa vu cD cbl cfv crn
      wrex vv vw cv wral wa vw cv cJ wcel cD cme wcel vw cv cD cbl cfv crn wcel
      vw cv cD cdm cdm wss vv cv vu cv wcel vu cv vw cv wss wa vu cD cbl cfv
      crn wrex vv vw cv wral wa cD cme wcel vw cv cD cbl cfv crn wcel wa vw cv
      cD cdm cdm wss vv cv vu cv wcel vu cv vw cv wss wa vu cD cbl cfv crn wrex
      vv vw cv wral vw cv cD cD cdm cdm cD cdm cdm eqid rnblssm vw cv cD cbl
      cfv crn wcel vv cv vu cv wcel vu cv vw cv wss wa vu cD cbl cfv crn wrex
      vv vw cv wral cD cme wcel vw cv cD cbl cfv crn wcel vv cv vu cv wcel vu
      cv vw cv wss wa vu cD cbl cfv crn wrex vv vw cv vw cv cD cbl cfv crn wcel
      vv cv vw cv wcel vw cv vw cv wss vv cv vu cv wcel vu cv vw cv wss wa vu
      cD cbl cfv crn wrex vw cv ssid vv cv vu cv wcel vu cv vw cv wss wa vv cv
      vw cv wcel vw cv vw cv wss wa vu vw cv cD cbl cfv crn vu cv vw cv wceq vv
      cv vu cv wcel vv cv vw cv wcel vu cv vw cv wss vw cv vw cv wss vu vw vv
      elequ2 vu cv vw cv vw cv sseq1 anbi12d rcla4ev mpanr2 r19.21aiva adantl
      jca ex vv vu vw cv cD cJ cD cdm cdm cD cdm cdm eqid opni.1 isopn sylibrd
      ssrdv $.
      $( [13-Nov-2007] $) $( [12-Sep-2006] $)

    $( The union of a collection of open sets of a metric space is open.
       Theorem T2 of [Kreyszig] p. 19. $)
    opnuni $p |- ( ( D e. Met /\ A C_ J ) ->
                 U. A e. J ) $=
      cD cme wcel cA cJ wss cA cuni cJ wcel cD cme wcel cA cJ wss cA cuni cD
      cdm cdm wss vw cv vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn wrex
      vw cA cuni wral wa cA cuni cJ wcel cD cme wcel cA cJ wss cA cuni cD cdm
      cdm wss vw cv vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn wrex vw
      cA cuni wral cD cme wcel cA cJ wss cA cD cdm cdm cpw wss cA cuni cD cdm
      cdm wss cA cJ wss cJ cD cdm cdm cpw wss cA cD cdm cdm cpw wss cD cme wcel
      cA cJ cD cdm cdm cpw sstr2 cD cJ cD cdm cdm cD cdm cdm eqid opni.1 opnfss
      syl5com cA cD cdm cdm cpw wss cA cuni cD cdm cdm cpw cuni cD cdm cdm cA
      cD cdm cdm cpw uniss cD cdm cdm unipw syl6ss syl6 cD cme wcel cA cJ wss
      vw cv vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn wrex vw cA cuni
      cD cme wcel cA cJ wss vw cv cA cuni wcel vw cv vv cv wcel vv cv cA cuni
      wss wa vv cD cbl cfv crn wrex wi cD cme wcel cA cJ wss wa vw cv vu cv
      wcel vu cA wrex vw cv vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn
      wrex vw cv cA cuni wcel cD cme wcel cA cJ wss wa vw cv vu cv wcel vw cv
      vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn wrex vu cA cD cme wcel
      cA cJ wss wa vu cv cA wcel vw cv vu cv wcel vw cv vv cv wcel vv cv cA
      cuni wss wa vv cD cbl cfv crn wrex cD cme wcel cA cJ wss wa vu cv cA wcel
      vw cv vu cv wcel wa wa vw cv vv cv wcel vv cv vu cv wss wa vv cD cbl cfv
      crn wrex vw cv vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn wrex cD
      cme wcel vu cv cJ wcel vw cv vu cv wcel vw cv vv cv wcel vv cv vu cv wss
      wa vv cD cbl cfv crn wrex cD cme wcel cA cJ wss wa vu cv cA wcel vw cv vu
      cv wcel wa wa vv vu cv cD vw cv cJ opni.1 opni cD cme wcel cA cJ wss vu
      cv cA wcel vw cv vu cv wcel wa simpll cA cJ wss vu cv cA wcel vu cv cJ
      wcel cD cme wcel vw cv vu cv wcel cA cJ vu cv ssel2 ad2ant2lr cD cme wcel
      cA cJ wss wa vu cv cA wcel vw cv vu cv wcel simprr syl3anc vu cv cA wcel
      vw cv vv cv wcel vv cv vu cv wss wa vv cD cbl cfv crn wrex vw cv vv cv
      wcel vv cv cA cuni wss wa vv cD cbl cfv crn wrex wi cD cme wcel cA cJ wss
      wa vw cv vu cv wcel vu cv cA wcel vw cv vv cv wcel vv cv vu cv wss wa vw
      cv vv cv wcel vv cv cA cuni wss wa vv cD cbl cfv crn vu cv cA wcel vv cv
      vu cv wss vv cv cA cuni wss vw cv vv cv wcel vv cv vu cv wss vu cv cA
      wcel vv cv cA cuni wss vv cv vu cv cA ssuni expcom anim2d r19.22sdv
      ad2antrl mpd exp32 r19.23adv vu vw cv cA eluni2 syl5ib ex r19.21adv jcad
      vw vv cA cuni cD cJ cD cdm cdm cD cdm cdm eqid opni.1 isopn sylibrd imp
      $.
      $( [12-Nov-2007] $) $( [4-Sep-2006] $)

    $( The intersection of two open sets of a metric space is open. $)
    opnin $p |- ( ( D e. Met /\ A e. J /\ B e. J ) ->
               ( A i^i B ) e. J ) $=
      cD cme wcel cA cJ wcel cB cJ wcel cA cB cin cJ wcel cD cme wcel cA cD cdm
      cdm wss vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA
      wral wa cB cD cdm cdm wss vw cv vu cv wcel vu cv cB wss wa vu cD cbl cfv
      crn wrex vw cB wral wa wa cA cB cin cD cdm cdm wss vx cv vy cv wcel vy cv
      cA cB cin wss wa vy cD cbl cfv crn wrex vx cA cB cin wral wa cA cJ wcel
      cB cJ wcel wa cA cB cin cJ wcel cA cD cdm cdm wss vz cv vv cv wcel vv cv
      cA wss wa vv cD cbl cfv crn wrex vz cA wral wa cB cD cdm cdm wss vw cv vu
      cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral wa wa cD cme
      wcel cA cB cin cD cdm cdm wss vx cv vy cv wcel vy cv cA cB cin wss wa vy
      cD cbl cfv crn wrex vx cA cB cin wral wa cA cD cdm cdm wss cB cD cdm cdm
      wss vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral vw
      cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral cD cme
      wcel cA cB cin cD cdm cdm wss vx cv vy cv wcel vy cv cA cB cin wss wa vy
      cD cbl cfv crn wrex vx cA cB cin wral wa wi cA cB cin cD cdm cdm wss vz
      cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral vw cv vu
      cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral wa cD cme wcel
      cA cB cin cD cdm cdm wss vx cv vy cv wcel vy cv cA cB cin wss wa vy cD
      cbl cfv crn wrex vx cA cB cin wral wa wi cA cD cdm cdm wss cB cD cdm cdm
      wss wa cA cB cin cD cdm cdm wss vz cv vv cv wcel vv cv cA wss wa vv cD
      cbl cfv crn wrex vz cA wral vw cv vu cv wcel vu cv cB wss wa vu cD cbl
      cfv crn wrex vw cB wral wa cD cme wcel cA cB cin cD cdm cdm wss vx cv vy
      cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex vx cA cB cin wral
      wa wi vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral
      vw cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral wa cD
      cme wcel cA cB cin cD cdm cdm wss cA cB cin cD cdm cdm wss vx cv vy cv
      wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex vx cA cB cin wral wa
      vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral vw cv
      vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral wa cD cme
      wcel cA cB cin cD cdm cdm wss cA cB cin cD cdm cdm wss vx cv vy cv wcel
      vy cv cA cB cin wss wa vy cD cbl cfv crn wrex vx cA cB cin wral wa vz cv
      vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral vw cv vu cv
      wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral wa cD cme wcel cA
      cB cin cD cdm cdm wss wa cA cB cin cD cdm cdm wss vx cv vy cv wcel vy cv
      cA cB cin wss wa vy cD cbl cfv crn wrex vx cA cB cin wral cD cme wcel cA
      cB cin cD cdm cdm wss wa cA cB cin cD cdm cdm wss wi vz cv vv cv wcel vv
      cv cA wss wa vv cD cbl cfv crn wrex vz cA wral vw cv vu cv wcel vu cv cB
      wss wa vu cD cbl cfv crn wrex vw cB wral wa cD cme wcel cA cB cin cD cdm
      cdm wss pm3.27 a1i vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn
      wrex vz cA wral vw cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex
      vw cB wral wa cD cme wcel cA cB cin cD cdm cdm wss wa vx cv vy cv wcel vy
      cv cA cB cin wss wa vy cD cbl cfv crn wrex vx cA cB cin vx cv cA cB cin
      wcel cD cme wcel cA cB cin cD cdm cdm wss wa vz cv vv cv wcel vv cv cA
      wss wa vv cD cbl cfv crn wrex vz cA wral vw cv vu cv wcel vu cv cB wss wa
      vu cD cbl cfv crn wrex vw cB wral wa vx cv vy cv wcel vy cv cA cB cin wss
      wa vy cD cbl cfv crn wrex vx cv cA cB cin wcel cD cme wcel vx cv cD cdm
      cdm wcel vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA
      wral vw cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral
      wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi cA
      cB cin cD cdm cdm wss vx cv cA cB cin wcel vz cv vv cv wcel vv cv cA wss
      wa vv cD cbl cfv crn wrex vz cA wral vw cv vu cv wcel vu cv cB wss wa vu
      cD cbl cfv crn wrex vw cB wral wa cD cme wcel vx cv cD cdm cdm wcel wa vx
      cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex vx cv cA cB
      cin wcel vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA
      wral vw cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral
      wa cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin
      wss wa vy cD cbl cfv crn wrex wi vx cv cA wcel vx cv cB wcel wa vz cv vv
      cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral vw cv vu cv
      wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral wa cD cme wcel vx
      cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl
      cfv crn wrex wi vx cv cA cB cin wcel vx cv cA wcel vz cv vv cv wcel vv cv
      cA wss wa vv cD cbl cfv crn wrex vz cA wral vx cv cB wcel vw cv vu cv
      wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw cB wral cD cme wcel vx cv
      cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv
      crn wrex wi vx cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vx cv
      vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex cD cme wcel vx cv cD
      cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn
      wrex wi vx cv cA wcel vz cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn
      wrex vz cA wral wa vx cv cB wcel vw cv vu cv wcel vu cv cB wss wa vu cD
      cbl cfv crn wrex vw cB wral wa vx cv vv cv wcel vv cv cA wss wa vv cD cbl
      cfv crn wrex vx cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex wa
      vx cv vv cv wcel vv cv cA wss wa vx cv vu cv wcel vu cv cB wss wa wa vu
      cD cbl cfv crn wrex vv cD cbl cfv crn wrex cD cme wcel vx cv cD cdm cdm
      wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi
      vx cv vv cv wcel vv cv cA wss wa vx cv vu cv wcel vu cv cB wss wa vv vu
      cD cbl cfv crn cD cbl cfv crn reeanv vx cv vv cv wcel vv cv cA wss wa vx
      cv vu cv wcel vu cv cB wss wa wa cD cme wcel vx cv cD cdm cdm wcel wa vx
      cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi vv vu cD
      cbl cfv crn cD cbl cfv crn vv cv cD cbl cfv crn wcel vu cv cD cbl cfv crn
      wcel wa vx cv vv cv wcel vv cv cA wss wa vx cv vu cv wcel vu cv cB wss wa
      wa cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin
      wss wa vy cD cbl cfv crn wrex wi vv cv cD cbl cfv crn wcel vx cv vv cv
      wcel vv cv cA wss wa vu cv cD cbl cfv crn wcel vx cv vu cv wcel vu cv cB
      wss wa cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB
      cin wss wa vy cD cbl cfv crn wrex wi vv cv cD cbl cfv crn wcel vx cv vv
      cv wcel wa vv cv cA wss wa vu cv cD cbl cfv crn wcel vx cv vu cv wcel wa
      vu cv cB wss wa cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy
      cv cA cB cin wss wa vy cD cbl cfv crn wrex wi vv cv cD cbl cfv crn wcel
      vx cv vv cv wcel vv cv cA wss wa wa vu cv cD cbl cfv crn wcel vx cv vu cv
      wcel vu cv cB wss wa wa vv cv cD cbl cfv crn wcel vx cv vv cv wcel wa vu
      cv cD cbl cfv crn wcel vx cv vu cv wcel wa vv cv cA wss vu cv cB wss cD
      cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa
      vy cD cbl cfv crn wrex wi vv cv cD cbl cfv crn wcel vx cv vv cv wcel wa
      vu cv cD cbl cfv crn wcel vx cv vu cv wcel wa wa vv cv cA wss vu cv cB
      wss wa cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB
      cin wss wa vy cD cbl cfv crn wrex wi cD cme wcel vx cv cD cdm cdm wcel wa
      vv cv cD cbl cfv crn wcel vx cv vv cv wcel wa vu cv cD cbl cfv crn wcel
      vx cv vu cv wcel wa wa vv cv cA wss vu cv cB wss wa vx cv vy cv wcel vy
      cv cA cB cin wss wa vy cD cbl cfv crn wrex cD cme wcel vx cv cD cdm cdm
      wcel wa vv cv cD cbl cfv crn wcel vx cv vv cv wcel wa vu cv cD cbl cfv
      crn wcel vx cv vu cv wcel wa wa cc0 vf cv clt wbr vx cv vf cv cD cbl cfv
      co vv cv wss wa vf cr wrex cc0 vg cv clt wbr vx cv vg cv cD cbl cfv co vu
      cv wss wa vg cr wrex wa vv cv cA wss vu cv cB wss wa vx cv vy cv wcel vy
      cv cA cB cin wss wa vy cD cbl cfv crn wrex wi cD cme wcel vv cv cD cbl
      cfv crn wcel vx cv vv cv wcel wa vu cv cD cbl cfv crn wcel vx cv vu cv
      wcel wa wa cc0 vf cv clt wbr vx cv vf cv cD cbl cfv co vv cv wss wa vf cr
      wrex cc0 vg cv clt wbr vx cv vg cv cD cbl cfv co vu cv wss wa vg cr wrex
      wa wi vx cv cD cdm cdm wcel cD cme wcel vv cv cD cbl cfv crn wcel vx cv
      vv cv wcel wa cc0 vf cv clt wbr vx cv vf cv cD cbl cfv co vv cv wss wa vf
      cr wrex vu cv cD cbl cfv crn wcel vx cv vu cv wcel wa cc0 vg cv clt wbr
      vx cv vg cv cD cbl cfv co vu cv wss wa vg cr wrex cD cme wcel vv cv cD
      cbl cfv crn wcel vx cv vv cv wcel cc0 vf cv clt wbr vx cv vf cv cD cbl
      cfv co vv cv wss wa vf cr wrex vf vv cv cD vx cv blss 3expib cD cme wcel
      vu cv cD cbl cfv crn wcel vx cv vu cv wcel cc0 vg cv clt wbr vx cv vg cv
      cD cbl cfv co vu cv wss wa vg cr wrex vg vu cv cD vx cv blss 3expib
      anim12d adantr cD cme wcel vx cv cD cdm cdm wcel wa cc0 vf cv clt wbr vx
      cv vf cv cD cbl cfv co vv cv wss wa cc0 vg cv clt wbr vx cv vg cv cD cbl
      cfv co vu cv wss wa wa vg cr wrex vf cr wrex vv cv cA wss vu cv cB wss wa
      vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi cc0 vf
      cv clt wbr vx cv vf cv cD cbl cfv co vv cv wss wa vf cr wrex cc0 vg cv
      clt wbr vx cv vg cv cD cbl cfv co vu cv wss wa vg cr wrex wa cD cme wcel
      vx cv cD cdm cdm wcel wa cc0 vf cv clt wbr vx cv vf cv cD cbl cfv co vv
      cv wss wa cc0 vg cv clt wbr vx cv vg cv cD cbl cfv co vu cv wss wa wa vv
      cv cA wss vu cv cB wss wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD
      cbl cfv crn wrex wi vf vg cr cr cc0 vf cv clt wbr vx cv vf cv cD cbl cfv
      co vv cv wss wa cc0 vg cv clt wbr vx cv vg cv cD cbl cfv co vu cv wss wa
      wa vv cv cA wss vu cv cB wss wa cD cme wcel vx cv cD cdm cdm wcel wa vf
      cv cr wcel vg cv cr wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD
      cbl cfv crn wrex cc0 vf cv clt wbr cc0 vg cv clt wbr vx cv vf cv cD cbl
      cfv co vv cv wss vx cv vg cv cD cbl cfv co vu cv wss vv cv cA wss vu cv
      cB wss wa cD cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel vg cv cr
      wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi
      wi wi cc0 vf cv clt wbr cc0 vg cv clt wbr wa vx cv vf cv cD cbl cfv co vv
      cv wss vx cv vg cv cD cbl cfv co vu cv wss wa vv cv cA wss vu cv cB wss
      wa cD cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel vg cv cr wcel wa vx
      cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi wi cc0 vf
      cv clt wbr cc0 vg cv clt wbr wa vx cv vf cv cD cbl cfv co vx cv vg cv cD
      cbl cfv co cin cA cB cin wss cD cme wcel vx cv cD cdm cdm wcel wa vf cv
      cr wcel vg cv cr wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD
      cbl cfv crn wrex wi wi vx cv vf cv cD cbl cfv co vv cv wss vx cv vg cv cD
      cbl cfv co vu cv wss wa vv cv cA wss vu cv cB wss wa wa vf cv cr wcel vg
      cv cr wcel wa cc0 vf cv clt wbr cc0 vg cv clt wbr wa vx cv vf cv cD cbl
      cfv co vx cv vg cv cD cbl cfv co cin cA cB cin wss cD cme wcel vx cv cD
      cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn
      wrex vf cv cr wcel vg cv cr wcel wa cc0 vf cv clt wbr cc0 vg cv clt wbr
      wa vx cv vf cv cD cbl cfv co vx cv vg cv cD cbl cfv co cin cA cB cin wss
      cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv wcel vy cv cA cB cin wss
      wa vy cD cbl cfv crn wrex wi wi vf cv cr wcel cc0 vf cv clt wbr vg cv cr
      wcel cc0 vg cv clt wbr vx cv vf cv cD cbl cfv co vx cv vg cv cD cbl cfv
      co cin cA cB cin wss cD cme wcel vx cv cD cdm cdm wcel wa vx cv vy cv
      wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex wi wi cD cme wcel vx
      cv cD cdm cdm wcel wa vf cv cr wcel cc0 vf cv clt wbr wa vg cv cr wcel
      cc0 vg cv clt wbr wa wa vx cv vf cv cD cbl cfv co vx cv vg cv cD cbl cfv
      co cin cA cB cin wss vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl
      cfv crn wrex cD cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel cc0 vf cv
      clt wbr wa vg cv cr wcel cc0 vg cv clt wbr wa wa vx cv vf cv cD cbl cfv
      co vx cv vg cv cD cbl cfv co cin cA cB cin wss vx cv vy cv wcel vy cv cA
      cB cin wss wa vy cD cbl cfv crn wrex wi cD cme wcel vx cv cD cdm cdm wcel
      wa vf cv cr wcel cc0 vf cv clt wbr wa vg cv cr wcel cc0 vg cv clt wbr wa
      wa wa vx cv vf cv cD cbl cfv co vx cv vg cv cD cbl cfv co cin cA cB cin
      wss vx cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl cfv co cA cB cin wss
      vx cv vy cv wcel vy cv cA cB cin wss wa vy cD cbl cfv crn wrex cD cme
      wcel vx cv cD cdm cdm wcel wa vf cv cr wcel cc0 vf cv clt wbr wa vg cv cr
      wcel cc0 vg cv clt wbr wa wa wa vx cv vf cv cD cbl cfv co vx cv vg cv cD
      cbl cfv co cin vx cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl cfv co cA
      cB cin cD cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel cc0 vf cv clt
      wbr wa vg cv cr wcel cc0 vg cv clt wbr wa vx cv vf cv cD cbl cfv co vx cv
      vg cv cD cbl cfv co cin vx cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl
      cfv co wceq cD vx cv vf cv vg cv cD cdm cdm cD cdm cdm eqid blin 3expb
      sseq1d cD cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel cc0 vf cv clt
      wbr wa vg cv cr wcel cc0 vg cv clt wbr wa wa wa vx cv vf cv vg cv cle wbr
      vf cv vg cv cif cD cbl cfv co cA cB cin wss vx cv vy cv wcel vy cv cA cB
      cin wss wa vy cD cbl cfv crn wrex vx cv vf cv vg cv cle wbr vf cv vg cv
      cif cD cbl cfv co cD cbl cfv crn wcel vx cv vx cv vf cv vg cv cle wbr vf
      cv vg cv cif cD cbl cfv co wcel vx cv vf cv vg cv cle wbr vf cv vg cv cif
      cD cbl cfv co cA cB cin wss wa vx cv vy cv wcel vy cv cA cB cin wss wa vy
      cD cbl cfv crn wrex cD cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel
      cc0 vf cv clt wbr wa vg cv cr wcel cc0 vg cv clt wbr wa wa wa vx cv vf cv
      vg cv cle wbr vf cv vg cv cif cD cbl cfv co cA cB cin wss wa vx cv vy cv
      wcel vy cv cA cB cin wss wa vx cv vx cv vf cv vg cv cle wbr vf cv vg cv
      cif cD cbl cfv co wcel vx cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl
      cfv co cA cB cin wss wa vy vx cv vf cv vg cv cle wbr vf cv vg cv cif cD
      cbl cfv co cD cbl cfv crn vy cv vx cv vf cv vg cv cle wbr vf cv vg cv cif
      cD cbl cfv co wceq vx cv vy cv wcel vx cv vx cv vf cv vg cv cle wbr vf cv
      vg cv cif cD cbl cfv co wcel vy cv cA cB cin wss vx cv vf cv vg cv cle
      wbr vf cv vg cv cif cD cbl cfv co cA cB cin wss vy cv vx cv vf cv vg cv
      cle wbr vf cv vg cv cif cD cbl cfv co vx cv eleq2 vy cv vx cv vf cv vg cv
      cle wbr vf cv vg cv cif cD cbl cfv co cA cB cin sseq1 anbi12d rcla4ev cD
      cme wcel vx cv cD cdm cdm wcel wa vf cv cr wcel cc0 vf cv clt wbr wa vg
      cv cr wcel cc0 vg cv clt wbr wa wa wa vx cv vf cv vg cv cle wbr vf cv vg
      cv cif cD cbl cfv co cD cbl cfv crn wcel vx cv vf cv vg cv cle wbr vf cv
      vg cv cif cD cbl cfv co cA cB cin wss cD cme wcel vx cv cD cdm cdm wcel
      wa vf cv vg cv cle wbr vf cv vg cv cif cr wcel cc0 vf cv vg cv cle wbr vf
      cv vg cv cif clt wbr wa vx cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl
      cfv co cD cbl cfv crn wcel vf cv cr wcel cc0 vf cv clt wbr wa vg cv cr
      wcel cc0 vg cv clt wbr wa wa cD vx cv vf cv vg cv cle wbr vf cv vg cv cif
      cD cdm cdm cD cdm cdm eqid blelrn vf cv vg cv cle wbr vf cv cr wcel cc0
      vf cv clt wbr wa vg cv cr wcel cc0 vg cv clt wbr wa vf cv vg cv cle wbr
      vf cv vg cv cif cr wcel cc0 vf cv vg cv cle wbr vf cv vg cv cif clt wbr
      wa vf cv vg cv vf cv vf cv vg cv cle wbr vf cv vg cv cif wceq vf cv cr
      wcel vf cv vg cv cle wbr vf cv vg cv cif cr wcel cc0 vf cv clt wbr cc0 vf
      cv vg cv cle wbr vf cv vg cv cif clt wbr vf cv vf cv vg cv cle wbr vf cv
      vg cv cif cr eleq1 vf cv vf cv vg cv cle wbr vf cv vg cv cif cc0 clt
      breq2 anbi12d vg cv vf cv vg cv cle wbr vf cv vg cv cif wceq vg cv cr
      wcel vf cv vg cv cle wbr vf cv vg cv cif cr wcel cc0 vg cv clt wbr cc0 vf
      cv vg cv cle wbr vf cv vg cv cif clt wbr vg cv vf cv vg cv cle wbr vf cv
      vg cv cif cr eleq1 vg cv vf cv vg cv cle wbr vf cv vg cv cif cc0 clt
      breq2 anbi12d ifboth sylan2 adantr cD cme wcel vx cv cD cdm cdm wcel wa
      vf cv cr wcel cc0 vf cv clt wbr wa vg cv cr wcel cc0 vg cv clt wbr wa wa
      wa vx cv vx cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl cfv co wcel vx
      cv vf cv vg cv cle wbr vf cv vg cv cif cD cbl cfv co cA cB cin wss cD cme
      wcel vx cv cD cdm cdm wcel wa vf cv vg cv cle wbr vf cv vg cv cif cr wcel
      cc0 vf cv vg cv cle wbr vf cv vg cv cif clt wbr wa vx cv vx cv vf cv vg
      cv cle wbr vf cv vg cv cif cD cbl cfv co wcel vf cv cr wcel cc0 vf cv clt
      wbr wa vg cv cr wcel cc0 vg cv clt wbr wa wa cD vx cv vf cv vg cv cle wbr
      vf cv vg cv cif cD cdm cdm cD cdm cdm eqid blcntr vf cv vg cv cle wbr vf
      cv cr wcel cc0 vf cv clt wbr wa vg cv cr wcel cc0 vg cv clt wbr wa vf cv
      vg cv cle wbr vf cv vg cv cif cr wcel cc0 vf cv vg cv cle wbr vf cv vg cv
      cif clt wbr wa vf cv vg cv vf cv vf cv vg cv cle wbr vf cv vg cv cif wceq
      vf cv cr wcel vf cv vg cv cle wbr vf cv vg cv cif cr wcel cc0 vf cv clt
      wbr cc0 vf cv vg cv cle wbr vf cv vg cv cif clt wbr vf cv vf cv vg cv cle
      wbr vf cv vg cv cif cr eleq1 vf cv vf cv vg cv cle wbr vf cv vg cv cif
      cc0 clt breq2 anbi12d vg cv vf cv vg cv cle wbr vf cv vg cv cif wceq vg
      cv cr wcel vf cv vg cv cle wbr vf cv vg cv cif cr wcel cc0 vg cv clt wbr
      cc0 vf cv vg cv cle wbr vf cv vg cv cif clt wbr vg cv vf cv vg cv cle wbr
      vf cv vg cv cif cr eleq1 vg cv vf cv vg cv cle wbr vf cv vg cv cif cc0
      clt breq2 anbi12d ifboth sylan2 anim1i sylanc ex sylbid ex com3l an4s ex
      com4l vx cv vf cv cD cbl cfv co vv cv wss vv cv cA wss vx cv vg cv cD cbl
      cfv co vu cv wss vu cv cB wss vx cv vf cv cD cbl cfv co vx cv vg cv cD
      cbl cfv co cin cA cB cin wss vx cv vf cv cD cbl cfv co cA wss vx cv vg cv
      cD cbl cfv co cB wss vx cv vf cv cD cbl cfv co vx cv vg cv cD cbl cfv co
      cin cA cB cin wss vx cv vf cv cD cbl cfv co vv cv wss vv cv cA wss wa vx
      cv vg cv cD cbl cfv co vu cv wss vu cv cB wss wa vx cv vf cv cD cbl cfv
      co cA vx cv vg cv cD cbl cfv co cB ss2in vx cv vf cv cD cbl cfv co vv cv
      cA sstr vx cv vg cv cD cbl cfv co vu cv cB sstr syl2an an4s syl5 expdimp
      an4s com4t r19.23advv cc0 vf cv clt wbr vx cv vf cv cD cbl cfv co vv cv
      wss wa cc0 vg cv clt wbr vx cv vg cv cD cbl cfv co vu cv wss wa vf vg cr
      cr reeanv syl5ibr syld com3l imp an4s vv cv cD cbl cfv crn wcel vx cv vv
      cv wcel vv cv cA wss anass vu cv cD cbl cfv crn wcel vx cv vu cv wcel vu
      cv cB wss anass syl2anbr an4s ex r19.23aivv sylbir vz cv vv cv wcel vv cv
      cA wss wa vv cD cbl cfv crn wrex vx cv vv cv wcel vv cv cA wss wa vv cD
      cbl cfv crn wrex vz vx cv cA vz cv vx cv wceq vz cv vv cv wcel vv cv cA
      wss wa vx cv vv cv wcel vv cv cA wss wa vv cD cbl cfv crn vz cv vx cv
      wceq vz cv vv cv wcel vx cv vv cv wcel vv cv cA wss vz cv vx cv vv cv
      eleq1 anbi1d rexbidv rcla4va vw cv vu cv wcel vu cv cB wss wa vu cD cbl
      cfv crn wrex vx cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex vw
      vx cv cB vw cv vx cv wceq vw cv vu cv wcel vu cv cB wss wa vx cv vu cv
      wcel vu cv cB wss wa vu cD cbl cfv crn vw cv vx cv wceq vw cv vu cv wcel
      vx cv vu cv wcel vu cv cB wss vw cv vx cv vu cv eleq1 anbi1d rexbidv
      rcla4va syl2an an4s vx cv cA cB elin sylanb ex com23 cA cB cin cD cdm cdm
      wss vx cv cA cB cin wcel vx cv cD cdm cdm wcel cA cB cin cD cdm cdm vx cv
      ssel com12 sylan2d com13 r19.21adv jcad exp3a com3r imp cA cD cdm cdm wss
      cA cB cin cD cdm cdm wss cB cD cdm cdm wss cA cB cD cdm cdm ssinss1
      adantr sylan an4s com12 cD cme wcel cA cJ wcel cA cD cdm cdm wss vz cv vv
      cv wcel vv cv cA wss wa vv cD cbl cfv crn wrex vz cA wral wa cB cJ wcel
      cB cD cdm cdm wss vw cv vu cv wcel vu cv cB wss wa vu cD cbl cfv crn wrex
      vw cB wral wa vz vv cA cD cJ cD cdm cdm cD cdm cdm eqid opni.1 isopn vw
      vu cB cD cJ cD cdm cdm cD cdm cdm eqid opni.1 isopn anbi12d vx vy cA cB
      cin cD cJ cD cdm cdm cD cdm cdm eqid opni.1 isopn 3imtr4d 3impib $.
      $( [13-Nov-2007] $) $( [4-Sep-2006] $)

    $( The set of open sets of a metric space is a topology.  Remark in
       [Kreyszig] p. 19.  This theorem connects the two concepts and makes
       available the theorems for topologies for use with metric spaces. $)
    opntop $p |- ( D e. Met -> J e. Top ) $=
      cJ ctop wcel vw cv cJ wss vw cv cuni cJ wcel wi vw wal vw cv vv cv cin cJ
      wcel vv cJ wral vw cJ wral cD cme wcel cJ cvv wcel cJ ctop wcel vw cv cJ
      wss vw cv cuni cJ wcel wi vw wal vw cv vv cv cin cJ wcel vv cJ wral vw cJ
      wral wa wb cJ cD copn cfv cvv opni.1 cD copn fvex eqeltri vw vv cvv cJ
      istopg ax-mp cD cme wcel vw cv cJ wss vw cv cuni cJ wcel wi vw cD cme
      wcel vw cv cJ wss vw cv cuni cJ wcel vw cv cD cJ opni.1 opnuni ex
      19.21aiv cD cme wcel vw cv vv cv cin cJ wcel vw vv cJ cJ cD cme wcel vw
      cv cJ wcel vv cv cJ wcel vw cv vv cv cin cJ wcel vw cv vv cv cD cJ opni.1
      opnin 3expib r19.21aivv sylanbrc $.
      $( [13-Nov-2007] $) $( [28-Aug-2006] $)

    $( The topology generated by the balls of a metric space is its open
       sets. $)
    tgbl $p |- ( D e. Met -> ( topGen ` ran ( ball ` D ) ) = J ) $=
      cJ ctop wcel cD cbl cfv crn cJ wss vv cv vu cv wcel vu cv vw cv wss wa vu
      cD cbl cfv crn wrex vv vw cv wral vw cJ wral cD cbl cfv crn ctg cfv cJ
      wceq cD cme wcel cJ ctop wcel cD cbl cfv crn cJ wss vv cv vu cv wcel vu
      cv vw cv wss wa vu cD cbl cfv crn wrex vv vw cv wral vw cJ wral w3a cD
      cbl cfv crn ctb wcel cD cbl cfv crn ctg cfv cJ wceq vw vv vu cD cbl cfv
      crn cJ basgen2 pm3.27d cD cJ opni.1 opntop cD cJ opni.1 blssopn cD cme
      wcel vv cv vu cv wcel vu cv vw cv wss wa vu cD cbl cfv crn wrex vw vv cJ
      vw cv cD cme wcel vw cv cJ wcel vv cv vw cv wcel vv cv vu cv wcel vu cv
      vw cv wss wa vu cD cbl cfv crn wrex vu vw cv cD vv cv cJ opni.1 opni
      3expib r19.21aivv syl3anc $.
      $( [3-Dec-2007] $) $( [13-Sep-2006] $)

    $( The balls of a metric space form a basis for a topology. $)
    blbas $p |- ( D e. Met -> ran ( ball ` D ) e. Bases ) $=
      cJ ctop wcel cD cbl cfv crn cJ wss vw cv vv cv wcel vv cv vu cv wss wa vv
      cD cbl cfv crn wrex vw vu cv wral vu cJ wral cD cbl cfv crn ctb wcel cD
      cme wcel cJ ctop wcel cD cbl cfv crn cJ wss vw cv vv cv wcel vv cv vu cv
      wss wa vv cD cbl cfv crn wrex vw vu cv wral vu cJ wral w3a cD cbl cfv crn
      ctb wcel cD cbl cfv crn ctg cfv cJ wceq vu vw vv cD cbl cfv crn cJ
      basgen2 pm3.26d cD cJ opni.1 opntop cD cJ opni.1 blssopn cD cme wcel vw
      cv vv cv wcel vv cv vu cv wss wa vv cD cbl cfv crn wrex vu vw cJ vu cv cD
      cme wcel vu cv cJ wcel vw cv vu cv wcel vw cv vv cv wcel vv cv vu cv wss
      wa vv cD cbl cfv crn wrex vv vu cv cD vw cv cJ opni.1 opni 3expib
      r19.21aivv syl3anc $.
      $( [1-Dec-2007] $) $( [12-Sep-2006] $)
  $}

  ${
    opn0.1 $e |- J = ( Open ` D ) $.
    $( The empty set is an open set of a metric space.  Part of Theorem T1 of
       [Kreyszig] p. 19. $)
    opn0 $p |- ( D e. Met -> (/) e. J ) $=
      cD cme wcel cJ ctop wcel c0 cJ wcel cD cJ opn0.1 opntop cJ 0opn syl $.
      $( [21-Feb-2008] $) $( [4-Sep-2006] $)

    $( A ball of a metric space is an open set. $)
    rnblopn $p |- ( ( D e. Met /\ B e. ran ( ball ` D ) ) ->
                B e. J ) $=
      cD cme wcel cB cD cbl cfv crn wcel cB cJ wcel cD cme wcel cD cbl cfv crn
      cJ cB cD cJ opn0.1 blssopn sseld imp $.
      $( [13-Nov-2007] $) $( [12-Sep-2006] $)
  $}

  ${
    $d x y D $.  $d x y X $.
    unirnbl.1 $e |- X = dom dom D $.
    $( The union of the set of balls of a metric space is its base set. $)
    unirnbl $p |- ( D e. Met -> U. ran ( ball ` D ) = X ) $=
      cD cme wcel cD cbl cfv crn cuni cX cD cme wcel cD cbl cfv crn cuni cD
      copn cfv cuni cX cD cme wcel cD cbl cfv crn cD copn cfv wss cD cbl cfv
      crn cuni cD copn cfv cuni wss cD cD copn cfv cD copn cfv eqid blssopn cD
      cbl cfv crn cD copn cfv uniss syl cD cD copn cfv cX unirnbl.1 cD copn cfv
      eqid uniopn2 sseqtrd cD cme wcel vx cX cD cbl cfv crn cuni cD cme wcel vx
      cv cX wcel vx cv vy cv wcel vy cD cbl cfv crn wrex vx cv cD cbl cfv crn
      cuni wcel cD cme wcel vx cv cX wcel vx cv vy cv wcel vy cD cbl cfv crn
      wrex vy cD vx cv cX unirnbl.1 blex ex vy vx cv cD cbl cfv crn eluni2
      syl6ibr ssrdv eqssd $.
      $( [5-Apr-2008] $) $( [12-Sep-2006] $)
  $}

  ${
    $d r x y D $.  $d r x y J $.  $d r x y P $.  $d r y N $.  $d r x y R $.
    $d x y S $.  $d r x y X $.
    blopn.1 $e |- X = dom dom D $.
    blopn.2 $e |- J = ( Open ` D ) $.
    $( A ball of a metric space is an open set. $)
    blopn $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) ) ->
                    ( P ( ball ` D ) R ) e. J ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl
      cfv co cD cbl cfv crn wcel cP cR cD cbl cfv co cJ wcel cD cP cR cX
      blopn.1 blelrn cD cme wcel cP cR cD cbl cfv co cD cbl cfv crn wcel cP cR
      cD cbl cfv co cJ wcel wi cP cX wcel cR cr wcel cc0 cR clt wbr wa cD cme
      wcel cP cR cD cbl cfv co cD cbl cfv crn wcel cP cR cD cbl cfv co cJ wcel
      cP cR cD cbl cfv co cD cJ blopn.2 rnblopn ex ad2antrr mpd $.
      $( [14-Nov-2007] $) $( [9-Mar-2007] $)

    $( A neighborhood of a point defined in terms of balls. $)
    neibl $p |- ( ( D e. Met /\ P e. X ) -> ( N e. ( ( nei ` J ) ` { P } )
    <-> ( N C_ X /\ E. r e. RR ( 0 < r /\ ( P ( ball ` D ) r ) C_ N ) ) ) ) $=
      cD cme wcel cP cX wcel wa cN cP csn cJ cnei cfv cfv wcel cN cJ cuni wss
      cP vy cv wcel vy cv cN wss wa vy cJ wrex wa cN cX wss cP vy cv wcel vy cv
      cN wss wa vy cJ wrex wa cN cX wss cc0 vr cv clt wbr cP vr cv cD cbl cfv
      co cN wss wa vr cr wrex wa cJ ctop wcel cP cJ cuni wcel cN cP csn cJ cnei
      cfv cfv wcel cN cJ cuni wss cP vy cv wcel vy cv cN wss wa vy cJ wrex wa
      wb cD cme wcel cP cX wcel wa cP vy cJ cN cJ cuni cJ cuni eqid isneip cD
      cme wcel cJ ctop wcel cP cX wcel cD cJ blopn.2 opntop adantr cD cme wcel
      cP cJ cuni wcel cP cX wcel cD cme wcel cJ cuni cX cP cD cJ cX blopn.1
      blopn.2 uniopn2 eleq2d biimpar sylanc cD cme wcel cP cX wcel wa cN cJ
      cuni wss cN cX wss cP vy cv wcel vy cv cN wss wa vy cJ wrex cD cme wcel
      cN cJ cuni wss cN cX wss wb cP cX wcel cD cme wcel cJ cuni cX cN cD cJ cX
      blopn.1 blopn.2 uniopn2 sseq2d adantr anbi1d cD cme wcel cP cX wcel wa cN
      cX wss cP vy cv wcel vy cv cN wss wa vy cJ wrex cc0 vr cv clt wbr cP vr
      cv cD cbl cfv co cN wss wa vr cr wrex cD cme wcel cP cX wcel wa cN cX wss
      wa cP vy cv wcel vy cv cN wss wa vy cJ wrex cc0 vr cv clt wbr cP vr cv cD
      cbl cfv co cN wss wa vr cr wrex cD cme wcel cP cX wcel wa cN cX wss wa cP
      vy cv wcel vy cv cN wss wa cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN
      wss wa vr cr wrex vy cJ cD cme wcel vy cv cJ wcel cP vy cv wcel vy cv cN
      wss wa cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN wss wa vr cr wrex wi
      wi cP cX wcel cN cX wss cD cme wcel vy cv cJ wcel cP vy cv wcel vy cv cN
      wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN wss wa vr cr wrex cD cme
      wcel vy cv cJ wcel cP vy cv wcel vy cv cN wss cc0 vr cv clt wbr cP vr cv
      cD cbl cfv co cN wss wa vr cr wrex wi vy cv cN wss cc0 vr cv clt wbr cP
      vr cv cD cbl cfv co vy cv wss wa vr cr wrex cc0 vr cv clt wbr cP vr cv cD
      cbl cfv co cN wss wa vr cr wrex cD cme wcel vy cv cJ wcel cP vy cv wcel
      w3a vy cv cN wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co vy cv wss wa
      cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN wss wa vr cr vy cv cN wss cP
      vr cv cD cbl cfv co vy cv wss cP vr cv cD cbl cfv co cN wss cc0 vr cv clt
      wbr cP vr cv cD cbl cfv co vy cv wss vy cv cN wss cP vr cv cD cbl cfv co
      cN wss cP vr cv cD cbl cfv co vy cv cN sstr2 com12 anim2d r19.22sdv vr vy
      cv cD cP cJ blopn.2 opni2 syl5com 3exp imp4a ad2antrr r19.23adv cD cme
      wcel cP cX wcel wa cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN wss wa vr
      cr wrex cP vy cv wcel vy cv cN wss wa vy cJ wrex wi cN cX wss cD cme wcel
      cP cX wcel wa cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN wss wa cP vy cv
      wcel vy cv cN wss wa vy cJ wrex vr cr cD cme wcel cP cX wcel wa vr cv cr
      wcel cc0 vr cv clt wbr cP vr cv cD cbl cfv co cN wss cP vy cv wcel vy cv
      cN wss wa vy cJ wrex cD cme wcel cP cX wcel wa vr cv cr wcel cc0 vr cv
      clt wbr cP vr cv cD cbl cfv co cN wss cP vy cv wcel vy cv cN wss wa vy cJ
      wrex cP vr cv cD cbl cfv co cJ wcel cP cP vr cv cD cbl cfv co wcel cP vr
      cv cD cbl cfv co cN wss wa cP vy cv wcel vy cv cN wss wa vy cJ wrex cD
      cme wcel cP cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD
      cbl cfv co cN wss wa cP vy cv wcel vy cv cN wss wa cP cP vr cv cD cbl cfv
      co wcel cP vr cv cD cbl cfv co cN wss wa vy cP vr cv cD cbl cfv co cJ vy
      cv cP vr cv cD cbl cfv co wceq cP vy cv wcel cP cP vr cv cD cbl cfv co
      wcel vy cv cN wss cP vr cv cD cbl cfv co cN wss vy cv cP vr cv cD cbl cfv
      co cP eleq2 vy cv cP vr cv cD cbl cfv co cN sseq1 anbi12d rcla4ev cD cme
      wcel cP cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD cbl
      cfv co cJ wcel cP vr cv cD cbl cfv co cN wss cD cP vr cv cJ cX blopn.1
      blopn.2 blopn adantr cD cme wcel cP cX wcel wa vr cv cr wcel cc0 vr cv
      clt wbr wa wa cP cP vr cv cD cbl cfv co wcel cP vr cv cD cbl cfv co cN
      wss cD cP vr cv cX blopn.1 blcntr anim1i sylanc exp42 imp4a r19.23adv
      adantr impbid pm5.32da 3bitrd $.
      $( [7-Dec-2007] $) $( [8-Nov-2007] $)

    $( The neighborhoods around a point ` P ` of a metric space are those
       subsets containing a ball around ` P ` .  Definition of neighborhood in
       [Kreyszig] p. 19. $)
    metnei $p |- ( ( D e. Met /\ P e. X ) -> ( ( nei ` J ) ` { P } ) = { x |
         ( x C_ X /\ E. r e. RR ( 0 < r /\ ( P ( ball ` D ) r ) C_ x ) ) } ) $=
      cD cme wcel cP cX wcel wa vx cv cX wss cc0 vr cv clt wbr cP vr cv cD cbl
      cfv co vx cv wss wa vr cr wrex wa vx cP csn cJ cnei cfv cfv cD cP cJ vx
      cv cX vr blopn.1 blopn.2 neibl abbi2dv $.
      $( [23-Jun-2008] $) $( [8-Nov-2007] $)

    $( A ball around a point is a neighborhood of the point. $)
    blnei $p |- ( ( ( D e. Met /\ P e. X ) /\ ( R e. RR /\ 0 < R ) ) ->
              ( P ( ball ` D ) R ) e. ( ( nei ` J ) ` { P } ) ) $=
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl
      cfv co cP csn cJ cnei cfv cfv wcel cP cR cD cbl cfv co cX wss cc0 vr cv
      clt wbr cP vr cv cD cbl cfv co cP cR cD cbl cfv co wss wa vr cr wrex wa
      cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl
      cfv co cX wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co cP cR cD cbl cfv
      co wss wa vr cr wrex cD cP cR cX blopn.1 blssm cR cr wcel cc0 cR clt wbr
      wa cc0 vr cv clt wbr cP vr cv cD cbl cfv co cP cR cD cbl cfv co wss wa vr
      cr wrex cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr cP cR cD cbl
      cfv co cP cR cD cbl cfv co wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co
      cP cR cD cbl cfv co wss wa vr cr wrex cP cR cD cbl cfv co ssid cc0 vr cv
      clt wbr cP vr cv cD cbl cfv co cP cR cD cbl cfv co wss wa cc0 cR clt wbr
      cP cR cD cbl cfv co cP cR cD cbl cfv co wss wa vr cR cr vr cv cR wceq cc0
      vr cv clt wbr cc0 cR clt wbr cP vr cv cD cbl cfv co cP cR cD cbl cfv co
      wss cP cR cD cbl cfv co cP cR cD cbl cfv co wss vr cv cR cc0 clt breq2 vr
      cv cR wceq cP vr cv cD cbl cfv co cP cR cD cbl cfv co cP cR cD cbl cfv co
      vr cv cR cP cD cbl cfv opreq2 sseq1d anbi12d rcla4ev mpanr2 adantl jca cD
      cme wcel cP cX wcel wa cP cR cD cbl cfv co cP csn cJ cnei cfv cfv wcel cP
      cR cD cbl cfv co cX wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co cP cR cD
      cbl cfv co wss wa vr cr wrex wa wb cR cr wcel cc0 cR clt wbr wa cD cP cJ
      cP cR cD cbl cfv co cX vr blopn.1 blopn.2 neibl adantr mpbird $.
      $( [19-Dec-2007] $) $( [8-Nov-2007] $)

    $( Every ball around a limit point ` P ` of a subset ` S ` includes a
       member of ` S ` (even if ` P e/ S ` ). $)
    lpbl $p |- ( ( ( D e. Met /\ S C_ X /\ P e. ( ( limPt ` J ) ` S ) ) /\
           ( R e. RR /\ 0 < R ) ) -> E. x e. S x e. ( P ( ball ` D ) R ) ) $=
      cD cme wcel cS cJ cuni wss wa cP cS cJ clp cfv cfv wcel wa cR cr wcel cc0
      cR clt wbr wa vx cv cP cR cD cbl cfv co wcel vx cS wrex cD cme wcel cS cX
      wss cP cS cJ clp cfv cfv wcel w3a cD cme wcel cS cJ cuni wss wa cP cS cJ
      clp cfv cfv wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD cbl cfv co
      cS cP csn cdif cin c0 wne vx cv cP cR cD cbl cfv co wcel vx cS wrex cP cR
      cD cbl cfv co cP csn cJ cnei cfv cfv wcel vy cv cS cP csn cdif cin c0 wne
      vy cP csn cJ cnei cfv cfv wral cP cR cD cbl cfv co cS cP csn cdif cin c0
      wne cD cme wcel cS cJ cuni wss wa cP cS cJ clp cfv cfv wcel wa cR cr wcel
      cc0 cR clt wbr wa wa vy cv cS cP csn cdif cin c0 wne cP cR cD cbl cfv co
      cS cP csn cdif cin c0 wne vy cP cR cD cbl cfv co cP csn cJ cnei cfv cfv
      vy cv cP cR cD cbl cfv co wceq vy cv cS cP csn cdif cin cP cR cD cbl cfv
      co cS cP csn cdif cin c0 vy cv cP cR cD cbl cfv co cS cP csn cdif ineq1
      neeq1d rcla4va cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa cP
      cR cD cbl cfv co cP csn cJ cnei cfv cfv wcel cD cme wcel cS cJ cuni wss
      wa cP cS cJ clp cfv cfv wcel wa cD cP cR cJ cX blopn.1 blopn.2 blnei cD
      cme wcel cS cJ cuni wss wa cP cS cJ clp cfv cfv wcel wa cD cme wcel cP cX
      wcel cD cme wcel cS cJ cuni wss cP cS cJ clp cfv cfv wcel simpll cD cme
      wcel cS cJ cuni wss wa cP cS cJ clp cfv cfv wcel wa cP cJ cuni cX cJ ctop
      wcel cS cJ cuni wss cP cS cJ clp cfv cfv wcel cP cJ cuni wcel cD cme wcel
      cS cJ clp cfv cfv cJ cuni wss cP cS cJ clp cfv cfv wcel cP cJ cuni wcel
      cJ ctop wcel cS cJ cuni wss wa cS cJ clp cfv cfv cJ cuni cP ssel2 cS cJ
      cJ cuni cJ cuni eqid lpss sylan cD cJ blopn.2 opntop sylanl1 cD cme wcel
      cJ cuni cX wceq cS cJ cuni wss cP cS cJ clp cfv cfv wcel cD cJ cX blopn.1
      blopn.2 uniopn2 ad2antrr eleqtrd jca sylan cD cme wcel cS cJ cuni wss wa
      cP cS cJ clp cfv cfv wcel wa vy cv cS cP csn cdif cin c0 wne vy cP csn cJ
      cnei cfv cfv wral cR cr wcel cc0 cR clt wbr wa cJ ctop wcel cS cJ cuni
      wss cP cS cJ clp cfv cfv wcel vy cv cS cP csn cdif cin c0 wne vy cP csn
      cJ cnei cfv cfv wral cD cme wcel cJ ctop wcel cS cJ cuni wss wa cP cS cJ
      clp cfv cfv wcel wa cP cS cJ clp cfv cfv wcel vy cv cS cP csn cdif cin c0
      wne vy cP csn cJ cnei cfv cfv wral cJ ctop wcel cS cJ cuni wss wa cP cS
      cJ clp cfv cfv wcel pm3.27 cJ ctop wcel cS cJ cuni wss cP cJ cuni wcel cP
      cS cJ clp cfv cfv wcel vy cv cS cP csn cdif cin c0 wne vy cP csn cJ cnei
      cfv cfv wral wb cJ ctop wcel cS cJ cuni wss wa cP cS cJ clp cfv cfv wcel
      wa cP cS vy cJ cJ cuni cJ cuni eqid islp2 cJ ctop wcel cS cJ cuni wss cP
      cS cJ clp cfv cfv wcel simpll cJ ctop wcel cS cJ cuni wss cP cS cJ clp
      cfv cfv wcel simplr cS cJ clp cfv cfv cJ cuni wss cP cS cJ clp cfv cfv
      wcel cP cJ cuni wcel cJ ctop wcel cS cJ cuni wss wa cS cJ clp cfv cfv cJ
      cuni cP ssel2 cS cJ cJ cuni cJ cuni eqid lpss sylan syl3anc mpbid cD cJ
      blopn.2 opntop sylanl1 adantr sylanc cP cR cD cbl cfv co cS cP csn cdif
      cin c0 wne vx cv cP cR cD cbl cfv co wcel wn vx cS wral wn vx cv cP cR cD
      cbl cfv co wcel vx cS wrex vx cv cP cR cD cbl cfv co wcel wn vx cS wral
      cP cR cD cbl cfv co cS cP csn cdif cin c0 vx cv cP cR cD cbl cfv co wcel
      wn vx cS wral cP cR cD cbl cfv co cS cin c0 wceq cP cR cD cbl cfv co cS
      cP csn cdif cin c0 wceq cP cR cD cbl cfv co cS cin c0 wceq cS cP cR cD
      cbl cfv co cin c0 wceq vx cv cP cR cD cbl cfv co wcel wn vx cS wral cP cR
      cD cbl cfv co cS cin cS cP cR cD cbl cfv co cin c0 cP cR cD cbl cfv co cS
      incom eqeq1i vx cS cP cR cD cbl cfv co disj bitr2i cP cR cD cbl cfv co cS
      cP csn cdif cin cP cR cD cbl cfv co cS cin wss cP cR cD cbl cfv co cS cin
      c0 wceq cP cR cD cbl cfv co cS cP csn cdif cin c0 wceq cS cP csn cdif cS
      wss cP cR cD cbl cfv co cS cP csn cdif cin cP cR cD cbl cfv co cS cin wss
      cS cP csn difss cS cP csn cdif cS cP cR cD cbl cfv co sslin ax-mp cP cR
      cD cbl cfv co cS cP csn cdif cin cP cR cD cbl cfv co cS cin sseq0 mpan
      sylbi necon3ai vx cv cP cR cD cbl cfv co wcel vx cS dfrex2 sylibr syl cD
      cme wcel cS cX wss cP cS cJ clp cfv cfv wcel cD cme wcel cS cJ cuni wss
      wa cP cS cJ clp cfv cfv wcel wa cD cme wcel cS cX wss wa cD cme wcel cS
      cJ cuni wss wa cP cS cJ clp cfv cfv wcel cD cme wcel cS cX wss wa cD cme
      wcel cS cJ cuni wss cD cme wcel cS cX wss pm3.26 cD cme wcel cS cJ cuni
      wss cS cX wss cD cme wcel cJ cuni cX cS cD cJ cX blopn.1 blopn.2 uniopn2
      sseq2d biimpar jca anim1i 3impa sylan $.
      $( [25-Dec-2007] $) $( [9-Nov-2007] $)
  $}

  ${
    $d o r s x C $.  $d o r s x D $.  $d o r s x J $.  $d o r s x K $.
    $d o r s x X $. $d o r s x Y $.
    metequiv.1 $e |- X = dom dom C $.
    metequiv.2 $e |- Y = dom dom D $.
    metequiv.3 $e |- J = ( Open ` C ) $.
    metequiv.4 $e |- K = ( Open ` D ) $.
    $( Two ways of saying that two metrics generate the same topology.  Two
       metrics satisfying the right-hand side are said to be (topologically)
       equivalent.  (Contributed by Jeffrey Hankins, 21-Jun-2009.) $)
    metequiv $p |- ( ( C e. Met /\ D e. Met ) -> ( J = K
   <-> ( X = Y /\ A. x e. X ( A. r e. RR ( 0 < r -> E. s e. RR ( 0 < s
  /\ ( x ( ball ` D ) s ) C_ ( x ( ball ` C ) r ) ) ) /\ A. s e. RR ( 0 < s
  -> E. r e. RR ( 0 < r /\ ( x ( ball ` C ) r )
              C_ ( x ( ball ` D ) s ) ) ) ) ) ) ) $=
      cC cme wcel cD cme wcel wa cJ cK wceq cX cY wceq cc0 vr cv clt wbr cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs
      cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa
      vx cX wral wa cC cme wcel cD cme wcel wa cJ cK wceq cX cY wceq cc0 vr cv
      clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex
      wi vs cr wral wa vx cX wral cC cme wcel cD cme wcel wa cJ cK wceq cX cY
      wceq cC cme wcel cD cme wcel wa cJ cK wceq wa cJ cuni cK cuni cX cY cJ cK
      wceq cJ cuni cK cuni wceq cC cme wcel cD cme wcel wa cJ cK unieq adantl
      cC cme wcel cJ cuni cX wceq cD cme wcel cJ cK wceq cC cJ cX metequiv.1
      metequiv.3 uniopn2 ad2antrr cD cme wcel cK cuni cY wceq cC cme wcel cJ cK
      wceq cD cK cY metequiv.2 metequiv.4 uniopn2 ad2antlr 3eqtr3d ex cC cme
      wcel cD cme wcel wa cJ cK wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral cC cme
      wcel cD cme wcel wa cJ cK wceq wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX cC cme
      wcel cD cme wcel wa cJ cK wceq wa vx cv cX wcel wa cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral
      cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv cX wcel wa cc0 vr cv clt
      wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co
      wss wa vs cr wrex wi vr cr cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv
      cX wcel wa vr cv cr wcel wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex cC cme wcel
      cD cme wcel wa cJ cK wceq wa vx cv cX wcel wa vr cv cr wcel cc0 vr cv clt
      wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co
      wss wa vs cr wrex cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv cX wcel
      wa vr cv cr wcel cc0 vr cv clt wbr wa wa vx cv vr cv cC cbl cfv co cK
      wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv
      co wss wa vs cr wrex cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv cX
      wcel wa vr cv cr wcel cc0 vr cv clt wbr wa wa vx cv vr cv cC cbl cfv co
      cJ cK cC cme wcel cD cme wcel wa vx cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa vx cv vr cv cC cbl cfv co cJ wcel cJ cK wceq cC cme wcel vx cv
      cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv vr cv cC cbl cfv co cJ
      wcel cD cme wcel cC vx cv vr cv cJ cX metequiv.1 metequiv.3 blopn
      adantllr adantllr cC cme wcel cD cme wcel wa cJ cK wceq vx cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa simpllr eleqtrd cC cme wcel cD cme wcel
      wa vx cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv vr cv cC cbl
      cfv co cK wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC
      cbl cfv co wss wa vs cr wrex wi cJ cK wceq cC cme wcel cD cme wcel wa vx
      cv cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa wa vx cv vx cv vr cv cC
      cbl cfv co wcel vx cv vr cv cC cbl cfv co cK wcel cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi cC cme
      wcel vx cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv vx cv vr cv
      cC cbl cfv co wcel cD cme wcel cC vx cv vr cv cX metequiv.1 blcntr
      adantllr cC cme wcel cD cme wcel wa vr cv cr wcel cc0 vr cv clt wbr wa vx
      cv vx cv vr cv cC cbl cfv co wcel vx cv vr cv cC cbl cfv co cK wcel cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi wi vx cv cX wcel cD cme wcel vx cv vx cv vr cv cC cbl cfv
      co wcel vx cv vr cv cC cbl cfv co cK wcel cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi wi cC cme
      wcel vr cv cr wcel cc0 vr cv clt wbr wa cD cme wcel vx cv vx cv vr cv cC
      cbl cfv co wcel vx cv vr cv cC cbl cfv co cK wcel cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex cD cme
      wcel vx cv vr cv cC cbl cfv co cK wcel vx cv vx cv vr cv cC cbl cfv co
      wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv
      co wss wa vs cr wrex vs vx cv vr cv cC cbl cfv co cD vx cv cK metequiv.4
      opni2 3com23 3exp ad2antlr adantlr mpd adantllr mpd anassrs ex r19.21aiva
      cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv cX wcel vx cv cY wcel cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral cC cme wcel cD cme wcel wa cJ
      cK wceq wa vx cv cX wcel vx cv cY wcel cC cme wcel cD cme wcel wa cJ cK
      wceq wa cX cY vx cv cC cme wcel cD cme wcel wa cJ cK wceq wa cJ cuni cK
      cuni cX cY cJ cK wceq cJ cuni cK cuni wceq cC cme wcel cD cme wcel wa cJ
      cK unieq adantl cC cme wcel cJ cuni cX wceq cD cme wcel cJ cK wceq cC cJ
      cX metequiv.1 metequiv.3 uniopn2 ad2antrr cD cme wcel cK cuni cY wceq cC
      cme wcel cJ cK wceq cD cK cY metequiv.2 metequiv.4 uniopn2 ad2antlr
      3eqtr3d eleq2d biimpa cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv cY
      wcel wa cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr cC cme wcel cD cme wcel
      wa cJ cK wceq wa vx cv cY wcel wa vs cv cr wcel wa cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex cC cme wcel cD cme wcel wa cJ cK wceq wa vx cv cY wcel wa vs
      cv cr wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vx cv vs cv cD cbl cfv co wss wa vr cr wrex cC cme wcel cD cme wcel wa cJ
      cK wceq wa vx cv cY wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vx cv
      vs cv cD cbl cfv co cJ wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vx cv vs cv cD cbl cfv co wss wa vr cr wrex cC cme wcel cD cme wcel wa cJ
      cK wceq wa vx cv cY wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vx cv
      vs cv cD cbl cfv co cK cJ cC cme wcel cD cme wcel wa vx cv cY wcel vs cv
      cr wcel cc0 vs cv clt wbr wa vx cv vs cv cD cbl cfv co cK wcel cJ cK wceq
      cD cme wcel vx cv cY wcel vs cv cr wcel cc0 vs cv clt wbr wa vx cv vs cv
      cD cbl cfv co cK wcel cC cme wcel cD vx cv vs cv cK cY metequiv.2
      metequiv.4 blopn adantlll adantllr cC cme wcel cD cme wcel wa cJ cK wceq
      vx cv cY wcel vs cv cr wcel cc0 vs cv clt wbr wa simpllr eleqtrrd cC cme
      wcel cD cme wcel wa vx cv cY wcel vs cv cr wcel cc0 vs cv clt wbr wa vx
      cv vs cv cD cbl cfv co cJ wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
      co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi cJ cK wceq cC cme wcel
      cD cme wcel wa vx cv cY wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vx
      cv vx cv vs cv cD cbl cfv co wcel vx cv vs cv cD cbl cfv co cJ wcel cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi cD cme wcel vx cv cY wcel vs cv cr wcel cc0 vs cv clt wbr
      wa vx cv vx cv vs cv cD cbl cfv co wcel cC cme wcel cD vx cv vs cv cY
      metequiv.2 blcntr adantlll cC cme wcel cD cme wcel wa vs cv cr wcel cc0
      vs cv clt wbr wa vx cv vx cv vs cv cD cbl cfv co wcel vx cv vs cv cD cbl
      cfv co cJ wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi wi vx cv cY wcel cC cme wcel vx cv vx cv
      vs cv cD cbl cfv co wcel vx cv vs cv cD cbl cfv co cJ wcel cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex
      wi wi cD cme wcel vs cv cr wcel cc0 vs cv clt wbr wa cC cme wcel vx cv vx
      cv vs cv cD cbl cfv co wcel vx cv vs cv cD cbl cfv co cJ wcel cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex cC cme wcel vx cv vs cv cD cbl cfv co cJ wcel vx cv vx cv vs cv cD
      cbl cfv co wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex vr vx cv vs cv cD cbl cfv co cC vx cv cJ
      metequiv.3 opni2 3com23 3exp ad2antrr adantlr mpd adantllr mpd anassrs ex
      r19.21aiva syldan jca r19.21aiva ex jcad cC cme wcel cD cme wcel wa cX cY
      wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi vs cr wral wa vx cX wral wa cJ cK wceq cC cme wcel cD cme
      wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs
      cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa vo cJ cK cC
      cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa
      wa vo cv cX wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa
      vr cr wrex vx vo cv wral wa vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex vx vo cv wral wa vo cv cJ wcel vo cv
      cK wcel cC cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX
      wral wa wa vo cv cX wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv
      wss wa vr cr wrex vx vo cv wral wa vo cv cY wss cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx vo cv wral wa cC cme wcel
      cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa vo cv
      cX wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex vx vo cv wral wa vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vo cv wss wa vs cr wrex vx vo cv wral cC cme wcel cD cme wcel wa
      cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt
      wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co
      wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa vo cv cX wss vo cv cY
      wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex
      vx vo cv wral cC cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral
      wa vx cX wral wa wa vo cv cX wss vo cv cY wss cC cme wcel cD cme wcel wa
      cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt
      wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co
      wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa cX cY vo cv cC cme
      wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral simprl
      sseq2d biimpd adantrd cC cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt
      wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co
      wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr
      wral wa vx cX wral wa wa vo cv cX wss cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral wa cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx vo cv wral cC cme wcel
      cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa vo cv
      cX wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex vx vo cv wral wa wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo
      cv wss wa vs cr wrex vx vo cv cC cme wcel cD cme wcel wa cX cY wceq cc0
      vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC
      cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa vx cX wral wa wa vo cv cX wss cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral wa vx cC cme
      wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa vx
      cC cme wcel cD cme wcel wa vx ax-17 cX cY wceq cc0 vr cv clt wbr cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs
      cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa
      vx cX wral vx cX cY wceq vx ax-17 cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX hbra1
      hban hban vo cv cX wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv
      wss wa vr cr wrex vx vo cv wral vx vo cv cX wss vx ax-17 cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx vo cv hbra1 hban
      hban vo cv cX wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss
      wa vr cr wrex vx vo cv wral wa cC cme wcel cD cme wcel wa cX cY wceq cc0
      vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC
      cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa vx cX wral wa wa vx cv vo cv wcel cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi vo cv cX wss vx cv
      vo cv wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex wi cC cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX
      wral wa wa vx cv vo cv wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vo cv wss wa vs cr wrex wi wi cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vo cv wss wa vr cr wrex vx vo cv wral vx cv vo cv wcel cc0 vr cv clt wbr
      vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi vo cv cX wss cC cme
      wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa
      vx cv vo cv wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa
      vs cr wrex wi wi vx cv vo cv wcel vx cv vo cv wcel cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi vo cv cX wss cC cme
      wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx cv
      vo cv wcel vx cv vo cv wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vo cv wss wa vr cr wrex wi cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo
      cv wss wa vr cr wrex vo cv cX wss cC cme wcel cD cme wcel wa cX cY wceq
      cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv
      cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa vx cX wral wa wa cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex wi wi vx cv vo cv wcel cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex pm2.27 cC cme wcel
      cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa wa cc0 vr
      cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vo cv cX wss
      vx cv vo cv wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa
      vs cr wrex cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa cC cme wcel
      cD cme wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa
      vr cr wrex vo cv cX wss vx cv vo cv wcel cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex wi wi wi cX cY wceq vx cv cX wcel cc0
      vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC
      cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa wi cC cme wcel cD cme wcel wa cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vo cv cX wss vx cv vo cv
      wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex
      wi wi wi wi cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt
      wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co
      wss wa vr cr wrex wi vs cr wral wa vx cX wral cX cY wceq vx cv cX wcel
      cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv
      cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa wi wa cC cme wcel cD cme wcel wa cc0 vr cv clt wbr
      vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vo cv cX wss vx cv vo
      cv wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex wi wi wi vo cv cX wss vx cv vo cv wcel cX cY wceq vx cv cX wcel cc0
      vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC
      cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa wi wa cC cme wcel cD cme wcel wa wa cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vo cv cX wss vx cv vo
      cv wcel cX cY wceq vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa wi wa cC cme
      wcel cD cme wcel wa wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv
      wss wa vr cr wrex cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss
      wa vs cr wrex wi wi vo cv cX wss vx cv vo cv wcel wa vx cv cX wcel cX cY
      wceq vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs
      cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa wi wa cC cme wcel cD cme wcel
      wa wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi wi
      vo cv cX vx cv ssel2 cX cY wceq vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa wi wa
      cC cme wcel cD cme wcel wa wa vx cv cX wcel vo cv cX wss vx cv vo cv wcel
      wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi cX
      cY wceq vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa wi cC cme wcel cD cme wcel
      wa vx cv cX wcel vo cv cX wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vo cv wss wa vr cr wrex cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi vx cv cX wcel vx cv cX
      wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi vs cr wral wa wi cC cme wcel cD cme wcel wa cX cY wceq vo
      cv cX wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vo cv wss wa vr cr wrex cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex wi wi vx cv cX wcel vx cv cX wcel cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral
      wa wi cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa cX cY wceq vo cv
      cX wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo
      cv wss wa vr cr wrex cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex wi wi wi wi vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa
      pm2.27 vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa
      cX cY wceq vo cv cX wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vo cv wss wa vr cr wrex cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex wi wi wi vx cv cX wcel cc0 vr cv clt
      wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co
      wss wa vs cr wrex wi vr cr wral cC cme wcel cD cme wcel wa cX cY wceq vo
      cv cX wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vo cv wss wa vr cr wrex cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex wi wi wi cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr
      wral vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral wa cC
      cme wcel cD cme wcel wa wa cX cY wceq vo cv cX wss vx cv vo cv wcel wa
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi vx cv
      cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx
      cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral wa cC cme wcel cD
      cme wcel wa wa cX cY wceq wa vo cv cX wss vx cv vo cv wcel wa wa cc0 vr
      cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa vs cr wrex vr cr vx cv cX wcel cc0 vr cv
      clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi vr cr wral wa cC cme wcel cD cme wcel wa wa
      cX cY wceq wa vo cv cX wss vx cv vo cv wcel wa vr vx cv cX wcel cc0 vr cv
      clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi vr cr wral wa cC cme wcel cD cme wcel wa wa
      cX cY wceq vr vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral wa cC cme wcel cD cme wcel wa vr vx cv cX wcel cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi vr cr wral vr vx cv cX wcel vr ax-17 cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi vr cr hbra1 hban cC cme wcel cD cme wcel wa vr ax-17 hban
      cX cY wceq vr ax-17 hban vo cv cX wss vx cv vo cv wcel wa vr ax-17 hban
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vr
      ax-17 vx cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral wa
      cC cme wcel cD cme wcel wa wa cX cY wceq wa vo cv cX wss vx cv vo cv wcel
      wa wa vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss
      wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx
      cv cX wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral wa cC cme wcel
      cD cme wcel wa wa cX cY wceq vo cv cX wss vx cv vo cv wcel wa vr cv cr
      wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa wa cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi vx cv cX
      wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral wa cC cme wcel cD cme
      wcel wa wa vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo
      cv wss wa wa vo cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt
      wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx cv cX wcel cc0
      vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC
      cbl cfv co wss wa vs cr wrex wi vr cr wral wa cC cme wcel cD cme wcel wa
      vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa wa
      vo cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi vx cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi wi cC cme wcel cD cme wcel wa vr
      cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa wa vo
      cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex wi wi wi wi cc0 vr cv clt wbr cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs
      cr wrex wi vr cr wral vx cv cX wcel vr cv cr wcel cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi wi cC cme wcel cD cme wcel wa vr cv cr wcel cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa wa vo cv cX wss vx cv vo cv
      wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss
      wa vs cr wrex wi wi wi wi vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa wa vr cv cr wcel cc0 vr cv clt wbr cc0 vs cv clt
      wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex
      wi wi cC cme wcel cD cme wcel wa vx cv cX wcel vo cv cX wss vx cv vo cv
      wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss
      wa vs cr wrex wi wi vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vo cv wss wa vr cv cr wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi wi
      cC cme wcel cD cme wcel wa vx cv cX wcel vo cv cX wss vx cv vo cv wcel wa
      cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex wi wi wi wi wi vr cv cr wcel vr cv cr wcel cc0 vr cv clt wbr cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs
      cr wrex wi wi cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa cC
      cme wcel cD cme wcel wa vx cv cX wcel vo cv cX wss vx cv vo cv wcel wa cX
      cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex wi wi wi wi vr cv cr wcel vr cv cr wcel cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi wi cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vo cv wss wa cC cme wcel cD cme wcel wa vx cv cX wcel vo
      cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex wi wi wi wi wi vr cv cr wcel cc0 vr cv
      clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi pm2.27 cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vo cv wss wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cv cr wcel
      cC cme wcel cD cme wcel wa vx cv cX wcel vo cv cX wss vx cv vo cv wcel wa
      cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex wi wi wi wi cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss
      cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv
      cC cbl cfv co wss wa vs cr wrex wi vr cv cr wcel cC cme wcel cD cme wcel
      wa vx cv cX wcel vo cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi wi wi
      wi cc0 vr cv clt wbr cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vx cv vr cv cC
      cbl cfv co vo cv wss vr cv cr wcel cC cme wcel cD cme wcel wa vx cv cX
      wcel vo cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi wi wi cc0 vr cv clt
      wbr cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex vx cv vr cv cC cbl
      cfv co vo cv wss vr cv cr wcel cC cme wcel cD cme wcel wa vx cv cX wcel
      vo cv cX wss vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi wi wi wi cc0 vr cv clt wbr
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss
      wa vs cr wrex pm2.27 cC cme wcel cD cme wcel wa vx cv vr cv cC cbl cfv co
      vo cv wss vr cv cr wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex vx cv cX wcel vo cv cX wss vx cv vo
      cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex wi wi wi cC cme wcel cD cme wcel wa vx cv vr cv cC cbl
      cfv co vo cv wss vr cv cr wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vx cv vr cv cC cbl cfv co wss wa vs cr wrex vx cv cX wcel vo cv cX wss
      vx cv vo cv wcel wa cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vo cv wss wa vs cr wrex wi wi wi wi cC cme wcel cD cme wcel wa vx cv
      vr cv cC cbl cfv co vo cv wss vr cv cr wcel w3a vo cv cX wss vx cv vo cv
      wcel wa vx cv cX wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex cX cY wceq cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi cC cme wcel cD cme wcel wa
      vx cv vr cv cC cbl cfv co vo cv wss vr cv cr wcel vo cv cX wss vx cv vo
      cv wcel wa vx cv cX wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx
      cv vr cv cC cbl cfv co wss wa vs cr wrex cX cY wceq cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi wi cC cme wcel cD
      cme wcel wa vo cv cX wss vx cv vo cv wcel wa vr cv cr wcel vx cv vr cv cC
      cbl cfv co vo cv wss vx cv cX wcel cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex cX cY wceq cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi cC cme
      wcel cD cme wcel wa vo cv cX wss vx cv vo cv wcel wa vr cv cr wcel vx cv
      vr cv cC cbl cfv co vo cv wss vx cv cX wcel cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex cX cY wceq cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi wi wi
      wi wi vx cv vr cv cC cbl cfv co vo cv wss vx cv cX wcel cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex cX
      cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex wi wi wi wi vr cv cr wcel vx cv vr cv cC cbl cfv co vo cv wss cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs
      cr wrex cX cY wceq cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss
      wa vs cr wrex wi wi vx cv cX wcel vx cv vr cv cC cbl cfv co vo cv wss cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex cX cY wceq vx cv vr cv cC cbl cfv co vo cv wss cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vo cv wss wa vs cr vx cv vr cv cC cbl cfv co vo
      cv wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv
      co wss wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa wi vs
      cv cr wcel vx cv vr cv cC cbl cfv co vo cv wss vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss vx cv vs cv cD cbl cfv co vo cv wss cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss vx cv
      vr cv cC cbl cfv co vo cv wss vx cv vs cv cD cbl cfv co vo cv wss vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co vo cv sstr expcom anim2d
      a1d r19.22dv a1dd a1d a1i a1i12 com24 3imp com24 3exp com14 syl6 com23
      imp com13 syld com23 imp com14 imp cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr ra4 sylan2 imp com24 imp31 exp3a r19.23ad exp31 adantlrr exp31 syld
      com14 imp31 com13 mpd ex com4t ex cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX ra4
      sylan2 impcom com14 syld com4l impcom cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa vr cr wrex vx vo cv ra4 sylan2 impcom r19.21ai ex
      jcad cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs
      cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa cC cme wcel cD
      cme wcel wa vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo
      cv wss wa vs cr wrex vx vo cv wral wa vo cv cX wss cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral wa wi cX cY
      wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv
      vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi vs cr wral wa vx cX wral cc0 vr cv clt wbr cc0 vs cv clt
      wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex
      wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
      co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY
      wral cC cme wcel cD cme wcel wa vo cv cY wss cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vo cv wss wa vs cr wrex vx vo cv wral wa vo cv cX wss
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx vo
      cv wral wa wi wi cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral cc0 vr
      cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex
      wi vs cr wral wa vx cY wral cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX cY raleq1
      biimpa cC cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY
      wral wa vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex vx vo cv wral wa vo cv cX wss cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral wa wi cC cme
      wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral wa wa
      vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs
      cr wrex vx vo cv wral wa vo cv cX wss cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral cC cme wcel cD cme wcel
      wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv
      clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral wa wa vo cv cY wss
      vo cv cX wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs
      cr wrex vx vo cv wral cC cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt
      wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co
      wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr
      wral wa vx cY wral wa wa vo cv cX wss vo cv cY wss cC cme wcel cD cme
      wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl
      cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs
      cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral wa wa cX cY vo cv cC
      cme wcel cD cme wcel wa cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx
      cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr
      cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral
      simprl sseq2d biimprd adantrd cC cme wcel cD cme wcel wa cc0 vr cv clt
      wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co
      wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr
      wral wa vx cY wral vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vo cv wss wa vs cr wrex vx vo cv wral wa cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral wi cX cY wceq cC cme
      wcel cD cme wcel wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral wa vo cv cY wss
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx vo
      cv wral wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex vx vo cv wral cC cme wcel cD cme wcel wa cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY
      wral wa vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex vx vo cv wral wa wa cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa vr cr wrex vx vo cv cC cme wcel cD cme wcel wa
      cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv
      cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr
      wrex wi vs cr wral wa vx cY wral wa vo cv cY wss cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx vo cv wral wa vx cC cme
      wcel cD cme wcel wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral vx cC cme wcel
      cD cme wcel wa vx ax-17 cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY hbra1 hban vo cv
      cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex vx vo cv wral vx vo cv cY wss vx ax-17 cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vo cv wss wa vs cr wrex vx vo cv hbra1 hban hban vo cv cY
      wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex
      vx vo cv wral wa cC cme wcel cD cme wcel wa cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY
      wral wa vx cv vo cv wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo
      cv wss wa vr cr wrex wi vo cv cY wss vx cv vo cv wcel cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex wi cC cme wcel cD cme
      wcel wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx
      cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss
      wa vr cr wrex wi vs cr wral wa vx cY wral wa vx cv vo cv wcel cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vx vo cv wral
      vx cv vo cv wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa
      vs cr wrex wi vo cv cY wss cC cme wcel cD cme wcel wa cc0 vr cv clt wbr
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss
      wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr
      wral wa vx cY wral wa vx cv vo cv wcel cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa vr cr wrex wi wi vx cv vo cv wcel vx cv vo cv
      wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex
      wi vo cv cY wss cC cme wcel cD cme wcel wa cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY
      wral wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex vx cv vo cv wcel vx cv vo cv wcel cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex wi cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa vs cr wrex vo cv cY wss cC cme wcel cD cme wcel
      wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr
      cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr
      cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr
      cr wrex wi vs cr wral wa vx cY wral wa cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vo cv wss wa vr cr wrex wi wi vx cv vo cv wcel cc0 vs cv clt
      wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex pm2.27 cC cme wcel
      cD cme wcel wa cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv
      clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral wa cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vo cv cY wss vx cv vo
      cv wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex cC cme wcel cD cme wcel wa vx cv cY wcel cc0 vr cv clt wbr cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr
      wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa wi
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vo cv
      cY wss vx cv vo cv wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv
      wss wa vr cr wrex wi wi wi cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY wral vx cv
      cY wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx
      cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss
      wa vr cr wrex wi vs cr wral wa wi cC cme wcel cD cme wcel wa cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex vo cv cY wss vx
      cv vo cv wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr
      cr wrex wi wi wi vo cv cY wss vx cv vo cv wcel vx cv cY wcel cc0 vr cv
      clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex
      wi vs cr wral wa wi cC cme wcel cD cme wcel wa wa cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa vs cr wrex cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vo cv wss wa vr cr wrex vo cv cY wss vx cv vo cv wcel vx cv
      cY wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx
      cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss
      wa vr cr wrex wi vs cr wral wa wi cC cme wcel cD cme wcel wa wa cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi vo cv cY wss
      vx cv vo cv wcel wa vx cv cY wcel vx cv cY wcel cc0 vr cv clt wbr cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs
      cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa
      wi cC cme wcel cD cme wcel wa wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vo cv wss wa vs cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo
      cv wss wa vr cr wrex wi wi vo cv cY vx cv ssel2 vx cv cY wcel cc0 vr cv
      clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl
      cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex
      wi vs cr wral wa wi cC cme wcel cD cme wcel wa wa vx cv cY wcel vo cv cY
      wss vx cv vo cv wcel wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss
      wa vr cr wrex wi vx cv cY wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr
      wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv
      vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa wi cC cme wcel cD
      cme wcel wa vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa cc0 vs cv clt
      wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex cc0 vr cv clt wbr
      vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi vx cv cY wcel
      vx cv cY wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv
      clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa wi cC cme wcel cD cme wcel wa
      vo cv cY wss vx cv vo cv wcel wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv
      co vo cv wss wa vs cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo
      cv wss wa vr cr wrex wi wi vx cv cY wcel vx cv cY wcel cc0 vr cv clt wbr
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss
      wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr
      wral wa wi cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt
      wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co
      wss wa vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa vo cv cY
      wss vx cv vo cv wcel wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv
      wss wa vs cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss
      wa vr cr wrex wi wi wi vx cv cY wcel cc0 vr cv clt wbr cc0 vs cv clt wbr
      vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi
      vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa pm2.27 vx cv
      cY wcel cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx
      cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0 vs cv clt wbr
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss
      wa vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa vo cv cY wss vx
      cv vo cv wcel wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa
      vs cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex wi wi vx cv cY wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral
      cC cme wcel cD cme wcel wa vo cv cY wss vx cv vo cv wcel wa cc0 vs cv clt
      wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr wrex cc0 vr cv clt wbr
      vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi cc0 vr cv clt wbr
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss
      wa vs cr wrex wi vr cr wral vx cv cY wcel cc0 vs cv clt wbr cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex
      wi vs cr wral wa cC cme wcel cD cme wcel wa wa vo cv cY wss vx cv vo cv
      wcel wa cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cr
      wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex
      wi vx cv cY wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa cC
      cme wcel cD cme wcel wa wa vo cv cY wss vx cv vo cv wcel wa wa cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vo cv wss wa vr cr wrex vs cr vx cv cY wcel cc0 vs cv
      clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa wa
      vo cv cY wss vx cv vo cv wcel wa vs vx cv cY wcel cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa vs vx cv cY wcel
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr wral vs vx cv cY wcel vs ax-17
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr hbra1 hban cC cme wcel cD cme
      wcel wa vs ax-17 hban vo cv cY wss vx cv vo cv wcel wa vs ax-17 hban cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vs ax-17
      vx cv cY wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
      co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa cC cme
      wcel cD cme wcel wa wa vo cv cY wss vx cv vo cv wcel wa wa vs cv cr wcel
      cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx cv cY wcel cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa
      wa vo cv cY wss vx cv vo cv wcel wa vs cv cr wcel cc0 vs cv clt wbr vx cv
      vs cv cD cbl cfv co vo cv wss wa wa cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vo cv wss wa vr cr wrex wi vx cv cY wcel cc0 vs cv clt wbr cc0 vr
      cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr
      cr wrex wi vs cr wral wa cC cme wcel cD cme wcel wa wa vs cv cr wcel cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa wa vo cv cY wss vx
      cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa
      vr cr wrex vx cv cY wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral
      wa cC cme wcel cD cme wcel wa vs cv cr wcel cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vo cv wss wa wa vo cv cY wss vx cv vo cv wcel wa cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi vx cv cY
      wcel vs cv cr wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl
      cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi wi cC cme wcel cD
      cme wcel wa vs cv cr wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo
      cv wss wa wa vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi cc0 vs cv clt wbr cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex wi vs cr wral vx cv cY wcel vs cv cr wcel cc0 vs cv clt wbr
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss
      wa vr cr wrex wi wi cC cme wcel cD cme wcel wa vs cv cr wcel cc0 vs cv
      clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa wa vo cv cY wss vx cv vo
      cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex wi wi wi vs cv cr wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co
      vo cv wss wa wa vs cv cr wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi wi cC
      cme wcel cD cme wcel wa vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi vs
      cv cr wcel cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs cv
      cr wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi wi cC cme wcel cD cme wcel wa
      vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi wi vs cv cr wcel vs cv
      cr wcel cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex wi wi cc0 vs cv clt wbr vx cv vs
      cv cD cbl cfv co vo cv wss wa cC cme wcel cD cme wcel wa vx cv cY wcel vo
      cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vo cv wss wa vr cr wrex wi wi wi vs cv cr wcel vs cv cr wcel cc0 vs cv
      clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex wi wi cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi cc0 vs
      cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa cC cme wcel cD cme wcel
      wa vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi wi vs cv cr wcel cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi pm2.27 cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vo cv wss wa cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cv cr
      wcel cC cme wcel cD cme wcel wa vx cv cY wcel vo cv cY wss vx cv vo cv
      wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex wi wi wi cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cv cr wcel cC cme wcel cD cme wcel wa
      vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr
      cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi wi wi cc0 vs cv clt wbr
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vx cv vs cv cD cbl cfv co vo cv wss vs
      cv cr wcel cC cme wcel cD cme wcel wa vx cv cY wcel vo cv cY wss vx cv vo
      cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr
      wrex wi wi wi wi cc0 vs cv clt wbr cc0 vs cv clt wbr cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi cc0
      vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa
      vr cr wrex vx cv vs cv cD cbl cfv co vo cv wss vs cv cr wcel cC cme wcel
      cD cme wcel wa vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi wi wi
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex pm2.27 cC cme wcel cD cme wcel wa vx cv
      vs cv cD cbl cfv co vo cv wss vs cv cr wcel cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex vx cv cY wcel
      vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
      co vo cv wss wa vr cr wrex wi wi vx cv vs cv cD cbl cfv co vo cv wss vs
      cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl
      cfv co wss wa vr cr wrex vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi
      wi wi wi cC cme wcel cD cme wcel wa vx cv vs cv cD cbl cfv co vo cv wss
      cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss
      wa vr cr wrex vx cv cY wcel vo cv cY wss vx cv vo cv wcel wa cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex wi wi wi vs cv
      cr wcel vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex vx cv cY wcel vx
      cv vs cv cD cbl cfv co vo cv wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
      co vo cv wss wa vr cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss wa vr cr wrex vx cv cY wcel vx cv vs cv cD cbl
      cfv co vo cv wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa
      vr cr wrex wi wi wi vo cv cY wss vx cv vo cv wcel wa cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex vx cv
      vs cv cD cbl cfv co vo cv wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
      vo cv wss wa vr cr wrex wi vx cv cY wcel vx cv vs cv cD cbl cfv co vo cv
      wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co
      wss wa vr cr wrex cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss
      wa vr cr wrex vx cv vs cv cD cbl cfv co vo cv wss cc0 vr cv clt wbr vx cv
      vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa cc0 vr cv clt wbr vx
      cv vr cv cC cbl cfv co vo cv wss wa vr cr vx cv vs cv cD cbl cfv co vo cv
      wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co
      wss wa cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vo cv wss wa wi vr cv
      cr wcel vx cv vs cv cD cbl cfv co vo cv wss vx cv vr cv cC cbl cfv co vx
      cv vs cv cD cbl cfv co wss vx cv vr cv cC cbl cfv co vo cv wss cc0 vr cv
      clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD cbl cfv co wss vx cv vs
      cv cD cbl cfv co vo cv wss vx cv vr cv cC cbl cfv co vo cv wss vx cv vr
      cv cC cbl cfv co vx cv vs cv cD cbl cfv co vo cv sstr expcom anim2d a1d
      r19.22dv com12 a1d a1i com14 a1d a1i com14 syl6 com23 imp com13 syld
      com23 imp com14 imp cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC
      cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr ra4
      sylan2 imp com23 imp exp3a r19.23ad ex adantlrl exp31 syld com3l imp
      com13 mpd ex com4t ancoms cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv
      cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral
      cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv
      cD cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cY ra4 sylan2 com14
      syld com4l impcom cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss
      wa vs cr wrex vx vo cv ra4 sylan2 impcom r19.21ai ex adantrl jcad expcom
      syldan impcom impbid cC cme wcel vo cv cJ wcel vo cv cX wss cc0 vr cv clt
      wbr vx cv vr cv cC cbl cfv co vo cv wss wa vr cr wrex vx vo cv wral wa wb
      cD cme wcel cX cY wceq cc0 vr cv clt wbr cc0 vs cv clt wbr vx cv vs cv cD
      cbl cfv co vx cv vr cv cC cbl cfv co wss wa vs cr wrex wi vr cr wral cc0
      vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vx cv vs cv cD
      cbl cfv co wss wa vr cr wrex wi vs cr wral wa vx cX wral wa vx vr vo cv
      cC cJ cX metequiv.1 metequiv.3 isopn4 ad2antrr cD cme wcel vo cv cK wcel
      vo cv cY wss cc0 vs cv clt wbr vx cv vs cv cD cbl cfv co vo cv wss wa vs
      cr wrex vx vo cv wral wa wb cC cme wcel cX cY wceq cc0 vr cv clt wbr cc0
      vs cv clt wbr vx cv vs cv cD cbl cfv co vx cv vr cv cC cbl cfv co wss wa
      vs cr wrex wi vr cr wral cc0 vs cv clt wbr cc0 vr cv clt wbr vx cv vr cv
      cC cbl cfv co vx cv vs cv cD cbl cfv co wss wa vr cr wrex wi vs cr wral
      wa vx cX wral wa vx vs vo cv cD cK cY metequiv.2 metequiv.4 isopn4
      ad2antlr 3bitr4d eqrdv ex impbid $.
      $( [21-Jun-2009] $) $( [20-Jun-2009] $)
  $}

  ${
    $d m n x y D $.  $d m n x y J $.
    methausi.1 $e |- D e. Met $.
    methausi.2 $e |- J = ( Open ` D ) $.
    $( The topology generated by a metric space is Hausdorff.  Remark in
       [Munkres] p. 126. $)
    methausi $p |- J e. Haus $=
      vx vy vm vn cJ cD cdm cdm cJ cuni cD cdm cdm cD cme wcel cJ cuni cD cdm
      cdm wceq methausi.1 cD cJ cD cdm cdm cD cdm cdm eqid methausi.2 uniopn2
      ax-mp eqcomi cD cme wcel cJ ctop wcel methausi.1 cD cJ methausi.2 opntop
      ax-mp vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cJ wcel vy cv vx
      cv vy cv cD co c2 cdiv co cD cbl cfv co cJ wcel vx cv vx cv vx cv vy cv
      cD co c2 cdiv co cD cbl cfv co wcel vy cv vy cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co wcel vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co vy
      cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cin c0 wceq w3a vx cv vn cv
      wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vm cJ wrex vn cJ wrex
      vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a vx cv vn
      cv wcel vy cv vm cv wcel vn cv vm cv cin c0 wceq w3a vx cv vx cv vx cv vy
      cv cD co c2 cdiv co cD cbl cfv co wcel vy cv vy cv vx cv vy cv cD co c2
      cdiv co cD cbl cfv co wcel vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv
      co vy cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cin c0 wceq w3a vx cv
      vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co wcel vy cv vm cv wcel vx
      cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co vm cv cin c0 wceq w3a vn vm
      vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co vy cv vx cv vy cv cD co
      c2 cdiv co cD cbl cfv co cJ cJ vn cv vx cv vx cv vy cv cD co c2 cdiv co
      cD cbl cfv co wceq vx cv vn cv wcel vx cv vx cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co wcel vn cv vm cv cin c0 wceq vx cv vx cv vy cv cD co c2
      cdiv co cD cbl cfv co vm cv cin c0 wceq vy cv vm cv wcel vn cv vx cv vx
      cv vy cv cD co c2 cdiv co cD cbl cfv co vx cv eleq2 vn cv vx cv vx cv vy
      cv cD co c2 cdiv co cD cbl cfv co wceq vn cv vm cv cin vx cv vx cv vy cv
      cD co c2 cdiv co cD cbl cfv co vm cv cin c0 vn cv vx cv vx cv vy cv cD co
      c2 cdiv co cD cbl cfv co vm cv ineq1 eqeq1d 3anbi13d vm cv vy cv vx cv vy
      cv cD co c2 cdiv co cD cbl cfv co wceq vy cv vm cv wcel vy cv vy cv vx cv
      vy cv cD co c2 cdiv co cD cbl cfv co wcel vx cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co vm cv cin c0 wceq vx cv vx cv vy cv cD co c2 cdiv co cD
      cbl cfv co vy cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cin c0 wceq
      vx cv vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co wcel vm cv vy cv
      vx cv vy cv cD co c2 cdiv co cD cbl cfv co vy cv eleq2 vm cv vy cv vx cv
      vy cv cD co c2 cdiv co cD cbl cfv co wceq vx cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co vm cv cin vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv
      co vy cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cin c0 vm cv vy cv vx
      cv vy cv cD co c2 cdiv co cD cbl cfv co vx cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co ineq2 eqeq1d 3anbi23d rcla42ev vx cv cD cdm cdm wcel vx
      cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv vy cv cD co c2 cdiv co clt
      wbr wa vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cJ wcel vx cv cD
      cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a cD cme wcel vx cv
      cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv vy cv cD
      co c2 cdiv co clt wbr wa vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co
      cJ wcel methausi.1 cD vx cv vx cv vy cv cD co c2 cdiv co cJ cD cdm cdm cD
      cdm cdm eqid methausi.2 blopn mpanl1 vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv wne 3simp1 vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel vx cv vy cv wne w3a vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv
      vy cv cD co c2 cdiv co clt wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel vx cv vy cv cD co c2 cdiv co cr wcel vx cv vy cv wne vx cv cD cdm
      cdm wcel vy cv cD cdm cdm wcel wa vx cv vy cv cD co cr wcel vx cv vy cv
      cD co c2 cdiv co cr wcel cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv cD co cr wcel methausi.1 vx cv vy cv cD cD cdm cdm
      cD cdm cdm eqid metcl mp3an1 vx cv vy cv cD co rehalfcl syl 3adant3 vx cv
      cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a cc0 vx cv vy cv
      cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr vx cv cD cdm cdm
      wcel vy cv cD cdm cdm wcel vx cv vy cv wne cc0 vx cv vy cv cD co clt wbr
      cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne
      cc0 vx cv vy cv cD co clt wbr wb methausi.1 vx cv vy cv cD cD cdm cdm cD
      cdm cdm eqid metgt0 mp3an1 biimp3a vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt
      wbr wb vx cv vy cv wne vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx
      cv vy cv cD co cr wcel cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv cD
      co c2 cdiv co clt wbr wb cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv cD co cr wcel methausi.1 vx cv vy cv cD cD cdm cdm
      cD cdm cdm eqid metcl mp3an1 vx cv vy cv cD co halfpos2 syl 3adant3 mpbid
      jca sylanc vy cv cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel cc0
      vx cv vy cv cD co c2 cdiv co clt wbr wa vy cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co cJ wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx
      cv vy cv wne w3a cD cme wcel vy cv cD cdm cdm wcel vx cv vy cv cD co c2
      cdiv co cr wcel cc0 vx cv vy cv cD co c2 cdiv co clt wbr wa vy cv vx cv
      vy cv cD co c2 cdiv co cD cbl cfv co cJ wcel methausi.1 cD vy cv vx cv vy
      cv cD co c2 cdiv co cJ cD cdm cdm cD cdm cdm eqid methausi.2 blopn mpanl1
      vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne 3simp2 vx cv
      cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a vx cv vy cv cD
      co c2 cdiv co cr wcel cc0 vx cv vy cv cD co c2 cdiv co clt wbr vx cv cD
      cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel
      vx cv vy cv wne vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx cv vy
      cv cD co cr wcel vx cv vy cv cD co c2 cdiv co cr wcel cD cme wcel vx cv
      cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr wcel
      methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx cv
      vy cv cD co rehalfcl syl 3adant3 vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel vx cv vy cv wne w3a cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv cD
      co c2 cdiv co clt wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv
      vy cv wne cc0 vx cv vy cv cD co clt wbr cD cme wcel vx cv cD cdm cdm wcel
      vy cv cD cdm cdm wcel vx cv vy cv wne cc0 vx cv vy cv cD co clt wbr wb
      methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metgt0 mp3an1
      biimp3a vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel cc0 vx cv vy cv cD co
      clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr wb vx cv vy cv wne vx cv
      cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx cv vy cv cD co cr wcel cc0 vx
      cv vy cv cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr wb cD cme
      wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr
      wcel methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx
      cv vy cv cD co halfpos2 syl 3adant3 mpbid jca sylanc vx cv cD cdm cdm
      wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a vx cv vx cv vx cv vy cv cD
      co c2 cdiv co cD cbl cfv co wcel vy cv vy cv vx cv vy cv cD co c2 cdiv co
      cD cbl cfv co wcel vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co vy cv
      vx cv vy cv cD co c2 cdiv co cD cbl cfv co cin c0 wceq vx cv cD cdm cdm
      wcel vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv vy cv cD co c2 cdiv
      co clt wbr wa vx cv vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co wcel
      vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a cD cme
      wcel vx cv cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv
      vy cv cD co c2 cdiv co clt wbr wa vx cv vx cv vx cv vy cv cD co c2 cdiv
      co cD cbl cfv co wcel methausi.1 cD vx cv vx cv vy cv cD co c2 cdiv co cD
      cdm cdm cD cdm cdm eqid blcntr mpanl1 vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv wne 3simp1 vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel vx cv vy cv wne w3a vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv
      vy cv cD co c2 cdiv co clt wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel vx cv vy cv cD co c2 cdiv co cr wcel vx cv vy cv wne vx cv cD cdm
      cdm wcel vy cv cD cdm cdm wcel wa vx cv vy cv cD co cr wcel vx cv vy cv
      cD co c2 cdiv co cr wcel cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv cD co cr wcel methausi.1 vx cv vy cv cD cD cdm cdm
      cD cdm cdm eqid metcl mp3an1 vx cv vy cv cD co rehalfcl syl 3adant3 vx cv
      cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a cc0 vx cv vy cv
      cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr vx cv cD cdm cdm
      wcel vy cv cD cdm cdm wcel vx cv vy cv wne cc0 vx cv vy cv cD co clt wbr
      cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne
      cc0 vx cv vy cv cD co clt wbr wb methausi.1 vx cv vy cv cD cD cdm cdm cD
      cdm cdm eqid metgt0 mp3an1 biimp3a vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt
      wbr wb vx cv vy cv wne vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx
      cv vy cv cD co cr wcel cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv cD
      co c2 cdiv co clt wbr wb cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv cD co cr wcel methausi.1 vx cv vy cv cD cD cdm cdm
      cD cdm cdm eqid metcl mp3an1 vx cv vy cv cD co halfpos2 syl 3adant3 mpbid
      jca sylanc vy cv cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel cc0
      vx cv vy cv cD co c2 cdiv co clt wbr wa vy cv vy cv vx cv vy cv cD co c2
      cdiv co cD cbl cfv co wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx
      cv vy cv wne w3a cD cme wcel vy cv cD cdm cdm wcel vx cv vy cv cD co c2
      cdiv co cr wcel cc0 vx cv vy cv cD co c2 cdiv co clt wbr wa vy cv vy cv
      vx cv vy cv cD co c2 cdiv co cD cbl cfv co wcel methausi.1 cD vy cv vx cv
      vy cv cD co c2 cdiv co cD cdm cdm cD cdm cdm eqid blcntr mpanl1 vx cv cD
      cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne 3simp2 vx cv cD cdm
      cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne w3a vx cv vy cv cD co c2
      cdiv co cr wcel cc0 vx cv vy cv cD co c2 cdiv co clt wbr vx cv cD cdm cdm
      wcel vy cv cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel vx cv vy
      cv wne vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx cv vy cv cD co
      cr wcel vx cv vy cv cD co c2 cdiv co cr wcel cD cme wcel vx cv cD cdm cdm
      wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr wcel methausi.1 vx cv vy
      cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx cv vy cv cD co rehalfcl
      syl 3adant3 vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne
      w3a cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt
      wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne cc0 vx cv
      vy cv cD co clt wbr cD cme wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel vx cv vy cv wne cc0 vx cv vy cv cD co clt wbr wb methausi.1 vx cv vy
      cv cD cD cdm cdm cD cdm cdm eqid metgt0 mp3an1 biimp3a vx cv cD cdm cdm
      wcel vy cv cD cdm cdm wcel cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy cv
      cD co c2 cdiv co clt wbr wb vx cv vy cv wne vx cv cD cdm cdm wcel vy cv
      cD cdm cdm wcel wa vx cv vy cv cD co cr wcel cc0 vx cv vy cv cD co clt
      wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr wb cD cme wcel vx cv cD cdm
      cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr wcel methausi.1 vx cv
      vy cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx cv vy cv cD co
      halfpos2 syl 3adant3 mpbid jca sylanc vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel wa vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv vy cv cD co c2
      cdiv co clt wbr vx cv vy cv cD co c2 cdiv co vx cv vy cv cD co c2 cdiv co
      cle wbr w3a vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co vy cv vx cv
      vy cv cD co c2 cdiv co cD cbl cfv co cin c0 wceq vx cv cD cdm cdm wcel vy
      cv cD cdm cdm wcel vx cv vy cv wne w3a cD cme wcel vx cv cD cdm cdm wcel
      vy cv cD cdm cdm wcel vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv vy
      cv cD co c2 cdiv co clt wbr vx cv vy cv cD co c2 cdiv co vx cv vy cv cD
      co c2 cdiv co cle wbr w3a vx cv vx cv vy cv cD co c2 cdiv co cD cbl cfv
      co vy cv vx cv vy cv cD co c2 cdiv co cD cbl cfv co cin c0 wceq
      methausi.1 cD vx cv vy cv vx cv vy cv cD co c2 cdiv co cD cdm cdm cD cdm
      cdm eqid bl2in mp3anl1 vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv
      vy cv wne 3simpa vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv
      wne w3a vx cv vy cv cD co c2 cdiv co cr wcel cc0 vx cv vy cv cD co c2
      cdiv co clt wbr vx cv vy cv cD co c2 cdiv co vx cv vy cv cD co c2 cdiv co
      cle wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co c2
      cdiv co cr wcel vx cv vy cv wne vx cv cD cdm cdm wcel vy cv cD cdm cdm
      wcel wa vx cv vy cv cD co cr wcel vx cv vy cv cD co c2 cdiv co cr wcel cD
      cme wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr
      wcel methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx
      cv vy cv cD co rehalfcl syl 3adant3 vx cv cD cdm cdm wcel vy cv cD cdm
      cdm wcel vx cv vy cv wne w3a cc0 vx cv vy cv cD co clt wbr cc0 vx cv vy
      cv cD co c2 cdiv co clt wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel
      vx cv vy cv wne cc0 vx cv vy cv cD co clt wbr cD cme wcel vx cv cD cdm
      cdm wcel vy cv cD cdm cdm wcel vx cv vy cv wne cc0 vx cv vy cv cD co clt
      wbr wb methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metgt0 mp3an1
      biimp3a vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel cc0 vx cv vy cv cD co
      clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr wb vx cv vy cv wne vx cv
      cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx cv vy cv cD co cr wcel cc0 vx
      cv vy cv cD co clt wbr cc0 vx cv vy cv cD co c2 cdiv co clt wbr wb cD cme
      wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr
      wcel methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx
      cv vy cv cD co halfpos2 syl 3adant3 mpbid vx cv cD cdm cdm wcel vy cv cD
      cdm cdm wcel vx cv vy cv cD co c2 cdiv co vx cv vy cv cD co c2 cdiv co
      cle wbr vx cv vy cv wne vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel wa vx
      cv vy cv cD co c2 cdiv co cr wcel vx cv vy cv cD co c2 cdiv co vx cv vy
      cv cD co c2 cdiv co cle wbr vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel
      wa vx cv vy cv cD co cr wcel vx cv vy cv cD co c2 cdiv co cr wcel cD cme
      wcel vx cv cD cdm cdm wcel vy cv cD cdm cdm wcel vx cv vy cv cD co cr
      wcel methausi.1 vx cv vy cv cD cD cdm cdm cD cdm cdm eqid metcl mp3an1 vx
      cv vy cv cD co rehalfcl syl vx cv vy cv cD co c2 cdiv co leid syl 3adant3
      3jca sylanc 3jca syl3anc ishausi $.
      $( [1-Dec-2007] $) $( [9-Mar-2007] $)
  $}

  ${
    methaus.1 $e |- J = ( Open ` D ) $.
    $( The topology generated by a metric space is Hausdorff.  Remark in
       [Munkres] p. 126. $)
    methaus $p |- ( D e. Met -> J e. Haus ) $=
      cD cme wcel cJ cha wcel cD cme wcel cD c0 cif copn cfv cha wcel cD c0 cD
      cD cme wcel cD c0 cif wceq cJ cD cme wcel cD c0 cif copn cfv cha cD cD
      cme wcel cD c0 cif wceq cD copn cfv cD cme wcel cD c0 cif copn cfv cJ cD
      cD cme wcel cD c0 cif copn fveq2 methaus.1 syl5eq eleq1d cD cme wcel cD
      c0 cif cD cme wcel cD c0 cif copn cfv cD c0 cme 0met elimel cD cme wcel
      cD c0 cif copn cfv eqid methausi dedth $.
      $( [3-Dec-2007] $) $( [15-Mar-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Continuity in metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    metcnf.1 $e |- X = dom dom C $.
    metcnf.2 $e |- Y = dom dom D $.
    metcnf.3 $e |- J = ( Open ` C ) $.
    metcnf.4 $e |- K = ( Open ` D ) $.
    $( A continuous function at point ` P ` is a mapping (metric space version
       of ~ cnpf ). $)
    metcnpf $p |- ( ( ( C e. Met /\ D e. Met /\ P e. X ) /\
                F e. ( ( J CnP K ) ` P ) ) -> F : X --> Y ) $=
      cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa cJ
      cuni cK cuni cF wf cX cY cF wf cJ ctop wcel cK ctop wcel cP cJ cuni wcel
      w3a cF cP cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cC cme wcel cD cme
      wcel cP cX wcel w3a cP cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid
      cnpf cC cme wcel cD cme wcel cP cX wcel w3a cJ ctop wcel cK ctop wcel cP
      cJ cuni wcel cC cme wcel cD cme wcel cJ ctop wcel cP cX wcel cC cJ
      metcnf.3 opntop 3ad2ant1 cD cme wcel cC cme wcel cK ctop wcel cP cX wcel
      cD cK metcnf.4 opntop 3ad2ant2 cC cme wcel cP cX wcel cP cJ cuni wcel cD
      cme wcel cC cme wcel cP cJ cuni wcel cP cX wcel cC cme wcel cJ cuni cX cP
      cC cJ cX metcnf.1 metcnf.3 uniopn2 eleq2d biimpar 3adant2 3jca sylan cC
      cme wcel cD cme wcel cP cX wcel w3a cJ cuni cK cuni cF wf cX cY cF wf wb
      cF cP cJ cK ccnp co cfv wcel cC cme wcel cD cme wcel cJ cuni cK cuni cF
      wf cX cY cF wf wb cP cX wcel cC cme wcel cJ cuni cK cuni cF wf cX cK cuni
      cF wf cD cme wcel cX cY cF wf cC cme wcel cJ cuni cX wceq cJ cuni cK cuni
      cF wf cX cK cuni cF wf wb cC cJ cX metcnf.1 metcnf.3 uniopn2 cJ cuni cX
      cK cuni cF feq2 syl cD cme wcel cK cuni cY wceq cX cK cuni cF wf cX cY cF
      wf wb cD cK cY metcnf.2 metcnf.4 uniopn2 cK cuni cY cX cF feq3 syl
      sylan9bb 3adant3 adantr mpbid $.
      $( [30-Dec-2007] $) $( [16-Dec-2007] $)

    $( A continuous function is a mapping (metric space version of ~ cnf ). $)
    metcnf $p |- ( ( C e. Met /\ D e. Met /\
                F e. ( J Cn K ) ) -> F : X --> Y ) $=
      cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cJ cuni cK cuni cF wf cX
      cY cF wf cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cJ cuni cK cuni
      cF wf cC cme wcel cD cme wcel cF cJ cK ccn co wcel cF cJ cK cJ cuni cK
      cuni cJ cuni eqid cK cuni eqid cnf cC cJ metcnf.3 opntop cD cK metcnf.4
      opntop cF cJ cK ccn co wcel id syl3an cC cme wcel cD cme wcel cJ cuni cK
      cuni cF wf cX cY cF wf wb cF cJ cK ccn co wcel cC cme wcel cJ cuni cK
      cuni cF wf cX cK cuni cF wf cD cme wcel cX cY cF wf cC cme wcel cJ cuni
      cX wceq cJ cuni cK cuni cF wf cX cK cuni cF wf wb cC cJ cX metcnf.1
      metcnf.3 uniopn2 cJ cuni cX cK cuni cF feq2 syl cD cme wcel cK cuni cY
      wceq cX cK cuni cF wf cX cY cF wf wb cD cK cY metcnf.2 metcnf.4 uniopn2
      cK cuni cY cX cF feq3 syl sylan9bb 3adant3 mpbid $.
      $( [19-Nov-2007] $) $( [1-Aug-2007] $)

    $( A constant function is continuous (metric space version of
       ~ cnconst ). $)
    metcnconst $p |- ( ( ( C e. Met /\ D e. Met ) /\ ( B e. Y /\
             F : X --> { B } ) ) -> F e. ( J Cn K ) ) $=
      cJ ctop wcel cK ctop wcel wa cB cK cuni wcel cJ cuni cB csn cF wf wa cF
      cJ cK ccn co wcel cC cme wcel cD cme wcel wa cB cY wcel cX cB csn cF wf
      wa wa cB cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid cnconst cC
      cme wcel cD cme wcel wa cJ ctop wcel cK ctop wcel wa cB cY wcel cX cB csn
      cF wf wa cC cme wcel cJ ctop wcel cD cme wcel cK ctop wcel cC cJ metcnf.3
      opntop cD cK metcnf.4 opntop anim12i adantr cC cme wcel cD cme wcel wa cB
      cK cuni wcel cJ cuni cB csn cF wf wa cB cY wcel cX cB csn cF wf wa cD cme
      wcel cB cK cuni wcel cB cY wcel cC cme wcel cJ cuni cB csn cF wf cX cB
      csn cF wf cD cme wcel cK cuni cY cB cD cK cY metcnf.2 metcnf.4 uniopn2
      eleq2d cC cme wcel cJ cuni cX wceq cJ cuni cB csn cF wf cX cB csn cF wf
      wb cC cJ cX metcnf.1 metcnf.3 uniopn2 cJ cuni cX cB csn cF feq2 syl
      bi2anan9r biimpar sylanc $.
      $( [22-Nov-2007] $) $( [10-Aug-2007] $)
  $}

  ${
    $d u v w x y z F $.  $d u v w x y z C $.  $d u v w x y z D $.
    $d u v w x y z X $.  $d u v w x y z Y $.  $d u v w x y z P $.
    $d u v w x y z J $.  $d v x y K $.
    metcn.1 $e |- X = dom dom C $.
    metcn.2 $e |- J = ( Open ` C ) $.
    metcn.3 $e |- Y = dom dom D $.
    metcn.4 $e |- K = ( Open ` D ) $.
    $( MAY BE REVISED - avoid funimass3 here to simplify metcnp2 , and also
       use iscnp2 for metcnp $)
    $( Lemma for ~ metcnp . $)
    metcnplem $p |- ( ( ( C e. Met /\ D e. Met ) /\ ( F : X --> Y /\ P e. X ) )
     -> ( A. y e. RR ( 0 < y -> E. z e. RR ( 0 < z /\ ( P ( ball ` C ) z ) C_
    ( `' F " ( ( F ` P ) ( ball ` D ) y ) ) ) ) <-> A. y e. RR ( 0 < y ->
      E. z e. RR ( 0 < z /\ A. w e. X ( ( P C w ) < z ->
    ( ( F ` P ) D ( F ` w ) ) < y ) ) ) ) ) $=
      cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss wa vz cr wrex wi cc0 vy cv clt wbr cc0 vz cv clt wbr cP
      vw cv cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi
      vw cX wral wa vz cr wrex wi vy cr cC cme wcel cD cme wcel wa cX cY cF wf
      cP cX wcel wa wa vy cv cr wcel wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP
      vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz
      cr wrex cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF cfv vw cv cF
      cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex cC cme wcel cD cme
      wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr cc0
      vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv
      co cima wss wa vz cr wrex cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr
      cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wb
      cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0
      vy cv clt wbr wa wa cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP
      cF cfv vy cv cD cbl cfv co cima wss wa cc0 vz cv clt wbr cP vw cv cC co
      vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa
      vz cr cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr
      wcel cc0 vy cv clt wbr wa wa vz cv cr wcel wa cc0 vz cv clt wbr cP vz cv
      cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss cP vw cv cC
      co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral
      cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0
      vy cv clt wbr wa wa vz cv cr wcel cc0 vz cv clt wbr cP vz cv cC cbl cfv
      co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss cP vw cv cC co vz cv
      clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wb cC
      cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy
      cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa cP vz cv cC cbl cfv co
      cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss cP vw cv cC co vz cv clt
      wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wb cC cme
      wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv
      clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa cP vz cv cC cbl cfv
      co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss vw cv cF cfv cP cF cfv
      vy cv cD cbl cfv co wcel vw cP vz cv cC cbl cfv co wral cP vw cv cC co vz
      cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral cF
      wfun cP vz cv cC cbl cfv co cF cdm wss cP vz cv cC cbl cfv co cF ccnv cP
      cF cfv vy cv cD cbl cfv co cima wss vw cv cF cfv cP cF cfv vy cv cD cbl
      cfv co wcel vw cP vz cv cC cbl cfv co wral wb cC cme wcel cD cme wcel wa
      cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr
      wcel cc0 vz cv clt wbr wa wa wa vw cP vz cv cC cbl cfv co cP cF cfv vy cv
      cD cbl cfv co cF funimass5 cX cY cF wf cP cX wcel wa cF wfun cC cme wcel
      cD cme wcel wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv
      clt wbr wa wa cX cY cF wf cF wfun cP cX wcel cX cY cF ffun adantr
      ad2antlr cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr
      wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa cP vz
      cv cC cbl cfv co cX cF cdm cC cme wcel cP cX wcel wa vz cv cr wcel cc0 vz
      cv clt wbr wa cP vz cv cC cbl cfv co cX wss cC cme wcel cD cme wcel wa cX
      cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr
      wcel cc0 vz cv clt wbr wa wa wa cC cP vz cv cX metcn.1 blssm cC cme wcel
      cD cme wcel wa cX cY cF wf cP cX wcel wa wa cC cme wcel cP cX wcel wa vy
      cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa cC
      cme wcel cD cme wcel wa cC cme wcel cX cY cF wf cP cX wcel wa cP cX wcel
      cC cme wcel cD cme wcel pm3.26 cX cY cF wf cP cX wcel pm3.27 anim12i
      adantr cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr
      wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa simprr
      sylanc cX cY cF wf cP cX wcel wa cF cdm cX wceq cC cme wcel cD cme wcel
      wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa
      wa cX cY cF wf cF cdm cX wceq cP cX wcel cX cY cF fdm adantr ad2antlr
      sseqtr4d sylanc cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa
      vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa
      wa vw cv cF cfv cP cF cfv vy cv cD cbl cfv co wcel cP vw cv cC co vz cv
      clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cP vz cv cC cbl
      cfv co cX cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv
      cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa vw
      cv cP vz cv cC cbl cfv co wcel vw cv cF cfv cP cF cfv vy cv cD cbl cfv co
      wcel wi vw cv cX wcel vw cv cP vz cv cC cbl cfv co wcel vw cv cF cfv cP
      cF cfv vy cv cD cbl cfv co wcel wi wi vw cv cX wcel cP vw cv cC co vz cv
      clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi wi cC cme wcel cD
      cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr
      wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa vw cv cP vz cv cC cbl cfv co
      wcel vw cv cF cfv cP cF cfv vy cv cD cbl cfv co wcel wi vw cv cP vz cv cC
      cbl cfv co wcel vw cv cX wcel vw cv cF cfv cP cF cfv vy cv cD cbl cfv co
      wcel wi wi vw cv cX wcel vw cv cP vz cv cC cbl cfv co wcel vw cv cF cfv
      cP cF cfv vy cv cD cbl cfv co wcel wi wi cC cme wcel cD cme wcel wa cX cY
      cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel
      cc0 vz cv clt wbr wa wa wa vw cv cP vz cv cC cbl cfv co wcel vw cv cF cfv
      cP cF cfv vy cv cD cbl cfv co wcel vw cv cX wcel vw cv cF cfv cP cF cfv
      vy cv cD cbl cfv co wcel wi cC cme wcel cD cme wcel wa cX cY cF wf cP cX
      wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt
      wbr wa wa wa vw cv cP vz cv cC cbl cfv co wcel wa vw cv cX wcel vw cv cF
      cfv cP cF cfv vy cv cD cbl cfv co wcel vw cv cX wcel vw cv cF cfv cP cF
      cfv vy cv cD cbl cfv co wcel wi wb cP vz cv cC cbl cfv co cX wss vw cv cP
      vz cv cC cbl cfv co wcel vw cv cX wcel cC cme wcel cD cme wcel wa cX cY
      cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel
      cc0 vz cv clt wbr wa wa wa cP vz cv cC cbl cfv co cX vw cv ssel2 cC cme
      wcel cP cX wcel wa vz cv cr wcel cc0 vz cv clt wbr wa cP vz cv cC cbl cfv
      co cX wss cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv
      cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa cC
      cP vz cv cX metcn.1 blssm cC cme wcel cD cme wcel wa cX cY cF wf cP cX
      wcel wa wa cC cme wcel cP cX wcel wa vy cv cr wcel cc0 vy cv clt wbr wa
      vz cv cr wcel cc0 vz cv clt wbr wa wa cC cme wcel cD cme wcel wa cC cme
      wcel cX cY cF wf cP cX wcel wa cP cX wcel cC cme wcel cD cme wcel pm3.26
      cX cY cF wf cP cX wcel pm3.27 anim12i adantr cC cme wcel cD cme wcel wa
      cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr
      wcel cc0 vz cv clt wbr wa simprr sylanc sylan vw cv cX wcel vw cv cF cfv
      cP cF cfv vy cv cD cbl cfv co wcel biimt syl pm5.74da vw cv cP vz cv cC
      cbl cfv co wcel vw cv cX wcel vw cv cF cfv cP cF cfv vy cv cD cbl cfv co
      wcel bi2.04 syl6bb cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa
      wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa
      wa wa vw cv cX wcel vw cv cP vz cv cC cbl cfv co wcel vw cv cF cfv cP cF
      cfv vy cv cD cbl cfv co wcel wi cP vw cv cC co vz cv clt wbr cP cF cfv vw
      cv cF cfv cD co vy cv clt wbr wi cC cme wcel cD cme wcel wa cX cY cF wf
      cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz
      cv clt wbr wa wa wa vw cv cX wcel wa vw cv cP vz cv cC cbl cfv co wcel cP
      vw cv cC co vz cv clt wbr vw cv cF cfv cP cF cfv vy cv cD cbl cfv co wcel
      cP cF cfv vw cv cF cfv cD co vy cv clt wbr cC cme wcel cP cX wcel vw cv
      cX wcel w3a vz cv cr wcel cc0 vz cv clt wbr wa vw cv cP vz cv cC cbl cfv
      co wcel cP vw cv cC co vz cv clt wbr wb cC cme wcel cD cme wcel wa cX cY
      cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel
      cc0 vz cv clt wbr wa wa wa vw cv cX wcel wa vw cv cC cP vz cv cX metcn.1
      elbl2 cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr
      wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa vw cv
      cX wcel wa cC cme wcel cP cX wcel vw cv cX wcel cC cme wcel cD cme wcel
      wa cX cY cF wf cP cX wcel wa wa cC cme wcel vy cv cr wcel cc0 vy cv clt
      wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel cC cme wcel cD
      cme wcel cX cY cF wf cP cX wcel wa simpll ad2antrr cC cme wcel cD cme
      wcel wa cX cY cF wf cP cX wcel wa wa cP cX wcel vy cv cr wcel cc0 vy cv
      clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel cC cme
      wcel cD cme wcel wa cX cY cF wf cP cX wcel simprr ad2antrr cC cme wcel cD
      cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr
      wa vz cv cr wcel cc0 vz cv clt wbr wa wa wa vw cv cX wcel pm3.27 3jca cC
      cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy
      cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel simplrr
      sylanc cD cme wcel cP cF cfv cY wcel vw cv cF cfv cY wcel w3a vy cv cr
      wcel cc0 vy cv clt wbr wa vw cv cF cfv cP cF cfv vy cv cD cbl cfv co wcel
      cP cF cfv vw cv cF cfv cD co vy cv clt wbr wb cC cme wcel cD cme wcel wa
      cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr
      wcel cc0 vz cv clt wbr wa wa wa vw cv cX wcel wa vw cv cF cfv cD cP cF
      cfv vy cv cY metcn.3 elbl2 cC cme wcel cD cme wcel wa cX cY cF wf cP cX
      wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt
      wbr wa wa wa vw cv cX wcel wa cD cme wcel cP cF cfv cY wcel vw cv cF cfv
      cY wcel cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa cD cme
      wcel vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr
      wa wa vw cv cX wcel cC cme wcel cD cme wcel cX cY cF wf cP cX wcel wa
      simplr ad2antrr cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa
      cP cF cfv cY wcel vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz
      cv clt wbr wa wa vw cv cX wcel cX cY cF wf cP cX wcel wa cP cF cfv cY
      wcel cC cme wcel cD cme wcel wa cX cY cP cF ffvelrn adantl ad2antrr cC
      cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vw cv cX wcel vw cv
      cF cfv cY wcel vy cv cr wcel cc0 vy cv clt wbr wa vz cv cr wcel cc0 vz cv
      clt wbr wa wa cX cY cF wf cP cX wcel wa vw cv cX wcel vw cv cF cfv cY
      wcel cC cme wcel cD cme wcel wa cX cY cF wf vw cv cX wcel vw cv cF cfv cY
      wcel cP cX wcel cX cY vw cv cF ffvelrn adantlr adantll adantlr 3jca cC
      cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr wcel cc0 vy
      cv clt wbr wa vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel simplrl
      sylanc imbi12d pm5.74da bitrd ralbidv2 bitrd anassrs anassrs pm5.32da
      rexbidva anassrs pm5.74da ralbidva $.
      $( [16-Nov-2007] $) $( [12-May-2007] $)

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous at point ` P ` .  _Warning:  The HTML proof page is 0.6
       megabyte in size_. $)
    metcnp $p |- ( ( C e. Met /\ D e. Met /\ P e. X ) ->
                ( F e. ( ( J CnP K ) ` P ) <->
          ( F : X --> Y /\ A. y e. RR ( 0 < y -> E. z e. RR ( 0 < z /\
      A. w e. X ( ( P C w ) < z -> ( ( F ` P ) D ( F ` w ) ) < y ) ) ) ) ) ) $=
      cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cJ
      cuni cK cuni cF wf cP cF cfv vv cv wcel cP vu cv wcel cF vu cv cima vv cv
      wss wa vu cJ wrex wi vv cK wral wa cX cY cF wf cP cF cfv vv cv wcel cP vu
      cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral wa cX cY cF
      wf cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr
      wral wa cJ ctop wcel cK ctop wcel cP cJ cuni wcel cF cP cJ cK ccnp co cfv
      wcel cJ cuni cK cuni cF wf cP cF cfv vv cv wcel cP vu cv wcel cF vu cv
      cima vv cv wss wa vu cJ wrex wi vv cK wral wa wb cC cme wcel cD cme wcel
      cP cX wcel w3a vu vv cP cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni
      eqid iscnp cC cme wcel cD cme wcel cJ ctop wcel cP cX wcel cC cJ metcn.2
      opntop 3ad2ant1 cD cme wcel cC cme wcel cK ctop wcel cP cX wcel cD cK
      metcn.4 opntop 3ad2ant2 cC cme wcel cP cX wcel cP cJ cuni wcel cD cme
      wcel cC cme wcel cP cJ cuni wcel cP cX wcel cC cme wcel cJ cuni cX cP cC
      cJ cX metcn.1 metcn.2 uniopn2 eleq2d biimpar 3adant2 syl3anc cC cme wcel
      cD cme wcel cJ cuni cK cuni cF wf cP cF cfv vv cv wcel cP vu cv wcel cF
      vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral wa cX cY cF wf cP cF cfv
      vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK
      wral wa wb cP cX wcel cC cme wcel cD cme wcel wa cJ cuni cK cuni cF wf cX
      cY cF wf cP cF cfv vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu
      cJ wrex wi vv cK wral cJ cuni cX wceq cK cuni cY wceq cJ cuni cK cuni cF
      wf cX cY cF wf wb cC cme wcel cD cme wcel cJ cuni cK cuni cX cY cF feq23
      cC cJ cX metcn.1 metcn.2 uniopn2 cD cK cY metcn.3 metcn.4 uniopn2 syl2an
      anbi1d 3adant3 cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf cP cF
      cfv vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv
      cK wral cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr
      cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi
      vy cr wral cC cme wcel cD cme wcel cP cX wcel cX cY cF wf cP cF cfv vv cv
      wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral
      cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr
      wral wb wi cC cme wcel cD cme wcel cX cY cF wf cP cX wcel cP cF cfv vv cv
      wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral
      cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr
      wral wb cC cme wcel cD cme wcel cX cY cF wf cP cX wcel cP cF cfv vv cv
      wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral
      cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr
      wral wb cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa cP cF cfv
      vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK
      wral cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv
      cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral cc0 vy
      cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF cfv vw cv
      cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral cC
      cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa cP cF cfv vv cv wcel
      cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral cc0 vy
      cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy
      cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral cC cme wcel cD cme
      wcel wa cX cY cF wf cP cX wcel wa wa cP cF cfv vv cv wcel cP vu cv wcel
      cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral wa cc0 vy cv clt wbr
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss wa vz cr wrex wi vy cr cC cme wcel cD cme wcel wa cX cY
      cF wf cP cX wcel wa wa cP cF cfv vv cv wcel cP vu cv wcel cF vu cv cima
      vv cv wss wa vu cJ wrex wi vv cK wral wa vy cv cr wcel cc0 vy cv clt wbr
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss wa vz cr wrex cC cme wcel cD cme wcel wa cX cY cF wf cP
      cX wcel wa wa vy cv cr wcel cc0 vy cv clt wbr wa cP cF cfv vv cv wcel cP
      vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral cc0 vz cv
      clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima
      wss wa vz cr wrex cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa
      vy cv cr wcel cc0 vy cv clt wbr wa wa cP cF cfv vv cv wcel cP vu cv wcel
      cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK wral cc0 vz cv clt wbr cP
      vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz
      cr wrex cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa vy cv cr
      wcel cc0 vy cv clt wbr wa wa cP cF cfv vv cv wcel cP vu cv wcel cF vu cv
      cima vv cv wss wa vu cJ wrex wi vv cK wral cP vu cv wcel cF vu cv cima cP
      cF cfv vy cv cD cbl cfv co wss wa vu cJ wrex cc0 vz cv clt wbr cP vz cv
      cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr
      wrex cD cme wcel cX cY cF wf cP cX wcel wa vy cv cr wcel cc0 vy cv clt
      wbr wa cP cF cfv vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu
      cJ wrex wi vv cK wral cP vu cv wcel cF vu cv cima cP cF cfv vy cv cD cbl
      cfv co wss wa vu cJ wrex wi cC cme wcel cD cme wcel cP cF cfv cY wcel vy
      cv cr wcel cc0 vy cv clt wbr wa cP cF cfv vv cv wcel cP vu cv wcel cF vu
      cv cima vv cv wss wa vu cJ wrex wi vv cK wral cP vu cv wcel cF vu cv cima
      cP cF cfv vy cv cD cbl cfv co wss wa vu cJ wrex wi cX cY cF wf cP cX wcel
      wa cP cF cfv vy cv cD cbl cfv co cK wcel cP cF cfv cP cF cfv vy cv cD cbl
      cfv co wcel cP cF cfv vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa
      vu cJ wrex wi vv cK wral cP vu cv wcel cF vu cv cima cP cF cfv vy cv cD
      cbl cfv co wss wa vu cJ wrex wi cD cme wcel cP cF cfv cY wcel wa vy cv cr
      wcel cc0 vy cv clt wbr wa wa cP cF cfv vy cv cD cbl cfv co cK wcel cP cF
      cfv vv cv wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv
      cK wral cP cF cfv cP cF cfv vy cv cD cbl cfv co wcel cP vu cv wcel cF vu
      cv cima cP cF cfv vy cv cD cbl cfv co wss wa vu cJ wrex cP cF cfv vv cv
      wcel cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex wi cP cF cfv cP
      cF cfv vy cv cD cbl cfv co wcel cP vu cv wcel cF vu cv cima cP cF cfv vy
      cv cD cbl cfv co wss wa vu cJ wrex wi vv cP cF cfv vy cv cD cbl cfv co cK
      vv cv cP cF cfv vy cv cD cbl cfv co wceq cP cF cfv vv cv wcel cP cF cfv
      cP cF cfv vy cv cD cbl cfv co wcel cP vu cv wcel cF vu cv cima vv cv wss
      wa vu cJ wrex cP vu cv wcel cF vu cv cima cP cF cfv vy cv cD cbl cfv co
      wss wa vu cJ wrex vv cv cP cF cfv vy cv cD cbl cfv co cP cF cfv eleq2 vv
      cv cP cF cfv vy cv cD cbl cfv co wceq cP vu cv wcel cF vu cv cima vv cv
      wss wa cP vu cv wcel cF vu cv cima cP cF cfv vy cv cD cbl cfv co wss wa
      vu cJ vv cv cP cF cfv vy cv cD cbl cfv co wceq cF vu cv cima vv cv wss cF
      vu cv cima cP cF cfv vy cv cD cbl cfv co wss cP vu cv wcel vv cv cP cF
      cfv vy cv cD cbl cfv co cF vu cv cima sseq2 anbi2d rexbidv imbi12d rcla4v
      com23 cD cP cF cfv vy cv cK cY metcn.3 metcn.4 blopn cD cP cF cfv vy cv
      cY metcn.3 blcntr sylc cX cY cP cF ffvelrn sylanl2 adantlll cC cme wcel
      cD cme wcel wa cX cY cF wf cP cX wcel wa wa cP vu cv wcel cF vu cv cima
      cP cF cfv vy cv cD cbl cfv co wss wa vu cJ wrex cc0 vz cv clt wbr cP vz
      cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr
      wrex wi vy cv cr wcel cc0 vy cv clt wbr wa cC cme wcel cX cY cF wf cP vu
      cv wcel cF vu cv cima cP cF cfv vy cv cD cbl cfv co wss wa vu cJ wrex cc0
      vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv
      co cima wss wa vz cr wrex wi cD cme wcel cP cX wcel cC cme wcel cX cY cF
      wf wa cP vu cv wcel cF vu cv cima cP cF cfv vy cv cD cbl cfv co wss wa
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss wa vz cr wrex vu cJ cC cme wcel cX cY cF wf wa vu cv cJ
      wcel wa cP vu cv wcel cF vu cv cima cP cF cfv vy cv cD cbl cfv co wss cc0
      vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv
      co cima wss wa vz cr wrex cC cme wcel cX cY cF wf wa vu cv cJ wcel wa cP
      vu cv wcel wa cF vu cv cima cP cF cfv vy cv cD cbl cfv co wss vu cv cF
      ccnv cP cF cfv vy cv cD cbl cfv co cima wss cc0 vz cv clt wbr cP vz cv cC
      cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex
      cC cme wcel cX cY cF wf wa vu cv cJ wcel wa cF vu cv cima cP cF cfv vy cv
      cD cbl cfv co wss vu cv cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wb
      cP vu cv wcel cF wfun vu cv cF cdm wss cF vu cv cima cP cF cfv vy cv cD
      cbl cfv co wss vu cv cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wb cC
      cme wcel cX cY cF wf wa vu cv cJ wcel wa vu cv cP cF cfv vy cv cD cbl cfv
      co cF funimass3 cX cY cF wf cF wfun cC cme wcel vu cv cJ wcel cX cY cF
      ffun ad2antlr cC cme wcel cX cY cF wf wa vu cv cJ wcel wa vu cv cX cF cdm
      cC cme wcel vu cv cJ wcel vu cv cX wss cX cY cF wf vu cv cC cJ cX metcn.1
      metcn.2 opnss adantlr cX cY cF wf cF cdm cX wceq cC cme wcel vu cv cJ
      wcel cX cY cF fdm ad2antlr sseqtr4d sylanc adantr cC cme wcel vu cv cJ
      wcel cP vu cv wcel vu cv cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss wa vz cr wrex wi cX cY cF wf vu cv cF ccnv cP cF cfv vy
      cv cD cbl cfv co cima wss cc0 vz cv clt wbr cP vz cv cC cbl cfv co vu cv
      wss wa vz cr wrex cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF
      cfv vy cv cD cbl cfv co cima wss wa vz cr wrex cC cme wcel vu cv cJ wcel
      wa cP vu cv wcel wa vu cv cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co vu cv wss wa cc0 vz cv clt wbr
      cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa
      vz cr vu cv cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss vz cv cr wcel
      wa cP vz cv cC cbl cfv co vu cv wss cP vz cv cC cbl cfv co cF ccnv cP cF
      cfv vy cv cD cbl cfv co cima wss cc0 vz cv clt wbr vu cv cF ccnv cP cF
      cfv vy cv cD cbl cfv co cima wss cP vz cv cC cbl cfv co vu cv wss cP vz
      cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wi vz cv
      cr wcel cP vz cv cC cbl cfv co vu cv wss vu cv cF ccnv cP cF cfv vy cv cD
      cbl cfv co cima wss cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss cP vz cv cC cbl cfv co vu cv cF ccnv cP cF cfv vy cv cD
      cbl cfv co cima sstr expcom adantr anim2d r19.22dva cC cme wcel vu cv cJ
      wcel cP vu cv wcel cc0 vz cv clt wbr cP vz cv cC cbl cfv co vu cv wss wa
      vz cr wrex vz vu cv cC cP cJ metcn.2 opni2 3expa syl5com adantllr sylbid
      expimpd r19.23adva ad2ant2r adantr syld imp an1rs exp32 r19.21aiv cC cme
      wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr cc0 vz
      cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co
      cima wss wa vz cr wrex wi vy cr wral wa cP cF cfv vv cv wcel cP vu cv
      wcel cF vu cv cima vv cv wss wa vu cJ wrex wi vv cK cC cme wcel cD cme
      wcel wa cX cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr
      cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa
      vz cr wrex wi vy cr wral wa vv cv cK wcel wa cP cF cfv vv cv wcel cP vu
      cv wcel cF vu cv cima vv cv wss wa vu cJ wrex cC cme wcel cD cme wcel wa
      cX cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv
      cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr
      wrex wi vy cr wral wa vv cv cK wcel wa cP cF cfv vv cv wcel wa cc0 vw cv
      clt wbr cP cF cfv vw cv cD cbl cfv co vv cv wss wa vw cr wrex cP vu cv
      wcel cF vu cv cima vv cv wss wa vu cJ wrex cC cme wcel cD cme wcel wa cX
      cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC
      cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex
      wi vy cr wral wa vv cv cK wcel cP cF cfv vv cv wcel cc0 vw cv clt wbr cP
      cF cfv vw cv cD cbl cfv co vv cv wss wa vw cr wrex cD cme wcel vv cv cK
      wcel cP cF cfv vv cv wcel wa cc0 vw cv clt wbr cP cF cfv vw cv cD cbl cfv
      co vv cv wss wa vw cr wrex cC cme wcel cD cme wcel wa cX cY cF wf cP cX
      wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral
      wa cD cme wcel vv cv cK wcel cP cF cfv vv cv wcel cc0 vw cv clt wbr cP cF
      cfv vw cv cD cbl cfv co vv cv wss wa vw cr wrex vw vv cv cD cP cF cfv cK
      metcn.4 opni2 3expb cC cme wcel cD cme wcel cX cY cF wf cP cX wcel wa cc0
      vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv
      vy cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral simpllr sylan
      anassrs cC cme wcel cD cme wcel wa cX cY cF wf cP cX wcel wa wa cc0 vy cv
      clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv
      cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral wa cc0 vw cv clt wbr
      cP cF cfv vw cv cD cbl cfv co vv cv wss wa vw cr wrex cP vu cv wcel cF vu
      cv cima vv cv wss wa vu cJ wrex wi vv cv cK wcel cP cF cfv vv cv wcel cC
      cme wcel cX cY cF wf cP cX wcel wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP
      vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz
      cr wrex wi vy cr wral cc0 vw cv clt wbr cP cF cfv vw cv cD cbl cfv co vv
      cv wss wa vw cr wrex cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex
      wi cD cme wcel cC cme wcel cX cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr
      cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl
      cfv co cima wss wa vz cr wrex wi vy cr wral wa cc0 vw cv clt wbr cP cF
      cfv vw cv cD cbl cfv co vv cv wss wa cP vu cv wcel cF vu cv cima vv cv
      wss wa vu cJ wrex vw cr cC cme wcel cX cY cF wf cP cX wcel wa wa cc0 vy
      cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy
      cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral wa vw cv cr wcel wa
      cc0 vw cv clt wbr cP cF cfv vw cv cD cbl cfv co vv cv wss wa cP vu cv
      wcel cF vu cv cima vv cv wss wa vu cJ wrex cC cme wcel cX cY cF wf cP cX
      wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral
      wa vw cv cr wcel wa cc0 vw cv clt wbr cP cF cfv vw cv cD cbl cfv co vv cv
      wss wa wa cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw
      cv cD cbl cfv co cima wss wa vz cr wrex cP vu cv wcel cF vu cv cima vv cv
      wss wa vu cJ wrex cC cme wcel cX cY cF wf cP cX wcel wa wa cc0 vy cv clt
      wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD
      cbl cfv co cima wss wa vz cr wrex wi vy cr wral wa vw cv cr wcel wa cc0
      vw cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv
      vw cv cD cbl cfv co cima wss wa vz cr wrex cP cF cfv vw cv cD cbl cfv co
      vv cv wss cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral
      vw cv cr wcel cc0 vw cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co
      cF ccnv cP cF cfv vw cv cD cbl cfv co cima wss wa vz cr wrex cC cme wcel
      cX cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv
      cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr
      wrex wi vy cr wral vw cv cr wcel wa cc0 vw cv clt wbr cc0 vz cv clt wbr
      cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw cv cD cbl cfv co cima wss wa
      vz cr wrex cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex wi cc0 vw cv
      clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw cv
      cD cbl cfv co cima wss wa vz cr wrex wi vy vw cv cr vy cv vw cv wceq cc0
      vy cv clt wbr cc0 vw cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co
      cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex cc0 vz cv
      clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw cv cD cbl cfv co cima
      wss wa vz cr wrex vy cv vw cv cc0 clt breq2 vy cv vw cv wceq cc0 vz cv
      clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima
      wss wa cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw cv
      cD cbl cfv co cima wss wa vz cr vy cv vw cv wceq cP vz cv cC cbl cfv co
      cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vw cv cD cbl cfv co cima wss cc0 vz cv clt wbr vy cv vw cv
      wceq cF ccnv cP cF cfv vy cv cD cbl cfv co cima cF ccnv cP cF cfv vw cv
      cD cbl cfv co cima cP vz cv cC cbl cfv co vy cv vw cv wceq cP cF cfv vy
      cv cD cbl cfv co cP cF cfv vw cv cD cbl cfv co cF ccnv vy cv vw cv cP cF
      cfv cD cbl cfv opreq2 imaeq2d sseq2d anbi2d rexbidv imbi12d rcla4cva imp
      adantlll adantrr cC cme wcel cX cY cF wf cP cX wcel wa wa cc0 vy cv clt
      wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD
      cbl cfv co cima wss wa vz cr wrex wi vy cr wral wa vw cv cr wcel wa cP cF
      cfv vw cv cD cbl cfv co vv cv wss cc0 vz cv clt wbr cP vz cv cC cbl cfv
      co cF ccnv cP cF cfv vw cv cD cbl cfv co cima wss wa vz cr wrex cP vu cv
      wcel cF vu cv cima vv cv wss wa vu cJ wrex wi cc0 vw cv clt wbr cC cme
      wcel cX cY cF wf cP cX wcel wa wa vw cv cr wcel cP cF cfv vw cv cD cbl
      cfv co vv cv wss cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF
      cfv vw cv cD cbl cfv co cima wss wa vz cr wrex cP vu cv wcel cF vu cv
      cima vv cv wss wa vu cJ wrex wi cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz
      cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr
      wrex wi vy cr wral cC cme wcel cX cY cF wf cP cX wcel wa wa cP cF cfv vw
      cv cD cbl cfv co vv cv wss cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vw cv cD cbl cfv co cima wss wa vz cr wrex cP vu cv wcel
      cF vu cv cima vv cv wss wa vu cJ wrex wi vw cv cr wcel cC cme wcel cX cY
      cF wf cP cX wcel wa wa cP cF cfv vw cv cD cbl cfv co vv cv wss wa cc0 vz
      cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw cv cD cbl cfv co
      cima wss wa cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex vz cr cC
      cme wcel cX cY cF wf cP cX wcel wa wa cP cF cfv vw cv cD cbl cfv co vv cv
      wss wa vz cv cr wcel wa cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv
      cP cF cfv vw cv cD cbl cfv co cima wss cP vu cv wcel cF vu cv cima vv cv
      wss wa vu cJ wrex cC cme wcel cX cY cF wf cP cX wcel wa wa cP cF cfv vw
      cv cD cbl cfv co vv cv wss wa vz cv cr wcel wa cc0 vz cv clt wbr wa cP vz
      cv cC cbl cfv co cF ccnv cP cF cfv vw cv cD cbl cfv co cima wss cF cP vz
      cv cC cbl cfv co cima cP cF cfv vw cv cD cbl cfv co wss cP vu cv wcel cF
      vu cv cima vv cv wss wa vu cJ wrex cC cme wcel cX cY cF wf cP cX wcel wa
      wa vz cv cr wcel cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP cF
      cfv vw cv cD cbl cfv co wss cP vz cv cC cbl cfv co cF ccnv cP cF cfv vw
      cv cD cbl cfv co cima wss wb cP cF cfv vw cv cD cbl cfv co vv cv wss cF
      wfun cP vz cv cC cbl cfv co cF cdm wss cF cP vz cv cC cbl cfv co cima cP
      cF cfv vw cv cD cbl cfv co wss cP vz cv cC cbl cfv co cF ccnv cP cF cfv
      vw cv cD cbl cfv co cima wss wb cC cme wcel cX cY cF wf cP cX wcel wa wa
      vz cv cr wcel wa cc0 vz cv clt wbr wa cP vz cv cC cbl cfv co cP cF cfv vw
      cv cD cbl cfv co cF funimass3 cC cme wcel cX cY cF wf cP cX wcel wa wa cF
      wfun vz cv cr wcel cc0 vz cv clt wbr cX cY cF wf cF wfun cC cme wcel cP
      cX wcel cX cY cF ffun ad2antrl ad2antrr cC cme wcel cX cY cF wf cP cX
      wcel wa wa vz cv cr wcel wa cc0 vz cv clt wbr wa cP vz cv cC cbl cfv co
      cX cF cdm cC cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr wcel cc0 vz
      cv clt wbr cP vz cv cC cbl cfv co cX wss cC cme wcel cP cX wcel vz cv cr
      wcel cc0 vz cv clt wbr wa cP vz cv cC cbl cfv co cX wss cX cY cF wf cC cP
      vz cv cX metcn.1 blssm adantlrl anassrs cC cme wcel cX cY cF wf cP cX
      wcel wa wa cF cdm cX wceq vz cv cr wcel cc0 vz cv clt wbr cX cY cF wf cF
      cdm cX wceq cC cme wcel cP cX wcel cX cY cF fdm ad2antrl ad2antrr
      sseqtr4d sylanc adantllr cC cme wcel cX cY cF wf cP cX wcel wa wa cP cF
      cfv vw cv cD cbl cfv co vv cv wss wa vz cv cr wcel wa cc0 vz cv clt wbr
      wa cF cP vz cv cC cbl cfv co cima cP cF cfv vw cv cD cbl cfv co wss cP vu
      cv wcel cF vu cv cima vv cv wss wa vu cJ wrex cP vz cv cC cbl cfv co cJ
      wcel cP cP vz cv cC cbl cfv co wcel cF cP vz cv cC cbl cfv co cima vv cv
      wss wa cP vu cv wcel cF vu cv cima vv cv wss wa vu cJ wrex cC cme wcel cX
      cY cF wf cP cX wcel wa wa cP cF cfv vw cv cD cbl cfv co vv cv wss wa vz
      cv cr wcel wa cc0 vz cv clt wbr wa cF cP vz cv cC cbl cfv co cima cP cF
      cfv vw cv cD cbl cfv co wss wa cP vu cv wcel cF vu cv cima vv cv wss wa
      cP cP vz cv cC cbl cfv co wcel cF cP vz cv cC cbl cfv co cima vv cv wss
      wa vu cP vz cv cC cbl cfv co cJ vu cv cP vz cv cC cbl cfv co wceq cP vu
      cv wcel cP cP vz cv cC cbl cfv co wcel cF vu cv cima vv cv wss cF cP vz
      cv cC cbl cfv co cima vv cv wss vu cv cP vz cv cC cbl cfv co cP eleq2 vu
      cv cP vz cv cC cbl cfv co wceq cF vu cv cima cF cP vz cv cC cbl cfv co
      cima vv cv vu cv cP vz cv cC cbl cfv co cF imaeq2 sseq1d anbi12d rcla4ev
      cC cme wcel cX cY cF wf cP cX wcel wa wa cP cF cfv vw cv cD cbl cfv co vv
      cv wss wa vz cv cr wcel wa cc0 vz cv clt wbr wa cP vz cv cC cbl cfv co cJ
      wcel cF cP vz cv cC cbl cfv co cima cP cF cfv vw cv cD cbl cfv co wss cC
      cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr wcel cc0 vz cv clt wbr cP
      vz cv cC cbl cfv co cJ wcel cP cF cfv vw cv cD cbl cfv co vv cv wss cC
      cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr wcel cc0 vz cv clt wbr cP
      vz cv cC cbl cfv co cJ wcel cC cme wcel cP cX wcel vz cv cr wcel cc0 vz
      cv clt wbr wa cP vz cv cC cbl cfv co cJ wcel cX cY cF wf cC cP vz cv cJ
      cX metcn.1 metcn.2 blopn adantlrl anassrs adantllr adantr cC cme wcel cX
      cY cF wf cP cX wcel wa wa cP cF cfv vw cv cD cbl cfv co vv cv wss wa vz
      cv cr wcel wa cc0 vz cv clt wbr wa cF cP vz cv cC cbl cfv co cima cP cF
      cfv vw cv cD cbl cfv co wss wa cP cP vz cv cC cbl cfv co wcel cF cP vz cv
      cC cbl cfv co cima vv cv wss cC cme wcel cX cY cF wf cP cX wcel wa wa cP
      cF cfv vw cv cD cbl cfv co vv cv wss wa vz cv cr wcel wa cc0 vz cv clt
      wbr wa cP cP vz cv cC cbl cfv co wcel cF cP vz cv cC cbl cfv co cima cP
      cF cfv vw cv cD cbl cfv co wss cC cme wcel cX cY cF wf cP cX wcel wa wa
      vz cv cr wcel cc0 vz cv clt wbr cP cP vz cv cC cbl cfv co wcel cP cF cfv
      vw cv cD cbl cfv co vv cv wss cC cme wcel cX cY cF wf cP cX wcel wa wa vz
      cv cr wcel cc0 vz cv clt wbr cP cP vz cv cC cbl cfv co wcel cC cme wcel
      cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa cP cP vz cv cC cbl cfv co
      wcel cX cY cF wf cC cP vz cv cX metcn.1 blcntr adantlrl anassrs adantllr
      adantr cC cme wcel cX cY cF wf cP cX wcel wa wa cP cF cfv vw cv cD cbl
      cfv co vv cv wss wa cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP
      cF cfv vw cv cD cbl cfv co wss cF cP vz cv cC cbl cfv co cima vv cv wss
      vz cv cr wcel cP cF cfv vw cv cD cbl cfv co vv cv wss cc0 vz cv clt wbr
      cF cP vz cv cC cbl cfv co cima cP cF cfv vw cv cD cbl cfv co wss cF cP vz
      cv cC cbl cfv co cima vv cv wss cC cme wcel cX cY cF wf cP cX wcel wa wa
      cP cF cfv vw cv cD cbl cfv co vv cv wss cF cP vz cv cC cbl cfv co cima cP
      cF cfv vw cv cD cbl cfv co wss cF cP vz cv cC cbl cfv co cima vv cv wss
      cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP cF cfv vw cv cD cbl
      cfv co wss cP cF cfv vw cv cD cbl cfv co vv cv wss cF cP vz cv cC cbl cfv
      co cima vv cv wss cF cP vz cv cC cbl cfv co cima cP cF cfv vw cv cD cbl
      cfv co vv cv sstr ancoms adantlr adantlll adantllr jca sylanc ex sylbird
      expimpd r19.23adva adantlr adantllr adantrl mpd ex r19.23adva adantllr
      ad2antrr mpd ex r19.21aiva impbida vy vz vw cC cD cP cF cJ cK cX cY
      metcn.1 metcn.2 metcn.3 metcn.4 metcnplem bitrd exp43 com34 3imp pm5.32d
      3bitrd $.
      $( [16-Nov-2007] $) $( [11-May-2007] $)

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous at point ` P ` .  The distance arguments are swapped compared
       to ~ metcnp (and Munkres' ~ metcn ) for compatibility with ~ df-lm .
       Definition 1.3-3 of [Kreyszig] p. 20. $)
    metcnp2 $p |- ( ( C e. Met /\ D e. Met /\ P e. X ) ->
                ( F e. ( ( J CnP K ) ` P ) <->
          ( F : X --> Y /\ A. y e. RR ( 0 < y -> E. z e. RR ( 0 < z /\
      A. w e. X ( ( w C P ) < z -> ( ( F ` w ) D ( F ` P ) ) < y ) ) ) ) ) ) $=
      cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX cY
      cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP
      cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy
      cr wral wa cX cY cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv cP cC co
      vz cv clt wbr vw cv cF cfv cP cF cfv cD co vy cv clt wbr wi vw cX wral wa
      vz cr wrex wi vy cr wral wa vy vz vw cC cD cP cF cJ cK cX cY metcn.1
      metcn.2 metcn.3 metcn.4 metcnp cC cme wcel cD cme wcel cP cX wcel w3a cX
      cY cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr
      cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi
      vy cr wral cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv clt
      wbr vw cv cF cfv cP cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr
      wrex wi vy cr wral cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa
      cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi cc0
      vy cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv
      cP cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr cC cme
      wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cc0 vz cv clt wbr cP vw cv
      cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX
      wral wa vz cr wrex cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv
      cF cfv cP cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex cc0 vy
      cv clt wbr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cc0 vz
      cv clt wbr cP vw cv cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy
      cv clt wbr wi vw cX wral wa cc0 vz cv clt wbr vw cv cP cC co vz cv clt
      wbr vw cv cF cfv cP cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr cC
      cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cP vw cv cC co vz cv
      clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral vw cv cP
      cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vy cv clt wbr wi vw cX
      wral cc0 vz cv clt wbr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf
      wa cP vw cv cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vy cv
      clt wbr wi vw cX cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vw
      cv cX wcel wa cP vw cv cC co vz cv clt wbr vw cv cP cC co vz cv clt wbr
      cP cF cfv vw cv cF cfv cD co vy cv clt wbr vw cv cF cfv cP cF cfv cD co
      vy cv clt wbr cC cme wcel cD cme wcel cP cX wcel w3a vw cv cX wcel cP vw
      cv cC co vz cv clt wbr vw cv cP cC co vz cv clt wbr wb cX cY cF wf cC cme
      wcel cP cX wcel vw cv cX wcel cP vw cv cC co vz cv clt wbr vw cv cP cC co
      vz cv clt wbr wb cD cme wcel cC cme wcel cP cX wcel wa vw cv cX wcel wa
      cP vw cv cC co vw cv cP cC co vz cv clt cC cme wcel cP cX wcel vw cv cX
      wcel cP vw cv cC co vw cv cP cC co wceq cP vw cv cC cX metcn.1 metsym
      3expa breq1d 3adantl2 adantlr cC cme wcel cD cme wcel cP cX wcel w3a cX
      cY cF wf wa vw cv cX wcel wa cP cF cfv vw cv cF cfv cD co vw cv cF cfv cP
      cF cfv cD co vy cv clt cD cme wcel cP cF cfv cY wcel vw cv cF cfv cY wcel
      cP cF cfv vw cv cF cfv cD co vw cv cF cfv cP cF cfv cD co wceq cC cme
      wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vw cv cX wcel wa cP cF cfv
      vw cv cF cfv cD cY metcn.3 metsym cC cme wcel cD cme wcel cP cX wcel w3a
      cD cme wcel cX cY cF wf vw cv cX wcel cC cme wcel cD cme wcel cP cX wcel
      3simp2 ad2antrr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cP
      cF cfv cY wcel vw cv cX wcel cP cX wcel cC cme wcel cX cY cF wf cP cF cfv
      cY wcel cD cme wcel cX cY cF wf cP cX wcel cP cF cfv cY wcel cX cY cP cF
      ffvelrn ancoms 3ad2antl3 adantr cX cY cF wf vw cv cX wcel vw cv cF cfv cY
      wcel cC cme wcel cD cme wcel cP cX wcel w3a cX cY vw cv cF ffvelrn
      adantll syl3anc breq1d imbi12d ralbidva anbi2d rexbidv imbi2d ralbidv
      pm5.32da bitrd $.
      $( [17-Nov-2007] $) $( [4-Jun-2007] $)

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous.  Theorem 10.1 of [Munkres] p. 127.  The second biconditional
       argument says that for every positive "epsilon" ` y ` there is a
       positive "delta" ` z ` such that a distance less than delta in ` C `
       maps to a distance less than epsilon in ` D ` . $)
    metcn $p |- ( ( C e. Met /\ D e. Met ) ->
                ( F e. ( J Cn K ) <-> ( F : X --> Y /\
                A. x e. X A. y e. RR ( 0 < y -> E. z e. RR ( 0 < z /\
      A. w e. X ( ( x C w ) < z -> ( ( F ` x ) D ( F ` w ) ) < y ) ) ) ) ) ) $=
      cC cme wcel cD cme wcel wa cF cJ cK ccn co wcel cJ cuni cK cuni cF wf cF
      vx cv cJ cK ccnp co cfv wcel vx cJ cuni wral wa cJ cuni cK cuni cF wf cc0
      vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr
      wral vx cJ cuni wral wa cX cY cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr
      vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cX wral wa cJ ctop wcel
      cK ctop wcel cF cJ cK ccn co wcel cJ cuni cK cuni cF wf cF vx cv cJ cK
      ccnp co cfv wcel vx cJ cuni wral wa wb cC cme wcel cD cme wcel cJ ctop
      wcel cK ctop wcel wa cF cJ cK ccn co wcel cJ cuni cK cuni cF wf cF cJ cK
      ccn co wcel wa cJ cuni cK cuni cF wf cF vx cv cJ cK ccnp co cfv wcel vx
      cJ cuni wral wa cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cJ cuni
      cK cuni cF wf cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cJ cuni cK
      cuni cF wf cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid cnf 3expia
      pm4.71rd cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf cF cJ cK ccn
      co wcel cF vx cv cJ cK ccnp co cfv wcel vx cJ cuni wral cJ ctop wcel cK
      ctop wcel cJ cuni cK cuni cF wf cF cJ cK ccn co wcel cF vx cv cJ cK ccnp
      co cfv wcel vx cJ cuni wral wb vx cF cJ cK cJ cuni cK cuni cJ cuni eqid
      cK cuni eqid cncnp 3expa pm5.32da bitrd cC cJ metcn.2 opntop cD cK
      metcn.4 opntop syl2an cC cme wcel cD cme wcel wa cJ cuni cK cuni cF wf cF
      vx cv cJ cK ccnp co cfv wcel vx cJ cuni wral cc0 vy cv clt wbr cc0 vz cv
      clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co
      vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cJ cuni wral
      cC cme wcel cD cme wcel wa cJ cuni cK cuni cF wf wa cF vx cv cJ cK ccnp
      co cfv wcel cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv
      clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz
      cr wrex wi vy cr wral vx cJ cuni cC cme wcel cD cme wcel wa vx cv cJ cuni
      wcel cJ cuni cK cuni cF wf cF vx cv cJ cK ccnp co cfv wcel cc0 vy cv clt
      wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral wb
      cC cme wcel cD cme wcel wa vx cv cJ cuni wcel wa cJ cuni cK cuni cF wf cF
      vx cv cJ cK ccnp co cfv wcel cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw
      cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi
      vw cX wral wa vz cr wrex wi vy cr wral wb cC cme wcel cD cme wcel wa vx
      cv cJ cuni wcel wa cJ cuni cK cuni cF wf cF vx cv cJ cK ccnp co cfv wcel
      wa cJ cuni cK cuni cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv
      cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw
      cX wral wa vz cr wrex wi vy cr wral wa wb cJ cuni cK cuni cF wf cF vx cv
      cJ cK ccnp co cfv wcel cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC
      co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX
      wral wa vz cr wrex wi vy cr wral wb wi cC cme wcel cD cme wcel wa vx cv
      cJ cuni wcel wa cJ cuni cK cuni cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr
      vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cX wral wa vz cr wrex wi vy cr wral wa cX cY cF wf cc0 vy cv
      clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw
      cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral
      wa cF vx cv cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cF vx cv cJ cK
      ccnp co cfv wcel wa cC cme wcel cD cme wcel wa vx cv cJ cuni wcel wa cJ
      cuni cK cuni cF wf cX cY cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv
      vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr
      wi vw cX wral wa vz cr wrex wi vy cr wral cC cme wcel cD cme wcel wa cJ
      cuni cK cuni cF wf cX cY cF wf wb vx cv cJ cuni wcel cJ cuni cX wceq cK
      cuni cY wceq cJ cuni cK cuni cF wf cX cY cF wf wb cC cme wcel cD cme wcel
      cJ cuni cK cuni cX cY cF feq23 cC cJ cX metcn.1 metcn.2 uniopn2 cD cK cY
      metcn.3 metcn.4 uniopn2 syl2an adantr anbi1d cC cme wcel cD cme wcel wa
      vx cv cJ cuni wcel vx cv cX wcel cF vx cv cJ cK ccnp co cfv wcel cX cY cF
      wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi
      vy cr wral wa wb cC cme wcel cD cme wcel wa vx cv cJ cuni wcel vx cv cX
      wcel cC cme wcel cD cme wcel wa cJ cuni cX vx cv cC cme wcel cJ cuni cX
      wceq cD cme wcel cC cJ cX metcn.1 metcn.2 uniopn2 adantr eleq2d biimpa cC
      cme wcel cD cme wcel vx cv cX wcel cF vx cv cJ cK ccnp co cfv wcel cX cY
      cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex
      wi vy cr wral wa wb vy vz vw cC cD vx cv cF cJ cK cX cY metcn.1 metcn.2
      metcn.3 metcn.4 metcnp 3expa syldan cC cme wcel cD cme wcel wa vx cv cJ
      cuni wcel cF vx cv cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cF vx cv
      cJ cK ccnp co cfv wcel wa wb cJ ctop wcel cK ctop wcel vx cv cJ cuni wcel
      cF vx cv cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cF vx cv cJ cK ccnp
      co cfv wcel wa wb wi cC cme wcel cD cme wcel cJ ctop wcel cK ctop wcel vx
      cv cJ cuni wcel cF vx cv cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cF
      vx cv cJ cK ccnp co cfv wcel wa wb cJ ctop wcel cK ctop wcel vx cv cJ
      cuni wcel w3a cF vx cv cJ cK ccnp co cfv wcel cJ cuni cK cuni cF wf cJ
      ctop wcel cK ctop wcel vx cv cJ cuni wcel w3a cF vx cv cJ cK ccnp co cfv
      wcel cJ cuni cK cuni cF wf vx cv cF cJ cK cJ cuni cK cuni cJ cuni eqid cK
      cuni eqid cnpf ex pm4.71rd 3expia cC cJ metcn.2 opntop cD cK metcn.4
      opntop syl2an imp 3bitr2rd cJ cuni cK cuni cF wf cF vx cv cJ cK ccnp co
      cfv wcel cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt
      wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr
      wrex wi vy cr wral pm5.32 sylibr imp an1rs ralbidva pm5.32da cC cme wcel
      cD cme wcel wa cJ cuni cK cuni cF wf cX cY cF wf cc0 vy cv clt wbr cc0 vz
      cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD
      co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cJ cuni
      wral cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex
      wi vy cr wral vx cX wral cJ cuni cX wceq cK cuni cY wceq cJ cuni cK cuni
      cF wf cX cY cF wf wb cC cme wcel cD cme wcel cJ cuni cK cuni cX cY cF
      feq23 cC cJ cX metcn.1 metcn.2 uniopn2 cD cK cY metcn.3 metcn.4 uniopn2
      syl2an cC cme wcel cD cme wcel wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cJ cuni cX cC cme wcel
      cJ cuni cX wceq cD cme wcel cC cJ cX metcn.1 metcn.2 uniopn2 adantr
      raleq1d anbi12d 3bitrd $.
      $( [16-Nov-2007] $) $( [15-May-2007] $)

    ${
      $d w x y z A $.  $d x y w z C $.  $d x y w z D $.  $d w z K $.
      $( MAY BE REVISED - delete this if not used $)
      $( Epsilon-delta property of a continuous metric space function, with
         function arguments as in ~ metcnp . $)
      metcnpi $p |- ( ( ( C e. Met /\ D e. Met /\ P e. X ) /\ ( F e.
           ( ( J CnP K ) ` P ) /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
        A. y e. X ( ( P C y ) < x -> ( ( F ` P ) D ( F ` y ) ) < A ) ) ) $=
        cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA
        cr wcel cc0 cA clt wbr cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr
        cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex cC
        cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX cY
        cF wf cc0 vz cv clt wbr cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr
        cP cF cfv vy cv cF cfv cD co vz cv clt wbr wi vy cX wral wa vx cr wrex
        wi vz cr wral wa cA cr wcel cc0 cA clt wbr cc0 vx cv clt wbr cP vy cv
        cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX
        wral wa vx cr wrex wi wi vz vx vy cC cD cP cF cJ cK cX cY metcn.1
        metcn.2 metcn.3 metcn.4 metcnp cc0 vz cv clt wbr cc0 vx cv clt wbr cP
        vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co vz cv clt wbr wi
        vy cX wral wa vx cr wrex wi vz cr wral cA cr wcel cc0 cA clt wbr cc0 vx
        cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA
        clt wbr wi vy cX wral wa vx cr wrex wi wi cX cY cF wf cc0 vz cv clt wbr
        cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
        cD co vz cv clt wbr wi vy cX wral wa vx cr wrex wi cc0 cA clt wbr cc0
        vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co
        cA clt wbr wi vy cX wral wa vx cr wrex wi vz cA cr vz cv cA wceq cc0 vz
        cv clt wbr cc0 cA clt wbr cc0 vx cv clt wbr cP vy cv cC co vx cv clt
        wbr cP cF cfv vy cv cF cfv cD co vz cv clt wbr wi vy cX wral wa vx cr
        wrex cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF
        cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex vz cv cA cc0 clt breq2
        vz cv cA wceq cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv
        vy cv cF cfv cD co vz cv clt wbr wi vy cX wral wa cc0 vx cv clt wbr cP
        vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy
        cX wral wa vx cr vz cv cA wceq cP vy cv cC co vx cv clt wbr cP cF cfv
        vy cv cF cfv cD co vz cv clt wbr wi vy cX wral cP vy cv cC co vx cv clt
        wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral cc0 vx cv clt
        wbr vz cv cA wceq cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
        cD co vz cv clt wbr wi cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF
        cfv cD co cA clt wbr wi vy cX vz cv cA wceq cP cF cfv vy cv cF cfv cD
        co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr cP vy cv cC co
        vx cv clt wbr vz cv cA cP cF cfv vy cv cF cfv cD co clt breq2 imbi2d
        ralbidv anbi2d rexbidv imbi12d rcla4cv adantl syl6bi 3imp2 $.
        $( [2-Jan-2008] $) $( [17-Dec-2007] $)

      $( MAY BE REVISED - delete this if not used $)
      $( Epsilon-delta property of a continuous metric space function, with
         swapped distance function arguments as in ~ metcnp2 . $)
      metcnpi2 $p |- ( ( ( C e. Met /\ D e. Met /\ P e. X ) /\ ( F e.
           ( ( J CnP K ) ` P ) /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
        A. y e. X ( ( y C P ) < x -> ( ( F ` y ) D ( F ` P ) ) < A ) ) ) $=
        cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA
        cr wcel cc0 cA clt wbr cc0 vx cv clt wbr vy cv cP cC co vx cv clt wbr
        vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex cC
        cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX cY
        cF wf cc0 vz cv clt wbr cc0 vx cv clt wbr vy cv cP cC co vx cv clt wbr
        vy cv cF cfv cP cF cfv cD co vz cv clt wbr wi vy cX wral wa vx cr wrex
        wi vz cr wral wa cA cr wcel cc0 cA clt wbr cc0 vx cv clt wbr vy cv cP
        cC co vx cv clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX
        wral wa vx cr wrex wi wi vz vx vy cC cD cP cF cJ cK cX cY metcn.1
        metcn.2 metcn.3 metcn.4 metcnp2 cc0 vz cv clt wbr cc0 vx cv clt wbr vy
        cv cP cC co vx cv clt wbr vy cv cF cfv cP cF cfv cD co vz cv clt wbr wi
        vy cX wral wa vx cr wrex wi vz cr wral cA cr wcel cc0 cA clt wbr cc0 vx
        cv clt wbr vy cv cP cC co vx cv clt wbr vy cv cF cfv cP cF cfv cD co cA
        clt wbr wi vy cX wral wa vx cr wrex wi wi cX cY cF wf cc0 vz cv clt wbr
        cc0 vx cv clt wbr vy cv cP cC co vx cv clt wbr vy cv cF cfv cP cF cfv
        cD co vz cv clt wbr wi vy cX wral wa vx cr wrex wi cc0 cA clt wbr cc0
        vx cv clt wbr vy cv cP cC co vx cv clt wbr vy cv cF cfv cP cF cfv cD co
        cA clt wbr wi vy cX wral wa vx cr wrex wi vz cA cr vz cv cA wceq cc0 vz
        cv clt wbr cc0 cA clt wbr cc0 vx cv clt wbr vy cv cP cC co vx cv clt
        wbr vy cv cF cfv cP cF cfv cD co vz cv clt wbr wi vy cX wral wa vx cr
        wrex cc0 vx cv clt wbr vy cv cP cC co vx cv clt wbr vy cv cF cfv cP cF
        cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex vz cv cA cc0 clt breq2
        vz cv cA wceq cc0 vx cv clt wbr vy cv cP cC co vx cv clt wbr vy cv cF
        cfv cP cF cfv cD co vz cv clt wbr wi vy cX wral wa cc0 vx cv clt wbr vy
        cv cP cC co vx cv clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy
        cX wral wa vx cr vz cv cA wceq vy cv cP cC co vx cv clt wbr vy cv cF
        cfv cP cF cfv cD co vz cv clt wbr wi vy cX wral vy cv cP cC co vx cv
        clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral cc0 vx cv
        clt wbr vz cv cA wceq vy cv cP cC co vx cv clt wbr vy cv cF cfv cP cF
        cfv cD co vz cv clt wbr wi vy cv cP cC co vx cv clt wbr vy cv cF cfv cP
        cF cfv cD co cA clt wbr wi vy cX vz cv cA wceq vy cv cF cfv cP cF cfv
        cD co vz cv clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr vy cv cP cC
        co vx cv clt wbr vz cv cA vy cv cF cfv cP cF cfv cD co clt breq2 imbi2d
        ralbidv anbi2d rexbidv imbi12d rcla4cv adantl syl6bi 3imp2 $.
        $( [8-Feb-2008] $) $( [16-Dec-2007] $)

      $( MAY BE REVISED - delete this if not used $)
      $( Epsilon-delta property of a metric space function continuous at
         ` P ` .  A variation of ~ metcnpi2 with non-strict ordering. $)
      metcnpi3 $p |- ( ( ( C e. Met /\ D e. Met /\ P e. X ) /\ ( F e.
           ( ( J CnP K ) ` P ) /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
        A. y e. X ( ( y C P ) <_ x -> ( ( F ` y ) D ( F ` P ) ) <_ A ) ) ) $=
        cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA
        cr wcel cc0 cA clt wbr w3a wa cc0 vz cv clt wbr vy cv cP cC co vz cv
        clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral wa vz cr
        wrex cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cF cfv cP cF
        cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex vz vy cA cC cD cP cF
        cJ cK cX cY metcn.1 metcn.2 metcn.3 metcn.4 metcnpi2 cC cme wcel cD cme
        wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt
        wbr cc0 vz cv clt wbr vy cv cP cC co vz cv clt wbr vy cv cF cfv cP cF
        cfv cD co cA clt wbr wi vy cX wral wa vz cr wrex cc0 vx cv clt wbr vy
        cv cP cC co vx cv cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy
        cX wral wa vx cr wrex wi cC cme wcel cD cme wcel cP cX wcel w3a cF cP
        cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt wbr cc0 vz cv clt wbr vy
        cv cP cC co vz cv clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy
        cX wral wa vz cr wrex cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy
        cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex wi wi
        wi cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel
        cX cY cF wf cA cr wcel cc0 cA clt wbr cc0 vz cv clt wbr vy cv cP cC co
        vz cv clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral wa
        vz cr wrex cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cF cfv
        cP cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex wi wi wi cC cD
        cP cF cJ cK cX cY metcn.1 metcn.3 metcn.2 metcn.4 metcnpf cC cme wcel
        cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr cc0
        vz cv clt wbr vy cv cP cC co vz cv clt wbr vy cv cF cfv cP cF cfv cD co
        cA clt wbr wi vy cX wral wa vz cr wrex cc0 vx cv clt wbr vy cv cP cC co
        vx cv cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX wral wa
        vx cr wrex wi cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA
        cr wcel cc0 cA clt wbr wa wa cc0 vz cv clt wbr vy cv cP cC co vz cv clt
        wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral wa cc0 vx cv
        clt wbr vy cv cP cC co vx cv cle wbr vy cv cF cfv cP cF cfv cD co cA
        cle wbr wi vy cX wral wa vx cr wrex vz cr cC cme wcel cD cme wcel cP cX
        wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa vz cv cr wcel
        cc0 vz cv clt wbr vy cv cP cC co vz cv clt wbr vy cv cF cfv cP cF cfv
        cD co cA clt wbr wi vy cX wral wa cc0 vx cv clt wbr vy cv cP cC co vx
        cv cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX wral wa vx
        cr wrex vz cv c2 cdiv co cr wcel cc0 vz cv c2 cdiv co clt wbr vy cv cP
        cC co vz cv c2 cdiv co cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr
        wi vy cX wral wa cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv
        cF cfv cP cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex cC cme
        wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt
        wbr wa wa vz cv cr wcel cc0 vz cv clt wbr vy cv cP cC co vz cv clt wbr
        vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral wa wa wa cc0 vx
        cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cF cfv cP cF cfv cD co cA
        cle wbr wi vy cX wral wa cc0 vz cv c2 cdiv co clt wbr vy cv cP cC co vz
        cv c2 cdiv co cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX
        wral wa vx vz cv c2 cdiv co cr vx cv vz cv c2 cdiv co wceq cc0 vx cv
        clt wbr cc0 vz cv c2 cdiv co clt wbr vy cv cP cC co vx cv cle wbr vy cv
        cF cfv cP cF cfv cD co cA cle wbr wi vy cX wral vy cv cP cC co vz cv c2
        cdiv co cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX wral
        vx cv vz cv c2 cdiv co cc0 clt breq2 vx cv vz cv c2 cdiv co wceq vy cv
        cP cC co vx cv cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cv
        cP cC co vz cv c2 cdiv co cle wbr vy cv cF cfv cP cF cfv cD co cA cle
        wbr wi vy cX vx cv vz cv c2 cdiv co wceq vy cv cP cC co vx cv cle wbr
        vy cv cP cC co vz cv c2 cdiv co cle wbr vy cv cF cfv cP cF cfv cD co cA
        cle wbr vx cv vz cv c2 cdiv co vy cv cP cC co cle breq2 imbi1d ralbidv
        anbi12d rcla4ev vz cv cr wcel vz cv c2 cdiv co cr wcel cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        cc0 vz cv clt wbr vy cv cP cC co vz cv clt wbr vy cv cF cfv cP cF cfv
        cD co cA clt wbr wi vy cX wral wa vz cv rehalfcl ad2antrl cC cme wcel
        cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa
        wa vz cv cr wcel cc0 vz cv clt wbr vy cv cP cC co vz cv clt wbr vy cv
        cF cfv cP cF cfv cD co cA clt wbr wi vy cX wral cc0 vz cv c2 cdiv co
        clt wbr vy cv cP cC co vz cv c2 cdiv co cle wbr vy cv cF cfv cP cF cfv
        cD co cA cle wbr wi vy cX wral wa cC cme wcel cD cme wcel cP cX wcel
        w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa vz cv cr wcel cc0 vz
        cv clt wbr vy cv cP cC co vz cv clt wbr vy cv cF cfv cP cF cfv cD co cA
        clt wbr wi vy cX wral cc0 vz cv c2 cdiv co clt wbr vy cv cP cC co vz cv
        c2 cdiv co cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX
        wral wa wi cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr
        wcel cc0 cA clt wbr wa wa vz cv cr wcel cc0 vz cv clt wbr wa wa vy cv
        cP cC co vz cv clt wbr vy cv cF cfv cP cF cfv cD co cA clt wbr wi vy cX
        wral vy cv cP cC co vz cv c2 cdiv co cle wbr vy cv cF cfv cP cF cfv cD
        co cA cle wbr wi vy cX wral cc0 vz cv c2 cdiv co clt wbr cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        vz cv cr wcel cc0 vz cv clt wbr wa wa vy cv cP cC co vz cv clt wbr vy
        cv cF cfv cP cF cfv cD co cA clt wbr wi vy cv cP cC co vz cv c2 cdiv co
        cle wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi vy cX cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        vz cv cr wcel cc0 vz cv clt wbr wa wa vy cv cX wcel wa vy cv cP cC co
        vz cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt wbr vy cv cF cfv cP
        cF cfv cD co cA clt wbr vy cv cF cfv cP cF cfv cD co cA cle wbr cC cme
        wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt
        wbr wa wa vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX wcel vy cv cP cC
        co vz cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt wbr wi cC cme wcel
        cD cme wcel cP cX wcel w3a vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX
        wcel vy cv cP cC co vz cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt
        wbr wi wi wi cX cY cF wf cA cr wcel cc0 cA clt wbr wa cC cme wcel cP cX
        wcel vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX wcel vy cv cP cC co vz
        cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt wbr wi wi wi cD cme wcel
        cC cme wcel cP cX wcel wa vy cv cX wcel vz cv cr wcel cc0 vz cv clt wbr
        wa vy cv cP cC co vz cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt wbr
        wi cC cme wcel cP cX wcel vy cv cX wcel vz cv cr wcel cc0 vz cv clt wbr
        wa vy cv cP cC co vz cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt wbr
        wi wi cC cme wcel cP cX wcel vy cv cX wcel w3a vy cv cP cC co cr wcel
        vz cv cr wcel cc0 vz cv clt wbr wa vy cv cP cC co vz cv c2 cdiv co cle
        wbr vy cv cP cC co vz cv clt wbr wi wi cC cme wcel vy cv cX wcel cP cX
        wcel vy cv cP cC co cr wcel vy cv cP cC cX metcn.1 metcl 3com23 vy cv
        cP cC co cr wcel vz cv cr wcel cc0 vz cv clt wbr wa vy cv cP cC co vz
        cv c2 cdiv co cle wbr vy cv cP cC co vz cv clt wbr wi vy cv cP cC co cr
        wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vy cv cP cC co vz cv c2 cdiv
        co cle wbr vz cv c2 cdiv co vz cv clt wbr vy cv cP cC co vz cv clt wbr
        vz cv cr wcel cc0 vz cv clt wbr wa vz cv c2 cdiv co vz cv clt wbr vy cv
        cP cC co cr wcel vz cv cr wcel cc0 vz cv clt wbr vz cv c2 cdiv co vz cv
        clt wbr vz cv halfpos biimpa adantl vy cv cP cC co cr wcel vz cv cr
        wcel vy cv cP cC co vz cv c2 cdiv co cle wbr vz cv c2 cdiv co vz cv clt
        wbr wa vy cv cP cC co vz cv clt wbr wi cc0 vz cv clt wbr vy cv cP cC co
        cr wcel vz cv c2 cdiv co cr wcel vz cv cr wcel vy cv cP cC co vz cv c2
        cdiv co cle wbr vz cv c2 cdiv co vz cv clt wbr wa vy cv cP cC co vz cv
        clt wbr wi vy cv cP cC co cr wcel vz cv cr wcel wa vy cv cP cC co vz cv
        c2 cdiv co vz cv lelttr vy cv cP cC co cr wcel vz cv cr wcel pm3.26 vz
        cv cr wcel vz cv c2 cdiv co cr wcel vy cv cP cC co cr wcel vz cv
        rehalfcl adantl vy cv cP cC co cr wcel vz cv cr wcel pm3.27 syl3anc
        adantrr mpan2d ex syl 3expia com23 3adant2 ad2antrr imp31 cC cme wcel
        cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa
        wa vy cv cX wcel vy cv cF cfv cP cF cfv cD co cA clt wbr vy cv cF cfv
        cP cF cfv cD co cA cle wbr wi vz cv cr wcel cc0 vz cv clt wbr wa vy cv
        cF cfv cP cF cfv cD co cr wcel cA cr wcel vy cv cF cfv cP cF cfv cD co
        cA clt wbr vy cv cF cfv cP cF cfv cD co cA cle wbr wi cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        vy cv cX wcel wa vy cv cF cfv cP cF cfv cD co cA ltle cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa vy cv cX wcel vy cv cF cfv cP cF
        cfv cD co cr wcel cA cr wcel cc0 cA clt wbr wa cC cme wcel cD cme wcel
        cP cX wcel w3a cX cY cF wf vy cv cX wcel vy cv cF cfv cP cF cfv cD co
        cr wcel cD cme wcel cP cX wcel cX cY cF wf vy cv cX wcel vy cv cF cfv
        cP cF cfv cD co cr wcel wi wi cC cme wcel cD cme wcel cP cX wcel cX cY
        cF wf vy cv cX wcel vy cv cF cfv cP cF cfv cD co cr wcel wi wi cD cme
        wcel cX cY cF wf cP cX wcel vy cv cX wcel vy cv cF cfv cP cF cfv cD co
        cr wcel wi cD cme wcel cX cY cF wf cP cX wcel vy cv cX wcel vy cv cF
        cfv cP cF cfv cD co cr wcel cD cme wcel vy cv cF cfv cY wcel cP cF cfv
        cY wcel wa vy cv cF cfv cP cF cfv cD co cr wcel cX cY cF wf cP cX wcel
        vy cv cX wcel wa wa cD cme wcel vy cv cF cfv cY wcel cP cF cfv cY wcel
        vy cv cF cfv cP cF cfv cD co cr wcel vy cv cF cfv cP cF cfv cD cY
        metcn.3 metcl 3expb cX cY cF wf vy cv cX wcel cP cX wcel vy cv cF cfv
        cY wcel cP cF cfv cY wcel wa cX cY cF wf vy cv cX wcel cP cX wcel vy cv
        cF cfv cY wcel cP cF cfv cY wcel wa cX cY cF wf vy cv cX wcel wa vy cv
        cF cfv cY wcel cX cY cF wf cP cX wcel wa cP cF cfv cY wcel cX cY vy cv
        cF ffvelrn cX cY cP cF ffvelrn anim12i anandis ancom2s sylan2 exp45
        com23 imp 3adant1 imp31 adantlr cC cme wcel cD cme wcel cP cX wcel w3a
        cX cY cF wf wa cA cr wcel cc0 cA clt wbr vy cv cX wcel simplrl sylanc
        adantlr imim12d r19.20dva vz cv cr wcel cc0 vz cv clt wbr wa cc0 vz cv
        c2 cdiv co clt wbr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf
        wa cA cr wcel cc0 cA clt wbr wa wa vz cv cr wcel cc0 vz cv clt wbr cc0
        vz cv c2 cdiv co clt wbr vz cv halfpos2 biimpa adantl jctild exp32
        imp45 sylanc exp32 r19.23adv exp32 syldan ex 3imp2 mpd $.
        $( [15-Feb-2008] $) $( [16-Dec-2007] $)

      $( MAY BE REVISED - delete this if not used $)
      $( Epsilon-delta property of a metric space function continuous at
         ` P ` .  A variation of ~ metcnpi with non-strict ordering. $)
      metcnpi4 $p |- ( ( ( C e. Met /\ D e. Met /\ P e. X ) /\ ( F e.
           ( ( J CnP K ) ` P ) /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
        A. y e. X ( ( P C y ) <_ x -> ( ( F ` P ) D ( F ` y ) ) <_ A ) ) ) $=
        cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA
        cr wcel cc0 cA clt wbr w3a wa cc0 vz cv clt wbr cP vy cv cC co vz cv
        clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vz cr
        wrex cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF
        cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex vz vy cA cC cD cP cF
        cJ cK cX cY metcn.1 metcn.2 metcn.3 metcn.4 metcnpi cC cme wcel cD cme
        wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt
        wbr cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF
        cfv cD co cA clt wbr wi vy cX wral wa vz cr wrex cc0 vx cv clt wbr cP
        vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy
        cX wral wa vx cr wrex wi cC cme wcel cD cme wcel cP cX wcel w3a cF cP
        cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt wbr cc0 vz cv clt wbr cP
        vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy
        cX wral wa vz cr wrex cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP
        cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex wi wi
        wi cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel
        cX cY cF wf cA cr wcel cc0 cA clt wbr cc0 vz cv clt wbr cP vy cv cC co
        vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa
        vz cr wrex cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy
        cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex wi wi wi cC cD
        cP cF cJ cK cX cY metcn.1 metcn.3 metcn.2 metcn.4 metcnpf cC cme wcel
        cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr cc0
        vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co
        cA clt wbr wi vy cX wral wa vz cr wrex cc0 vx cv clt wbr cP vy cv cC co
        vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa
        vx cr wrex wi cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA
        cr wcel cc0 cA clt wbr wa wa cc0 vz cv clt wbr cP vy cv cC co vz cv clt
        wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa cc0 vx cv
        clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA
        cle wbr wi vy cX wral wa vx cr wrex vz cr cC cme wcel cD cme wcel cP cX
        wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa vz cv cr wcel
        cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv
        cD co cA clt wbr wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co vx
        cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx
        cr wrex vz cv c2 cdiv co cr wcel cc0 vz cv c2 cdiv co clt wbr cP vy cv
        cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr
        wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF
        cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex cC cme
        wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt
        wbr wa wa vz cv cr wcel cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr
        cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa wa wa cc0 vx
        cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA
        cle wbr wi vy cX wral wa cc0 vz cv c2 cdiv co clt wbr cP vy cv cC co vz
        cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX
        wral wa vx vz cv c2 cdiv co cr vx cv vz cv c2 cdiv co wceq cc0 vx cv
        clt wbr cc0 vz cv c2 cdiv co clt wbr cP vy cv cC co vx cv cle wbr cP cF
        cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral cP vy cv cC co vz cv c2
        cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral
        vx cv vz cv c2 cdiv co cc0 clt breq2 vx cv vz cv c2 cdiv co wceq cP vy
        cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi cP vy
        cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle
        wbr wi vy cX vx cv vz cv c2 cdiv co wceq cP vy cv cC co vx cv cle wbr
        cP vy cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA
        cle wbr vx cv vz cv c2 cdiv co cP vy cv cC co cle breq2 imbi1d ralbidv
        anbi12d rcla4ev vz cv cr wcel vz cv c2 cdiv co cr wcel cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv
        cD co cA clt wbr wi vy cX wral wa vz cv rehalfcl ad2antrl cC cme wcel
        cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa
        wa vz cv cr wcel cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF
        cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral cc0 vz cv c2 cdiv co
        clt wbr cP vy cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv
        cD co cA cle wbr wi vy cX wral wa cC cme wcel cD cme wcel cP cX wcel
        w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa vz cv cr wcel cc0 vz
        cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA
        clt wbr wi vy cX wral cc0 vz cv c2 cdiv co clt wbr cP vy cv cC co vz cv
        c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX
        wral wa wi cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr
        wcel cc0 cA clt wbr wa wa vz cv cr wcel cc0 vz cv clt wbr wa wa cP vy
        cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX
        wral cP vy cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD
        co cA cle wbr wi vy cX wral cc0 vz cv c2 cdiv co clt wbr cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        vz cv cr wcel cc0 vz cv clt wbr wa wa cP vy cv cC co vz cv clt wbr cP
        cF cfv vy cv cF cfv cD co cA clt wbr wi cP vy cv cC co vz cv c2 cdiv co
        cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        vz cv cr wcel cc0 vz cv clt wbr wa wa vy cv cX wcel wa cP vy cv cC co
        vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv
        cF cfv cD co cA clt wbr cP cF cfv vy cv cF cfv cD co cA cle wbr cC cme
        wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt
        wbr wa wa vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX wcel cP vy cv cC
        co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi cC cme wcel
        cD cme wcel cP cX wcel w3a vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX
        wcel cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt
        wbr wi wi wi cX cY cF wf cA cr wcel cc0 cA clt wbr wa cC cme wcel cP cX
        wcel vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX wcel cP vy cv cC co vz
        cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi wi wi cD cme wcel
        cC cme wcel cP cX wcel wa vy cv cX wcel vz cv cr wcel cc0 vz cv clt wbr
        wa cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr
        wi cC cme wcel cP cX wcel vy cv cX wcel vz cv cr wcel cc0 vz cv clt wbr
        wa cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr
        wi wi cC cme wcel cP cX wcel vy cv cX wcel w3a cP vy cv cC co cr wcel
        vz cv cr wcel cc0 vz cv clt wbr wa cP vy cv cC co vz cv c2 cdiv co cle
        wbr cP vy cv cC co vz cv clt wbr wi wi cP vy cv cC cX metcn.1 metcl cP
        vy cv cC co cr wcel vz cv cr wcel cc0 vz cv clt wbr wa cP vy cv cC co
        vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi cP vy cv cC co
        cr wcel vz cv cr wcel cc0 vz cv clt wbr wa wa cP vy cv cC co vz cv c2
        cdiv co cle wbr vz cv c2 cdiv co vz cv clt wbr cP vy cv cC co vz cv clt
        wbr vz cv cr wcel cc0 vz cv clt wbr wa vz cv c2 cdiv co vz cv clt wbr
        cP vy cv cC co cr wcel vz cv cr wcel cc0 vz cv clt wbr vz cv c2 cdiv co
        vz cv clt wbr vz cv halfpos biimpa adantl cP vy cv cC co cr wcel vz cv
        cr wcel cP vy cv cC co vz cv c2 cdiv co cle wbr vz cv c2 cdiv co vz cv
        clt wbr wa cP vy cv cC co vz cv clt wbr wi cc0 vz cv clt wbr cP vy cv
        cC co cr wcel vz cv c2 cdiv co cr wcel vz cv cr wcel cP vy cv cC co vz
        cv c2 cdiv co cle wbr vz cv c2 cdiv co vz cv clt wbr wa cP vy cv cC co
        vz cv clt wbr wi cP vy cv cC co cr wcel vz cv cr wcel wa cP vy cv cC co
        vz cv c2 cdiv co vz cv lelttr cP vy cv cC co cr wcel vz cv cr wcel
        pm3.26 vz cv cr wcel vz cv c2 cdiv co cr wcel cP vy cv cC co cr wcel vz
        cv rehalfcl adantl cP vy cv cC co cr wcel vz cv cr wcel pm3.27 syl3anc
        adantrr mpan2d ex syl 3expia com23 3adant2 ad2antrr imp31 cC cme wcel
        cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa
        wa vy cv cX wcel cP cF cfv vy cv cF cfv cD co cA clt wbr cP cF cfv vy
        cv cF cfv cD co cA cle wbr wi vz cv cr wcel cc0 vz cv clt wbr wa cP cF
        cfv vy cv cF cfv cD co cr wcel cA cr wcel cP cF cfv vy cv cF cfv cD co
        cA clt wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa cA cr wcel cc0 cA clt wbr wa wa
        vy cv cX wcel wa cP cF cfv vy cv cF cfv cD co cA ltle cC cme wcel cD
        cme wcel cP cX wcel w3a cX cY cF wf wa vy cv cX wcel cP cF cfv vy cv cF
        cfv cD co cr wcel cA cr wcel cc0 cA clt wbr wa cC cme wcel cD cme wcel
        cP cX wcel w3a cX cY cF wf vy cv cX wcel cP cF cfv vy cv cF cfv cD co
        cr wcel cD cme wcel cP cX wcel cX cY cF wf vy cv cX wcel cP cF cfv vy
        cv cF cfv cD co cr wcel wi wi cC cme wcel cD cme wcel cP cX wcel cX cY
        cF wf vy cv cX wcel cP cF cfv vy cv cF cfv cD co cr wcel wi wi cD cme
        wcel cX cY cF wf cP cX wcel vy cv cX wcel cP cF cfv vy cv cF cfv cD co
        cr wcel wi cD cme wcel cX cY cF wf cP cX wcel vy cv cX wcel cP cF cfv
        vy cv cF cfv cD co cr wcel cD cme wcel cP cF cfv cY wcel vy cv cF cfv
        cY wcel wa cP cF cfv vy cv cF cfv cD co cr wcel cX cY cF wf cP cX wcel
        vy cv cX wcel wa wa cD cme wcel cP cF cfv cY wcel vy cv cF cfv cY wcel
        cP cF cfv vy cv cF cfv cD co cr wcel cP cF cfv vy cv cF cfv cD cY
        metcn.3 metcl 3expb cX cY cF wf cP cX wcel vy cv cX wcel cP cF cfv cY
        wcel vy cv cF cfv cY wcel wa cX cY cF wf cP cX wcel wa cP cF cfv cY
        wcel cX cY cF wf vy cv cX wcel wa vy cv cF cfv cY wcel cX cY cP cF
        ffvelrn cX cY vy cv cF ffvelrn anim12i anandis sylan2 exp45 com23 imp
        3adant1 imp31 adantlr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF
        wf wa cA cr wcel cc0 cA clt wbr vy cv cX wcel simplrl sylanc adantlr
        imim12d r19.20dva vz cv cr wcel cc0 vz cv clt wbr wa cc0 vz cv c2 cdiv
        co clt wbr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cA cr
        wcel cc0 cA clt wbr wa wa vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv c2
        cdiv co clt wbr vz cv halfpos2 biimpa adantl jctild exp32 imp45 sylanc
        exp32 r19.23adv exp32 syldan ex 3imp2 mpd $.
        $( [3-Jan-2008] $) $( [17-Dec-2007] $)

      $( Epsilon-delta property of a continuous metric space function. $)
      metcni $p |- ( ( ( C e. Met /\ D e. Met /\
                  F e. ( J Cn K ) ) /\
           ( P e. X /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
        A. y e. X ( ( P C y ) < x -> ( ( F ` P ) D ( F ` y ) ) < A ) ) ) $=
        cP cX wcel cA cr wcel cc0 cA clt wbr w3a cC cme wcel cD cme wcel cF cJ
        cK ccn co wcel w3a cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF
        cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex cP cX
        wcel cA cr wcel cc0 cA clt wbr cC cme wcel cD cme wcel cF cJ cK ccn co
        wcel w3a cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv
        cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex wi cP cX wcel cA cr
        wcel wa cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cc0 cA clt wbr
        cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
        cD co cA clt wbr wi vy cX wral wa vx cr wrex cP cX wcel cA cr wcel wa
        cc0 vw cv clt wbr cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt wbr vz
        cv cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa vx cr wrex
        wi vw cr wral vz cX wral cc0 cA clt wbr cc0 vx cv clt wbr cP vy cv cC
        co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral
        wa vx cr wrex wi cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cc0
        vw cv clt wbr cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt wbr vz cv
        cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa vx cr wrex wi
        cc0 cA clt wbr cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv
        vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex wi cc0 vw cv
        clt wbr cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv
        cF cfv cD co vw cv clt wbr wi vy cX wral wa vx cr wrex wi vz vw cP cA
        cX cr vz cv cP wceq cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt wbr
        vz cv cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa vx cr
        wrex cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF
        cfv cD co vw cv clt wbr wi vy cX wral wa vx cr wrex cc0 vw cv clt wbr
        vz cv cP wceq cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt wbr vz cv
        cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa cc0 vx cv clt
        wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co vw cv clt
        wbr wi vy cX wral wa vx cr vz cv cP wceq vz cv vy cv cC co vx cv clt
        wbr vz cv cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral cP vy
        cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy
        cX wral cc0 vx cv clt wbr vz cv cP wceq vz cv vy cv cC co vx cv clt wbr
        vz cv cF cfv vy cv cF cfv cD co vw cv clt wbr wi cP vy cv cC co vx cv
        clt wbr cP cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX vz cv cP
        wceq vz cv vy cv cC co vx cv clt wbr cP vy cv cC co vx cv clt wbr vz cv
        cF cfv vy cv cF cfv cD co vw cv clt wbr cP cF cfv vy cv cF cfv cD co vw
        cv clt wbr vz cv cP wceq vz cv vy cv cC co cP vy cv cC co vx cv clt vz
        cv cP vy cv cC opreq1 breq1d vz cv cP wceq vz cv cF cfv vy cv cF cfv cD
        co cP cF cfv vy cv cF cfv cD co vw cv clt vz cv cP wceq vz cv cF cfv cP
        cF cfv vy cv cF cfv cD vz cv cP cF fveq2 opreq1d breq1d imbi12d ralbidv
        anbi2d rexbidv imbi2d vw cv cA wceq cc0 vw cv clt wbr cc0 cA clt wbr
        cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
        cD co vw cv clt wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy
        cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX
        wral wa vx cr wrex vw cv cA cc0 clt breq2 vw cv cA wceq cc0 vx cv clt
        wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co vw cv clt
        wbr wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP
        cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr vw cv cA
        wceq cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co vw cv
        clt wbr wi vy cX wral cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF
        cfv cD co cA clt wbr wi vy cX wral cc0 vx cv clt wbr vw cv cA wceq cP
        vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co vw cv clt wbr wi
        cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi
        vy cX vw cv cA wceq cP cF cfv vy cv cF cfv cD co vw cv clt wbr cP cF
        cfv vy cv cF cfv cD co cA clt wbr cP vy cv cC co vx cv clt wbr vw cv cA
        cP cF cfv vy cv cF cfv cD co clt breq2 imbi2d ralbidv anbi2d rexbidv
        imbi12d rcla42v cC cme wcel cD cme wcel cF cJ cK ccn co wcel cc0 vw cv
        clt wbr cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt wbr vz cv cF cfv
        vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa vx cr wrex wi vw cr
        wral vz cX wral cC cme wcel cD cme wcel wa cF cJ cK ccn co wcel cX cY
        cF wf cc0 vw cv clt wbr cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt
        wbr vz cv cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa vx
        cr wrex wi vw cr wral vz cX wral wa cc0 vw cv clt wbr cc0 vx cv clt wbr
        vz cv vy cv cC co vx cv clt wbr vz cv cF cfv vy cv cF cfv cD co vw cv
        clt wbr wi vy cX wral wa vx cr wrex wi vw cr wral vz cX wral vz vw vx
        vy cC cD cF cJ cK cX cY metcn.1 metcn.2 metcn.3 metcn.4 metcn cX cY cF
        wf cc0 vw cv clt wbr cc0 vx cv clt wbr vz cv vy cv cC co vx cv clt wbr
        vz cv cF cfv vy cv cF cfv cD co vw cv clt wbr wi vy cX wral wa vx cr
        wrex wi vw cr wral vz cX wral pm3.27 syl6bi 3impia syl5 com23 3impia
        impcom $.
        $( [19-Nov-2007] $) $( [3-Aug-2007] $)

      $( MAY BE REVISED - delete this if not used $)
      $( Epsilon-delta property of a continuous metric space function. $)
      metcni2 $p |- ( ( ( C e. Met /\ D e. Met /\
                  F e. ( J Cn K ) ) /\
           ( P e. X /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
        A. y e. X ( ( P C y ) <_ x -> ( ( F ` P ) D ( F ` y ) ) <_ A ) ) ) $=
        cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel
        cc0 cA clt wbr w3a wa cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP
        cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vz cr wrex cc0 vx
        cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA
        cle wbr wi vy cX wral wa vx cr wrex vz vy cA cC cD cP cF cJ cK cX cY
        metcn.1 metcn.2 metcn.3 metcn.4 metcni cC cme wcel cD cme wcel cF cJ cK
        ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a wa cc0 vz cv
        clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA
        clt wbr wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr
        cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex vz
        cr cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr
        wcel cc0 cA clt wbr w3a wa vz cv cr wcel cc0 vz cv clt wbr cP vy cv cC
        co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral
        wa cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF
        cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex vz cv c2 cdiv co cr
        wcel cc0 vz cv c2 cdiv co clt wbr cP vy cv cC co vz cv c2 cdiv co cle
        wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa cc0 vx cv
        clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA
        cle wbr wi vy cX wral wa vx cr wrex cC cme wcel cD cme wcel cF cJ cK
        ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a wa vz cv cr
        wcel cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF
        cfv cD co cA clt wbr wi vy cX wral wa wa wa cc0 vx cv clt wbr cP vy cv
        cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX
        wral wa cc0 vz cv c2 cdiv co clt wbr cP vy cv cC co vz cv c2 cdiv co
        cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx vz
        cv c2 cdiv co cr vx cv vz cv c2 cdiv co wceq cc0 vx cv clt wbr cc0 vz
        cv c2 cdiv co clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF
        cfv cD co cA cle wbr wi vy cX wral cP vy cv cC co vz cv c2 cdiv co cle
        wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral vx cv vz cv
        c2 cdiv co cc0 clt breq2 vx cv vz cv c2 cdiv co wceq cP vy cv cC co vx
        cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi cP vy cv cC co vz
        cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX
        vx cv vz cv c2 cdiv co wceq cP vy cv cC co vx cv cle wbr cP vy cv cC co
        vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr vx cv
        vz cv c2 cdiv co cP vy cv cC co cle breq2 imbi1d ralbidv anbi12d
        rcla4ev vz cv cr wcel vz cv c2 cdiv co cr wcel cC cme wcel cD cme wcel
        cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a wa
        cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv
        cD co cA clt wbr wi vy cX wral wa vz cv rehalfcl ad2antrl cC cme wcel
        cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt
        wbr w3a wa vz cv cr wcel cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr
        cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral cc0 vz cv c2 cdiv
        co clt wbr cP vy cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF
        cfv cD co cA cle wbr wi vy cX wral wa cC cme wcel cD cme wcel cF cJ cK
        ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a wa vz cv cr
        wcel cc0 vz cv clt wbr cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF
        cfv cD co cA clt wbr wi vy cX wral cc0 vz cv c2 cdiv co clt wbr cP vy
        cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA cle
        wbr wi vy cX wral wa wi cC cme wcel cD cme wcel cF cJ cK ccn co wcel
        w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a wa vz cv cr wcel cc0 vz cv
        clt wbr wa wa cP vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co
        cA clt wbr wi vy cX wral cP vy cv cC co vz cv c2 cdiv co cle wbr cP cF
        cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral cc0 vz cv c2 cdiv co
        clt wbr cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA
        cr wcel cc0 cA clt wbr w3a wa vz cv cr wcel cc0 vz cv clt wbr wa wa cP
        vy cv cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi cP
        vy cv cC co vz cv c2 cdiv co cle wbr cP cF cfv vy cv cF cfv cD co cA
        cle wbr wi vy cX cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX
        wcel cA cr wcel cc0 cA clt wbr w3a wa vz cv cr wcel cc0 vz cv clt wbr
        wa wa vy cv cX wcel wa cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv
        cC co vz cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr cP cF cfv
        vy cv cF cfv cD co cA cle wbr cC cme wcel cD cme wcel cF cJ cK ccn co
        wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a wa vz cv cr wcel cc0
        vz cv clt wbr wa vy cv cX wcel cP vy cv cC co vz cv c2 cdiv co cle wbr
        cP vy cv cC co vz cv clt wbr wi cC cme wcel cD cme wcel cP cX wcel cA
        cr wcel cc0 cA clt wbr w3a vz cv cr wcel cc0 vz cv clt wbr wa vy cv cX
        wcel cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt
        wbr wi wi wi cF cJ cK ccn co wcel cC cme wcel cA cr wcel cP cX wcel vz
        cv cr wcel cc0 vz cv clt wbr wa vy cv cX wcel cP vy cv cC co vz cv c2
        cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi wi wi cc0 cA clt wbr cC
        cme wcel cP cX wcel wa vy cv cX wcel vz cv cr wcel cc0 vz cv clt wbr wa
        cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi
        cC cme wcel cP cX wcel vy cv cX wcel vz cv cr wcel cc0 vz cv clt wbr wa
        cP vy cv cC co vz cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi
        wi cC cme wcel cP cX wcel vy cv cX wcel w3a cP vy cv cC co cr wcel vz
        cv cr wcel cc0 vz cv clt wbr wa cP vy cv cC co vz cv c2 cdiv co cle wbr
        cP vy cv cC co vz cv clt wbr wi wi cP vy cv cC cX metcn.1 metcl cP vy
        cv cC co cr wcel vz cv cr wcel cc0 vz cv clt wbr wa cP vy cv cC co vz
        cv c2 cdiv co cle wbr cP vy cv cC co vz cv clt wbr wi cP vy cv cC co cr
        wcel vz cv cr wcel cc0 vz cv clt wbr wa wa cP vy cv cC co vz cv c2 cdiv
        co cle wbr vz cv c2 cdiv co vz cv clt wbr cP vy cv cC co vz cv clt wbr
        vz cv cr wcel cc0 vz cv clt wbr wa vz cv c2 cdiv co vz cv clt wbr cP vy
        cv cC co cr wcel vz cv cr wcel cc0 vz cv clt wbr vz cv c2 cdiv co vz cv
        clt wbr vz cv halfpos biimpa adantl cP vy cv cC co cr wcel vz cv cr
        wcel cP vy cv cC co vz cv c2 cdiv co cle wbr vz cv c2 cdiv co vz cv clt
        wbr wa cP vy cv cC co vz cv clt wbr wi cc0 vz cv clt wbr cP vy cv cC co
        cr wcel vz cv c2 cdiv co cr wcel vz cv cr wcel cP vy cv cC co vz cv c2
        cdiv co cle wbr vz cv c2 cdiv co vz cv clt wbr wa cP vy cv cC co vz cv
        clt wbr wi cP vy cv cC co cr wcel vz cv cr wcel wa cP vy cv cC co vz cv
        c2 cdiv co vz cv lelttr cP vy cv cC co cr wcel vz cv cr wcel pm3.26 vz
        cv cr wcel vz cv c2 cdiv co cr wcel cP vy cv cC co cr wcel vz cv
        rehalfcl adantl cP vy cv cC co cr wcel vz cv cr wcel pm3.27 syl3anc
        adantrr mpan2d ex syl 3expia com23 3ad2antr1 3ad2antl1 imp31 cC cme
        wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA
        clt wbr w3a wa vy cv cX wcel cP cF cfv vy cv cF cfv cD co cA clt wbr cP
        cF cfv vy cv cF cfv cD co cA cle wbr wi vz cv cr wcel cc0 vz cv clt wbr
        wa cP cF cfv vy cv cF cfv cD co cr wcel cA cr wcel cP cF cfv vy cv cF
        cfv cD co cA clt wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi cC cme
        wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA
        clt wbr w3a wa vy cv cX wcel wa cP cF cfv vy cv cF cfv cD co cA ltle cC
        cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0
        cA clt wbr w3a wa vy cv cX wcel cP cF cfv vy cv cF cfv cD co cr wcel cC
        cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cA cr wcel cP cX wcel vy
        cv cX wcel cP cF cfv vy cv cF cfv cD co cr wcel wi cc0 cA clt wbr cC
        cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel vy cv cX wcel
        cP cF cfv vy cv cF cfv cD co cr wcel wi cC cme wcel cD cme wcel cX cY
        cF wf cP cX wcel vy cv cX wcel cP cF cfv vy cv cF cfv cD co cr wcel wi
        wi cF cJ cK ccn co wcel cD cme wcel cX cY cF wf cP cX wcel vy cv cX
        wcel cP cF cfv vy cv cF cfv cD co cr wcel wi wi cC cme wcel cD cme wcel
        cX cY cF wf cP cX wcel vy cv cX wcel cP cF cfv vy cv cF cfv cD co cr
        wcel wi wi cD cme wcel cX cY cF wf cP cX wcel vy cv cX wcel cP cF cfv
        vy cv cF cfv cD co cr wcel cD cme wcel cP cF cfv cY wcel vy cv cF cfv
        cY wcel wa cP cF cfv vy cv cF cfv cD co cr wcel cX cY cF wf cP cX wcel
        vy cv cX wcel wa wa cD cme wcel cP cF cfv cY wcel vy cv cF cfv cY wcel
        cP cF cfv vy cv cF cfv cD co cr wcel cP cF cfv vy cv cF cfv cD cY
        metcn.3 metcl 3expb cX cY cF wf cP cX wcel vy cv cX wcel cP cF cfv cY
        wcel vy cv cF cfv cY wcel wa cX cY cF wf cP cX wcel wa cP cF cfv cY
        wcel cX cY cF wf vy cv cX wcel wa vy cv cF cfv cY wcel cX cY cP cF
        ffvelrn cX cY vy cv cF ffvelrn anim12i anandis sylan2 exp45 imp 3adant1
        cC cD cF cJ cK cX cY metcn.1 metcn.3 metcn.2 metcn.4 metcnf syld3an3
        imp 3ad2antr1 imp cP cX wcel cA cr wcel cc0 cA clt wbr w3a cA cr wcel
        cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a vy cv cX wcel cP cX
        wcel cA cr wcel cc0 cA clt wbr 3simp2 ad2antlr sylanc adantlr imim12d
        r19.20dva vz cv cr wcel cc0 vz cv clt wbr wa cc0 vz cv c2 cdiv co clt
        wbr cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr
        wcel cc0 cA clt wbr w3a wa vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv c2
        cdiv co clt wbr vz cv halfpos2 biimpa adantl jctild exp32 imp45 sylanc
        exp32 r19.23adv mpd $.
        $( [14-Dec-2007] $) $( [14-Dec-2007] $)
    $}

    $( Two ways to express that ` F ` is continuous at ` P ` for metric spaces.
       Proposition 14-4.2 of [Gleason] p. 240. $)
    metcnp3 $p |- ( ( C e. Met /\ D e. Met /\ P e. X )
    -> ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\
    A. y e. RR ( 0 < y -> E. z e. RR ( 0 < z /\ ( F " ( P ( ball ` C ) z ) )
    C_ ( ( F ` P ) ( ball ` D ) y ) ) ) ) ) ) $=
      cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX cY
      cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP
      cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy
      cr wral wa cX cY cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr cF cP vz cv cC
      cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss wa vz cr wrex wi vy cr
      wral wa vy vz vw cC cD cP cF cJ cK cX cY metcn.1 metcn.2 metcn.3 metcn.4
      metcnp cC cme wcel cD cme wcel cP cX wcel cX cY cF wf cc0 vy cv clt wbr
      cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD
      co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral wa cX cY cF wf
      cc0 vy cv clt wbr cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP cF
      cfv vy cv cD cbl cfv co wss wa vz cr wrex wi vy cr wral wa wb cC cme wcel
      cD cme wcel wa cP cX wcel wa cX cY cF wf cc0 vy cv clt wbr cc0 vz cv clt
      wbr cP vw cv cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cX wral wa vz cr wrex wi vy cr wral cc0 vy cv clt wbr cc0 vz cv
      clt wbr cF cP vz cv cC cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss
      wa vz cr wrex wi vy cr wral cC cme wcel cD cme wcel wa cX cY cF wf cP cX
      wcel cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP
      cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy
      cr wral cc0 vy cv clt wbr cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co
      cima cP cF cfv vy cv cD cbl cfv co wss wa vz cr wrex wi vy cr wral wb cC
      cme wcel cD cme wcel wa cX cY cF wf cP cX wcel cc0 vy cv clt wbr cc0 vz
      cv clt wbr cP vw cv cC co vz cv clt wbr cP cF cfv vw cv cF cfv cD co vy
      cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral cc0 vy cv clt wbr
      cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP cF cfv vy cv cD cbl
      cfv co wss wa vz cr wrex wi vy cr wral wb cC cme wcel cD cme wcel wa cX
      cY cF wf cP cX wcel wa wa cc0 vy cv clt wbr cc0 vz cv clt wbr cF cP vz cv
      cC cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss wa vz cr wrex wi vy
      cr wral cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF
      ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex wi vy cr wral
      cc0 vy cv clt wbr cc0 vz cv clt wbr cP vw cv cC co vz cv clt wbr cP cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr
      wral cC cme wcel cX cY cF wf cP cX wcel wa cc0 vy cv clt wbr cc0 vz cv
      clt wbr cF cP vz cv cC cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss
      wa vz cr wrex wi vy cr wral cc0 vy cv clt wbr cc0 vz cv clt wbr cP vz cv
      cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr
      wrex wi vy cr wral wb cD cme wcel cC cme wcel cX cY cF wf cP cX wcel wa
      wa cc0 vy cv clt wbr cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP
      cF cfv vy cv cD cbl cfv co wss wa vz cr wrex wi cc0 vy cv clt wbr cc0 vz
      cv clt wbr cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co
      cima wss wa vz cr wrex wi vy cr cC cme wcel cX cY cF wf cP cX wcel wa wa
      cc0 vz cv clt wbr cF cP vz cv cC cbl cfv co cima cP cF cfv vy cv cD cbl
      cfv co wss wa vz cr wrex cc0 vz cv clt wbr cP vz cv cC cbl cfv co cF ccnv
      cP cF cfv vy cv cD cbl cfv co cima wss wa vz cr wrex cc0 vy cv clt wbr cC
      cme wcel cX cY cF wf cP cX wcel wa wa cc0 vz cv clt wbr cF cP vz cv cC
      cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss wa cc0 vz cv clt wbr cP
      vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wa vz
      cr cC cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr wcel wa cc0 vz cv
      clt wbr cF cP vz cv cC cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss
      cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss cC
      cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr wcel cc0 vz cv clt wbr cF
      cP vz cv cC cbl cfv co cima cP cF cfv vy cv cD cbl cfv co wss cP vz cv cC
      cbl cfv co cF ccnv cP cF cfv vy cv cD cbl cfv co cima wss wb cF wfun cP
      vz cv cC cbl cfv co cF cdm wss cF cP vz cv cC cbl cfv co cima cP cF cfv
      vy cv cD cbl cfv co wss cP vz cv cC cbl cfv co cF ccnv cP cF cfv vy cv cD
      cbl cfv co cima wss wb cC cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr
      wcel cc0 vz cv clt wbr wa wa cP vz cv cC cbl cfv co cP cF cfv vy cv cD
      cbl cfv co cF funimass3 cX cY cF wf cP cX wcel wa cF wfun cC cme wcel vz
      cv cr wcel cc0 vz cv clt wbr wa cX cY cF wf cF wfun cP cX wcel cX cY cF
      ffun adantr ad2antlr cC cme wcel cX cY cF wf cP cX wcel wa wa vz cv cr
      wcel cc0 vz cv clt wbr wa wa cP vz cv cC cbl cfv co cX cF cdm cC cme wcel
      cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa cP vz cv cC cbl cfv co cX
      wss cX cY cF wf cC cP vz cv cX metcn.1 blssm adantlrl cX cY cF wf cP cX
      wcel wa cF cdm cX wceq cC cme wcel vz cv cr wcel cc0 vz cv clt wbr wa cX
      cY cF wf cF cdm cX wceq cP cX wcel cX cY cF fdm adantr ad2antlr sseqtr4d
      sylanc anassrs pm5.32da rexbidva imbi2d ralbidv adantlr vy vz vw cC cD cP
      cF cJ cK cX cY metcn.1 metcn.2 metcn.3 metcn.4 metcnplem bitr2d anassrs
      an1rs pm5.32da 3impa bitrd $.
      $( [11-Mar-2008] $) $( [17-May-2007] $)
  $}

  ${
    $d f w x y z B $.  $d f w x y z C $.  $d f w x y z D $.  $d f w x y z J $.
    $d f x y K $.  $d f x y L $.
    metcnco.1 $e |- J = ( Open ` B ) $.
    metcnco.2 $e |- K = ( Open ` C ) $.
    metcnco.3 $e |- L = ( Open ` D ) $.
    $( Composition of two continuous functions (metric space version of
       ~ cnco ). $)
    metcnco $p  |- ( ( ( B e. Met /\ C e. Met /\ D e. Met ) /\ (
        F e. ( J Cn K ) /\ G e. ( K Cn L ) ) ) -> ( G o. F ) e. ( J Cn L ) ) $=
      cJ ctop wcel cK ctop wcel cL ctop wcel cF cJ cK ccn co wcel cG cK cL ccn
      co wcel wa cG cF ccom cJ cL ccn co wcel cB cme wcel cC cme wcel cD cme
      wcel cF cG cJ cK cL cnco cB cJ metcnco.1 opntop cC cK metcnco.2 opntop cD
      cL metcnco.3 opntop syl3anl $.
      $( [19-Nov-2007] $) $( [6-Aug-2007] $)

    $( Subset relationship for continuity of metric spaces. $)
    metcnss $p |- ( ( ( B e. Met /\ C e. Met /\ D e. Met ) /\ C C_ D ) ->
      ( J Cn K ) C_ ( J Cn L ) ) $=
      cB cme wcel cC cme wcel cD cme wcel w3a cC cD wss wa vf cJ cK ccn co cJ
      cL ccn co cB cme wcel cC cme wcel cD cme wcel w3a cC cD wss wa cB cdm cdm
      cC cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt wbr wi vw
      cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm wral wa cB cdm
      cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv
      cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr
      wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm wral wa
      vf cv cJ cK ccn co wcel vf cv cJ cL ccn co wcel cC cme wcel cD cme wcel
      cC cD wss cB cdm cdm cC cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt
      wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co
      vy cv clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm
      cdm wral wa cB cdm cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv
      clt wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv
      cD co vy cv clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx
      cB cdm cdm wral wa wi cB cme wcel cC cme wcel cD cme wcel wa cC cD wss wa
      cB cdm cdm cC cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv
      vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt
      wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm wral
      wa cB cdm cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv
      clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm
      wral cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv
      wf cB cdm cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv
      clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm
      wral cC cD wss cB cdm cdm cC cdm cdm vf cv wf cB cdm cdm cD cdm cdm vf cv
      wf wi cC cme wcel cD cme wcel wa cB cdm cdm cC cdm cdm vf cv wf cC cD wss
      cB cdm cdm cD cdm cdm vf cv wf cB cdm cdm cC cdm cdm vf cv wf cC cdm cdm
      cD cdm cdm wss cB cdm cdm cD cdm cdm vf cv wf cC cD wss cB cdm cdm cC cdm
      cdm cD cdm cdm vf cv fss cC cD cC cdm cdm cD cdm cdm cC cdm cdm eqid cD
      cdm cdm eqid metss sylan2 expcom adantl adantrd cC cme wcel cD cme wcel
      wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz
      cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cC co vy cv clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral
      vx cB cdm cdm wral cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw
      cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm wral cC cme
      wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv wf wa cc0 vy
      cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv
      cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cB cdm cdm wral wa vz cr
      wrex wi vy cr wral vx cB cdm cdm wral cc0 vy cv clt wbr cc0 vz cv clt wbr
      vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy
      cv clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm
      cdm wral cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf
      cv wf wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cB cdm cdm
      wral wa vz cr wrex wi vy cr wral cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv
      clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm
      cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv wf wa
      vx cv cB cdm cdm wcel wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv
      cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr
      wi vw cB cdm cdm wral wa vz cr wrex wi cc0 vy cv clt wbr cc0 vz cv clt
      wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co
      vy cv clt wbr wi vw cB cdm cdm wral wa vz cr wrex wi vy cr cC cme wcel cD
      cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv wf wa vx cv cB cdm
      cdm wcel wa cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv
      cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cB cdm cdm wral wa vz cr
      wrex cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cC co vy cv clt wbr wi vw cB cdm cdm wral wa vz cr wrex cc0
      vy cv clt wbr cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm
      cdm vf cv wf wa vx cv cB cdm cdm wcel wa cc0 vz cv clt wbr vx cv vw cv cB
      co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi
      vw cB cdm cdm wral wa cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt wbr wi vw cB cdm cdm wral
      wa vz cr cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf
      cv wf wa vx cv cB cdm cdm wcel wa vx cv vw cv cB co vz cv clt wbr vx cv
      vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cB cdm cdm wral vx cv
      vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt
      wbr wi vw cB cdm cdm wral cc0 vz cv clt wbr cC cme wcel cD cme wcel wa cC
      cD wss wa cB cdm cdm cC cdm cdm vf cv wf wa vx cv cB cdm cdm wcel wa vx
      cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv
      clt wbr wi vx cv vw cv cB co vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cC co vy cv clt wbr wi vw cB cdm cdm cC cme wcel cD cme wcel wa cC cD
      wss wa cB cdm cdm cC cdm cdm vf cv wf wa vx cv cB cdm cdm wcel wa vw cv
      cB cdm cdm wcel wa vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr vx
      cv vf cv cfv vw cv vf cv cfv cC co vy cv clt wbr vx cv vw cv cB co vz cv
      clt wbr cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf
      cv wf wa vx cv cB cdm cdm wcel wa vw cv cB cdm cdm wcel wa vx cv vf cv
      cfv vw cv vf cv cfv cD co vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt
      cC cme wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv wf wa
      vx cv cB cdm cdm wcel wa vw cv cB cdm cdm wcel wa vx cv vf cv cfv vw cv
      vf cv cfv cD cC cdm cdm cC cdm cdm cxp cres co vx cv vf cv cfv vw cv vf
      cv cfv cD co vx cv vf cv cfv vw cv vf cv cfv cC co cB cdm cdm cC cdm cdm
      vf cv wf vx cv cB cdm cdm wcel vw cv cB cdm cdm wcel vx cv vf cv cfv vw
      cv vf cv cfv cD cC cdm cdm cC cdm cdm cxp cres co vx cv vf cv cfv vw cv
      vf cv cfv cD co wceq cC cme wcel cD cme wcel wa cC cD wss wa vx cv vf cv
      cfv cC cdm cdm wcel vw cv vf cv cfv cC cdm cdm wcel vx cv vf cv cfv vw cv
      vf cv cfv cD cC cdm cdm cC cdm cdm cxp cres co vx cv vf cv cfv vw cv vf
      cv cfv cD co wceq cB cdm cdm cC cdm cdm vf cv wf vx cv cB cdm cdm wcel wa
      vw cv cB cdm cdm wcel wa vx cv vf cv cfv vw cv vf cv cfv cC cdm cdm cC
      cdm cdm cD oprvres cB cdm cdm cC cdm cdm vf cv wf vx cv cB cdm cdm wcel
      wa vx cv vf cv cfv cC cdm cdm wcel vw cv cB cdm cdm wcel cB cdm cdm cC
      cdm cdm vx cv vf cv ffvelrn adantr cB cdm cdm cC cdm cdm vf cv wf vw cv
      cB cdm cdm wcel vw cv vf cv cfv cC cdm cdm wcel vx cv cB cdm cdm wcel cB
      cdm cdm cC cdm cdm vw cv vf cv ffvelrn adantlr sylanc adantlll cC cme
      wcel cD cme wcel wa cC cD wss wa cB cdm cdm cC cdm cdm vf cv wf wa vx cv
      cB cdm cdm wcel wa vw cv cB cdm cdm wcel wa cD cC cdm cdm cC cdm cdm cxp
      cres cC vx cv vf cv cfv vw cv vf cv cfv cC cme wcel cD cme wcel wa cC cD
      wss wa cB cdm cdm cC cdm cdm vf cv wf wa cD cC cdm cdm cC cdm cdm cxp
      cres cC wceq vx cv cB cdm cdm wcel vw cv cB cdm cdm wcel cC cme wcel cD
      cme wcel wa cC cD wss wa cD cC cdm cdm cC cdm cdm cxp cres cC wceq cB cdm
      cdm cC cdm cdm vf cv wf cC cme wcel cD cme wcel wa cC cD wss wa cD cC cdm
      cres cD cC cdm cdm cC cdm cdm cxp cres cC cC cme wcel cD cC cdm cres cD
      cC cdm cdm cC cdm cdm cxp cres wceq cD cme wcel cC cD wss cC cme wcel cC
      cdm cdm cC cdm cdm cxp cr cC wf cC cdm cC cdm cdm cC cdm cdm cxp wceq cD
      cC cdm cres cD cC cdm cdm cC cdm cdm cxp cres wceq cC cC cdm cdm cC cdm
      cdm eqid metf cC cdm cdm cC cdm cdm cxp cr cC fdm cC cdm cC cdm cdm cC
      cdm cdm cxp cD reseq2 3syl ad2antrr cD cme wcel cC cD wss cD cC cdm cres
      cC wceq cC cme wcel cD wfun cC cD wss cD cC cdm cres cC wceq cD cme wcel
      cD cC funssres cD cme wcel cD cdm cdm cD cdm cdm cxp cr cD wf cD wfun cD
      cD cdm cdm cD cdm cdm eqid metf cD cdm cdm cD cdm cdm cxp cr cD ffun syl
      sylan adantll eqtr3d adantr ad2antrr opreqd eqtr3d breq1d imbi2d ralbidva
      anbi2d rexbidv imbi2d ralbidv ralbidva biimprd expimpd jcad 3adantl1 cB
      cme wcel cC cme wcel cD cme wcel w3a vf cv cJ cK ccn co wcel cB cdm cdm
      cC cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt wbr wi vw
      cB cdm cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm wral wa wb cC
      cD wss cB cme wcel cC cme wcel vf cv cJ cK ccn co wcel cB cdm cdm cC cdm
      cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cC co vy cv clt wbr wi vw cB cdm
      cdm wral wa vz cr wrex wi vy cr wral vx cB cdm cdm wral wa wb cD cme wcel
      vx vy vz vw cB cC vf cv cJ cK cB cdm cdm cC cdm cdm cB cdm cdm eqid
      metcnco.1 cC cdm cdm eqid metcnco.2 metcn 3adant3 adantr cB cme wcel cC
      cme wcel cD cme wcel w3a vf cv cJ cL ccn co wcel cB cdm cdm cD cdm cdm vf
      cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cB cdm cdm wral
      wa vz cr wrex wi vy cr wral vx cB cdm cdm wral wa wb cC cD wss cB cme
      wcel cD cme wcel vf cv cJ cL ccn co wcel cB cdm cdm cD cdm cdm vf cv wf
      cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv
      vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cB cdm cdm wral wa vz
      cr wrex wi vy cr wral vx cB cdm cdm wral wa wb cC cme wcel vx vy vz vw cB
      cD vf cv cJ cL cB cdm cdm cD cdm cdm cB cdm cdm eqid metcnco.1 cD cdm cdm
      eqid metcnco.3 metcn 3adant2 adantr 3imtr4d ssrdv $.
      $( [20-Nov-2007] $) $( [29-May-2007] $)
  $}

  ${
    $d w x y z C $.  $d w x y z D $.  $d w x y z F $.  $d w x y z B $.
    $d w x y z J $.  $d w x y z K $.  $d x y L $.  $d w x y z X $.
    metcnss2.1 $e |- X = dom dom B $.
    metcnss2.2 $e |- J = ( Open ` B ) $.
    metcnss2.3 $e |- K = ( Open ` C ) $.
    metcnss2.4 $e |- L = ( Open ` D ) $.
    $( Subset relationship for continuity of metric spaces. $)
    metcnss2 $p |- ( ( ( B e. Met /\ C e. Met /\ D e. Met ) /\ ( B C_ C
                 /\ F e. ( K Cn L ) ) ) -> ( F |` X ) e. ( J Cn L ) ) $=
      cB cme wcel cC cme wcel cD cme wcel w3a cB cC wss cF cK cL ccn co wcel cF
      cX cres cJ cL ccn co wcel cB cme wcel cC cme wcel cD cme wcel w3a cB cC
      wss wa cF cK cL ccn co wcel cF cX cres cJ cL ccn co wcel cB cme wcel cC
      cme wcel cD cme wcel w3a cB cC wss wa cC cdm cdm cD cdm cdm cF wf cc0 vy
      cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv
      vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi
      vy cr wral vx cC cdm cdm wral wa cX cD cdm cdm cF cX cres wf cc0 vy cv
      clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv cF cX
      cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr wi vw cX wral wa vz cr
      wrex wi vy cr wral vx cX wral wa cF cK cL ccn co wcel cF cX cres cJ cL
      ccn co wcel cB cme wcel cC cme wcel cB cC wss cC cdm cdm cD cdm cdm cF wf
      cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv
      cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr
      wrex wi vy cr wral vx cC cdm cdm wral wa cX cD cdm cdm cF cX cres wf cc0
      vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv cF
      cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr wi vw cX wral wa vz
      cr wrex wi vy cr wral vx cX wral wa wi cD cme wcel cB cme wcel cC cme
      wcel wa cB cC wss wa cC cdm cdm cD cdm cdm cF wf cX cD cdm cdm cF cX cres
      wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr
      wrex wi vy cr wral vx cC cdm cdm wral cc0 vy cv clt wbr cc0 vz cv clt wbr
      vx cv vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw cv cF cX cres cfv
      cD co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cX wral
      cB cC wss cC cdm cdm cD cdm cdm cF wf cX cD cdm cdm cF cX cres wf wi cB
      cme wcel cC cme wcel wa cC cdm cdm cD cdm cdm cF wf cB cC wss cX cD cdm
      cdm cF cX cres wf cC cdm cdm cD cdm cdm cF wf cX cC cdm cdm wss cX cD cdm
      cdm cF cX cres wf cB cC wss cC cdm cdm cD cdm cdm cX cF fssres cB cC cX
      cC cdm cdm metcnss2.1 cC cdm cdm eqid metss sylan2 expcom adantl cB cme
      wcel cC cme wcel wa cB cC wss wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC cdm cdm wral
      cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv
      cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr
      wrex wi vy cr wral vx cX wral cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv
      vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw cv cF cX cres cfv cD co
      vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cX wral cB cC
      wss cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz
      cr wrex wi vy cr wral vx cC cdm cdm wral cc0 vy cv clt wbr cc0 vz cv clt
      wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv
      clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cX wral wi
      cB cme wcel cC cme wcel wa cB cC wss cX cC cdm cdm wss cc0 vy cv clt wbr
      cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF
      cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral
      vx cC cdm cdm wral cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm
      cdm wral wa vz cr wrex wi vy cr wral vx cX wral wi cB cC cX cC cdm cdm
      metcnss2.1 cC cdm cdm eqid metss cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cX cC cdm cdm
      ssralv syl adantl cB cme wcel cC cme wcel wa cB cC wss wa cc0 vy cv clt
      wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv
      cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr
      wral cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr
      vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr wi vw cX
      wral wa vz cr wrex wi vy cr wral vx cX cB cme wcel cC cme wcel wa cB cC
      wss wa vx cv cX wcel wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv
      cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw
      cC cdm cdm wral wa vz cr wrex wi cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw cv cF cX cres cfv cD
      co vy cv clt wbr wi vw cX wral wa vz cr wrex wi vy cr cB cme wcel cC cme
      wcel wa cB cC wss wa vx cv cX wcel wa cc0 vz cv clt wbr vx cv vw cv cC co
      vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm
      cdm wral wa vz cr wrex cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt wbr
      vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr wi vw cX
      wral wa vz cr wrex cc0 vy cv clt wbr cB cme wcel cC cme wcel wa cB cC wss
      wa vx cv cX wcel wa cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx
      cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa cc0
      vz cv clt wbr vx cv vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw cv
      cF cX cres cfv cD co vy cv clt wbr wi vw cX wral wa vz cr cB cme wcel cC
      cme wcel wa cB cC wss wa vx cv cX wcel wa vx cv vw cv cC co vz cv clt wbr
      vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral vx cv
      vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw cv cF cX cres cfv cD co
      vy cv clt wbr wi vw cX wral cc0 vz cv clt wbr cB cme wcel cC cme wcel wa
      cB cC wss wa vx cv cX wcel wa vx cv vw cv cC co vz cv clt wbr vx cv cF
      cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral vx cv vw cv cC
      co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX
      wral vx cv vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw cv cF cX
      cres cfv cD co vy cv clt wbr wi vw cX wral cB cC wss vx cv vw cv cC co vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm
      wral vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy
      cv clt wbr wi vw cX wral wi cB cme wcel cC cme wcel wa vx cv cX wcel cB
      cC wss cX cC cdm cdm wss vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw
      cv cF cfv cD co vy cv clt wbr wi vw cC cdm cdm wral vx cv vw cv cC co vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX wral wi
      cB cC cX cC cdm cdm metcnss2.1 cC cdm cdm eqid metss vx cv vw cv cC co vz
      cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi vw cX cC cdm
      cdm ssralv syl ad2antlr cB cme wcel cC cme wcel wa cB cC wss wa vx cv cX
      wcel wa vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co
      vy cv clt wbr wi vx cv vw cv cB co vz cv clt wbr vx cv cF cX cres cfv vw
      cv cF cX cres cfv cD co vy cv clt wbr wi vw cX cB cme wcel cC cme wcel wa
      cB cC wss wa vx cv cX wcel wa vw cv cX wcel wa vx cv vw cv cB co vz cv
      clt wbr vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr wi
      vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt
      wbr wi cB cme wcel cC cme wcel wa cB cC wss wa vx cv cX wcel wa vw cv cX
      wcel wa vx cv vw cv cB co vz cv clt wbr vx cv vw cv cC co vz cv clt wbr
      vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr vx cv cF
      cfv vw cv cF cfv cD co vy cv clt wbr cB cme wcel cC cme wcel wa cB cC wss
      wa vx cv cX wcel wa vw cv cX wcel wa vx cv vw cv cB co vx cv vw cv cC co
      vz cv clt cB cme wcel cC cme wcel wa cB cC wss wa vx cv cX wcel wa vw cv
      cX wcel wa vx cv vw cv cC cX cX cxp cres co vx cv vw cv cB co vx cv vw cv
      cC co cB cme wcel cC cme wcel wa cB cC wss wa vx cv vw cv cC cX cX cxp
      cres co vx cv vw cv cB co wceq vx cv cX wcel vw cv cX wcel cB cme wcel cC
      cme wcel wa cB cC wss wa cC cX cX cxp cres cB vx cv vw cv cB cme wcel cC
      cme wcel wa cB cC wss wa cC cB cdm cres cC cX cX cxp cres cB cB cme wcel
      cC cB cdm cres cC cX cX cxp cres wceq cC cme wcel cB cC wss cB cme wcel
      cX cX cxp cr cB wf cB cdm cX cX cxp wceq cC cB cdm cres cC cX cX cxp cres
      wceq cB cX metcnss2.1 metf cX cX cxp cr cB fdm cB cdm cX cX cxp cC reseq2
      3syl ad2antrr cC cme wcel cB cC wss cC cB cdm cres cB wceq cB cme wcel cC
      wfun cB cC wss cC cB cdm cres cB wceq cC cme wcel cC cB funssres cC cme
      wcel cC cdm cdm cC cdm cdm cxp cr cC wf cC wfun cC cC cdm cdm cC cdm cdm
      eqid metf cC cdm cdm cC cdm cdm cxp cr cC ffun syl sylan adantll eqtr3d
      opreqd ad2antrr vx cv cX wcel vw cv cX wcel vx cv vw cv cC cX cX cxp cres
      co vx cv vw cv cC co wceq cB cme wcel cC cme wcel wa cB cC wss wa vx cv
      vw cv cX cX cC oprvres adantll eqtr3d breq1d vx cv cX wcel vw cv cX wcel
      vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr vx cv cF
      cfv vw cv cF cfv cD co vy cv clt wbr wb cB cme wcel cC cme wcel wa cB cC
      wss wa vx cv cX wcel vw cv cX wcel wa vx cv cF cX cres cfv vw cv cF cX
      cres cfv cD co vx cv cF cfv vw cv cF cfv cD co vy cv clt vx cv cX wcel vw
      cv cX wcel vx cv cF cX cres cfv vx cv cF cfv vw cv cF cX cres cfv vw cv
      cF cfv cD vx cv cX cF fvres vw cv cX cF fvres opreqan12d breq1d adantll
      imbi12d biimprd r19.20dva syld anim2d r19.22sdv imim2d r19.20sdv
      r19.20dva syld anim12d 3adantl3 cB cme wcel cC cme wcel cD cme wcel w3a
      cF cK cL ccn co wcel cC cdm cdm cD cdm cdm cF wf cc0 vy cv clt wbr cc0 vz
      cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD
      co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC
      cdm cdm wral wa wb cB cC wss cC cme wcel cD cme wcel cF cK cL ccn co wcel
      cC cdm cdm cD cdm cdm cF wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw
      cv cC co vz cv clt wbr vx cv cF cfv vw cv cF cfv cD co vy cv clt wbr wi
      vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC cdm cdm wral wa wb
      cB cme wcel vx vy vz vw cC cD cF cK cL cC cdm cdm cD cdm cdm cC cdm cdm
      eqid metcnss2.3 cD cdm cdm eqid metcnss2.4 metcn 3adant1 adantr cB cme
      wcel cC cme wcel cD cme wcel w3a cF cX cres cJ cL ccn co wcel cX cD cdm
      cdm cF cX cres wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co
      vz cv clt wbr vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt
      wbr wi vw cX wral wa vz cr wrex wi vy cr wral vx cX wral wa wb cB cC wss
      cB cme wcel cD cme wcel cF cX cres cJ cL ccn co wcel cX cD cdm cdm cF cX
      cres wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cB co vz cv clt
      wbr vx cv cF cX cres cfv vw cv cF cX cres cfv cD co vy cv clt wbr wi vw
      cX wral wa vz cr wrex wi vy cr wral vx cX wral wa wb cC cme wcel vx vy vz
      vw cB cD cF cX cres cJ cL cX cD cdm cdm metcnss2.1 metcnss2.2 cD cdm cdm
      eqid metcnss2.4 metcn 3adant2 adantr 3imtr4d imp anasss $.
      $( [5-Dec-2007] $) $( [23-Aug-2007] $)
  $}

  ${
    metidcn.1 $e |- X = dom dom C $.
    metidcn.3 $e |- J = ( Open ` C ) $.
    metidcn.4 $e |- K = ( Open ` D ) $.
    $( The identity function is continuous (metric space version of
       ~ idcn ). $)
    metidcn $p |- ( ( C e. Met /\ D e. Met /\ C C_ D ) ->
       ( _I |` X ) e. ( J Cn K ) ) $=
      cC cme wcel cD cme wcel cC cD wss w3a cJ cJ ccn co cJ cK ccn co cid cX
      cres cC cme wcel cD cme wcel cC cD wss cJ cJ ccn co cJ cK ccn co wss cC
      cme wcel cC cme wcel cD cme wcel w3a cC cD wss cJ cJ ccn co cJ cK ccn co
      wss cC cme wcel cD cme wcel wa cC cC cD cJ cJ cK metidcn.3 metidcn.3
      metidcn.4 metcnss cC cme wcel cD cme wcel cC cme wcel cC cme wcel cD cme
      wcel w3a cC cme wcel cC cme wcel cD cme wcel w3a id 3anidm12 sylan 3impa
      cC cme wcel cD cme wcel cid cX cres cJ cJ ccn co wcel cC cD wss cC cme
      wcel cid cJ cuni cres cid cX cres cJ cJ ccn co cC cme wcel cJ cuni cX
      wceq cid cJ cuni cres cid cX cres wceq cC cJ cX metidcn.1 metidcn.3
      uniopn2 cJ cuni cX cid reseq2 syl cC cme wcel cJ ctop wcel cid cJ cuni
      cres cJ cJ ccn co wcel cC cJ metidcn.3 opntop cJ cJ cuni cJ cuni eqid
      idcn syl eqeltrrd 3ad2ant1 sseldd $.
      $( [3-Dec-2007] $) $( [23-Aug-2007] $)
  $}

  ${
    metdnsconst.1 $e |- X = dom dom C $.
    metdnsconst.2 $e |- Y = dom dom D $.
    metdnsconst.3 $e |- J = ( Open ` C ) $.
    metdnsconst.4 $e |- K = ( Open ` D ) $.
    $( If a continuous mapping to a metric space is constant on a dense
       subset, it is constant on the entire space (metric space version of
       ~ dnsconst ). $)
    metdnsconst $p |- ( ( ( C e. Met /\ D e. Met /\ F e. ( J Cn K ) ) /\
             ( P e. Y /\ A C_ ( `' F " { P } ) /\
                 ( ( cls ` J ) ` A ) = X ) ) -> F : X --> { P } ) $=
      cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cP cY wcel cA cF ccnv cP
      csn cima wss cA cJ ccl cfv cfv cX wceq w3a cX cP csn cF wf cC cme wcel cD
      cme wcel cF cJ cK ccn co wcel w3a cP cK cuni wcel cA cF ccnv cP csn cima
      wss cA cJ ccl cfv cfv cJ cuni wceq w3a cJ cuni cP csn cF wf cP cY wcel cA
      cF ccnv cP csn cima wss cA cJ ccl cfv cfv cX wceq w3a cX cP csn cF wf cJ
      ctop wcel cK cha wcel cF cJ cK ccn co wcel cP cK cuni wcel cA cF ccnv cP
      csn cima wss cA cJ ccl cfv cfv cJ cuni wceq w3a cJ cuni cP csn cF wf wi
      cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cJ ctop wcel cK cha wcel
      cF cJ cK ccn co wcel w3a cP cK cuni wcel cA cF ccnv cP csn cima wss cA cJ
      ccl cfv cfv cJ cuni wceq w3a cJ cuni cP csn cF wf cA cP cF cJ cK cJ cuni
      cK cuni cJ cuni eqid cK cuni eqid dnsconst ex cC cme wcel cD cme wcel cJ
      ctop wcel cF cJ cK ccn co wcel cC cJ metdnsconst.3 opntop 3ad2ant1 cD cme
      wcel cC cme wcel cK cha wcel cF cJ cK ccn co wcel cD cK metdnsconst.4
      methaus 3ad2ant2 cC cme wcel cD cme wcel cF cJ cK ccn co wcel 3simp3
      syl3anc cC cme wcel cD cme wcel cP cK cuni wcel cA cF ccnv cP csn cima
      wss cA cJ ccl cfv cfv cJ cuni wceq w3a cP cY wcel cA cF ccnv cP csn cima
      wss cA cJ ccl cfv cfv cX wceq w3a wb cF cJ cK ccn co wcel cC cme wcel cD
      cme wcel wa cP cK cuni wcel cP cY wcel cA cJ ccl cfv cfv cJ cuni wceq cA
      cJ ccl cfv cfv cX wceq cA cF ccnv cP csn cima wss cC cme wcel cD cme wcel
      wa cK cuni cY cP cD cme wcel cK cuni cY wceq cC cme wcel cD cK cY
      metdnsconst.2 metdnsconst.4 uniopn2 adantl eleq2d cC cme wcel cD cme wcel
      wa cJ cuni cX cA cJ ccl cfv cfv cC cme wcel cJ cuni cX wceq cD cme wcel
      cC cJ cX metdnsconst.1 metdnsconst.3 uniopn2 adantr eqeq2d 3anbi13d
      3adant3 cC cme wcel cD cme wcel cJ cuni cP csn cF wf cX cP csn cF wf wb
      cF cJ cK ccn co wcel cC cme wcel cJ cuni cX wceq cJ cuni cP csn cF wf cX
      cP csn cF wf wb cC cJ cX metdnsconst.1 metdnsconst.3 uniopn2 cJ cuni cX
      cP csn cF feq2 syl 3ad2ant1 3imtr3d imp $.
      $( [6-Dec-2007] $) $( [24-Aug-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Examples of metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d D x y z $.
    cnmet.1 $e |- D = ( abs o. - ) $.
    $( Value of the distance function of the metric space of complex
       numbers. $)
    cnmetdval $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( A D B ) = ( abs ` ( A - B ) ) ) $=
      cA cc wcel cB cc wcel wa cA cB cop cabs cmin ccom cfv cA cB cop cmin cfv
      cabs cfv cA cB cD co cA cB cmin co cabs cfv cA cc wcel cB cc wcel wa cA
      cB cop cmin cdm wcel cA cB cop cabs cmin ccom cfv cA cB cop cmin cfv cabs
      cfv wceq cA cc wcel cB cc wcel wa cA cB cop cc cc cxp cmin cdm cA cB cc
      cc opelxpi cc cc cxp cc cmin subopr fdmi syl6eleqr cabs wfun cmin wfun cA
      cB cop cmin cdm wcel cA cB cop cabs cmin ccom cfv cA cB cop cmin cfv cabs
      cfv wceq cc cr cabs wf cabs wfun absf cc cr cabs ffun ax-mp cc cc cxp cc
      cmin wf cmin wfun subopr cc cc cxp cc cmin ffun ax-mp cA cB cop cabs cmin
      fvco mp3an12 syl cA cB cD co cA cB cop cD cfv cA cB cop cabs cmin ccom
      cfv cA cB cD df-opr cA cB cop cD cabs cmin ccom cnmet.1 fveq1i eqtri cA
      cB cmin co cA cB cop cmin cfv cabs cA cB cmin df-opr fveq2i 3eqtr4g $.
      $( [7-Sep-2007] $) $( [9-Dec-2006] $)

    $( The base set of the metric for complex numbers. $)
    cnmetba $p |- CC = dom dom D $=
      cD cdm cdm cc cc cxp cdm cc cD cdm cc cc cxp cD cdm cabs cmin ccom cdm cc
      cc cxp cD cabs cmin ccom cnmet.1 dmeqi cc cc cxp cr cabs cmin ccom cc cr
      cabs wf cc cc cxp cc cmin wf cc cc cxp cr cabs cmin ccom wf absf subopr
      cc cc cxp cc cr cabs cmin fco mp2an fdmi eqtri dmeqi cc dmxpid eqtr2i $.
      $( [10-Sep-2007] $) $( [30-Aug-2007] $)

    $( The absolute value metric determines a metric space on the complex
       numbers.  This theorem provides a link between complex numbers and
       metrics spaces, making metric space theorems available for use with
       complex numbers.  (Contributed by FL, 9-Oct-2006.) $)
    cnmet $p |- D e. Met $=
      vx vy vz cD cc axcnex cc cc cxp cr cD wf cc cc cxp cr cabs cmin ccom wf
      cc cr cabs wf cc cc cxp cc cmin wf cc cc cxp cr cabs cmin ccom wf absf
      subopr cc cc cxp cc cr cabs cmin fco mp2an cD cabs cmin ccom wceq cc cc
      cxp cr cD wf cc cc cxp cr cabs cmin ccom wf wb cnmet.1 cc cc cxp cr cD
      cabs cmin ccom feq1 ax-mp mpbir vx cv cc wcel vy cv cc wcel wa vx cv vy
      cv cmin co cabs cfv cc0 wceq vx cv vy cv cmin co cc0 wceq vx cv vy cv cD
      co cc0 wceq vx cv vy cv wceq vx cv cc wcel vy cv cc wcel wa vx cv vy cv
      cmin co cc wcel vx cv vy cv cmin co cabs cfv cc0 wceq vx cv vy cv cmin co
      cc0 wceq wb vx cv vy cv subcl vx cv vy cv cmin co abs00 syl vx cv cc wcel
      vy cv cc wcel wa vx cv vy cv cmin co cabs cfv vx cv vy cv cD co cc0 vx cv
      cc wcel vy cv cc wcel wa vx cv vy cv cD co vx cv vy cv cmin co cabs cfv
      vx cv vy cv cD cnmet.1 cnmetdval eqcomd eqeq1d vx cv vy cv subeq0 3bitr3d
      vx cv cc wcel vy cv cc wcel vz cv cc wcel w3a vx cv vy cv cmin co cabs
      cfv vz cv vx cv cmin co cabs cfv vz cv vy cv cmin co cabs cfv caddc co vx
      cv vy cv cD co vz cv vx cv cD co vz cv vy cv cD co caddc co cle vx cv cc
      wcel vy cv cc wcel vz cv cc wcel w3a vx cv vy cv cmin co cabs cfv vx cv
      vz cv cmin co cabs cfv vz cv vy cv cmin co cabs cfv caddc co vz cv vx cv
      cmin co cabs cfv vz cv vy cv cmin co cabs cfv caddc co cle vx cv vy cv vz
      cv abs3dif vx cv cc wcel vz cv cc wcel vx cv vz cv cmin co cabs cfv vz cv
      vy cv cmin co cabs cfv caddc co vz cv vx cv cmin co cabs cfv vz cv vy cv
      cmin co cabs cfv caddc co wceq vy cv cc wcel vx cv cc wcel vz cv cc wcel
      wa vx cv vz cv cmin co cabs cfv vz cv vx cv cmin co cabs cfv vz cv vy cv
      cmin co cabs cfv caddc vx cv vz cv abssub opreq1d 3adant2 breqtrd vx cv
      cc wcel vy cv cc wcel vx cv vy cv cD co vx cv vy cv cmin co cabs cfv wceq
      vz cv cc wcel vx cv vy cv cD cnmet.1 cnmetdval 3adant3 vz cv cc wcel vx
      cv cc wcel vy cv cc wcel vz cv vx cv cD co vz cv vy cv cD co caddc co vz
      cv vx cv cmin co cabs cfv vz cv vy cv cmin co cabs cfv caddc co wceq vz
      cv cc wcel vx cv cc wcel vy cv cc wcel w3a vz cv vx cv cD co vz cv vx cv
      cmin co cabs cfv vz cv vy cv cD co vz cv vy cv cmin co cabs cfv caddc vz
      cv cc wcel vx cv cc wcel vz cv vx cv cD co vz cv vx cv cmin co cabs cfv
      wceq vy cv cc wcel vz cv vx cv cD cnmet.1 cnmetdval 3adant3 vz cv cc wcel
      vy cv cc wcel vz cv vy cv cD co vz cv vy cv cmin co cabs cfv wceq vx cv
      cc wcel vz cv vy cv cD cnmet.1 cnmetdval 3adant2 opreq12d 3coml 3brtr4d
      ismeti $.
      $( [7-Sep-2007] $) $( [6-Oct-2006] $)
  $}

  ${
    $d A f w x y z $.  $d B f w x y z $.  $d C w x y z $.  $d D w x y z $.
    $d J f w x y z $.  $d K f x y $.
    cncfmet.1 $e |- C = ( ( abs o. - ) |` ( A X. A ) ) $.
    cncfmet.2 $e |- D = ( ( abs o. - ) |` ( B X. B ) ) $.
    cncfmet.3 $e |- J = ( Open ` C ) $.
    cncfmet.4 $e |- K = ( Open ` D ) $.
    $( Relate complex function continuity to metric space continuity.
       (Contributed by Paul Chapman, 26-Nov-2007.) $)
    cncfmet $p |- ( ( A C_ CC /\ B C_ CC ) ->
                       ( A -cn-> B ) = ( J Cn K ) ) $=
      cA cc wss cB cc wss wa cJ cK ccn co cA cB ccncf co cA cc wss cB cc wss wa
      vf cJ cK ccn co cA cB ccncf co cA cc wss cB cc wss wa vf cv cJ cK ccn co
      wcel cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa vf cv cA cB ccncf co wcel cA cc wss cB
      cc wss wa cC cdm cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt
      wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co
      vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC cdm
      cdm wral wa cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx
      cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral
      vz crp wrex vy crp wral vx cA wral wa vf cv cJ cK ccn co wcel cA cc wss
      cB cc wss wa cC cdm cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv
      clt wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv
      cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx
      cC cdm cdm wral wa cA cB vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx
      cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv
      clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC cdm cdm
      wral wa cA cB vf cv wf vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv
      vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex vy crp wral vx cA wral wa cA cc wss cB cc wss wa cC cdm cdm cD
      cdm cdm vf cv wf cA cB vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv
      vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt
      wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC cdm cdm wral
      cC cdm cdm cA wceq cD cdm cdm cB wceq cC cdm cdm cD cdm cdm vf cv wf cA
      cB vf cv wf wb cA cc wss cB cc wss cC cdm cdm cD cdm cdm cA cB vf cv
      feq23 cA cc wss cC cdm cdm cA cA cxp cdm cA cA cc wss cC cdm cA cA cxp cA
      cc wss cA cA cxp cabs cmin ccom cdm cin cA cA cxp cC cdm cA cc wss cA cA
      cxp cc cc cxp cin cA cA cxp cA cA cxp cabs cmin ccom cdm cin cA cc wss cA
      cA cxp cc cc cxp wss cA cA cxp cc cc cxp cin cA cA cxp wceq cA cc wss cA
      cA cxp cc cc cxp wss cA cc cA cc ssxp anidms cA cA cxp cc cc cxp df-ss
      sylib cabs cmin ccom cdm cc cc cxp cA cA cxp cc cc cxp cr cabs cmin ccom
      cc cr cabs wf cc cc cxp cc cmin wf cc cc cxp cr cabs cmin ccom wf absf
      subopr cc cc cxp cc cr cabs cmin fco mp2an fdmi ineq2i syl5eq cC cdm cabs
      cmin ccom cA cA cxp cres cdm cA cA cxp cabs cmin ccom cdm cin cC cabs
      cmin ccom cA cA cxp cres cncfmet.1 dmeqi cabs cmin ccom cA cA cxp dmres
      eqtri syl5eq dmeqd cA dmxpid syl6eq cB cc wss cD cdm cdm cB cB cxp cdm cB
      cB cc wss cD cdm cB cB cxp cB cc wss cB cB cxp cabs cmin ccom cdm cin cB
      cB cxp cD cdm cB cc wss cB cB cxp cc cc cxp cin cB cB cxp cB cB cxp cabs
      cmin ccom cdm cin cB cc wss cB cB cxp cc cc cxp wss cB cB cxp cc cc cxp
      cin cB cB cxp wceq cB cc wss cB cB cxp cc cc cxp wss cB cc cB cc ssxp
      anidms cB cB cxp cc cc cxp df-ss sylib cabs cmin ccom cdm cc cc cxp cB cB
      cxp cc cc cxp cr cabs cmin ccom cc cr cabs wf cc cc cxp cc cmin wf cc cc
      cxp cr cabs cmin ccom wf absf subopr cc cc cxp cc cr cabs cmin fco mp2an
      fdmi ineq2i syl5eq cD cdm cabs cmin ccom cB cB cxp cres cdm cB cB cxp
      cabs cmin ccom cdm cin cD cabs cmin ccom cB cB cxp cres cncfmet.2 dmeqi
      cabs cmin ccom cB cB cxp dmres eqtri syl5eq dmeqd cB dmxpid syl6eq syl2an
      anbi1d cA cc wss cB cc wss wa cA cB vf cv wf cc0 vy cv clt wbr cc0 vz cv
      clt wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv
      cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx
      cC cdm cdm wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv
      cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp
      wrex vy crp wral vx cA wral cA cc wss cB cc wss cA cB vf cv wf cc0 vy cv
      clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv
      vw cv vf cv cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex
      wi vy cr wral vx cC cdm cdm wral vx cv vw cv cmin co cabs cfv vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw
      cA wral vz crp wrex vy crp wral vx cA wral wb cA cc wss cB cc wss cA cB
      vf cv wf w3a cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cC cdm
      cdm wral wa vz cr wrex wi vy cr wral vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral vz crp wrex vy crp wral vx cC cdm cdm cA cA cc wss cB cc wss
      cA cB vf cv wf w3a vx cv cC cdm cdm wcel cc0 vy cv clt wbr cc0 vz cv clt
      wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co
      vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral wi vx cv
      cA wcel cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cC cdm cdm
      wral wa vz cr wrex wi vy cr wral wi vx cv cA wcel vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral wi cA cc wss cB cc
      wss cA cB vf cv wf w3a vx cv cC cdm cdm wcel vx cv cA wcel cc0 vy cv clt
      wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi
      vy cr wral cA cc wss cB cc wss cA cB vf cv wf w3a cC cdm cdm cA vx cv cA
      cc wss cB cc wss cC cdm cdm cA wceq cA cB vf cv wf cA cc wss cC cdm cdm
      cA cA cxp cdm cA cA cc wss cC cdm cA cA cxp cA cc wss cA cA cxp cabs cmin
      ccom cdm cin cA cA cxp cC cdm cA cc wss cA cA cxp cc cc cxp cin cA cA cxp
      cA cA cxp cabs cmin ccom cdm cin cA cc wss cA cA cxp cc cc cxp wss cA cA
      cxp cc cc cxp cin cA cA cxp wceq cA cc wss cA cA cxp cc cc cxp wss cA cc
      cA cc ssxp anidms cA cA cxp cc cc cxp df-ss sylib cabs cmin ccom cdm cc
      cc cxp cA cA cxp cc cc cxp cr cabs cmin ccom cc cr cabs wf cc cc cxp cc
      cmin wf cc cc cxp cr cabs cmin ccom wf absf subopr cc cc cxp cc cr cabs
      cmin fco mp2an fdmi ineq2i syl5eq cC cdm cabs cmin ccom cA cA cxp cres
      cdm cA cA cxp cabs cmin ccom cdm cin cC cabs cmin ccom cA cA cxp cres
      cncfmet.1 dmeqi cabs cmin ccom cA cA cxp dmres eqtri syl5eq dmeqd cA
      dmxpid syl6eq 3ad2ant1 eleq2d imbi1d cA cc wss cB cc wss cA cB vf cv wf
      w3a vx cv cA wcel cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw
      cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral vz crp wrex vy crp wral cA cc wss cB cc wss cA cB vf cv
      wf w3a vx cv cA wcel wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv
      cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr
      wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral cc0 vy cv clt wbr vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex wi vy cr wral vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin
      co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy crp wral cA cc wss
      cB cc wss cA cB vf cv wf w3a vx cv cA wcel wa cc0 vy cv clt wbr cc0 vz cv
      clt wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv
      cD co vy cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex wi cc0 vy cv clt
      wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf
      cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex wi vy cr
      cA cc wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel wa cc0 vz cv clt wbr
      vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy
      cv clt wbr wi vw cC cdm cdm wral wa vz cr wrex vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex cc0 vy cv clt wbr cA cc wss cB cc wss
      cA cB vf cv wf w3a vx cv cA wcel wa cc0 vz cv clt wbr vx cv vw cv cC co
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw
      cC cdm cdm wral wa vz cr wrex cc0 vz cv clt wbr vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral wa vz cr wrex vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral vz crp wrex cA cc wss cB cc wss cA cB vf cv wf w3a vx cv cA
      wcel wa cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv
      vw cv vf cv cfv cD co vy cv clt wbr wi vw cC cdm cdm wral wa cc0 vz cv
      clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv
      vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral wa vz cr cA cc wss
      cB cc wss cA cB vf cv wf w3a vx cv cA wcel wa vx cv vw cv cC co vz cv clt
      wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vw cC cdm cdm
      wral vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf
      cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral cc0 vz cv clt wbr cA
      cc wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel wa vx cv vw cv cC co vz
      cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vx cv
      vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin
      co cabs cfv vy cv clt wbr wi vw cC cdm cdm cA cA cc wss cB cc wss cA cB
      vf cv wf w3a vx cv cA wcel wa vw cv cC cdm cdm wcel vx cv vw cv cC co vz
      cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi wi vw
      cv cA wcel vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cD co vy cv clt wbr wi wi vw cv cA wcel vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt
      wbr wi wi cA cc wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel wa vw cv
      cC cdm cdm wcel vw cv cA wcel vx cv vw cv cC co vz cv clt wbr vx cv vf cv
      cfv vw cv vf cv cfv cD co vy cv clt wbr wi cA cc wss cB cc wss cA cB vf
      cv wf w3a vx cv cA wcel wa cC cdm cdm cA vw cv cA cc wss cB cc wss cA cB
      vf cv wf w3a cC cdm cdm cA wceq vx cv cA wcel cA cc wss cB cc wss cC cdm
      cdm cA wceq cA cB vf cv wf cA cc wss cC cdm cdm cA cA cxp cdm cA cA cc
      wss cC cdm cA cA cxp cA cc wss cA cA cxp cabs cmin ccom cdm cin cA cA cxp
      cC cdm cA cc wss cA cA cxp cc cc cxp cin cA cA cxp cA cA cxp cabs cmin
      ccom cdm cin cA cc wss cA cA cxp cc cc cxp wss cA cA cxp cc cc cxp cin cA
      cA cxp wceq cA cc wss cA cA cxp cc cc cxp wss cA cc cA cc ssxp anidms cA
      cA cxp cc cc cxp df-ss sylib cabs cmin ccom cdm cc cc cxp cA cA cxp cc cc
      cxp cr cabs cmin ccom cc cr cabs wf cc cc cxp cc cmin wf cc cc cxp cr
      cabs cmin ccom wf absf subopr cc cc cxp cc cr cabs cmin fco mp2an fdmi
      ineq2i syl5eq cC cdm cabs cmin ccom cA cA cxp cres cdm cA cA cxp cabs
      cmin ccom cdm cin cC cabs cmin ccom cA cA cxp cres cncfmet.1 dmeqi cabs
      cmin ccom cA cA cxp dmres eqtri syl5eq dmeqd cA dmxpid syl6eq 3ad2ant1
      adantr eleq2d imbi1d cA cc wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel
      wa vw cv cA wcel vx cv vw cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf
      cv cfv cD co vy cv clt wbr wi vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi cA cc
      wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel vw cv cA wcel vx cv vw cv
      cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr
      wi vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cmin co cabs cfv vy cv clt wbr wi wb cA cc wss cB cc wss cA cB vf cv
      wf w3a vx cv cA wcel vw cv cA wcel vx cv vw cv cC co vz cv clt wbr vx cv
      vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr wi vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv
      clt wbr wi wb cA cc wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel vw cv
      cA wcel wa wa vx cv vw cv cC co vz cv clt wbr vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt wbr vx
      cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr cA cc wss cB
      cc wss cA cB vf cv wf w3a vx cv cA wcel vw cv cA wcel wa wa vx cv vw cv
      cC co vx cv vw cv cmin co cabs cfv vz cv clt cA cc wss cB cc wss vx cv cA
      wcel vw cv cA wcel wa vx cv vw cv cC co vx cv vw cv cmin co cabs cfv wceq
      cA cB vf cv wf cA cc wss vx cv cA wcel vw cv cA wcel wa wa vx cv vw cv cC
      co vx cv vw cv cabs cmin ccom co vx cv vw cv cmin co cabs cfv vx cv cA
      wcel vw cv cA wcel wa vx cv vw cv cC co vx cv vw cv cabs cmin ccom co
      wceq cA cc wss vx cv cA wcel vw cv cA wcel wa vx cv vw cv cabs cmin ccom
      cA cA cxp cres co vx cv vw cv cabs cmin ccom co vx cv vw cv cC co vx cv
      vw cv cA cA cabs cmin ccom oprvres cC cabs cmin ccom cA cA cxp cres vx cv
      vw cv cncfmet.1 opreqi syl5eq adantl cA cc wss vx cv cA wcel vw cv cA
      wcel wa wa vx cv cc wcel vw cv cc wcel wa vx cv vw cv cabs cmin ccom co
      vx cv vw cv cmin co cabs cfv wceq cA cc wss vx cv cA wcel vw cv cA wcel
      wa vx cv cc wcel vw cv cc wcel wa cA cc wss vx cv cA wcel vx cv cc wcel
      vw cv cA wcel vw cv cc wcel cA cc vx cv ssel cA cc vw cv ssel anim12d imp
      vx cv vw cv cabs cmin ccom cabs cmin ccom eqid cnmetdval syl eqtrd
      3ad2antl1 breq1d cA cc wss cB cc wss cA cB vf cv wf w3a vx cv cA wcel vw
      cv cA wcel wa wa vx cv vf cv cfv vw cv vf cv cfv cD co vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv vy cv clt cA cc wss cB cc wss cA cB vf cv
      wf w3a vx cv cA wcel vw cv cA wcel wa vx cv vf cv cfv cB wcel vw cv vf cv
      cfv cB wcel wa vx cv vf cv cfv vw cv vf cv cfv cD co vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv wceq cA cB vf cv wf cA cc wss vx cv cA wcel
      vw cv cA wcel wa vx cv vf cv cfv cB wcel vw cv vf cv cfv cB wcel wa cB cc
      wss cA cB vf cv wf vx cv cA wcel vw cv cA wcel wa vx cv vf cv cfv cB wcel
      vw cv vf cv cfv cB wcel wa cA cB vf cv wf vx cv cA wcel vx cv vf cv cfv
      cB wcel vw cv cA wcel vw cv vf cv cfv cB wcel cA cB vf cv wf vx cv cA
      wcel vx cv vf cv cfv cB wcel cA cB vx cv vf cv ffvelrn ex cA cB vf cv wf
      vw cv cA wcel vw cv vf cv cfv cB wcel cA cB vw cv vf cv ffvelrn ex
      anim12d imp 3ad2antl3 cB cc wss cA cc wss vx cv vf cv cfv cB wcel vw cv
      vf cv cfv cB wcel wa vx cv vf cv cfv vw cv vf cv cfv cD co vx cv vf cv
      cfv vw cv vf cv cfv cmin co cabs cfv wceq cA cB vf cv wf cB cc wss vx cv
      vf cv cfv cB wcel vw cv vf cv cfv cB wcel wa wa vx cv vf cv cfv vw cv vf
      cv cfv cD co vx cv vf cv cfv vw cv vf cv cfv cabs cmin ccom co vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vx cv vf cv cfv cB wcel vw cv vf
      cv cfv cB wcel wa vx cv vf cv cfv vw cv vf cv cfv cD co vx cv vf cv cfv
      vw cv vf cv cfv cabs cmin ccom co wceq cB cc wss vx cv vf cv cfv cB wcel
      vw cv vf cv cfv cB wcel wa vx cv vf cv cfv vw cv vf cv cfv cabs cmin ccom
      cB cB cxp cres co vx cv vf cv cfv vw cv vf cv cfv cabs cmin ccom co vx cv
      vf cv cfv vw cv vf cv cfv cD co vx cv vf cv cfv vw cv vf cv cfv cB cB
      cabs cmin ccom oprvres cD cabs cmin ccom cB cB cxp cres vx cv vf cv cfv
      vw cv vf cv cfv cncfmet.2 opreqi syl5eq adantl cB cc wss vx cv vf cv cfv
      cB wcel vw cv vf cv cfv cB wcel wa wa vx cv vf cv cfv cc wcel vw cv vf cv
      cfv cc wcel wa vx cv vf cv cfv vw cv vf cv cfv cabs cmin ccom co vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv wceq cB cc wss vx cv vf cv cfv cB
      wcel vw cv vf cv cfv cB wcel wa vx cv vf cv cfv cc wcel vw cv vf cv cfv
      cc wcel wa cB cc wss vx cv vf cv cfv cB wcel vx cv vf cv cfv cc wcel vw
      cv vf cv cfv cB wcel vw cv vf cv cfv cc wcel cB cc vx cv vf cv cfv ssel
      cB cc vw cv vf cv cfv ssel anim12d imp vx cv vf cv cfv vw cv vf cv cfv
      cabs cmin ccom cabs cmin ccom eqid cnmetdval syl eqtrd 3ad2antl2 syldan
      breq1d imbi12d 3impb 3expia pm5.74d bitrd ralbidv2 anbi2d rexbidv vz cv
      crp wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv
      vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral wa vz wex vz cv cr
      wcel cc0 vz cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv
      vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral wa
      wa vz wex vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex cc0
      vz cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv
      vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral wa vz cr
      wrex vz cv crp wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral wa vz
      cv cr wcel cc0 vz cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral wa wa vz vz cv crp wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral wa vz cv cr wcel cc0 vz cv clt wbr wa vx cv vw cv cmin co cabs cfv
      vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt
      wbr wi vw cA wral wa vz cv cr wcel cc0 vz cv clt wbr vx cv vw cv cmin co
      cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv
      vy cv clt wbr wi vw cA wral wa wa vz cv crp wcel vz cv cr wcel cc0 vz cv
      clt wbr wa vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz cv elrp
      anbi1i vz cv cr wcel cc0 vz cv clt wbr vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral anass bitri exbii vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp df-rex cc0 vz cv clt wbr vx cv vw cv cmin co cabs cfv vz cv
      clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi
      vw cA wral wa vz cr df-rex 3bitr4ri syl6bb imbi2d ralbidv vy cv crp wcel
      vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv
      cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex wi vy wal vy
      cv cr wcel cc0 vy cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex wi wi vy wal vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex vy crp wral cc0 vy cv clt wbr vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex wi vy cr wral vy cv crp wcel vx cv vw
      cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co
      cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex wi vy cv cr wcel cc0 vy
      cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex wi
      wi vy vy cv crp wcel vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf
      cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz
      crp wrex wi vy cv cr wcel cc0 vy cv clt wbr wa vx cv vw cv cmin co cabs
      cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv
      clt wbr wi vw cA wral vz crp wrex wi vy cv cr wcel cc0 vy cv clt wbr vx
      cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv
      cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex wi wi vy cv crp
      wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv vw cv cmin co cabs cfv vz
      cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr
      wi vw cA wral vz crp wrex vy cv elrp imbi1i vy cv cr wcel cc0 vy cv clt
      wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw cv vf
      cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex impexp
      bitri albii vx cv vw cv cmin co cabs cfv vz cv clt wbr vx cv vf cv cfv vw
      cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA wral vz crp wrex vy
      crp df-ral cc0 vy cv clt wbr vx cv vw cv cmin co cabs cfv vz cv clt wbr
      vx cv vf cv cfv vw cv vf cv cfv cmin co cabs cfv vy cv clt wbr wi vw cA
      wral vz crp wrex wi vy cr df-ral 3bitr4ri syl6bb pm5.74da bitrd ralbidv2
      3expa pm5.32da bitrd cC cme wcel cD cme wcel vf cv cJ cK ccn co wcel cC
      cdm cdm cD cdm cdm vf cv wf cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw
      cv cC co vz cv clt wbr vx cv vf cv cfv vw cv vf cv cfv cD co vy cv clt
      wbr wi vw cC cdm cdm wral wa vz cr wrex wi vy cr wral vx cC cdm cdm wral
      wa wb cC cabs cmin ccom cA cA cxp cres cme cncfmet.1 cabs cmin ccom cme
      wcel cabs cmin ccom cA cA cxp cres cme wcel cabs cmin ccom cabs cmin ccom
      eqid cnmet cabs cmin ccom cA metres ax-mp eqeltri cD cabs cmin ccom cB cB
      cxp cres cme cncfmet.2 cabs cmin ccom cme wcel cabs cmin ccom cB cB cxp
      cres cme wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cB
      metres ax-mp eqeltri vx vy vz vw cC cD vf cv cJ cK cC cdm cdm cD cdm cdm
      cC cdm cdm eqid cncfmet.3 cD cdm cdm eqid cncfmet.4 metcn mp2an syl5bb vx
      vy vz vw cA cB vf cv elcncf bitr4d eqrdv eqcomd $.
      $( [27-Nov-2007] $) $( [11-Oct-2007] $)
  $}

  ${
    cncfmet1.1 $e |- D = ( abs o. - ) $.
    cncfmet1.2 $e |- J = ( Open ` D ) $.
    $( Relate complex function continuity to metric space continuity.
       (Contributed by Paul Chapman, 28-Nov-2007.) $)
    cncfmet1 $p |- ( CC -cn-> CC ) = ( J Cn J ) $=
      cc cc wss cc cc wss cc cc ccncf co cJ cJ ccn co wceq cc ssid cc ssid cc
      cc cD cD cJ cJ cD cabs cmin ccom cabs cmin ccom cc cc cxp cres cncfmet1.1
      cabs cmin ccom wrel cabs cmin ccom cdm cc cc cxp wss cabs cmin ccom cc cc
      cxp cres cabs cmin ccom wceq cabs cmin relco cabs cmin ccom cdm cc cc cxp
      cabs cmin ccom cdm cmin cdm cc cc cxp cmin crn cabs cdm wss cabs cmin
      ccom cdm cmin cdm wceq cmin crn cc cabs cdm cc cc cxp cc cmin wf cmin crn
      cc wss subopr cc cc cxp cc cmin frn ax-mp cc cr cabs absf fdmi sseqtr4i
      cabs cmin dmcosseq ax-mp cc cc cxp cc cmin subopr fdmi eqtri eqimssi cabs
      cmin ccom cc cc cxp relssres mp2an eqtr4i cD cabs cmin ccom cabs cmin
      ccom cc cc cxp cres cncfmet1.1 cabs cmin ccom wrel cabs cmin ccom cdm cc
      cc cxp wss cabs cmin ccom cc cc cxp cres cabs cmin ccom wceq cabs cmin
      relco cabs cmin ccom cdm cc cc cxp cabs cmin ccom cdm cmin cdm cc cc cxp
      cmin crn cabs cdm wss cabs cmin ccom cdm cmin cdm wceq cmin crn cc cabs
      cdm cc cc cxp cc cmin wf cmin crn cc wss subopr cc cc cxp cc cmin frn
      ax-mp cc cr cabs absf fdmi sseqtr4i cabs cmin dmcosseq ax-mp cc cc cxp cc
      cmin subopr fdmi eqtri eqimssi cabs cmin ccom cc cc cxp relssres mp2an
      eqtr4i cncfmet1.2 cncfmet1.2 cncfmet mp2an $.
      $( [28-Nov-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    $d x y z C $.
    cn2met.1 $e |- C = ( abs o. - ) $.
    cn2met.2 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( CC X. CC ) /\
             y e. ( CC X. CC ) ) /\ z = sup ( { ( ( 1st ` x ) C ( 1st ` y ) ) ,
                  ( ( 2nd ` x ) C ( 2nd ` y ) ) } , RR , < ) ) } $.
    $( The standard metric space on ` CC X. CC ` . $)
    cn2met $p |- D e. Met $=
      vx vy vz cC cC cD cc cc cC cn2met.1 cnmetba cC cn2met.1 cnmetba cC
      cn2met.1 cnmet cC cn2met.1 cnmet cn2met.2 metxp $.
      $( [7-Oct-2007] $) $( [21-Jun-2007] $)
  $}

  ${
    $d r s t u v w D $.  $d v w A $.  $d v w B $.
    remet.1 $e |- D = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    $( Value of the distance function of the metric space of real numbers. $)
    remetdval $p |- ( ( A e. RR /\ B e. RR ) ->
                  ( A D B ) = ( abs ` ( A - B ) ) ) $=
      cA cr wcel cB cr wcel wa cA cB cop cabs cmin ccom cr cr cxp cres cfv cA
      cB cmin co cabs cfv cA cB cD co cA cr wcel cB cr wcel wa cA cB cop cabs
      cmin ccom cr cr cxp cres cfv cA cB cop cabs cmin ccom cfv cA cB cmin co
      cabs cfv cA cr wcel cB cr wcel wa cA cB cop cr cr cxp wcel cA cB cop cabs
      cmin ccom cr cr cxp cres cfv cA cB cop cabs cmin ccom cfv wceq cA cB cr
      cr opelxpi cA cB cop cr cr cxp cabs cmin ccom fvres syl cA cr wcel cB cr
      wcel wa cA cB cabs cmin ccom co cA cB cmin co cabs cfv cA cB cop cabs
      cmin ccom cfv cA cc wcel cB cc wcel cA cB cabs cmin ccom co cA cB cmin co
      cabs cfv wceq cA cr wcel cB cr wcel cA cB cabs cmin ccom cabs cmin ccom
      eqid cnmetdval cA recn cB recn syl2an cA cB cabs cmin ccom df-opr syl5eqr
      eqtrd cA cB cD co cA cB cop cD cfv cA cB cop cabs cmin ccom cr cr cxp
      cres cfv cA cB cD df-opr cA cB cop cD cabs cmin ccom cr cr cxp cres
      remet.1 fveq1i eqtri syl5eq $.
      $( [20-Sep-2007] $) $( [16-May-2007] $)

    $( The base set for the metric for real numbers. $)
    remetba $p |- RR = dom dom D $=
      cD cdm cdm cr cr cxp cdm cr cD cdm cr cr cxp cD cdm cabs cmin ccom cr cr
      cxp cres cdm cr cr cxp cabs cmin ccom cdm cin cr cr cxp cD cabs cmin ccom
      cr cr cxp cres remet.1 dmeqi cabs cmin ccom cr cr cxp dmres cr cr cxp
      cabs cmin ccom cdm wss cr cr cxp cabs cmin ccom cdm cin cr cr cxp wceq cr
      cr cxp cc cc cxp cabs cmin ccom cdm cr cc wss cr cc wss cr cr cxp cc cc
      cxp wss axresscn axresscn cr cc cr cc ssxp mp2an cc cc cxp cr cabs cmin
      ccom cc cr cabs wf cc cc cxp cc cmin wf cc cc cxp cr cabs cmin ccom wf
      absf subopr cc cc cxp cc cr cabs cmin fco mp2an fdmi sseqtr4i cr cr cxp
      cabs cmin ccom cdm df-ss mpbi 3eqtri dmeqi cr dmxpid eqtr2i $.
      $( [20-Sep-2007] $) $( [30-Aug-2007] $)

    $( The absolute value metric determines a metric space on the reals. $)
    remet $p |- D e. Met $=
      cD cabs cmin ccom cr cr cxp cres cme remet.1 cabs cmin ccom cme wcel cabs
      cmin ccom cr cr cxp cres cme wcel cabs cmin ccom cabs cmin ccom eqid
      cnmet cabs cmin ccom cr metres ax-mp eqeltri $.
      $( [21-Sep-2007] $) $( [10-Feb-2007] $)

    $( A ball in terms of an open interval of reals. $)
    bl2ioo $p |- ( ( A e. RR /\ B e. RR /\ 0 < B ) -> ( A ( ball ` D
                  ) B ) = ( ( A - B ) (,) ( A + B ) ) ) $=
      cA cr wcel cB cr wcel cc0 cB clt wbr w3a vw cA cB cD cbl cfv co cA cB
      cmin co cA cB caddc co cioo co cA cr wcel cB cr wcel cc0 cB clt wbr w3a
      vw cv cA cB cD cbl cfv co wcel vw cv cr wcel cA vw cv cD co cB clt wbr wa
      vw cv cA cB cmin co cA cB caddc co cioo co wcel cA cr wcel cB cr wcel cc0
      cB clt wbr vw cv cA cB cD cbl cfv co wcel vw cv cr wcel cA vw cv cD co cB
      clt wbr wa wb cD cme wcel cA cr wcel cB cr wcel cc0 cB clt wbr wa vw cv
      cA cB cD cbl cfv co wcel vw cv cr wcel cA vw cv cD co cB clt wbr wa wb cD
      remet.1 remet vw cv cD cA cB cr cD remet.1 remetba elbl mpanl1 3impb cA
      cr wcel cB cr wcel vw cv cA cB cmin co cA cB caddc co cioo co wcel vw cv
      cr wcel cA vw cv cD co cB clt wbr wa wb cc0 cB clt wbr cA cr wcel cB cr
      wcel wa vw cv cA cB cmin co cA cB caddc co cioo co wcel vw cv cr wcel cA
      cB cmin co vw cv clt wbr vw cv cA cB caddc co clt wbr w3a vw cv cr wcel
      cA vw cv cD co cB clt wbr wa cA cB cmin co cxr wcel cA cB caddc co cxr
      wcel vw cv cA cB cmin co cA cB caddc co cioo co wcel vw cv cr wcel cA cB
      cmin co vw cv clt wbr vw cv cA cB caddc co clt wbr w3a wb cA cr wcel cB
      cr wcel wa cA cB cmin co cA cB caddc co vw cv elioo2 cA cr wcel cB cr
      wcel wa cA cB cmin co cr wcel cA cB cmin co cxr wcel cA cB resubcl cA cB
      cmin co rexr syl cA cr wcel cB cr wcel wa cA cB caddc co cr wcel cA cB
      caddc co cxr wcel cA cB readdcl cA cB caddc co rexr syl sylanc cA cr wcel
      cB cr wcel wa vw cv cr wcel cA cB cmin co vw cv clt wbr vw cv cA cB caddc
      co clt wbr wa wa vw cv cr wcel cA vw cv cD co cB clt wbr wa vw cv cr wcel
      cA cB cmin co vw cv clt wbr vw cv cA cB caddc co clt wbr w3a cA cr wcel
      cB cr wcel wa vw cv cr wcel cA cB cmin co vw cv clt wbr vw cv cA cB caddc
      co clt wbr wa cA vw cv cD co cB clt wbr cA cr wcel cB cr wcel wa vw cv cr
      wcel wa cA vw cv cD co cB clt wbr vw cv cA cmin co cabs cfv cB clt wbr cA
      cB cmin co vw cv clt wbr vw cv cA cB caddc co clt wbr wa cA cr wcel cB cr
      wcel wa vw cv cr wcel wa cA vw cv cD co vw cv cA cmin co cabs cfv cB clt
      cA cr wcel vw cv cr wcel cA vw cv cD co vw cv cA cmin co cabs cfv wceq cB
      cr wcel cA cr wcel vw cv cr wcel wa cA vw cv cD co cA vw cv cmin co cabs
      cfv vw cv cA cmin co cabs cfv cA vw cv cD remet.1 remetdval cA cc wcel vw
      cv cc wcel cA vw cv cmin co cabs cfv vw cv cA cmin co cabs cfv wceq cA cr
      wcel vw cv cr wcel cA vw cv abssub cA recn vw cv recn syl2an eqtrd
      adantlr breq1d cA cr wcel cB cr wcel vw cv cr wcel vw cv cA cmin co cabs
      cfv cB clt wbr cA cB cmin co vw cv clt wbr vw cv cA cB caddc co clt wbr
      wa wb vw cv cr wcel cA cr wcel cB cr wcel vw cv cA cmin co cabs cfv cB
      clt wbr cA cB cmin co vw cv clt wbr vw cv cA cB caddc co clt wbr wa wb vw
      cv cA cB absdiflt 3coml 3expa bitr2d pm5.32da vw cv cr wcel cA cB cmin co
      vw cv clt wbr vw cv cA cB caddc co clt wbr 3anass syl5bb bitrd 3adant3
      bitr4d eqrdv $.
      $( [21-Sep-2007] $) $( [18-May-2007] $)

    $( An open interval of reals in terms of a ball. $)
    ioo2bl $p |- ( ( A e. RR /\ B e. RR /\ A < B ) -> ( A (,) B ) =
     ( ( ( A + B ) / 2 ) ( ball ` D ) ( ( B - A ) / 2 ) ) ) $=
      cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cioo co cB cA caddc co c2
      cdiv co cB cA cmin co c2 cdiv co cD cbl cfv co cA cB caddc co c2 cdiv co
      cB cA cmin co c2 cdiv co cD cbl cfv co cB cr wcel cA cr wcel cA cB clt
      wbr cA cB cioo co cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co cD
      cbl cfv co wceq cB cr wcel cA cr wcel cA cB clt wbr w3a cB cA caddc co c2
      cdiv co cB cA cmin co c2 cdiv co cD cbl cfv co cB cA caddc co c2 cdiv co
      cB cA cmin co c2 cdiv co cmin co cB cA caddc co c2 cdiv co cB cA cmin co
      c2 cdiv co caddc co cioo co cA cB cioo co cB cA caddc co c2 cdiv co cr
      wcel cB cA cmin co c2 cdiv co cr wcel cc0 cB cA cmin co c2 cdiv co clt
      wbr cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co cD cbl cfv co cB
      cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co cmin co cB cA caddc co c2
      cdiv co cB cA cmin co c2 cdiv co caddc co cioo co wceq cB cr wcel cA cr
      wcel cA cB clt wbr w3a cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co
      cD remet.1 bl2ioo cB cr wcel cA cr wcel cB cA caddc co c2 cdiv co cr wcel
      cA cB clt wbr cB cr wcel cA cr wcel wa cB cA caddc co cr wcel cB cA caddc
      co c2 cdiv co cr wcel cB cA readdcl cB cA caddc co rehalfcl syl 3adant3
      cB cr wcel cA cr wcel cB cA cmin co c2 cdiv co cr wcel cA cB clt wbr cB
      cr wcel cA cr wcel wa cB cA cmin co cr wcel cB cA cmin co c2 cdiv co cr
      wcel cB cA resubcl cB cA cmin co rehalfcl syl 3adant3 cB cr wcel cA cr
      wcel cA cB clt wbr cc0 cB cA cmin co c2 cdiv co clt wbr cB cr wcel cA cr
      wcel wa cA cB clt wbr cc0 cB cA cmin co clt wbr cc0 cB cA cmin co c2 cdiv
      co clt wbr cA cr wcel cB cr wcel cA cB clt wbr cc0 cB cA cmin co clt wbr
      wb cA cB posdif ancoms cB cr wcel cA cr wcel wa cB cA cmin co cr wcel cc0
      cB cA cmin co clt wbr cc0 cB cA cmin co c2 cdiv co clt wbr wb cB cA
      resubcl cB cA cmin co halfpos2 syl bitrd biimp3a syl3anc cB cr wcel cA cr
      wcel cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co cmin co cB cA
      caddc co c2 cdiv co cB cA cmin co c2 cdiv co caddc co cioo co cA cB cioo
      co wceq cA cB clt wbr cB cc wcel cA cc wcel cB cA caddc co c2 cdiv co cB
      cA cmin co c2 cdiv co cmin co cB cA caddc co c2 cdiv co cB cA cmin co c2
      cdiv co caddc co cioo co cA cB cioo co wceq cB cr wcel cA cr wcel cB cc
      wcel cA cc wcel wa cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co
      cmin co cA cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co caddc co cB
      cioo cB cc wcel cA cc wcel wa cB cA caddc co cB cA cmin co cmin co c2
      cdiv co c2 cA cmul co c2 cdiv co cB cA caddc co c2 cdiv co cB cA cmin co
      c2 cdiv co cmin co cA cB cc wcel cA cc wcel wa cB cA caddc co cB cA cmin
      co cmin co c2 cA cmul co c2 cdiv cB cc wcel cA cc wcel wa cB cA caddc co
      cB cA cmin co cmin co cA cA caddc co c2 cA cmul co cB cc wcel cA cc wcel
      cB cA caddc co cB cA cmin co cmin co cA cA caddc co wceq cB cA cA pnncan
      3anidm23 cA cc wcel c2 cA cmul co cA cA caddc co wceq cB cc wcel cA
      2times adantl eqtr4d opreq1d cB cA caddc co cc wcel cB cA cmin co cc wcel
      cB cA caddc co cB cA cmin co cmin co c2 cdiv co cB cA caddc co c2 cdiv co
      cB cA cmin co c2 cdiv co cmin co wceq cB cc wcel cA cc wcel wa cB cA
      caddc co cc wcel cB cA cmin co cc wcel c2 cc wcel c2 cc0 wne wa cB cA
      caddc co cB cA cmin co cmin co c2 cdiv co cB cA caddc co c2 cdiv co cB cA
      cmin co c2 cdiv co cmin co wceq c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i cB
      cA caddc co cB cA cmin co c2 divsubdir mp3an3 cB cA addcl cB cA subcl
      sylanc cA cc wcel c2 cA cmul co c2 cdiv co cA wceq cB cc wcel cA cc wcel
      c2 cc wcel c2 cc0 wne c2 cA cmul co c2 cdiv co cA wceq 2cn 2ne0 cA c2
      divcan3 mp3an23 adantl 3eqtr3d cB cc wcel cA cc wcel wa cB cA caddc co cB
      cA cmin co caddc co c2 cdiv co c2 cB cmul co c2 cdiv co cB cA caddc co c2
      cdiv co cB cA cmin co c2 cdiv co caddc co cB cB cc wcel cA cc wcel wa cB
      cA caddc co cB cA cmin co caddc co c2 cB cmul co c2 cdiv cB cc wcel cA cc
      wcel wa cB cA caddc co cB cA cmin co caddc co cB cB caddc co c2 cB cmul
      co cB cc wcel cA cc wcel cB cA caddc co cB cA cmin co caddc co cB cB
      caddc co wceq cB cA cB ppncan 3anidm13 cB cc wcel c2 cB cmul co cB cB
      caddc co wceq cA cc wcel cB 2times adantr eqtr4d opreq1d cB cA caddc co
      cc wcel cB cA cmin co cc wcel cB cA caddc co cB cA cmin co caddc co c2
      cdiv co cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co caddc co wceq
      cB cc wcel cA cc wcel wa cB cA caddc co cc wcel cB cA cmin co cc wcel c2
      cc wcel c2 cc0 wne wa cB cA caddc co cB cA cmin co caddc co c2 cdiv co cB
      cA caddc co c2 cdiv co cB cA cmin co c2 cdiv co caddc co wceq c2 cc wcel
      c2 cc0 wne 2cn 2ne0 pm3.2i cB cA caddc co cB cA cmin co c2 divdir mp3an3
      cB cA addcl cB cA subcl sylanc cB cc wcel c2 cB cmul co c2 cdiv co cB
      wceq cA cc wcel cB cc wcel c2 cc wcel c2 cc0 wne c2 cB cmul co c2 cdiv co
      cB wceq 2cn 2ne0 cB c2 divcan3 mp3an23 adantr 3eqtr3d opreq12d cB recn cA
      recn syl2an 3adant3 eqtr2d 3com12 cA cr wcel cB cr wcel cA cB clt wbr w3a
      cA cB caddc co c2 cdiv co cB cA caddc co c2 cdiv co cB cA cmin co c2 cdiv
      co cD cbl cfv cA cr wcel cB cr wcel cA cB caddc co c2 cdiv co cB cA caddc
      co c2 cdiv co wceq cA cB clt wbr cA cr wcel cB cr wcel wa cA cB caddc co
      cB cA caddc co c2 cdiv cA cc wcel cB cc wcel cA cB caddc co cB cA caddc
      co wceq cA cr wcel cB cr wcel cA cB addcom cA recn cB recn syl2an opreq1d
      3adant3 opreq1d eqtr4d $.
      $( [15-Apr-2008] $) $( [18-May-2007] $)

    $( The balls of the standard real metric space are included in the open
       real intervals. $)
    blssioo $p |- ran ( ball ` D ) C_ ran (,) $=
      vw cD cbl cfv crn cioo crn vv cv vu cv cD cbl cfv co vw cv wceq vu cc0
      cpnf cioo co wrex vv cr wrex vt cv vs cv cioo co vw cv wceq vs cxr wrex
      vt cxr wrex vw cv cD cbl cfv crn wcel vw cv cioo crn wcel vv cv vu cv cD
      cbl cfv co vw cv wceq vt cv vs cv cioo co vw cv wceq vs cxr wrex vt cxr
      wrex vv vu cr cc0 cpnf cioo co vv cv cr wcel vu cv cr wcel cc0 vu cv clt
      wbr wa vv cv vu cv cD cbl cfv co vw cv wceq vt cv vs cv cioo co vw cv
      wceq vs cxr wrex vt cxr wrex wi vu cv cc0 cpnf cioo co wcel vv cv cr wcel
      vu cv cr wcel cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vw cv wceq vt
      cv vs cv cioo co vw cv wceq vs cxr wrex vt cxr wrex wi vv cv cr wcel vu
      cv cr wcel cc0 vu cv clt wbr w3a vv cv vu cv cD cbl cfv co vw cv wceq vv
      cv vu cv cmin co vv cv vu cv caddc co cioo co vw cv wceq vt cv vs cv cioo
      co vw cv wceq vs cxr wrex vt cxr wrex vv cv cr wcel vu cv cr wcel cc0 vu
      cv clt wbr w3a vv cv vu cv cD cbl cfv co vv cv vu cv cmin co vv cv vu cv
      caddc co cioo co vw cv vv cv vu cv cD remet.1 bl2ioo eqeq1d vv cv cr wcel
      vu cv cr wcel vv cv vu cv cmin co vv cv vu cv caddc co cioo co vw cv wceq
      vt cv vs cv cioo co vw cv wceq vs cxr wrex vt cxr wrex wi cc0 vu cv clt
      wbr vv cv vu cv cmin co cr wcel vv cv vu cv caddc co cr wcel vv cv vu cv
      cmin co vv cv vu cv caddc co cioo co vw cv wceq vt cv vs cv cioo co vw cv
      wceq vs cxr wrex vt cxr wrex wi vv cv cr wcel vu cv cr wcel wa vv cv vu
      cv cmin co cxr wcel vv cv vu cv caddc co cxr wcel vv cv vu cv cmin co vv
      cv vu cv caddc co cioo co vw cv wceq vt cv vs cv cioo co vw cv wceq vs
      cxr wrex vt cxr wrex wi vv cv vu cv cmin co cr wcel vv cv vu cv caddc co
      cr wcel vv cv vu cv cmin co cxr wcel vv cv vu cv caddc co cxr wcel vv cv
      vu cv cmin co vv cv vu cv caddc co cioo co vw cv wceq vt cv vs cv cioo co
      vw cv wceq vs cxr wrex vt cxr wrex vt cv vs cv cioo co vw cv wceq vv cv
      vu cv cmin co vv cv vu cv caddc co cioo co vw cv wceq vv cv vu cv cmin co
      vs cv cioo co vw cv wceq vt vs vv cv vu cv cmin co vv cv vu cv caddc co
      cxr cxr vt cv vv cv vu cv cmin co wceq vt cv vs cv cioo co vv cv vu cv
      cmin co vs cv cioo co vw cv vt cv vv cv vu cv cmin co vs cv cioo opreq1
      eqeq1d vs cv vv cv vu cv caddc co wceq vv cv vu cv cmin co vs cv cioo co
      vv cv vu cv cmin co vv cv vu cv caddc co cioo co vw cv vs cv vv cv vu cv
      caddc co vv cv vu cv cmin co cioo opreq2 eqeq1d rcla42ev 3expia vv cv vu
      cv cmin co rexr vv cv vu cv caddc co rexr syl2an vv cv vu cv resubcl vv
      cv vu cv readdcl sylanc 3adant3 sylbid 3expb vu cv repos sylan2b
      r19.23aivv cD cbl cfv cr cc0 cpnf cioo co cxp wfn vw cv cD cbl cfv crn
      wcel vv cv vu cv cD cbl cfv co vw cv wceq vu cc0 cpnf cioo co wrex vv cr
      wrex wb cr cc0 cpnf cioo co cxp cr cpw cD cbl cfv wf cD cbl cfv cr cc0
      cpnf cioo co cxp wfn cD cme wcel cr cc0 cpnf cioo co cxp cr cpw cD cbl
      cfv wf cD remet.1 remet cD cr cD remet.1 remetba blf ax-mp cr cc0 cpnf
      cioo co cxp cr cpw cD cbl cfv ffn ax-mp vv vu cr cc0 cpnf cioo co vw cv
      cD cbl cfv oprvelrn ax-mp cioo cxr cxr cxp wfn vw cv cioo crn wcel vt cv
      vs cv cioo co vw cv wceq vs cxr wrex vt cxr wrex wb cxr cxr cxp cr cpw
      cioo wf cioo cxr cxr cxp wfn ioof cxr cxr cxp cr cpw cioo ffn ax-mp vt vs
      cxr cxr vw cv cioo oprvelrn ax-mp 3imtr4i ssriv $.
      $( [18-Oct-2007] $) $( [8-May-2007] $)

    $( Lemma for ~ tgioo .  An open interval includes a ball around any of its
       points.  _Warning:  The HTML proof page is 0.6MB in size_. $)
    tgioolem $p |- ( ( t e. RR* /\ s e. RR* ) -> ( v e. ( t (,) s ) -> E. u e.
          RR ( 0 < u /\ ( v ( ball ` D ) u ) C_ ( t (,) s ) ) ) ) $=
      vt cv cxr wcel vs cv cxr wcel wa vv cv vt cv vs cv cioo co wcel vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a cc0 vu cv clt wbr vv cv
      vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vt cv vs cv vv
      cv elioo2 vt cv cr wcel vt cv cpnf wceq vt cv cmnf wceq w3o vs cv cr wcel
      vs cv cpnf wceq vs cv cmnf wceq w3o vv cv cr wcel vt cv vv cv clt wbr vv
      cv vs cv clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs
      cv cioo co wss wa vu cr wrex wi vt cv cxr wcel vs cv cxr wcel vt cv cr
      wcel vs cv cr wcel vs cv cpnf wceq vs cv cmnf wceq w3o vv cv cr wcel vt
      cv vv cv clt wbr vv cv vs cv clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD
      cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex wi vt cv cpnf wceq vt cv
      cmnf wceq vt cv cr wcel vs cv cr wcel vv cv cr wcel vt cv vv cv clt wbr
      vv cv vs cv clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv
      vs cv cioo co wss wa vu cr wrex wi vs cv cpnf wceq vs cv cmnf wceq vt cv
      cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo
      co wss wa vu cr wrex vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv
      vv cv clt wbr vv cv vs cv clt wbr w3a wa cc0 vu cv clt wbr vv cv vu cv cD
      cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vv cv vt cv cmin co vs
      cv vv cv cmin co vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv
      clt wbr vv cv vt cv cmin co cr wcel vv cv vs cv clt wbr vt cv cr wcel vv
      cv cr wcel vv cv vt cv cmin co cr wcel vs cv cr wcel vt cv vv cv clt wbr
      vv cv cr wcel vt cv cr wcel vv cv vt cv cmin co cr wcel vv cv vt cv
      resubcl ancoms ad2ant2r 3adantr3 vt cv cr wcel vs cv cr wcel wa vv cv cr
      wcel vt cv vv cv clt wbr vs cv vv cv cmin co cr wcel vv cv vs cv clt wbr
      vs cv cr wcel vv cv cr wcel vs cv vv cv cmin co cr wcel vt cv cr wcel vt
      cv vv cv clt wbr vs cv vv cv resubcl ad2ant2lr 3adantr3 vv cv vt cv cmin
      co cr wcel cc0 vv cv vt cv cmin co clt wbr vv cv vv cv vt cv cmin co cD
      cbl cfv co vt cv vs cv cioo co wss wa cc0 vu cv clt wbr vv cv vu cv cD
      cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vt cv cr wcel vs cv cr
      wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a wa vv
      cv vt cv cmin co vs cv vv cv cmin co cle wbr wa cc0 vu cv clt wbr vv cv
      vu cv cD cbl cfv co vt cv vs cv cioo co wss wa cc0 vv cv vt cv cmin co
      clt wbr vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co wss
      wa vu vv cv vt cv cmin co cr vu cv vv cv vt cv cmin co wceq cc0 vu cv clt
      wbr cc0 vv cv vt cv cmin co clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv
      cioo co wss vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co
      wss vu cv vv cv vt cv cmin co cc0 clt breq2 vu cv vv cv vt cv cmin co
      wceq vv cv vu cv cD cbl cfv co vv cv vv cv vt cv cmin co cD cbl cfv co vt
      cv vs cv cioo co vu cv vv cv vt cv cmin co vv cv cD cbl cfv opreq2 sseq1d
      anbi12d rcla4ev vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv
      clt wbr vv cv vs cv clt wbr w3a wa vv cv vt cv cmin co cr wcel vv cv vt
      cv cmin co vs cv vv cv cmin co cle wbr vt cv cr wcel vs cv cr wcel wa vv
      cv cr wcel vt cv vv cv clt wbr vv cv vt cv cmin co cr wcel vv cv vs cv
      clt wbr vt cv cr wcel vv cv cr wcel vv cv vt cv cmin co cr wcel vs cv cr
      wcel vt cv vv cv clt wbr vv cv cr wcel vt cv cr wcel vv cv vt cv cmin co
      cr wcel vv cv vt cv resubcl ancoms ad2ant2r 3adantr3 adantr vt cv cr wcel
      vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr
      w3a wa vv cv vt cv cmin co vs cv vv cv cmin co cle wbr wa cc0 vv cv vt cv
      cmin co clt wbr vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo
      co wss vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr
      vv cv vs cv clt wbr w3a wa cc0 vv cv vt cv cmin co clt wbr vv cv vt cv
      cmin co vs cv vv cv cmin co cle wbr vt cv cr wcel vs cv cr wcel wa vv cv
      cr wcel vt cv vv cv clt wbr cc0 vv cv vt cv cmin co clt wbr vv cv vs cv
      clt wbr vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr wa cc0 vv cv vt
      cv cmin co clt wbr vs cv cr wcel vt cv cr wcel vv cv cr wcel vt cv vv cv
      clt wbr cc0 vv cv vt cv cmin co clt wbr vt cv cr wcel vv cv cr wcel vt cv
      vv cv clt wbr cc0 vv cv vt cv cmin co clt wbr vt cv vv cv posdif biimp3a
      3expb adantlr 3adantr3 adantr vt cv cr wcel vs cv cr wcel wa vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a wa vv cv vt cv cmin co
      vs cv vv cv cmin co cle wbr wa vv cv vv cv vt cv cmin co cD cbl cfv co vt
      cv vv cv vv cv vt cv cmin co caddc co cioo co vt cv vs cv cioo co vt cv
      cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a wa vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vv cv vv cv
      vt cv cmin co caddc co cioo co wceq vv cv vt cv cmin co vs cv vv cv cmin
      co cle wbr vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt
      wbr vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vv cv vv cv vt cv cmin
      co caddc co cioo co wceq vv cv vs cv clt wbr vt cv cr wcel vv cv cr wcel
      vt cv vv cv clt wbr wa vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vv
      cv vv cv vt cv cmin co caddc co cioo co wceq vs cv cr wcel vt cv cr wcel
      vv cv cr wcel vt cv vv cv clt wbr vv cv vv cv vt cv cmin co cD cbl cfv co
      vt cv vv cv vv cv vt cv cmin co caddc co cioo co wceq vt cv cr wcel vv cv
      cr wcel vt cv vv cv clt wbr w3a vv cv vv cv vt cv cmin co cD cbl cfv co
      vv cv vv cv vt cv cmin co cmin co vv cv vv cv vt cv cmin co caddc co cioo
      co vt cv vv cv vv cv vt cv cmin co caddc co cioo co vv cv cr wcel vv cv
      vt cv cmin co cr wcel cc0 vv cv vt cv cmin co clt wbr vv cv vv cv vt cv
      cmin co cD cbl cfv co vv cv vv cv vt cv cmin co cmin co vv cv vv cv vt cv
      cmin co caddc co cioo co wceq vt cv cr wcel vv cv cr wcel vt cv vv cv clt
      wbr w3a vv cv vv cv vt cv cmin co cD remet.1 bl2ioo vt cv cr wcel vv cv
      cr wcel vt cv vv cv clt wbr 3simp2 vt cv cr wcel vv cv cr wcel vv cv vt
      cv cmin co cr wcel vt cv vv cv clt wbr vv cv cr wcel vt cv cr wcel vv cv
      vt cv cmin co cr wcel vv cv vt cv resubcl ancoms 3adant3 vt cv cr wcel vv
      cv cr wcel vt cv vv cv clt wbr cc0 vv cv vt cv cmin co clt wbr vt cv vv
      cv posdif biimp3a syl3anc vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr
      w3a vv cv vv cv vt cv cmin co cmin co vt cv vv cv vv cv vt cv cmin co
      caddc co cioo vt cv cr wcel vv cv cr wcel vv cv vv cv vt cv cmin co cmin
      co vt cv wceq vt cv vv cv clt wbr vv cv cr wcel vt cv cr wcel vv cv vv cv
      vt cv cmin co cmin co vt cv wceq vv cv cc wcel vt cv cc wcel vv cv vv cv
      vt cv cmin co cmin co vt cv wceq vv cv cr wcel vt cv cr wcel vv cv vt cv
      nncan vv cv recn vt cv recn syl2an ancoms 3adant3 opreq1d eqtrd 3expb
      adantlr 3adantr3 adantr vt cv cr wcel vv cv vv cv vt cv cmin co caddc co
      cr wcel vs cv cr wcel w3a vv cv vv cv vt cv cmin co caddc co vs cv cle
      wbr vt cv vv cv vv cv vt cv cmin co caddc co cioo co vt cv vs cv cioo co
      wss vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv
      cv vs cv clt wbr w3a wa vv cv vt cv cmin co vs cv vv cv cmin co cle wbr
      wa vt cv cxr wcel vv cv vv cv vt cv cmin co caddc co cxr wcel vs cv cxr
      wcel vv cv vv cv vt cv cmin co caddc co vs cv cle wbr vt cv vv cv vv cv
      vt cv cmin co caddc co cioo co vt cv vs cv cioo co wss wi vt cv cr wcel
      vv cv vv cv vt cv cmin co caddc co cr wcel vs cv cr wcel vt cv cxr wcel
      vv cv vv cv vt cv cmin co caddc co cxr wcel vs cv cxr wcel w3a vv cv vv
      cv vt cv cmin co caddc co vs cv cle wbr vt cv vv cv vv cv vt cv cmin co
      caddc co cioo co vt cv vs cv cioo co wss vt cv vv cv vv cv vt cv cmin co
      caddc co vs cv iooss2 ex vt cv rexr vv cv vv cv vt cv cmin co caddc co
      rexr vs cv rexr syl3an vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv
      vv cv clt wbr vv cv vs cv clt wbr w3a wa vv cv vt cv cmin co vs cv vv cv
      cmin co cle wbr wa vt cv cr wcel vv cv vv cv vt cv cmin co caddc co cr
      wcel vs cv cr wcel vt cv cr wcel vs cv cr wcel vv cv cr wcel vt cv vv cv
      clt wbr vv cv vs cv clt wbr w3a vv cv vt cv cmin co vs cv vv cv cmin co
      cle wbr simplll vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv
      clt wbr vv cv vs cv clt wbr w3a wa vv cv vv cv vt cv cmin co caddc co cr
      wcel vv cv vt cv cmin co vs cv vv cv cmin co cle wbr vt cv cr wcel vs cv
      cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vv cv vt cv cmin co
      caddc co cr wcel vv cv vs cv clt wbr vt cv cr wcel vv cv cr wcel vv cv vv
      cv vt cv cmin co caddc co cr wcel vs cv cr wcel vt cv vv cv clt wbr vv cv
      cr wcel vv cv vt cv cmin co cr wcel vv cv vv cv vt cv cmin co caddc co cr
      wcel vt cv cr wcel vv cv cr wcel wa vv cv vv cv vt cv cmin co readdcl vt
      cv cr wcel vv cv cr wcel pm3.27 vv cv cr wcel vt cv cr wcel vv cv vt cv
      cmin co cr wcel vv cv vt cv resubcl ancoms sylanc ad2ant2r 3adantr3
      adantr vt cv cr wcel vs cv cr wcel vv cv cr wcel vt cv vv cv clt wbr vv
      cv vs cv clt wbr w3a vv cv vt cv cmin co vs cv vv cv cmin co cle wbr
      simpllr 3jca vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt
      wbr vv cv vs cv clt wbr w3a wa vv cv vv cv vt cv cmin co caddc co vs cv
      cle wbr vv cv vt cv cmin co vs cv vv cv cmin co cle wbr vt cv cr wcel vs
      cv cr wcel wa vt cv vv cv clt wbr vv cv cr wcel vv cv vv cv vt cv cmin co
      caddc co vs cv cle wbr vv cv vt cv cmin co vs cv vv cv cmin co cle wbr wb
      vv cv vs cv clt wbr vv cv cr wcel vv cv vt cv cmin co cr wcel vs cv cr
      wcel vv cv vv cv vt cv cmin co caddc co vs cv cle wbr vv cv vt cv cmin co
      vs cv vv cv cmin co cle wbr wb vt cv cr wcel vs cv cr wcel wa vv cv cr
      wcel wa vv cv vv cv vt cv cmin co vs cv leaddsub2 vt cv cr wcel vs cv cr
      wcel wa vv cv cr wcel pm3.27 vt cv cr wcel vv cv cr wcel vv cv vt cv cmin
      co cr wcel vs cv cr wcel vv cv cr wcel vt cv cr wcel vv cv vt cv cmin co
      cr wcel vv cv vt cv resubcl ancoms adantlr vt cv cr wcel vs cv cr wcel vv
      cv cr wcel simplr syl3anc 3ad2antr1 biimpar sylc eqsstrd jca sylanc vs cv
      vv cv cmin co cr wcel cc0 vs cv vv cv cmin co clt wbr vv cv vs cv vv cv
      cmin co cD cbl cfv co vt cv vs cv cioo co wss wa cc0 vu cv clt wbr vv cv
      vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vt cv cr wcel
      vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr
      w3a wa vs cv vv cv cmin co vv cv vt cv cmin co cle wbr wa cc0 vu cv clt
      wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa cc0 vs cv vv cv
      cmin co clt wbr vv cv vs cv vv cv cmin co cD cbl cfv co vt cv vs cv cioo
      co wss wa vu vs cv vv cv cmin co cr vu cv vs cv vv cv cmin co wceq cc0 vu
      cv clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv vu cv cD cbl cfv co vt
      cv vs cv cioo co wss vv cv vs cv vv cv cmin co cD cbl cfv co vt cv vs cv
      cioo co wss vu cv vs cv vv cv cmin co cc0 clt breq2 vu cv vs cv vv cv
      cmin co wceq vv cv vu cv cD cbl cfv co vv cv vs cv vv cv cmin co cD cbl
      cfv co vt cv vs cv cioo co vu cv vs cv vv cv cmin co vv cv cD cbl cfv
      opreq2 sseq1d anbi12d rcla4ev vt cv cr wcel vs cv cr wcel wa vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a wa vs cv vv cv cmin co
      cr wcel vs cv vv cv cmin co vv cv vt cv cmin co cle wbr vt cv cr wcel vs
      cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vs cv vv cv cmin co cr
      wcel vv cv vs cv clt wbr vs cv cr wcel vv cv cr wcel vs cv vv cv cmin co
      cr wcel vt cv cr wcel vt cv vv cv clt wbr vs cv vv cv resubcl ad2ant2lr
      3adantr3 adantr vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv
      clt wbr vv cv vs cv clt wbr w3a wa vs cv vv cv cmin co vv cv vt cv cmin
      co cle wbr wa cc0 vs cv vv cv cmin co clt wbr vv cv vs cv vv cv cmin co
      cD cbl cfv co vt cv vs cv cioo co wss vt cv cr wcel vs cv cr wcel wa vv
      cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a wa cc0 vs cv vv cv
      cmin co clt wbr vs cv vv cv cmin co vv cv vt cv cmin co cle wbr vt cv cr
      wcel vs cv cr wcel wa vv cv cr wcel vv cv vs cv clt wbr cc0 vs cv vv cv
      cmin co clt wbr vt cv vv cv clt wbr vs cv cr wcel vv cv cr wcel vv cv vs
      cv clt wbr wa cc0 vs cv vv cv cmin co clt wbr vt cv cr wcel vs cv cr wcel
      vv cv cr wcel vv cv vs cv clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv
      cr wcel vs cv cr wcel vv cv vs cv clt wbr cc0 vs cv vv cv cmin co clt wbr
      vv cv cr wcel vs cv cr wcel vv cv vs cv clt wbr cc0 vs cv vv cv cmin co
      clt wbr vv cv vs cv posdif biimp3a 3com12 3expb adantll 3adantr2 adantr
      vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs
      cv clt wbr w3a wa vs cv vv cv cmin co vv cv vt cv cmin co cle wbr wa vv
      cv vs cv vv cv cmin co cD cbl cfv co vv cv vs cv vv cv cmin co cmin co vs
      cv cioo co vt cv vs cv cioo co vt cv cr wcel vs cv cr wcel wa vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a wa vv cv vs cv vv cv
      cmin co cD cbl cfv co vv cv vs cv vv cv cmin co cmin co vs cv cioo co
      wceq vs cv vv cv cmin co vv cv vt cv cmin co cle wbr vt cv cr wcel vs cv
      cr wcel wa vv cv cr wcel vv cv vs cv clt wbr vv cv vs cv vv cv cmin co cD
      cbl cfv co vv cv vs cv vv cv cmin co cmin co vs cv cioo co wceq vt cv vv
      cv clt wbr vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr wa vv cv vs cv
      vv cv cmin co cD cbl cfv co vv cv vs cv vv cv cmin co cmin co vs cv cioo
      co wceq vt cv cr wcel vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr vv
      cv vs cv vv cv cmin co cD cbl cfv co vv cv vs cv vv cv cmin co cmin co vs
      cv cioo co wceq vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr w3a vv cv
      vs cv vv cv cmin co cD cbl cfv co vv cv vs cv vv cv cmin co cmin co vv cv
      vs cv vv cv cmin co caddc co cioo co vv cv vs cv vv cv cmin co cmin co vs
      cv cioo co vv cv cr wcel vs cv vv cv cmin co cr wcel cc0 vs cv vv cv cmin
      co clt wbr vv cv vs cv vv cv cmin co cD cbl cfv co vv cv vs cv vv cv cmin
      co cmin co vv cv vs cv vv cv cmin co caddc co cioo co wceq vs cv cr wcel
      vv cv cr wcel vv cv vs cv clt wbr w3a vv cv vs cv vv cv cmin co cD
      remet.1 bl2ioo vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr 3simp2 vs
      cv cr wcel vv cv cr wcel vs cv vv cv cmin co cr wcel vv cv vs cv clt wbr
      vs cv vv cv resubcl 3adant3 vv cv cr wcel vs cv cr wcel vv cv vs cv clt
      wbr cc0 vs cv vv cv cmin co clt wbr vv cv cr wcel vs cv cr wcel vv cv vs
      cv clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv vs cv posdif biimp3a
      3com12 syl3anc vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr w3a vv cv
      vs cv vv cv cmin co caddc co vs cv vv cv vs cv vv cv cmin co cmin co cioo
      vs cv cr wcel vv cv cr wcel vv cv vs cv vv cv cmin co caddc co vs cv wceq
      vv cv vs cv clt wbr vv cv cr wcel vs cv cr wcel vv cv vs cv vv cv cmin co
      caddc co vs cv wceq vv cv cc wcel vs cv cc wcel vv cv vs cv vv cv cmin co
      caddc co vs cv wceq vv cv cr wcel vs cv cr wcel vv cv vs cv pncan3 vv cv
      recn vs cv recn syl2an ancoms 3adant3 opreq2d eqtrd 3expb adantll
      3adantr2 adantr vt cv cr wcel vv cv vs cv vv cv cmin co cmin co cr wcel
      vs cv cr wcel w3a vt cv vv cv vs cv vv cv cmin co cmin co cle wbr vv cv
      vs cv vv cv cmin co cmin co vs cv cioo co vt cv vs cv cioo co wss vt cv
      cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a wa vs cv vv cv cmin co vv cv vt cv cmin co cle wbr wa vt cv
      cxr wcel vv cv vs cv vv cv cmin co cmin co cxr wcel vs cv cxr wcel vt cv
      vv cv vs cv vv cv cmin co cmin co cle wbr vv cv vs cv vv cv cmin co cmin
      co vs cv cioo co vt cv vs cv cioo co wss wi vt cv cr wcel vv cv vs cv vv
      cv cmin co cmin co cr wcel vs cv cr wcel vt cv cxr wcel vv cv vs cv vv cv
      cmin co cmin co cxr wcel vs cv cxr wcel w3a vt cv vv cv vs cv vv cv cmin
      co cmin co cle wbr vv cv vs cv vv cv cmin co cmin co vs cv cioo co vt cv
      vs cv cioo co wss vt cv vv cv vs cv vv cv cmin co cmin co vs cv iooss1 ex
      vt cv rexr vv cv vs cv vv cv cmin co cmin co rexr vs cv rexr syl3an vt cv
      cr wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a wa vs cv vv cv cmin co vv cv vt cv cmin co cle wbr wa vt cv
      cr wcel vv cv vs cv vv cv cmin co cmin co cr wcel vs cv cr wcel vt cv cr
      wcel vs cv cr wcel vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr
      w3a vs cv vv cv cmin co vv cv vt cv cmin co cle wbr simplll vt cv cr wcel
      vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr
      w3a wa vv cv vs cv vv cv cmin co cmin co cr wcel vs cv vv cv cmin co vv
      cv vt cv cmin co cle wbr vt cv cr wcel vs cv cr wcel wa vv cv cr wcel vt
      cv vv cv clt wbr vv cv vs cv vv cv cmin co cmin co cr wcel vv cv vs cv
      clt wbr vs cv cr wcel vv cv cr wcel vv cv vs cv vv cv cmin co cmin co cr
      wcel vt cv cr wcel vt cv vv cv clt wbr vv cv cr wcel vs cv vv cv cmin co
      cr wcel vv cv vs cv vv cv cmin co cmin co cr wcel vs cv cr wcel vv cv cr
      wcel wa vv cv vs cv vv cv cmin co resubcl vs cv cr wcel vv cv cr wcel
      pm3.27 vs cv vv cv resubcl sylanc ad2ant2lr 3adantr3 adantr vt cv cr wcel
      vs cv cr wcel vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a
      vs cv vv cv cmin co vv cv vt cv cmin co cle wbr simpllr 3jca vt cv cr
      wcel vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt
      wbr w3a wa vs cv vv cv cmin co vv cv vt cv cmin co cle wbr vt cv vv cv vs
      cv vv cv cmin co cmin co cle wbr vt cv cr wcel vs cv cr wcel wa vt cv vv
      cv clt wbr vv cv cr wcel vs cv vv cv cmin co vv cv vt cv cmin co cle wbr
      vt cv vv cv vs cv vv cv cmin co cmin co cle wbr wb vv cv vs cv clt wbr vs
      cv vv cv cmin co cr wcel vv cv cr wcel vt cv cr wcel vs cv vv cv cmin co
      vv cv vt cv cmin co cle wbr vt cv vv cv vs cv vv cv cmin co cmin co cle
      wbr wb vt cv cr wcel vs cv cr wcel wa vv cv cr wcel wa vs cv vv cv cmin
      co vv cv vt cv lesub vs cv cr wcel vv cv cr wcel vs cv vv cv cmin co cr
      wcel vt cv cr wcel vs cv vv cv resubcl adantll vt cv cr wcel vs cv cr
      wcel wa vv cv cr wcel pm3.27 vt cv cr wcel vs cv cr wcel vv cv cr wcel
      simpll syl3anc 3ad2antr1 biimpa sylc eqsstrd jca sylanc lecasei ex vt cv
      cr wcel vs cv cpnf wceq wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo
      co wss wa vu cr wrex vt cv cr wcel vs cv cpnf wceq wa vv cv cr wcel vt cv
      vv cv clt wbr cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv
      cioo co wss wa vu cr wrex vv cv vs cv clt wbr vv cv vt cv cmin co cr wcel
      cc0 vv cv vt cv cmin co clt wbr vv cv vv cv vt cv cmin co cD cbl cfv co
      vt cv vs cv cioo co wss wa cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt
      cv vs cv cioo co wss wa vu cr wrex vt cv cr wcel vs cv cpnf wceq wa vv cv
      cr wcel vt cv vv cv clt wbr wa wa cc0 vu cv clt wbr vv cv vu cv cD cbl
      cfv co vt cv vs cv cioo co wss wa cc0 vv cv vt cv cmin co clt wbr vv cv
      vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co wss wa vu vv cv vt
      cv cmin co cr vu cv vv cv vt cv cmin co wceq cc0 vu cv clt wbr cc0 vv cv
      vt cv cmin co clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss
      vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co wss vu cv vv
      cv vt cv cmin co cc0 clt breq2 vu cv vv cv vt cv cmin co wceq vv cv vu cv
      cD cbl cfv co vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co
      vu cv vv cv vt cv cmin co vv cv cD cbl cfv opreq2 sseq1d anbi12d rcla4ev
      vt cv cr wcel vv cv cr wcel vv cv vt cv cmin co cr wcel vs cv cpnf wceq
      vt cv vv cv clt wbr vv cv cr wcel vt cv cr wcel vv cv vt cv cmin co cr
      wcel vv cv vt cv resubcl ancoms ad2ant2r vt cv cr wcel vs cv cpnf wceq wa
      vv cv cr wcel vt cv vv cv clt wbr wa wa cc0 vv cv vt cv cmin co clt wbr
      vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co wss vt cv cr
      wcel vv cv cr wcel vt cv vv cv clt wbr wa cc0 vv cv vt cv cmin co clt wbr
      vs cv cpnf wceq vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr cc0 vv cv
      vt cv cmin co clt wbr vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr cc0
      vv cv vt cv cmin co clt wbr vt cv vv cv posdif biimp3a 3expb adantlr vt
      cv cr wcel vs cv cpnf wceq wa vv cv cr wcel vt cv vv cv clt wbr wa wa vt
      cv vv cv vv cv vt cv cmin co caddc co cioo co vt cv cpnf cioo co vv cv vv
      cv vt cv cmin co cD cbl cfv co vt cv vs cv cioo co vt cv cr wcel vv cv cr
      wcel vt cv vv cv vv cv vt cv cmin co caddc co cioo co vt cv cpnf cioo co
      wss vs cv cpnf wceq vt cv vv cv clt wbr vt cv cxr wcel vv cv vv cv vt cv
      cmin co caddc co cxr wcel vt cv vv cv vv cv vt cv cmin co caddc co cioo
      co vt cv cpnf cioo co wss vt cv cr wcel vv cv cr wcel wa vt cv cxr wcel
      vv cv vv cv vt cv cmin co caddc co cxr wcel wa vv cv vv cv vt cv cmin co
      caddc co cpnf cle wbr vt cv vv cv vv cv vt cv cmin co caddc co cioo co vt
      cv cpnf cioo co wss vv cv vv cv vt cv cmin co caddc co cxr wcel vv cv vv
      cv vt cv cmin co caddc co cpnf cle wbr vt cv cxr wcel vv cv vv cv vt cv
      cmin co caddc co pnfge adantl vt cv cxr wcel vv cv vv cv vt cv cmin co
      caddc co cxr wcel cpnf cxr wcel vv cv vv cv vt cv cmin co caddc co cpnf
      cle wbr vt cv vv cv vv cv vt cv cmin co caddc co cioo co vt cv cpnf cioo
      co wss pnfxr vt cv vv cv vv cv vt cv cmin co caddc co cpnf iooss2 mp3anl3
      mpdan vt cv cr wcel vt cv cxr wcel vv cv cr wcel vt cv rexr adantr vt cv
      cr wcel vv cv cr wcel wa vv cv vv cv vt cv cmin co caddc co cr wcel vv cv
      vv cv vt cv cmin co caddc co cxr wcel vv cv cr wcel vv cv vt cv cmin co
      cr wcel vv cv vv cv vt cv cmin co caddc co cr wcel vt cv cr wcel vv cv cr
      wcel wa vv cv vv cv vt cv cmin co readdcl vt cv cr wcel vv cv cr wcel
      pm3.27 vv cv cr wcel vt cv cr wcel vv cv vt cv cmin co cr wcel vv cv vt
      cv resubcl ancoms sylanc vv cv vv cv vt cv cmin co caddc co rexr syl
      sylanc ad2ant2r vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr wa vv cv
      vv cv vt cv cmin co cD cbl cfv co vt cv vv cv vv cv vt cv cmin co caddc
      co cioo co wceq vs cv cpnf wceq vt cv cr wcel vv cv cr wcel vt cv vv cv
      clt wbr vv cv vv cv vt cv cmin co cD cbl cfv co vt cv vv cv vv cv vt cv
      cmin co caddc co cioo co wceq vt cv cr wcel vv cv cr wcel vt cv vv cv clt
      wbr w3a vv cv vv cv vt cv cmin co cD cbl cfv co vv cv vv cv vt cv cmin co
      cmin co vv cv vv cv vt cv cmin co caddc co cioo co vt cv vv cv vv cv vt
      cv cmin co caddc co cioo co vv cv cr wcel vv cv vt cv cmin co cr wcel cc0
      vv cv vt cv cmin co clt wbr vv cv vv cv vt cv cmin co cD cbl cfv co vv cv
      vv cv vt cv cmin co cmin co vv cv vv cv vt cv cmin co caddc co cioo co
      wceq vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr w3a vv cv vv cv vt
      cv cmin co cD remet.1 bl2ioo vt cv cr wcel vv cv cr wcel vt cv vv cv clt
      wbr 3simp2 vt cv cr wcel vv cv cr wcel vv cv vt cv cmin co cr wcel vt cv
      vv cv clt wbr vv cv cr wcel vt cv cr wcel vv cv vt cv cmin co cr wcel vv
      cv vt cv resubcl ancoms 3adant3 vt cv cr wcel vv cv cr wcel vt cv vv cv
      clt wbr cc0 vv cv vt cv cmin co clt wbr vt cv vv cv posdif biimp3a
      syl3anc vt cv cr wcel vv cv cr wcel vt cv vv cv clt wbr w3a vv cv vv cv
      vt cv cmin co cmin co vt cv vv cv vv cv vt cv cmin co caddc co cioo vt cv
      cr wcel vv cv cr wcel vv cv vv cv vt cv cmin co cmin co vt cv wceq vt cv
      vv cv clt wbr vv cv cr wcel vt cv cr wcel vv cv vv cv vt cv cmin co cmin
      co vt cv wceq vv cv cc wcel vt cv cc wcel vv cv vv cv vt cv cmin co cmin
      co vt cv wceq vv cv cr wcel vt cv cr wcel vv cv vt cv nncan vv cv recn vt
      cv recn syl2an ancoms 3adant3 opreq1d eqtrd 3expb adantlr vs cv cpnf wceq
      vt cv vs cv cioo co vt cv cpnf cioo co wceq vt cv cr wcel vv cv cr wcel
      vt cv vv cv clt wbr wa vs cv cpnf vt cv cioo opreq2 ad2antlr 3sstr4d jca
      sylanc 3adantr3 ex vs cv cmnf wceq vv cv cr wcel vt cv vv cv clt wbr vv
      cv vs cv clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs
      cv cioo co wss wa vu cr wrex wi vt cv cr wcel vs cv cmnf wceq vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr cc0 vu cv clt wbr vv cv vu
      cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vs cv cmnf wceq vv
      cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr cc0 vu cv clt wbr vv
      cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex wi wi vs cv
      cmnf wceq vv cv cr wcel wa vv cv vs cv clt wbr cc0 vu cv clt wbr vv cv vu
      cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex wi vt cv vv cv clt
      wbr vs cv cmnf wceq vv cv cr wcel wa vv cv vs cv clt wbr cc0 vu cv clt
      wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vs cv
      cmnf wceq vv cv cr wcel wa vv cv vs cv clt wbr wn vv cv cmnf clt wbr wn
      vv cv cr wcel vv cv cmnf clt wbr wn vs cv cmnf wceq vv cv cr wcel vv cv
      cxr wcel vv cv cmnf clt wbr wn vv cv rexr vv cv nltmnf syl adantl vs cv
      cmnf wceq vv cv vs cv clt wbr wn vv cv cmnf clt wbr wn wb vv cv cr wcel
      vs cv cmnf wceq vv cv vs cv clt wbr vv cv cmnf clt wbr vs cv cmnf vv cv
      clt breq2 notbid adantr mpbird pm2.21d a1d ex 3impd adantl 3jaodan vt cv
      cpnf wceq vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a cc0
      vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr
      wrex wi vs cv cr wcel vs cv cpnf wceq vs cv cmnf wceq w3o vt cv cpnf wceq
      vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr cc0 vu cv clt wbr
      vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vt cv
      cpnf wceq vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr cc0 vu cv
      clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex
      wi wi vt cv cpnf wceq vv cv cr wcel wa vt cv vv cv clt wbr vv cv vs cv
      clt wbr cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co
      wss wa vu cr wrex wi vt cv cpnf wceq vv cv cr wcel wa vt cv vv cv clt wbr
      wn cpnf vv cv clt wbr wn vv cv cr wcel cpnf vv cv clt wbr wn vt cv cpnf
      wceq vv cv cr wcel vv cv cxr wcel cpnf vv cv clt wbr wn vv cv rexr vv cv
      pnfnlt syl adantl vt cv cpnf wceq vt cv vv cv clt wbr wn cpnf vv cv clt
      wbr wn wb vv cv cr wcel vt cv cpnf wceq vt cv vv cv clt wbr cpnf vv cv
      clt wbr vt cv cpnf vv cv clt breq1 notbid adantr mpbird pm2.21d ex 3impd
      adantr vt cv cmnf wceq vs cv cr wcel vv cv cr wcel vt cv vv cv clt wbr vv
      cv vs cv clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs
      cv cioo co wss wa vu cr wrex wi vs cv cpnf wceq vs cv cmnf wceq vt cv
      cmnf wceq vs cv cr wcel wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo
      co wss wa vu cr wrex vt cv cmnf wceq vs cv cr wcel wa vv cv cr wcel vv cv
      vs cv clt wbr cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv
      cioo co wss wa vu cr wrex vt cv vv cv clt wbr vs cv vv cv cmin co cr wcel
      cc0 vs cv vv cv cmin co clt wbr vv cv vs cv vv cv cmin co cD cbl cfv co
      vt cv vs cv cioo co wss wa cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt
      cv vs cv cioo co wss wa vu cr wrex vt cv cmnf wceq vs cv cr wcel wa vv cv
      cr wcel vv cv vs cv clt wbr wa wa cc0 vu cv clt wbr vv cv vu cv cD cbl
      cfv co vt cv vs cv cioo co wss wa cc0 vs cv vv cv cmin co clt wbr vv cv
      vs cv vv cv cmin co cD cbl cfv co vt cv vs cv cioo co wss wa vu vs cv vv
      cv cmin co cr vu cv vs cv vv cv cmin co wceq cc0 vu cv clt wbr cc0 vs cv
      vv cv cmin co clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss
      vv cv vs cv vv cv cmin co cD cbl cfv co vt cv vs cv cioo co wss vu cv vs
      cv vv cv cmin co cc0 clt breq2 vu cv vs cv vv cv cmin co wceq vv cv vu cv
      cD cbl cfv co vv cv vs cv vv cv cmin co cD cbl cfv co vt cv vs cv cioo co
      vu cv vs cv vv cv cmin co vv cv cD cbl cfv opreq2 sseq1d anbi12d rcla4ev
      vs cv cr wcel vv cv cr wcel vs cv vv cv cmin co cr wcel vt cv cmnf wceq
      vv cv vs cv clt wbr vs cv vv cv resubcl ad2ant2lr vt cv cmnf wceq vs cv
      cr wcel wa vv cv cr wcel vv cv vs cv clt wbr wa wa cc0 vs cv vv cv cmin
      co clt wbr vv cv vs cv vv cv cmin co cD cbl cfv co vt cv vs cv cioo co
      wss vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr wa cc0 vs cv vv cv
      cmin co clt wbr vt cv cmnf wceq vs cv cr wcel vv cv cr wcel vv cv vs cv
      clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv cr wcel vs cv cr wcel vv cv
      vs cv clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv cr wcel vs cv cr wcel
      vv cv vs cv clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv vs cv posdif
      biimp3a 3com12 3expb adantll vt cv cmnf wceq vs cv cr wcel wa vv cv cr
      wcel vv cv vs cv clt wbr wa wa vv cv vs cv vv cv cmin co cmin co vs cv
      cioo co cmnf vs cv cioo co vv cv vs cv vv cv cmin co cD cbl cfv co vt cv
      vs cv cioo co vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr wa vv cv vs
      cv vv cv cmin co cmin co vs cv cioo co cmnf vs cv cioo co wss vt cv cmnf
      wceq vv cv vs cv vv cv cmin co cmin co cxr wcel vs cv cxr wcel vv cv vs
      cv vv cv cmin co cmin co vs cv cioo co cmnf vs cv cioo co wss vs cv cr
      wcel vv cv cr wcel vv cv vs cv clt wbr wa wa vv cv vs cv vv cv cmin co
      cmin co cxr wcel vs cv cxr wcel wa cmnf vv cv vs cv vv cv cmin co cmin co
      cle wbr vv cv vs cv vv cv cmin co cmin co vs cv cioo co cmnf vs cv cioo
      co wss vv cv vs cv vv cv cmin co cmin co cxr wcel cmnf vv cv vs cv vv cv
      cmin co cmin co cle wbr vs cv cxr wcel vv cv vs cv vv cv cmin co cmin co
      mnfle adantr cmnf cxr wcel vv cv vs cv vv cv cmin co cmin co cxr wcel vs
      cv cxr wcel cmnf vv cv vs cv vv cv cmin co cmin co cle wbr vv cv vs cv vv
      cv cmin co cmin co vs cv cioo co cmnf vs cv cioo co wss mnfxr cmnf vv cv
      vs cv vv cv cmin co cmin co vs cv iooss1 mp3anl1 mpdan vs cv cr wcel vv
      cv cr wcel vv cv vs cv vv cv cmin co cmin co cxr wcel vv cv vs cv clt wbr
      vs cv cr wcel vv cv cr wcel wa vv cv vs cv vv cv cmin co cmin co cr wcel
      vv cv vs cv vv cv cmin co cmin co cxr wcel vv cv cr wcel vs cv vv cv cmin
      co cr wcel vv cv vs cv vv cv cmin co cmin co cr wcel vs cv cr wcel vv cv
      cr wcel wa vv cv vs cv vv cv cmin co resubcl vs cv cr wcel vv cv cr wcel
      pm3.27 vs cv vv cv resubcl sylanc vv cv vs cv vv cv cmin co cmin co rexr
      syl adantrr vs cv cr wcel vs cv cxr wcel vv cv cr wcel vv cv vs cv clt
      wbr wa vs cv rexr adantr sylanc adantll vs cv cr wcel vv cv cr wcel vv cv
      vs cv clt wbr wa vv cv vs cv vv cv cmin co cD cbl cfv co vv cv vs cv vv
      cv cmin co cmin co vs cv cioo co wceq vt cv cmnf wceq vs cv cr wcel vv cv
      cr wcel vv cv vs cv clt wbr vv cv vs cv vv cv cmin co cD cbl cfv co vv cv
      vs cv vv cv cmin co cmin co vs cv cioo co wceq vs cv cr wcel vv cv cr
      wcel vv cv vs cv clt wbr w3a vv cv vs cv vv cv cmin co cD cbl cfv co vv
      cv vs cv vv cv cmin co cmin co vv cv vs cv vv cv cmin co caddc co cioo co
      vv cv vs cv vv cv cmin co cmin co vs cv cioo co vv cv cr wcel vs cv vv cv
      cmin co cr wcel cc0 vs cv vv cv cmin co clt wbr vv cv vs cv vv cv cmin co
      cD cbl cfv co vv cv vs cv vv cv cmin co cmin co vv cv vs cv vv cv cmin co
      caddc co cioo co wceq vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr w3a
      vv cv vs cv vv cv cmin co cD remet.1 bl2ioo vs cv cr wcel vv cv cr wcel
      vv cv vs cv clt wbr 3simp2 vs cv cr wcel vv cv cr wcel vs cv vv cv cmin
      co cr wcel vv cv vs cv clt wbr vs cv vv cv resubcl 3adant3 vv cv cr wcel
      vs cv cr wcel vv cv vs cv clt wbr cc0 vs cv vv cv cmin co clt wbr vv cv
      cr wcel vs cv cr wcel vv cv vs cv clt wbr cc0 vs cv vv cv cmin co clt wbr
      vv cv vs cv posdif biimp3a 3com12 syl3anc vs cv cr wcel vv cv cr wcel vv
      cv vs cv clt wbr w3a vv cv vs cv vv cv cmin co caddc co vs cv vv cv vs cv
      vv cv cmin co cmin co cioo vs cv cr wcel vv cv cr wcel vv cv vs cv vv cv
      cmin co caddc co vs cv wceq vv cv vs cv clt wbr vv cv cr wcel vs cv cr
      wcel vv cv vs cv vv cv cmin co caddc co vs cv wceq vv cv cc wcel vs cv cc
      wcel vv cv vs cv vv cv cmin co caddc co vs cv wceq vv cv cr wcel vs cv cr
      wcel vv cv vs cv pncan3 vv cv recn vs cv recn syl2an ancoms 3adant3
      opreq2d eqtrd 3expb adantll vt cv cmnf wceq vt cv vs cv cioo co cmnf vs
      cv cioo co wceq vs cv cr wcel vv cv cr wcel vv cv vs cv clt wbr wa vt cv
      cmnf vs cv cioo opreq1 ad2antrr 3sstr4d jca sylanc 3adantr2 ex vt cv cmnf
      wceq vs cv cpnf wceq wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt
      wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co
      wss wa vu cr wrex c1 cr wcel cc0 c1 clt wbr vv cv c1 cD cbl cfv co vt cv
      vs cv cioo co wss wa cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs
      cv cioo co wss wa vu cr wrex vt cv cmnf wceq vs cv cpnf wceq wa vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr w3a wa cc0 vu cv clt wbr vv
      cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa cc0 c1 clt wbr vv cv c1
      cD cbl cfv co vt cv vs cv cioo co wss wa vu c1 cr vu cv c1 wceq cc0 vu cv
      clt wbr cc0 c1 clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss
      vv cv c1 cD cbl cfv co vt cv vs cv cioo co wss vu cv c1 cc0 clt breq2 vu
      cv c1 wceq vv cv vu cv cD cbl cfv co vv cv c1 cD cbl cfv co vt cv vs cv
      cioo co vu cv c1 vv cv cD cbl cfv opreq2 sseq1d anbi12d rcla4ev 1re vt cv
      cmnf wceq vs cv cpnf wceq wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs
      cv clt wbr w3a wa vv cv c1 cD cbl cfv co vt cv vs cv cioo co wss cc0 c1
      clt wbr vt cv cmnf wceq vs cv cpnf wceq wa vv cv cr wcel vt cv vv cv clt
      wbr vv cv vs cv clt wbr w3a wa vv cv c1 cmin co vv cv c1 caddc co cioo co
      cmnf cpnf cioo co vv cv c1 cD cbl cfv co vt cv vs cv cioo co vv cv c1
      cmin co vv cv c1 caddc co cioo co cmnf cpnf cioo co wss vt cv cmnf wceq
      vs cv cpnf wceq wa vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt wbr
      w3a wa vv cv c1 cmin co vv cv c1 caddc co cioo co cr cmnf cpnf cioo co vv
      cv c1 cmin co vv cv c1 caddc co ioossre ioomax sseqtr4i a1i vv cv cr wcel
      vt cv vv cv clt wbr vv cv vs cv clt wbr w3a vv cv c1 cD cbl cfv co vv cv
      c1 cmin co vv cv c1 caddc co cioo co wceq vt cv cmnf wceq vs cv cpnf wceq
      wa vv cv cr wcel vt cv vv cv clt wbr vv cv c1 cD cbl cfv co vv cv c1 cmin
      co vv cv c1 caddc co cioo co wceq vv cv vs cv clt wbr vv cv cr wcel c1 cr
      wcel cc0 c1 clt wbr vv cv c1 cD cbl cfv co vv cv c1 cmin co vv cv c1
      caddc co cioo co wceq 1re lt01 vv cv c1 cD remet.1 bl2ioo mp3an23
      3ad2ant1 adantl vt cv cmnf wceq vs cv cpnf wceq wa vt cv vs cv cioo co
      cmnf cpnf cioo co wceq vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv clt
      wbr w3a vt cv cmnf vs cv cpnf cioo opreq12 adantr 3sstr4d lt01 jctil
      sylancr ex vs cv cmnf wceq vv cv cr wcel vt cv vv cv clt wbr vv cv vs cv
      clt wbr w3a cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo
      co wss wa vu cr wrex wi vt cv cmnf wceq vs cv cmnf wceq vv cv cr wcel vt
      cv vv cv clt wbr vv cv vs cv clt wbr cc0 vu cv clt wbr vv cv vu cv cD cbl
      cfv co vt cv vs cv cioo co wss wa vu cr wrex vs cv cmnf wceq vv cv cr
      wcel vt cv vv cv clt wbr vv cv vs cv clt wbr cc0 vu cv clt wbr vv cv vu
      cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex wi wi vs cv cmnf
      wceq vv cv cr wcel wa vv cv vs cv clt wbr cc0 vu cv clt wbr vv cv vu cv
      cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex wi vt cv vv cv clt
      wbr vs cv cmnf wceq vv cv cr wcel wa vv cv vs cv clt wbr cc0 vu cv clt
      wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co wss wa vu cr wrex vs cv
      cmnf wceq vv cv cr wcel wa vv cv vs cv clt wbr wn vv cv cmnf clt wbr wn
      vv cv cr wcel vv cv cmnf clt wbr wn vs cv cmnf wceq vv cv cr wcel vv cv
      cxr wcel vv cv cmnf clt wbr wn vv cv rexr vv cv nltmnf syl adantl vs cv
      cmnf wceq vv cv vs cv clt wbr wn vv cv cmnf clt wbr wn wb vv cv cr wcel
      vs cv cmnf wceq vv cv vs cv clt wbr vv cv cmnf clt wbr vs cv cmnf vv cv
      clt breq2 notbid adantr mpbird pm2.21d a1d ex 3impd adantl 3jaodan
      3jaoian vt cv elxr vs cv elxr syl2anb sylbid $.
      $( [22-Oct-2007] $) $( [21-May-2007] $)

    ${
      $d w J $.
      tgioo.2 $e |- J = ( Open ` D ) $.
      $( The topology generated by open intervals of reals is the same as the
         open sets of the standard metric space on the reals. $)
      tgioo $p |- ( topGen ` ran (,) ) = J $=
        cD cbl cfv crn ctg cfv cioo crn ctg cfv cJ cD cbl cfv crn ctb wcel cioo
        crn ctb wcel wa cD cbl cfv crn cioo crn wss cioo crn cD cbl cfv crn ctg
        cfv wss wa cD cbl cfv crn ctg cfv cioo crn ctg cfv wceq cD cbl cfv crn
        ctb wcel cioo crn ctb wcel cD cme wcel cD cbl cfv crn ctb wcel cD
        remet.1 remet cD cD copn cfv cD copn cfv eqid blbas ax-mp retopbas
        pm3.2i cD cbl cfv crn cioo crn wss cioo crn cD cbl cfv crn ctg cfv wss
        cD remet.1 blssioo cioo crn cJ cD cbl cfv crn ctg cfv vw cioo crn cJ vw
        cv cJ wcel vw cv cr wss cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vw
        cv wss wa vu cr wrex vv vw cv wral vw cv cioo crn wcel cD cme wcel vw
        cv cJ wcel vw cv cr wss cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vw
        cv wss wa vu cr wrex vv vw cv wral wa wb cD remet.1 remet vv vu vw cv
        cD cJ cr cD remet.1 remetba tgioo.2 isopn4 ax-mp vw cv cioo crn wcel vw
        cv cioo crn cuni cr vw cv cioo crn elssuni unirnioo syl6ss vw cv cioo
        crn wcel cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vw cv wss wa vu cr
        wrex vv vw cv vw cv cioo crn wcel vt cv vs cv cioo co vw cv wceq vs cxr
        wrex vt cxr wrex vv cv vw cv wcel cc0 vu cv clt wbr vv cv vu cv cD cbl
        cfv co vw cv wss wa vu cr wrex wi cioo cxr cxr cxp wfn vw cv cioo crn
        wcel vt cv vs cv cioo co vw cv wceq vs cxr wrex vt cxr wrex wb cxr cxr
        cxp cr cpw cioo wf cioo cxr cxr cxp wfn ioof cxr cxr cxp cr cpw cioo
        ffn ax-mp vt vs cxr cxr vw cv cioo oprvelrn ax-mp vt cv vs cv cioo co
        vw cv wceq vv cv vw cv wcel cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co
        vw cv wss wa vu cr wrex wi vt vs cxr cxr vt cv cxr wcel vs cv cxr wcel
        wa vt cv vs cv cioo co vw cv wceq vv cv vw cv wcel cc0 vu cv clt wbr vv
        cv vu cv cD cbl cfv co vw cv wss wa vu cr wrex wi vt cv cxr wcel vs cv
        cxr wcel wa vt cv vs cv cioo co vw cv wceq wa vv cv vt cv vs cv cioo co
        wcel cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs cv cioo co
        wss wa vu cr wrex vv cv vw cv wcel cc0 vu cv clt wbr vv cv vu cv cD cbl
        cfv co vw cv wss wa vu cr wrex vt cv cxr wcel vs cv cxr wcel wa vv cv
        vt cv vs cv cioo co wcel cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt
        cv vs cv cioo co wss wa vu cr wrex wi vt cv vs cv cioo co vw cv wceq vv
        vu vt cD vs remet.1 tgioolem adantr vt cv vs cv cioo co vw cv wceq vv
        cv vt cv vs cv cioo co wcel vv cv vw cv wcel wb vt cv cxr wcel vs cv
        cxr wcel wa vt cv vs cv cioo co vw cv vv cv eleq2 adantl vt cv vs cv
        cioo co vw cv wceq cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv vs
        cv cioo co wss wa vu cr wrex cc0 vu cv clt wbr vv cv vu cv cD cbl cfv
        co vw cv wss wa vu cr wrex wb vt cv cxr wcel vs cv cxr wcel wa vt cv vs
        cv cioo co vw cv wceq cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vt cv
        vs cv cioo co wss wa cc0 vu cv clt wbr vv cv vu cv cD cbl cfv co vw cv
        wss wa vu cr vt cv vs cv cioo co vw cv wceq vv cv vu cv cD cbl cfv co
        vt cv vs cv cioo co wss vv cv vu cv cD cbl cfv co vw cv wss cc0 vu cv
        clt wbr vt cv vs cv cioo co vw cv vv cv vu cv cD cbl cfv co sseq2
        anbi2d rexbidv adantl 3imtr3d ex r19.23aivv sylbi r19.21aiv sylanbrc
        ssriv cD cme wcel cD cbl cfv crn ctg cfv cJ wceq cD remet.1 remet cD cJ
        tgioo.2 tgbl ax-mp sseqtr4i pm3.2i cD cbl cfv crn cioo crn 2basgen
        mp2an cD cme wcel cD cbl cfv crn ctg cfv cJ wceq cD remet.1 remet cD cJ
        tgioo.2 tgbl ax-mp eqtr3i $.
        $( [5-Dec-2007] $) $( [7-May-2007] $)

      $( ` QQ ` is dense in ` RR ` . $)
      qdensere2 $p |- ( ( cls ` J ) ` QQ ) = RR $=
        cq cioo crn ctg cfv ccl cfv cfv cq cJ ccl cfv cfv cr cq cioo crn ctg
        cfv ccl cfv cJ ccl cfv cioo crn ctg cfv cJ ccl cD cJ remet.1 tgioo.2
        tgioo fveq2i fveq1i qdensere eqtr3i $.
        $( [6-Dec-2007] $) $( [24-Aug-2007] $)
    $}
  $}

  ${
    $d x y z $.
    $( The standard topology on the reals is Hausdorff. $)
    rehaus $p |- ( topGen ` ran (,) ) e. Haus $=
      cioo crn ctg cfv cabs cmin ccom cr cr cxp cres copn cfv cha cabs cmin
      ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom
      cr cr cxp cres eqid cabs cmin ccom cr cr cxp cres copn cfv eqid tgioo
      cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres copn cfv cabs
      cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid remet cabs
      cmin ccom cr cr cxp cres copn cfv eqid methausi eqeltri $.
      $( [28-Jun-2008] $) $( [8-Mar-2007] $)
  $}

  ${
    $d X x y z $.  $d X u v w $.  $d D u v w $.  $d u x y z $.  $d v x y z $.
    $d w x y z $.
    dscmet.1 $e |- X e. _V $.
    dscmet.2 $e |- D = { <. <. x , y >. , z >. | ( ( x e. X /\ y e. X ) /\
                  z = if ( x = y , 0 , 1 ) ) } $.
    $( The discrete metric on any set ` X ` .  Definition 1.1-8 of [Kreyszig]
       p. 8.  (Contributed by FL, 12-Oct-2006.) $)
    dscmet $p |- D e. Met $=
      vw vv vu cD cX dscmet.1 vx vy vz cX cX vx cv vy cv wceq cc0 c1 cif cr cD
      dscmet.2 vx cv vy cv wceq cc0 c1 cif cr wcel vx cv cX wcel vy cv cX wcel
      wa vx cv vy cv wceq cc0 c1 cr 0re 1re keepel a1i foprab vw cv cX wcel vv
      cv cX wcel wa vw cv vv cv cD co cc0 wceq vw cv vv cv wceq cc0 c1 cif cc0
      wceq vw cv vv cv wceq vw cv cX wcel vv cv cX wcel wa vw cv vv cv cD co vw
      cv vv cv wceq cc0 c1 cif cc0 vx vy vz vw cv vv cv cX cX vx cv vy cv wceq
      cc0 c1 cif vw cv vv cv wceq cc0 c1 cif cD vw cv vy cv wceq cc0 c1 cif vw
      cv vv cv wceq cc0 c1 cif cr vw cv vv cv wceq cc0 c1 cr 0re 1re keepel
      elisseti vx cv vw cv wceq vx cv vy cv wceq vw cv vy cv wceq cc0 c1 vx cv
      vw cv vy cv eqeq1 ifbid vy cv vv cv wceq vw cv vy cv wceq vw cv vv cv
      wceq cc0 c1 vy cv vv cv vw cv eqeq2 ifbid dscmet.2 oprabval2 eqeq1d vw cv
      vv cv wceq cc0 c1 cif cc0 wceq vw cv vv cv wceq vw cv vv cv wceq cc0 vw
      cv vv cv wceq cc0 c1 cif cc0 vw cv vv cv wceq cc0 c1 cif wceq vw cv vv cv
      wceq cc0 cc0 wceq wa vw cv vv cv wceq wn cc0 c1 wceq wa wo vw cv vv cv
      wceq vw cv vv cv wceq cc0 cc0 c1 eqif vw cv vv cv wceq cc0 cc0 wceq wa vw
      cv vv cv wceq vw cv vv cv wceq wn cc0 c1 wceq wa vw cv vv cv wceq cc0 cc0
      wceq pm3.26 cc0 c1 wceq vw cv vv cv wceq wn vw cv vv cv wceq cc0 c1 wceq
      vw cv vv cv wceq vw cv vv cv wceq cc0 c1 wceq vw cv vv cv wceq vw cv vv
      cv wceq wo cc0 c1 wne cc0 c1 wceq wn c1 cc0 wne cc0 c1 wne ax1ne0 c1 cc0
      necom mpbi cc0 c1 df-ne mpbi pm2.21i orcanai ancoms jaoi sylbi eqcoms vw
      cv vv cv wceq cc0 c1 iftrue impbii syl6bb vw cv cX wcel vv cv cX wcel vu
      cv cX wcel w3a vw cv vv cv wceq cc0 c1 cif vu cv vw cv wceq cc0 c1 cif vu
      cv vv cv wceq cc0 c1 cif caddc co vw cv vv cv cD co vu cv vw cv cD co vu
      cv vv cv cD co caddc co cle vw cv vv cv wceq cc0 c1 cif vu cv vw cv wceq
      cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co cle wbr vw cv cX wcel vv
      cv cX wcel vu cv cX wcel w3a vw cv vv cv wceq vw cv vv cv wceq cc0 c1 cif
      vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co cle wbr
      vw cv vv cv wceq vw cv vv cv wceq cc0 c1 cif cc0 vu cv vw cv wceq cc0 c1
      cif vu cv vv cv wceq cc0 c1 cif caddc co cle vw cv vv cv wceq cc0 c1
      iftrue vu cv vw cv wceq vw cv vv cv wceq cc0 vu cv vw cv wceq cc0 c1 cif
      vu cv vv cv wceq cc0 c1 cif caddc co cle wbr vu cv vw cv wceq vw cv vv cv
      wceq wa vu cv vw cv wceq vu cv vv cv wceq wa cc0 vu cv vw cv wceq cc0 c1
      cif vu cv vv cv wceq cc0 c1 cif caddc co cle wbr vu cv vw cv wceq vw cv
      vv cv wceq vu cv vv cv wceq vu vw vv equtr imdistani vu cv vw cv wceq vu
      cv vv cv wceq wa cc0 cc0 caddc co vu cv vw cv wceq cc0 c1 cif vu cv vv cv
      wceq cc0 c1 cif caddc co cc0 cle vu cv vw cv wceq vu cv vv cv wceq vu cv
      vw cv wceq cc0 c1 cif cc0 vu cv vv cv wceq cc0 c1 cif cc0 caddc vu cv vw
      cv wceq cc0 c1 iftrue vu cv vv cv wceq cc0 c1 iftrue opreqan12d cc0 cc0
      0re 0nn0 nn0addge1i syl5breqr syl vu cv vw cv wceq wn vw cv vv cv wceq wa
      vu cv vw cv wceq wn vu cv vv cv wceq wn wa cc0 vu cv vw cv wceq cc0 c1
      cif vu cv vv cv wceq cc0 c1 cif caddc co cle wbr vu cv vw cv wceq wn vw
      cv vv cv wceq vu cv vv cv wceq wn vw cv vv cv wceq vu cv vw cv wceq wn vu
      cv vv cv wceq wn vw cv vv cv wceq vu cv vw cv wceq vu cv vv cv wceq vw vv
      vu equequ2 notbid biimpcd imdistani vu cv vw cv wceq wn vu cv vv cv wceq
      wn wa c1 c1 caddc co vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1
      cif caddc co cc0 cle vu cv vw cv wceq wn vu cv vv cv wceq wn vu cv vw cv
      wceq cc0 c1 cif c1 vu cv vv cv wceq cc0 c1 cif c1 caddc vu cv vw cv wceq
      cc0 c1 iffalse vu cv vv cv wceq cc0 c1 iffalse opreqan12d cc0 c1 cle wbr
      cc0 c1 cle wbr cc0 c1 c1 caddc co cle wbr cc0 c1 0re 1re lt01 ltleii cc0
      c1 0re 1re lt01 ltleii c1 c1 1re 1re addge0i mp2an syl5breqr syl
      pm2.61ian eqbrtrd vw cv vv cv wceq wn vw cv vv cv wceq cc0 c1 cif c1 vu
      cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co cle vw cv
      vv cv wceq cc0 c1 iffalse vu cv vw cv wceq vw cv vv cv wceq wn c1 vu cv
      vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co cle wbr wi vu
      cv vw cv wceq vw cv vv cv wceq wn c1 vu cv vw cv wceq cc0 c1 cif vu cv vv
      cv wceq cc0 c1 cif caddc co cle wbr vu cv vw cv wceq vw cv vv cv wceq wn
      wa vu cv vw cv wceq vu cv vv cv wceq wn wa c1 vu cv vw cv wceq cc0 c1 cif
      vu cv vv cv wceq cc0 c1 cif caddc co cle wbr vu cv vw cv wceq vw cv vv cv
      wceq wn vu cv vv cv wceq wn vu cv vw cv wceq vw cv vv cv wne vu cv vv cv
      wne vw cv vv cv wceq wn vu cv vv cv wceq wn vu cv vw cv wceq vu cv vv cv
      wne vw cv vv cv wne vu cv vw cv vv cv neeq1 biimprd vw cv vv cv df-ne vu
      cv vv cv df-ne 3imtr3g imdistani vu cv vw cv wceq vu cv vv cv wceq wn wa
      c1 vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co c1
      cle vu cv vw cv wceq vu cv vv cv wceq wn wa vu cv vw cv wceq cc0 c1 cif
      vu cv vv cv wceq cc0 c1 cif caddc co cc0 c1 caddc co c1 vu cv vw cv wceq
      vu cv vv cv wceq wn vu cv vw cv wceq cc0 c1 cif cc0 vu cv vv cv wceq cc0
      c1 cif c1 caddc vu cv vw cv wceq cc0 c1 iftrue vu cv vv cv wceq cc0 c1
      iffalse opreqan12d c1 ax1cn addid2i syl6eq c1 1re leidi syl5breqr syl ex
      vu cv vw cv wceq wn c1 vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0
      c1 cif caddc co cle wbr vw cv vv cv wceq wn vu cv vw cv wceq wn vu cv vv
      cv wceq c1 vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc
      co cle wbr vu cv vw cv wceq wn vu cv vv cv wceq wa c1 vu cv vw cv wceq
      cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co c1 cle vu cv vw cv wceq
      wn vu cv vv cv wceq wa vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0
      c1 cif caddc co c1 cc0 caddc co c1 vu cv vw cv wceq wn vu cv vv cv wceq
      vu cv vw cv wceq cc0 c1 cif c1 vu cv vv cv wceq cc0 c1 cif cc0 caddc vu
      cv vw cv wceq cc0 c1 iffalse vu cv vv cv wceq cc0 c1 iftrue opreqan12d c1
      ax1cn addid1i syl6eq c1 1re leidi syl5breqr vu cv vw cv wceq wn vu cv vv
      cv wceq wn wa c2 vu cv vw cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif
      caddc co c1 cle vu cv vw cv wceq wn vu cv vv cv wceq wn wa vu cv vw cv
      wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif caddc co c1 c1 caddc co c2 vu
      cv vw cv wceq wn vu cv vv cv wceq wn vu cv vw cv wceq cc0 c1 cif c1 vu cv
      vv cv wceq cc0 c1 cif c1 caddc vu cv vw cv wceq cc0 c1 iffalse vu cv vv
      cv wceq cc0 c1 iffalse opreqan12d df-2 syl6eqr c1 c2 1re 2re 1lt2 ltleii
      syl5breqr pm2.61dan a1d pm2.61i eqbrtrd pm2.61i a1i vw cv cX wcel vv cv
      cX wcel vw cv vv cv cD co vw cv vv cv wceq cc0 c1 cif wceq vu cv cX wcel
      vx vy vz vw cv vv cv cX cX vx cv vy cv wceq cc0 c1 cif vw cv vv cv wceq
      cc0 c1 cif cD vw cv vy cv wceq cc0 c1 cif vw cv vv cv wceq cc0 c1 cif cr
      vw cv vv cv wceq cc0 c1 cr 0re 1re keepel elisseti vx cv vw cv wceq vx cv
      vy cv wceq vw cv vy cv wceq cc0 c1 vx cv vw cv vy cv eqeq1 ifbid vy cv vv
      cv wceq vw cv vy cv wceq vw cv vv cv wceq cc0 c1 vy cv vv cv vw cv eqeq2
      ifbid dscmet.2 oprabval2 3adant3 vw cv cX wcel vv cv cX wcel vu cv cX
      wcel w3a vu cv vw cv cD co vu cv vw cv wceq cc0 c1 cif vu cv vv cv cD co
      vu cv vv cv wceq cc0 c1 cif caddc vw cv cX wcel vu cv cX wcel vu cv vw cv
      cD co vu cv vw cv wceq cc0 c1 cif wceq vv cv cX wcel vu cv cX wcel vw cv
      cX wcel vu cv vw cv cD co vu cv vw cv wceq cc0 c1 cif wceq vx vy vz vu cv
      vw cv cX cX vx cv vy cv wceq cc0 c1 cif vu cv vw cv wceq cc0 c1 cif cD vu
      cv vy cv wceq cc0 c1 cif vu cv vw cv wceq cc0 c1 cif cr vu cv vw cv wceq
      cc0 c1 cr 0re 1re keepel elisseti vx cv vu cv wceq vx cv vy cv wceq vu cv
      vy cv wceq cc0 c1 vx cv vu cv vy cv eqeq1 ifbid vy cv vw cv wceq vu cv vy
      cv wceq vu cv vw cv wceq cc0 c1 vy cv vw cv vu cv eqeq2 ifbid dscmet.2
      oprabval2 ancoms 3adant2 vv cv cX wcel vu cv cX wcel vu cv vv cv cD co vu
      cv vv cv wceq cc0 c1 cif wceq vw cv cX wcel vu cv cX wcel vv cv cX wcel
      vu cv vv cv cD co vu cv vv cv wceq cc0 c1 cif wceq vx vy vz vu cv vv cv
      cX cX vx cv vy cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif cD vu cv vy
      cv wceq cc0 c1 cif vu cv vv cv wceq cc0 c1 cif cr vu cv vv cv wceq cc0 c1
      cr 0re 1re keepel elisseti vx cv vu cv wceq vx cv vy cv wceq vu cv vy cv
      wceq cc0 c1 vx cv vu cv vy cv eqeq1 ifbid vy cv vv cv wceq vu cv vy cv
      wceq vu cv vv cv wceq cc0 c1 vy cv vv cv vu cv eqeq2 ifbid dscmet.2
      oprabval2 ancoms 3adant1 opreq12d 3brtr4d ismeti $.
      $( [18-Apr-2008] $) $( [9-Oct-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Neighborhoods and closure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
  @c neiOLD @.
  @c accOLD @.
  @c acc @.
  @c cls @.
  @c int @.

  @( Extend class notation with neighborhood of a metric space point. @)
  cne @a class neiOLD @.

  @( Extend class notation with accumulation points (limit points) of
     a metric space point. @)
  cacOLD @a class accOLD @.

  @( Extend class notation with accumulation points (limit points) of
     a metric space point. @)
  cac @a class acc @.

  @( Extend class notation with closure of a metric space subset. @)
  ccl @a class cls @.

  @( Extend class notation with interior of a metric space subset. @)
  cnt @a class int @.

  @{
    @d u v w x y z @.
    @( Define a function on metric spaces whose value is the relation "subset
       ` x ` is a neighborhood of point ` y ` ." @)
    df-neiOLD @a |- neiOLD =
             { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x C_ ( 1st ` z ) /\ y e. ( 1st ` z ) /\ E. v e. RR
      ( 0 < v /\ ( y ( ball ` z ) v ) C_ x ) ) } ) } @.

    @( Define a function on metric spaces whose value is the relation " ` x `
       is an accumulation point (limit point) of subset ` y ` ." @)
    df-accOLD @a |- accOLD =
                   { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x e. ( 1st ` z ) /\ y C_ ( 1st ` z ) /\ A. v ( ( v C_ ( 1st ` z ) /\
       v ( neiOLD ` z ) x ) -> E. u e. v ( u e. y /\ -. u = x ) ) ) } ) } @.

    @( Define a function on metric spaces whose value is the relation " ` x `
       is an accumulation point (limit point) of subset ` y ` ." @)
    df-acc @a |- acc = { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x e. ( 1st ` z ) /\ y C_ ( 1st ` z ) /\ A. v e. RR ( 0 < v -> E. u e.
      ( x ( ball ` z ) v ) ( u e. y /\ -. u = x ) ) ) } ) } @.

    @( Define a function on metric spaces whose value is the closure function
       on the subsets of the metric space. @)
    df-clsOLD @a |- cls = { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x C_ ( 1st ` z ) /\
      y = ( x u. { v e. ( 1st ` z ) | v ( acc ` z ) x } ) ) } ) } @.

    @( Define a function on metric spaces whose value is the interior function
       on the subsets of the metric space. @)
    df-ntr @a |- int = { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x C_ ( 1st ` z ) /\ y = U. { v e. ran ( ball ` z ) | v C_ x } ) } @.
  @}

  @{
    @d u v w x y z M @.  @d v w x y z X @.  @d u v w x y z @.
    accfval.1 @e |- X = ( 1st ` M ) @.
    @( The relation "subset ` x ` is a neighborhood of point ` y ` ." @)
    neifvalOLD @p |- ( M e. MetSp ->
                ( neiOLD ` M ) = { <. x , y >. | ( x C_ X /\
           y e. X /\ E. v e. RR ( 0 < v /\ ( y ( ball ` M ) v ) C_ x ) ) } ) @=
      ( vz vw cv c1st cfv wss wcel cc0 clt wbr cblOLD co wa cr wrex w3a
      copab cmt
      cne wceq fveq2 syl6eqr sseq2d eleq2d opreqd sseq1d anbi2d rexbidv
      3anbi123d opabbidv df-neiOLD cpw cxp cvv fvex eqeltri pwex xpex df-3an
      visset elpw 3anbi1i bitr3i opabbii opabssxp eqsstr3i ssexi
      fvopab4 ) GHDAIZ
      GIZJKZLZBIZVQMZNCIZOPZVSWAVPQKZRZVOLZSZCTUAZUBZABUCVOELZVSEMZWBVSWADQKZRZ
      VOLZSZCTUAZUBZABUCZUDUEVPDUFZWHWPABWRVRWIVTWJWGWOWRVQEVOWRVQDJKZEVPDJUGFU
      HZUIWRVQEVSWTUJWRWFWNCTWRWEWMWBWRWDWLVOWRWCWKVSWAVPDQUGUKULUMUNUOUPABGHCU
      QWQEURZEUSZXAEEEWSUTFDJVAVBZVCXCVDWQVOXAMZWJSWOSZABUCXBXEWPABXEXDWJWOUBWP
      XDWJWOVEXDWIWJWOVOEAVFVGVHVIVJWOABXAEVKVLVMVN @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The relation " ` x ` is an accumulation point (limit point) of subset
       ` y ` ." @)
    accfvalOLD @p |- ( M e. MetSp -> ( accOLD ` M ) = { <. x , y >. |
      ( x e. X /\ y C_ X /\ A. v ( ( v C_ X /\
       v ( neiOLD ` M ) x ) -> E. u e. v ( u e. y /\ -. u = x ) ) ) } ) @=
      ( vz vw cv c1st cfv wcel wss cne wbr wa wceq wn wrex wi wal w3a copab
      cmt cacOLD fveq2 syl6eqr eleq2d sseq2d wb breq syl anbi12d imbi1d albidv
      3anbi123d opabbidv df-accOLD cpw cxp cvv fvex eqeltri pwex xpex df-3an
      visset elpw 3anbi2i bitr3i opabbii opabssxp eqsstr3i ssexi
      fvopab4 ) HIEAJZ
      HJZKLZMZBJZVSNZCJZVSNZWCVQVROLZPZQZDJZWAMWHVQRSQDWCTZUAZCUBZUCZABUDVQFMZW
      AFNZWCFNZWCVQEOLZPZQZWIUAZCUBZUCZABUDZUEUFVRERZWLXAABXCVTWMWBWNWKWTXCVSFV
      QXCVSEKLZFVREKUGGUHZUIXCVSFWAXEUJXCWJWSCXCWGWRWIXCWDWOWFWQXCVSFWCXEUJXCWE
      WPRWFWQUKVREOUGWCVQWEWPULUMUNUOUPUQURABHICDUSXBFFUTZVAZFXFFXDVBGEKVCVDZFX
      HVEVFXBWMWAXFMZQWTQZABUDXGXJXAABXJWMXIWTUCXAWMXIWTVGXIWNWMWTWAFBVHVIVJVKV
      LWTABFXFVMVNVOVP @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The relation " ` x ` is an accumulation point (limit point) of subset
       ` y ` ." @)
    accfval @p |- ( M e. MetSp -> ( acc ` M ) = { <. x , y >. |
      ( x e. X /\ y C_ X /\ A. v e. RR ( 0 < v -> E. u e.
      ( x ( ball ` M ) v ) ( u e. y /\ -. u = x ) ) ) } ) @=
      ( vz vw cv c1st cfv wcel wss cc0 clt wbr wceq wn wa cblOLD co wrex wi cr
      wral w3a copab cmt cac fveq2 syl6eqr eleq2d sseq2d wb opreqd rexeq1 syl
      imbi2d ralbidv 3anbi123d opabbidv df-acc cpw cxp cvv fvex eqeltri pwex
      xpex df-3an visset elpw 3anbi2i bitr3i opabbii opabssxp eqsstr3i ssexi
      fvopab4 ) HIEAJZHJZKLZMZBJZWCNZOCJZPQZDJZWEMWIWARSTZDWAWGWBUALZUBZUCZUDZC
      UEUFZUGZABUHWAFMZWEFNZWHWJDWAWGEUALZUBZUCZUDZCUEUFZUGZABUHZUIUJWBERZWPXDA
      BXFWDWQWFWRWOXCXFWCFWAXFWCEKLZFWBEKUKGULZUMXFWCFWEXHUNXFWNXBCUEXFWMXAWHXF
      WLWTRWMXAUOXFWKWSWAWGWBEUAUKUPWJDWLWTUQURUSUTVAVBABHICDVCXEFFVDZVEZFXIFXG
      VFGEKVGVHZFXKVIVJXEWQWEXIMZTXCTZABUHXJXMXDABXMWQXLXCUGXDWQXLXCVKXLWRWQXCW
      EFBVLVMVNVOVPXCABFXIVQVRVSVT @.
      @( [ ?] @) @( [9-Sep-2006] @)

    @( The closure function on the subsets of the metric space. @)
    clsfvalOLD @p |- ( M e. MetSp -> ( cls ` M ) =  { <. x , y >. | ( x C_ X /\
                     y = ( x u. { v e. X | v ( acc ` M ) x } ) ) } ) @=
      ( vz vw cv c1st cfv wss cac wbr crab cun wceq wa copab cmt ccl fveq2
      syl6eqr sseq2d rabeq syl wb breq rabbisdv eqtrd uneq2d eqeq2d anbi12d
      opabbidv df-clsOLD cpw wcel cvv visset elpw anbi1i opabbii fvex eqeltri
      pwex
      opabex2 eqeltrri fvopab4 ) GHDAIZGIZJKZLZBIZVICIZVIVJMKZNZCVKOZPZQZRZAB
      SVIELZVMVIVNVIDMKZNZCEOZPZQZRZABSZTUAVJDQZVTWGABWIVLWAVSWFWIVKEVIWIVKDJKZ
      EVJDJUBFUCZUDWIVRWEVMWIVQWDVIWIVQVPCEOZWDWIVKEQVQWLQWKVPCVKEUEUFWIVPWCCEW
      IVOWBQVPWCUGVJDMUBVNVIVOWBUHUFUIUJUKULUMUNABGHCUOVIEUPZUQZWFRZABSWHURWOWG
      ABWNWAWFVIEAUSUTVAVBABWMWEEEWJURFDJVCVDVEVFVGVH @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The interior function on the subsets of the metric space. @)
    ntrfval @p |- ( M e. MetSp -> ( int ` M ) =  { <. x , y >. | ( x C_ X /\
                     y = U. { v e. ran ( ball ` M ) | v C_ x } ) } ) @=
?@.
  @}

  @{
    @d w x y z M @.  @d w x y z P @.  @d w x y z S @.  @d w x y z X @.
    accbr.1 @e |- X = ( 1st ` M ) @.
    @( A neighborhood of a point ` P ` is any subset ` S ` that contains a ball
       around ` P ` .  Definition of neighborhood in [Kreyszig] p. 19. @)
    neibrOLD @p |- ( ( M e. MetSp /\ S C_ X /\ P e. X ) ->
                    ( S ( neiOLD ` M ) P <->
                E. x e. RR ( 0 < x /\ ( P ( ball ` M ) x ) C_ S ) ) ) @=
     ( vy vz cmt wcel wss w3a cne cfv wbr cv cc0 clt cblOLD co wa cr wrex copab
      wb wceq neifvalOLD breq syl 3ad2ant1 cpw sseq1 sseq2 anbi2d rexbidv
      3anbi13d eleq1 opreq1 sseq1d 3anbi23d eqid brabg cvv c1st fvex eqeltri
      elpw2g ax-mp sylanbr df-3an baibr bitr4d 3adant1 bitrd ) DIJZCEKZBEJZLCBD
      MNZOZCBGPZEKZHPZEJZQAPZROZWBWDDSNZTZVTKZUAZAUBUCZLZGHUDZOZWEBWDWFTZCKZUAZ
      AUBUCZVOVPVSWMUEZVQVOVRWLUFWRGHADEFUGCBVRWLUHUIUJVPVQWMWQUEVOVPVQUAZWMVPV
      QWQLZWQCEUKZJZVQWMWTUEVPWKVPWCWEWGCKZUAZAUBUCZLWTGHCBXAEWLVTCUFZWAVPWJXEW
      CVTCEULXFWIXDAUBXFWHXCWEVTCWGUMUNUOUPWBBUFZWCVQXEWQVPWBBEUQXGXDWPAUBXGXCW
      OWEXGWGWNCWBBWDWFURUSUNUOUTWLVAVBEVCJXBVPUEEDVDNVCFDVDVEVFCEVCVGVHVIWTWSW
      QVPVQWQVJVKVLVMVN @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( ` P ` is an accumulation point (also called limit point) of a subset
       ` S ` iff every ball around ` P ` contains a point in ` S ` distinct
       from ` P ` .  Definition 2.20(b) [Rudin] p. 28. @)
    accbr @p |- ( ( M e. MetSp /\ P e. X /\ S C_ X ) -> ( P ( acc ` M ) S <->
            A. x e. RR ( 0 < x -> E. y e. ( P ( ball ` M ) x )
                ( y e. S /\ -. y = P ) ) ) ) @=
      ( vz vw cmt wcel wss w3a cac cfv wbr cv cc0 clt wceq wn wa cblOLD co wrex
      wi cr wral copab wb accfval breq syl 3ad2ant1 cpw eleq1 opreq1 rexeq1
      eqeq2 notbid anbi2d rexbidv bitrd imbi2d ralbidv 3anbi13d sseq1 eleq2
      anbi1d 3anbi23d eqid brabg cvv c1st fvex eqeltri elpw2g ax-mp sylan2br
      df-3an baibr bitr4d 3adant1 ) EJKZCFKZDFLZMCDENOZPZCDHQZFKZIQZFLZRAQZSPZB
      QZWKKZWOWITZUAZUBZBWIWMEUCOZUDZUEZUFZAUGUHZMZHIUIZPZWNWODKZWOCTZUAZUBZBCW
      MWTUDZUEZUFZAUGUHZWDWEWHXGUJZWFWDWGXFTXPHIABEFGUKCDWGXFULUMUNWEWFXGXOUJWD
      WEWFUBZXGWEWFXOMZXOWEDFUOZKZXGXRUJWFXEWEWLWNWPXJUBZBXLUEZUFZAUGUHZMXRHICD
      FXSXFWICTZWJWEXDYDWLWICFUPYEXCYCAUGYEXBYBWNYEXBWSBXLUEZYBYEXAXLTXBYFUJWIC
      WMWTUQWSBXAXLURUMYEWSYABXLYEWRXJWPYEWQXIWICWOUSUTVAVBVCVDVEVFWKDTZWLWFYDX
      OWEWKDFVGYGYCXNAUGYGYBXMWNYGYAXKBXLYGWPXHXJWKDWOVHVIVBVDVEVJXFVKVLFVMKXTW
      FUJFEVNOVMGEVNVOVPDFVMVQVRVSXRXQXOWEWFXOVTWAWBWCVC @.
      @( [ ?] @) @( [9-Sep-2006] @)

    @( ` P ` is an accumulation point (also called limit point) of a subset
       ` S ` iff every neighborhood of ` P ` contains a point in ` S ` distinct
       from ` P ` .  Definition of accumulation point in [Kreyszig] p. 21. @)
    accbrOLD @p |- ( ( M e. MetSp /\ P e. X /\ S C_ X ) -> ( P ( accOLD ` M ) S
                   <-> A. x ( ( x C_ X /\ x ( neiOLD ` M ) P ) -> E. y e. x
                   ( y e. S /\ -. y = P ) ) ) ) @=
      ( vz vw cmt wcel wss w3a cacOLD cfv wbr cv cne wa wceq wn wrex wi wal
      copab
      wb accfvalOLD breq syl 3ad2ant1 cpw eleq1 breq2 anbi2d eqeq2 notbid
      rexbidv
      imbi12d albidv 3anbi13d sseq1 eleq2 anbi1d imbi2d 3anbi23d eqid brabg
      cvv c1st fvex eqeltri elpw2g ax-mp sylan2br df-3an baibr bitr4d 3adant1
      bitrd ) EJKZCFKZDFLZMCDENOZPZCDHQZFKZIQZFLZAQZFLZWIWEEROZPZSZBQZWGKZWNWET
      ZUAZSZBWIUBZUCZAUDZMZHIUEZPZWJWICWKPZSZWNDKZWNCTZUAZSZBWIUBZUCZAUDZVTWAWD
      XDUFZWBVTWCXCTXNHIABEFGUGCDWCXCUHUIUJWAWBXDXMUFVTWAWBSZXDWAWBXMMZXMWADFUK
      ZKZXDXPUFWBXBWAWHXFWOXISZBWIUBZUCZAUDZMXPHICDFXQXCWECTZWFWAXAYBWHWECFULYC
      WTYAAYCWMXFWSXTYCWLXEWJWECWIWKUMUNYCWRXSBWIYCWQXIWOYCWPXHWECWNUOUPUNUQURU
      SUTWGDTZWHWBYBXMWAWGDFVAYDYAXLAYDXTXKXFYDXSXJBWIYDWOXGXIWGDWNVBVCUQVDUSVE
      XCVFVGFVHKXRWBUFFEVIOVHGEVIVJVKDFVHVLVMVNXPXOXMWAWBXMVOVPVQVRVS @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The closure of a subset of a metric space consists of the subset and
       the accumulation points of the subset.  Definition of closure of
       [Kreyszig] p. 21. @)
    clsval2 @p |- ( ( M e. MetSp /\ S C_ X ) -> ( ( cls ` M ) ` S ) =
                 ( S u. { x e. X | x ( acc ` M ) S } ) ) @=
      ? @.

    @( The interior of a subset of a metric space is the union of all the balls
       it includes.  From Definition 2.20(e) of [Rudin] p. 28.  Rudin uses
       "neighborhood" for what we call "ball." @)
    ntrval @p |- ( ( M e. MetSp /\ S C_ X ) -> ( ( int ` M ) ` S ) =
                 U. { x e. ran ( ball ` M ) | x C_ S } ) @=
?@.
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Convergence and completeness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~~>m $.  $( Limit arrow. $)
  $c Cau $.
  $c CMet $.

  $( Extend class notation with a function on metric spaces whose value is
     the convergence relation for limit sequences in the space. $)
  clm $a class ~~>m $.

  $( Extend class notation with a function on metric spaces whose value is the
     set of all Cauchy sequences of the space. $)
  cca $a class Cau $.

  $( Extend class notation with class of complete metric spaces. $)
  cms $a class CMet $.

  ${
    $d j k m x y f z w $.
    $( Define a function on metric spaces whose value is the convergence
       relation for the space.  Although ` f ` is typically a function from
       upper integers to the metric space, it doesn't have to be.
       Unfortunately, the expression after " ` w = ` " must exist to use
       ~ fvopab4 , and we use the otherwise unnecessary conjunct
       ` f C_ ( CC X. dom dom z ) ` to ensure that.  This could be changed
       to the more liberal (but more complex)
       ` f C_ ( CC X. ( dom dom z u. { (/) } ) ) ` if we want to allow for
       functions with undefined values. $)
    df-lm $a |- ~~>m = { <. z , w >. | ( z e. Met /\ w = { <. f , y >. |
      ( f C_ ( CC X. dom dom z ) /\ y e. dom dom z /\ A. x e. RR ( 0 < x ->
       E. j e. ZZ A. k e. ZZ ( j <_ k -> ( ( f ` k ) e. dom dom z /\
           ( ( f ` k ) D y ) < x ) ) ) ) } ) } $.

    $( Define a function on metric spaces whose value is the set of Cauchy
       sequences of the space. $)
    df-cau $a |- Cau = { <. z , w >. | ( z e. Met /\ w = { f |
           ( f C_ ( CC X. dom dom z ) /\ A. x e. RR ( 0 < x ->
          E. j e. ZZ A. k e. ZZ A. m e. ZZ ( ( j <_ k /\ j <_ m ) ->
            ( ( f ` k ) e. dom dom z /\ ( f ` m ) e. dom dom z /\
             ( ( f ` k ) D ( f ` m ) ) < x ) ) ) ) } ) } $.

    $( Define the class of complete metrics. $)
    df-cmet $a |- CMet = { x e. Met | A. f e. ( Cau ` x )
           E. y e. dom dom x f ( ~~>m ` x ) y } $.
  $}

  ${
    $d f j k m w x y z D $.  $d f w y z X $.
    lmfval.1 $e |- X = dom dom D $.
    $( The relation "sequence ` f ` converges to point ` y ` " in a metric
       space. $)
    lmfval $p |- ( D e. Met -> ( ~~>m ` D ) =
      { <. f , y >. | ( f C_ ( CC X. X ) /\ y e. X /\ A. x e. RR ( 0 < x ->
             E. j e. ZZ A. k e. ZZ ( j <_ k ->
      ( ( f ` k ) e. X /\ ( ( f ` k ) D y ) < x ) ) ) ) } ) $=
      cD cme wcel vf cv cc cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt
      wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy copab cvv wcel cD
      clm cfv vf cv cc cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr
      wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy copab wceq vf cv cc
      cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf
      cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral
      vj cz wrex wi vx cr wral w3a vf vy copab cc cX cxp cpw cX cxp wss cc cX
      cxp cpw cX cxp cvv wcel vf cv cc cX cxp wss vy cv cX wcel cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD
      co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy
      copab cvv wcel cD cme wcel vf cv cc cX cxp wss vy cv cX wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv
      cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy
      copab cc cX cxp cpw cX cxp cvv ssexg vf cv cc cX cxp wss vy cv cX wcel
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv
      cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral
      w3a vf vy copab vf cv cc cX cxp cpw wcel vy cv cX wcel wa cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD
      co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral wa vf vy copab
      cc cX cxp cpw cX cxp vf cv cc cX cxp cpw wcel vy cv cX wcel wa cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv
      cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral wa vf cv cc
      cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf
      cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral
      vj cz wrex wi vx cr wral w3a vf vy vf cv cc cX cxp cpw wcel vy cv cX wcel
      wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf
      cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral wa vf cv cc cX cxp cpw wcel vy cv cX wcel cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt
      wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf cv cc cX cxp wss vy
      cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cX wcel
      vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi
      vx cr wral w3a vf cv cc cX cxp cpw wcel vy cv cX wcel cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co
      vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral df-3an vf cv cc
      cX cxp cpw wcel vf cv cc cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv
      clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral vf cv cc cX cxp vf
      visset elpw 3anbi1i bitr3i opabbii cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi
      vk cz wral vj cz wrex wi vx cr wral vf vy cc cX cxp cpw cX opabssxp
      eqsstr3i cc cX cxp cpw cvv wcel cX cvv wcel cc cX cxp cpw cX cxp cvv wcel
      cD cme wcel cc cX cxp cpw cX cvv cvv xpexg cD cme wcel cX cvv wcel cc cX
      cxp cvv wcel cc cX cxp cpw cvv wcel cD cme wcel cD cdm cdm cvv cX cD cme
      wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD cdm cvv dmexg
      syl lmfval.1 syl5eqel cc cvv wcel cX cvv wcel cc cX cxp cvv wcel axcnex
      cc cX cvv cvv xpexg mpan cc cX cxp cvv pwexg 3syl cD cme wcel cD cdm cdm
      cvv cX cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD
      cdm cvv dmexg syl lmfval.1 syl5eqel sylanc sylancr vz vw cD vf cv cc vz
      cv cdm cdm cxp wss vy cv vz cv cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv vf cv cfv vz cv cdm cdm wcel vk cv vf cv cfv vy cv cD co vx
      cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy copab vf
      cv cc cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk
      cz wral vj cz wrex wi vx cr wral w3a vf vy copab cme cvv clm vz cv cD
      wceq vf cv cc vz cv cdm cdm cxp wss vy cv vz cv cdm cdm wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vz cv cdm cdm wcel vk cv vf
      cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral w3a vf cv cc cX cxp wss vy cv cX wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr
      wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy vz cv cD wceq vf cv
      cc vz cv cdm cdm cxp wss vf cv cc cX cxp wss vy cv vz cv cdm cdm wcel vy
      cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vz cv
      cdm cdm wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral
      vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf
      cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral
      vj cz wrex wi vx cr wral vz cv cD wceq cc vz cv cdm cdm cxp cc cX cxp vf
      cv vz cv cD wceq vz cv cdm cdm cX wceq cc vz cv cdm cdm cxp cc cX cxp
      wceq vz cv cD wceq vz cv cdm cdm cD cdm cdm cX vz cv cD wceq vz cv cdm cD
      cdm vz cv cD dmeq dmeqd lmfval.1 syl6eqr vz cv cdm cdm cX cc xpeq2 syl
      sseq2d vz cv cD wceq vz cv cdm cdm cX vy cv vz cv cD wceq vz cv cdm cdm
      cD cdm cdm cX vz cv cD wceq vz cv cdm cD cdm vz cv cD dmeq dmeqd lmfval.1
      syl6eqr eleq2d vz cv cD wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      vf cv cfv vz cv cdm cdm wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa
      wi vk cz wral vj cz wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz
      wral vj cz wrex wi vx cr vz cv cD wceq vj cv vk cv cle wbr vk cv vf cv
      cfv vz cv cdm cdm wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk
      cz wral vj cz wrex vj cv vk cv cle wbr vk cv vf cv cfv cX wcel vk cv vf
      cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex cc0 vx cv
      clt wbr vz cv cD wceq vj cv vk cv cle wbr vk cv vf cv cfv vz cv cdm cdm
      wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vj cv vk cv cle wbr
      vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi
      vj vk cz cz vz cv cD wceq vk cv vf cv cfv vz cv cdm cdm wcel vk cv vf cv
      cfv vy cv cD co vx cv clt wbr wa vk cv vf cv cfv cX wcel vk cv vf cv cfv
      vy cv cD co vx cv clt wbr wa vj cv vk cv cle wbr vz cv cD wceq vk cv vf
      cv cfv vz cv cdm cdm wcel vk cv vf cv cfv cX wcel vk cv vf cv cfv vy cv
      cD co vx cv clt wbr vz cv cD wceq vz cv cdm cdm cX vk cv vf cv cfv vz cv
      cD wceq vz cv cdm cdm cD cdm cdm cX vz cv cD wceq vz cv cdm cD cdm vz cv
      cD dmeq dmeqd lmfval.1 syl6eqr eleq2d anbi1d imbi2d rexralbidv imbi2d
      ralbidv 3anbi123d opabbidv vx vy vz vw cD vf vj vk df-lm fvopab4g mpdan
      $.
      $( [7-Sep-2007] $) $( [7-Sep-2006] $)

    $( The set of Cauchy sequences on a metric space. $)
    caufval $p |- ( D e. Met -> ( Cau ` D ) = { f |
           ( f C_ ( CC X. X ) /\ A. x e. RR ( 0 < x ->
          E. j e. ZZ A. k e. ZZ A. m e. ZZ ( ( j <_ k /\ j <_ m ) ->
            ( ( f ` k ) e. X /\ ( f ` m ) e. X /\
             ( ( f ` k ) D ( f ` m ) ) < x ) ) ) ) } ) $=
      cD cme wcel vf cv cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj
      cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv
      vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz
      wral vj cz wrex wi vx cr wral wa vf cab cvv wcel cD cca cfv vf cv cc cX
      cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk
      cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv
      cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr
      wral wa vf cab wceq cD cme wcel cX cvv wcel cc cX cxp cvv wcel vf cv cc
      cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa
      vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf
      cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx
      cr wral wa vf cab cvv wcel cD cme wcel cD cdm cdm cvv cX cD cme wcel cD
      cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD cdm cvv dmexg syl
      lmfval.1 syl5eqel cc cvv wcel cX cvv wcel cc cX cxp cvv wcel axcnex cc cX
      cvv cvv xpexg mpan cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle
      wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm
      cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex
      wi vx cr wral vf cc cX cxp cvv abssexg 3syl vz vw cD vf cv cc vz cv cdm
      cdm cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa
      vk cv vf cv cfv vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm cdm wcel vk
      cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz
      wral vj cz wrex wi vx cr wral wa vf cab vf cv cc cX cxp wss cc0 vx cv clt
      wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm
      cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr
      w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa vf cab cme cvv
      cca vz cv cD wceq vf cv cc vz cv cdm cdm cxp wss cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv vz cv cdm cdm wcel
      vm cv vf cv cfv vz cv cdm cdm wcel vk cv vf cv cfv vm cv vf cv cfv cD co
      vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa vf
      cv cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle
      wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm
      cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex
      wi vx cr wral wa vf vz cv cD wceq vf cv cc vz cv cdm cdm cxp wss vf cv cc
      cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa
      vk cv vf cv cfv vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm cdm wcel vk
      cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz
      wral vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv
      vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf
      cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral
      vj cz wrex wi vx cr wral vz cv cD wceq cc vz cv cdm cdm cxp cc cX cxp vf
      cv vz cv cD wceq vz cv cdm cdm cX wceq cc vz cv cdm cdm cxp cc cX cxp
      wceq vz cv cD wceq vz cv cdm cdm cD cdm cdm cX vz cv cD wceq vz cv cdm cD
      cdm vz cv cD dmeq dmeqd lmfval.1 syl6eqr vz cv cdm cdm cX cc xpeq2 syl
      sseq2d vz cv cD wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv
      cle wbr wa vk cv vf cv cfv vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm
      cdm wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz
      wral vk cz wral vj cz wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv
      vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf
      cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral
      vj cz wrex wi vx cr vz cv cD wceq vj cv vk cv cle wbr vj cv vm cv cle wbr
      wa vk cv vf cv cfv vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm cdm wcel
      vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk
      cz wral vj cz wrex vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv
      cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co
      vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex cc0 vx cv clt wbr
      vz cv cD wceq vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv
      vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm cdm wcel vk cv vf cv cfv vm
      cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vj cv vk cv cle wbr vj
      cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv
      vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vj vk cz
      cz vz cv cD wceq vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv
      cfv vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm cdm wcel vk cv vf cv cfv
      vm cv vf cv cfv cD co vx cv clt wbr w3a wi vj cv vk cv cle wbr vj cv vm
      cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv
      cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz vz cv cD wceq vk cv
      vf cv cfv vz cv cdm cdm wcel vm cv vf cv cfv vz cv cdm cdm wcel vk cv vf
      cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a vk cv vf cv cfv cX wcel vm
      cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr
      w3a vj cv vk cv cle wbr vj cv vm cv cle wbr wa vz cv cD wceq vk cv vf cv
      cfv vz cv cdm cdm wcel vk cv vf cv cfv cX wcel vm cv vf cv cfv vz cv cdm
      cdm wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx
      cv clt wbr vz cv cD wceq vz cv cdm cdm cX vk cv vf cv cfv vz cv cD wceq
      vz cv cdm cdm cD cdm cdm cX vz cv cD wceq vz cv cdm cD cdm vz cv cD dmeq
      dmeqd lmfval.1 syl6eqr eleq2d vz cv cD wceq vz cv cdm cdm cX vm cv vf cv
      cfv vz cv cD wceq vz cv cdm cdm cD cdm cdm cX vz cv cD wceq vz cv cdm cD
      cdm vz cv cD dmeq dmeqd lmfval.1 syl6eqr eleq2d 3anbi12d imbi2d ralbidv
      rexralbidv imbi2d ralbidv anbi12d abbidv vx vz vw cD vf vj vk vm df-cau
      fvopab4g mpdan $.
      $( [7-Sep-2007] $) $( [8-Sep-2006] $)
  $}

  ${
    $d f j k x y D $.
    $( The metric space convergence relation is a relation. $)
    lmrel $p |- ( D e. Met -> Rel ( ~~>m ` D ) ) $=
      cD cme wcel cD clm cfv wrel vf cv cc cD cdm cdm cxp wss vy cv cD cdm cdm
      wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cD cdm cdm
      wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz
      wrex wi vx cr wral w3a vf vy copab wrel vf cv cc cD cdm cdm cxp wss vy cv
      cD cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cD
      cdm cdm wcel vk cv vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral
      vj cz wrex wi vx cr wral w3a vf vy relopab cD cme wcel cD clm cfv vf cv
      cc cD cdm cdm cxp wss vy cv cD cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv vf cv cfv cD cdm cdm wcel vk cv vf cv cfv vy cv cD co vx cv
      clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vf vy copab wceq cD
      clm cfv wrel vf cv cc cD cdm cdm cxp wss vy cv cD cdm cdm wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cD cdm cdm wcel vk cv vf cv
      cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral
      w3a vf vy copab wrel wb vx vy cD vf vj vk cD cdm cdm cD cdm cdm eqid
      lmfval cD clm cfv vf cv cc cD cdm cdm cxp wss vy cv cD cdm cdm wcel cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv cD cdm cdm wcel vk cv
      vf cv cfv vy cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral w3a vf vy copab releq syl mpbiri $.
      $( [10-Sep-2007] $) $( [7-Dec-2006] $)
  $}

  ${
    $d f j k m w x y z F $.  $d f j k m w x y z D $.
    $d j k w x z P $.  $d f m w y z X $.
    lmbr.1 $e |- X = dom dom D $.
    $( Express the binary relation "sequence ` F ` converges to point ` P ` "
       in a metric space.  Definition 1.4-1 of [Kreyszig] p. 25.  The
       condition ` F C_ ( CC X. X ) ` allows us to use objects more general
       than sequences when convenient; see the comment in ~ df-lm . $)
    lmbr $p |- ( ( D e. Met /\ P e. A ) -> ( F ( ~~>m ` D ) P <->
    ( F C_ ( CC X. X ) /\ P e. X /\ A. x e. RR ( 0 < x -> E. j e. ZZ A. k e. ZZ
           ( j <_ k -> ( ( F ` k ) e. X /\ ( ( F ` k ) D P ) < x ) ) ) ) ) ) $=
      cD cme wcel cP cA wcel wa cF cP cD clm cfv wbr cF cc cX cxp wss cP cX
      wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
      cfv cP cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a
      cD cme wcel cF cvv wcel cP cA wcel wa wa cD cme wcel cP cA wcel wa cF cP
      cD clm cfv wbr wa cD cme wcel cF cvv wcel cP cA wcel wa cD cme wcel cP cA
      wcel cF cP cD clm cfv wbr simpll cD cme wcel cF cP cD clm cfv wbr cP cA
      wcel cF cvv wcel cP cA wcel wa cD cme wcel cF cP cD clm cfv wbr wa cF cvv
      wcel cP cA wcel cD clm cfv wrel cF cP cD clm cfv wbr cF cvv wcel cD cme
      wcel cF cP cD clm cfv brrelex cD lmrel sylan anim1i an1rs jca cD cme wcel
      cP cA wcel wa cP cX wcel cF cc cX cxp wss cD cme wcel cF cvv wcel cP cA
      wcel wa wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk
      cv cF cfv cP cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral cD cme wcel cP cA wcel cF cc cX cxp wss cD cme wcel cF cvv wcel cP
      cA wcel wa wa cD cme wcel cP cA wcel cF cc cX cxp wss wa wa cD cme wcel
      cF cvv wcel cP cA wcel cD cme wcel cP cA wcel cF cc cX cxp wss wa pm3.26
      cD cme wcel cF cc cX cxp wss cF cvv wcel cP cA wcel cF cc cX cxp wss cD
      cme wcel cF cvv wcel cF cc cX cxp wss cc cX cxp cvv wcel cF cvv wcel cD
      cme wcel cF cc cX cxp cvv ssexg cc cvv wcel cX cvv wcel cc cX cxp cvv
      wcel cD cme wcel cc cX cvv cvv xpexg axcnex cD cme wcel cD cdm cdm cvv cX
      cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD cdm cvv
      dmexg syl lmbr.1 syl5eqel sylancr sylan2 ancoms adantrl cD cme wcel cP cA
      wcel cF cc cX cxp wss simprl jca32 anassrs 3ad2antr1 cD cme wcel cF cP cD
      clm cfv wbr cF cP vz cv cc cX cxp wss vw cv cX wcel cc0 vx cv clt wbr vj
      cv vk cv cle wbr vk cv vz cv cfv cX wcel vk cv vz cv cfv vw cv cD co vx
      cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a vz vw copab wbr
      cF cvv wcel cP cA wcel wa cF cc cX cxp wss cP cX wcel cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt
      wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a cD cme wcel cD clm cfv
      vz cv cc cX cxp wss vw cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
      vk cv vz cv cfv cX wcel vk cv vz cv cfv vw cv cD co vx cv clt wbr wa wi
      vk cz wral vj cz wrex wi vx cr wral w3a vz vw copab wceq cF cP cD clm cfv
      wbr cF cP vz cv cc cX cxp wss vw cv cX wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv vz cv cfv cX wcel vk cv vz cv cfv vw cv cD co vx cv clt wbr
      wa wi vk cz wral vj cz wrex wi vx cr wral w3a vz vw copab wbr wb vx vw cD
      vz vj vk cX lmbr.1 lmfval cF cP cD clm cfv vz cv cc cX cxp wss vw cv cX
      wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vz cv cfv cX wcel vk cv
      vz cv cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral w3a vz vw copab breq syl vz cv cc cX cxp wss vw cv cX wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv vz cv cfv cX wcel vk cv vz cv cfv vw cv
      cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a cF cc
      cX cxp wss vw cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz
      wrex wi vx cr wral w3a cF cc cX cxp wss cP cX wcel cc0 vx cv clt wbr vj
      cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr
      wa wi vk cz wral vj cz wrex wi vx cr wral w3a vz vw cF cP cvv cA vz cv cc
      cX cxp wss vw cv cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vz
      cv cfv cX wcel vk cv vz cv cfv vw cv cD co vx cv clt wbr wa wi vk cz wral
      vj cz wrex wi vx cr wral w3a vz vw copab vz cv cF wceq vz cv cc cX cxp
      wss cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vz cv
      cfv cX wcel vk cv vz cv cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj
      cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz
      wrex wi vx cr wral vw cv cX wcel vz cv cF cc cX cxp sseq1 vz cv cF wceq
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vz cv cfv cX wcel vk cv vz cv
      cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vw cv cD co
      vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr vz cv cF wceq vj cv vk
      cv cle wbr vk cv vz cv cfv cX wcel vk cv vz cv cfv vw cv cD co vx cv clt
      wbr wa wi vk cz wral vj cz wrex vj cv vk cv cle wbr vk cv cF cfv cX wcel
      vk cv cF cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex cc0 vx
      cv clt wbr vz cv cF wceq vj cv vk cv cle wbr vk cv vz cv cfv cX wcel vk
      cv vz cv cfv vw cv cD co vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cF
      cfv cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr wa wi vj vk cz cz vz
      cv cF wceq vk cv vz cv cfv cX wcel vk cv vz cv cfv vw cv cD co vx cv clt
      wbr wa vk cv cF cfv cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr wa vj
      cv vk cv cle wbr vz cv cF wceq vk cv vz cv cfv cX wcel vk cv cF cfv cX
      wcel vk cv vz cv cfv vw cv cD co vx cv clt wbr vk cv cF cfv vw cv cD co
      vx cv clt wbr vz cv cF wceq vk cv vz cv cfv vk cv cF cfv cX vk cv vz cv
      cF fveq1 eleq1d vz cv cF wceq vk cv vz cv cfv vw cv cD co vk cv cF cfv vw
      cv cD co vx cv clt vz cv cF wceq vk cv vz cv cfv vk cv cF cfv vw cv cD vk
      cv vz cv cF fveq1 opreq1d breq1d anbi12d imbi2d rexralbidv imbi2d ralbidv
      3anbi13d vw cv cP wceq vw cv cX wcel cP cX wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr
      wa wi vk cz wral vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk
      cz wral vj cz wrex wi vx cr wral cF cc cX cxp wss vw cv cP cX eleq1 vw cv
      cP wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
      cF cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx
      cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr vw cv cP wceq vj cv vk cv
      cle wbr vk cv cF cfv cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr wa wi
      vk cz wral vj cz wrex vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
      cfv cP cD co vx cv clt wbr wa wi vk cz wral vj cz wrex cc0 vx cv clt wbr
      vw cv cP wceq vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vw cv
      cD co vx cv clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
      cF cfv cP cD co vx cv clt wbr wa wi vj vk cz cz vw cv cP wceq vk cv cF
      cfv cX wcel vk cv cF cfv vw cv cD co vx cv clt wbr wa vk cv cF cfv cX
      wcel vk cv cF cfv cP cD co vx cv clt wbr wa vj cv vk cv cle wbr vw cv cP
      wceq vk cv cF cfv vw cv cD co vx cv clt wbr vk cv cF cfv cP cD co vx cv
      clt wbr vk cv cF cfv cX wcel vw cv cP wceq vk cv cF cfv vw cv cD co vk cv
      cF cfv cP cD co vx cv clt vw cv cP vk cv cF cfv cD opreq2 breq1d anbi2d
      imbi2d rexralbidv imbi2d ralbidv 3anbi23d vz cv cc cX cxp wss vw cv cX
      wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv vz cv cfv cX wcel vk cv
      vz cv cfv vw cv cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr
      wral w3a vz vw copab eqid brabg sylan9bb pm5.21nd $.
      $( [10-Sep-2007] $) $( [7-Dec-2006] $)

    ${
      $d j x D $.  $d j k N $.  $d j k x X $.  $d j k x Z $.  $d j k x R $.
      lmbr2.3 $e |- N e. ZZ $.
      lmbr2.4 $e |- Z = ( ZZ>= ` N ) $.
      $( Express the binary relation "sequence ` F ` converges to point ` P ` "
         in a metric space using an abitrary set of upper integers. $)
      lmbr2 $p |-  ( ( D e. Met /\ P e. A ) -> ( F ( ~~>m ` D ) P <->
      ( F C_ ( CC X. X ) /\ P e. X /\ A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z
           ( j <_ k -> ( ( F ` k ) e. X /\ ( ( F ` k ) D P ) < x ) ) ) ) ) ) $=
        cD cme wcel cP cA wcel wa cF cP cD clm cfv wbr cF cc cX cxp wss cP cX
        wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
        cF cfv cP cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral
        w3a cF cc cX cxp wss cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
        vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ
        wral vj cZ wrex wi vx cr wral w3a vx cA cD cP vj vk cF cX lmbr.1 lmbr
        cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv
        cP cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral cc0 vx
        cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD
        co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral cF cc cX cxp
        wss cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX
        wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cz wral vj cz wrex wi
        cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv
        cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr vj cv vk cv
        cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi
        vk cz wral vj cz wrex vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
        cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex cc0 vx cv clt
        wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa vj vk
        cN cN cZ cZ lmbr2.3 cZ cN cuz cfv lmbr2.4 eqimss2i cZ cN cuz cfv cz
        lmbr2.4 cN uzssz eqsstri lmbr2.3 cZ cN cuz cfv lmbr2.4 eqimss2i cZ cN
        cuz cfv cz lmbr2.4 cN uzssz eqsstri cvg3i imbi2i ralbii 3anbi3i syl6bb
        $.
        $( [11-Sep-2007] $) $( [19-Dec-2006] $)

      $( Express the binary relation "sequence ` F ` converges to point ` P ` "
         in a metric space using an abitrary set of upper integers.  This
         version of ~ lmbr2 presupposes that ` F ` is a function. $)
      lmbrf $p |-  ( ( D e. Met /\ P e. A /\ F : Z --> X ) ->
   ( F ( ~~>m ` D ) P <-> ( P e. X /\ A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z
           ( j <_ k -> ( ( F ` k ) D P ) < x ) ) ) ) ) $=
        cD cme wcel cP cA wcel cZ cX cF wf w3a cF cP cD clm cfv wbr cF cc cX
        cxp wss cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
        cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex
        wi vx cr wral w3a cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk
        cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ wrex wi vx cr wral
        wa cD cme wcel cP cA wcel cF cP cD clm cfv wbr cF cc cX cxp wss cP cX
        wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
        cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral
        w3a wb cZ cX cF wf vx cA cD cP vj vk cF cN cX cZ lmbr.1 lmbr2.3 lmbr2.4
        lmbr2 3adant3 cZ cX cF wf cD cme wcel cF cc cX cxp wss cP cX wcel cc0
        vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP
        cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral w3a cP cX
        wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv
        clt wbr wi vk cZ wral vj cZ wrex wi vx cr wral wa wb cP cA wcel cZ cX
        cF wf cF cc cX cxp wss cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
        vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ
        wral vj cZ wrex wi vx cr wral w3a cP cX wcel cc0 vx cv clt wbr vj cv vk
        cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa
        wi vk cZ wral vj cZ wrex wi vx cr wral wa cP cX wcel cc0 vx cv clt wbr
        vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral
        vj cZ wrex wi vx cr wral wa cZ cX cF wf cP cX wcel cc0 vx cv clt wbr vj
        cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt
        wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral wa cF cc cX cxp wss cP cX
        wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
        cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral
        wa wa cF cc cX cxp wss cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
        vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ
        wral vj cZ wrex wi vx cr wral w3a cZ cX cF wf cF cc cX cxp wss cP cX
        wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
        cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral
        wa cF cZ cX cxp wss cZ cX cxp cc cX cxp wss cF cc cX cxp wss cZ cX cF
        wf cF cZ cX cxp cc cX cxp sstr cZ cX cF fssxp cZ cc wss cX cX wss cZ cX
        cxp cc cX cxp wss cZ cN cuz cfv cc lmbr2.4 cN cuz cfv cz cc cN uzssz
        zsscn sstri eqsstri cX ssid cZ cc cX cX ssxp mp2an sylancl biantrurd cF
        cc cX cxp wss cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
        cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ
        wrex wi vx cr wral 3anass syl6rbbr cZ cX cF wf cc0 vx cv clt wbr vj cv
        vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ
        wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
        cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex
        wi vx cr wral cP cX wcel cZ cX cF wf cc0 vx cv clt wbr vj cv vk cv cle
        wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ wrex wi cc0
        vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP
        cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr cZ cX cF wf vj
        cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral vj
        cZ wrex vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co
        vx cv clt wbr wa wi vk cZ wral vj cZ wrex cc0 vx cv clt wbr cZ cX cF wf
        vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral
        vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv
        clt wbr wa wi vk cZ wral vj cZ cZ cX cF wf vj cv vk cv cle wbr vk cv cF
        cfv cP cD co vx cv clt wbr wi vj cv vk cv cle wbr vk cv cF cfv cX wcel
        vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ cZ cX cF wf vk cv cZ
        wcel wa vk cv cF cfv cP cD co vx cv clt wbr vk cv cF cfv cX wcel vk cv
        cF cfv cP cD co vx cv clt wbr wa vj cv vk cv cle wbr cZ cX cF wf vk cv
        cZ wcel wa vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr cZ
        cX vk cv cF ffvelrn biantrurd imbi2d ralbidva rexbidv imbi2d ralbidv
        anbi2d bitr4d 3ad2ant3 bitrd $.
        $( [15-Sep-2007] $) $( [20-Jul-2007] $)

      $( Express the binary relation "sequence ` F ` converges to point ` P ` "
         in a metric space using an abitrary set of upper integers.  This
         version of ~ lmbrf presupposes that the convergence point is in the
         metric space. $)
      lmbrf2 $p |-  ( ( D e. Met /\ P e. X /\ F : Z --> X ) ->
   ( F ( ~~>m ` D ) P <-> A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z
           ( j <_ k -> ( ( F ` k ) D P ) < x ) ) ) ) $=
        cD cme wcel cP cX wcel cZ cX cF wf w3a cF cP cD clm cfv wbr cP cX wcel
        cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt
        wbr wi vk cZ wral vj cZ wrex wi vx cr wral wa cc0 vx cv clt wbr vj cv
        vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ
        wrex wi vx cr wral vx cX cD cP vj vk cF cN cX cZ lmbr.1 lmbr2.3 lmbr2.4
        lmbrf cD cme wcel cP cX wcel cZ cX cF wf w3a cP cX wcel cc0 vx cv clt
        wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cZ
        wral vj cZ wrex wi vx cr wral cD cme wcel cP cX wcel cZ cX cF wf 3simp2
        biantrurd bitr4d $.
        $( [5-Oct-2007] $) $( [24-Jul-2007] $)

      $( Convergence property of a converging sequence. $)
      lmcvg $p |- ( ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) /\
             ( R e. RR /\ 0 < R ) ) -> E. j e. Z A. k e. Z
           ( j <_ k -> ( ( F ` k ) e. X /\ ( ( F ` k ) D P ) < R ) ) ) $=
        cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cR cr wcel cc0 cR clt
        wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cR
        clt wbr wa wi vk cZ wral vj cZ wrex cD cme wcel cP cA wcel cF cP cD clm
        cfv wbr w3a cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel
        vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx
        cr wral cR cr wcel cc0 cR clt wbr vj cv vk cv cle wbr vk cv cF cfv cX
        wcel vk cv cF cfv cP cD co cR clt wbr wa wi vk cZ wral vj cZ wrex wi wi
        cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cF cc cX cxp wss cP cX
        wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
        cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral
        cD cme wcel cP cA wcel cF cP cD clm cfv wbr cF cc cX cxp wss cP cX wcel
        cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv
        cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi vx cr wral w3a vx
        cA cD cP vj vk cF cN cX cZ lmbr.1 lmbr2.3 lmbr2.4 lmbr2 biimp3a 3simp3d
        cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv
        cP cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex wi cc0 cR clt wbr vj
        cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cR clt wbr
        wa wi vk cZ wral vj cZ wrex wi vx cR cr vx cv cR wceq cc0 vx cv clt wbr
        cc0 cR clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP
        cD co vx cv clt wbr wa wi vk cZ wral vj cZ wrex vj cv vk cv cle wbr vk
        cv cF cfv cX wcel vk cv cF cfv cP cD co cR clt wbr wa wi vk cZ wral vj
        cZ wrex vx cv cR cc0 clt breq2 vx cv cR wceq vj cv vk cv cle wbr vk cv
        cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vj cv vk cv
        cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cR clt wbr wa wi vj
        vk cZ cZ vx cv cR wceq vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv
        clt wbr wa vk cv cF cfv cX wcel vk cv cF cfv cP cD co cR clt wbr wa vj
        cv vk cv cle wbr vx cv cR wceq vk cv cF cfv cP cD co vx cv clt wbr vk
        cv cF cfv cP cD co cR clt wbr vk cv cF cfv cX wcel vx cv cR vk cv cF
        cfv cP cD co clt breq2 anbi2d imbi2d rexralbidv imbi12d rcla4cv syl
        imp32 $.
        $( [29-Sep-2007] $) $( [1-Jun-2007] $)

      $( MAY BE REVISED - use this to improve uses of lmcvg $)
      $( Convergence property of a converging sequence. $)
      lmcvg2 $p |- ( ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) /\
             ( R e. RR /\ 0 < R ) ) -> E. j e. Z A. k e. Z
           ( j <_ k -> ( ( F ` k ) D P ) < R ) ) $=
        cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cR cr wcel cc0 cR clt
        wbr wa wa vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD
        co cR clt wbr wa wi vk cZ wral vj cZ wrex vj cv vk cv cle wbr vk cv cF
        cfv cP cD co cR clt wbr wi vk cZ wral vj cZ wrex cA cD cP cR vj vk cF
        cN cX cZ lmbr.1 lmbr2.3 lmbr2.4 lmcvg vj cv vk cv cle wbr vk cv cF cfv
        cX wcel vk cv cF cfv cP cD co cR clt wbr wa wi vk cZ wral vj cv vk cv
        cle wbr vk cv cF cfv cP cD co cR clt wbr wi vk cZ wral vj cZ vj cv vk
        cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cR clt wbr wa wi
        vj cv vk cv cle wbr vk cv cF cfv cP cD co cR clt wbr wi vk cZ vk cv cF
        cfv cX wcel vk cv cF cfv cP cD co cR clt wbr wa vk cv cF cfv cP cD co
        cR clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD
        co cR clt wbr pm3.27 imim2i r19.20si r19.22si syl $.
        $( [30-Sep-2007] $) $( [20-Jul-2007] $)

      $( A constant sequence converges to its value. $)
      lmconst $p |- ( ( D e. Met /\ P e. X ) ->
                     ( Z X. { P } ) ( ~~>m ` D ) P ) $=
        cD cme wcel cP cX wcel wa cZ cP csn cxp cP cD clm cfv wbr cc0 vx cv clt
        wbr vj cv vk cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr
        wi vk cZ wral vj cZ wrex wi vx cr wral cD cme wcel cP cX wcel wa cc0 vx
        cv clt wbr vj cv vk cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx cv
        clt wbr wi vk cZ wral vj cZ wrex wi vx cr cD cme wcel cP cX wcel wa cc0
        vx cv clt wbr vj cv vk cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx
        cv clt wbr wi vk cZ wral vj cZ wrex wi vx cv cr wcel cD cme wcel cP cX
        wcel wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cZ cP csn cxp cfv
        cP cD co vx cv clt wbr wi vk cZ wral vj cZ wrex cN cZ wcel cN vk cv cle
        wbr vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr wi vk cZ wral vj cv
        vk cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr wi vk cZ
        wral vj cZ wrex cD cme wcel cP cX wcel wa cc0 vx cv clt wbr wa vj cv vk
        cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr wi vk cZ wral
        cN vk cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr wi vk
        cZ wral vj cN cZ vj cv cN wceq vj cv vk cv cle wbr vk cv cZ cP csn cxp
        cfv cP cD co vx cv clt wbr wi cN vk cv cle wbr vk cv cZ cP csn cxp cfv
        cP cD co vx cv clt wbr wi vk cZ vj cv cN wceq vj cv vk cv cle wbr cN vk
        cv cle wbr vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr vj cv cN vk
        cv cle breq1 imbi1d ralbidv rcla4ev cN cz wcel cN cZ wcel lmbr2.3 cN cz
        wcel cN cN cuz cfv cZ cN uzid lmbr2.4 syl6eleqr ax-mp cD cme wcel cP cX
        wcel wa cc0 vx cv clt wbr wa cN vk cv cle wbr vk cv cZ cP csn cxp cfv
        cP cD co vx cv clt wbr wi vk cZ cD cme wcel cP cX wcel wa cc0 vx cv clt
        wbr wa vk cv cZ wcel wa vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr
        cN vk cv cle wbr cD cme wcel cP cX wcel wa cc0 vx cv clt wbr wa vk cv
        cZ wcel wa vk cv cZ cP csn cxp cfv cP cD co cc0 vx cv clt cD cme wcel
        cP cX wcel wa vk cv cZ wcel vk cv cZ cP csn cxp cfv cP cD co cc0 wceq
        cc0 vx cv clt wbr cD cme wcel cP cX wcel wa vk cv cZ wcel wa vk cv cZ
        cP csn cxp cfv cP cD co cP cP cD co cc0 cD cme wcel cP cX wcel wa vk cv
        cZ wcel wa vk cv cZ cP csn cxp cfv cP cP cD cP cX wcel vk cv cZ wcel vk
        cv cZ cP csn cxp cfv cP wceq cD cme wcel cZ cP vk cv cX fvconst2g
        adantll opreq1d cD cme wcel cP cX wcel wa cP cP cD co cc0 wceq vk cv cZ
        wcel cP cD cX lmbr.1 met0 adantr eqtrd adantlr cD cme wcel cP cX wcel
        wa cc0 vx cv clt wbr vk cv cZ wcel simplr eqbrtrd a1d r19.21aiva
        sylancr ex a1d r19.21aiv cD cme wcel cP cX wcel cZ cX cZ cP csn cxp wf
        cZ cP csn cxp cP cD clm cfv wbr cc0 vx cv clt wbr vj cv vk cv cle wbr
        vk cv cZ cP csn cxp cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ wrex
        wi vx cr wral wb cP cX wcel cZ cX cZ cP csn cxp wf cD cme wcel cZ cP
        csn cZ cP csn cxp wf cP csn cX wss cZ cX cZ cP csn cxp wf cP cX wcel cZ
        cP csn cX cZ cP csn cxp fss cZ cP cX fconstg cP cX snssi sylanc adantl
        vx cD cP vj vk cZ cP csn cxp cN cX cZ lmbr.1 lmbr2.3 lmbr2.4 lmbrf2
        mpd3an3 mpbird $.
        $( [25-Dec-2007] $) $( [8-Nov-2007] $)
    $}

    ${
      $d j k x X $.
      $( A condition that implies convergence. $)
      lmnn $p |- ( ( ( D e. Met /\ P e. X ) /\ ( F : NN --> X /\ A. k e. NN
                 ( ( F ` k ) D P ) < ( 1 / k ) ) ) -> F ( ~~>m ` D ) P ) $=
        cD cme wcel cP cX wcel wa cn cX cF wf vk cv cF cfv cP cD co c1 vk cv
        cdiv co clt wbr vk cn wral cF cP cD clm cfv wbr cD cme wcel cP cX wcel
        wa cn cX cF wf wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr vk cn
        wral cF cP cD clm cfv wbr cD cme wcel cP cX wcel wa cn cX cF wf wa vk
        cv cF cfv cP cD co c1 vk cv cdiv co clt wbr vk cn wral cP cX wcel cc0
        vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr
        wi vk cn wral vj cn wrex wi vx cr wral wa cF cP cD clm cfv wbr cD cme
        wcel cP cX wcel wa cn cX cF wf wa vk cv cF cfv cP cD co c1 vk cv cdiv
        co clt wbr vk cn wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
        cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral cP cX
        wcel cD cme wcel cP cX wcel wa cn cX cF wf wa vk cv cF cfv cP cD co c1
        vk cv cdiv co clt wbr vk cn wral cc0 vx cv clt wbr vj cv vk cv cle wbr
        vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr
        cD cme wcel cP cX wcel wa cn cX cF wf wa vk cv cF cfv cP cD co c1 vk cv
        cdiv co clt wbr vk cn wral vx cv cr wcel cc0 vx cv clt wbr vj cv vk cv
        cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex cD
        cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv clt wbr
        wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr vk cn wral vj cv vk
        cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex
        cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv clt
        wbr wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr vk cn wral vj cv
        vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn
        wrex c1 vx cv cdiv co c1 caddc co cfl cfv cn wcel c1 vx cv cdiv co c1
        caddc co cfl cfv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi
        vk cn wral vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi
        vk cn wral vj cn wrex cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr
        wcel cc0 vx cv clt wbr wa wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt
        wbr vk cn wral wa vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt
        wbr wi vk cn wral c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr vk
        cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj c1 vx cv cdiv co c1
        caddc co cfl cfv cn vj cv c1 vx cv cdiv co c1 caddc co cfl cfv wceq vj
        cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi c1 vx cv cdiv
        co c1 caddc co cfl cfv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt
        wbr wi vk cn vj cv c1 vx cv cdiv co c1 caddc co cfl cfv wceq vj cv vk
        cv cle wbr c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr vk cv cF
        cfv cP cD co vx cv clt wbr vj cv c1 vx cv cdiv co c1 caddc co cfl cfv
        vk cv cle breq1 imbi1d ralbidv rcla4ev vx cv cr wcel cc0 vx cv clt wbr
        wa c1 vx cv cdiv co c1 caddc co cfl cfv cn wcel cD cme wcel cP cX wcel
        wa cn cX cF wf wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr vk cn
        wral c1 vx cv cdiv co c1 caddc co cr wcel c1 c1 vx cv cdiv co c1 caddc
        co cle wbr c1 vx cv cdiv co c1 caddc co cfl cfv cn wcel vx cv cr wcel
        cc0 vx cv clt wbr wa c1 vx cv cdiv co c1 caddc co flge1nn vx cv cr wcel
        cc0 vx cv clt wbr wa c1 vx cv cdiv co cr wcel c1 vx cv cdiv co c1 caddc
        co cr wcel vx cv cr wcel cc0 vx cv clt wbr vx cv cc0 wne c1 vx cv cdiv
        co cr wcel vx cv gt0ne0 vx cv rereccl syldan c1 vx cv cdiv co peano2re
        syl vx cv cr wcel cc0 vx cv clt wbr wa cc0 c1 vx cv cdiv co cle wbr c1
        c1 vx cv cdiv co c1 caddc co cle wbr c1 vx cv cdiv co cr wcel cc0 c1 vx
        cv cdiv co clt wbr cc0 c1 vx cv cdiv co cle wbr vx cv cr wcel cc0 vx cv
        clt wbr wa cc0 cr wcel c1 vx cv cdiv co cr wcel cc0 c1 vx cv cdiv co
        clt wbr cc0 c1 vx cv cdiv co cle wbr wi 0re cc0 c1 vx cv cdiv co ltle
        mpan vx cv cr wcel cc0 vx cv clt wbr vx cv cc0 wne c1 vx cv cdiv co cr
        wcel vx cv gt0ne0 vx cv rereccl syldan vx cv recgt0 sylc c1 cr wcel c1
        vx cv cdiv co cr wcel cc0 c1 vx cv cdiv co cle wbr c1 c1 vx cv cdiv co
        c1 caddc co cle wbr wb vx cv cr wcel cc0 vx cv clt wbr wa c1 c1 vx cv
        cdiv co addge02 1re vx cv cr wcel cc0 vx cv clt wbr vx cv cc0 wne c1 vx
        cv cdiv co cr wcel vx cv gt0ne0 vx cv rereccl syldan sylancr mpbid
        sylanc ad2antlr cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel
        cc0 vx cv clt wbr wa wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr
        vk cn wral c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr vk cv cF
        cfv cP cD co vx cv clt wbr wi vk cn wral cD cme wcel cP cX wcel wa cn
        cX cF wf wa vx cv cr wcel cc0 vx cv clt wbr wa wa vk cv cF cfv cP cD co
        c1 vk cv cdiv co clt wbr c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle
        wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn cD cme wcel cP cX wcel
        wa cn cX cF wf wa vx cv cr wcel cc0 vx cv clt wbr wa wa vk cv cn wcel
        wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr c1 vx cv cdiv co c1
        caddc co cfl cfv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr cD
        cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv clt wbr
        wa wa vk cv cn wcel wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr
        c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr wa wa vk cv cF cfv
        cP cD co c1 vk cv cdiv co vx cv cD cme wcel cP cX wcel wa cn cX cF wf
        wa vx cv cr wcel cc0 vx cv clt wbr wa wa vk cv cn wcel wa vk cv cF cfv
        cP cD co cr wcel vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr c1 vx
        cv cdiv co c1 caddc co cfl cfv vk cv cle wbr wa cD cme wcel cP cX wcel
        wa cn cX cF wf wa vk cv cn wcel vk cv cF cfv cP cD co cr wcel vx cv cr
        wcel cc0 vx cv clt wbr wa cD cme wcel cP cX wcel wa cn cX cF wf vk cv
        cn wcel vk cv cF cfv cP cD co cr wcel cD cme wcel cP cX wcel wa vk cv
        cF cfv cX wcel vk cv cF cfv cP cD co cr wcel cn cX cF wf vk cv cn wcel
        wa cD cme wcel cP cX wcel vk cv cF cfv cX wcel vk cv cF cfv cP cD co cr
        wcel cD cme wcel vk cv cF cfv cX wcel cP cX wcel vk cv cF cfv cP cD co
        cr wcel vk cv cF cfv cP cD cX lmbr.1 metcl 3com23 3expa cn cX vk cv cF
        ffvelrn sylan2 anassrs adantlr adantr vk cv cn wcel c1 vk cv cdiv co cr
        wcel cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv
        clt wbr wa wa vk cv cF cfv cP cD co c1 vk cv cdiv co clt wbr c1 vx cv
        cdiv co c1 caddc co cfl cfv vk cv cle wbr wa vk cv nnrecre ad2antlr cD
        cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv clt wbr
        wa wa vx cv cr wcel vk cv cn wcel vk cv cF cfv cP cD co c1 vk cv cdiv
        co clt wbr c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr wa cD cme
        wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv clt wbr
        simprl ad2antrr cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel
        cc0 vx cv clt wbr wa wa vk cv cn wcel wa vk cv cF cfv cP cD co c1 vk cv
        cdiv co clt wbr c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr
        simprl cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr wcel cc0 vx cv
        clt wbr wa wa vk cv cn wcel wa vk cv cF cfv cP cD co c1 vk cv cdiv co
        clt wbr c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr c1 vk cv
        cdiv co vx cv cle wbr cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv cr
        wcel cc0 vx cv clt wbr wa wa vk cv cn wcel wa c1 vx cv cdiv co c1 caddc
        co cfl cfv vk cv cle wbr c1 vk cv cdiv co vx cv cle wbr wi vk cv cF cfv
        cP cD co c1 vk cv cdiv co clt wbr vx cv cr wcel cc0 vx cv clt wbr wa vk
        cv cn wcel c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr c1 vk cv
        cdiv co vx cv cle wbr wi cD cme wcel cP cX wcel wa cn cX cF wf wa vx cv
        cr wcel cc0 vx cv clt wbr wa vk cv cn wcel wa c1 vx cv cdiv co c1 caddc
        co cfl cfv vk cv cle wbr c1 vk cv cdiv co vx cv clt wbr c1 vk cv cdiv
        co vx cv cle wbr vx cv cr wcel cc0 vx cv clt wbr wa vk cv cn wcel wa c1
        vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr c1 vx cv cdiv co vk cv
        clt wbr c1 vk cv cdiv co vx cv clt wbr c1 vx cv cdiv co cr wcel vk cv
        cn wcel c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle wbr c1 vx cv
        cdiv co vk cv clt wbr wi vx cv cr wcel cc0 vx cv clt wbr wa c1 vx cv
        cdiv co cr wcel vk cv cn wcel wa c1 vx cv cdiv co c1 vx cv cdiv co c1
        caddc co cfl cfv clt wbr c1 vx cv cdiv co c1 caddc co cfl cfv vk cv cle
        wbr c1 vx cv cdiv co vk cv clt wbr c1 vx cv cdiv co cr wcel c1 vx cv
        cdiv co c1 vx cv cdiv co c1 caddc co cfl cfv clt wbr vk cv cn wcel c1
        vx cv cdiv co cr wcel c1 vx cv cdiv co c1 vx cv cdiv co cfl cfv c1
        caddc co c1 vx cv cdiv co c1 caddc co cfl cfv clt c1 vx cv cdiv co
        flltp1 c1 vx cv cdiv co cr wcel c1 cz wcel c1 vx cv cdiv co c1 caddc co
        cfl cfv c1 vx cv cdiv co cfl cfv c1 caddc co wceq 1z c1 vx cv cdiv co
        c1 fladdz mpan2 breqtrrd adantr c1 vx cv cdiv co cr wcel c1 vx cv cdiv
        co c1 caddc co cfl cfv cr wcel vk cv cr wcel c1 vx cv cdiv co c1 vx cv
        cdiv co c1 caddc co cfl cfv clt wbr c1 vx cv cdiv co c1 caddc co cfl
        cfv vk cv cle wbr wa c1 vx cv cdiv co vk cv clt wbr wi c1 vx cv cdiv co
        cr wcel vk cv cn wcel wa c1 vx cv cdiv co c1 vx cv cdiv co c1 caddc co
        cfl cfv vk cv ltletr c1 vx cv cdiv co cr wcel vk cv cn wcel pm3.26 c1
        vx cv cdiv co cr wcel c1 vx cv cdiv co c1 caddc co cfl cfv cr wcel vk
        cv cn wcel c1 vx cv cdiv co cr wcel c1 vx cv cdiv co c1 caddc co cr
        wcel c1 vx cv cdiv co c1 caddc co cfl cfv cr wcel c1 vx cv cdiv co
        peano2re c1 vx cv cdiv co c1 caddc co reflcl syl adantr vk cv cn wcel
        vk cv cr wcel c1 vx cv cdiv co cr wcel vk cv nnre adantl syl3anc mpand
        vx cv cr wcel cc0 vx cv clt wbr vx cv cc0 wne c1 vx cv cdiv co cr wcel
        vx cv gt0ne0 vx cv rereccl syldan sylan vx cv cr wcel cc0 vx cv clt wbr
        wa vk cv cr wcel cc0 vk cv clt wbr wa c1 vx cv cdiv co vk cv clt wbr c1
        vk cv cdiv co vx cv clt wbr wb vk cv cn wcel vx cv vk cv ltrec1 vk cv
        cn wcel vk cv cr wcel cc0 vk cv clt wbr vk cv nnre vk cv nngt0 jca
        sylan2 sylibd vx cv cr wcel vk cv cn wcel c1 vk cv cdiv co vx cv clt
        wbr c1 vk cv cdiv co vx cv cle wbr wi cc0 vx cv clt wbr vk cv cn wcel
        vx cv cr wcel c1 vk cv cdiv co vx cv clt wbr c1 vk cv cdiv co vx cv cle
        wbr wi c1 vk cv cdiv co cr wcel vx cv cr wcel c1 vk cv cdiv co vx cv
        clt wbr c1 vk cv cdiv co vx cv cle wbr wi vk cv cn wcel c1 vk cv cdiv
        co vx cv ltle vk cv nnrecre sylan ancoms adantlr syld adantll a1d imp32
        ltletrd exp32 r19.20dva imp sylanc exp31 com23 exp4a r19.21adv cD cme
        wcel cP cX wcel cn cX cF wf simplr jctild cD cme wcel cP cX wcel cn cX
        cF wf cF cP cD clm cfv wbr cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle
        wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx
        cr wral wa wb vx cX cD cP vj vk cF c1 cX cn lmbr.1 1z nnuz lmbrf 3expa
        sylibrd imp anasss $.
        $( [6-Oct-2007] $) $( [8-Jun-2007] $)
    $}

    $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` ."
       Part of Definition 1.4-3 of [Kreyszig] p. 28.  The condition
       ` F C_ ( CC X. X ) ` allows us to use objects more general than
       sequences when convenient; see the comment in ~ df-lm . $)
    iscau $p |- ( D e. Met -> ( F e. ( Cau ` D ) <-> ( F C_ ( CC X. X ) /\
                 A. x e. RR ( 0 < x -> E. j e. ZZ A. k e. ZZ A. m e. ZZ (
              ( j <_ k /\ j <_ m ) -> ( ( F ` k ) e. X /\ ( F ` m ) e. X /\
                 ( ( F ` k ) D ( F ` m ) ) < x ) ) ) ) ) ) $=
      cD cme wcel cF cD cca cfv wcel cF cc0 vx cv clt wbr vj cv vk cv cle wbr
      vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk
      cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz
      wral vj cz wrex wi vx cr wral vf cc cX cxp cpw crab wcel cF cc cX cxp wss
      cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv
      cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt
      wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa cD cme wcel
      cD cca cfv cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa
      vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf
      cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx
      cr wral vf cc cX cxp cpw crab cF cD cme wcel cD cca cfv vf cv cc cX cxp
      wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf
      cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD
      co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa
      vf cab cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv
      vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv
      cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral
      vf cc cX cxp cpw crab vx cD vf vj vk vm cX lmbr.1 caufval cc0 vx cv clt
      wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm
      cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr
      w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral vf cc cX cxp cpw
      crab vf cv cc cX cxp cpw wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv
      vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf
      cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral
      vj cz wrex wi vx cr wral wa vf cab vf cv cc cX cxp wss cc0 vx cv clt wbr
      vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv
      vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a
      wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa vf cab cc0 vx cv clt
      wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm
      cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr
      w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral vf cc cX cxp cpw
      df-rab vf cv cc cX cxp cpw wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj
      cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv
      vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz
      wral vj cz wrex wi vx cr wral wa vf cv cc cX cxp wss cc0 vx cv clt wbr vj
      cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf
      cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi
      vm cz wral vk cz wral vj cz wrex wi vx cr wral wa vf vf cv cc cX cxp cpw
      wcel vf cv cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm
      cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv
      cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj
      cz wrex wi vx cr wral vf cv cc cX cxp vf visset elpw anbi1i abbii eqtr2i
      syl6eq eleq2d cD cme wcel cF cc cX cxp cpw wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv cX
      wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk
      cz wral vj cz wrex wi vx cr wral wa cF cc cX cxp wss cc0 vx cv clt wbr vj
      cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv
      cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral
      vk cz wral vj cz wrex wi vx cr wral wa cF cc0 vx cv clt wbr vj cv vk cv
      cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX
      wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm cz
      wral vk cz wral vj cz wrex wi vx cr wral vf cc cX cxp cpw crab wcel cD
      cme wcel cF cc cX cxp cpw wcel cF cc cX cxp wss cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv cX
      wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk
      cz wral vj cz wrex wi vx cr wral cD cme wcel cc cX cxp cvv wcel cF cc cX
      cxp cpw wcel cF cc cX cxp wss wb cc cvv wcel cX cvv wcel cc cX cxp cvv
      wcel cD cme wcel cc cX cvv cvv xpexg axcnex cD cme wcel cD cdm cdm cvv cX
      cD cme wcel cD cdm cvv wcel cD cdm cdm cvv wcel cD cme dmexg cD cdm cvv
      dmexg syl lmbr.1 syl5eqel sylancr cF cc cX cxp cvv elpw2g syl anbi1d cc0
      vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv
      cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx
      cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral cc0 vx
      cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX
      wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr
      w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral vf cF cc cX cxp cpw
      vf cv cF wceq cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr
      wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv
      vf cv cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi
      cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv
      cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt
      wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr vf cv cF wceq vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv
      cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vm
      cz wral vk cz wral vj cz wrex vj cv vk cv cle wbr vj cv vm cv cle wbr wa
      vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co
      vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex cc0 vx cv clt wbr
      vf cv cF wceq vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv vf cv cfv
      cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx
      cv clt wbr w3a wi vm cz wral vj cv vk cv cle wbr vj cv vm cv cle wbr wa
      vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co
      vx cv clt wbr w3a wi vm cz wral vj vk cz cz vf cv cF wceq vj cv vk cv cle
      wbr vj cv vm cv cle wbr wa vk cv vf cv cfv cX wcel vm cv vf cv cfv cX
      wcel vk cv vf cv cfv vm cv vf cv cfv cD co vx cv clt wbr w3a wi vj cv vk
      cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv cX
      wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz vf cv cF
      wceq vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm
      cv vf cv cfv cD co vx cv clt wbr w3a vk cv cF cfv cX wcel vm cv cF cfv cX
      wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a vj cv vk cv cle
      wbr vj cv vm cv cle wbr wa vf cv cF wceq vk cv vf cv cfv cX wcel vk cv cF
      cfv cX wcel vm cv vf cv cfv cX wcel vm cv cF cfv cX wcel vk cv vf cv cfv
      vm cv vf cv cfv cD co vx cv clt wbr vk cv cF cfv vm cv cF cfv cD co vx cv
      clt wbr vf cv cF wceq vk cv vf cv cfv vk cv cF cfv cX vk cv vf cv cF
      fveq1 eleq1d vf cv cF wceq vm cv vf cv cfv vm cv cF cfv cX vm cv vf cv cF
      fveq1 eleq1d vf cv cF wceq vk cv vf cv cfv vm cv vf cv cfv cD co vk cv cF
      cfv vm cv cF cfv cD co vx cv clt vf cv cF wceq vk cv vf cv cfv vk cv cF
      cfv vm cv vf cv cfv vm cv cF cfv cD vk cv vf cv cF fveq1 vm cv vf cv cF
      fveq1 opreq12d breq1d 3anbi123d imbi2d ralbidv rexralbidv imbi2d ralbidv
      elrab syl5bb bitrd $.
      $( [10-Sep-2007] $) $( [7-Dec-2006] $)

    ${
      $d j k x D $.  $d j k m N $.  $d j k x X $.  $d j k m x y Z $.
      iscau3.3 $e |- N e. ZZ $.
      iscau3.4 $e |- Z = ( ZZ>= ` N ) $.
      $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` ,"
         using an abitrary set of upper integers. $)
      iscau2 $p |- ( D e. Met -> ( F e. ( Cau ` D ) <-> ( F C_ ( CC X. X ) /\
                 A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z A. m e. Z (
              ( j <_ k /\ j <_ m ) -> ( ( F ` k ) e. X /\ ( F ` m ) e. X /\
                 ( ( F ` k ) D ( F ` m ) ) < x ) ) ) ) ) ) $=
        cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vj cv
        vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv
        cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral
        vk cz wral vj cz wrex wi vx cr wral wa cF cc cX cxp wss cc0 vx cv clt
        wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm
        cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi
        vm cZ wral vk cZ wral vj cZ wrex wi vx cr wral wa vx cD vj vk vm cF cX
        lmbr.1 iscau cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr
        wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv
        cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr
        wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv
        cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx
        cv clt wbr w3a wi vm cZ wral vk cZ wral vj cZ wrex wi vx cr wral cF cc
        cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa
        vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD
        co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi cc0 vx cv
        clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel
        vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a
        wi vm cZ wral vk cZ wral vj cZ wrex wi vx cr vj cv vk cv cle wbr vj cv
        vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv
        vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz
        wrex vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm
        cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi
        vm cZ wral vk cZ wral vj cZ wrex cc0 vx cv clt wbr vk cv cF cfv cX wcel
        vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a
        vk vm vj cN cZ iscau3.3 iscau3.4 cau5i imbi2i ralbii anbi2i syl6bb $.
        $( [21-Sep-2007] $) $( [19-Dec-2006] $)

      $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` "
         with one less quantifier. $)
      iscau3 $p |- ( D e. Met -> ( F e. ( Cau ` D ) <-> ( F C_ ( CC X. X ) /\
                   A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z (
                j <_ k -> ( ( F ` j ) e. X /\ ( F ` k ) e. X /\
                   ( ( F ` j ) D ( F ` k ) ) < x ) ) ) ) ) ) $=
        cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vm cv
        vj cv cle wbr vm cv vk cv cle wbr wa vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cZ wral
        vj cZ wral vm cZ wrex wi vx cr wral wa cF cc cX cxp wss cc0 vx cv clt
        wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
        cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi
        vx cr wral wa vx cD vm vj vk cF cN cX cZ lmbr.1 iscau3.3 iscau3.4
        iscau2 cD cme wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv
        cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt
        wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral cc0 vx cv clt wbr vm cv
        vj cv cle wbr vm cv vk cv cle wbr wa vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cZ wral
        vj cZ wral vm cZ wrex wi vx cr wral cF cc cX cxp wss vj cv cF cfv cX
        wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr
        w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv
        cD co vx cv clt wbr w3a vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv
        cF cfv vm cv cF cfv cD co vx cv clt wbr w3a vj cv cF cfv cX wcel vk cv
        cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr
        w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv
        cD co vy cv c2 cdiv co clt wbr w3a wa vk cv cF cfv cX wcel vm cv cF cfv
        cX wcel vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr w3a vx vy vj vk
        vm cZ cD cme wcel vk cv vm cv wceq vk cv cF cfv cX wcel vm cv cF cfv cX
        wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr vj cv cF cfv vm cv
        cF cfv cD co vx cv clt wbr vj cv cF cfv cX wcel vk cv vm cv wceq vk cv
        cF cfv vm cv cF cfv cX vk cv vm cv cF fveq2 eleq1d vk cv vm cv wceq vj
        cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co vx cv clt
        vk cv vm cv wceq vk cv cF cfv vm cv cF cfv vj cv cF cfv cD vk cv vm cv
        cF fveq2 opreq2d breq1d 3anbi23d vj cv vk cv wceq vj cv cF cfv cX wcel
        vk cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vx cv clt wbr vk
        cv cF cfv vm cv cF cfv cD co vx cv clt wbr vm cv cF cfv cX wcel vj cv
        vk cv wceq vj cv cF cfv vk cv cF cfv cX vj cv vk cv cF fveq2 eleq1d vj
        cv vk cv wceq vj cv cF cfv vm cv cF cfv cD co vk cv cF cfv vm cv cF cfv
        cD co vx cv clt vj cv vk cv wceq vj cv cF cfv vk cv cF cfv vm cv cF cfv
        cD vj cv vk cv cF fveq2 opreq1d breq1d 3anbi13d vx cv vy cv c2 cdiv co
        wceq vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
        cfv cD co vx cv clt wbr w3a vj cv cF cfv cX wcel vk cv cF cfv cX wcel
        vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF
        cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vx cv
        clt wbr w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm
        cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vx cv vy cv c2 cdiv co
        wceq vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr vj cv cF cfv vk cv
        cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vx cv vy cv c2 cdiv co vj cv cF cfv vk cv cF cfv cD co clt
        breq2 3anbi3d vx cv vy cv c2 cdiv co wceq vj cv cF cfv vm cv cF cfv cD
        co vx cv clt wbr vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt
        wbr vj cv cF cfv cX wcel vm cv cF cfv cX wcel vx cv vy cv c2 cdiv co vj
        cv cF cfv vm cv cF cfv cD co clt breq2 3anbi3d anbi12d vx cv vy cv wceq
        vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr vk cv cF cfv vm cv cF cfv
        cD co vy cv clt wbr vk cv cF cfv cX wcel vm cv cF cfv cX wcel vx cv vy
        cv vk cv cF cfv vm cv cF cfv cD co clt breq2 3anbi3d cD cme wcel vy cv
        cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv
        cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv cF
        cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr
        w3a wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF
        cfv cD co vy cv clt wbr w3a wi vj cv cZ wcel vk cv cZ wcel vm cv cZ
        wcel w3a cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj
        cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co
        vy cv c2 cdiv co clt wbr w3a wa vk cv cF cfv cX wcel vm cv cF cfv cX
        wcel vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr vj cv cF cfv cX wcel
        vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co
        clt wbr w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm
        cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a wa vk cv cF cfv cX wcel wi
        cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel
        vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv
        cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2
        cdiv co clt wbr w3a 3simpl2 a1i vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv
        cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy
        cv c2 cdiv co clt wbr w3a wa vm cv cF cfv cX wcel wi cD cme wcel vy cv
        cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv
        cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv cF
        cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr
        3simpr2 a1i cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vj cv cF
        cfv cX wcel wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa vj cv cF
        cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF
        cfv cD co vy cv c2 cdiv co clt wbr wa w3a vk cv cF cfv vm cv cF cfv cD
        co vy cv clt wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv
        vk cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm
        cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt
        wbr w3a wa cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vj cv cF
        cfv cX wcel wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa vj cv cF
        cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF
        cfv cD co vy cv c2 cdiv co clt wbr wa vk cv cF cfv vm cv cF cfv cD co
        vy cv clt wbr cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv
        cF cfv cX wcel vm cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co
        vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv
        co clt wbr wa vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr wi wi vj cv
        cF cfv cX wcel cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv
        cF cfv cX wcel vm cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co
        vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv
        co clt wbr wa vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr wi cD cme
        wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv
        cF cfv cX wcel wa wa wa vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv
        co clt wbr vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr wa
        vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc
        co vy cv clt wbr vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr vj cv cF
        cfv vk cv cF cfv cD co cr wcel vj cv cF cfv vm cv cF cfv cD co cr wcel
        vy cv cr wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr
        vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr wa vj cv cF
        cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co vy cv
        clt wbr wi cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv cF
        cfv cX wcel vm cv cF cfv cX wcel wa wa wa vj cv cF cfv vk cv cF cfv cD
        co vj cv cF cfv vm cv cF cfv cD co vy cv lt2halves cD cme wcel vy cv cr
        wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
        cfv cD co cr wcel vm cv cF cfv cX wcel cD cme wcel vj cv cF cfv cX wcel
        vk cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co cr wcel vy cv
        cr wcel cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
        cfv vk cv cF cfv cD co cr wcel vj cv cF cfv vk cv cF cfv cD cX lmbr.1
        metcl 3expb adantlr adantrrr cD cme wcel vy cv cr wcel wa vj cv cF cfv
        cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co cr wcel vk
        cv cF cfv cX wcel cD cme wcel vj cv cF cfv cX wcel vm cv cF cfv cX wcel
        wa vj cv cF cfv vm cv cF cfv cD co cr wcel vy cv cr wcel cD cme wcel vj
        cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co
        cr wcel vj cv cF cfv vm cv cF cfv cD cX lmbr.1 metcl 3expb adantlr
        adantrrl cD cme wcel vy cv cr wcel vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vm cv cF cfv cX wcel wa wa simplr syl3anc cD cme wcel vy cv cr
        wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel
        wa wa wa vk cv cF cfv vm cv cF cfv cD co vj cv cF cfv vk cv cF cfv cD
        co vj cv cF cfv vm cv cF cfv cD co caddc co cle wbr vj cv cF cfv vk cv
        cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co vy cv clt wbr vk
        cv cF cfv vm cv cF cfv cD co vy cv clt wbr cD cme wcel vj cv cF cfv cX
        wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa wa vk cv cF cfv vm cv
        cF cfv cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv
        cD co caddc co cle wbr vy cv cr wcel cD cme wcel vk cv cF cfv cX wcel
        vm cv cF cfv cX wcel wa vj cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv
        cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co
        caddc co cle wbr cD cme wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel
        vj cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vj cv cF cfv vk cv
        cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co cle wbr cD cme
        wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv cX wcel vk
        cv cF cfv vm cv cF cfv cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF
        cfv vm cv cF cfv cD co caddc co cle wbr vk cv cF cfv vm cv cF cfv vj cv
        cF cfv cD cX lmbr.1 mettri4 exp43 imp44 ancom2s adantlr vk cv cF cfv vm
        cv cF cfv cD co cr wcel vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm
        cv cF cfv cD co caddc co cr wcel vy cv cr wcel vk cv cF cfv vm cv cF
        cfv cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD
        co caddc co cle wbr vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv
        cF cfv cD co caddc co vy cv clt wbr wa vk cv cF cfv vm cv cF cfv cD co
        vy cv clt wbr wi cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk
        cv cF cfv cX wcel vm cv cF cfv cX wcel wa wa wa vk cv cF cfv vm cv cF
        cfv cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD
        co caddc co vy cv lelttr cD cme wcel vk cv cF cfv cX wcel vm cv cF cfv
        cX wcel wa vk cv cF cfv vm cv cF cfv cD co cr wcel vy cv cr wcel vj cv
        cF cfv cX wcel cD cme wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk
        cv cF cfv vm cv cF cfv cD co cr wcel vk cv cF cfv vm cv cF cfv cD cX
        lmbr.1 metcl 3expb ad2ant2rl cD cme wcel vj cv cF cfv cX wcel vk cv cF
        cfv cX wcel vm cv cF cfv cX wcel wa wa vj cv cF cfv vk cv cF cfv cD co
        vj cv cF cfv vm cv cF cfv cD co caddc co cr wcel vy cv cr wcel vj cv cF
        cfv vk cv cF cfv cD co cr wcel vj cv cF cfv vm cv cF cfv cD co cr wcel
        vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc
        co cr wcel cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv
        cF cfv cX wcel wa wa wa vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm
        cv cF cfv cD co readdcl cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vj cv cF cfv vk cv cF cfv cD co cr wcel vm cv cF cfv cX wcel cD
        cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv
        cF cfv cD co cr wcel vj cv cF cfv vk cv cF cfv cD cX lmbr.1 metcl 3expb
        adantrrr cD cme wcel vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF
        cfv vm cv cF cfv cD co cr wcel vk cv cF cfv cX wcel cD cme wcel vj cv
        cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co cr
        wcel vj cv cF cfv vm cv cF cfv cD cX lmbr.1 metcl 3expb adantrrl sylanc
        adantlr cD cme wcel vy cv cr wcel vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vm cv cF cfv cX wcel wa wa simplr syl3anc mpand syld exp32 adantld
        3impd vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
        cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv cX wcel vm cv cF cfv cX
        wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr an6
        syl5ib 3jcad adantr cZ cN cuz cfv cz iscau3.4 cN uzssz eqsstri cau3i
        anbi2d bitr4d $.
        $( [12-Oct-2007] $) $( [14-Dec-2006] $)

      $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` "
         presupposing ` F ` is a function. $)
      iscauf $p |- ( ( D e. Met /\ F : Z --> X ) -> ( F e. ( Cau ` D ) <->
          A. x e. RR ( 0 < x -> E. j e. Z A. k e. Z ( j <_ k ->
                   ( ( F ` j ) D ( F ` k ) ) < x ) ) ) ) $=
        cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vj cv
        vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
        cv cF cfv cD co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr
        wral wa cZ cX cF wf cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv
        vk cv cF cfv cD co vx cv clt wbr wi vk cZ wral vj cZ wrex wi vx cr wral
        vx cD vj vk cF cN cX cZ lmbr.1 iscau3.3 iscau3.4 iscau3 cZ cX cF wf cc0
        vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr wi vk cZ wral vj cZ wrex wi vx cr wral cc0 vx cv clt wbr vj cv
        vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
        cv cF cfv cD co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr
        wral cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral wa cZ cX cF wf cc0
        vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr wi vk cZ wral vj cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cle
        wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv
        cD co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr cZ cX cF wf
        vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk
        cZ wral vj cZ wrex vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF
        cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cZ
        wral vj cZ wrex cc0 vx cv clt wbr cZ cX cF wf vj cv vk cv cle wbr vj cv
        cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk cZ wral vj cv vk cv cle
        wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv
        cD co vx cv clt wbr w3a wi vk cZ wral vj cZ cZ cX cF wf vj cv cZ wcel
        wa vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi
        vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
        cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cZ cZ cX cF wf vj cv cZ
        wcel wa vk cv cZ wcel wa vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr
        vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD
        co vx cv clt wbr w3a vj cv vk cv cle wbr cZ cX cF wf vj cv cZ wcel wa
        vk cv cZ wcel wa vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co vx
        cv clt wbr wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
        cv cF cfv cD co vx cv clt wbr w3a cZ cX cF wf vj cv cZ wcel wa vk cv cZ
        wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa vj cv cF cfv vk cv
        cF cfv cD co vx cv clt wbr cZ cX cF wf vj cv cZ wcel wa vk cv cZ wcel
        wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel cZ cX cF wf vj cv cZ wcel
        wa vj cv cF cfv cX wcel vk cv cZ wcel cZ cX vj cv cF ffvelrn adantr cZ
        cX cF wf vk cv cZ wcel vk cv cF cfv cX wcel vj cv cZ wcel cZ cX vk cv
        cF ffvelrn adantlr jca biantrurd vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr df-3an syl6bbr
        imbi2d ralbidva rexbidva imbi2d ralbidv cZ cX cF wf cF cc cX cxp wss
        cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cZ wral
        vj cZ wrex wi vx cr wral cF cZ cX cxp wss cZ cX cxp cc cX cxp wss cF cc
        cX cxp wss cZ cX cF wf cF cZ cX cxp cc cX cxp sstr cZ cX cF fssxp cZ cc
        wss cX cX wss cZ cX cxp cc cX cxp wss cZ cN cuz cfv cc iscau3.4 cN cuz
        cfv cz cc cN uzssz zsscn sstri eqsstri cX ssid cZ cc cX cX ssxp mp2an
        sylancl biantrurd bitr2d sylan9bb $.
        $( [12-Oct-2007] $) $( [24-Jul-2007] $)
    $}

    ${
      $d j k x D $.  $d j k x X $.
      $( MAY BE REVISED? $)
      $( Express the property " ` F ` is a Cauchy sequence of metric
         ` D ` ." $)
      iscau4 $p |- ( D e. Met -> ( F e. ( Cau ` D ) <-> ( F C_ ( CC X. X )
                /\ A. x e. RR ( 0 < x -> E. j e. ZZ A. k e. ZZ (
                j <_ k -> ( ( F ` j ) e. X /\ ( F ` k ) e. X /\
                   ( ( F ` j ) D ( F ` k ) ) < x ) ) ) ) ) ) $=
        cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vm cv
        vj cv cle wbr vm cv vk cv cle wbr wa vj cv cF cfv cX wcel vk cv cF cfv
        cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cz wral
        vj cz wral vm cz wrex wi vx cr wral wa cF cc cX cxp wss cc0 vx cv clt
        wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
        cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cz wral vj cz wrex wi
        vx cr wral wa vx cD vm vj vk cF cX lmbr.1 iscau cD cme wcel cc0 vx cv
        clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel
        vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cz wral vj cz
        wrex wi vx cr wral cc0 vx cv clt wbr vm cv vj cv cle wbr vm cv vk cv
        cle wbr wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv
        cF cfv cD co vx cv clt wbr w3a wi vk cz wral vj cz wral vm cz wrex wi
        vx cr wral cF cc cX cxp wss vj cv cF cfv cX wcel vk cv cF cfv cX wcel
        vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a vj cv cF cfv cX wcel
        vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a
        vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD
        co vx cv clt wbr w3a vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
        cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX
        wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv
        co clt wbr w3a wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF
        cfv vm cv cF cfv cD co vy cv clt wbr w3a vx vy vj vk vm cz cD cme wcel
        vk cv vm cv wceq vk cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv
        vk cv cF cfv cD co vx cv clt wbr vj cv cF cfv vm cv cF cfv cD co vx cv
        clt wbr vj cv cF cfv cX wcel vk cv vm cv wceq vk cv cF cfv vm cv cF cfv
        cX vk cv vm cv cF fveq2 eleq1d vk cv vm cv wceq vj cv cF cfv vk cv cF
        cfv cD co vj cv cF cfv vm cv cF cfv cD co vx cv clt vk cv vm cv wceq vk
        cv cF cfv vm cv cF cfv vj cv cF cfv cD vk cv vm cv cF fveq2 opreq2d
        breq1d 3anbi23d vj cv vk cv wceq vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vj cv cF cfv vm cv cF cfv cD co vx cv clt wbr vk cv cF cfv vm cv
        cF cfv cD co vx cv clt wbr vm cv cF cfv cX wcel vj cv vk cv wceq vj cv
        cF cfv vk cv cF cfv cX vj cv vk cv cF fveq2 eleq1d vj cv vk cv wceq vj
        cv cF cfv vm cv cF cfv cD co vk cv cF cfv vm cv cF cfv cD co vx cv clt
        vj cv vk cv wceq vj cv cF cfv vk cv cF cfv vm cv cF cfv cD vj cv vk cv
        cF fveq2 opreq1d breq1d 3anbi13d vx cv vy cv c2 cdiv co wceq vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr w3a vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
        cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv
        cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a vj cv
        cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy
        cv c2 cdiv co clt wbr w3a vx cv vy cv c2 cdiv co wceq vj cv cF cfv vk
        cv cF cfv cD co vx cv clt wbr vj cv cF cfv vk cv cF cfv cD co vy cv c2
        cdiv co clt wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vx cv vy cv
        c2 cdiv co vj cv cF cfv vk cv cF cfv cD co clt breq2 3anbi3d vx cv vy
        cv c2 cdiv co wceq vj cv cF cfv vm cv cF cfv cD co vx cv clt wbr vj cv
        cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv cX wcel
        vm cv cF cfv cX wcel vx cv vy cv c2 cdiv co vj cv cF cfv vm cv cF cfv
        cD co clt breq2 3anbi3d anbi12d vx cv vy cv wceq vk cv cF cfv vm cv cF
        cfv cD co vx cv clt wbr vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr
        vk cv cF cfv cX wcel vm cv cF cfv cX wcel vx cv vy cv vk cv cF cfv vm
        cv cF cfv cD co clt breq2 3anbi3d cD cme wcel vy cv cr wcel wa vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vy cv
        c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv
        cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a wa vk cv cF cfv
        cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vy cv clt
        wbr w3a wi vj cv cz wcel vk cv cz wcel vm cv cz wcel w3a cD cme wcel vy
        cv cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
        cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv
        cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr
        w3a wa vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF
        cfv cD co vy cv clt wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
        cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX
        wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv
        co clt wbr w3a wa vk cv cF cfv cX wcel wi cD cme wcel vy cv cr wcel wa
        vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD
        co vy cv c2 cdiv co clt wbr vj cv cF cfv cX wcel vm cv cF cfv cX wcel
        vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a 3simpl2
        a1i vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv
        cD co vy cv c2 cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv cF cfv cX
        wcel vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a wa vm
        cv cF cfv cX wcel wi cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel
        vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co
        clt wbr w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm
        cv cF cfv cD co vy cv c2 cdiv co clt wbr 3simpr2 a1i cD cme wcel vy cv
        cr wcel wa vj cv cF cfv cX wcel vj cv cF cfv cX wcel wa vk cv cF cfv cX
        wcel vm cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co vy cv c2
        cdiv co clt wbr vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt
        wbr wa w3a vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr vj cv cF cfv
        cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vy cv c2
        cdiv co clt wbr w3a vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF
        cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr w3a wa cD cme wcel vy
        cv cr wcel wa vj cv cF cfv cX wcel vj cv cF cfv cX wcel wa vk cv cF cfv
        cX wcel vm cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co vy cv
        c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt
        wbr wa vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr cD cme wcel vy cv
        cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX
        wcel wa vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv
        cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr wa vk cv cF cfv vm
        cv cF cfv cD co vy cv clt wbr wi wi vj cv cF cfv cX wcel cD cme wcel vy
        cv cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX
        wcel wa vj cv cF cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv
        cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr wa vk cv cF cfv vm
        cv cF cfv cD co vy cv clt wbr wi cD cme wcel vy cv cr wcel wa vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa wa wa vj cv cF
        cfv vk cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF
        cfv cD co vy cv c2 cdiv co clt wbr wa vj cv cF cfv vk cv cF cfv cD co
        vj cv cF cfv vm cv cF cfv cD co caddc co vy cv clt wbr vk cv cF cfv vm
        cv cF cfv cD co vy cv clt wbr vj cv cF cfv vk cv cF cfv cD co cr wcel
        vj cv cF cfv vm cv cF cfv cD co cr wcel vy cv cr wcel vj cv cF cfv vk
        cv cF cfv cD co vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cD
        co vy cv c2 cdiv co clt wbr wa vj cv cF cfv vk cv cF cfv cD co vj cv cF
        cfv vm cv cF cfv cD co caddc co vy cv clt wbr wi cD cme wcel vy cv cr
        wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel
        wa wa wa vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD
        co vy cv lt2halves cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk
        cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co cr wcel vm cv cF cfv
        cX wcel cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa vj cv
        cF cfv vk cv cF cfv cD co cr wcel vy cv cr wcel cD cme wcel vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co cr
        wcel vj cv cF cfv vk cv cF cfv cD cX lmbr.1 metcl 3expb adantlr
        adantrrr cD cme wcel vy cv cr wcel wa vj cv cF cfv cX wcel vm cv cF cfv
        cX wcel vj cv cF cfv vm cv cF cfv cD co cr wcel vk cv cF cfv cX wcel cD
        cme wcel vj cv cF cfv cX wcel vm cv cF cfv cX wcel wa vj cv cF cfv vm
        cv cF cfv cD co cr wcel vy cv cr wcel cD cme wcel vj cv cF cfv cX wcel
        vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co cr wcel vj cv cF
        cfv vm cv cF cfv cD cX lmbr.1 metcl 3expb adantlr adantrrl cD cme wcel
        vy cv cr wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX
        wcel wa wa simplr syl3anc cD cme wcel vy cv cr wcel wa vj cv cF cfv cX
        wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa wa wa vk cv cF cfv vm
        cv cF cfv cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF
        cfv cD co caddc co cle wbr vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv
        vm cv cF cfv cD co caddc co vy cv clt wbr vk cv cF cfv vm cv cF cfv cD
        co vy cv clt wbr cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel
        vm cv cF cfv cX wcel wa wa vk cv cF cfv vm cv cF cfv cD co vj cv cF cfv
        vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co cle wbr vy
        cv cr wcel cD cme wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa vj
        cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vj cv cF cfv vk cv cF
        cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co cle wbr cD cme wcel
        vk cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv cX wcel vk cv cF
        cfv vm cv cF cfv cD co vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm
        cv cF cfv cD co caddc co cle wbr cD cme wcel vk cv cF cfv cX wcel vm cv
        cF cfv cX wcel vj cv cF cfv cX wcel vk cv cF cfv vm cv cF cfv cD co vj
        cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co
        cle wbr vk cv cF cfv vm cv cF cfv vj cv cF cfv cD cX lmbr.1 mettri4
        exp43 imp44 ancom2s adantlr vk cv cF cfv vm cv cF cfv cD co cr wcel vj
        cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co
        cr wcel vy cv cr wcel vk cv cF cfv vm cv cF cfv cD co vj cv cF cfv vk
        cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co cle wbr vj cv
        cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co vy
        cv clt wbr wa vk cv cF cfv vm cv cF cfv cD co vy cv clt wbr wi cD cme
        wcel vy cv cr wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv
        cF cfv cX wcel wa wa wa vk cv cF cfv vm cv cF cfv cD co vj cv cF cfv vk
        cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co vy cv lelttr
        cD cme wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa vk cv cF cfv
        vm cv cF cfv cD co cr wcel vy cv cr wcel vj cv cF cfv cX wcel cD cme
        wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel vk cv cF cfv vm cv cF
        cfv cD co cr wcel vk cv cF cfv vm cv cF cfv cD cX lmbr.1 metcl 3expb
        ad2ant2rl cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv
        cF cfv cX wcel wa wa vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv
        cF cfv cD co caddc co cr wcel vy cv cr wcel vj cv cF cfv vk cv cF cfv
        cD co cr wcel vj cv cF cfv vm cv cF cfv cD co cr wcel vj cv cF cfv vk
        cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co caddc co cr wcel cD cme
        wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv cX wcel wa
        wa wa vj cv cF cfv vk cv cF cfv cD co vj cv cF cfv vm cv cF cfv cD co
        readdcl cD cme wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
        cfv vk cv cF cfv cD co cr wcel vm cv cF cfv cX wcel cD cme wcel vj cv
        cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co cr
        wcel vj cv cF cfv vk cv cF cfv cD cX lmbr.1 metcl 3expb adantrrr cD cme
        wcel vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF
        cfv cD co cr wcel vk cv cF cfv cX wcel cD cme wcel vj cv cF cfv cX wcel
        vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cD co cr wcel vj cv cF
        cfv vm cv cF cfv cD cX lmbr.1 metcl 3expb adantrrl sylanc adantlr cD
        cme wcel vy cv cr wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv
        cF cfv cX wcel wa wa simplr syl3anc mpand syld exp32 adantld 3impd vj
        cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co
        vy cv c2 cdiv co clt wbr vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj
        cv cF cfv vm cv cF cfv cD co vy cv c2 cdiv co clt wbr an6 syl5ib 3jcad
        adantr cz ssid cau3i anbi2d bitr4d $.
        $( [5-Jul-2008] $) $( [14-Dec-2006] $)

      $( MAY BE REVISED - use iscaunns instead? $)
      $( Express the property " ` F ` is a Cauchy sequence of metric
         ` D ` ." $)
      iscau5 $p |- ( ( D e. Met /\ F : NN --> X ) -> ( F e. ( Cau ` D ) <->
        A. x e. RR+ E. j e. NN A. k e. NN ( j <_ k ->
          ( ( F ` j ) D ( F ` k ) ) < x ) ) ) $=
        cD cme wcel cn cX cF wf wa cF cD cca cfv wcel cF cc cX cxp wss cc0 vx
        cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
        cn wrex wi vx cr wral wa vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv
        cD co vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral cD cme wcel cF
        cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr
        vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD
        co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral wa wb cn cX
        cF wf vx cD vj vk cF c1 cX cn lmbr.1 1z nnuz iscau3 adantr cn cX cF wf
        vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk
        cn wral vj cn wrex vx crp wral cF cc cX cxp wss cc0 vx cv clt wbr vj cv
        vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
        cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr
        wral wa wb cD cme wcel cn cX cF wf vj cv vk cv cle wbr vj cv cF cfv vk
        cv cF cfv cD co vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral cc0
        vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX
        wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
        cn wrex wi vx cr wral cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv
        cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
        cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral wa
        cn cX cF wf vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr wi vk cn wral vj cn wrex vx crp wral vj cv vk cv cle wbr vj cv
        cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx
        cv clt wbr w3a wi vk cn wral vj cn wrex vx crp wral cc0 vx cv clt wbr
        vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
        cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx
        cr wral cn cX cF wf vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co
        vx cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vj cv cF cfv
        cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt
        wbr w3a wi vk cn wral vj cn wrex vx crp cn cX cF wf vj cv vk cv cle wbr
        vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk cn wral vj cv vk cv
        cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
        cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn cn cX cF wf vj cv cn
        wcel wa vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt
        wbr wi vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj
        cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn cn cX cF wf vj
        cv cn wcel wa vk cv cn wcel wa vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
        cfv cD co vx cv clt wbr w3a vj cv vk cv cle wbr cn cX cF wf vj cv cn
        wcel wa vk cv cn wcel wa vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr
        vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv
        cD co vx cv clt wbr wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
        cF cfv vk cv cF cfv cD co vx cv clt wbr w3a cn cX cF wf vj cv cn wcel
        wa vk cv cn wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa vj cv
        cF cfv vk cv cF cfv cD co vx cv clt wbr cn cX cF wf vj cv cn wcel vk cv
        cn wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa cn cX cF wf vj cv
        cn wcel vk cv cn wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa cn
        cX cF wf vj cv cn wcel wa vj cv cF cfv cX wcel cn cX cF wf vk cv cn
        wcel wa vk cv cF cfv cX wcel cn cX vj cv cF ffvelrn cn cX vk cv cF
        ffvelrn anim12i anandis anassrs biantrurd vj cv cF cfv cX wcel vk cv cF
        cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr df-3an
        syl6bbr imbi2d ralbidva rexbidva ralbidv vj cv vk cv cle wbr vj cv cF
        cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv
        clt wbr w3a wi vk cn wral vj cn wrex vx ralrp syl6bb cn cX cF wf cF cc
        cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel
        vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a
        wi vk cn wral vj cn wrex wi vx cr wral cF cn cX cxp wss cn cX cxp cc cX
        cxp wss cF cc cX cxp wss cn cX cF wf cF cn cX cxp cc cX cxp sstr cn cX
        cF fssxp cn cc wss cX cX wss cn cX cxp cc cX cxp wss nnsscn cX ssid cn
        cc cX cX ssxp mp2an sylancl biantrurd bitrd adantl bitr4d $.
        $( [21-Mar-2008] $) $( [12-Feb-2008] $)
    $}
  $}

  ${
    $d y A $.  $d j k x D $.  $d j k x y F $.  $d j k x P $.  $d j k R $.
    $d j k x X $.
    lmbrnns.1 $e |- X = dom dom D $.
    lmbrnns.2 $e |- ( k e. NN -> A = ( F ` k ) ) $.
    $( Express the binary relation "sequence ` F ` converges to point ` P ` "
       in a metric space." $)
    lmbrnns $p |-  ( ( D e. Met /\ P e. X /\ F : NN --> X ) ->
   ( F ( ~~>m ` D ) P <-> A. x e. RR+ E. j e. NN A. k e. NN
           ( j <_ k -> ( A D P ) < x ) ) ) $=
      cD cme wcel cP cX wcel cn cX cF wf w3a cF cP cD clm cfv wbr cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral
      vj cn wrex wi vx cr wral vj cv vk cv cle wbr cA cP cD co vx cv clt wbr wi
      vk cn wral vj cn wrex vx crp wral vx cD cP vj vk cF c1 cX cn lmbrnns.1 1z
      nnuz lmbrf2 vj cv vk cv cle wbr cA cP cD co vx cv clt wbr wi vk cn wral
      vj cn wrex vx crp wral vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv
      clt wbr wi vk cn wral vj cn wrex vx crp wral cc0 vx cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex
      wi vx cr wral vj cv vk cv cle wbr cA cP cD co vx cv clt wbr wi vk cn wral
      vj cn wrex vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk
      cn wral vj cn wrex vx crp vj cv vk cv cle wbr cA cP cD co vx cv clt wbr
      wi vk cn wral vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi
      vk cn wral vj cn vj cv vk cv cle wbr cA cP cD co vx cv clt wbr wi vj cv
      vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn vk cv cn wcel
      cA cP cD co vx cv clt wbr vk cv cF cfv cP cD co vx cv clt wbr vj cv vk cv
      cle wbr vk cv cn wcel cA cP cD co vk cv cF cfv cP cD co vx cv clt vk cv
      cn wcel cA vk cv cF cfv cP cD lmbrnns.2 opreq1d breq1d imbi2d ralbiia
      rexbii ralbii vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi
      vk cn wral vj cn wrex vx ralrp bitr2i syl6bb $.
      $( [6-Jul-2008] $) $( [27-Feb-2008] $)

    $( Convergence property of a converging sequence. $)
    lmcvgnns $p |- ( ( ( D e. Met /\ P e. B ) /\ ( F ( ~~>m ` D ) P /\ R e. RR+
       ) ) -> E. j e. NN A. k e. NN ( j <_ k -> ( A D P ) < R ) ) $=
      cD cme wcel cP cB wcel wa cF cP cD clm cfv wbr cR crp wcel wa wa vj cv vk
      cv cle wbr vk cv cF cfv cP cD co cR clt wbr wi vk cn wral vj cn wrex vj
      cv vk cv cle wbr cA cP cD co cR clt wbr wi vk cn wral vj cn wrex cD cme
      wcel cP cB wcel cF cP cD clm cfv wbr cR crp wcel vj cv vk cv cle wbr vk
      cv cF cfv cP cD co cR clt wbr wi vk cn wral vj cn wrex cD cme wcel cP cB
      wcel cF cP cD clm cfv wbr cR crp wcel vj cv vk cv cle wbr vk cv cF cfv cP
      cD co cR clt wbr wi vk cn wral vj cn wrex cD cme wcel cP cB wcel cF cP cD
      clm cfv wbr w3a cR cr wcel cc0 cR clt wbr wa vj cv vk cv cle wbr vk cv cF
      cfv cP cD co cR clt wbr wi vk cn wral vj cn wrex cR crp wcel cB cD cP cR
      vj vk cF c1 cX cn lmbrnns.1 1z nnuz lmcvg2 cR elrp sylan2b 3exp1 imp43 vj
      cv vk cv cle wbr cA cP cD co cR clt wbr wi vk cn wral vj cv vk cv cle wbr
      vk cv cF cfv cP cD co cR clt wbr wi vk cn wral vj cn vj cv vk cv cle wbr
      cA cP cD co cR clt wbr wi vj cv vk cv cle wbr vk cv cF cfv cP cD co cR
      clt wbr wi vk cn vk cv cn wcel cA cP cD co cR clt wbr vk cv cF cfv cP cD
      co cR clt wbr vj cv vk cv cle wbr vk cv cn wcel cA cP cD co vk cv cF cfv
      cP cD co cR clt vk cv cn wcel cA vk cv cF cfv cP cD lmbrnns.2 opreq1d
      breq1d imbi2d ralbiia rexbii sylibr $.
      $( [18-Mar-2008] $) $( [27-Feb-2008] $)

    $( MAY BE REVISED - shorten with iscau5 if iscau5 is actually needed
       elsewhere.  Also:  make hyp ( F ` k ) = A ? $)
    $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` ." $)
    iscaunns $p |- ( ( D e. Met /\ F : NN --> X ) -> ( F e. ( Cau ` D ) <->
        A. x e. RR+ E. j e. NN A. k e. NN ( j <_ k ->
          ( [_ j / k ]_ A D A ) < x ) ) ) $=
      cD cme wcel cn cX cF wf wa cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv
      clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj
      cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex
      wi vx cr wral wa vj cv vk cv cle wbr vk vj cv cA csb cA cD co vx cv clt
      wbr wi vk cn wral vj cn wrex vx crp wral cD cme wcel cF cD cca cfv wcel
      cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX
      wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr
      w3a wi vk cn wral vj cn wrex wi vx cr wral wa wb cn cX cF wf vx cD vj vk
      cF c1 cX cn lmbrnns.1 1z nnuz iscau3 adantr cn cX cF wf vj cv vk cv cle
      wbr vk vj cv cA csb cA cD co vx cv clt wbr wi vk cn wral vj cn wrex vx
      crp wral cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF
      cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv
      clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral wa wb cD cme wcel cn
      cX cF wf vj cv vk cv cle wbr vk vj cv cA csb cA cD co vx cv clt wbr wi vk
      cn wral vj cn wrex vx crp wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj
      cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx
      cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral cF cc cX cxp wss
      cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv
      cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral
      vj cn wrex wi vx cr wral wa cn cX cF wf vj cv vk cv cle wbr vk vj cv cA
      csb cA cD co vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral vj cv vk
      cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv
      cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex vx crp wral cc0
      vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX
      wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
      cn wrex wi vx cr wral cn cX cF wf vj cv vk cv cle wbr vk vj cv cA csb cA
      cD co vx cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vj cv cF
      cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv
      clt wbr w3a wi vk cn wral vj cn wrex vx crp cn cX cF wf vj cv vk cv cle
      wbr vk vj cv cA csb cA cD co vx cv clt wbr wi vk cn wral vj cv vk cv cle
      wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv
      cD co vx cv clt wbr w3a wi vk cn wral vj cn cn cX cF wf vj cv cn wcel wa
      vj cv vk cv cle wbr vk vj cv cA csb cA cD co vx cv clt wbr wi vj cv vk cv
      cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
      cfv cD co vx cv clt wbr w3a wi vk cn cn cX cF wf vj cv cn wcel wa vk cv
      cn wcel wa vk vj cv cA csb cA cD co vx cv clt wbr vj cv cF cfv cX wcel vk
      cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a vj cv
      vk cv cle wbr cn cX cF wf vj cv cn wcel wa vk cv cn wcel wa vk vj cv cA
      csb cA cD co vx cv clt wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa
      vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wa vj cv cF cfv cX wcel vk
      cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a cn cX
      cF wf vj cv cn wcel wa vk cv cn wcel wa vk vj cv cA csb cA cD co vx cv
      clt wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr vj cv cF cfv cX
      wcel vk cv cF cfv cX wcel wa vj cv cF cfv vk cv cF cfv cD co vx cv clt
      wbr wa vj cv cn wcel vk cv cn wcel vk vj cv cA csb cA cD co vx cv clt wbr
      vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wb cn cX cF wf vj cv cn
      wcel vk cv cn wcel wa vk vj cv cA csb cA cD co vj cv cF cfv vk cv cF cfv
      cD co vx cv clt vj cv cn wcel vk cv cn wcel vk vj cv cA csb vj cv cF cfv
      cA vk cv cF cfv cD vk cv cn wcel cA vk cv cF cfv wceq wi vj cv cn wcel vk
      vj cv cA csb vj cv cF cfv wceq wi vk vj vj cv cn wcel vk vj cv cA csb vj
      cv cF cfv wceq vk vj cv cn wcel vk ax-17 vk vy vy vk vj cv cA csb vj cv
      cF cfv vk vy vj cv cA vj visset vy cv vj cv wcel vk ax-17 hbcsb1 vy cv vj
      cv cF cfv wcel vk ax-17 hbeq hbim vk cv vj cv wceq vk cv cn wcel vj cv cn
      wcel cA vk cv cF cfv wceq vk vj cv cA csb vj cv cF cfv wceq vk cv vj cv
      cn eleq1 vk cv vj cv wceq cA vk vj cv cA csb vk cv cF cfv vj cv cF cfv vk
      vj cv cA csbeq1a vk cv vj cv cF fveq2 eqeq12d imbi12d lmbrnns.2 chvar
      lmbrnns.2 opreqan12d breq1d adantll cn cX cF wf vj cv cn wcel wa vk cv cn
      wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa vj cv cF cfv vk cv
      cF cfv cD co vx cv clt wbr cn cX cF wf vj cv cn wcel vk cv cn wcel vj cv
      cF cfv cX wcel vk cv cF cfv cX wcel wa cn cX cF wf vj cv cn wcel vk cv cn
      wcel vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa cn cX cF wf vj cv cn
      wcel wa vj cv cF cfv cX wcel cn cX cF wf vk cv cn wcel wa vk cv cF cfv cX
      wcel cn cX vj cv cF ffvelrn cn cX vk cv cF ffvelrn anim12i anandis
      anassrs biantrurd bitrd vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
      cF cfv vk cv cF cfv cD co vx cv clt wbr df-3an syl6bbr imbi2d ralbidva
      rexbidva ralbidv vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX
      wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
      cn wrex vx ralrp syl6bb cn cX cF wf cF cc cX cxp wss cc0 vx cv clt wbr vj
      cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv
      vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr
      wral cF cn cX cxp wss cn cX cxp cc cX cxp wss cF cc cX cxp wss cn cX cF
      wf cF cn cX cxp cc cX cxp sstr cn cX cF fssxp cn cc wss cX cX wss cn cX
      cxp cc cX cxp wss nnsscn cX ssid cn cc cX cX ssxp mp2an sylancl biantrurd
      bitrd adantl bitr4d $.
      $( [9-Jul-2008] $) $( [27-Feb-2008] $)
  $}

  ${
    $d f j k m x F $.  $d f j k m x y D $.  $d j k x P $.  $d f j k m x y X $.
    caun0.1 $e |- X = dom dom D $.
    $( A metric with a Cauchy sequence cannot be empty. $)
    caun0 $p |- ( ( D e. Met /\ F e. ( Cau ` D ) ) -> X =/= (/) ) $=
      cD cme wcel cF cD cca cfv wcel cX c0 wne cD cme wcel cF cD cca cfv wcel
      cc0 vx cv clt wbr vj cv cn wcel vj cv cF cfv cX wcel wi vj cn wrex wi vx
      cr wral cX c0 wne cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx
      cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel
      vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn
      wrex wi vx cr wral wa cc0 vx cv clt wbr vj cv cn wcel vj cv cF cfv cX
      wcel wi vj cn wrex wi vx cr wral vx cD vj vk cF c1 cX cn caun0.1 1z nnuz
      iscau3 cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv
      cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn
      wral vj cn wrex wi vx cr wral cc0 vx cv clt wbr vj cv cn wcel vj cv cF
      cfv cX wcel wi vj cn wrex wi vx cr wral cF cc cX cxp wss cc0 vx cv clt
      wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
      cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi
      cc0 vx cv clt wbr vj cv cn wcel vj cv cF cfv cX wcel wi vj cn wrex wi vx
      cr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
      cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex vj cv
      cn wcel vj cv cF cfv cX wcel wi vj cn wrex cc0 vx cv clt wbr vj cv vk cv
      cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF
      cfv cD co vx cv clt wbr w3a wi vk cn wral vj cv cn wcel vj cv cF cfv cX
      wcel wi vj cn vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX
      wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
      cv vk cv cle wbr vj cv cF cfv cX wcel wi vk cn wral vj cv cn wcel vj cv
      vj cv cle wbr vj cv cF cfv cX wcel wi wi vj cv cn wcel vj cv cF cfv cX
      wcel wi vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj
      cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vj cv vk cv cle wbr vj
      cv cF cfv cX wcel wi vk cn vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj
      cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a vj cv cF cfv cX wcel vj cv
      vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
      cv cF cfv cD co vx cv clt wbr 3simp1 imim2i r19.20si vj cv vk cv cle wbr
      vj cv cF cfv cX wcel wi vj cv vj cv cle wbr vj cv cF cfv cX wcel wi vk vj
      cv cn vk cv vj cv wceq vj cv vk cv cle wbr vj cv vj cv cle wbr vj cv cF
      cfv cX wcel vk cv vj cv vj cv cle breq2 imbi1d rcla4cv vj cv cn wcel vj
      cv vj cv cle wbr vj cv cF cfv cX wcel wi vj cv cF cfv cX wcel vj cv cn
      wcel vj cv cr wcel vj cv vj cv cle wbr vj cv vj cv cle wbr vj cv cF cfv
      cX wcel wi vj cv cF cfv cX wcel wi vj cv nnre vj cv leid vj cv vj cv cle
      wbr vj cv cF cfv cX wcel pm2.27 3syl a2i 3syl r19.22si imim2i r19.20si
      adantl syl6bi cc0 vx cv clt wbr vj cv cn wcel vj cv cF cfv cX wcel wi vj
      cn wrex wi vx cr wral c1 cr wcel vj cv cn wcel vj cv cF cfv cX wcel wi vj
      cn wrex wi cX c0 wne cc0 vx cv clt wbr vj cv cn wcel vj cv cF cfv cX wcel
      wi vj cn wrex wi vj cv cn wcel vj cv cF cfv cX wcel wi vj cn wrex vx c1
      cr vx cv c1 wceq cc0 vx cv clt wbr vj cv cn wcel vj cv cF cfv cX wcel wi
      vj cn wrex wi cc0 c1 clt wbr vj cv cn wcel vj cv cF cfv cX wcel wi vj cn
      wrex wi vj cv cn wcel vj cv cF cfv cX wcel wi vj cn wrex vx cv c1 wceq
      cc0 vx cv clt wbr cc0 c1 clt wbr vj cv cn wcel vj cv cF cfv cX wcel wi vj
      cn wrex vx cv c1 cc0 clt breq2 imbi1d cc0 c1 clt wbr vj cv cn wcel vj cv
      cF cfv cX wcel wi vj cn wrex lt01 a1bi syl6bbr rcla4cv c1 cr wcel vj cv
      cn wcel vj cv cF cfv cX wcel wi vj cn wrex wi vj cv cn wcel vj cv cF cfv
      cX wcel wi vj cn wrex cX c0 wne c1 cr wcel vj cv cn wcel vj cv cF cfv cX
      wcel wi vj cn wrex 1re a1bi vj cv cn wcel vj cv cF cfv cX wcel wi cX c0
      wne vj cn vj cv cn wcel vj cv cF cfv cX wcel wi vj cv cn wcel cX c0 wne
      vj cv cF cfv cX wcel cX c0 wne vj cv cn wcel cX vj cv cF cfv ne0i imim2i
      com12 r19.23aiv sylbir syl syl6 imp $.
      $( [12-Oct-2007] $) $( [19-Dec-2006] $)

    $( The property " ` D ` is a complete metric," meaning all Cauchy sequences
       converge to a point in the space.  Part of Definition 1.4-3 of
       [Kreyszig] p. 28. $)
    iscms $p |- ( D e. CMet <-> ( D e. Met /\
                 A. f e. ( Cau ` D ) E. x e. X f ( ~~>m ` D ) x ) ) $=
      vf cv vx cv vy cv clm cfv wbr vx vy cv cdm cdm wrex vf vy cv cca cfv wral
      vf cv vx cv cD clm cfv wbr vx cX wrex vf cD cca cfv wral vy cD cme cms vy
      cv cD wceq vf cv vx cv vy cv clm cfv wbr vx vy cv cdm cdm wrex vf cv vx
      cv cD clm cfv wbr vx cX wrex vf vy cv cca cfv cD cca cfv vy cv cD cca
      fveq2 vy cv cD wceq vf cv vx cv vy cv clm cfv wbr vf cv vx cv cD clm cfv
      wbr vx vy cv cdm cdm cX vy cv cD wceq vy cv cdm cdm cD cdm cdm cX vy cv
      cD wceq vy cv cdm cD cdm vy cv cD dmeq dmeqd caun0.1 syl6eqr vy cv cD
      wceq vy cv clm cfv cD clm cfv wceq vf cv vx cv vy cv clm cfv wbr vf cv vx
      cv cD clm cfv wbr wb vy cv cD clm fveq2 vf cv vx cv vy cv clm cfv cD clm
      cfv breq syl rexeq12d raleq12d vy vx vf df-cmet elrab2 $.
      $( [12-Oct-2007] $) $( [7-Sep-2006] $)

    $( The convergence of a Cauchy sequence in a complete metric space. $)
    cmscvg $p |- ( ( D e. CMet /\ F e. ( Cau ` D ) ) ->
                 E. x e. X F ( ~~>m ` D ) x ) $=
      vf cv vx cv cD clm cfv wbr vx cX wrex vf cD cca cfv wral cF cD cca cfv
      wcel cF vx cv cD clm cfv wbr vx cX wrex cD cms wcel vf cv vx cv cD clm
      cfv wbr vx cX wrex cF vx cv cD clm cfv wbr vx cX wrex vf cF cD cca cfv vf
      cv cF wceq vf cv vx cv cD clm cfv wbr cF vx cv cD clm cfv wbr vx cX vf cv
      cF vx cv cD clm cfv breq1 rexbidv rcla4cva cD cms wcel cD cme wcel vf cv
      vx cv cD clm cfv wbr vx cX wrex vf cD cca cfv wral vx cD vf cX caun0.1
      iscms pm3.27bi sylan $.
      $( [11-Nov-2007] $) $( [19-Dec-2006] $)

    $( Inclusion of a function having a limit (used to ensure the limit
       relation is a set, under our definition). $)
    lmfss $p |- ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) ->
               F C_ ( CC X. X ) ) $=
      cD cme wcel cP cA wcel cF cP cD clm cfv wbr cF cc cX cxp wss cD cme wcel
      cP cA wcel wa cF cP cD clm cfv wbr cF cc cX cxp wss cP cX wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx
      cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a cF cc cX cxp wss
      vx cA cD cP vj vk cF cX caun0.1 lmbr cF cc cX cxp wss cP cX wcel cc0 vx
      cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co
      vx cv clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral 3simp1 syl6bi
      3impia $.
      $( [11-Feb-2008] $) $( [7-Dec-2006] $)

    $( Closure of a limit. $)
    lmcl $p |- ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) ->
               P e. X ) $=
      cD cme wcel cP cA wcel cF cP cD clm cfv wbr cP cX wcel cD cme wcel cP cA
      wcel wa cF cP cD clm cfv wbr cF cc cX cxp wss cP cX wcel cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv
      clt wbr wa wi vk cz wral vj cz wrex wi vx cr wral w3a cP cX wcel vx cA cD
      cP vj vk cF cX caun0.1 lmbr cF cc cX cxp wss cP cX wcel cc0 vx cv clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt
      wbr wa wi vk cz wral vj cz wrex wi vx cr wral 3simp2 syl6bi 3impia $.
      $( [25-Sep-2007] $) $( [19-Dec-2006] $)

    $( Inclusion of a Cauchy sequence, under our definition. $)
    caufss $p |- ( ( D e. Met /\ F e. ( Cau ` D ) ) ->
               F C_ ( CC X. X ) ) $=
      cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cX wcel vm cv cF cfv cX
      wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk
      cz wral vj cz wrex wi vx cr wral vx cD vj vk vm cF cX caun0.1 iscau
      pm3.26bda $.
      $( [12-Oct-2007] $) $( [7-Dec-2006] $)
  $}

  ${
    $d j k x A $.  $d j k x B $.  $d j k x D $.  $d j k x F $.
    lmuni.1 $e |- A e. _V $.
    lmuni.2 $e |- B e. _V $.
    $( A sequence converges to at most one limit.  Part of Lemma 1.4-2(a) of
       [Kreyszig] p. 26. $)
    lmuni $p |- ( ( D e. Met /\ F ( ~~>m ` D ) A /\ F ( ~~>m ` D ) B )
               -> A = B ) $=
      cD cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cA cB cD co cc0
      wceq cA cB wceq cA cB cD co cr wcel cc0 cA cB cD co cle wbr cc0 vx cv clt
      wbr cA cB cD co vx cv clt wbr wi vx cr wral cA cB cD co cc0 wceq cD cme
      wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a vx cA cB cD co
      squeeze0 cD cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cD cme
      wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a cA cB cD co cr wcel cD cme
      wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cD cme wcel cA cD cdm
      cdm wcel cB cD cdm cdm wcel cD cme wcel cF cA cD clm cfv wbr cF cB cD clm
      cfv wbr 3simp1 cD cme wcel cF cA cD clm cfv wbr cA cD cdm cdm wcel cF cB
      cD clm cfv wbr cD cme wcel cA cvv wcel cF cA cD clm cfv wbr cA cD cdm cdm
      wcel lmuni.1 cvv cD cA cF cD cdm cdm cD cdm cdm eqid lmcl mp3an2 3adant3
      cD cme wcel cF cB cD clm cfv wbr cB cD cdm cdm wcel cF cA cD clm cfv wbr
      cD cme wcel cB cvv wcel cF cB cD clm cfv wbr cB cD cdm cdm wcel lmuni.2
      cvv cD cB cF cD cdm cdm cD cdm cdm eqid lmcl mp3an2 3adant2 3jca cA cB cD
      cD cdm cdm cD cdm cdm eqid metcl syl cD cme wcel cF cA cD clm cfv wbr cF
      cB cD clm cfv wbr w3a cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel
      w3a cc0 cA cB cD co cle wbr cD cme wcel cF cA cD clm cfv wbr cF cB cD clm
      cfv wbr w3a cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel cD cme wcel
      cF cA cD clm cfv wbr cF cB cD clm cfv wbr 3simp1 cD cme wcel cF cA cD clm
      cfv wbr cA cD cdm cdm wcel cF cB cD clm cfv wbr cD cme wcel cA cvv wcel
      cF cA cD clm cfv wbr cA cD cdm cdm wcel lmuni.1 cvv cD cA cF cD cdm cdm
      cD cdm cdm eqid lmcl mp3an2 3adant3 cD cme wcel cF cB cD clm cfv wbr cB
      cD cdm cdm wcel cF cA cD clm cfv wbr cD cme wcel cB cvv wcel cF cB cD clm
      cfv wbr cB cD cdm cdm wcel lmuni.2 cvv cD cB cF cD cdm cdm cD cdm cdm
      eqid lmcl mp3an2 3adant2 3jca cA cB cD cD cdm cdm cD cdm cdm eqid metge0
      syl cD cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cc0 vx cv
      clt wbr cA cB cD co vx cv clt wbr wi vx cr cD cme wcel cF cA cD clm cfv
      wbr cF cB cD clm cfv wbr w3a vx cv cr wcel cc0 vx cv clt wbr cA cB cD co
      vx cv clt wbr cD cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a
      vx cv cr wcel cc0 vx cv clt wbr wa wa vj cv vk cv cle wbr vk cv cF cfv cD
      cdm cdm wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF
      cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa
      wi vk cn wral vj cn wrex cA cB cD co vx cv clt wbr cD cme wcel cF cA cD
      clm cfv wbr cF cB cD clm cfv wbr w3a vx cv c2 cdiv co cr wcel cc0 vx cv
      c2 cdiv co clt wbr wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk
      cv cF cfv cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa wi vk cn wral
      vj cn wrex vx cv cr wcel cc0 vx cv clt wbr wa cD cme wcel cF cA cD clm
      cfv wbr cF cB cD clm cfv wbr w3a vx cv c2 cdiv co cr wcel cc0 vx cv c2
      cdiv co clt wbr wa wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk
      cv cF cfv cA cD co vx cv c2 cdiv co clt wbr wa wi vk cn wral vj cn wrex
      vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx
      cv c2 cdiv co clt wbr wa wi vk cn wral vj cn wrex wa vj cv vk cv cle wbr
      vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt
      wbr wa vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx cv c2 cdiv
      co clt wbr wa wa wi vk cn wral vj cn wrex cD cme wcel cF cA cD clm cfv
      wbr cF cB cD clm cfv wbr w3a vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv
      co clt wbr wa wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv
      cF cfv cA cD co vx cv c2 cdiv co clt wbr wa wi vk cn wral vj cn wrex vj
      cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx cv
      c2 cdiv co clt wbr wa wi vk cn wral vj cn wrex cD cme wcel cF cA cD clm
      cfv wbr vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr wa vj cv vk
      cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co vx cv c2
      cdiv co clt wbr wa wi vk cn wral vj cn wrex cF cB cD clm cfv wbr cD cme
      wcel cA cvv wcel cF cA cD clm cfv wbr vx cv c2 cdiv co cr wcel cc0 vx cv
      c2 cdiv co clt wbr wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk
      cv cF cfv cA cD co vx cv c2 cdiv co clt wbr wa wi vk cn wral vj cn wrex
      lmuni.1 cvv cD cA vx cv c2 cdiv co vj vk cF c1 cD cdm cdm cn cD cdm cdm
      eqid 1z nnuz lmcvg mp3anl2 3adantl3 cD cme wcel cF cB cD clm cfv wbr vx
      cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr wa vj cv vk cv cle wbr
      vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx cv c2 cdiv co clt
      wbr wa wi vk cn wral vj cn wrex cF cA cD clm cfv wbr cD cme wcel cB cvv
      wcel cF cB cD clm cfv wbr vx cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co
      clt wbr wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv
      cB cD co vx cv c2 cdiv co clt wbr wa wi vk cn wral vj cn wrex lmuni.2 cvv
      cD cB vx cv c2 cdiv co vj vk cF c1 cD cdm cdm cn cD cdm cdm eqid 1z nnuz
      lmcvg mp3anl2 3adantl2 jca vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cA
      cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm wcel vk cv cF
      cfv cB cD co vx cv c2 cdiv co clt wbr wa vj vk c1 cn 1z nnuz cvganuzi
      sylib vx cv cr wcel cc0 vx cv clt wbr wa vx cv c2 cdiv co cr wcel cc0 vx
      cv c2 cdiv co clt wbr vx cv cr wcel vx cv c2 cdiv co cr wcel cc0 vx cv
      clt wbr vx cv rehalfcl adantr vx cv cr wcel cc0 vx cv clt wbr cc0 vx cv
      c2 cdiv co clt wbr vx cv halfpos2 biimpa jca sylan2 cD cme wcel cA cD cdm
      cdm wcel cB cD cdm cdm wcel w3a vx cv cr wcel vj cv vk cv cle wbr vk cv
      cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr wa
      vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx cv c2 cdiv co clt
      wbr wa wa wi vk cn wral vj cn wrex cA cB cD co vx cv clt wbr wi cD cme
      wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a vx cv cr wcel cc0 vx
      cv clt wbr wa cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a vx cv
      cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv
      cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm wcel vk cv
      cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa wi vk cn wral vj cn wrex
      vj cv vk cv cle wbr vk cn wrex vj cn wral cA cB cD co vx cv clt wbr vj cv
      vk cv cle wbr vk cn wrex vj cn vj cv cn wcel vj cv vj cv cle wbr vj cv vk
      cv cle wbr vk cn wrex vj cv cn wcel vj cv cr wcel vj cv vj cv cle wbr vj
      cv nnre vj cv leid syl vj cv vk cv cle wbr vj cv vj cv cle wbr vk vj cv
      cn vk cv vj cv vj cv cle breq2 rcla4ev mpdan rgen cD cme wcel cA cD cdm
      cdm wcel cB cD cdm cdm wcel w3a vx cv cr wcel wa vj cv vk cv cle wbr vk
      cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr
      wa vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co vx cv c2 cdiv co
      clt wbr wa wa wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cn wrex cA
      cB cD co vx cv clt wbr wi vj cn wrex vj cv vk cv cle wbr vk cn wrex vj cn
      wral cA cB cD co vx cv clt wbr wi cD cme wcel cA cD cdm cdm wcel cB cD
      cdm cdm wcel w3a vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cD cdm
      cdm wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv
      cD cdm cdm wcel vk cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa wi
      vk cn wral vj cv vk cv cle wbr vk cn wrex cA cB cD co vx cv clt wbr wi vj
      cn cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a vx cv cr wcel wa
      vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co vx
      cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD
      co vx cv c2 cdiv co clt wbr wa wa wi vk cn wral vj cv vk cv cle wbr cA cB
      cD co vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr vk cn wrex cA cB cD
      co vx cv clt wbr wi cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a
      vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv
      cF cfv cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm wcel
      vk cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa wi vj cv vk cv cle
      wbr cA cB cD co vx cv clt wbr wi vk cn cD cme wcel cA cD cdm cdm wcel cB
      cD cdm cdm wcel w3a vx cv cr wcel wa vk cv cF cfv cD cdm cdm wcel vk cv
      cF cfv cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm wcel
      vk cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa cA cB cD co vx cv
      clt wbr vj cv vk cv cle wbr cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm
      wcel w3a vx cv cr wcel wa vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD
      co vx cv c2 cdiv co clt wbr vk cv cF cfv cB cD co vx cv c2 cdiv co clt
      wbr wa wa cA cB cD co vx cv clt wbr vk cv cF cfv cD cdm cdm wcel vk cv cF
      cfv cA cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cD cdm cdm wcel vk
      cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa wa cD cme wcel cA cD cdm
      cdm wcel cB cD cdm cdm wcel w3a vx cv cr wcel wa vk cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr vk cv cF cfv cB cD co
      vx cv c2 cdiv co clt wbr wa cA cB cD co vx cv clt wbr cD cme wcel cA cD
      cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel vx cv cr
      wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr vk cv cF cfv cB cD co
      vx cv c2 cdiv co clt wbr wa cA cB cD co vx cv clt wbr wi cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vx
      cv cr wcel wa vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr vk cv cF cfv
      cB cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cA cD co vk cv cF cfv
      cB cD co caddc co vx cv clt wbr cA cB cD co vx cv clt wbr cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vx
      cv cr wcel wa vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr vk cv cF cfv
      cB cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cA cD co vk cv cF cfv
      cB cD co caddc co vx cv c2 cdiv co vx cv c2 cdiv co caddc co clt wbr vk
      cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co vx cv clt wbr vk cv cF
      cfv cA cD co cr wcel vk cv cF cfv cB cD co cr wcel wa vx cv c2 cdiv co cr
      wcel vx cv c2 cdiv co cr wcel wa vk cv cF cfv cA cD co vx cv c2 cdiv co
      clt wbr vk cv cF cfv cB cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv cA
      cD co vk cv cF cfv cB cD co caddc co vx cv c2 cdiv co vx cv c2 cdiv co
      caddc co clt wbr wi cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a
      vk cv cF cfv cD cdm cdm wcel wa vx cv cr wcel vk cv cF cfv cA cD co vk cv
      cF cfv cB cD co vx cv c2 cdiv co vx cv c2 cdiv co lt2add cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vk
      cv cF cfv cA cD co cr wcel vk cv cF cfv cB cD co cr wcel cD cme wcel cA
      cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co cr
      wcel cB cD cdm cdm wcel cD cme wcel cA cD cdm cdm wcel vk cv cF cfv cD
      cdm cdm wcel vk cv cF cfv cA cD co cr wcel cD cme wcel vk cv cF cfv cD
      cdm cdm wcel cA cD cdm cdm wcel vk cv cF cfv cA cD co cr wcel vk cv cF
      cfv cA cD cD cdm cdm cD cdm cdm eqid metcl 3com23 3expa 3adantl3 cD cme
      wcel cB cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD
      co cr wcel cA cD cdm cdm wcel cD cme wcel cB cD cdm cdm wcel vk cv cF cfv
      cD cdm cdm wcel vk cv cF cfv cB cD co cr wcel cD cme wcel vk cv cF cfv cD
      cdm cdm wcel cB cD cdm cdm wcel vk cv cF cfv cB cD co cr wcel vk cv cF
      cfv cB cD cD cdm cdm cD cdm cdm eqid metcl 3com23 3expa 3adantl2 jca vx
      cv cr wcel vx cv c2 cdiv co cr wcel vx cv c2 cdiv co cr wcel vx cv
      rehalfcl vx cv rehalfcl jca syl2an vx cv cr wcel vk cv cF cfv cA cD co vk
      cv cF cfv cB cD co caddc co vx cv c2 cdiv co vx cv c2 cdiv co caddc co
      clt wbr vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co vx cv clt
      wbr wb cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv
      cD cdm cdm wcel wa vx cv cr wcel vx cv c2 cdiv co vx cv c2 cdiv co caddc
      co vx cv vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co clt vx cv
      cr wcel vx cv cc wcel vx cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv
      wceq vx cv recn vx cv 2halves syl breq2d adantl sylibd cD cme wcel cA cD
      cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vx cv
      cr wcel wa cA cB cD co vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc
      co cle wbr vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co vx cv clt
      wbr cA cB cD co vx cv clt wbr cD cme wcel cA cD cdm cdm wcel cB cD cdm
      cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa cA cB cD co vk cv cF cfv cA
      cD co vk cv cF cfv cB cD co caddc co cle wbr vx cv cr wcel cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel cA cB cD
      co vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co cle wbr cD cme
      wcel vk cv cF cfv cD cdm cdm wcel cB cD cdm cdm wcel cA cD cdm cdm wcel
      cA cB cD co vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co cle wbr
      cD cme wcel vk cv cF cfv cD cdm cdm wcel cA cD cdm cdm wcel cB cD cdm cdm
      wcel cA cB cD co vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co cle
      wbr cD cme wcel vk cv cF cfv cD cdm cdm wcel cA cD cdm cdm wcel cB cD cdm
      cdm wcel cA cB cD co vk cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co
      cle wbr cA cB vk cv cF cfv cD cD cdm cdm cD cdm cdm eqid mettri2 3exp2
      com34 com24 3imp1 adantr cA cB cD co cr wcel vk cv cF cfv cA cD co vk cv
      cF cfv cB cD co caddc co cr wcel vx cv cr wcel cA cB cD co vk cv cF cfv
      cA cD co vk cv cF cfv cB cD co caddc co cle wbr vk cv cF cfv cA cD co vk
      cv cF cfv cB cD co caddc co vx cv clt wbr wa cA cB cD co vx cv clt wbr wi
      cD cme wcel cA cD cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm
      cdm wcel wa vx cv cr wcel wa cA cB cD co vk cv cF cfv cA cD co vk cv cF
      cfv cB cD co caddc co vx cv lelttr cD cme wcel cA cD cdm cdm wcel cB cD
      cdm cdm wcel w3a cA cB cD co cr wcel vk cv cF cfv cD cdm cdm wcel vx cv
      cr wcel cA cB cD cD cdm cdm cD cdm cdm eqid metcl ad2antrr cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vk
      cv cF cfv cA cD co vk cv cF cfv cB cD co caddc co cr wcel vx cv cr wcel
      vk cv cF cfv cA cD co cr wcel vk cv cF cfv cB cD co cr wcel vk cv cF cfv
      cA cD co vk cv cF cfv cB cD co caddc co cr wcel cD cme wcel cA cD cdm cdm
      wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vk cv cF cfv
      cA cD co vk cv cF cfv cB cD co readdcl cD cme wcel cA cD cdm cdm wcel vk
      cv cF cfv cD cdm cdm wcel vk cv cF cfv cA cD co cr wcel cB cD cdm cdm
      wcel cD cme wcel cA cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vk cv cF
      cfv cA cD co cr wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel cA cD cdm
      cdm wcel vk cv cF cfv cA cD co cr wcel vk cv cF cfv cA cD cD cdm cdm cD
      cdm cdm eqid metcl 3com23 3expa 3adantl3 cD cme wcel cB cD cdm cdm wcel
      vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cB cD co cr wcel cA cD cdm cdm
      wcel cD cme wcel cB cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vk cv cF
      cfv cB cD co cr wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel cB cD cdm
      cdm wcel vk cv cF cfv cB cD co cr wcel vk cv cF cfv cB cD cD cdm cdm cD
      cdm cdm eqid metcl 3com23 3expa 3adantl2 sylanc adantr cD cme wcel cA cD
      cdm cdm wcel cB cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel wa vx cv
      cr wcel pm3.27 syl3anc mpand syld an1rs expimpd vk cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cA cD co vx cv c2 cdiv co clt wbr vk cv cF cfv cB cD co
      vx cv c2 cdiv co clt wbr anandi syl5ibr imim2d r19.20sdv vj cv vk cv cle
      wbr cA cB cD co vx cv clt wbr vk cn r19.23v syl6ib r19.22sdv vj cv vk cv
      cle wbr vk cn wrex cA cB cD co vx cv clt wbr vj cn r19.36av syl6 mpii cD
      cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cD cme wcel cA cD
      cdm cdm wcel cB cD cdm cdm wcel cD cme wcel cF cA cD clm cfv wbr cF cB cD
      clm cfv wbr 3simp1 cD cme wcel cF cA cD clm cfv wbr cA cD cdm cdm wcel cF
      cB cD clm cfv wbr cD cme wcel cA cvv wcel cF cA cD clm cfv wbr cA cD cdm
      cdm wcel lmuni.1 cvv cD cA cF cD cdm cdm cD cdm cdm eqid lmcl mp3an2
      3adant3 cD cme wcel cF cB cD clm cfv wbr cB cD cdm cdm wcel cF cA cD clm
      cfv wbr cD cme wcel cB cvv wcel cF cB cD clm cfv wbr cB cD cdm cdm wcel
      lmuni.2 cvv cD cB cF cD cdm cdm cD cdm cdm eqid lmcl mp3an2 3adant2 3jca
      vx cv cr wcel cc0 vx cv clt wbr pm3.26 syl2an mpd exp32 r19.21aiv syl3anc
      cD cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel w3a cA cB cD co cc0 wceq cA cB wceq wb
      cD cme wcel cF cA cD clm cfv wbr cF cB cD clm cfv wbr w3a cD cme wcel cA
      cD cdm cdm wcel cB cD cdm cdm wcel cD cme wcel cF cA cD clm cfv wbr cF cB
      cD clm cfv wbr 3simp1 cD cme wcel cF cA cD clm cfv wbr cA cD cdm cdm wcel
      cF cB cD clm cfv wbr cD cme wcel cA cvv wcel cF cA cD clm cfv wbr cA cD
      cdm cdm wcel lmuni.1 cvv cD cA cF cD cdm cdm cD cdm cdm eqid lmcl mp3an2
      3adant3 cD cme wcel cF cB cD clm cfv wbr cB cD cdm cdm wcel cF cA cD clm
      cfv wbr cD cme wcel cB cvv wcel cF cB cD clm cfv wbr cB cD cdm cdm wcel
      lmuni.2 cvv cD cB cF cD cdm cdm cD cdm cdm eqid lmcl mp3an2 3adant2 3jca
      cA cB cD cD cdm cdm cD cdm cdm eqid meteq0 syl mpbid $.
      $( [21-Mar-2008] $) $( [31-Jan-2008] $)
  $}

  ${
    lmsslem.1 $e |- ( ( ( D e. Met /\ ch ) /\ ph ) ->
         F C_ ( CC X. dom dom D ) ) $.
    lmsslem.2 $e |- ( ( ( ( D |` ( Y X. Y ) ) e. Met /\ ch ) /\ ps ) ->
         F C_ ( CC X. dom dom ( D |` ( Y X. Y ) ) ) ) $.
    lmsslem.3 $e |- ( ( D e. Met /\ ( ch /\
        F : NN --> dom dom ( D |` ( Y X. Y ) ) ) ) -> ( ph <-> ps ) ) $.
    lmsslem.4 $e |- ( ch -> F : NN --> Y ) $.
    $( Lemma for ~ lmss and ~ causs . $)
    lmsslem $p |- ( ( D e. Met /\ ch ) -> ( ph <-> ps ) ) $=
      cD cme wcel wch wa wph wps wo wph wps wb wi wph wps wb cD cme wcel wch wa
      wph wps wo cF cc cD cdm cdm cxp wss wph wps wb cD cme wcel wch wa wph wps
      wo cF cc cD cdm cdm cxp wss cD cme wcel wch wa wph cF cc cD cdm cdm cxp
      wss wps lmsslem.1 cF cc cD cY cY cxp cres cdm cdm cxp wss cc cD cY cY cxp
      cres cdm cdm cxp cc cD cdm cdm cxp wss cF cc cD cdm cdm cxp wss cD cme
      wcel wch wa wps wa cF cc cD cY cY cxp cres cdm cdm cxp cc cD cdm cdm cxp
      sstr cD cY cY cxp cres cme wcel wch wps cF cc cD cY cY cxp cres cdm cdm
      cxp wss cD cme wcel lmsslem.2 cD cY metres sylanl1 cc cc wss cD cY cY cxp
      cres cdm cdm cD cdm cdm wss cc cD cY cY cxp cres cdm cdm cxp cc cD cdm
      cdm cxp wss cc ssid cD cY cY cxp cres cdm cD cdm wss cD cY cY cxp cres
      cdm cdm cD cdm cdm wss cD cY cY cxp cres cD wss cD cY cY cxp cres cdm cD
      cdm wss cD cY cY cxp resss cD cY cY cxp cres cD dmss ax-mp cD cY cY cxp
      cres cdm cD cdm dmss ax-mp cc cc cD cY cY cxp cres cdm cdm cD cdm cdm
      ssxp mp2an sylancl jaodan ex cD cme wcel wch wa cF cc cD cdm cdm cxp wss
      wph wps wb cD cme wcel wch cF cc cD cdm cdm cxp wss wph wps wb cD cme
      wcel wch cF cc cD cdm cdm cxp wss wa wch cn cD cY cY cxp cres cdm cdm cF
      wf wa wph wps wb cD cme wcel wch cF cc cD cdm cdm cxp wss wa wa wch cn cD
      cY cY cxp cres cdm cdm cF wf cD cme wcel wch cF cc cD cdm cdm cxp wss
      simprl cD cme wcel cn cY cF wf cF cc cD cdm cdm cxp wss cn cD cY cY cxp
      cres cdm cdm cF wf wch cD cme wcel cn cY cF wf cF cc cD cdm cdm cxp wss
      wa cn cD cY cY cxp cres cdm cdm cF wf cD cme wcel cn cD cY cY cxp cres
      cdm cdm cF wf cn cY cD cdm cdm cin cF wf cn cY cF wf cF cc cD cdm cdm cxp
      wss wa cD cme wcel cD cY cY cxp cres cdm cdm cY cD cdm cdm cin wceq cn cD
      cY cY cxp cres cdm cdm cF wf cn cY cD cdm cdm cin cF wf wb cD cme wcel cD
      cdm cdm cY cin cD cY cY cxp cres cdm cdm cY cD cdm cdm cin cD cD cdm cdm
      cY cD cdm cdm eqid metssba cY cD cdm cdm incom syl5req cD cY cY cxp cres
      cdm cdm cY cD cdm cdm cin cn cF feq3 syl cn cY cD cdm cdm cin cF wf cn cY
      cF wf cn cD cdm cdm cF wf cn cY cF wf cF cc cD cdm cdm cxp wss wa cn cY
      cD cdm cdm cF fin cn cY cF wf cF cc cD cdm cdm cxp wss pm3.26 cn cY cF wf
      cF cc cD cdm cdm cxp wss wa cF cn wfn cF crn cD cdm cdm wss wa cn cD cdm
      cdm cF wf cn cY cF wf cF cn wfn cF cc cD cdm cdm cxp wss cF crn cD cdm
      cdm wss cn cY cF ffn cF cc cD cdm cdm cxp wss cF crn cc cD cdm cdm cxp
      crn cD cdm cdm cF cc cD cdm cdm cxp rnss cc c0 wne cc cD cdm cdm cxp crn
      cD cdm cdm wceq c1 cc wcel cc c0 wne ax1cn cc c1 ne0i ax-mp cc cD cdm cdm
      rnxp ax-mp syl6ss anim12i cn cD cdm cdm cF df-f sylibr sylanbrc syl5bir
      imp lmsslem.4 sylanr1 jca lmsslem.3 syldan anassrs ex syld wph wps oibabs
      sylib $.
      $( [11-Feb-2008] $) $( [29-Jan-2008] $)
  $}

  ${
    $d j k x D $.  $d j k x F $.  $d j k x P $.  $d j k x Y $.
    $( Limit on a metric subspace. $)
    lmss $p |- ( ( D e. Met /\ P e. Y /\ F : NN --> Y ) ->
          ( F ( ~~>m ` D ) P <-> F ( ~~>m ` ( D |` ( Y X. Y ) ) ) P ) ) $=
      cD cme wcel cP cY wcel cn cY cF wf cF cP cD clm cfv wbr cF cP cD cY cY
      cxp cres clm cfv wbr wb cF cP cD clm cfv wbr cF cP cD cY cY cxp cres clm
      cfv wbr cP cY wcel cn cY cF wf wa cD cF cY cD cme wcel cP cY wcel cF cP
      cD clm cfv wbr cF cc cD cdm cdm cxp wss cn cY cF wf cD cme wcel cP cY
      wcel cF cP cD clm cfv wbr cF cc cD cdm cdm cxp wss cY cD cP cF cD cdm cdm
      cD cdm cdm eqid lmfss 3expa adantlrr cD cY cY cxp cres cme wcel cP cY
      wcel cF cP cD cY cY cxp cres clm cfv wbr cF cc cD cY cY cxp cres cdm cdm
      cxp wss cn cY cF wf cD cY cY cxp cres cme wcel cP cY wcel cF cP cD cY cY
      cxp cres clm cfv wbr cF cc cD cY cY cxp cres cdm cdm cxp wss cY cD cY cY
      cxp cres cP cF cD cY cY cxp cres cdm cdm cD cY cY cxp cres cdm cdm eqid
      lmfss 3expa adantlrr cD cme wcel cP cY wcel cn cY cF wf wa cn cD cY cY
      cxp cres cdm cdm cF wf wa wa cP cD cY cY cxp cres cdm cdm wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD cY cY cxp cres co vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa cP cD cdm cdm wcel cc0
      vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi
      vk cn wral vj cn wrex wi vx cr wral wa cF cP cD cY cY cxp cres clm cfv
      wbr cF cP cD clm cfv wbr cD cme wcel cP cY wcel cn cY cF wf wa cP cD cY
      cY cxp cres cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF
      cfv cP cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi vx
      cr wral wa cP cD cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv
      cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa
      wb cn cD cY cY cxp cres cdm cdm cF wf cD cme wcel cP cY wcel cn cY cF wf
      wa wa cP cD cY cY cxp cres cdm cdm wcel cP cD cdm cdm wcel cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cP cD cY cY cxp cres co vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi
      vx cr wral cD cme wcel cP cY wcel cP cD cY cY cxp cres cdm cdm wcel cP cD
      cdm cdm wcel wb cn cY cF wf cD cme wcel cP cD cY cY cxp cres cdm cdm wcel
      cP cY cD cdm cdm cin wcel cP cY wcel cP cD cdm cdm wcel cD cme wcel cD cY
      cY cxp cres cdm cdm cY cD cdm cdm cin cP cD cme wcel cD cdm cdm cY cin cD
      cY cY cxp cres cdm cdm cY cD cdm cdm cin cD cD cdm cdm cY cD cdm cdm eqid
      metssba cY cD cdm cdm incom syl5req eleq2d cP cY cD cdm cdm cin wcel cP
      cY wcel cP cD cdm cdm wcel cP cY cD cdm cdm elin baib sylan9bb adantrr cP
      cY wcel cn cY cF wf wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cP cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr
      wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr wral wb cD cme wcel cP cY wcel
      cn cY cF wf wa cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD
      cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi cc0 vx cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral
      vj cn wrex wi vx cr cP cY wcel cn cY cF wf wa vj cv vk cv cle wbr vk cv
      cF cfv cP cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex vj
      cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn
      wrex cc0 vx cv clt wbr cP cY wcel cn cY cF wf wa vj cv vk cv cle wbr vk
      cv cF cfv cP cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cv vk cv
      cle wbr vk cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn cP cY
      wcel cn cY cF wf wa vj cv vk cv cle wbr vk cv cF cfv cP cD cY cY cxp cres
      co vx cv clt wbr wi vj cv vk cv cle wbr vk cv cF cfv cP cD co vx cv clt
      wbr wi vk cn cP cY wcel cn cY cF wf wa vk cv cn wcel wa vk cv cF cfv cP
      cD cY cY cxp cres co vx cv clt wbr vk cv cF cfv cP cD co vx cv clt wbr vj
      cv vk cv cle wbr cP cY wcel cn cY cF wf wa vk cv cn wcel wa vk cv cF cfv
      cP cD cY cY cxp cres co vk cv cF cfv cP cD co vx cv clt cP cY wcel cn cY
      cF wf vk cv cn wcel vk cv cF cfv cP cD cY cY cxp cres co vk cv cF cfv cP
      cD co wceq cn cY cF wf vk cv cn wcel wa cP cY wcel vk cv cF cfv cP cD cY
      cY cxp cres co vk cv cF cfv cP cD co wceq vk cv cF cfv cY wcel cP cY wcel
      vk cv cF cfv cP cD cY cY cxp cres co vk cv cF cfv cP cD co wceq cn cY cF
      wf vk cv cn wcel wa vk cv cF cfv cP cY cY cD oprvres cn cY vk cv cF
      ffvelrn sylan ancoms anassrs breq1d imbi2d ralbidva rexbidv imbi2d
      ralbidv adantl anbi12d adantrr cD cme wcel cP cY wcel cn cD cY cY cxp
      cres cdm cdm cF wf cF cP cD cY cY cxp cres clm cfv wbr cP cD cY cY cxp
      cres cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP
      cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral
      wa wb cn cY cF wf cD cme wcel cP cY wcel cn cD cY cY cxp cres cdm cdm cF
      wf cF cP cD cY cY cxp cres clm cfv wbr cP cD cY cY cxp cres cdm cdm wcel
      cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD cY cY cxp cres
      co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa wb cD cY cY
      cxp cres cme wcel cP cY wcel cn cD cY cY cxp cres cdm cdm cF wf cF cP cD
      cY cY cxp cres clm cfv wbr cP cD cY cY cxp cres cdm cdm wcel cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD cY cY cxp cres co vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa wb cD cme wcel vx cY cD
      cY cY cxp cres cP vj vk cF c1 cD cY cY cxp cres cdm cdm cn cD cY cY cxp
      cres cdm cdm eqid 1z nnuz lmbrf cD cY metres syl3an1 3expb adantrlr cD
      cme wcel cP cY wcel cn cD cY cY cxp cres cdm cdm cF wf cF cP cD clm cfv
      wbr cP cD cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa wb cn cY
      cF wf cD cme wcel cP cY wcel cn cD cY cY cxp cres cdm cdm cF wf cF cP cD
      clm cfv wbr cP cD cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk
      cv cF cfv cP cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral
      wa wb cD cme wcel cP cY wcel cn cD cdm cdm cF wf cF cP cD clm cfv wbr cP
      cD cdm cdm wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cP cD
      co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa wb cn cD cY cY
      cxp cres cdm cdm cF wf vx cY cD cP vj vk cF c1 cD cdm cdm cn cD cdm cdm
      eqid 1z nnuz lmbrf cn cD cY cY cxp cres cdm cdm cF wf cD cY cY cxp cres
      cdm cdm cD cdm cdm wss cn cD cdm cdm cF wf cD cY cY cxp cres cdm cD cdm
      wss cD cY cY cxp cres cdm cdm cD cdm cdm wss cD cY cY cxp cres cD wss cD
      cY cY cxp cres cdm cD cdm wss cD cY cY cxp resss cD cY cY cxp cres cD
      dmss ax-mp cD cY cY cxp cres cdm cD cdm dmss ax-mp cn cD cY cY cxp cres
      cdm cdm cD cdm cdm cF fss mpan2 syl3an3 3expb adantrlr 3bitr4rd cP cY
      wcel cn cY cF wf pm3.27 lmsslem 3impb $.
      $( [11-Feb-2008] $) $( [30-Jan-2008] $)
  $}

  ${
    $d j k x D $.  $d j k x F $.  $d j k x Y $.
    $( Cauchy sequence on a metric subspace. $)
    caussi $p |- ( ( D e. Met /\ F e. ( Cau ` ( D |` ( Y X. Y ) ) ) ) ->
            F e. ( Cau ` D ) ) $=
      cD cme wcel cF cD cY cY cxp cres cca cfv wcel cF cD cca cfv wcel cD cme
      wcel cF cc cD cY cY cxp cres cdm cdm cxp wss cc0 vx cv clt wbr vj cv vk
      cv cle wbr vj cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cY
      cY cxp cres cdm cdm wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co
      vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral wa cF cc cD cdm
      cdm cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cD cdm cdm wcel vj cv cF cfv vk cv cF cfv cD co vx cv
      clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral wa cF cD cY cY cxp
      cres cca cfv wcel cF cD cca cfv wcel cD cme wcel cF cc cD cY cY cxp cres
      cdm cdm cxp wss cF cc cD cdm cdm cxp wss cc0 vx cv clt wbr vj cv vk cv
      cle wbr vj cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY
      cxp cres cdm cdm wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx
      cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral cc0 vx cv clt wbr
      vj cv vk cv cle wbr vj cv cF cfv cD cdm cdm wcel vk cv cF cfv cD cdm cdm
      wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
      cn wrex wi vx cr wral cF cc cD cY cY cxp cres cdm cdm cxp wss cF cc cD
      cdm cdm cxp wss wi cD cme wcel cF cc cD cY cY cxp cres cdm cdm cxp wss cc
      cD cY cY cxp cres cdm cdm cxp cc cD cdm cdm cxp wss cF cc cD cdm cdm cxp
      wss cc cc wss cD cY cY cxp cres cdm cdm cD cdm cdm wss cc cD cY cY cxp
      cres cdm cdm cxp cc cD cdm cdm cxp wss cc ssid cD cY cY cxp cres cdm cD
      cdm wss cD cY cY cxp cres cdm cdm cD cdm cdm wss cD cY cY cxp cres cD wss
      cD cY cY cxp cres cdm cD cdm wss cD cY cY cxp resss cD cY cY cxp cres cD
      dmss ax-mp cD cY cY cxp cres cdm cD cdm dmss ax-mp cc cc cD cY cY cxp
      cres cdm cdm cD cdm cdm ssxp mp2an cF cc cD cY cY cxp cres cdm cdm cxp cc
      cD cdm cdm cxp sstr mpan2 a1i cD cme wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vj cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY
      cxp cres cdm cdm wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx
      cv clt wbr w3a wi vk cn wral vj cn wrex wi cc0 vx cv clt wbr vj cv vk cv
      cle wbr vj cv cF cfv cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vj cv
      cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi
      vx cr cD cme wcel vj cv vk cv cle wbr vj cv cF cfv cD cY cY cxp cres cdm
      cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj cv cF cfv vk cv
      cF cfv cD cY cY cxp cres co vx cv clt wbr w3a wi vk cn wral vj cn wrex vj
      cv vk cv cle wbr vj cv cF cfv cD cdm cdm wcel vk cv cF cfv cD cdm cdm
      wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj
      cn wrex cc0 vx cv clt wbr cD cme wcel vj cv vk cv cle wbr vj cv cF cfv cD
      cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel
      vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr w3a wi vk cn
      wral vj cv vk cv cle wbr vj cv cF cfv cD cdm cdm wcel vk cv cF cfv cD cdm
      cdm wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral
      vj cn cD cme wcel vj cv vk cv cle wbr vj cv cF cfv cD cY cY cxp cres cdm
      cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj cv cF cfv vk cv
      cF cfv cD cY cY cxp cres co vx cv clt wbr w3a wi vj cv vk cv cle wbr vj
      cv cF cfv cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vj cv cF cfv vk cv
      cF cfv cD co vx cv clt wbr w3a wi vk cn cD cme wcel vj cv cF cfv cD cY cY
      cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj cv
      cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr w3a vj cv cF cfv
      cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vj cv cF cfv vk cv cF cfv cD
      co vx cv clt wbr w3a vj cv vk cv cle wbr cD cme wcel vj cv cF cfv cD cY
      cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj
      cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr w3a vj cv cF
      cfv cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vj cv cF cfv vk cv cF
      cfv cD co vx cv clt wbr vj cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv
      cF cfv cD cY cY cxp cres cdm cdm wcel vj cv cF cfv vk cv cF cfv cD cY cY
      cxp cres co vx cv clt wbr w3a vj cv cF cfv cD cdm cdm wcel wi cD cme wcel
      vj cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp
      cres cdm cdm wcel vj cv cF cfv cD cdm cdm wcel vj cv cF cfv vk cv cF cfv
      cD cY cY cxp cres co vx cv clt wbr cD cY cY cxp cres cdm cdm cD cdm cdm
      vj cv cF cfv cD cY cY cxp cres cdm cD cdm wss cD cY cY cxp cres cdm cdm
      cD cdm cdm wss cD cY cY cxp cres cD wss cD cY cY cxp cres cdm cD cdm wss
      cD cY cY cxp resss cD cY cY cxp cres cD dmss ax-mp cD cY cY cxp cres cdm
      cD cdm dmss ax-mp sseli 3ad2ant1 a1i vj cv cF cfv cD cY cY cxp cres cdm
      cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj cv cF cfv vk cv
      cF cfv cD cY cY cxp cres co vx cv clt wbr w3a vk cv cF cfv cD cdm cdm
      wcel wi cD cme wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj cv cF
      cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vj cv cF
      cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr cD cY cY cxp cres cdm
      cdm cD cdm cdm vk cv cF cfv cD cY cY cxp cres cdm cD cdm wss cD cY cY cxp
      cres cdm cdm cD cdm cdm wss cD cY cY cxp cres cD wss cD cY cY cxp cres
      cdm cD cdm wss cD cY cY cxp resss cD cY cY cxp cres cD dmss ax-mp cD cY
      cY cxp cres cdm cD cdm dmss ax-mp sseli 3ad2ant2 a1i cD cme wcel vj cv cF
      cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm
      wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr vj cv
      cF cfv vk cv cF cfv cD co vx cv clt wbr cD cme wcel vj cv cF cfv cD cY cY
      cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj cv
      cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr vj cv cF cfv vk cv
      cF cfv cD co vx cv clt wbr wi cD cme wcel vj cv cF cfv cD cY cY cxp cres
      cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel wa wa vj cv cF
      cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr vj cv cF cfv vk cv cF
      cfv cD co vx cv clt wbr cD cme wcel vj cv cF cfv cD cY cY cxp cres cdm
      cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel wa wa vj cv cF cfv
      vk cv cF cfv cD cY cY cxp cres co vj cv cF cfv vk cv cF cfv cD co vx cv
      clt cD cme wcel vj cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv
      cD cY cY cxp cres cdm cdm wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp
      cres co vj cv cF cfv vk cv cF cfv cD co wceq vj cv cF cfv cY wcel vk cv
      cF cfv cY wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vj cv cF
      cfv vk cv cF cfv cD co wceq cD cme wcel vj cv cF cfv cD cY cY cxp cres
      cdm cdm wcel wa cD cme wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel
      wa vj cv cF cfv vk cv cF cfv cY cY cD oprvres cD cme wcel vj cv cF cfv cD
      cY cY cxp cres cdm cdm wcel vj cv cF cfv cY wcel cD cme wcel cD cY cY cxp
      cres cdm cdm cY vj cv cF cfv cD cme wcel cD cY cY cxp cres cdm cdm cD cdm
      cdm cY cin cY cD cD cdm cdm cY cD cdm cdm eqid metssba cD cdm cdm cY cin
      cY wss cD cme wcel cD cdm cdm cY inss2 a1i eqsstr3d sseld imp cD cme wcel
      vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vk cv cF cfv cY wcel cD cme
      wcel cD cY cY cxp cres cdm cdm cY vk cv cF cfv cD cme wcel cD cY cY cxp
      cres cdm cdm cD cdm cdm cY cin cY cD cD cdm cdm cY cD cdm cdm eqid
      metssba cD cdm cdm cY cin cY wss cD cme wcel cD cdm cdm cY inss2 a1i
      eqsstr3d sseld imp syl2an anandis breq1d biimpd exp32 3impd 3jcad imim2d
      r19.20sdv r19.22sdv imim2d r19.20sdv anim12d cD cme wcel cD cY cY cxp
      cres cme wcel cF cD cY cY cxp cres cca cfv wcel cF cc cD cY cY cxp cres
      cdm cdm cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cD cY
      cY cxp cres cdm cdm wcel vk cv cF cfv cD cY cY cxp cres cdm cdm wcel vj
      cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr w3a wi vk cn
      wral vj cn wrex wi vx cr wral wa wb cD cY metres vx cD cY cY cxp cres vj
      vk cF c1 cD cY cY cxp cres cdm cdm cn cD cY cY cxp cres cdm cdm eqid 1z
      nnuz iscau3 syl vx cD vj vk cF c1 cD cdm cdm cn cD cdm cdm eqid 1z nnuz
      iscau3 3imtr4d imp $.
      $( [21-Mar-2008] $) $( [30-Jan-2008] $)

    $( Cauchy sequence on a metric subspace. $)
    causs $p |- ( ( D e. Met /\ F : NN --> Y ) -> ( F e. ( Cau ` D ) <->
            F e. ( Cau ` ( D |` ( Y X. Y ) ) ) ) ) $=
      cF cD cca cfv wcel cF cD cY cY cxp cres cca cfv wcel cn cY cF wf cD cF cY
      cD cme wcel cF cD cca cfv wcel cF cc cD cdm cdm cxp wss cn cY cF wf cD cF
      cD cdm cdm cD cdm cdm eqid caufss adantlr cD cY cY cxp cres cme wcel cF
      cD cY cY cxp cres cca cfv wcel cF cc cD cY cY cxp cres cdm cdm cxp wss cn
      cY cF wf cD cY cY cxp cres cF cD cY cY cxp cres cdm cdm cD cY cY cxp cres
      cdm cdm eqid caufss adantlr cD cme wcel cn cY cF wf cn cD cY cY cxp cres
      cdm cdm cF wf wa wa cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk
      cv cF cfv cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi
      vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF
      cfv cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral cF cD cY
      cY cxp cres cca cfv wcel cF cD cca cfv wcel cn cY cF wf cc0 vx cv clt wbr
      vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk
      cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk cn wral vj
      cn wrex wi vx cr wral wb cD cme wcel cn cD cY cY cxp cres cdm cdm cF wf
      cn cY cF wf cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF
      cfv cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi cc0 vx
      cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr cn cY cF wf vj cv vk cv cle wbr vj
      cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr wi vk cn wral
      vj cn wrex vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt
      wbr wi vk cn wral vj cn wrex cc0 vx cv clt wbr cn cY cF wf vj cv vk cv
      cle wbr vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr wi
      vk cn wral vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt
      wbr wi vk cn wral vj cn cn cY cF wf vj cv cn wcel wa vj cv vk cv cle wbr
      vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt wbr wi vj cv vk
      cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk cn cn cY
      cF wf vj cv cn wcel wa vk cv cn wcel wa vj cv cF cfv vk cv cF cfv cD cY
      cY cxp cres co vx cv clt wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt
      wbr vj cv vk cv cle wbr cn cY cF wf vj cv cn wcel wa vk cv cn wcel wa vj
      cv cF cfv vk cv cF cfv cD cY cY cxp cres co vj cv cF cfv vk cv cF cfv cD
      co vx cv clt cn cY cF wf vj cv cn wcel vk cv cn wcel vj cv cF cfv vk cv
      cF cfv cD cY cY cxp cres co vj cv cF cfv vk cv cF cfv cD co wceq cn cY cF
      wf vj cv cn wcel vk cv cn wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp
      cres co vj cv cF cfv vk cv cF cfv cD co wceq vj cv cF cfv cY wcel vk cv
      cF cfv cY wcel vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vj cv cF
      cfv vk cv cF cfv cD co wceq cn cY cF wf vj cv cn wcel wa cn cY cF wf vk
      cv cn wcel wa vj cv cF cfv vk cv cF cfv cY cY cD oprvres cn cY vj cv cF
      ffvelrn cn cY vk cv cF ffvelrn syl2an anandis anassrs breq1d imbi2d
      ralbidva rexbidva imbi2d ralbidv ad2antrl cD cme wcel cn cD cY cY cxp
      cres cdm cdm cF wf cF cD cY cY cxp cres cca cfv wcel cc0 vx cv clt wbr vj
      cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD cY cY cxp cres co vx cv clt
      wbr wi vk cn wral vj cn wrex wi vx cr wral wb cn cY cF wf cD cY cY cxp
      cres cme wcel cn cD cY cY cxp cres cdm cdm cF wf cF cD cY cY cxp cres cca
      cfv wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv
      cD cY cY cxp cres co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral
      wb cD cme wcel vx cD cY cY cxp cres vj vk cF c1 cD cY cY cxp cres cdm cdm
      cn cD cY cY cxp cres cdm cdm eqid 1z nnuz iscauf cD cY metres sylan
      adantrl cD cme wcel cn cD cY cY cxp cres cdm cdm cF wf cF cD cca cfv wcel
      cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cD co vx
      cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wb cn cY cF wf cD cme
      wcel cn cD cdm cdm cF wf cF cD cca cfv wcel cc0 vx cv clt wbr vj cv vk cv
      cle wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr wi vk cn wral vj cn
      wrex wi vx cr wral wb cn cD cY cY cxp cres cdm cdm cF wf vx cD vj vk cF
      c1 cD cdm cdm cn cD cdm cdm eqid 1z nnuz iscauf cn cD cY cY cxp cres cdm
      cdm cF wf cD cY cY cxp cres cdm cdm cD cdm cdm wss cn cD cdm cdm cF wf cD
      cY cY cxp cres cdm cD cdm wss cD cY cY cxp cres cdm cdm cD cdm cdm wss cD
      cY cY cxp cres cD wss cD cY cY cxp cres cdm cD cdm wss cD cY cY cxp resss
      cD cY cY cxp cres cD dmss ax-mp cD cY cY cxp cres cdm cD cdm dmss ax-mp
      cn cD cY cY cxp cres cdm cdm cD cdm cdm cF fss mpan2 sylan2 adantrl
      3bitr4rd cn cY cF wf id lmsslem $.
      $( [22-Feb-2008] $) $( [29-Jan-2008] $)
  $}

  ${
    $d h z F $.  $d h z J $.  $d h z P $.  $d h z X $.  $d h z Z $.
    lmfexlem1.1 $e |- G = { <. h , z >. | ( h e. Z /\
                       z = if ( ( F ` h ) e. X , ( F ` h ) , P ) ) } $.
    $( Lemma for ~ lmfex .  ` G ` is a function constructed from an arbitrary
       sequence ` F ` , from ` NN ` to the metric space base set. $)
    lmfexlem1 $p |- ( P e. X -> G : Z --> X ) $=
      cP cX wcel vh cv cF cfv cX wcel vh cv cF cfv cP cif cX wcel vh cZ wral cZ
      cX cG wf cP cX wcel vh cv cF cfv cX wcel vh cv cF cfv cP cif cX wcel vh
      cZ cP cX wcel vh cv cF cfv cX wcel vh cv cF cfv cP cif cX wcel vh cv cZ
      wcel cP cX wcel vh cv cF cfv cX wcel vh cv cF cfv cX wcel wa vh cv cF cfv
      cX wcel wn cP cX wcel wa wo vh cv cF cfv cX wcel vh cv cF cfv cP cif cX
      wcel cP cX wcel vh cv cF cfv cX wcel vh cv cF cfv cX wcel wa vh cv cF cfv
      cX wcel wn cP cX wcel wa cP cX wcel vh cv cF cfv cX wcel vh cv cF cfv cX
      wcel wa wn vh cv cF cfv cX wcel wn cP cX wcel vh cv cF cfv cX wcel vh cv
      cF cfv cX wcel vh cv cF cfv cX wcel wa cP cX wcel vh cv cF cfv cX wcel vh
      cv cF cfv cX wcel cP cX wcel vh cv cF cfv cX wcel idd ancld con3d anc2ri
      orrd vh cv cF cfv cX wcel vh cv cF cfv cP cX ifel sylibr adantr
      r19.21aiva vh vz cZ cX vh cv cF cfv cX wcel vh cv cF cfv cP cif cG
      lmfexlem1.1 fopab2 sylib $.
      $( [28-May-2007] $) $( [27-May-2007] $)

    $( Lemma for ~ lmfex .  When the value of ` F ` exists, it equals the
       value of ` G ` . $)
    lmfexlem2 $p |- ( ( J e. Z /\ ( F ` J ) e. X ) ->
                     ( G ` J ) = ( F ` J ) ) $=
      cJ cZ wcel cJ cF cfv cX wcel wa cJ cG cfv cJ cF cfv cX wcel cJ cF cfv cP
      cif cJ cF cfv cJ cZ wcel cJ cF cfv cX wcel cJ cF cfv cP cif cX wcel cJ cG
      cfv cJ cF cfv cX wcel cJ cF cfv cP cif wceq cJ cF cfv cX wcel vh vz cJ vh
      cv cF cfv cX wcel vh cv cF cfv cP cif cJ cF cfv cX wcel cJ cF cfv cP cif
      cZ cX cG vh cv cJ wceq vh cv cF cfv cX wcel vh cv cF cfv cP cif cJ cF cfv
      cX wcel vh cv cF cfv cP cif cJ cF cfv cX wcel cJ cF cfv cP cif vh cv cJ
      wceq vh cv cF cfv cX wcel cJ cF cfv cX wcel vh cv cF cfv cP vh cv cJ wceq
      vh cv cF cfv cJ cF cfv cX vh cv cJ cF fveq2 eleq1d ifbid vh cv cJ wceq cJ
      cF cfv cX wcel vh cv cF cfv cJ cF cfv cP vh cv cJ cF fveq2 ifeq1d eqtrd
      lmfexlem1.1 fvopab4g cJ cF cfv cX wcel cJ cF cfv cX wcel cJ cF cfv cP cif
      cJ cF cfv cX cJ cF cfv cX wcel cJ cF cfv cP iftrue cJ cF cfv cX wcel id
      eqeltrd sylan2 cJ cF cfv cX wcel cJ cF cfv cX wcel cJ cF cfv cP cif cJ cF
      cfv wceq cJ cZ wcel cJ cF cfv cX wcel cJ cF cfv cP iftrue adantl eqtrd $.
      $( [28-May-2007] $) $( [27-May-2007] $)

    ${
      $d x A $.  $d j k x D $.  $d j k x F $.  $d j k x G $.  $d j k N $.
      $d j k x P $.  $d j k x X $.  $d j k x Z $.  $d h k z $.
      lmfexlem3.1 $e |- X = dom dom D $.
      lmfexlem3.3 $e |- N e. ZZ $.
      lmfexlem3.4 $e |- Z = ( ZZ>= ` N ) $.
      $( Lemma for ~ lmfex .  If ` F ` converges, so does the function ` G `
         constructed from it. $)
      lmfexlem3 $p |- ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) ->
           ( G : Z --> X /\ G ( ~~>m ` D ) P ) ) $=
        cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cZ cX cG wf cG cP cD
        clm cfv wbr cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cP cX wcel
        cZ cX cG wf cA cD cP cF cX lmfexlem3.1 lmcl vz cP vh cF cG cX cZ
        lmfexlem1.1 lmfexlem1 syl cD cme wcel cP cA wcel cF cP cD clm cfv wbr
        w3a cG cP cD clm cfv wbr cP cX wcel cc0 vx cv clt wbr vj cv vk cv cle
        wbr vk cv cG cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ wrex wi vx
        cr wral wa cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cP cX wcel
        cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cP cD co vx cv clt
        wbr wi vk cZ wral vj cZ wrex wi vx cr wral cA cD cP cF cX lmfexlem3.1
        lmcl cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cc0 vx cv clt wbr
        vj cv vk cv cle wbr vk cv cG cfv cP cD co vx cv clt wbr wi vk cZ wral
        vj cZ wrex wi vx cr cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a vx
        cv cr wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cP cD co
        vx cv clt wbr wi vk cZ wral vj cZ wrex cD cme wcel cP cA wcel cF cP cD
        clm cfv wbr w3a vx cv cr wcel cc0 vx cv clt wbr wa wa vj cv vk cv cle
        wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk
        cZ wral vj cZ wrex vj cv vk cv cle wbr vk cv cG cfv cP cD co vx cv clt
        wbr wi vk cZ wral vj cZ wrex cA cD cP vx cv vj vk cF cN cX cZ
        lmfexlem3.1 lmfexlem3.3 lmfexlem3.4 lmcvg vj cv vk cv cle wbr vk cv cF
        cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa wi vk cZ wral vj cv
        vk cv cle wbr vk cv cG cfv cP cD co vx cv clt wbr wi vk cZ wral vj cZ
        vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv
        clt wbr wa wi vj cv vk cv cle wbr vk cv cG cfv cP cD co vx cv clt wbr
        wi vk cZ vk cv cZ wcel vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv
        clt wbr wa vk cv cG cfv cP cD co vx cv clt wbr vj cv vk cv cle wbr vk
        cv cZ wcel vk cv cF cfv cX wcel vk cv cF cfv cP cD co vx cv clt wbr wa
        vk cv cG cfv cP cD co vx cv clt wbr vk cv cZ wcel vk cv cF cfv cX wcel
        vk cv cF cfv cP cD co vx cv clt wbr vk cv cG cfv cP cD co vx cv clt wbr
        vk cv cZ wcel vk cv cF cfv cX wcel wa vk cv cG cfv cP cD co vx cv clt
        wbr vk cv cF cfv cP cD co vx cv clt wbr vk cv cZ wcel vk cv cF cfv cX
        wcel wa vk cv cG cfv cP cD co vk cv cF cfv cP cD co vx cv clt vk cv cZ
        wcel vk cv cF cfv cX wcel wa vk cv cG cfv vk cv cF cfv cP cD vz cP vh
        cF cG vk cv cX cZ lmfexlem1.1 lmfexlem2 opreq1d breq1d biimpar anasss
        ex imim2d r19.20i r19.22si syl exp32 r19.21aiv jca cD cme wcel cP cA
        wcel cZ cX cG wf cG cP cD clm cfv wbr cP cX wcel cc0 vx cv clt wbr vj
        cv vk cv cle wbr vk cv cG cfv cP cD co vx cv clt wbr wi vk cZ wral vj
        cZ wrex wi vx cr wral wa wb cF cP cD clm cfv wbr vx cA cD cP vj vk cG
        cN cX cZ lmfexlem3.1 lmfexlem3.3 lmfexlem3.4 lmbrf cD cme wcel cP cA
        wcel cF cP cD clm cfv wbr w3a cP cX wcel cZ cX cG wf cA cD cP cF cX
        lmfexlem3.1 lmcl vz cP vh cF cG cX cZ lmfexlem1.1 lmfexlem1 syl
        syld3an3 mpbird jca $.
        $( [10-Dec-2007] $) $( [27-May-2007] $)
    $}
  $}

  ${
    $d g j k D $.  $d g h j k z F $.  $d j k N $.  $d g h j k z P $.
    $d j k Q $.  $d j k R $.  $d g h j k z X $.  $d g h j k z Z $.
    lmfex.1 $e |- X = dom dom D $.
    lmfex.3 $e |- N e. ZZ $.
    lmfex.4 $e |- Z = ( ZZ>= ` N ) $.
    $( If ` F ` (not necessarily a function) converges, there is a function
       ` g ` that converges to the same point. $)
    lmfex $p |- ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) -> E. g
         ( g : Z --> X /\ g ( ~~>m ` D ) P ) ) $=
      cD cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cZ cX vh cv cZ wcel vz cv
      vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh vz copab wf vh cv cZ
      wcel vz cv vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh vz copab
      cP cD clm cfv wbr wa cZ cX vg cv wf vg cv cP cD clm cfv wbr wa vg wex vz
      cA cD cP vh cF vh cv cZ wcel vz cv vh cv cF cfv cX wcel vh cv cF cfv cP
      cif wceq wa vh vz copab cN cX cZ vh cv cZ wcel vz cv vh cv cF cfv cX wcel
      vh cv cF cfv cP cif wceq wa vh vz copab eqid lmfex.1 lmfex.3 lmfex.4
      lmfexlem3 cZ cX vg cv wf vg cv cP cD clm cfv wbr wa cZ cX vh cv cZ wcel
      vz cv vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh vz copab wf vh
      cv cZ wcel vz cv vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh vz
      copab cP cD clm cfv wbr wa vg vh cv cZ wcel vz cv vh cv cF cfv cX wcel vh
      cv cF cfv cP cif wceq wa vh vz copab vh vz cZ vh cv cF cfv cX wcel vh cv
      cF cfv cP cif cZ cN cuz cfv cvv lmfex.4 cN cuz fvex eqeltri opabex2 vg cv
      vh cv cZ wcel vz cv vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh
      vz copab wceq cZ cX vg cv wf cZ cX vh cv cZ wcel vz cv vh cv cF cfv cX
      wcel vh cv cF cfv cP cif wceq wa vh vz copab wf vg cv cP cD clm cfv wbr
      vh cv cZ wcel vz cv vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh
      vz copab cP cD clm cfv wbr cZ cX vg cv vh cv cZ wcel vz cv vh cv cF cfv
      cX wcel vh cv cF cfv cP cif wceq wa vh vz copab feq1 vg cv vh cv cZ wcel
      vz cv vh cv cF cfv cX wcel vh cv cF cfv cP cif wceq wa vh vz copab cP cD
      clm cfv breq1 anbi12d cla4ev syl $.
      $( [10-Dec-2007] $) $( [27-May-2007] $)

    $( If the distance from each member of a converging sequence to a given
       point is less than or equal to a given amount, so is the convergence
       value.  _Warning:  The HTML proof page is 0.5MB in size_. $)
    lmle $p |- ( ( ( D e. Met /\ P e. A /\ F ( ~~>m ` D ) P ) /\ ( Q e. X /\
     R e. RR /\ A. k e. Z ( ( F ` k ) D Q ) <_ R ) ) -> ( P D Q ) <_ R ) $=
      cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel vk
      cv cF cfv cQ cD co cR cle wbr vk cZ wral w3a cP cQ cD co cR cle wbr cD
      cme wcel cP cA wcel cF cP cD clm cfv wbr w3a cD cme wcel cP cX wcel cF cP
      cD clm cfv wbr w3a cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co cR cle wbr
      vk cZ wral w3a wa cP cQ cD co cR cle wbr cR cP cQ cD co clt wbr wn cD cme
      wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel vk cv cF
      cfv cQ cD co cR cle wbr vk cZ wral w3a wa cR cP cQ cD co clt wbr cP cQ cD
      co cP cQ cD co clt wbr cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cR
      cr wcel cQ cX wcel cP cQ cD co cP cQ cD co clt wbr wn vk cv cF cfv cQ cD
      co cR cle wbr vk cZ wral cD cme wcel cP cX wcel cQ cX wcel cP cQ cD co cP
      cQ cD co clt wbr wn cF cP cD clm cfv wbr cD cme wcel cP cX wcel wa cQ cX
      wcel wa cP cQ cD co cr wcel cP cQ cD co cP cQ cD co clt wbr wn cD cme
      wcel cP cX wcel cQ cX wcel cP cQ cD co cr wcel cP cQ cD cX lmfex.1 metcl
      3expa cP cQ cD co ltnr syl 3adantl3 3ad2antr1 cD cme wcel cP cX wcel cF
      cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co cR cle
      wbr vk cZ wral w3a wa cR cP cQ cD co clt wbr cP cQ cD co cP cQ cD co clt
      wbr cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel
      vk cv cF cfv cQ cD co cR cle wbr vk cZ wral w3a wa cR cP cQ cD co clt wbr
      wa vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ
      cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc
      co cP cQ cD co clt wbr wa wa vj cZ wrex cP cQ cD co cP cQ cD co clt wbr
      cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel vk
      cv cF cfv cQ cD co cR cle wbr vk cZ wral w3a wa cR cP cQ cD co clt wbr wa
      vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cP cQ cD
      co cR cmin co clt wbr wa wi vk cZ wral vj cZ wrex vj cv cF cfv cX wcel cP
      cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cle wbr vj
      cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co clt wbr wa
      wa vj cZ wrex cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel
      cR cr wcel wa cR cP cQ cD co clt wbr vj cv vk cv cle wbr vk cv cF cfv cX
      wcel vk cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr wa wi vk cZ
      wral vj cZ wrex cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co cR cle wbr vk
      cZ wral w3a cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cP cQ cD co
      cR cmin co cr wcel cc0 cP cQ cD co cR cmin co clt wbr wa vj cv vk cv cle
      wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cP cQ cD co cR cmin co clt
      wbr wa wi vk cZ wral vj cZ wrex cD cme wcel cP cX wcel cF cP cD clm cfv
      wbr w3a cQ cX wcel cR cr wcel wa wa cR cP cQ cD co clt wbr wa cX cD cP cP
      cQ cD co cR cmin co vj vk cF cN cX cZ lmfex.1 lmfex.3 lmfex.4 lmcvg cD
      cme wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel wa cR
      cP cQ cD co clt wbr simpll cD cme wcel cP cX wcel wa cQ cX wcel cR cr
      wcel wa cR cP cQ cD co clt wbr cP cQ cD co cR cmin co cr wcel cc0 cP cQ
      cD co cR cmin co clt wbr wa cD cme wcel cP cX wcel cF cP cD clm cfv wbr
      w3a cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa wa cR cP cQ cD co
      clt wbr wa cP cQ cD co cR cmin co cr wcel cc0 cP cQ cD co cR cmin co clt
      wbr cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa wa cP cQ cD co cR
      cmin co cr wcel cR cP cQ cD co clt wbr cD cme wcel cP cX wcel wa cQ cX
      wcel cR cr wcel cP cQ cD co cR cmin co cr wcel cP cQ cD co cr wcel cR cr
      wcel cP cQ cD co cR cmin co cr wcel cD cme wcel cP cX wcel wa cQ cX wcel
      wa cP cQ cD co cR resubcl cD cme wcel cP cX wcel cQ cX wcel cP cQ cD co
      cr wcel cP cQ cD cX lmfex.1 metcl 3expa sylan anasss adantr cD cme wcel
      cP cX wcel wa cQ cX wcel cR cr wcel wa wa cR cP cQ cD co clt wbr cc0 cP
      cQ cD co cR cmin co clt wbr cR cr wcel cP cQ cD co cr wcel cR cP cQ cD co
      clt wbr cc0 cP cQ cD co cR cmin co clt wbr wb cD cme wcel cP cX wcel wa
      cQ cX wcel cR cr wcel wa wa cR cP cQ cD co posdif cD cme wcel cP cX wcel
      wa cQ cX wcel cR cr wcel simprr cD cme wcel cP cX wcel wa cQ cX wcel cP
      cQ cD co cr wcel cR cr wcel cD cme wcel cP cX wcel cQ cX wcel cP cQ cD co
      cr wcel cP cQ cD cX lmfex.1 metcl 3expa adantrr sylanc biimpa jca cD cme
      wcel cP cX wcel cF cP cD clm cfv wbr 3simpa sylanl1 sylanc cQ cX wcel cR
      cr wcel vk cv cF cfv cQ cD co cR cle wbr vk cZ wral 3simpa sylanl2 cD cme
      wcel cP cX wcel cF cP cD clm cfv wbr w3a cQ cX wcel cR cr wcel vk cv cF
      cfv cQ cD co cR cle wbr vk cZ wral w3a wa vj cv vk cv cle wbr vk cv cF
      cfv cX wcel vk cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr wa wi vk
      cZ wral vj cZ wrex vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co
      vj cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv
      cQ cD co caddc co cP cQ cD co clt wbr wa wa vj cZ wrex wi cR cP cQ cD co
      clt wbr cD cme wcel cP cX wcel cQ cX wcel cR cr wcel vk cv cF cfv cQ cD
      co cR cle wbr vk cZ wral w3a vj cv vk cv cle wbr vk cv cF cfv cX wcel vk
      cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr wa wi vk cZ wral vj cZ
      wrex vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv
      cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co
      caddc co cP cQ cD co clt wbr wa wa vj cZ wrex wi cF cP cD clm cfv wbr cD
      cme wcel cP cX wcel wa cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co cR cle
      wbr vk cZ wral w3a wa vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
      cfv cP cD co cP cQ cD co cR cmin co clt wbr wa wi vk cZ wral vj cv cF cfv
      cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co
      cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co
      clt wbr wa wa vj cZ cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel vk cv
      cF cfv cQ cD co cR cle wbr vk cZ wral w3a wa vj cv cZ wcel wa vj cv vk cv
      cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cP cQ cD co cR cmin co
      clt wbr wa wi vk cZ wral vj cv cF cfv cX wcel vj cv cF cfv cP cD co cP cQ
      cD co cR cmin co clt wbr wa vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv
      cP cD co vj cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj
      cv cF cfv cQ cD co caddc co cP cQ cD co clt wbr wa wa vj cv cZ wcel vj cv
      vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cP cQ cD co cR
      cmin co clt wbr wa wi vk cZ wral vj cv cF cfv cX wcel vj cv cF cfv cP cD
      co cP cQ cD co cR cmin co clt wbr wa wi cD cme wcel cP cX wcel wa cQ cX
      wcel cR cr wcel vk cv cF cfv cQ cD co cR cle wbr vk cZ wral w3a wa vj cv
      cZ wcel vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cP
      cQ cD co cR cmin co clt wbr wa wi vk cZ wral vj cv vj cv cle wbr vj cv cF
      cfv cX wcel vj cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr wa vj cv
      cZ wcel vj cv cN cuz cfv wcel vj cv vj cv cle wbr cZ cN cuz cfv vj cv
      lmfex.4 eleq2i vj cv cN cuz cfv wcel vj cv cz wcel vj cv cr wcel vj cv vj
      cv cle wbr cN vj cv eluzelz vj cv zre vj cv leid 3syl sylbi vj cv vk cv
      cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP cD co cP cQ cD co cR cmin co
      clt wbr wa wi vj cv vj cv cle wbr vj cv cF cfv cX wcel vj cv cF cfv cP cD
      co cP cQ cD co cR cmin co clt wbr wa wi vk vj cv cZ vk cv vj cv wceq vj
      cv vk cv cle wbr vj cv vj cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv cP
      cD co cP cQ cD co cR cmin co clt wbr wa vj cv cF cfv cX wcel vj cv cF cfv
      cP cD co cP cQ cD co cR cmin co clt wbr wa vk cv vj cv vj cv cle breq2 vk
      cv vj cv wceq vk cv cF cfv cX wcel vj cv cF cfv cX wcel vk cv cF cfv cP
      cD co cP cQ cD co cR cmin co clt wbr vj cv cF cfv cP cD co cP cQ cD co cR
      cmin co clt wbr vk cv vj cv wceq vk cv cF cfv vj cv cF cfv cX vk cv vj cv
      cF fveq2 eleq1d vk cv vj cv wceq vk cv cF cfv cP cD co vj cv cF cfv cP cD
      co cP cQ cD co cR cmin co clt vk cv vj cv wceq vk cv cF cfv vj cv cF cfv
      cP cD vk cv vj cv cF fveq2 opreq1d breq1d anbi12d imbi12d rcla4v mpid
      adantl cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel vk cv cF cfv cQ cD
      co cR cle wbr vk cZ wral w3a wa vj cv cZ wcel wa vj cv cF cfv cX wcel vj
      cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr cP cQ cD co vj cv cF
      cfv cP cD co vj cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co
      vj cv cF cfv cQ cD co caddc co cP cQ cD co clt wbr wa cD cme wcel cP cX
      wcel wa cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co cR cle wbr vk cZ wral
      w3a vj cv cZ wcel vj cv cF cfv cX wcel vj cv cF cfv cP cD co cP cQ cD co
      cR cmin co clt wbr cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD
      co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co
      cP cQ cD co clt wbr wa wi wi cD cme wcel cP cX wcel wa cQ cX wcel cR cr
      wcel vk cv cF cfv cQ cD co cR cle wbr vk cZ wral vj cv cZ wcel vj cv cF
      cfv cX wcel vj cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr cP cQ cD
      co vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cle wbr vj cv cF
      cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co clt wbr wa wi wi
      wi cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co
      cR cle wbr vk cZ wral vj cv cZ wcel vj cv cF cfv cX wcel vj cv cF cfv cP
      cD co cP cQ cD co cR cmin co clt wbr cP cQ cD co vj cv cF cfv cP cD co vj
      cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ
      cD co caddc co cP cQ cD co clt wbr wa wi wi wi wi vj cv cZ wcel vk cv cF
      cfv cQ cD co cR cle wbr vk cZ wral cD cme wcel cP cX wcel wa cQ cX wcel
      cR cr wcel wa wa vj cv cF cfv cX wcel vj cv cF cfv cP cD co cP cQ cD co
      cR cmin co clt wbr cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD
      co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co
      cP cQ cD co clt wbr wa wi wi vj cv cZ wcel vk cv cF cfv cQ cD co cR cle
      wbr vk cZ wral vj cv cF cfv cQ cD co cR cle wbr cD cme wcel cP cX wcel wa
      cQ cX wcel cR cr wcel wa wa vj cv cF cfv cX wcel vj cv cF cfv cP cD co cP
      cQ cD co cR cmin co clt wbr cP cQ cD co vj cv cF cfv cP cD co vj cv cF
      cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co
      caddc co cP cQ cD co clt wbr wa wi wi wi vk cv cF cfv cQ cD co cR cle wbr
      vj cv cF cfv cQ cD co cR cle wbr vk vj cv cZ vk cv vj cv wceq vk cv cF
      cfv cQ cD co vj cv cF cfv cQ cD co cR cle vk cv vj cv wceq vk cv cF cfv
      vj cv cF cfv cQ cD vk cv vj cv cF fveq2 opreq1d breq1d rcla4v cD cme wcel
      cP cX wcel wa cQ cX wcel cR cr wcel wa wa vj cv cF cfv cX wcel vj cv cF
      cfv cP cD co cP cQ cD co cR cmin co clt wbr vj cv cF cfv cQ cD co cR cle
      wbr cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cle
      wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co clt
      wbr wa cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa wa vj cv cF cfv
      cX wcel vj cv cF cfv cP cD co cP cQ cD co cR cmin co clt wbr vj cv cF cfv
      cQ cD co cR cle wbr cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD
      co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co
      cP cQ cD co clt wbr wa cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa
      wa vj cv cF cfv cX wcel wa vj cv cF cfv cP cD co cP cQ cD co cR cmin co
      clt wbr vj cv cF cfv cQ cD co cR cle wbr wa vj cv cF cfv cP cD co vj cv
      cF cfv cQ cD co caddc co cP cQ cD co clt wbr cP cQ cD co vj cv cF cfv cP
      cD co vj cv cF cfv cQ cD co caddc co cle wbr cD cme wcel cP cX wcel wa cQ
      cX wcel cR cr wcel wa wa vj cv cF cfv cX wcel wa vj cv cF cfv cP cD co cP
      cQ cD co cR cmin co clt wbr vj cv cF cfv cQ cD co cR cle wbr wa vj cv cF
      cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co cR cmin co cR
      caddc co clt wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cP
      cQ cD co clt wbr vj cv cF cfv cP cD co cr wcel vj cv cF cfv cQ cD co cr
      wcel cP cQ cD co cR cmin co cr wcel cR cr wcel vj cv cF cfv cP cD co cP
      cQ cD co cR cmin co clt wbr vj cv cF cfv cQ cD co cR cle wbr wa vj cv cF
      cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co cR cmin co cR
      caddc co clt wbr wi cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa wa
      vj cv cF cfv cX wcel wa vj cv cF cfv cP cD co vj cv cF cfv cQ cD co cP cQ
      cD co cR cmin co cR ltleadd cD cme wcel cP cX wcel wa vj cv cF cfv cX
      wcel vj cv cF cfv cP cD co cr wcel cQ cX wcel cR cr wcel wa cD cme wcel
      cP cX wcel vj cv cF cfv cX wcel vj cv cF cfv cP cD co cr wcel cD cme wcel
      vj cv cF cfv cX wcel cP cX wcel vj cv cF cfv cP cD co cr wcel vj cv cF
      cfv cP cD cX lmfex.1 metcl 3com23 3expa adantlr cD cme wcel cP cX wcel wa
      cQ cX wcel vj cv cF cfv cX wcel vj cv cF cfv cQ cD co cr wcel cR cr wcel
      cD cme wcel cQ cX wcel vj cv cF cfv cX wcel vj cv cF cfv cQ cD co cr wcel
      cP cX wcel cD cme wcel cQ cX wcel vj cv cF cfv cX wcel vj cv cF cfv cQ cD
      co cr wcel cD cme wcel vj cv cF cfv cX wcel cQ cX wcel vj cv cF cfv cQ cD
      co cr wcel vj cv cF cfv cQ cD cX lmfex.1 metcl 3com23 3expa adantllr
      adantlrr cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa wa cP cQ cD
      co cR cmin co cr wcel vj cv cF cfv cX wcel cD cme wcel cP cX wcel wa cQ
      cX wcel cR cr wcel cP cQ cD co cR cmin co cr wcel cP cQ cD co cr wcel cR
      cr wcel cP cQ cD co cR cmin co cr wcel cD cme wcel cP cX wcel wa cQ cX
      wcel wa cP cQ cD co cR resubcl cD cme wcel cP cX wcel cQ cX wcel cP cQ cD
      co cr wcel cP cQ cD cX lmfex.1 metcl 3expa sylan anasss adantr cD cme
      wcel cP cX wcel wa cQ cX wcel cR cr wcel vj cv cF cfv cX wcel simplrr
      syl2anc cD cme wcel cP cX wcel wa cQ cX wcel cR cr wcel wa wa vj cv cF
      cfv cX wcel wa cP cQ cD co cR cmin co cR caddc co cP cQ cD co vj cv cF
      cfv cP cD co vj cv cF cfv cQ cD co caddc co clt cD cme wcel cP cX wcel wa
      cQ cX wcel cR cr wcel wa wa cP cQ cD co cR cmin co cR caddc co cP cQ cD
      co wceq vj cv cF cfv cX wcel cD cme wcel cP cX wcel wa cQ cX wcel cR cr
      wcel cP cQ cD co cR cmin co cR caddc co cP cQ cD co wceq cP cQ cD co cc
      wcel cR cc wcel cP cQ cD co cR cmin co cR caddc co cP cQ cD co wceq cD
      cme wcel cP cX wcel wa cQ cX wcel wa cR cr wcel cP cQ cD co cR npcan cD
      cme wcel cP cX wcel wa cQ cX wcel wa cP cQ cD co cD cme wcel cP cX wcel
      cQ cX wcel cP cQ cD co cr wcel cP cQ cD cX lmfex.1 metcl 3expa recnd cR
      recn syl2an anasss adantr breq2d sylibd cD cme wcel cP cX wcel wa cQ cX
      wcel vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv
      cQ cD co caddc co cle wbr cR cr wcel cD cme wcel cP cX wcel wa cQ cX wcel
      vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD
      co caddc co cle wbr cP cQ vj cv cF cfv cD cX lmfex.1 mettri4 anassrs
      adantlrr jctild exp4b com4r syl6 com13 exp32 3impd imp31 imdistand syld
      r19.22dva 3adantl3 adantr mpd cD cme wcel cP cX wcel cF cP cD clm cfv wbr
      w3a cQ cX wcel cR cr wcel vk cv cF cfv cQ cD co cR cle wbr vk cZ wral w3a
      wa vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ
      cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc
      co cP cQ cD co clt wbr wa wa vj cZ wrex cP cQ cD co cP cQ cD co clt wbr
      wi cR cP cQ cD co clt wbr cD cme wcel cP cX wcel cF cP cD clm cfv wbr w3a
      cR cr wcel cQ cX wcel vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD
      co vj cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF
      cfv cQ cD co caddc co cP cQ cD co clt wbr wa wa vj cZ wrex cP cQ cD co cP
      cQ cD co clt wbr wi vk cv cF cfv cQ cD co cR cle wbr vk cZ wral cD cme
      wcel cP cX wcel cQ cX wcel vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv
      cP cD co vj cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj
      cv cF cfv cQ cD co caddc co cP cQ cD co clt wbr wa wa vj cZ wrex cP cQ cD
      co cP cQ cD co clt wbr wi cF cP cD clm cfv wbr cD cme wcel cP cX wcel wa
      cQ cX wcel wa vj cv cF cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj
      cv cF cfv cQ cD co caddc co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ
      cD co caddc co cP cQ cD co clt wbr wa wa cP cQ cD co cP cQ cD co clt wbr
      vj cZ cD cme wcel cP cX wcel wa cQ cX wcel wa vj cv cZ wcel wa vj cv cF
      cfv cX wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc
      co cle wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD
      co clt wbr wa cP cQ cD co cP cQ cD co clt wbr cP cQ cD co cr wcel vj cv
      cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cr wcel cP cQ cD co cr
      wcel cP cQ cD co vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cle
      wbr vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co clt
      wbr wa cP cQ cD co cP cQ cD co clt wbr wi cD cme wcel cP cX wcel wa cQ cX
      wcel wa vj cv cZ wcel wa vj cv cF cfv cX wcel wa cP cQ cD co vj cv cF cfv
      cP cD co vj cv cF cfv cQ cD co caddc co cP cQ cD co lelttr cD cme wcel cP
      cX wcel wa cQ cX wcel wa cP cQ cD co cr wcel vj cv cZ wcel vj cv cF cfv
      cX wcel cD cme wcel cP cX wcel cQ cX wcel cP cQ cD co cr wcel cP cQ cD cX
      lmfex.1 metcl 3expa ad2antrr cD cme wcel cP cX wcel wa cQ cX wcel wa vj
      cv cF cfv cX wcel vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cr
      wcel vj cv cZ wcel vj cv cF cfv cP cD co cr wcel vj cv cF cfv cQ cD co cr
      wcel vj cv cF cfv cP cD co vj cv cF cfv cQ cD co caddc co cr wcel cD cme
      wcel cP cX wcel wa cQ cX wcel wa vj cv cF cfv cX wcel wa vj cv cF cfv cP
      cD co vj cv cF cfv cQ cD co readdcl cD cme wcel cP cX wcel wa vj cv cF
      cfv cX wcel vj cv cF cfv cP cD co cr wcel cQ cX wcel cD cme wcel cP cX
      wcel vj cv cF cfv cX wcel vj cv cF cfv cP cD co cr wcel cD cme wcel vj cv
      cF cfv cX wcel cP cX wcel vj cv cF cfv cP cD co cr wcel vj cv cF cfv cP
      cD cX lmfex.1 metcl 3com23 3expa adantlr cD cme wcel cQ cX wcel vj cv cF
      cfv cX wcel vj cv cF cfv cQ cD co cr wcel cP cX wcel cD cme wcel cQ cX
      wcel vj cv cF cfv cX wcel vj cv cF cfv cQ cD co cr wcel cD cme wcel vj cv
      cF cfv cX wcel cQ cX wcel vj cv cF cfv cQ cD co cr wcel vj cv cF cfv cQ
      cD cX lmfex.1 metcl 3com23 3expa adantllr sylanc adantlr cD cme wcel cP
      cX wcel wa cQ cX wcel wa cP cQ cD co cr wcel vj cv cZ wcel vj cv cF cfv
      cX wcel cD cme wcel cP cX wcel cQ cX wcel cP cQ cD co cr wcel cP cQ cD cX
      lmfex.1 metcl 3expa ad2antrr syl3anc expimpd r19.23adva 3adantl3
      3ad2antr1 adantr mpd ex mtod cD cme wcel cP cX wcel cF cP cD clm cfv wbr
      w3a cQ cX wcel cR cr wcel cP cQ cD co cR cle wbr cR cP cQ cD co clt wbr
      wn wb vk cv cF cfv cQ cD co cR cle wbr vk cZ wral cD cme wcel cP cX wcel
      cQ cX wcel cR cr wcel wa cP cQ cD co cR cle wbr cR cP cQ cD co clt wbr wn
      wb cF cP cD clm cfv wbr cP cQ cD co cr wcel cR cr wcel cP cQ cD co cR cle
      wbr cR cP cQ cD co clt wbr wn wb cD cme wcel cP cX wcel wa cQ cX wcel cR
      cr wcel wa wa cP cQ cD co cR lenlt cD cme wcel cP cX wcel wa cQ cX wcel
      cP cQ cD co cr wcel cR cr wcel cD cme wcel cP cX wcel cQ cX wcel cP cQ cD
      co cr wcel cP cQ cD cX lmfex.1 metcl 3expa adantrr cD cme wcel cP cX wcel
      wa cQ cX wcel cR cr wcel simprr sylanc 3adantl3 3adantr3 mpbird cD cme
      wcel cP cA wcel cF cP cD clm cfv wbr w3a cD cme wcel cP cX wcel cF cP cD
      clm cfv wbr cD cme wcel cP cA wcel cF cP cD clm cfv wbr 3simp1 cA cD cP
      cF cX lmfex.1 lmcl cD cme wcel cP cA wcel cF cP cD clm cfv wbr 3simp3
      3jca sylan $.
      $( [24-Dec-2007] $) $( [23-Dec-2007] $)
  $}

  ${
    $d f x D $.
    $( A complete metric space is a metric space. $)
    cmsmet $p |- ( D e. CMet -> D e. Met ) $=
      cD cms wcel cD cme wcel vf cv vx cv cD clm cfv wbr vx cD cdm cdm wrex vf
      cD cca cfv wral vx cD vf cD cdm cdm cD cdm cdm eqid iscms pm3.26bi $.
      $( [9-Nov-2007] $) $( [18-Dec-2006] $)
  $}

  ${
    cmsmeti.1 $e |- D e. CMet $.
    $( A complete metric space is a metric space. $)
    cmsmeti $p |- D e. Met $=
      cD cms wcel cD cme wcel cmsmeti.1 cD cmsmet ax-mp $.
      $( [10-Nov-2007] $) $( [26-Oct-2007] $)
  $}

  ${
    $d j k w x y z F $.  $d j k w D $.  $d j k w x y z P $.
    lmclim.1 $e |- D = ( abs o. - ) $.
    $( Relate a limit on the metric space of complex numbers to our complex
       number limit notation. $)
    lmclim $p |- ( P e. A ->
                 ( F ( ~~>m ` D ) P <-> ( F C_ ( CC X. CC ) /\ F ~~> P ) ) ) $=
      cP cA wcel cF cP cD clm cfv wbr cF cc cc cxp wss cP cc wcel cc0 vw cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv
      clt wbr wa wi vk cz wral vj cz wrex wi vw cr wral w3a cF cc cc cxp wss cF
      cP cli wbr wa cD cme wcel cP cA wcel cF cP cD clm cfv wbr cF cc cc cxp
      wss cP cc wcel cc0 vw cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel
      vk cv cF cfv cP cD co vw cv clt wbr wa wi vk cz wral vj cz wrex wi vw cr
      wral w3a wb cD lmclim.1 cnmet vw cA cD cP vj vk cF cc cD lmclim.1 cnmetba
      lmbr mpan cP cA wcel cF cc cc cxp wss cP cc wcel cc0 vw cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa
      wi vk cz wral vj cz wrex wi vw cr wral wa wa cF cc cc cxp wss cF cP cli
      wbr wa cF cc cc cxp wss cP cc wcel cc0 vw cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa wi vk cz wral
      vj cz wrex wi vw cr wral w3a cP cA wcel cF cc cc cxp wss cP cc wcel cc0
      vw cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD
      co vw cv clt wbr wa wi vk cz wral vj cz wrex wi vw cr wral wa cF cP cli
      wbr cF cc cc cxp wss cP cA wcel cP cc wcel cc0 vw cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa wi vk
      cz wral vj cz wrex wi vw cr wral wa cF cP cli wbr wb cF cc cc cxp wss cP
      cA wcel wa cF cP cli wbr cP cc wcel cc0 vw cv clt wbr vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv cP cmin co cabs cfv vw cv clt wbr wa wi
      vk cz wral vj cz wrex wi vw cr wral wa cP cc wcel cc0 vw cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa
      wi vk cz wral vj cz wrex wi vw cr wral wa cF cvv wcel cP cA wcel cF cP
      cli wbr cP cc wcel cc0 vw cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cc
      wcel vk cv cF cfv cP cmin co cabs cfv vw cv clt wbr wa wi vk cz wral vj
      cz wrex wi vw cr wral wa wb cF cc cc cxp wss vw cP cvv cA vj vk cF clim
      cF cc cc cxp cc cc axcnex axcnex xpex ssex sylan cP cc wcel cc0 vw cv clt
      wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv
      clt wbr wa wi vk cz wral vj cz wrex wi vw cr wral cc0 vw cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cmin co cabs cfv vw cv
      clt wbr wa wi vk cz wral vj cz wrex wi vw cr wral cP cc wcel cc0 vw cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw
      cv clt wbr wa wi vk cz wral vj cz wrex wi cc0 vw cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cmin co cabs cfv vw cv clt
      wbr wa wi vk cz wral vj cz wrex wi vw cr cP cc wcel vj cv vk cv cle wbr
      vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa wi vk cz wral
      vj cz wrex vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cmin
      co cabs cfv vw cv clt wbr wa wi vk cz wral vj cz wrex cc0 vw cv clt wbr
      cP cc wcel vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv cP cD co
      vw cv clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cc wcel vk cv cF cfv
      cP cmin co cabs cfv vw cv clt wbr wa wi vj vk cz cz cP cc wcel vk cv cF
      cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa vk cv cF cfv cc wcel
      vk cv cF cfv cP cmin co cabs cfv vw cv clt wbr wa vj cv vk cv cle wbr cP
      cc wcel vk cv cF cfv cc wcel vk cv cF cfv cP cD co vw cv clt wbr vk cv cF
      cfv cP cmin co cabs cfv vw cv clt wbr cP cc wcel vk cv cF cfv cc wcel wa
      vk cv cF cfv cP cD co vk cv cF cfv cP cmin co cabs cfv vw cv clt vk cv cF
      cfv cc wcel cP cc wcel vk cv cF cfv cP cD co vk cv cF cfv cP cmin co cabs
      cfv wceq vk cv cF cfv cP cD lmclim.1 cnmetdval ancoms breq1d pm5.32da
      imbi2d rexralbidv imbi2d ralbidv pm5.32i syl6rbbr ancoms pm5.32da cF cc
      cc cxp wss cP cc wcel cc0 vw cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cc wcel vk cv cF cfv cP cD co vw cv clt wbr wa wi vk cz wral vj cz wrex
      wi vw cr wral 3anass syl5bb bitrd $.
      $( [1-Oct-2007] $) $( [9-Dec-2006] $)

    $( Relate a limit on the metric space of complex numbers to our complex
       number limit notation. $)
    lmclimnn $p |- ( ( P e. A /\ F : NN --> CC ) ->
                 ( F ( ~~>m ` D ) P <-> F ~~> P ) ) $=
      cP cA wcel cF cP cD clm cfv wbr cF cc cc cxp wss cF cP cli wbr wa cn cc
      cF wf cF cP cli wbr cA cD cP cF lmclim.1 lmclim cn cc cF wf cF cP cli wbr
      cF cc cc cxp wss cF cP cli wbr wa cn cc cF wf cF cc cc cxp wss cF cP cli
      wbr cF cn cc cxp wss cn cc cxp cc cc cxp wss cF cc cc cxp wss cn cc cF wf
      cF cn cc cxp cc cc cxp sstr cn cc cF fssxp cn cc wss cc cc wss cn cc cxp
      cc cc cxp wss nnsscn cc ssid cn cc cc cc ssxp mp2an sylancl biantrurd
      bicomd sylan9bb $.
      $( [2-Oct-2007] $) $( [24-Jul-2007] $)
  $}

  ${
    $d f j k n r y D $.  $d f j n r y J $.  $d f j n r y M $.
    $d f j k n r y P $.  $d f j k n r y X $.
    metelcls.1 $e |- X = dom dom D $.
    metelcls.2 $e |- J = ( Open ` D ) $.
    metelcls.3 $e |- P e. _V $.
    $( A point belongs to the closure of a subset iff there is a sequence in
       the subset converging to it.  Theorem 1.4-6(a) of [Kreyszig] p. 30.
       _Warning:  The HTML proof page is 0.5MB in size_. $)
    metelcls $p |- ( ( D e. Met /\ M C_ X ) -> ( P e. ( ( cls ` J ) ` M ) <->
            E. f ( f : NN --> M /\ f ( ~~>m ` D ) P ) ) ) $=
      cD cme wcel cM cX wss wa cP cM cJ ccl cfv cfv wcel cn cM vf cv wf vf cv
      cP cD clm cfv wbr wa vf wex cD cme wcel cM cX wss wa cP cM cJ ccl cfv cfv
      wcel cn cM vf cv wf vf cv cP cD clm cfv wbr wa vf wex cD cme wcel cM cX
      wss wa cP cM cJ ccl cfv cfv wcel wa cP cM wcel cn cM vf cv wf vf cv cP cD
      clm cfv wbr wa vf wex cD cme wcel cM cX wss wa cP cM wcel cn cM vf cv wf
      vf cv cP cD clm cfv wbr wa vf wex cP cM cJ ccl cfv cfv wcel cn cM cn cP
      csn cxp wf cn cP csn cxp cP cD clm cfv wbr cn cM vf cv wf vf cv cP cD clm
      cfv wbr wa vf wex cD cme wcel cM cX wss wa cP cM wcel wa cn cM vf cv wf
      vf cv cP cD clm cfv wbr wa cn cM cn cP csn cxp wf cn cP csn cxp cP cD clm
      cfv wbr wa vf cn cP csn cxp cn cP csn nnex cP snex xpex vf cv cn cP csn
      cxp wceq cn cM vf cv wf cn cM cn cP csn cxp wf vf cv cP cD clm cfv wbr cn
      cP csn cxp cP cD clm cfv wbr cn cM vf cv cn cP csn cxp feq1 vf cv cn cP
      csn cxp cP cD clm cfv breq1 anbi12d cla4ev cP cM wcel cn cM cn cP csn cxp
      wf cD cme wcel cM cX wss wa cn cP csn cn cP csn cxp wf cP csn cM wss cn
      cM cn cP csn cxp wf cP cM wcel cn cP csn cM cn cP csn cxp fss cn cP
      metelcls.3 fconst cP cM snssi sylancr adantl cD cme wcel cM cX wss cP cM
      wcel cn cP csn cxp cP cD clm cfv wbr cD cme wcel cP cX wcel cn cP csn cxp
      cP cD clm cfv wbr cM cX wss cP cM wcel wa cD cP c1 cX cn metelcls.1 1z
      nnuz lmconst cM cX cP ssel2 sylan2 anassrs sylanc adantlr cD cme wcel cM
      cX wss wa cP cM cJ ccl cfv cfv wcel cP cM wcel wn cn cM vf cv wf vf cv cP
      cD clm cfv wbr wa vf wex cD cme wcel cM cX wss wa cP cM cJ ccl cfv cfv
      wcel cP cM wcel wn wa cP cM cJ clp cfv cfv wcel cn cM vf cv wf vf cv cP
      cD clm cfv wbr wa vf wex cJ ctop wcel cM cJ cuni wss wa cP cM cJ ccl cfv
      cfv wcel cP cM wcel wn wa cP cM cJ clp cfv cfv wcel cD cme wcel cM cX wss
      wa cP cM cJ cJ cuni cJ cuni eqid islpi cD cme wcel cM cX wss wa cJ ctop
      wcel cM cJ cuni wss cD cme wcel cJ ctop wcel cM cX wss cD cJ metelcls.2
      opntop adantr cD cme wcel cM cJ cuni wss cM cX wss cD cme wcel cJ cuni cX
      cM cD cJ cX metelcls.1 metelcls.2 uniopn2 sseq2d biimpar jca sylan cD cme
      wcel cM cX wss wa cP cM cJ clp cfv cfv wcel wa cn cM vf cv wf vj cv vf cv
      cfv cP c1 vj cv cdiv co cD cbl cfv co wcel vj cn wral wa vf wex cn cM vf
      cv wf vf cv cP cD clm cfv wbr wa vf wex cD cme wcel cM cX wss wa cP cM cJ
      clp cfv cfv wcel wa vy cv cP c1 vj cv cdiv co cD cbl cfv co wcel vy cM
      wrex vj cn wral cn cM vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co cD cbl
      cfv co wcel vj cn wral wa vf wex cD cme wcel cM cX wss cP cM cJ clp cfv
      cfv wcel vy cv cP c1 vj cv cdiv co cD cbl cfv co wcel vy cM wrex vj cn
      wral cD cme wcel cM cX wss cP cM cJ clp cfv cfv wcel w3a vy cv cP c1 vj
      cv cdiv co cD cbl cfv co wcel vy cM wrex vj cn cD cme wcel cM cX wss cP
      cM cJ clp cfv cfv wcel w3a c1 vj cv cdiv co cr wcel cc0 c1 vj cv cdiv co
      clt wbr wa vy cv cP c1 vj cv cdiv co cD cbl cfv co wcel vy cM wrex vj cv
      cn wcel vy cD cP c1 vj cv cdiv co cM cJ cX metelcls.1 metelcls.2 lpbl vj
      cv cn wcel c1 vj cv cdiv co cr wcel cc0 c1 vj cv cdiv co clt wbr vj cv
      nnrecre vj cv nnrecgt0 jca sylan2 r19.21aiva 3expa vy cv cP c1 vj cv cdiv
      co cD cbl cfv co wcel vj cv vf cv cfv cP c1 vj cv cdiv co cD cbl cfv co
      wcel vj vy cn cM vf nnex vy cv vj cv vf cv cfv cP c1 vj cv cdiv co cD cbl
      cfv co eleq1 ac6s syl cD cme wcel cM cX wss wa cP cM cJ clp cfv cfv wcel
      cP cX wcel cn cM vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co cD cbl cfv
      co wcel vj cn wral wa vf wex cn cM vf cv wf vf cv cP cD clm cfv wbr wa vf
      wex wi cM cJ clp cfv cfv cX wss cP cM cJ clp cfv cfv wcel cP cX wcel cD
      cme wcel cM cX wss wa cM cJ clp cfv cfv cX cP ssel2 cD cme wcel cM cX wss
      wa cM cJ clp cfv cfv cJ cuni cX cJ ctop wcel cM cJ cuni wss cM cJ clp cfv
      cfv cJ cuni wss cD cme wcel cM cX wss wa cM cJ cJ cuni cJ cuni eqid lpss
      cD cme wcel cJ ctop wcel cM cX wss cD cJ metelcls.2 opntop adantr cD cme
      wcel cM cJ cuni wss cM cX wss cD cme wcel cJ cuni cX cM cD cJ cX
      metelcls.1 metelcls.2 uniopn2 sseq2d biimpar sylanc cD cme wcel cJ cuni
      cX wceq cM cX wss cD cJ cX metelcls.1 metelcls.2 uniopn2 adantr sseqtrd
      sylan cD cme wcel cM cX wss wa cP cX wcel wa cn cM vf cv wf vj cv vf cv
      cfv cP c1 vj cv cdiv co cD cbl cfv co wcel vj cn wral wa cn cM vf cv wf
      vf cv cP cD clm cfv wbr wa vf cD cme wcel cM cX wss wa cP cX wcel wa cn
      cM vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co cD cbl cfv co wcel vj cn
      wral wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa cD cme wcel cM cX wss
      wa cP cX wcel wa cn cM vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co cD
      cbl cfv co wcel vj cn wral wa wa cn cM vf cv wf vf cv cP cD clm cfv wbr
      cD cme wcel cM cX wss wa cP cX wcel wa cn cM vf cv wf vj cv vf cv cfv cP
      c1 vj cv cdiv co cD cbl cfv co wcel vj cn wral simprl cD cme wcel cM cX
      wss wa cP cX wcel wa cn cM vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co
      cD cbl cfv co wcel vj cn wral wa cn cX vf cv wf vj cv vf cv cfv cP cD co
      c1 vj cv cdiv co clt wbr vj cn wral wa vf cv cP cD clm cfv wbr cD cme
      wcel cM cX wss wa cP cX wcel wa cn cM vf cv wf vj cv vf cv cfv cP c1 vj
      cv cdiv co cD cbl cfv co wcel vj cn wral wa cn cX vf cv wf vj cv vf cv
      cfv cP cD co c1 vj cv cdiv co clt wbr vj cn wral wa cD cme wcel cM cX wss
      wa cP cX wcel wa cn cM vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co cD
      cbl cfv co wcel vj cn wral wa cn cX vf cv wf vj cv vf cv cfv cP c1 vj cv
      cdiv co cD cbl cfv co wcel vj cn wral wa cn cX vf cv wf vj cv vf cv cfv
      cP cD co c1 vj cv cdiv co clt wbr vj cn wral wa cD cme wcel cM cX wss wa
      cP cX wcel wa cn cM vf cv wf cn cX vf cv wf vj cv vf cv cfv cP c1 vj cv
      cdiv co cD cbl cfv co wcel vj cn wral cD cme wcel cM cX wss wa cn cM vf
      cv wf cn cX vf cv wf wi cP cX wcel cM cX wss cn cM vf cv wf cn cX vf cv
      wf wi cD cme wcel cn cM vf cv wf cM cX wss cn cX vf cv wf cn cM vf cv wf
      cM cX wss cn cX vf cv wf cn cM cX vf cv fss ex com12 adantl adantr anim1d
      cD cme wcel cP cX wcel cn cX vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co
      cD cbl cfv co wcel vj cn wral wa cn cX vf cv wf vj cv vf cv cfv cP cD co
      c1 vj cv cdiv co clt wbr vj cn wral wa wb cM cX wss cD cme wcel cP cX
      wcel wa cn cX vf cv wf vj cv vf cv cfv cP c1 vj cv cdiv co cD cbl cfv co
      wcel vj cn wral vj cv vf cv cfv cP cD co c1 vj cv cdiv co clt wbr vj cn
      wral cD cme wcel cP cX wcel wa cn cX vf cv wf wa vj cv vf cv cfv cP c1 vj
      cv cdiv co cD cbl cfv co wcel vj cv vf cv cfv cP cD co c1 vj cv cdiv co
      clt wbr vj cn cD cme wcel cP cX wcel vj cv vf cv cfv cX wcel w3a c1 vj cv
      cdiv co cr wcel cc0 c1 vj cv cdiv co clt wbr wa vj cv vf cv cfv cP c1 vj
      cv cdiv co cD cbl cfv co wcel vj cv vf cv cfv cP cD co c1 vj cv cdiv co
      clt wbr wb cD cme wcel cP cX wcel wa cn cX vf cv wf wa vj cv cn wcel wa
      vj cv vf cv cfv cD cP c1 vj cv cdiv co cX metelcls.1 elbl3 cD cme wcel cP
      cX wcel wa cn cX vf cv wf vj cv cn wcel cD cme wcel cP cX wcel vj cv vf
      cv cfv cX wcel w3a cD cme wcel cP cX wcel wa vj cv vf cv cfv cX wcel cD
      cme wcel cP cX wcel vj cv vf cv cfv cX wcel w3a cn cX vf cv wf vj cv cn
      wcel wa cD cme wcel cP cX wcel vj cv vf cv cfv cX wcel cD cme wcel cP cX
      wcel vj cv vf cv cfv cX wcel w3a cD cme wcel cP cX wcel vj cv vf cv cfv
      cX wcel w3a id 3expa cn cX vj cv vf cv ffvelrn sylan2 anassrs vj cv cn
      wcel c1 vj cv cdiv co cr wcel cc0 c1 vj cv cdiv co clt wbr wa cD cme wcel
      cP cX wcel wa cn cX vf cv wf wa vj cv cn wcel c1 vj cv cdiv co cr wcel
      cc0 c1 vj cv cdiv co clt wbr vj cv nnrecre vj cv nnrecgt0 jca adantl
      sylanc ralbidva pm5.32da adantlr sylibd imp cD cme wcel cP cX wcel cn cX
      vf cv wf vj cv vf cv cfv cP cD co c1 vj cv cdiv co clt wbr vj cn wral wa
      vf cv cP cD clm cfv wbr cM cX wss cD cP vj vf cv cX metelcls.1 lmnn
      adantllr syldan jca ex 19.22dv syldan mpd syldan anassrs pm2.61dan ex cD
      cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa cP cM cJ
      ccl cfv cfv wcel vf cD cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD
      clm cfv wbr wa cP cM cJ ccl cfv cfv wcel cD cme wcel cM cX wss wa cn cM
      vf cv wf vf cv cP cD clm cfv wbr wa wa cP cM cM cJ clp cfv cfv cun cM cJ
      ccl cfv cfv cD cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv
      wbr wa wa cP cM wcel cP cM cJ clp cfv cfv wcel wo cP cM cM cJ clp cfv cfv
      cun wcel cD cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr
      wa wa cP cM wcel cP cM cJ clp cfv cfv wcel cD cme wcel cM cX wss wa cn cM
      vf cv wf vf cv cP cD clm cfv wbr wa wa cP cM wcel wn cP cM cJ clp cfv cfv
      wcel cD cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa
      wa cP cM wcel wn wa cP cM cJ clp cfv cfv wcel vn cv cM cP csn cdif cin c0
      wne vn cP csn cJ cnei cfv cfv wral cD cme wcel cM cX wss wa cn cM vf cv
      wf vf cv cP cD clm cfv wbr wa wa cP cM wcel wn wa vn cv cM cP csn cdif
      cin c0 wne vn cP csn cJ cnei cfv cfv cD cme wcel cM cX wss wa cn cM vf cv
      wf vf cv cP cD clm cfv wbr wa wa cP cM wcel wn wa vn cv cP csn cJ cnei
      cfv cfv wcel vn cv cX wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co vn cv
      wss wa vr cr wrex wa vn cv cM cP csn cdif cin c0 wne cD cme wcel cM cX
      wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa vn cv cP csn cJ cnei
      cfv cfv wcel vn cv cX wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co vn cv
      wss wa vr cr wrex wa wb cP cM wcel wn cD cme wcel vf cv cP cD clm cfv wbr
      vn cv cP csn cJ cnei cfv cfv wcel vn cv cX wss cc0 vr cv clt wbr cP vr cv
      cD cbl cfv co vn cv wss wa vr cr wrex wa wb cM cX wss cn cM vf cv wf cD
      cme wcel vf cv cP cD clm cfv wbr cP cX wcel vn cv cP csn cJ cnei cfv cfv
      wcel vn cv cX wss cc0 vr cv clt wbr cP vr cv cD cbl cfv co vn cv wss wa
      vr cr wrex wa wb cD cme wcel cP cvv wcel vf cv cP cD clm cfv wbr cP cX
      wcel metelcls.3 cvv cD cP vf cv cX metelcls.1 lmcl mp3an2 cD cP cJ vn cv
      cX vr metelcls.1 metelcls.2 neibl syldan ad2ant2rl adantr cD cme wcel cM
      cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa cP cM wcel wn wa
      cc0 vr cv clt wbr cP vr cv cD cbl cfv co vn cv wss wa vr cr wrex vn cv cM
      cP csn cdif cin c0 wne vn cv cX wss cD cme wcel cM cX wss wa cn cM vf cv
      wf vf cv cP cD clm cfv wbr wa wa cP cM wcel wn wa cc0 vr cv clt wbr cP vr
      cv cD cbl cfv co vn cv wss wa vn cv cM cP csn cdif cin c0 wne vr cr cD
      cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa cP cM
      wcel wn wa vr cv cr wcel cc0 vr cv clt wbr cP vr cv cD cbl cfv co vn cv
      wss wa vn cv cM cP csn cdif cin c0 wne cD cme wcel vf cv cP cD clm cfv
      wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD cbl cfv co vn cv
      wss wa cP cM wcel wn wa cn cM vf cv wf cM cX wss wa vn cv cM cP csn cdif
      cin c0 wne cD cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv
      wbr wa wa cP cM wcel wn wa vr cv cr wcel cc0 vr cv clt wbr cP vr cv cD
      cbl cfv co vn cv wss wa wa wa cD cme wcel vf cv cP cD clm cfv wbr wa vr
      cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD cbl cfv co vn cv wss wa cP
      cM wcel wn wa cn cM vf cv wf cM cX wss wa wa vj cv vf cv cfv cP cD co vr
      cv clt wbr vj cn wrex vn cv cM cP csn cdif cin c0 wne cD cme wcel vf cv
      cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD
      cbl cfv co vn cv wss wa vj cv vf cv cfv cP cD co vr cv clt wbr vj cn wrex
      cP cM wcel wn cn cM vf cv wf cM cX wss wa cD cme wcel vf cv cP cD clm cfv
      wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa vj cv vf cv cfv cP cD co vr
      cv clt wbr vj cn wrex cP vr cv cD cbl cfv co vn cv wss cD cme wcel vf cv
      cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa vj cv vk cv
      cle wbr vk cv vf cv cfv cP cD co vr cv clt wbr wi vk cn wral vj cn wrex
      vj cv vf cv cfv cP cD co vr cv clt wbr vj cn wrex cD cme wcel cP cvv wcel
      vf cv cP cD clm cfv wbr vr cv cr wcel cc0 vr cv clt wbr wa vj cv vk cv
      cle wbr vk cv vf cv cfv cP cD co vr cv clt wbr wi vk cn wral vj cn wrex
      metelcls.3 cvv cD cP vr cv vj vk vf cv c1 cX cn metelcls.1 1z nnuz lmcvg2
      mp3anl2 vj cv vk cv cle wbr vk cv vf cv cfv cP cD co vr cv clt wbr wi vk
      cn wral vj cv vf cv cfv cP cD co vr cv clt wbr vj cn vj cv cn wcel vj cv
      vk cv cle wbr vk cv vf cv cfv cP cD co vr cv clt wbr wi vk cn wral vj cv
      vj cv cle wbr vj cv vf cv cfv cP cD co vr cv clt wbr vj cv cn wcel vj cv
      cr wcel vj cv vj cv cle wbr vj cv nnre vj cv leid syl vj cv vk cv cle wbr
      vk cv vf cv cfv cP cD co vr cv clt wbr wi vj cv vj cv cle wbr vj cv vf cv
      cfv cP cD co vr cv clt wbr wi vk vj cv cn vk cv vj cv wceq vj cv vk cv
      cle wbr vj cv vj cv cle wbr vk cv vf cv cfv cP cD co vr cv clt wbr vj cv
      vf cv cfv cP cD co vr cv clt wbr vk cv vj cv vj cv cle breq2 vk cv vj cv
      wceq vk cv vf cv cfv cP cD co vj cv vf cv cfv cP cD co vr cv clt vk cv vj
      cv wceq vk cv vf cv cfv vj cv vf cv cfv cP cD vk cv vj cv vf cv fveq2
      opreq1d breq1d imbi12d rcla4v mpid r19.22i syl adantr ad2antrr cD cme
      wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP
      vr cv cD cbl cfv co vn cv wss wa cP cM wcel wn wa cn cM vf cv wf cM cX
      wss wa wa vj cv vf cv cfv cP cD co vr cv clt wbr vn cv cM cP csn cdif cin
      c0 wne vj cn cD cme wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr
      cv clt wbr wa wa cP vr cv cD cbl cfv co vn cv wss wa cP cM wcel wn wa cn
      cM vf cv wf cM cX wss wa vj cv cn wcel vj cv vf cv cfv cP cD co vr cv clt
      wbr vn cv cM cP csn cdif cin c0 wne wi wi cD cme wcel vf cv cP cD clm cfv
      wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD cbl cfv co vn cv
      wss wa cP cM wcel wn wa cn cM vf cv wf cM cX wss wa vj cv cn wcel vj cv
      vf cv cfv cP cD co vr cv clt wbr vn cv cM cP csn cdif cin c0 wne cD cme
      wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP
      vr cv cD cbl cfv co vn cv wss wa cP cM wcel wn wa cn cM vf cv wf cM cX
      wss wa vj cv cn wcel wa vj cv vf cv cfv cP cD co vr cv clt wbr wa vj cv
      vf cv cfv vn cv wcel vj cv vf cv cfv cM cP csn cdif wcel wa vn cv cM cP
      csn cdif cin c0 wne cD cme wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel
      cc0 vr cv clt wbr wa wa cP vr cv cD cbl cfv co vn cv wss wa cn cM vf cv
      wf cM cX wss wa vj cv cn wcel wa vj cv vf cv cfv cP cD co vr cv clt wbr
      wa vj cv vf cv cfv vn cv wcel cP cM wcel wn vj cv vf cv cfv cM cP csn
      cdif wcel cD cme wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv
      clt wbr wa wa cn cM vf cv wf cM cX wss wa vj cv cn wcel wa vj cv vf cv
      cfv cP cD co vr cv clt wbr wa vj cv vf cv cfv cP vr cv cD cbl cfv co wcel
      cP vr cv cD cbl cfv co vn cv wss vj cv vf cv cfv vn cv wcel cD cme wcel
      vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa vj cv vf
      cv cfv cX wcel vj cv vf cv cfv cP cD co vr cv clt wbr vj cv vf cv cfv cP
      vr cv cD cbl cfv co wcel cn cM vf cv wf cM cX wss wa vj cv cn wcel wa cD
      cme wcel cP cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa vj cv vf cv cfv
      cX wcel vj cv vf cv cfv cP cD co vr cv clt wbr wa vj cv vf cv cfv cP vr
      cv cD cbl cfv co wcel wi cD cme wcel vf cv cP cD clm cfv wbr wa cD cme
      wcel cP cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa vj cv vf cv cfv cX
      wcel vj cv vf cv cfv cP cD co vr cv clt wbr vj cv vf cv cfv cP vr cv cD
      cbl cfv co wcel cD cme wcel cP cX wcel wa vj cv vf cv cfv cX wcel vr cv
      cr wcel cc0 vr cv clt wbr wa vj cv vf cv cfv cP cD co vr cv clt wbr vj cv
      vf cv cfv cP vr cv cD cbl cfv co wcel wi cD cme wcel cP cX wcel vj cv vf
      cv cfv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vj cv vf cv cfv cP cD
      co vr cv clt wbr vj cv vf cv cfv cP vr cv cD cbl cfv co wcel wi wi cD cme
      wcel cP cX wcel vj cv vf cv cfv cX wcel w3a vr cv cr wcel cc0 vr cv clt
      wbr wa vj cv vf cv cfv cP cD co vr cv clt wbr vj cv vf cv cfv cP vr cv cD
      cbl cfv co wcel cD cme wcel cP cX wcel vj cv vf cv cfv cX wcel w3a vr cv
      cr wcel cc0 vr cv clt wbr wa wa vj cv vf cv cfv cP vr cv cD cbl cfv co
      wcel vj cv vf cv cfv cP cD co vr cv clt wbr vj cv vf cv cfv cD cP vr cv
      cX metelcls.1 elbl3 biimpar exp31 3expia com23 imp4b cD cme wcel vf cv cP
      cD clm cfv wbr wa cD cme wcel cP cX wcel cD cme wcel vf cv cP cD clm cfv
      wbr pm3.26 cD cme wcel cP cvv wcel vf cv cP cD clm cfv wbr cP cX wcel
      metelcls.3 cvv cD cP vf cv cX metelcls.1 lmcl mp3an2 jca sylan cn cX vf
      cv wf vj cv cn wcel vj cv vf cv cfv cX wcel cn cM vf cv wf cM cX wss wa
      cn cX vj cv vf cv ffvelrn cn cM cX vf cv fss sylan sylani cP vr cv cD cbl
      cfv co vn cv vj cv vf cv cfv ssel sylan9 cP cM wcel wn cn cM vf cv wf cM
      cX wss wa vj cv cn wcel wa vj cv vf cv cfv cM cP csn cdif wcel vj cv vf
      cv cfv cP cD co vr cv clt wbr cn cM vf cv wf cM cX wss wa vj cv cn wcel
      wa cP cM wcel wn vj cv vf cv cfv cM cP csn cdif wcel cn cM vf cv wf vj cv
      cn wcel cP cM wcel wn vj cv vf cv cfv cM cP csn cdif wcel wi cM cX wss cn
      cM vf cv wf vj cv cn wcel wa vj cv vf cv cfv cM wcel cP cM wcel wn vj cv
      vf cv cfv cM cP csn cdif wcel wi cn cM vj cv vf cv ffvelrn vj cv vf cv
      cfv cM wcel cP cM wcel wn vj cv vf cv cfv cM wcel vj cv vf cv cfv cP csn
      wcel wn wa vj cv vf cv cfv cM cP csn cdif wcel vj cv vf cv cfv cM wcel cP
      cM wcel wn vj cv vf cv cfv cP csn wcel wn vj cv vf cv cfv cM wcel vj cv
      vf cv cfv cP csn wcel cP cM wcel vj cv vf cv cfv cP csn wcel vj cv vf cv
      cfv cM wcel cP cM wcel vj cv vf cv cfv cP csn wcel vj cv vf cv cfv cP
      wceq vj cv vf cv cfv cM wcel cP cM wcel wi vj cv vf cv cfv cP metelcls.3
      elsnc2 vj cv vf cv cfv cP wceq vj cv vf cv cfv cM wcel cP cM wcel vj cv
      vf cv cfv cP cM eleq1 biimpd sylbi com12 con3d anc2li vj cv vf cv cfv cM
      cP csn eldif syl6ibr syl adantlr com12 adantrd anim12ii vj cv vf cv cfv
      vn cv cM cP csn cdif inelcm syl6 exp4c imp r19.23adv mpd cD cme wcel cM
      cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa vr cv cr wcel cc0
      vr cv clt wbr cP vr cv cD cbl cfv co vn cv wss wa wa cP cM wcel wn cD cme
      wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP
      vr cv cD cbl cfv co vn cv wss wa cP cM wcel wn wa cD cme wcel cM cX wss
      wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa vr cv cr wcel cc0 vr cv
      clt wbr cP vr cv cD cbl cfv co vn cv wss wa wa wa cD cme wcel vf cv cP cD
      clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD cbl cfv
      co vn cv wss wa cP cM wcel wn cD cme wcel cM cX wss wa cn cM vf cv wf vf
      cv cP cD clm cfv wbr wa wa vr cv cr wcel cc0 vr cv clt wbr cP vr cv cD
      cbl cfv co vn cv wss wa wa wa cD cme wcel vf cv cP cD clm cfv wbr wa vr
      cv cr wcel cc0 vr cv clt wbr wa wa cP vr cv cD cbl cfv co vn cv wss cD
      cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa cD cme
      wcel vf cv cP cD clm cfv wbr wa vr cv cr wcel cc0 vr cv clt wbr cP vr cv
      cD cbl cfv co vn cv wss wa wa vr cv cr wcel cc0 vr cv clt wbr wa cD cme
      wcel cM cX wss wa cD cme wcel cn cM vf cv wf vf cv cP cD clm cfv wbr wa
      vf cv cP cD clm cfv wbr cD cme wcel cM cX wss pm3.26 cn cM vf cv wf vf cv
      cP cD clm cfv wbr pm3.27 anim12i vr cv cr wcel cc0 vr cv clt wbr vr cv cr
      wcel cc0 vr cv clt wbr wa cP vr cv cD cbl cfv co vn cv wss vr cv cr wcel
      cc0 vr cv clt wbr wa id adantrr anim12i cD cme wcel cM cX wss wa cn cM vf
      cv wf vf cv cP cD clm cfv wbr wa wa vr cv cr wcel cc0 vr cv clt wbr cP vr
      cv cD cbl cfv co vn cv wss simprrr jca anim1i an1rs cD cme wcel cM cX wss
      wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa cn cM vf cv wf cM cX wss
      wa cP cM wcel wn vr cv cr wcel cc0 vr cv clt wbr cP vr cv cD cbl cfv co
      vn cv wss wa wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa cD cme wcel cM
      cX wss wa cn cM vf cv wf cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv
      wbr wa cn cM vf cv wf cD cme wcel cM cX wss wa cM cX wss cn cM vf cv wf
      vf cv cP cD clm cfv wbr pm3.26 cD cme wcel cM cX wss pm3.27 anim12i
      ancoms ad2antrr sylanc exp32 r19.23adv adantld sylbid r19.21aiv cD cme
      wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa wa cP cM cJ
      clp cfv cfv wcel vn cv cM cP csn cdif cin c0 wne vn cP csn cJ cnei cfv
      cfv wral wb cP cM wcel wn cD cme wcel cM cX wss wa vf cv cP cD clm cfv
      wbr cP cM cJ clp cfv cfv wcel vn cv cM cP csn cdif cin c0 wne vn cP csn
      cJ cnei cfv cfv wral wb cn cM vf cv wf cJ ctop wcel cM cJ cuni wss cP cJ
      cuni wcel cP cM cJ clp cfv cfv wcel vn cv cM cP csn cdif cin c0 wne vn cP
      csn cJ cnei cfv cfv wral wb cD cme wcel cM cX wss wa vf cv cP cD clm cfv
      wbr wa cP cM vn cJ cJ cuni cJ cuni eqid islp2 cD cme wcel cM cX wss wa cJ
      ctop wcel vf cv cP cD clm cfv wbr cD cme wcel cJ ctop wcel cM cX wss cD
      cJ metelcls.2 opntop adantr adantr cD cme wcel cM cX wss wa cM cJ cuni
      wss vf cv cP cD clm cfv wbr cD cme wcel cM cJ cuni wss cM cX wss cD cme
      wcel cJ cuni cX cM cD cJ cX metelcls.1 metelcls.2 uniopn2 sseq2d biimpar
      adantr cD cme wcel vf cv cP cD clm cfv wbr cP cJ cuni wcel cM cX wss cD
      cme wcel vf cv cP cD clm cfv wbr wa cP cX cJ cuni cD cme wcel cP cvv wcel
      vf cv cP cD clm cfv wbr cP cX wcel metelcls.3 cvv cD cP vf cv cX
      metelcls.1 lmcl mp3an2 cD cme wcel cJ cuni cX wceq vf cv cP cD clm cfv
      wbr cD cJ cX metelcls.1 metelcls.2 uniopn2 adantr eleqtrrd adantlr
      syl3anc adantrl adantr mpbird ex orrd cP cM cM cJ clp cfv cfv elun sylibr
      cJ ctop wcel cM cJ cuni wss cM cJ ccl cfv cfv cM cM cJ clp cfv cfv cun
      wceq cD cme wcel cM cX wss wa cn cM vf cv wf vf cv cP cD clm cfv wbr wa
      wa cM cJ cJ cuni cJ cuni eqid clslp cD cme wcel cJ ctop wcel cM cX wss cn
      cM vf cv wf vf cv cP cD clm cfv wbr wa cD cJ metelcls.2 opntop ad2antrr
      cD cme wcel cM cX wss wa cM cJ cuni wss cn cM vf cv wf vf cv cP cD clm
      cfv wbr wa cD cme wcel cM cJ cuni wss cM cX wss cD cme wcel cJ cuni cX cM
      cD cJ cX metelcls.1 metelcls.2 uniopn2 sseq2d biimpar adantr sylanc
      eleqtrrd ex 19.23adv impbid $.
      $( [26-Dec-2007] $) $( [8-Nov-2007] $)
  $}

  ${
    $d f x D $.  $d f x J $.  $d f x M $.  $d f x X $.
    metcls.1 $e |- X = dom dom D $.
    metcls.2 $e |- J = ( Open ` D ) $.
    $( The closure of a subset of a metric space is equal to its points of
       convergence.  Theorem 1.4-6(a) of [Kreyszig] p. 30. $)
    metcls $p |- ( ( D e. Met /\ M C_ X ) -> ( ( cls ` J ) ` M ) =
          { x | E. f ( f : NN --> M /\ f ( ~~>m ` D ) x ) } ) $=
      cD cme wcel cM cX wss wa cn cM vf cv wf vf cv vx cv cD clm cfv wbr wa vf
      wex vx cM cJ ccl cfv cfv cD vx cv vf cJ cM cX metcls.1 metcls.2 vx visset
      metelcls abbi2dv $.
      $( [10-Jul-2008] $) $( [11-Nov-2007] $)

    $( A subset of a metric space is closed iff every convergent sequence on it
       converges to a point in the subset.  Theorem 1.4-6(b) of [Kreyszig]
       p. 30. $)
    metcld $p |- ( ( D e. Met /\ M C_ X ) -> ( M e. ( Clsd ` J ) <->
     A. x A. f ( ( f : NN --> M /\ f ( ~~>m ` D ) x ) -> x e. M ) ) ) $=
      cD cme wcel cM cX wss wa cM cJ ccld cfv wcel cM cJ ccl cfv cfv cM wss cn
      cM vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cM wcel wi vf wal vx wal
      cJ ctop wcel cM cJ cuni wss cM cJ ccld cfv wcel cM cJ ccl cfv cfv cM wss
      wb cD cme wcel cM cX wss wa cM cJ cJ cuni cJ cuni eqid iscld4 cD cme wcel
      cJ ctop wcel cM cX wss cD cJ metcls.2 opntop adantr cD cme wcel cM cJ
      cuni wss cM cX wss cD cme wcel cJ cuni cX cM cD cJ cX metcls.1 metcls.2
      uniopn2 sseq2d biimpar sylanc cD cme wcel cM cX wss wa cn cM vf cv wf vf
      cv vx cv cD clm cfv wbr wa vx cv cM wcel wi vf wal vx wal vx cv cM cJ ccl
      cfv cfv wcel vx cv cM wcel wi vx wal cM cJ ccl cfv cfv cM wss cD cme wcel
      cM cX wss wa cn cM vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cM wcel
      wi vf wal vx cv cM cJ ccl cfv cfv wcel vx cv cM wcel wi vx cD cme wcel cM
      cX wss wa vx cv cM cJ ccl cfv cfv wcel vx cv cM wcel wi cn cM vf cv wf vf
      cv vx cv cD clm cfv wbr wa vf wex vx cv cM wcel wi cn cM vf cv wf vf cv
      vx cv cD clm cfv wbr wa vx cv cM wcel wi vf wal cD cme wcel cM cX wss wa
      vx cv cM cJ ccl cfv cfv wcel cn cM vf cv wf vf cv vx cv cD clm cfv wbr wa
      vf wex vx cv cM wcel cD vx cv vf cJ cM cX metcls.1 metcls.2 vx visset
      metelcls imbi1d cn cM vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cM
      wcel vf 19.23v syl6rbbr albidv vx cM cJ ccl cfv cfv cM dfss2 syl6bbr
      bitr4d $.
      $( [13-Jan-2008] $) $( [11-Nov-2007] $)
  $}

  ${
    $d f k m w x z C $.  $d f k m w x z D $.  $d f j k m w x y z F $.
    $d k m x z G $.  $d w x z J $.  $d x K $.  $d f k m w x z P $.
    $d f j k m w x z X $.  $d f j k m w x y z Y $.
    metcnp4.1 $e |- X = dom dom C $.
    metcnp4.3 $e |- Y = dom dom D $.
    metcnp4.c $e |- J = ( Open ` C ) $.
    metcnp4.d $e |- K = ( Open ` D ) $.
    metcnp4.5 $e |- G = { <. j , y >. | ( j e. NN /\ y = ( F ` ( f ` j ) ) )
                    } $.
    $( Lemma for ~ metcnp4 . $)
    metcnp4lem1 $p |- ( k e. NN -> ( G ` k ) = ( F ` ( f ` k ) ) ) $=
      vj vy vk cv vj cv vf cv cfv cF cfv vk cv vf cv cfv cF cfv cn cG vj cv vk
      cv wceq vj cv vf cv cfv vk cv vf cv cfv cF vj cv vk cv vf cv fveq2 fveq2d
      metcnp4.5 vk cv vf cv cfv cF fvex fvopab4 $.
      $( [6-Oct-2007] $) $( [5-Jun-2007] $)

    $( Lemma for ~ metcnp4 . $)
    metcnp4lem2 $p |- ( ( ( C e. Met /\ P e. X ) /\ F : X --> Y )  ->
      ( ( f : NN --> X /\ f ( ~~>m ` C ) P ) ->
 ( A. x e. RR ( 0 < x -> E. z e. RR ( 0 < z /\ A. w e. X ( ( w C P ) < z ->
  ( ( F ` w ) D ( F ` P ) ) < x ) ) ) -> A. x e. RR
      ( 0 < x -> E. k e. NN A. m e. NN ( k <_ m ->
              ( ( G ` m ) D ( F ` P ) ) < x ) ) ) ) ) $=
      cC cme wcel cP cX wcel wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm
      cfv wbr wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv clt
      wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex wi vx cr wral cc0 vx cv clt wbr vk cv vm cv cle wbr vm cv cG cfv cP
      cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex wi vx cr wral wi cC
      cme wcel cP cX wcel wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm cfv
      wbr wa wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv clt
      wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex wi cc0 vx cv clt wbr vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD
      co vx cv clt wbr wi vm cn wral vk cn wrex wi vx cr cC cme wcel cP cX wcel
      wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa wa cc0 vz cv
      clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral wa vz cr wrex vk cv vm cv cle wbr vm cv cG cfv cP
      cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex cc0 vx cv clt wbr cC
      cme wcel cP cX wcel wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm cfv
      wbr wa wa cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP
      cF cfv cD co vx cv clt wbr wi vw cX wral wa vk cv vm cv cle wbr vm cv cG
      cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex vz cr cC cme
      wcel cP cX wcel wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm cfv wbr
      wa wa vz cv cr wcel cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv
      cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral vk cv vm cv cle wbr vm
      cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex cC cme
      wcel cP cX wcel wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm cfv wbr
      wa wa vz cv cr wcel cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv
      cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral vk cv vm cv cle wbr vm
      cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex wi cC
      cme wcel cP cX wcel wa cX cY cF wf wa cn cX vf cv wf vf cv cP cC clm cfv
      wbr wa wa vz cv cr wcel cc0 vz cv clt wbr wa vk cv vm cv cle wbr vm cv vf
      cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi vm cn wral vk
      cn wrex vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx
      cv clt wbr wi vm cn wral vk cn wrex wi cC cme wcel cP cX wcel wa vf cv cP
      cC clm cfv wbr vz cv cr wcel cc0 vz cv clt wbr wa vk cv vm cv cle wbr vm
      cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi vm cn
      wral vk cn wrex wi cX cY cF wf cn cX vf cv wf cC cme wcel cP cX wcel vf
      cv cP cC clm cfv wbr vz cv cr wcel cc0 vz cv clt wbr wa vk cv vm cv cle
      wbr vm cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi
      vm cn wral vk cn wrex wi cC cme wcel cP cX wcel vf cv cP cC clm cfv wbr
      w3a vz cv cr wcel cc0 vz cv clt wbr wa vk cv vm cv cle wbr vm cv vf cv
      cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi vm cn wral vk cn
      wrex cX cC cP vz cv vk vm vf cv c1 cX cn metcnp4.1 1z nnuz lmcvg ex 3expa
      ad2ant2rl cX cY cF wf vk cv vm cv cle wbr vm cv vf cv cfv cX wcel vm cv
      vf cv cfv cP cC co vz cv clt wbr wa wi vm cn wral vk cn wrex vw cv cP cC
      co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral
      vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn
      wral vk cn wrex wi wi cC cme wcel cP cX wcel wa cn cX vf cv wf vf cv cP
      cC clm cfv wbr wa cX cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF cfv
      cP cF cfv cD co vx cv clt wbr wi vw cX wral vk cv vm cv cle wbr vm cv vf
      cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi vm cn wral vk
      cn wrex vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi
      vm cn wral vk cn wrex cX cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF
      cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral vk cv vm cv cle wbr vm cv
      vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi vm cn wral
      vk cn wrex vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr
      wi vm cn wral vk cn wrex wi cX cY cF wf vw cv cP cC co vz cv clt wbr vw
      cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vk cv vm cv cle
      wbr vm cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi
      vm cn wral vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr
      wi vm cn wral vk cn cX cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF cfv
      cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vk cv vm cv cle wbr vm cv
      vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wi vk cv vm
      cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn cX cY cF
      wf vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt
      wbr wi vw cX wral wa vm cv cn wcel wa vm cv vf cv cfv cX wcel vm cv vf cv
      cfv cP cC co vz cv clt wbr wa vm cv cG cfv cP cF cfv cD co vx cv clt wbr
      vk cv vm cv cle wbr cX cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF cfv
      cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vm cv cn wcel wa vm cv vf
      cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa vm cv cG cfv cP
      cF cfv cD co vx cv clt wbr cX cY cF wf vw cv cP cC co vz cv clt wbr vw cv
      cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vm cv cn wcel wa vm
      cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz cv clt wbr wa wa vm cv
      cG cfv cP cF cfv cD co vm cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt
      vm cv cn wcel vm cv cG cfv cP cF cfv cD co vm cv vf cv cfv cF cfv cP cF
      cfv cD co wceq cX cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF cfv cP
      cF cfv cD co vx cv clt wbr wi vw cX wral wa vm cv vf cv cfv cX wcel vm cv
      vf cv cfv cP cC co vz cv clt wbr wa vm cv cn wcel vm cv cG cfv vm cv vf
      cv cfv cF cfv cP cF cfv cD vy cC cD vf vj vm cF cG cJ cK cX cY metcnp4.1
      metcnp4.3 metcnp4.c metcnp4.d metcnp4.5 metcnp4lem1 opreq1d ad2antlr cX
      cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral wa vm cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co
      vz cv clt wbr wa vm cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vm
      cv cn wcel vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx
      cv clt wbr wi vw cX wral vm cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co
      vz cv clt wbr wa vm cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr cX
      cY cF wf vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral vm cv vf cv cfv cX wcel vm cv vf cv cfv cP cC co vz
      cv clt wbr vm cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vw cv cP
      cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vm cv
      vf cv cfv cP cC co vz cv clt wbr vm cv vf cv cfv cF cfv cP cF cfv cD co
      vx cv clt wbr wi vw vm cv vf cv cfv cX vw cv vm cv vf cv cfv wceq vw cv
      cP cC co vz cv clt wbr vm cv vf cv cfv cP cC co vz cv clt wbr vw cv cF
      cfv cP cF cfv cD co vx cv clt wbr vm cv vf cv cfv cF cfv cP cF cfv cD co
      vx cv clt wbr vw cv vm cv vf cv cfv wceq vw cv cP cC co vm cv vf cv cfv
      cP cC co vz cv clt vw cv vm cv vf cv cfv cP cC opreq1 breq1d vw cv vm cv
      vf cv cfv wceq vw cv cF cfv cP cF cfv cD co vm cv vf cv cfv cF cfv cP cF
      cfv cD co vx cv clt vw cv vm cv vf cv cfv wceq vw cv cF cfv vm cv vf cv
      cfv cF cfv cP cF cfv cD vw cv vm cv vf cv cfv cF fveq2 opreq1d breq1d
      imbi12d rcla4cv imp32 adantll adantlr eqbrtrd ex imim2d r19.20dva
      r19.22sdv ex com23 ad2antlr syld exp3a imp4a r19.23adv imim2d r19.20sdv
      ex $.
      $( [6-Oct-2007] $) $( [5-Jun-2007] $)

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous at point ` P ` .  Theorem 14-4.3 of [Gleason] p. 240. $)
    metcnp4 $p |- ( ( C e. Met /\ D e. Met /\ P e. X ) ->
      ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\ A. f ( ( f : NN --> X
                /\ f ( ~~>m ` C ) P ) ->  G ( ~~>m ` D ) ( F ` P ) ) ) ) ) $=
      cC cme wcel cD cme wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel cX cY
      cF wf cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw
      cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr wrex wi vx
      cr wral wa cX cY cF wf cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG cP cF
      cfv cD clm cfv wbr wi vf wal wa vx vz vw cC cD cP cF cJ cK cX cY
      metcnp4.1 metcnp4.c metcnp4.3 metcnp4.d metcnp2 cC cme wcel cD cme wcel
      cP cX wcel w3a cX cY cF wf cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP
      cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX
      wral wa vz cr wrex wi vx cr wral cn cX vf cv wf vf cv cP cC clm cfv wbr
      wa cG cP cF cfv cD clm cfv wbr wi vf wal cC cme wcel cD cme wcel cP cX
      wcel w3a cX cY cF wf wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC
      co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral
      wa vz cr wrex wi vx cr wral cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG
      cP cF cfv cD clm cfv wbr wi vf wal cC cme wcel cD cme wcel cP cX wcel w3a
      cX cY cF wf wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv
      clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex wi vx cr wral cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG cP cF cfv
      cD clm cfv wbr wi vf cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf
      wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cc0 vx cv clt wbr cc0 vz cv
      clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral wa vz cr wrex wi vx cr wral cG cP cF cfv cD clm cfv
      wbr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cn cX vf cv wf
      vf cv cP cC clm cfv wbr wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP
      cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX
      wral wa vz cr wrex wi vx cr wral cG cP cF cfv cD clm cfv wbr wi cC cme
      wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cn cX vf cv wf vf cv cP cC
      clm cfv wbr wa wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz
      cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz
      cr wrex wi vx cr wral cc0 vx cv clt wbr vk cv vm cv cle wbr vm cv cG cfv
      cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex wi vx cr wral cG
      cP cF cfv cD clm cfv wbr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF
      wf wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cc0 vx cv clt wbr cc0 vz
      cv clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx
      cv clt wbr wi vw cX wral wa vz cr wrex wi vx cr wral cc0 vx cv clt wbr vk
      cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral
      vk cn wrex wi vx cr wral wi cC cme wcel cP cX wcel cX cY cF wf cn cX vf
      cv wf vf cv cP cC clm cfv wbr wa cc0 vx cv clt wbr cc0 vz cv clt wbr vw
      cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi
      vw cX wral wa vz cr wrex wi vx cr wral cc0 vx cv clt wbr vk cv vm cv cle
      wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex
      wi vx cr wral wi wi cD cme wcel vx vy vz vw cC cD cP vf vj vk vm cF cG cJ
      cK cX cY metcnp4.1 metcnp4.3 metcnp4.c metcnp4.d metcnp4.5 metcnp4lem2
      3adantl2 imp cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cn cX
      vf cv wf cG cP cF cfv cD clm cfv wbr cc0 vx cv clt wbr vk cv vm cv cle
      wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex
      wi vx cr wral wb vf cv cP cC clm cfv wbr cD cme wcel cP cF cfv cY wcel cn
      cY cG wf cG cP cF cfv cD clm cfv wbr cc0 vx cv clt wbr vk cv vm cv cle
      wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cn wrex
      wi vx cr wral wb cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cn
      cX vf cv wf wa vx cD cP cF cfv vk vm cG c1 cY cn metcnp4.3 1z nnuz lmbrf2
      cC cme wcel cD cme wcel cP cX wcel w3a cD cme wcel cX cY cF wf cn cX vf
      cv wf cC cme wcel cD cme wcel cP cX wcel 3simp2 ad2antrr cC cme wcel cD
      cme wcel cP cX wcel w3a cX cY cF wf wa cP cF cfv cY wcel cn cX vf cv wf
      cP cX wcel cC cme wcel cX cY cF wf cP cF cfv cY wcel cD cme wcel cX cY cF
      wf cP cX wcel cP cF cfv cY wcel cX cY cP cF ffvelrn ancoms 3ad2antl3
      adantr cX cY cF wf cn cX vf cv wf cn cY cG wf cC cme wcel cD cme wcel cP
      cX wcel w3a cX cY cF wf cn cX vf cv wf wa vj cv vf cv cfv cF cfv cY wcel
      vj cn wral cn cY cG wf cX cY cF wf cn cX vf cv wf wa vj cv vf cv cfv cF
      cfv cY wcel vj cn cX cY cF wf cn cX vf cv wf vj cv cn wcel vj cv vf cv
      cfv cF cfv cY wcel cX cY cF wf vj cv vf cv cfv cX wcel vj cv vf cv cfv cF
      cfv cY wcel cn cX vf cv wf vj cv cn wcel wa cX cY vj cv vf cv cfv cF
      ffvelrn cn cX vj cv vf cv ffvelrn sylan2 anassrs r19.21aiva vj vy cn cY
      vj cv vf cv cfv cF cfv cG metcnp4.5 fopab2 sylib adantll syl3anc adantrr
      sylibrd ex com23 19.21adv cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF
      wf wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG cP cF cfv cD clm cfv
      wbr wi vf wal cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv
      clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex wi vx cr cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa cn cX
      vf cv wf vf cv cP cC clm cfv wbr wa cG cP cF cfv cD clm cfv wbr wi vf wal
      vx cv cr wcel cc0 vx cv clt wbr cc0 vz cv clt wbr vw cv cP cC co vz cv
      clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vx cv cr wcel
      cc0 vx cv clt wbr wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG cP cF
      cfv cD clm cfv wbr wi vf wal cc0 vz cv clt wbr vw cv cP cC co vz cv clt
      wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vx cv cr wcel
      cc0 vx cv clt wbr wa wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG cP
      cF cfv cD clm cfv wbr wi vf wal cc0 vz cv clt wbr vw cv cP cC co vz cv
      clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr
      wrex cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vx cv cr wcel
      cc0 vx cv clt wbr wa wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG cP
      cF cfv cD clm cfv wbr wi vf wal cn cX vf cv wf vk cv vf cv cfv cP cC co
      c1 vk cv cdiv co clt wbr vk cn wral wa vk cv vf cv cfv cF cfv cP cF cfv
      cD co vx cv clt wbr vk cn wrex wi vf wal cc0 vz cv clt wbr vw cv cP cC co
      vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa
      vz cr wrex cC cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vx cv cr
      wcel cc0 vx cv clt wbr wa wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cG
      cP cF cfv cD clm cfv wbr wi cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk
      cv cdiv co clt wbr vk cn wral wa vk cv vf cv cfv cF cfv cP cF cfv cD co
      vx cv clt wbr vk cn wrex wi vf cC cme wcel cD cme wcel cP cX wcel w3a cX
      cY cF wf wa vx cv cr wcel cc0 vx cv clt wbr wa wa cn cX vf cv wf vk cv vf
      cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn wral wa cn cX vf cv wf vf
      cv cP cC clm cfv wbr wa cG cP cF cfv cD clm cfv wbr vk cv vf cv cfv cF
      cfv cP cF cfv cD co vx cv clt wbr vk cn wrex cC cme wcel cD cme wcel cP
      cX wcel w3a cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt
      wbr vk cn wral wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa wi cX cY cF
      wf vx cv cr wcel cc0 vx cv clt wbr wa cC cme wcel cP cX wcel cn cX vf cv
      wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn wral wa cn cX
      vf cv wf vf cv cP cC clm cfv wbr wa wi cD cme wcel cC cme wcel cP cX wcel
      wa cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn
      wral wa cn cX vf cv wf vf cv cP cC clm cfv wbr wa cC cme wcel cP cX wcel
      wa cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn
      wral wa wa cn cX vf cv wf vf cv cP cC clm cfv wbr cC cme wcel cP cX wcel
      wa cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn
      wral simprl cC cP vk vf cv cX metcnp4.1 lmnn jca ex 3adant2 ad2antrr cC
      cme wcel cD cme wcel cP cX wcel w3a cX cY cF wf wa vx cv cr wcel cc0 vx
      cv clt wbr wa cG cP cF cfv cD clm cfv wbr vk cv vf cv cfv cF cfv cP cF
      cfv cD co vx cv clt wbr vk cn wrex wi cD cme wcel cP cX wcel cX cY cF wf
      vx cv cr wcel cc0 vx cv clt wbr wa cG cP cF cfv cD clm cfv wbr vk cv vf
      cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vk cn wrex wi wi cC cme wcel
      cD cme wcel cX cY cF wf cP cX wcel vx cv cr wcel cc0 vx cv clt wbr wa cG
      cP cF cfv cD clm cfv wbr vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt
      wbr vk cn wrex wi wi cD cme wcel cX cY cF wf cP cX wcel vx cv cr wcel cc0
      vx cv clt wbr wa cG cP cF cfv cD clm cfv wbr vk cv vf cv cfv cF cfv cP cF
      cfv cD co vx cv clt wbr vk cn wrex wi wi cD cme wcel cP cF cfv cY wcel vx
      cv cr wcel cc0 vx cv clt wbr wa cG cP cF cfv cD clm cfv wbr vk cv vf cv
      cfv cF cfv cP cF cfv cD co vx cv clt wbr vk cn wrex wi wi cX cY cF wf cP
      cX wcel wa cD cme wcel cP cF cfv cY wcel wa cG cP cF cfv cD clm cfv wbr
      vx cv cr wcel cc0 vx cv clt wbr wa vk cv vf cv cfv cF cfv cP cF cfv cD co
      vx cv clt wbr vk cn wrex cD cme wcel cP cF cfv cY wcel cG cP cF cfv cD
      clm cfv wbr vx cv cr wcel cc0 vx cv clt wbr wa vk cv vf cv cfv cF cfv cP
      cF cfv cD co vx cv clt wbr vk cn wrex wi cD cme wcel cP cF cfv cY wcel cG
      cP cF cfv cD clm cfv wbr w3a vx cv cr wcel cc0 vx cv clt wbr wa vk cv vf
      cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vk cn wrex cD cme wcel cP cF
      cfv cY wcel cG cP cF cfv cD clm cfv wbr w3a vx cv cr wcel cc0 vx cv clt
      wbr wa wa vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr
      wi vm cn wral vk cn wrex vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt
      wbr vk cn wrex cY cD cP cF cfv vx cv vk vm cG c1 cY cn metcnp4.3 1z nnuz
      lmcvg2 vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr wi
      vm cn wral vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vk cn vk
      cv cn wcel vk cv vm cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr
      wi vm cn wral vk cv cG cfv cP cF cfv cD co vx cv clt wbr vk cv vf cv cfv
      cF cfv cP cF cfv cD co vx cv clt wbr vk cv cn wcel vk cv vm cv cle wbr vm
      cv cG cfv cP cF cfv cD co vx cv clt wbr wi vm cn wral vk cv vk cv cle wbr
      vk cv cG cfv cP cF cfv cD co vx cv clt wbr vk cv cn wcel vk cv cr wcel vk
      cv vk cv cle wbr vk cv nnre vk cv leid syl vk cv vm cv cle wbr vm cv cG
      cfv cP cF cfv cD co vx cv clt wbr wi vk cv vk cv cle wbr vk cv cG cfv cP
      cF cfv cD co vx cv clt wbr wi vm vk cv cn vm cv vk cv wceq vk cv vm cv
      cle wbr vk cv vk cv cle wbr vm cv cG cfv cP cF cfv cD co vx cv clt wbr vk
      cv cG cfv cP cF cfv cD co vx cv clt wbr vm cv vk cv vk cv cle breq2 vm cv
      vk cv wceq vm cv cG cfv cP cF cfv cD co vk cv cG cfv cP cF cfv cD co vx
      cv clt vm cv vk cv wceq vm cv cG cfv vk cv cG cfv cP cF cfv cD vm cv vk
      cv cG fveq2 opreq1d breq1d imbi12d rcla4v mpid vk cv cn wcel vk cv cG cfv
      cP cF cfv cD co vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt vk cv cn
      wcel vk cv cG cfv vk cv vf cv cfv cF cfv cP cF cfv cD vy cC cD vf vj vk
      cF cG cJ cK cX cY metcnp4.1 metcnp4.3 metcnp4.c metcnp4.d metcnp4.5
      metcnp4lem1 opreq1d breq1d sylibd r19.22i syl ex 3expia com23 cX cY cP cF
      ffvelrn sylan2 anassrs an1rs 3adantl1 imp imim12d 19.20dv cn cX vf cv wf
      vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn wral wa vk cv vf
      cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vk cn wrex wi vf wal vw cv cP
      cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr
      wi vw cX wral vk cn wrex cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr
      vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa vz cr wrex cn
      cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn wral
      wa vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vk cn wrex wi vf
      wal cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk
      cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr wi vk cn wrex wi vf wal
      vw cv cP cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx
      cv clt wbr wi vw cX wral vk cn wrex cn cX vf cv wf vk cv vf cv cfv cP cC
      co c1 vk cv cdiv co clt wbr vk cn wral wa vk cv vf cv cfv cF cfv cP cF
      cfv cD co vx cv clt wbr vk cn wrex wi cn cX vf cv wf vk cv vf cv cfv cP
      cC co c1 vk cv cdiv co clt wbr vk cv vf cv cfv cF cfv cP cF cfv cD co vx
      cv clt wbr wi vk cn wrex wi vf cn cX vf cv wf vk cv vf cv cfv cP cC co c1
      vk cv cdiv co clt wbr vk cn wral wa vk cv vf cv cfv cF cfv cP cF cfv cD
      co vx cv clt wbr vk cn wrex wi cn cX vf cv wf vk cv vf cv cfv cP cC co c1
      vk cv cdiv co clt wbr vk cn wral vk cv vf cv cfv cF cfv cP cF cfv cD co
      vx cv clt wbr vk cn wrex wi wi cn cX vf cv wf vk cv vf cv cfv cP cC co c1
      vk cv cdiv co clt wbr vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt
      wbr wi vk cn wrex wi cn cX vf cv wf vk cv vf cv cfv cP cC co c1 vk cv
      cdiv co clt wbr vk cn wral vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv
      clt wbr vk cn wrex impexp vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt
      wbr vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt wbr wi vk cn wrex vk
      cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cn wral vk cv vf cv cfv
      cF cfv cP cF cfv cD co vx cv clt wbr vk cn wrex wi cn cX vf cv wf vk cv
      vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cv vf cv cfv cF cfv cP cF
      cfv cD co vx cv clt wbr vk cn r19.35 imbi2i bitr4i albii vw cv cP cC co
      c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vk
      cv vf cv cfv cP cC co c1 vk cv cdiv co clt wbr vk cv vf cv cfv cF cfv cP
      cF cfv cD co vx cv clt wbr wi vk vw cn cX vf nnex vw cv vk cv vf cv cfv
      wceq vw cv cP cC co c1 vk cv cdiv co clt wbr vk cv vf cv cfv cP cC co c1
      vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr vk cv vf
      cv cfv cF cfv cP cF cfv cD co vx cv clt wbr vw cv vk cv vf cv cfv wceq vw
      cv cP cC co vk cv vf cv cfv cP cC co c1 vk cv cdiv co clt vw cv vk cv vf
      cv cfv cP cC opreq1 breq1d vw cv vk cv vf cv cfv wceq vw cv cF cfv cP cF
      cfv cD co vk cv vf cv cfv cF cfv cP cF cfv cD co vx cv clt vw cv vk cv vf
      cv cfv wceq vw cv cF cfv vk cv vf cv cfv cF cfv cP cF cfv cD vw cv vk cv
      vf cv cfv cF fveq2 opreq1d breq1d imbi12d ac6n sylbi vw cv cP cC co c1 vk
      cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX
      wral cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF
      cfv cD co vx cv clt wbr wi vw cX wral wa vz cr wrex vk cn c1 vk cv cdiv
      co cr wcel cc0 c1 vk cv cdiv co clt wbr vw cv cP cC co c1 vk cv cdiv co
      clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral wa cc0
      vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co
      vx cv clt wbr wi vw cX wral wa vz cr wrex vk cv cn wcel vw cv cP cC co c1
      vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX
      wral wa cc0 vz cv clt wbr vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF
      cfv cD co vx cv clt wbr wi vw cX wral wa cc0 c1 vk cv cdiv co clt wbr vw
      cv cP cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral wa vz c1 vk cv cdiv co cr vz cv c1 vk cv cdiv co
      wceq cc0 vz cv clt wbr cc0 c1 vk cv cdiv co clt wbr vw cv cP cC co vz cv
      clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr wi vw cX wral vw cv cP
      cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt wbr
      wi vw cX wral vz cv c1 vk cv cdiv co cc0 clt breq2 vz cv c1 vk cv cdiv co
      wceq vw cv cP cC co vz cv clt wbr vw cv cF cfv cP cF cfv cD co vx cv clt
      wbr wi vw cv cP cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD
      co vx cv clt wbr wi vw cX vz cv c1 vk cv cdiv co wceq vw cv cP cC co vz
      cv clt wbr vw cv cP cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv
      cD co vx cv clt wbr vz cv c1 vk cv cdiv co vw cv cP cC co clt breq2
      imbi1d ralbidv anbi12d rcla4ev vk cv cn wcel c1 vk cv cdiv co cr wcel vw
      cv cP cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP cF cfv cD co vx cv
      clt wbr wi vw cX wral vk cv nnrecre adantr vk cv cn wcel cc0 c1 vk cv
      cdiv co clt wbr vw cv cP cC co c1 vk cv cdiv co clt wbr vw cv cF cfv cP
      cF cfv cD co vx cv clt wbr wi vw cX wral vk cv nnrecgt0 anim1i sylanc
      r19.23aiva syl syl6 imp an1rs exp43 r19.21adv impbid pm5.32da bitrd $.
      $( [17-Nov-2007] $) $( [17-May-2007] $)

    $( MAY BE REVISED - A. x e. X could just be A. x using lmcl $)
    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous.  Theorem 10.3 of [Munkres] p. 128. $)
    metcn4 $p |- ( ( C e. Met /\ D e. Met /\ F : X --> Y ) ->
             ( F e. ( J Cn K ) <-> A. f ( f : NN --> X ->
           A. x e. X ( f ( ~~>m ` C ) x ->  G ( ~~>m ` D ) ( F ` x ) ) ) ) ) $=
      cC cme wcel cD cme wcel cX cY cF wf cF cJ cK ccn co wcel cn cX vf cv wf
      vf cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi vx cX wral
      wi vf wal wb cC cme wcel cD cme wcel wa cX cY cF wf wa cF cJ cK ccn co
      wcel cF vx cv cJ cK ccnp co cfv wcel vx cJ cuni wral cF vx cv cJ cK ccnp
      co cfv wcel vx cX wral cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv
      cF cfv cD clm cfv wbr wi vx cX wral wi vf wal cJ ctop wcel cK ctop wcel
      cJ cuni cK cuni cF wf cF cJ cK ccn co wcel cF vx cv cJ cK ccnp co cfv
      wcel vx cJ cuni wral wb cC cme wcel cD cme wcel wa cX cY cF wf wa vx cF
      cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid cncnp cC cme wcel cJ ctop
      wcel cD cme wcel cX cY cF wf cC cJ metcnp4.c opntop ad2antrr cD cme wcel
      cK ctop wcel cC cme wcel cX cY cF wf cD cK metcnp4.d opntop ad2antlr cC
      cme wcel cD cme wcel wa cJ cuni cK cuni cF wf cX cY cF wf cC cme wcel cJ
      cuni cK cuni cF wf cX cK cuni cF wf cD cme wcel cX cY cF wf cC cme wcel
      cJ cuni cX wceq cJ cuni cK cuni cF wf cX cK cuni cF wf wb cC cJ cX
      metcnp4.1 metcnp4.c uniopn2 cJ cuni cX cK cuni cF feq2 syl cD cme wcel cK
      cuni cY wceq cX cK cuni cF wf cX cY cF wf wb cD cK cY metcnp4.3 metcnp4.d
      uniopn2 cK cuni cY cX cF feq3 syl sylan9bb biimpar syl3anc cC cme wcel cF
      vx cv cJ cK ccnp co cfv wcel vx cJ cuni wral cF vx cv cJ cK ccnp co cfv
      wcel vx cX wral wb cD cme wcel cX cY cF wf cC cme wcel cF vx cv cJ cK
      ccnp co cfv wcel vx cJ cuni cX cC cJ cX metcnp4.1 metcnp4.c uniopn2
      raleq1d ad2antrr cC cme wcel cD cme wcel wa cX cY cF wf wa cF vx cv cJ cK
      ccnp co cfv wcel vx cX wral cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG
      vx cv cF cfv cD clm cfv wbr wi wi vf wal vx cX wral cn cX vf cv wf vf cv
      vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi vx cX wral wi vf
      wal cC cme wcel cD cme wcel wa cX cY cF wf wa cF vx cv cJ cK ccnp co cfv
      wcel cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv
      wbr wi wi vf wal vx cX cC cme wcel cD cme wcel wa cX cY cF wf wa vx cv cX
      wcel wa cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf cn cX vf cv wf vf cv
      vx cv cC clm cfv wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf wal wa cn cX
      vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi wi
      vf wal cC cme wcel cD cme wcel wa vx cv cX wcel cF vx cv cJ cK ccnp co
      cfv wcel cX cY cF wf cn cX vf cv wf vf cv vx cv cC clm cfv wbr wa cG vx
      cv cF cfv cD clm cfv wbr wi vf wal wa wb cX cY cF wf cC cme wcel cD cme
      wcel vx cv cX wcel cF vx cv cJ cK ccnp co cfv wcel cX cY cF wf cn cX vf
      cv wf vf cv vx cv cC clm cfv wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf
      wal wa wb vy cC cD vx cv vf vj cF cG cJ cK cX cY metcnp4.1 metcnp4.3
      metcnp4.c metcnp4.d metcnp4.5 metcnp4 3expa adantlr cC cme wcel cD cme
      wcel wa cX cY cF wf wa vx cv cX wcel wa cn cX vf cv wf vf cv vx cv cC clm
      cfv wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf wal cX cY cF wf cn cX vf
      cv wf vf cv vx cv cC clm cfv wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf
      wal wa cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm
      cfv wbr wi wi vf wal cX cY cF wf cn cX vf cv wf vf cv vx cv cC clm cfv
      wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf wal cX cY cF wf cn cX vf cv
      wf vf cv vx cv cC clm cfv wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf wal
      wa wb cC cme wcel cD cme wcel wa vx cv cX wcel cX cY cF wf cn cX vf cv wf
      vf cv vx cv cC clm cfv wbr wa cG vx cv cF cfv cD clm cfv wbr wi vf wal
      ibar ad2antlr cn cX vf cv wf vf cv vx cv cC clm cfv wbr wa cG vx cv cF
      cfv cD clm cfv wbr wi cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv
      cF cfv cD clm cfv wbr wi wi vf cn cX vf cv wf vf cv vx cv cC clm cfv wbr
      cG vx cv cF cfv cD clm cfv wbr impexp albii syl5rbbr bitrd ralbidva cn cX
      vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi wi
      vf wal vx cX wral cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF
      cfv cD clm cfv wbr wi wi vx cX wral vf wal cn cX vf cv wf vf cv vx cv cC
      clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi vx cX wral wi vf wal cn cX
      vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi wi
      vx vf cX ralcom4 cn cX vf cv wf vf cv vx cv cC clm cfv wbr cG vx cv cF
      cfv cD clm cfv wbr wi wi vx cX wral cn cX vf cv wf vf cv vx cv cC clm cfv
      wbr cG vx cv cF cfv cD clm cfv wbr wi vx cX wral wi vf cn cX vf cv wf vf
      cv vx cv cC clm cfv wbr cG vx cv cF cfv cD clm cfv wbr wi vx cX r19.21v
      albii bitri syl6bb 3bitrd 3impa $.
      $( [18-Nov-2007] $) $( [13-Jun-2007] $)
  $}


  ${
    $d g p C $.  $d g j p y D $.  $d g j p y F $.  $d g j p y G $.  $d g p H $.
    $d p J $.  $d p K $.  $d p P $.  $d g j p X $.
    metcn4i.1 $e |- X = dom dom C $.
    metcn4i.c $e |- J = ( Open ` C ) $.
    metcn4i.d $e |- K = ( Open ` D ) $.
    metcn4i.5 $e |- H = { <. j , y >. | ( j e. NN /\ y = ( F ` ( G ` j ) ) )
                    } $.
    metcn4i.p $e |- P e. _V $.
    $( Convergence carries through a continuous mapping. $)
    metcn4i $p |- ( ( ( C e. Met /\ D e. Met /\ F e. ( J Cn K ) ) /\ (
       G : NN --> X /\ G ( ~~>m ` C ) P ) ) -> H ( ~~>m ` D ) ( F ` P ) ) $=
      cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cn cX cG wf cG cP cC clm
      cfv wbr wa wa cP cX wcel cH cP cF cfv cD clm cfv wbr cC cme wcel cF cJ cK
      ccn co wcel cn cX cG wf cG cP cC clm cfv wbr wa cP cX wcel cD cme wcel cC
      cme wcel cG cP cC clm cfv wbr cP cX wcel cF cJ cK ccn co wcel cn cX cG wf
      cC cme wcel cP cvv wcel cG cP cC clm cfv wbr cP cX wcel metcn4i.p cvv cC
      cP cG cX metcn4i.1 lmcl mp3an2 ad2ant2rl 3adantl2 cC cme wcel cD cme wcel
      cF cJ cK ccn co wcel w3a cn cX cG wf cG cP cC clm cfv wbr cP cX wcel cH
      cP cF cfv cD clm cfv wbr wi cC cme wcel cD cme wcel cF cJ cK ccn co wcel
      w3a cn cX cG wf cG cP cC clm cfv wbr cP cX wcel cH cP cF cfv cD clm cfv
      wbr wi wi cP cX wcel cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cn
      cX cG wf wa cG cP cC clm cfv wbr cH cP cF cfv cD clm cfv wbr cP cX wcel
      cG vp cv cC clm cfv wbr cH vp cv cF cfv cD clm cfv wbr wi vp cX wral cG
      cP cC clm cfv wbr cH cP cF cfv cD clm cfv wbr wi cC cme wcel cD cme wcel
      cF cJ cK ccn co wcel w3a cn cX cG wf wa cG vp cv cC clm cfv wbr cH vp cv
      cF cfv cD clm cfv wbr wi cG cP cC clm cfv wbr cH cP cF cfv cD clm cfv wbr
      wi vp cP cX vp cv cP wceq cG vp cv cC clm cfv wbr cG cP cC clm cfv wbr cH
      vp cv cF cfv cD clm cfv wbr cH cP cF cfv cD clm cfv wbr vp cv cP cG cC
      clm cfv breq2 vp cv cP wceq vp cv cF cfv cP cF cfv cH cD clm cfv vp cv cP
      cF fveq2 breq2d imbi12d rcla4v cC cme wcel cD cme wcel cF cJ cK ccn co
      wcel w3a cn cX cG wf cG vp cv cC clm cfv wbr cH vp cv cF cfv cD clm cfv
      wbr wi vp cX wral cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cn cX
      cG wf cG cvv wcel cG vp cv cC clm cfv wbr cH vp cv cF cfv cD clm cfv wbr
      wi vp cX wral cn cX cG wf cn cvv wcel cG cvv wcel nnex cn cX cvv cG fex
      mpan2 cG cvv wcel cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cn cX
      cG wf cG vp cv cC clm cfv wbr cH vp cv cF cfv cD clm cfv wbr wi vp cX
      wral cG cvv wcel cn cX vg cv wf vg cv vp cv cC clm cfv wbr vj cv cn wcel
      vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF cfv cD clm cfv
      wbr wi vp cX wral wi vg wal cn cX cG wf cG vp cv cC clm cfv wbr cH vp cv
      cF cfv cD clm cfv wbr wi vp cX wral wi cC cme wcel cD cme wcel cF cJ cK
      ccn co wcel w3a cn cX vg cv wf vg cv vp cv cC clm cfv wbr vj cv cn wcel
      vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF cfv cD clm cfv
      wbr wi vp cX wral wi cn cX cG wf cG vp cv cC clm cfv wbr cH vp cv cF cfv
      cD clm cfv wbr wi vp cX wral wi vg cG cvv vg cv cG wceq cn cX vg cv wf cn
      cX cG wf vg cv vp cv cC clm cfv wbr vj cv cn wcel vy cv vj cv vg cv cfv
      cF cfv wceq wa vj vy copab vp cv cF cfv cD clm cfv wbr wi vp cX wral cG
      vp cv cC clm cfv wbr cH vp cv cF cfv cD clm cfv wbr wi vp cX wral cn cX
      vg cv cG feq1 vg cv cG wceq vg cv vp cv cC clm cfv wbr vj cv cn wcel vy
      cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF cfv cD clm cfv wbr
      wi cG vp cv cC clm cfv wbr cH vp cv cF cfv cD clm cfv wbr wi vp cX vg cv
      cG wceq vg cv vp cv cC clm cfv wbr cG vp cv cC clm cfv wbr vj cv cn wcel
      vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF cfv cD clm cfv
      wbr cH vp cv cF cfv cD clm cfv wbr vg cv cG vp cv cC clm cfv breq1 vg cv
      cG wceq vj cv cn wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab cH
      vp cv cF cfv cD clm cfv vg cv cG wceq vj cv cn wcel vy cv vj cv vg cv cfv
      cF cfv wceq wa vj vy copab vj cv cn wcel vy cv vj cv cG cfv cF cfv wceq
      wa vj vy copab cH vg cv cG wceq vj cv cn wcel vy cv vj cv vg cv cfv cF
      cfv wceq wa vj cv cn wcel vy cv vj cv cG cfv cF cfv wceq wa vj vy vg cv
      cG wceq vy cv vj cv vg cv cfv cF cfv wceq vy cv vj cv cG cfv cF cfv wceq
      vj cv cn wcel vg cv cG wceq vj cv vg cv cfv cF cfv vj cv cG cfv cF cfv vy
      cv vg cv cG wceq vj cv vg cv cfv vj cv cG cfv cF vj cv vg cv cG fveq1
      fveq2d eqeq2d anbi2d opabbidv metcn4i.5 syl6eqr breq1d imbi12d ralbidv
      imbi12d cla4gv cC cme wcel cD cme wcel cF cJ cK ccn co wcel w3a cX cD cdm
      cdm cF wf cn cX vg cv wf vg cv vp cv cC clm cfv wbr vj cv cn wcel vy cv
      vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF cfv cD clm cfv wbr wi
      vp cX wral wi vg wal cC cD cF cJ cK cX cD cdm cdm metcn4i.1 cD cdm cdm
      eqid metcn4i.c metcn4i.d metcnf cC cme wcel cD cme wcel cF cJ cK ccn co
      wcel cX cD cdm cdm cF wf cn cX vg cv wf vg cv vp cv cC clm cfv wbr vj cv
      cn wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF cfv cD
      clm cfv wbr wi vp cX wral wi vg wal wi cC cme wcel cD cme wcel cX cD cdm
      cdm cF wf cF cJ cK ccn co wcel cn cX vg cv wf vg cv vp cv cC clm cfv wbr
      vj cv cn wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv cF
      cfv cD clm cfv wbr wi vp cX wral wi vg wal cC cme wcel cD cme wcel cX cD
      cdm cdm cF wf cF cJ cK ccn co wcel cn cX vg cv wf vg cv vp cv cC clm cfv
      wbr vj cv cn wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab vp cv
      cF cfv cD clm cfv wbr wi vp cX wral wi vg wal wi cC cme wcel cD cme wcel
      cX cD cdm cdm cF wf w3a cF cJ cK ccn co wcel cn cX vg cv wf vg cv vp cv
      cC clm cfv wbr vj cv cn wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy
      copab vp cv cF cfv cD clm cfv wbr wi vp cX wral wi vg wal vp vy cC cD vg
      vj cF vj cv cn wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab cJ
      cK cX cD cdm cdm metcn4i.1 cD cdm cdm eqid metcn4i.c metcn4i.d vj cv cn
      wcel vy cv vj cv vg cv cfv cF cfv wceq wa vj vy copab eqid metcn4 biimpd
      3exp com34 3imp mpd syl5 com3l mpdi imp syl5 com3l ex imp32 mpd $.
      $( [7-Jan-2008] $) $( [25-Dec-2007] $)
  $}

  ${
    $d j m n p v x y z B $.  $d j m n p v x y z C $.  $d j m v D $.
    $d j m n p v x y z R $.  $d j m n p v x y z S $.  $d j k m n v w x y z X $.
    $d j k m p v w x y z Y $.
    xplm.a $e |- R e. _V $.
    xplm.b $e |- S e. _V $.
    xplm.1 $e |- X = dom dom B $.
    xplm.3 $e |- Y = dom dom C $.
    xplm.5 $e |- B e. Met $.
    xplm.6 $e |- C e. Met $.
    xplm.7 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( X X. Y )
         /\ y e. ( X X. Y ) ) /\ z = sup ( { ( ( 1st ` x ) B ( 1st ` y )
            ) , ( ( 2nd ` x ) C ( 2nd ` y ) ) } , RR , < ) ) } $.
    ${
      $d j m v x y z F $.  $d j m v x y z G $.  $d j k m v w H $.
      xplmi.9 $e |- F =
              { <. k , w >. | ( k e. NN /\ w = ( 1st ` ( H ` k ) ) ) } $.
      xplmi.10 $e |- G =
              { <. k , w >. | ( k e. NN /\ w = ( 2nd ` ( H ` k ) ) ) } $.
      $( Two sequences converge if the sequence of their ordered pairs
         converges.  One direction of Proposition 14-2.6 of [Gleason] p. 230.
         _Warning:  The HTML proof page is 0.5MB in size_. $)
      xplmi $p |- ( ( H : NN --> ( X X. Y ) /\ H ( ~~>m ` D ) <. R , S >. )
           -> ( ( F : NN --> X /\ F ( ~~>m ` B ) R ) /\
                ( G : NN --> Y /\ G ( ~~>m ` C ) S ) ) ) $=
        cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cn cX cF wf cF cR cB clm
        cfv wbr wa cn cY cG wf cG cS cC clm cfv wbr wa wa cn cX cY cxp cH wf cH
        cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa wa cn cX cF wf cF cR
        cB clm cfv wbr wa cn cY cG wf cG cS cC clm cfv wbr wa wa cH cR cS cop
        cD clm cfv wbr cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX
        wcel cS cY wcel wa wa cn cX cF wf cF cR cB clm cfv wbr wa cn cY cG wf
        cG cS cC clm cfv wbr wa cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr
        cR cX wcel cS cY wcel wa wa cF cR cB clm cfv wbr cn cX cF wf cn cX cY
        cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa wa cR cX
        wcel cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv
        clt wbr wi vm cn wral vj cn wrex wi vv cr wral wa cF cR cB clm cfv wbr
        cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa
        wa cR cX wcel cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv cF cfv cR cB
        co vv cv clt wbr wi vm cn wral vj cn wrex wi vv cr wral cH cR cS cop cD
        clm cfv wbr cR cX wcel cS cY wcel wa wa cR cX wcel wi cn cX cY cxp cH
        wf cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel simprl a1i cn cX
        cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa wa
        cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt
        wbr wi vm cn wral vj cn wrex wi vv cr cn cX cY cxp cH wf cH cR cS cop
        cD clm cfv wbr cR cX wcel cS cY wcel wa wa vv cv cr wcel cc0 vv cv clt
        wbr vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn
        wral vj cn wrex cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX
        wcel cS cY wcel wa wa wa vv cv cr wcel cc0 vv cv clt wbr wa wa vj cv vm
        cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj
        cn wrex vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm
        cn wral vj cn wrex cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa
        wa vv cv cr wcel cc0 vv cv clt wbr wa vj cv vm cv cle wbr vm cv cH cfv
        cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex cn cX cY cxp cH
        wf cH cR cS cop cD clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa vj cv
        vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral
        vj cn wrex cR cX wcel cS cY wcel wa cR cS cop cvv wcel cH cR cS cop cD
        clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa vj cv vm cv cle wbr vm
        cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex cR cS
        opex cD cme wcel cR cS cop cvv wcel cH cR cS cop cD clm cfv wbr vv cv
        cr wcel cc0 vv cv clt wbr wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop
        cD co vv cv clt wbr wi vm cn wral vj cn wrex vx vy vz cB cC cD cX cY
        xplm.1 xplm.3 xplm.5 xplm.6 xplm.7 metxp cvv cD cR cS cop vv cv vj vm
        cH c1 cX cY cxp cn cD cdm cdm cX cY cxp cX cY cxp cxp cdm cX cY cxp cD
        cdm cX cY cxp cX cY cxp cxp vx vy vz cX cY cxp cX cY cxp vx cv c1st cfv
        vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt
        csup cD cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv
        c2nd cfv cC co cpr clt ltso supex xplm.7 dmoprab2 dmeqi cX cY cxp
        dmxpid eqtr2i 1z nnuz lmcvg2 mp3anl1 mpanl1 adantlr adantll cn cX cY
        cxp cH wf cR cX wcel cS cY wcel wa vv cv cr wcel cc0 vv cv clt wbr wa
        vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn
        wral vj cn wrex vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr
        wi vm cn wral vj cn wrex wi cH cR cS cop cD clm cfv wbr cn cX cY cxp cH
        wf cR cX wcel cS cY wcel wa wa vv cv cr wcel vj cv vm cv cle wbr vm cv
        cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex vj cv vm
        cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn wral vj cn wrex
        wi cc0 vv cv clt wbr cn cX cY cxp cH wf cR cX wcel cS cY wcel wa wa vv
        cv cr wcel wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv
        clt wbr wi vm cn wral vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv
        clt wbr wi vm cn wral vj cn cn cX cY cxp cH wf cR cX wcel cS cY wcel wa
        wa vv cv cr wcel wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv
        cv clt wbr wi vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr
        wi vm cn cn cX cY cxp cH wf cR cX wcel cS cY wcel wa wa vv cv cr wcel
        wa vm cv cn wcel wa vm cv cH cfv cR cS cop cD co vv cv clt wbr vm cv cF
        cfv cR cB co vv cv clt wbr vj cv vm cv cle wbr cn cX cY cxp cH wf cR cX
        wcel cS cY wcel wa vv cv cr wcel vm cv cn wcel vm cv cH cfv cR cS cop
        cD co vv cv clt wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cv cn
        wcel cn cX cY cxp cH wf cR cX wcel cS cY wcel wa vv cv cr wcel vm cv cH
        cfv cR cS cop cD co vv cv clt wbr vm cv cF cfv cR cB co vv cv clt wbr
        wi cn cX cY cxp cH wf vm cv cn wcel cR cX wcel cS cY wcel wa vv cv cr
        wcel vm cv cH cfv cR cS cop cD co vv cv clt wbr vm cv cF cfv cR cB co
        vv cv clt wbr wi wi wi cn cX cY cxp cH wf vm cv cn wcel cR cX wcel cS
        cY wcel wa vv cv cr wcel vm cv cH cfv cR cS cop cD co vv cv clt wbr vm
        cv cF cfv cR cB co vv cv clt wbr wi cn cX cY cxp cH wf vm cv cn wcel wa
        cR cX wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cH cfv cR cS cop cD
        co vv cv clt wbr vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv
        clt wbr vm cv cF cfv cR cB co vv cv clt wbr cn cX cY cxp cH wf vm cv cn
        wcel wa vm cv cH cfv cR cS cop cD co vv cv clt wbr vm cv cF cfv vm cv
        cG cfv cop cR cS cop cD co vv cv clt wbr wb cR cX wcel cS cY wcel wa vv
        cv cr wcel wa cn cX cY cxp cH wf vm cv cn wcel wa vm cv cH cfv cR cS
        cop cD co vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv clt cn cX
        cY cxp cH wf vm cv cn wcel wa vm cv cH cfv vm cv cF cfv vm cv cG cfv
        cop cR cS cop cD cn cX cY cxp cH wf vm cv cn wcel wa vm cv cH cfv vm cv
        cH cfv c1st cfv vm cv cH cfv c2nd cfv cop vm cv cF cfv vm cv cG cfv cop
        cn cX cY cxp cH wf vm cv cn wcel wa vm cv cH cfv cX cY cxp wcel vm cv
        cH cfv vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cop wceq cn cX cY
        cxp vm cv cH ffvelrn vm cv cH cfv cX cY cxp wcel vm cv cH cfv vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cop wceq vm cv cH cfv c1st cfv cX
        wcel vm cv cH cfv c2nd cfv cY wcel wa vm cv cH cfv cX cY elxp6 pm3.26bi
        syl vm cv cn wcel vm cv cF cfv vm cv cG cfv cop vm cv cH cfv c1st cfv
        vm cv cH cfv c2nd cfv cop wceq cn cX cY cxp cH wf vm cv cn wcel vm cv
        cF cfv vm cv cH cfv c1st cfv vm cv cG cfv vm cv cH cfv c2nd cfv vk vw
        vm cv vk cv cH cfv c1st cfv vm cv cH cfv c1st cfv cn cF vk cv vm cv
        wceq vk cv cH cfv vm cv cH cfv c1st vk cv vm cv cH fveq2 fveq2d xplmi.9
        vm cv cH cfv c1st fvex fvopab4 vk vw vm cv vk cv cH cfv c2nd cfv vm cv
        cH cfv c2nd cfv cn cG vk cv vm cv wceq vk cv cH cfv vm cv cH cfv c2nd
        vk cv vm cv cH fveq2 fveq2d xplmi.10 vm cv cH cfv c2nd fvex fvopab4
        opeq12d adantl eqtr4d opreq1d breq1d adantr cn cX cY cxp cH wf vm cv cn
        wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cF cfv vm cv
        cG cfv cop cR cS cop cD co vv cv clt wbr vm cv cF cfv cR cB co vv cv
        clt wbr wi vm cv cG cfv cS cC co vm cv cF cfv cR cB co cn cX cY cxp cH
        wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vm cv cG cfv cS cC co cr
        wcel vv cv cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cS cY wcel vm cv
        cG cfv cS cC co cr wcel cR cX wcel vm cv cG cfv cY wcel cS cY wcel vm
        cv cG cfv cS cC co cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cC cme
        wcel vm cv cG cfv cY wcel cS cY wcel vm cv cG cfv cS cC co cr wcel
        xplm.6 vm cv cG cfv cS cC cY xplm.3 metcl mp3an1 cn cY cG wf vm cv cn
        wcel vm cv cG cfv cY wcel cn cX cY cxp cH wf cn cY vm cv cG ffvelrn cn
        cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn wral cn cY cG wf cn
        cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn cn cX cY cxp cH wf
        vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c2nd cfv cY
        wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY
        cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk
        cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.27d
        syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd cfv cG xplmi.10 fopab2
        sylib sylan sylan adantrl adantrr cn cX cY cxp cH wf vm cv cn wcel wa
        cR cX wcel cS cY wcel wa vm cv cF cfv cR cB co cr wcel vv cv cr wcel cn
        cX cY cxp cH wf vm cv cn wcel wa cR cX wcel vm cv cF cfv cR cB co cr
        wcel cS cY wcel vm cv cF cfv cX wcel cR cX wcel vm cv cF cfv cR cB co
        cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cB cme wcel vm cv cF cfv cX
        wcel cR cX wcel vm cv cF cfv cR cB co cr wcel xplm.5 vm cv cF cfv cR cB
        cX xplm.1 metcl mp3an1 cn cX cF wf vm cv cn wcel vm cv cF cfv cX wcel
        cn cX cY cxp cH wf cn cX vm cv cF ffvelrn cn cX cY cxp cH wf vk cv cH
        cfv c1st cfv cX wcel vk cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH
        cfv c1st cfv cX wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH
        cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH
        ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv
        cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw
        cn cX vk cv cH cfv c1st cfv cF xplmi.9 fopab2 sylib sylan sylan adantrr
        adantrr cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vm
        cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr vm cv cF cfv vm cv cG
        cfv cop cR cS cop cD co vv cv clt wbr vm cv cF cfv cR cB co vv cv clt
        wbr wi vv cv cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS
        cY wcel wa wa vm cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr wa vm
        cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv clt wbr vm cv cF cfv
        cR cB co vv cv clt wbr cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel
        cS cY wcel wa wa vm cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr wa
        vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vm cv cF cfv cR cB co vv
        cv clt vm cv cF cfv vm cv cG cfv cop cX cY cxp wcel cR cS cop cX cY cxp
        wcel wa vm cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr vm cv cF
        cfv vm cv cG cfv cop cR cS cop cD co vm cv cF cfv cR cB co wceq cn cX
        cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa wa vx vy vz cB
        cC cD vm cv cF cfv vm cv cG cfv cop cR cS cop vm cv cF cfv vm cv cG cfv
        cR cS cX cY xplm.1 xplm.3 xplm.5 xplm.6 xplm.7 vm cv cF cfv vm cv cG
        cfv cop c1st cfv vm cv cF cfv vm cv cF cfv vm cv cG cfv vm cv cF fvex
        op1st eqcomi vm cv cF cfv vm cv cG cfv cop c2nd cfv vm cv cG cfv vm cv
        cF cfv vm cv cG cfv vm cv cF fvex vm cv cG fvex op2nd eqcomi cR cS cop
        c1st cfv cR cR cS xplm.a op1st eqcomi cR cS cop c2nd cfv cS cR cS
        xplm.a xplm.b op2nd eqcomi metxptval cn cX cY cxp cH wf vm cv cn wcel
        wa vm cv cF cfv vm cv cG cfv cop cX cY cxp wcel cR cX wcel cS cY wcel
        wa cR cS cop cX cY cxp wcel vm cv cF cfv cX wcel vm cv cG cfv cY wcel
        vm cv cF cfv vm cv cG cfv cop cX cY cxp wcel cn cX cY cxp cH wf vm cv
        cn wcel wa vm cv cF cfv vm cv cG cfv cX cY opelxpi cn cX cF wf vm cv cn
        wcel vm cv cF cfv cX wcel cn cX cY cxp cH wf cn cX vm cv cF ffvelrn cn
        cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk cn wral cn cX cF wf cn
        cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk cn cn cX cY cxp cH wf
        vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX
        wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY
        cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk
        cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.26d
        syl r19.21aiva vk vw cn cX vk cv cH cfv c1st cfv cF xplmi.9 fopab2
        sylib sylan cn cY cG wf vm cv cn wcel vm cv cG cfv cY wcel cn cX cY cxp
        cH wf cn cY vm cv cG ffvelrn cn cX cY cxp cH wf vk cv cH cfv c2nd cfv
        cY wcel vk cn wral cn cY cG wf cn cX cY cxp cH wf vk cv cH cfv c2nd cfv
        cY wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY
        cxp wcel vk cv cH cfv c2nd cfv cY wcel cn cX cY cxp vk cv cH ffvelrn vk
        cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp
        wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk
        cv cH cfv cX cY elxp7 pm3.27bi pm3.27d syl r19.21aiva vk vw cn cY vk cv
        cH cfv c2nd cfv cG xplmi.10 fopab2 sylib sylan sylanc cR cS cX cY
        opelxpi anim12i sylan breq1d biimpd adantlrr cn cX cY cxp cH wf vm cv
        cn wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cF cfv cR
        cB co vm cv cG cfv cS cC co cle wbr wa vm cv cF cfv vm cv cG cfv cop cR
        cS cop cD co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr vm cv cF
        cfv cR cB co vv cv clt wbr cn cX cY cxp cH wf vm cv cn wcel wa cR cX
        wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cF cfv cR cB co vm cv cG
        cfv cS cC co cle wbr wa vm cv cF cfv vm cv cG cfv cop cR cS cop cD co
        vm cv cG cfv cS cC co vv cv clt cn cX cY cxp cH wf vm cv cn wcel wa cR
        cX wcel cS cY wcel wa vm cv cF cfv cR cB co vm cv cG cfv cS cC co cle
        wbr vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vm cv cG cfv cS cC co
        wceq vv cv cr wcel vm cv cF cfv vm cv cG cfv cop cX cY cxp wcel cR cS
        cop cX cY cxp wcel wa vm cv cF cfv cR cB co vm cv cG cfv cS cC co cle
        wbr vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vm cv cG cfv cS cC co
        wceq cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa wa vx
        vy vz cB cC cD vm cv cF cfv vm cv cG cfv cop cR cS cop vm cv cF cfv vm
        cv cG cfv cR cS cX cY xplm.1 xplm.3 xplm.5 xplm.6 xplm.7 vm cv cF cfv
        vm cv cG cfv cop c1st cfv vm cv cF cfv vm cv cF cfv vm cv cG cfv vm cv
        cF fvex op1st eqcomi vm cv cF cfv vm cv cG cfv cop c2nd cfv vm cv cG
        cfv vm cv cF cfv vm cv cG cfv vm cv cF fvex vm cv cG fvex op2nd eqcomi
        cR cS cop c1st cfv cR cR cS xplm.a op1st eqcomi cR cS cop c2nd cfv cS
        cR cS xplm.a xplm.b op2nd eqcomi metxpfval cn cX cY cxp cH wf vm cv cn
        wcel wa vm cv cF cfv vm cv cG cfv cop cX cY cxp wcel cR cX wcel cS cY
        wcel wa cR cS cop cX cY cxp wcel vm cv cF cfv cX wcel vm cv cG cfv cY
        wcel vm cv cF cfv vm cv cG cfv cop cX cY cxp wcel cn cX cY cxp cH wf vm
        cv cn wcel wa vm cv cF cfv vm cv cG cfv cX cY opelxpi cn cX cF wf vm cv
        cn wcel vm cv cF cfv cX wcel cn cX cY cxp cH wf cn cX vm cv cF ffvelrn
        cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk cn wral cn cX cF wf
        cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk cn cn cX cY cxp cH
        wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv
        cX wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv
        cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX
        cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi
        pm3.26d syl r19.21aiva vk vw cn cX vk cv cH cfv c1st cfv cF xplmi.9
        fopab2 sylib sylan cn cY cG wf vm cv cn wcel vm cv cG cfv cY wcel cn cX
        cY cxp cH wf cn cY vm cv cG ffvelrn cn cX cY cxp cH wf vk cv cH cfv
        c2nd cfv cY wcel vk cn wral cn cY cG wf cn cX cY cxp cH wf vk cv cH cfv
        c2nd cfv cY wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv
        cX cY cxp wcel vk cv cH cfv c2nd cfv cY wcel cn cX cY cxp vk cv cH
        ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv
        cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.27d syl r19.21aiva vk vw
        cn cY vk cv cH cfv c2nd cfv cG xplmi.10 fopab2 sylib sylan sylanc cR cS
        cX cY opelxpi anim12i sylan adantlrr breq1d cn cX cY cxp cH wf vm cv cn
        wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cF cfv cR cB
        co vm cv cG cfv cS cC co cle wbr vm cv cG cfv cS cC co vv cv clt wbr vm
        cv cF cfv cR cB co vv cv clt wbr vm cv cF cfv cR cB co cr wcel vm cv cG
        cfv cS cC co cr wcel vv cv cr wcel vm cv cF cfv cR cB co vm cv cG cfv
        cS cC co cle wbr vm cv cG cfv cS cC co vv cv clt wbr wa vm cv cF cfv cR
        cB co vv cv clt wbr wi cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel
        cS cY wcel wa vv cv cr wcel wa wa vm cv cF cfv cR cB co vm cv cG cfv cS
        cC co vv cv lelttr cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY
        wcel wa vm cv cF cfv cR cB co cr wcel vv cv cr wcel cn cX cY cxp cH wf
        vm cv cn wcel wa cR cX wcel vm cv cF cfv cR cB co cr wcel cS cY wcel vm
        cv cF cfv cX wcel cR cX wcel vm cv cF cfv cR cB co cr wcel cn cX cY cxp
        cH wf vm cv cn wcel wa cB cme wcel vm cv cF cfv cX wcel cR cX wcel vm
        cv cF cfv cR cB co cr wcel xplm.5 vm cv cF cfv cR cB cX xplm.1 metcl
        mp3an1 cn cX cF wf vm cv cn wcel vm cv cF cfv cX wcel cn cX cY cxp cH
        wf cn cX vm cv cF ffvelrn cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX
        wcel vk cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX
        wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY cxp
        wcel vk cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH ffvelrn vk cv
        cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd
        cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp wcel
        vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk cv cH
        cfv cX cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw cn cX vk cv cH
        cfv c1st cfv cF xplmi.9 fopab2 sylib sylan sylan adantrr adantrr cn cX
        cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vm cv cG cfv cS
        cC co cr wcel vv cv cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cS cY
        wcel vm cv cG cfv cS cC co cr wcel cR cX wcel vm cv cG cfv cY wcel cS
        cY wcel vm cv cG cfv cS cC co cr wcel cn cX cY cxp cH wf vm cv cn wcel
        wa cC cme wcel vm cv cG cfv cY wcel cS cY wcel vm cv cG cfv cS cC co cr
        wcel xplm.6 vm cv cG cfv cS cC cY xplm.3 metcl mp3an1 cn cY cG wf vm cv
        cn wcel vm cv cG cfv cY wcel cn cX cY cxp cH wf cn cY vm cv cG ffvelrn
        cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn wral cn cY cG wf
        cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn cn cX cY cxp cH
        wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c2nd cfv
        cY wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv
        cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX
        cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi
        pm3.27d syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd cfv cG xplmi.10
        fopab2 sylib sylan sylan adantrl adantrr cn cX cY cxp cH wf vm cv cn
        wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel simprr syl3anc expdimp
        sylbid lecasei sylbid exp43 com12 com4l imp41 imim2d r19.20dva
        r19.22sdv adantrr adantlrl mpd exp43 r19.21adv jcad cn cX cY cxp cH wf
        cn cX cF wf cF cR cB clm cfv wbr cR cX wcel cc0 vv cv clt wbr vj cv vm
        cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn wral vj cn wrex
        wi vv cr wral wa wb cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk
        cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk
        cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk
        cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv
        cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX
        cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw cn cX vk cv cH cfv c1st
        cfv cF xplmi.9 fopab2 sylib cB cme wcel cR cvv wcel cn cX cF wf cF cR
        cB clm cfv wbr cR cX wcel cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv
        cF cfv cR cB co vv cv clt wbr wi vm cn wral vj cn wrex wi vv cr wral wa
        wb xplm.5 xplm.a vv cvv cB cR vj vm cF c1 cX cn xplm.1 1z nnuz lmbrf
        mp3an12 syl sylibrd cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk
        cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH cfv c1st cfv cX wcel vk
        cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk
        cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv
        cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX
        cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw cn cX vk cv cH cfv c1st
        cfv cF xplmi.9 fopab2 sylib jctild cn cX cY cxp cH wf cH cR cS cop cD
        clm cfv wbr cR cX wcel cS cY wcel wa wa cG cS cC clm cfv wbr cn cY cG
        wf cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel
        wa wa cS cY wcel cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv cG cfv cS
        cC co vv cv clt wbr wi vm cn wral vj cn wrex wi vv cr wral wa cG cS cC
        clm cfv wbr cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel
        cS cY wcel wa wa cS cY wcel cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv
        cG cfv cS cC co vv cv clt wbr wi vm cn wral vj cn wrex wi vv cr wral cH
        cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa wa cS cY wcel wi cn
        cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel
        simprr a1i cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cR cX wcel cS
        cY wcel wa wa cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv cG cfv cS cC
        co vv cv clt wbr wi vm cn wral vj cn wrex wi vv cr cn cX cY cxp cH wf
        cH cR cS cop cD clm cfv wbr cR cX wcel cS cY wcel wa wa vv cv cr wcel
        cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt
        wbr wi vm cn wral vj cn wrex cn cX cY cxp cH wf cH cR cS cop cD clm cfv
        wbr cR cX wcel cS cY wcel wa wa wa vv cv cr wcel cc0 vv cv clt wbr wa
        wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm
        cn wral vj cn wrex vj cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt
        wbr wi vm cn wral vj cn wrex cH cR cS cop cD clm cfv wbr cR cX wcel cS
        cY wcel wa wa vv cv cr wcel cc0 vv cv clt wbr wa vj cv vm cv cle wbr vm
        cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex cn cX
        cY cxp cH wf cH cR cS cop cD clm cfv wbr vv cv cr wcel cc0 vv cv clt
        wbr wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr
        wi vm cn wral vj cn wrex cR cX wcel cS cY wcel wa cR cS cop cvv wcel cH
        cR cS cop cD clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa vj cv vm cv
        cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn
        wrex cR cS opex cD cme wcel cR cS cop cvv wcel cH cR cS cop cD clm cfv
        wbr vv cv cr wcel cc0 vv cv clt wbr wa vj cv vm cv cle wbr vm cv cH cfv
        cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex vx vy vz cB cC
        cD cX cY xplm.1 xplm.3 xplm.5 xplm.6 xplm.7 metxp cvv cD cR cS cop vv
        cv vj vm cH c1 cX cY cxp cn cD cdm cdm cX cY cxp cX cY cxp cxp cdm cX
        cY cxp cD cdm cX cY cxp cX cY cxp cxp vx vy vz cX cY cxp cX cY cxp vx
        cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co
        cpr cr clt csup cD cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd
        cfv vy cv c2nd cfv cC co cpr clt ltso supex xplm.7 dmoprab2 dmeqi cX cY
        cxp dmxpid eqtr2i 1z nnuz lmcvg2 mp3anl1 mpanl1 adantlr adantll cn cX
        cY cxp cH wf cR cX wcel cS cY wcel wa vv cv cr wcel cc0 vv cv clt wbr
        wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm
        cn wral vj cn wrex vj cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt
        wbr wi vm cn wral vj cn wrex wi cH cR cS cop cD clm cfv wbr cn cX cY
        cxp cH wf cR cX wcel cS cY wcel wa wa vv cv cr wcel vj cv vm cv cle wbr
        vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex vj
        cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn wral vj
        cn wrex wi cc0 vv cv clt wbr cn cX cY cxp cH wf cR cX wcel cS cY wcel
        wa wa vv cv cr wcel wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co
        vv cv clt wbr wi vm cn wral vj cv vm cv cle wbr vm cv cG cfv cS cC co
        vv cv clt wbr wi vm cn wral vj cn cn cX cY cxp cH wf cR cX wcel cS cY
        wcel wa wa vv cv cr wcel wa vj cv vm cv cle wbr vm cv cH cfv cR cS cop
        cD co vv cv clt wbr wi vj cv vm cv cle wbr vm cv cG cfv cS cC co vv cv
        clt wbr wi vm cn cn cX cY cxp cH wf cR cX wcel cS cY wcel wa wa vv cv
        cr wcel wa vm cv cn wcel wa vm cv cH cfv cR cS cop cD co vv cv clt wbr
        vm cv cG cfv cS cC co vv cv clt wbr vj cv vm cv cle wbr cn cX cY cxp cH
        wf cR cX wcel cS cY wcel wa vv cv cr wcel vm cv cn wcel vm cv cH cfv cR
        cS cop cD co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cv
        cn wcel cn cX cY cxp cH wf cR cX wcel cS cY wcel wa vv cv cr wcel vm cv
        cH cfv cR cS cop cD co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt
        wbr wi cn cX cY cxp cH wf vm cv cn wcel cR cX wcel cS cY wcel wa vv cv
        cr wcel vm cv cH cfv cR cS cop cD co vv cv clt wbr vm cv cG cfv cS cC
        co vv cv clt wbr wi wi wi cn cX cY cxp cH wf vm cv cn wcel cR cX wcel
        cS cY wcel wa vv cv cr wcel vm cv cH cfv cR cS cop cD co vv cv clt wbr
        vm cv cG cfv cS cC co vv cv clt wbr wi cn cX cY cxp cH wf vm cv cn wcel
        wa cR cX wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cH cfv cR cS cop
        cD co vv cv clt wbr vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv
        clt wbr vm cv cG cfv cS cC co vv cv clt wbr cn cX cY cxp cH wf vm cv cn
        wcel wa vm cv cH cfv cR cS cop cD co vv cv clt wbr vm cv cF cfv vm cv
        cG cfv cop cR cS cop cD co vv cv clt wbr wb cR cX wcel cS cY wcel wa vv
        cv cr wcel wa cn cX cY cxp cH wf vm cv cn wcel wa vm cv cH cfv cR cS
        cop cD co vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv clt cn cX
        cY cxp cH wf vm cv cn wcel wa vm cv cH cfv vm cv cF cfv vm cv cG cfv
        cop cR cS cop cD cn cX cY cxp cH wf vm cv cn wcel wa vm cv cH cfv vm cv
        cH cfv c1st cfv vm cv cH cfv c2nd cfv cop vm cv cF cfv vm cv cG cfv cop
        cn cX cY cxp cH wf vm cv cn wcel wa vm cv cH cfv cX cY cxp wcel vm cv
        cH cfv vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cop wceq cn cX cY
        cxp vm cv cH ffvelrn vm cv cH cfv cX cY cxp wcel vm cv cH cfv vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cop wceq vm cv cH cfv c1st cfv cX
        wcel vm cv cH cfv c2nd cfv cY wcel wa vm cv cH cfv cX cY elxp6 pm3.26bi
        syl vm cv cn wcel vm cv cF cfv vm cv cG cfv cop vm cv cH cfv c1st cfv
        vm cv cH cfv c2nd cfv cop wceq cn cX cY cxp cH wf vm cv cn wcel vm cv
        cF cfv vm cv cH cfv c1st cfv vm cv cG cfv vm cv cH cfv c2nd cfv vk vw
        vm cv vk cv cH cfv c1st cfv vm cv cH cfv c1st cfv cn cF vk cv vm cv
        wceq vk cv cH cfv vm cv cH cfv c1st vk cv vm cv cH fveq2 fveq2d xplmi.9
        vm cv cH cfv c1st fvex fvopab4 vk vw vm cv vk cv cH cfv c2nd cfv vm cv
        cH cfv c2nd cfv cn cG vk cv vm cv wceq vk cv cH cfv vm cv cH cfv c2nd
        vk cv vm cv cH fveq2 fveq2d xplmi.10 vm cv cH cfv c2nd fvex fvopab4
        opeq12d adantl eqtr4d opreq1d breq1d adantr cn cX cY cxp cH wf vm cv cn
        wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel wa wa vm cv cF cfv vm cv
        cG cfv cop cR cS cop cD co vv cv clt wbr vm cv cG cfv cS cC co vv cv
        clt wbr wi vm cv cG cfv cS cC co vm cv cF cfv cR cB co cn cX cY cxp cH
        wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vm cv cG cfv cS cC co cr
        wcel vv cv cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cS cY wcel vm cv
        cG cfv cS cC co cr wcel cR cX wcel vm cv cG cfv cY wcel cS cY wcel vm
        cv cG cfv cS cC co cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cC cme
        wcel vm cv cG cfv cY wcel cS cY wcel vm cv cG cfv cS cC co cr wcel
        xplm.6 vm cv cG cfv cS cC cY xplm.3 metcl mp3an1 cn cY cG wf vm cv cn
        wcel vm cv cG cfv cY wcel cn cX cY cxp cH wf cn cY vm cv cG ffvelrn cn
        cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn wral cn cY cG wf cn
        cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn cn cX cY cxp cH wf
        vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c2nd cfv cY
        wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY
        cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk
        cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.27d
        syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd cfv cG xplmi.10 fopab2
        sylib sylan sylan adantrl adantrr cn cX cY cxp cH wf vm cv cn wcel wa
        cR cX wcel cS cY wcel wa vm cv cF cfv cR cB co cr wcel vv cv cr wcel cn
        cX cY cxp cH wf vm cv cn wcel wa cR cX wcel vm cv cF cfv cR cB co cr
        wcel cS cY wcel vm cv cF cfv cX wcel cR cX wcel vm cv cF cfv cR cB co
        cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cB cme wcel vm cv cF cfv cX
        wcel cR cX wcel vm cv cF cfv cR cB co cr wcel xplm.5 vm cv cF cfv cR cB
        cX xplm.1 metcl mp3an1 cn cX cF wf vm cv cn wcel vm cv cF cfv cX wcel
        cn cX cY cxp cH wf cn cX vm cv cF ffvelrn cn cX cY cxp cH wf vk cv cH
        cfv c1st cfv cX wcel vk cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH
        cfv c1st cfv cX wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH
        cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH
        ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv
        cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw
        cn cX vk cv cH cfv c1st cfv cF xplmi.9 fopab2 sylib sylan sylan adantrr
        adantrr cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vv
        cv cr wcel wa wa vm cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr wa
        vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv clt wbr vm cv cF
        cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr cn cX cY
        cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel wa wa
        vm cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr wa vm cv cF cfv vm
        cv cG cfv cop cR cS cop cD co vm cv cF cfv cR cB co vv cv clt cn cX cY
        cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vm cv cG cfv cS cC
        co vm cv cF cfv cR cB co cle wbr vm cv cF cfv vm cv cG cfv cop cR cS
        cop cD co vm cv cF cfv cR cB co wceq vv cv cr wcel vm cv cF cfv vm cv
        cG cfv cop cX cY cxp wcel cR cS cop cX cY cxp wcel wa vm cv cG cfv cS
        cC co vm cv cF cfv cR cB co cle wbr vm cv cF cfv vm cv cG cfv cop cR cS
        cop cD co vm cv cF cfv cR cB co wceq cn cX cY cxp cH wf vm cv cn wcel
        wa cR cX wcel cS cY wcel wa wa vx vy vz cB cC cD vm cv cF cfv vm cv cG
        cfv cop cR cS cop vm cv cF cfv vm cv cG cfv cR cS cX cY xplm.1 xplm.3
        xplm.5 xplm.6 xplm.7 vm cv cF cfv vm cv cG cfv cop c1st cfv vm cv cF
        cfv vm cv cF cfv vm cv cG cfv vm cv cF fvex op1st eqcomi vm cv cF cfv
        vm cv cG cfv cop c2nd cfv vm cv cG cfv vm cv cF cfv vm cv cG cfv vm cv
        cF fvex vm cv cG fvex op2nd eqcomi cR cS cop c1st cfv cR cR cS xplm.a
        op1st eqcomi cR cS cop c2nd cfv cS cR cS xplm.a xplm.b op2nd eqcomi
        metxptval cn cX cY cxp cH wf vm cv cn wcel wa vm cv cF cfv vm cv cG cfv
        cop cX cY cxp wcel cR cX wcel cS cY wcel wa cR cS cop cX cY cxp wcel vm
        cv cF cfv cX wcel vm cv cG cfv cY wcel vm cv cF cfv vm cv cG cfv cop cX
        cY cxp wcel cn cX cY cxp cH wf vm cv cn wcel wa vm cv cF cfv vm cv cG
        cfv cX cY opelxpi cn cX cF wf vm cv cn wcel vm cv cF cfv cX wcel cn cX
        cY cxp cH wf cn cX vm cv cF ffvelrn cn cX cY cxp cH wf vk cv cH cfv
        c1st cfv cX wcel vk cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH cfv
        c1st cfv cX wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv
        cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH
        ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv
        cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw
        cn cX vk cv cH cfv c1st cfv cF xplmi.9 fopab2 sylib sylan cn cY cG wf
        vm cv cn wcel vm cv cG cfv cY wcel cn cX cY cxp cH wf cn cY vm cv cG
        ffvelrn cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn wral cn
        cY cG wf cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn cn cX
        cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv
        c2nd cfv cY wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp
        wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv
        cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st
        cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7
        pm3.27bi pm3.27d syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd cfv cG
        xplmi.10 fopab2 sylib sylan sylanc cR cS cX cY opelxpi anim12i sylan
        adantlrr breq1d cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY
        wcel wa vv cv cr wcel wa wa vm cv cG cfv cS cC co vm cv cF cfv cR cB co
        cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv
        clt wbr vm cv cG cfv cS cC co cr wcel vm cv cF cfv cR cB co cr wcel vv
        cv cr wcel vm cv cG cfv cS cC co vm cv cF cfv cR cB co cle wbr vm cv cF
        cfv cR cB co vv cv clt wbr wa vm cv cG cfv cS cC co vv cv clt wbr wi cn
        cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vv cv cr wcel
        wa wa vm cv cG cfv cS cC co vm cv cF cfv cR cB co vv cv lelttr cn cX cY
        cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vm cv cG cfv cS cC
        co cr wcel vv cv cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cS cY wcel
        vm cv cG cfv cS cC co cr wcel cR cX wcel vm cv cG cfv cY wcel cS cY
        wcel vm cv cG cfv cS cC co cr wcel cn cX cY cxp cH wf vm cv cn wcel wa
        cC cme wcel vm cv cG cfv cY wcel cS cY wcel vm cv cG cfv cS cC co cr
        wcel xplm.6 vm cv cG cfv cS cC cY xplm.3 metcl mp3an1 cn cY cG wf vm cv
        cn wcel vm cv cG cfv cY wcel cn cX cY cxp cH wf cn cY vm cv cG ffvelrn
        cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn wral cn cY cG wf
        cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn cn cX cY cxp cH
        wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c2nd cfv
        cY wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv
        cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX
        cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi
        pm3.27d syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd cfv cG xplmi.10
        fopab2 sylib sylan sylan adantrl adantrr cn cX cY cxp cH wf vm cv cn
        wcel wa cR cX wcel cS cY wcel wa vm cv cF cfv cR cB co cr wcel vv cv cr
        wcel cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel vm cv cF cfv cR cB
        co cr wcel cS cY wcel vm cv cF cfv cX wcel cR cX wcel vm cv cF cfv cR
        cB co cr wcel cn cX cY cxp cH wf vm cv cn wcel wa cB cme wcel vm cv cF
        cfv cX wcel cR cX wcel vm cv cF cfv cR cB co cr wcel xplm.5 vm cv cF
        cfv cR cB cX xplm.1 metcl mp3an1 cn cX cF wf vm cv cn wcel vm cv cF cfv
        cX wcel cn cX cY cxp cH wf cn cX vm cv cF ffvelrn cn cX cY cxp cH wf vk
        cv cH cfv c1st cfv cX wcel vk cn wral cn cX cF wf cn cX cY cxp cH wf vk
        cv cH cfv c1st cfv cX wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk
        cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel cn cX cY cxp vk
        cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv
        cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw
        cn cX vk cv cH cfv c1st cfv cF xplmi.9 fopab2 sylib sylan sylan adantrr
        adantrr cn cX cY cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa vv
        cv cr wcel simprr syl3anc expdimp sylbid cn cX cY cxp cH wf vm cv cn
        wcel wa cR cX wcel cS cY wcel wa vm cv cF cfv cR cB co vm cv cG cfv cS
        cC co cle wbr vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv cv clt
        wbr vm cv cG cfv cS cC co vv cv clt wbr wi vv cv cr wcel cn cX cY cxp
        cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa wa vm cv cF cfv cR cB
        co vm cv cG cfv cS cC co cle wbr wa vm cv cF cfv vm cv cG cfv cop cR cS
        cop cD co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr cn cX cY
        cxp cH wf vm cv cn wcel wa cR cX wcel cS cY wcel wa wa vm cv cF cfv cR
        cB co vm cv cG cfv cS cC co cle wbr wa vm cv cF cfv vm cv cG cfv cop cR
        cS cop cD co vm cv cG cfv cS cC co vv cv clt vm cv cF cfv vm cv cG cfv
        cop cX cY cxp wcel cR cS cop cX cY cxp wcel wa vm cv cF cfv cR cB co vm
        cv cG cfv cS cC co cle wbr vm cv cF cfv vm cv cG cfv cop cR cS cop cD
        co vm cv cG cfv cS cC co wceq cn cX cY cxp cH wf vm cv cn wcel wa cR cX
        wcel cS cY wcel wa wa vx vy vz cB cC cD vm cv cF cfv vm cv cG cfv cop
        cR cS cop vm cv cF cfv vm cv cG cfv cR cS cX cY xplm.1 xplm.3 xplm.5
        xplm.6 xplm.7 vm cv cF cfv vm cv cG cfv cop c1st cfv vm cv cF cfv vm cv
        cF cfv vm cv cG cfv vm cv cF fvex op1st eqcomi vm cv cF cfv vm cv cG
        cfv cop c2nd cfv vm cv cG cfv vm cv cF cfv vm cv cG cfv vm cv cF fvex
        vm cv cG fvex op2nd eqcomi cR cS cop c1st cfv cR cR cS xplm.a op1st
        eqcomi cR cS cop c2nd cfv cS cR cS xplm.a xplm.b op2nd eqcomi metxpfval
        cn cX cY cxp cH wf vm cv cn wcel wa vm cv cF cfv vm cv cG cfv cop cX cY
        cxp wcel cR cX wcel cS cY wcel wa cR cS cop cX cY cxp wcel vm cv cF cfv
        cX wcel vm cv cG cfv cY wcel vm cv cF cfv vm cv cG cfv cop cX cY cxp
        wcel cn cX cY cxp cH wf vm cv cn wcel wa vm cv cF cfv vm cv cG cfv cX
        cY opelxpi cn cX cF wf vm cv cn wcel vm cv cF cfv cX wcel cn cX cY cxp
        cH wf cn cX vm cv cF ffvelrn cn cX cY cxp cH wf vk cv cH cfv c1st cfv
        cX wcel vk cn wral cn cX cF wf cn cX cY cxp cH wf vk cv cH cfv c1st cfv
        cX wcel vk cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY
        cxp wcel vk cv cH cfv c1st cfv cX wcel cn cX cY cxp vk cv cH ffvelrn vk
        cv cH cfv cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv cY wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp
        wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk
        cv cH cfv cX cY elxp7 pm3.27bi pm3.26d syl r19.21aiva vk vw cn cX vk cv
        cH cfv c1st cfv cF xplmi.9 fopab2 sylib sylan cn cY cG wf vm cv cn wcel
        vm cv cG cfv cY wcel cn cX cY cxp cH wf cn cY vm cv cG ffvelrn cn cX cY
        cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn wral cn cY cG wf cn cX cY
        cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk cn cn cX cY cxp cH wf vk cv
        cn wcel wa vk cv cH cfv cX cY cxp wcel vk cv cH cfv c2nd cfv cY wcel cn
        cX cY cxp vk cv cH ffvelrn vk cv cH cfv cX cY cxp wcel vk cv cH cfv
        c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel vk cv cH cfv cX cY cxp
        wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX cY elxp7 pm3.27bi pm3.27d
        syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd cfv cG xplmi.10 fopab2
        sylib sylan sylanc cR cS cX cY opelxpi anim12i sylan breq1d biimpd
        adantlrr lecasei sylbid exp43 com12 com4l imp41 imim2d r19.20dva
        r19.22sdv adantrr adantlrl mpd exp43 r19.21adv jcad cn cX cY cxp cH wf
        cn cY cG wf cG cS cC clm cfv wbr cS cY wcel cc0 vv cv clt wbr vj cv vm
        cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn wral vj cn wrex
        wi vv cr wral wa wb cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk
        cn wral cn cY cG wf cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk
        cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk
        cv cH cfv c2nd cfv cY wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv
        cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX
        cY elxp7 pm3.27bi pm3.27d syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd
        cfv cG xplmi.10 fopab2 sylib cC cme wcel cS cvv wcel cn cY cG wf cG cS
        cC clm cfv wbr cS cY wcel cc0 vv cv clt wbr vj cv vm cv cle wbr vm cv
        cG cfv cS cC co vv cv clt wbr wi vm cn wral vj cn wrex wi vv cr wral wa
        wb xplm.6 xplm.b vv cvv cC cS vj vm cG c1 cY cn xplm.3 1z nnuz lmbrf
        mp3an12 syl sylibrd cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk
        cn wral cn cY cG wf cn cX cY cxp cH wf vk cv cH cfv c2nd cfv cY wcel vk
        cn cn cX cY cxp cH wf vk cv cn wcel wa vk cv cH cfv cX cY cxp wcel vk
        cv cH cfv c2nd cfv cY wcel cn cX cY cxp vk cv cH ffvelrn vk cv cH cfv
        cX cY cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY
        wcel vk cv cH cfv cX cY cxp wcel vk cv cH cfv cvv cvv cxp wcel vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv cY wcel wa vk cv cH cfv cX
        cY elxp7 pm3.27bi pm3.27d syl r19.21aiva vk vw cn cY vk cv cH cfv c2nd
        cfv cG xplmi.10 fopab2 sylib jctild jcad cH cR cS cop cD clm cfv wbr cR
        cX wcel cS cY wcel wa cH cR cS cop cD clm cfv wbr cR cS cop cX cY cxp
        wcel cR cX wcel cS cY wcel wa cD cme wcel cR cS cop cvv wcel cH cR cS
        cop cD clm cfv wbr cR cS cop cX cY cxp wcel vx vy vz cB cC cD cX cY
        xplm.1 xplm.3 xplm.5 xplm.6 xplm.7 metxp cR cS opex cvv cD cR cS cop cH
        cX cY cxp cD cdm cdm cX cY cxp cX cY cxp cxp cdm cX cY cxp cD cdm cX cY
        cxp cX cY cxp cxp vx vy vz cX cY cxp cX cY cxp vx cv c1st cfv vy cv
        c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup cD
        cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC
        co cpr clt ltso supex xplm.7 dmoprab2 dmeqi cX cY cxp dmxpid eqtr2i
        lmcl mp3an12 cR cS cX cY xplm.b opelxp sylib ancli syl5 imp $.
        $( [5-Oct-2007] $) $( [30-Jul-2007] $)

      $( Two sequences converge if the sequence of their ordered pairs
         converges.  Part of Proposition 14-2.6 of [Gleason] p. 230.  Note:
         The hypothesis ` S e. _V ` is redundant but is kept for
         convenience. $)
      xplmi2 $p |- ( ( H : NN --> ( X X. Y ) /\ H ( ~~>m ` D ) R )
           -> ( ( F : NN --> X /\ F ( ~~>m ` B ) ( 1st ` R ) ) /\
                ( G : NN --> Y /\ G ( ~~>m ` C ) ( 2nd ` R ) ) ) ) $=
        cn cX cY cxp cH wf cH cR c1st cfv cR c2nd cfv cop cD clm cfv wbr cn cX
        cF wf cF cR c1st cfv cB clm cfv wbr wa cn cY cG wf cG cR c2nd cfv cC
        clm cfv wbr wa wa cH cR cD clm cfv wbr vx vy vz vw cB cC cD cR c1st cfv
        cR c2nd cfv vk cF cG cH cX cY cR c1st fvex cR c2nd fvex xplm.1 xplm.3
        xplm.5 xplm.6 xplm.7 xplmi.9 xplmi.10 xplmi cH cR cD clm cfv wbr cH cR
        c1st cfv cR c2nd cfv cop cD clm cfv wbr cH cR cD clm cfv wbr cR cR c1st
        cfv cR c2nd cfv cop cH cD clm cfv cH cR cD clm cfv wbr cR cX cY cxp
        wcel cR cR c1st cfv cR c2nd cfv cop wceq cD cme wcel cR cvv wcel cH cR
        cD clm cfv wbr cR cX cY cxp wcel vx vy vz cB cC cD cX cY xplm.1 xplm.3
        xplm.5 xplm.6 xplm.7 metxp xplm.a cvv cD cR cH cX cY cxp cD cdm cdm cX
        cY cxp cX cY cxp cxp cdm cX cY cxp cD cdm cX cY cxp cX cY cxp cxp vx vy
        vz cX cY cxp cX cY cxp vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd
        cfv vy cv c2nd cfv cC co cpr cr clt csup cD cr vx cv c1st cfv vy cv
        c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr clt ltso supex
        xplm.7 dmoprab2 dmeqi cX cY cxp dmxpid eqtr2i lmcl mp3an12 cR cX cY cxp
        wcel cR cR c1st cfv cR c2nd cfv cop wceq cR c1st cfv cX wcel cR c2nd
        cfv cY wcel wa cR cX cY elxp6 pm3.26bi syl breq2d ibi sylan2 $.
        $( [7-Oct-2007] $) $( [30-Jul-2007] $)
    $}

    ${
      $d j k m n p v w x y z F $.  $d j k m n p v w x y z G $.  $d j m v H $.
      xplm.9 $e |- F : NN --> X $.
      xplm.10 $e |- G : NN --> Y $.
      xplm.11 $e |- H =
            { <. k , w >. | ( k e. NN /\ w = <. ( F ` k ) , ( G ` k ) >. ) } $.
      $( Two sequences converge iff the sequence of their ordered pairs
         converges.  Proposition 14-2.6 of [Gleason] p. 230.  _Warning:  The
         HTML proof page is 0.5MB in size_. $)
      xplm $p |- ( ( F ( ~~>m ` B ) R /\ G ( ~~>m ` C ) S ) <->
                 H ( ~~>m ` D ) <. R , S >. ) $=
        cF cR cB clm cfv wbr cG cS cC clm cfv wbr wa cH cR cS cop cD clm cfv
        wbr cH cR cS cop cD clm cfv wbr cR cS cop cX cY cxp wcel cc0 vv cv clt
        wbr vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi
        vm cn wral vj cn wrex wi vv cr wral cF cR cB clm cfv wbr cG cS cC clm
        cfv wbr wa cD cme wcel cR cS cop cvv wcel cn cX cY cxp cH wf cH cR cS
        cop cD clm cfv wbr cR cS cop cX cY cxp wcel cc0 vv cv clt wbr vj cv vm
        cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj
        cn wrex wi vv cr wral wa wb vx vy vz cB cC cD cX cY xplm.1 xplm.3
        xplm.5 xplm.6 xplm.7 metxp cR cS opex vk vw cn cX cY cxp vk cv cF cfv
        vk cv cG cfv cop cH xplm.11 vk cv cF cfv cX wcel vk cv cG cfv cY wcel
        vk cv cF cfv vk cv cG cfv cop cX cY cxp wcel vk cv cn wcel vk cv cF cfv
        vk cv cG cfv cX cY opelxpi cn cX vk cv cF xplm.9 ffvelrni cn cY vk cv
        cG xplm.10 ffvelrni sylanc fopab vv cvv cD cR cS cop vj vm cH c1 cX cY
        cxp cn cD cdm cdm cX cY cxp cX cY cxp cxp cdm cX cY cxp cD cdm cX cY
        cxp cX cY cxp cxp vx vy vz cX cY cxp cX cY cxp vx cv c1st cfv vy cv
        c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup cD
        cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC
        co cpr clt ltso supex xplm.7 dmoprab2 dmeqi cX cY cxp dmxpid eqtr2i 1z
        nnuz lmbrf mp3an cR cX wcel cS cY wcel cR cS cop cX cY cxp wcel cF cR
        cB clm cfv wbr cG cS cC clm cfv wbr cR cS cX cY opelxpi cB cme wcel cR
        cvv wcel cF cR cB clm cfv wbr cR cX wcel xplm.5 xplm.a cvv cB cR cF cX
        xplm.1 lmcl mp3an12 cC cme wcel cS cvv wcel cG cS cC clm cfv wbr cS cY
        wcel xplm.6 xplm.b cvv cC cS cG cY xplm.3 lmcl mp3an12 syl2an cF cR cB
        clm cfv wbr cG cS cC clm cfv wbr wa cc0 vv cv clt wbr vj cv vm cv cle
        wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn wral vj cn wrex
        wi vv cr cF cR cB clm cfv wbr cG cS cC clm cfv wbr wa vv cv cr wcel cc0
        vv cv clt wbr vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv
        clt wbr wi vm cn wral vj cn wrex cF cR cB clm cfv wbr cG cS cC clm cfv
        wbr wa vv cv cr wcel cc0 vv cv clt wbr wa wa vj cv vm cv cle wbr vm cv
        cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi
        vm cn wral vj cn wrex vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co
        vv cv clt wbr wi vm cn wral vj cn wrex cF cR cB clm cfv wbr cG cS cC
        clm cfv wbr wa vv cv cr wcel cc0 vv cv clt wbr wa wa vn cv vm cv cle
        wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn wral vn cn wrex vp cv
        vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn wral vp cn
        wrex wa vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv
        cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vj cn wrex cF cR cB clm
        cfv wbr cG cS cC clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa vn cv
        vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn wral vn cn
        wrex vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn
        wral vp cn wrex wa cF cR cB clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr
        wa wa vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn
        wral vn cn wrex cG cS cC clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa
        wa vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn
        wral vp cn wrex cR cvv wcel cF cR cB clm cfv wbr vv cv cr wcel cc0 vv
        cv clt wbr wa vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr
        wi vm cn wral vn cn wrex xplm.a cB cme wcel cR cvv wcel cF cR cB clm
        cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa vn cv vm cv cle wbr vm cv cF
        cfv cR cB co vv cv clt wbr wi vm cn wral vn cn wrex xplm.5 cvv cB cR vv
        cv vn vm cF c1 cX cn xplm.1 1z nnuz lmcvg2 mp3anl1 mpanl1 cS cvv wcel
        cG cS cC clm cfv wbr vv cv cr wcel cc0 vv cv clt wbr wa vp cv vm cv cle
        wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn wral vp cn wrex xplm.b
        cC cme wcel cS cvv wcel cG cS cC clm cfv wbr vv cv cr wcel cc0 vv cv
        clt wbr wa vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi
        vm cn wral vp cn wrex xplm.6 cvv cC cS vv cv vp vm cG c1 cY cn xplm.3
        1z nnuz lmcvg2 mp3anl1 mpanl1 anim12i anandirs vn cv vm cv cle wbr vm
        cv cF cfv cR cB co vv cv clt wbr wi vm cn wral vn cn wrex vp cv vm cv
        cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn wral vp cn wrex wa
        vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn wral
        vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn wral
        wa vp cn wrex vn cn wrex vj cv vm cv cle wbr vm cv cF cfv cR cB co vv
        cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vj cn
        wrex vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm cn
        wral vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn
        wral vn vp cn cn reeanv vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv
        clt wbr wi vm cn wral vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv
        clt wbr wi vm cn wral wa vj cv vm cv cle wbr vm cv cF cfv cR cB co vv
        cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vj cn
        wrex vn vp cn cn vn cv cn wcel vp cv cn wcel wa vn cv vm cv cle wbr vp
        cv vm cv cle wbr wa vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS
        cC co vv cv clt wbr wa wi vm cn wral vj cv vm cv cle wbr vm cv cF cfv
        cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn
        wral vj cn wrex vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr
        wi vm cn wral vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr
        wi vm cn wral wa vn cv cn wcel vp cv cn wcel wa vn cv vm cv cle wbr vp
        cv vm cv cle wbr wa vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS
        cC co vv cv clt wbr wa wi vm cn wral vj cv vm cv cle wbr vm cv cF cfv
        cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn
        wral vj cn wrex wi vn cv vp cv vn cv cn wcel vn cv cr wcel vp cv cn
        wcel vn cv nnre adantr vp cv cn wcel vp cv cr wcel vn cv cn wcel vp cv
        nnre adantl vn cv cn wcel vp cv cn wcel wa vn cv vp cv cle wbr wa vn cv
        vm cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR cB co vv cv clt
        wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vp cv cn wcel
        vp cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS
        cC co vv cv clt wbr wa wi vm cn wral wa vj cv vm cv cle wbr vm cv cF
        cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm
        cn wral vj cn wrex vn cv cn wcel vp cv cn wcel wa vn cv vp cv cle wbr
        wa vn cv vm cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR cB co vv
        cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vp cv
        vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co
        vv cv clt wbr wa wi vm cn wral vp cv cn wcel vn cv cn wcel vp cv cn
        wcel wa vn cv vp cv cle wbr wa vn cv vm cv cle wbr vp cv vm cv cle wbr
        wa vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt
        wbr wa wi vp cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv
        cG cfv cS cC co vv cv clt wbr wa wi vm cn vn cv cn wcel vp cv cn wcel
        wa vn cv vp cv cle wbr wa vm cv cn wcel wa vp cv vm cv cle wbr vn cv vm
        cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR cB co vv cv clt wbr
        vm cv cG cfv cS cC co vv cv clt wbr wa vn cv cn wcel vp cv cn wcel wa
        vn cv vp cv cle wbr wa vm cv cn wcel wa vp cv vm cv cle wbr vn cv vm cv
        cle wbr vn cv cn wcel vp cv cn wcel wa vm cv cn wcel vn cv vp cv cle
        wbr vp cv vm cv cle wbr vn cv vm cv cle wbr wi vn cv cn wcel vp cv cn
        wcel wa vm cv cn wcel wa vn cv vp cv cle wbr vp cv vm cv cle wbr vn cv
        vm cv cle wbr vn cv cn wcel vp cv cn wcel vm cv cn wcel vn cv vp cv cle
        wbr vp cv vm cv cle wbr wa vn cv vm cv cle wbr wi vn cv cr wcel vp cv
        cr wcel vm cv cr wcel vn cv vp cv cle wbr vp cv vm cv cle wbr wa vn cv
        vm cv cle wbr wi vn cv cn wcel vp cv cn wcel vm cv cn wcel vn cv vp cv
        vm cv letr vn cv nnre vp cv nnre vm cv nnre syl3an 3expa expdimp an1rs
        ancrd imim1d r19.20dva vn cv cn wcel vp cv cn wcel vn cv vp cv cle wbr
        simplr jctild vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr
        vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vp cv vm cv cle
        wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt
        wbr wa wi vm cn wral vj vp cv cn vj cv vp cv wceq vj cv vm cv cle wbr
        vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr
        wa wi vp cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG
        cfv cS cC co vv cv clt wbr wa wi vm cn vj cv vp cv wceq vj cv vm cv cle
        wbr vp cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG
        cfv cS cC co vv cv clt wbr wa vj cv vp cv vm cv cle breq1 imbi1d
        ralbidv rcla4ev syl6 vn cv cn wcel vp cv cn wcel wa vp cv vn cv cle wbr
        wa vn cv vm cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR cB co vv
        cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vn cv
        cn wcel vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv
        cG cfv cS cC co vv cv clt wbr wa wi vm cn wral wa vj cv vm cv cle wbr
        vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr
        wa wi vm cn wral vj cn wrex vn cv cn wcel vp cv cn wcel wa vp cv vn cv
        cle wbr wa vn cv vm cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR
        cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn
        wral vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG
        cfv cS cC co vv cv clt wbr wa wi vm cn wral vn cv cn wcel vn cv cn wcel
        vp cv cn wcel wa vp cv vn cv cle wbr wa vn cv vm cv cle wbr vp cv vm cv
        cle wbr wa vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv
        cv clt wbr wa wi vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt
        wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn vn cv cn wcel vp cv
        cn wcel wa vp cv vn cv cle wbr wa vm cv cn wcel wa vn cv vm cv cle wbr
        vn cv vm cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR cB co vv cv
        clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa vn cv cn wcel vp cv cn
        wcel wa vp cv vn cv cle wbr wa vm cv cn wcel wa vn cv vm cv cle wbr vp
        cv vm cv cle wbr vn cv cn wcel vp cv cn wcel wa vm cv cn wcel vp cv vn
        cv cle wbr vn cv vm cv cle wbr vp cv vm cv cle wbr wi vn cv cn wcel vp
        cv cn wcel wa vm cv cn wcel wa vp cv vn cv cle wbr vn cv vm cv cle wbr
        vp cv vm cv cle wbr vn cv cn wcel vp cv cn wcel vm cv cn wcel vp cv vn
        cv cle wbr vn cv vm cv cle wbr wa vp cv vm cv cle wbr wi vp cv cn wcel
        vn cv cn wcel vm cv cn wcel vp cv vn cv cle wbr vn cv vm cv cle wbr wa
        vp cv vm cv cle wbr wi vp cv cr wcel vn cv cr wcel vm cv cr wcel vp cv
        vn cv cle wbr vn cv vm cv cle wbr wa vp cv vm cv cle wbr wi vp cv cn
        wcel vn cv cn wcel vm cv cn wcel vp cv vn cv vm cv letr vp cv nnre vn
        cv nnre vm cv nnre syl3an 3com12 3expa expdimp an1rs ancld imim1d
        r19.20dva vn cv cn wcel vp cv cn wcel vp cv vn cv cle wbr simpll jctild
        vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS
        cC co vv cv clt wbr wa wi vm cn wral vn cv vm cv cle wbr vm cv cF cfv
        cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn
        wral vj vn cv cn vj cv vn cv wceq vj cv vm cv cle wbr vm cv cF cfv cR
        cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vn cv vm
        cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv
        cv clt wbr wa wi vm cn vj cv vn cv wceq vj cv vm cv cle wbr vn cv vm cv
        cle wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv
        clt wbr wa vj cv vn cv vm cv cle breq1 imbi1d ralbidv rcla4ev syl6
        lecasei vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vm
        cn wral vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm
        cn wral wa vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi
        vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr wi wa vm cn
        wral vn cv vm cv cle wbr vp cv vm cv cle wbr wa vm cv cF cfv cR cB co
        vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vn
        cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt wbr wi vp cv vm cv cle
        wbr vm cv cG cfv cS cC co vv cv clt wbr wi vm cn r19.26 vn cv vm cv cle
        wbr vm cv cF cfv cR cB co vv cv clt wbr wi vp cv vm cv cle wbr vm cv cG
        cfv cS cC co vv cv clt wbr wi wa vn cv vm cv cle wbr vp cv vm cv cle
        wbr wa vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv
        clt wbr wa wi vm cn vn cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt
        wbr vp cv vm cv cle wbr vm cv cG cfv cS cC co vv cv clt wbr prth
        r19.20si sylbir syl5 r19.23aivv sylbir syl cF cR cB clm cfv wbr cG cS
        cC clm cfv wbr wa vj cv vm cv cle wbr vm cv cF cfv cR cB co vv cv clt
        wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vj cn wrex vj
        cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn
        wral vj cn wrex wi vv cv cr wcel cc0 vv cv clt wbr wa cF cR cB clm cfv
        wbr cG cS cC clm cfv wbr wa vj cv vm cv cle wbr vm cv cF cfv cR cB co
        vv cv clt wbr vm cv cG cfv cS cC co vv cv clt wbr wa wi vm cn wral vj
        cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr wi vm cn
        wral vj cn cF cR cB clm cfv wbr cG cS cC clm cfv wbr wa vj cv vm cv cle
        wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt
        wbr wa wi vj cv vm cv cle wbr vm cv cH cfv cR cS cop cD co vv cv clt
        wbr wi vm cn cF cR cB clm cfv wbr cG cS cC clm cfv wbr wa vm cv cn wcel
        wa vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt
        wbr wa vm cv cH cfv cR cS cop cD co vv cv clt wbr vj cv vm cv cle wbr
        cR cX wcel cS cY wcel wa vm cv cn wcel vm cv cF cfv cR cB co vv cv clt
        wbr vm cv cG cfv cS cC co vv cv clt wbr wa vm cv cH cfv cR cS cop cD co
        vv cv clt wbr wi cF cR cB clm cfv wbr cG cS cC clm cfv wbr wa cR cX
        wcel cS cY wcel wa vm cv cn wcel wa vm cv cF cfv cR cB co vv cv clt wbr
        vm cv cG cfv cS cC co vv cv clt wbr wa vm cv cF cfv vm cv cG cfv cop cR
        cS cop cD co vv cv clt wbr vm cv cH cfv cR cS cop cD co vv cv clt wbr
        cR cX wcel cS cY wcel wa vm cv cn wcel wa vm cv cF cfv vm cv cG cfv cop
        cR cS cop cD co vv cv clt wbr vm cv cG cfv cS cC co vm cv cF cfv cR cB
        co clt wbr vm cv cF cfv cR cB co vm cv cG cfv cS cC co cif vv cv clt
        wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv cS cC co vv cv clt
        wbr wa cR cX wcel cS cY wcel wa vm cv cn wcel wa vm cv cF cfv vm cv cG
        cfv cop cR cS cop cD co vm cv cG cfv cS cC co vm cv cF cfv cR cB co clt
        wbr vm cv cF cfv cR cB co vm cv cG cfv cS cC co cif vv cv clt vm cv cn
        wcel cR cX wcel cS cY wcel wa vm cv cF cfv vm cv cG cfv cop cR cS cop
        cD co vm cv cG cfv cS cC co vm cv cF cfv cR cB co clt wbr vm cv cF cfv
        cR cB co vm cv cG cfv cS cC co cif wceq vm cv cF cfv vm cv cG cfv cop
        cX cY cxp wcel cR cS cop cX cY cxp wcel vm cv cF cfv vm cv cG cfv cop
        cR cS cop cD co vm cv cG cfv cS cC co vm cv cF cfv cR cB co clt wbr vm
        cv cF cfv cR cB co vm cv cG cfv cS cC co cif wceq vm cv cn wcel cR cX
        wcel cS cY wcel wa vx vy vz cB cC cD vm cv cF cfv vm cv cG cfv cop cR
        cS cop vm cv cF cfv vm cv cG cfv cR cS cX cY xplm.1 xplm.3 xplm.5
        xplm.6 xplm.7 vm cv cF cfv vm cv cG cfv cop c1st cfv vm cv cF cfv vm cv
        cF cfv vm cv cG cfv vm cv cF fvex op1st eqcomi vm cv cF cfv vm cv cG
        cfv cop c2nd cfv vm cv cG cfv vm cv cF cfv vm cv cG cfv vm cv cF fvex
        vm cv cG fvex op2nd eqcomi cR cS cop c1st cfv cR cR cS xplm.a op1st
        eqcomi cR cS cop c2nd cfv cS cR cS xplm.a xplm.b op2nd eqcomi metxpdval
        vm cv cF cfv cX wcel vm cv cG cfv cY wcel vm cv cF cfv vm cv cG cfv cop
        cX cY cxp wcel vm cv cn wcel vm cv cF cfv vm cv cG cfv cX cY opelxpi cn
        cX vm cv cF xplm.9 ffvelrni cn cY vm cv cG xplm.10 ffvelrni sylanc cR
        cS cX cY opelxpi syl2an ancoms breq1d vm cv cG cfv cS cC co vm cv cF
        cfv cR cB co clt wbr vm cv cF cfv cR cB co vv cv clt wbr vm cv cG cfv
        cS cC co vv cv clt wbr vm cv cG cfv cS cC co vm cv cF cfv cR cB co clt
        wbr vm cv cF cfv cR cB co vm cv cG cfv cS cC co cif vv cv clt wbr vm cv
        cF cfv cR cB co vm cv cG cfv cS cC co vm cv cF cfv cR cB co vm cv cG
        cfv cS cC co vm cv cF cfv cR cB co clt wbr vm cv cF cfv cR cB co vm cv
        cG cfv cS cC co cif vv cv clt breq1 vm cv cG cfv cS cC co vm cv cG cfv
        cS cC co vm cv cF cfv cR cB co clt wbr vm cv cF cfv cR cB co vm cv cG
        cfv cS cC co cif vv cv clt breq1 ifboth syl5bir vm cv cn wcel vm cv cH
        cfv cR cS cop cD co vv cv clt wbr vm cv cF cfv vm cv cG cfv cop cR cS
        cop cD co vv cv clt wbr wb cR cX wcel cS cY wcel wa vm cv cn wcel vm cv
        cH cfv cR cS cop cD co vm cv cF cfv vm cv cG cfv cop cR cS cop cD co vv
        cv clt vm cv cn wcel vm cv cH cfv vm cv cF cfv vm cv cG cfv cop cR cS
        cop cD vk vw vm cv vk cv cF cfv vk cv cG cfv cop vm cv cF cfv vm cv cG
        cfv cop cn cH vk cv vm cv wceq vk cv cF cfv vm cv cF cfv vk cv cG cfv
        vm cv cG cfv vk cv vm cv cF fveq2 vk cv vm cv cG fveq2 opeq12d xplm.11
        vm cv cF cfv vm cv cG cfv opex fvopab4 opreq1d breq1d adantl sylibrd cF
        cR cB clm cfv wbr cR cX wcel cG cS cC clm cfv wbr cS cY wcel cB cme
        wcel cR cvv wcel cF cR cB clm cfv wbr cR cX wcel xplm.5 xplm.a cvv cB
        cR cF cX xplm.1 lmcl mp3an12 cC cme wcel cS cvv wcel cG cS cC clm cfv
        wbr cS cY wcel xplm.6 xplm.b cvv cC cS cG cY xplm.3 lmcl mp3an12
        anim12i sylan imim2d r19.20dva r19.22sdv adantr mpd exp32 r19.21aiv
        sylanbrc cn cX cY cxp cH wf cH cR cS cop cD clm cfv wbr cF cR cB clm
        cfv wbr cG cS cC clm cfv wbr wa vk vw cn cX cY cxp vk cv cF cfv vk cv
        cG cfv cop cH xplm.11 vk cv cF cfv cX wcel vk cv cG cfv cY wcel vk cv
        cF cfv vk cv cG cfv cop cX cY cxp wcel vk cv cn wcel vk cv cF cfv vk cv
        cG cfv cX cY opelxpi cn cX vk cv cF xplm.9 ffvelrni cn cY vk cv cG
        xplm.10 ffvelrni sylanc fopab cn cX cY cxp cH wf cH cR cS cop cD clm
        cfv wbr wa cn cX cF wf cF cR cB clm cfv wbr wa cn cY cG wf cG cS cC clm
        cfv wbr wa wa cF cR cB clm cfv wbr cG cS cC clm cfv wbr wa vx vy vz vv
        cB cC cD cR cS vm cF cG cH cX cY xplm.a xplm.b xplm.1 xplm.3 xplm.5
        xplm.6 xplm.7 cF vm cv cn wcel vv cv vm cv cF cfv wceq wa vm vv copab
        vm cv cn wcel vv cv vm cv cH cfv c1st cfv wceq wa vm vv copab cF cn wfn
        cF vm cv cn wcel vv cv vm cv cF cfv wceq wa vm vv copab wceq cn cX cF
        wf cF cn wfn xplm.9 cn cX cF ffn ax-mp vm vv cn cF dffn5 mpbi vm cv cn
        wcel vv cv vm cv cH cfv c1st cfv wceq wa vm cv cn wcel vv cv vm cv cF
        cfv wceq wa vm vv vm cv cn wcel vv cv vm cv cH cfv c1st cfv wceq vv cv
        vm cv cF cfv wceq vm cv cn wcel vm cv cH cfv c1st cfv vm cv cF cfv vv
        cv vm cv cn wcel vm cv cH cfv c1st cfv vm cv cF cfv vm cv cG cfv cop
        c1st cfv vm cv cF cfv vm cv cn wcel vm cv cH cfv vm cv cF cfv vm cv cG
        cfv cop c1st vk vw vm cv vk cv cF cfv vk cv cG cfv cop vm cv cF cfv vm
        cv cG cfv cop cn cH vk cv vm cv wceq vk cv cF cfv vm cv cF cfv vk cv cG
        cfv vm cv cG cfv vk cv vm cv cF fveq2 vk cv vm cv cG fveq2 opeq12d
        xplm.11 vm cv cF cfv vm cv cG cfv opex fvopab4 fveq2d vm cv cF cfv vm
        cv cG cfv vm cv cF fvex op1st syl6eq eqeq2d pm5.32i opabbii eqtr4i cG
        vm cv cn wcel vv cv vm cv cG cfv wceq wa vm vv copab vm cv cn wcel vv
        cv vm cv cH cfv c2nd cfv wceq wa vm vv copab cG cn wfn cG vm cv cn wcel
        vv cv vm cv cG cfv wceq wa vm vv copab wceq cn cY cG wf cG cn wfn
        xplm.10 cn cY cG ffn ax-mp vm vv cn cG dffn5 mpbi vm cv cn wcel vv cv
        vm cv cH cfv c2nd cfv wceq wa vm cv cn wcel vv cv vm cv cG cfv wceq wa
        vm vv vm cv cn wcel vv cv vm cv cH cfv c2nd cfv wceq vv cv vm cv cG cfv
        wceq vm cv cn wcel vm cv cH cfv c2nd cfv vm cv cG cfv vv cv vm cv cn
        wcel vm cv cH cfv c2nd cfv vm cv cF cfv vm cv cG cfv cop c2nd cfv vm cv
        cG cfv vm cv cn wcel vm cv cH cfv vm cv cF cfv vm cv cG cfv cop c2nd vk
        vw vm cv vk cv cF cfv vk cv cG cfv cop vm cv cF cfv vm cv cG cfv cop cn
        cH vk cv vm cv wceq vk cv cF cfv vm cv cF cfv vk cv cG cfv vm cv cG cfv
        vk cv vm cv cF fveq2 vk cv vm cv cG fveq2 opeq12d xplm.11 vm cv cF cfv
        vm cv cG cfv opex fvopab4 fveq2d vm cv cF cfv vm cv cG cfv vm cv cF
        fvex vm cv cG fvex op2nd syl6eq eqeq2d pm5.32i opabbii eqtr4i xplmi cn
        cX cF wf cF cR cB clm cfv wbr wa cF cR cB clm cfv wbr cn cY cG wf cG cS
        cC clm cfv wbr wa cG cS cC clm cfv wbr cn cX cF wf cF cR cB clm cfv wbr
        pm3.27 cn cY cG wf cG cS cC clm cfv wbr pm3.27 anim12i syl mpan impbii
        $.
        $( [19-Apr-2008] $) $( [16-Jul-2007] $)
    $}
  $}

  ${
    $d p q r s t u A $.  $d p q r x y z B $.  $d p q r x y z C $.
    $d p q r s t u D $.  $d p q r t u v w x y z F $.
    $d p q r t u v w x y z G $.  $d p q r s t u H $.  $d p q r s t u w J $.
    $d p q r t u w K $.  $d p q r t u w L $.  $d t u M $.
    $d p q r s t u v w X $.  $d p r s t u v w x y z Y $.
    $d q r s t u v w x y z Z $.
    xpcn.1 $e |- X = dom dom A $.
    xpcn.3 $e |- Y = dom dom B $.
    xpcn.5 $e |- Z = dom dom C $.
    xpcn.7 $e |- A e. Met $.
    xpcn.8 $e |- B e. Met $.
    xpcn.9 $e |- C e. Met $.
    xpcn.10 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( Y X. Z ) /\ y e.
      ( Y X. Z ) ) /\ z = sup ( { ( ( 1st ` x ) B ( 1st ` y ) ) , ( ( 2nd ` x )
      C ( 2nd ` y ) ) } , RR , < ) ) } $.
    xpcn.11 $e |- J = ( Open ` A ) $.
    xpcn.12 $e |- K = ( Open ` B ) $.
    xpcn.11a $e |- L = ( Open ` C ) $.
    xpcn.11b $e |- M = ( Open ` D ) $.
    xpcn.13 $e |- H =
             { <. w , v >. | ( w e. X /\ v = <. ( F ` w ) , ( G ` w ) >. ) } $.
    $( Construct a continuous function to the product of the codomains of
       two continuous functions on a common metric space.  _Warning:  The
       HTML proof page is 0.5MB in size_. $)
    xpcn $p |- ( ( F e. ( J Cn K ) /\ G e. ( J Cn L ) ) ->
                 H e. ( J Cn M ) ) $=
      cH cJ cM ccn co wcel cX cY cZ cxp cH wf cc0 vt cv clt wbr cc0 vs cv clt
      wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv
      clt wbr wi vr cX wral wa vs cr wrex wi vt cr wral vu cX wral cF cJ cK ccn
      co wcel cG cJ cL ccn co wcel wa cA cme wcel cD cme wcel cH cJ cM ccn co
      wcel cX cY cZ cxp cH wf cc0 vt cv clt wbr cc0 vs cv clt wbr vu cv vr cv
      cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr
      cX wral wa vs cr wrex wi vt cr wral vu cX wral wa wb xpcn.7 vx vy vz cB
      cC cD cY cZ xpcn.3 xpcn.5 xpcn.8 xpcn.9 xpcn.10 metxp vu vt vs vr cA cD
      cH cJ cM cX cY cZ cxp xpcn.1 xpcn.11 cD cdm cdm cY cZ cxp cY cZ cxp cxp
      cdm cY cZ cxp cD cdm cY cZ cxp cY cZ cxp cxp vx vy vz cY cZ cxp cY cZ cxp
      vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co
      cpr cr clt csup cD cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv
      vy cv c2nd cfv cC co cpr clt ltso supex xpcn.10 dmoprab2 dmeqi cY cZ cxp
      dmxpid eqtr2i xpcn.11b metcn mp2an cF cJ cK ccn co wcel cG cJ cL ccn co
      wcel wa vw cv cF cfv vw cv cG cfv cop cY cZ cxp wcel vw cX wral cX cY cZ
      cxp cH wf cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vw cv cF cfv vw cv
      cG cfv cop cY cZ cxp wcel vw cX cF cJ cK ccn co wcel cG cJ cL ccn co wcel
      wa vw cv cX wcel wa vw cv cF cfv cY wcel vw cv cG cfv cZ wcel wa vw cv cF
      cfv vw cv cG cfv cop cY cZ cxp wcel cF cJ cK ccn co wcel cG cJ cL ccn co
      wcel vw cv cX wcel vw cv cF cfv cY wcel vw cv cG cfv cZ wcel wa cF cJ cK
      ccn co wcel vw cv cX wcel wa vw cv cF cfv cY wcel cG cJ cL ccn co wcel vw
      cv cX wcel wa vw cv cG cfv cZ wcel cX cY cF wf vw cv cX wcel vw cv cF cfv
      cY wcel cF cJ cK ccn co wcel cX cY vw cv cF ffvelrn cA cme wcel cB cme
      wcel cF cJ cK ccn co wcel cX cY cF wf xpcn.7 xpcn.8 cA cB cF cJ cK cX cY
      xpcn.1 xpcn.3 xpcn.11 xpcn.12 metcnf mp3an12 sylan cX cZ cG wf vw cv cX
      wcel vw cv cG cfv cZ wcel cG cJ cL ccn co wcel cX cZ vw cv cG ffvelrn cA
      cme wcel cC cme wcel cG cJ cL ccn co wcel cX cZ cG wf xpcn.7 xpcn.9 cA cC
      cG cJ cL cX cZ xpcn.1 xpcn.5 xpcn.11 xpcn.11a metcnf mp3an12 sylan
      anim12i anandirs vw cv cF cfv vw cv cG cfv cY cZ opelxpi syl r19.21aiva
      vw vv cX cY cZ cxp vw cv cF cfv vw cv cG cfv cop cH xpcn.13 fopab2 sylib
      cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa cc0 vt cv clt wbr cc0 vs cv
      clt wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co
      vt cv clt wbr wi vr cX wral wa vs cr wrex wi vu vt cX cr cF cJ cK ccn co
      wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr cc0 vs cv clt wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv
      cH cfv cD co vt cv clt wbr wi vr cX wral wa vs cr wrex wi cF cJ cK ccn co
      wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr cc0 vs cv clt wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv
      cH cfv cD co vt cv clt wbr wi vr cX wral wa vs cr wrex cF cJ cK ccn co
      wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr w3a wa cc0 vp cv clt wbr vu cv vr cv cA co vp cv clt wbr vu cv cF cfv
      vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa vp cr wrex cc0 vq cv
      clt wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co
      vt cv clt wbr wi vr cX wral wa vq cr wrex cc0 vs cv clt wbr vu cv vr cv
      cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr
      cX wral wa vs cr wrex cF cJ cK ccn co wcel vu cv cX wcel vt cv cr wcel
      cc0 vt cv clt wbr w3a cc0 vp cv clt wbr vu cv vr cv cA co vp cv clt wbr
      vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa vp cr wrex
      cG cJ cL ccn co wcel cB cme wcel cF cJ cK ccn co wcel vu cv cX wcel vt cv
      cr wcel cc0 vt cv clt wbr w3a cc0 vp cv clt wbr vu cv vr cv cA co vp cv
      clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa vp
      cr wrex xpcn.8 cA cme wcel cB cme wcel cF cJ cK ccn co wcel vu cv cX wcel
      vt cv cr wcel cc0 vt cv clt wbr w3a cc0 vp cv clt wbr vu cv vr cv cA co
      vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral
      wa vp cr wrex xpcn.7 vp vr vt cv cA cB vu cv cF cJ cK cX cY xpcn.1
      xpcn.11 xpcn.3 xpcn.12 metcni mp3anl1 mpanl1 adantlr cG cJ cL ccn co wcel
      vu cv cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a cc0 vq cv clt wbr vu cv
      vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr
      wi vr cX wral wa vq cr wrex cF cJ cK ccn co wcel cC cme wcel cG cJ cL ccn
      co wcel vu cv cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a cc0 vq cv clt
      wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv
      clt wbr wi vr cX wral wa vq cr wrex xpcn.9 cA cme wcel cC cme wcel cG cJ
      cL ccn co wcel vu cv cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a cc0 vq
      cv clt wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC
      co vt cv clt wbr wi vr cX wral wa vq cr wrex xpcn.7 vq vr vt cv cA cC vu
      cv cG cJ cL cX cZ xpcn.1 xpcn.11 xpcn.5 xpcn.11a metcni mp3anl1 mpanl1
      adantll cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv
      cr wcel cc0 vt cv clt wbr w3a wa cc0 vp cv clt wbr vu cv vr cv cA co vp
      cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa
      cc0 vq cv clt wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG
      cfv cC co vt cv clt wbr wi vr cX wral wa wa vq cr wrex vp cr wrex cc0 vs
      cv clt wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD
      co vt cv clt wbr wi vr cX wral wa vs cr wrex cc0 vp cv clt wbr vu cv vr
      cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi
      vr cX wral wa vp cr wrex cc0 vq cv clt wbr vu cv vr cv cA co vq cv clt
      wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi vr cX wral wa vq cr
      wrex wa cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv
      cr wcel cc0 vt cv clt wbr w3a wa cc0 vp cv clt wbr vu cv vr cv cA co vp
      cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa
      cc0 vq cv clt wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG
      cfv cC co vt cv clt wbr wi vr cX wral wa wa cc0 vs cv clt wbr vu cv vr cv
      cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr
      cX wral wa vs cr wrex vp vq cr cr cF cJ cK ccn co wcel cG cJ cL ccn co
      wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a wa vp cv cr
      wcel vq cv cr wcel wa cc0 vp cv clt wbr vu cv vr cv cA co vp cv clt wbr
      vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa cc0 vq cv
      clt wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co
      vt cv clt wbr wi vr cX wral wa wa cc0 vs cv clt wbr vu cv vr cv cA co vs
      cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr cX wral wa
      vs cr wrex wi cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel
      vt cv cr wcel cc0 vt cv clt wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa
      cc0 vp cv clt wbr cc0 vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu
      cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt
      wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi wa vr cX wral wa cc0
      vs cv clt wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv
      cD co vt cv clt wbr wi vr cX wral wa vs cr wrex cc0 vp cv clt wbr vu cv
      vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr
      wi vr cX wral wa cc0 vq cv clt wbr vu cv vr cv cA co vq cv clt wbr vu cv
      cG cfv vr cv cG cfv cC co vt cv clt wbr wi vr cX wral wa wa cF cJ cK ccn
      co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa cc0 vp cv clt wbr cc0 vq cv
      clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB
      co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG
      cfv cC co vt cv clt wbr wi wa vr cX wral wa cc0 vs cv clt wbr vu cv vr cv
      cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr
      cX wral wa vs cr wrex vp cv vq cv cle wbr vp cv vq cv cif cr wcel cc0 vp
      cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv vr cv cA co vp cv vq cv
      cle wbr vp cv vq cv cif clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt
      wbr wi vr cX wral wa cc0 vs cv clt wbr vu cv vr cv cA co vs cv clt wbr vu
      cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr cX wral wa vs cr wrex cF
      cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0
      vt cv clt wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa cc0 vp cv clt wbr
      cc0 vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv
      cF cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv cG
      cfv vr cv cG cfv cC co vt cv clt wbr wi wa vr cX wral wa wa cc0 vs cv clt
      wbr vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv
      clt wbr wi vr cX wral wa cc0 vp cv vq cv cle wbr vp cv vq cv cif clt wbr
      vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv cH
      cfv vr cv cH cfv cD co vt cv clt wbr wi vr cX wral wa vs vp cv vq cv cle
      wbr vp cv vq cv cif cr vs cv vp cv vq cv cle wbr vp cv vq cv cif wceq cc0
      vs cv clt wbr cc0 vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv vr cv
      cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr
      cX wral vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu
      cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr cX wral vs cv vp cv vq
      cv cle wbr vp cv vq cv cif cc0 clt breq2 vs cv vp cv vq cv cle wbr vp cv
      vq cv cif wceq vu cv vr cv cA co vs cv clt wbr vu cv cH cfv vr cv cH cfv
      cD co vt cv clt wbr wi vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv
      cif clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr cX vs cv
      vp cv vq cv cle wbr vp cv vq cv cif wceq vu cv vr cv cA co vs cv clt wbr
      vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv cH
      cfv vr cv cH cfv cD co vt cv clt wbr vs cv vp cv vq cv cle wbr vp cv vq
      cv cif vu cv vr cv cA co clt breq2 imbi1d ralbidv anbi12d rcla4ev vp cv
      cr wcel vq cv cr wcel wa vp cv vq cv cle wbr vp cv vq cv cif cr wcel cF
      cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0
      vt cv clt wbr w3a wa cc0 vp cv clt wbr cc0 vq cv clt wbr wa vu cv vr cv
      cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vu
      cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt
      wbr wi wa vr cX wral wa vp cv vq cv cle wbr vp cv vq cv cr ifcl ad2antlr
      cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel
      cc0 vt cv clt wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa cc0 vp cv clt
      wbr cc0 vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr
      cv cF cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv cG
      cfv vr cv cG cfv cC co vt cv clt wbr wi wa vr cX wral wa wa cc0 vp cv vq
      cv cle wbr vp cv vq cv cif clt wbr vu cv vr cv cA co vp cv vq cv cle wbr
      vp cv vq cv cif clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi
      vr cX wral cc0 vp cv clt wbr cc0 vq cv clt wbr wa cc0 vp cv vq cv cle wbr
      vp cv vq cv cif clt wbr cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu
      cv cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a wa vp cv cr wcel vq cv cr
      wcel wa wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB
      co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG
      cfv cC co vt cv clt wbr wi wa vr cX wral vp cv vq cv cle wbr cc0 vp cv
      clt wbr cc0 vq cv clt wbr cc0 vp cv vq cv cle wbr vp cv vq cv cif clt wbr
      vp cv vq cv vp cv vp cv vq cv cle wbr vp cv vq cv cif cc0 clt breq2 vq cv
      vp cv vq cv cle wbr vp cv vq cv cif cc0 clt breq2 ifboth ad2antrl cF cJ
      cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt
      cv clt wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa cc0 vp cv clt wbr cc0
      vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF
      cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv cG cfv
      vr cv cG cfv cC co vt cv clt wbr wi wa vr cX wral vu cv vr cv cA co vp cv
      vq cv cle wbr vp cv vq cv cif clt wbr vu cv cH cfv vr cv cH cfv cD co vt
      cv clt wbr wi vr cX wral cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu
      cv cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a wa vp cv cr wcel vq cv cr
      wcel wa wa cc0 vp cv clt wbr cc0 vq cv clt wbr wa wa vu cv vr cv cA co vp
      cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vu cv vr cv
      cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi wa
      vr cX wral vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr
      vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr cX wral cF cJ cK ccn
      co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa cc0 vp cv clt wbr cc0 vq cv
      clt wbr wa wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv
      cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv
      cG cfv cC co vt cv clt wbr wi wa vu cv vr cv cA co vp cv vq cv cle wbr vp
      cv vq cv cif clt wbr vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vr
      cX cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr
      wcel cc0 vt cv clt wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa cc0 vp cv
      clt wbr cc0 vq cv clt wbr wa wa vr cv cX wcel wa vu cv vr cv cA co vp cv
      clt wbr vu cv vr cv cA co vq cv clt wbr wa vu cv cF cfv vr cv cF cfv cB
      co vt cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wa wi vu
      cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv cH cfv
      vr cv cH cfv cD co vt cv clt wbr wi vu cv vr cv cA co vp cv clt wbr vu cv
      cF cfv vr cv cF cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt
      wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi wa cF cJ cK ccn co
      wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa vr cv cX wcel vu cv vr cv cA
      co vp cv clt wbr vu cv vr cv cA co vq cv clt wbr wa vu cv cF cfv vr cv cF
      cfv cB co vt cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wa
      wi vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv cH
      cfv vr cv cH cfv cD co vt cv clt wbr wi wi cc0 vp cv clt wbr cc0 vq cv
      clt wbr wa cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt
      cv cr wcel cc0 vt cv clt wbr w3a wa vp cv cr wcel vq cv cr wcel wa wa vr
      cv cX wcel wa vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt
      wbr vu cv vr cv cA co vp cv clt wbr vu cv vr cv cA co vq cv clt wbr wa vu
      cv cF cfv vr cv cF cfv cB co vt cv clt wbr vu cv cG cfv vr cv cG cfv cC
      co vt cv clt wbr wa vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr vu cv
      cX wcel vt cv cr wcel cc0 vt cv clt wbr w3a vp cv cr wcel vq cv cr wcel
      wa vr cv cX wcel vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif
      clt wbr vu cv vr cv cA co vp cv clt wbr vu cv vr cv cA co vq cv clt wbr
      wa wi cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr
      wcel cc0 vt cv clt wbr w3a vr cv cX wcel vp cv cr wcel vq cv cr wcel wa
      vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu cv vr cv
      cA co vp cv clt wbr vu cv vr cv cA co vq cv clt wbr wa wi vu cv cX wcel
      vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cX wcel wa vp cv cr wcel vq cv
      cr wcel vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt wbr vu
      cv vr cv cA co vp cv clt wbr vu cv vr cv cA co vq cv clt wbr wa wi vu cv
      vr cv cA co cr wcel vp cv cr wcel vq cv cr wcel vu cv vr cv cA co vp cv
      vq cv cle wbr vp cv vq cv cif clt wbr vu cv vr cv cA co vp cv clt wbr vu
      cv vr cv cA co vq cv clt wbr wa wi vu cv cX wcel vt cv cr wcel cc0 vt cv
      clt wbr w3a vr cv cX wcel wa vu cv vr cv cA co cr wcel vp cv cr wcel vq
      cv cr wcel w3a vu cv vr cv cA co vp cv vq cv cle wbr vp cv vq cv cif clt
      wbr vu cv vr cv cA co vp cv clt wbr vu cv vr cv cA co vq cv clt wbr wa vu
      cv vr cv cA co vp cv vq cv ltmin biimpd vu cv cX wcel vt cv cr wcel vr cv
      cX wcel vu cv vr cv cA co cr wcel cc0 vt cv clt wbr cA cme wcel vu cv cX
      wcel vr cv cX wcel vu cv vr cv cA co cr wcel xpcn.7 vu cv vr cv cA cX
      xpcn.1 metcl mp3an1 3ad2antl1 syl3an1 3expb an1rs adantlll cF cJ cK ccn
      co wcel cG cJ cL ccn co wcel wa vu cv cX wcel vt cv cr wcel cc0 vt cv clt
      wbr w3a wa vr cv cX wcel vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr vu
      cv cG cfv vr cv cG cfv cC co vt cv clt wbr wa vu cv cH cfv vr cv cH cfv
      cD co vt cv clt wbr wi vp cv cr wcel vq cv cr wcel wa cF cJ cK ccn co
      wcel cG cJ cL ccn co wcel wa vu cv cX wcel vr cv cX wcel vu cv cF cfv vr
      cv cF cfv cB co vt cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt
      wbr wa vu cv cH cfv vr cv cH cfv cD co vt cv clt wbr wi vu cv cX wcel vt
      cv cr wcel cc0 vt cv clt wbr w3a cF cJ cK ccn co wcel cG cJ cL ccn co
      wcel wa vu cv cX wcel vr cv cX wcel vu cv cF cfv vr cv cF cfv cB co vt cv
      clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wa vu cv cH cfv vr
      cv cH cfv cD co vt cv clt wbr wi cF cJ cK ccn co wcel cG cJ cL ccn co
      wcel wa vu cv cX wcel vr cv cX wcel wa wa vu cv cH cfv vr cv cH cfv cD co
      vt cv clt wbr vu cv cG cfv vr cv cG cfv cC co vu cv cF cfv vr cv cF cfv
      cB co clt wbr vu cv cF cfv vr cv cF cfv cB co vu cv cG cfv vr cv cG cfv
      cC co cif vt cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr vu
      cv cG cfv vr cv cG cfv cC co vt cv clt wbr wa cF cJ cK ccn co wcel cG cJ
      cL ccn co wcel wa vu cv cX wcel vr cv cX wcel wa wa vu cv cH cfv vr cv cH
      cfv cD co vu cv cG cfv vr cv cG cfv cC co vu cv cF cfv vr cv cF cfv cB co
      clt wbr vu cv cF cfv vr cv cF cfv cB co vu cv cG cfv vr cv cG cfv cC co
      cif vt cv clt cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vu cv cX wcel
      vr cv cX wcel wa wa vu cv cH cfv vr cv cH cfv cD co vu cv cF cfv vu cv cG
      cfv cop vr cv cF cfv vr cv cG cfv cop cD co vu cv cG cfv vr cv cG cfv cC
      co vu cv cF cfv vr cv cF cfv cB co clt wbr vu cv cF cfv vr cv cF cfv cB
      co vu cv cG cfv vr cv cG cfv cC co cif vu cv cX wcel vr cv cX wcel wa vu
      cv cH cfv vr cv cH cfv cD co vu cv cF cfv vu cv cG cfv cop vr cv cF cfv
      vr cv cG cfv cop cD co wceq cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa
      vu cv cX wcel vr cv cX wcel vu cv cH cfv vu cv cF cfv vu cv cG cfv cop vr
      cv cH cfv vr cv cF cfv vr cv cG cfv cop cD vw vv vu cv vw cv cF cfv vw cv
      cG cfv cop vu cv cF cfv vu cv cG cfv cop cX cH vw cv vu cv wceq vw cv cF
      cfv vu cv cF cfv vw cv cG cfv vu cv cG cfv vw cv vu cv cF fveq2 vw cv vu
      cv cG fveq2 opeq12d xpcn.13 vu cv cF cfv vu cv cG cfv opex fvopab4 vw vv
      vr cv vw cv cF cfv vw cv cG cfv cop vr cv cF cfv vr cv cG cfv cop cX cH
      vw cv vr cv wceq vw cv cF cfv vr cv cF cfv vw cv cG cfv vr cv cG cfv vw
      cv vr cv cF fveq2 vw cv vr cv cG fveq2 opeq12d xpcn.13 vr cv cF cfv vr cv
      cG cfv opex fvopab4 opreqan12d adantl vu cv cF cfv vu cv cG cfv cop cY cZ
      cxp wcel vr cv cF cfv vr cv cG cfv cop cY cZ cxp wcel vu cv cF cfv vu cv
      cG cfv cop vr cv cF cfv vr cv cG cfv cop cD co vu cv cG cfv vr cv cG cfv
      cC co vu cv cF cfv vr cv cF cfv cB co clt wbr vu cv cF cfv vr cv cF cfv
      cB co vu cv cG cfv vr cv cG cfv cC co cif wceq cF cJ cK ccn co wcel cG cJ
      cL ccn co wcel wa vu cv cX wcel vr cv cX wcel wa wa vx vy vz cB cC cD vu
      cv cF cfv vu cv cG cfv cop vr cv cF cfv vr cv cG cfv cop vu cv cF cfv vu
      cv cG cfv vr cv cF cfv vr cv cG cfv cY cZ xpcn.3 xpcn.5 xpcn.8 xpcn.9
      xpcn.10 vu cv cF cfv vu cv cG cfv cop c1st cfv vu cv cF cfv vu cv cF cfv
      vu cv cG cfv vu cv cF fvex op1st eqcomi vu cv cF cfv vu cv cG cfv cop
      c2nd cfv vu cv cG cfv vu cv cF cfv vu cv cG cfv vu cv cF fvex vu cv cG
      fvex op2nd eqcomi vr cv cF cfv vr cv cG cfv cop c1st cfv vr cv cF cfv vr
      cv cF cfv vr cv cG cfv vr cv cF fvex op1st eqcomi vr cv cF cfv vr cv cG
      cfv cop c2nd cfv vr cv cG cfv vr cv cF cfv vr cv cG cfv vr cv cF fvex vr
      cv cG fvex op2nd eqcomi metxpdval cF cJ cK ccn co wcel cG cJ cL ccn co
      wcel wa vu cv cX wcel vu cv cF cfv vu cv cG cfv cop cY cZ cxp wcel vr cv
      cX wcel cF cJ cK ccn co wcel cG cJ cL ccn co wcel vu cv cX wcel vu cv cF
      cfv vu cv cG cfv cop cY cZ cxp wcel vu cv cF cfv cY wcel vu cv cG cfv cZ
      wcel vu cv cF cfv vu cv cG cfv cop cY cZ cxp wcel cF cJ cK ccn co wcel vu
      cv cX wcel wa cG cJ cL ccn co wcel vu cv cX wcel wa vu cv cF cfv vu cv cG
      cfv cY cZ opelxpi cX cY cF wf vu cv cX wcel vu cv cF cfv cY wcel cF cJ cK
      ccn co wcel cX cY vu cv cF ffvelrn cA cme wcel cB cme wcel cF cJ cK ccn
      co wcel cX cY cF wf xpcn.7 xpcn.8 cA cB cF cJ cK cX cY xpcn.1 xpcn.3
      xpcn.11 xpcn.12 metcnf mp3an12 sylan cX cZ cG wf vu cv cX wcel vu cv cG
      cfv cZ wcel cG cJ cL ccn co wcel cX cZ vu cv cG ffvelrn cA cme wcel cC
      cme wcel cG cJ cL ccn co wcel cX cZ cG wf xpcn.7 xpcn.9 cA cC cG cJ cL cX
      cZ xpcn.1 xpcn.5 xpcn.11 xpcn.11a metcnf mp3an12 sylan syl2an anandirs
      adantrr cF cJ cK ccn co wcel cG cJ cL ccn co wcel wa vr cv cX wcel vr cv
      cF cfv vr cv cG cfv cop cY cZ cxp wcel vu cv cX wcel cF cJ cK ccn co wcel
      cG cJ cL ccn co wcel vr cv cX wcel vr cv cF cfv vr cv cG cfv cop cY cZ
      cxp wcel vr cv cF cfv cY wcel vr cv cG cfv cZ wcel vr cv cF cfv vr cv cG
      cfv cop cY cZ cxp wcel cF cJ cK ccn co wcel vr cv cX wcel wa cG cJ cL ccn
      co wcel vr cv cX wcel wa vr cv cF cfv vr cv cG cfv cY cZ opelxpi cX cY cF
      wf vr cv cX wcel vr cv cF cfv cY wcel cF cJ cK ccn co wcel cX cY vr cv cF
      ffvelrn cA cme wcel cB cme wcel cF cJ cK ccn co wcel cX cY cF wf xpcn.7
      xpcn.8 cA cB cF cJ cK cX cY xpcn.1 xpcn.3 xpcn.11 xpcn.12 metcnf mp3an12
      sylan cX cZ cG wf vr cv cX wcel vr cv cG cfv cZ wcel cG cJ cL ccn co wcel
      cX cZ vr cv cG ffvelrn cA cme wcel cC cme wcel cG cJ cL ccn co wcel cX cZ
      cG wf xpcn.7 xpcn.9 cA cC cG cJ cL cX cZ xpcn.1 xpcn.5 xpcn.11 xpcn.11a
      metcnf mp3an12 sylan syl2an anandirs adantrl sylanc eqtrd breq1d vu cv cG
      cfv vr cv cG cfv cC co vu cv cF cfv vr cv cF cfv cB co clt wbr vu cv cF
      cfv vr cv cF cfv cB co vt cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt
      cv clt wbr vu cv cG cfv vr cv cG cfv cC co vu cv cF cfv vr cv cF cfv cB
      co clt wbr vu cv cF cfv vr cv cF cfv cB co vu cv cG cfv vr cv cG cfv cC
      co cif vt cv clt wbr vu cv cF cfv vr cv cF cfv cB co vu cv cG cfv vr cv
      cG cfv cC co vu cv cF cfv vr cv cF cfv cB co vu cv cG cfv vr cv cG cfv cC
      co vu cv cF cfv vr cv cF cfv cB co clt wbr vu cv cF cfv vr cv cF cfv cB
      co vu cv cG cfv vr cv cG cfv cC co cif vt cv clt breq1 vu cv cG cfv vr cv
      cG cfv cC co vu cv cG cfv vr cv cG cfv cC co vu cv cF cfv vr cv cF cfv cB
      co clt wbr vu cv cF cfv vr cv cF cfv cB co vu cv cG cfv vr cv cG cfv cC
      co cif vt cv clt breq1 ifboth syl5bir anassrs vu cv cX wcel vt cv cr wcel
      cc0 vt cv clt wbr 3simp1 sylanl2 adantlr imim12d adantlr vu cv vr cv cA
      co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr vu cv vr
      cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr prth
      syl5 r19.20dva imp anasss jca sylanc ex cc0 vp cv clt wbr vu cv vr cv cA
      co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX
      wral wa cc0 vq cv clt wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr
      cv cG cfv cC co vt cv clt wbr wi vr cX wral wa wa cc0 vp cv clt wbr cc0
      vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF
      cfv cB co vt cv clt wbr wi vr cX wral vu cv vr cv cA co vq cv clt wbr vu
      cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi vr cX wral wa wa cc0 vp cv
      clt wbr cc0 vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv
      vr cv cF cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv
      cG cfv vr cv cG cfv cC co vt cv clt wbr wi wa vr cX wral wa cc0 vp cv clt
      wbr vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv
      clt wbr wi vr cX wral cc0 vq cv clt wbr vu cv vr cv cA co vq cv clt wbr
      vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi vr cX wral an4 vu cv vr
      cv cA co vp cv clt wbr vu cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi
      vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv clt
      wbr wi wa vr cX wral vu cv vr cv cA co vp cv clt wbr vu cv cF cfv vr cv
      cF cfv cB co vt cv clt wbr wi vr cX wral vu cv vr cv cA co vq cv clt wbr
      vu cv cG cfv vr cv cG cfv cC co vt cv clt wbr wi vr cX wral wa cc0 vp cv
      clt wbr cc0 vq cv clt wbr wa vu cv vr cv cA co vp cv clt wbr vu cv cF cfv
      vr cv cF cfv cB co vt cv clt wbr wi vu cv vr cv cA co vq cv clt wbr vu cv
      cG cfv vr cv cG cfv cC co vt cv clt wbr wi vr cX r19.26 anbi2i bitr4i
      syl5ib ex r19.23advv cc0 vp cv clt wbr vu cv vr cv cA co vp cv clt wbr vu
      cv cF cfv vr cv cF cfv cB co vt cv clt wbr wi vr cX wral wa cc0 vq cv clt
      wbr vu cv vr cv cA co vq cv clt wbr vu cv cG cfv vr cv cG cfv cC co vt cv
      clt wbr wi vr cX wral wa vp vq cr cr reeanv syl5ibr mp2and 3exp2 imp3a
      r19.21aivv sylanbrc $.
      $( [20-Nov-2007] $) $( [8-Aug-2007] $)
  $}

  ${
    $d w A $.  $d w x y z B $.  $d w x y z C $.  $d v w x y z F $.
    $d v w x y z G $.  $d w J $.  $d w K $.  $d w L $.  $d w M $.  $d v w O $.
    $d v w x y z P $.  $d v w x y z X $.  $d v w x y z Y $.  $d v w x y z Z $.
    oprcn.1 $e |- X = dom dom A $.
    oprcn.2 $e |- Y = dom dom B $.
    oprcn.4 $e |- Z = dom dom C $.
    oprcn.6 $e |- A e. Met $.
    oprcn.7 $e |- B e. Met $.
    oprcn.8 $e |- C e. Met $.
    oprcn.9 $e |- J e. Met $.
    oprcn.a $e |- K = ( Open ` A ) $.
    oprcn.b $e |- L = ( Open ` B ) $.
    oprcn.c $e |- M = ( Open ` C ) $.
    oprcn.d $e |- N = ( Open ` D ) $.
    oprcn.j $e |- Q = ( Open ` J ) $.
    oprcn.10 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( Y X. Z ) /\ y e. (
      Y X. Z ) ) /\ z = sup ( { ( ( 1st ` x ) B ( 1st ` y ) ) , ( ( 2nd ` x ) C
      ( 2nd ` y ) ) } , RR , < ) ) } $.
    oprcn.11 $e |- O e. ( N Cn Q ) $.
    ${
      oprcn.12 $e |- H =
               { <. w , v >. | ( w e. X /\ v = ( ( F ` w ) O ( G ` w ) ) ) } $.
      $( Construct a continuous function ` H ` built from two functions ` F `
         and ` G ` (on a common metric space ` A ` ) applied to an operation
         ` O ` .  This can be used to show, e.g., that ` x ^ 2 + x ` is
         continuous if we know that ` x ^ 2 ` , ` x ` , and ` + ` are. $)
      oprcn $p |- ( ( F e. ( K Cn L ) /\ G e. ( K Cn M ) ) ->
                     H e. ( K Cn Q ) ) $=
        cF cK cL ccn co wcel cG cK cM ccn co wcel wa cH cO vw cv cX wcel vv cv
        vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab ccom cK cQ ccn co cF
        cK cL ccn co wcel cG cK cM ccn co wcel wa cO vw cv cX wcel vv cv vw cv
        cF cfv vw cv cG cfv cop wceq wa vw vv copab ccom vw cv cX wcel vv cv vw
        vw cv cF cfv vw cv cG cfv cop vw cv cO cfv csb wceq wa vw vv copab cH
        cF cK cL ccn co wcel cG cK cM ccn co wcel wa vw cv cX wcel vv cv vw cv
        cF cfv vw cv cG cfv cop wceq wa vw vv copab crn cY cZ cxp wss cO vw cv
        cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab ccom vw
        cv cX wcel vv cv vw vw cv cF cfv vw cv cG cfv cop vw cv cO cfv csb wceq
        wa vw vv copab wceq cF cK cL ccn co wcel cG cK cM ccn co wcel wa vw cv
        cF cfv vw cv cG cfv cop cY cZ cxp wcel vw cX wral vw cv cX wcel vv cv
        vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab crn cY cZ cxp wss cF
        cK cL ccn co wcel cG cK cM ccn co wcel wa vw cv cF cfv vw cv cG cfv cop
        cY cZ cxp wcel vw cX cF cK cL ccn co wcel cG cK cM ccn co wcel wa vw cv
        cX wcel wa vw cv cF cfv cY wcel vw cv cG cfv cZ wcel wa vw cv cF cfv vw
        cv cG cfv cop cY cZ cxp wcel cF cK cL ccn co wcel cG cK cM ccn co wcel
        vw cv cX wcel vw cv cF cfv cY wcel vw cv cG cfv cZ wcel wa cF cK cL ccn
        co wcel vw cv cX wcel wa vw cv cF cfv cY wcel cG cK cM ccn co wcel vw
        cv cX wcel wa vw cv cG cfv cZ wcel cX cY cF wf vw cv cX wcel vw cv cF
        cfv cY wcel cF cK cL ccn co wcel cX cY vw cv cF ffvelrn cA cme wcel cB
        cme wcel cF cK cL ccn co wcel cX cY cF wf oprcn.6 oprcn.7 cA cB cF cK
        cL cX cY oprcn.1 oprcn.2 oprcn.a oprcn.b metcnf mp3an12 sylan cX cZ cG
        wf vw cv cX wcel vw cv cG cfv cZ wcel cG cK cM ccn co wcel cX cZ vw cv
        cG ffvelrn cA cme wcel cC cme wcel cG cK cM ccn co wcel cX cZ cG wf
        oprcn.6 oprcn.8 cA cC cG cK cM cX cZ oprcn.1 oprcn.4 oprcn.a oprcn.c
        metcnf mp3an12 sylan anim12i anandirs vw cv cF cfv vw cv cG cfv cY cZ
        opelxpi syl r19.21aiva vw vv cX cY cZ cxp vw cv cF cfv vw cv cG cfv cop
        vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab
        vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab
        eqid vw cv cF cfv vw cv cG cfv opex rnssopab sylib vw vv cY cZ cxp cX
        vw cv cO cfv vw cv cF cfv vw cv cG cfv cop cO vw cv cX wcel vv cv vw cv
        cF cfv vw cv cG cfv cop wceq wa vw vv copab vw cv cO fvex vw cv cF cfv
        vw cv cG cfv opex cY cZ cxp cJ cdm cdm cO wf cO vw cv cY cZ cxp wcel vv
        cv vw cv cO cfv wceq wa vw vv copab wceq cD cme wcel cJ cme wcel cO cN
        cQ ccn co wcel cY cZ cxp cJ cdm cdm cO wf vx vy vz cB cC cD cY cZ
        oprcn.2 oprcn.4 oprcn.7 oprcn.8 oprcn.10 metxp oprcn.9 oprcn.11 cD cJ
        cO cN cQ cY cZ cxp cJ cdm cdm cD cdm cdm cY cZ cxp cY cZ cxp cxp cdm cY
        cZ cxp cD cdm cY cZ cxp cY cZ cxp cxp vx vy vz cY cZ cxp cY cZ cxp vx
        cv c1st cfv vy cv c1st cfv cB co vx cv c2nd cfv vy cv c2nd cfv cC co
        cpr cr clt csup cD cr vx cv c1st cfv vy cv c1st cfv cB co vx cv c2nd
        cfv vy cv c2nd cfv cC co cpr clt ltso supex oprcn.10 dmoprab2 dmeqi cY
        cZ cxp dmxpid eqtr2i cJ cdm cdm eqid oprcn.d oprcn.j metcnf mp3an cY cZ
        cxp cJ cdm cdm cO wf cO vw cv cY cZ cxp wcel vv cv vw cv cO cfv wceq wa
        vw vv copab wceq vw cv cO cfv cJ cdm cdm wcel vw cY cZ cxp wral vw vv
        cY cZ cxp cJ cdm cdm cO fopabfv pm3.26bi ax-mp vw cv cX wcel vv cv vw
        cv cF cfv vw cv cG cfv cop wceq wa vw vv copab eqid fopabcos syl cH vw
        cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cO co wceq wa vw vv copab vw
        cv cX wcel vv cv vw vw cv cF cfv vw cv cG cfv cop vw cv cO cfv csb wceq
        wa vw vv copab oprcn.12 vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv
        cO co wceq wa vw cv cX wcel vv cv vw vw cv cF cfv vw cv cG cfv cop vw
        cv cO cfv csb wceq wa vw vv vv cv vw cv cF cfv vw cv cG cfv cO co wceq
        vv cv vw vw cv cF cfv vw cv cG cfv cop vw cv cO cfv csb wceq vw cv cX
        wcel vw cv cF cfv vw cv cG cfv cO co vw vw cv cF cfv vw cv cG cfv cop
        vw cv cO cfv csb vv cv vw vw cv cF cfv vw cv cG cfv cop vw cv csb cO
        cfv vw cv cF cfv vw cv cG cfv cop cO cfv vw vw cv cF cfv vw cv cG cfv
        cop vw cv cO cfv csb vw cv cF cfv vw cv cG cfv cO co vw vw cv cF cfv vw
        cv cG cfv cop vw cv csb vw cv cF cfv vw cv cG cfv cop cO vw cv cF cfv
        vw cv cG cfv cop cvv wcel vw vw cv cF cfv vw cv cG cfv cop vw cv csb vw
        cv cF cfv vw cv cG cfv cop wceq vw cv cF cfv vw cv cG cfv opex vw vw cv
        cF cfv vw cv cG cfv cop cvv csbvarg ax-mp fveq2i vw cv cF cfv vw cv cG
        cfv cop cvv wcel vw vw cv cF cfv vw cv cG cfv cop vw cv cO cfv csb vw
        vw cv cF cfv vw cv cG cfv cop vw cv csb cO cfv wceq vw cv cF cfv vw cv
        cG cfv opex vw vw cv cF cfv vw cv cG cfv cop vw cv cvv cO csbfv2g ax-mp
        vw cv cF cfv vw cv cG cfv cO df-opr 3eqtr4ri eqeq2i anbi2i opabbii
        eqtri syl6reqr vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq
        wa vw vv copab cK cN ccn co wcel cO cN cQ ccn co wcel cO vw cv cX wcel
        vv cv vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab ccom cK cQ ccn
        co wcel cF cK cL ccn co wcel cG cK cM ccn co wcel wa cA cme wcel cD cme
        wcel cJ cme wcel w3a vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cop
        wceq wa vw vv copab cK cN ccn co wcel cO cN cQ ccn co wcel wa cO vw cv
        cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq wa vw vv copab ccom cK
        cQ ccn co wcel cA cme wcel cD cme wcel cJ cme wcel oprcn.6 vx vy vz cB
        cC cD cY cZ oprcn.2 oprcn.4 oprcn.7 oprcn.8 oprcn.10 metxp oprcn.9
        3pm3.2i cA cD cJ vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq
        wa vw vv copab cO cK cN cQ oprcn.a oprcn.d oprcn.j metcnco mpan vx vy
        vz vw vv cA cB cC cD cF cG vw cv cX wcel vv cv vw cv cF cfv vw cv cG
        cfv cop wceq wa vw vv copab cK cL cM cN cX cY cZ oprcn.1 oprcn.2
        oprcn.4 oprcn.6 oprcn.7 oprcn.8 oprcn.10 oprcn.a oprcn.b oprcn.c
        oprcn.d vw cv cX wcel vv cv vw cv cF cfv vw cv cG cfv cop wceq wa vw vv
        copab eqid xpcn oprcn.11 sylancl eqeltrd $.
        $( [21-Nov-2007] $) $( [7-Aug-2007] $)
    $}

    ${
      opr1cn.12 $e |- H =
               { <. w , v >. | ( w e. X /\ v = ( ( F ` w ) O P ) ) } $.
      $( Construct a continuous function ` H ` built from a function ` F ` and
         a constant applied to an operation ` O ` . $)
      opr1cn $p |- ( ( F e. ( K Cn L ) /\ P e. Z ) ->
                     H e. ( K Cn Q ) ) $=
        cF cK cL ccn co wcel cP cZ wcel wa cH vw cv cX wcel vv cv vw cv cF cfv
        vw cv cX cP csn cxp cfv cO co wceq wa vw vv copab cK cQ ccn co cP cZ
        wcel cH vw cv cX wcel vv cv vw cv cF cfv vw cv cX cP csn cxp cfv cO co
        wceq wa vw vv copab wceq cF cK cL ccn co wcel cP cZ wcel vw cv cX wcel
        vv cv vw cv cF cfv vw cv cX cP csn cxp cfv cO co wceq wa vw vv copab vw
        cv cX wcel vv cv vw cv cF cfv cP cO co wceq wa vw vv copab cH cP cZ
        wcel vw cv cX wcel vv cv vw cv cF cfv vw cv cX cP csn cxp cfv cO co
        wceq wa vw cv cX wcel vv cv vw cv cF cfv cP cO co wceq wa vw vv cP cZ
        wcel vw cv cX wcel vv cv vw cv cF cfv vw cv cX cP csn cxp cfv cO co
        wceq vv cv vw cv cF cfv cP cO co wceq cP cZ wcel vw cv cX wcel wa vw cv
        cF cfv vw cv cX cP csn cxp cfv cO co vw cv cF cfv cP cO co vv cv cP cZ
        wcel vw cv cX wcel wa vw cv cX cP csn cxp cfv cP vw cv cF cfv cO cX cP
        vw cv cZ fvconst2g opreq2d eqeq2d pm5.32da opabbidv opr1cn.12 syl6reqr
        adantl cF cK cL ccn co wcel cX cP csn cxp cK cM ccn co wcel vw cv cX
        wcel vv cv vw cv cF cfv vw cv cX cP csn cxp cfv cO co wceq wa vw vv
        copab cK cQ ccn co wcel cP cZ wcel vx vy vz vw vv cA cB cC cD cQ cF cX
        cP csn cxp vw cv cX wcel vv cv vw cv cF cfv vw cv cX cP csn cxp cfv cO
        co wceq wa vw vv copab cJ cK cL cM cN cO cX cY cZ oprcn.1 oprcn.2
        oprcn.4 oprcn.6 oprcn.7 oprcn.8 oprcn.9 oprcn.a oprcn.b oprcn.c oprcn.d
        oprcn.j oprcn.10 oprcn.11 vw cv cX wcel vv cv vw cv cF cfv vw cv cX cP
        csn cxp cfv cO co wceq wa vw vv copab eqid oprcn cP cZ wcel cX cP csn
        cX cP csn cxp wf cX cP csn cxp cK cM ccn co wcel cX cP cZ fconstg cA
        cme wcel cC cme wcel cP cZ wcel cX cP csn cX cP csn cxp wf wa cX cP csn
        cxp cK cM ccn co wcel oprcn.6 oprcn.8 cP cA cC cX cP csn cxp cK cM cX
        cZ oprcn.1 oprcn.4 oprcn.a oprcn.c metcnconst mpanl12 mpdan sylan2
        eqeltrd $.
        $( [4-Dec-2007] $) $( [10-Aug-2007] $)
    $}

    ${
      opr2cn.12 $e |- H =
               { <. w , v >. | ( w e. X /\ v = ( P O ( G ` w ) ) ) } $.
      $( Construct a continuous function ` H ` built from a function ` G ` and
         a constant applied to an operation ` O ` . $)
      opr2cn $p |- ( ( P e. Y /\ G e. ( K Cn M ) ) ->
                     H e. ( K Cn Q ) ) $=
        cP cY wcel cG cK cM ccn co wcel wa cH vw cv cX wcel vv cv vw cv cX cP
        csn cxp cfv vw cv cG cfv cO co wceq wa vw vv copab cK cQ ccn co cP cY
        wcel cH vw cv cX wcel vv cv vw cv cX cP csn cxp cfv vw cv cG cfv cO co
        wceq wa vw vv copab wceq cG cK cM ccn co wcel cP cY wcel vw cv cX wcel
        vv cv vw cv cX cP csn cxp cfv vw cv cG cfv cO co wceq wa vw vv copab vw
        cv cX wcel vv cv cP vw cv cG cfv cO co wceq wa vw vv copab cH cP cY
        wcel vw cv cX wcel vv cv vw cv cX cP csn cxp cfv vw cv cG cfv cO co
        wceq wa vw cv cX wcel vv cv cP vw cv cG cfv cO co wceq wa vw vv cP cY
        wcel vw cv cX wcel vv cv vw cv cX cP csn cxp cfv vw cv cG cfv cO co
        wceq vv cv cP vw cv cG cfv cO co wceq cP cY wcel vw cv cX wcel wa vw cv
        cX cP csn cxp cfv vw cv cG cfv cO co cP vw cv cG cfv cO co vv cv cP cY
        wcel vw cv cX wcel wa vw cv cX cP csn cxp cfv cP vw cv cG cfv cO cX cP
        vw cv cY fvconst2g opreq1d eqeq2d pm5.32da opabbidv opr2cn.12 syl6reqr
        adantr cX cP csn cxp cK cL ccn co wcel cG cK cM ccn co wcel vw cv cX
        wcel vv cv vw cv cX cP csn cxp cfv vw cv cG cfv cO co wceq wa vw vv
        copab cK cQ ccn co wcel cP cY wcel vx vy vz vw vv cA cB cC cD cQ cX cP
        csn cxp cG vw cv cX wcel vv cv vw cv cX cP csn cxp cfv vw cv cG cfv cO
        co wceq wa vw vv copab cJ cK cL cM cN cO cX cY cZ oprcn.1 oprcn.2
        oprcn.4 oprcn.6 oprcn.7 oprcn.8 oprcn.9 oprcn.a oprcn.b oprcn.c oprcn.d
        oprcn.j oprcn.10 oprcn.11 vw cv cX wcel vv cv vw cv cX cP csn cxp cfv
        vw cv cG cfv cO co wceq wa vw vv copab eqid oprcn cP cY wcel cX cP csn
        cX cP csn cxp wf cX cP csn cxp cK cL ccn co wcel cX cP cY fconstg cA
        cme wcel cB cme wcel cP cY wcel cX cP csn cX cP csn cxp wf wa cX cP csn
        cxp cK cL ccn co wcel oprcn.6 oprcn.7 cP cA cB cX cP csn cxp cK cL cX
        cY oprcn.1 oprcn.2 oprcn.a oprcn.b metcnconst mpanl12 mpdan sylan
        eqeltrd $.
        $( [1-Dec-2007] $) $( [10-Aug-2007] $)
    $}
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w C $.  $d w J $.  $d v w O $.
    $d v w x y z P $.  $d v w x y z X $.  $d v w x y z Y $.
    oprscn.1 $e |- X = dom dom A $.
    oprscn.3 $e |- Y = dom dom B $.
    oprscn.5 $e |- A e. Met $.
    oprscn.6 $e |- B e. Met $.
    oprscn.7 $e |- C e. Met $.
    oprscn.8 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( X X. Y ) /\ y e. (
      X X. Y ) ) /\ z = sup ( { ( ( 1st ` x ) A ( 1st ` y ) ) , ( ( 2nd ` x ) B
      ( 2nd ` y ) ) } , RR , < ) ) } $.
    oprscn.j $e |- J = ( Open ` A ) $.
    oprscn.k $e |- K = ( Open ` C ) $.
    oprscn.l $e |- L = ( Open ` D ) $.
    oprscn.9 $e |- O e. ( L Cn K ) $.
    ${
      opr1scn.10 $e |- G =
               { <. w , v >. | ( w e. X /\ v = ( w O P ) ) } $.
      $( Construct a continuous function ` G ` from a continuous operation
         ` O ` with the second argument held constant. $)
      opr1scn $p |- ( P e. Y -> G e. ( J Cn K ) ) $=
        cid cX cres cJ cJ ccn co wcel cP cY wcel cG cJ cK ccn co wcel cA cme
        wcel cA cme wcel cA cA wss cid cX cres cJ cJ ccn co wcel oprscn.5
        oprscn.5 cA ssid cA cA cJ cJ cX oprscn.1 oprscn.j oprscn.j metidcn
        mp3an vx vy vz vw vv cA cA cB cD cP cK cid cX cres cG cC cJ cJ cB copn
        cfv cL cO cX cX cY oprscn.1 oprscn.1 oprscn.3 oprscn.5 oprscn.5
        oprscn.6 oprscn.7 oprscn.j oprscn.j cB copn cfv eqid oprscn.l oprscn.k
        oprscn.8 oprscn.9 cG vw cv cX wcel vv cv vw cv cP cO co wceq wa vw vv
        copab vw cv cX wcel vv cv vw cv cid cX cres cfv cP cO co wceq wa vw vv
        copab opr1scn.10 vw cv cX wcel vv cv vw cv cid cX cres cfv cP cO co
        wceq wa vw cv cX wcel vv cv vw cv cP cO co wceq wa vw vv vw cv cX wcel
        vv cv vw cv cid cX cres cfv cP cO co wceq vv cv vw cv cP cO co wceq vw
        cv cX wcel vw cv cid cX cres cfv cP cO co vw cv cP cO co vv cv vw cv cX
        wcel vw cv cid cX cres cfv vw cv cP cO cX vw cv fvresi opreq1d eqeq2d
        pm5.32i opabbii eqtr4i opr1cn mpan $.
        $( [5-Dec-2007] $) $( [23-Aug-2007] $)
    $}
  $}

  ${
    $d h q u v w C $.  $d h m q D $.  $d m u v w F $.  $d m u v w G $.
    $d q H $.  $d q J $.  $d q K $.  $d h k q r O $.  $d k m r u v w $.
    bopcn.1 $e |- C = ( abs o. - ) $.
    bopcn.2 $e |- D = { <. <. w , v >. , u >. | ( ( w e. ( CC X. CC ) /\ v e.
      ( CC X. CC ) ) /\ u = sup ( { ( ( 1st ` w ) C ( 1st ` v ) ) , ( ( 2nd ` w
          ) C ( 2nd ` v ) ) } , RR , < ) ) } $.
    bopcn.j $e |- J = ( Open ` C ) $.
    bopcn.k $e |- K = ( Open ` D ) $.
    bopcn.5 $e |- O : ( CC X. CC ) --> CC $.
    bopcn.6 $e |- F =
            { <. k , r >. | ( k e. NN /\ r = ( 1st ` ( h ` k ) ) ) } $.
    bopcn.7 $e |- G =
            { <. k , r >. | ( k e. NN /\ r = ( 2nd ` ( h ` k ) ) ) } $.
    bopcn.9 $e |- ( ( ( 1st ` ( h ` k ) ) e. CC /\ ( 2nd ` ( h ` k ) ) e.
               CC ) -> ( ( 1st ` ( h ` k ) ) O ( 2nd ` ( h ` k ) ) ) e. CC ) $.
    bopcn.10 $e |- ( ( ( F ~~> ( 1st ` q ) /\ G ~~> ( 2nd ` q ) ) /\ ( 1 e. ZZ
    /\ A. m e. ( ZZ>= ` 1 ) ( ( F ` m ) e. CC /\ ( G ` m ) e. CC /\ ( H ` m ) =
    ( ( F ` m ) O ( G ` m ) ) ) ) ) -> H ~~> ( ( 1st ` q ) O ( 2nd ` q ) ) ) $.
    bopcn.8 $e |- H = { <. k , r >. | ( k e. NN /\ r = ( O ` ( h ` k ) ) ) } $.
    $( Lemma for ~ bopcn . $)
    bopcnlem1 $p |- ( ( h : NN --> ( CC X. CC ) /\ h ( ~~>m ` D ) q )
         -> ( ( F : NN --> CC /\ F ~~> ( 1st ` q ) ) /\
              ( G : NN --> CC /\ G ~~> ( 2nd ` q ) ) ) ) $=
      cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cF wf cF vq cv
      c1st cfv cC clm cfv wbr wa cn cc cG wf cG vq cv c2nd cfv cC clm cfv wbr
      wa wa cn cc cF wf cF vq cv c1st cfv cli wbr wa cn cc cG wf cG vq cv c2nd
      cfv cli wbr wa wa vw vv vu vr cC cC cD vq cv vq cv vk cF cG vh cv cc cc
      vq visset vq visset cC bopcn.1 cnmetba cC bopcn.1 cnmetba cC bopcn.1
      cnmet cC bopcn.1 cnmet bopcn.2 bopcn.6 bopcn.7 xplmi2 cn cc cF wf cF vq
      cv c1st cfv cC clm cfv wbr wa cn cc cF wf cF vq cv c1st cfv cli wbr wa cn
      cc cG wf cG vq cv c2nd cfv cC clm cfv wbr wa cn cc cG wf cG vq cv c2nd
      cfv cli wbr wa cn cc cF wf cF vq cv c1st cfv cC clm cfv wbr cF vq cv c1st
      cfv cli wbr vq cv c1st cfv cvv wcel cn cc cF wf cF vq cv c1st cfv cC clm
      cfv wbr cF vq cv c1st cfv cli wbr wb vq cv c1st fvex cvv cC vq cv c1st
      cfv cF bopcn.1 lmclimnn mpan pm5.32i cn cc cG wf cG vq cv c2nd cfv cC clm
      cfv wbr cG vq cv c2nd cfv cli wbr vq cv c2nd cfv cvv wcel cn cc cG wf cG
      vq cv c2nd cfv cC clm cfv wbr cG vq cv c2nd cfv cli wbr wb vq cv c2nd
      fvex cvv cC vq cv c2nd cfv cG bopcn.1 lmclimnn mpan pm5.32i anbi12i sylib
      $.
      $( [18-Nov-2007] $) $( [30-Jul-2007] $)

    $( Lemma for ~ bopcn . $)
    bopcnlem2 $p |- ( ( h : NN --> ( CC X. CC ) /\ h ( ~~>m ` D ) q ) ->
              H ~~> ( ( 1st ` q ) O ( 2nd ` q ) ) ) $=
      cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cF wf cF vq cv
      c1st cfv cli wbr wa cn cc cG wf cG vq cv c2nd cfv cli wbr wa wa cH vq cv
      c1st cfv vq cv c2nd cfv cO co cli wbr vw vv vu cC cD vh vk vm cF cG cH cJ
      cK cO vr vq bopcn.1 bopcn.2 bopcn.j bopcn.k bopcn.5 bopcn.6 bopcn.7
      bopcn.9 bopcn.10 bopcn.8 bopcnlem1 cF vq cv c1st cfv cli wbr cG vq cv
      c2nd cfv cli wbr wa vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH
      cfv vm cv cF cfv vm cv cG cfv cO co wceq w3a vm c1 cuz cfv wral cH vq cv
      c1st cfv vq cv c2nd cfv cO co cli wbr cn cc cc cxp vh cv wf vh cv vq cv
      cD clm cfv wbr wa cn cc cF wf cF vq cv c1st cfv cli wbr wa cn cc cG wf cG
      vq cv c2nd cfv cli wbr wa wa wa cF vq cv c1st cfv cli wbr cG vq cv c2nd
      cfv cli wbr wa c1 cz wcel vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv
      cH cfv vm cv cF cfv vm cv cG cfv cO co wceq w3a vm c1 cuz cfv wral cH vq
      cv c1st cfv vq cv c2nd cfv cO co cli wbr 1z bopcn.10 mpanr1 cn cc cF wf
      cF vq cv c1st cfv cli wbr wa cn cc cG wf cG vq cv c2nd cfv cli wbr wa wa
      cF vq cv c1st cfv cli wbr cG vq cv c2nd cfv cli wbr wa cn cc cc cxp vh cv
      wf vh cv vq cv cD clm cfv wbr wa cn cc cF wf cF vq cv c1st cfv cli wbr wa
      cF vq cv c1st cfv cli wbr cn cc cG wf cG vq cv c2nd cfv cli wbr wa cG vq
      cv c2nd cfv cli wbr cn cc cF wf cF vq cv c1st cfv cli wbr pm3.27 cn cc cG
      wf cG vq cv c2nd cfv cli wbr pm3.27 anim12i adantl cn cc cc cxp vh cv wf
      vh cv vq cv cD clm cfv wbr wa cn cc cF wf cF vq cv c1st cfv cli wbr wa cn
      cc cG wf vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF
      cfv vm cv cG cfv cO co wceq w3a vm c1 cuz cfv wral cG vq cv c2nd cfv cli
      wbr cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cF wf cn cc
      cG wf vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv
      vm cv cG cfv cO co wceq w3a vm c1 cuz cfv wral cF vq cv c1st cfv cli wbr
      cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cF wf cn cc cG
      wf wa wa vm cv cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF
      cfv vm cv cG cfv cO co wceq w3a vm c1 cuz cfv cn cc cc cxp vh cv wf vh cv
      vq cv cD clm cfv wbr wa cn cc cF wf cn cc cG wf wa wa vm cv cn wcel vm cv
      cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv vm cv cG
      cfv cO co wceq w3a vm cv c1 cuz cfv wcel cn cc cc cxp vh cv wf vh cv vq
      cv cD clm cfv wbr wa cn cc cF wf cn cc cG wf wa wa vm cv cn wcel wa vm cv
      cF cfv cc wcel vm cv cG cfv cc wcel vm cv cH cfv vm cv cF cfv vm cv cG
      cfv cO co wceq cn cc cF wf cn cc cG wf wa vm cv cn wcel vm cv cF cfv cc
      wcel cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cF wf vm
      cv cn wcel vm cv cF cfv cc wcel cn cc cG wf cn cc vm cv cF ffvelrn
      adantlr adantll cn cc cF wf cn cc cG wf wa vm cv cn wcel vm cv cG cfv cc
      wcel cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cG wf vm
      cv cn wcel vm cv cG cfv cc wcel cn cc cF wf cn cc vm cv cG ffvelrn
      adantll adantll cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc
      cF wf cn cc cG wf wa wa vm cv cn wcel wa vm cv vh cv cfv cO cfv vm cv vh
      cv cfv c1st cfv vm cv vh cv cfv c2nd cfv cO co vm cv cH cfv vm cv cF cfv
      vm cv cG cfv cO co cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa vm
      cv cn wcel vm cv vh cv cfv cO cfv vm cv vh cv cfv c1st cfv vm cv vh cv
      cfv c2nd cfv cO co wceq cn cc cF wf cn cc cG wf wa cn cc cc cxp vh cv wf
      vm cv cn wcel vm cv vh cv cfv cO cfv vm cv vh cv cfv c1st cfv vm cv vh cv
      cfv c2nd cfv cO co wceq vh cv vq cv cD clm cfv wbr cn cc cc cxp vh cv wf
      vm cv cn wcel wa vm cv vh cv cfv cO cfv vm cv vh cv cfv c1st cfv vm cv vh
      cv cfv c2nd cfv cop cO cfv vm cv vh cv cfv c1st cfv vm cv vh cv cfv c2nd
      cfv cO co cn cc cc cxp vh cv wf vm cv cn wcel wa vm cv vh cv cfv vm cv vh
      cv cfv c1st cfv vm cv vh cv cfv c2nd cfv cop cO cn cc cc cxp vh cv wf vm
      cv cn wcel wa vm cv vh cv cfv cc cc cxp wcel vm cv vh cv cfv vm cv vh cv
      cfv c1st cfv vm cv vh cv cfv c2nd cfv cop wceq cn cc cc cxp vm cv vh cv
      ffvelrn vm cv vh cv cfv cc cc cxp wcel vm cv vh cv cfv vm cv vh cv cfv
      c1st cfv vm cv vh cv cfv c2nd cfv cop wceq vm cv vh cv cfv c1st cfv cc
      wcel vm cv vh cv cfv c2nd cfv cc wcel wa vm cv vh cv cfv cc cc elxp6
      pm3.26bi syl fveq2d vm cv vh cv cfv c1st cfv vm cv vh cv cfv c2nd cfv cO
      df-opr syl6eqr adantlr adantlr vm cv cn wcel vm cv cH cfv vm cv vh cv cfv
      cO cfv wceq cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cn cc cF
      wf cn cc cG wf wa wa vk vr vm cv vk cv vh cv cfv cO cfv vm cv vh cv cfv
      cO cfv cn cH vk cv vm cv wceq vk cv vh cv cfv vm cv vh cv cfv cO vk cv vm
      cv vh cv fveq2 fveq2d bopcn.8 vm cv vh cv cfv cO fvex fvopab4 adantl vm
      cv cn wcel vm cv cF cfv vm cv cG cfv cO co vm cv vh cv cfv c1st cfv vm cv
      vh cv cfv c2nd cfv cO co wceq cn cc cc cxp vh cv wf vh cv vq cv cD clm
      cfv wbr wa cn cc cF wf cn cc cG wf wa wa vm cv cn wcel vm cv cF cfv vm cv
      vh cv cfv c1st cfv vm cv cG cfv vm cv vh cv cfv c2nd cfv cO vk vr vm cv
      vk cv vh cv cfv c1st cfv vm cv vh cv cfv c1st cfv cn cF vk cv vm cv wceq
      vk cv vh cv cfv vm cv vh cv cfv c1st vk cv vm cv vh cv fveq2 fveq2d
      bopcn.6 vm cv vh cv cfv c1st fvex fvopab4 vk vr vm cv vk cv vh cv cfv
      c2nd cfv vm cv vh cv cfv c2nd cfv cn cG vk cv vm cv wceq vk cv vh cv cfv
      vm cv vh cv cfv c2nd vk cv vm cv vh cv fveq2 fveq2d bopcn.7 vm cv vh cv
      cfv c2nd fvex fvopab4 opreq12d adantl 3eqtr4d 3jca vm cv elnnuz sylan2br
      r19.21aiva adantrlr adantrrr sylanc mpdan $.
      $( [18-Nov-2007] $) $( [30-Jul-2007] $)

    $( Lemma for ~ bopcn . $)
    bopcnlem3 $p |- ( ( h : NN --> ( CC X. CC ) /\ h ( ~~>m ` D ) q ) ->
              H ~~> ( O ` q ) ) $=
      cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cH vq cv c1st cfv vq
      cv c2nd cfv cO co cli wbr cH vq cv cO cfv cli wbr vw vv vu cC cD vh vk vm
      cF cG cH cJ cK cO vr vq bopcn.1 bopcn.2 bopcn.j bopcn.k bopcn.5 bopcn.6
      bopcn.7 bopcn.9 bopcn.10 bopcn.8 bopcnlem2 vh cv vq cv cD clm cfv wbr cH
      vq cv c1st cfv vq cv c2nd cfv cO co cli wbr cH vq cv cO cfv cli wbr wb cn
      cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr vq cv c1st cfv vq cv c2nd
      cfv cO co vq cv cO cfv cH cli vh cv vq cv cD clm cfv wbr vq cv cO cfv vq
      cv c1st cfv vq cv c2nd cfv cop cO cfv vq cv c1st cfv vq cv c2nd cfv cO co
      vh cv vq cv cD clm cfv wbr vq cv vq cv c1st cfv vq cv c2nd cfv cop cO vh
      cv vq cv cD clm cfv wbr vq cv cc cc cxp wcel vq cv vq cv c1st cfv vq cv
      c2nd cfv cop wceq cD cme wcel vq cv cvv wcel vh cv vq cv cD clm cfv wbr
      vq cv cc cc cxp wcel vw vv vu cC cD bopcn.1 bopcn.2 cn2met vq visset cvv
      cD vq cv vh cv cc cc cxp cD cdm cdm cc cc cxp cc cc cxp cxp cdm cc cc cxp
      cD cdm cc cc cxp cc cc cxp cxp vw vv vu cc cc cxp cc cc cxp vw cv c1st
      cfv vv cv c1st cfv cC co vw cv c2nd cfv vv cv c2nd cfv cC co cpr cr clt
      csup cD cr vw cv c1st cfv vv cv c1st cfv cC co vw cv c2nd cfv vv cv c2nd
      cfv cC co cpr clt ltso supex bopcn.2 dmoprab2 dmeqi cc cc cxp dmxpid
      eqtr2i lmcl mp3an12 vq cv cc cc cxp wcel vq cv vq cv c1st cfv vq cv c2nd
      cfv cop wceq vq cv c1st cfv cc wcel vq cv c2nd cfv cc wcel wa vq cv cc cc
      elxp6 pm3.26bi syl fveq2d vq cv c1st cfv vq cv c2nd cfv cO df-opr
      syl6reqr breq2d adantl mpbid $.
      $( [18-Nov-2007] $) $( [30-Jul-2007] $)

    $( Lemma for ~ bopcn . $)
    bopcnlem4 $p |- ( ( h : NN --> ( CC X. CC ) /\ h ( ~~>m ` D ) q ) ->
              H ( ~~>m ` C ) ( O ` q ) ) $=
      cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cH vq cv cO cfv cC
      clm cfv wbr cH vq cv cO cfv cli wbr vw vv vu cC cD vh vk vm cF cG cH cJ
      cK cO vr vq bopcn.1 bopcn.2 bopcn.j bopcn.k bopcn.5 bopcn.6 bopcn.7
      bopcn.9 bopcn.10 bopcn.8 bopcnlem3 cn cc cc cxp vh cv wf cH vq cv cO cfv
      cC clm cfv wbr cH vq cv cO cfv cli wbr wb vh cv vq cv cD clm cfv wbr vq
      cv cO cfv cvv wcel cn cc cH wf cH vq cv cO cfv cC clm cfv wbr cH vq cv cO
      cfv cli wbr wb cn cc cc cxp vh cv wf cvv cC vq cv cO cfv cH bopcn.1
      lmclimnn vq cv cO fvex cn cc cc cxp vh cv wf vk cv vh cv cfv cO cfv cc
      wcel vk cn wral cn cc cH wf cn cc cc cxp vh cv wf vk cv vh cv cfv cO cfv
      cc wcel vk cn cn cc cc cxp vh cv wf vk cv cn wcel wa vk cv vh cv cfv cc
      cc cxp wcel vk cv vh cv cfv cO cfv cc wcel cn cc cc cxp vk cv vh cv
      ffvelrn cc cc cxp cc vk cv vh cv cfv cO bopcn.5 ffvelrni syl r19.21aiva
      vk vr cn cc vk cv vh cv cfv cO cfv cH bopcn.8 fopab2 sylib sylancr adantr
      mpbird $.
      $( [18-Nov-2007] $) $( [30-Jul-2007] $)

    $( Conditions for a binary operation ` O ` on ` CC ` to be continuous. $)
    bopcn $p |- O e. ( K Cn J ) $=
      cO cK cJ ccn co wcel cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr cH
      vq cv cO cfv cC clm cfv wbr wi vq cc cc cxp wral wi vh cD cme wcel cC cme
      wcel cc cc cxp cc cO wf cO cK cJ ccn co wcel cn cc cc cxp vh cv wf vh cv
      vq cv cD clm cfv wbr cH vq cv cO cfv cC clm cfv wbr wi vq cc cc cxp wral
      wi vh wal wb vw vv vu cC cC cD cc cc cC bopcn.1 cnmetba cC bopcn.1
      cnmetba cC bopcn.1 cnmet cC bopcn.1 cnmet bopcn.2 metxp cC bopcn.1 cnmet
      bopcn.5 vq vr cD cC vh vk cO cH cK cJ cc cc cxp cc cD cdm cdm cc cc cxp
      cc cc cxp cxp cdm cc cc cxp cD cdm cc cc cxp cc cc cxp cxp vw vv vu cc cc
      cxp cc cc cxp vw cv c1st cfv vv cv c1st cfv cC co vw cv c2nd cfv vv cv
      c2nd cfv cC co cpr cr clt csup cD cr vw cv c1st cfv vv cv c1st cfv cC co
      vw cv c2nd cfv vv cv c2nd cfv cC co cpr clt ltso supex bopcn.2 dmoprab2
      dmeqi cc cc cxp dmxpid eqtr2i cC bopcn.1 cnmetba bopcn.k bopcn.j bopcn.8
      metcn4 mp3an cn cc cc cxp vh cv wf vh cv vq cv cD clm cfv wbr cH vq cv cO
      cfv cC clm cfv wbr wi vq cc cc cxp cn cc cc cxp vh cv wf vh cv vq cv cD
      clm cfv wbr cH vq cv cO cfv cC clm cfv wbr wi vq cv cc cc cxp wcel cn cc
      cc cxp vh cv wf vh cv vq cv cD clm cfv wbr cH vq cv cO cfv cC clm cfv wbr
      vw vv vu cC cD vh vk vm cF cG cH cJ cK cO vr vq bopcn.1 bopcn.2 bopcn.j
      bopcn.k bopcn.5 bopcn.6 bopcn.7 bopcn.9 bopcn.10 bopcn.8 bopcnlem4 ex
      adantr r19.21aiva mpgbir $.
      $( [18-Nov-2007] $) $( [25-Jul-2007] $)
  $}

  ${
    $d h q u v w C $.  $d h m q D $.  $d q J $.  $d q K $.
    $d h k m q r u v w $.
    addcn.1 $e |- C = ( abs o. - ) $.
    addcn.2 $e |- D = { <. <. w , v >. , u >. | ( ( w e. ( CC X. CC ) /\ v e.
      ( CC X. CC ) ) /\ u = sup ( { ( ( 1st ` w ) C ( 1st ` v ) ) , ( ( 2nd ` w
      ) C ( 2nd ` v ) ) } , RR , < ) ) } $.
    addcn.j $e |- J = ( Open ` C ) $.
    addcn.k $e |- K = ( Open ` D ) $.
    $( Complex number addition is a continuous function.  Part of Proposition
       14-4.16 of [Gleason] p. 243. $)
    addcn $p |- + e. ( K Cn J ) $=
      vw vv vu cC cD vh vk vm vk cv cn wcel vr cv vk cv vh cv cfv c1st cfv wceq
      wa vk vr copab vk cv cn wcel vr cv vk cv vh cv cfv c2nd cfv wceq wa vk vr
      copab vk cv cn wcel vr cv vk cv vh cv cfv caddc cfv wceq wa vk vr copab
      cJ cK caddc vr vq addcn.1 addcn.2 addcn.j addcn.k axaddopr vk cv cn wcel
      vr cv vk cv vh cv cfv c1st cfv wceq wa vk vr copab eqid vk cv cn wcel vr
      cv vk cv vh cv cfv c2nd cfv wceq wa vk vr copab eqid vk cv vh cv cfv c1st
      cfv vk cv vh cv cfv c2nd cfv addcl vq cv c1st cfv vq cv c2nd cfv vm vk cv
      cn wcel vr cv vk cv vh cv cfv c1st cfv wceq wa vk vr copab vk cv cn wcel
      vr cv vk cv vh cv cfv c2nd cfv wceq wa vk vr copab vk cv cn wcel vr cv vk
      cv vh cv cfv caddc cfv wceq wa vk vr copab c1 vk vr cn vk cv vh cv cfv
      c1st cfv nnex opabex2 vk vr cn vk cv vh cv cfv c2nd cfv nnex opabex2 vk
      vr cn vk cv vh cv cfv caddc cfv nnex opabex2 vq cv c1st fvex vq cv c2nd
      fvex climadd vk cv cn wcel vr cv vk cv vh cv cfv caddc cfv wceq wa vk vr
      copab eqid bopcn $.
      $( [26-Nov-2007] $) $( [30-Jul-2007] $)

    $( Complex number subtraction is a continuous function.  Part of
       Proposition 14-4.16 of [Gleason] p. 243. $)
    subcn $p |- - e. ( K Cn J ) $=
      vw vv vu cC cD vh vk vm vk cv cn wcel vr cv vk cv vh cv cfv c1st cfv wceq
      wa vk vr copab vk cv cn wcel vr cv vk cv vh cv cfv c2nd cfv wceq wa vk vr
      copab vk cv cn wcel vr cv vk cv vh cv cfv cmin cfv wceq wa vk vr copab cJ
      cK cmin vr vq addcn.1 addcn.2 addcn.j addcn.k subopr vk cv cn wcel vr cv
      vk cv vh cv cfv c1st cfv wceq wa vk vr copab eqid vk cv cn wcel vr cv vk
      cv vh cv cfv c2nd cfv wceq wa vk vr copab eqid vk cv vh cv cfv c1st cfv
      vk cv vh cv cfv c2nd cfv subcl vq cv c1st cfv vq cv c2nd cfv vm vk cv cn
      wcel vr cv vk cv vh cv cfv c1st cfv wceq wa vk vr copab vk cv cn wcel vr
      cv vk cv vh cv cfv c2nd cfv wceq wa vk vr copab vk cv cn wcel vr cv vk cv
      vh cv cfv cmin cfv wceq wa vk vr copab c1 vk vr cn vk cv vh cv cfv c1st
      cfv nnex opabex2 vk vr cn vk cv vh cv cfv c2nd cfv nnex opabex2 vk vr cn
      vk cv vh cv cfv cmin cfv nnex opabex2 vq cv c1st fvex vq cv c2nd fvex
      climsub vk cv cn wcel vr cv vk cv vh cv cfv cmin cfv wceq wa vk vr copab
      eqid bopcn $.
      $( [26-Nov-2007] $) $( [4-Aug-2007] $)

    $( Complex number multiplication is a continuous function.  Part of
       Proposition 14-4.16 of [Gleason] p. 243. $)
    mulcn $p |- x. e. ( K Cn J ) $=
      vw vv vu cC cD vh vk vm vk cv cn wcel vr cv vk cv vh cv cfv c1st cfv wceq
      wa vk vr copab vk cv cn wcel vr cv vk cv vh cv cfv c2nd cfv wceq wa vk vr
      copab vk cv cn wcel vr cv vk cv vh cv cfv cmul cfv wceq wa vk vr copab cJ
      cK cmul vr vq addcn.1 addcn.2 addcn.j addcn.k axmulopr vk cv cn wcel vr
      cv vk cv vh cv cfv c1st cfv wceq wa vk vr copab eqid vk cv cn wcel vr cv
      vk cv vh cv cfv c2nd cfv wceq wa vk vr copab eqid vk cv vh cv cfv c1st
      cfv vk cv vh cv cfv c2nd cfv mulcl vq cv c1st cfv vq cv c2nd cfv vm vk cv
      cn wcel vr cv vk cv vh cv cfv c1st cfv wceq wa vk vr copab vk cv cn wcel
      vr cv vk cv vh cv cfv c2nd cfv wceq wa vk vr copab vk cv cn wcel vr cv vk
      cv vh cv cfv cmul cfv wceq wa vk vr copab c1 vk vr cn vk cv vh cv cfv
      c1st cfv nnex opabex2 vk vr cn vk cv vh cv cfv c2nd cfv nnex opabex2 vk
      vr cn vk cv vh cv cfv cmul cfv nnex opabex2 vq cv c1st fvex vq cv c2nd
      fvex climmul vk cv cn wcel vr cv vk cv vh cv cfv cmul cfv wceq wa vk vr
      copab eqid bopcn $.
      $( [18-Nov-2007] $) $( [30-Jul-2007] $)
  $}

  ${
    $d w C $.  $d s t u w D $.  $d j m q r s t u v w F $.  $d j v w N $.
    $d j k m w J $.  $d j k m w K $.  $d j k m q r s t u v w X $.
    fsumcn.1 $e |- C e. Met $.
    fsumcn.2 $e |- X = dom dom C $.
    fsumcn.7 $e |- D = ( abs o. - ) $.
    fsumcn.j $e |- J = ( Open ` C ) $.
    fsumcn.k $e |- K = ( Open ` D ) $.
    fsumcn.11 $e |- ( k e. NN -> F e. ( J Cn K ) ) $.
    fsumcn.13 $e |- G =
         { <. w , v >. | ( w e. X /\ v = sum_ k e. ( 1 ... N ) ( F ` w ) ) } $.
    ${
      fsumcnlem.14 $e |- B = { <. <. u , t >. , s >. | ( ( u e. ( CC X. CC )
          /\ t e. ( CC X. CC ) ) /\ s = sup ( { ( ( 1st ` u ) D ( 1st ` t ) ) ,
                  ( ( 2nd ` u ) D ( 2nd ` t ) ) } , RR , < ) ) } $.
      $( Lemma for ~ fsumcn .  _Warning:  The HTML proof page is 0.4MB in
         size_. $)
      fsumcnlem $p |- ( N e. NN -> G e. ( J Cn K ) ) $=
        cN cn wcel vw cv cX wcel vv cv c1 cN cfz co vw cv cF cfv vk csu wceq wa
        vw vv copab cJ cK ccn co cG vw cv cX wcel vv cv c1 vj cv cfz co vw cv
        cF cfv vk csu wceq wa vw vv copab cJ cK ccn co wcel vw cv cX wcel vv cv
        c1 c1 cfz co vw cv cF cfv vk csu wceq wa vw vv copab cJ cK ccn co wcel
        vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv
        copab cJ cK ccn co wcel vw cv cX wcel vv cv c1 vm cv c1 caddc co cfz co
        vw cv cF cfv vk csu wceq wa vw vv copab cJ cK ccn co wcel vw cv cX wcel
        vv cv c1 cN cfz co vw cv cF cfv vk csu wceq wa vw vv copab cJ cK ccn co
        wcel vj vm cN vm cv cn wcel vw cv cX wcel vv cv c1 vm cv cfz co vw cv
        cF cfv vk csu wceq wa vw vv copab cJ cK ccn co wcel vw cv cX wcel vv cv
        c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu wceq wa vw vv copab cJ
        cK ccn co wcel vm cv cn wcel vw cv cX wcel vv cv c1 vm cv cfz co vw cv
        cF cfv vk csu wceq wa vw vv copab cJ cK ccn co wcel wa vw cv cX wcel vv
        cv c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu wceq wa vw vv copab
        vw cv cX wcel vv cv vw cv vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF
        cfv vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1 caddc co cF csb
        cfv caddc co wceq wa vw vv copab cJ cK ccn co vm cv cn wcel vw cv cX
        wcel vv cv c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu wceq wa vw
        vv copab vw cv cX wcel vv cv vw cv vw cv cX wcel vv cv c1 vm cv cfz co
        vw cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1 caddc co
        cF csb cfv caddc co wceq wa vw vv copab wceq vw cv cX wcel vv cv c1 vm
        cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cJ cK ccn co wcel vm
        cv cn wcel vw cv cX wcel vv cv c1 vm cv c1 caddc co cfz co vw cv cF cfv
        vk csu wceq wa vw cv cX wcel vv cv vw cv vw cv cX wcel vv cv c1 vm cv
        cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1
        caddc co cF csb cfv caddc co wceq wa vw vv vm cv cn wcel vw cv cX wcel
        vv cv c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu wceq vv cv vw cv
        vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv
        copab cfv vw cv vk vm cv c1 caddc co cF csb cfv caddc co wceq vm cv cn
        wcel vw cv cX wcel wa c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu
        vw cv vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa
        vw vv copab cfv vw cv vk vm cv c1 caddc co cF csb cfv caddc co vv cv vm
        cv cn wcel vw cv cX wcel wa c1 vm cv c1 caddc co cfz co vw cv cF cfv vk
        csu c1 vm cv cfz co vw cv cF cfv vk csu vk vm cv c1 caddc co vw cv cF
        cfv csb caddc co vw cv vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv
        vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1 caddc co cF csb cfv
        caddc co vm cv cn wcel c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu
        c1 vm cv cfz co vw cv cF cfv vk csu vk vm cv c1 caddc co vw cv cF cfv
        csb caddc co wceq vw cv cX wcel vm cv cn wcel vm cv c1 cuz cfv wcel c1
        vm cv c1 caddc co cfz co vw cv cF cfv vk csu c1 vm cv cfz co vw cv cF
        cfv vk csu vk vm cv c1 caddc co vw cv cF cfv csb caddc co wceq vm cv
        elnnuz vw cv cF cfv vk c1 vm cv vw cv cF fvex fsump1slem sylbi adantr
        vw cv cX wcel vw cv vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk
        csu wceq wa vw vv copab cfv vw cv vk vm cv c1 caddc co cF csb cfv caddc
        co c1 vm cv cfz co vw cv cF cfv vk csu vk vm cv c1 caddc co vw cv cF
        cfv csb caddc co wceq vm cv cn wcel vw cv cX wcel vw cv vw cv cX wcel
        vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv c1 vm
        cv cfz co vw cv cF cfv vk csu vw cv vk vm cv c1 caddc co cF csb cfv vk
        vm cv c1 caddc co vw cv cF cfv csb caddc vw cv cX wcel c1 vm cv cfz co
        vw cv cF cfv vk csu cvv wcel vw cv vw cv cX wcel vv cv c1 vm cv cfz co
        vw cv cF cfv vk csu wceq wa vw vv copab cfv c1 vm cv cfz co vw cv cF
        cfv vk csu wceq c1 vm cv cfz co vw cv cF cfv vk sumex vw vv cX c1 vm cv
        cfz co vw cv cF cfv vk csu cvv fvopab2 mpan2 vw cv vk vm cv c1 caddc co
        cF csb cfv vk vm cv c1 caddc co vw cv cF cfv csb wceq vw cv cX wcel vk
        vm cv c1 caddc co vw cv cF cfv csb vk vm cv c1 caddc co vw cv csb vk vm
        cv c1 caddc co cF csb cfv vw cv vk vm cv c1 caddc co cF csb cfv vm cv
        c1 caddc co cvv wcel vk vm cv c1 caddc co vw cv cF cfv csb vk vm cv c1
        caddc co vw cv csb vk vm cv c1 caddc co cF csb cfv wceq vm cv c1 caddc
        oprex vk vm cv c1 caddc co vw cv cvv cF csbfv12g ax-mp vk vm cv c1
        caddc co vw cv csb vw cv vk vm cv c1 caddc co cF csb vm cv c1 caddc co
        cvv wcel vk vm cv c1 caddc co vw cv csb vw cv wceq vm cv c1 caddc oprex
        vk vv vm cv c1 caddc co vw cv cvv vv cv vw cv wcel vk ax-17 csbconstgf
        ax-mp fveq2i eqtr2i a1i opreq12d adantl eqtr4d eqeq2d pm5.32da opabbidv
        adantr vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa
        vw vv copab cJ cK ccn co wcel vk vm cv c1 caddc co cF csb cJ cK ccn co
        wcel vw cv cX wcel vv cv vw cv vw cv cX wcel vv cv c1 vm cv cfz co vw
        cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1 caddc co cF
        csb cfv caddc co wceq wa vw vv copab cJ cK ccn co wcel vm cv cn wcel vw
        cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv
        copab cJ cK ccn co wcel wa vr cv cX wcel vq cv c1 vm cv cfz co vr cv cF
        cfv vk csu wceq wa vr vq copab cJ cK ccn co wcel vk vm cv c1 caddc co
        cF csb cJ cK ccn co wcel vw cv cX wcel vv cv vw cv vw cv cX wcel vv cv
        c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vk vm
        cv c1 caddc co cF csb cfv caddc co wceq wa vw vv copab cJ cK ccn co
        wcel vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw
        vv copab cJ cK ccn co wcel vu vt vs vw vv cC cD cD cB cK vr cv cX wcel
        vq cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vr vq copab vk vm cv
        c1 caddc co cF csb vw cv cX wcel vv cv vw cv vw cv cX wcel vv cv c1 vm
        cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1
        caddc co cF csb cfv caddc co wceq wa vw vv copab cD cJ cK cK cB copn
        cfv caddc cX cc cc fsumcn.2 cD fsumcn.7 cnmetba cD fsumcn.7 cnmetba
        fsumcn.1 cD fsumcn.7 cnmet cD fsumcn.7 cnmet cD fsumcn.7 cnmet fsumcn.j
        fsumcn.k fsumcn.k cB copn cfv eqid fsumcn.k fsumcnlem.14 vu vt vs cD cB
        cK cB copn cfv fsumcn.7 fsumcnlem.14 fsumcn.k cB copn cfv eqid addcn vw
        cv cX wcel vv cv vw cv vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv
        vk csu wceq wa vw vv copab cfv vw cv vk vm cv c1 caddc co cF csb cfv
        caddc co wceq wa vw cv cX wcel vv cv vw cv vr cv cX wcel vq cv c1 vm cv
        cfz co vr cv cF cfv vk csu wceq wa vr vq copab cfv vw cv vk vm cv c1
        caddc co cF csb cfv caddc co wceq wa vw vv vv cv vw cv vw cv cX wcel vv
        cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vk
        vm cv c1 caddc co cF csb cfv caddc co wceq vv cv vw cv vr cv cX wcel vq
        cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vr vq copab cfv vw cv vk
        vm cv c1 caddc co cF csb cfv caddc co wceq vw cv cX wcel vw cv vw cv cX
        wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv
        vw cv vk vm cv c1 caddc co cF csb cfv caddc co vw cv vr cv cX wcel vq
        cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vr vq copab cfv vw cv vk
        vm cv c1 caddc co cF csb cfv caddc co vv cv vw cv vw cv cX wcel vv cv
        c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab cfv vw cv vr cv
        cX wcel vq cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vr vq copab
        cfv vw cv vk vm cv c1 caddc co cF csb cfv caddc vw cv vw cv cX wcel vv
        cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab vr cv cX
        wcel vq cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vr vq copab vw
        cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vr cv cX
        wcel vq cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vw vv vr vq vw
        cv vr cv wceq vv cv vq cv wceq wa vw cv cX wcel vr cv cX wcel vv cv c1
        vm cv cfz co vw cv cF cfv vk csu wceq vq cv c1 vm cv cfz co vr cv cF
        cfv vk csu wceq vw cv vr cv wceq vw cv cX wcel vr cv cX wcel wb vv cv
        vq cv wceq vw cv vr cv cX eleq1 adantr vv cv vq cv wceq vw cv vr cv
        wceq vv cv vq cv c1 vm cv cfz co vw cv cF cfv vk csu c1 vm cv cfz co vr
        cv cF cfv vk csu vv cv vq cv wceq id vw cv vr cv wceq c1 vm cv cfz co
        vw cv cF cfv vr cv cF cfv vk vw cv vr cv cF fveq2 sumeq2sdv eqeqan12rd
        anbi12d cbvopabv fveq1i opreq1i eqeq2i anbi2i opabbii oprcn vw cv cX
        wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab vr
        cv cX wcel vq cv c1 vm cv cfz co vr cv cF cfv vk csu wceq wa vr vq
        copab cJ cK ccn co vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk
        csu wceq wa vr cv cX wcel vq cv c1 vm cv cfz co vr cv cF cfv vk csu
        wceq wa vw vv vr vq vw cv vr cv wceq vv cv vq cv wceq wa vw cv cX wcel
        vr cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq vq cv c1
        vm cv cfz co vr cv cF cfv vk csu wceq vw cv vr cv wceq vw cv cX wcel vr
        cv cX wcel wb vv cv vq cv wceq vw cv vr cv cX eleq1 adantr vv cv vq cv
        wceq vw cv vr cv wceq vv cv vq cv c1 vm cv cfz co vw cv cF cfv vk csu
        c1 vm cv cfz co vr cv cF cfv vk csu vv cv vq cv wceq id vw cv vr cv
        wceq c1 vm cv cfz co vw cv cF cfv vr cv cF cfv vk vw cv vr cv cF fveq2
        sumeq2sdv eqeqan12rd anbi12d cbvopabv eleq1i sylanb vm cv cn wcel vw cv
        cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab
        cJ cK ccn co wcel pm3.27 vm cv cn wcel vk vm cv c1 caddc co cF csb cJ
        cK ccn co wcel vw cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu
        wceq wa vw vv copab cJ cK ccn co wcel vm cv c1 caddc co cn wcel cF cJ
        cK ccn co wcel vk cn wral vk vm cv c1 caddc co cF csb cJ cK ccn co wcel
        vm cv cn wcel vk vm cv c1 caddc co cn cF cJ cK ccn co ra4csbela vm cv
        peano2nn cF cJ cK ccn co wcel vk cn fsumcn.11 rgen sylancl adantr
        sylanc eqeltrd ex vw cv cX wcel vv cv c1 c1 cfz co vw cv cF cfv vk csu
        wceq wa vw vv copab vk c1 vw cv cX wcel vv cv vw cv cF cfv wceq wa vw
        vv copab csb cJ cK ccn co vk c1 vw cv cX wcel vv cv vw cv cF cfv wceq
        wa vw vv copab csb vw cv cX wcel vv cv vw cv cF cfv wceq wa vk c1 wsbc
        vw vv copab vw cv cX wcel vv cv c1 c1 cfz co vw cv cF cfv vk csu wceq
        wa vw vv copab c1 cn wcel vk c1 vw cv cX wcel vv cv vw cv cF cfv wceq
        wa vw vv copab csb vw cv cX wcel vv cv vw cv cF cfv wceq wa vk c1 wsbc
        vw vv copab wceq 1nn vw cv cX wcel vv cv vw cv cF cfv wceq wa vk vw vv
        c1 cn csbopabg ax-mp vw cv cX wcel vv cv vw cv cF cfv wceq wa vk c1
        wsbc vw cv cX wcel vv cv c1 c1 cfz co vw cv cF cfv vk csu wceq wa vw vv
        vw cv cX wcel vv cv vw cv cF cfv wceq wa vk c1 wsbc vw cv cX wcel vk c1
        wsbc vv cv vw cv cF cfv wceq vk c1 wsbc wa vw cv cX wcel vv cv c1 c1
        cfz co vw cv cF cfv vk csu wceq wa c1 cn wcel vw cv cX wcel vv cv vw cv
        cF cfv wceq wa vk c1 wsbc vw cv cX wcel vk c1 wsbc vv cv vw cv cF cfv
        wceq vk c1 wsbc wa wb 1nn vw cv cX wcel vv cv vw cv cF cfv wceq vk c1
        cn sbcang ax-mp vw cv cX wcel vk c1 wsbc vw cv cX wcel vv cv vw cv cF
        cfv wceq vk c1 wsbc vv cv c1 c1 cfz co vw cv cF cfv vk csu wceq c1 cvv
        wcel vw cv cX wcel vk c1 wsbc vw cv cX wcel wb c1 cn 1nn elisseti vw cv
        cX wcel vk c1 cvv vw cv cX wcel vk ax-17 sbcgf ax-mp vv cv vw cv cF cfv
        wceq vk c1 wsbc vv cv vk c1 vw cv cF cfv csb wceq vv cv c1 c1 cfz co vw
        cv cF cfv vk csu wceq c1 cvv wcel vv cv vw cv cF cfv wceq vk c1 wsbc vv
        cv vk c1 vw cv cF cfv csb wceq wb c1 cn 1nn elisseti vk c1 vv cv vw cv
        cF cfv cvv sbceq2dig ax-mp c1 c1 cfz co vw cv cF cfv vk csu vk c1 vw cv
        cF cfv csb vv cv c1 cz wcel vw cv cF cfv cvv wcel vk c1 c1 cfz co wral
        c1 c1 cfz co vw cv cF cfv vk csu vk c1 vw cv cF cfv csb wceq 1z vw cv
        cF cfv cvv wcel vk c1 c1 cfz co vw cv cF cfv cvv wcel vk cv c1 c1 cfz
        co wcel vw cv cF fvex a1i rgen vw cv cF cfv cvv vk c1 fsum1s mp2an
        eqeq2i bitr4i anbi12i bitri opabbii eqtr2i c1 cn wcel vw cv cX wcel vv
        cv vw cv cF cfv wceq wa vw vv copab cJ cK ccn co wcel vk cn wral vk c1
        vw cv cX wcel vv cv vw cv cF cfv wceq wa vw vv copab csb cJ cK ccn co
        wcel 1nn vw cv cX wcel vv cv vw cv cF cfv wceq wa vw vv copab cJ cK ccn
        co wcel vk cn vk cv cn wcel cF vw cv cX wcel vv cv vw cv cF cfv wceq wa
        vw vv copab cJ cK ccn co vk cv cn wcel cX cc cF wf cF vw cv cX wcel vv
        cv vw cv cF cfv wceq wa vw vv copab wceq vk cv cn wcel cF cJ cK ccn co
        wcel cX cc cF wf fsumcn.11 cC cme wcel cD cme wcel cF cJ cK ccn co wcel
        cX cc cF wf fsumcn.1 cD fsumcn.7 cnmet cC cD cF cJ cK cX cc fsumcn.2 cD
        fsumcn.7 cnmetba fsumcn.j fsumcn.k metcnf mp3an12 syl cX cc cF wf cF vw
        cv cX wcel vv cv vw cv cF cfv wceq wa vw vv copab wceq vw cv cF cfv cc
        wcel vw cX wral vw vv cX cc cF fopabfv pm3.26bi syl fsumcn.11 eqeltrrd
        rgen vk c1 cn vw cv cX wcel vv cv vw cv cF cfv wceq wa vw vv copab cJ
        cK ccn co ra4csbela mp2an eqeltri vj cv c1 wceq vw cv cX wcel vv cv c1
        vj cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab vw cv cX wcel vv
        cv c1 c1 cfz co vw cv cF cfv vk csu wceq wa vw vv copab cJ cK ccn co vj
        cv c1 wceq vw cv cX wcel vv cv c1 vj cv cfz co vw cv cF cfv vk csu wceq
        wa vw cv cX wcel vv cv c1 c1 cfz co vw cv cF cfv vk csu wceq wa vw vv
        vj cv c1 wceq vv cv c1 vj cv cfz co vw cv cF cfv vk csu wceq vv cv c1
        c1 cfz co vw cv cF cfv vk csu wceq vw cv cX wcel vj cv c1 wceq c1 vj cv
        cfz co vw cv cF cfv vk csu c1 c1 cfz co vw cv cF cfv vk csu vv cv vj cv
        c1 wceq c1 vj cv cfz co c1 c1 cfz co vw cv cF cfv vk vj cv c1 c1 cfz
        opreq2 sumeq1d eqeq2d anbi2d opabbidv eleq1d vj cv vm cv wceq vw cv cX
        wcel vv cv c1 vj cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab vw
        cv cX wcel vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq wa vw vv
        copab cJ cK ccn co vj cv vm cv wceq vw cv cX wcel vv cv c1 vj cv cfz co
        vw cv cF cfv vk csu wceq wa vw cv cX wcel vv cv c1 vm cv cfz co vw cv
        cF cfv vk csu wceq wa vw vv vj cv vm cv wceq vv cv c1 vj cv cfz co vw
        cv cF cfv vk csu wceq vv cv c1 vm cv cfz co vw cv cF cfv vk csu wceq vw
        cv cX wcel vj cv vm cv wceq c1 vj cv cfz co vw cv cF cfv vk csu c1 vm
        cv cfz co vw cv cF cfv vk csu vv cv vj cv vm cv wceq c1 vj cv cfz co c1
        vm cv cfz co vw cv cF cfv vk vj cv vm cv c1 cfz opreq2 sumeq1d eqeq2d
        anbi2d opabbidv eleq1d vj cv vm cv c1 caddc co wceq vw cv cX wcel vv cv
        c1 vj cv cfz co vw cv cF cfv vk csu wceq wa vw vv copab vw cv cX wcel
        vv cv c1 vm cv c1 caddc co cfz co vw cv cF cfv vk csu wceq wa vw vv
        copab cJ cK ccn co vj cv vm cv c1 caddc co wceq vw cv cX wcel vv cv c1
        vj cv cfz co vw cv cF cfv vk csu wceq wa vw cv cX wcel vv cv c1 vm cv
        c1 caddc co cfz co vw cv cF cfv vk csu wceq wa vw vv vj cv vm cv c1
        caddc co wceq vv cv c1 vj cv cfz co vw cv cF cfv vk csu wceq vv cv c1
        vm cv c1 caddc co cfz co vw cv cF cfv vk csu wceq vw cv cX wcel vj cv
        vm cv c1 caddc co wceq c1 vj cv cfz co vw cv cF cfv vk csu c1 vm cv c1
        caddc co cfz co vw cv cF cfv vk csu vv cv vj cv vm cv c1 caddc co wceq
        c1 vj cv cfz co c1 vm cv c1 caddc co cfz co vw cv cF cfv vk vj cv vm cv
        c1 caddc co c1 cfz opreq2 sumeq1d eqeq2d anbi2d opabbidv eleq1d vj cv
        cN wceq vw cv cX wcel vv cv c1 vj cv cfz co vw cv cF cfv vk csu wceq wa
        vw vv copab vw cv cX wcel vv cv c1 cN cfz co vw cv cF cfv vk csu wceq
        wa vw vv copab cJ cK ccn co vj cv cN wceq vw cv cX wcel vv cv c1 vj cv
        cfz co vw cv cF cfv vk csu wceq wa vw cv cX wcel vv cv c1 cN cfz co vw
        cv cF cfv vk csu wceq wa vw vv vj cv cN wceq vv cv c1 vj cv cfz co vw
        cv cF cfv vk csu wceq vv cv c1 cN cfz co vw cv cF cfv vk csu wceq vw cv
        cX wcel vj cv cN wceq c1 vj cv cfz co vw cv cF cfv vk csu c1 cN cfz co
        vw cv cF cfv vk csu vv cv vj cv cN wceq c1 vj cv cfz co c1 cN cfz co vw
        cv cF cfv vk vj cv cN c1 cfz opreq2 sumeq1d eqeq2d anbi2d opabbidv
        eleq1d nnindALT fsumcn.13 syl5eqel $.
        $( [2-Dec-2007] $) $( [6-Aug-2007] $)
    $}

    $( A finite sum of functions to complex numbers from a common metric space
       is continuous.  The class expression for ` F ` normally contains free
       variable ` k ` to index it. $)
    fsumcn $p |- ( N e. NN -> G e. ( J Cn K ) ) $=
      vw vv vu vt vu cv cc cc cxp wcel vt cv cc cc cxp wcel wa vs cv vu cv c1st
      cfv vt cv c1st cfv cD co vu cv c2nd cfv vt cv c2nd cfv cD co cpr cr clt
      csup wceq wa vu vt vs copab2 cC cD vk cF cG cJ cK cN cX vs fsumcn.1
      fsumcn.2 fsumcn.7 fsumcn.j fsumcn.k fsumcn.11 fsumcn.13 vu cv cc cc cxp
      wcel vt cv cc cc cxp wcel wa vs cv vu cv c1st cfv vt cv c1st cfv cD co vu
      cv c2nd cfv vt cv c2nd cfv cD co cpr cr clt csup wceq wa vu vt vs copab2
      eqid fsumcnlem $.
      $( [2-Dec-2007] $) $( [8-Aug-2007] $)
  $}

  ${
    $d a g j k m n x y D $.  $d a h j k m n x y z F $.  $d g j k m n x y G $.
    $d a g h j k m n x y z X $.
    iscms2lem1.1 $e |- G = { <. h , z >. | ( h e. NN /\
                       z = if ( ( F ` h ) e. X , ( F ` h ) , a ) ) } $.
    iscms2lem3.2 $e |- X = dom dom D $.
    $( Lemma for ~ iscms2 .  If the arbitrary sequence ` F ` is Cauchy, so
       is the constructed function ` G ` . $)
    iscms2lem3 $p |- ( ( D e. Met /\ F e. ( Cau ` D ) /\ a e. X ) ->
                     G e. ( Cau ` D ) ) $=
      cD cme wcel cF cD cca cfv wcel va cv cX wcel w3a cG cD cca cfv wcel cc0
      vx cv clt wbr vj cv vk cv cle wbr vj cv cG cfv vk cv cG cfv cD co vx cv
      clt wbr wi vk cn wral vj cn wrex wi vx cr wral cD cme wcel cF cD cca cfv
      wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cG cfv vk cv cG cfv cD
      co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral va cv cX wcel cD
      cme wcel cF cD cca cfv wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv
      cG cfv vk cv cG cfv cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr
      wral cD cme wcel cF cD cca cfv wcel cF cc cX cxp wss cc0 vx cv clt wbr vj
      cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv
      vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr
      wral wa cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cG cfv vk cv cG cfv
      cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral vx cD vj vk cF
      c1 cX cn iscms2lem3.2 1z nnuz iscau3 cD cme wcel cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
      cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex wi vx cr wral
      cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cG cfv vk cv cG cfv cD co vx
      cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral cF cc cX cxp wss cD cme
      wcel cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF
      cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn
      wral vj cn wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cG cfv vk
      cv cG cfv cD co vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr cD cme
      wcel vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv
      cF cfv vk cv cF cfv cD co vx cv clt wbr w3a wi vk cn wral vj cn wrex vj
      cv vk cv cle wbr vj cv cG cfv vk cv cG cfv cD co vx cv clt wbr wi vk cn
      wral vj cn wrex cc0 vx cv clt wbr cD cme wcel vj cv vk cv cle wbr vj cv
      cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv
      clt wbr w3a wi vk cn wral vj cv vk cv cle wbr vj cv cG cfv vk cv cG cfv
      cD co vx cv clt wbr wi vk cn wral vj cn cD cme wcel vj cv cn wcel wa vj
      cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv
      vk cv cF cfv cD co vx cv clt wbr w3a wi vj cv vk cv cle wbr vj cv cG cfv
      vk cv cG cfv cD co vx cv clt wbr wi vk cn cD cme wcel vj cv cn wcel wa vk
      cv cn wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
      cv cF cfv cD co vx cv clt wbr w3a vj cv cG cfv vk cv cG cfv cD co vx cv
      clt wbr vj cv vk cv cle wbr vj cv cn wcel vk cv cn wcel vj cv cF cfv cX
      wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr
      w3a vj cv cG cfv vk cv cG cfv cD co vx cv clt wbr wi cD cme wcel vj cv cn
      wcel vk cv cn wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
      cfv vk cv cF cfv cD co vx cv clt wbr vj cv cG cfv vk cv cG cfv cD co vx
      cv clt wbr vj cv cn wcel vk cv cn wcel wa vj cv cF cfv cX wcel vk cv cF
      cfv cX wcel vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr vj cv cG cfv vk
      cv cG cfv cD co vx cv clt wbr wi vj cv cn wcel vk cv cn wcel wa vj cv cF
      cfv cX wcel vk cv cF cfv cX wcel wa wa vj cv cG cfv vk cv cG cfv cD co vx
      cv clt wbr vj cv cF cfv vk cv cF cfv cD co vx cv clt wbr vj cv cn wcel vk
      cv cn wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX wcel wa wa vj cv cG
      cfv vk cv cG cfv cD co vj cv cF cfv vk cv cF cfv cD co vx cv clt vj cv cn
      wcel vj cv cF cfv cX wcel vk cv cn wcel vk cv cF cfv cX wcel vj cv cG cfv
      vk cv cG cfv cD co vj cv cF cfv vk cv cF cfv cD co wceq vj cv cn wcel vj
      cv cF cfv cX wcel wa vk cv cn wcel vk cv cF cfv cX wcel wa vj cv cG cfv
      vj cv cF cfv vk cv cG cfv vk cv cF cfv cD vz va cv vh cF cG vj cv cX cn
      iscms2lem1.1 lmfexlem2 vz va cv vh cF cG vk cv cX cn iscms2lem1.1
      lmfexlem2 opreqan12d an4s breq1d biimprd exp32 3impd adantll imim2d
      r19.20dva r19.22dva imim2d r19.20sdv adantld sylbid imp 3adant3 cD cme
      wcel cn cX cG wf cG cD cca cfv wcel cc0 vx cv clt wbr vj cv vk cv cle wbr
      vj cv cG cfv vk cv cG cfv cD co vx cv clt wbr wi vk cn wral vj cn wrex wi
      vx cr wral wb cD cme wcel cF cD cca cfv wcel va cv cX wcel w3a vx cD vj
      vk cG c1 cX cn iscms2lem3.2 1z nnuz iscauf cD cme wcel cF cD cca cfv wcel
      va cv cX wcel 3simp1 va cv cX wcel cD cme wcel cn cX cG wf cF cD cca cfv
      wcel vz va cv vh cF cG cX cn iscms2lem1.1 lmfexlem1 3ad2ant3 sylanc
      mpbird $.
      $( [13-Oct-2007] $) $( [19-Dec-2006] $)

    $( Lemma for ~ iscms2 .  Whenever the constructed function ` G `
       converges, so does the arbitrary Cauchy sequence ` F ` . $)
    iscms2lem4 $p |- ( ( D e. Met /\ F e. ( Cau ` D ) /\
                      G ( ~~>m ` D ) x ) -> F ( ~~>m ` D ) x ) $=
      cD cme wcel cF cD cca cfv wcel cG vx cv cD clm cfv wbr w3a cF vx cv cD
      clm cfv wbr cF cc cX cxp wss vx cv cX wcel cc0 vy cv clt wbr vj cv vk cv
      cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi
      vk cn wral vj cn wrex wi vy cr wral w3a cD cme wcel cF cD cca cfv wcel cG
      vx cv cD clm cfv wbr w3a cF cc cX cxp wss vx cv cX wcel cc0 vy cv clt wbr
      vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv
      clt wbr wa wi vk cn wral vj cn wrex wi vy cr wral cD cme wcel cF cD cca
      cfv wcel cF cc cX cxp wss cG vx cv cD clm cfv wbr cD cF cX iscms2lem3.2
      caufss 3adant3 cD cme wcel cG vx cv cD clm cfv wbr vx cv cX wcel cF cD
      cca cfv wcel cD cme wcel vx cv cvv wcel cG vx cv cD clm cfv wbr vx cv cX
      wcel vx visset cvv cD vx cv cG cX iscms2lem3.2 lmcl mp3an2 3adant2 cD cme
      wcel cF cD cca cfv wcel cG vx cv cD clm cfv wbr cc0 vy cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr
      wa wi vk cn wral vj cn wrex wi vy cr wral cD cme wcel cF cD cca cfv wcel
      cG vx cv cD clm cfv wbr wa cc0 vy cv clt wbr vm cv vk cv cle wbr vm cv cF
      cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv
      clt wbr w3a wi vk cn wral vm cn wrex wi vy cr wral cc0 vy cv clt wbr vn
      cv vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt
      wbr wa wi vk cn wral vn cn wrex wi vy cr wral wa cc0 vy cv clt wbr vj cv
      vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr
      wa wi vk cn wral vj cn wrex wi vy cr wral cD cme wcel cF cD cca cfv wcel
      cc0 vy cv clt wbr vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv
      cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral
      vm cn wrex wi vy cr wral cG vx cv cD clm cfv wbr cc0 vy cv clt wbr vn cv
      vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr
      wa wi vk cn wral vn cn wrex wi vy cr wral cD cme wcel cF cD cca cfv wcel
      cF cc cX cxp wss cc0 vy cv clt wbr vm cv vk cv cle wbr vm cv cF cfv cX
      wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr
      w3a wi vk cn wral vm cn wrex wi vy cr wral wa cc0 vy cv clt wbr vm cv vk
      cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv
      cF cfv cD co vy cv clt wbr w3a wi vk cn wral vm cn wrex wi vy cr wral vy
      cD vm vk cF c1 cX cn iscms2lem3.2 1z nnuz iscau3 cF cc cX cxp wss cc0 vy
      cv clt wbr vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel
      vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral vm cn
      wrex wi vy cr wral pm3.27 syl6bi cD cme wcel cG vx cv cD clm cfv wbr cG
      cc cX cxp wss vx cv cX wcel cc0 vy cv clt wbr vn cv vk cv cle wbr vk cv
      cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vn
      cn wrex wi vy cr wral w3a cc0 vy cv clt wbr vn cv vk cv cle wbr vk cv cG
      cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vn cn
      wrex wi vy cr wral cD cme wcel vx cv cvv wcel cG vx cv cD clm cfv wbr cG
      cc cX cxp wss vx cv cX wcel cc0 vy cv clt wbr vn cv vk cv cle wbr vk cv
      cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vn
      cn wrex wi vy cr wral w3a wb vx visset vy cvv cD vx cv vn vk cG c1 cX cn
      iscms2lem3.2 1z nnuz lmbr2 mpan2 cG cc cX cxp wss vx cv cX wcel cc0 vy cv
      clt wbr vn cv vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co
      vy cv clt wbr wa wi vk cn wral vn cn wrex wi vy cr wral 3simp3 syl6bi
      anim12d cc0 vy cv clt wbr vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv
      cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn
      wral vm cn wrex wi vy cr wral cc0 vy cv clt wbr vn cv vk cv cle wbr vk cv
      cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vn
      cn wrex wi vy cr wral cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cF cfv
      cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn
      wrex wi vy cr wral cc0 vy cv clt wbr vm cv vk cv cle wbr vm cv cF cfv cX
      wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr
      w3a wi vk cn wral vm cn wrex wi cc0 vy cv clt wbr vn cv vk cv cle wbr vk
      cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cn wral
      vn cn wrex wi cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel
      vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn wrex wi vy
      cr vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF
      cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral vm cn wrex vn cv
      vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr
      wa wi vk cn wral vn cn wrex vj cv vk cv cle wbr vk cv cF cfv cX wcel vk
      cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn wrex cc0 vy cv
      clt wbr vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm
      cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral vn cv vk cv
      cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi
      vk cn wral vn cn wrex vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
      cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn wrex wi vm cn vm cv
      cn wcel vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm
      cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral wa vn cv vk
      cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa
      wi vk cn wral vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv
      cD co vy cv clt wbr wa wi vk cn wral vj cn wrex vn cn vm cv cn wcel vn cv
      cn wcel vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm
      cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral vn cv vk cv
      cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi
      vk cn wral vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD
      co vy cv clt wbr wa wi vk cn wral vj cn wrex wi vm cv cn wcel vn cv cn
      wcel wa vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm
      cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral wa vn cv vk
      cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa
      wi vk cn wral vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF
      cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cv
      vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr
      wa wi vk cn wral vj cn wrex vm cv cn wcel vn cv cn wcel wa vm cv vk cv
      cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF
      cfv cD co vy cv clt wbr w3a wi vk cn wral vn cv vk cv cle wbr vk cv cG
      cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vm cv
      vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
      cfv vx cv cD co vy cv clt wbr wa wi vk cn wral wi vm cv cn wcel vn cv cn
      wcel wa vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm
      cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vk cn wral vn cv vk cv
      cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi
      vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk
      cv cF cfv vx cv cD co vy cv clt wbr wa wi wi vk cn wral vn cv vk cv cle
      wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk
      cn wral vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX
      wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral wi vm cv cn
      wcel vn cv cn wcel wa vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF
      cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vn cv vk
      cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa
      wi vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel
      vk cv cF cfv vx cv cD co vy cv clt wbr wa wi wi vk cn vm cv cn wcel vn cv
      cn wcel wa vk cv cn wcel wa vm cv vk cv cle wbr vm cv cF cfv cX wcel vk
      cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vn
      cv vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt
      wbr wa wi vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv
      cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vm cv cn wcel vn cv
      cn wcel wa vk cv cn wcel wa vm cv vk cv cle wbr vm cv cF cfv cX wcel vk
      cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vn
      cv vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt
      wbr wa wi wa vm cv vk cv cle wbr vn cv vk cv cle wbr wa vk cv cF cfv cX
      wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vm cv vn cv cle wbr vn
      cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co
      vy cv clt wbr wa wi vk cv cn wcel vm cv vk cv cle wbr vm cv cF cfv cX
      wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr
      w3a wi vn cv vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co
      vy cv clt wbr wa wi wa vm cv vk cv cle wbr vn cv vk cv cle wbr wa vk cv
      cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi wi vm cv cn
      wcel vn cv cn wcel wa vk cv cn wcel vm cv vk cv cle wbr vm cv cF cfv cX
      wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr
      w3a wi vn cv vk cv cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co
      vy cv clt wbr wa wi vm cv vk cv cle wbr vn cv vk cv cle wbr wa vk cv cF
      cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cv cn wcel vm
      cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv
      vk cv cF cfv cD co vy cv clt wbr w3a wi wa vm cv vk cv cle wbr vn cv vk
      cv cle wbr wa vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr
      wa wi vm cv vk cv cle wbr vn cv vk cv cle wbr wa vk cv cF cfv cX wcel vk
      cv cF cfv vx cv cD co vy cv clt wbr wa wi vn cv vk cv cle wbr vk cv cG
      cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi vk cv cn wcel vm
      cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv
      vk cv cF cfv cD co vy cv clt wbr w3a wi wa vm cv vk cv cle wbr vn cv vk
      cv cle wbr wa vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr
      wa vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa vk cv
      cn wcel vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm
      cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi wa vm cv vk cv cle wbr
      vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa vk cv cF
      cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wb vn cv vk cv cle
      wbr vk cv cn wcel vm cv vk cv cle wbr vm cv cF cfv cX wcel vk cv cF cfv
      cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a wi vm cv vk cv
      cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa vk
      cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wb wi vk cv
      cn wcel vm cv cF cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF
      cfv cD co vy cv clt wbr w3a vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co
      vy cv clt wbr wa vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt
      wbr wa wb vm cv vk cv cle wbr vk cv cn wcel vk cv cF cfv cX wcel vk cv cG
      cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa vk cv cF cfv cX
      wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wb vm cv cF cfv cX wcel vk
      cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr w3a vk cv
      cn wcel vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cG cfv vx cv cD
      co vy cv clt wbr wa vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv
      clt wbr wa wb vk cv cn wcel vk cv cF cfv cX wcel wa vk cv cG cfv cX wcel
      vk cv cF cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr vk cv cF cfv
      vx cv cD co vy cv clt wbr vk cv cn wcel vk cv cF cfv cX wcel wa vk cv cG
      cfv vk cv cF cfv cX vz va cv vh cF cG vk cv cX cn iscms2lem1.1 lmfexlem2
      eleq1d vk cv cn wcel vk cv cF cfv cX wcel wa vk cv cG cfv vx cv cD co vk
      cv cF cfv vx cv cD co vy cv clt vk cv cn wcel vk cv cF cfv cX wcel wa vk
      cv cG cfv vk cv cF cfv vx cv cD vz va cv vh cF cG vk cv cX cn
      iscms2lem1.1 lmfexlem2 opreq1d breq1d anbi12d ex vm cv cF cfv cX wcel vk
      cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv clt wbr 3simp2
      syl5 imim2d imp adantrd pm5.74d vm cv vk cv cle wbr vn cv vk cv cle wbr
      vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa pm3.42
      syl5bi expimpd adantl vm cv cn wcel vn cv cn wcel wa vk cv cn wcel wa vm
      cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vm cv vk cv cle wbr vn cv
      vk cv cle wbr wa vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt
      wbr wa vm cv cn wcel vn cv cn wcel vk cv cn wcel vm cv vn cv cle wbr vn
      cv vm cv cif vk cv cle wbr vm cv vk cv cle wbr vn cv vk cv cle wbr wa wb
      vm cv cr wcel vn cv cr wcel vk cv cr wcel vm cv vn cv cle wbr vn cv vm cv
      cif vk cv cle wbr vm cv vk cv cle wbr vn cv vk cv cle wbr wa wb vm cv cn
      wcel vn cv cn wcel vk cv cn wcel vm cv vn cv vk cv maxle vm cv nnre vn cv
      nnre vk cv nnre syl3an 3expa imbi1d sylibrd exp3a r19.20dva vn cv vk cv
      cle wbr vk cv cG cfv cX wcel vk cv cG cfv vx cv cD co vy cv clt wbr wa wi
      vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk
      cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn r19.20 syl6 imp vm cv cn
      wcel vn cv cn wcel wa vm cv vn cv cle wbr vn cv vm cv cif vk cv cle wbr
      vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn
      wral vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy
      cv clt wbr wa wi vk cn wral vj cn wrex wi vm cv vk cv cle wbr vm cv cF
      cfv cX wcel vk cv cF cfv cX wcel vm cv cF cfv vk cv cF cfv cD co vy cv
      clt wbr w3a wi vk cn wral vm cv cn wcel vn cv cn wcel wa vm cv vn cv cle
      wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv
      cD co vy cv clt wbr wa wi vk cn wral vj cv vk cv cle wbr vk cv cF cfv cX
      wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn wrex
      vm cv vn cv cle wbr vn cv vm cv cif cn wcel vm cv vn cv cle wbr vn cv vm
      cv cif vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv
      clt wbr wa wi vk cn wral vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv
      cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn wrex vm cv cn
      wcel vn cv cn wcel wa vj cv vk cv cle wbr vk cv cF cfv cX wcel vk cv cF
      cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vm cv vn cv cle wbr vn cv
      vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy
      cv clt wbr wa wi vk cn wral vj vm cv vn cv cle wbr vn cv vm cv cif cn vj
      cv vm cv vn cv cle wbr vn cv vm cv cif wceq vj cv vk cv cle wbr vk cv cF
      cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa wi vm cv vn cv cle
      wbr vn cv vm cv cif vk cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv
      cD co vy cv clt wbr wa wi vk cn vj cv vm cv vn cv cle wbr vn cv vm cv cif
      wceq vj cv vk cv cle wbr vm cv vn cv cle wbr vn cv vm cv cif vk cv cle
      wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa vj cv
      vm cv vn cv cle wbr vn cv vm cv cif vk cv cle breq1 imbi1d ralbidv
      rcla4ev vn cv cn wcel vm cv cn wcel vm cv vn cv cle wbr vn cv vm cv cif
      cn wcel vm cv vn cv cle wbr vn cv vm cv cn ifcl ancoms sylan ex adantr
      syld an1rs r19.23adva r19.23aiva imim3i r19.20sii imp syl6 3impib 3jca cD
      cme wcel cF cD cca cfv wcel cF vx cv cD clm cfv wbr cF cc cX cxp wss vx
      cv cX wcel cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv cF cfv cX wcel vk
      cv cF cfv vx cv cD co vy cv clt wbr wa wi vk cn wral vj cn wrex wi vy cr
      wral w3a wb cG vx cv cD clm cfv wbr cD cme wcel vx cv cvv wcel cF vx cv
      cD clm cfv wbr cF cc cX cxp wss vx cv cX wcel cc0 vy cv clt wbr vj cv vk
      cv cle wbr vk cv cF cfv cX wcel vk cv cF cfv vx cv cD co vy cv clt wbr wa
      wi vk cn wral vj cn wrex wi vy cr wral w3a wb vx visset vy cvv cD vx cv
      vj vk cF c1 cX cn iscms2lem3.2 1z nnuz lmbr2 mpan2 3ad2ant1 mpbird $.
      $( [13-Oct-2007] $) $( [19-Dec-2006] $)

    $( Lemma for ~ iscms2 .  If all Cauchy sequences ` g ` that are functions
       on ` NN ` converge, then any arbitrary Cauchy sequence ` F ` also
       converges. $)
    iscms2lem5 $p |- ( ( ( D e. Met /\ A. g e. ( Cau ` D ) ( g : NN --> X ->
                     E. x e. X g ( ~~>m ` D ) x ) ) /\ F e. ( Cau ` D ) ) ->
                     E. x e. X F ( ~~>m ` D ) x ) $=
      cD cme wcel cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg cD
      cca cfv wral wa cF cD cca cfv wcel wa cX c0 wne cF vx cv cD clm cfv wbr
      vx cX wrex cD cme wcel cF cD cca cfv wcel cX c0 wne cn cX vg cv wf vg cv
      vx cv cD clm cfv wbr vx cX wrex wi vg cD cca cfv wral cD cF cX
      iscms2lem3.2 caun0 adantlr cD cme wcel cn cX vg cv wf vg cv vx cv cD clm
      cfv wbr vx cX wrex wi vg cD cca cfv wral wa cF cD cca cfv wcel wa va cv
      cX wcel va wex cF vx cv cD clm cfv wbr vx cX wrex cX c0 wne cD cme wcel
      cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg cD cca cfv
      wral wa cF cD cca cfv wcel wa va cv cX wcel cF vx cv cD clm cfv wbr vx cX
      wrex va cD cme wcel cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex
      wi vg cD cca cfv wral wa cF cD cca cfv wcel wa va cv cX wcel cF vx cv cD
      clm cfv wbr vx cX wrex cD cme wcel cn cX vg cv wf vg cv vx cv cD clm cfv
      wbr vx cX wrex wi vg cD cca cfv wral wa cF cD cca cfv wcel wa va cv cX
      wcel wa cG vx cv cD clm cfv wbr vx cX wrex cF vx cv cD clm cfv wbr vx cX
      wrex cD cme wcel cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi
      vg cD cca cfv wral wa cF cD cca cfv wcel wa va cv cX wcel wa cG cD cca
      cfv wcel cG vx cv cD clm cfv wbr vx cX wrex cD cme wcel cF cD cca cfv
      wcel va cv cX wcel cG cD cca cfv wcel cn cX vg cv wf vg cv vx cv cD clm
      cfv wbr vx cX wrex wi vg cD cca cfv wral cD cme wcel cF cD cca cfv wcel
      va cv cX wcel cG cD cca cfv wcel vz cD vh cF cG cX va iscms2lem1.1
      iscms2lem3.2 iscms2lem3 3expa adantllr cD cme wcel cn cX vg cv wf vg cv
      vx cv cD clm cfv wbr vx cX wrex wi vg cD cca cfv wral wa va cv cX wcel cG
      cD cca cfv wcel cG vx cv cD clm cfv wbr vx cX wrex wi cF cD cca cfv wcel
      cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg cD cca cfv
      wral va cv cX wcel cG cD cca cfv wcel cG vx cv cD clm cfv wbr vx cX wrex
      wi cD cme wcel cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg
      cD cca cfv wral va cv cX wcel cG cD cca cfv wcel cG vx cv cD clm cfv wbr
      vx cX wrex wi cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg
      cD cca cfv wral cG cD cca cfv wcel va cv cX wcel cG vx cv cD clm cfv wbr
      vx cX wrex cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg cD
      cca cfv wral cG cD cca cfv wcel cn cX cG wf cG vx cv cD clm cfv wbr vx cX
      wrex va cv cX wcel cn cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex
      wi cn cX cG wf cG vx cv cD clm cfv wbr vx cX wrex wi vg cG cD cca cfv vg
      cv cG wceq cn cX vg cv wf cn cX cG wf vg cv vx cv cD clm cfv wbr vx cX
      wrex cG vx cv cD clm cfv wbr vx cX wrex cn cX vg cv cG feq1 vg cv cG wceq
      vg cv vx cv cD clm cfv wbr cG vx cv cD clm cfv wbr vx cX vg cv cG vx cv
      cD clm cfv breq1 rexbidv imbi12d rcla4cv vz va cv vh cF cG cX cn
      iscms2lem1.1 lmfexlem1 syl7 com23 imp adantll adantlr mpd cD cme wcel cn
      cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg cD cca cfv wral
      wa cF cD cca cfv wcel wa cG vx cv cD clm cfv wbr vx cX wrex cF vx cv cD
      clm cfv wbr vx cX wrex wi va cv cX wcel cD cme wcel cF cD cca cfv wcel cG
      vx cv cD clm cfv wbr vx cX wrex cF vx cv cD clm cfv wbr vx cX wrex wi cn
      cX vg cv wf vg cv vx cv cD clm cfv wbr vx cX wrex wi vg cD cca cfv wral
      cD cme wcel cF cD cca cfv wcel wa cG vx cv cD clm cfv wbr cF vx cv cD clm
      cfv wbr vx cX cD cme wcel cF cD cca cfv wcel cG vx cv cD clm cfv wbr cF
      vx cv cD clm cfv wbr vx vz cD vh cF cG cX va iscms2lem1.1 iscms2lem3.2
      iscms2lem4 3expia r19.22sdv adantlr adantr mpd ex 19.23adv va cX n0
      syl5ib mpd $.
      $( [13-Oct-2007] $) $( [19-Dec-2006] $)
  $}

  ${
    $d a f g x D $.  $d a f g m x y X $.
    iscms2.1 $e |- X = dom dom D $.
    $( The property " ` D ` is a complete metric" expressed in terms of
       functions on ` NN ` .  Thus we only have to look at functions on
       ` NN ` , and not all possible Cauchy sequences, to determine
       completeness. $)
    iscms2 $p |- ( D e. CMet <-> ( D e. Met /\
     A. f e. ( Cau ` D ) ( f : NN --> X -> E. x e. X f ( ~~>m ` D ) x ) ) ) $=
      cD cms wcel cD cme wcel cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx cX
      wrex wi vf cD cca cfv wral wa cD cms wcel cD cme wcel vf cv vx cv cD clm
      cfv wbr vx cX wrex vf cD cca cfv wral wa cD cme wcel cn cX vf cv wf vf cv
      vx cv cD clm cfv wbr vx cX wrex wi vf cD cca cfv wral wa vx cD vf cX
      iscms2.1 iscms vf cv vx cv cD clm cfv wbr vx cX wrex vf cD cca cfv wral
      cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx cX wrex wi vf cD cca cfv
      wral cD cme wcel vf cv vx cv cD clm cfv wbr vx cX wrex cn cX vf cv wf vf
      cv vx cv cD clm cfv wbr vx cX wrex wi vf cD cca cfv vf cv vx cv cD clm
      cfv wbr vx cX wrex cn cX vf cv wf ax-1 r19.20si anim2i sylbi cD cme wcel
      cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx cX wrex wi vf cD cca cfv
      wral wa cD cme wcel vg cv vx cv cD clm cfv wbr vx cX wrex vg cD cca cfv
      wral wa cD cms wcel cD cme wcel cn cX vf cv wf vf cv vx cv cD clm cfv wbr
      vx cX wrex wi vf cD cca cfv wral vg cv vx cv cD clm cfv wbr vx cX wrex vg
      cD cca cfv wral cD cme wcel cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx
      cX wrex wi vf cD cca cfv wral vg cv vx cv cD clm cfv wbr vx cX wrex vg cD
      cca cfv wral cD cme wcel cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx cX
      wrex wi vf cD cca cfv wral wa vg cv vx cv cD clm cfv wbr vx cX wrex vg cD
      cca cfv vx vy cD vf vm vg cv vm cv cn wcel vy cv vm cv vg cv cfv cX wcel
      vm cv vg cv cfv va cv cif wceq wa vm vy copab cX va vm cv cn wcel vy cv
      vm cv vg cv cfv cX wcel vm cv vg cv cfv va cv cif wceq wa vm vy copab
      eqid iscms2.1 iscms2lem5 r19.21aiva ex imdistani vx cD vg cX iscms2.1
      iscms sylibr impbii $.
      $( [13-Oct-2007] $) $( [18-Dec-2006] $)
  $}

  ${
    $d f x D $.  $d f x X $.
    iscms2i.1 $e |- X = dom dom D $.
    iscms2i.2 $e |- D e. Met $.
    iscms2i.3 $e |- ( ( f e. ( Cau ` D ) /\ f : NN --> X ) ->
                    E. x e. X f ( ~~>m ` D ) x ) $.
    $( Properties that determine a complete metric space. $)
    iscms2i $p |- D e. CMet $=
      cD cms wcel cD cme wcel cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx cX
      wrex wi vf cD cca cfv wral vx cD vf cX iscms2i.1 iscms2 iscms2i.2 cn cX
      vf cv wf vf cv vx cv cD clm cfv wbr vx cX wrex wi vf cD cca cfv vf cv cD
      cca cfv wcel cn cX vf cv wf vf cv vx cv cD clm cfv wbr vx cX wrex
      iscms2i.3 ex rgen mpbir2an $.
      $( [14-Oct-2007] $) $( [15-Apr-2007] $)
  $}

  ${
    $d j k m n q x D $.  $d j k m n q x F $.  $d j k m n q x P $.
    lmcau.1 $e |- P e. _V $.
    $( Every convergent sequence in a metric space is a Cauchy sequence.
       Theorem 1.4-5 of [Kreyszig] p. 28.  _Warning:  The HTML proof page is
       0.5MB in size_. $)
    lmcau $p |- ( ( D e. Met /\ F ( ~~>m ` D ) P ) -> F e. ( Cau ` D ) ) $=
      cD cme wcel cF cP cD clm cfv wbr cF cD cca cfv wcel cD cme wcel cF cc cD
      cdm cdm cxp wss cP cD cdm cdm wcel cc0 vq cv clt wbr vj cv vn cv cle wbr
      vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vq cv clt wbr wa wi vn
      cz wral vj cz wrex wi vq cr wral w3a cF cc cD cdm cdm cxp wss cc0 vx cv
      clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm
      cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx
      cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa cF cP
      cD clm cfv wbr cF cD cca cfv wcel cD cme wcel cF cc cD cdm cdm cxp wss cP
      cD cdm cdm wcel cc0 vq cv clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vq cv clt wbr wa wi vn cz wral vj cz wrex
      wi vq cr wral cF cc cD cdm cdm cxp wss cc0 vx cv clt wbr vj cv vk cv cle
      wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD
      cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz
      wral vk cz wral vj cz wrex wi vx cr wral wa cD cme wcel cF cc cD cdm cdm
      cxp wss cP cD cdm cdm wcel cc0 vq cv clt wbr vj cv vn cv cle wbr vn cv cF
      cfv cD cdm cdm wcel vn cv cF cfv cP cD co vq cv clt wbr wa wi vn cz wral
      vj cz wrex wi vq cr wral cF cc cD cdm cdm cxp wss cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm cdm wcel vm cv
      cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a
      wi vm cz wral vk cz wral vj cz wrex wi vx cr wral wa cD cme wcel cP cD
      cdm cdm wcel cc0 vq cv clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vq cv clt wbr wa wi vn cz wral vj cz wrex
      wi vq cr wral wa cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle
      wbr wa vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF
      cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz
      wrex wi vx cr wral cF cc cD cdm cdm cxp wss cD cme wcel cP cD cdm cdm
      wcel cc0 vx cv c2 cdiv co clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn cz wral
      vj cz wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm
      cv cle wbr wa vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel
      vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz
      wral vj cz wrex wi vx cr wral cc0 vq cv clt wbr vj cv vn cv cle wbr vn cv
      cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vq cv clt wbr wa wi vn cz
      wral vj cz wrex wi vq cr wral cD cme wcel cP cD cdm cdm wcel cc0 vx cv c2
      cdiv co clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF
      cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn cz wral vj cz wrex wi vx
      cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk
      cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv
      cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cz wrex wi vx
      cr wral cD cme wcel cP cD cdm cdm wcel wa cc0 vx cv c2 cdiv co clt wbr vj
      cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv
      c2 cdiv co clt wbr wa wi vn cz wral vj cz wrex wi cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm cdm wcel vm cv
      cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a
      wi vm cz wral vk cz wral vj cz wrex wi vx cr cD cme wcel cP cD cdm cdm
      wcel wa vx cv cr wcel wa cc0 vx cv clt wbr cc0 vx cv c2 cdiv co clt wbr
      vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx
      cv c2 cdiv co clt wbr wa wi vn cz wral vj cz wrex vj cv vk cv cle wbr vj
      cv vm cv cle wbr wa vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm
      wcel vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk
      cz wral vj cz wrex vx cv cr wcel cc0 vx cv clt wbr cc0 vx cv c2 cdiv co
      clt wbr wi cD cme wcel cP cD cdm cdm wcel wa vx cv cr wcel cc0 vx cv clt
      wbr cc0 vx cv c2 cdiv co clt wbr vx cv halfpos2 biimpd adantl cD cme wcel
      cP cD cdm cdm wcel wa vx cv cr wcel wa vj cv vn cv cle wbr vn cv cF cfv
      cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn
      cz wral vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm
      cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx
      cv clt wbr w3a wi vm cz wral vk cz wral vj cz cD cme wcel cP cD cdm cdm
      wcel wa vx cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel
      vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vj cv vm cv cle wbr
      vm cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt
      wbr wa wi wa vm cz wral vk cz wral vj cv vk cv cle wbr vj cv vm cv cle
      wbr wa vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF
      cfv vm cv cF cfv cD co vx cv clt wbr w3a wi vm cz wral vk cz wral vj cv
      vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2
      cdiv co clt wbr wa wi vn cz wral cD cme wcel cP cD cdm cdm wcel wa vx cv
      cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv
      cP cD co vx cv c2 cdiv co clt wbr wa wi vj cv vm cv cle wbr vm cv cF cfv
      cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi wa
      vm cz wral vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm
      cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx
      cv clt wbr w3a wi vm cz wral vk cz cD cme wcel cP cD cdm cdm wcel wa vx
      cv cr wcel wa vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF
      cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vj cv vm cv cle wbr vm cv cF
      cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi
      wa vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm cdm
      wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx cv
      clt wbr w3a wi vm cz vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk
      cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vj cv vm cv cle wbr vm
      cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr
      wa wi wa vj cv vk cv cle wbr vj cv vm cv cle wbr wa vk cv cF cfv cD cdm
      cdm wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vm cv cF cfv
      cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wa cD
      cme wcel cP cD cdm cdm wcel wa vx cv cr wcel wa vk cv cF cfv cD cdm cdm
      wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF cfv cD co vx cv
      clt wbr w3a vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv
      cP cD co vx cv c2 cdiv co clt wbr wa vj cv vm cv cle wbr vm cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa prth cD
      cme wcel cP cD cdm cdm wcel wa vx cv cr wcel wa vk cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vm cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wa vk cv
      cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel vk cv cF cfv vm cv cF
      cfv cD co vx cv clt wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cP cD
      co vx cv c2 cdiv co clt wbr wa vm cv cF cfv cD cdm cdm wcel vm cv cF cfv
      cP cD co vx cv c2 cdiv co clt wbr wa wa vk cv cF cfv cD cdm cdm wcel wi
      cD cme wcel cP cD cdm cdm wcel wa vx cv cr wcel wa vk cv cF cfv cD cdm
      cdm wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr vm cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa simpll a1i
      vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt
      wbr wa vm cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv
      co clt wbr wa wa vm cv cF cfv cD cdm cdm wcel wi cD cme wcel cP cD cdm
      cdm wcel wa vx cv cr wcel wa vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cP
      cD co vx cv c2 cdiv co clt wbr wa vm cv cF cfv cD cdm cdm wcel vm cv cF
      cfv cP cD co vx cv c2 cdiv co clt wbr simprl a1i vk cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vm cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wa cD cme
      wcel cP cD cdm cdm wcel wa vx cv cr wcel wa vk cv cF cfv vm cv cF cfv cD
      co vx cv clt wbr vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr vm cv cF cfv cP cD co
      vx cv c2 cdiv co clt wbr cD cme wcel cP cD cdm cdm wcel wa vx cv cr wcel
      wa vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr wi vk cv cF cfv cD cdm
      cdm wcel vm cv cF cfv cD cdm cdm wcel wa vk cv cF cfv cP cD co vx cv c2
      cdiv co clt wbr vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa cD cme
      wcel cP cD cdm cdm wcel wa vx cv cr wcel wa vk cv cF cfv vm cv cF cfv cD
      co vx cv clt wbr wi vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm
      wcel wa cD cme wcel cP cD cdm cdm wcel wa vx cv cr wcel wa vk cv cF cfv
      cP cD co vx cv c2 cdiv co clt wbr vm cv cF cfv cP cD co vx cv c2 cdiv co
      clt wbr wa vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr vk cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cD cme wcel cP cD cdm cdm
      wcel vx cv cr wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr vm cv
      cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv vm cv cF cfv cD
      co vx cv clt wbr wi cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv
      cD cdm cdm wcel wa cP cD cdm cdm wcel vx cv cr wcel vk cv cF cfv cP cD co
      vx cv c2 cdiv co clt wbr vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr
      wa vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr wi wi wi cD cme wcel vk
      cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm
      wcel vx cv cr wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr vm cv
      cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv vm cv cF cfv cD
      co vx cv clt wbr wi cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv
      cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv cr wcel wa wa vk cv cF cfv
      cP cD co vx cv c2 cdiv co clt wbr vm cv cF cfv cP cD co vx cv c2 cdiv co
      clt wbr wa vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc co vx cv c2
      cdiv co vx cv c2 cdiv co caddc co clt wbr vk cv cF cfv vm cv cF cfv cD co
      vx cv clt wbr vk cv cF cfv cP cD co cr wcel vm cv cF cfv cP cD co cr wcel
      wa vx cv c2 cdiv co cr wcel vx cv c2 cdiv co cr wcel wa vk cv cF cfv cP
      cD co vx cv c2 cdiv co clt wbr vm cv cF cfv cP cD co vx cv c2 cdiv co clt
      wbr wa vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc co vx cv c2 cdiv
      co vx cv c2 cdiv co caddc co clt wbr wi cD cme wcel vk cv cF cfv cD cdm
      cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv cr
      wcel wa wa vk cv cF cfv cP cD co vm cv cF cfv cP cD co vx cv c2 cdiv co
      vx cv c2 cdiv co lt2add cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF
      cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vk cv cF cfv cP cD co cr
      wcel vm cv cF cfv cP cD co cr wcel wa vx cv cr wcel cD cme wcel vk cv cF
      cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa
      wa vk cv cF cfv cP cD co cr wcel vm cv cF cfv cP cD co cr wcel cD cme
      wcel vk cv cF cfv cD cdm cdm wcel cP cD cdm cdm wcel vk cv cF cfv cP cD
      co cr wcel vm cv cF cfv cD cdm cdm wcel cD cme wcel vk cv cF cfv cD cdm
      cdm wcel cP cD cdm cdm wcel vk cv cF cfv cP cD co cr wcel vk cv cF cfv cP
      cD cD cdm cdm cD cdm cdm eqid metcl 3expb adantrlr cD cme wcel vm cv cF
      cfv cD cdm cdm wcel cP cD cdm cdm wcel vm cv cF cfv cP cD co cr wcel vk
      cv cF cfv cD cdm cdm wcel cD cme wcel vm cv cF cfv cD cdm cdm wcel cP cD
      cdm cdm wcel vm cv cF cfv cP cD co cr wcel vm cv cF cfv cP cD cD cdm cdm
      cD cdm cdm eqid metcl 3expb adantrll jca adantrr vx cv cr wcel vx cv c2
      cdiv co cr wcel vx cv c2 cdiv co cr wcel wa cD cme wcel vk cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv
      cr wcel vx cv c2 cdiv co cr wcel vx cv c2 cdiv co cr wcel vx cv rehalfcl
      vx cv rehalfcl jca ad2antll sylanc cD cme wcel vk cv cF cfv cD cdm cdm
      wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv cr wcel
      wa wa vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc co vx cv c2 cdiv
      co vx cv c2 cdiv co caddc co clt wbr vk cv cF cfv cP cD co vm cv cF cfv
      cP cD co caddc co vx cv clt wbr vk cv cF cfv vm cv cF cfv cD co vx cv clt
      wbr vx cv cr wcel vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc co vx
      cv c2 cdiv co vx cv c2 cdiv co caddc co clt wbr vk cv cF cfv cP cD co vm
      cv cF cfv cP cD co caddc co vx cv clt wbr wb cD cme wcel vk cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv
      cr wcel vx cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv vk cv cF cfv cP
      cD co vm cv cF cfv cP cD co caddc co clt vx cv cr wcel vx cv cc wcel vx
      cv c2 cdiv co vx cv c2 cdiv co caddc co vx cv wceq vx cv recn vx cv
      2halves syl breq2d ad2antll cD cme wcel vk cv cF cfv cD cdm cdm wcel vm
      cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv cr wcel wa wa vk
      cv cF cfv vm cv cF cfv cD co vk cv cF cfv cP cD co vm cv cF cfv cP cD co
      caddc co cle wbr vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc co vx
      cv clt wbr vk cv cF cfv vm cv cF cfv cD co vx cv clt wbr cD cme wcel vk
      cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm cdm
      wcel wa vk cv cF cfv vm cv cF cfv cD co vk cv cF cfv cP cD co vm cv cF
      cfv cP cD co caddc co cle wbr vx cv cr wcel cD cme wcel vk cv cF cfv cD
      cdm cdm wcel vm cv cF cfv cD cdm cdm wcel cP cD cdm cdm wcel w3a vk cv cF
      cfv vm cv cF cfv cD co vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc
      co cle wbr vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa
      cP cD cdm cdm wcel wa vk cv cF cfv vm cv cF cfv cP cD cD cdm cdm cD cdm
      cdm eqid mettri3 vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm
      wcel cP cD cdm cdm wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm
      cdm wcel cP cD cdm cdm wcel w3a vk cv cF cfv cD cdm cdm wcel vm cv cF cfv
      cD cdm cdm wcel cP cD cdm cdm wcel w3a id 3expa sylan2 adantrr vk cv cF
      cfv vm cv cF cfv cD co cr wcel vk cv cF cfv cP cD co vm cv cF cfv cP cD
      co caddc co cr wcel vx cv cr wcel vk cv cF cfv vm cv cF cfv cD co vk cv
      cF cfv cP cD co vm cv cF cfv cP cD co caddc co cle wbr vk cv cF cfv cP cD
      co vm cv cF cfv cP cD co caddc co vx cv clt wbr wa vk cv cF cfv vm cv cF
      cfv cD co vx cv clt wbr wi cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv
      cF cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vx cv cr wcel wa wa vk cv
      cF cfv vm cv cF cfv cD co vk cv cF cfv cP cD co vm cv cF cfv cP cD co
      caddc co vx cv lelttr cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF
      cfv cD cdm cdm wcel wa cP cD cdm cdm wcel wa vk cv cF cfv vm cv cF cfv cD
      co cr wcel vx cv cr wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv
      cF cfv cD cdm cdm wcel wa vk cv cF cfv vm cv cF cfv cD co cr wcel cP cD
      cdm cdm wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm
      cdm wcel vk cv cF cfv vm cv cF cfv cD co cr wcel vk cv cF cfv vm cv cF
      cfv cD cD cdm cdm cD cdm cdm eqid metcl 3expb adantrr adantrr cD cme wcel
      vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel wa cP cD cdm
      cdm wcel wa vk cv cF cfv cP cD co vm cv cF cfv cP cD co caddc co cr wcel
      vx cv cr wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD
      cdm cdm wcel wa cP cD cdm cdm wcel wa wa vk cv cF cfv cP cD co cr wcel vm
      cv cF cfv cP cD co cr wcel wa vk cv cF cfv cP cD co vm cv cF cfv cP cD co
      caddc co cr wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD
      cdm cdm wcel wa cP cD cdm cdm wcel wa wa vk cv cF cfv cP cD co cr wcel vm
      cv cF cfv cP cD co cr wcel cD cme wcel vk cv cF cfv cD cdm cdm wcel cP cD
      cdm cdm wcel vk cv cF cfv cP cD co cr wcel vm cv cF cfv cD cdm cdm wcel
      cD cme wcel vk cv cF cfv cD cdm cdm wcel cP cD cdm cdm wcel vk cv cF cfv
      cP cD co cr wcel vk cv cF cfv cP cD cD cdm cdm cD cdm cdm eqid metcl
      3expb adantrlr cD cme wcel vm cv cF cfv cD cdm cdm wcel cP cD cdm cdm
      wcel vm cv cF cfv cP cD co cr wcel vk cv cF cfv cD cdm cdm wcel cD cme
      wcel vm cv cF cfv cD cdm cdm wcel cP cD cdm cdm wcel vm cv cF cfv cP cD
      co cr wcel vm cv cF cfv cP cD cD cdm cdm cD cdm cdm eqid metcl 3expb
      adantrll jca vk cv cF cfv cP cD co vm cv cF cfv cP cD co readdcl syl
      adantrr cD cme wcel vk cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm
      wcel wa cP cD cdm cdm wcel wa vx cv cr wcel simprr syl3anc mpand sylbid
      syld exp44 com12 imp4c com23 imp an4s com12 3jcad syl9r r19.20sdv
      r19.20sdv vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv
      cP cD co vx cv c2 cdiv co clt wbr wa wi vj cv vm cv cle wbr vm cv cF cfv
      cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi wa
      vm cz wral vk cz wral vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk
      cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vk cz wral vj cv vm cv
      cle wbr vm cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv
      co clt wbr wa wi vm cz wral vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm
      wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn cz wral vj
      cv vk cv cle wbr vk cv cF cfv cD cdm cdm wcel vk cv cF cfv cP cD co vx cv
      c2 cdiv co clt wbr wa wi vj cv vm cv cle wbr vm cv cF cfv cD cdm cdm wcel
      vm cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vk vm cz raaanv vj
      cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv
      c2 cdiv co clt wbr wa wi vn cz wral vj cv vk cv cle wbr vk cv cF cfv cD
      cdm cdm wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vk cz
      vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx
      cv c2 cdiv co clt wbr wa wi vj cv vk cv cle wbr vk cv cF cfv cD cdm cdm
      wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn vk cv cz vn
      cv vk cv wceq vj cv vn cv cle wbr vj cv vk cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vk cv cF cfv
      cD cdm cdm wcel vk cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa vn cv
      vk cv vj cv cle breq2 vn cv vk cv wceq vn cv cF cfv cD cdm cdm wcel vk cv
      cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr vk
      cv cF cfv cP cD co vx cv c2 cdiv co clt wbr vn cv vk cv wceq vn cv cF cfv
      vk cv cF cfv cD cdm cdm vn cv vk cv cF fveq2 eleq1d vn cv vk cv wceq vn
      cv cF cfv cP cD co vk cv cF cfv cP cD co vx cv c2 cdiv co clt vn cv vk cv
      wceq vn cv cF cfv vk cv cF cfv cP cD vn cv vk cv cF fveq2 opreq1d breq1d
      anbi12d imbi12d rcla4cv r19.21aiv vj cv vn cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn cz wral
      vj cv vm cv cle wbr vm cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx
      cv c2 cdiv co clt wbr wa wi vm cz vj cv vn cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vj cv vm cv
      cle wbr vm cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx cv c2 cdiv
      co clt wbr wa wi vn vm cv cz vn cv vm cv wceq vj cv vn cv cle wbr vj cv
      vm cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2
      cdiv co clt wbr wa vm cv cF cfv cD cdm cdm wcel vm cv cF cfv cP cD co vx
      cv c2 cdiv co clt wbr wa vn cv vm cv vj cv cle breq2 vn cv vm cv wceq vn
      cv cF cfv cD cdm cdm wcel vm cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD
      co vx cv c2 cdiv co clt wbr vm cv cF cfv cP cD co vx cv c2 cdiv co clt
      wbr vn cv vm cv wceq vn cv cF cfv vm cv cF cfv cD cdm cdm vn cv vm cv cF
      fveq2 eleq1d vn cv vm cv wceq vn cv cF cfv cP cD co vm cv cF cfv cP cD co
      vx cv c2 cdiv co clt vn cv vm cv wceq vn cv cF cfv vm cv cF cfv cP cD vn
      cv vm cv cF fveq2 opreq1d breq1d anbi12d imbi12d rcla4cv r19.21aiv
      sylanbrc syl5 r19.22sdv imim12d r19.20dva expimpd cc0 vq cv clt wbr vj cv
      vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vq cv
      clt wbr wa wi vn cz wral vj cz wrex wi vq cr wral cc0 vx cv c2 cdiv co
      clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP
      cD co vx cv c2 cdiv co clt wbr wa wi vn cz wral vj cz wrex wi vx cr cc0
      vq cv clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF
      cfv cP cD co vq cv clt wbr wa wi vn cz wral vj cz wrex wi vq cr wral vx
      cv c2 cdiv co cr wcel cc0 vx cv c2 cdiv co clt wbr vj cv vn cv cle wbr vn
      cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr
      wa wi vn cz wral vj cz wrex wi vx cv cr wcel cc0 vq cv clt wbr vj cv vn
      cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vq cv clt
      wbr wa wi vn cz wral vj cz wrex wi cc0 vx cv c2 cdiv co clt wbr vj cv vn
      cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2
      cdiv co clt wbr wa wi vn cz wral vj cz wrex wi vq vx cv c2 cdiv co cr vq
      cv vx cv c2 cdiv co wceq cc0 vq cv clt wbr cc0 vx cv c2 cdiv co clt wbr
      vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co vq
      cv clt wbr wa wi vn cz wral vj cz wrex vj cv vn cv cle wbr vn cv cF cfv
      cD cdm cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vn
      cz wral vj cz wrex vq cv vx cv c2 cdiv co cc0 clt breq2 vq cv vx cv c2
      cdiv co wceq vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF
      cfv cP cD co vq cv clt wbr wa wi vj cv vn cv cle wbr vn cv cF cfv cD cdm
      cdm wcel vn cv cF cfv cP cD co vx cv c2 cdiv co clt wbr wa wi vj vn cz cz
      vq cv vx cv c2 cdiv co wceq vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP
      cD co vq cv clt wbr wa vn cv cF cfv cD cdm cdm wcel vn cv cF cfv cP cD co
      vx cv c2 cdiv co clt wbr wa vj cv vn cv cle wbr vq cv vx cv c2 cdiv co
      wceq vn cv cF cfv cP cD co vq cv clt wbr vn cv cF cfv cP cD co vx cv c2
      cdiv co clt wbr vn cv cF cfv cD cdm cdm wcel vq cv vx cv c2 cdiv co vn cv
      cF cfv cP cD co clt breq2 anbi2d imbi2d rexralbidv imbi12d rcla4cv vx cv
      rehalfcl syl5 r19.21aiv sylan2i anim2d exp4d 3impd cD cme wcel cP cvv
      wcel cF cP cD clm cfv wbr cF cc cD cdm cdm cxp wss cP cD cdm cdm wcel cc0
      vq cv clt wbr vj cv vn cv cle wbr vn cv cF cfv cD cdm cdm wcel vn cv cF
      cfv cP cD co vq cv clt wbr wa wi vn cz wral vj cz wrex wi vq cr wral w3a
      wb lmcau.1 vq cvv cD cP vj vn cF cD cdm cdm cD cdm cdm eqid lmbr mpan2 vx
      cD vj vk vm cF cD cdm cdm cD cdm cdm eqid iscau 3imtr4d imp $.
      $( [29-Jan-2008] $) $( [29-Jan-2008] $)
  $}

  ${
    $d f x y D $.  $d f x J $.  $d f x y X $.  $d f x y Y $.
    cmsss.1 $e |- X = dom dom D $.
    cmsss.2 $e |- J = ( Open ` D ) $.
    $( A subspace of a complete metric space is complete iff it is closed in
       the parent space.  Theorem 1.4-7 of [Kreyszig] p. 30. $)
    cmsss $p |- ( ( D e. CMet /\ Y C_ X ) -> ( ( D |` ( Y X. Y ) ) e. CMet <->
                Y e. ( Clsd ` J ) ) ) $=
      cD cms wcel cY cX wss wa cD cY cY cxp cres cms wcel cY cJ ccld cfv wcel
      cD cme wcel cY cX wss cD cY cY cxp cres cms wcel cY cJ ccld cfv wcel cD
      cms wcel cD cme wcel cY cX wss wa cD cY cY cxp cres cms wcel wa cY cJ
      ccld cfv wcel cY cJ ccl cfv cfv cY wss cD cme wcel cY cX wss wa cD cY cY
      cxp cres cms wcel wa vx cY cJ ccl cfv cfv cY cD cme wcel cY cX wss wa cD
      cY cY cxp cres cms wcel vx cv cY cJ ccl cfv cfv wcel vx cv cY wcel wi cD
      cme wcel cY cX wss wa vx cv cY cJ ccl cfv cfv wcel cD cY cY cxp cres cms
      wcel vx cv cY wcel cD cme wcel cY cX wss wa vx cv cY cJ ccl cfv cfv wcel
      cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vf wex cD cY cY cxp cres cms
      wcel vx cv cY wcel wi cD vx cv vf cJ cY cX cmsss.1 cmsss.2 vx visset
      metelcls cD cme wcel cY cX wss wa cn cY vf cv wf vf cv vx cv cD clm cfv
      wbr wa cD cY cY cxp cres cms wcel vx cv cY wcel wi vf cD cme wcel cY cX
      wss wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa cD cY cY cxp cres cms
      wcel vx cv cY wcel wi cD cme wcel cY cX wss wa cn cY vf cv wf vf cv vx cv
      cD clm cfv wbr wa wa cD cY cY cxp cres cms wcel vf cv vy cv cD cY cY cxp
      cres clm cfv wbr vy cD cY cY cxp cres cdm cdm wrex vx cv cY wcel cD cme
      wcel cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa cD cY cY cxp cres cms
      wcel vf cv vy cv cD cY cY cxp cres clm cfv wbr vy cD cY cY cxp cres cdm
      cdm wrex wi cY cX wss cD cme wcel cn cY vf cv wf vf cv vx cv cD clm cfv
      wbr wa wa vf cv cD cY cY cxp cres cca cfv wcel cD cY cY cxp cres cms wcel
      vf cv vy cv cD cY cY cxp cres clm cfv wbr vy cD cY cY cxp cres cdm cdm
      wrex wi cD cme wcel cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa wa vf cv
      cD cca cfv wcel vf cv cD cY cY cxp cres cca cfv wcel cD cme wcel vf cv vx
      cv cD clm cfv wbr vf cv cD cca cfv wcel cn cY vf cv wf cD vx cv vf cv vx
      visset lmcau adantrl cD cme wcel cn cY vf cv wf vf cv cD cca cfv wcel vf
      cv cD cY cY cxp cres cca cfv wcel wb vf cv vx cv cD clm cfv wbr cD vf cv
      cY causs adantrr mpbid cD cY cY cxp cres cms wcel vf cv cD cY cY cxp cres
      cca cfv wcel vf cv vy cv cD cY cY cxp cres clm cfv wbr vy cD cY cY cxp
      cres cdm cdm wrex vy cD cY cY cxp cres vf cv cD cY cY cxp cres cdm cdm cD
      cY cY cxp cres cdm cdm eqid cmscvg expcom syl adantlr cD cme wcel cY cX
      wss wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa wa vf cv vy cv cD cY
      cY cxp cres clm cfv wbr vx cv cY wcel vy cD cY cY cxp cres cdm cdm cD cme
      wcel cY cX wss wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa wa vy cv
      cD cY cY cxp cres cdm cdm wcel vy cv cY wcel vf cv vy cv cD cY cY cxp
      cres clm cfv wbr vx cv cY wcel wi cD cme wcel cY cX wss wa vy cv cY wcel
      vy cv cD cY cY cxp cres cdm cdm wcel wb cn cY vf cv wf vf cv vx cv cD clm
      cfv wbr wa cD cme wcel cY cX wss wa cY cD cY cY cxp cres cdm cdm vy cv cD
      cX cY cmsss.1 metssba2 eleq2d adantr cD cme wcel cn cY vf cv wf vf cv vx
      cv cD clm cfv wbr wa vy cv cY wcel vf cv vy cv cD cY cY cxp cres clm cfv
      wbr vx cv cY wcel wi wi cY cX wss cD cme wcel cn cY vf cv wf vf cv vx cv
      cD clm cfv wbr wa wa vy cv cY wcel vf cv vy cv cD cY cY cxp cres clm cfv
      wbr vx cv cY wcel cD cme wcel cn cY vf cv wf vf cv vx cv cD clm cfv wbr
      wa wa vy cv cY wcel vf cv vy cv cD cY cY cxp cres clm cfv wbr wa wa vx cv
      vy cv wceq vx cv cY wcel cD cme wcel vf cv vx cv cD clm cfv wbr vf cv vy
      cv cD clm cfv wbr vx cv vy cv wceq cD cme wcel cn cY vf cv wf vf cv vx cv
      cD clm cfv wbr wa wa vy cv cY wcel vf cv vy cv cD cY cY cxp cres clm cfv
      wbr wa wa vx cv vy cv cD vf cv vx visset vy visset lmuni cD cme wcel cn
      cY vf cv wf vf cv vx cv cD clm cfv wbr wa vy cv cY wcel vf cv vy cv cD cY
      cY cxp cres clm cfv wbr wa simpll cD cme wcel cn cY vf cv wf vf cv vx cv
      cD clm cfv wbr vy cv cY wcel vf cv vy cv cD cY cY cxp cres clm cfv wbr wa
      simplrr cD cme wcel cn cY vf cv wf vy cv cY wcel vf cv vy cv cD cY cY cxp
      cres clm cfv wbr wa vf cv vy cv cD clm cfv wbr vf cv vx cv cD clm cfv wbr
      cD cme wcel cn cY vf cv wf vy cv cY wcel vf cv vy cv cD cY cY cxp cres
      clm cfv wbr vf cv vy cv cD clm cfv wbr cD cme wcel vy cv cY wcel cn cY vf
      cv wf vf cv vy cv cD cY cY cxp cres clm cfv wbr vf cv vy cv cD clm cfv
      wbr wi cD cme wcel vy cv cY wcel cn cY vf cv wf vf cv vy cv cD cY cY cxp
      cres clm cfv wbr vf cv vy cv cD clm cfv wbr wi cD cme wcel vy cv cY wcel
      cn cY vf cv wf w3a vf cv vy cv cD clm cfv wbr vf cv vy cv cD cY cY cxp
      cres clm cfv wbr cD vy cv vf cv cY lmss biimprd 3exp com23 imp43 adantlrr
      syl3anc vy cv cY wcel vx cv vy cv wceq vx cv cY wcel wi cD cme wcel cn cY
      vf cv wf vf cv vx cv cD clm cfv wbr wa wa vf cv vy cv cD cY cY cxp cres
      clm cfv wbr vy cv cY vx cv eleq1a ad2antrl mpd exp32 adantlr sylbird
      r19.23adv syld ex 19.23adv sylbid com23 imp ssrdv cD cme wcel cY cX wss
      wa cY cJ ccld cfv wcel cY cJ ccl cfv cfv cY wss wb cD cY cY cxp cres cms
      wcel cJ ctop wcel cY cJ cuni wss cY cJ ccld cfv wcel cY cJ ccl cfv cfv cY
      wss wb cD cme wcel cY cX wss wa cY cJ cJ cuni cJ cuni eqid iscld4 cD cme
      wcel cJ ctop wcel cY cX wss cD cJ cmsss.2 opntop adantr cD cme wcel cY cJ
      cuni wss cY cX wss cD cme wcel cJ cuni cX cY cD cJ cX cmsss.1 cmsss.2
      uniopn2 sseq2d biimpar sylanc adantr mpbird cD cmsmet sylanl1 cD cY cY
      cxp cres cms wcel cD cY cY cxp cres cme wcel cn cD cY cY cxp cres cdm cdm
      vf cv wf vf cv vx cv cD cY cY cxp cres clm cfv wbr vx cD cY cY cxp cres
      cdm cdm wrex wi vf cD cY cY cxp cres cca cfv wral cD cms wcel cY cX wss
      wa cY cJ ccld cfv wcel wa vx cD cY cY cxp cres vf cD cY cY cxp cres cdm
      cdm cD cY cY cxp cres cdm cdm eqid iscms2 cD cms wcel cD cY cY cxp cres
      cme wcel cY cX wss cY cJ ccld cfv wcel cD cms wcel cD cme wcel cD cY cY
      cxp cres cme wcel cD cmsmet cD cY metres syl ad2antrr cD cms wcel cY cX
      wss wa cY cJ ccld cfv wcel wa cn cD cY cY cxp cres cdm cdm vf cv wf vf cv
      vx cv cD cY cY cxp cres clm cfv wbr vx cD cY cY cxp cres cdm cdm wrex wi
      vf cD cY cY cxp cres cca cfv cD cms wcel cY cX wss wa cY cJ ccld cfv wcel
      wa vf cv cD cY cY cxp cres cca cfv wcel wa cn cY vf cv wf vf cv vx cv cD
      cY cY cxp cres clm cfv wbr vx cY wrex cn cD cY cY cxp cres cdm cdm vf cv
      wf vf cv vx cv cD cY cY cxp cres clm cfv wbr vx cD cY cY cxp cres cdm cdm
      wrex cD cms wcel cY cX wss cY cJ ccld cfv wcel vf cv cD cY cY cxp cres
      cca cfv wcel cn cY vf cv wf vf cv vx cv cD cY cY cxp cres clm cfv wbr vx
      cY wrex wi cD cms wcel vf cv cD cY cY cxp cres cca cfv wcel cY cJ ccld
      cfv wcel cY cX wss cn cY vf cv wf vf cv vx cv cD cY cY cxp cres clm cfv
      wbr vx cY wrex wi cD cms wcel vf cv cD cY cY cxp cres cca cfv wcel vf cv
      vx cv cD clm cfv wbr vx cX wrex cY cJ ccld cfv wcel cY cX wss cn cY vf cv
      wf vf cv vx cv cD cY cY cxp cres clm cfv wbr vx cY wrex wi wi wi cD cms
      wcel vf cv cD cY cY cxp cres cca cfv wcel vf cv vx cv cD clm cfv wbr vx
      cX wrex cD cms wcel vf cv cD cY cY cxp cres cca cfv wcel vf cv cD cca cfv
      wcel vf cv vx cv cD clm cfv wbr vx cX wrex cD cme wcel vf cv cD cY cY cxp
      cres cca cfv wcel vf cv cD cca cfv wcel cD cms wcel cD vf cv cY caussi cD
      cmsmet sylan vx cD vf cv cX cmsss.1 cmscvg syldan ex cD cms wcel cD cme
      wcel vf cv vx cv cD clm cfv wbr vx cX wrex cY cJ ccld cfv wcel cY cX wss
      cn cY vf cv wf vf cv vx cv cD cY cY cxp cres clm cfv wbr vx cY wrex wi wi
      wi wi cD cmsmet cD cme wcel cY cX wss cY cJ ccld cfv wcel vf cv vx cv cD
      clm cfv wbr vx cX wrex cn cY vf cv wf vf cv vx cv cD cY cY cxp cres clm
      cfv wbr vx cY wrex wi cD cme wcel cY cX wss cY cJ ccld cfv wcel vf cv vx
      cv cD clm cfv wbr vx cX wrex cn cY vf cv wf vf cv vx cv cD cY cY cxp cres
      clm cfv wbr vx cY wrex wi wi cD cme wcel cY cX wss wa cY cJ ccld cfv wcel
      wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr vx cX wrex vf cv vx cv cD cY
      cY cxp cres clm cfv wbr vx cY wrex cD cme wcel cY cX wss wa cY cJ ccld
      cfv wcel wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr vx cX wrex vf cv vx
      cv cD cY cY cxp cres clm cfv wbr vx cY wrex wi cD cme wcel cY cX wss wa
      cY cJ ccld cfv wcel wa cn cY vf cv wf wa vf cv vx cv cD clm cfv wbr vf cv
      vx cv cD cY cY cxp cres clm cfv wbr vx cX cY cD cme wcel cY cX wss wa cY
      cJ ccld cfv wcel wa cn cY vf cv wf wa vf cv vx cv cD clm cfv wbr vx cv cY
      wcel vf cv vx cv cD cY cY cxp cres clm cfv wbr wa vx cv cX wcel cD cme
      wcel cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf wa vf cv vx cv cD
      clm cfv wbr vx cv cY wcel vf cv vx cv cD cY cY cxp cres clm cfv wbr wa cD
      cme wcel cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf wa vf cv vx
      cv cD clm cfv wbr wa vx cv cY wcel vf cv vx cv cD cY cY cxp cres clm cfv
      wbr cD cme wcel cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf vf cv
      vx cv cD clm cfv wbr vx cv cY wcel cD cme wcel cY cX wss wa cY cJ ccld
      cfv wcel wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cY wcel cD
      cme wcel cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf vf cv vx cv
      cD clm cfv wbr wa vx cv cY cJ ccl cfv cfv wcel vx cv cY wcel cD cme wcel
      cY cX wss wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cY cJ ccl
      cfv cfv wcel wi cY cJ ccld cfv wcel cD cme wcel cY cX wss wa vx cv cY cJ
      ccl cfv cfv wcel cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vf wex cn
      cY vf cv wf vf cv vx cv cD clm cfv wbr wa cD vx cv vf cJ cY cX cmsss.1
      cmsss.2 vx visset metelcls cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa
      vf 19.8a syl5bir adantr cD cme wcel cY cJ ccld cfv wcel vx cv cY cJ ccl
      cfv cfv wcel vx cv cY wcel wb cY cX wss cD cme wcel cY cJ ccld cfv wcel
      wa cY cJ ccl cfv cfv cY vx cv cJ ctop wcel cY cJ ccld cfv wcel cY cJ ccl
      cfv cfv cY wceq cD cme wcel cY cJ cldcls cD cJ cmsss.2 opntop sylan
      eleq2d adantlr sylibd imp anassrs cD cme wcel cY cX wss wa cY cJ ccld cfv
      wcel wa cn cY vf cv wf wa vf cv vx cv cD clm cfv wbr cD cme wcel vx cv cY
      wcel cn cY vf cv wf w3a vf cv vx cv cD cY cY cxp cres clm cfv wbr cD cme
      wcel cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf wa vf cv vx cv cD
      clm cfv wbr wa cD cme wcel vx cv cY wcel cn cY vf cv wf cD cme wcel cY cX
      wss wa cY cJ ccld cfv wcel wa cD cme wcel cn cY vf cv wf vf cv vx cv cD
      clm cfv wbr cD cme wcel cY cX wss cY cJ ccld cfv wcel simpll ad2antrr cD
      cme wcel cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf vf cv vx cv
      cD clm cfv wbr vx cv cY wcel cD cme wcel cY cX wss wa cY cJ ccld cfv wcel
      wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cY wcel cD cme wcel
      cY cX wss wa cY cJ ccld cfv wcel wa cn cY vf cv wf vf cv vx cv cD clm cfv
      wbr wa vx cv cY cJ ccl cfv cfv wcel vx cv cY wcel cD cme wcel cY cX wss
      wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cY cJ ccl cfv cfv
      wcel wi cY cJ ccld cfv wcel cD cme wcel cY cX wss wa vx cv cY cJ ccl cfv
      cfv wcel cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vf wex cn cY vf cv
      wf vf cv vx cv cD clm cfv wbr wa cD vx cv vf cJ cY cX cmsss.1 cmsss.2 vx
      visset metelcls cn cY vf cv wf vf cv vx cv cD clm cfv wbr wa vf 19.8a
      syl5bir adantr cD cme wcel cY cJ ccld cfv wcel vx cv cY cJ ccl cfv cfv
      wcel vx cv cY wcel wb cY cX wss cD cme wcel cY cJ ccld cfv wcel wa cY cJ
      ccl cfv cfv cY vx cv cJ ctop wcel cY cJ ccld cfv wcel cY cJ ccl cfv cfv
      cY wceq cD cme wcel cY cJ cldcls cD cJ cmsss.2 opntop sylan eleq2d
      adantlr sylibd imp anassrs cD cme wcel cY cX wss wa cY cJ ccld cfv wcel
      wa cn cY vf cv wf vf cv vx cv cD clm cfv wbr simplr 3jca cD cme wcel vx
      cv cY wcel cn cY vf cv wf w3a vf cv vx cv cD clm cfv wbr vf cv vx cv cD
      cY cY cxp cres clm cfv wbr cD vx cv vf cv cY lmss biimpa sylancom jca ex
      adantld r19.22dv2 ex com23 exp31 com24 syl syld com24 imp41 cD cms wcel
      cY cX wss wa cn cY vf cv wf cn cD cY cY cxp cres cdm cdm vf cv wf wb cY
      cJ ccld cfv wcel vf cv cD cY cY cxp cres cca cfv wcel cD cms wcel cY cX
      wss wa cY cD cY cY cxp cres cdm cdm wceq cn cY vf cv wf cn cD cY cY cxp
      cres cdm cdm vf cv wf wb cD cme wcel cY cX wss cY cD cY cY cxp cres cdm
      cdm wceq cD cms wcel cD cX cY cmsss.1 metssba2 cD cmsmet sylan cY cD cY
      cY cxp cres cdm cdm cn vf cv feq3 syl ad2antrr cD cms wcel cY cX wss wa
      vf cv vx cv cD cY cY cxp cres clm cfv wbr vx cY wrex vf cv vx cv cD cY cY
      cxp cres clm cfv wbr vx cD cY cY cxp cres cdm cdm wrex wb cY cJ ccld cfv
      wcel vf cv cD cY cY cxp cres cca cfv wcel cD cms wcel cY cX wss wa vf cv
      vx cv cD cY cY cxp cres clm cfv wbr vx cY cD cY cY cxp cres cdm cdm cD
      cme wcel cY cX wss cY cD cY cY cxp cres cdm cdm wceq cD cms wcel cD cX cY
      cmsss.1 metssba2 cD cmsmet sylan rexeq1d ad2antrr 3imtr3d r19.21aiva
      sylanbrc impbida $.
      $( [23-Mar-2008] $) $( [28-Jan-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of complete metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f j k v w D $.
    cncms.1 $e |- D = ( abs o. - ) $.
    $( The set of complex numbers is a complete metric space under the absolute
       value metric. $)
    cncms $p |- D e. CMet $=
      vw cD vf cc cD cncms.1 cnmetba cD cncms.1 cnmet vf cv cD cca cfv wcel cn
      cc vf cv wf wa vf cv vw cv cD clm cfv wbr vw cc wrex vf cv vw cv cli wbr
      vw cc wrex cn cc vf cv wf cc0 vv cv clt wbr vj cv vk cv cle wbr vk cv vf
      cv cfv vj cv vf cv cfv cmin co cabs cfv vv cv clt wbr wi vk cn wral vj cn
      wrex wi vv cr wral vf cv vw cv cli wbr vw cc wrex vf cv cD cca cfv wcel
      cn cc vf cv wf wa vw vk vv vj vf cv caucvg3 vf cv cD cca cfv wcel cn cc
      vf cv wf pm3.27 cn cc vf cv wf vf cv cD cca cfv wcel cc0 vv cv clt wbr vj
      cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmin co cabs cfv vv cv
      clt wbr wi vk cn wral vj cn wrex wi vv cr wral cn cc vf cv wf vf cv cD
      cca cfv wcel cc0 vv cv clt wbr vj cv vk cv cle wbr vj cv vf cv cfv vk cv
      vf cv cfv cD co vv cv clt wbr wi vk cn wral vj cn wrex wi vv cr wral cc0
      vv cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmin co
      cabs cfv vv cv clt wbr wi vk cn wral vj cn wrex wi vv cr wral cD cme wcel
      cn cc vf cv wf vf cv cD cca cfv wcel cc0 vv cv clt wbr vj cv vk cv cle
      wbr vj cv vf cv cfv vk cv vf cv cfv cD co vv cv clt wbr wi vk cn wral vj
      cn wrex wi vv cr wral wb cD cncms.1 cnmet vv cD vj vk vf cv c1 cc cn cD
      cncms.1 cnmetba 1z nnuz iscauf mpan cn cc vf cv wf cc0 vv cv clt wbr vj
      cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vv cv clt wbr wi
      vk cn wral vj cn wrex wi cc0 vv cv clt wbr vj cv vk cv cle wbr vk cv vf
      cv cfv vj cv vf cv cfv cmin co cabs cfv vv cv clt wbr wi vk cn wral vj cn
      wrex wi vv cr cn cc vf cv wf vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf
      cv cfv cD co vv cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr
      vk cv vf cv cfv vj cv vf cv cfv cmin co cabs cfv vv cv clt wbr wi vk cn
      wral vj cn wrex cc0 vv cv clt wbr cn cc vf cv wf vj cv vk cv cle wbr vj
      cv vf cv cfv vk cv vf cv cfv cD co vv cv clt wbr wi vk cn wral vj cv vk
      cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmin co cabs cfv vv cv clt wbr
      wi vk cn wral vj cn cn cc vf cv wf vj cv cn wcel wa vj cv vk cv cle wbr
      vj cv vf cv cfv vk cv vf cv cfv cD co vv cv clt wbr wi vj cv vk cv cle
      wbr vk cv vf cv cfv vj cv vf cv cfv cmin co cabs cfv vv cv clt wbr wi vk
      cn cn cc vf cv wf vj cv cn wcel wa vk cv cn wcel wa vj cv vf cv cfv vk cv
      vf cv cfv cD co vv cv clt wbr vk cv vf cv cfv vj cv vf cv cfv cmin co
      cabs cfv vv cv clt wbr vj cv vk cv cle wbr cn cc vf cv wf vj cv cn wcel
      wa vk cv cn wcel wa vj cv vf cv cfv vk cv vf cv cfv cD co vk cv vf cv cfv
      vj cv vf cv cfv cmin co cabs cfv vv cv clt vj cv vf cv cfv cc wcel vk cv
      vf cv cfv cc wcel vj cv vf cv cfv vk cv vf cv cfv cD co vk cv vf cv cfv
      vj cv vf cv cfv cmin co cabs cfv wceq cn cc vf cv wf vj cv cn wcel wa vk
      cv cn wcel wa vj cv vf cv cfv cc wcel vk cv vf cv cfv cc wcel wa vj cv vf
      cv cfv vk cv vf cv cfv cD co vj cv vf cv cfv vk cv vf cv cfv cmin co cabs
      cfv vk cv vf cv cfv vj cv vf cv cfv cmin co cabs cfv vj cv vf cv cfv vk
      cv vf cv cfv cD cncms.1 cnmetdval vj cv vf cv cfv vk cv vf cv cfv abssub
      eqtrd cn cc vf cv wf vj cv cn wcel wa vj cv vf cv cfv cc wcel vk cv cn
      wcel cn cc vj cv vf cv ffvelrn adantr cn cc vf cv wf vk cv cn wcel vk cv
      vf cv cfv cc wcel vj cv cn wcel cn cc vk cv vf cv ffvelrn adantlr sylanc
      breq1d imbi2d ralbidva rexbidva imbi2d ralbidv bitrd biimpac sylanc cn cc
      vf cv wf vf cv vw cv cD clm cfv wbr vw cc wrex vf cv vw cv cli wbr vw cc
      wrex wb vf cv cD cca cfv wcel cn cc vf cv wf vf cv vw cv cD clm cfv wbr
      vf cv vw cv cli wbr vw cc vw cv cvv wcel cn cc vf cv wf vf cv vw cv cD
      clm cfv wbr vf cv vw cv cli wbr wb vw visset cvv cD vw cv vf cv cncms.1
      lmclimnn mpan rexbidv adantl mpbird iscms2i $.
      $( [15-Oct-2007] $) $( [20-Dec-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Baire's Category Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for ~ bcth .  Property of exponentially decreasing terms. $)
  bcthlem1 $p |- ( ( ( m e. NN /\ Y e. RR ) /\ ( Z e. RR /\ Z < ( Y / 2 ) ) )
         -> ( Y < ( 1 / ( 2 ^ m ) ) -> Z < ( 1 / ( 2 ^ ( m + 1 ) ) ) ) ) $=
    vm cv cn0 wcel cY cr wcel cZ cr wcel cZ cY c2 cdiv co clt wbr wa cY c1 c2
    vm cv cexp co cdiv co clt wbr cZ c1 c2 vm cv c1 caddc co cexp co cdiv co
    clt wbr wi vm cv cn wcel vm cv cn0 wcel cY cr wcel wa cZ cr wcel cZ cY c2
    cdiv co clt wbr wa wa cY c1 c2 vm cv cexp co cdiv co clt wbr cY c2 cdiv co
    c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr cZ c1 c2 vm cv c1 caddc co
    cexp co cdiv co clt wbr vm cv cn0 wcel cY cr wcel wa cY c1 c2 vm cv cexp co
    cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv c1 caddc co cexp co cdiv co clt
    wbr wb cZ cr wcel cZ cY c2 cdiv co clt wbr wa vm cv cn0 wcel cY cr wcel wa
    cY c1 c2 vm cv cexp co cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv cexp co
    cdiv co c2 cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv c1 caddc co cexp co
    cdiv co clt wbr cY cr wcel vm cv cn0 wcel cY c1 c2 vm cv cexp co cdiv co
    clt wbr cY c2 cdiv co c1 c2 vm cv cexp co cdiv co c2 cdiv co clt wbr wb cY
    cr wcel c1 c2 vm cv cexp co cdiv co cr wcel cY c1 c2 vm cv cexp co cdiv co
    clt wbr cY c2 cdiv co c1 c2 vm cv cexp co cdiv co c2 cdiv co clt wbr wb vm
    cv cn0 wcel cY cr wcel c1 c2 vm cv cexp co cdiv co cr wcel c2 cr wcel cY c1
    c2 vm cv cexp co cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv cexp co cdiv co
    c2 cdiv co clt wbr wb 2re cY cr wcel c1 c2 vm cv cexp co cdiv co cr wcel c2
    cr wcel w3a cc0 c2 clt wbr cY c1 c2 vm cv cexp co cdiv co clt wbr cY c2
    cdiv co c1 c2 vm cv cexp co cdiv co c2 cdiv co clt wbr wb 2pos cY c1 c2 vm
    cv cexp co cdiv co c2 ltdiv1OLD mpan2 mp3an3 c2 vm cv cexp co cr wcel c2 vm
    cv cexp co cc0 wne c1 c2 vm cv cexp co cdiv co cr wcel vm cv cn0 wcel c2 vm
    cv cexp co rereccl c2 cr wcel vm cv cn0 wcel c2 vm cv cexp co cr wcel 2re
    c2 vm cv reexpcl mpan c2 cc wcel c2 cc0 wne vm cv cn0 wcel c2 vm cv cexp co
    cc0 wne 2cn 2ne0 c2 vm cv expne0i mp3an12 sylanc sylan2 ancoms vm cv cn0
    wcel cY cr wcel wa c1 c2 vm cv cexp co cdiv co c2 cdiv co c1 c2 vm cv c1
    caddc co cexp co cdiv co cY c2 cdiv co clt vm cv cn0 wcel c1 c2 vm cv cexp
    co cdiv co c2 cdiv co c1 c2 vm cv c1 caddc co cexp co cdiv co wceq cY cr
    wcel vm cv cn0 wcel c1 c2 vm cv cexp co cdiv co c2 cdiv co c1 c2 vm cv cexp
    co c2 cmul co cdiv co c1 c2 vm cv c1 caddc co cexp co cdiv co c2 vm cv cexp
    co cc wcel c2 vm cv cexp co cc0 wne c1 c2 vm cv cexp co cdiv co c2 cdiv co
    c1 c2 vm cv cexp co c2 cmul co cdiv co wceq vm cv cn0 wcel c2 vm cv cexp co
    cc wcel c2 vm cv cexp co cc0 wne wa c2 cc wcel c2 cc0 wne c1 c2 vm cv cexp
    co cdiv co c2 cdiv co c1 c2 vm cv cexp co c2 cmul co cdiv co wceq 2cn 2ne0
    c2 vm cv cexp co c2 recdiv2 mpanr12 vm cv cn0 wcel c2 vm cv cexp co c2 cr
    wcel vm cv cn0 wcel c2 vm cv cexp co cr wcel 2re c2 vm cv reexpcl mpan
    recnd c2 cc wcel c2 cc0 wne vm cv cn0 wcel c2 vm cv cexp co cc0 wne 2cn
    2ne0 c2 vm cv expne0i mp3an12 sylanc vm cv cn0 wcel c2 vm cv c1 caddc co
    cexp co c2 vm cv cexp co c2 cmul co c1 cdiv c2 cc wcel vm cv cn0 wcel c2 vm
    cv c1 caddc co cexp co c2 vm cv cexp co c2 cmul co wceq 2cn c2 vm cv expp1
    mpan opreq2d eqtr4d adantr breq2d bitrd adantr vm cv cn0 wcel cY cr wcel cZ
    cr wcel cZ cY c2 cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv c1 caddc co cexp
    co cdiv co clt wbr cZ c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi cZ
    cr wcel cY cr wcel vm cv cn0 wcel cZ cY c2 cdiv co clt wbr cY c2 cdiv co c1
    c2 vm cv c1 caddc co cexp co cdiv co clt wbr cZ c1 c2 vm cv c1 caddc co
    cexp co cdiv co clt wbr wi wi cZ cr wcel cY cr wcel vm cv cn0 wcel cZ cY c2
    cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv c1 caddc co cexp co cdiv co clt
    wbr cZ c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi wi cZ cr wcel cY
    cr wcel vm cv cn0 wcel w3a cZ cY c2 cdiv co clt wbr cY c2 cdiv co c1 c2 vm
    cv c1 caddc co cexp co cdiv co clt wbr cZ c1 c2 vm cv c1 caddc co cexp co
    cdiv co clt wbr cZ cr wcel cY cr wcel c1 c2 vm cv c1 caddc co cexp co cdiv
    co cr wcel cZ cY c2 cdiv co clt wbr cY c2 cdiv co c1 c2 vm cv c1 caddc co
    cexp co cdiv co clt wbr wa cZ c1 c2 vm cv c1 caddc co cexp co cdiv co clt
    wbr wi vm cv cn0 wcel cZ cr wcel cY c2 cdiv co cr wcel c1 c2 vm cv c1 caddc
    co cexp co cdiv co cr wcel cZ cY c2 cdiv co clt wbr cY c2 cdiv co c1 c2 vm
    cv c1 caddc co cexp co cdiv co clt wbr wa cZ c1 c2 vm cv c1 caddc co cexp
    co cdiv co clt wbr wi cY cr wcel cZ cY c2 cdiv co c1 c2 vm cv c1 caddc co
    cexp co cdiv co axlttrn cY rehalfcl syl3an2 vm cv cn0 wcel vm cv c1 caddc
    co cn0 wcel c1 c2 vm cv c1 caddc co cexp co cdiv co cr wcel vm cv peano2nn0
    c2 vm cv c1 caddc co cexp co cr wcel c2 vm cv c1 caddc co cexp co cc0 wne
    c1 c2 vm cv c1 caddc co cexp co cdiv co cr wcel vm cv c1 caddc co cn0 wcel
    c2 vm cv c1 caddc co cexp co rereccl c2 cr wcel vm cv c1 caddc co cn0 wcel
    c2 vm cv c1 caddc co cexp co cr wcel 2re c2 vm cv c1 caddc co reexpcl mpan
    c2 cc wcel c2 cc0 wne vm cv c1 caddc co cn0 wcel c2 vm cv c1 caddc co cexp
    co cc0 wne 2cn 2ne0 c2 vm cv c1 caddc co expne0i mp3an12 sylanc syl syl3an3
    exp3a 3exp com13 imp43 sylbid vm cv nnnn0 sylanl1 $.
    $( [6-Nov-2007] $) $( [19-Oct-2007] $)

  ${
    $d k n D $.  $d k n S $.  $d k n g $.  $d k n j $.  $d k n m $.
    $d k n q $.
    $( Lemma for ~ bcth .  For any ` m ` , we can always find a greater ` n `
       meeting the convergence criterion. $)
    bcthlem2 $p |- ( ( ( m e. NN /\ j e. NN ) /\
       A. k e. NN ( j <_ k -> ( ( ( 1st o. g ) ` k ) D q ) < S ) ) ->
           E. n e. NN ( m < n /\ ( ( ( 1st o. g ) ` n ) D q ) < S ) ) $=
      vm cv cn wcel vj cv cn wcel wa vj cv vk cv cle wbr vk cv c1st vg cv ccom
      cfv vq cv cD co cS clt wbr wi vk cn wral vm cv vn cv clt wbr vn cv c1st
      vg cv ccom cfv vq cv cD co cS clt wbr wa vn cn wrex vm cv cn wcel vj cv
      cn wcel wa vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD co cS
      clt wbr wi vk cn wral vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv
      cD co cS clt wbr wa vn cn wrex wi vm cv vj cv vm cv cn wcel vj cv cn wcel
      wa vm cv vj cv clt wbr wa vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv
      vq cv cD co cS clt wbr wi vk cn wral vj cv vj cv cle wbr vj cv c1st vg cv
      ccom cfv vq cv cD co cS clt wbr wi vj cv c1st vg cv ccom cfv vq cv cD co
      cS clt wbr vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co cS
      clt wbr wa vn cn wrex vj cv cn wcel vj cv vk cv cle wbr vk cv c1st vg cv
      ccom cfv vq cv cD co cS clt wbr wi vk cn wral vj cv vj cv cle wbr vj cv
      c1st vg cv ccom cfv vq cv cD co cS clt wbr wi wi vm cv cn wcel vm cv vj
      cv clt wbr vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD co cS
      clt wbr wi vj cv vj cv cle wbr vj cv c1st vg cv ccom cfv vq cv cD co cS
      clt wbr wi vk vj cv cn vk cv vj cv wceq vj cv vk cv cle wbr vj cv vj cv
      cle wbr vk cv c1st vg cv ccom cfv vq cv cD co cS clt wbr vj cv c1st vg cv
      ccom cfv vq cv cD co cS clt wbr vk cv vj cv vj cv cle breq2 vk cv vj cv
      wceq vk cv c1st vg cv ccom cfv vq cv cD co vj cv c1st vg cv ccom cfv vq
      cv cD co cS clt vk cv vj cv wceq vk cv c1st vg cv ccom cfv vj cv c1st vg
      cv ccom cfv vq cv cD vk cv vj cv c1st vg cv ccom fveq2 opreq1d breq1d
      imbi12d rcla4v ad2antlr vm cv cn wcel vj cv cn wcel wa vm cv vj cv clt
      wbr wa vj cv vj cv cle wbr vj cv vj cv cle wbr vj cv c1st vg cv ccom cfv
      vq cv cD co cS clt wbr wi vj cv c1st vg cv ccom cfv vq cv cD co cS clt
      wbr wi vj cv cn wcel vj cv vj cv cle wbr vm cv cn wcel vm cv vj cv clt
      wbr vj cv cn wcel vj cv cr wcel vj cv vj cv cle wbr vj cv nnre vj cv leid
      syl ad2antlr vj cv vj cv cle wbr vj cv c1st vg cv ccom cfv vq cv cD co cS
      clt wbr pm2.27 syl vm cv cn wcel vj cv cn wcel wa vm cv vj cv clt wbr wa
      vj cv c1st vg cv ccom cfv vq cv cD co cS clt wbr vm cv vn cv clt wbr vn
      cv c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vn cn wrex vj cv cn wcel
      vm cv vj cv clt wbr vj cv c1st vg cv ccom cfv vq cv cD co cS clt wbr wa
      vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co cS clt wbr wa
      vn cn wrex vm cv cn wcel vj cv cn wcel wa vm cv vj cv clt wbr wa vj cv
      c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vm cv vn cv clt wbr vn cv
      c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vm cv vj cv clt wbr vj cv
      c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vn vj cv cn vn cv vj cv
      wceq vm cv vn cv clt wbr vm cv vj cv clt wbr vn cv c1st vg cv ccom cfv vq
      cv cD co cS clt wbr vj cv c1st vg cv ccom cfv vq cv cD co cS clt wbr vn
      cv vj cv vm cv clt breq2 vn cv vj cv wceq vn cv c1st vg cv ccom cfv vq cv
      cD co vj cv c1st vg cv ccom cfv vq cv cD co cS clt vn cv vj cv wceq vn cv
      c1st vg cv ccom cfv vj cv c1st vg cv ccom cfv vq cv cD vn cv vj cv c1st
      vg cv ccom fveq2 opreq1d breq1d anbi12d rcla4ev vm cv cn wcel vj cv cn
      wcel vm cv vj cv clt wbr vj cv c1st vg cv ccom cfv vq cv cD co cS clt wbr
      simpllr vm cv vj cv clt wbr vj cv c1st vg cv ccom cfv vq cv cD co cS clt
      wbr vm cv vj cv clt wbr vj cv c1st vg cv ccom cfv vq cv cD co cS clt wbr
      wa vm cv cn wcel vj cv cn wcel wa vm cv vj cv clt wbr vj cv c1st vg cv
      ccom cfv vq cv cD co cS clt wbr wa id adantll sylanc ex 3syld vm cv cn
      wcel vj cv cn wcel wa vj cv vm cv cle wbr wa vj cv vk cv cle wbr vk cv
      c1st vg cv ccom cfv vq cv cD co cS clt wbr wi vk cn wral vj cv vm cv c1
      caddc co cle wbr vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt
      wbr wi vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr vm cv
      vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vn cn
      wrex vm cv cn wcel vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD
      co cS clt wbr wi vk cn wral vj cv vm cv c1 caddc co cle wbr vm cv c1
      caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr wi wi vj cv cn wcel
      vj cv vm cv cle wbr vm cv cn wcel vm cv c1 caddc co cn wcel vj cv vk cv
      cle wbr vk cv c1st vg cv ccom cfv vq cv cD co cS clt wbr wi vk cn wral vj
      cv vm cv c1 caddc co cle wbr vm cv c1 caddc co c1st vg cv ccom cfv vq cv
      cD co cS clt wbr wi wi vm cv peano2nn vj cv vk cv cle wbr vk cv c1st vg
      cv ccom cfv vq cv cD co cS clt wbr wi vj cv vm cv c1 caddc co cle wbr vm
      cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr wi vk vm cv c1
      caddc co cn vk cv vm cv c1 caddc co wceq vj cv vk cv cle wbr vj cv vm cv
      c1 caddc co cle wbr vk cv c1st vg cv ccom cfv vq cv cD co cS clt wbr vm
      cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr vk cv vm cv c1
      caddc co vj cv cle breq2 vk cv vm cv c1 caddc co wceq vk cv c1st vg cv
      ccom cfv vq cv cD co vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS
      clt vk cv vm cv c1 caddc co wceq vk cv c1st vg cv ccom cfv vm cv c1 caddc
      co c1st vg cv ccom cfv vq cv cD vk cv vm cv c1 caddc co c1st vg cv ccom
      fveq2 opreq1d breq1d imbi12d rcla4v syl ad2antrr vm cv cn wcel vj cv cn
      wcel wa vj cv vm cv cle wbr wa vj cv vm cv c1 caddc co cle wbr vj cv vm
      cv c1 caddc co cle wbr vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co
      cS clt wbr wi vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt
      wbr wi vm cv cn wcel vj cv cn wcel wa vj cv vm cv cle wbr vj cv vm cv c1
      caddc co cle wbr vm cv cn wcel vj cv cn wcel wa vj cv vm cv cle wbr vm cv
      vm cv c1 caddc co cle wbr vj cv vm cv c1 caddc co cle wbr vm cv cn wcel
      vm cv vm cv c1 caddc co cle wbr vj cv cn wcel vm cv cn wcel vm cv cr wcel
      vm cv vm cv c1 caddc co cle wbr vm cv nnre vm cv lep1 syl adantr vj cv cr
      wcel vm cv cr wcel vm cv c1 caddc co cr wcel vj cv vm cv cle wbr vm cv vm
      cv c1 caddc co cle wbr wa vj cv vm cv c1 caddc co cle wbr wi vm cv cn
      wcel vj cv cn wcel wa vj cv vm cv vm cv c1 caddc co letr vj cv cn wcel vj
      cv cr wcel vm cv cn wcel vj cv nnre adantl vm cv cn wcel vm cv cr wcel vj
      cv cn wcel vm cv nnre adantr vm cv cn wcel vm cv c1 caddc co cr wcel vj
      cv cn wcel vm cv cn wcel vm cv cr wcel vm cv c1 caddc co cr wcel vm cv
      nnre vm cv peano2re syl adantr syl3anc mpan2d imp vj cv vm cv c1 caddc co
      cle wbr vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr
      pm2.27 syl vm cv cn wcel vj cv cn wcel wa vj cv vm cv cle wbr wa vm cv c1
      caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr vm cv vn cv clt wbr
      vn cv c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vn cn wrex vm cv c1
      caddc co cn wcel vm cv vm cv c1 caddc co clt wbr vm cv c1 caddc co c1st
      vg cv ccom cfv vq cv cD co cS clt wbr wa vm cv vn cv clt wbr vn cv c1st
      vg cv ccom cfv vq cv cD co cS clt wbr wa vn cn wrex vm cv cn wcel vj cv
      cn wcel wa vj cv vm cv cle wbr wa vm cv c1 caddc co c1st vg cv ccom cfv
      vq cv cD co cS clt wbr wa vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv
      vq cv cD co cS clt wbr wa vm cv vm cv c1 caddc co clt wbr vm cv c1 caddc
      co c1st vg cv ccom cfv vq cv cD co cS clt wbr wa vn vm cv c1 caddc co cn
      vn cv vm cv c1 caddc co wceq vm cv vn cv clt wbr vm cv vm cv c1 caddc co
      clt wbr vn cv c1st vg cv ccom cfv vq cv cD co cS clt wbr vm cv c1 caddc
      co c1st vg cv ccom cfv vq cv cD co cS clt wbr vn cv vm cv c1 caddc co vm
      cv clt breq2 vn cv vm cv c1 caddc co wceq vn cv c1st vg cv ccom cfv vq cv
      cD co vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt vn cv vm
      cv c1 caddc co wceq vn cv c1st vg cv ccom cfv vm cv c1 caddc co c1st vg
      cv ccom cfv vq cv cD vn cv vm cv c1 caddc co c1st vg cv ccom fveq2
      opreq1d breq1d anbi12d rcla4ev vm cv cn wcel vj cv cn wcel wa vj cv vm cv
      cle wbr wa vm cv c1 caddc co cn wcel vm cv c1 caddc co c1st vg cv ccom
      cfv vq cv cD co cS clt wbr vm cv cn wcel vm cv c1 caddc co cn wcel vj cv
      cn wcel vj cv vm cv cle wbr vm cv peano2nn ad2antrr adantr vm cv cn wcel
      vj cv cn wcel wa vj cv vm cv cle wbr wa vm cv vm cv c1 caddc co clt wbr
      vm cv c1 caddc co c1st vg cv ccom cfv vq cv cD co cS clt wbr vm cv cn
      wcel vm cv vm cv c1 caddc co clt wbr vj cv cn wcel vj cv vm cv cle wbr vm
      cv cn wcel vm cv cr wcel vm cv vm cv c1 caddc co clt wbr vm cv nnre vm cv
      ltp1 syl ad2antrr anim1i sylanc ex 3syld vm cv cn wcel vm cv cr wcel vj
      cv cn wcel vm cv nnre adantr vj cv cn wcel vj cv cr wcel vm cv cn wcel vj
      cv nnre adantl pm2.61ltlei imp $.
      $( [7-Nov-2007] $) $( [24-Oct-2007] $)
  $}

  $( Lemma for ~ bcth .  Two ways to express the first component of a ball
     (expressed as an ordered pair) in the sequence of balls ` g ` . $)
  bcthlem3 $p |- ( ( g : NN --> A /\ N e. NN ) ->
            ( ( 1st o. g ) ` N ) = ( 1st ` ( g ` N ) ) ) $=
    c1st wfun cn cA vg cv wf cN cn wcel cN c1st vg cv ccom cfv cN vg cv cfv
    c1st cfv wceq cvv cvv c1st wfo c1st wfun fo1st cvv cvv c1st fofun ax-mp cn
    cA cN c1st vg cv fvco3 mp3an1 $.
    $( [8-Nov-2007] $) $( [21-Oct-2007] $)

  ${
    $d x g $.  $d x N $.
    bcthlem5.7 $e |- A = ( X X. { x e. RR | 0 < x } ) $.
    $( Lemma for ~ bcth .  Closure of the ball components in a sequence ` g `
       of ordered pairs (that represents a sequence of balls). $)
    bcthlem4 $p |- ( ( g : NN --> A /\ N e. NN ) ->
        ( ( 1st ` ( g ` N ) ) e. X /\
        ( ( 2nd ` ( g ` N ) ) e. RR /\ 0 < ( 2nd ` ( g ` N ) ) ) ) ) $=
      cn cA vg cv wf cN cn wcel wa cN vg cv cfv cA wcel cN vg cv cfv c1st cfv
      cX wcel cN vg cv cfv c2nd cfv cr wcel cc0 cN vg cv cfv c2nd cfv clt wbr
      wa wa cn cA cN vg cv ffvelrn cN vg cv cfv cA wcel cN vg cv cfv cX cc0 vx
      cv clt wbr vx cr crab cxp wcel cN vg cv cfv c1st cfv cX wcel cN vg cv cfv
      c2nd cfv cr wcel cc0 cN vg cv cfv c2nd cfv clt wbr wa wa cA cX cc0 vx cv
      clt wbr vx cr crab cxp cN vg cv cfv bcthlem5.7 eleq2i cN vg cv cfv cX cc0
      vx cv clt wbr vx cr crab cxp wcel cN vg cv cfv c1st cfv cX wcel cN vg cv
      cfv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel wa cN vg cv cfv c1st cfv
      cX wcel cN vg cv cfv c2nd cfv cr wcel cc0 cN vg cv cfv c2nd cfv clt wbr
      wa wa cN vg cv cfv cX cc0 vx cv clt wbr vx cr crab cxp wcel cN vg cv cfv
      cN vg cv cfv c1st cfv cN vg cv cfv c2nd cfv cop wceq cN vg cv cfv c1st
      cfv cX wcel cN vg cv cfv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel wa cN
      vg cv cfv cX cc0 vx cv clt wbr vx cr crab elxp6 pm3.27bi cN vg cv cfv
      c2nd cfv cc0 vx cv clt wbr vx cr crab wcel cN vg cv cfv c2nd cfv cr wcel
      cc0 cN vg cv cfv c2nd cfv clt wbr wa cN vg cv cfv c1st cfv cX wcel cc0 vx
      cv clt wbr cc0 cN vg cv cfv c2nd cfv clt wbr vx cN vg cv cfv c2nd cfv cr
      vx cv cN vg cv cfv c2nd cfv cc0 clt breq2 elrab anbi2i sylib sylbi syl $.
      $( [7-Nov-2007] $) $( [21-Oct-2007] $)
  $}

  ${
    $d x D $.  $d x p J $.  $d x p K $.  $d x p M $.  $d x P $.  $d x R $.
    $d x X $.
    bcthlem6.1 $e |- D e. CMet $.
    bcthlem6.3 $e |- X = dom dom D $.
    bcthlem6.4 $e |- J = ( Open ` D ) $.
    $( Lemma for ~ bcth .  Helper lemma expressing the base set for use with
       topology theorems. $)
    bcthlem5 $p |- X = U. J $=
      cJ cuni cX cD cme wcel cJ cuni cX wceq cD bcthlem6.1 cmsmeti cD cJ cX
      bcthlem6.3 bcthlem6.4 uniopn2 ax-mp eqcomi $.
      $( [11-Nov-2007] $) $( [4-Oct-2007] $)

    $( Lemma for ~ bcth .  Helper lemma showing the open sets of the metric
       ` D ` form a topology. $)
    bcthlem6 $p |- J e. Top $=
      cD cme wcel cJ ctop wcel cD bcthlem6.1 cmsmeti cD cJ bcthlem6.4 opntop
      ax-mp $.
      $( [13-Nov-2007] $) $( [4-Oct-2007] $)

    $( Lemma for ~ bcth .  If ` M ` is rare in ` X ` , i.e. the interior of its
       closure is empty, then its closure does not include any ball. $)
    bcthlem7 $p |- ( ( ( M C_ X /\ ( ( int ` J ) ` ( ( cls ` J ) ` M ) ) =
                   (/) ) /\ ( P e. X /\ R e. RR /\ 0 < R ) ) ->
                    -. ( P ( ball ` D ) R ) C_ ( ( cls ` J ) ` M ) ) $=
      cM cX wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa cP cX wcel cR cr
      wcel cc0 cR clt wbr w3a wa vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa vx
      cJ wrex wn cP cR cD cbl cfv co cM cJ ccl cfv cfv wss wn cM cX wss cM cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vx cv cM cJ ccl cfv cfv wss vx cv
      c0 wne wa vx cJ wrex wn cP cX wcel cR cr wcel cc0 cR clt wbr w3a cM cX
      wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vx cv cM cJ ccl cfv cfv
      wss vx cv c0 wceq wi vx cJ wral vx cv cM cJ ccl cfv cfv wss vx cv c0 wne
      wa vx cJ wrex wn cM cX wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vx cv
      cM cJ ccl cfv cfv wss vx cv c0 wceq wi vx cJ wral cJ ctop wcel cM cJ ccl
      cfv cfv cX wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vx cv cM cJ ccl
      cfv cfv wss vx cv c0 wceq wi vx cJ wral wb cM cX wss vx cM cJ ccl cfv cfv
      cJ cX cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem5 ntreq0 cD cJ cX
      bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem6 cJ ctop wcel cM cX wss cM cJ
      ccl cfv cfv cX wss cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem6 cM
      cJ cX cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem5 clsss3 mpan
      sylancr biimpa vx cv cM cJ ccl cfv cfv wss vx cv c0 wceq wi vx cJ wral vx
      cv cM cJ ccl cfv cfv wss vx cv c0 wne wa wn vx cJ wral vx cv cM cJ ccl
      cfv cfv wss vx cv c0 wne wa vx cJ wrex wn vx cv cM cJ ccl cfv cfv wss vx
      cv c0 wceq wi vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa wn vx cJ vx cv
      cM cJ ccl cfv cfv wss vx cv c0 wceq wi vx cv cM cJ ccl cfv cfv wss vx cv
      c0 wne wn wi vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa wn vx cv c0 wne
      wn vx cv c0 wceq vx cv cM cJ ccl cfv cfv wss vx cv c0 nne imbi2i vx cv cM
      cJ ccl cfv cfv wss vx cv c0 wne imnan bitr3i ralbii vx cv cM cJ ccl cfv
      cfv wss vx cv c0 wne wa vx cJ ralnex bitri sylib adantr cP cX wcel cR cr
      wcel cc0 cR clt wbr w3a vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa vx cJ
      wrex wn cP cR cD cbl cfv co cM cJ ccl cfv cfv wss wn wi cM cX wss cM cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq wa cP cX wcel cR cr wcel cc0 cR clt
      wbr w3a cP cR cD cbl cfv co cM cJ ccl cfv cfv wss vx cv cM cJ ccl cfv cfv
      wss vx cv c0 wne wa vx cJ wrex cP cX wcel cR cr wcel cc0 cR clt wbr cP cR
      cD cbl cfv co cM cJ ccl cfv cfv wss vx cv cM cJ ccl cfv cfv wss vx cv c0
      wne wa vx cJ wrex wi cD cme wcel cP cX wcel cR cr wcel cc0 cR clt wbr wa
      cP cR cD cbl cfv co cM cJ ccl cfv cfv wss vx cv cM cJ ccl cfv cfv wss vx
      cv c0 wne wa vx cJ wrex wi cD bcthlem6.1 cmsmeti cP cR cD cbl cfv co cM
      cJ ccl cfv cfv wss cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa
      wa vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa vx cJ wrex cP cR cD cbl
      cfv co cJ wcel cP cR cD cbl cfv co cM cJ ccl cfv cfv wss cP cR cD cbl cfv
      co c0 wne wa vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa vx cJ wrex cP cR
      cD cbl cfv co cM cJ ccl cfv cfv wss cD cme wcel cP cX wcel wa cR cr wcel
      cc0 cR clt wbr wa wa wa vx cv cM cJ ccl cfv cfv wss vx cv c0 wne wa cP cR
      cD cbl cfv co cM cJ ccl cfv cfv wss cP cR cD cbl cfv co c0 wne wa vx cP
      cR cD cbl cfv co cJ vx cv cP cR cD cbl cfv co wceq vx cv cM cJ ccl cfv
      cfv wss cP cR cD cbl cfv co cM cJ ccl cfv cfv wss vx cv c0 wne cP cR cD
      cbl cfv co c0 wne vx cv cP cR cD cbl cfv co cM cJ ccl cfv cfv sseq1 vx cv
      cP cR cD cbl cfv co c0 neeq1 anbi12d rcla4ev cD cme wcel cP cX wcel wa cR
      cr wcel cc0 cR clt wbr wa wa cP cR cD cbl cfv co cJ wcel cP cR cD cbl cfv
      co cM cJ ccl cfv cfv wss cD cP cR cJ cX bcthlem6.3 bcthlem6.4 blopn
      adantl cD cme wcel cP cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cP cR cD
      cbl cfv co c0 wne cP cR cD cbl cfv co cM cJ ccl cfv cfv wss cD cP cR cX
      bcthlem6.3 bln0 anim2i sylanc expcom mpanl1 3impb con3d adantl mpd $.
      $( [14-Nov-2007] $) $( [6-Oct-2007] $)

    $( Lemma for ~ bcth .  Any open nonempty set includes a ball of radius less
       than ` 1 / ( 2 ^ k ) ` . $)
    bcthlem8 $p |- ( ( M =/= (/) /\ M e. J /\ K e. NN ) -> E. p e. M E. x e.
        RR ( 0 < x /\ x < ( 1 / ( 2 ^ K ) ) /\ ( p ( ball ` D ) x ) C_ M ) ) $=
      cM c0 wne cM cJ wcel cK cn wcel w3a vp cv cM wcel cc0 vx cv clt wbr vx cv
      c1 c2 cK cexp co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx
      cr wrex wa vp wex cc0 vx cv clt wbr vx cv c1 c2 cK cexp co cdiv co clt
      wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex vp cM wrex cM cJ wcel
      cK cn wcel cM c0 wne vp cv cM wcel cc0 vx cv clt wbr vx cv c1 c2 cK cexp
      co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex wa vp
      wex cM cJ wcel cK cn wcel cM c0 wne vp cv cM wcel cc0 vx cv clt wbr vx cv
      c1 c2 cK cexp co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx
      cr wrex wa vp wex cM cJ wcel cK cn wcel wa vp cv cM wcel vp wex vp cv cM
      wcel cc0 vx cv clt wbr vx cv c1 c2 cK cexp co cdiv co clt wbr vp cv vx cv
      cD cbl cfv co cM wss w3a vx cr wrex wa vp wex cM c0 wne cM cJ wcel cK cn
      wcel wa vp cv cM wcel vp cv cM wcel cc0 vx cv clt wbr vx cv c1 c2 cK cexp
      co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex wa vp
      cM cJ wcel cK cn wcel wa vp cv cM wcel cc0 vx cv clt wbr vx cv c1 c2 cK
      cexp co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex
      cM cJ wcel cK cn wcel wa vp cv cM wcel cc0 vx cv clt wbr vx cv c1 c2 cK
      cexp co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex
      cM cJ wcel vp cv cM wcel cK cn wcel cc0 vx cv clt wbr vx cv c1 c2 cK cexp
      co cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex cD cme
      wcel cM cJ wcel vp cv cM wcel w3a c1 c2 cK cexp co cdiv co cr wcel cc0 c1
      c2 cK cexp co cdiv co clt wbr wa cc0 vx cv clt wbr vx cv c1 c2 cK cexp co
      cdiv co clt wbr vp cv vx cv cD cbl cfv co cM wss w3a vx cr wrex cM cJ
      wcel vp cv cM wcel wa cK cn wcel vx cM cD vp cv c1 c2 cK cexp co cdiv co
      cJ bcthlem6.4 opni3 cM cJ wcel vp cv cM wcel wa cD cme wcel cM cJ wcel vp
      cv cM wcel cD cme wcel cM cJ wcel vp cv cM wcel wa cD bcthlem6.1 cmsmeti
      a1i cM cJ wcel vp cv cM wcel pm3.26 cM cJ wcel vp cv cM wcel pm3.27 3jca
      cK cn wcel cK cn0 wcel c1 c2 cK cexp co cdiv co cr wcel cc0 c1 c2 cK cexp
      co cdiv co clt wbr wa cK nnnn0 cK cn0 wcel c1 c2 cK cexp co cdiv co cr
      wcel cc0 c1 c2 cK cexp co cdiv co clt wbr c2 cK cexp co cr wcel c2 cK
      cexp co cc0 wne c1 c2 cK cexp co cdiv co cr wcel cK cn0 wcel c2 cK cexp
      co rereccl c2 cr wcel cK cn0 wcel c2 cK cexp co cr wcel 2re c2 cK reexpcl
      mpan c2 cK cexp co cr wcel cc0 c2 cK cexp co clt wbr c2 cK cexp co cc0
      wne cK cn0 wcel c2 cK cexp co gt0ne0 c2 cr wcel cK cn0 wcel c2 cK cexp co
      cr wcel 2re c2 cK reexpcl mpan c2 cr wcel cK cn0 wcel cc0 c2 clt wbr cc0
      c2 cK cexp co clt wbr 2re 2pos c2 cK expgt0 mp3an13 sylanc sylanc c2 cK
      cexp co cr wcel cc0 c2 cK cexp co clt wbr cc0 c1 c2 cK cexp co cdiv co
      clt wbr cK cn0 wcel c2 cK cexp co recgt0 c2 cr wcel cK cn0 wcel c2 cK
      cexp co cr wcel 2re c2 cK reexpcl mpan c2 cr wcel cK cn0 wcel cc0 c2 clt
      wbr cc0 c2 cK cexp co clt wbr 2re 2pos c2 cK expgt0 mp3an13 sylanc jca
      syl syl2an an1rs ex ancld 19.22dv vp cM n0 syl5ib 3impia 3comr cc0 vx cv
      clt wbr vx cv c1 c2 cK cexp co cdiv co clt wbr vp cv vx cv cD cbl cfv co
      cM wss w3a vx cr wrex vp cM df-rex sylibr $.
      $( [15-Nov-2007] $) $( [5-Oct-2007] $)

    ${
      bcthlem9.5 $e |- O =
        ( ( X \ ( ( cls ` J ) ` M ) ) i^i ( P ( ball ` D ) ( R / 2 ) ) ) $.
      $( Lemma for ~ bcth .  If ` M ` is rare in ` X ` , the intersection of
         the complement of its closure with any ball is nonempty and open.
         (Use ~ bcthlem8 for existence of an included ball.) $)
      bcthlem9 $p |- ( ( ( M C_ X /\ ( ( int ` J ) ` ( ( cls ` J ) ` M ) ) =
      (/) ) /\ ( P e. X /\ R e. RR /\ 0 < R ) ) -> ( O =/= (/) /\ O e. J ) ) $=
        cM cX wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa cP cX wcel cR c2
        cdiv co cr wcel cc0 cR c2 cdiv co clt wbr w3a cO c0 wne cO cJ wcel wa
        cP cX wcel cR cr wcel cc0 cR clt wbr w3a cM cX wss cM cJ ccl cfv cfv cJ
        cnt cfv cfv c0 wceq wa cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv
        co clt wbr w3a wa cO c0 wne cO cJ wcel cM cX wss cM cJ ccl cfv cfv cJ
        cnt cfv cfv c0 wceq wa cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv
        co clt wbr w3a wa cO c0 wne cP cR c2 cdiv co cD cbl cfv co cM cJ ccl
        cfv cfv wss wn cD cP cR c2 cdiv co cJ cM cX bcthlem6.1 bcthlem6.3
        bcthlem6.4 bcthlem7 cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co
        clt wbr w3a cO c0 wne cP cR c2 cdiv co cD cbl cfv co cM cJ ccl cfv cfv
        wss wn wb cM cX wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa cP cX
        wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr w3a cP cR c2 cdiv
        co cD cbl cfv co cX cin cM cJ ccl cfv cfv wss wn cP cR c2 cdiv co cD
        cbl cfv co cM cJ ccl cfv cfv wss wn cO c0 wne cP cX wcel cR c2 cdiv co
        cr wcel cc0 cR c2 cdiv co clt wbr w3a cP cR c2 cdiv co cD cbl cfv co cX
        cin cM cJ ccl cfv cfv wss cP cR c2 cdiv co cD cbl cfv co cM cJ ccl cfv
        cfv wss cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr w3a
        cP cR c2 cdiv co cD cbl cfv co cX cin cP cR c2 cdiv co cD cbl cfv co cM
        cJ ccl cfv cfv cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt
        wbr w3a cP cR c2 cdiv co cD cbl cfv co cX wss cP cR c2 cdiv co cD cbl
        cfv co cX cin cP cR c2 cdiv co cD cbl cfv co wceq cP cX wcel cR c2 cdiv
        co cr wcel cc0 cR c2 cdiv co clt wbr cP cR c2 cdiv co cD cbl cfv co cX
        wss cD cme wcel cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt
        wbr wa cP cR c2 cdiv co cD cbl cfv co cX wss cD bcthlem6.1 cmsmeti cD
        cP cR c2 cdiv co cX bcthlem6.3 blssm mpanl1 3impb cP cR c2 cdiv co cD
        cbl cfv co cX df-ss sylib sseq1d notbid cP cR c2 cdiv co cD cbl cfv co
        cX cin cM cJ ccl cfv cfv wss cO c0 cP cR c2 cdiv co cD cbl cfv co cX
        cin cM cJ ccl cfv cfv wss cP cR c2 cdiv co cD cbl cfv co cX cM cJ ccl
        cfv cfv cdif cin c0 wceq cO c0 wceq cP cR c2 cdiv co cD cbl cfv co cX
        cM cJ ccl cfv cfv inssdif0 cO cP cR c2 cdiv co cD cbl cfv co cX cM cJ
        ccl cfv cfv cdif cin c0 cO cX cM cJ ccl cfv cfv cdif cP cR c2 cdiv co
        cD cbl cfv co cin cP cR c2 cdiv co cD cbl cfv co cX cM cJ ccl cfv cfv
        cdif cin bcthlem9.5 cX cM cJ ccl cfv cfv cdif cP cR c2 cdiv co cD cbl
        cfv co incom eqtri eqeq1i bitr4i necon3bbii syl5bbr adantl mpbird cM cX
        wss cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr w3a cO
        cJ wcel cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq cX cM cJ ccl cfv cfv
        cdif cJ wcel cP cR c2 cdiv co cD cbl cfv co cJ wcel cO cJ wcel cM cX
        wss cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr w3a cX
        cM cJ ccl cfv cfv cdif cJ wcel cP cR c2 cdiv co cD cbl cfv co cJ wcel
        wa cX cM cJ ccl cfv cfv cdif cP cR c2 cdiv co cD cbl cfv co cin cJ cO
        cD cme wcel cX cM cJ ccl cfv cfv cdif cJ wcel cP cR c2 cdiv co cD cbl
        cfv co cJ wcel cX cM cJ ccl cfv cfv cdif cP cR c2 cdiv co cD cbl cfv co
        cin cJ wcel cD bcthlem6.1 cmsmeti cX cM cJ ccl cfv cfv cdif cP cR c2
        cdiv co cD cbl cfv co cD cJ bcthlem6.4 opnin mp3an1 bcthlem9.5 syl5eqel
        cJ ctop wcel cM cX wss cX cM cJ ccl cfv cfv cdif cJ wcel cD cJ cX
        bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem6 cM cJ cX cD cJ cX bcthlem6.1
        bcthlem6.3 bcthlem6.4 bcthlem5 cmclsopn mpan cP cX wcel cR c2 cdiv co
        cr wcel cc0 cR c2 cdiv co clt wbr cP cR c2 cdiv co cD cbl cfv co cJ
        wcel cD cme wcel cP cX wcel cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt
        wbr wa cP cR c2 cdiv co cD cbl cfv co cJ wcel cD bcthlem6.1 cmsmeti cD
        cP cR c2 cdiv co cJ cX bcthlem6.3 bcthlem6.4 blopn mpanl1 3impb syl2an
        adantlr jca cP cX wcel cR cr wcel cc0 cR clt wbr w3a cP cX wcel cR c2
        cdiv co cr wcel cc0 cR c2 cdiv co clt wbr cP cX wcel cR cr wcel cc0 cR
        clt wbr 3simp1 cR cr wcel cP cX wcel cR c2 cdiv co cr wcel cc0 cR clt
        wbr cR rehalfcl 3ad2ant2 cR cr wcel cc0 cR clt wbr cc0 cR c2 cdiv co
        clt wbr cP cX wcel cR cr wcel cc0 cR clt wbr cc0 cR c2 cdiv co clt wbr
        cR halfpos2 biimpa 3adant1 3jca sylan2 $.
        $( [14-Nov-2007] $) $( [7-Oct-2007] $)
    $}

    ${
      bcthlem11.2 $e |- X =/= (/) $.
      $( Lemma for ~ bcth .  If ` M ` is rare in ` X ` , the complement
         of its closure is not empty and is open. $)
      bcthlem10 $p |- ( ( M C_ X /\ ( ( int ` J ) ` ( ( cls ` J ) ` M ) ) = (/)
                ) -> ( ( X \ ( ( cls ` J ) ` M ) ) =/= (/) /\
                       ( X \ ( ( cls ` J ) ` M ) ) e. J ) ) $=
        cM cX wss cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa cX cM cJ ccl cfv
        cfv cdif c0 wne cX cM cJ ccl cfv cfv cdif cJ wcel cM cX wss cM cJ ccl
        cfv cfv cX wne cX cM cJ ccl cfv cfv cdif c0 wne cM cJ ccl cfv cfv cJ
        cnt cfv cfv c0 wceq cM cX wss cM cJ ccl cfv cfv cX wne cX cM cJ ccl cfv
        cfv cdif c0 wne cM cX wss cX cM cJ ccl cfv cfv cdif c0 cM cJ ccl cfv
        cfv cX cM cX wss cX cM cJ ccl cfv cfv wss cM cJ ccl cfv cfv cX wceq cX
        cM cJ ccl cfv cfv cdif c0 wceq cM cX wss cM cJ ccl cfv cfv cX wss cX cM
        cJ ccl cfv cfv wss cM cJ ccl cfv cfv cX wceq wi cJ ctop wcel cM cX wss
        cM cJ ccl cfv cfv cX wss cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4
        bcthlem6 cM cJ cX cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem5
        clsss3 mpan cM cJ ccl cfv cfv cX wss cX cM cJ ccl cfv cfv wss cM cJ ccl
        cfv cfv cX wceq cM cJ ccl cfv cfv cX wss cX cM cJ ccl cfv cfv wss wa cM
        cJ ccl cfv cfv cX cM cJ ccl cfv cfv cX wss cX cM cJ ccl cfv cfv wss
        pm3.26 cM cJ ccl cfv cfv cX wss cX cM cJ ccl cfv cfv wss pm3.27 eqssd
        ex syl cX cM cJ ccl cfv cfv ssdif0 syl5ibr necon3d imp cM cJ ccl cfv
        cfv cX cM cJ ccl cfv cfv cJ cnt cfv cfv c0 cM cJ ccl cfv cfv cX wceq cX
        c0 wne cM cJ ccl cfv cfv cJ cnt cfv cfv c0 wne bcthlem11.2 cM cJ ccl
        cfv cfv cX wceq cX cM cJ ccl cfv cfv cJ cnt cfv cfv c0 cM cJ ccl cfv
        cfv cX wceq cM cJ ccl cfv cfv cJ cnt cfv cfv cX cJ cnt cfv cfv cX cM cJ
        ccl cfv cfv cX cJ cnt cfv fveq2 cJ ctop wcel cX cJ cnt cfv cfv cX wceq
        cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem6 cJ cX cD cJ cX
        bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem5 ntrtop ax-mp syl6req neeq1d
        mpbii necon2i sylan2 cM cX wss cX cM cJ ccl cfv cfv cdif cJ wcel cM cJ
        ccl cfv cfv cJ cnt cfv cfv c0 wceq cJ ctop wcel cM cX wss cX cM cJ ccl
        cfv cfv cdif cJ wcel cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem6
        cM cJ cX cD cJ cX bcthlem6.1 bcthlem6.3 bcthlem6.4 bcthlem5 cmclsopn
        mpan adantr jca $.
        $( [15-Nov-2007] $) $( [5-Oct-2007] $)
    $}
  $}

  ${
    $d j k n D $.  $d j k p r X $.  $d j k n x g $.  $d j k n p r m x $.
    $d j k n q $.
    bcthlem12.1 $e |- D e. CMet $.
    bcthlem12.3 $e |- X = dom dom D $.
    bcthlem12.7 $e |- A = ( X X. { x e. RR | 0 < x } ) $.
    $( Lemma for ~ bcth .  Triangle inequality. $)
    bcthlem11 $p |- ( ( ( g : NN --> A /\ m e. NN ) /\ ( n e. NN /\ q e. X )
           ) -> ( ( ( 1st o. g ) ` m ) D q ) <_
              ( ( ( ( 1st o. g ) ` m ) D ( ( 1st o. g ) ` n ) ) +
                ( ( ( 1st o. g ) ` n ) D q ) ) ) $=
      vm cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg cv ccom cfv
      cX wcel vm cv c1st vg cv ccom cfv vq cv cD co vm cv c1st vg cv ccom cfv
      vn cv c1st vg cv ccom cfv cD co vn cv c1st vg cv ccom cfv vq cv cD co
      caddc co cle wbr cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX
      wcel wa wa cD cme wcel vm cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn
      cv c1st vg cv ccom cfv cX wcel w3a vm cv c1st vg cv ccom cfv vq cv cD co
      vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vn cv c1st vg
      cv ccom cfv vq cv cD co caddc co cle wbr cD bcthlem12.1 cmsmeti vm cv
      c1st vg cv ccom cfv vq cv vn cv c1st vg cv ccom cfv cD cX bcthlem12.3
      mettri mpan cn cA vg cv wf vm cv cn wcel wa vm cv c1st vg cv ccom cfv cX
      wcel vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel wa vm cv
      c1st vg cv ccom cfv vm cv vg cv cfv c1st cfv cX cA vg vm cv bcthlem3 cn
      cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv
      cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm
      cv cX bcthlem12.7 bcthlem4 pm3.26d eqeltrd adantr cn cA vg cv wf vm cv cn
      wcel wa vn cv cn wcel vq cv cX wcel simprr cn cA vg cv wf vm cv cn wcel
      wa vn cv cn wcel vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel cn cA vg
      cv wf vn cv cn wcel vn cv c1st vg cv ccom cfv cX wcel vm cv cn wcel cn cA
      vg cv wf vn cv cn wcel wa vn cv c1st vg cv ccom cfv vn cv vg cv cfv c1st
      cfv cX cA vg vn cv bcthlem3 cn cA vg cv wf vn cv cn wcel wa vn cv vg cv
      cfv c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv
      c2nd cfv clt wbr wa vx cA vg vn cv cX bcthlem12.7 bcthlem4 pm3.26d
      eqeltrd adantlr adantrr syl3anc $.
      $( [12-Nov-2007] $) $( [23-Oct-2007] $)

    $( Lemma for ~ bcth .  Helper lemma for satisfying the antecendent of
       ~ acdc5 . $)
    bcthlem12 $p |- { <. p , r >. | ( ( p e. X /\
       ( r e. RR /\ 0 < r ) ) /\ ( r < ( ( 2nd ` y ) / 2 ) /\ ( p (
         ball ` D ) r ) C_ O ) ) } e. ~P A $=
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA
      cpw wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr
      copab cA wss vp cv cX wcel vr cv cc0 vx cv clt wbr vx cr crab wcel wa vr
      cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa
      wa vp vr copab cX cc0 vx cv clt wbr vx cr crab cxp vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA vr cv vy cv c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa vp vr cX cc0 vx cv
      clt wbr vx cr crab opabssxp vp cv cX wcel vr cv cc0 vx cv clt wbr vx cr
      crab wcel wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss wa wa vp vr copab vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv
      co cO wss wa wa vp vr copab vp cv cX wcel vr cv cc0 vx cv clt wbr vx cr
      crab wcel wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss wa wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa
      vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss
      wa wa vp vr vp cv cX wcel vr cv cc0 vx cv clt wbr vx cr crab wcel wa vp
      cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa vr cv cc0 vx cv clt
      wbr vx cr crab wcel vr cv cr wcel cc0 vr cv clt wbr wa vp cv cX wcel cc0
      vx cv clt wbr cc0 vr cv clt wbr vx vr cv cr vx cv vr cv cc0 clt breq2
      elrab anbi2i anbi1i opabbii eqcomi bcthlem12.7 3sstr4i vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt
      wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA cA cX cc0 vx cv
      clt wbr vx cr crab cxp cvv bcthlem12.7 cX cc0 vx cv clt wbr vx cr crab cX
      cD cdm cdm cvv bcthlem12.3 cD cdm cD cms wcel cD cdm cvv wcel bcthlem12.1
      cD cms dmexg ax-mp dmex eqeltri cc0 vx cv clt wbr vx cr reex rabex xpex
      eqeltri elpw2 mpbir $.
      $( [8-Nov-2007] $) $( [30-Oct-2007] $)

    $( Lemma for ~ bcth .  In the sequence ` g ` of balls (expressed as ordered
       pairs), for any ` m ` , there is a larger ` n ` whose ball's center
       distance from limit ` p ` is less than half of the ball radius at
       ` m ` . $)
    bcthlem13 $p |- ( ( ( g : NN --> A /\ m e. NN ) /\
          ( 1st o. g ) ( ~~>m ` D ) q ) -> E. n e. NN ( m < n /\
       ( ( ( 1st o. g ) ` n ) D q ) < ( ( 2nd ` ( g ` m ) ) / 2 ) ) ) $=
      cn cA vg cv wf vm cv cn wcel wa c1st vg cv ccom vq cv cD clm cfv wbr wa
      vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr wi vk cn wral vj cn wrex vm cv vn cv clt wbr
      vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr wa vn cn wrex c1st vg cv ccom vq cv cD clm cfv wbr vm cv vg cv
      cfv c2nd cfv c2 cdiv co cr wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr wa vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD co vm
      cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi vk cn wral vj cn wrex cn cA
      vg cv wf vm cv cn wcel wa c1st vg cv ccom vq cv cD clm cfv wbr wa vq cv
      cvv wcel c1st vg cv ccom vq cv cD clm cfv wbr vm cv vg cv cfv c2nd cfv c2
      cdiv co cr wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vj cv
      vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd
      cfv c2 cdiv co clt wbr wi vk cn wral vj cn wrex vq visset cD cme wcel vq
      cv cvv wcel c1st vg cv ccom vq cv cD clm cfv wbr vm cv vg cv cfv c2nd cfv
      c2 cdiv co cr wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vj
      cv vk cv cle wbr vk cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr wi vk cn wral vj cn wrex cD bcthlem12.1
      cmsmeti cvv cD vq cv vm cv vg cv cfv c2nd cfv c2 cdiv co vj vk c1st vg cv
      ccom c1 cX cn bcthlem12.3 1z nnuz lmcvg2 mp3anl1 mpanl1 cn cA vg cv wf vm
      cv cn wcel wa c1st vg cv ccom vq cv cD clm cfv wbr pm3.27 cn cA vg cv wf
      vm cv cn wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cc0 vm cv vg
      cv cfv c2nd cfv c2 cdiv co clt wbr wa c1st vg cv ccom vq cv cD clm cfv
      wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0
      vm cv vg cv cfv c2nd cfv clt wbr wa vm cv vg cv cfv c2nd cfv c2 cdiv co
      cr wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa cn cA vg cv wf
      vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd
      cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem12.7 bcthlem4 pm3.27d vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv
      vg cv cfv c2nd cfv clt wbr wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel
      cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c2nd cfv
      cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cc0 vm cv vg cv cfv
      c2nd cfv clt wbr vm cv vg cv cfv c2nd cfv rehalfcl adantr vm cv vg cv cfv
      c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cc0 vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c2nd cfv halfpos2 biimpa jca
      syl adantr sylanc vm cv cn wcel vj cv vk cv cle wbr vk cv c1st vg cv ccom
      cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi vk cn wral
      vj cn wrex vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co vm
      cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vn cn wrex wi cn cA vg cv wf
      c1st vg cv ccom vq cv cD clm cfv wbr vm cv cn wcel vj cv vk cv cle wbr vk
      cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr wi vk cn wral vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv
      cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vn cn wrex vj cn vm
      cv cn wcel vj cv cn wcel wa vj cv vk cv cle wbr vk cv c1st vg cv ccom cfv
      vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi vk cn wral vm
      cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr wa vn cn wrex cD vm cv vg cv cfv c2nd cfv c2
      cdiv co vg vj vk vm vn vq bcthlem2 ex r19.23adva ad2antlr mpd $.
      $( [12-Nov-2007] $) $( [24-Oct-2007] $)
  $}

  ${
    $d j p y z A $.  $d r x D $.  $d p w x z J $.  $d p x K $.  $d p w x z M $.
    $d p r O $.  $d x P $.  $d x R $.  $d j p r w x y z X $.
    bcthlem15.1 $e |- D e. CMet $.
    bcthlem15.3 $e |- X = dom dom D $.
    bcthlem15.4 $e |- J = ( Open ` D ) $.
    bcthlem15.7 $e |- A = ( X X. { x e. RR | 0 < x } ) $.
    bcthlem15.8 $e |- O = ( ( X \ ( ( cls ` J ) ` ( M ` j ) ) ) i^i
          ( ( 1st ` y ) ( ball ` D ) ( ( 2nd ` y ) / 2 ) ) ) $.
    $( Lemma for ~ bcth .  Helper lemma for satisfying the antecendent of
       ~ acdc5 . $)
    bcthlem14 $p |- ( ( ( ( M ` j ) C_ X /\ ( ( int ` J ) ` ( ( cls ` J )
      ` ( M ` j ) ) ) = (/) ) /\ ( j e. NN /\ y e. A ) ) -> { <. p , r >. |
     ( ( p e. X /\ ( r e. RR /\ 0 < r ) ) /\ ( r < ( ( 2nd ` y ) / 2 ) /\
            ( p ( ball ` D ) r ) C_ O ) ) } =/= (/) ) $=
      vj cv cM cfv cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa
      vj cv cn wcel vy cv cA wcel wa wa vp cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss wa wa vr wex vp wex vp cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss wa wa vp vr copab c0 wne vj cv cM cfv cX wss vj cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel vy cv cA wcel wa
      wa vp cv cO wcel vp wex vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO
      wss wa wa vr wex vp wex vj cv cM cfv cX wss vj cv cM cfv cJ ccl cfv cfv
      cJ cnt cfv cfv c0 wceq wa vj cv cn wcel vy cv cA wcel wa wa cO c0 wne vp
      cv cO wcel vp wex vj cv cM cfv cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt
      cfv cfv c0 wceq wa vj cv cn wcel vy cv cA wcel wa wa cO c0 wne cO cJ wcel
      vj cv cM cfv cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa
      vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr
      w3a cO c0 wne cO cJ wcel wa vj cv cn wcel vy cv cA wcel wa cD vy cv c1st
      cfv vy cv c2nd cfv cJ vj cv cM cfv cO cX bcthlem15.1 bcthlem15.3
      bcthlem15.4 bcthlem15.8 bcthlem9 vy cv cA wcel vy cv c1st cfv cX wcel vy
      cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a vj cv cn wcel vy cv cA
      wcel vy cv cX cc0 vx cv clt wbr vx cr crab cxp wcel vy cv c1st cfv cX
      wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a cA cX cc0 vx
      cv clt wbr vx cr crab cxp vy cv bcthlem15.7 eleq2i vy cv cX cc0 vx cv clt
      wbr vx cr crab cxp wcel vy cv c1st cfv cX wcel vy cv c2nd cfv cc0 vx cv
      clt wbr vx cr crab wcel wa vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel
      cc0 vy cv c2nd cfv clt wbr w3a vy cv cX cc0 vx cv clt wbr vx cr crab cxp
      wcel vy cv vy cv c1st cfv vy cv c2nd cfv cop wceq vy cv c1st cfv cX wcel
      vy cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel wa vy cv cX cc0 vx cv
      clt wbr vx cr crab elxp6 pm3.27bi vy cv c1st cfv cX wcel vy cv c2nd cfv
      cc0 vx cv clt wbr vx cr crab wcel wa vy cv c1st cfv cX wcel vy cv c2nd
      cfv cr wcel cc0 vy cv c2nd cfv clt wbr wa wa vy cv c1st cfv cX wcel vy cv
      c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a vy cv c2nd cfv cc0 vx cv
      clt wbr vx cr crab wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr
      wa vy cv c1st cfv cX wcel cc0 vx cv clt wbr cc0 vy cv c2nd cfv clt wbr vx
      vy cv c2nd cfv cr vx cv vy cv c2nd cfv cc0 clt breq2 elrab anbi2i vy cv
      c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr 3anass
      bitr4i sylib sylbi adantl sylan2 pm3.26d vp cO n0 sylib vj cv cM cfv cX
      wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel
      vy cv cA wcel wa wa vp cv cO wcel vp cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss wa wa vr wex vp vj cv cM cfv cX wss vj cv cM cfv cJ ccl cfv
      cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel vy cv cA wcel wa wa vp cv cO
      wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vr cv vy cv c2nd
      cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vr wex wa
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vr wex vj cv cM
      cfv cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn
      wcel vy cv cA wcel wa wa vp cv cO wcel vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss wa wa vr wex vp cv cO wcel vp cv cX wcel wi vj cv cM cfv cX
      wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel
      vy cv cA wcel wa wa cO cX vp cv cO cX vj cv cM cfv cJ ccl cfv cfv cdif vy
      cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin cX bcthlem15.8 cX
      vj cv cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co
      cD cbl cfv co cin cX vj cv cM cfv cJ ccl cfv cfv cdif cX cX vj cv cM cfv
      cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv
      co inss1 cX vj cv cM cfv cJ ccl cfv cfv difss sstri eqsstri sseli a1i vj
      cv cM cfv cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj
      cv cn wcel vy cv cA wcel wa wa vp cv cO wcel cc0 vr cv clt wbr vr cv vy
      cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss w3a vr cr
      wrex vr cv cr wcel cc0 vr cv clt wbr wa vr cv vy cv c2nd cfv c2 cdiv co
      clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vr wex vj cv cM cfv cX wss
      vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel vy cv
      cA wcel wa wa vp cv cO wcel cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss w3a vr cr wrex cO cJ
      wcel vp cv cO wcel wa vy cv c2nd cfv c2 cdiv co cr wcel cc0 vy cv c2nd
      cfv c2 cdiv co clt wbr wa cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv
      co clt wbr vp cv vr cv cD cbl cfv co cO wss w3a vr cr wrex vj cv cM cfv
      cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn
      wcel vy cv cA wcel wa wa vp cv cO wcel wa cD cme wcel cO cJ wcel vp cv cO
      wcel vy cv c2nd cfv c2 cdiv co cr wcel cc0 vy cv c2nd cfv c2 cdiv co clt
      wbr wa cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr
      cv cD cbl cfv co cO wss w3a vr cr wrex cD bcthlem15.1 cmsmeti vr cO cD vp
      cv vy cv c2nd cfv c2 cdiv co cJ bcthlem15.4 opni3 mp3anl1 vj cv cM cfv cX
      wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel
      vy cv cA wcel wa wa cO cJ wcel vp cv cO wcel vj cv cM cfv cX wss vj cv cM
      cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel vy cv cA wcel
      wa wa cO c0 wne cO cJ wcel vj cv cM cfv cX wss vj cv cM cfv cJ ccl cfv
      cfv cJ cnt cfv cfv c0 wceq wa vy cv c1st cfv cX wcel vy cv c2nd cfv cr
      wcel cc0 vy cv c2nd cfv clt wbr w3a cO c0 wne cO cJ wcel wa vj cv cn wcel
      vy cv cA wcel wa cD vy cv c1st cfv vy cv c2nd cfv cJ vj cv cM cfv cO cX
      bcthlem15.1 bcthlem15.3 bcthlem15.4 bcthlem15.8 bcthlem9 vy cv cA wcel vy
      cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a
      vj cv cn wcel vy cv cA wcel vy cv cX cc0 vx cv clt wbr vx cr crab cxp
      wcel vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt
      wbr w3a cA cX cc0 vx cv clt wbr vx cr crab cxp vy cv bcthlem15.7 eleq2i
      vy cv cX cc0 vx cv clt wbr vx cr crab cxp wcel vy cv c1st cfv cX wcel vy
      cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel wa vy cv c1st cfv cX wcel
      vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a vy cv cX cc0 vx cv
      clt wbr vx cr crab cxp wcel vy cv vy cv c1st cfv vy cv c2nd cfv cop wceq
      vy cv c1st cfv cX wcel vy cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel
      wa vy cv cX cc0 vx cv clt wbr vx cr crab elxp6 pm3.27bi vy cv c1st cfv cX
      wcel vy cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel wa vy cv c1st cfv
      cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr wa wa vy cv
      c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a vy
      cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel vy cv c2nd cfv cr wcel cc0
      vy cv c2nd cfv clt wbr wa vy cv c1st cfv cX wcel cc0 vx cv clt wbr cc0 vy
      cv c2nd cfv clt wbr vx vy cv c2nd cfv cr vx cv vy cv c2nd cfv cc0 clt
      breq2 elrab anbi2i vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy
      cv c2nd cfv clt wbr 3anass bitr4i sylib sylbi adantl sylan2 pm3.27d
      anim1i vj cv cn wcel vy cv cA wcel wa vy cv c2nd cfv c2 cdiv co cr wcel
      cc0 vy cv c2nd cfv c2 cdiv co clt wbr wa vj cv cM cfv cX wss vj cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vp cv cO wcel vy cv cA wcel vy
      cv c2nd cfv c2 cdiv co cr wcel cc0 vy cv c2nd cfv c2 cdiv co clt wbr wa
      vj cv cn wcel vy cv cA wcel vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel
      cc0 vy cv c2nd cfv clt wbr w3a vy cv c2nd cfv c2 cdiv co cr wcel cc0 vy
      cv c2nd cfv c2 cdiv co clt wbr wa vy cv cA wcel vy cv cX cc0 vx cv clt
      wbr vx cr crab cxp wcel vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0
      vy cv c2nd cfv clt wbr w3a cA cX cc0 vx cv clt wbr vx cr crab cxp vy cv
      bcthlem15.7 eleq2i vy cv cX cc0 vx cv clt wbr vx cr crab cxp wcel vy cv
      c1st cfv cX wcel vy cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel wa vy
      cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr w3a
      vy cv cX cc0 vx cv clt wbr vx cr crab cxp wcel vy cv vy cv c1st cfv vy cv
      c2nd cfv cop wceq vy cv c1st cfv cX wcel vy cv c2nd cfv cc0 vx cv clt wbr
      vx cr crab wcel wa vy cv cX cc0 vx cv clt wbr vx cr crab elxp6 pm3.27bi
      vy cv c1st cfv cX wcel vy cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel
      wa vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt
      wbr wa wa vy cv c1st cfv cX wcel vy cv c2nd cfv cr wcel cc0 vy cv c2nd
      cfv clt wbr w3a vy cv c2nd cfv cc0 vx cv clt wbr vx cr crab wcel vy cv
      c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr wa vy cv c1st cfv cX wcel cc0
      vx cv clt wbr cc0 vy cv c2nd cfv clt wbr vx vy cv c2nd cfv cr vx cv vy cv
      c2nd cfv cc0 clt breq2 elrab anbi2i vy cv c1st cfv cX wcel vy cv c2nd cfv
      cr wcel cc0 vy cv c2nd cfv clt wbr 3anass bitr4i sylib sylbi vy cv c2nd
      cfv cr wcel cc0 vy cv c2nd cfv clt wbr vy cv c2nd cfv c2 cdiv co cr wcel
      cc0 vy cv c2nd cfv c2 cdiv co clt wbr wa vy cv c1st cfv cX wcel vy cv
      c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr wa vy cv c2nd cfv c2 cdiv co
      cr wcel cc0 vy cv c2nd cfv c2 cdiv co clt wbr vy cv c2nd cfv cr wcel vy
      cv c2nd cfv c2 cdiv co cr wcel cc0 vy cv c2nd cfv clt wbr vy cv c2nd cfv
      rehalfcl adantr vy cv c2nd cfv cr wcel cc0 vy cv c2nd cfv clt wbr cc0 vy
      cv c2nd cfv c2 cdiv co clt wbr vy cv c2nd cfv halfpos2 biimpa jca 3adant1
      syl adantl ad2antlr sylanc ex cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss w3a vr cr wrex vr cv cr
      wcel cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr
      cv cD cbl cfv co cO wss w3a wa vr wex vr cv cr wcel cc0 vr cv clt wbr wa
      vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss
      wa wa vr wex cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cO wss w3a vr cr df-rex vr cv cr wcel cc0 vr cv
      clt wbr wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv
      co cO wss wa wa vr cv cr wcel cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss w3a wa vr vr cv cr wcel
      cc0 vr cv clt wbr wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv
      cD cbl cfv co cO wss wa wa vr cv cr wcel cc0 vr cv clt wbr vr cv vy cv
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa wa vr
      cv cr wcel cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cO wss w3a wa vr cv cr wcel cc0 vr cv clt wbr vr
      cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa
      anass cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr
      cv cD cbl cfv co cO wss w3a cc0 vr cv clt wbr vr cv vy cv c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vr cv cr wcel cc0
      vr cv clt wbr vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cO wss 3anass anbi2i bitr4i exbii bitr4i syl6ib jcad vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt
      wbr vp cv vr cv cD cbl cfv co cO wss wa wa vr wex vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv
      vr cv cD cbl cfv co cO wss wa wa wa vr wex vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv
      cD cbl cfv co cO wss wa wa vr wex wa vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD
      cbl cfv co cO wss wa wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss
      wa wa wa vr vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vr cv vy cv
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa anass
      exbii vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vr cv vy cv c2nd
      cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vr 19.42v
      bitr2i syl6ib 19.22dv mpd vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr
      wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co
      cO wss wa wa vp vr opabn0 sylibr $.
      $( [14-Nov-2007] $) $( [10-Oct-2007] $)
  $}

  ${
    $d j y z A $.  $d j p r y z D $.  $d k F $.  $d j p r y z J $.
    $d j p r y z K $.  $d j p r y z M $.  $d z O $.  $d p r P $.
    $d j p r y z Q $.  $d j p r y z X $.  $d g j k m p r y z $.
    bcthlem16.1 $e |- D e. CMet $.
    bcthlem16.3 $e |- X = dom dom D $.
    bcthlem16.6 $e |- F = { <. <. j , y >. , z >. | ( ( j e. NN /\ y e. A )
  /\ z = { <. p , r >. | ( ( p e. X /\ ( r e. RR /\ 0 < r ) ) /\
     ( r < ( ( 2nd ` y ) / 2 ) /\ ( p ( ball ` D ) r ) C_ O ) ) } ) } $.
    bcthlem16.8 $e |- O = ( ( X \ ( ( cls ` J ) ` ( M ` j ) ) ) i^i
          ( ( 1st ` y ) ( ball ` D ) ( ( 2nd ` y ) / 2 ) ) ) $.
    $( Lemma for ~ bcth .  Relationship between a ball ` Q ` and the next ball
       ` P ` in sequence ` g ` , according to the generating function ` F ` 's
       value ` ( K F Q ) ` . $)
    bcthlem15 $p |- ( ( ( K e. NN /\ Q e. A ) /\ P e. ( K F Q ) ) ->
       ( ( ( 1st ` P ) e. X /\ ( ( 2nd ` P ) e. RR /\ 0 < ( 2nd ` P ) ) ) /\
  ( ( 2nd ` P ) < ( ( 2nd ` Q ) / 2 ) /\
  ( ( 1st ` P ) ( ball ` D ) ( 2nd ` P ) ) C_ ( ( X \ ( ( cls ` J ) `
  ( M ` K ) ) ) i^i ( ( 1st ` Q ) ( ball ` D ) ( ( 2nd ` Q ) / 2 ) ) ) ) ) ) $=
      cK cn wcel cQ cA wcel wa cP cK cQ cF co wcel wa cP vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa wa vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv
      vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd
      cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr copab wcel cP c1st cfv
      cX wcel cP c2nd cfv cr wcel cc0 cP c2nd cfv clt wbr wa wa cP c2nd cfv cQ
      c2nd cfv c2 cdiv co clt wbr cP c1st cfv cP c2nd cfv cD cbl cfv co cX cK
      cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv
      co cin wss wa wa cK cn wcel cQ cA wcel wa cP cK cQ cF co wcel cP vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv cQ c2nd cfv c2 cdiv co
      clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ
      c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr copab
      wcel cK cn wcel cQ cA wcel wa cK cQ cF co vp cv cX wcel vr cv cr wcel cc0
      vr cv clt wbr wa wa vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD
      cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2
      cdiv co cD cbl cfv co cin wss wa wa vp vr copab cP vj vy vz cK cQ cn cA
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab vp
      cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv cQ c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv
      cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr
      copab cF vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl
      cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin
      wss wa wa vp vr copab vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa
      vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM
      cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co
      cin wss wa wa vp vr copab cX cr cxp cX cr cX cD cdm cdm cvv bcthlem16.3
      cD cdm cD cms wcel cD cdm cvv wcel bcthlem16.1 cD cms dmexg ax-mp dmex
      eqeltri reex xpex vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr
      cv cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv
      cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin
      wss wa wa vp vr copab vp cv cX wcel vr cv cr wcel wa vr cv cQ c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv
      cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr
      copab cX cr cxp vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv
      cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ
      ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss
      wa wa vp cv cX wcel vr cv cr wcel wa vr cv cQ c2nd cfv c2 cdiv co clt wbr
      vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ
      c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr vp cv cX wcel vr cv
      cr wcel cc0 vr cv clt wbr wa wa vp cv cX wcel vr cv cr wcel wa vr cv cQ
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl
      cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa
      vp cv cX wcel vr cv cr wcel vp cv cX wcel vr cv cr wcel wa cc0 vr cv clt
      wbr vp cv cX wcel vr cv cr wcel wa id adantrr anim1i ssopab2i vr cv cQ
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl
      cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa
      vp vr cX cr opabssxp sstri ssexi vj cv cK wceq vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cO wss wa wa vp cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl
      cfv co cX cK cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2
      cdiv co cD cbl cfv co cin wss wa wa vp vr vj cv cK wceq vr cv vy cv c2nd
      cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa vr cv vy cv
      c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl
      cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin
      wss wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vj cv cK wceq
      vp cv vr cv cD cbl cfv co cO wss vp cv vr cv cD cbl cfv co cX cK cM cfv
      cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv
      co cin wss vr cv vy cv c2nd cfv c2 cdiv co clt wbr vj cv cK wceq cO cX cK
      cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD
      cbl cfv co cin vp cv vr cv cD cbl cfv co vj cv cK wceq cX vj cv cM cfv cJ
      ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co
      cin cX cK cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2
      cdiv co cD cbl cfv co cin cO vj cv cK wceq cX vj cv cM cfv cJ ccl cfv cfv
      cdif cX cK cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2
      cdiv co cD cbl cfv co vj cv cK wceq vj cv cM cfv cJ ccl cfv cfv cK cM cfv
      cJ ccl cfv cfv cX vj cv cK wceq vj cv cM cfv cK cM cfv cJ ccl cfv vj cv
      cK cM fveq2 fveq2d difeq2d ineq1d bcthlem16.8 syl5eq sseq2d anbi2d anbi2d
      opabbidv vy cv cQ wceq vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX
      cK cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD
      cbl cfv co cin wss wa wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      wa vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK
      cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv
      co cin wss wa wa vp vr vy cv cQ wceq vr cv vy cv c2nd cfv c2 cdiv co clt
      wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif vy cv c1st
      cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa vr cv cQ c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv
      cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vy cv cQ wceq vr cv vy cv c2nd
      cfv c2 cdiv co clt wbr vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv
      cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd
      cfv c2 cdiv co cD cbl cfv co cin wss vp cv vr cv cD cbl cfv co cX cK cM
      cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co
      cin wss vy cv cQ wceq vy cv c2nd cfv c2 cdiv co cQ c2nd cfv c2 cdiv co vr
      cv clt vy cv cQ wceq vy cv c2nd cfv cQ c2nd cfv c2 cdiv vy cv cQ c2nd
      fveq2 opreq1d breq2d vy cv cQ wceq cX cK cM cfv cJ ccl cfv cfv cdif vy cv
      c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin cX cK cM cfv cJ ccl
      cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin vp cv
      vr cv cD cbl cfv co vy cv cQ wceq vy cv c1st cfv vy cv c2nd cfv c2 cdiv
      co cD cbl cfv co cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cX cK
      cM cfv cJ ccl cfv cfv cdif vy cv cQ wceq vy cv c1st cfv cQ c1st cfv vy cv
      c2nd cfv c2 cdiv co cQ c2nd cfv c2 cdiv co cD cbl cfv vy cv cQ c1st fveq2
      vy cv cQ wceq vy cv c2nd cfv cQ c2nd cfv c2 cdiv vy cv cQ c2nd fveq2
      opreq1d opreq12d ineq2d sseq2d anbi12d anbi2d opabbidv bcthlem16.6
      oprabval2 eleq2d biimpa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      wa vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK
      cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv
      co cin wss wa wa cP c1st cfv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      wa vr cv cQ c2nd cfv c2 cdiv co clt wbr cP c1st cfv vr cv cD cbl cfv co
      cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD
      cbl cfv co cin wss wa wa cP c1st cfv cX wcel cP c2nd cfv cr wcel cc0 cP
      c2nd cfv clt wbr wa wa cP c2nd cfv cQ c2nd cfv c2 cdiv co clt wbr cP c1st
      cfv cP c2nd cfv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st
      cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr cP vp cv cP
      c1st cfv wceq vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa cP c1st
      cfv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv cQ c2nd cfv c2
      cdiv co clt wbr vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv
      cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa vr cv cQ
      c2nd cfv c2 cdiv co clt wbr cP c1st cfv vr cv cD cbl cfv co cX cK cM cfv
      cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin
      wss wa vp cv cP c1st cfv wceq vp cv cX wcel cP c1st cfv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vp cv cP c1st cfv cX eleq1 anbi1d vp cv cP c1st
      cfv wceq vp cv vr cv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ
      c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss cP c1st cfv vr cv
      cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2
      cdiv co cD cbl cfv co cin wss vr cv cQ c2nd cfv c2 cdiv co clt wbr vp cv
      cP c1st cfv wceq vp cv vr cv cD cbl cfv co cP c1st cfv vr cv cD cbl cfv
      co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD
      cbl cfv co cin vp cv cP c1st cfv vr cv cD cbl cfv opreq1 sseq1d anbi2d
      anbi12d vr cv cP c2nd cfv wceq cP c1st cfv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa wa cP c1st cfv cX wcel cP c2nd cfv cr wcel cc0 cP c2nd cfv
      clt wbr wa wa vr cv cQ c2nd cfv c2 cdiv co clt wbr cP c1st cfv vr cv cD
      cbl cfv co cX cK cM cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2
      cdiv co cD cbl cfv co cin wss wa cP c2nd cfv cQ c2nd cfv c2 cdiv co clt
      wbr cP c1st cfv cP c2nd cfv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv
      cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa vr cv cP
      c2nd cfv wceq vr cv cr wcel cc0 vr cv clt wbr wa cP c2nd cfv cr wcel cc0
      cP c2nd cfv clt wbr wa cP c1st cfv cX wcel vr cv cP c2nd cfv wceq vr cv
      cr wcel cP c2nd cfv cr wcel cc0 vr cv clt wbr cc0 cP c2nd cfv clt wbr vr
      cv cP c2nd cfv cr eleq1 vr cv cP c2nd cfv cc0 clt breq2 anbi12d anbi2d vr
      cv cP c2nd cfv wceq vr cv cQ c2nd cfv c2 cdiv co clt wbr cP c2nd cfv cQ
      c2nd cfv c2 cdiv co clt wbr cP c1st cfv vr cv cD cbl cfv co cX cK cM cfv
      cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin
      wss cP c1st cfv cP c2nd cfv cD cbl cfv co cX cK cM cfv cJ ccl cfv cfv
      cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co cin wss vr cv cP
      c2nd cfv cQ c2nd cfv c2 cdiv co clt breq1 vr cv cP c2nd cfv wceq cP c1st
      cfv vr cv cD cbl cfv co cP c1st cfv cP c2nd cfv cD cbl cfv co cX cK cM
      cfv cJ ccl cfv cfv cdif cQ c1st cfv cQ c2nd cfv c2 cdiv co cD cbl cfv co
      cin vr cv cP c2nd cfv cP c1st cfv cD cbl cfv opreq2 sseq1d anbi12d
      anbi12d elopabi syl $.
      $( [8-Nov-2007] $) $( [18-Oct-2007] $)

    $( Lemma for ~ bcth .  A ball in sequence ` g ` is included in the
       complement of the closure of reference sequence ` M ` . $)
    bcthlem16 $p |- ( ( ( g :  NN --> A /\ ( ( ( 1st ` ( g ` 1 ) )
    ( ball ` D ) ( 2nd ` ( g ` 1 ) ) ) C_ ( X \ ( ( cls ` J ) ` ( M ` 1 )
    ) ) /\ A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) /\
    m e. NN ) -> ( ( 1st ` ( g ` m ) ) ( ball ` D ) ( 2nd ` ( g ` m ) ) ) C_
    ( X \ ( ( cls ` J ) ` ( M ` m ) ) ) ) $=
      vm cv cn wcel cn cA vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv
      cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm
      cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co cX vm cv cM
      cfv cJ ccl cfv cfv cdif wss vm cv cn wcel cn cA vg cv wf c1 vg cv cfv
      c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv
      cdif wss vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv
      cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm cv cn wcel cn cA
      vg cv wf wa c1 vm cv clt wbr c1 vm cv wceq wo c1 vg cv cfv c1st cfv c1 vg
      cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co
      cX vm cv cM cfv cJ ccl cfv cfv cdif wss wi vm cv cn wcel c1 vm cv clt wbr
      c1 vm cv wceq wo cn cA vg cv wf vm cv cn wcel c1 vm cv cle wbr c1 vm cv
      clt wbr c1 vm cv wceq wo vm cv nnge1 c1 cr wcel vm cv cr wcel c1 vm cv
      cle wbr c1 vm cv clt wbr c1 vm cv wceq wo wb vm cv cn wcel c1 vm cv leloe
      1re vm cv nnre sylancr mpbid adantr vm cv cn wcel cn cA vg cv wf wa c1 vm
      cv clt wbr c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv vg cv cfv c1st
      cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv
      cdif wss wi c1 vm cv wceq vm cv cn wcel cn cA vg cv wf wa c1 vm cv clt
      wbr wa vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD
      cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss c1 vg cv cfv c1st cfv
      c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss
      vm cv cn wcel cn cA vg cv wf wa c1 vm cv clt wbr wa vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral vm cv c1
      cmin co c1 caddc co vg cv cfv vm cv c1 cmin co c1 caddc co vm cv c1 cmin
      co vg cv cfv cF co wcel vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv
      cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm cv cn wcel c1 vm
      cv clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral vm cv c1 cmin co c1 caddc co vg cv cfv vm cv c1
      cmin co c1 caddc co vm cv c1 cmin co vg cv cfv cF co wcel wi cn cA vg cv
      wf vm cv cn wcel c1 vm cv clt wbr wa vm cv c1 cmin co cn wcel vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral vm cv c1 cmin co c1 caddc co vg cv cfv vm cv c1 cmin co c1 caddc co
      vm cv c1 cmin co vg cv cfv cF co wcel wi vm cv cn wcel c1 vm cv clt wbr
      vm cv c1 cmin co cn wcel c1 cn wcel vm cv cn wcel c1 vm cv clt wbr vm cv
      c1 cmin co cn wcel wb 1nn c1 vm cv nnsub mpan biimpa vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vm cv c1 cmin co c1
      caddc co vg cv cfv vm cv c1 cmin co c1 caddc co vm cv c1 cmin co vg cv
      cfv cF co wcel vk vm cv c1 cmin co cn vk cv vm cv c1 cmin co wceq vk cv
      c1 caddc co vg cv cfv vm cv c1 cmin co c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co vm cv c1 cmin co c1 caddc co vm cv c1 cmin
      co vg cv cfv cF co vk cv vm cv c1 cmin co wceq vk cv c1 caddc co vm cv c1
      cmin co c1 caddc co vg cv vk cv vm cv c1 cmin co c1 caddc opreq1 fveq2d
      vk cv vm cv c1 cmin co wceq vk cv c1 caddc co vm cv c1 cmin co c1 caddc
      co vk cv vg cv cfv vm cv c1 cmin co vg cv cfv cF vk cv vm cv c1 cmin co
      c1 caddc opreq1 vk cv vm cv c1 cmin co vg cv fveq2 opreq12d eleq12d
      rcla4v syl adantlr vm cv cn wcel cn cA vg cv wf wa c1 vm cv clt wbr wa vm
      cv c1 cmin co c1 caddc co vg cv cfv vm cv c1 cmin co c1 caddc co vm cv c1
      cmin co vg cv cfv cF co wcel vm cv vg cv cfv vm cv vm cv c1 cmin co vg cv
      cfv cF co wcel vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl
      cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm cv cn wcel vm cv c1
      cmin co c1 caddc co vg cv cfv vm cv c1 cmin co c1 caddc co vm cv c1 cmin
      co vg cv cfv cF co wcel vm cv vg cv cfv vm cv vm cv c1 cmin co vg cv cfv
      cF co wcel wb cn cA vg cv wf c1 vm cv clt wbr vm cv cn wcel vm cv cc wcel
      vm cv c1 cmin co c1 caddc co vg cv cfv vm cv c1 cmin co c1 caddc co vm cv
      c1 cmin co vg cv cfv cF co wcel vm cv vg cv cfv vm cv vm cv c1 cmin co vg
      cv cfv cF co wcel wb vm cv nncn vm cv cc wcel vm cv c1 cmin co c1 caddc
      co vg cv cfv vm cv vg cv cfv vm cv c1 cmin co c1 caddc co vm cv c1 cmin
      co vg cv cfv cF co vm cv vm cv c1 cmin co vg cv cfv cF co vm cv cc wcel
      vm cv c1 cmin co c1 caddc co vm cv vg cv vm cv cc wcel c1 cc wcel vm cv
      c1 cmin co c1 caddc co vm cv wceq ax1cn vm cv c1 npcan mpan2 fveq2d vm cv
      cc wcel vm cv c1 cmin co c1 caddc co vm cv vm cv c1 cmin co vg cv cfv cF
      vm cv cc wcel c1 cc wcel vm cv c1 cmin co c1 caddc co vm cv wceq ax1cn vm
      cv c1 npcan mpan2 opreq1d eleq12d syl ad2antrr vm cv cn wcel cn cA vg cv
      wf wa c1 vm cv clt wbr wa vm cv vg cv cfv vm cv vm cv c1 cmin co vg cv
      cfv cF co wcel vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl
      cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm cv cn wcel vm cv c1
      cmin co vg cv cfv cA wcel wa vm cv vg cv cfv vm cv vm cv c1 cmin co vg cv
      cfv cF co wcel vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl
      cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm cv cn wcel cn cA vg cv
      wf wa c1 vm cv clt wbr wa vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd
      cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif vm cv c1 cmin co vg
      cv cfv c1st cfv vm cv c1 cmin co vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv
      co cin wss cX vm cv cM cfv cJ ccl cfv cfv cdif vm cv c1 cmin co vg cv cfv
      c1st cfv vm cv c1 cmin co vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co cin
      cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vm
      cv cn wcel vm cv c1 cmin co vg cv cfv cA wcel wa vm cv vg cv cfv vm cv vm
      cv c1 cmin co vg cv cfv cF co wcel wa vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif vm cv
      c1 cmin co vg cv cfv c1st cfv vm cv c1 cmin co vg cv cfv c2nd cfv c2 cdiv
      co cD cbl cfv co cin cX vm cv cM cfv cJ ccl cfv cfv cdif sstr vm cv cn
      wcel vm cv c1 cmin co vg cv cfv cA wcel wa vm cv vg cv cfv vm cv vm cv c1
      cmin co vg cv cfv cF co wcel wa vm cv vg cv cfv c2nd cfv vm cv c1 cmin co
      vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif vm cv
      c1 cmin co vg cv cfv c1st cfv vm cv c1 cmin co vg cv cfv c2nd cfv c2 cdiv
      co cD cbl cfv co cin wss vm cv cn wcel vm cv c1 cmin co vg cv cfv cA wcel
      wa vm cv vg cv cfv vm cv vm cv c1 cmin co vg cv cfv cF co wcel wa vm cv
      vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg
      cv cfv c2nd cfv clt wbr wa wa vm cv vg cv cfv c2nd cfv vm cv c1 cmin co
      vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif vm cv
      c1 cmin co vg cv cfv c1st cfv vm cv c1 cmin co vg cv cfv c2nd cfv c2 cdiv
      co cD cbl cfv co cin wss wa vy vz cA cD vm cv vg cv cfv vm cv c1 cmin co
      vg cv cfv vj cF cJ vm cv cM cO cX vr vp bcthlem16.1 bcthlem16.3
      bcthlem16.6 bcthlem16.8 bcthlem15 pm3.27d pm3.27d cX vm cv cM cfv cJ ccl
      cfv cfv cdif vm cv c1 cmin co vg cv cfv c1st cfv vm cv c1 cmin co vg cv
      cfv c2nd cfv c2 cdiv co cD cbl cfv co inss1 sylancl vm cv cn wcel cn cA
      vg cv wf wa c1 vm cv clt wbr wa vm cv cn wcel vm cv c1 cmin co vg cv cfv
      cA wcel vm cv cn wcel cn cA vg cv wf c1 vm cv clt wbr simpll vm cv cn
      wcel cn cA vg cv wf c1 vm cv clt wbr vm cv c1 cmin co vg cv cfv cA wcel
      cn cA vg cv wf vm cv cn wcel c1 vm cv clt wbr vm cv c1 cmin co vg cv cfv
      cA wcel wi cn cA vg cv wf vm cv cn wcel c1 vm cv clt wbr vm cv c1 cmin co
      vg cv cfv cA wcel cn cA vg cv wf vm cv c1 cmin co cn wcel vm cv c1 cmin
      co vg cv cfv cA wcel vm cv cn wcel c1 vm cv clt wbr wa cn cA vm cv c1
      cmin co vg cv ffvelrn vm cv cn wcel c1 vm cv clt wbr vm cv c1 cmin co cn
      wcel c1 cn wcel vm cv cn wcel c1 vm cv clt wbr vm cv c1 cmin co cn wcel
      wb 1nn c1 vm cv nnsub mpan biimpa sylan2 exp32 com12 imp31 jca sylan ex
      sylbid syld adantld vm cv cn wcel cn cA vg cv wf wa c1 vm cv wceq wa c1
      vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ
      ccl cfv cfv cdif wss vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD
      cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral c1 vm cv
      wceq c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM
      cfv cJ ccl cfv cfv cdif wss vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd
      cfv cD cbl cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss wi vm cv cn
      wcel cn cA vg cv wf wa c1 vm cv wceq c1 vg cv cfv c1st cfv c1 vg cv cfv
      c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vm cv vg cv
      cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ
      ccl cfv cfv cdif wss c1 vm cv wceq c1 vg cv cfv c1st cfv c1 vg cv cfv
      c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv
      cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif cX vm cv cM cfv cJ ccl cfv
      cfv cdif c1 vm cv wceq c1 vg cv cfv c1st cfv vm cv vg cv cfv c1st cfv c1
      vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv cD cbl cfv c1 vm cv wceq c1
      vg cv cfv vm cv vg cv cfv c1st c1 vm cv vg cv fveq2 fveq2d c1 vm cv wceq
      c1 vg cv cfv vm cv vg cv cfv c2nd c1 vm cv vg cv fveq2 fveq2d opreq12d c1
      vm cv wceq c1 cM cfv cJ ccl cfv cfv vm cv cM cfv cJ ccl cfv cfv cX c1 vm
      cv wceq c1 cM cfv vm cv cM cfv cJ ccl cfv c1 vm cv cM fveq2 fveq2d
      difeq2d sseq12d biimpd adantl adantrd jaodan mpdan expimpd impcom $.
      $( [11-Nov-2007] $) $( [25-Oct-2007] $)
  $}

  ${
    $d j m n q s w y z A $.  $d j m n p q r s w y z D $.  $d k m n q s w F $.
    $d j p r y z J $.  $d j p r y z M $.  $d z O $.  $d j m n p q r w y z X $.
    $d j k m n p q r s w x y z g $.
    bcthlem18.1 $e |- D e. CMet $.
    bcthlem18.3 $e |- X = dom dom D $.
    bcthlem18.6 $e |- F = { <. <. j , y >. , z >. | ( ( j e. NN /\ y e. A )
  /\ z = { <. p , r >. | ( ( p e. X /\ ( r e. RR /\ 0 < r ) ) /\
     ( r < ( ( 2nd ` y ) / 2 ) /\ ( p ( ball ` D ) r ) C_ O ) ) } ) } $.
    bcthlem18.7 $e |- A = ( X X. { x e. RR | 0 < x } ) $.
    bcthlem18.8 $e |- O = ( ( X \ ( ( cls ` J ) ` ( M ` j ) ) ) i^i
          ( ( 1st ` y ) ( ball ` D ) ( ( 2nd ` y ) / 2 ) ) ) $.
    $( Lemma for ~ bcth .  The radius of the balls in sequence ` g ` decreases
       exponentially. $)
    bcthlem17 $p |- ( n e. NN ->
    ( ( g : NN --> A /\ ( ( 2nd ` ( g ` 1 ) ) < ( 1 / 2 ) /\
      A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) ->
           ( 2nd ` ( g ` n ) ) < ( 1 / ( 2 ^ n ) ) ) ) $=
      cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      wa vq cv vg cv cfv c2nd cfv c1 c2 vq cv cexp co cdiv co clt wbr wi cn cA
      vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa c1
      vg cv cfv c2nd cfv c1 c2 c1 cexp co cdiv co clt wbr wi cn cA vg cv wf c1
      vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv vg cv
      cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr wi cn cA vg cv wf c1 vg
      cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv c1 caddc co
      vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi cn
      cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vn cv vg cv cfv c2nd cfv c1 c2 vn cv cexp co cdiv co clt wbr wi vq vm vn
      cv vm cv cn wcel cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt
      wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv
      co clt wbr vm cv c1 caddc co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co
      cexp co cdiv co clt wbr vm cv cn wcel cn cA vg cv wf vm cv c1 caddc co vg
      cv cfv vm cv c1 caddc co vm cv vg cv cfv cF co wcel vm cv vg cv cfv c2nd
      cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv c1 caddc co vg cv cfv c2nd
      cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi c1 vg cv cfv c2nd
      cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel cn cA vg cv wf vm
      cv c1 caddc co vg cv cfv vm cv c1 caddc co vm cv vg cv cfv cF co wcel vm
      cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv c1 caddc
      co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi
      vm cv cn wcel cn cA vg cv wf wa vm cv c1 caddc co vg cv cfv vm cv c1
      caddc co vm cv vg cv cfv cF co wcel vm cv c1 caddc co vg cv cfv c1st cfv
      cX wcel vm cv c1 caddc co vg cv cfv c2nd cfv cr wcel cc0 vm cv c1 caddc
      co vg cv cfv c2nd cfv clt wbr wa wa vm cv c1 caddc co vg cv cfv c2nd cfv
      vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv c1 caddc co vg cv cfv
      c1st cfv vm cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co cX vm cv c1
      caddc co cM cfv cJ ccl cfv cfv cdif vm cv vg cv cfv c1st cfv vm cv vg cv
      cfv c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vm cv vg cv cfv c2nd
      cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv c1 caddc co vg cv cfv c2nd
      cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi vm cv cn wcel cn
      cA vg cv wf wa vm cv c1 caddc co vg cv cfv vm cv c1 caddc co vm cv vg cv
      cfv cF co wcel vm cv c1 caddc co vg cv cfv c1st cfv cX wcel vm cv c1
      caddc co vg cv cfv c2nd cfv cr wcel cc0 vm cv c1 caddc co vg cv cfv c2nd
      cfv clt wbr wa wa vm cv c1 caddc co vg cv cfv c2nd cfv vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr vm cv c1 caddc co vg cv cfv c1st cfv vm cv c1
      caddc co vg cv cfv c2nd cfv cD cbl cfv co cX vm cv c1 caddc co cM cfv cJ
      ccl cfv cfv cdif vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co cin wss wa wa vm cv c1 caddc co cn wcel vm cv vg cv
      cfv cA wcel wa vm cv c1 caddc co vg cv cfv vm cv c1 caddc co vm cv vg cv
      cfv cF co wcel vm cv c1 caddc co vg cv cfv c1st cfv cX wcel vm cv c1
      caddc co vg cv cfv c2nd cfv cr wcel cc0 vm cv c1 caddc co vg cv cfv c2nd
      cfv clt wbr wa wa vm cv c1 caddc co vg cv cfv c2nd cfv vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr vm cv c1 caddc co vg cv cfv c1st cfv vm cv c1
      caddc co vg cv cfv c2nd cfv cD cbl cfv co cX vm cv c1 caddc co cM cfv cJ
      ccl cfv cfv cdif vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co cin wss wa wa vm cv cn wcel cn cA vg cv wf wa vy vz
      cA cD vm cv c1 caddc co vg cv cfv vm cv vg cv cfv vj cF cJ vm cv c1 caddc
      co cM cO cX vr vp bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.8
      bcthlem15 vm cv cn wcel cn cA vg cv wf wa vm cv c1 caddc co cn wcel vm cv
      vg cv cfv cA wcel vm cv cn wcel vm cv c1 caddc co cn wcel cn cA vg cv wf
      vm cv peano2nn adantr cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv cA
      wcel cn cA vm cv vg cv ffvelrn ancoms jca sylan ex vm cv cn wcel cn cA vg
      cv wf wa vm cv c1 caddc co vg cv cfv c1st cfv cX wcel vm cv c1 caddc co
      vg cv cfv c2nd cfv cr wcel cc0 vm cv c1 caddc co vg cv cfv c2nd cfv clt
      wbr wa wa vm cv c1 caddc co vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv
      c2 cdiv co clt wbr vm cv c1 caddc co vg cv cfv c1st cfv vm cv c1 caddc co
      vg cv cfv c2nd cfv cD cbl cfv co cX vm cv c1 caddc co cM cfv cJ ccl cfv
      cfv cdif vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co cin wss wa wa vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co
      cdiv co clt wbr vm cv c1 caddc co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc
      co cexp co cdiv co clt wbr wi vm cv cn wcel cn cA vg cv wf wa vm cv c1
      caddc co vg cv cfv c1st cfv cX wcel vm cv c1 caddc co vg cv cfv c2nd cfv
      cr wcel cc0 vm cv c1 caddc co vg cv cfv c2nd cfv clt wbr wa wa vm cv c1
      caddc co vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr
      vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv c1
      caddc co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt
      wbr wi vm cv c1 caddc co vg cv cfv c1st cfv vm cv c1 caddc co vg cv cfv
      c2nd cfv cD cbl cfv co cX vm cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vm
      cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co
      cin wss vm cv cn wcel cn cA vg cv wf wa vm cv c1 caddc co vg cv cfv c2nd
      cfv cr wcel cc0 vm cv c1 caddc co vg cv cfv c2nd cfv clt wbr wa vm cv c1
      caddc co vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr
      vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv c1
      caddc co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt
      wbr wi vm cv c1 caddc co vg cv cfv c1st cfv cX wcel vm cv cn wcel cn cA
      vg cv wf wa vm cv c1 caddc co vg cv cfv c2nd cfv cr wcel vm cv c1 caddc
      co vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv
      vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv c1 caddc co
      vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co cdiv co clt wbr wi cc0
      vm cv c1 caddc co vg cv cfv c2nd cfv clt wbr vm cv cn wcel vm cv vg cv
      cfv c2nd cfv cr wcel wa vm cv c1 caddc co vg cv cfv c2nd cfv cr wcel vm
      cv c1 caddc co vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv c2 cdiv co clt
      wbr wa vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv
      c1 caddc co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co cdiv co
      clt wbr wi vm cv cn wcel cn cA vg cv wf wa vm vm cv vg cv cfv c2nd cfv vm
      cv c1 caddc co vg cv cfv c2nd cfv bcthlem1 vm cv cn wcel cn cA vg cv wf
      wa vm cv cn wcel vm cv vg cv cfv c2nd cfv cr wcel vm cv cn wcel cn cA vg
      cv wf pm3.26 cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c2nd cfv cr
      wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0
      vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg
      cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv
      cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d
      pm3.26d ancoms jca sylan adantrlr adantrll adantrrr ex syld expimpd vm cv
      cn wcel vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral vm cv c1 caddc co vg cv cfv vm cv c1 caddc co vm cv vg
      cv cfv cF co wcel c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vm cv c1
      caddc co vg cv cfv vm cv c1 caddc co vm cv vg cv cfv cF co wcel vk vm cv
      cn vk cv vm cv wceq vk cv c1 caddc co vg cv cfv vm cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co vm cv c1 caddc co vm cv vg cv
      cfv cF co vk cv vm cv wceq vk cv c1 caddc co vm cv c1 caddc co vg cv vk
      cv vm cv c1 caddc opreq1 fveq2d vk cv vm cv wceq vk cv c1 caddc co vm cv
      c1 caddc co vk cv vg cv cfv vm cv vg cv cfv cF vk cv vm cv c1 caddc
      opreq1 vk cv vm cv vg cv fveq2 opreq12d eleq12d rcla4v adantld sylan2d
      a2d c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr c1 vg cv cfv c2nd cfv c1
      c2 c1 cexp co cdiv co clt wbr cn cA vg cv wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral c1 vg cv cfv c2nd
      cfv c1 c2 c1 cexp co cdiv co clt wbr c1 vg cv cfv c2nd cfv c1 c2 cdiv co
      clt wbr c1 c2 c1 cexp co cdiv co c1 c2 cdiv co c1 vg cv cfv c2nd cfv clt
      c2 c1 cexp co c2 c1 cdiv c2 cc wcel c2 c1 cexp co c2 wceq 2cn c2 exp1
      ax-mp opreq2i breq2i biimpri ad2antrl vq cv c1 wceq vq cv vg cv cfv c2nd
      cfv c1 c2 vq cv cexp co cdiv co clt wbr c1 vg cv cfv c2nd cfv c1 c2 c1
      cexp co cdiv co clt wbr cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv
      co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa wa vq cv c1 wceq vq cv vg cv cfv c2nd cfv c1 vg
      cv cfv c2nd cfv c1 c2 vq cv cexp co cdiv co c1 c2 c1 cexp co cdiv co clt
      vq cv c1 wceq vq cv vg cv cfv c1 vg cv cfv c2nd vq cv c1 vg cv fveq2
      fveq2d vq cv c1 wceq c2 vq cv cexp co c2 c1 cexp co c1 cdiv vq cv c1 c2
      cexp opreq2 opreq2d breq12d imbi2d vq cv vm cv wceq vq cv vg cv cfv c2nd
      cfv c1 c2 vq cv cexp co cdiv co clt wbr vm cv vg cv cfv c2nd cfv c1 c2 vm
      cv cexp co cdiv co clt wbr cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2
      cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa wa vq cv vm cv wceq vq cv vg cv cfv c2nd cfv
      vm cv vg cv cfv c2nd cfv c1 c2 vq cv cexp co cdiv co c1 c2 vm cv cexp co
      cdiv co clt vq cv vm cv wceq vq cv vg cv cfv vm cv vg cv cfv c2nd vq cv
      vm cv vg cv fveq2 fveq2d vq cv vm cv wceq c2 vq cv cexp co c2 vm cv cexp
      co c1 cdiv vq cv vm cv c2 cexp opreq2 opreq2d breq12d imbi2d vq cv vm cv
      c1 caddc co wceq vq cv vg cv cfv c2nd cfv c1 c2 vq cv cexp co cdiv co clt
      wbr vm cv c1 caddc co vg cv cfv c2nd cfv c1 c2 vm cv c1 caddc co cexp co
      cdiv co clt wbr cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt
      wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa vq cv vm cv c1 caddc co wceq vq cv vg cv cfv c2nd
      cfv vm cv c1 caddc co vg cv cfv c2nd cfv c1 c2 vq cv cexp co cdiv co c1
      c2 vm cv c1 caddc co cexp co cdiv co clt vq cv vm cv c1 caddc co wceq vq
      cv vg cv cfv vm cv c1 caddc co vg cv cfv c2nd vq cv vm cv c1 caddc co vg
      cv fveq2 fveq2d vq cv vm cv c1 caddc co wceq c2 vq cv cexp co c2 vm cv c1
      caddc co cexp co c1 cdiv vq cv vm cv c1 caddc co c2 cexp opreq2 opreq2d
      breq12d imbi2d vq cv vn cv wceq vq cv vg cv cfv c2nd cfv c1 c2 vq cv cexp
      co cdiv co clt wbr vn cv vg cv cfv c2nd cfv c1 c2 vn cv cexp co cdiv co
      clt wbr cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vq cv vn cv wceq vq cv vg cv cfv c2nd cfv vn cv vg cv cfv c2nd
      cfv c1 c2 vq cv cexp co cdiv co c1 c2 vn cv cexp co cdiv co clt vq cv vn
      cv wceq vq cv vg cv cfv vn cv vg cv cfv c2nd vq cv vn cv vg cv fveq2
      fveq2d vq cv vn cv wceq c2 vq cv cexp co c2 vn cv cexp co c1 cdiv vq cv
      vn cv c2 cexp opreq2 opreq2d breq12d imbi2d nnindALT $.
      $( [10-Nov-2007] $) $( [21-Oct-2007] $)

    $( Lemma for ~ bcth .  Sequence ` g ` represents a series of nested
       balls. $)
    bcthlem18 $p |- ( n e. NN -> ( ( ( g : NN --> A /\ A. k e. NN
    ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) /\ m e. NN ) -> ( m < n
  -> ( ( 1st ` ( g ` n ) ) ( ball ` D ) ( 2nd ` ( g ` n ) ) ) C_ ( ( 1st ` (
           g ` m ) ) ( ball ` D ) ( ( 2nd ` ( g ` m ) ) / 2 ) ) ) ) ) $=
      cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa vm cv cn wcel wa vm cv vs cv clt wbr vs cv
      vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi wi cn
      cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa vm cv cn wcel wa vm cv c1 clt wbr c1 vg cv cfv
      c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm
      cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi wi cn cA vg cv wf
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral wa vm cv cn wcel wa vm cv vq cv clt wbr vq cv vg cv cfv c1st
      cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv
      vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi wi cn cA vg cv wf vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa vm cv cn wcel wa vm cv vq cv c1 caddc co clt wbr vq cv c1
      caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wss wi wi cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa vm cv
      vn cv clt wbr vn cv vg cv cfv c1st cfv vn cv vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wss wi wi vs vq vn cv vq cv cn wcel cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa vm cv vq cv clt wbr vq cv vg cv cfv c1st cfv vq
      cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv
      cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vm cv vq cv c1 caddc co clt
      wbr vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd
      cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co wss wi vq cv cn wcel cn cA vg cv wf vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      vm cv cn wcel wa vm cv vq cv clt wbr vq cv vg cv cfv c1st cfv vq cv vg cv
      cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd
      cfv c2 cdiv co cD cbl cfv co wss wi vm cv vq cv c1 caddc co clt wbr vq cv
      c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD
      cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co wss wi wi vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv
      cn wcel wa wa vm cv vq cv c1 caddc co clt wbr vm cv vq cv clt wbr vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vq cv
      c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD
      cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co wss vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn
      wcel wa wa vm cv vq cv c1 caddc co clt wbr vm cv vq cv clt wbr vm cv vq
      cv wceq wo vm cv vq cv clt wbr vq cv vg cv cfv c1st cfv vq cv vg cv cfv
      c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv
      c2 cdiv co cD cbl cfv co wss wi vq cv c1 caddc co vg cv cfv c1st cfv vq
      cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv
      vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vq cv cn wcel vm
      cv cn wcel vm cv vq cv clt wbr vm cv vq cv wceq wo vm cv vq cv c1 caddc
      co clt wbr wb cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel vq cv cn wcel
      vm cv vq cv clt wbr vm cv vq cv wceq wo vm cv vq cv c1 caddc co clt wbr
      wb vm cv cn wcel vq cv cn wcel wa vm cv vq cv cle wbr vm cv vq cv clt wbr
      vm cv vq cv wceq wo vm cv vq cv c1 caddc co clt wbr vm cv cr wcel vq cv
      cr wcel vm cv vq cv cle wbr vm cv vq cv clt wbr vm cv vq cv wceq wo wb vm
      cv cn wcel vq cv cn wcel vm cv vq cv leloe vm cv nnre vq cv nnre syl2an
      vm cv vq cv nnleltp1 bitr3d ancoms adantrl vq cv cn wcel cn cA vg cv wf
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral wa vm cv cn wcel wa wa vm cv vq cv clt wbr vm cv vq cv clt wbr
      vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg
      cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi
      vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv
      cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv
      co cD cbl cfv co wss wi vm cv vq cv wceq vq cv cn wcel cn cA vg cv wf vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa vm cv vq cv clt wbr vm cv vq cv clt wbr vq cv vg cv cfv c1st
      cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv
      vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vq cv c1 caddc co vg
      cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm cv
      vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss
      wi wi vm cv cn wcel vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv
      vq cv clt wbr vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wss wi vm cv vq cv clt wbr vq cv c1 caddc co vg cv cfv c1st
      cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vq cv cn
      wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral wa wa vq cv vg cv cfv c1st cfv vq cv vg
      cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv
      c2nd cfv c2 cdiv co cD cbl cfv co wss vq cv c1 caddc co vg cv cfv c1st
      cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vm cv vq
      cv clt wbr vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vq cv c1 caddc co
      vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vq
      cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co wss vq cv vg
      cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vq cv c1
      caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wss wi vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vq cv
      c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD
      cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq cv vg cv
      cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co cin vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vq cv c1 caddc
      co cn wcel vq cv vg cv cfv cA wcel wa vq cv c1 caddc co vg cv cfv vq cv
      c1 caddc co vq cv vg cv cfv cF co wcel vq cv c1 caddc co vg cv cfv c1st
      cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co cX vq cv c1 caddc
      co cM cfv cJ ccl cfv cfv cdif vq cv vg cv cfv c1st cfv vq cv vg cv cfv
      c2nd cfv c2 cdiv co cD cbl cfv co cin wss vq cv cn wcel cn cA vg cv wf vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa vq cv c1 caddc co cn wcel vq cv vg cv cfv cA wcel wa vq cv
      c1 caddc co vg cv cfv vq cv c1 caddc co vq cv vg cv cfv cF co wcel wa vq
      cv c1 caddc co vg cv cfv c2nd cfv vq cv vg cv cfv c2nd cfv c2 cdiv co clt
      wbr vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd
      cfv cD cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co cin
      wss vq cv c1 caddc co cn wcel vq cv vg cv cfv cA wcel wa vq cv c1 caddc
      co vg cv cfv vq cv c1 caddc co vq cv vg cv cfv cF co wcel wa vq cv c1
      caddc co vg cv cfv c1st cfv cX wcel vq cv c1 caddc co vg cv cfv c2nd cfv
      cr wcel cc0 vq cv c1 caddc co vg cv cfv c2nd cfv clt wbr wa wa vq cv c1
      caddc co vg cv cfv c2nd cfv vq cv vg cv cfv c2nd cfv c2 cdiv co clt wbr
      vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv
      cD cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq cv vg cv
      cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa
      vy vz cA cD vq cv c1 caddc co vg cv cfv vq cv vg cv cfv vj cF cJ vq cv c1
      caddc co cM cO cX vr vp bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.8
      bcthlem15 pm3.27d pm3.27d vq cv cn wcel cn cA vg cv wf vq cv c1 caddc co
      cn wcel vq cv vg cv cfv cA wcel wa vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral vq cv cn wcel cn cA vg cv
      wf wa vq cv c1 caddc co cn wcel vq cv vg cv cfv cA wcel vq cv cn wcel vq
      cv c1 caddc co cn wcel cn cA vg cv wf vq cv peano2nn adantr cn cA vg cv
      wf vq cv cn wcel vq cv vg cv cfv cA wcel cn cA vq cv vg cv ffvelrn ancoms
      jca adantrr vq cv cn wcel vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral vq cv c1 caddc co vg cv cfv vq cv
      c1 caddc co vq cv vg cv cfv cF co wcel cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vq cv c1 caddc co
      vg cv cfv vq cv c1 caddc co vq cv vg cv cfv cF co wcel vk vq cv cn vk cv
      vq cv wceq vk cv c1 caddc co vg cv cfv vq cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co vq cv c1 caddc co vq cv vg cv cfv cF co
      vk cv vq cv wceq vk cv c1 caddc co vq cv c1 caddc co vg cv vk cv vq cv c1
      caddc opreq1 fveq2d vk cv vq cv wceq vk cv c1 caddc co vq cv c1 caddc co
      vk cv vg cv cfv vq cv vg cv cfv cF vk cv vq cv c1 caddc opreq1 vk cv vq
      cv vg cv fveq2 opreq12d eleq12d rcla4va adantrl sylanc vq cv cn wcel cn
      cA vg cv wf cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq cv vg cv
      cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co cin vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co wss vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral vq cv cn wcel cn cA vg cv wf wa cX vq cv c1 caddc co cM cfv cJ ccl
      cfv cfv cdif vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co cin vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv
      cD cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq cv vg cv
      cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co cin vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss
      vq cv cn wcel cn cA vg cv wf wa cX vq cv c1 caddc co cM cfv cJ ccl cfv
      cfv cdif vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co inss2 a1i cn cA vg cv wf vq cv cn wcel vq cv vg cv cfv c1st
      cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co vq cv vg cv cfv
      c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co wss cD cme wcel vq cv vg
      cv cfv c1st cfv cX wcel wa vq cv vg cv cfv c2nd cfv c2 cdiv co cr wcel
      cc0 vq cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vq cv vg cv cfv c2nd
      cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr wa w3a vq cv vg cv cfv
      c2nd cfv c2 cdiv co vq cv vg cv cfv c2nd cfv cle wbr vq cv vg cv cfv c1st
      cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co vq cv vg cv cfv
      c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co wss cn cA vg cv wf vq cv
      cn wcel wa cD vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv
      co vq cv vg cv cfv c2nd cfv cX bcthlem18.3 ssbl cn cA vg cv wf vq cv cn
      wcel wa cD cme wcel vq cv vg cv cfv c1st cfv cX wcel wa vq cv vg cv cfv
      c2nd cfv c2 cdiv co cr wcel cc0 vq cv vg cv cfv c2nd cfv c2 cdiv co clt
      wbr wa vq cv vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt
      wbr wa cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c1st cfv cX wcel
      cD cme wcel cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c1st cfv cX
      wcel vq cv vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt
      wbr wa vx cA vg vq cv cX bcthlem18.7 bcthlem4 pm3.26d cD bcthlem18.1
      cmsmeti jctil cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c2nd cfv c2
      cdiv co cr wcel cc0 vq cv vg cv cfv c2nd cfv c2 cdiv co clt wbr cn cA vg
      cv wf vq cv cn wcel wa vq cv vg cv cfv c2nd cfv cr wcel vq cv vg cv cfv
      c2nd cfv c2 cdiv co cr wcel cn cA vg cv wf vq cv cn wcel wa vq cv vg cv
      cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf
      vq cv cn wcel wa vq cv vg cv cfv c1st cfv cX wcel vq cv vg cv cfv c2nd
      cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vq cv cX
      bcthlem18.7 bcthlem4 pm3.27d pm3.26d vq cv vg cv cfv c2nd cfv rehalfcl
      syl cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c2nd cfv cr wcel cc0
      vq cv vg cv cfv c2nd cfv clt wbr wa cc0 vq cv vg cv cfv c2nd cfv c2 cdiv
      co clt wbr cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c1st cfv cX
      wcel vq cv vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt
      wbr wa vx cA vg vq cv cX bcthlem18.7 bcthlem4 pm3.27d vq cv vg cv cfv
      c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr cc0 vq cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr vq cv vg cv cfv c2nd cfv halfpos2 biimpa syl
      jca cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c1st cfv cX wcel vq
      cv vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr wa vx
      cA vg vq cv cX bcthlem18.7 bcthlem4 pm3.27d 3jca cn cA vg cv wf vq cv cn
      wcel wa vq cv vg cv cfv c2nd cfv c2 cdiv co vq cv vg cv cfv c2nd cfv clt
      wbr vq cv vg cv cfv c2nd cfv c2 cdiv co vq cv vg cv cfv c2nd cfv cle wbr
      cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c2nd cfv cr wcel cc0 vq
      cv vg cv cfv c2nd cfv clt wbr wa vq cv vg cv cfv c2nd cfv c2 cdiv co vq
      cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vq cv cn wcel wa vq cv vg cv
      cfv c1st cfv cX wcel vq cv vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv
      c2nd cfv clt wbr wa vx cA vg vq cv cX bcthlem18.7 bcthlem4 pm3.27d vq cv
      vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr vq cv vg
      cv cfv c2nd cfv c2 cdiv co vq cv vg cv cfv c2nd cfv clt wbr vq cv vg cv
      cfv c2nd cfv halfpos biimpa syl vq cv vg cv cfv c2nd cfv c2 cdiv co cr
      wcel vq cv vg cv cfv c2nd cfv cr wcel vq cv vg cv cfv c2nd cfv c2 cdiv co
      vq cv vg cv cfv c2nd cfv clt wbr vq cv vg cv cfv c2nd cfv c2 cdiv co vq
      cv vg cv cfv c2nd cfv cle wbr wi cn cA vg cv wf vq cv cn wcel wa vq cv vg
      cv cfv c2nd cfv c2 cdiv co vq cv vg cv cfv c2nd cfv ltle cn cA vg cv wf
      vq cv cn wcel wa vq cv vg cv cfv c2nd cfv cr wcel vq cv vg cv cfv c2nd
      cfv c2 cdiv co cr wcel cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv
      c2nd cfv cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vq
      cv cn wcel wa vq cv vg cv cfv c1st cfv cX wcel vq cv vg cv cfv c2nd cfv
      cr wcel cc0 vq cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vq cv cX
      bcthlem18.7 bcthlem4 pm3.27d pm3.26d vq cv vg cv cfv c2nd cfv rehalfcl
      syl cn cA vg cv wf vq cv cn wcel wa vq cv vg cv cfv c2nd cfv cr wcel cc0
      vq cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vq cv cn wcel wa vq cv vg
      cv cfv c1st cfv cX wcel vq cv vg cv cfv c2nd cfv cr wcel cc0 vq cv vg cv
      cfv c2nd cfv clt wbr wa vx cA vg vq cv cX bcthlem18.7 bcthlem4 pm3.27d
      pm3.26d sylanc mpd sylanc ancoms sstrd adantrr sstrd vq cv c1 caddc co vg
      cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co sstr2 syl
      imim2d com23 adantrr vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn
      wcel wa wa vm cv vq cv wceq vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1
      caddc co vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv
      vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vm cv vq cv clt wbr vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vq cv
      cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk
      cv vg cv cfv cF co wcel vk cn wral wa vm cv vq cv wceq vq cv c1 caddc co
      vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm
      cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co
      wss wi vm cv cn wcel vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv
      vq cv wceq vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv
      cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd
      cfv c2 cdiv co cD cbl cfv co wss vq cv cn wcel cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vm cv vq cv wceq wa vq cv c1 caddc co vg cv cfv c1st cfv vq cv
      c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vq cv vg cv cfv c1st cfv vq
      cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co vm cv vg cv cfv c1st cfv
      vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co vq cv cn wcel cn cA vg
      cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc
      co vg cv cfv c2nd cfv cD cbl cfv co vq cv vg cv cfv c1st cfv vq cv vg cv
      cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vm cv vq cv wceq vq cv c1 caddc
      co cn wcel vq cv vg cv cfv cA wcel wa vq cv c1 caddc co vg cv cfv vq cv
      c1 caddc co vq cv vg cv cfv cF co wcel vq cv c1 caddc co vg cv cfv c1st
      cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vq cv vg cv cfv
      c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vq cv cn
      wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral wa wa vq cv c1 caddc co cn wcel vq cv vg
      cv cfv cA wcel wa vq cv c1 caddc co vg cv cfv vq cv c1 caddc co vq cv vg
      cv cfv cF co wcel wa vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc
      co vg cv cfv c2nd cfv cD cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl
      cfv cfv cdif vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co cin vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co vq cv c1 caddc co cn wcel vq cv vg cv cfv cA wcel
      wa vq cv c1 caddc co vg cv cfv vq cv c1 caddc co vq cv vg cv cfv cF co
      wcel wa vq cv c1 caddc co vg cv cfv c2nd cfv vq cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg
      cv cfv c2nd cfv cD cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv
      cdif vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl
      cfv co cin wss vq cv c1 caddc co cn wcel vq cv vg cv cfv cA wcel wa vq cv
      c1 caddc co vg cv cfv vq cv c1 caddc co vq cv vg cv cfv cF co wcel wa vq
      cv c1 caddc co vg cv cfv c1st cfv cX wcel vq cv c1 caddc co vg cv cfv
      c2nd cfv cr wcel cc0 vq cv c1 caddc co vg cv cfv c2nd cfv clt wbr wa wa
      vq cv c1 caddc co vg cv cfv c2nd cfv vq cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr vq cv c1 caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv
      c2nd cfv cD cbl cfv co cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq
      cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co
      cin wss wa vy vz cA cD vq cv c1 caddc co vg cv cfv vq cv vg cv cfv vj cF
      cJ vq cv c1 caddc co cM cO cX vr vp bcthlem18.1 bcthlem18.3 bcthlem18.6
      bcthlem18.8 bcthlem15 pm3.27d pm3.27d cX vq cv c1 caddc co cM cfv cJ ccl
      cfv cfv cdif vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co cin vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co wss vq cv c1 caddc co cn wcel vq cv vg cv cfv cA
      wcel wa vq cv c1 caddc co vg cv cfv vq cv c1 caddc co vq cv vg cv cfv cF
      co wcel wa cX vq cv c1 caddc co cM cfv cJ ccl cfv cfv cdif vq cv vg cv
      cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co inss2 a1i
      sstrd vq cv cn wcel cn cA vg cv wf vq cv c1 caddc co cn wcel vq cv vg cv
      cfv cA wcel wa vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral vq cv cn wcel cn cA vg cv wf wa vq cv c1 caddc
      co cn wcel vq cv vg cv cfv cA wcel vq cv cn wcel vq cv c1 caddc co cn
      wcel cn cA vg cv wf vq cv peano2nn adantr cn cA vg cv wf vq cv cn wcel vq
      cv vg cv cfv cA wcel cn cA vq cv vg cv ffvelrn ancoms jca adantrr vq cv
      cn wcel vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral vq cv c1 caddc co vg cv cfv vq cv c1 caddc co vq cv vg
      cv cfv cF co wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vq cv c1 caddc co vg cv cfv vq cv c1
      caddc co vq cv vg cv cfv cF co wcel vk vq cv cn vk cv vq cv wceq vk cv c1
      caddc co vg cv cfv vq cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co vq cv c1 caddc co vq cv vg cv cfv cF co vk cv vq cv wceq vk
      cv c1 caddc co vq cv c1 caddc co vg cv vk cv vq cv c1 caddc opreq1 fveq2d
      vk cv vq cv wceq vk cv c1 caddc co vq cv c1 caddc co vk cv vg cv cfv vq
      cv vg cv cfv cF vk cv vq cv c1 caddc opreq1 vk cv vq cv vg cv fveq2
      opreq12d eleq12d rcla4va adantrl sylanc adantr vm cv vq cv wceq vm cv vg
      cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co vq cv
      vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wceq
      vq cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv vq cv wceq vm cv vg
      cv cfv c1st cfv vq cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv
      co vq cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv vm cv vq cv wceq vm cv
      vg cv cfv vq cv vg cv cfv c1st vm cv vq cv vg cv fveq2 fveq2d vm cv vq cv
      wceq vm cv vg cv cfv c2nd cfv vq cv vg cv cfv c2nd cfv c2 cdiv vm cv vq
      cv wceq vm cv vg cv cfv vq cv vg cv cfv c2nd vm cv vq cv vg cv fveq2
      fveq2d opreq1d opreq12d adantl sseqtr4d ex adantrr a1dd jaod sylbird
      com23 ex a2d vm cv cn wcel vm cv c1 clt wbr c1 vg cv cfv c1st cfv c1 vg
      cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv
      c2nd cfv c2 cdiv co cD cbl cfv co wss wi cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm
      cv cn wcel vm cv c1 clt wbr c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv
      cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv
      co cD cbl cfv co wss vm cv cn wcel c1 vm cv cle wbr vm cv c1 clt wbr wn
      vm cv nnge1 c1 cr wcel vm cv cr wcel c1 vm cv cle wbr vm cv c1 clt wbr wn
      wb vm cv cn wcel c1 vm cv lenlt 1re vm cv nnre sylancr mpbid pm2.21d
      adantl vs cv c1 wceq vm cv vs cv clt wbr vs cv vg cv cfv c1st cfv vs cv
      vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv
      c2nd cfv c2 cdiv co cD cbl cfv co wss wi vm cv c1 clt wbr c1 vg cv cfv
      c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm
      cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi cn cA vg cv wf vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa vm cv cn wcel wa vs cv c1 wceq vm cv vs cv clt wbr vm cv c1
      clt wbr vs cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co
      vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv
      co wss c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co vm cv vg
      cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vs
      cv c1 vm cv clt breq2 vs cv c1 wceq vs cv vg cv cfv c1st cfv vs cv vg cv
      cfv c2nd cfv cD cbl cfv co c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD
      cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co vs cv c1 wceq vs cv vg cv cfv c1st cfv c1 vg cv cfv c1st
      cfv vs cv vg cv cfv c2nd cfv c1 vg cv cfv c2nd cfv cD cbl cfv vs cv c1
      wceq vs cv vg cv cfv c1 vg cv cfv c1st vs cv c1 vg cv fveq2 fveq2d vs cv
      c1 wceq vs cv vg cv cfv c1 vg cv cfv c2nd vs cv c1 vg cv fveq2 fveq2d
      opreq12d sseq1d imbi12d imbi2d vs cv vq cv wceq vm cv vs cv clt wbr vs cv
      vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vm cv
      vq cv clt wbr vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wss wi cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa vs cv
      vq cv wceq vm cv vs cv clt wbr vm cv vq cv clt wbr vs cv vg cv cfv c1st
      cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv
      vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vq cv vg cv cfv c1st cfv
      vq cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vs cv vq cv vm cv clt breq2
      vs cv vq cv wceq vs cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl
      cfv co vq cv vg cv cfv c1st cfv vq cv vg cv cfv c2nd cfv cD cbl cfv co vm
      cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co
      vs cv vq cv wceq vs cv vg cv cfv c1st cfv vq cv vg cv cfv c1st cfv vs cv
      vg cv cfv c2nd cfv vq cv vg cv cfv c2nd cfv cD cbl cfv vs cv vq cv wceq
      vs cv vg cv cfv vq cv vg cv cfv c1st vs cv vq cv vg cv fveq2 fveq2d vs cv
      vq cv wceq vs cv vg cv cfv vq cv vg cv cfv c2nd vs cv vq cv vg cv fveq2
      fveq2d opreq12d sseq1d imbi12d imbi2d vs cv vq cv c1 caddc co wceq vm cv
      vs cv clt wbr vs cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wss wi vm cv vq cv c1 caddc co clt wbr vq cv c1 caddc co vg cv
      cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm cv vg
      cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi
      cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa vm cv cn wcel wa vs cv vq cv c1 caddc co
      wceq vm cv vs cv clt wbr vm cv vq cv c1 caddc co clt wbr vs cv vg cv cfv
      c1st cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv
      vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vq cv c1 caddc co
      vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl cfv co vm
      cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co
      wss vs cv vq cv c1 caddc co vm cv clt breq2 vs cv vq cv c1 caddc co wceq
      vs cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vq cv c1
      caddc co vg cv cfv c1st cfv vq cv c1 caddc co vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co vs cv vq cv c1 caddc co wceq vs cv vg cv cfv c1st cfv vq cv c1
      caddc co vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv vq cv c1 caddc co vg
      cv cfv c2nd cfv cD cbl cfv vs cv vq cv c1 caddc co wceq vs cv vg cv cfv
      vq cv c1 caddc co vg cv cfv c1st vs cv vq cv c1 caddc co vg cv fveq2
      fveq2d vs cv vq cv c1 caddc co wceq vs cv vg cv cfv vq cv c1 caddc co vg
      cv cfv c2nd vs cv vq cv c1 caddc co vg cv fveq2 fveq2d opreq12d sseq1d
      imbi12d imbi2d vs cv vn cv wceq vm cv vs cv clt wbr vs cv vg cv cfv c1st
      cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv
      vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi vm cv vn cv clt wbr vn
      cv vg cv cfv c1st cfv vn cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv
      cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wss wi cn
      cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa vm cv cn wcel wa vs cv vn cv wceq vm cv vs cv
      clt wbr vm cv vn cv clt wbr vs cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd
      cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co wss vn cv vg cv cfv c1st cfv vn cv vg cv cfv c2nd
      cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co wss vs cv vn cv vm cv clt breq2 vs cv vn cv wceq vs
      cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv cD cbl cfv co vn cv vg cv
      cfv c1st cfv vn cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st
      cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co vs cv vn cv wceq vs
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv vs cv vg cv cfv c2nd cfv
      vn cv vg cv cfv c2nd cfv cD cbl cfv vs cv vn cv wceq vs cv vg cv cfv vn
      cv vg cv cfv c1st vs cv vn cv vg cv fveq2 fveq2d vs cv vn cv wceq vs cv
      vg cv cfv vn cv vg cv cfv c2nd vs cv vn cv vg cv fveq2 fveq2d opreq12d
      sseq1d imbi12d imbi2d nnindALT $.
      $( [9-Nov-2007] $) $( [21-Oct-2007] $)

    $( Lemma for ~ bcth .  The distance between the center of a ball at ` m `
       and any later ball in sequence ` g ` is less than half the radius of
       the ball at ` m ` . $)
    bcthlem19 $p |- ( ( ( n e. NN /\ ( ( g : NN --> A /\ A. k e. NN
  ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) /\ m e. NN ) ) /\ m < n ) ->
  ( ( 1st ` ( g ` m ) ) D ( 1st ` ( g ` n ) ) ) <
                 ( ( 2nd ` ( g ` m ) ) / 2 ) ) $=
      vn cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn
      cv clt wbr wa vn cv vg cv cfv c1st cfv vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wcel vm cv vg cv cfv c1st cfv vn
      cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr
      vn cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn
      cv clt wbr wa vn cv vg cv cfv c1st cfv vn cv vg cv cfv c2nd cfv cD cbl
      cfv co vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co vn cv vg cv cfv c1st cfv vn cv cn wcel cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa vm cv vn cv clt wbr vn cv vg cv cfv c1st cfv vn
      cv vg cv cfv c2nd cfv cD cbl cfv co vm cv vg cv cfv c1st cfv vm cv vg cv
      cfv c2nd cfv c2 cdiv co cD cbl cfv co wss vx vy vz cA cD vg vj vk vm vn
      cF cJ cM cO cX vr vp bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7
      bcthlem18.8 bcthlem18 imp31 vn cv cn wcel cn cA vg cv wf vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      vm cv cn wcel wa wa vn cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv vn
      cv vg cv cfv c2nd cfv cD cbl cfv co wcel vm cv vn cv clt wbr vn cv cn
      wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral wa vn cv vg cv cfv c1st cfv vn cv vg cv
      cfv c1st cfv vn cv vg cv cfv c2nd cfv cD cbl cfv co wcel vm cv cn wcel vn
      cv cn wcel cn cA vg cv wf vn cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv vn cv vg cv cfv c2nd cfv cD cbl cfv co wcel vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral vn cv cn wcel
      cn cA vg cv wf wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c2nd
      cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa wa vn cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv vn cv vg cv cfv c2nd cfv cD cbl cfv co
      wcel cn cA vg cv wf vn cv cn wcel vn cv vg cv cfv c1st cfv cX wcel vn cv
      vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa wa vx
      cA vg vn cv cX bcthlem18.7 bcthlem4 ancoms cD cme wcel vn cv vg cv cfv
      c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv
      c2nd cfv clt wbr wa vn cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv vn
      cv vg cv cfv c2nd cfv cD cbl cfv co wcel cD bcthlem18.1 cmsmeti cD vn cv
      vg cv cfv c1st cfv vn cv vg cv cfv c2nd cfv cX bcthlem18.3 blcntr mpanl1
      syl adantrr adantrr adantr sseldd vn cv cn wcel cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa wa vn cv vg cv cfv c1st cfv vm cv vg cv cfv c1st
      cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD cbl cfv co wcel vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr wb vm cv vn cv clt wbr vn cv cn wcel cn cA vg cv wf vm cv
      cn wcel vn cv vg cv cfv c1st cfv vm cv vg cv cfv c1st cfv vm cv vg cv cfv
      c2nd cfv c2 cdiv co cD cbl cfv co wcel vm cv vg cv cfv c1st cfv vn cv vg
      cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wb vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vn cv vg cv cfv
      c1st cfv vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co cD
      cbl cfv co wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co
      vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wb vm cv vg cv cfv c1st cfv
      cX wcel vn cv vg cv cfv c1st cfv cX wcel wa vm cv vg cv cfv c2nd cfv c2
      cdiv co cr wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vn cv
      vg cv cfv c1st cfv vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co cD cbl cfv co wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wb cn cA vg cv wf
      vm cv cn wcel wa vn cv cn wcel wa cD cme wcel vm cv vg cv cfv c1st cfv cX
      wcel vn cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv c2 cdiv co
      cr wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vn cv vg cv
      cfv c1st cfv vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv c2 cdiv co
      cD cbl cfv co wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD
      co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wb cD bcthlem18.1 cmsmeti
      vn cv vg cv cfv c1st cfv cD vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd
      cfv c2 cdiv co cX bcthlem18.3 elbl2 mp3anl1 cn cA vg cv wf vm cv cn wcel
      wa vn cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st
      cfv cX wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX
      wcel vn cv cn wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st
      cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv
      clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.26d adantr cn cA vg
      cv wf vn cv cn wcel vn cv vg cv cfv c1st cfv cX wcel vm cv cn wcel cn cA
      vg cv wf vn cv cn wcel wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv
      cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vn
      cv cX bcthlem18.7 bcthlem4 pm3.26d adantlr jca cn cA vg cv wf vm cv cn
      wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cc0 vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr wa vn cv cn wcel cn cA vg cv wf vm cv cn wcel
      wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr
      wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cc0 vm cv vg cv cfv c2nd
      cfv c2 cdiv co clt wbr wa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv
      c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv
      c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d vm cv
      vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vm cv
      vg cv cfv c2nd cfv c2 cdiv co cr wcel cc0 vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr vm cv vg cv cfv c2nd cfv cr wcel vm cv vg cv cfv c2nd cfv
      c2 cdiv co cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr vm cv vg cv cfv
      c2nd cfv rehalfcl adantr vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv
      cfv c2nd cfv clt wbr cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm
      cv vg cv cfv c2nd cfv halfpos2 biimpa jca syl adantr sylanc ancoms
      adantrlr adantr mpbid $.
      $( [9-Nov-2007] $) $( [23-Oct-2007] $)

    $( MAY BE REVISED - why is this proof so long? $)
    $( Lemma for ~ bcth .  A weaker version of ~ bcthlem19 . $)
    bcthlem20 $p |- ( ( ( n e. NN /\ m <_ n ) /\ ( ( g : NN --> A /\
          A. k e. NN ( g ` ( k + 1 ) )
         e. ( ( k + 1 ) F ( g ` k ) ) ) /\ m e. NN ) ) -> ( ( 1st ` (
          g ` m ) ) D ( 1st ` ( g ` n ) ) ) < ( 2nd ` ( g ` m ) ) ) $=
      vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv
      cn wcel wa wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm
      cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv c2nd cfv vn cv cn wcel
      vm cv vn cv cle wbr wa cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co cr wcel vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral vn cv cn wcel cn cA
      vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co cr wcel vm cv vn cv cle wbr vm cv vg cv cfv c1st cfv cX wcel vn
      cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co cr wcel vn cv cn wcel cn cA vg cv wf vm cv cn wcel wa wa
      cD cme wcel vm cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st cfv cX
      wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cD
      cms wcel cD cme wcel bcthlem18.1 cD cmsmet ax-mp vm cv vg cv cfv c1st cfv
      vn cv vg cv cfv c1st cfv cD cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vm
      cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vn cv cn wcel cn cA vg cv
      wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd
      cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.26d adantl vn cv cn wcel cn cA vg cv wf vn cv vg
      cv cfv c1st cfv cX wcel vm cv cn wcel cn cA vg cv wf vn cv cn wcel vn cv
      vg cv cfv c1st cfv cX wcel cn cA vg cv wf vn cv cn wcel wa vn cv vg cv
      cfv c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv
      c2nd cfv clt wbr wa vx cA vg vn cv cX bcthlem18.7 bcthlem4 pm3.26d ancoms
      adantrr sylanc adantlr adantrlr cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn
      wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel vn cv cn wcel vm cv
      vn cv cle wbr wa cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c2nd cfv c2
      cdiv co cr wcel vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv
      c2nd cfv cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cn cA vg cv
      wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv
      c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv
      cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt
      wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d pm3.26d vm cv vg cv
      cfv c2nd cfv rehalfcl syl adantlr adantl cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm
      cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel vn cv cn wcel vm cv vn cv
      cle wbr wa cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c2nd cfv cr wcel
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr
      wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa
      vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm
      cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4
      pm3.27d pm3.26d adantlr adantl vn cv cn wcel vm cv vn cv cle wbr cn cA vg
      cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa vm cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv cn wcel
      vn cv cn wcel vm cv vn cv cle wbr cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv vg
      cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv
      c2 cdiv co clt wbr vm cv cn wcel vn cv cn wcel vm cv vn cv cle wbr cn cA
      vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi wi vm cv cn wcel vn
      cv cn wcel wa vm cv vn cv cle wbr vm cv vn cv clt wbr vm cv vn cv wceq wo
      cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi vm cv cr
      wcel vn cv cr wcel vm cv vn cv cle wbr vm cv vn cv clt wbr vm cv vn cv
      wceq wo wb vm cv cn wcel vn cv cn wcel vm cv vn cv leloe vm cv nnre vn cv
      nnre syl2an vm cv cn wcel vn cv cn wcel wa vm cv vn cv clt wbr vm cv vn
      cv wceq wo cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa vm cv vg cv cfv c1st cfv vn cv
      vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi
      vm cv cn wcel vn cv cn wcel wa vm cv vn cv clt wbr cn cA vg cv wf vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg
      cv cfv c2nd cfv c2 cdiv co clt wbr wi vm cv vn cv wceq vm cv cn wcel vn
      cv cn wcel vm cv vn cv clt wbr cn cA vg cv wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr wi vn cv cn wcel vm cv cn wcel vm cv vn cv clt wbr cn cA
      vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi wi vn cv cn wcel cn
      cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa vm cv vn cv clt wbr vm cv cn wcel vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr vn cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel
      vm cv vn cv clt wbr vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD
      co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vn cv cn wcel cn cA vg cv
      wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa vm cv cn wcel vm cv vn cv clt wbr vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr wi vn cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa vm
      cv vn cv clt wbr vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co
      vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi vn cv cn wcel cn cA vg cv
      wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn cv clt wbr vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr vx vy vz cA cD vg vj vk vm vn cF cJ cM cO cX vr vp
      bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7 bcthlem18.8 bcthlem19 ex
      ex exp3a com34 com24 com12 imp31 vm cv cn wcel vn cv cn wcel wa vm cv vn
      cv wceq wa cn cA vg cv wf vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral vm cv
      cn wcel vm cv vn cv wceq cn cA vg cv wf vm cv vg cv cfv c1st cfv vn cv vg
      cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wi vn
      cv cn wcel vm cv cn wcel vm cv vn cv wceq wa cn cA vg cv wf vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr cn cA vg cv wf vm cv cn wcel vm cv vn cv wceq wa vm cv vg
      cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv
      c2 cdiv co clt wbr cn cA vg cv wf vm cv cn wcel vm cv vn cv wceq wa wa vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cc0 vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt cn cA vg cv wf vm cv cn wcel vm cv vn cv wceq wa
      wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv
      cfv c1st cfv vm cv vg cv cfv c1st cfv cD co cc0 cn cA vg cv wf vm cv cn
      wcel vm cv vn cv wceq wa wa vm cv vg cv cfv c1st cfv vm cv vg cv cfv c1st
      cfv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv
      cn wcel vm cv vn cv wceq wa vm cv vg cv cfv c1st cfv vm cv vg cv cfv c1st
      cfv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co wceq cn
      cA vg cv wf vm cv vn cv wceq vm cv vg cv cfv c1st cfv vm cv vg cv cfv
      c1st cfv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co
      wceq vm cv cn wcel vm cv vn cv wceq vm cv vg cv cfv c1st cfv vn cv vg cv
      cfv c1st cfv vm cv vg cv cfv c1st cfv cD vm cv vn cv wceq vm cv vg cv cfv
      vn cv vg cv cfv c1st vm cv vn cv vg cv fveq2 fveq2d opreq2d adantl adantl
      eqcomd cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c1st cfv vm cv vg cv
      cfv c1st cfv cD co cc0 wceq vm cv vn cv wceq cD cme wcel vm cv vg cv cfv
      c1st cfv cX wcel vm cv vg cv cfv c1st cfv vm cv vg cv cfv c1st cfv cD co
      cc0 wceq cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cD cX
      bcthlem18.3 met0 cD cms wcel cD cme wcel bcthlem18.1 cD cmsmet ax-mp cn
      cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv
      cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm
      cv cX bcthlem18.7 bcthlem4 pm3.26d sylancr adantrr eqtrd cn cA vg cv wf
      vm cv cn wcel cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vn cv
      wceq vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt
      wbr cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr cn cA vg cv wf vm cv
      cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv
      clt wbr cc0 vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv
      c2nd cfv halfpos2 biimpa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv
      c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm
      cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv
      cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.27d pm3.26d cn cA vg cv wf vm cv cn wcel wa vm
      cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA
      vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv
      cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm
      cv cX bcthlem18.7 bcthlem4 pm3.27d pm3.27d sylanc adantrr eqbrtrd ancoms
      ex adantlr adantrd jaodan ex sylbid ex com4l imp43 cn cA vg cv wf vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv
      cfv c2nd cfv clt wbr vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv wf
      vm cv cn wcel vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv c2nd
      cfv clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv
      cfv c2nd cfv clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv
      c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv
      cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr vm cv vg cv cfv c2nd cfv c2
      cdiv co vm cv vg cv cfv c2nd cfv clt wbr vm cv vg cv cfv c2nd cfv halfpos
      biimpa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel
      cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm
      cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv
      vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4
      pm3.27d pm3.26d cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv
      cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel
      wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0
      vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7
      bcthlem4 pm3.27d pm3.27d sylanc adantlr adantl lttrd $.
      $( [9-Nov-2007] $) $( [22-Oct-2007] $)

    $( Lemma for ~ bcth .  A defining property for ` ( 1st o. g ) ` to be
       a Cauchy sequence. $)
    bcthlem21 $p |- ( ( g : NN --> A /\ ( ( 2nd ` ( g ` 1 ) ) < ( 1 / 2 ) /\
        A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) ->
     ( w e. RR -> ( 0 < w -> E. m e. NN A. n e. NN ( m <_ n ->
      ( ( ( 1st o. g ) ` m ) D ( ( 1st o. g ) ` n ) ) < w ) ) ) ) $=
      cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      wa vw cv cr wcel cc0 vw cv clt wbr vm cv vn cv cle wbr vm cv c1st vg cv
      ccom cfv vn cv c1st vg cv ccom cfv cD co vw cv clt wbr wi vn cn wral vm
      cn wrex cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa c1 c2 vm cv cexp co cdiv
      co vw cv clt wbr vm cn wrex vm cv vn cv cle wbr vm cv c1st vg cv ccom cfv
      vn cv c1st vg cv ccom cfv cD co vw cv clt wbr wi vn cn wral vm cn wrex vw
      cv cr wcel cc0 vw cv clt wbr wa c1 c2 vm cv cexp co cdiv co vw cv clt wbr
      vm cn wrex cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa c1 vw cv cdiv co c2 vm
      cv cexp co clt wbr vm cn wrex c1 c2 vm cv cexp co cdiv co vw cv clt wbr
      vm cn wrex vw cv cr wcel cc0 vw cv clt wbr wa c1 vw cv cdiv co cr wcel c1
      vw cv cdiv co c2 vm cv cexp co clt wbr vm cn wrex vw cv cr wcel cc0 vw cv
      clt wbr vw cv cc0 wne c1 vw cv cdiv co cr wcel vw cv gt0ne0 vw cv rereccl
      syldan c1 vw cv cdiv co cr wcel c2 cr wcel c1 c2 clt wbr c1 vw cv cdiv co
      c2 vm cv cexp co clt wbr vm cn wrex 2re 1lt2 c1 vw cv cdiv co c2 vm
      expnbnd mp3an23 syl vw cv cr wcel cc0 vw cv clt wbr wa c1 vw cv cdiv co
      c2 vm cv cexp co clt wbr c1 c2 vm cv cexp co cdiv co vw cv clt wbr vm cn
      vw cv cr wcel cc0 vw cv clt wbr wa c2 vm cv cexp co cr wcel cc0 c2 vm cv
      cexp co clt wbr wa c1 vw cv cdiv co c2 vm cv cexp co clt wbr c1 c2 vm cv
      cexp co cdiv co vw cv clt wbr wb vm cv cn wcel vw cv c2 vm cv cexp co
      ltrec1 vm cv cn wcel vm cv cn0 wcel c2 vm cv cexp co cr wcel cc0 c2 vm cv
      cexp co clt wbr wa vm cv nnnn0 vm cv cn0 wcel c2 vm cv cexp co cr wcel
      cc0 c2 vm cv cexp co clt wbr c2 cr wcel vm cv cn0 wcel c2 vm cv cexp co
      cr wcel 2re c2 vm cv reexpcl mpan c2 cr wcel vm cv cn0 wcel cc0 c2 clt
      wbr cc0 c2 vm cv cexp co clt wbr 2re 2pos c2 vm cv expgt0 mp3an13 jca syl
      sylan2 rexbidva mpbid adantl cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2
      cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa c1
      c2 vm cv cexp co cdiv co vw cv clt wbr vm cv vn cv cle wbr vm cv c1st vg
      cv ccom cfv vn cv c1st vg cv ccom cfv cD co vw cv clt wbr wi vn cn wral
      vm cn cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa c1 c2
      vm cv cexp co cdiv co vw cv clt wbr vm cv vn cv cle wbr vm cv c1st vg cv
      ccom cfv vn cv c1st vg cv ccom cfv cD co vw cv clt wbr wi vn cn cn cA vg
      cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv
      cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa c1 c2 vm cv cexp co cdiv
      co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr vm cv c1st vg cv ccom
      cfv vn cv c1st vg cv ccom cfv cD co vw cv clt wbr cn cA vg cv wf c1 vg cv
      cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw
      cv clt wbr wa wa vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co vw cv clt
      wbr vn cv cn wcel vm cv vn cv cle wbr wa wa wa vm cv c1st vg cv ccom cfv
      vn cv c1st vg cv ccom cfv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co vw cv clt cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv
      co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa vm cv
      cn wcel wa c1 c2 vm cv cexp co cdiv co vw cv clt wbr vn cv cn wcel vm cv
      vn cv cle wbr wa wa vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv
      cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co wceq cn cA
      vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw
      cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel c1 c2 vm cv cexp co cdiv
      co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr wa wa vm cv c1st vg cv
      ccom cfv vn cv c1st vg cv ccom cfv cD co vm cv vg cv cfv c1st cfv vn cv
      vg cv cfv c1st cfv cD co wceq wi cn cA vg cv wf c1 vg cv cfv c2nd cfv c1
      c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa vm
      cv cn wcel c1 c2 vm cv cexp co cdiv co vw cv clt wbr vn cv cn wcel vm cv
      vn cv cle wbr wa wa vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv
      cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co wceq wi wi
      cn cA vg cv wf vw cv cr wcel cc0 vw cv clt wbr wa vm cv cn wcel c1 c2 vm
      cv cexp co cdiv co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr wa wa
      vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co wceq wi wi wi c1 vg cv cfv c2nd
      cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa cn cA vg cv wf vm cv cn wcel c1
      c2 vm cv cexp co cdiv co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr
      wa wa vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vm cv vg
      cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co wceq wi wi vw cv cr wcel
      cc0 vw cv clt wbr wa cn cA vg cv wf vm cv cn wcel c1 c2 vm cv cexp co
      cdiv co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr wa wa vm cv c1st
      vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vm cv vg cv cfv c1st cfv
      vn cv vg cv cfv c1st cfv cD co wceq cn cA vg cv wf vm cv cn wcel wa vn cv
      cn wcel vm cv vn cv cle wbr wa vm cv c1st vg cv ccom cfv vn cv c1st vg cv
      ccom cfv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co
      wceq c1 c2 vm cv cexp co cdiv co vw cv clt wbr cn cA vg cv wf vm cv cn
      wcel wa vn cv cn wcel vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv
      cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co wceq vm cv
      vn cv cle wbr cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel wa vm cv c1st
      vg cv ccom cfv vm cv vg cv cfv c1st cfv vn cv c1st vg cv ccom cfv vn cv
      vg cv cfv c1st cfv cD cn cA vg cv wf vm cv cn wcel wa vm cv c1st vg cv
      ccom cfv vm cv vg cv cfv c1st cfv wceq vn cv cn wcel cA vg vm cv bcthlem3
      adantr cn cA vg cv wf vn cv cn wcel vn cv c1st vg cv ccom cfv vn cv vg cv
      cfv c1st cfv wceq vm cv cn wcel cA vg vn cv bcthlem3 adantlr opreq12d
      adantrr adantrl exp31 a1d adantr imp imp imp cn cA vg cv wf c1 vg cv cfv
      c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv
      clt wbr wa wa vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co vw cv clt wbr
      vn cv cn wcel vm cv vn cv cle wbr vm cv vg cv cfv c1st cfv vn cv vg cv
      cfv c1st cfv cD co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr cn cA
      vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw
      cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa c1 c2 vm cv cexp co
      cdiv co vw cv clt wbr vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr cn cA vg cv wf c1
      vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel
      cc0 vw cv clt wbr wa wa vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co vw
      cv clt wbr vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vw cv
      clt wbr wi vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv wf c1 vg cv
      cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw
      cv clt wbr wa wa vm cv cn wcel wa wa vm cv vg cv cfv c1st cfv vn cv vg cv
      cfv c1st cfv cD co c1 c2 vm cv cexp co cdiv co clt wbr c1 c2 vm cv cexp
      co cdiv co vw cv clt wbr vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co vw cv clt wbr vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv
      wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv
      cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa wa vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c1 c2 vm cv
      cexp co cdiv co vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv wf c1 vg
      cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel vw cv cr
      wcel cc0 vw cv clt wbr wa vn cv cn wcel cn cA vg cv wf c1 vg cv cfv c2nd
      cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel wa vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel vm cv vn cv cle wbr
      vn cv cn wcel cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral wa wa vm cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co cr wcel cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co
      clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa wa vn cv cn wcel vm cv cn wcel vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co cr wcel wi cn cA vg cv wf c1 vg cv cfv
      c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel vn cv cn
      wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cn
      cA vg cv wf vm cv cn wcel vn cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg
      cv cfv c1st cfv cD co cr wcel wi wi c1 vg cv cfv c2nd cfv c1 c2 cdiv co
      clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa cn cA vg cv wf vm cv cn wcel vn cv cn wcel vm cv vg
      cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cn cA vg cv wf vm
      cv cn wcel vn cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co cr wcel vm cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st
      cfv cX wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr
      wcel cn cA vg cv wf vm cv cn wcel wa cn cA vg cv wf vn cv cn wcel wa cD
      cme wcel vm cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st cfv cX
      wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cD
      bcthlem18.1 cmsmeti vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD
      cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vm cv cn wcel wa vm cv vg cv
      cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv
      c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.26d cn cA
      vg cv wf vn cv cn wcel wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv
      cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vn
      cv cX bcthlem18.7 bcthlem4 pm3.26d syl2an anandis exp32 adantr com23
      com12 imp32 adantlr adantrlr cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2
      cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa vm
      cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel vn cv cn wcel vm cv vn cv
      cle wbr wa cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa vm cv cn wcel vm cv vg cv cfv c2nd cfv cr wcel vw cv cr
      wcel cc0 vw cv clt wbr wa cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv
      c2nd cfv cr wcel c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel
      cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm
      cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv
      vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4
      pm3.27d pm3.26d adantlr adantlr adantl cn cA vg cv wf c1 vg cv cfv c2nd
      cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv clt
      wbr wa wa vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co cr wcel vn cv cn
      wcel vm cv vn cv cle wbr wa vm cv cn wcel c1 c2 vm cv cexp co cdiv co cr
      wcel cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel vm cv cn0
      wcel c1 c2 vm cv cexp co cdiv co cr wcel vm cv nnnn0 c2 vm cv cexp co cr
      wcel c2 vm cv cexp co cc0 wne c1 c2 vm cv cexp co cdiv co cr wcel vm cv
      cn0 wcel c2 vm cv cexp co rereccl c2 cr wcel vm cv cn0 wcel c2 vm cv cexp
      co cr wcel 2re c2 vm cv reexpcl mpan c2 cc wcel c2 cc0 wne vm cv cn0 wcel
      c2 vm cv cexp co cc0 wne 2cn 2ne0 c2 vm cv expne0i mp3an12 sylanc syl
      adantl adantl vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv wf c1 vg
      cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd
      cfv clt wbr vw cv cr wcel cc0 vw cv clt wbr wa vn cv cn wcel vm cv vn cv
      cle wbr wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv clt wbr
      cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      wa vx vy vz cA cD vg vj vk vm vn cF cJ cM cO cX vr vp bcthlem18.1
      bcthlem18.3 bcthlem18.6 bcthlem18.7 bcthlem18.8 bcthlem20 cn cA vg cv wf
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa c1 vg cv cfv c2nd cfv c1 c2 cdiv
      co clt wbr cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa id adantrl sylanr1 adantrlr cn
      cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vw cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa vm cv vg cv cfv
      c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vn cv cn wcel vm cv vn cv
      cle wbr wa cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa vm cv cn wcel vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co
      cdiv co clt wbr vw cv cr wcel cc0 vw cv clt wbr wa vm cv cn wcel cn cA vg
      cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv
      vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vm cv cn wcel cn
      cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vm cv vg cv cfv c2nd cfv c1 c2 vm cv cexp co cdiv co clt wbr vx vy vz cA
      cD vg vj vk vm cF cJ cM cO cX vr vp bcthlem18.1 bcthlem18.3 bcthlem18.6
      bcthlem18.7 bcthlem18.8 bcthlem17 imp ancoms adantlr adantl lttrd vm cv
      vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel c1 c2 vm cv
      cexp co cdiv co cr wcel vw cv cr wcel vm cv vg cv cfv c1st cfv vn cv vg
      cv cfv c1st cfv cD co c1 c2 vm cv cexp co cdiv co clt wbr c1 c2 vm cv
      cexp co cdiv co vw cv clt wbr wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co vw cv clt wbr wi vn cv cn wcel vm cv vn cv cle wbr wa cn
      cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vw cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa wa vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co c1 c2 vm cv cexp co cdiv co vw cv
      axlttrn vn cv cn wcel vm cv vn cv cle wbr wa cn cA vg cv wf c1 vg cv cfv
      c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel vw cv cr wcel cc0 vw
      cv clt wbr wa vn cv cn wcel cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2
      cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa wa vm cv cn wcel wa vm cv vg cv cfv c1st cfv
      vn cv vg cv cfv c1st cfv cD co cr wcel vm cv vn cv cle wbr vn cv cn wcel
      cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      wa vm cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co
      cr wcel cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vn cv cn wcel vm cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg
      cv cfv c1st cfv cD co cr wcel wi cn cA vg cv wf c1 vg cv cfv c2nd cfv c1
      c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel vn cv cn wcel vm cv vg
      cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cn cA vg cv wf vm
      cv cn wcel vn cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co cr wcel wi wi c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa cn cA vg cv wf vm cv cn wcel vn cv cn wcel vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co cr wcel cn cA vg cv wf vm cv cn wcel
      vn cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr
      wcel vm cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st cfv cX wcel vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cn cA vg cv
      wf vm cv cn wcel wa cn cA vg cv wf vn cv cn wcel wa cD cme wcel vm cv vg
      cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cD bcthlem18.1 cmsmeti vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD cX bcthlem18.3 metcl
      mp3an1 cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel
      vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa
      vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.26d cn cA vg cv wf vn cv cn
      wcel wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel
      cc0 vn cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vn cv cX bcthlem18.7
      bcthlem4 pm3.26d syl2an anandis exp32 adantr com23 com12 imp32 adantlr
      adantrlr cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vw cv cr wcel cc0 vw cv clt wbr wa wa vm cv cn wcel wa c1 c2
      vm cv cexp co cdiv co cr wcel vn cv cn wcel vm cv vn cv cle wbr wa vm cv
      cn wcel c1 c2 vm cv cexp co cdiv co cr wcel cn cA vg cv wf c1 vg cv cfv
      c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw cv
      clt wbr wa wa vm cv cn wcel vm cv cn0 wcel c1 c2 vm cv cexp co cdiv co cr
      wcel vm cv nnnn0 c2 vm cv cexp co cr wcel c2 vm cv cexp co cc0 wne c1 c2
      vm cv cexp co cdiv co cr wcel vm cv cn0 wcel c2 vm cv cexp co rereccl c2
      cr wcel vm cv cn0 wcel c2 vm cv cexp co cr wcel 2re c2 vm cv reexpcl mpan
      c2 cc wcel c2 cc0 wne vm cv cn0 wcel c2 vm cv cexp co cc0 wne 2cn 2ne0 c2
      vm cv expne0i mp3an12 sylanc syl adantl adantl cn cA vg cv wf c1 vg cv
      cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vw cv cr wcel cc0 vw
      cv clt wbr wa wa vm cv cn wcel wa vw cv cr wcel vn cv cn wcel vm cv vn cv
      cle wbr wa cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa vw cv cr wcel cc0 vw cv clt wbr vm cv cn wcel simplrl
      adantl syl3anc mpand exp31 com4t imp45 eqbrtrd exp45 r19.21adv r19.22dva
      mpd exp32 $.
      $( [10-Nov-2007] $) $( [22-Oct-2007] $)

    $( Lemma for ~ bcth .  The sequence of ball centers ` ( 1st o. g ) ` is a
       Cauchy sequence. $)
    bcthlem22 $p |- ( ( g : NN --> A /\ (
            ( 2nd ` ( g ` 1 ) ) < ( 1 / 2 ) /\
      A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) ->
           ( 1st o. g ) e. ( Cau ` D ) ) $=
      cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      wa c1st vg cv ccom cD cca cfv wcel cc0 vw cv clt wbr vm cv vn cv cle wbr
      vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vw cv clt wbr
      wi vn cn wral vm cn wrex wi vw cr wral cn cA vg cv wf c1 vg cv cfv c2nd
      cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa wa cc0 vw cv clt wbr vm cv vn cv
      cle wbr vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vw cv
      clt wbr wi vn cn wral vm cn wrex wi vw cr vx vy vz vw cA cD vg vj vk vm
      vn cF cJ cM cO cX vr vp bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7
      bcthlem18.8 bcthlem21 r19.21aiv cn cA vg cv wf c1st vg cv ccom cD cca cfv
      wcel cc0 vw cv clt wbr vm cv vn cv cle wbr vm cv c1st vg cv ccom cfv vn
      cv c1st vg cv ccom cfv cD co vw cv clt wbr wi vn cn wral vm cn wrex wi vw
      cr wral wb c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa cD
      cme wcel cn cX c1st vg cv ccom wf c1st vg cv ccom cD cca cfv wcel cc0 vw
      cv clt wbr vm cv vn cv cle wbr vm cv c1st vg cv ccom cfv vn cv c1st vg cv
      ccom cfv cD co vw cv clt wbr wi vn cn wral vm cn wrex wi vw cr wral wb cn
      cA vg cv wf vw cD vm vn c1st vg cv ccom c1 cX cn bcthlem18.3 1z nnuz
      iscauf cD bcthlem18.1 cmsmeti cn cA vg cv wf cn cX cc0 vx cv clt wbr vx
      cr crab cxp vg cv wf cn cX c1st vg cv ccom wf cA cX cc0 vx cv clt wbr vx
      cr crab cxp wceq cn cA vg cv wf cn cX cc0 vx cv clt wbr vx cr crab cxp vg
      cv wf wb bcthlem18.7 cA cX cc0 vx cv clt wbr vx cr crab cxp cn vg cv feq3
      ax-mp cn cX cc0 vx cv clt wbr vx cr crab vg cv 1stcof sylbi sylancr
      adantr mpbird $.
      $( [10-Nov-2007] $) $( [21-Oct-2007] $)

    $( Lemma for ~ bcth .  Since sequence of ball centers ` ( 1st o. g ) ` is a
       Cauchy sequence and the metric space is complete, the sequence converges
       to a point ` p ` in the metric space. $)
    bcthlem23 $p |- ( ( g : NN --> A /\ (
            ( 2nd ` ( g ` 1 ) ) < ( 1 / 2 ) /\
      A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) ->
           E. q e. X ( 1st o. g ) ( ~~>m ` D ) q ) $=
      cD cms wcel c1st vg cv ccom cD cca cfv wcel c1st vg cv ccom vq cv cD clm
      cfv wbr vq cX wrex cn cA vg cv wf c1 vg cv cfv c2nd cfv c1 c2 cdiv co clt
      wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa vq cD c1st vg cv ccom cX bcthlem18.3 cmscvg
      bcthlem18.1 vx vy vz cA cD vg vj vk cF cJ cM cO cX vr vp bcthlem18.1
      bcthlem18.3 bcthlem18.6 bcthlem18.7 bcthlem18.8 bcthlem22 sylancr $.
      $( [11-Nov-2007] $) $( [23-Oct-2007] $)

    $( Lemma for ~ bcth .  An upper limit for the distance between a ball
       center at ` m ` and the convergence point ` q ` , in terms of any later
       ball center at ` n ` . $)
    bcthlem24 $p |- ( ( ( ( n e. NN /\ q e. X ) /\ ( ( g : NN --> A /\
  A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) /\ m e. NN ) ) /\
        m < n ) -> ( ( ( 1st o. g ) ` m ) D q ) <
         ( ( ( 2nd ` ( g ` m ) ) / 2 ) + ( ( ( 1st o. g ) ` n ) D q ) ) ) $=
      vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel
      wa wa vm cv vn cv clt wbr wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv
      vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom
      cfv vq cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st
      vg cv ccom cfv vq cv cD co caddc co vn cv cn wcel vq cv cX wcel wa cn cA
      vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa vm cv cn wcel wa wa vm cv c1st vg cv ccom cfv vq cv
      cD co cr wcel vm cv vn cv clt wbr vn cv cn wcel vq cv cX wcel wa cn cA vg
      cv wf vm cv cn wcel vm cv c1st vg cv ccom cfv vq cv cD co cr wcel vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa vm cv
      c1st vg cv ccom cfv vq cv cD co cr wcel cn cA vg cv wf vm cv cn wcel wa
      vq cv cX wcel vm cv c1st vg cv ccom cfv vq cv cD co cr wcel vn cv cn wcel
      vm cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vm cv c1st vg cv ccom cfv
      vq cv cD co cr wcel cn cA vg cv wf vm cv cn wcel wa cD cme wcel vm cv
      c1st vg cv ccom cfv cX wcel vq cv cX wcel vm cv c1st vg cv ccom cfv vq cv
      cD co cr wcel cD bcthlem18.1 cmsmeti vm cv c1st vg cv ccom cfv vq cv cD
      cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vm cv cn wcel wa vm cv c1st vg
      cv ccom cfv vm cv vg cv cfv c1st cfv cX cA vg vm cv bcthlem3 cn cA vg cv
      wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd
      cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.26d eqeltrd sylan adantrl ancoms adantrlr adantr
      vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel
      wa wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st
      vg cv ccom cfv vq cv cD co caddc co cr wcel vm cv vn cv clt wbr vn cv cn
      wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv vq cv cD co
      caddc co cr wcel vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co wcel vk cn wral cn cA vg cv wf vm cv cn wcel wa vn cv cn
      wcel vq cv cX wcel wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co vn cv c1st vg cv ccom cfv vq cv cD co caddc co cr wcel vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel vn cv c1st vg cv ccom
      cfv vq cv cD co cr wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co vn cv c1st vg cv ccom cfv vq cv cD co caddc co cr wcel cn cA vg cv
      wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa wa vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv vq cv
      cD co readdcl cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel vq cv cX wcel vm cv
      vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st cfv cX wcel vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cn cA vg cv wf vm cv
      cn wcel wa vn cv cn wcel wa cD cme wcel vm cv vg cv cfv c1st cfv cX wcel
      vn cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co cr wcel cD bcthlem18.1 cmsmeti vm cv vg cv cfv c1st cfv vn
      cv vg cv cfv c1st cfv cD cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vm cv
      cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vn cv cn wcel cn cA vg cv wf
      vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd
      cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.26d adantr cn cA vg cv wf vn cv cn wcel vn cv vg
      cv cfv c1st cfv cX wcel vm cv cn wcel cn cA vg cv wf vn cv cn wcel wa vn
      cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv
      vg cv cfv c2nd cfv clt wbr wa vx cA vg vn cv cX bcthlem18.7 bcthlem4
      pm3.26d adantlr sylanc adantrr cn cA vg cv wf vn cv cn wcel vq cv cX wcel
      wa vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vm cv cn wcel cn cA vg
      cv wf vn cv cn wcel vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co
      cr wcel vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg cv
      ccom cfv vq cv cD co cr wcel cn cA vg cv wf vn cv cn wcel wa cD cme wcel
      vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg cv ccom cfv
      vq cv cD co cr wcel cD bcthlem18.1 cmsmeti vn cv c1st vg cv ccom cfv vq
      cv cD cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vn cv cn wcel wa vn cv
      c1st vg cv ccom cfv vn cv vg cv cfv c1st cfv cX cA vg vn cv bcthlem3 cn
      cA vg cv wf vn cv cn wcel wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv
      cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vn
      cv cX bcthlem18.7 bcthlem4 pm3.26d eqeltrd sylan anasss adantlr sylanc
      ancoms adantrlr adantr vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa vm cv cn wcel wa wa vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv
      c1st vg cv ccom cfv vq cv cD co caddc co cr wcel vm cv vn cv clt wbr vn
      cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv
      c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co cr
      wcel vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX
      wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq
      cv cD co caddc co cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel vn
      cv c1st vg cv ccom cfv vq cv cD co cr wcel vm cv vg cv cfv c2nd cfv c2
      cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co cr wcel cn cA vg
      cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa wa vm cv vg cv cfv
      c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co readdcl cn cA
      vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel vn
      cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv
      cfv c2nd cfv cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cn cA vg
      cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv
      cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st
      cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv
      clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d pm3.26d vm cv
      vg cv cfv c2nd cfv rehalfcl syl adantr cn cA vg cv wf vn cv cn wcel vq cv
      cX wcel wa vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vm cv cn wcel cn
      cA vg cv wf vn cv cn wcel vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv
      cD co cr wcel vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st
      vg cv ccom cfv vq cv cD co cr wcel cn cA vg cv wf vn cv cn wcel wa cD cme
      wcel vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg cv
      ccom cfv vq cv cD co cr wcel cD bcthlem18.1 cmsmeti vn cv c1st vg cv ccom
      cfv vq cv cD cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vn cv cn wcel wa
      vn cv c1st vg cv ccom cfv vn cv vg cv cfv c1st cfv cX cA vg vn cv
      bcthlem3 cn cA vg cv wf vn cv cn wcel wa vn cv vg cv cfv c1st cfv cX wcel
      vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa
      vx cA vg vn cv cX bcthlem18.7 bcthlem4 pm3.26d eqeltrd sylan anasss
      adantlr sylanc ancoms adantrlr adantr vn cv cn wcel vq cv cX wcel wa cn
      cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv c1st vg cv ccom cfv vq
      cv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv
      c1st vg cv ccom cfv vq cv cD co caddc co cle wbr vm cv vn cv clt wbr vn
      cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel vm cv c1st vg cv
      ccom cfv vq cv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD
      co vn cv c1st vg cv ccom cfv vq cv cD co caddc co cle wbr vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral cn
      cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa vm cv c1st vg
      cv ccom cfv vq cv cD co vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co vn cv c1st vg cv ccom cfv vq cv cD co caddc co cle wbr cn cA vg cv
      wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa wa vm cv c1st vg cv
      ccom cfv vq cv cD co vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv
      cD co vn cv c1st vg cv ccom cfv vq cv cD co caddc co vm cv vg cv cfv c1st
      cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv vq cv cD co
      caddc co cle vx cA cD vg vm vn cX vq bcthlem18.1 bcthlem18.3 bcthlem18.7
      bcthlem11 cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa
      wa vm cv c1st vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv vq
      cv cD co caddc cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vm cv c1st
      vg cv ccom cfv vn cv c1st vg cv ccom cfv cD co vm cv vg cv cfv c1st cfv
      vn cv vg cv cfv c1st cfv cD co wceq vq cv cX wcel cn cA vg cv wf vm cv cn
      wcel wa vn cv cn wcel wa vm cv c1st vg cv ccom cfv vm cv vg cv cfv c1st
      cfv vn cv c1st vg cv ccom cfv vn cv vg cv cfv c1st cfv cD cn cA vg cv wf
      vm cv cn wcel wa vm cv c1st vg cv ccom cfv vm cv vg cv cfv c1st cfv wceq
      vn cv cn wcel cA vg vm cv bcthlem3 adantr cn cA vg cv wf vn cv cn wcel vn
      cv c1st vg cv ccom cfv vn cv vg cv cfv c1st cfv wceq vm cv cn wcel cA vg
      vn cv bcthlem3 adantlr opreq12d adantrr opreq1d breqtrd ancoms adantrlr
      adantr vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv
      cn wcel wa wa vm cv vn cv clt wbr wa vm cv vg cv cfv c1st cfv vn cv vg cv
      cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg
      cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv
      vq cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv
      ccom cfv vq cv cD co caddc co clt wbr vn cv cn wcel cn cA vg cv wf vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa vm cv vn cv clt wbr vm cv vg cv cfv c1st cfv vn
      cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr
      vq cv cX wcel vx vy vz cA cD vg vj vk vm vn cF cJ cM cO cX vr vp
      bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7 bcthlem18.8 bcthlem19
      adantllr vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm
      cv cn wcel wa wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co
      vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c1st cfv vn
      cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv vq cv cD co caddc
      co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD
      co caddc co clt wbr wb vm cv vn cv clt wbr vn cv cn wcel vq cv cX wcel wa
      cn cA vg cv wf vm cv cn wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv
      c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv
      cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom cfv vq
      cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv
      ccom cfv vq cv cD co caddc co clt wbr wb vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral cn cA vg cv wf vm cv
      cn wcel wa vn cv cn wcel vq cv cX wcel wa vm cv vg cv cfv c1st cfv vn cv
      vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv
      ccom cfv vq cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv
      c1st vg cv ccom cfv vq cv cD co caddc co clt wbr wb cn cA vg cv wf vm cv
      cn wcel wa vn cv cn wcel vq cv cX wcel vm cv vg cv cfv c1st cfv vn cv vg
      cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv
      vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv c1st vg cv ccom
      cfv vq cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st
      vg cv ccom cfv vq cv cD co caddc co clt wbr wb vm cv vg cv cfv c1st cfv
      vn cv vg cv cfv c1st cfv cD co cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv
      co cr wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv
      co clt wbr vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co vn cv
      c1st vg cv ccom cfv vq cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv
      co vn cv c1st vg cv ccom cfv vq cv cD co caddc co clt wbr wb cn cA vg cv
      wf vm cv cn wcel wa vn cv cn wcel wa vq cv cX wcel wa vm cv vg cv cfv
      c1st cfv vn cv vg cv cfv c1st cfv cD co vm cv vg cv cfv c2nd cfv c2 cdiv
      co vn cv c1st vg cv ccom cfv vq cv cD co ltadd1 cn cA vg cv wf vm cv cn
      wcel wa vn cv cn wcel wa vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st
      cfv cD co cr wcel vq cv cX wcel vm cv vg cv cfv c1st cfv cX wcel vn cv vg
      cv cfv c1st cfv cX wcel vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv
      cD co cr wcel cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel wa cD cme
      wcel vm cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c1st cfv cX wcel vm
      cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD co cr wcel cD
      bcthlem18.1 cmsmeti vm cv vg cv cfv c1st cfv vn cv vg cv cfv c1st cfv cD
      cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vm cv cn wcel wa vm cv vg cv
      cfv c1st cfv cX wcel vn cv cn wcel cn cA vg cv wf vm cv cn wcel wa vm cv
      vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg
      cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.26d
      adantr cn cA vg cv wf vn cv cn wcel vn cv vg cv cfv c1st cfv cX wcel vm
      cv cn wcel cn cA vg cv wf vn cv cn wcel wa vn cv vg cv cfv c1st cfv cX
      wcel vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt
      wbr wa vx cA vg vn cv cX bcthlem18.7 bcthlem4 pm3.26d adantlr sylanc
      adantr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv
      co cr wcel vn cv cn wcel vq cv cX wcel cn cA vg cv wf vm cv cn wcel wa vm
      cv vg cv cfv c2nd cfv cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel
      cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm
      cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv
      cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv
      c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d
      pm3.26d vm cv vg cv cfv c2nd cfv rehalfcl syl ad2antrr cn cA vg cv wf vn
      cv cn wcel vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vm
      cv cn wcel vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg
      cv ccom cfv vq cv cD co cr wcel cn cA vg cv wf vn cv cn wcel wa cD cme
      wcel vn cv c1st vg cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg cv
      ccom cfv vq cv cD co cr wcel cD bcthlem18.1 cmsmeti vn cv c1st vg cv ccom
      cfv vq cv cD cX bcthlem18.3 metcl mp3an1 cn cA vg cv wf vn cv cn wcel wa
      vn cv c1st vg cv ccom cfv vn cv vg cv cfv c1st cfv cX cA vg vn cv
      bcthlem3 cn cA vg cv wf vn cv cn wcel wa vn cv vg cv cfv c1st cfv cX wcel
      vn cv vg cv cfv c2nd cfv cr wcel cc0 vn cv vg cv cfv c2nd cfv clt wbr wa
      vx cA vg vn cv cX bcthlem18.7 bcthlem4 pm3.26d eqeltrd sylan adantllr
      syl3anc anasss ancoms adantrlr adantr mpbid lelttrd $.
      $( [12-Nov-2007] $) $( [23-Oct-2007] $)

    $( Lemma for ~ bcth .  Helper lemma to remove the dependence on ` n ` of
       the upper limit in ~ bcthlem24 . $)
    bcthlem25 $p |- ( ( ( ( ( n e. NN /\ q e. X ) /\ ( ( g : NN --> A /\
  A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) /\ m e. NN ) ) /\
        m < n ) /\
    ( ( ( 1st o. g ) ` n ) D q ) < ( ( 2nd ` ( g ` m ) ) / 2 ) ) ->
        ( ( ( 1st o. g ) ` m ) D q ) < ( 2nd ` ( g ` m ) ) ) $=
      vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv
      vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel
      wa wa vm cv vn cv clt wbr wa vn cv c1st vg cv ccom cfv vq cv cD co vm cv
      vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv c1st vg cv ccom cfv vq cv cD
      co vm cv vg cv cfv c2nd cfv clt wbr vn cv cn wcel vq cv cX wcel wa cn cA
      vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn cv clt wbr wa vn cv
      c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt
      wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv
      cD co caddc co vm cv vg cv cfv c2nd cfv clt wbr vm cv c1st vg cv ccom cfv
      vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr vn cv cn wcel vq cv cX wcel
      wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vn cv c1st vg cv ccom
      cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv
      cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co vm
      cv vg cv cfv c2nd cfv clt wbr wb vm cv vn cv clt wbr vn cv cn wcel vq cv
      cX wcel wa cn cA vg cv wf vm cv cn wcel vn cv c1st vg cv ccom cfv vq cv
      cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c2nd
      cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co vm cv vg cv
      cfv c2nd cfv clt wbr wb vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk
      cv vg cv cfv cF co wcel vk cn wral cn cA vg cv wf vm cv cn wcel wa vn cv
      cn wcel vq cv cX wcel wa vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg
      cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vn
      cv c1st vg cv ccom cfv vq cv cD co caddc co vm cv vg cv cfv c2nd cfv clt
      wbr wb cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX wcel wa wa
      vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq
      cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv
      c2nd cfv c2 cdiv co caddc co clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co
      vn cv c1st vg cv ccom cfv vq cv cD co caddc co vm cv vg cv cfv c2nd cfv
      clt wbr vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vm cv vg cv cfv
      c2nd cfv c2 cdiv co cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel
      vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co
      clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq
      cv cD co caddc co vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv
      c2nd cfv c2 cdiv co caddc co clt wbr wb cn cA vg cv wf vm cv cn wcel wa
      vn cv cn wcel vq cv cX wcel wa wa vn cv c1st vg cv ccom cfv vq cv cD co
      vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv c2nd cfv c2 cdiv co
      ltadd2 cn cA vg cv wf vn cv cn wcel vq cv cX wcel wa vn cv c1st vg cv
      ccom cfv vq cv cD co cr wcel vm cv cn wcel cn cA vg cv wf vn cv cn wcel
      vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vn cv c1st vg
      cv ccom cfv cX wcel vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co
      cr wcel cn cA vg cv wf vn cv cn wcel wa cD cme wcel vn cv c1st vg cv ccom
      cfv cX wcel vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel
      cD bcthlem18.1 cmsmeti vn cv c1st vg cv ccom cfv vq cv cD cX bcthlem18.3
      metcl mp3an1 cn cA vg cv wf vn cv cn wcel wa vn cv c1st vg cv ccom cfv vn
      cv vg cv cfv c1st cfv cX cA vg vn cv bcthlem3 cn cA vg cv wf vn cv cn
      wcel wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel
      cc0 vn cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vn cv cX bcthlem18.7
      bcthlem4 pm3.26d eqeltrd sylan anasss adantlr cn cA vg cv wf vm cv cn
      wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel vn cv cn wcel vq cv
      cX wcel wa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr
      wcel vm cv vg cv cfv c2nd cfv c2 cdiv co cr wcel cn cA vg cv wf vm cv cn
      wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt
      wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm
      cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx
      cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d pm3.26d vm cv vg cv cfv c2nd
      cfv rehalfcl syl adantr cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv
      c2nd cfv c2 cdiv co cr wcel vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf
      vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel vm cv vg cv cfv c2nd
      cfv c2 cdiv co cr wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv
      c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm
      cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv
      cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.27d pm3.26d vm cv vg cv cfv c2nd cfv rehalfcl
      syl adantr syl3anc cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX
      wcel wa wa vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv c2nd cfv
      c2 cdiv co caddc co vm cv vg cv cfv c2nd cfv vm cv vg cv cfv c2nd cfv c2
      cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co clt cn cA vg cv wf
      vm cv cn wcel wa vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv c2nd
      cfv c2 cdiv co caddc co vm cv vg cv cfv c2nd cfv wceq vn cv cn wcel vq cv
      cX wcel wa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cc
      wcel vm cv vg cv cfv c2nd cfv c2 cdiv co vm cv vg cv cfv c2nd cfv c2 cdiv
      co caddc co vm cv vg cv cfv c2nd cfv wceq cn cA vg cv wf vm cv cn wcel wa
      vm cv vg cv cfv c2nd cfv cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv
      c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm
      cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv
      cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.27d pm3.26d recnd vm cv vg cv cfv c2nd cfv
      2halves syl adantr breq2d bitrd ancoms adantrlr adantr vn cv cn wcel vq
      cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn
      cv clt wbr wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd
      cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co clt wbr vm
      cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co
      caddc co vm cv vg cv cfv c2nd cfv clt wbr vm cv c1st vg cv ccom cfv vq cv
      cD co vm cv vg cv cfv c2nd cfv clt wbr vx vy vz cA cD vg vj vk vm vn cF
      cJ cM cO cX vr vq vp bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7
      bcthlem18.8 bcthlem24 vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv
      vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc
      co clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv
      vq cv cD co caddc co vm cv vg cv cfv c2nd cfv clt wbr wa vm cv c1st vg cv
      ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wi vm cv vn cv clt
      wbr vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel vm cv
      c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv
      c1st vg cv ccom cfv vq cv cD co caddc co clt wbr vm cv vg cv cfv c2nd cfv
      c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co vm cv vg cv cfv
      c2nd cfv clt wbr wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv clt wbr wi vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral cn cA vg cv wf vm cv cn wcel wa vn cv cn
      wcel vq cv cX wcel wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv
      cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co
      clt wbr vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq
      cv cD co caddc co vm cv vg cv cfv c2nd cfv clt wbr wa vm cv c1st vg cv
      ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wi vm cv c1st vg cv
      ccom cfv vq cv cD co cr wcel vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv
      c1st vg cv ccom cfv vq cv cD co caddc co cr wcel vm cv vg cv cfv c2nd cfv
      cr wcel vm cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co clt wbr vm cv vg
      cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc co
      vm cv vg cv cfv c2nd cfv clt wbr wa vm cv c1st vg cv ccom cfv vq cv cD co
      vm cv vg cv cfv c2nd cfv clt wbr wi cn cA vg cv wf vm cv cn wcel wa vn cv
      cn wcel vq cv cX wcel wa wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv
      vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co caddc
      co vm cv vg cv cfv c2nd cfv axlttrn cn cA vg cv wf vm cv cn wcel wa vq cv
      cX wcel vm cv c1st vg cv ccom cfv vq cv cD co cr wcel vn cv cn wcel vm cv
      c1st vg cv ccom cfv cX wcel vq cv cX wcel vm cv c1st vg cv ccom cfv vq cv
      cD co cr wcel cn cA vg cv wf vm cv cn wcel wa cD cme wcel vm cv c1st vg
      cv ccom cfv cX wcel vq cv cX wcel vm cv c1st vg cv ccom cfv vq cv cD co
      cr wcel cD bcthlem18.1 cmsmeti vm cv c1st vg cv ccom cfv vq cv cD cX
      bcthlem18.3 metcl mp3an1 cn cA vg cv wf vm cv cn wcel wa vm cv c1st vg cv
      ccom cfv vm cv vg cv cfv c1st cfv cX cA vg vm cv bcthlem3 cn cA vg cv wf
      vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd
      cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX
      bcthlem18.7 bcthlem4 pm3.26d eqeltrd sylan adantrl vm cv vg cv cfv c2nd
      cfv c2 cdiv co cr wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vm
      cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv vq cv cD co
      caddc co cr wcel cn cA vg cv wf vm cv cn wcel wa vn cv cn wcel vq cv cX
      wcel wa wa vm cv vg cv cfv c2nd cfv c2 cdiv co vn cv c1st vg cv ccom cfv
      vq cv cD co readdcl cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd
      cfv c2 cdiv co cr wcel vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm
      cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel vm cv vg cv cfv c2nd cfv
      c2 cdiv co cr wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd
      cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn
      wcel wa vm cv vg cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel
      cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7
      bcthlem4 pm3.27d pm3.26d vm cv vg cv cfv c2nd cfv rehalfcl syl adantr cn
      cA vg cv wf vn cv cn wcel vq cv cX wcel wa vn cv c1st vg cv ccom cfv vq
      cv cD co cr wcel vm cv cn wcel cn cA vg cv wf vn cv cn wcel vq cv cX wcel
      vn cv c1st vg cv ccom cfv vq cv cD co cr wcel vn cv c1st vg cv ccom cfv
      cX wcel vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel cn cA
      vg cv wf vn cv cn wcel wa cD cme wcel vn cv c1st vg cv ccom cfv cX wcel
      vq cv cX wcel vn cv c1st vg cv ccom cfv vq cv cD co cr wcel cD
      bcthlem18.1 cmsmeti vn cv c1st vg cv ccom cfv vq cv cD cX bcthlem18.3
      metcl mp3an1 cn cA vg cv wf vn cv cn wcel wa vn cv c1st vg cv ccom cfv vn
      cv vg cv cfv c1st cfv cX cA vg vn cv bcthlem3 cn cA vg cv wf vn cv cn
      wcel wa vn cv vg cv cfv c1st cfv cX wcel vn cv vg cv cfv c2nd cfv cr wcel
      cc0 vn cv vg cv cfv c2nd cfv clt wbr wa vx cA vg vn cv cX bcthlem18.7
      bcthlem4 pm3.26d eqeltrd sylan anasss adantlr sylanc cn cA vg cv wf vm cv
      cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel vn cv cn wcel vq cv cX wcel
      wa cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0
      vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vm cv cn wcel wa vm cv vg
      cv cfv c1st cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv
      cfv c2nd cfv clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d
      pm3.26d adantr syl3anc ancoms adantrlr adantr mpand sylbid imp $.
      $( [12-Nov-2007] $) $( [24-Oct-2007] $)

    $( Lemma for ~ bcth .  The convergence point ` q ` belongs to every ball
       in sequence ` g ` . $)
    bcthlem26 $p |- ( ( ( q e. X /\ ( ( g : NN --> A /\
  A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) /\ m e. NN ) ) /\
          ( 1st o. g ) ( ~~>m ` D ) q ) -> q e. ( ( 1st ` ( g ` m ) )
        ( ball ` D ) ( 2nd ` ( g ` m ) ) ) ) $=
      vq cv cX wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa c1st vg
      cv ccom vq cv cD clm cfv wbr wa vq cv vm cv vg cv cfv c1st cfv vm cv vg
      cv cfv c2nd cfv cD cbl cfv co wcel vm cv vg cv cfv c1st cfv vq cv cD co
      vm cv vg cv cfv c2nd cfv clt wbr vq cv cX wcel cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa wa c1st vg cv ccom vq cv cD clm cfv wbr wa vm cv
      vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd
      cfv c2 cdiv co clt wbr wa vn cn wrex vm cv vg cv cfv c1st cfv vq cv cD co
      vm cv vg cv cfv c2nd cfv clt wbr cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn
      wcel wa c1st vg cv ccom vq cv cD clm cfv wbr vm cv vn cv clt wbr vn cv
      c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt
      wbr wa vn cn wrex vq cv cX wcel cn cA vg cv wf vm cv cn wcel c1st vg cv
      ccom vq cv cD clm cfv wbr vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv
      vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vn cn wrex vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral vx cA cD vg vm vn cX vq bcthlem18.1 bcthlem18.3 bcthlem18.7
      bcthlem13 adantllr adantll vq cv cX wcel cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm
      cv cn wcel wa wa vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD
      co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vn cn wrex vm cv vg cv
      cfv c1st cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wi c1st vg cv
      ccom vq cv cD clm cfv wbr vq cv cX wcel cn cA vg cv wf vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm
      cv cn wcel wa wa vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD
      co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vm cv vg cv cfv c1st
      cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr vn cn vn cv cn wcel vq
      cv cX wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn cv
      clt wbr vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv c2
      cdiv co clt wbr wa vm cv vg cv cfv c1st cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv clt wbr wi vn cv cn wcel vq cv cX wcel cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq
      cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr wa vm cv vg cv cfv
      c1st cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wi vn cv cn wcel vq
      cv cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn
      cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv
      c2 cdiv co clt wbr vm cv vg cv cfv c1st cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv clt wbr vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa vm cv cn wcel wa wa vm cv vn cv clt wbr vn cv c1st vg cv ccom cfv
      vq cv cD co vm cv vg cv cfv c2nd cfv c2 cdiv co clt wbr vm cv vg cv cfv
      c1st cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr vn cv cn wcel vq cv
      cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv vn cv
      clt wbr wa vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c2nd cfv
      c2 cdiv co clt wbr wa vm cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv
      cfv c1st cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt vn cv cn wcel vq cv
      cX wcel wa cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa wa vm cv c1st
      vg cv ccom cfv vq cv cD co vm cv vg cv cfv c1st cfv vq cv cD co wceq vm
      cv vn cv clt wbr vn cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv
      c2nd cfv c2 cdiv co clt wbr cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa
      vm cv c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c1st cfv vq cv cD
      co wceq vn cv cn wcel vq cv cX wcel wa cn cA vg cv wf vm cv cn wcel vm cv
      c1st vg cv ccom cfv vq cv cD co vm cv vg cv cfv c1st cfv vq cv cD co wceq
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral cn cA vg cv wf vm cv cn wcel wa vm cv c1st vg cv ccom cfv vm
      cv vg cv cfv c1st cfv vq cv cD cA vg vm cv bcthlem3 opreq1d adantlr
      adantl ad2antrr vx vy vz cA cD vg vj vk vm vn cF cJ cM cO cX vr vq vp
      bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7 bcthlem18.8 bcthlem25
      eqbrtrrd exp31 imp3a anasss expcom r19.23adv adantr mpd vq cv cX wcel cn
      cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa vm cv cn wcel wa wa vq cv vm cv vg cv cfv c1st
      cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co wcel vm cv vg cv cfv c1st cfv
      vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wb c1st vg cv ccom vq cv cD
      clm cfv wbr vq cv cX wcel cn cA vg cv wf vm cv cn wcel vq cv vm cv vg cv
      cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co wcel vm cv vg cv cfv
      c1st cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wb vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral vm
      cv vg cv cfv c1st cfv cX wcel vq cv cX wcel wa vm cv vg cv cfv c2nd cfv
      cr wcel cc0 vm cv vg cv cfv c2nd cfv clt wbr wa vq cv vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co wcel vm cv vg cv cfv c1st
      cfv vq cv cD co vm cv vg cv cfv c2nd cfv clt wbr wb vq cv cX wcel cn cA
      vg cv wf vm cv cn wcel wa wa cD cme wcel vm cv vg cv cfv c1st cfv cX wcel
      vq cv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd
      cfv clt wbr wa vq cv vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD
      cbl cfv co wcel vm cv vg cv cfv c1st cfv vq cv cD co vm cv vg cv cfv c2nd
      cfv clt wbr wb cD bcthlem18.1 cmsmeti vq cv cD vm cv vg cv cfv c1st cfv
      vm cv vg cv cfv c2nd cfv cX bcthlem18.3 elbl2 mp3anl1 vq cv cX wcel cn cA
      vg cv wf vm cv cn wcel wa wa vm cv vg cv cfv c1st cfv cX wcel vq cv cX
      wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX wcel vq
      cv cX wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st cfv cX
      wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt
      wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.26d adantl vq cv cX
      wcel cn cA vg cv wf vm cv cn wcel wa pm3.26 jca cn cA vg cv wf vm cv cn
      wcel wa vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv clt
      wbr wa vq cv cX wcel cn cA vg cv wf vm cv cn wcel wa vm cv vg cv cfv c1st
      cfv cX wcel vm cv vg cv cfv c2nd cfv cr wcel cc0 vm cv vg cv cfv c2nd cfv
      clt wbr wa vx cA vg vm cv cX bcthlem18.7 bcthlem4 pm3.27d adantl sylanc
      adantrlr adantr mpbird $.
      $( [12-Nov-2007] $) $( [24-Oct-2007] $)

    $( Lemma for ~ bcth .  The convergence point ` q ` belongs to the
       complement of the interior of any member of reference sequence
       ` M ` . $)
    bcthlem27 $p |- ( ( ( q e. X /\
  ( ( g :  NN --> A /\ ( ( ( 1st ` ( g ` 1 ) )
    ( ball ` D ) ( 2nd ` ( g ` 1 ) ) ) C_ ( X \ ( ( cls ` J ) ` ( M ` 1 )
    ) ) /\ A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) /\
    m e. NN ) ) /\
          ( 1st o. g ) ( ~~>m ` D ) q ) -> q e.
    ( X \ ( ( cls ` J ) ` ( M ` m ) ) ) ) $=
      vq cv cX wcel cn cA vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv
      cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm
      cv cn wcel wa wa c1st vg cv ccom vq cv cD clm cfv wbr wa vm cv vg cv cfv
      c1st cfv vm cv vg cv cfv c2nd cfv cD cbl cfv co cX vm cv cM cfv cJ ccl
      cfv cfv cdif vq cv cn cA vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd
      cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vm cv cn wcel wa vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv cD cbl
      cfv co cX vm cv cM cfv cJ ccl cfv cfv cdif wss vq cv cX wcel c1st vg cv
      ccom vq cv cD clm cfv wbr vy vz cA cD vg vj vk vm cF cJ cM cO cX vr vp
      bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.8 bcthlem16 ad2antlr vq cv
      cX wcel cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk
      cv vg cv cfv cF co wcel vk cn wral wa vm cv cn wcel wa c1st vg cv ccom vq
      cv cD clm cfv wbr vq cv vm cv vg cv cfv c1st cfv vm cv vg cv cfv c2nd cfv
      cD cbl cfv co wcel cn cA vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd
      cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vm cv cn wcel wa vx vy vz cA cD vg vj vk vm cF cJ cM cO cX vr vq vp
      bcthlem18.1 bcthlem18.3 bcthlem18.6 bcthlem18.7 bcthlem18.8 bcthlem26 cn
      cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral vm cv cn wcel cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv
      cn wcel wa c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa vm cv cn
      wcel wa id adantlrl sylanl2 sseldd $.
      $( [12-Nov-2007] $) $( [25-Oct-2007] $)
  $}

  ${
    $d g j k m p q y z A $.  $d g j k m p q r x y z D $.  $d g k m q F $.
    $d g j m p q r x y z J $.  $d g j m p q r x y z M $.  $d p r z O $.
    $d g m q Q $.  $d g j m k p q r x y z X $.
    bcthlem29.1 $e |- D e. CMet $.
    bcthlem29.3 $e |- X = dom dom D $.
    bcthlem29.4 $e |- J = ( Open ` D ) $.
    bcthlem29.5 $e |- M : NN --> ~P X $.
    bcthlem29.6 $e |- F = { <. <. j , y >. , z >. | ( ( j e. NN /\ y e. A )
  /\ z = { <. p , r >. | ( ( p e. X /\ ( r e. RR /\ 0 < r ) ) /\
     ( r < ( ( 2nd ` y ) / 2 ) /\ ( p ( ball ` D ) r ) C_ O ) ) } ) } $.
    bcthlem29.7 $e |- A = ( X X. { x e. RR | 0 < x } ) $.
    bcthlem29.8 $e |- O = ( ( X \ ( ( cls ` J ) ` ( M ` j ) ) ) i^i
          ( ( 1st ` y ) ( ball ` D ) ( ( 2nd ` y ) / 2 ) ) ) $.
    $( Lemma for ~ bcth .  The convergence point ` q ` does not belong to any
       member of reference sequence ` M ` . $)
    bcthlem28 $p |- ( ( ( ( q e. X /\ ( ( 1st ` Q ) ( ball ` D )
     ( 2nd ` Q ) ) C_ ( X \ ( ( cls ` J ) ` ( M ` 1 ) ) ) ) /\
   ( g : NN --> A /\ ( ( g ` 1 ) = Q /\ A. k e. NN ( g ` ( k + 1 ) )
    e. ( ( k + 1 ) F ( g ` k ) ) ) ) ) /\ ( 1st o. g ) ( ~~>m ` D ) q ) ->
         -. E. m e. NN q e. ( M ` m ) ) $=
      vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl
      cfv cfv cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      wa c1st vg cv ccom vq cv cD clm cfv wbr wa vq cv vm cv cM cfv wcel wn vm
      cn wral vq cv vm cv cM cfv wcel vm cn wrex wn vq cv cX wcel cQ c1st cfv
      cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss wa cn cA
      vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa wa c1st vg cv ccom vq cv
      cD clm cfv wbr wa vq cv vm cv cM cfv wcel wn vm cn vq cv cX wcel cQ c1st
      cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss wa cn
      cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa wa c1st vg cv ccom
      vq cv cD clm cfv wbr vm cv cn wcel vq cv vm cv cM cfv wcel wn wi vq cv cX
      wcel cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv
      cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa wa vm
      cv cn wcel c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv cM cfv wcel
      wn vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ
      ccl cfv cfv cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa vm cv cn wcel c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv
      cM cfv wcel wn wi wi vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl cfv co
      cX c1 cM cfv cJ ccl cfv cfv cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa vm cv cn wcel c1st vg cv ccom vq cv cD clm cfv wbr
      vq cv vm cv cM cfv wcel wn vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl
      cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv
      cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa wa vm cv cn wcel wa c1st vg cv ccom vq cv cD clm
      cfv wbr vq cv vm cv cM cfv wcel wn cn cA vg cv wf c1 vg cv cfv cQ wceq vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa vm cv cn wcel wa cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss vq cv cX wcel c1st vg cv ccom vq cv cD
      clm cfv wbr vq cv vm cv cM cfv wcel wn wi cn cA vg cv wf c1 vg cv cfv cQ
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa vm cv cn wcel wa cQ c1st cfv cQ c2nd cfv cD cbl cfv
      co cX c1 cM cfv cJ ccl cfv cfv cdif wss c1 vg cv cfv c1st cfv c1 vg cv
      cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vq cv cX
      wcel c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv cM cfv wcel wn wi
      wi c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk
      cv vg cv cfv cF co wcel vk cn wral wa c1 vg cv cfv c1st cfv c1 vg cv cfv
      c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cQ c1st cfv
      cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss wb cn cA
      vg cv wf vm cv cn wcel c1 vg cv cfv cQ wceq c1 vg cv cfv c1st cfv c1 vg
      cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cQ
      c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss
      wb vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral c1 vg cv cfv cQ wceq c1 vg cv cfv c1st cfv c1 vg cv cfv
      c2nd cfv cD cbl cfv co cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv
      cJ ccl cfv cfv cdif c1 vg cv cfv cQ wceq c1 vg cv cfv c1st cfv cQ c1st
      cfv c1 vg cv cfv c2nd cfv cQ c2nd cfv cD cbl cfv c1 vg cv cfv cQ c1st
      fveq2 c1 vg cv cfv cQ c2nd fveq2 opreq12d sseq1d adantr ad2antlr cn cA vg
      cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral vm cv cn wcel c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv
      cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vq cv cX wcel c1st vg
      cv ccom vq cv cD clm cfv wbr vq cv vm cv cM cfv wcel wn wi wi wi c1 vg cv
      cfv cQ wceq cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc co
      vk cv vg cv cfv cF co wcel vk cn wral vm cv cn wcel c1 vg cv cfv c1st cfv
      c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss
      vq cv cX wcel c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv cM cfv
      wcel wn wi wi wi cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral c1 vg cv cfv c1st cfv c1
      vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vm
      cv cn wcel vq cv cX wcel c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv
      cM cfv wcel wn wi wi cn cA vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv
      c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral vm cv cn wcel vq cv cX wcel c1st vg cv ccom vq cv cD clm cfv wbr vq
      cv vm cv cM cfv wcel wn wi wi wi cn cA vg cv wf c1 vg cv cfv c1st cfv c1
      vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral vm cv cn wcel vq cv cX wcel c1st vg cv ccom vq cv cD clm cfv wbr
      vq cv vm cv cM cfv wcel wn wi wi wi vq cv cX wcel cn cA vg cv wf c1 vg cv
      cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv
      cfv cdif wss vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral wa wa vm cv cn wcel c1st vg cv ccom vq cv cD
      clm cfv wbr vq cv vm cv cM cfv wcel wn wi vq cv cX wcel cn cA vg cv wf c1
      vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ
      ccl cfv cfv cdif wss vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel c1st vg cv ccom vq cv
      cD clm cfv wbr vq cv vm cv cM cfv wcel wn vq cv cX wcel cn cA vg cv wf c1
      vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1 cM cfv cJ
      ccl cfv cfv cdif wss vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel wa wa c1st vg cv ccom
      vq cv cD clm cfv wbr wa vq cv cX vm cv cM cfv cJ ccl cfv cfv cdif wcel vq
      cv vm cv cM cfv wcel wn vx vy vz cA cD vg vj vk vm cF cJ cM cO cX vr vq
      vp bcthlem29.1 bcthlem29.3 bcthlem29.6 bcthlem29.7 bcthlem29.8 bcthlem27
      cn cA vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co
      cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co vg cv cfv vk cv c1
      caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel wa vq
      cv cX vm cv cM cfv cJ ccl cfv cfv cdif wcel vq cv vm cv cM cfv wcel wn wi
      vq cv cX wcel c1st vg cv ccom vq cv cD clm cfv wbr vm cv cn wcel vq cv cX
      vm cv cM cfv cJ ccl cfv cfv cdif wcel vq cv vm cv cM cfv wcel wn wi cn cA
      vg cv wf c1 vg cv cfv c1st cfv c1 vg cv cfv c2nd cfv cD cbl cfv co cX c1
      cM cfv cJ ccl cfv cfv cdif wss vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa vm cv cn wcel vq cv vm cv
      cM cfv wcel vq cv vm cv cM cfv cJ ccl cfv cfv wcel vq cv cX vm cv cM cfv
      cJ ccl cfv cfv cdif wcel vm cv cn wcel vm cv cM cfv vm cv cM cfv cJ ccl
      cfv cfv vq cv cJ ctop wcel vm cv cM cfv cX wss vm cv cM cfv vm cv cM cfv
      cJ ccl cfv cfv wss vm cv cn wcel vm cv cM cfv cJ cX cD cJ cX bcthlem29.1
      bcthlem29.3 bcthlem29.4 bcthlem5 sscls cD cJ cX bcthlem29.1 bcthlem29.3
      bcthlem29.4 bcthlem6 vm cv cn wcel vm cv cM cfv cX cpw wcel vm cv cM cfv
      cX wss cn cX cpw vm cv cM bcthlem29.5 ffvelrni vm cv cM cfv cX elpwi syl
      sylancr sseld vq cv cX vm cv cM cfv cJ ccl cfv cfv eldifn nsyli adantl
      ad2antlr mpd exp42 com3l exp32 com23 com34 imp31 adantlrl sylbird com13
      imp41 exp42 imp com23 imp r19.21aiv vq cv vm cv cM cfv wcel vm cn ralnex
      sylib $.
      $( [13-Nov-2007] $) $( [25-Oct-2007] $)

    $( Lemma for ~ bcth .  Therefore the union of all members of reference
       sequence ` M ` does not occupy the entire metric space ` X ` .  Also,
       use metric space completeness (via  ~ bcthlem23 ) to eliminate the limit
       point ` q ` from the antecedents. $)
    bcthlem29 $p |- ( ( ( ( 2nd ` Q ) < ( 1 / 2 ) /\ ( ( 1st ` Q )
      ( ball ` D ) ( 2nd ` Q ) ) C_ ( X \ ( ( cls ` J ) ` ( M ` 1 ) ) ) )
       /\ ( g : NN --> A /\ ( ( g ` 1 ) = Q /\ A. k e. NN ( g ` ( k + 1 ) ) e.
           ( ( k + 1 ) F ( g ` k ) ) ) ) ) -> -. U. ran M = X ) $=
      cQ c2nd cfv c1 c2 cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD cbl cfv co
      cX c1 cM cfv cJ ccl cfv cfv cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral wa wa wa c1st vg cv ccom vq cv cD clm cfv wbr vq cX wrex
      cM crn cuni cX wceq wn cQ c2nd cfv c1 c2 cdiv co clt wbr cn cA vg cv wf
      c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral wa wa c1st vg cv ccom vq cv cD clm cfv
      wbr vq cX wrex cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl
      cfv cfv cdif wss cQ c2nd cfv c1 c2 cdiv co clt wbr cn cA vg cv wf c1 vg
      cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv
      cfv cF co wcel vk cn wral c1st vg cv ccom vq cv cD clm cfv wbr vq cX wrex
      c1 vg cv cfv cQ wceq cQ c2nd cfv c1 c2 cdiv co clt wbr cn cA vg cv wf vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral c1st vg cv ccom vq cv cD clm cfv wbr vq cX wrex wi c1 vg cv cfv
      cQ wceq cQ c2nd cfv c1 c2 cdiv co clt wbr c1 vg cv cfv c2nd cfv c1 c2
      cdiv co clt wbr cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral c1st vg cv ccom vq cv cD clm cfv
      wbr vq cX wrex wi wi c1 vg cv cfv cQ wceq c1 vg cv cfv c2nd cfv cQ c2nd
      cfv c1 c2 cdiv co clt c1 vg cv cfv cQ c2nd fveq2 breq1d cn cA vg cv wf c1
      vg cv cfv c2nd cfv c1 c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk
      cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral c1st vg cv ccom vq
      cv cD clm cfv wbr vq cX wrex wi cn cA vg cv wf c1 vg cv cfv c2nd cfv c1
      c2 cdiv co clt wbr vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg
      cv cfv cF co wcel vk cn wral c1st vg cv ccom vq cv cD clm cfv wbr vq cX
      wrex vx vy vz cA cD vg vj vk cF cJ cM cO cX vr vq vp bcthlem29.1
      bcthlem29.3 bcthlem29.6 bcthlem29.7 bcthlem29.8 bcthlem23 exp32 com12
      syl6bir com3l imp45 adantlr cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1
      cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral wa wa c1st vg cv ccom vq cv cD clm cfv wbr vq cX wrex cM crn cuni cX
      wceq wn wi cQ c2nd cfv c1 c2 cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD
      cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv
      cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa wa wa c1st vg cv ccom vq cv cD clm cfv wbr cM
      crn cuni cX wceq wn vq cX vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl
      cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv
      cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa wa wa c1st vg cv ccom vq cv cD clm cfv wbr cM crn
      cuni cX wceq wn wi vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv cQ wceq vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral wa wa wa c1st vg cv ccom vq cv cD clm cfv wbr cM crn cuni cX wceq
      wn vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ
      ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc
      co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa
      wa wa c1st vg cv ccom vq cv cD clm cfv wbr wa vq cv vm cv cM cfv wcel vm
      cn wrex cM crn cuni cX wceq vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl
      cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv
      cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa wa c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv
      cM cfv wcel vm cn wrex wn vq cv cX wcel cQ c1st cfv cQ c2nd cfv cD cbl
      cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss cn cA vg cv wf c1 vg cv cfv
      cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral wa wa c1st vg cv ccom vq cv cD clm cfv wbr vq cv vm cv
      cM cfv wcel vm cn wrex wn vx vy vz cA cD cQ vg vj vk vm cF cJ cM cO cX vr
      vq vp bcthlem29.1 bcthlem29.3 bcthlem29.4 bcthlem29.5 bcthlem29.6
      bcthlem29.7 bcthlem29.8 bcthlem28 exp41 imp4c cM crn cuni cX wceq vq cv
      cX wcel vq cv vm cv cM cfv wcel vm cn wrex cM crn cuni cX wceq vq cv cX
      wcel wa vq cv cM crn cuni wcel vq cv vm cv cM cfv wcel vm cn wrex cM crn
      cuni cX wceq vq cv cM crn cuni wcel vq cv cX wcel cM crn cuni cX vq cv
      eleq2 biimpar vq cv cM crn cuni wcel vq cv vm cv cM cfv wcel vm cM cdm
      wrex vq cv vm cv cM cfv wcel vm cn wrex cM wfun vq cv cM crn cuni wcel vq
      cv vm cv cM cfv wcel vm cM cdm wrex wb cn cX cpw cM wf cM wfun
      bcthlem29.5 cn cX cpw cM ffun ax-mp vm vq cv cM elunirn ax-mp cM cdm cn
      wceq vq cv vm cv cM cfv wcel vm cM cdm wrex vq cv vm cv cM cfv wcel vm cn
      wrex wb cn cX cpw cM bcthlem29.5 fdmi vq cv vm cv cM cfv wcel vm cM cdm
      cn rexeq1 ax-mp bitri sylib expcom nsyld exp3a com12 r19.23adv adantll
      mpd $.
      $( [13-Nov-2007] $) $( [29-Oct-2007] $)

    $( Lemma for ~ bcth .  Apply the Axiom of Dependent Choice ~ acdc5 to show
       the existence of the recursive sequence of balls ` g ` . $)
    bcthlem30 $p |- ( ( A. j e. NN ( ( int ` J ) `
        ( ( cls ` J ) ` ( M ` j ) ) ) = (/) /\ Q e. A ) ->
      E. g ( g : NN --> A /\ ( g ` 1 ) = Q /\
         A. k e. NN ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) $=
      cn cA cxp cA cpw c0 csn cdif cF wf cQ cA wcel cn cA vg cv wf c1 vg cv cfv
      cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF
      co wcel vk cn wral w3a vg wex vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv
      c0 wceq vj cn wral cA cQ vg vk cF cA cX cc0 vx cv clt wbr vx cr crab cxp
      cvv bcthlem29.7 cX cc0 vx cv clt wbr vx cr crab cX cD cdm cdm cvv
      bcthlem29.3 cD cdm cD cms wcel cD cdm cvv wcel bcthlem29.1 cD cms dmexg
      ax-mp dmex eqeltri cc0 vx cv clt wbr vx cr reex rabex xpex eqeltri acdc5
      vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vj cn wral vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv
      co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA cpw c0
      csn cdif wcel vy cA wral vj cn wral cn cA cxp cA cpw c0 csn cdif cF wf vj
      cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA cpw c0 csn cdif wcel
      vy cA wral vj cn vj cv cn wcel vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv
      c0 wceq wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy
      cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp
      vr copab cA cpw c0 csn cdif wcel vy cA vj cv cn wcel vj cv cM cfv cJ ccl
      cfv cfv cJ cnt cfv cfv c0 wceq wa vy cv cA wcel wa vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA cpw wcel vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt
      wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab c0 wne wa vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv
      co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA cpw c0
      csn cdif wcel vj cv cn wcel vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0
      wceq wa vy cv cA wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO
      wss wa wa vp vr copab c0 wne vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp cv vr cv cD cbl cfv
      co cO wss wa wa vp vr copab cA cpw wcel vj cv cM cfv cX wss vj cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cn wcel vy cv cA wcel wa
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab c0
      wne vj cv cn wcel vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa
      vy cv cA wcel wa vx vy cA cD vj cJ cM cO cX vr vp bcthlem29.1 bcthlem29.3
      bcthlem29.4 bcthlem29.7 bcthlem29.8 bcthlem14 vj cv cn wcel vj cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vj cv cM cfv cX wss vj cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vy cv cA wcel vj cv cn wcel vj
      cv cM cfv cX wss vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vj cv
      cn wcel vj cv cM cfv cX cpw wcel vj cv cM cfv cX wss cn cX cpw vj cv cM
      bcthlem29.5 ffvelrni vj cv cM cfv cX elpwi syl anim1i adantr vj cv cn
      wcel vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vy cv cA wcel
      wa vj cv cn wcel vy cv cA wcel vj cv cn wcel vj cv cM cfv cJ ccl cfv cfv
      cJ cnt cfv cfv c0 wceq vy cv cA wcel simpll vj cv cn wcel vj cv cM cfv cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq wa vy cv cA wcel pm3.27 jca sylanc vx
      vy cA cD cO cX vr vp bcthlem29.1 bcthlem29.3 bcthlem29.7 bcthlem12 jctil
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv
      c2 cdiv co clt wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA
      cpw c0 eldifsn sylibr r19.21aiva r19.20ia vj vy vz cn cA vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt
      wbr vp cv vr cv cD cbl cfv co cO wss wa wa vp vr copab cA cpw c0 csn cdif
      cF bcthlem29.6 foprab2 sylib sylan $.
      $( [14-Nov-2007] $) $( [11-Oct-2007] $)

    $( Lemma for ~ bcth .  Eliminate the antecedents involving sequence
       ` g ` . $)
    bcthlem31 $p |- ( ( ( ( 2nd ` Q ) < ( 1 / 2 ) /\ ( ( 1st ` Q )
   ( ball ` D ) ( 2nd ` Q ) ) C_ ( X \ ( ( cls ` J ) ` ( M ` 1 ) ) ) ) /\
  ( A. j e. NN ( ( int ` J ) ` ( ( cls ` J ) ` ( M ` j ) ) ) = (/) /\
             Q e. A ) ) -> -. U. ran M = X ) $=
      cQ c2nd cfv c1 c2 cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD cbl cfv co
      cX c1 cM cfv cJ ccl cfv cfv cdif wss wa vj cv cM cfv cJ ccl cfv cfv cJ
      cnt cfv cfv c0 wceq vj cn wral cQ cA wcel wa wa cn cA vg cv wf c1 vg cv
      cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv
      cF co wcel vk cn wral wa wa vg wex cM crn cuni cX wceq wn cQ c2nd cfv c1
      c2 cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ
      ccl cfv cfv cdif wss wa vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0
      wceq vj cn wral cQ cA wcel wa wa cn cA vg cv wf c1 vg cv cfv cQ wceq vk
      cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk
      cn wral w3a vg wex cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vg wex vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vj cn wral cQ
      cA wcel wa cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv
      cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex cQ
      c2nd cfv c1 c2 cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss wa vx vy vz cA cD cQ vg vj vk cF cJ cM
      cO cX vr vp bcthlem29.1 bcthlem29.3 bcthlem29.4 bcthlem29.5 bcthlem29.6
      bcthlem29.7 bcthlem29.8 bcthlem30 adantl cn cA vg cv wf c1 vg cv cfv cQ
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral w3a cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      vg cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv
      c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral 3anass exbii sylib cQ
      c2nd cfv c1 c2 cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ wceq
      vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel
      vk cn wral wa wa vg wex cM crn cuni cX wceq wn wi vj cv cM cfv cJ ccl cfv
      cfv cJ cnt cfv cfv c0 wceq vj cn wral cQ cA wcel wa cQ c2nd cfv c1 c2
      cdiv co clt wbr cQ c1st cfv cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl
      cfv cfv cdif wss wa cn cA vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral wa wa
      cM crn cuni cX wceq wn vg cQ c2nd cfv c1 c2 cdiv co clt wbr cQ c1st cfv
      cQ c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss wa cn cA
      vg cv wf c1 vg cv cfv cQ wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral wa wa cM crn cuni cX wceq wn vx
      vy vz cA cD cQ vg vj vk cF cJ cM cO cX vr vp bcthlem29.1 bcthlem29.3
      bcthlem29.4 bcthlem29.5 bcthlem29.6 bcthlem29.7 bcthlem29.8 bcthlem29 ex
      19.23adv adantr mpd $.
      $( [15-Nov-2007] $) $( [29-Oct-2007] $)
  $}

  ${
    $d j p y z A $.  $d j p r x y z D $.  $d j p r x y z J $.
    $d j p r x y z M $.  $d j p r x y z X $.  $d s x $.
    bcthlem33.1 $e |- D e. CMet $.
    bcthlem33.3 $e |- X = dom dom D $.
    bcthlem33.4 $e |- J = ( Open ` D ) $.
    bcthlem33.5 $e |- M : NN --> ~P X $.
    $( Lemma for ~ bcth .  Eliminate hypotheses no longer needed. $)
    bcthlem32 $p |- ( ( ( s < ( 1 / 2 ) /\ ( q ( ball ` D ) s )
   C_ ( X \ ( ( cls ` J ) ` ( M ` 1 ) ) ) ) /\ ( A. j e. NN ( ( int ` J ) `
   ( ( cls ` J ) ` ( M ` j ) ) ) = (/) /\ ( q e. X /\ ( s e. RR /\ 0 < s ) )
         ) ) -> -. U. ran M = X ) $=
      vq cv vs cv cop c2nd cfv c1 c2 cdiv co clt wbr vq cv vs cv cop c1st cfv
      vq cv vs cv cop c2nd cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif
      wss wa vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vj cn wral vq
      cv vs cv cop cX cc0 vx cv clt wbr vx cr crab cxp wcel wa cM crn cuni cX
      wceq wn vs cv c1 c2 cdiv co clt wbr vq cv vs cv cD cbl cfv co cX c1 cM
      cfv cJ ccl cfv cfv cdif wss wa vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv
      c0 wceq vj cn wral vq cv cX wcel vs cv cr wcel cc0 vs cv clt wbr wa wa wa
      vx vy vz cX cc0 vx cv clt wbr vx cr crab cxp cD vq cv vs cv cop vj vj cv
      cn wcel vy cv cX cc0 vx cv clt wbr vx cr crab cxp wcel wa vz cv vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv
      co clt wbr vp cv vr cv cD cbl cfv co cX vj cv cM cfv cJ ccl cfv cfv cdif
      vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp
      vr copab wceq wa vj vy vz copab2 cJ cM cX vj cv cM cfv cJ ccl cfv cfv
      cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin cX vr vp
      bcthlem33.1 bcthlem33.3 bcthlem33.4 bcthlem33.5 vj cv cn wcel vy cv cX
      cc0 vx cv clt wbr vx cr crab cxp wcel wa vz cv vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa wa vr cv vy cv c2nd cfv c2 cdiv co clt wbr vp
      cv vr cv cD cbl cfv co cX vj cv cM cfv cJ ccl cfv cfv cdif vy cv c1st cfv
      vy cv c2nd cfv c2 cdiv co cD cbl cfv co cin wss wa wa vp vr copab wceq wa
      vj vy vz copab2 eqid cX cc0 vx cv clt wbr vx cr crab cxp eqid cX vj cv cM
      cfv cJ ccl cfv cfv cdif vy cv c1st cfv vy cv c2nd cfv c2 cdiv co cD cbl
      cfv co cin eqid bcthlem31 vq cv vs cv cop c2nd cfv c1 c2 cdiv co clt wbr
      vs cv c1 c2 cdiv co clt wbr vq cv vs cv cop c1st cfv vq cv vs cv cop c2nd
      cfv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vq cv vs cv cD cbl
      cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vq cv vs cv cop c2nd cfv vs
      cv c1 c2 cdiv co clt vq cv vs cv vq visset vs visset op2nd breq1i vq cv
      vs cv cop c1st cfv vq cv vs cv cop c2nd cfv cD cbl cfv co vq cv vs cv cD
      cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif vq cv vs cv cop c1st cfv vq
      cv vq cv vs cv cop c2nd cfv vs cv cD cbl cfv vq cv vs cv vq visset op1st
      vq cv vs cv vq visset vs visset op2nd opreq12i sseq1i anbi12i vq cv vs cv
      cop cX cc0 vx cv clt wbr vx cr crab cxp wcel vq cv cX wcel vs cv cr wcel
      cc0 vs cv clt wbr wa wa vj cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0
      wceq vj cn wral vq cv vs cv cop cX cc0 vx cv clt wbr vx cr crab cxp wcel
      vq cv cX wcel vs cv cc0 vx cv clt wbr vx cr crab wcel wa vq cv cX wcel vs
      cv cr wcel cc0 vs cv clt wbr wa wa vq cv vs cv cX cc0 vx cv clt wbr vx cr
      crab vs visset opelxp vs cv cc0 vx cv clt wbr vx cr crab wcel vs cv cr
      wcel cc0 vs cv clt wbr wa vq cv cX wcel cc0 vx cv clt wbr cc0 vs cv clt
      wbr vx vs cv cr vx cv vs cv cc0 clt breq2 elrab anbi2i bitri anbi2i
      syl2anbr $.
      $( [15-Nov-2007] $) $( [25-Oct-2007] $)
  $}

  ${
    $d j A $.  $d j k s x D $.  $d j k q s x J $.  $d j k q s x M $.
    $d j k q s x X $.
    bcthlem34.1 $e |- D e. CMet $.
    bcthlem34.2 $e |- X =/= (/) $.
    bcthlem34.3 $e |- X = dom dom D $.
    bcthlem34.4 $e |- J = ( Open ` D ) $.
    bcthlem34.5 $e |- M : NN --> ~P X $.
    $( Lemma for ~ bcth .  All members of reference sequence ` M ` cannot
       have an empty interior. $)
    bcthlem33 $p |- ( ( U. ran M = X /\ ran M C_ ( Clsd ` J ) )
           -> E. k e. NN ( ( int ` J ) ` ( M ` k ) ) =/= (/) ) $=
      cM crn cuni cX wceq cM crn cJ ccld cfv wss wa vk cv cM cfv cJ cnt cfv cfv
      c0 wceq vk cn wral wn vk cv cM cfv cJ cnt cfv cfv c0 wne vk cn wrex cM
      crn cuni cX wceq cM crn cJ ccld cfv wss wa vk cv cM cfv cJ ccl cfv cfv cJ
      cnt cfv cfv c0 wceq vk cn wral wn vk cv cM cfv cJ cnt cfv cfv c0 wceq vk
      cn wral wn cM crn cuni cX wceq vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv
      c0 wceq vk cn wral wn cM crn cJ ccld cfv wss vk cv cM cfv cJ ccl cfv cfv
      cJ cnt cfv cfv c0 wceq vk cn wral cM crn cuni cX wceq vk cv cM cfv cJ ccl
      cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cc0 vs cv clt wbr vs cv c1 c2
      c1 cexp co cdiv co clt wbr vq cv vs cv cD cbl cfv co cX c1 cM cfv cJ ccl
      cfv cfv cdif wss w3a vs cr wrex vq cX c1 cM cfv cJ ccl cfv cfv cdif wrex
      cM crn cuni cX wceq wn vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq
      vk cn wral c1 cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq cX c1 cM cfv
      cJ ccl cfv cfv cdif c0 wne cX c1 cM cfv cJ ccl cfv cfv cdif cJ wcel wa
      cc0 vs cv clt wbr vs cv c1 c2 c1 cexp co cdiv co clt wbr vq cv vs cv cD
      cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss w3a vs cr wrex vq cX c1
      cM cfv cJ ccl cfv cfv cdif wrex c1 cn wcel vk cv cM cfv cJ ccl cfv cfv cJ
      cnt cfv cfv c0 wceq vk cn wral c1 cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0
      wceq wi 1nn vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq c1 cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk c1 cn vk cv c1 wceq vk cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c1 cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0
      vk cv c1 wceq vk cv cM cfv cJ ccl cfv cfv c1 cM cfv cJ ccl cfv cfv cJ cnt
      cfv vk cv c1 wceq vk cv cM cfv c1 cM cfv cJ ccl cfv vk cv c1 cM fveq2
      fveq2d fveq2d eqeq1d rcla4v ax-mp c1 cM cfv cX wss c1 cM cfv cJ ccl cfv
      cfv cJ cnt cfv cfv c0 wceq cX c1 cM cfv cJ ccl cfv cfv cdif c0 wne cX c1
      cM cfv cJ ccl cfv cfv cdif cJ wcel wa c1 cM cfv cX cpw wcel c1 cM cfv cX
      wss c1 cn wcel c1 cM cfv cX cpw wcel 1nn cn cX cpw c1 cM bcthlem34.5
      ffvelrni ax-mp c1 cM cfv cX elpwi ax-mp cD cJ c1 cM cfv cX bcthlem34.1
      bcthlem34.3 bcthlem34.4 bcthlem34.2 bcthlem10 mpan cX c1 cM cfv cJ ccl
      cfv cfv cdif c0 wne cX c1 cM cfv cJ ccl cfv cfv cdif cJ wcel c1 cn wcel
      cc0 vs cv clt wbr vs cv c1 c2 c1 cexp co cdiv co clt wbr vq cv vs cv cD
      cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss w3a vs cr wrex vq cX c1
      cM cfv cJ ccl cfv cfv cdif wrex 1nn vs cD cJ c1 cX c1 cM cfv cJ ccl cfv
      cfv cdif cX vq bcthlem34.1 bcthlem34.3 bcthlem34.4 bcthlem8 mp3an3 3syl
      vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cc0 vs cv
      clt wbr vs cv c1 c2 c1 cexp co cdiv co clt wbr vq cv vs cv cD cbl cfv co
      cX c1 cM cfv cJ ccl cfv cfv cdif wss w3a cM crn cuni cX wceq wn vq vs cX
      c1 cM cfv cJ ccl cfv cfv cdif cr vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv
      cfv c0 wceq vk cn wral vq cv cX wcel vs cv cr wcel cc0 vs cv clt wbr vs
      cv c1 c2 c1 cexp co cdiv co clt wbr vq cv vs cv cD cbl cfv co cX c1 cM
      cfv cJ ccl cfv cfv cdif wss w3a cM crn cuni cX wceq wn wi vq cv cX c1 cM
      cfv cJ ccl cfv cfv cdif wcel cc0 vs cv clt wbr vs cv c1 c2 c1 cexp co
      cdiv co clt wbr vq cv vs cv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv
      cdif wss w3a vq cv cX wcel vs cv cr wcel wa vk cv cM cfv cJ ccl cfv cfv
      cJ cnt cfv cfv c0 wceq vk cn wral cM crn cuni cX wceq wn cc0 vs cv clt
      wbr vs cv c1 c2 c1 cexp co cdiv co clt wbr vq cv vs cv cD cbl cfv co cX
      c1 cM cfv cJ ccl cfv cfv cdif wss vq cv cX wcel vs cv cr wcel wa vk cv cM
      cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cM crn cuni cX wceq
      wn wi wi cc0 vs cv clt wbr vs cv c1 c2 cdiv co clt wbr vq cv vs cv cD cbl
      cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vq cv cX wcel vs cv cr wcel
      wa vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cM crn
      cuni cX wceq wn wi wi wi vs cv c1 c2 c1 cexp co cdiv co clt wbr vq cv cX
      wcel vs cv cr wcel wa cc0 vs cv clt wbr vs cv c1 c2 cdiv co clt wbr vq cv
      vs cv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv cM cfv cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cM crn cuni cX wceq wn wi
      vq cv cX wcel vs cv cr wcel cc0 vs cv clt wbr vs cv c1 c2 cdiv co clt wbr
      vq cv vs cv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv cM
      cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cM crn cuni cX wceq
      wn wi wi wi wi vq cv cX wcel vs cv cr wcel cc0 vs cv clt wbr vs cv c1 c2
      cdiv co clt wbr vq cv vs cv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv
      cdif wss vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral cM
      crn cuni cX wceq wn wi wi wi vs cv c1 c2 cdiv co clt wbr vq cv vs cv cD
      cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv cM cfv cJ ccl cfv
      cfv cJ cnt cfv cfv c0 wceq vk cn wral vq cv cX wcel vs cv cr wcel cc0 vs
      cv clt wbr wa wa cM crn cuni cX wceq wn vs cv c1 c2 cdiv co clt wbr vq cv
      vs cv cD cbl cfv co cX c1 cM cfv cJ ccl cfv cfv cdif wss vk cv cM cfv cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral vq cv cX wcel vs cv cr wcel
      cc0 vs cv clt wbr wa wa cM crn cuni cX wceq wn cD vk cJ cM cX vs vq
      bcthlem34.1 bcthlem34.3 bcthlem34.4 bcthlem34.5 bcthlem32 exp43 com4r
      exp32 imp com4l c1 c2 c1 cexp co cdiv co c1 c2 cdiv co vs cv clt c2 c1
      cexp co c2 c1 cdiv c2 cc wcel c2 c1 cexp co c2 wceq 2cn c2 exp1 ax-mp
      opreq2i breq2i syl5ib 3imp com13 vq cv cX c1 cM cfv cJ ccl cfv cfv eldifi
      sylani r19.23advv mpd con2i adantr cM crn cJ ccld cfv wss vk cv cM cfv cJ
      ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral wn vk cv cM cfv cJ cnt cfv
      cfv c0 wceq vk cn wral wn wb cM crn cuni cX wceq cM crn cJ ccld cfv wss
      vk cv cM cfv cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cn wral vk cv cM
      cfv cJ cnt cfv cfv c0 wceq vk cn wral cM crn cJ ccld cfv wss vk cv cM cfv
      cJ ccl cfv cfv cJ cnt cfv cfv c0 wceq vk cv cM cfv cJ cnt cfv cfv c0 wceq
      vk cn cM crn cJ ccld cfv wss vk cv cn wcel wa vk cv cM cfv cJ ccl cfv cfv
      cJ cnt cfv cfv vk cv cM cfv cJ cnt cfv cfv c0 cM crn cJ ccld cfv wss vk
      cv cn wcel wa vk cv cM cfv cJ ccl cfv cfv vk cv cM cfv cJ cnt cfv cJ ctop
      wcel vk cv cM cfv cJ ccld cfv wcel vk cv cM cfv cJ ccl cfv cfv vk cv cM
      cfv wceq cM crn cJ ccld cfv wss vk cv cn wcel wa vk cv cM cfv cJ cldcls
      cD cJ cX bcthlem34.1 bcthlem34.3 bcthlem34.4 bcthlem6 cn cJ ccld cfv cM
      wf vk cv cn wcel vk cv cM cfv cJ ccld cfv wcel cM crn cJ ccld cfv wss cn
      cJ ccld cfv vk cv cM ffvelrn cn cM crn cM wf cM crn cJ ccld cfv wss cn cJ
      ccld cfv cM wf cM cn wfn cn cM crn cM wf cn cX cpw cM wf cM cn wfn
      bcthlem34.5 cn cX cpw cM ffn ax-mp cn cM dffn3 mpbi cn cM crn cJ ccld cfv
      cM fss mpan sylan sylancr fveq2d eqeq1d ralbidva notbid adantl mpbid vk
      cv cM cfv cJ cnt cfv cfv c0 wne vk cn wrex vk cv cM cfv cJ cnt cfv cfv c0
      wceq wn vk cn wrex vk cv cM cfv cJ cnt cfv cfv c0 wceq vk cn wral wn vk
      cv cM cfv cJ cnt cfv cfv c0 wne vk cv cM cfv cJ cnt cfv cfv c0 wceq wn vk
      cn vk cv cM cfv cJ cnt cfv cfv c0 df-ne rexbii vk cv cM cfv cJ cnt cfv
      cfv c0 wceq vk cn rexnal bitr2i sylib $.
      $( [15-Nov-2007] $) $( [25-Oct-2007] $)
  $}

  ${
    $d k D $.  $d k J $.  $d k M $.  $d k X $.
    bcth.1 $e |- X = dom dom D $.
    bcth.2 $e |- J = ( Open ` D ) $.
    $( Baire's Category Theorem.  If a nonempty metric space is complete, it
       is nonmeager in itself.  In other words, the metric space cannot be the
       countable union of rare closed subsets (where rare means having an
       empty interior), so some subset ` M `` k ` must have a nonempty
       interior.   Theorem 4.7-2 of [Kreyszig] p. 247.  (The terminology
       "meager" and "nonmeager" is used by Kreyszig to replace Baire's "of the
       first category" and "of the second category."  The latter terms are
       going out of favor to avoid confusion with category theory.) $)
    bcth $p |- ( ( ( D e. CMet /\ X =/= (/) /\ M : NN --> ~P X ) /\
      ( U. ran M = X /\ ran M C_ ( Clsd ` J ) ) ) ->
               E. k e. NN ( ( int ` J ) ` ( M ` k ) ) =/= (/) ) $=
      cD cms wcel cX c0 wne cn cX cpw cM wf w3a cM crn cuni cX wceq cM crn cJ
      ccld cfv wss wa vk cv cM cfv cJ cnt cfv cfv c0 wne vk cn wrex cD cms wcel
      cX c0 wne cn cX cpw cM wf cM crn cuni cX wceq cM crn cJ ccld cfv wss wa
      vk cv cM cfv cJ cnt cfv cfv c0 wne vk cn wrex wi cD cms wcel cX c0 wne wa
      cn cX cpw cM wf cM crn cuni cX wceq cM crn cJ ccld cfv wss wa vk cv cM
      cfv cJ cnt cfv cfv c0 wne vk cn wrex wi wi cn cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif cdm cdm cpw cM wf cM crn cuni cD cms wcel cX c0 wne wa
      cD cabs cmin ccom cif cdm cdm wceq cM crn cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif copn cfv ccld cfv wss wa vk cv cM cfv cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn wrex wi
      wi cD cabs cmin ccom cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      wceq cn cX cpw cM wf cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      cdm cdm cpw cM wf cM crn cuni cX wceq cM crn cJ ccld cfv wss wa vk cv cM
      cfv cJ cnt cfv cfv c0 wne vk cn wrex wi cM crn cuni cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif cdm cdm wceq cM crn cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif copn cfv ccld cfv wss wa vk cv cM cfv cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn wrex wi
      cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cX cpw cD cms wcel
      cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw wceq cn cX cpw cM wf cn cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf wb cD cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cX cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif cdm cdm wceq cX cpw cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif cdm cdm cpw wceq cD cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif wceq cD cdm cdm cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm cX cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cD
      cdm cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cD cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif dmeq dmeqd bcth.1 syl5eq cX cD cms wcel
      cX c0 wne wa cD cabs cmin ccom cif cdm cdm pweq syl cX cpw cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cn cM feq3 syl cD cD cms wcel
      cX c0 wne wa cD cabs cmin ccom cif wceq cM crn cuni cX wceq cM crn cJ
      ccld cfv wss wa cM crn cuni cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm wceq cM crn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      copn cfv ccld cfv wss wa vk cv cM cfv cJ cnt cfv cfv c0 wne vk cn wrex vk
      cv cM cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv cnt cfv
      cfv c0 wne vk cn wrex cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      wceq cM crn cuni cX wceq cM crn cuni cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm wceq cM crn cJ ccld cfv wss cM crn cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif copn cfv ccld cfv wss cD cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif wceq cX cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm cM crn cuni cD cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif wceq cD cdm cdm cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm cX cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cD
      cdm cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cD cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif dmeq dmeqd bcth.1 syl5eq eqeq2d cD cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif wceq cJ ccld cfv cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif copn cfv ccld cfv cM crn cD cD cms wcel
      cX c0 wne wa cD cabs cmin ccom cif wceq cJ cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif copn cfv ccld cD cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif wceq cD copn cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      copn cfv cJ cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn fveq2
      bcth.2 syl5eq fveq2d sseq2d anbi12d cD cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif wceq vk cv cM cfv cJ cnt cfv cfv c0 wne vk cv cM cfv cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn
      cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq vk cv cM cfv cJ
      cnt cfv cfv vk cv cM cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      copn cfv cnt cfv cfv c0 cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      wceq vk cv cM cfv cJ cnt cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif copn cfv cnt cfv cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      wceq cJ cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv cnt cD cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cD copn cfv cD cms wcel
      cX c0 wne wa cD cabs cmin ccom cif copn cfv cJ cD cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif copn fveq2 bcth.2 syl5eq fveq2d fveq1d neeq1d
      rexbidv imbi12d imbi12d cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      cdm cdm cpw cM wf cM crn cuni cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm wceq cM crn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      copn cfv ccld cfv wss wa vk cv cM cfv cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn wrex wi cn cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif
      crn cuni cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm wceq cn
      cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0
      csn cxp cif crn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv
      ccld cfv wss wa vk cv cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      cdm cdm cpw cM wf cM cn c0 csn cxp cif cfv cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn wrex wi cM cn c0 csn
      cxp cM cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM
      wf cM cn c0 csn cxp cif wceq cM crn cuni cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm wceq cM crn cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif copn cfv ccld cfv wss wa cn cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif crn cuni cD cms wcel
      cX c0 wne wa cD cabs cmin ccom cif cdm cdm wceq cn cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif crn cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv ccld cfv wss wa vk
      cv cM cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv cnt cfv
      cfv c0 wne vk cn wrex vk cv cn cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm cpw cM wf cM cn c0 csn cxp cif cfv cD cms wcel cX c0 wne wa
      cD cabs cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn wrex cM cn cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn
      cxp cif wceq cM crn cuni cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      cdm cdm wceq cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm
      cpw cM wf cM cn c0 csn cxp cif crn cuni cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm wceq cM crn cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif copn cfv ccld cfv wss cn cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif crn cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif copn cfv ccld cfv wss cM cn cD cms wcel cX c0
      wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif wceq
      cM crn cuni cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw
      cM wf cM cn c0 csn cxp cif crn cuni cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cdm cdm cM cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm
      cdm cpw cM wf cM cn c0 csn cxp cif wceq cM crn cn cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif crn cM cn
      cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0
      csn cxp cif rneq unieqd eqeq1d cM cn cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif wceq cM crn cn cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0
      csn cxp cif crn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv
      ccld cfv cM cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw
      cM wf cM cn c0 csn cxp cif rneq sseq1d anbi12d cM cn cD cms wcel cX c0
      wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif wceq
      vk cv cM cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv cnt
      cfv cfv c0 wne vk cv cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      cdm cdm cpw cM wf cM cn c0 csn cxp cif cfv cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif copn cfv cnt cfv cfv c0 wne vk cn cM cn cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif
      wceq vk cv cM cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv
      cnt cfv cfv vk cv cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm
      cdm cpw cM wf cM cn c0 csn cxp cif cfv cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif copn cfv cnt cfv cfv c0 cM cn cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif wceq vk cv cM
      cfv vk cv cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw
      cM wf cM cn c0 csn cxp cif cfv cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif copn cfv cnt cfv vk cv cM cn cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif fveq1 fveq2d neeq1d
      rexbidv imbi12d cD cms wcel cX c0 wne wa cD cabs cmin ccom cif vk cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif copn cfv cn cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif cdm cdm cpw cM wf cM cn c0 csn cxp cif cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cD cms wcel cX c0 wne wa
      cD cabs cmin ccom cif cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm c0 wne cD cms wcel cX c0 wne wa cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm c0 wne wa cabs cmin ccom cms wcel cabs cmin ccom cdm cdm c0
      wne wa cD cabs cmin ccom cD cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif wceq cD cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cms
      wcel cX c0 wne cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm c0
      wne cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cms eleq1 cD cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif wceq cX cD cms wcel cX c0 wne wa
      cD cabs cmin ccom cif cdm cdm c0 cD cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif wceq cD cdm cdm cD cms wcel cX c0 wne wa cD cabs cmin ccom cif
      cdm cdm cX cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cD cdm
      cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cD cD cms wcel cX c0
      wne wa cD cabs cmin ccom cif dmeq dmeqd bcth.1 syl5eq neeq1d anbi12d cabs
      cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cabs cmin
      ccom cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cms wcel
      cabs cmin ccom cdm cdm c0 wne cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm c0 wne cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cms eleq1 cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif wceq cabs cmin ccom cdm cdm cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm c0 cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif wceq cabs cmin ccom cdm cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif dmeq dmeqd neeq1d anbi12d cabs cmin ccom cms wcel cabs cmin ccom
      cdm cdm c0 wne cabs cmin ccom cabs cmin ccom eqid cncms cc c0 wne cabs
      cmin ccom cdm cdm c0 wne cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp cc
      cabs cmin ccom cdm cdm c0 cabs cmin ccom cabs cmin ccom eqid cnmetba
      neeq1i mpbi pm3.2i elimhyp pm3.26i cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm
      c0 wne cD cms wcel cX c0 wne wa cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm
      c0 wne wa cabs cmin ccom cms wcel cabs cmin ccom cdm cdm c0 wne wa cD
      cabs cmin ccom cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cD
      cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cms wcel cX c0
      wne cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm c0 wne cD cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif cms eleq1 cD cD cms wcel cX
      c0 wne wa cD cabs cmin ccom cif wceq cX cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm c0 cD cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif wceq cD cdm cdm cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm
      cdm cX cD cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cD cdm cD
      cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cD cD cms wcel cX c0 wne
      wa cD cabs cmin ccom cif dmeq dmeqd bcth.1 syl5eq neeq1d anbi12d cabs
      cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin ccom cif wceq cabs cmin
      ccom cms wcel cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cms wcel
      cabs cmin ccom cdm cdm c0 wne cD cms wcel cX c0 wne wa cD cabs cmin ccom
      cif cdm cdm c0 wne cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cms eleq1 cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif wceq cabs cmin ccom cdm cdm cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm c0 cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif wceq cabs cmin ccom cdm cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cabs cmin ccom cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif dmeq dmeqd neeq1d anbi12d cabs cmin ccom cms wcel cabs cmin ccom
      cdm cdm c0 wne cabs cmin ccom cabs cmin ccom eqid cncms cc c0 wne cabs
      cmin ccom cdm cdm c0 wne cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp cc
      cabs cmin ccom cdm cdm c0 cabs cmin ccom cabs cmin ccom eqid cnmetba
      neeq1i mpbi pm3.2i elimhyp pm3.27i cD cms wcel cX c0 wne wa cD cabs cmin
      ccom cif cdm cdm eqid cD cms wcel cX c0 wne wa cD cabs cmin ccom cif copn
      cfv eqid cn cD cms wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw cM
      cn c0 csn cxp cn c0 csn cn c0 csn cxp wf c0 csn cD cms wcel cX c0 wne wa
      cD cabs cmin ccom cif cdm cdm cpw wss cn cD cms wcel cX c0 wne wa cD cabs
      cmin ccom cif cdm cdm cpw cn c0 csn cxp wf cn c0 0ex fconst c0 cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw wcel c0 csn cD cms
      wcel cX c0 wne wa cD cabs cmin ccom cif cdm cdm cpw wss cD cms wcel cX c0
      wne wa cD cabs cmin ccom cif cdm cdm 0elpw c0 cD cms wcel cX c0 wne wa cD
      cabs cmin ccom cif cdm cdm cpw snssi ax-mp cn c0 csn cD cms wcel cX c0
      wne wa cD cabs cmin ccom cif cdm cdm cpw cn c0 csn cxp fss mp2an elimf
      bcthlem33 dedth dedth 3impia imp $.
      $( [15-Nov-2007] $) $( [28-Oct-2007] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 Group theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Definitions and basic properties for groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Grp $.
  $c Id $.
  $c inv $.
  $c /g $.
  $c ^g $.

  $( Extend class notation with the class of all group operations. $)
  cgr $a class Grp $.

  $( Extend class notation with a function mapping a group operation to the
     group's identity element. $)
  cgi $a class Id $.

  $( Extend class notation with a function mapping a group operation to the
     inverse function for the group. $)
  cgn $a class inv $.

  $( Extend class notation with a function mapping a group operation to the
     division (or subtraction) operation for the group. $)
  cgs $a class /g $.

  $( Extend class notation with a function mapping a group operation to the
     power operation for the group. $)
  cgx $a class ^g $.

  ${
    $d f g t u x y z $.
    $( Define the class of all group operations.  The base set for a group
       can be determined from its group operation.  Based on the definition in
       Exercise 28 of [Herstein] p. 54. $)
    df-grp $a |- Grp = { g | E. t ( g : ( t X. t ) --> t
       /\ A. x e. t A. y e. t A. z e. t ( ( x g y ) g z ) = ( x g ( y g z ) )
   /\ E. u e. t A. x e. t ( ( u g x ) = x /\ E. y e. t ( y g x ) = u ) ) } $.

    $( Define a function that maps a group operation to the group's identity
       element. $)
    df-gid $a |- Id = { <. g , y >. | y =
                 U. { u e. ran g | A. x e. ran g ( ( u g x ) = x
                 /\ ( x g u ) = x ) } } $.

    $( Define a function that maps a group operation to the group's inverse
       function. $)
    df-ginv $a |- inv = { <. g , f >. | ( g e. Grp /\ f = { <. x , y >. |
      ( x e. ran g /\ y = U. { z e. ran g | ( z g x ) = ( Id ` g ) } ) } ) } $.

    $( Define a function that maps a group operation to the group's division
       (or subtraction) operation. $)
    df-gdiv $a |- /g = { <. g , f >. | ( g e. Grp /\ f = { <. <. x , y >. ,
    z >. | ( ( x e. ran g /\ y e. ran g ) /\
         z = ( x g ( ( inv ` g ) ` y ) ) ) } ) } $.

    $( Define a function that maps a group operation to the group's power
       operation. $)
    df-gx $a |- ^g = { <. g , f >. | ( g e. Grp /\ f = { <. <. x , y >. ,
      z >. | ( ( x e. ran g /\ y e. ZZ ) /\ z = if ( y = 0 , ( Id ` g ) ,
      if ( 0 < y , ( ( g seq1 ( NN X. { x } ) ) ` y ) ,
      ( ( inv ` g ) ` ( ( g seq1 ( NN X. { x } ) ) ` -u y ) ) ) ) ) } ) } $.
  $}

  ${
    $d g t u x y z G $.  $d g t u x y z X $.
    isgrp.1 $e |- X = ran G $.
    $( The predicate "is a group operation."  Note that ` X ` is the base set
       of the group. $)
    isgrp $p |- ( G e. A -> ( G e. Grp <-> ( G : ( X X. X ) --> X /\
       A. x e. X A. y e. X A. z e. X ( ( x G y ) G z ) = ( x G ( y G z ) )
   /\ E. u e. X A. x e. X ( ( u G x ) = x /\ E. y e. X ( y G x ) = u ) ) ) ) $=
      cG cA wcel cG cgr wcel vt cv cG crn wceq vt cv vt cv cxp vt cv cG wf vx
      cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv
      wral vy vt cv wral vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv
      cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex w3a wa vt
      wex cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG
      co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co vx cv
      wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex w3a
      cG cA wcel cG cgr wcel vt cv vt cv cxp vt cv cG wf vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv wral
      vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq
      vy vt cv wrex wa vx vt cv wral vu vt cv wrex w3a vt wex vt cv cG crn wceq
      vt cv vt cv cxp vt cv cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral vu cv vx cv
      cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx vt cv
      wral vu vt cv wrex w3a wa vt wex vt cv vt cv cxp vt cv vg cv wf vx cv vy
      cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg cv co vg cv co wceq vz vt
      cv wral vy vt cv wral vx vt cv wral vu cv vx cv vg cv co vx cv wceq vy cv
      vx cv vg cv co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex
      w3a vt wex vt cv vt cv cxp vt cv cG wf vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral
      vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex
      wa vx vt cv wral vu vt cv wrex w3a vt wex vg cG cgr cA vg cv cG wceq vt
      cv vt cv cxp vt cv vg cv wf vx cv vy cv vg cv co vz cv vg cv co vx cv vy
      cv vz cv vg cv co vg cv co wceq vz vt cv wral vy vt cv wral vx vt cv wral
      vu cv vx cv vg cv co vx cv wceq vy cv vx cv vg cv co vu cv wceq vy vt cv
      wrex wa vx vt cv wral vu vt cv wrex w3a vt cv vt cv cxp vt cv cG wf vx cv
      vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral
      vy vt cv wral vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG
      co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex w3a vt vg cv
      cG wceq vt cv vt cv cxp vt cv vg cv wf vt cv vt cv cxp vt cv cG wf vx cv
      vy cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg cv co vg cv co wceq vz
      vt cv wral vy vt cv wral vx vt cv wral vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral
      vu cv vx cv vg cv co vx cv wceq vy cv vx cv vg cv co vu cv wceq vy vt cv
      wrex wa vx vt cv wral vu vt cv wrex vu cv vx cv cG co vx cv wceq vy cv vx
      cv cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex vt cv vt
      cv cxp vt cv vg cv cG feq1 vg cv cG wceq vx cv vy cv vg cv co vz cv vg cv
      co vx cv vy cv vz cv vg cv co vg cv co wceq vz vt cv wral vx cv vy cv cG
      co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral vx vy vt
      cv vt cv vg cv cG wceq vx cv vy cv vg cv co vz cv vg cv co vx cv vy cv vz
      cv vg cv co vg cv co wceq vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz vt cv vg cv cG wceq vx cv vy cv vg cv co vz cv vg cv
      co vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv vg cv co vg cv co vx
      cv vy cv vz cv cG co cG co vg cv cG wceq vx cv vy cv vg cv co vz cv vg cv
      co vx cv vy cv vg cv co vz cv cG co vx cv vy cv cG co vz cv cG co vx cv
      vy cv vg cv co vz cv vg cv cG opreq vg cv cG wceq vx cv vy cv vg cv co vx
      cv vy cv cG co vz cv cG vx cv vy cv vg cv cG opreq opreq1d eqtrd vg cv cG
      wceq vx cv vy cv vz cv vg cv co vg cv co vx cv vy cv vz cv vg cv co cG co
      vx cv vy cv vz cv cG co cG co vx cv vy cv vz cv vg cv co vg cv cG opreq
      vg cv cG wceq vy cv vz cv vg cv co vy cv vz cv cG co vx cv cG vy cv vz cv
      vg cv cG opreq opreq2d eqtrd eqeq12d ralbidv 2ralbidv vg cv cG wceq vu cv
      vx cv vg cv co vx cv wceq vy cv vx cv vg cv co vu cv wceq vy vt cv wrex
      wa vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv
      wrex wa vu vx vt cv vt cv vg cv cG wceq vu cv vx cv vg cv co vx cv wceq
      vu cv vx cv cG co vx cv wceq vy cv vx cv vg cv co vu cv wceq vy vt cv
      wrex vy cv vx cv cG co vu cv wceq vy vt cv wrex vg cv cG wceq vu cv vx cv
      vg cv co vu cv vx cv cG co vx cv vu cv vx cv vg cv cG opreq eqeq1d vg cv
      cG wceq vy cv vx cv vg cv co vu cv wceq vy cv vx cv cG co vu cv wceq vy
      vt cv vg cv cG wceq vy cv vx cv vg cv co vy cv vx cv cG co vu cv vy cv vx
      cv vg cv cG opreq eqeq1d rexbidv anbi12d rexralbidv 3anbi123d exbidv vx
      vy vz vu vt vg df-grp elab2g vt cv vt cv cxp vt cv cG wf vx cv vy cv cG
      co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv
      wral vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv
      wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex w3a vt cv cG crn wceq
      vt cv vt cv cxp vt cv cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral vu cv vx cv
      cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx vt cv
      wral vu vt cv wrex w3a wa vt vt cv vt cv cxp vt cv cG wf vx cv vy cv cG
      co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv
      wral vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv
      wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex w3a vt cv cG crn wceq
      vt cv vt cv cxp vt cv cG wf vu cv vx cv cG co vx cv wceq vy cv vx cv cG
      co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex vt cv cG crn
      wceq vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      vt cv wral vy vt cv wral vx vt cv wral vt cv vt cv cxp vt cv cG wf vu cv
      vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx
      vt cv wral vu vt cv wrex wa vt cv vt cv cxp vt cv cG wfo vt cv cG crn
      wceq vt cv vt cv cxp vt cv cG wf vu cv vx cv cG co vx cv wceq vy cv vx cv
      cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex wa vt cv vt
      cv cxp vt cv cG wf vz cv vu cv vy cv cG co wceq vy vt cv wrex vu vt cv
      wrex vz vt cv wral wa vt cv vt cv cxp vt cv cG wfo vu cv vx cv cG co vx
      cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt
      cv wrex vz cv vu cv vy cv cG co wceq vy vt cv wrex vu vt cv wrex vz vt cv
      wral vt cv vt cv cxp vt cv cG wf vu cv vx cv cG co vx cv wceq vy cv vx cv
      cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex vz cv vu cv
      vy cv cG co wceq vy vt cv wrex vu vt cv wrex vz vt cv vz cv vt cv wcel vu
      cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa
      vx vt cv wral vu vt cv wrex vz cv vu cv vy cv cG co wceq vy vt cv wrex vu
      vt cv wrex vz cv vt cv wcel vu cv vx cv cG co vx cv wceq vy cv vx cv cG
      co vu cv wceq vy vt cv wrex wa vx vt cv wral vz cv vu cv vy cv cG co wceq
      vy vt cv wrex vu vt cv vz cv vt cv wcel vu cv vx cv cG co vx cv wceq vx
      vt cv wral vz cv vu cv vy cv cG co wceq vy vt cv wrex vu cv vx cv cG co
      vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vz
      cv vt cv wcel vu cv vx cv cG co vx cv wceq vx vt cv wral vz cv vu cv vz
      cv cG co wceq vz cv vu cv vy cv cG co wceq vy vt cv wrex vu cv vx cv cG
      co vx cv wceq vz cv vu cv vz cv cG co wceq vx vz cv vt cv vx cv vz cv
      wceq vu cv vx cv cG co vx cv wceq vu cv vz cv cG co vz cv wceq vz cv vu
      cv vz cv cG co wceq vx cv vz cv wceq vu cv vx cv cG co vu cv vz cv cG co
      vx cv vz cv vx cv vz cv vu cv cG opreq2 vx cv vz cv wceq id eqeq12d vu cv
      vz cv cG co vz cv eqcom syl6bb rcla4v vz cv vt cv wcel vz cv vu cv vz cv
      cG co wceq vz cv vu cv vy cv cG co wceq vy vt cv wrex vz cv vu cv vy cv
      cG co wceq vz cv vu cv vz cv cG co wceq vy vz cv vt cv vy cv vz cv wceq
      vu cv vy cv cG co vu cv vz cv cG co vz cv vy cv vz cv vu cv cG opreq2
      eqeq2d rcla4ev ex syld vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu
      cv wceq vy vt cv wrex wa vu cv vx cv cG co vx cv wceq vx vt cv vu cv vx
      cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex pm3.26
      r19.20si syl5 r19.22sdv impcom r19.21aiva anim2i vu vy vz vt cv vt cv vt
      cv cG fooprv sylibr vt cv vt cv cxp vt cv cG wfo cG crn vt cv vt cv vt cv
      cxp vt cv cG forn eqcomd syl 3adant2 pm4.71ri exbii syl6bb cG cA wcel cG
      crn cvv wcel vt cv cG crn wceq vt cv vt cv cxp vt cv cG wf vx cv vy cv cG
      co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv
      wral vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv
      wceq vy vt cv wrex wa vx vt cv wral vu vt cv wrex w3a wa vt wex cX cX cxp
      cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
      vz cX wral vy cX wral vx cX wral vu cv vx cv cG co vx cv wceq vy cv vx cv
      cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex w3a wb cG cA rnexg
      vt cv vt cv cxp vt cv cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral vu cv vx cv
      cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx vt cv
      wral vu vt cv wrex w3a cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co
      vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv
      vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX
      wral vu cX wrex w3a vt cG crn cvv vt cv cG crn wceq vt cv cX wceq vt cv
      vt cv cxp vt cv cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG
      co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral vu cv vx cv cG co
      vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vx vt cv wral vu
      vt cv wrex w3a cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy
      cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG
      co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX
      wrex w3a wb cX cG crn vt cv isgrp.1 eqeq2i vt cv cX wceq vt cv vt cv cxp
      vt cv cG wf cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz vt cv wral vy vt cv wral vx vt cv wral vx cv vy
      cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX
      wral vx cX wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq
      vy vt cv wrex wa vx vt cv wral vu vt cv wrex vu cv vx cv cG co vx cv wceq
      vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex vt cv cX
      wceq vt cv vt cv cxp vt cv cG wf cX cX cxp vt cv cG wf cX cX cxp cX cG wf
      vt cv cX wceq vt cv vt cv cxp cX cX cxp wceq vt cv vt cv cxp vt cv cG wf
      cX cX cxp vt cv cG wf wb vt cv cX wceq vt cv vt cv cxp cX vt cv cxp cX cX
      cxp vt cv cX vt cv xpeq1 vt cv cX cX xpeq2 eqtrd vt cv vt cv cxp cX cX
      cxp vt cv cG feq2 syl vt cv cX cX cX cxp cG feq3 bitrd vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv wral vy vt cv
      wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      cX wral vy cX wral vx vt cv cX vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz vt cv wral vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vz cX wral vy vt cv cX vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz vt cv cX raleq1 raleqd
      raleqd vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy vt cv
      wrex wa vx vt cv wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu
      cv wceq vy cX wrex wa vx cX wral vu vt cv cX vu cv vx cv cG co vx cv wceq
      vy cv vx cv cG co vu cv wceq vy vt cv wrex wa vu cv vx cv cG co vx cv
      wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx vt cv cX vt cv cX wceq
      vy cv vx cv cG co vu cv wceq vy vt cv wrex vy cv vx cv cG co vu cv wceq
      vy cX wrex vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy
      vt cv cX rexeq1 anbi2d raleqd rexeqd 3anbi123d sylbir ceqsexgv syl bitrd
      $.
      $( [3-Nov-2006] $) $( [10-Oct-2006] $)
  $}

  ${
    $d u x y z G $.  $d u x y z U $.  $d u x y z X $.  $d y N $.
    isgrpi.1 $e |- X e. _V $.
    isgrpi.2 $e |- G : ( X X. X ) --> X $.
    isgrpi.3 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                   ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $.
    isgrpi.4 $e |- U e. X $.
    isgrpi.5 $e |- ( x e. X -> ( U G x ) = x ) $.
    isgrpi.6 $e |- ( x e. X -> N e. X ) $.
    isgrpi.7 $e |- ( x e. X -> ( N G x ) = U ) $.
    $( Properties that determine a group operation.  Read ` N ` as
       ` N ( x ) ` . $)
    isgrpi $p |- G e. Grp $=
      cG cgr wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co
      vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX
      wrex w3a cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co vx
      cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex
      isgrpi.2 vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
      vx vy vz cX cX cX isgrpi.3 rgen3 cU cX wcel cU vx cv cG co vx cv wceq vy
      cv vx cv cG co cU wceq vy cX wrex wa vx cX wral vu cv vx cv cG co vx cv
      wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex
      isgrpi.4 cU vx cv cG co vx cv wceq vy cv vx cv cG co cU wceq vy cX wrex
      wa vx cX vx cv cX wcel cU vx cv cG co vx cv wceq vy cv vx cv cG co cU
      wceq vy cX wrex isgrpi.5 cN cX wcel cN vx cv cG co cU wceq vy cv vx cv cG
      co cU wceq vy cX wrex vx cv cX wcel vy cv vx cv cG co cU wceq cN vx cv cG
      co cU wceq vy cN cX vy cv cN wceq vy cv vx cv cG co cN vx cv cG co cU vy
      cv cN vx cv cG opreq1 eqeq1d rcla4ev isgrpi.6 isgrpi.7 sylanc jca rgen vu
      cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx
      cX wral cU vx cv cG co vx cv wceq vy cv vx cv cG co cU wceq vy cX wrex wa
      vx cX wral vu cU cX vu cv cU wceq vu cv vx cv cG co vx cv wceq vy cv vx
      cv cG co vu cv wceq vy cX wrex wa cU vx cv cG co vx cv wceq vy cv vx cv
      cG co cU wceq vy cX wrex wa vx cX vu cv cU wceq vu cv vx cv cG co vx cv
      wceq cU vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex vy
      cv vx cv cG co cU wceq vy cX wrex vu cv cU wceq vu cv vx cv cG co cU vx
      cv cG co vx cv vu cv cU vx cv cG opreq1 eqeq1d vu cv cU wceq vy cv vx cv
      cG co vu cv wceq vy cv vx cv cG co cU wceq vy cX vu cv cU vy cv vx cv cG
      co eqeq2 rexbidv anbi12d ralbidv rcla4ev mp2an 3pm3.2i cG cvv wcel cG cgr
      wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co vx cv
      wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex w3a
      wb cX cX cxp cX cG wf cX cX cxp cvv wcel cG cvv wcel isgrpi.2 cX cX
      isgrpi.1 isgrpi.1 xpex cX cX cxp cX cvv cG fex mp2an vx vy vz vu cvv cG
      cX cG crn cX cX cX cxp cX cG wfo cG crn cX wceq cX cX cxp cX cG wfo cX cX
      cxp cX cG wf vx cv vy cv vz cv cG co wceq vz cX wrex vy cX wrex vx cX
      wral vy vz vx cX cX cX cG fooprv isgrpi.2 vx cv vy cv vz cv cG co wceq vz
      cX wrex vy cX wrex vx cX vx cv cX wcel vx cv cU vx cv cG co wceq vx cv vy
      cv vz cv cG co wceq vz cX wrex vy cX wrex vx cv cX wcel cU vx cv cG co vx
      cv isgrpi.5 eqcomd cU cX wcel vx cv cX wcel vx cv cU vx cv cG co wceq vx
      cv vy cv vz cv cG co wceq vz cX wrex vy cX wrex isgrpi.4 vy vz cX cX cU
      vx cv vx cv cG rcla4eopr mp3an1 mpdan rgen mpbir2an cX cX cxp cX cG forn
      ax-mp eqcomi isgrp ax-mp mpbir $.
      $( [4-Nov-2006] $) $( [4-Nov-2006] $)
  $}

  ${
    $d w x y z A $.  $d x y z B $.  $d z C $.  $d u w x y z G $.
    $d u w x y z X $.  $d y U $.
    grpfo.1 $e |- X = ran G $.
    $( A group operation maps onto the group's underlying set. $)
    grpfo $p |- ( G e. Grp -> G : ( X X. X ) -onto-> X ) $=
      cG cgr wcel cX cX cxp cX cG wf cG crn cX wceq wa cX cX cxp cX cG wfo cG
      cgr wcel cX cX cxp cX cG wf cG crn cX wceq cG cgr wcel cX cX cxp cX cG wf
      vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX
      wral vy cX wral vx cX wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG co
      vu cv wceq vy cX wrex wa vx cX wral vu cX wrex cG cgr wcel cX cX cxp cX
      cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      cX wral vy cX wral vx cX wral vu cv vx cv cG co vx cv wceq vy cv vx cv cG
      co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex w3a vx vy vz vu cgr cG
      cX grpfo.1 isgrp ibi 3simp1d cX cG crn grpfo.1 eqcomi jctir cX cX cxp cX
      cG dffo2 sylibr $.
      $( [31-Oct-2006] $) $( [30-Oct-2006] $)

    $( Closure law for a group operation. $)
    grpcl $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      cX cX cxp cX cG wf cA cX wcel cB cX wcel cA cB cG co cX wcel cG cgr wcel
      cA cB cX cX cX cG foprrn cG cgr wcel cX cX cxp cX cG wfo cX cX cxp cX cG
      wf cG cX grpfo.1 grpfo cX cX cxp cX cG fof syl syl3an1 $.
      $( [19-Oct-2006] $) $( [10-Oct-2006] $)

    $( A group has a left identity element, and every member has a left
       inverse. $)
    grplidinv $p |- ( G e. Grp ->
         E. u e. X A. x e. X ( ( u G x ) = x /\ E. y e. X ( y G x ) = u ) ) $=
      cG cgr wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co
      vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX
      wrex cG cgr wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv
      cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu
      cX wrex w3a vx vy vz vu cgr cG cX grpfo.1 isgrp ibi 3simp3d $.
      $( [3-Nov-2006] $) $( [2-Nov-2006] $)

    $( The base set of a group is not empty.  (Contributed by Szymon
       Jaroszewicz, 3-Apr-2007.) $)
    grpn0 $p |- ( G e. Grp -> X =/= (/) ) $=
      cG cgr wcel vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy
      cX wrex wa vx cX wral vu cX wrex cX c0 wne vx vy vu cG cX grpfo.1
      grplidinv vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX
      wrex wa vx cX wral vu cX rexn0 syl $.
      $( [3-Apr-2007] $) $( [2-Mar-2007] $)

    $( A group operation is associative. $)
    grpass $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
              ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cB cC cG co cG co wceq cA cX wcel cB cX wcel cC cX wcel w3a vx cv vy cv
      cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX
      wral vx cX wral cA cB cG co cC cG co cA cB cC cG co cG co wceq cG cgr
      wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq cA
      cB cG co cC cG co cA cB cC cG co cG co wceq cA vy cv cG co vz cv cG co cA
      vy cv vz cv cG co cG co wceq cA cB cG co vz cv cG co cA cB vz cv cG co cG
      co wceq vx vy vz cA cB cC cX cX cX vx cv cA wceq vx cv vy cv cG co vz cv
      cG co cA vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co cA vy cv
      vz cv cG co cG co vx cv cA wceq vx cv vy cv cG co cA vy cv cG co vz cv cG
      vx cv cA vy cv cG opreq1 opreq1d vx cv cA vy cv vz cv cG co cG opreq1
      eqeq12d vy cv cB wceq cA vy cv cG co vz cv cG co cA cB cG co vz cv cG co
      cA vy cv vz cv cG co cG co cA cB vz cv cG co cG co vy cv cB wceq cA vy cv
      cG co cA cB cG co vz cv cG vy cv cB cA cG opreq2 opreq1d vy cv cB wceq vy
      cv vz cv cG co cB vz cv cG co cA cG vy cv cB vz cv cG opreq1 opreq2d
      eqeq12d vz cv cC wceq cA cB cG co vz cv cG co cA cB cG co cC cG co cA cB
      vz cv cG co cG co cA cB cC cG co cG co vz cv cC cA cB cG co cG opreq2 vz
      cv cC wceq cB vz cv cG co cB cC cG co cA cG vz cv cC cB cG opreq2 opreq2d
      eqeq12d rcla43v cG cgr wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG
      co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu
      cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx
      cX wral vu cX wrex cG cgr wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral
      vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa
      vx cX wral vu cX wrex w3a vx vy vz vu cgr cG cX grpfo.1 isgrp ibi 3simp2d
      syl5com imp $.
      $( [18-Oct-2006] $) $( [10-Oct-2006] $)

    $( Lemma for ~ grpidinv . $)
    grpidinvlem1 $p |- ( ( ( G e. Grp /\ ( Y e. X /\ A e. X ) ) /\
                  ( ( Y G A ) = U /\ ( A G A ) = A ) ) -> ( U G A ) = U ) $=
      cG cgr wcel cY cX wcel cA cX wcel wa wa cY cA cG co cU wceq cA cA cG co
      cA wceq wa wa cU cA cG co cY cA cA cG co cG co cY cA cG co cU cG cgr wcel
      cY cX wcel cA cX wcel wa wa cY cA cG co cU wceq cA cA cG co cA wceq wa wa
      cY cA cG co cA cG co cU cA cG co cY cA cA cG co cG co cY cA cG co cU wceq
      cY cA cG co cA cG co cU cA cG co wceq cG cgr wcel cY cX wcel cA cX wcel
      wa wa cA cA cG co cA wceq cY cA cG co cU cA cG opreq1 ad2antrl cG cgr
      wcel cY cX wcel cA cX wcel wa wa cY cA cG co cA cG co cY cA cA cG co cG
      co wceq cY cA cG co cU wceq cA cA cG co cA wceq wa cG cgr wcel cY cX wcel
      cA cX wcel cA cX wcel w3a cY cA cG co cA cG co cY cA cA cG co cG co wceq
      cY cX wcel cA cX wcel wa cY cA cA cG cX grpfo.1 grpass cY cX wcel cA cX
      wcel cY cX wcel cA cX wcel cA cX wcel w3a cY cX wcel cA cX wcel cA cX
      wcel w3a id 3anidm23 sylan2 adantr eqtr3d cA cA cG co cA wceq cY cA cA cG
      co cG co cY cA cG co wceq cG cgr wcel cY cX wcel cA cX wcel wa wa cY cA
      cG co cU wceq cA cA cG co cA cY cG opreq2 ad2antll cG cgr wcel cY cX wcel
      cA cX wcel wa wa cY cA cG co cU wceq cA cA cG co cA wceq simprl 3eqtrd $.
      $( [24-Oct-2006] $) $( [10-Oct-2006] $)

    $( Lemma for ~ grpidinv . $)
    grpidinvlem2 $p |- ( ( ( G e. Grp /\ ( Y e. X /\ A e. X ) ) /\ ( ( U G Y )
         = Y /\ ( Y G A ) = U ) ) -> ( ( A G Y ) G ( A G Y ) ) = ( A G Y ) ) $=
      cG cgr wcel cY cX wcel cA cX wcel wa wa cU cY cG co cY wceq cY cA cG co
      cU wceq wa wa cA cY cG co cA cY cG co cG co cA cY cA cY cG co cG co cG co
      cA cY cG co cG cgr wcel cY cX wcel cA cX wcel wa wa cA cY cG co cA cY cG
      co cG co cA cY cA cY cG co cG co cG co wceq cU cY cG co cY wceq cY cA cG
      co cU wceq wa cG cgr wcel cY cX wcel cA cX wcel wa cA cX wcel cY cX wcel
      cA cY cG co cX wcel w3a cA cY cG co cA cY cG co cG co cA cY cA cY cG co
      cG co cG co wceq cG cgr wcel cY cX wcel cA cX wcel wa wa cA cX wcel cY cX
      wcel cA cY cG co cX wcel cG cgr wcel cY cX wcel cA cX wcel simprr cG cgr
      wcel cY cX wcel cA cX wcel simprl cG cgr wcel cY cX wcel cA cX wcel cA cY
      cG co cX wcel cG cgr wcel cA cX wcel cY cX wcel cA cY cG co cX wcel cA cY
      cG cX grpfo.1 grpcl 3com23 3expb 3jca cA cY cA cY cG co cG cX grpfo.1
      grpass syldan adantr cG cgr wcel cY cX wcel cA cX wcel wa wa cU cY cG co
      cY wceq cY cA cG co cU wceq wa wa cY cA cY cG co cG co cY cA cG cG cgr
      wcel cY cX wcel cA cX wcel wa wa cU cY cG co cY wceq cY cA cG co cU wceq
      wa wa cY cY cA cY cG co cG co cU cY cG co cY wceq cY cA cG co cU wceq wa
      cG cgr wcel cY cX wcel cA cX wcel wa wa cY cY cA cG co cY cG co cY cA cY
      cG co cG co cU cY cG co cY wceq cY cA cG co cU wceq wa cY cA cG co cY cG
      co cU cY cG co cY cY cA cG co cU wceq cY cA cG co cY cG co cU cY cG co
      wceq cU cY cG co cY wceq cY cA cG co cU cY cG opreq1 adantl cU cY cG co
      cY wceq cY cA cG co cU wceq pm3.26 eqtr2d cG cgr wcel cY cX wcel cA cX
      wcel cY cX wcel w3a cY cA cG co cY cG co cY cA cY cG co cG co wceq cY cX
      wcel cA cX wcel wa cY cA cY cG cX grpfo.1 grpass cY cX wcel cA cX wcel cY
      cX wcel cA cX wcel cY cX wcel w3a cY cX wcel cA cX wcel cY cX wcel w3a id
      3anidm13 sylan2 sylan9eqr eqcomd opreq2d eqtrd $.
      $( [24-Oct-2006] $) $( [10-Oct-2006] $)

    ${
      $d w x y z U $.  $d w y ph $.  $d y ps $.
      grpidinvlem3.2 $e |- ( ph <-> A. x e. X ( U G x ) = x ) $.
      grpidinvlem3.3 $e |- ( ps <-> A. x e. X E. z e. X ( z G x ) = U ) $.
      $( Lemma for ~ grpidinv . $)
      grpidinvlem3 $p |- ( ( ( ( G e. Grp /\ U e. X ) /\ ( ph /\ ps ) ) /\
                  A e. X ) -> E. y e. X ( ( y G A ) = U /\ ( A G y ) = U ) ) $=
        cG cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cA cG co cU
        wceq vy cX wrex vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX
        wrex wph wps wa cA cX wcel vy cv cA cG co cU wceq vy cX wrex cG cgr
        wcel cU cX wcel wa wps cA cX wcel vy cv cA cG co cU wceq vy cX wrex wph
        vy cv vx cv cG co cU wceq vy cX wrex vx cX wral cA cX wcel vy cv cA cG
        co cU wceq vy cX wrex wps vy cv vx cv cG co cU wceq vy cX wrex vy cv cA
        cG co cU wceq vy cX wrex vx cA cX vx cv cA wceq vy cv vx cv cG co cU
        wceq vy cv cA cG co cU wceq vy cX vx cv cA wceq vy cv vx cv cG co vy cv
        cA cG co cU vx cv cA vy cv cG opreq2 eqeq1d rexbidv rcla4cva wps vz cv
        vx cv cG co cU wceq vz cX wrex vx cX wral vy cv vx cv cG co cU wceq vy
        cX wrex vx cX wral grpidinvlem3.3 vz cv vx cv cG co cU wceq vz cX wrex
        vy cv vx cv cG co cU wceq vy cX wrex vx cX vz cv vx cv cG co cU wceq vy
        cv vx cv cG co cU wceq vz vy cX vz cv vy cv wceq vz cv vx cv cG co vy
        cv vx cv cG co cU vz cv vy cv vx cv cG opreq1 eqeq1d cbvrexv ralbii
        bitri sylanb adantll adantll cG cgr wcel cU cX wcel wa wph wps wa wa cA
        cX wcel wa vy cv cA cG co cU wceq vy cv cA cG co cU wceq cA vy cv cG co
        cU wceq wa vy cX cG cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel wa
        vy cv cX wcel wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq cG cgr
        wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cX wcel wa vy cv
        cA cG co cU wceq cA vy cv cG co cU wceq cG cgr wcel cU cX wcel wa wph
        wps wa wa cA cX wcel wa vy cv cX wcel wa vy cv cA cG co cU wceq wa cU
        cA vy cv cG co cG co cA vy cv cG co cU cG cgr wcel cU cX wcel wa wph
        wps wa wa cA cX wcel wa vy cv cX wcel wa cU cA vy cv cG co cG co cA vy
        cv cG co wceq vy cv cA cG co cU wceq cA vy cv cG co cX wcel cU vx cv cG
        co vx cv wceq vx cX wral cU cA vy cv cG co cG co cA vy cv cG co wceq cG
        cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cX wcel wa cU
        vx cv cG co vx cv wceq cU cA vy cv cG co cG co cA vy cv cG co wceq vx
        cA vy cv cG co cX vx cv cA vy cv cG co wceq cU vx cv cG co cU cA vy cv
        cG co cG co vx cv cA vy cv cG co vx cv cA vy cv cG co cU cG opreq2 vx
        cv cA vy cv cG co wceq id eqeq12d rcla4va cG cgr wcel cU cX wcel wa cA
        cX wcel vy cv cX wcel cA vy cv cG co cX wcel wph wps wa cG cgr wcel cA
        cX wcel vy cv cX wcel cA vy cv cG co cX wcel cU cX wcel cG cgr wcel cA
        cX wcel vy cv cX wcel cA vy cv cG co cX wcel cA vy cv cG cX grpfo.1
        grpcl 3expa adantllr adantllr cG cgr wcel cU cX wcel wa wph wps wa wa
        cU vx cv cG co vx cv wceq vx cX wral cA cX wcel vy cv cX wcel wph cU vx
        cv cG co vx cv wceq vx cX wral cG cgr wcel cU cX wcel wa wps wph cU vx
        cv cG co vx cv wceq vx cX wral grpidinvlem3.2 biimpi ad2antrl ad2antrr
        sylanc adantr cG cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy
        cv cX wcel wa vy cv cA cG co cU wceq wa cA vy cv cG co cA vy cv cG co
        cG co cA vy cv cG co wceq cU cA vy cv cG co cG co cU wceq cG cgr wcel
        vy cv cX wcel cA cX wcel wa wa cU vy cv cG co vy cv wceq vy cv cA cG co
        cU wceq wa cA vy cv cG co cA vy cv cG co cG co cA vy cv cG co wceq cG
        cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cX wcel wa vy
        cv cA cG co cU wceq wa cA cU cG cX vy cv grpfo.1 grpidinvlem2 cG cgr
        wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cX wcel wa cG cgr
        wcel vy cv cX wcel cA cX wcel wa wa vy cv cA cG co cU wceq cG cgr wcel
        cU cX wcel wa cA cX wcel vy cv cX wcel cG cgr wcel vy cv cX wcel cA cX
        wcel wa wa wph wps wa cG cgr wcel cA cX wcel vy cv cX wcel cG cgr wcel
        vy cv cX wcel cA cX wcel wa wa cU cX wcel vy cv cX wcel cA cX wcel cG
        cgr wcel cG cgr wcel vy cv cX wcel cA cX wcel wa wa vy cv cX wcel cA cX
        wcel wa cG cgr wcel pm3.22 ancom31s adantllr adantllr adantr cG cgr
        wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cX wcel wa cU vy
        cv cG co vy cv wceq vy cv cA cG co cU wceq wph wps wa cA cX wcel vy cv
        cX wcel cU vy cv cG co vy cv wceq cG cgr wcel cU cX wcel wa wph wps wa
        vy cv cX wcel cU vy cv cG co vy cv wceq cA cX wcel wph vy cv cX wcel cU
        vy cv cG co vy cv wceq wps cU vx cv cG co vx cv wceq vx cX wral vy cv
        cX wcel cU vy cv cG co vy cv wceq wph cU vx cv cG co vx cv wceq cU vy
        cv cG co vy cv wceq vx vy cv cX vx cv vy cv wceq cU vx cv cG co cU vy
        cv cG co vx cv vy cv vx cv vy cv cU cG opreq2 vx cv vy cv wceq id
        eqeq12d rcla4cva grpidinvlem3.2 sylanb adantlr adantlr adantlll anim1i
        sylanc cG cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel wa vy cv cX
        wcel wa cA vy cv cG co cA vy cv cG co cG co cA vy cv cG co wceq cU cA
        vy cv cG co cG co cU wceq wi vy cv cA cG co cU wceq cG cgr wcel cU cX
        wcel wa wph wps wa wa cA cX wcel vy cv cX wcel cA vy cv cG co cA vy cv
        cG co cG co cA vy cv cG co wceq cU cA vy cv cG co cG co cU wceq wi cG
        cgr wcel cU cX wcel wa wph wps wa wa cA cX wcel vy cv cX wcel cA vy cv
        cG co cA vy cv cG co cG co cA vy cv cG co wceq cU cA vy cv cG co cG co
        cU wceq wi cG cgr wcel cU cX wcel wa wph wps cA cX wcel vy cv cX wcel
        wa cA vy cv cG co cA vy cv cG co cG co cA vy cv cG co wceq cU cA vy cv
        cG co cG co cU wceq wi wi cG cgr wcel cU cX wcel wa wph cA cX wcel vy
        cv cX wcel wa wps cA vy cv cG co cA vy cv cG co cG co cA vy cv cG co
        wceq cU cA vy cv cG co cG co cU wceq wi cG cgr wcel cU cX wcel wa wph
        cA cX wcel vy cv cX wcel wa wps cA vy cv cG co cA vy cv cG co cG co cA
        vy cv cG co wceq cU cA vy cv cG co cG co cU wceq wi wi cG cgr wcel cU
        cX wcel wa wph cA cX wcel vy cv cX wcel wa wa wa cA vy cv cG co cX wcel
        wps cA vy cv cG co cA vy cv cG co cG co cA vy cv cG co wceq cU cA vy cv
        cG co cG co cU wceq wi cG cgr wcel cA cX wcel vy cv cX wcel wa cA vy cv
        cG co cX wcel cU cX wcel wph cG cgr wcel cA cX wcel vy cv cX wcel cA vy
        cv cG co cX wcel cA vy cv cG cX grpfo.1 grpcl 3expb ad2ant2rl cG cgr
        wcel cU cX wcel wa wph cA cX wcel vy cv cX wcel wa wa wa vw cv cA vy cv
        cG co cG co cU wceq vw cX wrex cA vy cv cG co cA vy cv cG co cG co cA
        vy cv cG co wceq cU cA vy cv cG co cG co cU wceq wi cA vy cv cG co cX
        wcel wps wa cG cgr wcel cU cX wcel wa wph cA cX wcel vy cv cX wcel wa
        wa wa vw cv cA vy cv cG co cG co cU wceq cA vy cv cG co cA vy cv cG co
        cG co cA vy cv cG co wceq cU cA vy cv cG co cG co cU wceq wi vw cX cG
        cgr wcel cU cX wcel wa wph cA cX wcel vy cv cX wcel wa wa wa vw cv cX
        wcel vw cv cA vy cv cG co cG co cU wceq cA vy cv cG co cA vy cv cG co
        cG co cA vy cv cG co wceq cU cA vy cv cG co cG co cU wceq cG cgr wcel
        vw cv cX wcel cA vy cv cG co cX wcel wa wa vw cv cA vy cv cG co cG co
        cU wceq cA vy cv cG co cA vy cv cG co cG co cA vy cv cG co wceq wa cU
        cA vy cv cG co cG co cU wceq cG cgr wcel cU cX wcel wa wph cA cX wcel
        vy cv cX wcel wa wa wa vw cv cX wcel wa cA vy cv cG co cU cG cX vw cv
        grpfo.1 grpidinvlem1 cG cgr wcel cU cX wcel wa wph cA cX wcel vy cv cX
        wcel wa wa wa vw cv cX wcel cG cgr wcel vw cv cX wcel cA vy cv cG co cX
        wcel wa wa cG cgr wcel cA cX wcel vy cv cX wcel wa vw cv cX wcel cG cgr
        wcel vw cv cX wcel cA vy cv cG co cX wcel wa wa wi cU cX wcel wph cG
        cgr wcel cA cX wcel vy cv cX wcel wa cA vy cv cG co cX wcel vw cv cX
        wcel cG cgr wcel vw cv cX wcel cA vy cv cG co cX wcel wa wa wi cG cgr
        wcel cA cX wcel vy cv cX wcel cA vy cv cG co cX wcel cA vy cv cG cX
        grpfo.1 grpcl 3expb cG cgr wcel cA vy cv cG co cX wcel wa vw cv cX wcel
        cG cgr wcel vw cv cX wcel cA vy cv cG co cX wcel wa wa cG cgr wcel vw
        cv cX wcel cA vy cv cG co cX wcel cG cgr wcel vw cv cX wcel cA vy cv cG
        co cX wcel wa wa cG cgr wcel vw cv cX wcel wa cA vy cv cG co cX wcel wa
        cG cgr wcel vw cv cX wcel cA vy cv cG co cX wcel wa wa cG cgr wcel vw
        cv cX wcel cA vy cv cG co cX wcel anass biimpi an1rs ex syldan
        ad2ant2rl imp sylan exp43 r19.23adv cA vy cv cG co cX wcel vw cv vx cv
        cG co cU wceq vw cX wrex vx cX wral vw cv cA vy cv cG co cG co cU wceq
        vw cX wrex wps vw cv vx cv cG co cU wceq vw cX wrex vw cv cA vy cv cG
        co cG co cU wceq vw cX wrex vx cA vy cv cG co cX vx cv cA vy cv cG co
        wceq vw cv vx cv cG co cU wceq vw cv cA vy cv cG co cG co cU wceq vw cX
        vx cv cA vy cv cG co wceq vw cv vx cv cG co vw cv cA vy cv cG co cG co
        cU vx cv cA vy cv cG co vw cv cG opreq2 eqeq1d rexbidv rcla4va wps vz
        cv vx cv cG co cU wceq vz cX wrex vx cX wral vw cv vx cv cG co cU wceq
        vw cX wrex vx cX wral grpidinvlem3.3 vz cv vx cv cG co cU wceq vz cX
        wrex vw cv vx cv cG co cU wceq vw cX wrex vx cX vz cv vx cv cG co cU
        wceq vw cv vx cv cG co cU wceq vz vw cX vz cv vw cv wceq vz cv vx cv cG
        co vw cv vx cv cG co cU vz cv vw cv vx cv cG opreq1 eqeq1d cbvrexv
        ralbii bitri sylan2b syl5 mpand exp32 com34 imp32 exp3a imp31 adantr
        mpd eqtr3d ex ancld r19.22dva mpd $.
        $( [25-Oct-2006] $) $( [11-Oct-2006] $)
    $}

    $( Lemma for ~ grpidinv . $)
    grpidinvlem4 $p |- ( ( ( G e. Grp /\ A e. X ) /\ E. y e. X
             ( ( y G A ) = U /\ ( A G y ) = U ) ) -> ( A G U ) = ( U G A ) ) $=
      cG cgr wcel cA cX wcel wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq
      wa vy cX wrex cA cU cG co cU cA cG co wceq cG cgr wcel cA cX wcel wa vy
      cv cA cG co cU wceq cA vy cv cG co cU wceq wa cA cU cG co cU cA cG co
      wceq vy cX cG cgr wcel cA cX wcel wa vy cv cX wcel vy cv cA cG co cU wceq
      cA vy cv cG co cU wceq wa cA cU cG co cU cA cG co wceq cG cgr wcel cA cX
      wcel wa vy cv cX wcel wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq cA
      cU cG co cU cA cG co wceq cG cgr wcel cA cX wcel wa vy cv cX wcel wa vy
      cv cA cG co cU wceq wa cA vy cv cG co cU wceq cA cU cG co cA vy cv cG co
      cA cG co cU cA cG co cG cgr wcel cA cX wcel wa vy cv cX wcel wa vy cv cA
      cG co cU wceq cA vy cv cG co cA cG co cA vy cv cA cG co cG co cA cU cG co
      cG cgr wcel cA cX wcel vy cv cX wcel cA cX wcel w3a cA vy cv cG co cA cG
      co cA vy cv cA cG co cG co wceq cG cgr wcel cA cX wcel wa vy cv cX wcel
      wa cA vy cv cA cG cX grpfo.1 grpass cG cgr wcel cA cX wcel vy cv cX wcel
      simpll cG cgr wcel cA cX wcel wa vy cv cX wcel wa cA cX wcel vy cv cX
      wcel cA cX wcel cG cgr wcel cA cX wcel vy cv cX wcel simplr cG cgr wcel
      cA cX wcel wa vy cv cX wcel pm3.27 cG cgr wcel cA cX wcel vy cv cX wcel
      simplr 3jca sylanc vy cv cA cG co cU cA cG opreq2 sylan9eq cA vy cv cG co
      cU cA cG opreq1 sylan9req anasss exp31 r19.23adv imp $.
      $( [25-Oct-2006] $) $( [14-Oct-2006] $)

    $( A group has a left and right identity element, and every member has a
       left and right inverse. $)
    grpidinv $p |- ( G e. Grp -> E. u e. X A. x e. X ( ( ( u G x ) = x /\
         ( x G u ) = x ) /\ E. y e. X ( ( y G x ) = u /\ ( x G y ) = u ) ) ) $=
      cG cgr wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw
      cX wrex wa vz cX wral vu cX wrex vu cv vx cv cG co vx cv wceq vx cv vu cv
      cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv
      wceq wa vy cX wrex wa vx cX wral vu cX wrex vz vw vu cG cX grpfo.1
      grplidinv cG cgr wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu
      cv wceq vw cX wrex wa vz cX wral vu cv vx cv cG co vx cv wceq vx cv vu cv
      cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv
      wceq wa vy cX wrex wa vx cX wral vu cX cG cgr wcel vu cv cX wcel vu cv vz
      cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral
      vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv
      cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral
      cG cgr wcel vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co
      vu cv wceq vw cX wrex wa vz cX wral wa wa vu cv vx cv cG co vx cv wceq vx
      cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG
      co vu cv wceq wa vy cX wrex wa vx cX cG cgr wcel vu cv cX wcel vu cv vz
      cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral
      wa wa vx cv cX wcel wa vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx
      cv wceq vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy
      cX wrex vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu
      cv wceq vw cX wrex wa vz cX wral wa vx cv cX wcel vu cv vx cv cG co vx cv
      wceq cG cgr wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu cv
      wceq vw cX wrex wa vz cX wral vx cv cX wcel vu cv vx cv cG co vx cv wceq
      vu cv cX wcel vu cv vz cv cG co vz cv wceq vz cX wral vx cv cX wcel vu cv
      vx cv cG co vx cv wceq vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu
      cv wceq vw cX wrex wa vz cX wral vu cv vz cv cG co vz cv wceq vu cv vx cv
      cG co vx cv wceq vz vx cv cX vz cv vx cv wceq vu cv vz cv cG co vu cv vx
      cv cG co vz cv vx cv vz cv vx cv vu cv cG opreq2 vz cv vx cv wceq id
      eqeq12d rcla4cva vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu cv
      wceq vw cX wrex wa vu cv vz cv cG co vz cv wceq vz cX vu cv vz cv cG co
      vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex pm3.26 r19.20si sylan
      adantll adantll cG cgr wcel vu cv cX wcel vu cv vz cv cG co vz cv wceq vw
      cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral wa wa vx cv cX wcel wa
      vx cv vu cv cG co vu cv vx cv cG co vx cv cG cgr wcel vx cv cX wcel wa vy
      cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex vx
      cv vu cv cG co vu cv vx cv cG co wceq cG cgr wcel vu cv cX wcel vu cv vz
      cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral
      wa wa vx cv cX wcel wa vy vx cv vu cv cG cX grpfo.1 grpidinvlem4 cG cgr
      wcel vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu cv
      wceq vw cX wrex wa vz cX wral wa wa cG cgr wcel vx cv cX wcel cG cgr wcel
      vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq
      vw cX wrex wa vz cX wral wa pm3.26 anim1i cG cgr wcel vu cv cX wcel vu cv
      vz cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX
      wral wa wa vx cv cX wcel cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co
      vz cv wceq vz cX wral vw cv vz cv cG co vu cv wceq vw cX wrex vz cX wral
      wa wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX
      wrex cG cgr wcel vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv
      cG co vu cv wceq vw cX wrex wa vz cX wral wa wa vx cv cX wcel wa cG cgr
      wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vz cX wral vw cv vz cv
      cG co vu cv wceq vw cX wrex vz cX wral cG cgr wcel vu cv cX wcel vu cv vz
      cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral
      wa wa cG cgr wcel vu cv cX wcel wa vx cv cX wcel cG cgr wcel vu cv cX
      wcel cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vw cv vz
      cv cG co vu cv wceq vw cX wrex wa vz cX wral cG cgr wcel vu cv cX wcel wa
      id adantrr adantr vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv
      cG co vu cv wceq vw cX wrex wa vz cX wral wa vu cv vz cv cG co vz cv wceq
      vz cX wral cG cgr wcel vx cv cX wcel vu cv vz cv cG co vz cv wceq vw cv
      vz cv cG co vu cv wceq vw cX wrex wa vz cX wral vu cv vz cv cG co vz cv
      wceq vz cX wral vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG
      co vu cv wceq vw cX wrex wa vu cv vz cv cG co vz cv wceq vz cX vu cv vz
      cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex pm3.26
      r19.20si adantl ad2antlr vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv
      vz cv cG co vu cv wceq vw cX wrex wa vz cX wral wa vw cv vz cv cG co vu
      cv wceq vw cX wrex vz cX wral cG cgr wcel vx cv cX wcel vu cv vz cv cG co
      vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral vw cv vz
      cv cG co vu cv wceq vw cX wrex vz cX wral vu cv cX wcel vu cv vz cv cG co
      vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vw cv vz cv cG co
      vu cv wceq vw cX wrex vz cX vu cv vz cv cG co vz cv wceq vw cv vz cv cG
      co vu cv wceq vw cX wrex pm3.27 r19.20si adantl ad2antlr jca32 vu cv vz
      cv cG co vz cv wceq vz cX wral vw cv vz cv cG co vu cv wceq vw cX wrex vz
      cX wral vz vy vw vx cv vu cv cG cX grpfo.1 vu cv vz cv cG co vz cv wceq
      vz cX wral biid vw cv vz cv cG co vu cv wceq vw cX wrex vz cX wral biid
      grpidinvlem3 sylancom sylanc vu cv cX wcel vu cv vz cv cG co vz cv wceq
      vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral wa vx cv cX wcel vu
      cv vx cv cG co vx cv wceq cG cgr wcel vu cv vz cv cG co vz cv wceq vw cv
      vz cv cG co vu cv wceq vw cX wrex wa vz cX wral vx cv cX wcel vu cv vx cv
      cG co vx cv wceq vu cv cX wcel vu cv vz cv cG co vz cv wceq vz cX wral vx
      cv cX wcel vu cv vx cv cG co vx cv wceq vu cv vz cv cG co vz cv wceq vw
      cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral vu cv vz cv cG co vz
      cv wceq vu cv vx cv cG co vx cv wceq vz vx cv cX vz cv vx cv wceq vu cv
      vz cv cG co vu cv vx cv cG co vz cv vx cv vz cv vx cv vu cv cG opreq2 vz
      cv vx cv wceq id eqeq12d rcla4cva vu cv vz cv cG co vz cv wceq vw cv vz
      cv cG co vu cv wceq vw cX wrex wa vu cv vz cv cG co vz cv wceq vz cX vu
      cv vz cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex pm3.26
      r19.20si sylan adantll adantll eqtrd cG cgr wcel vu cv cX wcel vu cv vz
      cv cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral
      wa wa vx cv cX wcel cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv
      wceq vz cX wral vw cv vz cv cG co vu cv wceq vw cX wrex vz cX wral wa wa
      vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex
      cG cgr wcel vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co
      vu cv wceq vw cX wrex wa vz cX wral wa wa vx cv cX wcel wa cG cgr wcel vu
      cv cX wcel wa vu cv vz cv cG co vz cv wceq vz cX wral vw cv vz cv cG co
      vu cv wceq vw cX wrex vz cX wral cG cgr wcel vu cv cX wcel vu cv vz cv cG
      co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral wa wa
      cG cgr wcel vu cv cX wcel wa vx cv cX wcel cG cgr wcel vu cv cX wcel cG
      cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vw cv vz cv cG co
      vu cv wceq vw cX wrex wa vz cX wral cG cgr wcel vu cv cX wcel wa id
      adantrr adantr vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG
      co vu cv wceq vw cX wrex wa vz cX wral wa vu cv vz cv cG co vz cv wceq vz
      cX wral cG cgr wcel vx cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz
      cv cG co vu cv wceq vw cX wrex wa vz cX wral vu cv vz cv cG co vz cv wceq
      vz cX wral vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG co
      vu cv wceq vw cX wrex wa vu cv vz cv cG co vz cv wceq vz cX vu cv vz cv
      cG co vz cv wceq vw cv vz cv cG co vu cv wceq vw cX wrex pm3.26 r19.20si
      adantl ad2antlr vu cv cX wcel vu cv vz cv cG co vz cv wceq vw cv vz cv cG
      co vu cv wceq vw cX wrex wa vz cX wral wa vw cv vz cv cG co vu cv wceq vw
      cX wrex vz cX wral cG cgr wcel vx cv cX wcel vu cv vz cv cG co vz cv wceq
      vw cv vz cv cG co vu cv wceq vw cX wrex wa vz cX wral vw cv vz cv cG co
      vu cv wceq vw cX wrex vz cX wral vu cv cX wcel vu cv vz cv cG co vz cv
      wceq vw cv vz cv cG co vu cv wceq vw cX wrex wa vw cv vz cv cG co vu cv
      wceq vw cX wrex vz cX vu cv vz cv cG co vz cv wceq vw cv vz cv cG co vu
      cv wceq vw cX wrex pm3.27 r19.20si adantl ad2antlr jca32 vu cv vz cv cG
      co vz cv wceq vz cX wral vw cv vz cv cG co vu cv wceq vw cX wrex vz cX
      wral vz vy vw vx cv vu cv cG cX grpfo.1 vu cv vz cv cG co vz cv wceq vz
      cX wral biid vw cv vz cv cG co vu cv wceq vw cX wrex vz cX wral biid
      grpidinvlem3 sylancom jca31 r19.21aiva exp32 r19.22dv mpd $.
      $( [25-Oct-2006] $) $( [14-Oct-2006] $)

    $( The left identity element of a group is unique.  Lemma 2.2.1(a) of
       [Herstein] p. 55. $)
    grpideu $p |- ( G e. Grp -> E! u e. X A. x e. X ( u G x ) = x ) $=
      cG cgr wcel vu cv vx cv cG co vx cv wceq vx cX wral vw cv vx cv cG co vx
      cv wceq vx cX wral vu cv vw cv wceq wi vw cX wral wa vu cX wrex vu cv vx
      cv cG co vx cv wceq vx cX wral vu cX wreu cG cgr wcel vu cv vz cv cG co
      vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq
      vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral vu cX wrex vu cv
      vx cv cG co vx cv wceq vx cX wral vw cv vx cv cG co vx cv wceq vx cX wral
      vu cv vw cv wceq wi vw cX wral wa vu cX wrex vz vy vu cG cX grpfo.1
      grpidinv cG cgr wcel vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv
      wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy
      cX wrex wa vz cX wral vu cv vx cv cG co vx cv wceq vx cX wral vw cv vx cv
      cG co vx cv wceq vx cX wral vu cv vw cv wceq wi vw cX wral wa vu cX cG
      cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vz cv vu cv cG co
      vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq
      wa vy cX wrex wa vz cX wral vu cv vx cv cG co vx cv wceq vx cX wral vw cv
      vx cv cG co vx cv wceq vx cX wral vu cv vw cv wceq wi vw cX wral wa cG
      cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vz cv vu cv cG co
      vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq
      wa vy cX wrex wa vz cX wral wa vu cv vx cv cG co vx cv wceq vx cX wral vw
      cv vx cv cG co vx cv wceq vx cX wral vu cv vw cv wceq wi vw cX wral vu cv
      vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co
      vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral vu cv
      vx cv cG co vx cv wceq vx cX wral cG cgr wcel vu cv cX wcel wa vu cv vz
      cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu
      cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral vu cv vz
      cv cG co vz cv wceq vz cX wral vu cv vx cv cG co vx cv wceq vx cX wral vu
      cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG
      co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vu cv vz cv
      cG co vz cv wceq vz cX vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz
      cv wceq vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy
      cX wrex simpll r19.20si vu cv vz cv cG co vz cv wceq vu cv vx cv cG co vx
      cv wceq vz vx cX vz cv vx cv wceq vu cv vz cv cG co vu cv vx cv cG co vz
      cv vx cv vz cv vx cv vu cv cG opreq2 vz cv vx cv wceq id eqeq12d cbvralv
      sylib adantl cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vz
      cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG
      co vu cv wceq wa vy cX wrex wa vz cX wral wa vw cv vx cv cG co vx cv wceq
      vx cX wral vu cv vw cv wceq wi vw cX cG cgr wcel vu cv cX wcel wa vu cv
      vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co
      vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral wa vw
      cv cX wcel wa vu cv vx cv cG co vx cv wceq vx cX wral vw cv vx cv cG co
      vx cv wceq vx cX wral vu cv vw cv wceq vu cv vz cv cG co vz cv wceq vz cv
      vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co
      vu cv wceq wa vy cX wrex wa vz cX wral vu cv vx cv cG co vx cv wceq vx cX
      wral cG cgr wcel vu cv cX wcel wa vw cv cX wcel vu cv vz cv cG co vz cv
      wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv
      vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral vu cv vz cv cG co vz
      cv wceq vz cX wral vu cv vx cv cG co vx cv wceq vx cX wral vu cv vz cv cG
      co vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv
      wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vu cv vz cv cG co vz
      cv wceq vz cX vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq
      vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex
      simpll r19.20si vu cv vz cv cG co vz cv wceq vu cv vx cv cG co vx cv wceq
      vz vx cX vz cv vx cv wceq vu cv vz cv cG co vu cv vx cv cG co vz cv vx cv
      vz cv vx cv vu cv cG opreq2 vz cv vx cv wceq id eqeq12d cbvralv sylib
      ad2antlr cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vz cv
      vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co
      vu cv wceq wa vy cX wrex wa vz cX wral wa vw cv cX wcel wa vu cv vx cv cG
      co vx cv wceq vx cX wral vw cv vx cv cG co vx cv wceq vx cX wral wa vu cv
      vw cv wceq cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv wceq vz
      cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG
      co vu cv wceq wa vy cX wrex wa vz cX wral wa vw cv cX wcel wa vu cv vx cv
      cG co vx cv wceq vx cX wral vw cv vx cv cG co vx cv wceq vx cX wral wa wa
      vw cv vu cv cG co vu cv vw cv cG co vu cv vw cv cG cgr wcel vu cv cX wcel
      wa vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq wa vy cv vz
      cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex wa vz cX
      wral wa vw cv cX wcel wa vw cv vu cv cG co vu cv vw cv cG co wceq vu cv
      vx cv cG co vx cv wceq vx cX wral vw cv vx cv cG co vx cv wceq vx cX wral
      wa cG cgr wcel vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq
      wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX
      wrex wa vz cX wral vw cv cX wcel vw cv vu cv cG co vu cv vw cv cG co wceq
      vu cv cX wcel cG cgr wcel vw cv cX wcel vu cv vz cv cG co vz cv wceq vz
      cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG
      co vu cv wceq wa vy cX wrex wa vz cX wral vw cv vu cv cG co vu cv vw cv
      cG co wceq cG cgr wcel vw cv cX wcel wa vu cv vz cv cG co vz cv wceq vz
      cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG
      co vu cv wceq wa vy cX wrex wa vz cX wral vy cv vw cv cG co vu cv wceq vw
      cv vy cv cG co vu cv wceq wa vy cX wrex vw cv vu cv cG co vu cv vw cv cG
      co wceq cG cgr wcel vw cv cX wcel wa vy cv vz cv cG co vu cv wceq vz cv
      vy cv cG co vu cv wceq wa vy cX wrex vz cX wral vy cv vw cv cG co vu cv
      wceq vw cv vy cv cG co vu cv wceq wa vy cX wrex vu cv vz cv cG co vz cv
      wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv
      vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral vw cv cX wcel vy cv vz
      cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX wrex vz cX wral
      vy cv vw cv cG co vu cv wceq vw cv vy cv cG co vu cv wceq wa vy cX wrex
      cG cgr wcel vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa
      vy cX wrex vy cv vw cv cG co vu cv wceq vw cv vy cv cG co vu cv wceq wa
      vy cX wrex vz vw cv cX vz cv vw cv wceq vy cv vz cv cG co vu cv wceq vz
      cv vy cv cG co vu cv wceq wa vy cv vw cv cG co vu cv wceq vw cv vy cv cG
      co vu cv wceq wa vy cX vz cv vw cv wceq vy cv vz cv cG co vu cv wceq vy
      cv vw cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq vw cv vy cv cG co
      vu cv wceq vz cv vw cv wceq vy cv vz cv cG co vy cv vw cv cG co vu cv vz
      cv vw cv vy cv cG opreq2 eqeq1d vz cv vw cv wceq vz cv vy cv cG co vw cv
      vy cv cG co vu cv vz cv vw cv vy cv cG opreq1 eqeq1d anbi12d rexbidv
      rcla4va adantll vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq
      wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX
      wrex wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy
      cX wrex vz cX vu cv vz cv cG co vz cv wceq vz cv vu cv cG co vz cv wceq
      wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG co vu cv wceq wa vy cX
      wrex pm3.27 r19.20si sylan2 vy vw cv vu cv cG cX grpfo.1 grpidinvlem4
      syldan an1rs adantllr adantr cG cgr wcel vu cv cX wcel wa vw cv cX wcel
      vu cv vx cv cG co vx cv wceq vx cX wral vw cv vx cv cG co vx cv wceq vx
      cX wral wa vw cv vu cv cG co vu cv wceq vu cv vz cv cG co vz cv wceq vz
      cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv vy cv cG
      co vu cv wceq wa vy cX wrex wa vz cX wral cG cgr wcel vu cv cX wcel wa vw
      cv vx cv cG co vx cv wceq vx cX wral vw cv vu cv cG co vu cv wceq vw cv
      cX wcel vu cv vx cv cG co vx cv wceq vx cX wral vu cv cX wcel vw cv vx cv
      cG co vx cv wceq vx cX wral vw cv vu cv cG co vu cv wceq cG cgr wcel vw
      cv vx cv cG co vx cv wceq vw cv vu cv cG co vu cv wceq vx vu cv cX vx cv
      vu cv wceq vw cv vx cv cG co vw cv vu cv cG co vx cv vu cv vx cv vu cv vw
      cv cG opreq2 vx cv vu cv wceq id eqeq12d rcla4va adantll ad2ant2rl
      adantllr vw cv cX wcel vu cv vx cv cG co vx cv wceq vx cX wral vu cv vw
      cv cG co vw cv wceq cG cgr wcel vu cv cX wcel wa vu cv vz cv cG co vz cv
      wceq vz cv vu cv cG co vz cv wceq wa vy cv vz cv cG co vu cv wceq vz cv
      vy cv cG co vu cv wceq wa vy cX wrex wa vz cX wral wa vw cv vx cv cG co
      vx cv wceq vx cX wral vu cv vx cv cG co vx cv wceq vu cv vw cv cG co vw
      cv wceq vx vw cv cX vx cv vw cv wceq vu cv vx cv cG co vu cv vw cv cG co
      vx cv vw cv vx cv vw cv vu cv cG opreq2 vx cv vw cv wceq id eqeq12d
      rcla4va ad2ant2lr 3eqtr3d ex mpand r19.21aiva jca ex r19.22dva mpd vu cv
      vx cv cG co vx cv wceq vx cX wral vw cv vx cv cG co vx cv wceq vx cX wral
      vu vw cX vu cv vw cv wceq vu cv vx cv cG co vx cv wceq vw cv vx cv cG co
      vx cv wceq vx cX vu cv vw cv wceq vu cv vx cv cG co vw cv vx cv cG co vx
      cv vu cv vw cv vx cv cG opreq1 eqeq1d ralbidv reu8 sylibr $.
      $( [25-Oct-2006] $) $( [14-Oct-2006] $)
  $}

  $( A group's range in terms of its domain. $)
  grprndm $p |- ( G e. Grp -> ran G = dom dom G ) $=
    cG cgr wcel cG crn cG crn cxp cG crn cG wfo cG crn cG cdm cdm wceq cG cG
    crn cG crn eqid grpfo cG crn cG crn cxp cG crn cG wfo cG cdm cdm cG crn cG
    crn cxp cdm cG crn cG crn cG crn cxp cG crn cG wfo cG cdm cG crn cG crn cxp
    cG crn cG crn cxp cG crn cG wfo cG crn cG crn cxp cG crn cG wf cG cdm cG
    crn cG crn cxp wceq cG crn cG crn cxp cG crn cG fof cG crn cG crn cxp cG
    crn cG fdm syl dmeqd cG crn dmxpid syl6req syl $.
    $( [1-May-2008] $) $( [6-Apr-2008] $)

  $( The empty set is not a group. $)
  0ngrp $p |- -. (/) e. Grp $=
    c0 cgr wcel c0 c0 wne c0 c0 wne wn c0 c0 wceq c0 eqid c0 c0 nne mpbir c0 c0
    c0 crn c0 rn0 eqcomi grpn0 mto $.
    $( [25-Apr-2007] $) $( [25-Apr-2007] $)

  ${
    grprn.1 $e |- G e. Grp $.
    grprn.2 $e |- dom G = ( X X. X ) $.
    $( The range of a group operation.  Useful for satisfying group base set
       hypotheses of the form ` X = ran G ` . $)
    grprn $p |- X = ran G $=
      cG cX cX cxp wfn cG cG crn cG crn cxp wfn cX cG crn wceq cG cX cX cxp wfn
      cG wfun cG cdm cX cX cxp wceq cG cX cX cxp df-fn cG crn cG crn cxp cG crn
      cG wfo cG wfun cG cgr wcel cG crn cG crn cxp cG crn cG wfo grprn.1 cG cG
      crn cG crn eqid grpfo ax-mp cG crn cG crn cxp cG crn cG fofun ax-mp
      grprn.2 mpbir2an cG crn cG crn cxp cG crn cG wfo cG cG crn cG crn cxp wfn
      cG cgr wcel cG crn cG crn cxp cG crn cG wfo grprn.1 cG cG crn cG crn eqid
      grpfo ax-mp cG crn cG crn cxp cG crn cG fofn ax-mp cG cX cX cxp wfn cG cG
      crn cG crn cxp wfn wa cX cX cxp cG crn cG crn cxp wceq cX cG crn wceq cX
      cX cxp cG crn cG crn cxp cG fndmu cX cG crn xpid11 sylib mp2an $.
      $( [30-Mar-2008] $) $( [5-Nov-2006] $)
  $}

  ${
    $d G u x y $. $d X u x y $.
    grprlidrid.1  $e |- X = ran G $.
     $( In a group a left and right identity element is a left identity
       element.  (Contributed by FL, 5-Feb-2010.) $)
    grprlidrid  $p |- ( G e. Grp ->
       U. { u e. X | A. x e. X ( ( u G x ) = x /\ ( x G u ) = x ) } =
       U. { u e. X | A. x e. X ( u G x ) = x } ) $=
      cX cX wss vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx
      cX wral vu cv vx cv cG co vx cv wceq vx cX wral wi vu cX wral wa vu cv vx
      cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX wrex
      vu cv vx cv cG co vx cv wceq vx cX wral vu cX wreu wa vu cv vx cv cG co
      vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX crab cuni vu
      cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni wceq cG cgr wcel vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu
      cv vx cv cG co vx cv wceq vx cX wral vu cX cX reuuniss2 cG cgr wcel vu cv
      vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cv
      vx cv cG co vx cv wceq vx cX wral wi vu cX wral cX cX wss cG cgr wcel vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu
      cv vx cv cG co vx cv wceq vx cX wral wi vu cX cG cgr wcel vu cv vx cv cG
      co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cv vx cv cG
      co vx cv wceq vx cX wral wi vu cv cX wcel cG cgr wcel vu cv vx cv cG co
      vx cv wceq vx cv vu cv cG co vx cv wceq wa vu cv vx cv cG co vx cv wceq
      vx cX vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vu cv
      vx cv cG co vx cv wceq wi cG cgr wcel vx cv cX wcel wa vu cv vx cv cG co
      vx cv wceq vx cv vu cv cG co vx cv wceq pm3.26 a1i r19.20dva a1d
      r19.21aiv cX ssid jctil cG cgr wcel vu cv vx cv cG co vx cv wceq vx cv vu
      cv cG co vx cv wceq wa vx cX wral vu cX wrex vu cv vx cv cG co vx cv wceq
      vx cX wral vu cX wreu cG cgr wcel vu cv vx cv cG co vx cv wceq vx cv vu
      cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu
      cv wceq wa vy cX wrex wa vx cX wral vu cX wrex vu cv vx cv cG co vx cv
      wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX wrex vx vy vu cG cX
      grprlidrid.1 grpidinv vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx
      cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa
      vy cX wrex wa vx cX wral vu cv vx cv cG co vx cv wceq vx cv vu cv cG co
      vx cv wceq wa vx cX wral vu cX vu cv vx cv cG co vx cv wceq vx cv vu cv
      cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv
      wceq wa vy cX wrex wa vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx
      cv wceq wa vx cX vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
      wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy
      cX wrex pm3.26 r19.20si r19.22si syl vx vu cG cX grprlidrid.1 grpideu jca
      sylanc $.
      $( [5-Feb-2010] $) $( [5-Feb-2010] $)
  $}

  ${
    $d g u x y $.
    $( The identity of the empty set is the empty set.  (Contributed by FL,
       5-Feb-2010.) $)
    gid0 $p |- ( Id ` (/) ) = (/) $=
      c0 cgi cfv c0 vy cv vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co
      vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni wceq vg vy copab
      cfv c0 c0 cgi vy cv vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co
      vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni wceq vg vy copab
      vx vy vu vg df-gid fveq1i vg vy c0 vu cv vx cv vg cv co vx cv wceq vx cv
      vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni c0
      0ex 0ex vg cv c0 wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv
      co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni vu cv vx cv vg
      cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx c0 crn wral vu c0
      crn crab cuni c0 vg cv c0 wceq vu cv vx cv vg cv co vx cv wceq vx cv vu
      cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab vu cv vx cv
      vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx c0 crn wral vu
      c0 crn crab vg cv c0 wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg
      cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu c0
      crn crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq
      wa vx c0 crn wral vu c0 crn crab vg cv c0 wceq vg cv crn c0 crn wceq vu
      cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv
      crn wral vu vg cv crn crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg
      cv co vx cv wceq wa vx vg cv crn wral vu c0 crn crab wceq vg cv c0 rneq
      vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg
      cv crn wral vu vg cv crn c0 crn rabeq syl vg cv c0 wceq vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu cv
      vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx c0 crn
      wral vu c0 crn vg cv c0 wceq vu cv c0 crn wcel wa vu cv vx cv vg cv co vx
      cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn c0 crn vg cv c0
      wceq vg cv crn c0 crn wceq vu cv c0 crn wcel vg cv c0 rneq adantr raleq1d
      rabbidv eqtrd unieqd vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co
      vx cv wceq wa vx c0 crn wral vu c0 crn crab cuni c0 cuni c0 vu cv vx cv
      vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx c0 crn wral vu
      c0 crn crab c0 vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv
      wceq wa vx c0 crn wral vu c0 crn crab vu cv vx cv vg cv co vx cv wceq vx
      cv vu cv vg cv co vx cv wceq wa vx c0 crn wral vu c0 crab c0 c0 crn c0
      wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa
      vx c0 crn wral vu c0 crn crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv
      vg cv co vx cv wceq wa vx c0 crn wral vu c0 crab wceq rn0 vu cv vx cv vg
      cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx c0 crn wral vu c0
      crn c0 rabeq ax-mp vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co
      vx cv wceq wa vx c0 crn wral vu rab0 eqtri unieqi uni0 eqtri syl6eq
      fvopab eqtri $.
      $( [5-Feb-2010] $) $( [5-Feb-2010] $)
  $}

  ${
    $d w x y z $.
    $( ` Id ` is a function.  (Contributed by FL, 5-Feb-2010.) $)
    fungid $p |- Fun Id $=
      cgi wfun vy cv vz cv vx cv vw cv co vx cv wceq vx cv vz cv vw cv co vx cv
      wceq wa vx vw cv crn wral vz vw cv crn crab cuni wceq vw vy copab wfun vw
      vy vz cv vx cv vw cv co vx cv wceq vx cv vz cv vw cv co vx cv wceq wa vx
      vw cv crn wral vz vw cv crn crab cuni funopabeq cgi vy cv vz cv vx cv vw
      cv co vx cv wceq vx cv vz cv vw cv co vx cv wceq wa vx vw cv crn wral vz
      vw cv crn crab cuni wceq vw vy copab wceq cgi wfun vy cv vz cv vx cv vw
      cv co vx cv wceq vx cv vz cv vw cv co vx cv wceq wa vx vw cv crn wral vz
      vw cv crn crab cuni wceq vw vy copab wfun wb vx vy vz vw df-gid cgi vy cv
      vz cv vx cv vw cv co vx cv wceq vx cv vz cv vw cv co vx cv wceq wa vx vw
      cv crn wral vz vw cv crn crab cuni wceq vw vy copab funeq ax-mp mpbir $.
      $( [5-Feb-2010] $) $( [5-Feb-2010] $)
  $}

  ${
    $d u x y z A $.
    grpsn.1 $e |- A e. _V $.
    $( MAY BE REVISED - this is useless since we have ablsn - delete this if
       if ever get an example of a non-Abelian group to go here. $)
    $( The group operation for the singleton group. $)
    grpsn $p |- { <. <. A , A >. , A >. } e. Grp $=
      vx vy vz cA cA cA cop cA cop csn cA cA csn cA snex cA csn cA csn cxp cA
      csn cA cA cop cA cop csn wf cA cA cop csn cA csn cA cA cop cA cop csn wf
      cA cA cop csn cA csn cA cA cop cA cop csn wf1o cA cA cop csn cA csn cA cA
      cop cA cop csn wf cA cA cop cA cA cA opex grpsn.1 f1osn cA cA cop csn cA
      csn cA cA cop cA cop csn f1of ax-mp cA csn cA csn cxp cA cA cop csn wceq
      cA csn cA csn cxp cA csn cA cA cop cA cop csn wf cA cA cop csn cA csn cA
      cA cop cA cop csn wf wb cA cA grpsn.1 grpsn.1 xpsn cA csn cA csn cxp cA
      cA cop csn cA csn cA cA cop cA cop csn feq2 ax-mp mpbir vx cv cA wceq vy
      cv cA wceq vz cv cA wceq vx cv vy cv cA cA cop cA cop csn co vz cv cA cA
      cop cA cop csn co vx cv vy cv vz cv cA cA cop cA cop csn co cA cA cop cA
      cop csn co wceq vx cv cA csn wcel vy cv cA csn wcel vz cv cA csn wcel vx
      cv cA wceq vy cv cA wceq vz cv cA wceq w3a vx cv vy cv cA cA cop cA cop
      csn co vz cv cA cA cop cA cop csn co cA vx cv vy cv vz cv cA cA cop cA
      cop csn co cA cA cop cA cop csn co vx cv cA wceq vy cv cA wceq vz cv cA
      wceq vx cv vy cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co cA
      wceq vz cv cA wceq vx cv cA wceq vy cv cA wceq wa vx cv vy cv cA cA cop
      cA cop csn co vz cv cA cA cop cA cop csn co vx cv vy cv cA cA cop cA cop
      csn co cA cA cA cop cA cop csn co cA vz cv cA vx cv vy cv cA cA cop cA
      cop csn co cA cA cop cA cop csn opreq2 vx cv cA wceq vy cv cA wceq wa vx
      cv vy cv cA cA cop cA cop csn co cA cA cA cop cA cop csn co cA cA cA cA
      cop cA cop csn co cA vx cv cA wceq vy cv cA wceq wa vx cv vy cv cA cA cop
      cA cop csn co cA cA cA cA cop cA cop csn vx cv cA wceq vy cv cA wceq vx
      cv vy cv cA cA cop cA cop csn co cA vy cv cA cA cop cA cop csn co cA vx
      cv cA vy cv cA cA cop cA cop csn opreq1 vy cv cA wceq cA vy cv cA cA cop
      cA cop csn co cA cA cA cA cop cA cop csn co cA vy cv cA cA cA cA cop cA
      cop csn opreq2 cA cA cA cA cop cA cop csn co cA cA cop cA cA cop cA cop
      csn cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA opex
      grpsn.1 fvsn eqtri syl6eq sylan9eq opreq1d cA cA cA cA cop cA cop csn co
      cA cA cop cA cA cop cA cop csn cfv cA cA cA cA cA cop cA cop csn df-opr
      cA cA cop cA cA cA opex grpsn.1 fvsn eqtri syl6eq sylan9eqr 3impa vx cv
      cA wceq vy cv cA wceq vz cv cA wceq vx cv vy cv vz cv cA cA cop cA cop
      csn co cA cA cop cA cop csn co cA wceq vx cv cA wceq vy cv cA wceq vz cv
      cA wceq wa vx cv vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn
      co cA vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co cA vx
      cv cA vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn opreq1 vy
      cv cA wceq vz cv cA wceq wa cA vy cv vz cv cA cA cop cA cop csn co cA cA
      cop cA cop csn co cA cA cA cA cop cA cop csn co cA vy cv cA wceq vz cv cA
      wceq wa vy cv vz cv cA cA cop cA cop csn co cA cA cA cA cop cA cop csn vy
      cv cA wceq vz cv cA wceq vy cv vz cv cA cA cop cA cop csn co cA vz cv cA
      cA cop cA cop csn co cA vy cv cA vz cv cA cA cop cA cop csn opreq1 vz cv
      cA wceq cA vz cv cA cA cop cA cop csn co cA cA cA cA cop cA cop csn co cA
      vz cv cA cA cA cA cop cA cop csn opreq2 cA cA cA cA cop cA cop csn co cA
      cA cop cA cA cop cA cop csn cfv cA cA cA cA cA cop cA cop csn df-opr cA
      cA cop cA cA cA opex grpsn.1 fvsn eqtri syl6eq sylan9eq opreq2d cA cA cA
      cA cop cA cop csn co cA cA cop cA cA cop cA cop csn cfv cA cA cA cA cA
      cop cA cop csn df-opr cA cA cop cA cA cA opex grpsn.1 fvsn eqtri syl6eq
      sylan9eq 3impb eqtr4d vx cA elsn vy cA elsn vz cA elsn syl3anb cA grpsn.1
      snid vx cv cA csn wcel vx cv cA wceq cA vx cv cA cA cop cA cop csn co vx
      cv wceq vx cA elsn vx cv cA wceq cA cA cA cA cop cA cop csn co cA cA vx
      cv cA cA cop cA cop csn co vx cv cA cA cA cA cop cA cop csn co cA cA cop
      cA cA cop cA cop csn cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop
      cA cA cA opex grpsn.1 fvsn eqtri vx cv cA cA cA cA cop cA cop csn opreq2
      vx cv cA wceq id 3eqtr4a sylbi cA cA csn wcel vx cv cA csn wcel cA
      grpsn.1 snid a1i vx cv cA csn wcel vx cv cA wceq cA vx cv cA cA cop cA
      cop csn co cA wceq vx cA elsn vx cv cA wceq cA vx cv cA cA cop cA cop csn
      co cA cA cA cA cop cA cop csn co cA vx cv cA cA cA cA cop cA cop csn
      opreq2 cA cA cA cA cop cA cop csn co cA cA cop cA cA cop cA cop csn cfv
      cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA opex grpsn.1 fvsn
      eqtri syl6eq sylbi isgrpi $.
      $( [5-Feb-2010] $) $( [4-Nov-2006] $)
  $}

  ${
    $d x y A $.  $d g u x y G $.  $d u x y U $.  $d g u x y X $.
    grpidval.1 $e |- X = ran G $.
    grpidval.2 $e |- U = ( Id ` G ) $.
    ${
      grpidvallem.3 $e |- G e. Grp $.
      $( The value of the identity element of a group. $)
      grpidvallem $p |-
                   U = U. { u e. X | A. x e. X ( u G x ) = x } $=
        cU cG cgi cfv vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni
        grpidval.2 cG cvv wcel vu cv vx cv cG co vx cv wceq vx cX wral vu cX
        crab cuni cvv wcel cG cgi cfv vu cv vx cv cG co vx cv wceq vx cX wral
        vu cX crab cuni wceq cG cgr grpidvallem.3 elisseti vu cv vx cv cG co vx
        cv wceq vx cX wral vu cX crab vu cv vx cv cG co vx cv wceq vx cX wral
        vu cX cX cG crn cvv grpidval.1 cG cG cgr grpidvallem.3 elisseti rnex
        eqeltri rabex uniex vg vy cG vu cv vx cv vg cv co vx cv wceq vx cv vu
        cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni vu
        cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni cvv cvv cgi vg cv
        cG wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq
        wa vx vg cv crn wral vu vg cv crn crab cuni vu cv vx cv cG co vx cv
        wceq vx cv vu cv cG co vx cv wceq wa vx cG crn wral vu cG crn crab cuni
        vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni vg cv cG wceq
        vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx
        vg cv crn wral vu vg cv crn crab vu cv vx cv cG co vx cv wceq vx cv vu
        cv cG co vx cv wceq wa vx cG crn wral vu cG crn crab vg cv cG wceq vu
        cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg
        cv crn wral vu vg cv crn crab vu cv vx cv vg cv co vx cv wceq vx cv vu
        cv vg cv co vx cv wceq wa vx vg cv crn wral vu cG crn crab vu cv vx cv
        cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cG crn wral vu cG
        crn crab vg cv cG wceq vg cv crn cG crn wceq vu cv vx cv vg cv co vx cv
        wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
        crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa
        vx vg cv crn wral vu cG crn crab wceq vg cv cG rneq vu cv vx cv vg cv
        co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu
        vg cv crn cG crn rabeq syl vg cv cG wceq vu cv vx cv vg cv co vx cv
        wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu cv vx cv
        cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cG crn wral vu cG
        crn vg cv cG wceq vu cv cG crn wcel wa vu cv vx cv vg cv co vx cv wceq
        vx cv vu cv vg cv co vx cv wceq wa vu cv vx cv cG co vx cv wceq vx cv
        vu cv cG co vx cv wceq wa vx vg cv crn cG crn vg cv cG wceq vg cv crn
        cG crn wceq vu cv cG crn wcel vg cv cG rneq adantr vg cv cG wceq vu cv
        cG crn wcel wa vu cv vx cv vg cv co vx cv wceq vu cv vx cv cG co vx cv
        wceq vx cv vu cv vg cv co vx cv wceq vx cv vu cv cG co vx cv wceq vg cv
        cG wceq vu cv vx cv vg cv co vx cv wceq vu cv vx cv cG co vx cv wceq wb
        vu cv cG crn wcel vg cv cG wceq vu cv vx cv vg cv co vu cv vx cv cG co
        vx cv vu cv vx cv vg cv cG opreq eqeq1d adantr vg cv cG wceq vx cv vu
        cv vg cv co vx cv wceq vx cv vu cv cG co vx cv wceq wb vu cv cG crn
        wcel vg cv cG wceq vx cv vu cv vg cv co vx cv vu cv cG co vx cv vx cv
        vu cv vg cv cG opreq eqeq1d adantr anbi12d raleq12d rabbidv eqtrd
        unieqd vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx
        cG crn wral vu cG crn crab cuni vu cv vx cv cG co vx cv wceq vx cv vu
        cv cG co vx cv wceq wa vx cG crn wral vu cX crab cuni vu cv vx cv cG co
        vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX crab cuni
        vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni vu cv vx cv cG
        co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cG crn wral vu cG crn
        crab vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cG
        crn wral vu cX crab cG crn cX wceq vu cv vx cv cG co vx cv wceq vx cv
        vu cv cG co vx cv wceq wa vx cG crn wral vu cG crn crab vu cv vx cv cG
        co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cG crn wral vu cX crab
        wceq cX cG crn grpidval.1 eqcomi vu cv vx cv cG co vx cv wceq vx cv vu
        cv cG co vx cv wceq wa vx cG crn wral vu cG crn cX rabeq ax-mp unieqi
        vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cG crn
        wral vu cX crab vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
        wceq wa vx cX wral vu cX crab vu cv vx cv cG co vx cv wceq vx cv vu cv
        cG co vx cv wceq wa vx cG crn wral vu cv vx cv cG co vx cv wceq vx cv
        vu cv cG co vx cv wceq wa vx cX wral vu cX vu cv vx cv cG co vx cv wceq
        vx cv vu cv cG co vx cv wceq wa vx cG crn wral vu cv vx cv cG co vx cv
        wceq vx cv vu cv cG co vx cv wceq wa vx cX wral wb vu cv cX wcel cG crn
        cX wceq vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx
        cG crn wral vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq
        wa vx cX wral wb cX cG crn grpidval.1 eqcomi vu cv vx cv cG co vx cv
        wceq vx cv vu cv cG co vx cv wceq wa vx cG crn cX raleq1 ax-mp a1i
        rabbii unieqi cG cgr wcel vu cv vx cv cG co vx cv wceq vx cv vu cv cG
        co vx cv wceq wa vx cX wral vu cX crab cuni vu cv vx cv cG co vx cv
        wceq vx cX wral vu cX crab cuni wceq grpidvallem.3 vx vu cG cX
        grpidval.1 grprlidrid ax-mp 3eqtri syl6eq cgi vy cv vu cv vx cv vg cv
        co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu
        vg cv crn crab cuni wceq vg vy copab vy cv vu cv vx cv vg cv co vx cv
        wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
        crab cuni wceq vg vy copab cvv cres vg cv cvv wcel vy cv vu cv vx cv vg
        cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral
        vu vg cv crn crab cuni wceq wa vg vy copab vx vy vu vg df-gid vy cv vu
        cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg
        cv crn wral vu vg cv crn crab cuni wceq vg vy copab wrel vy cv vu cv vx
        cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn
        wral vu vg cv crn crab cuni wceq vg vy copab cvv cres vy cv vu cv vx cv
        vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn
        wral vu vg cv crn crab cuni wceq vg vy copab wceq vy cv vu cv vx cv vg
        cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral
        vu vg cv crn crab cuni wceq vg vy relopab vy cv vu cv vx cv vg cv co vx
        cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv
        crn crab cuni wceq vg vy copab resid ax-mp vy cv vu cv vx cv vg cv co
        vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg
        cv crn crab cuni wceq vg vy cvv resopab 3eqtr2i fvopab4g mp2an eqtri $.
        $( [5-Feb-2010] $) $( [5-Feb-2010] $)
    $}

    $( The value of the identity element of a group. $)
    grpidval $p |- ( G e. Grp ->
                 U = U. { u e. X | A. x e. X ( u G x ) = x } ) $=
      cG cgr wcel cU vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni
      wceq cG cgr wcel cG c0 c0 cop c0 cop csn cif cgi cfv vu cv vx cv cG cgr
      wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG cgr wcel cG c0 c0
      cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif
      crn crab cuni wceq cG c0 c0 cop c0 cop csn cG cG cgr wcel cG c0 c0 cop c0
      cop csn cif wceq cG cgi cfv vu cv vx cv cG co vx cv wceq vx cG crn wral
      vu cG crn crab cuni wceq cG cgr wcel cG c0 c0 cop c0 cop csn cif cgi cfv
      vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG
      cgr wcel cG c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop
      c0 cop csn cif crn crab cuni wceq cU vu cv vx cv cG co vx cv wceq vx cX
      wral vu cX crab cuni wceq cG cG cgr wcel cG c0 c0 cop c0 cop csn cif wceq
      cG cgi cfv cG cgr wcel cG c0 c0 cop c0 cop csn cif cgi cfv vu cv vx cv cG
      co vx cv wceq vx cG crn wral vu cG crn crab cuni vu cv vx cv cG cgr wcel
      cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG cgr wcel cG c0 c0 cop c0
      cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab
      cuni cG cG cgr wcel cG c0 c0 cop c0 cop csn cif cgi fveq2 cG cG cgr wcel
      cG c0 c0 cop c0 cop csn cif wceq vu cv vx cv cG co vx cv wceq vx cG crn
      wral vu cG crn crab vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif
      co vx cv wceq vx cG cgr wcel cG c0 c0 cop c0 cop csn cif crn wral vu cG
      cgr wcel cG c0 c0 cop c0 cop csn cif crn crab cG cG cgr wcel cG c0 c0 cop
      c0 cop csn cif wceq vu cv vx cv cG co vx cv wceq vx cG crn wral vu cG crn
      crab vu cv vx cv cG co vx cv wceq vx cG crn wral vu cG cgr wcel cG c0 c0
      cop c0 cop csn cif crn crab vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop
      csn cif co vx cv wceq vx cG cgr wcel cG c0 c0 cop c0 cop csn cif crn wral
      vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab cG cG cgr wcel cG c0
      c0 cop c0 cop csn cif wceq cG crn cG cgr wcel cG c0 c0 cop c0 cop csn cif
      crn wceq vu cv vx cv cG co vx cv wceq vx cG crn wral vu cG crn crab vu cv
      vx cv cG co vx cv wceq vx cG crn wral vu cG cgr wcel cG c0 c0 cop c0 cop
      csn cif crn crab wceq cG cG cgr wcel cG c0 c0 cop c0 cop csn cif rneq vu
      cv vx cv cG co vx cv wceq vx cG crn wral vu cG crn cG cgr wcel cG c0 c0
      cop c0 cop csn cif crn rabeq syl cG cG cgr wcel cG c0 c0 cop c0 cop csn
      cif wceq vu cv vx cv cG co vx cv wceq vx cG crn wral vu cv vx cv cG cgr
      wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG cgr wcel cG c0 c0
      cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif
      crn cG cG cgr wcel cG c0 c0 cop c0 cop csn cif wceq vu cv vx cv cG co vx
      cv wceq vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq
      vx cG crn cG cgr wcel cG c0 c0 cop c0 cop csn cif crn cG cG cgr wcel cG
      c0 c0 cop c0 cop csn cif rneq cG cG cgr wcel cG c0 c0 cop c0 cop csn cif
      wceq vu cv vx cv cG co vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn
      cif co vx cv vu cv vx cv cG cG cgr wcel cG c0 c0 cop c0 cop csn cif opreq
      eqeq1d raleq12d rabbisdv eqtrd unieqd eqeq12d cU cG cgi cfv vu cv vx cv
      cG co vx cv wceq vx cX wral vu cX crab cuni vu cv vx cv cG co vx cv wceq
      vx cG crn wral vu cG crn crab cuni grpidval.2 vu cv vx cv cG co vx cv
      wceq vx cX wral vu cX crab vu cv vx cv cG co vx cv wceq vx cG crn wral vu
      cG crn crab vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab vu cv vx
      cv cG co vx cv wceq vx cX wral vu cG crn crab vu cv vx cv cG co vx cv
      wceq vx cG crn wral vu cG crn crab cX cG crn wceq vu cv vx cv cG co vx cv
      wceq vx cX wral vu cX crab vu cv vx cv cG co vx cv wceq vx cX wral vu cG
      crn crab wceq grpidval.1 vu cv vx cv cG co vx cv wceq vx cX wral vu cX cG
      crn rabeq ax-mp vu cv vx cv cG co vx cv wceq vx cX wral vu cv vx cv cG co
      vx cv wceq vx cG crn wral vu cG crn vu cv vx cv cG co vx cv wceq vx cX
      wral vu cv vx cv cG co vx cv wceq vx cG crn wral wb vu cv cG crn wcel cX
      cG crn wceq vu cv vx cv cG co vx cv wceq vx cX wral vu cv vx cv cG co vx
      cv wceq vx cG crn wral wb grpidval.1 vu cv vx cv cG co vx cv wceq vx cX
      cG crn raleq1 ax-mp a1i rabbii eqtri unieqi eqeq12i syl5bb cG cgr wcel cG
      c0 c0 cop c0 cop csn cif cgi cfv cG cgr wcel cG c0 c0 cop c0 cop csn cif
      vy cv vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa
      vx vg cv crn wral vu vg cv crn crab cuni wceq vg vy copab cfv vu cv vx cv
      cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG cgr wcel cG
      c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn
      cif crn crab cuni cG cgr wcel cG c0 c0 cop c0 cop csn cif cgi vy cv vu cv
      vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn
      wral vu vg cv crn crab cuni wceq vg vy copab vx vy vu vg df-gid fveq1i vg
      vy cG cgr wcel cG c0 c0 cop c0 cop csn cif vu cv vx cv vg cv co vx cv
      wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
      crab cuni vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv
      wceq vx cG cgr wcel cG c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel
      cG c0 c0 cop c0 cop csn cif crn crab cuni cG cgr wcel cG c0 c0 cop c0 cop
      csn cif cvv wcel cG cgr wcel cG cvv wcel wa cG cgr wcel wn c0 c0 cop c0
      cop csn cvv wcel wa wo cG cgr wcel cG cvv wcel wa cG cgr wcel wn c0 c0
      cop c0 cop csn cvv wcel wa cG cgr wcel cG cvv wcel wa wn cG cgr wcel wn
      c0 c0 cop c0 cop csn cvv wcel cG cgr wcel cG cgr wcel cG cvv wcel wa cG
      cgr wcel cG cvv wcel cG cgr elisset ancli con3i c0 c0 cop c0 cop snex
      jctir orri cG cgr wcel cG c0 c0 cop c0 cop csn cvv ifel mpbir vu cv vx cv
      cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG cgr wcel cG
      c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn
      cif crn crab vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv
      wceq vx cG cgr wcel cG c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel
      cG c0 c0 cop c0 cop csn cif crn cG cgr wcel cG c0 c0 cop c0 cop csn cif
      cG cgr wcel cG c0 c0 cop c0 cop csn cif cvv wcel cG cgr wcel cG cvv wcel
      wa cG cgr wcel wn c0 c0 cop c0 cop csn cvv wcel wa wo cG cgr wcel cG cvv
      wcel wa cG cgr wcel wn c0 c0 cop c0 cop csn cvv wcel wa cG cgr wcel cG
      cvv wcel wa wn cG cgr wcel wn c0 c0 cop c0 cop csn cvv wcel cG cgr wcel
      cG cgr wcel cG cvv wcel wa cG cgr wcel cG cvv wcel cG cgr elisset ancli
      con3i c0 c0 cop c0 cop snex jctir orri cG cgr wcel cG c0 c0 cop c0 cop
      csn cvv ifel mpbir rnex rabex uniex vg cv cG cgr wcel cG c0 c0 cop c0 cop
      csn cif wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv
      wceq wa vx vg cv crn wral vu vg cv crn crab cuni vu cv vx cv cG cgr wcel
      cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cv vu cv cG cgr wcel cG c0
      c0 cop c0 cop csn cif co vx cv wceq wa vx cG cgr wcel cG c0 c0 cop c0 cop
      csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab cuni
      vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cG
      cgr wcel cG c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop
      c0 cop csn cif crn crab cuni vg cv cG cgr wcel cG c0 c0 cop c0 cop csn
      cif wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq
      wa vx vg cv crn wral vu vg cv crn crab vu cv vx cv cG cgr wcel cG c0 c0
      cop c0 cop csn cif co vx cv wceq vx cv vu cv cG cgr wcel cG c0 c0 cop c0
      cop csn cif co vx cv wceq wa vx cG cgr wcel cG c0 c0 cop c0 cop csn cif
      crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab vg cv cG cgr
      wcel cG c0 c0 cop c0 cop csn cif wceq vu cv vx cv vg cv co vx cv wceq vx
      cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab vu cv
      vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn
      wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab vu cv vx cv cG
      cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cv vu cv cG cgr
      wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq wa vx cG cgr wcel cG c0 c0
      cop c0 cop csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif
      crn crab vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif wceq vg cv crn cG
      cgr wcel cG c0 c0 cop c0 cop csn cif crn wceq vu cv vx cv vg cv co vx cv
      wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
      crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa
      vx vg cv crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab
      wceq vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif rneq vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg
      cv crn cG cgr wcel cG c0 c0 cop c0 cop csn cif crn rabeq syl vg cv cG cgr
      wcel cG c0 c0 cop c0 cop csn cif wceq vu cv vx cv vg cv co vx cv wceq vx
      cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu cv vx cv cG cgr wcel
      cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cv vu cv cG cgr wcel cG c0
      c0 cop c0 cop csn cif co vx cv wceq wa vx cG cgr wcel cG c0 c0 cop c0 cop
      csn cif crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn vg cv cG
      cgr wcel cG c0 c0 cop c0 cop csn cif wceq vu cv vx cv vg cv co vx cv wceq
      vx cv vu cv vg cv co vx cv wceq wa vu cv vx cv cG cgr wcel cG c0 c0 cop
      c0 cop csn cif co vx cv wceq vx cv vu cv cG cgr wcel cG c0 c0 cop c0 cop
      csn cif co vx cv wceq wa vx vg cv crn cG cgr wcel cG c0 c0 cop c0 cop csn
      cif crn vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif rneq vg cv cG cgr
      wcel cG c0 c0 cop c0 cop csn cif wceq vu cv vx cv vg cv co vx cv wceq vu
      cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq vx cv vu
      cv vg cv co vx cv wceq vx cv vu cv cG cgr wcel cG c0 c0 cop c0 cop csn
      cif co vx cv wceq vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif wceq vu
      cv vx cv vg cv co vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co
      vx cv vu cv vx cv vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif opreq
      eqeq1d vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif wceq vx cv vu cv vg
      cv co vx cv vu cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv vx cv
      vu cv vg cv cG cgr wcel cG c0 c0 cop c0 cop csn cif opreq eqeq1d anbi12d
      raleq12d rabbisdv eqtrd unieqd cG cgr wcel cG c0 c0 cop c0 cop csn cif
      cgr wcel vu cv vx cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv
      wceq vx cv vu cv cG cgr wcel cG c0 c0 cop c0 cop csn cif co vx cv wceq wa
      vx cG cgr wcel cG c0 c0 cop c0 cop csn cif crn wral vu cG cgr wcel cG c0
      c0 cop c0 cop csn cif crn crab cuni vu cv vx cv cG cgr wcel cG c0 c0 cop
      c0 cop csn cif co vx cv wceq vx cG cgr wcel cG c0 c0 cop c0 cop csn cif
      crn wral vu cG cgr wcel cG c0 c0 cop c0 cop csn cif crn crab cuni wceq cG
      c0 c0 cop c0 cop csn cgr c0 0ex grpsn elimel vx vu cG cgr wcel cG c0 c0
      cop c0 cop csn cif cG cgr wcel cG c0 c0 cop c0 cop csn cif crn cG cgr
      wcel cG c0 c0 cop c0 cop csn cif crn eqid grprlidrid ax-mp syl6eq fvopab
      eqtri dedth $.
      $( [5-Feb-2010] $) $( [5-Feb-2010] $)

    $( The identity element of a group belongs to the group. $)
    grpidcl $p |- ( G e. Grp -> U e. X ) $=
      cG cgr wcel cU vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni cX
      vx vu cU cG cX grpidval.1 grpidval.2 grpidval cG cgr wcel vu cv vx cv cG
      co vx cv wceq vx cX wral vu cX wreu vu cv vx cv cG co vx cv wceq vx cX
      wral vu cX crab cuni cX wcel vx vu cG cX grpidval.1 grpideu vu cv vx cv
      cG co vx cv wceq vx cX wral vu cX reucl syl eqeltrd $.
      $( [26-Oct-2006] $) $( [24-Oct-2006] $)

    $( A group's properties using the explicit identity element. $)
    grpidinv2 $p |- ( ( G e. Grp /\ A e. X ) -> ( ( ( U G A ) = A /\
         ( A G U ) = A ) /\ E. y e. X ( ( y G A ) = U /\ ( A G y ) = U ) ) ) $=
      cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa vy cv vx cv cG co
      cU wceq vx cv vy cv cG co cU wceq wa vy cX wrex wa vx cX wral cA cX wcel
      cU cA cG co cA wceq cA cU cG co cA wceq wa vy cv cA cG co cU wceq cA vy
      cv cG co cU wceq wa vy cX wrex wa cG cgr wcel cU vx cv cG co vx cv wceq
      vx cv cU cG co vx cv wceq wa vy cv vx cv cG co cU wceq vx cv vy cv cG co
      cU wceq wa vy cX wrex wa cU cA cG co cA wceq cA cU cG co cA wceq wa vy cv
      cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex wa vx cA cX vx cv
      cA wceq cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa cU cA cG
      co cA wceq cA cU cG co cA wceq wa vy cv vx cv cG co cU wceq vx cv vy cv
      cG co cU wceq wa vy cX wrex vy cv cA cG co cU wceq cA vy cv cG co cU wceq
      wa vy cX wrex vx cv cA wceq cU vx cv cG co vx cv wceq cU cA cG co cA wceq
      vx cv cU cG co vx cv wceq cA cU cG co cA wceq vx cv cA wceq cU vx cv cG
      co cU cA cG co vx cv cA vx cv cA cU cG opreq2 vx cv cA wceq id eqeq12d vx
      cv cA wceq vx cv cU cG co cA cU cG co vx cv cA vx cv cA cU cG opreq1 vx
      cv cA wceq id eqeq12d anbi12d vx cv cA wceq vy cv vx cv cG co cU wceq vx
      cv vy cv cG co cU wceq wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq
      wa vy cX vx cv cA wceq vy cv vx cv cG co cU wceq vy cv cA cG co cU wceq
      vx cv vy cv cG co cU wceq cA vy cv cG co cU wceq vx cv cA wceq vy cv vx
      cv cG co vy cv cA cG co cU vx cv cA vy cv cG opreq2 eqeq1d vx cv cA wceq
      vx cv vy cv cG co cA vy cv cG co cU vx cv cA vy cv cG opreq1 eqeq1d
      anbi12d rexbidv anbi12d rcla4cva cG cgr wcel cU vx cv cG co vx cv wceq vx
      cv cU cG co vx cv wceq wa vy cv vx cv cG co cU wceq vx cv vy cv cG co cU
      wceq wa vy cX wrex wa vx cX wral vu cv vx cv cG co vx cv wceq vx cv vu cv
      cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv
      wceq wa vy cX wrex wa vx cX wral vu cX crab cuni cU wceq cG cgr wcel vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG
      co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu
      cX crab cuni vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni cU
      vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv
      cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral
      vu cX wrex vu cv vx cv cG co vx cv wceq vx cX wral vu cX wreu vu cv vx cv
      cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv
      wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu cX crab
      cuni vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni wceq cG cgr
      wcel cX cX wss vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq
      wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX
      wrex wa vx cX wral vu cv vx cv cG co vx cv wceq vx cX wral wi vu cX wral
      vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv
      cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral
      vu cX wrex vu cv vx cv cG co vx cv wceq vx cX wral vu cX wreu wa vu cv vx
      cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu
      cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu cX
      crab cuni vu cv vx cv cG co vx cv wceq vx cX wral vu cX crab cuni wceq cX
      ssid vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv
      vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx
      cX wral vu cv vx cv cG co vx cv wceq vx cX wral wi vu cX vu cv vx cv cG
      co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv
      wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu cv vx cv
      cG co vx cv wceq vx cX wral wi vu cv cX wcel vu cv vx cv cG co vx cv wceq
      vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv
      cG co vu cv wceq wa vy cX wrex wa vu cv vx cv cG co vx cv wceq vx cX vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq vy cv vx cv cG co
      vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex simpll r19.20si a1i
      rgen vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv
      vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx
      cX wral vu cv vx cv cG co vx cv wceq vx cX wral vu cX cX reuuniss2
      mpanl12 vx vy vu cG cX grpidval.1 grpidinv vx vu cG cX grpidval.1 grpideu
      sylanc vx vu cU cG cX grpidval.1 grpidval.2 grpidval eqtr4d cU cX wcel vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG
      co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu
      cX wreu cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa vy cv vx
      cv cG co cU wceq vx cv vy cv cG co cU wceq wa vy cX wrex wa vx cX wral vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG
      co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu
      cX crab cuni cU wceq wb cG cgr wcel vu cv vx cv cG co vx cv wceq vx cv vu
      cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu
      cv wceq wa vy cX wrex wa vx cX wral cU vx cv cG co vx cv wceq vx cv cU cG
      co vx cv wceq wa vy cv vx cv cG co cU wceq vx cv vy cv cG co cU wceq wa
      vy cX wrex wa vx cX wral vu cX cU vu cv cU wceq vu cv vx cv cG co vx cv
      wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv
      vy cv cG co vu cv wceq wa vy cX wrex wa cU vx cv cG co vx cv wceq vx cv
      cU cG co vx cv wceq wa vy cv vx cv cG co cU wceq vx cv vy cv cG co cU
      wceq wa vy cX wrex wa vx cX vu cv cU wceq vu cv vx cv cG co vx cv wceq vx
      cv vu cv cG co vx cv wceq wa cU vx cv cG co vx cv wceq vx cv cU cG co vx
      cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa
      vy cX wrex vy cv vx cv cG co cU wceq vx cv vy cv cG co cU wceq wa vy cX
      wrex vu cv cU wceq vu cv vx cv cG co vx cv wceq cU vx cv cG co vx cv wceq
      vx cv vu cv cG co vx cv wceq vx cv cU cG co vx cv wceq vu cv cU wceq vu
      cv vx cv cG co cU vx cv cG co vx cv vu cv cU vx cv cG opreq1 eqeq1d vu cv
      cU wceq vx cv vu cv cG co vx cv cU cG co vx cv vu cv cU vx cv cG opreq2
      eqeq1d anbi12d vu cv cU wceq vy cv vx cv cG co vu cv wceq vx cv vy cv cG
      co vu cv wceq wa vy cv vx cv cG co cU wceq vx cv vy cv cG co cU wceq wa
      vy cX vu cv cU wceq vy cv vx cv cG co vu cv wceq vy cv vx cv cG co cU
      wceq vx cv vy cv cG co vu cv wceq vx cv vy cv cG co cU wceq vu cv cU vy
      cv vx cv cG co eqeq2 vu cv cU vx cv vy cv cG co eqeq2 anbi12d rexbidv
      anbi12d ralbidv reuuni2 cU cG cX grpidval.1 grpidval.2 grpidcl vu cv vx
      cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu
      cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu cX
      wrex vu cv vx cv cG co vx cv wceq vx cX wral vu cX wreu vu cv vx cv cG co
      vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq
      vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu cX wreu cG
      cgr wcel cX cX wss vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
      wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy
      cX wrex wa vx cX wral vu cv vx cv cG co vx cv wceq vx cX wral wi vu cX
      wral vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv
      vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx
      cX wral vu cX wrex vu cv vx cv cG co vx cv wceq vx cX wral vu cX wreu wa
      vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv
      cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral
      vu cX wreu cX ssid vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
      wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy
      cX wrex wa vx cX wral vu cv vx cv cG co vx cv wceq vx cX wral wi vu cX vu
      cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG
      co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vx cX wral vu
      cv vx cv cG co vx cv wceq vx cX wral wi vu cv cX wcel vu cv vx cv cG co
      vx cv wceq vx cv vu cv cG co vx cv wceq wa vy cv vx cv cG co vu cv wceq
      vx cv vy cv cG co vu cv wceq wa vy cX wrex wa vu cv vx cv cG co vx cv
      wceq vx cX vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq vy
      cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq wa vy cX wrex
      simpll r19.20si a1i rgen vu cv vx cv cG co vx cv wceq vx cv vu cv cG co
      vx cv wceq wa vy cv vx cv cG co vu cv wceq vx cv vy cv cG co vu cv wceq
      wa vy cX wrex wa vx cX wral vu cv vx cv cG co vx cv wceq vx cX wral vu cX
      cX reuss2 mpanl12 vx vy vu cG cX grpidval.1 grpidinv vx vu cG cX
      grpidval.1 grpideu sylanc sylanc mpbird sylan $.
      $( [27-Oct-2006] $) $( [24-Oct-2006] $)

    $( The identity element of a group is a left identity. $)
    grplid $p |- ( ( G e. Grp /\ A e. X ) -> ( U G A ) = A ) $=
      cG cgr wcel cA cX wcel wa cU cA cG co cA wceq cA cU cG co cA wceq wa vy
      cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex wa cU cA cG co
      cA wceq vy cA cU cG cX grpidval.1 grpidval.2 grpidinv2 cU cA cG co cA
      wceq cA cU cG co cA wceq vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa
      vy cX wrex simpll syl $.
      $( [28-Oct-2006] $) $( [24-Oct-2006] $)

    $( The identity element of a group is a right identity. $)
    grprid $p |- ( ( G e. Grp /\ A e. X ) -> ( A G U ) = A ) $=
      cG cgr wcel cA cX wcel wa cU cA cG co cA wceq cA cU cG co cA wceq wa vy
      cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex wa cA cU cG co
      cA wceq vy cA cU cG cX grpidval.1 grpidval.2 grpidinv2 cU cA cG co cA
      wceq cA cU cG co cA wceq vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa
      vy cX wrex simplr syl $.
      $( [27-Oct-2006] $) $( [24-Oct-2006] $)
  $}

  ${
    $d x y z G $.  $d x y z X $.
    $d y A $.  $d y B $.  $d y C $.  $d y G $.  $d y X $.
    grprcan.1 $e |- X = ran G $.
    $( Right cancellation law for groups. $)
    grprcan $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel cA cC cG co cB cC cG co wceq
      cA cB wceq wb cG cgr wcel cA cX wcel cB cX wcel cC cX wcel cA cC cG co cB
      cC cG co wceq cA cB wceq wb cG cgr wcel cA cX wcel wa cB cX wcel cC cX
      wcel wa wa cA cC cG co cB cC cG co wceq cA cB wceq cG cgr wcel cA cX wcel
      wa cB cX wcel cC cX wcel wa wa cC vy cv cG co cG cgi cfv wceq vy cX wrex
      cA cC cG co cB cC cG co wceq cA cB wceq wi cG cgr wcel cC cX wcel cC vy
      cv cG co cG cgi cfv wceq vy cX wrex cA cX wcel cB cX wcel cG cgr wcel cC
      cX wcel wa cG cgi cfv cC cG co cC wceq cC cG cgi cfv cG co cC wceq wa vy
      cv cC cG co cG cgi cfv wceq cC vy cv cG co cG cgi cfv wceq wa vy cX wrex
      wa cC vy cv cG co cG cgi cfv wceq vy cX wrex vy cC cG cgi cfv cG cX
      grprcan.1 cG cgi cfv eqid grpidinv2 vy cv cC cG co cG cgi cfv wceq cC vy
      cv cG co cG cgi cfv wceq wa vy cX wrex cC vy cv cG co cG cgi cfv wceq vy
      cX wrex cG cgi cfv cC cG co cC wceq cC cG cgi cfv cG co cC wceq wa vy cv
      cC cG co cG cgi cfv wceq cC vy cv cG co cG cgi cfv wceq wa cC vy cv cG co
      cG cgi cfv wceq vy cX vy cv cC cG co cG cgi cfv wceq cC vy cv cG co cG
      cgi cfv wceq pm3.27 r19.22si adantl syl ad2ant2rl cG cgr wcel cA cX wcel
      wa cB cX wcel cC cX wcel wa wa cC vy cv cG co cG cgi cfv wceq cA cC cG co
      cB cC cG co wceq cA cB wceq wi vy cX cG cgr wcel cA cX wcel wa cB cX wcel
      cC cX wcel wa wa vy cv cX wcel cC vy cv cG co cG cgi cfv wceq cA cC cG co
      cB cC cG co wceq cA cB wceq cG cgr wcel cA cX wcel wa cB cX wcel cC cX
      wcel wa wa vy cv cX wcel cC vy cv cG co cG cgi cfv wceq cA cC cG co cB cC
      cG co wceq wa wa wa cA cG cgi cfv cG co cB cG cgi cfv cG co cA cB cG cgr
      wcel cA cX wcel wa cB cX wcel cC cX wcel wa wa vy cv cX wcel cC vy cv cG
      co cG cgi cfv wceq cA cC cG co cB cC cG co wceq wa wa wa cA cC vy cv cG
      co cG co cB cC vy cv cG co cG co cA cG cgi cfv cG co cB cG cgi cfv cG co
      cG cgr wcel cA cX wcel wa cB cX wcel cC cX wcel wa wa vy cv cX wcel cA cC
      cG co cB cC cG co wceq cA cC vy cv cG co cG co cB cC vy cv cG co cG co
      wceq cC vy cv cG co cG cgi cfv wceq cG cgr wcel cA cX wcel wa cB cX wcel
      cC cX wcel wa wa vy cv cX wcel cA cC cG co cB cC cG co wceq wa wa cA cC
      cG co vy cv cG co cB cC cG co vy cv cG co cA cC vy cv cG co cG co cB cC
      vy cv cG co cG co cA cC cG co cB cC cG co wceq cA cC cG co vy cv cG co cB
      cC cG co vy cv cG co wceq cG cgr wcel cA cX wcel wa cB cX wcel cC cX wcel
      wa wa vy cv cX wcel cA cC cG co cB cC cG co vy cv cG opreq1 ad2antll cG
      cgr wcel cA cX wcel wa cB cX wcel cC cX wcel wa wa vy cv cX wcel cA cC cG
      co vy cv cG co cA cC vy cv cG co cG co wceq cA cC cG co cB cC cG co wceq
      cG cgr wcel cA cX wcel wa cC cX wcel vy cv cX wcel cA cC cG co vy cv cG
      co cA cC vy cv cG co cG co wceq cB cX wcel cG cgr wcel cA cX wcel cC cX
      wcel vy cv cX wcel cA cC cG co vy cv cG co cA cC vy cv cG co cG co wceq
      cG cgr wcel cA cX wcel cC cX wcel vy cv cX wcel cA cC cG co vy cv cG co
      cA cC vy cv cG co cG co wceq cA cC vy cv cG cX grprcan.1 grpass 3exp2
      imp41 adantlrl adantrr cG cgr wcel cA cX wcel wa cB cX wcel cC cX wcel wa
      wa vy cv cX wcel cB cC cG co vy cv cG co cB cC vy cv cG co cG co wceq cA
      cC cG co cB cC cG co wceq cG cgr wcel cB cX wcel cC cX wcel wa vy cv cX
      wcel cB cC cG co vy cv cG co cB cC vy cv cG co cG co wceq cA cX wcel cG
      cgr wcel cB cX wcel cC cX wcel vy cv cX wcel cB cC cG co vy cv cG co cB
      cC vy cv cG co cG co wceq cG cgr wcel cB cX wcel cC cX wcel vy cv cX wcel
      cB cC cG co vy cv cG co cB cC vy cv cG co cG co wceq cB cC vy cv cG cX
      grprcan.1 grpass 3exp2 imp42 adantllr adantrr 3eqtr3d adantrrl vy cv cX
      wcel cC vy cv cG co cG cgi cfv wceq cA cC cG co cB cC cG co wceq wa wa cA
      cC vy cv cG co cG co cA cG cgi cfv cG co wceq cG cgr wcel cA cX wcel wa
      cB cX wcel cC cX wcel wa wa cC vy cv cG co cG cgi cfv wceq cA cC vy cv cG
      co cG co cA cG cgi cfv cG co wceq vy cv cX wcel cA cC cG co cB cC cG co
      wceq cC vy cv cG co cG cgi cfv cA cG opreq2 ad2antrl adantl vy cv cX wcel
      cC vy cv cG co cG cgi cfv wceq cA cC cG co cB cC cG co wceq wa wa cB cC
      vy cv cG co cG co cB cG cgi cfv cG co wceq cG cgr wcel cA cX wcel wa cB
      cX wcel cC cX wcel wa wa cC vy cv cG co cG cgi cfv wceq cB cC vy cv cG co
      cG co cB cG cgi cfv cG co wceq vy cv cX wcel cA cC cG co cB cC cG co wceq
      cC vy cv cG co cG cgi cfv cB cG opreq2 ad2antrl adantl 3eqtr3d cG cgr
      wcel cA cX wcel wa cA cG cgi cfv cG co cA wceq cB cX wcel cC cX wcel wa
      vy cv cX wcel cC vy cv cG co cG cgi cfv wceq cA cC cG co cB cC cG co wceq
      wa wa cA cG cgi cfv cG cX grprcan.1 cG cgi cfv eqid grprid ad2antrr cG
      cgr wcel cA cX wcel wa cB cX wcel cC cX wcel wa wa cB cG cgi cfv cG co cB
      wceq vy cv cX wcel cC vy cv cG co cG cgi cfv wceq cA cC cG co cB cC cG co
      wceq wa wa cG cgr wcel cB cX wcel cB cG cgi cfv cG co cB wceq cA cX wcel
      cC cX wcel cB cG cgi cfv cG cX grprcan.1 cG cgi cfv eqid grprid ad2ant2r
      adantr 3eqtr3d exp45 r19.23adv mpd cA cB cC cG opreq1 impbid1 exp43 3imp2
      $.
      $( [28-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  ${
    $d y z A $.  $d y z G $.  $d y z U $.  $d y z X $.
    grpinveu.1 $e |- X = ran G $.
    grpinveu.2 $e |- U = ( Id ` G ) $.
    $( The left inverse element of a group is unique.  Lemma 2.2.1(b) of
       [Herstein] p. 55. $)
    grpinveu $p |- ( ( G e. Grp /\ A e. X ) -> E! y e. X ( y G A ) = U ) $=
      cG cgr wcel cA cX wcel wa vy cv cA cG co cU wceq vz cv cA cG co cU wceq
      vy cv vz cv wceq wi vz cX wral wa vy cX wrex vy cv cA cG co cU wceq vy cX
      wreu cG cgr wcel cA cX wcel wa vy cv cA cG co cU wceq vy cX wrex vy cv cA
      cG co cU wceq vz cv cA cG co cU wceq vy cv vz cv wceq wi vz cX wral wa vy
      cX wrex cG cgr wcel cA cX wcel wa cU cA cG co cA wceq cA cU cG co cA wceq
      wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex wa vy cv
      cA cG co cU wceq vy cX wrex vy cA cU cG cX grpinveu.1 grpinveu.2
      grpidinv2 vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex vy
      cv cA cG co cU wceq vy cX wrex cU cA cG co cA wceq cA cU cG co cA wceq wa
      vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cv cA cG co cU wceq
      vy cX vy cv cA cG co cU wceq cA vy cv cG co cU wceq pm3.26 r19.22si
      adantl syl cG cgr wcel cA cX wcel wa vy cv cA cG co cU wceq vy cv cA cG
      co cU wceq vz cv cA cG co cU wceq vy cv vz cv wceq wi vz cX wral wa vy cX
      cG cgr wcel cA cX wcel wa vy cv cX wcel wa vy cv cA cG co cU wceq vz cv
      cA cG co cU wceq vy cv vz cv wceq wi vz cX wral cG cgr wcel cA cX wcel wa
      vy cv cX wcel wa vy cv cA cG co cU wceq vz cv cA cG co cU wceq vy cv vz
      cv wceq wi vz cX cG cgr wcel cA cX wcel wa vy cv cX wcel wa vz cv cX wcel
      wa vy cv cA cG co cU wceq vz cv cA cG co cU wceq vy cv vz cv wceq cG cgr
      wcel cA cX wcel wa vz cv cX wcel vy cv cX wcel vy cv cA cG co cU wceq vz
      cv cA cG co cU wceq wa vy cv vz cv wceq wi cG cgr wcel cA cX wcel vz cv
      cX wcel vy cv cX wcel vy cv cA cG co cU wceq vz cv cA cG co cU wceq wa vy
      cv vz cv wceq wi cG cgr wcel vy cv cX wcel vz cv cX wcel cA cX wcel vy cv
      cA cG co cU wceq vz cv cA cG co cU wceq wa vy cv vz cv wceq wi cG cgr
      wcel vy cv cX wcel vz cv cX wcel cA cX wcel vy cv cA cG co cU wceq vz cv
      cA cG co cU wceq wa vy cv vz cv wceq wi cG cgr wcel vy cv cX wcel vz cv
      cX wcel cA cX wcel w3a wa vy cv cA cG co vz cv cA cG co wceq vy cv vz cv
      wceq vy cv cA cG co cU wceq vz cv cA cG co cU wceq wa vy cv vz cv cA cG
      cX grpinveu.1 grprcan vy cv cA cG co vz cv cA cG co cU eqtr3 syl5bi 3exp2
      com24 imp41 an1rs exp3a r19.21adva ancld r19.22dva mpd vy cv cA cG co cU
      wceq vz cv cA cG co cU wceq vy vz cX vy cv vz cv wceq vy cv cA cG co vz
      cv cA cG co cU vy cv vz cv cA cG opreq1 eqeq1d reu8 sylibr $.
      $( [29-Oct-2006] $) $( [27-Oct-2006] $)

    $( Two ways of saying that an element of a group is the identity element.
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    grpid $p |- ( ( G e. Grp /\ A e. X ) ->
                  ( A = U <-> ( A G A ) = A ) ) $=
      cG cgr wcel cA cX wcel wa cA cA cG co cU cA cG co wceq cA cU wceq cA cA
      cG co cA wceq cG cgr wcel cA cX wcel cA cA cG co cU cA cG co wceq cA cU
      wceq wb cG cgr wcel cA cX wcel cA cA cG co cU cA cG co wceq cA cU wceq wb
      cG cgr wcel cA cX wcel cU cX wcel cA cX wcel cA cA cG co cU cA cG co wceq
      cA cU wceq wb wi cU cG cX grpinveu.1 grpinveu.2 grpidcl cG cgr wcel cA cX
      wcel cU cX wcel cA cX wcel cA cA cG co cU cA cG co wceq cA cU wceq wb cA
      cU cA cG cX grpinveu.1 grprcan 3exp2 mpid pm2.43d imp cG cgr wcel cA cX
      wcel wa cU cA cG co cA cA cA cG co cA cU cG cX grpinveu.1 grpinveu.2
      grplid eqeq2d bitr3d $.
      $( [26-Feb-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d n x y A $.  $d y B $.  $d y C $.  $d f g n x y G $.  $d f g n x y X $.
    $d f g n x U $.
    grpinvfval.1 $e |- X = ran G $.
    grpinvfval.2 $e |- U = ( Id ` G ) $.
    grpinvfval.3 $e |- N = ( inv ` G ) $.
    $( The inverse function of a group. $)
    grpinvfval $p |- ( G e. Grp -> N = { <. x , n >. | ( x e. X /\
                     n = U. { y e. X | ( y G x ) = U } ) } ) $=
      cG cgr wcel cG cgn cfv vx cv cX wcel vn cv vy cv vx cv cG co cU wceq vy
      cX crab cuni wceq wa vx vn copab cN cG cgr wcel vx cv cX wcel vn cv vy cv
      vx cv cG co cU wceq vy cX crab cuni wceq wa vx vn copab cvv wcel cG cgn
      cfv vx cv cX wcel vn cv vy cv vx cv cG co cU wceq vy cX crab cuni wceq wa
      vx vn copab wceq cG cgr wcel cX cvv wcel vx cv cX wcel vn cv vy cv vx cv
      cG co cU wceq vy cX crab cuni wceq wa vx vn copab cvv wcel cG cgr wcel cG
      crn cvv cX cG cgr rnexg grpinvfval.1 syl5eqel vx vn cX vy cv vx cv cG co
      cU wceq vy cX crab cuni cvv opabex2g syl vg vf cG vx cv vg cv crn wcel vn
      cv vy cv vx cv vg cv co vg cv cgi cfv wceq vy vg cv crn crab cuni wceq wa
      vx vn copab vx cv cX wcel vn cv vy cv vx cv cG co cU wceq vy cX crab cuni
      wceq wa vx vn copab cgr cvv cgn vg cv cG wceq vx cv vg cv crn wcel vn cv
      vy cv vx cv vg cv co vg cv cgi cfv wceq vy vg cv crn crab cuni wceq wa vx
      cv cX wcel vn cv vy cv vx cv cG co cU wceq vy cX crab cuni wceq wa vx vn
      vg cv cG wceq vx cv vg cv crn wcel vx cv cX wcel vn cv vy cv vx cv vg cv
      co vg cv cgi cfv wceq vy vg cv crn crab cuni wceq vn cv vy cv vx cv cG co
      cU wceq vy cX crab cuni wceq vg cv cG wceq vg cv crn cX vx cv vg cv cG
      wceq vg cv crn cG crn cX vg cv cG rneq grpinvfval.1 syl6eqr eleq2d vg cv
      cG wceq vy cv vx cv vg cv co vg cv cgi cfv wceq vy vg cv crn crab cuni vy
      cv vx cv cG co cU wceq vy cX crab cuni vn cv vg cv cG wceq vy cv vx cv vg
      cv co vg cv cgi cfv wceq vy vg cv crn crab vy cv vx cv cG co cU wceq vy
      cX crab vg cv cG wceq vy cv vx cv vg cv co vg cv cgi cfv wceq vy vg cv
      crn crab vy cv vx cv vg cv co vg cv cgi cfv wceq vy cX crab vy cv vx cv
      cG co cU wceq vy cX crab vg cv cG wceq vg cv crn cX wceq vy cv vx cv vg
      cv co vg cv cgi cfv wceq vy vg cv crn crab vy cv vx cv vg cv co vg cv cgi
      cfv wceq vy cX crab wceq vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq
      grpinvfval.1 syl6eqr vy cv vx cv vg cv co vg cv cgi cfv wceq vy vg cv crn
      cX rabeq syl vg cv cG wceq vy cv vx cv vg cv co vg cv cgi cfv wceq vy cv
      vx cv cG co cU wceq vy cX vg cv cG wceq vy cv vx cv vg cv co vy cv vx cv
      cG co vg cv cgi cfv cU vy cv vx cv vg cv cG opreq vg cv cG wceq vg cv cgi
      cfv cG cgi cfv cU vg cv cG cgi fveq2 grpinvfval.2 syl6eqr eqeq12d
      rabbisdv eqtrd unieqd eqeq2d anbi12d opabbidv vx vn vy vf vg df-ginv
      fvopab4g mpdan grpinvfval.3 syl5eq $.
      $( [30-Oct-2006] $) $( [26-Oct-2006] $)

    $( The inverse of a group element. $)
    grpinvval $p |- ( ( G e. Grp /\ A e. X ) ->
                    ( N ` A ) = U. { y e. X | ( y G A ) = U } ) $=
      cG cgr wcel cA cX wcel wa cA cN cfv cA vx cv cX wcel vn cv vy cv vx cv cG
      co cU wceq vy cX crab cuni wceq wa vx vn copab cfv vy cv cA cG co cU wceq
      vy cX crab cuni cG cgr wcel cA cN cfv cA vx cv cX wcel vn cv vy cv vx cv
      cG co cU wceq vy cX crab cuni wceq wa vx vn copab cfv wceq cA cX wcel cG
      cgr wcel cA cN vx cv cX wcel vn cv vy cv vx cv cG co cU wceq vy cX crab
      cuni wceq wa vx vn copab vx vy cU vn cG cN cX grpinvfval.1 grpinvfval.2
      grpinvfval.3 grpinvfval fveq1d adantr cA cX wcel vy cv cA cG co cU wceq
      vy cX crab cuni cvv wcel cA vx cv cX wcel vn cv vy cv vx cv cG co cU wceq
      vy cX crab cuni wceq wa vx vn copab cfv vy cv cA cG co cU wceq vy cX crab
      cuni wceq cG cgr wcel cA cX wcel wa vx vn cA vy cv vx cv cG co cU wceq vy
      cX crab cuni vy cv cA cG co cU wceq vy cX crab cuni cX cvv vx cv cX wcel
      vn cv vy cv vx cv cG co cU wceq vy cX crab cuni wceq wa vx vn copab vx cv
      cA wceq vy cv vx cv cG co cU wceq vy cX crab vy cv cA cG co cU wceq vy cX
      crab vx cv cA wceq vy cv vx cv cG co cU wceq vy cv cA cG co cU wceq vy cX
      vx cv cA wceq vy cv vx cv cG co vy cv cA cG co cU vx cv cA vy cv cG
      opreq2 eqeq1d rabbisdv unieqd vx cv cX wcel vn cv vy cv vx cv cG co cU
      wceq vy cX crab cuni wceq wa vx vn copab eqid fvopab4g cG cgr wcel cA cX
      wcel pm3.27 cG cgr wcel vy cv cA cG co cU wceq vy cX crab cuni cvv wcel
      cA cX wcel cG cgr wcel cX cvv wcel vy cv cA cG co cU wceq vy cX crab cvv
      wcel vy cv cA cG co cU wceq vy cX crab cuni cvv wcel cG cgr wcel cG crn
      cvv cX cG cgr rnexg grpinvfval.1 syl5eqel vy cv cA cG co cU wceq vy cX
      cvv rabexg vy cv cA cG co cU wceq vy cX crab cvv uniexg 3syl adantr
      sylanc eqtrd $.
      $( [30-Oct-2006] $) $( [26-Oct-2006] $)
  $}

  ${
    $d y A $.  $d y G $.  $d y X $.
    grpinvcl.1 $e |- X = ran G $.
    grpinvcl.2 $e |- N = ( inv ` G ) $.
    $( A group element's inverse is a group element. $)
    grpinvcl $p |- ( ( G e. Grp /\ A e. X ) -> ( N ` A ) e. X ) $=
      cG cgr wcel cA cX wcel wa cA cN cfv vy cv cA cG co cG cgi cfv wceq vy cX
      crab cuni cX vy cA cG cgi cfv cG cN cX grpinvcl.1 cG cgi cfv eqid
      grpinvcl.2 grpinvval cG cgr wcel cA cX wcel wa vy cv cA cG co cG cgi cfv
      wceq vy cX wreu vy cv cA cG co cG cgi cfv wceq vy cX crab cuni cX wcel vy
      cA cG cgi cfv cG cX grpinvcl.1 cG cgi cfv eqid grpinveu vy cv cA cG co cG
      cgi cfv wceq vy cX reucl syl eqeltrd $.
      $( [31-Oct-2006] $) $( [27-Oct-2006] $)
  $}

  ${
    $d y A $.  $d y G $.  $d y N $.  $d y U $.  $d y X $.
    grpinv.1 $e |- X = ran G $.
    grpinv.2 $e |- U = ( Id ` G ) $.
    grpinv.3 $e |- N = ( inv ` G ) $.
    $( The properties of a group element's inverse. $)
    grpinv $p |- ( ( G e. Grp /\ A e. X ) ->
                 ( ( ( N ` A ) G A ) = U /\ ( A G ( N ` A ) ) = U ) ) $=
      cG cgr wcel cA cX wcel wa cA cN cfv cA cG co cU wceq cA cA cN cfv cG co
      cU wceq wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX crab
      cuni cA cN cfv wceq cG cgr wcel cA cX wcel wa vy cv cA cG co cU wceq cA
      vy cv cG co cU wceq wa vy cX crab cuni vy cv cA cG co cU wceq vy cX crab
      cuni cA cN cfv vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX
      wrex vy cv cA cG co cU wceq vy cX wreu vy cv cA cG co cU wceq cA vy cv cG
      co cU wceq wa vy cX crab cuni vy cv cA cG co cU wceq vy cX crab cuni wceq
      cG cgr wcel cA cX wcel wa cX cX wss vy cv cA cG co cU wceq cA vy cv cG co
      cU wceq wa vy cv cA cG co cU wceq wi vy cX wral vy cv cA cG co cU wceq cA
      vy cv cG co cU wceq wa vy cX wrex vy cv cA cG co cU wceq vy cX wreu wa vy
      cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX crab cuni vy cv cA cG
      co cU wceq vy cX crab cuni wceq cX ssid vy cv cA cG co cU wceq cA vy cv
      cG co cU wceq wa vy cv cA cG co cU wceq wi vy cX vy cv cA cG co cU wceq
      cA vy cv cG co cU wceq wa vy cv cA cG co cU wceq wi vy cv cX wcel vy cv
      cA cG co cU wceq cA vy cv cG co cU wceq pm3.26 a1i rgen vy cv cA cG co cU
      wceq cA vy cv cG co cU wceq wa vy cv cA cG co cU wceq vy cX cX reuuniss2
      mpanl12 cG cgr wcel cA cX wcel wa cU cA cG co cA wceq cA cU cG co cA wceq
      wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex vy cA cU
      cG cX grpinv.1 grpinv.2 grpidinv2 pm3.27d vy cA cU cG cX grpinv.1
      grpinv.2 grpinveu sylanc vy cA cU cG cN cX grpinv.1 grpinv.2 grpinv.3
      grpinvval eqtr4d cA cN cfv cX wcel vy cv cA cG co cU wceq cA vy cv cG co
      cU wceq wa vy cX wreu cA cN cfv cA cG co cU wceq cA cA cN cfv cG co cU
      wceq wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX crab cuni
      cA cN cfv wceq wb cG cgr wcel cA cX wcel wa vy cv cA cG co cU wceq cA vy
      cv cG co cU wceq wa cA cN cfv cA cG co cU wceq cA cA cN cfv cG co cU wceq
      wa vy cX cA cN cfv vy cv cA cN cfv wceq vy cv cA cG co cU wceq cA cN cfv
      cA cG co cU wceq cA vy cv cG co cU wceq cA cA cN cfv cG co cU wceq vy cv
      cA cN cfv wceq vy cv cA cG co cA cN cfv cA cG co cU vy cv cA cN cfv cA cG
      opreq1 eqeq1d vy cv cA cN cfv wceq cA vy cv cG co cA cA cN cfv cG co cU
      vy cv cA cN cfv cA cG opreq2 eqeq1d anbi12d reuuni2 cA cG cN cX grpinv.1
      grpinv.3 grpinvcl vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX
      wrex vy cv cA cG co cU wceq vy cX wreu vy cv cA cG co cU wceq cA vy cv cG
      co cU wceq wa vy cX wreu cG cgr wcel cA cX wcel wa cX cX wss vy cv cA cG
      co cU wceq cA vy cv cG co cU wceq wa vy cv cA cG co cU wceq wi vy cX wral
      vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cX wrex vy cv cA cG
      co cU wceq vy cX wreu wa vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa
      vy cX wreu cX ssid vy cv cA cG co cU wceq cA vy cv cG co cU wceq wa vy cv
      cA cG co cU wceq wi vy cX vy cv cA cG co cU wceq cA vy cv cG co cU wceq
      wa vy cv cA cG co cU wceq wi vy cv cX wcel vy cv cA cG co cU wceq cA vy
      cv cG co cU wceq pm3.26 a1i rgen vy cv cA cG co cU wceq cA vy cv cG co cU
      wceq wa vy cv cA cG co cU wceq vy cX cX reuss2 mpanl12 cG cgr wcel cA cX
      wcel wa cU cA cG co cA wceq cA cU cG co cA wceq wa vy cv cA cG co cU wceq
      cA vy cv cG co cU wceq wa vy cX wrex vy cA cU cG cX grpinv.1 grpinv.2
      grpidinv2 pm3.27d vy cA cU cG cX grpinv.1 grpinv.2 grpinveu sylanc sylanc
      mpbird $.
      $( [1-Nov-2006] $) $( [27-Oct-2006] $)

    $( The left inverse of a group element. $)
    grplinv $p |- ( ( G e. Grp /\ A e. X ) -> ( ( N ` A ) G A ) = U ) $=
      cG cgr wcel cA cX wcel wa cA cN cfv cA cG co cU wceq cA cA cN cfv cG co
      cU wceq cA cU cG cN cX grpinv.1 grpinv.2 grpinv.3 grpinv pm3.26d $.
      $( [4-Nov-2006] $) $( [27-Oct-2006] $)

    $( The right inverse of a group element. $)
    grprinv $p |- ( ( G e. Grp /\ A e. X ) -> ( A G ( N ` A ) ) = U ) $=
      cG cgr wcel cA cX wcel wa cA cN cfv cA cG co cU wceq cA cA cN cfv cG co
      cU wceq cA cU cG cN cX grpinv.1 grpinv.2 grpinv.3 grpinv pm3.27d $.
      $( [6-Nov-2006] $) $( [27-Oct-2006] $)

    $( The inverse of a group element expressed in terms of the identity
       element. $)
    grpinvid1 $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                    ( ( N ` A ) = B <-> ( A G B ) = U ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cB wceq cA cB cG co cU
      wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cB wceq wa cA cA cN
      cfv cG co cA cB cG co cU cA cN cfv cB wceq cA cA cN cfv cG co cA cB cG co
      wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cB cA cG opreq2
      adantl cG cgr wcel cA cX wcel cB cX wcel w3a cA cA cN cfv cG co cU wceq
      cA cN cfv cB wceq cG cgr wcel cA cX wcel cA cA cN cfv cG co cU wceq cB cX
      wcel cA cU cG cN cX grpinv.1 grpinv.2 grpinv.3 grprinv 3adant3 adantr
      eqtr3d cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cG co cU wceq wa cA cN
      cfv cA cB cG co cG co cA cN cfv cU cG co cB cA cN cfv cA cB cG co cU wceq
      cA cN cfv cA cB cG co cG co cA cN cfv cU cG co wceq cG cgr wcel cA cX
      wcel cB cX wcel w3a cA cB cG co cU cA cN cfv cG opreq2 adantl cG cgr wcel
      cA cX wcel cB cX wcel w3a cA cN cfv cA cB cG co cG co cB wceq cA cB cG co
      cU wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cA cG co cB cG co
      cU cB cG co cA cN cfv cA cB cG co cG co cB cG cgr wcel cA cX wcel cA cN
      cfv cA cG co cB cG co cU cB cG co wceq cB cX wcel cG cgr wcel cA cX wcel
      wa cA cN cfv cA cG co cU cB cG cA cU cG cN cX grpinv.1 grpinv.2 grpinv.3
      grplinv opreq1d 3adant3 cG cgr wcel cA cX wcel cB cX wcel cA cN cfv cA cG
      co cB cG co cA cN cfv cA cB cG co cG co wceq cG cgr wcel cA cX wcel cB cX
      wcel wa cA cN cfv cX wcel cA cX wcel cB cX wcel w3a cA cN cfv cA cG co cB
      cG co cA cN cfv cA cB cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel
      wa wa cA cN cfv cX wcel cA cX wcel cB cX wcel cG cgr wcel cA cX wcel cA
      cN cfv cX wcel cB cX wcel cA cG cN cX grpinv.1 grpinv.3 grpinvcl adantrr
      cG cgr wcel cA cX wcel cB cX wcel simprl cG cgr wcel cA cX wcel cB cX
      wcel simprr 3jca cA cN cfv cA cB cG cX grpinv.1 grpass syldan 3impb cG
      cgr wcel cB cX wcel cU cB cG co cB wceq cA cX wcel cB cU cG cX grpinv.1
      grpinv.2 grplid 3adant2 3eqtr3d adantr cG cgr wcel cA cX wcel cB cX wcel
      w3a cA cN cfv cU cG co cA cN cfv wceq cA cB cG co cU wceq cG cgr wcel cA
      cX wcel cA cN cfv cU cG co cA cN cfv wceq cB cX wcel cG cgr wcel cA cX
      wcel cA cN cfv cX wcel cA cN cfv cU cG co cA cN cfv wceq cA cG cN cX
      grpinv.1 grpinv.3 grpinvcl cA cN cfv cU cG cX grpinv.1 grpinv.2 grprid
      syldan 3adant3 adantr 3eqtr3rd impbida $.
      $( [10-Nov-2006] $) $( [27-Oct-2006] $)

    $( The inverse of a group element expressed in terms of the identity
       element. $)
    grpinvid2 $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                    ( ( N ` A ) = B <-> ( B G A ) = U ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cB wceq cB cA cG co cU
      wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cB wceq wa cA cN cfv
      cA cG co cB cA cG co cU cA cN cfv cB wceq cA cN cfv cA cG co cB cA cG co
      wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cB cA cG opreq1
      adantl cG cgr wcel cA cX wcel cB cX wcel w3a cA cN cfv cA cG co cU wceq
      cA cN cfv cB wceq cG cgr wcel cA cX wcel cA cN cfv cA cG co cU wceq cB cX
      wcel cA cU cG cN cX grpinv.1 grpinv.2 grpinv.3 grplinv 3adant3 adantr
      eqtr3d cG cgr wcel cA cX wcel cB cX wcel w3a cB cA cG co cU wceq wa cA cN
      cfv cU cA cN cfv cG co cB cA cG co cA cN cfv cG co cB cG cgr wcel cA cX
      wcel cB cX wcel w3a cA cN cfv cU cA cN cfv cG co wceq cB cA cG co cU wceq
      cG cgr wcel cA cX wcel cB cX wcel w3a cU cA cN cfv cG co cA cN cfv cG cgr
      wcel cA cX wcel cU cA cN cfv cG co cA cN cfv wceq cB cX wcel cG cgr wcel
      cA cX wcel cA cN cfv cX wcel cU cA cN cfv cG co cA cN cfv wceq cA cG cN
      cX grpinv.1 grpinv.3 grpinvcl cA cN cfv cU cG cX grpinv.1 grpinv.2 grplid
      syldan 3adant3 eqcomd adantr cB cA cG co cU wceq cB cA cG co cA cN cfv cG
      co cU cA cN cfv cG co wceq cG cgr wcel cA cX wcel cB cX wcel w3a cB cA cG
      co cU cA cN cfv cG opreq1 adantl cG cgr wcel cA cX wcel cB cX wcel w3a cB
      cA cG co cA cN cfv cG co cB wceq cB cA cG co cU wceq cG cgr wcel cA cX
      wcel cB cX wcel w3a cB cA cG co cA cN cfv cG co cB cA cA cN cfv cG co cG
      co cB cU cG co cB cG cgr wcel cA cX wcel cB cX wcel cB cA cG co cA cN cfv
      cG co cB cA cA cN cfv cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel
      wa cB cX wcel cA cX wcel cA cN cfv cX wcel w3a cB cA cG co cA cN cfv cG
      co cB cA cA cN cfv cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel wa
      wa cB cX wcel cA cX wcel cA cN cfv cX wcel cG cgr wcel cA cX wcel cB cX
      wcel simprr cG cgr wcel cA cX wcel cB cX wcel simprl cG cgr wcel cA cX
      wcel cA cN cfv cX wcel cB cX wcel cA cG cN cX grpinv.1 grpinv.3 grpinvcl
      adantrr 3jca cB cA cA cN cfv cG cX grpinv.1 grpass syldan 3impb cG cgr
      wcel cA cX wcel cB cA cA cN cfv cG co cG co cB cU cG co wceq cB cX wcel
      cG cgr wcel cA cX wcel wa cA cA cN cfv cG co cU cB cG cA cU cG cN cX
      grpinv.1 grpinv.2 grpinv.3 grprinv opreq2d 3adant3 cG cgr wcel cB cX wcel
      cB cU cG co cB wceq cA cX wcel cB cU cG cX grpinv.1 grpinv.2 grprid
      3adant2 3eqtrd adantr 3eqtr2d impbida $.
      $( [23-Nov-2006] $) $( [27-Oct-2006] $)
  $}

  ${
    grpinvid.1 $e |- U = ( Id ` G ) $.
    grpinvid.2 $e |- N = ( inv ` G ) $.
    $( The inverse of the identity element of a group. $)
    grpinvid $p |- ( G e. Grp -> ( N ` U ) = U ) $=
      cG cgr wcel cU cN cfv cU wceq cU cU cG co cU wceq cG cgr wcel cU cG crn
      wcel cU cU cG co cU wceq cU cG cG crn cG crn eqid grpinvid.1 grpidcl cU
      cU cG cG crn cG crn eqid grpinvid.1 grplid mpdan cG cgr wcel cU cG crn
      wcel cU cG crn wcel cU cN cfv cU wceq cU cU cG co cU wceq wb cU cG cG crn
      cG crn eqid grpinvid.1 grpidcl cU cG cG crn cG crn eqid grpinvid.1
      grpidcl cU cU cU cG cN cG crn cG crn eqid grpinvid.1 grpinvid.2 grpinvid1
      mpd3an23 mpbird $.
      $( [28-Feb-2008] $) $( [4-Dec-2006] $)
  $}

  ${
    grplcan.1 $e |- X = ran G $.
    $( Left cancellation law for groups. $)
    grplcan $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cC cA cG co cC cB cG
      co wceq cA cB wceq cG cgr wcel cA cX wcel cB cX wcel cC cX wcel cC cA cG
      co cC cB cG co wceq cA cB wceq wi cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel cC cA cG co cC cB cG co wceq cA cB wceq wi cG cgr wcel cA cX wcel wa
      cB cX wcel cC cX wcel wa wa cC cA cG co cC cB cG co wceq cA cB wceq cG
      cgr wcel cA cX wcel wa cB cX wcel cC cX wcel wa wa cC cA cG co cC cB cG
      co wceq wa cC cG cgn cfv cfv cC cA cG co cG co cC cG cgn cfv cfv cC cB cG
      co cG co cA cB cC cA cG co cC cB cG co wceq cC cG cgn cfv cfv cC cA cG co
      cG co cC cG cgn cfv cfv cC cB cG co cG co wceq cG cgr wcel cA cX wcel wa
      cB cX wcel cC cX wcel wa wa cC cA cG co cC cB cG co cC cG cgn cfv cfv cG
      opreq2 adantl cG cgr wcel cA cX wcel wa cB cX wcel cC cX wcel wa wa cC cG
      cgn cfv cfv cC cA cG co cG co cA wceq cC cA cG co cC cB cG co wceq cG cgr
      wcel cA cX wcel wa cC cX wcel cC cG cgn cfv cfv cC cA cG co cG co cA wceq
      cB cX wcel cG cgr wcel cA cX wcel wa cC cX wcel wa cC cG cgn cfv cfv cC
      cG co cA cG co cG cgi cfv cA cG co cC cG cgn cfv cfv cC cA cG co cG co cA
      cG cgr wcel cA cX wcel wa cC cX wcel wa cC cG cgn cfv cfv cC cG co cG cgi
      cfv cA cG cG cgr wcel cC cX wcel cC cG cgn cfv cfv cC cG co cG cgi cfv
      wceq cA cX wcel cC cG cgi cfv cG cG cgn cfv cX grplcan.1 cG cgi cfv eqid
      cG cgn cfv eqid grplinv adantlr opreq1d cG cgr wcel cA cX wcel cC cX wcel
      cC cG cgn cfv cfv cC cG co cA cG co cC cG cgn cfv cfv cC cA cG co cG co
      wceq cG cgr wcel cA cX wcel cC cX wcel wa cC cG cgn cfv cfv cX wcel cC cX
      wcel cA cX wcel w3a cC cG cgn cfv cfv cC cG co cA cG co cC cG cgn cfv cfv
      cC cA cG co cG co wceq cG cgr wcel cA cX wcel cC cX wcel wa wa cC cG cgn
      cfv cfv cX wcel cC cX wcel cA cX wcel cG cgr wcel cC cX wcel cC cG cgn
      cfv cfv cX wcel cA cX wcel cC cG cG cgn cfv cX grplcan.1 cG cgn cfv eqid
      grpinvcl adantrl cG cgr wcel cA cX wcel cC cX wcel simprr cG cgr wcel cA
      cX wcel cC cX wcel simprl 3jca cC cG cgn cfv cfv cC cA cG cX grplcan.1
      grpass syldan anassrs cG cgr wcel cA cX wcel wa cG cgi cfv cA cG co cA
      wceq cC cX wcel cA cG cgi cfv cG cX grplcan.1 cG cgi cfv eqid grplid
      adantr 3eqtr3d adantrl adantr cG cgr wcel cA cX wcel wa cB cX wcel cC cX
      wcel wa wa cC cG cgn cfv cfv cC cB cG co cG co cB wceq cC cA cG co cC cB
      cG co wceq cG cgr wcel cB cX wcel cC cX wcel wa cC cG cgn cfv cfv cC cB
      cG co cG co cB wceq cA cX wcel cG cgr wcel cB cX wcel cC cX wcel wa wa cC
      cG cgn cfv cfv cC cG co cB cG co cG cgi cfv cB cG co cC cG cgn cfv cfv cC
      cB cG co cG co cB cG cgr wcel cB cX wcel cC cX wcel wa wa cC cG cgn cfv
      cfv cC cG co cG cgi cfv cB cG cG cgr wcel cC cX wcel cC cG cgn cfv cfv cC
      cG co cG cgi cfv wceq cB cX wcel cC cG cgi cfv cG cG cgn cfv cX grplcan.1
      cG cgi cfv eqid cG cgn cfv eqid grplinv adantrl opreq1d cG cgr wcel cB cX
      wcel cC cX wcel wa cC cG cgn cfv cfv cX wcel cC cX wcel cB cX wcel w3a cC
      cG cgn cfv cfv cC cG co cB cG co cC cG cgn cfv cfv cC cB cG co cG co wceq
      cG cgr wcel cB cX wcel cC cX wcel wa wa cC cG cgn cfv cfv cX wcel cC cX
      wcel cB cX wcel cG cgr wcel cC cX wcel cC cG cgn cfv cfv cX wcel cB cX
      wcel cC cG cG cgn cfv cX grplcan.1 cG cgn cfv eqid grpinvcl adantrl cG
      cgr wcel cB cX wcel cC cX wcel simprr cG cgr wcel cB cX wcel cC cX wcel
      simprl 3jca cC cG cgn cfv cfv cC cB cG cX grplcan.1 grpass syldan cG cgr
      wcel cB cX wcel cG cgi cfv cB cG co cB wceq cC cX wcel cB cG cgi cfv cG
      cX grplcan.1 cG cgi cfv eqid grplid adantrr 3eqtr3d adantlr adantr
      3eqtr3d ex exp43 3imp2 cA cB cC cG opreq2 impbid1 $.
      $( [11-Nov-2006] $) $( [27-Oct-2006] $)
  $}

  ${
    $d u v w x y z G $.  $d u v w x y z X $.
    isgrp2i.1 $e |- X e. _V $.
    isgrp2i.2 $e |- X =/= (/) $.
    isgrp2i.3 $e |- G : ( X X. X ) --> X $.
    isgrp2i.4 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                    ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $.
    isgrp2i.5 $e |- ( ( x e. X /\ y e. X ) -> E. z e. X ( z G x ) = y ) $.
    isgrp2i.6 $e |- ( ( x e. X /\ y e. X ) -> E. z e. X ( x G z ) = y ) $.
    $( An alternate way to show a group operation.  Exercise 1 of [Herstein]
       p. 57. $)
    isgrp2i $p |- G e. Grp $=
      cG cgr wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co
      vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX
      wrex w3a cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co vx
      cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex
      isgrp2i.3 vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vx vy vz cX cX cX isgrp2i.4 rgen3 vw cv cX wcel vw wex vu cv vx cv
      cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu
      cX wrex cX c0 wne vw cv cX wcel vw wex isgrp2i.2 vw cX n0 mpbi vw cv cX
      wcel vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX wrex
      wa vx cX wral vu cX wrex vw vw cv cX wcel vu cv vw cv cG co vw cv wceq vu
      cX wrex vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq vy cX
      wrex wa vx cX wral vu cX wrex vw cv cX wcel vz cv vw cv cG co vw cv wceq
      vz cX wrex vu cv vw cv cG co vw cv wceq vu cX wrex vw cv cX wcel vz cv vw
      cv cG co vw cv wceq vz cX wrex vx cv cX wcel vw cv cX wcel wa vz cv vx cv
      cG co vw cv wceq vz cX wrex wi vw cv cX wcel vw cv cX wcel wa vz cv vw cv
      cG co vw cv wceq vz cX wrex wi vx vw vx cv vw cv wceq vx cv cX wcel vw cv
      cX wcel wa vw cv cX wcel vw cv cX wcel wa vz cv vx cv cG co vw cv wceq vz
      cX wrex vz cv vw cv cG co vw cv wceq vz cX wrex vx cv vw cv wceq vx cv cX
      wcel vw cv cX wcel vw cv cX wcel vx cv vw cv cX eleq1 anbi1d vx cv vw cv
      wceq vz cv vx cv cG co vw cv wceq vz cv vw cv cG co vw cv wceq vz cX vx
      cv vw cv wceq vz cv vx cv cG co vz cv vw cv cG co vw cv vx cv vw cv vz cv
      cG opreq2 eqeq1d rexbidv imbi12d vx cv cX wcel vy cv cX wcel wa vz cv vx
      cv cG co vy cv wceq vz cX wrex wi vx cv cX wcel vw cv cX wcel wa vz cv vx
      cv cG co vw cv wceq vz cX wrex wi vy vw vy cv vw cv wceq vx cv cX wcel vy
      cv cX wcel wa vx cv cX wcel vw cv cX wcel wa vz cv vx cv cG co vy cv wceq
      vz cX wrex vz cv vx cv cG co vw cv wceq vz cX wrex vy cv vw cv wceq vy cv
      cX wcel vw cv cX wcel vx cv cX wcel vy cv vw cv cX eleq1 anbi2d vy cv vw
      cv wceq vz cv vx cv cG co vy cv wceq vz cv vx cv cG co vw cv wceq vz cX
      vy cv vw cv vz cv vx cv cG co eqeq2 rexbidv imbi12d isgrp2i.5 chvarv
      chvarv anidms vz cv vw cv cG co vw cv wceq vu cv vw cv cG co vw cv wceq
      vz vu cX vz cv vu cv wceq vz cv vw cv cG co vu cv vw cv cG co vw cv vz cv
      vu cv vw cv cG opreq1 eqeq1d cbvrexv sylib vw cv cX wcel vu cv vw cv cG
      co vw cv wceq vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv wceq
      vy cX wrex wa vx cX wral vu cX vw cv cX wcel vu cv cX wcel wa vu cv vw cv
      cG co vw cv wceq vu cv vx cv cG co vx cv wceq vy cv vx cv cG co vu cv
      wceq vy cX wrex wa vx cX vw cv cX wcel vu cv cX wcel wa vx cv cX wcel vu
      cv vw cv cG co vw cv wceq vu cv vx cv cG co vx cv wceq vy cv vx cv cG co
      vu cv wceq vy cX wrex wa vw cv cX wcel vu cv cX wcel wa vx cv cX wcel vu
      cv vw cv cG co vw cv wceq vu cv vx cv cG co vx cv wceq vy cv vx cv cG co
      vu cv wceq vy cX wrex wa vw cv cX wcel vu cv cX wcel wa vx cv cX wcel wa
      vu cv vw cv cG co vw cv wceq wa vu cv vx cv cG co vx cv wceq vy cv vx cv
      cG co vu cv wceq vy cX wrex vw cv cX wcel vu cv cX wcel wa vx cv cX wcel
      wa vu cv vw cv cG co vw cv wceq wa vw cv vv cv cG co vx cv wceq vv cX
      wrex vu cv vx cv cG co vx cv wceq vw cv cX wcel vu cv cX wcel wa vx cv cX
      wcel wa vw cv vv cv cG co vx cv wceq vv cX wrex vu cv vw cv cG co vw cv
      wceq vw cv cX wcel vx cv cX wcel vw cv vv cv cG co vx cv wceq vv cX wrex
      vu cv cX wcel vw cv cX wcel vx cv cX wcel wa vw cv vz cv cG co vx cv wceq
      vz cX wrex vw cv vv cv cG co vx cv wceq vv cX wrex vx cv vz cv cG co vy
      cv wceq vz cX wrex vw cv vz cv cG co vy cv wceq vz cX wrex vw cv vz cv cG
      co vx cv wceq vz cX wrex vx vy vw cv vx cv cX cX vx cv vw cv wceq vx cv
      vz cv cG co vy cv wceq vw cv vz cv cG co vy cv wceq vz cX vx cv vw cv
      wceq vx cv vz cv cG co vw cv vz cv cG co vy cv vx cv vw cv vz cv cG
      opreq1 eqeq1d rexbidv vy cv vx cv wceq vw cv vz cv cG co vy cv wceq vw cv
      vz cv cG co vx cv wceq vz cX vy cv vx cv vw cv vz cv cG co eqeq2 rexbidv
      isgrp2i.6 vtocl2ga vw cv vz cv cG co vx cv wceq vw cv vv cv cG co vx cv
      wceq vz vv cX vz cv vv cv wceq vw cv vz cv cG co vw cv vv cv cG co vx cv
      vz cv vv cv vw cv cG opreq2 eqeq1d cbvrexv sylib adantlr adantr vw cv cX
      wcel vu cv cX wcel wa vu cv vw cv cG co vw cv wceq vw cv vv cv cG co vx
      cv wceq vv cX wrex vu cv vx cv cG co vx cv wceq wi vx cv cX wcel vw cv cX
      wcel vu cv cX wcel wa vu cv vw cv cG co vw cv wceq wa vw cv vv cv cG co
      vx cv wceq vu cv vx cv cG co vx cv wceq vv cX vw cv cX wcel vu cv cX wcel
      wa vu cv vw cv cG co vw cv wceq wa vv cv cX wcel vw cv vv cv cG co vx cv
      wceq vu cv vx cv cG co vx cv wceq vw cv cX wcel vu cv cX wcel wa vu cv vw
      cv cG co vw cv wceq wa vv cv cX wcel wa vw cv vv cv cG co vx cv wceq wa
      vu cv vw cv vv cv cG co cG co vw cv vv cv cG co vu cv vx cv cG co vx cv
      vw cv cX wcel vu cv cX wcel wa vu cv vw cv cG co vw cv wceq wa vv cv cX
      wcel wa vu cv vw cv vv cv cG co cG co vw cv vv cv cG co wceq vw cv vv cv
      cG co vx cv wceq vw cv cX wcel vu cv cX wcel wa vu cv vw cv cG co vw cv
      wceq wa vv cv cX wcel wa vu cv vw cv cG co vv cv cG co vu cv vw cv vv cv
      cG co cG co vw cv vv cv cG co vw cv cX wcel vu cv cX wcel wa vv cv cX
      wcel vu cv vw cv cG co vv cv cG co vu cv vw cv vv cv cG co cG co wceq vu
      cv vw cv cG co vw cv wceq vw cv cX wcel vu cv cX wcel vv cv cX wcel vu cv
      vw cv cG co vv cv cG co vu cv vw cv vv cv cG co cG co wceq vu cv cX wcel
      vw cv cX wcel vv cv cX wcel vu cv vw cv cG co vv cv cG co vu cv vw cv vv
      cv cG co cG co wceq vx cv cX wcel vw cv cX wcel vv cv cX wcel w3a vx cv
      vw cv cG co vv cv cG co vx cv vw cv vv cv cG co cG co wceq wi vu cv cX
      wcel vw cv cX wcel vv cv cX wcel w3a vu cv vw cv cG co vv cv cG co vu cv
      vw cv vv cv cG co cG co wceq wi vx vu vx cv vu cv wceq vx cv cX wcel vw
      cv cX wcel vv cv cX wcel w3a vu cv cX wcel vw cv cX wcel vv cv cX wcel
      w3a vx cv vw cv cG co vv cv cG co vx cv vw cv vv cv cG co cG co wceq vu
      cv vw cv cG co vv cv cG co vu cv vw cv vv cv cG co cG co wceq vx cv vu cv
      wceq vx cv cX wcel vu cv cX wcel vw cv cX wcel vv cv cX wcel vx cv vu cv
      cX eleq1 3anbi1d vx cv vu cv wceq vx cv vw cv cG co vv cv cG co vu cv vw
      cv cG co vv cv cG co vx cv vw cv vv cv cG co cG co vu cv vw cv vv cv cG
      co cG co vx cv vu cv wceq vx cv vw cv cG co vu cv vw cv cG co vv cv cG vx
      cv vu cv vw cv cG opreq1 opreq1d vx cv vu cv vw cv vv cv cG co cG opreq1
      eqeq12d imbi12d vx cv cX wcel vy cv cX wcel vv cv cX wcel w3a vx cv vy cv
      cG co vv cv cG co vx cv vy cv vv cv cG co cG co wceq wi vx cv cX wcel vw
      cv cX wcel vv cv cX wcel w3a vx cv vw cv cG co vv cv cG co vx cv vw cv vv
      cv cG co cG co wceq wi vy vw vy cv vw cv wceq vx cv cX wcel vy cv cX wcel
      vv cv cX wcel w3a vx cv cX wcel vw cv cX wcel vv cv cX wcel w3a vx cv vy
      cv cG co vv cv cG co vx cv vy cv vv cv cG co cG co wceq vx cv vw cv cG co
      vv cv cG co vx cv vw cv vv cv cG co cG co wceq vy cv vw cv wceq vy cv cX
      wcel vw cv cX wcel vx cv cX wcel vv cv cX wcel vy cv vw cv cX eleq1
      3anbi2d vy cv vw cv wceq vx cv vy cv cG co vv cv cG co vx cv vw cv cG co
      vv cv cG co vx cv vy cv vv cv cG co cG co vx cv vw cv vv cv cG co cG co
      vy cv vw cv wceq vx cv vy cv cG co vx cv vw cv cG co vv cv cG vy cv vw cv
      vx cv cG opreq2 opreq1d vy cv vw cv wceq vy cv vv cv cG co vw cv vv cv cG
      co vx cv cG vy cv vw cv vv cv cG opreq1 opreq2d eqeq12d imbi12d vx cv cX
      wcel vy cv cX wcel vz cv cX wcel w3a vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq wi vx cv cX wcel vy cv cX wcel vv cv cX wcel
      w3a vx cv vy cv cG co vv cv cG co vx cv vy cv vv cv cG co cG co wceq wi
      vz vv vz cv vv cv wceq vx cv cX wcel vy cv cX wcel vz cv cX wcel w3a vx
      cv cX wcel vy cv cX wcel vv cv cX wcel w3a vx cv vy cv cG co vz cv cG co
      vx cv vy cv vz cv cG co cG co wceq vx cv vy cv cG co vv cv cG co vx cv vy
      cv vv cv cG co cG co wceq vz cv vv cv wceq vz cv cX wcel vv cv cX wcel vx
      cv cX wcel vy cv cX wcel vz cv vv cv cX eleq1 3anbi3d vz cv vv cv wceq vx
      cv vy cv cG co vz cv cG co vx cv vy cv cG co vv cv cG co vx cv vy cv vz
      cv cG co cG co vx cv vy cv vv cv cG co cG co vz cv vv cv vx cv vy cv cG
      co cG opreq2 vz cv vv cv wceq vy cv vz cv cG co vy cv vv cv cG co vx cv
      cG vz cv vv cv vy cv cG opreq2 opreq2d eqeq12d imbi12d isgrp2i.4 chvarv
      chvarv chvarv 3com12 3expa adantlr vu cv vw cv cG co vw cv wceq vu cv vw
      cv cG co vv cv cG co vw cv vv cv cG co wceq vw cv cX wcel vu cv cX wcel
      wa vv cv cX wcel vu cv vw cv cG co vw cv vv cv cG opreq1 ad2antlr eqtr3d
      adantr vw cv vv cv cG co vx cv wceq vu cv vw cv vv cv cG co cG co vu cv
      vx cv cG co wceq vw cv cX wcel vu cv cX wcel wa vu cv vw cv cG co vw cv
      wceq wa vv cv cX wcel wa vw cv vv cv cG co vx cv vu cv cG opreq2 adantl
      vw cv cX wcel vu cv cX wcel wa vu cv vw cv cG co vw cv wceq wa vv cv cX
      wcel wa vw cv vv cv cG co vx cv wceq pm3.27 3eqtr3d exp31 r19.23adv
      adantlr mpd vw cv cX wcel vu cv cX wcel wa vx cv cX wcel wa vy cv vx cv
      cG co vu cv wceq vy cX wrex vu cv vw cv cG co vw cv wceq vu cv cX wcel vx
      cv cX wcel vy cv vx cv cG co vu cv wceq vy cX wrex vw cv cX wcel vx cv cX
      wcel vu cv cX wcel vy cv vx cv cG co vu cv wceq vy cX wrex vx cv cX wcel
      vu cv cX wcel wa vz cv vx cv cG co vu cv wceq vz cX wrex vy cv vx cv cG
      co vu cv wceq vy cX wrex vx cv cX wcel vy cv cX wcel wa vz cv vx cv cG co
      vy cv wceq vz cX wrex wi vx cv cX wcel vu cv cX wcel wa vz cv vx cv cG co
      vu cv wceq vz cX wrex wi vy vu vy cv vu cv wceq vx cv cX wcel vy cv cX
      wcel wa vx cv cX wcel vu cv cX wcel wa vz cv vx cv cG co vy cv wceq vz cX
      wrex vz cv vx cv cG co vu cv wceq vz cX wrex vy cv vu cv wceq vy cv cX
      wcel vu cv cX wcel vx cv cX wcel vy cv vu cv cX eleq1 anbi2d vy cv vu cv
      wceq vz cv vx cv cG co vy cv wceq vz cv vx cv cG co vu cv wceq vz cX vy
      cv vu cv vz cv vx cv cG co eqeq2 rexbidv imbi12d isgrp2i.5 chvarv vz cv
      vx cv cG co vu cv wceq vy cv vx cv cG co vu cv wceq vz vy cX vz cv vy cv
      wceq vz cv vx cv cG co vy cv vx cv cG co vu cv vz cv vy cv vx cv cG
      opreq1 eqeq1d cbvrexv sylib ancoms adantll adantr jca exp31 com23
      r19.21adv r19.22dva mpd 19.23aiv ax-mp 3pm3.2i cG cvv wcel cG cgr wcel cX
      cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG
      co wceq vz cX wral vy cX wral vx cX wral vu cv vx cv cG co vx cv wceq vy
      cv vx cv cG co vu cv wceq vy cX wrex wa vx cX wral vu cX wrex w3a wb cX
      cX cxp cX cG wf cX cX cxp cvv wcel cG cvv wcel isgrp2i.3 cX cX isgrp2i.1
      isgrp2i.1 xpex cX cX cxp cX cvv cG fex mp2an vx vy vz vu cvv cG cX cG crn
      cX cX cX cxp cX cG wfo cG crn cX wceq cX cX cxp cX cG wfo cX cX cxp cX cG
      wf vy cv vx cv vz cv cG co wceq vz cX wrex vx cX wrex vy cX wral vx vz vy
      cX cX cX cG fooprv isgrp2i.3 vy cv vx cv vz cv cG co wceq vz cX wrex vx
      cX wrex vy cX cX c0 wne vy cv vx cv vz cv cG co wceq vz cX wrex vx cX
      wral vy cv vx cv vz cv cG co wceq vz cX wrex vx cX wrex vy cv cX wcel vy
      cv vx cv vz cv cG co wceq vz cX wrex vx cX r19.2z isgrp2i.2 vy cv cX wcel
      vy cv vx cv vz cv cG co wceq vz cX wrex vx cX vy cv cX wcel vx cv cX wcel
      wa vx cv vz cv cG co vy cv wceq vz cX wrex vy cv vx cv vz cv cG co wceq
      vz cX wrex vx cv cX wcel vy cv cX wcel vx cv vz cv cG co vy cv wceq vz cX
      wrex isgrp2i.6 ancoms vx cv vz cv cG co vy cv wceq vy cv vx cv vz cv cG
      co wceq vz cX vx cv vz cv cG co vy cv eqcom rexbii sylib r19.21aiva
      sylancr rgen mpbir2an cX cX cxp cX cG forn ax-mp eqcomi isgrp ax-mp mpbir
      $.
      $( [5-Mar-2007] $) $( [5-Dec-2006] $)
  $}

  ${
    $d x y z G $.  $d x y N $.  $d x y z X $.
    grpasscan1.1 $e |- X = ran G $.
    grpasscan1.2 $e |- N = ( inv ` G ) $.
    $( An associative cancellation law for groups.  (Contributed by Paul
       Chapman, 25-Feb-2008.) $)
    grpasscan1 $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                          ( A G ( ( N ` A ) G B ) ) = B ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cA cN cfv cG co cB cG co cG cgi
      cfv cB cG co cA cA cN cfv cB cG co cG co cB cG cgr wcel cA cX wcel cB cX
      wcel w3a cA cA cN cfv cG co cG cgi cfv cB cG cG cgr wcel cA cX wcel cA cA
      cN cfv cG co cG cgi cfv wceq cB cX wcel cA cG cgi cfv cG cN cX
      grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grprinv 3adant3 opreq1d cG cgr
      wcel cA cX wcel cB cX wcel cA cA cN cfv cG co cB cG co cA cA cN cfv cB cG
      co cG co wceq cG cgr wcel cA cX wcel wa cA cN cfv cX wcel cB cX wcel cA
      cA cN cfv cG co cB cG co cA cA cN cfv cB cG co cG co wceq wi cA cG cN cX
      grpasscan1.1 grpasscan1.2 grpinvcl cG cgr wcel cA cX wcel cA cN cfv cX
      wcel cB cX wcel cA cA cN cfv cG co cB cG co cA cA cN cfv cB cG co cG co
      wceq wi wi cG cgr wcel cA cX wcel cA cN cfv cX wcel cB cX wcel cA cA cN
      cfv cG co cB cG co cA cA cN cfv cB cG co cG co wceq cA cA cN cfv cB cG cX
      grpasscan1.1 grpass 3exp2 imp mpd 3impia cG cgr wcel cB cX wcel cG cgi
      cfv cB cG co cB wceq cA cX wcel cB cG cgi cfv cG cX grpasscan1.1 cG cgi
      cfv eqid grplid 3adant2 3eqtr3d $.
      $( [21-Apr-2008] $) $( [25-Feb-2008] $)

    $( An associative cancellation law for groups.  (Contributed by Paul
       Chapman, 17-Apr-2009.) $)
    grpasscan2 $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                       ( ( A G ( N ` B ) ) G B ) = A ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cN cfv cG co cB cG co cA cB
      cN cfv cB cG co cG co cA cG cgi cfv cG co cA cG cgr wcel cA cX wcel cB cN
      cfv cX wcel cB cX wcel w3a cA cB cN cfv cG co cB cG co cA cB cN cfv cB cG
      co cG co wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cN cfv cB cG cX
      grpasscan1.1 grpass cG cgr wcel cA cX wcel cB cX wcel 3simp1 cG cgr wcel
      cA cX wcel cB cX wcel w3a cA cX wcel cB cN cfv cX wcel cB cX wcel cG cgr
      wcel cA cX wcel cB cX wcel 3simp2 cG cgr wcel cB cX wcel cB cN cfv cX
      wcel cG cgr wcel cA cX wcel cB cX wcel w3a cB cG cN cX grpasscan1.1
      grpasscan1.2 grpinvcl cG cgr wcel cA cX wcel cB cX wcel 3simp1 cG cgr
      wcel cA cX wcel cB cX wcel 3simp3 sylanc cG cgr wcel cA cX wcel cB cX
      wcel 3simp3 3jca sylanc cG cgr wcel cA cX wcel cB cX wcel w3a cB cN cfv
      cB cG co cG cgi cfv cA cG cG cgr wcel cB cX wcel cB cN cfv cB cG co cG
      cgi cfv wceq cG cgr wcel cA cX wcel cB cX wcel w3a cB cG cgi cfv cG cN cX
      grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grplinv cG cgr wcel cA cX wcel
      cB cX wcel 3simp1 cG cgr wcel cA cX wcel cB cX wcel 3simp3 sylanc opreq2d
      cG cgr wcel cA cX wcel cA cG cgi cfv cG co cA wceq cG cgr wcel cA cX wcel
      cB cX wcel w3a cA cG cgi cfv cG cX grpasscan1.1 cG cgi cfv eqid grprid cG
      cgr wcel cA cX wcel cB cX wcel 3simp1 cG cgr wcel cA cX wcel cB cX wcel
      3simp2 sylanc 3eqtrd $.
      $( [19-Apr-2009] $) $( [17-Apr-2009] $)

    $( Double inverse law for groups.  Lemma 2.2.1(c) of [Herstein] p. 55. $)
    grp2inv $p |- ( ( G e. Grp /\ A e. X ) -> ( N ` ( N ` A ) ) = A ) $=
      cG cgr wcel cA cX wcel wa cA cN cfv cA cN cfv cN cfv cG co cA cN cfv cA
      cG co wceq cA cN cfv cN cfv cA wceq cG cgr wcel cA cX wcel wa cA cN cfv
      cA cN cfv cN cfv cG co cG cgi cfv cA cN cfv cA cG co cG cgr wcel cA cX
      wcel cA cN cfv cX wcel cA cN cfv cA cN cfv cN cfv cG co cG cgi cfv wceq
      cA cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl cA cN cfv cG cgi cfv cG cN
      cX grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grprinv syldan cA cG cgi cfv
      cG cN cX grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grplinv eqtr4d cG cgr
      wcel cA cX wcel cA cN cfv cN cfv cX wcel cA cX wcel cA cN cfv cX wcel w3a
      cA cN cfv cA cN cfv cN cfv cG co cA cN cfv cA cG co wceq cA cN cfv cN cfv
      cA wceq wb cG cgr wcel cA cX wcel wa cA cN cfv cN cfv cX wcel cA cX wcel
      cA cN cfv cX wcel cG cgr wcel cA cX wcel cA cN cfv cX wcel cA cN cfv cN
      cfv cX wcel cA cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl cA cN cfv cG
      cN cX grpasscan1.1 grpasscan1.2 grpinvcl syldan cG cgr wcel cA cX wcel
      pm3.27 cA cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl 3jca cA cN cfv cN
      cfv cA cA cN cfv cG cX grpasscan1.1 grplcan syldan mpbid $.
      $( [24-Nov-2006] $) $( [27-Oct-2006] $)

    $( Mapping of the inverse function of a group. $)
    grpinvf $p |- ( G e. Grp -> N : X -1-1-onto-> X ) $=
      cG cgr wcel cN cX wfn cN crn cX wceq vx cv cN cfv vy cv cN cfv wceq vx cv
      vy cv wceq wi vy cX wral vx cX wral w3a cX cX cN wf1o cG cgr wcel cN cX
      wfn cN crn cX wceq vx cv cN cfv vy cv cN cfv wceq vx cv vy cv wceq wi vy
      cX wral vx cX wral cG cgr wcel cN cX wfn vx cv cX wcel vy cv vz cv vx cv
      cG co cG cgi cfv wceq vz cX crab cuni wceq wa vx vy copab cX wfn cG cgr
      wcel vz cv vx cv cG co cG cgi cfv wceq vz cX crab cuni cvv wcel vx cX
      wral vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni wceq wa vx vy copab cX wfn cG cgr wcel vz cv vx cv cG co cG cgi cfv
      wceq vz cX crab cuni cvv wcel vx cX cG cgr wcel vz cv vx cv cG co cG cgi
      cfv wceq vz cX crab cuni cvv wcel vx cv cX wcel cG cgr wcel vz cv vx cv
      cG co cG cgi cfv wceq vz cX crab cvv wcel vz cv vx cv cG co cG cgi cfv
      wceq vz cX crab cuni cvv wcel cG cgr wcel cX cvv wcel vz cv vx cv cG co
      cG cgi cfv wceq vz cX crab cvv wcel cG cgr wcel cG crn cvv cX cG cgr
      rnexg grpasscan1.1 syl5eqel vz cv vx cv cG co cG cgi cfv wceq vz cX cvv
      rabexg syl vz cv vx cv cG co cG cgi cfv wceq vz cX crab cvv uniexg syl
      adantr r19.21aiva vx vy cX vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni wceq wa vx vy copab vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv
      wceq vz cX crab cuni wceq wa vx vy copab eqid fnopab2g sylib cG cgr wcel
      cN vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab cuni
      wceq wa vx vy copab wceq cN cX wfn vx cv cX wcel vy cv vz cv vx cv cG co
      cG cgi cfv wceq vz cX crab cuni wceq wa vx vy copab cX wfn wb vx vz cG
      cgi cfv vy cG cN cX grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grpinvfval
      cX cN vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni wceq wa vx vy copab fneq1 syl mpbird cG cgr wcel cN crn vy cv vx cv
      cN cfv wceq vx cX wrex vy cab cX cG cgr wcel cN cX wfn cN crn vy cv vx cv
      cN cfv wceq vx cX wrex vy cab wceq cG cgr wcel cN cX wfn vx cv cX wcel vy
      cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab cuni wceq wa vx vy copab
      cX wfn cG cgr wcel vz cv vx cv cG co cG cgi cfv wceq vz cX crab cuni cvv
      wcel vx cX wral vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz
      cX crab cuni wceq wa vx vy copab cX wfn cG cgr wcel vz cv vx cv cG co cG
      cgi cfv wceq vz cX crab cuni cvv wcel vx cX cG cgr wcel vz cv vx cv cG co
      cG cgi cfv wceq vz cX crab cuni cvv wcel vx cv cX wcel cG cgr wcel vz cv
      vx cv cG co cG cgi cfv wceq vz cX crab cvv wcel vz cv vx cv cG co cG cgi
      cfv wceq vz cX crab cuni cvv wcel cG cgr wcel cX cvv wcel vz cv vx cv cG
      co cG cgi cfv wceq vz cX crab cvv wcel cG cgr wcel cG crn cvv cX cG cgr
      rnexg grpasscan1.1 syl5eqel vz cv vx cv cG co cG cgi cfv wceq vz cX cvv
      rabexg syl vz cv vx cv cG co cG cgi cfv wceq vz cX crab cvv uniexg syl
      adantr r19.21aiva vx vy cX vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni wceq wa vx vy copab vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv
      wceq vz cX crab cuni wceq wa vx vy copab eqid fnopab2g sylib cG cgr wcel
      cN vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab cuni
      wceq wa vx vy copab wceq cN cX wfn vx cv cX wcel vy cv vz cv vx cv cG co
      cG cgi cfv wceq vz cX crab cuni wceq wa vx vy copab cX wfn wb vx vz cG
      cgi cfv vy cG cN cX grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grpinvfval
      cX cN vx cv cX wcel vy cv vz cv vx cv cG co cG cgi cfv wceq vz cX crab
      cuni wceq wa vx vy copab fneq1 syl mpbird vx vy cX cN fnrnfv syl cG cgr
      wcel vy cv vx cv cN cfv wceq vx cX wrex vy cX cG cgr wcel vy cv cX wcel
      vy cv vx cv cN cfv wceq vx cX wrex cG cgr wcel vy cv cX wcel vy cv vx cv
      cN cfv wceq vx cX wrex vy cv cN cfv cX wcel vy cv vy cv cN cfv cN cfv
      wceq vy cv vx cv cN cfv wceq vx cX wrex cG cgr wcel vy cv cX wcel wa vy
      cv vx cv cN cfv wceq vy cv vy cv cN cfv cN cfv wceq vx vy cv cN cfv cX vx
      cv vy cv cN cfv wceq vx cv cN cfv vy cv cN cfv cN cfv vy cv vx cv vy cv
      cN cfv cN fveq2 eqeq2d rcla4ev vy cv cG cN cX grpasscan1.1 grpasscan1.2
      grpinvcl cG cgr wcel vy cv cX wcel wa vy cv cN cfv cN cfv vy cv vy cv cG
      cN cX grpasscan1.1 grpasscan1.2 grp2inv eqcomd sylanc ex cG cgr wcel vy
      cv vx cv cN cfv wceq vy cv cX wcel vx cX cG cgr wcel vx cv cX wcel vy cv
      vx cv cN cfv wceq vy cv cX wcel cG cgr wcel vx cv cX wcel wa vy cv vx cv
      cN cfv wceq wa vy cv vx cv cN cfv cX cG cgr wcel vx cv cX wcel wa vy cv
      vx cv cN cfv wceq pm3.27 cG cgr wcel vx cv cX wcel wa vx cv cN cfv cX
      wcel vy cv vx cv cN cfv wceq vx cv cG cN cX grpasscan1.1 grpasscan1.2
      grpinvcl adantr eqeltrd exp31 r19.23adv impbid abbi2dv eqtr4d cG cgr wcel
      vx cv cN cfv vy cv cN cfv wceq vx cv vy cv wceq wi vx vy cX cX cG cgr
      wcel vx cv cX wcel vy cv cX wcel wa vx cv cN cfv vy cv cN cfv wceq vx cv
      vy cv wceq wi cG cgr wcel vx cv cX wcel vy cv cX wcel wa wa vx cv cN cfv
      cN cfv vy cv cN cfv cN cfv wceq vx cv vy cv wceq vx cv cN cfv vy cv cN
      cfv wceq cG cgr wcel vx cv cX wcel vy cv cX wcel vx cv cN cfv cN cfv vy
      cv cN cfv cN cfv wceq vx cv vy cv wceq wb cG cgr wcel vx cv cX wcel wa cG
      cgr wcel vy cv cX wcel wa vx cv cN cfv cN cfv vx cv vy cv cN cfv cN cfv
      vy cv vx cv cG cN cX grpasscan1.1 grpasscan1.2 grp2inv vy cv cG cN cX
      grpasscan1.1 grpasscan1.2 grp2inv eqeqan12d anandis vx cv cN cfv vy cv cN
      cfv cN fveq2 syl5bi ex r19.21aivv 3jca vx vy cX cX cN dff1o6 sylibr $.
      $( [29-Mar-2008] $) $( [29-Mar-2008] $)

    $( The inverse of the group operation reverses the arguments.  Lemma
       2.2.1(d) of [Herstein] p. 55. $)
    grpinvop $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                   ( N ` ( A G B ) ) = ( ( N ` B ) G ( N ` A ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv cB cN cfv cA cN
      cfv cG co wceq cA cB cG co cB cN cfv cA cN cfv cG co cG co cG cgi cfv
      wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cG co cB cN cfv cA cN
      cfv cG co cG co cA cB cB cN cfv cA cN cfv cG co cG co cG co cA cA cN cfv
      cG co cG cgi cfv cG cgr wcel cA cX wcel cB cX wcel cB cN cfv cA cN cfv cG
      co cX wcel w3a cA cB cG co cB cN cfv cA cN cfv cG co cG co cA cB cB cN
      cfv cA cN cfv cG co cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel
      w3a cA cB cB cN cfv cA cN cfv cG co cG cX grpasscan1.1 grpass cG cgr wcel
      cA cX wcel cB cX wcel 3simp1 cG cgr wcel cA cX wcel cB cX wcel w3a cA cX
      wcel cB cX wcel cB cN cfv cA cN cfv cG co cX wcel cG cgr wcel cA cX wcel
      cB cX wcel 3simp2 cG cgr wcel cA cX wcel cB cX wcel 3simp3 cG cgr wcel cB
      cN cfv cX wcel cA cN cfv cX wcel cB cN cfv cA cN cfv cG co cX wcel cG cgr
      wcel cA cX wcel cB cX wcel w3a cB cN cfv cA cN cfv cG cX grpasscan1.1
      grpcl cG cgr wcel cA cX wcel cB cX wcel 3simp1 cG cgr wcel cB cX wcel cB
      cN cfv cX wcel cA cX wcel cB cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl
      3adant2 cG cgr wcel cA cX wcel cA cN cfv cX wcel cB cX wcel cA cG cN cX
      grpasscan1.1 grpasscan1.2 grpinvcl 3adant3 syl3anc 3jca sylanc cG cgr
      wcel cA cX wcel cB cX wcel w3a cB cB cN cfv cA cN cfv cG co cG co cA cN
      cfv cA cG cG cgr wcel cA cX wcel cB cX wcel w3a cB cB cN cfv cG co cA cN
      cfv cG co cG cgi cfv cA cN cfv cG co cB cB cN cfv cA cN cfv cG co cG co
      cA cN cfv cG cgr wcel cA cX wcel cB cX wcel w3a cB cB cN cfv cG co cG cgi
      cfv cA cN cfv cG cG cgr wcel cB cX wcel cB cB cN cfv cG co cG cgi cfv
      wceq cA cX wcel cB cG cgi cfv cG cN cX grpasscan1.1 cG cgi cfv eqid
      grpasscan1.2 grprinv 3adant2 opreq1d cG cgr wcel cB cX wcel cB cN cfv cX
      wcel cA cN cfv cX wcel w3a cB cB cN cfv cG co cA cN cfv cG co cB cB cN
      cfv cA cN cfv cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel w3a cB
      cB cN cfv cA cN cfv cG cX grpasscan1.1 grpass cG cgr wcel cA cX wcel cB
      cX wcel 3simp1 cG cgr wcel cA cX wcel cB cX wcel w3a cB cX wcel cB cN cfv
      cX wcel cA cN cfv cX wcel cG cgr wcel cA cX wcel cB cX wcel 3simp3 cG cgr
      wcel cB cX wcel cB cN cfv cX wcel cA cX wcel cB cG cN cX grpasscan1.1
      grpasscan1.2 grpinvcl 3adant2 cG cgr wcel cA cX wcel cA cN cfv cX wcel cB
      cX wcel cA cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl 3adant3 3jca
      sylanc cG cgr wcel cA cX wcel cG cgi cfv cA cN cfv cG co cA cN cfv wceq
      cB cX wcel cG cgr wcel cA cX wcel cA cN cfv cX wcel cG cgi cfv cA cN cfv
      cG co cA cN cfv wceq cA cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl cA cN
      cfv cG cgi cfv cG cX grpasscan1.1 cG cgi cfv eqid grplid syldan 3adant3
      3eqtr3d opreq2d cG cgr wcel cA cX wcel cA cA cN cfv cG co cG cgi cfv wceq
      cB cX wcel cA cG cgi cfv cG cN cX grpasscan1.1 cG cgi cfv eqid
      grpasscan1.2 grprinv 3adant3 3eqtrd cG cgr wcel cA cB cG co cX wcel cB cN
      cfv cA cN cfv cG co cX wcel cA cB cG co cN cfv cB cN cfv cA cN cfv cG co
      wceq cA cB cG co cB cN cfv cA cN cfv cG co cG co cG cgi cfv wceq wb cG
      cgr wcel cA cX wcel cB cX wcel w3a cA cB cG co cB cN cfv cA cN cfv cG co
      cG cgi cfv cG cN cX grpasscan1.1 cG cgi cfv eqid grpasscan1.2 grpinvid1
      cG cgr wcel cA cX wcel cB cX wcel 3simp1 cA cB cG cX grpasscan1.1 grpcl
      cG cgr wcel cB cN cfv cX wcel cA cN cfv cX wcel cB cN cfv cA cN cfv cG co
      cX wcel cG cgr wcel cA cX wcel cB cX wcel w3a cB cN cfv cA cN cfv cG cX
      grpasscan1.1 grpcl cG cgr wcel cA cX wcel cB cX wcel 3simp1 cG cgr wcel
      cB cX wcel cB cN cfv cX wcel cA cX wcel cB cG cN cX grpasscan1.1
      grpasscan1.2 grpinvcl 3adant2 cG cgr wcel cA cX wcel cA cN cfv cX wcel cB
      cX wcel cA cG cN cX grpasscan1.1 grpasscan1.2 grpinvcl 3adant3 syl3anc
      syl3anc mpbird $.
      $( [24-Nov-2006] $) $( [27-Oct-2006] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d f g x y z G $.  $d f g x y z N $.
    $d f g x y z X $.
    grpdiv.1 $e |- X = ran G $.
    grpdiv.2 $e |- N = ( inv ` G ) $.
    grpdiv.3 $e |- D = ( /g ` G ) $.
    $( Group division (or subtraction) operation. $)
    grpdivfval $p |- ( G e. Grp -> D = { <. <. x , y >. , z >. |
          ( ( x e. X /\ y e. X ) /\ z = ( x G ( N ` y ) ) ) } ) $=
      cG cgr wcel cG cgs cfv vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv
      cN cfv cG co wceq wa vx vy vz copab2 cD cG cgr wcel vx cv cX wcel vy cv
      cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz copab2 cvv
      wcel cG cgs cfv vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv
      cG co wceq wa vx vy vz copab2 wceq cX cvv wcel cX cvv wcel vx cv cX wcel
      vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz copab2
      cvv wcel cG cgr wcel vx vy vz cX cX vx cv vy cv cN cfv cG co cvv cvv vx
      cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy
      vz copab2 vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co
      wceq wa vx vy vz copab2 eqid oprabex2g cG cgr wcel cG crn cvv cX cG cgr
      rnexg grpdiv.1 syl5eqel cG cgr wcel cG crn cvv cX cG cgr rnexg grpdiv.1
      syl5eqel sylanc vg vf cG vx cv vg cv crn wcel vy cv vg cv crn wcel wa vz
      cv vx cv vy cv vg cv cgn cfv cfv vg cv co wceq wa vx vy vz copab2 vx cv
      cX wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz
      copab2 cgr cvv cgs vg cv cG wceq vx cv vg cv crn wcel vy cv vg cv crn
      wcel wa vz cv vx cv vy cv vg cv cgn cfv cfv vg cv co wceq wa vx cv cX
      wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz vg
      cv cG wceq vx cv vg cv crn wcel vy cv vg cv crn wcel wa vx cv cX wcel vy
      cv cX wcel wa vz cv vx cv vy cv vg cv cgn cfv cfv vg cv co wceq vz cv vx
      cv vy cv cN cfv cG co wceq vg cv cG wceq vx cv vg cv crn wcel vx cv cX
      wcel vy cv vg cv crn wcel vy cv cX wcel vg cv cG wceq vg cv crn cX vx cv
      vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq grpdiv.1 syl6eqr eleq2d
      vg cv cG wceq vg cv crn cX vy cv vg cv cG wceq vg cv crn cG crn cX vg cv
      cG rneq grpdiv.1 syl6eqr eleq2d anbi12d vg cv cG wceq vx cv vy cv vg cv
      cgn cfv cfv vg cv co vx cv vy cv cN cfv cG co vz cv vg cv cG wceq vx cv
      vy cv vg cv cgn cfv cfv vg cv co vx cv vy cv vg cv cgn cfv cfv cG co vx
      cv vy cv cN cfv cG co vx cv vy cv vg cv cgn cfv cfv vg cv cG opreq vg cv
      cG wceq vy cv vg cv cgn cfv cfv vy cv cN cfv vx cv cG vg cv cG wceq vy cv
      vg cv cgn cfv cN vg cv cG wceq vg cv cgn cfv cG cgn cfv cN vg cv cG cgn
      fveq2 grpdiv.2 syl6eqr fveq1d opreq2d eqtrd eqeq2d anbi12d oprabbidv vx
      vy vz vf vg df-gdiv fvopab4g mpdan grpdiv.3 syl5eq $.
      $( [17-Feb-2008] $) $( [15-Feb-2008] $)

    $( Group division (or subtraction) operation value. $)
    grpdivval $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                   ( A D B ) = ( A G ( N ` B ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cD co cA cB vx cv cX wcel vy
      cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz copab2 co
      cA cB cN cfv cG co cG cgr wcel cA cX wcel cA cB cD co cA cB vx cv cX wcel
      vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz copab2
      co wceq cB cX wcel cG cgr wcel cD vx cv cX wcel vy cv cX wcel wa vz cv vx
      cv vy cv cN cfv cG co wceq wa vx vy vz copab2 cA cB vx vy vz cD cG cN cX
      grpdiv.1 grpdiv.2 grpdiv.3 grpdivfval opreqd 3ad2ant1 cA cX wcel cB cX
      wcel cA cB vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co
      wceq wa vx vy vz copab2 co cA cB cN cfv cG co wceq cG cgr wcel vx vy vz
      cA cB cX cX vx cv vy cv cN cfv cG co cA cB cN cfv cG co vx cv cX wcel vy
      cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy vz copab2 cA
      vy cv cN cfv cG co cA cB cN cfv cG oprex vx cv cA vy cv cN cfv cG opreq1
      vy cv cB wceq vy cv cN cfv cB cN cfv cA cG vy cv cB cN fveq2 opreq2d vx
      cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cN cfv cG co wceq wa vx vy
      vz copab2 eqid oprabval2 3adant1 eqtrd $.
      $( [17-Feb-2008] $) $( [15-Feb-2008] $)

    $( Group division by an inverse. $)
    grpdivinv $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                   ( A D ( N ` B ) ) = ( A G B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cN cfv cD co cA cB cN cfv cN
      cfv cG co cA cB cG co cG cgr wcel cA cX wcel cB cN cfv cX wcel cA cB cN
      cfv cD co cA cB cN cfv cN cfv cG co wceq cB cX wcel cA cB cN cfv cD cG cN
      cX grpdiv.1 grpdiv.2 grpdiv.3 grpdivval cG cgr wcel cB cX wcel cB cN cfv
      cX wcel cA cX wcel cB cG cN cX grpdiv.1 grpdiv.2 grpinvcl 3adant2
      syld3an3 cG cgr wcel cA cX wcel cB cX wcel w3a cB cN cfv cN cfv cB cA cG
      cG cgr wcel cB cX wcel cB cN cfv cN cfv cB wceq cA cX wcel cB cG cN cX
      grpdiv.1 grpdiv.2 grp2inv 3adant2 opreq2d eqtrd $.
      $( [26-Feb-2008] $) $( [15-Feb-2008] $)

    $( Inverse of a group division. $)
    grpinvdiv $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                   ( N ` ( A D B ) ) = ( B D A ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cD co cN cfv cA cB cN cfv cG
      co cN cfv cB cN cfv cN cfv cA cN cfv cG co cB cA cD co cG cgr wcel cA cX
      wcel cB cX wcel w3a cA cB cD co cA cB cN cfv cG co cN cA cB cD cG cN cX
      grpdiv.1 grpdiv.2 grpdiv.3 grpdivval fveq2d cG cgr wcel cA cX wcel cB cN
      cfv cX wcel cA cB cN cfv cG co cN cfv cB cN cfv cN cfv cA cN cfv cG co
      wceq cB cX wcel cA cB cN cfv cG cN cX grpdiv.1 grpdiv.2 grpinvop cG cgr
      wcel cB cX wcel cB cN cfv cX wcel cA cX wcel cB cG cN cX grpdiv.1
      grpdiv.2 grpinvcl 3adant2 syld3an3 cG cgr wcel cA cX wcel cB cX wcel w3a
      cB cN cfv cN cfv cA cN cfv cG co cB cA cN cfv cG co cB cA cD co cG cgr
      wcel cA cX wcel cB cX wcel w3a cB cN cfv cN cfv cB cA cN cfv cG cG cgr
      wcel cB cX wcel cB cN cfv cN cfv cB wceq cA cX wcel cB cG cN cX grpdiv.1
      grpdiv.2 grp2inv 3adant2 opreq1d cG cgr wcel cB cX wcel cA cX wcel cB cA
      cD co cB cA cN cfv cG co wceq cB cA cD cG cN cX grpdiv.1 grpdiv.2
      grpdiv.3 grpdivval 3com23 eqtr4d 3eqtrd $.
      $( [26-Feb-2008] $) $( [24-Feb-2008] $)
  $}

  ${
    $d x y z G $.  $d x y z X $.
    grpdivf.1 $e |- X = ran G $.
    grpdivf.3 $e |- D = ( /g ` G ) $.
    $( Mapping for group division. $)
    grpdivf $p |- ( G e. Grp -> D : ( X X. X ) --> X ) $=
      cG cgr wcel cX cX cxp cX cD wf cX cX cxp cX vx cv cX wcel vy cv cX wcel
      wa vz cv vx cv vy cv cG cgn cfv cfv cG co wceq wa vx vy vz copab2 wf cG
      cgr wcel vx cv vy cv cG cgn cfv cfv cG co cX wcel vy cX wral vx cX wral
      cX cX cxp cX vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cG cgn cfv
      cfv cG co wceq wa vx vy vz copab2 wf cG cgr wcel vx cv vy cv cG cgn cfv
      cfv cG co cX wcel vx vy cX cX cG cgr wcel vx cv cX wcel vy cv cX wcel vx
      cv vy cv cG cgn cfv cfv cG co cX wcel cG cgr wcel vx cv cX wcel vy cv cG
      cgn cfv cfv cX wcel vx cv vy cv cG cgn cfv cfv cG co cX wcel vy cv cX
      wcel vx cv vy cv cG cgn cfv cfv cG cX grpdivf.1 grpcl cG cgr wcel vy cv
      cX wcel vy cv cG cgn cfv cfv cX wcel vx cv cX wcel vy cv cG cG cgn cfv cX
      grpdivf.1 cG cgn cfv eqid grpinvcl 3adant2 syld3an3 3expib r19.21aivv vx
      vy vz cX cX vx cv vy cv cG cgn cfv cfv cG co cX vx cv cX wcel vy cv cX
      wcel wa vz cv vx cv vy cv cG cgn cfv cfv cG co wceq wa vx vy vz copab2 vx
      cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cG cgn cfv cfv cG co wceq
      wa vx vy vz copab2 eqid foprab2 sylib cG cgr wcel cX cX cxp cX cD vx cv
      cX wcel vy cv cX wcel wa vz cv vx cv vy cv cG cgn cfv cfv cG co wceq wa
      vx vy vz copab2 vx vy vz cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid
      grpdivf.3 grpdivfval feq1d mpbird $.
      $( [10-Apr-2008] $) $( [10-Apr-2008] $)

    $( Closure of group division (or subtraction) operation. $)
    grpdivcl $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) -> ( A D B ) e. X ) $=
      cX cX cxp cX cD wf cA cX wcel cB cX wcel cA cB cD co cX wcel cG cgr wcel
      cA cB cX cX cX cD foprrn cD cG cX grpdivf.1 grpdivf.3 grpdivf syl3an1 $.
      $( [24-Feb-2008] $) $( [15-Feb-2008] $)

    $( Double group division. $)
    grpdivdiv $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( A D ( B D C ) ) = ( A G ( C D B ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cD co cD co
      cA cB cC cD co cG cgn cfv cfv cG co cA cC cB cD co cG co cG cgr wcel cA
      cX wcel cB cC cD co cX wcel cA cB cC cD co cD co cA cB cC cD co cG cgn
      cfv cfv cG co wceq cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA
      cB cC cD co cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpdivf.3
      grpdivval cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a pm3.26 cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel 3simpr1 cG cgr wcel cB cX wcel cC
      cX wcel cB cC cD co cX wcel cA cX wcel cB cC cD cG cX grpdivf.1 grpdivf.3
      grpdivcl 3adant3r1 syl3anc cG cgr wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa cB cC cD co cG cgn cfv cfv cC cB cD co cA cG cG cgr wcel cB cX
      wcel cC cX wcel cB cC cD co cG cgn cfv cfv cC cB cD co wceq cA cX wcel cB
      cC cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpdivf.3 grpinvdiv
      3adant3r1 opreq2d eqtrd $.
      $( [27-Feb-2008] $) $( [24-Feb-2008] $)

    $( Associative-type law for multiplication and division. $)
    grpmuldivass $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A G B ) D C ) = ( A G ( B D C ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cG co cC cG cgn
      cfv cfv cG co cA cB cC cG cgn cfv cfv cG co cG co cA cB cG co cC cD co cA
      cB cC cD co cG co cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cX
      wcel cB cX wcel cC cG cgn cfv cfv cX wcel w3a cA cB cG co cC cG cgn cfv
      cfv cG co cA cB cC cG cgn cfv cfv cG co cG co wceq cG cgr wcel cA cX wcel
      cB cX wcel cC cX wcel w3a wa cA cX wcel cB cX wcel cC cG cgn cfv cfv cX
      wcel cG cgr wcel cA cX wcel cB cX wcel cC cX wcel 3simpr1 cG cgr wcel cA
      cX wcel cB cX wcel cC cX wcel 3simpr2 cG cgr wcel cA cX wcel cC cX wcel
      cC cG cgn cfv cfv cX wcel cB cX wcel cC cG cG cgn cfv cX grpdivf.1 cG cgn
      cfv eqid grpinvcl 3ad2antr3 3jca cA cB cC cG cgn cfv cfv cG cX grpdivf.1
      grpass syldan cG cgr wcel cA cB cG co cX wcel cC cX wcel cA cB cG co cC
      cD co cA cB cG co cC cG cgn cfv cfv cG co wceq cG cgr wcel cA cX wcel cB
      cX wcel cC cX wcel w3a wa cA cB cG co cC cD cG cG cgn cfv cX grpdivf.1 cG
      cgn cfv eqid grpdivf.3 grpdivval cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel w3a pm3.26 cG cgr wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cC
      cX wcel cA cB cG cX grpdivf.1 grpcl 3adant3r3 cG cgr wcel cA cX wcel cB
      cX wcel cC cX wcel 3simpr3 syl3anc cG cgr wcel cA cX wcel cB cX wcel cC
      cX wcel w3a wa cB cC cD co cB cC cG cgn cfv cfv cG co cA cG cG cgr wcel
      cB cX wcel cC cX wcel cB cC cD co cB cC cG cgn cfv cfv cG co wceq cA cX
      wcel cB cC cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpdivf.3
      grpdivval 3adant3r1 opreq2d 3eqtr4d $.
      $( [24-Feb-2008] $) $( [15-Feb-2008] $)

    ${
      grpdivid.3 $e |- U = ( Id ` G ) $.
      $( Division of a group member by itself. $)
      grpdivid $p |- ( ( G e. Grp /\ A e. X ) -> ( A D A ) = U ) $=
        cG cgr wcel cA cX wcel wa cA cA cD co cA cA cG cgn cfv cfv cG co cU cG
        cgr wcel cA cX wcel cA cA cD co cA cA cG cgn cfv cfv cG co wceq cA cA
        cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpdivf.3 grpdivval
        3anidm23 cA cU cG cG cgn cfv cX grpdivf.1 grpdivid.3 cG cgn cfv eqid
        grprinv eqtrd $.
        $( [27-Feb-2008] $) $( [15-Feb-2008] $)
    $}

    $( Group theory analog of ~ pncan . $)
    grppncan $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
        ( ( A G B ) D B ) = A ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cG co cB cD co cA cB cB cD co
      cG co cA cG cgi cfv cG co cA cG cgr wcel cA cX wcel cB cX wcel cB cX wcel
      w3a cA cB cG co cB cD co cA cB cB cD co cG co wceq cG cgr wcel cA cX wcel
      cB cX wcel w3a cA cB cB cD cG cX grpdivf.1 grpdivf.3 grpmuldivass cG cgr
      wcel cA cX wcel cB cX wcel 3simp1 cG cgr wcel cA cX wcel cB cX wcel w3a
      cA cX wcel cB cX wcel cB cX wcel cG cgr wcel cA cX wcel cB cX wcel 3simp2
      cG cgr wcel cA cX wcel cB cX wcel 3simp3 cG cgr wcel cA cX wcel cB cX
      wcel 3simp3 3jca sylanc cG cgr wcel cB cX wcel cA cB cB cD co cG co cA cG
      cgi cfv cG co wceq cA cX wcel cG cgr wcel cB cX wcel wa cB cB cD co cG
      cgi cfv cA cG cB cD cG cgi cfv cG cX grpdivf.1 grpdivf.3 cG cgi cfv eqid
      grpdivid opreq2d 3adant2 cG cgr wcel cA cX wcel cA cG cgi cfv cG co cA
      wceq cB cX wcel cA cG cgi cfv cG cX grpdivf.1 cG cgi cfv eqid grprid
      3adant3 3eqtrd $.
      $( [27-Feb-2008] $) $( [15-Feb-2008] $)

    $( Group theory analog of ~ npcan . $)
    grpnpcan $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
        ( ( A D B ) G B ) = A ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cD co cB cG co cA cB cG cgn
      cfv cfv cG co cB cG co cA cB cG cgn cfv cfv cB cG co cG co cA cG cgr wcel
      cA cX wcel cB cX wcel w3a cA cB cD co cA cB cG cgn cfv cfv cG co cB cG cA
      cB cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpdivf.3 grpdivval
      opreq1d cG cgr wcel cA cX wcel cB cG cgn cfv cfv cX wcel cB cX wcel w3a
      cA cB cG cgn cfv cfv cG co cB cG co cA cB cG cgn cfv cfv cB cG co cG co
      wceq cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cG cgn cfv cfv cB cG cX
      grpdivf.1 grpass cG cgr wcel cA cX wcel cB cX wcel 3simp1 cG cgr wcel cA
      cX wcel cB cX wcel w3a cA cX wcel cB cG cgn cfv cfv cX wcel cB cX wcel cG
      cgr wcel cA cX wcel cB cX wcel 3simp2 cG cgr wcel cB cX wcel cB cG cgn
      cfv cfv cX wcel cA cX wcel cB cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid
      grpinvcl 3adant2 cG cgr wcel cA cX wcel cB cX wcel 3simp3 3jca sylanc cG
      cgr wcel cA cX wcel cB cX wcel w3a cA cB cG cgn cfv cfv cB cG co cG co cA
      cG cgi cfv cG co cA cG cgr wcel cB cX wcel cA cB cG cgn cfv cfv cB cG co
      cG co cA cG cgi cfv cG co wceq cA cX wcel cG cgr wcel cB cX wcel wa cB cG
      cgn cfv cfv cB cG co cG cgi cfv cA cG cB cG cgi cfv cG cG cgn cfv cX
      grpdivf.1 cG cgi cfv eqid cG cgn cfv eqid grplinv opreq2d 3adant2 cG cgr
      wcel cA cX wcel cA cG cgi cfv cG co cA wceq cB cX wcel cA cG cgi cfv cG
      cX grpdivf.1 cG cgi cfv eqid grprid 3adant3 eqtrd 3eqtrd $.
      $( [26-Feb-2008] $) $( [15-Feb-2008] $)

    $( Group theory analog of ~ pnpcan2 . $)
    grppnpcan2 $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A G C ) D ( B G C ) ) = ( A D B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC cG co cB cC cG
      co cD co cA cC cG co cB cC cG co cG cgn cfv cfv cG co cA cC cG co cC cG
      cgn cfv cfv cB cG cgn cfv cfv cG co cG co cA cB cD co cG cgr wcel cA cC
      cG co cX wcel cB cC cG co cX wcel cA cC cG co cB cC cG co cD co cA cC cG
      co cB cC cG co cG cgn cfv cfv cG co wceq cG cgr wcel cA cX wcel cB cX
      wcel cC cX wcel w3a wa cA cC cG co cB cC cG co cD cG cG cgn cfv cX
      grpdivf.1 cG cgn cfv eqid grpdivf.3 grpdivval cG cgr wcel cA cX wcel cB
      cX wcel cC cX wcel w3a pm3.26 cG cgr wcel cA cX wcel cC cX wcel cA cC cG
      co cX wcel cB cX wcel cA cC cG cX grpdivf.1 grpcl 3adant3r2 cG cgr wcel
      cB cX wcel cC cX wcel cB cC cG co cX wcel cA cX wcel cB cC cG cX
      grpdivf.1 grpcl 3adant3r1 syl3anc cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel w3a wa cB cC cG co cG cgn cfv cfv cC cG cgn cfv cfv cB cG cgn cfv
      cfv cG co cA cC cG co cG cG cgr wcel cB cX wcel cC cX wcel cB cC cG co cG
      cgn cfv cfv cC cG cgn cfv cfv cB cG cgn cfv cfv cG co wceq cA cX wcel cB
      cC cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpinvop 3adant3r1 opreq2d
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC cC cG cgn cfv
      cfv cB cG cgn cfv cfv cG co cG co cG co cA cB cG cgn cfv cfv cG co cA cC
      cG co cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cG co cA cB cD co cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cC cC cG cgn cfv cfv cB cG
      cgn cfv cfv cG co cG co cB cG cgn cfv cfv cA cG cG cgr wcel cB cX wcel cC
      cX wcel cC cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cG co cB cG cgn cfv
      cfv wceq cA cX wcel cG cgr wcel cB cX wcel cC cX wcel w3a cC cC cG cgn
      cfv cfv cG co cB cG cgn cfv cfv cG co cG cgi cfv cB cG cgn cfv cfv cG co
      cC cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cG co cB cG cgn cfv cfv cG
      cgr wcel cB cX wcel cC cX wcel w3a cC cC cG cgn cfv cfv cG co cG cgi cfv
      cB cG cgn cfv cfv cG cG cgr wcel cC cX wcel cC cC cG cgn cfv cfv cG co cG
      cgi cfv wceq cB cX wcel cC cG cgi cfv cG cG cgn cfv cX grpdivf.1 cG cgi
      cfv eqid cG cgn cfv eqid grprinv 3adant2 opreq1d cG cgr wcel cC cX wcel
      cC cG cgn cfv cfv cX wcel cB cG cgn cfv cfv cX wcel w3a cC cC cG cgn cfv
      cfv cG co cB cG cgn cfv cfv cG co cC cC cG cgn cfv cfv cB cG cgn cfv cfv
      cG co cG co wceq cG cgr wcel cB cX wcel cC cX wcel w3a cC cC cG cgn cfv
      cfv cB cG cgn cfv cfv cG cX grpdivf.1 grpass cG cgr wcel cB cX wcel cC cX
      wcel 3simp1 cG cgr wcel cB cX wcel cC cX wcel w3a cC cX wcel cC cG cgn
      cfv cfv cX wcel cB cG cgn cfv cfv cX wcel cG cgr wcel cB cX wcel cC cX
      wcel 3simp3 cG cgr wcel cC cX wcel cC cG cgn cfv cfv cX wcel cB cX wcel
      cC cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpinvcl 3adant2 cG cgr
      wcel cB cX wcel cB cG cgn cfv cfv cX wcel cC cX wcel cB cG cG cgn cfv cX
      grpdivf.1 cG cgn cfv eqid grpinvcl 3adant3 3jca sylanc cG cgr wcel cB cX
      wcel cG cgi cfv cB cG cgn cfv cfv cG co cB cG cgn cfv cfv wceq cC cX wcel
      cG cgr wcel cB cX wcel cB cG cgn cfv cfv cX wcel cG cgi cfv cB cG cgn cfv
      cfv cG co cB cG cgn cfv cfv wceq cB cG cG cgn cfv cX grpdivf.1 cG cgn cfv
      eqid grpinvcl cB cG cgn cfv cfv cG cgi cfv cG cX grpdivf.1 cG cgi cfv
      eqid grplid syldan 3adant3 3eqtr3d 3adant3r1 opreq2d cG cgr wcel cA cX
      wcel cB cX wcel cC cX wcel w3a cA cX wcel cC cX wcel cC cG cgn cfv cfv cB
      cG cgn cfv cfv cG co cX wcel w3a cA cC cG co cC cG cgn cfv cfv cB cG cgn
      cfv cfv cG co cG co cA cC cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cG co
      cG co wceq cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cX wcel
      cC cX wcel cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cX wcel cG cgr wcel
      cA cX wcel cB cX wcel cC cX wcel 3simpr1 cG cgr wcel cA cX wcel cB cX
      wcel cC cX wcel 3simpr3 cG cgr wcel cC cG cgn cfv cfv cX wcel cB cG cgn
      cfv cfv cX wcel cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cX wcel cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cC cG cgn cfv cfv cB cG cgn
      cfv cfv cG cX grpdivf.1 grpcl cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel w3a pm3.26 cG cgr wcel cA cX wcel cC cX wcel cC cG cgn cfv cfv cX
      wcel cB cX wcel cC cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpinvcl
      3ad2antr3 cG cgr wcel cA cX wcel cB cX wcel cB cG cgn cfv cfv cX wcel cC
      cX wcel cB cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid grpinvcl 3ad2antr2
      syl3anc 3jca cA cC cC cG cgn cfv cfv cB cG cgn cfv cfv cG co cG cX
      grpdivf.1 grpass syldan cG cgr wcel cA cX wcel cB cX wcel cA cB cD co cA
      cB cG cgn cfv cfv cG co wceq cC cX wcel cA cB cD cG cG cgn cfv cX
      grpdivf.1 cG cgn cfv eqid grpdivf.3 grpdivval 3adant3r3 3eqtr4d 3eqtrd $.
      $( [26-Feb-2008] $) $( [15-Feb-2008] $)

    $( Group theory analog of ~ nnncan2 . $)
    grpnnncan2 $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A D C ) D ( B D C ) ) = ( A D B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC cD co cB cC cD
      co cD co cA cC cG cgn cfv cfv cG co cB cC cG cgn cfv cfv cG co cD co cA
      cB cD co cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC cD co
      cA cC cG cgn cfv cfv cG co cB cC cD co cB cC cG cgn cfv cfv cG co cD cG
      cgr wcel cA cX wcel cC cX wcel cA cC cD co cA cC cG cgn cfv cfv cG co
      wceq cB cX wcel cA cC cD cG cG cgn cfv cX grpdivf.1 cG cgn cfv eqid
      grpdivf.3 grpdivval 3adant3r2 cG cgr wcel cB cX wcel cC cX wcel cB cC cD
      co cB cC cG cgn cfv cfv cG co wceq cA cX wcel cB cC cD cG cG cgn cfv cX
      grpdivf.1 cG cgn cfv eqid grpdivf.3 grpdivval 3adant3r1 opreq12d cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cX wcel cB cX wcel cC cG cgn
      cfv cfv cX wcel w3a cA cC cG cgn cfv cfv cG co cB cC cG cgn cfv cfv cG co
      cD co cA cB cD co wceq cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a
      cA cX wcel cB cX wcel cC cG cgn cfv cfv cX wcel w3a cG cgr wcel cA cX
      wcel cA cX wcel cB cX wcel cB cX wcel cC cX wcel cC cG cgn cfv cfv cX
      wcel cG cgr wcel cA cX wcel idd cG cgr wcel cB cX wcel idd cG cgr wcel cC
      cX wcel cC cG cgn cfv cfv cX wcel cC cG cG cgn cfv cX grpdivf.1 cG cgn
      cfv eqid grpinvcl ex 3anim123d imp cA cB cC cG cgn cfv cfv cD cG cX
      grpdivf.1 grpdivf.3 grppnpcan2 syldan eqtrd $.
      $( [27-Feb-2008] $) $( [15-Feb-2008] $)

    $( Group theory analog of ~ npncan . $)
    grpnpncan $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
             ( ( A D B ) G ( B D C ) ) = ( A D C ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cD co cB cG co
      cC cD co cA cB cD co cB cC cD co cG co cA cC cD co cG cgr wcel cA cX wcel
      cB cX wcel cC cX wcel w3a cA cB cD co cX wcel cB cX wcel cC cX wcel w3a
      cA cB cD co cB cG co cC cD co cA cB cD co cB cC cD co cG co wceq cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cD co cX wcel cB cX
      wcel cC cX wcel cG cgr wcel cA cX wcel cB cX wcel cA cB cD co cX wcel cC
      cX wcel cA cB cD cG cX grpdivf.1 grpdivf.3 grpdivcl 3adant3r3 cG cgr wcel
      cA cX wcel cB cX wcel cC cX wcel 3simpr2 cG cgr wcel cA cX wcel cB cX
      wcel cC cX wcel 3simpr3 3jca cA cB cD co cB cC cD cG cX grpdivf.1
      grpdivf.3 grpmuldivass syldan cG cgr wcel cA cX wcel cB cX wcel cA cB cD
      co cB cG co cC cD co cA cC cD co wceq cC cX wcel cG cgr wcel cA cX wcel
      cB cX wcel wa wa cA cB cD co cB cG co cA cC cD cG cgr wcel cA cX wcel cB
      cX wcel cA cB cD co cB cG co cA wceq cA cB cD cG cX grpdivf.1 grpdivf.3
      grpnpcan 3expb opreq1d 3adantr3 eqtr3d $.
      $( [28-Feb-2008] $) $( [24-Feb-2008] $)
  $}

  ${
    $d G f g x y z $.  $d N f g z $.  $d U f g x y z $.  $d X f g x y z $.
    $d A x y z $.  $d G x y z $.  $d K x y z $.  $d N x y z $.
    gxoprval.1 $e |- X = ran G $.
    gxoprval.2 $e |- U = ( Id ` G ) $.
    gxoprval.3 $e |- N = ( inv ` G ) $.
    gxoprval.4 $e |- P = ( ^g ` G ) $.
    $( The value of the group power operator function.  (Contributed by Paul
       Chapman, 17-Apr-2009.) $)
    gxoprval $p |- ( G e. Grp -> P = { <. <. x , y >. , z >. |
        ( ( x e. X /\ y e. ZZ ) /\
        z = if ( y = 0 , U , if ( 0 < y , ( ( G seq1 ( NN X. { x } ) ) ` y ) ,
          ( N ` ( ( G seq1 ( NN X. { x } ) ) ` -u y ) ) ) ) ) } ) $=
      cG cgr wcel cG cgx cfv vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0
      wceq cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv
      cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz
      copab2 cP cG cgr wcel vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq
      cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG
      cn vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 cvv
      wcel cG cgx cfv vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq cU
      cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn
      vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 wceq cX
      cvv wcel cz cvv wcel vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq
      cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG
      cn vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 cvv
      wcel cG cgr wcel vx vy vz cX cz vy cv cc0 wceq cU cc0 vy cv clt wbr vy cv
      cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co
      cfv cN cfv cif cif cvv cvv vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0
      wceq cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv
      cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz
      copab2 vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq cU cc0 vy cv
      clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn
      cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 eqid oprabex2g cG
      cgr wcel cG crn cvv cX cG cgr rnexg gxoprval.1 syl5eqel zex sylancl vg vf
      cG vx cv vg cv crn wcel vy cv cz wcel wa vz cv vy cv cc0 wceq vg cv cgi
      cfv cc0 vy cv clt wbr vy cv vg cv cn vx cv csn cxp cseq1 co cfv vy cv
      cneg vg cv cn vx cv csn cxp cseq1 co cfv vg cv cgn cfv cfv cif cif wceq
      wa vx vy vz copab2 vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq cU
      cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn
      vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 cgr cvv
      cgx vg cv cG wceq vx cv vg cv crn wcel vy cv cz wcel wa vz cv vy cv cc0
      wceq vg cv cgi cfv cc0 vy cv clt wbr vy cv vg cv cn vx cv csn cxp cseq1
      co cfv vy cv cneg vg cv cn vx cv csn cxp cseq1 co cfv vg cv cgn cfv cfv
      cif cif wceq wa vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq cU
      cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn
      vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz vg cv cG wceq
      vx cv vg cv crn wcel vy cv cz wcel wa vx cv cX wcel vy cv cz wcel wa vz
      cv vy cv cc0 wceq vg cv cgi cfv cc0 vy cv clt wbr vy cv vg cv cn vx cv
      csn cxp cseq1 co cfv vy cv cneg vg cv cn vx cv csn cxp cseq1 co cfv vg cv
      cgn cfv cfv cif cif wceq vz cv vy cv cc0 wceq cU cc0 vy cv clt wbr vy cv
      cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co
      cfv cN cfv cif cif wceq vg cv cG wceq vx cv vg cv crn wcel vx cv cX wcel
      vy cv cz wcel vg cv cG wceq vg cv crn cX vx cv vg cv cG wceq vg cv crn cG
      crn cX vg cv cG rneq gxoprval.1 syl6eqr eleq2d anbi1d vg cv cG wceq vy cv
      cc0 wceq vg cv cgi cfv cc0 vy cv clt wbr vy cv vg cv cn vx cv csn cxp
      cseq1 co cfv vy cv cneg vg cv cn vx cv csn cxp cseq1 co cfv vg cv cgn cfv
      cfv cif cif vy cv cc0 wceq cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp
      cseq1 co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif cif
      vz cv vg cv cG wceq vy cv cc0 wceq vg cv cgi cfv cc0 vy cv clt wbr vy cv
      vg cv cn vx cv csn cxp cseq1 co cfv vy cv cneg vg cv cn vx cv csn cxp
      cseq1 co cfv vg cv cgn cfv cfv cif cif vy cv cc0 wceq vg cv cgi cfv cc0
      vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx
      cv csn cxp cseq1 co cfv cN cfv cif cif vy cv cc0 wceq cU cc0 vy cv clt
      wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp
      cseq1 co cfv cN cfv cif cif vg cv cG wceq vy cv cc0 wceq cc0 vy cv clt
      wbr vy cv vg cv cn vx cv csn cxp cseq1 co cfv vy cv cneg vg cv cn vx cv
      csn cxp cseq1 co cfv vg cv cgn cfv cfv cif cc0 vy cv clt wbr vy cv cG cn
      vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN
      cfv cif vg cv cgi cfv vg cv cG wceq cc0 vy cv clt wbr vy cv vg cv cn vx
      cv csn cxp cseq1 co cfv vy cv cneg vg cv cn vx cv csn cxp cseq1 co cfv vg
      cv cgn cfv cfv cif cc0 vy cv clt wbr vy cv vg cv cn vx cv csn cxp cseq1
      co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif cc0 vy cv
      clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn
      cxp cseq1 co cfv cN cfv cif vg cv cG wceq cc0 vy cv clt wbr vy cv cneg vg
      cv cn vx cv csn cxp cseq1 co cfv vg cv cgn cfv cfv vy cv cneg cG cn vx cv
      csn cxp cseq1 co cfv cN cfv vy cv vg cv cn vx cv csn cxp cseq1 co cfv vg
      cv cG wceq vy cv cneg vg cv cn vx cv csn cxp cseq1 co cfv vg cv cgn cfv
      cfv vy cv cneg vg cv cn vx cv csn cxp cseq1 co cfv cN cfv vy cv cneg cG
      cn vx cv csn cxp cseq1 co cfv cN cfv vg cv cG wceq vy cv cneg vg cv cn vx
      cv csn cxp cseq1 co cfv vg cv cgn cfv cN vg cv cG wceq vg cv cgn cfv cG
      cgn cfv cN vg cv cG cgn fveq2 gxoprval.3 syl6eqr fveq1d vg cv cG wceq vy
      cv cneg vg cv cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn
      cxp cseq1 co cfv cN vg cv cG wceq vy cv cneg vg cv cn vx cv csn cxp cseq1
      co cG cn vx cv csn cxp cseq1 co vg cv cG cn vx cv csn cxp cseq1 opreq1
      fveq1d fveq2d eqtrd ifeq2d vg cv cG wceq cc0 vy cv clt wbr vy cv vg cv cn
      vx cv csn cxp cseq1 co cfv vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv
      cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv vg cv cG wceq vy cv vg cv cn
      vx cv csn cxp cseq1 co cG cn vx cv csn cxp cseq1 co vg cv cG cn vx cv csn
      cxp cseq1 opreq1 fveq1d ifeq1d eqtrd ifeq2d vg cv cG wceq vy cv cc0 wceq
      vg cv cgi cfv cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv
      vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif vg cv cG wceq vg
      cv cgi cfv cG cgi cfv cU vg cv cG cgi fveq2 gxoprval.2 syl6eqr ifeq1d
      eqtrd eqeq2d anbi12d oprabbidv vx vy vz vf vg df-gx fvopab4g mpdan
      gxoprval.4 syl5eq $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( The result of the group power operator.  (Contributed by Paul Chapman,
       17-Apr-2009.) $)
    gxval $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) -> ( A P K ) =
      if ( K = 0 , U , if ( 0 < K , ( ( G seq1 ( NN X. { A } ) ) ` K ) ,
           ( N ` ( ( G seq1 ( NN X. { A } ) ) ` -u K ) ) ) ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel cA cK cP co cK cc0 wceq cU cc0 cK clt
      wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co
      cfv cN cfv cif cif wceq cG cgr wcel cA cX wcel cK cz wcel wa cA cK cP co
      cA cK vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq cU cc0 vy cv
      clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn
      cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 co cK cc0 wceq cU
      cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp
      cseq1 co cfv cN cfv cif cif cG cgr wcel cP vx cv cX wcel vy cv cz wcel wa
      vz cv vy cv cc0 wceq cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1
      co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa
      vx vy vz copab2 cA cK vx vy vz cP cU cG cN cX gxoprval.1 gxoprval.2
      gxoprval.3 gxoprval.4 gxoprval opreqd vx vy vz cA cK cX cz vy cv cc0 wceq
      cU cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG
      cn vx cv csn cxp cseq1 co cfv cN cfv cif cif cK cc0 wceq cU cc0 cK clt
      wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co
      cfv cN cfv cif cif vx cv cX wcel vy cv cz wcel wa vz cv vy cv cc0 wceq cU
      cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn
      vx cv csn cxp cseq1 co cfv cN cfv cif cif wceq wa vx vy vz copab2 vy cv
      cc0 wceq cU cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co cfv vy cv
      cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cif cK cc0 wceq cU cc0 cK
      clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1
      co cfv cN cfv cif cU cG cgi cfv cvv gxoprval.2 cG cgi fvex eqeltri cc0 cK
      clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1
      co cfv cN cfv cK cG cn cA csn cxp cseq1 co fvex cK cneg cG cn cA csn cxp
      cseq1 co cfv cN fvex ifex ifex vx cv cA wceq vy cv cc0 wceq cc0 vy cv clt
      wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp
      cseq1 co cfv cN cfv cif cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co
      cfv vy cv cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cU vx cv cA wceq
      cc0 vy cv clt wbr vy cv cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn
      vx cv csn cxp cseq1 co cfv cN cfv cif cc0 vy cv clt wbr vy cv cG cn cA
      csn cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv
      cif cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co cfv vy cv cneg cG
      cn cA csn cxp cseq1 co cfv cN cfv cif vx cv cA wceq cc0 vy cv clt wbr vy
      cv cG cn vx cv csn cxp cseq1 co cfv vy cv cG cn cA csn cxp cseq1 co cfv
      vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv vx cv cA wceq vy cv cG
      cn vx cv csn cxp cseq1 co cG cn cA csn cxp cseq1 co vx cv cA wceq cn vx
      cv csn cxp cn cA csn cxp cG cseq1 vx cv cA wceq vx cv csn cA csn wceq cn
      vx cv csn cxp cn cA csn cxp wceq vx cv cA sneq vx cv csn cA csn cn xpeq2
      syl opreq2d fveq1d ifeq1d vx cv cA wceq cc0 vy cv clt wbr vy cv cneg cG
      cn vx cv csn cxp cseq1 co cfv cN cfv vy cv cneg cG cn cA csn cxp cseq1 co
      cfv cN cfv vy cv cG cn cA csn cxp cseq1 co cfv vx cv cA wceq vy cv cneg
      cG cn vx cv csn cxp cseq1 co cfv vy cv cneg cG cn cA csn cxp cseq1 co cfv
      cN vx cv cA wceq vy cv cneg cG cn vx cv csn cxp cseq1 co cG cn cA csn cxp
      cseq1 co vx cv cA wceq cn vx cv csn cxp cn cA csn cxp cG cseq1 vx cv cA
      wceq vx cv csn cA csn wceq cn vx cv csn cxp cn cA csn cxp wceq vx cv cA
      sneq vx cv csn cA csn cn xpeq2 syl opreq2d fveq1d fveq2d ifeq2d eqtrd
      ifeq2d vy cv cK wceq vy cv cc0 wceq cU cc0 vy cv clt wbr vy cv cG cn cA
      csn cxp cseq1 co cfv vy cv cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif
      cif cK cc0 wceq cU cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co cfv
      vy cv cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cif cK cc0 wceq cU
      cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp
      cseq1 co cfv cN cfv cif cif vy cv cK wceq vy cv cc0 wceq cK cc0 wceq cU
      cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co cfv vy cv cneg cG cn cA
      csn cxp cseq1 co cfv cN cfv cif vy cv cK cc0 eqeq1 ifbid vy cv cK wceq cK
      cc0 wceq cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co cfv vy cv cneg
      cG cn cA csn cxp cseq1 co cfv cN cfv cif cc0 cK clt wbr cK cG cn cA csn
      cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cU vy
      cv cK wceq cc0 vy cv clt wbr vy cv cG cn cA csn cxp cseq1 co cfv vy cv
      cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cc0 cK clt wbr vy cv cG cn
      cA csn cxp cseq1 co cfv vy cv cneg cG cn cA csn cxp cseq1 co cfv cN cfv
      cif cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv vy cv cneg cG cn cA
      csn cxp cseq1 co cfv cN cfv cif cc0 cK clt wbr cK cG cn cA csn cxp cseq1
      co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif vy cv cK wceq cc0
      vy cv clt wbr cc0 cK clt wbr vy cv cG cn cA csn cxp cseq1 co cfv vy cv
      cneg cG cn cA csn cxp cseq1 co cfv cN cfv vy cv cK cc0 clt breq2 ifbid vy
      cv cK wceq cc0 cK clt wbr vy cv cG cn cA csn cxp cseq1 co cfv cK cG cn cA
      csn cxp cseq1 co cfv vy cv cneg cG cn cA csn cxp cseq1 co cfv cN cfv vy
      cv cK cG cn cA csn cxp cseq1 co fveq2 ifeq1d vy cv cK wceq cc0 cK clt wbr
      vy cv cneg cG cn cA csn cxp cseq1 co cfv cN cfv cK cneg cG cn cA csn cxp
      cseq1 co cfv cN cfv cK cG cn cA csn cxp cseq1 co cfv vy cv cK wceq vy cv
      cneg cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv
      cN vy cv cK wceq vy cv cneg cK cneg cG cn cA csn cxp cseq1 co vy cv cK
      negeq fveq2d fveq2d ifeq2d 3eqtrd ifeq2d eqtrd vx cv cX wcel vy cv cz
      wcel wa vz cv vy cv cc0 wceq cU cc0 vy cv clt wbr vy cv cG cn vx cv csn
      cxp cseq1 co cfv vy cv cneg cG cn vx cv csn cxp cseq1 co cfv cN cfv cif
      cif wceq wa vx vy vz copab2 eqid oprabval2 sylan9eq 3impb $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxpval.1 $e |- X = ran G $.
    gxpval.2 $e |- P = ( ^g ` G ) $.
    $( The result of the group power operator when the exponent is positive.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxpval $p |- ( ( G e. Grp /\ A e. X /\ K e. NN ) ->
                   ( A P K ) = ( ( G seq1 ( NN X. { A } ) ) ` K ) ) $=
      cG cgr wcel cA cX wcel cK cn wcel w3a cA cK cP co cK cc0 wceq cG cgi cfv
      cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp
      cseq1 co cfv cG cgn cfv cfv cif cif cK cG cn cA csn cxp cseq1 co cfv cG
      cgr wcel cA cX wcel cK cz wcel cA cK cP co cK cc0 wceq cG cgi cfv cc0 cK
      clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1
      co cfv cG cgn cfv cfv cif cif wceq cK cn wcel cA cP cG cgi cfv cG cK cG
      cgn cfv cX gxpval.1 cG cgi cfv eqid cG cgn cfv eqid gxpval.2 gxval cK nnz
      syl3an3 cK cn wcel cG cgr wcel cK cc0 wceq cG cgi cfv cc0 cK clt wbr cK
      cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cG
      cgn cfv cfv cif cif cK cG cn cA csn cxp cseq1 co cfv wceq cA cX wcel cK
      cn wcel cK cc0 wceq cG cgi cfv cc0 cK clt wbr cK cG cn cA csn cxp cseq1
      co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cG cgn cfv cfv cif cif cc0
      cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp
      cseq1 co cfv cG cgn cfv cfv cif cK cG cn cA csn cxp cseq1 co cfv cK cn
      wcel cK cc0 wceq wn cK cc0 wceq cG cgi cfv cc0 cK clt wbr cK cG cn cA csn
      cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cG cgn cfv cfv cif
      cif cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn
      cxp cseq1 co cfv cG cgn cfv cfv cif wceq cK cn wcel cK cc0 wne cK cc0
      wceq wn cK nnne0 cK cc0 df-ne sylib cK cc0 wceq cG cgi cfv cc0 cK clt wbr
      cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cG
      cgn cfv cfv cif iffalse syl cK cn wcel cc0 cK clt wbr cc0 cK clt wbr cK
      cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cG
      cgn cfv cfv cif cK cG cn cA csn cxp cseq1 co cfv wceq cK nngt0 cc0 cK clt
      wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co
      cfv cG cgn cfv cfv iftrue syl eqtrd 3ad2ant3 eqtrd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxnval.1 $e |- X = ran G $.
    gxnval.2 $e |- P = ( ^g ` G ) $.
    gxnval.3 $e |- N = ( inv ` G ) $.
    $( The result of the group power operator when the exponent is negative.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxnval $p |- ( ( G e. Grp /\ A e. X /\ ( K e. ZZ /\ K < 0 ) ) ->
        ( A P K ) = ( N ` ( ( G seq1 ( NN X. { A } ) ) ` -u K ) ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel cK cc0 clt wbr wa w3a cA cK cP co cK
      cc0 wceq cG cgi cfv cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK
      cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cif cK cneg cG cn cA csn
      cxp cseq1 co cfv cN cfv cG cgr wcel cA cX wcel cK cz wcel cA cK cP co cK
      cc0 wceq cG cgi cfv cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK
      cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cif wceq cK cc0 clt wbr cA
      cP cG cgi cfv cG cK cN cX gxnval.1 cG cgi cfv eqid gxnval.3 gxnval.2
      gxval 3adant3r cK cz wcel cK cc0 clt wbr wa cG cgr wcel cK cc0 wceq cG
      cgi cfv cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA
      csn cxp cseq1 co cfv cN cfv cif cif cK cneg cG cn cA csn cxp cseq1 co cfv
      cN cfv wceq cA cX wcel cK cz wcel cK cc0 clt wbr wa cK cc0 wceq cG cgi
      cfv cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn
      cxp cseq1 co cfv cN cfv cif cif cc0 cK clt wbr cK cG cn cA csn cxp cseq1
      co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cK cneg cG cn cA
      csn cxp cseq1 co cfv cN cfv cK cz wcel cK cc0 clt wbr wa cK cc0 wceq wn
      cK cc0 wceq cG cgi cfv cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK
      cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif cif cc0 cK clt wbr cK cG cn
      cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp cseq1 co cfv cN cfv cif
      wceq cK cr wcel cK cc0 clt wbr cK cc0 wceq wn cK cz wcel cK cr wcel cK
      cc0 clt wbr wa cK cc0 wne cK cc0 wceq wn cK cr wcel cK cc0 clt wbr wa cc0
      cK cK cr wcel cc0 cr wcel cK cc0 clt wbr cc0 cK wne 0re cK cc0 ltne
      mp3an2 necomd cK cc0 df-ne sylib cK zre sylan cK cc0 wceq cG cgi cfv cc0
      cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn cA csn cxp
      cseq1 co cfv cN cfv cif iffalse syl cK cz wcel cK cc0 clt wbr wa cc0 cK
      clt wbr wn cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg cG cn
      cA csn cxp cseq1 co cfv cN cfv cif cK cneg cG cn cA csn cxp cseq1 co cfv
      cN cfv wceq cK cz wcel cK cc0 clt wbr cc0 cK clt wbr wn cK cr wcel cc0 cr
      wcel cK cc0 clt wbr cc0 cK clt wbr wn wi cK cz wcel cK cc0 ltnsym cK zre
      0re sylancl imp cc0 cK clt wbr cK cG cn cA csn cxp cseq1 co cfv cK cneg
      cG cn cA csn cxp cseq1 co cfv cN cfv iffalse syl eqtrd 3ad2ant3 eqtrd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gx0.1 $e |- X = ran G $.
    gx0.2 $e |- U = ( Id ` G ) $.
    gx0.3 $e |- P = ( ^g ` G ) $.
    $( The result of the group power operator when the exponent is zero.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gx0 $p |- ( ( G e. Grp /\ A e. X ) -> ( A P 0 ) = U ) $=
      cG cgr wcel cA cX wcel wa cA cc0 cP co cc0 cc0 wceq cU cc0 cc0 clt wbr
      cc0 cG cn cA csn cxp cseq1 co cfv cc0 cneg cG cn cA csn cxp cseq1 co cfv
      cG cgn cfv cfv cif cif cU cG cgr wcel cA cX wcel cc0 cz wcel cA cc0 cP co
      cc0 cc0 wceq cU cc0 cc0 clt wbr cc0 cG cn cA csn cxp cseq1 co cfv cc0
      cneg cG cn cA csn cxp cseq1 co cfv cG cgn cfv cfv cif cif wceq 0z cA cP
      cU cG cc0 cG cgn cfv cX gx0.1 gx0.2 cG cgn cfv eqid gx0.3 gxval mp3an3
      cc0 cc0 wceq cc0 cc0 wceq cU cc0 cc0 clt wbr cc0 cG cn cA csn cxp cseq1
      co cfv cc0 cneg cG cn cA csn cxp cseq1 co cfv cG cgn cfv cfv cif cif cU
      wceq cc0 eqid cc0 cc0 wceq cU cc0 cc0 clt wbr cc0 cG cn cA csn cxp cseq1
      co cfv cc0 cneg cG cn cA csn cxp cseq1 co cfv cG cgn cfv cfv cif iftrue
      ax-mp syl6eq $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d A g $.  $d G g $.
    gx1.1 $e |- X = ran G $.
    gx1.2 $e |- P = ( ^g ` G ) $.
    $( The result of the group power operator when the exponent is one.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gx1 $p |- ( ( G e. Grp /\ A e. X ) -> ( A P 1 ) = A ) $=
      cG cgr wcel cA cX wcel wa cA c1 cP co c1 cG cn cA csn cxp cseq1 co cfv cA
      cG cgr wcel cA cX wcel c1 cn wcel cA c1 cP co c1 cG cn cA csn cxp cseq1
      co cfv wceq 1nn cA cP cG c1 cX gx1.1 gx1.2 gxpval mp3an3 cG cgr wcel cA
      cX wcel c1 cG cn cA csn cxp cseq1 co cfv c1 cn cA csn cxp cfv cA c1 vg cv
      cn cA csn cxp cseq1 co cfv c1 cn cA csn cxp cfv wceq c1 cG cn cA csn cxp
      cseq1 co cfv c1 cn cA csn cxp cfv wceq vg cG cgr vg cv cG wceq c1 vg cv
      cn cA csn cxp cseq1 co cfv c1 cG cn cA csn cxp cseq1 co cfv c1 cn cA csn
      cxp cfv vg cv cG wceq c1 vg cv cn cA csn cxp cseq1 co cG cn cA csn cxp
      cseq1 co vg cv cG cn cA csn cxp cseq1 opreq1 fveq1d eqeq1d vg cv cn cA
      csn cxp vg visset cn cA csn nnex cA snex xpex seq11 vtoclg cn cA csn cn
      cA csn cxp wf c1 cn wcel c1 cn cA csn cxp cfv cA wceq cA cX wcel cn cA c1
      cn cA csn cxp fvconst cn cA cX fconstg 1nn sylancl sylan9eq eqtrd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxnn0neg.1 $e |- X = ran G $.
    gxnn0neg.2 $e |- N = ( inv ` G ) $.
    gxnn0neg.3 $e |- P = ( ^g ` G ) $.
    $( A negative group power is the inverse of the positive power (lemma with
       nonnegative exponent - use ~ gxneg instead).  (Contributed by Paul
       Chapman, 17-Apr-2009.) $)
    gxnn0neg $p |- ( ( G e. Grp /\ A e. X /\ K e. NN0 ) ->
                     ( A P -u K ) = ( N ` ( A P K ) ) ) $=
      cG cgr wcel cA cX wcel cK cn0 wcel cA cK cneg cP co cA cK cP co cN cfv
      wceq cG cgr wcel cA cX wcel wa cK cn wcel cK cc0 wceq wo cA cK cneg cP co
      cA cK cP co cN cfv wceq cK cn0 wcel cG cgr wcel cA cX wcel wa cK cn wcel
      cA cK cneg cP co cA cK cP co cN cfv wceq cK cc0 wceq cG cgr wcel cA cX
      wcel cK cn wcel cA cK cneg cP co cA cK cP co cN cfv wceq cG cgr wcel cA
      cX wcel cK cn wcel w3a cA cK cneg cP co cK cneg cneg cG cn cA csn cxp
      cseq1 co cfv cN cfv cA cK cP co cN cfv cG cgr wcel cA cX wcel cK cneg cz
      wcel cK cneg cc0 clt wbr wa cA cK cneg cP co cK cneg cneg cG cn cA csn
      cxp cseq1 co cfv cN cfv wceq cK cn wcel cA cP cG cK cneg cN cX gxnn0neg.1
      gxnn0neg.3 gxnn0neg.2 gxnval cK cn wcel cK cneg cz wcel cK cneg cc0 clt
      wbr cK cn wcel cK cz wcel cK cneg cz wcel cK nnz cK znegcl syl cK cn wcel
      cc0 cK clt wbr cK cneg cc0 clt wbr cK nngt0 cK cn wcel cK cr wcel cc0 cK
      clt wbr cK cneg cc0 clt wbr wb cK nnre cK lt0neg2 syl mpbid jca syl3an3
      cG cgr wcel cA cX wcel cK cn wcel w3a cA cK cP co cK cneg cneg cG cn cA
      csn cxp cseq1 co cfv cN cG cgr wcel cA cX wcel cK cn wcel w3a cA cK cP co
      cK cG cn cA csn cxp cseq1 co cfv cK cneg cneg cG cn cA csn cxp cseq1 co
      cfv cA cP cG cK cX gxnn0neg.1 gxnn0neg.3 gxpval cK cn wcel cG cgr wcel cK
      cneg cneg cG cn cA csn cxp cseq1 co cfv cK cG cn cA csn cxp cseq1 co cfv
      wceq cA cX wcel cK cn wcel cK cneg cneg cK cG cn cA csn cxp cseq1 co cK
      cn wcel cK cc wcel cK cneg cneg cK wceq cK nncn cK negneg syl fveq2d
      3ad2ant3 eqtr4d fveq2d eqtr4d 3expia cG cgr wcel cA cX wcel wa cK cc0
      wceq cA cK cneg cP co cA cK cP co cN cfv wceq cG cgr wcel cA cX wcel wa
      cK cc0 wceq wa cA cK cneg cP co cG cgi cfv cA cK cP co cN cfv cK cc0 wceq
      cG cgr wcel cA cX wcel wa cA cK cneg cP co cA cc0 cP co cG cgi cfv cK cc0
      wceq cK cneg cc0 cA cP cK cc0 wceq cK cneg cc0 cneg cc0 cK cc0 negeq neg0
      syl6eq opreq2d cA cP cG cgi cfv cG cX gxnn0neg.1 cG cgi cfv eqid
      gxnn0neg.3 gx0 sylan9eqr cK cc0 wceq cG cgr wcel cA cX wcel wa cA cK cP
      co cN cfv cA cc0 cP co cN cfv cG cgi cfv cK cc0 wceq cA cK cP co cA cc0
      cP co cN cK cc0 cA cP opreq2 fveq2d cG cgr wcel cA cX wcel wa cA cc0 cP
      co cN cfv cG cgi cfv cN cfv cG cgi cfv cG cgr wcel cA cX wcel wa cA cc0
      cP co cG cgi cfv cN cA cP cG cgi cfv cG cX gxnn0neg.1 cG cgi cfv eqid
      gxnn0neg.3 gx0 fveq2d cG cgr wcel cG cgi cfv cN cfv cG cgi cfv wceq cA cX
      wcel cG cgi cfv cG cN cG cgi cfv eqid gxnn0neg.2 grpinvid adantr eqtrd
      sylan9eqr eqtr4d ex jaod cK elnn0 syl5ib 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d A g k m $.  $d G g k m $.  $d K g m $.  $d P k m $.  $d X k m $.
    gxnn0suc.1 $e |- X = ran G $.
    gxnn0suc.2 $e |- P = ( ^g ` G ) $.
    $( Induction on group power (lemma with nonnegative exponent - use ~ gxsuc
       instead).  (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxnn0suc $p |- ( ( G e. Grp /\ A e. X /\ K e. NN0 ) ->
                     ( A P ( K + 1 ) ) = ( ( A P K ) G A ) ) $=
      cG cgr wcel cA cX wcel cK cn0 wcel cA cK c1 caddc co cP co cA cK cP co cA
      cG co wceq cG cgr wcel cA cX wcel wa cK cn wcel cK cc0 wceq wo cA cK c1
      caddc co cP co cA cK cP co cA cG co wceq cK cn0 wcel cG cgr wcel cA cX
      wcel wa cK cn wcel cA cK c1 caddc co cP co cA cK cP co cA cG co wceq cK
      cc0 wceq cG cgr wcel cA cX wcel cK cn wcel cA cK c1 caddc co cP co cA cK
      cP co cA cG co wceq cG cgr wcel cA cX wcel cK cn wcel w3a cK c1 caddc co
      cG cn cA csn cxp cseq1 co cfv cK cG cn cA csn cxp cseq1 co cfv cK c1
      caddc co cn cA csn cxp cfv cG co cA cK c1 caddc co cP co cA cK cP co cA
      cG co cG cgr wcel cK cn wcel cK c1 caddc co cG cn cA csn cxp cseq1 co cfv
      cK cG cn cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn cxp cfv cG co
      wceq cA cX wcel cG cgr wcel cK cn wcel cK c1 caddc co cG cn cA csn cxp
      cseq1 co cfv cK cG cn cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn
      cxp cfv cG co wceq cK cn wcel cK c1 caddc co vg cv cn cA csn cxp cseq1 co
      cfv cK vg cv cn cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn cxp cfv
      vg cv co wceq wi cK cn wcel cK c1 caddc co cG cn cA csn cxp cseq1 co cfv
      cK cG cn cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn cxp cfv cG co
      wceq wi vg cG cgr vg cv cG wceq cK c1 caddc co vg cv cn cA csn cxp cseq1
      co cfv cK vg cv cn cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn cxp
      cfv vg cv co wceq cK c1 caddc co cG cn cA csn cxp cseq1 co cfv cK cG cn
      cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn cxp cfv cG co wceq cK cn
      wcel vg cv cG wceq cK c1 caddc co vg cv cn cA csn cxp cseq1 co cfv cK c1
      caddc co cG cn cA csn cxp cseq1 co cfv cK vg cv cn cA csn cxp cseq1 co
      cfv cK c1 caddc co cn cA csn cxp cfv vg cv co cK cG cn cA csn cxp cseq1
      co cfv cK c1 caddc co cn cA csn cxp cfv cG co vg cv cG wceq cK c1 caddc
      co vg cv cn cA csn cxp cseq1 co cG cn cA csn cxp cseq1 co vg cv cG cn cA
      csn cxp cseq1 opreq1 fveq1d vg cv cG wceq cK vg cv cn cA csn cxp cseq1 co
      cfv cK c1 caddc co cn cA csn cxp cfv vg cv co cK cG cn cA csn cxp cseq1
      co cfv cK c1 caddc co cn cA csn cxp cfv vg cv co cK cG cn cA csn cxp
      cseq1 co cfv cK c1 caddc co cn cA csn cxp cfv cG co vg cv cG wceq cK vg
      cv cn cA csn cxp cseq1 co cfv cK cG cn cA csn cxp cseq1 co cfv cK c1
      caddc co cn cA csn cxp cfv vg cv vg cv cG wceq cK vg cv cn cA csn cxp
      cseq1 co cG cn cA csn cxp cseq1 co vg cv cG cn cA csn cxp cseq1 opreq1
      fveq1d opreq1d cK cG cn cA csn cxp cseq1 co cfv cK c1 caddc co cn cA csn
      cxp cfv vg cv cG opreq eqtrd eqeq12d imbi2d cK vg cv cn cA csn cxp vg
      visset cn cA csn nnex cA snex xpex seq1p1 vtoclg imp 3adant2 cG cgr wcel
      cA cX wcel cK c1 caddc co cn wcel cA cK c1 caddc co cP co cK c1 caddc co
      cG cn cA csn cxp cseq1 co cfv wceq cK cn wcel cA cP cG cK c1 caddc co cX
      gxnn0suc.1 gxnn0suc.2 gxpval cK peano2nn syl3an3 cG cgr wcel cA cX wcel
      cK cn wcel w3a cA cK cP co cK cG cn cA csn cxp cseq1 co cfv cA cK c1
      caddc co cn cA csn cxp cfv cG cA cP cG cK cX gxnn0suc.1 gxnn0suc.2 gxpval
      cG cgr wcel cA cX wcel cK cn wcel w3a cK c1 caddc co cn cA csn cxp cfv cA
      cA cX wcel cK cn wcel cK c1 caddc co cn cA csn cxp cfv cA wceq cG cgr
      wcel cn cA csn cn cA csn cxp wf cK c1 caddc co cn wcel cK c1 caddc co cn
      cA csn cxp cfv cA wceq cA cX wcel cK cn wcel cn cA cK c1 caddc co cn cA
      csn cxp fvconst cn cA cX fconstg cK peano2nn syl2an 3adant1 eqcomd
      opreq12d 3eqtr4d 3expia cG cgr wcel cA cX wcel cK cc0 wceq cA cK c1 caddc
      co cP co cA cK cP co cA cG co wceq cG cgr wcel cA cX wcel cK cc0 wceq w3a
      cA cK c1 caddc co cP co cA cK cP co cA cG co wceq cA c1 cP co cA cc0 cP
      co cA cG co wceq cG cgr wcel cA cX wcel cA c1 cP co cA cc0 cP co cA cG co
      wceq cK cc0 wceq cG cgr wcel cA cX wcel wa cA c1 cP co cA cA cc0 cP co cA
      cG co cA cP cG cX gxnn0suc.1 gxnn0suc.2 gx1 cG cgr wcel cA cX wcel wa cA
      cc0 cP co cA cG co cG cgi cfv cA cG co cA cG cgr wcel cA cX wcel wa cA
      cc0 cP co cG cgi cfv cA cG cA cP cG cgi cfv cG cX gxnn0suc.1 cG cgi cfv
      eqid gxnn0suc.2 gx0 opreq1d cA cG cgi cfv cG cX gxnn0suc.1 cG cgi cfv
      eqid grplid eqtrd eqtr4d 3adant3 cK cc0 wceq cG cgr wcel cA cK c1 caddc
      co cP co cA cK cP co cA cG co wceq cA c1 cP co cA cc0 cP co cA cG co wceq
      wb cA cX wcel cK cc0 wceq cA cK c1 caddc co cP co cA c1 cP co cA cK cP co
      cA cG co cA cc0 cP co cA cG co cK cc0 wceq cK c1 caddc co c1 cA cP cK cc0
      wceq cK c1 caddc co cc0 c1 caddc co c1 cK cc0 c1 caddc opreq1 c1 ax1cn
      addid2i syl6eq opreq2d cK cc0 wceq cA cK cP co cA cc0 cP co cA cG cK cc0
      cA cP opreq2 opreq1d eqeq12d 3ad2ant3 mpbird 3expia jaod cK elnn0 syl5ib
      3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( Closure of the group power operator.  (Contributed by Paul Chapman,
       17-Apr-2009.) $)
    gxcl $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) -> ( A P K ) e. X ) $=
      cG cgr wcel cA cX wcel cK cz wcel cA cK cP co cX wcel cA vm cv cP co cX
      wcel cA cc0 cP co cX wcel cA vk cv cP co cX wcel cA vk cv cneg cP co cX
      wcel cA vk cv c1 caddc co cP co cX wcel vm vk cK cA cK cP co cX wcel cG
      cgr wcel cA cX wcel wa vm cv cc0 wceq cA vm cv cP co cA cc0 cP co cX vm
      cv cc0 cA cP opreq2 eleq1d vm cv vk cv wceq cA vm cv cP co cA vk cv cP co
      cX vm cv vk cv cA cP opreq2 eleq1d vm cv vk cv c1 caddc co wceq cA vm cv
      cP co cA vk cv c1 caddc co cP co cX vm cv vk cv c1 caddc co cA cP opreq2
      eleq1d vm cv vk cv cneg wceq cA vm cv cP co cA vk cv cneg cP co cX vm cv
      vk cv cneg cA cP opreq2 eleq1d vm cv cK wceq cA vm cv cP co cA cK cP co
      cX vm cv cK cA cP opreq2 eleq1d cG cgr wcel cA cX wcel wa cA cc0 cP co cG
      cgi cfv cX cA cP cG cgi cfv cG cX gxnn0suc.1 cG cgi cfv eqid gxnn0suc.2
      gx0 cG cgr wcel cG cgi cfv cX wcel cA cX wcel cG cgi cfv cG cX gxnn0suc.1
      cG cgi cfv eqid grpidcl adantr eqeltrd cG cgr wcel cA cX wcel vk cv cn0
      wcel cA vk cv cP co cX wcel cA vk cv c1 caddc co cP co cX wcel wi cG cgr
      wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv cP co cX wcel cA vk cv cP co
      cA cG co cX wcel cA vk cv c1 caddc co cP co cX wcel cG cgr wcel cA cX
      wcel cA vk cv cP co cX wcel cA vk cv cP co cA cG co cX wcel wi vk cv cn0
      wcel cG cgr wcel cA cX wcel cA vk cv cP co cX wcel cA vk cv cP co cA cG
      co cX wcel cG cgr wcel cA vk cv cP co cX wcel cA cX wcel cA vk cv cP co
      cA cG co cX wcel cA vk cv cP co cA cG cX gxnn0suc.1 grpcl 3com23 3expia
      3adant3 cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv c1 caddc co cP
      co cA vk cv cP co cA cG co cX cA cP cG vk cv cX gxnn0suc.1 gxnn0suc.2
      gxnn0suc eleq1d sylibrd 3expia cG cgr wcel cA cX wcel vk cv cn wcel cA vk
      cv cP co cX wcel cA vk cv cneg cP co cX wcel wi cG cgr wcel cA cX wcel vk
      cv cn wcel w3a cA vk cv cP co cX wcel cA vk cv cneg cP co cX wcel cG cgr
      wcel cA cX wcel vk cv cn wcel w3a cA vk cv cP co cX wcel wa cA vk cv cneg
      cP co cA vk cv cP co cG cgn cfv cfv cX cG cgr wcel cA cX wcel vk cv cn
      wcel w3a cA vk cv cneg cP co cA vk cv cP co cG cgn cfv cfv wceq cA vk cv
      cP co cX wcel cG cgr wcel cA cX wcel vk cv cn0 wcel cA vk cv cneg cP co
      cA vk cv cP co cG cgn cfv cfv wceq vk cv cn wcel cA cP cG vk cv cG cgn
      cfv cX gxnn0suc.1 cG cgn cfv eqid gxnn0suc.2 gxnn0neg vk cv nnnn0 syl3an3
      adantr cG cgr wcel cA cX wcel cA vk cv cP co cX wcel cA vk cv cP co cG
      cgn cfv cfv cX wcel vk cv cn wcel cA vk cv cP co cG cG cgn cfv cX
      gxnn0suc.1 cG cgn cfv eqid grpinvcl 3ad2antl1 eqeltrd ex 3expia zindd
      3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxneg.1 $e |- X = ran G $.
    gxneg.2 $e |- N = ( inv ` G ) $.
    gxneg.3 $e |- P = ( ^g ` G ) $.
    $( A negative group power is the inverse of the positive power.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxneg $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) ->
                     ( A P -u K ) = ( N ` ( A P K ) ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel w3a cK cn0 wcel cK cneg cn0 wcel wo cA
      cK cneg cP co cA cK cP co cN cfv wceq cK cz wcel cG cgr wcel cK cn0 wcel
      cK cneg cn0 wcel wo cA cX wcel cK cz wcel cK cr wcel cK cn0 wcel cK cneg
      cn0 wcel wo cK elznn0 pm3.27bi 3ad2ant3 cG cgr wcel cA cX wcel cK cz wcel
      w3a cK cn0 wcel cA cK cneg cP co cA cK cP co cN cfv wceq cK cneg cn0 wcel
      cG cgr wcel cA cX wcel cK cz wcel cK cn0 wcel cA cK cneg cP co cA cK cP
      co cN cfv wceq wi cG cgr wcel cA cX wcel wa cK cz wcel cK cn0 wcel cA cK
      cneg cP co cA cK cP co cN cfv wceq cG cgr wcel cA cX wcel cK cz wcel cK
      cn0 wcel wa cA cK cneg cP co cA cK cP co cN cfv wceq cG cgr wcel cA cX
      wcel cK cn0 wcel cA cK cneg cP co cA cK cP co cN cfv wceq cK cz wcel cA
      cP cG cK cN cX gxneg.1 gxneg.2 gxneg.3 gxnn0neg 3adant3l 3expia exp3a
      3impia cG cgr wcel cA cX wcel cK cz wcel cK cneg cn0 wcel cA cK cneg cP
      co cA cK cP co cN cfv wceq wi cG cgr wcel cA cX wcel wa cK cz wcel cK
      cneg cn0 wcel cA cK cneg cP co cA cK cP co cN cfv wceq cG cgr wcel cA cX
      wcel cK cz wcel cK cneg cn0 wcel wa cA cK cneg cP co cA cK cP co cN cfv
      wceq cG cgr wcel cA cX wcel cK cz wcel cK cneg cn0 wcel wa w3a cA cK cneg
      cP co cN cfv cN cfv cA cK cneg cP co cA cK cP co cN cfv cG cgr wcel cA cK
      cneg cP co cX wcel cA cK cneg cP co cN cfv cN cfv cA cK cneg cP co wceq
      cG cgr wcel cA cX wcel cK cz wcel cK cneg cn0 wcel wa w3a cA cK cneg cP
      co cG cN cX gxneg.1 gxneg.2 grp2inv cG cgr wcel cA cX wcel cK cz wcel cK
      cneg cn0 wcel wa 3simp1 cG cgr wcel cA cX wcel cK cz wcel cA cK cneg cP
      co cX wcel cK cneg cn0 wcel cG cgr wcel cA cX wcel cK cneg cz wcel cA cK
      cneg cP co cX wcel cK cz wcel cA cP cG cK cneg cX gxneg.1 gxneg.3 gxcl cK
      znegcl syl3an3 3adant3r sylanc cG cgr wcel cA cX wcel cK cz wcel cK cneg
      cn0 wcel wa w3a cA cK cneg cP co cN cfv cA cK cP co cN cG cgr wcel cA cX
      wcel cK cz wcel cK cneg cn0 wcel wa w3a cA cK cneg cneg cP co cA cK cneg
      cP co cN cfv cA cK cP co cG cgr wcel cA cX wcel cK cneg cn0 wcel cA cK
      cneg cneg cP co cA cK cneg cP co cN cfv wceq cK cz wcel cA cP cG cK cneg
      cN cX gxneg.1 gxneg.2 gxneg.3 gxnn0neg 3adant3l cG cgr wcel cA cX wcel cK
      cz wcel cK cneg cn0 wcel wa w3a cK cz wcel cK cc wcel cA cK cneg cneg cP
      co cA cK cP co wceq cK cz wcel cK cneg cn0 wcel wa cG cgr wcel cK cz wcel
      cA cX wcel cK cz wcel cK cneg cn0 wcel pm3.26 3ad2ant3 cK zcn cK cc wcel
      cK cneg cneg cK cA cP cK negneg opreq2d 3syl eqtr3d fveq2d eqtr3d 3expia
      exp3a 3impia jaod mpd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( The inverse of a negative group power is the positive power.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxneg2 $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) ->
                   ( N ` ( A P -u K ) ) = ( A P K ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel w3a cA cK cneg cP co cN cfv cA cK cP co
      cN cfv cN cfv cA cK cP co cG cgr wcel cA cX wcel cK cz wcel w3a cA cK
      cneg cP co cA cK cP co cN cfv cN cA cP cG cK cN cX gxneg.1 gxneg.2
      gxneg.3 gxneg fveq2d cG cgr wcel cA cK cP co cX wcel cA cK cP co cN cfv
      cN cfv cA cK cP co wceq cG cgr wcel cA cX wcel cK cz wcel w3a cA cK cP co
      cG cN cX gxneg.1 gxneg.2 grp2inv cG cgr wcel cA cX wcel cK cz wcel 3simp1
      cA cP cG cK cX gxneg.1 gxneg.3 gxcl sylanc eqtrd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( The result of the group power operator when the exponent is minus one.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxm1 $p |- ( ( G e. Grp /\ A e. X ) -> ( A P -u 1 ) = ( N ` A ) ) $=
      cG cgr wcel cA cX wcel wa cA c1 cneg cP co cA c1 cP co cN cfv cA cN cfv
      cG cgr wcel cA cX wcel c1 cz wcel cA c1 cneg cP co cA c1 cP co cN cfv
      wceq 1z cA cP cG c1 cN cX gxneg.1 gxneg.2 gxneg.3 gxneg mp3an3 cG cgr
      wcel cA cX wcel wa cA c1 cP co cA cN cA cP cG cX gxneg.1 gxneg.3 gx1
      fveq2d eqtrd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d A k m $.  $d G k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxcom.1 $e |- X = ran G $.
    gxcom.2 $e |- P = ( ^g ` G ) $.
    $( The group power operator commutes with the group operation.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxcom $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) ->
                  ( ( A P K ) G A ) = ( A G ( A P K ) ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel cA cK cP co cA cG co cA cA cK cP co cG
      co wceq cA vm cv cP co cA cG co cA cA vm cv cP co cG co wceq cA cc0 cP co
      cA cG co cA cA cc0 cP co cG co wceq cA vk cv cP co cA cG co cA cA vk cv
      cP co cG co wceq cA vk cv cneg cP co cA cG co cA cA vk cv cneg cP co cG
      co wceq cA vk cv c1 caddc co cP co cA cG co cA cA vk cv c1 caddc co cP co
      cG co wceq vm vk cK cA cK cP co cA cG co cA cA cK cP co cG co wceq cG cgr
      wcel cA cX wcel wa vm cv cc0 wceq cA vm cv cP co cA cG co cA cc0 cP co cA
      cG co cA cA vm cv cP co cG co cA cA cc0 cP co cG co vm cv cc0 wceq cA vm
      cv cP co cA cc0 cP co cA cG vm cv cc0 cA cP opreq2 opreq1d vm cv cc0 wceq
      cA vm cv cP co cA cc0 cP co cA cG vm cv cc0 cA cP opreq2 opreq2d eqeq12d
      vm cv vk cv wceq cA vm cv cP co cA cG co cA vk cv cP co cA cG co cA cA vm
      cv cP co cG co cA cA vk cv cP co cG co vm cv vk cv wceq cA vm cv cP co cA
      vk cv cP co cA cG vm cv vk cv cA cP opreq2 opreq1d vm cv vk cv wceq cA vm
      cv cP co cA vk cv cP co cA cG vm cv vk cv cA cP opreq2 opreq2d eqeq12d vm
      cv vk cv c1 caddc co wceq cA vm cv cP co cA cG co cA vk cv c1 caddc co cP
      co cA cG co cA cA vm cv cP co cG co cA cA vk cv c1 caddc co cP co cG co
      vm cv vk cv c1 caddc co wceq cA vm cv cP co cA vk cv c1 caddc co cP co cA
      cG vm cv vk cv c1 caddc co cA cP opreq2 opreq1d vm cv vk cv c1 caddc co
      wceq cA vm cv cP co cA vk cv c1 caddc co cP co cA cG vm cv vk cv c1 caddc
      co cA cP opreq2 opreq2d eqeq12d vm cv vk cv cneg wceq cA vm cv cP co cA
      cG co cA vk cv cneg cP co cA cG co cA cA vm cv cP co cG co cA cA vk cv
      cneg cP co cG co vm cv vk cv cneg wceq cA vm cv cP co cA vk cv cneg cP co
      cA cG vm cv vk cv cneg cA cP opreq2 opreq1d vm cv vk cv cneg wceq cA vm
      cv cP co cA vk cv cneg cP co cA cG vm cv vk cv cneg cA cP opreq2 opreq2d
      eqeq12d vm cv cK wceq cA vm cv cP co cA cG co cA cK cP co cA cG co cA cA
      vm cv cP co cG co cA cA cK cP co cG co vm cv cK wceq cA vm cv cP co cA cK
      cP co cA cG vm cv cK cA cP opreq2 opreq1d vm cv cK wceq cA vm cv cP co cA
      cK cP co cA cG vm cv cK cA cP opreq2 opreq2d eqeq12d cG cgr wcel cA cX
      wcel wa cA cc0 cP co cA cG co cA cA cA cc0 cP co cG co cG cgr wcel cA cX
      wcel wa cA cc0 cP co cA cG co cG cgi cfv cA cG co cA cG cgr wcel cA cX
      wcel wa cA cc0 cP co cG cgi cfv cA cG cA cP cG cgi cfv cG cX gxcom.1 cG
      cgi cfv eqid gxcom.2 gx0 opreq1d cA cG cgi cfv cG cX gxcom.1 cG cgi cfv
      eqid grplid eqtrd cG cgr wcel cA cX wcel wa cA cA cc0 cP co cG co cA cG
      cgi cfv cG co cA cG cgr wcel cA cX wcel wa cA cc0 cP co cG cgi cfv cA cG
      cA cP cG cgi cfv cG cX gxcom.1 cG cgi cfv eqid gxcom.2 gx0 opreq2d cA cG
      cgi cfv cG cX gxcom.1 cG cgi cfv eqid grprid eqtrd eqtr4d cG cgr wcel cA
      cX wcel vk cv cn0 wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq cA vk cv c1 caddc co cP co cA cG co cA cA vk cv c1 caddc co cP co cG
      co wceq wi cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv cP co cA cG
      co cA cA vk cv cP co cG co wceq cA vk cv c1 caddc co cP co cA cG co cA cA
      vk cv c1 caddc co cP co cG co wceq cG cgr wcel cA cX wcel vk cv cn0 wcel
      w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cA vk cv
      cP co cG co cA cG co cA cA vk cv cP co cA cG co cG co cA vk cv c1 caddc
      co cP co cA cG co cA cA vk cv c1 caddc co cP co cG co cG cgr wcel cA cX
      wcel vk cv cn0 wcel w3a cA cA vk cv cP co cG co cA cG co cA cA vk cv cP
      co cA cG co cG co wceq cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq cG cgr wcel cA cX wcel vk cv cz wcel cA cA vk cv cP co cG co cA cG
      co cA cA vk cv cP co cA cG co cG co wceq vk cv cn0 wcel cG cgr wcel cA cX
      wcel cA vk cv cP co cX wcel cA cX wcel w3a cA cA vk cv cP co cG co cA cG
      co cA cA vk cv cP co cA cG co cG co wceq cG cgr wcel cA cX wcel vk cv cz
      wcel w3a cA cA vk cv cP co cA cG cX gxcom.1 grpass cG cgr wcel cA cX wcel
      vk cv cz wcel 3simp1 cG cgr wcel cA cX wcel vk cv cz wcel w3a cA cX wcel
      cA vk cv cP co cX wcel cA cX wcel cG cgr wcel cA cX wcel vk cv cz wcel
      3simp2 cA cP cG vk cv cX gxcom.1 gxcom.2 gxcl cG cgr wcel cA cX wcel vk
      cv cz wcel 3simp2 3jca sylanc vk cv nn0z syl3an3 adantr cG cgr wcel cA cX
      wcel vk cv cn0 wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq wa cA vk cv c1 caddc co cP co cA cA vk cv cP co cG co cA cG cG cgr
      wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv c1 caddc co cP co cA cA vk cv
      cP co cG co wceq cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq cG
      cgr wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv c1 caddc co cP co cA vk
      cv cP co cA cG co cA cA vk cv cP co cG co cA cP cG vk cv cX gxcom.1
      gxcom.2 gxnn0suc eqeq1d biimpar opreq1d cG cgr wcel cA cX wcel vk cv cn0
      wcel w3a cA cA vk cv c1 caddc co cP co cG co cA cA vk cv cP co cA cG co
      cG co wceq cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq cG cgr
      wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv c1 caddc co cP co cA vk cv cP
      co cA cG co cA cG cA cP cG vk cv cX gxcom.1 gxcom.2 gxnn0suc opreq2d
      adantr 3eqtr4d ex 3expia cG cgr wcel cA cX wcel wa vk cv cz wcel cA vk cv
      cP co cA cG co cA cA vk cv cP co cG co wceq cA vk cv cneg cP co cA cG co
      cA cA vk cv cneg cP co cG co wceq wi vk cv cn wcel cG cgr wcel cA cX wcel
      vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq cA vk
      cv cneg cP co cA cG co cA cA vk cv cneg cP co cG co wceq wi cG cgr wcel
      cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG
      co wceq cA vk cv cneg cP co cA cG co cA cA vk cv cneg cP co cG co wceq cG
      cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv
      cP co cG co wceq wa cA cA vk cv cneg cP co cG co cA cG cgn cfv cfv cG co
      cA cG co cA vk cv cneg cP co cA cG co cA cA vk cv cneg cP co cG co cG cgr
      wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP
      co cG co wceq wa cA cA vk cv cneg cP co cG co cA cG cgn cfv cfv cG co cA
      vk cv cneg cP co cA cG cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv
      cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cA vk cv cneg cP co cG
      co cA cG cgn cfv cfv cG co cA cA vk cv cneg cP co cA cG cgn cfv cfv cG co
      cG co cA cA cG cgn cfv cfv cA vk cv cneg cP co cG co cG co cA vk cv cneg
      cP co cG cgr wcel cA cX wcel cA vk cv cneg cP co cX wcel cA cG cgn cfv
      cfv cX wcel w3a cA cA vk cv cneg cP co cG co cA cG cgn cfv cfv cG co cA
      cA vk cv cneg cP co cA cG cgn cfv cfv cG co cG co wceq cG cgr wcel cA cX
      wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq wa cA cA vk cv cneg cP co cA cG cgn cfv cfv cG cX gxcom.1 grpass cG
      cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP
      co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv
      cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cX wcel cA vk cv cneg
      cP co cX wcel cA cG cgn cfv cfv cX wcel cG cgr wcel cA cX wcel vk cv cz
      wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl2 cG cgr
      wcel cA cX wcel vk cv cz wcel cA vk cv cneg cP co cX wcel cG cgr wcel cA
      cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq wa cG cgr wcel cA cX wcel vk cv cneg cz wcel cA vk cv cneg cP co cX
      wcel vk cv cz wcel cA cP cG vk cv cneg cX gxcom.1 gxcom.2 gxcl vk cv
      znegcl syl3an3 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG
      co cA cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz
      wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl2 cG cgr
      wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co
      cG co wceq 3simpl3 syl3anc cG cgr wcel cA cX wcel cA cG cgn cfv cfv cX
      wcel cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA
      cA vk cv cP co cG co wceq wa cA cG cG cgn cfv cX gxcom.1 cG cgn cfv eqid
      grpinvcl cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA
      cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl2 sylanc 3jca
      sylanc cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co
      cA cA vk cv cP co cG co wceq wa cA vk cv cneg cP co cA cG cgn cfv cfv cG
      co cA cG cgn cfv cfv cA vk cv cneg cP co cG co cA cG cG cgr wcel cA cX
      wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq wa cA vk cv cP co cA cG co cG cgn cfv cfv cA cA vk cv cP co cG co cG
      cgn cfv cfv cA cG cgn cfv cfv cA vk cv cneg cP co cG co cA vk cv cneg cP
      co cA cG cgn cfv cfv cG co cA vk cv cP co cA cG co cA cA vk cv cP co cG
      co wceq cA vk cv cP co cA cG co cG cgn cfv cfv cA cA vk cv cP co cG co cG
      cgn cfv cfv wceq cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co
      cA cG co cA cA vk cv cP co cG co cG cgn cfv fveq2 adantl cG cgr wcel cA
      cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq wa cA vk cv cP co cA cG co cG cgn cfv cfv cA cG cgn cfv cfv cA vk cv
      cP co cG cgn cfv cfv cG co cA cG cgn cfv cfv cA vk cv cneg cP co cG co cG
      cgr wcel cA vk cv cP co cX wcel cA cX wcel cA vk cv cP co cA cG co cG cgn
      cfv cfv cA cG cgn cfv cfv cA vk cv cP co cG cgn cfv cfv cG co wceq cG cgr
      wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP
      co cG co wceq wa cA vk cv cP co cA cG cG cgn cfv cX gxcom.1 cG cgn cfv
      eqid grpinvop cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG
      co cA cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz
      wcel cA vk cv cP co cX wcel cG cgr wcel cA cX wcel vk cv cz wcel w3a cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cP cG vk cv cX
      gxcom.1 gxcom.2 gxcl cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co
      cA cG co cA cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk
      cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl2
      cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv
      cP co cG co wceq 3simpl3 syl3anc cG cgr wcel cA cX wcel vk cv cz wcel cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl2 syl3anc cG cgr
      wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP
      co cG co wceq wa cA vk cv cneg cP co cA vk cv cP co cG cgn cfv cfv cA cG
      cgn cfv cfv cG cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cneg cP co
      cA vk cv cP co cG cgn cfv cfv wceq cG cgr wcel cA cX wcel vk cv cz wcel
      w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cP cG vk
      cv cG cgn cfv cX gxcom.1 cG cgn cfv eqid gxcom.2 gxneg cG cgr wcel cA cX
      wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq
      3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA
      cA vk cv cP co cG co wceq 3simpl2 cG cgr wcel cA cX wcel vk cv cz wcel cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl3 syl3anc opreq2d
      eqtr4d cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co
      cA cA vk cv cP co cG co wceq wa cA cA vk cv cP co cG co cG cgn cfv cfv cA
      vk cv cP co cG cgn cfv cfv cA cG cgn cfv cfv cG co cA vk cv cneg cP co cA
      cG cgn cfv cfv cG co cG cgr wcel cA cX wcel cA vk cv cP co cX wcel cA cA
      vk cv cP co cG co cG cgn cfv cfv cA vk cv cP co cG cgn cfv cfv cA cG cgn
      cfv cfv cG co wceq cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP
      co cA cG co cA cA vk cv cP co cG co wceq wa cA cA vk cv cP co cG cG cgn
      cfv cX gxcom.1 cG cgn cfv eqid grpinvop cG cgr wcel cA cX wcel vk cv cz
      wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl1 cG cgr
      wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co
      cG co wceq 3simpl2 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cX
      wcel cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA
      cA vk cv cP co cG co wceq wa cA cP cG vk cv cX gxcom.1 gxcom.2 gxcl cG
      cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP
      co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co
      cA cG co cA cA vk cv cP co cG co wceq 3simpl2 cG cgr wcel cA cX wcel vk
      cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl3
      syl3anc syl3anc cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co
      cA cG co cA cA vk cv cP co cG co wceq wa cA vk cv cneg cP co cA vk cv cP
      co cG cgn cfv cfv cA cG cgn cfv cfv cG cG cgr wcel cA cX wcel vk cv cz
      wcel cA vk cv cneg cP co cA vk cv cP co cG cgn cfv cfv wceq cG cgr wcel
      cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG
      co wceq wa cA cP cG vk cv cG cgn cfv cX gxcom.1 cG cgn cfv eqid gxcom.2
      gxneg cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA
      vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel cA vk
      cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl2 cG cgr wcel cA cX
      wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq
      3simpl3 syl3anc opreq1d eqtr4d 3eqtr3rd opreq2d cG cgr wcel cA cX wcel cA
      vk cv cneg cP co cX wcel cA cA cG cgn cfv cfv cA vk cv cneg cP co cG co
      cG co cA vk cv cneg cP co wceq cG cgr wcel cA cX wcel vk cv cz wcel w3a
      cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cA vk cv cneg
      cP co cG cG cgn cfv cX gxcom.1 cG cgn cfv eqid grpasscan1 cG cgr wcel cA
      cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co
      cA cA vk cv cP co cG co wceq 3simpl2 cG cgr wcel cA cX wcel vk cv cz wcel
      cA vk cv cneg cP co cX wcel cG cgr wcel cA cX wcel vk cv cz wcel w3a cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cG cgr wcel cA cX
      wcel vk cv cneg cz wcel cA vk cv cneg cP co cX wcel vk cv cz wcel cA cP
      cG vk cv cneg cX gxcom.1 gxcom.2 gxcl vk cv znegcl syl3an3 cG cgr wcel cA
      cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq 3simpl1 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co
      cA cA vk cv cP co cG co wceq 3simpl2 cG cgr wcel cA cX wcel vk cv cz wcel
      cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl3 syl3anc
      syl3anc 3eqtrd opreq1d cG cgr wcel cA cA vk cv cneg cP co cG co cX wcel
      cA cX wcel cA cA vk cv cneg cP co cG co cA cG cgn cfv cfv cG co cA cG co
      cA cA vk cv cneg cP co cG co wceq cG cgr wcel cA cX wcel vk cv cz wcel
      w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cA vk cv
      cneg cP co cG co cA cG cG cgn cfv cX gxcom.1 cG cgn cfv eqid grpasscan2
      cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv
      cP co cG co wceq 3simpl1 cG cgr wcel cA cX wcel cA vk cv cneg cP co cX
      wcel cA cA vk cv cneg cP co cG co cX wcel cG cgr wcel cA cX wcel vk cv cz
      wcel w3a cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq wa cA cA vk
      cv cneg cP co cG cX gxcom.1 grpcl cG cgr wcel cA cX wcel vk cv cz wcel cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA
      cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq 3simpl2 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cneg cP co cX
      wcel cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv cP co cA cG co cA
      cA vk cv cP co cG co wceq wa cG cgr wcel cA cX wcel vk cv cneg cz wcel cA
      vk cv cneg cP co cX wcel vk cv cz wcel cA cP cG vk cv cneg cX gxcom.1
      gxcom.2 gxcl vk cv znegcl syl3an3 cG cgr wcel cA cX wcel vk cv cz wcel cA
      vk cv cP co cA cG co cA cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel cA
      cX wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co
      wceq 3simpl2 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cA cG co
      cA cA vk cv cP co cG co wceq 3simpl3 syl3anc syl3anc cG cgr wcel cA cX
      wcel vk cv cz wcel cA vk cv cP co cA cG co cA cA vk cv cP co cG co wceq
      3simpl2 syl3anc eqtr3d ex 3expia vk cv nnz syl5 zindd 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d A k m $.  $d G k m $.  $d K k m $.  $d N k m $.  $d P k m $.
    $d X k m $.
    gxinv.1 $e |- X = ran G $.
    gxinv.2 $e |- N = ( inv ` G ) $.
    gxinv.3 $e |- P = ( ^g ` G ) $.
    $( The group power operator commutes with the group inverse function.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxinv $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) ->
                  ( ( N ` A ) P K ) = ( N ` ( A P K ) ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel cA cN cfv cK cP co cA cK cP co cN cfv
      wceq cA cN cfv vm cv cP co cA vm cv cP co cN cfv wceq cA cN cfv cc0 cP co
      cA cc0 cP co cN cfv wceq cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq
      cA cN cfv vk cv cneg cP co cA vk cv cneg cP co cN cfv wceq cA cN cfv vk
      cv c1 caddc co cP co cA vk cv c1 caddc co cP co cN cfv wceq vm vk cK cA
      cN cfv cK cP co cA cK cP co cN cfv wceq cG cgr wcel cA cX wcel wa vm cv
      cc0 wceq cA cN cfv vm cv cP co cA cN cfv cc0 cP co cA vm cv cP co cN cfv
      cA cc0 cP co cN cfv vm cv cc0 cA cN cfv cP opreq2 vm cv cc0 wceq cA vm cv
      cP co cA cc0 cP co cN vm cv cc0 cA cP opreq2 fveq2d eqeq12d vm cv vk cv
      wceq cA cN cfv vm cv cP co cA cN cfv vk cv cP co cA vm cv cP co cN cfv cA
      vk cv cP co cN cfv vm cv vk cv cA cN cfv cP opreq2 vm cv vk cv wceq cA vm
      cv cP co cA vk cv cP co cN vm cv vk cv cA cP opreq2 fveq2d eqeq12d vm cv
      vk cv c1 caddc co wceq cA cN cfv vm cv cP co cA cN cfv vk cv c1 caddc co
      cP co cA vm cv cP co cN cfv cA vk cv c1 caddc co cP co cN cfv vm cv vk cv
      c1 caddc co cA cN cfv cP opreq2 vm cv vk cv c1 caddc co wceq cA vm cv cP
      co cA vk cv c1 caddc co cP co cN vm cv vk cv c1 caddc co cA cP opreq2
      fveq2d eqeq12d vm cv vk cv cneg wceq cA cN cfv vm cv cP co cA cN cfv vk
      cv cneg cP co cA vm cv cP co cN cfv cA vk cv cneg cP co cN cfv vm cv vk
      cv cneg cA cN cfv cP opreq2 vm cv vk cv cneg wceq cA vm cv cP co cA vk cv
      cneg cP co cN vm cv vk cv cneg cA cP opreq2 fveq2d eqeq12d vm cv cK wceq
      cA cN cfv vm cv cP co cA cN cfv cK cP co cA vm cv cP co cN cfv cA cK cP
      co cN cfv vm cv cK cA cN cfv cP opreq2 vm cv cK wceq cA vm cv cP co cA cK
      cP co cN vm cv cK cA cP opreq2 fveq2d eqeq12d cG cgr wcel cA cX wcel wa
      cG cgi cfv cN cfv cG cgi cfv cA cc0 cP co cN cfv cA cN cfv cc0 cP co cG
      cgr wcel cG cgi cfv cN cfv cG cgi cfv wceq cA cX wcel cG cgi cfv cG cN cG
      cgi cfv eqid gxinv.2 grpinvid adantr cG cgr wcel cA cX wcel wa cA cc0 cP
      co cG cgi cfv cN cA cP cG cgi cfv cG cX gxinv.1 cG cgi cfv eqid gxinv.3
      gx0 fveq2d cG cgr wcel cA cX wcel cA cN cfv cX wcel cA cN cfv cc0 cP co
      cG cgi cfv wceq cA cG cN cX gxinv.1 gxinv.2 grpinvcl cA cN cfv cP cG cgi
      cfv cG cX gxinv.1 cG cgi cfv eqid gxinv.3 gx0 syldan 3eqtr4rd cG cgr wcel
      cA cX wcel vk cv cn0 wcel cA cN cfv vk cv cP co cA vk cv cP co cN cfv
      wceq cA cN cfv vk cv c1 caddc co cP co cA vk cv c1 caddc co cP co cN cfv
      wceq wi cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA cN cfv vk cv cP co
      cA vk cv cP co cN cfv wceq cA cN cfv vk cv c1 caddc co cP co cA vk cv c1
      caddc co cP co cN cfv wceq cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA
      cN cfv vk cv cP co cA vk cv cP co cN cfv wceq wa cA cN cfv cA cN cfv vk
      cv cP co cG co cA cN cfv cA vk cv cP co cN cfv cG co cA cN cfv vk cv c1
      caddc co cP co cA vk cv c1 caddc co cP co cN cfv cA cN cfv vk cv cP co cA
      vk cv cP co cN cfv wceq cA cN cfv cA cN cfv vk cv cP co cG co cA cN cfv
      cA vk cv cP co cN cfv cG co wceq cG cgr wcel cA cX wcel vk cv cn0 wcel
      w3a cA cN cfv vk cv cP co cA vk cv cP co cN cfv cA cN cfv cG opreq2
      adantl cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA cN cfv vk cv c1 caddc
      co cP co cA cN cfv cA cN cfv vk cv cP co cG co wceq cA cN cfv vk cv cP co
      cA vk cv cP co cN cfv wceq cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA
      cN cfv vk cv c1 caddc co cP co cA cN cfv vk cv cP co cA cN cfv cG co cA
      cN cfv cA cN cfv vk cv cP co cG co cG cgr wcel cA cN cfv cX wcel vk cv
      cn0 wcel cA cN cfv vk cv c1 caddc co cP co cA cN cfv vk cv cP co cA cN
      cfv cG co wceq cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA cN cfv cP cG
      vk cv cX gxinv.1 gxinv.3 gxnn0suc cG cgr wcel cA cX wcel vk cv cn0 wcel
      3simp1 cG cgr wcel cA cX wcel cA cN cfv cX wcel vk cv cn0 wcel cA cG cN
      cX gxinv.1 gxinv.2 grpinvcl 3adant3 cG cgr wcel cA cX wcel vk cv cn0 wcel
      3simp3 syl3anc cG cgr wcel cA cN cfv cX wcel vk cv cn0 wcel cA cN cfv vk
      cv cP co cA cN cfv cG co cA cN cfv cA cN cfv vk cv cP co cG co wceq cG
      cgr wcel cA cX wcel vk cv cn0 wcel w3a cG cgr wcel cA cN cfv cX wcel vk
      cv cz wcel cA cN cfv vk cv cP co cA cN cfv cG co cA cN cfv cA cN cfv vk
      cv cP co cG co wceq vk cv cn0 wcel cA cN cfv cP cG vk cv cX gxinv.1
      gxinv.3 gxcom vk cv nn0z syl3an3 cG cgr wcel cA cX wcel vk cv cn0 wcel
      3simp1 cG cgr wcel cA cX wcel cA cN cfv cX wcel vk cv cn0 wcel cA cG cN
      cX gxinv.1 gxinv.2 grpinvcl 3adant3 cG cgr wcel cA cX wcel vk cv cn0 wcel
      3simp3 syl3anc eqtrd adantr cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA
      vk cv c1 caddc co cP co cN cfv cA cN cfv cA vk cv cP co cN cfv cG co wceq
      cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq cG cgr wcel cA cX wcel
      vk cv cn0 wcel w3a cA vk cv c1 caddc co cP co cN cfv cA vk cv cP co cA cG
      co cN cfv cA cN cfv cA vk cv cP co cN cfv cG co cG cgr wcel cA cX wcel vk
      cv cn0 wcel w3a cA vk cv c1 caddc co cP co cA vk cv cP co cA cG co cN cA
      cP cG vk cv cX gxinv.1 gxinv.3 gxnn0suc fveq2d cG cgr wcel cA vk cv cP co
      cX wcel cA cX wcel cA vk cv cP co cA cG co cN cfv cA cN cfv cA vk cv cP
      co cN cfv cG co wceq cG cgr wcel cA cX wcel vk cv cn0 wcel w3a cA vk cv
      cP co cA cG cN cX gxinv.1 gxinv.2 grpinvop cG cgr wcel cA cX wcel vk cv
      cn0 wcel 3simp1 cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cX
      wcel vk cv cn0 wcel cA cP cG vk cv cX gxinv.1 gxinv.3 gxcl vk cv nn0z
      syl3an3 cG cgr wcel cA cX wcel vk cv cn0 wcel 3simp2 syl3anc eqtrd adantr
      3eqtr4d ex 3expia cG cgr wcel cA cX wcel wa vk cv cz wcel cA cN cfv vk cv
      cP co cA vk cv cP co cN cfv wceq cA cN cfv vk cv cneg cP co cA vk cv cneg
      cP co cN cfv wceq wi vk cv cn wcel cG cgr wcel cA cX wcel vk cv cz wcel
      cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq cA cN cfv vk cv cneg cP
      co cA vk cv cneg cP co cN cfv wceq wi cG cgr wcel cA cX wcel vk cv cz
      wcel w3a cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq cA cN cfv vk cv
      cneg cP co cA vk cv cneg cP co cN cfv wceq cG cgr wcel cA cX wcel vk cv
      cz wcel w3a cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq wa cA cN cfv
      vk cv cneg cP co cA cN cfv vk cv cP co cN cfv cA vk cv cneg cP co cN cfv
      cG cgr wcel cA cX wcel vk cv cz wcel w3a cA cN cfv vk cv cneg cP co cA cN
      cfv vk cv cP co cN cfv wceq cA cN cfv vk cv cP co cA vk cv cP co cN cfv
      wceq cG cgr wcel cA cN cfv cX wcel vk cv cz wcel cA cN cfv vk cv cneg cP
      co cA cN cfv vk cv cP co cN cfv wceq cG cgr wcel cA cX wcel vk cv cz wcel
      w3a cA cN cfv cP cG vk cv cN cX gxinv.1 gxinv.2 gxinv.3 gxneg cG cgr wcel
      cA cX wcel vk cv cz wcel 3simp1 cG cgr wcel cA cX wcel cA cN cfv cX wcel
      vk cv cz wcel cA cG cN cX gxinv.1 gxinv.2 grpinvcl 3adant3 cG cgr wcel cA
      cX wcel vk cv cz wcel 3simp3 syl3anc adantr cG cgr wcel cA cX wcel vk cv
      cz wcel w3a cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq wa cA vk cv
      cneg cP co cA cN cfv vk cv cP co cN cG cgr wcel cA cX wcel vk cv cz wcel
      w3a cA cN cfv vk cv cP co cA vk cv cP co cN cfv wceq wa cA vk cv cneg cP
      co cA vk cv cP co cN cfv cA cN cfv vk cv cP co cG cgr wcel cA cX wcel vk
      cv cz wcel w3a cA vk cv cneg cP co cA vk cv cP co cN cfv wceq cA cN cfv
      vk cv cP co cA vk cv cP co cN cfv wceq cA cP cG vk cv cN cX gxinv.1
      gxinv.2 gxinv.3 gxneg adantr cG cgr wcel cA cX wcel vk cv cz wcel w3a cA
      cN cfv vk cv cP co cA vk cv cP co cN cfv wceq pm3.27 eqtr4d fveq2d eqtr4d
      ex 3expia vk cv nnz syl5 zindd 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( The group power operator commutes with the group inverse function.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxinv2 $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) ->
                   ( N ` ( ( N ` A ) P K ) ) = ( A P K ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel w3a cA cN cfv cN cfv cK cP co cA cN cfv
      cK cP co cN cfv cA cK cP co cG cgr wcel cA cN cfv cX wcel cK cz wcel cA
      cN cfv cN cfv cK cP co cA cN cfv cK cP co cN cfv wceq cG cgr wcel cA cX
      wcel cK cz wcel w3a cA cN cfv cP cG cK cN cX gxinv.1 gxinv.2 gxinv.3
      gxinv cG cgr wcel cA cX wcel cK cz wcel 3simp1 cG cgr wcel cA cX wcel cA
      cN cfv cX wcel cK cz wcel cA cG cN cX gxinv.1 gxinv.2 grpinvcl 3adant3 cG
      cgr wcel cA cX wcel cK cz wcel 3simp3 syl3anc cG cgr wcel cA cX wcel cK
      cz wcel w3a cA cN cfv cN cfv cA cK cP cG cgr wcel cA cX wcel cA cN cfv cN
      cfv cA wceq cK cz wcel cA cG cN cX gxinv.1 gxinv.2 grp2inv 3adant3
      opreq1d eqtr3d $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxsuc.1 $e |- X = ran G $.
    gxsuc.2 $e |- P = ( ^g ` G ) $.
    $( Induction on group power.  (Contributed by Paul Chapman,
       17-Apr-2009.) $)
    gxsuc $p |- ( ( G e. Grp /\ A e. X /\ K e. ZZ ) ->
                  ( A P ( K + 1 ) ) = ( ( A P K ) G A ) ) $=
      cG cgr wcel cA cX wcel cK cz wcel w3a cK cn0 wcel cK cneg cn wcel wo cA
      cK c1 caddc co cP co cA cK cP co cA cG co wceq cK cz wcel cG cgr wcel cK
      cn0 wcel cK cneg cn wcel wo cA cX wcel cK cz wcel cK cn0 wcel cK cr wcel
      cK cneg cn wcel wa wo cK cn0 wcel cK cneg cn wcel wo cK cz wcel cK cn0
      wcel cK cr wcel cK cneg cn wcel wa wo cK elznn0nn biimpi cK cr wcel cK
      cneg cn wcel wa cK cneg cn wcel cK cn0 wcel cK cr wcel cK cneg cn wcel
      pm3.27 orim2i syl 3ad2ant3 cG cgr wcel cA cX wcel cK cz wcel w3a cK cn0
      wcel cA cK c1 caddc co cP co cA cK cP co cA cG co wceq cK cneg cn wcel cG
      cgr wcel cA cX wcel cK cn0 wcel cA cK c1 caddc co cP co cA cK cP co cA cG
      co wceq wi cK cz wcel cG cgr wcel cA cX wcel cK cn0 wcel cA cK c1 caddc
      co cP co cA cK cP co cA cG co wceq cA cP cG cK cX gxsuc.1 gxsuc.2
      gxnn0suc 3expia 3adant3 cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel
      cA cK c1 caddc co cP co cA cK cP co cA cG co wceq wi cG cgr wcel cA cX
      wcel wa cK cz wcel cK cneg cn wcel cA cK c1 caddc co cP co cA cK cP co cA
      cG co wceq cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa cA cK c1
      caddc co cP co cA cK cP co cA cG co wceq cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa w3a cA cK cP co cA cG co cA cA cK cP co cG co cA
      cA cG cgn cfv cfv cA cK c1 caddc co cP co cG co cG co cA cK c1 caddc co
      cP co cG cgr wcel cA cX wcel cK cz wcel cA cK cP co cA cG co cA cA cK cP
      co cG co wceq cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cA
      cP cG cK cX gxsuc.1 gxsuc.2 gxcom cG cgr wcel cA cX wcel cK cz wcel cK
      cneg cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel
      wa 3simp2 cK cz wcel cK cneg cn wcel wa cG cgr wcel cK cz wcel cA cX wcel
      cK cz wcel cK cneg cn wcel pm3.26 3ad2ant3 syl3anc cG cgr wcel cA cX wcel
      cK cz wcel cK cneg cn wcel wa w3a cA cG cgn cfv cfv cA cK c1 caddc co cP
      co cG co cA cK cP co cA cG cG cgr wcel cA cX wcel cK cz wcel cK cneg cn
      wcel wa w3a cA cG cgn cfv cfv cA cK c1 caddc co cP co cG cgn cfv cfv cG
      cgn cfv cfv cG co cA cG cgn cfv cfv cA cK c1 caddc co cP co cG co cA cK
      cP co cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cA cK c1
      caddc co cP co cG cgn cfv cfv cG cgn cfv cfv cA cK c1 caddc co cP co cA
      cG cgn cfv cfv cG cG cgr wcel cA cK c1 caddc co cP co cX wcel cA cK c1
      caddc co cP co cG cgn cfv cfv cG cgn cfv cfv cA cK c1 caddc co cP co wceq
      cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cA cK c1 caddc
      co cP co cG cG cgn cfv cX gxsuc.1 cG cgn cfv eqid grp2inv cG cgr wcel cA
      cX wcel cK cz wcel cK cneg cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK c1
      caddc co cz wcel cA cK c1 caddc co cP co cX wcel cG cgr wcel cA cX wcel
      cK cz wcel cK cneg cn wcel wa w3a cA cP cG cK c1 caddc co cX gxsuc.1
      gxsuc.2 gxcl cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp1
      cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp2 cG cgr wcel
      cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cK cz wcel cK c1 caddc co cz
      wcel cK cz wcel cK cneg cn wcel wa cG cgr wcel cK cz wcel cA cX wcel cK
      cz wcel cK cneg cn wcel pm3.26 3ad2ant3 cK peano2z syl syl3anc sylanc
      opreq2d cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cA cK c1
      caddc co cP co cG cgn cfv cfv cA cG co cG cgn cfv cfv cA cK cP co cG cgn
      cfv cfv cG cgn cfv cfv cA cG cgn cfv cfv cA cK c1 caddc co cP co cG cgn
      cfv cfv cG cgn cfv cfv cG co cA cK cP co cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa w3a cA cK c1 caddc co cP co cG cgn cfv cfv cA cG
      co cA cK cP co cG cgn cfv cfv cG cgn cfv cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa w3a cA cK c1 caddc co cP co cG cgn cfv cfv cA cG
      co cA cK cneg cP co cA cK cP co cG cgn cfv cfv cG cgr wcel cA cX wcel cK
      cz wcel cK cneg cn wcel wa w3a cA cK c1 caddc co cneg c1 caddc co cP co
      cA cK c1 caddc co cneg cP co cA cG co cA cK cneg cP co cA cK c1 caddc co
      cP co cG cgn cfv cfv cA cG co cG cgr wcel cA cX wcel cK c1 caddc co cneg
      cn0 wcel cA cK c1 caddc co cneg c1 caddc co cP co cA cK c1 caddc co cneg
      cP co cA cG co wceq cK cz wcel cK cneg cn wcel wa cA cP cG cK c1 caddc co
      cneg cX gxsuc.1 gxsuc.2 gxnn0suc cK cz wcel cK cneg cn wcel wa cK c1
      caddc co cneg cn0 wcel cK cneg c1 cmin co cn0 wcel cK cneg cn wcel cK
      cneg c1 cmin co cn0 wcel cK cz wcel cK cneg cn wcel cK cneg cc wcel cK
      cneg c1 cmin co cn0 wcel cK cneg elnnnn0 pm3.27bi adantl cK cz wcel cK c1
      caddc co cneg cn0 wcel cK cneg c1 cmin co cn0 wcel wb cK cneg cn wcel cK
      cz wcel cK c1 caddc co cneg cK cneg c1 cmin co cn0 cK cz wcel cK c1 caddc
      co cneg cK cneg c1 cneg caddc co cK cneg c1 cmin co cK cc wcel c1 cc wcel
      cK c1 caddc co cneg cK cneg c1 cneg caddc co wceq cK cz wcel cK c1 negdi
      cK zcn ax1cn sylancl cK cz wcel cK cc wcel cK cneg cc wcel cK cneg c1
      cneg caddc co cK cneg c1 cmin co wceq cK zcn cK negcl cK cneg cc wcel c1
      cc wcel cK cneg c1 cneg caddc co cK cneg c1 cmin co wceq ax1cn cK cneg c1
      negsub mpan2 3syl eqtrd eleq1d adantr mpbird syl3an3 cG cgr wcel cA cX
      wcel cK cz wcel cK cneg cn wcel wa w3a cK cz wcel cA cK c1 caddc co cneg
      c1 caddc co cP co cA cK cneg cP co wceq cK cz wcel cK cneg cn wcel wa cG
      cgr wcel cK cz wcel cA cX wcel cK cz wcel cK cneg cn wcel pm3.26 3ad2ant3
      cK cz wcel cK c1 caddc co cneg c1 caddc co cK cneg cA cP cK cz wcel cK c1
      caddc co cneg c1 caddc co cK cneg c1 cmin co c1 caddc co cK cneg cK cz
      wcel cK c1 caddc co cneg cK cneg c1 cmin co c1 caddc cK cz wcel cK c1
      caddc co cneg cK cneg c1 cneg caddc co cK cneg c1 cmin co cK cc wcel c1
      cc wcel cK c1 caddc co cneg cK cneg c1 cneg caddc co wceq cK cz wcel cK
      c1 negdi cK zcn ax1cn sylancl cK cz wcel cK cc wcel cK cneg cc wcel cK
      cneg c1 cneg caddc co cK cneg c1 cmin co wceq cK zcn cK negcl cK cneg cc
      wcel c1 cc wcel cK cneg c1 cneg caddc co cK cneg c1 cmin co wceq ax1cn cK
      cneg c1 negsub mpan2 3syl eqtrd opreq1d cK cz wcel cK cc wcel cK cneg cc
      wcel cK cneg c1 cmin co c1 caddc co cK cneg wceq cK zcn cK negcl cK cneg
      cc wcel c1 cc wcel cK cneg c1 cmin co c1 caddc co cK cneg wceq ax1cn cK
      cneg c1 npcan mpan2 3syl eqtrd opreq2d syl cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa w3a cA cK c1 caddc co cneg cP co cA cK c1 caddc
      co cP co cG cgn cfv cfv cA cG cG cgr wcel cA cX wcel cK cz wcel cA cK c1
      caddc co cneg cP co cA cK c1 caddc co cP co cG cgn cfv cfv wceq cG cgr
      wcel cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cG cgr wcel cA cX wcel
      cK c1 caddc co cz wcel cA cK c1 caddc co cneg cP co cA cK c1 caddc co cP
      co cG cgn cfv cfv wceq cK cz wcel cA cP cG cK c1 caddc co cG cgn cfv cX
      gxsuc.1 cG cgn cfv eqid gxsuc.2 gxneg cK peano2z syl3an3 cG cgr wcel cA
      cX wcel cK cz wcel cK cneg cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa 3simp2 cK cz wcel cK cneg cn wcel wa cG cgr wcel
      cK cz wcel cA cX wcel cK cz wcel cK cneg cn wcel pm3.26 3ad2ant3 syl3anc
      opreq1d 3eqtr3rd cG cgr wcel cA cX wcel cK cz wcel cA cK cneg cP co cA cK
      cP co cG cgn cfv cfv wceq cG cgr wcel cA cX wcel cK cz wcel cK cneg cn
      wcel wa w3a cA cP cG cK cG cgn cfv cX gxsuc.1 cG cgn cfv eqid gxsuc.2
      gxneg cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp1 cG cgr
      wcel cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp2 cK cz wcel cK cneg
      cn wcel wa cG cgr wcel cK cz wcel cA cX wcel cK cz wcel cK cneg cn wcel
      pm3.26 3ad2ant3 syl3anc eqtrd fveq2d cG cgr wcel cA cK c1 caddc co cP co
      cG cgn cfv cfv cX wcel cA cX wcel cA cK c1 caddc co cP co cG cgn cfv cfv
      cA cG co cG cgn cfv cfv cA cG cgn cfv cfv cA cK c1 caddc co cP co cG cgn
      cfv cfv cG cgn cfv cfv cG co wceq cG cgr wcel cA cX wcel cK cz wcel cK
      cneg cn wcel wa w3a cA cK c1 caddc co cP co cG cgn cfv cfv cA cG cG cgn
      cfv cX gxsuc.1 cG cgn cfv eqid grpinvop cG cgr wcel cA cX wcel cK cz wcel
      cK cneg cn wcel wa 3simp1 cG cgr wcel cA cK c1 caddc co cP co cX wcel cA
      cK c1 caddc co cP co cG cgn cfv cfv cX wcel cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa w3a cA cK c1 caddc co cP co cG cG cgn cfv cX
      gxsuc.1 cG cgn cfv eqid grpinvcl cG cgr wcel cA cX wcel cK cz wcel cK
      cneg cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK c1 caddc co cz wcel cA
      cK c1 caddc co cP co cX wcel cG cgr wcel cA cX wcel cK cz wcel cK cneg cn
      wcel wa w3a cA cP cG cK c1 caddc co cX gxsuc.1 gxsuc.2 gxcl cG cgr wcel
      cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK
      cz wcel cK cneg cn wcel wa 3simp2 cG cgr wcel cA cX wcel cK cz wcel cK
      cneg cn wcel wa w3a cK cz wcel cK c1 caddc co cz wcel cK cz wcel cK cneg
      cn wcel wa cG cgr wcel cK cz wcel cA cX wcel cK cz wcel cK cneg cn wcel
      pm3.26 3ad2ant3 cK peano2z syl syl3anc sylanc cG cgr wcel cA cX wcel cK
      cz wcel cK cneg cn wcel wa 3simp2 syl3anc cG cgr wcel cA cK cP co cX wcel
      cA cK cP co cG cgn cfv cfv cG cgn cfv cfv cA cK cP co wceq cG cgr wcel cA
      cX wcel cK cz wcel cK cneg cn wcel wa w3a cA cK cP co cG cG cgn cfv cX
      gxsuc.1 cG cgn cfv eqid grp2inv cG cgr wcel cA cX wcel cK cz wcel cK cneg
      cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK cz wcel cA cK cP co cX wcel
      cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cA cP cG cK cX
      gxsuc.1 gxsuc.2 gxcl cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa
      3simp1 cG cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp2 cK cz
      wcel cK cneg cn wcel wa cG cgr wcel cK cz wcel cA cX wcel cK cz wcel cK
      cneg cn wcel pm3.26 3ad2ant3 syl3anc sylanc 3eqtr3d eqtr3d opreq2d cG cgr
      wcel cA cX wcel cA cK c1 caddc co cP co cX wcel cA cA cG cgn cfv cfv cA
      cK c1 caddc co cP co cG co cG co cA cK c1 caddc co cP co wceq cG cgr wcel
      cA cX wcel cK cz wcel cK cneg cn wcel wa w3a cA cA cK c1 caddc co cP co
      cG cG cgn cfv cX gxsuc.1 cG cgn cfv eqid grpasscan1 cG cgr wcel cA cX
      wcel cK cz wcel cK cneg cn wcel wa 3simp1 cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa 3simp2 cG cgr wcel cA cX wcel cK c1 caddc co cz
      wcel cA cK c1 caddc co cP co cX wcel cG cgr wcel cA cX wcel cK cz wcel cK
      cneg cn wcel wa w3a cA cP cG cK c1 caddc co cX gxsuc.1 gxsuc.2 gxcl cG
      cgr wcel cA cX wcel cK cz wcel cK cneg cn wcel wa 3simp1 cG cgr wcel cA
      cX wcel cK cz wcel cK cneg cn wcel wa 3simp2 cG cgr wcel cA cX wcel cK cz
      wcel cK cneg cn wcel wa w3a cK cz wcel cK c1 caddc co cz wcel cK cz wcel
      cK cneg cn wcel wa cG cgr wcel cK cz wcel cA cX wcel cK cz wcel cK cneg
      cn wcel pm3.26 3ad2ant3 cK peano2z syl syl3anc syl3anc 3eqtr2rd 3expia
      exp3a 3impia jaod mpd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d G k m $.  $d K k m $.  $d P k m $.  $d U k m $.
    gxid.1 $e |- U = ( Id ` G ) $.
    gxid.2 $e |- P = ( ^g ` G ) $.
    $( The identity element of a group to any power remains unchanged.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxid $p |- ( ( G e. Grp /\ K e. ZZ ) -> ( U P K ) = U ) $=
      cG cgr wcel cK cz wcel cU cK cP co cU wceq cU vm cv cP co cU wceq cU cc0
      cP co cU wceq cU vk cv cP co cU wceq cU vk cv cneg cP co cU wceq cU vk cv
      c1 caddc co cP co cU wceq vm vk cK cU cK cP co cU wceq cG cgr wcel vm cv
      cc0 wceq cU vm cv cP co cU cc0 cP co cU vm cv cc0 cU cP opreq2 eqeq1d vm
      cv vk cv wceq cU vm cv cP co cU vk cv cP co cU vm cv vk cv cU cP opreq2
      eqeq1d vm cv vk cv c1 caddc co wceq cU vm cv cP co cU vk cv c1 caddc co
      cP co cU vm cv vk cv c1 caddc co cU cP opreq2 eqeq1d vm cv vk cv cneg
      wceq cU vm cv cP co cU vk cv cneg cP co cU vm cv vk cv cneg cU cP opreq2
      eqeq1d vm cv cK wceq cU vm cv cP co cU cK cP co cU vm cv cK cU cP opreq2
      eqeq1d cG cgr wcel cU cG crn wcel cU cc0 cP co cU wceq cU cG cG crn cG
      crn eqid gxid.1 grpidcl cU cP cU cG cG crn cG crn eqid gxid.1 gxid.2 gx0
      mpdan cG cgr wcel vk cv cz wcel cU vk cv cP co cU wceq cU vk cv c1 caddc
      co cP co cU wceq wi vk cv cn0 wcel cG cgr wcel vk cv cz wcel cU vk cv cP
      co cU wceq cU vk cv c1 caddc co cP co cU wceq wi cG cgr wcel vk cv cz
      wcel wa cU vk cv cP co cU wceq cU vk cv c1 caddc co cP co cU wceq cG cgr
      wcel vk cv cz wcel wa cU vk cv cP co cU vk cv c1 caddc co cP co cU cG cgr
      wcel vk cv cz wcel wa cU vk cv c1 caddc co cP co cU vk cv cP co cU cG co
      cU vk cv cP co cG cgr wcel cU cG crn wcel vk cv cz wcel cU vk cv c1 caddc
      co cP co cU vk cv cP co cU cG co wceq cG cgr wcel vk cv cz wcel wa cU cP
      cG vk cv cG crn cG crn eqid gxid.2 gxsuc cG cgr wcel vk cv cz wcel pm3.26
      cG cgr wcel cU cG crn wcel vk cv cz wcel cU cG cG crn cG crn eqid gxid.1
      grpidcl adantr cG cgr wcel vk cv cz wcel pm3.27 syl3anc cG cgr wcel cU vk
      cv cP co cG crn wcel cU vk cv cP co cU cG co cU vk cv cP co wceq cG cgr
      wcel vk cv cz wcel wa cU vk cv cP co cU cG cG crn cG crn eqid gxid.1
      grprid cG cgr wcel vk cv cz wcel pm3.26 cG cgr wcel cU cG crn wcel vk cv
      cz wcel cU vk cv cP co cG crn wcel cG cgr wcel vk cv cz wcel wa cU cP cG
      vk cv cG crn cG crn eqid gxid.2 gxcl cG cgr wcel vk cv cz wcel pm3.26 cG
      cgr wcel cU cG crn wcel vk cv cz wcel cU cG cG crn cG crn eqid gxid.1
      grpidcl adantr cG cgr wcel vk cv cz wcel pm3.27 syl3anc sylanc eqtr2d
      eqeq1d biimpd ex vk cv nn0z syl5 cG cgr wcel vk cv cz wcel cU vk cv cP co
      cU wceq cU vk cv cneg cP co cU wceq wi vk cv cn wcel cG cgr wcel vk cv cz
      wcel cU vk cv cP co cU wceq cU vk cv cneg cP co cU wceq wi cG cgr wcel vk
      cv cz wcel cU vk cv cP co cU wceq cU vk cv cneg cP co cU wceq cG cgr wcel
      vk cv cz wcel cU vk cv cP co cU wceq w3a cU vk cv cneg cP co cU vk cv cP
      co cG cgn cfv cfv cU cG cgr wcel vk cv cz wcel cU vk cv cneg cP co cU vk
      cv cP co cG cgn cfv cfv wceq cU vk cv cP co cU wceq cG cgr wcel vk cv cz
      wcel cU vk cv cneg cP co cU vk cv cP co cG cgn cfv cfv wceq cG cgr wcel
      cU cG crn wcel vk cv cz wcel cU vk cv cneg cP co cU vk cv cP co cG cgn
      cfv cfv wceq cG cgr wcel cU cP cG vk cv cG cgn cfv cG crn cG crn eqid cG
      cgn cfv eqid gxid.2 gxneg cU cG cG crn cG crn eqid gxid.1 grpidcl syl3an2
      3anidm12 3adant3 cG cgr wcel cU vk cv cP co cU wceq cU vk cv cP co cG cgn
      cfv cfv cU wceq vk cv cz wcel cU vk cv cP co cU wceq cG cgr wcel cU vk cv
      cP co cG cgn cfv cfv cU cG cgn cfv cfv cU cU vk cv cP co cU cG cgn cfv
      fveq2 cU cG cG cgn cfv gxid.1 cG cgn cfv eqid grpinvid sylan9eqr 3adant2
      eqtrd 3expia ex vk cv nnz syl5 zindd imp $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d A k m $.  $d G k m $.  $d J k m $.  $d K m $.  $d P k m $.
    $d X k m $.
    gxnn0add.1 $e |- X = ran G $.
    gxnn0add.2 $e |- P = ( ^g ` G ) $.
    $( The group power of a sum is the group product of the powers (lemma with
       nonnegative exponent - use ~ gxadd instead).  (Contributed by Paul
       Chapman, 17-Apr-2009.) $)
    gxnn0add $p |- ( ( G e. Grp /\ A e. X /\ ( J e. ZZ /\ K e. NN0 ) ) ->
                     ( A P ( J + K ) ) = ( ( A P J ) G ( A P K ) ) ) $=
      cG cgr wcel cA cX wcel cJ cz wcel cK cn0 wcel wa cA cJ cK caddc co cP co
      cA cJ cP co cA cK cP co cG co wceq cG cgr wcel cA cX wcel wa cJ cz wcel
      cK cn0 wcel cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG
      cgr wcel cA cX wcel cJ cz wcel cK cn0 wcel cA cJ cK caddc co cP co cA cJ
      cP co cA cK cP co cG co wceq wi cK cn0 wcel cG cgr wcel cA cX wcel cJ cz
      wcel w3a cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG
      cgr wcel cA cX wcel cJ cz wcel w3a cA cJ vm cv caddc co cP co cA cJ cP co
      cA vm cv cP co cG co wceq wi cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ
      cc0 caddc co cP co cA cJ cP co cA cc0 cP co cG co wceq wi cG cgr wcel cA
      cX wcel cJ cz wcel w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP
      co cG co wceq wi cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ vk cv c1
      caddc co caddc co cP co cA cJ cP co cA vk cv c1 caddc co cP co cG co wceq
      wi cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ cK caddc co cP co cA cJ cP
      co cA cK cP co cG co wceq wi vm vk cK vm cv cc0 wceq cA cJ vm cv caddc co
      cP co cA cJ cP co cA vm cv cP co cG co wceq cA cJ cc0 caddc co cP co cA
      cJ cP co cA cc0 cP co cG co wceq cG cgr wcel cA cX wcel cJ cz wcel w3a vm
      cv cc0 wceq cA cJ vm cv caddc co cP co cA cJ cc0 caddc co cP co cA cJ cP
      co cA vm cv cP co cG co cA cJ cP co cA cc0 cP co cG co vm cv cc0 wceq cJ
      vm cv caddc co cJ cc0 caddc co cA cP vm cv cc0 cJ caddc opreq2 opreq2d vm
      cv cc0 wceq cA vm cv cP co cA cc0 cP co cA cJ cP co cG vm cv cc0 cA cP
      opreq2 opreq2d eqeq12d imbi2d vm cv vk cv wceq cA cJ vm cv caddc co cP co
      cA cJ cP co cA vm cv cP co cG co wceq cA cJ vk cv caddc co cP co cA cJ cP
      co cA vk cv cP co cG co wceq cG cgr wcel cA cX wcel cJ cz wcel w3a vm cv
      vk cv wceq cA cJ vm cv caddc co cP co cA cJ vk cv caddc co cP co cA cJ cP
      co cA vm cv cP co cG co cA cJ cP co cA vk cv cP co cG co vm cv vk cv wceq
      cJ vm cv caddc co cJ vk cv caddc co cA cP vm cv vk cv cJ caddc opreq2
      opreq2d vm cv vk cv wceq cA vm cv cP co cA vk cv cP co cA cJ cP co cG vm
      cv vk cv cA cP opreq2 opreq2d eqeq12d imbi2d vm cv vk cv c1 caddc co wceq
      cA cJ vm cv caddc co cP co cA cJ cP co cA vm cv cP co cG co wceq cA cJ vk
      cv c1 caddc co caddc co cP co cA cJ cP co cA vk cv c1 caddc co cP co cG
      co wceq cG cgr wcel cA cX wcel cJ cz wcel w3a vm cv vk cv c1 caddc co
      wceq cA cJ vm cv caddc co cP co cA cJ vk cv c1 caddc co caddc co cP co cA
      cJ cP co cA vm cv cP co cG co cA cJ cP co cA vk cv c1 caddc co cP co cG
      co vm cv vk cv c1 caddc co wceq cJ vm cv caddc co cJ vk cv c1 caddc co
      caddc co cA cP vm cv vk cv c1 caddc co cJ caddc opreq2 opreq2d vm cv vk
      cv c1 caddc co wceq cA vm cv cP co cA vk cv c1 caddc co cP co cA cJ cP co
      cG vm cv vk cv c1 caddc co cA cP opreq2 opreq2d eqeq12d imbi2d vm cv cK
      wceq cA cJ vm cv caddc co cP co cA cJ cP co cA vm cv cP co cG co wceq cA
      cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG cgr wcel cA cX
      wcel cJ cz wcel w3a vm cv cK wceq cA cJ vm cv caddc co cP co cA cJ cK
      caddc co cP co cA cJ cP co cA vm cv cP co cG co cA cJ cP co cA cK cP co
      cG co vm cv cK wceq cJ vm cv caddc co cJ cK caddc co cA cP vm cv cK cJ
      caddc opreq2 opreq2d vm cv cK wceq cA vm cv cP co cA cK cP co cA cJ cP co
      cG vm cv cK cA cP opreq2 opreq2d eqeq12d imbi2d cG cgr wcel cA cX wcel cJ
      cz wcel w3a cA cJ cP co cG cgi cfv cG co cA cJ cP co cA cJ cP co cA cc0
      cP co cG co cA cJ cc0 caddc co cP co cG cgr wcel cA cX wcel cJ cz wcel
      w3a cA cJ cP co cX wcel cA cJ cP co cG cgi cfv cG co cA cJ cP co wceq cA
      cP cG cJ cX gxnn0add.1 gxnn0add.2 gxcl cG cgr wcel cA cX wcel cA cJ cP co
      cX wcel cA cJ cP co cG cgi cfv cG co cA cJ cP co wceq wi cJ cz wcel cG
      cgr wcel cA cJ cP co cX wcel cA cJ cP co cG cgi cfv cG co cA cJ cP co
      wceq cA cJ cP co cG cgi cfv cG cX gxnn0add.1 cG cgi cfv eqid grprid ex
      3ad2ant1 mpd cG cgr wcel cA cX wcel cA cJ cP co cA cc0 cP co cG co cA cJ
      cP co cG cgi cfv cG co wceq cJ cz wcel cG cgr wcel cA cX wcel wa cA cc0
      cP co cG cgi cfv cA cJ cP co cG cA cP cG cgi cfv cG cX gxnn0add.1 cG cgi
      cfv eqid gxnn0add.2 gx0 opreq2d 3adant3 cJ cz wcel cG cgr wcel cA cJ cc0
      caddc co cP co cA cJ cP co wceq cA cX wcel cJ cz wcel cJ cc0 caddc co cJ
      cA cP cJ cz wcel cJ cc wcel cJ cc0 caddc co cJ wceq cJ zcn cJ addid1 syl
      opreq2d 3ad2ant3 3eqtr4rd vk cv cn0 wcel vk cv cz wcel cG cgr wcel cA cX
      wcel cJ cz wcel w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co
      cG co wceq wi cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ vk cv c1 caddc
      co caddc co cP co cA cJ cP co cA vk cv c1 caddc co cP co cG co wceq wi wi
      vk cv nn0z vk cv cz wcel cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ vk
      cv caddc co cP co cA cJ cP co cA vk cv cP co cG co wceq cA cJ vk cv c1
      caddc co caddc co cP co cA cJ cP co cA vk cv c1 caddc co cP co cG co wceq
      cG cgr wcel cA cX wcel cJ cz wcel w3a vk cv cz wcel cA cJ vk cv caddc co
      cP co cA cJ cP co cA vk cv cP co cG co wceq cA cJ vk cv c1 caddc co caddc
      co cP co cA cJ cP co cA vk cv c1 caddc co cP co cG co wceq wi cG cgr wcel
      cA cX wcel cJ cz wcel vk cv cz wcel cA cJ vk cv caddc co cP co cA cJ cP
      co cA vk cv cP co cG co wceq cA cJ vk cv c1 caddc co caddc co cP co cA cJ
      cP co cA vk cv c1 caddc co cP co cG co wceq wi wi cG cgr wcel cA cX wcel
      wa cJ cz wcel vk cv cz wcel cA cJ vk cv caddc co cP co cA cJ cP co cA vk
      cv cP co cG co wceq cA cJ vk cv c1 caddc co caddc co cP co cA cJ cP co cA
      vk cv c1 caddc co cP co cG co wceq wi cG cgr wcel cA cX wcel cJ cz wcel
      vk cv cz wcel wa cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co cG
      co wceq cA cJ vk cv c1 caddc co caddc co cP co cA cJ cP co cA vk cv c1
      caddc co cP co cG co wceq wi cG cgr wcel cA cX wcel cJ cz wcel vk cv cz
      wcel wa w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co cG co
      wceq cA cJ vk cv c1 caddc co caddc co cP co cA cJ cP co cA vk cv c1 caddc
      co cP co cG co wceq cG cgr wcel cA cX wcel cJ cz wcel vk cv cz wcel wa
      w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co cG co wceq wa
      cA cJ vk cv caddc co c1 caddc co cP co cA cJ vk cv c1 caddc co caddc co
      cP co cA cJ cP co cA vk cv c1 caddc co cP co cG co cG cgr wcel cA cX wcel
      cJ cz wcel vk cv cz wcel wa w3a cA cJ vk cv caddc co cP co cA cJ cP co cA
      vk cv cP co cG co wceq wa cJ vk cv caddc co c1 caddc co cJ vk cv c1 caddc
      co caddc co cA cP cG cgr wcel cA cX wcel cJ cz wcel vk cv cz wcel wa w3a
      cJ vk cv caddc co c1 caddc co cJ vk cv c1 caddc co caddc co wceq cA cJ vk
      cv caddc co cP co cA cJ cP co cA vk cv cP co cG co wceq cJ cz wcel vk cv
      cz wcel wa cG cgr wcel cJ vk cv caddc co c1 caddc co cJ vk cv c1 caddc co
      caddc co wceq cA cX wcel cJ cc wcel vk cv cc wcel cJ vk cv caddc co c1
      caddc co cJ vk cv c1 caddc co caddc co wceq cJ cz wcel vk cv cz wcel cJ
      cc wcel vk cv cc wcel c1 cc wcel cJ vk cv caddc co c1 caddc co cJ vk cv
      c1 caddc co caddc co wceq ax1cn cJ vk cv c1 addass mp3an3 cJ zcn vk cv
      zcn syl2an 3ad2ant3 adantr opreq2d cG cgr wcel cA cX wcel cJ cz wcel vk
      cv cz wcel wa w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co
      cG co wceq wa cA cJ cP co cA vk cv cP co cG co cA cG co cA cJ cP co cA vk
      cv cP co cA cG co cG co cA cJ vk cv caddc co c1 caddc co cP co cA cJ cP
      co cA vk cv c1 caddc co cP co cG co cG cgr wcel cA cJ cP co cX wcel cA vk
      cv cP co cX wcel cA cX wcel w3a cA cJ cP co cA vk cv cP co cG co cA cG co
      cA cJ cP co cA vk cv cP co cA cG co cG co wceq cG cgr wcel cA cX wcel cJ
      cz wcel vk cv cz wcel wa w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk
      cv cP co cG co wceq wa cA cJ cP co cA vk cv cP co cA cG cX gxnn0add.1
      grpass cG cgr wcel cA cX wcel cJ cz wcel vk cv cz wcel wa cA cJ vk cv
      caddc co cP co cA cJ cP co cA vk cv cP co cG co wceq 3simpl1 cG cgr wcel
      cA cX wcel cJ cz wcel vk cv cz wcel wa w3a cA cJ vk cv caddc co cP co cA
      cJ cP co cA vk cv cP co cG co wceq wa cA cJ cP co cX wcel cA vk cv cP co
      cX wcel cA cX wcel cG cgr wcel cA cX wcel cJ cz wcel vk cv cz wcel wa w3a
      cA cJ cP co cX wcel cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co
      cG co wceq cG cgr wcel cA cX wcel cJ cz wcel cA cJ cP co cX wcel vk cv cz
      wcel cA cP cG cJ cX gxnn0add.1 gxnn0add.2 gxcl 3adant3r adantr cG cgr
      wcel cA cX wcel cJ cz wcel vk cv cz wcel wa w3a cA vk cv cP co cX wcel cA
      cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co cG co wceq cG cgr wcel
      cA cX wcel vk cv cz wcel cA vk cv cP co cX wcel cJ cz wcel cA cP cG vk cv
      cX gxnn0add.1 gxnn0add.2 gxcl 3adant3l adantr cG cgr wcel cA cX wcel cJ
      cz wcel vk cv cz wcel wa cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv
      cP co cG co wceq 3simpl2 3jca sylanc cG cgr wcel cA cX wcel cJ cz wcel vk
      cv cz wcel wa w3a cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co
      cG co wceq cA cJ vk cv caddc co c1 caddc co cP co cA cJ vk cv caddc co cP
      co cA cG co cA cJ cP co cA vk cv cP co cG co cA cG co cG cgr wcel cA cX
      wcel cJ vk cv caddc co cz wcel cA cJ vk cv caddc co c1 caddc co cP co cA
      cJ vk cv caddc co cP co cA cG co wceq cJ cz wcel vk cv cz wcel wa cA cP
      cG cJ vk cv caddc co cX gxnn0add.1 gxnn0add.2 gxsuc cJ vk cv zaddcl
      syl3an3 cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co cG co cA cG
      opreq1 sylan9eq cG cgr wcel cA cX wcel cJ cz wcel vk cv cz wcel wa w3a cA
      cJ cP co cA vk cv c1 caddc co cP co cG co cA cJ cP co cA vk cv cP co cA
      cG co cG co wceq cA cJ vk cv caddc co cP co cA cJ cP co cA vk cv cP co cG
      co wceq cG cgr wcel cA cX wcel vk cv cz wcel cA cJ cP co cA vk cv c1
      caddc co cP co cG co cA cJ cP co cA vk cv cP co cA cG co cG co wceq cJ cz
      wcel cG cgr wcel cA cX wcel vk cv cz wcel w3a cA vk cv c1 caddc co cP co
      cA vk cv cP co cA cG co cA cJ cP co cG cA cP cG vk cv cX gxnn0add.1
      gxnn0add.2 gxsuc opreq2d 3adant3l adantr 3eqtr4d eqtr3d ex 3expia exp3a
      3impia com12 a2d syl nn0ind com12 3expia imp3a 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( The group power of a sum is the group product of the powers.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxadd $p |- ( ( G e. Grp /\ A e. X /\ ( J e. ZZ /\ K e. ZZ ) ) ->
                  ( A P ( J + K ) ) = ( ( A P J ) G ( A P K ) ) ) $=
      cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel wa cA cJ cK caddc co cP co
      cA cJ cP co cA cK cP co cG co wceq cG cgr wcel cA cX wcel wa cJ cz wcel
      cK cz wcel cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG
      cgr wcel cA cX wcel cJ cz wcel cK cz wcel cA cJ cK caddc co cP co cA cJ
      cP co cA cK cP co cG co wceq wi cG cgr wcel cA cX wcel cJ cz wcel w3a cK
      cz wcel cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG cgr
      wcel cA cX wcel cJ cz wcel w3a cK cz wcel wa cK cn0 wcel cK cneg cn0 wcel
      wo cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cK cz wcel
      cK cn0 wcel cK cneg cn0 wcel wo cG cgr wcel cA cX wcel cJ cz wcel w3a cK
      cz wcel cK cr wcel cK cn0 wcel cK cneg cn0 wcel wo cK elznn0 pm3.27bi
      adantl cG cgr wcel cA cX wcel cJ cz wcel w3a cK cz wcel wa cK cn0 wcel cA
      cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cK cneg cn0 wcel
      cG cgr wcel cA cX wcel cJ cz wcel w3a cK cn0 wcel cA cJ cK caddc co cP co
      cA cJ cP co cA cK cP co cG co wceq wi cK cz wcel cG cgr wcel cA cX wcel
      cJ cz wcel cK cn0 wcel cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG
      co wceq wi cG cgr wcel cA cX wcel wa cJ cz wcel cK cn0 wcel cA cJ cK
      caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG cgr wcel cA cX wcel
      cJ cz wcel cK cn0 wcel wa cA cJ cK caddc co cP co cA cJ cP co cA cK cP co
      cG co wceq cA cP cG cJ cK cX gxnn0add.1 gxnn0add.2 gxnn0add 3expia exp3a
      3impia adantr cG cgr wcel cA cX wcel cJ cz wcel w3a cK cz wcel cK cneg
      cn0 wcel cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq wi cG
      cgr wcel cA cX wcel cJ cz wcel w3a cK cz wcel cK cneg cn0 wcel cA cJ cK
      caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG cgr wcel cA cX wcel
      cJ cz wcel cK cz wcel cK cneg cn0 wcel wa cA cJ cK caddc co cP co cA cJ
      cP co cA cK cP co cG co wceq wi cG cgr wcel cA cX wcel wa cJ cz wcel cK
      cz wcel cK cneg cn0 wcel wa cA cJ cK caddc co cP co cA cJ cP co cA cK cP
      co cG co wceq cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co wceq cG
      cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a cA
      cJ cK caddc co cP co cA cK cP co cG cgn cfv cfv cG co cA cK cP co cG co
      cA cJ cK caddc co cP co cA cJ cP co cA cK cP co cG co cG cgr wcel cA cJ
      cK caddc co cP co cX wcel cA cK cP co cX wcel cA cJ cK caddc co cP co cA
      cK cP co cG cgn cfv cfv cG co cA cK cP co cG co cA cJ cK caddc co cP co
      wceq cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa
      w3a cA cJ cK caddc co cP co cA cK cP co cG cG cgn cfv cX gxnn0add.1 cG
      cgn cfv eqid grpasscan2 cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK
      cneg cn0 wcel wa wa 3simp1 cG cgr wcel cA cX wcel cJ cK caddc co cz wcel
      cA cJ cK caddc co cP co cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa
      wa cA cP cG cJ cK caddc co cX gxnn0add.1 gxnn0add.2 gxcl cJ cz wcel cK cz
      wcel cJ cK caddc co cz wcel cK cz wcel cK cneg cn0 wcel wa cJ cK zaddcl
      cK cz wcel cK cneg cn0 wcel pm3.26 sylan2 syl3an3 cG cgr wcel cA cX wcel
      cK cz wcel cA cK cP co cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa
      wa cA cP cG cK cX gxnn0add.1 gxnn0add.2 gxcl cK cz wcel cK cneg cn0 wcel
      wa cK cz wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel pm3.26 adantl
      syl3an3 syl3anc cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa w3a cA cJ cK caddc co cP co cA cK cP co cG cgn cfv cfv cG co
      cA cJ cP co cA cK cP co cG cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel
      cK cneg cn0 wcel wa wa w3a cA cJ cK caddc co cK cneg caddc co cP co cA cJ
      cK caddc co cP co cA cK cneg cP co cG co cA cJ cP co cA cJ cK caddc co cP
      co cA cK cP co cG cgn cfv cfv cG co cG cgr wcel cA cX wcel cJ cK caddc co
      cz wcel cK cneg cn0 wcel wa cA cJ cK caddc co cK cneg caddc co cP co cA
      cJ cK caddc co cP co cA cK cneg cP co cG co wceq cJ cz wcel cK cz wcel cK
      cneg cn0 wcel wa wa cA cP cG cJ cK caddc co cK cneg cX gxnn0add.1
      gxnn0add.2 gxnn0add cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa cJ cK
      caddc co cz wcel cK cneg cn0 wcel cJ cz wcel cK cz wcel cJ cK caddc co cz
      wcel cK cz wcel cK cneg cn0 wcel wa cJ cK zaddcl cK cz wcel cK cneg cn0
      wcel pm3.26 sylan2 cK cz wcel cK cneg cn0 wcel wa cK cneg cn0 wcel cJ cz
      wcel cK cz wcel cK cneg cn0 wcel pm3.27 adantl jca syl3an3 cJ cz wcel cK
      cz wcel cK cneg cn0 wcel wa wa cG cgr wcel cA cJ cK caddc co cK cneg
      caddc co cP co cA cJ cP co wceq cA cX wcel cJ cz wcel cK cz wcel cK cneg
      cn0 wcel wa wa cJ cK caddc co cK cneg caddc co cJ cA cP cJ cc wcel cK cc
      wcel cJ cK caddc co cK cneg caddc co cJ wceq cJ cz wcel cK cz wcel cK
      cneg cn0 wcel wa cJ cc wcel cK cc wcel wa cJ cK caddc co cK cneg caddc co
      cJ cK caddc co cK cmin co cJ cJ cc wcel cK cc wcel cJ cK caddc co cc wcel
      cJ cK caddc co cK cneg caddc co cJ cK caddc co cK cmin co wceq cJ cK
      addcl cJ cK caddc co cK negsub sylancom cJ cK pncan eqtrd cJ zcn cK cz
      wcel cK cneg cn0 wcel wa cK cz wcel cK cc wcel cK cz wcel cK cneg cn0
      wcel pm3.26 cK zcn syl syl2an opreq2d 3ad2ant3 cG cgr wcel cA cX wcel cJ
      cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a cA cK cneg cP co cA cK cP
      co cG cgn cfv cfv cA cJ cK caddc co cP co cG cG cgr wcel cA cX wcel cK cz
      wcel cA cK cneg cP co cA cK cP co cG cgn cfv cfv wceq cJ cz wcel cK cz
      wcel cK cneg cn0 wcel wa wa cA cP cG cK cG cgn cfv cX gxnn0add.1 cG cgn
      cfv eqid gxnn0add.2 gxneg cK cz wcel cK cneg cn0 wcel wa cK cz wcel cJ cz
      wcel cK cz wcel cK cneg cn0 wcel pm3.26 adantl syl3an3 opreq2d 3eqtr3rd
      opreq1d eqtr3d 3expia exp3a 3impia exp3a imp jaod mpd ex 3expia imp3a
      3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxsub.1 $e |- X = ran G $.
    gxsub.2 $e |- N = ( inv ` G ) $.
    gxsub.3 $e |- P = ( ^g ` G ) $.
    $( The group power of a difference is the group quotient of the powers.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxsub $p |- ( ( G e. Grp /\ A e. X /\ ( J e. ZZ /\ K e. ZZ ) ) ->
        ( A P ( J - K ) ) = ( ( A P J ) G ( N ` ( A P K ) ) ) ) $=
      cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel wa w3a cA cJ cK cneg caddc
      co cP co cA cJ cP co cA cK cneg cP co cG co cA cJ cK cmin co cP co cA cJ
      cP co cA cK cP co cN cfv cG co cG cgr wcel cA cX wcel cJ cz wcel cK cneg
      cz wcel wa cA cJ cK cneg caddc co cP co cA cJ cP co cA cK cneg cP co cG
      co wceq cJ cz wcel cK cz wcel wa cA cP cG cJ cK cneg cX gxsub.1 gxsub.3
      gxadd cK cz wcel cK cneg cz wcel cJ cz wcel cK znegcl anim2i syl3an3 cG
      cgr wcel cA cX wcel cJ cz wcel cK cz wcel wa w3a cJ cK cneg caddc co cJ
      cK cmin co cA cP cJ cz wcel cK cz wcel wa cG cgr wcel cJ cK cneg caddc co
      cJ cK cmin co wceq cA cX wcel cJ cc wcel cK cc wcel cJ cK cneg caddc co
      cJ cK cmin co wceq cJ cz wcel cK cz wcel cJ cK negsub cJ zcn cK zcn
      syl2an 3ad2ant3 opreq2d cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel wa
      w3a cA cK cneg cP co cA cK cP co cN cfv cA cJ cP co cG cG cgr wcel cA cX
      wcel cK cz wcel cA cK cneg cP co cA cK cP co cN cfv wceq cJ cz wcel cA cP
      cG cK cN cX gxsub.1 gxsub.2 gxsub.3 gxneg 3adant3l opreq2d 3eqtr3d $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    $d A k m $.  $d G k m $.  $d J k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxnn0mul.1 $e |- X = ran G $.
    gxnn0mul.2 $e |- P = ( ^g ` G ) $.
    $( The group power of a product is the composition of the powers (lemma
       with nonnegative exponent - use ~ gxmul instead).  (Contributed by Paul
       Chapman, 17-Apr-2009.) $)
    gxnn0mul $p |- ( ( G e. Grp /\ A e. X /\ ( J e. ZZ /\ K e. NN0 ) ) ->
                     ( A P ( J x. K ) ) = ( ( A P J ) P K ) ) $=
      cG cgr wcel cA cX wcel cJ cz wcel cK cn0 wcel wa cA cJ cK cmul co cP co
      cA cJ cP co cK cP co wceq cG cgr wcel cA cX wcel wa cJ cz wcel cK cn0
      wcel cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq cG cgr wcel cA cX
      wcel cJ cz wcel cK cn0 wcel cA cJ cK cmul co cP co cA cJ cP co cK cP co
      wceq wi cK cn0 wcel cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ cK cmul
      co cP co cA cJ cP co cK cP co wceq cG cgr wcel cA cX wcel cJ cz wcel w3a
      cA cJ vm cv cmul co cP co cA cJ cP co vm cv cP co wceq wi cG cgr wcel cA
      cX wcel cJ cz wcel w3a cA cJ cc0 cmul co cP co cA cJ cP co cc0 cP co wceq
      wi cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ vk cv cmul co cP co cA cJ
      cP co vk cv cP co wceq wi cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ vk
      cv c1 caddc co cmul co cP co cA cJ cP co vk cv c1 caddc co cP co wceq wi
      cG cgr wcel cA cX wcel cJ cz wcel w3a cA cJ cK cmul co cP co cA cJ cP co
      cK cP co wceq wi vm vk cK vm cv cc0 wceq cA cJ vm cv cmul co cP co cA cJ
      cP co vm cv cP co wceq cA cJ cc0 cmul co cP co cA cJ cP co cc0 cP co wceq
      cG cgr wcel cA cX wcel cJ cz wcel w3a vm cv cc0 wceq cA cJ vm cv cmul co
      cP co cA cJ cc0 cmul co cP co cA cJ cP co vm cv cP co cA cJ cP co cc0 cP
      co vm cv cc0 wceq cJ vm cv cmul co cJ cc0 cmul co cA cP vm cv cc0 cJ cmul
      opreq2 opreq2d vm cv cc0 cA cJ cP co cP opreq2 eqeq12d imbi2d vm cv vk cv
      wceq cA cJ vm cv cmul co cP co cA cJ cP co vm cv cP co wceq cA cJ vk cv
      cmul co cP co cA cJ cP co vk cv cP co wceq cG cgr wcel cA cX wcel cJ cz
      wcel w3a vm cv vk cv wceq cA cJ vm cv cmul co cP co cA cJ vk cv cmul co
      cP co cA cJ cP co vm cv cP co cA cJ cP co vk cv cP co vm cv vk cv wceq cJ
      vm cv cmul co cJ vk cv cmul co cA cP vm cv vk cv cJ cmul opreq2 opreq2d
      vm cv vk cv cA cJ cP co cP opreq2 eqeq12d imbi2d vm cv vk cv c1 caddc co
      wceq cA cJ vm cv cmul co cP co cA cJ cP co vm cv cP co wceq cA cJ vk cv
      c1 caddc co cmul co cP co cA cJ cP co vk cv c1 caddc co cP co wceq cG cgr
      wcel cA cX wcel cJ cz wcel w3a vm cv vk cv c1 caddc co wceq cA cJ vm cv
      cmul co cP co cA cJ vk cv c1 caddc co cmul co cP co cA cJ cP co vm cv cP
      co cA cJ cP co vk cv c1 caddc co cP co vm cv vk cv c1 caddc co wceq cJ vm
      cv cmul co cJ vk cv c1 caddc co cmul co cA cP vm cv vk cv c1 caddc co cJ
      cmul opreq2 opreq2d vm cv vk cv c1 caddc co cA cJ cP co cP opreq2 eqeq12d
      imbi2d vm cv cK wceq cA cJ vm cv cmul co cP co cA cJ cP co vm cv cP co
      wceq cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq cG cgr wcel cA cX
      wcel cJ cz wcel w3a vm cv cK wceq cA cJ vm cv cmul co cP co cA cJ cK cmul
      co cP co cA cJ cP co vm cv cP co cA cJ cP co cK cP co vm cv cK wceq cJ vm
      cv cmul co cJ cK cmul co cA cP vm cv cK cJ cmul opreq2 opreq2d vm cv cK
      cA cJ cP co cP opreq2 eqeq12d imbi2d cG cgr wcel cA cX wcel cJ cz wcel
      w3a cA cc0 cP co cG cgi cfv cA cJ cc0 cmul co cP co cA cJ cP co cc0 cP co
      cG cgr wcel cA cX wcel cA cc0 cP co cG cgi cfv wceq cJ cz wcel cA cP cG
      cgi cfv cG cX gxnn0mul.1 cG cgi cfv eqid gxnn0mul.2 gx0 3adant3 cJ cz
      wcel cG cgr wcel cA cJ cc0 cmul co cP co cA cc0 cP co wceq cA cX wcel cJ
      cz wcel cJ cc0 cmul co cc0 cA cP cJ cz wcel cJ cc wcel cJ cc0 cmul co cc0
      wceq cJ zcn cJ mul01 syl opreq2d 3ad2ant3 cG cgr wcel cA cJ cP co cX wcel
      cA cJ cP co cc0 cP co cG cgi cfv wceq cG cgr wcel cA cX wcel cJ cz wcel
      w3a cA cJ cP co cP cG cgi cfv cG cX gxnn0mul.1 cG cgi cfv eqid gxnn0mul.2
      gx0 cG cgr wcel cA cX wcel cJ cz wcel 3simp1 cA cP cG cJ cX gxnn0mul.1
      gxnn0mul.2 gxcl sylanc 3eqtr4d vk cv cn0 wcel cG cgr wcel cA cX wcel cJ
      cz wcel w3a cA cJ vk cv cmul co cP co cA cJ cP co vk cv cP co wceq cA cJ
      vk cv c1 caddc co cmul co cP co cA cJ cP co vk cv c1 caddc co cP co wceq
      cG cgr wcel cA cX wcel cJ cz wcel w3a vk cv cn0 wcel cA cJ vk cv cmul co
      cP co cA cJ cP co vk cv cP co wceq cA cJ vk cv c1 caddc co cmul co cP co
      cA cJ cP co vk cv c1 caddc co cP co wceq wi cG cgr wcel cA cX wcel cJ cz
      wcel vk cv cn0 wcel cA cJ vk cv cmul co cP co cA cJ cP co vk cv cP co
      wceq cA cJ vk cv c1 caddc co cmul co cP co cA cJ cP co vk cv c1 caddc co
      cP co wceq wi wi cG cgr wcel cA cX wcel wa cJ cz wcel vk cv cn0 wcel cA
      cJ vk cv cmul co cP co cA cJ cP co vk cv cP co wceq cA cJ vk cv c1 caddc
      co cmul co cP co cA cJ cP co vk cv c1 caddc co cP co wceq wi cG cgr wcel
      cA cX wcel cJ cz wcel vk cv cn0 wcel wa cA cJ vk cv cmul co cP co cA cJ
      cP co vk cv cP co wceq cA cJ vk cv c1 caddc co cmul co cP co cA cJ cP co
      vk cv c1 caddc co cP co wceq wi cG cgr wcel cA cX wcel cJ cz wcel vk cv
      cn0 wcel wa w3a cA cJ vk cv cmul co cP co cA cJ cP co vk cv cP co wceq cA
      cJ vk cv c1 caddc co cmul co cP co cA cJ cP co vk cv c1 caddc co cP co
      wceq cG cgr wcel cA cX wcel cJ cz wcel vk cv cn0 wcel wa w3a cA cJ vk cv
      cmul co cP co cA cJ cP co vk cv cP co wceq wa cA cJ vk cv cmul co cP co
      cA cJ cP co cG co cA cJ cP co vk cv cP co cA cJ cP co cG co cA cJ vk cv
      c1 caddc co cmul co cP co cA cJ cP co vk cv c1 caddc co cP co cA cJ vk cv
      cmul co cP co cA cJ cP co vk cv cP co wceq cA cJ vk cv cmul co cP co cA
      cJ cP co cG co cA cJ cP co vk cv cP co cA cJ cP co cG co wceq cG cgr wcel
      cA cX wcel cJ cz wcel vk cv cn0 wcel wa w3a cA cJ vk cv cmul co cP co cA
      cJ cP co vk cv cP co cA cJ cP co cG opreq1 adantl cG cgr wcel cA cX wcel
      cJ cz wcel vk cv cn0 wcel wa w3a cA cJ vk cv c1 caddc co cmul co cP co cA
      cJ vk cv cmul co cP co cA cJ cP co cG co wceq cA cJ vk cv cmul co cP co
      cA cJ cP co vk cv cP co wceq cG cgr wcel cA cX wcel cJ cz wcel vk cv cn0
      wcel wa w3a cA cJ vk cv c1 caddc co cmul co cP co cA cJ vk cv cmul co cJ
      caddc co cP co cA cJ vk cv cmul co cP co cA cJ cP co cG co cJ cz wcel vk
      cv cn0 wcel wa cG cgr wcel cA cJ vk cv c1 caddc co cmul co cP co cA cJ vk
      cv cmul co cJ caddc co cP co wceq cA cX wcel cJ cz wcel vk cv cn0 wcel wa
      cJ vk cv c1 caddc co cmul co cJ vk cv cmul co cJ caddc co cA cP cJ cc
      wcel vk cv cc wcel cJ vk cv c1 caddc co cmul co cJ vk cv cmul co cJ caddc
      co wceq cJ cz wcel vk cv cn0 wcel cJ cc wcel vk cv cc wcel wa cJ vk cv c1
      caddc co cmul co cJ vk cv cmul co cJ c1 cmul co caddc co cJ vk cv cmul co
      cJ caddc co cJ cc wcel vk cv cc wcel c1 cc wcel cJ vk cv c1 caddc co cmul
      co cJ vk cv cmul co cJ c1 cmul co caddc co wceq ax1cn cJ vk cv c1 adddi
      mp3an3 cJ cc wcel cJ vk cv cmul co cJ c1 cmul co caddc co cJ vk cv cmul
      co cJ caddc co wceq vk cv cc wcel cJ cc wcel cJ c1 cmul co cJ cJ vk cv
      cmul co caddc cJ mulid1 opreq2d adantr eqtrd cJ zcn vk cv nn0cn syl2an
      opreq2d 3ad2ant3 cG cgr wcel cA cX wcel cJ vk cv cmul co cz wcel cJ cz
      wcel wa cA cJ vk cv cmul co cJ caddc co cP co cA cJ vk cv cmul co cP co
      cA cJ cP co cG co wceq cJ cz wcel vk cv cn0 wcel wa cA cP cG cJ vk cv
      cmul co cJ cX gxnn0mul.1 gxnn0mul.2 gxadd cJ cz wcel vk cv cn0 wcel wa cJ
      vk cv cmul co cz wcel cJ cz wcel cJ cz wcel vk cv cz wcel cJ vk cv cmul
      co cz wcel vk cv cn0 wcel cJ vk cv zmulcl vk cv nn0z sylan2 cJ cz wcel vk
      cv cn0 wcel pm3.26 jca syl3an3 eqtrd adantr cG cgr wcel cA cX wcel cJ cz
      wcel vk cv cn0 wcel wa w3a cA cJ cP co vk cv c1 caddc co cP co cA cJ cP
      co vk cv cP co cA cJ cP co cG co wceq cA cJ vk cv cmul co cP co cA cJ cP
      co vk cv cP co wceq cG cgr wcel cA cJ cP co cX wcel vk cv cz wcel cA cJ
      cP co vk cv c1 caddc co cP co cA cJ cP co vk cv cP co cA cJ cP co cG co
      wceq cG cgr wcel cA cX wcel cJ cz wcel vk cv cn0 wcel wa w3a cA cJ cP co
      cP cG vk cv cX gxnn0mul.1 gxnn0mul.2 gxsuc cG cgr wcel cA cX wcel cJ cz
      wcel vk cv cn0 wcel wa 3simp1 cG cgr wcel cA cX wcel cJ cz wcel cA cJ cP
      co cX wcel vk cv cn0 wcel cA cP cG cJ cX gxnn0mul.1 gxnn0mul.2 gxcl
      3adant3r cG cgr wcel cA cX wcel cJ cz wcel vk cv cn0 wcel wa w3a vk cv
      cn0 wcel vk cv cz wcel cJ cz wcel vk cv cn0 wcel wa cG cgr wcel vk cv cn0
      wcel cA cX wcel cJ cz wcel vk cv cn0 wcel pm3.27 3ad2ant3 vk cv nn0z syl
      syl3anc adantr 3eqtr4d ex 3expia exp3a 3impia com12 a2d nn0ind com12
      3expia imp3a 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)

    $( The group power of a product is the composition of the powers.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxmul $p |- ( ( G e. Grp /\ A e. X /\ ( J e. ZZ /\ K e. ZZ ) ) ->
                  ( A P ( J x. K ) ) = ( ( A P J ) P K ) ) $=
      cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel wa cA cJ cK cmul co cP co cA
      cJ cP co cK cP co wceq cG cgr wcel cA cX wcel wa cJ cz wcel cK cz wcel cA
      cJ cK cmul co cP co cA cJ cP co cK cP co wceq cG cgr wcel cA cX wcel cJ
      cz wcel cK cz wcel cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq wi cG
      cgr wcel cA cX wcel cJ cz wcel w3a cK cz wcel cA cJ cK cmul co cP co cA
      cJ cP co cK cP co wceq cG cgr wcel cA cX wcel cJ cz wcel w3a cK cz wcel
      wa cK cn0 wcel cK cneg cn0 wcel wo cA cJ cK cmul co cP co cA cJ cP co cK
      cP co wceq cK cz wcel cK cn0 wcel cK cneg cn0 wcel wo cG cgr wcel cA cX
      wcel cJ cz wcel w3a cK cz wcel cK cr wcel cK cn0 wcel cK cneg cn0 wcel wo
      cK elznn0 pm3.27bi adantl cG cgr wcel cA cX wcel cJ cz wcel w3a cK cz
      wcel wa cK cn0 wcel cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq cK
      cneg cn0 wcel cG cgr wcel cA cX wcel cJ cz wcel w3a cK cn0 wcel cA cJ cK
      cmul co cP co cA cJ cP co cK cP co wceq wi cK cz wcel cG cgr wcel cA cX
      wcel cJ cz wcel cK cn0 wcel cA cJ cK cmul co cP co cA cJ cP co cK cP co
      wceq wi cG cgr wcel cA cX wcel wa cJ cz wcel cK cn0 wcel cA cJ cK cmul co
      cP co cA cJ cP co cK cP co wceq cG cgr wcel cA cX wcel cJ cz wcel cK cn0
      wcel wa cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq cA cP cG cJ cK
      cX gxnn0mul.1 gxnn0mul.2 gxnn0mul 3expia exp3a 3impia adantr cG cgr wcel
      cA cX wcel cJ cz wcel w3a cK cz wcel cK cneg cn0 wcel cA cJ cK cmul co cP
      co cA cJ cP co cK cP co wceq wi cG cgr wcel cA cX wcel cJ cz wcel w3a cK
      cz wcel cK cneg cn0 wcel cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq
      cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa cA cJ cK
      cmul co cP co cA cJ cP co cK cP co wceq wi cG cgr wcel cA cX wcel wa cJ
      cz wcel cK cz wcel cK cneg cn0 wcel wa cA cJ cK cmul co cP co cA cJ cP co
      cK cP co wceq cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa cA cJ cK cmul co cP co cA cJ cP co cK cP co wceq cG cgr wcel
      cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a cA cJ cK cmul
      co cP co cA cJ cP co cK cneg cP co cG cgn cfv cfv cA cJ cP co cK cP co cG
      cgn cfv cfv cG cgn cfv cfv cA cJ cP co cK cP co cG cgr wcel cA cX wcel cJ
      cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a cA cJ cK cmul co cP co cA
      cJ cP co cG cgn cfv cfv cK cneg cP co cA cJ cP co cK cneg cP co cG cgn
      cfv cfv cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa
      wa w3a cA cJ cneg cK cneg cmul co cP co cA cJ cneg cP co cK cneg cP co cA
      cJ cK cmul co cP co cA cJ cP co cG cgn cfv cfv cK cneg cP co cG cgr wcel
      cA cX wcel cJ cneg cz wcel cK cneg cn0 wcel wa cA cJ cneg cK cneg cmul co
      cP co cA cJ cneg cP co cK cneg cP co wceq cJ cz wcel cK cz wcel cK cneg
      cn0 wcel wa wa cA cP cG cJ cneg cK cneg cX gxnn0mul.1 gxnn0mul.2 gxnn0mul
      cJ cz wcel cJ cneg cz wcel cK cz wcel cK cneg cn0 wcel wa cK cneg cn0
      wcel cJ znegcl cK cz wcel cK cneg cn0 wcel pm3.27 anim12i syl3an3 cG cgr
      wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a cJ cneg
      cK cneg cmul co cJ cK cmul co cA cP cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa cG cgr wcel cJ cneg cK cneg cmul co cJ cK cmul co wceq cA cX
      wcel cJ cc wcel cK cc wcel cJ cneg cK cneg cmul co cJ cK cmul co wceq cJ
      cz wcel cK cz wcel cK cneg cn0 wcel wa cJ cK mul2neg cJ zcn cK cz wcel cK
      cc wcel cK cneg cn0 wcel cK zcn adantr syl2an 3ad2ant3 opreq2d cG cgr
      wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a cA cJ
      cneg cP co cA cJ cP co cG cgn cfv cfv cK cneg cP cG cgr wcel cA cX wcel
      cJ cz wcel cA cJ cneg cP co cA cJ cP co cG cgn cfv cfv wceq cJ cz wcel cK
      cz wcel cK cneg cn0 wcel wa wa cA cP cG cJ cG cgn cfv cX gxnn0mul.1 cG
      cgn cfv eqid gxnn0mul.2 gxneg cJ cz wcel cK cz wcel cK cneg cn0 wcel wa
      pm3.26 syl3an3 opreq1d 3eqtr3d cG cgr wcel cA cJ cP co cX wcel cK cneg cz
      wcel cA cJ cP co cG cgn cfv cfv cK cneg cP co cA cJ cP co cK cneg cP co
      cG cgn cfv cfv wceq cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg
      cn0 wcel wa wa w3a cA cJ cP co cP cG cK cneg cG cgn cfv cX gxnn0mul.1 cG
      cgn cfv eqid gxnn0mul.2 gxinv cG cgr wcel cA cX wcel cJ cz wcel cK cz
      wcel cK cneg cn0 wcel wa wa 3simp1 cG cgr wcel cA cX wcel cJ cz wcel cA
      cJ cP co cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa cA cP cG cJ
      cX gxnn0mul.1 gxnn0mul.2 gxcl cJ cz wcel cK cz wcel cK cneg cn0 wcel wa
      pm3.26 syl3an3 cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa w3a cK cz wcel cK cneg cz wcel cJ cz wcel cK cz wcel cK cneg
      cn0 wcel wa wa cG cgr wcel cK cz wcel cA cX wcel cK cz wcel cK cneg cn0
      wcel wa cK cz wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel pm3.26 adantl
      3ad2ant3 cK znegcl syl syl3anc eqtrd cG cgr wcel cA cX wcel cJ cz wcel cK
      cz wcel cK cneg cn0 wcel wa wa w3a cA cJ cP co cK cneg cP co cA cJ cP co
      cK cP co cG cgn cfv cfv cG cgn cfv cG cgr wcel cA cJ cP co cX wcel cK cz
      wcel cA cJ cP co cK cneg cP co cA cJ cP co cK cP co cG cgn cfv cfv wceq
      cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa w3a
      cA cJ cP co cP cG cK cG cgn cfv cX gxnn0mul.1 cG cgn cfv eqid gxnn0mul.2
      gxneg cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa
      3simp1 cG cgr wcel cA cX wcel cJ cz wcel cA cJ cP co cX wcel cJ cz wcel
      cK cz wcel cK cneg cn0 wcel wa wa cA cP cG cJ cX gxnn0mul.1 gxnn0mul.2
      gxcl cJ cz wcel cK cz wcel cK cneg cn0 wcel wa pm3.26 syl3an3 cJ cz wcel
      cK cz wcel cK cneg cn0 wcel wa wa cG cgr wcel cK cz wcel cA cX wcel cK cz
      wcel cK cneg cn0 wcel wa cK cz wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel pm3.26 adantl 3ad2ant3 syl3anc fveq2d cG cgr wcel cA cJ cP co cK cP
      co cX wcel cA cJ cP co cK cP co cG cgn cfv cfv cG cgn cfv cfv cA cJ cP co
      cK cP co wceq cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa w3a cA cJ cP co cK cP co cG cG cgn cfv cX gxnn0mul.1 cG cgn
      cfv eqid grp2inv cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa 3simp1 cG cgr wcel cA cJ cP co cX wcel cK cz wcel cA cJ cP co
      cK cP co cX wcel cG cgr wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0
      wcel wa wa w3a cA cJ cP co cP cG cK cX gxnn0mul.1 gxnn0mul.2 gxcl cG cgr
      wcel cA cX wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel wa wa 3simp1 cG
      cgr wcel cA cX wcel cJ cz wcel cA cJ cP co cX wcel cJ cz wcel cK cz wcel
      cK cneg cn0 wcel wa wa cA cP cG cJ cX gxnn0mul.1 gxnn0mul.2 gxcl cJ cz
      wcel cK cz wcel cK cneg cn0 wcel wa pm3.26 syl3an3 cJ cz wcel cK cz wcel
      cK cneg cn0 wcel wa wa cG cgr wcel cK cz wcel cA cX wcel cK cz wcel cK
      cneg cn0 wcel wa cK cz wcel cJ cz wcel cK cz wcel cK cneg cn0 wcel pm3.26
      adantl 3ad2ant3 syl3anc sylanc 3eqtrd 3expia exp3a 3impia exp3a imp jaod
      mpd ex 3expia imp3a 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    gxmodid.1 $e |- X = ran G $.
    gxmodid.2 $e |- U = ( Id ` G ) $.
    gxmodid.3 $e |- P = ( ^g ` G ) $.
    $( Casting out powers of the identity element leaves the group power
       unchanged.  (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxmodid $p |- ( ( G e. Grp /\ ( K e. ZZ /\ M e. NN ) /\
      ( A e. X /\ ( A P M ) = U ) ) -> ( A P ( K mod M ) ) = ( A P K ) ) $=
      cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa
      w3a cA cK cM cmo co cP co cA cK cP co cA cM cK cM cdiv co cfl cfv cmul co
      cneg cP co cG co cA cK cP co cU cG co cA cK cP co cG cgr wcel cK cz wcel
      cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa w3a cA cK cM cmo co cP co
      cA cK cM cK cM cdiv co cfl cfv cmul co cmin co cP co cA cK cM cK cM cdiv
      co cfl cfv cmul co cneg caddc co cP co cA cK cP co cA cM cK cM cdiv co
      cfl cfv cmul co cneg cP co cG co cG cgr wcel cK cz wcel cM cn wcel wa cA
      cX wcel cA cM cP co cU wceq wa w3a cK cM cmo co cK cM cK cM cdiv co cfl
      cfv cmul co cmin co cA cP cK cz wcel cM cn wcel wa cG cgr wcel cK cM cmo
      co cK cM cK cM cdiv co cfl cfv cmul co cmin co wceq cA cX wcel cA cM cP
      co cU wceq wa cK cr wcel cM crp wcel cK cM cmo co cK cM cK cM cdiv co cfl
      cfv cmul co cmin co wceq cK cz wcel cM cn wcel cK cM modval cK zre cM
      nnrp syl2an 3ad2ant2 opreq2d cG cgr wcel cK cz wcel cM cn wcel wa cA cX
      wcel cA cM cP co cU wceq wa w3a cK cM cK cM cdiv co cfl cfv cmul co cneg
      caddc co cK cM cK cM cdiv co cfl cfv cmul co cmin co cA cP cK cz wcel cM
      cn wcel wa cG cgr wcel cK cM cK cM cdiv co cfl cfv cmul co cneg caddc co
      cK cM cK cM cdiv co cfl cfv cmul co cmin co wceq cA cX wcel cA cM cP co
      cU wceq wa cK cc wcel cM cK cM cdiv co cfl cfv cmul co cc wcel cK cM cK
      cM cdiv co cfl cfv cmul co cneg caddc co cK cM cK cM cdiv co cfl cfv cmul
      co cmin co wceq cK cz wcel cM cn wcel wa cK cM cK cM cdiv co cfl cfv cmul
      co negsub cK cz wcel cM cn wcel wa cK cz wcel cK cc wcel cK cz wcel cM cn
      wcel pm3.26 cK zcn syl cK cz wcel cM cn wcel wa cM cK cM cdiv co cfl cfv
      cmul co cz wcel cM cK cM cdiv co cfl cfv cmul co cc wcel cM cz wcel cK cM
      cdiv co cfl cfv cz wcel cM cK cM cdiv co cfl cfv cmul co cz wcel cK cz
      wcel cM cn wcel wa cM cK cM cdiv co cfl cfv zmulcl cM cn wcel cM cz wcel
      cK cz wcel cM nnz adantl cK cz wcel cM cn wcel wa cK cM cdiv co cr wcel
      cK cM cdiv co cfl cfv cz wcel cK cz wcel cM cn wcel cK cM cdiv co cr wcel
      cK cr wcel cM cr wcel cM cc0 wne cK cM cdiv co cr wcel cK cz wcel cM cn
      wcel cM cn wcel cK cM redivcl cK zre cM nnre cM nnne0 syl3an 3anidm23 cK
      cM cdiv co flcl syl sylanc cM cK cM cdiv co cfl cfv cmul co zcn syl
      sylanc 3ad2ant2 opreq2d cG cgr wcel cA cX wcel cK cz wcel cM cK cM cdiv
      co cfl cfv cmul co cneg cz wcel wa cA cK cM cK cM cdiv co cfl cfv cmul co
      cneg caddc co cP co cA cK cP co cA cM cK cM cdiv co cfl cfv cmul co cneg
      cP co cG co wceq cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP
      co cU wceq wa w3a cA cP cG cK cM cK cM cdiv co cfl cfv cmul co cneg cX
      gxmodid.1 gxmodid.3 gxadd cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel
      cA cM cP co cU wceq wa 3simp1 cA cX wcel cA cM cP co cU wceq wa cG cgr
      wcel cA cX wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq
      pm3.26 3ad2ant3 cK cz wcel cM cn wcel wa cG cgr wcel cK cz wcel cM cK cM
      cdiv co cfl cfv cmul co cneg cz wcel wa cA cX wcel cA cM cP co cU wceq wa
      cK cz wcel cM cn wcel wa cK cz wcel cM cK cM cdiv co cfl cfv cmul co cneg
      cz wcel cK cz wcel cM cn wcel pm3.26 cK cz wcel cM cn wcel wa cM cK cM
      cdiv co cfl cfv cmul co cz wcel cM cK cM cdiv co cfl cfv cmul co cneg cz
      wcel cM cz wcel cK cM cdiv co cfl cfv cz wcel cM cK cM cdiv co cfl cfv
      cmul co cz wcel cK cz wcel cM cn wcel wa cM cK cM cdiv co cfl cfv zmulcl
      cM cn wcel cM cz wcel cK cz wcel cM nnz adantl cK cz wcel cM cn wcel wa
      cK cM cdiv co cr wcel cK cM cdiv co cfl cfv cz wcel cK cz wcel cM cn wcel
      cK cM cdiv co cr wcel cK cr wcel cM cr wcel cM cc0 wne cK cM cdiv co cr
      wcel cK cz wcel cM cn wcel cM cn wcel cK cM redivcl cK zre cM nnre cM
      nnne0 syl3an 3anidm23 cK cM cdiv co flcl syl sylanc cM cK cM cdiv co cfl
      cfv cmul co znegcl syl jca 3ad2ant2 syl3anc 3eqtr2d cG cgr wcel cK cz
      wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa w3a cA cM cK cM cdiv
      co cfl cfv cmul co cneg cP co cU cA cK cP co cG cG cgr wcel cK cz wcel cM
      cn wcel wa cA cX wcel cA cM cP co cU wceq wa w3a cA cM cK cM cdiv co cfl
      cfv cneg cmul co cP co cA cM cK cM cdiv co cfl cfv cmul co cneg cP co cU
      cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa
      w3a cM cK cM cdiv co cfl cfv cneg cmul co cM cK cM cdiv co cfl cfv cmul
      co cneg cA cP cK cz wcel cM cn wcel wa cG cgr wcel cM cK cM cdiv co cfl
      cfv cneg cmul co cM cK cM cdiv co cfl cfv cmul co cneg wceq cA cX wcel cA
      cM cP co cU wceq wa cM cc wcel cK cM cdiv co cfl cfv cc wcel cM cK cM
      cdiv co cfl cfv cneg cmul co cM cK cM cdiv co cfl cfv cmul co cneg wceq
      cK cz wcel cM cn wcel wa cM cK cM cdiv co cfl cfv mulneg2 cK cz wcel cM
      cn wcel wa cM cz wcel cM cc wcel cM cn wcel cM cz wcel cK cz wcel cM nnz
      adantl cM zcn syl cK cz wcel cM cn wcel wa cK cM cdiv co cfl cfv cz wcel
      cK cM cdiv co cfl cfv cc wcel cK cz wcel cM cn wcel wa cK cM cdiv co cr
      wcel cK cM cdiv co cfl cfv cz wcel cK cz wcel cM cn wcel cK cM cdiv co cr
      wcel cK cr wcel cM cr wcel cM cc0 wne cK cM cdiv co cr wcel cK cz wcel cM
      cn wcel cM cn wcel cK cM redivcl cK zre cM nnre cM nnne0 syl3an 3anidm23
      cK cM cdiv co flcl syl cK cM cdiv co cfl cfv zcn syl sylanc 3ad2ant2
      opreq2d cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU
      wceq wa w3a cA cM cK cM cdiv co cfl cfv cneg cmul co cP co cA cM cP co cK
      cM cdiv co cfl cfv cneg cP co cU cK cM cdiv co cfl cfv cneg cP co cU cG
      cgr wcel cA cX wcel cM cz wcel cK cM cdiv co cfl cfv cneg cz wcel wa cA
      cM cK cM cdiv co cfl cfv cneg cmul co cP co cA cM cP co cK cM cdiv co cfl
      cfv cneg cP co wceq cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM
      cP co cU wceq wa w3a cA cP cG cM cK cM cdiv co cfl cfv cneg cX gxmodid.1
      gxmodid.3 gxmul cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP
      co cU wceq wa 3simp1 cA cX wcel cA cM cP co cU wceq wa cG cgr wcel cA cX
      wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq pm3.26
      3ad2ant3 cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU
      wceq wa w3a cM cz wcel cK cM cdiv co cfl cfv cneg cz wcel cK cz wcel cM
      cn wcel wa cG cgr wcel cM cz wcel cA cX wcel cA cM cP co cU wceq wa cM cn
      wcel cM cz wcel cK cz wcel cM nnz adantl 3ad2ant2 cK cz wcel cM cn wcel
      wa cG cgr wcel cK cM cdiv co cfl cfv cneg cz wcel cA cX wcel cA cM cP co
      cU wceq wa cK cz wcel cM cn wcel wa cK cM cdiv co cfl cfv cz wcel cK cM
      cdiv co cfl cfv cneg cz wcel cK cz wcel cM cn wcel wa cK cM cdiv co cr
      wcel cK cM cdiv co cfl cfv cz wcel cK cz wcel cM cn wcel cK cM cdiv co cr
      wcel cK cr wcel cM cr wcel cM cc0 wne cK cM cdiv co cr wcel cK cz wcel cM
      cn wcel cM cn wcel cK cM redivcl cK zre cM nnre cM nnne0 syl3an 3anidm23
      cK cM cdiv co flcl syl cK cM cdiv co cfl cfv znegcl syl 3ad2ant2 jca
      syl3anc cA cX wcel cA cM cP co cU wceq wa cG cgr wcel cA cM cP co cK cM
      cdiv co cfl cfv cneg cP co cU cK cM cdiv co cfl cfv cneg cP co wceq cK cz
      wcel cM cn wcel wa cA cM cP co cU wceq cA cM cP co cK cM cdiv co cfl cfv
      cneg cP co cU cK cM cdiv co cfl cfv cneg cP co wceq cA cX wcel cA cM cP
      co cU cK cM cdiv co cfl cfv cneg cP opreq1 adantl 3ad2ant3 cG cgr wcel cK
      cM cdiv co cfl cfv cneg cz wcel cU cK cM cdiv co cfl cfv cneg cP co cU
      wceq cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq
      wa w3a cP cU cG cK cM cdiv co cfl cfv cneg gxmodid.2 gxmodid.3 gxid cG
      cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa
      3simp1 cK cz wcel cM cn wcel wa cG cgr wcel cK cM cdiv co cfl cfv cneg cz
      wcel cA cX wcel cA cM cP co cU wceq wa cK cz wcel cM cn wcel wa cK cM
      cdiv co cfl cfv cz wcel cK cM cdiv co cfl cfv cneg cz wcel cK cz wcel cM
      cn wcel wa cK cM cdiv co cr wcel cK cM cdiv co cfl cfv cz wcel cK cz wcel
      cM cn wcel cK cM cdiv co cr wcel cK cr wcel cM cr wcel cM cc0 wne cK cM
      cdiv co cr wcel cK cz wcel cM cn wcel cM cn wcel cK cM redivcl cK zre cM
      nnre cM nnne0 syl3an 3anidm23 cK cM cdiv co flcl syl cK cM cdiv co cfl
      cfv znegcl syl 3ad2ant2 sylanc 3eqtrd eqtr3d opreq2d cG cgr wcel cA cK cP
      co cX wcel cA cK cP co cU cG co cA cK cP co wceq cG cgr wcel cK cz wcel
      cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa w3a cA cK cP co cU cG cX
      gxmodid.1 gxmodid.2 grprid cG cgr wcel cK cz wcel cM cn wcel wa cA cX
      wcel cA cM cP co cU wceq wa 3simp1 cG cgr wcel cA cX wcel cK cz wcel cA
      cK cP co cX wcel cG cgr wcel cK cz wcel cM cn wcel wa cA cX wcel cA cM cP
      co cU wceq wa w3a cA cP cG cK cX gxmodid.1 gxmodid.3 gxcl cG cgr wcel cK
      cz wcel cM cn wcel wa cA cX wcel cA cM cP co cU wceq wa 3simp1 cA cX wcel
      cA cM cP co cU wceq wa cG cgr wcel cA cX wcel cK cz wcel cM cn wcel wa cA
      cX wcel cA cM cP co cU wceq pm3.26 3ad2ant3 cK cz wcel cM cn wcel wa cG
      cgr wcel cK cz wcel cA cX wcel cA cM cP co cU wceq wa cK cz wcel cM cn
      wcel pm3.26 3ad2ant2 syl3anc sylanc 3eqtrd $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

  ${
    resgrprn.1 $e |- H = ( G |` ( Y X. Y ) ) $.
    $( The underlying set of a group operation which is a restriction of a
       mapping.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
    resgrprn $p |- ( ( dom G = ( X X. X ) /\ H e. Grp /\ Y C_ X ) ->
                        Y = ran H ) $=
      cG cdm cX cX cxp wceq cH cgr wcel cY cX wss w3a cY cY cxp cH crn cH crn
      cxp wceq cY cH crn wceq cG cdm cX cX cxp wceq cH cgr wcel cY cX wss w3a
      cH cdm cY cY cxp cH crn cH crn cxp cG cdm cX cX cxp wceq cY cX wss cH cdm
      cY cY cxp wceq cH cgr wcel cG cdm cX cX cxp wceq cY cX wss wa cG cY cY
      cxp cres cdm cY cY cxp cH cdm cG cdm cX cX cxp wceq cY cX wss wa cY cY
      cxp cG cdm wss cG cY cY cxp cres cdm cY cY cxp wceq cG cdm cX cX cxp wceq
      cY cY cxp cX cX cxp wss cY cY cxp cG cdm wss cY cX wss cG cdm cX cX cxp
      wceq cY cY cxp cG cdm wss cY cY cxp cX cX cxp wss cG cdm cX cX cxp cY cY
      cxp sseq2 biimpar cY cX wss cY cY cxp cX cX cxp wss cY cX cY cX ssxp
      anidms sylan2 cY cY cxp cG ssdmres sylib cH cG cY cY cxp cres resgrprn.1
      dmeqi syl5eq 3adant2 cH cgr wcel cG cdm cX cX cxp wceq cH cdm cH crn cH
      crn cxp wceq cY cX wss cH cgr wcel cH crn cH crn cxp cH crn cH wfo cH crn
      cH crn cxp cH crn cH wf cH cdm cH crn cH crn cxp wceq cH cH crn cH crn
      eqid grpfo cH crn cH crn cxp cH crn cH fof cH crn cH crn cxp cH crn cH
      fdm 3syl 3ad2ant2 eqtr3d cY cH crn xpid11 sylib $.
      $( [25-Apr-2008] $) $( [25-Mar-2008] $)
  $}

  ${
    $d A a b g h x y $.  $d B a b $.  $d F x y $.  $d G a b g h x y $.
    $d X a b g h x y $.
    grplact.1 $e |- F = { <. g , h >. | ( g e. X /\ h = { <. a , b >. |
                          ( a e. X /\ b = ( g G a ) ) } ) } $.
    grplact.2 $e |- X = ran G $.

    $( The left group action of element ` A ` of group ` G ` .  (Contributed by
       Paul Chapman, 18-Mar-2008.) $)
    grplactfval $p |- ( ( G e. Grp /\ A e. X ) ->
                ( F ` A ) = { <. a , b >. | ( a e. X /\ b = ( A G a ) ) } ) $=
      cA cX wcel cG cgr wcel cA cF cfv va cv cX wcel vb cv cA va cv cG co wceq
      wa va vb copab wceq cA cX wcel va cv cX wcel vb cv cA va cv cG co wceq wa
      va vb copab cvv wcel cA cF cfv va cv cX wcel vb cv cA va cv cG co wceq wa
      va vb copab wceq cG cgr wcel vg vh cA va cv cX wcel vb cv vg cv va cv cG
      co wceq wa va vb copab va cv cX wcel vb cv cA va cv cG co wceq wa va vb
      copab cX cvv cF vg cv cA wceq va cv cX wcel vb cv vg cv va cv cG co wceq
      wa va cv cX wcel vb cv cA va cv cG co wceq wa va vb vg cv cA wceq vb cv
      vg cv va cv cG co wceq vb cv cA va cv cG co wceq va cv cX wcel vg cv cA
      wceq vg cv va cv cG co cA va cv cG co vb cv vg cv cA va cv cG opreq1
      eqeq2d anbi2d opabbidv grplact.1 fvopab4g cG cgr wcel cX cvv wcel va cv
      cX wcel vb cv cA va cv cG co wceq wa va vb copab cvv wcel cG cgr wcel cG
      crn cvv cX cG cgr rnexg grplact.2 syl5eqel va vb cX cA va cv cG co cvv
      opabex2g syl sylan2 ancoms $.
      $( [18-Mar-2008] $) $( [18-Mar-2008] $)

    $( The value of the left group action of element ` A ` of group ` G ` at
       ` B ` .  (Contributed by Paul Chapman, 18-Mar-2008.) $)
    grplactval $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                       ( ( F ` A ) ` B ) = ( A G B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cB cA cF cfv cfv cB va cv cX wcel
      vb cv cA va cv cG co wceq wa va vb copab cfv cA cB cG co cG cgr wcel cA
      cX wcel cB cX wcel w3a cB cA cF cfv va cv cX wcel vb cv cA va cv cG co
      wceq wa va vb copab cG cgr wcel cA cX wcel cA cF cfv va cv cX wcel vb cv
      cA va cv cG co wceq wa va vb copab wceq cB cX wcel cA vg vh cF cG cX va
      vb grplact.1 grplact.2 grplactfval 3adant3 fveq1d cB cX wcel cG cgr wcel
      cB va cv cX wcel vb cv cA va cv cG co wceq wa va vb copab cfv cA cB cG co
      wceq cA cX wcel va vb cB cA va cv cG co cA cB cG co cX va cv cX wcel vb
      cv cA va cv cG co wceq wa va vb copab va cv cB cA cG opreq2 va cv cX wcel
      vb cv cA va cv cG co wceq wa va vb copab eqid cA cB cG oprex fvopab4
      3ad2ant3 eqtrd $.
      $( [18-Mar-2008] $) $( [18-Mar-2008] $)

    $( The left group action of element ` A ` of group ` G ` maps the
       underlying set ` X ` of ` G ` one-to-one onto itself.  (Contributed by
       Paul Chapman, 18-Mar-2008.) $)
    grplactf1o $p |- ( ( G e. Grp /\ A e. X ) ->
                       ( F ` A ) : X -1-1-onto-> X ) $=
      cX cX cA cF cfv wf1o cX cX cA cF cfv wf1 cA cF cfv crn cX wceq cG cgr
      wcel cA cX wcel wa cX cX cA cF cfv dff1o5 cX cX cA cF cfv wf1 cX cX cA cF
      cfv wf vx cv cA cF cfv cfv vy cv cA cF cfv cfv wceq vx cv vy cv wceq wi
      vy cX wral vx cX wral cG cgr wcel cA cX wcel wa vx vy cX cX cA cF cfv
      dff13 cG cgr wcel cA cX wcel wa cX cX cA cF cfv wf cX cX va cv cX wcel vb
      cv cA va cv cG co wceq wa va vb copab wf cG cgr wcel cA cX wcel wa cA va
      cv cG co cX wcel va cX wral cX cX va cv cX wcel vb cv cA va cv cG co wceq
      wa va vb copab wf cG cgr wcel cA cX wcel wa cA va cv cG co cX wcel va cX
      cG cgr wcel cA cX wcel va cv cX wcel cA va cv cG co cX wcel cA va cv cG
      cX grplact.2 grpcl 3expia r19.21aiv va vb cX cX cA va cv cG co va cv cX
      wcel vb cv cA va cv cG co wceq wa va vb copab va cv cX wcel vb cv cA va
      cv cG co wceq wa va vb copab eqid fopab2 sylib cG cgr wcel cA cX wcel wa
      cX cX cA cF cfv va cv cX wcel vb cv cA va cv cG co wceq wa va vb copab cA
      vg vh cF cG cX va vb grplact.1 grplact.2 grplactfval feq1d mpbird cG cgr
      wcel cA cX wcel wa vx cv cA cF cfv cfv vy cv cA cF cfv cfv wceq vx cv vy
      cv wceq wi vx vy cX cX cG cgr wcel cA cX wcel wa vx cv cX wcel vy cv cX
      wcel wa vx cv cA cF cfv cfv vy cv cA cF cfv cfv wceq vx cv vy cv wceq wi
      cG cgr wcel cA cX wcel wa vx cv cX wcel vy cv cX wcel wa wa vx cv cA cF
      cfv cfv vy cv cA cF cfv cfv wceq vx cv vy cv wceq cG cgr wcel cA cX wcel
      wa vx cv cX wcel vy cv cX wcel wa wa vx cv cA cF cfv cfv vy cv cA cF cfv
      cfv wceq cA vx cv cG co cA vy cv cG co wceq vx cv vy cv wceq cG cgr wcel
      cA cX wcel wa vx cv cX wcel vy cv cX wcel wa wa vx cv cA cF cfv cfv cA vx
      cv cG co wceq vy cv cA cF cfv cfv cA vy cv cG co wceq wa vx cv cA cF cfv
      cfv vy cv cA cF cfv cfv wceq cA vx cv cG co cA vy cv cG co wceq wb cG cgr
      wcel cA cX wcel wa vx cv cX wcel vy cv cX wcel wa vx cv cA cF cfv cfv cA
      vx cv cG co wceq vy cv cA cF cfv cfv cA vy cv cG co wceq wa cG cgr wcel
      cA cX wcel wa vx cv cX wcel vx cv cA cF cfv cfv cA vx cv cG co wceq vy cv
      cX wcel vy cv cA cF cfv cfv cA vy cv cG co wceq cG cgr wcel cA cX wcel vx
      cv cX wcel vx cv cA cF cfv cfv cA vx cv cG co wceq cA vx cv vg vh cF cG
      cX va vb grplact.1 grplact.2 grplactval 3expia cG cgr wcel cA cX wcel vy
      cv cX wcel vy cv cA cF cfv cfv cA vy cv cG co wceq cA vy cv vg vh cF cG
      cX va vb grplact.1 grplact.2 grplactval 3expia anim12d imp vx cv cA cF
      cfv cfv cA vx cv cG co vy cv cA cF cfv cfv cA vy cv cG co eqeq12 syl vx
      cv cX wcel vy cv cX wcel wa cG cgr wcel cA cX wcel wa cA vx cv cG co cA
      vy cv cG co wceq vx cv vy cv wceq wb vx cv cX wcel vy cv cX wcel wa cG
      cgr wcel cA cX wcel cA vx cv cG co cA vy cv cG co wceq vx cv vy cv wceq
      wb vx cv cX wcel vy cv cX wcel wa cA cX wcel cG cgr wcel cA vx cv cG co
      cA vy cv cG co wceq vx cv vy cv wceq wb vx cv cX wcel vy cv cX wcel cA cX
      wcel cG cgr wcel cA vx cv cG co cA vy cv cG co wceq vx cv vy cv wceq wb
      wi cG cgr wcel vx cv cX wcel vy cv cX wcel cA cX wcel w3a cA vx cv cG co
      cA vy cv cG co wceq vx cv vy cv wceq wb vx cv vy cv cA cG cX grplact.2
      grplcan expcom 3expia com23 imp3a impcom bitrd biimpd ex r19.21aivv
      sylanbrc cG cgr wcel cA cX wcel wa cA cF cfv crn cX cG cgr wcel cA cX
      wcel wa cX cX cA cF cfv wf cA cF cfv crn cX wss cG cgr wcel cA cX wcel wa
      cX cX cA cF cfv wf cX cX va cv cX wcel vb cv cA va cv cG co wceq wa va vb
      copab wf cG cgr wcel cA cX wcel wa cA va cv cG co cX wcel va cX wral cX
      cX va cv cX wcel vb cv cA va cv cG co wceq wa va vb copab wf cG cgr wcel
      cA cX wcel wa cA va cv cG co cX wcel va cX cG cgr wcel cA cX wcel va cv
      cX wcel cA va cv cG co cX wcel cA va cv cG cX grplact.2 grpcl 3expia
      r19.21aiv va vb cX cX cA va cv cG co va cv cX wcel vb cv cA va cv cG co
      wceq wa va vb copab va cv cX wcel vb cv cA va cv cG co wceq wa va vb
      copab eqid fopab2 sylib cG cgr wcel cA cX wcel wa cX cX cA cF cfv va cv
      cX wcel vb cv cA va cv cG co wceq wa va vb copab cA vg vh cF cG cX va vb
      grplact.1 grplact.2 grplactfval feq1d mpbird cX cX cA cF cfv frn syl cG
      cgr wcel cA cX wcel wa vy cX cA cF cfv crn cG cgr wcel cA cX wcel wa vy
      cv cX wcel vy cv cA va cv cG co wceq va cX wrex vy cv cA cF cfv crn wcel
      cG cgr wcel cA cX wcel vy cv cX wcel vy cv cA va cv cG co wceq va cX wrex
      cA cG cgn cfv cfv vy cv cG co cX wcel vy cv cA cA cG cgn cfv cfv vy cv cG
      co cG co wceq vy cv cA va cv cG co wceq va cX wrex cG cgr wcel cA cX wcel
      vy cv cX wcel w3a vy cv cA va cv cG co wceq vy cv cA cA cG cgn cfv cfv vy
      cv cG co cG co wceq va cA cG cgn cfv cfv vy cv cG co cX va cv cA cG cgn
      cfv cfv vy cv cG co wceq cA va cv cG co cA cA cG cgn cfv cfv vy cv cG co
      cG co vy cv va cv cA cG cgn cfv cfv vy cv cG co cA cG opreq2 eqeq2d
      rcla4ev cG cgr wcel cA cX wcel vy cv cX wcel cA cG cgn cfv cfv vy cv cG
      co cX wcel cG cgr wcel cA cX wcel cA cG cgn cfv cfv cX wcel vy cv cX wcel
      cA cG cgn cfv cfv vy cv cG co cX wcel wi cA cG cG cgn cfv cX grplact.2 cG
      cgn cfv eqid grpinvcl cG cgr wcel cA cG cgn cfv cfv cX wcel vy cv cX wcel
      cA cG cgn cfv cfv vy cv cG co cX wcel cA cG cgn cfv cfv vy cv cG cX
      grplact.2 grpcl 3expia syldan 3impia cG cgr wcel cA cX wcel vy cv cX wcel
      w3a cA cA cG cgn cfv cfv vy cv cG co cG co vy cv cA vy cv cG cG cgn cfv
      cX grplact.2 cG cgn cfv eqid grpasscan1 eqcomd sylanc 3expia cG cgr wcel
      cA cX wcel wa vy cv cA cF cfv crn wcel vy cv va cv cX wcel vb cv cA va cv
      cG co wceq wa va vb copab crn wcel vy cv cA va cv cG co wceq va cX wrex
      cG cgr wcel cA cX wcel wa cA cF cfv crn va cv cX wcel vb cv cA va cv cG
      co wceq wa va vb copab crn vy cv cG cgr wcel cA cX wcel wa cA cF cfv va
      cv cX wcel vb cv cA va cv cG co wceq wa va vb copab cA vg vh cF cG cX va
      vb grplact.1 grplact.2 grplactfval rneqd eleq2d vy cv va cv cX wcel vb cv
      cA va cv cG co wceq wa va vb copab crn wcel vy cv cA va cv cG co wceq va
      cX wrex va vb cX cA va cv cG co vy cv va cv cX wcel vb cv cA va cv cG co
      wceq wa va vb copab cA va cv cG oprex va cv cX wcel vb cv cA va cv cG co
      wceq wa va vb copab eqid elrnopab biimpri syl5bir syld ssrdv eqssd
      sylanbrc $.
      $( [21-Apr-2008] $) $( [18-Mar-2008] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Definition and basic properties of Abelian groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Abel $.

  $( Extend class notation with the class of all Abelian group operations. $)
  cabl $a class Abel $.

  ${
    $d g x y $.
    $( Define the class of all Abelian group operations. $)
    df-abl $a |- Abel = { g e. Grp | A. x e. ran g A. y e. ran g ( x g y ) =
                 ( y g x ) } $.
  $}

  ${
    $d g x y G $.  $d g x y X $.
    isabl.1 $e |- X = ran G $.
    $( The predicate "is an Abelian (commutative) group operation." $)
    isabl $p |- ( G e. Abel <-> ( G e. Grp /\
             A. x e. X A. y e. X ( x G y ) = ( y G x ) ) ) $=
      vx cv vy cv vg cv co vy cv vx cv vg cv co wceq vy vg cv crn wral vx vg cv
      crn wral vx cv vy cv cG co vy cv vx cv cG co wceq vy cX wral vx cX wral
      vg cG cgr cabl vg cv cG wceq vx cv vy cv vg cv co vy cv vx cv vg cv co
      wceq vy vg cv crn wral vx vg cv crn wral vx cv vy cv vg cv co vy cv vx cv
      vg cv co wceq vy cX wral vx cX wral vx cv vy cv cG co vy cv vx cv cG co
      wceq vy cX wral vx cX wral vg cv cG wceq vg cv crn cX wceq vx cv vy cv vg
      cv co vy cv vx cv vg cv co wceq vy vg cv crn wral vx vg cv crn wral vx cv
      vy cv vg cv co vy cv vx cv vg cv co wceq vy cX wral vx cX wral wb vg cv
      cG wceq vg cv crn cG crn cX vg cv cG rneq isabl.1 syl6eqr vx cv vy cv vg
      cv co vy cv vx cv vg cv co wceq vy vg cv crn wral vx cv vy cv vg cv co vy
      cv vx cv vg cv co wceq vy cX wral vx vg cv crn cX vx cv vy cv vg cv co vy
      cv vx cv vg cv co wceq vy vg cv crn cX raleq1 raleqd syl vg cv cG wceq vx
      cv vy cv vg cv co vy cv vx cv vg cv co wceq vx cv vy cv cG co vy cv vx cv
      cG co wceq vx vy cX cX vg cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG
      co vy cv vx cv vg cv co vy cv vx cv cG co vx cv vy cv vg cv cG opreq vy
      cv vx cv vg cv cG opreq eqeq12d 2ralbidv bitrd vx vy vg df-abl elrab2 $.
      $( [4-Nov-2006] $) $( [2-Nov-2006] $)
  $}

  ${
    $d x y G $.
    $( An Abelian group operation is a group operation. $)
    ablgrp $p |- ( G e. Abel -> G e. Grp ) $=
      cG cabl wcel cG cgr wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cG
      crn wral vx cG crn wral vx vy cG cG crn cG crn eqid isabl pm3.26bi $.
      $( [6-Nov-2006] $) $( [2-Nov-2006] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y X $.
    ablcom.1 $e |- X = ran G $.
    $( An Abelian group operation is commutative. $)
    ablcom $p |- ( ( G e. Abel /\ A e. X /\ B e. X ) ->
                 ( A G B ) = ( B G A ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cA cX
      wcel cB cX wcel wa vx cv vy cv cG co vy cv vx cv cG co wceq vy cX wral vx
      cX wral cA cB cG co cB cA cG co wceq cG cabl wcel vx cv vy cv cG co vy cv
      vx cv cG co wceq cA cB cG co cB cA cG co wceq cA vy cv cG co vy cv cA cG
      co wceq vx vy cA cB cX cX vx cv cA wceq vx cv vy cv cG co cA vy cv cG co
      vy cv vx cv cG co vy cv cA cG co vx cv cA vy cv cG opreq1 vx cv cA vy cv
      cG opreq2 eqeq12d vy cv cB wceq cA vy cv cG co cA cB cG co vy cv cA cG co
      cB cA cG co vy cv cB cA cG opreq2 vy cv cB cA cG opreq1 eqeq12d rcla42v
      cG cabl wcel cG cgr wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cX
      wral vx cX wral vx vy cG cX ablcom.1 isabl pm3.27bi syl5com 3impib $.
      $( [10-Nov-2006] $) $( [2-Nov-2006] $)

    $( Commutative/associative law for Abelian groups. $)
    abl23 $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cG co cG co
      cA cC cB cG co cG co cA cB cG co cC cG co cA cC cG co cB cG co cG cabl
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cB cC cG co cC cB cG co cA
      cG cG cabl wcel cB cX wcel cC cX wcel cB cC cG co cC cB cG co wceq cA cX
      wcel cB cC cG cX ablcom.1 ablcom 3adant3r1 opreq2d cG cgr wcel cA cX wcel
      cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA cB cC cG co cG co wceq
      cG cabl wcel cA cB cC cG cX ablcom.1 grpass cG ablgrp sylan cG cgr wcel
      cA cX wcel cB cX wcel cC cX wcel w3a cA cC cG co cB cG co cA cC cB cG co
      cG co wceq cG cabl wcel cG cgr wcel cA cX wcel cC cX wcel cB cX wcel w3a
      cA cC cG co cB cG co cA cC cB cG co cG co wceq cA cX wcel cB cX wcel cC
      cX wcel w3a cA cC cB cG cX ablcom.1 grpass cA cX wcel cB cX wcel cC cX
      wcel 3ancomb sylan2b cG ablgrp sylan 3eqtr4d $.
      $( [26-Apr-2007] $) $( [26-Apr-2007] $)

    $( Commutative/associative law for Abelian groups. $)
    abl4 $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X ) )
               -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa cA cB cG
      co cC cD cG co cG co cA cC cG co cB cD cG co cG co wceq cG cabl wcel cA
      cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa wa cA cB cG co cC cG co
      cD cG co cA cC cG co cB cG co cD cG co cA cB cG co cC cD cG co cG co cA
      cC cG co cB cD cG co cG co cG cabl wcel cA cX wcel cB cX wcel wa cC cX
      wcel cD cX wcel wa wa wa cA cB cG co cC cG co cA cC cG co cB cG co cD cG
      cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cA cX
      wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA cC cG co cB cG co
      wceq cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa wa
      cA cX wcel cB cX wcel cC cX wcel cG cabl wcel cA cX wcel cB cX wcel cC cX
      wcel cD cX wcel wa simprll cG cabl wcel cA cX wcel cB cX wcel cC cX wcel
      cD cX wcel wa simprlr cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD
      cX wcel simprrl 3jca cA cB cC cG cX ablcom.1 abl23 syldan opreq1d cG cgr
      wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cA cB cG co cC
      cG co cD cG co cA cB cG co cC cD cG co cG co wceq cG cabl wcel cG cgr
      wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cA cB cG co cX
      wcel cC cX wcel cD cX wcel w3a cA cB cG co cC cG co cD cG co cA cB cG co
      cC cD cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel wa cC cX wcel cD
      cX wcel wa wa wa cA cB cG co cX wcel cC cX wcel cD cX wcel cG cgr wcel cA
      cX wcel cB cX wcel wa cA cB cG co cX wcel cC cX wcel cD cX wcel wa cG cgr
      wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cA cB cG cX ablcom.1 grpcl
      3expb adantrr cG cgr wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel
      simprrl cG cgr wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel
      simprrr 3jca cA cB cG co cC cD cG cX ablcom.1 grpass syldan cG ablgrp
      sylan cG cgr wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cA
      cC cG co cB cG co cD cG co cA cC cG co cB cD cG co cG co wceq cG cabl
      wcel cG cgr wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cA
      cC cG co cX wcel cB cX wcel cD cX wcel w3a cA cC cG co cB cG co cD cG co
      cA cC cG co cB cD cG co cG co wceq cG cgr wcel cA cX wcel cB cX wcel wa
      cC cX wcel cD cX wcel wa wa wa cA cC cG co cX wcel cB cX wcel cD cX wcel
      cG cgr wcel cA cX wcel cB cX wcel wa cC cX wcel cA cC cG co cX wcel cD cX
      wcel cG cgr wcel cA cX wcel cC cX wcel cA cC cG co cX wcel cB cX wcel cG
      cgr wcel cA cX wcel cC cX wcel cA cC cG co cX wcel cA cC cG cX ablcom.1
      grpcl 3expb adantrlr adantrrr cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel cD cX wcel wa simprlr cG cgr wcel cA cX wcel cB cX wcel wa cC cX
      wcel cD cX wcel simprrr 3jca cA cC cG co cB cD cG cX ablcom.1 grpass
      syldan cG ablgrp sylan 3eqtr3d 3impb $.
      $( [2-May-2007] $) $( [26-Apr-2007] $)
  $}

  ${
    $d x y G $.  $d x y X $.
    isabli.1 $e |- G e. Grp $.
    isabli.2 $e |- dom G = ( X X. X ) $.
    isabli.3 $e |- ( ( x e. X /\ y e. X ) -> ( x G y ) = ( y G x ) ) $.
    $( Properties that determine an Abelian group operation. $)
    isabli $p |- G e. Abel $=
      cG cabl wcel cG cgr wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cX
      wral vx cX wral vx vy cG cX cG cX isabli.1 isabli.2 grprn isabl isabli.1
      vx cv vy cv cG co vy cv vx cv cG co wceq vx vy cX isabli.3 rgen2a
      mpbir2an $.
      $( [9-Apr-2008] $) $( [5-Nov-2006] $)
  $}

  ${
    abldiv.1 $e |- X = ran G $.
    abldiv.3 $e |- D = ( /g ` G ) $.
    $( Law for group multiplication and division. $)
    ablmuldiv $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
     ( ( A G B ) D C ) = ( ( A D C ) G B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cG co cC cD co
      cB cA cG co cC cD co cB cA cC cD co cG co cA cC cD co cB cG co cG cabl
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cG co cB cA cG co cC
      cD cG cabl wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cC cX
      wcel cA cB cG cX abldiv.1 ablcom 3adant3r3 opreq1d cG cabl wcel cB cX
      wcel cA cX wcel cC cX wcel w3a cB cA cG co cC cD co cB cA cC cD co cG co
      wceq cA cX wcel cB cX wcel cC cX wcel w3a cG cgr wcel cB cX wcel cA cX
      wcel cC cX wcel w3a cB cA cG co cC cD co cB cA cC cD co cG co wceq cG
      cabl wcel cB cA cC cD cG cX abldiv.1 abldiv.3 grpmuldivass cG ablgrp
      sylan cA cX wcel cB cX wcel cC cX wcel 3ancoma sylan2b cG cabl wcel cA cX
      wcel cB cX wcel cC cX wcel w3a cB cX wcel cA cC cD co cX wcel wa cB cA cC
      cD co cG co cA cC cD co cB cG co wceq cG cabl wcel cA cX wcel cB cX wcel
      cC cX wcel w3a wa cB cX wcel cA cC cD co cX wcel cG cabl wcel cA cX wcel
      cB cX wcel cC cX wcel 3simpr2 cG cabl wcel cA cX wcel cC cX wcel cA cC cD
      co cX wcel cB cX wcel cG cgr wcel cA cX wcel cC cX wcel cA cC cD co cX
      wcel cG cabl wcel cA cC cD cG cX abldiv.1 abldiv.3 grpdivcl cG ablgrp
      syl3an1 3adant3r2 jca cG cabl wcel cB cX wcel cA cC cD co cX wcel cB cA
      cC cD co cG co cA cC cD co cB cG co wceq cB cA cC cD co cG cX abldiv.1
      ablcom 3expb syldan 3eqtrd $.
      $( [25-Feb-2008] $) $( [15-Feb-2008] $)

    $( Law for double group division. $)
    abldivdiv $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
    ( A D ( B D C ) ) = ( ( A D B ) G C ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cD co cD co
      cA cC cB cD co cG co cA cB cD co cC cG co cG cgr wcel cA cX wcel cB cX
      wcel cC cX wcel w3a cA cB cC cD co cD co cA cC cB cD co cG co wceq cG
      cabl wcel cA cB cC cD cG cX abldiv.1 abldiv.3 grpdivdiv cG ablgrp sylan
      cG cabl wcel cA cX wcel cC cX wcel cB cX wcel w3a cA cC cB cD co cG co cA
      cB cD co cC cG co wceq cA cX wcel cB cX wcel cC cX wcel w3a cG cabl wcel
      cA cX wcel cC cX wcel cB cX wcel w3a wa cA cC cG co cB cD co cA cC cB cD
      co cG co cA cB cD co cC cG co cG cgr wcel cA cX wcel cC cX wcel cB cX
      wcel w3a cA cC cG co cB cD co cA cC cB cD co cG co wceq cG cabl wcel cA
      cC cB cD cG cX abldiv.1 abldiv.3 grpmuldivass cG ablgrp sylan cA cC cB cD
      cG cX abldiv.1 abldiv.3 ablmuldiv eqtr3d cA cX wcel cB cX wcel cC cX wcel
      3ancomb sylan2b eqtrd $.
      $( [29-Feb-2008] $) $( [29-Feb-2008] $)

    $( Law for double group division. $)
    abldivdiv4 $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
    ( ( A D B ) D C ) = ( A D ( B G C ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cD co cC cD co
      cA cB cD co cC cG cgn cfv cfv cG co cA cB cC cG cgn cfv cfv cD co cD co
      cA cB cC cG co cD co cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA
      cB cD co cC cD co cA cB cD co cC cG cgn cfv cfv cG co wceq cG cabl wcel
      cG cgr wcel cA cB cD co cX wcel cC cX wcel cA cB cD co cC cD co cA cB cD
      co cC cG cgn cfv cfv cG co wceq cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel w3a wa cA cB cD co cC cD cG cG cgn cfv cX abldiv.1 cG cgn cfv eqid
      abldiv.3 grpdivval cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a
      pm3.26 cG cgr wcel cA cX wcel cB cX wcel cA cB cD co cX wcel cC cX wcel
      cA cB cD cG cX abldiv.1 abldiv.3 grpdivcl 3adant3r3 cG cgr wcel cA cX
      wcel cB cX wcel cC cX wcel 3simpr3 syl3anc cG ablgrp sylan cG cabl wcel
      cA cX wcel cB cX wcel cC cX wcel w3a cA cX wcel cB cX wcel cC cG cgn cfv
      cfv cX wcel w3a cA cB cC cG cgn cfv cfv cD co cD co cA cB cD co cC cG cgn
      cfv cfv cG co wceq cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa
      cA cX wcel cB cX wcel cC cG cgn cfv cfv cX wcel cG cabl wcel cA cX wcel
      cB cX wcel cC cX wcel 3simpr1 cG cabl wcel cA cX wcel cB cX wcel cC cX
      wcel 3simpr2 cG cgr wcel cC cX wcel cC cG cgn cfv cfv cX wcel cG cabl
      wcel cA cX wcel cB cX wcel cC cX wcel w3a cC cG cG cgn cfv cX abldiv.1 cG
      cgn cfv eqid grpinvcl cG ablgrp cA cX wcel cB cX wcel cC cX wcel 3simp3
      syl2an 3jca cA cB cC cG cgn cfv cfv cD cG cX abldiv.1 abldiv.3 abldivdiv
      syldan cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cB cC cG cgn
      cfv cfv cD co cB cC cG co cA cD cG cabl wcel cB cX wcel cC cX wcel cB cC
      cG cgn cfv cfv cD co cB cC cG co wceq cA cX wcel cG cgr wcel cB cX wcel
      cC cX wcel cB cC cG cgn cfv cfv cD co cB cC cG co wceq cG cabl wcel cB cC
      cD cG cG cgn cfv cX abldiv.1 cG cgn cfv eqid abldiv.3 grpdivinv cG ablgrp
      syl3an1 3adant3r1 opreq2d 3eqtr2d $.
      $( [29-Feb-2008] $) $( [29-Feb-2008] $)

    $( Swap the second and third terms in a double division. $)
    abldiv23 $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
   ( ( A D B ) D C ) = ( ( A D C ) D B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cG co cD co
      cA cC cB cG co cD co cA cB cD co cC cD co cA cC cD co cB cD co cG cabl
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cB cC cG co cC cB cG co cA
      cD cG cabl wcel cB cX wcel cC cX wcel cB cC cG co cC cB cG co wceq cA cX
      wcel cB cC cG cX abldiv.1 ablcom 3adant3r1 opreq2d cA cB cC cD cG cX
      abldiv.1 abldiv.3 abldivdiv4 cG cabl wcel cA cX wcel cC cX wcel cB cX
      wcel w3a cA cC cD co cB cD co cA cC cB cG co cD co wceq cA cX wcel cB cX
      wcel cC cX wcel w3a cA cC cB cD cG cX abldiv.1 abldiv.3 abldivdiv4 cA cX
      wcel cB cX wcel cC cX wcel 3ancomb sylan2b 3eqtr4d $.
      $( [29-Feb-2008] $) $( [29-Feb-2008] $)

    $( Group theory analog of ~ nnncan . $)
    ablnnncan $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A D ( B D C ) ) D C ) = ( A D B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cD co cD co
      cC cD co cA cB cC cD co cC cG co cD co cA cB cD co cG cabl wcel cA cX
      wcel cB cX wcel cC cX wcel w3a cA cX wcel cB cC cD co cX wcel cC cX wcel
      w3a cA cB cC cD co cD co cC cD co cA cB cC cD co cC cG co cD co wceq cG
      cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cX wcel cB cC cD co
      cX wcel cC cX wcel cG cabl wcel cA cX wcel cB cX wcel cC cX wcel 3simpr1
      cG cabl wcel cB cX wcel cC cX wcel cB cC cD co cX wcel cA cX wcel cG cgr
      wcel cB cX wcel cC cX wcel cB cC cD co cX wcel cG cabl wcel cB cC cD cG
      cX abldiv.1 abldiv.3 grpdivcl cG ablgrp syl3an1 3adant3r1 cG cabl wcel cA
      cX wcel cB cX wcel cC cX wcel 3simpr3 3jca cA cB cC cD co cC cD cG cX
      abldiv.1 abldiv.3 abldivdiv4 syldan cG cabl wcel cA cX wcel cB cX wcel cC
      cX wcel w3a wa cB cC cD co cC cG co cB cA cD cG cabl wcel cB cX wcel cC
      cX wcel cB cC cD co cC cG co cB wceq cA cX wcel cG cgr wcel cB cX wcel cC
      cX wcel cB cC cD co cC cG co cB wceq cG cabl wcel cB cC cD cG cX abldiv.1
      abldiv.3 grpnpcan cG ablgrp syl3an1 3adant3r1 opreq2d eqtrd $.
      $( [29-Feb-2008] $) $( [29-Feb-2008] $)

    $( Group theory analog of ~ nncan . $)
    ablnncan $p |- ( ( G e. Abel /\ A e. X /\ B e. X ) ->
             ( A D ( A D B ) ) = B ) $=
      cG cabl wcel cA cX wcel cB cX wcel w3a cA cA cB cD co cD co cA cA cD co
      cB cG co cG cgi cfv cB cG co cB cG cabl wcel cA cX wcel cB cX wcel cA cA
      cB cD co cD co cA cA cD co cB cG co wceq cG cabl wcel cA cX wcel cA cX
      wcel cB cX wcel w3a cA cA cB cD co cD co cA cA cD co cB cG co wceq cA cX
      wcel cB cX wcel wa cA cA cB cD cG cX abldiv.1 abldiv.3 abldivdiv cA cX
      wcel cB cX wcel cA cX wcel cA cX wcel cB cX wcel w3a cA cX wcel cA cX
      wcel cB cX wcel w3a id 3anidm12 sylan2 3impb cG cabl wcel cA cX wcel cB
      cX wcel w3a cA cA cD co cG cgi cfv cB cG cG cabl wcel cA cX wcel cA cA cD
      co cG cgi cfv wceq cB cX wcel cG cgr wcel cA cX wcel cA cA cD co cG cgi
      cfv wceq cG cabl wcel cA cD cG cgi cfv cG cX abldiv.1 abldiv.3 cG cgi cfv
      eqid grpdivid cG ablgrp sylan 3adant3 opreq1d cG cabl wcel cB cX wcel cG
      cgi cfv cB cG co cB wceq cA cX wcel cG cgr wcel cB cX wcel cG cgi cfv cB
      cG co cB wceq cG cabl wcel cB cG cgi cfv cG cX abldiv.1 cG cgi cfv eqid
      grplid cG ablgrp sylan 3adant2 3eqtrd $.
      $( [7-Mar-2008] $) $( [7-Mar-2008] $)

    $( Group theory analog of ~ nnncan1 . $)
    ablnnncan1 $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A D B ) D ( A D C ) ) = ( C D B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cD co cA cC cD
      co cD co cA cA cC cD co cD co cB cD co cC cB cD co cG cabl wcel cA cX
      wcel cB cX wcel cC cX wcel w3a cA cX wcel cB cX wcel cA cC cD co cX wcel
      w3a cA cB cD co cA cC cD co cD co cA cA cC cD co cD co cB cD co wceq cG
      cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cX wcel cB cX wcel
      cA cC cD co cX wcel cG cabl wcel cA cX wcel cB cX wcel cC cX wcel 3simpr1
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel 3simpr2 cG cabl wcel cA cX
      wcel cC cX wcel cA cC cD co cX wcel cB cX wcel cG cgr wcel cA cX wcel cC
      cX wcel cA cC cD co cX wcel cG cabl wcel cA cC cD cG cX abldiv.1 abldiv.3
      grpdivcl cG ablgrp syl3an1 3adant3r2 3jca cA cB cA cC cD co cD cG cX
      abldiv.1 abldiv.3 abldiv23 syldan cG cabl wcel cA cX wcel cB cX wcel cC
      cX wcel w3a wa cA cA cC cD co cD co cC cB cD cG cabl wcel cA cX wcel cC
      cX wcel cA cA cC cD co cD co cC wceq cB cX wcel cA cC cD cG cX abldiv.1
      abldiv.3 ablnncan 3adant3r2 opreq1d eqtrd $.
      $( [2-Apr-2008] $) $( [7-Mar-2008] $)
  $}

  ${
    $d A k m $.  $d B k m $.  $d G k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxdi.1 $e |- X = ran G $.
    gxdi.2 $e |- P = ( ^g ` G ) $.
    $( Distribution of group power over group operation for abelian groups.
       (Contributed by Paul Chapman, 17-Apr-2009.) $)
    gxdi $p |- ( ( G e. Abel /\ ( A e. X /\ B e. X ) /\ K e. ZZ ) ->
                 ( ( A G B ) P K ) = ( ( A P K ) G ( B P K ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel wa cK cz wcel cA cB cG co cK cP co cA
      cK cP co cB cK cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel cK cz
      wcel cA cB cG co cK cP co cA cK cP co cB cK cP co cG co wceq wi cA cB cG
      co vm cv cP co cA vm cv cP co cB vm cv cP co cG co wceq cA cB cG co cc0
      cP co cA cc0 cP co cB cc0 cP co cG co wceq cA cB cG co vk cv cP co cA vk
      cv cP co cB vk cv cP co cG co wceq cA cB cG co vk cv cneg cP co cA vk cv
      cneg cP co cB vk cv cneg cP co cG co wceq cA cB cG co vk cv c1 caddc co
      cP co cA vk cv c1 caddc co cP co cB vk cv c1 caddc co cP co cG co wceq vm
      vk cK cA cB cG co cK cP co cA cK cP co cB cK cP co cG co wceq cG cabl
      wcel cA cX wcel cB cX wcel w3a vm cv cc0 wceq cA cB cG co vm cv cP co cA
      cB cG co cc0 cP co cA vm cv cP co cB vm cv cP co cG co cA cc0 cP co cB
      cc0 cP co cG co vm cv cc0 cA cB cG co cP opreq2 vm cv cc0 wceq cA vm cv
      cP co cA cc0 cP co cB vm cv cP co cB cc0 cP co cG vm cv cc0 cA cP opreq2
      vm cv cc0 cB cP opreq2 opreq12d eqeq12d vm cv vk cv wceq cA cB cG co vm
      cv cP co cA cB cG co vk cv cP co cA vm cv cP co cB vm cv cP co cG co cA
      vk cv cP co cB vk cv cP co cG co vm cv vk cv cA cB cG co cP opreq2 vm cv
      vk cv wceq cA vm cv cP co cA vk cv cP co cB vm cv cP co cB vk cv cP co cG
      vm cv vk cv cA cP opreq2 vm cv vk cv cB cP opreq2 opreq12d eqeq12d vm cv
      vk cv c1 caddc co wceq cA cB cG co vm cv cP co cA cB cG co vk cv c1 caddc
      co cP co cA vm cv cP co cB vm cv cP co cG co cA vk cv c1 caddc co cP co
      cB vk cv c1 caddc co cP co cG co vm cv vk cv c1 caddc co cA cB cG co cP
      opreq2 vm cv vk cv c1 caddc co wceq cA vm cv cP co cA vk cv c1 caddc co
      cP co cB vm cv cP co cB vk cv c1 caddc co cP co cG vm cv vk cv c1 caddc
      co cA cP opreq2 vm cv vk cv c1 caddc co cB cP opreq2 opreq12d eqeq12d vm
      cv vk cv cneg wceq cA cB cG co vm cv cP co cA cB cG co vk cv cneg cP co
      cA vm cv cP co cB vm cv cP co cG co cA vk cv cneg cP co cB vk cv cneg cP
      co cG co vm cv vk cv cneg cA cB cG co cP opreq2 vm cv vk cv cneg wceq cA
      vm cv cP co cA vk cv cneg cP co cB vm cv cP co cB vk cv cneg cP co cG vm
      cv vk cv cneg cA cP opreq2 vm cv vk cv cneg cB cP opreq2 opreq12d eqeq12d
      vm cv cK wceq cA cB cG co vm cv cP co cA cB cG co cK cP co cA vm cv cP co
      cB vm cv cP co cG co cA cK cP co cB cK cP co cG co vm cv cK cA cB cG co
      cP opreq2 vm cv cK wceq cA vm cv cP co cA cK cP co cB vm cv cP co cB cK
      cP co cG vm cv cK cA cP opreq2 vm cv cK cB cP opreq2 opreq12d eqeq12d cG
      cabl wcel cA cX wcel cB cX wcel w3a cG cgi cfv cG cgi cfv cG co cG cgi
      cfv cA cc0 cP co cB cc0 cP co cG co cA cB cG co cc0 cP co cG cgr wcel cG
      cgi cfv cX wcel cG cgi cfv cG cgi cfv cG co cG cgi cfv wceq cG cabl wcel
      cA cX wcel cB cX wcel w3a cG cgi cfv cG cgi cfv cG cX gxdi.1 cG cgi cfv
      eqid grplid cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a cG cgr wcel cG cgi cfv cX
      wcel cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1 cG
      cgi cfv cG cX gxdi.1 cG cgi cfv eqid grpidcl syl sylanc cG cabl wcel cA
      cX wcel cB cX wcel w3a cA cc0 cP co cG cgi cfv cB cc0 cP co cG cgi cfv cG
      cG cgr wcel cA cX wcel cA cc0 cP co cG cgi cfv wceq cG cabl wcel cA cX
      wcel cB cX wcel w3a cA cP cG cgi cfv cG cX gxdi.1 cG cgi cfv eqid gxdi.2
      gx0 cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1 cG
      cabl wcel cA cX wcel cB cX wcel 3simp2 sylanc cG cgr wcel cB cX wcel cB
      cc0 cP co cG cgi cfv wceq cG cabl wcel cA cX wcel cB cX wcel w3a cB cP cG
      cgi cfv cG cX gxdi.1 cG cgi cfv eqid gxdi.2 gx0 cG cabl wcel cA cX wcel
      cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1 cG cabl wcel cA cX wcel cB cX
      wcel 3simp3 sylanc opreq12d cG cgr wcel cA cB cG co cX wcel cA cB cG co
      cc0 cP co cG cgi cfv wceq cG cabl wcel cA cX wcel cB cX wcel w3a cA cB cG
      co cP cG cgi cfv cG cX gxdi.1 cG cgi cfv eqid gxdi.2 gx0 cG cabl wcel cA
      cX wcel cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1 cG cgr wcel cA cX wcel
      cB cX wcel cA cB cG co cX wcel cG cabl wcel cA cB cG cX gxdi.1 grpcl cG
      ablgrp syl3an1 sylanc 3eqtr4rd cG cabl wcel cA cX wcel cB cX wcel w3a vk
      cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co
      wceq cA cB cG co vk cv c1 caddc co cP co cA vk cv c1 caddc co cP co cB vk
      cv c1 caddc co cP co cG co wceq wi vk cv cn0 wcel cG cabl wcel cA cX wcel
      cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk
      cv cP co cG co wceq cA cB cG co vk cv c1 caddc co cP co cA vk cv c1 caddc
      co cP co cB vk cv c1 caddc co cP co cG co wceq wi cG cabl wcel cA cX wcel
      cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk
      cv cP co cG co wceq cA cB cG co vk cv c1 caddc co cP co cA vk cv c1 caddc
      co cP co cB vk cv c1 caddc co cP co cG co wceq cG cabl wcel cA cX wcel cB
      cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv
      cP co cG co wceq w3a cA cB cG co vk cv c1 caddc co cP co cA vk cv cP co
      cA cG co cB vk cv cP co cB cG co cG co cA vk cv c1 caddc co cP co cB vk
      cv c1 caddc co cP co cG co cG cabl wcel cA cX wcel cB cX wcel w3a vk cv
      cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq
      w3a cA cB cG co vk cv c1 caddc co cP co cA cB cG co vk cv cP co cA cB cG
      co cG co cA vk cv cP co cB vk cv cP co cG co cA cB cG co cG co cA vk cv
      cP co cA cG co cB vk cv cP co cB cG co cG co cG cgr wcel cA cB cG co cX
      wcel vk cv cz wcel cA cB cG co vk cv c1 caddc co cP co cA cB cG co vk cv
      cP co cA cB cG co cG co wceq cG cabl wcel cA cX wcel cB cX wcel w3a vk cv
      cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq
      w3a cA cB cG co cP cG vk cv cX gxdi.1 gxdi.2 gxsuc cG cabl wcel cA cX
      wcel cB cX wcel w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel
      cB cX wcel cG ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel
      w3a vk cv cz wcel cA cB cG co cX wcel cA cB cG co vk cv cP co cA vk cv cP
      co cB vk cv cP co cG co wceq cG cgr wcel cA cX wcel cB cX wcel cA cB cG
      co cX wcel cG cabl wcel cA cB cG cX gxdi.1 grpcl cG ablgrp syl3an1
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co
      vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq 3simp2 syl3anc cA cB
      cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel
      cA cX wcel cB cX wcel w3a cA cB cG co vk cv cP co cA cB cG co cG co cA vk
      cv cP co cB vk cv cP co cG co cA cB cG co cG co wceq vk cv cz wcel cA cB
      cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co cA cB cG co cG
      opreq1 3ad2ant3 cG cabl wcel cA vk cv cP co cX wcel cB vk cv cP co cX
      wcel wa cA cX wcel cB cX wcel wa cA vk cv cP co cB vk cv cP co cG co cA
      cB cG co cG co cA vk cv cP co cA cG co cB vk cv cP co cB cG co cG co wceq
      cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP
      co cA vk cv cP co cB vk cv cP co cG co wceq w3a cA vk cv cP co cB vk cv
      cP co cA cB cG cX gxdi.1 abl4 cG cabl wcel cA cX wcel cB cX wcel w3a vk
      cv cz wcel cG cabl wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv
      cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp1 3ad2ant1 cG
      cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co
      cA vk cv cP co cB vk cv cP co cG co wceq w3a cA vk cv cP co cX wcel cB vk
      cv cP co cX wcel cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv cP co cX
      wcel cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk
      cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a cA cP cG vk cv cX
      gxdi.1 gxdi.2 gxcl cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel
      cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co
      wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cX wcel
      cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl
      wcel cA cX wcel cB cX wcel 3simp2 3ad2ant1 cG cabl wcel cA cX wcel cB cX
      wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq 3simp2 syl3anc cG cgr wcel cB cX wcel vk cv cz wcel cB vk
      cv cP co cX wcel cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA
      cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a cB cP
      cG vk cv cX gxdi.1 gxdi.2 gxcl cG cabl wcel cA cX wcel cB cX wcel w3a vk
      cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp
      3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cB
      cX wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq
      cG cabl wcel cA cX wcel cB cX wcel 3simp3 3ad2ant1 cG cabl wcel cA cX
      wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co
      cB vk cv cP co cG co wceq 3simp2 syl3anc jca cG cabl wcel cA cX wcel cB
      cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv
      cP co cG co wceq w3a cA cX wcel cB cX wcel cG cabl wcel cA cX wcel cB cX
      wcel w3a vk cv cz wcel cA cX wcel cA cB cG co vk cv cP co cA vk cv cP co
      cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp2
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cB cX wcel
      cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl
      wcel cA cX wcel cB cX wcel 3simp3 3ad2ant1 jca syl3anc 3eqtrd cG cabl
      wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq w3a cA vk cv c1 caddc co cP co cA
      vk cv cP co cA cG co cB vk cv c1 caddc co cP co cB vk cv cP co cB cG co
      cG cG cgr wcel cA cX wcel vk cv cz wcel cA vk cv c1 caddc co cP co cA vk
      cv cP co cA cG co wceq cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz
      wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a
      cA cP cG vk cv cX gxdi.1 gxdi.2 gxsuc cG cabl wcel cA cX wcel cB cX wcel
      w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB
      vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG
      ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz
      wcel cA cX wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG
      co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp2 3ad2ant1 cG cabl wcel
      cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv
      cP co cB vk cv cP co cG co wceq 3simp2 syl3anc cG cgr wcel cB cX wcel vk
      cv cz wcel cB vk cv c1 caddc co cP co cB vk cv cP co cB cG co wceq cG
      cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co
      cA vk cv cP co cB vk cv cP co cG co wceq w3a cB cP cG vk cv cX gxdi.1
      gxdi.2 gxsuc cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cG cgr
      wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG
      cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1 3ad2ant1
      cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cB cX wcel cA cB cG
      co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA
      cX wcel cB cX wcel 3simp3 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a
      vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co
      wceq 3simp2 syl3anc opreq12d eqtr4d 3expia ex vk cv nn0z syl5 cG cabl
      wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq cA cB cG co vk cv cneg cP co cA vk
      cv cneg cP co cB vk cv cneg cP co cG co wceq wi vk cv cn wcel cG cabl
      wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq cA cB cG co vk cv cneg cP co cA vk
      cv cneg cP co cB vk cv cneg cP co cG co wceq wi cG cabl wcel cA cX wcel
      cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk
      cv cP co cG co wceq cA cB cG co vk cv cneg cP co cA vk cv cneg cP co cB
      vk cv cneg cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel w3a vk cv
      cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq
      w3a cA cB cG co vk cv cneg cP co cA vk cv cP co cG cgn cfv cfv cB vk cv
      cP co cG cgn cfv cfv cG co cA vk cv cneg cP co cB vk cv cneg cP co cG co
      cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP
      co cA vk cv cP co cB vk cv cP co cG co wceq w3a cA cB cG co vk cv cneg cP
      co cA cB cG co vk cv cP co cG cgn cfv cfv cB vk cv cP co cA vk cv cP co
      cG co cG cgn cfv cfv cA vk cv cP co cG cgn cfv cfv cB vk cv cP co cG cgn
      cfv cfv cG co cG cgr wcel cA cB cG co cX wcel vk cv cz wcel cA cB cG co
      vk cv cneg cP co cA cB cG co vk cv cP co cG cgn cfv cfv wceq cG cabl wcel
      cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv
      cP co cB vk cv cP co cG co wceq w3a cA cB cG co cP cG vk cv cG cgn cfv cX
      gxdi.1 cG cgn cfv eqid gxdi.2 gxneg cG cabl wcel cA cX wcel cB cX wcel
      w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB
      vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG
      ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz
      wcel cA cB cG co cX wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv
      cP co cG co wceq cG cgr wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cG
      cabl wcel cA cB cG cX gxdi.1 grpcl cG ablgrp syl3an1 3ad2ant1 cG cabl
      wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq 3simp2 syl3anc cG cabl wcel cA cX
      wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co
      cB vk cv cP co cG co wceq w3a cA cB cG co vk cv cP co cB vk cv cP co cA
      vk cv cP co cG co cG cgn cfv cG cabl wcel cA cX wcel cB cX wcel w3a vk cv
      cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq
      w3a cA cB cG co vk cv cP co cB vk cv cP co cA vk cv cP co cG co wceq cA
      vk cv cP co cB vk cv cP co cG co cB vk cv cP co cA vk cv cP co cG co wceq
      cG cabl wcel cA vk cv cP co cX wcel cB vk cv cP co cX wcel cA vk cv cP co
      cB vk cv cP co cG co cB vk cv cP co cA vk cv cP co cG co wceq cG cabl
      wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq w3a cA vk cv cP co cB vk cv cP co
      cG cX gxdi.1 ablcom cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel
      cG cabl wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co
      wceq cG cabl wcel cA cX wcel cB cX wcel 3simp1 3ad2ant1 cG cgr wcel cA cX
      wcel vk cv cz wcel cA vk cv cP co cX wcel cG cabl wcel cA cX wcel cB cX
      wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq w3a cA cP cG vk cv cX gxdi.1 gxdi.2 gxcl cG cabl wcel cA cX
      wcel cB cX wcel w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel
      cB cX wcel cG ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel
      w3a vk cv cz wcel cA cX wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk
      cv cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp2 3ad2ant1 cG
      cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co
      cA vk cv cP co cB vk cv cP co cG co wceq 3simp2 syl3anc cG cgr wcel cB cX
      wcel vk cv cz wcel cB vk cv cP co cX wcel cG cabl wcel cA cX wcel cB cX
      wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq w3a cB cP cG vk cv cX gxdi.1 gxdi.2 gxcl cG cabl wcel cA cX
      wcel cB cX wcel w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA
      vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel
      cB cX wcel cG ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel
      w3a vk cv cz wcel cB cX wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk
      cv cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp3 3ad2ant1 cG
      cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co
      cA vk cv cP co cB vk cv cP co cG co wceq 3simp2 syl3anc syl3anc cA cB cG
      co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA
      cX wcel cB cX wcel w3a cA cB cG co vk cv cP co cB vk cv cP co cA vk cv cP
      co cG co wceq cA vk cv cP co cB vk cv cP co cG co cB vk cv cP co cA vk cv
      cP co cG co wceq wb vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co
      cB vk cv cP co cG co cB vk cv cP co cA vk cv cP co cG co eqeq1 3ad2ant3
      mpbird fveq2d cG cgr wcel cB vk cv cP co cX wcel cA vk cv cP co cX wcel
      cB vk cv cP co cA vk cv cP co cG co cG cgn cfv cfv cA vk cv cP co cG cgn
      cfv cfv cB vk cv cP co cG cgn cfv cfv cG co wceq cG cabl wcel cA cX wcel
      cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk
      cv cP co cG co wceq w3a cB vk cv cP co cA vk cv cP co cG cG cgn cfv cX
      gxdi.1 cG cgn cfv eqid grpinvop cG cabl wcel cA cX wcel cB cX wcel w3a vk
      cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp
      3ad2ant1 3ad2ant1 cG cgr wcel cB cX wcel vk cv cz wcel cB vk cv cP co cX
      wcel cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk
      cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a cB cP cG vk cv cX
      gxdi.1 gxdi.2 gxcl cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel
      cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co
      wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp 3ad2ant1
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cB cX wcel
      cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl
      wcel cA cX wcel cB cX wcel 3simp3 3ad2ant1 cG cabl wcel cA cX wcel cB cX
      wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq 3simp2 syl3anc cG cgr wcel cA cX wcel vk cv cz wcel cA vk
      cv cP co cX wcel cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA
      cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a cA cP
      cG vk cv cX gxdi.1 gxdi.2 gxcl cG cabl wcel cA cX wcel cB cX wcel w3a vk
      cv cz wcel cG cgr wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP
      co cG co wceq cG cabl wcel cA cX wcel cG cgr wcel cB cX wcel cG ablgrp
      3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA
      cX wcel cA cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq
      cG cabl wcel cA cX wcel cB cX wcel 3simp2 3ad2ant1 cG cabl wcel cA cX
      wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP co
      cB vk cv cP co cG co wceq 3simp2 syl3anc syl3anc 3eqtrd cG cabl wcel cA
      cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co vk cv cP co cA vk cv cP
      co cB vk cv cP co cG co wceq w3a cA vk cv cneg cP co cA vk cv cP co cG
      cgn cfv cfv cB vk cv cneg cP co cB vk cv cP co cG cgn cfv cfv cG cG cgr
      wcel cA cX wcel vk cv cz wcel cA vk cv cneg cP co cA vk cv cP co cG cgn
      cfv cfv wceq cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB
      cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a cA cP cG
      vk cv cG cgn cfv cX gxdi.1 cG cgn cfv eqid gxdi.2 gxneg cG cabl wcel cA
      cX wcel cB cX wcel w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP co
      cA vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG cgr
      wcel cB cX wcel cG ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel cB cX
      wcel w3a vk cv cz wcel cA cX wcel cA cB cG co vk cv cP co cA vk cv cP co
      cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp2
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co
      vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq 3simp2 syl3anc cG
      cgr wcel cB cX wcel vk cv cz wcel cB vk cv cneg cP co cB vk cv cP co cG
      cgn cfv cfv wceq cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA
      cB cG co vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq w3a cB cP
      cG vk cv cG cgn cfv cX gxdi.1 cG cgn cfv eqid gxdi.2 gxneg cG cabl wcel
      cA cX wcel cB cX wcel w3a vk cv cz wcel cG cgr wcel cA cB cG co vk cv cP
      co cA vk cv cP co cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cG
      cgr wcel cB cX wcel cG ablgrp 3ad2ant1 3ad2ant1 cG cabl wcel cA cX wcel
      cB cX wcel w3a vk cv cz wcel cB cX wcel cA cB cG co vk cv cP co cA vk cv
      cP co cB vk cv cP co cG co wceq cG cabl wcel cA cX wcel cB cX wcel 3simp3
      3ad2ant1 cG cabl wcel cA cX wcel cB cX wcel w3a vk cv cz wcel cA cB cG co
      vk cv cP co cA vk cv cP co cB vk cv cP co cG co wceq 3simp2 syl3anc
      opreq12d eqtr4d 3expia ex vk cv nnz syl5 zindd 3expb 3impia $.
      $( [20-Apr-2009] $) $( [17-Apr-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Subgroups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SubGrp $.

  $( Extend class notation to include the class of subgroups. $)
  csubg $a class SubGrp $.

  ${
    $d g h s $.
    $( Define the set of subgroups of ` g ` . $)
    df-subg $a |- SubGrp = { <. g , s >. |
                             ( g e. Grp /\ s = { h e. Grp | h C_ g } ) } $.
  $}

  ${
    $d G g h s $.  $d H h $.
    $( The predicate "is a subgroup of ` G ` ."  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    issubg $p |- ( H e. ( SubGrp ` G ) <->
                   ( G e. Grp /\ H e. Grp /\ H C_ G ) ) $=
      cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cgr wcel cH
      cgr wcel cH cG wss w3a cG cgr wcel cH cgr wcel cH cG wss wa cH cG csubg
      cfv wcel cG cgr wcel cH cgr wcel cH cG wss 3anass cG cgr wcel cH cG csubg
      cfv wcel cG cgr wcel wn cG csubg cdm wcel wn cG csubg cfv c0 wceq cH cG
      csubg cfv wcel wn cG csubg cdm wcel cG cgr wcel cG csubg cdm wcel cG cgr
      wcel csubg cdm cgr cG vg vs cgr vh cv vg cv wss vh cgr crab csubg vh cv
      vg cv wss vh cgr crab vh cv cgr wcel vh cv vg cv wss wa vh cab cvv vh cv
      vg cv wss vh cgr df-rab vh cv cgr wcel vh cv vg cv wss wa vh cab vh cv vg
      cv wss vh cab vg cv cpw vh cv vg cv wss vh cab cvv vh vg cv df-pw vg cv
      vg visset pwex eqeltrri vh cv cgr wcel vh cv vg cv wss wa vh cv vg cv wss
      vh vh cv cgr wcel vh cv vg cv wss pm3.27 ss2abi ssexi eqeltri vg vh vs
      df-subg dmopab2 eleq2i biimpi con3i cG csubg ndmfv cH cG csubg cfv wcel
      cG csubg cfv c0 wceq cG csubg cfv cH n0i con2i 3syl con4i cG cgr wcel cH
      cG csubg cfv wcel cH cgr wcel cH cG wss wa cG cgr wcel cH cG csubg cfv
      wcel cG cgr wcel wn cG csubg cdm wcel wn cG csubg cfv c0 wceq cH cG csubg
      cfv wcel wn cG csubg cdm wcel cG cgr wcel cG csubg cdm wcel cG cgr wcel
      csubg cdm cgr cG vg vs cgr vh cv vg cv wss vh cgr crab csubg vh cv vg cv
      wss vh cgr crab vh cv cgr wcel vh cv vg cv wss wa vh cab cvv vh cv vg cv
      wss vh cgr df-rab vh cv cgr wcel vh cv vg cv wss wa vh cab vh cv vg cv
      wss vh cab vg cv cpw vh cv vg cv wss vh cab cvv vh vg cv df-pw vg cv vg
      visset pwex eqeltrri vh cv cgr wcel vh cv vg cv wss wa vh cv vg cv wss vh
      vh cv cgr wcel vh cv vg cv wss pm3.27 ss2abi ssexi eqeltri vg vh vs
      df-subg dmopab2 eleq2i biimpi con3i cG csubg ndmfv cH cG csubg cfv wcel
      cG csubg cfv c0 wceq cG csubg cfv cH n0i con2i 3syl con4i cG cgr wcel cH
      cG csubg cfv wcel cH cgr wcel cH cG wss wa cG cgr wcel cH cG csubg cfv
      wcel cH vh cv cG wss vh cgr crab wcel cH cgr wcel cH cG wss wa cG cgr
      wcel cG csubg cfv vh cv cG wss vh cgr crab cH cG cgr wcel vh cv cG wss vh
      cgr crab cvv wcel cG csubg cfv vh cv cG wss vh cgr crab wceq cG cgr wcel
      vh cv cG wss vh cv cgr wcel wa vh cab cvv vh cv cG wss vh cgr crab vh cv
      cgr wcel vh cG cgr abssexg vh cv cG wss vh cgr crab vh cv cgr wcel vh cv
      cG wss wa vh cab vh cv cG wss vh cv cgr wcel wa vh cab vh cv cG wss vh
      cgr df-rab vh cv cgr wcel vh cv cG wss wa vh cv cG wss vh cv cgr wcel wa
      vh vh cv cgr wcel vh cv cG wss ancom abbii eqtri syl5eqel vg vs cG vh cv
      vg cv wss vh cgr crab vh cv cG wss vh cgr crab cgr cvv csubg vg cv cG
      wceq vh cv vg cv wss vh cv cG wss vh cgr vg cv cG vh cv sseq2 rabbisdv vg
      vh vs df-subg fvopab4g mpdan eleq2d vh cv cG wss cH cG wss vh cH cgr vh
      cv cH cG sseq1 elrab syl6bb biimpd mpcom sylanbrc cG cgr wcel cH cgr wcel
      cH cG wss cH cG csubg cfv wcel cG cgr wcel cH cG csubg cfv wcel cH cgr
      wcel cH cG wss wa cG cgr wcel cH cG csubg cfv wcel cH vh cv cG wss vh cgr
      crab wcel cH cgr wcel cH cG wss wa cG cgr wcel cG csubg cfv vh cv cG wss
      vh cgr crab cH cG cgr wcel vh cv cG wss vh cgr crab cvv wcel cG csubg cfv
      vh cv cG wss vh cgr crab wceq cG cgr wcel vh cv cG wss vh cv cgr wcel wa
      vh cab cvv vh cv cG wss vh cgr crab vh cv cgr wcel vh cG cgr abssexg vh
      cv cG wss vh cgr crab vh cv cgr wcel vh cv cG wss wa vh cab vh cv cG wss
      vh cv cgr wcel wa vh cab vh cv cG wss vh cgr df-rab vh cv cgr wcel vh cv
      cG wss wa vh cv cG wss vh cv cgr wcel wa vh vh cv cgr wcel vh cv cG wss
      ancom abbii eqtri syl5eqel vg vs cG vh cv vg cv wss vh cgr crab vh cv cG
      wss vh cgr crab cgr cvv csubg vg cv cG wceq vh cv vg cv wss vh cv cG wss
      vh cgr vg cv cG vh cv sseq2 rabbisdv vg vh vs df-subg fvopab4g mpdan
      eleq2d vh cv cG wss cH cG wss vh cH cgr vh cv cH cG sseq1 elrab syl6bb
      biimpar 3impb impbii $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    subgres.1 $e |- W = ran H $.
    $( A subgroup operation is the restriction of its parent group operation to
       its underlying set.  (Contributed by Paul Chapman, 3-Mar-2008.) $)
    subgres $p |- ( H e. ( SubGrp ` G ) -> H = ( G |` ( W X. W ) ) ) $=
      cH cG csubg cfv wcel cG cW cW cxp cres cH cW cW cxp cres cH cG wfun cH cG
      wss cW cW cxp cH cdm wss cG cW cW cxp cres cH cW cW cxp cres wceq cH cG
      csubg cfv wcel cW cW cxp cG cH fun2ssres cH cG csubg cfv wcel cG cgr wcel
      cG wfun cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss cH cG
      csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cH issubg biimpi
      3simp1d cG cgr wcel cG crn cG crn cxp cG crn cG wfo cG wfun cG cG crn cG
      crn eqid grpfo cG crn cG crn cxp cG crn cG fofun syl syl cH cG csubg cfv
      wcel cG cgr wcel cH cgr wcel cH cG wss cH cG csubg cfv wcel cG cgr wcel
      cH cgr wcel cH cG wss w3a cG cH issubg biimpi 3simp3d cH cG csubg cfv
      wcel cW cW cxp cW cH wf cH cdm cW cW cxp wceq cW cW cxp cH cdm wss cH cG
      csubg cfv wcel cH cgr wcel cW cW cxp cW cH wfo cW cW cxp cW cH wf cH cG
      csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss cH cG csubg cfv wcel cG
      cgr wcel cH cgr wcel cH cG wss w3a cG cH issubg biimpi 3simp2d cH cW
      subgres.1 grpfo cW cW cxp cW cH fof 3syl cW cW cxp cW cH fdm cW cW cxp cH
      cdm eqimss2 3syl syl3anc cH cG csubg cfv wcel cH cgr wcel cW cW cxp cW cH
      wfo cH cW cW cxp cres cH wceq cH cG csubg cfv wcel cG cgr wcel cH cgr
      wcel cH cG wss cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a
      cG cH issubg biimpi 3simp2d cH cW subgres.1 grpfo cW cW cxp cW cH wfo cH
      cW cW cxp wfn cH cW cW cxp cres cH wceq cW cW cxp cW cH fofn cW cW cxp cH
      fnresdm syl 3syl eqtr2d $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)

    $( The result of a subgroup operation is the same as the result of its
       parent operation.  (Contributed by Paul Chapman, 3-Mar-2008.) $)
    subgopr $p |- ( H e. ( SubGrp ` G ) ->
                    ( ( A e. W /\ B e. W ) -> ( A H B ) = ( A G B ) ) ) $=
      cH cG csubg cfv wcel cA cW wcel cB cW wcel wa cA cB cH co cA cB cG co
      wceq cH cG csubg cfv wcel cA cW wcel cB cW wcel wa wa cA cB cH co cA cB
      cG cW cW cxp cres co cA cB cG co cH cG csubg cfv wcel cA cW wcel cB cW
      wcel wa wa cH cG cW cW cxp cres cA cB cH cG csubg cfv wcel cH cG cW cW
      cxp cres wceq cA cW wcel cB cW wcel wa cG cH cW subgres.1 subgres adantr
      opreqd cA cW wcel cB cW wcel wa cA cB cG cW cW cxp cres co cA cB cG co
      wceq cH cG csubg cfv wcel cA cB cW cW cG oprvres adantl eqtrd ex $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    subgrnss.1 $e |- X = ran G $.
    subgrnss.2 $e |- W = ran H $.
    $( The underlying set of a subgroup is a subset of its parent group's
       underlying set.  (Contributed by Paul Chapman, 3-Mar-2008.) $)
    subgrnss $p |- ( H e. ( SubGrp ` G ) -> W C_ X ) $=
      cH cG csubg cfv wcel cH crn cG crn cW cX cH cG csubg cfv wcel cH crn cG
      crn wss cG cW cW cxp cima cG crn wss cG cW cW cxp imassrn cH cG csubg cfv
      wcel cH crn cG cW cW cxp cima cG crn cH cG csubg cfv wcel cH crn cG cW cW
      cxp cres crn cG cW cW cxp cima cH cG csubg cfv wcel cH cG cW cW cxp cres
      cG cH cW subgrnss.2 subgres rneqd cG cW cW cxp df-ima syl6eqr sseq1d
      mpbiri subgrnss.2 subgrnss.1 3sstr4g $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    subgid.1 $e |- U = ( Id ` G ) $.
    subgid.2 $e |- T = ( Id ` H ) $.
    $( The identity element of a subgroup is the same as its parent's.
       (Contributed by Paul Chapman, 3-Mar-2008.) $)
    subgid $p |- ( H e. ( SubGrp ` G ) -> T = U ) $=
      cH cG csubg cfv wcel cT cU wceq cT cT cG co cT wceq cH cG csubg cfv wcel
      cT cT cH co cT cT cG co cT cH cG csubg cfv wcel cT cH crn wcel cT cH crn
      wcel cT cT cH co cT cT cG co wceq cH cG csubg cfv wcel cH cgr wcel cT cH
      crn wcel cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss cH cG
      csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cH issubg biimpi
      3simp2d cT cH cH crn cH crn eqid subgid.2 grpidcl syl cH cG csubg cfv
      wcel cH cgr wcel cT cH crn wcel cH cG csubg cfv wcel cG cgr wcel cH cgr
      wcel cH cG wss cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a
      cG cH issubg biimpi 3simp2d cT cH cH crn cH crn eqid subgid.2 grpidcl syl
      cT cT cG cH cH crn cH crn eqid subgopr mp2and cH cgr wcel cT cH crn wcel
      cT cT cH co cT wceq cH cG csubg cfv wcel cT cT cH cH crn cH crn eqid
      subgid.2 grplid cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss cH
      cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cH issubg
      biimpi 3simp2d cH cG csubg cfv wcel cH cgr wcel cT cH crn wcel cH cG
      csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss cH cG csubg cfv wcel cG
      cgr wcel cH cgr wcel cH cG wss w3a cG cH issubg biimpi 3simp2d cT cH cH
      crn cH crn eqid subgid.2 grpidcl syl sylanc eqtr3d cG cgr wcel cT cG crn
      wcel cT cU wceq cT cT cG co cT wceq wb cH cG csubg cfv wcel cT cU cG cG
      crn cG crn eqid subgid.1 grpid cH cG csubg cfv wcel cG cgr wcel cH cgr
      wcel cH cG wss cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a
      cG cH issubg biimpi 3simp1d cH cG csubg cfv wcel cH crn cG crn cT cG cH
      cH crn cG crn cG crn eqid cH crn eqid subgrnss cH cG csubg cfv wcel cH
      cgr wcel cT cH crn wcel cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH
      cG wss cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cH
      issubg biimpi 3simp2d cT cH cH crn cH crn eqid subgid.2 grpidcl syl
      sseldd sylanc mpbird $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d A x y $.  $d B y $.  $d G x y $.  $d H x y $.  $d Y x y $.
    issubgilem.1 $e |- ( ( x e. Y /\ y e. Y ) -> ( x H y ) = ( x G y ) ) $.
    $( Lemma for ~ issubgi . $)
    issubgilem $p |- ( ( A e. Y /\ B e. Y ) -> ( A H B ) = ( A G B ) ) $=
      vx cv vy cv cH co vx cv vy cv cG co wceq cA vy cv cH co cA vy cv cG co
      wceq cA cB cH co cA cB cG co wceq vx vy cA cB cY cY vx cv cA wceq vx cv
      vy cv cH co cA vy cv cH co vx cv vy cv cG co cA vy cv cG co vx cv cA vy
      cv cH opreq1 vx cv cA vy cv cG opreq1 eqeq12d vy cv cB wceq cA vy cv cH
      co cA cB cH co cA vy cv cG co cA cB cG co vy cv cB cA cH opreq2 vy cv cB
      cA cG opreq2 eqeq12d issubgilem.1 vtocl2ga $.
      $( [25-Feb-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d G a b $.  $d H a b x y $.  $d H b x y z $.  $d N a b y $.
    $d U a b x y $.  $d U b x y z $.  $d Y a b x y $.  $d Y b x y z $.
    issubgi.1 $e |- G e. Grp $.
    issubgi.2 $e |- X = ran G $.
    issubgi.3 $e |- U = ( Id ` G ) $.
    issubgi.4 $e |- N = ( inv ` G ) $.
    issubgi.5 $e |- Y C_ X $.
    issubgi.6 $e |- H = ( G |` ( Y X. Y ) ) $.
    issubgi.7 $e |- ( ( x e. Y /\ y e. Y ) -> ( x G y ) e. Y ) $.
    issubgi.8 $e |- U e. Y $.
    issubgi.9 $e |- ( x e. Y -> ( N ` x ) e. Y ) $.
    $( Properties that determine a subgroup.  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    issubgi $p |- H e. ( SubGrp ` G ) $=
      cG cgr wcel cH cgr wcel cH cG wss cH cG csubg cfv wcel issubgi.1 vx vy vz
      cU cH vx cv cN cfv cY cY cX cX cG crn cvv issubgi.2 cG cgr wcel cG crn
      cvv wcel issubgi.1 cG cgr rnexg ax-mp eqeltri issubgi.5 ssexi cY cY cxp
      cY cH wf cH cY cY cxp wfn vx cv vy cv cH co cY wcel vy cY wral vx cY wral
      vx vy cY cY cY cH ffnoprv cY cY cxp cX cH wf cH cY cY cxp wfn cY cY cxp
      cX cH wf cY cY cxp cX cG cY cY cxp cres wf cX cX cxp cX cG wf cY cY cxp
      cX cX cxp wss cY cY cxp cX cG cY cY cxp cres wf cG cgr wcel cX cX cxp cX
      cG wf issubgi.1 cG cgr wcel cX cX cxp cX cG wfo cX cX cxp cX cG wf cG cX
      issubgi.2 grpfo cX cX cxp cX cG fof syl ax-mp cY cX wss cY cX wss cY cY
      cxp cX cX cxp wss issubgi.5 issubgi.5 cY cX cY cX ssxp mp2an cX cX cxp cX
      cY cY cxp cG fssres mp2an cH cG cY cY cxp cres wceq cY cY cxp cX cH wf cY
      cY cxp cX cG cY cY cxp cres wf wb issubgi.6 cY cY cxp cX cH cG cY cY cxp
      cres feq1 ax-mp mpbir cY cY cxp cX cH ffn ax-mp vx cv vy cv cH co cY wcel
      vx vy cY vx cv cY wcel vy cv cY wcel wa vx cv vy cv cH co vx cv vy cv cG
      co cY va vb vx cv vy cv cG cH cY va cv cY wcel vb cv cY wcel wa va cv vb
      cv cG cY cY cxp cres co va cv vb cv cG co va cv vb cv cH co va cv vb cv
      cY cY cG oprvres cH cG cY cY cxp cres va cv vb cv issubgi.6 opreqi syl5eq
      issubgilem issubgi.7 eqeltrd rgen2a mpbir2an vx cv cY wcel vy cv cY wcel
      vz cv cY wcel w3a vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co
      cG co vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co vx cv
      cX wcel vy cv cX wcel vz cv cX wcel vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vx cv cY wcel vy cv cY wcel vz cv cY wcel cG
      cgr wcel vx cv cX wcel vy cv cX wcel vz cv cX wcel w3a vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq issubgi.1 vx cv vy cv vz
      cv cG cX issubgi.2 grpass mpan cY cX vx cv issubgi.5 sseli cY cX vy cv
      issubgi.5 sseli cY cX vz cv issubgi.5 sseli syl3an vx cv cY wcel vy cv cY
      wcel vz cv cY wcel w3a vx cv vy cv cH co vz cv cH co vx cv vy cv cH co vz
      cv cG co vx cv vy cv cG co vz cv cG co vx cv cY wcel vy cv cY wcel vz cv
      cY wcel vx cv vy cv cH co vz cv cH co vx cv vy cv cH co vz cv cG co wceq
      vx cv vy cv cH co cY wcel vz cv cY wcel vx cv vy cv cH co vz cv cH co vx
      cv vy cv cH co vz cv cG co wceq vx cv cY wcel vy cv cY wcel wa va vb vx
      cv vy cv cH co vz cv cG cH cY va cv cY wcel vb cv cY wcel wa va cv vb cv
      cG cY cY cxp cres co va cv vb cv cG co va cv vb cv cH co va cv vb cv cY
      cY cG oprvres cH cG cY cY cxp cres va cv vb cv issubgi.6 opreqi syl5eq
      issubgilem vx cv cY wcel vy cv cY wcel wa vx cv vy cv cH co vx cv vy cv
      cG co cY va vb vx cv vy cv cG cH cY va cv cY wcel vb cv cY wcel wa va cv
      vb cv cG cY cY cxp cres co va cv vb cv cG co va cv vb cv cH co va cv vb
      cv cY cY cG oprvres cH cG cY cY cxp cres va cv vb cv issubgi.6 opreqi
      syl5eq issubgilem issubgi.7 eqeltrd sylan 3impa vx cv cY wcel vy cv cY
      wcel vx cv vy cv cH co vz cv cG co vx cv vy cv cG co vz cv cG co wceq vz
      cv cY wcel vx cv cY wcel vy cv cY wcel wa vx cv vy cv cH co vx cv vy cv
      cG co vz cv cG va vb vx cv vy cv cG cH cY va cv cY wcel vb cv cY wcel wa
      va cv vb cv cG cY cY cxp cres co va cv vb cv cG co va cv vb cv cH co va
      cv vb cv cY cY cG oprvres cH cG cY cY cxp cres va cv vb cv issubgi.6
      opreqi syl5eq issubgilem opreq1d 3adant3 eqtrd vx cv cY wcel vy cv cY
      wcel vz cv cY wcel w3a vx cv vy cv vz cv cH co cH co vx cv vy cv vz cv cH
      co cG co vx cv vy cv vz cv cG co cG co vx cv cY wcel vy cv cY wcel vz cv
      cY wcel vx cv vy cv vz cv cH co cH co vx cv vy cv vz cv cH co cG co wceq
      vx cv cY wcel vy cv vz cv cH co cY wcel vx cv vy cv vz cv cH co cH co vx
      cv vy cv vz cv cH co cG co wceq vy cv cY wcel vz cv cY wcel wa va vb vx
      cv vy cv vz cv cH co cG cH cY va cv cY wcel vb cv cY wcel wa va cv vb cv
      cG cY cY cxp cres co va cv vb cv cG co va cv vb cv cH co va cv vb cv cY
      cY cG oprvres cH cG cY cY cxp cres va cv vb cv issubgi.6 opreqi syl5eq
      issubgilem vy cv vz cv cY cY cY cH cY cY cxp cY cH wf cH cY cY cxp wfn vx
      cv vy cv cH co cY wcel vy cY wral vx cY wral vx vy cY cY cY cH ffnoprv cY
      cY cxp cX cH wf cH cY cY cxp wfn cY cY cxp cX cH wf cY cY cxp cX cG cY cY
      cxp cres wf cX cX cxp cX cG wf cY cY cxp cX cX cxp wss cY cY cxp cX cG cY
      cY cxp cres wf cG cgr wcel cX cX cxp cX cG wf issubgi.1 cG cgr wcel cX cX
      cxp cX cG wfo cX cX cxp cX cG wf cG cX issubgi.2 grpfo cX cX cxp cX cG
      fof syl ax-mp cY cX wss cY cX wss cY cY cxp cX cX cxp wss issubgi.5
      issubgi.5 cY cX cY cX ssxp mp2an cX cX cxp cX cY cY cxp cG fssres mp2an
      cH cG cY cY cxp cres wceq cY cY cxp cX cH wf cY cY cxp cX cG cY cY cxp
      cres wf wb issubgi.6 cY cY cxp cX cH cG cY cY cxp cres feq1 ax-mp mpbir
      cY cY cxp cX cH ffn ax-mp vx cv vy cv cH co cY wcel vx vy cY vx cv cY
      wcel vy cv cY wcel wa vx cv vy cv cH co vx cv vy cv cG co cY va vb vx cv
      vy cv cG cH cY va cv cY wcel vb cv cY wcel wa va cv vb cv cG cY cY cxp
      cres co va cv vb cv cG co va cv vb cv cH co va cv vb cv cY cY cG oprvres
      cH cG cY cY cxp cres va cv vb cv issubgi.6 opreqi syl5eq issubgilem
      issubgi.7 eqeltrd rgen2a mpbir2an foprcl sylan2 3impb vy cv cY wcel vz cv
      cY wcel vx cv vy cv vz cv cH co cG co vx cv vy cv vz cv cG co cG co wceq
      vx cv cY wcel vy cv cY wcel vz cv cY wcel wa vy cv vz cv cH co vy cv vz
      cv cG co vx cv cG va vb vy cv vz cv cG cH cY va cv cY wcel vb cv cY wcel
      wa va cv vb cv cG cY cY cxp cres co va cv vb cv cG co va cv vb cv cH co
      va cv vb cv cY cY cG oprvres cH cG cY cY cxp cres va cv vb cv issubgi.6
      opreqi syl5eq issubgilem opreq2d 3adant1 eqtrd 3eqtr4d issubgi.8 vx cv cY
      wcel cU vx cv cH co cU vx cv cG co vx cv cU cY wcel vx cv cY wcel cU vx
      cv cH co cU vx cv cG co wceq issubgi.8 va vb cU vx cv cG cH cY va cv cY
      wcel vb cv cY wcel wa va cv vb cv cG cY cY cxp cres co va cv vb cv cG co
      va cv vb cv cH co va cv vb cv cY cY cG oprvres cH cG cY cY cxp cres va cv
      vb cv issubgi.6 opreqi syl5eq issubgilem mpan cG cgr wcel vx cv cX wcel
      cU vx cv cG co vx cv wceq vx cv cY wcel vx cv cU cG cX issubgi.2
      issubgi.3 grplid issubgi.1 cY cX vx cv issubgi.5 sseli sylancr eqtrd
      issubgi.9 vx cv cY wcel vx cv cN cfv vx cv cH co vx cv cN cfv vx cv cG co
      cU vx cv cN cfv cY wcel vx cv cY wcel vx cv cN cfv vx cv cH co vx cv cN
      cfv vx cv cG co wceq issubgi.9 va vb vx cv cN cfv vx cv cG cH cY va cv cY
      wcel vb cv cY wcel wa va cv vb cv cG cY cY cxp cres co va cv vb cv cG co
      va cv vb cv cH co va cv vb cv cY cY cG oprvres cH cG cY cY cxp cres va cv
      vb cv issubgi.6 opreqi syl5eq issubgilem mpancom cG cgr wcel vx cv cX
      wcel vx cv cN cfv vx cv cG co cU wceq vx cv cY wcel vx cv cU cG cN cX
      issubgi.2 issubgi.3 issubgi.4 grplinv issubgi.1 cY cX vx cv issubgi.5
      sseli sylancr eqtrd isgrpi cH cG cY cY cxp cres cG issubgi.6 cG cY cY cxp
      resss eqsstri cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a
      cG cH issubg biimpri mp3an $.
      $( [3-Mar-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d G x y $.  $d H x y $.
    $( A subgroup of an Abelian group is Abelian.  (Contributed by Paul
       Chapman, 25-Apr-2008.) $)
    subgabl $p |- ( ( G e. Abel /\ H e. ( SubGrp ` G ) ) -> H e. Abel ) $=
      cH cG csubg cfv wcel vx cv vy cv cH co vy cv vx cv cH co wceq vy cH crn
      wral vx cH crn wral cH cabl wcel cG cabl wcel cH cG csubg cfv wcel wa cH
      cgr wcel vx cv vy cv cH co vy cv vx cv cH co wceq vy cH crn wral vx cH
      crn wral cH cabl wcel cH cG csubg cfv wcel cH cabl wcel cH cgr wcel vx cv
      vy cv cH co vy cv vx cv cH co wceq vy cH crn wral vx cH crn wral wa vx vy
      cH cH crn cH crn eqid isabl biimpri cH cG csubg cfv wcel cG cgr wcel cH
      cgr wcel cH cG wss cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss
      w3a cG cH issubg biimpi 3simp2d sylan cG cabl wcel cH cG csubg cfv wcel
      pm3.27 cG cabl wcel cH cG csubg cfv wcel wa vx cv vy cv cH co vy cv vx cv
      cH co wceq vx vy cH crn cH crn cG cabl wcel cH cG csubg cfv wcel wa vx cv
      cH crn wcel vy cv cH crn wcel wa vx cv vy cv cH co vy cv vx cv cH co wceq
      cG cabl wcel cH cG csubg cfv wcel wa vx cv cH crn wcel vy cv cH crn wcel
      wa wa vx cv vy cv cG co vy cv vx cv cG co vx cv vy cv cH co vy cv vx cv
      cH co cG cabl wcel cH cG csubg cfv wcel wa vx cv cH crn wcel vy cv cH crn
      wcel wa vx cv vy cv cG co vy cv vx cv cG co wceq cH cG csubg cfv wcel vx
      cv cH crn wcel vy cv cH crn wcel wa vx cv cG crn wcel vy cv cG crn wcel
      wa cG cabl wcel vx cv vy cv cG co vy cv vx cv cG co wceq cH cG csubg cfv
      wcel vx cv cH crn wcel vx cv cG crn wcel vy cv cH crn wcel vy cv cG crn
      wcel cH cG csubg cfv wcel cH crn cG crn vx cv cG cH cH crn cG crn cG crn
      eqid cH crn eqid subgrnss sseld cH cG csubg cfv wcel cH crn cG crn vy cv
      cG cH cH crn cG crn cG crn eqid cH crn eqid subgrnss sseld anim12d cG
      cabl wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cG crn wral vx cG
      crn wral vx cv cG crn wcel vy cv cG crn wcel wa vx cv vy cv cG co vy cv
      vx cv cG co wceq wi cG cabl wcel cG cgr wcel vx cv vy cv cG co vy cv vx
      cv cG co wceq vy cG crn wral vx cG crn wral vx vy cG cG crn cG crn eqid
      isabl pm3.27bi vx cv vy cv cG co vy cv vx cv cG co wceq vx vy cG crn cG
      crn ra42 syl sylan9r imp cG cabl wcel cH cG csubg cfv wcel wa vx cv cH
      crn wcel vy cv cH crn wcel wa vx cv vy cv cH co vx cv vy cv cG co wceq cH
      cG csubg cfv wcel vx cv cH crn wcel vy cv cH crn wcel wa vx cv vy cv cH
      co vx cv vy cv cG co wceq wi cG cabl wcel vx cv vy cv cG cH cH crn cH crn
      eqid subgopr adantl imp cG cabl wcel cH cG csubg cfv wcel wa vx cv cH crn
      wcel vy cv cH crn wcel wa vy cv vx cv cH co vy cv vx cv cG co wceq cH cG
      csubg cfv wcel vx cv cH crn wcel vy cv cH crn wcel wa vy cv vx cv cH co
      vy cv vx cv cG co wceq wi cG cabl wcel cH cG csubg cfv wcel vy cv cH crn
      wcel vx cv cH crn wcel vy cv vx cv cH co vy cv vx cv cG co wceq vy cv vx
      cv cG cH cH crn cH crn eqid subgopr ancomsd adantl imp 3eqtr4d ex
      r19.21aivv sylanc $.
      $( [26-Apr-2008] $) $( [25-Apr-2008] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of Abelian groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d u x y z A $.
    ablsn.1 $e |- A e. _V $.
    $( The Abelian group operation for the singleton group. $)
    ablsn $p |- { <. <. A , A >. , A >. } e. Abel $=
      vx vy cA cA cop cA cop csn cA csn cA ablsn.1 grpsn cA cA cop cA cop csn
      cdm cA cA cop csn cA csn cA csn cxp cA cA cop cA dmsnop cA cA ablsn.1
      ablsn.1 xpsn eqtr4i vx cv cA wceq vy cv cA wceq vx cv vy cv cA cA cop cA
      cop csn co vy cv vx cv cA cA cop cA cop csn co wceq vx cv cA csn wcel vy
      cv cA csn wcel vx cv cA wceq vy cv cA wceq wa vx cv vy cv cA cA cop cA
      cop csn co cA cA cA cA cop cA cop csn co vy cv vx cv cA cA cop cA cop csn
      co vx cv cA vy cv cA cA cA cop cA cop csn opreq12 vx cv cA wceq vy cv cA
      wceq vy cv vx cv cA cA cop cA cop csn co vy cv cA cA cA cop cA cop csn co
      cA cA cA cA cop cA cop csn co vx cv cA vy cv cA cA cop cA cop csn opreq2
      vy cv cA cA cA cA cop cA cop csn opreq1 sylan9eq eqtr4d vx cA elsn vy cA
      elsn syl2anb isabli $.
      $( [29-Nov-2006] $) $( [5-Nov-2006] $)
  $}

  ${
    $d x y z A $.
    $( Complex number addition is an Abelian group operation. $)
    cnaddabl $p |- + e. Abel $=
      vx vy caddc cc vx vy vz cc0 caddc vx cv cneg cc axcnex axaddopr vx cv vy
      cv vz cv addass 0cn vx cv addid2 vx cv negcl vx cv cc wcel vx cv vx cv
      cneg caddc co vx cv cneg vx cv caddc co cc0 vx cv cc wcel vx cv cneg cc
      wcel vx cv vx cv cneg caddc co vx cv cneg vx cv caddc co wceq vx cv negcl
      vx cv vx cv cneg addcom mpdan vx cv negid eqtr3d isgrpi cc cc cxp cc
      caddc axaddopr fdmi vx cv vy cv addcom isabli $.
      $( [7-Nov-2006] $) $( [5-Nov-2006] $)

    $( The group identity element of complex number addition is zero.
       (Contributed by Steve Rodriguez, 3-Dec-2006.) $)
    cnid $p |- 0 = ( Id ` + ) $=
      caddc cgi cfv cc0 cc0 vx cv caddc co vx cv wceq vx cc wral caddc cgi cfv
      cc0 wceq cc0 vx cv caddc co vx cv wceq vx cc vx cv addid2 rgen cc0 cc
      wcel cc0 vx cv caddc co vx cv wceq vx cc wral caddc cgi cfv cc0 wceq wb
      0cn vy cv vx cv caddc co vx cv wceq vx cc wral vy cv vx cv caddc co vx cv
      wceq vx cc wral vy cc crab cuni vy cv wceq wb cc0 vx cv caddc co vx cv
      wceq vx cc wral caddc cgi cfv cc0 wceq wb vy cc0 cc vy cv cc0 wceq vy cv
      vx cv caddc co vx cv wceq vx cc wral cc0 vx cv caddc co vx cv wceq vx cc
      wral vy cv vx cv caddc co vx cv wceq vx cc wral vy cc crab cuni vy cv
      wceq caddc cgi cfv cc0 wceq vy cv cc0 wceq vy cv vx cv caddc co vx cv
      wceq cc0 vx cv caddc co vx cv wceq vx cc vy cv cc0 wceq vy cv vx cv caddc
      co cc0 vx cv caddc co vx cv vy cv cc0 vx cv caddc opreq1 eqeq1d ralbidv
      vy cv cc0 wceq vy cv vx cv caddc co vx cv wceq vx cc wral vy cc crab cuni
      caddc cgi cfv vy cv cc0 vy cv vx cv caddc co vx cv wceq vx cc wral vy cc
      crab cuni caddc cgi cfv wceq vy cv cc0 wceq caddc cgi cfv vy cv vx cv
      caddc co vx cv wceq vx cc wral vy cc crab cuni caddc cgr wcel caddc cgi
      cfv vy cv vx cv caddc co vx cv wceq vx cc wral vy cc crab cuni wceq caddc
      cabl wcel caddc cgr wcel cnaddabl caddc ablgrp ax-mp vx vy caddc cgi cfv
      caddc cc caddc cc caddc cabl wcel caddc cgr wcel cnaddabl caddc ablgrp
      ax-mp cc cc cxp cc caddc axaddopr fdmi grprn caddc cgi cfv eqid grpidval
      ax-mp eqcomi a1i vy cv cc0 wceq id eqeq12d bibi12d vy cv cc wcel vy cv vx
      cv caddc co vx cv wceq vx cc wral vy cc wreu vy cv vx cv caddc co vx cv
      wceq vx cc wral vy cv vx cv caddc co vx cv wceq vx cc wral vy cc crab
      cuni vy cv wceq wb caddc cgr wcel vy cv vx cv caddc co vx cv wceq vx cc
      wral vy cc wreu caddc cabl wcel caddc cgr wcel cnaddabl caddc ablgrp
      ax-mp vx vy caddc cc caddc cc caddc cabl wcel caddc cgr wcel cnaddabl
      caddc ablgrp ax-mp cc cc cxp cc caddc axaddopr fdmi grprn grpideu ax-mp
      vy cv vx cv caddc co vx cv wceq vx cc wral vy cc reuuni1 mpan2 vtoclga
      ax-mp mpbi eqcomi $.
      $( [25-Jul-2008] $) $( [28-Nov-2006] $)

    $( Value of the group inverse of complex number addition.  (Contributed by
       Steve Rodriguez, 3-Dec-2006.) $)
    addinv $p |- ( A e. CC -> ( ( inv ` + ) ` A ) = -u A ) $=
      cA cc wcel cA caddc cgn cfv cfv cc0 cA cmin co cA cneg cA cc wcel cA vy
      cv caddc co cc0 wceq vy cc crab cuni vy cv cA caddc co cc0 wceq vy cc
      crab cuni cc0 cA cmin co cA caddc cgn cfv cfv cA cc wcel cA vy cv caddc
      co cc0 wceq vy cc crab vy cv cA caddc co cc0 wceq vy cc crab cA cc wcel
      cA vy cv caddc co cc0 wceq vy cv cA caddc co cc0 wceq vy cc cA cc wcel vy
      cv cc wcel wa cA vy cv caddc co vy cv cA caddc co cc0 cA vy cv addcom
      eqeq1d rabbidv unieqd cc0 cc wcel cA cc wcel cc0 cA cmin co cA vy cv
      caddc co cc0 wceq vy cc crab cuni wceq 0cn vy cc0 cA subval mpan caddc
      cgr wcel cA cc wcel cA caddc cgn cfv cfv vy cv cA caddc co cc0 wceq vy cc
      crab cuni wceq caddc cabl wcel caddc cgr wcel cnaddabl caddc ablgrp ax-mp
      vy cA cc0 caddc caddc cgn cfv cc caddc cc caddc cabl wcel caddc cgr wcel
      cnaddabl caddc ablgrp ax-mp cc cc cxp cc caddc axaddopr fdmi grprn cnid
      caddc cgn cfv eqid grpinvval mpan 3eqtr4rd cA df-neg syl6eqr $.
      $( [25-Jul-2008] $) $( [3-Dec-2006] $)

    $( The real numbers under addition comprise a subgroup of the complex
       numbers under addition.  (Contributed by Paul Chapman, 25-Apr-2008.) $)
    readdsubg $p |- ( + |` ( RR X. RR ) ) e. ( SubGrp ` + ) $=
      vx vy cc0 caddc caddc cr cr cxp cres caddc cgn cfv cc cr caddc cabl wcel
      caddc cgr wcel cnaddabl caddc ablgrp ax-mp caddc cc caddc cabl wcel caddc
      cgr wcel cnaddabl caddc ablgrp ax-mp cc cc cxp cc caddc axaddopr fdmi
      grprn cnid caddc cgn cfv eqid axresscn caddc cr cr cxp cres eqid vx cv vy
      cv readdcl 0re vx cv cr wcel vx cv caddc cgn cfv cfv vx cv cneg cr vx cv
      cr wcel vx cv cc wcel vx cv caddc cgn cfv cfv vx cv cneg wceq vx cv recn
      vx cv addinv syl vx cv renegcl eqeltrd issubgi $.
      $( [26-Apr-2008] $) $( [25-Apr-2008] $)

    $( The integers under addition comprise a subgroup of the complex numbers
       under addition.  (Contributed by Paul Chapman, 25-Apr-2008.) $)
    zaddsubg $p |- ( + |` ( ZZ X. ZZ ) ) e. ( SubGrp ` + ) $=
      vx vy cc0 caddc caddc cz cz cxp cres caddc cgn cfv cc cz caddc cabl wcel
      caddc cgr wcel cnaddabl caddc ablgrp ax-mp caddc cc caddc cabl wcel caddc
      cgr wcel cnaddabl caddc ablgrp ax-mp cc cc cxp cc caddc axaddopr fdmi
      grprn cnid caddc cgn cfv eqid zsscn caddc cz cz cxp cres eqid vx cv vy cv
      zaddcl 0z vx cv cz wcel vx cv caddc cgn cfv cfv vx cv cneg cz vx cv cz
      wcel vx cv cc wcel vx cv caddc cgn cfv cfv vx cv cneg wceq vx cv zcn vx
      cv addinv syl vx cv znegcl eqeltrd issubgi $.
      $( [26-Apr-2008] $) $( [25-Apr-2008] $)

    $( Nonzero complex number multiplication is an Abelian group operation.
       (Contributed by Steve Rodriguez, 12-Feb-2007.) $)
    ablmul $p |- ( x. |` ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) ) e. Abel $=
      vx vy cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cc cc0 csn cdif vx vy
      vz c1 cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres c1 vx cv cdiv co cc
      cc0 csn cdif cc cvv wcel cc cc0 csn cdif cvv wcel axcnex cc cc0 csn cvv
      difexg ax-mp mulnzcnopr vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif
      wcel vz cv cc cc0 csn cdif wcel w3a vx cv vy cv cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres co vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co vx cv vy cv cmul co vz cv cmul co vx cv vy cv vz cv cmul co cmul
      co vx cv vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co
      cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv cc cc0 csn cdif
      wcel vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel w3a vx cv vy
      cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vz cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv vy cv cmul cc cc0 csn cdif cc cc0
      csn cdif cxp cres co vz cv cmul co vx cv vy cv cmul co vz cv cmul co vx
      cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif
      wcel w3a vx cv vy cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co cc
      cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel wa vx cv vy cv cmul cc cc0
      csn cdif cc cc0 csn cdif cxp cres co vz cv cmul cc cc0 csn cdif cc cc0
      csn cdif cxp cres co vx cv vy cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co vz cv cmul co wceq vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn
      cdif wcel vz cv cc cc0 csn cdif wcel vx cv vy cv cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres co cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel
      wa vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel wa vx cv vy cv
      cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co cc cc0 csn cdif wcel vz
      cv cc cc0 csn cdif wcel vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif
      wcel wa vx cv vy cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx
      cv vy cv cmul co cc cc0 csn cdif vx cv vy cv cc cc0 csn cdif cc cc0 csn
      cdif cmul oprvres vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel
      wa vx cv vy cv cmul co cc wcel vx cv vy cv cmul co cc0 wne wa vx cv vy cv
      cmul co cc cc0 csn cdif wcel vx cv cc wcel vx cv cc0 wne wa vy cv cc wcel
      vy cv cc0 wne wa vx cv vy cv cmul co cc wcel vx cv vy cv cmul co cc0 wne
      wa vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel vx cv cc wcel vx
      cv cc0 wne wa vy cv cc wcel vy cv cc0 wne wa wa vx cv vy cv cmul co cc
      wcel vx cv vy cv cmul co cc0 wne vx cv cc wcel vy cv cc wcel vx cv vy cv
      cmul co cc wcel vx cv cc0 wne vy cv cc0 wne vx cv vy cv mulcl ad2ant2r vx
      cv vy cv mulne0 jca vx cv cc cc0 eldifsn vy cv cc cc0 eldifsn syl2anb vx
      cv vy cv cmul co cc cc0 eldifsn sylibr eqeltrd anim1i 3impa vx cv vy cv
      cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vz cv cc cc0 csn cdif cc
      cc0 csn cdif cmul oprvres syl vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn
      cdif wcel vz cv cc cc0 csn cdif wcel w3a vx cv vy cv cmul cc cc0 csn cdif
      cc cc0 csn cdif cxp cres co vx cv vy cv cmul co vz cv cmul vx cv cc cc0
      csn cdif wcel vy cv cc cc0 csn cdif wcel vx cv vy cv cmul cc cc0 csn cdif
      cc cc0 csn cdif cxp cres co vx cv vy cv cmul co wceq vz cv cc cc0 csn
      cdif wcel vx cv vy cv cc cc0 csn cdif cc cc0 csn cdif cmul oprvres
      3adant3 opreq1d eqtrd vx cv cc wcel vy cv cc wcel vz cv cc wcel vx cv vy
      cv cmul co vz cv cmul co vx cv vy cv vz cv cmul co cmul co wceq vx cv cc
      cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel
      vx cv vy cv vz cv mulass vx cv cc cc0 csn eldifi vy cv cc cc0 csn eldifi
      vz cv cc cc0 csn eldifi syl3an vx cv cc cc0 csn cdif wcel vy cv cc cc0
      csn cdif wcel vz cv cc cc0 csn cdif wcel w3a vx cv vy cv vz cv cmul co
      cmul co vx cv vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      co cmul co vx cv vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv cc cc0 csn
      cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel w3a vy cv
      vz cv cmul co vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      co vx cv cmul vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel vy cv
      vz cv cmul co vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      co wceq vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc
      cc0 csn cdif wcel wa vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co vy cv vz cv cmul co vy cv vz cv cc cc0 csn cdif cc cc0 csn cdif
      cmul oprvres eqcomd 3adant1 opreq2d vx cv cc cc0 csn cdif wcel vy cv cc
      cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel w3a vx cv vy cv vz cv cmul
      co cmul co vx cv vy cv vz cv cmul co cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres co vx cv vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co cmul co vx cv vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres co cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv cc cc0
      csn cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel vx cv
      vy cv vz cv cmul co cmul co vx cv vy cv vz cv cmul co cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co wceq vx cv cc cc0 csn cdif wcel vy cv vz
      cv cmul co cc cc0 csn cdif wcel vx cv vy cv vz cv cmul co cmul co vx cv
      vy cv vz cv cmul co cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co wceq
      vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel wa vx cv cc cc0 csn
      cdif wcel vy cv vz cv cmul co cc cc0 csn cdif wcel wa vx cv vy cv vz cv
      cmul co cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv vy cv vz
      cv cmul co cmul co vx cv vy cv vz cv cmul co cc cc0 csn cdif cc cc0 csn
      cdif cmul oprvres eqcomd vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif
      wcel wa vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vy
      cv vz cv cmul co cc cc0 csn cdif vy cv vz cv cc cc0 csn cdif cc cc0 csn
      cdif cmul oprvres vy cv vz cv cc cc0 csn cdif cc cc0 csn cdif cc cc0 csn
      cdif cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres mulnzcnopr foprcl
      eqeltrrd sylan2 3impb vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif
      wcel vz cv cc cc0 csn cdif wcel w3a vy cv vz cv cmul co vy cv vz cv cmul
      cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv cmul vy cv cc cc0 csn
      cdif wcel vz cv cc cc0 csn cdif wcel vy cv vz cv cmul co vy cv vz cv cmul
      cc cc0 csn cdif cc cc0 csn cdif cxp cres co wceq vx cv cc cc0 csn cdif
      wcel vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel wa vy cv vz cv
      cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vy cv vz cv cmul co vy
      cv vz cv cc cc0 csn cdif cc cc0 csn cdif cmul oprvres eqcomd 3adant1
      opreq2d vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc
      cc0 csn cdif wcel w3a vy cv vz cv cmul co vy cv vz cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv cmul cc cc0 csn cdif cc cc0 csn
      cdif cxp cres vy cv cc cc0 csn cdif wcel vz cv cc cc0 csn cdif wcel vy cv
      vz cv cmul co vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      co wceq vx cv cc cc0 csn cdif wcel vy cv cc cc0 csn cdif wcel vz cv cc
      cc0 csn cdif wcel wa vy cv vz cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co vy cv vz cv cmul co vy cv vz cv cc cc0 csn cdif cc cc0 csn cdif
      cmul oprvres eqcomd 3adant1 opreq2d 3eqtr3d eqtrd 3eqtrd c1 cc cc0 csn
      cdif wcel c1 cc wcel c1 cc0 wne c1 cc cc0 eldifsn ax1cn ax1ne0 mpbir2an
      vx cv cc cc0 csn cdif wcel c1 vx cv cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres co c1 vx cv cmul co vx cv c1 cc cc0 csn cdif wcel vx cv cc cc0
      csn cdif wcel c1 vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co
      c1 vx cv cmul co wceq c1 cc cc0 csn cdif wcel c1 cc wcel c1 cc0 wne c1 cc
      cc0 eldifsn ax1cn ax1ne0 mpbir2an c1 vx cv cc cc0 csn cdif cc cc0 csn
      cdif cmul oprvres mpan vx cv cc cc0 csn cdif wcel vx cv cc wcel c1 vx cv
      cmul co vx cv wceq vx cv cc cc0 csn eldifi vx cv mulid2 syl eqtrd vx cv
      cc wcel vx cv cc0 wne wa c1 vx cv cdiv co cc wcel c1 vx cv cdiv co cc0
      wne wa vx cv cc cc0 csn cdif wcel c1 vx cv cdiv co cc cc0 csn cdif wcel
      vx cv cc wcel vx cv cc0 wne wa c1 vx cv cdiv co cc wcel c1 vx cv cdiv co
      cc0 wne vx cv reccl vx cv recne0 jca vx cv cc cc0 eldifsn c1 vx cv cdiv
      co cc cc0 eldifsn 3imtr4i vx cv cc cc0 csn cdif wcel c1 vx cv cdiv co vx
      cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co c1 vx cv cdiv co vx
      cv cmul co c1 c1 vx cv cdiv co cc cc0 csn cdif wcel vx cv cc cc0 csn cdif
      wcel c1 vx cv cdiv co vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      co c1 vx cv cdiv co vx cv cmul co wceq vx cv cc wcel vx cv cc0 wne wa c1
      vx cv cdiv co cc wcel c1 vx cv cdiv co cc0 wne wa vx cv cc cc0 csn cdif
      wcel c1 vx cv cdiv co cc cc0 csn cdif wcel vx cv cc wcel vx cv cc0 wne wa
      c1 vx cv cdiv co cc wcel c1 vx cv cdiv co cc0 wne vx cv reccl vx cv
      recne0 jca vx cv cc cc0 eldifsn c1 vx cv cdiv co cc cc0 eldifsn 3imtr4i
      c1 vx cv cdiv co vx cv cc cc0 csn cdif cc cc0 csn cdif cmul oprvres
      mpancom vx cv cc cc0 csn cdif wcel vx cv cc wcel vx cv cc0 wne wa c1 vx
      cv cdiv co vx cv cmul co c1 wceq vx cv cc cc0 eldifsn vx cv recid2 sylbi
      eqtrd isgrpi cc cc0 csn cdif cc cc0 csn cdif cxp cc cc0 csn cdif cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres mulnzcnopr fdmi vx cv cc cc0 csn
      cdif wcel vy cv cc cc0 csn cdif wcel wa vx cv vy cv cmul co vy cv vx cv
      cmul co vx cv vy cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vy
      cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv cc wcel
      vy cv cc wcel vx cv vy cv cmul co vy cv vx cv cmul co wceq vx cv cc cc0
      csn cdif wcel vy cv cc cc0 csn cdif wcel vx cv vy cv mulcom vx cv cc cc0
      csn eldifi vy cv cc cc0 csn eldifi syl2an vx cv vy cv cc cc0 csn cdif cc
      cc0 csn cdif cmul oprvres vy cv cc cc0 csn cdif wcel vx cv cc cc0 csn
      cdif wcel vy cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vy
      cv vx cv cmul co wceq vy cv vx cv cc cc0 csn cdif cc cc0 csn cdif cmul
      oprvres ancoms 3eqtr4d isabli $.
      $( [24-Feb-2007] $) $( [7-Nov-2006] $)

    $( The group identity element of nonzero complex number multiplication is
       one.  (Contributed by Steve Rodriguez, 23-Feb-2007.) $)
    mulid $p |- ( Id ` ( x. |` ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) ) ) = 1 $=
      c1 vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx
      cc cc0 csn cdif wral cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cgi
      cfv c1 wceq c1 vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx
      cv wceq vx cc cc0 csn cdif vx cv cc cc0 csn cdif wcel c1 vx cv cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres co c1 vx cv cmul co vx cv c1 cc cc0
      csn cdif wcel vx cv cc cc0 csn cdif wcel c1 vx cv cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres co c1 vx cv cmul co wceq c1 cc cc0 csn cdif wcel c1
      cc wcel c1 cc0 wne c1 cc cc0 eldifsn ax1cn ax1ne0 mpbir2an c1 vx cv cc
      cc0 csn cdif cc cc0 csn cdif cmul oprvres mpan vx cv cc cc0 csn cdif wcel
      vx cv cc wcel c1 vx cv cmul co vx cv wceq vx cv cc cc0 csn eldifi vx cv
      mulid2 syl eqtrd rgen c1 cc cc0 csn cdif wcel c1 vx cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral cmul
      cc cc0 csn cdif cc cc0 csn cdif cxp cres cgi cfv c1 wceq wb c1 cc cc0 csn
      cdif wcel c1 cc wcel c1 cc0 wne c1 cc cc0 eldifsn ax1cn ax1ne0 mpbir2an
      vy cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq
      vx cc cc0 csn cdif wral vy cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc cc0 csn cdif crab
      cuni vy cv wceq wb c1 vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      co vx cv wceq vx cc cc0 csn cdif wral cmul cc cc0 csn cdif cc cc0 csn
      cdif cxp cres cgi cfv c1 wceq wb vy c1 cc cc0 csn cdif vy cv c1 wceq vy
      cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx
      cc cc0 csn cdif wral c1 vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres co vx cv wceq vx cc cc0 csn cdif wral vy cv vx cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc
      cc0 csn cdif crab cuni vy cv wceq cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres cgi cfv c1 wceq vy cv c1 wceq vy cv vx cv cmul cc cc0 csn cdif
      cc cc0 csn cdif cxp cres co vx cv wceq c1 vx cv cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif vy cv c1 wceq vy
      cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co c1 vx cv cmul
      cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv vy cv c1 vx cv cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres opreq1 eqeq1d ralbidv cmul cc cc0
      csn cdif cc cc0 csn cdif cxp cres cgi cfv vy cv vx cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc
      cc0 csn cdif crab cuni wceq vy cv c1 wceq vy cv vx cv cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc
      cc0 csn cdif crab cuni vy cv wceq cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres cgi cfv c1 wceq wb cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      cgr wcel cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cgi cfv vy cv vx
      cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0
      csn cdif wral vy cc cc0 csn cdif crab cuni wceq cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres cabl wcel cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres cgr wcel ablmul cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres ablgrp
      ax-mp vx vy cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cgi cfv cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres cc cc0 csn cdif cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres cc cc0 csn cdif cmul cc cc0 csn cdif cc cc0
      csn cdif cxp cres cabl wcel cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      cgr wcel ablmul cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres ablgrp
      ax-mp cc cc0 csn cdif cc cc0 csn cdif cxp cc cc0 csn cdif cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres mulnzcnopr fdmi grprn cmul cc cc0 csn cdif
      cc cc0 csn cdif cxp cres cgi cfv eqid grpidval ax-mp vy cv vx cv cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif
      wral vy cc cc0 csn cdif crab cuni cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres cgi cfv wceq vy cv c1 wceq vy cv vx cv cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc cc0 csn
      cdif crab cuni vy cv wceq cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres
      cgi cfv c1 wceq wb cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cgi cfv
      vy cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq
      vx cc cc0 csn cdif wral vy cc cc0 csn cdif crab cuni wceq vy cv vx cv
      cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn
      cdif wral vy cc cc0 csn cdif crab cuni cmul cc cc0 csn cdif cc cc0 csn
      cdif cxp cres cgi cfv vy cv c1 eqeq12 cmul cc cc0 csn cdif cc cc0 csn
      cdif cxp cres cgi cfv vy cv vx cv cmul cc cc0 csn cdif cc cc0 csn cdif
      cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc cc0 csn cdif crab
      cuni eqcom sylanb mpan bibi12d vy cv cc cc0 csn cdif wcel vy cv vx cv
      cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn
      cdif wral vy cc cc0 csn cdif wreu vy cv vx cv cmul cc cc0 csn cdif cc cc0
      csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cv vx cv cmul
      cc cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif
      wral vy cc cc0 csn cdif crab cuni vy cv wceq wb cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres cgr wcel vy cv vx cv cmul cc cc0 csn cdif cc cc0
      csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif wral vy cc cc0 csn
      cdif wreu cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cabl wcel cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres cgr wcel ablmul cmul cc cc0 csn
      cdif cc cc0 csn cdif cxp cres ablgrp ax-mp vx vy cmul cc cc0 csn cdif cc
      cc0 csn cdif cxp cres cc cc0 csn cdif cmul cc cc0 csn cdif cc cc0 csn
      cdif cxp cres cc cc0 csn cdif cmul cc cc0 csn cdif cc cc0 csn cdif cxp
      cres cabl wcel cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres cgr wcel
      ablmul cmul cc cc0 csn cdif cc cc0 csn cdif cxp cres ablgrp ax-mp cc cc0
      csn cdif cc cc0 csn cdif cxp cc cc0 csn cdif cmul cc cc0 csn cdif cc cc0
      csn cdif cxp cres mulnzcnopr fdmi grprn grpideu ax-mp vy cv vx cv cmul cc
      cc0 csn cdif cc cc0 csn cdif cxp cres co vx cv wceq vx cc cc0 csn cdif
      wral vy cc cc0 csn cdif reuuni1 mpan2 vtoclga ax-mp mpbi $.
      $( [25-Jul-2008] $) $( [3-Dec-2006] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Group homomorphism
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F x y $.  $d G a b x y $.  $d H a b x y $.  $d O x y $.  $d X x y $.
    $d Y a b x y $.

    ghgrpi.1 $e |- G e. Grp $.
    ghgrpi.2 $e |- X = ran G $.
    ghgrpi.3 $e |- F : X -onto-> Y $.
    ghgrpi.4 $e |- Y C_ A $.
    ghgrpi.5 $e |- O Fn ( A X. A ) $.
    ghgrpi.6 $e |- ( ( x e. X /\ y e. X ) ->
                     ( F ` ( x G y ) ) = ( ( F ` x ) O ( F ` y ) ) ) $.
    ghgrpi.7 $e |- H = ( O |` ( Y X. Y ) ) $.

    ${
      $d C a b $.  $d D b $.  $d F a b $.  $d O a b $.  $d X a b $.
      $( Lemma for ~ ghgrpi . $)
      ghgrpilem1 $p |- ( ( C e. X /\ D e. X ) ->
                         ( F ` ( C G D ) ) = ( ( F ` C ) H ( F ` D ) ) ) $=
        cC cX wcel cD cX wcel wa cC cD cG co cF cfv cC cF cfv cD cF cfv cO co
        cC cF cfv cD cF cfv cH co cC cX wcel cD cX wcel wa va cv vb cv cG co cF
        cfv va cv cF cfv vb cv cF cfv cO co wceq vb cX wral va cX wral cC cD cG
        co cF cfv cC cF cfv cD cF cfv cO co wceq vx cv vy cv cG co cF cfv vx cv
        cF cfv vy cv cF cfv cO co wceq vy cX wral vx cX wral va cv vb cv cG co
        cF cfv va cv cF cfv vb cv cF cfv cO co wceq vb cX wral va cX wral vx cv
        vy cv cG co cF cfv vx cv cF cfv vy cv cF cfv cO co wceq vx vy cX
        ghgrpi.6 rgen2a vx cv vy cv cG co cF cfv vx cv cF cfv vy cv cF cfv cO
        co wceq va cv vb cv cG co cF cfv va cv cF cfv vb cv cF cfv cO co wceq
        va cv vy cv cG co cF cfv va cv cF cfv vy cv cF cfv cO co wceq vx vy va
        vb cX cX vx cv va cv wceq vx cv vy cv cG co cF cfv va cv vy cv cG co cF
        cfv vx cv cF cfv vy cv cF cfv cO co va cv cF cfv vy cv cF cfv cO co vx
        cv va cv wceq vx cv vy cv cG co va cv vy cv cG co cF vx cv va cv vy cv
        cG opreq1 fveq2d vx cv va cv wceq vx cv cF cfv va cv cF cfv vy cv cF
        cfv cO vx cv va cv cF fveq2 opreq1d eqeq12d vy cv vb cv wceq va cv vy
        cv cG co cF cfv va cv vb cv cG co cF cfv va cv cF cfv vy cv cF cfv cO
        co va cv cF cfv vb cv cF cfv cO co vy cv vb cv wceq va cv vy cv cG co
        va cv vb cv cG co cF vy cv vb cv va cv cG opreq2 fveq2d vy cv vb cv
        wceq vy cv cF cfv vb cv cF cfv va cv cF cfv cO vy cv vb cv cF fveq2
        opreq2d eqeq12d cbvral2v mpbi va cv vb cv cG co cF cfv va cv cF cfv vb
        cv cF cfv cO co wceq cC cD cG co cF cfv cC cF cfv cD cF cfv cO co wceq
        cC vb cv cG co cF cfv cC cF cfv vb cv cF cfv cO co wceq va vb cC cD cX
        cX va cv cC wceq va cv vb cv cG co cF cfv cC vb cv cG co cF cfv va cv
        cF cfv vb cv cF cfv cO co cC cF cfv vb cv cF cfv cO co va cv cC wceq va
        cv vb cv cG co cC vb cv cG co cF va cv cC vb cv cG opreq1 fveq2d va cv
        cC wceq va cv cF cfv cC cF cfv vb cv cF cfv cO va cv cC cF fveq2
        opreq1d eqeq12d vb cv cD wceq cC vb cv cG co cF cfv cC cD cG co cF cfv
        cC cF cfv vb cv cF cfv cO co cC cF cfv cD cF cfv cO co vb cv cD wceq cC
        vb cv cG co cC cD cG co cF vb cv cD cC cG opreq2 fveq2d vb cv cD wceq
        vb cv cF cfv cD cF cfv cC cF cfv cO vb cv cD cF fveq2 opreq2d eqeq12d
        rcla42v mpi cC cF cfv cY wcel cD cF cfv cY wcel cC cF cfv cD cF cfv cH
        co cC cF cfv cD cF cfv cO co wceq cC cX wcel cD cX wcel cC cF cfv cY
        wcel cD cF cfv cY wcel wa cC cF cfv cD cF cfv cO cY cY cxp cres co cC
        cF cfv cD cF cfv cO co cC cF cfv cD cF cfv cH co cC cF cfv cD cF cfv cY
        cY cO oprvres cH cO cY cY cxp cres cC cF cfv cD cF cfv ghgrpi.7 opreqi
        syl5eq cC cX wcel cC cF cfv cF crn cY cF cX wfn cC cX wcel cC cF cfv cF
        crn wcel cF cX wfn cF crn cY wceq cX cY cF wfo cF cX wfn cF crn cY wceq
        wa ghgrpi.3 cX cY cF df-fo mpbi pm3.26i cX cC cF fnfvelrn mpan cF cX
        wfn cF crn cY wceq cX cY cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX
        cY cF df-fo mpbi pm3.27i syl6eleq cD cX wcel cD cF cfv cF crn cY cF cX
        wfn cD cX wcel cD cF cfv cF crn wcel cF cX wfn cF crn cY wceq cX cY cF
        wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi pm3.26i cX
        cD cF fnfvelrn mpan cF cX wfn cF crn cY wceq cX cY cF wfo cF cX wfn cF
        crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi pm3.27i syl6eleq syl2an
        eqtr4d $.
        $( [26-Apr-2008] $) $( [25-Apr-2008] $)
    $}

    ${
      $d C w $.  $d F w $.  $d X w $.  $d ch w $.  $d ph w $.
      ghgrpilem2.8 $e |- ( ( w e. X /\ ph ) -> ps ) $.
      ghgrpilem2.9 $e |- ( ( F ` w ) = C -> ( ps <-> ch ) ) $.
      $( Lemma for ~ ghgrpi . $)
      ghgrpilem2 $p |- ( ( ph /\ C e. Y ) -> ch ) $=
        wph cC cY wcel wch wph vw cv cF cfv cC wceq vw cX wrex wch cC cY wcel
        wph vw cv cF cfv cC wceq wch vw cX vw cv cF cfv cC wceq wps wch wph vw
        cv cX wcel wa ghgrpilem2.9 vw cv cX wcel wph wps ghgrpilem2.8 ancoms
        syl5cbi r19.23adva cC cY wcel cC cF crn wcel vw cv cF cfv cC wceq vw cX
        wrex cF crn cY cC cF cX wfn cF crn cY wceq cX cY cF wfo cF cX wfn cF
        crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi pm3.27i eleq2i cF cX wfn cC
        cF crn wcel vw cv cF cfv cC wceq vw cX wrex wb cF cX wfn cF crn cY wceq
        cX cY cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi
        pm3.26i vw cX cC cF fvelrnb ax-mp bitr3i syl5ib imp $.
        $( [26-Apr-2008] $) $( [25-Apr-2008] $)
    $}

    ${
      $d D c $.  $d F c z $.  $d G c $.  $d H a b c x y z $.  $d N c $.
      $d X z $.  $d Y c z $.

      ghgrpilem3.8 $e |- U = ( Id ` G ) $.
      ghgrpilem3.9 $e |- N = ( inv ` G ) $.
      ghgrpilem3.10 $e |- D = ( /g ` G ) $.
      $( Lemma for ~ ghgrpi . $)
      ghgrpilem3 $p |- ( ( a e. Y /\ b e. Y ) ->
          ( E. c e. Y ( c H a ) = b /\ E. c e. Y ( a H c ) = b ) ) $=
        va cv cY wcel vb cv cY wcel wa vc cv va cv cH co vb cv wceq vc cY wrex
        va cv vc cv cH co vb cv wceq vc cY wrex va cv cY wcel vc cv va cv cH co
        vy cv cF cfv wceq vc cY wrex vc cv va cv cH co vb cv wceq vc cY wrex vx
        vy vy cA vb cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4
        ghgrpi.5 ghgrpi.6 ghgrpi.7 vy cv cX wcel vc cv vx cv cF cfv cH co vy cv
        cF cfv wceq vc cY wrex vc cv va cv cH co vy cv cF cfv wceq vc cY wrex
        vx vy vx cA va cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4
        ghgrpi.5 ghgrpi.6 ghgrpi.7 vy cv cX wcel vx cv cX wcel vc cv vx cv cF
        cfv cH co vy cv cF cfv wceq vc cY wrex vy cv vx cv cD co cF cfv cY wcel
        vy cv vx cv cD co cF cfv vx cv cF cfv cH co vy cv cF cfv wceq vc cv vx
        cv cF cfv cH co vy cv cF cfv wceq vc cY wrex vy cv cX wcel vx cv cX
        wcel wa vc cv vx cv cF cfv cH co vy cv cF cfv wceq vy cv vx cv cD co cF
        cfv vx cv cF cfv cH co vy cv cF cfv wceq vc vy cv vx cv cD co cF cfv cY
        vc cv vy cv vx cv cD co cF cfv wceq vc cv vx cv cF cfv cH co vy cv vx
        cv cD co cF cfv vx cv cF cfv cH co vy cv cF cfv vc cv vy cv vx cv cD co
        cF cfv vx cv cF cfv cH opreq1 eqeq1d rcla4ev vy cv cX wcel vx cv cX
        wcel wa vy cv vx cv cD co cF cfv cF crn cY cF cX wfn vy cv vx cv cD co
        cX wcel vy cv vx cv cD co cF cfv cF crn wcel vy cv cX wcel vx cv cX
        wcel wa cX vy cv vx cv cD co cF fnfvelrn cF cX wfn cF crn cY wceq cX cY
        cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi pm3.26i
        cG cgr wcel vy cv cX wcel vx cv cX wcel vy cv vx cv cD co cX wcel
        ghgrpi.1 vy cv vx cv cD cG cX ghgrpi.2 ghgrpilem3.10 grpdivcl mp3an1
        sylancr cF cX wfn cF crn cY wceq cX cY cF wfo cF cX wfn cF crn cY wceq
        wa ghgrpi.3 cX cY cF df-fo mpbi pm3.27i syl6eleq vy cv cX wcel vx cv cX
        wcel wa vy cv vx cv cD co vx cv cG co cF cfv vy cv vx cv cD co cF cfv
        vx cv cF cfv cH co vy cv cF cfv vy cv cX wcel vx cv cX wcel vy cv vx cv
        cD co cX wcel vy cv vx cv cD co vx cv cG co cF cfv vy cv vx cv cD co cF
        cfv vx cv cF cfv cH co wceq cG cgr wcel vy cv cX wcel vx cv cX wcel vy
        cv vx cv cD co cX wcel ghgrpi.1 vy cv vx cv cD cG cX ghgrpi.2
        ghgrpilem3.10 grpdivcl mp3an1 vx vy cA vy cv vx cv cD co vx cv cF cG cH
        cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7
        ghgrpilem1 sylancom vy cv cX wcel vx cv cX wcel wa vy cv vx cv cD co vx
        cv cG co vy cv cF cG cgr wcel vy cv cX wcel vx cv cX wcel vy cv vx cv
        cD co vx cv cG co vy cv wceq ghgrpi.1 vy cv vx cv cD cG cX ghgrpi.2
        ghgrpilem3.10 grpnpcan mp3an1 fveq2d eqtr3d sylanc ancoms vx cv cF cfv
        va cv wceq vc cv vx cv cF cfv cH co vy cv cF cfv wceq vc cv va cv cH co
        vy cv cF cfv wceq vc cY vx cv cF cfv va cv wceq vc cv vx cv cF cfv cH
        co vc cv va cv cH co vy cv cF cfv vx cv cF cfv va cv vc cv cH opreq2
        eqeq1d rexbidv ghgrpilem2 vy cv cF cfv vb cv wceq vc cv va cv cH co vy
        cv cF cfv wceq vc cv va cv cH co vb cv wceq vc cY vy cv cF cfv vb cv vc
        cv va cv cH co eqeq2 rexbidv ghgrpilem2 va cv cY wcel va cv vc cv cH co
        vy cv cF cfv wceq vc cY wrex va cv vc cv cH co vb cv wceq vc cY wrex vx
        vy vy cA vb cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4
        ghgrpi.5 ghgrpi.6 ghgrpi.7 vy cv cX wcel vx cv cF cfv vc cv cH co vy cv
        cF cfv wceq vc cY wrex va cv vc cv cH co vy cv cF cfv wceq vc cY wrex
        vx vy vx cA va cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4
        ghgrpi.5 ghgrpi.6 ghgrpi.7 vx cv cN cfv vy cv cG co cF cfv cY wcel vx
        cv cF cfv vx cv cN cfv vy cv cG co cF cfv cH co vy cv cF cfv wceq vx cv
        cF cfv vc cv cH co vy cv cF cfv wceq vc cY wrex vx cv cX wcel vy cv cX
        wcel wa vx cv cF cfv vc cv cH co vy cv cF cfv wceq vx cv cF cfv vx cv
        cN cfv vy cv cG co cF cfv cH co vy cv cF cfv wceq vc vx cv cN cfv vy cv
        cG co cF cfv cY vc cv vx cv cN cfv vy cv cG co cF cfv wceq vx cv cF cfv
        vc cv cH co vx cv cF cfv vx cv cN cfv vy cv cG co cF cfv cH co vy cv cF
        cfv vc cv vx cv cN cfv vy cv cG co cF cfv vx cv cF cfv cH opreq2 eqeq1d
        rcla4ev vx cv cX wcel vy cv cX wcel wa vx cv cN cfv vy cv cG co cF cfv
        cF crn cY cF cX wfn vx cv cN cfv vy cv cG co cX wcel vx cv cN cfv vy cv
        cG co cF cfv cF crn wcel vx cv cX wcel vy cv cX wcel wa cX vx cv cN cfv
        vy cv cG co cF fnfvelrn cF cX wfn cF crn cY wceq cX cY cF wfo cF cX wfn
        cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi pm3.26i vx cv cN cfv cX
        wcel vy cv cX wcel vx cv cN cfv vy cv cG co cX wcel vx cv cX wcel cG
        cgr wcel vx cv cN cfv cX wcel vy cv cX wcel vx cv cN cfv vy cv cG co cX
        wcel ghgrpi.1 vx cv cN cfv vy cv cG cX ghgrpi.2 grpcl mp3an1 cG cgr
        wcel vx cv cX wcel vx cv cN cfv cX wcel ghgrpi.1 vx cv cG cN cX
        ghgrpi.2 ghgrpilem3.9 grpinvcl mpan sylan sylancr cF cX wfn cF crn cY
        wceq cX cY cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo
        mpbi pm3.27i syl6eleq vx cv cX wcel vy cv cX wcel wa vx cv vx cv cN cfv
        vy cv cG co cG co cF cfv vx cv cF cfv vx cv cN cfv vy cv cG co cF cfv
        cH co vy cv cF cfv vx cv cX wcel vy cv cX wcel vx cv cN cfv vy cv cG co
        cX wcel vx cv vx cv cN cfv vy cv cG co cG co cF cfv vx cv cF cfv vx cv
        cN cfv vy cv cG co cF cfv cH co wceq vx cv cN cfv cX wcel vy cv cX wcel
        vx cv cN cfv vy cv cG co cX wcel vx cv cX wcel cG cgr wcel vx cv cN cfv
        cX wcel vy cv cX wcel vx cv cN cfv vy cv cG co cX wcel ghgrpi.1 vx cv
        cN cfv vy cv cG cX ghgrpi.2 grpcl mp3an1 cG cgr wcel vx cv cX wcel vx
        cv cN cfv cX wcel ghgrpi.1 vx cv cG cN cX ghgrpi.2 ghgrpilem3.9
        grpinvcl mpan sylan vx vy cA vx cv vx cv cN cfv vy cv cG co cF cG cH cO
        cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7
        ghgrpilem1 syldan vx cv cX wcel vy cv cX wcel wa vx cv vx cv cN cfv vy
        cv cG co cG co vy cv cF cG cgr wcel vx cv cX wcel vy cv cX wcel vx cv
        vx cv cN cfv vy cv cG co cG co vy cv wceq ghgrpi.1 vx cv vy cv cG cN cX
        ghgrpi.2 ghgrpilem3.9 grpasscan1 mp3an1 fveq2d eqtr3d sylanc vx cv cF
        cfv va cv wceq vx cv cF cfv vc cv cH co vy cv cF cfv wceq va cv vc cv
        cH co vy cv cF cfv wceq vc cY vx cv cF cfv va cv wceq vx cv cF cfv vc
        cv cH co va cv vc cv cH co vy cv cF cfv vx cv cF cfv va cv vc cv cH
        opreq1 eqeq1d rexbidv ghgrpilem2 vy cv cF cfv vb cv wceq va cv vc cv cH
        co vy cv cF cfv wceq va cv vc cv cH co vb cv wceq vc cY vy cv cF cfv vb
        cv va cv vc cv cH co eqeq2 rexbidv ghgrpilem2 jca $.
        $( [26-Apr-2008] $) $( [25-Apr-2008] $)

      $( Lemma for ~ ghgrpi . $)
      ghgrpilem4 $p |- H e. Grp $=
        va vb vc cH cY cX cvv wcel cX cY cF wfo cY cvv wcel cX cG crn cvv
        ghgrpi.2 cG cgr wcel cG crn cvv wcel ghgrpi.1 cG cgr rnexg ax-mp
        eqeltri ghgrpi.3 cX cY cvv cF fornex mp2 cU cF cfv cY wcel cY c0 wne cU
        cF cfv cF crn cY cF cX wfn cU cX wcel cU cF cfv cF crn wcel cF cX wfn
        cF crn cY wceq cX cY cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY
        cF df-fo mpbi pm3.26i cG cgr wcel cU cX wcel ghgrpi.1 cU cG cX ghgrpi.2
        ghgrpilem3.8 grpidcl ax-mp cX cU cF fnfvelrn mp2an cF cX wfn cF crn cY
        wceq cX cY cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo
        mpbi pm3.27i eleqtri cY cU cF cfv ne0i ax-mp cY cY cxp cY cH wf cH cY
        cY cxp wfn va cv vb cv cH co cY wcel vb cY wral va cY wral va vb cY cY
        cY cH ffnoprv cH cY cY cxp wfn cO cY cY cxp cres cY cY cxp wfn cO cA cA
        cxp wfn cY cY cxp cA cA cxp wss cO cY cY cxp cres cY cY cxp wfn
        ghgrpi.5 cY cA wss cY cA wss cY cY cxp cA cA cxp wss ghgrpi.4 ghgrpi.4
        cY cA cY cA ssxp mp2an cA cA cxp cY cY cxp cO fnssres mp2an cH cO cY cY
        cxp cres wceq cH cY cY cxp wfn cO cY cY cxp cres cY cY cxp wfn wb
        ghgrpi.7 cY cY cxp cH cO cY cY cxp cres fneq1 ax-mp mpbir va cv vb cv
        cH co cY wcel va vb cY va cv cY wcel va cv vy cv cF cfv cH co cY wcel
        va cv vb cv cH co cY wcel vx vy vy cA vb cv cF cG cH cO cX cY ghgrpi.1
        ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 vy cv cX wcel vx
        cv cF cfv vy cv cF cfv cH co cY wcel va cv vy cv cF cfv cH co cY wcel
        vx vy vx cA va cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4
        ghgrpi.5 ghgrpi.6 ghgrpi.7 vx cv cX wcel vy cv cX wcel wa vx cv cF cfv
        vy cv cF cfv cH co cF crn cY vx cv cX wcel vy cv cX wcel wa vx cv vy cv
        cG co cF cfv vx cv cF cfv vy cv cF cfv cH co cF crn vx vy cA vx cv vy
        cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5
        ghgrpi.6 ghgrpi.7 ghgrpilem1 cF cX wfn vx cv vy cv cG co cX wcel vx cv
        vy cv cG co cF cfv cF crn wcel vx cv cX wcel vy cv cX wcel wa cX vx cv
        vy cv cG co cF fnfvelrn cF cX wfn cF crn cY wceq cX cY cF wfo cF cX wfn
        cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi pm3.26i cG cgr wcel vx
        cv cX wcel vy cv cX wcel vx cv vy cv cG co cX wcel ghgrpi.1 vx cv vy cv
        cG cX ghgrpi.2 grpcl mp3an1 sylancr eqeltrrd cF cX wfn cF crn cY wceq
        cX cY cF wfo cF cX wfn cF crn cY wceq wa ghgrpi.3 cX cY cF df-fo mpbi
        pm3.27i syl6eleq vx cv cF cfv va cv wceq vx cv cF cfv vy cv cF cfv cH
        co va cv vy cv cF cfv cH co cY vx cv cF cfv va cv vy cv cF cfv cH
        opreq1 eleq1d ghgrpilem2 vy cv cF cfv vb cv wceq va cv vy cv cF cfv cH
        co va cv vb cv cH co cY vy cv cF cfv vb cv va cv cH opreq2 eleq1d
        ghgrpilem2 rgen2a mpbir2an va cv cY wcel vb cv cY wcel vc cv cY wcel va
        cv vb cv cH co vc cv cH co va cv vb cv vc cv cH co cH co wceq va cv cY
        wcel vb cv cY wcel wa va cv vb cv cH co vz cv cF cfv cH co va cv vb cv
        vz cv cF cfv cH co cH co wceq va cv vb cv cH co vc cv cH co va cv vb cv
        vc cv cH co cH co wceq vx vy vz cA vc cv cF cG cH cO cX cY ghgrpi.1
        ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 vz cv cX wcel va
        cv cY wcel vb cv cY wcel va cv vb cv cH co vz cv cF cfv cH co va cv vb
        cv vz cv cF cfv cH co cH co wceq vz cv cX wcel va cv cY wcel wa va cv
        vy cv cF cfv cH co vz cv cF cfv cH co va cv vy cv cF cfv vz cv cF cfv
        cH co cH co wceq va cv vb cv cH co vz cv cF cfv cH co va cv vb cv vz cv
        cF cfv cH co cH co wceq vx vy vy cA vb cv cF cG cH cO cX cY ghgrpi.1
        ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 vy cv cX wcel vz
        cv cX wcel va cv cY wcel va cv vy cv cF cfv cH co vz cv cF cfv cH co va
        cv vy cv cF cfv vz cv cF cfv cH co cH co wceq vy cv cX wcel vz cv cX
        wcel wa vx cv cF cfv vy cv cF cfv cH co vz cv cF cfv cH co vx cv cF cfv
        vy cv cF cfv vz cv cF cfv cH co cH co wceq va cv vy cv cF cfv cH co vz
        cv cF cfv cH co va cv vy cv cF cfv vz cv cF cfv cH co cH co wceq vx vy
        vx cA va cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4
        ghgrpi.5 ghgrpi.6 ghgrpi.7 vx cv cX wcel vy cv cX wcel vz cv cX wcel vx
        cv cF cfv vy cv cF cfv cH co vz cv cF cfv cH co vx cv cF cfv vy cv cF
        cfv vz cv cF cfv cH co cH co wceq vx cv cX wcel vy cv cX wcel vz cv cX
        wcel w3a vx cv vy cv cG co cF cfv vz cv cF cfv cH co vx cv cF cfv vy cv
        vz cv cG co cF cfv cH co vx cv cF cfv vy cv cF cfv cH co vz cv cF cfv
        cH co vx cv cF cfv vy cv cF cfv vz cv cF cfv cH co cH co vx cv cX wcel
        vy cv cX wcel vz cv cX wcel w3a vx cv vy cv cG co vz cv cG co cF cfv vx
        cv vy cv vz cv cG co cG co cF cfv vx cv vy cv cG co cF cfv vz cv cF cfv
        cH co vx cv cF cfv vy cv vz cv cG co cF cfv cH co vx cv cX wcel vy cv
        cX wcel vz cv cX wcel w3a vx cv vy cv cG co vz cv cG co vx cv vy cv vz
        cv cG co cG co cF cG cgr wcel vx cv cX wcel vy cv cX wcel vz cv cX wcel
        w3a vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
        ghgrpi.1 vx cv vy cv vz cv cG cX ghgrpi.2 grpass mpan fveq2d vx cv cX
        wcel vy cv cX wcel vz cv cX wcel vx cv vy cv cG co vz cv cG co cF cfv
        vx cv vy cv cG co cF cfv vz cv cF cfv cH co wceq vx cv vy cv cG co cX
        wcel vz cv cX wcel vx cv vy cv cG co vz cv cG co cF cfv vx cv vy cv cG
        co cF cfv vz cv cF cfv cH co wceq vx cv cX wcel vy cv cX wcel wa vx vy
        cA vx cv vy cv cG co vz cv cF cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3
        ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 ghgrpilem1 cG cgr wcel vx cv cX
        wcel vy cv cX wcel vx cv vy cv cG co cX wcel ghgrpi.1 vx cv vy cv cG cX
        ghgrpi.2 grpcl mp3an1 sylan 3impa vx cv cX wcel vy cv cX wcel vz cv cX
        wcel vx cv vy cv vz cv cG co cG co cF cfv vx cv cF cfv vy cv vz cv cG
        co cF cfv cH co wceq vx cv cX wcel vy cv vz cv cG co cX wcel vx cv vy
        cv vz cv cG co cG co cF cfv vx cv cF cfv vy cv vz cv cG co cF cfv cH co
        wceq vy cv cX wcel vz cv cX wcel wa vx vy cA vx cv vy cv vz cv cG co cF
        cG cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6
        ghgrpi.7 ghgrpilem1 cG cgr wcel vy cv cX wcel vz cv cX wcel vy cv vz cv
        cG co cX wcel ghgrpi.1 vy cv vz cv cG cX ghgrpi.2 grpcl mp3an1 sylan2
        3impb 3eqtr3d vx cv cX wcel vy cv cX wcel vz cv cX wcel w3a vx cv vy cv
        cG co cF cfv vx cv cF cfv vy cv cF cfv cH co vz cv cF cfv cH vx cv cX
        wcel vy cv cX wcel vx cv vy cv cG co cF cfv vx cv cF cfv vy cv cF cfv
        cH co wceq vz cv cX wcel vx vy cA vx cv vy cv cF cG cH cO cX cY
        ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7
        ghgrpilem1 3adant3 opreq1d vx cv cX wcel vy cv cX wcel vz cv cX wcel
        w3a vy cv vz cv cG co cF cfv vy cv cF cfv vz cv cF cfv cH co vx cv cF
        cfv cH vy cv cX wcel vz cv cX wcel vy cv vz cv cG co cF cfv vy cv cF
        cfv vz cv cF cfv cH co wceq vx cv cX wcel vx vy cA vy cv vz cv cF cG cH
        cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7
        ghgrpilem1 3adant1 opreq2d 3eqtr3d 3expb vx cv cF cfv va cv wceq vx cv
        cF cfv vy cv cF cfv cH co vz cv cF cfv cH co va cv vy cv cF cfv cH co
        vz cv cF cfv cH co vx cv cF cfv vy cv cF cfv vz cv cF cfv cH co cH co
        va cv vy cv cF cfv vz cv cF cfv cH co cH co vx cv cF cfv va cv wceq vx
        cv cF cfv vy cv cF cfv cH co va cv vy cv cF cfv cH co vz cv cF cfv cH
        vx cv cF cfv va cv vy cv cF cfv cH opreq1 opreq1d vx cv cF cfv va cv vy
        cv cF cfv vz cv cF cfv cH co cH opreq1 eqeq12d ghgrpilem2 anasss vy cv
        cF cfv vb cv wceq va cv vy cv cF cfv cH co vz cv cF cfv cH co va cv vb
        cv cH co vz cv cF cfv cH co va cv vy cv cF cfv vz cv cF cfv cH co cH co
        va cv vb cv vz cv cF cfv cH co cH co vy cv cF cfv vb cv wceq va cv vy
        cv cF cfv cH co va cv vb cv cH co vz cv cF cfv cH vy cv cF cfv vb cv va
        cv cH opreq2 opreq1d vy cv cF cfv vb cv wceq vy cv cF cfv vz cv cF cfv
        cH co vb cv vz cv cF cfv cH co va cv cH vy cv cF cfv vb cv vz cv cF cfv
        cH opreq1 opreq2d eqeq12d ghgrpilem2 anasss vz cv cF cfv vc cv wceq va
        cv vb cv cH co vz cv cF cfv cH co va cv vb cv cH co vc cv cH co va cv
        vb cv vz cv cF cfv cH co cH co va cv vb cv vc cv cH co cH co vz cv cF
        cfv vc cv va cv vb cv cH co cH opreq2 vz cv cF cfv vc cv wceq vb cv vz
        cv cF cfv cH co vb cv vc cv cH co va cv cH vz cv cF cfv vc cv vb cv cH
        opreq2 opreq2d eqeq12d ghgrpilem2 3impa va cv cY wcel vb cv cY wcel wa
        vc cv va cv cH co vb cv wceq vc cY wrex va cv vc cv cH co vb cv wceq vc
        cY wrex vx vy cA cD cU cF cG cH cN cO cX cY va vb vc ghgrpi.1 ghgrpi.2
        ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 ghgrpilem3.8 ghgrpilem3.9
        ghgrpilem3.10 ghgrpilem3 pm3.26d va cv cY wcel vb cv cY wcel wa vc cv
        va cv cH co vb cv wceq vc cY wrex va cv vc cv cH co vb cv wceq vc cY
        wrex vx vy cA cD cU cF cG cH cN cO cX cY va vb vc ghgrpi.1 ghgrpi.2
        ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 ghgrpilem3.8 ghgrpilem3.9
        ghgrpilem3.10 ghgrpilem3 pm3.27d isgrp2i $.
        $( [26-Apr-2008] $) $( [25-Apr-2008] $)
    $}

    $( The image of a group ` G ` under a group homomorphism ` F ` is a group,
       and furthermore is Abelian if ` G ` is Abelian.  This is a stronger
       result than that usually found in the literature, since the target of
       the homomorphism (operator ` O ` in our model) need not have any of the
       properties of a group as a prerequisite.  (Contributed by Paul Chapman,
       25-Apr-2008.) $)
    ghgrpi $p |- ( H e. Grp /\ ( G e. Abel -> H e. Abel ) ) $=
      cH cgr wcel cG cabl wcel cH cabl wcel wi vx vy cA cG cgs cfv cG cgi cfv
      cF cG cH cG cgn cfv cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5
      ghgrpi.6 ghgrpi.7 cG cgi cfv eqid cG cgn cfv eqid cG cgs cfv eqid
      ghgrpilem4 cH cgr wcel va cv vb cv cH co vb cv va cv cH co wceq vb cY
      wral va cY wral cH cabl wcel cG cabl wcel cH cabl wcel cH cgr wcel va cv
      vb cv cH co vb cv va cv cH co wceq vb cY wral va cY wral wa va vb cH cY
      cO cdm cA cA cxp wceq cH cgr wcel cY cA wss cY cH crn wceq cO cA cA cxp
      wfn cO cdm cA cA cxp wceq ghgrpi.5 cA cA cxp cO fndm ax-mp vx vy cA cG
      cgs cfv cG cgi cfv cF cG cH cG cgn cfv cO cX cY ghgrpi.1 ghgrpi.2
      ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 cG cgi cfv eqid cG cgn cfv
      eqid cG cgs cfv eqid ghgrpilem4 ghgrpi.4 cO cH cA cY ghgrpi.7 resgrprn
      mp3an isabl biimpri vx vy cA cG cgs cfv cG cgi cfv cF cG cH cG cgn cfv cO
      cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 cG
      cgi cfv eqid cG cgn cfv eqid cG cgs cfv eqid ghgrpilem4 cG cabl wcel va
      cv vb cv cH co vb cv va cv cH co wceq va vb cY cY cG cabl wcel va cv cY
      wcel vb cv cY wcel va cv vb cv cH co vb cv va cv cH co wceq cG cabl wcel
      va cv cY wcel vb cv cY wcel va cv vb cv cH co vb cv va cv cH co wceq cG
      cabl wcel va cv cY wcel wa va cv vy cv cF cfv cH co vy cv cF cfv va cv cH
      co wceq va cv vb cv cH co vb cv va cv cH co wceq vx vy vy cA vb cv cF cG
      cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6
      ghgrpi.7 vy cv cX wcel cG cabl wcel va cv cY wcel va cv vy cv cF cfv cH
      co vy cv cF cfv va cv cH co wceq vy cv cX wcel cG cabl wcel wa vx cv cF
      cfv vy cv cF cfv cH co vy cv cF cfv vx cv cF cfv cH co wceq va cv vy cv
      cF cfv cH co vy cv cF cfv va cv cH co wceq vx vy vx cA va cv cF cG cH cO
      cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 vx
      cv cX wcel vy cv cX wcel cG cabl wcel vx cv cF cfv vy cv cF cfv cH co vy
      cv cF cfv vx cv cF cfv cH co wceq cG cabl wcel vx cv cX wcel vy cv cX
      wcel vx cv cF cfv vy cv cF cfv cH co vy cv cF cfv vx cv cF cfv cH co wceq
      cG cabl wcel vx cv cX wcel vy cv cX wcel w3a vx cv vy cv cG co cF cfv vy
      cv vx cv cG co cF cfv vx cv cF cfv vy cv cF cfv cH co vy cv cF cfv vx cv
      cF cfv cH co cG cabl wcel vx cv cX wcel vy cv cX wcel w3a vx cv vy cv cG
      co vy cv vx cv cG co cF vx cv vy cv cG cX ghgrpi.2 ablcom fveq2d vx cv cX
      wcel vy cv cX wcel vx cv vy cv cG co cF cfv vx cv cF cfv vy cv cF cfv cH
      co wceq cG cabl wcel vx vy cA vx cv vy cv cF cG cH cO cX cY ghgrpi.1
      ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6 ghgrpi.7 ghgrpilem1 3adant1
      vx cv cX wcel vy cv cX wcel vy cv vx cv cG co cF cfv vy cv cF cfv vx cv
      cF cfv cH co wceq cG cabl wcel vy cv cX wcel vx cv cX wcel vy cv vx cv cG
      co cF cfv vy cv cF cfv vx cv cF cfv cH co wceq vx vy cA vy cv vx cv cF cG
      cH cO cX cY ghgrpi.1 ghgrpi.2 ghgrpi.3 ghgrpi.4 ghgrpi.5 ghgrpi.6
      ghgrpi.7 ghgrpilem1 ancoms 3adant1 3eqtr3d 3coml 3expb vx cv cF cfv va cv
      wceq vx cv cF cfv vy cv cF cfv cH co va cv vy cv cF cfv cH co vy cv cF
      cfv vx cv cF cfv cH co vy cv cF cfv va cv cH co vx cv cF cfv va cv vy cv
      cF cfv cH opreq1 vx cv cF cfv va cv vy cv cF cfv cH opreq2 eqeq12d
      ghgrpilem2 anasss vy cv cF cfv vb cv wceq va cv vy cv cF cfv cH co va cv
      vb cv cH co vy cv cF cfv va cv cH co vb cv va cv cH co vy cv cF cfv vb cv
      va cv cH opreq2 vy cv cF cfv vb cv va cv cH opreq1 eqeq12d ghgrpilem2
      3impa 3expib r19.21aivv sylancr pm3.2i $.
      $( [26-Apr-2008] $) $( [25-Apr-2008] $)
  $}

  ${
    $d F x y $.  $d H x y $.  $d O x y $.  $d S x y $.  $d W x y $.
    $d Z x y $.
    ghsubgi.1 $e |- S e. ( SubGrp ` G ) $.
    ghsubgi.2 $e |- X = ran G $.
    ghsubgi.3 $e |- F : X --> Y $.
    ghsubgi.4 $e |- Y C_ A $.
    ghsubgi.5 $e |- O Fn ( A X. A ) $.
    ghsubgi.6 $e |- ( ( x e. X /\ y e. X ) ->
                      ( F ` ( x G y ) ) = ( ( F ` x ) O ( F ` y ) ) ) $.
    ghsubgi.7 $e |- Z = ran S $.
    ghsubgi.8 $e |- W = ( F " Z ) $.
    ghsubgi.9 $e |- H = ( O |` ( W X. W ) ) $.

    $( The image of a subgroup ` S ` of group ` G ` under a group homomorphism
       ` F ` on ` G ` is a group, and furthermore is Abelian if ` S ` is
       Abelian.  (Contributed by Paul Chapman, 25-Apr-2008.) $)
    ghsubgi $p |- ( H e. Grp /\ ( S e. Abel -> H e. Abel ) ) $=
      vx vy cA cF cZ cres cS cH cO cZ cW cG cgr wcel cS cgr wcel cS cG wss cS
      cG csubg cfv wcel cG cgr wcel cS cgr wcel cS cG wss w3a ghsubgi.1 cG cS
      issubg mpbi 3simp2i ghsubgi.7 cZ cW cF cZ cres wfo cZ cF cZ cima cF cZ
      cres wfo cF wfun cZ cF cdm wss cZ cF cZ cima cF cZ cres wfo cX cY cF wf
      cF wfun ghsubgi.3 cX cY cF ffun ax-mp cZ cX cF cdm cS cG csubg cfv wcel
      cZ cX wss ghsubgi.1 cG cS cZ cX ghsubgi.2 ghsubgi.7 subgrnss ax-mp cX cY
      cF ghsubgi.3 fdmi sseqtr4i cZ cF fores mp2an cW cF cZ cima wceq cZ cW cF
      cZ cres wfo cZ cF cZ cima cF cZ cres wfo wb ghsubgi.8 cW cF cZ cima cZ cF
      cZ cres foeq3 ax-mp mpbir cW cY cA cW cF cZ cima cY ghsubgi.8 cF cZ cima
      cF cZ cres crn cY cF cZ df-ima cX cY cF wf cZ cX wss cF cZ cres crn cY
      wss ghsubgi.3 cS cG csubg cfv wcel cZ cX wss ghsubgi.1 cG cS cZ cX
      ghsubgi.2 ghsubgi.7 subgrnss ax-mp cX cY cF wf cZ cX wss wa cZ cY cF cZ
      cres wf cF cZ cres crn cY wss cX cY cZ cF fssres cZ cY cF cZ cres frn syl
      mp2an eqsstri eqsstri ghsubgi.4 sstri ghsubgi.5 vx cv cZ wcel vy cv cZ
      wcel wa vx cv vy cv cS co cF cZ cres cfv vx cv cF cfv vy cv cF cfv cO co
      vx cv cF cZ cres cfv vy cv cF cZ cres cfv cO co vx cv cZ wcel vy cv cZ
      wcel wa vx cv vy cv cS co cF cZ cres cfv vx cv vy cv cS co cF cfv vx cv
      vy cv cG co cF cfv vx cv cF cfv vy cv cF cfv cO co vx cv cZ wcel vy cv cZ
      wcel wa vx cv vy cv cS co cZ wcel vx cv vy cv cS co cF cZ cres cfv vx cv
      vy cv cS co cF cfv wceq cS cgr wcel vx cv cZ wcel vy cv cZ wcel vx cv vy
      cv cS co cZ wcel cG cgr wcel cS cgr wcel cS cG wss cS cG csubg cfv wcel
      cG cgr wcel cS cgr wcel cS cG wss w3a ghsubgi.1 cG cS issubg mpbi 3simp2i
      vx cv vy cv cS cZ ghsubgi.7 grpcl mp3an1 vx cv vy cv cS co cZ cF fvres
      syl vx cv cZ wcel vy cv cZ wcel wa vx cv vy cv cS co vx cv vy cv cG co cF
      cS cG csubg cfv wcel vx cv cZ wcel vy cv cZ wcel wa vx cv vy cv cS co vx
      cv vy cv cG co wceq wi ghsubgi.1 vx cv vy cv cG cS cZ ghsubgi.7 subgopr
      ax-mp fveq2d vx cv cX wcel vy cv cX wcel vx cv vy cv cG co cF cfv vx cv
      cF cfv vy cv cF cfv cO co wceq vx cv cZ wcel vy cv cZ wcel ghsubgi.6 cZ
      cX vx cv cS cG csubg cfv wcel cZ cX wss ghsubgi.1 cG cS cZ cX ghsubgi.2
      ghsubgi.7 subgrnss ax-mp sseli cZ cX vy cv cS cG csubg cfv wcel cZ cX wss
      ghsubgi.1 cG cS cZ cX ghsubgi.2 ghsubgi.7 subgrnss ax-mp sseli syl2an
      3eqtrd vx cv cZ wcel vy cv cZ wcel vx cv cF cZ cres cfv vx cv cF cfv vy
      cv cF cZ cres cfv vy cv cF cfv cO vx cv cZ cF fvres vy cv cZ cF fvres
      opreqan12d eqtr4d ghsubgi.9 ghgrpi $.
      $( [26-Apr-2008] $) $( [25-Apr-2008] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Group actions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpAct $.
  $( Extend class definition to include the class of group actions. $)
  cga $a class GrpAct $.

  ${
    $d g m s x y z $.
    $( Define the class of all group actions. $)
    df-ga $a |- GrpAct = { <. g , m >. | ( g e. Grp /\ E. s ( m : ( ran g X. s
    ) --> s /\ A. x e. s ( ( ( Id ` g ) m x ) = x /\ A. y e. ran g A. z e. ran
    g ( ( y g z ) m x ) = ( y m ( z m x ) ) ) ) ) } $.
  $}

  ${
    $d g m s x y z G $. $d g m s x y z M $. $d g m U $. $d g m y z X $.
    isgalem.1 $e |- X = ran G $.
    isgalem.2 $e |- U = ( Id ` G ) $.
    $( Lemma for ~ isga . $)
    isgalem $p |- ( M e. A -> ( <. G , M >. e. GrpAct <-> ( G e. Grp /\ E. s (
    M : ( X X. s ) --> s /\ A. x e. s ( ( U M x ) = x /\ A. y e. X A. z e. X (
    ( y G z ) M x ) = ( y M ( z M x ) ) ) ) ) ) ) $=
      cM cA wcel cG cM cop cga wcel cG cgr wcel cX vs cv cxp vs cv cM wf cU vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex wa cG cvv
      wcel cM cA wcel wa cG cM cop cga wcel cM cA wcel cG cvv wcel cM cA wcel
      wa cG cM cop cga wcel cG cvv wcel cM cA wcel cG cM cop cga wcel cG cM cga
      wbr cG cvv wcel cG cM cga df-br cG cM cga cga wrel vg cv cgr wcel vg cv
      crn vs cv cxp vs cv vm cv wf vg cv cgi cfv vx cv vm cv co vx cv wceq vy
      cv vz cv vg cv co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq
      vz vg cv crn wral vy vg cv crn wral wa vx vs cv wral wa vs wex wa vg vm
      copab wrel vg cv cgr wcel vg cv crn vs cv cxp vs cv vm cv wf vg cv cgi
      cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx cv vm cv co vy cv
      vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy vg cv crn wral wa
      vx vs cv wral wa vs wex wa vg vm relopab cga vg cv cgr wcel vg cv crn vs
      cv cxp vs cv vm cv wf vg cv cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv
      vg cv co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv
      crn wral vy vg cv crn wral wa vx vs cv wral wa vs wex wa vg vm copab vx
      vy vz vg vm vs df-ga releqi mpbir brrelexi sylbir anim1i ancoms cG cgr
      wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co
      vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa
      vx vs cv wral wa vs wex wa cM cA wcel cG cvv wcel cM cA wcel wa cG cgr
      wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co
      vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa
      vx vs cv wral wa vs wex wa cG cvv wcel cM cA wcel cG cgr wcel cG cvv wcel
      cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx
      cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx
      vs cv wral wa vs wex cG cgr elisset adantr anim1i ancoms cG cvv wcel cM
      cA wcel wa cG cM cop vg cv cgr wcel vg cv crn vs cv cxp vs cv vm cv wf vg
      cv cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx cv vm cv co
      vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy vg cv crn
      wral wa vx vs cv wral wa vs wex wa vg vm copab wcel cG cgr wcel cX vs cv
      cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co
      vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs cv wral
      wa vs wex wa cG cM cop cga wcel vg cv cgr wcel vg cv crn vs cv cxp vs cv
      vm cv wf vg cv cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx
      cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy
      vg cv crn wral wa vx vs cv wral wa vs wex wa cG cgr wcel cX vs cv cxp vs
      cv vm cv wf cU vx cv vm cv co vx cv wceq vy cv vz cv cG co vx cv vm cv co
      vy cv vz cv vx cv vm cv co vm cv co wceq vz cX wral vy cX wral wa vx vs
      cv wral wa vs wex wa cG cgr wcel cX vs cv cxp vs cv cM wf cU vx cv cM co
      vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex wa vg vm cG cM cvv
      cA vg cv cG wceq vg cv cgr wcel cG cgr wcel vg cv crn vs cv cxp vs cv vm
      cv wf vg cv cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx cv
      vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy vg
      cv crn wral wa vx vs cv wral wa vs wex cX vs cv cxp vs cv vm cv wf cU vx
      cv vm cv co vx cv wceq vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx cv
      vm cv co vm cv co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex
      vg cv cG cgr eleq1 vg cv cG wceq vg cv crn vs cv cxp vs cv vm cv wf vg cv
      cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx cv vm cv co vy
      cv vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy vg cv crn wral
      wa vx vs cv wral wa cX vs cv cxp vs cv vm cv wf cU vx cv vm cv co vx cv
      wceq vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co
      wceq vz cX wral vy cX wral wa vx vs cv wral wa vs vg cv cG wceq vg cv crn
      vs cv cxp vs cv vm cv wf cX vs cv cxp vs cv vm cv wf vg cv cgi cfv vx cv
      vm cv co vx cv wceq vy cv vz cv vg cv co vx cv vm cv co vy cv vz cv vx cv
      vm cv co vm cv co wceq vz vg cv crn wral vy vg cv crn wral wa vx vs cv
      wral cU vx cv vm cv co vx cv wceq vy cv vz cv cG co vx cv vm cv co vy cv
      vz cv vx cv vm cv co vm cv co wceq vz cX wral vy cX wral wa vx vs cv wral
      vg cv cG wceq vg cv crn cX wceq vg cv crn vs cv cxp cX vs cv cxp wceq vg
      cv crn vs cv cxp vs cv vm cv wf cX vs cv cxp vs cv vm cv wf wb vg cv cG
      wceq vg cv crn cG crn cX vg cv cG rneq isgalem.1 syl6eqr vg cv crn cX vs
      cv xpeq1 vg cv crn vs cv cxp cX vs cv cxp vs cv vm cv feq2 3syl vg cv cG
      wceq vg cv cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx cv
      vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy vg
      cv crn wral wa cU vx cv vm cv co vx cv wceq vy cv vz cv cG co vx cv vm cv
      co vy cv vz cv vx cv vm cv co vm cv co wceq vz cX wral vy cX wral wa vx
      vs cv vg cv cG wceq vg cv cgi cfv vx cv vm cv co vx cv wceq cU vx cv vm
      cv co vx cv wceq vy cv vz cv vg cv co vx cv vm cv co vy cv vz cv vx cv vm
      cv co vm cv co wceq vz vg cv crn wral vy vg cv crn wral vy cv vz cv cG co
      vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz cX wral vy cX
      wral vg cv cG wceq vg cv cgi cfv vx cv vm cv co cU vx cv vm cv co vx cv
      vg cv cG wceq vg cv cgi cfv cU vx cv vm cv vg cv cG wceq vg cv cgi cfv cG
      cgi cfv cU vg cv cG cgi fveq2 isgalem.2 syl6eqr opreq1d eqeq1d vg cv cG
      wceq vy cv vz cv vg cv co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv
      co wceq vz vg cv crn wral vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx
      cv vm cv co vm cv co wceq vz cX wral vy vg cv crn cX vg cv cG wceq vg cv
      crn cG crn cX vg cv cG rneq isgalem.1 syl6eqr vg cv cG wceq vy cv vz cv
      vg cv co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vy cv vz
      cv cG co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv
      crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isgalem.1 syl6eqr
      vg cv cG wceq vy cv vz cv vg cv co vx cv vm cv co vy cv vz cv cG co vx cv
      vm cv co vy cv vz cv vx cv vm cv co vm cv co vg cv cG wceq vy cv vz cv vg
      cv co vy cv vz cv cG co vx cv vm cv vy cv vz cv vg cv cG opreq opreq1d
      eqeq1d raleq12d raleq12d anbi12d ralbidv anbi12d exbidv anbi12d vm cv cM
      wceq cX vs cv cxp vs cv vm cv wf cU vx cv vm cv co vx cv wceq vy cv vz cv
      cG co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz cX wral
      vy cX wral wa vx vs cv wral wa vs wex cX vs cv cxp vs cv cM wf cU vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex cG cgr wcel vm
      cv cM wceq cX vs cv cxp vs cv vm cv wf cU vx cv vm cv co vx cv wceq vy cv
      vz cv cG co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz cX
      wral vy cX wral wa vx vs cv wral wa cX vs cv cxp vs cv cM wf cU vx cv cM
      co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx vs cv wral wa vs vm cv cM wceq cX vs cv
      cxp vs cv vm cv wf cX vs cv cxp vs cv cM wf cU vx cv vm cv co vx cv wceq
      vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq
      vz cX wral vy cX wral wa vx vs cv wral cU vx cv cM co vx cv wceq vy cv vz
      cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx vs cv wral cX vs cv cxp vs cv vm cv cM feq1 vm cv cM wceq cU
      vx cv vm cv co vx cv wceq vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx
      cv vm cv co vm cv co wceq vz cX wral vy cX wral wa cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx vs cv vm cv cM wceq cU vx cv vm cv co vx cv wceq
      cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx
      cv vm cv co vm cv co wceq vz cX wral vy cX wral vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral vm cv cM
      wceq cU vx cv vm cv co cU vx cv cM co vx cv cU vx cv vm cv cM opreq
      eqeq1d vm cv cM wceq vy cv vz cv cG co vx cv vm cv co vy cv vz cv vx cv
      vm cv co vm cv co wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vy vz cX cX vm cv cM wceq vy cv vz cv cG co vx cv vm cv co
      vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv vm cv co vm cv co vy cv
      vz cv vx cv cM co cM co vy cv vz cv cG co vx cv vm cv cM opreq vm cv cM
      wceq vy cv vz cv vx cv vm cv co vm cv co vy cv vz cv vx cv vm cv co cM co
      vy cv vz cv vx cv cM co cM co vy cv vz cv vx cv vm cv co vm cv cM opreq
      vm cv cM wceq vz cv vx cv vm cv co vz cv vx cv cM co vy cv cM vz cv vx cv
      vm cv cM opreq opreq2d eqtrd eqeq12d 2ralbidv anbi12d ralbidv anbi12d
      exbidv anbi2d opelopabg cga vg cv cgr wcel vg cv crn vs cv cxp vs cv vm
      cv wf vg cv cgi cfv vx cv vm cv co vx cv wceq vy cv vz cv vg cv co vx cv
      vm cv co vy cv vz cv vx cv vm cv co vm cv co wceq vz vg cv crn wral vy vg
      cv crn wral wa vx vs cv wral wa vs wex wa vg vm copab cG cM cop vx vy vz
      vg vm vs df-ga eleq2i syl5bb pm5.21nd $.
      $( [17-May-2010] $) $( [10-Aug-2009] $)
  $}

  ${
    $d s A $. $d s x y z G $. $d s x y z M $. $d s U $. $d s y z X $. $d s x Y
    $.
    isga.1 $e |- X = ran G $.
    isga.2 $e |- Y = ran dom M $.
    isga.3 $e |- U = ( Id ` G ) $.
    $( The predicate "is a (left) group action."  The group ` G ` is said to
       act on the base set ` Y ` of the action, which is not assumed to have
       any special properties.  There is a related notion of right group
       action, but as the Wikipedia article explains, it is not mathematically
       interesting.  The way actions are usually thought of is that each
       element ` g ` of ` G ` is a permutation of the elements of ` Y ` (see
       ~ gapm ). Since group theory was classically about symmetry groups, it
       is therefore likely that the notion of group action was useful even in
       early group theory.  (Contributed by Jeff Hankins, 10-Aug-2009.)  $)
    isga $p |- ( M e. A -> ( <. G , M >. e. GrpAct <-> ( G e. Grp /\ M : ( X X.
    Y ) --> Y /\ A. x e. Y ( ( U M x ) = x /\ A. y e. X A. z e. X ( ( y G z ) M
    x ) = ( y M ( z M x ) ) ) ) ) ) $=
      cM cA wcel cG cM cop cga wcel cG cgr wcel cX vs cv cxp vs cv cM wf cU vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex wa cG cgr
      wcel cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY
      wral w3a vx vy vz cA cU cG cM cX vs isga.1 isga.3 isgalem cM cA wcel cG
      cgr wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv
      cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx vs cv wral wa vs wex wa cG cgr wcel cX cY cxp cY cM wf cU vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx cY wral w3a cG cgr wcel cX vs cv
      cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co
      vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs cv wral
      wa vs wex wa cM cA wcel cG cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx
      cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq
      vz cX wral vy cX wral wa vx cY wral w3a cX vs cv cxp vs cv cM wf cU vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex cG cgr wcel cM
      cA wcel cG cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz
      cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx cY wral w3a wi cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx vs cv wral wa cG cgr wcel cM cA wcel cG cgr wcel
      cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM
      co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral
      w3a wi wi vs cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz
      cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx vs cv wral wa cG cgr wcel cM cA wcel cG cgr wcel cX cY cxp cY
      cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral w3a cX vs cv
      cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co
      vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs cv wral
      wa cG cgr wcel cM cA wcel w3a vs cv cY wceq cG cgr wcel cX cY cxp cY cM
      wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx
      cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral w3a cX vs cv cxp
      vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv
      vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa cG
      cgr wcel cM cA wcel w3a vs cv cM cdm crn cY cX vs cv cxp vs cv cM wf cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa cG cgr wcel cM cA
      wcel w3a cM cdm crn cX vs cv cxp crn vs cv cX vs cv cxp vs cv cM wf cU vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa cG cgr wcel cM cA
      wcel w3a cM cdm cX vs cv cxp cX vs cv cxp vs cv cM wf cU vx cv cM co vx
      cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq
      vz cX wral vy cX wral wa vx vs cv wral wa cG cgr wcel cM cdm cX vs cv cxp
      wceq cM cA wcel cX vs cv cxp vs cv cM wf cM cdm cX vs cv cxp wceq cU vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx vs cv wral cX vs cv cxp vs cv cM
      fdm adantr 3ad2ant1 rneqd cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx vs cv wral wa cG cgr wcel cM cA wcel w3a cX c0
      wne cX vs cv cxp crn vs cv wceq cG cgr wcel cX vs cv cxp vs cv cM wf cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa cX c0 wne cM cA
      wcel cG cX isga.1 grpn0 3ad2ant2 cX vs cv rnxp syl eqtr2d isga.2 syl6eqr
      cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx
      cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx
      vs cv wral wa cG cgr wcel vs cv cY wceq cG cgr wcel cX cY cxp cY cM wf cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cX wral vy cX wral wa vx cY wral w3a wi cM cA wcel cG
      cgr wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv
      cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx vs cv wral wa vs cv cY wceq cG cgr wcel cX cY cxp cY cM wf cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cX wral vy cX wral wa vx cY wral w3a wi cG cgr wcel cX
      vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs
      cv wral vs cv cY wceq cG cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx cY wral w3a wi vs cv cY wceq cG cgr wcel cX vs
      cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM
      co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs cv
      wral w3a cG cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv
      vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy
      cX wral wa vx cY wral w3a vs cv cY wceq cX vs cv cxp vs cv cM wf cX cY
      cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy
      cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs cv wral cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cX wral vy cX wral wa vx cY wral cG cgr wcel cX vs cv
      cxp cX cY cxp wceq vs cv cY wceq cX vs cv cxp vs cv cM wf cX cY cxp cY cM
      wf wb vs cv cY cX xpeq2 cX vs cv cxp vs cv cX cY cxp cY cM feq23 mpancom
      cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv
      cM co cM co wceq vz cX wral vy cX wral wa vx vs cv cY raleq1 3anbi23d
      biimpcd 3expb ancoms 3adant3 mpd 3exp 19.23aiv impcom com12 cG cgr wcel
      cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM
      co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral
      w3a cM cA wcel cG cgr wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx vs cv wral wa vs wex wa cG cgr wcel cX cY cxp cY
      cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral cM cA wcel cG
      cgr wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv
      cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx vs cv wral wa vs wex wa wi cM cA wcel cG cgr wcel cX cY cxp cY
      cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral wa wa cG cgr
      wcel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co
      vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa
      vx vs cv wral wa vs wex wa cM cA wcel cX cY cxp cY cM wf cU vx cv cM co
      vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx cY wral wa cX vs cv cxp vs cv cM wf cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex cG cgr
      wcel cM cA wcel cM cdm cvv wcel cY cvv wcel cX cY cxp cY cM wf cU vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cX wral vy cX wral wa vx cY wral wa cX vs cv cxp vs cv cM wf
      cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv
      cM co cM co wceq vz cX wral vy cX wral wa vx vs cv wral wa vs wex wi cM
      cA dmexg cM cdm cvv wcel cM cdm crn cvv cY cM cdm cvv rnexg isga.2
      syl5eqel cX vs cv cxp vs cv cM wf cU vx cv cM co vx cv wceq vy cv vz cv
      cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx vs cv wral wa cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy
      cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral
      vy cX wral wa vx cY wral wa vs cY cvv vs cv cY wceq cX vs cv cxp vs cv cM
      wf cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx vs
      cv wral cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz
      cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral cX vs cv
      cxp cX cY cxp wceq vs cv cY wceq cX vs cv cxp vs cv cM wf cX cY cxp cY cM
      wf wb vs cv cY cX xpeq2 cX vs cv cxp vs cv cX cY cxp cY cM feq23 mpancom
      cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv
      cM co cM co wceq vz cX wral vy cX wral wa vx vs cv cY raleq1 anbi12d
      cla4egv 3syl anim2d com12 3impb com12 impbid bitrd $.
      $( [17-May-2010] $) $( [10-Aug-2009] $)
  $}

  ${
    $d x y z G $. $d x y z M $. $d x y z X $. $d x Y $.
    gafo.1 $e |- X = ran G $.
    gafo.2 $e |- Y = ran dom M $.
    $( A group action is onto its base set.  (Contributed by Jeff Hankins,
       10-Aug-2009.) $)
    gafo $p |- ( ( M e. A /\ <. G , M >. e. GrpAct ) -> M : ( X X. Y ) -onto->
    Y ) $=
      cM cA wcel cG cM cop cga wcel wa cM cX cY cxp wfn cM crn cY wceq wa cX cY
      cxp cY cM wfo cM cA wcel cG cM cop cga wcel wa cG cgr wcel cX cY cxp cY
      cM wf cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy
      cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral w3a
      cM cX cY cxp wfn cM crn cY wceq wa cM cA wcel cG cM cop cga wcel cG cgr
      wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG
      co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral
      wa vx cY wral w3a vx vy vz cA cG cgi cfv cG cM cX cY gafo.1 gafo.2 cG cgi
      cfv eqid isga biimpa cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM
      co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx cY wral w3a cM cX cY cxp wfn cM crn cY
      wceq cX cY cxp cY cM wf cG cgr wcel cM cX cY cxp wfn cG cgi cfv vx cv cM
      co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx cY wral cX cY cxp cY cM ffn 3ad2ant2 cG
      cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv
      cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx cY wral w3a cM crn cY cX cY cxp cY cM wf cG cgr wcel cM crn cY
      wss cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv
      vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral cX cY
      cxp cY cM frn 3ad2ant2 cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM
      co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx cY wral w3a vx cv cY wcel vx cv cM crn
      wcel wi vx wal cY cM crn wss cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx cY wral w3a vx cv cY wcel vx cv cM
      crn wcel wi vx cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx
      cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq
      vz cX wral vy cX wral wa vx cY wral vx cG cgr wcel vx ax-17 cX cY cxp cY
      cM wf vx ax-17 cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY
      hbra1 hb3an cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx cY wral vx cv cY wcel vx cv cM crn wcel wi cG
      cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral vx cv cY wcel
      cG cgr wcel cX cY cxp cY cM wf vx cv cM crn wcel cG cgi cfv vx cv cM co
      vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx cY wral vx cv cY wcel cG cgi cfv vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cX wral vy cX wral wa cG cgr wcel cX cY cxp cY cM wf vx cv cM
      crn wcel wi wi cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY
      ra4 vx cv cY wcel cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx
      cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa cG
      cgr wcel cX cY cxp cY cM wf vx cv cM crn wcel vx cv cY wcel cG cgi cfv vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa cG cgr wcel w3a cX cY cxp cY cM wf wa
      cG cgi cfv vx cv cM co vx cv cM crn vx cv cY wcel cG cgi cfv vx cv cM co
      vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa cG cgr wcel w3a cG cgi cfv vx cv cM co vx
      cv wceq cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv
      cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX
      wral wa vx cv cY wcel cG cgi cfv vx cv cM co vx cv wceq cG cgr wcel cG
      cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co wceq vz cX wral vy cX wral pm3.26 3ad2ant2 adantr cM cX
      cY cxp wfn cG cgi cfv cX wcel vx cv cY wcel cG cgi cfv vx cv cM co cM crn
      wcel vx cv cY wcel cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx
      cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa cG
      cgr wcel w3a cX cY cxp cY cM wf wa cX cY cG cgi cfv vx cv cM fnoprvrn cX
      cY cxp cY cM wf cM cX cY cxp wfn vx cv cY wcel cG cgi cfv vx cv cM co vx
      cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq
      vz cX wral vy cX wral wa cG cgr wcel w3a cX cY cxp cY cM ffn adantl vx cv
      cY wcel cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co
      vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa cG cgr wcel
      w3a cG cgi cfv cX wcel cX cY cxp cY cM wf cG cgr wcel vx cv cY wcel cG
      cgi cfv cX wcel cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa cG cgi
      cfv cG cX gafo.1 cG cgi cfv eqid grpidcl 3ad2ant3 adantr vx cv cY wcel cG
      cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co wceq vz cX wral vy cX wral wa cG cgr wcel cX cY cxp cY
      cM wf 3simpl1 syl3anc eqeltrrd 3exp1 sylcom com4t 3imp 19.21ai vx cY cM
      crn dfss2 sylibr eqssd jca syl cX cY cxp cY cM df-fo sylibr $.
      $( [17-May-2010] $) $( [10-Aug-2009] $)
  $}

  ${
    $d x y z G $. $d x y z M $. $d y z X $. $d x Y $.
    isga2.1 $e |- X = ran G $.
    isga2.2 $e |- Y = ran M $.
    isga2.3 $e |- U = ( Id ` G ) $.
    $( An equivalent form of ~ isga .  (Contributed by Jeff Hankins,
       10-Aug-2009.) $)
    isga2 $p |- ( M e. A -> ( <. G , M >. e. GrpAct <-> ( G e. Grp /\ M : ( X
    X. Y ) --> Y /\ A. x e. Y ( ( U M x ) = x /\ A. y e. X A. z e. X ( ( y G z
    ) M x ) = ( y M ( z M x ) ) ) ) ) ) $=
      cM cA wcel cG cM cop cga wcel cG cgr wcel cX cY cxp cY cM wf cU vx cv cM
      co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq vz cX wral vy cX wral wa vx cY wral w3a cM cA wcel cY cM cdm crn
      wceq wa cM cA wcel cG cM cop cga wcel wa cM cA wcel cY cM cdm crn wceq cM
      cA wcel cG cM cop cga wcel pm3.26 cM cA wcel cG cM cop cga wcel wa cX cM
      cdm crn cxp cM cdm crn cM wfo cY cM cdm crn wceq cA cG cM cX cM cdm crn
      isga2.1 cM cdm crn eqid gafo cX cM cdm crn cxp cM cdm crn cM wfo cM crn
      cM cdm crn cY cX cM cdm crn cxp cM cdm crn cM forn isga2.2 syl5eq syl jca
      cG cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG
      co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral
      wa vx cY wral w3a cY cM cdm crn wceq cM cA wcel cG cgr wcel cX cY cxp cY
      cM wf cY cM cdm crn wceq cU vx cv cM co vx cv wceq vy cv vz cv cG co vx
      cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx
      cY wral cG cgr wcel cX cY cxp cY cM wf wa cM cdm crn cX cY cxp crn cY cX
      cY cxp cY cM wf cM cdm crn cX cY cxp crn wceq cG cgr wcel cX cY cxp cY cM
      wf cM cdm cX cY cxp cX cY cxp cY cM fdm rneqd adantl cG cgr wcel cX cY
      cxp crn cY wceq cX cY cxp cY cM wf cG cgr wcel cX c0 wne cX cY cxp crn cY
      wceq cG cX isga2.1 grpn0 cX cY rnxp syl adantr eqtr2d 3adant3 anim2i cM
      cA wcel cG cM cop cga wcel cG cgr wcel cX cM cdm crn cxp cM cdm crn cM wf
      cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv
      cM co cM co wceq vz cX wral vy cX wral wa vx cM cdm crn wral w3a cY cM
      cdm crn wceq cG cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy
      cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral
      vy cX wral wa vx cY wral w3a vx vy vz cA cU cG cM cX cM cdm crn isga2.1
      cM cdm crn eqid isga2.3 isga cG cgr wcel cX cM cdm crn cxp cM cdm crn cM
      wf cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx
      cv cM co cM co wceq vz cX wral vy cX wral wa vx cM cdm crn wral w3a cG
      cgr wcel cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG co
      vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa
      vx cY wral w3a wb cM cdm crn cY cM cdm crn cY wceq cX cM cdm crn cxp cM
      cdm crn cM wf cX cY cxp cY cM wf cU vx cv cM co vx cv wceq vy cv vz cv cG
      co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral
      wa vx cM cdm crn wral cU vx cv cM co vx cv wceq vy cv vz cv cG co vx cv
      cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY
      wral cG cgr wcel cX cM cdm crn cxp cX cY cxp wceq cM cdm crn cY wceq cX
      cM cdm crn cxp cM cdm crn cM wf cX cY cxp cY cM wf wb cM cdm crn cY cX
      xpeq2 cX cM cdm crn cxp cM cdm crn cX cY cxp cY cM feq23 mpancom cU vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cX wral vy cX wral wa vx cM cdm crn cY raleq1 3anbi23d eqcoms
      sylan9bb pm5.21nd $.
      $( [17-May-2010] $) $( [10-Aug-2009] $)
  $}

  ${
    $d x y z G $.
    $( The action of a group on the empty set.  (Contributed by Jeff Hankins,
       11-Aug-2009.) $)
    ga0 $p |- ( G e. Grp -> <. G , (/) >. e. GrpAct ) $=
      cG cgr wcel cG cgr wcel cG crn c0 cxp c0 c0 wf cG cgi cfv vx cv c0 co vx
      cv wceq vy cv vz cv cG co vx cv c0 co vy cv vz cv vx cv c0 co c0 co wceq
      vz cG crn wral vy cG crn wral wa vx c0 wral w3a cG c0 cop cga wcel cG cgr
      wcel cG cgr wcel cG crn c0 cxp c0 c0 wf cG cgi cfv vx cv c0 co vx cv wceq
      vy cv vz cv cG co vx cv c0 co vy cv vz cv vx cv c0 co c0 co wceq vz cG
      crn wral vy cG crn wral wa vx c0 wral cG cgr wcel id cG crn c0 cxp c0 c0
      wf cG cgr wcel cG crn c0 cxp c0 c0 wf c0 c0 wceq cG crn c0 cxp c0 wceq cG
      crn c0 cxp c0 f00 c0 eqid cG crn xp0 mpbir2an a1i cG cgi cfv vx cv c0 co
      vx cv wceq vy cv vz cv cG co vx cv c0 co vy cv vz cv vx cv c0 co c0 co
      wceq vz cG crn wral vy cG crn wral wa vx c0 wral cG cgr wcel cG cgi cfv
      vx cv c0 co vx cv wceq vy cv vz cv cG co vx cv c0 co vy cv vz cv vx cv c0
      co c0 co wceq vz cG crn wral vy cG crn wral wa vx ral0 a1i 3jca c0 cvv
      wcel cG c0 cop cga wcel cG cgr wcel cG crn c0 cxp c0 c0 wf cG cgi cfv vx
      cv c0 co vx cv wceq vy cv vz cv cG co vx cv c0 co vy cv vz cv vx cv c0 co
      c0 co wceq vz cG crn wral vy cG crn wral wa vx c0 wral w3a wb 0ex vx vy
      vz cvv cG cgi cfv cG c0 cG crn c0 cG crn eqid c0 crn c0 rn0 eqcomi cG cgi
      cfv eqid isga2 ax-mp sylibr $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d x y z G $. $d x y z S $. $d x y z X $.
    gaid.1 $e |- X = ran G $.
    $( The trivial action of a group on any set. Each group element corresponds
       to the identity permutation.  (Contributed by Jeff Hankins,
       11-Aug-2009.) $)
    gaid $p |- ( ( G e. Grp /\ S e. A ) -> <. G , ( 2nd |` ( X X. S ) ) >. e.
    GrpAct ) $=
      cG cgr wcel cS cA wcel wa cG c2nd cX cS cxp cres cop cga wcel cG cgr wcel
      cX c2nd cX cS cxp cres crn cxp c2nd cX cS cxp cres crn c2nd cX cS cxp
      cres wf cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq vy cv vz cv cG
      co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX cS cxp cres co
      c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa vx c2nd cX cS cxp
      cres crn wral w3a cG cgr wcel cS cA wcel wa cG cgr wcel cX c2nd cX cS cxp
      cres crn cxp c2nd cX cS cxp cres crn c2nd cX cS cxp cres wf cG cgi cfv vx
      cv c2nd cX cS cxp cres co vx cv wceq vy cv vz cv cG co vx cv c2nd cX cS
      cxp cres co vy cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres
      co wceq vz cX wral vy cX wral wa vx c2nd cX cS cxp cres crn wral w3a cG
      cgr wcel cX cS cxp cS c2nd cX cS cxp cres wf cG cgi cfv vx cv c2nd cX cS
      cxp cres co vx cv wceq vy cv vz cv cG co vx cv c2nd cX cS cxp cres co vy
      cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres co wceq vz cX
      wral vy cX wral wa vx cS wral w3a cG cgr wcel cS cA wcel wa cG cgr wcel
      cX cS cxp cS c2nd cX cS cxp cres wf cG cgi cfv vx cv c2nd cX cS cxp cres
      co vx cv wceq vy cv vz cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv
      vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres co wceq vz cX wral vy cX
      wral wa vx cS wral cG cgr wcel cS cA wcel pm3.26 cX cS cxp cS c2nd cX cS
      cxp cres wf cG cgr wcel cS cA wcel wa cX cS f2ndres a1i cG cgr wcel cS cA
      wcel wa cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq vy cv vz cv cG
      co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX cS cxp cres co
      c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa vx cS cG cgr wcel cS
      cA wcel vx cv cS wcel cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq
      vy cv vz cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX
      cS cxp cres co c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa cG
      cgr wcel cS cA wcel vx cv cS wcel w3a cG cgi cfv vx cv c2nd cX cS cxp
      cres co vx cv wceq vy cv vz cv cG co vx cv c2nd cX cS cxp cres co vy cv
      vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres co wceq vz cX wral
      vy cX wral cG cgr wcel cS cA wcel vx cv cS wcel w3a cG cgi cfv vx cv c2nd
      cX cS cxp cres co cG cgi cfv vx cv cop c2nd cfv vx cv cG cgr wcel cS cA
      wcel vx cv cS wcel w3a cG cgi cfv vx cv cop c2nd cX cS cxp cres cfv cG
      cgi cfv vx cv cop c2nd cfv cG cgi cfv vx cv c2nd cX cS cxp cres co cG cgr
      wcel cS cA wcel vx cv cS wcel w3a cG cgi cfv vx cv cop cX cS cxp wcel cG
      cgi cfv vx cv cop c2nd cX cS cxp cres cfv cG cgi cfv vx cv cop c2nd cfv
      wceq cG cgi cfv cX wcel vx cv cS wcel cG cgi cfv vx cv cop cX cS cxp wcel
      cG cgr wcel cS cA wcel vx cv cS wcel w3a cG cgi cfv vx cv cX cS opelxpi
      cG cgr wcel cS cA wcel cG cgi cfv cX wcel vx cv cS wcel cG cgi cfv cG cX
      gaid.1 cG cgi cfv eqid grpidcl 3ad2ant1 cG cgr wcel cS cA wcel vx cv cS
      wcel 3simp3 sylanc cG cgi cfv vx cv cop cX cS cxp c2nd fvres syl cG cgi
      cfv vx cv c2nd cX cS cxp cres df-opr syl5eq cG cgi cfv vx cv cG cgi fvex
      vx visset op2nd syl6eq cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv vz
      cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX cS cxp
      cres co c2nd cX cS cxp cres co wceq vz cX wral vy cX cG cgr wcel cS cA
      wcel vx cv cS wcel w3a vy cv cX wcel vy cv vz cv cG co vx cv c2nd cX cS
      cxp cres co vy cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres
      co wceq vz cX cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz
      cv cX wcel vy cv vz cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv vx
      cv c2nd cX cS cxp cres co c2nd cX cS cxp cres co wceq cG cgr wcel cS cA
      wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel w3a vy cv vz cv cG co
      vx cv c2nd cX cS cxp cres co vy cv vz cv cG co vx cv cop c2nd cfv vy cv
      vz cv vx cv c2nd cX cS cxp cres co cop c2nd cfv vy cv vz cv vx cv c2nd cX
      cS cxp cres co c2nd cX cS cxp cres co cG cgr wcel cS cA wcel vx cv cS
      wcel w3a vy cv cX wcel vz cv cX wcel w3a vy cv vz cv cG co vx cv cop c2nd
      cX cS cxp cres cfv vy cv vz cv cG co vx cv cop c2nd cfv vy cv vz cv cG co
      vx cv c2nd cX cS cxp cres co cG cgr wcel cS cA wcel vx cv cS wcel w3a vy
      cv cX wcel vz cv cX wcel w3a vy cv vz cv cG co vx cv cop cX cS cxp wcel
      vy cv vz cv cG co vx cv cop c2nd cX cS cxp cres cfv vy cv vz cv cG co vx
      cv cop c2nd cfv wceq vy cv vz cv cG co cX wcel vx cv cS wcel vy cv vz cv
      cG co vx cv cop cX cS cxp wcel cG cgr wcel cS cA wcel vx cv cS wcel w3a
      vy cv cX wcel vz cv cX wcel w3a vy cv vz cv cG co vx cv cX cS opelxpi cG
      cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel vy cv
      vz cv cG co cX wcel cG cgr wcel cS cA wcel vy cv cX wcel vz cv cX wcel vy
      cv vz cv cG co cX wcel wi wi vx cv cS wcel cG cgr wcel vy cv cX wcel vz
      cv cX wcel vy cv vz cv cG co cX wcel vy cv vz cv cG cX gaid.1 grpcl 3exp
      3ad2ant1 3imp cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vx
      cv cS wcel vz cv cX wcel cG cgr wcel cS cA wcel vx cv cS wcel 3simp3
      3ad2ant1 sylanc vy cv vz cv cG co vx cv cop cX cS cxp c2nd fvres syl vy
      cv vz cv cG co vx cv c2nd cX cS cxp cres df-opr syl5eq cG cgr wcel cS cA
      wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel w3a vx cv vz cv vx cv
      c2nd cX cS cxp cres co vy cv vz cv cG co vx cv cop c2nd cfv vy cv vz cv
      vx cv c2nd cX cS cxp cres co cop c2nd cfv cG cgr wcel cS cA wcel vx cv cS
      wcel w3a vy cv cX wcel vz cv cX wcel w3a vx cv vz cv vx cv cop c2nd cX cS
      cxp cres cfv vz cv vx cv c2nd cX cS cxp cres co cG cgr wcel cS cA wcel vx
      cv cS wcel w3a vy cv cX wcel vz cv cX wcel w3a vz cv vx cv cop c2nd cX cS
      cxp cres cfv vz cv vx cv cop c2nd cfv vx cv cG cgr wcel cS cA wcel vx cv
      cS wcel w3a vy cv cX wcel vz cv cX wcel w3a vz cv vx cv cop cX cS cxp
      wcel vz cv vx cv cop c2nd cX cS cxp cres cfv vz cv vx cv cop c2nd cfv
      wceq vz cv cX wcel vx cv cS wcel vz cv vx cv cop cX cS cxp wcel cG cgr
      wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel w3a vz cv
      vx cv cX cS opelxpi cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX
      wcel vz cv cX wcel 3simp3 cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv
      cX wcel vx cv cS wcel vz cv cX wcel cG cgr wcel cS cA wcel vx cv cS wcel
      3simp3 3ad2ant1 sylanc vz cv vx cv cop cX cS cxp c2nd fvres syl vz cv vx
      cv vz visset vx visset op2nd syl6req vz cv vx cv c2nd cX cS cxp cres
      df-opr syl6eqr vy cv vz cv cG co vx cv vy cv vz cv cG oprex vx visset
      op2nd vy cv vz cv vx cv c2nd cX cS cxp cres co vy visset vz cv vx cv c2nd
      cX cS cxp cres oprex op2nd 3eqtr4g cG cgr wcel cS cA wcel vx cv cS wcel
      w3a vy cv cX wcel vz cv cX wcel w3a vy cv vz cv vx cv c2nd cX cS cxp cres
      co cop c2nd cX cS cxp cres cfv vy cv vz cv vx cv c2nd cX cS cxp cres co
      cop c2nd cfv vy cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres
      co cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel
      w3a vy cv vz cv vx cv c2nd cX cS cxp cres co cop cX cS cxp wcel vy cv vz
      cv vx cv c2nd cX cS cxp cres co cop c2nd cX cS cxp cres cfv vy cv vz cv
      vx cv c2nd cX cS cxp cres co cop c2nd cfv wceq vy cv cX wcel vz cv vx cv
      c2nd cX cS cxp cres co cS wcel vy cv vz cv vx cv c2nd cX cS cxp cres co
      cop cX cS cxp wcel cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel
      vz cv cX wcel w3a vy cv vz cv vx cv c2nd cX cS cxp cres co cX cS opelxpi
      cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel
      3simp2 cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX
      wcel w3a vz cv vx cv c2nd cX cS cxp cres co vz cv vx cv cop c2nd cfv cS
      cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel w3a
      vz cv vx cv cop c2nd cX cS cxp cres cfv vz cv vx cv cop c2nd cfv vz cv vx
      cv c2nd cX cS cxp cres co cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv
      cX wcel vz cv cX wcel w3a vz cv vx cv cop cX cS cxp wcel vz cv vx cv cop
      c2nd cX cS cxp cres cfv vz cv vx cv cop c2nd cfv wceq vz cv cX wcel vx cv
      cS wcel vz cv vx cv cop cX cS cxp wcel cG cgr wcel cS cA wcel vx cv cS
      wcel w3a vy cv cX wcel vz cv cX wcel w3a vz cv vx cv cX cS opelxpi cG cgr
      wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX wcel 3simp3 cG
      cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vx cv cS wcel vz cv
      cX wcel cG cgr wcel cS cA wcel vx cv cS wcel 3simp3 3ad2ant1 sylanc vz cv
      vx cv cop cX cS cxp c2nd fvres syl vz cv vx cv c2nd cX cS cxp cres df-opr
      syl5eq cG cgr wcel cS cA wcel vx cv cS wcel w3a vy cv cX wcel vz cv cX
      wcel w3a vx cv cS vz cv vx cv cop c2nd cfv cG cgr wcel cS cA wcel vx cv
      cS wcel w3a vy cv cX wcel vx cv cS wcel vz cv cX wcel cG cgr wcel cS cA
      wcel vx cv cS wcel 3simp3 3ad2ant1 vz cv vx cv vz visset vx visset op2nd
      syl5eqel eqeltrd sylanc vy cv vz cv vx cv c2nd cX cS cxp cres co cop cX
      cS cxp c2nd fvres syl vy cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS
      cxp cres df-opr syl5req 3eqtrd 3exp r19.21adv r19.21aiv jca 3expia
      r19.21aiv 3jca cG cgr wcel cS cA wcel wa c2nd cX cS cxp cres crn cS wceq
      cG cgr wcel cX c2nd cX cS cxp cres crn cxp c2nd cX cS cxp cres crn c2nd
      cX cS cxp cres wf cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq vy
      cv vz cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX cS
      cxp cres co c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa vx c2nd
      cX cS cxp cres crn wral w3a cG cgr wcel cX cS cxp cS c2nd cX cS cxp cres
      wf cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq vy cv vz cv cG co
      vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX cS cxp cres co
      c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa vx cS wral w3a wb cG
      cgr wcel c2nd cX cS cxp cres crn cS wceq cS cA wcel cG cgr wcel cX c0 wne
      cX cS cxp cS c2nd cX cS cxp cres wfo c2nd cX cS cxp cres crn cS wceq cG
      cX gaid.1 grpn0 cX cS fo2ndres cX cS cxp cS c2nd cX cS cxp cres forn 3syl
      adantr c2nd cX cS cxp cres crn cS wceq cX c2nd cX cS cxp cres crn cxp
      c2nd cX cS cxp cres crn c2nd cX cS cxp cres wf cX cS cxp cS c2nd cX cS
      cxp cres wf cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq vy cv vz
      cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX cS cxp
      cres co c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa vx c2nd cX
      cS cxp cres crn wral cG cgi cfv vx cv c2nd cX cS cxp cres co vx cv wceq
      vy cv vz cv cG co vx cv c2nd cX cS cxp cres co vy cv vz cv vx cv c2nd cX
      cS cxp cres co c2nd cX cS cxp cres co wceq vz cX wral vy cX wral wa vx cS
      wral cG cgr wcel cX c2nd cX cS cxp cres crn cxp cX cS cxp wceq c2nd cX cS
      cxp cres crn cS wceq cX c2nd cX cS cxp cres crn cxp c2nd cX cS cxp cres
      crn c2nd cX cS cxp cres wf cX cS cxp cS c2nd cX cS cxp cres wf wb c2nd cX
      cS cxp cres crn cS cX xpeq2 cX c2nd cX cS cxp cres crn cxp c2nd cX cS cxp
      cres crn cX cS cxp cS c2nd cX cS cxp cres feq23 mpancom cG cgi cfv vx cv
      c2nd cX cS cxp cres co vx cv wceq vy cv vz cv cG co vx cv c2nd cX cS cxp
      cres co vy cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres co
      wceq vz cX wral vy cX wral wa vx c2nd cX cS cxp cres crn cS raleq1
      3anbi23d syl mpbird cG cgr wcel cS cA wcel wa c2nd cX cS cxp cres cvv
      wcel cG c2nd cX cS cxp cres cop cga wcel cG cgr wcel cX c2nd cX cS cxp
      cres crn cxp c2nd cX cS cxp cres crn c2nd cX cS cxp cres wf cG cgi cfv vx
      cv c2nd cX cS cxp cres co vx cv wceq vy cv vz cv cG co vx cv c2nd cX cS
      cxp cres co vy cv vz cv vx cv c2nd cX cS cxp cres co c2nd cX cS cxp cres
      co wceq vz cX wral vy cX wral wa vx c2nd cX cS cxp cres crn wral w3a wb
      cX cS cxp cS c2nd cX cS cxp cres wf cX cS cxp cvv wcel c2nd cX cS cxp
      cres cvv wcel cG cgr wcel cS cA wcel wa cX cS cxp cS cvv c2nd cX cS cxp
      cres fex cX cS f2ndres cX cvv wcel cS cA wcel cX cS cxp cvv wcel cG cgr
      wcel cX cS cvv cA xpexg cG cgr wcel cG crn cvv cX cG cgr rnexg gaid.1
      syl5eqel sylan sylancr vx vy vz cvv cG cgi cfv cG c2nd cX cS cxp cres cX
      c2nd cX cS cxp cres crn gaid.1 c2nd cX cS cxp cres crn eqid cG cgi cfv
      eqid isga2 syl mpbird $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d x y z G $. $d x y z H $. $d x y z X $. $d x y z Y $.
    ssga.1 $e |- X = ran G $.
    ssga.2 $e |- Y = ran H $.
    $( A subgroup acts on its parent group.  (Contributed by Jeff Hankins,
       13-Aug-2009.) $)
    ssga $p |- ( H e. ( SubGrp ` G ) -> <. H , ( G |` ( Y X. X ) ) >. e. GrpAct
    ) $=
      cH cG csubg cfv wcel cH cG cY cX cxp cres cop cga wcel cH cgr wcel cY cG
      cY cX cxp cres crn cxp cG cY cX cxp cres crn cG cY cX cxp cres wf cH cgi
      cfv vx cv cG cY cX cxp cres co vx cv wceq vy cv vz cv cH co vx cv cG cY
      cX cxp cres co vy cv vz cv vx cv cG cY cX cxp cres co cG cY cX cxp cres
      co wceq vz cY wral vy cY wral wa vx cG cY cX cxp cres crn wral w3a cH cG
      csubg cfv wcel cH cgr wcel cY cG cY cX cxp cres crn cxp cG cY cX cxp cres
      crn cG cY cX cxp cres wf cH cgi cfv vx cv cG cY cX cxp cres co vx cv wceq
      vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv vz cv vx cv cG cY cX
      cxp cres co cG cY cX cxp cres co wceq vz cY wral vy cY wral wa vx cG cY
      cX cxp cres crn wral w3a cH cgr wcel cY cX cxp cX cG cY cX cxp cres wf cH
      cgi cfv vx cv cG cY cX cxp cres co vx cv wceq vy cv vz cv cH co vx cv cG
      cY cX cxp cres co vy cv vz cv vx cv cG cY cX cxp cres co cG cY cX cxp
      cres co wceq vz cY wral vy cY wral wa vx cX wral w3a cH cG csubg cfv wcel
      cH cgr wcel cY cX cxp cX cG cY cX cxp cres wf cH cgi cfv vx cv cG cY cX
      cxp cres co vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv
      vz cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy
      cY wral wa vx cX wral cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG
      wss w3a cH cgr wcel cG cH issubg cG cgr wcel cH cgr wcel cH cG wss 3simp2
      sylbi cH cG csubg cfv wcel cG cY cX cxp cres cY cX cxp wfn cG cY cX cxp
      cres crn cX wss wa cY cX cxp cX cG cY cX cxp cres wf cH cG csubg cfv wcel
      cG cY cX cxp cres cY cX cxp wfn cG cY cX cxp cres crn cX wss cG cY cX cxp
      cres cY cX cxp wfn cG cY cX cxp cres wfun cG cY cX cxp cres cdm cY cX cxp
      wceq cH cG csubg cfv wcel cG cY cX cxp cres cY cX cxp df-fn cH cG csubg
      cfv wcel cG cgr wcel cX cX cxp cX cG wfo cG cY cX cxp cres wfun cH cG
      csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cgr wcel cG cH
      issubg cG cgr wcel cH cgr wcel cH cG wss 3simp1 sylbi cG cX ssga.1 grpfo
      cX cX cxp cX cG wfo cG wfun cG cY cX cxp cres wfun cX cX cxp cX cG fofun
      cY cX cxp cG funres syl 3syl cH cG csubg cfv wcel cY cX cxp cG cdm wss cG
      cY cX cxp cres cdm cY cX cxp wceq cH cG csubg cfv wcel cY cX cxp cX cX
      cxp cG cdm cH cG csubg cfv wcel cY cX wss cY cX cxp cX cX cxp wss cG cH
      cY cX ssga.1 ssga.2 subgrnss cY cX wss vx cY cX cxp cX cX cxp cY cX wss
      vx cv vy cv vz cv cop wceq vy cv cY wcel vz cv cX wcel wa wa vz wex vy
      wex vx cv cX cX cxp wcel vx cv cY cX cxp wcel vx cv vy cv vz cv cop wceq
      vy cv cY wcel vz cv cX wcel wa wa vz wex vy wex cY cX wss vx cv cX cX cxp
      wcel vx cv vy cv vz cv cop wceq vy cv cY wcel vz cv cX wcel wa wa cY cX
      wss vx cv cX cX cxp wcel wi vy vz vx cv vy cv vz cv cop wceq vy cv cY
      wcel vz cv cX wcel wa wa cY cX wss vy cv vz cv cop cX cX cxp wcel vx cv
      cX cX cxp wcel vy cv cY wcel vz cv cX wcel wa cY cX wss vy cv vz cv cop
      cX cX cxp wcel wi vx cv vy cv vz cv cop wceq vy cv cY wcel vz cv cX wcel
      wa cY cX wss vy cv vz cv cop cX cX cxp wcel vy cv cX wcel vz cv cX wcel
      vy cv vz cv cop cX cX cxp wcel vy cv cY wcel vz cv cX wcel wa cY cX wss
      wa vy cv vz cv cX cX opelxpi vy cv cY wcel cY cX wss vy cv cX wcel vz cv
      cX wcel cY cX wss vy cv cY wcel vy cv cX wcel cY cX vy cv ssel impcom
      adantlr vy cv cY wcel vz cv cX wcel cY cX wss simplr sylanc ex adantl vx
      cv vy cv vz cv cop wceq vx cv cX cX cxp wcel vy cv vz cv cop cX cX cxp
      wcel wb vy cv cY wcel vz cv cX wcel wa vx cv vy cv vz cv cop cX cX cxp
      eleq1 adantr sylibrd 19.23aivv com12 vy vz vx cv cY cX elxp syl5ib ssrdv
      syl cH cG csubg cfv wcel cG cgr wcel cX cX cxp cX cG wfo cG cdm cX cX cxp
      wceq cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cgr
      wcel cG cH issubg cG cgr wcel cH cgr wcel cH cG wss 3simp1 sylbi cG cX
      ssga.1 grpfo cX cX cxp cX cG wfo cX cX cxp cX cG wf cG cdm cX cX cxp wceq
      cX cX cxp cX cG fof cX cX cxp cX cG fdm syl 3syl sseqtr4d cY cX cxp cG
      ssdmres sylib sylanbrc cG cY cX cxp cres crn cG crn cX cG cY cX cxp cres
      cG wss cG cY cX cxp cres crn cG crn wss cG cY cX cxp resss cG cY cX cxp
      cres cG rnss ax-mp ssga.1 sseqtr4i jctir cY cX cxp cX cG cY cX cxp cres
      df-f sylibr cH cG csubg cfv wcel cH cgi cfv vx cv cG cY cX cxp cres co vx
      cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv vz cv vx cv cG
      cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy cY wral wa vx
      cX cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv vx cv cG cY cX cxp
      cres co vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv vz
      cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy cY
      wral cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv vx cv cop cG cY cX
      cxp cres cfv vx cv cH cgi cfv vx cv cG cY cX cxp cres co cH cG csubg cfv
      wcel vx cv cX wcel wa cH cgi cfv vx cv cop cG cY cX cxp cres cfv cH cgi
      cfv vx cv cop cG cfv vx cv cH cG csubg cfv wcel vx cv cX wcel wa cH cgi
      cfv vx cv cop cY cX cxp wcel cH cgi cfv vx cv cop cG cY cX cxp cres cfv
      cH cgi cfv vx cv cop cG cfv wceq cH cgi cfv cY wcel vx cv cX wcel cH cgi
      cfv vx cv cop cY cX cxp wcel cH cG csubg cfv wcel cH cgi cfv vx cv cY cX
      opelxpi cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cH cgi
      cfv cY wcel cG cH issubg cH cgr wcel cG cgr wcel cH cgi cfv cY wcel cH cG
      wss cH cgi cfv cH cY ssga.2 cH cgi cfv eqid grpidcl 3ad2ant2 sylbi sylan
      cH cgi cfv vx cv cop cY cX cxp cG fvres syl cH cG csubg cfv wcel vx cv cX
      wcel wa cH cgi cfv vx cv cG co vx cv cH cgi cfv vx cv cop cG cfv cH cG
      csubg cfv wcel vx cv cX wcel wa cH cgi cfv vx cv cG co cG cgi cfv vx cv
      cG co vx cv cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv cG cgi cfv
      vx cv cG cH cG csubg cfv wcel cH cgi cfv cG cgi cfv wceq vx cv cX wcel cH
      cgi cfv cG cgi cfv cG cH cG cgi cfv eqid cH cgi cfv eqid subgid adantr
      opreq1d cG cgr wcel vx cv cX wcel cG cgi cfv vx cv cG co vx cv wceq cH cG
      csubg cfv wcel vx cv cG cgi cfv cG cX ssga.1 cG cgi cfv eqid grplid cH cG
      csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cgr wcel cG cH
      issubg cG cgr wcel cH cgr wcel cH cG wss 3simp1 sylbi sylan eqtrd cH cgi
      cfv vx cv cG df-opr syl5eqr eqtrd cH cgi cfv vx cv cG cY cX cxp cres
      df-opr syl5eq cH cG csubg cfv wcel vx cv cX wcel wa vy cv vz cv cH co vx
      cv cG cY cX cxp cres co vy cv vz cv vx cv cG cY cX cxp cres co cG cY cX
      cxp cres co wceq vy vz cY cY cH cG csubg cfv wcel vx cv cX wcel wa vy cv
      cY wcel vz cv cY wcel wa vy cv vz cv cH co vx cv cG cY cX cxp cres co vy
      cv vz cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co wceq cH cG csubg
      cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa vy cv vz cv
      cH co vx cv cG cY cX cxp cres co vy cv vz cv cH co vx cv cop cG cfv vy cv
      vz cv cG co vx cv cG co vy cv vz cv vx cv cG cY cX cxp cres co cG cY cX
      cxp cres co cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY
      wcel wa wa vy cv vz cv cH co vx cv cop cG cY cX cxp cres cfv vy cv vz cv
      cH co vx cv cop cG cfv vy cv vz cv cH co vx cv cG cY cX cxp cres co cH cG
      csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa vy cv
      vz cv cH co vx cv cop cY cX cxp wcel vy cv vz cv cH co vx cv cop cG cY cX
      cxp cres cfv vy cv vz cv cH co vx cv cop cG cfv wceq vy cv vz cv cH co cY
      wcel vx cv cX wcel vy cv vz cv cH co vx cv cop cY cX cxp wcel cH cG csubg
      cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa vy cv vz cv
      cH co vx cv cY cX opelxpi cY cY cxp cY cH wf vy cv cY wcel vz cv cY wcel
      vy cv vz cv cH co cY wcel cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY
      wcel vz cv cY wcel wa wa vy cv vz cv cY cY cY cH foprrn cH cG csubg cfv
      wcel cY cY cxp cY cH wf vx cv cX wcel vy cv cY wcel vz cv cY wcel wa cH
      cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cY cY cxp cY cH
      wf cG cH issubg cH cgr wcel cG cgr wcel cY cY cxp cY cH wf cH cG wss cH
      cgr wcel cY cY cxp cY cH wfo cY cY cxp cY cH wf cH cY ssga.2 grpfo cY cY
      cxp cY cH fof syl 3ad2ant2 sylbi ad2antrr cH cG csubg cfv wcel vx cv cX
      wcel wa vy cv cY wcel vz cv cY wcel simprl cH cG csubg cfv wcel vx cv cX
      wcel wa vy cv cY wcel vz cv cY wcel simprr syl3anc cH cG csubg cfv wcel
      vx cv cX wcel vy cv cY wcel vz cv cY wcel wa simplr sylanc vy cv vz cv cH
      co vx cv cop cY cX cxp cG fvres syl vy cv vz cv cH co vx cv cG cY cX cxp
      cres df-opr syl5eq cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz
      cv cY wcel wa wa vy cv vz cv cH co vx cv cG co vy cv vz cv cG co vx cv cG
      co vy cv vz cv cH co vx cv cop cG cfv cH cG csubg cfv wcel vx cv cX wcel
      wa vy cv cY wcel vz cv cY wcel wa wa vy cv vz cv cH co vy cv vz cv cG co
      vx cv cG cH cG csubg cfv wcel vy cv cY wcel vz cv cY wcel wa vy cv vz cv
      cH co vy cv vz cv cG co wceq cH cG csubg cfv wcel vx cv cX wcel wa vy cv
      cY wcel vz cv cY wcel wa wa vy cv vz cv cG cH cY ssga.2 subgopr cH cG
      csubg cfv wcel vx cv cX wcel vy cv cY wcel vz cv cY wcel wa simpll cH cG
      csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa pm3.27
      sylc opreq1d vy cv vz cv cH co vx cv cG df-opr syl5eqr cH cG csubg cfv
      wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa vy cv vz cv vx cv
      cG cY cX cxp cres co cG co vy cv vz cv vx cv cG co cG co vy cv vz cv vx
      cv cG cY cX cxp cres co cG cY cX cxp cres co vy cv vz cv cG co vx cv cG
      co cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa
      wa vz cv vx cv cG cY cX cxp cres co vz cv vx cv cG co vy cv cG cH cG
      csubg cfv wcel vx cv cX wcel wa vz cv cY wcel vz cv vx cv cG cY cX cxp
      cres co vz cv vx cv cG co wceq vy cv cY wcel cH cG csubg cfv wcel vx cv
      cX wcel wa vz cv cY wcel wa vz cv vx cv cop cG cY cX cxp cres cfv vz cv
      vx cv cop cG cfv vz cv vx cv cG cY cX cxp cres co vz cv vx cv cG co cH cG
      csubg cfv wcel vx cv cX wcel wa vz cv cY wcel wa vz cv vx cv cop cY cX
      cxp wcel vz cv vx cv cop cG cY cX cxp cres cfv vz cv vx cv cop cG cfv
      wceq vx cv cX wcel vz cv cY wcel vz cv vx cv cop cY cX cxp wcel cH cG
      csubg cfv wcel vz cv cY wcel vx cv cX wcel vz cv vx cv cop cY cX cxp wcel
      vz cv vx cv cY cX opelxpi ancoms adantll vz cv vx cv cop cY cX cxp cG
      fvres syl vz cv vx cv cG cY cX cxp cres df-opr vz cv vx cv cG df-opr
      3eqtr4g adantrl opreq2d cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY
      wcel vz cv cY wcel wa wa vy cv vz cv vx cv cG cY cX cxp cres co cop cG cY
      cX cxp cres cfv vy cv vz cv vx cv cG cY cX cxp cres co cop cG cfv vy cv
      vz cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co vy cv vz cv vx cv
      cG cY cX cxp cres co cG co cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY
      wcel vz cv cY wcel wa wa vy cv vz cv vx cv cG cY cX cxp cres co cop cY cX
      cxp wcel vy cv vz cv vx cv cG cY cX cxp cres co cop cG cY cX cxp cres cfv
      vy cv vz cv vx cv cG cY cX cxp cres co cop cG cfv wceq vy cv cY wcel vz
      cv vx cv cG cY cX cxp cres co cX wcel vy cv vz cv vx cv cG cY cX cxp cres
      co cop cY cX cxp wcel cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel
      vz cv cY wcel wa wa vy cv vz cv vx cv cG cY cX cxp cres co cY cX opelxpi
      cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel simprl
      cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa
      vz cv vx cv cG cY cX cxp cres co vz cv vx cv cop cG cfv cX cH cG csubg
      cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa vz cv vx cv
      cop cG cY cX cxp cres cfv vz cv vx cv cop cG cfv vz cv vx cv cG cY cX cxp
      cres co cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel
      wa wa vz cv vx cv cop cY cX cxp wcel vz cv vx cv cop cG cY cX cxp cres
      cfv vz cv vx cv cop cG cfv wceq vx cv cX wcel vz cv cY wcel vz cv vx cv
      cop cY cX cxp wcel cH cG csubg cfv wcel vy cv cY wcel vz cv cY wcel vx cv
      cX wcel vz cv vx cv cop cY cX cxp wcel vz cv vx cv cY cX opelxpi ancoms
      ad2ant2l vz cv vx cv cop cY cX cxp cG fvres syl vz cv vx cv cG cY cX cxp
      cres df-opr syl5eq cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz
      cv cY wcel wa wa vz cv vx cv cG co cX vz cv vx cv cop cG cfv cX cX cxp cX
      cG wf vz cv cX wcel vx cv cX wcel vz cv vx cv cG co cX wcel cH cG csubg
      cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel wa wa vz cv vx cv
      cX cX cX cG foprrn cH cG csubg cfv wcel cX cX cxp cX cG wf vx cv cX wcel
      vy cv cY wcel vz cv cY wcel wa cH cG csubg cfv wcel cG cgr wcel cX cX cxp
      cX cG wfo cX cX cxp cX cG wf cH cG csubg cfv wcel cG cgr wcel cH cgr wcel
      cH cG wss w3a cG cgr wcel cG cH issubg cG cgr wcel cH cgr wcel cH cG wss
      3simp1 sylbi cG cX ssga.1 grpfo cX cX cxp cX cG fof 3syl ad2antrr cY cX
      wss vx cv cX wcel vy cv cY wcel vz cv cY wcel wa vz cv cX wcel cH cG
      csubg cfv wcel cY cX wss vz cv cY wcel vz cv cX wcel vx cv cX wcel vy cv
      cY wcel cY cX vz cv ssel2 ad2ant2rl cG cH cY cX ssga.1 ssga.2 subgrnss
      sylanl1 cH cG csubg cfv wcel vx cv cX wcel vy cv cY wcel vz cv cY wcel wa
      simplr syl3anc vz cv vx cv cG df-opr syl5eqelr eqeltrd sylanc vy cv vz cv
      vx cv cG cY cX cxp cres co cop cY cX cxp cG fvres syl vy cv vz cv vx cv
      cG cY cX cxp cres co cG cY cX cxp cres df-opr vy cv vz cv vx cv cG cY cX
      cxp cres co cG df-opr 3eqtr4g cG cgr wcel vy cv cX wcel vz cv cX wcel vx
      cv cX wcel w3a vy cv vz cv cG co vx cv cG co vy cv vz cv vx cv cG co cG
      co wceq cH cG csubg cfv wcel vx cv cX wcel wa vy cv cY wcel vz cv cY wcel
      wa wa vy cv vz cv vx cv cG cX ssga.1 grpass cH cG csubg cfv wcel cG cgr
      wcel vx cv cX wcel vy cv cY wcel vz cv cY wcel wa cH cG csubg cfv wcel cG
      cgr wcel cH cgr wcel cH cG wss w3a cG cgr wcel cG cH issubg cG cgr wcel
      cH cgr wcel cH cG wss 3simp1 sylbi ad2antrr cY cX wss vx cv cX wcel vy cv
      cY wcel vz cv cY wcel wa vy cv cX wcel vz cv cX wcel vx cv cX wcel w3a cH
      cG csubg cfv wcel cY cX wss vx cv cX wcel wa vy cv cY wcel vz cv cY wcel
      wa wa vy cv cX wcel vz cv cX wcel vx cv cX wcel cY cX wss vy cv cY wcel
      vy cv cX wcel vx cv cX wcel vz cv cY wcel cY cX vy cv ssel2 ad2ant2r cY
      cX wss vz cv cY wcel vz cv cX wcel vx cv cX wcel vy cv cY wcel cY cX vz
      cv ssel2 ad2ant2rl cY cX wss vx cv cX wcel vy cv cY wcel vz cv cY wcel wa
      simplr 3jca cG cH cY cX ssga.1 ssga.2 subgrnss sylanl1 sylanc 3eqtr4rd
      3eqtrd ex r19.21aivv jca r19.21aiva 3jca cH cG csubg cfv wcel cG cY cX
      cxp cres crn cX wceq cH cgr wcel cY cG cY cX cxp cres crn cxp cG cY cX
      cxp cres crn cG cY cX cxp cres wf cH cgi cfv vx cv cG cY cX cxp cres co
      vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv vz cv vx cv
      cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy cY wral wa
      vx cG cY cX cxp cres crn wral w3a cH cgr wcel cY cX cxp cX cG cY cX cxp
      cres wf cH cgi cfv vx cv cG cY cX cxp cres co vx cv wceq vy cv vz cv cH
      co vx cv cG cY cX cxp cres co vy cv vz cv vx cv cG cY cX cxp cres co cG
      cY cX cxp cres co wceq vz cY wral vy cY wral wa vx cX wral w3a wb cH cG
      csubg cfv wcel cG cY cX cxp cima cX cG cY cX cxp cres crn cH cG csubg cfv
      wcel cG cY cX cxp cima cX cG cY cX cxp cima cX wss cH cG csubg cfv wcel
      cG cY cX cxp cima cG crn cX cG cY cX cxp imassrn ssga.1 sseqtr4i a1i cH
      cG csubg cfv wcel vx cX cG cY cX cxp cima cH cG csubg cfv wcel vx cv cX
      wcel vy cv cY cX cxp wcel vy cv vx cv cop cG wcel wa vy wex vx cv cG cY
      cX cxp cima wcel cH cG csubg cfv wcel vx cv cX wcel cH cgi cfv vx cv cop
      cY cX cxp wcel cH cgi cfv vx cv cop vx cv cop cG wcel wa vy cv cY cX cxp
      wcel vy cv vx cv cop cG wcel wa vy wex cH cG csubg cfv wcel vx cv cX wcel
      cH cgi cfv vx cv cop cY cX cxp wcel cH cgi cfv vx cv cop vx cv cop cG
      wcel wa cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv cY wcel vx cv cX
      wcel wa cH cgi cfv vx cv cop cG cfv vx cv wceq wa cH cgi cfv vx cv cop cY
      cX cxp wcel cH cgi cfv vx cv cop vx cv cop cG wcel wa cH cG csubg cfv
      wcel vx cv cX wcel wa cH cgi cfv cY wcel vx cv cX wcel cH cgi cfv vx cv
      cop cG cfv vx cv wceq cH cG csubg cfv wcel cH cgi cfv cY wcel vx cv cX
      wcel cH cG csubg cfv wcel cH cgr wcel cH cgi cfv cY wcel cH cG csubg cfv
      wcel cG cgr wcel cH cgr wcel cH cG wss w3a cH cgr wcel cG cH issubg cG
      cgr wcel cH cgr wcel cH cG wss 3simp2 sylbi cH cgi cfv cH cY ssga.2 cH
      cgi cfv eqid grpidcl syl adantr cH cG csubg cfv wcel vx cv cX wcel pm3.27
      cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv vx cv cop cG cfv vx cv
      wceq cG cgi cfv vx cv cop cG cfv vx cv wceq cG cgr wcel vx cv cX wcel cG
      cgi cfv vx cv cop cG cfv vx cv wceq cH cG csubg cfv wcel cG cgr wcel vx
      cv cX wcel wa cG cgi cfv vx cv cG co vx cv cG cgi cfv vx cv cop cG cfv vx
      cv cG cgi cfv cG cX ssga.1 cG cgi cfv eqid grplid cG cgi cfv vx cv cG
      df-opr syl5eqr cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a
      cG cgr wcel cG cH issubg cG cgr wcel cH cgr wcel cH cG wss 3simp1 sylbi
      sylan cH cG csubg cfv wcel cH cgi cfv vx cv cop cG cfv vx cv wceq cG cgi
      cfv vx cv cop cG cfv vx cv wceq wb vx cv cX wcel cH cG csubg cfv wcel cH
      cgi cfv cG cgi cfv wceq cH cgi cfv vx cv cop cG cfv vx cv wceq cG cgi cfv
      vx cv cop cG cfv vx cv wceq wb cH cgi cfv cG cgi cfv cG cH cG cgi cfv
      eqid cH cgi cfv eqid subgid cH cgi cfv cG cgi cfv wceq cH cgi cfv vx cv
      cop cG cfv cG cgi cfv vx cv cop cG cfv vx cv cH cgi cfv cG cgi cfv wceq
      cH cgi cfv vx cv cop cG cgi cfv vx cv cop cG cH cgi cfv cG cgi cfv vx cv
      opeq1 fveq2d eqeq1d syl adantr mpbird jca31 cH cG csubg cfv wcel vx cv cX
      wcel wa cH cgi cfv cY wcel vx cv cX wcel wa cH cgi cfv vx cv cop cY cX
      cxp wcel cH cgi cfv vx cv cop cG cfv vx cv wceq cH cgi cfv vx cv cop vx
      cv cop cG wcel cH cgi cfv cY wcel vx cv cX wcel wa cH cgi cfv vx cv cop
      cY cX cxp wcel wb cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv vx cv
      cop cY cX cxp wcel cH cgi cfv cY wcel vx cv cX wcel wa cH cgi cfv vx cv
      cY cX vx visset opelxp bicomi a1i cG wfun cH cgi cfv vx cv cop cG cdm
      wcel cH cgi cfv vx cv cop cG cfv vx cv wceq cH cgi cfv vx cv cop vx cv
      cop cG wcel wb cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv vx cv cop
      vx cv cG vx visset funopfvb cH cG csubg cfv wcel cG wfun vx cv cX wcel cH
      cG csubg cfv wcel cG cgr wcel cX cX cxp cX cG wfo cG wfun cH cG csubg cfv
      wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cgr wcel cG cH issubg cG
      cgr wcel cH cgr wcel cH cG wss 3simp1 sylbi cG cX ssga.1 grpfo cX cX cxp
      cX cG fofun 3syl adantr cH cG csubg cfv wcel vx cv cX wcel wa cH cgi cfv
      vx cv cop cX cX cxp cG cdm cH cgi cfv cX wcel vx cv cX wcel cH cgi cfv vx
      cv cop cX cX cxp wcel cH cG csubg cfv wcel cH cgi cfv vx cv cX cX opelxpi
      cH cG csubg cfv wcel cY cX cH cgi cfv cG cH cY cX ssga.1 ssga.2 subgrnss
      cH cG csubg cfv wcel cH cgr wcel cH cgi cfv cY wcel cH cG csubg cfv wcel
      cG cgr wcel cH cgr wcel cH cG wss w3a cH cgr wcel cG cH issubg cG cgr
      wcel cH cgr wcel cH cG wss 3simp2 sylbi cH cgi cfv cH cY ssga.2 cH cgi
      cfv eqid grpidcl syl sseldd sylan cH cG csubg cfv wcel cG cdm cX cX cxp
      wceq vx cv cX wcel cH cG csubg cfv wcel cX cX cxp cX cG wfo cX cX cxp cX
      cG wf cG cdm cX cX cxp wceq cH cG csubg cfv wcel cG cgr wcel cX cX cxp cX
      cG wfo cH cG csubg cfv wcel cG cgr wcel cH cgr wcel cH cG wss w3a cG cgr
      wcel cG cH issubg cG cgr wcel cH cgr wcel cH cG wss 3simp1 sylbi cG cX
      ssga.1 grpfo syl cX cX cxp cX cG fof cX cX cxp cX cG fdm 3syl adantr
      eleqtrrd sylanc anbi12d mpbid ex vy cv cY cX cxp wcel vy cv vx cv cop cG
      wcel wa cH cgi cfv vx cv cop cY cX cxp wcel cH cgi cfv vx cv cop vx cv
      cop cG wcel wa vy cH cgi cfv vx cv cop cH cgi cfv vx cv opex vy cv cH cgi
      cfv vx cv cop wceq vy cv cY cX cxp wcel cH cgi cfv vx cv cop cY cX cxp
      wcel vy cv vx cv cop cG wcel cH cgi cfv vx cv cop vx cv cop cG wcel vy cv
      cH cgi cfv vx cv cop cY cX cxp eleq1 vy cv cH cgi cfv vx cv cop wceq vy
      cv vx cv cop cH cgi cfv vx cv cop vx cv cop cG vy cv cH cgi cfv vx cv cop
      vx cv opeq1 eleq1d anbi12d cla4ev syl6 vy vx cv cG cY cX cxp vx visset
      elima3 syl6ibr ssrdv eqssd cG cY cX cxp df-ima syl5eqr cG cY cX cxp cres
      crn cX wceq cY cG cY cX cxp cres crn cxp cG cY cX cxp cres crn cG cY cX
      cxp cres wf cY cX cxp cX cG cY cX cxp cres wf cH cgi cfv vx cv cG cY cX
      cxp cres co vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv
      vz cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy
      cY wral wa vx cG cY cX cxp cres crn wral cH cgi cfv vx cv cG cY cX cxp
      cres co vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv vz
      cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy cY
      wral wa vx cX wral cH cgr wcel cY cG cY cX cxp cres crn cxp cY cX cxp
      wceq cG cY cX cxp cres crn cX wceq cY cG cY cX cxp cres crn cxp cG cY cX
      cxp cres crn cG cY cX cxp cres wf cY cX cxp cX cG cY cX cxp cres wf wb cG
      cY cX cxp cres crn cX cY xpeq2 cY cG cY cX cxp cres crn cxp cG cY cX cxp
      cres crn cY cX cxp cX cG cY cX cxp cres feq23 mpancom cH cgi cfv vx cv cG
      cY cX cxp cres co vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co
      vy cv vz cv vx cv cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY
      wral vy cY wral wa vx cG cY cX cxp cres crn cX raleq1 3anbi23d syl mpbird
      cH cG csubg cfv wcel cG cgr wcel cG cY cX cxp cres cvv wcel cH cG cY cX
      cxp cres cop cga wcel cH cgr wcel cY cG cY cX cxp cres crn cxp cG cY cX
      cxp cres crn cG cY cX cxp cres wf cH cgi cfv vx cv cG cY cX cxp cres co
      vx cv wceq vy cv vz cv cH co vx cv cG cY cX cxp cres co vy cv vz cv vx cv
      cG cY cX cxp cres co cG cY cX cxp cres co wceq vz cY wral vy cY wral wa
      vx cG cY cX cxp cres crn wral w3a wb cH cG csubg cfv wcel cG cgr wcel cH
      cgr wcel cH cG wss w3a cG cgr wcel cG cH issubg cG cgr wcel cH cgr wcel
      cH cG wss 3simp1 sylbi cG cY cX cxp cgr resexg vx vy vz cvv cH cgi cfv cH
      cG cY cX cxp cres cY cG cY cX cxp cres crn ssga.2 cG cY cX cxp cres crn
      eqid cH cgi cfv eqid isga2 3syl mpbird $.
      $( [17-May-2010] $) $( [13-Aug-2009] $)
  $}

  ${
    $d x y z G $. $d x y z M $.
    $( The first element of a group action ordered pair is a group.
       (Contributed by Jeff Hankins, 11-Aug-2009.) $)
    gagrp $p |- ( ( M e. A /\ <. G , M >. e. GrpAct ) -> G e. Grp ) $=
      cM cA wcel cG cM cop cga wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv
      vz cv vx cv cM co cM co wceq vz cG crn wral vy cG crn wral wa vx cM crn
      wral cM cA wcel cG cM cop cga wcel cG cgr wcel cG crn cM crn cxp cM crn
      cM wf cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy
      cv vz cv vx cv cM co cM co wceq vz cG crn wral vy cG crn wral wa vx cM
      crn wral w3a vx vy vz cA cG cgi cfv cG cM cG crn cM crn cG crn eqid cM
      crn eqid cG cgi cfv eqid isga2 biimpa 3simp1d $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d x y z G $. $d x y z M $. $d x y z X $. $d x y z Y $.
    gaf.1 $e |- X = ran G $.
    gaf.2 $e |- Y = ran M $.
    $( The mapping of the group action operation.  (Contributed by Jeff
       Hankins, 11-Aug-2009.) $)
    gaf $p |- ( ( M e. A /\ <. G , M >. e. GrpAct )
              -> M : ( X X. Y ) --> Y ) $=
      cM cA wcel cG cM cop cga wcel wa cG cgr wcel cX cY cxp cY cM wf cG cgi
      cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx
      cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral cM cA wcel cG cM
      cop cga wcel cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx cY wral w3a vx vy vz cA cG cgi cfv cG cM cX cY
      gaf.1 gaf.2 cG cgi cfv eqid isga2 biimpa 3simp2d $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z G $. $d x y z M $. $d x y z U $. $d x
    y z Y $.
    gagrpid.1 $e |- Y = ran M $.
    gagrpid.2 $e |- U = ( Id ` G ) $.
    $( The identity of the group does not alter the base set.  (Contributed by
       Jeff Hankins, 11-Aug-2009.) $)
    gagrpid $p |- ( ( M e. B /\ <. G , M >. e. GrpAct /\ A e. Y ) -> ( U M A )
    = A ) $=
      cM cB wcel cG cM cop cga wcel cA cY wcel cU cA cM co cA wceq cA cY wcel
      cM cB wcel cG cM cop cga wcel wa cU cA cM co cA wceq cM cB wcel cG cM cop
      cga wcel wa cU vx cv cM co vx cv wceq wi cM cB wcel cG cM cop cga wcel wa
      cU cA cM co cA wceq wi vx cA cY vx cv cA wceq cU vx cv cM co vx cv wceq
      cU cA cM co cA wceq cM cB wcel cG cM cop cga wcel wa vx cv cA wceq cU vx
      cv cM co cU cA cM co vx cv cA vx cv cA cU cM opreq2 vx cv cA wceq id
      eqeq12d imbi2d cM cB wcel cG cM cop cga wcel wa vx cv cY wcel cU vx cv cM
      co vx cv wceq cM cB wcel cG cM cop cga wcel wa cU vx cv cM co vx cv wceq
      vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cG
      crn wral vy cG crn wral wa vx cY wral vx cv cY wcel cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cG crn wral vy cG crn wral wa wi vx cv cY wcel cU vx cv cM co vx cv wceq
      wi cM cB wcel cG cM cop cga wcel wa cG cgr wcel cG crn cY cxp cY cM wf cU
      vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vz cG crn wral vy cG crn wral wa vx cY wral cM cB wcel cG
      cM cop cga wcel cG cgr wcel cG crn cY cxp cY cM wf cU vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cG crn wral vy cG crn wral wa vx cY wral w3a vx vy vz cB cU cG cM cG crn
      cY cG crn eqid gagrpid.1 gagrpid.2 isga2 biimpa 3simp3d cU vx cv cM co vx
      cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq
      vz cG crn wral vy cG crn wral wa vx cY ra4 cU vx cv cM co vx cv wceq vy
      cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cG crn
      wral vy cG crn wral wa cU vx cv cM co vx cv wceq vx cv cY wcel cU vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cG crn wral vy cG crn wral pm3.26 imim2i 3syl com12 vtoclga
      com12 3impia $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $. $d x y z G $. $d x y z K $. $d x
    y z M $. $d x y z X $. $d x y z Y $.
    gaass.1 $e |- X = ran G $.
    gaass.2 $e |- Y = ran M $.
    $( An "associative" property for group actions.  (Contributed by Jeff
       Hankins, 11-Aug-2009.) $)
    gaass $p |- ( ( M e. K /\ <. G , M >. e. GrpAct /\ ( A e. X /\ B e. X /\ C
    e. Y ) ) -> ( ( A G B ) M C ) = ( A M ( B M C ) ) ) $=
      cM cK wcel cG cM cop cga wcel cA cX wcel cB cX wcel cC cY wcel w3a cA cB
      cG co cC cM co cA cB cC cM co cM co wceq cA cX wcel cB cX wcel cC cY wcel
      w3a cM cK wcel cG cM cop cga wcel wa cA cB cG co cC cM co cA cB cC cM co
      cM co wceq cM cK wcel cG cM cop cga wcel wa vy cv vz cv cG co vx cv cM co
      vy cv vz cv vx cv cM co cM co wceq wi cM cK wcel cG cM cop cga wcel wa cA
      vz cv cG co vx cv cM co cA vz cv vx cv cM co cM co wceq wi cM cK wcel cG
      cM cop cga wcel wa cA cB cG co vx cv cM co cA cB vx cv cM co cM co wceq
      wi cM cK wcel cG cM cop cga wcel wa cA cB cG co cC cM co cA cB cC cM co
      cM co wceq wi vy vz vx cA cB cC cX cX cY vy cv cA wceq vy cv vz cv cG co
      vx cv cM co vy cv vz cv vx cv cM co cM co wceq cA vz cv cG co vx cv cM co
      cA vz cv vx cv cM co cM co wceq cM cK wcel cG cM cop cga wcel wa vy cv cA
      wceq vy cv vz cv cG co vx cv cM co cA vz cv cG co vx cv cM co vy cv vz cv
      vx cv cM co cM co cA vz cv vx cv cM co cM co vy cv cA wceq vy cv vz cv cG
      co cA vz cv cG co vx cv cM vy cv cA vz cv cG opreq1 opreq1d vy cv cA vz
      cv vx cv cM co cM opreq1 eqeq12d imbi2d vz cv cB wceq cA vz cv cG co vx
      cv cM co cA vz cv vx cv cM co cM co wceq cA cB cG co vx cv cM co cA cB vx
      cv cM co cM co wceq cM cK wcel cG cM cop cga wcel wa vz cv cB wceq cA vz
      cv cG co vx cv cM co cA cB cG co vx cv cM co cA vz cv vx cv cM co cM co
      cA cB vx cv cM co cM co vz cv cB wceq cA vz cv cG co cA cB cG co vx cv cM
      vz cv cB cA cG opreq2 opreq1d vz cv cB wceq vz cv vx cv cM co cB vx cv cM
      co cA cM vz cv cB vx cv cM opreq1 opreq2d eqeq12d imbi2d vx cv cC wceq cA
      cB cG co vx cv cM co cA cB vx cv cM co cM co wceq cA cB cG co cC cM co cA
      cB cC cM co cM co wceq cM cK wcel cG cM cop cga wcel wa vx cv cC wceq cA
      cB cG co vx cv cM co cA cB cG co cC cM co cA cB vx cv cM co cM co cA cB
      cC cM co cM co vx cv cC cA cB cG co cM opreq2 vx cv cC wceq cB vx cv cM
      co cB cC cM co cA cM vx cv cC cB cM opreq2 opreq2d eqeq12d imbi2d vy cv
      cX wcel vz cv cX wcel vx cv cY wcel cM cK wcel cG cM cop cga wcel wa vy
      cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq wi cM cK
      wcel cG cM cop cga wcel wa vx cv cY wcel vy cv cX wcel vz cv cX wcel wa
      vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq cM cK
      wcel cG cM cop cga wcel wa vx cv cY wcel vy cv vz cv cG co vx cv cM co vy
      cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral vy cv cX wcel vz cv
      cX wcel wa vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co
      wceq wi cM cK wcel cG cM cop cga wcel wa vx cv cY wcel cG cgi cfv vx cv
      cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM
      co wceq vz cX wral vy cX wral wa vy cv vz cv cG co vx cv cM co vy cv vz
      cv vx cv cM co cM co wceq vz cX wral vy cX wral cM cK wcel cG cM cop cga
      wcel wa cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co
      vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa vx cY wral vx
      cv cY wcel cG cgi cfv vx cv cM co vx cv wceq vy cv vz cv cG co vx cv cM
      co vy cv vz cv vx cv cM co cM co wceq vz cX wral vy cX wral wa wi cM cK
      wcel cG cM cop cga wcel wa cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx
      cv cM co vx cv wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co
      cM co wceq vz cX wral vy cX wral wa vx cY wral cM cK wcel cG cM cop cga
      wcel cG cgr wcel cX cY cxp cY cM wf cG cgi cfv vx cv cM co vx cv wceq vy
      cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral
      vy cX wral wa vx cY wral w3a vx vy vz cK cG cgi cfv cG cM cX cY gaass.1
      gaass.2 cG cgi cfv eqid isga2 biimpa 3simp3d cG cgi cfv vx cv cM co vx cv
      wceq vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz
      cX wral vy cX wral wa vx cY ra4 syl cG cgi cfv vx cv cM co vx cv wceq vy
      cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM co cM co wceq vz cX wral
      vy cX wral pm3.27 syl6 vy cv vz cv cG co vx cv cM co vy cv vz cv vx cv cM
      co cM co wceq vy vz cX cX ra42 syl6 com13 3impia vtocl3ga com12 3impia $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    gacan.1 $e |- X = ran G $.
    gacan.2 $e |- Y = ran M $.
    gacan.3 $e |- N = ( inv ` G ) $.
    $( Group inverses cancel in a group action.  (Contributed by Jeff Hankins,
       11-Aug-2009.) $)
    gacan $p |- ( ( M e. K /\ <. G , M >. e. GrpAct /\ ( A e. X /\ B e. Y /\ C
    e. Y ) ) -> ( ( A M B ) = C <-> ( ( N ` A ) M C ) = B ) ) $=
      cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a w3a cA
      cB cM co cC wceq cA cN cfv cC cM co cB wceq cM cK wcel cG cM cop cga wcel
      cA cX wcel cB cY wcel cC cY wcel w3a w3a cA cB cM co cC wceq wa cA cN cfv
      cA cG co cB cM co cA cN cfv cA cB cM co cM co cB cA cN cfv cC cM co cM cK
      wcel cG cM cop cga wcel cA cN cfv cX wcel cA cX wcel cB cY wcel w3a cA cN
      cfv cA cG co cB cM co cA cN cfv cA cB cM co cM co wceq cM cK wcel cG cM
      cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a w3a cA cB cM co cC wceq
      wa cA cN cfv cA cB cG cK cM cX cY gacan.1 gacan.2 gaass cM cK wcel cG cM
      cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a cA cB cM co cC wceq
      3simpl1 cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel
      w3a cA cB cM co cC wceq 3simpl2 cM cK wcel cG cM cop cga wcel cA cX wcel
      cB cY wcel cC cY wcel w3a w3a cA cB cM co cC wceq wa cA cN cfv cX wcel cA
      cX wcel cB cY wcel cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC
      cY wcel w3a w3a cA cN cfv cX wcel cA cB cM co cC wceq cM cK wcel cG cM
      cop cga wcel cA cX wcel cA cN cfv cX wcel cA cX wcel cB cY wcel cC cY
      wcel w3a cM cK wcel cG cM cop cga wcel cA cX wcel cA cN cfv cX wcel cG
      cgr wcel cA cX wcel cA cN cfv cX wcel cM cK wcel cG cM cop cga wcel wa cA
      cG cN cX gacan.1 gacan.3 grpinvcl cK cG cM gagrp sylan 3impa cA cX wcel
      cB cY wcel cC cY wcel 3simp1 syl3an3 adantr cM cK wcel cG cM cop cga wcel
      cA cX wcel cB cY wcel cC cY wcel w3a w3a cA cX wcel cA cB cM co cC wceq
      cA cX wcel cB cY wcel cC cY wcel w3a cM cK wcel cA cX wcel cG cM cop cga
      wcel cA cX wcel cB cY wcel cC cY wcel 3simp1 3ad2ant3 adantr cM cK wcel
      cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a w3a cB cY wcel cA
      cB cM co cC wceq cA cX wcel cB cY wcel cC cY wcel w3a cM cK wcel cB cY
      wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel 3simp2 3ad2ant3
      adantr 3jca syl3anc cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel
      cC cY wcel w3a w3a cA cN cfv cA cG co cB cM co cB wceq cA cB cM co cC
      wceq cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a
      w3a cA cN cfv cA cG co cB cM co cG cgi cfv cB cM co cB cM cK wcel cG cM
      cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a w3a cA cN cfv cA cG co
      cG cgi cfv cB cM cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC
      cY wcel w3a cA cN cfv cA cG co cG cgi cfv wceq cG cgr wcel cA cX wcel cA
      cN cfv cA cG co cG cgi cfv wceq cM cK wcel cG cM cop cga wcel wa cA cX
      wcel cB cY wcel cC cY wcel w3a cA cG cgi cfv cG cN cX gacan.1 cG cgi cfv
      eqid gacan.3 grplinv cK cG cM gagrp cA cX wcel cB cY wcel cC cY wcel
      3simp1 syl2an 3impa opreq1d cM cK wcel cG cM cop cga wcel cB cY wcel cG
      cgi cfv cB cM co cB wceq cA cX wcel cB cY wcel cC cY wcel w3a cB cK cG
      cgi cfv cG cM cY gacan.2 cG cgi cfv eqid gagrpid cA cX wcel cB cY wcel cC
      cY wcel 3simp2 syl3an3 eqtrd adantr cA cB cM co cC wceq cA cN cfv cA cB
      cM co cM co cA cN cfv cC cM co wceq cM cK wcel cG cM cop cga wcel cA cX
      wcel cB cY wcel cC cY wcel w3a w3a cA cB cM co cC cA cN cfv cM opreq2
      adantl 3eqtr3rd cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY
      wcel w3a w3a cA cN cfv cC cM co cB wceq wa cA cA cN cfv cG co cC cM co cA
      cA cN cfv cC cM co cM co cC cA cB cM co cM cK wcel cG cM cop cga wcel cA
      cX wcel cB cY wcel cC cY wcel w3a w3a cA cA cN cfv cG co cC cM co cA cA
      cN cfv cC cM co cM co wceq cA cN cfv cC cM co cB wceq cM cK wcel cG cM
      cop cga wcel cA cX wcel cA cN cfv cX wcel cC cY wcel w3a cA cA cN cfv cG
      co cC cM co cA cA cN cfv cC cM co cM co wceq cA cX wcel cB cY wcel cC cY
      wcel w3a cA cA cN cfv cC cG cK cM cX cY gacan.1 gacan.2 gaass cM cK wcel
      cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a w3a cA cX wcel cA
      cN cfv cX wcel cC cY wcel cA cX wcel cB cY wcel cC cY wcel w3a cM cK wcel
      cA cX wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel 3simp1
      3ad2ant3 cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel
      w3a cA cN cfv cX wcel cG cgr wcel cA cX wcel cA cN cfv cX wcel cM cK wcel
      cG cM cop cga wcel wa cA cX wcel cB cY wcel cC cY wcel w3a cA cG cN cX
      gacan.1 gacan.3 grpinvcl cK cG cM gagrp cA cX wcel cB cY wcel cC cY wcel
      3simp1 syl2an 3impa cA cX wcel cB cY wcel cC cY wcel w3a cM cK wcel cC cY
      wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel 3simp3 3ad2ant3
      3jca syld3an3 adantr cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel
      cC cY wcel w3a w3a cA cA cN cfv cG co cC cM co cC wceq cA cN cfv cC cM co
      cB wceq cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel
      w3a w3a cA cA cN cfv cG co cC cM co cG cgi cfv cC cM co cC cM cK wcel cG
      cM cop cga wcel cA cX wcel cB cY wcel cC cY wcel w3a w3a cA cA cN cfv cG
      co cG cgi cfv cC cM cM cK wcel cG cM cop cga wcel cA cX wcel cB cY wcel
      cC cY wcel w3a cA cA cN cfv cG co cG cgi cfv wceq cG cgr wcel cA cX wcel
      cA cA cN cfv cG co cG cgi cfv wceq cM cK wcel cG cM cop cga wcel wa cA cX
      wcel cB cY wcel cC cY wcel w3a cA cG cgi cfv cG cN cX gacan.1 cG cgi cfv
      eqid gacan.3 grprinv cK cG cM gagrp cA cX wcel cB cY wcel cC cY wcel
      3simp1 syl2an 3impa opreq1d cM cK wcel cG cM cop cga wcel cC cY wcel cG
      cgi cfv cC cM co cC wceq cA cX wcel cB cY wcel cC cY wcel w3a cC cK cG
      cgi cfv cG cM cY gacan.2 cG cgi cfv eqid gagrpid cA cX wcel cB cY wcel cC
      cY wcel 3simp3 syl3an3 eqtrd adantr cA cN cfv cC cM co cB wceq cA cA cN
      cfv cC cM co cM co cA cB cM co wceq cM cK wcel cG cM cop cga wcel cA cX
      wcel cB cY wcel cC cY wcel w3a w3a cA cN cfv cC cM co cB cA cM opreq2
      adantl 3eqtr3rd impbida $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d u v A $. $d u v B $. $d u v G $. $d u v M $. $d u v N $. $d u v X $. $d
    u v Y $. $d t u v $. $d u v x $. $d u v z $.
    gapmlem.1 $e |- X = ran G $.
    gapmlem.2 $e |- Y = ran M $.
    gapmlem.3 $e |- N = ( inv ` G ) $.
    $( Lemma for ~ gapm . $)
    gapmlem $p |- ( ( ( ( M e. B /\ <. G , M >. e. GrpAct /\ A e. X ) /\ t e. Y
    ) /\ ( z M t /\ z ( 2nd |` ( { A } X. _V ) ) x ) ) -> ( ( N ` A ) M t ) = x
    ) $=
      cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa vz cv vt cv
      cM wbr vz cv vx cv c2nd cA csn cvv cxp cres wbr wa cA cN cfv vt cv cM co
      vx cv wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa
      vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz cv cA csn cvv cxp wcel wa
      wa cA cN cfv vt cv cM co vx cv wceq vz cv vt cv cM wbr vz cv vx cv c2nd
      cA csn cvv cxp cres wbr wa cM cB wcel cG cM cop cga wcel cA cX wcel w3a
      vt cv cY wcel wa vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz cv cA
      csn cvv cxp wcel wa wa vz cv vu cv vv cv cop wceq vu cv cA csn wcel vv cv
      cvv wcel wa wa vv wex vu wex cA cN cfv vt cv cM co vx cv wceq vz cv cA
      csn cvv cxp wcel vz cv vu cv vv cv cop wceq vu cv cA csn wcel vv cv cvv
      wcel wa wa vv wex vu wex vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz
      cv cA csn cvv cxp wcel vz cv vu cv vv cv cop wceq vu cv cA csn wcel vv cv
      cvv wcel wa wa vv wex vu wex vu vv vz cv cA csn cvv elxp biimpi ad2antll
      vz cv vu cv vv cv cop wceq vu cv cA csn wcel vv cv cvv wcel wa wa vv wex
      vu wex vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz cv cA csn cvv cxp
      wcel wa wa cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa
      cA cN cfv vt cv cM co vx cv wceq vz cv vu cv vv cv cop wceq vu cv cA csn
      wcel vv cv cvv wcel wa wa vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz
      cv cA csn cvv cxp wcel wa wa cM cB wcel cG cM cop cga wcel cA cX wcel w3a
      vt cv cY wcel wa cA cN cfv vt cv cM co vx cv wceq wi wi vu vv vu cv cA
      csn wcel vv cv cvv wcel wa vz cv vu cv vv cv cop wceq vz cv vt cv cM wbr
      vz cv vx cv cop c2nd wcel vz cv cA csn cvv cxp wcel wa wa cM cB wcel cG
      cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cN cfv vt cv cM co vx
      cv wceq wi wi vu cv cA csn wcel vv cv cvv wcel wa vu cv cA wceq vz cv vu
      cv vv cv cop wceq vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz cv cA
      csn cvv cxp wcel wa wa cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv
      cY wcel wa cA cN cfv vt cv cM co vx cv wceq wi wi wi vu cv cA csn wcel vv
      cv cvv wcel wa vu cv cA csn wcel vu cv cA wceq vu cv cA csn wcel vv cv
      cvv wcel wa vu cv cA csn wcel vu cv cA csn wcel vv cv cvv wcel pm3.26 vu
      cv cA csn wcel vv cv cvv wcel vv visset jctr impbii vu cA elsn bitri vu
      cv cA wceq vz cv vu cv vv cv cop wceq vz cv cA vv cv cop wceq vz cv vt cv
      cM wbr vz cv vx cv cop c2nd wcel vz cv cA csn cvv cxp wcel wa wa cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cN cfv vt cv
      cM co vx cv wceq wi wi vu cv cA wceq vu cv vv cv cop cA vv cv cop vz cv
      vu cv cA vv cv opeq1 eqeq2d vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel
      vz cv cA csn cvv cxp wcel wa wa vz cv cA vv cv cop wceq cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cN cfv vt cv cM co vx cv
      wceq wi vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel vz cv cA vv cv cop
      wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cN
      cfv vt cv cM co vx cv wceq wi wi vz cv cA csn cvv cxp wcel vz cv cA vv cv
      cop wceq vz cv vt cv cM wbr vz cv vx cv cop c2nd wcel wa cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cN cfv vt cv cM co vx cv
      wceq wi vz cv cA vv cv cop wceq vz cv vt cv cM wbr vz cv vx cv cop c2nd
      wcel wa cA vv cv cop vt cv cM wbr cA vv cv cop vx cv cop c2nd wcel wa cM
      cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cN cfv vt
      cv cM co vx cv wceq wi vz cv cA vv cv cop wceq vz cv vt cv cM wbr cA vv
      cv cop vt cv cM wbr vz cv vx cv cop c2nd wcel cA vv cv cop vx cv cop c2nd
      wcel vz cv cA vv cv cop vt cv cM breq1 vz cv cA vv cv cop wceq vz cv vx
      cv cop cA vv cv cop vx cv cop c2nd vz cv cA vv cv cop vx cv opeq1 eleq1d
      anbi12d cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA
      vv cv cop vt cv cM wbr cA vv cv cop vx cv cop c2nd wcel wa cA cN cfv vt
      cv cM co vx cv wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY
      wcel wa cA vv cv cM co vt cv wceq cA vv cv cop cM cdm wcel wa vv cv vx cv
      wceq cA cN cfv vt cv cM co vx cv wceq cA vv cv cop vt cv cM wbr cA vv cv
      cop vx cv cop c2nd wcel cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt
      cv cY wcel wa cA vv cv cM co vt cv wceq cA vv cv cop cM cdm wcel wa vv cv
      vx cv wceq wa cA vv cv cM co vt cv wceq cA vv cv cop cX cY cxp wcel wa vv
      cv vx cv wceq wa cA cN cfv vt cv cM co vx cv wceq cM cB wcel cG cM cop
      cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cM co vt cv wceq cA vv
      cv cop cM cdm wcel wa cA vv cv cM co vt cv wceq cA vv cv cop cX cY cxp
      wcel wa vv cv vx cv wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt
      cv cY wcel wa cA vv cv cop cM cdm wcel cA vv cv cop cX cY cxp wcel cA vv
      cv cM co vt cv wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY
      wcel wa cM cdm cX cY cxp cA vv cv cop cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a cM cdm cX cY cxp wceq vt cv cY wcel cM cB wcel cG cM cop cga
      wcel cM cdm cX cY cxp wceq cA cX wcel cM cB wcel cG cM cop cga wcel wa cX
      cY cxp cY cM wf cM cdm cX cY cxp wceq cB cG cM cX cY gapmlem.1 gapmlem.2
      gaf cX cY cxp cY cM fdm syl 3adant3 adantr eleq2d anbi2d anbi1d cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cM co vt
      cv wceq vv cv cY wcel wa vv cv vx cv wceq cA cN cfv vt cv cM co vx cv
      wceq cA vv cv cM co vt cv wceq cA vv cv cop cX cY cxp wcel wa cM cB wcel
      cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cM co vt cv
      wceq vv cv cY wcel wa vv cv vx cv wceq wa cA cN cfv vt cv cM co vx cv
      wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv
      cv cM co vt cv wceq vv cv cY wcel wa vv cv vx cv wceq wa wa cA cN cfv vt
      cv cM co vv cv vx cv cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv
      cY wcel wa cA vv cv cM co vt cv wceq vv cv cY wcel wa vv cv vx cv wceq wa
      wa cA vv cv cM co vt cv wceq cA cN cfv vt cv cM co vv cv wceq cM cB wcel
      cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cM co vt cv
      wceq vv cv cY wcel vv cv vx cv wceq simprll cM cB wcel cG cM cop cga wcel
      cA cX wcel vv cv cY wcel vt cv cY wcel w3a cA vv cv cM co vt cv wceq cA
      cN cfv vt cv cM co vv cv wceq wb cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a vt cv cY wcel wa cA vv cv cM co vt cv wceq vv cv cY wcel wa vv cv vx
      cv wceq wa wa cA vv cv vt cv cG cB cM cN cX cY gapmlem.1 gapmlem.2
      gapmlem.3 gacan cM cB wcel cG cM cop cga wcel cA cX wcel w3a cM cB wcel
      vt cv cY wcel cA vv cv cM co vt cv wceq vv cv cY wcel wa vv cv vx cv wceq
      wa cM cB wcel cG cM cop cga wcel cA cX wcel 3simp1 ad2antrr cM cB wcel cG
      cM cop cga wcel cA cX wcel w3a cG cM cop cga wcel vt cv cY wcel cA vv cv
      cM co vt cv wceq vv cv cY wcel wa vv cv vx cv wceq wa cM cB wcel cG cM
      cop cga wcel cA cX wcel 3simp2 ad2antrr cM cB wcel cG cM cop cga wcel cA
      cX wcel w3a vt cv cY wcel wa cA vv cv cM co vt cv wceq vv cv cY wcel wa
      vv cv vx cv wceq wa wa cA cX wcel vv cv cY wcel vt cv cY wcel cM cB wcel
      cG cM cop cga wcel cA cX wcel w3a cA cX wcel vt cv cY wcel cA vv cv cM co
      vt cv wceq vv cv cY wcel wa vv cv vx cv wceq wa cM cB wcel cG cM cop cga
      wcel cA cX wcel 3simp3 ad2antrr cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a vt cv cY wcel wa cA vv cv cM co vt cv wceq vv cv cY wcel vv cv vx cv
      wceq simprlr cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel
      cA vv cv cM co vt cv wceq vv cv cY wcel wa vv cv vx cv wceq wa simplr
      3jca syl3anc mpbid cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY
      wcel wa cA vv cv cM co vt cv wceq vv cv cY wcel wa vv cv vx cv wceq
      simprr eqtrd ex cA vv cv cop cX cY cxp wcel vv cv cY wcel cA vv cv cM co
      vt cv wceq cA vv cv cop cX cY cxp wcel cA cX wcel vv cv cY wcel cA vv cv
      cX cY vv visset opelxp pm3.27bi anim2i sylani sylbid cM cB wcel cG cM cop
      cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cop vt cv cM wbr cA vv
      cv cM co vt cv wceq cA vv cv cop cM cdm wcel cM cB wcel cG cM cop cga
      wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cop vt cv cM wbr cA vv cv
      cop cM cfv vt cv wceq cA vv cv cM co vt cv wceq cM cB wcel cG cM cop cga
      wcel cA cX wcel w3a vt cv cY wcel wa cM wfun cA vv cv cop vt cv cM wbr cA
      vv cv cop cM cfv vt cv wceq wi cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a cM wfun vt cv cY wcel cM cB wcel cG cM cop cga wcel cM wfun cA cX
      wcel cM cB wcel cG cM cop cga wcel wa cX cY cxp cY cM wf cM wfun cB cG cM
      cX cY gapmlem.1 gapmlem.2 gaf cX cY cxp cY cM ffun syl 3adant3 adantr cA
      vv cv cop vt cv cM vt visset funbrfv syl cA vv cv cM co cA vv cv cop cM
      cfv vt cv cA vv cv cM df-opr eqeq1i syl6ibr cA vv cv cop vt cv cM wbr cA
      vv cv cop cM cdm wcel wi cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt
      cv cY wcel wa cA vv cv cop vt cv cM cA vv cv opex breldm a1i jcad cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cop c2nd
      cfv vx cv wceq vv cv vx cv wceq cA vv cv cop vx cv cop c2nd wcel cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA vv cv cop c2nd
      cfv vv cv vx cv cM cB wcel cG cM cop cga wcel cA cX wcel w3a cA vv cv cop
      c2nd cfv vv cv wceq vt cv cY wcel cA cX wcel cM cB wcel cA vv cv cop c2nd
      cfv vv cv wceq cG cM cop cga wcel cA cX wcel vv cv cvv wcel cA vv cv cop
      c2nd cfv vv cv wceq vv visset cA vv cv cX cvv op2ndg mpan2 3ad2ant3
      adantr eqeq1d cvv cvv c2nd wfo cA vv cv cop vx cv cop c2nd wcel cA vv cv
      cop c2nd cfv vx cv wceq wi fo2nd cvv cvv c2nd wfo c2nd wfun cA vv cv cop
      vx cv cop c2nd wcel cA vv cv cop c2nd cfv vx cv wceq wi cvv cvv c2nd
      fofun cA vv cv cop vx cv c2nd vx visset funopfv syl ax-mp syl5bi syl2and
      com12 syl6bi com12 adantrr com12 syl6bi sylbi impcom 19.23aivv com13 mpdi
      vz cv vx cv c2nd cA csn cvv cxp cres wbr vz cv vx cv cop c2nd wcel vz cv
      cA csn cvv cxp wcel wa vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp
      cres wbr vz cv vx cv cop c2nd cA csn cvv cxp cres wcel vz cv vx cv cop
      c2nd wcel vz cv cA csn cvv cxp wcel wa vz cv vx cv c2nd cA csn cvv cxp
      cres df-br vz cv vx cv c2nd cA csn cvv cxp vx visset opelres bitri anbi2i
      syl5ib imp $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}

  ${
    $d t w x y z A $. $d t w x y z B $. $d t w x y z G $. $d t w x y z M $. $d
    t w x y z X $. $d t w x y z Y $.
    gapm.1 $e |- X = ran G $.
    gapm.2 $e |- Y = ran M $.
    gapm.3 $e |- F = ( M o. `' ( 2nd |` ( { A } X. _V ) ) ) $.
    $( The action of a particular group element is a permutation of the base
       set.  (Contributed by Jeff Hankins, 11-Aug-2009.) $)
    gapm $p |- ( ( M e. B /\ <. G , M >. e. GrpAct /\ A e. X ) -> F : Y
    -1-1-onto-> Y ) $=
      cY cY cF wf1o cF cY wfn cF ccnv cY wfn cM cB wcel cG cM cop cga wcel cA
      cX wcel w3a cY cY cF dff1o4 cM cB wcel cG cM cop cga wcel cA cX wcel w3a
      cY cY cF wf cF cY wfn cX cY cxp cY cM wf cA cX wcel cY cY cF wf cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a cX cY cA cY cM cF gapm.3 curry1f
      cM cB wcel cG cM cop cga wcel cX cY cxp cY cM wf cA cX wcel cB cG cM cX
      cY gapm.1 gapm.2 gaf 3adant3 cM cB wcel cG cM cop cga wcel cA cX wcel
      3simp3 sylanc cY cY cF ffn syl cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a c2nd cA csn cvv cxp cres cM ccnv ccom cY wfn cF ccnv cY wfn cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a c2nd cA csn cvv cxp cres cM ccnv
      ccom wfun c2nd cA csn cvv cxp cres cM ccnv ccom cdm cY wceq wa c2nd cA
      csn cvv cxp cres cM ccnv ccom cY wfn cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a c2nd cA csn cvv cxp cres cM ccnv ccom cdm cY wceq c2nd cA csn
      cvv cxp cres cM ccnv ccom wfun cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a c2nd cA csn cvv cxp cres cM ccnv ccom cdm cY wceq c2nd cA csn cvv cxp
      cres cM ccnv ccom wfun cM cB wcel cG cM cop cga wcel cA cX wcel w3a cM
      ccnv ccnv c2nd cA csn cvv cxp cres cdm cima cY c2nd cA csn cvv cxp cres
      cM ccnv ccom cdm cM cB wcel cG cM cop cga wcel cA cX wcel w3a cM ccnv
      ccnv cA csn cvv cxp cima cY cM ccnv ccnv c2nd cA csn cvv cxp cres cdm
      cima cM cB wcel cG cM cop cga wcel cA cX wcel w3a cM ccnv ccnv cA csn cvv
      cxp cima cM cA csn cvv cxp cima cY cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a cM ccnv ccnv cM cA csn cvv cxp cM cB wcel cG cM cop cga wcel cA
      cX wcel w3a cM wrel cM ccnv ccnv cM wceq cM cB wcel cG cM cop cga wcel cA
      cX wcel w3a cX cY cxp cY cM wf cM wrel cM cB wcel cG cM cop cga wcel cX
      cY cxp cY cM wf cA cX wcel cB cG cM cX cY gapm.1 gapm.2 gaf 3adant3 cX cY
      cxp cY cM frel syl cM dfrel2 sylib imaeq1d cM cB wcel cG cM cop cga wcel
      cA cX wcel w3a cM cA csn cvv cxp cima cY cM cA csn cvv cxp cima cY wss cM
      cB wcel cG cM cop cga wcel cA cX wcel w3a cM cA csn cvv cxp cima cM crn
      cY cM cA csn cvv cxp imassrn gapm.2 sseqtr4i a1i cM cB wcel cG cM cop cga
      wcel cA cX wcel w3a vt cY cM cA csn cvv cxp cima cM cB wcel cG cM cop cga
      wcel cA cX wcel w3a vt cv cY wcel vx cv cA csn cvv cxp wcel vx cv vt cv
      cop cM wcel wa vx wex vt cv cM cA csn cvv cxp cima wcel cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel vx cv cA csn cvv cxp wcel vx cv
      vt cv cop cM wcel wa vx wex cA cA cG cgn cfv cfv vt cv cM co cop cA csn
      cvv cxp wcel cA cA cG cgn cfv cfv vt cv cM co cop vt cv cop cM wcel vx cv
      cA csn cvv cxp wcel vx cv vt cv cop cM wcel wa vx wex cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel wa vx cv cA csn cvv cxp wcel vx
      cv vt cv cop cM wcel wa cA cA cG cgn cfv cfv vt cv cM co cop cA csn cvv
      cxp wcel cA cA cG cgn cfv cfv vt cv cM co cop vt cv cop cM wcel wa vx cA
      cA cG cgn cfv cfv vt cv cM co cop cA cA cG cgn cfv cfv vt cv cM co opex
      vx cv cA cA cG cgn cfv cfv vt cv cM co cop wceq vx cv cA csn cvv cxp wcel
      cA cA cG cgn cfv cfv vt cv cM co cop cA csn cvv cxp wcel vx cv vt cv cop
      cM wcel cA cA cG cgn cfv cfv vt cv cM co cop vt cv cop cM wcel vx cv cA
      cA cG cgn cfv cfv vt cv cM co cop cA csn cvv cxp eleq1 vx cv cA cA cG cgn
      cfv cfv vt cv cM co cop wceq vx cv vt cv cop cA cA cG cgn cfv cfv vt cv
      cM co cop vt cv cop cM vx cv cA cA cG cgn cfv cfv vt cv cM co cop vt cv
      opeq1 eleq1d anbi12d cla4ev cA cA csn wcel cA cG cgn cfv cfv vt cv cM co
      cvv wcel cA cA cG cgn cfv cfv vt cv cM co cop cA csn cvv cxp wcel cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cA cG cgn cfv
      cfv vt cv cM co cA csn cvv opelxpi cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a cA cA csn wcel vt cv cY wcel cA cX wcel cM cB wcel cA cA csn
      wcel cG cM cop cga wcel cA cX snidg 3ad2ant3 adantr cA cG cgn cfv cfv vt
      cv cM oprex sylancl cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY
      wcel wa cA cA cG cgn cfv cfv vt cv cM co cop cM cfv vt cv wceq cA cA cG
      cgn cfv cfv vt cv cM co cop vt cv cop cM wcel cM cB wcel cG cM cop cga
      wcel cA cX wcel w3a vt cv cY wcel wa cA cA cG cgn cfv cfv vt cv cM co cM
      co vt cv cA cA cG cgn cfv cfv vt cv cM co cop cM cfv cM cB wcel cG cM cop
      cga wcel cA cX wcel w3a vt cv cY wcel wa cA cA cG cgn cfv cfv vt cv cM co
      cM co vt cv wceq cA cG cgn cfv cfv vt cv cM co cA cG cgn cfv cfv vt cv cM
      co wceq cA cG cgn cfv cfv vt cv cM co eqid cM cB wcel cG cM cop cga wcel
      cA cX wcel cA cG cgn cfv cfv vt cv cM co cY wcel vt cv cY wcel w3a cA cA
      cG cgn cfv cfv vt cv cM co cM co vt cv wceq cA cG cgn cfv cfv vt cv cM co
      cA cG cgn cfv cfv vt cv cM co wceq wb cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a vt cv cY wcel wa cA cA cG cgn cfv cfv vt cv cM co vt cv cG cB cM
      cG cgn cfv cX cY gapm.1 gapm.2 cG cgn cfv eqid gacan cM cB wcel cG cM cop
      cga wcel cA cX wcel vt cv cY wcel 3simpl1 cM cB wcel cG cM cop cga wcel
      cA cX wcel vt cv cY wcel 3simpl2 cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a vt cv cY wcel wa cA cX wcel cA cG cgn cfv cfv vt cv cM co cY wcel vt
      cv cY wcel cM cB wcel cG cM cop cga wcel cA cX wcel vt cv cY wcel 3simpl3
      cX cY cxp cY cM wf cA cG cgn cfv cfv cX wcel vt cv cY wcel cA cG cgn cfv
      cfv vt cv cM co cY wcel cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt
      cv cY wcel wa cA cG cgn cfv cfv vt cv cY cX cY cM foprrn cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a cX cY cxp cY cM wf vt cv cY wcel cM cB wcel
      cG cM cop cga wcel cX cY cxp cY cM wf cA cX wcel cB cG cM cX cY gapm.1
      gapm.2 gaf 3adant3 adantr cM cB wcel cG cM cop cga wcel cA cX wcel w3a cA
      cG cgn cfv cfv cX wcel vt cv cY wcel cM cB wcel cG cM cop cga wcel cA cX
      wcel cA cG cgn cfv cfv cX wcel cG cgr wcel cA cX wcel cA cG cgn cfv cfv
      cX wcel cM cB wcel cG cM cop cga wcel wa cA cG cG cgn cfv cX gapm.1 cG
      cgn cfv eqid grpinvcl cB cG cM gagrp sylan 3impa adantr cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel pm3.27 syl3anc cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel pm3.27 3jca syl3anc mpbiri cA
      cA cG cgn cfv cfv vt cv cM co cM df-opr syl5eqr cM cX cY cxp wfn cA cA cG
      cgn cfv cfv vt cv cM co cop cX cY cxp wcel cA cA cG cgn cfv cfv vt cv cM
      co cop cM cfv vt cv wceq cA cA cG cgn cfv cfv vt cv cM co cop vt cv cop
      cM wcel wb cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa
      cX cY cxp cA cA cG cgn cfv cfv vt cv cM co cop vt cv cM vt visset fnopfvb
      cM cB wcel cG cM cop cga wcel cA cX wcel w3a cM cX cY cxp wfn vt cv cY
      wcel cM cB wcel cG cM cop cga wcel cM cX cY cxp wfn cA cX wcel cM cB wcel
      cG cM cop cga wcel wa cX cY cxp cY cM wf cM cX cY cxp wfn cB cG cM cX cY
      gapm.1 gapm.2 gaf cX cY cxp cY cM ffn syl 3adant3 adantr cA cX wcel cA cG
      cgn cfv cfv vt cv cM co cY wcel cA cA cG cgn cfv cfv vt cv cM co cop cX
      cY cxp wcel cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa
      cA cA cG cgn cfv cfv vt cv cM co cX cY opelxpi cM cB wcel cG cM cop cga
      wcel cA cX wcel vt cv cY wcel 3simpl3 cX cY cxp cY cM wf cA cG cgn cfv
      cfv cX wcel vt cv cY wcel cA cG cgn cfv cfv vt cv cM co cY wcel cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa cA cG cgn cfv cfv
      vt cv cY cX cY cM foprrn cM cB wcel cG cM cop cga wcel cA cX wcel w3a cX
      cY cxp cY cM wf vt cv cY wcel cM cB wcel cG cM cop cga wcel cX cY cxp cY
      cM wf cA cX wcel cB cG cM cX cY gapm.1 gapm.2 gaf 3adant3 adantr cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a cA cG cgn cfv cfv cX wcel vt cv cY
      wcel cM cB wcel cG cM cop cga wcel cA cX wcel cA cG cgn cfv cfv cX wcel
      cG cgr wcel cA cX wcel cA cG cgn cfv cfv cX wcel cM cB wcel cG cM cop cga
      wcel wa cA cG cG cgn cfv cX gapm.1 cG cgn cfv eqid grpinvcl cB cG cM
      gagrp sylan 3impa adantr cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt
      cv cY wcel pm3.27 syl3anc sylanc sylanc mpbid sylanc ex vx vt cv cM cA
      csn cvv cxp vt visset elima3 syl6ibr ssrdv eqssd eqtrd c2nd cA csn cvv
      cxp cres cdm cA csn cvv cxp cM ccnv ccnv c2nd cA csn cvv cxp cres cdm cA
      csn cvv cxp c2nd cdm cin cA csn cvv cxp c2nd cA csn cvv cxp dmres cA csn
      cvv cxp c2nd cdm wss cA csn cvv cxp c2nd cdm cin cA csn cvv cxp wceq cA
      csn cvv cxp cvv c2nd cdm cA csn cvv cxp ssv cvv cvv c2nd wfo c2nd cdm cvv
      wceq fo2nd cvv cvv c2nd wfo c2nd cvv wfn c2nd cdm cvv wceq cvv cvv c2nd
      fofn cvv c2nd fndm syl ax-mp sseqtr4i cA csn cvv cxp c2nd cdm df-ss mpbi
      eqtri imaeq2i syl5eq c2nd cA csn cvv cxp cres cM ccnv dmco syl5eq cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a c2nd cA csn cvv cxp cres cM ccnv
      ccom cdm cY wceq c2nd cA csn cvv cxp cres cM ccnv ccom wrel vt cv vx cv
      c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx wmo vt c2nd cA csn cvv cxp
      cres cM ccnv ccom cdm wral wa c2nd cA csn cvv cxp cres cM ccnv ccom wfun
      cM cB wcel cG cM cop cga wcel cA cX wcel w3a c2nd cA csn cvv cxp cres cM
      ccnv ccom cdm cY wceq c2nd cA csn cvv cxp cres cM ccnv ccom wrel vt cv vx
      cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx wmo vt c2nd cA csn cvv
      cxp cres cM ccnv ccom cdm wral cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a c2nd cA csn cvv cxp cres cM ccnv ccom cdm cY wceq c2nd cA csn cvv cxp
      cres cM ccnv ccom wrel c2nd cA csn cvv cxp cres cM ccnv relco a1i12 c2nd
      cA csn cvv cxp cres cM ccnv ccom cdm cY wceq vt cv vx cv c2nd cA csn cvv
      cxp cres cM ccnv ccom wbr vx wmo vt c2nd cA csn cvv cxp cres cM ccnv ccom
      cdm wral vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx wmo vt
      cY wral cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv vx cv c2nd cA
      csn cvv cxp cres cM ccnv ccom wbr vx wmo vt c2nd cA csn cvv cxp cres cM
      ccnv ccom cdm cY raleq1 cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt
      cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx wmo vt cY cM cB
      wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel vt cv vx cv c2nd cA
      csn cvv cxp cres cM ccnv ccom wbr vt cv vx cv c2nd cA csn cvv cxp cres cM
      ccnv ccom wbr vx vy wsb wa vx cv vy cv wceq wi vy wal vx wal vt cv vx cv
      c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx wmo cM cB wcel cG cM cop cga
      wcel cA cX wcel w3a vt cv cY wcel vt cv vx cv c2nd cA csn cvv cxp cres cM
      ccnv ccom wbr vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx vy
      wsb wa vx cv vy cv wceq wi vy wal vx cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a vt cv cY wcel vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom
      wbr vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx vy wsb wa vx
      cv vy cv wceq wi vy cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY
      wcel vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vt cv vy cv
      c2nd cA csn cvv cxp cres cM ccnv ccom wbr wa vx cv vy cv wceq vt cv vx cv
      c2nd cA csn cvv cxp cres cM ccnv ccom wbr vt cv vx cv c2nd cA csn cvv cxp
      cres cM ccnv ccom wbr vx vy wsb wa cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a vt cv cY wcel vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp
      cres wbr wa vz wex vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp
      cres wbr wa vw wex wa vx cv vy cv wceq wi vt cv vx cv c2nd cA csn cvv cxp
      cres cM ccnv ccom wbr vt cv vy cv c2nd cA csn cvv cxp cres cM ccnv ccom
      wbr wa vx cv vy cv wceq wi vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv
      cxp cres wbr wa vz wex vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp
      cres wbr wa vw wex wa vt cv cY wcel cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a vx cv vy cv wceq vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv
      cxp cres wbr wa vz wex vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp
      cres wbr wa vw wex vt cv cY wcel cM cB wcel cG cM cop cga wcel cA cX wcel
      w3a vx cv vy cv wceq wi wi vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv
      cxp cres wbr wa vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp cres
      wbr wa vw wex vt cv cY wcel cM cB wcel cG cM cop cga wcel cA cX wcel w3a
      vx cv vy cv wceq wi wi wi vz vz cv vt cv cM wbr vz cv vx cv c2nd cA csn
      cvv cxp cres wbr wa vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp
      cres wbr wa vt cv cY wcel cM cB wcel cG cM cop cga wcel cA cX wcel w3a vx
      cv vy cv wceq wi wi vw vt cv cY wcel cM cB wcel cG cM cop cga wcel cA cX
      wcel w3a vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp cres wbr wa
      vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vx cv vy
      cv wceq cM cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel vz cv
      vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp cres wbr wa vw cv vt cv cM
      wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vx cv vy cv wceq wi wi cM
      cB wcel cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa vz cv vt cv cM
      wbr vz cv vx cv c2nd cA csn cvv cxp cres wbr wa cA cG cgn cfv cfv vt cv
      cM co vx cv wceq vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp cres
      wbr wa vx cv vy cv wceq wi cM cB wcel cG cM cop cga wcel cA cX wcel w3a
      vt cv cY wcel wa vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp cres
      wbr wa cA cG cgn cfv cfv vt cv cM co vx cv wceq vx vz vt cA cB cG cM cG
      cgn cfv cX cY gapm.1 gapm.2 cG cgn cfv eqid gapmlem ex cM cB wcel cG cM
      cop cga wcel cA cX wcel w3a vt cv cY wcel wa vw cv vt cv cM wbr vw cv vy
      cv c2nd cA csn cvv cxp cres wbr wa cA cG cgn cfv cfv vt cv cM co vy cv
      wceq cA cG cgn cfv cfv vt cv cM co vx cv wceq vx cv vy cv wceq cM cB wcel
      cG cM cop cga wcel cA cX wcel w3a vt cv cY wcel wa vw cv vt cv cM wbr vw
      cv vy cv c2nd cA csn cvv cxp cres wbr wa cA cG cgn cfv cfv vt cv cM co vy
      cv wceq vy vw vt cA cB cG cM cG cgn cfv cX cY gapm.1 gapm.2 cG cgn cfv
      eqid gapmlem ex cA cG cgn cfv cfv vt cv cM co vy cv wceq vx cv vy cv wceq
      wi vx cv cA cG cgn cfv cfv vt cv cM co vx cv cA cG cgn cfv cfv vt cv cM
      co wceq cA cG cgn cfv cfv vt cv cM co vy cv wceq vx cv vy cv wceq vx cv
      cA cG cgn cfv cfv vt cv cM co vy cv eqtr ex eqcoms syl9 syld expcom com4t
      19.23adv 19.23aiv imp com13 vz cv vt cv cM wbr vz cv vx cv c2nd cA csn
      cvv cxp cres wbr wa vz wex vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv
      cxp cres wbr wa vw wex wa vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv
      ccom wbr vt cv vy cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr wa vx cv
      vy cv wceq vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp cres wbr wa
      vz wex vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vw cv vt cv
      cM wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vw wex vt cv vy cv
      c2nd cA csn cvv cxp cres cM ccnv ccom wbr vt cv vx cv c2nd cA csn cvv cxp
      cres cM ccnv ccom wbr vt cv vz cv cM ccnv wbr vz cv vx cv c2nd cA csn cvv
      cxp cres wbr wa vz wex vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp
      cres wbr wa vz wex vz vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv vt
      visset vx visset brco vt cv vz cv cM ccnv wbr vz cv vx cv c2nd cA csn cvv
      cxp cres wbr wa vz cv vt cv cM wbr vz cv vx cv c2nd cA csn cvv cxp cres
      wbr wa vz vt cv vz cv cM ccnv wbr vz cv vt cv cM wbr vz cv vx cv c2nd cA
      csn cvv cxp cres wbr vt cv vz cv cM vt visset vz visset brcnv anbi1i
      exbii bitr2i vt cv vy cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vt cv
      vw cv cM ccnv wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vw wex vw
      cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vw wex vw vt
      cv vy cv c2nd cA csn cvv cxp cres cM ccnv vt visset vy visset brco vt cv
      vw cv cM ccnv wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vw cv vt cv
      cM wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr wa vw vt cv vw cv cM ccnv
      wbr vw cv vt cv cM wbr vw cv vy cv c2nd cA csn cvv cxp cres wbr vt cv vw
      cv cM vt visset vw visset brcnv anbi1i exbii bitr2i anbi12i imbi1i syl6ib
      vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx vy wsb vt cv vy
      cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vt cv vx cv c2nd cA csn cvv
      cxp cres cM ccnv ccom wbr vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv
      ccom wbr vt cv vy cv c2nd cA csn cvv cxp cres cM ccnv ccom wbr vx vy cv
      vy visset vx cv vy cv vt cv c2nd cA csn cvv cxp cres cM ccnv ccom breq2
      sbcie anbi2i syl7ib 19.21adv 19.21adv vt cv vx cv c2nd cA csn cvv cxp
      cres cM ccnv ccom wbr vx vy vt cv vx cv c2nd cA csn cvv cxp cres cM ccnv
      ccom wbr vy ax-17 mo3 syl6ibr r19.21aiv syl5cbir jcad vt vx c2nd cA csn
      cvv cxp cres cM ccnv ccom dffun7 syl6ibr jcai ancomd c2nd cA csn cvv cxp
      cres cM ccnv ccom cY df-fn sylibr cF ccnv c2nd cA csn cvv cxp cres cM
      ccnv ccom wceq cF ccnv cY wfn c2nd cA csn cvv cxp cres cM ccnv ccom cY
      wfn wb cF ccnv cM c2nd cA csn cvv cxp cres ccnv ccom ccnv c2nd cA csn cvv
      cxp cres ccnv ccnv cM ccnv ccom c2nd cA csn cvv cxp cres cM ccnv ccom cF
      cM c2nd cA csn cvv cxp cres ccnv ccom gapm.3 cnveqi cM c2nd cA csn cvv
      cxp cres ccnv cnvco c2nd cA csn cvv cxp cres cM ccnv cocnvcnv1 3eqtri cY
      cF ccnv c2nd cA csn cvv cxp cres cM ccnv ccom fneq1 ax-mp sylibr sylanbrc
      $.
      $( [17-May-2010] $) $( [11-Aug-2009] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Ring theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ring $.

  $( Extend class notation with the class of all unital rings. $)
  cring $a class Ring $.

  ${
    $d g h x y z $.
    $( Define the class of all unital rings. $)
    df-ring $a |- Ring = { <. g , h >. | ( ( g e. Abel /\ h : ( ran g X. ran g
      ) --> ran g ) /\ ( A. x e. ran g A. y e. ran g A. z e. ran g ( ( ( x h y
       ) h z ) = ( x h ( y h z ) ) /\ ( x h ( y g z ) ) = ( ( x h y ) g ( x h z
          ) ) /\ ( ( x g y ) h z ) = ( ( x h z ) g ( y h z ) ) ) /\ E. x e. ran
            g A. y e. ran g ( ( y h x ) = y /\ ( x h y ) = y ) ) ) } $.
  $}

  ${
    $d g h x y z G $.  $d g h x y z H $.  $d g h x y z X $.
    isring.1 $e |- X = ran G $.
    $( The predicate "is a (unital) ring."  Definition of ring with unit in
       [Schechter] p. 187.  (Contributed by Jeffrey Hankins, 21-Nov-2006.) $)
    isring $p |- ( H e. A -> ( <. G , H >. e. Ring <-> ( ( G e. Abel /\ H : ( X
      X. X ) --> X ) /\ ( A. x e. X A. y e. X A. z e. X ( ( ( x H y ) H z ) = (
        x H ( y H z ) ) /\ ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) /\ ( (
          x G y ) H z ) = ( ( x H z ) G ( y H z ) ) ) /\ E. x e. X A. y e. X (
            ( y H x ) = y /\ ( x H y ) = y ) ) ) ) ) $=
      cH cA wcel cG cH cop cring wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv
      vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz
      cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv
      cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz
      cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH
      co vy cv wceq wa vy cX wral vx cX wrex wa wa cG cvv wcel cH cA wcel wa cG
      cH cop cring wcel cH cA wcel cG cvv wcel cH cA wcel wa cG cH cop cring
      wcel cG cvv wcel cH cA wcel cG cH cop cring wcel cG cH cring wbr cG cvv
      wcel cG cH cring df-br cG cH cring cring wrel vg cv cabl wcel vg cv crn
      vg cv crn cxp vg cv crn vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co
      vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv
      co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg
      cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co
      wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral vy cv vx
      cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn
      wral vx vg cv crn wrex wa wa vg vh copab wrel vg cv cabl wcel vg cv crn
      vg cv crn cxp vg cv crn vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co
      vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv
      co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg
      cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co
      wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral vy cv vx
      cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn
      wral vx vg cv crn wrex wa wa vg vh relopab cring vg cv cabl wcel vg cv
      crn vg cv crn cxp vg cv crn vh cv wf wa vx cv vy cv vh cv co vz cv vh cv
      co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh
      cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv
      vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv
      co wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral vy cv
      vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn
      wral vx vg cv crn wrex wa wa vg vh copab vx vy vz vg vh df-ring releqi
      mpbir brrelexi sylbir anim1i ancoms cH cA wcel cG cabl wcel cX cX cxp cX
      cH wf wa cG cvv wcel cH cA wcel wa vx cv vy cv cH co vz cv cH co vx cv vy
      cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co
      vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH
      co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy
      cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx
      cX wrex wa cH cA wcel cG cabl wcel cG cvv wcel cH cA wcel wa cX cX cxp cX
      cH wf cG cabl wcel cH cA wcel cG cvv wcel cH cA wcel wa cG cabl wcel cG
      cvv wcel cH cA wcel cG cabl elisset anim1i ancoms adantrr adantrr cG cvv
      wcel cH cA wcel wa cG cH cop vg cv cabl wcel vg cv crn vg cv crn cxp vg
      cv crn vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv
      vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh
      cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv
      co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv
      crn wral vy vg cv crn wral vx vg cv crn wral vy cv vx cv vh cv co vy cv
      wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn wral vx vg cv crn
      wrex wa wa vg vh copab wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv vy
      cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv
      cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG
      co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX
      wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
      vy cv wceq wa vy cX wral vx cX wrex wa wa cG cH cop cring wcel vg cv cabl
      wcel vg cv crn vg cv crn cxp vg cv crn vh cv wf wa vx cv vy cv vh cv co
      vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv
      vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq
      vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh
      cv co vg cv co wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn
      wral vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa
      vy vg cv crn wral vx vg cv crn wrex wa wa cG cabl wcel cX cX cxp cX vh cv
      wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh
      cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz
      cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv
      co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX wral
      vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy cX
      wral vx cX wrex wa wa cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH
      co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co
      cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz
      cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy
      cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
      wceq wa vy cX wral vx cX wrex wa wa vg vh cG cH cvv cA vg cv cG wceq vg
      cv cabl wcel vg cv crn vg cv crn cxp vg cv crn vh cv wf wa cG cabl wcel
      cX cX cxp cX vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv
      vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy
      cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv
      vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz
      vg cv crn wral vy vg cv crn wral vx vg cv crn wral vy cv vx cv vh cv co
      vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn wral vx vg cv
      crn wrex wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX
      wral vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa
      vy cX wral vx cX wrex wa vg cv cG wceq vg cv cabl wcel cG cabl wcel vg cv
      crn vg cv crn cxp vg cv crn vh cv wf cX cX cxp cX vh cv wf vg cv cG cabl
      eleq1 vg cv cG wceq vg cv crn cX wceq vg cv crn vg cv crn cxp vg cv crn
      vh cv wf cX cX cxp cX vh cv wf wb vg cv cG wceq vg cv crn cG crn cX vg cv
      cG rneq isring.1 syl6eqr vg cv crn cX wceq vg cv crn vg cv crn cxp vg cv
      crn vh cv wf cX cX cxp vg cv crn vh cv wf cX cX cxp cX vh cv wf vg cv crn
      cX wceq vg cv crn vg cv crn cxp cX cX cxp wceq vg cv crn vg cv crn cxp vg
      cv crn vh cv wf cX cX cxp vg cv crn vh cv wf wb vg cv crn cX wceq vg cv
      crn vg cv crn cxp cX vg cv crn cxp cX cX cxp vg cv crn cX vg cv crn xpeq1
      vg cv crn cX cX xpeq2 eqtrd vg cv crn vg cv crn cxp cX cX cxp vg cv crn
      vh cv feq2 syl vg cv crn cX cX cX cxp vh cv feq3 bitrd syl anbi12d vg cv
      cG wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh
      cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv
      vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz
      cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv crn wral vy
      vg cv crn wral vx vg cv crn wral vx cv vy cv vh cv co vz cv vh cv co vx
      cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx
      cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv
      vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX
      wral vy cX wral vx cX wral vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh
      cv co vy cv wceq wa vy vg cv crn wral vx vg cv crn wrex vy cv vx cv vh cv
      co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx cX wrex vg
      cv cG wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co
      vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv
      vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv crn wral
      vy vg cv crn wral vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv
      vh cv co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv
      co vx cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv
      vz cv vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral
      vx vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isring.1
      syl6eqr vg cv cG wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz
      cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv
      vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh
      cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg
      cv crn wral vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy vg cv crn cX
      vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isring.1 syl6eqr vg cv cG
      wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv
      co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz
      cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vx cv vy cv vh cv co vz
      cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv cG
      co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy
      cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co cG co
      wceq w3a vz vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq
      isring.1 syl6eqr vg cv cG wceq vx cv vy cv vz cv vg cv co vh cv co vx cv
      vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vz cv cG co
      vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv
      vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv
      co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv
      vh cv co cG co wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv
      vh cv co vh cv co wceq vg cv cG wceq vx cv vy cv vz cv vg cv co vh cv co
      vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv
      co vg cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co vg cv cG wceq
      vy cv vz cv vg cv co vy cv vz cv cG co vx cv vh cv vy cv vz cv vg cv cG
      opreq opreq2d vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv cG opreq
      eqeq12d vg cv cG wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vy cv cG
      co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co vx
      cv vz cv vh cv co vy cv vz cv vh cv co cG co vg cv cG wceq vx cv vy cv vg
      cv co vx cv vy cv cG co vz cv vh cv vx cv vy cv vg cv cG opreq opreq1d vx
      cv vz cv vh cv co vy cv vz cv vh cv co vg cv cG opreq eqeq12d 3anbi23d
      raleq12d raleq12d raleq12d vg cv cG wceq vy cv vx cv vh cv co vy cv wceq
      vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn wral vy cv vx cv vh cv co
      vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx vg cv crn cX
      vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isring.1 syl6eqr vg cv cG
      wceq vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa
      vy vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isring.1
      syl6eqr raleq1d rexeq12d anbi12d anbi12d vh cv cH wceq cG cabl wcel cX cX
      cxp cX vh cv wf wa cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv vh cv
      co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz
      cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx
      cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co
      cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv vh cv co vy
      cv wceq vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx cX wrex wa vx cv
      vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz
      cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv
      cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz
      cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH
      co vy cv wceq wa vy cX wral vx cX wrex wa vh cv cH wceq cX cX cxp cX vh
      cv wf cX cX cxp cX cH wf cG cabl wcel cX cX cxp cX vh cv cH feq1 anbi2d
      vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX
      wral vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx
      cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
      vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
      wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv vh cv co vy cv wceq
      vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx cX wrex vy cv vx cv cH
      co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex vh cv
      cH wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh
      cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz
      cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv
      co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vx cv vy cv cH co vz cv
      cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx
      cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co
      vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vx vy cX cX
      vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co wceq w3a vx cv vy cv cH co vz cv cH
      co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv
      vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx
      cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX vh cv cH wceq vx cv
      vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx
      cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv
      vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq
      vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co
      wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh
      cv co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
      cv cH co cG co wceq vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx
      cv vy cv cH co vz cv cH co vx cv vy cv vz cv vh cv co vh cv co vx cv vy
      cv vz cv cH co cH co vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx
      cv vy cv vh cv co vz cv cH co vx cv vy cv cH co vz cv cH co vx cv vy cv
      vh cv co vz cv vh cv cH opreq vh cv cH wceq vx cv vy cv vh cv co vx cv vy
      cv cH co vz cv cH vx cv vy cv vh cv cH opreq opreq1d eqtrd vh cv cH wceq
      vx cv vy cv vz cv vh cv co vh cv co vx cv vy cv vz cv vh cv co cH co vx
      cv vy cv vz cv cH co cH co vx cv vy cv vz cv vh cv co vh cv cH opreq vh
      cv cH wceq vy cv vz cv vh cv co vy cv vz cv cH co vx cv cH vy cv vz cv vh
      cv cH opreq opreq2d eqtrd eqeq12d vh cv cH wceq vx cv vy cv vz cv cG co
      vh cv co vx cv vy cv vz cv cG co cH co vx cv vy cv vh cv co vx cv vz cv
      vh cv co cG co vx cv vy cv cH co vx cv vz cv cH co cG co vx cv vy cv vz
      cv cG co vh cv cH opreq vh cv cH wceq vx cv vy cv vh cv co vx cv vy cv cH
      co vx cv vz cv vh cv co vx cv vz cv cH co cG vx cv vy cv vh cv cH opreq
      vx cv vz cv vh cv cH opreq opreq12d eqeq12d vh cv cH wceq vx cv vy cv cG
      co vz cv vh cv co vx cv vy cv cG co vz cv cH co vx cv vz cv vh cv co vy
      cv vz cv vh cv co cG co vx cv vz cv cH co vy cv vz cv cH co cG co vx cv
      vy cv cG co vz cv vh cv cH opreq vh cv cH wceq vx cv vz cv vh cv co vx cv
      vz cv cH co vy cv vz cv vh cv co vy cv vz cv cH co cG vx cv vz cv vh cv
      cH opreq vy cv vz cv vh cv cH opreq opreq12d eqeq12d 3anbi123d ralbidv
      2ralbidv vh cv cH wceq vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv
      co vy cv wceq wa vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
      wceq wa vx vy cX cX vh cv cH wceq vy cv vx cv vh cv co vy cv wceq vy cv
      vx cv cH co vy cv wceq vx cv vy cv vh cv co vy cv wceq vx cv vy cv cH co
      vy cv wceq vh cv cH wceq vy cv vx cv vh cv co vy cv vx cv cH co vy cv vy
      cv vx cv vh cv cH opreq eqeq1d vh cv cH wceq vx cv vy cv vh cv co vx cv
      vy cv cH co vy cv vx cv vy cv vh cv cH opreq eqeq1d anbi12d rexralbidv
      anbi12d anbi12d opelopabg cring vg cv cabl wcel vg cv crn vg cv crn cxp
      vg cv crn vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz
      cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv
      vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh
      cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg
      cv crn wral vy vg cv crn wral vx vg cv crn wral vy cv vx cv vh cv co vy
      cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn wral vx vg cv crn
      wrex wa wa vg vh copab cG cH cop vx vy vz vg vh df-ring eleq2i syl5bb
      pm5.21nd $.
      $( [22-Nov-2006] $) $( [21-Nov-2006] $)
  $}

  ${
    $d G g h x y z $.  $d H g h x y z $.  $d R g h $.  $d X g h x y z $.
    ringi.1 $e |- G = ( 1st ` R ) $.
    ringi.2 $e |- H = ( 2nd ` R ) $.
    ringi.3 $e |- X = ran G $.
    $( The properties of a unital ring.  (Contributed by Steve Rodriguez,
       8-Sep-2007.) $)
    ringi $p |- ( R e. Ring -> ( ( G e. Abel /\ H : ( X X. X ) --> X ) /\
     ( A. x e. X A. y e. X A. z e. X ( ( ( x H y ) H z ) = ( x H ( y H z ) ) /\
                 ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) /\
                 ( ( x G y ) H z ) = ( ( x H z ) G ( y H z ) ) ) /\
                E. x e. X A. y e. X ( ( y H x ) = y /\ ( x H y ) = y ) ) ) ) $=
      cR cring wcel cR vg cv cabl wcel vg cv crn vg cv crn cxp vg cv crn vh cv
      wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh
      cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv
      vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz
      cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv crn wral vy
      vg cv crn wral vx vg cv crn wral vy cv vx cv vh cv co vy cv wceq vx cv vy
      cv vh cv co vy cv wceq wa vy vg cv crn wral vx vg cv crn wrex wa wa vg vh
      copab wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH
      co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv
      vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx
      cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx
      cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy
      cX wral vx cX wrex wa wa cring vg cv cabl wcel vg cv crn vg cv crn cxp vg
      cv crn vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv
      vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh
      cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv
      co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv
      crn wral vy vg cv crn wral vx vg cv crn wral vy cv vx cv vh cv co vy cv
      wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn wral vx vg cv crn
      wrex wa wa vg vh copab cR vx vy vz vg vh df-ring eleq2i vg cv cabl wcel
      vg cv crn vg cv crn cxp vg cv crn vh cv wf wa vx cv vy cv vh cv co vz cv
      vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv
      co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv
      vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co
      vg cv co wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral
      vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg
      cv crn wral vx vg cv crn wrex wa wa cG cabl wcel cX cX cxp cX vh cv wf wa
      vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co
      wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh
      cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy
      cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv
      vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy cX wral
      vx cX wrex wa wa cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz
      cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co
      vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH
      co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX
      wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq
      wa vy cX wral vx cX wrex wa wa vg vh cR vg cv cR c1st cfv wceq vg cv cG
      wceq vg cv cabl wcel vg cv crn vg cv crn cxp vg cv crn vh cv wf wa vx cv
      vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx
      cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv
      co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co
      vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv crn wral vy vg cv crn
      wral vx vg cv crn wral vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv
      co vy cv wceq wa vy vg cv crn wral vx vg cv crn wrex wa wa cG cabl wcel
      cX cX cxp cX vh cv wf wa vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv
      vz cv vh cv co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv
      vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co
      vx cv vz cv vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX
      wral vx cX wral vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy
      cv wceq wa vy cX wral vx cX wrex wa wa wb cG cR c1st cfv vg cv ringi.1
      eqeq2i vg cv cG wceq vg cv cabl wcel vg cv crn vg cv crn cxp vg cv crn vh
      cv wf wa cG cabl wcel cX cX cxp cX vh cv wf wa vx cv vy cv vh cv co vz cv
      vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv
      co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv
      vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co
      vg cv co wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral
      vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg
      cv crn wral vx vg cv crn wrex wa vx cv vy cv vh cv co vz cv vh cv co vx
      cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx
      cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv
      vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX
      wral vy cX wral vx cX wral vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh
      cv co vy cv wceq wa vy cX wral vx cX wrex wa vg cv cG wceq vg cv cabl
      wcel cG cabl wcel vg cv crn vg cv crn cxp vg cv crn vh cv wf cX cX cxp cX
      vh cv wf vg cv cG cabl eleq1 vg cv cG wceq vg cv crn cX wceq vg cv crn vg
      cv crn cxp vg cv crn vh cv wf cX cX cxp cX vh cv wf wb vg cv cG wceq vg
      cv crn cG crn cX vg cv cG rneq ringi.3 syl6eqr vg cv crn cX wceq vg cv
      crn vg cv crn cxp vg cv crn vh cv wf cX cX cxp vg cv crn vh cv wf cX cX
      cxp cX vh cv wf vg cv crn cX wceq vg cv crn vg cv crn cxp cX cX cxp wceq
      vg cv crn vg cv crn cxp vg cv crn vh cv wf cX cX cxp vg cv crn vh cv wf
      wb vg cv crn cX wceq vg cv crn vg cv crn cxp cX vg cv crn cxp cX cX cxp
      vg cv crn cX vg cv crn xpeq1 vg cv crn cX cX xpeq2 eqtrd vg cv crn vg cv
      crn cxp cX cX cxp vg cv crn vh cv feq2 syl vg cv crn cX cX cX cxp vh cv
      feq3 bitrd syl anbi12d vg cv cG wceq vx cv vy cv vh cv co vz cv vh cv co
      vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv
      co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg
      cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co
      wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral vx cv vy
      cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv
      vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG
      co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv
      vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv vh
      cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv crn wral vx
      vg cv crn wrex vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv
      wceq wa vy cX wral vx cX wrex vg cv cG wceq vx cv vy cv vh cv co vz cv vh
      cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co
      vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy
      cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg
      cv co wceq w3a vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral vx
      cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq
      vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh
      cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv
      co vy cv vz cv vh cv co vg cv co wceq w3a vz cX wral vy cX wral vx cX
      wral vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv
      co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv
      vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co
      vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX wral vg
      cv cG wceq vg cv crn cX wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy
      cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv
      vy cv vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz
      cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a
      vz vg cv crn wral vy vg cv crn wral vx vg cv crn wral vx cv vy cv vh cv
      co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz
      cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co
      wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv
      vh cv co vg cv co wceq w3a vz cX wral vy cX wral vx cX wral wb vg cv cG
      wceq vg cv crn cG crn cX vg cv cG rneq ringi.3 syl6eqr vx cv vy cv vh cv
      co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz
      cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv co
      wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv
      vh cv co vg cv co wceq w3a vz vg cv crn wral vy vg cv crn wral vx cv vy
      cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv
      vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co
      vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy
      cv vz cv vh cv co vg cv co wceq w3a vz cX wral vy cX wral vx vg cv crn cX
      vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co
      wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv
      vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh
      cv co vy cv vz cv vh cv co vg cv co wceq w3a vz vg cv crn wral vx cv vy
      cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv
      vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co
      vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy
      cv vz cv vh cv co vg cv co wceq w3a vz cX wral vy vg cv crn cX vx cv vy
      cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv
      vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co
      vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv co vy
      cv vz cv vh cv co vg cv co wceq w3a vz vg cv crn cX raleq1 raleqd raleqd
      syl vg cv cG wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv
      vh cv co vh cv co wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh
      cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv
      co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq w3a vz cX wral
      vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co
      wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh
      cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy
      cv vz cv vh cv co cG co wceq w3a vz cX wral vx vy cX cX vg cv cG wceq vx
      cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq
      vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv vh cv co vx cv vz cv vh
      cv co vg cv co wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vz cv vh cv
      co vy cv vz cv vh cv co vg cv co wceq w3a vx cv vy cv vh cv co vz cv vh
      cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv cG co vh
      cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv cG
      co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co cG co wceq
      w3a vz cX vg cv cG wceq vx cv vy cv vz cv vg cv co vh cv co vx cv vy cv
      vh cv co vx cv vz cv vh cv co vg cv co wceq vx cv vy cv vz cv cG co vh cv
      co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv vg cv
      co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co wceq
      vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv
      co cG co wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vg cv cG wceq vx cv vy cv vz cv vg cv co vh cv co vx cv
      vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co vg
      cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co vg cv cG wceq vy cv
      vz cv vg cv co vy cv vz cv cG co vx cv vh cv vy cv vz cv vg cv cG opreq
      opreq2d vx cv vy cv vh cv co vx cv vz cv vh cv co vg cv cG opreq eqeq12d
      vg cv cG wceq vx cv vy cv vg cv co vz cv vh cv co vx cv vy cv cG co vz cv
      vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co vg cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co vg cv cG wceq vx cv vy cv vg cv co vx
      cv vy cv cG co vz cv vh cv vx cv vy cv vg cv cG opreq opreq1d vx cv vz cv
      vh cv co vy cv vz cv vh cv co vg cv cG opreq eqeq12d 3anbi23d ralbidv
      2ralbidv bitrd vg cv cG wceq vy cv vx cv vh cv co vy cv wceq vx cv vy cv
      vh cv co vy cv wceq wa vy vg cv crn wral vy cv vx cv vh cv co vy cv wceq
      vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx vg cv crn cX vg cv cG
      wceq vg cv crn cG crn cX vg cv cG rneq ringi.3 syl6eqr vg cv cG wceq vy
      cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv co vy cv wceq wa vy vg cv
      crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq ringi.3 syl6eqr
      raleq1d rexeq12d anbi12d anbi12d sylbir vh cv cR c2nd cfv wceq vh cv cH
      wceq cG cabl wcel cX cX cxp cX vh cv wf wa vx cv vy cv vh cv co vz cv vh
      cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz cv cG co vh
      cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx cv vy cv cG
      co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co cG co wceq
      w3a vz cX wral vy cX wral vx cX wral vy cv vx cv vh cv co vy cv wceq vx
      cv vy cv vh cv co vy cv wceq wa vy cX wral vx cX wrex wa wa cG cabl wcel
      cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH
      co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv
      cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
      cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH
      co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa wa
      wb cH cR c2nd cfv vh cv ringi.2 eqeq2i vh cv cH wceq cG cabl wcel cX cX
      cxp cX vh cv wf wa cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv vh cv
      co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx cv vy cv vz
      cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq vx
      cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh cv co
      cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv vh cv co vy
      cv wceq vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx cX wrex wa vx cv
      vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz
      cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv
      cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz
      cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH
      co vy cv wceq wa vy cX wral vx cX wrex wa vh cv cH wceq cX cX cxp cX vh
      cv wf cX cX cxp cX cH wf cG cabl wcel cX cX cxp cX vh cv cH feq1 anbi2d
      vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vy cX wral vx cX
      wral vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx
      cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
      vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
      wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv vh cv co vy cv wceq
      vx cv vy cv vh cv co vy cv wceq wa vy cX wral vx cX wrex vy cv vx cv cH
      co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex vh cv
      cH wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh
      cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz
      cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv
      co vy cv vz cv vh cv co cG co wceq w3a vz cX wral vx cv vy cv cH co vz cv
      cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx
      cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co
      vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vx vy cX cX
      vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv
      co vh cv co wceq vx cv vy cv vz cv cG co vh cv co vx cv vy cv vh cv co vx
      cv vz cv vh cv co cG co wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv
      vh cv co vy cv vz cv vh cv co cG co wceq w3a vx cv vy cv cH co vz cv cH
      co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv
      vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx
      cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX vh cv cH wceq vx cv
      vy cv vh cv co vz cv vh cv co vx cv vy cv vz cv vh cv co vh cv co wceq vx
      cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv
      vz cv cG co vh cv co vx cv vy cv vh cv co vx cv vz cv vh cv co cG co wceq
      vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co
      wceq vx cv vy cv cG co vz cv vh cv co vx cv vz cv vh cv co vy cv vz cv vh
      cv co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
      cv cH co cG co wceq vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx
      cv vy cv cH co vz cv cH co vx cv vy cv vz cv vh cv co vh cv co vx cv vy
      cv vz cv cH co cH co vh cv cH wceq vx cv vy cv vh cv co vz cv vh cv co vx
      cv vy cv vh cv co vz cv cH co vx cv vy cv cH co vz cv cH co vx cv vy cv
      vh cv co vz cv vh cv cH opreq vh cv cH wceq vx cv vy cv vh cv co vx cv vy
      cv cH co vz cv cH vx cv vy cv vh cv cH opreq opreq1d eqtrd vh cv cH wceq
      vx cv vy cv vz cv vh cv co vh cv co vx cv vy cv vz cv vh cv co cH co vx
      cv vy cv vz cv cH co cH co vx cv vy cv vz cv vh cv co vh cv cH opreq vh
      cv cH wceq vy cv vz cv vh cv co vy cv vz cv cH co vx cv cH vy cv vz cv vh
      cv cH opreq opreq2d eqtrd eqeq12d vh cv cH wceq vx cv vy cv vz cv cG co
      vh cv co vx cv vy cv vz cv cG co cH co vx cv vy cv vh cv co vx cv vz cv
      vh cv co cG co vx cv vy cv cH co vx cv vz cv cH co cG co vx cv vy cv vz
      cv cG co vh cv cH opreq vh cv cH wceq vx cv vy cv vh cv co vx cv vy cv cH
      co vx cv vz cv vh cv co vx cv vz cv cH co cG vx cv vy cv vh cv cH opreq
      vx cv vz cv vh cv cH opreq opreq12d eqeq12d vh cv cH wceq vx cv vy cv cG
      co vz cv vh cv co vx cv vy cv cG co vz cv cH co vx cv vz cv vh cv co vy
      cv vz cv vh cv co cG co vx cv vz cv cH co vy cv vz cv cH co cG co vx cv
      vy cv cG co vz cv vh cv cH opreq vh cv cH wceq vx cv vz cv vh cv co vx cv
      vz cv cH co vy cv vz cv vh cv co vy cv vz cv cH co cG vx cv vz cv vh cv
      cH opreq vy cv vz cv vh cv cH opreq opreq12d eqeq12d 3anbi123d ralbidv
      2ralbidv vh cv cH wceq vy cv vx cv vh cv co vy cv wceq vx cv vy cv vh cv
      co vy cv wceq wa vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
      wceq wa vx vy cX cX vh cv cH wceq vy cv vx cv vh cv co vy cv wceq vy cv
      vx cv cH co vy cv wceq vx cv vy cv vh cv co vy cv wceq vx cv vy cv cH co
      vy cv wceq vh cv cH wceq vy cv vx cv vh cv co vy cv vx cv cH co vy cv vy
      cv vx cv vh cv cH opreq eqeq1d vh cv cH wceq vx cv vy cv vh cv co vx cv
      vy cv cH co vy cv vx cv vy cv vh cv cH opreq eqeq1d anbi12d rexralbidv
      anbi12d anbi12d sylbir elopabi sylbi $.
      $( [14-Sep-2007] $) $( [8-Sep-2007] $)
  $}

  ${
    $d G x y z $.  $d H x y z $.  $d X x y z $.
    ringsm.1 $e |- G = ( 1st ` R ) $.
    ringsm.2 $e |- H = ( 2nd ` R ) $.
    ringsm.3 $e |- X = ran G $.
    $( Functionality of the multiplication operation of a ring.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.) $)
    ringsm $p |- ( R e. Ring -> H : ( X X. X ) --> X ) $=
      cR cring wcel cG cabl wcel cX cX cxp cX cH wf cR cring wcel cG cabl wcel
      cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH
      co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv
      cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
      cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH
      co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa vx
      vy vz cR cG cH cX ringsm.1 ringsm.2 ringsm.3 ringi pm3.26d pm3.27d $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    ringcl.1 $e |- G = ( 1st ` R ) $.
    ringcl.2 $e |- H = ( 2nd ` R ) $.
    ringcl.3 $e |- X = ran G $.
    $( Closure of the multiplication operation of a ring.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.) $)
    ringcl $p |- ( ( R e. Ring /\ A e. X /\ B e. X ) -> ( A H B ) e. X ) $=
      cX cX cxp cX cH wf cA cX wcel cB cX wcel cA cB cH co cX wcel cR cring
      wcel cA cB cX cX cX cH foprrn cR cG cH cX ringcl.1 ringcl.2 ringcl.3
      ringsm syl3an1 $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    $d A u x $.  $d G u x y $.  $d H u w x y $.  $d R x $.  $d X w u x y $.
    ringid.1 $e |- G = ( 1st ` R ) $.
    ringid.2 $e |- H = ( 2nd ` R ) $.
    ringid.3 $e |- X = ran G $.
    $( The multiplication operation of a unital ring has (one or more) identity
       elements.  (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ringid $p |- ( ( R e. Ring /\ A e. X ) ->
                 E. u e. X ( ( A H u ) = A /\ ( u H A ) = A ) ) $=
      cA cX wcel cR cring wcel cA vu cv cH co cA wceq vu cv cA cH co cA wceq wa
      vu cX wrex cR cring wcel vx cv vu cv cH co vx cv wceq vu cv vx cv cH co
      vx cv wceq wa vu cX wrex wi cR cring wcel cA vu cv cH co cA wceq vu cv cA
      cH co cA wceq wa vu cX wrex wi vx cA cX vx cv cA wceq vx cv vu cv cH co
      vx cv wceq vu cv vx cv cH co vx cv wceq wa vu cX wrex cA vu cv cH co cA
      wceq vu cv cA cH co cA wceq wa vu cX wrex cR cring wcel vx cv cA wceq vx
      cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa cA vu cv cH co
      cA wceq vu cv cA cH co cA wceq wa vu cX vx cv cA wceq vx cv vu cv cH co
      vx cv wceq cA vu cv cH co cA wceq vu cv vx cv cH co vx cv wceq vu cv cA
      cH co cA wceq vx cv cA wceq vx cv vu cv cH co cA vu cv cH co vx cv cA vx
      cv cA vu cv cH opreq1 vx cv cA wceq id eqeq12d vx cv cA wceq vu cv vx cv
      cH co vu cv cA cH co vx cv cA vx cv cA vu cv cH opreq2 vx cv cA wceq id
      eqeq12d anbi12d rexbidv imbi2d cR cring wcel vx cv cX wcel vx cv vu cv cH
      co vx cv wceq vu cv vx cv cH co vx cv wceq wa vu cX wrex cR cring wcel vx
      cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa vx cX wral vu
      cX wrex vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa vu
      cX wrex vx cX wral vx cv cX wcel vx cv vu cv cH co vx cv wceq vu cv vx cv
      cH co vx cv wceq wa vu cX wrex wi cR cring wcel vu cv vx cv cH co vy cv
      cH co vu cv vx cv vy cv cH co cH co wceq vu cv vx cv vy cv cG co cH co vu
      cv vx cv cH co vu cv vy cv cH co cG co wceq vu cv vx cv cG co vy cv cH co
      vu cv vy cv cH co vx cv vy cv cH co cG co wceq w3a vy cX wral vx cX wral
      vu cX wral vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa
      vx cX wral vu cX wrex cR cring wcel cG cabl wcel cX cX cxp cX cH wf wa vu
      cv vx cv cH co vy cv cH co vu cv vx cv vy cv cH co cH co wceq vu cv vx cv
      vy cv cG co cH co vu cv vx cv cH co vu cv vy cv cH co cG co wceq vu cv vx
      cv cG co vy cv cH co vu cv vy cv cH co vx cv vy cv cH co cG co wceq w3a
      vy cX wral vx cX wral vu cX wral vx cv vu cv cH co vx cv wceq vu cv vx cv
      cH co vx cv wceq wa vx cX wral vu cX wrex wa vu vx vy cR cG cH cX
      ringid.1 ringid.2 ringid.3 ringi pm3.27d pm3.27d vx cv vu cv cH co vx cv
      wceq vu cv vx cv cH co vx cv wceq wa vu vx cX cX r19.12 vx cv vu cv cH co
      vx cv wceq vu cv vx cv cH co vx cv wceq wa vu cX wrex vx cX ra4 3syl
      com12 vtoclga impcom $.
      $( [14-Sep-2007] $) $( [8-Sep-2007] $)

    $( The unit element of a ring is unique. $)
    ringideu $p |- ( R e. Ring ->
                 E! u e. X A. x e. X ( ( x H u ) = x /\ ( u H x ) = x ) ) $=
      cR cring wcel vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq
      wa vx cX wral vu cX wrex vx cv vu cv cH co vx cv wceq vu cv vx cv cH co
      vx cv wceq wa vx cX wral vx cv vw cv cH co vx cv wceq vw cv vx cv cH co
      vx cv wceq wa vx cX wral wa vu cv vw cv wceq wi vw cX wral vu cX wral wa
      vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa vx cX wral
      vu cX wreu cR cring wcel vx cv vu cv cH co vx cv wceq vu cv vx cv cH co
      vx cv wceq wa vx cX wral vu cX wrex vx cv vu cv cH co vx cv wceq vu cv vx
      cv cH co vx cv wceq wa vx cX wral vx cv vw cv cH co vx cv wceq vw cv vx
      cv cH co vx cv wceq wa vx cX wral wa vu cv vw cv wceq wi vw cX wral vu cX
      wral cR cring wcel cG cabl wcel cX cX cxp cX cH wf wa vu cv vx cv cH co
      vy cv cH co vu cv vx cv vy cv cH co cH co wceq vu cv vx cv vy cv cG co cH
      co vu cv vx cv cH co vu cv vy cv cH co cG co wceq vu cv vx cv cG co vy cv
      cH co vu cv vy cv cH co vx cv vy cv cH co cG co wceq w3a vy cX wral vx cX
      wral vu cX wral vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq
      wa vx cX wral vu cX wrex wa wa vx cv vu cv cH co vx cv wceq vu cv vx cv
      cH co vx cv wceq wa vx cX wral vu cX wrex vu vx vy cR cG cH cX ringid.1
      ringid.2 ringid.3 ringi cG cabl wcel cX cX cxp cX cH wf wa vu cv vx cv cH
      co vy cv cH co vu cv vx cv vy cv cH co cH co wceq vu cv vx cv vy cv cG co
      cH co vu cv vx cv cH co vu cv vy cv cH co cG co wceq vu cv vx cv cG co vy
      cv cH co vu cv vy cv cH co vx cv vy cv cH co cG co wceq w3a vy cX wral vx
      cX wral vu cX wral vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv
      wceq wa vx cX wral vu cX wrex simprr syl vx cv vu cv cH co vx cv wceq vu
      cv vx cv cH co vx cv wceq wa vx cX wral vx cv vw cv cH co vx cv wceq vw
      cv vx cv cH co vx cv wceq wa vx cX wral wa vu cv vw cv wceq wi vu vw cX
      vw cv cX wcel vu cv cX wcel vx cv vu cv cH co vx cv wceq vu cv vx cv cH
      co vx cv wceq wa vx cX wral vx cv vw cv cH co vx cv wceq vw cv vx cv cH
      co vx cv wceq wa vx cX wral wa vu cv vw cv wceq wi vw cv cX wcel vu cv cX
      wcel wa vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa vx
      cX wral vx cv vw cv cH co vx cv wceq vw cv vx cv cH co vx cv wceq wa vx
      cX wral wa vw cv vu cv cH co vw cv wceq vw cv vu cv cH co vu cv wceq wa
      vu cv vw cv wceq vw cv cX wcel vx cv vu cv cH co vx cv wceq vu cv vx cv
      cH co vx cv wceq wa vx cX wral vw cv vu cv cH co vw cv wceq vu cv cX wcel
      vx cv vw cv cH co vx cv wceq vw cv vx cv cH co vx cv wceq wa vx cX wral
      vw cv vu cv cH co vu cv wceq vw cv cX wcel vx cv vu cv cH co vx cv wceq
      vx cX wral vw cv vu cv cH co vw cv wceq vx cv vu cv cH co vx cv wceq vu
      cv vx cv cH co vx cv wceq wa vx cX wral vx cv vu cv cH co vx cv wceq vw
      cv vu cv cH co vw cv wceq vx vw cv cX vx cv vw cv wceq vx cv vu cv cH co
      vw cv vu cv cH co vx cv vw cv vx cv vw cv vu cv cH opreq1 vx cv vw cv
      wceq id eqeq12d rcla4v vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx
      cv wceq wa vx cv vu cv cH co vx cv wceq vx cX vx cv vu cv cH co vx cv
      wceq vu cv vx cv cH co vx cv wceq pm3.26 r19.20si syl5 vu cv cX wcel vw
      cv vx cv cH co vx cv wceq vx cX wral vw cv vu cv cH co vu cv wceq vx cv
      vw cv cH co vx cv wceq vw cv vx cv cH co vx cv wceq wa vx cX wral vw cv
      vx cv cH co vx cv wceq vw cv vu cv cH co vu cv wceq vx vu cv cX vx cv vu
      cv wceq vw cv vx cv cH co vw cv vu cv cH co vx cv vu cv vx cv vu cv vw cv
      cH opreq2 vx cv vu cv wceq id eqeq12d rcla4v vx cv vw cv cH co vx cv wceq
      vw cv vx cv cH co vx cv wceq wa vw cv vx cv cH co vx cv wceq vx cX vx cv
      vw cv cH co vx cv wceq vw cv vx cv cH co vx cv wceq pm3.27 r19.20si syl5
      im2anan9 vw cv vu cv cH co vu cv wceq vw cv vu cv cH co vw cv wceq vu cv
      vw cv wceq vw cv vu cv cH co vu cv vw cv eqtr2 ancoms syl6 ancoms rgen2a
      jctir vx cv vu cv cH co vx cv wceq vu cv vx cv cH co vx cv wceq wa vx cX
      wral vx cv vw cv cH co vx cv wceq vw cv vx cv cH co vx cv wceq wa vx cX
      wral vu vw cX vu cv vw cv wceq vx cv vu cv cH co vx cv wceq vu cv vx cv
      cH co vx cv wceq wa vx cv vw cv cH co vx cv wceq vw cv vx cv cH co vx cv
      wceq wa vx cX vu cv vw cv wceq vx cv vu cv cH co vx cv wceq vx cv vw cv
      cH co vx cv wceq vu cv vx cv cH co vx cv wceq vw cv vx cv cH co vx cv
      wceq vu cv vw cv wceq vx cv vu cv cH co vx cv vw cv cH co vx cv vu cv vw
      cv vx cv cH opreq2 eqeq1d vu cv vw cv wceq vu cv vx cv cH co vw cv vx cv
      cH co vx cv vu cv vw cv vx cv cH opreq1 eqeq1d anbi12d ralbidv reu4
      sylibr $.
      $( [5-Apr-2009] $) $( [4-Apr-2009] $)
  $}

  ${
    $d A x y z $.  $d B y z $.  $d C z $.  $d G x y z $.  $d H x y z $.
    $d X x y z $.
    ringdi.1 $e |- G = ( 1st ` R ) $.
    ringdi.2 $e |- H = ( 2nd ` R ) $.
    ringdi.3 $e |- X = ran G $.
    $( Distributive law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ringdi $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                     ( A H ( B G C ) ) = ( ( A H B ) G ( A H C ) ) ) $=
      cA cX wcel cB cX wcel cC cX wcel w3a cR cring wcel cA cB cC cG co cH co
      cA cB cH co cA cC cH co cG co wceq cA cX wcel cB cX wcel cC cX wcel w3a
      vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
      cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv
      vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq
      w3a vz cX wral vy cX wral vx cX wral cA cB cC cG co cH co cA cB cH co cA
      cC cH co cG co wceq cR cring wcel cA cX wcel cB cX wcel cC cX wcel w3a vx
      cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
      vz cX wral vy cX wral vx cX wral cA cB cC cG co cH co cA cB cH co cA cC
      cH co cG co wceq vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
      co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co
      cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH
      co cG co wceq w3a vz cX wral vy cX wral vx cX wral vx cv vy cv vz cv cG
      co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq cA cB cC cG co cH
      co cA cB cH co cA cC cH co cG co wceq cA vy cv vz cv cG co cH co cA vy cv
      cH co cA vz cv cH co cG co wceq cA cB vz cv cG co cH co cA cB cH co cA vz
      cv cH co cG co wceq vx vy vz cA cB cC cX cX cX vx cv cA wceq vx cv vy cv
      vz cv cG co cH co cA vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz
      cv cH co cG co cA vy cv cH co cA vz cv cH co cG co vx cv cA vy cv vz cv
      cG co cH opreq1 vx cv cA wceq vx cv vy cv cH co cA vy cv cH co vx cv vz
      cv cH co cA vz cv cH co cG vx cv cA vy cv cH opreq1 vx cv cA vz cv cH
      opreq1 opreq12d eqeq12d vy cv cB wceq cA vy cv vz cv cG co cH co cA cB vz
      cv cG co cH co cA vy cv cH co cA vz cv cH co cG co cA cB cH co cA vz cv
      cH co cG co vy cv cB wceq vy cv vz cv cG co cB vz cv cG co cA cH vy cv cB
      vz cv cG opreq1 opreq2d vy cv cB wceq cA vy cv cH co cA cB cH co cA vz cv
      cH co cG vy cv cB cA cH opreq2 opreq1d eqeq12d vz cv cC wceq cA cB vz cv
      cG co cH co cA cB cC cG co cH co cA cB cH co cA vz cv cH co cG co cA cB
      cH co cA cC cH co cG co vz cv cC wceq cB vz cv cG co cB cC cG co cA cH vz
      cv cC cB cG opreq2 opreq2d vz cv cC wceq cA vz cv cH co cA cC cH co cA cB
      cH co cG vz cv cC cA cH opreq2 opreq2d eqeq12d rcla43v vx cv vy cv cH co
      vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH
      co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv
      cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX
      wral vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG
      co wceq vz cX wral vy cX wral vx cX vx cv vy cv cH co vz cv cH co vx cv
      vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH
      co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv
      cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vx cv vy cv vz cv cG co
      cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vz cX wral vy cX vx
      cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv
      vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy
      cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a
      vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co
      wceq vz cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co
      wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG
      co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co
      cG co wceq 3simp2 r19.20si r19.20si r19.20si syl5 cR cring wcel vx cv vy
      cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv
      cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG
      co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX
      wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
      vy cv wceq wa vy cX wral vx cX wrex cR cring wcel cG cabl wcel cX cX cxp
      cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co
      wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG
      co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co
      cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv
      wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa vx vy vz cR
      cG cH cX ringdi.1 ringdi.2 ringdi.3 ringi pm3.27d pm3.26d syl5 impcom $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( Distributive law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ringdir $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                      ( ( A G B ) H C ) = ( ( A H C ) G ( B H C ) ) ) $=
      cA cX wcel cB cX wcel cC cX wcel w3a cR cring wcel cA cB cG co cC cH co
      cA cC cH co cB cC cH co cG co wceq cA cX wcel cB cX wcel cC cX wcel w3a
      vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
      cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv
      vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq
      w3a vz cX wral vy cX wral vx cX wral cA cB cG co cC cH co cA cC cH co cB
      cC cH co cG co wceq cR cring wcel cA cX wcel cB cX wcel cC cX wcel w3a vx
      cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq
      vz cX wral vy cX wral vx cX wral cA cB cG co cC cH co cA cC cH co cB cC
      cH co cG co wceq vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
      co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co
      cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH
      co cG co wceq w3a vz cX wral vy cX wral vx cX wral vx cv vy cv cG co vz
      cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq cA cB cG co cC cH
      co cA cC cH co cB cC cH co cG co wceq cA vy cv cG co vz cv cH co cA vz cv
      cH co vy cv vz cv cH co cG co wceq cA cB cG co vz cv cH co cA vz cv cH co
      cB vz cv cH co cG co wceq vx vy vz cA cB cC cX cX cX vx cv cA wceq vx cv
      vy cv cG co vz cv cH co cA vy cv cG co vz cv cH co vx cv vz cv cH co vy
      cv vz cv cH co cG co cA vz cv cH co vy cv vz cv cH co cG co vx cv cA wceq
      vx cv vy cv cG co cA vy cv cG co vz cv cH vx cv cA vy cv cG opreq1
      opreq1d vx cv cA wceq vx cv vz cv cH co cA vz cv cH co vy cv vz cv cH co
      cG vx cv cA vz cv cH opreq1 opreq1d eqeq12d vy cv cB wceq cA vy cv cG co
      vz cv cH co cA cB cG co vz cv cH co cA vz cv cH co vy cv vz cv cH co cG
      co cA vz cv cH co cB vz cv cH co cG co vy cv cB wceq cA vy cv cG co cA cB
      cG co vz cv cH vy cv cB cA cG opreq2 opreq1d vy cv cB wceq vy cv vz cv cH
      co cB vz cv cH co cA vz cv cH co cG vy cv cB vz cv cH opreq1 opreq2d
      eqeq12d vz cv cC wceq cA cB cG co vz cv cH co cA cB cG co cC cH co cA vz
      cv cH co cB vz cv cH co cG co cA cC cH co cB cC cH co cG co vz cv cC cA
      cB cG co cH opreq2 vz cv cC wceq cA vz cv cH co cA cC cH co cB vz cv cH
      co cB cC cH co cG vz cv cC cA cH opreq2 vz cv cC cB cH opreq2 opreq12d
      eqeq12d rcla43v vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
      co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co
      cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH
      co cG co wceq w3a vz cX wral vy cX wral vx cv vy cv cG co vz cv cH co vx
      cv vz cv cH co vy cv vz cv cH co cG co wceq vz cX wral vy cX wral vx cX
      vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
      cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv
      vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq
      w3a vz cX wral vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
      cv cH co cG co wceq vz cX wral vy cX vx cv vy cv cH co vz cv cH co vx cv
      vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH
      co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv
      cH co vy cv vz cv cH co cG co wceq w3a vx cv vy cv cG co vz cv cH co vx
      cv vz cv cH co vy cv vz cv cH co cG co wceq vz cX vx cv vy cv cH co vz cv
      cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx
      cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co
      vx cv vz cv cH co vy cv vz cv cH co cG co wceq 3simp3 r19.20si r19.20si
      r19.20si syl5 cR cring wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz
      cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv
      vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy
      cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx
      cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex
      cR cring wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv
      cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx
      cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co
      vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral
      vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa
      vy cX wral vx cX wrex wa vx vy vz cR cG cH cX ringdi.1 ringdi.2 ringdi.3
      ringi pm3.27d pm3.26d syl5 impcom $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( Associative law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ringass $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                      ( ( A H B ) H C ) = ( A H ( B H C ) ) ) $=
      cA cX wcel cB cX wcel cC cX wcel w3a cR cring wcel cA cB cH co cC cH co
      cA cB cC cH co cH co wceq cA cX wcel cB cX wcel cC cX wcel w3a vx cv vy
      cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cX wral vy cX
      wral vx cX wral cA cB cH co cC cH co cA cB cC cH co cH co wceq cR cring
      wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq cA
      cB cH co cC cH co cA cB cC cH co cH co wceq cA vy cv cH co vz cv cH co cA
      vy cv vz cv cH co cH co wceq cA cB cH co vz cv cH co cA cB vz cv cH co cH
      co wceq vx vy vz cA cB cC cX cX cX vx cv cA wceq vx cv vy cv cH co vz cv
      cH co cA vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co cA vy cv
      vz cv cH co cH co vx cv cA wceq vx cv vy cv cH co cA vy cv cH co vz cv cH
      vx cv cA vy cv cH opreq1 opreq1d vx cv cA vy cv vz cv cH co cH opreq1
      eqeq12d vy cv cB wceq cA vy cv cH co vz cv cH co cA cB cH co vz cv cH co
      cA vy cv vz cv cH co cH co cA cB vz cv cH co cH co vy cv cB wceq cA vy cv
      cH co cA cB cH co vz cv cH vy cv cB cA cH opreq2 opreq1d vy cv cB wceq vy
      cv vz cv cH co cB vz cv cH co cA cH vy cv cB vz cv cH opreq1 opreq2d
      eqeq12d vz cv cC wceq cA cB cH co vz cv cH co cA cB cH co cC cH co cA cB
      vz cv cH co cH co cA cB cC cH co cH co vz cv cC cA cB cH co cH opreq2 vz
      cv cC wceq cB vz cv cH co cB cC cH co cA cH vz cv cC cB cH opreq2 opreq2d
      eqeq12d rcla43v cR cring wcel vx cv vy cv cH co vz cv cH co vx cv vy cv
      vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx
      cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co
      vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vx cv
      vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cX wral vy
      cX wral vx cX wral cR cring wcel vx cv vy cv cH co vz cv cH co vx cv vy
      cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co
      vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH
      co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy
      cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx
      cX wrex cR cring wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH
      co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co
      cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz
      cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy
      cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
      wceq wa vy cX wral vx cX wrex wa vx vy vz cR cG cH cX ringdi.1 ringdi.2
      ringdi.3 ringi pm3.27d pm3.26d vx cv vy cv cH co vz cv cH co vx cv vy cv
      vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx
      cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co
      vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cv vy cv cH co
      vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cX wral vy cX wral vx
      cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv
      vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx
      cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq
      w3a vz cX wral vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
      co wceq vz cX wral vy cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv
      cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz
      cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv
      vz cv cH co cG co wceq w3a vx cv vy cv cH co vz cv cH co vx cv vy cv vz
      cv cH co cH co wceq vz cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv
      cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz
      cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv
      vz cv cH co cG co wceq 3simp1 r19.20si r19.20si r19.20si syl syl5 impcom
      $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    $d A x $.  $d G x $.  $d H x $.  $d R x $.  $d X x $.
    ring2.1 $e |- G = ( 1st ` R ) $.
    ring2.2 $e |- H = ( 2nd ` R ) $.
    ring2.3 $e |- X = ran G $.
    $( A ring element plus itself is two times the element.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.) $)
    ring2 $p   |- ( ( R e. Ring /\ A e. X ) ->
                  E. x e. X ( A G A ) = ( ( x G x ) H A ) ) $=
      cR cring wcel cA cX wcel wa vx cv cA cH co vx cv cA cH co cG co cA cA cG
      co wceq vx cX wrex cA cA cG co vx cv vx cv cG co cA cH co wceq vx cX wrex
      cR cring wcel cA cX wcel wa cA vx cv cH co cA wceq vx cv cA cH co cA wceq
      wa vx cX wrex vx cv cA cH co cA wceq vx cX wrex vx cv cA cH co vx cv cA
      cH co cG co cA cA cG co wceq vx cX wrex vx cA cR cG cH cX ring2.1 ring2.2
      ring2.3 ringid cA vx cv cH co cA wceq vx cv cA cH co cA wceq wa vx cv cA
      cH co cA wceq vx cX cA vx cv cH co cA wceq vx cv cA cH co cA wceq pm3.27
      r19.22si vx cv cA cH co cA wceq vx cv cA cH co vx cv cA cH co cG co cA cA
      cG co wceq vx cX vx cv cA cH co cA wceq vx cv cA cH co vx cv cA cH co cG
      co cA cA cG co wceq vx cv cA cH co cA vx cv cA cH co cA cG opreq12 anidms
      r19.22si 3syl cR cring wcel cA cX wcel wa vx cv cA cH co vx cv cA cH co
      cG co cA cA cG co wceq cA cA cG co vx cv vx cv cG co cA cH co wceq vx cX
      cR cring wcel cA cX wcel vx cv cX wcel vx cv cA cH co vx cv cA cH co cG
      co cA cA cG co wceq cA cA cG co vx cv vx cv cG co cA cH co wceq wi cR
      cring wcel cA cX wcel vx cv cX wcel w3a vx cv cA cH co vx cv cA cH co cG
      co cA cA cG co wceq cA cA cG co vx cv vx cv cG co cA cH co wceq vx cv vx
      cv cG co cA cH co vx cv cA cH co vx cv cA cH co cG co wceq vx cv cA cH co
      vx cv cA cH co cG co cA cA cG co wceq cA cA cG co vx cv vx cv cG co cA cH
      co wceq cR cring wcel cA cX wcel vx cv cX wcel w3a vx cv vx cv cG co cA
      cH co vx cv cA cH co vx cv cA cH co cG co wceq vx cv cA cH co vx cv cA cH
      co cG co cA cA cG co wceq wa vx cv vx cv cG co cA cH co cA cA cG co vx cv
      vx cv cG co cA cH co vx cv cA cH co vx cv cA cH co cG co cA cA cG co eqtr
      eqcomd vx cv cX wcel cA cX wcel cR cring wcel vx cv vx cv cG co cA cH co
      vx cv cA cH co vx cv cA cH co cG co wceq vx cv cX wcel cA cX wcel cR
      cring wcel vx cv vx cv cG co cA cH co vx cv cA cH co vx cv cA cH co cG co
      wceq vx cv cX wcel cA cX wcel cR cring wcel vx cv vx cv cG co cA cH co vx
      cv cA cH co vx cv cA cH co cG co wceq wi wi vx cv cX wcel vx cv cX wcel
      cA cX wcel cR cring wcel vx cv vx cv cG co cA cH co vx cv cA cH co vx cv
      cA cH co cG co wceq wi cR cring wcel vx cv cX wcel vx cv cX wcel cA cX
      wcel w3a vx cv vx cv cG co cA cH co vx cv cA cH co vx cv cA cH co cG co
      wceq vx cv vx cv cA cR cG cH cX ring2.1 ring2.2 ring2.3 ringdir expcom
      3expia anidms 3imp 3com13 sylan ex 3expa r19.22dva mpd $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    $d G x y z $.  $d R x y z $.
    ringabl.1 $e |- G = ( 1st ` R ) $.
    $( A ring's addition operation is an Abelian group operation.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.) $)
    ringabl $p   |- ( R e. Ring -> G e. Abel ) $=
      cR cring wcel cG cabl wcel cG crn cG crn cxp cG crn cR c2nd cfv wf cR
      cring wcel cG cabl wcel cG crn cG crn cxp cG crn cR c2nd cfv wf wa vx cv
      vy cv cR c2nd cfv co vz cv cR c2nd cfv co vx cv vy cv vz cv cR c2nd cfv
      co cR c2nd cfv co wceq vx cv vy cv vz cv cG co cR c2nd cfv co vx cv vy cv
      cR c2nd cfv co vx cv vz cv cR c2nd cfv co cG co wceq vx cv vy cv cG co vz
      cv cR c2nd cfv co vx cv vz cv cR c2nd cfv co vy cv vz cv cR c2nd cfv co
      cG co wceq w3a vz cG crn wral vy cG crn wral vx cG crn wral vy cv vx cv
      cR c2nd cfv co vy cv wceq vx cv vy cv cR c2nd cfv co vy cv wceq wa vy cG
      crn wral vx cG crn wrex wa vx vy vz cR cG cR c2nd cfv cG crn ringabl.1 cR
      c2nd cfv eqid cG crn eqid ringi pm3.26d pm3.26d $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    ringgrp.1 $e |- G = ( 1st ` R ) $.
    $( A ring's addition operation is a group operation.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.) $)
    ringgrp $p   |- ( R e. Ring -> G e. Grp ) $=
      cR cring wcel cG cabl wcel cG cgr wcel cR cG ringgrp.1 ringabl cG ablgrp
      syl $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    ringgcl.1 $e |- G = ( 1st ` R ) $.
    ringgcl.2 $e |- X = ran G $.
    $( Closure law for the addition (group) operation of a ring.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.) $)
    ringgcl $p   |- ( ( R e. Ring /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      cG cgr wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cR cring wcel cA cB
      cG cX ringgcl.2 grpcl cR cG ringgcl.1 ringgrp syl3an1 $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( The addition operation of a ring is commutative.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.) $)
    ringcom $p   |- ( ( R e. Ring /\ A e. X /\ B e. X ) ->
                      ( A G B ) = ( B G A ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cR cring
      wcel cA cB cG cX ringgcl.2 ablcom cR cG ringgcl.1 ringabl syl3an1 $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( The addition operation of a ring is associative.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.) $)
    ringaass $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                        ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cB cC cG co cG co wceq cR cring wcel cA cB cC cG cX ringgcl.2 grpass cR
      cG ringgcl.1 ringgrp sylan $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( The addition operation of a ring is commutative.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.) $)
    ringa23 $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                      ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cC cG co cB cG co wceq cR cring wcel cA cB cC cG cX ringgcl.2 abl23 cR cG
      ringgcl.1 ringabl sylan $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( Rearrangement of 4 terms in a sum of ring elements.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.) $)
    ringa4 $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X ) /\
                   ( C e. X /\ D e. X ) ) ->
                     ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa cA cB cG
      co cC cD cG co cG co cA cC cG co cB cD cG co cG co wceq cR cring wcel cA
      cB cC cD cG cX ringgcl.2 abl4 cR cG ringgcl.1 ringabl syl3an1 $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( Right cancellation law for the addition operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ringrcan $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                       ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cC cG co cB cC cG co
      wceq cA cB wceq wb cR cring wcel cA cB cC cG cX ringgcl.2 grprcan cR cG
      ringgcl.1 ringgrp sylan $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( Left cancellation law for the addition operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ringlcan $p   |- ( ( R e. Ring /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                       ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cC cA cG co cC cB cG co
      wceq cA cB wceq wb cR cring wcel cA cB cC cG cX ringgcl.2 grplcan cR cG
      ringgcl.1 ringgrp sylan $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

  ${
    ring0cl.1 $e |- G = ( 1st ` R ) $.
    ring0cl.2 $e |- X = ran G $.
    ring0cl.3 $e |- Z = ( Id ` G ) $.
    $( A ring has an additive identity element.  (Contributed by Steve
       Rodriguez, 9-Sep-2007.) $)
    ring0cl $p   |- ( R e. Ring -> Z e. X ) $=
      cR cring wcel cG cgr wcel cZ cX wcel cR cG ring0cl.1 ringgrp cZ cG cX
      ring0cl.2 ring0cl.3 grpidcl syl $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( The additive identity of a ring is a right identity element.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ring0rid $p   |- ( ( R e. Ring /\ A e. X ) -> ( A G Z ) = A ) $=
      cG cgr wcel cA cX wcel cA cZ cG co cA wceq cR cring wcel cA cZ cG cX
      ring0cl.2 ring0cl.3 grprid cR cG ring0cl.1 ringgrp sylan $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)

    $( The additive identity of a ring is a left identity element.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    ring0lid $p   |- ( ( R e. Ring /\ A e. X ) -> ( Z G A ) = A ) $=
      cG cgr wcel cA cX wcel cZ cA cG co cA wceq cR cring wcel cA cZ cG cX
      ring0cl.2 ring0cl.3 grplid cR cG ring0cl.1 ringgrp sylan $.
      $( [14-Sep-2007] $) $( [9-Sep-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
   $d x y z $.
   $( The set of complex numbers is a (unital) ring.  (Contributed by Steve
      Rodriguez, 2-Feb-2007.) $)
   cnring $p |- <. + , x. >. e. Ring $=
     caddc cmul cop cring wcel caddc cabl wcel cc cc cxp cc cmul wf wa vx cv vy
     cv cmul co vz cv cmul co vx cv vy cv vz cv cmul co cmul co wceq vx cv vy
     cv vz cv caddc co cmul co vx cv vy cv cmul co vx cv vz cv cmul co caddc co
     wceq vx cv vy cv caddc co vz cv cmul co vx cv vz cv cmul co vy cv vz cv
     cmul co caddc co wceq w3a vz cc wral vy cc wral vx cc wral vy cv vx cv
     cmul co vy cv wceq vx cv vy cv cmul co vy cv wceq wa vy cc wral vx cc wrex
     wa cmul cvv wcel caddc cmul cop cring wcel caddc cabl wcel cc cc cxp cc
     cmul wf wa vx cv vy cv cmul co vz cv cmul co vx cv vy cv vz cv cmul co
     cmul co wceq vx cv vy cv vz cv caddc co cmul co vx cv vy cv cmul co vx cv
     vz cv cmul co caddc co wceq vx cv vy cv caddc co vz cv cmul co vx cv vz cv
     cmul co vy cv vz cv cmul co caddc co wceq w3a vz cc wral vy cc wral vx cc
     wral vy cv vx cv cmul co vy cv wceq vx cv vy cv cmul co vy cv wceq wa vy
     cc wral vx cc wrex wa wa wb mulex vx vy vz cvv caddc cmul cc caddc cc
     caddc cabl wcel caddc cgr wcel cnaddabl caddc ablgrp ax-mp cc cc cxp cc
     caddc axaddopr fdmi grprn isring ax-mp caddc cabl wcel cc cc cxp cc cmul
     wf cnaddabl axmulopr pm3.2i vx cv vy cv cmul co vz cv cmul co vx cv vy cv
     vz cv cmul co cmul co wceq vx cv vy cv vz cv caddc co cmul co vx cv vy cv
     cmul co vx cv vz cv cmul co caddc co wceq vx cv vy cv caddc co vz cv cmul
     co vx cv vz cv cmul co vy cv vz cv cmul co caddc co wceq w3a vz cc wral vy
     cc wral vx cc wral vy cv vx cv cmul co vy cv wceq vx cv vy cv cmul co vy
     cv wceq wa vy cc wral vx cc wrex vx cv vy cv cmul co vz cv cmul co vx cv
     vy cv vz cv cmul co cmul co wceq vx cv vy cv vz cv caddc co cmul co vx cv
     vy cv cmul co vx cv vz cv cmul co caddc co wceq vx cv vy cv caddc co vz cv
     cmul co vx cv vz cv cmul co vy cv vz cv cmul co caddc co wceq w3a vx vy vz
     cc cc cc vx cv cc wcel vy cv cc wcel vz cv cc wcel w3a vx cv vy cv cmul co
     vz cv cmul co vx cv vy cv vz cv cmul co cmul co wceq vx cv vy cv vz cv
     caddc co cmul co vx cv vy cv cmul co vx cv vz cv cmul co caddc co wceq vx
     cv vy cv caddc co vz cv cmul co vx cv vz cv cmul co vy cv vz cv cmul co
     caddc co wceq vx cv vy cv vz cv mulass vx cv vy cv vz cv adddi vx cv vy cv
     vz cv adddir 3jca rgen3 c1 cc wcel vy cv c1 cmul co vy cv wceq c1 vy cv
     cmul co vy cv wceq wa vy cc wral vy cv vx cv cmul co vy cv wceq vx cv vy
     cv cmul co vy cv wceq wa vy cc wral vx cc wrex ax1cn vy cv c1 cmul co vy
     cv wceq c1 vy cv cmul co vy cv wceq wa vy cc vy cv cc wcel vy cv c1 cmul
     co vy cv wceq c1 vy cv cmul co vy cv wceq vy cv ax1id vy cv mulid2 jca
     rgen vy cv vx cv cmul co vy cv wceq vx cv vy cv cmul co vy cv wceq wa vy
     cc wral vy cv c1 cmul co vy cv wceq c1 vy cv cmul co vy cv wceq wa vy cc
     wral vx c1 cc vx cv c1 wceq vy cv vx cv cmul co vy cv wceq vx cv vy cv
     cmul co vy cv wceq wa vy cv c1 cmul co vy cv wceq c1 vy cv cmul co vy cv
     wceq wa vy cc vx cv c1 wceq vy cv vx cv cmul co vy cv wceq vy cv c1 cmul
     co vy cv wceq vx cv vy cv cmul co vy cv wceq c1 vy cv cmul co vy cv wceq
     vx cv c1 wceq vy cv vx cv cmul co vy cv c1 cmul co vy cv vx cv c1 vy cv
     cmul opreq2 eqeq1d vx cv c1 wceq vx cv vy cv cmul co c1 vy cv cmul co vy
     cv vx cv c1 vy cv cmul opreq1 eqeq1d anbi12d ralbidv rcla4ev mp2an pm3.2i
     mpbir2an $.
     $( [25-Jul-2008] $) $( [22-Nov-2006] $)
  $}

  ${
   $d x y z A $.
   ringsn.1 $e |- A e. _V $.
   $( The _trivial_ or _zero_ ring defined on a singleton set ` { A } `
      (see  ~ http://en.wikipedia.org/wiki/Trivial&#x5F;ring ).  (Contributed
      by Steve Rodriguez, 10-Feb-2007.) $)
   ringsn $p |- <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >.
                e. Ring $=
     cA cA cop cA cop csn cA cA cop cA cop csn cop cring wcel cA cA cop cA cop
     csn cabl wcel cA csn cA csn cxp cA csn cA cA cop cA cop csn wf wa vx cv vy
     cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vy cv vz cv
     cA cA cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy cv vz cv cA
     cA cop cA cop csn co cA cA cop cA cop csn co vx cv vy cv cA cA cop cA cop
     csn co vx cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co wceq vx
     cv vy cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vz cv
     cA cA cop cA cop csn co vy cv vz cv cA cA cop cA cop csn co cA cA cop cA
     cop csn co wceq w3a vz cA csn wral vy cA csn wral vx cA csn wral vy cv vx
     cv cA cA cop cA cop csn co vy cv wceq vx cv vy cv cA cA cop cA cop csn co
     vy cv wceq wa vy cA csn wral vx cA csn wrex wa cA cA cop cA cop csn cvv
     wcel cA cA cop cA cop csn cA cA cop cA cop csn cop cring wcel cA cA cop cA
     cop csn cabl wcel cA csn cA csn cxp cA csn cA cA cop cA cop csn wf wa vx
     cv vy cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vy cv
     vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy cv vz
     cv cA cA cop cA cop csn co cA cA cop cA cop csn co vx cv vy cv cA cA cop
     cA cop csn co vx cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co
     wceq vx cv vy cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx
     cv vz cv cA cA cop cA cop csn co vy cv vz cv cA cA cop cA cop csn co cA cA
     cop cA cop csn co wceq w3a vz cA csn wral vy cA csn wral vx cA csn wral vy
     cv vx cv cA cA cop cA cop csn co vy cv wceq vx cv vy cv cA cA cop cA cop
     csn co vy cv wceq wa vy cA csn wral vx cA csn wrex wa wa wb cA cA cop cA
     cop snex vx vy vz cvv cA cA cop cA cop csn cA cA cop cA cop csn cA csn cA
     cA cop cA cop csn crn cA csn cA cA cop cA cA cA opex ringsn.1 rnsnop
     eqcomi isring ax-mp cA cA cop cA cop csn cabl wcel cA csn cA csn cxp cA
     csn cA cA cop cA cop csn wf cA ringsn.1 ablsn cA csn cA csn cxp cA csn cA
     cA cop cA cop csn wf cA cA cop cA cop csn cA csn cA csn cxp wfn vx cv vy
     cv cA cA cop cA cop csn co cA csn wcel vy cA csn wral vx cA csn wral vx vy
     cA csn cA csn cA csn cA cA cop cA cop csn ffnoprv cA cA cop cA cop csn cA
     csn cA csn cxp wfn cA cA cop cA cop csn wfun cA cA cop cA cop csn cdm cA
     csn cA csn cxp wceq cA cA cop cA cop csn cA csn cA csn cxp df-fn cA cA cop
     cA cA cA opex ringsn.1 funsn cA cA cop cA cop csn cdm cA cA cop csn cA csn
     cA csn cxp cA cA cop cA dmsnop cA cA ringsn.1 ringsn.1 xpsn eqtr4i
     mpbir2an vx cv vy cv cA cA cop cA cop csn co cA csn wcel vx vy cA csn vx
     cv cA wceq vy cv cA wceq vx cv vy cv cA cA cop cA cop csn co cA csn wcel
     vx cv cA csn wcel vy cv cA csn wcel vx cv cA wceq vy cv cA wceq wa vx cv
     vy cv cA cA cop cA cop csn co cA wceq vx cv vy cv cA cA cop cA cop csn co
     cA csn wcel vx cv cA wceq vy cv cA wceq wa vx cv vy cv cA cA cop cA cop
     csn co cA cA cA cA cop cA cop csn co cA vx cv cA vy cv cA cA cA cop cA cop
     csn opreq12 cA cA cA cA cop cA cop csn co cA cA cop cA cA cop cA cop csn
     cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA opex ringsn.1
     fvsn eqtri syl6eq vx cv vy cv cA cA cop cA cop csn co cA ringsn.1 elsnc2
     sylibr vx cA elsn vy cA elsn syl2anb rgen2a mpbir2an pm3.2i vx cv vy cv cA
     cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vy cv vz cv cA cA
     cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy cv vz cv cA cA cop
     cA cop csn co cA cA cop cA cop csn co vx cv vy cv cA cA cop cA cop csn co
     vx cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy
     cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vz cv cA cA
     cop cA cop csn co vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn
     co wceq w3a vz cA csn wral vy cA csn wral vx cA csn wral vy cv vx cv cA cA
     cop cA cop csn co vy cv wceq vx cv vy cv cA cA cop cA cop csn co vy cv
     wceq wa vy cA csn wral vx cA csn wrex vx cv vy cv cA cA cop cA cop csn co
     vz cv cA cA cop cA cop csn co vx cv vy cv vz cv cA cA cop cA cop csn co cA
     cA cop cA cop csn co wceq vx cv vy cv vz cv cA cA cop cA cop csn co cA cA
     cop cA cop csn co vx cv vy cv cA cA cop cA cop csn co vx cv vz cv cA cA
     cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy cv cA cA cop cA
     cop csn co vz cv cA cA cop cA cop csn co vx cv vz cv cA cA cop cA cop csn
     co vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co wceq w3a vx
     vy vz cA csn cA csn cA csn vx cv cA wceq vy cv cA wceq vz cv cA wceq vx cv
     vy cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vy cv vz
     cv cA cA cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy cv vz cv
     cA cA cop cA cop csn co cA cA cop cA cop csn co vx cv vy cv cA cA cop cA
     cop csn co vx cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co
     wceq vx cv vy cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx
     cv vz cv cA cA cop cA cop csn co vy cv vz cv cA cA cop cA cop csn co cA cA
     cop cA cop csn co wceq w3a vx cv cA csn wcel vy cv cA csn wcel vz cv cA
     csn wcel vx cv cA wceq vy cv cA wceq vz cv cA wceq w3a vx cv vy cv cA cA
     cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vy cv vz cv cA cA
     cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy cv vz cv cA cA cop
     cA cop csn co cA cA cop cA cop csn co vx cv vy cv cA cA cop cA cop csn co
     vx cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn co wceq vx cv vy
     cv cA cA cop cA cop csn co vz cv cA cA cop cA cop csn co vx cv vz cv cA cA
     cop cA cop csn co vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn
     co wceq vx cv cA wceq vy cv cA wceq vz cv cA wceq w3a vx cv vy cv cA cA
     cop cA cop csn co vx cv vz cv vy cv vz cv cA cA cop cA cop csn co cA cA
     cop cA cop csn vx cv cA wceq vy cv cA wceq vx cv vy cv cA cA cop cA cop
     csn co vx cv wceq vz cv cA wceq vx cv cA wceq vy cv cA wceq wa cA cA cA cA
     cop cA cop csn co cA vx cv vy cv cA cA cop cA cop csn co vx cv cA cA cA cA
     cop cA cop csn co cA cA cop cA cA cop cA cop csn cfv cA cA cA cA cA cop cA
     cop csn df-opr cA cA cop cA cA cA opex ringsn.1 fvsn eqtri vx cv cA vy cv
     cA cA cA cop cA cop csn opreq12 vx cv cA wceq vy cv cA wceq pm3.26 3eqtr4a
     3adant3 vy cv cA wceq vz cv cA wceq vz cv vy cv vz cv cA cA cop cA cop csn
     co wceq vx cv cA wceq vy cv cA wceq vz cv cA wceq wa vz cv cA vy cv vz cv
     cA cA cop cA cop csn co vy cv cA wceq vz cv cA wceq pm3.27 vy cv cA wceq
     vz cv cA wceq wa vy cv vz cv cA cA cop cA cop csn co cA cA cA cA cop cA
     cop csn co cA vy cv cA vz cv cA cA cA cop cA cop csn opreq12 cA cA cA cA
     cop cA cop csn co cA cA cop cA cA cop cA cop csn cfv cA cA cA cA cA cop cA
     cop csn df-opr cA cA cop cA cA cA opex ringsn.1 fvsn eqtri syl6eq eqtr4d
     3adant1 opreq12d vx cv cA wceq vy cv cA wceq vz cv cA wceq w3a vx cv vx cv
     vy cv cA cA cop cA cop csn co vy cv vz cv cA cA cop cA cop csn co vx cv vz
     cv cA cA cop cA cop csn co cA cA cop cA cop csn vx cv cA wceq vy cv cA
     wceq vx cv vx cv vy cv cA cA cop cA cop csn co wceq vz cv cA wceq vx cv cA
     wceq vy cv cA wceq wa vx cv cA vx cv vy cv cA cA cop cA cop csn co vx cv
     cA wceq vy cv cA wceq pm3.26 vx cv cA wceq vy cv cA wceq wa vx cv vy cv cA
     cA cop cA cop csn co cA cA cA cA cop cA cop csn co cA vx cv cA vy cv cA cA
     cA cop cA cop csn opreq12 cA cA cA cA cop cA cop csn co cA cA cop cA cA
     cop cA cop csn cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA
     opex ringsn.1 fvsn eqtri syl6eq eqtr4d 3adant3 vx cv cA wceq vy cv cA wceq
     vy cv vz cv cA cA cop cA cop csn co vx cv vz cv cA cA cop cA cop csn co
     wceq vz cv cA wceq vy cv cA wceq vx cv cA wceq vy cv vz cv cA cA cop cA
     cop csn co vx cv vz cv cA cA cop cA cop csn co wceq vy cv cA wceq vx cv cA
     wceq wa vy cv vx cv vz cv cA cA cop cA cop csn vy cv vx cv cA eqtr3
     opreq1d ancoms 3adant3 opreq12d vx cv cA wceq vy cv cA wceq vz cv cA wceq
     w3a vx cv vy cv cA cA cop cA cop csn co vx cv vz cv cA cA cop cA cop csn
     co vz cv vy cv vz cv cA cA cop cA cop csn co cA cA cop cA cop csn vy cv cA
     wceq vz cv cA wceq vx cv vy cv cA cA cop cA cop csn co vx cv vz cv cA cA
     cop cA cop csn co wceq vx cv cA wceq vy cv cA wceq vz cv cA wceq wa vy cv
     vz cv vx cv cA cA cop cA cop csn vy cv vz cv cA eqtr3 opreq2d 3adant1 vy
     cv cA wceq vz cv cA wceq vz cv vy cv vz cv cA cA cop cA cop csn co wceq vx
     cv cA wceq vy cv cA wceq vz cv cA wceq wa vz cv cA vy cv vz cv cA cA cop
     cA cop csn co vy cv cA wceq vz cv cA wceq pm3.27 vy cv cA wceq vz cv cA
     wceq wa vy cv vz cv cA cA cop cA cop csn co cA cA cA cA cop cA cop csn co
     cA vy cv cA vz cv cA cA cA cop cA cop csn opreq12 cA cA cA cA cop cA cop
     csn co cA cA cop cA cA cop cA cop csn cfv cA cA cA cA cA cop cA cop csn
     df-opr cA cA cop cA cA cA opex ringsn.1 fvsn eqtri syl6eq eqtr4d 3adant1
     opreq12d 3jca vx cA elsn vy cA elsn vz cA elsn syl3anb rgen3 cA cA csn
     wcel vy cv cA cA cA cop cA cop csn co vy cv wceq cA vy cv cA cA cop cA cop
     csn co vy cv wceq wa vy cA csn wral vy cv vx cv cA cA cop cA cop csn co vy
     cv wceq vx cv vy cv cA cA cop cA cop csn co vy cv wceq wa vy cA csn wral
     vx cA csn wrex cA ringsn.1 snid vy cv cA cA cA cop cA cop csn co vy cv
     wceq cA vy cv cA cA cop cA cop csn co vy cv wceq wa vy cA csn vy cv cA csn
     wcel vy cv cA wceq vy cv cA cA cA cop cA cop csn co vy cv wceq cA vy cv cA
     cA cop cA cop csn co vy cv wceq wa vy cA elsn vy cv cA wceq vy cv cA cA cA
     cop cA cop csn co vy cv wceq cA vy cv cA cA cop cA cop csn co vy cv wceq
     wa cA cA cA cA cop cA cop csn co cA wceq cA cA cA cA cop cA cop csn co cA
     wceq wa cA cA cA cA cop cA cop csn co cA wceq cA cA cA cA cop cA cop csn
     co cA wceq cA cA cA cA cop cA cop csn co cA cA cop cA cA cop cA cop csn
     cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA opex ringsn.1
     fvsn eqtri cA cA cA cA cop cA cop csn co cA cA cop cA cA cop cA cop csn
     cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA opex ringsn.1
     fvsn eqtri pm3.2i vy cv cA wceq vy cv cA cA cA cop cA cop csn co vy cv
     wceq cA cA cA cA cop cA cop csn co cA wceq cA vy cv cA cA cop cA cop csn
     co vy cv wceq cA cA cA cA cop cA cop csn co cA wceq vy cv cA wceq vy cv cA
     cA cA cop cA cop csn co cA cA cA cA cop cA cop csn co vy cv cA vy cv cA cA
     cA cA cop cA cop csn opreq1 vy cv cA wceq id eqeq12d vy cv cA wceq cA vy
     cv cA cA cop cA cop csn co cA cA cA cA cop cA cop csn co vy cv cA vy cv cA
     cA cA cA cop cA cop csn opreq2 vy cv cA wceq id eqeq12d anbi12d mpbiri
     sylbi rgen vy cv vx cv cA cA cop cA cop csn co vy cv wceq vx cv vy cv cA
     cA cop cA cop csn co vy cv wceq wa vy cA csn wral vy cv cA cA cA cop cA
     cop csn co vy cv wceq cA vy cv cA cA cop cA cop csn co vy cv wceq wa vy cA
     csn wral vx cA cA csn vx cv cA wceq vy cv vx cv cA cA cop cA cop csn co vy
     cv wceq vx cv vy cv cA cA cop cA cop csn co vy cv wceq wa vy cv cA cA cA
     cop cA cop csn co vy cv wceq cA vy cv cA cA cop cA cop csn co vy cv wceq
     wa vy cA csn vx cv cA wceq vy cv vx cv cA cA cop cA cop csn co vy cv wceq
     vy cv cA cA cA cop cA cop csn co vy cv wceq vx cv vy cv cA cA cop cA cop
     csn co vy cv wceq cA vy cv cA cA cop cA cop csn co vy cv wceq vx cv cA
     wceq vy cv vx cv cA cA cop cA cop csn co vy cv cA cA cA cop cA cop csn co
     vy cv vx cv cA vy cv cA cA cop cA cop csn opreq2 eqeq1d vx cv cA wceq vx
     cv vy cv cA cA cop cA cop csn co cA vy cv cA cA cop cA cop csn co vy cv vx
     cv cA vy cv cA cA cop cA cop csn opreq1 eqeq1d anbi12d ralbidv rcla4ev
     mp2an pm3.2i mpbir2an $.
     $( [10-Feb-2007] $) $( [3-Feb-2007] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Division Rings
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c DivRing $.

  $( Extend class notation with the class of all division rings. $)
  cdrng $a class DivRing $.

  ${
    $d g h $.
    $( Define the class of all division rings (sometimes called skew
       fields).  A division ring is a unital ring where every element except
       the additive identity has a multiplicative inverse. $)
    df-drng $a |- DivRing = { <. g , h >. | ( <. g , h >. e. Ring  /\ ( h |` (
     ( ran g \ { ( Id ` g ) } ) X. ( ran g \ { ( Id ` g ) } ) ) ) e. Grp ) } $.
  $}

  ${
    $d g h H $.  $d g h R $.  $d g h X $.  $d g h Z $.
    drngi.1 $e |- G = ( 1st ` R ) $.
    drngi.2 $e |- H = ( 2nd ` R ) $.
    drngi.3 $e |- X = ran G $.
    drngi.4 $e |- Z = ( Id ` G ) $.
    $( The properties of a division ring. $)
    drngi $p |- ( R e. DivRing -> ( R e. Ring /\
        ( H |` ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. Grp ) ) $=
      cR cdrng wcel cR cring wcel cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr
      wcel wa cR c1st cfv cR c2nd cfv cop cring wcel cH cX cZ csn cdif cX cZ
      csn cdif cxp cres cgr wcel wa cR cdrng wcel cR vg cv vh cv cop cring wcel
      vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif
      cxp cres cgr wcel wa vg vh copab wcel cR c1st cfv cR c2nd cfv cop cring
      wcel cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel wa cdrng vg cv vh
      cv cop cring wcel vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv
      cgi cfv csn cdif cxp cres cgr wcel wa vg vh copab cR vg vh df-drng eleq2i
      vg cv vh cv cop cring wcel vh cv vg cv crn vg cv cgi cfv csn cdif vg cv
      crn vg cv cgi cfv csn cdif cxp cres cgr wcel wa cR c1st cfv vh cv cop
      cring wcel vh cv cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel wa cR
      c1st cfv cR c2nd cfv cop cring wcel cH cX cZ csn cdif cX cZ csn cdif cxp
      cres cgr wcel wa vg vh cR vg cv cR c1st cfv wceq vg cv vh cv cop cring
      wcel cR c1st cfv vh cv cop cring wcel vh cv vg cv crn vg cv cgi cfv csn
      cdif vg cv crn vg cv cgi cfv csn cdif cxp cres cgr wcel vh cv cX cZ csn
      cdif cX cZ csn cdif cxp cres cgr wcel vg cv cR c1st cfv wceq vg cv vh cv
      cop cR c1st cfv vh cv cop cring vg cv cR c1st cfv vh cv opeq1 eleq1d vg
      cv cR c1st cfv wceq vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg
      cv cgi cfv csn cdif cxp cres vh cv cX cZ csn cdif cX cZ csn cdif cxp cres
      cgr vg cv cR c1st cfv wceq vg cv crn vg cv cgi cfv csn cdif vg cv crn vg
      cv cgi cfv csn cdif cxp cX cZ csn cdif cX cZ csn cdif cxp wceq vh cv vg
      cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp cres
      vh cv cX cZ csn cdif cX cZ csn cdif cxp cres wceq vg cv cR c1st cfv wceq
      vg cv crn vg cv cgi cfv csn cdif cX cZ csn cdif wceq vg cv crn vg cv cgi
      cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp cX cZ csn cdif cX cZ
      csn cdif cxp wceq vg cv cR c1st cfv wceq vg cv crn vg cv cgi cfv csn cdif
      cX vg cv cgi cfv csn cdif cX cZ csn cdif vg cv cR c1st cfv wceq vg cv crn
      cX vg cv cgi cfv csn vg cv cR c1st cfv wceq vg cv crn cG crn cX vg cv cR
      c1st cfv wceq vg cv cG vg cv cR c1st cfv wceq vg cv cR c1st cfv cG vg cv
      cR c1st cfv wceq id drngi.1 syl6eqr rneqd drngi.3 syl6eqr difeq1d vg cv
      cR c1st cfv wceq vg cv cgi cfv csn cZ csn cX vg cv cR c1st cfv wceq vg cv
      cgi cfv cZ vg cv cR c1st cfv wceq vg cv cgi cfv cG cgi cfv cZ vg cv cR
      c1st cfv wceq vg cv cG cgi vg cv cR c1st cfv wceq vg cv cR c1st cfv cG vg
      cv cR c1st cfv wceq id drngi.1 syl6eqr fveq2d drngi.4 syl6eqr sneqd
      difeq2d eqtrd vg cv crn vg cv cgi cfv csn cdif cX cZ csn cdif wceq vg cv
      crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp vg cv crn
      vg cv cgi cfv csn cdif cX cZ csn cdif cxp cX cZ csn cdif cX cZ csn cdif
      cxp vg cv crn vg cv cgi cfv csn cdif cX cZ csn cdif vg cv crn vg cv cgi
      cfv csn cdif xpeq2 vg cv crn vg cv cgi cfv csn cdif cX cZ csn cdif cX cZ
      csn cdif xpeq1 eqtrd syl vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv
      cgi cfv csn cdif cxp cX cZ csn cdif cX cZ csn cdif cxp vh cv reseq2 syl
      eleq1d anbi12d vh cv cR c2nd cfv wceq cR c1st cfv vh cv cop cring wcel vh
      cv cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel wa cR c1st cfv cR c2nd
      cfv cop cring wcel vh cv cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel
      wa cR c1st cfv cR c2nd cfv cop cring wcel cH cX cZ csn cdif cX cZ csn
      cdif cxp cres cgr wcel wa vh cv cR c2nd cfv wceq cR c1st cfv vh cv cop
      cring wcel cR c1st cfv cR c2nd cfv cop cring wcel vh cv cX cZ csn cdif cX
      cZ csn cdif cxp cres cgr wcel vh cv cR c2nd cfv wceq cR c1st cfv vh cv
      cop cR c1st cfv cR c2nd cfv cop cring vh cv cR c2nd cfv cR c1st cfv opeq2
      eleq1d anbi1d vh cv cR c2nd cfv wceq cH cX cZ csn cdif cX cZ csn cdif cxp
      cres cgr wcel vh cv cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel cR
      c1st cfv cR c2nd cfv cop cring wcel vh cv cR c2nd cfv wceq cH cX cZ csn
      cdif cX cZ csn cdif cxp cres vh cv cX cZ csn cdif cX cZ csn cdif cxp cres
      cgr vh cv cR c2nd cfv wceq cH vh cv wceq cH cX cZ csn cdif cX cZ csn cdif
      cxp cres vh cv cX cZ csn cdif cX cZ csn cdif cxp cres wceq vh cv cR c2nd
      cfv wceq vh cv cR c2nd cfv cH vh cv cR c2nd cfv wceq id drngi.2 syl6reqr
      cH vh cv cX cZ csn cdif cX cZ csn cdif cxp reseq1 syl eleq1d anbi2d
      bitr4d elopabi sylbi cR cdrng wcel cR cring wcel cR c1st cfv cR c2nd cfv
      cop cring wcel cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel cR
      cdrng wcel cR cR c1st cfv cR c2nd cfv cop cring cdrng wrel cR cdrng wcel
      cR cR c1st cfv cR c2nd cfv cop wceq cdrng wrel vg cv vh cv cop cring wcel
      vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif
      cxp cres cgr wcel wa vg vh copab wrel vg cv vh cv cop cring wcel vh cv vg
      cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp cres
      cgr wcel wa vg vh relopab cdrng vg cv vh cv cop cring wcel vh cv vg cv
      crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp cres cgr
      wcel wa vg vh copab vg vh df-drng releqi mpbir cR cdrng 1st2nd mpan
      eleq1d anbi1d mpbird $.
      $( [4-Apr-2009] $) $( [4-Apr-2009] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Star Fields
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c *-Fld $.

  $( Extend class notation with the class of all star fields. $)
  csfld $a class *-Fld $.

  ${
    $d f n x y $.
    $( Define the class of all star fields, which are all division rings with
       involutions. $)
    df-sfld $a |- *-Fld = { <. r , n >. | ( r e. DivRing  /\
   n : ran ( 1st ` r ) --> ran ( 1st ` r ) /\
   A. x e. dom n A. y e. dom n
       ( ( n ` ( x ( 1st ` r ) y ) ) = ( ( n ` x ) ( 1st ` r ) ( n ` y ) ) /\
         ( n ` ( x ( 2nd ` r ) y ) ) = ( ( n ` y ) ( 2nd ` r ) ( n ` x ) ) /\
         ( n ` ( n ` x ) ) = x ) ) } $.
  $}

  ${
    $d g h H $.  $d g h R $.  $d g h X $.  $d g h Z $.
    sfldi.1 $e |- R = ( 1st ` F ) $.
    sfldi.2 $e |- N = ( 2nd ` F ) $.
    sfldi.3 $e |- G = ( 1st ` R ) $.
    sfldi.4 $e |- H = ( 2nd ` R ) $.
    sfldi.5 $e |- X = ran G $.
    sfldi.6 $e |- Z = ( Id ` G ) $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Complex vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CVec $.

  $( Extend class notation with the class of all complex vector spaces. $)
  cvc $a class CVec $.

  ${
    $d g s x y z $.
    $( Define the class of all complex vector spaces. $)
    df-vc $a |- CVec = { <. g , s >. | ( g e. Abel /\
     s :  ( CC X. ran g ) --> ran g /\ A. x e. ran g ( ( 1 s x ) = x /\
       A. y e. CC ( A. z e. ran g ( y s ( x g z ) ) = ( ( y s x ) g ( y s z ) )
         /\ A. z e. CC ( ( ( y + z ) s x ) = ( ( y s x ) g ( z s x ) ) /\
           ( ( y x. z ) s x ) = ( y s ( z s x ) ) ) ) ) ) } $.

    $( The class of all complex vector spaces is a relation. $)
    vcrel $p |- Rel CVec $=
      cvc wrel vg cv cabl wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs
      cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co
      vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co
      vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy
      cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq
      wa vz cc wral wa vy cc wral wa vx vg cv crn wral w3a vg vs copab wrel vg
      cv cabl wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv co vx cv
      wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv
      vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv
      co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv
      cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc
      wral wa vy cc wral wa vx vg cv crn wral w3a vg vs relopab cvc vg cv cabl
      wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv co vx cv wceq vy
      cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co
      vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa
      vy cc wral wa vx vg cv crn wral w3a vg vs copab vx vy vz vg vs df-vc
      releqi mpbir $.
      $( [6-Apr-2007] $) $( [17-Mar-2007] $)
  $}

  ${
    $d g s w x y z G $.  $d g s w x y z S $.  $d g s W $.  $d g s w x y z X $.
    $d w x y z A $.  $d w x y z B $.  $d x y z C $.
    vci.1 $e |- G = ( 1st ` W ) $.
    vci.2 $e |- S = ( 2nd ` W ) $.
    vci.3 $e |- X = ran G $.
    $( The properties of a complex vector space, which is an Abelian group
       (i.e. the vectors, with the operation of vector addition) accompanied
       by a scalar multiplication operation on the field of complex numbers.
       The variable ` W ` was chosen because ` _V ` is already used for the
       universal class. $)
    vci $p |- ( W e. CVec ->
              ( G e. Abel /\
         S :  ( CC X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. CC ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. CC ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) $=
      cW cvc wcel cW vg cv cabl wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx
      cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs
      cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cc wral wa vy cc wral wa vx vg cv crn wral w3a vg vs
      copab wcel cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy
      cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq
      vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv
      cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co
      cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral w3a cvc vg cv cabl
      wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv co vx cv wceq vy
      cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co
      vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa
      vy cc wral wa vx vg cv crn wral w3a vg vs copab cW vx vy vz vg vs df-vc
      eleq2i vg cv cabl wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv
      co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy
      cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vz cc wral wa vy cc wral wa vx vg cv crn wral w3a cG cabl wcel cc cX cxp
      cX vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv co
      vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz
      cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cc wral wa vy cc wral wa vx cX wral w3a cG cabl wcel cc
      cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co
      vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv
      vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      wral wa vy cc wral wa vx cX wral w3a vg vs cW vg cv cW c1st cfv wceq vg
      cv cG wceq vg cv cabl wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx cv
      vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv
      co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc
      co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq
      vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co
      wceq wa vz cc wral wa vy cc wral wa vx vg cv crn wral w3a cG cabl wcel cc
      cX cxp cX vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co
      vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral
      vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs
      cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs
      cv co vs cv co wceq wa vz cc wral wa vy cc wral wa vx cX wral w3a wb cG
      cW c1st cfv vg cv vci.1 eqeq2i vg cv cG wceq vg cv cabl wcel cG cabl wcel
      cc vg cv crn cxp vg cv crn vs cv wf cc cX cxp cX vs cv wf c1 vx cv vs cv
      co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy
      cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vz cc wral wa vy cc wral wa vx vg cv crn wral c1 vx cv vs cv co vx cv
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc
      wral wa vx cX wral vg cv cG cabl eleq1 vg cv cG wceq vg cv crn cX wceq cc
      vg cv crn cxp vg cv crn vs cv wf cc cX cxp cX vs cv wf wb vg cv cG wceq
      vg cv crn cG crn cX vg cv cG rneq vci.3 syl6eqr vg cv crn cX wceq cc vg
      cv crn cxp vg cv crn vs cv wf cc cX cxp vg cv crn vs cv wf cc cX cxp cX
      vs cv wf vg cv crn cX wceq cc vg cv crn cxp cc cX cxp wceq cc vg cv crn
      cxp vg cv crn vs cv wf cc cX cxp vg cv crn vs cv wf wb vg cv crn cX cc
      xpeq2 cc vg cv crn cxp cc cX cxp vg cv crn vs cv feq2 syl vg cv crn cX cc
      cX cxp vs cv feq3 bitrd syl vg cv cG wceq c1 vx cv vs cv co vx cv wceq vy
      cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co
      vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa
      vy cc wral wa c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv
      co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv
      vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co
      cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co
      vs cv co wceq wa vz cc wral wa vy cc wral wa vx vg cv crn cX vg cv cG
      wceq vg cv crn cG crn cX vg cv cG rneq vci.3 syl6eqr vg cv cG wceq vy cv
      vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co
      vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy cv
      vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy
      cc wral vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv
      vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv
      vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv
      vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc
      wral c1 vx cv vs cv co vx cv wceq vg cv cG wceq vy cv vx cv vz cv vg cv
      co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg
      cv crn wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz
      cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv
      vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cv vx cv vz cv cG
      co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX
      wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv
      vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv
      vs cv co vs cv co wceq wa vz cc wral wa vy cc vg cv cG wceq vy cv vx cv
      vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv
      co wceq vz vg cv crn wral vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs
      cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vz cc wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv
      vx cv vs cv co vs cv co wceq wa vz cc wral vg cv cG wceq vy cv vx cv vz
      cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv
      cG rneq vci.3 syl6eqr vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co
      vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co vg cv cG wceq
      vx cv vz cv vg cv co vx cv vz cv cG co vy cv vs cv vx cv vz cv vg cv cG
      opreq opreq2d vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv cG opreq
      eqeq12d raleq12d vg cv cG wceq vy cv vz cv caddc co vx cv vs cv co vy cv
      vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vy cv vz cv caddc
      co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy
      cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq
      wa vz cc vg cv cG wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs
      cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv caddc co vx cv vs cv
      co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul
      co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq vg cv cG wceq
      vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co vy cv vx cv vs cv co
      vz cv vx cv vs cv co cG co vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co vg cv cG opreq eqeq2d anbi1d ralbidv
      anbi12d ralbidv anbi2d raleq12d 3anbi123d sylbir vs cv cW c2nd cfv wceq
      vs cv cS wceq cG cabl wcel cc cX cxp cX vs cv wf c1 vx cv vs cv co vx cv
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc
      wral wa vx cX wral w3a cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx
      cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co
      cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co
      vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv
      vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral w3a wb
      cS cW c2nd cfv vs cv vci.2 eqeq2i vs cv cS wceq cc cX cxp cX vs cv wf cc
      cX cxp cX cS wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs
      cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv
      co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv
      co vs cv co wceq wa vz cc wral wa vy cc wral wa vx cX wral c1 vx cv cS co
      vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS
      co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS
      co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz
      cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral cG
      cabl wcel cc cX cxp cX vs cv cS feq1 vs cv cS wceq c1 vx cv vs cv co vx
      cv wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv
      vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv
      vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv
      vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc
      wral wa c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx
      cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx
      cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul
      co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc
      wral wa vx cX vs cv cS wceq c1 vx cv vs cv co vx cv wceq c1 vx cv cS co
      vx cv wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz
      cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy
      cc wral vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co
      cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co
      vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv
      vx cv cS co cS co wceq wa vz cc wral wa vy cc wral vs cv cS wceq c1 vx cv
      vs cv co c1 vx cv cS co vx cv c1 vx cv vs cv cS opreq eqeq1d vs cv cS
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cv vx
      cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX
      wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc wral wa vy cc vs cv cS wceq vy cv vx cv vz cv cG co vs cv
      co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv
      vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz
      cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx
      cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx
      cv vs cv co vs cv co wceq wa vz cc wral vy cv vz cv caddc co vx cv cS co
      vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv
      cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral vs cv cS wceq vy
      cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co
      cG co wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS
      co cG co wceq vz cX vs cv cS wceq vy cv vx cv vz cv cG co vs cv co vy cv
      vx cv vz cv cG co cS co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co
      vy cv vx cv cS co vy cv vz cv cS co cG co vy cv vx cv vz cv cG co vs cv
      cS opreq vs cv cS wceq vy cv vx cv vs cv co vy cv vx cv cS co vy cv vz cv
      vs cv co vy cv vz cv cS co cG vy cv vx cv vs cv cS opreq vy cv vz cv vs
      cv cS opreq opreq12d eqeq12d ralbidv vs cv cS wceq vy cv vz cv caddc co
      vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG
      co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc vs cv cS wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv caddc co vx cv cS
      co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq vy cv vz cv cmul co
      vx cv cS co vy cv vz cv vx cv cS co cS co wceq vs cv cS wceq vy cv vz cv
      caddc co vx cv vs cv co vy cv vz cv caddc co vx cv cS co vy cv vx cv vs
      cv co vz cv vx cv vs cv co cG co vy cv vx cv cS co vz cv vx cv cS co cG
      co vy cv vz cv caddc co vx cv vs cv cS opreq vs cv cS wceq vy cv vx cv vs
      cv co vy cv vx cv cS co vz cv vx cv vs cv co vz cv vx cv cS co cG vy cv
      vx cv vs cv cS opreq vz cv vx cv vs cv cS opreq opreq12d eqeq12d vs cv cS
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv cmul co vx cv cS co
      vy cv vz cv vx cv vs cv co vs cv co vy cv vz cv vx cv cS co cS co vy cv
      vz cv cmul co vx cv vs cv cS opreq vs cv cS wceq vy cv vz cv vx cv vs cv
      co vs cv co vy cv vz cv vx cv cS co vs cv co vy cv vz cv vx cv cS co cS
      co vs cv cS wceq vz cv vx cv vs cv co vz cv vx cv cS co vy cv vs cv vz cv
      vx cv vs cv cS opreq opreq2d vy cv vz cv vx cv cS co vs cv cS opreq eqtrd
      eqeq12d anbi12d ralbidv anbi12d ralbidv anbi12d ralbidv 3anbi23d sylbir
      elopabi sylbi $.
      $( [4-Nov-2006] $) $( [3-Nov-2006] $)

    $( Functionality of th scalar product of a complex vector space. $)
    vcsm $p |- ( W e. CVec -> S : ( CC X. X ) --> X ) $=
      cW cvc wcel cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy
      cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq
      vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv
      cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co
      cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral vx vy vz cS cG cW cX
      vci.1 vci.2 vci.3 vci 3simp2d $.
      $( [5-Nov-2006] $) $( [3-Nov-2006] $)

    $( Closure of the scalar product of a complex vector space. $)
    vccl $p |- ( ( W e. CVec /\ A e. CC /\ B e. X ) -> ( A S B ) e. X ) $=
      cc cX cxp cX cS wf cA cc wcel cB cX wcel cA cB cS co cX wcel cW cvc wcel
      cA cB cX cc cX cS foprrn cS cG cW cX vci.1 vci.2 vci.3 vcsm syl3an1 $.
      $( [11-Nov-2006] $) $( [3-Nov-2006] $)

    $( Identity element for the scalar product of a complex vector space. $)
    vcid $p |- ( ( W e. CVec /\ A e. X ) -> ( 1 S A ) = A ) $=
      c1 vx cv cS co vx cv wceq vx cX wral cA cX wcel c1 cA cS co cA wceq cW
      cvc wcel c1 vx cv cS co vx cv wceq c1 cA cS co cA wceq vx cA cX vx cv cA
      wceq c1 vx cv cS co c1 cA cS co vx cv cA vx cv cA c1 cS opreq2 vx cv cA
      wceq id eqeq12d rcla4cva cW cvc wcel cG cabl wcel cc cX cxp cX cS wf c1
      vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy
      cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy
      cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS
      co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx
      cX wral w3a c1 vx cv cS co vx cv wceq vx cX wral vx vy vz cS cG cW cX
      vci.1 vci.2 vci.3 vci c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co
      cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz
      cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy
      cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      wral wa vy cc wral wa vx cX wral cG cabl wcel c1 vx cv cS co vx cv wceq
      vx cX wral cc cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv
      cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq
      wa vz cc wral wa vy cc wral wa c1 vx cv cS co vx cv wceq vx cX c1 vx cv
      cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz
      cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx
      cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy
      cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral pm3.26
      r19.20si 3ad2ant3 syl sylan $.
      $( [4-Nov-2006] $) $( [3-Nov-2006] $)

    $( Distributive law for the scalar product of a complex vector space. $)
    vcdi $p |- ( ( W e. CVec /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
       ( A S ( B G C ) ) = ( ( A S B ) G ( A S C ) ) ) $=
      cA cc wcel cB cX wcel cC cX wcel w3a cW cvc wcel cA cB cC cG co cS co cA
      cB cS co cA cC cS co cG co wceq cB cX wcel cA cc wcel cC cX wcel cW cvc
      wcel cA cB cC cG co cS co cA cB cS co cA cC cS co cG co wceq wi cB cX
      wcel cA cc wcel cC cX wcel w3a vy cv vx cv vz cv cG co cS co vy cv vx cv
      cS co vy cv vz cv cS co cG co wceq vz cX wral vy cc wral vx cX wral cA cB
      cC cG co cS co cA cB cS co cA cC cS co cG co wceq cW cvc wcel vy cv vx cv
      vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq cA cB cC
      cG co cS co cA cB cS co cA cC cS co cG co wceq vy cv cB vz cv cG co cS co
      vy cv cB cS co vy cv vz cv cS co cG co wceq cA cB vz cv cG co cS co cA cB
      cS co cA vz cv cS co cG co wceq vx vy vz cB cA cC cX cc cX vx cv cB wceq
      vy cv vx cv vz cv cG co cS co vy cv cB vz cv cG co cS co vy cv vx cv cS
      co vy cv vz cv cS co cG co vy cv cB cS co vy cv vz cv cS co cG co vx cv
      cB wceq vx cv vz cv cG co cB vz cv cG co vy cv cS vx cv cB vz cv cG
      opreq1 opreq2d vx cv cB wceq vy cv vx cv cS co vy cv cB cS co vy cv vz cv
      cS co cG vx cv cB vy cv cS opreq2 opreq1d eqeq12d vy cv cA wceq vy cv cB
      vz cv cG co cS co cA cB vz cv cG co cS co vy cv cB cS co vy cv vz cv cS
      co cG co cA cB cS co cA vz cv cS co cG co vy cv cA cB vz cv cG co cS
      opreq1 vy cv cA wceq vy cv cB cS co cA cB cS co vy cv vz cv cS co cA vz
      cv cS co cG vy cv cA cB cS opreq1 vy cv cA vz cv cS opreq1 opreq12d
      eqeq12d vz cv cC wceq cA cB vz cv cG co cS co cA cB cC cG co cS co cA cB
      cS co cA vz cv cS co cG co cA cB cS co cA cC cS co cG co vz cv cC wceq cB
      vz cv cG co cB cC cG co cA cS vz cv cC cB cG opreq2 opreq2d vz cv cC wceq
      cA vz cv cS co cA cC cS co cA cB cS co cG vz cv cC cA cS opreq2 opreq2d
      eqeq12d rcla43v cW cvc wcel cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS
      co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv
      cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv
      cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv
      vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral
      w3a vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG
      co wceq vz cX wral vy cc wral vx cX wral vx vy vz cS cG cW cX vci.1 vci.2
      vci.3 vci c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv
      vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co
      vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv
      cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa
      vy cc wral wa vx cX wral cG cabl wcel vy cv vx cv vz cv cG co cS co vy cv
      vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cc wral vx cX wral
      cc cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS
      co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv
      vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      wral wa vy cc wral wa vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy
      cv vz cv cS co cG co wceq vz cX wral vy cc wral vx cX vy cv vx cv vz cv
      cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq
      wa vz cc wral wa vy cc wral vy cv vx cv vz cv cG co cS co vy cv vx cv cS
      co vy cv vz cv cS co cG co wceq vz cX wral vy cc wral c1 vx cv cS co vx
      cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co
      cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co
      vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv
      vx cv cS co cS co wceq wa vz cc wral wa vy cv vx cv vz cv cG co cS co vy
      cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cc vy cv vx cv
      vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX
      wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc wral pm3.26 r19.20si adantl r19.20si 3ad2ant3 syl syl5
      3com12 impcom $.
      $( [25-Nov-2006] $) $( [3-Nov-2006] $)

    $( Distributive law for the scalar product of a complex vector space. $)
    vcdir $p |- ( ( W e. CVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A + B ) S C ) = ( ( A S C ) G ( B S C ) ) ) $=
      cA cc wcel cB cc wcel cC cX wcel w3a cW cvc wcel cA cB caddc co cC cS co
      cA cC cS co cB cC cS co cG co wceq cC cX wcel cA cc wcel cB cc wcel cW
      cvc wcel cA cB caddc co cC cS co cA cC cS co cB cC cS co cG co wceq wi cC
      cX wcel cA cc wcel cB cc wcel w3a vy cv vz cv caddc co vx cv cS co vy cv
      vx cv cS co vz cv vx cv cS co cG co wceq vz cc wral vy cc wral vx cX wral
      cA cB caddc co cC cS co cA cC cS co cB cC cS co cG co wceq cW cvc wcel vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq cA cB caddc co cC cS co cA cC cS co cB cC cS co cG co wceq vy cv vz
      cv caddc co cC cS co vy cv cC cS co vz cv cC cS co cG co wceq cA vz cv
      caddc co cC cS co cA cC cS co vz cv cC cS co cG co wceq vx vy vz cC cA cB
      cX cc cc vx cv cC wceq vy cv vz cv caddc co vx cv cS co vy cv vz cv caddc
      co cC cS co vy cv vx cv cS co vz cv vx cv cS co cG co vy cv cC cS co vz
      cv cC cS co cG co vx cv cC vy cv vz cv caddc co cS opreq2 vx cv cC wceq
      vy cv vx cv cS co vy cv cC cS co vz cv vx cv cS co vz cv cC cS co cG vx
      cv cC vy cv cS opreq2 vx cv cC vz cv cS opreq2 opreq12d eqeq12d vy cv cA
      wceq vy cv vz cv caddc co cC cS co cA vz cv caddc co cC cS co vy cv cC cS
      co vz cv cC cS co cG co cA cC cS co vz cv cC cS co cG co vy cv cA wceq vy
      cv vz cv caddc co cA vz cv caddc co cC cS vy cv cA vz cv caddc opreq1
      opreq1d vy cv cA wceq vy cv cC cS co cA cC cS co vz cv cC cS co cG vy cv
      cA cC cS opreq1 opreq1d eqeq12d vz cv cB wceq cA vz cv caddc co cC cS co
      cA cB caddc co cC cS co cA cC cS co vz cv cC cS co cG co cA cC cS co cB
      cC cS co cG co vz cv cB wceq cA vz cv caddc co cA cB caddc co cC cS vz cv
      cB cA caddc opreq2 opreq1d vz cv cB wceq vz cv cC cS co cB cC cS co cA cC
      cS co cG vz cv cB cC cS opreq1 opreq2d eqeq12d rcla43v cW cvc wcel cG
      cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv
      cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq
      wa vz cc wral wa vy cc wral wa vx cX wral w3a vy cv vz cv caddc co vx cv
      cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vz cc wral vy cc
      wral vx cX wral vx vy vz cS cG cW cX vci.1 vci.2 vci.3 vci c1 vx cv cS co
      vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS
      co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS
      co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz
      cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral cG
      cabl wcel vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv
      cS co cG co wceq vz cc wral vy cc wral vx cX wral cc cX cxp cX cS wf c1
      vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy
      cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy
      cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS
      co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vz cc wral vy cc wral vx cX vy cv vx cv vz cv cG co cS co vy cv vx
      cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx
      cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul
      co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc
      wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vz cc wral vy cc wral c1 vx cv cS co vx cv wceq vy cv vx cv vz
      cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral
      vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG
      co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc wral wa vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co
      vz cv vx cv cS co cG co wceq vz cc wral vy cc vy cv vz cv caddc co vx cv
      cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co
      vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral vy cv vz cv
      caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vz cc
      wral vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG
      co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz
      cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx
      cv cS co cS co wceq wa vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co
      vz cv vx cv cS co cG co wceq vz cc vy cv vz cv caddc co vx cv cS co vy cv
      vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co
      vy cv vz cv vx cv cS co cS co wceq pm3.26 r19.20si adantl r19.20si adantl
      r19.20si 3ad2ant3 syl syl5 3coml impcom $.
      $( [12-Nov-2006] $) $( [3-Nov-2006] $)

    $( Associative law for the scalar product of a complex vector space. $)
    vcass $p |- ( ( W e. CVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A x. B ) S C ) = ( A S ( B S C ) ) ) $=
      cA cc wcel cB cc wcel cC cX wcel w3a cW cvc wcel cA cB cmul co cC cS co
      cA cB cC cS co cS co wceq cC cX wcel cA cc wcel cB cc wcel cW cvc wcel cA
      cB cmul co cC cS co cA cB cC cS co cS co wceq wi cC cX wcel cA cc wcel cB
      cc wcel w3a vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq vz cc wral vy cc wral vx cX wral cA cB cmul co cC cS co cA cB cC cS
      co cS co wceq cW cvc wcel vy cv vz cv cmul co vx cv cS co vy cv vz cv vx
      cv cS co cS co wceq cA cB cmul co cC cS co cA cB cC cS co cS co wceq vy
      cv vz cv cmul co cC cS co vy cv vz cv cC cS co cS co wceq cA vz cv cmul
      co cC cS co cA vz cv cC cS co cS co wceq vx vy vz cC cA cB cX cc cc vx cv
      cC wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv cmul co cC cS co vy
      cv vz cv vx cv cS co cS co vy cv vz cv cC cS co cS co vx cv cC vy cv vz
      cv cmul co cS opreq2 vx cv cC wceq vz cv vx cv cS co vz cv cC cS co vy cv
      cS vx cv cC vz cv cS opreq2 opreq2d eqeq12d vy cv cA wceq vy cv vz cv
      cmul co cC cS co cA vz cv cmul co cC cS co vy cv vz cv cC cS co cS co cA
      vz cv cC cS co cS co vy cv cA wceq vy cv vz cv cmul co cA vz cv cmul co
      cC cS vy cv cA vz cv cmul opreq1 opreq1d vy cv cA vz cv cC cS co cS
      opreq1 eqeq12d vz cv cB wceq cA vz cv cmul co cC cS co cA cB cmul co cC
      cS co cA vz cv cC cS co cS co cA cB cC cS co cS co vz cv cB wceq cA vz cv
      cmul co cA cB cmul co cC cS vz cv cB cA cmul opreq2 opreq1d vz cv cB wceq
      vz cv cC cS co cB cC cS co cA cS vz cv cB cC cS opreq1 opreq2d eqeq12d
      rcla43v cW cvc wcel cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx cv
      wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG
      co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz
      cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx
      cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral w3a vy cv
      vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq vz cc wral
      vy cc wral vx cX wral vx vy vz cS cG cW cX vci.1 vci.2 vci.3 vci c1 vx cv
      cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz
      cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx
      cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy
      cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral
      cG cabl wcel vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS
      co wceq vz cc wral vy cc wral vx cX wral cc cX cxp cX cS wf c1 vx cv cS
      co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv
      cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv
      cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv
      vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vy cv vz cv
      cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq vz cc wral vy cc
      wral vx cX vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS
      co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS
      co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz
      cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral vy cv vz cv cmul co
      vx cv cS co vy cv vz cv vx cv cS co cS co wceq vz cc wral vy cc wral c1
      vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy
      cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy
      cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS
      co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cv vz cv cmul
      co vx cv cS co vy cv vz cv vx cv cS co cS co wceq vz cc wral vy cc vy cv
      vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq
      vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz
      cc wral vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq vz cc wral vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz
      cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx
      cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy
      cv vz cv vx cv cS co cS co wceq wa vy cv vz cv cmul co vx cv cS co vy cv
      vz cv vx cv cS co cS co wceq vz cc vy cv vz cv caddc co vx cv cS co vy cv
      vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co
      vy cv vz cv vx cv cS co cS co wceq pm3.27 r19.20si adantl r19.20si adantl
      r19.20si 3ad2ant3 syl syl5 3coml impcom $.
      $( [25-Nov-2006] $) $( [3-Nov-2006] $)

    $( A vector plus itself is two times the vector. $)
    vc2 $p |- ( ( W e. CVec /\ A e. X ) -> ( A G A ) = ( 2 S A ) ) $=
      cW cvc wcel cA cX wcel wa c1 cA cS co c1 cA cS co cG co cA cA cG co c2 cA
      cS co cW cvc wcel cA cX wcel wa c1 cA cS co cA c1 cA cS co cA cG cA cS cG
      cW cX vci.1 vci.2 vci.3 vcid cA cS cG cW cX vci.1 vci.2 vci.3 vcid
      opreq12d cW cvc wcel cA cX wcel wa c1 c1 caddc co cA cS co c1 cA cS co c1
      cA cS co cG co c2 cA cS co cW cvc wcel c1 cc wcel cA cX wcel c1 c1 caddc
      co cA cS co c1 cA cS co c1 cA cS co cG co wceq ax1cn cW cvc wcel c1 cc
      wcel c1 cc wcel cA cX wcel c1 c1 caddc co cA cS co c1 cA cS co c1 cA cS
      co cG co wceq ax1cn c1 c1 cA cS cG cW cX vci.1 vci.2 vci.3 vcdir mp3anr1
      mpanr1 c2 c1 c1 caddc co cA cS df-2 opreq1i syl5req eqtr3d $.
      $( [1-Feb-2007] $) $( [1-Feb-2007] $)

    $( Subtractive distributive law for the scalar product of a complex vector
       space. $)
    vcsubdir $p |- ( ( W e. CVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A - B ) S C ) = ( ( A S C ) G ( -u 1 S ( B S C ) ) ) ) $=
      cW cvc wcel cA cc wcel cB cc wcel cC cX wcel w3a wa cA cB cneg caddc co
      cC cS co cA cC cS co cB cneg cC cS co cG co cA cB cmin co cC cS co cA cC
      cS co c1 cneg cB cC cS co cS co cG co cW cvc wcel cA cc wcel cB cneg cc
      wcel cC cX wcel cA cB cneg caddc co cC cS co cA cC cS co cB cneg cC cS co
      cG co wceq cB cc wcel cA cB cneg cC cS cG cW cX vci.1 vci.2 vci.3 vcdir
      cB negcl syl3anr2 cW cvc wcel cA cc wcel cB cc wcel cC cX wcel w3a wa cA
      cB cneg caddc co cA cB cmin co cC cS cA cc wcel cB cc wcel cC cX wcel w3a
      cA cB cneg caddc co cA cB cmin co wceq cW cvc wcel cA cc wcel cB cc wcel
      cA cB cneg caddc co cA cB cmin co wceq cC cX wcel cA cB negsub 3adant3
      adantl opreq1d cW cvc wcel cA cc wcel cB cc wcel cC cX wcel w3a wa cB
      cneg cC cS co c1 cneg cB cC cS co cS co cA cC cS co cG cW cvc wcel cB cc
      wcel cC cX wcel cB cneg cC cS co c1 cneg cB cC cS co cS co wceq cA cc
      wcel cW cvc wcel cB cc wcel cC cX wcel wa wa c1 cneg cB cmul co cC cS co
      cB cneg cC cS co c1 cneg cB cC cS co cS co cW cvc wcel cB cc wcel cC cX
      wcel wa wa c1 cneg cB cmul co cB cneg cC cS cB cc wcel c1 cneg cB cmul co
      cB cneg wceq cW cvc wcel cC cX wcel cB mulm1 ad2antrl opreq1d cW cvc wcel
      c1 cneg cc wcel cB cc wcel cC cX wcel c1 cneg cB cmul co cC cS co c1 cneg
      cB cC cS co cS co wceq c1 ax1cn negcli c1 cneg cB cC cS cG cW cX vci.1
      vci.2 vci.3 vcass mp3anr1 eqtr3d 3adantr1 opreq2d 3eqtr3d $.
      $( [9-Aug-2007] $) $( [31-Jul-2007] $)
  $}

  ${
    $d x y z G $.  $d x y z W $.
    vcabl.1 $e |- G = ( 1st ` W ) $.
    $( Vector addition is an Abelian group operation. $)
    vcabl $p |- ( W e. CVec -> G e. Abel ) $=
      cW cvc wcel cG cabl wcel cc cG crn cxp cG crn cW c2nd cfv wf c1 vx cv cW
      c2nd cfv co vx cv wceq vy cv vx cv vz cv cG co cW c2nd cfv co vy cv vx cv
      cW c2nd cfv co vy cv vz cv cW c2nd cfv co cG co wceq vz cG crn wral vy cv
      vz cv caddc co vx cv cW c2nd cfv co vy cv vx cv cW c2nd cfv co vz cv vx
      cv cW c2nd cfv co cG co wceq vy cv vz cv cmul co vx cv cW c2nd cfv co vy
      cv vz cv vx cv cW c2nd cfv co cW c2nd cfv co wceq wa vz cc wral wa vy cc
      wral wa vx cG crn wral vx vy vz cW c2nd cfv cG cW cG crn vcabl.1 cW c2nd
      cfv eqid cG crn eqid vci 3simp1d $.
      $( [12-Nov-2006] $) $( [3-Nov-2006] $)

    $( Vector addition is a group operation. $)
    vcgrp $p |- ( W e. CVec -> G e. Grp ) $=
      cW cvc wcel cG cabl wcel cG cgr wcel cG cW vcabl.1 vcabl cG ablgrp syl $.
      $( [14-Nov-2006] $) $( [4-Nov-2006] $)
  $}

  ${
    vcgcl.1 $e |- G = ( 1st ` W ) $.
    vcgcl.2 $e |- X = ran G $.
    $( Closure law for the vector addition (group) operation of a complex
       vector space. $)
    vcgcl $p |- ( ( W e. CVec /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      cG cgr wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cW cvc wcel cA cB
      cG cX vcgcl.2 grpcl cG cW vcgcl.1 vcgrp syl3an1 $.
      $( [5-Feb-2007] $) $( [1-Feb-2007] $)
  $}

  ${
    vccom.1 $e |- G = ( 1st ` W ) $.
    vccom.2 $e |- X = ran G $.
    $( Vector addition is commutative. $)
    vccom $p |- ( ( W e. CVec /\ A e. X /\ B e. X ) ->
                ( A G B ) = ( B G A ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cW cvc
      wcel cA cB cG cX vccom.2 ablcom cG cW vccom.1 vcabl syl3an1 $.
      $( [29-Nov-2006] $) $( [4-Nov-2006] $)

    $( Vector addition is associative. $)
    vcaass $p |- ( ( W e. CVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cB cC cG co cG co wceq cW cvc wcel cA cB cC cG cX vccom.2 grpass cG cW
      vccom.1 vcgrp sylan $.
      $( [8-Dec-2006] $) $( [4-Nov-2006] $)

    $( Commutative/associative law that swaps the last two terms in a triple
       vector sum. $)
    vca23 $p |- ( ( W e. CVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
     ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cC cG co cB cG co wceq cW cvc wcel cA cB cC cG cX vccom.2 abl23 cG cW
      vccom.1 vcabl sylan $.
      $( [6-Aug-2007] $) $( [5-Aug-2007] $)

    $( Rearrangement of 4 terms in a vector sum. $)
    vca4 $p |- ( ( W e. CVec /\ ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X )
      ) -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa cA cB cG
      co cC cD cG co cG co cA cC cG co cB cD cG co cG co wceq cW cvc wcel cA cB
      cC cD cG cX vccom.2 abl4 cG cW vccom.1 vcabl syl3an1 $.
      $( [7-Aug-2007] $) $( [5-Aug-2007] $)

    $( Right cancellation law for vector addition. $)
    vcrcan $p |- ( ( W e. CVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cC cG co cB cC cG co
      wceq cA cB wceq wb cW cvc wcel cA cB cC cG cX vccom.2 grprcan cG cW
      vccom.1 vcgrp sylan $.
      $( [11-Apr-2007] $) $( [4-Nov-2006] $)

    $( Left cancellation law for vector addition. $)
    vclcan $p |- ( ( W e. CVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cC cA cG co cC cB cG co
      wceq cA cB wceq wb cW cvc wcel cA cB cC cG cX vccom.2 grplcan cG cW
      vccom.1 vcgrp sylan $.
      $( [14-Nov-2006] $) $( [4-Nov-2006] $)
  $}

  ${
    vczcl.1 $e |- G = ( 1st ` W ) $.
    vczcl.2 $e |- X = ran G $.
    vczcl.3 $e |- Z = ( Id ` G ) $.
    $( The zero vector is a vector. $)
    vczcl $p |- ( W e. CVec -> Z e. X ) $=
      cW cvc wcel cG cgr wcel cZ cX wcel cG cW vczcl.1 vcgrp cZ cG cX vczcl.2
      vczcl.3 grpidcl syl $.
      $( [15-Nov-2006] $) $( [4-Nov-2006] $)

    $( The zero vector is a right identity element. $)
    vc0rid $p |- ( ( W e. CVec /\ A e. X ) -> ( A G Z ) = A ) $=
      cG cgr wcel cA cX wcel cA cZ cG co cA wceq cW cvc wcel cA cZ cG cX
      vczcl.2 vczcl.3 grprid cG cW vczcl.1 vcgrp sylan $.
      $( [15-Nov-2006] $) $( [4-Nov-2006] $)

    $( The zero vector is a left identity element. $)
    vc0lid $p |- ( ( W e. CVec /\ A e. X ) -> ( Z G A ) = A ) $=
      cG cgr wcel cA cX wcel cZ cA cG co cA wceq cW cvc wcel cA cZ cG cX
      vczcl.2 vczcl.3 grplid cG cW vczcl.1 vcgrp sylan $.
      $( [3-May-2007] $) $( [26-Apr-2007] $)
  $}

  ${
    vc0.1 $e |- G = ( 1st ` W ) $.
    vc0.2 $e |- S = ( 2nd ` W ) $.
    vc0.3 $e |- X = ran G $.
    vc0.4 $e |- Z = ( Id ` G ) $.
    $( Zero times a vector is the zero vector.  Equation 1a of [Kreyszig]
       p. 51. $)
    vc0 $p |- ( ( W e. CVec /\ A e. X ) -> ( 0 S A ) = Z ) $=
      cW cvc wcel cA cX wcel wa cA cc0 cA cS co cG co cA cZ cG co wceq cc0 cA
      cS co cZ wceq cW cvc wcel cA cX wcel wa cA cZ cG co cA c1 cA cS co cc0 cA
      cS co cG co cA cc0 cA cS co cG co cA cG cW cX cZ vc0.1 vc0.3 vc0.4 vc0rid
      cW cvc wcel cA cX wcel wa c1 cc0 caddc co cA cS co c1 cA cS co c1 cA cS
      co cc0 cA cS co cG co cA c1 cc0 caddc co cA cS co c1 cA cS co wceq cW cvc
      wcel cA cX wcel wa c1 cc0 caddc co c1 cA cS c1 ax1cn addid1i opreq1i a1i
      cW cvc wcel cc0 cc wcel cA cX wcel c1 cc0 caddc co cA cS co c1 cA cS co
      cc0 cA cS co cG co wceq 0cn cW cvc wcel c1 cc wcel cc0 cc wcel cA cX wcel
      c1 cc0 caddc co cA cS co c1 cA cS co cc0 cA cS co cG co wceq ax1cn c1 cc0
      cA cS cG cW cX vc0.1 vc0.2 vc0.3 vcdir mp3anr1 mpanr1 cA cS cG cW cX
      vc0.1 vc0.2 vc0.3 vcid 3eqtr3d cW cvc wcel cA cX wcel wa c1 cA cS co cA
      cc0 cA cS co cG cA cS cG cW cX vc0.1 vc0.2 vc0.3 vcid opreq1d 3eqtr2rd cW
      cvc wcel cA cX wcel cc0 cA cS co cX wcel cZ cX wcel cA cX wcel w3a cA cc0
      cA cS co cG co cA cZ cG co wceq cc0 cA cS co cZ wceq wb cW cvc wcel cA cX
      wcel wa cc0 cA cS co cX wcel cZ cX wcel cA cX wcel cW cvc wcel cc0 cc
      wcel cA cX wcel cc0 cA cS co cX wcel 0cn cc0 cA cS cG cW cX vc0.1 vc0.2
      vc0.3 vccl mp3an2 cW cvc wcel cZ cX wcel cA cX wcel cG cW cX cZ vc0.1
      vc0.3 vc0.4 vczcl adantr cW cvc wcel cA cX wcel pm3.27 3jca cc0 cA cS co
      cZ cA cG cW cX vc0.1 vc0.3 vclcan syldan mpbid $.
      $( [24-Nov-2006] $) $( [4-Nov-2006] $)

    $( Anything times the zero vector is the zero vector.  Equation 1b of
       [Kreyszig] p. 51. $)
    vcz $p |- ( ( W e. CVec /\ A e. CC ) -> ( A S Z ) = Z ) $=
      cW cvc wcel cA cc wcel wa cA cZ cS co cA cc0 cmul co cZ cS co cc0 cZ cS
      co cZ cW cvc wcel cA cc wcel wa cA cc0 cmul co cZ cS co cA cc0 cZ cS co
      cS co cA cZ cS co cW cvc wcel cA cc wcel cA cc wcel cZ cX wcel wa cA cc0
      cmul co cZ cS co cA cc0 cZ cS co cS co wceq cA cc wcel cW cvc wcel cA cc
      wcel cZ cX wcel wa cW cvc wcel cZ cX wcel cA cc wcel cG cW cX cZ vc0.1
      vc0.3 vc0.4 vczcl anim2i ancoms cW cvc wcel cA cc wcel cc0 cc wcel cZ cX
      wcel cA cc0 cmul co cZ cS co cA cc0 cZ cS co cS co wceq 0cn cA cc0 cZ cS
      cG cW cX vc0.1 vc0.2 vc0.3 vcass mp3anr2 syldan cW cvc wcel cA cc0 cZ cS
      co cS co cA cZ cS co wceq cA cc wcel cW cvc wcel cc0 cZ cS co cZ cA cS cW
      cvc wcel cZ cX wcel cc0 cZ cS co cZ wceq cG cW cX cZ vc0.1 vc0.3 vc0.4
      vczcl cZ cS cG cW cX cZ vc0.1 vc0.2 vc0.3 vc0.4 vc0 mpdan opreq2d adantr
      eqtr2d cA cc wcel cA cc0 cmul co cZ cS co cc0 cZ cS co wceq cW cvc wcel
      cA cc wcel cA cc0 cmul co cc0 cZ cS cA mul01 opreq1d adantl cW cvc wcel
      cc0 cZ cS co cZ wceq cA cc wcel cW cvc wcel cZ cX wcel cc0 cZ cS co cZ
      wceq cG cW cX cZ vc0.1 vc0.3 vc0.4 vczcl cZ cS cG cW cX cZ vc0.1 vc0.2
      vc0.3 vc0.4 vc0 mpdan adantr 3eqtrd $.
      $( [5-Feb-2007] $) $( [24-Nov-2006] $)
  $}

  ${
    vcm.1 $e |- G = ( 1st ` W ) $.
    vcm.2 $e |- S = ( 2nd ` W ) $.
    vcm.3 $e |- X = ran G $.
    vcm.4 $e |- M = ( inv ` G ) $.
    $( Minus 1 times a vector is the underlying group's inverse element.
       Equation 2 of [Kreyszig] p. 51. $)
    vcm $p |- ( ( W e. CVec /\ A e. X ) -> ( -u 1 S A ) = ( M ` A ) ) $=
      cW cvc wcel cA cX wcel wa cG cgi cfv cA cM cfv cG co c1 cneg cA cS co cG
      cgi cfv cG co cA cM cfv c1 cneg cA cS co cW cvc wcel cA cX wcel wa c1
      cneg cA cS co cA cG co cA cM cfv cG co c1 cneg cA cS co cA cA cM cfv cG
      co cG co cG cgi cfv cA cM cfv cG co c1 cneg cA cS co cG cgi cfv cG co cG
      cgr wcel c1 cneg cA cS co cX wcel cA cX wcel cA cM cfv cX wcel w3a c1
      cneg cA cS co cA cG co cA cM cfv cG co c1 cneg cA cS co cA cA cM cfv cG
      co cG co wceq cW cvc wcel cA cX wcel wa c1 cneg cA cS co cA cA cM cfv cG
      cX vcm.3 grpass cW cvc wcel cG cgr wcel cA cX wcel cG cW vcm.1 vcgrp
      adantr cW cvc wcel cA cX wcel wa c1 cneg cA cS co cX wcel cA cX wcel cA
      cM cfv cX wcel cW cvc wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX
      wcel c1 ax1cn negcli c1 cneg cA cS cG cW cX vcm.1 vcm.2 vcm.3 vccl mp3an2
      cW cvc wcel cA cX wcel pm3.27 cG cgr wcel cA cX wcel cA cM cfv cX wcel cW
      cvc wcel cA cG cM cX vcm.3 vcm.4 grpinvcl cG cW vcm.1 vcgrp sylan 3jca
      sylanc cW cvc wcel cA cX wcel wa c1 cneg cA cS co cA cG co cG cgi cfv cA
      cM cfv cG cW cvc wcel cA cX wcel wa c1 cneg cA cS co c1 cA cS co cG co c1
      cneg cA cS co cA cG co cG cgi cfv cW cvc wcel cA cX wcel wa c1 cA cS co
      cA c1 cneg cA cS co cG cA cS cG cW cX vcm.1 vcm.2 vcm.3 vcid opreq2d cW
      cvc wcel cA cX wcel wa c1 cneg c1 caddc co cA cS co cc0 cA cS co c1 cneg
      cA cS co c1 cA cS co cG co cG cgi cfv c1 cneg c1 caddc co cA cS co cc0 cA
      cS co wceq cW cvc wcel cA cX wcel wa c1 cneg c1 caddc co cc0 cA cS c1
      cneg c1 caddc co c1 c1 cneg caddc co cc0 c1 cneg c1 c1 ax1cn negcli ax1cn
      addcomi c1 ax1cn negidi eqtri opreq1i a1i cW cvc wcel c1 cc wcel cA cX
      wcel c1 cneg c1 caddc co cA cS co c1 cneg cA cS co c1 cA cS co cG co wceq
      ax1cn cW cvc wcel c1 cneg cc wcel c1 cc wcel cA cX wcel c1 cneg c1 caddc
      co cA cS co c1 cneg cA cS co c1 cA cS co cG co wceq c1 ax1cn negcli c1
      cneg c1 cA cS cG cW cX vcm.1 vcm.2 vcm.3 vcdir mp3anr1 mpanr1 cA cS cG cW
      cX cG cgi cfv vcm.1 vcm.2 vcm.3 cG cgi cfv eqid vc0 3eqtr3d eqtr3d
      opreq1d cW cvc wcel cA cX wcel wa cA cA cM cfv cG co cG cgi cfv c1 cneg
      cA cS co cG cG cgr wcel cA cX wcel cA cA cM cfv cG co cG cgi cfv wceq cW
      cvc wcel cA cG cgi cfv cG cM cX vcm.3 cG cgi cfv eqid vcm.4 grprinv cG cW
      vcm.1 vcgrp sylan opreq2d 3eqtr3d cG cgr wcel cA cM cfv cX wcel cG cgi
      cfv cA cM cfv cG co cA cM cfv wceq cW cvc wcel cA cX wcel wa cA cM cfv cG
      cgi cfv cG cX vcm.3 cG cgi cfv eqid grplid cW cvc wcel cG cgr wcel cA cX
      wcel cG cW vcm.1 vcgrp adantr cG cgr wcel cA cX wcel cA cM cfv cX wcel cW
      cvc wcel cA cG cM cX vcm.3 vcm.4 grpinvcl cG cW vcm.1 vcgrp sylan sylanc
      cG cgr wcel c1 cneg cA cS co cX wcel c1 cneg cA cS co cG cgi cfv cG co c1
      cneg cA cS co wceq cW cvc wcel cA cX wcel wa c1 cneg cA cS co cG cgi cfv
      cG cX vcm.3 cG cgi cfv eqid grprid cW cvc wcel cG cgr wcel cA cX wcel cG
      cW vcm.1 vcgrp adantr cW cvc wcel c1 cneg cc wcel cA cX wcel c1 cneg cA
      cS co cX wcel c1 ax1cn negcli c1 cneg cA cS cG cW cX vcm.1 vcm.2 vcm.3
      vccl mp3an2 sylanc 3eqtr3rd $.
      $( [4-Dec-2006] $) $( [25-Nov-2006] $)
  $}

  ${
    vcrinv.1 $e |- G = ( 1st ` W ) $.
    vcrinv.2 $e |- S = ( 2nd ` W ) $.
    vcrinv.3 $e |- X = ran G $.
    vcrinv.4 $e |- Z = ( Id ` G ) $.
    $( A vector minus itself. $)
    vcrinv $p |- ( ( W e. CVec /\ A e. X ) -> ( A G ( -u 1 S A ) ) = Z ) $=
      cW cvc wcel cA cX wcel wa cA c1 cneg cA cS co cG co cA cA cG cgn cfv cfv
      cG co cZ cW cvc wcel cA cX wcel wa c1 cneg cA cS co cA cG cgn cfv cfv cA
      cG cA cS cG cG cgn cfv cW cX vcrinv.1 vcrinv.2 vcrinv.3 cG cgn cfv eqid
      vcm opreq2d cG cgr wcel cA cX wcel cA cA cG cgn cfv cfv cG co cZ wceq cW
      cvc wcel cA cZ cG cG cgn cfv cX vcrinv.3 vcrinv.4 cG cgn cfv eqid grprinv
      cG cW vcrinv.1 vcgrp sylan eqtrd $.
      $( [14-Dec-2006] $) $( [4-Dec-2006] $)

    $( Minus a vector plus itself. $)
    vclinv $p |- ( ( W e. CVec /\ A e. X ) -> ( ( -u 1 S A ) G A ) = Z ) $=
      cW cvc wcel cA cX wcel wa c1 cneg cA cS co cA cG co cA cG cgn cfv cfv cA
      cG co cZ cW cvc wcel cA cX wcel wa c1 cneg cA cS co cA cG cgn cfv cfv cA
      cG cA cS cG cG cgn cfv cW cX vcrinv.1 vcrinv.2 vcrinv.3 cG cgn cfv eqid
      vcm opreq1d cG cgr wcel cA cX wcel cA cG cgn cfv cfv cA cG co cZ wceq cW
      cvc wcel cA cZ cG cG cgn cfv cX vcrinv.3 vcrinv.4 cG cgn cfv eqid grplinv
      cG cW vcrinv.1 vcgrp sylan eqtrd $.
      $( [6-Dec-2006] $) $( [4-Dec-2006] $)
  $}

  ${
    vcni.1 $e |- G = ( 1st ` W ) $.
    vcni.2 $e |- S = ( 2nd ` W ) $.
    vcni.3 $e |- X = ran G $.
    $( Double negative of a vector. $)
    vcnegneg $p |- ( ( W e. CVec /\ A e. X ) ->
                  ( -u 1 S ( -u 1 S A ) ) = A ) $=
      cW cvc wcel cA cX wcel wa c1 cneg c1 cneg cmul co cA cS co c1 cneg c1
      cneg cA cS co cS co cA cW cvc wcel c1 cneg cc wcel cA cX wcel c1 cneg c1
      cneg cmul co cA cS co c1 cneg c1 cneg cA cS co cS co wceq c1 ax1cn negcli
      cW cvc wcel c1 cneg cc wcel c1 cneg cc wcel cA cX wcel c1 cneg c1 cneg
      cmul co cA cS co c1 cneg c1 cneg cA cS co cS co wceq c1 ax1cn negcli c1
      cneg c1 cneg cA cS cG cW cX vcni.1 vcni.2 vcni.3 vcass mp3anr1 mpanr1 cW
      cvc wcel cA cX wcel wa c1 cA cS co cA c1 cneg c1 cneg cmul co cA cS co cA
      cS cG cW cX vcni.1 vcni.2 vcni.3 vcid c1 cneg c1 cneg cmul co c1 cA cS c1
      cneg c1 cneg cmul co c1 c1 cmul co c1 c1 c1 ax1cn ax1cn mul2negi c1 ax1cn
      mulid1i eqtri opreq1i syl5eq eqtr3d $.
      $( [10-Aug-2007] $) $( [6-Aug-2007] $)

    $( Distribution of negative over vector subtraction. $)
    vcnegsubdi2 $p |- ( ( W e. CVec /\ A e. X /\ B e. X ) ->
              ( -u 1 S ( A G ( -u 1 S B ) ) ) = ( B G ( -u 1 S A ) ) ) $=
      cW cvc wcel cA cX wcel cB cX wcel w3a c1 cneg cA c1 cneg cB cS co cG co
      cS co c1 cneg cA cS co c1 cneg c1 cneg cB cS co cS co cG co c1 cneg cA cS
      co cB cG co cB c1 cneg cA cS co cG co cW cvc wcel cA cX wcel c1 cneg cB
      cS co cX wcel c1 cneg cA c1 cneg cB cS co cG co cS co c1 cneg cA cS co c1
      cneg c1 cneg cB cS co cS co cG co wceq cB cX wcel cW cvc wcel cA cX wcel
      c1 cneg cB cS co cX wcel c1 cneg cA c1 cneg cB cS co cG co cS co c1 cneg
      cA cS co c1 cneg c1 cneg cB cS co cS co cG co wceq cW cvc wcel c1 cneg cc
      wcel cA cX wcel c1 cneg cB cS co cX wcel c1 cneg cA c1 cneg cB cS co cG
      co cS co c1 cneg cA cS co c1 cneg c1 cneg cB cS co cS co cG co wceq c1
      ax1cn negcli c1 cneg cA c1 cneg cB cS co cS cG cW cX vcni.1 vcni.2 vcni.3
      vcdi mp3anr1 3impb cW cvc wcel cB cX wcel c1 cneg cB cS co cX wcel cA cX
      wcel cW cvc wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel c1
      ax1cn negcli c1 cneg cB cS cG cW cX vcni.1 vcni.2 vcni.3 vccl mp3an2
      3adant2 syld3an3 cW cvc wcel cA cX wcel cB cX wcel w3a c1 cneg c1 cneg cB
      cS co cS co cB c1 cneg cA cS co cG cW cvc wcel cB cX wcel c1 cneg c1 cneg
      cB cS co cS co cB wceq cA cX wcel cB cS cG cW cX vcni.1 vcni.2 vcni.3
      vcnegneg 3adant2 opreq2d cW cvc wcel c1 cneg cA cS co cX wcel cB cX wcel
      c1 cneg cA cS co cB cG co cB c1 cneg cA cS co cG co wceq cA cX wcel c1
      cneg cA cS co cB cG cW cX vcni.1 vcni.3 vccom cW cvc wcel cA cX wcel c1
      cneg cA cS co cX wcel cB cX wcel cW cvc wcel c1 cneg cc wcel cA cX wcel
      c1 cneg cA cS co cX wcel c1 ax1cn negcli c1 cneg cA cS cG cW cX vcni.1
      vcni.2 vcni.3 vccl mp3an2 3adant3 syld3an2 3eqtrd $.
      $( [12-Aug-2007] $) $( [6-Aug-2007] $)

    $( Rearrangement of 4 terms in a mixed vector addition and subtraction. $)
    vcsub4 $p |- ( ( W e. CVec /\ ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X )
              ) -> ( ( A G B ) G ( -u 1 S ( C G D ) ) ) =
            ( ( A G ( -u 1 S C ) ) G ( B G ( -u 1 S D ) ) ) ) $=
      cW cvc wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa w3a cA cB
      cG co c1 cneg cC cD cG co cS co cG co cA cB cG co c1 cneg cC cS co c1
      cneg cD cS co cG co cG co cA c1 cneg cC cS co cG co cB c1 cneg cD cS co
      cG co cG co cW cvc wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa
      w3a c1 cneg cC cD cG co cS co c1 cneg cC cS co c1 cneg cD cS co cG co cA
      cB cG co cG cW cvc wcel cC cX wcel cD cX wcel wa c1 cneg cC cD cG co cS
      co c1 cneg cC cS co c1 cneg cD cS co cG co wceq cA cX wcel cB cX wcel wa
      cW cvc wcel c1 cneg cc wcel cC cX wcel cD cX wcel c1 cneg cC cD cG co cS
      co c1 cneg cC cS co c1 cneg cD cS co cG co wceq c1 ax1cn negcli c1 cneg
      cC cD cS cG cW cX vcni.1 vcni.2 vcni.3 vcdi mp3anr1 3adant2 opreq2d cW
      cvc wcel cA cX wcel cB cX wcel wa c1 cneg cC cS co cX wcel c1 cneg cD cS
      co cX wcel wa cA cB cG co c1 cneg cC cS co c1 cneg cD cS co cG co cG co
      cA c1 cneg cC cS co cG co cB c1 cneg cD cS co cG co cG co wceq cC cX wcel
      cD cX wcel wa cA cB c1 cneg cC cS co c1 cneg cD cS co cG cW cX vcni.1
      vcni.3 vca4 cW cvc wcel cC cX wcel cD cX wcel wa c1 cneg cC cS co cX wcel
      c1 cneg cD cS co cX wcel wa cA cX wcel cB cX wcel wa cW cvc wcel cC cX
      wcel cD cX wcel c1 cneg cC cS co cX wcel c1 cneg cD cS co cX wcel wa cW
      cvc wcel cC cX wcel wa c1 cneg cC cS co cX wcel cW cvc wcel cD cX wcel wa
      c1 cneg cD cS co cX wcel cW cvc wcel c1 cneg cc wcel cC cX wcel c1 cneg
      cC cS co cX wcel c1 ax1cn negcli c1 cneg cC cS cG cW cX vcni.1 vcni.2
      vcni.3 vccl mp3an2 cW cvc wcel c1 cneg cc wcel cD cX wcel c1 cneg cD cS
      co cX wcel c1 ax1cn negcli c1 cneg cD cS cG cW cX vcni.1 vcni.2 vcni.3
      vccl mp3an2 anim12i anandis 3adant2 syld3an3 eqtrd $.
      $( [25-Aug-2007] $) $( [5-Aug-2007] $)
  $}

  ${
    $d g s x y z G $.  $d g s x y z S $.  $d g s x z X $.
    isvclem.1 $e |- X = ran G $.
    $( Lemma for ~ isvc . $)
    isvclem $p |- ( ( G e. _V /\ S e. _V ) -> ( <. G , S >. e. CVec
      <-> ( G e. Abel /\ S :  ( CC X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. CC ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. CC ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) ) $=
      cG cvv wcel cS cvv wcel wa cG cS cop vg cv cabl wcel cc vg cv crn cxp vg
      cv crn vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co
      vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv
      crn wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz
      cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc wral wa vx vg cv
      crn wral w3a vg vs copab wcel cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS
      co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv
      cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv
      cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv
      vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral
      w3a cG cS cop cvc wcel vg cv cabl wcel cc vg cv crn cxp vg cv crn vs cv
      wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv
      vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv
      vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co
      vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv
      co vs cv co wceq wa vz cc wral wa vy cc wral wa vx vg cv crn wral w3a cG
      cabl wcel cc cX cxp cX vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv
      vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq
      vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv
      vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc wral wa vx cX wral
      w3a cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy cv vx cv
      vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX
      wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc wral wa vy cc wral wa vx cX wral w3a vg vs cG cS cvv cvv vg
      cv cG wceq vg cv cabl wcel cG cabl wcel cc vg cv crn cxp vg cv crn vs cv
      wf cc cX cxp cX vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv
      vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq
      vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv
      co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co
      vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc wral wa
      vx vg cv crn wral c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs
      cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv
      co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv
      co vs cv co wceq wa vz cc wral wa vy cc wral wa vx cX wral vg cv cG cabl
      eleq1 vg cv cG wceq vg cv crn cX wceq cc vg cv crn cxp vg cv crn vs cv wf
      cc cX cxp cX vs cv wf wb vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq
      isvclem.1 syl6eqr vg cv crn cX wceq cc vg cv crn cxp vg cv crn vs cv wf
      cc cX cxp vg cv crn vs cv wf cc cX cxp cX vs cv wf vg cv crn cX wceq cc
      vg cv crn cxp cc cX cxp wceq cc vg cv crn cxp vg cv crn vs cv wf cc cX
      cxp vg cv crn vs cv wf wb vg cv crn cX cc xpeq2 cc vg cv crn cxp cc cX
      cxp vg cv crn vs cv feq2 syl vg cv crn cX cc cX cxp vs cv feq3 bitrd syl
      vg cv cG wceq c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs
      cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv
      crn wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz
      cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc wral wa c1 vx cv
      vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co
      vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs
      cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv
      cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc
      wral wa vy cc wral wa vx vg cv crn cX vg cv cG wceq vg cv crn cG crn cX
      vg cv cG rneq isvclem.1 syl6eqr vg cv cG wceq vy cv vx cv vz cv vg cv co
      vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv
      crn wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz
      cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc wral vy cv vx cv
      vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq
      vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv
      vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc wral c1 vx cv vs cv
      co vx cv wceq vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx
      cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz
      cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg
      cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co
      vs cv co wceq wa vz cc wral wa vy cv vx cv vz cv cG co vs cv co vy cv vx
      cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc
      co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy
      cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq
      wa vz cc wral wa vy cc vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co
      vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral
      vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv
      vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv
      co wceq wa vz cc wral vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co
      vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co wceq vy cv vx cv vz cv
      cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz vg
      cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isvclem.1
      syl6eqr vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vz
      cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co vg cv co vy
      cv vx cv vs cv co vy cv vz cv vs cv co cG co vg cv cG wceq vx cv vz cv vg
      cv co vx cv vz cv cG co vy cv vs cv vx cv vz cv vg cv cG opreq opreq2d vy
      cv vx cv vs cv co vy cv vz cv vs cv co vg cv cG opreq eqeq12d raleq12d vg
      cv cG wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz
      cv vx cv vs cv co vs cv co wceq wa vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc vg cv cG
      wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv
      vs cv co vg cv co wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs
      cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co
      vy cv vz cv vx cv vs cv co vs cv co wceq vg cv cG wceq vy cv vx cv vs cv
      co vz cv vx cv vs cv co vg cv co vy cv vx cv vs cv co vz cv vx cv vs cv
      co cG co vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv
      vx cv vs cv co vg cv cG opreq eqeq2d anbi1d ralbidv anbi12d ralbidv
      anbi2d raleq12d 3anbi123d vs cv cS wceq cc cX cxp cX vs cv wf cc cX cxp
      cX cS wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv co vy
      cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv
      co wceq wa vz cc wral wa vy cc wral wa vx cX wral c1 vx cv cS co vx cv
      wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG
      co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz
      cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx
      cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral cG cabl
      wcel cc cX cxp cX vs cv cS feq1 vs cv cS wceq c1 vx cv vs cv co vx cv
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cc
      wral wa c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx
      cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx
      cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul
      co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc
      wral wa vx cX vs cv cS wceq c1 vx cv vs cv co vx cv wceq c1 vx cv cS co
      vx cv wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz
      cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy
      cc wral vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co
      cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co
      vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv
      vx cv cS co cS co wceq wa vz cc wral wa vy cc wral vs cv cS wceq c1 vx cv
      vs cv co c1 vx cv cS co vx cv c1 vx cv vs cv cS opreq eqeq1d vs cv cS
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cc wral wa vy cv vx
      cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX
      wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc wral wa vy cc vs cv cS wceq vy cv vx cv vz cv cG co vs cv
      co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv
      vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz
      cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx
      cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx
      cv vs cv co vs cv co wceq wa vz cc wral vy cv vz cv caddc co vx cv cS co
      vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv
      cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral vs cv cS wceq vy
      cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co
      cG co wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS
      co cG co wceq vz cX vs cv cS wceq vy cv vx cv vz cv cG co vs cv co vy cv
      vx cv vz cv cG co cS co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co
      vy cv vx cv cS co vy cv vz cv cS co cG co vy cv vx cv vz cv cG co vs cv
      cS opreq vs cv cS wceq vy cv vx cv vs cv co vy cv vx cv cS co vy cv vz cv
      vs cv co vy cv vz cv cS co cG vy cv vx cv vs cv cS opreq vy cv vz cv vs
      cv cS opreq opreq12d eqeq12d ralbidv vs cv cS wceq vy cv vz cv caddc co
      vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG
      co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cc vs cv cS wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv caddc co vx cv cS
      co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx
      cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq vy cv vz cv cmul co
      vx cv cS co vy cv vz cv vx cv cS co cS co wceq vs cv cS wceq vy cv vz cv
      caddc co vx cv vs cv co vy cv vz cv caddc co vx cv cS co vy cv vx cv vs
      cv co vz cv vx cv vs cv co cG co vy cv vx cv cS co vz cv vx cv cS co cG
      co vy cv vz cv caddc co vx cv vs cv cS opreq vs cv cS wceq vy cv vx cv vs
      cv co vy cv vx cv cS co vz cv vx cv vs cv co vz cv vx cv cS co cG vy cv
      vx cv vs cv cS opreq vz cv vx cv vs cv cS opreq opreq12d eqeq12d vs cv cS
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv cmul co vx cv cS co
      vy cv vz cv vx cv vs cv co vs cv co vy cv vz cv vx cv cS co cS co vy cv
      vz cv cmul co vx cv vs cv cS opreq vs cv cS wceq vy cv vz cv vx cv vs cv
      co vs cv co vy cv vz cv vx cv vs cv co cS co vy cv vz cv vx cv cS co cS
      co vy cv vz cv vx cv vs cv co vs cv cS opreq vs cv cS wceq vz cv vx cv vs
      cv co vz cv vx cv cS co vy cv cS vz cv vx cv vs cv cS opreq opreq2d eqtrd
      eqeq12d anbi12d ralbidv anbi12d ralbidv anbi12d ralbidv 3anbi23d
      opelopabg cvc vg cv cabl wcel cc vg cv crn cxp vg cv crn vs cv wf c1 vx
      cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs
      cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cc wral wa vy cc wral wa vx vg cv crn wral w3a vg vs
      copab cG cS cop vx vy vz vg vs df-vc eleq2i syl5bb $.
      $( [2-Jun-2008] $) $( [31-May-2008] $)
  $}

  ${
    $d x y z G $.
    $( Lemma for ~ vcoprne . $)
    vcoprnelem $p |- ( <. G , G >. e. CVec -> G : ( CC X. CC ) --> CC ) $=
      cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cG wf cG cG cop cvc wcel cG
      cG cop cvv cvv cxp wcel cG cvv wcel cvc cvv cvv cxp cG cG cop cvc wrel
      cvc cvv cvv cxp wss vcrel cvc df-rel mpbi sseli cG cG cvv cvv opelxp1 syl
      cG cvv wcel cG cG cop cvc wcel wa cG cabl wcel cc cG crn cxp cG crn cG wf
      c1 vx cv cG co vx cv wceq vy cv vx cv vz cv cG co cG co vy cv vx cv cG co
      vy cv vz cv cG co cG co wceq vz cG crn wral vy cv vz cv caddc co vx cv cG
      co vy cv vx cv cG co vz cv vx cv cG co cG co wceq vy cv vz cv cmul co vx
      cv cG co vy cv vz cv vx cv cG co cG co wceq wa vz cc wral wa vy cc wral
      wa vx cG crn wral w3a cc cc cxp cc cG wf cG cvv wcel cG cG cop cvc wcel
      cG cabl wcel cc cG crn cxp cG crn cG wf c1 vx cv cG co vx cv wceq vy cv
      vx cv vz cv cG co cG co vy cv vx cv cG co vy cv vz cv cG co cG co wceq vz
      cG crn wral vy cv vz cv caddc co vx cv cG co vy cv vx cv cG co vz cv vx
      cv cG co cG co wceq vy cv vz cv cmul co vx cv cG co vy cv vz cv vx cv cG
      co cG co wceq wa vz cc wral wa vy cc wral wa vx cG crn wral w3a cG cvv
      wcel cG cG cop cvc wcel cG cabl wcel cc cG crn cxp cG crn cG wf c1 vx cv
      cG co vx cv wceq vy cv vx cv vz cv cG co cG co vy cv vx cv cG co vy cv vz
      cv cG co cG co wceq vz cG crn wral vy cv vz cv caddc co vx cv cG co vy cv
      vx cv cG co vz cv vx cv cG co cG co wceq vy cv vz cv cmul co vx cv cG co
      vy cv vz cv vx cv cG co cG co wceq wa vz cc wral wa vy cc wral wa vx cG
      crn wral w3a wb vx vy vz cG cG cG crn cG crn eqid isvclem anidms biimpa
      cG cabl wcel cc cG crn cxp cG crn cG wf cc cc cxp cc cG wf c1 vx cv cG co
      vx cv wceq vy cv vx cv vz cv cG co cG co vy cv vx cv cG co vy cv vz cv cG
      co cG co wceq vz cG crn wral vy cv vz cv caddc co vx cv cG co vy cv vx cv
      cG co vz cv vx cv cG co cG co wceq vy cv vz cv cmul co vx cv cG co vy cv
      vz cv vx cv cG co cG co wceq wa vz cc wral wa vy cc wral wa vx cG crn
      wral cG cabl wcel cc cG crn cxp cG crn cG wf wa cc cG crn cxp cG crn cG
      wf cc cc cxp cc cG wf cG cabl wcel cc cG crn cxp cG crn cG wf pm3.27 cG
      cabl wcel cc cG crn cxp cG crn cG wf wa cG crn cc wceq cc cG crn cxp cG
      crn cG wf cc cc cxp cc cG wf wb cG cgr wcel cc cG crn cxp cG crn cG wf cG
      crn cc wceq cG cabl wcel cG cgr wcel cc cG crn cxp cG crn cG wf wa cG crn
      cG crn cxp cc cG crn cxp wceq cG crn cc wceq cG cG crn cG crn cxp wfn cG
      cc cG crn cxp wfn cG crn cG crn cxp cc cG crn cxp wceq cG cgr wcel cc cG
      crn cxp cG crn cG wf cG crn cG crn cxp cc cG crn cxp cG fndmu cG cgr wcel
      cG crn cG crn cxp cG crn cG wfo cG cG crn cG crn cxp wfn cG cG crn cG crn
      eqid grpfo cG crn cG crn cxp cG crn cG fofn syl cc cG crn cxp cG crn cG
      ffn syl2an cG cgr wcel cG crn cG crn cxp cc cG crn cxp wceq cG crn cc
      wceq wb cc cG crn cxp cG crn cG wf cG cgr wcel cG crn c0 wne cG crn cG
      crn cxp cc cG crn cxp wceq cG crn cc wceq wb cG cG crn cG crn eqid grpn0
      cG crn cc xp11a syl adantr mpbid cG ablgrp sylan cG crn cc wceq cc cG crn
      cxp cG crn cG wf cc cc cxp cG crn cG wf cc cc cxp cc cG wf cG crn cc wceq
      cc cG crn cxp cc cc cxp wceq cc cG crn cxp cG crn cG wf cc cc cxp cG crn
      cG wf wb cG crn cc cc xpeq2 cc cG crn cxp cc cc cxp cG crn cG feq2 syl cG
      crn cc cc cc cxp cG feq3 bitrd syl mpbid 3adant3 syl mpancom $.
      $( [1-Jun-2008] $) $( [31-May-2008] $)
  $}

  $( The operations of a complex vector space cannot be identical. $)
  vcoprne $p |- ( <. G , S >. e. CVec -> G =/= S ) $=
    cG cS cop cvc wcel cG cS cG cS wceq cG cG cop cvc wcel cG cS cop cvc wcel
    cG cG cop cvc wcel c1 cc0 wceq c1 cc0 wne c1 cc0 wceq wn ax1ne0 c1 cc0
    df-ne mpbi cG cG cop cvc wcel cc0 c1 cG co cc0 cG cG cop c1st cfv cgi cfv
    cG cG cop c1st cfv co c1 cc0 cG cG cop cvc wcel cc0 cG cG cop c1st cfv cgi
    cfv cG cG cop c1st cfv co cc0 cG cG cop c1st cfv cgi cfv cG co cc0 c1 cG co
    cG cG cop cvc wcel cG cG cop c1st cfv cG cc0 cG cG cop c1st cfv cgi cfv cG
    cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf
    cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex
    cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl opreqd
    cG cG cop cvc wcel cG cG cop c1st cfv cgi cfv c1 cc0 cG cG cG cop cvc wcel
    c1 cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 c1 cG cG cop c1st
    cfv co wceq cG cG cop c1st cfv cgi cfv c1 wceq cG cG cop cvc wcel c1 cG cG
    cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 c1 c1 cG cG cop c2nd cfv co
    c1 c1 cG cG cop c1st cfv co cG cG cop cvc wcel c1 cG cG cop c1st cfv crn
    wcel c1 cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 wceq cG cG cop
    cvc wcel cc cG cG cop c1st cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv
    crn cG crn cG cdm cdm cc cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop
    cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc
    cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG
    cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG
    cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG
    wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel
    cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG
    cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv eqid
    vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm
    cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG
    wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc
    dmxpid syl6eq 3eqtrd ax1cn syl5eleqr c1 cG cG cop c1st cfv cG cG cop cG cG
    cop c1st cfv crn cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv eqid cG cG
    cop c1st cfv crn eqid cG cG cop c1st cfv cgi cfv eqid vc0rid mpdan cG cG
    cop cvc wcel c1 cG cG cop c1st cfv crn wcel c1 c1 cG cG cop c2nd cfv co c1
    wceq cG cG cop cvc wcel cc cG cG cop c1st cfv crn c1 cG cG cop cvc wcel cG
    cG cop c1st cfv crn cG crn cG cdm cdm cc cG cG cop cvc wcel cG cG cop c1st
    cfv cG cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp
    cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv
    cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl
    rneqd cG cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc
    wcel cG cG cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG cG cop
    c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG
    cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex
    sylancl cG cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG cop c1st
    cfv eqid vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm cdm cc cc
    cxp cdm cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel cc cc cxp
    cc cG wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd
    cc dmxpid syl6eq 3eqtrd ax1cn syl5eleqr c1 cG cG cop c2nd cfv cG cG cop
    c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG cop c1st cfv eqid cG cG cop
    c2nd cfv eqid cG cG cop c1st cfv crn eqid vcid mpdan cG cG cop cvc wcel cG
    cG cop c2nd cfv cG cG cop c1st cfv c1 c1 cG cG cop cvc wcel cG cG cop c2nd
    cfv cG cG cG cop c1st cfv cG cG cop cvc wcel cG cvv wcel cG cG cop c2nd cfv
    cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc
    wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl
    cG cvv wcel cG cG cop c2nd cfv cG wceq cG cG cvv cvv op2ndg anidms syl cG
    cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf
    cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex
    cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl eqtr4d
    opreqd 3eqtr2d cG cG cop cvc wcel cG cG cop c1st cfv cgi cfv cG cG cop c1st
    cfv crn wcel c1 cG cG cop c1st cfv crn wcel c1 cG cG cop c1st cfv crn wcel
    w3a c1 cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 c1 cG cG cop
    c1st cfv co wceq cG cG cop c1st cfv cgi cfv c1 wceq wb cG cG cop cvc wcel
    cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv crn wcel c1 cG cG cop c1st
    cfv crn wcel c1 cG cG cop c1st cfv crn wcel cG cG cop c1st cfv cG cG cop cG
    cG cop c1st cfv crn cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv eqid cG
    cG cop c1st cfv crn eqid cG cG cop c1st cfv cgi cfv eqid vczcl cG cG cop
    cvc wcel cc cG cG cop c1st cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv
    crn cG crn cG cdm cdm cc cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop
    cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc
    cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG
    cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG
    cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG
    wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel
    cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG
    cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv eqid
    vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm
    cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG
    wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc
    dmxpid syl6eq 3eqtrd ax1cn syl5eleqr cG cG cop cvc wcel cc cG cG cop c1st
    cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv crn cG crn cG cdm cdm cc
    cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc wcel cG cvv wcel cG
    cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel
    cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex
    axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG cG cop cvc wcel cG cgr
    wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG cop c1st cfv cG cgr cG
    cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf
    cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex
    cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl cG cG
    cop c1st cfv cG cG cop cG cG cop c1st cfv eqid vcgrp eqeltrrd cG grprndm
    syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm cc cG cG cop cvc wcel cG
    cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG wf cG cdm cc cc cxp wceq
    cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc dmxpid syl6eq 3eqtrd ax1cn
    syl5eleqr 3jca cG cG cop c1st cfv cgi cfv c1 c1 cG cG cop c1st cfv cG cG
    cop cG cG cop c1st cfv crn cG cG cop c1st cfv eqid cG cG cop c1st cfv crn
    eqid vclcan mpdan mpbid opreq2d eqtr2d cG cG cop cvc wcel cc0 cG cG cop
    c1st cfv cgi cfv cG cG cop c2nd cfv co cG cG cop c1st cfv cgi cfv cc0 c1 cG
    co c1 cG cG cop cvc wcel cc0 cc wcel cc0 cG cG cop c1st cfv cgi cfv cG cG
    cop c2nd cfv co cG cG cop c1st cfv cgi cfv wceq 0cn cc0 cG cG cop c2nd cfv
    cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG cop c1st cfv cgi
    cfv cG cG cop c1st cfv eqid cG cG cop c2nd cfv eqid cG cG cop c1st cfv crn
    eqid cG cG cop c1st cfv cgi cfv eqid vcz mpan2 cG cG cop cvc wcel cc0 cG cG
    cop c1st cfv cgi cfv cG cG cop c2nd cfv co cc0 cG cG cop c1st cfv cgi cfv
    cG co cc0 c1 cG co cG cG cop cvc wcel cG cG cop c2nd cfv cG cc0 cG cG cop
    c1st cfv cgi cfv cG cG cop cvc wcel cG cvv wcel cG cG cop c2nd cfv cG wceq
    cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc
    cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cvv
    wcel cG cG cop c2nd cfv cG wceq cG cG cvv cvv op2ndg anidms syl opreqd cG
    cG cop cvc wcel cG cG cop c1st cfv cgi cfv c1 cc0 cG cG cG cop cvc wcel c1
    cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 c1 cG cG cop c1st cfv
    co wceq cG cG cop c1st cfv cgi cfv c1 wceq cG cG cop cvc wcel c1 cG cG cop
    c1st cfv cgi cfv cG cG cop c1st cfv co c1 c1 c1 cG cG cop c2nd cfv co c1 c1
    cG cG cop c1st cfv co cG cG cop cvc wcel c1 cG cG cop c1st cfv crn wcel c1
    cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 wceq cG cG cop cvc wcel
    cc cG cG cop c1st cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv crn cG
    crn cG cdm cdm cc cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc
    wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp
    cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG
    cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG
    cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG
    wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel
    cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG
    cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv eqid
    vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm
    cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG
    wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc
    dmxpid syl6eq 3eqtrd ax1cn syl5eleqr c1 cG cG cop c1st cfv cG cG cop cG cG
    cop c1st cfv crn cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv eqid cG cG
    cop c1st cfv crn eqid cG cG cop c1st cfv cgi cfv eqid vc0rid mpdan cG cG
    cop cvc wcel c1 cG cG cop c1st cfv crn wcel c1 c1 cG cG cop c2nd cfv co c1
    wceq cG cG cop cvc wcel cc cG cG cop c1st cfv crn c1 cG cG cop cvc wcel cG
    cG cop c1st cfv crn cG crn cG cdm cdm cc cG cG cop cvc wcel cG cG cop c1st
    cfv cG cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp
    cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv
    cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl
    rneqd cG cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc
    wcel cG cG cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG cG cop
    c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG
    cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex
    sylancl cG cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG cop c1st
    cfv eqid vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm cdm cc cc
    cxp cdm cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel cc cc cxp
    cc cG wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd
    cc dmxpid syl6eq 3eqtrd ax1cn syl5eleqr c1 cG cG cop c2nd cfv cG cG cop
    c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG cop c1st cfv eqid cG cG cop
    c2nd cfv eqid cG cG cop c1st cfv crn eqid vcid mpdan cG cG cop cvc wcel cG
    cG cop c2nd cfv cG cG cop c1st cfv c1 c1 cG cG cop cvc wcel cG cG cop c2nd
    cfv cG cG cG cop c1st cfv cG cG cop cvc wcel cG cvv wcel cG cG cop c2nd cfv
    cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc
    wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl
    cG cvv wcel cG cG cop c2nd cfv cG wceq cG cG cvv cvv op2ndg anidms syl cG
    cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf
    cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex
    cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl eqtr4d
    opreqd 3eqtr2d cG cG cop cvc wcel cG cG cop c1st cfv cgi cfv cG cG cop c1st
    cfv crn wcel c1 cG cG cop c1st cfv crn wcel c1 cG cG cop c1st cfv crn wcel
    w3a c1 cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv co c1 c1 cG cG cop
    c1st cfv co wceq cG cG cop c1st cfv cgi cfv c1 wceq wb cG cG cop cvc wcel
    cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv crn wcel c1 cG cG cop c1st
    cfv crn wcel c1 cG cG cop c1st cfv crn wcel cG cG cop c1st cfv cG cG cop cG
    cG cop c1st cfv crn cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv eqid cG
    cG cop c1st cfv crn eqid cG cG cop c1st cfv cgi cfv eqid vczcl cG cG cop
    cvc wcel cc cG cG cop c1st cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv
    crn cG crn cG cdm cdm cc cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop
    cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc
    cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG
    cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG
    cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG
    wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel
    cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG
    cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv eqid
    vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm
    cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG
    wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc
    dmxpid syl6eq 3eqtrd ax1cn syl5eleqr cG cG cop cvc wcel cc cG cG cop c1st
    cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv crn cG crn cG cdm cdm cc
    cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc wcel cG cvv wcel cG
    cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel
    cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex
    axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG cG cop cvc wcel cG cgr
    wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG cop c1st cfv cG cgr cG
    cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf
    cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex
    cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl cG cG
    cop c1st cfv cG cG cop cG cG cop c1st cfv eqid vcgrp eqeltrrd cG grprndm
    syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm cc cG cG cop cvc wcel cG
    cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG wf cG cdm cc cc cxp wceq
    cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc dmxpid syl6eq 3eqtrd ax1cn
    syl5eleqr 3jca cG cG cop c1st cfv cgi cfv c1 c1 cG cG cop c1st cfv cG cG
    cop cG cG cop c1st cfv crn cG cG cop c1st cfv eqid cG cG cop c1st cfv crn
    eqid vclcan mpdan mpbid opreq2d eqtrd cG cG cop cvc wcel c1 cG cG cop c1st
    cfv cgi cfv cG cG cop c1st cfv co c1 c1 cG cG cop c1st cfv co wceq cG cG
    cop c1st cfv cgi cfv c1 wceq cG cG cop cvc wcel c1 cG cG cop c1st cfv cgi
    cfv cG cG cop c1st cfv co c1 c1 c1 cG cG cop c2nd cfv co c1 c1 cG cG cop
    c1st cfv co cG cG cop cvc wcel c1 cG cG cop c1st cfv crn wcel c1 cG cG cop
    c1st cfv cgi cfv cG cG cop c1st cfv co c1 wceq cG cG cop cvc wcel cc cG cG
    cop c1st cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv crn cG crn cG cdm
    cdm cc cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc wcel cG cvv
    wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG
    cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc
    axcnex axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG cG cop cvc wcel cG
    cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG cop c1st cfv cG
    cgr cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc
    cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG
    fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl cG
    cG cop c1st cfv cG cG cop cG cG cop c1st cfv eqid vcgrp eqeltrrd cG grprndm
    syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm cc cG cG cop cvc wcel cG
    cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG wf cG cdm cc cc cxp wceq
    cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc dmxpid syl6eq 3eqtrd ax1cn
    syl5eleqr c1 cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG cop
    c1st cfv cgi cfv cG cG cop c1st cfv eqid cG cG cop c1st cfv crn eqid cG cG
    cop c1st cfv cgi cfv eqid vc0rid mpdan cG cG cop cvc wcel c1 cG cG cop c1st
    cfv crn wcel c1 c1 cG cG cop c2nd cfv co c1 wceq cG cG cop cvc wcel cc cG
    cG cop c1st cfv crn c1 cG cG cop cvc wcel cG cG cop c1st cfv crn cG crn cG
    cdm cdm cc cG cG cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc wcel cG
    cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel
    cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc
    axcnex axcnex xpex sylancl cG cG cvv op1stg syl rneqd cG cG cop cvc wcel cG
    cgr wcel cG crn cG cdm cdm wceq cG cG cop cvc wcel cG cG cop c1st cfv cG
    cgr cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc
    cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG
    fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl cG
    cG cop c1st cfv cG cG cop cG cG cop c1st cfv eqid vcgrp eqeltrrd cG grprndm
    syl cG cG cop cvc wcel cG cdm cdm cc cc cxp cdm cc cG cG cop cvc wcel cG
    cdm cc cc cxp cG cG cop cvc wcel cc cc cxp cc cG wf cG cdm cc cc cxp wceq
    cG vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc dmxpid syl6eq 3eqtrd ax1cn
    syl5eleqr c1 cG cG cop c2nd cfv cG cG cop c1st cfv cG cG cop cG cG cop c1st
    cfv crn cG cG cop c1st cfv eqid cG cG cop c2nd cfv eqid cG cG cop c1st cfv
    crn eqid vcid mpdan cG cG cop cvc wcel cG cG cop c2nd cfv cG cG cop c1st
    cfv c1 c1 cG cG cop cvc wcel cG cG cop c2nd cfv cG cG cG cop c1st cfv cG cG
    cop cvc wcel cG cvv wcel cG cG cop c2nd cfv cG wceq cc cc cxp cc cG wf cc
    cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cvv wcel cG cG cop c2nd cfv
    cG wceq cG cG cvv cvv op2ndg anidms syl cG cG cop cvc wcel cG cvv wcel cG
    cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel
    cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex
    axcnex xpex sylancl cG cG cvv op1stg syl eqtr4d opreqd 3eqtr2d cG cG cop
    cvc wcel cG cG cop c1st cfv cgi cfv cG cG cop c1st cfv crn wcel c1 cG cG
    cop c1st cfv crn wcel c1 cG cG cop c1st cfv crn wcel w3a c1 cG cG cop c1st
    cfv cgi cfv cG cG cop c1st cfv co c1 c1 cG cG cop c1st cfv co wceq cG cG
    cop c1st cfv cgi cfv c1 wceq wb cG cG cop cvc wcel cG cG cop c1st cfv cgi
    cfv cG cG cop c1st cfv crn wcel c1 cG cG cop c1st cfv crn wcel c1 cG cG cop
    c1st cfv crn wcel cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG
    cop c1st cfv cgi cfv cG cG cop c1st cfv eqid cG cG cop c1st cfv crn eqid cG
    cG cop c1st cfv cgi cfv eqid vczcl cG cG cop cvc wcel cc cG cG cop c1st cfv
    crn c1 cG cG cop cvc wcel cG cG cop c1st cfv crn cG crn cG cdm cdm cc cG cG
    cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc wcel cG cvv wcel cG cG cop
    c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG
    cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex
    sylancl cG cG cvv op1stg syl rneqd cG cG cop cvc wcel cG cgr wcel cG crn cG
    cdm cdm wceq cG cG cop cvc wcel cG cG cop c1st cfv cG cgr cG cG cop cvc
    wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp
    cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl cG cG cop
    c1st cfv cG cG cop cG cG cop c1st cfv eqid vcgrp eqeltrrd cG grprndm syl cG
    cG cop cvc wcel cG cdm cdm cc cc cxp cdm cc cG cG cop cvc wcel cG cdm cc cc
    cxp cG cG cop cvc wcel cc cc cxp cc cG wf cG cdm cc cc cxp wceq cG
    vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc dmxpid syl6eq 3eqtrd ax1cn
    syl5eleqr cG cG cop cvc wcel cc cG cG cop c1st cfv crn c1 cG cG cop cvc
    wcel cG cG cop c1st cfv crn cG crn cG cdm cdm cc cG cG cop cvc wcel cG cG
    cop c1st cfv cG cG cG cop cvc wcel cG cvv wcel cG cG cop c1st cfv cG wceq
    cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc
    cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv
    op1stg syl rneqd cG cG cop cvc wcel cG cgr wcel cG crn cG cdm cdm wceq cG
    cG cop cvc wcel cG cG cop c1st cfv cG cgr cG cG cop cvc wcel cG cvv wcel cG
    cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel
    cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex
    axcnex xpex sylancl cG cG cvv op1stg syl cG cG cop c1st cfv cG cG cop cG cG
    cop c1st cfv eqid vcgrp eqeltrrd cG grprndm syl cG cG cop cvc wcel cG cdm
    cdm cc cc cxp cdm cc cG cG cop cvc wcel cG cdm cc cc cxp cG cG cop cvc wcel
    cc cc cxp cc cG wf cG cdm cc cc cxp wceq cG vcoprnelem cc cc cxp cc cG fdm
    syl dmeqd cc dmxpid syl6eq 3eqtrd ax1cn syl5eleqr 3jca cG cG cop c1st cfv
    cgi cfv c1 c1 cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG cop
    c1st cfv eqid cG cG cop c1st cfv crn eqid vclcan mpdan mpbid 3eqtr3d cG cG
    cop cvc wcel cc0 cG cG cop c1st cfv crn wcel cc0 cG cG cop c1st cfv cgi cfv
    cG cG cop c1st cfv co cc0 wceq cG cG cop cvc wcel cc cG cG cop c1st cfv crn
    cc0 cG cG cop cvc wcel cG cG cop c1st cfv crn cG crn cG cdm cdm cc cG cG
    cop cvc wcel cG cG cop c1st cfv cG cG cG cop cvc wcel cG cvv wcel cG cG cop
    c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp cvv wcel cG cvv wcel cG cG
    cop cvc wcel cc cc cxp cc cvv cG fex cG vcoprnelem cc cc axcnex axcnex xpex
    sylancl cG cG cvv op1stg syl rneqd cG cG cop cvc wcel cG cgr wcel cG crn cG
    cdm cdm wceq cG cG cop cvc wcel cG cG cop c1st cfv cG cgr cG cG cop cvc
    wcel cG cvv wcel cG cG cop c1st cfv cG wceq cc cc cxp cc cG wf cc cc cxp
    cvv wcel cG cvv wcel cG cG cop cvc wcel cc cc cxp cc cvv cG fex cG
    vcoprnelem cc cc axcnex axcnex xpex sylancl cG cG cvv op1stg syl cG cG cop
    c1st cfv cG cG cop cG cG cop c1st cfv eqid vcgrp eqeltrrd cG grprndm syl cG
    cG cop cvc wcel cG cdm cdm cc cc cxp cdm cc cG cG cop cvc wcel cG cdm cc cc
    cxp cG cG cop cvc wcel cc cc cxp cc cG wf cG cdm cc cc cxp wceq cG
    vcoprnelem cc cc cxp cc cG fdm syl dmeqd cc dmxpid syl6eq 3eqtrd 0cn
    syl5eleqr cc0 cG cG cop c1st cfv cG cG cop cG cG cop c1st cfv crn cG cG cop
    c1st cfv cgi cfv cG cG cop c1st cfv eqid cG cG cop c1st cfv crn eqid cG cG
    cop c1st cfv cgi cfv eqid vc0rid mpdan 3eqtr3d mto cG cS wceq cG cG cop cG
    cS cop cvc cG cS cG opeq2 eleq1d mtbii necon2ai $.
    $( [2-Jun-2008] $) $( [31-May-2008] $)

  $( The components of a complex vector space are sets. $)
  vcex $p |- ( <. G , S >. e. CVec -> ( G e. _V /\ S e. _V ) ) $=
    cG cS cop cvc wcel cG cvv wcel cS cvv wcel cG cS cop cvc wcel cG cS cop cvv
    cvv cxp wcel cG cvv wcel cvc cvv cvv cxp cG cS cop cvc wrel cvc cvv cvv cxp
    wss vcrel cvc df-rel mpbi sseli cG cS cvv cvv opelxp1 syl cS cvv wcel cG cS
    cop cvc wcel cS cvv wcel wn cG cS cop cvc wcel cG cG cop cvc wcel cG cG cop
    cvc wcel cG cG wceq cG eqid cG cG cop cvc wcel cG cG wne cG cG wceq wn cG
    cG vcoprne cG cG df-ne sylib mt2 cS cvv wcel wn cG cS cop cG cG cop cvc cG
    cS opprc2 eleq1d mtbiri con4i jca $.
    $( [2-Jun-2008] $) $( [31-May-2008] $)

  ${
    $d x y z G $.  $d x y z S $.  $d x z X $.
    isvc.1 $e |- X = ran G $.
    $( The predicate "is a complex vector space." $)
    isvc $p |- ( <. G , S >. e. CVec <-> ( G e. Abel /\
         S :  ( CC X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. CC ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. CC ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) $=
      cG cS cop cvc wcel cG cvv wcel cS cvv wcel wa cG cabl wcel cc cX cxp cX
      cS wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv
      cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv
      cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co
      vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc
      wral wa vx cX wral w3a cS cG vcex cG cabl wcel cc cX cxp cX cS wf cG cvv
      wcel cS cvv wcel wa c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS
      co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv
      vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      wral wa vy cc wral wa vx cX wral cG cabl wcel cc cX cxp cX cS wf wa cG
      cvv wcel cS cvv wcel cG cabl wcel cG cvv wcel cc cX cxp cX cS wf cG cabl
      elisset adantr cc cX cxp cX cS wf cG cabl wcel cS cvv wcel cc cX cxp cX
      cS wf cc cX cxp cvv wcel cS cvv wcel cG cabl wcel cc cX cxp cX cvv cS fex
      cc cvv wcel cX cvv wcel cc cX cxp cvv wcel cG cabl wcel cc cX cvv cvv
      xpexg axcnex cG cabl wcel cG cgr wcel cX cvv wcel cG ablgrp cG cgr wcel
      cG crn cvv cX cG cgr rnexg isvc.1 syl5eqel syl sylancr sylan2 ancoms jca
      3adant3 vx vy vz cS cG cX isvc.1 isvclem pm5.21nii $.
      $( [3-Jun-2008] $) $( [31-May-2008] $)
  $}

  ${
    $d x y z G $.  $d x y z S $.  $d x y z X $.
    isvci.1 $e |- G e. Abel $.
    isvci.2 $e |- dom G = ( X X. X ) $.
    isvci.3 $e |- S : ( CC X. X ) --> X $.
    isvci.4 $e |- ( x e. X -> ( 1 S x ) = x ) $.
    isvci.5 $e |- ( ( y e. CC /\ x e. X /\ z e. X ) ->
                  ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) ) ) $.
    isvci.6 $e |- ( ( y e. CC /\ z e. CC /\ x e. X ) ->
                  ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) ) $.
    isvci.7 $e |- ( ( y e. CC /\ z e. CC /\ x e. X ) ->
                  ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) $.
    isvci.8 $e |- W = <. G , S >. $.
    $( Properties that determine a complex vector space. $)
    isvci $p |- W e. CVec $=
      cW cG cS cop cvc isvci.8 cG cS cop cvc wcel cG cabl wcel cc cX cxp cX cS
      wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS
      co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS
      co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx
      cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc wral
      wa vx cX wral w3a cG cabl wcel cc cX cxp cX cS wf c1 vx cv cS co vx cv
      wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG
      co wceq vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz
      cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx
      cv cS co cS co wceq wa vz cc wral wa vy cc wral wa vx cX wral isvci.1
      isvci.3 c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx
      cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx
      cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul
      co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc wral wa vy cc
      wral wa vx cX vx cv cX wcel c1 vx cv cS co vx cv wceq vy cv vx cv vz cv
      cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq
      wa vz cc wral wa vy cc wral isvci.4 vx cv cX wcel vy cv vx cv vz cv cG co
      cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz
      cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy
      cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      wral wa vy cc vx cv cX wcel vy cv cc wcel wa vy cv vx cv vz cv cG co cS
      co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv
      vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      wral vx cv cX wcel vy cv cc wcel wa vy cv vx cv vz cv cG co cS co vy cv
      vx cv cS co vy cv vz cv cS co cG co wceq vz cX vx cv cX wcel vy cv cc
      wcel vz cv cX wcel vy cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv
      vz cv cS co cG co wceq vy cv cc wcel vx cv cX wcel vz cv cX wcel vy cv vx
      cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq
      isvci.5 3com12 3expa r19.21aiva vx cv cX wcel vy cv cc wcel wa vy cv vz
      cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy
      cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cc
      vx cv cX wcel vy cv cc wcel vz cv cc wcel vy cv vz cv caddc co vx cv cS
      co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx
      cv cS co vy cv vz cv vx cv cS co cS co wceq wa vy cv cc wcel vz cv cc
      wcel vx cv cX wcel vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz
      cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx
      cv cS co cS co wceq wa vy cv cc wcel vz cv cc wcel vx cv cX wcel w3a vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq
      isvci.6 isvci.7 jca 3comr 3expa r19.21aiva jca r19.21aiva jca rgen
      3pm3.2i vx vy vz cS cG cX cG cX cG cabl wcel cG cgr wcel isvci.1 cG
      ablgrp ax-mp isvci.2 grprn isvc mpbir eqeltri $.
      $( [10-Apr-2008] $) $( [5-Nov-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Examples of complex vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( The set of complex numbers is a complex vector space.  The vector
       operation is ` + ` , and the scalar product is ` x. ` . $)
    cnvc $p |- <. + , x. >. e. CVec $=
      vx vy vz cmul caddc caddc cmul cop cc cnaddabl cc cc cxp cc caddc
      axaddopr fdmi axmulopr vx cv mulid2 vy cv vx cv vz cv adddi vy cv vz cv
      vx cv adddir vy cv vz cv vx cv mulass caddc cmul cop eqid isvci $.
      $( [9-Nov-2006] $) $( [5-Nov-2006] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Normed complex vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c NrmCVec $.

  $c +v $.
  $c BaseSet $.
  $c .s $.
  $c 0v $.
  $c -v $.
  $c norm $.

  $c IndMet $.

  $( Extend class notation with the class of all normed complex vector
     spaces. $)
  cnv $a class NrmCVec $.

  $( Extend class notation with vector addition in a normed complex vector
     space.  In the literature, the subscript "v" is omitted, but we need it to
     avoid ambiguity with complex number addition ` + ` ~ caddc . $)
  cpv $a class +v $.

  $( Extend class notation with the base set of a normed complex vector
     space.  (Note that ` BaseSet ` is capitalized because, once it is fixed
     for a particular vector space ` U ` , it is not a function, unlike e.g.
     ` norm ` .  This is our typical convention.) $)
  cba $a class BaseSet $.

  $( Extend class notation with scalar multiplication in a normed complex
     vector space.  In the literature scalar multiplication is usually
     indicated by juxtaposition, but we need an explicit symbol to prevent
     ambiguity. $)
  cns $a class .s $.

  $( Extend class notation with zero vector in a normed complex vector
     space. $)
  cn0v $a class 0v $.

  $( Extend class notation with vector subtraction in a normed complex vector
     space. $)
  cnsb $a class -v $.

  $( Extend class notation with the norm function in a normed complex vector
     space.  In the literature, the norm of ` A ` is usually  written
     "|| ` A ` ||", but we use function notation to take advantage of our
     existing theorems about functions. $)
  cnm $a class norm $.

  $( Extend class notation with the class of the induced metrics on normed
     complex vector spaces. $)
  cims $a class IndMet $.

  ${
    $d g s m n o t u w x y z $.  $d y G $.  $d y N $.  $d y S $.
    $( Define the class of all normed complex vector spaces. $)
    df-nv $a |- NrmCVec = { <. <. g , s >. , n >. | ( <. g , s >. e. CVec /\
   n : ran g --> RR /\ A. x e. ran g ( ( ( n ` x ) = 0 -> x = ( Id ` g ) )
/\ A. y e. CC ( n ` ( y s x ) ) = ( ( abs ` y ) x. ( n ` x ) ) /\
A. y e. ran g ( n ` ( x g y ) ) <_ ( ( n ` x ) + ( n ` y ) ) ) ) } $.

    $( Structure of the class of all normed complex vectors spaces. $)
    nvss $p |- NrmCVec C_ ( ( _V X. _V ) X. _V ) $=
      cnv vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv cc0
      wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn
      cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral
      w3a vx vg cv crn wral w3a vg vs vn copab2 cvv cvv cxp cvv cxp vx vy vg vn
      vs df-nv vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv
      cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn
      cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral
      w3a vx vg cv crn wral w3a vg vs vn oprabss eqsstri $.
      $( [29-Nov-2006] $) $( [28-Nov-2006] $)

    $( A normed complex vector space is a vector space. $)
    nvvcop $p |- ( <. <. G , S >. , N >. e. NrmCVec -> <. G , S >. e. CVec ) $=
      cG cS cop cN cop cnv wcel cG cS cop cN cop vy cv c1st cfv cvc wcel vy cab
      wcel cG cS cop cvc wcel cnv vy cv c1st cfv cvc wcel vy cab cG cS cop cN
      cop cnv vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv
      cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn
      cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral
      w3a vx vg cv crn wral w3a vg vs vn copab2 vy cv c1st cfv cvc wcel vy cab
      vx vy vg vn vs df-nv vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv
      vn cv cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv
      cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg
      cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv
      crn wral w3a vx vg cv crn wral w3a vg vs vn copab2 vg cv vs cv cop cvc
      wcel vg vs vn copab2 vy cv c1st cfv cvc wcel vy cab vg cv vs cv cop cvc
      wcel vg cv crn cr vn cv wf vx cv vn cv cfv cc0 wceq vx cv vg cv cgi cfv
      wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv
      cmul co wceq vy cc wral vx cv vy cv vg cv co vn cv cfv vx cv vn cv cfv vy
      cv vn cv cfv caddc co cle wbr vy vg cv crn wral w3a vx vg cv crn wral w3a
      vg cv vs cv cop cvc wcel vg vs vn vg cv vs cv cop cvc wcel vg cv crn cr
      vn cv wf vx cv vn cv cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv
      vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral
      vx cv vy cv vg cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co
      cle wbr vy vg cv crn wral w3a vx vg cv crn wral 3simp1 ssoprab2i vg cv vs
      cv cop cvc wcel vg vs vn copab2 vx cv cvc wcel vx vn copab vy cv c1st cfv
      cvc wcel vy cab vg cv vs cv cop cvc wcel vg vs vn copab2 vx cv vg cv vs
      cv cop wceq vg cv vs cv cop cvc wcel wa vs wex vg wex vx vn copab vx cv
      cvc wcel vx vn copab vg cv vs cv cop cvc wcel vg vs vn vx dfoprab2 vx cv
      vg cv vs cv cop wceq vg cv vs cv cop cvc wcel wa vs wex vg wex vx cv cvc
      wcel vx vn vx cv vg cv vs cv cop wceq vg cv vs cv cop cvc wcel wa vs wex
      vg wex vx cv vg cv vs cv cop wceq vs wex vg wex vx cv cvc wcel vx cv vg
      cv vs cv cop wceq vg cv vs cv cop cvc wcel wa vs wex vg wex vx cv vg cv
      vs cv cop wceq vx cv cvc wcel wa vs wex vg wex vx cv vg cv vs cv cop wceq
      vs wex vg wex vx cv cvc wcel wa vx cv vg cv vs cv cop wceq vx cv cvc wcel
      wa vx cv vg cv vs cv cop wceq vg cv vs cv cop cvc wcel wa vg vs vx cv vg
      cv vs cv cop wceq vx cv cvc wcel vg cv vs cv cop cvc wcel vx cv vg cv vs
      cv cop cvc eleq1 pm5.32i 2exbii vx cv vg cv vs cv cop wceq vx cv cvc wcel
      vg vs 19.41vv bitr3i pm3.27bi ssopab2i eqsstri vx cv cvc wcel vx vn copab
      vy cv vx cv vn cv cop wceq vx cv cvc wcel wa vn wex vx wex vy cab vy cv
      c1st cfv cvc wcel vy cab vx cv cvc wcel vx vn vy df-opab vy cv vx cv vn
      cv cop wceq vx cv cvc wcel wa vn wex vx wex vy cv c1st cfv cvc wcel vy vy
      cv vx cv vn cv cop wceq vx cv cvc wcel wa vn wex vx wex vy cv vx cv vn cv
      cop wceq vn wex vx wex vy cv c1st cfv cvc wcel vy cv vx cv vn cv cop wceq
      vx cv cvc wcel wa vn wex vx wex vy cv vx cv vn cv cop wceq vy cv c1st cfv
      cvc wcel wa vn wex vx wex vy cv vx cv vn cv cop wceq vn wex vx wex vy cv
      c1st cfv cvc wcel wa vy cv vx cv vn cv cop wceq vy cv c1st cfv cvc wcel
      wa vy cv vx cv vn cv cop wceq vx cv cvc wcel wa vx vn vy cv vx cv vn cv
      cop wceq vy cv c1st cfv cvc wcel vx cv cvc wcel vy cv vx cv vn cv cop
      wceq vy cv c1st cfv vx cv cvc vy cv vx cv vn cv cop wceq vy cv c1st cfv
      vx cv vn cv cop c1st cfv vx cv vy cv vx cv vn cv cop c1st fveq2 vx cv vn
      cv vx visset op1st syl6eq eleq1d pm5.32i 2exbii vy cv vx cv vn cv cop
      wceq vy cv c1st cfv cvc wcel vx vn 19.41vv bitr3i pm3.27bi ss2abi eqsstri
      sstri sstri eqsstri sseli vy cv c1st cfv cvc wcel cG cS cop cvc wcel vy
      cG cS cop cN cop cG cS cop cN opex vy cv cG cS cop cN cop wceq vy cv c1st
      cfv cG cS cop cvc vy cv cG cS cop cN cop wceq vy cv c1st cfv cG cS cop cN
      cop c1st cfv cG cS cop vy cv cG cS cop cN cop c1st fveq2 cG cS cop cN cG
      cS opex op1st syl6eq eleq1d elab sylib $.
      $( [6-Jun-2008] $) $( [5-Jun-2008] $)

    $( Define vector addition on a normed complex vector space. $)
    df-va $a |- +v = ( 1st o. 1st ) $.

    $( Define the base set of a normed complex vector space. $)
    df-ba $a |- BaseSet = { <. x , y >. | y = ran ( +v ` x ) } $.

    $( Define scalar multiplication on a normed complex vector space. $)
    df-sm $a |- .s = ( 2nd o. 1st ) $.

    $( Define the zero vector in a normed complex vector space. $)
    df-0v $a |- 0v = ( Id o. +v ) $.

    $( Define vector subtraction on a normed complex vector space. $)
    df-vs $a |- -v = ( /g o. +v ) $.

    $( Define the norm function in a normed complex vector space. $)
    df-nm $a |- norm = 2nd $.

    $( Define the induced metric on a normed complex vector space. $)
    df-ims $a |- IndMet = { <. u , d >. | ( u e. NrmCVec
                 /\ d = ( ( norm ` u ) o. ( -v ` u ) ) ) } $.
  $}

  $( The class of all normed complex vectors spaces is a relation. $)
  nvrel $p |- Rel NrmCVec $=
    cnv wrel cnv cvv cvv cxp wss cnv cvv cvv cxp cvv cxp cvv cvv cxp nvss cvv
    cvv cxp cvv xpss sstri cnv df-rel mpbir $.
    $( [18-Nov-2006] $) $( [14-Nov-2006] $)

  ${
    $d x y U $.
    vafval.2 $e |- G = ( +v ` U ) $.
    $( Value of the function for the vector addition (group) operation on a
       normed complex vector space. $)
    vafval $p |- G = ( 1st ` ( 1st ` U ) ) $=
      cG cU cpv cfv cU c1st cfv c1st cfv vafval.2 cU cvv wcel cU cpv cfv cU
      c1st cfv c1st cfv wceq cU cvv wcel cU c1st c1st ccom cfv cU c1st cfv c1st
      cfv cU cpv cfv c1st wfun cvv cvv c1st wf cU cvv wcel cU c1st c1st ccom
      cfv cU c1st cfv c1st cfv wceq cvv cvv c1st wfo c1st wfun fo1st cvv cvv
      c1st fofun ax-mp cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof
      ax-mp cvv cvv cU c1st c1st fvco3 mp3an12 cU cpv c1st c1st ccom df-va
      fveq1i syl5eq cU cvv wcel wn cU cpv cfv c0 cU c1st cfv c1st cfv cU cpv
      fvprc cU cvv wcel wn cU c1st cfv c1st cfv c0 c1st cfv c0 cU cvv wcel wn
      cU c1st cfv c0 c1st cU c1st fvprc fveq2d 1st0 syl6req eqtrd pm2.61i eqtri
      $.
      $( [12-May-2007] $) $( [23-Apr-2007] $)
  $}

  ${
    $d x y U $.
    bafval.1 $e |- X = ( BaseSet ` U ) $.
    bafval.2 $e |- G = ( +v ` U ) $.
    $( Value of the function for the base set of a normed complex vector
       space. $)
    bafval $p |- X = ran G $=
      cU cba cfv cU cpv cfv crn cX cG crn cU cvv wcel cU cba cfv cU cpv cfv crn
      wceq cU cvv wcel cU vy cv vx cv cpv cfv crn wceq vx vy copab cfv cU cpv
      cfv crn cU cba cfv cU cvv wcel cU cpv cfv crn cvv wcel cU vy cv vx cv cpv
      cfv crn wceq vx vy copab cfv cU cpv cfv crn wceq cU cpv cfv cU cpv fvex
      rnex vx vy cU vx cv cpv cfv crn cU cpv cfv crn cvv cvv vx cv cU wceq vx
      cv cpv cfv cU cpv cfv vx cv cU cpv fveq2 rneqd fvopabg mpan2 cU cba vy cv
      vx cv cpv cfv crn wceq vx vy copab vx vy df-ba fveq1i syl5eq cU cvv wcel
      wn cU cba cfv c0 cU cpv cfv crn cU cba fvprc cU cvv wcel wn cU cpv cfv
      crn c0 crn c0 cU cvv wcel wn cU cpv cfv c0 cU cpv fvprc rneqd rn0 syl6eq
      eqtr4d pm2.61i bafval.1 cG cU cpv cfv bafval.2 rneqi 3eqtr4i $.
      $( [13-May-2007] $) $( [23-Apr-2007] $)
  $}

  ${
    $d x y U $.
    smfval.4 $e |- S = ( .s ` U ) $.
    $( Value of the function for the scalar multiplication operation on a
       normed complex vector space. $)
    smfval $p |- S = ( 2nd ` ( 1st ` U ) ) $=
      cS cU cns cfv cU c1st cfv c2nd cfv smfval.4 cU cvv wcel cU cns cfv cU
      c1st cfv c2nd cfv wceq cU cvv wcel cU c2nd c1st ccom cfv cU c1st cfv c2nd
      cfv cU cns cfv c2nd wfun cvv cvv c1st wf cU cvv wcel cU c2nd c1st ccom
      cfv cU c1st cfv c2nd cfv wceq cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv
      c2nd fofun ax-mp cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof
      ax-mp cvv cvv cU c2nd c1st fvco3 mp3an12 cU cns c2nd c1st ccom df-sm
      fveq1i syl5eq cU cvv wcel wn cU cns cfv c0 cU c1st cfv c2nd cfv cU cns
      fvprc cU cvv wcel wn cU c1st cfv c2nd cfv c0 c2nd cfv c0 cU cvv wcel wn
      cU c1st cfv c0 c2nd cU c1st fvprc fveq2d 2nd0 syl6req eqtrd pm2.61i eqtri
      $.
      $( [5-Sep-2007] $) $( [24-Apr-2007] $)
  $}

  ${
    $d x y U $.  $d x y z w $.
    0vfval.2 $e |- G = ( +v ` U ) $.
    0vfval.5 $e |- Z = ( 0v ` U ) $.
    $( Value of the function for the zero vector on a normed complex vector
       space. $)
    0vfval $p |- Z = ( Id ` G ) $=
      cU cn0v cfv cU cpv cfv cgi cfv cZ cG cgi cfv cU cvv wcel cU cn0v cfv cU
      cpv cfv cgi cfv wceq cU cvv wcel cU cgi cpv ccom cfv cU cpv cfv cgi cfv
      cU cn0v cfv cgi wfun cpv cvv wfn cU cvv wcel cU cgi cpv ccom cfv cU cpv
      cfv cgi cfv wceq fungid cpv cvv wfn c1st c1st ccom cvv wfn c1st cvv wfn
      c1st cvv wfn c1st crn cvv wss c1st c1st ccom cvv wfn cvv cvv c1st wfo
      c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp cvv cvv c1st wfo c1st cvv wfn
      fo1st cvv cvv c1st fofn ax-mp c1st crn ssv cvv cvv c1st c1st fnco mp3an
      cpv c1st c1st ccom wceq cpv cvv wfn c1st c1st ccom cvv wfn wb df-va cvv
      cpv c1st c1st ccom fneq1 ax-mp mpbir cvv cU cgi cpv fvco2 mp3an12 cU cn0v
      cgi cpv ccom df-0v fveq1i syl5eq cU cvv wcel wn cU cn0v cfv c0 cU cpv cfv
      cgi cfv cU cn0v fvprc cU cvv wcel wn cU cpv cfv cgi cfv c0 cgi cfv c0 cU
      cvv wcel wn cU cpv cfv c0 cgi cU cpv fvprc fveq2d gid0 syl6req eqtrd
      pm2.61i 0vfval.5 cG cU cpv cfv cgi 0vfval.2 fveq2i 3eqtr4i $.
      $( [5-Feb-2010] $) $( [24-Apr-2007] $)
  $}

  ${
    $d x y U $.
    nmfval.6 $e |- N = ( norm ` U ) $.
    $( Value of the norm function in a normed complex vector space. $)
    nmfval $p |- N = ( 2nd ` U ) $=
      cN cU cnm cfv cU c2nd cfv nmfval.6 cU cnm c2nd df-nm fveq1i eqtri $.
      $( [5-Sep-2007] $) $( [25-Apr-2007] $)
  $}

  ${
    nvop2.1 $e |- W = ( 1st ` U ) $.
    nvop2.6 $e |- N = ( norm ` U ) $.
    $( A normed complex vector space is an ordered pair of a vector space
       and a norm operation. $)
    nvop2 $p |- ( U e. NrmCVec -> U = <. W , N >. ) $=
      cU cnv wcel cU cU c1st cfv cU c2nd cfv cop cW cN cop cnv wrel cU cnv wcel
      cU cU c1st cfv cU c2nd cfv cop wceq nvrel cU cnv 1st2nd mpan cW cU c1st
      cfv cN cU c2nd cfv nvop2.1 cU cN nvop2.6 nmfval opeq12i syl6eqr $.
      $( [6-Sep-2007] $) $( [28-Nov-2006] $)
  $}

  ${
    nvvop.1 $e |- W = ( 1st ` U ) $.
    nvvop.2 $e |- G = ( +v ` U ) $.
    nvvop.4 $e |- S = ( .s ` U ) $.
    $( The vector space component of a normed complex vector space is
       an ordered pair of the underlying group and a scalar product. $)
    nvvop $p |- ( U e. NrmCVec -> W = <. G , S >. ) $=
      cU cnv wcel cW cW c1st cfv cW c2nd cfv cop cG cS cop cvv cvv cxp wrel cW
      cvv cvv cxp wcel cW cW c1st cfv cW c2nd cfv cop wceq cU cnv wcel cW cvv
      cvv cxp 1st2nd cvv cvv relxp cU cnv wcel cW cvv cvv cxp wcel cU cnm cfv
      cvv wcel cU cnv wcel cW cU cnm cfv cop cvv cvv cxp cvv cxp wcel cW cvv
      cvv cxp wcel cU cnm cfv cvv wcel wa cU cnv wcel cW cU cnm cfv cop cnv
      wcel cW cU cnm cfv cop cvv cvv cxp cvv cxp wcel cU cnv wcel cW cU cnm cfv
      cop cnv wcel cU cnv wcel cU cW cU cnm cfv cop cnv cU cU cnm cfv cW
      nvvop.1 cU cnm cfv eqid nvop2 eleq1d ibi cnv cvv cvv cxp cvv cxp cW cU
      cnm cfv cop nvss sseli syl cW cU cnm cfv cvv cvv cxp cvv cU cnm fvex
      opelxp sylib pm3.26d sylancr cG cW c1st cfv cS cW c2nd cfv cG cU c1st cfv
      c1st cfv cW c1st cfv cU cG nvvop.2 vafval cW cU c1st cfv c1st nvvop.1
      fveq2i eqtr4i cS cU c1st cfv c2nd cfv cW c2nd cfv cS cU nvvop.4 smfval cW
      cU c1st cfv c2nd nvvop.1 fveq2i eqtr4i opeq12i syl6eqr $.
      $( [6-Sep-2007] $) $( [28-Nov-2006] $)
  $}

  ${
    $d g n s x y G $.  $d g n s x y N $.  $d g n s x y S $.  $d g n s x y X $.
    $d g n s Z $.
    isnvlem.1 $e |- X = ran G $.
    isnvlem.2 $e |- Z = ( Id ` G ) $.
    $( Lemma for ~ isnv . $)
    isnvlem $p |- ( ( G e. _V /\ S e. _V /\ N e. _V ) ->
                 ( <. <. G , S >. , N >. e. NrmCVec <-> ( <. G , S >. e. CVec
        /\ N : X --> RR /\ A. x e. X ( ( ( N ` x ) = 0 -> x = Z )
           /\ A. y e. CC ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) /\
           A. y e. X ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) ) $=
      cG cvv wcel cS cvv wcel cN cvv wcel w3a cG cS cop cN cop vg cv vs cv cop
      cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv cc0 wceq vx cv vg cv cgi
      cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv
      cmul co wceq vy cc wral vx cv vy cv vg cv co vn cv cfv vx cv vn cv cfv vy
      cv vn cv cfv caddc co cle wbr vy vg cv crn wral w3a vx vg cv crn wral w3a
      vg vs vn copab2 wcel cG cS cop cvc wcel cX cr cN wf vx cv cN cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv
      cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN
      cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a cG cS cop cN cop cnv
      wcel vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv cc0
      wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn
      cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral
      w3a vx vg cv crn wral w3a cG vs cv cop cvc wcel cX cr vn cv wf vx cv vn
      cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv vs cv co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv
      cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX
      wral w3a cG cS cop cvc wcel cX cr vn cv wf vx cv vn cv cfv cc0 wceq vx cv
      cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn cv cfv
      cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv
      vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a cG cS cop cvc
      wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co
      cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cG
      co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX
      wral w3a vg vs vn cG cS cN cvv cvv cvv vg cv cG wceq vg cv vs cv cop cvc
      wcel cG vs cv cop cvc wcel vg cv crn cr vn cv wf cX cr vn cv wf vx cv vn
      cv cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv
      cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg
      cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv
      crn wral w3a vx vg cv crn wral vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi
      vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co
      wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv
      cfv caddc co cle wbr vy cX wral w3a vx cX wral vg cv cG wceq vg cv vs cv
      cop cG vs cv cop cvc vg cv cG vs cv opeq1 eleq1d vg cv cG wceq vg cv crn
      cX wceq vg cv crn cr vn cv wf cX cr vn cv wf wb vg cv cG wceq vg cv crn
      cG crn cX vg cv cG rneq isnvlem.1 syl6eqr vg cv crn cX cr vn cv feq2 syl
      vg cv cG wceq vx cv vn cv cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv
      vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy
      cc wral vx cv vy cv vg cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv
      caddc co cle wbr vy vg cv crn wral w3a vx cv vn cv cfv cc0 wceq vx cv cZ
      wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv
      cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv
      vn cv cfv caddc co cle wbr vy cX wral w3a vx vg cv crn cX vg cv cG wceq
      vg cv crn cG crn cX vg cv cG rneq isnvlem.1 syl6eqr vg cv cG wceq vx cv
      vn cv cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vx cv vn cv cfv cc0 wceq
      vx cv cZ wceq wi vx cv vy cv vg cv co vn cv cfv vx cv vn cv cfv vy cv vn
      cv cfv caddc co cle wbr vy vg cv crn wral vx cv vy cv cG co vn cv cfv vx
      cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral vy cv vx cv vs
      cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vg
      cv cG wceq vx cv vg cv cgi cfv wceq vx cv cZ wceq vx cv vn cv cfv cc0
      wceq vg cv cG wceq vg cv cgi cfv cZ vx cv vg cv cG wceq vg cv cgi cfv cG
      cgi cfv cZ vg cv cG cgi fveq2 isnvlem.2 syl6eqr eqeq2d imbi2d vg cv cG
      wceq vx cv vy cv vg cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc
      co cle wbr vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv
      caddc co cle wbr vy vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv
      cG rneq isnvlem.1 syl6eqr vg cv cG wceq vx cv vy cv vg cv co vn cv cfv vx
      cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle vg
      cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG co vn cv vx cv vy cv vg cv
      cG opreq fveq2d breq1d raleq12d 3anbi13d raleq12d 3anbi123d vs cv cS wceq
      cG vs cv cop cvc wcel cG cS cop cvc wcel vx cv vn cv cfv cc0 wceq vx cv
      cZ wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv
      cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv
      vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral vx cv vn cv cfv cc0
      wceq vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn
      cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral cX cr vn
      cv wf vs cv cS wceq cG vs cv cop cG cS cop cvc vs cv cS cG opeq2 eleq1d
      vs cv cS wceq vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv vs cv
      co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv
      vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy
      cX wral w3a vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co
      vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy
      cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX
      wral w3a vx cX vs cv cS wceq vy cv vx cv vs cv co vn cv cfv vy cv cabs
      cfv vx cv vn cv cfv cmul co wceq vy cc wral vy cv vx cv cS co vn cv cfv
      vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vn cv cfv
      cc0 wceq vx cv cZ wceq wi vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy
      cv vn cv cfv caddc co cle wbr vy cX wral vs cv cS wceq vy cv vx cv vs cv
      co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cv vx cv cS
      co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc vs cv cS
      wceq vy cv vx cv vs cv co vn cv cfv vy cv vx cv cS co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co vs cv cS wceq vy cv vx cv vs cv co vy cv
      vx cv cS co vn cv vy cv vx cv vs cv cS opreq fveq2d eqeq1d ralbidv
      3anbi2d ralbidv 3anbi13d vn cv cN wceq cX cr vn cv wf cX cr cN wf vx cv
      vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv
      cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX
      wral vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy
      cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cG co cN cfv
      vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral cG
      cS cop cvc wcel cX cr vn cv cN feq1 vn cv cN wceq vx cv vn cv cfv cc0
      wceq vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn
      cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cv cN cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv
      cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN
      cfv caddc co cle wbr vy cX wral w3a vx cX vn cv cN wceq vx cv vn cv cfv
      cc0 wceq vx cv cZ wceq wi vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx
      cv cS co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral
      vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc
      wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co
      cle wbr vy cX wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv
      caddc co cle wbr vy cX wral vn cv cN wceq vx cv vn cv cfv cc0 wceq vx cv
      cN cfv cc0 wceq vx cv cZ wceq vn cv cN wceq vx cv vn cv cfv vx cv cN cfv
      cc0 vx cv vn cv cN fveq1 eqeq1d imbi1d vn cv cN wceq vy cv vx cv cS co vn
      cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cv vx cv cS co cN
      cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc vn cv cN wceq vy cv vx
      cv cS co vn cv cfv vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv vn cv
      cfv cmul co vy cv cabs cfv vx cv cN cfv cmul co vy cv vx cv cS co vn cv
      cN fveq1 vn cv cN wceq vx cv vn cv cfv vx cv cN cfv vy cv cabs cfv cmul
      vx cv vn cv cN fveq1 opreq2d eqeq12d ralbidv vn cv cN wceq vx cv vy cv cG
      co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vx cv vy cv
      cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX vn cv cN
      wceq vx cv vy cv cG co vn cv cfv vx cv vy cv cG co cN cfv vx cv vn cv cfv
      vy cv vn cv cfv caddc co vx cv cN cfv vy cv cN cfv caddc co cle vx cv vy
      cv cG co vn cv cN fveq1 vn cv cN wceq vx cv vn cv cfv vx cv cN cfv vy cv
      vn cv cfv vy cv cN cfv caddc vx cv vn cv cN fveq1 vy cv vn cv cN fveq1
      opreq12d breq12d ralbidv 3anbi123d ralbidv 3anbi23d eloprabg cnv vg cv vs
      cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv cc0 wceq vx cv vg
      cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn
      cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral w3a vx vg cv crn
      wral w3a vg vs vn copab2 cG cS cop cN cop vx vy vg vn vs df-nv eleq2i
      syl5bb $.
      $( [7-Jun-2008] $) $( [11-Nov-2006] $)
  $}

  ${
    $d x y G $.  $d x y S $.
    $( The components of a normed complex vector space are sets. $)
    nvex $p |- ( <. <. G , S >. , N >. e. NrmCVec
            -> ( G e. _V /\ S e. _V /\ N e. _V ) ) $=
      cG cvv wcel cS cvv wcel cN cvv wcel w3a cG cvv wcel cS cvv wcel wa cN cvv
      wcel cG cS cop cN cop cnv wcel cG cvv wcel cS cvv wcel cN cvv wcel df-3an
      cG cS cop cN cop cnv wcel cG cS cop cvc wcel cG cvv wcel cS cvv wcel wa
      cS cG cN nvvcop cS cG vcex syl cN cvv wcel cG cS cop cN cop cnv wcel cN
      cvv wcel wn cG cS cop cN cop cnv wcel cG cS cop cG cS cop cop cnv wcel cG
      cS cop cG cS cop cop cnv wcel cG crn cr cG cS cop wf cG cvv wcel cS cvv
      wcel cG cS cop cvv wcel w3a cG cS cop cG cS cop cop cnv wcel cG crn cr cG
      cS cop wf cG cS cop cG cS cop cop cnv wcel cG cvv wcel cS cvv wcel wa cG
      cS cop cvv wcel wa cG cvv wcel cS cvv wcel cG cS cop cvv wcel w3a cG cS
      cop cG cS cop cop cnv wcel cG cvv wcel cS cvv wcel wa cG cS cop cvv wcel
      cG cS cop cG cS cop cop cnv wcel cG cS cop cvc wcel cG cvv wcel cS cvv
      wcel wa cS cG cG cS cop nvvcop cS cG vcex syl cG cS opex jctir cG cvv
      wcel cS cvv wcel cG cS cop cvv wcel df-3an sylibr cG cvv wcel cS cvv wcel
      cG cS cop cvv wcel w3a cG cS cop cG cS cop cop cnv wcel cG cS cop cvc
      wcel cG crn cr cG cS cop wf vx cv cG cS cop cfv cc0 wceq vx cv cG cgi cfv
      wceq wi vy cv vx cv cS co cG cS cop cfv vy cv cabs cfv vx cv cG cS cop
      cfv cmul co wceq vy cc wral vx cv vy cv cG co cG cS cop cfv vx cv cG cS
      cop cfv vy cv cG cS cop cfv caddc co cle wbr vy cG crn wral w3a vx cG crn
      wral w3a cG crn cr cG cS cop wf vx vy cS cG cG cS cop cG crn cG cgi cfv
      cG crn eqid cG cgi cfv eqid isnvlem cG cS cop cvc wcel cG crn cr cG cS
      cop wf vx cv cG cS cop cfv cc0 wceq vx cv cG cgi cfv wceq wi vy cv vx cv
      cS co cG cS cop cfv vy cv cabs cfv vx cv cG cS cop cfv cmul co wceq vy cc
      wral vx cv vy cv cG co cG cS cop cfv vx cv cG cS cop cfv vy cv cG cS cop
      cfv caddc co cle wbr vy cG crn wral w3a vx cG crn wral 3simp2 syl6bi
      mpcom cG cS cop cG cS cop cop cnv wcel cG crn cr cG cS cop wf cG cS wceq
      cG cS cop cG cS cop cop cnv wcel cG cS cop cvc wcel cG cS wceq wn cS cG
      cG cS cop nvvcop cG cS cop cvc wcel cG cS wne cG cS wceq wn cS cG vcoprne
      cG cS df-ne sylib syl cG cS cop cG cS cop cop cnv wcel cG cS cop wfun cG
      cS wceq cG crn cr cG cS cop wf cG cS cop cG cS cop cop cnv wcel cG cvv
      wcel cS cvv wcel wa cG cS cop wfun cG cS wceq wi cG cS cop cG cS cop cop
      cnv wcel cG cS cop cvc wcel cG cvv wcel cS cvv wcel wa cS cG cG cS cop
      nvvcop cS cG vcex syl cS cvv wcel cG cS cop wfun cG cS wceq wi cG cvv
      wcel cS cvv wcel cG cS cop wfun cG cS wceq cG cS cvv funopg ex adantl syl
      cG crn cr cG cS cop ffun syl5 mtod pm2.65i cN cvv wcel wn cG cS cop cN
      cop cG cS cop cG cS cop cop cnv cG cS cop cN opprc2 eleq1d mtbiri con4i
      sylanbrc $.
      $( [9-Jun-2008] $) $( [5-Jun-2008] $)
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    isnv.1 $e |- X = ran G $.
    isnv.2 $e |- Z = ( Id ` G ) $.
    $( The predicate "is a normed complex vector space." $)
    isnv $p |- ( <. <. G , S >. , N >. e. NrmCVec <-> ( <. G , S >. e. CVec
        /\ N : X --> RR /\ A. x e. X ( ( ( N ` x ) = 0 -> x = Z )
           /\ A. y e. CC ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) /\
           A. y e. X ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) $=
      cG cS cop cN cop cnv wcel cG cvv wcel cS cvv wcel cN cvv wcel w3a cG cS
      cop cvc wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx
      cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv
      vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral
      w3a vx cX wral w3a cS cG cN nvex cG cS cop cvc wcel cX cr cN wf cG cvv
      wcel cS cvv wcel cN cvv wcel w3a vx cv cN cfv cc0 wceq vx cv cZ wceq wi
      vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc
      wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr
      vy cX wral w3a vx cX wral cG cvv wcel cS cvv wcel cN cvv wcel w3a cG cvv
      wcel cS cvv wcel wa cN cvv wcel cG cS cop cvc wcel cX cr cN wf wa cG cvv
      wcel cS cvv wcel cN cvv wcel df-3an cG cS cop cvc wcel cG cvv wcel cS cvv
      wcel wa cX cr cN wf cS cG vcex adantr cX cr cN wf cG cS cop cvc wcel cN
      cvv wcel cX cr cN wf cX cvv wcel cN cvv wcel cG cS cop cvc wcel cX cr cvv
      cN fex cG cS cop cvc wcel cG crn cvv cX cG cS cop cvc wcel cG cvv wcel cG
      crn cvv wcel cG cS cop cvc wcel cG cvv wcel cS cvv wcel cS cG vcex
      pm3.26d cG cvv rnexg syl isnv.1 syl5eqel sylan2 ancoms sylanbrc 3adant3
      vx vy cS cG cN cX cZ isnv.1 isnv.2 isnvlem pm5.21nii $.
      $( [10-Jun-2008] $) $( [5-Jun-2008] $)
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    isnvi.5 $e |- X = ran G $.
    isnvi.6 $e |- Z = ( Id ` G ) $.
    isnvi.7 $e |- <. G , S >. e. CVec $.
    isnvi.8 $e |- N : X --> RR $.
    isnvi.9 $e |- ( ( x e. X /\ ( N ` x ) = 0 ) -> x = Z ) $.
    isnvi.10 $e |- ( ( y e. CC /\ x e. X ) ->
                    ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) ) $.
    isnvi.11 $e |- ( ( x e. X /\ y e. X ) ->
                    ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) $.
    isnvi.12 $e |- U = <. <. G , S >. , N >. $.
    $( Properties that determine a normed complex vector space. $)
    isnvi $p |- U e. NrmCVec $=
      cU cG cS cop cN cop cnv isnvi.12 cG cS cop cN cop cnv wcel cG cS cop cvc
      wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co
      cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cG
      co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX
      wral w3a cG cS cop cvc wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cZ
      wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq
      vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co
      cle wbr vy cX wral w3a vx cX wral isnvi.7 isnvi.8 vx cv cN cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv
      cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN
      cfv caddc co cle wbr vy cX wral w3a vx cX vx cv cX wcel vx cv cN cfv cc0
      wceq vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN
      cfv cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv
      cN cfv caddc co cle wbr vy cX wral vx cv cX wcel vx cv cN cfv cc0 wceq vx
      cv cZ wceq isnvi.9 ex vx cv cX wcel vy cv vx cv cS co cN cfv vy cv cabs
      cfv vx cv cN cfv cmul co wceq vy cc vy cv cc wcel vx cv cX wcel vy cv vx
      cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq isnvi.10 ancoms
      r19.21aiva vx cv cX wcel vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN
      cfv caddc co cle wbr vy cX isnvi.11 r19.21aiva 3jca rgen 3pm3.2i vx vy cS
      cG cN cX cZ isnvi.5 isnvi.6 isnv mpbir eqeltri $.
      $( [10-Jun-2008] $) $( [15-Apr-2007] $)
  $}

  ${
    $d g n s x y G $.  $d g n s x y N $.  $d g n s x y $.  $d g n s U $.
    $d g n s x y S $.  $d g n s x y X $.  $d g n s x Z $.
    nvi.1 $e |- X = ( BaseSet ` U ) $.
    nvi.2 $e |- G = ( +v ` U ) $.
    nvi.4 $e |- S = ( .s ` U ) $.
    nvi.5 $e |- Z = ( 0v ` U ) $.
    nvi.6 $e |- N = ( norm ` U ) $.
    $( The properties of a normed complex vector space, which is a vector
       space accompanied by a norm. $)
    nvi $p |- ( U e. NrmCVec -> ( <. G , S >. e. CVec /\ N : X --> RR /\
       A. x e. X ( ( ( N ` x ) = 0 -> x = Z )
           /\ A. y e. CC ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) /\
              A. y e. X ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) $=
      cU cnv wcel cU vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv
      cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv
      vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv
      co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv
      crn wral w3a vx vg cv crn wral w3a vg vs vn copab2 wcel cG cS cop cvc
      wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co
      cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cG
      co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX
      wral w3a cnv vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv
      cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv
      vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv
      co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv
      crn wral w3a vx vg cv crn wral w3a vg vs vn copab2 cU vx vy vg vn vs
      df-nv eleq2i vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv
      cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv
      vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv
      co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv
      crn wral w3a vx vg cv crn wral w3a cG vs cv cop cvc wcel cX cr vn cv wf
      vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv vs cv co vn cv cfv
      vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG co
      vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a
      vx cX wral w3a cG cS cop cvc wcel cX cr vn cv wf vx cv vn cv cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn cv
      cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv
      vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a cG cS cop
      cvc wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv
      cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy
      cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a
      vx cX wral w3a vg vs vn cU vg cv cU c1st cfv c1st cfv wceq vg cv cG wceq
      vg cv vs cv cop cvc wcel vg cv crn cr vn cv wf vx cv vn cv cfv cc0 wceq
      vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv
      vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn cv cfv vx
      cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral w3a vx vg
      cv crn wral w3a cG vs cv cop cvc wcel cX cr vn cv wf vx cv vn cv cfv cc0
      wceq vx cv cZ wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv
      vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a wb vg
      cv cU c1st cfv c1st cfv wceq vg cv cU c1st cfv c1st cfv cG vg cv cU c1st
      cfv c1st cfv wceq id cU cG nvi.2 vafval syl6eqr vg cv cG wceq vg cv vs cv
      cop cvc wcel cG vs cv cop cvc wcel vg cv crn cr vn cv wf cX cr vn cv wf
      vx cv vn cv cfv cc0 wceq vx cv vg cv cgi cfv wceq wi vy cv vx cv vs cv co
      vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy
      cv vg cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy
      vg cv crn wral w3a vx vg cv crn wral vx cv vn cv cfv cc0 wceq vx cv cZ
      wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv
      cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv
      vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral vg cv cG wceq vg cv
      vs cv cop cG vs cv cop cvc vg cv cG vs cv opeq1 eleq1d vg cv cG wceq vg
      cv crn cX wceq vg cv crn cr vn cv wf cX cr vn cv wf wb vg cv cG wceq vg
      cv crn cG crn cX vg cv cG rneq cU cG cX nvi.1 nvi.2 bafval syl6eqr vg cv
      crn cX cr vn cv feq2 syl vg cv cG wceq vx cv vn cv cfv cc0 wceq vx cv vg
      cv cgi cfv wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn
      cv cfv cmul co wceq vy cc wral vx cv vy cv vg cv co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy vg cv crn wral w3a vx cv vn cv
      cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv vs cv co vn cv cfv vy cv cabs
      cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv
      vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx vg cv
      crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq cU cG cX nvi.1
      nvi.2 bafval syl6eqr vg cv cG wceq vx cv vn cv cfv cc0 wceq vx cv vg cv
      cgi cfv wceq wi vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vx cv vy cv vg
      cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy vg cv
      crn wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv
      caddc co cle wbr vy cX wral vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv
      vx cv vn cv cfv cmul co wceq vy cc wral vg cv cG wceq vx cv vg cv cgi cfv
      wceq vx cv cZ wceq vx cv vn cv cfv cc0 wceq vg cv cG wceq vg cv cgi cfv
      cZ vx cv vg cv cG wceq vg cv cgi cfv cG cgi cfv cZ vg cv cG cgi fveq2 cU
      cG cZ nvi.2 nvi.5 0vfval syl6eqr eqeq2d imbi2d vg cv cG wceq vx cv vy cv
      vg cv co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vx cv
      vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy
      vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq cU cG cX
      nvi.1 nvi.2 bafval syl6eqr vg cv cG wceq vx cv vy cv vg cv co vn cv cfv
      vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle
      vg cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG co vn cv vx cv vy cv vg
      cv cG opreq fveq2d breq1d raleq12d 3anbi13d raleq12d 3anbi123d syl vs cv
      cU c1st cfv c2nd cfv wceq vs cv cS wceq cG vs cv cop cvc wcel cX cr vn cv
      wf vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv vs cv co vn cv
      cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG
      co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral
      w3a vx cX wral w3a cG cS cop cvc wcel cX cr vn cv wf vx cv vn cv cfv cc0
      wceq vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn
      cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a wb vs
      cv cU c1st cfv c2nd cfv wceq vs cv cU c1st cfv c2nd cfv cS vs cv cU c1st
      cfv c2nd cfv wceq id cS cU nvi.4 smfval syl6eqr vs cv cS wceq cG vs cv
      cop cvc wcel cG cS cop cvc wcel vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi
      vy cv vx cv vs cv co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co
      wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv
      cfv caddc co cle wbr vy cX wral w3a vx cX wral vx cv vn cv cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn cv
      cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv
      vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX wral cX cr vn cv wf
      vs cv cS wceq cG vs cv cop cG cS cop cvc vs cv cS cG opeq2 eleq1d vs cv
      cS wceq vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv vs cv co vn
      cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv
      cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX
      wral w3a vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co vn
      cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv
      cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX
      wral w3a vx cX vs cv cS wceq vy cv vx cv vs cv co vn cv cfv vy cv cabs
      cfv vx cv vn cv cfv cmul co wceq vy cc wral vy cv vx cv cS co vn cv cfv
      vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vn cv cfv
      cc0 wceq vx cv cZ wceq wi vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy
      cv vn cv cfv caddc co cle wbr vy cX wral vs cv cS wceq vy cv vx cv vs cv
      co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cv vx cv cS
      co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc vs cv cS
      wceq vy cv vx cv vs cv co vn cv cfv vy cv vx cv cS co vn cv cfv vy cv
      cabs cfv vx cv vn cv cfv cmul co vs cv cS wceq vy cv vx cv vs cv co vy cv
      vx cv cS co vn cv vy cv vx cv vs cv cS opreq fveq2d eqeq1d ralbidv
      3anbi2d ralbidv 3anbi13d syl vn cv cU c2nd cfv wceq vn cv cN wceq cG cS
      cop cvc wcel cX cr vn cv wf vx cv vn cv cfv cc0 wceq vx cv cZ wceq wi vy
      cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy
      cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc
      co cle wbr vy cX wral w3a vx cX wral w3a cG cS cop cvc wcel cX cr cN wf
      vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy cv
      cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx
      cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a wb
      vn cv cU c2nd cfv wceq vn cv cU c2nd cfv cN vn cv cU c2nd cfv wceq id cU
      cN nvi.6 nmfval syl6eqr vn cv cN wceq cX cr vn cv wf cX cr cN wf vx cv vn
      cv cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs
      cfv vx cv vn cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv
      vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cX
      wral vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy
      cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cG co cN cfv
      vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral cG
      cS cop cvc wcel cX cr vn cv cN feq1 vn cv cN wceq vx cv vn cv cfv cc0
      wceq vx cv cZ wceq wi vy cv vx cv cS co vn cv cfv vy cv cabs cfv vx cv vn
      cv cfv cmul co wceq vy cc wral vx cv vy cv cG co vn cv cfv vx cv vn cv
      cfv vy cv vn cv cfv caddc co cle wbr vy cX wral w3a vx cv cN cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv
      cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN
      cfv caddc co cle wbr vy cX wral w3a vx cX vn cv cN wceq vx cv vn cv cfv
      cc0 wceq vx cv cZ wceq wi vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx
      cv cS co vn cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cc wral
      vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc
      wral vx cv vy cv cG co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co
      cle wbr vy cX wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv
      caddc co cle wbr vy cX wral vn cv cN wceq vx cv vn cv cfv cc0 wceq vx cv
      cN cfv cc0 wceq vx cv cZ wceq vn cv cN wceq vx cv vn cv cfv vx cv cN cfv
      cc0 vx cv vn cv cN fveq1 eqeq1d imbi1d vn cv cN wceq vy cv vx cv cS co vn
      cv cfv vy cv cabs cfv vx cv vn cv cfv cmul co wceq vy cv vx cv cS co cN
      cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc vn cv cN wceq vy cv vx
      cv cS co vn cv cfv vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv vn cv
      cfv cmul co vy cv cabs cfv vx cv cN cfv cmul co vy cv vx cv cS co vn cv
      cN fveq1 vn cv cN wceq vx cv vn cv cfv vx cv cN cfv vy cv cabs cfv cmul
      vx cv vn cv cN fveq1 opreq2d eqeq12d ralbidv vn cv cN wceq vx cv vy cv cG
      co vn cv cfv vx cv vn cv cfv vy cv vn cv cfv caddc co cle wbr vx cv vy cv
      cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX vn cv cN
      wceq vx cv vy cv cG co vn cv cfv vx cv vy cv cG co cN cfv vx cv vn cv cfv
      vy cv vn cv cfv caddc co vx cv cN cfv vy cv cN cfv caddc co cle vx cv vy
      cv cG co vn cv cN fveq1 vn cv cN wceq vx cv vn cv cfv vx cv cN cfv vy cv
      vn cv cfv vy cv cN cfv caddc vx cv vn cv cN fveq1 vy cv vn cv cN fveq1
      opreq12d breq12d ralbidv 3anbi123d ralbidv 3anbi23d syl eloprabi sylbi $.
      $( [5-Sep-2007] $) $( [11-Nov-2006] $)
  $}

  ${
    $d x y U $.  $d x y W $.
    nvvc.1 $e |- W = ( 1st ` U ) $.
    $( The vector space component of a normed complex vector space. $)
    nvvc $p |- ( U e. NrmCVec -> W e. CVec ) $=
      cU cnv wcel cW cW c1st cfv cW c2nd cfv cop cvc cW c2nd cfv cU cW c1st cfv
      cW nvvc.1 cW c1st cfv cU c1st cfv c1st cfv cU cpv cfv cW cU c1st cfv c1st
      nvvc.1 fveq2i cU cU cpv cfv cU cpv cfv eqid vafval eqtr4i cW c2nd cfv cU
      c1st cfv c2nd cfv cU cns cfv cW cU c1st cfv c2nd nvvc.1 fveq2i cU cns cfv
      cU cU cns cfv eqid smfval eqtr4i nvvop cU cnv wcel cW c1st cfv cW c2nd
      cfv cop cvc wcel cW c1st cfv crn cr cU c2nd cfv wf vx cv cU c2nd cfv cfv
      cc0 wceq vx cv cW c1st cfv cgi cfv wceq wi vy cv vx cv cW c2nd cfv co cU
      c2nd cfv cfv vy cv cabs cfv vx cv cU c2nd cfv cfv cmul co wceq vy cc wral
      vx cv vy cv cW c1st cfv co cU c2nd cfv cfv vx cv cU c2nd cfv cfv vy cv cU
      c2nd cfv cfv caddc co cle wbr vy cW c1st cfv crn wral w3a vx cW c1st cfv
      crn wral vx vy cW c2nd cfv cU cW c1st cfv cU c2nd cfv cW c1st cfv crn cW
      c1st cfv cgi cfv cU cba cfv cW c1st cfv crn cU cW c1st cfv cU cba cfv cU
      cba cfv eqid cW c1st cfv cU c1st cfv c1st cfv cU cpv cfv cW cU c1st cfv
      c1st nvvc.1 fveq2i cU cU cpv cfv cU cpv cfv eqid vafval eqtr4i bafval
      eqcomi cW c1st cfv cU c1st cfv c1st cfv cU cpv cfv cW cU c1st cfv c1st
      nvvc.1 fveq2i cU cU cpv cfv cU cpv cfv eqid vafval eqtr4i cW c2nd cfv cU
      c1st cfv c2nd cfv cU cns cfv cW cU c1st cfv c2nd nvvc.1 fveq2i cU cns cfv
      cU cU cns cfv eqid smfval eqtr4i cU cn0v cfv cW c1st cfv cgi cfv cU cW
      c1st cfv cU cn0v cfv cW c1st cfv cU c1st cfv c1st cfv cU cpv cfv cW cU
      c1st cfv c1st nvvc.1 fveq2i cU cU cpv cfv cU cpv cfv eqid vafval eqtr4i
      cU cn0v cfv eqid 0vfval eqcomi cU cnm cfv cU c2nd cfv cU cU cnm cfv cU
      cnm cfv eqid nmfval eqcomi nvi 3simp1d eqeltrd $.
      $( [7-Sep-2007] $) $( [28-Nov-2006] $)
  $}

  ${
    nvabl.1 $e |- G = ( +v ` U ) $.
    $( The vector addition operation of a normed complex vector space is an
       Abelian group. $)
    nvabl $p |- ( U e. NrmCVec -> G e. Abel ) $=
      cU cnv wcel cU c1st cfv cvc wcel cG cabl wcel cU cU c1st cfv cU c1st cfv
      eqid nvvc cG cU c1st cfv cU cG nvabl.1 vafval vcabl syl $.
      $( [15-Feb-2008] $) $( [15-Feb-2008] $)

    $( The vector addition operation of a normed complex vector space is a
       group. $)
    nvgrp $p |- ( U e. NrmCVec -> G e. Grp ) $=
      cU cnv wcel cG cabl wcel cG cgr wcel cU cG nvabl.1 nvabl cG ablgrp syl $.
      $( [16-Feb-2008] $) $( [15-Feb-2008] $)
  $}

  ${
    nvgf.1 $e |- X = ( BaseSet ` U ) $.
    nvgf.2 $e |- G = ( +v ` U ) $.
    $( Mapping for the vector addition operation. $)
    nvgf $p |- ( U e. NrmCVec -> G : ( X X. X ) --> X ) $=
      cU cnv wcel cG cgr wcel cX cX cxp cX cG wfo cX cX cxp cX cG wf cU cG
      nvgf.2 nvgrp cG cX cU cG cX nvgf.1 nvgf.2 bafval grpfo cX cX cxp cX cG
      fof 3syl $.
      $( [28-Jan-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    nvsf.1 $e |- X = ( BaseSet ` U ) $.
    nvsf.4 $e |- S = ( .s ` U ) $.
    $( Mapping for the scalar multiplication operation. $)
    nvsf $p |- ( U e. NrmCVec -> S : ( CC X. X ) --> X ) $=
      cU cnv wcel cU c1st cfv cvc wcel cc cX cxp cX cS wf cU cU c1st cfv cU
      c1st cfv eqid nvvc cS cU cpv cfv cU c1st cfv cX cU cU cpv cfv cU cpv cfv
      eqid vafval cS cU nvsf.4 smfval cU cU cpv cfv cX nvsf.1 cU cpv cfv eqid
      bafval vcsm syl $.
      $( [30-Jan-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    nvgcl.1 $e |- X = ( BaseSet ` U ) $.
    nvgcl.2 $e |- G = ( +v ` U ) $.
    $( Closure law for the vector addition (group) operation of a normed
       complex vector space. $)
    nvgcl $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                    ( A G B ) e. X ) $=
      cG cgr wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU cnv wcel cA cB
      cG cX cU cG cX nvgcl.1 nvgcl.2 bafval grpcl cU cG nvgcl.2 nvgrp syl3an1
      $.
      $( [22-Nov-2007] $) $( [23-Apr-2007] $)

    $( The vector addition (group) operation  is commutative. $)
    nvcom $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A G B ) = ( B G A ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cU cnv
      wcel cA cB cG cX cU cG cX nvgcl.1 nvgcl.2 bafval ablcom cU cG nvgcl.2
      nvabl syl3an1 $.
      $( [8-Dec-2007] $) $( [4-Dec-2007] $)

    $( The vector addition (group) operation is associative. $)
    nvass $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
              ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cB cC cG co cG co wceq cU cnv wcel cA cB cC cG cX cU cG cX nvgcl.1
      nvgcl.2 bafval grpass cU cG nvgcl.2 nvgrp sylan $.
      $( [8-Dec-2007] $) $( [4-Dec-2007] $)

    $( Commutative/associative law for vector addition. $)
    nvadd12 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( A G ( B G C ) ) = ( B G ( A G C ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cG co cC cG co
      cB cA cG co cC cG co cA cB cC cG co cG co cB cA cC cG co cG co cU cnv
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cG co cB cA cG co cC
      cG cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cC cX
      wcel cA cB cU cG cX nvgcl.1 nvgcl.2 nvcom 3adant3r3 opreq1d cA cB cC cU
      cG cX nvgcl.1 nvgcl.2 nvass cU cnv wcel cB cX wcel cA cX wcel cC cX wcel
      w3a cB cA cG co cC cG co cB cA cC cG co cG co wceq cA cX wcel cB cX wcel
      cC cX wcel w3a cB cA cC cU cG cX nvgcl.1 nvgcl.2 nvass cA cX wcel cB cX
      wcel cC cX wcel 3ancoma sylan2b 3eqtr3d $.
      $( [12-Jan-2008] $) $( [14-Dec-2007] $)

    $( Commutative/associative law for vector addition. $)
    nvadd23 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cC cG co cB cG co wceq cU cnv wcel cA cB cC cG cX cU cG cX nvgcl.1
      nvgcl.2 bafval abl23 cU cG nvgcl.2 nvabl sylan $.
      $( [5-Jan-2008] $) $( [27-Dec-2007] $)

    $( Right cancellation law for vector addition. $)
    nvrcan $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cC cG co cB cC cG co
      wceq cA cB wceq wb cU cnv wcel cA cB cC cG cX cU cG cX nvgcl.1 nvgcl.2
      bafval grprcan cU cG nvgcl.2 nvgrp sylan $.
      $( [7-Dec-2007] $) $( [4-Dec-2007] $)

    $( Left cancellation law for vector addition. $)
    nvlcan $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cC cA cG co cC cB cG co
      wceq cA cB wceq wb cU cnv wcel cA cB cC cG cX cU cG cX nvgcl.1 nvgcl.2
      bafval grplcan cU cG nvgcl.2 nvgrp sylan $.
      $( [11-Jan-2008] $) $( [14-Dec-2007] $)

    $( Rearrangement of 4 terms in a vector sum. $)
    nvadd4 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X ) /\ ( C e. X /\
       D e. X ) ) -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa cA cB cG
      co cC cD cG co cG co cA cC cG co cB cD cG co cG co wceq cU cnv wcel cA cB
      cC cD cG cX cU cG cX nvgcl.1 nvgcl.2 bafval abl4 cU cG nvgcl.2 nvabl
      syl3an1 $.
      $( [2-Mar-2008] $) $( [8-Feb-2008] $)
  $}

  ${
    nvscl.1 $e |- X = ( BaseSet ` U ) $.
    nvscl.4 $e |- S = ( .s ` U ) $.
    $( Closure law for the scalar product operation of a normed complex vector
       space. $)
    nvscl $p |- ( ( U e. NrmCVec /\ A e. CC /\ B e. X ) ->
                       ( A S B ) e. X ) $=
      cU c1st cfv cvc wcel cA cc wcel cB cX wcel cA cB cS co cX wcel cU cnv
      wcel cA cB cS cU cpv cfv cU c1st cfv cX cU cU cpv cfv cU cpv cfv eqid
      vafval cS cU nvscl.4 smfval cU cU cpv cfv cX nvscl.1 cU cpv cfv eqid
      bafval vccl cU cU c1st cfv cU c1st cfv eqid nvvc syl3an1 $.
      $( [6-Sep-2007] $) $( [1-Feb-2007] $)

    $( Identity element for the scalar product of a normed complex vector
       space. $)
    nvsid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( 1 S A ) = A ) $=
      cU c1st cfv cvc wcel cA cX wcel c1 cA cS co cA wceq cU cnv wcel cA cS cU
      cpv cfv cU c1st cfv cX cU cU cpv cfv cU cpv cfv eqid vafval cS cU nvscl.4
      smfval cU cU cpv cfv cX nvscl.1 cU cpv cfv eqid bafval vcid cU cU c1st
      cfv cU c1st cfv eqid nvvc sylan $.
      $( [7-Dec-2007] $) $( [4-Dec-2007] $)

    $( Associative law for the scalar product of a normed complex vector
       space. $)
    nvsass $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A x. B ) S C ) = ( A S ( B S C ) ) ) $=
      cU c1st cfv cvc wcel cA cc wcel cB cc wcel cC cX wcel w3a cA cB cmul co
      cC cS co cA cB cC cS co cS co wceq cU cnv wcel cA cB cC cS cU cpv cfv cU
      c1st cfv cX cU cU cpv cfv cU cpv cfv eqid vafval cS cU nvscl.4 smfval cU
      cU cpv cfv cX nvscl.1 cU cpv cfv eqid bafval vcass cU cU c1st cfv cU c1st
      cfv eqid nvvc sylan $.
      $( [20-Nov-2007] $) $( [17-Nov-2007] $)

    $( Commutative law for the scalar product of a normed complex vector
       space. $)
    nvscom $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( A S ( B S C ) ) = ( B S ( A S C ) ) ) $=
      cU cnv wcel cA cc wcel cB cc wcel cC cX wcel w3a wa cA cB cmul co cC cS
      co cB cA cmul co cC cS co cA cB cC cS co cS co cB cA cC cS co cS co cA cc
      wcel cB cc wcel cC cX wcel w3a cA cB cmul co cC cS co cB cA cmul co cC cS
      co wceq cU cnv wcel cA cc wcel cB cc wcel cA cB cmul co cC cS co cB cA
      cmul co cC cS co wceq cC cX wcel cA cc wcel cB cc wcel wa cA cB cmul co
      cB cA cmul co cC cS cA cB mulcom opreq1d 3adant3 adantl cA cB cC cS cU cX
      nvscl.1 nvscl.4 nvsass cU cnv wcel cB cc wcel cA cc wcel cC cX wcel w3a
      cB cA cmul co cC cS co cB cA cC cS co cS co wceq cA cc wcel cB cc wcel cC
      cX wcel w3a cB cA cC cS cU cX nvscl.1 nvscl.4 nvsass cA cc wcel cB cc
      wcel cC cX wcel 3ancoma sylan2b 3eqtr3d $.
      $( [2-Mar-2008] $) $( [14-Feb-2008] $)
  $}

  ${
    nvdi.1 $e |- X = ( BaseSet ` U ) $.
    nvdi.2 $e |- G = ( +v ` U ) $.
    nvdi.4 $e |- S = ( .s ` U ) $.
    $( Distributive law for the scalar product of a complex vector space. $)
    nvdi $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
       ( A S ( B G C ) ) = ( ( A S B ) G ( A S C ) ) ) $=
      cU c1st cfv cvc wcel cA cc wcel cB cX wcel cC cX wcel w3a cA cB cC cG co
      cS co cA cB cS co cA cC cS co cG co wceq cU cnv wcel cA cB cC cS cG cU
      c1st cfv cX cU cG nvdi.2 vafval cS cU nvdi.4 smfval cU cG cX nvdi.1
      nvdi.2 bafval vcdi cU cU c1st cfv cU c1st cfv eqid nvvc sylan $.
      $( [7-Dec-2007] $) $( [4-Dec-2007] $)

    $( Distributive law for the scalar product of a complex vector space. $)
    nvdir $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A + B ) S C ) = ( ( A S C ) G ( B S C ) ) ) $=
      cU c1st cfv cvc wcel cA cc wcel cB cc wcel cC cX wcel w3a cA cB caddc co
      cC cS co cA cC cS co cB cC cS co cG co wceq cU cnv wcel cA cB cC cS cG cU
      c1st cfv cX cU cG nvdi.2 vafval cS cU nvdi.4 smfval cU cG cX nvdi.1
      nvdi.2 bafval vcdir cU cU c1st cfv cU c1st cfv eqid nvvc sylan $.
      $( [8-Dec-2007] $) $( [4-Dec-2007] $)

    $( A vector plus itself is two times the vector. $)
    nv2 $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A G A ) = ( 2 S A ) ) $=
      cU c1st cfv cvc wcel cA cX wcel cA cA cG co c2 cA cS co wceq cU cnv wcel
      cA cS cG cU c1st cfv cX cU cG nvdi.2 vafval cS cU nvdi.4 smfval cU cG cX
      nvdi.1 nvdi.2 bafval vc2 cU cU c1st cfv cU c1st cfv eqid nvvc sylan $.
      $( [6-Mar-2008] $) $( [9-Feb-2008] $)
  $}

  ${
    $d f g x y z $.
    vsfval.2 $e |- G = ( +v ` U ) $.
    vsfval.3 $e |- M = ( -v ` U ) $.
    $( Value of the function for the vector subtraction operation on a
       normed complex vector space. $)
    vsfval $p |- M = ( /g ` G ) $=
      cU cnsb cfv cU cpv cfv cgs cfv cM cG cgs cfv cU cvv wcel cU cnsb cfv cU
      cpv cfv cgs cfv wceq cU cvv wcel cU cgs cpv ccom cfv cU cpv cfv cgs cfv
      cU cnsb cfv cU cvv wcel cU cpv cdm wcel cU cgs cpv ccom cfv cU cpv cfv
      cgs cfv wceq cpv cdm cvv cU cpv cdm c1st c1st ccom cdm c1st cdm cvv cpv
      c1st c1st ccom df-va dmeqi c1st cdm c1st crn wceq c1st c1st ccom cdm c1st
      cdm wceq c1st cdm cvv c1st crn cvv cvv c1st cvv cvv c1st wfo cvv cvv c1st
      wf fo1st cvv cvv c1st fof ax-mp fdmi cvv cvv c1st wfo c1st crn cvv wceq
      fo1st cvv cvv c1st forn ax-mp eqtr4i c1st c1st dmcoeq ax-mp cvv cvv c1st
      cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof ax-mp fdmi 3eqtri
      eleq2i cgs wfun cpv wfun cU cpv cdm wcel cU cgs cpv ccom cfv cU cpv cfv
      cgs cfv wceq cgs cgr wfn cgs wfun vg vf cgr vx cv vg cv crn wcel vy cv vg
      cv crn wcel wa vz cv vx cv vy cv vg cv cgn cfv cfv vg cv co wceq wa vx vy
      vz copab2 cgs vx vy vz vg cv crn vg cv crn vx cv vy cv vg cv cgn cfv cfv
      vg cv co vx cv vg cv crn wcel vy cv vg cv crn wcel wa vz cv vx cv vy cv
      vg cv cgn cfv cfv vg cv co wceq wa vx vy vz copab2 vg cv vg visset rnex
      vg cv vg visset rnex vx cv vg cv crn wcel vy cv vg cv crn wcel wa vz cv
      vx cv vy cv vg cv cgn cfv cfv vg cv co wceq wa vx vy vz copab2 eqid
      oprabex2 vx vy vz vf vg df-gdiv fnopab2 cgr cgs fnfun ax-mp cpv wfun c1st
      c1st ccom wfun c1st wfun c1st wfun c1st c1st ccom wfun cvv cvv c1st wfo
      c1st wfun fo1st cvv cvv c1st fofun ax-mp cvv cvv c1st wfo c1st wfun fo1st
      cvv cvv c1st fofun ax-mp c1st c1st funco mp2an cpv c1st c1st ccom wceq
      cpv wfun c1st c1st ccom wfun wb df-va cpv c1st c1st ccom funeq ax-mp
      mpbir cU cgs cpv fvco mp3an12 sylbir cU cnsb cgs cpv ccom df-vs fveq1i
      syl5eq cU cvv wcel wn c0 cgs cfv c0 cU cpv cfv cgs cfv cU cnsb cfv c0 cgs
      cfv c0 wceq cU cvv wcel wn c0 cgs cdm wcel wn c0 cgs cfv c0 wceq c0 cgs
      cdm wcel c0 cgr wcel 0ngrp cgs cdm cgr c0 vg vf cgr vx cv vg cv crn wcel
      vy cv vg cv crn wcel wa vz cv vx cv vy cv vg cv cgn cfv cfv vg cv co wceq
      wa vx vy vz copab2 cgs vx vy vz vg cv crn vg cv crn vx cv vy cv vg cv cgn
      cfv cfv vg cv co vx cv vg cv crn wcel vy cv vg cv crn wcel wa vz cv vx cv
      vy cv vg cv cgn cfv cfv vg cv co wceq wa vx vy vz copab2 vg cv vg visset
      rnex vg cv vg visset rnex vx cv vg cv crn wcel vy cv vg cv crn wcel wa vz
      cv vx cv vy cv vg cv cgn cfv cfv vg cv co wceq wa vx vy vz copab2 eqid
      oprabex2 vx vy vz vf vg df-gdiv dmopab2 eleq2i mtbir c0 cgs ndmfv ax-mp
      a1i cU cvv wcel wn cU cpv cfv c0 cgs cU cpv fvprc fveq2d cU cnsb fvprc
      3eqtr4rd pm2.61i vsfval.3 cG cU cpv cfv cgs vsfval.2 fveq2i 3eqtr4i $.
      $( [19-Feb-2008] $) $( [15-Feb-2008] $)
  $}

  ${
    nvzcl.1 $e |- X = ( BaseSet ` U ) $.
    nvzcl.6 $e |- Z = ( 0v ` U ) $.
    $( Closure law for the zero vector of a normed complex vector space. $)
    nvzcl $p |- ( U e. NrmCVec -> Z e. X ) $=
      cU cnv wcel cU cpv cfv cgr wcel cZ cX wcel cU cU cpv cfv cU cpv cfv eqid
      nvgrp cZ cU cpv cfv cX cU cU cpv cfv cX nvzcl.1 cU cpv cfv eqid bafval cU
      cU cpv cfv cZ cU cpv cfv eqid nvzcl.6 0vfval grpidcl syl $.
      $( [27-Nov-2007] $) $( [27-Nov-2007] $)
  $}

  ${
    nv0id.1 $e |- X = ( BaseSet ` U ) $.
    nv0id.2 $e |- G = ( +v ` U ) $.
    nv0id.6 $e |- Z = ( 0v ` U ) $.
    $( The zero vector is a right identity element. $)
    nv0rid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A G Z ) = A ) $=
      cG cgr wcel cA cX wcel cA cZ cG co cA wceq cU cnv wcel cA cZ cG cX cU cG
      cX nv0id.1 nv0id.2 bafval cU cG cZ nv0id.2 nv0id.6 0vfval grprid cU cG
      nv0id.2 nvgrp sylan $.
      $( [7-Dec-2007] $) $( [28-Nov-2007] $)

    $( The zero vector is a left identity element. $)
    nv0lid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( Z G A ) = A ) $=
      cG cgr wcel cA cX wcel cZ cA cG co cA wceq cU cnv wcel cA cZ cG cX cU cG
      cX nv0id.1 nv0id.2 bafval cU cG cZ nv0id.2 nv0id.6 0vfval grplid cU cG
      nv0id.2 nvgrp sylan $.
      $( [9-Dec-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    nv0.1 $e |- X = ( BaseSet ` U ) $.
    nv0.4 $e |- S = ( .s ` U ) $.
    nv0.6 $e |- Z = ( 0v ` U ) $.
    $( Zero times a vector is the zero vector. $)
    nv0 $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( 0 S A ) = Z ) $=
      cU c1st cfv cvc wcel cA cX wcel cc0 cA cS co cZ wceq cU cnv wcel cA cS cU
      cpv cfv cU c1st cfv cX cZ cU cU cpv cfv cU cpv cfv eqid vafval cS cU
      nv0.4 smfval cU cU cpv cfv cX nv0.1 cU cpv cfv eqid bafval cU cU cpv cfv
      cZ cU cpv cfv eqid nv0.6 0vfval vc0 cU cU c1st cfv cU c1st cfv eqid nvvc
      sylan $.
      $( [27-Nov-2007] $) $( [27-Nov-2007] $)
  $}

  ${
    nvsz.4 $e |- S = ( .s ` U ) $.
    nvsz.6 $e |- Z = ( 0v ` U ) $.
    $( Anything times the zero vector is the zero vector. $)
    nvsz $p |- ( ( U e. NrmCVec /\ A e. CC ) -> ( A S Z ) = Z ) $=
      cU c1st cfv cvc wcel cA cc wcel cA cZ cS co cZ wceq cU cnv wcel cA cS cU
      cpv cfv cU c1st cfv cU cba cfv cZ cU cU cpv cfv cU cpv cfv eqid vafval cS
      cU nvsz.4 smfval cU cU cpv cfv cU cba cfv cU cba cfv eqid cU cpv cfv eqid
      bafval cU cU cpv cfv cZ cU cpv cfv eqid nvsz.6 0vfval vcz cU cU c1st cfv
      cU c1st cfv eqid nvvc sylan $.
      $( [8-Dec-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    nvinv.1 $e |- X = ( BaseSet ` U ) $.
    nvinv.2 $e |- G = ( +v ` U ) $.
    nvinv.4 $e |- S = ( .s ` U ) $.
    nvinv.5 $e |- M = ( inv ` G ) $.
    $( Minus 1 times a vector is the underlying group's inverse element.
       Equation 2 of [Kreyszig] p. 51. $)
    nvinv $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( -u 1 S A ) = ( M ` A ) ) $=
      cU c1st cfv cvc wcel cA cX wcel c1 cneg cA cS co cA cM cfv wceq cU cnv
      wcel cA cS cG cM cU c1st cfv cX cU cG nvinv.2 vafval cS cU nvinv.4 smfval
      cU cG cX nvinv.1 nvinv.2 bafval nvinv.5 vcm cU cU c1st cfv cU c1st cfv
      eqid nvvc sylan $.
      $( [16-Feb-2008] $) $( [15-Feb-2008] $)
  $}

  ${
    $d x G $.  $d x N $.  $d x U $.
    invfval.2 $e |- G = ( +v ` U ) $.
    invfval.4 $e |- S = ( .s ` U ) $.
    invfval.3 $e |- N = ( S o. `' ( 2nd |` ( { -u 1 } X. _V ) ) ) $.
    $( Function for the negative of a vector on a normed complex vector space,
       in terms of the underlying addition group inverse.  (We currently do
       not have a separate notation for the negative of a vector.) $)
    invfval $p |- ( U e. NrmCVec -> N = ( inv ` G ) ) $=
      cU cnv wcel cN cG cgn cfv wceq vx cv cN cfv vx cv cG cgn cfv cfv wceq vx
      cU cba cfv wral cU cnv wcel vx cv cN cfv vx cv cG cgn cfv cfv wceq vx cU
      cba cfv cU cnv wcel vx cv cU cba cfv wcel wa vx cv cN cfv c1 cneg vx cv
      cS co vx cv cG cgn cfv cfv cS cc cU cba cfv cxp wfn vx cv cU cba cfv wcel
      vx cv cN cfv c1 cneg vx cv cS co wceq cU cnv wcel cS cc cU cba cfv cxp
      wfn c1 cneg cc wcel vx cv cU cba cfv wcel vx cv cN cfv c1 cneg vx cv cS
      co wceq c1 ax1cn negcli cc cU cba cfv c1 cneg vx cv cU cba cfv cS cN
      invfval.3 curry1val mp3an2 cU cnv wcel cc cU cba cfv cxp cU cba cfv cS wf
      cS cc cU cba cfv cxp wfn cS cU cU cba cfv cU cba cfv eqid invfval.4 nvsf
      cc cU cba cfv cxp cU cba cfv cS ffn syl sylan vx cv cS cU cG cG cgn cfv
      cU cba cfv cU cba cfv eqid invfval.2 invfval.4 cG cgn cfv eqid nvinv
      eqtrd r19.21aiva cN cU cba cfv wfn cG cgn cfv cU cba cfv wfn cN cG cgn
      cfv wceq vx cv cN cfv vx cv cG cgn cfv cfv wceq vx cU cba cfv wral wb cU
      cnv wcel vx cU cba cfv cN cG cgn cfv eqfnfv2 cU cnv wcel cU cba cfv cU
      cba cfv cN wf cN cU cba cfv wfn cc cU cba cfv cxp cU cba cfv cS wf c1
      cneg cc wcel cU cba cfv cU cba cfv cN wf cU cnv wcel cc cU cba cfv c1
      cneg cU cba cfv cS cN invfval.3 curry1f cS cU cU cba cfv cU cba cfv eqid
      invfval.4 nvsf c1 ax1cn negcli sylancl cU cba cfv cU cba cfv cN ffn syl
      cU cnv wcel cU cba cfv cU cba cfv cG cgn cfv wf1o cG cgn cfv cU cba cfv
      wfn cU cnv wcel cG cgr wcel cU cba cfv cU cba cfv cG cgn cfv wf1o cU cG
      invfval.2 nvgrp cG cG cgn cfv cU cba cfv cU cG cU cba cfv cU cba cfv eqid
      invfval.2 bafval cG cgn cfv eqid grpinvf syl cU cba cfv cU cba cfv cG cgn
      cfv f1ofn syl sylanc mpbird $.
      $( [7-May-2008] $) $( [27-Mar-2008] $)
  $}

  ${
    nvm.1 $e |- X = ( BaseSet ` U ) $.
    nvm.2 $e |- G = ( +v ` U ) $.
    nvm.3 $e |- M = ( -v ` U ) $.
    nvm.6 $e |- N = ( /g ` G ) $.
    $( Vector subtraction in terms of group division operation. $)
    nvm $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( A M B ) = ( A N B ) ) $=
      cA cB cM co cA cB cN co wceq cU cnv wcel cA cX wcel cB cX wcel w3a cM cN
      cA cB cM cG cgs cfv cN cU cG cM nvm.2 nvm.3 vsfval nvm.6 eqtr4i opreqi
      a1i $.
      $( [18-Feb-2008] $) $( [15-Feb-2008] $)
  $}

  ${
    $d x y z G $.  $d x y z U $.  $d x y z X $.
    nvmval.1 $e |- X = ( BaseSet ` U ) $.
    nvmval.2 $e |- G = ( +v ` U ) $.
    nvmval.4 $e |- S = ( .s ` U ) $.
    nvmval.3 $e |- M = ( -v ` U ) $.
    $( Value of vector subtraction on a normed complex vector space. $)
    nvmval $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A M B ) = ( A G ( -u 1 S B ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG cgs cfv co cA cB cG cgn
      cfv cfv cG co cA cB cM co cA c1 cneg cB cS co cG co cG cgr wcel cA cX
      wcel cB cX wcel cA cB cG cgs cfv co cA cB cG cgn cfv cfv cG co wceq cU
      cnv wcel cA cB cG cgs cfv cG cG cgn cfv cX cU cG cX nvmval.1 nvmval.2
      bafval cG cgn cfv eqid cG cgs cfv eqid grpdivval cU cG nvmval.2 nvgrp
      syl3an1 cA cB cU cG cM cG cgs cfv cX nvmval.1 nvmval.2 nvmval.3 cG cgs
      cfv eqid nvm cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cB cS co cB cG
      cgn cfv cfv cA cG cU cnv wcel cB cX wcel c1 cneg cB cS co cB cG cgn cfv
      cfv wceq cA cX wcel cB cS cU cG cG cgn cfv cX nvmval.1 nvmval.2 nvmval.4
      cG cgn cfv eqid nvinv 3adant2 opreq2d 3eqtr4d $.
      $( [12-Sep-2007] $) $( [11-Sep-2007] $)

    $( Value of the function for the vector subtraction operation on a normed
       complex vector space. $)
    nvmfval $p |- ( U e. NrmCVec -> M = { <. <. x , y >. , z >. |
                 ( ( x e. X /\ y e. X ) /\ z = ( x G ( -u 1 S y ) ) ) } ) $=
      cU cnv wcel cM vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cG cgn
      cfv cfv cG co wceq wa vx vy vz copab2 vx cv cX wcel vy cv cX wcel wa vz
      cv vx cv c1 cneg vy cv cS co cG co wceq wa vx vy vz copab2 cU cnv wcel cG
      cgr wcel cM vx cv cX wcel vy cv cX wcel wa vz cv vx cv vy cv cG cgn cfv
      cfv cG co wceq wa vx vy vz copab2 wceq cU cG nvmval.2 nvgrp vx vy vz cM
      cG cG cgn cfv cX cU cG cX nvmval.1 nvmval.2 bafval cG cgn cfv eqid cU cG
      cM nvmval.2 nvmval.3 vsfval grpdivfval syl cU cnv wcel vx cv cX wcel vy
      cv cX wcel wa vz cv vx cv c1 cneg vy cv cS co cG co wceq wa vx cv cX wcel
      vy cv cX wcel wa vz cv vx cv vy cv cG cgn cfv cfv cG co wceq wa vx vy vz
      cU cnv wcel vx cv cX wcel vy cv cX wcel wa vz cv vx cv c1 cneg vy cv cS
      co cG co wceq vz cv vx cv vy cv cG cgn cfv cfv cG co wceq cU cnv wcel vx
      cv cX wcel vy cv cX wcel wa wa vx cv c1 cneg vy cv cS co cG co vx cv vy
      cv cG cgn cfv cfv cG co vz cv cU cnv wcel vx cv cX wcel vy cv cX wcel wa
      wa c1 cneg vy cv cS co vy cv cG cgn cfv cfv vx cv cG cU cnv wcel vy cv cX
      wcel c1 cneg vy cv cS co vy cv cG cgn cfv cfv wceq vx cv cX wcel vy cv cS
      cU cG cG cgn cfv cX nvmval.1 nvmval.2 nvmval.4 cG cgn cfv eqid nvinv
      adantrl opreq2d eqeq2d pm5.32da oprabbidv eqtr4d $.
      $( [12-Sep-2007] $) $( [11-Sep-2007] $)
  $}

  ${
    nvzs.1 $e |- X = ( BaseSet ` U ) $.
    nvzs.3 $e |- M = ( -v ` U ) $.
    nvzs.4 $e |- S = ( .s ` U ) $.
    nvzs.6 $e |- Z = ( 0v ` U ) $.
    $( Two ways to express the negative of a vector. $)
    nvzs $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( Z M A ) = ( -u 1 S A ) ) $=
      cU cnv wcel cA cX wcel wa cZ cA cM co cZ c1 cneg cA cS co cU cpv cfv co
      c1 cneg cA cS co cU cnv wcel cZ cX wcel cA cX wcel cZ cA cM co cZ c1 cneg
      cA cS co cU cpv cfv co wceq cU cnv wcel cA cX wcel wa cZ cA cS cU cU cpv
      cfv cM cX nvzs.1 cU cpv cfv eqid nvzs.4 nvzs.3 nvmval cU cnv wcel cA cX
      wcel pm3.26 cU cnv wcel cZ cX wcel cA cX wcel cU cX cZ nvzs.1 nvzs.6
      nvzcl adantr cU cnv wcel cA cX wcel pm3.27 syl3anc cU cnv wcel cA cX wcel
      c1 cneg cA cS co cX wcel cZ c1 cneg cA cS co cU cpv cfv co c1 cneg cA cS
      co wceq cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX wcel
      c1 ax1cn negcli c1 cneg cA cS cU cX nvzs.1 nvzs.4 nvscl mp3an2 c1 cneg cA
      cS co cU cU cpv cfv cX cZ nvzs.1 cU cpv cfv eqid nvzs.6 nv0lid syldan
      eqtrd $.
      $( [29-Feb-2008] $) $( [29-Feb-2008] $)
  $}

  ${
    $d x y z U $.  $d x y z X $.
    nvmf.1 $e |- X = ( BaseSet ` U ) $.
    nvmf.3 $e |- M = ( -v ` U ) $.
    $( Mapping for the vector subtraction operation. $)
    nvmf $p |- ( U e. NrmCVec -> M : ( X X. X ) --> X ) $=
      cU cnv wcel cX cX cxp cX cM wf cX cX cxp cX vx cv cX wcel vy cv cX wcel
      wa vz cv vx cv c1 cneg vy cv cU cns cfv co cU cpv cfv co wceq wa vx vy vz
      copab2 wf cU cnv wcel vx cv c1 cneg vy cv cU cns cfv co cU cpv cfv co cX
      wcel vy cX wral vx cX wral cX cX cxp cX vx cv cX wcel vy cv cX wcel wa vz
      cv vx cv c1 cneg vy cv cU cns cfv co cU cpv cfv co wceq wa vx vy vz
      copab2 wf cU cnv wcel vx cv c1 cneg vy cv cU cns cfv co cU cpv cfv co cX
      wcel vx vy cX cX cU cnv wcel vx cv cX wcel vy cv cX wcel wa vx cv c1 cneg
      vy cv cU cns cfv co cU cpv cfv co cX wcel cU cnv wcel vx cv cX wcel c1
      cneg vy cv cU cns cfv co cX wcel vx cv c1 cneg vy cv cU cns cfv co cU cpv
      cfv co cX wcel cU cnv wcel vx cv cX wcel vy cv cX wcel wa wa vx cv c1
      cneg vy cv cU cns cfv co cU cU cpv cfv cX nvmf.1 cU cpv cfv eqid nvgcl cU
      cnv wcel vx cv cX wcel vy cv cX wcel wa pm3.26 cU cnv wcel vx cv cX wcel
      vy cv cX wcel simprl cU cnv wcel vy cv cX wcel c1 cneg vy cv cU cns cfv
      co cX wcel vx cv cX wcel cU cnv wcel c1 cneg cc wcel vy cv cX wcel c1
      cneg vy cv cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg vy cv cU cns cfv
      cU cX nvmf.1 cU cns cfv eqid nvscl mp3an2 adantrl syl3anc ex r19.21aivv
      vx vy vz cX cX vx cv c1 cneg vy cv cU cns cfv co cU cpv cfv co cX vx cv
      cX wcel vy cv cX wcel wa vz cv vx cv c1 cneg vy cv cU cns cfv co cU cpv
      cfv co wceq wa vx vy vz copab2 vx cv cX wcel vy cv cX wcel wa vz cv vx cv
      c1 cneg vy cv cU cns cfv co cU cpv cfv co wceq wa vx vy vz copab2 eqid
      foprab2 sylib cU cnv wcel cX cX cxp cX cM vx cv cX wcel vy cv cX wcel wa
      vz cv vx cv c1 cneg vy cv cU cns cfv co cU cpv cfv co wceq wa vx vy vz
      copab2 vx vy vz cU cns cfv cU cU cpv cfv cM cX nvmf.1 cU cpv cfv eqid cU
      cns cfv eqid nvmf.3 nvmfval feq1d mpbird $.
      $( [12-Sep-2007] $) $( [11-Sep-2007] $)

    $( Closure law for the vector subtraction operation of a normed complex
       vector space. $)
    nvmcl $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A M B ) e. X ) $=
      cX cX cxp cX cM wf cA cX wcel cB cX wcel cA cB cM co cX wcel cU cnv wcel
      cA cB cX cX cX cM foprrn cU cM cX nvmf.1 nvmf.3 nvmf syl3an1 $.
      $( [12-Sep-2007] $) $( [11-Sep-2007] $)

    $( Vector space analog of ~ nnncan1 . $)
    nvnnncan1 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A M B ) M ( A M C ) ) = ( C M B ) ) $=
      cU cpv cfv cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cM co cA
      cC cM co cM co cC cB cM co wceq cU cnv wcel cA cB cC cM cU cpv cfv cX cU
      cU cpv cfv cX nvmf.1 cU cpv cfv eqid bafval cU cU cpv cfv cM cU cpv cfv
      eqid nvmf.3 vsfval ablnnncan1 cU cU cpv cfv cU cpv cfv eqid nvabl sylan
      $.
      $( [2-Apr-2008] $) $( [7-Mar-2008] $)

    $( Vector space analog of ~ nnncan2 . $)
    nvnnncan2 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A M C ) M ( B M C ) ) = ( A M B ) ) $=
      cU cpv cfv cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cC cM co cB
      cC cM co cM co cA cB cM co wceq cU cnv wcel cA cB cC cM cU cpv cfv cX cU
      cU cpv cfv cX nvmf.1 cU cpv cfv eqid bafval cU cU cpv cfv cM cU cpv cfv
      eqid nvmf.3 vsfval grpnnncan2 cU cU cpv cfv cU cpv cfv eqid nvgrp sylan
      $.
      $( [15-Mar-2008] $) $( [15-Feb-2008] $)
  $}

  ${
    nvmdi.1 $e |- X = ( BaseSet ` U ) $.
    nvmdi.3 $e |- M = ( -v ` U ) $.
    nvmdi.4 $e |- S = ( .s ` U ) $.
    $( Distributive law for scalar product over subtraction. $)
    nvmdi $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
       ( A S ( B M C ) ) = ( ( A S B ) M ( A S C ) ) ) $=
      cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a wa cA cB c1 cneg cC cS
      co cU cpv cfv co cS co cA cB cS co c1 cneg cA cC cS co cS co cU cpv cfv
      co cA cB cC cM co cS co cA cB cS co cA cC cS co cM co cU cnv wcel cA cc
      wcel cB cX wcel cC cX wcel w3a wa cA cB c1 cneg cC cS co cU cpv cfv co cS
      co cA cB cS co cA c1 cneg cC cS co cS co cU cpv cfv co cA cB cS co c1
      cneg cA cC cS co cS co cU cpv cfv co cU cnv wcel cA cc wcel cB cX wcel cC
      cX wcel w3a cA cc wcel cB cX wcel c1 cneg cC cS co cX wcel w3a cA cB c1
      cneg cC cS co cU cpv cfv co cS co cA cB cS co cA c1 cneg cC cS co cS co
      cU cpv cfv co wceq cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a wa cA
      cc wcel cB cX wcel c1 cneg cC cS co cX wcel cU cnv wcel cA cc wcel cB cX
      wcel cC cX wcel 3simpr1 cU cnv wcel cA cc wcel cB cX wcel cC cX wcel
      3simpr2 cU cnv wcel cA cc wcel cC cX wcel c1 cneg cC cS co cX wcel cB cX
      wcel cU cnv wcel c1 cneg cc wcel cC cX wcel c1 cneg cC cS co cX wcel c1
      ax1cn negcli c1 cneg cC cS cU cX nvmdi.1 nvmdi.4 nvscl mp3an2 3ad2antr3
      3jca cA cB c1 cneg cC cS co cS cU cU cpv cfv cX nvmdi.1 cU cpv cfv eqid
      nvmdi.4 nvdi syldan cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a wa
      cA c1 cneg cC cS co cS co c1 cneg cA cC cS co cS co cA cB cS co cU cpv
      cfv cU cnv wcel cA cc wcel cC cX wcel cA c1 cneg cC cS co cS co c1 cneg
      cA cC cS co cS co wceq cB cX wcel cU cnv wcel cA cc wcel c1 cneg cc wcel
      cC cX wcel cA c1 cneg cC cS co cS co c1 cneg cA cC cS co cS co wceq c1
      ax1cn negcli cA c1 cneg cC cS cU cX nvmdi.1 nvmdi.4 nvscom mp3anr2
      3adantr2 opreq2d eqtrd cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a
      wa cB cC cM co cB c1 cneg cC cS co cU cpv cfv co cA cS cU cnv wcel cB cX
      wcel cC cX wcel cB cC cM co cB c1 cneg cC cS co cU cpv cfv co wceq cA cc
      wcel cB cC cS cU cU cpv cfv cM cX nvmdi.1 cU cpv cfv eqid nvmdi.4 nvmdi.3
      nvmval 3adant3r1 opreq2d cU cnv wcel cA cB cS co cX wcel cA cC cS co cX
      wcel cA cB cS co cA cC cS co cM co cA cB cS co c1 cneg cA cC cS co cS co
      cU cpv cfv co wceq cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a wa cA
      cB cS co cA cC cS co cS cU cU cpv cfv cM cX nvmdi.1 cU cpv cfv eqid
      nvmdi.4 nvmdi.3 nvmval cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a
      pm3.26 cU cnv wcel cA cc wcel cB cX wcel cA cB cS co cX wcel cC cX wcel
      cA cB cS cU cX nvmdi.1 nvmdi.4 nvscl 3adant3r3 cU cnv wcel cA cc wcel cC
      cX wcel cA cC cS co cX wcel cB cX wcel cA cC cS cU cX nvmdi.1 nvmdi.4
      nvscl 3adant3r2 syl3anc 3eqtr4d $.
      $( [7-Mar-2008] $) $( [14-Feb-2008] $)
  $}

  ${
    nvnegneg.1 $e |- X = ( BaseSet ` U ) $.
    nvnegneg.4 $e |- S = ( .s ` U ) $.
    $( Double negative of a vector. $)
    nvnegneg $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                  ( -u 1 S ( -u 1 S A ) ) = A ) $=
      cU cnv wcel cA cX wcel wa c1 cneg c1 cneg cA cS co cS co c1 cneg cA cS co
      cU cpv cfv cgn cfv cfv cA cU cpv cfv cgn cfv cfv cU cpv cfv cgn cfv cfv
      cA cU cnv wcel cA cX wcel c1 cneg cA cS co cX wcel c1 cneg c1 cneg cA cS
      co cS co c1 cneg cA cS co cU cpv cfv cgn cfv cfv wceq cU cnv wcel c1 cneg
      cc wcel cA cX wcel c1 cneg cA cS co cX wcel c1 ax1cn negcli c1 cneg cA cS
      cU cX nvnegneg.1 nvnegneg.4 nvscl mp3an2 c1 cneg cA cS co cS cU cU cpv
      cfv cU cpv cfv cgn cfv cX nvnegneg.1 cU cpv cfv eqid nvnegneg.4 cU cpv
      cfv cgn cfv eqid nvinv syldan cU cnv wcel cA cX wcel wa c1 cneg cA cS co
      cA cU cpv cfv cgn cfv cfv cU cpv cfv cgn cfv cA cS cU cU cpv cfv cU cpv
      cfv cgn cfv cX nvnegneg.1 cU cpv cfv eqid nvnegneg.4 cU cpv cfv cgn cfv
      eqid nvinv fveq2d cU cpv cfv cgr wcel cA cX wcel cA cU cpv cfv cgn cfv
      cfv cU cpv cfv cgn cfv cfv cA wceq cU cnv wcel cA cU cpv cfv cU cpv cfv
      cgn cfv cX cU cU cpv cfv cX nvnegneg.1 cU cpv cfv eqid bafval cU cpv cfv
      cgn cfv eqid grp2inv cU cU cpv cfv cU cpv cfv eqid nvgrp sylan 3eqtrd $.
      $( [7-Dec-2007] $) $( [4-Dec-2007] $)
  $}

  ${
    nvmul0or.1 $e |- X = ( BaseSet ` U ) $.
    nvmul0or.4 $e |- S = ( .s ` U ) $.
    nvmul0or.6 $e |- Z = ( 0v ` U ) $.
    $( If a scalar product is zero, one of its factors must be zero. $)
    nvmul0or $p |- ( ( U e. NrmCVec /\ A e. CC /\ B e. X ) ->
                    ( ( A S B ) = Z <-> ( A = 0 \/ B = Z ) ) ) $=
      cU cnv wcel cA cc wcel cB cX wcel w3a cA cB cS co cZ wceq cA cc0 wceq cB
      cZ wceq wo cU cnv wcel cA cc wcel cB cX wcel w3a cA cB cS co cZ wceq cA
      cc0 wceq cB cZ wceq wo cU cnv wcel cA cc wcel cB cX wcel w3a cA cB cS co
      cZ wceq wa cA cc0 wceq cB cZ wceq cU cnv wcel cA cc wcel cB cX wcel w3a
      cA cB cS co cZ wceq wa cA cc0 wne cB cZ wceq cA cc0 wceq wn cU cnv wcel
      cA cc wcel cB cX wcel w3a cA cB cS co cZ wceq wa cA cc0 wne cB cZ wceq cU
      cnv wcel cA cc wcel cB cX wcel w3a cA cB cS co cZ wceq wa cA cc0 wne wa
      c1 cA cdiv co cA cB cS co cS co c1 cA cdiv co cZ cS co cB cZ cA cB cS co
      cZ wceq c1 cA cdiv co cA cB cS co cS co c1 cA cdiv co cZ cS co wceq cU
      cnv wcel cA cc wcel cB cX wcel w3a cA cc0 wne cA cB cS co cZ c1 cA cdiv
      co cS opreq2 ad2antlr cU cnv wcel cA cc wcel cB cX wcel w3a cA cc0 wne c1
      cA cdiv co cA cB cS co cS co cB wceq cA cB cS co cZ wceq cU cnv wcel cA
      cc wcel cB cX wcel w3a cA cc0 wne wa c1 cA cdiv co cA cmul co cB cS co c1
      cB cS co c1 cA cdiv co cA cB cS co cS co cB cA cc wcel cU cnv wcel cA cc0
      wne c1 cA cdiv co cA cmul co cB cS co c1 cB cS co wceq cB cX wcel cA cc
      wcel cA cc0 wne wa c1 cA cdiv co cA cmul co c1 cB cS cA recid2 opreq1d
      3ad2antl2 cU cnv wcel c1 cA cdiv co cc wcel cA cc wcel cB cX wcel w3a c1
      cA cdiv co cA cmul co cB cS co c1 cA cdiv co cA cB cS co cS co wceq cU
      cnv wcel cA cc wcel cB cX wcel w3a cA cc0 wne wa c1 cA cdiv co cA cB cS
      cU cX nvmul0or.1 nvmul0or.4 nvsass cU cnv wcel cA cc wcel cB cX wcel cA
      cc0 wne 3simpl1 cU cnv wcel cA cc wcel cB cX wcel w3a cA cc0 wne wa c1 cA
      cdiv co cc wcel cA cc wcel cB cX wcel cA cc wcel cU cnv wcel cA cc0 wne
      c1 cA cdiv co cc wcel cB cX wcel cA reccl 3ad2antl2 cU cnv wcel cA cc
      wcel cB cX wcel cA cc0 wne 3simpl2 cU cnv wcel cA cc wcel cB cX wcel cA
      cc0 wne 3simpl3 3jca sylanc cU cnv wcel cA cc wcel cB cX wcel w3a c1 cB
      cS co cB wceq cA cc0 wne cU cnv wcel cB cX wcel c1 cB cS co cB wceq cA cc
      wcel cB cS cU cX nvmul0or.1 nvmul0or.4 nvsid 3adant2 adantr 3eqtr3d
      adantlr cU cnv wcel cA cc wcel cB cX wcel w3a cA cc0 wne c1 cA cdiv co cZ
      cS co cZ wceq cA cB cS co cZ wceq cU cnv wcel cA cc wcel cA cc0 wne c1 cA
      cdiv co cZ cS co cZ wceq cB cX wcel cU cnv wcel cA cc wcel cA cc0 wne c1
      cA cdiv co cZ cS co cZ wceq cU cnv wcel c1 cA cdiv co cc wcel c1 cA cdiv
      co cZ cS co cZ wceq cA cc wcel cA cc0 wne wa c1 cA cdiv co cS cU cZ
      nvmul0or.4 nvmul0or.6 nvsz cA reccl sylan2 anassrs 3adantl3 adantlr
      3eqtr3d ex cA cc0 df-ne syl5ibr orrd ex cU cnv wcel cA cc wcel cB cX wcel
      w3a cA cc0 wceq cA cB cS co cZ wceq cB cZ wceq cU cnv wcel cB cX wcel cA
      cc0 wceq cA cB cS co cZ wceq wi cA cc wcel cA cc0 wceq cA cB cS co cZ
      wceq cc0 cB cS co cZ wceq cU cnv wcel cB cX wcel wa cA cc0 wceq cA cB cS
      co cc0 cB cS co cZ cA cc0 cB cS opreq1 eqeq1d cB cS cU cX cZ nvmul0or.1
      nvmul0or.4 nvmul0or.6 nv0 syl5cbir 3adant2 cU cnv wcel cA cc wcel cB cZ
      wceq cA cB cS co cZ wceq wi cB cX wcel cB cZ wceq cA cB cS co cZ wceq cA
      cZ cS co cZ wceq cU cnv wcel cA cc wcel wa cB cZ wceq cA cB cS co cA cZ
      cS co cZ cB cZ cA cS opreq2 eqeq1d cA cS cU cZ nvmul0or.4 nvmul0or.6 nvsz
      syl5cbir 3adant3 jaod impbid $.
      $( [17-Dec-2007] $) $( [6-Dec-2007] $)
  $}

  ${
    nvrinv.1 $e |- X = ( BaseSet ` U ) $.
    nvrinv.2 $e |- G = ( +v ` U ) $.
    nvrinv.4 $e |- S = ( .s ` U ) $.
    nvrinv.6 $e |- Z = ( 0v ` U ) $.
    $( A vector minus itself. $)
    nvrinv $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A G ( -u 1 S A ) ) = Z ) $=
      cU cnv wcel cA cX wcel wa cA c1 cneg cA cS co cG co cA cA cG cgn cfv cfv
      cG co cZ cU cnv wcel cA cX wcel wa c1 cneg cA cS co cA cG cgn cfv cfv cA
      cG cA cS cU cG cG cgn cfv cX nvrinv.1 nvrinv.2 nvrinv.4 cG cgn cfv eqid
      nvinv opreq2d cG cgr wcel cA cX wcel cA cA cG cgn cfv cfv cG co cZ wceq
      cU cnv wcel cA cZ cG cG cgn cfv cX cU cG cX nvrinv.1 nvrinv.2 bafval cU
      cG cZ nvrinv.2 nvrinv.6 0vfval cG cgn cfv eqid grprinv cU cG nvrinv.2
      nvgrp sylan eqtrd $.
      $( [7-Dec-2007] $) $( [4-Dec-2007] $)

    $( Minus a vector plus itself. $)
    nvlinv $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( ( -u 1 S A ) G A ) = Z ) $=
      cU cnv wcel cA cX wcel wa c1 cneg cA cS co cA cG co cA cG cgn cfv cfv cA
      cG co cZ cU cnv wcel cA cX wcel wa c1 cneg cA cS co cA cG cgn cfv cfv cA
      cG cA cS cU cG cG cgn cfv cX nvrinv.1 nvrinv.2 nvrinv.4 cG cgn cfv eqid
      nvinv opreq1d cG cgr wcel cA cX wcel cA cG cgn cfv cfv cA cG co cZ wceq
      cU cnv wcel cA cZ cG cG cgn cfv cX cU cG cX nvrinv.1 nvrinv.2 bafval cU
      cG cZ nvrinv.2 nvrinv.6 0vfval cG cgn cfv eqid grplinv cU cG nvrinv.2
      nvgrp sylan eqtrd $.
      $( [9-Dec-2007] $) $( [4-Dec-2007] $)
  $}

  ${
    nvsubadd.1 $e |- X = ( BaseSet ` U ) $.
    nvsubadd.2 $e |- G = ( +v ` U ) $.
    nvsubadd.3 $e |- M = ( -v ` U ) $.
    $( Relationship between vector subtraction and addition. $)
    nvsubadd $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                ( ( A M B ) = C <-> ( B G C ) = A ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cM co cC wceq
      cA c1 cneg cB cU cns cfv co cG co cC wceq cB cC cG co cA wceq cU cnv wcel
      cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cM co cA c1 cneg cB cU cns
      cfv co cG co cC cU cnv wcel cA cX wcel cB cX wcel cA cB cM co cA c1 cneg
      cB cU cns cfv co cG co wceq cC cX wcel cA cB cU cns cfv cU cG cM cX
      nvsubadd.1 nvsubadd.2 cU cns cfv eqid nvsubadd.3 nvmval 3adant3r3 eqeq1d
      cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA c1 cneg cB cU cns
      cfv co cG co cC wceq cA cB cC cG co wceq cB cC cG co cA wceq cU cnv wcel
      cA cX wcel cB cX wcel cC cX wcel w3a wa cB cA c1 cneg cB cU cns cfv co cG
      co cG co cB cC cG co wceq cA c1 cneg cB cU cns cfv co cG co cC wceq cA cB
      cC cG co wceq cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a cA c1 cneg
      cB cU cns cfv co cG co cX wcel cC cX wcel cB cX wcel w3a cB cA c1 cneg cB
      cU cns cfv co cG co cG co cB cC cG co wceq cA c1 cneg cB cU cns cfv co cG
      co cC wceq wb cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA c1
      cneg cB cU cns cfv co cG co cX wcel cC cX wcel cB cX wcel cU cnv wcel cA
      cX wcel cB cX wcel cA c1 cneg cB cU cns cfv co cG co cX wcel cC cX wcel
      cU cnv wcel cA cX wcel c1 cneg cB cU cns cfv co cX wcel cA c1 cneg cB cU
      cns cfv co cG co cX wcel cB cX wcel cA c1 cneg cB cU cns cfv co cU cG cX
      nvsubadd.1 nvsubadd.2 nvgcl cU cnv wcel cB cX wcel c1 cneg cB cU cns cfv
      co cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB
      cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg cB cU cns cfv cU cX
      nvsubadd.1 cU cns cfv eqid nvscl mp3an2 3adant2 syld3an3 3adant3r3 cU cnv
      wcel cA cX wcel cB cX wcel cC cX wcel 3simpr3 cU cnv wcel cA cX wcel cB
      cX wcel cC cX wcel 3simpr2 3jca cA c1 cneg cB cU cns cfv co cG co cC cB
      cU cG cX nvsubadd.1 nvsubadd.2 nvlcan syldan cU cnv wcel cA cX wcel cB cX
      wcel cC cX wcel w3a wa cB cA c1 cneg cB cU cns cfv co cG co cG co cA cB
      cC cG co cU cnv wcel cA cX wcel cB cX wcel cB cA c1 cneg cB cU cns cfv co
      cG co cG co cA wceq cC cX wcel cU cnv wcel cA cX wcel cB cX wcel wa wa cB
      cA c1 cneg cB cU cns cfv co cG co cG co cA cB c1 cneg cB cU cns cfv co cG
      co cG co cA cU cn0v cfv cG co cA cU cnv wcel cA cX wcel cB cX wcel wa cB
      cX wcel cA cX wcel c1 cneg cB cU cns cfv co cX wcel w3a cB cA c1 cneg cB
      cU cns cfv co cG co cG co cA cB c1 cneg cB cU cns cfv co cG co cG co wceq
      cU cnv wcel cA cX wcel cB cX wcel wa wa cB cX wcel cA cX wcel c1 cneg cB
      cU cns cfv co cX wcel cU cnv wcel cA cX wcel cB cX wcel simprr cU cnv
      wcel cA cX wcel cB cX wcel simprl cU cnv wcel cB cX wcel c1 cneg cB cU
      cns cfv co cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1
      cneg cB cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg cB cU cns cfv cU cX
      nvsubadd.1 cU cns cfv eqid nvscl mp3an2 adantrl 3jca cB cA c1 cneg cB cU
      cns cfv co cU cG cX nvsubadd.1 nvsubadd.2 nvadd12 syldan cU cnv wcel cA
      cX wcel cB cX wcel wa wa cB c1 cneg cB cU cns cfv co cG co cU cn0v cfv cA
      cG cU cnv wcel cB cX wcel cB c1 cneg cB cU cns cfv co cG co cU cn0v cfv
      wceq cA cX wcel cB cU cns cfv cU cG cX cU cn0v cfv nvsubadd.1 nvsubadd.2
      cU cns cfv eqid cU cn0v cfv eqid nvrinv adantrl opreq2d cU cnv wcel cA cX
      wcel cA cU cn0v cfv cG co cA wceq cB cX wcel cA cU cG cX cU cn0v cfv
      nvsubadd.1 nvsubadd.2 cU cn0v cfv eqid nv0rid adantrr 3eqtrd 3adantr3
      eqeq1d bitr3d cA cB cC cG co eqcom syl6bb bitrd $.
      $( [17-Jan-2008] $) $( [14-Dec-2007] $)

    $( Cancellation law for vector subtraction. $)
    nvpncan2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                 ( ( A G B ) M A ) = B ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cA cM co cA cB cG co c1
      cneg cA cU cns cfv co cG co cA c1 cneg cA cU cns cfv co cG co cB cG co cB
      cU cnv wcel cA cB cG co cX wcel cA cX wcel cA cB cG co cA cM co cA cB cG
      co c1 cneg cA cU cns cfv co cG co wceq cU cnv wcel cA cX wcel cB cX wcel
      w3a cA cB cG co cA cU cns cfv cU cG cM cX nvsubadd.1 nvsubadd.2 cU cns
      cfv eqid nvsubadd.3 nvmval cU cnv wcel cA cX wcel cB cX wcel 3simp1 cA cB
      cU cG cX nvsubadd.1 nvsubadd.2 nvgcl cU cnv wcel cA cX wcel cB cX wcel
      3simp2 syl3anc cU cnv wcel cA cX wcel cB cX wcel c1 cneg cA cU cns cfv co
      cX wcel w3a cA cB cG co c1 cneg cA cU cns cfv co cG co cA c1 cneg cA cU
      cns cfv co cG co cB cG co wceq cU cnv wcel cA cX wcel cB cX wcel w3a cA
      cB c1 cneg cA cU cns cfv co cU cG cX nvsubadd.1 nvsubadd.2 nvadd23 cU cnv
      wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel cB cX wcel w3a
      cA cX wcel cB cX wcel c1 cneg cA cU cns cfv co cX wcel cU cnv wcel cA cX
      wcel cB cX wcel 3simp2 cU cnv wcel cA cX wcel cB cX wcel 3simp3 cU cnv
      wcel cA cX wcel c1 cneg cA cU cns cfv co cX wcel cB cX wcel cU cnv wcel
      c1 cneg cc wcel cA cX wcel c1 cneg cA cU cns cfv co cX wcel c1 ax1cn
      negcli c1 cneg cA cU cns cfv cU cX nvsubadd.1 cU cns cfv eqid nvscl
      mp3an2 3adant3 3jca sylanc cU cnv wcel cA cX wcel cB cX wcel w3a cA c1
      cneg cA cU cns cfv co cG co cB cG co cU cn0v cfv cB cG co cB cU cnv wcel
      cA cX wcel cB cX wcel w3a cA c1 cneg cA cU cns cfv co cG co cU cn0v cfv
      cB cG cU cnv wcel cA cX wcel cA c1 cneg cA cU cns cfv co cG co cU cn0v
      cfv wceq cB cX wcel cA cU cns cfv cU cG cX cU cn0v cfv nvsubadd.1
      nvsubadd.2 cU cns cfv eqid cU cn0v cfv eqid nvrinv 3adant3 opreq1d cU cnv
      wcel cB cX wcel cU cn0v cfv cB cG co cB wceq cA cX wcel cB cU cG cX cU
      cn0v cfv nvsubadd.1 nvsubadd.2 cU cn0v cfv eqid nv0lid 3adant2 eqtrd
      3eqtrd $.
      $( [6-Jan-2008] $) $( [27-Dec-2007] $)

    $( Cancellation law for vector subtraction. $)
    nvpncan $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                 ( ( A G B ) M B ) = A ) $=
      cU cnv wcel cB cX wcel cA cX wcel cA cB cG co cB cM co cA wceq cU cnv
      wcel cB cX wcel cA cX wcel w3a cB cA cG co cB cM co cA cB cG co cB cM co
      cA cU cnv wcel cB cX wcel cA cX wcel w3a cB cA cG co cA cB cG co cB cM cB
      cA cU cG cX nvsubadd.1 nvsubadd.2 nvcom opreq1d cB cA cU cG cM cX
      nvsubadd.1 nvsubadd.2 nvsubadd.3 nvpncan2 eqtr3d 3com23 $.
      $( [31-Jan-2008] $) $( [24-Jan-2008] $)

    $( Associative-type law for vector addition and subtraction. $)
    nvaddsubass $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
              ( ( A G B ) M C ) = ( A G ( B M C ) ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cM co cA
      cB cC cM co cG co wceq cU cnv wcel cA cB cC cM cG cX cU cG cX nvsubadd.1
      nvsubadd.2 bafval cU cG cM nvsubadd.2 nvsubadd.3 vsfval grpmuldivass cU
      cG nvsubadd.2 nvgrp sylan $.
      $( [30-Jan-2008] $) $( [24-Jan-2008] $)

    $( Commutative/associative law for vector addition and subtraction. $)
    nvaddsub $p |-  ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A G B ) M C ) = ( ( A M C ) G B ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cM co cA
      cC cM co cB cG co wceq cU cnv wcel cA cB cC cM cG cX cU cG cX nvsubadd.1
      nvsubadd.2 bafval cU cG cM nvsubadd.2 nvsubadd.3 vsfval ablmuldiv cU cG
      nvsubadd.2 nvabl sylan $.
      $( [1-Feb-2008] $) $( [24-Jan-2008] $)

    $( Cancellation law for a normed complex vector space. $)
    nvnpcan $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
         ( ( A M B ) G B ) = A ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cB cM co cA cB cM co cB
      cG co cA cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cB cM co cA cB cM
      co cB cG co wceq cU cnv wcel cA cX wcel cB cX wcel wa cA cX wcel cB cX
      wcel cB cX wcel w3a cA cB cG co cB cM co cA cB cM co cB cG co wceq cU cnv
      wcel cA cX wcel cB cX wcel wa wa cA cX wcel cB cX wcel cB cX wcel cU cnv
      wcel cA cX wcel cB cX wcel simprl cU cnv wcel cA cX wcel cB cX wcel
      simprr cU cnv wcel cA cX wcel cB cX wcel simprr 3jca cA cB cB cU cG cM cX
      nvsubadd.1 nvsubadd.2 nvsubadd.3 nvaddsub syldan 3impb cA cB cU cG cM cX
      nvsubadd.1 nvsubadd.2 nvsubadd.3 nvpncan eqtr3d $.
      $( [3-Feb-2008] $) $( [24-Jan-2008] $)

    $( Rearrangement of 4 terms in a mixed vector addition and subtraction. $)
    nvaddsub4 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X ) /\ ( C e. X /\
       D e. X ) ) -> ( ( A G B ) M ( C G D ) ) = ( ( A M C ) G ( B M D ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa w3a cA cB
      cG co c1 cneg cC cD cG co cU cns cfv co cG co cA c1 cneg cC cU cns cfv co
      cG co cB c1 cneg cD cU cns cfv co cG co cG co cA cB cG co cC cD cG co cM
      co cA cC cM co cB cD cM co cG co cU cnv wcel cA cX wcel cB cX wcel wa cC
      cX wcel cD cX wcel wa w3a cA cB cG co c1 cneg cC cD cG co cU cns cfv co
      cG co cA cB cG co c1 cneg cC cU cns cfv co c1 cneg cD cU cns cfv co cG co
      cG co cA c1 cneg cC cU cns cfv co cG co cB c1 cneg cD cU cns cfv co cG co
      cG co cU cnv wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa w3a
      c1 cneg cC cD cG co cU cns cfv co c1 cneg cC cU cns cfv co c1 cneg cD cU
      cns cfv co cG co cA cB cG co cG cU cnv wcel cC cX wcel cD cX wcel wa c1
      cneg cC cD cG co cU cns cfv co c1 cneg cC cU cns cfv co c1 cneg cD cU cns
      cfv co cG co wceq cA cX wcel cB cX wcel wa cU cnv wcel c1 cneg cc wcel cC
      cX wcel cD cX wcel c1 cneg cC cD cG co cU cns cfv co c1 cneg cC cU cns
      cfv co c1 cneg cD cU cns cfv co cG co wceq c1 ax1cn negcli c1 cneg cC cD
      cU cns cfv cU cG cX nvsubadd.1 nvsubadd.2 cU cns cfv eqid nvdi mp3anr1
      3adant2 opreq2d cU cnv wcel cA cX wcel cB cX wcel wa c1 cneg cC cU cns
      cfv co cX wcel c1 cneg cD cU cns cfv co cX wcel wa cA cB cG co c1 cneg cC
      cU cns cfv co c1 cneg cD cU cns cfv co cG co cG co cA c1 cneg cC cU cns
      cfv co cG co cB c1 cneg cD cU cns cfv co cG co cG co wceq cC cX wcel cD
      cX wcel wa cA cB c1 cneg cC cU cns cfv co c1 cneg cD cU cns cfv co cU cG
      cX nvsubadd.1 nvsubadd.2 nvadd4 cU cnv wcel cC cX wcel cD cX wcel wa c1
      cneg cC cU cns cfv co cX wcel c1 cneg cD cU cns cfv co cX wcel wa cA cX
      wcel cB cX wcel wa cU cnv wcel cC cX wcel cD cX wcel c1 cneg cC cU cns
      cfv co cX wcel c1 cneg cD cU cns cfv co cX wcel wa cU cnv wcel cC cX wcel
      wa c1 cneg cC cU cns cfv co cX wcel cU cnv wcel cD cX wcel wa c1 cneg cD
      cU cns cfv co cX wcel cU cnv wcel c1 cneg cc wcel cC cX wcel c1 cneg cC
      cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg cC cU cns cfv cU cX
      nvsubadd.1 cU cns cfv eqid nvscl mp3an2 cU cnv wcel c1 cneg cc wcel cD cX
      wcel c1 cneg cD cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg cD cU cns
      cfv cU cX nvsubadd.1 cU cns cfv eqid nvscl mp3an2 anim12i anandis 3adant2
      syld3an3 eqtrd cU cnv wcel cA cB cG co cX wcel cC cD cG co cX wcel cA cB
      cG co cC cD cG co cM co cA cB cG co c1 cneg cC cD cG co cU cns cfv co cG
      co wceq cU cnv wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa w3a
      cA cB cG co cC cD cG co cU cns cfv cU cG cM cX nvsubadd.1 nvsubadd.2 cU
      cns cfv eqid nvsubadd.3 nvmval cU cnv wcel cA cX wcel cB cX wcel wa cC cX
      wcel cD cX wcel wa 3simp1 cU cnv wcel cA cX wcel cB cX wcel wa cA cB cG
      co cX wcel cC cX wcel cD cX wcel wa cU cnv wcel cA cX wcel cB cX wcel cA
      cB cG co cX wcel cA cB cU cG cX nvsubadd.1 nvsubadd.2 nvgcl 3expb 3adant3
      cU cnv wcel cC cX wcel cD cX wcel wa cC cD cG co cX wcel cA cX wcel cB cX
      wcel wa cU cnv wcel cC cX wcel cD cX wcel cC cD cG co cX wcel cC cD cU cG
      cX nvsubadd.1 nvsubadd.2 nvgcl 3expb 3adant2 syl3anc cU cnv wcel cA cX
      wcel cB cX wcel wa cC cX wcel cD cX wcel wa w3a cA cC cM co cA c1 cneg cC
      cU cns cfv co cG co cB cD cM co cB c1 cneg cD cU cns cfv co cG co cG cU
      cnv wcel cA cX wcel cC cX wcel cD cX wcel wa cA cC cM co cA c1 cneg cC cU
      cns cfv co cG co wceq cB cX wcel cU cnv wcel cA cX wcel cC cX wcel cA cC
      cM co cA c1 cneg cC cU cns cfv co cG co wceq cD cX wcel cA cC cU cns cfv
      cU cG cM cX nvsubadd.1 nvsubadd.2 cU cns cfv eqid nvsubadd.3 nvmval
      3adant3r 3adant2r cU cnv wcel cB cX wcel cC cX wcel cD cX wcel wa cB cD
      cM co cB c1 cneg cD cU cns cfv co cG co wceq cA cX wcel cU cnv wcel cB cX
      wcel cD cX wcel cB cD cM co cB c1 cneg cD cU cns cfv co cG co wceq cC cX
      wcel cB cD cU cns cfv cU cG cM cX nvsubadd.1 nvsubadd.2 cU cns cfv eqid
      nvsubadd.3 nvmval 3adant3l 3adant2l opreq12d 3eqtr4d $.
      $( [12-Mar-2008] $) $( [8-Feb-2008] $)
  $}

  ${
    nvsubsub23.1 $e |- X = ( BaseSet ` U ) $.
    nvsubsub23.3 $e |- M = ( -v ` U ) $.
    $( Swap subtrahend and result of vector subtraction. $)
    nvsubsub23 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                ( ( A M B ) = C <-> ( A M C ) = B ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cB cC cU cpv cfv co
      cA wceq cC cB cU cpv cfv co cA wceq cA cB cM co cC wceq cA cC cM co cB
      wceq cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cB cC cU cpv cfv
      co cC cB cU cpv cfv co cA cU cnv wcel cB cX wcel cC cX wcel cB cC cU cpv
      cfv co cC cB cU cpv cfv co wceq cA cX wcel cB cC cU cU cpv cfv cX
      nvsubsub23.1 cU cpv cfv eqid nvcom 3adant3r1 eqeq1d cA cB cC cU cU cpv
      cfv cM cX nvsubsub23.1 cU cpv cfv eqid nvsubsub23.3 nvsubadd cU cnv wcel
      cA cX wcel cC cX wcel cB cX wcel w3a cA cC cM co cB wceq cC cB cU cpv cfv
      co cA wceq wb cA cX wcel cB cX wcel cC cX wcel w3a cA cC cB cU cU cpv cfv
      cM cX nvsubsub23.1 cU cpv cfv eqid nvsubsub23.3 nvsubadd cA cX wcel cB cX
      wcel cC cX wcel 3ancomb sylan2b 3bitr4d $.
      $( [4-Apr-2008] $) $( [14-Dec-2007] $)

    $( Cancellation law for a normed complex vector space. $)
    nvnncan $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
         ( A M ( A M B ) ) = B ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cA cB cM co cM co cA c1 cneg cA
      cB cM co cU cns cfv co cU cpv cfv co cU cn0v cfv cB cU cpv cfv co cB cU
      cnv wcel cA cX wcel cA cB cM co cX wcel cA cA cB cM co cM co cA c1 cneg
      cA cB cM co cU cns cfv co cU cpv cfv co wceq cB cX wcel cA cA cB cM co cU
      cns cfv cU cU cpv cfv cM cX nvsubsub23.1 cU cpv cfv eqid cU cns cfv eqid
      nvsubsub23.3 nvmval cA cB cU cM cX nvsubsub23.1 nvsubsub23.3 nvmcl
      syld3an3 cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cA cB cM co cU
      cns cfv co cU cpv cfv co cA c1 cneg cA cU cns cfv co cB cU cpv cfv co cU
      cpv cfv co cA c1 cneg cA cU cns cfv co cU cpv cfv co cB cU cpv cfv co cU
      cn0v cfv cB cU cpv cfv co cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg
      cA cB cM co cU cns cfv co c1 cneg cA cU cns cfv co cB cU cpv cfv co cA cU
      cpv cfv cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cA c1 cneg cB cU
      cns cfv co cU cpv cfv co cU cns cfv co c1 cneg cA cU cns cfv co c1 cneg
      c1 cneg cB cU cns cfv co cU cns cfv co cU cpv cfv co c1 cneg cA cB cM co
      cU cns cfv co c1 cneg cA cU cns cfv co cB cU cpv cfv co cU cnv wcel c1
      cneg cc wcel cA cX wcel c1 cneg cB cU cns cfv co cX wcel w3a c1 cneg cA
      c1 cneg cB cU cns cfv co cU cpv cfv co cU cns cfv co c1 cneg cA cU cns
      cfv co c1 cneg c1 cneg cB cU cns cfv co cU cns cfv co cU cpv cfv co wceq
      cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cA c1 cneg cB cU cns cfv co
      cU cns cfv cU cU cpv cfv cX nvsubsub23.1 cU cpv cfv eqid cU cns cfv eqid
      nvdi cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel cB
      cX wcel w3a c1 cneg cc wcel cA cX wcel c1 cneg cB cU cns cfv co cX wcel
      c1 cneg cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a c1 ax1cn negcli a1i
      cU cnv wcel cA cX wcel cB cX wcel 3simp2 cU cnv wcel cB cX wcel c1 cneg
      cB cU cns cfv co cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX
      wcel c1 cneg cB cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg cB cU cns
      cfv cU cX nvsubsub23.1 cU cns cfv eqid nvscl mp3an2 3adant2 3jca sylanc
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cM co cA c1 cneg cB cU cns
      cfv co cU cpv cfv co c1 cneg cU cns cfv cA cB cU cns cfv cU cU cpv cfv cM
      cX nvsubsub23.1 cU cpv cfv eqid cU cns cfv eqid nvsubsub23.3 nvmval
      opreq2d cU cnv wcel cA cX wcel cB cX wcel w3a cB c1 cneg c1 cneg cB cU
      cns cfv co cU cns cfv co c1 cneg cA cU cns cfv co cU cpv cfv cU cnv wcel
      cB cX wcel cB c1 cneg c1 cneg cB cU cns cfv co cU cns cfv co wceq cA cX
      wcel cU cnv wcel cB cX wcel wa c1 cneg c1 cneg cmul co cB cU cns cfv co
      cB c1 cneg c1 cneg cB cU cns cfv co cU cns cfv co cU cnv wcel cB cX wcel
      wa c1 cB cU cns cfv co cB c1 cneg c1 cneg cmul co cB cU cns cfv co cB cU
      cns cfv cU cX nvsubsub23.1 cU cns cfv eqid nvsid c1 cneg c1 cneg cmul co
      c1 cB cU cns cfv c1 cneg c1 cneg cmul co c1 c1 cmul co c1 c1 c1 ax1cn
      ax1cn mul2negi c1 ax1cn mulid1i eqtri opreq1i syl5eq cU cnv wcel c1 cneg
      cc wcel cB cX wcel c1 cneg c1 cneg cmul co cB cU cns cfv co c1 cneg c1
      cneg cB cU cns cfv co cU cns cfv co wceq c1 ax1cn negcli cU cnv wcel c1
      cneg cc wcel c1 cneg cc wcel cB cX wcel c1 cneg c1 cneg cmul co cB cU cns
      cfv co c1 cneg c1 cneg cB cU cns cfv co cU cns cfv co wceq c1 ax1cn
      negcli c1 cneg c1 cneg cB cU cns cfv cU cX nvsubsub23.1 cU cns cfv eqid
      nvsass mp3anr1 mpanr1 eqtr3d 3adant2 opreq2d 3eqtr4d opreq2d cU cnv wcel
      cA cX wcel c1 cneg cA cU cns cfv co cX wcel cB cX wcel w3a cA c1 cneg cA
      cU cns cfv co cU cpv cfv co cB cU cpv cfv co cA c1 cneg cA cU cns cfv co
      cB cU cpv cfv co cU cpv cfv co wceq cU cnv wcel cA cX wcel cB cX wcel w3a
      cA c1 cneg cA cU cns cfv co cB cU cU cpv cfv cX nvsubsub23.1 cU cpv cfv
      eqid nvass cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX
      wcel cB cX wcel w3a cA cX wcel c1 cneg cA cU cns cfv co cX wcel cB cX
      wcel cU cnv wcel cA cX wcel cB cX wcel 3simp2 cU cnv wcel cA cX wcel c1
      cneg cA cU cns cfv co cX wcel cB cX wcel cU cnv wcel c1 cneg cc wcel cA
      cX wcel c1 cneg cA cU cns cfv co cX wcel c1 ax1cn negcli c1 cneg cA cU
      cns cfv cU cX nvsubsub23.1 cU cns cfv eqid nvscl mp3an2 3adant3 cU cnv
      wcel cA cX wcel cB cX wcel 3simp3 3jca sylanc cU cnv wcel cA cX wcel cB
      cX wcel w3a cA c1 cneg cA cU cns cfv co cU cpv cfv co cU cn0v cfv cB cU
      cpv cfv cU cnv wcel cA cX wcel cA c1 cneg cA cU cns cfv co cU cpv cfv co
      cU cn0v cfv wceq cB cX wcel cA cU cns cfv cU cU cpv cfv cX cU cn0v cfv
      nvsubsub23.1 cU cpv cfv eqid cU cns cfv eqid cU cn0v cfv eqid nvrinv
      3adant3 opreq1d 3eqtr2d cU cnv wcel cB cX wcel cU cn0v cfv cB cU cpv cfv
      co cB wceq cA cX wcel cB cU cU cpv cfv cX cU cn0v cfv nvsubsub23.1 cU cpv
      cfv eqid cU cn0v cfv eqid nv0lid 3adant2 3eqtrd $.
      $( [4-Jan-2008] $) $( [17-Dec-2007] $)
  $}

  ${
    nvmeq0.1 $e |- X = ( BaseSet ` U ) $.
    nvmeq0.3 $e |- M = ( -v ` U ) $.
    nvmeq0.5 $e |- Z = ( 0v ` U ) $.
    $( The difference between two vectors is zero iff they are equal. $)
    nvmeq0 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
            ( ( A M B ) = Z <-> A = B ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cM co cB cU cpv cfv co cZ cB
      cU cpv cfv co wceq cA cB cM co cZ wceq cA cB wceq cU cnv wcel cA cX wcel
      cB cX wcel cA cB cM co cB cU cpv cfv co cZ cB cU cpv cfv co wceq cA cB cM
      co cZ wceq wb cU cnv wcel cA cX wcel cB cX wcel wa cA cB cM co cX wcel cZ
      cX wcel cB cX wcel w3a cA cB cM co cB cU cpv cfv co cZ cB cU cpv cfv co
      wceq cA cB cM co cZ wceq wb cU cnv wcel cA cX wcel cB cX wcel wa wa cA cB
      cM co cX wcel cZ cX wcel cB cX wcel cU cnv wcel cA cX wcel cB cX wcel cA
      cB cM co cX wcel cA cB cU cM cX nvmeq0.1 nvmeq0.3 nvmcl 3expb cU cnv wcel
      cZ cX wcel cA cX wcel cB cX wcel wa cU cX cZ nvmeq0.1 nvmeq0.5 nvzcl
      adantr cU cnv wcel cA cX wcel cB cX wcel simprr 3jca cA cB cM co cZ cB cU
      cU cpv cfv cX nvmeq0.1 cU cpv cfv eqid nvrcan syldan 3impb cU cnv wcel cA
      cX wcel cB cX wcel w3a cA cB cM co cB cU cpv cfv co cA cZ cB cU cpv cfv
      co cB cA cB cU cU cpv cfv cM cX nvmeq0.1 cU cpv cfv eqid nvmeq0.3 nvnpcan
      cU cnv wcel cB cX wcel cZ cB cU cpv cfv co cB wceq cA cX wcel cB cU cU
      cpv cfv cX cZ nvmeq0.1 cU cpv cfv eqid nvmeq0.5 nv0lid 3adant2 eqeq12d
      bitr3d $.
      $( [4-Feb-2008] $) $( [24-Jan-2008] $)

    $( A vector minus itself is the zero vector. $)
    nvmid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A M A ) = Z ) $=
      cU cnv wcel cA cX wcel wa cA cA cM co cZ wceq cA cA wceq cA eqid cU cnv
      wcel cA cX wcel cA cA cM co cZ wceq cA cA wceq wb cA cA cU cM cX cZ
      nvmeq0.1 nvmeq0.3 nvmeq0.5 nvmeq0 3anidm23 mpbiri $.
      $( [14-Feb-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    $d x y N $.  $d x y U $.  $d x y X $.
    nvf.1 $e |- X = ( BaseSet ` U ) $.
    nvf.6 $e |- N = ( norm ` U ) $.
    $( Mapping for the norm function. $)
    nvf $p |- ( U e. NrmCVec -> N : X --> RR ) $=
      cU cnv wcel cU cpv cfv cU cns cfv cop cvc wcel cX cr cN wf vx cv cN cfv
      cc0 wceq vx cv cU cn0v cfv wceq wi vy cv vx cv cU cns cfv co cN cfv vy cv
      cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cU cpv cfv co
      cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX
      wral vx vy cU cns cfv cU cU cpv cfv cN cX cU cn0v cfv nvf.1 cU cpv cfv
      eqid cU cns cfv eqid cU cn0v cfv eqid nvf.6 nvi 3simp2d $.
      $( [6-Sep-2007] $) $( [11-Nov-2006] $)

    $( The norm of a normed complex vector space is a real number. $)
    nvcl $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( N ` A ) e. RR ) $=
      cX cr cN wf cA cX wcel cA cN cfv cr wcel cU cnv wcel cX cr cA cN ffvelrn
      cU cN cX nvf.1 nvf.6 nvf sylan $.
      $( [8-Sep-2007] $) $( [24-Nov-2006] $)

    ${
      nvcli.9 $e |- U e. NrmCVec $.
      nvcli.7 $e |- A e. X $.
      $( The norm of a normed complex vector space is a real number. $)
      nvcli $p |- ( N ` A ) e. RR $=
        cU cnv wcel cA cX wcel cA cN cfv cr wcel nvcli.9 nvcli.7 cA cU cN cX
        nvf.1 nvf.6 nvcl mp2an $.
        $( [4-Oct-2007] $) $( [20-Apr-2007] $)
    $}
  $}

  ${
    nvdm.2 $e |- G = ( +v ` U ) $.
    nvdm.6 $e |- N = ( norm ` U ) $.
    $( Two ways to express the set of vectors in a normed complex vector
       space. $)
    nvdm $p |- ( U e. NrmCVec -> ( X = dom N <-> X = ran G ) ) $=
      cU cnv wcel cN cdm cG crn cX cU cnv wcel cG crn cr cN wf cN cdm cG crn
      wceq cU cN cG crn cU cba cfv cG crn cU cG cU cba cfv cU cba cfv eqid
      nvdm.2 bafval eqcomi nvdm.6 nvf cG crn cr cN fdm syl eqeq2d $.
      $( [25-Jun-2008] $) $( [31-Jan-2007] $)
  $}

  ${
    $d y A $.  $d x y B $.  $d x y N $.  $d x y S $.  $d x y U $.  $d x y X $.
    nvs.1 $e |- X = ( BaseSet ` U ) $.
    nvs.4 $e |- S = ( .s ` U ) $.
    nvs.6 $e |- N = ( norm ` U ) $.
    $( Proportionality property of the norm of a scalar product in a normed
       complex vector space. $)
    nvs $p |- ( ( U e. NrmCVec /\ A e. CC /\ B e. X ) ->
               ( N ` ( A S B ) ) = ( ( abs ` A ) x. ( N ` B ) ) ) $=
      cB cX wcel cA cc wcel cU cnv wcel cA cB cS co cN cfv cA cabs cfv cB cN
      cfv cmul co wceq cB cX wcel cA cc wcel cU cnv wcel cA cB cS co cN cfv cA
      cabs cfv cB cN cfv cmul co wceq cB cX wcel cA cc wcel wa vy cv vx cv cS
      co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cX wral
      cA cB cS co cN cfv cA cabs cfv cB cN cfv cmul co wceq cU cnv wcel vy cv
      vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq cA cB cS co
      cN cfv cA cabs cfv cB cN cfv cmul co wceq vy cv cB cS co cN cfv vy cv
      cabs cfv cB cN cfv cmul co wceq vx vy cB cA cX cc vx cv cB wceq vy cv vx
      cv cS co cN cfv vy cv cB cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co
      vy cv cabs cfv cB cN cfv cmul co vx cv cB wceq vy cv vx cv cS co vy cv cB
      cS co cN vx cv cB vy cv cS opreq2 fveq2d vx cv cB wceq vx cv cN cfv cB cN
      cfv vy cv cabs cfv cmul vx cv cB cN fveq2 opreq2d eqeq12d vy cv cA wceq
      vy cv cB cS co cN cfv cA cB cS co cN cfv vy cv cabs cfv cB cN cfv cmul co
      cA cabs cfv cB cN cfv cmul co vy cv cA wceq vy cv cB cS co cA cB cS co cN
      vy cv cA cB cS opreq1 fveq2d vy cv cA wceq vy cv cabs cfv cA cabs cfv cB
      cN cfv cmul vy cv cA cabs fveq2 opreq1d eqeq12d rcla42v cU cnv wcel cU
      cpv cfv cS cop cvc wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cU cn0v
      cfv wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co
      wceq vy cc wral vx cv vy cv cU cpv cfv co cN cfv vx cv cN cfv vy cv cN
      cfv caddc co cle wbr vy cX wral w3a vx cX wral w3a vx cv cN cfv cc0 wceq
      vx cv cU cn0v cfv wceq wi vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv
      cN cfv cmul co wceq vy cc wral vx cv vy cv cU cpv cfv co cN cfv vx cv cN
      cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral vy cv vx cv
      cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cX
      wral vx vy cS cU cU cpv cfv cN cX cU cn0v cfv nvs.1 cU cpv cfv eqid nvs.4
      cU cn0v cfv eqid nvs.6 nvi cU cpv cfv cS cop cvc wcel cX cr cN wf vx cv
      cN cfv cc0 wceq vx cv cU cn0v cfv wceq wi vy cv vx cv cS co cN cfv vy cv
      cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cU cpv cfv co
      cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX
      wral 3simp3 vx cv cN cfv cc0 wceq vx cv cU cn0v cfv wceq wi vy cv vx cv
      cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy
      cv cU cpv cfv co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX
      wral w3a vy cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co
      wceq vy cc wral vx cX vx cv cN cfv cc0 wceq vx cv cU cn0v cfv wceq wi vy
      cv vx cv cS co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc wral
      vx cv vy cv cU cpv cfv co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle
      wbr vy cX wral 3simp2 r19.20si 3syl syl5 3impia 3com13 $.
      $( [21-Sep-2007] $) $( [11-Nov-2006] $)

    $( The norm of a scalar product with a nonnegative real. $)
    nvsge0 $p |- ( ( U e. NrmCVec /\ ( A e. RR /\ 0 <_ A ) /\ B e. X ) ->
               ( N ` ( A S B ) ) = ( A x. ( N ` B ) ) ) $=
      cU cnv wcel cA cr wcel cc0 cA cle wbr wa cB cX wcel w3a cA cB cS co cN
      cfv cA cabs cfv cB cN cfv cmul co cA cB cN cfv cmul co cU cnv wcel cA cc
      wcel cB cX wcel cA cB cS co cN cfv cA cabs cfv cB cN cfv cmul co wceq cA
      cr wcel cc0 cA cle wbr wa cA cB cS cU cN cX nvs.1 nvs.4 nvs.6 nvs cA cr
      wcel cA cc wcel cc0 cA cle wbr cA recn adantr syl3an2 cU cnv wcel cA cr
      wcel cc0 cA cle wbr wa cB cX wcel w3a cA cabs cfv cA cB cN cfv cmul cA cr
      wcel cc0 cA cle wbr wa cU cnv wcel cA cabs cfv cA wceq cB cX wcel cA
      absid 3ad2ant2 opreq1d eqtrd $.
      $( [7-Jan-2008] $) $( [1-Jan-2008] $)

    $( The norm of the negative of a vector. $)
    nvm1 $p |- ( ( U e. NrmCVec /\ A e. X ) ->
               ( N ` ( -u 1 S A ) ) = ( N ` A ) ) $=
      cU cnv wcel cA cX wcel wa c1 cneg cA cS co cN cfv c1 cneg cabs cfv cA cN
      cfv cmul co cA cN cfv cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA
      cS co cN cfv c1 cneg cabs cfv cA cN cfv cmul co wceq c1 ax1cn negcli c1
      cneg cA cS cU cN cX nvs.1 nvs.4 nvs.6 nvs mp3an2 cU cnv wcel cA cX wcel
      wa c1 cA cN cfv cmul co cA cN cfv c1 cneg cabs cfv cA cN cfv cmul co cU
      cnv wcel cA cX wcel wa cA cN cfv cc wcel c1 cA cN cfv cmul co cA cN cfv
      wceq cU cnv wcel cA cX wcel wa cA cN cfv cA cU cN cX nvs.1 nvs.6 nvcl
      recnd cA cN cfv mulid2 syl c1 cneg cabs cfv c1 cA cN cfv cmul c1 cneg
      cabs cfv c1 cabs cfv c1 c1 ax1cn absnegi cc0 c1 cle wbr c1 cabs cfv c1
      wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp eqtri opreq1i syl5eq
      eqtrd $.
      $( [24-Sep-2007] $) $( [28-Nov-2006] $)
  $}

  ${
    nvdif.1 $e |- X = ( BaseSet ` U ) $.
    nvdif.2 $e |- G = ( +v ` U ) $.
    nvdif.4 $e |- S = ( .s ` U ) $.
    nvdif.6 $e |- N = ( norm ` U ) $.
    $( MAY BE REVISED - make this obsolete in favor of nvsub $)
    $( The norm of the difference between two vectors. $)
    nvdif $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( N ` ( A G ( -u 1 S B ) ) ) = ( N ` ( B G ( -u 1 S A ) ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cB c1 cneg cA cS co cG co
      cS co cN cfv cA c1 cneg cB cS co cG co cN cfv cB c1 cneg cA cS co cG co
      cN cfv cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cB c1 cneg cA cS co
      cG co cS co cA c1 cneg cB cS co cG co cN cU cnv wcel cA cX wcel cB cX
      wcel w3a c1 cneg cB c1 cneg cA cS co cG co cS co c1 cneg cB cS co c1 cneg
      c1 cneg cA cS co cS co cG co c1 cneg cB cS co cA cG co cA c1 cneg cB cS
      co cG co cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cA cS co cX wcel
      w3a c1 cneg cB c1 cneg cA cS co cG co cS co c1 cneg cB cS co c1 cneg c1
      cneg cA cS co cS co cG co wceq cU cnv wcel cA cX wcel cB cX wcel w3a c1
      cneg cB c1 cneg cA cS co cS cU cG cX nvdif.1 nvdif.2 nvdif.4 nvdi cU cnv
      wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel cB cX wcel w3a
      c1 cneg cc wcel cB cX wcel c1 cneg cA cS co cX wcel c1 cneg cc wcel cU
      cnv wcel cA cX wcel cB cX wcel w3a c1 ax1cn negcli a1i cU cnv wcel cA cX
      wcel cB cX wcel 3simp3 cU cnv wcel cA cX wcel c1 cneg cA cS co cX wcel cB
      cX wcel cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX wcel
      c1 ax1cn negcli c1 cneg cA cS cU cX nvdif.1 nvdif.4 nvscl mp3an2 3adant3
      3jca sylanc cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg c1 cneg cA cS
      co cS co cA c1 cneg cB cS co cG cU cnv wcel cA cX wcel c1 cneg c1 cneg cA
      cS co cS co cA wceq cB cX wcel cA cS cU cX nvdif.1 nvdif.4 nvnegneg
      3adant3 opreq2d cU cnv wcel c1 cneg cB cS co cX wcel cA cX wcel c1 cneg
      cB cS co cA cG co cA c1 cneg cB cS co cG co wceq cU cnv wcel cA cX wcel
      cB cX wcel w3a c1 cneg cB cS co cA cU cG cX nvdif.1 nvdif.2 nvcom cU cnv
      wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cB cX wcel c1 cneg cB cS co
      cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS
      co cX wcel c1 ax1cn negcli c1 cneg cB cS cU cX nvdif.1 nvdif.4 nvscl
      mp3an2 3adant2 cU cnv wcel cA cX wcel cB cX wcel 3simp2 syl3anc 3eqtrd
      fveq2d cU cnv wcel cB c1 cneg cA cS co cG co cX wcel c1 cneg cB c1 cneg
      cA cS co cG co cS co cN cfv cB c1 cneg cA cS co cG co cN cfv wceq cU cnv
      wcel cA cX wcel cB cX wcel w3a cB c1 cneg cA cS co cG co cS cU cN cX
      nvdif.1 nvdif.4 nvdif.6 nvm1 cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU
      cnv wcel cB cX wcel c1 cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX
      wcel cU cnv wcel cA cX wcel cB cX wcel w3a cB c1 cneg cA cS co cU cG cX
      nvdif.1 nvdif.2 nvgcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv
      wcel cA cX wcel cB cX wcel 3simp3 cU cnv wcel cA cX wcel c1 cneg cA cS co
      cX wcel cB cX wcel cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS
      co cX wcel c1 ax1cn negcli c1 cneg cA cS cU cX nvdif.1 nvdif.4 nvscl
      mp3an2 3adant3 syl3anc sylanc eqtr3d $.
      $( [25-Sep-2007] $) $( [1-Dec-2006] $)

    $( The norm of a vector plus the imaginary scalar product of another. $)
    nvpi $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( N ` ( A G ( _i S B ) ) ) = ( N ` ( B G ( -u _i S A ) ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a c1 cA ci cB cS co cG co cN cfv cmul
      co cA ci cB cS co cG co cN cfv cB ci cneg cA cS co cG co cN cfv cU cnv
      wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv cc wcel c1 cA
      ci cB cS co cG co cN cfv cmul co cA ci cB cS co cG co cN cfv wceq cU cnv
      wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv cU cnv wcel cA
      ci cB cS co cG co cX wcel cA ci cB cS co cG co cN cfv cr wcel cU cnv wcel
      cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cU cN cX nvdif.1 nvdif.6
      nvcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel ci
      cB cS co cX wcel cA ci cB cS co cG co cX wcel cB cX wcel cA ci cB cS co
      cU cG cX nvdif.1 nvdif.2 nvgcl cU cnv wcel cB cX wcel ci cB cS co cX wcel
      cA cX wcel cU cnv wcel ci cc wcel cB cX wcel ci cB cS co cX wcel axicn ci
      cB cS cU cX nvdif.1 nvdif.4 nvscl mp3an2 3adant2 syld3an3 sylanc recnd cA
      ci cB cS co cG co cN cfv mulid2 syl cU cnv wcel cA cX wcel cB cX wcel w3a
      ci cneg cabs cfv cA ci cB cS co cG co cN cfv cmul co cB ci cneg cA cS co
      cG co cN cfv c1 cA ci cB cS co cG co cN cfv cmul co cU cnv wcel cA cX
      wcel cB cX wcel w3a ci cneg cA ci cB cS co cG co cS co cN cfv ci cneg
      cabs cfv cA ci cB cS co cG co cN cfv cmul co cB ci cneg cA cS co cG co cN
      cfv cU cnv wcel cA ci cB cS co cG co cX wcel ci cneg cA ci cB cS co cG co
      cS co cN cfv ci cneg cabs cfv cA ci cB cS co cG co cN cfv cmul co wceq cU
      cnv wcel cA cX wcel cB cX wcel w3a cU cnv wcel ci cneg cc wcel cA ci cB
      cS co cG co cX wcel ci cneg cA ci cB cS co cG co cS co cN cfv ci cneg
      cabs cfv cA ci cB cS co cG co cN cfv cmul co wceq ci axicn negcli ci cneg
      cA ci cB cS co cG co cS cU cN cX nvdif.1 nvdif.4 nvdif.6 nvs mp3an2 cU
      cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel ci cB cS co
      cX wcel cA ci cB cS co cG co cX wcel cB cX wcel cA ci cB cS co cU cG cX
      nvdif.1 nvdif.2 nvgcl cU cnv wcel cB cX wcel ci cB cS co cX wcel cA cX
      wcel cU cnv wcel ci cc wcel cB cX wcel ci cB cS co cX wcel axicn ci cB cS
      cU cX nvdif.1 nvdif.4 nvscl mp3an2 3adant2 syld3an3 sylanc cU cnv wcel cA
      cX wcel cB cX wcel w3a ci cneg cA ci cB cS co cG co cS co cB ci cneg cA
      cS co cG co cN cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cA ci cB cS
      co cG co cS co ci cneg cA cS co ci cneg ci cB cS co cS co cG co ci cneg
      cA cS co cB cG co cB ci cneg cA cS co cG co cU cnv wcel cA cX wcel ci cB
      cS co cX wcel wa ci cneg cA ci cB cS co cG co cS co ci cneg cA cS co ci
      cneg ci cB cS co cS co cG co wceq cU cnv wcel cA cX wcel cB cX wcel w3a
      cU cnv wcel ci cneg cc wcel cA cX wcel ci cB cS co cX wcel ci cneg cA ci
      cB cS co cG co cS co ci cneg cA cS co ci cneg ci cB cS co cS co cG co
      wceq ci axicn negcli ci cneg cA ci cB cS co cS cU cG cX nvdif.1 nvdif.2
      nvdif.4 nvdi mp3anr1 cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel
      cA cX wcel cB cX wcel w3a cA cX wcel ci cB cS co cX wcel cU cnv wcel cA
      cX wcel cB cX wcel 3simp2 cU cnv wcel cB cX wcel ci cB cS co cX wcel cA
      cX wcel cU cnv wcel ci cc wcel cB cX wcel ci cB cS co cX wcel axicn ci cB
      cS cU cX nvdif.1 nvdif.4 nvscl mp3an2 3adant2 jca sylanc cU cnv wcel cA
      cX wcel cB cX wcel w3a ci cneg ci cB cS co cS co cB ci cneg cA cS co cG
      cU cnv wcel cB cX wcel ci cneg ci cB cS co cS co cB wceq cA cX wcel cU
      cnv wcel cB cX wcel wa ci cneg ci cmul co cB cS co ci cneg ci cB cS co cS
      co cB cU cnv wcel ci cc wcel cB cX wcel ci cneg ci cmul co cB cS co ci
      cneg ci cB cS co cS co wceq axicn cU cnv wcel ci cneg cc wcel ci cc wcel
      cB cX wcel ci cneg ci cmul co cB cS co ci cneg ci cB cS co cS co wceq ci
      axicn negcli ci cneg ci cB cS cU cX nvdif.1 nvdif.4 nvsass mp3anr1 mpanr1
      cU cnv wcel cB cX wcel wa c1 cB cS co cB ci cneg ci cmul co cB cS co cB
      cS cU cX nvdif.1 nvdif.4 nvsid ci cneg ci cmul co c1 cB cS ci cneg ci
      cmul co ci ci cmul co cneg c1 cneg cneg c1 ci ci axicn axicn mulneg1i ci
      ci cmul co c1 cneg ixi negeqi c1 ax1cn negnegi 3eqtri opreq1i syl5eq
      eqtr3d 3adant2 opreq2d cU cnv wcel ci cneg cA cS co cX wcel cB cX wcel ci
      cneg cA cS co cB cG co cB ci cneg cA cS co cG co wceq cA cX wcel ci cneg
      cA cS co cB cU cG cX nvdif.1 nvdif.2 nvcom cU cnv wcel cA cX wcel ci cneg
      cA cS co cX wcel cB cX wcel cU cnv wcel ci cneg cc wcel cA cX wcel ci
      cneg cA cS co cX wcel ci axicn negcli ci cneg cA cS cU cX nvdif.1 nvdif.4
      nvscl mp3an2 3adant3 syld3an2 3eqtrd fveq2d eqtr3d ci cneg cabs cfv c1 cA
      ci cB cS co cG co cN cfv cmul ci cneg cabs cfv ci cabs cfv c1 ci axicn
      absnegi absi eqtri opreq1i syl5eqr eqtr3d $.
      $( [29-Oct-2007] $) $( [2-Feb-2007] $)
  $}

  ${
    nvsub.1 $e |- X = ( BaseSet ` U ) $.
    nvsub.3 $e |- M = ( -v ` U ) $.
    nvsub.6 $e |- N = ( norm ` U ) $.
    $( The norm of the difference between two vectors. $)
    nvsub $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( N ` ( A M B ) ) = ( N ` ( B M A ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cU cns cfv co cU cpv
      cfv co cN cfv cB c1 cneg cA cU cns cfv co cU cpv cfv co cN cfv cA cB cM
      co cN cfv cB cA cM co cN cfv cA cB cU cns cfv cU cU cpv cfv cN cX nvsub.1
      cU cpv cfv eqid cU cns cfv eqid nvsub.6 nvdif cU cnv wcel cA cX wcel cB
      cX wcel w3a cA cB cM co cA c1 cneg cB cU cns cfv co cU cpv cfv co cN cA
      cB cU cns cfv cU cU cpv cfv cM cX nvsub.1 cU cpv cfv eqid cU cns cfv eqid
      nvsub.3 nvmval fveq2d cU cnv wcel cA cX wcel cB cX wcel w3a cB cA cM co
      cB c1 cneg cA cU cns cfv co cU cpv cfv co cN cU cnv wcel cB cX wcel cA cX
      wcel cB cA cM co cB c1 cneg cA cU cns cfv co cU cpv cfv co wceq cB cA cU
      cns cfv cU cU cpv cfv cM cX nvsub.1 cU cpv cfv eqid cU cns cfv eqid
      nvsub.3 nvmval 3com23 fveq2d 3eqtr4d $.
      $( [13-Feb-2008] $) $( [14-Dec-2007] $)
  $}

  ${
    nvz0.5 $e |- Z = ( 0v ` U ) $.
    nvz0.6 $e |- N = ( norm ` U ) $.
    $( The norm of a zero vector is zero. $)
    nvz0 $p |- ( U e. NrmCVec -> ( N ` Z ) = 0 ) $=
      cU cnv wcel cc0 cZ cU cns cfv co cN cfv cc0 cZ cN cfv cmul co cZ cN cfv
      cc0 cU cnv wcel cZ cU cba cfv wcel cc0 cZ cU cns cfv co cN cfv cc0 cZ cN
      cfv cmul co wceq cU cU cba cfv cZ cU cba cfv eqid nvz0.5 nvzcl cU cnv
      wcel cc0 cr wcel cc0 cc0 cle wbr wa cZ cU cba cfv wcel cc0 cZ cU cns cfv
      co cN cfv cc0 cZ cN cfv cmul co wceq cc0 cr wcel cc0 cc0 cle wbr 0re cc0
      0re leidi pm3.2i cc0 cZ cU cns cfv cU cN cU cba cfv cU cba cfv eqid cU
      cns cfv eqid nvz0.6 nvsge0 mp3an2 mpdan cU cnv wcel cc0 cZ cU cns cfv co
      cZ cN cU cnv wcel cZ cU cba cfv wcel cc0 cZ cU cns cfv co cZ wceq cU cU
      cba cfv cZ cU cba cfv eqid nvz0.5 nvzcl cZ cU cns cfv cU cU cba cfv cZ cU
      cba cfv eqid cU cns cfv eqid nvz0.5 nv0 mpdan fveq2d cU cnv wcel cZ cN
      cfv cc wcel cc0 cZ cN cfv cmul co cc0 wceq cU cnv wcel cZ cU cba cfv wcel
      cZ cN cfv cc wcel cU cU cba cfv cZ cU cba cfv eqid nvz0.5 nvzcl cU cnv
      wcel cZ cU cba cfv wcel wa cZ cN cfv cZ cU cN cU cba cfv cU cba cfv eqid
      nvz0.6 nvcl recnd mpdan cZ cN cfv mul02 syl 3eqtr3d $.
      $( [25-Sep-2007] $) $( [24-Nov-2006] $)
  $}

  ${
    $d x A $.  $d x y N $.  $d x y U $.  $d x y X $.  $d x Z $.
    nvz.1 $e |- X = ( BaseSet ` U ) $.
    nvz.5 $e |- Z = ( 0v ` U ) $.
    nvz.6 $e |- N = ( norm ` U ) $.
    $( The norm of a vector is zero iff the vector is zero.  First part of
       Problem 2 of [Kreyszig] p. 64. $)
    nvz $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( ( N ` A ) = 0 <-> A = Z ) ) $=
      cU cnv wcel cA cX wcel wa cA cN cfv cc0 wceq cA cZ wceq cU cnv wcel cA cX
      wcel cA cN cfv cc0 wceq cA cZ wceq wi cU cnv wcel vx cv cN cfv cc0 wceq
      vx cv cZ wceq wi vy cv vx cv cU cns cfv co cN cfv vy cv cabs cfv vx cv cN
      cfv cmul co wceq vy cc wral vx cv vy cv cU cpv cfv co cN cfv vx cv cN cfv
      vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral vx cv cN cfv cc0
      wceq vx cv cZ wceq wi vx cX wral cA cX wcel cA cN cfv cc0 wceq cA cZ wceq
      wi wi cU cnv wcel cU cpv cfv cU cns cfv cop cvc wcel cX cr cN wf vx cv cN
      cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cU cns cfv co cN cfv vy cv cabs
      cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cU cpv cfv co cN cfv
      vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral vx
      vy cU cns cfv cU cU cpv cfv cN cX cZ nvz.1 cU cpv cfv eqid cU cns cfv
      eqid nvz.5 nvz.6 nvi 3simp3d vx cv cN cfv cc0 wceq vx cv cZ wceq wi vy cv
      vx cv cU cns cfv co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy cc
      wral vx cv vy cv cU cpv cfv co cN cfv vx cv cN cfv vy cv cN cfv caddc co
      cle wbr vy cX wral w3a vx cv cN cfv cc0 wceq vx cv cZ wceq wi vx cX vx cv
      cN cfv cc0 wceq vx cv cZ wceq wi vy cv vx cv cU cns cfv co cN cfv vy cv
      cabs cfv vx cv cN cfv cmul co wceq vy cc wral vx cv vy cv cU cpv cfv co
      cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral 3simp1
      r19.20si vx cv cN cfv cc0 wceq vx cv cZ wceq wi cA cN cfv cc0 wceq cA cZ
      wceq wi vx cA cX vx cv cA wceq vx cv cN cfv cc0 wceq cA cN cfv cc0 wceq
      vx cv cZ wceq cA cZ wceq vx cv cA wceq vx cv cN cfv cA cN cfv cc0 vx cv
      cA cN fveq2 eqeq1d vx cv cA cZ eqeq1 imbi12d rcla4cv 3syl imp cU cnv wcel
      cA cZ wceq cA cN cfv cc0 wceq wi cA cX wcel cU cnv wcel cA cZ wceq cA cN
      cfv cc0 wceq cA cZ wceq cU cnv wcel cA cN cfv cZ cN cfv cc0 cA cZ cN
      fveq2 cU cN cZ nvz.5 nvz.6 nvz0 sylan9eqr ex adantr impbid $.
      $( [30-Sep-2007] $) $( [24-Nov-2006] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y N $.  $d x y U $.  $d x y X $.
    nvtri.1 $e |- X = ( BaseSet ` U ) $.
    nvtri.2 $e |- G = ( +v ` U ) $.
    nvtri.6 $e |- N = ( norm ` U ) $.
    $( Triangle inequality for the norm of a normed complex vector space. $)
    nvtri $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( N ` ( A G B ) ) <_ ( ( N ` A ) + ( N ` B ) ) ) $=
      cA cX wcel cB cX wcel cU cnv wcel cA cB cG co cN cfv cA cN cfv cB cN cfv
      caddc co cle wbr cA cX wcel cB cX wcel cU cnv wcel cA cB cG co cN cfv cA
      cN cfv cB cN cfv caddc co cle wbr cA cX wcel cB cX wcel wa vx cv vy cv cG
      co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr vy cX wral vx cX
      wral cA cB cG co cN cfv cA cN cfv cB cN cfv caddc co cle wbr cU cnv wcel
      vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle wbr cA cB
      cG co cN cfv cA cN cfv cB cN cfv caddc co cle wbr cA vy cv cG co cN cfv
      cA cN cfv vy cv cN cfv caddc co cle wbr vx vy cA cB cX cX vx cv cA wceq
      vx cv vy cv cG co cN cfv cA vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv
      caddc co cA cN cfv vy cv cN cfv caddc co cle vx cv cA wceq vx cv vy cv cG
      co cA vy cv cG co cN vx cv cA vy cv cG opreq1 fveq2d vx cv cA wceq vx cv
      cN cfv cA cN cfv vy cv cN cfv caddc vx cv cA cN fveq2 opreq1d breq12d vy
      cv cB wceq cA vy cv cG co cN cfv cA cB cG co cN cfv cA cN cfv vy cv cN
      cfv caddc co cA cN cfv cB cN cfv caddc co cle vy cv cB wceq cA vy cv cG
      co cA cB cG co cN vy cv cB cA cG opreq2 fveq2d vy cv cB wceq vy cv cN cfv
      cB cN cfv cA cN cfv caddc vy cv cB cN fveq2 opreq2d breq12d rcla42v cU
      cnv wcel vx cv cN cfv cc0 wceq vx cv cG cgi cfv wceq wi vy cv vx cv cU
      c1st cfv c2nd cfv co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy
      cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle
      wbr vy cX wral w3a vx cX wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv
      cN cfv caddc co cle wbr vy cX wral vx cX wral cU cnv wcel cG cU c1st cfv
      c2nd cfv cop cvc wcel cX cr cN wf vx cv cN cfv cc0 wceq vx cv cG cgi cfv
      wceq wi vy cv vx cv cU c1st cfv c2nd cfv co cN cfv vy cv cabs cfv vx cv
      cN cfv cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy
      cv cN cfv caddc co cle wbr vy cX wral w3a vx cX wral vx vy cU c1st cfv
      c2nd cfv cU cG cN cX cG cgi cfv nvtri.1 nvtri.2 cU cns cfv cU c1st cfv
      c2nd cfv cU cns cfv cU cU cns cfv eqid smfval eqcomi cU cn0v cfv cG cgi
      cfv cU cG cU cn0v cfv nvtri.2 cU cn0v cfv eqid 0vfval eqcomi nvtri.6 nvi
      3simp3d vx cv cN cfv cc0 wceq vx cv cG cgi cfv wceq wi vy cv vx cv cU
      c1st cfv c2nd cfv co cN cfv vy cv cabs cfv vx cv cN cfv cmul co wceq vy
      cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv caddc co cle
      wbr vy cX wral w3a vx cv vy cv cG co cN cfv vx cv cN cfv vy cv cN cfv
      caddc co cle wbr vy cX wral vx cX vx cv cN cfv cc0 wceq vx cv cG cgi cfv
      wceq wi vy cv vx cv cU c1st cfv c2nd cfv co cN cfv vy cv cabs cfv vx cv
      cN cfv cmul co wceq vy cc wral vx cv vy cv cG co cN cfv vx cv cN cfv vy
      cv cN cfv caddc co cle wbr vy cX wral 3simp3 r19.20si syl syl5 3impia
      3comr $.
      $( [30-Sep-2007] $) $( [11-Nov-2006] $)
  $}

  ${
    nvmtri.1 $e |- X = ( BaseSet ` U ) $.
    nvmtri.3 $e |- M = ( -v ` U ) $.
    nvmtri.6 $e |- N = ( norm ` U ) $.
    $( Triangle inequality for the norm of a vector difference. $)
    nvmtri $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( N ` ( A M B ) ) <_ ( ( N ` A ) + ( N ` B ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cU cns cfv co cU cpv
      cfv co cN cfv cA cN cfv c1 cneg cB cU cns cfv co cN cfv caddc co cA cB cM
      co cN cfv cA cN cfv cB cN cfv caddc co cle cU cnv wcel cA cX wcel c1 cneg
      cB cU cns cfv co cX wcel cA c1 cneg cB cU cns cfv co cU cpv cfv co cN cfv
      cA cN cfv c1 cneg cB cU cns cfv co cN cfv caddc co cle wbr cB cX wcel cA
      c1 cneg cB cU cns cfv co cU cU cpv cfv cN cX nvmtri.1 cU cpv cfv eqid
      nvmtri.6 nvtri cU cnv wcel cB cX wcel c1 cneg cB cU cns cfv co cX wcel cA
      cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cU cns cfv co
      cX wcel c1 ax1cn negcli c1 cneg cB cU cns cfv cU cX nvmtri.1 cU cns cfv
      eqid nvscl mp3an2 3adant2 syld3an3 cU cnv wcel cA cX wcel cB cX wcel w3a
      cA cB cM co cA c1 cneg cB cU cns cfv co cU cpv cfv co cN cA cB cU cns cfv
      cU cU cpv cfv cM cX nvmtri.1 cU cpv cfv eqid cU cns cfv eqid nvmtri.3
      nvmval fveq2d cU cnv wcel cA cX wcel cB cX wcel w3a cB cN cfv c1 cneg cB
      cU cns cfv co cN cfv cA cN cfv caddc cU cnv wcel cB cX wcel cB cN cfv c1
      cneg cB cU cns cfv co cN cfv wceq cA cX wcel cU cnv wcel cB cX wcel wa c1
      cneg cB cU cns cfv co cN cfv c1 cneg cabs cfv cB cN cfv cmul co cB cN cfv
      cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cU cns cfv co cN cfv c1
      cneg cabs cfv cB cN cfv cmul co wceq c1 ax1cn negcli c1 cneg cB cU cns
      cfv cU cN cX nvmtri.1 cU cns cfv eqid nvmtri.6 nvs mp3an2 cU cnv wcel cB
      cX wcel wa c1 cB cN cfv cmul co cB cN cfv c1 cneg cabs cfv cB cN cfv cmul
      co cU cnv wcel cB cX wcel wa cB cN cfv cc wcel c1 cB cN cfv cmul co cB cN
      cfv wceq cU cnv wcel cB cX wcel wa cB cN cfv cB cU cN cX nvmtri.1
      nvmtri.6 nvcl recnd cB cN cfv mulid2 syl c1 cneg cabs cfv c1 cB cN cfv
      cmul c1 cneg cabs cfv c1 cabs cfv c1 c1 ax1cn absnegi cc0 c1 cle wbr c1
      cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp eqtri
      opreq1i syl5eq eqtr2d 3adant2 opreq2d 3brtr4d $.
      $( [11-Jan-2008] $) $( [27-Dec-2007] $)

    $( Triangle inequality for the norm of a vector difference. $)
    nvmtri2 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
          ( N ` ( A M C ) ) <_ ( ( N ` ( A M B ) ) + ( N ` ( B M C ) ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC cM co cN cfv cA
      cB cM co cB cC cM co cU cpv cfv co cN cfv cA cB cM co cN cfv cB cC cM co
      cN cfv caddc co cle cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa
      cA cC cM co cA cB cM co cB cC cM co cU cpv cfv co cN cU cnv wcel cA cX
      wcel cB cX wcel cC cX wcel w3a wa cA cB cM co cB cC cM co cU cpv cfv co
      cA cC cM co cU cpv cfv cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a cA
      cB cM co cB cC cM co cU cpv cfv co cA cC cM co wceq cU cnv wcel cA cB cC
      cM cU cpv cfv cX cU cU cpv cfv cX nvmtri.1 cU cpv cfv eqid bafval cU cU
      cpv cfv cM cU cpv cfv eqid nvmtri.3 vsfval grpnpncan cU cU cpv cfv cU cpv
      cfv eqid nvgrp sylan eqcomd fveq2d cU cnv wcel cA cB cM co cX wcel cB cC
      cM co cX wcel cA cB cM co cB cC cM co cU cpv cfv co cN cfv cA cB cM co cN
      cfv cB cC cM co cN cfv caddc co cle wbr cU cnv wcel cA cX wcel cB cX wcel
      cC cX wcel w3a wa cA cB cM co cB cC cM co cU cU cpv cfv cN cX nvmtri.1 cU
      cpv cfv eqid nvmtri.6 nvtri cU cnv wcel cA cX wcel cB cX wcel cC cX wcel
      w3a pm3.26 cU cnv wcel cA cX wcel cB cX wcel cA cB cM co cX wcel cC cX
      wcel cA cB cU cM cX nvmtri.1 nvmtri.3 nvmcl 3adant3r3 cU cnv wcel cB cX
      wcel cC cX wcel cB cC cM co cX wcel cA cX wcel cB cC cU cM cX nvmtri.1
      nvmtri.3 nvmcl 3adant3r1 syl3anc eqbrtrd $.
      $( [16-Mar-2008] $) $( [24-Feb-2008] $)
  $}

  ${
    nvabs.1 $e |- X = ( BaseSet ` U ) $.
    nvabs.2 $e |- G = ( +v ` U ) $.
    nvabs.4 $e |- S = ( .s ` U ) $.
    nvabs.6 $e |- N = ( norm ` U ) $.
    $( Norm difference property of a normed complex vector space.  Problem 3
       of [Kreyszig] p. 64. $)
    nvabs $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
       ( abs ` ( ( N ` A ) - ( N ` B ) ) ) <_ ( N ` ( A G ( -u 1 S B ) ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cN cfv cB cN cfv cmin co cabs
      cfv cA c1 cneg cB cS co cG co cN cfv cle wbr cA c1 cneg cB cS co cG co cN
      cfv cneg cA cN cfv cB cN cfv cmin co cle wbr cA cN cfv cB cN cfv cmin co
      cA c1 cneg cB cS co cG co cN cfv cle wbr wa cU cnv wcel cA cX wcel cB cX
      wcel w3a cA c1 cneg cB cS co cG co cN cfv cneg cA cN cfv cB cN cfv cmin
      co cle wbr cA cN cfv cB cN cfv cmin co cA c1 cneg cB cS co cG co cN cfv
      cle wbr cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co
      cN cfv cneg cB c1 cneg cA cS co cG co cN cfv cneg cA cN cfv cB cN cfv
      cmin co cle cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG
      co cN cfv cB c1 cneg cA cS co cG co cN cfv cA cB cS cU cG cN cX nvabs.1
      nvabs.2 nvabs.4 nvabs.6 nvdif negeqd cU cnv wcel cA cX wcel cB cX wcel
      w3a cB c1 cneg cA cS co cG co cN cfv cneg cA cN cfv cB cN cfv cmin co cle
      wbr cB cN cfv cA cN cfv cB c1 cneg cA cS co cG co cN cfv cneg cmin co cle
      wbr cU cnv wcel cA cX wcel cB cX wcel w3a cB cN cfv cA cN cfv cB c1 cneg
      cA cS co cG co cN cfv caddc co cA cN cfv cB c1 cneg cA cS co cG co cN cfv
      cneg cmin co cle cU cnv wcel cA cX wcel cB cX wcel w3a cA cB c1 cneg cA
      cS co cG co cG co cN cfv cB cN cfv cA cN cfv cB c1 cneg cA cS co cG co cN
      cfv caddc co cle cU cnv wcel cA cX wcel cB cX wcel w3a cA cB c1 cneg cA
      cS co cG co cG co cB cN cU cnv wcel cA cX wcel cB cX wcel w3a cA cB c1
      cneg cA cS co cG co cG co cB c1 cneg cA cS co cG co cA cG co cB cU cnv
      wcel cA cX wcel cB c1 cneg cA cS co cG co cX wcel cA cB c1 cneg cA cS co
      cG co cG co cB c1 cneg cA cS co cG co cA cG co wceq cB cX wcel cA cB c1
      cneg cA cS co cG co cU cG cX nvabs.1 nvabs.2 nvcom cU cnv wcel cB cX wcel
      cA cX wcel cB c1 cneg cA cS co cG co cX wcel cU cnv wcel cB cX wcel c1
      cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX wcel cA cX wcel cB c1
      cneg cA cS co cU cG cX nvabs.1 nvabs.2 nvgcl cU cnv wcel cA cX wcel c1
      cneg cA cS co cX wcel cB cX wcel cU cnv wcel c1 cneg cc wcel cA cX wcel
      c1 cneg cA cS co cX wcel c1 ax1cn negcli c1 cneg cA cS cU cX nvabs.1
      nvabs.4 nvscl mp3an2 3adant2 syld3an3 3com23 syld3an3 cU cnv wcel cA cX
      wcel cB cX wcel w3a cB c1 cneg cA cS co cG co cA cG co cB c1 cneg cA cS
      co cA cG co cG co cB cU cn0v cfv cG co cB cU cnv wcel cA cX wcel cB cX
      wcel cB c1 cneg cA cS co cG co cA cG co cB c1 cneg cA cS co cA cG co cG
      co wceq cU cnv wcel cA cX wcel cB cX wcel wa cB cX wcel c1 cneg cA cS co
      cX wcel cA cX wcel w3a cB c1 cneg cA cS co cG co cA cG co cB c1 cneg cA
      cS co cA cG co cG co wceq cU cnv wcel cA cX wcel cB cX wcel wa wa cB cX
      wcel c1 cneg cA cS co cX wcel cA cX wcel cU cnv wcel cA cX wcel cB cX
      wcel simprr cU cnv wcel cA cX wcel c1 cneg cA cS co cX wcel cB cX wcel cU
      cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX wcel c1 ax1cn
      negcli c1 cneg cA cS cU cX nvabs.1 nvabs.4 nvscl mp3an2 adantrr cU cnv
      wcel cA cX wcel cB cX wcel simprl 3jca cB c1 cneg cA cS co cA cU cG cX
      nvabs.1 nvabs.2 nvass syldan 3impb cU cnv wcel cA cX wcel cB cX wcel w3a
      c1 cneg cA cS co cA cG co cU cn0v cfv cB cG cU cnv wcel cA cX wcel c1
      cneg cA cS co cA cG co cU cn0v cfv wceq cB cX wcel cA cS cU cG cX cU cn0v
      cfv nvabs.1 nvabs.2 nvabs.4 cU cn0v cfv eqid nvlinv 3adant3 opreq2d cU
      cnv wcel cB cX wcel cB cU cn0v cfv cG co cB wceq cA cX wcel cB cU cG cX
      cU cn0v cfv nvabs.1 nvabs.2 cU cn0v cfv eqid nv0rid 3adant2 3eqtrd eqtrd
      fveq2d cU cnv wcel cA cX wcel cB c1 cneg cA cS co cG co cX wcel cA cB c1
      cneg cA cS co cG co cG co cN cfv cA cN cfv cB c1 cneg cA cS co cG co cN
      cfv caddc co cle wbr cB cX wcel cA cB c1 cneg cA cS co cG co cU cG cN cX
      nvabs.1 nvabs.2 nvabs.6 nvtri cU cnv wcel cB cX wcel cA cX wcel cB c1
      cneg cA cS co cG co cX wcel cU cnv wcel cB cX wcel c1 cneg cA cS co cX
      wcel cB c1 cneg cA cS co cG co cX wcel cA cX wcel cB c1 cneg cA cS co cU
      cG cX nvabs.1 nvabs.2 nvgcl cU cnv wcel cA cX wcel c1 cneg cA cS co cX
      wcel cB cX wcel cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co
      cX wcel c1 ax1cn negcli c1 cneg cA cS cU cX nvabs.1 nvabs.4 nvscl mp3an2
      3adant2 syld3an3 3com23 syld3an3 eqbrtrrd cA cN cfv cc wcel cB c1 cneg cA
      cS co cG co cN cfv cc wcel cA cN cfv cB c1 cneg cA cS co cG co cN cfv
      cneg cmin co cA cN cfv cB c1 cneg cA cS co cG co cN cfv caddc co wceq cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cN cfv cB c1 cneg cA cS co cG co cN
      cfv subneg cU cnv wcel cA cX wcel cB cX wcel w3a cA cN cfv cU cnv wcel cA
      cX wcel cA cN cfv cr wcel cB cX wcel cA cU cN cX nvabs.1 nvabs.6 nvcl
      3adant3 recnd cU cnv wcel cA cX wcel cB cX wcel w3a cB c1 cneg cA cS co
      cG co cN cfv cU cnv wcel cB c1 cneg cA cS co cG co cX wcel cB c1 cneg cA
      cS co cG co cN cfv cr wcel cU cnv wcel cA cX wcel cB cX wcel w3a cB c1
      cneg cA cS co cG co cU cN cX nvabs.1 nvabs.6 nvcl cU cnv wcel cA cX wcel
      cB cX wcel 3simp1 cU cnv wcel cB cX wcel cA cX wcel cB c1 cneg cA cS co
      cG co cX wcel cU cnv wcel cB cX wcel c1 cneg cA cS co cX wcel cB c1 cneg
      cA cS co cG co cX wcel cA cX wcel cB c1 cneg cA cS co cU cG cX nvabs.1
      nvabs.2 nvgcl cU cnv wcel cA cX wcel c1 cneg cA cS co cX wcel cB cX wcel
      cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX wcel c1 ax1cn
      negcli c1 cneg cA cS cU cX nvabs.1 nvabs.4 nvscl mp3an2 3adant2 syld3an3
      3com23 sylanc recnd sylanc breqtrrd cB c1 cneg cA cS co cG co cN cfv cneg
      cr wcel cA cN cfv cr wcel cB cN cfv cr wcel cB c1 cneg cA cS co cG co cN
      cfv cneg cA cN cfv cB cN cfv cmin co cle wbr cB cN cfv cA cN cfv cB c1
      cneg cA cS co cG co cN cfv cneg cmin co cle wbr wb cU cnv wcel cA cX wcel
      cB cX wcel w3a cB c1 cneg cA cS co cG co cN cfv cneg cA cN cfv cB cN cfv
      lesub cU cnv wcel cA cX wcel cB cX wcel w3a cB c1 cneg cA cS co cG co cN
      cfv cr wcel cB c1 cneg cA cS co cG co cN cfv cneg cr wcel cU cnv wcel cB
      c1 cneg cA cS co cG co cX wcel cB c1 cneg cA cS co cG co cN cfv cr wcel
      cU cnv wcel cA cX wcel cB cX wcel w3a cB c1 cneg cA cS co cG co cU cN cX
      nvabs.1 nvabs.6 nvcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel
      cB cX wcel cA cX wcel cB c1 cneg cA cS co cG co cX wcel cU cnv wcel cB cX
      wcel c1 cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX wcel cA cX
      wcel cB c1 cneg cA cS co cU cG cX nvabs.1 nvabs.2 nvgcl cU cnv wcel cA cX
      wcel c1 cneg cA cS co cX wcel cB cX wcel cU cnv wcel c1 cneg cc wcel cA
      cX wcel c1 cneg cA cS co cX wcel c1 ax1cn negcli c1 cneg cA cS cU cX
      nvabs.1 nvabs.4 nvscl mp3an2 3adant2 syld3an3 3com23 sylanc cB c1 cneg cA
      cS co cG co cN cfv renegcl syl cU cnv wcel cA cX wcel cA cN cfv cr wcel
      cB cX wcel cA cU cN cX nvabs.1 nvabs.6 nvcl 3adant3 cU cnv wcel cB cX
      wcel cB cN cfv cr wcel cA cX wcel cB cU cN cX nvabs.1 nvabs.6 nvcl
      3adant2 syl3anc mpbird eqbrtrd cU cnv wcel cA cX wcel cB cX wcel w3a cA
      cN cfv cB cN cfv cmin co cA c1 cneg cB cS co cG co cN cfv cle wbr cA cN
      cfv cA c1 cneg cB cS co cG co cN cfv cB cN cfv caddc co cle wbr cU cnv
      wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co cB cG co cN cfv
      cA cN cfv cA c1 cneg cB cS co cG co cN cfv cB cN cfv caddc co cle cU cnv
      wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co cB cG co cA cN
      cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co cB cG co
      cA c1 cneg cB cS co cB cG co cG co cA cU cn0v cfv cG co cA cU cnv wcel cA
      cX wcel c1 cneg cB cS co cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co
      cB cG co cA c1 cneg cB cS co cB cG co cG co wceq cU cnv wcel cA cX wcel
      cB cX wcel w3a cA c1 cneg cB cS co cB cU cG cX nvabs.1 nvabs.2 nvass cU
      cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel cB cX wcel
      w3a cA cX wcel c1 cneg cB cS co cX wcel cB cX wcel cU cnv wcel cA cX wcel
      cB cX wcel 3simp2 cU cnv wcel cB cX wcel c1 cneg cB cS co cX wcel cA cX
      wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel c1
      ax1cn negcli c1 cneg cB cS cU cX nvabs.1 nvabs.4 nvscl mp3an2 3adant2 cU
      cnv wcel cA cX wcel cB cX wcel 3simp3 3jca sylanc cU cnv wcel cA cX wcel
      cB cX wcel w3a c1 cneg cB cS co cB cG co cU cn0v cfv cA cG cU cnv wcel cB
      cX wcel c1 cneg cB cS co cB cG co cU cn0v cfv wceq cA cX wcel cB cS cU cG
      cX cU cn0v cfv nvabs.1 nvabs.2 nvabs.4 cU cn0v cfv eqid nvlinv 3adant2
      opreq2d cU cnv wcel cA cX wcel cA cU cn0v cfv cG co cA wceq cB cX wcel cA
      cU cG cX cU cn0v cfv nvabs.1 nvabs.2 cU cn0v cfv eqid nv0rid 3adant3
      3eqtrd fveq2d cU cnv wcel cA c1 cneg cB cS co cG co cX wcel cB cX wcel cA
      c1 cneg cB cS co cG co cB cG co cN cfv cA c1 cneg cB cS co cG co cN cfv
      cB cN cfv caddc co cle wbr cA cX wcel cA c1 cneg cB cS co cG co cB cU cG
      cN cX nvabs.1 nvabs.2 nvabs.6 nvtri cU cnv wcel cA cX wcel c1 cneg cB cS
      co cX wcel cA c1 cneg cB cS co cG co cX wcel cB cX wcel cA c1 cneg cB cS
      co cU cG cX nvabs.1 nvabs.2 nvgcl cU cnv wcel cB cX wcel c1 cneg cB cS co
      cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS
      co cX wcel c1 ax1cn negcli c1 cneg cB cS cU cX nvabs.1 nvabs.4 nvscl
      mp3an2 3adant2 syld3an3 syld3an2 eqbrtrrd cA cN cfv cr wcel cB cN cfv cr
      wcel cA c1 cneg cB cS co cG co cN cfv cr wcel cA cN cfv cB cN cfv cmin co
      cA c1 cneg cB cS co cG co cN cfv cle wbr cA cN cfv cA c1 cneg cB cS co cG
      co cN cfv cB cN cfv caddc co cle wbr wb cU cnv wcel cA cX wcel cB cX wcel
      w3a cA cN cfv cB cN cfv cA c1 cneg cB cS co cG co cN cfv lesubadd cU cnv
      wcel cA cX wcel cA cN cfv cr wcel cB cX wcel cA cU cN cX nvabs.1 nvabs.6
      nvcl 3adant3 cU cnv wcel cB cX wcel cB cN cfv cr wcel cA cX wcel cB cU cN
      cX nvabs.1 nvabs.6 nvcl 3adant2 cU cnv wcel cA c1 cneg cB cS co cG co cX
      wcel cA c1 cneg cB cS co cG co cN cfv cr wcel cU cnv wcel cA cX wcel cB
      cX wcel w3a cA c1 cneg cB cS co cG co cU cN cX nvabs.1 nvabs.6 nvcl cU
      cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel c1 cneg cB
      cS co cX wcel cA c1 cneg cB cS co cG co cX wcel cB cX wcel cA c1 cneg cB
      cS co cU cG cX nvabs.1 nvabs.2 nvgcl cU cnv wcel cB cX wcel c1 cneg cB cS
      co cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB
      cS co cX wcel c1 ax1cn negcli c1 cneg cB cS cU cX nvabs.1 nvabs.4 nvscl
      mp3an2 3adant2 syld3an3 sylanc syl3anc mpbird jca cA cN cfv cB cN cfv
      cmin co cr wcel cA c1 cneg cB cS co cG co cN cfv cr wcel cA cN cfv cB cN
      cfv cmin co cabs cfv cA c1 cneg cB cS co cG co cN cfv cle wbr cA c1 cneg
      cB cS co cG co cN cfv cneg cA cN cfv cB cN cfv cmin co cle wbr cA cN cfv
      cB cN cfv cmin co cA c1 cneg cB cS co cG co cN cfv cle wbr wa wb cU cnv
      wcel cA cX wcel cB cX wcel w3a cA cN cfv cB cN cfv cmin co cA c1 cneg cB
      cS co cG co cN cfv absle cA cN cfv cr wcel cB cN cfv cr wcel cA cN cfv cB
      cN cfv cmin co cr wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA cN cfv cB
      cN cfv resubcl cU cnv wcel cA cX wcel cA cN cfv cr wcel cB cX wcel cA cU
      cN cX nvabs.1 nvabs.6 nvcl 3adant3 cU cnv wcel cB cX wcel cB cN cfv cr
      wcel cA cX wcel cB cU cN cX nvabs.1 nvabs.6 nvcl 3adant2 sylanc cU cnv
      wcel cA c1 cneg cB cS co cG co cX wcel cA c1 cneg cB cS co cG co cN cfv
      cr wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co
      cU cN cX nvabs.1 nvabs.6 nvcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU
      cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1 cneg cB cS co cG co cX
      wcel cB cX wcel cA c1 cneg cB cS co cU cG cX nvabs.1 nvabs.2 nvgcl cU cnv
      wcel cB cX wcel c1 cneg cB cS co cX wcel cA cX wcel cU cnv wcel c1 cneg
      cc wcel cB cX wcel c1 cneg cB cS co cX wcel c1 ax1cn negcli c1 cneg cB cS
      cU cX nvabs.1 nvabs.4 nvscl mp3an2 3adant2 syld3an3 sylanc sylanc mpbird
      $.
      $( [7-Oct-2007] $) $( [4-Dec-2006] $)
  $}

  ${
    nvge0.1 $e |- X = ( BaseSet ` U ) $.
    nvge0.6 $e |- N = ( norm ` U ) $.
    $( The norm of a normed complex vector space is nonnegative.  Second part
       of Problem 2 of [Kreyszig] p. 64. $)
    nvge0 $p |- ( ( U e. NrmCVec /\ A e. X ) -> 0 <_ ( N ` A ) ) $=
      c2 cr wcel cA cN cfv cr wcel wa cc0 c2 clt wbr cc0 c2 cA cN cfv cmul co
      cle wbr wa cc0 cA cN cfv cle wbr cU cnv wcel cA cX wcel wa c2 cA cN cfv
      prodge0 cU cnv wcel cA cX wcel wa cA cN cfv cr wcel c2 cr wcel cA cU cN
      cX nvge0.1 nvge0.6 nvcl 2re jctil cU cnv wcel cA cX wcel wa cc0 c2 cA cN
      cfv cmul co cle wbr cc0 c2 clt wbr cU cnv wcel cA cX wcel wa cc0 cA cN
      cfv c1 cneg cA cU cns cfv co cN cfv caddc co c2 cA cN cfv cmul co cle cU
      cnv wcel cA cX wcel wa cc0 cA c1 cneg cA cU cns cfv co cU cpv cfv co cN
      cfv cA cN cfv c1 cneg cA cU cns cfv co cN cfv caddc co cle cU cnv wcel cA
      cX wcel wa cU cn0v cfv cN cfv cc0 cA c1 cneg cA cU cns cfv co cU cpv cfv
      co cN cfv cU cnv wcel cU cn0v cfv cN cfv cc0 wceq cA cX wcel cU cN cU
      cn0v cfv cU cn0v cfv eqid nvge0.6 nvz0 adantr cU cnv wcel cA cX wcel wa
      cU cn0v cfv cA c1 cneg cA cU cns cfv co cU cpv cfv co cN cU cnv wcel cA
      cX wcel wa cU cn0v cfv c1 c1 cneg caddc co cA cU cns cfv co c1 cA cU cns
      cfv co c1 cneg cA cU cns cfv co cU cpv cfv co cA c1 cneg cA cU cns cfv co
      cU cpv cfv co cU cnv wcel cA cX wcel wa cc0 cA cU cns cfv co cU cn0v cfv
      c1 c1 cneg caddc co cA cU cns cfv co cA cU cns cfv cU cX cU cn0v cfv
      nvge0.1 cU cns cfv eqid cU cn0v cfv eqid nv0 c1 c1 cneg caddc co cc0 cA
      cU cns cfv c1 ax1cn negidi opreq1i syl5req cU cnv wcel c1 cneg cc wcel cA
      cX wcel c1 c1 cneg caddc co cA cU cns cfv co c1 cA cU cns cfv co c1 cneg
      cA cU cns cfv co cU cpv cfv co wceq c1 ax1cn negcli cU cnv wcel c1 cc
      wcel c1 cneg cc wcel cA cX wcel c1 c1 cneg caddc co cA cU cns cfv co c1
      cA cU cns cfv co c1 cneg cA cU cns cfv co cU cpv cfv co wceq ax1cn c1 c1
      cneg cA cU cns cfv cU cU cpv cfv cX nvge0.1 cU cpv cfv eqid cU cns cfv
      eqid nvdir mp3anr1 mpanr1 cU cnv wcel cA cX wcel wa c1 cA cU cns cfv co
      cA c1 cneg cA cU cns cfv co cU cpv cfv cA cU cns cfv cU cX nvge0.1 cU cns
      cfv eqid nvsid opreq1d 3eqtrd fveq2d eqtr3d cU cnv wcel cA cX wcel c1
      cneg cA cU cns cfv co cX wcel cA c1 cneg cA cU cns cfv co cU cpv cfv co
      cN cfv cA cN cfv c1 cneg cA cU cns cfv co cN cfv caddc co cle wbr cU cnv
      wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cU cns cfv co cX wcel c1 ax1cn
      negcli c1 cneg cA cU cns cfv cU cX nvge0.1 cU cns cfv eqid nvscl mp3an2
      cA c1 cneg cA cU cns cfv co cU cU cpv cfv cN cX nvge0.1 cU cpv cfv eqid
      nvge0.6 nvtri mpd3an3 eqbrtrd cU cnv wcel cA cX wcel wa cA cN cfv c1 cneg
      cA cU cns cfv co cN cfv caddc co cA cN cfv cA cN cfv caddc co c2 cA cN
      cfv cmul co cU cnv wcel cA cX wcel wa c1 cneg cA cU cns cfv co cN cfv cA
      cN cfv cA cN cfv caddc cA cU cns cfv cU cN cX nvge0.1 cU cns cfv eqid
      nvge0.6 nvm1 opreq2d cU cnv wcel cA cX wcel wa cA cN cfv cc wcel c2 cA cN
      cfv cmul co cA cN cfv cA cN cfv caddc co wceq cU cnv wcel cA cX wcel wa
      cA cN cfv cA cU cN cX nvge0.1 nvge0.6 nvcl recnd cA cN cfv 2times syl
      eqtr4d breqtrd 2pos jctil sylanc $.
      $( [16-Oct-2007] $) $( [28-Nov-2006] $)
  $}

  ${
    nvgt0.1 $e |- X = ( BaseSet ` U ) $.
    nvgt0.5 $e |- Z = ( 0v ` U ) $.
    nvgt0.6 $e |- N = ( norm ` U ) $.
    $( A nonzero norm is positive. $)
    nvgt0 $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                   ( A =/= Z <-> 0 < ( N ` A ) ) ) $=
      cU cnv wcel cA cX wcel wa cA cN cfv cc0 wne cA cZ wne cc0 cA cN cfv clt
      wbr cU cnv wcel cA cX wcel wa cA cN cfv cc0 cA cZ cA cU cN cX cZ nvgt0.1
      nvgt0.5 nvgt0.6 nvz necon3bid cA cN cfv cr wcel cc0 cA cN cfv cle wbr cA
      cN cfv cc0 wne cc0 cA cN cfv clt wbr wb cU cnv wcel cA cX wcel wa cA cN
      cfv ne0gt0 cA cU cN cX nvgt0.1 nvgt0.6 nvcl cA cU cN cX nvgt0.1 nvgt0.6
      nvge0 sylanc bitr3d $.
      $( [9-Dec-2007] $) $( [20-Nov-2007] $)
  $}

  ${
    nv1.1 $e |- X = ( BaseSet ` U ) $.
    nv1.4 $e |- S = ( .s ` U ) $.
    nv1.5 $e |- Z = ( 0v ` U ) $.
    nv1.6 $e |- N = ( norm ` U ) $.
    $( From any nonzero vector, construct a vector whose norm is one. $)
    nv1 $p |- ( (  U e. NrmCVec /\ A e. X /\ A =/= Z ) ->
               ( N ` ( ( 1 / ( N ` A ) ) S A ) ) = 1 ) $=
      cU cnv wcel cA cX wcel cA cZ wne w3a c1 cA cN cfv cdiv co cA cS co cN cfv
      c1 cA cN cfv cdiv co cA cN cfv cmul co cA cN cfv c1 cA cN cfv cdiv co
      cmul co c1 cU cnv wcel c1 cA cN cfv cdiv co cr wcel cc0 c1 cA cN cfv cdiv
      co cle wbr wa cA cX wcel c1 cA cN cfv cdiv co cA cS co cN cfv c1 cA cN
      cfv cdiv co cA cN cfv cmul co wceq cU cnv wcel cA cX wcel cA cZ wne w3a
      c1 cA cN cfv cdiv co cA cS cU cN cX nv1.1 nv1.4 nv1.6 nvsge0 cU cnv wcel
      cA cX wcel cA cZ wne 3simp1 cU cnv wcel cA cX wcel cA cZ wne w3a c1 cA cN
      cfv cdiv co cr wcel cc0 c1 cA cN cfv cdiv co cle wbr cA cN cfv cr wcel cA
      cN cfv cc0 wne c1 cA cN cfv cdiv co cr wcel cU cnv wcel cA cX wcel cA cZ
      wne w3a cA cN cfv rereccl cU cnv wcel cA cX wcel cA cN cfv cr wcel cA cZ
      wne cA cU cN cX nv1.1 nv1.6 nvcl 3adant3 cU cnv wcel cA cX wcel cA cN cfv
      cc0 wne cA cZ wne cU cnv wcel cA cX wcel wa cA cN cfv cc0 cA cZ cA cU cN
      cX cZ nv1.1 nv1.5 nv1.6 nvz necon3bid biimp3ar sylanc cA cN cfv cr wcel
      cc0 cA cN cfv clt wbr cc0 c1 cA cN cfv cdiv co cle wbr cU cnv wcel cA cX
      wcel cA cZ wne w3a c1 cr wcel cc0 c1 cle wbr cA cN cfv cr wcel cc0 cA cN
      cfv clt wbr wa cc0 c1 cA cN cfv cdiv co cle wbr 1re cc0 c1 0re 1re lt01
      ltleii c1 cA cN cfv divge0 mpanl12 cU cnv wcel cA cX wcel cA cN cfv cr
      wcel cA cZ wne cA cU cN cX nv1.1 nv1.6 nvcl 3adant3 cU cnv wcel cA cX
      wcel cA cZ wne cc0 cA cN cfv clt wbr cA cU cN cX cZ nv1.1 nv1.5 nv1.6
      nvgt0 biimp3a sylanc jca cU cnv wcel cA cX wcel cA cZ wne 3simp2 syl3anc
      c1 cA cN cfv cdiv co cc wcel cA cN cfv cc wcel c1 cA cN cfv cdiv co cA cN
      cfv cmul co cA cN cfv c1 cA cN cfv cdiv co cmul co wceq cU cnv wcel cA cX
      wcel cA cZ wne w3a c1 cA cN cfv cdiv co cA cN cfv mulcom cU cnv wcel cA
      cX wcel cA cZ wne w3a c1 cA cN cfv cdiv co cA cN cfv cr wcel cA cN cfv
      cc0 wne c1 cA cN cfv cdiv co cr wcel cU cnv wcel cA cX wcel cA cZ wne w3a
      cA cN cfv rereccl cU cnv wcel cA cX wcel cA cN cfv cr wcel cA cZ wne cA
      cU cN cX nv1.1 nv1.6 nvcl 3adant3 cU cnv wcel cA cX wcel cA cN cfv cc0
      wne cA cZ wne cU cnv wcel cA cX wcel wa cA cN cfv cc0 cA cZ cA cU cN cX
      cZ nv1.1 nv1.5 nv1.6 nvz necon3bid biimp3ar sylanc recnd cU cnv wcel cA
      cX wcel cA cN cfv cc wcel cA cZ wne cU cnv wcel cA cX wcel wa cA cN cfv
      cA cU cN cX nv1.1 nv1.6 nvcl recnd 3adant3 sylanc cA cN cfv cc wcel cA cN
      cfv cc0 wne cA cN cfv c1 cA cN cfv cdiv co cmul co c1 wceq cU cnv wcel cA
      cX wcel cA cZ wne w3a cA cN cfv recid cU cnv wcel cA cX wcel cA cN cfv cc
      wcel cA cZ wne cU cnv wcel cA cX wcel wa cA cN cfv cA cU cN cX nv1.1
      nv1.6 nvcl recnd 3adant3 cU cnv wcel cA cX wcel cA cN cfv cc0 wne cA cZ
      wne cU cnv wcel cA cX wcel wa cA cN cfv cc0 cA cZ cA cU cN cX cZ nv1.1
      nv1.5 nv1.6 nvz necon3bid biimp3ar sylanc 3eqtrd $.
      $( [10-Dec-2007] $) $( [6-Dec-2007] $)
  $}

  ${
    nvop.2 $e |- G = ( +v ` U ) $.
    nvop.4 $e |- S = ( .s ` U ) $.
    nvop.6 $e |- N = ( norm ` U ) $.
    $( A complex inner product space in terms of ordered pair components. $)
    nvop $p |- ( U e. NrmCVec -> U = <. <. G , S >. , N >. ) $=
      cU cnv wcel cU cU c1st cfv cU c2nd cfv cop cG cS cop cN cop cnv wrel cU
      cnv wcel cU cU c1st cfv cU c2nd cfv cop wceq nvrel cU cnv 1st2nd mpan cU
      cnv wcel cU c1st cfv cN cop cG cS cop cN cop cU c1st cfv cU c2nd cfv cop
      cU cnv wcel cU c1st cfv cG cS cop cN cS cU cG cU c1st cfv cU c1st cfv
      eqid nvop.2 nvop.4 nvvop opeq1d cN cU c2nd cfv cU c1st cfv cU cN nvop.6
      nmfval opeq2i syl5eqr eqtrd $.
      $( [25-Feb-2008] $) $( [11-Sep-2007] $)
  $}

  $( MAY BE REVISED?  is this needed? $)
  $( The vector addition and scalar product operations are not identical. $)
  nvoprne $p |- ( <. <. G , S >. , N >. e. NrmCVec -> G =/= S ) $=
    cG cS cop cN cop cnv wcel cG cS cop cN cop c1st cfv cvc wcel cG cS wne cG
    cS cop cN cop cG cS cop cN cop c1st cfv cG cS cop cN cop c1st cfv eqid nvvc
    cG cS cop cN cop c1st cfv cvc wcel cG cS cop cvc wcel cG cS wne cG cS cop
    cN cop c1st cfv cG cS cop cvc cG cS cop cN cG cS opex op1st eleq1i cS cG
    vcoprne sylbi syl $.
    $( [19-Jul-2008] $) $( [31-May-2008] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Examples of normed complex vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    cnnv.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is a normed complex vector space.  The vector
       operation is ` + ` , the scalar product is ` x. ` , and the norm
       function is ` abs ` .  (Contributed by Steve Rodriguez, 3-Dec-2006.) $)
    cnnv $p |- U e. NrmCVec $=
      vx vy cmul cU caddc cabs cc cc0 caddc cc caddc cabl wcel caddc cgr wcel
      cnaddabl caddc ablgrp ax-mp cc cc cxp cc caddc axaddopr fdmi grprn cnid
      cnvc absf vx cv cc wcel vx cv cabs cfv cc0 wceq vx cv cc0 wceq vx cv
      abs00 biimpa vy cv vx cv absmul vx cv vy cv abstri cnnv.6 isnvi $.
      $( [12-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    cnnvg.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The vector addition (group) operation of the normed complex vector space
       of complex numbers. $)
    cnnvg $p |- + = ( +v ` U ) $=
      cU cpv cfv cU c1st cfv c1st cfv caddc cmul cop c1st cfv caddc cU cU cpv
      cfv cU cpv cfv eqid vafval cU c1st cfv caddc cmul cop c1st cU c1st cfv
      caddc cmul cop cabs cop c1st cfv caddc cmul cop cU caddc cmul cop cabs
      cop c1st cnnvg.6 fveq2i caddc cmul cop cabs caddc cmul opex op1st eqtri
      fveq2i caddc cmul addex op1st 3eqtrri $.
      $( [12-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    cnnvba.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The base set of the normed complex vector space of complex numbers. $)
    cnnvba $p |- CC = ( BaseSet ` U ) $=
      caddc crn cU cpv cfv crn cc cU cba cfv caddc cU cpv cfv cU cnnvba.6 cnnvg
      rneqi caddc cc caddc cabl wcel caddc cgr wcel cnaddabl caddc ablgrp ax-mp
      cc cc cxp cc caddc axaddopr fdmi grprn cU cU cpv cfv cU cba cfv cU cba
      cfv eqid cU cpv cfv eqid bafval 3eqtr4i $.
      $( [24-Jul-2008] $) $( [7-Nov-2007] $)
  $}

  $( Derive the associative law for complex number addition ~ axaddass to
     demonstrate the use of ~ cnnv , ~ cnnvg , and ~ cnnvba . $)
  cnnvdemo $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) -> ( ( A + B ) + C ) =
      ( A + ( B + C ) ) ) $=
    caddc cmul cop cabs cop cnv wcel cA cc wcel cB cc wcel cC cc wcel w3a cA cB
    caddc co cC caddc co cA cB cC caddc co caddc co wceq caddc cmul cop cabs
    cop caddc cmul cop cabs cop eqid cnnv cA cB cC caddc cmul cop cabs cop
    caddc cc caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cnnvba caddc
    cmul cop cabs cop caddc cmul cop cabs cop eqid cnnvg nvass mpan $.
    $( [12-Jan-2008] $) $( [12-Jan-2008] $)

  ${
    cnnvs.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The scalar product operation of the normed complex vector space of
       complex numbers. $)
    cnnvs $p |- x. = ( .s ` U ) $=
      cU cns cfv cU c1st cfv c2nd cfv caddc cmul cop c2nd cfv cmul cU cns cfv
      cU cU cns cfv eqid smfval cU c1st cfv caddc cmul cop c2nd cU c1st cfv
      caddc cmul cop cabs cop c1st cfv caddc cmul cop cU caddc cmul cop cabs
      cop c1st cnnvs.6 fveq2i caddc cmul cop cabs caddc cmul opex op1st eqtri
      fveq2i caddc cmul addex mulex op2nd 3eqtrri $.
      $( [13-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    cnnvnm.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The norm operation of the normed complex vector space of complex
       numbers. $)
    cnnvnm $p |- abs = ( norm ` U ) $=
      cU cnm cfv cU c2nd cfv caddc cmul cop cabs cop c2nd cfv cabs cU cU cnm
      cfv cU cnm cfv eqid nmfval cU caddc cmul cop cabs cop c2nd cnnvnm.6
      fveq2i caddc cmul cop cabs caddc cmul opex cc cr cabs wf cc cvv wcel cabs
      cvv wcel absf axcnex cc cr cvv cabs fex mp2an op2nd 3eqtrri $.
      $( [15-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    $d x y z U $.
    cnnvm.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The vector subtraction operation of the normed complex vector space
       of complex numbers. $)
    cnnvm $p |- - = ( -v ` U ) $=
      vx cv cc wcel vy cv cc wcel wa vz cv vx cv vy cv cmin co wceq wa vx vy vz
      copab2 vx cv cc wcel vy cv cc wcel wa vz cv vx cv c1 cneg vy cv cmul co
      caddc co wceq wa vx vy vz copab2 cmin cU cnsb cfv vx cv cc wcel vy cv cc
      wcel wa vz cv vx cv vy cv cmin co wceq wa vx cv cc wcel vy cv cc wcel wa
      vz cv vx cv c1 cneg vy cv cmul co caddc co wceq wa vx vy vz vx cv cc wcel
      vy cv cc wcel wa vz cv vx cv vy cv cmin co wceq vz cv vx cv c1 cneg vy cv
      cmul co caddc co wceq vx cv cc wcel vy cv cc wcel wa vx cv vy cv cmin co
      vx cv c1 cneg vy cv cmul co caddc co vz cv vx cv cc wcel vy cv cc wcel wa
      vx cv c1 cneg vy cv cmul co caddc co vx cv vy cv cneg caddc co vx cv vy
      cv cmin co vx cv cc wcel vy cv cc wcel wa c1 cneg vy cv cmul co vy cv
      cneg vx cv caddc vy cv cc wcel c1 cneg vy cv cmul co vy cv cneg wceq vx
      cv cc wcel vy cv mulm1 adantl opreq2d vx cv vy cv negsub eqtr2d eqeq2d
      pm5.32i oprabbii cmin cc cc cxp wfn cmin vx cv cc wcel vy cv cc wcel wa
      vz cv vx cv vy cv cmin co wceq wa vx vy vz copab2 wceq cc cc cxp cc cmin
      wf cmin cc cc cxp wfn subopr cc cc cxp cc cmin ffn ax-mp vx vy vz cc cc
      cmin fnoprv mpbi cU cnv wcel cU cnsb cfv vx cv cc wcel vy cv cc wcel wa
      vz cv vx cv c1 cneg vy cv cmul co caddc co wceq wa vx vy vz copab2 wceq
      cU cnnvm.6 cnnv vx vy vz cmul cU caddc cU cnsb cfv cc cU cnnvm.6 cnnvba
      cU cnnvm.6 cnnvg cU cnnvm.6 cnnvs cU cnsb cfv eqid nvmfval ax-mp 3eqtr4i
      $.
      $( [15-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    elimnv.1 $e |- X = ( BaseSet ` U ) $.
    elimnv.5 $e |- Z = ( 0v ` U ) $.
    elimnv.9 $e |- U e. NrmCVec $.
    $( Hypothesis elimination lemma for normed complex vector spaces to assist
       weak deduction theorem. $)
    elimnv $p |- if ( A e. X , A , Z ) e. X $=
      cA cZ cX cU cnv wcel cZ cX wcel elimnv.9 cU cX cZ elimnv.1 elimnv.5 nvzcl
      ax-mp elimel $.
      $( [1-Nov-2007] $) $( [16-May-2007] $)
  $}

  $( Hypothesis elimination lemma for normed complex vector spaces
     to assist weak deduction theorem. $)
  elimnvu $p |- if ( U e. NrmCVec , U , <. <. + , x. >. , abs >. )
                 e. NrmCVec $=
    cU caddc cmul cop cabs cop cnv caddc cmul cop cabs cop caddc cmul cop cabs
    cop eqid cnnv elimel $.
    $( [31-May-2007] $) $( [16-May-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Induced metric of a normed complex vector space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d d u M $.  $d d u N $.  $d d u U $.
    imsval.3 $e |- M = ( -v ` U ) $.
    imsval.6 $e |- N = ( norm ` U ) $.
    imsval.8 $e |- D = ( IndMet ` U ) $.
    $( Value of the induced metric of a normed complex vector space. $)
    imsval $p |- ( U e. NrmCVec -> D = ( N o. M ) ) $=
      cU cnv wcel cU cims cfv cN cM ccom cD vu vd cU vu cv cnm cfv vu cv cnsb
      cfv ccom cN cM ccom cnv cims vu cv cU wceq vu cv cnm cfv vu cv cnsb cfv
      ccom cN vu cv cnsb cfv ccom cN cM ccom vu cv cU wceq vu cv cnm cfv cN vu
      cv cnsb cfv vu cv cU wceq vu cv cnm cfv cU cnm cfv cN vu cv cU cnm fveq2
      imsval.6 syl6eqr coeq1d vu cv cU wceq vu cv cnsb cfv cM cN vu cv cU wceq
      vu cv cnsb cfv cU cnsb cfv cM vu cv cU cnsb fveq2 imsval.3 syl6eqr coeq2d
      eqtrd vu vd df-ims cN cM cN cU cnm cfv cvv imsval.6 cU cnm fvex eqeltri
      cM cU cnsb cfv cvv imsval.3 cU cnsb fvex eqeltri coex fvopab4 imsval.8
      syl5eq $.
      $( [12-Sep-2007] $) $( [11-Sep-2007] $)
  $}

  ${
    imsdval.1 $e |- X = ( BaseSet ` U ) $.
    imsdval.3 $e |- M = ( -v ` U ) $.
    imsdval.6 $e |- N = ( norm ` U ) $.
    imsdval.8 $e |- D = ( IndMet ` U ) $.
    $( Value of the induced metric (distance function) of a normed complex
       vector space.  Equation 1 of [Kreyszig] p. 59. $)
    imsdval $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( N ` ( A M B ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cop cD cfv cA cB cop cM cfv
      cN cfv cA cB cD co cA cB cM co cN cfv cU cnv wcel cA cX wcel cB cX wcel
      w3a cA cB cop cD cfv cA cB cop cN cM ccom cfv cA cB cop cM cfv cN cfv cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cop cD cN cM ccom cU cnv wcel cA
      cX wcel cD cN cM ccom wceq cB cX wcel cD cU cM cN imsdval.3 imsdval.6
      imsdval.8 imsval 3ad2ant1 fveq1d cN wfun cM wfun cA cB cop cM cdm wcel cA
      cB cop cN cM ccom cfv cA cB cop cM cfv cN cfv wceq cU cnv wcel cA cX wcel
      cB cX wcel w3a cA cB cop cN cM fvco cU cnv wcel cA cX wcel cN wfun cB cX
      wcel cU cnv wcel cX cr cN wf cN wfun cU cN cX imsdval.1 imsdval.6 nvf cX
      cr cN ffun syl 3ad2ant1 cU cnv wcel cA cX wcel cM wfun cB cX wcel cU cnv
      wcel cX cX cxp cX cM wf cM wfun cU cM cX imsdval.1 imsdval.3 nvmf cX cX
      cxp cX cM ffun syl 3ad2ant1 cU cnv wcel cA cX wcel cB cX wcel w3a cA cB
      cop cX cX cxp cM cdm cA cX wcel cB cX wcel cA cB cop cX cX cxp wcel cU
      cnv wcel cA cB cX cX opelxpi 3adant1 cU cnv wcel cA cX wcel cM cdm cX cX
      cxp wceq cB cX wcel cU cnv wcel cX cX cxp cX cM wf cM cdm cX cX cxp wceq
      cU cM cX imsdval.1 imsdval.3 nvmf cX cX cxp cX cM fdm syl 3ad2ant1
      eleqtrrd syl3anc eqtrd cA cB cD df-opr cA cB cM co cA cB cop cM cfv cN cA
      cB cM df-opr fveq2i 3eqtr4g $.
      $( [12-Sep-2007] $) $( [11-Sep-2007] $)
  $}

  ${
    imsdval2.1 $e |- X = ( BaseSet ` U ) $.
    imsdval2.2 $e |- G = ( +v ` U ) $.
    imsdval2.4 $e |- S = ( .s ` U ) $.
    imsdval2.6 $e |- N = ( norm ` U ) $.
    imsdval2.8 $e |- D = ( IndMet ` U ) $.
    $( MAY BE REVISED $)
    $( Value of the distance function of the induced metric of a normed
       complex vector space.  Equation 1 of [Kreyszig] p. 59. $)
    imsdval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( N ` ( A G ( -u 1 S B ) ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cD co cA cB cU cnsb cfv co cN
      cfv cA c1 cneg cB cS co cG co cN cfv cA cB cD cU cU cnsb cfv cN cX
      imsdval2.1 cU cnsb cfv eqid imsdval2.6 imsdval2.8 imsdval cU cnv wcel cA
      cX wcel cB cX wcel w3a cA cB cU cnsb cfv co cA c1 cneg cB cS co cG co cN
      cA cB cS cU cG cU cnsb cfv cX imsdval2.1 imsdval2.2 imsdval2.4 cU cnsb
      cfv eqid nvmval fveq2d eqtrd $.
      $( [11-Sep-2007] $) $( [28-Nov-2006] $)
  $}

  ${
    nvnd.1 $e |- X = ( BaseSet ` U ) $.
    nvnd.5 $e |- Z = ( 0v ` U ) $.
    nvnd.6 $e |- N = ( norm ` U ) $.
    nvnd.8 $e |- D = ( IndMet ` U ) $.
    $( The norm of a normed complex vector space expressed in terms of the
       distance function of its induced metric.  Problem 1 of [Kreyszig]
       p. 63. $)
    nvnd $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( N ` A ) = ( A D Z ) ) $=
      cU cnv wcel cA cX wcel wa cA cZ cD co cA cZ cU cnsb cfv co cN cfv cA cN
      cfv cU cnv wcel cA cX wcel cZ cX wcel cA cZ cD co cA cZ cU cnsb cfv co cN
      cfv wceq cU cnv wcel cZ cX wcel cA cX wcel cU cX cZ nvnd.1 nvnd.5 nvzcl
      adantr cA cZ cD cU cU cnsb cfv cN cX nvnd.1 cU cnsb cfv eqid nvnd.6
      nvnd.8 imsdval mpd3an3 cU cnv wcel cA cX wcel wa cA cZ cU cnsb cfv co cA
      cN cU cnv wcel cA cX wcel wa cA cZ cU cnsb cfv co cA c1 cneg cZ cU cns
      cfv co cU cpv cfv co cA cZ cU cpv cfv co cA cU cnv wcel cA cX wcel cZ cX
      wcel cA cZ cU cnsb cfv co cA c1 cneg cZ cU cns cfv co cU cpv cfv co wceq
      cU cnv wcel cZ cX wcel cA cX wcel cU cX cZ nvnd.1 nvnd.5 nvzcl adantr cA
      cZ cU cns cfv cU cU cpv cfv cU cnsb cfv cX nvnd.1 cU cpv cfv eqid cU cns
      cfv eqid cU cnsb cfv eqid nvmval mpd3an3 cU cnv wcel cA c1 cneg cZ cU cns
      cfv co cU cpv cfv co cA cZ cU cpv cfv co wceq cA cX wcel cU cnv wcel c1
      cneg cZ cU cns cfv co cZ cA cU cpv cfv cU cnv wcel c1 cneg cc wcel c1
      cneg cZ cU cns cfv co cZ wceq c1 ax1cn negcli c1 cneg cU cns cfv cU cZ cU
      cns cfv eqid nvnd.5 nvsz mpan2 opreq2d adantr cA cU cU cpv cfv cX cZ
      nvnd.1 cU cpv cfv eqid nvnd.5 nv0rid 3eqtrd fveq2d eqtr2d $.
      $( [6-Jan-2008] $) $( [4-Dec-2006] $)
  $}

  ${
    $d x y z U $.  $d x y z X $.
    imsdfn.1 $e |- X = ( BaseSet ` U ) $.
    imsdfn.8 $e |- D = ( IndMet ` U ) $.
    $( Mapping for the induced metric distance function of a normed complex
       vector space. $)
    imsdf $p |- ( U e. NrmCVec -> D : ( X X. X ) --> RR ) $=
      cU cnv wcel cX cX cxp cr cD wf cX cX cxp cr cU cnm cfv cU cnsb cfv ccom
      wf cX cr cU cnm cfv wf cX cX cxp cX cU cnsb cfv wf cX cX cxp cr cU cnm
      cfv cU cnsb cfv ccom wf cU cnv wcel cX cX cxp cX cr cU cnm cfv cU cnsb
      cfv fco cU cU cnm cfv cX imsdfn.1 cU cnm cfv eqid nvf cU cU cnsb cfv cX
      imsdfn.1 cU cnsb cfv eqid nvmf sylanc cU cnv wcel cX cX cxp cr cD cU cnm
      cfv cU cnsb cfv ccom cD cU cU cnsb cfv cU cnm cfv cU cnsb cfv eqid cU cnm
      cfv eqid imsdfn.8 imsval feq1d mpbird $.
      $( [30-Sep-2007] $) $( [29-Nov-2006] $)

    $( Base set of the induced metric space of a normed complex vector
      space. $)
    imsba $p |- ( U e. NrmCVec -> X = dom dom D ) $=
      cU cnv wcel cX cX cxp cr cD wf cD cdm cX cX cxp wceq cX cD cdm cdm wceq
      cD cU cX imsdfn.1 imsdfn.8 imsdf cX cX cxp cr cD fdm cD cdm cX cX cxp
      wceq cD cdm cdm cX cX cxp cdm cX cD cdm cX cX cxp dmeq cX dmxpid syl6req
      3syl $.
      $( [3-Oct-2007] $) $( [4-Sep-2007] $)

    ${
      imsbai.u $e |- U e. NrmCVec $.
      $( Base set of the induced metric space of a normed complex vector
        space. $)
      imsbai $p |- X = dom dom D $=
        cU cnv wcel cX cD cdm cdm wceq imsbai.u cD cU cX imsdfn.1 imsdfn.8
        imsba ax-mp $.
        $( [22-Dec-2007] $) $( [19-Dec-2007] $)
    $}
  $}

  ${
    $d x y z D $.  $d x y z X $.
    imsmetlem.1 $e |- X = ( BaseSet ` U ) $.
    imsmetlem.2 $e |- G = ( +v ` U ) $.
    imsmetlem.7 $e |- M = ( inv ` G ) $.
    imsmetlem.4 $e |- S = ( .s ` U ) $.
    imsmetlem.5 $e |- Z = ( 0v ` U ) $.
    imsmetlem.6 $e |- N = ( norm ` U ) $.
    imsmetlem.8 $e |- D = ( IndMet ` U ) $.
    imsmetlem.9 $e |- U e. NrmCVec $.
    $( Lemma for ~ imsmet . $)
    imsmetlem $p |- D e. Met $=
      vx vy vz cD cX cX cU cba cfv cvv imsmetlem.1 cU cba fvex eqeltri cU cnv
      wcel cX cX cxp cr cD wf imsmetlem.9 cD cU cX imsmetlem.1 imsmetlem.8
      imsdf ax-mp vx cv cX wcel vy cv cX wcel wa vx cv vy cv cD co cc0 wceq vx
      cv c1 cneg vy cv cS co cG co cN cfv cc0 wceq vx cv c1 cneg vy cv cS co cG
      co cZ wceq vx cv vy cv wceq vx cv cX wcel vy cv cX wcel wa vx cv vy cv cD
      co vx cv c1 cneg vy cv cS co cG co cN cfv cc0 cU cnv wcel vx cv cX wcel
      vy cv cX wcel vx cv vy cv cD co vx cv c1 cneg vy cv cS co cG co cN cfv
      wceq imsmetlem.9 vx cv vy cv cD cS cU cG cN cX imsmetlem.1 imsmetlem.2
      imsmetlem.4 imsmetlem.6 imsmetlem.8 imsdval2 mp3an1 eqeq1d vx cv cX wcel
      vy cv cX wcel wa vx cv c1 cneg vy cv cS co cG co cX wcel vx cv c1 cneg vy
      cv cS co cG co cN cfv cc0 wceq vx cv c1 cneg vy cv cS co cG co cZ wceq wb
      vx cv cX wcel c1 cneg vy cv cS co cX wcel vx cv c1 cneg vy cv cS co cG co
      cX wcel vy cv cX wcel cU cnv wcel vx cv cX wcel c1 cneg vy cv cS co cX
      wcel vx cv c1 cneg vy cv cS co cG co cX wcel imsmetlem.9 vx cv c1 cneg vy
      cv cS co cU cG cX imsmetlem.1 imsmetlem.2 nvgcl mp3an1 cU cnv wcel c1
      cneg cc wcel vy cv cX wcel c1 cneg vy cv cS co cX wcel imsmetlem.9 c1
      ax1cn negcli c1 cneg vy cv cS cU cX imsmetlem.1 imsmetlem.4 nvscl mp3an12
      sylan2 cU cnv wcel vx cv c1 cneg vy cv cS co cG co cX wcel vx cv c1 cneg
      vy cv cS co cG co cN cfv cc0 wceq vx cv c1 cneg vy cv cS co cG co cZ wceq
      wb imsmetlem.9 vx cv c1 cneg vy cv cS co cG co cU cN cX cZ imsmetlem.1
      imsmetlem.5 imsmetlem.6 nvz mpan syl vx cv cX wcel vy cv cX wcel wa vx cv
      c1 cneg vy cv cS co cG co vy cv cG co cZ vy cv cG co wceq vx cv c1 cneg
      vy cv cS co cG co cZ wceq vx cv vy cv wceq vx cv cX wcel vy cv cX wcel vx
      cv c1 cneg vy cv cS co cG co cX wcel vx cv c1 cneg vy cv cS co cG co vy
      cv cG co cZ vy cv cG co wceq vx cv c1 cneg vy cv cS co cG co cZ wceq wb
      vx cv cX wcel c1 cneg vy cv cS co cX wcel vx cv c1 cneg vy cv cS co cG co
      cX wcel vy cv cX wcel cU cnv wcel vx cv cX wcel c1 cneg vy cv cS co cX
      wcel vx cv c1 cneg vy cv cS co cG co cX wcel imsmetlem.9 vx cv c1 cneg vy
      cv cS co cU cG cX imsmetlem.1 imsmetlem.2 nvgcl mp3an1 cU cnv wcel c1
      cneg cc wcel vy cv cX wcel c1 cneg vy cv cS co cX wcel imsmetlem.9 c1
      ax1cn negcli c1 cneg vy cv cS cU cX imsmetlem.1 imsmetlem.4 nvscl mp3an12
      sylan2 vx cv c1 cneg vy cv cS co cG co cX wcel cZ cX wcel vy cv cX wcel
      vx cv c1 cneg vy cv cS co cG co vy cv cG co cZ vy cv cG co wceq vx cv c1
      cneg vy cv cS co cG co cZ wceq wb cU cnv wcel cZ cX wcel imsmetlem.9 cU
      cX cZ imsmetlem.1 imsmetlem.5 nvzcl ax-mp cU cnv wcel vx cv c1 cneg vy cv
      cS co cG co cX wcel cZ cX wcel vy cv cX wcel w3a vx cv c1 cneg vy cv cS
      co cG co vy cv cG co cZ vy cv cG co wceq vx cv c1 cneg vy cv cS co cG co
      cZ wceq wb imsmetlem.9 vx cv c1 cneg vy cv cS co cG co cZ vy cv cU cG cX
      imsmetlem.1 imsmetlem.2 nvrcan mpan mp3an2 sylancom vx cv cX wcel vy cv
      cX wcel wa vx cv c1 cneg vy cv cS co cG co vy cv cG co vx cv cZ vy cv cG
      co vy cv vx cv cX wcel vy cv cX wcel wa vx cv c1 cneg vy cv cS co cG co
      vy cv cG co vx cv c1 cneg vy cv cS co vy cv cG co cG co vx cv cZ cG co vx
      cv vx cv cX wcel c1 cneg vy cv cS co cX wcel vy cv cX wcel vx cv c1 cneg
      vy cv cS co cG co vy cv cG co vx cv c1 cneg vy cv cS co vy cv cG co cG co
      wceq vx cv cX wcel vy cv cX wcel wa cU cnv wcel vx cv cX wcel c1 cneg vy
      cv cS co cX wcel vy cv cX wcel w3a vx cv c1 cneg vy cv cS co cG co vy cv
      cG co vx cv c1 cneg vy cv cS co vy cv cG co cG co wceq imsmetlem.9 vx cv
      c1 cneg vy cv cS co vy cv cU cG cX imsmetlem.1 imsmetlem.2 nvass mpan vx
      cv cX wcel vy cv cX wcel pm3.26 vy cv cX wcel c1 cneg vy cv cS co cX wcel
      vx cv cX wcel cU cnv wcel c1 cneg cc wcel vy cv cX wcel c1 cneg vy cv cS
      co cX wcel imsmetlem.9 c1 ax1cn negcli c1 cneg vy cv cS cU cX imsmetlem.1
      imsmetlem.4 nvscl mp3an12 adantl vx cv cX wcel vy cv cX wcel pm3.27
      syl3anc vx cv cX wcel vy cv cX wcel wa c1 cneg vy cv cS co vy cv cG co cZ
      vx cv cG vy cv cX wcel c1 cneg vy cv cS co vy cv cG co cZ wceq vx cv cX
      wcel cU cnv wcel vy cv cX wcel c1 cneg vy cv cS co vy cv cG co cZ wceq
      imsmetlem.9 vy cv cS cU cG cX cZ imsmetlem.1 imsmetlem.2 imsmetlem.4
      imsmetlem.5 nvlinv mpan adantl opreq2d vx cv cX wcel vx cv cZ cG co vx cv
      wceq vy cv cX wcel cU cnv wcel vx cv cX wcel vx cv cZ cG co vx cv wceq
      imsmetlem.9 vx cv cU cG cX cZ imsmetlem.1 imsmetlem.2 imsmetlem.5 nv0rid
      mpan adantr 3eqtrd vy cv cX wcel cZ vy cv cG co vy cv wceq vx cv cX wcel
      cU cnv wcel vy cv cX wcel cZ vy cv cG co vy cv wceq imsmetlem.9 vy cv cU
      cG cX cZ imsmetlem.1 imsmetlem.2 imsmetlem.5 nv0lid mpan adantl eqeq12d
      bitr3d 3bitrd vz cv cX wcel vx cv cX wcel vy cv cX wcel vx cv vy cv cD co
      vz cv vx cv cD co vz cv vy cv cD co caddc co cle wbr vz cv cX wcel vx cv
      cX wcel vy cv cX wcel w3a vx cv c1 cneg vz cv cS co cG co vz cv c1 cneg
      vy cv cS co cG co cG co cN cfv vx cv c1 cneg vz cv cS co cG co cN cfv vz
      cv c1 cneg vy cv cS co cG co cN cfv caddc co vx cv vy cv cD co vz cv vx
      cv cD co vz cv vy cv cD co caddc co cle vx cv c1 cneg vz cv cS co cG co
      cX wcel vz cv c1 cneg vy cv cS co cG co cX wcel vx cv c1 cneg vz cv cS co
      cG co vz cv c1 cneg vy cv cS co cG co cG co cN cfv vx cv c1 cneg vz cv cS
      co cG co cN cfv vz cv c1 cneg vy cv cS co cG co cN cfv caddc co cle wbr
      vz cv cX wcel vx cv cX wcel vy cv cX wcel w3a cU cnv wcel vx cv c1 cneg
      vz cv cS co cG co cX wcel vz cv c1 cneg vy cv cS co cG co cX wcel vx cv
      c1 cneg vz cv cS co cG co vz cv c1 cneg vy cv cS co cG co cG co cN cfv vx
      cv c1 cneg vz cv cS co cG co cN cfv vz cv c1 cneg vy cv cS co cG co cN
      cfv caddc co cle wbr imsmetlem.9 vx cv c1 cneg vz cv cS co cG co vz cv c1
      cneg vy cv cS co cG co cU cG cN cX imsmetlem.1 imsmetlem.2 imsmetlem.6
      nvtri mp3an1 vz cv cX wcel vx cv cX wcel vx cv c1 cneg vz cv cS co cG co
      cX wcel vy cv cX wcel vx cv cX wcel c1 cneg vz cv cS co cX wcel vx cv c1
      cneg vz cv cS co cG co cX wcel vz cv cX wcel vx cv cX wcel wa cU cnv wcel
      vx cv cX wcel c1 cneg vz cv cS co cX wcel vx cv c1 cneg vz cv cS co cG co
      cX wcel imsmetlem.9 vx cv c1 cneg vz cv cS co cU cG cX imsmetlem.1
      imsmetlem.2 nvgcl mp3an1 vz cv cX wcel vx cv cX wcel pm3.27 vz cv cX wcel
      c1 cneg vz cv cS co cX wcel vx cv cX wcel cU cnv wcel c1 cneg cc wcel vz
      cv cX wcel c1 cneg vz cv cS co cX wcel imsmetlem.9 c1 ax1cn negcli c1
      cneg vz cv cS cU cX imsmetlem.1 imsmetlem.4 nvscl mp3an12 adantr sylanc
      3adant3 vz cv cX wcel vy cv cX wcel vz cv c1 cneg vy cv cS co cG co cX
      wcel vx cv cX wcel vz cv cX wcel c1 cneg vy cv cS co cX wcel vz cv c1
      cneg vy cv cS co cG co cX wcel vy cv cX wcel cU cnv wcel vz cv cX wcel c1
      cneg vy cv cS co cX wcel vz cv c1 cneg vy cv cS co cG co cX wcel
      imsmetlem.9 vz cv c1 cneg vy cv cS co cU cG cX imsmetlem.1 imsmetlem.2
      nvgcl mp3an1 cU cnv wcel c1 cneg cc wcel vy cv cX wcel c1 cneg vy cv cS
      co cX wcel imsmetlem.9 c1 ax1cn negcli c1 cneg vy cv cS cU cX imsmetlem.1
      imsmetlem.4 nvscl mp3an12 sylan2 3adant2 sylanc vz cv cX wcel vx cv cX
      wcel vy cv cX wcel w3a vx cv vy cv cD co vx cv c1 cneg vy cv cS co cG co
      cN cfv vx cv c1 cneg vz cv cS co cG co vz cv c1 cneg vy cv cS co cG co cG
      co cN cfv vx cv cX wcel vy cv cX wcel vx cv vy cv cD co vx cv c1 cneg vy
      cv cS co cG co cN cfv wceq vz cv cX wcel cU cnv wcel vx cv cX wcel vy cv
      cX wcel vx cv vy cv cD co vx cv c1 cneg vy cv cS co cG co cN cfv wceq
      imsmetlem.9 vx cv vy cv cD cS cU cG cN cX imsmetlem.1 imsmetlem.2
      imsmetlem.4 imsmetlem.6 imsmetlem.8 imsdval2 mp3an1 3adant1 vz cv cX wcel
      vx cv cX wcel vy cv cX wcel w3a vx cv c1 cneg vz cv cS co cG co vz cv c1
      cneg vy cv cS co cG co cG co vx cv c1 cneg vy cv cS co cG co cN vz cv cX
      wcel vx cv cX wcel vy cv cX wcel w3a vx cv c1 cneg vz cv cS co cG co vz
      cv cG co c1 cneg vy cv cS co cG co vx cv c1 cneg vz cv cS co cG co vz cv
      c1 cneg vy cv cS co cG co cG co vx cv c1 cneg vy cv cS co cG co vx cv c1
      cneg vz cv cS co cG co cX wcel vz cv cX wcel c1 cneg vy cv cS co cX wcel
      vx cv c1 cneg vz cv cS co cG co vz cv cG co c1 cneg vy cv cS co cG co vx
      cv c1 cneg vz cv cS co cG co vz cv c1 cneg vy cv cS co cG co cG co wceq
      vz cv cX wcel vx cv cX wcel vy cv cX wcel w3a cU cnv wcel vx cv c1 cneg
      vz cv cS co cG co cX wcel vz cv cX wcel c1 cneg vy cv cS co cX wcel w3a
      vx cv c1 cneg vz cv cS co cG co vz cv cG co c1 cneg vy cv cS co cG co vx
      cv c1 cneg vz cv cS co cG co vz cv c1 cneg vy cv cS co cG co cG co wceq
      imsmetlem.9 vx cv c1 cneg vz cv cS co cG co vz cv c1 cneg vy cv cS co cU
      cG cX imsmetlem.1 imsmetlem.2 nvass mpan vz cv cX wcel vx cv cX wcel vx
      cv c1 cneg vz cv cS co cG co cX wcel vy cv cX wcel vx cv cX wcel c1 cneg
      vz cv cS co cX wcel vx cv c1 cneg vz cv cS co cG co cX wcel vz cv cX wcel
      vx cv cX wcel wa cU cnv wcel vx cv cX wcel c1 cneg vz cv cS co cX wcel vx
      cv c1 cneg vz cv cS co cG co cX wcel imsmetlem.9 vx cv c1 cneg vz cv cS
      co cU cG cX imsmetlem.1 imsmetlem.2 nvgcl mp3an1 vz cv cX wcel vx cv cX
      wcel pm3.27 vz cv cX wcel c1 cneg vz cv cS co cX wcel vx cv cX wcel cU
      cnv wcel c1 cneg cc wcel vz cv cX wcel c1 cneg vz cv cS co cX wcel
      imsmetlem.9 c1 ax1cn negcli c1 cneg vz cv cS cU cX imsmetlem.1
      imsmetlem.4 nvscl mp3an12 adantr sylanc 3adant3 vz cv cX wcel vx cv cX
      wcel vy cv cX wcel 3simp1 vy cv cX wcel vz cv cX wcel c1 cneg vy cv cS co
      cX wcel vx cv cX wcel cU cnv wcel c1 cneg cc wcel vy cv cX wcel c1 cneg
      vy cv cS co cX wcel imsmetlem.9 c1 ax1cn negcli c1 cneg vy cv cS cU cX
      imsmetlem.1 imsmetlem.4 nvscl mp3an12 3ad2ant3 syl3anc vz cv cX wcel vx
      cv cX wcel vy cv cX wcel w3a vx cv c1 cneg vz cv cS co cG co vz cv cG co
      vx cv c1 cneg vy cv cS co cG vz cv cX wcel vx cv cX wcel vx cv c1 cneg vz
      cv cS co cG co vz cv cG co vx cv wceq vy cv cX wcel vz cv cX wcel vx cv
      cX wcel wa vx cv c1 cneg vz cv cS co cG co vz cv cG co vx cv c1 cneg vz
      cv cS co vz cv cG co cG co vx cv cZ cG co vx cv vx cv cX wcel c1 cneg vz
      cv cS co cX wcel vz cv cX wcel vx cv c1 cneg vz cv cS co cG co vz cv cG
      co vx cv c1 cneg vz cv cS co vz cv cG co cG co wceq vz cv cX wcel vx cv
      cX wcel wa cU cnv wcel vx cv cX wcel c1 cneg vz cv cS co cX wcel vz cv cX
      wcel w3a vx cv c1 cneg vz cv cS co cG co vz cv cG co vx cv c1 cneg vz cv
      cS co vz cv cG co cG co wceq imsmetlem.9 vx cv c1 cneg vz cv cS co vz cv
      cU cG cX imsmetlem.1 imsmetlem.2 nvass mpan vz cv cX wcel vx cv cX wcel
      pm3.27 vz cv cX wcel c1 cneg vz cv cS co cX wcel vx cv cX wcel cU cnv
      wcel c1 cneg cc wcel vz cv cX wcel c1 cneg vz cv cS co cX wcel
      imsmetlem.9 c1 ax1cn negcli c1 cneg vz cv cS cU cX imsmetlem.1
      imsmetlem.4 nvscl mp3an12 adantr vz cv cX wcel vx cv cX wcel pm3.26
      syl3anc vz cv cX wcel vx cv cX wcel wa c1 cneg vz cv cS co vz cv cG co cZ
      vx cv cG vz cv cX wcel c1 cneg vz cv cS co vz cv cG co cZ wceq vx cv cX
      wcel cU cnv wcel vz cv cX wcel c1 cneg vz cv cS co vz cv cG co cZ wceq
      imsmetlem.9 vz cv cS cU cG cX cZ imsmetlem.1 imsmetlem.2 imsmetlem.4
      imsmetlem.5 nvlinv mpan adantr opreq2d vx cv cX wcel vx cv cZ cG co vx cv
      wceq vz cv cX wcel cU cnv wcel vx cv cX wcel vx cv cZ cG co vx cv wceq
      imsmetlem.9 vx cv cU cG cX cZ imsmetlem.1 imsmetlem.2 imsmetlem.5 nv0rid
      mpan adantl 3eqtrd 3adant3 opreq1d eqtr3d fveq2d eqtr4d vz cv cX wcel vx
      cv cX wcel vy cv cX wcel w3a vz cv vx cv cD co vx cv c1 cneg vz cv cS co
      cG co cN cfv vz cv vy cv cD co vz cv c1 cneg vy cv cS co cG co cN cfv
      caddc vz cv cX wcel vx cv cX wcel vz cv vx cv cD co vx cv c1 cneg vz cv
      cS co cG co cN cfv wceq vy cv cX wcel vz cv cX wcel vx cv cX wcel wa vz
      cv vx cv cD co vz cv c1 cneg vx cv cS co cG co cN cfv vx cv c1 cneg vz cv
      cS co cG co cN cfv cU cnv wcel vz cv cX wcel vx cv cX wcel vz cv vx cv cD
      co vz cv c1 cneg vx cv cS co cG co cN cfv wceq imsmetlem.9 vz cv vx cv cD
      cS cU cG cN cX imsmetlem.1 imsmetlem.2 imsmetlem.4 imsmetlem.6
      imsmetlem.8 imsdval2 mp3an1 cU cnv wcel vz cv cX wcel vx cv cX wcel vz cv
      c1 cneg vx cv cS co cG co cN cfv vx cv c1 cneg vz cv cS co cG co cN cfv
      wceq imsmetlem.9 vz cv vx cv cS cU cG cN cX imsmetlem.1 imsmetlem.2
      imsmetlem.4 imsmetlem.6 nvdif mp3an1 eqtrd 3adant3 vz cv cX wcel vy cv cX
      wcel vz cv vy cv cD co vz cv c1 cneg vy cv cS co cG co cN cfv wceq vx cv
      cX wcel cU cnv wcel vz cv cX wcel vy cv cX wcel vz cv vy cv cD co vz cv
      c1 cneg vy cv cS co cG co cN cfv wceq imsmetlem.9 vz cv vy cv cD cS cU cG
      cN cX imsmetlem.1 imsmetlem.2 imsmetlem.4 imsmetlem.6 imsmetlem.8
      imsdval2 mp3an1 3adant2 opreq12d 3brtr4d 3coml ismeti $.
      $( [2-Oct-2007] $) $( [29-Nov-2006] $)
  $}

  ${
    imsmet.8 $e |- D = ( IndMet ` U ) $.
    $( The induced metric of a normed complex vector space is a metric space.
       Part of Definition 2.2-1 of [Kreyszig] p. 58. $)
    imsmet $p |- ( U e. NrmCVec -> D e. Met ) $=
      cU cnv wcel cU cims cfv cme cD cU cnv wcel cU cims cfv cme wcel cU cnv
      wcel cU caddc cmul cop cabs cop cif cims cfv cme wcel cU caddc cmul cop
      cabs cop cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cU cims cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv cme cU cU cnv wcel cU
      caddc cmul cop cabs cop cif cims fveq2 eleq1d cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv cU cnv wcel cU caddc cmul cop cabs cop cif cns
      cfv cU cnv wcel cU caddc cmul cop cabs cop cif cU cnv wcel cU caddc cmul
      cop cabs cop cif cpv cfv cU cnv wcel cU caddc cmul cop cabs cop cif cpv
      cfv cgn cfv cU cnv wcel cU caddc cmul cop cabs cop cif cnm cfv cU cnv
      wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cn0v cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      eqid cU cnv wcel cU caddc cmul cop cabs cop cif cpv cfv eqid cU cnv wcel
      cU caddc cmul cop cabs cop cif cpv cfv cgn cfv eqid cU cnv wcel cU caddc
      cmul cop cabs cop cif cns cfv eqid cU cnv wcel cU caddc cmul cop cabs cop
      cif cn0v cfv eqid cU cnv wcel cU caddc cmul cop cabs cop cif cnm cfv eqid
      cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv eqid cU elimnvu
      imsmetlem dedth imsmet.8 syl5eqel $.
      $( [2-Oct-2007] $) $( [4-Dec-2006] $)
  $}

  ${
    nvelbl.1 $e |- X = ( BaseSet ` U ) $.
    nvelbl.3 $e |- M = ( -v ` U ) $.
    nvelbl.6 $e |- N = ( norm ` U ) $.
    nvelbl.8 $e |- D = ( IndMet ` U ) $.
    $( Membership of a vector in a ball. $)
    nvelbl $p |- ( ( ( U e. NrmCVec /\ P e. X /\ A e. X ) /\ ( R e. RR /\
      0 < R ) ) -> ( A e. ( P ( ball ` D ) R ) <-> ( N ` ( A M P ) ) < R ) ) $=
      cU cnv wcel cP cX wcel cA cX wcel w3a cR cr wcel cc0 cR clt wbr wa wa cA
      cP cR cD cbl cfv co wcel cA cP cD co cR clt wbr cA cP cM co cN cfv cR clt
      wbr cD cme wcel cP cD cdm cdm wcel cA cD cdm cdm wcel w3a cR cr wcel cc0
      cR clt wbr wa cA cP cR cD cbl cfv co wcel cA cP cD co cR clt wbr wb cU
      cnv wcel cP cX wcel cA cX wcel w3a cA cD cP cR cD cdm cdm cD cdm cdm eqid
      elbl3 cU cnv wcel cP cX wcel cA cX wcel w3a cD cme wcel cP cD cdm cdm
      wcel cA cD cdm cdm wcel cU cnv wcel cP cX wcel cD cme wcel cA cX wcel cD
      cU nvelbl.8 imsmet 3ad2ant1 cU cnv wcel cP cX wcel cP cD cdm cdm wcel cA
      cX wcel cU cnv wcel cP cX wcel cP cD cdm cdm wcel cU cnv wcel cX cD cdm
      cdm cP cD cU cX nvelbl.1 nvelbl.8 imsba eleq2d biimpa 3adant3 cU cnv wcel
      cA cX wcel cA cD cdm cdm wcel cP cX wcel cU cnv wcel cA cX wcel cA cD cdm
      cdm wcel cU cnv wcel cX cD cdm cdm cA cD cU cX nvelbl.1 nvelbl.8 imsba
      eleq2d biimpa 3adant2 3jca sylan cU cnv wcel cP cX wcel cA cX wcel w3a cA
      cP cD co cR clt wbr cA cP cM co cN cfv cR clt wbr wb cR cr wcel cc0 cR
      clt wbr wa cU cnv wcel cP cX wcel cA cX wcel w3a cA cP cD co cA cP cM co
      cN cfv cR clt cU cnv wcel cA cX wcel cP cX wcel cA cP cD co cA cP cM co
      cN cfv wceq cA cP cD cU cM cN cX nvelbl.1 nvelbl.3 nvelbl.6 nvelbl.8
      imsdval 3com23 breq1d adantr bitrd $.
      $( [27-Dec-2007] $) $( [27-Dec-2007] $)
  $}

  ${
    nvelbl2.1 $e |- X = ( BaseSet ` U ) $.
    nvelbl2.2 $e |- G = ( +v ` U ) $.
    nvelbl2.6 $e |- N = ( norm ` U ) $.
    nvelbl2.8 $e |- D = ( IndMet ` U ) $.
    $( Membership of an off-center vector in a ball. $)
    nvelbl2 $p |- ( ( ( U e. NrmCVec /\ P e. X /\ A e. X ) /\ ( R e. RR /\
      0 < R ) ) -> ( ( P G A ) e. ( P ( ball ` D ) R ) <-> ( N ` A ) < R ) ) $=
      cU cnv wcel cP cX wcel cA cX wcel w3a cR cr wcel cc0 cR clt wbr wa wa cP
      cA cG co cP cR cD cbl cfv co wcel cP cA cG co cP cU cnsb cfv co cN cfv cR
      clt wbr cA cN cfv cR clt wbr cU cnv wcel cP cX wcel cP cA cG co cX wcel
      w3a cR cr wcel cc0 cR clt wbr wa cP cA cG co cP cR cD cbl cfv co wcel cP
      cA cG co cP cU cnsb cfv co cN cfv cR clt wbr wb cU cnv wcel cP cX wcel cA
      cX wcel w3a cP cA cG co cD cP cR cU cU cnsb cfv cN cX nvelbl2.1 cU cnsb
      cfv eqid nvelbl2.6 nvelbl2.8 nvelbl cU cnv wcel cP cX wcel cP cA cG co cX
      wcel cU cnv wcel cP cX wcel cP cA cG co cX wcel w3a cA cX wcel cU cnv
      wcel cP cX wcel cP cA cG co cX wcel w3a id cP cA cU cG cX nvelbl2.1
      nvelbl2.2 nvgcl syld3an3 sylan cU cnv wcel cP cX wcel cA cX wcel w3a cP
      cA cG co cP cU cnsb cfv co cN cfv cR clt wbr cA cN cfv cR clt wbr wb cR
      cr wcel cc0 cR clt wbr wa cU cnv wcel cP cX wcel cA cX wcel w3a cP cA cG
      co cP cU cnsb cfv co cN cfv cA cN cfv cR clt cU cnv wcel cP cX wcel cA cX
      wcel w3a cP cA cG co cP cU cnsb cfv co cA cN cP cA cU cG cU cnsb cfv cX
      nvelbl2.1 nvelbl2.2 cU cnsb cfv eqid nvpncan2 fveq2d breq1d adantr bitrd
      $.
      $( [9-Jan-2008] $) $( [27-Dec-2007] $)
  $}

  ${
    nvcnf.1 $e |- X = ( BaseSet ` U ) $.
    nvcnf.2 $e |- Y = ( BaseSet ` W ) $.
    nvcnf.8 $e |- C = ( IndMet ` U ) $.
    nvcnf.d $e |- D = ( IndMet ` W ) $.
    nvcnf.3 $e |- J = ( Open ` C ) $.
    nvcnf.4 $e |- K = ( Open ` D ) $.
    $( MAY BE REVISED - not used? $)
    $( A continuous function is an operation (normed complex vector space
       version of ~ cnf ). $)
    nvcnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\
                F e. ( J Cn K ) ) -> F : X --> Y ) $=
      cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cX cY cF wf cC cdm cdm
      cD cdm cdm cF wf cC cme wcel cD cme wcel cF cJ cK ccn co wcel cC cdm cdm
      cD cdm cdm cF wf cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel cC cD cF cJ
      cK cC cdm cdm cD cdm cdm cC cdm cdm eqid cD cdm cdm eqid nvcnf.3 nvcnf.4
      metcnf cC cU nvcnf.8 imsmet cD cW nvcnf.d imsmet cF cJ cK ccn co wcel id
      syl3an cU cnv wcel cW cnv wcel cX cY cF wf cC cdm cdm cD cdm cdm cF wf wb
      cF cJ cK ccn co wcel cU cnv wcel cX cY cF wf cC cdm cdm cY cF wf cW cnv
      wcel cC cdm cdm cD cdm cdm cF wf cU cnv wcel cX cC cdm cdm wceq cX cY cF
      wf cC cdm cdm cY cF wf wb cC cU cX nvcnf.1 nvcnf.8 imsba cX cC cdm cdm cY
      cF feq2 syl cW cnv wcel cY cD cdm cdm wceq cC cdm cdm cY cF wf cC cdm cdm
      cD cdm cdm cF wf wb cD cW cY nvcnf.2 nvcnf.d imsba cY cD cdm cdm cC cdm
      cdm cF feq3 syl sylan9bb 3adant3 mpbird $.
      $( [30-Jan-2008] $) $( [13-Dec-2007] $)

    $( MAY BE REVISED - delete this if not used? $)
    $( A continuous function is an operation (normed complex vector space
       version of ~ cnpf ). $)
    nvcnpf $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ P e. X ) /\
                F e. ( ( J CnP K ) ` P ) ) -> F : X --> Y ) $=
      cU cnv wcel cW cnv wcel cP cX wcel w3a cF cP cJ cK ccnp co cfv wcel wa cX
      cY cF wf cC cdm cdm cD cdm cdm cF wf cC cme wcel cD cme wcel cP cC cdm
      cdm wcel w3a cF cP cJ cK ccnp co cfv wcel cC cdm cdm cD cdm cdm cF wf cU
      cnv wcel cW cnv wcel cP cX wcel w3a cC cD cP cF cJ cK cC cdm cdm cD cdm
      cdm cC cdm cdm eqid cD cdm cdm eqid nvcnf.3 nvcnf.4 metcnpf cU cnv wcel
      cW cnv wcel cP cX wcel w3a cC cme wcel cD cme wcel cP cC cdm cdm wcel cU
      cnv wcel cW cnv wcel cC cme wcel cP cX wcel cC cU nvcnf.8 imsmet 3ad2ant1
      cW cnv wcel cU cnv wcel cD cme wcel cP cX wcel cD cW nvcnf.d imsmet
      3ad2ant2 cU cnv wcel cP cX wcel cP cC cdm cdm wcel cW cnv wcel cU cnv
      wcel cP cX wcel cP cC cdm cdm wcel cU cnv wcel cX cC cdm cdm cP cC cU cX
      nvcnf.1 nvcnf.8 imsba eleq2d biimpa 3adant2 3jca sylan cU cnv wcel cW cnv
      wcel cP cX wcel w3a cX cY cF wf cC cdm cdm cD cdm cdm cF wf wb cF cP cJ
      cK ccnp co cfv wcel cU cnv wcel cW cnv wcel cX cY cF wf cC cdm cdm cD cdm
      cdm cF wf wb cP cX wcel cU cnv wcel cX cY cF wf cC cdm cdm cY cF wf cW
      cnv wcel cC cdm cdm cD cdm cdm cF wf cU cnv wcel cX cC cdm cdm wceq cX cY
      cF wf cC cdm cdm cY cF wf wb cC cU cX nvcnf.1 nvcnf.8 imsba cX cC cdm cdm
      cY cF feq2 syl cW cnv wcel cY cD cdm cdm wceq cC cdm cdm cY cF wf cC cdm
      cdm cD cdm cdm cF wf wb cD cW cY nvcnf.2 nvcnf.d imsba cY cD cdm cdm cC
      cdm cdm cF feq3 syl sylan9bb 3adant3 adantr mpbird $.
      $( [20-Jul-2008] $) $( [16-Dec-2007] $)
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y D $.  $d x y F $.  $d x y J $.
    $d x y K $.  $d x y P $.  $d x y U $.  $d x y W $.  $d x y X $.
    nvcni.1 $e |- X = ( BaseSet ` U ) $.
    nvcni.m $e |- M = ( norm ` U ) $.
    nvcni.n $e |- N = ( norm ` W ) $.
    nvcni.r $e |- R = ( -v ` U ) $.
    nvcni.s $e |- S = ( -v ` W ) $.
    nvcni.8 $e |- C = ( IndMet ` U ) $.
    nvcni.d $e |- D = ( IndMet ` W ) $.
    nvcni.j $e |- J = ( Open ` C ) $.
    nvcni.k $e |- K = ( Open ` D ) $.
    $( MAY BE REVISED - delete this if not used $)
    $( Epsilon-delta property of a continuous operator.  (Normed complex vector
       space version of ~ metcni .) $)
    nvcni $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ F e. ( J Cn K ) ) /\
        ( P e. X /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\ A. y e. X
      ( ( M ` ( P R y ) ) < x -> ( N ` ( ( F ` P ) S ( F ` y ) ) ) < A ) ) ) $=
      cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel
      cc0 cA clt wbr w3a wa cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP
      cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex cc0 vx
      cv clt wbr cP vy cv cR co cM cfv vx cv clt wbr cP cF cfv vy cv cF cfv cS
      co cN cfv cA clt wbr wi vy cX wral wa vx cr wrex cU cnv wcel cW cnv wcel
      cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx
      cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA
      clt wbr wi vy cX wral wa vx cr wrex cU cnv wcel cW cnv wcel cF cJ cK ccn
      co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt wbr cP
      vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy
      cX wral wa vx cr wrex wi cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr w3a
      cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD
      co cA clt wbr wi vy cC cdm cdm wral wa vx cr wrex wi cC cme wcel cD cme
      wcel cF cJ cK ccn co wcel cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr
      w3a cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
      cD co cA clt wbr wi vy cC cdm cdm wral wa vx cr wrex wi cU cnv wcel cW
      cnv wcel cF cJ cK ccn co wcel cC cme wcel cD cme wcel cF cJ cK ccn co
      wcel w3a cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt
      wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr
      wi vy cC cdm cdm wral wa vx cr wrex vx vy cA cC cD cP cF cJ cK cC cdm cdm
      cD cdm cdm cC cdm cdm eqid nvcni.j cD cdm cdm eqid nvcni.k metcni ex cC
      cU nvcni.8 imsmet cD cW nvcni.d imsmet cF cJ cK ccn co wcel id syl3an cU
      cnv wcel cW cnv wcel cP cX wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv
      clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt
      wbr wi vy cX wral wa vx cr wrex wi cP cC cdm cdm wcel cA cr wcel cc0 cA
      clt wbr w3a cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy
      cv cF cfv cD co cA clt wbr wi vy cC cdm cdm wral wa vx cr wrex wi wb cF
      cJ cK ccn co wcel cU cnv wcel cP cX wcel cA cr wcel cc0 cA clt wbr w3a cP
      cC cdm cdm wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt wbr cP vy cv
      cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral
      wa vx cr wrex cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy
      cv cF cfv cD co cA clt wbr wi vy cC cdm cdm wral wa vx cr wrex cU cnv
      wcel cP cX wcel cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr cU cnv wcel
      cX cC cdm cdm cP cC cU cX nvcni.1 nvcni.8 imsba eleq2d 3anbi1d cU cnv
      wcel cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF
      cfv cD co cA clt wbr wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co vx
      cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cC cdm cdm wral
      wa vx cr cU cnv wcel cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
      cD co cA clt wbr wi vy cX wral cP vy cv cC co vx cv clt wbr cP cF cfv vy
      cv cF cfv cD co cA clt wbr wi vy cC cdm cdm wral cc0 vx cv clt wbr cU cnv
      wcel cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr
      wi vy cX cC cdm cdm cC cU cX nvcni.1 nvcni.8 imsba raleq1d anbi2d rexbidv
      imbi12d 3ad2ant1 mpbird imp cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel
      w3a cA cr wcel cP cX wcel cc0 vx cv clt wbr cP vy cv cC co vx cv clt wbr
      cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr wrex cc0
      vx cv clt wbr cP vy cv cR co cM cfv vx cv clt wbr cP cF cfv vy cv cF cfv
      cS co cN cfv cA clt wbr wi vy cX wral wa vx cr wrex wb cc0 cA clt wbr cU
      cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cP cX wcel cc0 vx cv clt
      wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr
      wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv
      clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa
      vx cr wrex wb cU cnv wcel cW cnv wcel cX cW cba cfv cF wf cP cX wcel cc0
      vx cv clt wbr cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co
      cA clt wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cR co
      cM cfv vx cv clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy
      cX wral wa vx cr wrex wb wi cF cJ cK ccn co wcel cU cnv wcel cW cnv wcel
      cX cW cba cfv cF wf w3a cP cX wcel cc0 vx cv clt wbr cP vy cv cC co vx cv
      clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral wa vx cr
      wrex cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv clt wbr cP cF cfv vy
      cv cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa vx cr wrex wb cU cnv
      wcel cW cnv wcel cX cW cba cfv cF wf w3a cP cX wcel wa cc0 vx cv clt wbr
      cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi
      vy cX wral wa cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv clt wbr cP cF
      cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa vx cr cU cnv
      wcel cW cnv wcel cX cW cba cfv cF wf w3a cP cX wcel wa cP vy cv cC co vx
      cv clt wbr cP cF cfv vy cv cF cfv cD co cA clt wbr wi vy cX wral cP vy cv
      cR co cM cfv vx cv clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr
      wi vy cX wral cc0 vx cv clt wbr cU cnv wcel cW cnv wcel cX cW cba cfv cF
      wf w3a cP cX wcel wa cP vy cv cC co vx cv clt wbr cP cF cfv vy cv cF cfv
      cD co cA clt wbr wi cP vy cv cR co cM cfv vx cv clt wbr cP cF cfv vy cv
      cF cfv cS co cN cfv cA clt wbr wi vy cX cU cnv wcel cW cnv wcel cX cW cba
      cfv cF wf w3a cP cX wcel vy cv cX wcel cP vy cv cC co vx cv clt wbr cP cF
      cfv vy cv cF cfv cD co cA clt wbr wi cP vy cv cR co cM cfv vx cv clt wbr
      cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi wb cU cnv wcel cW cnv
      wcel cX cW cba cfv cF wf w3a cP cX wcel vy cv cX wcel wa wa cP vy cv cC
      co vx cv clt wbr cP vy cv cR co cM cfv vx cv clt wbr cP cF cfv vy cv cF
      cfv cD co cA clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr cU
      cnv wcel cW cnv wcel cP cX wcel vy cv cX wcel wa cP vy cv cC co vx cv clt
      wbr cP vy cv cR co cM cfv vx cv clt wbr wb cX cW cba cfv cF wf cU cnv
      wcel cP cX wcel vy cv cX wcel wa wa cP vy cv cC co cP vy cv cR co cM cfv
      vx cv clt cU cnv wcel cP cX wcel vy cv cX wcel cP vy cv cC co cP vy cv cR
      co cM cfv wceq cP vy cv cC cU cR cM cX nvcni.1 nvcni.r nvcni.m nvcni.8
      imsdval 3expb breq1d 3ad2antl1 cU cnv wcel cW cnv wcel cX cW cba cfv cF
      wf w3a cP cX wcel vy cv cX wcel wa wa cP cF cfv vy cv cF cfv cD co cP cF
      cfv vy cv cF cfv cS co cN cfv cA clt cW cnv wcel cP cF cfv cW cba cfv
      wcel vy cv cF cfv cW cba cfv wcel cP cF cfv vy cv cF cfv cD co cP cF cfv
      vy cv cF cfv cS co cN cfv wceq cU cnv wcel cW cnv wcel cX cW cba cfv cF
      wf w3a cP cX wcel vy cv cX wcel wa wa cP cF cfv vy cv cF cfv cD cW cS cN
      cW cba cfv cW cba cfv eqid nvcni.s nvcni.n nvcni.d imsdval cU cnv wcel cW
      cnv wcel cX cW cba cfv cF wf w3a cW cnv wcel cP cX wcel vy cv cX wcel wa
      cU cnv wcel cW cnv wcel cX cW cba cfv cF wf 3simp2 adantr cW cnv wcel cX
      cW cba cfv cF wf cP cX wcel vy cv cX wcel wa cP cF cfv cW cba cfv wcel cU
      cnv wcel cX cW cba cfv cF wf cP cX wcel cP cF cfv cW cba cfv wcel cW cnv
      wcel vy cv cX wcel cX cW cba cfv cP cF ffvelrn ad2ant2lr 3adantl1 cW cnv
      wcel cX cW cba cfv cF wf cP cX wcel vy cv cX wcel wa vy cv cF cfv cW cba
      cfv wcel cU cnv wcel cX cW cba cfv cF wf vy cv cX wcel vy cv cF cfv cW
      cba cfv wcel cW cnv wcel cP cX wcel cX cW cba cfv vy cv cF ffvelrn
      ad2ant2l 3adantl1 syl3anc breq1d imbi12d anassrs ralbidva anbi2d rexbidv
      ex cC cD cU cF cJ cK cW cX cW cba cfv nvcni.1 cW cba cfv eqid nvcni.8
      nvcni.d nvcni.j nvcni.k nvcnf syld3an3 imp 3ad2antr1 mpbid $.
      $( [16-Feb-2008] $) $( [13-Dec-2007] $)

    $( MAY BE REVISED - delete this if not used $)
    $( Epsilon-delta property of a continuous operator.  (Normed complex vector
       space version of ~ metcni .) $)
    nvcni2 $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ F e. ( J Cn K ) ) /\
        ( P e. X /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\ A. y e. X
    ( ( M ` ( P R y ) ) <_ x -> ( N ` ( ( F ` P ) S ( F ` y ) ) ) <_ A ) ) ) $=
      cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel
      cc0 cA clt wbr w3a wa cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP
      cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx
      cv clt wbr cP vy cv cR co cM cfv vx cv cle wbr cP cF cfv vy cv cF cfv cS
      co cN cfv cA cle wbr wi vy cX wral wa vx cr wrex cU cnv wcel cW cnv wcel
      cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx
      cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA
      cle wbr wi vy cX wral wa vx cr wrex cU cnv wcel cW cnv wcel cF cJ cK ccn
      co wcel w3a cP cX wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt wbr cP
      vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy
      cX wral wa vx cr wrex wi cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr w3a
      cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD
      co cA cle wbr wi vy cC cdm cdm wral wa vx cr wrex wi cC cme wcel cD cme
      wcel cF cJ cK ccn co wcel cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr
      w3a cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv
      cD co cA cle wbr wi vy cC cdm cdm wral wa vx cr wrex wi cU cnv wcel cW
      cnv wcel cF cJ cK ccn co wcel cC cme wcel cD cme wcel cF cJ cK ccn co
      wcel w3a cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt
      wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr
      wi vy cC cdm cdm wral wa vx cr wrex vx vy cA cC cD cP cF cJ cK cC cdm cdm
      cD cdm cdm cC cdm cdm eqid nvcni.j cD cdm cdm eqid nvcni.k metcni2 ex cC
      cU nvcni.8 imsmet cD cW nvcni.d imsmet cF cJ cK ccn co wcel id syl3an cU
      cnv wcel cW cnv wcel cP cX wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv
      clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle
      wbr wi vy cX wral wa vx cr wrex wi cP cC cdm cdm wcel cA cr wcel cc0 cA
      clt wbr w3a cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy
      cv cF cfv cD co cA cle wbr wi vy cC cdm cdm wral wa vx cr wrex wi wb cF
      cJ cK ccn co wcel cU cnv wcel cP cX wcel cA cr wcel cc0 cA clt wbr w3a cP
      cC cdm cdm wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt wbr cP vy cv
      cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral
      wa vx cr wrex cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy
      cv cF cfv cD co cA cle wbr wi vy cC cdm cdm wral wa vx cr wrex cU cnv
      wcel cP cX wcel cP cC cdm cdm wcel cA cr wcel cc0 cA clt wbr cU cnv wcel
      cX cC cdm cdm cP cC cU cX nvcni.1 nvcni.8 imsba eleq2d 3anbi1d cU cnv
      wcel cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF
      cfv cD co cA cle wbr wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co vx
      cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cC cdm cdm wral
      wa vx cr cU cnv wcel cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv
      cD co cA cle wbr wi vy cX wral cP vy cv cC co vx cv cle wbr cP cF cfv vy
      cv cF cfv cD co cA cle wbr wi vy cC cdm cdm wral cc0 vx cv clt wbr cU cnv
      wcel cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr
      wi vy cX cC cdm cdm cC cU cX nvcni.1 nvcni.8 imsba raleq1d anbi2d rexbidv
      imbi12d 3ad2ant1 mpbird imp cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel
      w3a cA cr wcel cP cX wcel cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr
      cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex cc0
      vx cv clt wbr cP vy cv cR co cM cfv vx cv cle wbr cP cF cfv vy cv cF cfv
      cS co cN cfv cA cle wbr wi vy cX wral wa vx cr wrex wb cc0 cA clt wbr cU
      cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cP cX wcel cc0 vx cv clt
      wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr
      wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv
      cle wbr cP cF cfv vy cv cF cfv cS co cN cfv cA cle wbr wi vy cX wral wa
      vx cr wrex wb cU cnv wcel cW cnv wcel cX cW cba cfv cF wf cP cX wcel cc0
      vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co
      cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cR co
      cM cfv vx cv cle wbr cP cF cfv vy cv cF cfv cS co cN cfv cA cle wbr wi vy
      cX wral wa vx cr wrex wb wi cF cJ cK ccn co wcel cU cnv wcel cW cnv wcel
      cX cW cba cfv cF wf w3a cP cX wcel cc0 vx cv clt wbr cP vy cv cC co vx cv
      cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral wa vx cr
      wrex cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv cle wbr cP cF cfv vy
      cv cF cfv cS co cN cfv cA cle wbr wi vy cX wral wa vx cr wrex wb cU cnv
      wcel cW cnv wcel cX cW cba cfv cF wf w3a cP cX wcel wa cc0 vx cv clt wbr
      cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi
      vy cX wral wa cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv cle wbr cP cF
      cfv vy cv cF cfv cS co cN cfv cA cle wbr wi vy cX wral wa vx cr cU cnv
      wcel cW cnv wcel cX cW cba cfv cF wf w3a cP cX wcel wa cP vy cv cC co vx
      cv cle wbr cP cF cfv vy cv cF cfv cD co cA cle wbr wi vy cX wral cP vy cv
      cR co cM cfv vx cv cle wbr cP cF cfv vy cv cF cfv cS co cN cfv cA cle wbr
      wi vy cX wral cc0 vx cv clt wbr cU cnv wcel cW cnv wcel cX cW cba cfv cF
      wf w3a cP cX wcel wa cP vy cv cC co vx cv cle wbr cP cF cfv vy cv cF cfv
      cD co cA cle wbr wi cP vy cv cR co cM cfv vx cv cle wbr cP cF cfv vy cv
      cF cfv cS co cN cfv cA cle wbr wi vy cX cU cnv wcel cW cnv wcel cX cW cba
      cfv cF wf w3a cP cX wcel vy cv cX wcel cP vy cv cC co vx cv cle wbr cP cF
      cfv vy cv cF cfv cD co cA cle wbr wi cP vy cv cR co cM cfv vx cv cle wbr
      cP cF cfv vy cv cF cfv cS co cN cfv cA cle wbr wi wb cU cnv wcel cW cnv
      wcel cX cW cba cfv cF wf w3a cP cX wcel vy cv cX wcel wa wa cP vy cv cC
      co vx cv cle wbr cP vy cv cR co cM cfv vx cv cle wbr cP cF cfv vy cv cF
      cfv cD co cA cle wbr cP cF cfv vy cv cF cfv cS co cN cfv cA cle wbr cU
      cnv wcel cW cnv wcel cP cX wcel vy cv cX wcel wa cP vy cv cC co vx cv cle
      wbr cP vy cv cR co cM cfv vx cv cle wbr wb cX cW cba cfv cF wf cU cnv
      wcel cP cX wcel vy cv cX wcel wa wa cP vy cv cC co cP vy cv cR co cM cfv
      vx cv cle cU cnv wcel cP cX wcel vy cv cX wcel cP vy cv cC co cP vy cv cR
      co cM cfv wceq cP vy cv cC cU cR cM cX nvcni.1 nvcni.r nvcni.m nvcni.8
      imsdval 3expb breq1d 3ad2antl1 cU cnv wcel cW cnv wcel cX cW cba cfv cF
      wf w3a cP cX wcel vy cv cX wcel wa wa cP cF cfv vy cv cF cfv cD co cP cF
      cfv vy cv cF cfv cS co cN cfv cA cle cW cnv wcel cP cF cfv cW cba cfv
      wcel vy cv cF cfv cW cba cfv wcel cP cF cfv vy cv cF cfv cD co cP cF cfv
      vy cv cF cfv cS co cN cfv wceq cU cnv wcel cW cnv wcel cX cW cba cfv cF
      wf w3a cP cX wcel vy cv cX wcel wa wa cP cF cfv vy cv cF cfv cD cW cS cN
      cW cba cfv cW cba cfv eqid nvcni.s nvcni.n nvcni.d imsdval cU cnv wcel cW
      cnv wcel cX cW cba cfv cF wf w3a cW cnv wcel cP cX wcel vy cv cX wcel wa
      cU cnv wcel cW cnv wcel cX cW cba cfv cF wf 3simp2 adantr cW cnv wcel cX
      cW cba cfv cF wf cP cX wcel vy cv cX wcel wa cP cF cfv cW cba cfv wcel cU
      cnv wcel cX cW cba cfv cF wf cP cX wcel cP cF cfv cW cba cfv wcel cW cnv
      wcel vy cv cX wcel cX cW cba cfv cP cF ffvelrn ad2ant2lr 3adantl1 cW cnv
      wcel cX cW cba cfv cF wf cP cX wcel vy cv cX wcel wa vy cv cF cfv cW cba
      cfv wcel cU cnv wcel cX cW cba cfv cF wf vy cv cX wcel vy cv cF cfv cW
      cba cfv wcel cW cnv wcel cP cX wcel cX cW cba cfv vy cv cF ffvelrn
      ad2ant2l 3adantl1 syl3anc breq1d imbi12d anassrs ralbidva anbi2d rexbidv
      ex cC cD cU cF cJ cK cW cX cW cba cfv nvcni.1 cW cba cfv eqid nvcni.8
      nvcni.d nvcni.j nvcni.k nvcnf syld3an3 imp 3ad2antr1 mpbid $.
      $( [21-Jul-2008] $) $( [13-Dec-2007] $)

    $( MAY BE REVISED - create metcni3 w/ swapped distance args, and replace
       nvcni above w/ proof from that, and make nvcni3 obsolete. $)
    $( Epsilon-delta property of a continuous operator.  (Normed complex vector
       space version of ~ metcni .) $)
    nvcni3 $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ F e. ( J Cn K ) ) /\
        ( P e. X /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\ A. y e. X
      ( ( M ` ( y R P ) ) < x -> ( N ` ( ( F ` y ) S ( F ` P ) ) ) < A ) ) ) $=
      cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cP cX wcel cA cr wcel
      cc0 cA clt wbr w3a wa cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv clt
      wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa vx cr
      wrex cc0 vx cv clt wbr vy cv cP cR co cM cfv vx cv clt wbr vy cv cF cfv
      cP cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa vx cr wrex vx vy cA cC
      cD cP cR cS cU cF cJ cK cM cN cW cX nvcni.1 nvcni.m nvcni.n nvcni.r
      nvcni.s nvcni.8 nvcni.d nvcni.j nvcni.k nvcni cU cnv wcel cW cnv wcel cF
      cJ cK ccn co wcel w3a cA cr wcel cP cX wcel cc0 vx cv clt wbr cP vy cv cR
      co cM cfv vx cv clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi
      vy cX wral wa vx cr wrex cc0 vx cv clt wbr vy cv cP cR co cM cfv vx cv
      clt wbr vy cv cF cfv cP cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa
      vx cr wrex wb cc0 cA clt wbr cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel
      w3a cP cX wcel wa cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv clt wbr
      cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy cX wral wa cc0 vx cv
      clt wbr vy cv cP cR co cM cfv vx cv clt wbr vy cv cF cfv cP cF cfv cS co
      cN cfv cA clt wbr wi vy cX wral wa vx cr cU cnv wcel cW cnv wcel cF cJ cK
      ccn co wcel w3a cP cX wcel wa cP vy cv cR co cM cfv vx cv clt wbr cP cF
      cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy cX wral vy cv cP cR co cM
      cfv vx cv clt wbr vy cv cF cfv cP cF cfv cS co cN cfv cA clt wbr wi vy cX
      wral cc0 vx cv clt wbr cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a
      cP cX wcel wa cP vy cv cR co cM cfv vx cv clt wbr cP cF cfv vy cv cF cfv
      cS co cN cfv cA clt wbr wi vy cv cP cR co cM cfv vx cv clt wbr vy cv cF
      cfv cP cF cfv cS co cN cfv cA clt wbr wi vy cX cU cnv wcel cW cnv wcel cF
      cJ cK ccn co wcel w3a cP cX wcel vy cv cX wcel cP vy cv cR co cM cfv vx
      cv clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr wi vy cv cP cR
      co cM cfv vx cv clt wbr vy cv cF cfv cP cF cfv cS co cN cfv cA clt wbr wi
      wb cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel w3a cP cX wcel vy cv cX
      wcel wa wa cP vy cv cR co cM cfv vx cv clt wbr vy cv cP cR co cM cfv vx
      cv clt wbr cP cF cfv vy cv cF cfv cS co cN cfv cA clt wbr vy cv cF cfv cP
      cF cfv cS co cN cfv cA clt wbr cU cnv wcel cW cnv wcel cP cX wcel vy cv
      cX wcel wa cP vy cv cR co cM cfv vx cv clt wbr vy cv cP cR co cM cfv vx
      cv clt wbr wb cF cJ cK ccn co wcel cU cnv wcel cP cX wcel vy cv cX wcel
      cP vy cv cR co cM cfv vx cv clt wbr vy cv cP cR co cM cfv vx cv clt wbr
      wb cU cnv wcel cP cX wcel vy cv cX wcel w3a cP vy cv cR co cM cfv vy cv
      cP cR co cM cfv vx cv clt cP vy cv cU cR cM cX nvcni.1 nvcni.r nvcni.m
      nvsub breq1d 3expb 3ad2antl1 cU cnv wcel cW cnv wcel cF cJ cK ccn co wcel
      w3a cP cX wcel vy cv cX wcel wa wa cP cF cfv vy cv cF cfv cS co cN cfv vy
      cv cF cfv cP cF cfv cS co cN cfv cA clt cU cnv wcel cW cnv wcel cF cJ cK
      ccn co wcel w3a cP cX wcel vy cv cX wcel wa cP cF cfv vy cv cF cfv cS co
      cN cfv vy cv cF cfv cP cF cfv cS co cN cfv wceq cU cnv wcel cW cnv wcel
      cX cW cba cfv cF wf cP cX wcel vy cv cX wcel wa cP cF cfv vy cv cF cfv cS
      co cN cfv vy cv cF cfv cP cF cfv cS co cN cfv wceq wi cF cJ cK ccn co
      wcel cW cnv wcel cX cW cba cfv cF wf cP cX wcel vy cv cX wcel wa cP cF
      cfv vy cv cF cfv cS co cN cfv vy cv cF cfv cP cF cfv cS co cN cfv wceq wi
      cU cnv wcel cW cnv wcel cX cW cba cfv cF wf wa cP cX wcel vy cv cX wcel
      wa cP cF cfv vy cv cF cfv cS co cN cfv vy cv cF cfv cP cF cfv cS co cN
      cfv wceq cW cnv wcel cX cW cba cfv cF wf cP cX wcel vy cv cX wcel wa cP
      cF cfv vy cv cF cfv cS co cN cfv vy cv cF cfv cP cF cfv cS co cN cfv wceq
      cW cnv wcel cP cF cfv cW cba cfv wcel vy cv cF cfv cW cba cfv wcel wa cP
      cF cfv vy cv cF cfv cS co cN cfv vy cv cF cfv cP cF cfv cS co cN cfv wceq
      cX cW cba cfv cF wf cP cX wcel vy cv cX wcel wa wa cW cnv wcel cP cF cfv
      cW cba cfv wcel vy cv cF cfv cW cba cfv wcel cP cF cfv vy cv cF cfv cS co
      cN cfv vy cv cF cfv cP cF cfv cS co cN cfv wceq cP cF cfv vy cv cF cfv cW
      cS cN cW cba cfv cW cba cfv eqid nvcni.s nvcni.n nvsub 3expb cX cW cba
      cfv cF wf cP cX wcel vy cv cX wcel cP cF cfv cW cba cfv wcel vy cv cF cfv
      cW cba cfv wcel wa cX cW cba cfv cF wf cP cX wcel wa cP cF cfv cW cba cfv
      wcel cX cW cba cfv cF wf vy cv cX wcel wa vy cv cF cfv cW cba cfv wcel cX
      cW cba cfv cP cF ffvelrn cX cW cba cfv vy cv cF ffvelrn anim12i anandis
      sylan2 anassrs ex 3adant1 cC cD cU cF cJ cK cW cX cW cba cfv nvcni.1 cW
      cba cfv eqid nvcni.8 nvcni.d nvcni.j nvcni.k nvcnf syld3an3 imp breq1d
      imbi12d anassrs ralbidva anbi2d rexbidv 3ad2antr1 mpbid $.
      $( [27-Jul-2008] $) $( [13-Dec-2007] $)
  $}

  ${
    nvlmcl.1 $e |- X = ( BaseSet ` U ) $.
    nvlmcl.2 $e |- D = ( IndMet ` U ) $.
    nvlmcl.3 $e |- P e. _V $.
    $( Closure of the limit of a converging vector sequence. $)
    nvlmcl $p |- ( ( U e. NrmCVec /\ F ( ~~>m ` D ) P ) -> P e. X ) $=
      cU cnv wcel cF cP cD clm cfv wbr wa cP cD cdm cdm cX cD cme wcel cF cP cD
      clm cfv wbr cP cD cdm cdm wcel cU cnv wcel cD cme wcel cP cvv wcel cF cP
      cD clm cfv wbr cP cD cdm cdm wcel nvlmcl.3 cvv cD cP cF cD cdm cdm cD cdm
      cdm eqid lmcl mp3an2 cD cU nvlmcl.2 imsmet sylan cU cnv wcel cX cD cdm
      cdm wceq cF cP cD clm cfv wbr cD cU cX nvlmcl.1 nvlmcl.2 imsba adantr
      eleqtrrd $.
      $( [6-Jan-2008] $) $( [26-Dec-2007] $)
  $}

  ${
    $d k D $.  $d k F $.  $d k P $.  $d k R $.  $d k U $.  $d k X $.
    nvlmle.1 $e |- X = ( BaseSet ` U ) $.
    nvlmle.6 $e |- N = ( norm ` U ) $.
    nvlmle.8 $e |- D = ( IndMet ` U ) $.
    nvlmle.p $e |- P e. _V $.
    $( If the norm of each member of a converging sequence is less than or
       equal to a given amount, so is the norm of the convergence value. $)
    nvlmle $p |- ( ( ( U e. NrmCVec /\ F : NN --> X /\ F ( ~~>m ` D ) P ) /\
     ( R e. RR /\ A. k e. NN ( N ` ( F ` k ) ) <_ R ) ) -> ( N ` P ) <_ R ) $=
      cU cnv wcel cn cX cF wf cF cP cD clm cfv wbr w3a cR cr wcel vk cv cF cfv
      cN cfv cR cle wbr vk cn wral wa wa cP cN cfv cP cU cn0v cfv cD co cR cle
      cU cnv wcel cn cX cF wf cF cP cD clm cfv wbr w3a cP cN cfv cP cU cn0v cfv
      cD co wceq cR cr wcel vk cv cF cfv cN cfv cR cle wbr vk cn wral wa cU cnv
      wcel cF cP cD clm cfv wbr cP cN cfv cP cU cn0v cfv cD co wceq cn cX cF wf
      cU cnv wcel cF cP cD clm cfv wbr cP cX wcel cP cN cfv cP cU cn0v cfv cD
      co wceq cD cP cU cF cX nvlmle.1 nvlmle.8 nvlmle.p nvlmcl cP cD cU cN cX
      cU cn0v cfv nvlmle.1 cU cn0v cfv eqid nvlmle.6 nvlmle.8 nvnd syldan
      3adant2 adantr cD cme wcel cF cP cD clm cfv wbr wa cU cn0v cfv cD cdm cdm
      wcel cR cr wcel vk cv cF cfv cU cn0v cfv cD co cR cle wbr vk cn wral w3a
      cP cU cn0v cfv cD co cR cle wbr cU cnv wcel cn cX cF wf cF cP cD clm cfv
      wbr w3a cR cr wcel vk cv cF cfv cN cfv cR cle wbr vk cn wral wa wa cD cme
      wcel cP cvv wcel cF cP cD clm cfv wbr cU cn0v cfv cD cdm cdm wcel cR cr
      wcel vk cv cF cfv cU cn0v cfv cD co cR cle wbr vk cn wral w3a cP cU cn0v
      cfv cD co cR cle wbr nvlmle.p cvv cD cP cU cn0v cfv cR vk cF c1 cD cdm
      cdm cn cD cdm cdm eqid 1z nnuz lmle mp3anl2 cU cnv wcel cn cX cF wf cF cP
      cD clm cfv wbr w3a cD cme wcel cF cP cD clm cfv wbr wa cR cr wcel vk cv
      cF cfv cN cfv cR cle wbr vk cn wral wa cU cnv wcel cF cP cD clm cfv wbr
      cD cme wcel cF cP cD clm cfv wbr wa cn cX cF wf cU cnv wcel cD cme wcel
      cF cP cD clm cfv wbr cD cU nvlmle.8 imsmet anim1i 3adant2 adantr cU cnv
      wcel cn cX cF wf cF cP cD clm cfv wbr w3a cR cr wcel vk cv cF cfv cN cfv
      cR cle wbr vk cn wral wa wa cU cn0v cfv cD cdm cdm wcel cR cr wcel vk cv
      cF cfv cU cn0v cfv cD co cR cle wbr vk cn wral cU cnv wcel cn cX cF wf cF
      cP cD clm cfv wbr w3a cU cn0v cfv cD cdm cdm wcel cR cr wcel vk cv cF cfv
      cN cfv cR cle wbr vk cn wral wa cU cnv wcel cn cX cF wf cU cn0v cfv cD
      cdm cdm wcel cF cP cD clm cfv wbr cU cnv wcel cU cn0v cfv cX cD cdm cdm
      cU cX cU cn0v cfv nvlmle.1 cU cn0v cfv eqid nvzcl cD cU cX nvlmle.1
      nvlmle.8 imsba eleqtrd 3ad2ant1 adantr cU cnv wcel cn cX cF wf cF cP cD
      clm cfv wbr w3a cR cr wcel vk cv cF cfv cN cfv cR cle wbr vk cn wral
      simprl cU cnv wcel cn cX cF wf cR cr wcel vk cv cF cfv cN cfv cR cle wbr
      vk cn wral wa vk cv cF cfv cU cn0v cfv cD co cR cle wbr vk cn wral cF cP
      cD clm cfv wbr cU cnv wcel cn cX cF wf wa vk cv cF cfv cN cfv cR cle wbr
      vk cn wral vk cv cF cfv cU cn0v cfv cD co cR cle wbr vk cn wral cR cr
      wcel cU cnv wcel cn cX cF wf wa vk cv cF cfv cN cfv cR cle wbr vk cn wral
      vk cv cF cfv cU cn0v cfv cD co cR cle wbr vk cn wral cU cnv wcel cn cX cF
      wf wa vk cv cF cfv cN cfv cR cle wbr vk cv cF cfv cU cn0v cfv cD co cR
      cle wbr vk cn cU cnv wcel cn cX cF wf wa vk cv cn wcel wa vk cv cF cfv cN
      cfv cR cle wbr vk cv cF cfv cU cn0v cfv cD co cR cle wbr cU cnv wcel cn
      cX cF wf wa vk cv cn wcel wa vk cv cF cfv cN cfv vk cv cF cfv cU cn0v cfv
      cD co cR cle cU cnv wcel cn cX cF wf vk cv cn wcel vk cv cF cfv cN cfv vk
      cv cF cfv cU cn0v cfv cD co wceq cU cnv wcel vk cv cF cfv cX wcel vk cv
      cF cfv cN cfv vk cv cF cfv cU cn0v cfv cD co wceq cn cX cF wf vk cv cn
      wcel wa vk cv cF cfv cD cU cN cX cU cn0v cfv nvlmle.1 cU cn0v cfv eqid
      nvlmle.6 nvlmle.8 nvnd cn cX vk cv cF ffvelrn sylan2 anassrs breq1d
      biimpd r19.20dva imp adantrl 3adantl3 3jca sylanc eqbrtrd $.
      $( [9-Jan-2008] $) $( [25-Dec-2007] $)
  $}

  ${
    $d t u v w x y z $.
    cnims.6 $e |- U = <. <. + , x. >. , abs >. $.
    cnims.7 $e |- D = ( abs o. - ) $.
    $( The metric induced on the complex numbers.  ~ cnmet proves that it is
       a metric.  (Contributed by Steve Rodriguez, 5-Dec-2006; revised by nm
       15-Jan-2008.) $)
    cnims $p |- D = ( IndMet ` U ) $=
      cD cabs cmin ccom cU cims cfv cnims.7 cU cnv wcel cU cims cfv cabs cmin
      ccom wceq cU cnims.6 cnnv cU cims cfv cU cmin cabs cU cnims.6 cnnvm cU
      cnims.6 cnnvnm cU cims cfv eqid imsval ax-mp eqtr4i $.
      $( [15-Jan-2008] $) $( [28-Nov-2006] $)
  $}

  ${
    vacn.1 $e |- X = ( BaseSet ` U ) $.
    vacn.6 $e |- N = ( norm ` U ) $.
    vacn.8 $e |- C = ( IndMet ` U ) $.
    vacn.9 $e |- U e. NrmCVec $.
    ${
      $d t h u v f g A $.  $d t h u v f g B $.  $d t k u v f g F $.
      $d t k f g u v G $.  $d t k h u v f g H $.  $d t k h u v f g M $.
      $d t u v f g ph $.  $d t k h u v f g X $.  $d t k h u v f g U $.
      $d t k h u v f g C $.
      vacnlem1.1 $e |- F e. _V $.
      vacnlem1.2 $e |- G e. _V $.
      vacnlem1.3 $e |- H e. _V $.
      vacnlem1.4 $e |- A e. _V $.
      vacnlem1.5 $e |- B e. _V $.
      vacnlem1.6 $e |- ( ph <-> ( ( F ( ~~>m ` C ) A /\ G ( ~~>m ` C ) B )
        /\ A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. X /\ ( G ` k ) e. X /\ ( H ` k )
        = ( ( F ` k ) ( +v ` U ) ( G ` k ) ) ) ) ) $.
      $( Lemma for ~ vacn . $)
      vacnlem1 $p |- ( ( t e. ( ZZ>= ` M ) /\ ph ) -> ( ( F ` t ) e. X /\
        ( G ` t ) e. X /\ ( H ` t ) = ( ( F ` t ) ( +v ` U ) ( G ` t ) ) ) ) $=
        vt cv cM cuz cfv wcel cF cA cC clm cfv wbr cG cB cC clm cfv wbr wa vk
        cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv
        cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral wa vt cv cF cfv cX
        wcel vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv
        cfv co wceq w3a wph vt cv cM cuz cfv wcel vk cv cF cfv cX wcel vk cv cG
        cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq
        w3a vk cM cuz cfv wral vt cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv
        cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq w3a cF cA cC clm
        cfv wbr cG cB cC clm cfv wbr wa vk cv cF cfv cX wcel vk cv cG cfv cX
        wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv
        cG cfv cU cpv cfv co wceq w3a vk vt cv cM cuz cfv vk cv vt cv wceq vk
        cv cF cfv cX wcel vt cv cF cfv cX wcel vk cv cG cfv cX wcel vt cv cG
        cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq
        vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq vk cv vt cv
        wceq vk cv cF cfv vt cv cF cfv cX vk cv vt cv cF fveq2 eleq1d vk cv vt
        cv wceq vk cv cG cfv vt cv cG cfv cX vk cv vt cv cG fveq2 eleq1d vk cv
        vt cv wceq vk cv cH cfv vt cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv
        cfv co vt cv cF cfv vt cv cG cfv cU cpv cfv co vk cv vt cv cH fveq2 vk
        cv vt cv wceq vk cv cF cfv vt cv cF cfv vk cv cG cfv vt cv cG cfv cU
        cpv cfv vk cv vt cv cF fveq2 vk cv vt cv cG fveq2 opreq12d eqeq12d
        3anbi123d rcla4va adantrl vacnlem1.6 sylan2b $.
        $( [21-Jun-2009] $) $( [12-Jun-2009] $)

      $( Lemma for ~ vacn . $)
      vacnlem2 $p |- ( ph -> ( A e. X /\ B e. X ) ) $=
        wph cF cA cC clm cfv wbr cG cB cC clm cfv wbr wa vk cv cF cfv cX wcel
        vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv
        co wceq w3a vk cM cuz cfv wral wa cA cX wcel cB cX wcel wa vacnlem1.6
        cF cA cC clm cfv wbr cG cB cC clm cfv wbr wa cA cX wcel cB cX wcel wa
        vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv vk
        cv cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral cF cA cC clm cfv
        wbr cA cX wcel cG cB cC clm cfv wbr cB cX wcel cU cnv wcel cF cA cC clm
        cfv wbr cA cX wcel vacn.9 cC cA cU cF cX vacn.1 vacn.8 vacnlem1.4
        nvlmcl mpan cU cnv wcel cG cB cC clm cfv wbr cB cX wcel vacn.9 cC cB cU
        cG cX vacn.1 vacn.8 vacnlem1.5 nvlmcl mpan anim12i adantr sylbi $.
        $( [21-Jun-2009] $) $( [12-Jun-2009] $)

      vacnlem.7 $e |- H C_ ( CC X. X ) $.
      vacnlem.8 $e |- M e. ZZ $.
      $( Lemma for ~ vacn . $)
      vacnlem3 $p |- ( ph -> H ( ~~>m ` C ) ( A ( +v ` U ) B ) ) $=
        cA cB cU cpv cfv co cX wcel cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv
        cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa
        wi vt cM cuz cfv wral vh cM cuz cfv wrex wi vv cr wral cH cA cB cU cpv
        cfv co cC clm cfv wbr wph cA cB cU cpv cfv co cX wcel cA cB cU cpv cfv
        co cvv wcel cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cX wcel
        vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz
        cfv wral vh cM cuz cfv wrex wi vv cr wral cH cA cB cU cpv cfv co cC clm
        cfv wbr wi cA cB cU cpv cfv co cX elisset cH cc cX cxp wss cA cB cU cpv
        cfv co cX wcel cA cB cU cpv cfv co cvv wcel cc0 vv cv clt wbr vh cv vt
        cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co
        vv cv clt wbr wa wi vt cM cuz cfv wral vh cM cuz cfv wrex wi vv cr wral
        cH cA cB cU cpv cfv co cC clm cfv wbr wi wi wi vacnlem.7 cH cc cX cxp
        wss cA cB cU cpv cfv co cX wcel cc0 vv cv clt wbr vh cv vt cv cle wbr
        vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt
        wbr wa wi vt cM cuz cfv wral vh cM cuz cfv wrex wi vv cr wral cA cB cU
        cpv cfv co cvv wcel cH cA cB cU cpv cfv co cC clm cfv wbr cH cc cX cxp
        wss cA cB cU cpv cfv co cX wcel cc0 vv cv clt wbr vh cv vt cv cle wbr
        vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt
        wbr wa wi vt cM cuz cfv wral vh cM cuz cfv wrex wi vv cr wral cA cB cU
        cpv cfv co cvv wcel cH cA cB cU cpv cfv co cC clm cfv wbr wi cA cB cU
        cpv cfv co cvv wcel cH cc cX cxp wss cA cB cU cpv cfv co cX wcel cc0 vv
        cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB
        cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh cM cuz
        cfv wrex wi vv cr wral w3a cH cA cB cU cpv cfv co cC clm cfv wbr cC cme
        wcel cA cB cU cpv cfv co cvv wcel cH cc cX cxp wss cA cB cU cpv cfv co
        cX wcel cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cX wcel vt
        cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv
        wral vh cM cuz cfv wrex wi vv cr wral w3a cH cA cB cU cpv cfv co cC clm
        cfv wbr wi cU cnv wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet ax-mp cC
        cme wcel cA cB cU cpv cfv co cvv wcel wa cH cA cB cU cpv cfv co cC clm
        cfv wbr cH cc cX cxp wss cA cB cU cpv cfv co cX wcel cc0 vv cv clt wbr
        vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv
        co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh cM cuz cfv wrex wi
        vv cr wral w3a vv cvv cC cA cB cU cpv cfv co vh vt cH cM cX cM cuz cfv
        cC cU cX vacn.1 vacn.8 vacn.9 imsbai vacnlem.8 cM cuz cfv eqid lmbr2
        biimprd mpan com12 3exp com34 ax-mp mpd wph cA cX wcel cB cX wcel wa cA
        cB cU cpv cfv co cX wcel wph cA cB cC cU vk cF cG cH cM cN cX vacn.1
        vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4
        vacnlem1.5 vacnlem1.6 vacnlem2 cU cnv wcel cA cX wcel cB cX wcel cA cB
        cU cpv cfv co cX wcel vacn.9 cA cB cU cU cpv cfv cX vacn.1 cU cpv cfv
        eqid nvgcl mp3an1 syl wph cc0 vv cv clt wbr vh cv vt cv cle wbr vt cv
        cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa
        wi vt cM cuz cfv wral vh cM cuz cfv wrex wi vv cr wph vv cv cr wcel cc0
        vv cv clt wbr vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA
        cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh cM cuz
        cfv wrex wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv vt cv cle wbr
        vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa
        wi vt cM cuz cfv wral vu cM cuz cfv wrex vf cv vg cv cle wbr vg cv cG
        cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vg cM
        cuz cfv wral vf cM cuz cfv wrex wa vh cv vt cv cle wbr vt cv cH cfv cX
        wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM
        cuz cfv wral vh cM cuz cfv wrex wph vv cv c2 cdiv co cr wcel cc0 vv cv
        c2 cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF
        cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vu cM
        cuz cfv wrex vf cv vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB
        cC co vv cv c2 cdiv co clt wbr wa wi vg cM cuz cfv wral vf cM cuz cfv
        wrex wa vv cv cr wcel cc0 vv cv clt wbr wa cF cA cC clm cfv wbr cG cB
        cC clm cfv wbr wa vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH
        cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral
        wa vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vu cv vt cv
        cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt
        wbr wa wi vt cM cuz cfv wral vu cM cuz cfv wrex vf cv vg cv cle wbr vg
        cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi
        vg cM cuz cfv wral vf cM cuz cfv wrex wa wph cF cA cC clm cfv wbr cG cB
        cC clm cfv wbr wa vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr
        wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv
        c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vu cM cuz cfv wrex vf cv vg
        cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co
        clt wbr wa wi vg cM cuz cfv wral vf cM cuz cfv wrex wa vk cv cF cfv cX
        wcel vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv
        cfv co wceq w3a vk cM cuz cfv wral cF cA cC clm cfv wbr cG cB cC clm
        cfv wbr vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vu cv
        vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv
        co clt wbr wa wi vt cM cuz cfv wral vu cM cuz cfv wrex vf cv vg cv cle
        wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr
        wa wi vg cM cuz cfv wral vf cM cuz cfv wrex wa cF cA cC clm cfv wbr vv
        cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa wa vu cv vt cv
        cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt
        wbr wa wi vt cM cuz cfv wral vu cM cuz cfv wrex cG cB cC clm cfv wbr vv
        cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa wa vf cv vg cv
        cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt
        wbr wa wi vg cM cuz cfv wral vf cM cuz cfv wrex cF cA cC clm cfv wbr vv
        cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vu cv vt cv cle
        wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr
        wa wi vt cM cuz cfv wral vu cM cuz cfv wrex cC cme wcel cA cvv wcel cF
        cA cC clm cfv wbr vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr
        wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv
        c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vu cM cuz cfv wrex wi cU
        cnv wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet ax-mp vacnlem1.4 cC cme
        wcel cA cvv wcel cF cA cC clm cfv wbr w3a vv cv c2 cdiv co cr wcel cc0
        vv cv c2 cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt
        cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vu
        cM cuz cfv wrex cvv cC cA vv cv c2 cdiv co vu vt cF cM cX cM cuz cfv cC
        cU cX vacn.1 vacn.8 vacn.9 imsbai vacnlem.8 cM cuz cfv eqid lmcvg ex
        mp3an12 imp cG cB cC clm cfv wbr vv cv c2 cdiv co cr wcel cc0 vv cv c2
        cdiv co clt wbr wa vf cv vg cv cle wbr vg cv cG cfv cX wcel vg cv cG
        cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vg cM cuz cfv wral vf cM
        cuz cfv wrex cC cme wcel cB cvv wcel cG cB cC clm cfv wbr vv cv c2 cdiv
        co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vf cv vg cv cle wbr vg cv cG
        cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vg cM
        cuz cfv wral vf cM cuz cfv wrex wi cU cnv wcel cC cme wcel vacn.9 cC cU
        vacn.8 imsmet ax-mp vacnlem1.5 cC cme wcel cB cvv wcel cG cB cC clm cfv
        wbr w3a vv cv c2 cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr wa vf cv
        vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv
        co clt wbr wa wi vg cM cuz cfv wral vf cM cuz cfv wrex cvv cC cB vv cv
        c2 cdiv co vf vg cG cM cX cM cuz cfv cC cU cX vacn.1 vacn.8 vacn.9
        imsbai vacnlem.8 cM cuz cfv eqid lmcvg ex mp3an12 imp anim12i anandirs
        adantlr vacnlem1.6 sylanb vv cv cr wcel cc0 vv cv clt wbr wa vv cv c2
        cdiv co cr wcel cc0 vv cv c2 cdiv co clt wbr vv cv cr wcel vv cv c2
        cdiv co cr wcel cc0 vv cv clt wbr vv cv rehalfcl adantr vv cv cr wcel
        cc0 vv cv clt wbr wa c2 cr wcel cc0 c2 clt wbr cc0 vv cv c2 cdiv co clt
        wbr 2re 2pos vv cv c2 divgt0 mpanr12 jca sylan2 wph vv cv cr wcel cc0
        vv cv clt wbr wa wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF
        cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vf cv vg
        cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co
        clt wbr wa wi vg cM cuz cfv wral wa vf cM cuz cfv wrex vu cM cuz cfv
        wrex vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv
        cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh cM cuz cfv wrex
        vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2
        cdiv co clt wbr wa wi vt cM cuz cfv wral vu cM cuz cfv wrex vf cv vg cv
        cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt
        wbr wa wi vg cM cuz cfv wral vf cM cuz cfv wrex wa wph vv cv cr wcel
        cc0 vv cv clt wbr wa wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv
        cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vf cv
        vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv
        co clt wbr wa wi vg cM cuz cfv wral wa vh cv vt cv cle wbr vt cv cH cfv
        cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt
        cM cuz cfv wral vh cM cuz cfv wrex vu vf cM cuz cfv cM cuz cfv wph vv
        cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz
        cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC
        co vv cv c2 cdiv co clt wbr wa wi vt cM cuz cfv wral vf cv vg cv cle
        wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr
        wa wi vg cM cuz cfv wral wa vh cv vt cv cle wbr vt cv cH cfv cX wcel vt
        cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv
        wral vh cM cuz cfv wrex wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu
        cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vu cv vt cv cle wbr vt
        cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi
        vf cv vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2
        cdiv co clt wbr wa wi wa vg cM cuz cfv wral vt cM cuz cfv wral vh cv vt
        cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co
        vv cv clt wbr wa wi vt cM cuz cfv wral vh cM cuz cfv wrex vu cv vt cv
        cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt
        wbr wa wi vt cM cuz cfv wral vf cv vg cv cle wbr vg cv cG cfv cX wcel
        vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vg cM cuz cfv wral
        wa wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv
        cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv vg cv cle wbr vg
        cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi
        wa vg cM cuz cfv wral vt cM cuz cfv wral vu cv vf cv cle wbr vf cv vu
        cv cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv
        co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh cv vt cv cle wbr vt
        cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr
        wa wi vt cM cuz cfv wral vh cM cuz cfv wrex wph vv cv cr wcel cc0 vv cv
        clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vu cv
        vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv
        co clt wbr wa wi vf cv vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv
        cB cC co vv cv c2 cdiv co clt wbr wa wi wa vg cM cuz cfv wral vu cv vf
        cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH
        cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wph vv
        cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz
        cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF
        cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv
        vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv
        co clt wbr wa wi wa vg cM cuz cfv wral vu cv vt cv cle wbr vt cv cF cfv
        cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv vt
        cv cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cC co vv cv c2 cdiv co
        clt wbr wa wi wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt
        cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr
        wa wi vt cv cM cuz cfv wcel vu cv vt cv cle wbr vt cv cF cfv cX wcel vt
        cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv vg cv cle wbr
        vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa
        wi wa vg cM cuz cfv wral vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv
        cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt
        cv cG cfv cX wcel vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi
        wa wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel
        vf cv cM cuz cfv wcel wa wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt
        cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv vg cv cle wbr
        vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa
        wi wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv
        cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv cX wcel vt
        cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi wa vg vt cv cM cuz
        cfv vg cv vt cv wceq vf cv vg cv cle wbr vg cv cG cfv cX wcel vg cv cG
        cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv
        cG cfv cX wcel vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vu
        cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2
        cdiv co clt wbr wa wi vg cv vt cv wceq vf cv vg cv cle wbr vf cv vt cv
        cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt
        wbr wa vt cv cG cfv cX wcel vt cv cG cfv cB cC co vv cv c2 cdiv co clt
        wbr wa vg cv vt cv vf cv cle breq2 vg cv vt cv wceq vg cv cG cfv cX
        wcel vt cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt
        wbr vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr vg cv vt cv wceq vg
        cv cG cfv vt cv cG cfv cX vg cv vt cv cG fveq2 eleq1d vg cv vt cv wceq
        vg cv cG cfv cB cC co vt cv cG cfv cB cC co vv cv c2 cdiv co clt vg cv
        vt cv wceq vg cv cG cfv vt cv cG cfv cB cC vg cv vt cv cG fveq2 opreq1d
        breq1d anbi12d imbi12d anbi2d rcla4v adantl wph vv cv cr wcel cc0 vv cv
        clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv
        cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF
        cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv
        cG cfv cX wcel vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi wa
        vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co
        cN cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        wa wi wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv
        cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi wph
        vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM
        cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv
        cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa wi vu
        cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv cX
        wcel vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vf cv vt cv
        cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr wa wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa
        vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel
        wa vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr
        wa vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr wa vu cv vt cv cle wbr wph vv cv cr wcel cc0 vv cv clt
        wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM
        cuz cfv wcel wa vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr vt cv cF
        cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cX
        wcel wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vt cv cF cfv cA cC co
        vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt vt cv cF cfv
        cX wcel cA cX wcel vt cv cF cfv cA cC co vt cv cF cfv cA cU cnsb cfv co
        cN cfv wceq wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv
        wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa cU cnv wcel
        vt cv cF cfv cX wcel cA cX wcel vt cv cF cfv cA cC co vt cv cF cfv cA
        cU cnsb cfv co cN cfv wceq vacn.9 vt cv cF cfv cA cC cU cU cnsb cfv cN
        cX vacn.1 cU cnsb cfv eqid vacn.6 vacn.8 imsdval mp3an1 wph vv cv cr
        wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv
        wcel wa wa vt cv cM cuz cfv wcel vt cv cF cfv cX wcel wph vt cv cM cuz
        cfv wcel vt cv cF cfv cX wcel wi vv cv cr wcel cc0 vv cv clt wbr wa vu
        cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa vt cv cM cuz cfv wcel wph
        vt cv cF cfv cX wcel vt cv cM cuz cfv wcel wph wa vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv
        co wceq wph vt cA cB cC cU vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8
        vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4 vacnlem1.5
        vacnlem1.6 vacnlem1 3simp1d expcom ad2antrr imp wph vv cv cr wcel cc0
        vv cv clt wbr wa wa cA cX wcel vu cv cM cuz cfv wcel vf cv cM cuz cfv
        wcel wa vt cv cM cuz cfv wcel wph cA cX wcel vv cv cr wcel cc0 vv cv
        clt wbr wa wph cA cX wcel cB cX wcel wph cA cB cC cU vk cF cG cH cM cN
        cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3
        vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem2 pm3.26d adantr ad2antrr
        sylanc breq1d anbi2d imbi2d wph vv cv cr wcel cc0 vv cv clt wbr wa wa
        vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel
        wa vt cv cG cfv cX wcel vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr
        wa vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr wa vf cv vt cv cle wbr wph vv cv cr wcel cc0 vv cv clt
        wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM
        cuz cfv wcel wa vt cv cG cfv cB cC co vv cv c2 cdiv co clt wbr vt cv cG
        cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cX
        wcel wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vt cv cG cfv cB cC co
        vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt vt cv cG cfv
        cX wcel cB cX wcel vt cv cG cfv cB cC co vt cv cG cfv cB cU cnsb cfv co
        cN cfv wceq wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv
        wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa cU cnv wcel
        vt cv cG cfv cX wcel cB cX wcel vt cv cG cfv cB cC co vt cv cG cfv cB
        cU cnsb cfv co cN cfv wceq vacn.9 vt cv cG cfv cB cC cU cU cnsb cfv cN
        cX vacn.1 cU cnsb cfv eqid vacn.6 vacn.8 imsdval mp3an1 wph vv cv cr
        wcel cc0 vv cv clt wbr wa wa vt cv cM cuz cfv wcel vt cv cG cfv cX wcel
        vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wph vt cv cM cuz cfv
        wcel vt cv cG cfv cX wcel vv cv cr wcel cc0 vv cv clt wbr wa vt cv cM
        cuz cfv wcel wph vt cv cG cfv cX wcel vt cv cM cuz cfv wcel wph wa vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv
        cG cfv cU cpv cfv co wceq wph vt cA cB cC cU vk cF cG cH cM cN cX
        vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4
        vacnlem1.5 vacnlem1.6 vacnlem1 3simp2d ancoms adantlr adantlr wph vv cv
        cr wcel cc0 vv cv clt wbr wa wa cB cX wcel vu cv cM cuz cfv wcel vf cv
        cM cuz cfv wcel wa vt cv cM cuz cfv wcel wph cB cX wcel vv cv cr wcel
        cc0 vv cv clt wbr wa wph cA cX wcel cB cX wcel wph cA cB cC cU vk cF cG
        cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2
        vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem2 pm3.27d adantr
        ad2antrr sylanc breq1d anbi2d imbi2d anbi12d wph vv cv cr wcel cc0 vv
        cv clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt
        cv cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF
        cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt cv
        cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr wa wi wa vu cv vf cv cle wbr vf cv vu cv cif vt
        cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cU
        cnsb cfv co cN cfv vv cv clt wbr wa wi vu cv vf cv cle wbr vf cv vu cv
        cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co
        cC co vv cv clt wbr wa wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu
        cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa
        vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co
        cN cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        wa wi wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv
        cX wcel vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv
        clt wbr wa wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv
        wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vt cv
        cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv cX wcel vt
        cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi wa wa
        vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr wa vt cv cH cfv cX
        wcel vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt
        wbr wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vt cv cH cfv cX wcel
        vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co
        cN cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        wa wi wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr wph vv cv cr
        wcel cc0 vv cv clt wbr wa wa vt cv cM cuz cfv wcel vt cv cH cfv cX wcel
        vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wph vt cv cM cuz cfv
        wcel vt cv cH cfv cX wcel vv cv cr wcel cc0 vv cv clt wbr wa vt cv cM
        cuz cfv wcel wph vt cv cH cfv cX wcel vt cv cM cuz cfv wcel wph wa vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv
        cG cfv cU cpv cfv co wceq w3a vt cv cH cfv cX wcel wph vt cA cB cC cU
        vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2
        vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem1 vt cv cF cfv cX
        wcel vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv
        cfv co wceq w3a vt cv cH cfv cX wcel vt cv cF cfv vt cv cG cfv cU cpv
        cfv co cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv cF cfv
        vt cv cG cfv cU cpv cfv co cX wcel vt cv cH cfv vt cv cF cfv vt cv cG
        cfv cU cpv cfv co wceq cU cnv wcel vt cv cF cfv cX wcel vt cv cG cfv cX
        wcel vt cv cF cfv vt cv cG cfv cU cpv cfv co cX wcel vacn.9 vt cv cF
        cfv vt cv cG cfv cU cU cpv cfv cX vacn.1 cU cpv cfv eqid nvgcl mp3an1
        3adant3 vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq vt cv
        cF cfv cX wcel vt cv cH cfv cX wcel vt cv cF cfv vt cv cG cfv cU cpv
        cfv co cX wcel wb vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv
        cG cfv cU cpv cfv co cX eleq1 3ad2ant3 mpbird syl ancoms adantlr
        adantlr ad2antrr wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz
        cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel vu cv vt cv
        cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv cX wcel vt
        cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi wa vu
        cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA cB cU
        cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wph vv cv cr wcel vu cv
        cM cuz cfv wcel vf cv cM cuz cfv wcel wa vt cv cM cuz cfv wcel vu cv vt
        cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv
        vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle wbr vt cv cG cfv cX wcel
        vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi wa
        vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA cB cU
        cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wi wi wi cc0 vv cv clt
        wbr wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa
        wa vt cv cM cuz cfv wcel vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv
        cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt
        cv cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv
        vv cv c2 cdiv co clt wbr wa wi wa vu cv vf cv cle wbr vf cv vu cv cif
        vt cv cle wbr vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv
        cv clt wbr wi wi vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv
        cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vf cv vt cv cle
        wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr wa wi wa wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr
        vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA cB cU cpv cfv co cU cnsb
        cfv co cN cfv vv cv clt wbr wi vu cv vt cv cle wbr vt cv cF cfv cX wcel
        vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vf
        cv vt cv cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr wa wi wph vv cv cr wcel wa vu cv cM cuz
        cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf
        cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA cB cU cpv cfv
        co cU cnsb cfv co cN cfv vv cv clt wbr wi wi vu cv vf cv cle wbr vf cv
        vu cv cif vt cv cle wbr vf cv vt cv cle wbr vt cv cG cfv cX wcel vt cv
        cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi wph vv
        cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv
        cM cuz cfv wcel wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF
        cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vt cv cH
        cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wph vv cv
        cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM
        cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vf cv
        vt cv cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr wa wi vu cv vt cv cle wbr vt cv cF cfv cX
        wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa
        wi vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr
        wi wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa
        wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv
        cle wbr vf cv vt cv cle wbr vt cv cG cfv cX wcel vt cv cG cfv cB cU
        cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vu cv vt cv cle wbr
        vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr wa wi vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co
        cN cfv vv cv clt wbr wi wi wph vv cv cr wcel wa vu cv cM cuz cfv wcel
        vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf cv cle
        wbr vf cv vu cv cif vt cv cle wbr wa vf cv vt cv cle wbr vt cv cG cfv
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        wa wi vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv
        c2 cdiv co clt wbr wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF
        cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vt cv cH
        cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wi wph vv
        cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv
        cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr wa
        vf cv vt cv cle wbr vf cv vt cv cle wbr vt cv cG cfv cX wcel vt cv cG
        cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vt cv cG
        cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr wa wi wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv
        wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif
        vt cv cle wbr vf cv vt cv cle wbr wph vv cv cr wcel wa vu cv cM cuz cfv
        wcel vf cv cM cuz cfv wcel wa wa vt cv cr wcel vu cv vf cv cle wbr vf
        cv vu cv cif vt cv cle wbr vf cv vt cv cle wbr wi vt cv cM cuz cfv wcel
        wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa
        vt cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vf cv
        vt cv cle wbr wi vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa vt cv
        cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vf cv vt cv
        cle wbr wi wi wph vv cv cr wcel wa vu cv cr wcel vf cv cr wcel vt cv cr
        wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vf cv vt cv cle
        wbr wi wi vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel vu cv cr wcel vf
        cv cr wcel wa vu cv vf cv cle wbr vf cv vu cv cif cr wcel vt cv cr wcel
        vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vf cv vt cv cle wbr
        wi wi vf cv cr wcel vu cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif
        cr wcel vu cv vf cv cle wbr vf cv vu cv cr ifcl ancoms vu cv cr wcel vf
        cv cr wcel wa vf cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr vu cv
        vf cv cle wbr vf cv vu cv cif cr wcel vt cv cr wcel vu cv vf cv cle wbr
        vf cv vu cv cif vt cv cle wbr vf cv vt cv cle wbr wi wi wi vu cv vf cv
        max2 vf cv cr wcel vf cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr vu
        cv vf cv cle wbr vf cv vu cv cif cr wcel vt cv cr wcel vu cv vf cv cle
        wbr vf cv vu cv cif vt cv cle wbr vf cv vt cv cle wbr wi wi wi wi vu cv
        cr wcel vf cv cr wcel vt cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif
        cr wcel vf cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr vu cv vf cv
        cle wbr vf cv vu cv cif vt cv cle wbr vf cv vt cv cle wbr wi vf cv cr
        wcel vu cv vf cv cle wbr vf cv vu cv cif cr wcel vt cv cr wcel vf cv vu
        cv vf cv cle wbr vf cv vu cv cif cle wbr vu cv vf cv cle wbr vf cv vu
        cv cif vt cv cle wbr vf cv vt cv cle wbr wi wi vf cv cr wcel vu cv vf
        cv cle wbr vf cv vu cv cif cr wcel vt cv cr wcel vf cv vu cv vf cv cle
        wbr vf cv vu cv cif cle wbr vu cv vf cv cle wbr vf cv vu cv cif vt cv
        cle wbr vf cv vt cv cle wbr wi wi vf cv cr wcel vu cv vf cv cle wbr vf
        cv vu cv cif cr wcel vt cv cr wcel w3a vf cv vu cv vf cv cle wbr vf cv
        vu cv cif cle wbr vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vf
        cv vt cv cle wbr vf cv vu cv vf cv cle wbr vf cv vu cv cif vt cv letr
        exp3a 3exp com23 com24 adantl mpd mpd vu cv cM cuz cfv wcel vu cv cz
        wcel vu cv cr wcel cM vu cv eluzelz vu cv zre syl vf cv cM cuz cfv wcel
        vf cv cz wcel vf cv cr wcel cM vf cv eluzelz vf cv zre syl syl2an
        adantl imp vt cv cM cuz cfv wcel vt cv cz wcel vt cv cr wcel cM vt cv
        eluzelz vt cv zre syl sylan2 imp vf cv vt cv cle wbr vt cv cG cfv cX
        wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa
        pm2.27 syl wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv
        wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif
        vt cv cle wbr wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv
        cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vt cv cG cfv cX
        wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa
        vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr
        wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa
        vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle
        wbr wa vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr wa wi vt cv cF cfv cX wcel vt cv
        cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa vt cv cG
        cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr wa vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt
        wbr wi wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel
        wa wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt
        cv cle wbr wa vu cv vt cv cle wbr vu cv vt cv cle wbr vt cv cF cfv cX
        wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa
        wi vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr wa wi wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv
        cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf
        cv vu cv cif vt cv cle wbr vu cv vt cv cle wbr wph vv cv cr wcel wa vu
        cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cr wcel vu cv vf
        cv cle wbr vf cv vu cv cif vt cv cle wbr vu cv vt cv cle wbr wi vt cv
        cM cuz cfv wcel wph vv cv cr wcel wa vu cv cM cuz cfv wcel vf cv cM cuz
        cfv wcel wa wa vt cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv
        cle wbr vu cv vt cv cle wbr wi vu cv cM cuz cfv wcel vf cv cM cuz cfv
        wcel wa vt cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr
        vu cv vt cv cle wbr wi wi wph vv cv cr wcel wa vu cv cr wcel vf cv cr
        wcel vt cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vu
        cv vt cv cle wbr wi wi vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel vu
        cv cr wcel vf cv cr wcel wa vu cv vu cv vf cv cle wbr vf cv vu cv cif
        cle wbr vt cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr
        vu cv vt cv cle wbr wi wi vu cv vf cv max1 vu cv cr wcel vf cv cr wcel
        wa vu cv vf cv cle wbr vf cv vu cv cif cr wcel vu cv vu cv vf cv cle
        wbr vf cv vu cv cif cle wbr vt cv cr wcel vu cv vf cv cle wbr vf cv vu
        cv cif vt cv cle wbr vu cv vt cv cle wbr wi wi wi vf cv cr wcel vu cv
        cr wcel vu cv vf cv cle wbr vf cv vu cv cif cr wcel vu cv vf cv cle wbr
        vf cv vu cv cr ifcl ancoms vu cv cr wcel vu cv vf cv cle wbr vf cv vu
        cv cif cr wcel vu cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr vt cv
        cr wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vu cv vt cv
        cle wbr wi wi wi wi vf cv cr wcel vu cv cr wcel vu cv vf cv cle wbr vf
        cv vu cv cif cr wcel vt cv cr wcel vu cv vu cv vf cv cle wbr vf cv vu
        cv cif cle wbr vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vu cv
        vt cv cle wbr wi vu cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif cr
        wcel vt cv cr wcel vu cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr vu
        cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vu cv vt cv cle wbr wi
        wi vu cv cr wcel vu cv vf cv cle wbr vf cv vu cv cif cr wcel vt cv cr
        wcel w3a vu cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr vu cv vf cv
        cle wbr vf cv vu cv cif vt cv cle wbr vu cv vt cv cle wbr vu cv vu cv
        vf cv cle wbr vf cv vu cv cif vt cv letr exp3a 3exp com34 adantr mpd
        mpd vu cv cM cuz cfv wcel vu cv cz wcel vu cv cr wcel cM vu cv eluzelz
        vu cv zre syl vf cv cM cuz cfv wcel vf cv cz wcel vf cv cr wcel cM vf
        cv eluzelz vf cv zre syl syl2an adantl imp vt cv cM cuz cfv wcel vt cv
        cz wcel vt cv cr wcel cM vt cv eluzelz vt cv zre syl sylan2 imp vu cv
        vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr wa pm2.27 syl wph vv cv cr wcel wa vu cv
        cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vu
        cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cF cfv cX wcel vt
        cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa vt cv cG
        cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr wa vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt
        wbr wi wi wph vv cv cr wcel wa vt cv cM cuz cfv wcel vu cv vf cv cle
        wbr vf cv vu cv cif vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA
        cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa vt cv cG cfv cX wcel
        vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa vt cv
        cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wi wi wi
        vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa vt cv cF cfv cX wcel vt
        cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa vu cv vf
        cv cle wbr vf cv vu cv cif vt cv cle wbr wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr wa vt cv cH cfv cA cB cU cpv cfv co cU
        cnsb cfv co cN cfv vv cv clt wbr wi vt cv cF cfv cX wcel vt cv cF cfv
        cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vu cv vf cv cle wbr
        vf cv vu cv cif vt cv cle wbr wph vv cv cr wcel wa vt cv cM cuz cfv
        wcel wa vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr wa vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv
        co cN cfv vv cv clt wbr wi wi wi vt cv cF cfv cX wcel wph vv cv cr wcel
        wa vt cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv
        cle wbr vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr wa vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN
        cfv vv cv clt wbr wi vt cv cF cfv cX wcel wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv
        cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        wa vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr
        wi wi wi vt cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle
        wbr vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt
        cv cF cfv cX wcel wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt
        cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr vt cv
        cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr wa vt cv cF cfv cX wcel wph vv cv cr wcel wa vt cv cM cuz cfv
        wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA
        cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr vt cv cG cfv cX
        wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt
        cv cF cfv cX wcel wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt
        cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vu cv vf cv
        cle wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA cB cU cpv cfv co
        cU cnsb cfv co cN cfv vv cv clt wbr wi wi wi vt cv cF cfv cX wcel wph
        vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cG cfv cX wcel vt cv
        cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv
        cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vu cv vf cv cle wbr
        vf cv vu cv cif vt cv cle wbr vt cv cH cfv cA cB cU cpv cfv co cU cnsb
        cfv co cN cfv vv cv clt wbr wi wi vt cv cF cfv cX wcel wph vv cv cr
        wcel wa vt cv cM cuz cfv wcel wa vt cv cG cfv cX wcel vt cv cG cfv cB
        cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cA cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr vu cv vf cv cle wbr vf cv vu cv
        cif vt cv cle wbr vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN
        cfv vv cv clt wbr wi wi wi wi vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa vt cv cG cfv cB cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cA cU cnsb cfv co
        cN cfv vv cv c2 cdiv co clt wbr vu cv vf cv cle wbr vf cv vu cv cif vt
        cv cle wbr vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv
        clt wbr wi wi wi vt cv cF cfv cX wcel vt cv cG cfv cX wcel wph vv cv cr
        wcel wa vt cv cM cuz cfv wcel wa vt cv cG cfv cB cU cnsb cfv co cN cfv
        vv cv c2 cdiv co clt wbr vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv
        cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wi wi wi
        vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cG cfv cB cU
        cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cA cU cnsb cfv
        co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cX wcel vt cv cG cfv cX
        wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cH cfv
        cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr vt cv cG cfv cB
        cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cA cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cX wcel vt cv cG
        cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv
        cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr wi wi wi
        vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa
        wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv
        cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cH cfv
        cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr vt cv cF cfv cX
        wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel
        wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt
        cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cH
        cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr vt cv cF
        cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz
        cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        w3a vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vt cv cF cfv
        vt cv cG cfv cU cpv cfv co cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv
        cv clt vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel
        wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr w3a vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co vt
        cv cF cfv vt cv cG cfv cU cpv cfv co cA cB cU cpv cfv co cU cnsb cfv co
        cN vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt
        cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr w3a vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co cA cB
        cU cpv cfv co cU cnsb cfv vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa
        wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU
        cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cH cfv vt cv cF cfv
        vt cv cG cfv cU cpv cfv co wceq vt cv cG cfv cB cU cnsb cfv co cN cfv
        vv cv c2 cdiv co clt wbr wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa
        vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq vt cv cF cfv
        cX wcel vt cv cG cfv cX wcel wa wph vt cv cM cuz cfv wcel vt cv cH cfv
        vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq vv cv cr wcel vt cv cM cuz
        cfv wcel wph vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq
        vt cv cM cuz cfv wcel wph wa vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq wph vt cA cB
        cC cU vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1
        vacnlem1.2 vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem1 3simp3d
        ancoms adantlr adantl 3ad2ant1 opreq1d fveq2d vt cv cF cfv cX wcel vt
        cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa
        vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG
        cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr w3a vt cv cF cfv
        cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv co cN cfv
        vv cv c2 cdiv co vv cv c2 cdiv co caddc co vt cv cF cfv vt cv cG cfv cU
        cpv cfv co cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt vt cv cF
        cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz
        cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        w3a vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU
        cpv cfv co cN cfv vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv cG cfv cB
        cU cnsb cfv co cN cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc
        co vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt
        cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr w3a vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv
        co cU cpv cfv co cX wcel vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB
        cU cnsb cfv co cU cpv cfv co cN cfv cr wcel vt cv cF cfv cA cU cnsb cfv
        co cX wcel vt cv cG cfv cB cU cnsb cfv co cX wcel vt cv cF cfv cA cU
        cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv co cX wcel vt cv
        cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv
        co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr w3a cU cnv wcel vt cv cF cfv cA cU cnsb cfv co cX wcel vt cv cG cfv
        cB cU cnsb cfv co cX wcel vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv
        cB cU cnsb cfv co cU cpv cfv co cX wcel vacn.9 vt cv cF cfv cA cU cnsb
        cfv co vt cv cG cfv cB cU cnsb cfv co cU cU cpv cfv cX vacn.1 cU cpv
        cfv eqid nvgcl mp3an1 vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph
        vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cA cU cnsb cfv co
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        vt cv cF cfv cX wcel cA cX wcel vt cv cF cfv cA cU cnsb cfv co cX wcel
        vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv
        cM cuz cfv wcel wa wa cU cnv wcel vt cv cF cfv cX wcel cA cX wcel vt cv
        cF cfv cA cU cnsb cfv co cX wcel vacn.9 vt cv cF cfv cA cU cU cnsb cfv
        cX vacn.1 cU cnsb cfv eqid nvmcl mp3an1 vt cv cF cfv cX wcel vt cv cG
        cfv cX wcel wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa simpll wph vv
        cv cr wcel wa vt cv cM cuz cfv wcel wa cA cX wcel vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel wa wph cA cX wcel vv cv cr wcel vt cv cM cuz cfv
        wcel wph cA cX wcel cB cX wcel wph cA cB cC cU vk cF cG cH cM cN cX
        vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4
        vacnlem1.5 vacnlem1.6 vacnlem2 pm3.26d ad2antrr adantl sylanc 3ad2ant1
        vt cv cG cfv cX wcel cB cX wcel vt cv cG cfv cB cU cnsb cfv co cX wcel
        vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv
        cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr w3a cU cnv wcel vt cv cG cfv cX wcel cB cX wcel vt cv cG cfv cB
        cU cnsb cfv co cX wcel vacn.9 vt cv cG cfv cB cU cU cnsb cfv cX vacn.1
        cU cnsb cfv eqid nvmcl mp3an1 vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU
        cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cX wcel vt cv
        cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv
        cX wcel vt cv cG cfv cX wcel wph vv cv cr wcel wa vt cv cM cuz cfv wcel
        wa simplr 3ad2ant1 vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv
        cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv
        co cN cfv vv cv c2 cdiv co clt wbr cB cX wcel vt cv cG cfv cB cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa cB cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa
        wph cB cX wcel vv cv cr wcel vt cv cM cuz cfv wcel wph cA cX wcel cB cX
        wcel wph cA cB cC cU vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9
        vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6
        vacnlem2 pm3.27d ad2antrr adantl 3ad2ant1 sylanc sylanc cU cnv wcel vt
        cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv
        co cX wcel vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv
        co cU cpv cfv co cN cfv cr wcel vacn.9 vt cv cF cfv cA cU cnsb cfv co
        vt cv cG cfv cB cU cnsb cfv co cU cpv cfv co cU cN cX vacn.1 vacn.6
        nvcl mpan syl vt cv cF cfv cA cU cnsb cfv co cN cfv cr wcel vt cv cG
        cfv cB cU cnsb cfv co cN cfv cr wcel vt cv cF cfv cA cU cnsb cfv co cN
        cfv vt cv cG cfv cB cU cnsb cfv co cN cfv caddc co cr wcel vt cv cF cfv
        cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv
        wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr w3a
        vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv cG cfv cB cU cnsb cfv co cN
        cfv readdcl vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr
        wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr w3a vt cv cF cfv cA cU cnsb cfv co cX wcel vt cv
        cF cfv cA cU cnsb cfv co cN cfv cr wcel vt cv cF cfv cX wcel cA cX wcel
        vt cv cF cfv cA cU cnsb cfv co cX wcel vt cv cF cfv cX wcel vt cv cG
        cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv
        cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv
        cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr w3a cU cnv wcel vt cv
        cF cfv cX wcel cA cX wcel vt cv cF cfv cA cU cnsb cfv co cX wcel vacn.9
        vt cv cF cfv cA cU cU cnsb cfv cX vacn.1 cU cnsb cfv eqid nvmcl mp3an1
        vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv
        cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vt cv cF cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN
        cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa simpll 3ad2ant1 vt cv cF
        cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz
        cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co
        clt wbr cA cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv
        co clt wbr wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa cA cX wcel vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph cA cX wcel vv cv cr wcel
        vt cv cM cuz cfv wcel wph cA cX wcel cB cX wcel wph cA cB cC cU vk cF
        cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2
        vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem2 pm3.26d ad2antrr
        adantl 3ad2ant1 sylanc cU cnv wcel vt cv cF cfv cA cU cnsb cfv co cX
        wcel vt cv cF cfv cA cU cnsb cfv co cN cfv cr wcel vacn.9 vt cv cF cfv
        cA cU cnsb cfv co cU cN cX vacn.1 vacn.6 nvcl mpan syl vt cv cF cfv cX
        wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel
        wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt
        cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr w3a vt cv
        cG cfv cB cU cnsb cfv co cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv
        cr wcel vt cv cG cfv cX wcel cB cX wcel vt cv cG cfv cB cU cnsb cfv co
        cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel
        wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr w3a cU cnv wcel vt cv cG cfv cX wcel cB cX wcel vt cv
        cG cfv cB cU cnsb cfv co cX wcel vacn.9 vt cv cG cfv cB cU cU cnsb cfv
        cX vacn.1 cU cnsb cfv eqid nvmcl mp3an1 vt cv cF cfv cX wcel vt cv cG
        cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv
        cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv
        cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        vt cv cF cfv cX wcel vt cv cG cfv cX wcel wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa simplr 3ad2ant1 vt cv cF cfv cX wcel vt cv cG cfv cX
        wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv
        cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr cB cX wcel vt cv cG
        cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wph vv cv cr wcel
        wa vt cv cM cuz cfv wcel wa cB cX wcel vt cv cF cfv cX wcel vt cv cG
        cfv cX wcel wa wph cB cX wcel vv cv cr wcel vt cv cM cuz cfv wcel wph
        cA cX wcel cB cX wcel wph cA cB cC cU vk cF cG cH cM cN cX vacn.1
        vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4
        vacnlem1.5 vacnlem1.6 vacnlem2 pm3.27d ad2antrr adantl 3ad2ant1 sylanc
        cU cnv wcel vt cv cG cfv cB cU cnsb cfv co cX wcel vt cv cG cfv cB cU
        cnsb cfv co cN cfv cr wcel vacn.9 vt cv cG cfv cB cU cnsb cfv co cU cN
        cX vacn.1 vacn.6 nvcl mpan syl sylanc vv cv c2 cdiv co cr wcel vv cv c2
        cdiv co cr wcel vv cv c2 cdiv co vv cv c2 cdiv co caddc co cr wcel vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv
        co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr w3a vv cv c2 cdiv co vv cv c2 cdiv co readdcl vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa
        wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vv cv
        c2 cdiv co cr wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv
        co clt wbr wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa vv cv c2 cdiv
        co cr wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa vv cv cr wcel
        vv cv c2 cdiv co cr wcel wph vt cv cM cuz cfv wcel vv cv rehalfcl
        ad2antlr adantl 3ad2ant1 vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa
        wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU
        cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vv cv c2 cdiv co cr wcel vt
        cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wph vv cv
        cr wcel wa vt cv cM cuz cfv wcel wa vv cv c2 cdiv co cr wcel vt cv cF
        cfv cX wcel vt cv cG cfv cX wcel wa vv cv cr wcel vv cv c2 cdiv co cr
        wcel wph vt cv cM cuz cfv wcel vv cv rehalfcl ad2antlr adantl 3ad2ant1
        sylanc vt cv cF cfv cA cU cnsb cfv co cX wcel vt cv cG cfv cB cU cnsb
        cfv co cX wcel vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb
        cfv co cU cpv cfv co cN cfv vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv
        cG cfv cB cU cnsb cfv co cN cfv caddc co cle wbr vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa
        wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv
        cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr w3a cU cnv
        wcel vt cv cF cfv cA cU cnsb cfv co cX wcel vt cv cG cfv cB cU cnsb cfv
        co cX wcel vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv
        co cU cpv cfv co cN cfv vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv cG
        cfv cB cU cnsb cfv co cN cfv caddc co cle wbr vacn.9 vt cv cF cfv cA cU
        cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cU cpv cfv cN cX vacn.1
        cU cpv cfv eqid vacn.6 nvtri mp3an1 vt cv cF cfv cX wcel vt cv cG cfv
        cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF
        cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cF cfv cA
        cU cnsb cfv co cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vt cv cF cfv cX wcel cA cX wcel vt cv cF cfv cA cU cnsb
        cfv co cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv
        cr wcel wa vt cv cM cuz cfv wcel wa wa cU cnv wcel vt cv cF cfv cX wcel
        cA cX wcel vt cv cF cfv cA cU cnsb cfv co cX wcel vacn.9 vt cv cF cfv
        cA cU cU cnsb cfv cX vacn.1 cU cnsb cfv eqid nvmcl mp3an1 vt cv cF cfv
        cX wcel vt cv cG cfv cX wcel wph vv cv cr wcel wa vt cv cM cuz cfv wcel
        wa simpll wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa cA cX wcel vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph cA cX wcel vv cv cr wcel
        vt cv cM cuz cfv wcel wph cA cX wcel cB cX wcel wph cA cB cC cU vk cF
        cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2
        vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem2 pm3.26d ad2antrr
        adantl sylanc 3ad2ant1 vt cv cG cfv cX wcel cB cX wcel vt cv cG cfv cB
        cU cnsb cfv co cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph
        vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co
        cN cfv vv cv c2 cdiv co clt wbr w3a cU cnv wcel vt cv cG cfv cX wcel cB
        cX wcel vt cv cG cfv cB cU cnsb cfv co cX wcel vacn.9 vt cv cG cfv cB
        cU cU cnsb cfv cX vacn.1 cU cnsb cfv eqid nvmcl mp3an1 vt cv cF cfv cX
        wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel
        wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt
        cv cG cfv cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv
        co clt wbr vt cv cF cfv cX wcel vt cv cG cfv cX wcel wph vv cv cr wcel
        wa vt cv cM cuz cfv wcel wa simplr 3ad2ant1 vt cv cF cfv cX wcel vt cv
        cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt
        cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr cB cX wcel
        vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wph vv
        cv cr wcel wa vt cv cM cuz cfv wcel wa cB cX wcel vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel wa wph cB cX wcel vv cv cr wcel vt cv cM cuz cfv
        wcel wph cA cX wcel cB cX wcel wph cA cB cC cU vk cF cG cH cM cN cX
        vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4
        vacnlem1.5 vacnlem1.6 vacnlem2 pm3.27d ad2antrr adantl 3ad2ant1 sylanc
        sylanc vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel
        wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv
        cv c2 cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2
        cdiv co clt wbr vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv cG cfv cB
        cU cnsb cfv co cN cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc
        co clt wbr vt cv cF cfv cA cU cnsb cfv co cN cfv cr wcel vt cv cG cfv
        cB cU cnsb cfv co cN cfv cr wcel vv cv c2 cdiv co cr wcel vv cv c2 cdiv
        co cr wcel vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt
        wbr vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr wa
        vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv cG cfv cB cU cnsb cfv co cN
        cfv caddc co vv cv c2 cdiv co vv cv c2 cdiv co caddc co clt wbr wi vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cN cfv vt cv cG cfv
        cB cU cnsb cfv co cN cfv vv cv c2 cdiv co vv cv c2 cdiv co lt2add vt cv
        cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa wa vt cv cF cfv cA cU cnsb cfv co cX wcel vt cv cF cfv
        cA cU cnsb cfv co cN cfv cr wcel vt cv cF cfv cX wcel cA cX wcel vt cv
        cF cfv cA cU cnsb cfv co cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX
        wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa cU cnv wcel vt
        cv cF cfv cX wcel cA cX wcel vt cv cF cfv cA cU cnsb cfv co cX wcel
        vacn.9 vt cv cF cfv cA cU cU cnsb cfv cX vacn.1 cU cnsb cfv eqid nvmcl
        mp3an1 vt cv cF cfv cX wcel vt cv cG cfv cX wcel wph vv cv cr wcel wa
        vt cv cM cuz cfv wcel wa simpll wph vv cv cr wcel wa vt cv cM cuz cfv
        wcel wa cA cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph cA
        cX wcel vv cv cr wcel vt cv cM cuz cfv wcel wph cA cX wcel cB cX wcel
        wph cA cB cC cU vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9
        vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6
        vacnlem2 pm3.26d ad2antrr adantl sylanc cU cnv wcel vt cv cF cfv cA cU
        cnsb cfv co cX wcel vt cv cF cfv cA cU cnsb cfv co cN cfv cr wcel
        vacn.9 vt cv cF cfv cA cU cnsb cfv co cU cN cX vacn.1 vacn.6 nvcl mpan
        syl vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa
        vt cv cM cuz cfv wcel wa wa vt cv cG cfv cB cU cnsb cfv co cX wcel vt
        cv cG cfv cB cU cnsb cfv co cN cfv cr wcel vt cv cG cfv cX wcel cB cX
        wcel vt cv cG cfv cB cU cnsb cfv co cX wcel vt cv cF cfv cX wcel vt cv
        cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa cU
        cnv wcel vt cv cG cfv cX wcel cB cX wcel vt cv cG cfv cB cU cnsb cfv co
        cX wcel vacn.9 vt cv cG cfv cB cU cU cnsb cfv cX vacn.1 cU cnsb cfv
        eqid nvmcl mp3an1 vt cv cF cfv cX wcel vt cv cG cfv cX wcel wph vv cv
        cr wcel wa vt cv cM cuz cfv wcel wa simplr wph vv cv cr wcel wa vt cv
        cM cuz cfv wcel wa cB cX wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        wa wph cB cX wcel vv cv cr wcel vt cv cM cuz cfv wcel wph cA cX wcel cB
        cX wcel wph cA cB cC cU vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8
        vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4 vacnlem1.5
        vacnlem1.6 vacnlem2 pm3.27d ad2antrr adantl sylanc cU cnv wcel vt cv cG
        cfv cB cU cnsb cfv co cX wcel vt cv cG cfv cB cU cnsb cfv co cN cfv cr
        wcel vacn.9 vt cv cG cfv cB cU cnsb cfv co cU cN cX vacn.1 vacn.6 nvcl
        mpan syl wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa vv cv c2 cdiv co
        cr wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa vv cv cr wcel vv
        cv c2 cdiv co cr wcel wph vt cv cM cuz cfv wcel vv cv rehalfcl ad2antlr
        adantl wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa vv cv c2 cdiv co
        cr wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa vv cv cr wcel vv
        cv c2 cdiv co cr wcel wph vt cv cM cuz cfv wcel vv cv rehalfcl ad2antlr
        adantl syl2anc 3impib lelttrd vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa vt cv cF cfv cA cU
        cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv cG cfv cB cU cnsb cfv
        co cN cfv vv cv c2 cdiv co clt wbr w3a vt cv cF cfv vt cv cG cfv cU cpv
        cfv co cA cB cU cpv cfv co cU cnsb cfv co vt cv cF cfv cA cU cnsb cfv
        co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv co cN vt cv cF cfv cX wcel
        vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa
        wa vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vt cv
        cF cfv vt cv cG cfv cU cpv cfv co cA cB cU cpv cfv co cU cnsb cfv co vt
        cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv
        co wceq vt cv cG cfv cB cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr
        vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv
        cF cfv vt cv cG cfv cU cpv cfv co cA cB cU cpv cfv co cU cnsb cfv co vt
        cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv
        co wceq vt cv cM cuz cfv wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel
        wa wph vt cv cF cfv vt cv cG cfv cU cpv cfv co cA cB cU cpv cfv co cU
        cnsb cfv co vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv
        co cU cpv cfv co wceq vv cv cr wcel vt cv cF cfv cX wcel vt cv cG cfv
        cX wcel wa cA cX wcel cB cX wcel wa vt cv cF cfv vt cv cG cfv cU cpv
        cfv co cA cB cU cpv cfv co cU cnsb cfv co vt cv cF cfv cA cU cnsb cfv
        co vt cv cG cfv cB cU cnsb cfv co cU cpv cfv co wceq wph cU cnv wcel vt
        cv cF cfv cX wcel vt cv cG cfv cX wcel wa cA cX wcel cB cX wcel wa vt
        cv cF cfv vt cv cG cfv cU cpv cfv co cA cB cU cpv cfv co cU cnsb cfv co
        vt cv cF cfv cA cU cnsb cfv co vt cv cG cfv cB cU cnsb cfv co cU cpv
        cfv co wceq vacn.9 vt cv cF cfv vt cv cG cfv cA cB cU cU cpv cfv cU
        cnsb cfv cX vacn.1 cU cpv cfv eqid cU cnsb cfv eqid nvaddsub4 mp3an1
        wph cA cB cC cU vk cF cG cH cM cN cX vacn.1 vacn.6 vacn.8 vacn.9
        vacnlem1.1 vacnlem1.2 vacnlem1.3 vacnlem1.4 vacnlem1.5 vacnlem1.6
        vacnlem2 sylan2 adantrr adantrr 3ad2ant1 fveq2d vt cv cF cfv cX wcel vt
        cv cG cfv cX wcel wa wph vv cv cr wcel wa vt cv cM cuz cfv wcel wa wa
        vt cv cF cfv cA cU cnsb cfv co cN cfv vv cv c2 cdiv co clt wbr vv cv vv
        cv c2 cdiv co vv cv c2 cdiv co caddc co wceq vt cv cG cfv cB cU cnsb
        cfv co cN cfv vv cv c2 cdiv co clt wbr wph vv cv cr wcel wa vt cv cM
        cuz cfv wcel wa vv cv vv cv c2 cdiv co vv cv c2 cdiv co caddc co wceq
        vt cv cF cfv cX wcel vt cv cG cfv cX wcel wa vv cv cr wcel vv cv vv cv
        c2 cdiv co vv cv c2 cdiv co caddc co wceq wph vt cv cM cuz cfv wcel vv
        cv cr wcel vv cv cc wcel vv cv vv cv c2 cdiv co vv cv c2 cdiv co caddc
        co wceq vv cv recn vv cv cc wcel vv cv c2 cdiv co vv cv c2 cdiv co
        caddc co vv cv vv cv 2halves eqcomd syl ad2antlr adantl 3ad2ant1
        3brtr4d eqbrtrd 3exp com13 a1i com14 exp31 com23 imp com3l imp com24
        com14 ex com24 imp com13 adantlr imp syld com23 syld ex com3l com14 imp
        com12 ex adantlrr imp41 jca exp31 wph vv cv cr wcel cc0 vv cv clt wbr
        wa wa vu cv cM cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz
        cfv wcel wa vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cU
        cnsb cfv co cN cfv vv cv clt wbr wa vt cv cH cfv cX wcel vt cv cH cfv
        cA cB cU cpv cfv co cC co vv cv clt wbr wa vu cv vf cv cle wbr vf cv vu
        cv cif vt cv cle wbr wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM
        cuz cfv wcel vf cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vt cv
        cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv vv cv clt wbr vt cv cH
        cfv cA cB cU cpv cfv co cC co vv cv clt wbr vt cv cH cfv cX wcel wph vv
        cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf cv cM cuz
        cfv wcel wa wa vt cv cM cuz cfv wcel wa vt cv cH cfv cA cB cU cpv cfv
        co cU cnsb cfv co cN cfv vt cv cH cfv cA cB cU cpv cfv co cC co vv cv
        clt wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa vt cv cH cfv cA cB cU
        cpv cfv co cC co vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv
        vt cv cH cfv cX wcel cA cB cU cpv cfv co cX wcel vt cv cH cfv cA cB cU
        cpv cfv co cC co vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv
        wceq wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv cM cuz cfv wcel vf
        cv cM cuz cfv wcel wa wa vt cv cM cuz cfv wcel wa cU cnv wcel vt cv cH
        cfv cX wcel cA cB cU cpv cfv co cX wcel vt cv cH cfv cA cB cU cpv cfv
        co cC co vt cv cH cfv cA cB cU cpv cfv co cU cnsb cfv co cN cfv wceq
        vacn.9 vt cv cH cfv cA cB cU cpv cfv co cC cU cU cnsb cfv cN cX vacn.1
        cU cnsb cfv eqid vacn.6 vacn.8 imsdval mp3an1 wph vv cv cr wcel cc0 vv
        cv clt wbr wa wa vt cv cM cuz cfv wcel vt cv cH cfv cX wcel vu cv cM
        cuz cfv wcel vf cv cM cuz cfv wcel wa wph vt cv cM cuz cfv wcel vt cv
        cH cfv cX wcel vv cv cr wcel cc0 vv cv clt wbr wa vt cv cM cuz cfv wcel
        wph vt cv cH cfv cX wcel vt cv cM cuz cfv wcel wph wa vt cv cF cfv cX
        wcel vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv
        cfv co wceq w3a vt cv cH cfv cX wcel wph vt cA cB cC cU vk cF cG cH cM
        cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3
        vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem1 vt cv cF cfv cX wcel vt cv cG
        cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq
        w3a vt cv cH cfv cX wcel vt cv cF cfv vt cv cG cfv cU cpv cfv co cX
        wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv cF cfv vt cv cG
        cfv cU cpv cfv co cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU cpv
        cfv co wceq cU cnv wcel vt cv cF cfv cX wcel vt cv cG cfv cX wcel vt cv
        cF cfv vt cv cG cfv cU cpv cfv co cX wcel vacn.9 vt cv cF cfv vt cv cG
        cfv cU cU cpv cfv cX vacn.1 cU cpv cfv eqid nvgcl mp3an1 3adant3 vt cv
        cH cfv vt cv cF cfv vt cv cG cfv cU cpv cfv co wceq vt cv cF cfv cX
        wcel vt cv cH cfv cX wcel vt cv cF cfv vt cv cG cfv cU cpv cfv co cX
        wcel wb vt cv cG cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cG cfv cU
        cpv cfv co cX eleq1 3ad2ant3 mpbird syl ancoms adantlr adantlr wph vv
        cv cr wcel cc0 vv cv clt wbr wa wa cA cB cU cpv cfv co cX wcel vu cv cM
        cuz cfv wcel vf cv cM cuz cfv wcel wa vt cv cM cuz cfv wcel wph cA cB
        cU cpv cfv co cX wcel vv cv cr wcel cc0 vv cv clt wbr wa wph cA cX wcel
        cB cX wcel wa cA cB cU cpv cfv co cX wcel wph cA cB cC cU vk cF cG cH
        cM cN cX vacn.1 vacn.6 vacn.8 vacn.9 vacnlem1.1 vacnlem1.2 vacnlem1.3
        vacnlem1.4 vacnlem1.5 vacnlem1.6 vacnlem2 cU cnv wcel cA cX wcel cB cX
        wcel cA cB cU cpv cfv co cX wcel vacn.9 cA cB cU cU cpv cfv cX vacn.1
        cU cpv cfv eqid nvgcl mp3an1 syl adantr ad2antrr sylanc eqcomd breq1d
        anbi2d imbi2d sylibd sylbid syld r19.20dva vu cv cM cuz cfv wcel vf cv
        cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu cv cif vt cv cle wbr vt
        cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr
        wa wi vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv
        cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wral
        vh cM cuz cfv wrex wi wph vv cv cr wcel cc0 vv cv clt wbr wa wa vu cv
        cM cuz cfv wcel vf cv cM cuz cfv wcel wa vu cv vf cv cle wbr vf cv vu
        cv cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv
        co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh cv vt cv cle wbr vt
        cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr
        wa wi vt cM cuz cfv wral vh cM cuz cfv wrex vu cv vf cv cle wbr vf cv
        vu cv cif cM cuz cfv wcel vu cv vf cv cle wbr vf cv vu cv cif vt cv cle
        wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv
        clt wbr wa wi vt cM cuz cfv wral vh cv vt cv cle wbr vt cv cH cfv cX
        wcel vt cv cH cfv cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM
        cuz cfv wral vh cM cuz cfv wrex vu cv cM cuz cfv wcel vf cv cM cuz cfv
        wcel wa vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU
        cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vu cv vf cv cle
        wbr vf cv vu cv cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA
        cB cU cpv cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv wral vh vu cv
        vf cv cle wbr vf cv vu cv cif cM cuz cfv vh cv vu cv vf cv cle wbr vf
        cv vu cv cif wceq vh cv vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv
        cA cB cU cpv cfv co cC co vv cv clt wbr wa wi vu cv vf cv cle wbr vf cv
        vu cv cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv
        cfv co cC co vv cv clt wbr wa wi vt cM cuz cfv vh cv vu cv vf cv cle
        wbr vf cv vu cv cif wceq vh cv vt cv cle wbr vu cv vf cv cle wbr vf cv
        vu cv cif vt cv cle wbr vt cv cH cfv cX wcel vt cv cH cfv cA cB cU cpv
        cfv co cC co vv cv clt wbr wa vh cv vu cv vf cv cle wbr vf cv vu cv cif
        vt cv cle breq1 imbi1d ralbidv rcla4ev vu cv cM cuz cfv wcel vf cv cM
        cuz cfv wcel wa vu cv cz wcel cM vu cv cle wbr wa vf cv cz wcel cM vf
        cv cle wbr wa wa vu cv vf cv cle wbr vf cv vu cv cif cz wcel cM vu cv
        vf cv cle wbr vf cv vu cv cif cle wbr wa vu cv vf cv cle wbr vf cv vu
        cv cif cM cuz cfv wcel vu cv cM cuz cfv wcel vu cv cz wcel cM vu cv cle
        wbr wa vf cv cM cuz cfv wcel vf cv cz wcel cM vf cv cle wbr wa vu cv cM
        cuz cfv wcel vu cv cz wcel cM vu cv cle wbr wa cM vu cv vacnlem.8
        eluz1i biimpi vf cv cM cuz cfv wcel vf cv cz wcel cM vf cv cle wbr wa
        cM vf cv vacnlem.8 eluz1i biimpi anim12i vu cv cz wcel cM vu cv cle wbr
        wa vf cv cz wcel cM vf cv cle wbr wa wa vu cv vf cv cle wbr vf cv vu cv
        cif cz wcel cM vu cv vf cv cle wbr vf cv vu cv cif cle wbr vu cv cz
        wcel vf cv cz wcel vu cv vf cv cle wbr vf cv vu cv cif cz wcel cM vu cv
        cle wbr cM vf cv cle wbr vf cv cz wcel vu cv cz wcel vu cv vf cv cle
        wbr vf cv vu cv cif cz wcel vu cv vf cv cle wbr vf cv vu cv cz ifcl
        ancoms ad2ant2r vu cv cz wcel vf cv cz wcel cM vf cv cle wbr wa cM vu
        cv vf cv cle wbr vf cv vu cv cif cle wbr cM vu cv cle wbr vf cv cz wcel
        cM vf cv cle wbr wa vu cv cz wcel cM vu cv vf cv cle wbr vf cv vu cv
        cif cle wbr vf cv cz wcel cM vf cv cle wbr vu cv cz wcel cM vu cv vf cv
        cle wbr vf cv vu cv cif cle wbr wi vf cv cz wcel vu cv cz wcel cM vf cv
        cle wbr cM vu cv vf cv cle wbr vf cv vu cv cif cle wbr vf cv cz wcel vu
        cv cz wcel cM vf cv cle wbr cM vu cv vf cv cle wbr vf cv vu cv cif cle
        wbr wi vf cv cr wcel vu cv cr wcel cM vf cv cle wbr cM vu cv vf cv cle
        wbr vf cv vu cv cif cle wbr wi vf cv cz wcel vu cv cz wcel vu cv cr
        wcel vf cv cr wcel cM vf cv cle wbr cM vu cv vf cv cle wbr vf cv vu cv
        cif cle wbr wi vu cv cr wcel vf cv cr wcel wa cM vf cv cle wbr vf cv vu
        cv vf cv cle wbr vf cv vu cv cif cle wbr cM vu cv vf cv cle wbr vf cv
        vu cv cif cle wbr vu cv vf cv max2 vu cv cr wcel vf cv cr wcel wa vu cv
        vf cv cle wbr vf cv vu cv cif cr wcel cM vf cv cle wbr vf cv vu cv vf
        cv cle wbr vf cv vu cv cif cle wbr wa cM vu cv vf cv cle wbr vf cv vu
        cv cif cle wbr wi vf cv cr wcel vu cv cr wcel vu cv vf cv cle wbr vf cv
        vu cv cif cr wcel vu cv vf cv cle wbr vf cv vu cv cr ifcl ancoms vf cv
        cr wcel vu cv vf cv cle wbr vf cv vu cv cif cr wcel cM vf cv cle wbr vf
        cv vu cv vf cv cle wbr vf cv vu cv cif cle wbr wa cM vu cv vf cv cle
        wbr vf cv vu cv cif cle wbr wi wi vu cv cr wcel vf cv cr wcel vu cv vf
        cv cle wbr vf cv vu cv cif cr wcel cM vf cv cle wbr vf cv vu cv vf cv
        cle wbr vf cv vu cv cif cle wbr wa cM vu cv vf cv cle wbr vf cv vu cv
        cif cle wbr wi cM cr wcel vf cv cr wcel vu cv vf cv cle wbr vf cv vu cv
        cif cr wcel cM vf cv cle wbr vf cv vu cv vf cv cle wbr vf cv vu cv cif
        cle wbr wa cM vu cv vf cv cle wbr vf cv vu cv cif cle wbr wi cM
        vacnlem.8 zrei cM vf cv vu cv vf cv cle wbr vf cv vu cv cif letr mp3an1
        ex adantl mpd mpan2d ancoms vf cv zre vu cv zre syl2an ex com23 imp
        impcom adantlr jca vu cv vf cv cle wbr vf cv vu cv cif cM cuz cfv wcel
        vu cv vf cv cle wbr vf cv vu cv cif cz wcel cM vu cv vf cv cle wbr vf
        cv vu cv cif cle wbr wa cM vu cv vf cv cle wbr vf cv vu cv cif
        vacnlem.8 eluz1i biimpri 3syl sylan ex adantl syld vu cv vt cv cle wbr
        vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2 cdiv co clt wbr wa
        wi vf cv vg cv cle wbr vg cv cG cfv cX wcel vg cv cG cfv cB cC co vv cv
        c2 cdiv co clt wbr wa wi vt vg cM cuz cfv raaanv syl5ibr ex r19.23advv
        vu cv vt cv cle wbr vt cv cF cfv cX wcel vt cv cF cfv cA cC co vv cv c2
        cdiv co clt wbr wa wi vt cM cuz cfv wral vf cv vg cv cle wbr vg cv cG
        cfv cX wcel vg cv cG cfv cB cC co vv cv c2 cdiv co clt wbr wa wi vg cM
        cuz cfv wral vu vf cM cuz cfv cM cuz cfv reeanv syl5ibr mpd exp32
        r19.21aiv sylc $.
        $( [21-Jun-2009] $) $( [12-Jun-2009] $)
    $}

    ${
      $d k U $.  $d k X $.  $d k N $.  $d k C $.  $d k F $.  $d k G $.
      $d k H $.  $d k A $.  $d k B $.  $d k M $.
      vacnlem4.1 $e |- F e. _V $.
      vacnlem4.2 $e |- G e. _V $.
      vacnlem4.3 $e |- A e. _V $.
      vacnlem4.4 $e |- B e. _V $.
      $( Lemma for ~ vacn . $)
      vacnlem4 $p |- ( ( H C_ ( CC X. X ) /\ ( ( M e. ZZ /\ F ( ~~>m ` C ) A
  /\ G ( ~~>m ` C ) B ) /\ A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. X
  /\ ( G ` k ) e. X /\ ( H ` k ) = ( ( F ` k ) ( +v ` U ) ( G ` k ) ) ) ) )
         -> H ( ~~>m ` C ) ( A ( +v ` U ) B ) ) $=
        cH cc cX cxp wss cM cz wcel cF cA cC clm cfv wbr cG cB cC clm cfv wbr
        w3a vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv
        vk cv cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral wa cH cA cB cU
        cpv cfv co cC clm cfv wbr cH cc cX cxp wss cM cz wcel cF cA cC clm cfv
        wbr cG cB cC clm cfv wbr w3a vk cv cF cfv cX wcel vk cv cG cfv cX wcel
        vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cuz
        cfv wral wa cH cA cB cU cpv cfv co cC clm cfv wbr wi cM cz wcel cF cA
        cC clm cfv wbr cG cB cC clm cfv wbr w3a vk cv cF cfv cX wcel vk cv cG
        cfv cX wcel vk cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG
        cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral wa cH cc cX cxp wss cH c0
        cif cA cB cU cpv cfv co cC clm cfv wbr wi cH c0 cH cH cc cX cxp wss cH
        c0 cif wceq cM cz wcel cF cA cC clm cfv wbr cG cB cC clm cfv wbr w3a vk
        cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv
        cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral wa cM cz wcel cF cA cC
        clm cfv wbr cG cB cC clm cfv wbr w3a vk cv cF cfv cX wcel vk cv cG cfv
        cX wcel vk cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv
        cU cpv cfv co wceq w3a vk cM cuz cfv wral wa cH cA cB cU cpv cfv co cC
        clm cfv wbr cH cc cX cxp wss cH c0 cif cA cB cU cpv cfv co cC clm cfv
        wbr cH cH cc cX cxp wss cH c0 cif wceq vk cv cF cfv cX wcel vk cv cG
        cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq
        w3a vk cM cuz cfv wral vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv
        cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co
        wceq w3a vk cM cuz cfv wral cM cz wcel cF cA cC clm cfv wbr cG cB cC
        clm cfv wbr w3a cH cH cc cX cxp wss cH c0 cif wceq vk cv cF cfv cX wcel
        vk cv cG cfv cX wcel vk cv cH cfv vk cv cF cfv vk cv cG cfv cU cpv cfv
        co wceq w3a vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX
        cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a
        vk cM cuz cfv cH cH cc cX cxp wss cH c0 cif wceq vk cv cH cfv vk cv cF
        cfv vk cv cG cfv cU cpv cfv co wceq vk cv cH cc cX cxp wss cH c0 cif
        cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq vk cv cF cfv cX wcel
        vk cv cG cfv cX wcel cH cH cc cX cxp wss cH c0 cif wceq vk cv cH cfv vk
        cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv
        co vk cv cH cH cc cX cxp wss cH c0 cif fveq1 eqeq1d 3anbi3d ralbidv
        anbi2d cH cH cc cX cxp wss cH c0 cif cA cB cU cpv cfv co cC clm cfv
        breq1 imbi12d cM cz wcel cF cA cC clm cfv wbr cG cB cC clm cfv wbr vk
        cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX cxp wss cH c0 cif
        cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral
        cH cc cX cxp wss cH c0 cif cA cB cU cpv cfv co cC clm cfv wbr cM cz
        wcel cF cA cC clm cfv wbr cG cB cC clm cfv wbr vk cv cF cfv cX wcel vk
        cv cG cfv cX wcel vk cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk
        cv cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral cH cc cX cxp wss cH
        c0 cif cA cB cU cpv cfv co cC clm cfv wbr cM cz wcel cF cA cC clm cfv
        wbr cG cB cC clm cfv wbr wa vk cv cF cfv cX wcel vk cv cG cfv cX wcel
        vk cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv
        cfv co wceq w3a vk cM cuz cfv wral wa cH cc cX cxp wss cH c0 cif cA cB
        cU cpv cfv co cC clm cfv wbr wi cF cA cC clm cfv wbr cG cB cC clm cfv
        wbr wa vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX cxp wss
        cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cz
        wcel cM c1 cif cuz cfv wral wa cH cc cX cxp wss cH c0 cif cA cB cU cpv
        cfv co cC clm cfv wbr wi cM c1 cM cM cz wcel cM c1 cif wceq cF cA cC
        clm cfv wbr cG cB cC clm cfv wbr wa vk cv cF cfv cX wcel vk cv cG cfv
        cX wcel vk cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv
        cU cpv cfv co wceq w3a vk cM cuz cfv wral wa cF cA cC clm cfv wbr cG cB
        cC clm cfv wbr wa vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc
        cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq
        w3a vk cM cz wcel cM c1 cif cuz cfv wral wa cH cc cX cxp wss cH c0 cif
        cA cB cU cpv cfv co cC clm cfv wbr cM cM cz wcel cM c1 cif wceq vk cv
        cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX cxp wss cH c0 cif
        cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cuz cfv wral
        vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX cxp wss cH c0
        cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cz wcel
        cM c1 cif cuz cfv wral cF cA cC clm cfv wbr cG cB cC clm cfv wbr wa cM
        cM cz wcel cM c1 cif wceq vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk
        cv cH cc cX cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv
        co wceq w3a vk cM cuz cfv cM cz wcel cM c1 cif cuz cfv cM cM cz wcel cM
        c1 cif cuz fveq2 raleq1d anbi2d imbi1d cF cA cC clm cfv wbr cG cB cC
        clm cfv wbr wa vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX
        cxp wss cH c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a
        vk cM cz wcel cM c1 cif cuz cfv wral wa cA cB cC cU vk cF cG cH cc cX
        cxp wss cH c0 cif cM cz wcel cM c1 cif cN cX vacn.1 vacn.6 vacn.8
        vacn.9 vacnlem4.1 vacnlem4.2 cH cc cX cxp wss cH cc cX cxp wss cH c0
        cif cvv wcel cH cc cX cxp wss cH cc cX cxp wss cH c0 cif cH cvv cH cc
        cX cxp wss cH c0 iftrue cH cc cX cxp cc cX axcnex cX cU cba cfv cvv
        vacn.1 cU cba fvex eqeltri xpex ssex eqeltrd cH cc cX cxp wss wn cH cc
        cX cxp wss cH c0 cif c0 cvv cH cc cX cxp wss cH c0 iffalse 0ex syl6eqel
        pm2.61i vacnlem4.3 vacnlem4.4 cF cA cC clm cfv wbr cG cB cC clm cfv wbr
        wa vk cv cF cfv cX wcel vk cv cG cfv cX wcel vk cv cH cc cX cxp wss cH
        c0 cif cfv vk cv cF cfv vk cv cG cfv cU cpv cfv co wceq w3a vk cM cz
        wcel cM c1 cif cuz cfv wral wa biid cH cc cX cxp wss cH cc cX cxp wss
        cH c0 cif cc cX cxp wss c0 cc cX cxp wss cH c0 cH cH cc cX cxp wss cH
        c0 cif cc cX cxp sseq1 c0 cH cc cX cxp wss cH c0 cif cc cX cxp sseq1 cc
        cX cxp 0ss elimhyp cM c1 cz 1z elimel vacnlem3 dedth exp4c 3imp1 dedth
        imp $.
        $( [21-Jun-2009] $) $( [14-Jun-2009] $)
    $}

    ${
      $d x y z h k m q r s t X $.  $d x y z h k m q r U $.
      $d x y z h k m q r t G $.  $d x y z h k m q r t C $.
      $d h m q t D $.  $d x y z h k m q r J $.  $d h k m q r K $.
      $d x y z h k m q r N $.  $d x y z m q t F $.  $d x y z m q t G $.
      $d x y z m q s t H $.  $d x y z m L $.
      vacn.2 $e |- G = ( +v ` U ) $.
      vacn.d $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( X X. X )
         /\ y e. ( X X. X ) ) /\ z = sup ( { ( ( 1st ` x ) C ( 1st ` y ) ) ,
                  ( ( 2nd ` x ) C ( 2nd ` y ) ) } , RR , < ) ) } $.
      vacn.j $e |- J = ( Open ` C ) $.
      vacn.k $e |- K = ( Open ` D ) $.
      vacn.f $e |- F
                = { <. k , r >. | ( k e. NN /\ r = ( 1st ` ( h ` k ) ) ) } $.
      vacn.g $e |- L
                = { <. k , r >. | ( k e. NN /\ r = ( 2nd ` ( h ` k ) ) ) } $.
      vacn.h $e |- H
                = { <. k , r >. | ( k e. NN /\ r = ( G ` ( h ` k ) ) ) } $.
      $( Lemma for ~ vacn . $)
      vacnlem5 $p |- ( ( h : NN --> ( X X. X ) /\ h ( ~~>m ` D ) q ) ->
             ( ( F ( ~~>m ` C ) ( 1st ` q ) /\ L ( ~~>m ` C ) ( 2nd ` q ) ) /\
                A. t e. ( ZZ>= ` 1 ) ( ( F ` t ) e. X /\ ( L ` t ) e. X /\
                        ( H ` t ) = ( ( F ` t ) ( +v ` U ) ( L ` t ) ) ) ) ) $=
        cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cF vq cv c1st cfv
        cC clm cfv wbr cL vq cv c2nd cfv cC clm cfv wbr wa vt cv cF cfv cX wcel
        vt cv cL cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cL cfv cU cpv cfv
        co wceq w3a vt c1 cuz cfv wral cn cX cX cxp vh cv wf vh cv vq cv cD clm
        cfv wbr wa cn cX cF wf cF vq cv c1st cfv cC clm cfv wbr wa cn cX cL wf
        cL vq cv c2nd cfv cC clm cfv wbr wa wa cF vq cv c1st cfv cC clm cfv wbr
        cL vq cv c2nd cfv cC clm cfv wbr wa vx vy vz vr cC cC cD vq cv c0 vk cF
        cL vh cv cX cX vq visset 0ex cC cU cX vacn.1 vacn.8 vacn.9 imsbai cC cU
        cX vacn.1 vacn.8 vacn.9 imsbai cU cnv wcel cC cme wcel vacn.9 cC cU
        vacn.8 imsmet ax-mp cU cnv wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet
        ax-mp vacn.d vacn.f vacn.g xplmi2 cn cX cF wf cF vq cv c1st cfv cC clm
        cfv wbr wa cF vq cv c1st cfv cC clm cfv wbr cn cX cL wf cL vq cv c2nd
        cfv cC clm cfv wbr wa cL vq cv c2nd cfv cC clm cfv wbr cn cX cF wf cF
        vq cv c1st cfv cC clm cfv wbr pm3.27 cn cX cL wf cL vq cv c2nd cfv cC
        clm cfv wbr pm3.27 anim12i syl cn cX cX cxp vh cv wf vh cv vq cv cD clm
        cfv wbr wa vt cv cF cfv cX wcel vt cv cL cfv cX wcel vt cv cH cfv vt cv
        cF cfv vt cv cL cfv cU cpv cfv co wceq w3a vt c1 cuz cfv cn cX cX cxp
        vh cv wf vh cv vq cv cD clm cfv wbr wa vt cv c1 cuz cfv wcel wa vt cv
        cF cfv cX wcel vt cv cL cfv cX wcel vt cv cH cfv vt cv cF cfv vt cv cL
        cfv cU cpv cfv co wceq cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr
        wa vt cv cn wcel vt cv cF cfv cX wcel vt cv c1 cuz cfv wcel cn cX cF wf
        cF vq cv c1st cfv cC clm cfv wbr wa cn cX cL wf cL vq cv c2nd cfv cC
        clm cfv wbr wa wa vt cv cn wcel vt cv cF cfv cX wcel cn cX cX cxp vh cv
        wf vh cv vq cv cD clm cfv wbr wa cn cX cF wf cF vq cv c1st cfv cC clm
        cfv wbr wa vt cv cn wcel vt cv cF cfv cX wcel cn cX cL wf cL vq cv c2nd
        cfv cC clm cfv wbr wa cn cX cF wf vt cv cn wcel vt cv cF cfv cX wcel cF
        vq cv c1st cfv cC clm cfv wbr cn cX vt cv cF ffvelrn adantlr adantlr vx
        vy vz vr cC cC cD vq cv c0 vk cF cL vh cv cX cX vq visset 0ex cC cU cX
        vacn.1 vacn.8 vacn.9 imsbai cC cU cX vacn.1 vacn.8 vacn.9 imsbai cU cnv
        wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet ax-mp cU cnv wcel cC cme
        wcel vacn.9 cC cU vacn.8 imsmet ax-mp vacn.d vacn.f vacn.g xplmi2 sylan
        vt cv elnnuz sylan2br cn cX cF wf cF vq cv c1st cfv cC clm cfv wbr wa
        cn cX cL wf cL vq cv c2nd cfv cC clm cfv wbr wa wa vt cv c1 cuz cfv
        wcel vt cv cL cfv cX wcel cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv
        wbr wa cn cX cL wf cL vq cv c2nd cfv cC clm cfv wbr wa vt cv c1 cuz cfv
        wcel vt cv cL cfv cX wcel cn cX cF wf cF vq cv c1st cfv cC clm cfv wbr
        wa cn cX cL wf vt cv c1 cuz cfv wcel vt cv cL cfv cX wcel cL vq cv c2nd
        cfv cC clm cfv wbr cn cX cL wf vt cv cn wcel vt cv cL cfv cX wcel vt cv
        c1 cuz cfv wcel cn cX vt cv cL ffvelrn vt cv elnnuz sylan2br adantlr
        adantll vx vy vz vr cC cC cD vq cv c0 vk cF cL vh cv cX cX vq visset
        0ex cC cU cX vacn.1 vacn.8 vacn.9 imsbai cC cU cX vacn.1 vacn.8 vacn.9
        imsbai cU cnv wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet ax-mp cU cnv
        wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet ax-mp vacn.d vacn.f vacn.g
        xplmi2 sylan cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa vt cv
        c1 cuz cfv wcel wa vt cv vh cv cfv cG cfv vt cv vh cv cfv c1st cfv vt
        cv vh cv cfv c2nd cfv cG co vt cv cH cfv vt cv cF cfv vt cv cL cfv cU
        cpv cfv co cn cX cX cxp vh cv wf vt cv c1 cuz cfv wcel vt cv vh cv cfv
        cG cfv vt cv vh cv cfv c1st cfv vt cv vh cv cfv c2nd cfv cG co wceq vh
        cv vq cv cD clm cfv wbr cn cX cX cxp vh cv wf vt cv c1 cuz cfv wcel wa
        vt cv vh cv cfv cG cfv vt cv vh cv cfv c1st cfv vt cv vh cv cfv c2nd
        cfv cop cG cfv vt cv vh cv cfv c1st cfv vt cv vh cv cfv c2nd cfv cG co
        cn cX cX cxp vh cv wf vt cv c1 cuz cfv wcel wa vt cv vh cv cfv vt cv vh
        cv cfv c1st cfv vt cv vh cv cfv c2nd cfv cop cG cn cX cX cxp vh cv wf
        vt cv c1 cuz cfv wcel wa vt cv vh cv cfv cX cX cxp wcel vt cv vh cv cfv
        vt cv vh cv cfv c1st cfv vt cv vh cv cfv c2nd cfv cop wceq cn cX cX cxp
        vh cv wf vt cv cn wcel vt cv vh cv cfv cX cX cxp wcel vt cv c1 cuz cfv
        wcel cn cX cX cxp vt cv vh cv ffvelrn vt cv elnnuz sylan2br vt cv vh cv
        cfv cX cX cxp wcel vt cv vh cv cfv vt cv vh cv cfv c1st cfv vt cv vh cv
        cfv c2nd cfv cop wceq vt cv vh cv cfv c1st cfv cX wcel vt cv vh cv cfv
        c2nd cfv cX wcel wa vt cv vh cv cfv cX cX elxp6 pm3.26bi syl fveq2d vt
        cv vh cv cfv c1st cfv vt cv vh cv cfv c2nd cfv cG df-opr syl6eqr
        adantlr vt cv c1 cuz cfv wcel vt cv cH cfv vt cv vh cv cfv cG cfv wceq
        cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa vt cv c1 cuz cfv
        wcel vt cv cn wcel vt cv cH cfv vt cv vh cv cfv cG cfv wceq vt cv
        elnnuz vk vr vt cv vk cv vh cv cfv cG cfv vt cv vh cv cfv cG cfv cn cH
        vk vt weq vk cv vh cv cfv vt cv vh cv cfv cG vk cv vt cv vh cv fveq2
        fveq2d vacn.h vt cv vh cv cfv cG fvex fvopab4 sylbir adantl vt cv c1
        cuz cfv wcel vt cv cF cfv vt cv cL cfv cU cpv cfv co vt cv vh cv cfv
        c1st cfv vt cv vh cv cfv c2nd cfv cG co wceq cn cX cX cxp vh cv wf vh
        cv vq cv cD clm cfv wbr wa vt cv c1 cuz cfv wcel vt cv cn wcel vt cv cF
        cfv vt cv cL cfv cU cpv cfv co vt cv vh cv cfv c1st cfv vt cv vh cv cfv
        c2nd cfv cG co wceq vt cv elnnuz vt cv cn wcel vt cv cF cfv vt cv cL
        cfv cG co vt cv vh cv cfv c1st cfv vt cv vh cv cfv c2nd cfv cG co vt cv
        cF cfv vt cv cL cfv cU cpv cfv co vt cv cn wcel vt cv cF cfv vt cv vh
        cv cfv c1st cfv vt cv cL cfv vt cv vh cv cfv c2nd cfv cG vk vr vt cv vk
        cv vh cv cfv c1st cfv vt cv vh cv cfv c1st cfv cn cF vk vt weq vk cv vh
        cv cfv vt cv vh cv cfv c1st vk cv vt cv vh cv fveq2 fveq2d vacn.f vt cv
        vh cv cfv c1st fvex fvopab4 vk vr vt cv vk cv vh cv cfv c2nd cfv vt cv
        vh cv cfv c2nd cfv cn cL vk vt weq vk cv vh cv cfv vt cv vh cv cfv c2nd
        vk cv vt cv vh cv fveq2 fveq2d vacn.g vt cv vh cv cfv c2nd fvex fvopab4
        opreq12d cU cpv cfv cG vt cv cF cfv vt cv cL cfv cG cU cpv cfv vacn.2
        eqcomi opreqi syl5eq sylbir adantl 3eqtr4d 3jca r19.21aiva jca $.
        $( [21-Jun-2009] $) $( [16-Jun-2009] $)

    $( Lemma for ~ vacn . $)
    vacnlem6 $p |- G e. ( K Cn J ) $=
      cG cK cJ ccn co wcel cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr cH
      vq cv cG cfv cC clm cfv wbr wi vq cX cX cxp wral wi vh cD cme wcel cC cme
      wcel cX cX cxp cX cG wf cG cK cJ ccn co wcel cn cX cX cxp vh cv wf vh cv
      vq cv cD clm cfv wbr cH vq cv cG cfv cC clm cfv wbr wi vq cX cX cxp wral
      wi vh wal wb vx vy vz cC cC cD cX cX cC cU cX vacn.1 vacn.8 vacn.9 imsbai
      cC cU cX vacn.1 vacn.8 vacn.9 imsbai cU cnv wcel cC cme wcel vacn.9 cC cU
      vacn.8 imsmet ax-mp cU cnv wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet
      ax-mp vacn.d metxp cU cnv wcel cC cme wcel vacn.9 cC cU vacn.8 imsmet
      ax-mp cU cnv wcel cX cX cxp cX cG wf vacn.9 cU cG cX vacn.1 vacn.2 nvgf
      ax-mp vq vr cD cC vh vk cG cH cK cJ cX cX cxp cX cD cdm cdm cX cX cxp cX
      cX cxp cxp cdm cX cX cxp cD cdm cX cX cxp cX cX cxp cxp vx vy vz cX cX
      cxp cX cX cxp vx cv c1st cfv vy cv c1st cfv cC co vx cv c2nd cfv vy cv
      c2nd cfv cC co cpr cr clt csup cD cr vx cv c1st cfv vy cv c1st cfv cC co
      vx cv c2nd cfv vy cv c2nd cfv cC co cpr clt ltso supex vacn.d dmoprab2
      dmeqi cX cX cxp dmxpid eqtr2i cC cU cX vacn.1 vacn.8 vacn.9 imsbai vacn.k
      vacn.j vacn.h metcn4 mp3an cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv
      wbr cH vq cv cG cfv cC clm cfv wbr wi vq cX cX cxp cn cX cX cxp vh cv wf
      vh cv vq cv cD clm cfv wbr cH vq cv cG cfv cC clm cfv wbr wi vq cv cX cX
      cxp wcel cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr cH vq cv cG cfv
      cC clm cfv wbr cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cF vq
      cv c1st cfv cC clm cfv wbr cL vq cv c2nd cfv cC clm cfv wbr wa vm cv cF
      cfv cX wcel vm cv cL cfv cX wcel vm cv cH cfv vm cv cF cfv vm cv cL cfv
      cU cpv cfv co wceq w3a vm c1 cuz cfv wral wa cH vq cv cG cfv cC clm cfv
      wbr vx vy vz vm cC cD cU vh vk cF cG cH cJ cK cL cN cX vr vq vacn.1
      vacn.6 vacn.8 vacn.9 vacn.2 vacn.d vacn.j vacn.k vacn.f vacn.g vacn.h
      vacnlem5 cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cF vq cv
      c1st cfv cC clm cfv wbr cL vq cv c2nd cfv cC clm cfv wbr wa vm cv cF cfv
      cX wcel vm cv cL cfv cX wcel vm cv cH cfv vm cv cF cfv vm cv cL cfv cU
      cpv cfv co wceq w3a vm c1 cuz cfv wral wa cH vq cv c1st cfv vq cv c2nd
      cfv cop cU cpv cfv cfv cC clm cfv wbr cH vq cv cG cfv cC clm cfv wbr cn
      cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cH cc cX cxp wss cF vq
      cv c1st cfv cC clm cfv wbr cL vq cv c2nd cfv cC clm cfv wbr wa vm cv cF
      cfv cX wcel vm cv cL cfv cX wcel vm cv cH cfv vm cv cF cfv vm cv cL cfv
      cU cpv cfv co wceq w3a vm c1 cuz cfv wral wa cH vq cv c1st cfv vq cv c2nd
      cfv cop cU cpv cfv cfv cC clm cfv wbr wi cn cX cX cxp vh cv wf cH cc cX
      cxp wss vh cv vq cv cD clm cfv wbr cn cX cX cxp vh cv wf vs vt cH cc cX
      cxp cH wrel cn cX cX cxp vh cv wf cH wrel vk cv cn wcel vr cv vk cv vh cv
      cfv cG cfv wceq wa vk vr copab wrel vk cv cn wcel vr cv vk cv vh cv cfv
      cG cfv wceq wa vk vr relopab cH vk cv cn wcel vr cv vk cv vh cv cfv cG
      cfv wceq wa vk vr copab vacn.h releqi mpbir a1i cn cX cX cxp vh cv wf vs
      cv cn wcel vt cv vs cv vh cv cfv cG cfv wceq wa vs cv vt cv cop cc cX cxp
      wcel vs cv vt cv cop cH wcel cn cX cX cxp vh cv wf vs cv cn wcel vt cv vs
      cv vh cv cfv cG cfv wceq wa vs cv cc wcel vt cv cX wcel wa vs cv vt cv
      cop cc cX cxp wcel cn cX cX cxp vh cv wf vs cv cn wcel vt cv vs cv vh cv
      cfv cG cfv wceq wa vs cv cc wcel vt cv cX wcel wa cn cX cX cxp vh cv wf
      vs cv cn wcel vt cv vs cv vh cv cfv cG cfv wceq wa wa vs cv cc wcel vt cv
      cX wcel vs cv cn wcel vs cv cc wcel cn cX cX cxp vh cv wf vt cv vs cv vh
      cv cfv cG cfv wceq vs cv nncn ad2antrl cn cX cX cxp vh cv wf vs cv cn
      wcel vt cv vs cv vh cv cfv cG cfv wceq wa wa vt cv vs cv vh cv cfv cG cfv
      cX cn cX cX cxp vh cv wf vs cv cn wcel vt cv vs cv vh cv cfv cG cfv wceq
      simprr cn cX cX cxp vh cv wf vs cv cn wcel vs cv vh cv cfv cG cfv cX wcel
      vt cv vs cv vh cv cfv cG cfv wceq cn cX cX cxp vh cv wf vs cv cn wcel wa
      vs cv vh cv cfv cX cX cxp wcel vs cv vh cv cfv cG cfv cX wcel cn cX cX
      cxp vs cv vh cv ffvelrn cX cX cxp cX vs cv vh cv cfv cG cU cnv wcel cX cX
      cxp cX cG wf vacn.9 cU cG cX vacn.1 vacn.2 nvgf ax-mp ffvelrni syl
      adantrr eqeltrd jca ex vs cv vt cv cc cX opelxpi syl6 vs cv vt cv cop cH
      wcel vs cv vt cv cop vk cv cn wcel vr cv vk cv vh cv cfv cG cfv wceq wa
      vk vr copab wcel vs cv cn wcel vt cv vs cv vh cv cfv cG cfv wceq wa vs cv
      vt cv cop cH wcel vs cv vt cv cop vk cv cn wcel vr cv vk cv vh cv cfv cG
      cfv wceq wa vk vr copab wcel cH vk cv cn wcel vr cv vk cv vh cv cfv cG
      cfv wceq wa vk vr copab vs cv vt cv cop vacn.h eleq2i biimpi vk cv cn
      wcel vr cv vk cv vh cv cfv cG cfv wceq wa vs cv cn wcel vr cv vs cv vh cv
      cfv cG cfv wceq wa vs cv cn wcel vt cv vs cv vh cv cfv cG cfv wceq wa vk
      vr vs cv vt cv vs visset vt visset vk cv vs cv wceq vk cv cn wcel vs cv
      cn wcel vr cv vk cv vh cv cfv cG cfv wceq vr cv vs cv vh cv cfv cG cfv
      wceq vk cv vs cv cn eleq1 vk cv vs cv wceq vk cv vh cv cfv cG cfv vs cv
      vh cv cfv cG cfv vr cv vk cv vs cv wceq vk cv vh cv cfv vs cv vh cv cfv
      cG vk cv vs cv vh cv fveq2 fveq2d eqeq2d anbi12d vr cv vt cv wceq vr cv
      vs cv vh cv cfv cG cfv wceq vt cv vs cv vh cv cfv cG cfv wceq vs cv cn
      wcel vr cv vt cv vs cv vh cv cfv cG cfv eqeq1 anbi2d opelopab sylib syl5
      relssdv adantr cH cc cX cxp wss cF vq cv c1st cfv cC clm cfv wbr cL vq cv
      c2nd cfv cC clm cfv wbr wa vm cv cF cfv cX wcel vm cv cL cfv cX wcel vm
      cv cH cfv vm cv cF cfv vm cv cL cfv cU cpv cfv co wceq w3a vm c1 cuz cfv
      wral wa cH vq cv c1st cfv vq cv c2nd cfv cU cpv cfv co cC clm cfv wbr cn
      cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cH vq cv c1st cfv vq cv
      c2nd cfv cop cU cpv cfv cfv cC clm cfv wbr cF vq cv c1st cfv cC clm cfv
      wbr cL vq cv c2nd cfv cC clm cfv wbr wa vm cv cF cfv cX wcel vm cv cL cfv
      cX wcel vm cv cH cfv vm cv cF cfv vm cv cL cfv cU cpv cfv co wceq w3a vm
      c1 cuz cfv wral wa cH cc cX cxp wss cH vq cv c1st cfv vq cv c2nd cfv cU
      cpv cfv co cC clm cfv wbr c1 cz wcel cF vq cv c1st cfv cC clm cfv wbr cL
      vq cv c2nd cfv cC clm cfv wbr vm cv cF cfv cX wcel vm cv cL cfv cX wcel
      vm cv cH cfv vm cv cF cfv vm cv cL cfv cU cpv cfv co wceq w3a vm c1 cuz
      cfv wral cH cc cX cxp wss cH vq cv c1st cfv vq cv c2nd cfv cU cpv cfv co
      cC clm cfv wbr wi 1z cH cc cX cxp wss c1 cz wcel cF vq cv c1st cfv cC clm
      cfv wbr cL vq cv c2nd cfv cC clm cfv wbr w3a vm cv cF cfv cX wcel vm cv
      cL cfv cX wcel vm cv cH cfv vm cv cF cfv vm cv cL cfv cU cpv cfv co wceq
      w3a vm c1 cuz cfv wral wa cH vq cv c1st cfv vq cv c2nd cfv cU cpv cfv co
      cC clm cfv wbr vq cv c1st cfv vq cv c2nd cfv cC cU vm cF cL cH c1 cN cX
      vacn.1 vacn.6 vacn.8 vacn.9 vk vr cn vk cv vh cv cfv c1st cfv cF nnex
      vacn.f fopabex2 vk vr cn vk cv vh cv cfv c2nd cfv cL nnex vacn.g fopabex2
      vq cv c1st fvex vq cv c2nd fvex vacnlem4 expcom mp3anl1 com12 cn cX cX
      cxp vh cv wf vh cv vq cv cD clm cfv wbr wa cH vq cv c1st cfv vq cv c2nd
      cfv cU cpv cfv co cC clm cfv wbr cH vq cv c1st cfv vq cv c2nd cfv cop cU
      cpv cfv cfv cC clm cfv wbr cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv
      wbr wa vq cv c1st cfv vq cv c2nd cfv cU cpv cfv co vq cv c1st cfv vq cv
      c2nd cfv cop cU cpv cfv cfv cH cC clm cfv vq cv c1st cfv vq cv c2nd cfv
      cU cpv cfv co vq cv c1st cfv vq cv c2nd cfv cop cU cpv cfv cfv wceq cn cX
      cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa vq cv c1st cfv vq cv c2nd
      cfv cU cpv cfv df-opr a1i breq2d biimpd syl9r mpd cn cX cX cxp vh cv wf
      vh cv vq cv cD clm cfv wbr wa vq cv cG cfv vq cv c1st cfv vq cv c2nd cfv
      cop cU cpv cfv cfv cH cC clm cfv cn cX cX cxp vh cv wf vh cv vq cv cD clm
      cfv wbr wa vq cv cU cpv cfv cfv vq cv c1st cfv vq cv c2nd cfv cop cU cpv
      cfv cfv vq cv cG cfv cn cX cX cxp vh cv wf vh cv vq cv cD clm cfv wbr wa
      vq cv vq cv c1st cfv vq cv c2nd cfv cop cU cpv cfv vh cv vq cv cD clm cfv
      wbr vq cv vq cv c1st cfv vq cv c2nd cfv cop wceq cn cX cX cxp vh cv wf cD
      cme wcel vq cv cvv wcel vh cv vq cv cD clm cfv wbr vq cv vq cv c1st cfv
      vq cv c2nd cfv cop wceq vx vy vz cC cC cD cX cX cC cU cX vacn.1 vacn.8
      vacn.9 imsbai cC cU cX vacn.1 vacn.8 vacn.9 imsbai cU cnv wcel cC cme
      wcel vacn.9 cC cU vacn.8 imsmet ax-mp cU cnv wcel cC cme wcel vacn.9 cC
      cU vacn.8 imsmet ax-mp vacn.d metxp vq visset cD cme wcel vq cv cvv wcel
      vh cv vq cv cD clm cfv wbr w3a vq cv cX cX cxp wcel vq cv vq cv c1st cfv
      vq cv c2nd cfv cop wceq vq cv c1st cfv cX wcel vq cv c2nd cfv cX wcel wa
      wa vq cv vq cv c1st cfv vq cv c2nd cfv cop wceq cvv cD vq cv vh cv cX cX
      cxp cD cdm cdm cX cX cxp cX cX cxp cxp cdm cX cX cxp cD cdm cX cX cxp cX
      cX cxp cxp vx vy vz cX cX cxp cX cX cxp vx cv c1st cfv vy cv c1st cfv cC
      co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup cD cr vx cv c1st
      cfv vy cv c1st cfv cC co vx cv c2nd cfv vy cv c2nd cfv cC co cpr clt ltso
      supex vacn.d dmoprab2 dmeqi cX cX cxp dmxpid eqtr2i lmcl vq cv cX cX cxp
      wcel vq cv vq cv c1st cfv vq cv c2nd cfv cop wceq vq cv c1st cfv cX wcel
      vq cv c2nd cfv cX wcel wa wa vq cv cX cX elxp6 biimpi vq cv vq cv c1st
      cfv vq cv c2nd cfv cop wceq vq cv c1st cfv cX wcel vq cv c2nd cfv cX wcel
      wa pm3.26 3syl mp3an12 adantl fveq2d vq cv cG cU cpv cfv vacn.2 fveq1i
      syl5eq breq2d sylibrd mpd ex adantr r19.21aiva mpgbir $.
      $( [21-Jun-2009] $) $( [11-Jun-2009] $)
    $}
  $}

  ${
    $d h k r x y z U $.
    vacn.11 $e |- X = ( BaseSet ` U ) $.
    vacn.12 $e |- G = ( +v ` U ) $.
    vacn.13 $e |- C = ( IndMet ` U ) $.
    vacn.14 $e |- D = { <. <. x , y >. , z >. | ( ( x e. ( X X. X )
            /\ y e. ( X X. X ) ) /\ z = sup ( { ( ( 1st ` x ) C ( 1st ` y ) ) ,
                ( ( 2nd ` x ) C ( 2nd ` y ) ) } , RR , < ) ) } $.
    vacn.15 $e |- J = ( Open ` C ) $.
    vacn.16 $e |- K = ( Open ` D ) $.
    $( Vector addition is continuous.  (Contributed by Jeffrey Hankins,
       16-Jun-2009.) $)
    vacn $p |- ( U e. NrmCVec -> G e. ( K Cn J ) ) $=
      cU cnv wcel cG cK cJ ccn co wcel cU cnv wcel cU caddc cmul cop cabs cop
      cif cpv cfv vx cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU
      cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel vy cv cU cnv
      wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cU
      cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv
      c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co cpr cr
      clt csup wceq wa vx vy vz copab2 copn cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv copn cfv ccn co wcel cU caddc cmul cop cabs cop cU
      cU cnv wcel cU caddc cmul cop cabs cop cif wceq cG cU cnv wcel cU caddc
      cmul cop cabs cop cif cpv cfv cK cJ ccn co vx cv cU cnv wcel cU caddc
      cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cba cfv cxp wcel vy cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel wa vz cv vx
      cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv co cpr cr clt csup wceq wa vx vy vz copab2 copn cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv copn cfv ccn co cU cU
      cnv wcel cU caddc cmul cop cabs cop cif wceq cU cpv cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cpv cfv cG cU cU cnv wcel cU caddc cmul cop
      cabs cop cif cpv fveq2 vacn.12 syl5eq cU cU cnv wcel cU caddc cmul cop
      cabs cop cif wceq cK vx cv cU cnv wcel cU caddc cmul cop cabs cop cif cba
      cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel vy cv cU
      cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy
      cv c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co cpr cr
      clt csup wceq wa vx vy vz copab2 copn cfv cJ cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv copn cfv ccn cU cU cnv wcel cU caddc cmul cop
      cabs cop cif wceq cD copn cfv vx cv cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp
      wcel vy cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel
      cU caddc cmul cop cabs cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv
      vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx
      cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co cpr cr clt csup wceq wa vx vy vz copab2 copn cfv cK cU cU cnv
      wcel cU caddc cmul cop cabs cop cif wceq cD vx cv cU cnv wcel cU caddc
      cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cba cfv cxp wcel vy cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel wa vz cv vx
      cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv co cpr cr clt csup wceq wa vx vy vz copab2 copn cU
      cU cnv wcel cU caddc cmul cop cabs cop cif wceq vx cv cX cX cxp wcel vy
      cv cX cX cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cC co vx cv c2nd
      cfv vy cv c2nd cfv cC co cpr cr clt csup wceq wa vx vy vz copab2 vx cv cU
      cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cba cfv cxp wcel vy cv cU cnv wcel cU caddc cmul cop
      cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cims cfv co cpr cr clt csup wceq wa vx vy vz
      copab2 cD cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq vx cv cX cX
      cxp wcel vy cv cX cX cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cC
      co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup wceq wa vx cv cU
      cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cba cfv cxp wcel vy cv cU cnv wcel cU caddc cmul cop
      cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cims cfv co cpr cr clt csup wceq wa vx vy vz
      cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq vx cv cX cX cxp wcel
      vy cv cX cX cxp wcel wa vx cv cU cnv wcel cU caddc cmul cop cabs cop cif
      cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel vy cv
      cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc
      cmul cop cabs cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy cv c1st
      cfv cC co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup wceq vz cv
      vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv co cpr cr clt csup wceq cU cU cnv wcel cU caddc
      cmul cop cabs cop cif wceq vx cv cX cX cxp wcel vx cv cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv cxp wcel vy cv cX cX cxp wcel vy cv cU cnv wcel cU caddc
      cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cba cfv cxp wcel cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cX cX
      cxp cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cxp vx cv cU cU cnv wcel cU caddc
      cmul cop cabs cop cif wceq cX cX cxp cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv cX cxp cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp cU cU cnv wcel cU
      caddc cmul cop cabs cop cif wceq cX cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv wceq cX cX cxp cU cnv wcel cU caddc cmul cop cabs cop cif
      cba cfv cX cxp wceq cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cU
      cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cX cU cU cnv
      wcel cU caddc cmul cop cabs cop cif cba fveq2 vacn.11 syl5eq cX cU cnv
      wcel cU caddc cmul cop cabs cop cif cba cfv cX xpeq1 syl cU cU cnv wcel
      cU caddc cmul cop cabs cop cif wceq cX cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv wceq cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      cX cxp cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cxp wceq cU cU cnv wcel cU caddc cmul
      cop cabs cop cif wceq cU cba cfv cU cnv wcel cU caddc cmul cop cabs cop
      cif cba cfv cX cU cU cnv wcel cU caddc cmul cop cabs cop cif cba fveq2
      vacn.11 syl5eq cX cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU
      cnv wcel cU caddc cmul cop cabs cop cif cba cfv xpeq2 syl eqtrd eleq2d cU
      cU cnv wcel cU caddc cmul cop cabs cop cif wceq cX cX cxp cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv cxp vy cv cU cU cnv wcel cU caddc cmul cop cabs cop cif
      wceq cX cX cxp cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cX cxp
      cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc
      cmul cop cabs cop cif cba cfv cxp cU cU cnv wcel cU caddc cmul cop cabs
      cop cif wceq cX cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv wceq
      cX cX cxp cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cX cxp wceq
      cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cU cba cfv cU cnv wcel
      cU caddc cmul cop cabs cop cif cba cfv cX cU cU cnv wcel cU caddc cmul
      cop cabs cop cif cba fveq2 vacn.11 syl5eq cX cU cnv wcel cU caddc cmul
      cop cabs cop cif cba cfv cX xpeq1 syl cU cU cnv wcel cU caddc cmul cop
      cabs cop cif wceq cX cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv
      wceq cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cX cxp cU cnv
      wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cba cfv cxp wceq cU cU cnv wcel cU caddc cmul cop cabs cop
      cif wceq cU cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cX
      cU cU cnv wcel cU caddc cmul cop cabs cop cif cba fveq2 vacn.11 syl5eq cX
      cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc
      cmul cop cabs cop cif cba cfv xpeq2 syl eqtrd eleq2d anbi12d cU cU cnv
      wcel cU caddc cmul cop cabs cop cif wceq vx cv c1st cfv vy cv c1st cfv cC
      co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup vx cv c1st cfv vy
      cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv
      c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims
      cfv co cpr cr clt csup vz cv cU cU cnv wcel cU caddc cmul cop cabs cop
      cif wceq vx cv c1st cfv vy cv c1st cfv cC co vx cv c2nd cfv vy cv c2nd
      cfv cC co cpr vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cims cfv co cpr wceq vx cv c1st cfv vy cv
      c1st cfv cC co vx cv c2nd cfv vy cv c2nd cfv cC co cpr cr clt csup vx cv
      c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims
      cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop cabs
      cop cif cims cfv co cpr cr clt csup wceq cU cU cnv wcel cU caddc cmul cop
      cabs cop cif wceq vx cv c1st cfv vy cv c1st cfv cC co vx cv c2nd cfv vy
      cv c2nd cfv cC co cpr vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc
      cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd cfv cC co cpr
      vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv co cpr cU cU cnv wcel cU caddc cmul cop cabs cop
      cif wceq vx cv c1st cfv vy cv c1st cfv cC co vx cv c1st cfv vy cv c1st
      cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co wceq vx cv
      c1st cfv vy cv c1st cfv cC co vx cv c2nd cfv vy cv c2nd cfv cC co cpr vx
      cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co vx cv c2nd cfv vy cv c2nd cfv cC co cpr wceq cU cU cnv wcel
      cU caddc cmul cop cabs cop cif wceq cC cU cnv wcel cU caddc cmul cop cabs
      cop cif cims cfv vx cv c1st cfv vy cv c1st cfv cU cU cnv wcel cU caddc
      cmul cop cabs cop cif wceq cU cims cfv cU cnv wcel cU caddc cmul cop cabs
      cop cif cims cfv cC cU cU cnv wcel cU caddc cmul cop cabs cop cif cims
      fveq2 vacn.13 syl5eq opreqd vx cv c1st cfv vy cv c1st cfv cC co vx cv
      c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims
      cfv co vx cv c2nd cfv vy cv c2nd cfv cC co preq1 syl cU cU cnv wcel cU
      caddc cmul cop cabs cop cif wceq vx cv c2nd cfv vy cv c2nd cfv cC co vx
      cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co wceq vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd cfv cC co cpr vx
      cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif
      cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv co cpr wceq cU cU cnv wcel cU caddc cmul cop cabs
      cop cif wceq cC cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv vx cv
      c2nd cfv vy cv c2nd cfv cU cU cnv wcel cU caddc cmul cop cabs cop cif
      wceq cU cims cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv cC
      cU cU cnv wcel cU caddc cmul cop cabs cop cif cims fveq2 vacn.13 syl5eq
      opreqd vx cv c2nd cfv vy cv c2nd cfv cC co vx cv c2nd cfv vy cv c2nd cfv
      cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv c1st cfv vy
      cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co preq2
      syl eqtrd cr vx cv c1st cfv vy cv c1st cfv cC co vx cv c2nd cfv vy cv
      c2nd cfv cC co cpr vx cv c1st cfv vy cv c1st cfv cU cnv wcel cU caddc
      cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd cfv cU cnv
      wcel cU caddc cmul cop cabs cop cif cims cfv co cpr clt supeq1 syl eqeq2d
      anbi12d oprabbidv vacn.14 syl5eq fveq2d vacn.16 syl5eq cU cU cnv wcel cU
      caddc cmul cop cabs cop cif wceq cC copn cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv copn cfv cJ cU cU cnv wcel cU caddc cmul cop
      cabs cop cif wceq cC cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv
      copn cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cU cims cfv cU
      cnv wcel cU caddc cmul cop cabs cop cif cims cfv cC cU cU cnv wcel cU
      caddc cmul cop cabs cop cif cims fveq2 vacn.13 syl5eq fveq2d vacn.15
      syl5eq opreq12d eleq12d vx vy vz cU cnv wcel cU caddc cmul cop cabs cop
      cif cims cfv vx cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU
      cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel vy cv cU cnv
      wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop
      cabs cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cU
      cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv
      c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co cpr cr
      clt csup wceq wa vx vy vz copab2 cU cnv wcel cU caddc cmul cop cabs cop
      cif vh vk vk cv cn wcel vr cv vk cv vh cv cfv c1st cfv wceq wa vk vr
      copab cU cnv wcel cU caddc cmul cop cabs cop cif cpv cfv vk cv cn wcel vr
      cv vk cv vh cv cfv cU cnv wcel cU caddc cmul cop cabs cop cif cpv cfv cfv
      wceq wa vk vr copab cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv
      copn cfv vx cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv
      wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel vy cv cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cU cnv
      wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd
      cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co cpr cr clt
      csup wceq wa vx vy vz copab2 copn cfv vk cv cn wcel vr cv vk cv vh cv cfv
      c2nd cfv wceq wa vk vr copab cU cnv wcel cU caddc cmul cop cabs cop cif
      cnm cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv vr cU cnv wcel
      cU caddc cmul cop cabs cop cif cba cfv eqid cU cnv wcel cU caddc cmul cop
      cabs cop cif cnm cfv eqid cU cnv wcel cU caddc cmul cop cabs cop cif cims
      cfv eqid cU elimnvu cU cnv wcel cU caddc cmul cop cabs cop cif cpv cfv
      eqid vx cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel
      cU caddc cmul cop cabs cop cif cba cfv cxp wcel vy cv cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU caddc cmul cop cabs
      cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy cv c1st cfv cU cnv
      wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv c2nd cfv vy cv c2nd
      cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co cpr cr clt
      csup wceq wa vx vy vz copab2 eqid cU cnv wcel cU caddc cmul cop cabs cop
      cif cims cfv copn cfv eqid vx cv cU cnv wcel cU caddc cmul cop cabs cop
      cif cba cfv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cxp wcel
      vy cv cU cnv wcel cU caddc cmul cop cabs cop cif cba cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cba cfv cxp wcel wa vz cv vx cv c1st cfv vy
      cv c1st cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv co vx cv
      c2nd cfv vy cv c2nd cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims
      cfv co cpr cr clt csup wceq wa vx vy vz copab2 copn cfv eqid vk cv cn
      wcel vr cv vk cv vh cv cfv c1st cfv wceq wa vk vr copab eqid vk cv cn
      wcel vr cv vk cv vh cv cfv c2nd cfv wceq wa vk vr copab eqid vk cv cn
      wcel vr cv vk cv vh cv cfv cU cnv wcel cU caddc cmul cop cabs cop cif cpv
      cfv cfv wceq wa vk vr copab eqid vacnlem6 dedth $.
      $( [21-Jun-2009] $) $( [16-Jun-2009] $)
  $}

  ${
    $d f u v w z F $.  $d f z D $.  $d z J $.  $d f u x y z $.
    sqcn.2 $e |- D = ( IndMet ` <. <. + , x. >. , abs >. ) $.
    sqcn.j $e |- J = ( Open ` D ) $.
    sqcn.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( x ^ 2 ) ) } $.
    $( MAY BE REVISED - make obsolete; use sqcn2. $)
    $( The square function on complex numbers is continuous. $)
    sqcn $p |- F e. ( J Cn J ) $=
      cF cJ cJ ccn co wcel cn cc vf cv wf vf cv vz cv cD clm cfv wbr vw cv cn
      wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cD clm
      cfv wbr wi vz cc wral wi vf cD cme wcel cD cme wcel cc cc cF wf cF cJ cJ
      ccn co wcel cn cc vf cv wf vf cv vz cv cD clm cfv wbr vw cv cn wcel vv cv
      vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cD clm cfv wbr wi
      vz cc wral wi vf wal wb cD cD caddc cmul cop cabs cop cims cfv cabs cmin
      ccom sqcn.2 cabs cmin ccom caddc cmul cop cabs cop caddc cmul cop cabs
      cop eqid cabs cmin ccom eqid cnims eqtr4i cnmet cD cD caddc cmul cop cabs
      cop cims cfv cabs cmin ccom sqcn.2 cabs cmin ccom caddc cmul cop cabs cop
      caddc cmul cop cabs cop eqid cabs cmin ccom eqid cnims eqtr4i cnmet vx vy
      cc cc vx cv c2 cexp co cF sqcn.1 vx cv sqcl fopab vz vv cD cD vf vw cF vw
      cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cJ cJ cc cc
      cD cD caddc cmul cop cabs cop cims cfv cabs cmin ccom sqcn.2 cabs cmin
      ccom caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cabs cmin ccom
      eqid cnims eqtr4i cnmetba cD cD caddc cmul cop cabs cop cims cfv cabs
      cmin ccom sqcn.2 cabs cmin ccom caddc cmul cop cabs cop caddc cmul cop
      cabs cop eqid cabs cmin ccom eqid cnims eqtr4i cnmetba sqcn.j sqcn.j vw
      cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab eqid metcn4
      mp3an cn cc vf cv wf vf cv vz cv cD clm cfv wbr vw cv cn wcel vv cv vw cv
      vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cD clm cfv wbr wi vz cc
      vz cv cc wcel cn cc vf cv wf vf cv vz cv cD clm cfv wbr vw cv cn wcel vv
      cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cD clm cfv wbr
      wi vz cv cc wcel cn cc vf cv wf wa vf cv vz cv cli wbr vw cv cn wcel vv
      cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cli wbr vf cv
      vz cv cD clm cfv wbr vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa
      vw vv copab vz cv cF cfv cD clm cfv wbr vf cv vz cv cli wbr vz cv cc wcel
      cn cc vf cv wf wa vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw
      vv copab vz cv cF cfv cli wbr vf cv vz cv cli wbr vz cv cc wcel cn cc vf
      cv wf wa wa vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv
      copab vz cv vz cv cmul co vz cv cF cfv cli vf cv vz cv cli wbr cn cc vf
      cv wf vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz
      cv vz cv cmul co cli wbr vz cv cc wcel vf cv vz cv cli wbr vf cv vz cv
      cli wbr wa c1 cz wcel vu cv vf cv cfv cc wcel vu cv vf cv cfv cc wcel vu
      cv vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cfv vu
      cv vf cv cfv vu cv vf cv cfv cmul co wceq w3a vu c1 cuz cfv wral wa vw cv
      cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv vz cv cmul
      co cli wbr vf cv vz cv cli wbr cn cc vf cv wf vz cv vz cv vu vf cv vf cv
      vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab c1 vf
      visset vf visset vw vv cn vw cv vf cv cfv cF cfv nnex opabex2 vz visset
      vz visset climmul vf cv vz cv cli wbr vf cv vz cv cli wbr vf cv vz cv cli
      wbr id ancli cn cc vf cv wf vu cv vf cv cfv cc wcel vu cv vf cv cfv cc
      wcel vu cv vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab
      cfv vu cv vf cv cfv vu cv vf cv cfv cmul co wceq w3a vu c1 cuz cfv wral
      c1 cz wcel cn cc vf cv wf vu cv vf cv cfv cc wcel vu cv vf cv cfv cc wcel
      vu cv vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cfv
      vu cv vf cv cfv vu cv vf cv cfv cmul co wceq w3a vu c1 cuz cfv cn cc vf
      cv wf vu cv cn wcel vu cv vf cv cfv cc wcel vu cv vf cv cfv cc wcel vu cv
      vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cfv vu cv
      vf cv cfv vu cv vf cv cfv cmul co wceq w3a vu cv c1 cuz cfv wcel cn cc vf
      cv wf vu cv cn wcel wa vu cv vf cv cfv cc wcel vu cv vf cv cfv cc wcel vu
      cv vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cfv vu
      cv vf cv cfv vu cv vf cv cfv cmul co wceq cn cc vu cv vf cv ffvelrn cn cc
      vu cv vf cv ffvelrn cn cc vf cv wf vu cv cn wcel wa vu cv vw cv cn wcel
      vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cfv vu cv vf cv cfv cF
      cfv vu cv vf cv cfv vu cv vf cv cfv cmul co vu cv cn wcel vu cv vw cv cn
      wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab cfv vu cv vf cv cfv
      cF cfv wceq cn cc vf cv wf vw vv vu cv vw cv vf cv cfv cF cfv vu cv vf cv
      cfv cF cfv cn vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv
      copab vw cv vu cv wceq vw cv vf cv cfv vu cv vf cv cfv cF vw cv vu cv vf
      cv fveq2 fveq2d vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv
      copab eqid vu cv vf cv cfv cF fvex fvopab4 adantl cn cc vf cv wf vu cv cn
      wcel wa vu cv vf cv cfv cc wcel vu cv vf cv cfv cF cfv vu cv vf cv cfv vu
      cv vf cv cfv cmul co wceq cn cc vu cv vf cv ffvelrn vu cv vf cv cfv cc
      wcel vu cv vf cv cfv cF cfv vu cv vf cv cfv c2 cexp co vu cv vf cv cfv vu
      cv vf cv cfv cmul co vx vy vu cv vf cv cfv vx cv c2 cexp co vu cv vf cv
      cfv c2 cexp co cc cF vx cv vu cv vf cv cfv c2 cexp opreq1 sqcn.1 vu cv vf
      cv cfv c2 cexp oprex fvopab4 vu cv vf cv cfv sqval eqtrd syl eqtrd 3jca
      vu cv elnnuz sylan2br r19.21aiva 1z jctil syl2an adantrl vz cv cc wcel vz
      cv cF cfv vz cv vz cv cmul co wceq vf cv vz cv cli wbr cn cc vf cv wf vz
      cv cc wcel vz cv cF cfv vz cv c2 cexp co vz cv vz cv cmul co vx vy vz cv
      vx cv c2 cexp co vz cv c2 cexp co cc cF vx cv vz cv c2 cexp opreq1 sqcn.1
      vz cv c2 cexp oprex fvopab4 vz cv sqval eqtrd ad2antrl breqtrrd expcom cc
      cD vz cv vf cv cD caddc cmul cop cabs cop cims cfv cabs cmin ccom sqcn.2
      cabs cmin ccom caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cabs
      cmin ccom eqid cnims eqtr4i lmclimnn cn cc vf cv wf vw cv cn wcel vv cv
      vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cD clm cfv wbr vw
      cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv
      cli wbr wb vz cv cc wcel cn cc vf cv wf cn cc vw cv cn wcel vv cv vw cv
      vf cv cfv cF cfv wceq wa vw vv copab wf vw cv cn wcel vv cv vw cv vf cv
      cfv cF cfv wceq wa vw vv copab vz cv cF cfv cD clm cfv wbr vw cv cn wcel
      vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cli wbr wb
      cn cc vf cv wf vw cv vf cv cfv cF cfv cc wcel vw cn wral cn cc vw cv cn
      wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab wf cn cc vf cv wf
      vw cv vf cv cfv cF cfv cc wcel vw cn cn cc vf cv wf vw cv cn wcel wa vw
      cv vf cv cfv cc wcel vw cv vf cv cfv cF cfv cc wcel cn cc vw cv vf cv
      ffvelrn cc cc vw cv vf cv cfv cF vx vy cc cc vx cv c2 cexp co cF sqcn.1
      vx cv sqcl fopab ffvelrni syl r19.21aiva vw vv cn cc vw cv vf cv cfv cF
      cfv vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab vw cv
      cn wcel vv cv vw cv vf cv cfv cF cfv wceq wa vw vv copab eqid fopab2
      sylib vz cv cF cfv cvv wcel cn cc vw cv cn wcel vv cv vw cv vf cv cfv cF
      cfv wceq wa vw vv copab wf vw cv cn wcel vv cv vw cv vf cv cfv cF cfv
      wceq wa vw vv copab vz cv cF cfv cD clm cfv wbr vw cv cn wcel vv cv vw cv
      vf cv cfv cF cfv wceq wa vw vv copab vz cv cF cfv cli wbr wb vz cv cF
      fvex cvv cD vz cv cF cfv vw cv cn wcel vv cv vw cv vf cv cfv cF cfv wceq
      wa vw vv copab cD caddc cmul cop cabs cop cims cfv cabs cmin ccom sqcn.2
      cabs cmin ccom caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cabs
      cmin ccom eqid cnims eqtr4i lmclimnn mpan syl adantl 3imtr4d ancoms
      r19.21aiva mpgbir $.
      $( [30-Nov-2007] $) $( [13-Jun-2007] $)
  $}

  ${
    $d w v $.
    sqcn2.1 $e |- D = ( abs o. - ) $.
    sqcn2.j $e |- J = ( Open ` D ) $.
    sqcn2.2 $e |- F = { <. w , v >. | ( w e. CC /\ v = ( w ^ 2 ) ) } $.
    $( The square function on complex numbers is continuous. $)
    sqcn2 $p |- F e. ( J Cn J ) $=
      vw vv cD cF cJ cD caddc cmul cop cabs cop caddc cmul cop cabs cop eqid
      sqcn2.1 cnims sqcn2.j sqcn2.2 sqcn $.
      $( [1-Dec-2007] $) $( [18-Aug-2007] $)
  $}

  ${
    $d t u v w C $.  $d t u v w D $.  $d t u v w J $.  $d v w K $.
    $d t u v w N $.  $d t u v w X $.
    nmcnilem.1 $e |- X = ( BaseSet ` U ) $.
    nmcnilem.2 $e |- G = ( +v ` U ) $.
    nmcnilem.4 $e |- S = ( .s ` U ) $.
    nmcnilem.6 $e |- N = ( norm ` U ) $.
    nmcnilem.8 $e |- C = ( IndMet ` U ) $.
    nmcnilem.7 $e |- D = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    nmcnilem.j $e |- J = ( Open ` C ) $.
    nmcnilem.k $e |- K = ( Open ` D ) $.
    nmcnilem.9 $e |- U e. NrmCVec $.
    $( Lemma for ~ nmcni . $)
    nmcnilem $p |- N e. ( J Cn K ) $=
      cN cJ cK ccn co wcel cX cr cN wf cc0 vv cv clt wbr cc0 vu cv clt wbr vw
      cv vt cv cC co vu cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt
      wbr wi vt cX wral wa vu cr wrex wi vv cr wral vw cX wral cC cme wcel cD
      cme wcel cN cJ cK ccn co wcel cX cr cN wf cc0 vv cv clt wbr cc0 vu cv clt
      wbr vw cv vt cv cC co vu cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv
      clt wbr wi vt cX wral wa vu cr wrex wi vv cr wral vw cX wral wa wb cU cnv
      wcel cC cme wcel nmcnilem.9 cC cU nmcnilem.8 imsmet ax-mp cD nmcnilem.7
      remet vw vv vu vt cC cD cN cJ cK cX cr cC cU cX nmcnilem.1 nmcnilem.8
      nmcnilem.9 imsbai nmcnilem.j cD nmcnilem.7 remetba nmcnilem.k metcn mp2an
      cU cnv wcel cX cr cN wf nmcnilem.9 cU cN cX nmcnilem.1 nmcnilem.6 nvf
      ax-mp cc0 vv cv clt wbr cc0 vu cv clt wbr vw cv vt cv cC co vu cv clt wbr
      vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr wi vt cX wral wa vu cr wrex
      wi vw vv cX cr vw cv cX wcel vv cv cr wcel wa cc0 vv cv clt wbr cc0 vu cv
      clt wbr vw cv vt cv cC co vu cv clt wbr vw cv cN cfv vt cv cN cfv cD co
      vv cv clt wbr wi vt cX wral wa vu cr wrex vv cv cr wcel cc0 vv cv clt wbr
      vw cv vt cv cC co vv cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt
      wbr wi vt cX wral wa cc0 vu cv clt wbr vw cv vt cv cC co vu cv clt wbr vw
      cv cN cfv vt cv cN cfv cD co vv cv clt wbr wi vt cX wral wa vu cr wrex vw
      cv cX wcel vv cv cr wcel wa cc0 vv cv clt wbr wa cc0 vu cv clt wbr vw cv
      vt cv cC co vu cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr
      wi vt cX wral wa cc0 vv cv clt wbr vw cv vt cv cC co vv cv clt wbr vw cv
      cN cfv vt cv cN cfv cD co vv cv clt wbr wi vt cX wral wa vu vv cv cr vu
      cv vv cv wceq cc0 vu cv clt wbr cc0 vv cv clt wbr vw cv vt cv cC co vu cv
      clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr wi vt cX wral vw cv
      vt cv cC co vv cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr
      wi vt cX wral vu cv vv cv cc0 clt breq2 vu cv vv cv wceq vw cv vt cv cC
      co vu cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr wi vw cv
      vt cv cC co vv cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr
      wi vt cX vu cv vv cv wceq vw cv vt cv cC co vu cv clt wbr vw cv vt cv cC
      co vv cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr vu cv vv
      cv vw cv vt cv cC co clt breq2 imbi1d ralbidv anbi12d rcla4ev vw cv cX
      wcel vv cv cr wcel cc0 vv cv clt wbr simplr vw cv cX wcel vv cv cr wcel
      wa cc0 vv cv clt wbr wa cc0 vv cv clt wbr vw cv vt cv cC co vv cv clt wbr
      vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr wi vt cX wral vw cv cX wcel
      vv cv cr wcel wa cc0 vv cv clt wbr pm3.27 vw cv cX wcel vv cv cr wcel wa
      cc0 vv cv clt wbr wa vw cv vt cv cC co vv cv clt wbr vw cv cN cfv vt cv
      cN cfv cD co vv cv clt wbr wi vt cX vw cv cX wcel vv cv cr wcel wa cc0 vv
      cv clt wbr wa vt cv cX wcel wa vw cv c1 cneg vt cv cS co cG co cN cfv vv
      cv clt wbr vw cv cN cfv vt cv cN cfv cmin co cabs cfv vv cv clt wbr vw cv
      vt cv cC co vv cv clt wbr vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr
      vw cv cX wcel vv cv cr wcel wa cc0 vv cv clt wbr wa vt cv cX wcel wa vw
      cv cN cfv vt cv cN cfv cmin co cabs cfv vw cv c1 cneg vt cv cS co cG co
      cN cfv cle wbr vw cv c1 cneg vt cv cS co cG co cN cfv vv cv clt wbr vw cv
      cN cfv vt cv cN cfv cmin co cabs cfv vv cv clt wbr vw cv cX wcel vv cv cr
      wcel wa vt cv cX wcel vw cv cN cfv vt cv cN cfv cmin co cabs cfv vw cv c1
      cneg vt cv cS co cG co cN cfv cle wbr cc0 vv cv clt wbr vw cv cX wcel vt
      cv cX wcel vw cv cN cfv vt cv cN cfv cmin co cabs cfv vw cv c1 cneg vt cv
      cS co cG co cN cfv cle wbr vv cv cr wcel cU cnv wcel vw cv cX wcel vt cv
      cX wcel vw cv cN cfv vt cv cN cfv cmin co cabs cfv vw cv c1 cneg vt cv cS
      co cG co cN cfv cle wbr nmcnilem.9 vw cv vt cv cS cU cG cN cX nmcnilem.1
      nmcnilem.2 nmcnilem.4 nmcnilem.6 nvabs mp3an1 adantlr adantlr vw cv cX
      wcel vv cv cr wcel wa vt cv cX wcel vw cv cN cfv vt cv cN cfv cmin co
      cabs cfv vw cv c1 cneg vt cv cS co cG co cN cfv cle wbr vw cv c1 cneg vt
      cv cS co cG co cN cfv vv cv clt wbr wa vw cv cN cfv vt cv cN cfv cmin co
      cabs cfv vv cv clt wbr wi cc0 vv cv clt wbr vw cv cN cfv vt cv cN cfv
      cmin co cabs cfv cr wcel vw cv c1 cneg vt cv cS co cG co cN cfv cr wcel
      vv cv cr wcel vw cv cN cfv vt cv cN cfv cmin co cabs cfv vw cv c1 cneg vt
      cv cS co cG co cN cfv cle wbr vw cv c1 cneg vt cv cS co cG co cN cfv vv
      cv clt wbr wa vw cv cN cfv vt cv cN cfv cmin co cabs cfv vv cv clt wbr wi
      vw cv cX wcel vv cv cr wcel wa vt cv cX wcel wa vw cv cN cfv vt cv cN cfv
      cmin co cabs cfv vw cv c1 cneg vt cv cS co cG co cN cfv vv cv lelttr vw
      cv cX wcel vt cv cX wcel vw cv cN cfv vt cv cN cfv cmin co cabs cfv cr
      wcel vv cv cr wcel vw cv cX wcel vt cv cX wcel wa vw cv cN cfv vt cv cN
      cfv cmin co cc wcel vw cv cN cfv vt cv cN cfv cmin co cabs cfv cr wcel vw
      cv cX wcel vt cv cX wcel wa vw cv cN cfv vt cv cN cfv cmin co vw cv cN
      cfv cr wcel vt cv cN cfv cr wcel vw cv cN cfv vt cv cN cfv cmin co cr
      wcel vw cv cX wcel vt cv cX wcel vw cv cN cfv vt cv cN cfv resubcl cU cnv
      wcel vw cv cX wcel vw cv cN cfv cr wcel nmcnilem.9 vw cv cU cN cX
      nmcnilem.1 nmcnilem.6 nvcl mpan cU cnv wcel vt cv cX wcel vt cv cN cfv cr
      wcel nmcnilem.9 vt cv cU cN cX nmcnilem.1 nmcnilem.6 nvcl mpan syl2an
      recnd vw cv cN cfv vt cv cN cfv cmin co abscl syl adantlr vw cv cX wcel
      vt cv cX wcel vw cv c1 cneg vt cv cS co cG co cN cfv cr wcel vv cv cr
      wcel vw cv cX wcel vt cv cX wcel wa vw cv c1 cneg vt cv cS co cG co cX
      wcel vw cv c1 cneg vt cv cS co cG co cN cfv cr wcel vw cv cX wcel c1 cneg
      vt cv cS co cX wcel vw cv c1 cneg vt cv cS co cG co cX wcel vt cv cX wcel
      cU cnv wcel vw cv cX wcel c1 cneg vt cv cS co cX wcel vw cv c1 cneg vt cv
      cS co cG co cX wcel nmcnilem.9 vw cv c1 cneg vt cv cS co cU cG cX
      nmcnilem.1 nmcnilem.2 nvgcl mp3an1 cU cnv wcel c1 cneg cc wcel vt cv cX
      wcel c1 cneg vt cv cS co cX wcel nmcnilem.9 c1 ax1cn negcli c1 cneg vt cv
      cS cU cX nmcnilem.1 nmcnilem.4 nvscl mp3an12 sylan2 cU cnv wcel vw cv c1
      cneg vt cv cS co cG co cX wcel vw cv c1 cneg vt cv cS co cG co cN cfv cr
      wcel nmcnilem.9 vw cv c1 cneg vt cv cS co cG co cU cN cX nmcnilem.1
      nmcnilem.6 nvcl mpan syl adantlr vw cv cX wcel vv cv cr wcel vt cv cX
      wcel simplr syl3anc adantlr mpand vw cv cX wcel vv cv cr wcel wa vt cv cX
      wcel vw cv vt cv cC co vv cv clt wbr vw cv c1 cneg vt cv cS co cG co cN
      cfv vv cv clt wbr wb cc0 vv cv clt wbr vw cv cX wcel vt cv cX wcel vw cv
      vt cv cC co vv cv clt wbr vw cv c1 cneg vt cv cS co cG co cN cfv vv cv
      clt wbr wb vv cv cr wcel cU cnv wcel vw cv cX wcel vt cv cX wcel vw cv vt
      cv cC co vv cv clt wbr vw cv c1 cneg vt cv cS co cG co cN cfv vv cv clt
      wbr wb nmcnilem.9 cU cnv wcel vw cv cX wcel vt cv cX wcel w3a vw cv vt cv
      cC co vw cv c1 cneg vt cv cS co cG co cN cfv vv cv clt vw cv vt cv cC cS
      cU cG cN cX nmcnilem.1 nmcnilem.2 nmcnilem.4 nmcnilem.6 nmcnilem.8
      imsdval2 breq1d mp3an1 adantlr adantlr vw cv cX wcel vv cv cr wcel wa vt
      cv cX wcel vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr vw cv cN cfv vt
      cv cN cfv cmin co cabs cfv vv cv clt wbr wb cc0 vv cv clt wbr vw cv cX
      wcel vt cv cX wcel vw cv cN cfv vt cv cN cfv cD co vv cv clt wbr vw cv cN
      cfv vt cv cN cfv cmin co cabs cfv vv cv clt wbr wb vv cv cr wcel vw cv cX
      wcel vt cv cX wcel wa vw cv cN cfv vt cv cN cfv cD co vw cv cN cfv vt cv
      cN cfv cmin co cabs cfv vv cv clt vw cv cN cfv cr wcel vt cv cN cfv cr
      wcel vw cv cN cfv vt cv cN cfv cD co vw cv cN cfv vt cv cN cfv cmin co
      cabs cfv wceq vw cv cX wcel vt cv cX wcel vw cv cN cfv vt cv cN cfv cD
      nmcnilem.7 remetdval cU cnv wcel vw cv cX wcel vw cv cN cfv cr wcel
      nmcnilem.9 vw cv cU cN cX nmcnilem.1 nmcnilem.6 nvcl mpan cU cnv wcel vt
      cv cX wcel vt cv cN cfv cr wcel nmcnilem.9 vt cv cU cN cX nmcnilem.1
      nmcnilem.6 nvcl mpan syl2an breq1d adantlr adantlr 3imtr4d r19.21aiva jca
      sylanc ex rgen2 mpbir2an $.
      $( [17-Nov-2007] $) $( [16-May-2007] $)
  $}

  ${
    nmcn.6 $e |- N = ( norm ` U ) $.
    nmcn.8 $e |- C = ( IndMet ` U ) $.
    nmcn.7 $e |- D = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    nmcn.j $e |- J = ( Open ` C ) $.
    nmcn.k $e |- K = ( Open ` D ) $.
    ${
      nmcni.9 $e |- U e. NrmCVec $.
      $( The norm of a normed complex vector space is a continuous function. $)
      nmcni $p |- N e. ( J Cn K ) $=
        cC cD cU cns cfv cU cU cpv cfv cJ cK cN cU cba cfv cU cba cfv eqid cU
        cpv cfv eqid cU cns cfv eqid nmcn.6 nmcn.8 nmcn.7 nmcn.j nmcn.k nmcni.9
        nmcnilem $.
        $( [17-Nov-2007] $) $( [16-May-2007] $)
    $}

    $( The norm of a normed complex vector space is a continuous function. $)
    nmcn $p |- ( U e. NrmCVec -> N e. ( J Cn K ) ) $=
      cU cnv wcel cN cJ cK ccn co wcel cU cnv wcel cU caddc cmul cop cabs cop
      cif cnm cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv copn cfv
      cK ccn co wcel cU caddc cmul cop cabs cop cU cU cnv wcel cU caddc cmul
      cop cabs cop cif wceq cN cU cnv wcel cU caddc cmul cop cabs cop cif cnm
      cfv cJ cK ccn co cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv copn
      cfv cK ccn co cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cU cnm
      cfv cU cnv wcel cU caddc cmul cop cabs cop cif cnm cfv cN cU cU cnv wcel
      cU caddc cmul cop cabs cop cif cnm fveq2 nmcn.6 syl5eq cU cU cnv wcel cU
      caddc cmul cop cabs cop cif wceq cJ cU cnv wcel cU caddc cmul cop cabs
      cop cif cims cfv copn cfv cK ccn cU cU cnv wcel cU caddc cmul cop cabs
      cop cif wceq cC copn cfv cU cnv wcel cU caddc cmul cop cabs cop cif cims
      cfv copn cfv cJ cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cC cU
      cnv wcel cU caddc cmul cop cabs cop cif cims cfv copn cU cU cnv wcel cU
      caddc cmul cop cabs cop cif wceq cU cims cfv cU cnv wcel cU caddc cmul
      cop cabs cop cif cims cfv cC cU cU cnv wcel cU caddc cmul cop cabs cop
      cif cims fveq2 nmcn.8 syl5eq fveq2d nmcn.j syl5eq opreq1d eleq12d cU cnv
      wcel cU caddc cmul cop cabs cop cif cims cfv cD cU cnv wcel cU caddc cmul
      cop cabs cop cif cU cnv wcel cU caddc cmul cop cabs cop cif cims cfv copn
      cfv cK cU cnv wcel cU caddc cmul cop cabs cop cif cnm cfv cU cnv wcel cU
      caddc cmul cop cabs cop cif cnm cfv eqid cU cnv wcel cU caddc cmul cop
      cabs cop cif cims cfv eqid nmcn.7 cU cnv wcel cU caddc cmul cop cabs cop
      cif cims cfv copn cfv eqid nmcn.k cU elimnvu nmcni dedth $.
      $( [21-Nov-2007] $) $( [16-May-2007] $)
  $}

  ${
    nmcn2.6 $e |- N = ( norm ` U ) $.
    nmcn2.8 $e |- D = ( IndMet ` U ) $.
    nmcn2.j $e |- J = ( Open ` D ) $.
    $( MAY BE REVISED - delete if not used? $)
    $( The norm of a normed complex vector space is a continuous function to
       ` RR ` . $)
    nmcn2 $p |- ( U e. NrmCVec -> N e. ( J Cn ( topGen ` ran (,) ) ) ) $=
      cU cnv wcel cN cJ cabs cmin ccom cr cr cxp cres copn cfv ccn co cJ cioo
      crn ctg cfv ccn co cD cabs cmin ccom cr cr cxp cres cU cJ cabs cmin ccom
      cr cr cxp cres copn cfv cN nmcn2.6 nmcn2.8 cabs cmin ccom cr cr cxp cres
      eqid nmcn2.j cabs cmin ccom cr cr cxp cres copn cfv eqid nmcn cioo crn
      ctg cfv cabs cmin ccom cr cr cxp cres copn cfv cJ ccn cabs cmin ccom cr
      cr cxp cres cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom cr cr
      cxp cres eqid cabs cmin ccom cr cr cxp cres copn cfv eqid tgioo opreq2i
      syl6eleqr $.
      $( [23-May-2008] $) $( [27-May-2007] $)

    ${
      nmcn3.k $e |- K = ( Open ` ( IndMet ` <. <. + , x. >. , abs >. ) ) $.
      $( MAY BE REVISED - delete if not used? $)
      $( The norm of a normed complex vector space is a continuous function to
         ` CC ` . $)
      nmcn3 $p |- ( U e. NrmCVec -> N e. ( J Cn K ) ) $=
        cD cme wcel cabs cmin ccom cr cr cxp cres cme wcel caddc cmul cop cabs
        cop cims cfv cme wcel w3a cabs cmin ccom cr cr cxp cres caddc cmul cop
        cabs cop cims cfv wss wa cN cJ cabs cmin ccom cr cr cxp cres copn cfv
        ccn co wcel cN cJ cK ccn co wcel cU cnv wcel cD cme wcel cabs cmin ccom
        cr cr cxp cres cme wcel caddc cmul cop cabs cop cims cfv cme wcel w3a
        cabs cmin ccom cr cr cxp cres caddc cmul cop cabs cop cims cfv wss wa
        cJ cabs cmin ccom cr cr cxp cres copn cfv ccn co cJ cK ccn co cN cD
        cabs cmin ccom cr cr cxp cres caddc cmul cop cabs cop cims cfv cJ cabs
        cmin ccom cr cr cxp cres copn cfv cK nmcn2.j cabs cmin ccom cr cr cxp
        cres copn cfv eqid nmcn3.k metcnss sseld cU cnv wcel cD cme wcel cabs
        cmin ccom cr cr cxp cres cme wcel caddc cmul cop cabs cop cims cfv cme
        wcel w3a cabs cmin ccom cr cr cxp cres caddc cmul cop cabs cop cims cfv
        wss cU cnv wcel cD cme wcel cabs cmin ccom cr cr cxp cres cme wcel
        caddc cmul cop cabs cop cims cfv cme wcel cD cU nmcn2.8 imsmet cabs
        cmin ccom cr cr cxp cres cme wcel cU cnv wcel cabs cmin ccom cr cr cxp
        cres cabs cmin ccom cr cr cxp cres eqid remet a1i caddc cmul cop cabs
        cop cims cfv cme wcel cU cnv wcel caddc cmul cop cabs cop cims cfv cabs
        cmin ccom caddc cmul cop cabs cop cims cfv cabs cmin ccom caddc cmul
        cop cabs cop caddc cmul cop cabs cop eqid cabs cmin ccom eqid cnims
        eqcomi cnmet a1i 3jca cabs cmin ccom cr cr cxp cres cabs cmin ccom
        caddc cmul cop cabs cop cims cfv cabs cmin ccom cr cr cxp resss cabs
        cmin ccom caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cabs
        cmin ccom eqid cnims sseqtri jctir cD cabs cmin ccom cr cr cxp cres cU
        cJ cabs cmin ccom cr cr cxp cres copn cfv cN nmcn2.6 nmcn2.8 cabs cmin
        ccom cr cr cxp cres eqid nmcn2.j cabs cmin ccom cr cr cxp cres copn cfv
        eqid nmcn sylc $.
        $( [28-Jul-2008] $) $( [30-May-2007] $)
    $}
  $}

  ${
    nmcnc.6 $e |- N = ( norm ` U ) $.
    nmcnc.8 $e |- C = ( IndMet ` U ) $.
    nmcnc.7 $e |- D = ( abs o. - ) $.
    nmcnc.j $e |- J = ( Open ` C ) $.
    nmcnc.k $e |- K = ( Open ` D ) $.
    $( The norm of a normed complex vector space is a continuous function to
       ` CC ` .  (For ` RR ` , see ~ nmcn .) $)
    nmcnc $p |- ( U e. NrmCVec -> N e. ( J Cn K ) ) $=
      cC cme wcel cabs cmin ccom cr cr cxp cres cme wcel cD cme wcel w3a cabs
      cmin ccom cr cr cxp cres cD wss wa cN cJ cabs cmin ccom cr cr cxp cres
      copn cfv ccn co wcel cN cJ cK ccn co wcel cU cnv wcel cC cme wcel cabs
      cmin ccom cr cr cxp cres cme wcel cD cme wcel w3a cabs cmin ccom cr cr
      cxp cres cD wss wa cJ cabs cmin ccom cr cr cxp cres copn cfv ccn co cJ cK
      ccn co cN cC cabs cmin ccom cr cr cxp cres cD cJ cabs cmin ccom cr cr cxp
      cres copn cfv cK nmcnc.j cabs cmin ccom cr cr cxp cres copn cfv eqid
      nmcnc.k metcnss sseld cU cnv wcel cC cme wcel cabs cmin ccom cr cr cxp
      cres cme wcel cD cme wcel w3a cabs cmin ccom cr cr cxp cres cD wss cU cnv
      wcel cC cme wcel cabs cmin ccom cr cr cxp cres cme wcel cD cme wcel cC cU
      nmcnc.8 imsmet cabs cmin ccom cr cr cxp cres cme wcel cU cnv wcel cabs
      cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid remet a1i cD
      cme wcel cU cnv wcel cD nmcnc.7 cnmet a1i 3jca cabs cmin ccom cr cr cxp
      cres cabs cmin ccom cD cabs cmin ccom cr cr cxp resss nmcnc.7 sseqtr4i
      jctir cC cabs cmin ccom cr cr cxp cres cU cJ cabs cmin ccom cr cr cxp
      cres copn cfv cN nmcnc.6 nmcnc.8 cabs cmin ccom cr cr cxp cres eqid
      nmcnc.j cabs cmin ccom cr cr cxp cres copn cfv eqid nmcn sylc $.
      $( [24-Nov-2007] $) $( [12-Aug-2007] $)
  $}

  ${
    abscn.1 $e |- C = ( abs o. - ) $.
    abscn.2 $e |- R = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    abscn.3 $e |- J = ( Open ` C ) $.
    abscn.4 $e |- K = ( Open ` R ) $.
    $( The absolute value function on complex numbers is continuous. $)
    abscn $p |- abs e. ( J Cn K ) $=
      cC cR caddc cmul cop cabs cop cJ cK cabs caddc cmul cop cabs cop cnm cfv
      caddc cmul cop cabs cop c2nd cfv cabs caddc cmul cop cabs cop caddc cmul
      cop cabs cop cnm cfv caddc cmul cop cabs cop cnm cfv eqid nmfval caddc
      cmul cop cabs caddc cmul opex cc cr cabs wf cc cvv wcel cabs cvv wcel
      absf axcnex cc cr cvv cabs fex mp2an op2nd eqtr2i cC cabs cmin ccom caddc
      cmul cop cabs cop cims cfv abscn.1 cabs cmin ccom caddc cmul cop cabs cop
      caddc cmul cop cabs cop eqid cabs cmin ccom eqid cnims eqtri abscn.2
      abscn.3 abscn.4 caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cnnv
      nmcni $.
      $( [5-Jun-2008] $) $( [22-Aug-2007] $)
  $}

  $( Absolute value is continuous.  Alternate proof of ~ abscncf . $)
  abscncfALT $p |- abs e. ( CC -cn-> RR ) $=
    cabs cabs cmin ccom copn cfv cabs cmin ccom cr cr cxp cres copn cfv ccn co
    cc cr ccncf co cabs cmin ccom cabs cmin ccom cr cr cxp cres cabs cmin ccom
    copn cfv cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom eqid cabs
    cmin ccom cr cr cxp cres eqid cabs cmin ccom copn cfv eqid cabs cmin ccom
    cr cr cxp cres copn cfv eqid abscn cc cc wss cr cc wss cc cr ccncf co cabs
    cmin ccom copn cfv cabs cmin ccom cr cr cxp cres copn cfv ccn co wceq cc
    ssid axresscn cc cr cabs cmin ccom cabs cmin ccom cr cr cxp cres cabs cmin
    ccom copn cfv cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom cc cc
    cxp cres cabs cmin ccom cabs cmin ccom wrel cabs cmin ccom cdm cc cc cxp
    wss cabs cmin ccom cc cc cxp cres cabs cmin ccom wceq cabs cmin relco cabs
    cmin ccom cdm cmin cdm cc cc cxp cabs cmin dmcoss cc cc cxp cc cmin subopr
    fdmi sseqtri cabs cmin ccom cc cc cxp relssres mp2an eqcomi cabs cmin ccom
    cr cr cxp cres eqid cabs cmin ccom copn cfv eqid cabs cmin ccom cr cr cxp
    cres copn cfv eqid cncfmet mp2an eleqtrri $.
    $( [6-Jun-2008] $) $( [6-Jun-2008] $)

  ${
    $d r s t u v w A $.  $d r s t u D $.  $d r s t u F $.  $d v w G $.
    $d r s t u J $.  $d r s t u v w X $.
    va1cn.1 $e |- X = ( BaseSet ` U ) $.
    va1cn.2 $e |- G = ( +v ` U ) $.
    va1cn.8 $e |- D = ( IndMet ` U ) $.
    va1cn.j $e |- J = ( Open ` D ) $.
    va1cn.f $e |- F = { <. w , v >. | ( w e. X /\ v = ( w G A ) ) } $.
    va1cn.9 $e |- U e. NrmCVec $.
    ${
      va1cnlem.6 $e |- N = ( norm ` U ) $.
      $( Lemma for ~ va1cn . $)
      va1cnlem $p |- ( A e. X -> F e. ( J Cn J ) ) $=
        cA cX wcel cX cX cF wf cc0 vs cv clt wbr cc0 vt cv clt wbr vr cv vu cv
        cD co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi vu
        cX wral wa vt cr wrex wi vs cr wral vr cX wral wa cF cJ cJ ccn co wcel
        cA cX wcel cX cX cF wf cc0 vs cv clt wbr cc0 vt cv clt wbr vr cv vu cv
        cD co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi vu
        cX wral wa vt cr wrex wi vs cr wral vr cX wral cA cX wcel vw cv cA cG
        co cX wcel vw cX wral cX cX cF wf cA cX wcel vw cv cA cG co cX wcel vw
        cX vw cv cX wcel cA cX wcel vw cv cA cG co cX wcel cU cnv wcel vw cv cX
        wcel cA cX wcel vw cv cA cG co cX wcel va1cn.9 vw cv cA cU cG cX
        va1cn.1 va1cn.2 nvgcl mp3an1 ancoms r19.21aiva vw vv cX cX vw cv cA cG
        co cF va1cn.f fopab2 sylib cA cX wcel cc0 vs cv clt wbr cc0 vt cv clt
        wbr vr cv vu cv cD co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs
        cv clt wbr wi vu cX wral wa vt cr wrex wi vr vs cX cr cA cX wcel vr cv
        cX wcel vs cv cr wcel wa cc0 vs cv clt wbr cc0 vt cv clt wbr vr cv vu
        cv cD co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi
        vu cX wral wa vt cr wrex cA cX wcel vr cv cX wcel vs cv cr wcel wa cc0
        vs cv clt wbr wa wa cc0 vt cv clt wbr vr cv vu cv cD co vt cv clt wbr
        vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi vu cX wral wa vt cr
        wrex cc0 vt cv clt wbr vr cv vu cv cD co vt cv clt wbr vr cv vu cv cD
        co vs cv clt wbr wi vu cX wral wa vt cr wrex vr cv cX wcel vs cv cr
        wcel wa cc0 vs cv clt wbr wa cc0 vt cv clt wbr vr cv vu cv cD co vt cv
        clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral wa vt cr wrex cA
        cX wcel vs cv cr wcel cc0 vs cv clt wbr cc0 vt cv clt wbr vr cv vu cv
        cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral wa vt
        cr wrex vr cv cX wcel vs cv cr wcel cc0 vs cv clt wbr vr cv vu cv cD co
        vs cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral cc0 vt cv
        clt wbr vr cv vu cv cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr
        wi vu cX wral wa vt cr wrex vr cv vu cv cD co vs cv clt wbr vr cv vu cv
        cD co vs cv clt wbr wi vu cX vu cv cX wcel vr cv vu cv cD co vs cv clt
        wbr idd rgen cc0 vt cv clt wbr vr cv vu cv cD co vt cv clt wbr vr cv vu
        cv cD co vs cv clt wbr wi vu cX wral wa cc0 vs cv clt wbr vr cv vu cv
        cD co vs cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral wa vt
        vs cv cr vt cv vs cv wceq cc0 vt cv clt wbr cc0 vs cv clt wbr vr cv vu
        cv cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral vr
        cv vu cv cD co vs cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX
        wral vt cv vs cv cc0 clt breq2 vt cv vs cv wceq vr cv vu cv cD co vt cv
        clt wbr vr cv vu cv cD co vs cv clt wbr wi vr cv vu cv cD co vs cv clt
        wbr vr cv vu cv cD co vs cv clt wbr wi vu cX vt cv vs cv wceq vr cv vu
        cv cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr vr cv vu cv cD
        co vs cv clt wbr vt cv vs cv vr cv vu cv cD co clt breq2 imbi1d ralbidv
        anbi12d rcla4ev mpanr2 adantll adantl cA cX wcel vr cv cX wcel vs cv cr
        wcel wa cc0 vt cv clt wbr vr cv vu cv cD co vt cv clt wbr vr cv cF cfv
        vu cv cF cfv cD co vs cv clt wbr wi vu cX wral wa vt cr wrex cc0 vt cv
        clt wbr vr cv vu cv cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr
        wi vu cX wral wa vt cr wrex wb cc0 vs cv clt wbr cA cX wcel vr cv cX
        wcel cc0 vt cv clt wbr vr cv vu cv cD co vt cv clt wbr vr cv cF cfv vu
        cv cF cfv cD co vs cv clt wbr wi vu cX wral wa vt cr wrex cc0 vt cv clt
        wbr vr cv vu cv cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr wi
        vu cX wral wa vt cr wrex wb vs cv cr wcel cA cX wcel vr cv cX wcel wa
        cc0 vt cv clt wbr vr cv vu cv cD co vt cv clt wbr vr cv cF cfv vu cv cF
        cfv cD co vs cv clt wbr wi vu cX wral wa cc0 vt cv clt wbr vr cv vu cv
        cD co vt cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral wa vt
        cr cA cX wcel vr cv cX wcel wa vr cv vu cv cD co vt cv clt wbr vr cv cF
        cfv vu cv cF cfv cD co vs cv clt wbr wi vu cX wral vr cv vu cv cD co vt
        cv clt wbr vr cv vu cv cD co vs cv clt wbr wi vu cX wral cc0 vt cv clt
        wbr cA cX wcel vr cv cX wcel wa vr cv vu cv cD co vt cv clt wbr vr cv
        cF cfv vu cv cF cfv cD co vs cv clt wbr wi vr cv vu cv cD co vt cv clt
        wbr vr cv vu cv cD co vs cv clt wbr wi vu cX cA cX wcel vr cv cX wcel
        wa vu cv cX wcel wa vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr vr cv
        vu cv cD co vs cv clt wbr vr cv vu cv cD co vt cv clt wbr cA cX wcel vr
        cv cX wcel wa vu cv cX wcel wa vr cv cF cfv vu cv cF cfv cD co vr cv vu
        cv cD co vs cv clt cA cX wcel vr cv cX wcel wa vu cv cX wcel wa vr cv
        cF cfv vu cv cF cfv cD co vr cv cA cG co vu cv cA cG co cD co vr cv vu
        cv cD co vr cv cX wcel vu cv cX wcel vr cv cF cfv vu cv cF cfv cD co vr
        cv cA cG co vu cv cA cG co cD co wceq cA cX wcel vr cv cX wcel vu cv cX
        wcel vr cv cF cfv vr cv cA cG co vu cv cF cfv vu cv cA cG co cD vw vv
        vr cv vw cv cA cG co vr cv cA cG co cX cF vw cv vr cv cA cG opreq1
        va1cn.f vr cv cA cG oprex fvopab4 vw vv vu cv vw cv cA cG co vu cv cA
        cG co cX cF vw cv vu cv cA cG opreq1 va1cn.f vu cv cA cG oprex fvopab4
        opreqan12d adantll cA cX wcel vr cv cX wcel vu cv cX wcel vr cv cA cG
        co vu cv cA cG co cD co vr cv vu cv cD co wceq vr cv cX wcel vu cv cX
        wcel cA cX wcel vr cv cA cG co vu cv cA cG co cD co vr cv vu cv cD co
        wceq vr cv cX wcel vu cv cX wcel cA cX wcel w3a vr cv cA cG co vu cv cA
        cG co cU cnsb cfv co cN cfv vr cv vu cv cU cnsb cfv co cN cfv vr cv cA
        cG co vu cv cA cG co cD co vr cv vu cv cD co vr cv cX wcel vu cv cX
        wcel cA cX wcel w3a vr cv cA cG co vu cv cA cG co cU cnsb cfv co vr cv
        vu cv cU cnsb cfv co cN cG cgr wcel vr cv cX wcel vu cv cX wcel cA cX
        wcel w3a vr cv cA cG co vu cv cA cG co cU cnsb cfv co vr cv vu cv cU
        cnsb cfv co wceq cU cnv wcel cG cgr wcel va1cn.9 cU cG va1cn.2 nvgrp
        ax-mp vr cv vu cv cA cU cnsb cfv cG cX cU cG cX va1cn.1 va1cn.2 bafval
        cU cG cU cnsb cfv va1cn.2 cU cnsb cfv eqid vsfval grppnpcan2 mpan
        fveq2d vr cv cA cG co cX wcel vu cv cA cG co cX wcel vr cv cA cG co vu
        cv cA cG co cD co vr cv cA cG co vu cv cA cG co cU cnsb cfv co cN cfv
        wceq vr cv cX wcel vu cv cX wcel cA cX wcel w3a cU cnv wcel vr cv cA cG
        co cX wcel vu cv cA cG co cX wcel vr cv cA cG co vu cv cA cG co cD co
        vr cv cA cG co vu cv cA cG co cU cnsb cfv co cN cfv wceq va1cn.9 vr cv
        cA cG co vu cv cA cG co cD cU cU cnsb cfv cN cX va1cn.1 cU cnsb cfv
        eqid va1cnlem.6 va1cn.8 imsdval mp3an1 vr cv cX wcel cA cX wcel vr cv
        cA cG co cX wcel vu cv cX wcel cU cnv wcel vr cv cX wcel cA cX wcel vr
        cv cA cG co cX wcel va1cn.9 vr cv cA cU cG cX va1cn.1 va1cn.2 nvgcl
        mp3an1 3adant2 vu cv cX wcel cA cX wcel vu cv cA cG co cX wcel vr cv cX
        wcel cU cnv wcel vu cv cX wcel cA cX wcel vu cv cA cG co cX wcel
        va1cn.9 vu cv cA cU cG cX va1cn.1 va1cn.2 nvgcl mp3an1 3adant1 sylanc
        vr cv cX wcel vu cv cX wcel vr cv vu cv cD co vr cv vu cv cU cnsb cfv
        co cN cfv wceq cA cX wcel cU cnv wcel vr cv cX wcel vu cv cX wcel vr cv
        vu cv cD co vr cv vu cv cU cnsb cfv co cN cfv wceq va1cn.9 vr cv vu cv
        cD cU cU cnsb cfv cN cX va1cn.1 cU cnsb cfv eqid va1cnlem.6 va1cn.8
        imsdval mp3an1 3adant3 3eqtr4d 3comr 3expa eqtrd breq1d imbi2d ralbidva
        anbi2d rexbidv adantrr adantrr mpbird exp32 r19.21aivv jca cD cme wcel
        cD cme wcel cF cJ cJ ccn co wcel cX cX cF wf cc0 vs cv clt wbr cc0 vt
        cv clt wbr vr cv vu cv cD co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD
        co vs cv clt wbr wi vu cX wral wa vt cr wrex wi vs cr wral vr cX wral
        wa wb cU cnv wcel cD cme wcel va1cn.9 cD cU va1cn.8 imsmet ax-mp cU cnv
        wcel cD cme wcel va1cn.9 cD cU va1cn.8 imsmet ax-mp vr vs vt vu cD cD
        cF cJ cJ cX cX cD cU cX va1cn.1 va1cn.8 va1cn.9 imsbai va1cn.j cD cU cX
        va1cn.1 va1cn.8 va1cn.9 imsbai va1cn.j metcn mp2an sylibr $.
        $( [23-Nov-2007] $) $( [12-Aug-2007] $)
    $}

    $( Vector addition is continuous in its first operand. $)
      va1cn $p |- ( A e. X -> F e. ( J Cn J ) ) $=
        vw vv cA cD cU cF cG cJ cU cnm cfv cX va1cn.1 va1cn.2 va1cn.8 va1cn.j
        va1cn.f va1cn.9 cU cnm cfv eqid va1cnlem $.
        $( [23-Nov-2007] $) $( [12-Aug-2007] $)
  $}

  ${
    $d t u v w A $.  $d r s t u C $.  $d r s t u D $.  $d r s t u F $.
    $d r s t u J $.  $d r s K $.  $d t u N $.  $d v w S $.  $d r s t u v w X $.
    sm1cni.1 $e |- X = ( BaseSet ` U ) $.
    sm1cni.4 $e |- S = ( .s ` U ) $.
    sm1cni.7 $e |- C = ( abs o. - ) $.
    sm1cni.8 $e |- D = ( IndMet ` U ) $.
    sm1cni.j $e |- J = ( Open ` C ) $.
    sm1cni.k $e |- K = ( Open ` D ) $.
    sm1cni.f $e |- F = { <. w , v >. | ( w e. CC /\ v = ( w S A ) ) } $.
    sm1cni.9 $e |- U e. NrmCVec $.
    sm1cni.a $e |- A e. X $.
    ${
      sm1cni.2 $e |- G = ( +v ` U ) $.
      sm1cnilem.6 $e |- N = ( norm ` U ) $.
      $( Lemma for ~ sm1cni . $)
      sm1cnilem $p |- F e. ( J Cn K ) $=
        cF cJ cK ccn co wcel cc cX cF wf cc0 vs cv clt wbr cc0 vt cv clt wbr vr
        cv vu cv cC co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt
        wbr wi vu cc wral wa vt cr wrex wi vs cr wral vr cc wral cC cme wcel cD
        cme wcel cF cJ cK ccn co wcel cc cX cF wf cc0 vs cv clt wbr cc0 vt cv
        clt wbr vr cv vu cv cC co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co
        vs cv clt wbr wi vu cc wral wa vt cr wrex wi vs cr wral vr cc wral wa
        wb cC sm1cni.7 cnmet cU cnv wcel cD cme wcel sm1cni.9 cD cU sm1cni.8
        imsmet ax-mp vr vs vt vu cC cD cF cJ cK cc cX cC sm1cni.7 cnmetba
        sm1cni.j cD cU cX sm1cni.1 sm1cni.8 sm1cni.9 imsbai sm1cni.k metcn
        mp2an vw vv cc cX vw cv cA cS co cF sm1cni.f cU cnv wcel vw cv cc wcel
        cA cX wcel vw cv cA cS co cX wcel sm1cni.9 sm1cni.a vw cv cA cS cU cX
        sm1cni.1 sm1cni.4 nvscl mp3an13 fopab cc0 vs cv clt wbr cc0 vt cv clt
        wbr vr cv vu cv cC co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs
        cv clt wbr wi vu cc wral wa vt cr wrex wi vr vs cc cr vr cv cc wcel vs
        cv cr wcel wa cc0 vs cv clt wbr cc0 vt cv clt wbr vr cv vu cv cC co vt
        cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi vu cc wral
        wa vt cr wrex vr cv cc wcel vs cv cr wcel wa cc0 vs cv clt wbr wa cc0
        vt cv clt wbr vr cv vu cv cC co vt cv clt wbr vr cv cF cfv vu cv cF cfv
        cD co vs cv clt wbr wi vu cc wral wa vt cr wrex cc0 vt cv clt wbr vr cv
        vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA cN
        cfv cmul co vs cv clt wbr wi vu cc wral wa vt cr wrex vr cv cc wcel vs
        cv cr wcel wa cc0 vs cv clt wbr wa cc0 vt cv clt wbr vr cv vu cv cmin
        co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA cN cfv cmul
        co vs cv clt wbr wi vu cc wral wa vt cr wrex cc0 vt cv clt wbr vr cv vu
        cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul
        co vs cv clt wbr wi vu cc wral wa vt cr wrex cA cN cfv cc0 cA cN cfv
        cc0 wceq cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr
        vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr wi vu cc
        wral wa cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr vr
        cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc wral wa vt
        cr cA cN cfv cc0 wceq vr cv vu cv cmin co cabs cfv vt cv clt wbr vr cv
        vu cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr wi vu cc wral vr
        cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv
        cc0 cmul co vs cv clt wbr wi vu cc wral cc0 vt cv clt wbr cA cN cfv cc0
        wceq vr cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co
        cabs cfv cA cN cfv cmul co vs cv clt wbr wi vr cv vu cv cmin co cabs
        cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt
        wbr wi vu cc cA cN cfv cc0 wceq vr cv vu cv cmin co cabs cfv cA cN cfv
        cmul co vs cv clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv
        clt wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr cA cN cfv cc0 wceq
        vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vr cv vu cv cmin co cabs
        cfv cc0 cmul co vs cv clt cA cN cfv cc0 vr cv vu cv cmin co cabs cfv
        cmul opreq2 breq1d imbi2d ralbidv anbi2d rexbidv vs cv cA cN cfv cdiv
        co cr wcel cc0 vs cv cA cN cfv cdiv co clt wbr vr cv vu cv cmin co cabs
        cfv vs cv cA cN cfv cdiv co clt wbr vr cv vu cv cmin co cabs cfv cA cN
        cfv cmul co vs cv clt wbr wi vu cc wral wa cc0 vt cv clt wbr vr cv vu
        cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA cN
        cfv cmul co vs cv clt wbr wi vu cc wral wa vt cr wrex vr cv cc wcel vs
        cv cr wcel wa cc0 vs cv clt wbr wa cA cN cfv cc0 wne wa cc0 vt cv clt
        wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs
        cfv cA cN cfv cmul co vs cv clt wbr wi vu cc wral wa cc0 vs cv cA cN
        cfv cdiv co clt wbr vr cv vu cv cmin co cabs cfv vs cv cA cN cfv cdiv
        co clt wbr vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr
        wi vu cc wral wa vt vs cv cA cN cfv cdiv co cr vt cv vs cv cA cN cfv
        cdiv co wceq cc0 vt cv clt wbr cc0 vs cv cA cN cfv cdiv co clt wbr vr
        cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA
        cN cfv cmul co vs cv clt wbr wi vu cc wral vr cv vu cv cmin co cabs cfv
        vs cv cA cN cfv cdiv co clt wbr vr cv vu cv cmin co cabs cfv cA cN cfv
        cmul co vs cv clt wbr wi vu cc wral vt cv vs cv cA cN cfv cdiv co cc0
        clt breq2 vt cv vs cv cA cN cfv cdiv co wceq vr cv vu cv cmin co cabs
        cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv
        clt wbr wi vr cv vu cv cmin co cabs cfv vs cv cA cN cfv cdiv co clt wbr
        vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr wi vu cc
        vt cv vs cv cA cN cfv cdiv co wceq vr cv vu cv cmin co cabs cfv vt cv
        clt wbr vr cv vu cv cmin co cabs cfv vs cv cA cN cfv cdiv co clt wbr vr
        cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr vt cv vs cv
        cA cN cfv cdiv co vr cv vu cv cmin co cabs cfv clt breq2 imbi1d ralbidv
        anbi12d rcla4ev vr cv cc wcel vs cv cr wcel wa cA cN cfv cc0 wne vs cv
        cA cN cfv cdiv co cr wcel cc0 vs cv clt wbr vs cv cr wcel cA cN cfv cc0
        wne vs cv cA cN cfv cdiv co cr wcel vr cv cc wcel vs cv cr wcel cA cN
        cfv cr wcel cA cN cfv cc0 wne vs cv cA cN cfv cdiv co cr wcel cA cU cN
        cX sm1cni.1 sm1cnilem.6 sm1cni.9 sm1cni.a nvcli vs cv cA cN cfv redivcl
        mp3an2 adantll adantlr vr cv cc wcel vs cv cr wcel wa cc0 vs cv clt wbr
        wa cA cN cfv cc0 wne wa cc0 vs cv cA cN cfv cdiv co clt wbr vr cv vu cv
        cmin co cabs cfv vs cv cA cN cfv cdiv co clt wbr vr cv vu cv cmin co
        cabs cfv cA cN cfv cmul co vs cv clt wbr wi vu cc wral vs cv cr wcel
        cc0 vs cv clt wbr cA cN cfv cc0 wne cc0 vs cv cA cN cfv cdiv co clt wbr
        vr cv cc wcel vs cv cr wcel cc0 vs cv clt wbr wa cc0 cA cN cfv clt wbr
        cc0 vs cv cA cN cfv cdiv co clt wbr cA cN cfv cc0 wne vs cv cr wcel cc0
        vs cv clt wbr wa cA cN cfv cr wcel cc0 cA cN cfv clt wbr cc0 vs cv cA
        cN cfv cdiv co clt wbr cA cU cN cX sm1cni.1 sm1cnilem.6 sm1cni.9
        sm1cni.a nvcli vs cv cA cN cfv divgt0 mpanr1 cc0 cA cN cfv cle wbr cA
        cN cfv cc0 wne cc0 cA cN cfv clt wbr cU cnv wcel cA cX wcel cc0 cA cN
        cfv cle wbr sm1cni.9 sm1cni.a cA cU cN cX sm1cni.1 sm1cnilem.6 nvge0
        mp2an cc0 cA cN cfv clt wbr cc0 cA cN cfv cle wbr cA cN cfv cc0 wne wa
        cc0 cA cN cfv 0re cA cU cN cX sm1cni.1 sm1cnilem.6 sm1cni.9 sm1cni.a
        nvcli ltleni biimpri mpan sylan2 adantlll vr cv cc wcel vs cv cr wcel
        wa cc0 vs cv clt wbr wa cA cN cfv cc0 wne wa vr cv vu cv cmin co cabs
        cfv vs cv cA cN cfv cdiv co clt wbr vr cv vu cv cmin co cabs cfv cA cN
        cfv cmul co vs cv clt wbr wi vu cc vr cv cc wcel vs cv cr wcel wa cc0
        vs cv clt wbr wa cA cN cfv cc0 wne wa vu cv cc wcel wa vr cv vu cv cmin
        co cabs cfv cA cN cfv cmul co vs cv clt wbr vr cv vu cv cmin co cabs
        cfv vs cv cA cN cfv cdiv co clt wbr vr cv vu cv cmin co cabs cfv cr
        wcel cA cN cfv cr wcel vs cv cr wcel w3a cc0 cA cN cfv clt wbr vr cv vu
        cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr vr cv vu cv cmin co
        cabs cfv vs cv cA cN cfv cdiv co clt wbr wb vr cv cc wcel vs cv cr wcel
        wa cc0 vs cv clt wbr wa cA cN cfv cc0 wne wa vu cv cc wcel wa vr cv vu
        cv cmin co cabs cfv cA cN cfv vs cv ltmuldivOLD vr cv cc wcel vs cv cr
        wcel wa cc0 vs cv clt wbr wa cA cN cfv cc0 wne wa vu cv cc wcel wa vr
        cv vu cv cmin co cabs cfv cr wcel cA cN cfv cr wcel vs cv cr wcel vr cv
        cc wcel vs cv cr wcel wa cc0 vs cv clt wbr wa vu cv cc wcel vr cv vu cv
        cmin co cabs cfv cr wcel cA cN cfv cc0 wne vr cv cc wcel vs cv cr wcel
        wa vu cv cc wcel vr cv vu cv cmin co cabs cfv cr wcel cc0 vs cv clt wbr
        vr cv cc wcel vu cv cc wcel vr cv vu cv cmin co cabs cfv cr wcel vs cv
        cr wcel vr cv cc wcel vu cv cc wcel wa vr cv vu cv cmin co cc wcel vr
        cv vu cv cmin co cabs cfv cr wcel vr cv vu cv subcl vr cv vu cv cmin co
        abscl syl adantlr adantlr adantlr cA cN cfv cr wcel vr cv cc wcel vs cv
        cr wcel wa cc0 vs cv clt wbr wa cA cN cfv cc0 wne wa vu cv cc wcel wa
        cA cU cN cX sm1cni.1 sm1cnilem.6 sm1cni.9 sm1cni.a nvcli a1i vr cv cc
        wcel vs cv cr wcel wa cc0 vs cv clt wbr wa vs cv cr wcel cA cN cfv cc0
        wne vu cv cc wcel vr cv cc wcel vs cv cr wcel cc0 vs cv clt wbr simplr
        ad2antrr 3jca cA cN cfv cc0 wne cc0 cA cN cfv clt wbr vr cv cc wcel vs
        cv cr wcel wa cc0 vs cv clt wbr wa vu cv cc wcel cc0 cA cN cfv cle wbr
        cA cN cfv cc0 wne cc0 cA cN cfv clt wbr cU cnv wcel cA cX wcel cc0 cA
        cN cfv cle wbr sm1cni.9 sm1cni.a cA cU cN cX sm1cni.1 sm1cnilem.6 nvge0
        mp2an cc0 cA cN cfv clt wbr cc0 cA cN cfv cle wbr cA cN cfv cc0 wne wa
        cc0 cA cN cfv 0re cA cU cN cX sm1cni.1 sm1cnilem.6 sm1cni.9 sm1cni.a
        nvcli ltleni biimpri mpan ad2antlr sylanc biimprd r19.21aiva jca sylanc
        vr cv cc wcel vs cv cr wcel wa cc0 vs cv clt wbr wa vr cv vu cv cmin co
        cabs cfv c1 clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt
        wbr wi vu cc wral cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv
        clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc
        wral wa vt cr wrex vr cv cc wcel vs cv cr wcel wa cc0 vs cv clt wbr wa
        vr cv vu cv cmin co cabs cfv c1 clt wbr vr cv vu cv cmin co cabs cfv
        cc0 cmul co vs cv clt wbr wi vu cc vr cv cc wcel vs cv cr wcel wa cc0
        vs cv clt wbr wa vu cv cc wcel wa vr cv vu cv cmin co cabs cfv cc0 cmul
        co vs cv clt wbr vr cv vu cv cmin co cabs cfv c1 clt wbr vr cv cc wcel
        vs cv cr wcel wa cc0 vs cv clt wbr wa vu cv cc wcel wa vr cv vu cv cmin
        co cabs cfv cc0 cmul co cc0 vs cv clt vr cv cc wcel vs cv cr wcel wa vu
        cv cc wcel vr cv vu cv cmin co cabs cfv cc0 cmul co cc0 wceq cc0 vs cv
        clt wbr vr cv cc wcel vu cv cc wcel vr cv vu cv cmin co cabs cfv cc0
        cmul co cc0 wceq vs cv cr wcel vr cv cc wcel vu cv cc wcel wa vr cv vu
        cv cmin co cabs cfv cc wcel vr cv vu cv cmin co cabs cfv cc0 cmul co
        cc0 wceq vr cv cc wcel vu cv cc wcel wa vr cv vu cv cmin co cabs cfv vr
        cv cc wcel vu cv cc wcel wa vr cv vu cv cmin co cc wcel vr cv vu cv
        cmin co cabs cfv cr wcel vr cv vu cv subcl vr cv vu cv cmin co abscl
        syl recnd vr cv vu cv cmin co cabs cfv mul01 syl adantlr adantlr vr cv
        cc wcel vs cv cr wcel wa cc0 vs cv clt wbr vu cv cc wcel simplr eqbrtrd
        a1d r19.21aiva cc0 c1 clt wbr vr cv vu cv cmin co cabs cfv c1 clt wbr
        vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc wral
        cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu
        cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc wral wa vt cr
        wrex lt01 c1 cr wcel cc0 c1 clt wbr vr cv vu cv cmin co cabs cfv c1 clt
        wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc
        wral wa cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr vr
        cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc wral wa vt
        cr wrex 1re cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt
        wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc
        wral wa cc0 c1 clt wbr vr cv vu cv cmin co cabs cfv c1 clt wbr vr cv vu
        cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc wral wa vt c1 cr
        vt cv c1 wceq cc0 vt cv clt wbr cc0 c1 clt wbr vr cv vu cv cmin co cabs
        cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt
        wbr wi vu cc wral vr cv vu cv cmin co cabs cfv c1 clt wbr vr cv vu cv
        cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vu cc wral vt cv c1 cc0
        clt breq2 vt cv c1 wceq vr cv vu cv cmin co cabs cfv vt cv clt wbr vr
        cv vu cv cmin co cabs cfv cc0 cmul co vs cv clt wbr wi vr cv vu cv cmin
        co cabs cfv c1 clt wbr vr cv vu cv cmin co cabs cfv cc0 cmul co vs cv
        clt wbr wi vu cc vt cv c1 wceq vr cv vu cv cmin co cabs cfv vt cv clt
        wbr vr cv vu cv cmin co cabs cfv c1 clt wbr vr cv vu cv cmin co cabs
        cfv cc0 cmul co vs cv clt wbr vt cv c1 vr cv vu cv cmin co cabs cfv clt
        breq2 imbi1d ralbidv anbi12d rcla4ev mpan mpan syl pm2.61ne vr cv cc
        wcel cc0 vt cv clt wbr vr cv vu cv cC co vt cv clt wbr vr cv cF cfv vu
        cv cF cfv cD co vs cv clt wbr wi vu cc wral wa vt cr wrex cc0 vt cv clt
        wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs
        cfv cA cN cfv cmul co vs cv clt wbr wi vu cc wral wa vt cr wrex wb vs
        cv cr wcel cc0 vs cv clt wbr vr cv cc wcel cc0 vt cv clt wbr vr cv vu
        cv cC co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi
        vu cc wral wa cc0 vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt
        wbr vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv clt wbr wi vu
        cc wral wa vt cr vr cv cc wcel vr cv vu cv cC co vt cv clt wbr vr cv cF
        cfv vu cv cF cfv cD co vs cv clt wbr wi vu cc wral vr cv vu cv cmin co
        cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA cN cfv cmul co
        vs cv clt wbr wi vu cc wral cc0 vt cv clt wbr vr cv cc wcel vr cv vu cv
        cC co vt cv clt wbr vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr wi vr
        cv vu cv cmin co cabs cfv vt cv clt wbr vr cv vu cv cmin co cabs cfv cA
        cN cfv cmul co vs cv clt wbr wi vu cc vr cv cc wcel vu cv cc wcel wa vr
        cv vu cv cC co vt cv clt wbr vr cv vu cv cmin co cabs cfv vt cv clt wbr
        vr cv cF cfv vu cv cF cfv cD co vs cv clt wbr vr cv vu cv cmin co cabs
        cfv cA cN cfv cmul co vs cv clt wbr vr cv cc wcel vu cv cc wcel wa vr
        cv vu cv cC co vr cv vu cv cmin co cabs cfv vt cv clt vr cv vu cv cC
        sm1cni.7 cnmetdval breq1d vr cv cc wcel vu cv cc wcel wa vr cv cF cfv
        vu cv cF cfv cD co vr cv vu cv cmin co cabs cfv cA cN cfv cmul co vs cv
        clt vr cv cc wcel vu cv cc wcel wa vr cv cF cfv vu cv cF cfv cD co vr
        cv cA cS co vu cv cA cS co cD co vr cv vu cv cmin co cabs cfv cA cN cfv
        cmul co vr cv cc wcel vu cv cc wcel vr cv cF cfv vr cv cA cS co vu cv
        cF cfv vu cv cA cS co cD vw vv vr cv vw cv cA cS co vr cv cA cS co cc
        cF vw cv vr cv cA cS opreq1 sm1cni.f vr cv cA cS oprex fvopab4 vw vv vu
        cv vw cv cA cS co vu cv cA cS co cc cF vw cv vu cv cA cS opreq1
        sm1cni.f vu cv cA cS oprex fvopab4 opreqan12d vr cv cc wcel vu cv cc
        wcel wa vr cv cA cS co vu cv cA cS co cD co vr cv cA cS co c1 cneg vu
        cv cA cS co cS co cG co cN cfv vr cv vu cv cmin co cA cS co cN cfv vr
        cv vu cv cmin co cabs cfv cA cN cfv cmul co vr cv cA cS co cX wcel vu
        cv cA cS co cX wcel vr cv cA cS co vu cv cA cS co cD co vr cv cA cS co
        c1 cneg vu cv cA cS co cS co cG co cN cfv wceq vr cv cc wcel vu cv cc
        wcel cU cnv wcel vr cv cA cS co cX wcel vu cv cA cS co cX wcel vr cv cA
        cS co vu cv cA cS co cD co vr cv cA cS co c1 cneg vu cv cA cS co cS co
        cG co cN cfv wceq sm1cni.9 vr cv cA cS co vu cv cA cS co cD cS cU cG cN
        cX sm1cni.1 sm1cni.2 sm1cni.4 sm1cnilem.6 sm1cni.8 imsdval2 mp3an1 cU
        cnv wcel vr cv cc wcel cA cX wcel vr cv cA cS co cX wcel sm1cni.9
        sm1cni.a vr cv cA cS cU cX sm1cni.1 sm1cni.4 nvscl mp3an13 cU cnv wcel
        vu cv cc wcel cA cX wcel vu cv cA cS co cX wcel sm1cni.9 sm1cni.a vu cv
        cA cS cU cX sm1cni.1 sm1cni.4 nvscl mp3an13 syl2an vr cv cc wcel vu cv
        cc wcel wa vr cv vu cv cmin co cA cS co vr cv cA cS co c1 cneg vu cv cA
        cS co cS co cG co cN vr cv cc wcel vu cv cc wcel cA cX wcel vr cv vu cv
        cmin co cA cS co vr cv cA cS co c1 cneg vu cv cA cS co cS co cG co wceq
        sm1cni.a cU c1st cfv cvc wcel vr cv cc wcel vu cv cc wcel cA cX wcel
        w3a vr cv vu cv cmin co cA cS co vr cv cA cS co c1 cneg vu cv cA cS co
        cS co cG co wceq cU cnv wcel cU c1st cfv cvc wcel sm1cni.9 cU cU c1st
        cfv cU c1st cfv eqid nvvc ax-mp vr cv vu cv cA cS cG cU c1st cfv cX cU
        cG sm1cni.2 vafval cS cU sm1cni.4 smfval cU cG cX sm1cni.1 sm1cni.2
        bafval vcsubdir mpan mp3an3 fveq2d vr cv cc wcel vu cv cc wcel wa vr cv
        vu cv cmin co cc wcel vr cv vu cv cmin co cA cS co cN cfv vr cv vu cv
        cmin co cabs cfv cA cN cfv cmul co wceq vr cv vu cv subcl cU cnv wcel
        vr cv vu cv cmin co cc wcel cA cX wcel vr cv vu cv cmin co cA cS co cN
        cfv vr cv vu cv cmin co cabs cfv cA cN cfv cmul co wceq sm1cni.9
        sm1cni.a vr cv vu cv cmin co cA cS cU cN cX sm1cni.1 sm1cni.4
        sm1cnilem.6 nvs mp3an13 syl 3eqtr2d eqtrd breq1d imbi12d ralbidva
        anbi2d rexbidv ad2antrr mpbird ex rgen2 mpbir2an $.
        $( [4-Dec-2007] $) $( [23-Aug-2007] $)
    $}

    $( Scalar multiplication is continuous in its first operand. $)
    sm1cni $p |- F e. ( J Cn K ) $=
      vw vv cA cC cD cS cU cF cU cpv cfv cJ cK cU cnm cfv cX sm1cni.1 sm1cni.4
      sm1cni.7 sm1cni.8 sm1cni.j sm1cni.k sm1cni.f sm1cni.9 sm1cni.a cU cpv cfv
      eqid cU cnm cfv eqid sm1cnilem $.
      $( [4-Dec-2007] $) $( [1-Aug-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Inner product
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c .i $.

  $( Extend class notation with the class inner product functions. $)
  cip $a class .i $.

  ${
    $d k n p w x y z $.
    $( Define a function that maps a complex normed vector space to its inner
       product operation in case its norm satisfies the parallelogram identity
       (otherwise the operation is still defined, but not meaningful).  Based
       on Exercise 4(a) of [ReedSimon] p. 63 and Theorem 6.44 of [Ponnusamy]
       p. 361.  Vector addition is ` ( 1st `` w ) ` , the scalar product is
       ` ( 2nd `` w ) ` , and the norm is ` n ` . $)
    df-ip $a |- .i = { <. <. w , n >. , p >. | ( <. w , n >. e. NrmCVec /\
        p = { <. <. x , y >. , z >. | ( ( x e. dom n /\ y e. dom n ) /\
        z = ( sum_ k e. ( 1 ... 4 ) ( ( _i ^ k ) x. ( ( n ` ( x ( 1st ` w )
        ( ( _i ^ k ) ( 2nd ` w ) y ) ) ) ^ 2 ) ) / 4 ) ) } ) } $.

$(
    df-ip $a |- .i = { <. x , y >. | ( x e. NrmCVec /\ E. g E. s E. n
            ( x = <. <. g , s >. , n >. /\ y = { <. <. a , b >. , c >. |
            ( ( a e. dom n /\ b e. dom n ) /\ c = ( sum_ k e. ( 1 ... 4 )
             ( ( _i ^ k ) x. ( ( n ` ( a g ( ( _i ^ k ) s b ) ) ) ^ 2 ) )
              / 4 ) ) } ) ) } $.

    df-ip $a |- .i = { <. x , y >. | ( x e. NrmCVec /\ E. g E. s E. n
            ( x = <. <. g , s >. , n >. /\ y = { <. <. a , b >. , c >. |
            ( ( a e. dom n /\ b e. dom n ) /\ c =
                ( ( ( ( ( n ` ( a g b ) ) ^ 2 ) +
                ( ( n ` ( a g ( -u 1 s b ) ) ) ^ 2 ) ) +
                ( _i x. ( ( ( n ` ( a g ( _i s b ) ) ) ^ 2 ) +
                ( ( n ` ( a g ( -u _i s b ) ) ) ^ 2 ) ) ) ) / 4 ) ) } ) ) } $.
$)
  $}

  ${
    $d k A $.  $d k B $.  $d k G $.  $d k N $.  $d k S $.
    ipval2lem.1 $e |- M e. _V $.
    $( Lemma for ~ ipval3 . $)
    ipval2lem1 $p |- [_ M / k ]_ ( ( _i ^ k ) x.
                           ( ( N ` ( A G ( ( _i ^ k ) S B ) ) ) ^ 2 ) ) =
              ( ( _i ^ M ) x. ( ( N ` ( A G ( ( _i ^ M ) S B ) ) ) ^ 2 ) ) $=
      vk cM ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp
      co cmul co csb vk cM ci vk cv cexp co csb vk cM cA ci vk cv cexp co cB cS
      co cG co cN cfv c2 cexp co csb cmul co ci cM cexp co cA ci cM cexp co cB
      cS co cG co cN cfv c2 cexp co cmul co cM cvv wcel vk cM ci vk cv cexp co
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb vk cM ci
      vk cv cexp co csb vk cM cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp
      co csb cmul co wceq ipval2lem.1 vk cM ci vk cv cexp co cA ci vk cv cexp
      co cB cS co cG co cN cfv c2 cexp co cvv cmul csbopr12g ax-mp vk cM ci vk
      cv cexp co csb ci cM cexp co vk cM cA ci vk cv cexp co cB cS co cG co cN
      cfv c2 cexp co csb cA ci cM cexp co cB cS co cG co cN cfv c2 cexp co cmul
      vk cM ci vk cv cexp co csb ci vk cM vk cv csb cexp co ci cM cexp co cM
      cvv wcel vk cM ci vk cv cexp co csb ci vk cM vk cv csb cexp co wceq
      ipval2lem.1 vk cM ci vk cv cvv cexp csbopr2g ax-mp vk cM vk cv csb cM ci
      cexp cM cvv wcel vk cM vk cv csb cM wceq ipval2lem.1 vk cM cvv csbvarg
      ax-mp opreq2i eqtri vk cM cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co csb vk cM cA ci vk cv cexp co cB cS co cG co cN cfv csb c2 cexp
      co cA ci cM cexp co cB cS co cG co cN cfv c2 cexp co cM cvv wcel vk cM cA
      ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co csb vk cM cA ci vk cv
      cexp co cB cS co cG co cN cfv csb c2 cexp co wceq ipval2lem.1 vk cM cA ci
      vk cv cexp co cB cS co cG co cN cfv c2 cvv cexp csbopr1g ax-mp vk cM cA
      ci vk cv cexp co cB cS co cG co cN cfv csb cA ci cM cexp co cB cS co cG
      co cN cfv c2 cexp vk cM cA ci vk cv cexp co cB cS co cG co cN cfv csb vk
      cM cA ci vk cv cexp co cB cS co cG co csb cN cfv cA ci cM cexp co cB cS
      co cG co cN cfv cM cvv wcel vk cM cA ci vk cv cexp co cB cS co cG co cN
      cfv csb vk cM cA ci vk cv cexp co cB cS co cG co csb cN cfv wceq
      ipval2lem.1 vk cM cA ci vk cv cexp co cB cS co cG co cvv cN csbfv2g ax-mp
      vk cM cA ci vk cv cexp co cB cS co cG co csb cA ci cM cexp co cB cS co cG
      co cN vk cM cA ci vk cv cexp co cB cS co cG co csb cA vk cM ci vk cv cexp
      co cB cS co csb cG co cA ci cM cexp co cB cS co cG co cM cvv wcel vk cM
      cA ci vk cv cexp co cB cS co cG co csb cA vk cM ci vk cv cexp co cB cS co
      csb cG co wceq ipval2lem.1 vk cM cA ci vk cv cexp co cB cS co cvv cG
      csbopr2g ax-mp vk cM ci vk cv cexp co cB cS co csb ci cM cexp co cB cS co
      cA cG vk cM ci vk cv cexp co cB cS co csb vk cM ci vk cv cexp co csb cB
      cS co ci cM cexp co cB cS co cM cvv wcel vk cM ci vk cv cexp co cB cS co
      csb vk cM ci vk cv cexp co csb cB cS co wceq ipval2lem.1 vk cM ci vk cv
      cexp co cB cvv cS csbopr1g ax-mp vk cM ci vk cv cexp co csb ci cM cexp co
      cB cS vk cM ci vk cv cexp co csb ci vk cM vk cv csb cexp co ci cM cexp co
      cM cvv wcel vk cM ci vk cv cexp co csb ci vk cM vk cv csb cexp co wceq
      ipval2lem.1 vk cM ci vk cv cvv cexp csbopr2g ax-mp vk cM vk cv csb cM ci
      cexp cM cvv wcel vk cM vk cv csb cM wceq ipval2lem.1 vk cM cvv csbvarg
      ax-mp opreq2i eqtri opreq1i eqtri opreq2i eqtri fveq2i eqtri opreq1i
      eqtri opreq12i eqtri $.
      $( [19-Feb-2007] $) $( [31-Jan-2007] $)
  $}

  ${
    $d k n p w x y z G $.  $d k n p w x y z N $.  $d k n p w x y z S $.
    $d k n p w x y z U $.  $d k x y z A $.  $d k x y z B $.  $d x y z X $.
    ipfval.1 $e |- X = ( BaseSet ` U ) $.
    ipfval.2 $e |- G = ( +v ` U ) $.
    ipfval.4 $e |- S = ( .s ` U ) $.
    ipfval.6 $e |- N = ( norm ` U ) $.
    ipfval.7 $e |- P = ( .i ` U ) $.
    $( The inner product function on a normed complex vector space.  The
       definition is meaningful for vector spaces that are also inner product
       spaces, i.e. satisfy the parallelogram law. $)
    ipfval $p |- ( U e. NrmCVec -> P = { <. <. x , y >. , z >. |
        ( ( x e. X /\ y e. X ) /\
       z = ( sum_ k e. ( 1 ... 4 ) ( ( _i ^ k ) x. ( ( N ` ( x G
       ( ( _i ^ k ) S y ) ) ) ^ 2 ) ) / 4 ) ) } ) $=
      cU cnv wcel cP cU c1st cfv cU c2nd cfv cop cip cfv cU c1st cfv cU c2nd
      cfv cip co vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv
      cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul
      co vk csu c4 cdiv co wceq wa vx vy vz copab2 cU cnv wcel cU cip cfv cU
      c1st cfv cU c2nd cfv cop cip cfv cP cU cnv wcel cU cU c1st cfv cU c2nd
      cfv cop cip cnv wrel cU cnv wcel cU cU c1st cfv cU c2nd cfv cop wceq
      nvrel cU cnv 1st2nd mpan fveq2d ipfval.7 syl5eq cU c1st cfv cU c2nd cfv
      cip co cU c1st cfv cU c2nd cfv cop cip cfv wceq cU cnv wcel cU c1st cfv
      cU c2nd cfv cip df-opr a1i cU cnv wcel cU c1st cfv cU c2nd cfv cip co vx
      cv cN cdm wcel vy cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co
      vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu
      c4 cdiv co wceq wa vx vy vz copab2 vx cv cX wcel vy cv cX wcel wa vz cv
      c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN
      cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 cU cnv
      wcel cU c1st cfv cU c2nd cfv cop cnv wcel cU c1st cfv cU c2nd cfv cip co
      vx cv cN cdm wcel vy cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp
      co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk
      csu c4 cdiv co wceq wa vx vy vz copab2 wceq cU cnv wcel cU c1st cfv cU
      c2nd cfv cop cnv wcel cU cnv wcel cU cU c1st cfv cU c2nd cfv cop cnv cnv
      wrel cU cnv wcel cU cU c1st cfv cU c2nd cfv cop wceq nvrel cU cnv 1st2nd
      mpan eleq1d ibi cU c1st cfv cvv wcel cU c2nd cfv cvv wcel cU c1st cfv cU
      c2nd cfv cop cnv wcel cU c1st cfv cU c2nd cfv cip co vx cv cN cdm wcel vy
      cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp
      co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa
      vx vy vz copab2 wceq cU c1st fvex cU c2nd fvex cU c1st cfv cvv wcel cU
      c2nd cfv cvv wcel cU c1st cfv cU c2nd cfv cop cnv wcel w3a vx cv cN cdm
      wcel vy cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk
      cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co
      wceq wa vx vy vz copab2 cvv wcel cU c1st cfv cU c2nd cfv cip co vx cv cN
      cdm wcel vy cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv
      ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4
      cdiv co wceq wa vx vy vz copab2 wceq vx vy vz cN cdm cN cdm c1 c4 cfz co
      ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp
      co cmul co vk csu c4 cdiv co vx cv cN cdm wcel vy cv cN cdm wcel wa vz cv
      c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN
      cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 cN cN cU
      cnm cfv cvv ipfval.6 cU cnm fvex eqeltri dmex cN cN cU cnm cfv cvv
      ipfval.6 cU cnm fvex eqeltri dmex vx cv cN cdm wcel vy cv cN cdm wcel wa
      vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG
      co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2
      eqid oprabex2 vw vn vp cU c1st cfv cU c2nd cfv cnv vx cv vn cv cdm wcel
      vy cv vn cv cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk
      cv cexp co vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv cfv c2 cexp co
      cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 vx cv cN cdm wcel vy cv
      cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co
      vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx
      vy vz copab2 cip cvv cvv cvv vw cv vn cv cop cU c1st cfv cU c2nd cfv cop
      wceq vw cv cU c1st cfv wceq vn cv cU c2nd cfv wceq wa vx cv vn cv cdm
      wcel vy cv vn cv cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci
      vk cv cexp co vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv cfv c2 cexp
      co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 vx cv cN cdm wcel vy
      cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp
      co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa
      vx vy vz copab2 wceq vw cv vn cv cU c1st cfv cU c2nd cfv vw visset vn
      visset cU c2nd fvex opth vw cv cU c1st cfv wceq vn cv cU c2nd cfv wceq wa
      vx cv vn cv cdm wcel vy cv vn cv cdm wcel wa vz cv c1 c4 cfz co ci vk cv
      cexp co vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw cv c1st cfv co
      vn cv cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx cv cN cdm wcel
      vy cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv
      cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co
      wceq wa vx vy vz vw cv cU c1st cfv wceq vn cv cU c2nd cfv wceq wa vx cv
      vn cv cdm wcel vy cv vn cv cdm wcel wa vx cv cN cdm wcel vy cv cN cdm
      wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv
      vw cv c2nd cfv co vw cv c1st cfv co vn cv cfv c2 cexp co cmul co vk csu
      c4 cdiv co wceq vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp
      co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq vn
      cv cU c2nd cfv wceq vx cv vn cv cdm wcel vy cv vn cv cdm wcel wa vx cv cN
      cdm wcel vy cv cN cdm wcel wa wb vw cv cU c1st cfv wceq vn cv cU c2nd cfv
      wceq vx cv vn cv cdm wcel vx cv cN cdm wcel vy cv vn cv cdm wcel vy cv cN
      cdm wcel vn cv cU c2nd cfv wceq vn cv cdm cN cdm vx cv vn cv cU c2nd cfv
      wceq vn cv cN vn cv cU c2nd cfv wceq vn cv cU c2nd cfv cN vn cv cU c2nd
      cfv wceq id cU cN ipfval.6 nmfval syl6eqr dmeqd eleq2d vn cv cU c2nd cfv
      wceq vn cv cdm cN cdm vy cv vn cv cU c2nd cfv wceq vn cv cN vn cv cU c2nd
      cfv wceq vn cv cU c2nd cfv cN vn cv cU c2nd cfv wceq id cU cN ipfval.6
      nmfval syl6eqr dmeqd eleq2d anbi12d adantl vw cv cU c1st cfv wceq vn cv
      cU c2nd cfv wceq wa c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co
      vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv cfv c2 cexp co cmul co vk
      csu c4 cdiv co c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv
      cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co vz cv vw cv cU
      c1st cfv wceq vn cv cU c2nd cfv wceq wa c1 c4 cfz co ci vk cv cexp co vx
      cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv cfv
      c2 cexp co cmul co vk csu c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv
      cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv vw cv
      cU c1st cfv wceq vn cv cU c2nd cfv wceq wa c1 c4 cfz co ci vk cv cexp co
      vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv
      cfv c2 cexp co cmul co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS
      co cG co cN cfv c2 cexp co cmul co vk vw cv cU c1st cfv wceq vn cv cU
      c2nd cfv wceq wa vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw cv
      c1st cfv co vn cv cfv c2 cexp co vx cv ci vk cv cexp co vy cv cS co cG co
      cN cfv c2 cexp co ci vk cv cexp co cmul vw cv cU c1st cfv wceq vn cv cU
      c2nd cfv wceq wa vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw cv
      c1st cfv co vn cv cfv vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2
      cexp vn cv cU c2nd cfv wceq vw cv cU c1st cfv wceq vx cv ci vk cv cexp co
      vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv cfv vx cv ci vk cv cexp
      co vy cv vw cv c2nd cfv co vw cv c1st cfv co cN cfv vx cv ci vk cv cexp
      co vy cv cS co cG co cN cfv vn cv cU c2nd cfv wceq vx cv ci vk cv cexp co
      vy cv vw cv c2nd cfv co vw cv c1st cfv co vn cv cN vn cv cU c2nd cfv wceq
      vn cv cU c2nd cfv cN vn cv cU c2nd cfv wceq id cU cN ipfval.6 nmfval
      syl6eqr fveq1d vw cv cU c1st cfv wceq vx cv ci vk cv cexp co vy cv vw cv
      c2nd cfv co vw cv c1st cfv co vx cv ci vk cv cexp co vy cv cS co cG co cN
      vw cv cU c1st cfv wceq vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw
      cv c1st cfv co vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co cG co vx cv
      ci vk cv cexp co vy cv cS co cG co vw cv cU c1st cfv wceq vw cv c1st cfv
      cG vx cv ci vk cv cexp co vy cv vw cv c2nd cfv co vw cv cU c1st cfv wceq
      vw cv c1st cfv cU c1st cfv c1st cfv cG vw cv cU c1st cfv c1st fveq2 cU cG
      ipfval.2 vafval syl6eqr opreqd vw cv cU c1st cfv wceq ci vk cv cexp co vy
      cv vw cv c2nd cfv co ci vk cv cexp co vy cv cS co vx cv cG vw cv cU c1st
      cfv wceq vw cv c2nd cfv cS ci vk cv cexp co vy cv vw cv cU c1st cfv wceq
      vw cv c2nd cfv cU c1st cfv c2nd cfv cS vw cv cU c1st cfv c2nd fveq2 cS cU
      ipfval.4 smfval syl6eqr opreqd opreq2d eqtrd fveq2d sylan9eqr opreq1d
      opreq2d sumeq2sdv opreq1d eqeq2d anbi12d oprabbidv sylbi vx vy vz vw vk
      vn vp df-ip oprabval6g mpan2 mp3an12 syl cU cnv wcel vx cv cN cdm wcel vy
      cv cN cdm wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp
      co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa
      vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv
      ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4
      cdiv co wceq wa vx vy vz cU cnv wcel vx cv cN cdm wcel vy cv cN cdm wcel
      wa vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx
      cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4
      cdiv co wceq cU cnv wcel vx cv cN cdm wcel vx cv cX wcel vy cv cN cdm
      wcel vy cv cX wcel cU cnv wcel cN cdm cX vx cv cU cnv wcel cX cr cN wf cN
      cdm cX wceq cU cN cX ipfval.1 ipfval.6 nvf cX cr cN fdm syl eleq2d cU cnv
      wcel cN cdm cX vy cv cU cnv wcel cX cr cN wf cN cdm cX wceq cU cN cX
      ipfval.1 ipfval.6 nvf cX cr cN fdm syl eleq2d anbi12d anbi1d oprabbidv
      eqtrd 3eqtr2d $.
      $( [16-Sep-2007] $) $( [10-Apr-2007] $)

    $( Value of the inner product.  The definition is meaningful for normed
       complex vector spaces that are also inner product spaces, i.e. satisfy
       the parallelogram law, although for convenience we define it for any
       normed complex vector space.  The vector (group) addition operation is
       ` G ` , the scalar product is ` S ` , the norm is ` N ` , and the set
       of vectors is ` X ` .  Equation 6.45 of [Ponnusamy] p. 361. $)
    ipval $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A P B ) =
                ( sum_ k e. ( 1 ... 4 ) ( ( _i ^ k ) x. ( ( N ` ( A G
                    ( ( _i ^ k ) S B ) ) ) ^ 2 ) ) / 4 ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cA cB vx cv cX wcel vy
      cv cX wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co
      vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx
      vy vz copab2 co c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cS
      co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co cU cnv wcel cA cX
      wcel cA cB cP co cA cB vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co
      ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp
      co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 co wceq cB cX wcel
      cU cnv wcel cP vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv
      cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul
      co vk csu c4 cdiv co wceq wa vx vy vz copab2 cA cB vx vy vz cP cS cU vk
      cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipfval opreqd
      3ad2ant1 cA cX wcel cB cX wcel cA cB vx cv cX wcel vy cv cX wcel wa vz cv
      c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN
      cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 co c1 c4
      cfz co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp
      co cmul co vk csu c4 cdiv co wceq cU cnv wcel vx vy vz cA cB cX cX c1 c4
      cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv
      c2 cexp co cmul co vk csu c4 cdiv co c1 c4 cfz co ci vk cv cexp co cA ci
      vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co
      vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv
      ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4
      cdiv co wceq wa vx vy vz copab2 c1 c4 cfz co ci vk cv cexp co cA ci vk cv
      cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv co c1
      c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co cmul co vk csu c4 cdiv oprex vx cv cA wceq c1 c4 cfz co ci vk cv
      cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul
      co vk csu c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co vy cv cS co
      cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv vx cv cA wceq c1 c4 cfz co
      ci vk cv cexp co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp
      co cmul co ci vk cv cexp co cA ci vk cv cexp co vy cv cS co cG co cN cfv
      c2 cexp co cmul co vk vx cv cA wceq vx cv ci vk cv cexp co vy cv cS co cG
      co cN cfv c2 cexp co cA ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp
      co ci vk cv cexp co cmul vx cv cA wceq vx cv ci vk cv cexp co vy cv cS co
      cG co cN cfv cA ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp vx cv
      cA wceq vx cv ci vk cv cexp co vy cv cS co cG co cA ci vk cv cexp co vy
      cv cS co cG co cN vx cv cA ci vk cv cexp co vy cv cS co cG opreq1 fveq2d
      opreq1d opreq2d sumeq2sdv opreq1d vy cv cB wceq c1 c4 cfz co ci vk cv
      cexp co cA ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co
      vk csu c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co
      cN cfv c2 cexp co cmul co vk csu c4 cdiv vy cv cB wceq c1 c4 cfz co ci vk
      cv cexp co cA ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul
      co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co
      cmul co vk vy cv cB wceq cA ci vk cv cexp co vy cv cS co cG co cN cfv c2
      cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co ci vk cv
      cexp co cmul vy cv cB wceq cA ci vk cv cexp co vy cv cS co cG co cN cfv
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp vy cv cB wceq cA ci vk
      cv cexp co vy cv cS co cG co cA ci vk cv cexp co cB cS co cG co cN vy cv
      cB wceq ci vk cv cexp co vy cv cS co ci vk cv cexp co cB cS co cA cG vy
      cv cB ci vk cv cexp co cS opreq2 opreq2d fveq2d opreq1d opreq2d sumeq2sdv
      opreq1d vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv cexp
      co vx cv ci vk cv cexp co vy cv cS co cG co cN cfv c2 cexp co cmul co vk
      csu c4 cdiv co wceq wa vx vy vz copab2 eqid oprabval2 3adant1 eqtrd $.
      $( [29-Sep-2007] $) $( [31-Jan-2007] $)

    $( Lemma for ~ ipval3 . $)
    ipval2lem2 $p |- ( ( ( U e. NrmCVec /\ A e. X /\ B e. X ) /\ C e. CC ) ->
               ( ( N ` ( A G ( C S B ) ) ) ^ 2 ) e. RR ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS co cG co
      cN cfv cr wcel cA cC cB cS co cG co cN cfv c2 cexp co cr wcel cU cnv wcel
      cA cC cB cS co cG co cX wcel cA cC cB cS co cG co cN cfv cr wcel cU cnv
      wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS co cG co cU cN
      cX ipfval.1 ipfval.6 nvcl cU cnv wcel cA cX wcel cB cX wcel w3a cU cnv
      wcel cC cc wcel cU cnv wcel cA cX wcel cB cX wcel 3simp1 adantr cU cnv
      wcel cA cX wcel cC cB cS co cX wcel cA cC cB cS co cG co cX wcel cU cnv
      wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS co cU cG cX
      ipfval.1 ipfval.2 nvgcl cU cnv wcel cA cX wcel cB cX wcel w3a cU cnv wcel
      cC cc wcel cU cnv wcel cA cX wcel cB cX wcel 3simp1 adantr cU cnv wcel cA
      cX wcel cB cX wcel w3a cA cX wcel cC cc wcel cU cnv wcel cA cX wcel cB cX
      wcel 3simp2 adantr cU cnv wcel cB cX wcel cC cc wcel cC cB cS co cX wcel
      cA cX wcel cU cnv wcel cB cX wcel cC cc wcel cC cB cS co cX wcel cU cnv
      wcel cC cc wcel cB cX wcel cC cB cS co cX wcel cC cB cS cU cX ipfval.1
      ipfval.4 nvscl 3com23 3expa 3adantl2 syl3anc sylanc cA cC cB cS co cG co
      cN cfv resqcl syl $.
      $( [1-Oct-2007] $) $( [1-Feb-2007] $)

    $( Lemma for ~ ipval3 . $)
    ipval2lem3 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( ( N ` ( A G B ) ) ^ 2 ) e. RR ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cB cS co cG co cN cfv c2 cexp
      co cA cB cG co cN cfv c2 cexp co cr cU cnv wcel cB cX wcel cA c1 cB cS co
      cG co cN cfv c2 cexp co cA cB cG co cN cfv c2 cexp co wceq cA cX wcel cU
      cnv wcel cB cX wcel wa cA c1 cB cS co cG co cN cfv cA cB cG co cN cfv c2
      cexp cU cnv wcel cB cX wcel wa cA c1 cB cS co cG co cA cB cG co cN cU cnv
      wcel cB cX wcel wa c1 cB cS co cB cA cG cB cS cU cX ipfval.1 ipfval.4
      nvsid opreq2d fveq2d opreq1d 3adant2 cU cnv wcel cA cX wcel cB cX wcel
      w3a c1 cc wcel cA c1 cB cS co cG co cN cfv c2 cexp co cr wcel ax1cn cA cB
      c1 cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7
      ipval2lem2 mpan2 eqeltrrd $.
      $( [1-Oct-2007] $) $( [1-Feb-2007] $)

    $( Lemma for ~ ipval3 . $)
    ipval2lem4 $p |- ( ( ( U e. NrmCVec /\ A e. X /\ B e. X ) /\ C e. CC ) ->
               ( ( N ` ( A G ( C S B ) ) ) ^ 2 ) e. CC ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS co cG co
      cN cfv c2 cexp co cA cB cC cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4
      ipfval.6 ipfval.7 ipval2lem2 recnd $.
      $( [1-Oct-2007] $) $( [1-Feb-2007] $)

    $( Expansion of the inner product value ~ ipval .  _Warning:  The HTML
       proof page is 0.5MB in size_. $)
    ipval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A P B )
               = ( ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) +
               ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u _i S B ) ) ) ^ 2 ) ) ) ) / 4 ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co c1 c4 cfz co ci vk cv
      cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co vk
      csu c4 cdiv co cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN
      cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co
      cA cB cP cS cU vk cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7
      ipval cU cnv wcel cA cX wcel cB cX wcel w3a c1 c4 cfz co ci vk cv cexp co
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co vk csu cA cB
      cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin
      co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN
      cfv c2 cexp co cmin co cmul co caddc co c4 cdiv cU cnv wcel cA cX wcel cB
      cX wcel w3a ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co c1 cneg cA
      c1 cneg cB cS co cG co cN cfv c2 cexp co cmul co caddc co ci cneg cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cmul co caddc co ci c4 cexp co cA
      ci c4 cexp co cB cS co cG co cN cfv c2 cexp co cmul co caddc co ci cA ci
      cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cmin co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co cA
      cB cG co cN cfv c2 cexp co caddc co c1 c4 cfz co ci vk cv cexp co cA ci
      vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co vk csu cA cB cG co
      cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci
      cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv
      c2 cexp co cmin co cmul co caddc co cU cnv wcel cA cX wcel cB cX wcel w3a
      ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co c1 cneg cA c1 cneg cB
      cS co cG co cN cfv c2 cexp co cmul co caddc co ci cneg cA ci cneg cB cS
      co cG co cN cfv c2 cexp co cmul co caddc co ci cA ci cB cS co cG co cN
      cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul
      co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci c4 cexp co cA
      ci c4 cexp co cB cS co cG co cN cfv c2 cexp co cmul co cA cB cG co cN cfv
      c2 cexp co caddc cU cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co
      cG co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp
      co cmin co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cneg
      caddc co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cA c1 cneg cB
      cS co cG co cN cfv c2 cexp co cmin co ci cA ci cneg cB cS co cG co cN cfv
      c2 cexp co cmul co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul
      co c1 cneg cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmul co caddc co
      ci cneg cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co caddc co ci
      cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv
      c2 cexp co cmin co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cA c1 cneg cB
      cS co cG co cN cfv c2 cexp co cmin co cc wcel ci cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmul co cc wcel ci cA ci cB cS co cG co cN cfv c2
      cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA
      ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cneg caddc co ci cA ci
      cB cS co cG co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv
      c2 cexp co cmin co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co
      cmin co wceq cU cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co cG
      co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmin co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co negsub ci
      cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc wcel cA c1 cneg cB cS
      co cG co cN cfv c2 cexp co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp
      co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co cc wcel cU
      cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co cG co cN cfv c2 cexp
      co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co subcl cU cnv wcel
      cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv c2 cexp co cc wcel
      ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc wcel cU cnv wcel cA
      cX wcel cB cX wcel w3a ci cc wcel cA ci cB cS co cG co cN cfv c2 cexp co
      cc wcel axicn cA cB ci cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4
      ipfval.6 ipfval.7 ipval2lem4 mpan2 ci cc wcel cA ci cB cS co cG co cN cfv
      c2 cexp co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc
      wcel axicn ci cA ci cB cS co cG co cN cfv c2 cexp co mulcl mpan syl cU
      cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cc wcel cA c1 cneg cB cS co cG
      co cN cfv c2 cexp co cc wcel c1 ax1cn negcli cA cB c1 cneg cP cS cU cG cN
      cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 sylanc
      cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cneg cB cS co cG co cN cfv c2
      cexp co cc wcel ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cc
      wcel cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cc wcel cA ci cneg cB
      cS co cG co cN cfv c2 cexp co cc wcel ci axicn negcli cA cB ci cneg cP cS
      cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2
      ci cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cmul co cc wcel axicn ci cA ci cneg
      cB cS co cG co cN cfv c2 cexp co mulcl mpan syl sylanc cU cnv wcel cA cX
      wcel cB cX wcel w3a ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co c1
      cneg cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmul co caddc co ci cA
      ci cB cS co cG co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN
      cfv c2 cexp co cmin co ci cneg cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cmul co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cneg
      caddc cU cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co cG co cN
      cfv c2 cexp co cmul co c1 cneg cA c1 cneg cB cS co cG co cN cfv c2 cexp
      co cmul co caddc co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cA
      c1 cneg cB cS co cG co cN cfv c2 cexp co cneg caddc co ci cA ci cB cS co
      cG co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp
      co cmin co cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cA c1 cneg cB cS
      co cG co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cneg ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co caddc cU
      cnv wcel cA cX wcel cB cX wcel w3a cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cc wcel c1 cneg cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmul
      co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cneg wceq cU cnv wcel cA
      cX wcel cB cX wcel w3a c1 cneg cc wcel cA c1 cneg cB cS co cG co cN cfv
      c2 cexp co cc wcel c1 ax1cn negcli cA cB c1 cneg cP cS cU cG cN cX
      ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 cA c1 cneg
      cB cS co cG co cN cfv c2 cexp co mulm1 syl opreq2d ci cA ci cB cS co cG
      co cN cfv c2 cexp co cmul co cc wcel cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cA c1
      cneg cB cS co cG co cN cfv c2 cexp co cneg caddc co ci cA ci cB cS co cG
      co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmin co wceq cU cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co cG
      co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      negsub cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv
      c2 cexp co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc
      wcel cU cnv wcel cA cX wcel cB cX wcel w3a ci cc wcel cA ci cB cS co cG
      co cN cfv c2 cexp co cc wcel axicn cA cB ci cP cS cU cG cN cX ipfval.1
      ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 ci cc wcel cA ci cB
      cS co cG co cN cfv c2 cexp co cc wcel ci cA ci cB cS co cG co cN cfv c2
      cexp co cmul co cc wcel axicn ci cA ci cB cS co cG co cN cfv c2 cexp co
      mulcl mpan syl cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cc wcel cA
      c1 cneg cB cS co cG co cN cfv c2 cexp co cc wcel c1 ax1cn negcli cA cB c1
      cneg cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7
      ipval2lem4 mpan2 sylanc eqtrd cU cnv wcel cA cX wcel cB cX wcel w3a cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci cneg cA ci cneg cB cS co
      cG co cN cfv c2 cexp co cmul co ci cA ci cneg cB cS co cG co cN cfv c2
      cexp co cmul co cneg wceq cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg
      cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci axicn
      negcli cA cB ci cneg cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4
      ipfval.6 ipfval.7 ipval2lem4 mpan2 ci cc wcel cA ci cneg cB cS co cG co
      cN cfv c2 cexp co cc wcel ci cneg cA ci cneg cB cS co cG co cN cfv c2
      cexp co cmul co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co
      cneg wceq axicn ci cA ci cneg cB cS co cG co cN cfv c2 cexp co mulneg1
      mpan syl opreq12d cU cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co
      cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin
      co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci
      cB cS co cG co cN cfv c2 cexp co cmul co ci cA ci cneg cB cS co cG co cN
      cfv c2 cexp co cmul co cmin co cA c1 cneg cB cS co cG co cN cfv c2 cexp
      co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cA c1 cneg
      cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cneg cB cS co cG co cN
      cfv c2 cexp co cmul co cmin co cU cnv wcel cA cX wcel cB cX wcel w3a ci
      cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv
      c2 cexp co cmin co cmul co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul
      co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cmin co cA c1
      cneg cB cS co cG co cN cfv c2 cexp co cmin cA ci cB cS co cG co cN cfv c2
      cexp co cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci cA
      ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2
      cexp co cmin co cmul co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co
      ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cmin co wceq cU
      cnv wcel cA cX wcel cB cX wcel w3a ci cc wcel cA ci cB cS co cG co cN cfv
      c2 cexp co cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci
      cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv
      c2 cexp co cmin co cmul co ci cA ci cB cS co cG co cN cfv c2 cexp co cmul
      co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cmin co wceq
      axicn ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co
      cN cfv c2 cexp co subdi mp3an1 cU cnv wcel cA cX wcel cB cX wcel w3a ci
      cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cc wcel axicn cA cB ci cP
      cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4
      mpan2 cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cc wcel cA ci cneg cB
      cS co cG co cN cfv c2 cexp co cc wcel ci axicn negcli cA cB ci cneg cP cS
      cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2
      sylanc opreq1d ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc wcel
      ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cc wcel cA c1 cneg
      cB cS co cG co cN cfv c2 cexp co cc wcel ci cA ci cB cS co cG co cN cfv
      c2 cexp co cmul co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co
      cmin co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cB
      cS co cG co cN cfv c2 cexp co cmul co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cmin co ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co
      cmin co wceq cU cnv wcel cA cX wcel cB cX wcel w3a ci cA ci cB cS co cG
      co cN cfv c2 cexp co cmul co ci cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co sub23 cU cnv wcel
      cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv c2 cexp co cc wcel
      ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc wcel cU cnv wcel cA
      cX wcel cB cX wcel w3a ci cc wcel cA ci cB cS co cG co cN cfv c2 cexp co
      cc wcel axicn cA cB ci cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4
      ipfval.6 ipfval.7 ipval2lem4 mpan2 ci cc wcel cA ci cB cS co cG co cN cfv
      c2 cexp co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cc
      wcel axicn ci cA ci cB cS co cG co cN cfv c2 cexp co mulcl mpan syl cU
      cnv wcel cA cX wcel cB cX wcel w3a cA ci cneg cB cS co cG co cN cfv c2
      cexp co cc wcel ci cA ci cneg cB cS co cG co cN cfv c2 cexp co cmul co cc
      wcel cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cc wcel cA ci cneg cB
      cS co cG co cN cfv c2 cexp co cc wcel ci axicn negcli cA cB ci cneg cP cS
      cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2
      ci cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cmul co cc wcel axicn ci cA ci cneg
      cB cS co cG co cN cfv c2 cexp co mulcl mpan syl cU cnv wcel cA cX wcel cB
      cX wcel w3a c1 cneg cc wcel cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cc wcel c1 ax1cn negcli cA cB c1 cneg cP cS cU cG cN cX ipfval.1 ipfval.2
      ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 syl3anc eqtrd 3eqtr4d cU cnv
      wcel cA cX wcel cB cX wcel w3a ci c4 cexp co cA ci c4 cexp co cB cS co cG
      co cN cfv c2 cexp co cmul co c1 cA cB cG co cN cfv c2 cexp co cmul co cA
      cB cG co cN cfv c2 cexp co cU cnv wcel cB cX wcel ci c4 cexp co cA ci c4
      cexp co cB cS co cG co cN cfv c2 cexp co cmul co c1 cA cB cG co cN cfv c2
      cexp co cmul co wceq cA cX wcel cU cnv wcel cB cX wcel wa ci c4 cexp co
      c1 cA ci c4 cexp co cB cS co cG co cN cfv c2 cexp co cA cB cG co cN cfv
      c2 cexp co cmul ci c4 cexp co c1 wceq cU cnv wcel cB cX wcel wa i4 a1i cU
      cnv wcel cB cX wcel wa cA ci c4 cexp co cB cS co cG co cN cfv cA cB cG co
      cN cfv c2 cexp cU cnv wcel cB cX wcel wa cA ci c4 cexp co cB cS co cG co
      cA cB cG co cN cU cnv wcel cB cX wcel wa ci c4 cexp co cB cS co cB cA cG
      cU cnv wcel cB cX wcel wa c1 cB cS co cB ci c4 cexp co cB cS co cB cS cU
      cX ipfval.1 ipfval.4 nvsid ci c4 cexp co c1 cB cS i4 opreq1i syl5eq
      opreq2d fveq2d opreq1d opreq12d 3adant2 cU cnv wcel cA cX wcel cB cX wcel
      w3a cA cB cG co cN cfv c2 cexp co cc wcel c1 cA cB cG co cN cfv c2 cexp
      co cmul co cA cB cG co cN cfv c2 cexp co wceq cU cnv wcel cA cX wcel cB
      cX wcel w3a cA cB cG co cN cfv c2 cexp co cA cB cP cS cU cG cN cX
      ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem3 recnd cA cB cG co
      cN cfv c2 cexp co mulid2 syl eqtrd opreq12d c1 c4 cfz co ci vk cv cexp co
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co vk csu ci cA
      ci cB cS co cG co cN cfv c2 cexp co cmul co c1 cneg cA c1 cneg cB cS co
      cG co cN cfv c2 cexp co cmul co caddc co ci cneg cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmul co caddc co ci c4 cexp co cA ci c4 cexp co cB
      cS co cG co cN cfv c2 cexp co cmul co caddc co wceq cU cnv wcel cA cX
      wcel cB cX wcel w3a c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB
      cS co cG co cN cfv c2 cexp co cmul co vk csu c1 c1 c3 caddc co cfz co ci
      vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul
      co vk csu vk c1 ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN
      cfv c2 cexp co cmul co csb vk c1 c1 caddc co ci vk cv cexp co cA ci vk cv
      cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb caddc co vk c1 c2
      caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co cmul co csb caddc co vk c1 c3 caddc co ci vk cv cexp co cA ci vk
      cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb caddc co ci cA ci
      cB cS co cG co cN cfv c2 cexp co cmul co c1 cneg cA c1 cneg cB cS co cG
      co cN cfv c2 cexp co cmul co caddc co ci cneg cA ci cneg cB cS co cG co
      cN cfv c2 cexp co cmul co caddc co ci c4 cexp co cA ci c4 cexp co cB cS
      co cG co cN cfv c2 cexp co cmul co caddc co c1 c4 cfz co c1 c1 c3 caddc
      co cfz co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co cmul co vk c4 c1 c3 caddc co c1 cfz c4 c3 c1 caddc co c1 c3 caddc
      co df-4 c3 c1 c3 3re recni ax1cn addcomi eqtri opreq2i sumeq1i c1 cz wcel
      c1 c1 c3 caddc co cfz co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG
      co cN cfv c2 cexp co cmul co vk csu vk c1 ci vk cv cexp co cA ci vk cv
      cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb vk c1 c1 caddc co ci
      vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul
      co csb caddc co vk c1 c2 caddc co ci vk cv cexp co cA ci vk cv cexp co cB
      cS co cG co cN cfv c2 cexp co cmul co csb caddc co vk c1 c3 caddc co ci
      vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul
      co csb caddc co wceq 1z ci vk cv cexp co cA ci vk cv cexp co cB cS co cG
      co cN cfv c2 cexp co cmul co vk c1 ci vk cv cexp co cA ci vk cv cexp co
      cB cS co cG co cN cfv c2 cexp co cmul oprex fsum4 ax-mp vk c1 ci vk cv
      cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb
      vk c1 c1 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN
      cfv c2 cexp co cmul co csb caddc co vk c1 c2 caddc co ci vk cv cexp co cA
      ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb caddc co ci
      cA ci cB cS co cG co cN cfv c2 cexp co cmul co c1 cneg cA c1 cneg cB cS
      co cG co cN cfv c2 cexp co cmul co caddc co ci cneg cA ci cneg cB cS co
      cG co cN cfv c2 cexp co cmul co caddc co vk c1 c3 caddc co ci vk cv cexp
      co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb ci c4
      cexp co cA ci c4 cexp co cB cS co cG co cN cfv c2 cexp co cmul co caddc
      vk c1 ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp
      co cmul co csb vk c1 c1 caddc co ci vk cv cexp co cA ci vk cv cexp co cB
      cS co cG co cN cfv c2 cexp co cmul co csb caddc co ci cA ci cB cS co cG
      co cN cfv c2 cexp co cmul co c1 cneg cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cmul co caddc co vk c1 c2 caddc co ci vk cv cexp co cA ci vk cv
      cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb ci cneg cA ci cneg
      cB cS co cG co cN cfv c2 cexp co cmul co caddc vk c1 ci vk cv cexp co cA
      ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb ci cA ci cB
      cS co cG co cN cfv c2 cexp co cmul co vk c1 c1 caddc co ci vk cv cexp co
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb c1 cneg
      cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmul co caddc vk c1 ci vk cv
      cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb
      ci c1 cexp co cA ci c1 cexp co cB cS co cG co cN cfv c2 cexp co cmul co
      ci cA ci cB cS co cG co cN cfv c2 cexp co cmul co cA cB cS vk cG c1 cN c1
      cz 1z elisseti ipval2lem1 ci c1 cexp co ci cA ci c1 cexp co cB cS co cG
      co cN cfv c2 cexp co cA ci cB cS co cG co cN cfv c2 cexp co cmul ci cc
      wcel ci c1 cexp co ci wceq axicn ci exp1 ax-mp cA ci c1 cexp co cB cS co
      cG co cN cfv cA ci cB cS co cG co cN cfv c2 cexp cA ci c1 cexp co cB cS
      co cG co cA ci cB cS co cG co cN ci c1 cexp co cB cS co ci cB cS co cA cG
      ci c1 cexp co ci cB cS ci cc wcel ci c1 cexp co ci wceq axicn ci exp1
      ax-mp opreq1i opreq2i fveq2i opreq1i opreq12i eqtri vk c2 ci vk cv cexp
      co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb ci c2
      cexp co cA ci c2 cexp co cB cS co cG co cN cfv c2 cexp co cmul co vk c1
      c1 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co cmul co csb c1 cneg cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmul co cA cB cS vk cG c2 cN c2 cc 2cn elisseti ipval2lem1 c2 c1 c1 caddc
      co wceq vk c2 ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv
      c2 cexp co cmul co csb vk c1 c1 caddc co ci vk cv cexp co cA ci vk cv
      cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb wceq df-2 vk c2 c1
      c1 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co cmul co csbeq1 ax-mp ci c2 cexp co c1 cneg cA ci c2 cexp co cB cS
      co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmul i2 cA ci c2 cexp co cB cS co cG co cN cfv cA c1 cneg cB cS co cG co
      cN cfv c2 cexp cA ci c2 cexp co cB cS co cG co cA c1 cneg cB cS co cG co
      cN ci c2 cexp co cB cS co c1 cneg cB cS co cA cG ci c2 cexp co c1 cneg cB
      cS i2 opreq1i opreq2i fveq2i opreq1i opreq12i 3eqtr3i opreq12i vk c3 ci
      vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul
      co csb ci c3 cexp co cA ci c3 cexp co cB cS co cG co cN cfv c2 cexp co
      cmul co vk c1 c2 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co
      cG co cN cfv c2 cexp co cmul co csb ci cneg cA ci cneg cB cS co cG co cN
      cfv c2 cexp co cmul co cA cB cS vk cG c3 cN c3 cr 3re elisseti ipval2lem1
      c3 c1 c2 caddc co wceq vk c3 ci vk cv cexp co cA ci vk cv cexp co cB cS
      co cG co cN cfv c2 cexp co cmul co csb vk c1 c2 caddc co ci vk cv cexp co
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb wceq c3
      c2 c1 caddc co c1 c2 caddc co df-3 c2 c1 2cn ax1cn addcomi eqtri vk c3 c1
      c2 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2
      cexp co cmul co csbeq1 ax-mp ci c3 cexp co ci cneg cA ci c3 cexp co cB cS
      co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmul i3 cA ci c3 cexp co cB cS co cG co cN cfv cA ci cneg cB cS co cG co
      cN cfv c2 cexp cA ci c3 cexp co cB cS co cG co cA ci cneg cB cS co cG co
      cN ci c3 cexp co cB cS co ci cneg cB cS co cA cG ci c3 cexp co ci cneg cB
      cS i3 opreq1i opreq2i fveq2i opreq1i opreq12i 3eqtr3i opreq12i vk c4 ci
      vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul
      co csb vk c1 c3 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG
      co cN cfv c2 cexp co cmul co csb ci c4 cexp co cA ci c4 cexp co cB cS co
      cG co cN cfv c2 cexp co cmul co c4 c1 c3 caddc co wceq vk c4 ci vk cv
      cexp co cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csb
      vk c1 c3 caddc co ci vk cv cexp co cA ci vk cv cexp co cB cS co cG co cN
      cfv c2 cexp co cmul co csb wceq c4 c3 c1 caddc co c1 c3 caddc co df-4 c3
      c1 c3 3re recni ax1cn addcomi eqtri vk c4 c1 c3 caddc co ci vk cv cexp co
      cA ci vk cv cexp co cB cS co cG co cN cfv c2 cexp co cmul co csbeq1 ax-mp
      cA cB cS vk cG c4 cN c4 cr 4re elisseti ipval2lem1 eqtr3i opreq12i 3eqtri
      a1i cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp co
      cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG
      co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co
      cmul co caddc co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB
      cS co cG co cN cfv c2 cexp co cmin co cmul co cA cB cG co cN cfv c2 cexp
      co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co caddc co ci cA ci
      cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cmin co cmul co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co cA
      cB cG co cN cfv c2 cexp co caddc co cA cB cG co cN cfv c2 cexp co cA c1
      cneg cB cS co cG co cN cfv c2 cexp co cmin co cc wcel ci cA ci cB cS co
      cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin
      co cmul co cc wcel cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG
      co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA
      ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co ci cA
      ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2
      cexp co cmin co cmul co cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co
      cG co cN cfv c2 cexp co cmin co caddc co wceq cU cnv wcel cA cX wcel cB
      cX wcel w3a cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN
      cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co addcom cA cB cG co
      cN cfv c2 cexp co cc wcel cA c1 cneg cB cS co cG co cN cfv c2 cexp co cc
      wcel cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cmin co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co
      cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co subcl cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp co cA cB cP
      cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem3
      recnd cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cc wcel cA c1 cneg cB
      cS co cG co cN cfv c2 cexp co cc wcel c1 ax1cn negcli cA cB c1 cneg cP cS
      cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2
      sylanc cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv
      c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cc wcel ci
      cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv
      c2 cexp co cmin co cmul co cc wcel cA ci cB cS co cG co cN cfv c2 cexp co
      cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel cA ci cB cS
      co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmin co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG
      co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co subcl cU
      cnv wcel cA cX wcel cB cX wcel w3a ci cc wcel cA ci cB cS co cG co cN cfv
      c2 cexp co cc wcel axicn cA cB ci cP cS cU cG cN cX ipfval.1 ipfval.2
      ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 cU cnv wcel cA cX wcel cB cX
      wcel w3a ci cneg cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp co cc
      wcel ci axicn negcli cA cB ci cneg cP cS cU cG cN cX ipfval.1 ipfval.2
      ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 sylanc ci cc wcel cA ci cB cS
      co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmin co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB
      cS co cG co cN cfv c2 cexp co cmin co cmul co cc wcel axicn ci cA ci cB
      cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmin co mulcl mpan syl sylanc ci cA ci cB cS co cG co cN cfv c2 cexp co
      cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co cc wcel cA c1
      cneg cB cS co cG co cN cfv c2 cexp co cc wcel cA cB cG co cN cfv c2 cexp
      co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co
      cG co cN cfv c2 cexp co cmin co cmul co cA c1 cneg cB cS co cG co cN cfv
      c2 cexp co cmin co cA cB cG co cN cfv c2 cexp co caddc co ci cA ci cB cS
      co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmin co cmul co cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co
      cN cfv c2 cexp co cmin co caddc co wceq cU cnv wcel cA cX wcel cB cX wcel
      w3a ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co
      cN cfv c2 cexp co cmin co cmul co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cA cB cG co cN cfv c2 cexp co subadd23 cU cnv wcel cA cX wcel cB
      cX wcel w3a cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmin co cc wcel ci cA ci cB cS co cG co cN cfv c2
      cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co cc
      wcel cA ci cB cS co cG co cN cfv c2 cexp co cc wcel cA ci cneg cB cS co
      cG co cN cfv c2 cexp co cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cA
      ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cc wcel cU cnv wcel cA
      cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg
      cB cS co cG co cN cfv c2 cexp co subcl cU cnv wcel cA cX wcel cB cX wcel
      w3a ci cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cc wcel axicn cA cB
      ci cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7
      ipval2lem4 mpan2 cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cc wcel cA
      ci cneg cB cS co cG co cN cfv c2 cexp co cc wcel ci axicn negcli cA cB ci
      cneg cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7
      ipval2lem4 mpan2 sylanc ci cc wcel cA ci cB cS co cG co cN cfv c2 cexp co
      cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cc wcel ci cA ci cB
      cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmin co cmul co cc wcel axicn ci cA ci cB cS co cG co cN cfv c2 cexp co
      cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co mulcl mpan syl cU cnv
      wcel cA cX wcel cB cX wcel w3a c1 cneg cc wcel cA c1 cneg cB cS co cG co
      cN cfv c2 cexp co cc wcel c1 ax1cn negcli cA cB c1 cneg cP cS cU cG cN cX
      ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem4 mpan2 cU cnv wcel
      cA cX wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp co cA cB cP cS cU cG
      cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem3 recnd
      syl3anc eqtr4d 3eqtr4d opreq1d eqtrd $.
      $( [1-Oct-2007] $) $( [31-Jan-2007] $)

    $( Four times the inner product value ~ ipval3 , useful for simplifying
       certain proofs. $)
    4ipval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
        ( 4 x. ( A P B ) ) = ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) +
               ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u _i S B ) ) ) ^ 2 ) ) ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a c4 cA cB cP co cmul co c4 cA cB cG
      co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co
      ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN
      cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co cmul co cA cB cG co cN
      cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA
      ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2
      cexp co cmin co cmul co caddc co cU cnv wcel cA cX wcel cB cX wcel w3a cA
      cB cP co cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv
      c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg
      cB cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co c4
      cmul cA cB cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7
      ipval2 opreq2d cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv
      c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci
      cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cmin co cmul co caddc co cc wcel c4 cA cB cG co cN cfv c2 cexp co cA
      c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co
      cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co
      cmul co caddc co c4 cdiv co cmul co cA cB cG co cN cfv c2 cexp co cA c1
      cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN
      cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul
      co caddc co wceq cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co
      cN cfv c2 cexp co cmin co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp
      co cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co cc wcel cA
      cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmin co cmul co caddc co cc wcel cU cnv wcel cA cX
      wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG
      co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA
      ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co addcl cA cB cG
      co cN cfv c2 cexp co cc wcel cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cc wcel cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cmin co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co
      cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co subcl cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv cc wcel cA cB cG co
      cN cfv c2 cexp co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG
      co cN cfv cU cnv wcel cA cB cG co cX wcel cA cB cG co cN cfv cr wcel cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cU cN cX ipfval.1 ipfval.6
      nvcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cA cB cU cG cX ipfval.1
      ipfval.2 nvgcl sylanc recnd cA cB cG co cN cfv sqcl syl cU cnv wcel cA cX
      wcel cB cX wcel w3a cA c1 cneg cB cS co cG co cN cfv cc wcel cA c1 cneg
      cB cS co cG co cN cfv c2 cexp co cc wcel cU cnv wcel cA cX wcel cB cX
      wcel w3a cA c1 cneg cB cS co cG co cN cfv cU cnv wcel cA c1 cneg cB cS co
      cG co cX wcel cA c1 cneg cB cS co cG co cN cfv cr wcel cU cnv wcel cA cX
      wcel cB cX wcel w3a cA c1 cneg cB cS co cG co cU cN cX ipfval.1 ipfval.6
      nvcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel c1
      cneg cB cS co cX wcel cA c1 cneg cB cS co cG co cX wcel cB cX wcel cA c1
      cneg cB cS co cU cG cX ipfval.1 ipfval.2 nvgcl cU cnv wcel cB cX wcel c1
      cneg cB cS co cX wcel cA cX wcel cU cnv wcel c1 cneg cc wcel cB cX wcel
      c1 cneg cB cS co cX wcel c1 ax1cn negcli c1 cneg cB cS cU cX ipfval.1
      ipfval.4 nvscl mp3an2 3adant2 syld3an3 sylanc recnd cA c1 cneg cB cS co
      cG co cN cfv sqcl syl sylanc cU cnv wcel cA cX wcel cB cX wcel w3a cA ci
      cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cmin co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg
      cB cS co cG co cN cfv c2 cexp co cmin co cmul co cc wcel cA ci cB cS co
      cG co cN cfv c2 cexp co cc wcel cA ci cneg cB cS co cG co cN cfv c2 cexp
      co cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmin co cc wcel cU cnv wcel cA cX wcel cB cX wcel
      w3a cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN
      cfv c2 cexp co subcl cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co
      cG co cN cfv cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cc wcel cU
      cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cN cfv cU cnv
      wcel cA ci cB cS co cG co cX wcel cA ci cB cS co cG co cN cfv cr wcel cU
      cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cG co cU cN cX ipfval.1
      ipfval.6 nvcl cU cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX
      wcel ci cB cS co cX wcel cA ci cB cS co cG co cX wcel cB cX wcel cA ci cB
      cS co cU cG cX ipfval.1 ipfval.2 nvgcl cU cnv wcel cB cX wcel ci cB cS co
      cX wcel cA cX wcel cU cnv wcel ci cc wcel cB cX wcel ci cB cS co cX wcel
      axicn ci cB cS cU cX ipfval.1 ipfval.4 nvscl mp3an2 3adant2 syld3an3
      sylanc recnd cA ci cB cS co cG co cN cfv sqcl syl cU cnv wcel cA cX wcel
      cB cX wcel w3a cA ci cneg cB cS co cG co cN cfv cc wcel cA ci cneg cB cS
      co cG co cN cfv c2 cexp co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a
      cA ci cneg cB cS co cG co cN cfv cU cnv wcel cA ci cneg cB cS co cG co cX
      wcel cA ci cneg cB cS co cG co cN cfv cr wcel cU cnv wcel cA cX wcel cB
      cX wcel w3a cA ci cneg cB cS co cG co cU cN cX ipfval.1 ipfval.6 nvcl cU
      cnv wcel cA cX wcel cB cX wcel 3simp1 cU cnv wcel cA cX wcel ci cneg cB
      cS co cX wcel cA ci cneg cB cS co cG co cX wcel cB cX wcel cA ci cneg cB
      cS co cU cG cX ipfval.1 ipfval.2 nvgcl cU cnv wcel cB cX wcel ci cneg cB
      cS co cX wcel cA cX wcel cU cnv wcel ci cneg cc wcel cB cX wcel ci cneg
      cB cS co cX wcel ci axicn negcli ci cneg cB cS cU cX ipfval.1 ipfval.4
      nvscl mp3an2 3adant2 syld3an3 sylanc recnd cA ci cneg cB cS co cG co cN
      cfv sqcl syl sylanc ci cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cA
      ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cc wcel ci cA ci cB cS
      co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp co
      cmin co cmul co cc wcel axicn ci cA ci cB cS co cG co cN cfv c2 cexp co
      cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co mulcl mpan syl sylanc
      cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmin co cmul co caddc co cc wcel c4 cc wcel c4 cc0
      wne c4 cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB
      cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co cmul co
      cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG
      co cN cfv c2 cexp co cmin co cmul co caddc co wceq c4 4re recni c4 4re
      4pos gt0ne0ii cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN
      cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci
      cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co c4 divcan2
      mp3an23 syl eqtrd $.
      $( [29-Oct-2007] $) $( [10-Apr-2007] $)

    ${
      ipval3.3 $e |- M = ( -v ` U ) $.
      $( Expansion of the inner product value ~ ipval . $)
      ipval3 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A P B )
               = ( ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
               ( ( N ` ( A M B ) ) ^ 2 ) ) +
               ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
               ( ( N ` ( A M ( _i S B ) ) ) ^ 2 ) ) ) ) / 4 ) ) $=
        cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cA cB cG co cN cfv c2
        cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cB
        cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co cG co cN cfv c2 cexp
        co cmin co cmul co caddc co c4 cdiv co cA cB cG co cN cfv c2 cexp co cA
        cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2
        cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cmul co caddc co
        c4 cdiv co cA cB cP cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6
        ipfval.7 ipval2 cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cN
        cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co
        cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co
        cmul co caddc co cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG
        co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co
        cA ci cneg cB cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co c4
        cdiv cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp
        co cA cB cM co cN cfv c2 cexp co cmin co cA cB cG co cN cfv c2 cexp co
        cA c1 cneg cB cS co cG co cN cfv c2 cexp co cmin co ci cA ci cB cS co
        cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co
        cmul co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co
        cG co cN cfv c2 cexp co cmin co cmul co caddc cU cnv wcel cA cX wcel cB
        cX wcel w3a cA cB cM co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN
        cfv c2 cexp co cA cB cG co cN cfv c2 cexp co cmin cU cnv wcel cA cX
        wcel cB cX wcel w3a cA cB cM co cN cfv cA c1 cneg cB cS co cG co cN cfv
        c2 cexp cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cM co cA c1 cneg cB
        cS co cG co cN cA cB cS cU cG cM cX ipfval.1 ipfval.2 ipfval.4 ipval3.3
        nvmval fveq2d opreq1d opreq2d cU cnv wcel cA cX wcel cB cX wcel w3a cA
        ci cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp
        co cmin co cA ci cB cS co cG co cN cfv c2 cexp co cA ci cneg cB cS co
        cG co cN cfv c2 cexp co cmin co ci cmul cU cnv wcel cA cX wcel cB cX
        wcel w3a cA ci cB cS co cM co cN cfv c2 cexp co cA ci cneg cB cS co cG
        co cN cfv c2 cexp co cA ci cB cS co cG co cN cfv c2 cexp co cmin cU cnv
        wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cM co cN cfv cA ci cneg
        cB cS co cG co cN cfv c2 cexp cU cnv wcel cA cX wcel cB cX wcel w3a cA
        ci cB cS co cM co cA ci cneg cB cS co cG co cN cU cnv wcel cA cX wcel
        cB cX wcel w3a cA ci cB cS co cM co cA c1 cneg ci cB cS co cS co cG co
        cA ci cneg cB cS co cG co cU cnv wcel cA cX wcel ci cB cS co cX wcel cA
        ci cB cS co cM co cA c1 cneg ci cB cS co cS co cG co wceq cB cX wcel cA
        ci cB cS co cS cU cG cM cX ipfval.1 ipfval.2 ipfval.4 ipval3.3 nvmval
        cU cnv wcel cB cX wcel ci cB cS co cX wcel cA cX wcel cU cnv wcel ci cc
        wcel cB cX wcel ci cB cS co cX wcel axicn ci cB cS cU cX ipfval.1
        ipfval.4 nvscl mp3an2 3adant2 syld3an3 cU cnv wcel cA cX wcel cB cX
        wcel w3a c1 cneg ci cB cS co cS co ci cneg cB cS co cA cG cU cnv wcel
        cB cX wcel c1 cneg ci cB cS co cS co ci cneg cB cS co wceq cA cX wcel
        cU cnv wcel cB cX wcel wa c1 cneg ci cmul co cB cS co c1 cneg ci cB cS
        co cS co ci cneg cB cS co cU cnv wcel ci cc wcel cB cX wcel c1 cneg ci
        cmul co cB cS co c1 cneg ci cB cS co cS co wceq axicn cU cnv wcel c1
        cneg cc wcel ci cc wcel cB cX wcel c1 cneg ci cmul co cB cS co c1 cneg
        ci cB cS co cS co wceq c1 ax1cn negcli c1 cneg ci cB cS cU cX ipfval.1
        ipfval.4 nvsass mp3anr1 mpanr1 c1 cneg ci cmul co ci cneg cB cS ci
        axicn mulm1i opreq1i syl5reqr 3adant2 opreq2d eqtrd fveq2d opreq1d
        opreq2d opreq2d opreq12d opreq1d eqtr4d $.
        $( [26-Dec-2007] $) $( [17-Nov-2007] $)

      $( Lemma for ~ ipval3 . $)
      ipval2lem5 $p |- ( ( ( U e. NrmCVec /\ A e. X /\ B e. X ) /\ C e. CC ) ->
                 ( ( N ` ( A M ( C S B ) ) ) ^ 2 ) e. RR ) $=
        cU cnv wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS co cM
        co cN cfv cr wcel cA cC cB cS co cM co cN cfv c2 cexp co cr wcel cU cnv
        wcel cA cC cB cS co cM co cX wcel cA cC cB cS co cM co cN cfv cr wcel
        cU cnv wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS co cM
        co cU cN cX ipfval.1 ipfval.6 nvcl cU cnv wcel cA cX wcel cB cX wcel
        w3a cU cnv wcel cC cc wcel cU cnv wcel cA cX wcel cB cX wcel 3simp1
        adantr cU cnv wcel cA cX wcel cC cB cS co cX wcel cA cC cB cS co cM co
        cX wcel cU cnv wcel cA cX wcel cB cX wcel w3a cC cc wcel wa cA cC cB cS
        co cU cM cX ipfval.1 ipval3.3 nvmcl cU cnv wcel cA cX wcel cB cX wcel
        w3a cU cnv wcel cC cc wcel cU cnv wcel cA cX wcel cB cX wcel 3simp1
        adantr cU cnv wcel cA cX wcel cB cX wcel w3a cA cX wcel cC cc wcel cU
        cnv wcel cA cX wcel cB cX wcel 3simp2 adantr cU cnv wcel cB cX wcel cC
        cc wcel cC cB cS co cX wcel cA cX wcel cU cnv wcel cB cX wcel cC cc
        wcel cC cB cS co cX wcel cU cnv wcel cC cc wcel cB cX wcel cC cB cS co
        cX wcel cC cB cS cU cX ipfval.1 ipfval.4 nvscl 3com23 3expa 3adantl2
        syl3anc sylanc cA cC cB cS co cM co cN cfv resqcl syl $.
        $( [10-Feb-2008] $) $( [1-Feb-2008] $)

      $( Lemma for ~ ipval3 . $)
      ipval2lem6 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                 ( ( N ` ( A M B ) ) ^ 2 ) e. RR ) $=
        cU cnv wcel cA cX wcel cB cX wcel w3a cA c1 cB cS co cM co cN cfv c2
        cexp co cA cB cM co cN cfv c2 cexp co cr cU cnv wcel cB cX wcel cA c1
        cB cS co cM co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co wceq cA
        cX wcel cU cnv wcel cB cX wcel wa cA c1 cB cS co cM co cN cfv cA cB cM
        co cN cfv c2 cexp cU cnv wcel cB cX wcel wa cA c1 cB cS co cM co cA cB
        cM co cN cU cnv wcel cB cX wcel wa c1 cB cS co cB cA cM cB cS cU cX
        ipfval.1 ipfval.4 nvsid opreq2d fveq2d opreq1d 3adant2 cU cnv wcel cA
        cX wcel cB cX wcel w3a c1 cc wcel cA c1 cB cS co cM co cN cfv c2 cexp
        co cr wcel ax1cn cA cB c1 cP cS cU cG cM cN cX ipfval.1 ipfval.2
        ipfval.4 ipfval.6 ipfval.7 ipval3.3 ipval2lem5 mpan2 eqeltrrd $.
        $( [10-Feb-2008] $) $( [1-Feb-2008] $)

      $( Four times the inner product value ~ ipval3 , useful for simplifying
         certain proofs. $)
      4ipval3 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( 4 x. ( A P B ) ) = ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
                 ( ( N ` ( A M B ) ) ^ 2 ) ) +
                 ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
                 ( ( N ` ( A M ( _i S B ) ) ) ^ 2 ) ) ) ) ) $=
        cU cnv wcel cA cX wcel cB cX wcel w3a c4 cA cB cP co cmul co c4 cA cB
        cG co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci
        cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co
        cmin co cmul co caddc co c4 cdiv co cmul co cA cB cG co cN cfv c2 cexp
        co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv
        c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cmul co caddc
        co cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cA cB cG co cN cfv
        c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG
        co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co
        cmul co caddc co c4 cdiv co c4 cmul cA cB cP cS cU cG cM cN cX ipfval.1
        ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval3.3 ipval3 opreq2d cU cnv wcel
        cA cX wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp co cA cB cM co cN
        cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci
        cB cS co cM co cN cfv c2 cexp co cmin co cmul co caddc co cc wcel c4 cA
        cB cG co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA
        ci cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp
        co cmin co cmul co caddc co c4 cdiv co cmul co cA cB cG co cN cfv c2
        cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co
        cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cmul
        co caddc co wceq cA cB cG co cN cfv c2 cexp co cA cB cM co cN cfv c2
        cexp co cmin co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp co cA ci
        cB cS co cM co cN cfv c2 cexp co cmin co cmul co cc wcel cA cB cG co cN
        cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co
        cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co
        cmul co caddc co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cG
        co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB
        cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co
        cmin co cmul co addcl cA cB cG co cN cfv c2 cexp co cc wcel cA cB cM co
        cN cfv c2 cexp co cc wcel cA cB cG co cN cfv c2 cexp co cA cB cM co cN
        cfv c2 cexp co cmin co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA
        cB cG co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co subcl cU cnv
        wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv c2 cexp co cA cB cP
        cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem3
        recnd cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cM co cN cfv c2 cexp
        co cA cB cP cS cU cG cM cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6
        ipfval.7 ipval3.3 ipval2lem6 recnd sylanc cU cnv wcel cA cX wcel cB cX
        wcel w3a cA ci cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN
        cfv c2 cexp co cmin co cc wcel ci cA ci cB cS co cG co cN cfv c2 cexp
        co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cmul co cc wcel cA ci
        cB cS co cG co cN cfv c2 cexp co cc wcel cA ci cB cS co cM co cN cfv c2
        cexp co cc wcel cA ci cB cS co cG co cN cfv c2 cexp co cA ci cB cS co
        cM co cN cfv c2 cexp co cmin co cc wcel cU cnv wcel cA cX wcel cB cX
        wcel w3a cA ci cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN
        cfv c2 cexp co subcl cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS
        co cG co cN cfv c2 cexp co cU cnv wcel cA cX wcel cB cX wcel w3a ci cc
        wcel cA ci cB cS co cG co cN cfv c2 cexp co cr wcel axicn cA cB ci cP
        cS cU cG cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval2lem2
        mpan2 recnd cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cS co cM co
        cN cfv c2 cexp co cU cnv wcel cA cX wcel cB cX wcel w3a ci cc wcel cA
        ci cB cS co cM co cN cfv c2 cexp co cr wcel axicn cA cB ci cP cS cU cG
        cM cN cX ipfval.1 ipfval.2 ipfval.4 ipfval.6 ipfval.7 ipval3.3
        ipval2lem5 mpan2 recnd sylanc ci cc wcel cA ci cB cS co cG co cN cfv c2
        cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cc wcel ci cA ci
        cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co
        cmin co cmul co cc wcel axicn ci cA ci cB cS co cG co cN cfv c2 cexp co
        cA ci cB cS co cM co cN cfv c2 cexp co cmin co mulcl mpan syl sylanc cA
        cB cG co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA
        ci cB cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp
        co cmin co cmul co caddc co cc wcel c4 cc wcel c4 cc0 wne c4 cA cB cG
        co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB
        cS co cG co cN cfv c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co
        cmin co cmul co caddc co c4 cdiv co cmul co cA cB cG co cN cfv c2 cexp
        co cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv
        c2 cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cmul co caddc
        co wceq c4 4re recni c4 4re 4pos gt0ne0ii cA cB cG co cN cfv c2 cexp co
        cA cB cM co cN cfv c2 cexp co cmin co ci cA ci cB cS co cG co cN cfv c2
        cexp co cA ci cB cS co cM co cN cfv c2 cexp co cmin co cmul co caddc co
        c4 divcan2 mp3an23 syl eqtrd $.
        $( [24-Mar-2008] $) $( [1-Feb-2008] $)
    $}
  $}

  ${
    $d k n p w x y z G $.  $d k n p w x y z N $.  $d k n p w x y z S $.
    $d k n p w x y z U $.  $d k x y z A $.  $d k x y z B $.  $d x y z X $.
    ipid.1 $e |- X = ( BaseSet ` U ) $.
    ipid.6 $e |- N = ( norm ` U ) $.
    ipid.7 $e |- P = ( .i ` U ) $.
    $( The inner product of a vector with itself is the square of the vector's
       norm.  Equation I4 of [Ponnusamy] p. 362. $)
    ipid $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                ( A P A ) = ( ( N ` A ) ^ 2 ) ) $=
      cU cnv wcel cA cX wcel wa cA cA cP co cA cA cU cpv cfv co cN cfv c2 cexp
      co cA c1 cneg cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co ci
      cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA cU
      cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co cmul co caddc co c4
      cdiv co c4 cA cN cfv c2 cexp co cmul co c4 cdiv co cA cN cfv c2 cexp co
      cU cnv wcel cA cX wcel cA cA cP co cA cA cU cpv cfv co cN cfv c2 cexp co
      cA c1 cneg cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co ci cA
      ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA cU cns
      cfv co cU cpv cfv co cN cfv c2 cexp co cmin co cmul co caddc co c4 cdiv
      co wceq cA cA cP cU cns cfv cU cU cpv cfv cN cX ipid.1 cU cpv cfv eqid cU
      cns cfv eqid ipid.6 ipid.7 ipval2 3anidm23 cU cnv wcel cA cX wcel wa c4
      cA cN cfv c2 cexp co cmul co cA cA cU cpv cfv co cN cfv c2 cexp co cA c1
      cneg cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co ci cA ci cA
      cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA cU cns cfv co
      cU cpv cfv co cN cfv c2 cexp co cmin co cmul co caddc co c4 cdiv cU cnv
      wcel cA cX wcel wa cA cA cU cpv cfv co cN cfv c2 cexp co cA c1 cneg cA cU
      cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co ci cA ci cA cU cns cfv
      co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA cU cns cfv co cU cpv cfv
      co cN cfv c2 cexp co cmin co cmul co caddc co c4 cA cN cfv c2 cexp co
      cmul co cc0 caddc co c4 cA cN cfv c2 cexp co cmul co cU cnv wcel cA cX
      wcel wa cA cA cU cpv cfv co cN cfv c2 cexp co cA c1 cneg cA cU cns cfv co
      cU cpv cfv co cN cfv c2 cexp co cmin co c4 cA cN cfv c2 cexp co cmul co
      ci cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA
      cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co cmul co cc0 caddc
      cU cnv wcel cA cX wcel wa cA cA cU cpv cfv co cN cfv c2 cexp co cA c1
      cneg cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co c4 cA cN
      cfv c2 cexp co cmul co cc0 cmin co c4 cA cN cfv c2 cexp co cmul co cU cnv
      wcel cA cX wcel wa cA cA cU cpv cfv co cN cfv c2 cexp co c4 cA cN cfv c2
      cexp co cmul co cA c1 cneg cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp
      co cc0 cmin cU cnv wcel cA cX wcel wa cA cA cU cpv cfv co cN cfv c2 cexp
      co c2 cA cN cfv cmul co c2 cexp co c2 c2 cexp co cA cN cfv c2 cexp co
      cmul co c4 cA cN cfv c2 cexp co cmul co cU cnv wcel cA cX wcel wa cA cA
      cU cpv cfv co cN cfv c2 cA cN cfv cmul co c2 cexp cU cnv wcel cA cX wcel
      wa cA cA cU cpv cfv co cN cfv c2 cA cU cns cfv co cN cfv c2 cA cN cfv
      cmul co cU cnv wcel cA cX wcel wa cA cA cU cpv cfv co c2 cA cU cns cfv co
      cN cU c1st cfv cvc wcel cA cX wcel cA cA cU cpv cfv co c2 cA cU cns cfv
      co wceq cU cnv wcel cA cU cns cfv cU cpv cfv cU c1st cfv cX cU cU cpv cfv
      cU cpv cfv eqid vafval cU cns cfv cU cU cns cfv eqid smfval cU cU cpv cfv
      cX ipid.1 cU cpv cfv eqid bafval vc2 cU cU c1st cfv cU c1st cfv eqid nvvc
      sylan fveq2d cU cnv wcel c2 cr wcel cc0 c2 cle wbr wa cA cX wcel c2 cA cU
      cns cfv co cN cfv c2 cA cN cfv cmul co wceq c2 cr wcel cc0 c2 cle wbr c2
      2nn nnrei cc0 c2 0re 2re 2pos ltleii pm3.2i c2 cA cU cns cfv cU cN cX
      ipid.1 cU cns cfv eqid ipid.6 nvsge0 mp3an2 eqtrd opreq1d cU cnv wcel cA
      cX wcel wa cA cN cfv cc wcel c2 cA cN cfv cmul co c2 cexp co c2 c2 cexp
      co cA cN cfv c2 cexp co cmul co wceq cU cnv wcel cA cX wcel wa cA cN cfv
      cA cU cN cX ipid.1 ipid.6 nvcl recnd c2 cc wcel cA cN cfv cc wcel c2 cn0
      wcel c2 cA cN cfv cmul co c2 cexp co c2 c2 cexp co cA cN cfv c2 cexp co
      cmul co wceq 2cn 2nn0 c2 cA cN cfv c2 mulexp mp3an13 syl c2 c2 cexp co cA
      cN cfv c2 cexp co cmul co c4 cA cN cfv c2 cexp co cmul co wceq cU cnv
      wcel cA cX wcel wa c2 c2 cexp co c4 cA cN cfv c2 cexp co cmul sq2 opreq1i
      a1i 3eqtrd cU cnv wcel cA cX wcel wa cA c1 cneg cA cU cns cfv co cU cpv
      cfv co cN cfv c2 cexp co cc0 c2 cexp co cc0 cU cnv wcel cA cX wcel wa cA
      c1 cneg cA cU cns cfv co cU cpv cfv co cN cfv cc0 c2 cexp cU cnv wcel cA
      cX wcel wa cA c1 cneg cA cU cns cfv co cU cpv cfv co cN cfv cU cn0v cfv
      cN cfv cc0 cU cnv wcel cA cX wcel wa cA c1 cneg cA cU cns cfv co cU cpv
      cfv co cU cn0v cfv cN cA cU cns cfv cU cU cpv cfv cX cU cn0v cfv ipid.1
      cU cpv cfv eqid cU cns cfv eqid cU cn0v cfv eqid nvrinv fveq2d cU cnv
      wcel cU cn0v cfv cN cfv cc0 wceq cA cX wcel cU cN cU cn0v cfv cU cn0v cfv
      eqid ipid.6 nvz0 adantr eqtrd opreq1d sq0 syl6eq opreq12d cU cnv wcel cA
      cX wcel wa c4 cA cN cfv c2 cexp co cmul co cc wcel c4 cA cN cfv c2 cexp
      co cmul co cc0 cmin co c4 cA cN cfv c2 cexp co cmul co wceq cU cnv wcel
      cA cX wcel wa cA cN cfv c2 cexp co cc wcel c4 cA cN cfv c2 cexp co cmul
      co cc wcel cU cnv wcel cA cX wcel wa cA cN cfv cc wcel cA cN cfv c2 cexp
      co cc wcel cU cnv wcel cA cX wcel wa cA cN cfv cA cU cN cX ipid.1 ipid.6
      nvcl recnd cA cN cfv sqcl syl c4 cc wcel cA cN cfv c2 cexp co cc wcel c4
      cA cN cfv c2 cexp co cmul co cc wcel c4 4re recni c4 cA cN cfv c2 cexp co
      mulcl mpan syl c4 cA cN cfv c2 cexp co cmul co subid1 syl eqtrd cU cnv
      wcel cA cX wcel wa ci cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp
      co cA ci cneg cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cmin co
      cmul co ci cc0 cmul co cc0 cU cnv wcel cA cX wcel wa cA ci cA cU cns cfv
      co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA cU cns cfv co cU cpv cfv
      co cN cfv c2 cexp co cmin co cc0 ci cmul cU cnv wcel cA cX wcel wa cA ci
      cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cA ci cneg cA cU cns cfv
      co cU cpv cfv co cN cfv c2 cexp co cmin co cA ci cA cU cns cfv co cU cpv
      cfv co cN cfv c2 cexp co cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2
      cexp co cmin co cc0 cU cnv wcel cA cX wcel wa cA ci cneg cA cU cns cfv co
      cU cpv cfv co cN cfv c2 cexp co cA ci cA cU cns cfv co cU cpv cfv co cN
      cfv c2 cexp co cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co
      cmin cU cnv wcel cA cX wcel wa cA ci cneg cA cU cns cfv co cU cpv cfv co
      cN cfv cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp cU cnv wcel cA
      cX wcel wa c1 ci cneg caddc co cA cU cns cfv co cN cfv c1 ci caddc co cA
      cU cns cfv co cN cfv cA ci cneg cA cU cns cfv co cU cpv cfv co cN cfv cA
      ci cA cU cns cfv co cU cpv cfv co cN cfv cU cnv wcel cA cX wcel wa c1 ci
      cneg caddc co cabs cfv cA cN cfv cmul co c1 ci caddc co cabs cfv cA cN
      cfv cmul co c1 ci cneg caddc co cA cU cns cfv co cN cfv c1 ci caddc co cA
      cU cns cfv co cN cfv c1 ci cneg caddc co cabs cfv c1 ci caddc co cabs cfv
      cA cN cfv cmul c1 ci cneg caddc co cabs cfv c1 c2 cexp co c1 c2 cexp co
      caddc co csqr cfv c1 ci c1 cmul co caddc co cabs cfv c1 ci caddc co cabs
      cfv c1 ci c1 cneg cmul co caddc co cabs cfv c1 c2 cexp co c1 cneg c2 cexp
      co caddc co csqr cfv c1 ci cneg caddc co cabs cfv c1 c2 cexp co c1 c2
      cexp co caddc co csqr cfv c1 cr wcel c1 cneg cr wcel c1 ci c1 cneg cmul
      co caddc co cabs cfv c1 c2 cexp co c1 cneg c2 cexp co caddc co csqr cfv
      wceq 1re c1 1re renegcli c1 c1 cneg absreim mp2an c1 ci c1 cneg cmul co
      caddc co c1 ci cneg caddc co cabs ci c1 cneg cmul co ci cneg c1 caddc ci
      c1 cneg cmul co ci c1 cmul co cneg ci cneg ci c1 axicn ax1cn mulneg2i ci
      c1 cmul co ci ci axicn mulid1i negeqi eqtri opreq2i fveq2i c1 c2 cexp co
      c1 cneg c2 cexp co caddc co c1 c2 cexp co c1 c2 cexp co caddc co csqr c1
      cneg c2 cexp co c1 c2 cexp co c1 c2 cexp co caddc c1 cc wcel c1 cneg c2
      cexp co c1 c2 cexp co wceq ax1cn c1 sqneg ax-mp opreq2i fveq2i 3eqtr3i c1
      cr wcel c1 cr wcel c1 ci c1 cmul co caddc co cabs cfv c1 c2 cexp co c1 c2
      cexp co caddc co csqr cfv wceq 1re 1re c1 c1 absreim mp2an c1 ci c1 cmul
      co caddc co c1 ci caddc co cabs ci c1 cmul co ci c1 caddc ci axicn
      mulid1i opreq2i fveq2i 3eqtr2i opreq1i cU cnv wcel c1 ci cneg caddc co cc
      wcel cA cX wcel c1 ci cneg caddc co cA cU cns cfv co cN cfv c1 ci cneg
      caddc co cabs cfv cA cN cfv cmul co wceq c1 ci cneg ax1cn ci axicn negcli
      addcli c1 ci cneg caddc co cA cU cns cfv cU cN cX ipid.1 cU cns cfv eqid
      ipid.6 nvs mp3an2 cU cnv wcel c1 ci caddc co cc wcel cA cX wcel c1 ci
      caddc co cA cU cns cfv co cN cfv c1 ci caddc co cabs cfv cA cN cfv cmul
      co wceq c1 ci ax1cn axicn addcli c1 ci caddc co cA cU cns cfv cU cN cX
      ipid.1 cU cns cfv eqid ipid.6 nvs mp3an2 3eqtr4a cU cnv wcel cA cX wcel
      wa c1 ci cneg caddc co cA cU cns cfv co cA ci cneg cA cU cns cfv co cU
      cpv cfv co cN cU cnv wcel cA cX wcel wa c1 ci cneg caddc co cA cU cns cfv
      co c1 cA cU cns cfv co ci cneg cA cU cns cfv co cU cpv cfv co cA ci cneg
      cA cU cns cfv co cU cpv cfv co cU cnv wcel ci cneg cc wcel cA cX wcel c1
      ci cneg caddc co cA cU cns cfv co c1 cA cU cns cfv co ci cneg cA cU cns
      cfv co cU cpv cfv co wceq ci axicn negcli cU cnv wcel c1 cc wcel ci cneg
      cc wcel cA cX wcel c1 ci cneg caddc co cA cU cns cfv co c1 cA cU cns cfv
      co ci cneg cA cU cns cfv co cU cpv cfv co wceq ax1cn c1 ci cneg cA cU cns
      cfv cU cU cpv cfv cX ipid.1 cU cpv cfv eqid cU cns cfv eqid nvdir mp3anr1
      mpanr1 cU cnv wcel cA cX wcel wa c1 cA cU cns cfv co cA ci cneg cA cU cns
      cfv co cU cpv cfv cA cU cns cfv cU cX ipid.1 cU cns cfv eqid nvsid
      opreq1d eqtrd fveq2d cU cnv wcel cA cX wcel wa c1 ci caddc co cA cU cns
      cfv co cA ci cA cU cns cfv co cU cpv cfv co cN cU cnv wcel cA cX wcel wa
      c1 ci caddc co cA cU cns cfv co c1 cA cU cns cfv co ci cA cU cns cfv co
      cU cpv cfv co cA ci cA cU cns cfv co cU cpv cfv co cU cnv wcel ci cc wcel
      cA cX wcel c1 ci caddc co cA cU cns cfv co c1 cA cU cns cfv co ci cA cU
      cns cfv co cU cpv cfv co wceq axicn cU cnv wcel c1 cc wcel ci cc wcel cA
      cX wcel c1 ci caddc co cA cU cns cfv co c1 cA cU cns cfv co ci cA cU cns
      cfv co cU cpv cfv co wceq ax1cn c1 ci cA cU cns cfv cU cU cpv cfv cX
      ipid.1 cU cpv cfv eqid cU cns cfv eqid nvdir mp3anr1 mpanr1 cU cnv wcel
      cA cX wcel wa c1 cA cU cns cfv co cA ci cA cU cns cfv co cU cpv cfv cA cU
      cns cfv cU cX ipid.1 cU cns cfv eqid nvsid opreq1d eqtrd fveq2d 3eqtr3d
      opreq1d opreq2d cU cnv wcel cA cX wcel wa cA ci cA cU cns cfv co cU cpv
      cfv co cN cfv c2 cexp co cc wcel cA ci cA cU cns cfv co cU cpv cfv co cN
      cfv c2 cexp co cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co
      cmin co cc0 wceq cU cnv wcel cA cX wcel cA ci cA cU cns cfv co cU cpv cfv
      co cN cfv c2 cexp co cc wcel cU cnv wcel cA cX wcel cA cX wcel w3a ci cc
      wcel cA ci cA cU cns cfv co cU cpv cfv co cN cfv c2 cexp co cc wcel axicn
      cA cA ci cP cU cns cfv cU cU cpv cfv cN cX ipid.1 cU cpv cfv eqid cU cns
      cfv eqid ipid.6 ipid.7 ipval2lem4 mpan2 3anidm23 cA ci cA cU cns cfv co
      cU cpv cfv co cN cfv c2 cexp co subid syl eqtrd opreq2d ci axicn mul01i
      syl6eq opreq12d cU cnv wcel cA cX wcel wa c4 cA cN cfv c2 cexp co cmul co
      cc wcel c4 cA cN cfv c2 cexp co cmul co cc0 caddc co c4 cA cN cfv c2 cexp
      co cmul co wceq cU cnv wcel cA cX wcel wa cA cN cfv c2 cexp co cc wcel c4
      cA cN cfv c2 cexp co cmul co cc wcel cU cnv wcel cA cX wcel wa cA cN cfv
      cc wcel cA cN cfv c2 cexp co cc wcel cU cnv wcel cA cX wcel wa cA cN cfv
      cA cU cN cX ipid.1 ipid.6 nvcl recnd cA cN cfv sqcl syl c4 cc wcel cA cN
      cfv c2 cexp co cc wcel c4 cA cN cfv c2 cexp co cmul co cc wcel c4 4re
      recni c4 cA cN cfv c2 cexp co mulcl mpan syl c4 cA cN cfv c2 cexp co cmul
      co addid1 syl eqtr2d opreq1d cU cnv wcel cA cX wcel wa cA cN cfv c2 cexp
      co cc wcel c4 cA cN cfv c2 cexp co cmul co c4 cdiv co cA cN cfv c2 cexp
      co wceq cU cnv wcel cA cX wcel wa cA cN cfv cc wcel cA cN cfv c2 cexp co
      cc wcel cU cnv wcel cA cX wcel wa cA cN cfv cA cU cN cX ipid.1 ipid.6
      nvcl recnd cA cN cfv sqcl syl cA cN cfv c2 cexp co cc wcel c4 cc wcel c4
      cc0 wne c4 cA cN cfv c2 cexp co cmul co c4 cdiv co cA cN cfv c2 cexp co
      wceq c4 4re recni c4 4re 4pos gt0ne0ii cA cN cfv c2 cexp co c4 divcan3
      mp3an23 syl 3eqtr2d $.
      $( [27-Nov-2007] $) $( [1-Feb-2007] $)

    $( Norm expressed in terms of inner product. $)
    ipnm $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                ( N ` A ) = ( sqr ` ( A P A ) ) ) $=
      cU cnv wcel cA cX wcel wa cA cA cP co csqr cfv cA cN cfv c2 cexp co csqr
      cfv cA cN cfv cU cnv wcel cA cX wcel wa cA cA cP co cA cN cfv c2 cexp co
      csqr cA cP cU cN cX ipid.1 ipid.6 ipid.7 ipid fveq2d cA cN cfv cr wcel
      cc0 cA cN cfv cle wbr cA cN cfv c2 cexp co csqr cfv cA cN cfv wceq cU cnv
      wcel cA cX wcel wa cA cN cfv sqrsq cA cU cN cX ipid.1 ipid.6 nvcl cA cU
      cN cX ipid.1 ipid.6 nvge0 sylanc eqtr2d $.
      $( [2-Dec-2007] $) $( [11-Sep-2007] $)
  $}

  ${
    $d k A $.  $d k B $.  $d k G $.  $d k x y z U $.  $d k W $.
    $d x y z k X $.
    ipcl.1 $e |- X = ( BaseSet ` U ) $.
    ipcl.7 $e |- P = ( .i ` U ) $.
    $( An inner product is a complex number. $)
    ipcl $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A P B ) e. CC ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co c1 c4 cfz co ci vk cv
      cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmul co vk csu c4 cdiv co cc cA cB cP cU cns cfv cU vk cU cpv
      cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid
      ipcl.7 ipval cU cnv wcel cA cX wcel cB cX wcel w3a ci vk cv cexp co cA ci
      vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmul co cc wcel vk c1 c4 cfz co wral c1 c4 cfz co ci vk cv cexp co cA ci
      vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmul co vk csu cc wcel c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu
      c4 cdiv co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a ci vk cv cexp co
      cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmul co cc wcel vk c1 c4 cfz co ci vk cv cexp co cc wcel cA ci vk cv
      cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel
      ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmul co cc wcel cU cnv wcel cA cX wcel cB cX wcel
      w3a vk cv c1 c4 cfz co wcel wa ci vk cv cexp co cA ci vk cv cexp co cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co mulcl vk cv c1 c4 cfz
      co wcel ci vk cv cexp co cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a vk
      cv c1 c4 cfz co wcel vk cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc
      wcel vk cv c4 elfznn vk cv nnnn0 ci cc wcel vk cv cn0 wcel ci vk cv cexp
      co cc wcel axicn ci vk cv expcl mpan 3syl adantl cU cnv wcel cA cX wcel
      cB cX wcel w3a ci vk cv cexp co cc wcel cA ci vk cv cexp co cB cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel vk cv c1 c4 cfz co
      wcel cA cB ci vk cv cexp co cP cU cns cfv cU cU cpv cfv cU cnm cfv cX
      ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem4
      vk cv c1 c4 cfz co wcel vk cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc
      wcel vk cv c4 elfznn vk cv nnnn0 ci cc wcel vk cv cn0 wcel ci vk cv cexp
      co cc wcel axicn ci vk cv expcl mpan 3syl sylan2 sylanc r19.21aiva c4 c1
      cuz cfv wcel ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmul co cc wcel vk c1 c4 cfz co wral c1
      c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu cc wcel c4 c1 cuz cfv
      wcel c4 cz wcel c1 c4 cle wbr c1 c4 1z eluz1i c4 cn wcel c4 cz wcel 4nn
      c4 nnz ax-mp c1 c4 cle wbr c1 c1 cmin co c4 clt wbr c1 c1 cmin co cc0 c4
      clt c1 ax1cn subidi 4pos eqbrtri c1 cn wcel c4 cn wcel c1 c4 cle wbr c1
      c1 cmin co c4 clt wbr wb 1nn 4nn c1 c4 nnlem1lt mp2an mpbir mpbir2an ci
      vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmul co vk c1 c4 fsumcl mpan c1 c4 cfz co ci vk cv
      cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmul co vk csu cc wcel c4 cc wcel c4 cc0 wne c1 c4 cfz co ci
      vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmul co vk csu c4 cdiv co cc wcel c4 4re recni c4 4re
      4pos gt0ne0ii c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 divcl
      mp3an23 3syl eqeltrd $.
      $( [6-Oct-2007] $) $( [1-Feb-2007] $)

    $( Mapping for the inner product operation. $)
    ipf $p |- ( U e. NrmCVec -> P : ( X X. X ) --> CC ) $=
      cU cnv wcel cX cX cxp cc cP wf cX cX cxp cc vx cv cX wcel vy cv cX wcel
      wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv
      co wceq wa vx vy vz copab2 wf cU cnv wcel c1 c4 cfz co ci vk cv cexp co
      vx cv ci vk cv cexp co vy cv cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmul co vk csu c4 cdiv co cc wcel vy cX wral vx cX wral cX cX
      cxp cc vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci vk cv cexp co
      vx cv ci vk cv cexp co vy cv cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2 wf cU cnv
      wcel c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv co
      cc wcel vx vy cX cX cU cnv wcel vx cv cX wcel vy cv cX wcel c1 c4 cfz co
      ci vk cv cexp co vx cv ci vk cv cexp co vy cv cU cns cfv co cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv co cc wcel cU cnv wcel
      vx cv cX wcel vy cv cX wcel w3a vx cv vy cv cP co c1 c4 cfz co ci vk cv
      cexp co vx cv ci vk cv cexp co vy cv cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmul co vk csu c4 cdiv co cc vx cv vy cv cP cU cns cfv
      cU vk cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU
      cnm cfv eqid ipcl.7 ipval vx cv vy cv cP cU cX ipcl.1 ipcl.7 ipcl
      eqeltrrd 3expib r19.21aivv vx vy vz cX cX c1 c4 cfz co ci vk cv cexp co
      vx cv ci vk cv cexp co vy cv cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmul co vk csu c4 cdiv co cc vx cv cX wcel vy cv cX wcel wa vz
      cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv co wceq
      wa vx vy vz copab2 vx cv cX wcel vy cv cX wcel wa vz cv c1 c4 cfz co ci
      vk cv cexp co vx cv ci vk cv cexp co vy cv cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vx vy vz copab2
      eqid foprab2 sylib cU cnv wcel cX cX cxp cc cP vx cv cX wcel vy cv cX
      wcel wa vz cv c1 c4 cfz co ci vk cv cexp co vx cv ci vk cv cexp co vy cv
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4
      cdiv co wceq wa vx vy vz copab2 vx vy vz cP cU cns cfv cU vk cU cpv cfv
      cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid
      ipcl.7 ipfval feq1d mpbird $.
      $( [31-Jan-2008] $) $( [28-Jan-2008] $)

    $( The complex conjugate of an inner product reverses its arguments.
       Equation I1 of [Ponnusamy] p. 362. $)
    ipcj $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( * ` ( A P B ) ) = ( B P A ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co cmul co caddc co c4 cdiv co ccj cfv cB cA cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cB c1 cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co ci cB ci cA cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cB ci cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmin co cmul co caddc co c4 cdiv co cA cB cP co ccj cfv cB cA
      cP co cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmin co cmul co caddc co c4 cdiv co ccj cfv cA cB cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmin co cmul co caddc co ccj cfv c4 ccj cfv cdiv co cB
      cA cU cpv cfv co cU cnm cfv cfv c2 cexp co cB c1 cneg cA cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cB ci cA cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cB ci cneg cA cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co cmul co caddc co cc wcel cA cB cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co cmul co caddc co c4 cdiv co ccj cfv cA cB cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmin co cmul co caddc co ccj cfv c4 ccj cfv cdiv co wceq cA cB
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc wcel ci cA ci cB cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co cc wcel cA cB
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co cc wcel cU cnv
      wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin
      co cmul co addcl cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel cA
      c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel
      cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc wcel cU cnv wcel cA cX
      wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1
      cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co subcl cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA cB cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv
      eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem3 recnd cU cnv wcel
      cA cX wcel cB cX wcel w3a c1 cneg cc wcel cA c1 cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel c1 ax1cn negcli cA cB c1
      cneg cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU
      cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem4 mpan2 sylanc cU cnv wcel
      cA cX wcel cB cX wcel w3a cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmin co cc wcel ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co cmul co cc wcel cA ci cB cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cc wcel cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cc wcel cA ci cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cmin co cc wcel cU cnv wcel cA cX wcel cB cX
      wcel w3a cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co subcl
      cU cnv wcel cA cX wcel cB cX wcel w3a ci cc wcel cA ci cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel axicn cA cB ci cP cU cns
      cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU
      cnm cfv eqid ipcl.7 ipval2lem4 mpan2 cU cnv wcel cA cX wcel cB cX wcel
      w3a ci cneg cc wcel cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cc wcel ci axicn negcli cA cB ci cneg cP cU cns cfv cU cU
      cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv
      eqid ipcl.7 ipval2lem4 mpan2 sylanc ci cc wcel cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cc wcel ci cA ci cB cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co cc wcel axicn ci cA
      ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co mulcl mpan
      syl sylanc cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co
      cc wcel c4 cc wcel c4 cc0 wne cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin
      co cmul co caddc co c4 cdiv co ccj cfv cA cB cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co cmul co caddc co ccj cfv c4 ccj cfv cdiv co wceq c4 4re recni
      c4 4re 4pos gt0ne0ii cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1
      cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci
      cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co
      caddc co c4 cjdiv mp3an23 syl cU cnv wcel cA cX wcel cB cX wcel w3a cA cB
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co ccj cfv c4 cdiv
      co cB cA cU cpv cfv co cU cnm cfv cfv c2 cexp co cB c1 cneg cA cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cB ci cA cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cB ci cneg cA cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co
      cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co ccj cfv c4
      ccj cfv cdiv co cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmin co cmul co caddc co ccj cfv cB cA cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cB c1 cneg cA cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmin co ci cB ci cA cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cB ci cneg cA cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmin co cmul co caddc co c4 cdiv cU cnv wcel cA cX
      wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1
      cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci
      cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co
      caddc co ccj cfv cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co cmin
      co cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cneg cmul co caddc co cB cA
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cB c1 cneg cA cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cB ci cA cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cB ci cneg cA cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co cA cB cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cmin co cr wcel cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cr wcel cA cB cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co cmul co caddc co ccj cfv cA cB cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co cmul co cmin co wceq cU cnv wcel cA cX wcel cB cX
      wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cA ci cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cjreim cA cB cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cr wcel cA c1 cneg cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cr wcel cA cB cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cmin co cr wcel cU cnv wcel cA cX wcel cB cX wcel w3a
      cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co resubcl cA cB cP cU cns cfv cU cU
      cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv
      eqid ipcl.7 ipval2lem3 cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cc
      wcel cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cr wcel c1 ax1cn negcli cA cB c1 cneg cP cU cns cfv cU cU cpv cfv cU cnm
      cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7
      ipval2lem2 mpan2 sylanc cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cr wcel cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cr wcel cA ci cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co cr wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA
      ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co resubcl cU cnv wcel
      cA cX wcel cB cX wcel w3a ci cc wcel cA ci cB cU cns cfv co cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cr wcel axicn cA cB ci cP cU cns cfv cU cU cpv
      cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid
      ipcl.7 ipval2lem2 mpan2 cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cc
      wcel cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cr wcel ci axicn negcli cA cB ci cneg cP cU cns cfv cU cU cpv cfv cU cnm
      cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7
      ipval2lem2 mpan2 sylanc sylanc cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co cc wcel cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co cc wcel cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1
      cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci
      cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co
      cmin co cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cneg cmul co caddc
      co wceq cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co cc wcel ci cc wcel cA ci cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cmin co cc wcel cA cB cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmin co cmul co cmin co cA cB cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co cneg cmul co caddc co wceq axicn cA cB cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co submul2 mp3an2 cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cc wcel cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cc wcel cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc wcel
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co subcl cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cA cB cP cU cns cfv cU cU cpv cfv cU cnm cfv cX
      ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem3
      recnd cU cnv wcel cA cX wcel cB cX wcel w3a c1 cneg cc wcel cA c1 cneg cB
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel c1 ax1cn
      negcli cA cB c1 cneg cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU
      cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem4 mpan2
      sylanc cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc
      wcel cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cc wcel cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA
      ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co
      cc wcel cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co subcl cU cnv wcel cA cX wcel cB cX wcel
      w3a ci cc wcel cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cc wcel axicn cA cB ci cP cU cns cfv cU cU cpv cfv cU cnm cfv cX
      ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem4
      mpan2 cU cnv wcel cA cX wcel cB cX wcel w3a ci cneg cc wcel cA ci cneg cB
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel ci axicn
      negcli cA cB ci cneg cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU
      cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem4 mpan2
      sylanc sylanc cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmin co cB cA cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cB c1 cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co ci cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin
      co cneg cmul co ci cB ci cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cB ci cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co cmul co caddc cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cB cA cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cB c1 cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cU cpv cfv co cU cnm
      cfv cfv cB cA cU cpv cfv co cU cnm cfv cfv c2 cexp cU cnv wcel cA cX wcel
      cB cX wcel w3a cA cB cU cpv cfv co cB cA cU cpv cfv co cU cnm cfv cA cB
      cU cU cpv cfv cX ipcl.1 cU cpv cfv eqid nvcom fveq2d opreq1d cU cnv wcel
      cA cX wcel cB cX wcel w3a cA c1 cneg cB cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv cB c1 cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp cA cB cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid
      cU cns cfv eqid cU cnm cfv eqid nvdif opreq1d opreq12d cU cnv wcel cA cX
      wcel cB cX wcel w3a cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co cneg cB ci cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cB ci cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co ci cmul cU cnv wcel cA cX wcel cB cX wcel w3a cA ci cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cneg cA ci cneg cB
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cB cU cns cfv
      co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cB ci cA cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cB ci cneg cA cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel cA ci cneg cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cneg cA ci cneg cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cB cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cmin co wceq cU cnv wcel cA cX wcel cB cX
      wcel w3a cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      negsubdi2 cU cnv wcel cA cX wcel cB cX wcel w3a ci cc wcel cA ci cB cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel axicn cA cB ci
      cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns
      cfv eqid cU cnm cfv eqid ipcl.7 ipval2lem4 mpan2 cU cnv wcel cA cX wcel
      cB cX wcel w3a ci cneg cc wcel cA ci cneg cB cU cns cfv co cU cpv cfv co
      cU cnm cfv cfv c2 cexp co cc wcel ci axicn negcli cA cB ci cneg cP cU cns
      cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU
      cnm cfv eqid ipcl.7 ipval2lem4 mpan2 sylanc cU cnv wcel cA cX wcel cB cX
      wcel w3a cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cB ci cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cB ci cneg cA cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin cU cnv wcel cA cX
      wcel cB cX wcel w3a cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv cB ci cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp cU cnv
      wcel cA cX wcel cB cX wcel w3a cB ci cA cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv cU
      cnv wcel cB cX wcel cA cX wcel cB ci cA cU cns cfv co cU cpv cfv co cU
      cnm cfv cfv cA ci cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv wceq
      cB cA cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU
      cns cfv eqid cU cnm cfv eqid nvpi 3com23 eqcomd opreq1d cU cnv wcel cA cX
      wcel cB cX wcel w3a cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      cB ci cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp cA cB cU
      cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv
      eqid cU cnm cfv eqid nvpi opreq1d opreq12d eqtrd opreq2d opreq12d 3eqtrd
      opreq1d c4 ccj cfv c4 cA cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1
      cneg cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci
      cA ci cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co
      caddc co ccj cfv cdiv c4 cr wcel c4 ccj cfv c4 wceq 4re c4 cjre ax-mp
      opreq2i syl5eq eqtrd cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cA
      cB cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cB cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co ccj
      cA cB cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ipcl.1 cU cpv cfv eqid cU
      cns cfv eqid cU cnm cfv eqid ipcl.7 ipval2 fveq2d cU cnv wcel cB cX wcel
      cA cX wcel cB cA cP co cB cA cU cpv cfv co cU cnm cfv cfv c2 cexp co cB
      c1 cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co
      ci cB ci cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cB ci
      cneg cA cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co
      cmul co caddc co c4 cdiv co wceq cB cA cP cU cns cfv cU cU cpv cfv cU cnm
      cfv cX ipcl.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ipcl.7
      ipval2 3com23 3eqtr4d $.
      $( [30-Oct-2007] $) $( [1-Feb-2007] $)

    $( An inner product times its conjugate. $)
    ipipcj $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( ( A P B ) x. ( B P A ) ) = ( ( abs ` ( A P B ) ) ^ 2 ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cabs cfv c2 cexp co cA
      cB cP co cA cB cP co ccj cfv cmul co cA cB cP co cB cA cP co cmul co cU
      cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cc wcel cA cB cP co cabs
      cfv c2 cexp co cA cB cP co cA cB cP co ccj cfv cmul co wceq cA cB cP cU
      cX ipcl.1 ipcl.7 ipcl cA cB cP co absvalsq syl cU cnv wcel cA cX wcel cB
      cX wcel w3a cA cB cP co ccj cfv cB cA cP co cA cB cP co cmul cA cB cP cU
      cX ipcl.1 ipcl.7 ipcj opreq2d eqtr2d $.
      $( [28-Dec-2007] $) $( [23-Nov-2007] $)

    $( Orthogonality (meaning inner product is 0) is commutative. $)
    iporthcom $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X )
              -> ( ( A P B ) = 0 <-> ( B P A ) = 0 ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co cc0 wceq cB cA cP co
      cc0 wceq cU cnv wcel cA cX wcel cB cX wcel w3a cA cB cP co ccj cfv cc0
      wceq cB cA cP co cc0 wceq cA cB cP co cc0 wceq cU cnv wcel cA cX wcel cB
      cX wcel w3a cA cB cP co ccj cfv cB cA cP co cc0 cA cB cP cU cX ipcl.1
      ipcl.7 ipcj eqeq1d cA cB cP co cc0 wceq cA cB cP co ccj cfv cc0 ccj cfv
      cc0 cA cB cP co cc0 ccj fveq2 cj0 syl6eq syl5bi cU cnv wcel cA cX wcel cB
      cX wcel w3a cB cA cP co ccj cfv cc0 wceq cA cB cP co cc0 wceq cB cA cP co
      cc0 wceq cU cnv wcel cA cX wcel cB cX wcel w3a cB cA cP co ccj cfv cA cB
      cP co cc0 cU cnv wcel cB cX wcel cA cX wcel cB cA cP co ccj cfv cA cB cP
      co wceq cB cA cP cU cX ipcl.1 ipcl.7 ipcj 3com23 eqeq1d cB cA cP co cc0
      wceq cB cA cP co ccj cfv cc0 ccj cfv cc0 cB cA cP co cc0 ccj fveq2 cj0
      syl6eq syl5bi impbid $.
      $( [17-Apr-2008] $) $( [17-Apr-2008] $)
  $}

  ${
    ip0r.1 $e |- X = ( BaseSet ` U ) $.
    ip0r.5 $e |- Z = ( 0v ` U ) $.
    ip0r.7 $e |- P = ( .i ` U ) $.
    $( Inner product with a zero second argument. $)
    ip0r $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A P Z ) = 0 ) $=
      cU cnv wcel cA cX wcel wa cA cZ cP co cA cZ cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA c1 cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co ci cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA ci cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co cmul co caddc co c4 cdiv co cc0 cU cnv wcel cA cX wcel cZ cX
      wcel cA cZ cP co cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg
      cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci
      cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cZ cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc
      co c4 cdiv co wceq cU cnv wcel cZ cX wcel cA cX wcel cU cX cZ ip0r.1
      ip0r.5 nvzcl adantr cA cZ cP cU cns cfv cU cU cpv cfv cU cnm cfv cX
      ip0r.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ip0r.7 ipval2
      mpd3an3 cU cnv wcel cA cX wcel wa cA cZ cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA c1 cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co ci cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA ci cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin co cmul co caddc co c4 cdiv co cc0 c4 cdiv co cc0 cU cnv wcel cA cX
      wcel wa cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cZ cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co ci cA ci cZ cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cZ cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co caddc co
      cc0 c4 cdiv cU cnv wcel cA cX wcel wa cA cZ cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cA c1 cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cmin co ci cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA ci cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cmin co cmul co caddc co cc0 ci cc0 cmul co caddc co cc0 cU cnv wcel
      cA cX wcel wa cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cA c1 cneg cZ
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc0 ci cA
      ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cZ
      cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cmul co ci
      cc0 cmul co caddc cU cnv wcel cA cX wcel wa cA cZ cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cA c1 cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cmin co cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cA
      cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc0 cU cnv wcel cA cX
      wcel wa cA c1 cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp
      co cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cA cZ cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cmin cU cnv wcel cA cX wcel wa cA c1 cneg cZ cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv cA cZ cU cpv cfv co cU cnm cfv
      cfv c2 cexp cU cnv wcel cA cX wcel wa cA c1 cneg cZ cU cns cfv co cU cpv
      cfv co cA cZ cU cpv cfv co cU cnm cfv cU cnv wcel cA cX wcel wa c1 cneg
      cZ cU cns cfv co cZ cA cU cpv cfv cU cnv wcel c1 cneg cZ cU cns cfv co cZ
      wceq cA cX wcel cU cnv wcel c1 cneg cc wcel c1 cneg cZ cU cns cfv co cZ
      wceq c1 ax1cn negcli c1 cneg cU cns cfv cU cZ cU cns cfv eqid ip0r.5 nvsz
      mpan2 adantr opreq2d fveq2d opreq1d opreq2d cU cnv wcel cA cX wcel wa cA
      cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel cA cZ cU cpv cfv co cU
      cnm cfv cfv c2 cexp co cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin
      co cc0 wceq cU cnv wcel cA cX wcel wa cA cZ cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cU cnv wcel cA cX wcel cZ cX wcel cA cZ cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cr wcel cU cnv wcel cZ cX wcel cA cX wcel cU cX cZ
      ip0r.1 ip0r.5 nvzcl adantr cA cZ cP cU cns cfv cU cU cpv cfv cU cnm cfv
      cX ip0r.1 cU cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ip0r.7
      ipval2lem3 mpd3an3 recnd cA cZ cU cpv cfv co cU cnm cfv cfv c2 cexp co
      subid syl eqtrd cU cnv wcel cA cX wcel wa cA ci cZ cU cns cfv co cU cpv
      cfv co cU cnm cfv cfv c2 cexp co cA ci cneg cZ cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cmin co cc0 ci cmul cU cnv wcel cA cX wcel
      wa cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci
      cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cA
      ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cZ cU
      cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc0 cU cnv
      wcel cA cX wcel wa cA ci cneg cZ cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv c2 cexp co cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp co cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmin cU cnv wcel cA cX wcel wa cA ci cneg cZ cU cns cfv co cU cpv cfv co
      cU cnm cfv cfv cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2
      cexp cU cnv wcel cA cX wcel wa cA ci cneg cZ cU cns cfv co cU cpv cfv co
      cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cU cnv wcel cA cX wcel wa
      ci cneg cZ cU cns cfv co ci cZ cU cns cfv co cA cU cpv cfv cU cnv wcel ci
      cneg cZ cU cns cfv co ci cZ cU cns cfv co wceq cA cX wcel cU cnv wcel ci
      cneg cZ cU cns cfv co cZ ci cZ cU cns cfv co cU cnv wcel ci cneg cc wcel
      ci cneg cZ cU cns cfv co cZ wceq ci axicn negcli ci cneg cU cns cfv cU cZ
      cU cns cfv eqid ip0r.5 nvsz mpan2 cU cnv wcel ci cc wcel ci cZ cU cns cfv
      co cZ wceq axicn ci cU cns cfv cU cZ cU cns cfv eqid ip0r.5 nvsz mpan2
      eqtr4d adantr opreq2d fveq2d opreq1d opreq2d cU cnv wcel cA cX wcel wa cA
      ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc wcel cA ci
      cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cA ci cZ cU cns
      cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cmin co cc0 wceq cU cnv
      wcel cA cX wcel cZ cX wcel cA ci cZ cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp co cc wcel cU cnv wcel cZ cX wcel cA cX wcel cU cX cZ
      ip0r.1 ip0r.5 nvzcl adantr cU cnv wcel cA cX wcel cZ cX wcel w3a ci cc
      wcel cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co cc
      wcel axicn cA cZ ci cP cU cns cfv cU cU cpv cfv cU cnm cfv cX ip0r.1 cU
      cpv cfv eqid cU cns cfv eqid cU cnm cfv eqid ip0r.7 ipval2lem4 mpan2
      mpd3an3 cA ci cZ cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      subid syl eqtrd opreq2d opreq12d cc0 ci cc0 cmul co caddc co cc0 cc0
      caddc co cc0 ci cc0 cmul co cc0 cc0 caddc ci axicn mul01i opreq2i cc0 0cn
      addid1i eqtri syl6eq opreq1d c4 c4 4re recni c4 4re 4pos gt0ne0ii div0i
      syl6eq eqtrd $.
      $( [1-Nov-2007] $) $( [5-Feb-2007] $)

    $( Inner product with a zero first argument.  Part of proof of Theorem 6.44
       of [Ponnusamy] p. 361. $)
    ip0l $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( Z P A ) = 0 ) $=
      cU cnv wcel cA cX wcel wa cA cZ cP co ccj cfv cZ cA cP co cc0 cU cnv wcel
      cA cX wcel cZ cX wcel cA cZ cP co ccj cfv cZ cA cP co wceq cU cnv wcel cZ
      cX wcel cA cX wcel cU cX cZ ip0r.1 ip0r.5 nvzcl adantr cA cZ cP cU cX
      ip0r.1 ip0r.7 ipcj mpd3an3 cU cnv wcel cA cX wcel wa cA cZ cP co ccj cfv
      cc0 ccj cfv cc0 cU cnv wcel cA cX wcel wa cA cZ cP co cc0 ccj cA cP cU cX
      cZ ip0r.1 ip0r.5 ip0r.7 ip0r fveq2d cj0 syl6eq eqtr3d $.
      $( [2-Nov-2007] $) $( [5-Feb-2007] $)

    $( The inner product of a vector with itself is zero iff the vector is
       zero.  Part of Definition 3.1-1 of [Kreyszig] p. 129. $)
    ipz $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( ( A P A ) = 0 <-> A = Z ) ) $=
      cU cnv wcel cA cX wcel wa cA cA cP co cc0 wceq cA cU cnm cfv cfv c2 cexp
      co cc0 wceq cA cU cnm cfv cfv cc0 wceq cA cZ wceq cU cnv wcel cA cX wcel
      wa cA cA cP co cA cU cnm cfv cfv c2 cexp co cc0 cA cP cU cU cnm cfv cX
      ip0r.1 cU cnm cfv eqid ip0r.7 ipid eqeq1d cU cnv wcel cA cX wcel wa cA cU
      cnm cfv cfv cc wcel cA cU cnm cfv cfv c2 cexp co cc0 wceq cA cU cnm cfv
      cfv cc0 wceq wb cU cnv wcel cA cX wcel wa cA cU cnm cfv cfv cA cU cU cnm
      cfv cX ip0r.1 cU cnm cfv eqid nvcl recnd cA cU cnm cfv cfv sqeq0 syl cA
      cU cU cnm cfv cX cZ ip0r.1 ip0r.5 cU cnm cfv eqid nvz 3bitrd $.
      $( [4-Feb-2008] $) $( [24-Jan-2008] $)
  $}

  ${
    $d a b c d f k t u v w A $.  $d a u w C $.  $d a c d f u w D $.
    $d a b c d f k t u v w G $.  $d v w H $.  $d a k u w J $.  $d a k u w K $.
    $d a b c d f k t u v w N $.  $d a b c d f k t u v w S $.
    $d a b k t u v w U $.  $d a b c d f k t u v w X $.
    ip1cni.1 $e |- X = ( BaseSet ` U ) $.
    ip1cni.2 $e |- G = ( +v ` U ) $.
    ip1cni.7 $e |- P = ( .i ` U ) $.
    ip1cni.8 $e |- C = ( IndMet ` U ) $.
    ip1cni.d $e |- D = ( abs o. - ) $.
    ip1cni.j $e |- J = ( Open ` C ) $.
    ip1cni.k $e |- K = ( Open ` D ) $.
    ip1cni.f $e |- F = { <. w , v >. | ( w e. X /\ v = ( w P A ) ) } $.
    ip1cni.9 $e |- U e. NrmCVec $.
    ip1cni.a $e |- A e. X $.
    ${
      ip1cnilem.4 $e |- S = ( .s ` U ) $.
      ip1cnilem.6 $e |- N = ( norm ` U ) $.
      ${
        ip1cnilem.12 $e |- H = { <. u , t >. | ( u e. X /\ t =
          ( u G ( ( _i ^ k ) S A ) ) ) } $.
        $( Lemma for ~ ip1cni . $)
        ip1cnilem1 $p |- ( k e. NN -> H e. ( J Cn J ) ) $=
          vk cv cn wcel ci vk cv cexp co cc wcel ci vk cv cexp co cA cS co cX
          wcel cH cJ cJ ccn co wcel vk cv cn wcel vk cv cn0 wcel ci vk cv cexp
          co cc wcel vk cv nnnn0 ci cc wcel vk cv cn0 wcel ci vk cv cexp co cc
          wcel axicn ci vk cv expcl mpan syl cU cnv wcel ci vk cv cexp co cc
          wcel cA cX wcel ci vk cv cexp co cA cS co cX wcel ip1cni.9 ip1cni.a
          ci vk cv cexp co cA cS cU cX ip1cni.1 ip1cnilem.4 nvscl mp3an13 vu vt
          ci vk cv cexp co cA cS co cC cU cH cG cJ cX ip1cni.1 ip1cni.2
          ip1cni.8 ip1cni.j ip1cnilem.12 ip1cni.9 va1cn 3syl $.
          $( [2-Dec-2007] $) $( [13-Aug-2007] $)
      $}

      ${
        ip1cnilem.13 $e |- H = { <. u , t >. | ( u e. X /\ t =
          ( N ` ( u G ( ( _i ^ k ) S A ) ) ) ) } $.
        $( Lemma for ~ ip1cni . $)
        ip1cnilem2 $p |- ( k e. NN -> H e. ( J Cn K ) ) $=
          vk cv cn wcel cN vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co
          cG co wceq wa vu vt copab ccom cH cJ cK ccn co vk cv cn wcel vu cv cX
          wcel vt cv vu cv ci vk cv cexp co cA cS co cG co wceq wa vu vt copab
          crn cX wss cN vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG
          co wceq wa vu vt copab ccom cH wceq vk cv cn wcel vu cv ci vk cv cexp
          co cA cS co cG co cX wcel vu cX wral vu cv cX wcel vt cv vu cv ci vk
          cv cexp co cA cS co cG co wceq wa vu vt copab crn cX wss vk cv cn
          wcel vu cv ci vk cv cexp co cA cS co cG co cX wcel vu cX vu cv cX
          wcel vk cv cn wcel vu cv ci vk cv cexp co cA cS co cG co cX wcel vu
          cv cX wcel ci vk cv cexp co cA cS co cX wcel vu cv ci vk cv cexp co
          cA cS co cG co cX wcel vk cv cn wcel cU cnv wcel vu cv cX wcel ci vk
          cv cexp co cA cS co cX wcel vu cv ci vk cv cexp co cA cS co cG co cX
          wcel ip1cni.9 vu cv ci vk cv cexp co cA cS co cU cG cX ip1cni.1
          ip1cni.2 nvgcl mp3an1 vk cv cn wcel vk cv cn0 wcel ci vk cv cexp co
          cc wcel ci vk cv cexp co cA cS co cX wcel vk cv nnnn0 ci cc wcel vk
          cv cn0 wcel ci vk cv cexp co cc wcel axicn ci vk cv expcl mpan cU cnv
          wcel ci vk cv cexp co cc wcel cA cX wcel ci vk cv cexp co cA cS co cX
          wcel ip1cni.9 ip1cni.a ci vk cv cexp co cA cS cU cX ip1cni.1
          ip1cnilem.4 nvscl mp3an13 3syl sylan2 ancoms r19.21aiva vu vt cX cX
          vu cv ci vk cv cexp co cA cS co cG co vu cv cX wcel vt cv vu cv ci vk
          cv cexp co cA cS co cG co wceq wa vu vt copab vu cv cX wcel vt cv vu
          cv ci vk cv cexp co cA cS co cG co wceq wa vu vt copab eqid vu cv ci
          vk cv cexp co cA cS co cG oprex rnssopab sylib vu vt va vb vt cX cX
          vu cv ci vk cv cexp co cA cS co cG co va cv cN cfv vu cv ci vk cv
          cexp co cA cS co cG co cN cfv vu cv cX wcel vt cv vu cv ci vk cv cexp
          co cA cS co cG co wceq wa vu vt copab cN cH vu cv ci vk cv cexp co cA
          cS co cG oprex va cv cN fvex vu cv ci vk cv cexp co cA cS co cG co cN
          fvex va cv vu cv ci vk cv cexp co cA cS co cG co cN fveq2 vu cv cX
          wcel vt cv vu cv ci vk cv cexp co cA cS co cG co wceq wa vu vt copab
          eqid cN cX wfn cN va cv cX wcel vb cv va cv cN cfv wceq wa va vb
          copab wceq cX cr cN wf cN cX wfn cU cnv wcel cX cr cN wf ip1cni.9 cU
          cN cX ip1cni.1 ip1cnilem.6 nvf ax-mp cX cr cN ffn ax-mp va vb cX cN
          dffn5 mpbi ip1cnilem.13 fopabco syl vk cv cn wcel vu cv cX wcel vt cv
          vu cv ci vk cv cexp co cA cS co cG co wceq wa vu vt copab cJ cJ ccn
          co wcel cN vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co
          wceq wa vu vt copab ccom cJ cK ccn co wcel vw vv vu vt cA cC cD cP cS
          cU vk cF cG vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co
          wceq wa vu vt copab cJ cK cN cX ip1cni.1 ip1cni.2 ip1cni.7 ip1cni.8
          ip1cni.d ip1cni.j ip1cni.k ip1cni.f ip1cni.9 ip1cni.a ip1cnilem.4
          ip1cnilem.6 vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co
          wceq wa vu vt copab eqid ip1cnilem1 vu cv cX wcel vt cv vu cv ci vk
          cv cexp co cA cS co cG co wceq wa vu vt copab cJ cJ ccn co wcel cN cJ
          cK ccn co wcel cN vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co
          cG co wceq wa vu vt copab ccom cJ cK ccn co wcel cU cnv wcel cN cJ cK
          ccn co wcel ip1cni.9 cC cD cU cJ cK cN ip1cnilem.6 ip1cni.8 ip1cni.d
          ip1cni.j ip1cni.k nmcnc ax-mp cC cme wcel cC cme wcel cD cme wcel w3a
          vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co wceq wa vu
          vt copab cJ cJ ccn co wcel cN cJ cK ccn co wcel wa cN vu cv cX wcel
          vt cv vu cv ci vk cv cexp co cA cS co cG co wceq wa vu vt copab ccom
          cJ cK ccn co wcel cC cme wcel cC cme wcel cD cme wcel cU cnv wcel cC
          cme wcel ip1cni.9 cC cU ip1cni.8 imsmet ax-mp cU cnv wcel cC cme wcel
          ip1cni.9 cC cU ip1cni.8 imsmet ax-mp cD ip1cni.d cnmet 3pm3.2i cC cC
          cD vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co wceq wa
          vu vt copab cN cJ cJ cK ip1cni.j ip1cni.j ip1cni.k metcnco mpan mpan2
          syl eqeltrrd $.
          $( [2-Dec-2007] $) $( [21-Aug-2007] $)
      $}

      ${
        ip1cnilem.14 $e |- H = { <. u , t >. | ( u e. X /\ t =
          ( ( N ` ( u G ( ( _i ^ k ) S A ) ) ) ^ 2 ) ) } $.
        $( Lemma for ~ ip1cni . $)
        ip1cnilem3 $p |- ( k e. NN -> H e. ( J Cn K ) ) $=
          vk cv cn wcel va cv cc wcel vb cv va cv c2 cexp co wceq wa va vb
          copab vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co cN
          cfv wceq wa vu vt copab ccom cH cJ cK ccn co vk cv cn wcel vu cv cX
          wcel vt cv vu cv ci vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt
          copab crn cc wss va cv cc wcel vb cv va cv c2 cexp co wceq wa va vb
          copab vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co cN
          cfv wceq wa vu vt copab ccom cH wceq vk cv cn wcel vu cv ci vk cv
          cexp co cA cS co cG co cN cfv cc wcel vu cX wral vu cv cX wcel vt cv
          vu cv ci vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt copab crn
          cc wss vk cv cn wcel vu cv ci vk cv cexp co cA cS co cG co cN cfv cc
          wcel vu cX vk cv cn wcel vu cv cX wcel wa vu cv ci vk cv cexp co cA
          cS co cG co cX wcel vu cv ci vk cv cexp co cA cS co cG co cN cfv cc
          wcel vu cv cX wcel vk cv cn wcel vu cv ci vk cv cexp co cA cS co cG
          co cX wcel vu cv cX wcel ci vk cv cexp co cA cS co cX wcel vu cv ci
          vk cv cexp co cA cS co cG co cX wcel vk cv cn wcel cU cnv wcel vu cv
          cX wcel ci vk cv cexp co cA cS co cX wcel vu cv ci vk cv cexp co cA
          cS co cG co cX wcel ip1cni.9 vu cv ci vk cv cexp co cA cS co cU cG cX
          ip1cni.1 ip1cni.2 nvgcl mp3an1 vk cv cn wcel vk cv cn0 wcel ci vk cv
          cexp co cc wcel ci vk cv cexp co cA cS co cX wcel vk cv nnnn0 ci cc
          wcel vk cv cn0 wcel ci vk cv cexp co cc wcel axicn ci vk cv expcl
          mpan cU cnv wcel ci vk cv cexp co cc wcel cA cX wcel ci vk cv cexp co
          cA cS co cX wcel ip1cni.9 ip1cni.a ci vk cv cexp co cA cS cU cX
          ip1cni.1 ip1cnilem.4 nvscl mp3an13 3syl sylan2 ancoms vu cv ci vk cv
          cexp co cA cS co cG co cX wcel vu cv ci vk cv cexp co cA cS co cG co
          cN cfv cU cnv wcel vu cv ci vk cv cexp co cA cS co cG co cX wcel vu
          cv ci vk cv cexp co cA cS co cG co cN cfv cr wcel ip1cni.9 vu cv ci
          vk cv cexp co cA cS co cG co cU cN cX ip1cni.1 ip1cnilem.6 nvcl mpan
          recnd syl r19.21aiva vu vt cX cc vu cv ci vk cv cexp co cA cS co cG
          co cN cfv vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co cG co
          cN cfv wceq wa vu vt copab vu cv cX wcel vt cv vu cv ci vk cv cexp co
          cA cS co cG co cN cfv wceq wa vu vt copab eqid vu cv ci vk cv cexp co
          cA cS co cG co cN fvex rnssopab sylib vu vt va vb vt cX cc vu cv ci
          vk cv cexp co cA cS co cG co cN cfv va cv c2 cexp co vu cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co vu cv cX wcel vt cv vu cv ci
          vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt copab va cv cc wcel
          vb cv va cv c2 cexp co wceq wa va vb copab cH vu cv ci vk cv cexp co
          cA cS co cG co cN fvex va cv c2 cexp oprex vu cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp oprex va cv vu cv ci vk cv cexp co cA cS
          co cG co cN cfv c2 cexp opreq1 vu cv cX wcel vt cv vu cv ci vk cv
          cexp co cA cS co cG co cN cfv wceq wa vu vt copab eqid va cv cc wcel
          vb cv va cv c2 cexp co wceq wa va vb copab eqid ip1cnilem.14 fopabco
          syl vk cv cn wcel vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS co
          cG co cN cfv wceq wa vu vt copab cJ cK ccn co wcel va cv cc wcel vb
          cv va cv c2 cexp co wceq wa va vb copab vu cv cX wcel vt cv vu cv ci
          vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt copab ccom cJ cK
          ccn co wcel vw vv vu vt cA cC cD cP cS cU vk cF cG vu cv cX wcel vt
          cv vu cv ci vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt copab
          cJ cK cN cX ip1cni.1 ip1cni.2 ip1cni.7 ip1cni.8 ip1cni.d ip1cni.j
          ip1cni.k ip1cni.f ip1cni.9 ip1cni.a ip1cnilem.4 ip1cnilem.6 vu cv cX
          wcel vt cv vu cv ci vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt
          copab eqid ip1cnilem2 vu cv cX wcel vt cv vu cv ci vk cv cexp co cA
          cS co cG co cN cfv wceq wa vu vt copab cJ cK ccn co wcel va cv cc
          wcel vb cv va cv c2 cexp co wceq wa va vb copab cK cK ccn co wcel va
          cv cc wcel vb cv va cv c2 cexp co wceq wa va vb copab vu cv cX wcel
          vt cv vu cv ci vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt
          copab ccom cJ cK ccn co wcel va vb cD va cv cc wcel vb cv va cv c2
          cexp co wceq wa va vb copab cK ip1cni.d ip1cni.k va cv cc wcel vb cv
          va cv c2 cexp co wceq wa va vb copab eqid sqcn2 cC cme wcel cD cme
          wcel cD cme wcel w3a vu cv cX wcel vt cv vu cv ci vk cv cexp co cA cS
          co cG co cN cfv wceq wa vu vt copab cJ cK ccn co wcel va cv cc wcel
          vb cv va cv c2 cexp co wceq wa va vb copab cK cK ccn co wcel wa va cv
          cc wcel vb cv va cv c2 cexp co wceq wa va vb copab vu cv cX wcel vt
          cv vu cv ci vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt copab
          ccom cJ cK ccn co wcel cC cme wcel cD cme wcel cD cme wcel cU cnv
          wcel cC cme wcel ip1cni.9 cC cU ip1cni.8 imsmet ax-mp cD ip1cni.d
          cnmet cD ip1cni.d cnmet 3pm3.2i cC cD cD vu cv cX wcel vt cv vu cv ci
          vk cv cexp co cA cS co cG co cN cfv wceq wa vu vt copab va cv cc wcel
          vb cv va cv c2 cexp co wceq wa va vb copab cJ cK cK ip1cni.j ip1cni.k
          ip1cni.k metcnco mpan mpan2 syl eqeltrrd $.
          $( [2-Dec-2007] $) $( [21-Aug-2007] $)
      $}

      ${
        ip1cnilem.15 $e |- H = { <. u , t >. |
              ( u e. X /\ t = ( ( ( _i ^ k ) x. ( 1 / 4 ) )
              x. ( ( N ` ( u G ( ( _i ^ k ) S A ) ) ) ^ 2 ) ) ) } $.
        $( Lemma for ~ ip1cni . $)
        ip1cnilem4 $p |- ( k e. NN -> H e. ( J Cn K ) ) $=
          ci vk cv cexp co c1 c4 cdiv co cmul co cc wcel va cv cX wcel vb cv va
          cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co wceq wa va vb
          copab cJ cK ccn co wcel cH cJ cK ccn co wcel vk cv cn wcel vc vd vf
          vu vt cC cD cD vc cv cc cc cxp wcel vd cv cc cc cxp wcel wa vf cv vc
          cv c1st cfv vd cv c1st cfv cD co vc cv c2nd cfv vd cv c2nd cfv cD co
          cpr cr clt csup wceq wa vc vd vf copab2 ci vk cv cexp co c1 c4 cdiv
          co cmul co cK va cv cX wcel vb cv va cv ci vk cv cexp co cA cS co cG
          co cN cfv c2 cexp co wceq wa va vb copab cH cD cJ cK cK vc cv cc cc
          cxp wcel vd cv cc cc cxp wcel wa vf cv vc cv c1st cfv vd cv c1st cfv
          cD co vc cv c2nd cfv vd cv c2nd cfv cD co cpr cr clt csup wceq wa vc
          vd vf copab2 copn cfv cmul cX cc cc cC cU cX ip1cni.1 ip1cni.8
          ip1cni.9 imsbai cD ip1cni.d cnmetba cD ip1cni.d cnmetba cU cnv wcel
          cC cme wcel ip1cni.9 cC cU ip1cni.8 imsmet ax-mp cD ip1cni.d cnmet cD
          ip1cni.d cnmet cD ip1cni.d cnmet ip1cni.j ip1cni.k ip1cni.k vc cv cc
          cc cxp wcel vd cv cc cc cxp wcel wa vf cv vc cv c1st cfv vd cv c1st
          cfv cD co vc cv c2nd cfv vd cv c2nd cfv cD co cpr cr clt csup wceq wa
          vc vd vf copab2 copn cfv eqid ip1cni.k vc cv cc cc cxp wcel vd cv cc
          cc cxp wcel wa vf cv vc cv c1st cfv vd cv c1st cfv cD co vc cv c2nd
          cfv vd cv c2nd cfv cD co cpr cr clt csup wceq wa vc vd vf copab2 eqid
          vc vd vf cD vc cv cc cc cxp wcel vd cv cc cc cxp wcel wa vf cv vc cv
          c1st cfv vd cv c1st cfv cD co vc cv c2nd cfv vd cv c2nd cfv cD co cpr
          cr clt csup wceq wa vc vd vf copab2 cK vc cv cc cc cxp wcel vd cv cc
          cc cxp wcel wa vf cv vc cv c1st cfv vd cv c1st cfv cD co vc cv c2nd
          cfv vd cv c2nd cfv cD co cpr cr clt csup wceq wa vc vd vf copab2 copn
          cfv ip1cni.d vc cv cc cc cxp wcel vd cv cc cc cxp wcel wa vf cv vc cv
          c1st cfv vd cv c1st cfv cD co vc cv c2nd cfv vd cv c2nd cfv cD co cpr
          cr clt csup wceq wa vc vd vf copab2 eqid ip1cni.k vc cv cc cc cxp
          wcel vd cv cc cc cxp wcel wa vf cv vc cv c1st cfv vd cv c1st cfv cD
          co vc cv c2nd cfv vd cv c2nd cfv cD co cpr cr clt csup wceq wa vc vd
          vf copab2 copn cfv eqid mulcn cH vu cv cX wcel vt cv ci vk cv cexp co
          c1 c4 cdiv co cmul co vu cv ci vk cv cexp co cA cS co cG co cN cfv c2
          cexp co cmul co wceq wa vu vt copab vu cv cX wcel vt cv ci vk cv cexp
          co c1 c4 cdiv co cmul co vu cv va cv cX wcel vb cv va cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co wceq wa va vb copab cfv cmul
          co wceq wa vu vt copab ip1cnilem.15 vu cv cX wcel vt cv ci vk cv cexp
          co c1 c4 cdiv co cmul co vu cv va cv cX wcel vb cv va cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co wceq wa va vb copab cfv cmul
          co wceq wa vu cv cX wcel vt cv ci vk cv cexp co c1 c4 cdiv co cmul co
          vu cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co wceq
          wa vu vt vu cv cX wcel vt cv ci vk cv cexp co c1 c4 cdiv co cmul co
          vu cv va cv cX wcel vb cv va cv ci vk cv cexp co cA cS co cG co cN
          cfv c2 cexp co wceq wa va vb copab cfv cmul co wceq vt cv ci vk cv
          cexp co c1 c4 cdiv co cmul co vu cv ci vk cv cexp co cA cS co cG co
          cN cfv c2 cexp co cmul co wceq vu cv cX wcel ci vk cv cexp co c1 c4
          cdiv co cmul co vu cv va cv cX wcel vb cv va cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co wceq wa va vb copab cfv cmul co ci vk
          cv cexp co c1 c4 cdiv co cmul co vu cv ci vk cv cexp co cA cS co cG
          co cN cfv c2 cexp co cmul co vt cv vu cv cX wcel vu cv va cv cX wcel
          vb cv va cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co wceq wa
          va vb copab cfv vu cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp
          co ci vk cv cexp co c1 c4 cdiv co cmul co cmul va vb vu cv va cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co vu cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co cX va cv cX wcel vb cv va cv ci vk
          cv cexp co cA cS co cG co cN cfv c2 cexp co wceq wa va vb copab va cv
          vu cv wceq va cv ci vk cv cexp co cA cS co cG co cN cfv vu cv ci vk
          cv cexp co cA cS co cG co cN cfv c2 cexp va cv vu cv wceq va cv ci vk
          cv cexp co cA cS co cG co vu cv ci vk cv cexp co cA cS co cG co cN va
          cv vu cv ci vk cv cexp co cA cS co cG opreq1 fveq2d opreq1d va cv cX
          wcel vb cv va cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co
          wceq wa va vb copab eqid vu cv ci vk cv cexp co cA cS co cG co cN cfv
          c2 cexp oprex fvopab4 opreq2d eqeq2d pm5.32i opabbii eqtr4i opr2cn vk
          cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc wcel ci vk cv cexp co
          c1 c4 cdiv co cmul co cc wcel vk cv nnnn0 ci cc wcel vk cv cn0 wcel
          ci vk cv cexp co cc wcel axicn ci vk cv expcl mpan ci vk cv cexp co
          cc wcel c1 c4 cdiv co cc wcel ci vk cv cexp co c1 c4 cdiv co cmul co
          cc wcel c4 c4 4re recni c4 4re 4pos gt0ne0ii reccli ci vk cv cexp co
          c1 c4 cdiv co mulcl mpan2 3syl vw vv va vb cA cC cD cP cS cU vk cF cG
          va cv cX wcel vb cv va cv ci vk cv cexp co cA cS co cG co cN cfv c2
          cexp co wceq wa va vb copab cJ cK cN cX ip1cni.1 ip1cni.2 ip1cni.7
          ip1cni.8 ip1cni.d ip1cni.j ip1cni.k ip1cni.f ip1cni.9 ip1cni.a
          ip1cnilem.4 ip1cnilem.6 va cv cX wcel vb cv va cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co wceq wa va vb copab eqid ip1cnilem3
          sylanc $.
          $( [2-Dec-2007] $) $( [21-Aug-2007] $)
      $}

      ${
        ip1cnilem.16 $e |- H = { <. u , t >. |
               ( u e. X /\ t = ( ( ( _i ^ k ) x. ( ( N ` ( u G (
                 ( _i ^ k ) S A ) ) ) ^ 2 ) ) x. ( 1 / 4 ) ) ) } $.
        $( Lemma for ~ ip1cni . $)
        ip1cnilem5 $p |- ( k e. NN -> H e. ( J Cn K ) ) $=
          vk cv cn wcel cH vu cv cX wcel vt cv ci vk cv cexp co c1 c4 cdiv co
          cmul co vu cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul
          co wceq wa vu vt copab cJ cK ccn co vk cv cn wcel vu cv cX wcel vt cv
          ci vk cv cexp co vu cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp
          co cmul co c1 c4 cdiv co cmul co wceq wa vu vt copab vu cv cX wcel vt
          cv ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co cmul co wceq wa vu vt copab cH vk cv cn
          wcel vu cv cX wcel vt cv ci vk cv cexp co vu cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv co cmul co wceq wa
          vu cv cX wcel vt cv ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co wceq wa vu vt
          vk cv cn wcel vu cv cX wcel vt cv ci vk cv cexp co vu cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv co cmul
          co wceq vt cv ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cmul co wceq vk cv cn wcel
          vu cv cX wcel wa ci vk cv cexp co vu cv ci vk cv cexp co cA cS co cG
          co cN cfv c2 cexp co cmul co c1 c4 cdiv co cmul co ci vk cv cexp co
          c1 c4 cdiv co cmul co vu cv ci vk cv cexp co cA cS co cG co cN cfv c2
          cexp co cmul co vt cv ci vk cv cexp co cc wcel vu cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co cc wcel ci vk cv cexp co vu cv ci vk
          cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv co
          cmul co ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co cmul co wceq vk cv cn wcel vu cv cX
          wcel wa ci vk cv cexp co cc wcel vu cv ci vk cv cexp co cA cS co cG
          co cN cfv c2 cexp co cc wcel c1 c4 cdiv co cc wcel ci vk cv cexp co
          vu cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co c1 c4
          cdiv co cmul co ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cmul co wceq c4 c4 4re recni
          c4 4re 4pos gt0ne0ii reccli ci vk cv cexp co vu cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co c1 c4 cdiv co mul23 mp3an3 vk cv cn
          wcel ci vk cv cexp co cc wcel vu cv cX wcel vk cv cn wcel vk cv cn0
          wcel ci vk cv cexp co cc wcel vk cv nnnn0 ci cc wcel vk cv cn0 wcel
          ci vk cv cexp co cc wcel axicn ci vk cv expcl mpan syl adantr vk cv
          cn wcel vu cv cX wcel wa vu cv ci vk cv cexp co cA cS co cG co cN cfv
          cc wcel vu cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cc
          wcel vk cv cn wcel vu cv cX wcel wa vu cv ci vk cv cexp co cA cS co
          cG co cN cfv vk cv cn wcel vu cv cX wcel wa vu cv ci vk cv cexp co cA
          cS co cG co cX wcel vu cv ci vk cv cexp co cA cS co cG co cN cfv cr
          wcel vu cv cX wcel vk cv cn wcel vu cv ci vk cv cexp co cA cS co cG
          co cX wcel vu cv cX wcel ci vk cv cexp co cA cS co cX wcel vu cv ci
          vk cv cexp co cA cS co cG co cX wcel vk cv cn wcel cU cnv wcel vu cv
          cX wcel ci vk cv cexp co cA cS co cX wcel vu cv ci vk cv cexp co cA
          cS co cG co cX wcel ip1cni.9 vu cv ci vk cv cexp co cA cS co cU cG cX
          ip1cni.1 ip1cni.2 nvgcl mp3an1 vk cv cn wcel vk cv cn0 wcel ci vk cv
          cexp co cc wcel ci vk cv cexp co cA cS co cX wcel vk cv nnnn0 ci cc
          wcel vk cv cn0 wcel ci vk cv cexp co cc wcel axicn ci vk cv expcl
          mpan cU cnv wcel ci vk cv cexp co cc wcel cA cX wcel ci vk cv cexp co
          cA cS co cX wcel ip1cni.9 ip1cni.a ci vk cv cexp co cA cS cU cX
          ip1cni.1 ip1cnilem.4 nvscl mp3an13 3syl sylan2 ancoms cU cnv wcel vu
          cv ci vk cv cexp co cA cS co cG co cX wcel vu cv ci vk cv cexp co cA
          cS co cG co cN cfv cr wcel ip1cni.9 vu cv ci vk cv cexp co cA cS co
          cG co cU cN cX ip1cni.1 ip1cnilem.6 nvcl mpan syl recnd vu cv ci vk
          cv cexp co cA cS co cG co cN cfv sqcl syl sylanc eqeq2d pm5.32da
          opabbidv ip1cnilem.16 syl5eq vw vv vu vt cA cC cD cP cS cU vk cF cG
          vu cv cX wcel vt cv ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co wceq wa vu vt
          copab cJ cK cN cX ip1cni.1 ip1cni.2 ip1cni.7 ip1cni.8 ip1cni.d
          ip1cni.j ip1cni.k ip1cni.f ip1cni.9 ip1cni.a ip1cnilem.4 ip1cnilem.6
          vu cv cX wcel vt cv ci vk cv cexp co c1 c4 cdiv co cmul co vu cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co wceq wa vu vt
          copab eqid ip1cnilem4 eqeltrd $.
          $( [2-Dec-2007] $) $( [21-Aug-2007] $)

        $( Lemma for ~ ip1cni . $)
        ip1cnilem6 $p |- F e. ( J Cn K ) $=
          c4 cn wcel cF cJ cK ccn co wcel 4nn vw vv cC cD vk cH cF cJ cK c4 cX
          cU cnv wcel cC cme wcel ip1cni.9 cC cU ip1cni.8 imsmet ax-mp cC cU cX
          ip1cni.1 ip1cni.8 ip1cni.9 imsbai ip1cni.d ip1cni.j ip1cni.k vw vv vu
          vt cA cC cD cP cS cU vk cF cG cH cJ cK cN cX ip1cni.1 ip1cni.2
          ip1cni.7 ip1cni.8 ip1cni.d ip1cni.j ip1cni.k ip1cni.f ip1cni.9
          ip1cni.a ip1cnilem.4 ip1cnilem.6 ip1cnilem.16 ip1cnilem5 cF vw cv cX
          wcel vv cv vw cv cA cP co wceq wa vw vv copab vw cv cX wcel vv cv c1
          c4 cfz co vw cv cH cfv vk csu wceq wa vw vv copab ip1cni.f vw cv cX
          wcel vv cv c1 c4 cfz co vw cv cH cfv vk csu wceq wa vw cv cX wcel vv
          cv vw cv cA cP co wceq wa vw vv vw cv cX wcel vv cv c1 c4 cfz co vw
          cv cH cfv vk csu wceq vv cv vw cv cA cP co wceq vw cv cX wcel c1 c4
          cfz co vw cv cH cfv vk csu vw cv cA cP co vv cv vw cv cX wcel c1 c4
          cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv
          c2 cexp co cmul co vk csu c4 cdiv co c1 c4 cfz co ci vk cv cexp co vw
          cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co vk csu
          c1 c4 cdiv co cmul co vw cv cA cP co c1 c4 cfz co vw cv cH cfv vk csu
          vw cv cX wcel c1 c4 cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co cmul co vk csu cc wcel c1 c4 cfz co ci
          vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co
          cmul co vk csu c4 cdiv co c1 c4 cfz co ci vk cv cexp co vw cv ci vk
          cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co vk csu c1 c4 cdiv
          co cmul co wceq vw cv cX wcel ci vk cv cexp co vw cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co cmul co cc wcel vk c1 c4 cfz co wral
          c1 c4 cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co
          cN cfv c2 cexp co cmul co vk csu cc wcel vw cv cX wcel ci vk cv cexp
          co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co cc
          wcel vk c1 c4 cfz co vw cv cX wcel vk cv cn wcel ci vk cv cexp co vw
          cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co cc wcel
          vk cv c1 c4 cfz co wcel ci vk cv cexp co cc wcel vw cv ci vk cv cexp
          co cA cS co cG co cN cfv c2 cexp co cc wcel ci vk cv cexp co vw cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co cc wcel vw cv
          cX wcel vk cv cn wcel wa ci vk cv cexp co vw cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co mulcl vk cv cn wcel ci vk cv cexp co cc
          wcel vw cv cX wcel vk cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc
          wcel vk cv nnnn0 ci cc wcel vk cv cn0 wcel ci vk cv cexp co cc wcel
          axicn ci vk cv expcl mpan syl adantl vw cv cX wcel vk cv cn wcel wa
          vw cv ci vk cv cexp co cA cS co cG co cN cfv cc wcel vw cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cc wcel vw cv cX wcel vk cv
          cn wcel wa vw cv ci vk cv cexp co cA cS co cG co cN cfv vw cv cX wcel
          vk cv cn wcel wa vw cv ci vk cv cexp co cA cS co cG co cX wcel vw cv
          ci vk cv cexp co cA cS co cG co cN cfv cr wcel vw cv cX wcel ci vk cv
          cexp co cA cS co cX wcel vw cv ci vk cv cexp co cA cS co cG co cX
          wcel vk cv cn wcel cU cnv wcel vw cv cX wcel ci vk cv cexp co cA cS
          co cX wcel vw cv ci vk cv cexp co cA cS co cG co cX wcel ip1cni.9 vw
          cv ci vk cv cexp co cA cS co cU cG cX ip1cni.1 ip1cni.2 nvgcl mp3an1
          vk cv cn wcel ci vk cv cexp co cc wcel ci vk cv cexp co cA cS co cX
          wcel vk cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc wcel vk cv
          nnnn0 ci cc wcel vk cv cn0 wcel ci vk cv cexp co cc wcel axicn ci vk
          cv expcl mpan syl cU cnv wcel ci vk cv cexp co cc wcel cA cX wcel ci
          vk cv cexp co cA cS co cX wcel ip1cni.9 ip1cni.a ci vk cv cexp co cA
          cS cU cX ip1cni.1 ip1cnilem.4 nvscl mp3an13 syl sylan2 cU cnv wcel vw
          cv ci vk cv cexp co cA cS co cG co cX wcel vw cv ci vk cv cexp co cA
          cS co cG co cN cfv cr wcel ip1cni.9 vw cv ci vk cv cexp co cA cS co
          cG co cU cN cX ip1cni.1 ip1cnilem.6 nvcl mpan syl recnd vw cv ci vk
          cv cexp co cA cS co cG co cN cfv sqcl syl sylanc vk cv c4 elfznn
          sylan2 r19.21aiva c4 c1 cuz cfv wcel ci vk cv cexp co vw cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cmul co cc wcel vk c1 c4 cfz
          co wral c1 c4 cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co
          cG co cN cfv c2 cexp co cmul co vk csu cc wcel c4 cn wcel c4 c1 cuz
          cfv wcel 4nn c4 elnnuz mpbi ci vk cv cexp co vw cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co cmul co vk c1 c4 fsumcl mpan syl c1
          c4 cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN
          cfv c2 cexp co cmul co vk csu cc wcel c4 cc wcel c4 cc0 wne c1 c4 cfz
          co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2
          cexp co cmul co vk csu c4 cdiv co c1 c4 cfz co ci vk cv cexp co vw cv
          ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co vk csu c1
          c4 cdiv co cmul co wceq c4 4re recni c4 4re 4pos gt0ne0ii c1 c4 cfz
          co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2
          cexp co cmul co vk csu c4 divrec mp3an23 syl cU cnv wcel vw cv cX
          wcel cA cX wcel vw cv cA cP co c1 c4 cfz co ci vk cv cexp co vw cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co vk csu c4 cdiv
          co wceq ip1cni.9 ip1cni.a vw cv cA cP cS cU vk cG cN cX ip1cni.1
          ip1cni.2 ip1cnilem.4 ip1cnilem.6 ip1cni.7 ipval mp3an13 vw cv cX wcel
          c1 c4 cfz co vw cv cH cfv vk csu c1 c4 cfz co ci vk cv cexp co vw cv
          ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv
          co cmul co vk csu c1 c4 cfz co ci vk cv cexp co vw cv ci vk cv cexp
          co cA cS co cG co cN cfv c2 cexp co cmul co vk csu c1 c4 cdiv co cmul
          co vw cv cX wcel c1 c4 cfz co vw cv cH cfv ci vk cv cexp co vw cv ci
          vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv co
          cmul co vk vu vt vw cv ci vk cv cexp co vu cv ci vk cv cexp co cA cS
          co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv co cmul co ci vk cv
          cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul
          co c1 c4 cdiv co cmul co cX cH vu cv vw cv wceq ci vk cv cexp co vu
          cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co ci vk cv
          cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul
          co c1 c4 cdiv co cmul vu cv vw cv wceq vu cv ci vk cv cexp co cA cS
          co cG co cN cfv c2 cexp co vw cv ci vk cv cexp co cA cS co cG co cN
          cfv c2 cexp co ci vk cv cexp co cmul vu cv vw cv wceq vu cv ci vk cv
          cexp co cA cS co cG co cN cfv vw cv ci vk cv cexp co cA cS co cG co
          cN cfv c2 cexp vu cv vw cv wceq vu cv ci vk cv cexp co cA cS co cG co
          vw cv ci vk cv cexp co cA cS co cG co cN vu cv vw cv ci vk cv cexp co
          cA cS co cG opreq1 fveq2d opreq1d opreq2d opreq1d ip1cnilem.16 ci vk
          cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co
          cmul co c1 c4 cdiv co cmul oprex fvopab4 sumeq2sdv vw cv cX wcel ci
          vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co
          cmul co cc wcel vk c1 c4 cfz co wral c1 c4 cfz co ci vk cv cexp co vw
          cv ci vk cv cexp co cA cS co cG co cN cfv c2 cexp co cmul co vk csu
          c1 c4 cdiv co cmul co c1 c4 cfz co ci vk cv cexp co vw cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cmul co c1 c4 cdiv co cmul
          co vk csu wceq vw cv cX wcel ci vk cv cexp co vw cv ci vk cv cexp co
          cA cS co cG co cN cfv c2 cexp co cmul co cc wcel vk c1 c4 cfz co vw
          cv cX wcel vk cv cn wcel ci vk cv cexp co vw cv ci vk cv cexp co cA
          cS co cG co cN cfv c2 cexp co cmul co cc wcel vk cv c1 c4 cfz co wcel
          ci vk cv cexp co cc wcel vw cv ci vk cv cexp co cA cS co cG co cN cfv
          c2 cexp co cc wcel ci vk cv cexp co vw cv ci vk cv cexp co cA cS co
          cG co cN cfv c2 cexp co cmul co cc wcel vw cv cX wcel vk cv cn wcel
          wa ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv c2
          cexp co mulcl vk cv cn wcel ci vk cv cexp co cc wcel vw cv cX wcel vk
          cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc wcel vk cv nnnn0 ci cc
          wcel vk cv cn0 wcel ci vk cv cexp co cc wcel axicn ci vk cv expcl
          mpan syl adantl vw cv cX wcel vk cv cn wcel wa vw cv ci vk cv cexp co
          cA cS co cG co cN cfv cc wcel vw cv ci vk cv cexp co cA cS co cG co
          cN cfv c2 cexp co cc wcel vw cv cX wcel vk cv cn wcel wa vw cv ci vk
          cv cexp co cA cS co cG co cN cfv vw cv cX wcel vk cv cn wcel wa vw cv
          ci vk cv cexp co cA cS co cG co cX wcel vw cv ci vk cv cexp co cA cS
          co cG co cN cfv cr wcel vw cv cX wcel ci vk cv cexp co cA cS co cX
          wcel vw cv ci vk cv cexp co cA cS co cG co cX wcel vk cv cn wcel cU
          cnv wcel vw cv cX wcel ci vk cv cexp co cA cS co cX wcel vw cv ci vk
          cv cexp co cA cS co cG co cX wcel ip1cni.9 vw cv ci vk cv cexp co cA
          cS co cU cG cX ip1cni.1 ip1cni.2 nvgcl mp3an1 vk cv cn wcel ci vk cv
          cexp co cc wcel ci vk cv cexp co cA cS co cX wcel vk cv cn wcel vk cv
          cn0 wcel ci vk cv cexp co cc wcel vk cv nnnn0 ci cc wcel vk cv cn0
          wcel ci vk cv cexp co cc wcel axicn ci vk cv expcl mpan syl cU cnv
          wcel ci vk cv cexp co cc wcel cA cX wcel ci vk cv cexp co cA cS co cX
          wcel ip1cni.9 ip1cni.a ci vk cv cexp co cA cS cU cX ip1cni.1
          ip1cnilem.4 nvscl mp3an13 syl sylan2 cU cnv wcel vw cv ci vk cv cexp
          co cA cS co cG co cX wcel vw cv ci vk cv cexp co cA cS co cG co cN
          cfv cr wcel ip1cni.9 vw cv ci vk cv cexp co cA cS co cG co cU cN cX
          ip1cni.1 ip1cnilem.6 nvcl mpan syl recnd vw cv ci vk cv cexp co cA cS
          co cG co cN cfv sqcl syl sylanc vk cv c4 elfznn sylan2 r19.21aiva c4
          c1 cuz cfv wcel c1 c4 cdiv co cc wcel ci vk cv cexp co vw cv ci vk cv
          cexp co cA cS co cG co cN cfv c2 cexp co cmul co cc wcel vk c1 c4 cfz
          co wral c1 c4 cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co
          cG co cN cfv c2 cexp co cmul co vk csu c1 c4 cdiv co cmul co c1 c4
          cfz co ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv
          c2 cexp co cmul co c1 c4 cdiv co cmul co vk csu wceq c4 cn wcel c4 c1
          cuz cfv wcel 4nn c4 elnnuz mpbi c4 c4 4re recni c4 4re 4pos gt0ne0ii
          reccli ci vk cv cexp co vw cv ci vk cv cexp co cA cS co cG co cN cfv
          c2 cexp co cmul co c1 c4 cdiv co vk c1 c4 fsummulc2 mp3an12 syl
          eqtr4d 3eqtr4rd eqeq2d pm5.32i opabbii eqtr4i fsumcn ax-mp $.
          $( [2-Dec-2007] $) $( [21-Aug-2007] $)
      $}
    $}

    $( Inner product is continuous in its first operand. $)
    ip1cni $p |- F e. ( J Cn K ) $=
      vw vv vu vt cA cC cD cP cU cns cfv cU vk cF cG vu cv cX wcel vt cv ci vk
      cv cexp co vu cv ci vk cv cexp co cA cU cns cfv co cG co cU cnm cfv cfv
      c2 cexp co cmul co c1 c4 cdiv co cmul co wceq wa vu vt copab cJ cK cU cnm
      cfv cX ip1cni.1 ip1cni.2 ip1cni.7 ip1cni.8 ip1cni.d ip1cni.j ip1cni.k
      ip1cni.f ip1cni.9 ip1cni.a cU cns cfv eqid cU cnm cfv eqid vu cv cX wcel
      vt cv ci vk cv cexp co vu cv ci vk cv cexp co cA cU cns cfv co cG co cU
      cnm cfv cfv c2 cexp co cmul co c1 c4 cdiv co cmul co wceq wa vu vt copab
      eqid ip1cnilem6 $.
      $( [2-Dec-2007] $) $( [21-Aug-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SubSp $.

  $( Extend class notation with the class of all subspaces of complex normed
     vector spaces. $)
  css $a class SubSp $.

  ${
    $d u s w $.
    $( Define the class of all subspaces of complex normed vector spaces. $)
    df-ssp $a |- SubSp = { <. u , s >. | ( u e. NrmCVec /\ s =
     { w e. NrmCVec | ( ( +v ` w ) C_ ( +v ` u ) /\ ( .s ` w ) C_ ( .s ` u )
         /\ ( norm ` w ) C_ ( norm ` u ) ) } ) } $.
  $}

  ${
    $d s u w G $.  $d s u w N $.  $d s u w S $.  $d s u w U $.
    sspval.g $e |- G = ( +v ` U ) $.
    sspval.s $e |- S = ( .s ` U ) $.
    sspval.n $e |- N = ( norm ` U ) $.
    sspval.h $e |- H = ( SubSp ` U ) $.
    $( The set of all subspaces of a normed complex vector space. $)
    sspval $p |- ( U e. NrmCVec -> H = { w e. NrmCVec | (
         ( +v ` w ) C_ G /\ ( .s ` w ) C_ S /\ ( norm ` w ) C_ N ) } ) $=
      cU cnv wcel cU css cfv vw cv cpv cfv cG wss vw cv cns cfv cS wss vw cv
      cnm cfv cN wss w3a vw cnv crab cH vu vs cU vw cv cpv cfv vu cv cpv cfv
      wss vw cv cns cfv vu cv cns cfv wss vw cv cnm cfv vu cv cnm cfv wss w3a
      vw cnv crab vw cv cpv cfv cG wss vw cv cns cfv cS wss vw cv cnm cfv cN
      wss w3a vw cnv crab cnv css vu cv cU wceq vw cv cpv cfv vu cv cpv cfv wss
      vw cv cns cfv vu cv cns cfv wss vw cv cnm cfv vu cv cnm cfv wss w3a vw cv
      cpv cfv cG wss vw cv cns cfv cS wss vw cv cnm cfv cN wss w3a vw cnv vu cv
      cU wceq vw cv cpv cfv vu cv cpv cfv wss vw cv cpv cfv cG wss vw cv cns
      cfv vu cv cns cfv wss vw cv cns cfv cS wss vw cv cnm cfv vu cv cnm cfv
      wss vw cv cnm cfv cN wss vu cv cU wceq vu cv cpv cfv cG vw cv cpv cfv vu
      cv cU wceq vu cv cpv cfv cU cpv cfv cG vu cv cU cpv fveq2 sspval.g
      syl6eqr sseq2d vu cv cU wceq vu cv cns cfv cS vw cv cns cfv vu cv cU wceq
      vu cv cns cfv cU cns cfv cS vu cv cU cns fveq2 sspval.s syl6eqr sseq2d vu
      cv cU wceq vu cv cnm cfv cN vw cv cnm cfv vu cv cU wceq vu cv cnm cfv cU
      cnm cfv cN vu cv cU cnm fveq2 sspval.n syl6eqr sseq2d 3anbi123d rabbisdv
      vw vu vs df-ssp vw cv cpv cfv cG wss vw cv cns cfv cS wss vw cv cnm cfv
      cN wss w3a vw cnv crab cG cpw cS cpw cxp cN cpw cxp cG cpw cS cpw cxp cN
      cpw cG cpw cS cpw cG cG cU cpv cfv cvv sspval.g cU cpv fvex eqeltri pwex
      cS cS cU cns cfv cvv sspval.s cU cns fvex eqeltri pwex xpex cN cN cU cnm
      cfv cvv sspval.n cU cnm fvex eqeltri pwex xpex vu vw cv cpv cfv cG wss vw
      cv cns cfv cS wss vw cv cnm cfv cN wss w3a vw cnv crab cG cpw cS cpw cxp
      cN cpw cxp vu cv cnv wcel vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw
      wcel wa vu cv cnm cfv cN cpw wcel wa wa vu cv vu cv c1st cfv vu cv c2nd
      cfv cop wceq vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd
      cfv cop wceq vu cv c1st cfv c1st cfv cG cpw wcel vu cv c1st cfv c2nd cfv
      cS cpw wcel wa wa vu cv c2nd cfv cN cpw wcel wa wa vu cv vw cv cpv cfv cG
      wss vw cv cns cfv cS wss vw cv cnm cfv cN wss w3a vw cnv crab wcel vu cv
      cG cpw cS cpw cxp cN cpw cxp wcel vu cv cnv wcel vu cv cpv cfv cG cpw
      wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN cpw wcel wa wa vu cv
      vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv c1st cfv vu cv c1st cfv c1st
      cfv vu cv c1st cfv c2nd cfv cop wceq vu cv c1st cfv c1st cfv cG cpw wcel
      vu cv c1st cfv c2nd cfv cS cpw wcel wa wa vu cv c2nd cfv cN cpw wcel wa
      vu cv cnv wcel vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv cpv cfv
      cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN cpw wcel wa vu
      cv vu cv c2nd cfv vu cv c1st cfv vu cv c1st cfv eqid vu cv cnm cfv vu cv
      c2nd cfv vu cv vu cv cnm cfv vu cv cnm cfv eqid nmfval eqcomi nvop2
      adantr vu cv cnv wcel vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw wcel
      wa vu cv cnm cfv cN cpw wcel wa wa vu cv c1st cfv vu cv c1st cfv c1st cfv
      vu cv c1st cfv c2nd cfv cop wceq vu cv c1st cfv c1st cfv cG cpw wcel vu
      cv c1st cfv c2nd cfv cS cpw wcel wa wa vu cv c2nd cfv cN cpw wcel vu cv
      cnv wcel vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm
      cfv cN cpw wcel wa wa vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st
      cfv c2nd cfv cop wceq vu cv c1st cfv c1st cfv cG cpw wcel vu cv c1st cfv
      c2nd cfv cS cpw wcel wa vu cv cnv wcel vu cv c1st cfv vu cv c1st cfv c1st
      cfv vu cv c1st cfv c2nd cfv cop wceq vu cv cpv cfv cG cpw wcel vu cv cns
      cfv cS cpw wcel wa vu cv cnm cfv cN cpw wcel wa vu cv c1st cfv c2nd cfv
      vu cv vu cv c1st cfv c1st cfv vu cv c1st cfv vu cv c1st cfv eqid vu cv
      cpv cfv vu cv c1st cfv c1st cfv vu cv vu cv cpv cfv vu cv cpv cfv eqid
      vafval eqcomi vu cv cns cfv vu cv c1st cfv c2nd cfv vu cv cns cfv vu cv
      vu cv cns cfv eqid smfval eqcomi nvvop adantr vu cv cnv wcel vu cv cpv
      cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN cpw wcel wa
      wa vu cv c1st cfv c1st cfv cG cpw wcel vu cv c1st cfv c2nd cfv cS cpw
      wcel vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv
      cN cpw wcel wa vu cv c1st cfv c1st cfv cG cpw wcel vu cv cnv wcel vu cv
      cpv cfv cG cpw wcel vu cv c1st cfv c1st cfv cG cpw wcel vu cv cns cfv cS
      cpw wcel vu cv cnm cfv cN cpw wcel vu cv cpv cfv cG cpw wcel vu cv c1st
      cfv c1st cfv cG cpw wcel vu cv cpv cfv vu cv c1st cfv c1st cfv cG cpw vu
      cv vu cv cpv cfv vu cv cpv cfv eqid vafval eleq1i biimpi ad2antrr adantl
      vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN
      cpw wcel wa vu cv c1st cfv c2nd cfv cS cpw wcel vu cv cnv wcel vu cv cns
      cfv cS cpw wcel vu cv c1st cfv c2nd cfv cS cpw wcel vu cv cpv cfv cG cpw
      wcel vu cv cnm cfv cN cpw wcel vu cv cns cfv cS cpw wcel vu cv c1st cfv
      c2nd cfv cS cpw wcel vu cv cns cfv vu cv c1st cfv c2nd cfv cS cpw vu cv
      cns cfv vu cv vu cv cns cfv eqid smfval eleq1i biimpi ad2antlr adantl jca
      jca vu cv cnm cfv cN cpw wcel vu cv c2nd cfv cN cpw wcel vu cv cnv wcel
      vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN
      cpw wcel vu cv c2nd cfv cN cpw wcel vu cv cnm cfv vu cv c2nd cfv cN cpw
      vu cv vu cv cnm cfv vu cv cnm cfv eqid nmfval eleq1i biimpi ad2antll jca
      jca vw cv cpv cfv cG wss vw cv cns cfv cS wss vw cv cnm cfv cN wss w3a vu
      cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN cpw
      wcel wa vw vu cv cnv vw cv vu cv wceq vw cv cpv cfv cG wss vw cv cns cfv
      cS wss vw cv cnm cfv cN wss w3a vu cv cpv cfv cG wss vu cv cns cfv cS wss
      vu cv cnm cfv cN wss w3a vu cv cpv cfv cG cpw wcel vu cv cns cfv cS cpw
      wcel wa vu cv cnm cfv cN cpw wcel wa vw cv vu cv wceq vw cv cpv cfv cG
      wss vu cv cpv cfv cG wss vw cv cns cfv cS wss vu cv cns cfv cS wss vw cv
      cnm cfv cN wss vu cv cnm cfv cN wss vw cv vu cv wceq vw cv cpv cfv vu cv
      cpv cfv cG vw cv vu cv cpv fveq2 sseq1d vw cv vu cv wceq vw cv cns cfv vu
      cv cns cfv cS vw cv vu cv cns fveq2 sseq1d vw cv vu cv wceq vw cv cnm cfv
      vu cv cnm cfv cN vw cv vu cv cnm fveq2 sseq1d 3anbi123d vu cv cpv cfv cG
      wss vu cv cns cfv cS wss vu cv cnm cfv cN wss w3a vu cv cpv cfv cG cpw
      wcel vu cv cns cfv cS cpw wcel vu cv cnm cfv cN cpw wcel w3a vu cv cpv
      cfv cG cpw wcel vu cv cns cfv cS cpw wcel wa vu cv cnm cfv cN cpw wcel wa
      vu cv cpv cfv cG cpw wcel vu cv cpv cfv cG wss vu cv cns cfv cS cpw wcel
      vu cv cns cfv cS wss vu cv cnm cfv cN cpw wcel vu cv cnm cfv cN wss vu cv
      cpv cfv cG vu cv cpv fvex elpw vu cv cns cfv cS vu cv cns fvex elpw vu cv
      cnm cfv cN vu cv cnm fvex elpw 3anbi123i vu cv cpv cfv cG cpw wcel vu cv
      cns cfv cS cpw wcel vu cv cnm cfv cN cpw wcel df-3an bitr3i syl6bb elrab
      vu cv cG cpw cS cpw cxp cN cpw cxp wcel vu cv vu cv c1st cfv vu cv c2nd
      cfv cop wceq vu cv c1st cfv cG cpw cS cpw cxp wcel vu cv c2nd cfv cN cpw
      wcel wa wa vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv c1st cfv vu
      cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq vu cv c1st cfv c1st
      cfv cG cpw wcel vu cv c1st cfv c2nd cfv cS cpw wcel wa wa vu cv c2nd cfv
      cN cpw wcel wa wa vu cv cG cpw cS cpw cxp cN cpw elxp6 vu cv c1st cfv cG
      cpw cS cpw cxp wcel vu cv c2nd cfv cN cpw wcel wa vu cv c1st cfv vu cv
      c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq vu cv c1st cfv c1st
      cfv cG cpw wcel vu cv c1st cfv c2nd cfv cS cpw wcel wa wa vu cv c2nd cfv
      cN cpw wcel wa vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv c1st
      cfv cG cpw cS cpw cxp wcel vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv
      c1st cfv c2nd cfv cop wceq vu cv c1st cfv c1st cfv cG cpw wcel vu cv c1st
      cfv c2nd cfv cS cpw wcel wa wa vu cv c2nd cfv cN cpw wcel vu cv c1st cfv
      cG cpw cS cpw elxp6 anbi1i anbi2i bitri 3imtr4i ssriv ssexi fvopab4
      sspval.h syl5eq $.
      $( [31-Jan-2008] $) $( [26-Jan-2008] $)
  $}

  ${
    $d w F $.  $d w G $.  $d w M $.  $d w N $.  $d w R $.  $d w S $.  $d w U $.
    $d w W $.
    isssp.g $e |- G = ( +v ` U ) $.
    isssp.f $e |- F = ( +v ` W ) $.
    isssp.s $e |- S = ( .s ` U ) $.
    isssp.r $e |- R = ( .s ` W ) $.
    isssp.n $e |- N = ( norm ` U ) $.
    isssp.m $e |- M = ( norm ` W ) $.
    isssp.h $e |- H = ( SubSp ` U ) $.
    $( The predicate "is a subspace." $)
    isssp $p |- ( U e. NrmCVec -> ( W e. H <-> ( W e. NrmCVec /\ (
               F C_ G /\ R C_ S /\ M C_ N ) ) ) ) $=
      cU cnv wcel cW cH wcel cW vw cv cpv cfv cG wss vw cv cns cfv cS wss vw cv
      cnm cfv cN wss w3a vw cnv crab wcel cW cnv wcel cF cG wss cR cS wss cM cN
      wss w3a wa cU cnv wcel cH vw cv cpv cfv cG wss vw cv cns cfv cS wss vw cv
      cnm cfv cN wss w3a vw cnv crab cW vw cS cU cG cH cN isssp.g isssp.s
      isssp.n isssp.h sspval eleq2d vw cv cpv cfv cG wss vw cv cns cfv cS wss
      vw cv cnm cfv cN wss w3a cF cG wss cR cS wss cM cN wss w3a vw cW cnv vw
      cv cW wceq vw cv cpv cfv cG wss cF cG wss vw cv cns cfv cS wss cR cS wss
      vw cv cnm cfv cN wss cM cN wss vw cv cW wceq vw cv cpv cfv cF cG vw cv cW
      wceq vw cv cpv cfv cW cpv cfv cF vw cv cW cpv fveq2 isssp.f syl6eqr
      sseq1d vw cv cW wceq vw cv cns cfv cR cS vw cv cW wceq vw cv cns cfv cW
      cns cfv cR vw cv cW cns fveq2 isssp.r syl6eqr sseq1d vw cv cW wceq vw cv
      cnm cfv cM cN vw cv cW wceq vw cv cnm cfv cW cnm cfv cM vw cv cW cnm
      fveq2 isssp.m syl6eqr sseq1d 3anbi123d elrab syl6bb $.
      $( [31-Jan-2008] $) $( [26-Jan-2008] $)
  $}

  ${
    sspid.h $e |- H = ( SubSp ` U ) $.
    $( A normed complex vector space is a subspace of itself. $)
    sspid $p |- ( U e. NrmCVec -> U e. H ) $=
      cU cnv wcel cU cH wcel cU cnv wcel cU cpv cfv cU cpv cfv wss cU cns cfv
      cU cns cfv wss cU cnm cfv cU cnm cfv wss w3a wa cU cnv wcel cU cpv cfv cU
      cpv cfv wss cU cns cfv cU cns cfv wss cU cnm cfv cU cnm cfv wss w3a cU
      cpv cfv cU cpv cfv wss cU cns cfv cU cns cfv wss cU cnm cfv cU cnm cfv
      wss cU cpv cfv ssid cU cns cfv ssid cU cnm cfv ssid 3pm3.2i jctr cU cns
      cfv cU cns cfv cU cU cpv cfv cU cpv cfv cH cU cnm cfv cU cnm cfv cU cU
      cpv cfv eqid cU cpv cfv eqid cU cns cfv eqid cU cns cfv eqid cU cnm cfv
      eqid cU cnm cfv eqid sspid.h isssp mpbird $.
      $( [5-May-2008] $) $( [8-Apr-2008] $)
  $}

  ${
    sspnv.h $e |- H = ( SubSp ` U ) $.
    $( A subspace is a normed complex vector space. $)
    sspnv $p |- ( ( U e. NrmCVec /\ W e. H ) -> W e. NrmCVec ) $=
      cU cnv wcel cW cH wcel cW cnv wcel cW cpv cfv cU cpv cfv wss cW cns cfv
      cU cns cfv wss cW cnm cfv cU cnm cfv wss w3a cW cns cfv cU cns cfv cU cW
      cpv cfv cU cpv cfv cH cW cnm cfv cU cnm cfv cW cU cpv cfv eqid cW cpv cfv
      eqid cU cns cfv eqid cW cns cfv eqid cU cnm cfv eqid cW cnm cfv eqid
      sspnv.h isssp pm3.26bda $.
      $( [1-Feb-2008] $) $( [27-Jan-2008] $)
  $}

  ${
    sspba.x $e |- X = ( BaseSet ` U ) $.
    sspba.y $e |- Y = ( BaseSet ` W ) $.
    sspba.h $e |- H = ( SubSp ` U ) $.
    $( The base set of a subspace is included in the parent base set. $)
    sspba $p |- ( ( U e. NrmCVec /\ W e. H ) -> Y C_ X ) $=
      cU cnv wcel cW cH wcel wa cW cpv cfv crn cU cpv cfv crn cY cX cU cnv wcel
      cW cH wcel wa cW cpv cfv cU cpv cfv wss cW cns cfv cU cns cfv wss cW cnm
      cfv cU cnm cfv wss w3a cW cpv cfv cU cpv cfv wss cW cpv cfv crn cU cpv
      cfv crn wss cU cnv wcel cW cH wcel cW cnv wcel cW cpv cfv cU cpv cfv wss
      cW cns cfv cU cns cfv wss cW cnm cfv cU cnm cfv wss w3a cW cns cfv cU cns
      cfv cU cW cpv cfv cU cpv cfv cH cW cnm cfv cU cnm cfv cW cU cpv cfv eqid
      cW cpv cfv eqid cU cns cfv eqid cW cns cfv eqid cU cnm cfv eqid cW cnm
      cfv eqid sspba.h isssp pm3.27bda cW cpv cfv cU cpv cfv wss cW cns cfv cU
      cns cfv wss cW cnm cfv cU cnm cfv wss 3simp1 cW cpv cfv cU cpv cfv rnss
      3syl cW cW cpv cfv cY sspba.y cW cpv cfv eqid bafval cU cU cpv cfv cX
      sspba.x cU cpv cfv eqid bafval 3sstr4g $.
      $( [31-Jan-2008] $) $( [27-Jan-2008] $)
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspg.y $e |- Y = ( BaseSet ` W ) $.
    sspg.g $e |- G = ( +v ` U ) $.
    sspg.f $e |- F = ( +v ` W ) $.
    sspg.h $e |- H = ( SubSp ` U ) $.
    $( Vector addition on a subspace is a restriction of vector addition on the
       parent space. $)
    sspg $p |- ( ( U e. NrmCVec /\ W e. H ) -> F = ( G |` ( Y X. Y ) ) ) $=
      cU cnv wcel cW cH wcel wa cF cG cY cY cxp cres wceq cY cY cxp cY cY cxp
      wceq vx cv vy cv cF co vx cv vy cv cG cY cY cxp cres co wceq vy cY wral
      vx cY wral wa cU cnv wcel cW cH wcel wa vx cv vy cv cF co vx cv vy cv cG
      cY cY cxp cres co wceq vy cY wral vx cY wral cY cY cxp cY cY cxp wceq cU
      cnv wcel cW cH wcel wa vx cv vy cv cF co vx cv vy cv cG cY cY cxp cres co
      wceq vx vy cY cY cU cnv wcel cW cH wcel wa vx cv cY wcel vy cv cY wcel wa
      vx cv vy cv cF co vx cv vy cv cG cY cY cxp cres co wceq cU cnv wcel cW cH
      wcel wa vx cv cY wcel vy cv cY wcel wa wa vx cv vy cv cG cY cY cxp cres
      co vx cv vy cv cF co cG cY cY cxp cres wfun cF cY cY cxp wfn cF cG cY cY
      cxp cres wss w3a vx cv cY wcel vy cv cY wcel wa vx cv vy cv cG cY cY cxp
      cres co vx cv vy cv cF co wceq cU cnv wcel cW cH wcel wa vx cv vy cv cY
      cY cG cY cY cxp cres cF oprssoprv cU cnv wcel cW cH wcel wa cG cY cY cxp
      cres wfun cF cY cY cxp wfn cF cG cY cY cxp cres wss cU cnv wcel cG cY cY
      cxp cres wfun cW cH wcel cU cnv wcel cU cba cfv cU cba cfv cxp cU cba cfv
      cG wf cG wfun cG cY cY cxp cres wfun cU cG cU cba cfv cU cba cfv eqid
      sspg.g nvgf cU cba cfv cU cba cfv cxp cU cba cfv cG ffun cY cY cxp cG
      funres 3syl adantr cU cnv wcel cW cH wcel wa cW cnv wcel cY cY cxp cY cF
      wf cF cY cY cxp wfn cU cH cW sspg.h sspnv cW cF cY sspg.y sspg.f nvgf cY
      cY cxp cY cF ffn 3syl cU cnv wcel cW cH wcel wa cF cF cY cY cxp cres cG
      cY cY cxp cres cU cnv wcel cW cH wcel wa cY cY cxp cY cF wf cF cY cY cxp
      wfn cF cY cY cxp cres cF wceq cU cnv wcel cW cH wcel wa cW cnv wcel cY cY
      cxp cY cF wf cU cH cW sspg.h sspnv cW cF cY sspg.y sspg.f nvgf syl cY cY
      cxp cY cF ffn cY cY cxp cF fnresdm 3syl cU cnv wcel cW cH wcel wa cF cG
      wss cW cns cfv cU cns cfv wss cW cnm cfv cU cnm cfv wss w3a cF cG wss cF
      cY cY cxp cres cG cY cY cxp cres wss cU cnv wcel cW cH wcel cW cnv wcel
      cF cG wss cW cns cfv cU cns cfv wss cW cnm cfv cU cnm cfv wss w3a cW cns
      cfv cU cns cfv cU cF cG cH cW cnm cfv cU cnm cfv cW sspg.g sspg.f cU cns
      cfv eqid cW cns cfv eqid cU cnm cfv eqid cW cnm cfv eqid sspg.h isssp
      pm3.27bda cF cG wss cW cns cfv cU cns cfv wss cW cnm cfv cU cnm cfv wss
      3simp1 cF cG cY cY cxp ssres 3syl eqsstr3d 3jca sylan eqcomd ex
      r19.21aivv cY cY cxp eqid jctil cF cY cY cxp wfn cG cY cY cxp cres cY cY
      cxp wfn cF cG cY cY cxp cres wceq cY cY cxp cY cY cxp wceq vx cv vy cv cF
      co vx cv vy cv cG cY cY cxp cres co wceq vy cY wral vx cY wral wa wb cU
      cnv wcel cW cH wcel wa vx vy cY cY cY cY cF cG cY cY cxp cres eqfnoprv cU
      cnv wcel cW cH wcel wa cW cnv wcel cY cY cxp cY cF wf cF cY cY cxp wfn cU
      cH cW sspg.h sspnv cW cF cY sspg.y sspg.f nvgf cY cY cxp cY cF ffn 3syl
      cG cU cba cfv cU cba cfv cxp wfn cY cY cxp cU cba cfv cU cba cfv cxp wss
      cG cY cY cxp cres cY cY cxp wfn cU cnv wcel cW cH wcel wa cU cba cfv cU
      cba cfv cxp cY cY cxp cG fnssres cU cnv wcel cG cU cba cfv cU cba cfv cxp
      wfn cW cH wcel cU cnv wcel cU cba cfv cU cba cfv cxp cU cba cfv cG wf cG
      cU cba cfv cU cba cfv cxp wfn cU cG cU cba cfv cU cba cfv eqid sspg.g
      nvgf cU cba cfv cU cba cfv cxp cU cba cfv cG ffn syl adantr cY cU cba cfv
      wss cY cU cba cfv wss cY cY cxp cU cba cfv cU cba cfv cxp wss cU cnv wcel
      cW cH wcel wa cY cU cba cfv cY cU cba cfv ssxp cU cH cW cU cba cfv cY cU
      cba cfv eqid sspg.y sspg.h sspba cU cH cW cU cba cfv cY cU cba cfv eqid
      sspg.y sspg.h sspba sylanc sylanc sylanc mpbird $.
      $( [1-Feb-2008] $) $( [28-Jan-2008] $)

    $( Vector addition on a subspace in terms of vector addition on the parent
       space. $)
    sspgval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A F B ) = ( A G B ) ) $=
      cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa cA cB cF co cA cB cG
      cY cY cxp cres co cA cB cG co cU cnv wcel cW cH wcel wa cF cG cY cY cxp
      cres cA cB cU cF cG cH cW cY sspg.y sspg.g sspg.f sspg.h sspg opreqd cA
      cB cY cY cG oprvres sylan9eq $.
      $( [2-Feb-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    $d x y R $.  $d x y S $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    ssps.y $e |- Y = ( BaseSet ` W ) $.
    ssps.s $e |- S = ( .s ` U ) $.
    ssps.r $e |- R = ( .s ` W ) $.
    ssps.h $e |- H = ( SubSp ` U ) $.
    $( Scalar multiplication on a subspace is a restriction of scalar
       multiplication on the parent space. $)
    ssps $p |- ( ( U e. NrmCVec /\ W e. H ) -> R = ( S |` ( CC X. Y ) ) ) $=
      cU cnv wcel cW cH wcel wa cR cS cc cY cxp cres wceq cc cY cxp cc cY cxp
      wceq vx cv vy cv cR co vx cv vy cv cS cc cY cxp cres co wceq vy cY wral
      vx cc wral wa cU cnv wcel cW cH wcel wa vx cv vy cv cR co vx cv vy cv cS
      cc cY cxp cres co wceq vy cY wral vx cc wral cc cY cxp cc cY cxp wceq cU
      cnv wcel cW cH wcel wa vx cv vy cv cR co vx cv vy cv cS cc cY cxp cres co
      wceq vx vy cc cY cU cnv wcel cW cH wcel wa vx cv cc wcel vy cv cY wcel wa
      vx cv vy cv cR co vx cv vy cv cS cc cY cxp cres co wceq cU cnv wcel cW cH
      wcel wa vx cv cc wcel vy cv cY wcel wa wa vx cv vy cv cS cc cY cxp cres
      co vx cv vy cv cR co cS cc cY cxp cres wfun cR cc cY cxp wfn cR cS cc cY
      cxp cres wss w3a vx cv cc wcel vy cv cY wcel wa vx cv vy cv cS cc cY cxp
      cres co vx cv vy cv cR co wceq cU cnv wcel cW cH wcel wa vx cv vy cv cc
      cY cS cc cY cxp cres cR oprssoprv cU cnv wcel cW cH wcel wa cS cc cY cxp
      cres wfun cR cc cY cxp wfn cR cS cc cY cxp cres wss cU cnv wcel cS cc cY
      cxp cres wfun cW cH wcel cU cnv wcel cc cU cba cfv cxp cU cba cfv cS wf
      cS wfun cS cc cY cxp cres wfun cS cU cU cba cfv cU cba cfv eqid ssps.s
      nvsf cc cU cba cfv cxp cU cba cfv cS ffun cc cY cxp cS funres 3syl adantr
      cU cnv wcel cW cH wcel wa cW cnv wcel cc cY cxp cY cR wf cR cc cY cxp wfn
      cU cH cW ssps.h sspnv cR cW cY ssps.y ssps.r nvsf cc cY cxp cY cR ffn
      3syl cU cnv wcel cW cH wcel wa cR cR cc cY cxp cres cS cc cY cxp cres cU
      cnv wcel cW cH wcel wa cc cY cxp cY cR wf cR cc cY cxp wfn cR cc cY cxp
      cres cR wceq cU cnv wcel cW cH wcel wa cW cnv wcel cc cY cxp cY cR wf cU
      cH cW ssps.h sspnv cR cW cY ssps.y ssps.r nvsf syl cc cY cxp cY cR ffn cc
      cY cxp cR fnresdm 3syl cU cnv wcel cW cH wcel wa cW cpv cfv cU cpv cfv
      wss cR cS wss cW cnm cfv cU cnm cfv wss w3a cR cS wss cR cc cY cxp cres
      cS cc cY cxp cres wss cU cnv wcel cW cH wcel cW cnv wcel cW cpv cfv cU
      cpv cfv wss cR cS wss cW cnm cfv cU cnm cfv wss w3a cR cS cU cW cpv cfv
      cU cpv cfv cH cW cnm cfv cU cnm cfv cW cU cpv cfv eqid cW cpv cfv eqid
      ssps.s ssps.r cU cnm cfv eqid cW cnm cfv eqid ssps.h isssp pm3.27bda cW
      cpv cfv cU cpv cfv wss cR cS wss cW cnm cfv cU cnm cfv wss 3simp2 cR cS
      cc cY cxp ssres 3syl eqsstr3d 3jca sylan eqcomd ex r19.21aivv cc cY cxp
      eqid jctil cR cc cY cxp wfn cS cc cY cxp cres cc cY cxp wfn cR cS cc cY
      cxp cres wceq cc cY cxp cc cY cxp wceq vx cv vy cv cR co vx cv vy cv cS
      cc cY cxp cres co wceq vy cY wral vx cc wral wa wb cU cnv wcel cW cH wcel
      wa vx vy cc cY cc cY cR cS cc cY cxp cres eqfnoprv cU cnv wcel cW cH wcel
      wa cW cnv wcel cc cY cxp cY cR wf cR cc cY cxp wfn cU cH cW ssps.h sspnv
      cR cW cY ssps.y ssps.r nvsf cc cY cxp cY cR ffn 3syl cS cc cU cba cfv cxp
      wfn cc cY cxp cc cU cba cfv cxp wss cS cc cY cxp cres cc cY cxp wfn cU
      cnv wcel cW cH wcel wa cc cU cba cfv cxp cc cY cxp cS fnssres cU cnv wcel
      cS cc cU cba cfv cxp wfn cW cH wcel cU cnv wcel cc cU cba cfv cxp cU cba
      cfv cS wf cS cc cU cba cfv cxp wfn cS cU cU cba cfv cU cba cfv eqid
      ssps.s nvsf cc cU cba cfv cxp cU cba cfv cS ffn syl adantr cc cc wss cY
      cU cba cfv wss cc cY cxp cc cU cba cfv cxp wss cU cnv wcel cW cH wcel wa
      cc cc cY cU cba cfv ssxp cc cc wss cU cnv wcel cW cH wcel wa cc ssid a1i
      cU cH cW cU cba cfv cY cU cba cfv eqid ssps.y ssps.h sspba sylanc sylanc
      sylanc mpbird $.
      $( [5-Feb-2008] $) $( [28-Jan-2008] $)

    $( Scalar multiplication on a subspace in terms of scalar multiplication
       on the parent space. $)
    sspsval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. CC /\ B e. Y ) ) ->
                    ( A R B ) = ( A S B ) ) $=
      cU cnv wcel cW cH wcel wa cA cc wcel cB cY wcel wa cA cB cR co cA cB cS
      cc cY cxp cres co cA cB cS co cU cnv wcel cW cH wcel wa cR cS cc cY cxp
      cres cA cB cR cS cU cH cW cY ssps.y ssps.s ssps.r ssps.h ssps opreqd cA
      cB cc cY cS oprvres sylan9eq $.
      $( [6-Feb-2008] $) $( [28-Jan-2008] $)
  $}

  $( MAY BE REVISED - sspvallem doesn't save space yet, but might if another
     operation is added. $)
  $(
  @{
    @d x y F @.  @d x y G @.  @d x y H @.  @d x y U @.  @d x y W @.
    @d x y Y @.
    sspvallem.y @e |- Y = ( BaseSet ` W ) @.
    sspvallem.h @e |- H = ( SubSp ` U ) @.
    @{
      sspvallem.1 @e |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y )
         ) -> R = S ) @.
      sspvallem.2 @e |- ( ( W e. NrmCVec /\ A e. Y /\ B e. Y ) -> P = R ) @.
      sspvallem.3 @e |- ( ( U e. NrmCVec /\ A e. ( BaseSet ` U ) /\
          B e. ( BaseSet ` U ) ) -> Q = S ) @.
      @( Lemma for ~ sspmval and others. @)
      sspvallem @p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) )
          -> P = Q ) @=
        ( cnv wcel wa wceq 3expb sspnv sylan cba cfv eqid sspba sseld anim12d
        imp adantlr syldan 3eqtr4d ) GPQZIHQZRZAJQZBJQZRZREFCDMIPQZURCESZUOUSUP
        UQUTNTGHILUAUBUOURAGUCUDZQZBVAQZRZDFSZUOURVDUOUPVBUQVCUOJVAAGHIVAJVAUEK
        LUFZUGUOJVABVFUGUHUIUMVDVEUNUMVBVCVEOTUJUKUL @.
        @( [?] @) @( [1-Feb-2008] @)
    @}

    @{
      sspmlem.1  @e |- ( ( ( U e. NrmCVec /\ W e. H ) /\ (
       x e. Y /\ y e. Y ) ) -> ( x F y ) = ( x G y ) ) @.
      sspmlem.2 @e |- ( W e. NrmCVec -> F : ( Y X. Y ) --> R ) @.
      sspmlem.3 @e |- ( U e. NrmCVec -> G : ( ( BaseSet ` U ) X.
               ( BaseSet ` U ) ) --> S ) @.
      @( Lemma for ~ sspm and others. @)
      sspmlem @p |- ( ( U e. NrmCVec /\ W e. H ) ->
            F = ( G |` ( Y X. Y ) ) ) @=
        ( cnv wcel wa cxp cres wceq cv co wral oprvres adantl eqtr4d ex
        r19.21aivv eqid jctil wfn wb eqfnoprv wf sspnv ffn 3syl cba cfv wss
        fnssres syl adantr sspba ssxp anidms sylanc mpbird ) EPQZIHQZRZFGJJSZTZ
        UAZVMVMUAZAUBZBUBZFUCZVQVRVNUCZUAZBJUDAJUDZRZVLWBVPVLWAABJJVLVQJQVRJQRZ
        WAVLWDRVSVQVRGUCZVTMWDVTWEUAVLVQVRJJGUEUFUGUHUIVMUJUKFVMULZVNVMULZVOWCU
        MVLABJJJJFVNUNVLIPQVMCFUOWFEHILUPNVMCFUQURGEUSUTZWHSZULZVMWIVAZWGVLWIVM
        GVBVJWJVKVJWIDGUOWJOWIDGUQVCVDVLJWHVAZWKEHIWHJWHUJKLVEWLWKJWHJWHVFVGVCV
        HVHVI @.
        @( [?] @) @( [1-Feb-2008] @)
    @}
  @}
  $)

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspmlem.y $e |- Y = ( BaseSet ` W ) $.
    sspmlem.h $e |- H = ( SubSp ` U ) $.
    sspmlem.1  $e |- ( ( ( U e. NrmCVec /\ W e. H ) /\ (
             x e. Y /\ y e. Y ) ) -> ( x F y ) = ( x G y ) ) $.
    sspmlem.2 $e |- ( W e. NrmCVec -> F : ( Y X. Y ) --> R ) $.
    sspmlem.3 $e |- ( U e. NrmCVec -> G : ( ( BaseSet ` U ) X.
             ( BaseSet ` U ) ) --> S ) $.
    $( Lemma for ~ sspm and others. $)
    sspmlem $p |- ( ( U e. NrmCVec /\ W e. H ) -> F = ( G |` ( Y X. Y ) ) ) $=
      cU cnv wcel cW cH wcel wa cF cG cY cY cxp cres wceq cY cY cxp cY cY cxp
      wceq vx cv vy cv cF co vx cv vy cv cG cY cY cxp cres co wceq vy cY wral
      vx cY wral wa cU cnv wcel cW cH wcel wa vx cv vy cv cF co vx cv vy cv cG
      cY cY cxp cres co wceq vy cY wral vx cY wral cY cY cxp cY cY cxp wceq cU
      cnv wcel cW cH wcel wa vx cv vy cv cF co vx cv vy cv cG cY cY cxp cres co
      wceq vx vy cY cY cU cnv wcel cW cH wcel wa vx cv cY wcel vy cv cY wcel wa
      vx cv vy cv cF co vx cv vy cv cG cY cY cxp cres co wceq cU cnv wcel cW cH
      wcel wa vx cv cY wcel vy cv cY wcel wa wa vx cv vy cv cF co vx cv vy cv
      cG co vx cv vy cv cG cY cY cxp cres co sspmlem.1 vx cv cY wcel vy cv cY
      wcel wa vx cv vy cv cG cY cY cxp cres co vx cv vy cv cG co wceq cU cnv
      wcel cW cH wcel wa vx cv vy cv cY cY cG oprvres adantl eqtr4d ex
      r19.21aivv cY cY cxp eqid jctil cF cY cY cxp wfn cG cY cY cxp cres cY cY
      cxp wfn cF cG cY cY cxp cres wceq cY cY cxp cY cY cxp wceq vx cv vy cv cF
      co vx cv vy cv cG cY cY cxp cres co wceq vy cY wral vx cY wral wa wb cU
      cnv wcel cW cH wcel wa vx vy cY cY cY cY cF cG cY cY cxp cres eqfnoprv cU
      cnv wcel cW cH wcel wa cW cnv wcel cY cY cxp cR cF wf cF cY cY cxp wfn cU
      cH cW sspmlem.h sspnv sspmlem.2 cY cY cxp cR cF ffn 3syl cG cU cba cfv cU
      cba cfv cxp wfn cY cY cxp cU cba cfv cU cba cfv cxp wss cG cY cY cxp cres
      cY cY cxp wfn cU cnv wcel cW cH wcel wa cU cba cfv cU cba cfv cxp cY cY
      cxp cG fnssres cU cnv wcel cG cU cba cfv cU cba cfv cxp wfn cW cH wcel cU
      cnv wcel cU cba cfv cU cba cfv cxp cS cG wf cG cU cba cfv cU cba cfv cxp
      wfn sspmlem.3 cU cba cfv cU cba cfv cxp cS cG ffn syl adantr cU cnv wcel
      cW cH wcel wa cY cU cba cfv wss cY cY cxp cU cba cfv cU cba cfv cxp wss
      cU cH cW cU cba cfv cY cU cba cfv eqid sspmlem.y sspmlem.h sspba cY cU
      cba cfv wss cY cY cxp cU cba cfv cU cba cfv cxp wss cY cU cba cfv cY cU
      cba cfv ssxp anidms syl sylanc sylanc mpbird $.
      $( [22-Feb-2008] $) $( [1-Feb-2008] $)
  $}

  ${
    $d x y L $.  $d x y M $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspm.y $e |- Y = ( BaseSet ` W ) $.
    sspm.m $e |- M = ( -v ` U ) $.
    sspm.l $e |- L = ( -v ` W ) $.
    sspm.h $e |- H = ( SubSp ` U ) $.
    $( Vector addition on a subspace in terms of vector addition on the parent
       space. $)
    sspmval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A L B ) = ( A M B ) ) $=
      cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa cA c1 cneg cB cW
      cns cfv co cW cpv cfv co cA c1 cneg cB cU cns cfv co cU cpv cfv co cA cB
      cL co cA cB cM co cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa
      cA c1 cneg cB cW cns cfv co cW cpv cfv co cA c1 cneg cB cW cns cfv co cU
      cpv cfv co cA c1 cneg cB cU cns cfv co cU cpv cfv co cU cnv wcel cW cH
      wcel wa cA cY wcel cB cY wcel wa cA cY wcel c1 cneg cB cW cns cfv co cY
      wcel wa cA c1 cneg cB cW cns cfv co cW cpv cfv co cA c1 cneg cB cW cns
      cfv co cU cpv cfv co wceq cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel
      wa cA cY wcel c1 cneg cB cW cns cfv co cY wcel wa cU cnv wcel cW cH wcel
      wa cB cY wcel c1 cneg cB cW cns cfv co cY wcel cA cY wcel cU cnv wcel cW
      cH wcel wa cW cnv wcel cB cY wcel c1 cneg cB cW cns cfv co cY wcel wi cU
      cH cW sspm.h sspnv cW cnv wcel cB cY wcel c1 cneg cB cW cns cfv co cY
      wcel cW cnv wcel c1 cneg cc wcel cB cY wcel c1 cneg cB cW cns cfv co cY
      wcel c1 ax1cn negcli c1 cneg cB cW cns cfv cW cY sspm.y cW cns cfv eqid
      nvscl mp3an2 ex syl anim2d imp cA c1 cneg cB cW cns cfv co cU cW cpv cfv
      cU cpv cfv cH cW cY sspm.y cU cpv cfv eqid cW cpv cfv eqid sspm.h sspgval
      syldan cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa c1 cneg cB
      cW cns cfv co c1 cneg cB cU cns cfv co cA cU cpv cfv cU cnv wcel cW cH
      wcel wa cB cY wcel c1 cneg cB cW cns cfv co c1 cneg cB cU cns cfv co wceq
      cA cY wcel cU cnv wcel cW cH wcel wa c1 cneg cc wcel cB cY wcel c1 cneg
      cB cW cns cfv co c1 cneg cB cU cns cfv co wceq c1 ax1cn negcli c1 cneg cB
      cW cns cfv cU cns cfv cU cH cW cY sspm.y cU cns cfv eqid cW cns cfv eqid
      sspm.h sspsval mpanr1 adantrl opreq2d eqtrd cW cnv wcel cA cY wcel cB cY
      wcel wa cA cB cL co cA c1 cneg cB cW cns cfv co cW cpv cfv co wceq cU cnv
      wcel cW cH wcel wa cW cnv wcel cA cY wcel cB cY wcel cA cB cL co cA c1
      cneg cB cW cns cfv co cW cpv cfv co wceq cA cB cW cns cfv cW cW cpv cfv
      cL cY sspm.y cW cpv cfv eqid cW cns cfv eqid sspm.l nvmval 3expb cU cH cW
      sspm.h sspnv sylan cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa cA
      cU cba cfv wcel cB cU cba cfv wcel wa cA cB cM co cA c1 cneg cB cU cns
      cfv co cU cpv cfv co wceq cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel
      wa cA cU cba cfv wcel cB cU cba cfv wcel wa cU cnv wcel cW cH wcel wa cA
      cY wcel cA cU cba cfv wcel cB cY wcel cB cU cba cfv wcel cU cnv wcel cW
      cH wcel wa cY cU cba cfv cA cU cH cW cU cba cfv cY cU cba cfv eqid sspm.y
      sspm.h sspba sseld cU cnv wcel cW cH wcel wa cY cU cba cfv cB cU cH cW cU
      cba cfv cY cU cba cfv eqid sspm.y sspm.h sspba sseld anim12d imp cU cnv
      wcel cA cU cba cfv wcel cB cU cba cfv wcel wa cA cB cM co cA c1 cneg cB
      cU cns cfv co cU cpv cfv co wceq cW cH wcel cU cnv wcel cA cU cba cfv
      wcel cB cU cba cfv wcel cA cB cM co cA c1 cneg cB cU cns cfv co cU cpv
      cfv co wceq cA cB cU cns cfv cU cU cpv cfv cM cU cba cfv cU cba cfv eqid
      cU cpv cfv eqid cU cns cfv eqid sspm.m nvmval 3expb adantlr syldan
      3eqtr4d $.
      $( [10-Feb-2008] $) $( [28-Jan-2008] $)

    $( Vector subtraction on a subspace is a restriction of vector subtraction
       on the parent space. $)
    sspm $p |- ( ( U e. NrmCVec /\ W e. H ) -> L = ( M |` ( Y X. Y ) ) ) $=
      vx vy cY cU cba cfv cU cL cM cH cW cY sspm.y sspm.h vx cv vy cv cU cH cL
      cM cW cY sspm.y sspm.m sspm.l sspm.h sspmval cW cL cY sspm.y sspm.l nvmf
      cU cM cU cba cfv cU cba cfv eqid sspm.m nvmf sspmlem $.
      $( [29-Mar-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspz.z $e |- Z = ( 0v ` U ) $.
    sspz.q $e |- Q = ( 0v ` W ) $.
    sspz.h $e |- H = ( SubSp ` U ) $.
    $( The zero vector of a subspace is the same as the parent's. $)
    sspz $p |- ( ( U e. NrmCVec /\ W e. H ) -> Q = Z ) $=
      cU cnv wcel cW cH wcel wa cQ cQ cW cnsb cfv co cQ cQ cU cnsb cfv co cQ cZ
      cU cnv wcel cW cH wcel wa cQ cW cba cfv wcel cQ cW cba cfv wcel wa cQ cQ
      cW cnsb cfv co cQ cQ cU cnsb cfv co wceq cU cnv wcel cW cH wcel wa cW cnv
      wcel cQ cW cba cfv wcel cQ cW cba cfv wcel wa cU cH cW sspz.h sspnv cW
      cnv wcel cQ cW cba cfv wcel cQ cW cba cfv wcel cW cW cba cfv cQ cW cba
      cfv eqid sspz.q nvzcl cW cW cba cfv cQ cW cba cfv eqid sspz.q nvzcl jca
      syl cQ cQ cU cH cW cnsb cfv cU cnsb cfv cW cW cba cfv cW cba cfv eqid cU
      cnsb cfv eqid cW cnsb cfv eqid sspz.h sspmval mpdan cW cnv wcel cQ cW cba
      cfv wcel cQ cQ cW cnsb cfv co cQ wceq cU cnv wcel cW cH wcel wa cQ cW cW
      cnsb cfv cW cba cfv cQ cW cba cfv eqid cW cnsb cfv eqid sspz.q nvmid cU
      cH cW sspz.h sspnv cU cnv wcel cW cH wcel wa cW cnv wcel cQ cW cba cfv
      wcel cU cH cW sspz.h sspnv cW cW cba cfv cQ cW cba cfv eqid sspz.q nvzcl
      syl sylanc cU cnv wcel cW cH wcel cQ cU cba cfv wcel cQ cQ cU cnsb cfv co
      cZ wceq cU cnv wcel cW cH wcel wa cW cba cfv cU cba cfv cQ cU cH cW cU
      cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid sspz.h sspba cU cnv
      wcel cW cH wcel wa cW cnv wcel cQ cW cba cfv wcel cU cH cW sspz.h sspnv
      cW cW cba cfv cQ cW cba cfv eqid sspz.q nvzcl syl sseldd cQ cU cU cnsb
      cfv cU cba cfv cZ cU cba cfv eqid cU cnsb cfv eqid sspz.z nvmid syldan
      3eqtr3d $.
      $( [24-Feb-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    $d x H $.  $d x M $.  $d x N $.  $d x U $.  $d x W $.  $d x Y $.
    sspn.y $e |- Y = ( BaseSet ` W ) $.
    sspn.n $e |- N = ( norm ` U ) $.
    sspn.m $e |- M = ( norm ` W ) $.
    sspn.h $e |- H = ( SubSp ` U ) $.
    $( The norm on a subspace is a restriction of the norm on the parent
       space. $)
    sspn $p |- ( ( U e. NrmCVec /\ W e. H ) -> M = ( N |` Y ) ) $=
      cU cnv wcel cW cH wcel wa cM cN cY cres wceq vx cv cM cfv vx cv cN cY
      cres cfv wceq vx cY wral cU cnv wcel cW cH wcel wa vx cv cM cfv vx cv cN
      cY cres cfv wceq vx cY cU cnv wcel cW cH wcel wa vx cv cY wcel wa vx cv
      cN cY cres cfv vx cv cM cfv cN cY cres wfun cM cN cY cres wss vx cv cM
      cdm wcel vx cv cN cY cres cfv vx cv cM cfv wceq cU cnv wcel cW cH wcel wa
      vx cv cY wcel wa vx cv cN cY cres cM funssfv cU cnv wcel cN cY cres wfun
      cW cH wcel vx cv cY wcel cU cnv wcel cU cba cfv cr cN wf cN wfun cN cY
      cres wfun cU cN cU cba cfv cU cba cfv eqid sspn.n nvf cU cba cfv cr cN
      ffun cY cN funres 3syl ad2antrr cU cnv wcel cW cH wcel wa cM cN cY cres
      wss vx cv cY wcel cU cnv wcel cW cH wcel wa cM cM cY cres cN cY cres cU
      cnv wcel cW cH wcel wa cY cr cM wf cM cY wfn cM cY cres cM wceq cU cnv
      wcel cW cH wcel wa cW cnv wcel cY cr cM wf cU cH cW sspn.h sspnv cW cM cY
      sspn.y sspn.m nvf syl cY cr cM ffn cY cM fnresdm 3syl cU cnv wcel cW cH
      wcel wa cW cpv cfv cU cpv cfv wss cW cns cfv cU cns cfv wss cM cN wss w3a
      cM cN wss cM cY cres cN cY cres wss cU cnv wcel cW cH wcel cW cnv wcel cW
      cpv cfv cU cpv cfv wss cW cns cfv cU cns cfv wss cM cN wss w3a cW cns cfv
      cU cns cfv cU cW cpv cfv cU cpv cfv cH cM cN cW cU cpv cfv eqid cW cpv
      cfv eqid cU cns cfv eqid cW cns cfv eqid sspn.n sspn.m sspn.h isssp
      pm3.27bda cW cpv cfv cU cpv cfv wss cW cns cfv cU cns cfv wss cM cN wss
      3simp3 cM cN cY ssres 3syl eqsstr3d adantr cW cnv wcel vx cv cY wcel vx
      cv cM cdm wcel cU cnv wcel cW cH wcel wa cW cnv wcel vx cv cM cdm wcel vx
      cv cY wcel cW cnv wcel cM cdm cY vx cv cW cnv wcel cY cr cM wf cM cdm cY
      wceq cW cM cY sspn.y sspn.m nvf cY cr cM fdm syl eleq2d biimpar cU cH cW
      sspn.h sspnv sylan syl3anc eqcomd r19.21aiva cM cY wfn cN cY cres cY wfn
      cM cN cY cres wceq vx cv cM cfv vx cv cN cY cres cfv wceq vx cY wral wb
      cU cnv wcel cW cH wcel wa vx cY cM cN cY cres eqfnfv2 cU cnv wcel cW cH
      wcel wa cW cnv wcel cY cr cM wf cM cY wfn cU cH cW sspn.h sspnv cW cM cY
      sspn.y sspn.m nvf cY cr cM ffn 3syl cN cU cba cfv wfn cY cU cba cfv wss
      cN cY cres cY wfn cU cnv wcel cW cH wcel wa cU cba cfv cY cN fnssres cU
      cnv wcel cN cU cba cfv wfn cW cH wcel cU cnv wcel cU cba cfv cr cN wf cN
      cU cba cfv wfn cU cN cU cba cfv cU cba cfv eqid sspn.n nvf cU cba cfv cr
      cN ffn syl adantr cU cH cW cU cba cfv cY cU cba cfv eqid sspn.y sspn.h
      sspba sylanc sylanc mpbird $.
      $( [7-Feb-2008] $) $( [28-Jan-2008] $)

    $( The norm on a subspace in terms of the norm on the parent space. $)
    sspnval $p |- ( ( U e. NrmCVec /\ W e. H /\ A e. Y ) ->
                    ( M ` A ) = ( N ` A ) ) $=
      cU cnv wcel cW cH wcel cA cY wcel cA cM cfv cA cN cfv wceq cU cnv wcel cW
      cH wcel wa cA cY wcel cA cM cfv cA cN cY cres cfv cA cN cfv cU cnv wcel
      cW cH wcel wa cA cM cN cY cres cU cH cM cN cW cY sspn.y sspn.n sspn.m
      sspn.h sspn fveq1d cA cY cN fvres sylan9eq 3impa $.
      $( [8-Feb-2008] $) $( [28-Jan-2008] $)
  $}


  ${
    $d k A $.  $d k B $.  $d k x y H $.  $d x y P $.  $d x y Q $.
    $d k x y U $.  $d k x y W $.  $d k x y Y $.
    sspi.y $e |- Y = ( BaseSet ` W ) $.
    sspi.p $e |- P = ( .i ` U ) $.
    sspi.q $e |- Q = ( .i ` W ) $.
    sspi.h $e |- H = ( SubSp ` U ) $.
    $( The inner product on a subspace in terms of the inner product on the
       parent space. $)
    sspival $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A Q B ) = ( A P B ) ) $=
      cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa c1 c4 cfz co ci vk
      cv cexp co cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cW cnm cfv
      cfv c2 cexp co cmul co vk csu c4 cdiv co c1 c4 cfz co ci vk cv cexp co cA
      ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co
      cmul co vk csu c4 cdiv co cA cB cQ co cA cB cP co cU cnv wcel cW cH wcel
      wa cA cY wcel cB cY wcel wa wa c1 c4 cfz co ci vk cv cexp co cA ci vk cv
      cexp co cB cW cns cfv co cW cpv cfv co cW cnm cfv cfv c2 cexp co cmul co
      vk csu c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co
      cU cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv cU cnv
      wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa c1 c4 cfz co ci vk cv cexp
      co cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cW cnm cfv cfv c2
      cexp co cmul co ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk cU cnv wcel cW cH wcel wa
      cA cY wcel cB cY wcel wa wa vk cv c1 c4 cfz co wcel wa cA ci vk cv cexp
      co cB cW cns cfv co cW cpv cfv co cW cnm cfv cfv c2 cexp co cA ci vk cv
      cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv c2 cexp co ci vk cv
      cexp co cmul cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa vk cv
      c1 c4 cfz co wcel wa cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co
      cW cnm cfv cfv cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm
      cfv cfv c2 cexp cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa vk cv
      c1 c4 cfz co wcel cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cW
      cnm cfv cfv cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv
      cfv wceq cU cnv wcel cW cH wcel wa cA cY wcel ci vk cv cexp co cc wcel cB
      cY wcel wa wa cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cW cnm
      cfv cfv cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      wceq cA cY wcel cB cY wcel wa vk cv c1 c4 cfz co wcel wa cU cnv wcel cW
      cH wcel wa cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa wa wa cA ci
      vk cv cexp co cB cW cns cfv co cW cpv cfv co cW cnm cfv cfv cA ci vk cv
      cexp co cB cW cns cfv co cW cpv cfv co cU cnm cfv cfv cA ci vk cv cexp co
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv cU cnv wcel cW cH wcel wa
      cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa wa cA ci vk cv cexp co
      cB cW cns cfv co cW cpv cfv co cY wcel cA ci vk cv cexp co cB cW cns cfv
      co cW cpv cfv co cW cnm cfv cfv cA ci vk cv cexp co cB cW cns cfv co cW
      cpv cfv co cU cnm cfv cfv wceq cW cnv wcel cA cY wcel ci vk cv cexp co cc
      wcel cB cY wcel wa wa cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co
      cY wcel cU cnv wcel cW cH wcel wa cW cnv wcel cA cY wcel ci vk cv cexp co
      cc wcel cB cY wcel wa wa cA cY wcel ci vk cv cexp co cB cW cns cfv co cY
      wcel wa cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cY wcel cW cnv
      wcel cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa wa cA cY wcel ci
      vk cv cexp co cB cW cns cfv co cY wcel wa cW cnv wcel ci vk cv cexp co cc
      wcel cB cY wcel wa ci vk cv cexp co cB cW cns cfv co cY wcel cA cY wcel
      cW cnv wcel ci vk cv cexp co cc wcel cB cY wcel ci vk cv cexp co cB cW
      cns cfv co cY wcel ci vk cv cexp co cB cW cns cfv cW cY sspi.y cW cns cfv
      eqid nvscl 3expib anim2d imp cW cnv wcel cA cY wcel ci vk cv cexp co cB
      cW cns cfv co cY wcel cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co
      cY wcel cA ci vk cv cexp co cB cW cns cfv co cW cW cpv cfv cY sspi.y cW
      cpv cfv eqid nvgcl 3expb syldan cU cH cW sspi.h sspnv sylan cU cnv wcel
      cW cH wcel cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cY wcel cA
      ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cW cnm cfv cfv cA ci vk
      cv cexp co cB cW cns cfv co cW cpv cfv co cU cnm cfv cfv wceq cA ci vk cv
      cexp co cB cW cns cfv co cW cpv cfv co cU cH cW cnm cfv cU cnm cfv cW cY
      sspi.y cU cnm cfv eqid cW cnm cfv eqid sspi.h sspnval 3expa syldan cU cnv
      wcel cW cH wcel wa cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa wa
      wa cA ci vk cv cexp co cB cW cns cfv co cW cpv cfv co cA ci vk cv cexp co
      cB cU cns cfv co cU cpv cfv co cU cnm cfv cU cnv wcel cW cH wcel wa cA cY
      wcel ci vk cv cexp co cc wcel cB cY wcel wa wa wa cA ci vk cv cexp co cB
      cW cns cfv co cW cpv cfv co cA ci vk cv cexp co cB cW cns cfv co cU cpv
      cfv co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnv wcel cW
      cH wcel wa cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa wa cA cY
      wcel ci vk cv cexp co cB cW cns cfv co cY wcel wa cA ci vk cv cexp co cB
      cW cns cfv co cW cpv cfv co cA ci vk cv cexp co cB cW cns cfv co cU cpv
      cfv co wceq cU cnv wcel cW cH wcel wa cA cY wcel ci vk cv cexp co cc wcel
      cB cY wcel wa wa cA cY wcel ci vk cv cexp co cB cW cns cfv co cY wcel wa
      cU cnv wcel cW cH wcel wa ci vk cv cexp co cc wcel cB cY wcel wa ci vk cv
      cexp co cB cW cns cfv co cY wcel cA cY wcel cU cnv wcel cW cH wcel wa cW
      cnv wcel ci vk cv cexp co cc wcel cB cY wcel wa ci vk cv cexp co cB cW
      cns cfv co cY wcel wi cU cH cW sspi.h sspnv cW cnv wcel ci vk cv cexp co
      cc wcel cB cY wcel ci vk cv cexp co cB cW cns cfv co cY wcel ci vk cv
      cexp co cB cW cns cfv cW cY sspi.y cW cns cfv eqid nvscl 3expib syl
      anim2d imp cA ci vk cv cexp co cB cW cns cfv co cU cW cpv cfv cU cpv cfv
      cH cW cY sspi.y cU cpv cfv eqid cW cpv cfv eqid sspi.h sspgval syldan cU
      cnv wcel cW cH wcel wa cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa
      wa wa ci vk cv cexp co cB cW cns cfv co ci vk cv cexp co cB cU cns cfv co
      cA cU cpv cfv cU cnv wcel cW cH wcel wa ci vk cv cexp co cc wcel cB cY
      wcel wa ci vk cv cexp co cB cW cns cfv co ci vk cv cexp co cB cU cns cfv
      co wceq cA cY wcel ci vk cv cexp co cB cW cns cfv cU cns cfv cU cH cW cY
      sspi.y cU cns cfv eqid cW cns cfv eqid sspi.h sspsval adantrl opreq2d
      eqtrd fveq2d eqtrd cA cY wcel vk cv c1 c4 cfz co wcel cB cY wcel cA cY
      wcel ci vk cv cexp co cc wcel cB cY wcel wa wa cA cY wcel vk cv c1 c4 cfz
      co wcel cB cY wcel cA cY wcel ci vk cv cexp co cc wcel cB cY wcel wa wa
      vk cv c1 c4 cfz co wcel cB cY wcel wa ci vk cv cexp co cc wcel cB cY wcel
      wa cA cY wcel vk cv c1 c4 cfz co wcel ci vk cv cexp co cc wcel cB cY wcel
      vk cv c1 c4 cfz co wcel vk cv cn wcel vk cv cn0 wcel ci vk cv cexp co cc
      wcel vk cv c4 elfznn vk cv nnnn0 ci cc wcel vk cv cn0 wcel ci vk cv cexp
      co cc wcel axicn ci vk cv expcl mpan 3syl anim1i anim2i anassrs an1rs
      sylan2 anassrs opreq1d opreq2d sumeq2dv opreq1d cW cnv wcel cA cY wcel cB
      cY wcel wa cA cB cQ co c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co
      cB cW cns cfv co cW cpv cfv co cW cnm cfv cfv c2 cexp co cmul co vk csu
      c4 cdiv co wceq cU cnv wcel cW cH wcel wa cW cnv wcel cA cY wcel cB cY
      wcel cA cB cQ co c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cW
      cns cfv co cW cpv cfv co cW cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv
      co wceq cA cB cQ cW cns cfv cW vk cW cpv cfv cW cnm cfv cY sspi.y cW cpv
      cfv eqid cW cns cfv eqid cW cnm cfv eqid sspi.q ipval 3expb cU cH cW
      sspi.h sspnv sylan cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa cA
      cU cba cfv wcel cB cU cba cfv wcel wa cA cB cP co c1 c4 cfz co ci vk cv
      cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv co cU cnm cfv cfv
      c2 cexp co cmul co vk csu c4 cdiv co wceq cU cnv wcel cW cH wcel wa cA cY
      wcel cB cY wcel wa cA cU cba cfv wcel cB cU cba cfv wcel wa cU cnv wcel
      cW cH wcel wa cA cY wcel cA cU cba cfv wcel cB cY wcel cB cU cba cfv wcel
      cU cnv wcel cW cH wcel wa cY cU cba cfv cA cU cH cW cU cba cfv cY cU cba
      cfv eqid sspi.y sspi.h sspba sseld cU cnv wcel cW cH wcel wa cY cU cba
      cfv cB cU cH cW cU cba cfv cY cU cba cfv eqid sspi.y sspi.h sspba sseld
      anim12d imp cU cnv wcel cA cU cba cfv wcel cB cU cba cfv wcel wa cA cB cP
      co c1 c4 cfz co ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU
      cpv cfv co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv co wceq cW cH
      wcel cU cnv wcel cA cU cba cfv wcel cB cU cba cfv wcel cA cB cP co c1 c4
      cfz co ci vk cv cexp co cA ci vk cv cexp co cB cU cns cfv co cU cpv cfv
      co cU cnm cfv cfv c2 cexp co cmul co vk csu c4 cdiv co wceq cA cB cP cU
      cns cfv cU vk cU cpv cfv cU cnm cfv cU cba cfv cU cba cfv eqid cU cpv cfv
      eqid cU cns cfv eqid cU cnm cfv eqid sspi.p ipval 3expb adantlr syldan
      3eqtr4d $.
      $( [15-Feb-2008] $) $( [28-Jan-2008] $)

    $( The inner product on a subspace is a restriction of the inner product on
       the parent space. $)
    sspi $p |- ( ( U e. NrmCVec /\ W e. H ) -> Q = ( P |` ( Y X. Y ) ) ) $=
      vx vy cc cc cU cQ cP cH cW cY sspi.y sspi.h vx cv vy cv cP cQ cU cH cW cY
      sspi.y sspi.p sspi.q sspi.h sspival cQ cW cY sspi.y sspi.q ipf cP cU cU
      cba cfv cU cba cfv eqid sspi.p ipf sspmlem $.
      $( [23-Feb-2008] $) $( [28-Jan-2008] $)
  $}

  ${
    sspims.y $e |- Y = ( BaseSet ` W ) $.
    sspims.d $e |- D = ( IndMet ` U ) $.
    sspims.c $e |- C = ( IndMet ` W ) $.
    sspims.h $e |- H = ( SubSp ` U ) $.
    $d x y C $.  $d x y D $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    $( The induced metric on a subspace in terms of the induced metric on the
       parent space. $)
    sspimsval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A C B ) = ( A D B ) ) $=
      cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa cA cB cW cnsb cfv
      co cW cnm cfv cfv cA cB cU cnsb cfv co cU cnm cfv cfv cA cB cC co cA cB
      cD co cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa wa cA cB cW cnsb
      cfv co cW cnm cfv cfv cA cB cW cnsb cfv co cU cnm cfv cfv cA cB cU cnsb
      cfv co cU cnm cfv cfv cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa
      cA cB cW cnsb cfv co cY wcel cA cB cW cnsb cfv co cW cnm cfv cfv cA cB cW
      cnsb cfv co cU cnm cfv cfv wceq cW cnv wcel cA cY wcel cB cY wcel wa cA
      cB cW cnsb cfv co cY wcel cU cnv wcel cW cH wcel wa cW cnv wcel cA cY
      wcel cB cY wcel cA cB cW cnsb cfv co cY wcel cA cB cW cW cnsb cfv cY
      sspims.y cW cnsb cfv eqid nvmcl 3expb cU cH cW sspims.h sspnv sylan cU
      cnv wcel cW cH wcel cA cB cW cnsb cfv co cY wcel cA cB cW cnsb cfv co cW
      cnm cfv cfv cA cB cW cnsb cfv co cU cnm cfv cfv wceq cA cB cW cnsb cfv co
      cU cH cW cnm cfv cU cnm cfv cW cY sspims.y cU cnm cfv eqid cW cnm cfv
      eqid sspims.h sspnval 3expa syldan cU cnv wcel cW cH wcel wa cA cY wcel
      cB cY wcel wa wa cA cB cW cnsb cfv co cA cB cU cnsb cfv co cU cnm cfv cA
      cB cU cH cW cnsb cfv cU cnsb cfv cW cY sspims.y cU cnsb cfv eqid cW cnsb
      cfv eqid sspims.h sspmval fveq2d eqtrd cW cnv wcel cA cY wcel cB cY wcel
      wa cA cB cC co cA cB cW cnsb cfv co cW cnm cfv cfv wceq cU cnv wcel cW cH
      wcel wa cW cnv wcel cA cY wcel cB cY wcel cA cB cC co cA cB cW cnsb cfv
      co cW cnm cfv cfv wceq cA cB cC cW cW cnsb cfv cW cnm cfv cY sspims.y cW
      cnsb cfv eqid cW cnm cfv eqid sspims.c imsdval 3expb cU cH cW sspims.h
      sspnv sylan cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa cA cU cba
      cfv wcel cB cU cba cfv wcel wa cA cB cD co cA cB cU cnsb cfv co cU cnm
      cfv cfv wceq cU cnv wcel cW cH wcel wa cA cY wcel cB cY wcel wa cA cU cba
      cfv wcel cB cU cba cfv wcel wa cU cnv wcel cW cH wcel wa cA cY wcel cA cU
      cba cfv wcel cB cY wcel cB cU cba cfv wcel cU cnv wcel cW cH wcel wa cY
      cU cba cfv cA cU cH cW cU cba cfv cY cU cba cfv eqid sspims.y sspims.h
      sspba sseld cU cnv wcel cW cH wcel wa cY cU cba cfv cB cU cH cW cU cba
      cfv cY cU cba cfv eqid sspims.y sspims.h sspba sseld anim12d imp cU cnv
      wcel cA cU cba cfv wcel cB cU cba cfv wcel wa cA cB cD co cA cB cU cnsb
      cfv co cU cnm cfv cfv wceq cW cH wcel cU cnv wcel cA cU cba cfv wcel cB
      cU cba cfv wcel cA cB cD co cA cB cU cnsb cfv co cU cnm cfv cfv wceq cA
      cB cD cU cU cnsb cfv cU cnm cfv cU cba cfv cU cba cfv eqid cU cnsb cfv
      eqid cU cnm cfv eqid sspims.d imsdval 3expb adantlr syldan 3eqtr4d $.
      $( [4-Mar-2008] $) $( [1-Feb-2008] $)

    $( The induced metric on a subspace is a restriction of the induced metric
       on the parent space. $)
    sspims $p |- ( ( U e. NrmCVec /\ W e. H ) -> C = ( D |` ( Y X. Y ) ) ) $=
      vx vy cr cr cU cC cD cH cW cY sspims.y sspims.h vx cv vy cv cC cD cU cH
      cW cY sspims.y sspims.d sspims.c sspims.h sspimsval cC cW cY sspims.y
      sspims.c imsdf cD cU cU cba cfv cU cba cfv eqid sspims.d imsdf sspmlem $.
      $( [22-Mar-2008] $) $( [1-Feb-2008] $)
  $}

  $( Define the class of all complete subspaces of a complex normed vector
     space. $)
  $(
  $c CSubSp $.
  ccs $a class SubSp $.
  df-cs $a |- CSubSp = { <. u , s >. | ( u e. NrmCVec /\ s =
       ( ( SubSp ` u ) |^| CBan ) ) } $.
  $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                     Operators on complex vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definitions and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LnOp $.
  $c normOp $.
  $c BLnOp $.
  $c 0op $.

  $( Extend class notation with the class of linear operators on normed complex
     vector spaces. $)
  clno $a class LnOp $.

  $( Extend class notation with the class of operator norms on normed complex
     vector spaces. $)
  cnmo $a class normOp $.

  $( Extend class notation with the class of bounded linear operators on
     normed complex vector spaces. $)
  cblo $a class BLnOp $.

  $( Extend class notation with the class of zero operators on normed complex
     vector spaces. $)
  c0o $a class 0op $.

  ${
    $d n o t u w x y z $.
    $( Define the class of linear operators between two normed complex vector
       spaces.  In the literature, an operator may be a partial function, i.e.
       the domain of an operator is not necessarily the entire vector space.
       However, since the domain of a linear operator is a vector subspace, we
       define it with a complete function for convenience and will use subset
       relations to specify the partial function case. $)
    df-lno $a |- LnOp = { <. <. u , w >. , o >. | ( ( u e. NrmCVec /\
      w e. NrmCVec ) /\ o = { t | ( t : ( BaseSet ` u ) --> ( BaseSet ` w ) /\
       A. x e. ( BaseSet ` u ) A. y e. CC A. z e. ( BaseSet ` u )
      ( t ` ( x ( +v ` u ) ( y ( .s ` u ) z ) ) ) =
         ( ( t ` x ) ( +v ` w ) ( y ( .s ` w ) ( t ` z ) ) ) ) } ) } $.

    $( Define the norm of an operator between two normed complex vector
       spaces.  This definition produces an operator norm function for each
       pair of vector spaces ` <. u , w >. ` .  Based on definition of linear
       operator norm in [AkhiezerGlazman] p. 39, although we define it for
       all operators for convenience.  It isn't necessarily meaningful for
       nonlinear operators, since it doesn't take into account operator values
       at vectors with norm greater than 1.  See Equation 2 of [Kreyszig] p. 92
       for a definition that does (although it ignores the value at the zero
       vector).  However, operator norms are rarely if ever used for nonlinear
       operators. $)
    df-nmo $a |- normOp = { <. <. u , w >. , n >. | ( ( u e. NrmCVec /\
      w e. NrmCVec ) /\ n = { <. t , y >. | ( t : ( BaseSet ` u ) -->
  ( BaseSet ` w ) /\ y = sup ( { x | E. z e. ( BaseSet ` u ) ( (
  ( norm ` u ) ` z ) <_ 1 /\ x = ( ( norm ` w ) ` ( t ` z ) ) ) } , RR* ,
   < ) ) } ) } $.

    $( Define the class of bounded linear operators between two normed complex
       vector spaces. $)
    df-blo $a |- BLnOp = { <. <. u , w >. , o >. | ( ( u e. NrmCVec /\
      w e. NrmCVec ) /\ o = { t e. ( u LnOp w ) | ( ( u normOp w ) ` t )
        < +oo } ) } $.

    $( Define the zero operator between two normed complex vector spaces. $)
    df-0o $a |- 0op = { <. <. u , w >. , o >. | ( ( u e. NrmCVec /\
      w e. NrmCVec ) /\ o = ( ( BaseSet ` u ) X. { ( 0v ` w ) } ) ) } $.


  $}

  $c adj $.
  $( Adjoint of an operator. $)
  caj $a class adj $.

  $c HmOp $.
  $( Set of Hermitional (self-adjoint) operators. $)
  chmo $a class HmOp $.

  ${
    $d a o s t u w x y $.
    $( Define the adjoint of an operator (if it exists).  The domain of
       ` U adj W ` is the set of all operators from ` U ` to ` W ` that have an
       adjoint.  Definition 3.9-1 of [Kreyszig] p. 196, although we don't
       require that ` U ` and ` W ` be Hilbert spaces nor that the operators be
       linear.  Although we define it for any normed vector space for
       convenience, the definition is meaningful only for inner product
       spaces. $)
    df-aj $a |- adj = { <. <. u , w >. , a >. | ( ( u e. NrmCVec /\
  w e. NrmCVec ) /\ a = { <. t , s >. | ( t : ( BaseSet ` u ) --> ( BaseSet ` w
  ) /\ s : ( BaseSet ` w ) --> ( BaseSet ` u ) /\ A. x e. ( BaseSet ` u ) A. y
  e. ( BaseSet ` w ) ( ( t ` x ) ( .i ` w ) y ) = ( x ( .i ` u ) ( s ` y ) ) )
  } ) } $.

    $( Define the set of Hermitian (self-adjoint) operators on a normed
       complex vector space (normally a Hilbert space).  Although we define it
       for any normed vector space for convenience, the definition is
       meaningful only for inner product spaces. $)
    df-hmo $a |- HmOp = { <. u , o >. | ( u e. NrmCVec /\ o = { t e.
        dom ( u adj u ) | ( ( u adj u ) ` t ) = t } ) } $.
  $}

  ${
    $d u v w A $.  $d v w B $.  $d w C $.
    $d o t u v w G $.  $d o t u v w H $.  $d o t u v w R $.  $d o t u v w S $.
    $d t u v w x y z T $.  $d o t u v w x y z U $.  $d o t u v w x y z W $.
    $d o t u v w x y z X $.  $d o t w Y $.
    lnoval.1 $e |- X = ( BaseSet ` U ) $.
    lnoval.2 $e |- Y = ( BaseSet ` W ) $.
    lnoval.3 $e |- G = ( +v ` U ) $.
    lnoval.4 $e |- H = ( +v ` W ) $.
    lnoval.5 $e |- R = ( .s ` U ) $.
    lnoval.6 $e |- S = ( .s ` W ) $.
    lnoval.7 $e |- L = ( U LnOp W ) $.
    $( The set of linear operators between two normed complex vector
       spaces. $)
    lnoval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> L =
      { t  | ( t : X --> Y /\ A. x e. X A. y e. CC A. z e. X
      ( t ` ( x G ( y R z ) ) ) = ( ( t ` x ) H ( y S ( t ` z ) ) ) ) } ) $=
      cU cnv wcel cW cnv wcel wa cU cW clno co cX cY vt cv wf vx cv vy cv vz cv
      cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co
      wceq vz cX wral vy cc wral vx cX wral wa vt cab cL vu vw vo cU cW cnv cnv
      vu cv cba cfv vw cv cba cfv vt cv wf vx cv vy cv vz cv vu cv cns cfv co
      vu cv cpv cfv co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv
      cns cfv co vw cv cpv cfv co wceq vz vu cv cba cfv wral vy cc wral vx vu
      cv cba cfv wral wa vt cab cX cY vt cv wf vx cv vy cv vz cv cR co cG co vt
      cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co wceq vz cX wral
      vy cc wral vx cX wral wa vt cab clno cX vw cv cba cfv vt cv wf vx cv vy
      cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw
      cv cns cfv co vw cv cpv cfv co wceq vz cX wral vy cc wral vx cX wral wa
      vt cab vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz
      cv vt cv cfv cS co cH co wceq vz cX wral vy cc wral vx cX wral vt cX cY
      cX cY vt cv wf vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy
      cv vz cv vt cv cfv cS co cH co wceq vz cX wral vy cc wral vx cX wral wa
      vt cab cX cU cba cfv cvv lnoval.1 cU cba fvex eqeltri cY cW cba cfv cvv
      lnoval.2 cW cba fvex eqeltri cX cY vt cv wf vx cv vy cv vz cv cR co cG co
      vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co wceq vz cX
      wral vy cc wral vx cX wral wa vt cab eqid fabex vu cv cU wceq vu cv cba
      cfv vw cv cba cfv vt cv wf vx cv vy cv vz cv vu cv cns cfv co vu cv cpv
      cfv co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv co
      vw cv cpv cfv co wceq vz vu cv cba cfv wral vy cc wral vx vu cv cba cfv
      wral wa cX vw cv cba cfv vt cv wf vx cv vy cv vz cv cR co cG co vt cv cfv
      vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv co vw cv cpv cfv co
      wceq vz cX wral vy cc wral vx cX wral wa vt vu cv cU wceq vu cv cba cfv
      vw cv cba cfv vt cv wf cX vw cv cba cfv vt cv wf vx cv vy cv vz cv vu cv
      cns cfv co vu cv cpv cfv co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv
      cfv vw cv cns cfv co vw cv cpv cfv co wceq vz vu cv cba cfv wral vy cc
      wral vx vu cv cba cfv wral vx cv vy cv vz cv cR co cG co vt cv cfv vx cv
      vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv co vw cv cpv cfv co wceq vz
      cX wral vy cc wral vx cX wral vu cv cU wceq vu cv cba cfv cX wceq vu cv
      cba cfv vw cv cba cfv vt cv wf cX vw cv cba cfv vt cv wf wb vu cv cU wceq
      vu cv cba cfv cU cba cfv cX vu cv cU cba fveq2 lnoval.1 syl6eqr vu cv cba
      cfv cX vw cv cba cfv vt cv feq2 syl vu cv cU wceq vx cv vy cv vz cv vu cv
      cns cfv co vu cv cpv cfv co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv
      cfv vw cv cns cfv co vw cv cpv cfv co wceq vz vu cv cba cfv wral vy cc
      wral vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv
      vt cv cfv vw cv cns cfv co vw cv cpv cfv co wceq vz cX wral vy cc wral vx
      vu cv cba cfv cX vu cv cU wceq vu cv cba cfv cU cba cfv cX vu cv cU cba
      fveq2 lnoval.1 syl6eqr vu cv cU wceq vx cv vy cv vz cv vu cv cns cfv co
      vu cv cpv cfv co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv
      cns cfv co vw cv cpv cfv co wceq vz vu cv cba cfv wral vx cv vy cv vz cv
      cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv
      co vw cv cpv cfv co wceq vz cX wral vy cc vu cv cU wceq vx cv vy cv vz cv
      vu cv cns cfv co vu cv cpv cfv co vt cv cfv vx cv vt cv cfv vy cv vz cv
      vt cv cfv vw cv cns cfv co vw cv cpv cfv co wceq vx cv vy cv vz cv cR co
      cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv co vw
      cv cpv cfv co wceq vz vu cv cba cfv cX vu cv cU wceq vu cv cba cfv cU cba
      cfv cX vu cv cU cba fveq2 lnoval.1 syl6eqr vu cv cU wceq vx cv vy cv vz
      cv vu cv cns cfv co vu cv cpv cfv co vt cv cfv vx cv vy cv vz cv cR co cG
      co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv co vw cv
      cpv cfv co vu cv cU wceq vx cv vy cv vz cv vu cv cns cfv co vu cv cpv cfv
      co vx cv vy cv vz cv cR co cG co vt cv vu cv cU wceq vx cv vy cv vz cv vu
      cv cns cfv co vu cv cpv cfv co vx cv vy cv vz cv cR co vu cv cpv cfv co
      vx cv vy cv vz cv cR co cG co vu cv cU wceq vy cv vz cv vu cv cns cfv co
      vy cv vz cv cR co vx cv vu cv cpv cfv vu cv cU wceq vu cv cns cfv cR vy
      cv vz cv vu cv cU wceq vu cv cns cfv cU cns cfv cR vu cv cU cns fveq2
      lnoval.5 syl6eqr opreqd opreq2d vu cv cU wceq vu cv cpv cfv cG vx cv vy
      cv vz cv cR co vu cv cU wceq vu cv cpv cfv cU cpv cfv cG vu cv cU cpv
      fveq2 lnoval.3 syl6eqr opreqd eqtrd fveq2d eqeq1d raleq12d ralbidv
      raleq12d anbi12d abbidv vw cv cW wceq cX vw cv cba cfv vt cv wf vx cv vy
      cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw
      cv cns cfv co vw cv cpv cfv co wceq vz cX wral vy cc wral vx cX wral wa
      cX cY vt cv wf vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy
      cv vz cv vt cv cfv cS co cH co wceq vz cX wral vy cc wral vx cX wral wa
      vt vw cv cW wceq cX vw cv cba cfv vt cv wf cX cY vt cv wf vx cv vy cv vz
      cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns
      cfv co vw cv cpv cfv co wceq vz cX wral vy cc wral vx cX wral vx cv vy cv
      vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co
      cH co wceq vz cX wral vy cc wral vx cX wral vw cv cW wceq vw cv cba cfv
      cY wceq cX vw cv cba cfv vt cv wf cX cY vt cv wf wb vw cv cW wceq vw cv
      cba cfv cW cba cfv cY vw cv cW cba fveq2 lnoval.2 syl6eqr vw cv cba cfv
      cY cX vt cv feq3 syl vw cv cW wceq vx cv vy cv vz cv cR co cG co vt cv
      cfv vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv co vw cv cpv cfv
      co wceq vz cX wral vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv
      cfv vy cv vz cv vt cv cfv cS co cH co wceq vz cX wral vx vy cX cc vw cv
      cW wceq vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz
      cv vt cv cfv vw cv cns cfv co vw cv cpv cfv co wceq vx cv vy cv vz cv cR
      co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co wceq
      vz cX vw cv cW wceq vx cv vt cv cfv vy cv vz cv vt cv cfv vw cv cns cfv
      co vw cv cpv cfv co vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co vx
      cv vy cv vz cv cR co cG co vt cv cfv vw cv cW wceq vx cv vt cv cfv vy cv
      vz cv vt cv cfv vw cv cns cfv co vw cv cpv cfv co vx cv vt cv cfv vy cv
      vz cv vt cv cfv cS co vw cv cpv cfv co vx cv vt cv cfv vy cv vz cv vt cv
      cfv cS co cH co vw cv cW wceq vy cv vz cv vt cv cfv vw cv cns cfv co vy
      cv vz cv vt cv cfv cS co vx cv vt cv cfv vw cv cpv cfv vw cv cW wceq vw
      cv cns cfv cS vy cv vz cv vt cv cfv vw cv cW wceq vw cv cns cfv cW cns
      cfv cS vw cv cW cns fveq2 lnoval.6 syl6eqr opreqd opreq2d vw cv cW wceq
      vw cv cpv cfv cH vx cv vt cv cfv vy cv vz cv vt cv cfv cS co vw cv cW
      wceq vw cv cpv cfv cW cpv cfv cH vw cv cW cpv fveq2 lnoval.4 syl6eqr
      opreqd eqtrd eqeq2d ralbidv 2ralbidv anbi12d abbidv vx vy vz vw vu vt vo
      df-lno oprabval2 lnoval.7 syl5eq $.
      $( [28-Nov-2007] $) $( [6-Nov-2007] $)

    $( The predicate "is a linear operator." $)
    islno $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> ( T e. L <->
      ( T : X --> Y /\ A. x e. X A. y e. CC A. z e. X
      ( T ` ( x G ( y R z ) ) ) = ( ( T ` x ) H ( y S ( T ` z ) ) ) ) ) ) $=
      cU cnv wcel cW cnv wcel wa cT cL wcel cT cX cY vt cv wf vx cv vy cv vz cv
      cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co
      wceq vz cX wral vy cc wral vx cX wral wa vt cab wcel cX cY cT wf vx cv vy
      cv vz cv cR co cG co cT cfv vx cv cT cfv vy cv vz cv cT cfv cS co cH co
      wceq vz cX wral vy cc wral vx cX wral wa cU cnv wcel cW cnv wcel wa cL cX
      cY vt cv wf vx cv vy cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv
      vz cv vt cv cfv cS co cH co wceq vz cX wral vy cc wral vx cX wral wa vt
      cab cT vx vy vz vt cR cS cU cG cH cL cW cX cY lnoval.1 lnoval.2 lnoval.3
      lnoval.4 lnoval.5 lnoval.6 lnoval.7 lnoval eleq2d cX cY vt cv wf vx cv vy
      cv vz cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS
      co cH co wceq vz cX wral vy cc wral vx cX wral wa cX cY cT wf vx cv vy cv
      vz cv cR co cG co cT cfv vx cv cT cfv vy cv vz cv cT cfv cS co cH co wceq
      vz cX wral vy cc wral vx cX wral wa vt cT cX cY cT wf cT cvv wcel vx cv
      vy cv vz cv cR co cG co cT cfv vx cv cT cfv vy cv vz cv cT cfv cS co cH
      co wceq vz cX wral vy cc wral vx cX wral cX cY cT wf cX cvv wcel cT cvv
      wcel cX cU cba cfv cvv lnoval.1 cU cba fvex eqeltri cX cY cvv cT fex
      mpan2 adantr vt cv cT wceq cX cY vt cv wf cX cY cT wf vx cv vy cv vz cv
      cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co
      wceq vz cX wral vy cc wral vx cX wral vx cv vy cv vz cv cR co cG co cT
      cfv vx cv cT cfv vy cv vz cv cT cfv cS co cH co wceq vz cX wral vy cc
      wral vx cX wral cX cY vt cv cT feq1 vt cv cT wceq vx cv vy cv vz cv cR co
      cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH co wceq vz
      cX wral vx cv vy cv vz cv cR co cG co cT cfv vx cv cT cfv vy cv vz cv cT
      cfv cS co cH co wceq vz cX wral vx vy cX cc vt cv cT wceq vx cv vy cv vz
      cv cR co cG co vt cv cfv vx cv vt cv cfv vy cv vz cv vt cv cfv cS co cH
      co wceq vx cv vy cv vz cv cR co cG co cT cfv vx cv cT cfv vy cv vz cv cT
      cfv cS co cH co wceq vz cX vt cv cT wceq vx cv vy cv vz cv cR co cG co vt
      cv cfv vx cv vy cv vz cv cR co cG co cT cfv vx cv vt cv cfv vy cv vz cv
      vt cv cfv cS co cH co vx cv cT cfv vy cv vz cv cT cfv cS co cH co vx cv
      vy cv vz cv cR co cG co vt cv cT fveq1 vt cv cT wceq vx cv vt cv cfv vx
      cv cT cfv vy cv vz cv vt cv cfv cS co vy cv vz cv cT cfv cS co cH vx cv
      vt cv cT fveq1 vt cv cT wceq vz cv vt cv cfv vz cv cT cfv vy cv cS vz cv
      vt cv cT fveq1 opreq2d opreq12d eqeq12d ralbidv 2ralbidv anbi12d elab3
      syl6bb $.
      $( [10-Dec-2007] $) $( [4-Dec-2007] $)

    $( Basic linearity property of a linear operator. $)
    lnolin $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
       ( A e. X /\ B e. CC /\ C e. X ) ) ->
      ( T ` ( A G ( B R C ) ) ) = ( ( T ` A ) H ( B S ( T ` C ) ) ) ) $=
      cA cX wcel cB cc wcel cC cX wcel w3a cU cnv wcel cW cnv wcel cT cL wcel
      w3a cA cB cC cR co cG co cT cfv cA cT cfv cB cC cT cfv cS co cH co wceq
      cA cX wcel cB cc wcel cC cX wcel w3a vu cv vv cv vw cv cR co cG co cT cfv
      vu cv cT cfv vv cv vw cv cT cfv cS co cH co wceq vw cX wral vv cc wral vu
      cX wral cA cB cC cR co cG co cT cfv cA cT cfv cB cC cT cfv cS co cH co
      wceq cU cnv wcel cW cnv wcel cT cL wcel w3a vu cv vv cv vw cv cR co cG co
      cT cfv vu cv cT cfv vv cv vw cv cT cfv cS co cH co wceq cA cB cC cR co cG
      co cT cfv cA cT cfv cB cC cT cfv cS co cH co wceq cA vv cv vw cv cR co cG
      co cT cfv cA cT cfv vv cv vw cv cT cfv cS co cH co wceq cA cB vw cv cR co
      cG co cT cfv cA cT cfv cB vw cv cT cfv cS co cH co wceq vu vv vw cA cB cC
      cX cc cX vu cv cA wceq vu cv vv cv vw cv cR co cG co cT cfv cA vv cv vw
      cv cR co cG co cT cfv vu cv cT cfv vv cv vw cv cT cfv cS co cH co cA cT
      cfv vv cv vw cv cT cfv cS co cH co vu cv cA wceq vu cv vv cv vw cv cR co
      cG co cA vv cv vw cv cR co cG co cT vu cv cA vv cv vw cv cR co cG opreq1
      fveq2d vu cv cA wceq vu cv cT cfv cA cT cfv vv cv vw cv cT cfv cS co cH
      vu cv cA cT fveq2 opreq1d eqeq12d vv cv cB wceq cA vv cv vw cv cR co cG
      co cT cfv cA cB vw cv cR co cG co cT cfv cA cT cfv vv cv vw cv cT cfv cS
      co cH co cA cT cfv cB vw cv cT cfv cS co cH co vv cv cB wceq cA vv cv vw
      cv cR co cG co cA cB vw cv cR co cG co cT vv cv cB wceq vv cv vw cv cR co
      cB vw cv cR co cA cG vv cv cB vw cv cR opreq1 opreq2d fveq2d vv cv cB
      wceq vv cv vw cv cT cfv cS co cB vw cv cT cfv cS co cA cT cfv cH vv cv cB
      vw cv cT cfv cS opreq1 opreq2d eqeq12d vw cv cC wceq cA cB vw cv cR co cG
      co cT cfv cA cB cC cR co cG co cT cfv cA cT cfv cB vw cv cT cfv cS co cH
      co cA cT cfv cB cC cT cfv cS co cH co vw cv cC wceq cA cB vw cv cR co cG
      co cA cB cC cR co cG co cT vw cv cC wceq cB vw cv cR co cB cC cR co cA cG
      vw cv cC cB cR opreq2 opreq2d fveq2d vw cv cC wceq cB vw cv cT cfv cS co
      cB cC cT cfv cS co cA cT cfv cH vw cv cC wceq vw cv cT cfv cC cT cfv cB
      cS vw cv cC cT fveq2 opreq2d opreq2d eqeq12d rcla43v cU cnv wcel cW cnv
      wcel cT cL wcel vu cv vv cv vw cv cR co cG co cT cfv vu cv cT cfv vv cv
      vw cv cT cfv cS co cH co wceq vw cX wral vv cc wral vu cX wral cU cnv
      wcel cW cnv wcel wa cT cL wcel cX cY cT wf vu cv vv cv vw cv cR co cG co
      cT cfv vu cv cT cfv vv cv vw cv cT cfv cS co cH co wceq vw cX wral vv cc
      wral vu cX wral vu vv vw cR cS cT cU cG cH cL cW cX cY lnoval.1 lnoval.2
      lnoval.3 lnoval.4 lnoval.5 lnoval.6 lnoval.7 islno pm3.27bda 3impa syl5
      impcom $.
      $( [12-Dec-2007] $) $( [4-Dec-2007] $)
  $}

  ${
    $d x y z T $.  $d x y z U $.  $d x y z W $.  $d x y z X $.
    lnof.1 $e |- X = ( BaseSet ` U ) $.
    lnof.2 $e |- Y = ( BaseSet ` W ) $.
    lnof.7 $e |- L = ( U LnOp W ) $.
    $( A linear operator is a mapping. $)
    lnof $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) -> T : X --> Y ) $=
      cU cnv wcel cW cnv wcel cT cL wcel cX cY cT wf cU cnv wcel cW cnv wcel wa
      cT cL wcel cX cY cT wf vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cT
      cfv vx cv cT cfv vy cv vz cv cT cfv cW cns cfv co cW cpv cfv co wceq vz
      cX wral vy cc wral vx cX wral vx vy vz cU cns cfv cW cns cfv cT cU cU cpv
      cfv cW cpv cfv cL cW cX cY lnof.1 lnof.2 cU cpv cfv eqid cW cpv cfv eqid
      cU cns cfv eqid cW cns cfv eqid lnof.7 islno pm3.26bda 3impa $.
      $( [11-Dec-2007] $) $( [4-Dec-2007] $)
  $}

  ${
    lno0.1 $e |- X = ( BaseSet ` U ) $.
    lno0.2 $e |- Y = ( BaseSet ` W ) $.
    lno0.5 $e |- Q = ( 0v ` U ) $.
    lno0.z $e |- Z = ( 0v ` W ) $.
    lno0.7 $e |- L = ( U LnOp W ) $.
    $( The value of a linear operator at zero is zero. $)
    lno0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L )
         -> ( T ` Q ) = Z ) $=
      cU cnv wcel cW cnv wcel cT cL wcel w3a cQ c1 cneg cQ cU cns cfv co cU cpv
      cfv co cT cfv cQ cT cfv c1 cneg cQ cT cfv cW cns cfv co cW cpv cfv co cQ
      cT cfv cZ cU cnv wcel cW cnv wcel cT cL wcel w3a cQ cX wcel c1 cneg cc
      wcel cQ cX wcel w3a cQ c1 cneg cQ cU cns cfv co cU cpv cfv co cT cfv cQ
      cT cfv c1 cneg cQ cT cfv cW cns cfv co cW cpv cfv co wceq cU cnv wcel cW
      cnv wcel cQ cX wcel c1 cneg cc wcel cQ cX wcel w3a cT cL wcel cU cnv wcel
      cQ cX wcel c1 cneg cc wcel cQ cX wcel cU cX cQ lno0.1 lno0.5 nvzcl c1
      cneg cc wcel cU cnv wcel c1 ax1cn negcli a1i cU cX cQ lno0.1 lno0.5 nvzcl
      3jca 3ad2ant1 cQ c1 cneg cQ cU cns cfv cW cns cfv cT cU cU cpv cfv cW cpv
      cfv cL cW cX cY lno0.1 lno0.2 cU cpv cfv eqid cW cpv cfv eqid cU cns cfv
      eqid cW cns cfv eqid lno0.7 lnolin mpdan cU cnv wcel cW cnv wcel cQ c1
      cneg cQ cU cns cfv co cU cpv cfv co cT cfv cQ cT cfv wceq cT cL wcel cU
      cnv wcel cQ c1 cneg cQ cU cns cfv co cU cpv cfv co cQ cT cU cnv wcel cQ
      c1 cneg cQ cU cns cfv co cU cpv cfv co cQ cQ cU cpv cfv co cQ cU cnv wcel
      c1 cneg cQ cU cns cfv co cQ cQ cU cpv cfv cU cnv wcel c1 cneg cc wcel c1
      cneg cQ cU cns cfv co cQ wceq c1 ax1cn negcli c1 cneg cU cns cfv cU cQ cU
      cns cfv eqid lno0.5 nvsz mpan2 opreq2d cU cnv wcel cQ cX wcel cQ cQ cU
      cpv cfv co cQ wceq cU cX cQ lno0.1 lno0.5 nvzcl cQ cU cU cpv cfv cX cQ
      lno0.1 cU cpv cfv eqid lno0.5 nv0rid mpdan eqtrd fveq2d 3ad2ant1 cW cnv
      wcel cQ cT cfv cY wcel cQ cT cfv c1 cneg cQ cT cfv cW cns cfv co cW cpv
      cfv co cZ wceq cU cnv wcel cW cnv wcel cT cL wcel w3a cQ cT cfv cW cns
      cfv cW cW cpv cfv cY cZ lno0.2 cW cpv cfv eqid cW cns cfv eqid lno0.z
      nvrinv cU cnv wcel cW cnv wcel cT cL wcel 3simp2 cX cY cT wf cQ cX wcel
      cQ cT cfv cY wcel cU cnv wcel cW cnv wcel cT cL wcel w3a cX cY cQ cT
      ffvelrn cT cU cL cW cX cY lno0.1 lno0.2 lno0.7 lnof cU cnv wcel cW cnv
      wcel cQ cX wcel cT cL wcel cU cX cQ lno0.1 lno0.5 nvzcl 3ad2ant1 sylanc
      sylanc 3eqtr3d $.
      $( [13-Dec-2007] $) $( [4-Dec-2007] $)
  $}

  ${
    $d x y z S $.  $d x y z T $.  $d x y z U $.  $d x y z X $.
    lnocoi.l $e |- L = ( U LnOp W ) $.
    lnocoi.m $e |- M = ( W LnOp X ) $.
    lnocoi.n $e |- N = ( U LnOp X ) $.
    lnocoi.u $e |- U e. NrmCVec $.
    lnocoi.w $e |- W e. NrmCVec $.
    lnocoi.x $e |- X e. NrmCVec $.
    lnocoi.s $e |- S e. L $.
    lnocoi.t $e |- T e. M $.
    $( The composition of two linear operators is linear. $)
    lnocoi $p |- ( T o. S ) e. N $=
      cT cS ccom cN wcel cU cba cfv cX cba cfv cT cS ccom wf vx cv vy cv vz cv
      cU cns cfv co cU cpv cfv co cT cS ccom cfv vx cv cT cS ccom cfv vy cv vz
      cv cT cS ccom cfv cX cns cfv co cX cpv cfv co wceq vz cU cba cfv wral vy
      cc wral vx cU cba cfv wral cU cnv wcel cX cnv wcel cT cS ccom cN wcel cU
      cba cfv cX cba cfv cT cS ccom wf vx cv vy cv vz cv cU cns cfv co cU cpv
      cfv co cT cS ccom cfv vx cv cT cS ccom cfv vy cv vz cv cT cS ccom cfv cX
      cns cfv co cX cpv cfv co wceq vz cU cba cfv wral vy cc wral vx cU cba cfv
      wral wa wb lnocoi.u lnocoi.x vx vy vz cU cns cfv cX cns cfv cT cS ccom cU
      cU cpv cfv cX cpv cfv cN cX cU cba cfv cX cba cfv cU cba cfv eqid cX cba
      cfv eqid cU cpv cfv eqid cX cpv cfv eqid cU cns cfv eqid cX cns cfv eqid
      lnocoi.n islno mp2an cW cba cfv cX cba cfv cT wf cU cba cfv cW cba cfv cS
      wf cU cba cfv cX cba cfv cT cS ccom wf cW cnv wcel cX cnv wcel cT cM wcel
      cW cba cfv cX cba cfv cT wf lnocoi.w lnocoi.x lnocoi.t cT cW cM cX cW cba
      cfv cX cba cfv cW cba cfv eqid cX cba cfv eqid lnocoi.m lnof mp3an cU cnv
      wcel cW cnv wcel cS cL wcel cU cba cfv cW cba cfv cS wf lnocoi.u lnocoi.w
      lnocoi.s cS cU cL cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv
      eqid lnocoi.l lnof mp3an cU cba cfv cW cba cfv cX cba cfv cT cS fco mp2an
      vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cT cS ccom cfv vx cv cT cS
      ccom cfv vy cv vz cv cT cS ccom cfv cX cns cfv co cX cpv cfv co wceq vx
      vy vz cU cba cfv cc cU cba cfv vx cv cU cba cfv wcel vy cv cc wcel vz cv
      cU cba cfv wcel w3a vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cT cS
      ccom cfv vx cv cS cfv cT cfv vy cv vz cv cS cfv cT cfv cX cns cfv co cX
      cpv cfv co vx cv cT cS ccom cfv vy cv vz cv cT cS ccom cfv cX cns cfv co
      cX cpv cfv co vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel
      w3a vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cT cS ccom cfv vx cv vy
      cv vz cv cU cns cfv co cU cpv cfv co cS cfv cT cfv vx cv cS cfv vy cv vz
      cv cS cfv cW cns cfv co cW cpv cfv co cT cfv vx cv cS cfv cT cfv vy cv vz
      cv cS cfv cT cfv cX cns cfv co cX cpv cfv co vx cv cU cba cfv wcel vy cv
      cc wcel vz cv cU cba cfv wcel w3a vx cv vy cv vz cv cU cns cfv co cU cpv
      cfv co cU cba cfv wcel vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cT
      cS ccom cfv vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cS cfv cT cfv
      wceq vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel vx cv vy
      cv vz cv cU cns cfv co cU cpv cfv co cU cba cfv wcel vx cv cU cba cfv
      wcel vy cv vz cv cU cns cfv co cU cba cfv wcel vx cv vy cv vz cv cU cns
      cfv co cU cpv cfv co cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel
      wa cU cnv wcel vx cv cU cba cfv wcel vy cv vz cv cU cns cfv co cU cba cfv
      wcel vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cU cba cfv wcel
      lnocoi.u vx cv vy cv vz cv cU cns cfv co cU cU cpv cfv cU cba cfv cU cba
      cfv eqid cU cpv cfv eqid nvgcl mp3an1 cU cnv wcel vy cv cc wcel vz cv cU
      cba cfv wcel vy cv vz cv cU cns cfv co cU cba cfv wcel lnocoi.u vy cv vz
      cv cU cns cfv cU cU cba cfv cU cba cfv eqid cU cns cfv eqid nvscl mp3an1
      sylan2 3impb cT wfun cU cba cfv cW cba cfv cS wf vx cv vy cv vz cv cU cns
      cfv co cU cpv cfv co cU cba cfv wcel vx cv vy cv vz cv cU cns cfv co cU
      cpv cfv co cT cS ccom cfv vx cv vy cv vz cv cU cns cfv co cU cpv cfv co
      cS cfv cT cfv wceq cW cba cfv cX cba cfv cT wf cT wfun cW cnv wcel cX cnv
      wcel cT cM wcel cW cba cfv cX cba cfv cT wf lnocoi.w lnocoi.x lnocoi.t cT
      cW cM cX cW cba cfv cX cba cfv cW cba cfv eqid cX cba cfv eqid lnocoi.m
      lnof mp3an cW cba cfv cX cba cfv cT ffun ax-mp cU cnv wcel cW cnv wcel cS
      cL wcel cU cba cfv cW cba cfv cS wf lnocoi.u lnocoi.w lnocoi.s cS cU cL
      cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid lnocoi.l lnof
      mp3an cU cba cfv cW cba cfv vx cv vy cv vz cv cU cns cfv co cU cpv cfv co
      cT cS fvco3 mp3an12 syl vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba
      cfv wcel w3a vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cS cfv vx cv
      cS cfv vy cv vz cv cS cfv cW cns cfv co cW cpv cfv co cT cU cnv wcel cW
      cnv wcel cS cL wcel w3a vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba
      cfv wcel w3a vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cS cfv vx cv
      cS cfv vy cv vz cv cS cfv cW cns cfv co cW cpv cfv co wceq cU cnv wcel cW
      cnv wcel cS cL wcel lnocoi.u lnocoi.w lnocoi.s 3pm3.2i vx cv vy cv vz cv
      cU cns cfv cW cns cfv cS cU cU cpv cfv cW cpv cfv cL cW cU cba cfv cW cba
      cfv cU cba cfv eqid cW cba cfv eqid cU cpv cfv eqid cW cpv cfv eqid cU
      cns cfv eqid cW cns cfv eqid lnocoi.l lnolin mpan fveq2d vx cv cS cfv cW
      cba cfv wcel vy cv cc wcel vz cv cS cfv cW cba cfv wcel vx cv cS cfv vy
      cv vz cv cS cfv cW cns cfv co cW cpv cfv co cT cfv vx cv cS cfv cT cfv vy
      cv vz cv cS cfv cT cfv cX cns cfv co cX cpv cfv co wceq vx cv cU cba cfv
      wcel vy cv cc wcel vz cv cU cba cfv wcel cW cnv wcel cX cnv wcel cT cM
      wcel w3a vx cv cS cfv cW cba cfv wcel vy cv cc wcel vz cv cS cfv cW cba
      cfv wcel w3a vx cv cS cfv vy cv vz cv cS cfv cW cns cfv co cW cpv cfv co
      cT cfv vx cv cS cfv cT cfv vy cv vz cv cS cfv cT cfv cX cns cfv co cX cpv
      cfv co wceq cW cnv wcel cX cnv wcel cT cM wcel lnocoi.w lnocoi.x lnocoi.t
      3pm3.2i vx cv cS cfv vy cv vz cv cS cfv cW cns cfv cX cns cfv cT cW cW
      cpv cfv cX cpv cfv cM cX cW cba cfv cX cba cfv cW cba cfv eqid cX cba cfv
      eqid cW cpv cfv eqid cX cpv cfv eqid cW cns cfv eqid cX cns cfv eqid
      lnocoi.m lnolin mpan cU cba cfv cW cba cfv vx cv cS cU cnv wcel cW cnv
      wcel cS cL wcel cU cba cfv cW cba cfv cS wf lnocoi.u lnocoi.w lnocoi.s cS
      cU cL cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid lnocoi.l
      lnof mp3an ffvelrni vy cv cc wcel id cU cba cfv cW cba cfv vz cv cS cU
      cnv wcel cW cnv wcel cS cL wcel cU cba cfv cW cba cfv cS wf lnocoi.u
      lnocoi.w lnocoi.s cS cU cL cW cU cba cfv cW cba cfv cU cba cfv eqid cW
      cba cfv eqid lnocoi.l lnof mp3an ffvelrni syl3an 3eqtrd vx cv cU cba cfv
      wcel vy cv cc wcel vz cv cU cba cfv wcel vx cv cT cS ccom cfv vy cv vz cv
      cT cS ccom cfv cX cns cfv co cX cpv cfv co vx cv cS cfv cT cfv vy cv vz
      cv cS cfv cT cfv cX cns cfv co cX cpv cfv co wceq vx cv cU cba cfv wcel
      vy cv cc wcel vz cv cU cba cfv wcel wa vx cv cT cS ccom cfv vx cv cS cfv
      cT cfv vy cv vz cv cT cS ccom cfv cX cns cfv co vy cv vz cv cS cfv cT cfv
      cX cns cfv co cX cpv cfv cT wfun cU cba cfv cW cba cfv cS wf vx cv cU cba
      cfv wcel vx cv cT cS ccom cfv vx cv cS cfv cT cfv wceq cW cba cfv cX cba
      cfv cT wf cT wfun cW cnv wcel cX cnv wcel cT cM wcel cW cba cfv cX cba
      cfv cT wf lnocoi.w lnocoi.x lnocoi.t cT cW cM cX cW cba cfv cX cba cfv cW
      cba cfv eqid cX cba cfv eqid lnocoi.m lnof mp3an cW cba cfv cX cba cfv cT
      ffun ax-mp cU cnv wcel cW cnv wcel cS cL wcel cU cba cfv cW cba cfv cS wf
      lnocoi.u lnocoi.w lnocoi.s cS cU cL cW cU cba cfv cW cba cfv cU cba cfv
      eqid cW cba cfv eqid lnocoi.l lnof mp3an cU cba cfv cW cba cfv vx cv cT
      cS fvco3 mp3an12 vz cv cU cba cfv wcel vy cv vz cv cT cS ccom cfv cX cns
      cfv co vy cv vz cv cS cfv cT cfv cX cns cfv co wceq vy cv cc wcel vz cv
      cU cba cfv wcel vz cv cT cS ccom cfv vz cv cS cfv cT cfv vy cv cX cns cfv
      cT wfun cU cba cfv cW cba cfv cS wf vz cv cU cba cfv wcel vz cv cT cS
      ccom cfv vz cv cS cfv cT cfv wceq cW cba cfv cX cba cfv cT wf cT wfun cW
      cnv wcel cX cnv wcel cT cM wcel cW cba cfv cX cba cfv cT wf lnocoi.w
      lnocoi.x lnocoi.t cT cW cM cX cW cba cfv cX cba cfv cW cba cfv eqid cX
      cba cfv eqid lnocoi.m lnof mp3an cW cba cfv cX cba cfv cT ffun ax-mp cU
      cnv wcel cW cnv wcel cS cL wcel cU cba cfv cW cba cfv cS wf lnocoi.u
      lnocoi.w lnocoi.s cS cU cL cW cU cba cfv cW cba cfv cU cba cfv eqid cW
      cba cfv eqid lnocoi.l lnof mp3an cU cba cfv cW cba cfv vz cv cT cS fvco3
      mp3an12 opreq2d adantl opreqan12d 3impb eqtr4d rgen3 mpbir2an $.
      $( [23-Apr-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    lnoadd.1 $e |- X = ( BaseSet ` U ) $.
    lnoadd.5 $e |- G = ( +v ` U ) $.
    lnoadd.6 $e |- H = ( +v ` W ) $.
    lnoadd.7 $e |- L = ( U LnOp W ) $.
    $( Addition property of a linear operator. $)
    lnoadd $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
  ( A e. X /\ B e. X ) ) -> ( T ` ( A G B ) ) = ( ( T ` A ) H ( T ` B ) ) ) $=
      cU cnv wcel cW cnv wcel cT cL wcel w3a cA cX wcel cB cX wcel wa wa cA c1
      cB cU cns cfv co cG co cT cfv cA cT cfv c1 cB cT cfv cW cns cfv co cH co
      cA cB cG co cT cfv cA cT cfv cB cT cfv cH co cU cnv wcel cW cnv wcel cT
      cL wcel w3a cA cX wcel c1 cc wcel cB cX wcel cA c1 cB cU cns cfv co cG co
      cT cfv cA cT cfv c1 cB cT cfv cW cns cfv co cH co wceq ax1cn cA c1 cB cU
      cns cfv cW cns cfv cT cU cG cH cL cW cX cW cba cfv lnoadd.1 cW cba cfv
      eqid lnoadd.5 lnoadd.6 cU cns cfv eqid cW cns cfv eqid lnoadd.7 lnolin
      mp3anr2 cU cnv wcel cW cnv wcel cT cL wcel w3a cA cX wcel cB cX wcel wa
      wa cA c1 cB cU cns cfv co cG co cA cB cG co cT cU cnv wcel cW cnv wcel cT
      cL wcel w3a cA cX wcel cB cX wcel wa wa c1 cB cU cns cfv co cB cA cG cU
      cnv wcel cW cnv wcel cA cX wcel cB cX wcel wa c1 cB cU cns cfv co cB wceq
      cT cL wcel cU cnv wcel cB cX wcel c1 cB cU cns cfv co cB wceq cA cX wcel
      cB cU cns cfv cU cX lnoadd.1 cU cns cfv eqid nvsid adantrl 3ad2antl1
      opreq2d fveq2d cU cnv wcel cW cnv wcel cT cL wcel w3a cA cX wcel cB cX
      wcel wa wa c1 cB cT cfv cW cns cfv co cB cT cfv cA cT cfv cH cU cnv wcel
      cW cnv wcel cT cL wcel w3a cB cX wcel c1 cB cT cfv cW cns cfv co cB cT
      cfv wceq cA cX wcel cU cnv wcel cW cnv wcel cT cL wcel w3a cB cX wcel cB
      cT cfv cW cba cfv wcel c1 cB cT cfv cW cns cfv co cB cT cfv wceq cX cW
      cba cfv cT wf cB cX wcel cB cT cfv cW cba cfv wcel cU cnv wcel cW cnv
      wcel cT cL wcel w3a cX cW cba cfv cB cT ffvelrn cT cU cL cW cX cW cba cfv
      lnoadd.1 cW cba cfv eqid lnoadd.7 lnof sylan cW cnv wcel cU cnv wcel cB
      cT cfv cW cba cfv wcel c1 cB cT cfv cW cns cfv co cB cT cfv wceq cT cL
      wcel cB cT cfv cW cns cfv cW cW cba cfv cW cba cfv eqid cW cns cfv eqid
      nvsid 3ad2antl2 syldan adantrl opreq2d 3eqtr3d $.
      $( [2-Aug-2008] $) $( [7-Dec-2007] $)
  $}

  ${
    lnosub.1 $e |- X = ( BaseSet ` U ) $.
    lnosub.5 $e |- M = ( -v ` U ) $.
    lnosub.6 $e |- N = ( -v ` W ) $.
    lnosub.7 $e |- L = ( U LnOp W ) $.
    $( Subtraction property of a linear operator. $)
    lnosub $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
  ( A e. X /\ B e. X ) ) -> ( T ` ( A M B ) ) = ( ( T ` A ) N ( T ` B ) ) ) $=
      cU cnv wcel cW cnv wcel cT cL wcel w3a cA cX wcel cB cX wcel wa wa cA c1
      cneg cB cU cns cfv co cU cpv cfv co cT cfv cA cT cfv c1 cneg cB cT cfv cW
      cns cfv co cW cpv cfv co cA cB cM co cT cfv cA cT cfv cB cT cfv cN co cU
      cnv wcel cW cnv wcel cT cL wcel w3a cA cX wcel c1 cneg cc wcel cB cX wcel
      cA c1 cneg cB cU cns cfv co cU cpv cfv co cT cfv cA cT cfv c1 cneg cB cT
      cfv cW cns cfv co cW cpv cfv co wceq c1 ax1cn negcli cA c1 cneg cB cU cns
      cfv cW cns cfv cT cU cU cpv cfv cW cpv cfv cL cW cX cW cba cfv lnosub.1
      cW cba cfv eqid cU cpv cfv eqid cW cpv cfv eqid cU cns cfv eqid cW cns
      cfv eqid lnosub.7 lnolin mp3anr2 cU cnv wcel cW cnv wcel cA cX wcel cB cX
      wcel wa cA cB cM co cT cfv cA c1 cneg cB cU cns cfv co cU cpv cfv co cT
      cfv wceq cT cL wcel cU cnv wcel cA cX wcel cB cX wcel wa wa cA cB cM co
      cA c1 cneg cB cU cns cfv co cU cpv cfv co cT cU cnv wcel cA cX wcel cB cX
      wcel cA cB cM co cA c1 cneg cB cU cns cfv co cU cpv cfv co wceq cA cB cU
      cns cfv cU cU cpv cfv cM cX lnosub.1 cU cpv cfv eqid cU cns cfv eqid
      lnosub.5 nvmval 3expb fveq2d 3ad2antl1 cU cnv wcel cW cnv wcel cT cL wcel
      w3a cA cX wcel cB cX wcel wa cA cT cfv cW cba cfv wcel cB cT cfv cW cba
      cfv wcel wa cA cT cfv cB cT cfv cN co cA cT cfv c1 cneg cB cT cfv cW cns
      cfv co cW cpv cfv co wceq cX cW cba cfv cT wf cA cX wcel cB cX wcel wa cA
      cT cfv cW cba cfv wcel cB cT cfv cW cba cfv wcel wa cU cnv wcel cW cnv
      wcel cT cL wcel w3a cX cW cba cfv cT wf cA cX wcel cB cX wcel cA cT cfv
      cW cba cfv wcel cB cT cfv cW cba cfv wcel wa cX cW cba cfv cT wf cA cX
      wcel wa cA cT cfv cW cba cfv wcel cX cW cba cfv cT wf cB cX wcel wa cB cT
      cfv cW cba cfv wcel cX cW cba cfv cA cT ffvelrn cX cW cba cfv cB cT
      ffvelrn anim12i anandis cT cU cL cW cX cW cba cfv lnosub.1 cW cba cfv
      eqid lnosub.7 lnof sylan cW cnv wcel cU cnv wcel cA cT cfv cW cba cfv
      wcel cB cT cfv cW cba cfv wcel wa cA cT cfv cB cT cfv cN co cA cT cfv c1
      cneg cB cT cfv cW cns cfv co cW cpv cfv co wceq cT cL wcel cW cnv wcel cA
      cT cfv cW cba cfv wcel cB cT cfv cW cba cfv wcel cA cT cfv cB cT cfv cN
      co cA cT cfv c1 cneg cB cT cfv cW cns cfv co cW cpv cfv co wceq cA cT cfv
      cB cT cfv cW cns cfv cW cW cpv cfv cN cW cba cfv cW cba cfv eqid cW cpv
      cfv eqid cW cns cfv eqid lnosub.6 nvmval 3expb 3ad2antl2 syldan 3eqtr4d
      $.
      $( [31-Dec-2007] $) $( [7-Dec-2007] $)
  $}

  ${
    lnomul.1 $e |- X = ( BaseSet ` U ) $.
    lnomul.5 $e |- R = ( .s ` U ) $.
    lnomul.6 $e |- S = ( .s ` W ) $.
    lnomul.7 $e |- L = ( U LnOp W ) $.
    $( Scalar multiplication property of a linear operator. $)
    lnomul $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
       ( A e. CC /\ B e. X ) ) -> ( T ` ( A R B ) ) = ( A S ( T ` B ) ) ) $=
      cU cnv wcel cW cnv wcel cT cL wcel w3a cA cc wcel cB cX wcel wa wa cU
      cn0v cfv cA cB cR co cU cpv cfv co cT cfv cU cn0v cfv cT cfv cA cB cT cfv
      cS co cW cpv cfv co cA cB cR co cT cfv cA cB cT cfv cS co cU cnv wcel cW
      cnv wcel cT cL wcel w3a cA cc wcel cB cX wcel wa cU cn0v cfv cX wcel cA
      cc wcel cB cX wcel w3a cU cn0v cfv cA cB cR co cU cpv cfv co cT cfv cU
      cn0v cfv cT cfv cA cB cT cfv cS co cW cpv cfv co wceq cU cnv wcel cW cnv
      wcel cA cc wcel cB cX wcel wa cU cn0v cfv cX wcel cA cc wcel cB cX wcel
      w3a cT cL wcel cU cnv wcel cA cc wcel cB cX wcel wa wa cU cn0v cfv cX
      wcel cA cc wcel cB cX wcel cU cnv wcel cU cn0v cfv cX wcel cA cc wcel cB
      cX wcel wa cU cX cU cn0v cfv lnomul.1 cU cn0v cfv eqid nvzcl adantr cU
      cnv wcel cA cc wcel cB cX wcel simprl cU cnv wcel cA cc wcel cB cX wcel
      simprr 3jca 3ad2antl1 cU cn0v cfv cA cB cR cS cT cU cU cpv cfv cW cpv cfv
      cL cW cX cW cba cfv lnomul.1 cW cba cfv eqid cU cpv cfv eqid cW cpv cfv
      eqid lnomul.5 lnomul.6 lnomul.7 lnolin syldan cU cnv wcel cW cnv wcel cA
      cc wcel cB cX wcel wa cU cn0v cfv cA cB cR co cU cpv cfv co cT cfv cA cB
      cR co cT cfv wceq cT cL wcel cU cnv wcel cA cc wcel cB cX wcel wa wa cU
      cn0v cfv cA cB cR co cU cpv cfv co cA cB cR co cT cU cnv wcel cA cc wcel
      cB cX wcel wa cA cB cR co cX wcel cU cn0v cfv cA cB cR co cU cpv cfv co
      cA cB cR co wceq cU cnv wcel cA cc wcel cB cX wcel cA cB cR co cX wcel cA
      cB cR cU cX lnomul.1 lnomul.5 nvscl 3expb cA cB cR co cU cU cpv cfv cX cU
      cn0v cfv lnomul.1 cU cpv cfv eqid cU cn0v cfv eqid nv0lid syldan fveq2d
      3ad2antl1 cU cnv wcel cW cnv wcel cT cL wcel w3a cA cc wcel cB cX wcel wa
      wa cU cn0v cfv cT cfv cA cB cT cfv cS co cW cpv cfv co cW cn0v cfv cA cB
      cT cfv cS co cW cpv cfv co cA cB cT cfv cS co cU cnv wcel cW cnv wcel cT
      cL wcel w3a cA cc wcel cB cX wcel wa wa cU cn0v cfv cT cfv cW cn0v cfv cA
      cB cT cfv cS co cW cpv cfv cU cnv wcel cW cnv wcel cT cL wcel w3a cU cn0v
      cfv cT cfv cW cn0v cfv wceq cA cc wcel cB cX wcel wa cU cn0v cfv cT cU cL
      cW cX cW cba cfv cW cn0v cfv lnomul.1 cW cba cfv eqid cU cn0v cfv eqid cW
      cn0v cfv eqid lnomul.7 lno0 adantr opreq1d cW cnv wcel cA cB cT cfv cS co
      cW cba cfv wcel cW cn0v cfv cA cB cT cfv cS co cW cpv cfv co cA cB cT cfv
      cS co wceq cU cnv wcel cW cnv wcel cT cL wcel w3a cA cc wcel cB cX wcel
      wa wa cA cB cT cfv cS co cW cW cpv cfv cW cba cfv cW cn0v cfv cW cba cfv
      eqid cW cpv cfv eqid cW cn0v cfv eqid nv0lid cU cnv wcel cW cnv wcel cT
      cL wcel w3a cW cnv wcel cA cc wcel cB cX wcel wa cU cnv wcel cW cnv wcel
      cT cL wcel 3simp2 adantr cW cnv wcel cA cc wcel cB cT cfv cW cba cfv wcel
      cA cB cT cfv cS co cW cba cfv wcel cU cnv wcel cW cnv wcel cT cL wcel w3a
      cA cc wcel cB cX wcel wa wa cA cB cT cfv cS cW cW cba cfv cW cba cfv eqid
      lnomul.6 nvscl cU cnv wcel cW cnv wcel cT cL wcel w3a cW cnv wcel cA cc
      wcel cB cX wcel wa cU cnv wcel cW cnv wcel cT cL wcel 3simp2 adantr cU
      cnv wcel cW cnv wcel cT cL wcel w3a cA cc wcel cB cX wcel simprl cU cnv
      wcel cW cnv wcel cT cL wcel w3a cB cX wcel cB cT cfv cW cba cfv wcel cA
      cc wcel cX cW cba cfv cT wf cB cX wcel cB cT cfv cW cba cfv wcel cU cnv
      wcel cW cnv wcel cT cL wcel w3a cX cW cba cfv cB cT ffvelrn cT cU cL cW
      cX cW cba cfv lnomul.1 cW cba cfv eqid lnomul.7 lnof sylan adantrl
      syl3anc sylanc eqtrd 3eqtr3d $.
      $( [17-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y D $.  $d x y J $.  $d x y K $.
    $d x y P $.  $d x y T $.  $d x y U $.  $d x y W $.  $d x y X $.
    nvcnpi3.1 $e |- X = ( BaseSet ` U ) $.
    nvcnpi3.m $e |- M = ( norm ` U ) $.
    nvcnpi3.n $e |- N = ( norm ` W ) $.
    nvcnpi3.r $e |- R = ( -v ` U ) $.
    nvcnpi3.8 $e |- C = ( IndMet ` U ) $.
    nvcnpi3.d $e |- D = ( IndMet ` W ) $.
    nvcnpi3.j $e |- J = ( Open ` C ) $.
    nvcnpi3.k $e |- K = ( Open ` D ) $.
    nvcnpi3.l $e |- L = ( U LnOp W ) $.
    nvcnpi3.t $e |- T e. L $.
    $( MAY BE REVISED - delete this if not used $)
    $( Epsilon-delta property of a linear operator continuous at a point.) $)
    nvcnpi3 $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ P e. X ) /\ ( T e.
  ( ( J CnP K ) ` P ) /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\
  A. y e. X ( ( M ` ( y R P ) ) <_ x -> ( N ` ( T ` ( y R P ) ) ) <_ A ) ) ) $=
      cU cnv wcel cW cnv wcel cP cX wcel w3a cT cP cJ cK ccnp co cfv wcel cA cr
      wcel cc0 cA clt wbr w3a wa cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr
      vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex cc0
      vx cv clt wbr vy cv cP cR co cM cfv vx cv cle wbr vy cv cP cR co cT cfv
      cN cfv cA cle wbr wi vy cX wral wa vx cr wrex cU cnv wcel cW cnv wcel cP
      cX wcel w3a cT cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt wbr w3a wa
      cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD
      co cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr vy cv cP cC
      co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cC cdm cdm
      wral wa vx cr wrex cC cme wcel cD cme wcel cP cC cdm cdm wcel w3a cT cP
      cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt wbr vy
      cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy
      cC cdm cdm wral wa vx cr wrex cU cnv wcel cW cnv wcel cP cX wcel w3a vx
      vy cA cC cD cP cT cJ cK cC cdm cdm cD cdm cdm cC cdm cdm eqid nvcnpi3.j
      cD cdm cdm eqid nvcnpi3.k metcnpi3 cU cnv wcel cW cnv wcel cP cX wcel w3a
      cC cme wcel cD cme wcel cP cC cdm cdm wcel cU cnv wcel cW cnv wcel cC cme
      wcel cP cX wcel cC cU nvcnpi3.8 imsmet 3ad2ant1 cW cnv wcel cU cnv wcel
      cD cme wcel cP cX wcel cD cW nvcnpi3.d imsmet 3ad2ant2 cU cnv wcel cP cX
      wcel cP cC cdm cdm wcel cW cnv wcel cU cnv wcel cP cX wcel cP cC cdm cdm
      wcel cU cnv wcel cX cC cdm cdm cP cC cU cX nvcnpi3.1 nvcnpi3.8 imsba
      eleq2d biimpa 3adant2 3jca sylan cU cnv wcel cW cnv wcel cP cX wcel w3a
      cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD
      co cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr vy cv cP cC
      co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cC cdm cdm
      wral wa vx cr wrex wb cT cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt
      wbr w3a cU cnv wcel cW cnv wcel cc0 vx cv clt wbr vy cv cP cC co vx cv
      cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cX wral wa vx cr
      wrex cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT
      cfv cD co cA cle wbr wi vy cC cdm cdm wral wa vx cr wrex wb cP cX wcel cU
      cnv wcel cc0 vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cT cfv cP
      cT cfv cD co cA cle wbr wi vy cX wral wa cc0 vx cv clt wbr vy cv cP cC co
      vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cC cdm cdm
      wral wa vx cr cU cnv wcel vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT
      cfv cD co cA cle wbr wi vy cX wral vy cv cP cC co vx cv cle wbr vy cv cT
      cfv cP cT cfv cD co cA cle wbr wi vy cC cdm cdm wral cc0 vx cv clt wbr cU
      cnv wcel vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle
      wbr wi vy cX cC cdm cdm cC cU cX nvcnpi3.1 nvcnpi3.8 imsba raleq1d anbi2d
      rexbidv 3ad2ant1 adantr mpbird cU cnv wcel cW cnv wcel cP cX wcel w3a cc0
      vx cv clt wbr vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co
      cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr vy cv cP cR co
      cM cfv vx cv cle wbr vy cv cP cR co cT cfv cN cfv cA cle wbr wi vy cX
      wral wa vx cr wrex wb cT cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt
      wbr w3a cU cnv wcel cW cnv wcel cP cX wcel w3a cc0 vx cv clt wbr vy cv cP
      cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cX wral
      wa cc0 vx cv clt wbr vy cv cP cR co cM cfv vx cv cle wbr vy cv cP cR co
      cT cfv cN cfv cA cle wbr wi vy cX wral wa vx cr cU cnv wcel cW cnv wcel
      cP cX wcel w3a vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co
      cA cle wbr wi vy cX wral vy cv cP cR co cM cfv vx cv cle wbr vy cv cP cR
      co cT cfv cN cfv cA cle wbr wi vy cX wral cc0 vx cv clt wbr cU cnv wcel
      cW cnv wcel cP cX wcel w3a vy cv cP cC co vx cv cle wbr vy cv cT cfv cP
      cT cfv cD co cA cle wbr wi vy cv cP cR co cM cfv vx cv cle wbr vy cv cP
      cR co cT cfv cN cfv cA cle wbr wi vy cX cU cnv wcel cW cnv wcel cP cX
      wcel vy cv cX wcel vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD
      co cA cle wbr wi vy cv cP cR co cM cfv vx cv cle wbr vy cv cP cR co cT
      cfv cN cfv cA cle wbr wi wb cU cnv wcel cW cnv wcel vy cv cX wcel cP cX
      wcel vy cv cP cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr
      wi vy cv cP cR co cM cfv vx cv cle wbr vy cv cP cR co cT cfv cN cfv cA
      cle wbr wi wb cU cnv wcel cW cnv wcel vy cv cX wcel cP cX wcel vy cv cP
      cC co vx cv cle wbr vy cv cT cfv cP cT cfv cD co cA cle wbr wi vy cv cP
      cR co cM cfv vx cv cle wbr vy cv cP cR co cT cfv cN cfv cA cle wbr wi wb
      cU cnv wcel cW cnv wcel wa vy cv cX wcel cP cX wcel wa wa vy cv cP cC co
      vx cv cle wbr vy cv cP cR co cM cfv vx cv cle wbr vy cv cT cfv cP cT cfv
      cD co cA cle wbr vy cv cP cR co cT cfv cN cfv cA cle wbr cU cnv wcel cW
      cnv wcel wa vy cv cX wcel cP cX wcel wa wa vy cv cP cC co vy cv cP cR co
      cM cfv vx cv cle cU cnv wcel vy cv cX wcel cP cX wcel wa vy cv cP cC co
      vy cv cP cR co cM cfv wceq cW cnv wcel cU cnv wcel vy cv cX wcel cP cX
      wcel vy cv cP cC co vy cv cP cR co cM cfv wceq vy cv cP cC cU cR cM cX
      nvcnpi3.1 nvcnpi3.r nvcnpi3.m nvcnpi3.8 imsdval 3expb adantlr breq1d cU
      cnv wcel cW cnv wcel wa vy cv cX wcel cP cX wcel wa wa vy cv cT cfv cP cT
      cfv cD co vy cv cP cR co cT cfv cN cfv cA cle cU cnv wcel cW cnv wcel wa
      vy cv cX wcel cP cX wcel wa wa vy cv cT cfv cP cT cfv cD co vy cv cT cfv
      cP cT cfv cW cnsb cfv co cN cfv vy cv cP cR co cT cfv cN cfv cW cnv wcel
      vy cv cT cfv cW cba cfv wcel cP cT cfv cW cba cfv wcel vy cv cT cfv cP cT
      cfv cD co vy cv cT cfv cP cT cfv cW cnsb cfv co cN cfv wceq cU cnv wcel
      cW cnv wcel wa vy cv cX wcel cP cX wcel wa wa vy cv cT cfv cP cT cfv cD
      cW cW cnsb cfv cN cW cba cfv cW cba cfv eqid cW cnsb cfv eqid nvcnpi3.n
      nvcnpi3.d imsdval cU cnv wcel cW cnv wcel vy cv cX wcel cP cX wcel wa
      simplr cU cnv wcel cW cnv wcel wa vy cv cX wcel vy cv cT cfv cW cba cfv
      wcel cP cX wcel cX cW cba cfv cT wf vy cv cX wcel vy cv cT cfv cW cba cfv
      wcel cU cnv wcel cW cnv wcel wa cX cW cba cfv vy cv cT ffvelrn cU cnv
      wcel cW cnv wcel cT cL wcel cX cW cba cfv cT wf nvcnpi3.t cT cU cL cW cX
      cW cba cfv nvcnpi3.1 cW cba cfv eqid nvcnpi3.l lnof mp3an3 sylan adantrr
      cU cnv wcel cW cnv wcel wa cP cX wcel cP cT cfv cW cba cfv wcel vy cv cX
      wcel cX cW cba cfv cT wf cP cX wcel cP cT cfv cW cba cfv wcel cU cnv wcel
      cW cnv wcel wa cX cW cba cfv cP cT ffvelrn cU cnv wcel cW cnv wcel cT cL
      wcel cX cW cba cfv cT wf nvcnpi3.t cT cU cL cW cX cW cba cfv nvcnpi3.1 cW
      cba cfv eqid nvcnpi3.l lnof mp3an3 sylan adantrl syl3anc cU cnv wcel cW
      cnv wcel wa vy cv cX wcel cP cX wcel wa wa vy cv cP cR co cT cfv vy cv cT
      cfv cP cT cfv cW cnsb cfv co cN cU cnv wcel cW cnv wcel cT cL wcel vy cv
      cX wcel cP cX wcel wa vy cv cP cR co cT cfv vy cv cT cfv cP cT cfv cW
      cnsb cfv co wceq nvcnpi3.t vy cv cP cT cU cL cR cW cnsb cfv cW cX
      nvcnpi3.1 nvcnpi3.r cW cnsb cfv eqid nvcnpi3.l lnosub mp3anl3 fveq2d
      eqtr4d breq1d imbi12d exp43 com34 3imp1 ralbidva anbi2d rexbidv adantr
      mpbid $.
      $( [9-Aug-2008] $) $( [16-Dec-2007] $)

    $( MAY BE REVISED - delete this if not used $)
    $( Epsilon-delta property of a linear operator continuous at a point.) $)
    nvcnpi4 $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ P e. X ) /\ ( T e. ( (
    J CnP K ) ` P ) /\ A e. RR /\ 0 < A ) ) -> E. x e. RR ( 0 < x /\ A. y e. X
    ( ( M ` ( P R y ) ) <_ x -> ( N ` ( T ` ( P R y ) ) ) <_ A ) ) ) $=
      cU cnv wcel cW cnv wcel cP cX wcel w3a cT cP cJ cK ccnp co cfv wcel cA cr
      wcel cc0 cA clt wbr w3a wa cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr
      cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy cX wral wa vx cr wrex cc0
      vx cv clt wbr cP vy cv cR co cM cfv vx cv cle wbr cP vy cv cR co cT cfv
      cN cfv cA cle wbr wi vy cX wral wa vx cr wrex cU cnv wcel cW cnv wcel cP
      cX wcel w3a cT cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt wbr w3a wa
      cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD
      co cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cC
      co vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy cC cdm cdm
      wral wa vx cr wrex cC cme wcel cD cme wcel cP cC cdm cdm wcel w3a cT cP
      cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt wbr w3a cc0 vx cv clt wbr cP
      vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy
      cC cdm cdm wral wa vx cr wrex cU cnv wcel cW cnv wcel cP cX wcel w3a vx
      vy cA cC cD cP cT cJ cK cC cdm cdm cD cdm cdm cC cdm cdm eqid nvcnpi3.j
      cD cdm cdm eqid nvcnpi3.k metcnpi4 cU cnv wcel cW cnv wcel cP cX wcel w3a
      cC cme wcel cD cme wcel cP cC cdm cdm wcel cU cnv wcel cW cnv wcel cC cme
      wcel cP cX wcel cC cU nvcnpi3.8 imsmet 3ad2ant1 cW cnv wcel cU cnv wcel
      cD cme wcel cP cX wcel cD cW nvcnpi3.d imsmet 3ad2ant2 cU cnv wcel cP cX
      wcel cP cC cdm cdm wcel cW cnv wcel cU cnv wcel cP cX wcel cP cC cdm cdm
      wcel cU cnv wcel cX cC cdm cdm cP cC cU cX nvcnpi3.1 nvcnpi3.8 imsba
      eleq2d biimpa 3adant2 3jca sylan cU cnv wcel cW cnv wcel cP cX wcel w3a
      cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD
      co cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cC
      co vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy cC cdm cdm
      wral wa vx cr wrex wb cT cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt
      wbr w3a cU cnv wcel cW cnv wcel cc0 vx cv clt wbr cP vy cv cC co vx cv
      cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy cX wral wa vx cr
      wrex cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT
      cfv cD co cA cle wbr wi vy cC cdm cdm wral wa vx cr wrex wb cP cX wcel cU
      cnv wcel cc0 vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cT cfv vy cv
      cT cfv cD co cA cle wbr wi vy cX wral wa cc0 vx cv clt wbr cP vy cv cC co
      vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy cC cdm cdm
      wral wa vx cr cU cnv wcel cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT
      cfv cD co cA cle wbr wi vy cX wral cP vy cv cC co vx cv cle wbr cP cT cfv
      vy cv cT cfv cD co cA cle wbr wi vy cC cdm cdm wral cc0 vx cv clt wbr cU
      cnv wcel cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle
      wbr wi vy cX cC cdm cdm cC cU cX nvcnpi3.1 nvcnpi3.8 imsba raleq1d anbi2d
      rexbidv 3ad2ant1 adantr mpbird cU cnv wcel cW cnv wcel cP cX wcel w3a cc0
      vx cv clt wbr cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD co
      cA cle wbr wi vy cX wral wa vx cr wrex cc0 vx cv clt wbr cP vy cv cR co
      cM cfv vx cv cle wbr cP vy cv cR co cT cfv cN cfv cA cle wbr wi vy cX
      wral wa vx cr wrex wb cT cP cJ cK ccnp co cfv wcel cA cr wcel cc0 cA clt
      wbr w3a cU cnv wcel cW cnv wcel cP cX wcel w3a cc0 vx cv clt wbr cP vy cv
      cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr wi vy cX wral
      wa cc0 vx cv clt wbr cP vy cv cR co cM cfv vx cv cle wbr cP vy cv cR co
      cT cfv cN cfv cA cle wbr wi vy cX wral wa vx cr cU cnv wcel cW cnv wcel
      cP cX wcel w3a cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD co
      cA cle wbr wi vy cX wral cP vy cv cR co cM cfv vx cv cle wbr cP vy cv cR
      co cT cfv cN cfv cA cle wbr wi vy cX wral cc0 vx cv clt wbr cU cnv wcel
      cW cnv wcel cP cX wcel w3a cP vy cv cC co vx cv cle wbr cP cT cfv vy cv
      cT cfv cD co cA cle wbr wi cP vy cv cR co cM cfv vx cv cle wbr cP vy cv
      cR co cT cfv cN cfv cA cle wbr wi vy cX cU cnv wcel cW cnv wcel cP cX
      wcel vy cv cX wcel cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD
      co cA cle wbr wi cP vy cv cR co cM cfv vx cv cle wbr cP vy cv cR co cT
      cfv cN cfv cA cle wbr wi wb cU cnv wcel cW cnv wcel cP cX wcel vy cv cX
      wcel cP vy cv cC co vx cv cle wbr cP cT cfv vy cv cT cfv cD co cA cle wbr
      wi cP vy cv cR co cM cfv vx cv cle wbr cP vy cv cR co cT cfv cN cfv cA
      cle wbr wi wb cU cnv wcel cW cnv wcel wa cP cX wcel vy cv cX wcel wa wa
      cP vy cv cC co vx cv cle wbr cP vy cv cR co cM cfv vx cv cle wbr cP cT
      cfv vy cv cT cfv cD co cA cle wbr cP vy cv cR co cT cfv cN cfv cA cle wbr
      cU cnv wcel cW cnv wcel wa cP cX wcel vy cv cX wcel wa wa cP vy cv cC co
      cP vy cv cR co cM cfv vx cv cle cU cnv wcel cP cX wcel vy cv cX wcel wa
      cP vy cv cC co cP vy cv cR co cM cfv wceq cW cnv wcel cU cnv wcel cP cX
      wcel vy cv cX wcel cP vy cv cC co cP vy cv cR co cM cfv wceq cP vy cv cC
      cU cR cM cX nvcnpi3.1 nvcnpi3.r nvcnpi3.m nvcnpi3.8 imsdval 3expb adantlr
      breq1d cU cnv wcel cW cnv wcel wa cP cX wcel vy cv cX wcel wa wa cP cT
      cfv vy cv cT cfv cD co cP vy cv cR co cT cfv cN cfv cA cle cU cnv wcel cW
      cnv wcel wa cP cX wcel vy cv cX wcel wa wa cP cT cfv vy cv cT cfv cD co
      cP cT cfv vy cv cT cfv cW cnsb cfv co cN cfv cP vy cv cR co cT cfv cN cfv
      cW cnv wcel cP cT cfv cW cba cfv wcel vy cv cT cfv cW cba cfv wcel cP cT
      cfv vy cv cT cfv cD co cP cT cfv vy cv cT cfv cW cnsb cfv co cN cfv wceq
      cU cnv wcel cW cnv wcel wa cP cX wcel vy cv cX wcel wa wa cP cT cfv vy cv
      cT cfv cD cW cW cnsb cfv cN cW cba cfv cW cba cfv eqid cW cnsb cfv eqid
      nvcnpi3.n nvcnpi3.d imsdval cU cnv wcel cW cnv wcel cP cX wcel vy cv cX
      wcel wa simplr cU cnv wcel cW cnv wcel wa cP cX wcel cP cT cfv cW cba cfv
      wcel vy cv cX wcel cX cW cba cfv cT wf cP cX wcel cP cT cfv cW cba cfv
      wcel cU cnv wcel cW cnv wcel wa cX cW cba cfv cP cT ffvelrn cU cnv wcel
      cW cnv wcel cT cL wcel cX cW cba cfv cT wf nvcnpi3.t cT cU cL cW cX cW
      cba cfv nvcnpi3.1 cW cba cfv eqid nvcnpi3.l lnof mp3an3 sylan adantrr cU
      cnv wcel cW cnv wcel wa vy cv cX wcel vy cv cT cfv cW cba cfv wcel cP cX
      wcel cX cW cba cfv cT wf vy cv cX wcel vy cv cT cfv cW cba cfv wcel cU
      cnv wcel cW cnv wcel wa cX cW cba cfv vy cv cT ffvelrn cU cnv wcel cW cnv
      wcel cT cL wcel cX cW cba cfv cT wf nvcnpi3.t cT cU cL cW cX cW cba cfv
      nvcnpi3.1 cW cba cfv eqid nvcnpi3.l lnof mp3an3 sylan adantrl syl3anc cU
      cnv wcel cW cnv wcel wa cP cX wcel vy cv cX wcel wa wa cP vy cv cR co cT
      cfv cP cT cfv vy cv cT cfv cW cnsb cfv co cN cU cnv wcel cW cnv wcel cT
      cL wcel cP cX wcel vy cv cX wcel wa cP vy cv cR co cT cfv cP cT cfv vy cv
      cT cfv cW cnsb cfv co wceq nvcnpi3.t cP vy cv cT cU cL cR cW cnsb cfv cW
      cX nvcnpi3.1 nvcnpi3.r cW cnsb cfv eqid nvcnpi3.l lnosub mp3anl3 fveq2d
      eqtr4d breq1d imbi12d exp43 3imp1 ralbidva anbi2d rexbidv adantr mpbid $.
      $( [4-Jan-2008] $) $( [16-Dec-2007] $)
  $}

  ${
    nvo00.1 $e |- X = ( BaseSet ` U ) $.
    $( Two ways to express a zero operator. $)
    nvo00 $p |- ( ( U e. NrmCVec /\ T : X --> Y ) ->
                  ( T = ( X X. { Z } ) <-> ran T = { Z } ) ) $=
      cX cY cT wf cU cnv wcel cT cX cZ csn cxp wceq cT crn cZ csn wceq wb cT cX
      wfn cX c0 wne cT cX cZ csn cxp wceq cT crn cZ csn wceq wb cX cY cT wf cU
      cnv wcel cX cZ cT fconst5 cX cY cT ffn cU cnv wcel cU cn0v cfv cX wcel cX
      c0 wne cU cX cU cn0v cfv nvo00.1 cU cn0v cfv eqid nvzcl cX cU cn0v cfv
      ne0i syl syl2an ancoms $.
      $( [22-Feb-2008] $) $( [27-Nov-2007] $)
  $}

  ${
    $d n t u w y L $.  $d n t w y M $.  $d t x y z T $.  $d n t u w x y z U $.
    $d n t u w x y z W $.  $d n t u w x y z X $.  $d n t w x y Y $.
    nmofval.1 $e |- X = ( BaseSet ` U ) $.
    nmofval.2 $e |- Y = ( BaseSet ` W ) $.
    nmofval.3 $e |- L = ( norm ` U ) $.
    nmofval.4 $e |- M = ( norm ` W ) $.
    nmofval.6 $e |- N = ( U normOp W ) $.
    $( The operator norm function. $)
    nmofval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> N =
   { <. t , y >. | ( t : X --> Y /\ y = sup ( { x | E. z e. X
       ( ( L ` z ) <_ 1 /\ x = ( M ` ( t ` z ) ) ) } , RR* , < ) ) } ) $=
      cU cnv wcel cW cnv wcel wa cU cW cnmo co cX cY vt cv wf vy cv vz cv cL
      cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr
      clt csup wceq wa vt vy copab cN vu vw vn cU cW cnv cnv vu cv cba cfv vw
      cv cba cfv vt cv wf vy cv vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv
      vt cv cfv vw cv cnm cfv cfv wceq wa vz vu cv cba cfv wrex vx cab cxr clt
      csup wceq wa vt vy copab cX cY vt cv wf vy cv vz cv cL cfv c1 cle wbr vx
      cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa
      vt vy copab cnmo cX vw cv cba cfv vt cv wf vy cv vz cv cL cfv c1 cle wbr
      vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt
      csup wceq wa vt vy copab vt cv cY cX cm co wcel vy cv vz cv cL cfv c1 cle
      wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup
      wceq wa vt vy copab cX cY vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz
      cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa vt vy
      copab cvv vt cv cY cX cm co wcel vy cv vz cv cL cfv c1 cle wbr vx cv vz
      cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa cX cY
      vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq
      wa vz cX wrex vx cab cxr clt csup wceq wa vt vy vt cv cY cX cm co wcel cX
      cY vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv
      wceq wa vz cX wrex vx cab cxr clt csup wceq cY cX vt cv cY cW cba cfv cvv
      nmofval.2 cW cba fvex eqeltri cX cU cba cfv cvv nmofval.1 cU cba fvex
      eqeltri elmap anbi1i opabbii vt vy cY cX cm co vz cv cL cfv c1 cle wbr vx
      cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup cY cX cm
      oprex opabex2 eqeltrri vu cv cU wceq vu cv cba cfv vw cv cba cfv vt cv wf
      vy cv vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm
      cfv cfv wceq wa vz vu cv cba cfv wrex vx cab cxr clt csup wceq wa cX vw
      cv cba cfv vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv
      vw cv cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa vt vy vu
      cv cU wceq vu cv cba cfv vw cv cba cfv vt cv wf cX vw cv cba cfv vt cv wf
      vy cv vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm
      cfv cfv wceq wa vz vu cv cba cfv wrex vx cab cxr clt csup wceq vy cv vz
      cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz
      cX wrex vx cab cxr clt csup wceq vu cv cU wceq vu cv cba cfv cX wceq vu
      cv cba cfv vw cv cba cfv vt cv wf cX vw cv cba cfv vt cv wf wb vu cv cU
      wceq vu cv cba cfv cU cba cfv cX vu cv cU cba fveq2 nmofval.1 syl6eqr vu
      cv cba cfv cX vw cv cba cfv vt cv feq2 syl vu cv cU wceq vz cv vu cv cnm
      cfv cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz vu
      cv cba cfv wrex vx cab cxr clt csup vz cv cL cfv c1 cle wbr vx cv vz cv
      vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup vy cv
      vu cv cU wceq vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv vt cv cfv vw
      cv cnm cfv cfv wceq wa vz vu cv cba cfv wrex vx cab vz cv cL cfv c1 cle
      wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx cab
      wceq vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm
      cfv cfv wceq wa vz vu cv cba cfv wrex vx cab cxr clt csup vz cv cL cfv c1
      cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx cab
      cxr clt csup wceq vu cv cU wceq vz cv vu cv cnm cfv cfv c1 cle wbr vx cv
      vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz vu cv cba cfv wrex vz cv cL
      cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex
      vx vu cv cU wceq vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv vt cv cfv
      vw cv cnm cfv cfv wceq wa vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv
      vw cv cnm cfv cfv wceq wa vz vu cv cba cfv cX vu cv cU wceq vu cv cba cfv
      cU cba cfv cX vu cv cU cba fveq2 nmofval.1 syl6eqr vu cv cU wceq vz cv vu
      cv cnm cfv cfv c1 cle wbr vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv
      vw cv cnm cfv cfv wceq vu cv cU wceq vz cv vu cv cnm cfv cfv vz cv cL cfv
      c1 cle vu cv cU wceq vz cv vu cv cnm cfv cL vu cv cU wceq vu cv cnm cfv
      cU cnm cfv cL vu cv cU cnm fveq2 nmofval.3 syl6eqr fveq1d breq1d anbi1d
      rexeq12d abbidv cxr vz cv vu cv cnm cfv cfv c1 cle wbr vx cv vz cv vt cv
      cfv vw cv cnm cfv cfv wceq wa vz vu cv cba cfv wrex vx cab vz cv cL cfv
      c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx
      cab clt supeq1 syl eqeq2d anbi12d opabbidv vw cv cW wceq cX vw cv cba cfv
      vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm
      cfv cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa cX cY vt cv wf vy
      cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX
      wrex vx cab cxr clt csup wceq wa vt vy vw cv cW wceq cX vw cv cba cfv vt
      cv wf cX cY vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv
      vw cv cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup wceq vy cv vz cv
      cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab
      cxr clt csup wceq vw cv cW wceq vw cv cba cfv cY wceq cX vw cv cba cfv vt
      cv wf cX cY vt cv wf wb vw cv cW wceq vw cv cba cfv cW cba cfv cY vw cv
      cW cba fveq2 nmofval.2 syl6eqr vw cv cba cfv cY cX vt cv feq3 syl vw cv
      cW wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv
      wceq wa vz cX wrex vx cab cxr clt csup vz cv cL cfv c1 cle wbr vx cv vz
      cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup vy cv vw cv cW
      wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq
      wa vz cX wrex vx cab vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv
      wceq wa vz cX wrex vx cab wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv
      cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup vz cv cL cfv
      c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt
      csup wceq vw cv cW wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv vw
      cv cnm cfv cfv wceq wa vz cX wrex vz cv cL cfv c1 cle wbr vx cv vz cv vt
      cv cfv cM cfv wceq wa vz cX wrex vx vw cv cW wceq vz cv cL cfv c1 cle wbr
      vx cv vz cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cv cL cfv c1 cle wbr
      vx cv vz cv vt cv cfv cM cfv wceq wa vz cX vw cv cW wceq vx cv vz cv vt
      cv cfv vw cv cnm cfv cfv wceq vx cv vz cv vt cv cfv cM cfv wceq vz cv cL
      cfv c1 cle wbr vw cv cW wceq vz cv vt cv cfv vw cv cnm cfv cfv vz cv vt
      cv cfv cM cfv vx cv vw cv cW wceq vz cv vt cv cfv vw cv cnm cfv cM vw cv
      cW wceq vw cv cnm cfv cW cnm cfv cM vw cv cW cnm fveq2 nmofval.4 syl6eqr
      fveq1d eqeq2d anbi2d rexbidv abbidv cxr vz cv cL cfv c1 cle wbr vx cv vz
      cv vt cv cfv vw cv cnm cfv cfv wceq wa vz cX wrex vx cab vz cv cL cfv c1
      cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab clt supeq1
      syl eqeq2d anbi12d opabbidv vx vy vz vw vu vt vn df-nmo oprabval2
      nmofval.6 syl5eq $.
      $( [10-Dec-2007] $) $( [6-Nov-2007] $)

    $( The operator norm function. $)
    nmoval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
  ( N ` T ) = sup ( { x | E. z e. X
       ( ( L ` z ) <_ 1 /\ x = ( M ` ( T ` z ) ) ) } , RR* , < ) ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cT cX cY vt cv wf vy cv
      vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex
      vx cab cxr clt csup wceq wa vt vy copab cfv vz cv cL cfv c1 cle wbr vx cv
      vz cv cT cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup cU cnv wcel cW
      cnv wcel cT cN cfv cT cX cY vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv
      vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa vt
      vy copab cfv wceq cX cY cT wf cU cnv wcel cW cnv wcel wa cT cN cX cY vt
      cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa
      vz cX wrex vx cab cxr clt csup wceq wa vt vy copab vx vy vz vt cU cL cM
      cN cW cX cY nmofval.1 nmofval.2 nmofval.3 nmofval.4 nmofval.6 nmofval
      fveq1d 3adant3 cX cY cT wf cU cnv wcel cT cX cY vt cv wf vy cv vz cv cL
      cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr
      clt csup wceq wa vt vy copab cfv vz cv cL cfv c1 cle wbr vx cv vz cv cT
      cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup wceq cW cnv wcel vt vy
      cT vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX
      wrex vx cab cxr clt csup vz cv cL cfv c1 cle wbr vx cv vz cv cT cfv cM
      cfv wceq wa vz cX wrex vx cab cxr clt csup cX cY cX cY vt cv wf vy cv vz
      cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx
      cab cxr clt csup wceq wa vt vy copab cxr vz cv cL cfv c1 cle wbr vx cv vz
      cv cT cfv cM cfv wceq wa vz cX wrex vx cab clt xrltso supex cX cU cba cfv
      cvv nmofval.1 cU cba fvex eqeltri cY cW cba cfv cvv nmofval.2 cW cba fvex
      eqeltri vt cv cT wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM
      cfv wceq wa vz cX wrex vx cab vz cv cL cfv c1 cle wbr vx cv vz cv cT cfv
      cM cfv wceq wa vz cX wrex vx cab wceq vz cv cL cfv c1 cle wbr vx cv vz cv
      vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup vz cv cL cfv c1
      cle wbr vx cv vz cv cT cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup
      wceq vt cv cT wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv
      wceq wa vz cX wrex vz cv cL cfv c1 cle wbr vx cv vz cv cT cfv cM cfv wceq
      wa vz cX wrex vx vt cv cT wceq vz cv cL cfv c1 cle wbr vx cv vz cv vt cv
      cfv cM cfv wceq wa vz cv cL cfv c1 cle wbr vx cv vz cv cT cfv cM cfv wceq
      wa vz cX vt cv cT wceq vx cv vz cv vt cv cfv cM cfv wceq vx cv vz cv cT
      cfv cM cfv wceq vz cv cL cfv c1 cle wbr vt cv cT wceq vz cv vt cv cfv cM
      cfv vz cv cT cfv cM cfv vx cv vt cv cT wceq vz cv vt cv cfv vz cv cT cfv
      cM vz cv vt cv cT fveq1 fveq2d eqeq2d anbi2d rexbidv abbidv cxr vz cv cL
      cfv c1 cle wbr vx cv vz cv vt cv cfv cM cfv wceq wa vz cX wrex vx cab vz
      cv cL cfv c1 cle wbr vx cv vz cv cT cfv cM cfv wceq wa vz cX wrex vx cab
      clt supeq1 syl cX cY vt cv wf vy cv vz cv cL cfv c1 cle wbr vx cv vz cv
      vt cv cfv cM cfv wceq wa vz cX wrex vx cab cxr clt csup wceq wa vt vy
      copab eqid fvopabf4 3ad2ant3 eqtrd $.
      $( [11-Dec-2007] $) $( [27-Nov-2007] $)
  $}

  ${
    $d x z T $.  $d x z W $.  $d x z X $.  $d x z Y $.
    nmosetre.2 $e |- Y = ( BaseSet ` W ) $.
    nmosetre.4 $e |- N = ( norm ` W ) $.
    $( The set in the supremum of the operator norm definition ~ df-nmo is a
       set of reals. $)
    nmosetre $p |- ( ( W e. NrmCVec /\ T : X --> Y ) -> {
     x | E. z e. X ( ( M ` z ) <_ 1 /\ x = ( N ` ( T ` z ) ) ) } C_ RR ) $=
      cW cnv wcel cX cY cT wf wa vz cv cM cfv c1 cle wbr vx cv vz cv cT cfv cN
      cfv wceq wa vz cX wrex vx cr cW cnv wcel cX cY cT wf wa vz cv cM cfv c1
      cle wbr vx cv vz cv cT cfv cN cfv wceq wa vx cv cr wcel vz cX cW cnv wcel
      cX cY cT wf wa vz cv cX wcel vz cv cM cfv c1 cle wbr vx cv vz cv cT cfv
      cN cfv wceq wa vx cv cr wcel cW cnv wcel cX cY cT wf wa vz cv cX wcel wa
      vx cv vz cv cT cfv cN cfv wceq vx cv cr wcel vz cv cM cfv c1 cle wbr vx
      cv vz cv cT cfv cN cfv wceq cW cnv wcel cX cY cT wf wa vz cv cX wcel wa
      vx cv cr wcel vx cv vz cv cT cfv cN cfv wceq vx cv cr wcel vz cv cT cfv
      cN cfv cr wcel cW cnv wcel cX cY cT wf wa vz cv cX wcel wa vx cv vz cv cT
      cfv cN cfv cr eleq1 cW cnv wcel cX cY cT wf vz cv cX wcel vz cv cT cfv cN
      cfv cr wcel cW cnv wcel vz cv cT cfv cY wcel vz cv cT cfv cN cfv cr wcel
      cX cY cT wf vz cv cX wcel wa vz cv cT cfv cW cN cY nmosetre.2 nmosetre.4
      nvcl cX cY vz cv cT ffvelrn sylan2 anassrs syl5bir impcom adantrl exp31
      r19.23adv abssdv $.
      $( [14-Dec-2007] $) $( [13-Nov-2007] $)
  $}

  ${
    $d x y M $.  $d x y N $.  $d x y T $.  $d x y X $.  $d x y Z $.
    nmosetn0.1 $e |- X = ( BaseSet ` U ) $.
    nmosetn0.5 $e |- Z = ( 0v ` U ) $.
    nmosetn0.4 $e |- M = ( norm ` U ) $.
    $( The set in the supremum of the operator norm definition ~ df-nmo is
       nonempty. $)
    nmosetn0 $p |- ( U e. NrmCVec -> ( N ` ( T ` Z ) ) e. { x | E. y e. X (
       ( M ` y ) <_ 1 /\ x = ( N ` ( T ` y ) ) ) } ) $=
      cU cnv wcel vy cv cM cfv c1 cle wbr cZ cT cfv cN cfv vy cv cT cfv cN cfv
      wceq wa vy cX wrex cZ cT cfv cN cfv vy cv cM cfv c1 cle wbr vx cv vy cv
      cT cfv cN cfv wceq wa vy cX wrex vx cab wcel cZ cX wcel cZ cM cfv c1 cle
      wbr cZ cT cfv cN cfv cZ cT cfv cN cfv wceq wa vy cv cM cfv c1 cle wbr cZ
      cT cfv cN cfv vy cv cT cfv cN cfv wceq wa vy cX wrex cU cnv wcel vy cv cM
      cfv c1 cle wbr cZ cT cfv cN cfv vy cv cT cfv cN cfv wceq wa cZ cM cfv c1
      cle wbr cZ cT cfv cN cfv cZ cT cfv cN cfv wceq wa vy cZ cX vy cv cZ wceq
      vy cv cM cfv c1 cle wbr cZ cM cfv c1 cle wbr cZ cT cfv cN cfv vy cv cT
      cfv cN cfv wceq cZ cT cfv cN cfv cZ cT cfv cN cfv wceq vy cv cZ wceq vy
      cv cM cfv cZ cM cfv c1 cle vy cv cZ cM fveq2 breq1d vy cv cZ wceq vy cv
      cT cfv cN cfv cZ cT cfv cN cfv cZ cT cfv cN cfv vy cv cZ wceq vy cv cT
      cfv cZ cT cfv cN vy cv cZ cT fveq2 fveq2d eqeq2d anbi12d rcla4ev cU cX cZ
      nmosetn0.1 nmosetn0.5 nvzcl cU cnv wcel cZ cM cfv c1 cle wbr cZ cT cfv cN
      cfv cZ cT cfv cN cfv wceq cU cnv wcel cZ cM cfv cc0 c1 cle cU cM cZ
      nmosetn0.5 nmosetn0.4 nvz0 cc0 c1 0re 1re lt01 ltleii syl6eqbr cZ cT cfv
      cN cfv eqid jctir sylanc vy cv cM cfv c1 cle wbr vx cv vy cv cT cfv cN
      cfv wceq wa vy cX wrex vy cv cM cfv c1 cle wbr cZ cT cfv cN cfv vy cv cT
      cfv cN cfv wceq wa vy cX wrex vx cZ cT cfv cN cfv cZ cT cfv cN fvex vx cv
      cZ cT cfv cN cfv wceq vy cv cM cfv c1 cle wbr vx cv vy cv cT cfv cN cfv
      wceq wa vy cv cM cfv c1 cle wbr cZ cT cfv cN cfv vy cv cT cfv cN cfv wceq
      wa vy cX vx cv cZ cT cfv cN cfv wceq vx cv vy cv cT cfv cN cfv wceq cZ cT
      cfv cN cfv vy cv cT cfv cN cfv wceq vy cv cM cfv c1 cle wbr vx cv cZ cT
      cfv cN cfv vy cv cT cfv cN cfv eqeq1 anbi2d rexbidv elab sylibr $.
      $( [13-Dec-2007] $) $( [8-Dec-2007] $)
  $}

  ${
    $d x z T $.  $d x z U $.  $d x z W $.  $d x z X $.  $d x z Y $.
    nmoxr.1 $e |- X = ( BaseSet ` U ) $.
    nmoxr.2 $e |- Y = ( BaseSet ` W ) $.
    nmoxr.3 $e |- N = ( U normOp W ) $.
    $( The norm of an operator is an extended real. $)
    nmoxr $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
              ( N ` T ) e. RR* ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv vz cv cU cnm cfv cfv c1
      cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr
      clt csup cxr vx vz cT cU cU cnm cfv cW cnm cfv cN cW cX cY nmoxr.1
      nmoxr.2 cU cnm cfv eqid cW cnm cfv eqid nmoxr.3 nmoval cW cnv wcel cX cY
      cT wf vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv
      wceq wa vz cX wrex vx cab cxr clt csup cxr wcel cU cnv wcel cW cnv wcel
      cX cY cT wf wa vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm
      cfv cfv wceq wa vz cX wrex vx cab cxr wss vz cv cU cnm cfv cfv c1 cle wbr
      vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup
      cxr wcel cW cnv wcel cX cY cT wf wa vz cv cU cnm cfv cfv c1 cle wbr vx cv
      vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cr cxr vx vz cT cU
      cnm cfv cW cnm cfv cW cX cY nmoxr.2 cW cnm cfv eqid nmosetre cr cxr wss
      cW cnv wcel cX cY cT wf wa ressxr a1i sstrd vz cv cU cnm cfv cfv c1 cle
      wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab supxrcl
      syl 3adant1 eqeltrd $.
      $( [15-Dec-2007] $) $( [27-Nov-2007] $)

    $( The norm of an operator is nonnegative. $)
    nmoge0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                  0 <_ ( N ` T ) ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cc0 cU cn0v cfv cT cfv cW cnm cfv
      cfv cle wbr cU cn0v cfv cT cfv cW cnm cfv cfv cT cN cfv cle wbr cc0 cT cN
      cfv cle wbr cW cnv wcel cU cn0v cfv cT cfv cY wcel cc0 cU cn0v cfv cT cfv
      cW cnm cfv cfv cle wbr cU cnv wcel cW cnv wcel cX cY cT wf w3a cU cn0v
      cfv cT cfv cW cW cnm cfv cY nmoxr.2 cW cnm cfv eqid nvge0 cU cnv wcel cW
      cnv wcel cX cY cT wf 3simp2 cU cnv wcel cX cY cT wf cU cn0v cfv cT cfv cY
      wcel cW cnv wcel cX cY cT wf cU cnv wcel cU cn0v cfv cT cfv cY wcel cX cY
      cT wf cU cn0v cfv cX wcel cU cn0v cfv cT cfv cY wcel cU cnv wcel cX cY cU
      cn0v cfv cT ffvelrn cU cX cU cn0v cfv nmoxr.1 cU cn0v cfv eqid nvzcl
      sylan2 ancoms 3adant2 sylanc cU cnv wcel cW cnv wcel cX cY cT wf w3a cU
      cn0v cfv cT cfv cW cnm cfv cfv vz cv cU cnm cfv cfv c1 cle wbr vx cv vz
      cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup cT cN cfv
      cle cW cnv wcel cX cY cT wf cU cnv wcel cU cn0v cfv cT cfv cW cnm cfv cfv
      vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa
      vz cX wrex vx cab cxr clt csup cle wbr cW cnv wcel cX cY cT wf cU cnv
      wcel cU cn0v cfv cT cfv cW cnm cfv cfv vz cv cU cnm cfv cfv c1 cle wbr vx
      cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup cle
      wbr vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv
      wceq wa vz cX wrex vx cab cxr wss cU cn0v cfv cT cfv cW cnm cfv cfv vz cv
      cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX
      wrex vx cab wcel cU cn0v cfv cT cfv cW cnm cfv cfv vz cv cU cnm cfv cfv
      c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab
      cxr clt csup cle wbr cW cnv wcel cX cY cT wf wa cU cnv wcel vz cv cU cnm
      cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex
      vx cab cU cn0v cfv cT cfv cW cnm cfv cfv supxrub cW cnv wcel cX cY cT wf
      wa vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq
      wa vz cX wrex vx cab cr wss vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv
      cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr wss vx vz cT cU cnm
      cfv cW cnm cfv cW cX cY nmoxr.2 cW cnm cfv eqid nmosetre vz cv cU cnm cfv
      cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx
      cab cr wss cr cxr wss vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv
      cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr wss ressxr vz cv cU cnm cfv
      cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx
      cab cr cxr sstr mpan2 syl vx vz cT cU cU cnm cfv cW cnm cfv cX cU cn0v
      cfv nmoxr.1 cU cn0v cfv eqid cU cnm cfv eqid nmosetn0 syl2an 3impa 3comr
      vx vz cT cU cU cnm cfv cW cnm cfv cN cW cX cY nmoxr.1 nmoxr.2 cU cnm cfv
      eqid cW cnm cfv eqid nmoxr.3 nmoval breqtrrd cc0 cxr wcel cU cn0v cfv cT
      cfv cW cnm cfv cfv cxr wcel cT cN cfv cxr wcel cc0 cU cn0v cfv cT cfv cW
      cnm cfv cfv cle wbr cU cn0v cfv cT cfv cW cnm cfv cfv cT cN cfv cle wbr
      wa cc0 cT cN cfv cle wbr wi cU cnv wcel cW cnv wcel cX cY cT wf w3a cc0
      cU cn0v cfv cT cfv cW cnm cfv cfv cT cN cfv xrletr cc0 cxr wcel cU cnv
      wcel cW cnv wcel cX cY cT wf w3a cc0 cr wcel cc0 cxr wcel 0re cc0 rexr
      ax-mp a1i cU cnv wcel cW cnv wcel cX cY cT wf w3a cU cn0v cfv cT cfv cW
      cnm cfv cfv cr wcel cU cn0v cfv cT cfv cW cnm cfv cfv cxr wcel cW cnv
      wcel cU cn0v cfv cT cfv cY wcel cU cn0v cfv cT cfv cW cnm cfv cfv cr wcel
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cU cn0v cfv cT cfv cW cW cnm cfv
      cY nmoxr.2 cW cnm cfv eqid nvcl cU cnv wcel cW cnv wcel cX cY cT wf
      3simp2 cU cnv wcel cX cY cT wf cU cn0v cfv cT cfv cY wcel cW cnv wcel cX
      cY cT wf cU cnv wcel cU cn0v cfv cT cfv cY wcel cX cY cT wf cU cn0v cfv
      cX wcel cU cn0v cfv cT cfv cY wcel cU cnv wcel cX cY cU cn0v cfv cT
      ffvelrn cU cX cU cn0v cfv nmoxr.1 cU cn0v cfv eqid nvzcl sylan2 ancoms
      3adant2 sylanc cU cn0v cfv cT cfv cW cnm cfv cfv rexr syl cT cU cN cW cX
      cY nmoxr.1 nmoxr.2 nmoxr.3 nmoxr syl3anc mp2and $.
      $( [2-Jan-2008] $) $( [8-Dec-2007] $)

    $( The norm of an operator is either real or plus infinity. $)
    nmorepnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                   ( ( N ` T ) e. RR <-> ( N ` T ) =/= +oo ) ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a vz cv cU cnm cfv cfv c1 cle wbr
      vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup
      cr wcel vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv
      wceq wa vz cX wrex vx cab cxr clt csup cpnf wne cT cN cfv cr wcel cT cN
      cfv cpnf wne cU cnv wcel cW cnv wcel cX cY cT wf vz cv cU cnm cfv cfv c1
      cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr
      clt csup cr wcel vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW
      cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup cpnf wne wb cW cnv
      wcel cX cY cT wf wa cU cnv wcel vz cv cU cnm cfv cfv c1 cle wbr vx cv vz
      cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup cr wcel
      vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa
      vz cX wrex vx cab cxr clt csup cpnf wne wb vz cv cU cnm cfv cfv c1 cle
      wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab cr wss vz
      cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz
      cX wrex vx cab c0 wne vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv
      cW cnm cfv cfv wceq wa vz cX wrex vx cab cxr clt csup cr wcel vz cv cU
      cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX
      wrex vx cab cxr clt csup cpnf wne wb cW cnv wcel cX cY cT wf wa cU cnv
      wcel vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv
      wceq wa vz cX wrex vx cab supxrre2 vx vz cT cU cnm cfv cW cnm cfv cW cX
      cY nmoxr.2 cW cnm cfv eqid nmosetre cU cnv wcel cU cn0v cfv cT cfv cW cnm
      cfv cfv vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv
      wceq wa vz cX wrex vx cab wcel vz cv cU cnm cfv cfv c1 cle wbr vx cv vz
      cv cT cfv cW cnm cfv cfv wceq wa vz cX wrex vx cab c0 wne vx vz cT cU cU
      cnm cfv cW cnm cfv cX cU cn0v cfv nmoxr.1 cU cn0v cfv eqid cU cnm cfv
      eqid nmosetn0 vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm
      cfv cfv wceq wa vz cX wrex vx cab cU cn0v cfv cT cfv cW cnm cfv cfv ne0i
      syl syl2an ancoms 3impb cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv
      vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa
      vz cX wrex vx cab cxr clt csup cr vx vz cT cU cU cnm cfv cW cnm cfv cN cW
      cX cY nmoxr.1 nmoxr.2 cU cnm cfv eqid cW cnm cfv eqid nmoxr.3 nmoval
      eleq1d cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cpnf vz cv cU
      cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv wceq wa vz cX
      wrex vx cab cxr clt csup cpnf cU cnv wcel cW cnv wcel cX cY cT wf w3a cT
      cN cfv vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cT cfv cW cnm cfv cfv
      wceq wa vz cX wrex vx cab cxr clt csup cpnf vx vz cT cU cU cnm cfv cW cnm
      cfv cN cW cX cY nmoxr.1 nmoxr.2 cU cnm cfv eqid cW cnm cfv eqid nmoxr.3
      nmoval eqeq1d necon3bid 3bitr4d $.
      $( [16-Dec-2007] $) $( [8-Dec-2007] $)

    $( The norm of any operator is real iff it is less than plus infinity. $)
    nmoreltpnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                   ( ( N ` T ) e. RR <-> ( N ` T ) < +oo ) ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cr wcel cT cN cfv cpnf
      wne cT cN cfv cpnf clt wbr cT cU cN cW cX cY nmoxr.1 nmoxr.2 nmoxr.3
      nmorepnf cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cpnf clt wbr
      cT cN cfv cpnf cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cxr wcel
      cT cN cfv cpnf wceq cT cN cfv cpnf clt wbr wn wb cT cU cN cW cX cY
      nmoxr.1 nmoxr.2 nmoxr.3 nmoxr cT cN cfv nltpnft syl necon2abid bitr4d $.
      $( [29-Dec-2007] $) $( [8-Dec-2007] $)

    $( The norm of an operator is greater than minus infinity. $)
    nmogtmnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                  -oo < ( N ` T ) ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cr wcel cT cN cfv cpnf
      wceq wn wb cT cN cfv cr wcel cT cN cfv cpnf wceq wo cmnf cT cN cfv clt
      wbr cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cr wcel cT cN cfv
      cpnf wne cT cN cfv cpnf wceq wn cT cU cN cW cX cY nmoxr.1 nmoxr.2 nmoxr.3
      nmorepnf cT cN cfv cpnf df-ne syl6bb cT cN cfv cr wcel cT cN cfv cpnf
      wceq wn wb cT cN cfv cr wcel cT cN cfv cpnf wceq wb wn cT cN cfv cr wcel
      cT cN cfv cpnf wceq wo cT cN cfv cr wcel cT cN cfv cpnf wceq xor3 cT cN
      cfv cr wcel cT cN cfv cpnf wceq wb wn cT cN cfv cr wcel cT cN cfv cpnf
      wceq wo cT cN cfv cr wcel cT cN cfv cpnf wceq wa wn cT cN cfv cr wcel cT
      cN cfv cpnf wceq xor2 pm3.26bi sylbir cT cN cfv mnfltxr 3syl $.
      $( [27-Dec-2007] $) $( [8-Dec-2007] $)
  $}

  ${
    $d x y A $.  $d x y L $.  $d x y M $.  $d x y T $.  $d x y U $.
    $d x y W $.  $d x y X $.  $d x y Y $.
    nmolb.1 $e |- X = ( BaseSet ` U ) $.
    nmolb.2 $e |- Y = ( BaseSet ` W ) $.
    nmolb.l $e |- L = ( norm ` U ) $.
    nmolb.m $e |- M = ( norm ` W ) $.
    nmolb.3 $e |- N = ( U normOp W ) $.
    $( A lower bound for an operator norm. $)
    nmolb $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) /\
         ( A e. X /\ ( L ` A ) <_ 1 ) ) -> ( M ` ( T ` A ) ) <_ ( N ` T ) ) $=
      cU cnv wcel cW cnv wcel cX cY cT wf w3a cA cX wcel cA cL cfv c1 cle wbr
      wa wa cA cT cfv cM cfv vy cv cL cfv c1 cle wbr vx cv vy cv cT cfv cM cfv
      wceq wa vy cX wrex vx cab cxr clt csup cT cN cfv cle vy cv cL cfv c1 cle
      wbr vx cv vy cv cT cfv cM cfv wceq wa vy cX wrex vx cab cxr wss cA cT cfv
      cM cfv vy cv cL cfv c1 cle wbr vx cv vy cv cT cfv cM cfv wceq wa vy cX
      wrex vx cab wcel cA cT cfv cM cfv vy cv cL cfv c1 cle wbr vx cv vy cv cT
      cfv cM cfv wceq wa vy cX wrex vx cab cxr clt csup cle wbr cU cnv wcel cW
      cnv wcel cX cY cT wf w3a cA cX wcel cA cL cfv c1 cle wbr wa vy cv cL cfv
      c1 cle wbr vx cv vy cv cT cfv cM cfv wceq wa vy cX wrex vx cab cA cT cfv
      cM cfv supxrub cW cnv wcel cX cY cT wf vy cv cL cfv c1 cle wbr vx cv vy
      cv cT cfv cM cfv wceq wa vy cX wrex vx cab cxr wss cU cnv wcel cW cnv
      wcel cX cY cT wf wa vy cv cL cfv c1 cle wbr vx cv vy cv cT cfv cM cfv
      wceq wa vy cX wrex vx cab cr cxr vx vy cT cL cM cW cX cY nmolb.2 nmolb.m
      nmosetre cr cxr wss cW cnv wcel cX cY cT wf wa ressxr a1i sstrd 3adant1
      cA cX wcel cA cL cfv c1 cle wbr wa vy cv cL cfv c1 cle wbr cA cT cfv cM
      cfv vy cv cT cfv cM cfv wceq wa vy cX wrex cA cT cfv cM cfv vy cv cL cfv
      c1 cle wbr vx cv vy cv cT cfv cM cfv wceq wa vy cX wrex vx cab wcel vy cv
      cL cfv c1 cle wbr cA cT cfv cM cfv vy cv cT cfv cM cfv wceq wa cA cL cfv
      c1 cle wbr vy cA cX vy cv cA wceq vy cv cL cfv c1 cle wbr cA cT cfv cM
      cfv vy cv cT cfv cM cfv wceq wa cA cL cfv c1 cle wbr cA cT cfv cM cfv cA
      cT cfv cM cfv wceq wa cA cL cfv c1 cle wbr vy cv cA wceq vy cv cL cfv c1
      cle wbr cA cL cfv c1 cle wbr cA cT cfv cM cfv vy cv cT cfv cM cfv wceq cA
      cT cfv cM cfv cA cT cfv cM cfv wceq vy cv cA wceq vy cv cL cfv cA cL cfv
      c1 cle vy cv cA cL fveq2 breq1d vy cv cA wceq vy cv cT cfv cM cfv cA cT
      cfv cM cfv cA cT cfv cM cfv vy cv cA wceq vy cv cT cfv cA cT cfv cM vy cv
      cA cT fveq2 fveq2d eqeq2d anbi12d cA cT cfv cM cfv cA cT cfv cM cfv wceq
      cA cL cfv c1 cle wbr cA cT cfv cM cfv eqid biantru syl6bbr rcla4ev vy cv
      cL cfv c1 cle wbr vx cv vy cv cT cfv cM cfv wceq wa vy cX wrex vy cv cL
      cfv c1 cle wbr cA cT cfv cM cfv vy cv cT cfv cM cfv wceq wa vy cX wrex vx
      cA cT cfv cM cfv cA cT cfv cM fvex vx cv cA cT cfv cM cfv wceq vy cv cL
      cfv c1 cle wbr vx cv vy cv cT cfv cM cfv wceq wa vy cv cL cfv c1 cle wbr
      cA cT cfv cM cfv vy cv cT cfv cM cfv wceq wa vy cX vx cv cA cT cfv cM cfv
      wceq vx cv vy cv cT cfv cM cfv wceq cA cT cfv cM cfv vy cv cT cfv cM cfv
      wceq vy cv cL cfv c1 cle wbr vx cv cA cT cfv cM cfv vy cv cT cfv cM cfv
      eqeq1 anbi2d rexbidv elab sylibr syl2an cU cnv wcel cW cnv wcel cX cY cT
      wf w3a cT cN cfv vy cv cL cfv c1 cle wbr vx cv vy cv cT cfv cM cfv wceq
      wa vy cX wrex vx cab cxr clt csup wceq cA cX wcel cA cL cfv c1 cle wbr wa
      vx vy cT cU cL cM cN cW cX cY nmolb.1 nmolb.2 nmolb.l nmolb.m nmolb.3
      nmoval adantr breqtrrd $.
      $( [1-Jan-2008] $) $( [8-Dec-2007] $)
  $}

  ${
    $d w x z A $.  $d f k r w x y z L $.  $d f k r w x y z M $.  $d k r y N $.
    $d f k r w x y z T $.  $d y z U $.  $d y z W $.  $d f k r w x y z X $.
    $d k r x y z Y $.
    nmoubi.1 $e |- X = ( BaseSet ` U ) $.
    nmoubi.y $e |- Y = ( BaseSet ` W ) $.
    nmoubi.l $e |- L = ( norm ` U ) $.
    nmoubi.m $e |- M = ( norm ` W ) $.
    nmoubi.3 $e |- N = ( U normOp W ) $.
    nmoubi.u $e |- U e. NrmCVec $.
    nmoubi.w $e |- W e. NrmCVec $.
    $( An upper bound for an operator norm. $)
    nmoubi $p |- ( ( T : X --> Y /\ A e. RR* /\ A. x e. X ( ( L ` x )
             <_ 1 -> ( M ` ( T ` x ) ) <_ A ) ) -> ( N ` T ) <_ A ) $=
      cX cY cT wf cA cxr wcel vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA
      cle wbr wi vx cX wral w3a cT cN cfv vz cv cL cfv c1 cle wbr vy cv vz cv
      cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt csup cA cle cX cY cT wf
      cA cxr wcel cT cN cfv vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM cfv
      wceq wa vz cX wrex vy cab cxr clt csup wceq vx cv cL cfv c1 cle wbr vx cv
      cT cfv cM cfv cA cle wbr wi vx cX wral cU cnv wcel cW cnv wcel cX cY cT
      wf cT cN cfv vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz
      cX wrex vy cab cxr clt csup wceq nmoubi.u nmoubi.w vy vz cT cU cL cM cN
      cW cX cY nmoubi.1 nmoubi.y nmoubi.l nmoubi.m nmoubi.3 nmoval mp3an12
      3ad2ant1 vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX
      wrex vy cab cxr wss cA cxr wcel vw cv cA cle wbr vw vz cv cL cfv c1 cle
      wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab wral vz cv cL cfv
      c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt
      csup cA cle wbr cX cY cT wf cA cxr wcel vx cv cL cfv c1 cle wbr vx cv cT
      cfv cM cfv cA cle wbr wi vx cX wral w3a vw vz cv cL cfv c1 cle wbr vy cv
      vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cA supxrleub cX cY cT wf cA
      cxr wcel vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX
      wrex vy cab cxr wss vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle
      wbr wi vx cX wral cX cY cT wf vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv
      cM cfv wceq wa vz cX wrex vy cab cr cxr cW cnv wcel cX cY cT wf vz cv cL
      cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cr wss
      nmoubi.w vy vz cT cL cM cW cX cY nmoubi.y nmoubi.m nmosetre mpan cr cxr
      wss cX cY cT wf ressxr a1i sstrd 3ad2ant1 cX cY cT wf cA cxr wcel vx cv
      cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle wbr wi vx cX wral 3simp2 vx
      cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle wbr wi vx cX wral cX cY
      cT wf vw cv cA cle wbr vw vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM
      cfv wceq wa vz cX wrex vy cab wral cA cxr wcel vx cv cL cfv c1 cle wbr vx
      cv cT cfv cM cfv cA cle wbr wi vx cX wral vw cv cA cle wbr vw vz cv cL
      cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab vx cv
      cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle wbr wi vx cX wral vz cv cL
      cfv c1 cle wbr vw cv vz cv cT cfv cM cfv wceq wa vz cX wrex vw cv cA cle
      wbr vw cv vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX
      wrex vy cab wcel vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle wbr
      wi vx cX wral vz cv cL cfv c1 cle wbr vw cv vz cv cT cfv cM cfv wceq wa
      vw cv cA cle wbr vz cX vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle
      wbr wi vx cX wral vz cv cX wcel vz cv cL cfv c1 cle wbr vw cv vz cv cT
      cfv cM cfv wceq vw cv cA cle wbr vx cv cL cfv c1 cle wbr vx cv cT cfv cM
      cfv cA cle wbr wi vx cX wral vz cv cX wcel vz cv cL cfv c1 cle wbr vz cv
      cT cfv cM cfv cA cle wbr vw cv vz cv cT cfv cM cfv wceq vw cv cA cle wbr
      wi vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cle wbr wi vz cv cL cfv
      c1 cle wbr vz cv cT cfv cM cfv cA cle wbr wi vx vz cv cX vx cv vz cv wceq
      vx cv cL cfv c1 cle wbr vz cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA
      cle wbr vz cv cT cfv cM cfv cA cle wbr vx cv vz cv wceq vx cv cL cfv vz
      cv cL cfv c1 cle vx cv vz cv cL fveq2 breq1d vx cv vz cv wceq vx cv cT
      cfv cM cfv vz cv cT cfv cM cfv cA cle vx cv vz cv wceq vx cv cT cfv vz cv
      cT cfv cM vx cv vz cv cT fveq2 fveq2d breq1d imbi12d rcla4cv vw cv vz cv
      cT cfv cM cfv wceq vw cv cA cle wbr vz cv cT cfv cM cfv cA cle wbr vw cv
      vz cv cT cfv cM cfv cA cle breq1 biimprcd syl8 imp4a r19.23adv vz cv cL
      cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vz cv cL cfv
      c1 cle wbr vw cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy vw cv vw
      visset vy cv vw cv wceq vz cv cL cfv c1 cle wbr vy cv vz cv cT cfv cM cfv
      wceq wa vz cv cL cfv c1 cle wbr vw cv vz cv cT cfv cM cfv wceq wa vz cX
      vy cv vw cv wceq vy cv vz cv cT cfv cM cfv wceq vw cv vz cv cT cfv cM cfv
      wceq vz cv cL cfv c1 cle wbr vy cv vw cv vz cv cT cfv cM cfv eqeq1 anbi2d
      rexbidv elab syl5ib r19.21aiv 3ad2ant3 syl3anc eqbrtrd $.
      $( [31-Dec-2007] $) $( [11-Dec-2007] $)

    $( An upper bound for an operator norm. $)
    nmoub3i $p |- ( ( T : X --> Y /\ A e. RR /\ A. x e. X
  ( M ` ( T ` x ) ) <_ ( A x. ( L ` x ) ) ) -> ( N ` T ) <_ ( abs ` A ) ) $=
      cX cY cT wf cA cr wcel vx cv cT cfv cM cfv cA vx cv cL cfv cmul co cle
      wbr vx cX wral cT cN cfv cA cabs cfv cle wbr cX cY cT wf cA cr wcel wa vx
      cv cT cfv cM cfv cA vx cv cL cfv cmul co cle wbr vx cX wral vx cv cL cfv
      c1 cle wbr vx cv cT cfv cM cfv cA cabs cfv cle wbr wi vx cX wral cT cN
      cfv cA cabs cfv cle wbr cX cY cT wf cA cr wcel wa vx cv cT cfv cM cfv cA
      vx cv cL cfv cmul co cle wbr vx cX wral vx cv cL cfv c1 cle wbr vx cv cT
      cfv cM cfv cA cabs cfv cle wbr wi vx cX wral cX cY cT wf cA cr wcel wa vx
      cv cT cfv cM cfv cA vx cv cL cfv cmul co cle wbr vx cv cL cfv c1 cle wbr
      vx cv cT cfv cM cfv cA cabs cfv cle wbr wi vx cX cX cY cT wf cA cr wcel
      wa vx cv cX wcel wa vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA vx cv
      cL cfv cmul co cle wbr vx cv cT cfv cM cfv cA cabs cfv cle wbr cX cY cT
      wf cA cr wcel wa vx cv cX wcel wa vx cv cL cfv c1 cle wbr vx cv cT cfv cM
      cfv cA vx cv cL cfv cmul co cle wbr vx cv cT cfv cM cfv cA cabs cfv cle
      wbr wi cX cY cT wf cA cr wcel wa vx cv cX wcel wa vx cv cL cfv c1 cle wbr
      wa vx cv cT cfv cM cfv cA vx cv cL cfv cmul co cle wbr cA vx cv cL cfv
      cmul co cA cabs cfv cle wbr vx cv cT cfv cM cfv cA cabs cfv cle wbr cA cr
      wcel vx cv cX wcel vx cv cL cfv c1 cle wbr cA vx cv cL cfv cmul co cA
      cabs cfv cle wbr cX cY cT wf cA cr wcel vx cv cX wcel wa vx cv cL cfv c1
      cle wbr wa cA vx cv cL cfv cmul co cA cabs cfv vx cv cL cfv cmul co cA
      cabs cfv cA cr wcel vx cv cX wcel wa cA vx cv cL cfv cmul co cr wcel vx
      cv cL cfv c1 cle wbr cA cr wcel vx cv cL cfv cr wcel cA vx cv cL cfv cmul
      co cr wcel vx cv cX wcel cA vx cv cL cfv remulcl cU cnv wcel vx cv cX
      wcel vx cv cL cfv cr wcel nmoubi.u vx cv cU cL cX nmoubi.1 nmoubi.l nvcl
      mpan sylan2 adantr cA cr wcel vx cv cX wcel wa cA cabs cfv vx cv cL cfv
      cmul co cr wcel vx cv cL cfv c1 cle wbr cA cabs cfv cr wcel vx cv cL cfv
      cr wcel cA cabs cfv vx cv cL cfv cmul co cr wcel cA cr wcel vx cv cX wcel
      cA cabs cfv vx cv cL cfv remulcl cA cr wcel cA cc wcel cA cabs cfv cr
      wcel cA recn cA abscl syl cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel
      nmoubi.u vx cv cU cL cX nmoubi.1 nmoubi.l nvcl mpan syl2an adantr cA cr
      wcel cA cabs cfv cr wcel vx cv cX wcel vx cv cL cfv c1 cle wbr cA cr wcel
      cA cc wcel cA cabs cfv cr wcel cA recn cA abscl syl ad2antrr cA cr wcel
      vx cv cX wcel wa cA vx cv cL cfv cmul co cA cabs cfv vx cv cL cfv cmul co
      cle wbr vx cv cL cfv c1 cle wbr cA cr wcel cA cabs cfv cr wcel vx cv cL
      cfv cr wcel cc0 vx cv cL cfv cle wbr wa w3a cA cA cabs cfv cle wbr cA vx
      cv cL cfv cmul co cA cabs cfv vx cv cL cfv cmul co cle wbr cA cr wcel vx
      cv cX wcel wa cA cA cabs cfv vx cv cL cfv lemul1a cA cr wcel vx cv cX
      wcel wa cA cr wcel cA cabs cfv cr wcel vx cv cL cfv cr wcel cc0 vx cv cL
      cfv cle wbr wa cA cr wcel vx cv cX wcel pm3.26 cA cr wcel cA cabs cfv cr
      wcel vx cv cX wcel cA cr wcel cA cc wcel cA cabs cfv cr wcel cA recn cA
      abscl syl adantr vx cv cX wcel vx cv cL cfv cr wcel cc0 vx cv cL cfv cle
      wbr wa cA cr wcel vx cv cX wcel vx cv cL cfv cr wcel cc0 vx cv cL cfv cle
      wbr cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel nmoubi.u vx cv cU cL
      cX nmoubi.1 nmoubi.l nvcl mpan cU cnv wcel vx cv cX wcel cc0 vx cv cL cfv
      cle wbr nmoubi.u vx cv cU cL cX nmoubi.1 nmoubi.l nvge0 mpan jca adantl
      3jca cA cr wcel cA cA cabs cfv cle wbr vx cv cX wcel cA leabs adantr
      sylanc adantr cA cr wcel vx cv cX wcel wa vx cv cL cfv c1 cle wbr wa cA
      cabs cfv vx cv cL cfv cmul co cA cabs cfv c1 cmul co cA cabs cfv cle vx
      cv cL cfv cr wcel c1 cr wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr
      wa w3a vx cv cL cfv c1 cle wbr cA cabs cfv vx cv cL cfv cmul co cA cabs
      cfv c1 cmul co cle wbr cA cr wcel vx cv cX wcel wa vx cv cL cfv c1 cA
      cabs cfv lemul2a cA cr wcel vx cv cX wcel wa vx cv cL cfv cr wcel c1 cr
      wcel cA cabs cfv cr wcel cc0 cA cabs cfv cle wbr wa vx cv cX wcel vx cv
      cL cfv cr wcel cA cr wcel cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel
      nmoubi.u vx cv cU cL cX nmoubi.1 nmoubi.l nvcl mpan adantl c1 cr wcel cA
      cr wcel vx cv cX wcel wa 1re a1i cA cr wcel vx cv cX wcel wa cA cabs cfv
      cr wcel cc0 cA cabs cfv cle wbr cA cr wcel cA cabs cfv cr wcel vx cv cX
      wcel cA cr wcel cA cc wcel cA cabs cfv cr wcel cA recn cA abscl syl
      adantr cA cr wcel cc0 cA cabs cfv cle wbr vx cv cX wcel cA cr wcel cA cc
      wcel cc0 cA cabs cfv cle wbr cA recn cA absge0 syl adantr jca 3jca sylan
      cA cr wcel cA cabs cfv c1 cmul co cA cabs cfv wceq vx cv cX wcel vx cv cL
      cfv c1 cle wbr cA cr wcel cA cabs cfv cc wcel cA cabs cfv c1 cmul co cA
      cabs cfv wceq cA cr wcel cA cabs cfv cA cr wcel cA cc wcel cA cabs cfv cr
      wcel cA recn cA abscl syl recnd cA cabs cfv ax1id syl ad2antrr breqtrd
      letrd adantlll cX cY cT wf cA cr wcel wa vx cv cX wcel wa vx cv cT cfv cM
      cfv cA vx cv cL cfv cmul co cle wbr cA vx cv cL cfv cmul co cA cabs cfv
      cle wbr wa vx cv cT cfv cM cfv cA cabs cfv cle wbr wi vx cv cL cfv c1 cle
      wbr vx cv cT cfv cM cfv cr wcel cA vx cv cL cfv cmul co cr wcel cA cabs
      cfv cr wcel vx cv cT cfv cM cfv cA vx cv cL cfv cmul co cle wbr cA vx cv
      cL cfv cmul co cA cabs cfv cle wbr wa vx cv cT cfv cM cfv cA cabs cfv cle
      wbr wi cX cY cT wf cA cr wcel wa vx cv cX wcel wa vx cv cT cfv cM cfv cA
      vx cv cL cfv cmul co cA cabs cfv letr cX cY cT wf vx cv cX wcel vx cv cT
      cfv cM cfv cr wcel cA cr wcel cX cY cT wf vx cv cX wcel wa vx cv cT cfv
      cY wcel vx cv cT cfv cM cfv cr wcel cX cY vx cv cT ffvelrn cW cnv wcel vx
      cv cT cfv cY wcel vx cv cT cfv cM cfv cr wcel nmoubi.w vx cv cT cfv cW cM
      cY nmoubi.y nmoubi.m nvcl mpan syl adantlr cA cr wcel vx cv cX wcel cA vx
      cv cL cfv cmul co cr wcel cX cY cT wf cA cr wcel vx cv cL cfv cr wcel cA
      vx cv cL cfv cmul co cr wcel vx cv cX wcel cA vx cv cL cfv remulcl cU cnv
      wcel vx cv cX wcel vx cv cL cfv cr wcel nmoubi.u vx cv cU cL cX nmoubi.1
      nmoubi.l nvcl mpan sylan2 adantll cA cr wcel cA cabs cfv cr wcel cX cY cT
      wf vx cv cX wcel cA cr wcel cA cc wcel cA cabs cfv cr wcel cA recn cA
      abscl syl ad2antlr syl3anc adantr mpan2d ex com23 r19.20dva imp cX cY cT
      wf cA cr wcel vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cabs cfv cle
      wbr wi vx cX wral cT cN cfv cA cabs cfv cle wbr cX cY cT wf cA cabs cfv
      cxr wcel vx cv cL cfv c1 cle wbr vx cv cT cfv cM cfv cA cabs cfv cle wbr
      wi vx cX wral cT cN cfv cA cabs cfv cle wbr cA cr wcel vx cA cabs cfv cT
      cU cL cM cN cW cX cY nmoubi.1 nmoubi.y nmoubi.l nmoubi.m nmoubi.3
      nmoubi.u nmoubi.w nmoubi cA cr wcel cA cabs cfv cr wcel cA cabs cfv cxr
      wcel cA cr wcel cA cc wcel cA cabs cfv cr wcel cA recn cA abscl syl cA
      cabs cfv rexr syl syl3an2 3expa syldan 3impa $.
      $( [1-Jan-2008] $) $( [12-Dec-2007] $)

    $( An upper bound for an operator norm. $)
    nmoub2i $p |- ( ( T : X --> Y /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. X
  ( M ` ( T ` x ) ) <_ ( A x. ( L ` x ) ) ) -> ( N ` T ) <_ A ) $=
      cX cY cT wf cA cr wcel cc0 cA cle wbr wa vx cv cT cfv cM cfv cA vx cv cL
      cfv cmul co cle wbr vx cX wral w3a cT cN cfv cA cabs cfv cA cle cX cY cT
      wf cA cr wcel vx cv cT cfv cM cfv cA vx cv cL cfv cmul co cle wbr vx cX
      wral cT cN cfv cA cabs cfv cle wbr cc0 cA cle wbr vx cA cT cU cL cM cN cW
      cX cY nmoubi.1 nmoubi.y nmoubi.l nmoubi.m nmoubi.3 nmoubi.u nmoubi.w
      nmoub3i 3adant2r cA cr wcel cc0 cA cle wbr wa cX cY cT wf cA cabs cfv cA
      wceq vx cv cT cfv cM cfv cA vx cv cL cfv cmul co cle wbr vx cX wral cA
      absid 3ad2ant2 breqtrd $.
      $( [18-Jan-2008] $) $( [11-Dec-2007] $)

    $( Two ways to express that an operator is bounded. $)
    nmobndi $p |- ( T : X --> Y -> ( ( N ` T ) e. RR <->
     E. r e. RR A. y e. X ( ( L ` y ) <_ 1 -> ( M ` ( T ` y ) ) <_ r ) ) ) $=
      cX cY cT wf cT cN cfv cr wcel vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv
      vr cv cle wbr wi vy cX wral vr cr wrex cT cN cfv cr wcel cX cY cT wf vy
      cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral vr
      cr wrex cT cN cfv cr wcel vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv cT
      cN cfv cle wbr wi vy cX wral vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv
      vr cv cle wbr wi vy cX wral vr cr wrex cX cY cT wf vy cv cL cfv c1 cle
      wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral vy cv cL cfv c1 cle
      wbr vy cv cT cfv cM cfv cT cN cfv cle wbr wi vy cX wral vr cT cN cfv cr
      vr cv cT cN cfv wceq vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv
      cle wbr wi vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv cT cN cfv cle wbr
      wi vy cX vr cv cT cN cfv wceq vy cv cT cfv cM cfv vr cv cle wbr vy cv cT
      cfv cM cfv cT cN cfv cle wbr vy cv cL cfv c1 cle wbr vr cv cT cN cfv vy
      cv cT cfv cM cfv cle breq2 imbi2d ralbidv rcla4ev cX cY cT wf vy cv cL
      cfv c1 cle wbr vy cv cT cfv cM cfv cT cN cfv cle wbr wi vy cX cX cY cT wf
      vy cv cX wcel vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv cT cN cfv cle
      wbr cW cnv wcel cX cY cT wf vy cv cX wcel vy cv cL cfv c1 cle wbr wa vy
      cv cT cfv cM cfv cT cN cfv cle wbr nmoubi.w cU cnv wcel cW cnv wcel cX cY
      cT wf vy cv cX wcel vy cv cL cfv c1 cle wbr wa vy cv cT cfv cM cfv cT cN
      cfv cle wbr nmoubi.u vy cv cT cU cL cM cN cW cX cY nmoubi.1 nmoubi.y
      nmoubi.l nmoubi.m nmoubi.3 nmolb mp3anl1 mpanl1 exp32 r19.21aiv sylan2
      expcom cX cY cT wf vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle
      wbr wi vy cX wral cT cN cfv cr wcel vr cr cX cY cT wf vr cv cr wcel vy cv
      cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral cT cN
      cfv cr wcel cT cN cfv cxr wcel vr cv cr wcel cmnf cT cN cfv clt wbr cT cN
      cfv vr cv cle wbr cT cN cfv cr wcel cX cY cT wf vr cv cr wcel vy cv cL
      cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral w3a cT cN
      cfv vr cv xrre cX cY cT wf vr cv cr wcel cT cN cfv cxr wcel vy cv cL cfv
      c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral cU cnv wcel cW
      cnv wcel cX cY cT wf cT cN cfv cxr wcel nmoubi.u nmoubi.w cT cU cN cW cX
      cY nmoubi.1 nmoubi.y nmoubi.3 nmoxr mp3an12 3ad2ant1 cX cY cT wf vr cv cr
      wcel vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX
      wral 3simp2 cX cY cT wf vr cv cr wcel cmnf cT cN cfv clt wbr vy cv cL cfv
      c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral cU cnv wcel cW
      cnv wcel cX cY cT wf cmnf cT cN cfv clt wbr nmoubi.u nmoubi.w cT cU cN cW
      cX cY nmoubi.1 nmoubi.y nmoubi.3 nmogtmnf mp3an12 3ad2ant1 cX cY cT wf vr
      cv cxr wcel vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi
      vy cX wral cT cN cfv vr cv cle wbr vr cv cr wcel vy vr cv cT cU cL cM cN
      cW cX cY nmoubi.1 nmoubi.y nmoubi.l nmoubi.m nmoubi.3 nmoubi.u nmoubi.w
      nmoubi vr cv rexr syl3an2 syl2anc 3expia r19.23adva impbid $.
      $( [24-Jan-2008] $) $( [11-Jan-2008] $)

    $( Two ways two express that an operator is unbounded. $)
    nmounbi $p |- ( T : X --> Y -> ( ( N ` T ) = +oo <->
      A. r e. RR E. y e. X ( ( L ` y ) <_ 1 /\ r < ( M ` ( T ` y ) ) ) ) ) $=
      cX cY cT wf vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv cM cfv clt wbr wa
      vy cX wrex vr cr wral cT cN cfv cpnf cX cY cT wf cT cN cfv cr wcel vy cv
      cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral vr cr
      wrex cT cN cfv cpnf wne vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv cM cfv
      clt wbr wa vy cX wrex vr cr wral wn vy cT cU cL cM cN cW cX cY vr
      nmoubi.1 nmoubi.y nmoubi.l nmoubi.m nmoubi.3 nmoubi.u nmoubi.w nmobndi cU
      cnv wcel cW cnv wcel cX cY cT wf cT cN cfv cr wcel cT cN cfv cpnf wne wb
      nmoubi.u nmoubi.w cT cU cN cW cX cY nmoubi.1 nmoubi.y nmoubi.3 nmorepnf
      mp3an12 cX cY cT wf vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle
      wbr wi vy cX wral vr cr wrex vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv
      cM cfv clt wbr wa vy cX wrex wn vr cr wrex vy cv cL cfv c1 cle wbr vr cv
      vy cv cT cfv cM cfv clt wbr wa vy cX wrex vr cr wral wn cX cY cT wf vy cv
      cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cX wral vy cv
      cL cfv c1 cle wbr vr cv vy cv cT cfv cM cfv clt wbr wa vy cX wrex wn vr
      cr cX cY cT wf vr cv cr wcel wa vy cv cL cfv c1 cle wbr vy cv cT cfv cM
      cfv vr cv cle wbr wi vy cX wral vy cv cL cfv c1 cle wbr vr cv vy cv cT
      cfv cM cfv clt wbr wa wn vy cX wral vy cv cL cfv c1 cle wbr vr cv vy cv
      cT cfv cM cfv clt wbr wa vy cX wrex wn cX cY cT wf vr cv cr wcel wa vy cv
      cL cfv c1 cle wbr vy cv cT cfv cM cfv vr cv cle wbr wi vy cv cL cfv c1
      cle wbr vr cv vy cv cT cfv cM cfv clt wbr wa wn vy cX cX cY cT wf vr cv
      cr wcel wa vy cv cX wcel wa vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv
      vr cv cle wbr wi vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv cM cfv clt
      wbr wn wi vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv cM cfv clt wbr wa wn
      cX cY cT wf vr cv cr wcel wa vy cv cX wcel wa vy cv cT cfv cM cfv vr cv
      cle wbr vr cv vy cv cT cfv cM cfv clt wbr wn vy cv cL cfv c1 cle wbr cX
      cY cT wf vy cv cX wcel vr cv cr wcel vy cv cT cfv cM cfv vr cv cle wbr vr
      cv vy cv cT cfv cM cfv clt wbr wn wb vy cv cT cfv cM cfv cr wcel vr cv cr
      wcel vy cv cT cfv cM cfv vr cv cle wbr vr cv vy cv cT cfv cM cfv clt wbr
      wn wb cX cY cT wf vy cv cX wcel wa vy cv cT cfv cM cfv vr cv lenlt cX cY
      cT wf vy cv cX wcel wa vy cv cT cfv cY wcel vy cv cT cfv cM cfv cr wcel
      cX cY vy cv cT ffvelrn cW cnv wcel vy cv cT cfv cY wcel vy cv cT cfv cM
      cfv cr wcel nmoubi.w vy cv cT cfv cW cM cY nmoubi.y nmoubi.m nvcl mpan
      syl sylan an1rs imbi2d vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv cM cfv
      clt wbr imnan syl6bb ralbidva vy cv cL cfv c1 cle wbr vr cv vy cv cT cfv
      cM cfv clt wbr wa vy cX ralnex syl6bb rexbidva vy cv cL cfv c1 cle wbr vr
      cv vy cv cT cfv cM cfv clt wbr wa vy cX wrex vr cr rexnal syl6bb 3bitr3d
      necon4abid $.
      $( [12-Feb-2008] $) $( [11-Jan-2008] $)

    $( An unbounded operator determines an unbounded sequence. $)
    nmounbseqi $p |- ( ( T : X --> Y /\ ( N ` T ) = +oo ) ->
         E. f ( f : NN --> X /\ A. k e. NN ( ( L ` ( f ` k ) ) <_ 1 /\
          k < ( M ` ( T ` ( f ` k ) ) ) ) ) ) $=
      cX cY cT wf cT cN cfv cpnf wceq wa vy cv cL cfv c1 cle wbr vk cv vy cv cT
      cfv cM cfv clt wbr wa vy cX wrex vk cr wral vy cv cL cfv c1 cle wbr vk cv
      vy cv cT cfv cM cfv clt wbr wa vy cX wrex vk cn wral cn cX vf cv wf vk cv
      vf cv cfv cL cfv c1 cle wbr vk cv vk cv vf cv cfv cT cfv cM cfv clt wbr
      wa vk cn wral wa vf wex cX cY cT wf cT cN cfv cpnf wceq vy cv cL cfv c1
      cle wbr vk cv vy cv cT cfv cM cfv clt wbr wa vy cX wrex vk cr wral vy cT
      cU cL cM cN cW cX cY vk nmoubi.1 nmoubi.y nmoubi.l nmoubi.m nmoubi.3
      nmoubi.u nmoubi.w nmounbi biimpa vy cv cL cfv c1 cle wbr vk cv vy cv cT
      cfv cM cfv clt wbr wa vy cX wrex vy cv cL cfv c1 cle wbr vk cv vy cv cT
      cfv cM cfv clt wbr wa vy cX wrex vk cr cn vk cv cn wcel vk cv cr wcel vy
      cv cL cfv c1 cle wbr vk cv vy cv cT cfv cM cfv clt wbr wa vy cX wrex vk
      cv nnre imim1i r19.20i2 vy cv cL cfv c1 cle wbr vk cv vy cv cT cfv cM cfv
      clt wbr wa vk cv vf cv cfv cL cfv c1 cle wbr vk cv vk cv vf cv cfv cT cfv
      cM cfv clt wbr wa vk vy cn cX vf nnex vy cv vk cv vf cv cfv wceq vy cv cL
      cfv c1 cle wbr vk cv vf cv cfv cL cfv c1 cle wbr vk cv vy cv cT cfv cM
      cfv clt wbr vk cv vk cv vf cv cfv cT cfv cM cfv clt wbr vy cv vk cv vf cv
      cfv wceq vy cv cL cfv vk cv vf cv cfv cL cfv c1 cle vy cv vk cv vf cv cfv
      cL fveq2 breq1d vy cv vk cv vf cv cfv wceq vy cv cT cfv cM cfv vk cv vf
      cv cfv cT cfv cM cfv vk cv clt vy cv vk cv vf cv cfv wceq vy cv cT cfv vk
      cv vf cv cfv cT cfv cM vy cv vk cv vf cv cfv cT fveq2 fveq2d breq2d
      anbi12d ac6s 3syl $.
      $( [3-Apr-2009] $) $( [11-Jan-2008] $)

    $( A bounded sequence determines a bounded operator. $)
    nmobndseqi $p |- ( ( T : X --> Y /\
         A. f ( ( f : NN --> X /\ A. k e. NN ( L ` ( f ` k ) ) <_ 1 ) ->
        E. k e. NN ( M ` ( T ` ( f ` k ) ) ) <_ k ) ) -> ( N ` T ) e. RR ) $=
      cX cY cT wf cn cX vf cv wf vk cv vf cv cfv cL cfv c1 cle wbr vk cn wral
      wa vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr vk cn wrex wi vf wal cT cN
      cfv cr wcel cX cY cT wf cT cN cfv cr wcel vy cv cL cfv c1 cle wbr vy cv
      cT cfv cM cfv vk cv cle wbr wi vy cX wral vk cr wrex cn cX vf cv wf vk cv
      vf cv cfv cL cfv c1 cle wbr vk cn wral wa vk cv vf cv cfv cT cfv cM cfv
      vk cv cle wbr vk cn wrex wi vf wal vy cT cU cL cM cN cW cX cY vk nmoubi.1
      nmoubi.y nmoubi.l nmoubi.m nmoubi.3 nmoubi.u nmoubi.w nmobndi cn cX vf cv
      wf vk cv vf cv cfv cL cfv c1 cle wbr vk cn wral wa vk cv vf cv cfv cT cfv
      cM cfv vk cv cle wbr vk cn wrex wi vf wal cn cX vf cv wf vk cv vf cv cfv
      cL cfv c1 cle wbr vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr wi vk cn
      wrex wi vf wal vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vk cv cle wbr
      wi vy cX wral vk cr wrex cn cX vf cv wf vk cv vf cv cfv cL cfv c1 cle wbr
      vk cn wral wa vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr vk cn wrex wi
      cn cX vf cv wf vk cv vf cv cfv cL cfv c1 cle wbr vk cv vf cv cfv cT cfv
      cM cfv vk cv cle wbr wi vk cn wrex wi vf cn cX vf cv wf vk cv vf cv cfv
      cL cfv c1 cle wbr vk cn wral wa vk cv vf cv cfv cT cfv cM cfv vk cv cle
      wbr vk cn wrex wi cn cX vf cv wf vk cv vf cv cfv cL cfv c1 cle wbr vk cn
      wral vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr vk cn wrex wi wi cn cX
      vf cv wf vk cv vf cv cfv cL cfv c1 cle wbr vk cv vf cv cfv cT cfv cM cfv
      vk cv cle wbr wi vk cn wrex wi cn cX vf cv wf vk cv vf cv cfv cL cfv c1
      cle wbr vk cn wral vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr vk cn wrex
      impexp vk cv vf cv cfv cL cfv c1 cle wbr vk cv vf cv cfv cT cfv cM cfv vk
      cv cle wbr wi vk cn wrex vk cv vf cv cfv cL cfv c1 cle wbr vk cn wral vk
      cv vf cv cfv cT cfv cM cfv vk cv cle wbr vk cn wrex wi cn cX vf cv wf vk
      cv vf cv cfv cL cfv c1 cle wbr vk cv vf cv cfv cT cfv cM cfv vk cv cle
      wbr vk cn r19.35 imbi2i bitr4i albii cn cX vf cv wf vk cv vf cv cfv cL
      cfv c1 cle wbr vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr wi vk cn wrex
      wi vf wal vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vk cv cle wbr wi vy
      cX wral vk cn wrex vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vk cv cle
      wbr wi vy cX wral vk cr wrex vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv
      vk cv cle wbr wi vk cv vf cv cfv cL cfv c1 cle wbr vk cv vf cv cfv cT cfv
      cM cfv vk cv cle wbr wi vk vy cn cX vf nnex vy cv vk cv vf cv cfv wceq vy
      cv cL cfv c1 cle wbr vk cv vf cv cfv cL cfv c1 cle wbr vy cv cT cfv cM
      cfv vk cv cle wbr vk cv vf cv cfv cT cfv cM cfv vk cv cle wbr vy cv vk cv
      vf cv cfv wceq vy cv cL cfv vk cv vf cv cfv cL cfv c1 cle vy cv vk cv vf
      cv cfv cL fveq2 breq1d vy cv vk cv vf cv cfv wceq vy cv cT cfv cM cfv vk
      cv vf cv cfv cT cfv cM cfv vk cv cle vy cv vk cv vf cv cfv wceq vy cv cT
      cfv vk cv vf cv cfv cT cfv cM vy cv vk cv vf cv cfv cT fveq2 fveq2d
      breq1d imbi12d ac6n vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vk cv cle
      wbr wi vy cX wral vy cv cL cfv c1 cle wbr vy cv cT cfv cM cfv vk cv cle
      wbr wi vy cX wral vk cn cr vk cv cn wcel vk cv cr wcel vy cv cL cfv c1
      cle wbr vy cv cT cfv cM cfv vk cv cle wbr wi vy cX wral vk cv nnre anim1i
      r19.22i2 syl sylbi syl5bir imp $.
      $( [24-Jan-2008] $) $( [18-Jan-2008] $)
  $}

  ${
    $d o t w L $.  $d o t w N $.  $d t T $.  $d o t u w U $.  $d o t u w W $.
    bloval.3 $e |- N = ( U normOp W ) $.
    bloval.4 $e |- L = ( U LnOp W ) $.
    bloval.5 $e |- B = ( U BLnOp W ) $.
    $( The class of bounded linear operators between two normed complex vector
       spaces. $)
    bloval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> B =
          { t e. L | ( N ` t ) < +oo } ) $=
      cU cnv wcel cW cnv wcel wa cU cW cblo co vt cv cN cfv cpnf clt wbr vt cL
      crab cB vu vw vo cU cW cnv cnv vt cv vu cv vw cv cnmo co cfv cpnf clt wbr
      vt vu cv vw cv clno co crab vt cv cN cfv cpnf clt wbr vt cL crab cblo vt
      cv cU vw cv cnmo co cfv cpnf clt wbr vt cU vw cv clno co crab vt cv cN
      cfv cpnf clt wbr vt cL cL cU cW clno co cvv bloval.4 cU cW clno oprex
      eqeltri rabex vu cv cU wceq vt cv vu cv vw cv cnmo co cfv cpnf clt wbr vt
      vu cv vw cv clno co crab vt cv cU vw cv cnmo co cfv cpnf clt wbr vt vu cv
      vw cv clno co crab vt cv cU vw cv cnmo co cfv cpnf clt wbr vt cU vw cv
      clno co crab vu cv cU wceq vt cv vu cv vw cv cnmo co cfv cpnf clt wbr vt
      cv cU vw cv cnmo co cfv cpnf clt wbr vt vu cv vw cv clno co vu cv cU wceq
      vt cv vu cv vw cv cnmo co cfv vt cv cU vw cv cnmo co cfv cpnf clt vu cv
      cU wceq vt cv vu cv vw cv cnmo co cU vw cv cnmo co vu cv cU vw cv cnmo
      opreq1 fveq1d breq1d rabbisdv vu cv cU wceq vu cv vw cv clno co cU vw cv
      clno co wceq vt cv cU vw cv cnmo co cfv cpnf clt wbr vt vu cv vw cv clno
      co crab vt cv cU vw cv cnmo co cfv cpnf clt wbr vt cU vw cv clno co crab
      wceq vu cv cU vw cv clno opreq1 vt cv cU vw cv cnmo co cfv cpnf clt wbr
      vt vu cv vw cv clno co cU vw cv clno co rabeq syl eqtrd vw cv cW wceq vt
      cv cU vw cv cnmo co cfv cpnf clt wbr vt cU vw cv clno co crab vt cv cU vw
      cv cnmo co cfv cpnf clt wbr vt cL crab vt cv cN cfv cpnf clt wbr vt cL
      crab vw cv cW wceq cU vw cv clno co cL wceq vt cv cU vw cv cnmo co cfv
      cpnf clt wbr vt cU vw cv clno co crab vt cv cU vw cv cnmo co cfv cpnf clt
      wbr vt cL crab wceq vw cv cW wceq cU vw cv clno co cU cW clno co cL vw cv
      cW cU clno opreq2 bloval.4 syl6eqr vt cv cU vw cv cnmo co cfv cpnf clt
      wbr vt cU vw cv clno co cL rabeq syl vw cv cW wceq vt cv cU vw cv cnmo co
      cfv cpnf clt wbr vt cv cN cfv cpnf clt wbr vt cL vw cv cW wceq vt cv cU
      vw cv cnmo co cfv vt cv cN cfv cpnf clt vw cv cW wceq vt cv cU vw cv cnmo
      co cN vw cv cW wceq cU vw cv cnmo co cU cW cnmo co cN vw cv cW cU cnmo
      opreq2 bloval.3 syl6eqr fveq1d breq1d rabbisdv eqtrd vw vu vt vo df-blo
      oprabval2 bloval.5 syl5eq $.
      $( [14-Dec-2007] $) $( [6-Nov-2007] $)

    $( The predicate "is a bounded linear operator." $)
    isblo $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> ( T e. B <->
      ( T e. L /\ ( N ` T ) < +oo ) ) ) $=
      cU cnv wcel cW cnv wcel wa cT cB wcel cT vt cv cN cfv cpnf clt wbr vt cL
      crab wcel cT cL wcel cT cN cfv cpnf clt wbr wa cU cnv wcel cW cnv wcel wa
      cB vt cv cN cfv cpnf clt wbr vt cL crab cT vt cB cU cL cN cW bloval.3
      bloval.4 bloval.5 bloval eleq2d vt cv cN cfv cpnf clt wbr cT cN cfv cpnf
      clt wbr vt cT cL vt cv cT wceq vt cv cN cfv cT cN cfv cpnf clt vt cv cT
      cN fveq2 breq1d elrab syl6bb $.
      $( [16-Dec-2007] $) $( [6-Nov-2007] $)

    $( The predicate "is a bounded linear operator." $)
    isblo2 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> ( T e. B <->
      ( T e. L /\ ( N ` T ) e. RR ) ) ) $=
      cU cnv wcel cW cnv wcel wa cT cB wcel cT cL wcel cT cN cfv cpnf clt wbr
      wa cT cL wcel cT cN cfv cr wcel wa cB cT cU cL cN cW bloval.3 bloval.4
      bloval.5 isblo cU cnv wcel cW cnv wcel wa cT cL wcel cT cN cfv cr wcel cT
      cN cfv cpnf clt wbr cU cnv wcel cW cnv wcel cT cL wcel cT cN cfv cr wcel
      cT cN cfv cpnf clt wbr wb cU cnv wcel cW cnv wcel cU cba cfv cW cba cfv
      cT wf cT cN cfv cr wcel cT cN cfv cpnf clt wbr wb cT cL wcel cT cU cN cW
      cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid bloval.3 nmoreltpnf
      cT cU cL cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid
      bloval.4 lnof syld3an3 3expa pm5.32da bitr4d $.
      $( [1-Jan-2008] $) $( [8-Dec-2007] $)
  $}

  ${
    bloln.4 $e |- L = ( U LnOp W ) $.
    bloln.5 $e |- B = ( U BLnOp W ) $.
    $( A bounded operator is a linear operator. $)
    bloln $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. B ) -> T e. L ) $=
      cU cnv wcel cW cnv wcel cT cB wcel cT cL wcel cU cnv wcel cW cnv wcel wa
      cT cB wcel cT cL wcel cT cU cW cnmo co cfv cpnf clt wbr cB cT cU cL cU cW
      cnmo co cW cU cW cnmo co eqid bloln.4 bloln.5 isblo pm3.26bda 3impa $.
      $( [23-Dec-2007] $) $( [8-Dec-2007] $)
  $}

  ${
    blof.1 $e |- X = ( BaseSet ` U ) $.
    blof.2 $e |- Y = ( BaseSet ` W ) $.
    blof.5 $e |- B = ( U BLnOp W ) $.
    $( A bounded operator is an operator. $)
    blof $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. B ) -> T : X --> Y ) $=
      cU cnv wcel cW cnv wcel cT cU cW clno co wcel cX cY cT wf cT cB wcel cT
      cU cU cW clno co cW cX cY blof.1 blof.2 cU cW clno co eqid lnof cB cT cU
      cU cW clno co cW cU cW clno co eqid blof.5 bloln syld3an3 $.
      $( [28-Dec-2007] $) $( [8-Dec-2007] $)
  $}

  ${
    nmblore.1 $e |- X = ( BaseSet ` U ) $.
    nmblore.2 $e |- Y = ( BaseSet ` W ) $.
    nmblore.3 $e |- N = ( U normOp W ) $.
    nmblore.5 $e |- B = ( U BLnOp W ) $.
    $( The norm of a bounded operator is a real number. $)
    nmblore $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. B ) ->
                ( N ` T ) e. RR ) $=
      cU cnv wcel cW cnv wcel cT cB wcel w3a cT cN cfv cr wcel cmnf cT cN cfv
      clt wbr cT cN cfv cpnf clt wbr wa cU cnv wcel cW cnv wcel cT cB wcel w3a
      cmnf cT cN cfv clt wbr cT cN cfv cpnf clt wbr cU cnv wcel cW cnv wcel cX
      cY cT wf cmnf cT cN cfv clt wbr cT cB wcel cT cU cN cW cX cY nmblore.1
      nmblore.2 nmblore.3 nmogtmnf cB cT cU cW cX cY nmblore.1 nmblore.2
      nmblore.5 blof syld3an3 cU cnv wcel cW cnv wcel cT cB wcel cT cN cfv cpnf
      clt wbr cU cnv wcel cW cnv wcel wa cT cB wcel cT cU cW clno co wcel cT cN
      cfv cpnf clt wbr cB cT cU cU cW clno co cN cW nmblore.3 cU cW clno co
      eqid nmblore.5 isblo pm3.27bda 3impa jca cU cnv wcel cW cnv wcel cT cB
      wcel w3a cU cnv wcel cW cnv wcel cX cY cT wf w3a cT cN cfv cxr wcel cT cN
      cfv cr wcel cmnf cT cN cfv clt wbr cT cN cfv cpnf clt wbr wa wb cU cnv
      wcel cW cnv wcel cT cB wcel w3a cU cnv wcel cW cnv wcel cX cY cT wf cU
      cnv wcel cW cnv wcel cT cB wcel 3simp1 cU cnv wcel cW cnv wcel cT cB wcel
      3simp2 cB cT cU cW cX cY nmblore.1 nmblore.2 nmblore.5 blof 3jca cT cU cN
      cW cX cY nmblore.1 nmblore.2 nmblore.3 nmoxr cT cN cfv xrrebnd 3syl
      mpbird $.
      $( [30-Dec-2007] $) $( [8-Dec-2007] $)
  $}

  ${
    $d o u w U $.  $d o u w W $.  $d o u w X $.  $d o w Z $.
    0oval.1 $e |- X = ( BaseSet ` U ) $.
    0oval.6 $e |- Z = ( 0v ` W ) $.
    0oval.0 $e |- O = ( U 0op W ) $.
    $( The zero operator between two normed complex vector spaces. $)
    0ofval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> O = ( X X. { Z } ) ) $=
      cU cnv wcel cW cnv wcel wa cU cW c0o co cX cZ csn cxp cO vu vw vo cU cW
      cnv cnv vu cv cba cfv vw cv cn0v cfv csn cxp cX cZ csn cxp c0o cX vw cv
      cn0v cfv csn cxp cX cZ csn cX cU cba cfv cvv 0oval.1 cU cba fvex eqeltri
      cZ snex xpex vu cv cU wceq vu cv cba cfv cX wceq vu cv cba cfv vw cv cn0v
      cfv csn cxp cX vw cv cn0v cfv csn cxp wceq vu cv cU wceq vu cv cba cfv cU
      cba cfv cX vu cv cU cba fveq2 0oval.1 syl6eqr vu cv cba cfv cX vw cv cn0v
      cfv csn xpeq1 syl vw cv cW wceq vw cv cn0v cfv csn cZ csn wceq cX vw cv
      cn0v cfv csn cxp cX cZ csn cxp wceq vw cv cW wceq vw cv cn0v cfv cZ vw cv
      cW wceq vw cv cn0v cfv cW cn0v cfv cZ vw cv cW cn0v fveq2 0oval.6 syl6eqr
      sneqd vw cv cn0v cfv csn cZ csn cX xpeq2 syl vw vu vo df-0o oprabval2
      0oval.0 syl5eq $.
      $( [12-Dec-2007] $) $( [28-Nov-2007] $)

    $( Value of the zero operator. $)
    0oval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ A e. X ) ->
            ( O ` A ) = Z ) $=
      cU cnv wcel cW cnv wcel cA cX wcel w3a cA cO cfv cA cX cZ csn cxp cfv cZ
      cU cnv wcel cW cnv wcel cA cO cfv cA cX cZ csn cxp cfv wceq cA cX wcel cU
      cnv wcel cW cnv wcel wa cA cO cX cZ csn cxp cU cO cW cX cZ 0oval.1
      0oval.6 0oval.0 0ofval fveq1d 3adant3 cA cX wcel cU cnv wcel cA cX cZ csn
      cxp cfv cZ wceq cW cnv wcel cX cZ cA cZ cW cn0v cfv cvv 0oval.6 cW cn0v
      fvex eqeltri fvconst2 3ad2ant3 eqtrd $.
      $( [13-Dec-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    $d o u w U $.  $d o u w W $.  $d o u w X $.  $d o w Z $.
    0oo.1 $e |- X = ( BaseSet ` U ) $.
    0oo.2 $e |- Y = ( BaseSet ` W ) $.
    0oo.0 $e |- Z = ( U 0op W ) $.
    $( The zero operator is an operator. $)
    0oo $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> Z : X --> Y ) $=
      cU cnv wcel cW cnv wcel wa cX cY cZ wf cX cY cX cW cn0v cfv csn cxp wf cW
      cnv wcel cX cY cX cW cn0v cfv csn cxp wf cU cnv wcel cW cnv wcel cW cn0v
      cfv cY wcel cW cn0v cfv csn cY wss cX cY cX cW cn0v cfv csn cxp wf cW cY
      cW cn0v cfv 0oo.2 cW cn0v cfv eqid nvzcl cW cn0v cfv cY snssi cX cW cn0v
      cfv csn cX cW cn0v cfv csn cxp wf cW cn0v cfv csn cY wss cX cY cX cW cn0v
      cfv csn cxp wf cX cW cn0v cfv cW cn0v fvex fconst cX cW cn0v cfv csn cY
      cX cW cn0v cfv csn cxp fss mpan 3syl adantl cU cnv wcel cW cnv wcel wa cX
      cY cZ cX cW cn0v cfv csn cxp cU cZ cW cX cW cn0v cfv 0oo.1 cW cn0v cfv
      eqid 0oo.0 0ofval feq1d mpbird $.
      $( [13-Dec-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    $d x y z U $.  $d x y z W $.  $d x y z Z $.
    0lno.0 $e |- Z = ( U 0op W ) $.
    0lno.7 $e |- L = ( U LnOp W ) $.
    $( The zero operator is linear. $)
    0lno $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> Z e. L ) $=
      cU cnv wcel cW cnv wcel wa cZ cL wcel cU cba cfv cW cba cfv cZ wf vx cv
      vy cv vz cv cU cns cfv co cU cpv cfv co cZ cfv vx cv cZ cfv vy cv vz cv
      cZ cfv cW cns cfv co cW cpv cfv co wceq vz cU cba cfv wral vy cc wral vx
      cU cba cfv wral wa cU cnv wcel cW cnv wcel wa cU cba cfv cW cba cfv cZ wf
      vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cZ cfv vx cv cZ cfv vy cv
      vz cv cZ cfv cW cns cfv co cW cpv cfv co wceq vz cU cba cfv wral vy cc
      wral vx cU cba cfv wral cU cW cU cba cfv cW cba cfv cZ cU cba cfv eqid cW
      cba cfv eqid 0lno.0 0oo cU cnv wcel cW cnv wcel wa vx cv vy cv vz cv cU
      cns cfv co cU cpv cfv co cZ cfv vx cv cZ cfv vy cv vz cv cZ cfv cW cns
      cfv co cW cpv cfv co wceq vz cU cba cfv wral vy cc wral vx cU cba cfv cU
      cnv wcel cW cnv wcel wa vx cv cU cba cfv wcel wa vx cv vy cv vz cv cU cns
      cfv co cU cpv cfv co cZ cfv vx cv cZ cfv vy cv vz cv cZ cfv cW cns cfv co
      cW cpv cfv co wceq vy vz cc cU cba cfv cU cnv wcel cW cnv wcel wa vx cv
      cU cba cfv wcel wa vy cv cc wcel vz cv cU cba cfv wcel wa vx cv vy cv vz
      cv cU cns cfv co cU cpv cfv co cZ cfv vx cv cZ cfv vy cv vz cv cZ cfv cW
      cns cfv co cW cpv cfv co wceq cU cnv wcel cW cnv wcel wa vx cv cU cba cfv
      wcel wa vy cv cc wcel vz cv cU cba cfv wcel wa wa cW cn0v cfv cW cn0v cfv
      cW cpv cfv co cW cn0v cfv vx cv cZ cfv vy cv vz cv cZ cfv cW cns cfv co
      cW cpv cfv co vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cZ cfv cU cnv
      wcel cW cnv wcel wa cW cn0v cfv cW cn0v cfv cW cpv cfv co cW cn0v cfv
      wceq vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel wa cW cnv
      wcel cW cn0v cfv cW cn0v cfv cW cpv cfv co cW cn0v cfv wceq cU cnv wcel
      cW cnv wcel cW cn0v cfv cW cba cfv wcel cW cn0v cfv cW cn0v cfv cW cpv
      cfv co cW cn0v cfv wceq cW cW cba cfv cW cn0v cfv cW cba cfv eqid cW cn0v
      cfv eqid nvzcl cW cn0v cfv cW cW cpv cfv cW cba cfv cW cn0v cfv cW cba
      cfv eqid cW cpv cfv eqid cW cn0v cfv eqid nv0rid mpdan adantl ad2antrr cU
      cnv wcel cW cnv wcel wa vx cv cU cba cfv wcel wa vy cv cc wcel vz cv cU
      cba cfv wcel wa wa vx cv cZ cfv cW cn0v cfv vy cv vz cv cZ cfv cW cns cfv
      co cW cn0v cfv cW cpv cfv cU cnv wcel cW cnv wcel wa vx cv cU cba cfv
      wcel wa vx cv cZ cfv cW cn0v cfv wceq vy cv cc wcel vz cv cU cba cfv wcel
      wa cU cnv wcel cW cnv wcel vx cv cU cba cfv wcel vx cv cZ cfv cW cn0v cfv
      wceq vx cv cU cZ cW cU cba cfv cW cn0v cfv cU cba cfv eqid cW cn0v cfv
      eqid 0lno.0 0oval 3expa adantr cU cnv wcel cW cnv wcel wa vy cv cc wcel
      vz cv cU cba cfv wcel wa vy cv vz cv cZ cfv cW cns cfv co cW cn0v cfv
      wceq vx cv cU cba cfv wcel cU cnv wcel cW cnv wcel wa vy cv cc wcel vz cv
      cU cba cfv wcel wa wa vy cv vz cv cZ cfv cW cns cfv co vy cv cW cn0v cfv
      cW cns cfv co cW cn0v cfv cU cnv wcel cW cnv wcel wa vy cv cc wcel vz cv
      cU cba cfv wcel wa wa vz cv cZ cfv cW cn0v cfv vy cv cW cns cfv cU cnv
      wcel cW cnv wcel wa vz cv cU cba cfv wcel vz cv cZ cfv cW cn0v cfv wceq
      vy cv cc wcel cU cnv wcel cW cnv wcel vz cv cU cba cfv wcel vz cv cZ cfv
      cW cn0v cfv wceq vz cv cU cZ cW cU cba cfv cW cn0v cfv cU cba cfv eqid cW
      cn0v cfv eqid 0lno.0 0oval 3expa adantrl opreq2d cW cnv wcel vy cv cc
      wcel vy cv cW cn0v cfv cW cns cfv co cW cn0v cfv wceq cU cnv wcel vz cv
      cU cba cfv wcel vy cv cW cns cfv cW cW cn0v cfv cW cns cfv eqid cW cn0v
      cfv eqid nvsz ad2ant2lr eqtrd adantlr opreq12d cU cnv wcel cW cnv wcel wa
      vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel wa vx cv vy cv
      vz cv cU cns cfv co cU cpv cfv co cZ cfv cW cn0v cfv wceq cU cnv wcel cW
      cnv wcel wa vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel wa
      wa vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cU cba cfv wcel vx cv vy
      cv vz cv cU cns cfv co cU cpv cfv co cZ cfv cW cn0v cfv wceq cU cnv wcel
      vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel wa wa vx cv vy
      cv vz cv cU cns cfv co cU cpv cfv co cU cba cfv wcel cW cnv wcel cU cnv
      wcel vx cv cU cba cfv wcel vy cv cc wcel vz cv cU cba cfv wcel wa vx cv
      vy cv vz cv cU cns cfv co cU cpv cfv co cU cba cfv wcel cU cnv wcel vx cv
      cU cba cfv wcel wa vy cv cc wcel vz cv cU cba cfv wcel wa vy cv vz cv cU
      cns cfv co cU cba cfv wcel vx cv vy cv vz cv cU cns cfv co cU cpv cfv co
      cU cba cfv wcel cU cnv wcel vy cv cc wcel vz cv cU cba cfv wcel wa vy cv
      vz cv cU cns cfv co cU cba cfv wcel vx cv cU cba cfv wcel cU cnv wcel vy
      cv cc wcel vz cv cU cba cfv wcel vy cv vz cv cU cns cfv co cU cba cfv
      wcel vy cv vz cv cU cns cfv cU cU cba cfv cU cba cfv eqid cU cns cfv eqid
      nvscl 3expb adantlr cU cnv wcel vx cv cU cba cfv wcel vy cv vz cv cU cns
      cfv co cU cba cfv wcel vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cU
      cba cfv wcel vx cv vy cv vz cv cU cns cfv co cU cU cpv cfv cU cba cfv cU
      cba cfv eqid cU cpv cfv eqid nvgcl 3expa syldan anasss adantlr cU cnv
      wcel cW cnv wcel vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cU cba cfv
      wcel vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cZ cfv cW cn0v cfv
      wceq vx cv vy cv vz cv cU cns cfv co cU cpv cfv co cU cZ cW cU cba cfv cW
      cn0v cfv cU cba cfv eqid cW cn0v cfv eqid 0lno.0 0oval 3expa syldan
      anassrs 3eqtr4rd ex r19.21aivv r19.21aiva jca vx vy vz cU cns cfv cW cns
      cfv cZ cU cU cpv cfv cW cpv cfv cL cW cU cba cfv cW cba cfv cU cba cfv
      eqid cW cba cfv eqid cU cpv cfv eqid cW cpv cfv eqid cU cns cfv eqid cW
      cns cfv eqid 0lno.7 islno mpbird $.
      $( [17-Dec-2007] $) $( [28-Nov-2007] $)
  $}

  ${
    $d x z U $.  $d x z W $.  $d x z Z $.
    nmo0.3 $e |- N = ( U normOp W ) $.
    nmo0.0 $e |- Z = ( U 0op W ) $.
    $( The operator norm of the zero operator. $)
    nmo0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) ->
         ( N ` Z ) = 0 ) $=
      cU cnv wcel cW cnv wcel wa cZ cN cfv cc0 csn cxr clt csup cc0 cU cnv wcel
      cW cnv wcel wa cZ cN cfv vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ
      cfv cW cnm cfv cfv wceq wa vz cU cba cfv wrex vx cab cxr clt csup cc0 csn
      cxr clt csup cU cnv wcel cW cnv wcel cU cba cfv cW cba cfv cZ wf cZ cN
      cfv vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ cfv cW cnm cfv cfv
      wceq wa vz cU cba cfv wrex vx cab cxr clt csup wceq cU cW cU cba cfv cW
      cba cfv cZ cU cba cfv eqid cW cba cfv eqid nmo0.0 0oo vx vz cZ cU cU cnm
      cfv cW cnm cfv cN cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv
      eqid cU cnm cfv eqid cW cnm cfv eqid nmo0.3 nmoval mpd3an3 cU cnv wcel cW
      cnv wcel wa vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ cfv cW cnm cfv
      cfv wceq wa vz cU cba cfv wrex vx cab cc0 csn wceq vz cv cU cnm cfv cfv
      c1 cle wbr vx cv vz cv cZ cfv cW cnm cfv cfv wceq wa vz cU cba cfv wrex
      vx cab cxr clt csup cc0 csn cxr clt csup wceq cU cnv wcel cW cnv wcel wa
      vx cv cc0 wceq vx cab vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ cfv
      cW cnm cfv cfv wceq wa vz cU cba cfv wrex vx cab cc0 csn cU cnv wcel cW
      cnv wcel wa vx cv cc0 wceq vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ
      cfv cW cnm cfv cfv wceq wa vz cU cba cfv wrex vx cU cnv wcel cW cnv wcel
      wa vx cv cc0 wceq vz cv cU cnm cfv cfv c1 cle wbr vz cU cba cfv wrex vx
      cv cc0 wceq wa vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ cfv cW cnm
      cfv cfv wceq wa vz cU cba cfv wrex cU cnv wcel vx cv cc0 wceq vz cv cU
      cnm cfv cfv c1 cle wbr vz cU cba cfv wrex vx cv cc0 wceq wa wb cW cnv
      wcel cU cnv wcel vz cv cU cnm cfv cfv c1 cle wbr vz cU cba cfv wrex vx cv
      cc0 wceq cU cn0v cfv cU cba cfv wcel cU cn0v cfv cU cnm cfv cfv c1 cle
      wbr vz cv cU cnm cfv cfv c1 cle wbr vz cU cba cfv wrex cU cnv wcel vz cv
      cU cnm cfv cfv c1 cle wbr cU cn0v cfv cU cnm cfv cfv c1 cle wbr vz cU
      cn0v cfv cU cba cfv vz cv cU cn0v cfv wceq vz cv cU cnm cfv cfv cU cn0v
      cfv cU cnm cfv cfv c1 cle vz cv cU cn0v cfv cU cnm cfv fveq2 breq1d
      rcla4ev cU cU cba cfv cU cn0v cfv cU cba cfv eqid cU cn0v cfv eqid nvzcl
      cU cnv wcel cU cn0v cfv cU cnm cfv cfv cc0 c1 cle cU cU cnm cfv cU cn0v
      cfv cU cn0v cfv eqid cU cnm cfv eqid nvz0 cc0 c1 0re 1re lt01 ltleii
      syl6eqbr sylanc biantrurd adantr cU cnv wcel cW cnv wcel wa vz cv cU cnm
      cfv cfv c1 cle wbr vx cv vz cv cZ cfv cW cnm cfv cfv wceq wa vz cU cba
      cfv wrex vz cv cU cnm cfv cfv c1 cle wbr vx cv cc0 wceq wa vz cU cba cfv
      wrex vz cv cU cnm cfv cfv c1 cle wbr vz cU cba cfv wrex vx cv cc0 wceq wa
      cU cnv wcel cW cnv wcel wa vz cv cU cnm cfv cfv c1 cle wbr vx cv vz cv cZ
      cfv cW cnm cfv cfv wceq wa vz cv cU cnm cfv cfv c1 cle wbr vx cv cc0 wceq
      wa vz cU cba cfv cU cnv wcel cW cnv wcel wa vz cv cU cba cfv wcel wa vx
      cv vz cv cZ cfv cW cnm cfv cfv wceq vx cv cc0 wceq vz cv cU cnm cfv cfv
      c1 cle wbr cU cnv wcel cW cnv wcel wa vz cv cU cba cfv wcel wa vz cv cZ
      cfv cW cnm cfv cfv cc0 vx cv cU cnv wcel cW cnv wcel wa vz cv cU cba cfv
      wcel wa vz cv cZ cfv cW cnm cfv cfv cW cn0v cfv cW cnm cfv cfv cc0 cU cnv
      wcel cW cnv wcel wa vz cv cU cba cfv wcel wa vz cv cZ cfv cW cn0v cfv cW
      cnm cfv cU cnv wcel cW cnv wcel vz cv cU cba cfv wcel vz cv cZ cfv cW
      cn0v cfv wceq vz cv cU cZ cW cU cba cfv cW cn0v cfv cU cba cfv eqid cW
      cn0v cfv eqid nmo0.0 0oval 3expa fveq2d cW cnv wcel cW cn0v cfv cW cnm
      cfv cfv cc0 wceq cU cnv wcel vz cv cU cba cfv wcel cW cW cnm cfv cW cn0v
      cfv cW cn0v cfv eqid cW cnm cfv eqid nvz0 ad2antlr eqtrd eqeq2d anbi2d
      rexbidva vz cv cU cnm cfv cfv c1 cle wbr vx cv cc0 wceq vz cU cba cfv
      r19.41v syl6rbb bitrd abbidv vx cc0 df-sn syl5req cxr vz cv cU cnm cfv
      cfv c1 cle wbr vx cv vz cv cZ cfv cW cnm cfv cfv wceq wa vz cU cba cfv
      wrex vx cab cc0 csn clt supeq1 syl eqtrd cc0 cxr wcel cc0 csn cxr clt
      csup cc0 wceq cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cxr cc0 clt
      xrltso supsn ax-mp syl6eq $.
      $( [16-Dec-2007] $) $( [27-Nov-2007] $)
  $}

  ${
    0blo.0 $e |- Z = ( U 0op W ) $.
    0blo.7 $e |- B = ( U BLnOp W ) $.
    $( The zero operator is a bounded linear operator. $)
    0blo $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> Z e. B ) $=
      cU cnv wcel cW cnv wcel wa cZ cB wcel cZ cU cW clno co wcel cZ cU cW cnmo
      co cfv cr wcel wa cU cnv wcel cW cnv wcel wa cZ cU cW clno co wcel cZ cU
      cW cnmo co cfv cr wcel cU cU cW clno co cW cZ 0blo.0 cU cW clno co eqid
      0lno cU cnv wcel cW cnv wcel wa cZ cU cW cnmo co cfv cc0 cr cU cU cW cnmo
      co cW cZ cU cW cnmo co eqid 0blo.0 nmo0 0re syl6eqel jca cB cZ cU cU cW
      clno co cU cW cnmo co cW cU cW cnmo co eqid cU cW clno co eqid 0blo.7
      isblo2 mpbird $.
      $( [1-Jan-2008] $) $( [8-Dec-2007] $)
  $}

  ${
    $d y z K $.  $d y z M $.  $d x N $.  $d z R $.  $d y z S $.  $d x y z T $.
    $d y z U $.  $d y z W $.  $d x y z X $.  $d y z Y $.  $d x Z $.
    nmlno0.3 $e |- N = ( U normOp W ) $.
    nmlno0.0 $e |- Z = ( U 0op W ) $.
    nmlno0.7 $e |- L = ( U LnOp W ) $.
    ${
      nmlno0lem.u $e |- U e. NrmCVec $.
      nmlno0lem.w $e |- W e. NrmCVec $.
      nmlno0lem.l $e |- T e. L $.
      nmlno0lem.1 $e |- X = ( BaseSet ` U ) $.
      nmlno0lem.2 $e |- Y = ( BaseSet ` W ) $.
      nmlno0lem.r $e |- R = ( .s ` U ) $.
      nmlno0lem.s $e |- S = ( .s ` W ) $.
      nmlno0lem.p $e |- P = ( 0v ` U ) $.
      nmlno0lem.q $e |- Q = ( 0v ` W ) $.
      nmlno0lem.k $e |- K = ( norm ` U ) $.
      nmlno0lem.m $e |- M = ( norm ` W ) $.
      $( Lemma for ~ nmlno0i . $)
      nmlno0lem $p |- ( ( N ` T ) = 0 <-> T = Z ) $=
        cT cN cfv cc0 wceq cT cZ wceq cT cN cfv cc0 wceq vx cv cT cfv vx cv cZ
        cfv wceq vx cX wral cT cZ wceq cT cN cfv cc0 wceq vx cv cT cfv vx cv cZ
        cfv wceq vx cX cT cN cfv cc0 wceq vx cv cX wcel wa vx cv cT cfv cQ vx
        cv cZ cfv cT cN cfv cc0 wceq vx cv cX wcel wa vx cv cT cfv cQ wne wn vx
        cv cT cfv cQ wceq cT cN cfv cc0 wceq vx cv cX wcel wa vx cv cT cfv cQ
        wne cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv clt wbr vx cv
        cX wcel vx cv cT cfv cQ wne cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS
        co cM cfv clt wbr wi cT cN cfv cc0 wceq vx cv cX wcel vx cv cT cfv cQ
        wne cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv clt wbr vx cv
        cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co vx cv cT cfv cS
        co cQ wne cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv clt wbr
        vx cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co vx cv cT
        cfv cS co cQ wne c1 vx cv cK cfv cdiv co cc0 wne vx cv cT cfv cQ wne wa
        vx cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co cc0 wne vx
        cv cT cfv cQ wne vx cv cK cfv cc wcel vx cv cK cfv cc0 wne c1 vx cv cK
        cfv cdiv co cc0 wne vx cv cX wcel vx cv cT cfv cQ wne wa vx cv cK cfv
        recne0 vx cv cX wcel vx cv cK cfv cc wcel vx cv cT cfv cQ wne vx cv cX
        wcel vx cv cK cfv cU cnv wcel vx cv cX wcel vx cv cK cfv cr wcel
        nmlno0lem.u vx cv cU cK cX nmlno0lem.1 nmlno0lem.k nvcl mpan recnd
        adantr vx cv cX wcel vx cv cT cfv cQ wne vx cv cK cfv cc0 wne vx cv cX
        wcel vx cv cK cfv cc0 vx cv cT cfv cQ vx cv cX wcel vx cv cK cfv cc0
        wceq vx cv cP wceq vx cv cT cfv cQ wceq cU cnv wcel vx cv cX wcel vx cv
        cK cfv cc0 wceq vx cv cP wceq wb nmlno0lem.u vx cv cU cK cX cP
        nmlno0lem.1 nmlno0lem.p nmlno0lem.k nvz mpan vx cv cP wceq vx cv cT cfv
        cP cT cfv cQ vx cv cP cT fveq2 cU cnv wcel cW cnv wcel cT cL wcel cP cT
        cfv cQ wceq nmlno0lem.u nmlno0lem.w nmlno0lem.l cP cT cU cL cW cX cY cQ
        nmlno0lem.1 nmlno0lem.2 nmlno0lem.p nmlno0lem.q nmlno0.7 lno0 mp3an
        syl6eq syl6bi necon3d imp sylanc vx cv cX wcel vx cv cT cfv cQ wne
        pm3.27 jca vx cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co
        vx cv cT cfv cS co cQ wne c1 vx cv cK cfv cdiv co cc0 wceq vx cv cT cfv
        cQ wceq wo wn c1 vx cv cK cfv cdiv co cc0 wne vx cv cT cfv cQ wne wa vx
        cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co cc0 wceq vx
        cv cT cfv cQ wceq wo c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cQ c1
        vx cv cK cfv cdiv co cc wcel vx cv cT cfv cY wcel c1 vx cv cK cfv cdiv
        co vx cv cT cfv cS co cQ wceq c1 vx cv cK cfv cdiv co cc0 wceq vx cv cT
        cfv cQ wceq wo wb vx cv cX wcel vx cv cT cfv cQ wne wa cW cnv wcel c1
        vx cv cK cfv cdiv co cc wcel vx cv cT cfv cY wcel c1 vx cv cK cfv cdiv
        co vx cv cT cfv cS co cQ wceq c1 vx cv cK cfv cdiv co cc0 wceq vx cv cT
        cfv cQ wceq wo wb nmlno0lem.w c1 vx cv cK cfv cdiv co vx cv cT cfv cS
        cW cY cQ nmlno0lem.2 nmlno0lem.s nmlno0lem.q nvmul0or mp3an1 vx cv cK
        cfv cc wcel vx cv cK cfv cc0 wne c1 vx cv cK cfv cdiv co cc wcel vx cv
        cX wcel vx cv cT cfv cQ wne wa vx cv cK cfv reccl vx cv cX wcel vx cv
        cK cfv cc wcel vx cv cT cfv cQ wne vx cv cX wcel vx cv cK cfv cU cnv
        wcel vx cv cX wcel vx cv cK cfv cr wcel nmlno0lem.u vx cv cU cK cX
        nmlno0lem.1 nmlno0lem.k nvcl mpan recnd adantr vx cv cX wcel vx cv cT
        cfv cQ wne vx cv cK cfv cc0 wne vx cv cX wcel vx cv cK cfv cc0 vx cv cT
        cfv cQ vx cv cX wcel vx cv cK cfv cc0 wceq vx cv cP wceq vx cv cT cfv
        cQ wceq cU cnv wcel vx cv cX wcel vx cv cK cfv cc0 wceq vx cv cP wceq
        wb nmlno0lem.u vx cv cU cK cX cP nmlno0lem.1 nmlno0lem.p nmlno0lem.k
        nvz mpan vx cv cP wceq vx cv cT cfv cP cT cfv cQ vx cv cP cT fveq2 cU
        cnv wcel cW cnv wcel cT cL wcel cP cT cfv cQ wceq nmlno0lem.u
        nmlno0lem.w nmlno0lem.l cP cT cU cL cW cX cY cQ nmlno0lem.1 nmlno0lem.2
        nmlno0lem.p nmlno0lem.q nmlno0.7 lno0 mp3an syl6eq syl6bi necon3d imp
        sylanc vx cv cX wcel vx cv cT cfv cY wcel vx cv cT cfv cQ wne cX cY vx
        cv cT cU cnv wcel cW cnv wcel cT cL wcel cX cY cT wf nmlno0lem.u
        nmlno0lem.w nmlno0lem.l cT cU cL cW cX cY nmlno0lem.1 nmlno0lem.2
        nmlno0.7 lnof mp3an ffvelrni adantr sylanc necon3abid c1 vx cv cK cfv
        cdiv co cc0 vx cv cT cfv cQ neanior syl6bbr mpbird vx cv cX wcel vx cv
        cT cfv cQ wne wa c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cY wcel c1
        vx cv cK cfv cdiv co vx cv cT cfv cS co cQ wne cc0 c1 vx cv cK cfv cdiv
        co vx cv cT cfv cS co cM cfv clt wbr wb c1 vx cv cK cfv cdiv co cc wcel
        vx cv cT cfv cY wcel c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cY wcel
        vx cv cX wcel vx cv cT cfv cQ wne wa cW cnv wcel c1 vx cv cK cfv cdiv
        co cc wcel vx cv cT cfv cY wcel c1 vx cv cK cfv cdiv co vx cv cT cfv cS
        co cY wcel nmlno0lem.w c1 vx cv cK cfv cdiv co vx cv cT cfv cS cW cY
        nmlno0lem.2 nmlno0lem.s nvscl mp3an1 vx cv cK cfv cc wcel vx cv cK cfv
        cc0 wne c1 vx cv cK cfv cdiv co cc wcel vx cv cX wcel vx cv cT cfv cQ
        wne wa vx cv cK cfv reccl vx cv cX wcel vx cv cK cfv cc wcel vx cv cT
        cfv cQ wne vx cv cX wcel vx cv cK cfv cU cnv wcel vx cv cX wcel vx cv
        cK cfv cr wcel nmlno0lem.u vx cv cU cK cX nmlno0lem.1 nmlno0lem.k nvcl
        mpan recnd adantr vx cv cX wcel vx cv cT cfv cQ wne vx cv cK cfv cc0
        wne vx cv cX wcel vx cv cK cfv cc0 vx cv cT cfv cQ vx cv cX wcel vx cv
        cK cfv cc0 wceq vx cv cP wceq vx cv cT cfv cQ wceq cU cnv wcel vx cv cX
        wcel vx cv cK cfv cc0 wceq vx cv cP wceq wb nmlno0lem.u vx cv cU cK cX
        cP nmlno0lem.1 nmlno0lem.p nmlno0lem.k nvz mpan vx cv cP wceq vx cv cT
        cfv cP cT cfv cQ vx cv cP cT fveq2 cU cnv wcel cW cnv wcel cT cL wcel
        cP cT cfv cQ wceq nmlno0lem.u nmlno0lem.w nmlno0lem.l cP cT cU cL cW cX
        cY cQ nmlno0lem.1 nmlno0lem.2 nmlno0lem.p nmlno0lem.q nmlno0.7 lno0
        mp3an syl6eq syl6bi necon3d imp sylanc vx cv cX wcel vx cv cT cfv cY
        wcel vx cv cT cfv cQ wne cX cY vx cv cT cU cnv wcel cW cnv wcel cT cL
        wcel cX cY cT wf nmlno0lem.u nmlno0lem.w nmlno0lem.l cT cU cL cW cX cY
        nmlno0lem.1 nmlno0lem.2 nmlno0.7 lnof mp3an ffvelrni adantr sylanc cW
        cnv wcel c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cY wcel c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cQ wne cc0 c1 vx cv cK cfv cdiv co vx cv
        cT cfv cS co cM cfv clt wbr wb nmlno0lem.w c1 vx cv cK cfv cdiv co vx
        cv cT cfv cS co cW cM cY cQ nmlno0lem.2 nmlno0lem.q nmlno0lem.m nvgt0
        mpan syl mpbid ex adantl cT cN cfv cc0 wceq vx cv cX wcel wa vx cv cT
        cfv cQ wne cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv clt
        wbr wn cT cN cfv cc0 wceq vx cv cX wcel wa vx cv cT cfv cQ wne wa c1 vx
        cv cK cfv cdiv co vx cv cT cfv cS co cM cfv cc0 cle wbr cc0 c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cM cfv clt wbr wn cT cN cfv cc0 wceq vx
        cv cX wcel wa vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co vx cv cT
        cfv cS co cM cfv vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq
        wa vz cX wrex vy cab cxr clt csup cc0 cle vx cv cX wcel vx cv cT cfv cQ
        wne c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cK cfv c1
        cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt
        csup cle wbr cT cN cfv cc0 wceq vx cv cX wcel vx cv cT cfv cQ wne wa c1
        vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cK cfv c1 cle wbr
        vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab wcel c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cK cfv c1 cle wbr vy cv vz
        cv cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt csup cle wbr vx cv
        cX wcel vx cv cT cfv cQ wne wa vz cv cK cfv c1 cle wbr c1 vx cv cK cfv
        cdiv co vx cv cT cfv cS co cM cfv vz cv cT cfv cM cfv wceq wa vz cX
        wrex c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cK cfv c1
        cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab wcel c1 vx
        cv cK cfv cdiv co vx cv cR co cX wcel c1 vx cv cK cfv cdiv co vx cv cR
        co cK cfv c1 cle wbr c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv
        c1 vx cv cK cfv cdiv co vx cv cR co cT cfv cM cfv wceq wa vz cv cK cfv
        c1 cle wbr c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cT
        cfv cM cfv wceq wa vz cX wrex vx cv cX wcel vx cv cT cfv cQ wne wa vz
        cv cK cfv c1 cle wbr c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv
        vz cv cT cfv cM cfv wceq wa c1 vx cv cK cfv cdiv co vx cv cR co cK cfv
        c1 cle wbr c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv c1 vx cv
        cK cfv cdiv co vx cv cR co cT cfv cM cfv wceq wa vz c1 vx cv cK cfv
        cdiv co vx cv cR co cX vz cv c1 vx cv cK cfv cdiv co vx cv cR co wceq
        vz cv cK cfv c1 cle wbr c1 vx cv cK cfv cdiv co vx cv cR co cK cfv c1
        cle wbr c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cT cfv
        cM cfv wceq c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv c1 vx cv
        cK cfv cdiv co vx cv cR co cT cfv cM cfv wceq vz cv c1 vx cv cK cfv
        cdiv co vx cv cR co wceq vz cv cK cfv c1 vx cv cK cfv cdiv co vx cv cR
        co cK cfv c1 cle vz cv c1 vx cv cK cfv cdiv co vx cv cR co cK fveq2
        breq1d vz cv c1 vx cv cK cfv cdiv co vx cv cR co wceq vz cv cT cfv cM
        cfv c1 vx cv cK cfv cdiv co vx cv cR co cT cfv cM cfv c1 vx cv cK cfv
        cdiv co vx cv cT cfv cS co cM cfv vz cv c1 vx cv cK cfv cdiv co vx cv
        cR co wceq vz cv cT cfv c1 vx cv cK cfv cdiv co vx cv cR co cT cfv cM
        vz cv c1 vx cv cK cfv cdiv co vx cv cR co cT fveq2 fveq2d eqeq2d
        anbi12d rcla4ev c1 vx cv cK cfv cdiv co cc wcel vx cv cX wcel c1 vx cv
        cK cfv cdiv co vx cv cR co cX wcel vx cv cX wcel vx cv cT cfv cQ wne wa
        cU cnv wcel c1 vx cv cK cfv cdiv co cc wcel vx cv cX wcel c1 vx cv cK
        cfv cdiv co vx cv cR co cX wcel nmlno0lem.u c1 vx cv cK cfv cdiv co vx
        cv cR cU cX nmlno0lem.1 nmlno0lem.r nvscl mp3an1 vx cv cK cfv cc wcel
        vx cv cK cfv cc0 wne c1 vx cv cK cfv cdiv co cc wcel vx cv cX wcel vx
        cv cT cfv cQ wne wa vx cv cK cfv reccl vx cv cX wcel vx cv cK cfv cc
        wcel vx cv cT cfv cQ wne vx cv cX wcel vx cv cK cfv cU cnv wcel vx cv
        cX wcel vx cv cK cfv cr wcel nmlno0lem.u vx cv cU cK cX nmlno0lem.1
        nmlno0lem.k nvcl mpan recnd adantr vx cv cX wcel vx cv cT cfv cQ wne vx
        cv cK cfv cc0 wne vx cv cX wcel vx cv cK cfv cc0 vx cv cT cfv cQ vx cv
        cX wcel vx cv cK cfv cc0 wceq vx cv cP wceq vx cv cT cfv cQ wceq cU cnv
        wcel vx cv cX wcel vx cv cK cfv cc0 wceq vx cv cP wceq wb nmlno0lem.u
        vx cv cU cK cX cP nmlno0lem.1 nmlno0lem.p nmlno0lem.k nvz mpan vx cv cP
        wceq vx cv cT cfv cP cT cfv cQ vx cv cP cT fveq2 cU cnv wcel cW cnv
        wcel cT cL wcel cP cT cfv cQ wceq nmlno0lem.u nmlno0lem.w nmlno0lem.l
        cP cT cU cL cW cX cY cQ nmlno0lem.1 nmlno0lem.2 nmlno0lem.p nmlno0lem.q
        nmlno0.7 lno0 mp3an syl6eq syl6bi necon3d imp sylanc vx cv cX wcel vx
        cv cT cfv cQ wne pm3.26 sylanc vx cv cX wcel vx cv cT cfv cQ wne wa c1
        vx cv cK cfv cdiv co vx cv cR co cK cfv c1 cle wbr c1 vx cv cK cfv cdiv
        co vx cv cT cfv cS co cM cfv c1 vx cv cK cfv cdiv co vx cv cR co cT cfv
        cM cfv wceq c1 vx cv cK cfv cdiv co vx cv cR co cK cfv cr wcel c1 vx cv
        cK cfv cdiv co vx cv cR co cK cfv c1 wceq c1 vx cv cK cfv cdiv co vx cv
        cR co cK cfv c1 cle wbr vx cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv
        cK cfv cdiv co vx cv cR co cK cfv c1 eqle vx cv cX wcel vx cv cT cfv cQ
        wne wa c1 vx cv cK cfv cdiv co vx cv cR co cK cfv c1 cr vx cv cX wcel
        vx cv cP wne c1 vx cv cK cfv cdiv co vx cv cR co cK cfv c1 wceq vx cv
        cT cfv cQ wne cU cnv wcel vx cv cX wcel vx cv cP wne c1 vx cv cK cfv
        cdiv co vx cv cR co cK cfv c1 wceq nmlno0lem.u vx cv cR cU cK cX cP
        nmlno0lem.1 nmlno0lem.r nmlno0lem.p nmlno0lem.k nv1 mp3an1 vx cv cP vx
        cv cT cfv cQ vx cv cP wceq vx cv cT cfv cP cT cfv cQ vx cv cP cT fveq2
        cU cnv wcel cW cnv wcel cT cL wcel cP cT cfv cQ wceq nmlno0lem.u
        nmlno0lem.w nmlno0lem.l cP cT cU cL cW cX cY cQ nmlno0lem.1 nmlno0lem.2
        nmlno0lem.p nmlno0lem.q nmlno0.7 lno0 mp3an syl6eq necon3i sylan2 1re
        syl6eqel vx cv cX wcel vx cv cP wne c1 vx cv cK cfv cdiv co vx cv cR co
        cK cfv c1 wceq vx cv cT cfv cQ wne cU cnv wcel vx cv cX wcel vx cv cP
        wne c1 vx cv cK cfv cdiv co vx cv cR co cK cfv c1 wceq nmlno0lem.u vx
        cv cR cU cK cX cP nmlno0lem.1 nmlno0lem.r nmlno0lem.p nmlno0lem.k nv1
        mp3an1 vx cv cP vx cv cT cfv cQ vx cv cP wceq vx cv cT cfv cP cT cfv cQ
        vx cv cP cT fveq2 cU cnv wcel cW cnv wcel cT cL wcel cP cT cfv cQ wceq
        nmlno0lem.u nmlno0lem.w nmlno0lem.l cP cT cU cL cW cX cY cQ nmlno0lem.1
        nmlno0lem.2 nmlno0lem.p nmlno0lem.q nmlno0.7 lno0 mp3an syl6eq necon3i
        sylan2 sylanc vx cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv
        co vx cv cT cfv cS co c1 vx cv cK cfv cdiv co vx cv cR co cT cfv cM vx
        cv cX wcel vx cv cT cfv cQ wne wa c1 vx cv cK cfv cdiv co vx cv cR co
        cT cfv c1 vx cv cK cfv cdiv co vx cv cT cfv cS co c1 vx cv cK cfv cdiv
        co cc wcel vx cv cX wcel c1 vx cv cK cfv cdiv co vx cv cR co cT cfv c1
        vx cv cK cfv cdiv co vx cv cT cfv cS co wceq vx cv cX wcel vx cv cT cfv
        cQ wne wa cU cnv wcel cW cnv wcel cT cL wcel w3a c1 vx cv cK cfv cdiv
        co cc wcel vx cv cX wcel wa c1 vx cv cK cfv cdiv co vx cv cR co cT cfv
        c1 vx cv cK cfv cdiv co vx cv cT cfv cS co wceq cU cnv wcel cW cnv wcel
        cT cL wcel nmlno0lem.u nmlno0lem.w nmlno0lem.l 3pm3.2i c1 vx cv cK cfv
        cdiv co vx cv cR cS cT cU cL cW cX nmlno0lem.1 nmlno0lem.r nmlno0lem.s
        nmlno0.7 lnomul mpan vx cv cK cfv cc wcel vx cv cK cfv cc0 wne c1 vx cv
        cK cfv cdiv co cc wcel vx cv cX wcel vx cv cT cfv cQ wne wa vx cv cK
        cfv reccl vx cv cX wcel vx cv cK cfv cc wcel vx cv cT cfv cQ wne vx cv
        cX wcel vx cv cK cfv cU cnv wcel vx cv cX wcel vx cv cK cfv cr wcel
        nmlno0lem.u vx cv cU cK cX nmlno0lem.1 nmlno0lem.k nvcl mpan recnd
        adantr vx cv cX wcel vx cv cT cfv cQ wne vx cv cK cfv cc0 wne vx cv cX
        wcel vx cv cK cfv cc0 vx cv cT cfv cQ vx cv cX wcel vx cv cK cfv cc0
        wceq vx cv cP wceq vx cv cT cfv cQ wceq cU cnv wcel vx cv cX wcel vx cv
        cK cfv cc0 wceq vx cv cP wceq wb nmlno0lem.u vx cv cU cK cX cP
        nmlno0lem.1 nmlno0lem.p nmlno0lem.k nvz mpan vx cv cP wceq vx cv cT cfv
        cP cT cfv cQ vx cv cP cT fveq2 cU cnv wcel cW cnv wcel cT cL wcel cP cT
        cfv cQ wceq nmlno0lem.u nmlno0lem.w nmlno0lem.l cP cT cU cL cW cX cY cQ
        nmlno0lem.1 nmlno0lem.2 nmlno0lem.p nmlno0lem.q nmlno0.7 lno0 mp3an
        syl6eq syl6bi necon3d imp sylanc vx cv cX wcel vx cv cT cfv cQ wne
        pm3.26 sylanc eqcomd fveq2d jca sylanc vz cv cK cfv c1 cle wbr vy cv vz
        cv cT cfv cM cfv wceq wa vz cX wrex vz cv cK cfv c1 cle wbr c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cT cfv cM cfv wceq wa vz cX
        wrex vy c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cM fvex vy cv c1 vx cv cK cfv cdiv co vx
        cv cT cfv cS co cM cfv wceq vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv
        cM cfv wceq wa vz cv cK cfv c1 cle wbr c1 vx cv cK cfv cdiv co vx cv cT
        cfv cS co cM cfv vz cv cT cfv cM cfv wceq wa vz cX vy cv c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cM cfv wceq vy cv vz cv cT cfv cM cfv
        wceq c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cT cfv cM
        cfv wceq vz cv cK cfv c1 cle wbr vy cv c1 vx cv cK cfv cdiv co vx cv cT
        cfv cS co cM cfv vz cv cT cfv cM cfv eqeq1 anbi2d rexbidv elab sylibr
        vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy
        cab cxr wss c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cK
        cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab wcel
        c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv vz cv cK cfv c1 cle
        wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt csup
        cle wbr vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX
        wrex vy cab cr cxr cW cnv wcel cX cY cT wf vz cv cK cfv c1 cle wbr vy
        cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cr wss nmlno0lem.w cU
        cnv wcel cW cnv wcel cT cL wcel cX cY cT wf nmlno0lem.u nmlno0lem.w
        nmlno0lem.l cT cU cL cW cX cY nmlno0lem.1 nmlno0lem.2 nmlno0.7 lnof
        mp3an vy vz cT cK cM cW cX cY nmlno0lem.2 nmlno0lem.m nmosetre mp2an
        ressxr sstri vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv cM cfv wceq wa
        vz cX wrex vy cab c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv
        supxrub mpan syl adantll cT cN cfv cc0 wceq vz cv cK cfv c1 cle wbr vy
        cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt csup cc0 wceq
        vx cv cX wcel vx cv cT cfv cQ wne cT cN cfv cc0 wceq vz cv cK cfv c1
        cle wbr vy cv vz cv cT cfv cM cfv wceq wa vz cX wrex vy cab cxr clt
        csup cc0 wceq cT cN cfv vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv cM
        cfv wceq wa vz cX wrex vy cab cxr clt csup cc0 cU cnv wcel cW cnv wcel
        cX cY cT wf cT cN cfv vz cv cK cfv c1 cle wbr vy cv vz cv cT cfv cM cfv
        wceq wa vz cX wrex vy cab cxr clt csup wceq nmlno0lem.u nmlno0lem.w cU
        cnv wcel cW cnv wcel cT cL wcel cX cY cT wf nmlno0lem.u nmlno0lem.w
        nmlno0lem.l cT cU cL cW cX cY nmlno0lem.1 nmlno0lem.2 nmlno0.7 lnof
        mp3an vy vz cT cU cK cM cN cW cX cY nmlno0lem.1 nmlno0lem.2 nmlno0lem.k
        nmlno0lem.m nmlno0.3 nmoval mp3an eqeq1i biimpi ad2antrr breqtrd vx cv
        cX wcel vx cv cT cfv cQ wne c1 vx cv cK cfv cdiv co vx cv cT cfv cS co
        cM cfv cc0 cle wbr cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM
        cfv clt wbr wn wb cT cN cfv cc0 wceq vx cv cX wcel vx cv cT cfv cQ wne
        wa c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv cr wcel c1 vx cv
        cK cfv cdiv co vx cv cT cfv cS co cM cfv cc0 cle wbr cc0 c1 vx cv cK
        cfv cdiv co vx cv cT cfv cS co cM cfv clt wbr wn wb vx cv cX wcel vx cv
        cT cfv cQ wne wa c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cY wcel c1
        vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv cr wcel c1 vx cv cK cfv
        cdiv co cc wcel vx cv cT cfv cY wcel c1 vx cv cK cfv cdiv co vx cv cT
        cfv cS co cY wcel vx cv cX wcel vx cv cT cfv cQ wne wa cW cnv wcel c1
        vx cv cK cfv cdiv co cc wcel vx cv cT cfv cY wcel c1 vx cv cK cfv cdiv
        co vx cv cT cfv cS co cY wcel nmlno0lem.w c1 vx cv cK cfv cdiv co vx cv
        cT cfv cS cW cY nmlno0lem.2 nmlno0lem.s nvscl mp3an1 vx cv cK cfv cc
        wcel vx cv cK cfv cc0 wne c1 vx cv cK cfv cdiv co cc wcel vx cv cX wcel
        vx cv cT cfv cQ wne wa vx cv cK cfv reccl vx cv cX wcel vx cv cK cfv cc
        wcel vx cv cT cfv cQ wne vx cv cX wcel vx cv cK cfv cU cnv wcel vx cv
        cX wcel vx cv cK cfv cr wcel nmlno0lem.u vx cv cU cK cX nmlno0lem.1
        nmlno0lem.k nvcl mpan recnd adantr vx cv cX wcel vx cv cT cfv cQ wne vx
        cv cK cfv cc0 wne vx cv cX wcel vx cv cK cfv cc0 vx cv cT cfv cQ vx cv
        cX wcel vx cv cK cfv cc0 wceq vx cv cP wceq vx cv cT cfv cQ wceq cU cnv
        wcel vx cv cX wcel vx cv cK cfv cc0 wceq vx cv cP wceq wb nmlno0lem.u
        vx cv cU cK cX cP nmlno0lem.1 nmlno0lem.p nmlno0lem.k nvz mpan vx cv cP
        wceq vx cv cT cfv cP cT cfv cQ vx cv cP cT fveq2 cU cnv wcel cW cnv
        wcel cT cL wcel cP cT cfv cQ wceq nmlno0lem.u nmlno0lem.w nmlno0lem.l
        cP cT cU cL cW cX cY cQ nmlno0lem.1 nmlno0lem.2 nmlno0lem.p nmlno0lem.q
        nmlno0.7 lno0 mp3an syl6eq syl6bi necon3d imp sylanc vx cv cX wcel vx
        cv cT cfv cY wcel vx cv cT cfv cQ wne cX cY vx cv cT cU cnv wcel cW cnv
        wcel cT cL wcel cX cY cT wf nmlno0lem.u nmlno0lem.w nmlno0lem.l cT cU
        cL cW cX cY nmlno0lem.1 nmlno0lem.2 nmlno0.7 lnof mp3an ffvelrni adantr
        sylanc cW cnv wcel c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cY wcel
        c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv cr wcel nmlno0lem.w
        c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cW cM cY nmlno0lem.2
        nmlno0lem.m nvcl mpan syl c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM
        cfv cr wcel cc0 cr wcel c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM
        cfv cc0 cle wbr cc0 c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv
        clt wbr wn wb 0re c1 vx cv cK cfv cdiv co vx cv cT cfv cS co cM cfv cc0
        lenlt mpan2 syl adantll mpbid ex pm2.65d vx cv cT cfv cQ nne sylib vx
        cv cX wcel vx cv cZ cfv cQ wceq cT cN cfv cc0 wceq cU cnv wcel cW cnv
        wcel vx cv cX wcel vx cv cZ cfv cQ wceq nmlno0lem.u nmlno0lem.w vx cv
        cU cZ cW cX cQ nmlno0lem.1 nmlno0lem.q nmlno0.0 0oval mp3an12 adantl
        eqtr4d r19.21aiva cT cX wfn cZ cX wfn cT cZ wceq vx cv cT cfv vx cv cZ
        cfv wceq vx cX wral wb cX cY cT wf cT cX wfn cU cnv wcel cW cnv wcel cT
        cL wcel cX cY cT wf nmlno0lem.u nmlno0lem.w nmlno0lem.l cT cU cL cW cX
        cY nmlno0lem.1 nmlno0lem.2 nmlno0.7 lnof mp3an cX cY cT ffn ax-mp cX cY
        cZ wf cZ cX wfn cU cnv wcel cW cnv wcel cX cY cZ wf nmlno0lem.u
        nmlno0lem.w cU cW cX cY cZ nmlno0lem.1 nmlno0lem.2 nmlno0.0 0oo mp2an
        cX cY cZ ffn ax-mp vx cX cT cZ eqfnfv2 mp2an sylibr cT cZ wceq cT cN
        cfv cZ cN cfv cc0 cT cZ cN fveq2 cU cnv wcel cW cnv wcel cZ cN cfv cc0
        wceq nmlno0lem.u nmlno0lem.w cU cN cW cZ nmlno0.3 nmlno0.0 nmo0 mp2an
        syl6eq impbii $.
        $( [26-Dec-2007] $) $( [28-Nov-2007] $)
    $}

    ${
      nmlno0i.u $e |- U e. NrmCVec $.
      nmlno0i.w $e |- W e. NrmCVec $.
      $( The norm of a linear operator is zero iff the operator is zero. $)
      nmlno0i $p |- ( T e. L -> ( ( N ` T ) = 0 <-> T = Z ) ) $=
        cT cL wcel cT cN cfv cc0 wceq cT cZ wceq wb cT cL wcel cT cZ cif cN cfv
        cc0 wceq cT cL wcel cT cZ cif cZ wceq wb cT cZ cT cT cL wcel cT cZ cif
        wceq cT cN cfv cc0 wceq cT cL wcel cT cZ cif cN cfv cc0 wceq cT cZ wceq
        cT cL wcel cT cZ cif cZ wceq cT cT cL wcel cT cZ cif wceq cT cN cfv cT
        cL wcel cT cZ cif cN cfv cc0 cT cT cL wcel cT cZ cif cN fveq2 eqeq1d cT
        cT cL wcel cT cZ cif cZ eqeq1 bibi12d cU cn0v cfv cW cn0v cfv cU cns
        cfv cW cns cfv cT cL wcel cT cZ cif cU cU cnm cfv cL cW cnm cfv cN cW
        cU cba cfv cW cba cfv cZ nmlno0.3 nmlno0.0 nmlno0.7 nmlno0i.u nmlno0i.w
        cT cZ cL cU cnv wcel cW cnv wcel cZ cL wcel nmlno0i.u nmlno0i.w cU cL
        cW cZ nmlno0.0 nmlno0.7 0lno mp2an elimel cU cba cfv eqid cW cba cfv
        eqid cU cns cfv eqid cW cns cfv eqid cU cn0v cfv eqid cW cn0v cfv eqid
        cU cnm cfv eqid cW cnm cfv eqid nmlno0lem dedth $.
        $( [26-Dec-2007] $) $( [6-Dec-2007] $)
    $}

    $( The norm of a linear operator is zero iff the operator is zero. $)
    nmlno0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) ->
       ( ( N ` T ) = 0 <-> T = Z ) ) $=
      cU cnv wcel cW cnv wcel cT cL wcel cT cN cfv cc0 wceq cT cZ wceq wb cU
      cnv wcel cW cnv wcel cT cL wcel cT cN cfv cc0 wceq cT cZ wceq wb wi cT cU
      cnv wcel cU caddc cmul cop cabs cop cif cW clno co wcel cT cU cnv wcel cU
      caddc cmul cop cabs cop cif cW cnmo co cfv cc0 wceq cT cU cnv wcel cU
      caddc cmul cop cabs cop cif cW c0o co wceq wb wi cT cU cnv wcel cU caddc
      cmul cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs cop cif clno co
      wcel cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW caddc
      cmul cop cabs cop cif cnmo co cfv cc0 wceq cT cU cnv wcel cU caddc cmul
      cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs cop cif c0o co wceq
      wb wi cU cW caddc cmul cop cabs cop caddc cmul cop cabs cop cU cU cnv
      wcel cU caddc cmul cop cabs cop cif wceq cT cL wcel cT cU cnv wcel cU
      caddc cmul cop cabs cop cif cW clno co wcel cT cN cfv cc0 wceq cT cZ wceq
      wb cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo co cfv cc0 wceq
      cT cU cnv wcel cU caddc cmul cop cabs cop cif cW c0o co wceq wb cU cU cnv
      wcel cU caddc cmul cop cabs cop cif wceq cL cU cnv wcel cU caddc cmul cop
      cabs cop cif cW clno co cT cU cU cnv wcel cU caddc cmul cop cabs cop cif
      wceq cU cW clno co cU cnv wcel cU caddc cmul cop cabs cop cif cW clno co
      cL cU cU cnv wcel cU caddc cmul cop cabs cop cif cW clno opreq1 nmlno0.7
      syl5eq eleq2d cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cT cN
      cfv cc0 wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo co cfv
      cc0 wceq cT cZ wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW c0o
      co wceq cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq cT cN cfv cT
      cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo co cfv cc0 cU cU cnv
      wcel cU caddc cmul cop cabs cop cif wceq cT cN cU cnv wcel cU caddc cmul
      cop cabs cop cif cW cnmo co cU cU cnv wcel cU caddc cmul cop cabs cop cif
      wceq cU cW cnmo co cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo co
      cN cU cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo opreq1 nmlno0.3
      syl5eq fveq1d eqeq1d cU cU cnv wcel cU caddc cmul cop cabs cop cif wceq
      cZ cU cnv wcel cU caddc cmul cop cabs cop cif cW c0o co cT cU cU cnv wcel
      cU caddc cmul cop cabs cop cif wceq cU cW c0o co cU cnv wcel cU caddc
      cmul cop cabs cop cif cW c0o co cZ cU cU cnv wcel cU caddc cmul cop cabs
      cop cif cW c0o opreq1 nmlno0.0 syl5eq eqeq2d bibi12d imbi12d cW cW cnv
      wcel cW caddc cmul cop cabs cop cif wceq cT cU cnv wcel cU caddc cmul cop
      cabs cop cif cW clno co wcel cT cU cnv wcel cU caddc cmul cop cabs cop
      cif cW cnv wcel cW caddc cmul cop cabs cop cif clno co wcel cT cU cnv
      wcel cU caddc cmul cop cabs cop cif cW cnmo co cfv cc0 wceq cT cU cnv
      wcel cU caddc cmul cop cabs cop cif cW c0o co wceq wb cT cU cnv wcel cU
      caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs cop cif
      cnmo co cfv cc0 wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv
      wcel cW caddc cmul cop cabs cop cif c0o co wceq wb cW cW cnv wcel cW
      caddc cmul cop cabs cop cif wceq cU cnv wcel cU caddc cmul cop cabs cop
      cif cW clno co cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW
      caddc cmul cop cabs cop cif clno co cT cW cW cnv wcel cW caddc cmul cop
      cabs cop cif cU cnv wcel cU caddc cmul cop cabs cop cif clno opreq2
      eleq2d cW cW cnv wcel cW caddc cmul cop cabs cop cif wceq cT cU cnv wcel
      cU caddc cmul cop cabs cop cif cW cnmo co cfv cc0 wceq cT cU cnv wcel cU
      caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs cop cif
      cnmo co cfv cc0 wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW c0o
      co wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW
      caddc cmul cop cabs cop cif c0o co wceq cW cW cnv wcel cW caddc cmul cop
      cabs cop cif wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo
      co cfv cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW caddc
      cmul cop cabs cop cif cnmo co cfv cc0 cW cW cnv wcel cW caddc cmul cop
      cabs cop cif wceq cT cU cnv wcel cU caddc cmul cop cabs cop cif cW cnmo
      co cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul
      cop cabs cop cif cnmo co cW cW cnv wcel cW caddc cmul cop cabs cop cif cU
      cnv wcel cU caddc cmul cop cabs cop cif cnmo opreq2 fveq1d eqeq1d cW cW
      cnv wcel cW caddc cmul cop cabs cop cif wceq cU cnv wcel cU caddc cmul
      cop cabs cop cif cW c0o co cU cnv wcel cU caddc cmul cop cabs cop cif cW
      cnv wcel cW caddc cmul cop cabs cop cif c0o co cT cW cW cnv wcel cW caddc
      cmul cop cabs cop cif cU cnv wcel cU caddc cmul cop cabs cop cif c0o
      opreq2 eqeq2d bibi12d imbi12d cT cU cnv wcel cU caddc cmul cop cabs cop
      cif cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul
      cop cabs cop cif clno co cU cnv wcel cU caddc cmul cop cabs cop cif cW
      cnv wcel cW caddc cmul cop cabs cop cif cnmo co cW cnv wcel cW caddc cmul
      cop cabs cop cif cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv wcel
      cW caddc cmul cop cabs cop cif c0o co cU cnv wcel cU caddc cmul cop cabs
      cop cif cW cnv wcel cW caddc cmul cop cabs cop cif cnmo co eqid cU cnv
      wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs
      cop cif c0o co eqid cU cnv wcel cU caddc cmul cop cabs cop cif cW cnv
      wcel cW caddc cmul cop cabs cop cif clno co eqid cU elimnvu cW elimnvu
      nmlno0i dedth2h 3impia $.
      $( [4-Jan-2008] $) $( [24-Nov-2007] $)
  $}


  ${
    $d x A $.  $d x K $.  $d x L $.  $d x M $.  $d x T $.  $d x X $.  $d x W $.
    nmlnoubi.1 $e |- X = ( BaseSet ` U ) $.
    nmlnoubi.z $e |- Z = ( 0v ` U ) $.
    nmlnoubi.k $e |- K = ( norm ` U ) $.
    nmlnoubi.m $e |- M = ( norm ` W ) $.
    nmlnoubi.3 $e |- N = ( U normOp W ) $.
    nmlnoubi.7 $e |- L = ( U LnOp W ) $.
    nmlnoubi.u $e |- U e. NrmCVec $.
    nmlnoubi.w $e |- W e. NrmCVec $.
    $( An upper bound for the operator norm of a linear operator, using only
       the properties of nonzero arguments. $)
    nmlnoubi $p |- ( ( T e. L /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. X ( x =/= Z
     -> ( M ` ( T ` x ) ) <_ ( A x. ( K ` x ) ) ) ) -> ( N ` T ) <_ A ) $=
      cT cL wcel cA cr wcel cc0 cA cle wbr wa vx cv cT cfv cM cfv cA vx cv cK
      cfv cmul co cle wbr vx cX wral cT cN cfv cA cle wbr vx cv cZ wne vx cv cT
      cfv cM cfv cA vx cv cK cfv cmul co cle wbr wi vx cX wral cX cW cba cfv cT
      wf cA cr wcel cc0 cA cle wbr wa vx cv cT cfv cM cfv cA vx cv cK cfv cmul
      co cle wbr vx cX wral cT cN cfv cA cle wbr cT cL wcel vx cA cT cU cK cM
      cN cW cX cW cba cfv nmlnoubi.1 cW cba cfv eqid nmlnoubi.k nmlnoubi.m
      nmlnoubi.3 nmlnoubi.u nmlnoubi.w nmoub2i cU cnv wcel cW cnv wcel cT cL
      wcel cX cW cba cfv cT wf nmlnoubi.u nmlnoubi.w cT cU cL cW cX cW cba cfv
      nmlnoubi.1 cW cba cfv eqid nmlnoubi.7 lnof mp3an12 syl3an1 cT cL wcel cA
      cr wcel cc0 cA cle wbr wa vx cv cZ wne vx cv cT cfv cM cfv cA vx cv cK
      cfv cmul co cle wbr wi vx cX wral vx cv cT cfv cM cfv cA vx cv cK cfv
      cmul co cle wbr vx cX wral cT cL wcel cA cr wcel cc0 cA cle wbr wa wa vx
      cv cZ wne vx cv cT cfv cM cfv cA vx cv cK cfv cmul co cle wbr wi vx cv cT
      cfv cM cfv cA vx cv cK cfv cmul co cle wbr vx cX cT cL wcel cA cr wcel
      cc0 cA cle wbr wa wa vx cv cZ wne vx cv cT cfv cM cfv cA vx cv cK cfv
      cmul co cle wbr wi vx cv cT cfv cM cfv cA vx cv cK cfv cmul co cle wbr cT
      cL wcel cA cr wcel cc0 cA cle wbr wa wa vx cv cZ wne vx cv cT cfv cM cfv
      cA vx cv cK cfv cmul co cle wbr wi wa vx cv cT cfv cM cfv cA vx cv cK cfv
      cmul co cle wbr cZ cT cfv cM cfv cA cZ cK cfv cmul co cle wbr vx cv cZ vx
      cv cZ wceq vx cv cT cfv cM cfv cZ cT cfv cM cfv cA vx cv cK cfv cmul co
      cA cZ cK cfv cmul co cle vx cv cZ wceq vx cv cT cfv cZ cT cfv cM vx cv cZ
      cT fveq2 fveq2d vx cv cZ wceq vx cv cK cfv cZ cK cfv cA cmul vx cv cZ cK
      fveq2 opreq2d breq12d vx cv cZ wne vx cv cT cfv cM cfv cA vx cv cK cfv
      cmul co cle wbr wi vx cv cZ wne vx cv cT cfv cM cfv cA vx cv cK cfv cmul
      co cle wbr cT cL wcel cA cr wcel cc0 cA cle wbr wa wa vx cv cZ wne vx cv
      cT cfv cM cfv cA vx cv cK cfv cmul co cle wbr wi vx cv cZ wne vx cv cT
      cfv cM cfv cA vx cv cK cfv cmul co cle wbr vx cv cZ wne vx cv cT cfv cM
      cfv cA vx cv cK cfv cmul co cle wbr wi id imp adantll cT cL wcel cA cr
      wcel cc0 cA cle wbr wa wa cZ cT cfv cM cfv cA cZ cK cfv cmul co cle wbr
      vx cv cZ wne vx cv cT cfv cM cfv cA vx cv cK cfv cmul co cle wbr wi cT cL
      wcel cA cr wcel cc0 cA cle wbr wa wa cc0 cc0 cZ cT cfv cM cfv cA cZ cK
      cfv cmul co cle cc0 cc0 cle wbr cT cL wcel cA cr wcel cc0 cA cle wbr wa
      wa cc0 0re leidi a1i cT cL wcel cZ cT cfv cM cfv cc0 wceq cA cr wcel cc0
      cA cle wbr wa cT cL wcel cZ cT cfv cM cfv cW cn0v cfv cM cfv cc0 cT cL
      wcel cZ cT cfv cW cn0v cfv cM cU cnv wcel cW cnv wcel cT cL wcel cZ cT
      cfv cW cn0v cfv wceq nmlnoubi.u nmlnoubi.w cZ cT cU cL cW cX cW cba cfv
      cW cn0v cfv nmlnoubi.1 cW cba cfv eqid nmlnoubi.z cW cn0v cfv eqid
      nmlnoubi.7 lno0 mp3an12 fveq2d cW cnv wcel cW cn0v cfv cM cfv cc0 wceq
      nmlnoubi.w cW cM cW cn0v cfv cW cn0v cfv eqid nmlnoubi.m nvz0 ax-mp
      syl6eq adantr cA cr wcel cA cZ cK cfv cmul co cc0 wceq cT cL wcel cc0 cA
      cle wbr cA cr wcel cA cc0 cmul co cc0 cA cZ cK cfv cmul co cA cr wcel cA
      cc wcel cA cc0 cmul co cc0 wceq cA recn cA mul01 syl cZ cK cfv cc0 cA
      cmul cU cnv wcel cZ cK cfv cc0 wceq nmlnoubi.u cU cK cZ nmlnoubi.z
      nmlnoubi.k nvz0 ax-mp opreq2i syl5eq ad2antrl 3brtr4d adantr pm2.61ne ex
      r19.20sdv 3impia syld3an3 $.
      $( [19-Jan-2008] $) $( [1-Jan-2008] $)
  $}

  ${
    nmlnogt0.3 $e |- N = ( U normOp W ) $.
    nmlnogt0.0 $e |- Z = ( U 0op W ) $.
    nmlnogt0.7 $e |- L = ( U LnOp W ) $.
    $( The norm of a nonzero linear operator is positive. $)
    nmlnogt0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) ->
                   ( T =/= Z <-> 0 < ( N ` T ) ) ) $=
      cU cnv wcel cW cnv wcel cT cL wcel w3a cT cN cfv cc0 wne cT cZ wne cc0 cT
      cN cfv clt wbr cU cnv wcel cW cnv wcel cT cL wcel w3a cT cN cfv cc0 cT cZ
      cT cU cL cN cW cZ nmlnogt0.3 nmlnogt0.0 nmlnogt0.7 nmlno0 necon3bid cU
      cnv wcel cW cnv wcel cU cba cfv cW cba cfv cT wf cT cN cfv cc0 wne cc0 cT
      cN cfv clt wbr wb cT cL wcel cT cN cfv cxr wcel cc0 cT cN cfv cle wbr cT
      cN cfv cc0 wne cc0 cT cN cfv clt wbr wb cU cnv wcel cW cnv wcel cU cba
      cfv cW cba cfv cT wf w3a cT cN cfv cxr wcel cc0 cT cN cfv cle wbr wa cT
      cN cfv cc0 wne cT cN cfv cc0 clt wbr cc0 cT cN cfv clt wbr wo cc0 cT cN
      cfv clt wbr cT cN cfv cxr wcel cT cN cfv cc0 wne cT cN cfv cc0 clt wbr
      cc0 cT cN cfv clt wbr wo wb cc0 cT cN cfv cle wbr cT cN cfv cxr wcel cc0
      cxr wcel cT cN cfv cc0 wne cT cN cfv cc0 clt wbr cc0 cT cN cfv clt wbr wo
      wb cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cT cN cfv cc0 xrlttri2
      mpan2 adantr cT cN cfv cxr wcel cc0 cT cN cfv cle wbr wa cT cN cfv cc0
      clt wbr wn cc0 cT cN cfv clt wbr cT cN cfv cc0 clt wbr cc0 cT cN cfv clt
      wbr wo wb cT cN cfv cxr wcel cc0 cT cN cfv cle wbr cT cN cfv cc0 clt wbr
      wn cc0 cxr wcel cT cN cfv cxr wcel cc0 cT cN cfv cle wbr cT cN cfv cc0
      clt wbr wn wb cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cc0 cT cN cfv
      xrlenlt mpan biimpa cT cN cfv cc0 clt wbr cc0 cT cN cfv clt wbr biorf syl
      bitr4d cT cU cN cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid
      nmlnogt0.3 nmoxr cT cU cN cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba
      cfv eqid nmlnogt0.3 nmoge0 sylanc cT cU cL cW cU cba cfv cW cba cfv cU
      cba cfv eqid cW cba cfv eqid nmlnogt0.7 lnof syld3an3 bitr3d $.
      $( [5-Jan-2008] $) $( [10-Dec-2007] $)
  $}

  ${
    $d x L $.  $d x T $.  $d x U $.  $d x W $.  $d x X $.
    lnon0.1 $e |- X = ( BaseSet ` U ) $.
    lnon0.6 $e |- Z = ( 0v ` U ) $.
    lnon0.0 $e |- O = ( U 0op W ) $.
    lnon0.7 $e |- L = ( U LnOp W ) $.
    $( The domain of a nonzero linear operator contains a nonzero vector. $)
    lnon0 $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\ T =/= O )
                   -> E. x e. X x =/= Z ) $=
      cU cnv wcel cW cnv wcel cT cL wcel w3a cT cO wne vx cv cZ wne vx cX wrex
      cU cnv wcel cW cnv wcel cT cL wcel w3a vx cv cZ wne vx cX wrex cT cO cU
      cnv wcel cW cnv wcel cT cL wcel w3a vx cv cZ wceq vx cX wral cT cO wceq
      vx cv cZ wne vx cX wrex wn cU cnv wcel cW cnv wcel cT cL wcel w3a vx cv
      cZ wceq vx cX wral cT cX cW cn0v cfv csn cxp wceq cT cO wceq cU cnv wcel
      cW cnv wcel cT cL wcel w3a vx cv cZ wceq vx cX wral cT cX wfn vx cv cT
      cfv cW cn0v cfv wceq vx cX wral wa cT cX cW cn0v cfv csn cxp wceq cU cnv
      wcel cW cnv wcel cT cL wcel w3a vx cv cZ wceq vx cX wral vx cv cT cfv cW
      cn0v cfv wceq vx cX wral cT cX wfn cU cnv wcel cW cnv wcel cT cL wcel w3a
      vx cv cZ wceq vx cv cT cfv cW cn0v cfv wceq vx cX cU cnv wcel cW cnv wcel
      cT cL wcel w3a vx cv cZ wceq vx cv cT cfv cW cn0v cfv wceq vx cv cZ wceq
      cU cnv wcel cW cnv wcel cT cL wcel w3a vx cv cT cfv cZ cT cfv cW cn0v cfv
      vx cv cZ cT fveq2 cZ cT cU cL cW cX cW cba cfv cW cn0v cfv lnon0.1 cW cba
      cfv eqid lnon0.6 cW cn0v cfv eqid lnon0.7 lno0 sylan9eqr ex r19.20sdv cU
      cnv wcel cW cnv wcel cT cL wcel w3a cX cW cba cfv cT wf cT cX wfn cT cU
      cL cW cX cW cba cfv lnon0.1 cW cba cfv eqid lnon0.7 lnof cX cW cba cfv cT
      ffn syl jctild cT cX wfn vx cv cT cfv cW cn0v cfv wceq vx cX wral wa cX
      cW cn0v cfv csn cT wf cT cX cW cn0v cfv csn cxp wceq vx cX cW cn0v cfv cT
      fconstfv cX cW cn0v cfv cT cW cn0v fvex fconst2 bitr3i syl6ib cU cnv wcel
      cW cnv wcel cT cL wcel w3a cO cX cW cn0v cfv csn cxp cT cU cnv wcel cW
      cnv wcel cO cX cW cn0v cfv csn cxp wceq cT cL wcel cU cO cW cX cW cn0v
      cfv lnon0.1 cW cn0v cfv eqid lnon0.0 0ofval 3adant3 eqeq2d sylibrd vx cv
      cZ wne vx cX wrex wn vx cv cZ wne wn vx cX wral vx cv cZ wceq vx cX wral
      vx cv cZ wne vx cX ralnex vx cv cZ wne wn vx cv cZ wceq vx cX vx cv cZ
      nne ralbii bitr3i syl5ib necon1ad imp $.
      $( [13-Aug-2008] $) $( [15-Dec-2007] $)
  $}

  ${
    nmblolbi.1 $e |- X = ( BaseSet ` U ) $.
    nmblolbi.4 $e |- L = ( norm ` U ) $.
    nmblolbi.5 $e |- M = ( norm ` W ) $.
    nmblolbi.6 $e |- N = ( U normOp W ) $.
    nmblolbi.7 $e |- B = ( U BLnOp W ) $.
    nmblolbi.u $e |- U e. NrmCVec $.
    nmblolbi.w $e |- W e. NrmCVec $.
    ${
      nmblolbii.b $e |- T e. B $.
      $( A lower bound for the norm of a bounded linear operator. $)
      nmblolbii $p |- ( A e. X ->
                ( M ` ( T ` A ) ) <_ ( ( N ` T ) x. ( L ` A ) ) ) $=
        cA cX wcel cA cT cfv cM cfv cT cN cfv cA cL cfv cmul co cle wbr cU cn0v
        cfv cT cfv cM cfv cT cN cfv cU cn0v cfv cL cfv cmul co cle wbr cA cU
        cn0v cfv cA cU cn0v cfv wceq cA cT cfv cM cfv cU cn0v cfv cT cfv cM cfv
        cT cN cfv cA cL cfv cmul co cT cN cfv cU cn0v cfv cL cfv cmul co cle cA
        cU cn0v cfv wceq cA cT cfv cU cn0v cfv cT cfv cM cA cU cn0v cfv cT
        fveq2 fveq2d cA cU cn0v cfv wceq cA cL cfv cU cn0v cfv cL cfv cT cN cfv
        cmul cA cU cn0v cfv cL fveq2 opreq2d breq12d cA cX wcel cA cU cn0v cfv
        wne wa cA cT cfv cM cfv cA cL cfv cdiv co cT cN cfv cle wbr cA cT cfv
        cM cfv cT cN cfv cA cL cfv cmul co cle wbr cA cX wcel cA cU cn0v cfv
        wne wa cA cT cfv cM cfv cA cL cfv cdiv co c1 cA cL cfv cdiv co cA cU
        cns cfv co cT cfv cM cfv cT cN cfv cle cA cX wcel cA cU cn0v cfv wne wa
        c1 cA cL cfv cdiv co cA cT cfv cW cns cfv co cM cfv c1 cA cL cfv cdiv
        co cA cT cfv cM cfv cmul co c1 cA cL cfv cdiv co cA cU cns cfv co cT
        cfv cM cfv cA cT cfv cM cfv cA cL cfv cdiv co c1 cA cL cfv cdiv co cr
        wcel cc0 c1 cA cL cfv cdiv co cle wbr wa cA cT cfv cW cba cfv wcel c1
        cA cL cfv cdiv co cA cT cfv cW cns cfv co cM cfv c1 cA cL cfv cdiv co
        cA cT cfv cM cfv cmul co wceq cA cX wcel cA cU cn0v cfv wne wa cW cnv
        wcel c1 cA cL cfv cdiv co cr wcel cc0 c1 cA cL cfv cdiv co cle wbr wa
        cA cT cfv cW cba cfv wcel c1 cA cL cfv cdiv co cA cT cfv cW cns cfv co
        cM cfv c1 cA cL cfv cdiv co cA cT cfv cM cfv cmul co wceq nmblolbi.w c1
        cA cL cfv cdiv co cA cT cfv cW cns cfv cW cM cW cba cfv cW cba cfv eqid
        cW cns cfv eqid nmblolbi.5 nvsge0 mp3an1 cA cX wcel cA cU cn0v cfv wne
        wa c1 cA cL cfv cdiv co cr wcel cc0 c1 cA cL cfv cdiv co cle wbr cA cL
        cfv cr wcel cA cL cfv cc0 wne c1 cA cL cfv cdiv co cr wcel cA cX wcel
        cA cU cn0v cfv wne wa cA cL cfv rereccl cA cX wcel cA cL cfv cr wcel cA
        cU cn0v cfv wne cU cnv wcel cA cX wcel cA cL cfv cr wcel nmblolbi.u cA
        cU cL cX nmblolbi.1 nmblolbi.4 nvcl mpan adantr cA cX wcel cA cL cfv
        cc0 wne cA cU cn0v cfv wne cA cX wcel cA cL cfv cc0 cA cU cn0v cfv cU
        cnv wcel cA cX wcel cA cL cfv cc0 wceq cA cU cn0v cfv wceq wb
        nmblolbi.u cA cU cL cX cU cn0v cfv nmblolbi.1 cU cn0v cfv eqid
        nmblolbi.4 nvz mpan necon3bid biimpar sylanc cA cX wcel cA cU cn0v cfv
        wne wa cc0 c1 cA cL cfv cdiv co clt wbr cc0 c1 cA cL cfv cdiv co cle
        wbr cA cL cfv cr wcel cc0 cA cL cfv clt wbr cc0 c1 cA cL cfv cdiv co
        clt wbr cA cX wcel cA cU cn0v cfv wne wa cA cL cfv recgt0 cA cX wcel cA
        cL cfv cr wcel cA cU cn0v cfv wne cU cnv wcel cA cX wcel cA cL cfv cr
        wcel nmblolbi.u cA cU cL cX nmblolbi.1 nmblolbi.4 nvcl mpan adantr cA
        cX wcel cA cU cn0v cfv wne cc0 cA cL cfv clt wbr cU cnv wcel cA cX wcel
        cA cU cn0v cfv wne cc0 cA cL cfv clt wbr wb nmblolbi.u cA cU cL cX cU
        cn0v cfv nmblolbi.1 cU cn0v cfv eqid nmblolbi.4 nvgt0 mpan biimpa
        sylanc cA cX wcel cA cU cn0v cfv wne wa c1 cA cL cfv cdiv co cr wcel
        cc0 c1 cA cL cfv cdiv co clt wbr cc0 c1 cA cL cfv cdiv co cle wbr wi cA
        cL cfv cr wcel cA cL cfv cc0 wne c1 cA cL cfv cdiv co cr wcel cA cX
        wcel cA cU cn0v cfv wne wa cA cL cfv rereccl cA cX wcel cA cL cfv cr
        wcel cA cU cn0v cfv wne cU cnv wcel cA cX wcel cA cL cfv cr wcel
        nmblolbi.u cA cU cL cX nmblolbi.1 nmblolbi.4 nvcl mpan adantr cA cX
        wcel cA cL cfv cc0 wne cA cU cn0v cfv wne cA cX wcel cA cL cfv cc0 cA
        cU cn0v cfv cU cnv wcel cA cX wcel cA cL cfv cc0 wceq cA cU cn0v cfv
        wceq wb nmblolbi.u cA cU cL cX cU cn0v cfv nmblolbi.1 cU cn0v cfv eqid
        nmblolbi.4 nvz mpan necon3bid biimpar sylanc cc0 cr wcel c1 cA cL cfv
        cdiv co cr wcel cc0 c1 cA cL cfv cdiv co clt wbr cc0 c1 cA cL cfv cdiv
        co cle wbr wi 0re cc0 c1 cA cL cfv cdiv co ltle mpan syl mpd jca cA cX
        wcel cA cT cfv cW cba cfv wcel cA cU cn0v cfv wne cX cW cba cfv cA cT
        cU cnv wcel cW cnv wcel cT cB wcel cX cW cba cfv cT wf nmblolbi.u
        nmblolbi.w nmblolbii.b cB cT cU cW cX cW cba cfv nmblolbi.1 cW cba cfv
        eqid nmblolbi.7 blof mp3an ffvelrni adantr sylanc cA cX wcel cA cU cn0v
        cfv wne wa c1 cA cL cfv cdiv co cA cU cns cfv co cT cfv c1 cA cL cfv
        cdiv co cA cT cfv cW cns cfv co cM c1 cA cL cfv cdiv co cc wcel cA cX
        wcel c1 cA cL cfv cdiv co cA cU cns cfv co cT cfv c1 cA cL cfv cdiv co
        cA cT cfv cW cns cfv co wceq cA cX wcel cA cU cn0v cfv wne wa cU cnv
        wcel cW cnv wcel cT cU cW clno co wcel w3a c1 cA cL cfv cdiv co cc wcel
        cA cX wcel wa c1 cA cL cfv cdiv co cA cU cns cfv co cT cfv c1 cA cL cfv
        cdiv co cA cT cfv cW cns cfv co wceq cU cnv wcel cW cnv wcel cT cU cW
        clno co wcel nmblolbi.u nmblolbi.w cU cnv wcel cW cnv wcel cT cB wcel
        cT cU cW clno co wcel nmblolbi.u nmblolbi.w nmblolbii.b cB cT cU cU cW
        clno co cW cU cW clno co eqid nmblolbi.7 bloln mp3an 3pm3.2i c1 cA cL
        cfv cdiv co cA cU cns cfv cW cns cfv cT cU cU cW clno co cW cX
        nmblolbi.1 cU cns cfv eqid cW cns cfv eqid cU cW clno co eqid lnomul
        mpan cA cX wcel cA cU cn0v cfv wne wa c1 cA cL cfv cdiv co cA cL cfv cr
        wcel cA cL cfv cc0 wne c1 cA cL cfv cdiv co cr wcel cA cX wcel cA cU
        cn0v cfv wne wa cA cL cfv rereccl cA cX wcel cA cL cfv cr wcel cA cU
        cn0v cfv wne cU cnv wcel cA cX wcel cA cL cfv cr wcel nmblolbi.u cA cU
        cL cX nmblolbi.1 nmblolbi.4 nvcl mpan adantr cA cX wcel cA cL cfv cc0
        wne cA cU cn0v cfv wne cA cX wcel cA cL cfv cc0 cA cU cn0v cfv cU cnv
        wcel cA cX wcel cA cL cfv cc0 wceq cA cU cn0v cfv wceq wb nmblolbi.u cA
        cU cL cX cU cn0v cfv nmblolbi.1 cU cn0v cfv eqid nmblolbi.4 nvz mpan
        necon3bid biimpar sylanc recnd cA cX wcel cA cU cn0v cfv wne pm3.26
        sylanc fveq2d cA cT cfv cM cfv cc wcel cA cL cfv cc wcel cA cL cfv cc0
        wne cA cT cfv cM cfv cA cL cfv cdiv co c1 cA cL cfv cdiv co cA cT cfv
        cM cfv cmul co wceq cA cX wcel cA cU cn0v cfv wne wa cA cT cfv cM cfv
        cA cL cfv divrec2 cA cX wcel cA cU cn0v cfv wne wa cA cT cfv cM cfv cA
        cX wcel cA cT cfv cM cfv cr wcel cA cU cn0v cfv wne cA cX wcel cA cT
        cfv cW cba cfv wcel cA cT cfv cM cfv cr wcel cX cW cba cfv cA cT cU cnv
        wcel cW cnv wcel cT cB wcel cX cW cba cfv cT wf nmblolbi.u nmblolbi.w
        nmblolbii.b cB cT cU cW cX cW cba cfv nmblolbi.1 cW cba cfv eqid
        nmblolbi.7 blof mp3an ffvelrni cW cnv wcel cA cT cfv cW cba cfv wcel cA
        cT cfv cM cfv cr wcel nmblolbi.w cA cT cfv cW cM cW cba cfv cW cba cfv
        eqid nmblolbi.5 nvcl mpan syl adantr recnd cA cX wcel cA cU cn0v cfv
        wne wa cA cL cfv cA cX wcel cA cL cfv cr wcel cA cU cn0v cfv wne cU cnv
        wcel cA cX wcel cA cL cfv cr wcel nmblolbi.u cA cU cL cX nmblolbi.1
        nmblolbi.4 nvcl mpan adantr recnd cA cX wcel cA cL cfv cc0 wne cA cU
        cn0v cfv wne cA cX wcel cA cL cfv cc0 cA cU cn0v cfv cU cnv wcel cA cX
        wcel cA cL cfv cc0 wceq cA cU cn0v cfv wceq wb nmblolbi.u cA cU cL cX
        cU cn0v cfv nmblolbi.1 cU cn0v cfv eqid nmblolbi.4 nvz mpan necon3bid
        biimpar syl3anc 3eqtr4rd c1 cA cL cfv cdiv co cA cU cns cfv co cX wcel
        c1 cA cL cfv cdiv co cA cU cns cfv co cL cfv c1 cle wbr c1 cA cL cfv
        cdiv co cA cU cns cfv co cT cfv cM cfv cT cN cfv cle wbr cA cX wcel cA
        cU cn0v cfv wne wa cU cnv wcel cW cnv wcel cX cW cba cfv cT wf w3a c1
        cA cL cfv cdiv co cA cU cns cfv co cX wcel c1 cA cL cfv cdiv co cA cU
        cns cfv co cL cfv c1 cle wbr wa c1 cA cL cfv cdiv co cA cU cns cfv co
        cT cfv cM cfv cT cN cfv cle wbr cU cnv wcel cW cnv wcel cX cW cba cfv
        cT wf nmblolbi.u nmblolbi.w cU cnv wcel cW cnv wcel cT cB wcel cX cW
        cba cfv cT wf nmblolbi.u nmblolbi.w nmblolbii.b cB cT cU cW cX cW cba
        cfv nmblolbi.1 cW cba cfv eqid nmblolbi.7 blof mp3an 3pm3.2i c1 cA cL
        cfv cdiv co cA cU cns cfv co cT cU cL cM cN cW cX cW cba cfv nmblolbi.1
        cW cba cfv eqid nmblolbi.4 nmblolbi.5 nmblolbi.6 nmolb mpan c1 cA cL
        cfv cdiv co cc wcel cA cX wcel c1 cA cL cfv cdiv co cA cU cns cfv co cX
        wcel cA cX wcel cA cU cn0v cfv wne wa cU cnv wcel c1 cA cL cfv cdiv co
        cc wcel cA cX wcel c1 cA cL cfv cdiv co cA cU cns cfv co cX wcel
        nmblolbi.u c1 cA cL cfv cdiv co cA cU cns cfv cU cX nmblolbi.1 cU cns
        cfv eqid nvscl mp3an1 cA cX wcel cA cU cn0v cfv wne wa c1 cA cL cfv
        cdiv co cA cL cfv cr wcel cA cL cfv cc0 wne c1 cA cL cfv cdiv co cr
        wcel cA cX wcel cA cU cn0v cfv wne wa cA cL cfv rereccl cA cX wcel cA
        cL cfv cr wcel cA cU cn0v cfv wne cU cnv wcel cA cX wcel cA cL cfv cr
        wcel nmblolbi.u cA cU cL cX nmblolbi.1 nmblolbi.4 nvcl mpan adantr cA
        cX wcel cA cL cfv cc0 wne cA cU cn0v cfv wne cA cX wcel cA cL cfv cc0
        cA cU cn0v cfv cU cnv wcel cA cX wcel cA cL cfv cc0 wceq cA cU cn0v cfv
        wceq wb nmblolbi.u cA cU cL cX cU cn0v cfv nmblolbi.1 cU cn0v cfv eqid
        nmblolbi.4 nvz mpan necon3bid biimpar sylanc recnd cA cX wcel cA cU
        cn0v cfv wne pm3.26 sylanc c1 cA cL cfv cdiv co cA cU cns cfv co cL cfv
        cr wcel c1 cA cL cfv cdiv co cA cU cns cfv co cL cfv c1 wceq c1 cA cL
        cfv cdiv co cA cU cns cfv co cL cfv c1 cle wbr cA cX wcel cA cU cn0v
        cfv wne wa c1 cA cL cfv cdiv co cA cU cns cfv co cL cfv c1 eqle cA cX
        wcel cA cU cn0v cfv wne wa c1 cA cL cfv cdiv co cA cU cns cfv co cX
        wcel c1 cA cL cfv cdiv co cA cU cns cfv co cL cfv cr wcel cA cX wcel cA
        cU cn0v cfv wne c1 cA cL cfv cdiv co cc wcel c1 cA cL cfv cdiv co cA cU
        cns cfv co cX wcel cA cX wcel cA cU cn0v cfv wne wa c1 cA cL cfv cdiv
        co cA cL cfv cr wcel cA cL cfv cc0 wne c1 cA cL cfv cdiv co cr wcel cA
        cX wcel cA cU cn0v cfv wne wa cA cL cfv rereccl cA cX wcel cA cL cfv cr
        wcel cA cU cn0v cfv wne cU cnv wcel cA cX wcel cA cL cfv cr wcel
        nmblolbi.u cA cU cL cX nmblolbi.1 nmblolbi.4 nvcl mpan adantr cA cX
        wcel cA cL cfv cc0 wne cA cU cn0v cfv wne cA cX wcel cA cL cfv cc0 cA
        cU cn0v cfv cU cnv wcel cA cX wcel cA cL cfv cc0 wceq cA cU cn0v cfv
        wceq wb nmblolbi.u cA cU cL cX cU cn0v cfv nmblolbi.1 cU cn0v cfv eqid
        nmblolbi.4 nvz mpan necon3bid biimpar sylanc recnd c1 cA cL cfv cdiv co
        cc wcel cA cX wcel c1 cA cL cfv cdiv co cA cU cns cfv co cX wcel cU cnv
        wcel c1 cA cL cfv cdiv co cc wcel cA cX wcel c1 cA cL cfv cdiv co cA cU
        cns cfv co cX wcel nmblolbi.u c1 cA cL cfv cdiv co cA cU cns cfv cU cX
        nmblolbi.1 cU cns cfv eqid nvscl mp3an1 ancoms syldan cU cnv wcel c1 cA
        cL cfv cdiv co cA cU cns cfv co cX wcel c1 cA cL cfv cdiv co cA cU cns
        cfv co cL cfv cr wcel nmblolbi.u c1 cA cL cfv cdiv co cA cU cns cfv co
        cU cL cX nmblolbi.1 nmblolbi.4 nvcl mpan syl cU cnv wcel cA cX wcel cA
        cU cn0v cfv wne c1 cA cL cfv cdiv co cA cU cns cfv co cL cfv c1 wceq
        nmblolbi.u cA cU cns cfv cU cL cX cU cn0v cfv nmblolbi.1 cU cns cfv
        eqid cU cn0v cfv eqid nmblolbi.4 nv1 mp3an1 sylanc sylanc eqbrtrd cA cT
        cfv cM cfv cr wcel cA cL cfv cr wcel cT cN cfv cr wcel w3a cc0 cA cL
        cfv clt wbr cA cT cfv cM cfv cA cL cfv cdiv co cT cN cfv cle wbr cA cT
        cfv cM cfv cT cN cfv cA cL cfv cmul co cle wbr wb cA cX wcel cA cU cn0v
        cfv wne wa cA cT cfv cM cfv cA cL cfv cT cN cfv ledivmul2OLD cA cX wcel
        cA cT cfv cM cfv cr wcel cA cL cfv cr wcel cT cN cfv cr wcel w3a cA cU
        cn0v cfv wne cA cX wcel cA cT cfv cM cfv cr wcel cA cL cfv cr wcel cT
        cN cfv cr wcel cA cX wcel cA cT cfv cW cba cfv wcel cA cT cfv cM cfv cr
        wcel cX cW cba cfv cA cT cU cnv wcel cW cnv wcel cT cB wcel cX cW cba
        cfv cT wf nmblolbi.u nmblolbi.w nmblolbii.b cB cT cU cW cX cW cba cfv
        nmblolbi.1 cW cba cfv eqid nmblolbi.7 blof mp3an ffvelrni cW cnv wcel
        cA cT cfv cW cba cfv wcel cA cT cfv cM cfv cr wcel nmblolbi.w cA cT cfv
        cW cM cW cba cfv cW cba cfv eqid nmblolbi.5 nvcl mpan syl cU cnv wcel
        cA cX wcel cA cL cfv cr wcel nmblolbi.u cA cU cL cX nmblolbi.1
        nmblolbi.4 nvcl mpan cT cN cfv cr wcel cA cX wcel cU cnv wcel cW cnv
        wcel cT cB wcel cT cN cfv cr wcel nmblolbi.u nmblolbi.w nmblolbii.b cB
        cT cU cN cW cX cW cba cfv nmblolbi.1 cW cba cfv eqid nmblolbi.6
        nmblolbi.7 nmblore mp3an a1i 3jca adantr cA cX wcel cA cU cn0v cfv wne
        cc0 cA cL cfv clt wbr cU cnv wcel cA cX wcel cA cU cn0v cfv wne cc0 cA
        cL cfv clt wbr wb nmblolbi.u cA cU cL cX cU cn0v cfv nmblolbi.1 cU cn0v
        cfv eqid nmblolbi.4 nvgt0 mpan biimpa sylanc mpbid cU cn0v cfv cT cfv
        cM cfv cT cN cfv cU cn0v cfv cL cfv cmul co cle wbr cA cX wcel cc0 cc0
        cU cn0v cfv cT cfv cM cfv cT cN cfv cU cn0v cfv cL cfv cmul co cle cc0
        0re leidi cU cn0v cfv cT cfv cM cfv cW cn0v cfv cM cfv cc0 cU cn0v cfv
        cT cfv cW cn0v cfv cM cU cnv wcel cW cnv wcel cT cU cW clno co wcel cU
        cn0v cfv cT cfv cW cn0v cfv wceq nmblolbi.u nmblolbi.w cU cnv wcel cW
        cnv wcel cT cB wcel cT cU cW clno co wcel nmblolbi.u nmblolbi.w
        nmblolbii.b cB cT cU cU cW clno co cW cU cW clno co eqid nmblolbi.7
        bloln mp3an cU cn0v cfv cT cU cU cW clno co cW cX cW cba cfv cW cn0v
        cfv nmblolbi.1 cW cba cfv eqid cU cn0v cfv eqid cW cn0v cfv eqid cU cW
        clno co eqid lno0 mp3an fveq2i cW cnv wcel cW cn0v cfv cM cfv cc0 wceq
        nmblolbi.w cW cM cW cn0v cfv cW cn0v cfv eqid nmblolbi.5 nvz0 ax-mp
        eqtri cT cN cfv cU cn0v cfv cL cfv cmul co cT cN cfv cc0 cmul co cc0 cU
        cn0v cfv cL cfv cc0 cT cN cfv cmul cU cnv wcel cU cn0v cfv cL cfv cc0
        wceq nmblolbi.u cU cL cU cn0v cfv cU cn0v cfv eqid nmblolbi.4 nvz0
        ax-mp opreq2i cT cN cfv cT cN cfv cU cnv wcel cW cnv wcel cT cB wcel cT
        cN cfv cr wcel nmblolbi.u nmblolbi.w nmblolbii.b cB cT cU cN cW cX cW
        cba cfv nmblolbi.1 cW cba cfv eqid nmblolbi.6 nmblolbi.7 nmblore mp3an
        recni mul01i eqtri 3brtr4i a1i pm2.61ne $.
        $( [2-Jan-2008] $) $( [7-Dec-2007] $)
    $}

    $( A lower bound for the norm of a bounded linear operator. $)
    nmblolbi $p |- ( ( T e. B /\ A e. X ) ->
              ( M ` ( T ` A ) ) <_ ( ( N ` T ) x. ( L ` A ) ) ) $=
      cT cB wcel cA cX wcel cA cT cfv cM cfv cT cN cfv cA cL cfv cmul co cle
      wbr cT cB wcel cA cX wcel cA cT cfv cM cfv cT cN cfv cA cL cfv cmul co
      cle wbr wi cA cX wcel cA cT cB wcel cT cU cW c0o co cif cfv cM cfv cT cB
      wcel cT cU cW c0o co cif cN cfv cA cL cfv cmul co cle wbr wi cT cU cW c0o
      co cT cT cB wcel cT cU cW c0o co cif wceq cA cT cfv cM cfv cT cN cfv cA
      cL cfv cmul co cle wbr cA cT cB wcel cT cU cW c0o co cif cfv cM cfv cT cB
      wcel cT cU cW c0o co cif cN cfv cA cL cfv cmul co cle wbr cA cX wcel cT
      cT cB wcel cT cU cW c0o co cif wceq cA cT cfv cM cfv cA cT cB wcel cT cU
      cW c0o co cif cfv cM cfv cT cN cfv cA cL cfv cmul co cT cB wcel cT cU cW
      c0o co cif cN cfv cA cL cfv cmul co cle cT cT cB wcel cT cU cW c0o co cif
      wceq cA cT cfv cA cT cB wcel cT cU cW c0o co cif cfv cM cA cT cT cB wcel
      cT cU cW c0o co cif fveq1 fveq2d cT cT cB wcel cT cU cW c0o co cif wceq
      cT cN cfv cT cB wcel cT cU cW c0o co cif cN cfv cA cL cfv cmul cT cT cB
      wcel cT cU cW c0o co cif cN fveq2 opreq1d breq12d imbi2d cA cB cT cB wcel
      cT cU cW c0o co cif cU cL cM cN cW cX nmblolbi.1 nmblolbi.4 nmblolbi.5
      nmblolbi.6 nmblolbi.7 nmblolbi.u nmblolbi.w cT cU cW c0o co cB cU cnv
      wcel cW cnv wcel cU cW c0o co cB wcel nmblolbi.u nmblolbi.w cB cU cW cU
      cW c0o co cU cW c0o co eqid nmblolbi.7 0blo mp2an elimel nmblolbii dedth
      imp $.
      $( [3-Jan-2008] $) $( [10-Dec-2007] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x L $.  $d x y M $.  $d x y N $.  $d x y T $.
    $d x y U $.  $d x y W $.  $d x y X $.
    isblo3i.1 $e |- X = ( BaseSet ` U ) $.
    isblo3i.m $e |- M = ( norm ` U ) $.
    isblo3i.n $e |- N = ( norm ` W ) $.
    isblo3i.4 $e |- L = ( U LnOp W ) $.
    isblo3i.5 $e |- B = ( U BLnOp W ) $.
    isblo3i.u $e |- U e. NrmCVec $.
    isblo3i.w $e |- W e. NrmCVec $.
    $( The predicate "is a bounded linear operator."  Definition 2.7-1 of
       [Kreyszig] p. 91. $)
    isblo3i $p |- ( T e. B <-> ( T e. L /\
          E. x e. RR A. y e. X ( N ` ( T ` y ) ) <_ ( x x. ( M ` y ) ) ) ) $=
      cT cB wcel cT cL wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle
      wbr vy cX wral vx cr wrex wa cT cB wcel cT cL wcel vy cv cT cfv cN cfv vx
      cv vy cv cM cfv cmul co cle wbr vy cX wral vx cr wrex cU cnv wcel cW cnv
      wcel cT cB wcel cT cL wcel isblo3i.u isblo3i.w cB cT cU cL cW isblo3i.4
      isblo3i.5 bloln mp3an12 cT cU cW cnmo co cfv cr wcel vy cv cT cfv cN cfv
      cT cU cW cnmo co cfv vy cv cM cfv cmul co cle wbr vy cX wral vy cv cT cfv
      cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral vx cr wrex cT cB
      wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral vy
      cv cT cfv cN cfv cT cU cW cnmo co cfv vy cv cM cfv cmul co cle wbr vy cX
      wral vx cT cU cW cnmo co cfv cr vx cv cT cU cW cnmo co cfv wceq vy cv cT
      cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cv cT cfv cN cfv cT cU
      cW cnmo co cfv vy cv cM cfv cmul co cle wbr vy cX vx cv cT cU cW cnmo co
      cfv wceq vx cv vy cv cM cfv cmul co cT cU cW cnmo co cfv vy cv cM cfv
      cmul co vy cv cT cfv cN cfv cle vx cv cT cU cW cnmo co cfv vy cv cM cfv
      cmul opreq1 breq2d ralbidv rcla4ev cU cnv wcel cW cnv wcel cT cB wcel cT
      cU cW cnmo co cfv cr wcel isblo3i.u isblo3i.w cB cT cU cU cW cnmo co cW
      cX cW cba cfv isblo3i.1 cW cba cfv eqid cU cW cnmo co eqid isblo3i.5
      nmblore mp3an12 cT cB wcel vy cv cT cfv cN cfv cT cU cW cnmo co cfv vy cv
      cM cfv cmul co cle wbr vy cX vy cv cB cT cU cM cN cU cW cnmo co cW cX
      isblo3i.1 isblo3i.m isblo3i.n cU cW cnmo co eqid isblo3i.5 isblo3i.u
      isblo3i.w nmblolbi r19.21aiva sylanc jca cT cL wcel vy cv cT cfv cN cfv
      vx cv vy cv cM cfv cmul co cle wbr vy cX wral vx cr wrex cT cB wcel cT cL
      wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral cT
      cB wcel vx cr cT cL wcel vx cv cr wcel vy cv cT cfv cN cfv vx cv vy cv cM
      cfv cmul co cle wbr vy cX wral cT cB wcel cT cL wcel vx cv cr wcel vy cv
      cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral w3a cT cL
      wcel cT cU cW cnmo co cfv cpnf clt wbr wa cT cB wcel cT cL wcel vx cv cr
      wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral
      w3a cT cL wcel cT cU cW cnmo co cfv cpnf clt wbr cT cL wcel vx cv cr wcel
      vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral 3simp1
      cX cW cba cfv cT wf vx cv cr wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv
      cmul co cle wbr vy cX wral cT cU cW cnmo co cfv cpnf clt wbr cT cL wcel
      cX cW cba cfv cT wf vx cv cr wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv
      cmul co cle wbr vy cX wral w3a cT cU cW cnmo co cfv vx cv cabs cfv cle
      wbr vx cv cabs cfv cpnf clt wbr cT cU cW cnmo co cfv cpnf clt wbr vy vx
      cv cT cU cM cN cU cW cnmo co cW cX cW cba cfv isblo3i.1 cW cba cfv eqid
      isblo3i.m isblo3i.n cU cW cnmo co eqid isblo3i.u isblo3i.w nmoub3i vx cv
      cr wcel cX cW cba cfv cT wf vx cv cabs cfv cpnf clt wbr vy cv cT cfv cN
      cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral vx cv cr wcel vx cv
      cabs cfv cr wcel vx cv cabs cfv cpnf clt wbr vx cv cr wcel vx cv cc wcel
      vx cv cabs cfv cr wcel vx cv recn vx cv abscl syl vx cv cabs cfv ltpnf
      syl 3ad2ant2 cT cU cW cnmo co cfv cxr wcel vx cv cabs cfv cxr wcel cpnf
      cxr wcel cT cU cW cnmo co cfv vx cv cabs cfv cle wbr vx cv cabs cfv cpnf
      clt wbr wa cT cU cW cnmo co cfv cpnf clt wbr wi cX cW cba cfv cT wf vx cv
      cr wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral
      w3a cT cU cW cnmo co cfv vx cv cabs cfv cpnf xrlelttr cX cW cba cfv cT wf
      vx cv cr wcel cT cU cW cnmo co cfv cxr wcel vy cv cT cfv cN cfv vx cv vy
      cv cM cfv cmul co cle wbr vy cX wral cU cnv wcel cW cnv wcel cX cW cba
      cfv cT wf cT cU cW cnmo co cfv cxr wcel isblo3i.u isblo3i.w cT cU cU cW
      cnmo co cW cX cW cba cfv isblo3i.1 cW cba cfv eqid cU cW cnmo co eqid
      nmoxr mp3an12 3ad2ant1 vx cv cr wcel cX cW cba cfv cT wf vx cv cabs cfv
      cxr wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX
      wral vx cv cr wcel vx cv cabs cfv cr wcel vx cv cabs cfv cxr wcel vx cv
      cr wcel vx cv cc wcel vx cv cabs cfv cr wcel vx cv recn vx cv abscl syl
      vx cv cabs cfv rexr syl 3ad2ant2 cpnf cxr wcel cX cW cba cfv cT wf vx cv
      cr wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral
      w3a pnfxr a1i syl3anc mp2and cU cnv wcel cW cnv wcel cT cL wcel cX cW cba
      cfv cT wf isblo3i.u isblo3i.w cT cU cL cW cX cW cba cfv isblo3i.1 cW cba
      cfv eqid isblo3i.4 lnof mp3an12 syl3an1 jca cU cnv wcel cW cnv wcel cT cB
      wcel cT cL wcel cT cU cW cnmo co cfv cpnf clt wbr wa wb isblo3i.u
      isblo3i.w cB cT cU cL cU cW cnmo co cW cU cW cnmo co eqid isblo3i.4
      isblo3i.5 isblo mp2an sylibr 3exp r19.23adv imp impbii $.
      $( [4-Jan-2008] $) $( [11-Dec-2007] $)

    $( Properties that determine a bounded linear operator. $)
    blo3i $p |- ( ( T e. L /\ A e. RR /\ A. y e. X ( N ` ( T ` y ) ) <_
               ( A x. ( M ` y ) ) ) -> T e. B ) $=
      cT cL wcel cA cr wcel vy cv cT cfv cN cfv cA vy cv cM cfv cmul co cle wbr
      vy cX wral cT cB wcel cT cL wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv
      cmul co cle wbr vy cX wral vx cr wrex cT cB wcel cA cr wcel vy cv cT cfv
      cN cfv cA vy cv cM cfv cmul co cle wbr vy cX wral wa cT cB wcel cT cL
      wcel vy cv cT cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral vx
      cr wrex wa vx vy cB cT cU cL cM cN cW cX isblo3i.1 isblo3i.m isblo3i.n
      isblo3i.4 isblo3i.5 isblo3i.u isblo3i.w isblo3i biimpri vy cv cT cfv cN
      cfv vx cv vy cv cM cfv cmul co cle wbr vy cX wral vy cv cT cfv cN cfv cA
      vy cv cM cfv cmul co cle wbr vy cX wral vx cA cr vx cv cA wceq vy cv cT
      cfv cN cfv vx cv vy cv cM cfv cmul co cle wbr vy cv cT cfv cN cfv cA vy
      cv cM cfv cmul co cle wbr vy cX vx cv cA wceq vx cv vy cv cM cfv cmul co
      cA vy cv cM cfv cmul co vy cv cT cfv cN cfv cle vx cv cA vy cv cM cfv
      cmul opreq1 breq2d ralbidv rcla4ev sylan2 3impb $.
      $( [21-Jan-2008] $) $( [13-Jan-2008] $)
  $}

  ${
    blometi.1 $e |- X = ( BaseSet ` U ) $.
    blometi.2 $e |- Y = ( BaseSet ` W ) $.
    blometi.8 $e |- C = ( IndMet ` U ) $.
    blometi.d $e |- D = ( IndMet ` W ) $.
    blometi.6 $e |- N = ( U normOp W ) $.
    blometi.7 $e |- B = ( U BLnOp W ) $.
    blometi.u $e |- U e. NrmCVec $.
    blometi.w $e |- W e. NrmCVec $.
    $( Upper bound for the distance between the values of a bounded linear
       operator. $)
    blometi $p |- ( ( T e. B /\ P e. X /\ Q e. X ) ->
         ( ( T ` P ) D ( T ` Q ) ) <_ ( ( N ` T ) x. ( P C Q ) ) ) $=
      cT cB wcel cP cX wcel cQ cX wcel w3a cP cQ cU cnsb cfv co cT cfv cW cnm
      cfv cfv cT cN cfv cP cQ cU cnsb cfv co cU cnm cfv cfv cmul co cP cT cfv
      cQ cT cfv cD co cT cN cfv cP cQ cC co cmul co cle cT cB wcel cP cX wcel
      cQ cX wcel cP cQ cU cnsb cfv co cT cfv cW cnm cfv cfv cT cN cfv cP cQ cU
      cnsb cfv co cU cnm cfv cfv cmul co cle wbr cT cB wcel cP cQ cU cnsb cfv
      co cX wcel cP cQ cU cnsb cfv co cT cfv cW cnm cfv cfv cT cN cfv cP cQ cU
      cnsb cfv co cU cnm cfv cfv cmul co cle wbr cP cX wcel cQ cX wcel wa cP cQ
      cU cnsb cfv co cB cT cU cU cnm cfv cW cnm cfv cN cW cX blometi.1 cU cnm
      cfv eqid cW cnm cfv eqid blometi.6 blometi.7 blometi.u blometi.w nmblolbi
      cU cnv wcel cP cX wcel cQ cX wcel cP cQ cU cnsb cfv co cX wcel blometi.u
      cP cQ cU cU cnsb cfv cX blometi.1 cU cnsb cfv eqid nvmcl mp3an1 sylan2
      3impb cT cB wcel cP cX wcel cQ cX wcel w3a cP cT cfv cQ cT cfv cD co cP
      cT cfv cQ cT cfv cW cnsb cfv co cW cnm cfv cfv cP cQ cU cnsb cfv co cT
      cfv cW cnm cfv cfv cP cT cfv cY wcel cQ cT cfv cY wcel cP cT cfv cQ cT
      cfv cD co cP cT cfv cQ cT cfv cW cnsb cfv co cW cnm cfv cfv wceq cT cB
      wcel cP cX wcel cQ cX wcel w3a cW cnv wcel cP cT cfv cY wcel cQ cT cfv cY
      wcel cP cT cfv cQ cT cfv cD co cP cT cfv cQ cT cfv cW cnsb cfv co cW cnm
      cfv cfv wceq blometi.w cP cT cfv cQ cT cfv cD cW cW cnsb cfv cW cnm cfv
      cY blometi.2 cW cnsb cfv eqid cW cnm cfv eqid blometi.d imsdval mp3an1 cT
      cB wcel cP cX wcel cP cT cfv cY wcel cQ cX wcel cX cY cT wf cP cX wcel cP
      cT cfv cY wcel cT cB wcel cX cY cP cT ffvelrn cU cnv wcel cW cnv wcel cT
      cB wcel cX cY cT wf blometi.u blometi.w cB cT cU cW cX cY blometi.1
      blometi.2 blometi.7 blof mp3an12 sylan 3adant3 cT cB wcel cQ cX wcel cQ
      cT cfv cY wcel cP cX wcel cX cY cT wf cQ cX wcel cQ cT cfv cY wcel cT cB
      wcel cX cY cQ cT ffvelrn cU cnv wcel cW cnv wcel cT cB wcel cX cY cT wf
      blometi.u blometi.w cB cT cU cW cX cY blometi.1 blometi.2 blometi.7 blof
      mp3an12 sylan 3adant2 sylanc cT cB wcel cP cX wcel cQ cX wcel w3a cP cQ
      cU cnsb cfv co cT cfv cP cT cfv cQ cT cfv cW cnsb cfv co cW cnm cfv cT cU
      cW clno co wcel cP cX wcel cQ cX wcel cP cQ cU cnsb cfv co cT cfv cP cT
      cfv cQ cT cfv cW cnsb cfv co wceq cT cB wcel cT cU cW clno co wcel cP cX
      wcel cQ cX wcel cP cQ cU cnsb cfv co cT cfv cP cT cfv cQ cT cfv cW cnsb
      cfv co wceq cW cnv wcel cT cU cW clno co wcel cP cX wcel cQ cX wcel wa cP
      cQ cU cnsb cfv co cT cfv cP cT cfv cQ cT cfv cW cnsb cfv co wceq
      blometi.w cU cnv wcel cW cnv wcel cT cU cW clno co wcel cP cX wcel cQ cX
      wcel wa cP cQ cU cnsb cfv co cT cfv cP cT cfv cQ cT cfv cW cnsb cfv co
      wceq blometi.u cP cQ cT cU cU cW clno co cU cnsb cfv cW cnsb cfv cW cX
      blometi.1 cU cnsb cfv eqid cW cnsb cfv eqid cU cW clno co eqid lnosub
      mp3anl1 mpanl1 3impb cU cnv wcel cW cnv wcel cT cB wcel cT cU cW clno co
      wcel blometi.u blometi.w cB cT cU cU cW clno co cW cU cW clno co eqid
      blometi.7 bloln mp3an12 syl3an1 fveq2d eqtr4d cT cB wcel cP cX wcel cQ cX
      wcel w3a cP cQ cC co cP cQ cU cnsb cfv co cU cnm cfv cfv cT cN cfv cmul
      cP cX wcel cQ cX wcel cP cQ cC co cP cQ cU cnsb cfv co cU cnm cfv cfv
      wceq cT cB wcel cU cnv wcel cP cX wcel cQ cX wcel cP cQ cC co cP cQ cU
      cnsb cfv co cU cnm cfv cfv wceq blometi.u cP cQ cC cU cU cnsb cfv cU cnm
      cfv cX blometi.1 cU cnsb cfv eqid cU cnm cfv eqid blometi.8 imsdval
      mp3an1 3adant1 opreq2d 3brtr4d $.
      $( [5-Jan-2008] $) $( [11-Dec-2007] $)
  $}

  ${
    $d v w x y B $.  $d w x y z C $.  $d w x y z D $.  $d w x y z J $.
    $d x y z K $.  $d v x L $.  $d w y z P $.  $d v w x y z T $.
    $d v w x y z U $.  $d v w x y z W $.  $d w x y z X $.
    blocni.8 $e |- C = ( IndMet ` U ) $.
    blocni.d $e |- D = ( IndMet ` W ) $.
    blocni.j $e |- J = ( Open ` C ) $.
    blocni.k $e |- K = ( Open ` D ) $.
    blocni.4 $e |- L = ( U LnOp W ) $.
    blocni.5 $e |- B = ( U BLnOp W ) $.
    blocni.u $e |- U e. NrmCVec $.
    blocni.w $e |- W e. NrmCVec $.
    blocni.l $e |- T e. L $.
    ${
      blocnilem.1 $e |- X = ( BaseSet ` U ) $.
      $( MAY BE REVISED - this needs to be broken up or shortened! $)
      $( Lemma for ~ blocni and ~ lnocni .  If a linear operator is continuous
         at any point, it is bounded.  _Warning:  The HTML proof page is 0.7MB
         in size_. $)
      blocnilem $p |- ( ( P e. X /\ T e. ( ( J CnP K ) ` P ) ) -> T e. B ) $=
        cP cX wcel cT cP cJ cK ccnp co cfv wcel wa cT cL wcel vw cv cT cfv cW
        cnm cfv cfv vx cv vw cv cU cnm cfv cfv cmul co cle wbr vw cX wral vx cr
        wrex wa cT cB wcel cP cX wcel cT cP cJ cK ccnp co cfv wcel wa vw cv cT
        cfv cW cnm cfv cfv vx cv vw cv cU cnm cfv cfv cmul co cle wbr vw cX
        wral vx cr wrex cT cL wcel cP cX wcel cT cP cJ cK ccnp co cfv wcel wa
        cc0 vz cv clt wbr cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr
        cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral
        wa vz cr wrex vw cv cT cfv cW cnm cfv cfv vx cv vw cv cU cnm cfv cfv
        cmul co cle wbr vw cX wral vx cr wrex cW cnv wcel cP cX wcel cT cP cJ
        cK ccnp co cfv wcel cc0 vz cv clt wbr cP vy cv cU cnsb cfv co cU cnm
        cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1
        cle wbr wi vy cX wral wa vz cr wrex blocni.w cU cnv wcel cW cnv wcel cP
        cX wcel cT cP cJ cK ccnp co cfv wcel cc0 vz cv clt wbr cP vy cv cU cnsb
        cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW
        cnm cfv cfv c1 cle wbr wi vy cX wral wa vz cr wrex blocni.u cU cnv wcel
        cW cnv wcel cP cX wcel w3a cT cP cJ cK ccnp co cfv wcel c1 cr wcel cc0
        vz cv clt wbr cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP
        vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral wa
        vz cr wrex 1re cU cnv wcel cW cnv wcel cP cX wcel w3a cT cP cJ cK ccnp
        co cfv wcel c1 cr wcel cc0 c1 clt wbr cc0 vz cv clt wbr cP vy cv cU
        cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv
        cW cnm cfv cfv c1 cle wbr wi vy cX wral wa vz cr wrex lt01 vz vy c1 cC
        cD cP cU cnsb cfv cT cU cJ cK cL cU cnm cfv cW cnm cfv cW cX
        blocnilem.1 cU cnm cfv eqid cW cnm cfv eqid cU cnsb cfv eqid blocni.8
        blocni.d blocni.j blocni.k blocni.4 blocni.l nvcnpi4 mp3anr3 mpanr2
        mp3anl1 mpanl1 cP cX wcel cc0 vz cv clt wbr cP vy cv cU cnsb cfv co cU
        cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv
        c1 cle wbr wi vy cX wral wa vz cr wrex vw cv cT cfv cW cnm cfv cfv vx
        cv vw cv cU cnm cfv cfv cmul co cle wbr vw cX wral vx cr wrex wi cT cP
        cJ cK ccnp co cfv wcel cP cX wcel cc0 vz cv clt wbr cP vy cv cU cnsb
        cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW
        cnm cfv cfv c1 cle wbr wi vy cX wral wa vw cv cT cfv cW cnm cfv cfv vx
        cv vw cv cU cnm cfv cfv cmul co cle wbr vw cX wral vx cr wrex vz cr cP
        cX wcel vz cv cr wcel cc0 vz cv clt wbr cP vy cv cU cnsb cfv co cU cnm
        cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1
        cle wbr wi vy cX wral vw cv cT cfv cW cnm cfv cfv vx cv vw cv cU cnm
        cfv cfv cmul co cle wbr vw cX wral vx cr wrex cP cX wcel vz cv cr wcel
        cc0 vz cv clt wbr cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr
        cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral
        vw cv cT cfv cW cnm cfv cfv vx cv vw cv cU cnm cfv cfv cmul co cle wbr
        vw cX wral vx cr wrex c1 vz cv cdiv co cr wcel vw cv cT cfv cW cnm cfv
        cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co cle wbr vw cX wral vw
        cv cT cfv cW cnm cfv cfv vx cv vw cv cU cnm cfv cfv cmul co cle wbr vw
        cX wral vx cr wrex cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa cP
        vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv
        co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral wa vw cv cT cfv cW
        cnm cfv cfv vx cv vw cv cU cnm cfv cfv cmul co cle wbr vw cX wral vw cv
        cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co cle
        wbr vw cX wral vx c1 vz cv cdiv co cr vx cv c1 vz cv cdiv co wceq vw cv
        cT cfv cW cnm cfv cfv vx cv vw cv cU cnm cfv cfv cmul co cle wbr vw cv
        cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co cle
        wbr vw cX vx cv c1 vz cv cdiv co wceq vx cv vw cv cU cnm cfv cfv cmul
        co c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co vw cv cT cfv cW cnm
        cfv cfv cle vx cv c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul opreq1
        breq2d ralbidv rcla4ev vz cv cr wcel cc0 vz cv clt wbr wa c1 vz cv cdiv
        co cr wcel cP cX wcel cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle
        wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX
        wral vz cv cr wcel cc0 vz cv clt wbr vz cv cc0 wne c1 vz cv cdiv co cr
        wcel vz cv gt0ne0 vz cv rereccl syldan ad2antlr cP cX wcel vz cv cr
        wcel cc0 vz cv clt wbr wa wa cP vy cv cU cnsb cfv co cU cnm cfv cfv vz
        cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi
        vy cX wral wa vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm
        cfv cfv cmul co cle wbr vw cX cP cX wcel vz cv cr wcel cc0 vz cv clt
        wbr wa wa cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv
        cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral wa vw cv
        cX wcel wa vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm
        cfv cfv cmul co cle wbr cU cn0v cfv cT cfv cW cnm cfv cfv c1 vz cv cdiv
        co cU cn0v cfv cU cnm cfv cfv cmul co cle wbr vw cv cU cn0v cfv vw cv
        cU cn0v cfv wceq vw cv cT cfv cW cnm cfv cfv cU cn0v cfv cT cfv cW cnm
        cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co c1 vz cv cdiv co
        cU cn0v cfv cU cnm cfv cfv cmul co cle vw cv cU cn0v cfv wceq vw cv cT
        cfv cU cn0v cfv cT cfv cW cnm cfv vw cv cU cn0v cfv cT fveq2 fveq2d vw
        cv cU cn0v cfv wceq vw cv cU cnm cfv cfv cU cn0v cfv cU cnm cfv cfv c1
        vz cv cdiv co cmul vw cv cU cn0v cfv cU cnm cfv fveq2 opreq2d breq12d
        cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa cP vy cv cU cnsb cfv
        co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm
        cfv cfv c1 cle wbr wi vy cX wral vw cv cX wcel vw cv cU cn0v cfv wne vw
        cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co
        cle wbr cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cU cn0v
        cfv wne vw cv cX wcel cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle
        wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX
        wral vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv
        cmul co cle wbr cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv
        cX wcel vw cv cU cn0v cfv wne cP vy cv cU cnsb cfv co cU cnm cfv cfv vz
        cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi
        vy cX wral vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm
        cfv cfv cmul co cle wbr wi cP cX wcel vz cv cr wcel cc0 vz cv clt wbr
        wa wa vw cv cX wcel vw cv cU cn0v cfv wne cP vy cv cU cnsb cfv co cU
        cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv
        c1 cle wbr wi vy cX wral vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co
        vw cv cU cnm cfv cfv cmul co cle wbr wi cP cX wcel vz cv cr wcel cc0 vz
        cv clt wbr wa wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cP vy cv cU
        cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv
        cW cnm cfv cfv c1 cle wbr wi vy cX wral cP cP vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW
        cnm cfv cfv c1 cle wbr vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw
        cv cU cnm cfv cfv cmul co cle wbr cP cX wcel vz cv cr wcel cc0 vz cv
        clt wbr wa wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cP vy cv cU
        cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv
        cW cnm cfv cfv c1 cle wbr wi vy cX wral cP cP vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cU cnm
        cfv cfv vz cv cle wbr cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle
        wbr cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw
        cv cU cn0v cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv
        cU cns cfv co cU cnsb cfv co cU cnsb cfv co cU cnm cfv cfv vz cv vz cv
        cle cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw
        cv cU cn0v cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv
        cU cns cfv co cU cnsb cfv co cU cnsb cfv co cU cnm cfv cfv vz cv vw cv
        cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnm cfv cfv vz cv cP cX
        wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw cv cU cn0v
        cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv
        co cU cnsb cfv co cU cnsb cfv co vz cv vw cv cU cnm cfv cfv cdiv co vw
        cv cU cns cfv co cU cnm cfv cP cX wcel vz cv cr wcel vw cv cX wcel vw
        cv cU cn0v cfv wne wa cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co cU cnsb cfv co cU cnsb cfv co vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cU cns cfv co wceq cc0 vz cv clt wbr cP cX wcel vz cv vw
        cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cX wcel cP cP vz cv vw cv
        cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv
        co vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co wceq cP cX
        wcel vz cv cr wcel wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cU cnv
        wcel cP cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co
        cX wcel cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU
        cnsb cfv co cU cnsb cfv co vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co wceq blocni.u cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co cU cU cnsb cfv cX blocnilem.1 cU cnsb cfv eqid nvnncan
        mp3an1 cP cX wcel vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa
        simpll vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv
        cU cnm cfv cfv cdiv co vw cv cU cns cfv co cX wcel cP cX wcel vz cv vw
        cv cU cnm cfv cfv cdiv co cc wcel vw cv cX wcel vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cX wcel vz cv cr wcel vw cv cX wcel vw
        cv cU cn0v cfv wne wa wa cU cnv wcel vz cv vw cv cU cnm cfv cfv cdiv co
        cc wcel vw cv cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns
        cfv co cX wcel blocni.u vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns
        cfv cU cX blocnilem.1 cU cns cfv eqid nvscl mp3an1 vz cv cr wcel vw cv
        cX wcel vw cv cU cn0v cfv wne wa wa vz cv vw cv cU cnm cfv cfv cdiv co
        vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0 wne
        wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw cv cX wcel vw cv cU
        cn0v cfv wne wa vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cnm
        cfv cfv cc0 wne vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vz cv vw cv
        cU cnm cfv cfv redivcl 3expb vw cv cX wcel vw cv cU cn0v cfv wne wa vw
        cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0 wne vw cv cX wcel vw
        cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw cv cX
        wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX
        blocnilem.1 cU cnm cfv eqid nvcl mpan adantr vw cv cX wcel vw cv cU cnm
        cfv cfv cc0 wne vw cv cU cn0v cfv wne vw cv cX wcel vw cv cU cnm cfv
        cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw cv cX wcel vw cv cU cnm cfv
        cfv cc0 wceq vw cv cU cn0v cfv wceq wb blocni.u vw cv cU cU cnm cfv cX
        cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid nvz mpan
        necon3bid biimpar jca sylan2 recnd vz cv cr wcel vw cv cX wcel vw cv cU
        cn0v cfv wne simprl sylanc adantll sylanc adantlrr fveq2d vz cv cr wcel
        cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv
        cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnm cfv cfv vz cv wceq cP
        cX wcel vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v
        cfv wne wa wa vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU
        cnm cfv cfv vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cnm cfv cfv
        cmul co vz cv vz cv vw cv cU cnm cfv cfv cdiv co cr wcel cc0 vz cv vw
        cv cU cnm cfv cfv cdiv co cle wbr wa vw cv cX wcel vz cv vw cv cU cnm
        cfv cfv cdiv co vw cv cU cns cfv co cU cnm cfv cfv vz cv vw cv cU cnm
        cfv cfv cdiv co vw cv cU cnm cfv cfv cmul co wceq vz cv cr wcel cc0 vz
        cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cU cnv wcel vz
        cv vw cv cU cnm cfv cfv cdiv co cr wcel cc0 vz cv vw cv cU cnm cfv cfv
        cdiv co cle wbr wa vw cv cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw
        cv cU cns cfv co cU cnm cfv cfv vz cv vw cv cU cnm cfv cfv cdiv co vw
        cv cU cnm cfv cfv cmul co wceq blocni.u vz cv vw cv cU cnm cfv cfv cdiv
        co vw cv cU cns cfv cU cU cnm cfv cX blocnilem.1 cU cns cfv eqid cU cnm
        cfv eqid nvsge0 mp3an1 vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel
        vw cv cU cn0v cfv wne wa wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel
        cc0 vz cv vw cv cU cnm cfv cfv cdiv co cle wbr vz cv cr wcel vw cv cX
        wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv co cr
        wcel cc0 vz cv clt wbr vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv
        cU cnm cfv cfv cc0 wne wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw
        cv cX wcel vw cv cU cn0v cfv wne wa vz cv cr wcel vw cv cU cnm cfv cfv
        cr wcel vw cv cU cnm cfv cfv cc0 wne vz cv vw cv cU cnm cfv cfv cdiv co
        cr wcel vz cv vw cv cU cnm cfv cfv redivcl 3expb vw cv cX wcel vw cv cU
        cn0v cfv wne wa vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0
        wne vw cv cX wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU
        cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU
        cU cnm cfv cX blocnilem.1 cU cnm cfv eqid nvcl mpan adantr vw cv cX
        wcel vw cv cU cnm cfv cfv cc0 wne vw cv cU cn0v cfv wne vw cv cX wcel
        vw cv cU cnm cfv cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw cv cX wcel vw
        cv cU cnm cfv cfv cc0 wceq vw cv cU cn0v cfv wceq wb blocni.u vw cv cU
        cU cnm cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid
        nvz mpan necon3bid biimpar jca sylan2 adantlr vz cv cr wcel cc0 vz cv
        cle wbr wa vw cv cU cnm cfv cfv cr wcel cc0 vw cv cU cnm cfv cfv clt
        wbr wa cc0 vz cv vw cv cU cnm cfv cfv cdiv co cle wbr vz cv cr wcel cc0
        vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU
        cnm cfv cfv divge0 vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv cle wbr
        cc0 cr wcel vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv cle wbr wi 0re
        cc0 vz cv ltle mpan imdistani vw cv cX wcel vw cv cU cn0v cfv wne wa vw
        cv cU cnm cfv cfv cr wcel cc0 vw cv cU cnm cfv cfv clt wbr vw cv cX
        wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw
        cv cX wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX
        blocnilem.1 cU cnm cfv eqid nvcl mpan adantr vw cv cX wcel vw cv cU
        cn0v cfv wne cc0 vw cv cU cnm cfv cfv clt wbr cU cnv wcel vw cv cX wcel
        vw cv cU cn0v cfv wne cc0 vw cv cU cnm cfv cfv clt wbr wb blocni.u vw
        cv cU cU cnm cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv
        eqid nvgt0 mpan biimpa jca syl2an jca vz cv cr wcel cc0 vz cv clt wbr
        wa vw cv cX wcel vw cv cU cn0v cfv wne simprl sylanc vz cv cc wcel vw
        cv cU cnm cfv cfv cc wcel vw cv cU cnm cfv cfv cc0 wne vz cv vw cv cU
        cnm cfv cfv cdiv co vw cv cU cnm cfv cfv cmul co vz cv wceq vz cv cr
        wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa vz
        cv vw cv cU cnm cfv cfv divcan1 vz cv cr wcel vz cv cc wcel cc0 vz cv
        clt wbr vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv recn ad2antrr vw
        cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm cfv cfv cc wcel vz cv
        cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa vw
        cv cU cnm cfv cfv vw cv cX wcel vw cv cU cnm cfv cfv cr wcel vw cv cU
        cn0v cfv wne cU cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cr wcel
        blocni.u vw cv cU cU cnm cfv cX blocnilem.1 cU cnm cfv eqid nvcl mpan
        adantr recnd adantl vw cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm
        cfv cfv cc0 wne vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv
        cU cnm cfv cfv cc0 wne vw cv cU cn0v cfv wne vw cv cX wcel vw cv cU cnm
        cfv cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw cv cX wcel vw cv cU cnm
        cfv cfv cc0 wceq vw cv cU cn0v cfv wceq wb blocni.u vw cv cU cU cnm cfv
        cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid nvz mpan
        necon3bid biimpar adantl syl3anc eqtrd adantll eqtrd vz cv cr wcel cc0
        vz cv clt wbr wa vz cv vz cv cle wbr cP cX wcel vw cv cX wcel vw cv cU
        cn0v cfv wne wa vz cv cr wcel vz cv vz cv cle wbr cc0 vz cv clt wbr vz
        cv leid adantr ad2antlr eqbrtrd cP cX wcel vz cv cr wcel cc0 vz cv clt
        wbr wa wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cP vz cv vw cv cU
        cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cX wcel cP vy cv
        cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT
        cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral cP cP vz cv vw cv cU cnm
        cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cU
        cnm cfv cfv vz cv cle wbr cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw
        cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv cfv c1
        cle wbr wi wi cP cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co cX wcel cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns
        cfv co cU cnsb cfv co cX wcel cP cX wcel vz cv cr wcel cc0 vz cv clt
        wbr wa wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cU cnv wcel cP cX
        wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cX wcel cP
        vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co
        cX wcel blocni.u cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv
        co cU cU cnsb cfv cX blocnilem.1 cU cnsb cfv eqid nvmcl mp3an1 cP cX
        wcel vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv
        wne wa simpll vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU
        cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co
        cX wcel cP cX wcel vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa
        vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cX wcel cc0 vz
        cv clt wbr vz cv vw cv cU cnm cfv cfv cdiv co cc wcel vw cv cX wcel vz
        cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cX wcel vz cv cr
        wcel vw cv cX wcel vw cv cU cn0v cfv wne wa wa cU cnv wcel vz cv vw cv
        cU cnm cfv cfv cdiv co cc wcel vw cv cX wcel vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cU cns cfv co cX wcel blocni.u vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cU cns cfv cU cX blocnilem.1 cU cns cfv eqid nvscl mp3an1
        vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa wa vz cv vw cv cU
        cnm cfv cfv cdiv co vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv cU
        cnm cfv cfv cc0 wne wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw cv
        cX wcel vw cv cU cn0v cfv wne wa vz cv cr wcel vw cv cU cnm cfv cfv cr
        wcel vw cv cU cnm cfv cfv cc0 wne vz cv vw cv cU cnm cfv cfv cdiv co cr
        wcel vz cv vw cv cU cnm cfv cfv redivcl 3expb vw cv cX wcel vw cv cU
        cn0v cfv wne wa vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0
        wne vw cv cX wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU
        cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU
        cU cnm cfv cX blocnilem.1 cU cnm cfv eqid nvcl mpan adantr vw cv cX
        wcel vw cv cU cnm cfv cfv cc0 wne vw cv cU cn0v cfv wne vw cv cX wcel
        vw cv cU cnm cfv cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw cv cX wcel vw
        cv cU cnm cfv cfv cc0 wceq vw cv cU cn0v cfv wceq wb blocni.u vw cv cU
        cU cnm cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid
        nvz mpan necon3bid biimpar jca sylan2 recnd vz cv cr wcel vw cv cX wcel
        vw cv cU cn0v cfv wne simprl sylanc adantlr adantll sylanc cP vy cv cU
        cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT cfv
        cW cnm cfv cfv c1 cle wbr wi cP cP vz cv vw cv cU cnm cfv cfv cdiv co
        vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cU cnm cfv cfv vz cv
        cle wbr cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU
        cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cP vz
        cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cX
        vy cv cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb
        cfv co wceq cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP cP
        vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co
        cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP vy cv cU cnsb cfv co cT
        cfv cW cnm cfv cfv c1 cle wbr cP cP vz cv vw cv cU cnm cfv cfv cdiv co
        vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv cfv
        c1 cle wbr vy cv cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv
        co cU cnsb cfv co wceq cP vy cv cU cnsb cfv co cU cnm cfv cfv cP cP vz
        cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU
        cnsb cfv co cU cnm cfv cfv vz cv cle vy cv cP vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co wceq cP vy cv cU cnsb
        cfv co cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU
        cnsb cfv co cU cnsb cfv co cU cnm cfv vy cv cP vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cP cU cnsb cfv opreq2
        fveq2d breq1d vy cv cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns
        cfv co cU cnsb cfv co wceq cP vy cv cU cnsb cfv co cT cfv cW cnm cfv
        cfv cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU
        cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle vy cv cP vz cv
        vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co wceq cP
        vy cv cU cnsb cfv co cT cfv cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw
        cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv vy cv
        cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv
        co wceq cP vy cv cU cnsb cfv co cP cP vz cv vw cv cU cnm cfv cfv cdiv
        co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT vy cv cP vz cv
        vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cP cU
        cnsb cfv opreq2 fveq2d fveq2d breq1d imbi12d rcla4v syl mpid cP cX wcel
        vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw cv cU cn0v cfv
        wne wa wa cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co
        cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr vz cv vw
        cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cnm cfv cfv cmul co c1 cle
        wbr vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv
        cmul co cle wbr cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv
        cX wcel vw cv cU cn0v cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm
        cfv cfv vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cnm cfv cfv
        cmul co c1 cle cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv
        cX wcel vw cv cU cn0v cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv cW cnm
        cfv cfv vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cns cfv co
        cW cnm cfv cfv vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cnm
        cfv cfv cmul co cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv
        cX wcel vw cv cU cn0v cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv vz cv
        vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cns cfv co cW cnm cfv cP
        cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw cv cU
        cn0v cfv wne wa wa cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co cU cnsb cfv co cU cnsb cfv co cT cfv vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cT cfv vz cv vw cv cU cnm cfv cfv cdiv
        co vw cv cT cfv cW cns cfv co cP cX wcel vz cv cr wcel cc0 vz cv clt
        wbr wa wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cP cP vz cv vw cv
        cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv
        co vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cT cP cX wcel
        vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa cP cP vz cv vw cv
        cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv
        co vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co wceq cc0 vz
        cv clt wbr cP cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns
        cfv co cX wcel cP cP vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns
        cfv co cU cnsb cfv co cU cnsb cfv co vz cv vw cv cU cnm cfv cfv cdiv co
        vw cv cU cns cfv co wceq cP cX wcel vz cv cr wcel wa vw cv cX wcel vw
        cv cU cn0v cfv wne wa wa cU cnv wcel cP cX wcel vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cX wcel cP cP vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cU cnsb cfv co cU cnsb cfv co vz cv vw
        cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co wceq blocni.u cP vz cv vw
        cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cU cU cnsb cfv cX
        blocnilem.1 cU cnsb cfv eqid nvnncan mp3an1 cP cX wcel vz cv cr wcel vw
        cv cX wcel vw cv cU cn0v cfv wne wa simpll vz cv cr wcel vw cv cX wcel
        vw cv cU cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU
        cns cfv co cX wcel cP cX wcel vz cv vw cv cU cnm cfv cfv cdiv co cc
        wcel vw cv cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv
        co cX wcel vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa wa cU
        cnv wcel vz cv vw cv cU cnm cfv cfv cdiv co cc wcel vw cv cX wcel vz cv
        vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cX wcel blocni.u vz cv
        vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv cU cX blocnilem.1 cU cns
        cfv eqid nvscl mp3an1 vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne
        wa wa vz cv vw cv cU cnm cfv cfv cdiv co vz cv cr wcel vw cv cU cnm cfv
        cfv cr wcel vw cv cU cnm cfv cfv cc0 wne wa vz cv vw cv cU cnm cfv cfv
        cdiv co cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv cr wcel vw
        cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0 wne vz cv vw cv cU
        cnm cfv cfv cdiv co cr wcel vz cv vw cv cU cnm cfv cfv redivcl 3expb vw
        cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm cfv cfv cr wcel vw cv
        cU cnm cfv cfv cc0 wne vw cv cX wcel vw cv cU cnm cfv cfv cr wcel vw cv
        cU cn0v cfv wne cU cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cr wcel
        blocni.u vw cv cU cU cnm cfv cX blocnilem.1 cU cnm cfv eqid nvcl mpan
        adantr vw cv cX wcel vw cv cU cnm cfv cfv cc0 wne vw cv cU cn0v cfv wne
        vw cv cX wcel vw cv cU cnm cfv cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw
        cv cX wcel vw cv cU cnm cfv cfv cc0 wceq vw cv cU cn0v cfv wceq wb
        blocni.u vw cv cU cU cnm cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv
        eqid cU cnm cfv eqid nvz mpan necon3bid biimpar jca sylan2 recnd vz cv
        cr wcel vw cv cX wcel vw cv cU cn0v cfv wne simprl sylanc adantll
        sylanc adantlrr fveq2d vz cv vw cv cU cnm cfv cfv cdiv co cc wcel vw cv
        cX wcel vz cv vw cv cU cnm cfv cfv cdiv co vw cv cU cns cfv co cT cfv
        vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cns cfv co wceq cP
        cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw cv cU
        cn0v cfv wne wa wa cU cnv wcel cW cnv wcel cT cL wcel w3a vz cv vw cv
        cU cnm cfv cfv cdiv co cc wcel vw cv cX wcel wa vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cU cns cfv co cT cfv vz cv vw cv cU cnm cfv cfv cdiv
        co vw cv cT cfv cW cns cfv co wceq cU cnv wcel cW cnv wcel cT cL wcel
        blocni.u blocni.w blocni.l 3pm3.2i vz cv vw cv cU cnm cfv cfv cdiv co
        vw cv cU cns cfv cW cns cfv cT cU cL cW cX blocnilem.1 cU cns cfv eqid
        cW cns cfv eqid blocni.4 lnomul mpan vz cv cr wcel cc0 vz cv clt wbr wa
        vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv
        co cc wcel cP cX wcel vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne
        wa vz cv vw cv cU cnm cfv cfv cdiv co cc wcel cc0 vz cv clt wbr vz cv
        cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa wa vz cv vw cv cU cnm
        cfv cfv cdiv co vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cnm
        cfv cfv cc0 wne wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw cv cX
        wcel vw cv cU cn0v cfv wne wa vz cv cr wcel vw cv cU cnm cfv cfv cr
        wcel vw cv cU cnm cfv cfv cc0 wne vz cv vw cv cU cnm cfv cfv cdiv co cr
        wcel vz cv vw cv cU cnm cfv cfv redivcl 3expb vw cv cX wcel vw cv cU
        cn0v cfv wne wa vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0
        wne vw cv cX wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU
        cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU
        cU cnm cfv cX blocnilem.1 cU cnm cfv eqid nvcl mpan adantr vw cv cX
        wcel vw cv cU cnm cfv cfv cc0 wne vw cv cU cn0v cfv wne vw cv cX wcel
        vw cv cU cnm cfv cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw cv cX wcel vw
        cv cU cnm cfv cfv cc0 wceq vw cv cU cn0v cfv wceq wb blocni.u vw cv cU
        cU cnm cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid
        nvz mpan necon3bid biimpar jca sylan2 recnd adantlr adantll cP cX wcel
        vz cv cr wcel cc0 vz cv clt wbr wa wa vw cv cX wcel vw cv cU cn0v cfv
        wne simprl sylanc eqtrd fveq2d vz cv cr wcel cc0 vz cv clt wbr wa vw cv
        cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv co vw
        cv cT cfv cW cns cfv co cW cnm cfv cfv vz cv vw cv cU cnm cfv cfv cdiv
        co vw cv cT cfv cW cnm cfv cfv cmul co wceq cP cX wcel vz cv vw cv cU
        cnm cfv cfv cdiv co cr wcel cc0 vz cv vw cv cU cnm cfv cfv cdiv co cle
        wbr wa vw cv cT cfv cW cba cfv wcel vz cv vw cv cU cnm cfv cfv cdiv co
        vw cv cT cfv cW cns cfv co cW cnm cfv cfv vz cv vw cv cU cnm cfv cfv
        cdiv co vw cv cT cfv cW cnm cfv cfv cmul co wceq vz cv cr wcel cc0 vz
        cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa cW cnv wcel vz
        cv vw cv cU cnm cfv cfv cdiv co cr wcel cc0 vz cv vw cv cU cnm cfv cfv
        cdiv co cle wbr wa vw cv cT cfv cW cba cfv wcel vz cv vw cv cU cnm cfv
        cfv cdiv co vw cv cT cfv cW cns cfv co cW cnm cfv cfv vz cv vw cv cU
        cnm cfv cfv cdiv co vw cv cT cfv cW cnm cfv cfv cmul co wceq blocni.w
        vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cns cfv cW cW cnm
        cfv cW cba cfv cW cba cfv eqid cW cns cfv eqid cW cnm cfv eqid nvsge0
        mp3an1 vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v
        cfv wne wa wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel cc0 vz cv vw
        cv cU cnm cfv cfv cdiv co cle wbr vz cv cr wcel vw cv cX wcel vw cv cU
        cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel cc0 vz cv
        clt wbr vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv
        cc0 wne wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw cv cX wcel vw
        cv cU cn0v cfv wne wa vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv
        cU cnm cfv cfv cc0 wne vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vz cv
        vw cv cU cnm cfv cfv redivcl 3expb vw cv cX wcel vw cv cU cn0v cfv wne
        wa vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0 wne vw cv cX
        wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw
        cv cX wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX
        blocnilem.1 cU cnm cfv eqid nvcl mpan adantr vw cv cX wcel vw cv cU cnm
        cfv cfv cc0 wne vw cv cU cn0v cfv wne vw cv cX wcel vw cv cU cnm cfv
        cfv cc0 vw cv cU cn0v cfv cU cnv wcel vw cv cX wcel vw cv cU cnm cfv
        cfv cc0 wceq vw cv cU cn0v cfv wceq wb blocni.u vw cv cU cU cnm cfv cX
        cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid nvz mpan
        necon3bid biimpar jca sylan2 adantlr vz cv cr wcel cc0 vz cv cle wbr wa
        vw cv cU cnm cfv cfv cr wcel cc0 vw cv cU cnm cfv cfv clt wbr wa cc0 vz
        cv vw cv cU cnm cfv cfv cdiv co cle wbr vz cv cr wcel cc0 vz cv clt wbr
        wa vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU cnm cfv cfv
        divge0 vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv cle wbr cc0 cr wcel vz
        cv cr wcel cc0 vz cv clt wbr cc0 vz cv cle wbr wi 0re cc0 vz cv ltle
        mpan imdistani vw cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm cfv
        cfv cr wcel cc0 vw cv cU cnm cfv cfv clt wbr vw cv cX wcel vw cv cU cnm
        cfv cfv cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw cv cX wcel vw cv
        cU cnm cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX blocnilem.1 cU
        cnm cfv eqid nvcl mpan adantr vw cv cX wcel vw cv cU cn0v cfv wne cc0
        vw cv cU cnm cfv cfv clt wbr cU cnv wcel vw cv cX wcel vw cv cU cn0v
        cfv wne cc0 vw cv cU cnm cfv cfv clt wbr wb blocni.u vw cv cU cU cnm
        cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid nvgt0
        mpan biimpa jca syl2an jca vw cv cX wcel vw cv cT cfv cW cba cfv wcel
        vz cv cr wcel cc0 vz cv clt wbr wa vw cv cU cn0v cfv wne cX cW cba cfv
        vw cv cT cU cnv wcel cW cnv wcel cT cL wcel cX cW cba cfv cT wf
        blocni.u blocni.w blocni.l cT cU cL cW cX cW cba cfv blocnilem.1 cW cba
        cfv eqid blocni.4 lnof mp3an ffvelrni ad2antrl sylanc adantll eqtrd
        breq1d vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v
        cfv wne wa vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cnm cfv
        cfv cmul co c1 cle wbr vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw
        cv cU cnm cfv cfv cmul co cle wbr wb cP cX wcel vz cv cr wcel cc0 vz cv
        clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa wa vz cv vw cv cU cnm
        cfv cfv cdiv co vw cv cT cfv cW cnm cfv cfv cmul co c1 cle wbr vw cv cT
        cfv cW cnm cfv cfv c1 vz cv vw cv cU cnm cfv cfv cdiv co cdiv co cle
        wbr vw cv cT cfv cW cnm cfv cfv c1 vz cv cdiv co vw cv cU cnm cfv cfv
        cmul co cle wbr vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw cv cT cfv
        cW cnm cfv cfv cr wcel wa cc0 vz cv vw cv cU cnm cfv cfv cdiv co clt
        wbr vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT cfv cW cnm cfv cfv cmul
        co c1 cle wbr vw cv cT cfv cW cnm cfv cfv c1 vz cv vw cv cU cnm cfv cfv
        cdiv co cdiv co cle wbr wb vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX
        wcel vw cv cU cn0v cfv wne wa wa vz cv vw cv cU cnm cfv cfv cdiv co cr
        wcel vw cv cT cfv cW cnm cfv cfv cr wcel c1 cr wcel cc0 vz cv vw cv cU
        cnm cfv cfv cdiv co clt wbr vz cv vw cv cU cnm cfv cfv cdiv co vw cv cT
        cfv cW cnm cfv cfv cmul co c1 cle wbr vw cv cT cfv cW cnm cfv cfv c1 vz
        cv vw cv cU cnm cfv cfv cdiv co cdiv co cle wbr wb 1re vz cv vw cv cU
        cnm cfv cfv cdiv co vw cv cT cfv cW cnm cfv cfv c1 lemuldiv2OLD mp3anl3
        vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne
        wa wa vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vw cv cT cfv cW cnm
        cfv cfv cr wcel vz cv cr wcel vw cv cX wcel vw cv cU cn0v cfv wne wa vz
        cv vw cv cU cnm cfv cfv cdiv co cr wcel cc0 vz cv clt wbr vz cv cr wcel
        vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0 wne wa vz cv vw
        cv cU cnm cfv cfv cdiv co cr wcel vw cv cX wcel vw cv cU cn0v cfv wne
        wa vz cv cr wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cnm cfv cfv cc0
        wne vz cv vw cv cU cnm cfv cfv cdiv co cr wcel vz cv vw cv cU cnm cfv
        cfv redivcl 3expb vw cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm
        cfv cfv cr wcel vw cv cU cnm cfv cfv cc0 wne vw cv cX wcel vw cv cU cnm
        cfv cfv cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw cv cX wcel vw cv
        cU cnm cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX blocnilem.1 cU
        cnm cfv eqid nvcl mpan adantr vw cv cX wcel vw cv cU cnm cfv cfv cc0
        wne vw cv cU cn0v cfv wne vw cv cX wcel vw cv cU cnm cfv cfv cc0 vw cv
        cU cn0v cfv cU cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cc0 wceq vw
        cv cU cn0v cfv wceq wb blocni.u vw cv cU cU cnm cfv cX cU cn0v cfv
        blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid nvz mpan necon3bid biimpar
        jca sylan2 adantlr vw cv cX wcel vw cv cT cfv cW cnm cfv cfv cr wcel vz
        cv cr wcel cc0 vz cv clt wbr wa vw cv cU cn0v cfv wne vw cv cX wcel vw
        cv cT cfv cW cba cfv wcel vw cv cT cfv cW cnm cfv cfv cr wcel cX cW cba
        cfv vw cv cT cU cnv wcel cW cnv wcel cT cL wcel cX cW cba cfv cT wf
        blocni.u blocni.w blocni.l cT cU cL cW cX cW cba cfv blocnilem.1 cW cba
        cfv eqid blocni.4 lnof mp3an ffvelrni cW cnv wcel vw cv cT cfv cW cba
        cfv wcel vw cv cT cfv cW cnm cfv cfv cr wcel blocni.w vw cv cT cfv cW
        cW cnm cfv cW cba cfv cW cba cfv eqid cW cnm cfv eqid nvcl mpan syl
        ad2antrl jca vz cv cr wcel cc0 vz cv clt wbr wa vw cv cU cnm cfv cfv cr
        wcel cc0 vw cv cU cnm cfv cfv clt wbr wa cc0 vz cv vw cv cU cnm cfv cfv
        cdiv co clt wbr vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU
        cnm cfv cfv divgt0 vw cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm
        cfv cfv cr wcel cc0 vw cv cU cnm cfv cfv clt wbr vw cv cX wcel vw cv cU
        cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw cv cX wcel vw
        cv cU cnm cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX blocnilem.1
        cU cnm cfv eqid nvcl mpan adantr vw cv cX wcel vw cv cU cn0v cfv wne
        cc0 vw cv cU cnm cfv cfv clt wbr cU cnv wcel vw cv cX wcel vw cv cU
        cn0v cfv wne cc0 vw cv cU cnm cfv cfv clt wbr wb blocni.u vw cv cU cU
        cnm cfv cX cU cn0v cfv blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid
        nvgt0 mpan biimpa jca sylan2 sylanc vz cv cr wcel cc0 vz cv clt wbr wa
        vw cv cX wcel vw cv cU cn0v cfv wne wa wa c1 vz cv vw cv cU cnm cfv cfv
        cdiv co cdiv co c1 vz cv cdiv co vw cv cU cnm cfv cfv cmul co vw cv cT
        cfv cW cnm cfv cfv cle vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel
        vw cv cU cn0v cfv wne wa wa c1 vz cv vw cv cU cnm cfv cfv cdiv co cdiv
        co vw cv cU cnm cfv cfv vz cv cdiv co c1 vz cv cdiv co vw cv cU cnm cfv
        cfv cmul co vz cv cc wcel vz cv cc0 wne wa vw cv cU cnm cfv cfv cc wcel
        vw cv cU cnm cfv cfv cc0 wne wa c1 vz cv vw cv cU cnm cfv cfv cdiv co
        cdiv co vw cv cU cnm cfv cfv vz cv cdiv co wceq vz cv cr wcel cc0 vz cv
        clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv vw cv cU cnm
        cfv cfv recdiv vz cv cr wcel cc0 vz cv clt wbr wa vz cv cc wcel vz cv
        cc0 wne vz cv cr wcel vz cv cc wcel cc0 vz cv clt wbr vz cv recn adantr
        vz cv gt0ne0 jca vw cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm
        cfv cfv cc wcel vw cv cU cnm cfv cfv cc0 wne vw cv cX wcel vw cv cU
        cn0v cfv wne wa vw cv cU cnm cfv cfv vw cv cX wcel vw cv cU cnm cfv cfv
        cr wcel vw cv cU cn0v cfv wne cU cnv wcel vw cv cX wcel vw cv cU cnm
        cfv cfv cr wcel blocni.u vw cv cU cU cnm cfv cX blocnilem.1 cU cnm cfv
        eqid nvcl mpan adantr recnd vw cv cX wcel vw cv cU cnm cfv cfv cc0 wne
        vw cv cU cn0v cfv wne vw cv cX wcel vw cv cU cnm cfv cfv cc0 vw cv cU
        cn0v cfv cU cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cc0 wceq vw cv
        cU cn0v cfv wceq wb blocni.u vw cv cU cU cnm cfv cX cU cn0v cfv
        blocnilem.1 cU cn0v cfv eqid cU cnm cfv eqid nvz mpan necon3bid biimpar
        jca syl2an vw cv cU cnm cfv cfv cc wcel vz cv cc wcel vz cv cc0 wne vw
        cv cU cnm cfv cfv vz cv cdiv co c1 vz cv cdiv co vw cv cU cnm cfv cfv
        cmul co wceq vz cv cr wcel cc0 vz cv clt wbr wa vw cv cX wcel vw cv cU
        cn0v cfv wne wa wa vw cv cU cnm cfv cfv vz cv divrec2 vw cv cX wcel vw
        cv cU cn0v cfv wne wa vw cv cU cnm cfv cfv cc wcel vz cv cr wcel cc0 vz
        cv clt wbr wa vw cv cX wcel vw cv cU cn0v cfv wne wa vw cv cU cnm cfv
        cfv vw cv cX wcel vw cv cU cnm cfv cfv cr wcel vw cv cU cn0v cfv wne cU
        cnv wcel vw cv cX wcel vw cv cU cnm cfv cfv cr wcel blocni.u vw cv cU
        cU cnm cfv cX blocnilem.1 cU cnm cfv eqid nvcl mpan adantr recnd adantl
        vz cv cr wcel vz cv cc wcel cc0 vz cv clt wbr vw cv cX wcel vw cv cU
        cn0v cfv wne wa vz cv recn ad2antrr vz cv cr wcel cc0 vz cv clt wbr wa
        vz cv cc0 wne vw cv cX wcel vw cv cU cn0v cfv wne wa vz cv gt0ne0
        adantr syl3anc eqtrd breq2d bitrd adantll bitrd sylibd exp32 com23
        com24 imp41 cP cX wcel vz cv cr wcel cc0 vz cv clt wbr wa wa cU cn0v
        cfv cT cfv cW cnm cfv cfv c1 vz cv cdiv co cU cn0v cfv cU cnm cfv cfv
        cmul co cle wbr cP vy cv cU cnsb cfv co cU cnm cfv cfv vz cv cle wbr cP
        vy cv cU cnsb cfv co cT cfv cW cnm cfv cfv c1 cle wbr wi vy cX wral vw
        cv cX wcel vz cv cr wcel cc0 vz cv clt wbr wa cU cn0v cfv cT cfv cW cnm
        cfv cfv c1 vz cv cdiv co cU cn0v cfv cU cnm cfv cfv cmul co cle wbr cP
        cX wcel vz cv cr wcel cc0 vz cv clt wbr wa cc0 c1 vz cv cdiv co cU cn0v
        cfv cU cnm cfv cfv cmul co cU cn0v cfv cT cfv cW cnm cfv cfv cle vz cv
        cr wcel cc0 vz cv clt wbr wa cc0 c1 vz cv cdiv co cU cn0v cfv cU cnm
        cfv cfv cmul co cc0 cle vz cv cr wcel cc0 vz cv clt wbr wa c1 vz cv
        cdiv co cc0 cmul co cc0 c1 vz cv cdiv co cU cn0v cfv cU cnm cfv cfv
        cmul co vz cv cr wcel cc0 vz cv clt wbr wa c1 vz cv cdiv co cc wcel c1
        vz cv cdiv co cc0 cmul co cc0 wceq vz cv cr wcel cc0 vz cv clt wbr wa
        c1 vz cv cdiv co vz cv cr wcel cc0 vz cv clt wbr vz cv cc0 wne c1 vz cv
        cdiv co cr wcel vz cv gt0ne0 vz cv rereccl syldan recnd c1 vz cv cdiv
        co mul01 syl cU cn0v cfv cU cnm cfv cfv cc0 c1 vz cv cdiv co cmul cU
        cnv wcel cU cn0v cfv cU cnm cfv cfv cc0 wceq blocni.u cU cU cnm cfv cU
        cn0v cfv cU cn0v cfv eqid cU cnm cfv eqid nvz0 ax-mp opreq2i syl5req
        cc0 0re leidi syl5breq cU cn0v cfv cT cfv cW cnm cfv cfv cW cn0v cfv cW
        cnm cfv cfv cc0 cU cn0v cfv cT cfv cW cn0v cfv cW cnm cfv cU cnv wcel
        cW cnv wcel cT cL wcel cU cn0v cfv cT cfv cW cn0v cfv wceq blocni.u
        blocni.w blocni.l cU cn0v cfv cT cU cL cW cX cW cba cfv cW cn0v cfv
        blocnilem.1 cW cba cfv eqid cU cn0v cfv eqid cW cn0v cfv eqid blocni.4
        lno0 mp3an fveq2i cW cnv wcel cW cn0v cfv cW cnm cfv cfv cc0 wceq
        blocni.w cW cW cnm cfv cW cn0v cfv cW cn0v cfv eqid cW cnm cfv eqid
        nvz0 ax-mp eqtri syl5eqbr adantl ad2antrr pm2.61ne r19.21aiva sylanc
        exp42 imp4a r19.23adv adantr mpd blocni.l jctil vx vw cB cT cU cL cU
        cnm cfv cW cnm cfv cW cX blocnilem.1 cU cnm cfv eqid cW cnm cfv eqid
        blocni.4 blocni.5 blocni.u blocni.w isblo3i sylibr $.
        $( [5-Jan-2008] $) $( [17-Dec-2007] $)
    $}

    $( A linear operator is continuous iff it is bounded.  Theorem 2.7-9(a) of
       [Kreyszig] p. 97. $)
    blocni $p |- ( T e. ( J Cn K ) <-> T e. B ) $=
      cT cJ cK ccn co wcel cT cB wcel cT cJ cK ccn co wcel cT cU cn0v cfv cJ cK
      ccnp co cfv wcel cT cB wcel cT cJ cK ccn co wcel cU cn0v cfv cJ cuni wcel
      cT cU cn0v cfv cJ cK ccnp co cfv wcel cU cn0v cfv cU cba cfv cJ cuni cU
      cnv wcel cU cn0v cfv cU cba cfv wcel blocni.u cU cU cba cfv cU cn0v cfv
      cU cba cfv eqid cU cn0v cfv eqid nvzcl ax-mp cC cme wcel cJ cuni cU cba
      cfv wceq cU cnv wcel cC cme wcel blocni.u cC cU blocni.8 imsmet ax-mp cC
      cJ cU cba cfv cC cU cU cba cfv cU cba cfv eqid blocni.8 blocni.u imsbai
      blocni.j uniopn2 ax-mp eleqtrri cJ ctop wcel cK ctop wcel cT cJ cK ccn co
      wcel cU cn0v cfv cJ cuni wcel wa cT cU cn0v cfv cJ cK ccnp co cfv wcel cC
      cme wcel cJ ctop wcel cU cnv wcel cC cme wcel blocni.u cC cU blocni.8
      imsmet ax-mp cC cJ blocni.j opntop ax-mp cD cme wcel cK ctop wcel cW cnv
      wcel cD cme wcel blocni.w cD cW blocni.d imsmet ax-mp cD cK blocni.k
      opntop ax-mp cU cn0v cfv cT cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni
      eqid cncnpi mpanl12 mpan2 cU cn0v cfv cU cba cfv wcel cT cU cn0v cfv cJ
      cK ccnp co cfv wcel cT cB wcel cU cnv wcel cU cn0v cfv cU cba cfv wcel
      blocni.u cU cU cba cfv cU cn0v cfv cU cba cfv eqid cU cn0v cfv eqid nvzcl
      ax-mp cB cC cD cU cn0v cfv cT cU cJ cK cL cW cU cba cfv blocni.8 blocni.d
      blocni.j blocni.k blocni.4 blocni.5 blocni.u blocni.w blocni.l cU cba cfv
      eqid blocnilem mpan syl cT cB wcel cT cJ cK ccn co wcel cU cW c0o co cJ
      cK ccn co wcel cT cU cW c0o co cT cU cW c0o co cJ cK ccn co eleq1 cT cB
      wcel cT cU cW c0o co wne wa cU cba cfv cW cba cfv cT wf cc0 vy cv clt wbr
      cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv vw cv cT
      cfv cD co vy cv clt wbr wi vw cU cba cfv wral wa vz cr wrex wi vy cr wral
      vx cU cba cfv wral wa cT cJ cK ccn co wcel cT cB wcel cT cU cW c0o co wne
      wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx
      cv cT cfv vw cv cT cfv cD co vy cv clt wbr wi vw cU cba cfv wral wa vz cr
      wrex wi vy cr wral vx cU cba cfv wral cU cba cfv cW cba cfv cT wf cT cB
      wcel cT cU cW c0o co wne wa cc0 vy cv clt wbr cc0 vz cv clt wbr vx cv vw
      cv cC co vz cv clt wbr vx cv cT cfv vw cv cT cfv cD co vy cv clt wbr wi
      vw cU cba cfv wral wa vz cr wrex wi vy cr wral vx cU cba cfv cT cB wcel
      cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa cc0 vy cv clt wbr cc0 vz
      cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv vw cv cT cfv cD
      co vy cv clt wbr wi vw cU cba cfv wral wa vz cr wrex wi vy cr cT cB wcel
      cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa vy cv cr wcel cc0 vy cv
      clt wbr cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv vw
      cv cT cfv cD co vy cv clt wbr wi vw cU cba cfv wral wa vz cr wrex vy cv
      cT cU cW cnmo co cfv cdiv co cr wcel cc0 vy cv cT cU cW cnmo co cfv cdiv
      co clt wbr vx cv vw cv cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr
      vx cv cT cfv vw cv cT cfv cD co vy cv clt wbr wi vw cU cba cfv wral wa
      cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv vw cv cT
      cfv cD co vy cv clt wbr wi vw cU cba cfv wral wa vz cr wrex cT cB wcel cT
      cU cW c0o co wne wa vx cv cU cba cfv wcel wa vy cv cr wcel cc0 vy cv clt
      wbr wa wa cc0 vz cv clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv
      vw cv cT cfv cD co vy cv clt wbr wi vw cU cba cfv wral wa cc0 vy cv cT cU
      cW cnmo co cfv cdiv co clt wbr vx cv vw cv cC co vy cv cT cU cW cnmo co
      cfv cdiv co clt wbr vx cv cT cfv vw cv cT cfv cD co vy cv clt wbr wi vw
      cU cba cfv wral wa vz vy cv cT cU cW cnmo co cfv cdiv co cr vz cv vy cv
      cT cU cW cnmo co cfv cdiv co wceq cc0 vz cv clt wbr cc0 vy cv cT cU cW
      cnmo co cfv cdiv co clt wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv
      vw cv cT cfv cD co vy cv clt wbr wi vw cU cba cfv wral vx cv vw cv cC co
      vy cv cT cU cW cnmo co cfv cdiv co clt wbr vx cv cT cfv vw cv cT cfv cD
      co vy cv clt wbr wi vw cU cba cfv wral vz cv vy cv cT cU cW cnmo co cfv
      cdiv co cc0 clt breq2 vz cv vy cv cT cU cW cnmo co cfv cdiv co wceq vx cv
      vw cv cC co vz cv clt wbr vx cv cT cfv vw cv cT cfv cD co vy cv clt wbr
      wi vx cv vw cv cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr vx cv cT
      cfv vw cv cT cfv cD co vy cv clt wbr wi vw cU cba cfv vz cv vy cv cT cU
      cW cnmo co cfv cdiv co wceq vx cv vw cv cC co vz cv clt wbr vx cv vw cv
      cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr vx cv cT cfv vw cv cT
      cfv cD co vy cv clt wbr vz cv vy cv cT cU cW cnmo co cfv cdiv co vx cv vw
      cv cC co clt breq2 imbi1d ralbidv anbi12d rcla4ev cT cB wcel cT cU cW c0o
      co wne wa vy cv cr wcel vy cv cT cU cW cnmo co cfv cdiv co cr wcel vx cv
      cU cba cfv wcel cc0 vy cv clt wbr vy cv cr wcel cT cU cW cnmo co cfv cr
      wcel cT cU cW cnmo co cfv cc0 wne vy cv cT cU cW cnmo co cfv cdiv co cr
      wcel cT cB wcel cT cU cW c0o co wne wa vy cv cr wcel wa vy cv cT cU cW
      cnmo co cfv redivcl cT cB wcel cT cU cW c0o co wne wa vy cv cr wcel
      pm3.27 cT cB wcel cT cU cW cnmo co cfv cr wcel cT cU cW c0o co wne vy cv
      cr wcel cU cnv wcel cW cnv wcel cT cB wcel cT cU cW cnmo co cfv cr wcel
      blocni.u blocni.w cB cT cU cU cW cnmo co cW cU cba cfv cW cba cfv cU cba
      cfv eqid cW cba cfv eqid cU cW cnmo co eqid blocni.5 nmblore mp3an12
      ad2antrr cT cU cW c0o co wne cT cU cW cnmo co cfv cc0 wne cT cB wcel vy
      cv cr wcel cT cU cW cnmo co cfv cc0 cT cU cW c0o co cT cU cW cnmo co cfv
      cc0 wceq cT cU cW c0o co wceq cT cL wcel cT cU cW cnmo co cfv cc0 wceq cT
      cU cW c0o co wceq wb blocni.l cT cU cL cU cW cnmo co cW cU cW c0o co cU
      cW cnmo co eqid cU cW c0o co eqid blocni.4 blocni.u blocni.w nmlno0i
      ax-mp biimpi necon3i ad2antlr syl3anc ad2ant2r cT cB wcel cT cU cW c0o co
      wne wa vx cv cU cba cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa cc0
      vy cv cT cU cW cnmo co cfv cdiv co clt wbr vx cv vw cv cC co vy cv cT cU
      cW cnmo co cfv cdiv co clt wbr vx cv cT cfv vw cv cT cfv cD co vy cv clt
      wbr wi vw cU cba cfv wral cT cB wcel cT cU cW c0o co wne wa vy cv cr wcel
      cc0 vy cv clt wbr wa cc0 vy cv cT cU cW cnmo co cfv cdiv co clt wbr vx cv
      cU cba cfv wcel vy cv cr wcel cc0 vy cv clt wbr wa cT cU cW cnmo co cfv
      cr wcel cc0 cT cU cW cnmo co cfv clt wbr wa cc0 vy cv cT cU cW cnmo co
      cfv cdiv co clt wbr cT cB wcel cT cU cW c0o co wne wa vy cv cr wcel cc0
      vy cv clt wbr wa wa vy cv cT cU cW cnmo co cfv divgt0 cT cB wcel cT cU cW
      c0o co wne wa vy cv cr wcel cc0 vy cv clt wbr wa pm3.27 cT cB wcel cT cU
      cW c0o co wne wa cT cU cW cnmo co cfv cr wcel cc0 cT cU cW cnmo co cfv
      clt wbr wa vy cv cr wcel cc0 vy cv clt wbr wa cT cB wcel cT cU cW cnmo co
      cfv cr wcel cT cU cW c0o co wne cc0 cT cU cW cnmo co cfv clt wbr cU cnv
      wcel cW cnv wcel cT cB wcel cT cU cW cnmo co cfv cr wcel blocni.u
      blocni.w cB cT cU cU cW cnmo co cW cU cba cfv cW cba cfv cU cba cfv eqid
      cW cba cfv eqid cU cW cnmo co eqid blocni.5 nmblore mp3an12 cT cU cW c0o
      co wne cc0 cT cU cW cnmo co cfv clt wbr cU cnv wcel cW cnv wcel cT cL
      wcel cT cU cW c0o co wne cc0 cT cU cW cnmo co cfv clt wbr wb blocni.u
      blocni.w blocni.l cT cU cL cU cW cnmo co cW cU cW c0o co cU cW cnmo co
      eqid cU cW c0o co eqid blocni.4 nmlnogt0 mp3an biimpi anim12i adantr
      sylanc adantlr cT cB wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa
      vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv vw cv cC co vy cv cT cU cW
      cnmo co cfv cdiv co clt wbr vx cv cT cfv vw cv cT cfv cD co vy cv clt wbr
      wi vw cU cba cfv cT cB wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel
      wa vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU cba cfv wcel vx cv vw
      cv cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr vx cv cT cfv vw cv cT
      cfv cD co vy cv clt wbr cT cB wcel cT cU cW c0o co wne wa vx cv cU cba
      cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU cba cfv wcel
      wa vx cv vw cv cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr cT cU cW
      cnmo co cfv vx cv vw cv cC co cmul co vy cv clt wbr vx cv cT cfv vw cv cT
      cfv cD co vy cv clt wbr cT cB wcel cT cU cW c0o co wne wa vx cv cU cba
      cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU cba cfv wcel
      wa cT cU cW cnmo co cfv vx cv vw cv cC co cmul co vy cv clt wbr vx cv vw
      cv cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr cT cU cW cnmo co cfv
      cr wcel vx cv vw cv cC co cr wcel vy cv cr wcel w3a cc0 cT cU cW cnmo co
      cfv clt wbr cT cU cW cnmo co cfv vx cv vw cv cC co cmul co vy cv clt wbr
      vx cv vw cv cC co vy cv cT cU cW cnmo co cfv cdiv co clt wbr wb cT cB
      wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa vy cv cr wcel cc0 vy
      cv clt wbr wa wa vw cv cU cba cfv wcel wa cT cU cW cnmo co cfv vx cv vw
      cv cC co vy cv ltmuldiv2OLD cT cB wcel cT cU cW c0o co wne wa vx cv cU
      cba cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU cba cfv
      wcel wa cT cU cW cnmo co cfv cr wcel vx cv vw cv cC co cr wcel vy cv cr
      wcel cT cB wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa cT cU cW
      cnmo co cfv cr wcel vy cv cr wcel cc0 vy cv clt wbr wa vw cv cU cba cfv
      wcel cT cB wcel cT cU cW cnmo co cfv cr wcel cT cU cW c0o co wne vx cv cU
      cba cfv wcel cU cnv wcel cW cnv wcel cT cB wcel cT cU cW cnmo co cfv cr
      wcel blocni.u blocni.w cB cT cU cU cW cnmo co cW cU cba cfv cW cba cfv cU
      cba cfv eqid cW cba cfv eqid cU cW cnmo co eqid blocni.5 nmblore mp3an12
      ad2antrr ad2antrr vx cv cU cba cfv wcel vy cv cr wcel cc0 vy cv clt wbr
      wa vw cv cU cba cfv wcel vx cv vw cv cC co cr wcel cT cB wcel cT cU cW
      c0o co wne wa vx cv cU cba cfv wcel vw cv cU cba cfv wcel vx cv vw cv cC
      co cr wcel vy cv cr wcel cc0 vy cv clt wbr wa cC cme wcel vx cv cU cba
      cfv wcel vw cv cU cba cfv wcel vx cv vw cv cC co cr wcel cU cnv wcel cC
      cme wcel blocni.u cC cU blocni.8 imsmet ax-mp vx cv vw cv cC cU cba cfv
      cC cU cU cba cfv cU cba cfv eqid blocni.8 blocni.u imsbai metcl mp3an1
      adantlr adantlll cT cB wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel
      wa vy cv cr wcel cc0 vy cv clt wbr wa wa vy cv cr wcel vw cv cU cba cfv
      wcel cT cB wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa vy cv cr
      wcel cc0 vy cv clt wbr simprl adantr 3jca cT cB wcel cT cU cW c0o co wne
      wa vx cv cU cba cfv wcel wa cc0 cT cU cW cnmo co cfv clt wbr vy cv cr
      wcel cc0 vy cv clt wbr wa vw cv cU cba cfv wcel cT cU cW c0o co wne cc0
      cT cU cW cnmo co cfv clt wbr cT cB wcel vx cv cU cba cfv wcel cT cU cW
      c0o co wne cc0 cT cU cW cnmo co cfv clt wbr cU cnv wcel cW cnv wcel cT cL
      wcel cT cU cW c0o co wne cc0 cT cU cW cnmo co cfv clt wbr wb blocni.u
      blocni.w blocni.l cT cU cL cU cW cnmo co cW cU cW c0o co cU cW cnmo co
      eqid cU cW c0o co eqid blocni.4 nmlnogt0 mp3an biimpi ad2antlr ad2antrr
      sylanc biimpar cT cB wcel cT cU cW c0o co wne wa vx cv cU cba cfv wcel wa
      vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU cba cfv wcel wa cT cU cW
      cnmo co cfv vx cv vw cv cC co cmul co vy cv clt wbr vx cv cT cfv vw cv cT
      cfv cD co vy cv clt wbr cT cB wcel cT cU cW c0o co wne wa vx cv cU cba
      cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU cba cfv wcel
      wa vx cv cT cfv vw cv cT cfv cD co cT cU cW cnmo co cfv vx cv vw cv cC co
      cmul co cle wbr cT cU cW cnmo co cfv vx cv vw cv cC co cmul co vy cv clt
      wbr vx cv cT cfv vw cv cT cfv cD co vy cv clt wbr cT cB wcel cT cU cW c0o
      co wne wa vx cv cU cba cfv wcel wa vw cv cU cba cfv wcel vx cv cT cfv vw
      cv cT cfv cD co cT cU cW cnmo co cfv vx cv vw cv cC co cmul co cle wbr vy
      cv cr wcel cc0 vy cv clt wbr wa cT cB wcel vx cv cU cba cfv wcel vw cv cU
      cba cfv wcel vx cv cT cfv vw cv cT cfv cD co cT cU cW cnmo co cfv vx cv
      vw cv cC co cmul co cle wbr cT cU cW c0o co wne cT cB wcel vx cv cU cba
      cfv wcel vw cv cU cba cfv wcel vx cv cT cfv vw cv cT cfv cD co cT cU cW
      cnmo co cfv vx cv vw cv cC co cmul co cle wbr cB cC cD vx cv vw cv cT cU
      cU cW cnmo co cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid
      blocni.8 blocni.d cU cW cnmo co eqid blocni.5 blocni.u blocni.w blometi
      3expa adantllr adantlr vx cv cT cfv vw cv cT cfv cD co cr wcel cT cU cW
      cnmo co cfv vx cv vw cv cC co cmul co cr wcel vy cv cr wcel vx cv cT cfv
      vw cv cT cfv cD co cT cU cW cnmo co cfv vx cv vw cv cC co cmul co cle wbr
      cT cU cW cnmo co cfv vx cv vw cv cC co cmul co vy cv clt wbr wa vx cv cT
      cfv vw cv cT cfv cD co vy cv clt wbr wi cT cB wcel cT cU cW c0o co wne wa
      vx cv cU cba cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa vw cv cU
      cba cfv wcel wa vx cv cT cfv vw cv cT cfv cD co cT cU cW cnmo co cfv vx
      cv vw cv cC co cmul co vy cv lelttr cT cB wcel cT cU cW c0o co wne wa vx
      cv cU cba cfv wcel wa vw cv cU cba cfv wcel vx cv cT cfv vw cv cT cfv cD
      co cr wcel vy cv cr wcel cc0 vy cv clt wbr wa vx cv cU cba cfv wcel vw cv
      cU cba cfv wcel vx cv cT cfv vw cv cT cfv cD co cr wcel cT cB wcel cT cU
      cW c0o co wne wa vx cv cT cfv cW cba cfv wcel vw cv cT cfv cW cba cfv
      wcel vx cv cT cfv vw cv cT cfv cD co cr wcel vx cv cU cba cfv wcel vw cv
      cU cba cfv wcel cD cme wcel vx cv cT cfv cW cba cfv wcel vw cv cT cfv cW
      cba cfv wcel vx cv cT cfv vw cv cT cfv cD co cr wcel cW cnv wcel cD cme
      wcel blocni.w cD cW blocni.d imsmet ax-mp vx cv cT cfv vw cv cT cfv cD cW
      cba cfv cD cW cW cba cfv cW cba cfv eqid blocni.d blocni.w imsbai metcl
      mp3an1 cU cba cfv cW cba cfv vx cv cT cU cnv wcel cW cnv wcel cT cL wcel
      cU cba cfv cW cba cfv cT wf blocni.u blocni.w blocni.l cT cU cL cW cU cba
      cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid blocni.4 lnof mp3an
      ffvelrni cU cba cfv cW cba cfv vw cv cT cU cnv wcel cW cnv wcel cT cL
      wcel cU cba cfv cW cba cfv cT wf blocni.u blocni.w blocni.l cT cU cL cW
      cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv eqid blocni.4 lnof mp3an
      ffvelrni syl2an adantll adantlr cT cB wcel cT cU cW c0o co wne wa vx cv
      cU cba cfv wcel wa vw cv cU cba cfv wcel cT cU cW cnmo co cfv vx cv vw cv
      cC co cmul co cr wcel vy cv cr wcel cc0 vy cv clt wbr wa cT cB wcel vx cv
      cU cba cfv wcel vw cv cU cba cfv wcel cT cU cW cnmo co cfv vx cv vw cv cC
      co cmul co cr wcel cT cU cW c0o co wne cT cB wcel vx cv cU cba cfv wcel
      vw cv cU cba cfv wcel cT cU cW cnmo co cfv vx cv vw cv cC co cmul co cr
      wcel cT cU cW cnmo co cfv cr wcel vx cv vw cv cC co cr wcel cT cU cW cnmo
      co cfv vx cv vw cv cC co cmul co cr wcel cT cB wcel vx cv cU cba cfv wcel
      vw cv cU cba cfv wcel wa cT cU cW cnmo co cfv vx cv vw cv cC co remulcl
      cU cnv wcel cW cnv wcel cT cB wcel cT cU cW cnmo co cfv cr wcel blocni.u
      blocni.w cB cT cU cU cW cnmo co cW cU cba cfv cW cba cfv cU cba cfv eqid
      cW cba cfv eqid cU cW cnmo co eqid blocni.5 nmblore mp3an12 cC cme wcel
      vx cv cU cba cfv wcel vw cv cU cba cfv wcel vx cv vw cv cC co cr wcel cU
      cnv wcel cC cme wcel blocni.u cC cU blocni.8 imsmet ax-mp vx cv vw cv cC
      cU cba cfv cC cU cU cba cfv cU cba cfv eqid blocni.8 blocni.u imsbai
      metcl mp3an1 syl2an anassrs adantllr adantlr cT cB wcel cT cU cW c0o co
      wne wa vx cv cU cba cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr wa wa vy
      cv cr wcel vw cv cU cba cfv wcel cT cB wcel cT cU cW c0o co wne wa vx cv
      cU cba cfv wcel wa vy cv cr wcel cc0 vy cv clt wbr simprl adantr syl3anc
      mpand imp syldan exp31 r19.21aiv jca sylanc exp32 r19.21aiv r19.21aiva cU
      cnv wcel cW cnv wcel cT cL wcel cU cba cfv cW cba cfv cT wf blocni.u
      blocni.w blocni.l cT cU cL cW cU cba cfv cW cba cfv cU cba cfv eqid cW
      cba cfv eqid blocni.4 lnof mp3an jctil cC cme wcel cD cme wcel cT cJ cK
      ccn co wcel cU cba cfv cW cba cfv cT wf cc0 vy cv clt wbr cc0 vz cv clt
      wbr vx cv vw cv cC co vz cv clt wbr vx cv cT cfv vw cv cT cfv cD co vy cv
      clt wbr wi vw cU cba cfv wral wa vz cr wrex wi vy cr wral vx cU cba cfv
      wral wa wb cU cnv wcel cC cme wcel blocni.u cC cU blocni.8 imsmet ax-mp
      cW cnv wcel cD cme wcel blocni.w cD cW blocni.d imsmet ax-mp vx vy vz vw
      cC cD cT cJ cK cU cba cfv cW cba cfv cC cU cU cba cfv cU cba cfv eqid
      blocni.8 blocni.u imsbai blocni.j cD cW cW cba cfv cW cba cfv eqid
      blocni.d blocni.w imsbai blocni.k metcn mp2an sylibr cU cW c0o co cJ cK
      ccn co wcel cT cB wcel cU cW c0o co cU cba cfv cW cn0v cfv csn cxp cJ cK
      ccn co cU cnv wcel cW cnv wcel cU cW c0o co cU cba cfv cW cn0v cfv csn
      cxp wceq blocni.u blocni.w cU cU cW c0o co cW cU cba cfv cW cn0v cfv cU
      cba cfv eqid cW cn0v cfv eqid cU cW c0o co eqid 0ofval mp2an cC cme wcel
      cD cme wcel wa cW cn0v cfv cW cba cfv wcel cU cba cfv cW cn0v cfv csn cU
      cba cfv cW cn0v cfv csn cxp wf wa cU cba cfv cW cn0v cfv csn cxp cJ cK
      ccn co wcel cC cme wcel cD cme wcel cU cnv wcel cC cme wcel blocni.u cC
      cU blocni.8 imsmet ax-mp cW cnv wcel cD cme wcel blocni.w cD cW blocni.d
      imsmet ax-mp pm3.2i cW cn0v cfv cW cba cfv wcel cU cba cfv cW cn0v cfv
      csn cU cba cfv cW cn0v cfv csn cxp wf cW cnv wcel cW cn0v cfv cW cba cfv
      wcel blocni.w cW cW cba cfv cW cn0v cfv cW cba cfv eqid cW cn0v cfv eqid
      nvzcl ax-mp cU cba cfv cW cn0v cfv cW cn0v fvex fconst pm3.2i cW cn0v cfv
      cC cD cU cba cfv cW cn0v cfv csn cxp cJ cK cU cba cfv cW cba cfv cC cU cU
      cba cfv cU cba cfv eqid blocni.8 blocni.u imsbai cD cW cW cba cfv cW cba
      cfv eqid blocni.d blocni.w imsbai blocni.j blocni.k metcnconst mp2an
      eqeltri a1i pm2.61ne impbii $.
      $( [5-Jan-2008] $) $( [18-Dec-2007] $)

    ${
      lnocni.1 $e |- X = ( BaseSet ` U ) $.
      $( If a linear operator is continuous at any point, it is continuous
         everywhere.  Theorem 2.7-9(b) of [Kreyszig] p. 97.   $)
      lnocni $p |- ( ( P e. X /\ T e. ( ( J CnP K ) ` P ) ) ->
                T e. ( J Cn K ) ) $=
        cP cX wcel cT cP cJ cK ccnp co cfv wcel wa cT cB wcel cT cJ cK ccn co
        wcel cB cC cD cP cT cU cJ cK cL cW cX blocni.8 blocni.d blocni.j
        blocni.k blocni.4 blocni.5 blocni.u blocni.w blocni.l lnocni.1
        blocnilem cB cC cD cT cU cJ cK cL cW blocni.8 blocni.d blocni.j
        blocni.k blocni.4 blocni.5 blocni.u blocni.w blocni.l blocni sylibr $.
        $( [22-Feb-2008] $) $( [18-Dec-2007] $)
    $}
  $}

  ${
    blocn.8 $e |- C = ( IndMet ` U ) $.
    blocn.d $e |- D = ( IndMet ` W ) $.
    blocn.j $e |- J = ( Open ` C ) $.
    blocn.k $e |- K = ( Open ` D ) $.
    blocn.5 $e |- B = ( U BLnOp W ) $.
    blocn.u $e |- U e. NrmCVec $.
    blocn.w $e |- W e. NrmCVec $.
    ${
      blocn.4 $e |- L = ( U LnOp W ) $.
      $( A linear operator is continuous iff it is bounded.  Theorem 2.7-9(a)
         of [Kreyszig] p. 97. $)
      blocn $p |- ( T e. L -> ( T e. ( J Cn K ) <-> T e. B ) ) $=
        cT cL wcel cT cJ cK ccn co wcel cT cB wcel wb cT cL wcel cT cU cW c0o
        co cif cJ cK ccn co wcel cT cL wcel cT cU cW c0o co cif cB wcel wb cT
        cU cW c0o co cT cT cL wcel cT cU cW c0o co cif wceq cT cJ cK ccn co
        wcel cT cL wcel cT cU cW c0o co cif cJ cK ccn co wcel cT cB wcel cT cL
        wcel cT cU cW c0o co cif cB wcel cT cT cL wcel cT cU cW c0o co cif cJ
        cK ccn co eleq1 cT cT cL wcel cT cU cW c0o co cif cB eleq1 bibi12d cB
        cC cD cT cL wcel cT cU cW c0o co cif cU cJ cK cL cW blocn.8 blocn.d
        blocn.j blocn.k blocn.4 blocn.5 blocn.u blocn.w cT cU cW c0o co cL cU
        cnv wcel cW cnv wcel cU cW c0o co cL wcel blocn.u blocn.w cU cL cW cU
        cW c0o co cU cW c0o co eqid blocn.4 0lno mp2an elimel blocni dedth $.
        $( [6-Jan-2008] $) $( [25-Dec-2007] $)
    $}

    $( A bounded linear operator is continuous. $)
    blocn2 $p |- ( T e. B -> T e. ( J Cn K ) ) $=
      cT cU cW clno co wcel cT cB wcel cT cJ cK ccn co wcel cU cnv wcel cW cnv
      wcel cT cB wcel cT cU cW clno co wcel blocn.u blocn.w cB cT cU cU cW clno
      co cW cU cW clno co eqid blocn.5 bloln mp3an12 cT cU cW clno co wcel cT
      cJ cK ccn co wcel cT cB wcel cB cC cD cT cU cJ cK cU cW clno co cW
      blocn.8 blocn.d blocn.j blocn.k blocn.5 blocn.u blocn.w cU cW clno co
      eqid blocn biimprd mpcom $.
      $( [9-Jan-2008] $) $( [25-Dec-2007] $)
  $}

  ${
    $d a u w P $.  $d a w Q $.  $d a s t u w x y U $.  $d a s t u w x y W $.
    $d a s t u w x X $.  $d a s t w y Y $.
    ajfval.1 $e |- X = ( BaseSet ` U ) $.
    ajfval.2 $e |- Y = ( BaseSet ` W ) $.
    ajfval.3 $e |- P = ( .i ` U ) $.
    ajfval.4 $e |- Q = ( .i ` W ) $.
    ajfval.5 $e |- A = ( U adj W ) $.
    $( The adjoint function. $)
    ajfval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> A =
     { <. t , s >. | ( t : X --> Y /\ s : Y --> X /\ A. x e. X A. y e. Y
    ( ( t ` x ) Q y ) = ( x P ( s ` y ) ) ) } ) $=
      cU cnv wcel cW cnv wcel wa cU cW caj co cX cY vt cv wf cY cX vs cv wf vx
      cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx
      cX wral w3a vt vs copab cA vu vw va cU cW cnv cnv vu cv cba cfv vw cv cba
      cfv vt cv wf vw cv cba cfv vu cv cba cfv vs cv wf vx cv vt cv cfv vy cv
      vw cv cip cfv co vx cv vy cv vs cv cfv vu cv cip cfv co wceq vy vw cv cba
      cfv wral vx vu cv cba cfv wral w3a vt vs copab cX cY vt cv wf cY cX vs cv
      wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY
      wral vx cX wral w3a vt vs copab caj cX vw cv cba cfv vt cv wf vw cv cba
      cfv cX vs cv wf vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv vs cv
      cfv cP co wceq vy vw cv cba cfv wral vx cX wral w3a vt vs copab cX cY vt
      cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP
      co wceq vy cY wral vx cX wral w3a vt vs copab cX cY vt cv wf cY cX vs cv
      wf wa vt vs copab cX cY vt cv wf cY cX vs cv wf wa vt vs copab cY cX cm
      co cX cY cm co cxp cvv cY cX cm co cX cY cm co cxp vt cv cY cX cm co wcel
      vs cv cX cY cm co wcel wa vt vs copab cX cY vt cv wf cY cX vs cv wf wa vt
      vs copab vt vs cY cX cm co cX cY cm co df-xp vt cv cY cX cm co wcel vs cv
      cX cY cm co wcel wa cX cY vt cv wf cY cX vs cv wf wa vt vs vt cv cY cX cm
      co wcel cX cY vt cv wf vs cv cX cY cm co wcel cY cX vs cv wf cY cX vt cv
      cY cW cba cfv cvv ajfval.2 cW cba fvex eqeltri cX cU cba cfv cvv ajfval.1
      cU cba fvex eqeltri elmap cX cY vs cv cX cU cba cfv cvv ajfval.1 cU cba
      fvex eqeltri cY cW cba cfv cvv ajfval.2 cW cba fvex eqeltri elmap anbi12i
      opabbii eqtr2i cY cX cm co cX cY cm co cY cX cm oprex cX cY cm oprex xpex
      eqeltri cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv
      vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a cX cY vt cv wf cY cX
      vs cv wf wa vt vs cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ
      co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral 3simpa ssopab2i
      ssexi vu cv cU wceq vu cv cba cfv vw cv cba cfv vt cv wf vw cv cba cfv vu
      cv cba cfv vs cv wf vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv vs
      cv cfv vu cv cip cfv co wceq vy vw cv cba cfv wral vx vu cv cba cfv wral
      w3a cX vw cv cba cfv vt cv wf vw cv cba cfv cX vs cv wf vx cv vt cv cfv
      vy cv vw cv cip cfv co vx cv vy cv vs cv cfv cP co wceq vy vw cv cba cfv
      wral vx cX wral w3a vt vs vu cv cU wceq vu cv cba cfv vw cv cba cfv vt cv
      wf cX vw cv cba cfv vt cv wf vw cv cba cfv vu cv cba cfv vs cv wf vw cv
      cba cfv cX vs cv wf vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv vs
      cv cfv vu cv cip cfv co wceq vy vw cv cba cfv wral vx vu cv cba cfv wral
      vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv vs cv cfv cP co wceq
      vy vw cv cba cfv wral vx cX wral vu cv cU wceq vu cv cba cfv cX wceq vu
      cv cba cfv vw cv cba cfv vt cv wf cX vw cv cba cfv vt cv wf wb vu cv cU
      wceq vu cv cba cfv cU cba cfv cX vu cv cU cba fveq2 ajfval.1 syl6eqr vu
      cv cba cfv cX vw cv cba cfv vt cv feq2 syl vu cv cU wceq vu cv cba cfv cX
      wceq vw cv cba cfv vu cv cba cfv vs cv wf vw cv cba cfv cX vs cv wf wb vu
      cv cU wceq vu cv cba cfv cU cba cfv cX vu cv cU cba fveq2 ajfval.1
      syl6eqr vu cv cba cfv cX vw cv cba cfv vs cv feq3 syl vu cv cU wceq vx cv
      vt cv cfv vy cv vw cv cip cfv co vx cv vy cv vs cv cfv vu cv cip cfv co
      wceq vy vw cv cba cfv wral vx cv vt cv cfv vy cv vw cv cip cfv co vx cv
      vy cv vs cv cfv cP co wceq vy vw cv cba cfv wral vx vu cv cba cfv cX vu
      cv cU wceq vu cv cba cfv cU cba cfv cX vu cv cU cba fveq2 ajfval.1
      syl6eqr vu cv cU wceq vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv
      vs cv cfv vu cv cip cfv co wceq vx cv vt cv cfv vy cv vw cv cip cfv co vx
      cv vy cv vs cv cfv cP co wceq vy vw cv cba cfv vu cv cU wceq vx cv vy cv
      vs cv cfv vu cv cip cfv co vx cv vy cv vs cv cfv cP co vx cv vt cv cfv vy
      cv vw cv cip cfv co vu cv cU wceq vu cv cip cfv cP vx cv vy cv vs cv cfv
      vu cv cU wceq vu cv cip cfv cU cip cfv cP vu cv cU cip fveq2 ajfval.3
      syl6eqr opreqd eqeq2d ralbidv raleq12d 3anbi123d opabbidv vw cv cW wceq
      cX vw cv cba cfv vt cv wf vw cv cba cfv cX vs cv wf vx cv vt cv cfv vy cv
      vw cv cip cfv co vx cv vy cv vs cv cfv cP co wceq vy vw cv cba cfv wral
      vx cX wral w3a cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co
      vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs vw cv cW
      wceq cX vw cv cba cfv vt cv wf cX cY vt cv wf vw cv cba cfv cX vs cv wf
      cY cX vs cv wf vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv vs cv
      cfv cP co wceq vy vw cv cba cfv wral vx cX wral vx cv vt cv cfv vy cv cQ
      co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral vw cv cW wceq
      vw cv cba cfv cY wceq cX vw cv cba cfv vt cv wf cX cY vt cv wf wb vw cv
      cW wceq vw cv cba cfv cW cba cfv cY vw cv cW cba fveq2 ajfval.2 syl6eqr
      vw cv cba cfv cY cX vt cv feq3 syl vw cv cW wceq vw cv cba cfv cY wceq vw
      cv cba cfv cX vs cv wf cY cX vs cv wf wb vw cv cW wceq vw cv cba cfv cW
      cba cfv cY vw cv cW cba fveq2 ajfval.2 syl6eqr vw cv cba cfv cY cX vs cv
      feq2 syl vw cv cW wceq vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vy cv
      vs cv cfv cP co wceq vy vw cv cba cfv wral vx cv vt cv cfv vy cv cQ co vx
      cv vy cv vs cv cfv cP co wceq vy cY wral vx cX vw cv cW wceq vx cv vt cv
      cfv vy cv vw cv cip cfv co vx cv vy cv vs cv cfv cP co wceq vx cv vt cv
      cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy vw cv cba cfv cY vw
      cv cW wceq vw cv cba cfv cW cba cfv cY vw cv cW cba fveq2 ajfval.2
      syl6eqr vw cv cW wceq vx cv vt cv cfv vy cv vw cv cip cfv co vx cv vt cv
      cfv vy cv cQ co vx cv vy cv vs cv cfv cP co vw cv cW wceq vw cv cip cfv
      cQ vx cv vt cv cfv vy cv vw cv cW wceq vw cv cip cfv cW cip cfv cQ vw cv
      cW cip fveq2 ajfval.4 syl6eqr opreqd eqeq1d raleq12d ralbidv 3anbi123d
      opabbidv vx vy vw vu vt vs va df-aj oprabval2 ajfval.5 syl5eq $.
      $( [8-Feb-2008] $) $( [25-Jan-2008] $)
  $}

  ${
    $d o t u A $.  $d t T $.  $d o t u U $.
    hmoval.8 $e |- H = ( HmOp ` U ) $.
    hmoval.9 $e |- A = ( U adj U ) $.
    $( The set of Hermitian (self-adjoint) operators on a normed complex
       vector space. $)
    hmoval $p |- ( U e. NrmCVec -> H = { t e. dom A | ( A ` t ) = t } ) $=
      cU cnv wcel cU chmo cfv vt cv cA cfv vt cv wceq vt cA cdm crab cH vu vo
      cU vt cv vu cv vu cv caj co cfv vt cv wceq vt vu cv vu cv caj co cdm crab
      vt cv cA cfv vt cv wceq vt cA cdm crab cnv chmo vu cv cU wceq vt cv vu cv
      vu cv caj co cfv vt cv wceq vt vu cv vu cv caj co cdm crab vt cv vu cv vu
      cv caj co cfv vt cv wceq vt cA cdm crab vt cv cA cfv vt cv wceq vt cA cdm
      crab vu cv cU wceq vu cv vu cv caj co cdm cA cdm wceq vt cv vu cv vu cv
      caj co cfv vt cv wceq vt vu cv vu cv caj co cdm crab vt cv vu cv vu cv
      caj co cfv vt cv wceq vt cA cdm crab wceq vu cv cU wceq vu cv vu cv caj
      co cA vu cv cU wceq vu cv vu cv caj co cU cU caj co cA vu cv cU wceq vu
      cv vu cv caj co cU cU caj co wceq vu cv cU vu cv cU caj opreq12 anidms
      hmoval.9 syl6eqr dmeqd vt cv vu cv vu cv caj co cfv vt cv wceq vt vu cv
      vu cv caj co cdm cA cdm rabeq syl vu cv cU wceq vt cv vu cv vu cv caj co
      cfv vt cv wceq vt cv cA cfv vt cv wceq vt cA cdm vu cv cU wceq vt cv vu
      cv vu cv caj co cfv vt cv cA cfv vt cv vu cv cU wceq vt cv vu cv vu cv
      caj co cA vu cv cU wceq vu cv vu cv caj co cU cU caj co cA vu cv cU wceq
      vu cv vu cv caj co cU cU caj co wceq vu cv cU vu cv cU caj opreq12 anidms
      hmoval.9 syl6eqr fveq1d eqeq1d rabbisdv eqtrd vu vt vo df-hmo vt cv cA
      cfv vt cv wceq vt cA cdm cA cA cU cU caj co cvv hmoval.9 cU cU caj oprex
      eqeltri dmex rabex fvopab4 hmoval.8 syl5eq $.
      $( [18-Feb-2008] $) $( [26-Jan-2008] $)

    $( The predicate "is a hermitian operator." $)
    ishmo $p |- ( U e. NrmCVec ->
      ( T e. H <-> ( T e. dom A /\ ( A ` T ) = T ) ) ) $=
      cU cnv wcel cT cH wcel cT vt cv cA cfv vt cv wceq vt cA cdm crab wcel cT
      cA cdm wcel cT cA cfv cT wceq wa cU cnv wcel cH vt cv cA cfv vt cv wceq
      vt cA cdm crab cT vt cA cU cH hmoval.8 hmoval.9 hmoval eleq2d vt cv cA
      cfv vt cv wceq cT cA cfv cT wceq vt cT cA cdm vt cv cT wceq vt cv cA cfv
      cT cA cfv vt cv cT vt cv cT cA fveq2 vt cv cT wceq id eqeq12d elrab
      syl6bb $.
      $( [29-Apr-2009] $) $( [26-Jan-2008] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                    Inner product (pre-Hilbert) spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CPreHil $.

  $( Extend class notation with the class of all complex inner product spaces
     (also called pre-Hilbert spaces). $)
  cphl $a class CPreHil $.

  ${
    $d g n s w x y $.
    $( Define the class of all complex inner product spaces.  An inner product
       space is a normed vector space whose norm satisfies the parallelogram
       law (a property that induces an inner product).  Based on Exercise 4(b)
       of [ReedSimon] p. 63.  The vector operation is ` g ` , the scalar
       product is ` s ` , and the norm is ` n ` .  An inner product space is
       also called a pre-Hilbert space. $)
    df-ph $a |- CPreHil = ( NrmCVec i^i { <. <. g , s >. , n >. |
          A. x e. ran g A. y e. ran g
       ( ( ( n ` ( x g y ) ) ^ 2 ) + ( ( n ` ( x g ( -u 1 s y ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( n ` x ) ^ 2 ) + ( ( n ` y ) ^ 2 ) ) ) } ) $.

    $( Every complex inner product space is a normed complex vector space. $)
    phnv $p |- ( U e. CPreHil -> U e. NrmCVec ) $=
      cphl cnv cU cphl cnv vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1
      cneg vy cv vs cv co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv
      cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv
      crn wral vx vg cv crn wral vg vs vn copab2 cin cnv vx vy vg vn vs df-ph
      cnv vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv
      co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co
      vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn wral vx vg
      cv crn wral vg vs vn copab2 inss1 eqsstri sseli $.
      $( [12-Apr-2007] $) $( [2-Apr-2007] $)

    $( The class of all complex inner product spaces is a relation. $)
    phrel $p |- Rel CPreHil $=
      cphl cnv wss cnv wrel cphl wrel vx cphl cnv vx cv phnv ssriv nvrel cphl
      cnv relss mp2 $.
      $( [18-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    phnvi.1 $e |- U e. CPreHil $.
    $( Every complex inner product space is a normed complex vector space. $)
    phnvi $p |- U e. NrmCVec $=
      cU cphl wcel cU cnv wcel phnvi.1 cU phnv ax-mp $.
      $( [22-Nov-2007] $) $( [20-Nov-2007] $)
  $}

  ${
    $d g n s x y G $.  $d g n s x y N $.  $d g n s x y S $.  $d g n s x y X $.
    $d g n s Z $.
    isphg.1 $e |- X = ran G $.
    $( The predicate "is a complex inner product space."  An inner product
       space is a normed vector space whose norm satisfies the parallelogram
       law.  The vector (group) addition operation is ` G ` , the scalar
       product is ` S ` , and the norm is ` N ` .  An inner product space is
       also called a pre-Hilbert space. $)
    isphg $p |- ( ( G e. A /\ S e. B /\ N e. C ) ->
  ( <. <. G , S >. , N >. e. CPreHil <-> ( <. <. G , S >. , N >. e. NrmCVec /\
          A. x e. X A. y e. X
      ( ( ( N ` ( x G y ) ) ^ 2 ) + ( ( N ` ( x G ( -u 1 S y ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` x ) ^ 2 ) + ( ( N ` y ) ^ 2 ) ) ) ) ) ) $=
      cG cA wcel cS cB wcel cN cC wcel w3a cG cS cop cN cop cnv wcel cG cS cop
      cN cop vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs
      cv co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp
      co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn wral vx
      vg cv crn wral vg vs vn copab2 wcel wa cG cS cop cN cop cnv wcel vx cv vy
      cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp
      co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co
      cmul co wceq vy cX wral vx cX wral wa cG cS cop cN cop cphl wcel cG cA
      wcel cS cB wcel cN cC wcel w3a cG cS cop cN cop vx cv vy cv vg cv co vn
      cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv co vg cv co vn cv cfv c2 cexp
      co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co
      caddc co cmul co wceq vy vg cv crn wral vx vg cv crn wral vg vs vn copab2
      wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co
      cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2
      cexp co caddc co cmul co wceq vy cX wral vx cX wral cG cS cop cN cop cnv
      wcel vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv
      co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co
      vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn wral vx vg
      cv crn wral vx cv vy cv cG co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs
      cv co cG co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co
      vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral vx
      cv vy cv cG co vn cv cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co vn cv
      cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2
      cexp co caddc co cmul co wceq vy cX wral vx cX wral vx cv vy cv cG co cN
      cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc co
      c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq
      vy cX wral vx cX wral vg vs vn cG cS cN cA cB cC vg cv cG wceq vx cv vy
      cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv co vg cv co vn
      cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv
      c2 cexp co caddc co cmul co wceq vy vg cv crn wral vx cv vy cv cG co vn
      cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv co cG co vn cv cfv c2 cexp co
      caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc
      co cmul co wceq vy cX wral vx vg cv crn cX vg cv cG wceq vg cv crn cG crn
      cX vg cv cG rneq isphg.1 syl6eqr vg cv cG wceq vx cv vy cv vg cv co vn cv
      cfv c2 cexp co vx cv c1 cneg vy cv vs cv co vg cv co vn cv cfv c2 cexp co
      caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc
      co cmul co wceq vx cv vy cv cG co vn cv cfv c2 cexp co vx cv c1 cneg vy
      cv vs cv co cG co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2
      cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn cX
      vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq isphg.1 syl6eqr vg cv cG
      wceq vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv
      co vg cv co vn cv cfv c2 cexp co caddc co vx cv vy cv cG co vn cv cfv c2
      cexp co vx cv c1 cneg vy cv vs cv co cG co vn cv cfv c2 cexp co caddc co
      c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co
      vg cv cG wceq vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv vy cv cG co
      vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv co vg cv co vn cv cfv c2
      cexp co vx cv c1 cneg vy cv vs cv co cG co vn cv cfv c2 cexp co caddc vg
      cv cG wceq vx cv vy cv vg cv co vn cv cfv vx cv vy cv cG co vn cv cfv c2
      cexp vg cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG co vn cv vx cv vy
      cv vg cv cG opreq fveq2d opreq1d vg cv cG wceq vx cv c1 cneg vy cv vs cv
      co vg cv co vn cv cfv vx cv c1 cneg vy cv vs cv co cG co vn cv cfv c2
      cexp vg cv cG wceq vx cv c1 cneg vy cv vs cv co vg cv co vx cv c1 cneg vy
      cv vs cv co cG co vn cv vx cv c1 cneg vy cv vs cv co vg cv cG opreq
      fveq2d opreq1d opreq12d eqeq1d raleq12d raleq12d vs cv cS wceq vx cv vy
      cv cG co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv co cG co vn cv
      cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2
      cexp co caddc co cmul co wceq vx cv vy cv cG co vn cv cfv c2 cexp co vx
      cv c1 cneg vy cv cS co cG co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv
      cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vx vy cX
      cX vs cv cS wceq vx cv vy cv cG co vn cv cfv c2 cexp co vx cv c1 cneg vy
      cv vs cv co cG co vn cv cfv c2 cexp co caddc co vx cv vy cv cG co vn cv
      cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co vn cv cfv c2 cexp co caddc
      co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc co cmul
      co vs cv cS wceq vx cv c1 cneg vy cv vs cv co cG co vn cv cfv c2 cexp co
      vx cv c1 cneg vy cv cS co cG co vn cv cfv c2 cexp co vx cv vy cv cG co vn
      cv cfv c2 cexp co caddc vs cv cS wceq vx cv c1 cneg vy cv vs cv co cG co
      vn cv cfv vx cv c1 cneg vy cv cS co cG co vn cv cfv c2 cexp vs cv cS wceq
      vx cv c1 cneg vy cv vs cv co cG co vx cv c1 cneg vy cv cS co cG co vn cv
      vs cv cS wceq c1 cneg vy cv vs cv co c1 cneg vy cv cS co vx cv cG c1 cneg
      vy cv vs cv cS opreq opreq2d fveq2d opreq1d opreq2d eqeq1d 2ralbidv vn cv
      cN wceq vx cv vy cv cG co vn cv cfv c2 cexp co vx cv c1 cneg vy cv cS co
      cG co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv
      vn cv cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cv vy cv cG co
      cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc
      co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co
      wceq vy cX wral vx cX vn cv cN wceq vx cv vy cv cG co vn cv cfv c2 cexp
      co vx cv c1 cneg vy cv cS co cG co vn cv cfv c2 cexp co caddc co c2 vx cv
      vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vx
      cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv
      c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co
      caddc co cmul co wceq vy cX vn cv cN wceq vx cv vy cv cG co vn cv cfv c2
      cexp co vx cv c1 cneg vy cv cS co cG co vn cv cfv c2 cexp co caddc co vx
      cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv
      c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp
      co caddc co cmul co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co
      caddc co cmul co vn cv cN wceq vx cv vy cv cG co vn cv cfv c2 cexp co vx
      cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co vn cv
      cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc vn
      cv cN wceq vx cv vy cv cG co vn cv cfv vx cv vy cv cG co cN cfv c2 cexp
      vx cv vy cv cG co vn cv cN fveq1 opreq1d vn cv cN wceq vx cv c1 cneg vy
      cv cS co cG co vn cv cfv vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp
      vx cv c1 cneg vy cv cS co cG co vn cv cN fveq1 opreq1d opreq12d vn cv cN
      wceq vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp co caddc co vx cv
      cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co c2 cmul vn cv cN wceq
      vx cv vn cv cfv c2 cexp co vx cv cN cfv c2 cexp co vy cv vn cv cfv c2
      cexp co vy cv cN cfv c2 cexp co caddc vn cv cN wceq vx cv vn cv cfv vx cv
      cN cfv c2 cexp vx cv vn cv cN fveq1 opreq1d vn cv cN wceq vy cv vn cv cfv
      vy cv cN cfv c2 cexp vy cv vn cv cN fveq1 opreq1d opreq12d opreq2d
      eqeq12d ralbidv ralbidv eloprabg anbi2d cG cS cop cN cop cphl wcel cG cS
      cop cN cop cnv vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy
      cv vs cv co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2
      cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn
      wral vx vg cv crn wral vg vs vn copab2 cin wcel cG cS cop cN cop cnv wcel
      cG cS cop cN cop vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg
      vy cv vs cv co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv
      c2 cexp co vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn
      wral vx vg cv crn wral vg vs vn copab2 wcel wa cphl cnv vx cv vy cv vg cv
      co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv co vg cv co vn cv cfv
      c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co vy cv vn cv cfv c2 cexp
      co caddc co cmul co wceq vy vg cv crn wral vx vg cv crn wral vg vs vn
      copab2 cin cG cS cop cN cop vx vy vg vn vs df-ph eleq2i cG cS cop cN cop
      cnv vx cv vy cv vg cv co vn cv cfv c2 cexp co vx cv c1 cneg vy cv vs cv
      co vg cv co vn cv cfv c2 cexp co caddc co c2 vx cv vn cv cfv c2 cexp co
      vy cv vn cv cfv c2 cexp co caddc co cmul co wceq vy vg cv crn wral vx vg
      cv crn wral vg vs vn copab2 elin bitri syl5bb $.
      $( [20-Apr-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    phop.2 $e |- G = ( +v ` U ) $.
    phop.4 $e |- S = ( .s ` U ) $.
    phop.6 $e |- N = ( norm ` U ) $.
    $( A complex inner product space in terms of ordered pair components. $)
    phop $p |- ( U e. CPreHil -> U = <. <. G , S >. , N >. ) $=
      cU cphl wcel cU cU c1st cfv cU c2nd cfv cop cG cS cop cN cop cphl wrel cU
      cphl wcel cU cU c1st cfv cU c2nd cfv cop wceq phrel cU cphl 1st2nd mpan
      cU cphl wcel cU c1st cfv cN cop cG cS cop cN cop cU c1st cfv cU c2nd cfv
      cop cU cphl wcel cU c1st cfv cG cS cop cN cU cphl wcel cU cnv wcel cU
      c1st cfv cvc wcel cU c1st cfv cG cS cop wceq cU phnv cU cU c1st cfv cU
      c1st cfv eqid nvvc cU c1st cfv cvc wcel cU c1st cfv cU c1st cfv c1st cfv
      cU c1st cfv c2nd cfv cop cG cS cop cvc wrel cU c1st cfv cvc wcel cU c1st
      cfv cU c1st cfv c1st cfv cU c1st cfv c2nd cfv cop wceq vcrel cU c1st cfv
      cvc 1st2nd mpan cG cU c1st cfv c1st cfv cS cU c1st cfv c2nd cfv cU cG
      phop.2 vafval cS cU phop.4 smfval opeq12i syl6eqr 3syl opeq1d cN cU c2nd
      cfv cU c1st cfv cU cN phop.6 nmfval opeq2i syl5eqr eqtrd $.
      $( [26-Sep-2007] $) $( [2-Apr-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of pre-Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    cnph.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is an inner product (pre-Hilbert) space.
       (Contributed by Steve Rodriguez, 28-Apr-2007; revised by nm
       24-Jul-2008.) $)
    cnph $p |- U e. CPreHil $=
      cU caddc cmul cop cabs cop cphl cnph.6 caddc cmul cop cabs cop cphl wcel
      caddc cmul cop cabs cop cnv wcel vx cv vy cv caddc co cabs cfv c2 cexp co
      vx cv c1 cneg vy cv cmul co caddc co cabs cfv c2 cexp co caddc co c2 vx
      cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co cmul co wceq vy
      cc wral vx cc wral caddc cvv wcel cmul cvv wcel cabs cvv wcel caddc cmul
      cop cabs cop cphl wcel caddc cmul cop cabs cop cnv wcel vx cv vy cv caddc
      co cabs cfv c2 cexp co vx cv c1 cneg vy cv cmul co caddc co cabs cfv c2
      cexp co caddc co c2 vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co
      caddc co cmul co wceq vy cc wral vx cc wral wa wb addex mulex vx vy cc vx
      cv vx cv ccj cfv cmul co csqr cfv cabs axcnex vx vy df-abs fopabex2 vx vy
      cvv cvv cvv cmul caddc cabs cc caddc cc caddc cabl wcel caddc cgr wcel
      cnaddabl caddc ablgrp ax-mp cc cc cxp cc caddc axaddopr fdmi grprn isphg
      mp3an caddc cmul cop cabs cop caddc cmul cop cabs cop eqid cnnv vx cv vy
      cv caddc co cabs cfv c2 cexp co vx cv c1 cneg vy cv cmul co caddc co cabs
      cfv c2 cexp co caddc co c2 vx cv cabs cfv c2 cexp co vy cv cabs cfv c2
      cexp co caddc co cmul co wceq vx vy cc vx cv cc wcel vy cv cc wcel wa vx
      cv vy cv caddc co cabs cfv c2 cexp co vx cv c1 cneg vy cv cmul co caddc
      co cabs cfv c2 cexp co caddc co vx cv vy cv caddc co cabs cfv c2 cexp co
      vx cv vy cv cmin co cabs cfv c2 cexp co caddc co vx cv cabs cfv c2 cexp
      co vy cv cabs cfv c2 cexp co caddc co vx cv cabs cfv c2 cexp co vy cv
      cabs cfv c2 cexp co caddc co caddc co c2 vx cv cabs cfv c2 cexp co vy cv
      cabs cfv c2 cexp co caddc co cmul co vx cv cc wcel vy cv cc wcel wa vx cv
      c1 cneg vy cv cmul co caddc co cabs cfv c2 cexp co vx cv vy cv cmin co
      cabs cfv c2 cexp co vx cv vy cv caddc co cabs cfv c2 cexp co caddc vx cv
      cc wcel vy cv cc wcel wa vx cv c1 cneg vy cv cmul co caddc co cabs cfv vx
      cv vy cv cmin co cabs cfv c2 cexp vx cv cc wcel vy cv cc wcel wa vx cv c1
      cneg vy cv cmul co caddc co vx cv vy cv cmin co cabs vx cv cc wcel vy cv
      cc wcel wa vx cv c1 cneg vy cv cmul co caddc co vx cv vy cv cneg caddc co
      vx cv vy cv cmin co vx cv cc wcel vy cv cc wcel wa c1 cneg vy cv cmul co
      vy cv cneg vx cv caddc vy cv cc wcel c1 cneg vy cv cmul co vy cv cneg
      wceq vx cv cc wcel vy cv mulm1 adantl opreq2d vx cv vy cv negsub eqtrd
      fveq2d opreq1d opreq2d vx cv cc wcel vy cv cc wcel wa vx cv vy cv caddc
      co cabs cfv c2 cexp co vx cv vy cv cmin co cabs cfv c2 cexp co caddc co
      vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co c2 vx cv vy
      cv ccj cfv cmul co cre cfv cmul co caddc co vx cv cabs cfv c2 cexp co vy
      cv cabs cfv c2 cexp co caddc co c2 vx cv vy cv ccj cfv cmul co cre cfv
      cmul co cmin co caddc co vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp
      co caddc co vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co
      caddc co vx cv cc wcel vy cv cc wcel wa vx cv vy cv caddc co cabs cfv c2
      cexp co vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co c2
      vx cv vy cv ccj cfv cmul co cre cfv cmul co caddc co vx cv vy cv cmin co
      cabs cfv c2 cexp co vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co
      caddc co c2 vx cv vy cv ccj cfv cmul co cre cfv cmul co cmin co caddc vx
      cv vy cv sqabsadd vx cv vy cv sqabssub opreq12d vx cv cabs cfv c2 cexp co
      vy cv cabs cfv c2 cexp co caddc co cc wcel c2 vx cv vy cv ccj cfv cmul co
      cre cfv cmul co cc wcel vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp
      co caddc co cc wcel vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co
      caddc co c2 vx cv vy cv ccj cfv cmul co cre cfv cmul co caddc co vx cv
      cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co c2 vx cv vy cv ccj
      cfv cmul co cre cfv cmul co cmin co caddc co vx cv cabs cfv c2 cexp co vy
      cv cabs cfv c2 cexp co caddc co vx cv cabs cfv c2 cexp co vy cv cabs cfv
      c2 cexp co caddc co caddc co wceq vx cv cc wcel vy cv cc wcel wa vx cv
      cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co c2 vx cv vy cv ccj
      cfv cmul co cre cfv cmul co vx cv cabs cfv c2 cexp co vy cv cabs cfv c2
      cexp co caddc co ppncan vx cv cabs cfv c2 cexp co cc wcel vy cv cabs cfv
      c2 cexp co cc wcel vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co
      caddc co cc wcel vx cv cc wcel vy cv cc wcel vx cv cabs cfv c2 cexp co vy
      cv cabs cfv c2 cexp co addcl vx cv cc wcel vx cv cabs cfv cc wcel vx cv
      cabs cfv c2 cexp co cc wcel vx cv cc wcel vx cv cabs cfv vx cv abscl
      recnd vx cv cabs cfv sqcl syl vy cv cc wcel vy cv cabs cfv cc wcel vy cv
      cabs cfv c2 cexp co cc wcel vy cv cc wcel vy cv cabs cfv vy cv abscl
      recnd vy cv cabs cfv sqcl syl syl2an vx cv cc wcel vy cv cc wcel wa vx cv
      vy cv ccj cfv cmul co cc wcel vx cv vy cv ccj cfv cmul co cre cfv cc wcel
      c2 vx cv vy cv ccj cfv cmul co cre cfv cmul co cc wcel vx cv cc wcel vy
      cv ccj cfv cc wcel vx cv vy cv ccj cfv cmul co cc wcel vy cv cc wcel vx
      cv vy cv ccj cfv mulcl vy cv cjcl sylan2 vx cv vy cv ccj cfv cmul co cc
      wcel vx cv vy cv ccj cfv cmul co cre cfv vx cv vy cv ccj cfv cmul co recl
      recnd c2 cc wcel vx cv vy cv ccj cfv cmul co cre cfv cc wcel c2 vx cv vy
      cv ccj cfv cmul co cre cfv cmul co cc wcel 2cn c2 vx cv vy cv ccj cfv
      cmul co cre cfv mulcl mpan 3syl vx cv cabs cfv c2 cexp co cc wcel vy cv
      cabs cfv c2 cexp co cc wcel vx cv cabs cfv c2 cexp co vy cv cabs cfv c2
      cexp co caddc co cc wcel vx cv cc wcel vy cv cc wcel vx cv cabs cfv c2
      cexp co vy cv cabs cfv c2 cexp co addcl vx cv cc wcel vx cv cabs cfv cc
      wcel vx cv cabs cfv c2 cexp co cc wcel vx cv cc wcel vx cv cabs cfv vx cv
      abscl recnd vx cv cabs cfv sqcl syl vy cv cc wcel vy cv cabs cfv cc wcel
      vy cv cabs cfv c2 cexp co cc wcel vy cv cc wcel vy cv cabs cfv vy cv
      abscl recnd vy cv cabs cfv sqcl syl syl2an syl3anc eqtrd vx cv cc wcel vy
      cv cc wcel wa vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc
      co cc wcel vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co
      vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co caddc co c2
      vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co cmul co wceq
      vx cv cabs cfv c2 cexp co cc wcel vy cv cabs cfv c2 cexp co cc wcel vx cv
      cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co cc wcel vx cv cc
      wcel vy cv cc wcel vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co
      addcl vx cv cc wcel vx cv cabs cfv cc wcel vx cv cabs cfv c2 cexp co cc
      wcel vx cv cc wcel vx cv cabs cfv vx cv abscl recnd vx cv cabs cfv sqcl
      syl vy cv cc wcel vy cv cabs cfv cc wcel vy cv cabs cfv c2 cexp co cc
      wcel vy cv cc wcel vy cv cabs cfv vy cv abscl recnd vy cv cabs cfv sqcl
      syl syl2an vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co
      cc wcel c2 vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co
      cmul co vx cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co vx
      cv cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co caddc co vx cv
      cabs cfv c2 cexp co vy cv cabs cfv c2 cexp co caddc co 2times eqcomd syl
      3eqtrd rgen2a mpbir2an eqeltri $.
      $( [25-Jul-2008] $) $( [28-Apr-2007] $)
  $}

  ${
    elimph.1 $e |- X = ( BaseSet ` U ) $.
    elimph.5 $e |- Z = ( 0v ` U ) $.
    elimph.6 $e |- U e. CPreHil $.
    $( MAY BE REVISED - use elimnvOLD ? $)
    $( Hypothesis elimination lemma for complex inner product spaces to assist
       weak deduction theorem. $)
    elimph $p |- if ( A e. X , A , Z ) e. X $=
      cA cU cX cZ elimph.1 elimph.5 cU elimph.6 phnvi elimnv $.
      $( [3-Nov-2007] $) $( [27-Apr-2007] $)
  $}

  $( MAY BE REVISED - use elimnvu ? $)
  $( Hypothesis elimination lemma for complex inner product spaces to assist
     weak deduction theorem. $)
  elimphu $p |- if ( U e. CPreHil , U , <. <. + , x. >. , abs >. )
                 e. CPreHil $=
    cU caddc cmul cop cabs cop cphl caddc cmul cop cabs cop caddc cmul cop cabs
    cop eqid cnph elimel $.
    $( [16-May-2007] $) $( [6-May-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Properties of pre-Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y M $.  $d x y N $.  $d x y U $.
    $d x y X $.
    isph.1 $e |- X = ( BaseSet ` U ) $.
    isph.2 $e |- G = ( +v ` U ) $.
    isph.3 $e |- M = ( -v ` U ) $.
    isph.6 $e |- N = ( norm ` U ) $.
    $( The predicate "is an inner product space." $)
    isph $p |- ( U e. CPreHil <-> ( U e. NrmCVec /\ A. x e. X A. y e. X
      ( ( ( N ` ( x G y ) ) ^ 2 ) + ( ( N ` ( x M y ) ) ^ 2 ) ) = (
      2 x. ( ( ( N ` x ) ^ 2 ) + ( ( N ` y ) ^ 2 ) ) ) ) ) $=
      cU cphl wcel cU cnv wcel cU cphl wcel wa cU cnv wcel vx cv vy cv cG co cN
      cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN
      cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral
      vx cX wral wa cU cphl wcel cU cnv wcel cU phnv pm4.71ri cU cnv wcel cU
      cphl wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2
      cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc
      co cmul co wceq vy cX wral vx cX wral cU cnv wcel cU cphl wcel vx cv vy
      cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc co
      c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq
      vy cX wral vx cX wral cU cnv wcel cU cG cU cns cfv cop cN cop wceq cU
      cphl wcel cU cnv wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv vy cv cM
      co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2
      cexp co caddc co cmul co wceq vy cX wral vx cX wral wa wb cU cns cfv cU
      cG cN isph.2 cU cns cfv eqid isph.6 nvop cU cG cU cns cfv cop cN cop wceq
      cU cphl wcel cG cU cns cfv cop cN cop cphl wcel cU cnv wcel vx cv vy cv
      cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc co c2
      vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy
      cX wral vx cX wral wa cU cG cU cns cfv cop cN cop cphl eleq1 cU cG cU cns
      cfv cop cN cop wceq cG cU cns cfv cop cN cop cnv wcel vx cv vy cv cG co
      cN cfv c2 cexp co vx cv c1 cneg vy cv cU cns cfv co cG co cN cfv c2 cexp
      co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co
      cmul co wceq vy cX wral vx cX wral wa cU cnv wcel vx cv vy cv cG co cN
      cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN
      cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral
      vx cX wral wa cG cU cns cfv cop cN cop cphl wcel cU cG cU cns cfv cop cN
      cop wceq cU cnv wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy
      cv cU cns cfv co cG co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp
      co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral wa
      cG cU cns cfv cop cN cop cnv wcel vx cv vy cv cG co cN cfv c2 cexp co vx
      cv c1 cneg vy cv cU cns cfv co cG co cN cfv c2 cexp co caddc co c2 vx cv
      cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX
      wral vx cX wral wa cU cnv wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv
      vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv
      cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral wa cU cG cU
      cns cfv cop cN cop wceq cU cnv wcel cG cU cns cfv cop cN cop cnv wcel vx
      cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cU cns cfv co cG co
      cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2
      cexp co caddc co cmul co wceq vy cX wral vx cX wral cU cG cU cns cfv cop
      cN cop cnv eleq1 anbi1d cU cnv wcel vx cv vy cv cG co cN cfv c2 cexp co
      vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co
      vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral vx cv
      vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cU cns cfv co cG co cN
      cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp
      co caddc co cmul co wceq vy cX wral vx cX wral cU cnv wcel vx cv vy cv cG
      co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx
      cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX
      wral vx cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cU cns cfv
      co cG co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN
      cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX cU cnv wcel vx cv
      cX wcel wa vx cv vy cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv
      c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co
      caddc co cmul co wceq vx cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg
      vy cv cU cns cfv co cG co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2
      cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX cU cnv wcel
      vx cv cX wcel wa vy cv cX wcel wa vx cv vy cv cG co cN cfv c2 cexp co vx
      cv vy cv cM co cN cfv c2 cexp co caddc co vx cv vy cv cG co cN cfv c2
      cexp co vx cv c1 cneg vy cv cU cns cfv co cG co cN cfv c2 cexp co caddc
      co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co cU
      cnv wcel vx cv cX wcel wa vy cv cX wcel wa vx cv vy cv cM co cN cfv c2
      cexp co vx cv c1 cneg vy cv cU cns cfv co cG co cN cfv c2 cexp co vx cv
      vy cv cG co cN cfv c2 cexp co caddc cU cnv wcel vx cv cX wcel wa vy cv cX
      wcel wa vx cv vy cv cM co cN cfv vx cv c1 cneg vy cv cU cns cfv co cG co
      cN cfv c2 cexp cU cnv wcel vx cv cX wcel wa vy cv cX wcel wa vx cv vy cv
      cM co vx cv c1 cneg vy cv cU cns cfv co cG co cN cU cnv wcel vx cv cX
      wcel vy cv cX wcel vx cv vy cv cM co vx cv c1 cneg vy cv cU cns cfv co cG
      co wceq vx cv vy cv cU cns cfv cU cG cM cX isph.1 isph.2 cU cns cfv eqid
      isph.3 nvmval 3expa fveq2d opreq1d opreq2d eqeq1d ralbidva ralbidva
      pm5.32i syl5rbb cG cvv wcel cU cns cfv cvv wcel cN cvv wcel cG cU cns cfv
      cop cN cop cphl wcel cG cU cns cfv cop cN cop cnv wcel vx cv vy cv cG co
      cN cfv c2 cexp co vx cv c1 cneg vy cv cU cns cfv co cG co cN cfv c2 cexp
      co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co
      cmul co wceq vy cX wral vx cX wral wa wb cG cU cpv cfv cvv isph.2 cU cpv
      fvex eqeltri cU cns cfv cU cns cfv cvv cU cns cfv eqid cU cns fvex
      eqeltri cN cU cnm cfv cvv isph.6 cU cnm fvex eqeltri vx vy cvv cvv cvv cU
      cns cfv cG cN cX cU cG cX isph.1 isph.2 bafval isphg mp3an syl5bb bitrd
      syl bianabs pm5.32i bitri $.
      $( [25-Feb-2008] $) $( [1-Feb-2008] $)

    $( The parallelogram law for an inner product space. $)
    phpar2 $p |- ( ( U e. CPreHil /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A M B ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel w3a vx cv vy cv cG co cN cfv c2 cexp
      co vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp
      co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral cA
      cB cG co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co caddc co c2 cA
      cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co cmul co wceq cU cphl wcel
      cA cX wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv
      c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co
      caddc co cmul co wceq vy cX wral vx cX wral cB cX wcel cU cphl wcel cU
      cnv wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2
      cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc
      co cmul co wceq vy cX wral vx cX wral wa vx cv vy cv cG co cN cfv c2 cexp
      co vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp
      co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral vx
      vy cU cG cM cN cX isph.1 isph.2 isph.3 isph.6 isph cU cnv wcel vx cv vy
      cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc co
      c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq
      vy cX wral vx cX wral pm3.27 sylbi 3ad2ant1 cA cX wcel cB cX wcel vx cv
      vy cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co caddc
      co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co
      wceq vy cX wral vx cX wral cA cB cG co cN cfv c2 cexp co cA cB cM co cN
      cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp co cB cN cfv c2 cexp co
      caddc co cmul co wceq wi cU cphl wcel vx cv vy cv cG co cN cfv c2 cexp co
      vx cv vy cv cM co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co
      vy cv cN cfv c2 cexp co caddc co cmul co wceq cA cB cG co cN cfv c2 cexp
      co cA cB cM co cN cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp co cB cN
      cfv c2 cexp co caddc co cmul co wceq cA vy cv cG co cN cfv c2 cexp co cA
      vy cv cM co cN cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp co vy cv cN
      cfv c2 cexp co caddc co cmul co wceq vx vy cA cB cX cX vx cv cA wceq vx
      cv vy cv cG co cN cfv c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co
      caddc co cA vy cv cG co cN cfv c2 cexp co cA vy cv cM co cN cfv c2 cexp
      co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co
      cmul co c2 cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co
      vx cv cA wceq vx cv vy cv cG co cN cfv c2 cexp co cA vy cv cG co cN cfv
      c2 cexp co vx cv vy cv cM co cN cfv c2 cexp co cA vy cv cM co cN cfv c2
      cexp co caddc vx cv cA wceq vx cv vy cv cG co cN cfv cA vy cv cG co cN
      cfv c2 cexp vx cv cA wceq vx cv vy cv cG co cA vy cv cG co cN vx cv cA vy
      cv cG opreq1 fveq2d opreq1d vx cv cA wceq vx cv vy cv cM co cN cfv cA vy
      cv cM co cN cfv c2 cexp vx cv cA wceq vx cv vy cv cM co cA vy cv cM co cN
      vx cv cA vy cv cM opreq1 fveq2d opreq1d opreq12d vx cv cA wceq vx cv cN
      cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cA cN cfv c2 cexp co vy
      cv cN cfv c2 cexp co caddc co c2 cmul vx cv cA wceq vx cv cN cfv c2 cexp
      co cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc vx cv cA wceq vx cv
      cN cfv cA cN cfv c2 cexp vx cv cA cN fveq2 opreq1d opreq1d opreq2d
      eqeq12d vy cv cB wceq cA vy cv cG co cN cfv c2 cexp co cA vy cv cM co cN
      cfv c2 cexp co caddc co cA cB cG co cN cfv c2 cexp co cA cB cM co cN cfv
      c2 cexp co caddc co c2 cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc
      co cmul co c2 cA cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co cmul co
      vy cv cB wceq cA vy cv cG co cN cfv c2 cexp co cA cB cG co cN cfv c2 cexp
      co cA vy cv cM co cN cfv c2 cexp co cA cB cM co cN cfv c2 cexp co caddc
      vy cv cB wceq cA vy cv cG co cN cfv cA cB cG co cN cfv c2 cexp vy cv cB
      wceq cA vy cv cG co cA cB cG co cN vy cv cB cA cG opreq2 fveq2d opreq1d
      vy cv cB wceq cA vy cv cM co cN cfv cA cB cM co cN cfv c2 cexp vy cv cB
      wceq cA vy cv cM co cA cB cM co cN vy cv cB cA cM opreq2 fveq2d opreq1d
      opreq12d vy cv cB wceq cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc
      co cA cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co c2 cmul vy cv cB
      wceq vy cv cN cfv c2 cexp co cB cN cfv c2 cexp co cA cN cfv c2 cexp co
      caddc vy cv cB wceq vy cv cN cfv cB cN cfv c2 cexp vy cv cB cN fveq2
      opreq1d opreq2d opreq2d eqeq12d rcla42v 3adant1 mpd $.
      $( [2-Mar-2008] $) $( [2-Apr-2007] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    phpar.1 $e |- X = ( BaseSet ` U ) $.
    phpar.2 $e |- G = ( +v ` U ) $.
    phpar.4 $e |- S = ( .s ` U ) $.
    phpar.6 $e |- N = ( norm ` U ) $.
    $( The parallelogram law for an inner product space. $)
    phpar $p |- ( ( U e. CPreHil /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel w3a vx cv vy cv cG co cN cfv c2 cexp
      co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc co c2 vx cv cN
      cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral
      vx cX wral cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv
      c2 cexp co caddc co c2 cA cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co
      cmul co wceq cU cphl wcel cA cX wcel vx cv vy cv cG co cN cfv c2 cexp co
      vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc co c2 vx cv cN
      cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral
      vx cX wral cB cX wcel cG cvv wcel cS cvv wcel cN cvv wcel w3a cG cS cop
      cN cop cphl wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv
      cS co cG co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv
      cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral cU cphl
      wcel cG cvv wcel cS cvv wcel cN cvv wcel w3a cG cS cop cN cop cphl wcel
      cG cS cop cN cop cnv wcel vx cv vy cv cG co cN cfv c2 cexp co vx cv c1
      cneg vy cv cS co cG co cN cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp
      co vy cv cN cfv c2 cexp co caddc co cmul co wceq vy cX wral vx cX wral vx
      vy cvv cvv cvv cS cG cN cX cU cG cX phpar.1 phpar.2 bafval isphg
      pm3.27bda cG cvv wcel cS cvv wcel cN cvv wcel w3a cU cphl wcel cG cvv
      wcel cS cvv wcel cN cvv wcel cG cU c1st cfv c1st cfv cvv cU cG phpar.2
      vafval cU c1st cfv c1st fvex eqeltri cS cU c1st cfv c2nd cfv cvv cS cU
      phpar.4 smfval cU c1st cfv c2nd fvex eqeltri cN cU c2nd cfv cvv cU cN
      phpar.6 nmfval cU c2nd fvex eqeltri 3pm3.2i a1i cU cphl wcel cG cS cop cN
      cop cphl wcel cU cphl wcel cU cG cS cop cN cop cphl cS cU cG cN phpar.2
      phpar.4 phpar.6 phop eleq1d ibi sylanc 3ad2ant1 cA cX wcel cB cX wcel vx
      cv vy cv cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv
      c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co
      caddc co cmul co wceq vy cX wral vx cX wral cA cB cG co cN cfv c2 cexp co
      cA c1 cneg cB cS co cG co cN cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp
      co cB cN cfv c2 cexp co caddc co cmul co wceq wi cU cphl wcel vx cv vy cv
      cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co
      caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul
      co wceq cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2
      cexp co caddc co c2 cA cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co
      cmul co wceq cA vy cv cG co cN cfv c2 cexp co cA c1 cneg vy cv cS co cG
      co cN cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp co vy cv cN cfv c2
      cexp co caddc co cmul co wceq vx vy cA cB cX cX vx cv cA wceq vx cv vy cv
      cG co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co
      caddc co cA vy cv cG co cN cfv c2 cexp co cA c1 cneg vy cv cS co cG co cN
      cfv c2 cexp co caddc co c2 vx cv cN cfv c2 cexp co vy cv cN cfv c2 cexp
      co caddc co cmul co c2 cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc
      co cmul co vx cv cA wceq vx cv vy cv cG co cN cfv c2 cexp co cA vy cv cG
      co cN cfv c2 cexp co vx cv c1 cneg vy cv cS co cG co cN cfv c2 cexp co cA
      c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc vx cv cA wceq vx cv vy
      cv cG co cN cfv cA vy cv cG co cN cfv c2 cexp vx cv cA wceq vx cv vy cv
      cG co cA vy cv cG co cN vx cv cA vy cv cG opreq1 fveq2d opreq1d vx cv cA
      wceq vx cv c1 cneg vy cv cS co cG co cN cfv cA c1 cneg vy cv cS co cG co
      cN cfv c2 cexp vx cv cA wceq vx cv c1 cneg vy cv cS co cG co cA c1 cneg
      vy cv cS co cG co cN vx cv cA c1 cneg vy cv cS co cG opreq1 fveq2d
      opreq1d opreq12d vx cv cA wceq vx cv cN cfv c2 cexp co vy cv cN cfv c2
      cexp co caddc co cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co c2
      cmul vx cv cA wceq vx cv cN cfv c2 cexp co cA cN cfv c2 cexp co vy cv cN
      cfv c2 cexp co caddc vx cv cA wceq vx cv cN cfv cA cN cfv c2 cexp vx cv
      cA cN fveq2 opreq1d opreq1d opreq2d eqeq12d vy cv cB wceq cA vy cv cG co
      cN cfv c2 cexp co cA c1 cneg vy cv cS co cG co cN cfv c2 cexp co caddc co
      cA cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv c2 cexp co
      caddc co c2 cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc co cmul co
      c2 cA cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co cmul co vy cv cB
      wceq cA vy cv cG co cN cfv c2 cexp co cA cB cG co cN cfv c2 cexp co cA c1
      cneg vy cv cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cN cfv
      c2 cexp co caddc vy cv cB wceq cA vy cv cG co cN cfv cA cB cG co cN cfv
      c2 cexp vy cv cB wceq cA vy cv cG co cA cB cG co cN vy cv cB cA cG opreq2
      fveq2d opreq1d vy cv cB wceq cA c1 cneg vy cv cS co cG co cN cfv cA c1
      cneg cB cS co cG co cN cfv c2 cexp vy cv cB wceq cA c1 cneg vy cv cS co
      cG co cA c1 cneg cB cS co cG co cN vy cv cB wceq c1 cneg vy cv cS co c1
      cneg cB cS co cA cG vy cv cB c1 cneg cS opreq2 opreq2d fveq2d opreq1d
      opreq12d vy cv cB wceq cA cN cfv c2 cexp co vy cv cN cfv c2 cexp co caddc
      co cA cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co c2 cmul vy cv cB
      wceq vy cv cN cfv c2 cexp co cB cN cfv c2 cexp co cA cN cfv c2 cexp co
      caddc vy cv cB wceq vy cv cN cfv cB cN cfv c2 cexp vy cv cB cN fveq2
      opreq1d opreq2d opreq2d eqeq12d rcla42v 3adant1 mpd $.
      $( [29-Oct-2007] $) $( [2-Apr-2007] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    ip1i.1 $e |- X = ( BaseSet ` U ) $.
    ip1i.2 $e |- G = ( +v ` U ) $.
    ip1i.4 $e |- S = ( .s ` U ) $.
    ip1i.7 $e |- P = ( .i ` U ) $.
    ip1i.9 $e |- U e. CPreHil $.
    ${
      ip1i.a $e |- A e. X $.
      ip1i.b $e |- B e. X $.
      ip1i.c $e |- C e. X $.
      ${
        ip1i.6 $e |- N = ( norm ` U ) $.
        ip0i.j $e |- J e. CC $.
        $( A slight variant of Equation 6.46 of [Ponnusamy] p. 362, where
           ` J ` is either 1 or -1 to represent +-1. $)
        ip0i $p |- ( ( ( ( N ` ( ( A G B ) G ( J S C ) ) ) ^ 2 ) -
             ( ( N ` ( ( A G B ) G ( -u J S C ) ) ) ^ 2 ) ) +
             ( ( ( N ` ( ( A G ( -u 1 S B ) ) G ( J S C ) ) ) ^ 2 ) -
           ( ( N ` ( ( A G ( -u 1 S B ) ) G ( -u J S C ) ) ) ^ 2 ) ) ) =
                ( 2 x. ( ( ( N ` ( A G ( J S C ) ) ) ^ 2 ) -
                ( ( N ` ( A G ( -u J S C ) ) ) ^ 2 ) ) ) $=
          c2 cA cJ cC cS co cG co cN cfv c2 cexp co cA cJ cneg cC cS co cG co
          cN cfv c2 cexp co cmin co cmul co c2 cA cJ cC cS co cG co cN cfv c2
          cexp co cmul co c2 cB cN cfv c2 cexp co cmul co caddc co c2 cA cJ
          cneg cC cS co cG co cN cfv c2 cexp co cmul co c2 cB cN cfv c2 cexp co
          cmul co caddc co cmin co cA cB cG co cJ cC cS co cG co cN cfv c2 cexp
          co cA c1 cneg cB cS co cG co cJ cC cS co cG co cN cfv c2 cexp co
          caddc co cA cB cG co cJ cneg cC cS co cG co cN cfv c2 cexp co cA c1
          cneg cB cS co cG co cJ cneg cC cS co cG co cN cfv c2 cexp co caddc co
          cmin co cA cB cG co cJ cC cS co cG co cN cfv c2 cexp co cA cB cG co
          cJ cneg cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS co
          cG co cJ cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co
          cJ cneg cC cS co cG co cN cfv c2 cexp co cmin co caddc co c2 cA cJ cC
          cS co cG co cN cfv c2 cexp co cA cJ cneg cC cS co cG co cN cfv c2
          cexp co cmin co cmul co c2 cA cJ cC cS co cG co cN cfv c2 cexp co
          cmul co c2 cA cJ cneg cC cS co cG co cN cfv c2 cexp co cmul co cmin
          co c2 cA cJ cC cS co cG co cN cfv c2 cexp co cmul co c2 cB cN cfv c2
          cexp co cmul co caddc co c2 cA cJ cneg cC cS co cG co cN cfv c2 cexp
          co cmul co c2 cB cN cfv c2 cexp co cmul co caddc co cmin co c2 cA cJ
          cC cS co cG co cN cfv c2 cexp co cA cJ cneg cC cS co cG co cN cfv c2
          cexp co 2cn cA cJ cC cS co cG co cN cfv cA cJ cC cS co cG co cN cfv
          cA cJ cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv
          wcel cA cX wcel cJ cC cS co cX wcel cA cJ cC cS co cG co cX wcel cU
          ip1i.9 phnvi ip1i.a cU cnv wcel cJ cc wcel cC cX wcel cJ cC cS co cX
          wcel cU ip1i.9 phnvi ip0i.j ip1i.c cJ cC cS cU cX ip1i.1 ip1i.4 nvscl
          mp3an cA cJ cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni
          sqcli cA cJ cneg cC cS co cG co cN cfv cA cJ cneg cC cS co cG co cN
          cfv cA cJ cneg cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi
          cU cnv wcel cA cX wcel cJ cneg cC cS co cX wcel cA cJ cneg cC cS co
          cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel cJ cneg cc wcel cC
          cX wcel cJ cneg cC cS co cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli
          ip1i.c cJ cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cJ cneg cC cS
          co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli subdii c2 cA
          cJ cC cS co cG co cN cfv c2 cexp co cmul co cc wcel c2 cA cJ cneg cC
          cS co cG co cN cfv c2 cexp co cmul co cc wcel c2 cB cN cfv c2 cexp co
          cmul co cc wcel c2 cA cJ cC cS co cG co cN cfv c2 cexp co cmul co c2
          cB cN cfv c2 cexp co cmul co caddc co c2 cA cJ cneg cC cS co cG co cN
          cfv c2 cexp co cmul co c2 cB cN cfv c2 cexp co cmul co caddc co cmin
          co c2 cA cJ cC cS co cG co cN cfv c2 cexp co cmul co c2 cA cJ cneg cC
          cS co cG co cN cfv c2 cexp co cmul co cmin co wceq c2 cA cJ cC cS co
          cG co cN cfv c2 cexp co 2cn cA cJ cC cS co cG co cN cfv cA cJ cC cS
          co cG co cN cfv cA cJ cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9
          phnvi cU cnv wcel cA cX wcel cJ cC cS co cX wcel cA cJ cC cS co cG co
          cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel cJ cc wcel cC cX wcel cJ
          cC cS co cX wcel cU ip1i.9 phnvi ip0i.j ip1i.c cJ cC cS cU cX ip1i.1
          ip1i.4 nvscl mp3an cA cJ cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          nvcli recni sqcli mulcli c2 cA cJ cneg cC cS co cG co cN cfv c2 cexp
          co 2cn cA cJ cneg cC cS co cG co cN cfv cA cJ cneg cC cS co cG co cN
          cfv cA cJ cneg cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi
          cU cnv wcel cA cX wcel cJ cneg cC cS co cX wcel cA cJ cneg cC cS co
          cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel cJ cneg cc wcel cC
          cX wcel cJ cneg cC cS co cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli
          ip1i.c cJ cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cJ cneg cC cS
          co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli mulcli c2 cB
          cN cfv c2 cexp co 2cn cB cN cfv cB cN cfv cB cU cN cX ip1i.1 ip1i.6
          cU ip1i.9 phnvi ip1i.b nvcli recni sqcli mulcli c2 cA cJ cC cS co cG
          co cN cfv c2 cexp co cmul co c2 cA cJ cneg cC cS co cG co cN cfv c2
          cexp co cmul co c2 cB cN cfv c2 cexp co cmul co pnpcan2 mp3an eqtr4i
          cA cB cG co cJ cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co
          cG co cJ cC cS co cG co cN cfv c2 cexp co caddc co c2 cA cJ cC cS co
          cG co cN cfv c2 cexp co cmul co c2 cB cN cfv c2 cexp co cmul co caddc
          co cA cB cG co cJ cneg cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB
          cS co cG co cJ cneg cC cS co cG co cN cfv c2 cexp co caddc co c2 cA
          cJ cneg cC cS co cG co cN cfv c2 cexp co cmul co c2 cB cN cfv c2 cexp
          co cmul co caddc co cmin cA cB cG co cJ cC cS co cG co cN cfv c2 cexp
          co cA c1 cneg cB cS co cG co cJ cC cS co cG co cN cfv c2 cexp co
          caddc co cA cJ cC cS co cG co cB cG co cN cfv c2 cexp co cA cJ cC cS
          co cG co c1 cneg cB cS co cG co cN cfv c2 cexp co caddc co c2 cA cJ
          cC cS co cG co cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co cmul
          co c2 cA cJ cC cS co cG co cN cfv c2 cexp co cmul co c2 cB cN cfv c2
          cexp co cmul co caddc co cA cB cG co cJ cC cS co cG co cN cfv c2 cexp
          co cA cJ cC cS co cG co cB cG co cN cfv c2 cexp co cA c1 cneg cB cS
          co cG co cJ cC cS co cG co cN cfv c2 cexp co cA cJ cC cS co cG co c1
          cneg cB cS co cG co cN cfv c2 cexp co caddc cA cB cG co cJ cC cS co
          cG co cN cfv cA cJ cC cS co cG co cB cG co cN cfv c2 cexp cA cB cG co
          cJ cC cS co cG co cA cJ cC cS co cG co cB cG co cN cG cabl wcel cA cX
          wcel cB cX wcel cJ cC cS co cX wcel w3a cA cB cG co cJ cC cS co cG co
          cA cJ cC cS co cG co cB cG co wceq cU c1st cfv cvc wcel cG cabl wcel
          cU cnv wcel cU c1st cfv cvc wcel cU ip1i.9 phnvi cU cU c1st cfv cU
          c1st cfv eqid nvvc ax-mp cG cU c1st cfv cU cG ip1i.2 vafval vcabl
          ax-mp cA cX wcel cB cX wcel cJ cC cS co cX wcel ip1i.a ip1i.b cU cnv
          wcel cJ cc wcel cC cX wcel cJ cC cS co cX wcel cU ip1i.9 phnvi ip0i.j
          ip1i.c cJ cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an 3pm3.2i cA cB cJ cC
          cS co cG cX cU cG cX ip1i.1 ip1i.2 bafval abl23 mp2an fveq2i opreq1i
          cA c1 cneg cB cS co cG co cJ cC cS co cG co cN cfv cA cJ cC cS co cG
          co c1 cneg cB cS co cG co cN cfv c2 cexp cA c1 cneg cB cS co cG co cJ
          cC cS co cG co cA cJ cC cS co cG co c1 cneg cB cS co cG co cN cG cabl
          wcel cA cX wcel c1 cneg cB cS co cX wcel cJ cC cS co cX wcel w3a cA
          c1 cneg cB cS co cG co cJ cC cS co cG co cA cJ cC cS co cG co c1 cneg
          cB cS co cG co wceq cU c1st cfv cvc wcel cG cabl wcel cU cnv wcel cU
          c1st cfv cvc wcel cU ip1i.9 phnvi cU cU c1st cfv cU c1st cfv eqid
          nvvc ax-mp cG cU c1st cfv cU cG ip1i.2 vafval vcabl ax-mp cA cX wcel
          c1 cneg cB cS co cX wcel cJ cC cS co cX wcel ip1i.a cU cnv wcel c1
          cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1
          ax1cn negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cU
          cnv wcel cJ cc wcel cC cX wcel cJ cC cS co cX wcel cU ip1i.9 phnvi
          ip0i.j ip1i.c cJ cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an 3pm3.2i cA c1
          cneg cB cS co cJ cC cS co cG cX cU cG cX ip1i.1 ip1i.2 bafval abl23
          mp2an fveq2i opreq1i opreq12i cU cphl wcel cA cJ cC cS co cG co cX
          wcel cB cX wcel cA cJ cC cS co cG co cB cG co cN cfv c2 cexp co cA cJ
          cC cS co cG co c1 cneg cB cS co cG co cN cfv c2 cexp co caddc co c2
          cA cJ cC cS co cG co cN cfv c2 cexp co cB cN cfv c2 cexp co caddc co
          cmul co wceq ip1i.9 cU cnv wcel cA cX wcel cJ cC cS co cX wcel cA cJ
          cC cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel cJ cc wcel
          cC cX wcel cJ cC cS co cX wcel cU ip1i.9 phnvi ip0i.j ip1i.c cJ cC cS
          cU cX ip1i.1 ip1i.4 nvscl mp3an cA cJ cC cS co cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an ip1i.b cA cJ cC cS co cG co cB cS cU cG cN cX ip1i.1
          ip1i.2 ip1i.4 ip1i.6 phpar mp3an c2 cA cJ cC cS co cG co cN cfv c2
          cexp co cB cN cfv c2 cexp co 2cn cA cJ cC cS co cG co cN cfv cA cJ cC
          cS co cG co cN cfv cA cJ cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel cJ cC cS co cX wcel cA cJ cC cS
          co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel cJ cc wcel cC cX
          wcel cJ cC cS co cX wcel cU ip1i.9 phnvi ip0i.j ip1i.c cJ cC cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA cJ cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli recni sqcli cB cN cfv cB cN cfv cB cU cN cX ip1i.1 ip1i.6
          cU ip1i.9 phnvi ip1i.b nvcli recni sqcli adddii 3eqtri cA cB cG co cJ
          cneg cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cJ
          cneg cC cS co cG co cN cfv c2 cexp co caddc co cA cJ cneg cC cS co cG
          co cB cG co cN cfv c2 cexp co cA cJ cneg cC cS co cG co c1 cneg cB cS
          co cG co cN cfv c2 cexp co caddc co c2 cA cJ cneg cC cS co cG co cN
          cfv c2 cexp co cB cN cfv c2 cexp co caddc co cmul co c2 cA cJ cneg cC
          cS co cG co cN cfv c2 cexp co cmul co c2 cB cN cfv c2 cexp co cmul co
          caddc co cA cB cG co cJ cneg cC cS co cG co cN cfv c2 cexp co cA cJ
          cneg cC cS co cG co cB cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG
          co cJ cneg cC cS co cG co cN cfv c2 cexp co cA cJ cneg cC cS co cG co
          c1 cneg cB cS co cG co cN cfv c2 cexp co caddc cA cB cG co cJ cneg cC
          cS co cG co cN cfv cA cJ cneg cC cS co cG co cB cG co cN cfv c2 cexp
          cA cB cG co cJ cneg cC cS co cG co cA cJ cneg cC cS co cG co cB cG co
          cN cG cabl wcel cA cX wcel cB cX wcel cJ cneg cC cS co cX wcel w3a cA
          cB cG co cJ cneg cC cS co cG co cA cJ cneg cC cS co cG co cB cG co
          wceq cU c1st cfv cvc wcel cG cabl wcel cU cnv wcel cU c1st cfv cvc
          wcel cU ip1i.9 phnvi cU cU c1st cfv cU c1st cfv eqid nvvc ax-mp cG cU
          c1st cfv cU cG ip1i.2 vafval vcabl ax-mp cA cX wcel cB cX wcel cJ
          cneg cC cS co cX wcel ip1i.a ip1i.b cU cnv wcel cJ cneg cc wcel cC cX
          wcel cJ cneg cC cS co cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli ip1i.c
          cJ cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an 3pm3.2i cA cB cJ cneg
          cC cS co cG cX cU cG cX ip1i.1 ip1i.2 bafval abl23 mp2an fveq2i
          opreq1i cA c1 cneg cB cS co cG co cJ cneg cC cS co cG co cN cfv cA cJ
          cneg cC cS co cG co c1 cneg cB cS co cG co cN cfv c2 cexp cA c1 cneg
          cB cS co cG co cJ cneg cC cS co cG co cA cJ cneg cC cS co cG co c1
          cneg cB cS co cG co cN cG cabl wcel cA cX wcel c1 cneg cB cS co cX
          wcel cJ cneg cC cS co cX wcel w3a cA c1 cneg cB cS co cG co cJ cneg
          cC cS co cG co cA cJ cneg cC cS co cG co c1 cneg cB cS co cG co wceq
          cU c1st cfv cvc wcel cG cabl wcel cU cnv wcel cU c1st cfv cvc wcel cU
          ip1i.9 phnvi cU cU c1st cfv cU c1st cfv eqid nvvc ax-mp cG cU c1st
          cfv cU cG ip1i.2 vafval vcabl ax-mp cA cX wcel c1 cneg cB cS co cX
          wcel cJ cneg cC cS co cX wcel ip1i.a cU cnv wcel c1 cneg cc wcel cB
          cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli
          ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cU cnv wcel cJ
          cneg cc wcel cC cX wcel cJ cneg cC cS co cX wcel cU ip1i.9 phnvi cJ
          ip0i.j negcli ip1i.c cJ cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an
          3pm3.2i cA c1 cneg cB cS co cJ cneg cC cS co cG cX cU cG cX ip1i.1
          ip1i.2 bafval abl23 mp2an fveq2i opreq1i opreq12i cU cphl wcel cA cJ
          cneg cC cS co cG co cX wcel cB cX wcel cA cJ cneg cC cS co cG co cB
          cG co cN cfv c2 cexp co cA cJ cneg cC cS co cG co c1 cneg cB cS co cG
          co cN cfv c2 cexp co caddc co c2 cA cJ cneg cC cS co cG co cN cfv c2
          cexp co cB cN cfv c2 cexp co caddc co cmul co wceq ip1i.9 cU cnv wcel
          cA cX wcel cJ cneg cC cS co cX wcel cA cJ cneg cC cS co cG co cX wcel
          cU ip1i.9 phnvi ip1i.a cU cnv wcel cJ cneg cc wcel cC cX wcel cJ cneg
          cC cS co cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli ip1i.c cJ cneg cC
          cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cJ cneg cC cS co cU cG cX
          ip1i.1 ip1i.2 nvgcl mp3an ip1i.b cA cJ cneg cC cS co cG co cB cS cU
          cG cN cX ip1i.1 ip1i.2 ip1i.4 ip1i.6 phpar mp3an c2 cA cJ cneg cC cS
          co cG co cN cfv c2 cexp co cB cN cfv c2 cexp co 2cn cA cJ cneg cC cS
          co cG co cN cfv cA cJ cneg cC cS co cG co cN cfv cA cJ cneg cC cS co
          cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cX wcel
          cJ cneg cC cS co cX wcel cA cJ cneg cC cS co cG co cX wcel cU ip1i.9
          phnvi ip1i.a cU cnv wcel cJ cneg cc wcel cC cX wcel cJ cneg cC cS co
          cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli ip1i.c cJ cneg cC cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA cJ cneg cC cS co cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an nvcli recni sqcli cB cN cfv cB cN cfv cB cU cN cX ip1i.1
          ip1i.6 cU ip1i.9 phnvi ip1i.b nvcli recni sqcli adddii 3eqtri
          opreq12i cA cB cG co cJ cC cS co cG co cN cfv c2 cexp co cA c1 cneg
          cB cS co cG co cJ cC cS co cG co cN cfv c2 cexp co cA cB cG co cJ
          cneg cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cJ
          cneg cC cS co cG co cN cfv c2 cexp co cA cB cG co cJ cC cS co cG co
          cN cfv cA cB cG co cJ cC cS co cG co cN cfv cA cB cG co cJ cC cS co
          cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cB cG co
          cX wcel cJ cC cS co cX wcel cA cB cG co cJ cC cS co cG co cX wcel cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU
          ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          cU cnv wcel cJ cc wcel cC cX wcel cJ cC cS co cX wcel cU ip1i.9 phnvi
          ip0i.j ip1i.c cJ cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cB cG co cJ
          cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli cA c1
          cneg cB cS co cG co cJ cC cS co cG co cN cfv cA c1 cneg cB cS co cG
          co cJ cC cS co cG co cN cfv cA c1 cneg cB cS co cG co cJ cC cS co cG
          co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA c1 cneg cB
          cS co cG co cX wcel cJ cC cS co cX wcel cA c1 cneg cB cS co cG co cJ
          cC cS co cG co cX wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg
          cB cS co cX wcel cA c1 cneg cB cS co cG co cX wcel cU ip1i.9 phnvi
          ip1i.a cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX
          wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.b c1 cneg cB cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an cU cnv wcel cJ cc wcel cC cX wcel cJ cC cS co cX wcel cU
          ip1i.9 phnvi ip0i.j ip1i.c cJ cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an
          cA c1 cneg cB cS co cG co cJ cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli recni sqcli cA cB cG co cJ cneg cC cS co cG co cN cfv cA
          cB cG co cJ cneg cC cS co cG co cN cfv cA cB cG co cJ cneg cC cS co
          cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cB cG co
          cX wcel cJ cneg cC cS co cX wcel cA cB cG co cJ cneg cC cS co cG co
          cX wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG co
          cX wcel cU ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an cU cnv wcel cJ cneg cc wcel cC cX wcel cJ cneg cC cS co
          cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli ip1i.c cJ cneg cC cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA cB cG co cJ cneg cC cS co cU cG cX
          ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli cA c1 cneg cB cS co cG co
          cJ cneg cC cS co cG co cN cfv cA c1 cneg cB cS co cG co cJ cneg cC cS
          co cG co cN cfv cA c1 cneg cB cS co cG co cJ cneg cC cS co cG co cU
          cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA c1 cneg cB cS co
          cG co cX wcel cJ cneg cC cS co cX wcel cA c1 cneg cB cS co cG co cJ
          cneg cC cS co cG co cX wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel c1
          cneg cB cS co cX wcel cA c1 cneg cB cS co cG co cX wcel cU ip1i.9
          phnvi ip1i.a cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co
          cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.b c1 cneg cB cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an cU cnv wcel cJ cneg cc wcel cC cX wcel cJ cneg cC cS co
          cX wcel cU ip1i.9 phnvi cJ ip0i.j negcli ip1i.c cJ cneg cC cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cG co cJ cneg cC cS co
          cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli addsub4i
          3eqtr2ri $.
          $( [31-Oct-2007] $) $( [23-Apr-2007] $)

        $( Lemma for ~ ip1i . $)
        ip1ilem $p |- ( ( ( A G B ) P C ) +
                         ( ( A G ( -u 1 S B ) ) P C ) ) = ( 2 x. ( A P C ) ) $=
          c4 cA cB cG co cC cP co cA c1 cneg cB cS co cG co cC cP co caddc co
          cmul co c4 cdiv co c4 c2 cA cC cP co cmul co cmul co c4 cdiv co cA cB
          cG co cC cP co cA c1 cneg cB cS co cG co cC cP co caddc co c2 cA cC
          cP co cmul co c4 cA cB cG co cC cP co cA c1 cneg cB cS co cG co cC cP
          co caddc co cmul co c4 c2 cA cC cP co cmul co cmul co c4 cdiv c2 c4
          cA cC cP co cmul co cmul co c2 cA cC cG co cN cfv c2 cexp co cA c1
          cneg cC cS co cG co cN cfv c2 cexp co cmin co ci cA ci cC cS co cG co
          cN cfv c2 cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co
          cmul co caddc co cmul co c4 c2 cA cC cP co cmul co cmul co c4 cA cB
          cG co cC cP co cA c1 cneg cB cS co cG co cC cP co caddc co cmul co c4
          cA cC cP co cmul co cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co
          cG co cN cfv c2 cexp co cmin co ci cA ci cC cS co cG co cN cfv c2
          cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co
          caddc co c2 cmul cU cnv wcel cA cX wcel cC cX wcel c4 cA cC cP co
          cmul co cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN
          cfv c2 cexp co cmin co ci cA ci cC cS co cG co cN cfv c2 cexp co cA
          ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co
          wceq cU ip1i.9 phnvi ip1i.a ip1i.c cA cC cP cS cU cG cN cX ip1i.1
          ip1i.2 ip1i.4 ip1i.6 ip1i.7 4ipval2 mp3an opreq2i c2 c4 cA cC cP co
          2cn c4 4re recni cU cnv wcel cA cX wcel cC cX wcel cA cC cP co cc
          wcel cU ip1i.9 phnvi ip1i.a ip1i.c cA cC cP cU cX ip1i.1 ip1i.7 ipcl
          mp3an mul12i c2 cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG
          co cN cfv c2 cexp co cmin co ci cA ci cC cS co cG co cN cfv c2 cexp
          co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co caddc
          co cmul co cA cB cG co cC cG co cN cfv c2 cexp co cA cB cG co c1 cneg
          cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS co cG co cC
          cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co c1 cneg cC cS co cG
          co cN cfv c2 cexp co cmin co caddc co ci cA cB cG co ci cC cS co cG
          co cN cfv c2 cexp co cA cB cG co ci cneg cC cS co cG co cN cfv c2
          cexp co cmin co cmul co ci cA c1 cneg cB cS co cG co ci cC cS co cG
          co cN cfv c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co cG co
          cN cfv c2 cexp co cmin co cmul co caddc co caddc co cA cB cG co cC cG
          co cN cfv c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv c2
          cexp co cmin co ci cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA
          cB cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co
          caddc co cA c1 cneg cB cS co cG co cC cG co cN cfv c2 cexp co cA c1
          cneg cB cS co cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co
          ci cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv c2 cexp co cA
          c1 cneg cB cS co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin
          co cmul co caddc co caddc co c4 cA cB cG co cC cP co cA c1 cneg cB cS
          co cG co cC cP co caddc co cmul co c2 cA cC cG co cN cfv c2 cexp co
          cA c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co ci cA ci cC cS co
          cG co cN cfv c2 cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co
          cmin co cmul co caddc co cmul co c2 cA cC cG co cN cfv c2 cexp co cA
          c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co c2 ci cA ci
          cC cS co cG co cN cfv c2 cexp co cA ci cneg cC cS co cG co cN cfv c2
          cexp co cmin co cmul co cmul co caddc co cA cB cG co cC cG co cN cfv
          c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin
          co cA c1 cneg cB cS co cG co cC cG co cN cfv c2 cexp co cA c1 cneg cB
          cS co cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co caddc co
          ci cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB cG co ci
          cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co ci cA c1 cneg
          cB cS co cG co ci cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS
          co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co
          caddc co caddc co c2 cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS
          co cG co cN cfv c2 cexp co cmin co ci cA ci cC cS co cG co cN cfv c2
          cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co
          2cn cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN cfv c2
          cexp co cA cC cG co cN cfv c2 cexp co cA cC cG co cN cfv cA cC cG co
          cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cX wcel cC cX
          wcel cA cC cG co cX wcel cU ip1i.9 phnvi ip1i.a ip1i.c cA cC cU cG cX
          ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni cA c1 cneg cC cS co cG
          co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN cfv cA c1 cneg cC
          cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cX
          wcel c1 cneg cC cS co cX wcel cA c1 cneg cC cS co cG co cX wcel cU
          ip1i.9 phnvi ip1i.a cU cnv wcel c1 cneg cc wcel cC cX wcel c1 cneg cC
          cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.c c1 cneg cC cS cU
          cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cC cS co cU cG cX ip1i.1
          ip1i.2 nvgcl mp3an nvcli resqcli recni subcli ci cA ci cC cS co cG co
          cN cfv c2 cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co
          axicn cA ci cC cS co cG co cN cfv c2 cexp co cA ci cneg cC cS co cG
          co cN cfv c2 cexp co cA ci cC cS co cG co cN cfv c2 cexp co cA ci cC
          cS co cG co cN cfv cA ci cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel ci cC cS co cX wcel cA ci cC cS
          co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel ci cc wcel cC cX
          wcel ci cC cS co cX wcel cU ip1i.9 phnvi axicn ip1i.c ci cC cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA ci cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli resqcli recni cA ci cneg cC cS co cG co cN cfv c2 cexp co
          cA ci cneg cC cS co cG co cN cfv cA ci cneg cC cS co cG co cU cN cX
          ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cX wcel ci cneg cC cS co
          cX wcel cA ci cneg cC cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU
          cnv wcel ci cneg cc wcel cC cX wcel ci cneg cC cS co cX wcel cU
          ip1i.9 phnvi ci axicn negcli ip1i.c ci cneg cC cS cU cX ip1i.1 ip1i.4
          nvscl mp3an cA ci cneg cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          nvcli resqcli recni subcli mulcli adddii cA cB cG co cC cG co cN cfv
          c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin
          co cA c1 cneg cB cS co cG co cC cG co cN cfv c2 cexp co cA c1 cneg cB
          cS co cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co caddc co
          c2 cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN cfv c2
          cexp co cmin co cmul co ci cA cB cG co ci cC cS co cG co cN cfv c2
          cexp co cA cB cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co
          cmul co ci cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv c2 cexp
          co cA c1 cneg cB cS co cG co ci cneg cC cS co cG co cN cfv c2 cexp co
          cmin co cmul co caddc co c2 ci cA ci cC cS co cG co cN cfv c2 cexp co
          cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co cmul co
          caddc cA cB cG co c1 cC cS co cG co cN cfv c2 cexp co cA cB cG co c1
          cneg cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS co cG
          co c1 cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co c1
          cneg cC cS co cG co cN cfv c2 cexp co cmin co caddc co c2 cA c1 cC cS
          co cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN cfv c2 cexp
          co cmin co cmul co cA cB cG co cC cG co cN cfv c2 cexp co cA cB cG co
          c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS co
          cG co cC cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co c1 cneg cC
          cS co cG co cN cfv c2 cexp co cmin co caddc co c2 cA cC cG co cN cfv
          c2 cexp co cA c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul
          co cA cB cC cP cS cU cG c1 cN cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9
          ip1i.a ip1i.b ip1i.c ip1i.6 ax1cn ip0i cA cB cG co c1 cC cS co cG co
          cN cfv c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv c2 cexp
          co cmin co cA cB cG co cC cG co cN cfv c2 cexp co cA cB cG co c1 cneg
          cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS co cG co c1
          cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co c1 cneg cC
          cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS co cG co cC cG
          co cN cfv c2 cexp co cA c1 cneg cB cS co cG co c1 cneg cC cS co cG co
          cN cfv c2 cexp co cmin co caddc cA cB cG co c1 cC cS co cG co cN cfv
          c2 cexp co cA cB cG co cC cG co cN cfv c2 cexp co cA cB cG co c1 cneg
          cC cS co cG co cN cfv c2 cexp co cmin cA cB cG co c1 cC cS co cG co
          cN cfv cA cB cG co cC cG co cN cfv c2 cexp cA cB cG co c1 cC cS co cG
          co cA cB cG co cC cG co cN c1 cC cS co cC cA cB cG co cG cU cnv wcel
          cC cX wcel c1 cC cS co cC wceq cU ip1i.9 phnvi ip1i.c cC cS cU cX
          ip1i.1 ip1i.4 nvsid mp2an opreq2i fveq2i opreq1i opreq1i cA c1 cneg
          cB cS co cG co c1 cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS
          co cG co cC cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co c1 cneg
          cC cS co cG co cN cfv c2 cexp co cmin cA c1 cneg cB cS co cG co c1 cC
          cS co cG co cN cfv cA c1 cneg cB cS co cG co cC cG co cN cfv c2 cexp
          cA c1 cneg cB cS co cG co c1 cC cS co cG co cA c1 cneg cB cS co cG co
          cC cG co cN c1 cC cS co cC cA c1 cneg cB cS co cG co cG cU cnv wcel
          cC cX wcel c1 cC cS co cC wceq cU ip1i.9 phnvi ip1i.c cC cS cU cX
          ip1i.1 ip1i.4 nvsid mp2an opreq2i fveq2i opreq1i opreq1i opreq12i cA
          c1 cC cS co cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN cfv
          c2 cexp co cmin co cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co
          cG co cN cfv c2 cexp co cmin co c2 cmul cA c1 cC cS co cG co cN cfv
          c2 cexp co cA cC cG co cN cfv c2 cexp co cA c1 cneg cC cS co cG co cN
          cfv c2 cexp co cmin cA c1 cC cS co cG co cN cfv cA cC cG co cN cfv c2
          cexp cA c1 cC cS co cG co cA cC cG co cN c1 cC cS co cC cA cG cU cnv
          wcel cC cX wcel c1 cC cS co cC wceq cU ip1i.9 phnvi ip1i.c cC cS cU
          cX ip1i.1 ip1i.4 nvsid mp2an opreq2i fveq2i opreq1i opreq1i opreq2i
          3eqtr3i ci cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB cG
          co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB cS
          co cG co ci cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG
          co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co caddc co cmul co
          ci c2 cA ci cC cS co cG co cN cfv c2 cexp co cA ci cneg cC cS co cG
          co cN cfv c2 cexp co cmin co cmul co cmul co ci cA cB cG co ci cC cS
          co cG co cN cfv c2 cexp co cA cB cG co ci cneg cC cS co cG co cN cfv
          c2 cexp co cmin co cmul co ci cA c1 cneg cB cS co cG co ci cC cS co
          cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co cG
          co cN cfv c2 cexp co cmin co cmul co caddc co c2 ci cA ci cC cS co cG
          co cN cfv c2 cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin
          co cmul co cmul co cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA
          cB cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg
          cB cS co cG co ci cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS
          co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co caddc co c2
          cA ci cC cS co cG co cN cfv c2 cexp co cA ci cneg cC cS co cG co cN
          cfv c2 cexp co cmin co cmul co ci cmul cA cB cC cP cS cU cG ci cN cX
          ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 ip1i.a ip1i.b ip1i.c ip1i.6 axicn
          ip0i opreq2i ci cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB
          cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cA c1 cneg cB
          cS co cG co ci cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co
          cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co axicn cA cB cG
          co ci cC cS co cG co cN cfv c2 cexp co cA cB cG co ci cneg cC cS co
          cG co cN cfv c2 cexp co cA cB cG co ci cC cS co cG co cN cfv c2 cexp
          co cA cB cG co ci cC cS co cG co cN cfv cA cB cG co ci cC cS co cG co
          cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cB cG co cX
          wcel ci cC cS co cX wcel cA cB cG co ci cC cS co cG co cX wcel cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU
          ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          cU cnv wcel ci cc wcel cC cX wcel ci cC cS co cX wcel cU ip1i.9 phnvi
          axicn ip1i.c ci cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cB cG co ci
          cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni cA cB
          cG co ci cneg cC cS co cG co cN cfv c2 cexp co cA cB cG co ci cneg cC
          cS co cG co cN cfv cA cB cG co ci cneg cC cS co cG co cU cN cX ip1i.1
          ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cB cG co cX wcel ci cneg cC cS
          co cX wcel cA cB cG co ci cneg cC cS co cG co cX wcel cU ip1i.9 phnvi
          cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU ip1i.9 phnvi
          ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci
          cneg cc wcel cC cX wcel ci cneg cC cS co cX wcel cU ip1i.9 phnvi ci
          axicn negcli ip1i.c ci cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          cB cG co ci cneg cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli
          resqcli recni subcli cA c1 cneg cB cS co cG co ci cC cS co cG co cN
          cfv c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co cG co cN
          cfv c2 cexp co cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv c2
          cexp co cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv cA c1 cneg
          cB cS co cG co ci cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9
          phnvi cU cnv wcel cA c1 cneg cB cS co cG co cX wcel ci cC cS co cX
          wcel cA c1 cneg cB cS co cG co ci cC cS co cG co cX wcel cU ip1i.9
          phnvi cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1 cneg cB
          cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel c1 cneg cc
          wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1 ax1cn
          negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA c1
          cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci cc
          wcel cC cX wcel ci cC cS co cX wcel cU ip1i.9 phnvi axicn ip1i.c ci
          cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cG co ci cC
          cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni cA c1
          cneg cB cS co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cA c1
          cneg cB cS co cG co ci cneg cC cS co cG co cN cfv cA c1 cneg cB cS co
          cG co ci cneg cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi
          cU cnv wcel cA c1 cneg cB cS co cG co cX wcel ci cneg cC cS co cX
          wcel cA c1 cneg cB cS co cG co ci cneg cC cS co cG co cX wcel cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1
          cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel c1
          cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1
          ax1cn negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci
          cneg cc wcel cC cX wcel ci cneg cC cS co cX wcel cU ip1i.9 phnvi ci
          axicn negcli ip1i.c ci cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          c1 cneg cB cS co cG co ci cneg cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli resqcli recni subcli adddii ci c2 cA ci cC cS co cG co cN
          cfv c2 cexp co cA ci cneg cC cS co cG co cN cfv c2 cexp co cmin co
          axicn 2cn cA ci cC cS co cG co cN cfv c2 cexp co cA ci cneg cC cS co
          cG co cN cfv c2 cexp co cA ci cC cS co cG co cN cfv c2 cexp co cA ci
          cC cS co cG co cN cfv cA ci cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel ci cC cS co cX wcel cA ci cC cS
          co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel ci cc wcel cC cX
          wcel ci cC cS co cX wcel cU ip1i.9 phnvi axicn ip1i.c ci cC cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA ci cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli resqcli recni cA ci cneg cC cS co cG co cN cfv c2 cexp co
          cA ci cneg cC cS co cG co cN cfv cA ci cneg cC cS co cG co cU cN cX
          ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cX wcel ci cneg cC cS co
          cX wcel cA ci cneg cC cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU
          cnv wcel ci cneg cc wcel cC cX wcel ci cneg cC cS co cX wcel cU
          ip1i.9 phnvi ci axicn negcli ip1i.c ci cneg cC cS cU cX ip1i.1 ip1i.4
          nvscl mp3an cA ci cneg cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          nvcli resqcli recni subcli mul12i 3eqtr3i opreq12i eqtr4i cA cB cG co
          cC cG co cN cfv c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv
          c2 cexp co cmin co cA c1 cneg cB cS co cG co cC cG co cN cfv c2 cexp
          co cA c1 cneg cB cS co cG co c1 cneg cC cS co cG co cN cfv c2 cexp co
          cmin co ci cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB cG
          co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co ci cA c1
          cneg cB cS co cG co ci cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB
          cS co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co
          cA cB cG co cC cG co cN cfv c2 cexp co cA cB cG co c1 cneg cC cS co
          cG co cN cfv c2 cexp co cA cB cG co cC cG co cN cfv c2 cexp co cA cB
          cG co cC cG co cN cfv cA cB cG co cC cG co cU cN cX ip1i.1 ip1i.6 cU
          ip1i.9 phnvi cU cnv wcel cA cB cG co cX wcel cC cX wcel cA cB cG co
          cC cG co cX wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA
          cB cG co cX wcel cU ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX ip1i.1
          ip1i.2 nvgcl mp3an ip1i.c cA cB cG co cC cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli resqcli recni cA cB cG co c1 cneg cC cS co cG co cN cfv
          c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv cA cB cG co c1
          cneg cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv
          wcel cA cB cG co cX wcel c1 cneg cC cS co cX wcel cA cB cG co c1 cneg
          cC cS co cG co cX wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX
          wcel cA cB cG co cX wcel cU ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX
          ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel c1 cneg cc wcel cC cX wcel c1
          cneg cC cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.c c1 cneg
          cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cB cG co c1 cneg cC cS co cU
          cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni subcli cA c1 cneg
          cB cS co cG co cC cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co
          c1 cneg cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cC
          cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co cC cG co cN cfv cA
          c1 cneg cB cS co cG co cC cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9
          phnvi cU cnv wcel cA c1 cneg cB cS co cG co cX wcel cC cX wcel cA c1
          cneg cB cS co cG co cC cG co cX wcel cU ip1i.9 phnvi cU cnv wcel cA
          cX wcel c1 cneg cB cS co cX wcel cA c1 cneg cB cS co cG co cX wcel cU
          ip1i.9 phnvi ip1i.a cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB
          cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.b c1 cneg cB cS cU
          cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cU cG cX ip1i.1
          ip1i.2 nvgcl mp3an ip1i.c cA c1 cneg cB cS co cG co cC cU cG cX
          ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni cA c1 cneg cB cS co cG
          co c1 cneg cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co
          c1 cneg cC cS co cG co cN cfv cA c1 cneg cB cS co cG co c1 cneg cC cS
          co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA c1
          cneg cB cS co cG co cX wcel c1 cneg cC cS co cX wcel cA c1 cneg cB cS
          co cG co c1 cneg cC cS co cG co cX wcel cU ip1i.9 phnvi cU cnv wcel
          cA cX wcel c1 cneg cB cS co cX wcel cA c1 cneg cB cS co cG co cX wcel
          cU ip1i.9 phnvi ip1i.a cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg
          cB cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.b c1 cneg cB cS
          cU cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cU cG cX ip1i.1
          ip1i.2 nvgcl mp3an cU cnv wcel c1 cneg cc wcel cC cX wcel c1 cneg cC
          cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.c c1 cneg cC cS cU
          cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cG co c1 cneg cC cS
          co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni subcli ci
          cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB cG co ci cneg
          cC cS co cG co cN cfv c2 cexp co cmin co axicn cA cB cG co ci cC cS
          co cG co cN cfv c2 cexp co cA cB cG co ci cneg cC cS co cG co cN cfv
          c2 cexp co cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB cG
          co ci cC cS co cG co cN cfv cA cB cG co ci cC cS co cG co cU cN cX
          ip1i.1 ip1i.6 cU ip1i.9 phnvi cU cnv wcel cA cB cG co cX wcel ci cC
          cS co cX wcel cA cB cG co ci cC cS co cG co cX wcel cU ip1i.9 phnvi
          cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU ip1i.9 phnvi
          ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci
          cc wcel cC cX wcel ci cC cS co cX wcel cU ip1i.9 phnvi axicn ip1i.c
          ci cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA cB cG co ci cC cS co cU
          cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni cA cB cG co ci
          cneg cC cS co cG co cN cfv c2 cexp co cA cB cG co ci cneg cC cS co cG
          co cN cfv cA cB cG co ci cneg cC cS co cG co cU cN cX ip1i.1 ip1i.6
          cU ip1i.9 phnvi cU cnv wcel cA cB cG co cX wcel ci cneg cC cS co cX
          wcel cA cB cG co ci cneg cC cS co cG co cX wcel cU ip1i.9 phnvi cU
          cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU ip1i.9 phnvi
          ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci
          cneg cc wcel cC cX wcel ci cneg cC cS co cX wcel cU ip1i.9 phnvi ci
          axicn negcli ip1i.c ci cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          cB cG co ci cneg cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli
          resqcli recni subcli mulcli ci cA c1 cneg cB cS co cG co ci cC cS co
          cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co cG
          co cN cfv c2 cexp co cmin co axicn cA c1 cneg cB cS co cG co ci cC cS
          co cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co
          cG co cN cfv c2 cexp co cA c1 cneg cB cS co cG co ci cC cS co cG co
          cN cfv c2 cexp co cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv
          cA c1 cneg cB cS co cG co ci cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU
          ip1i.9 phnvi cU cnv wcel cA c1 cneg cB cS co cG co cX wcel ci cC cS
          co cX wcel cA c1 cneg cB cS co cG co ci cC cS co cG co cX wcel cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1
          cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel c1
          cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1
          ax1cn negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci cc
          wcel cC cX wcel ci cC cS co cX wcel cU ip1i.9 phnvi axicn ip1i.c ci
          cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cG co ci cC
          cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli resqcli recni cA c1
          cneg cB cS co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cA c1
          cneg cB cS co cG co ci cneg cC cS co cG co cN cfv cA c1 cneg cB cS co
          cG co ci cneg cC cS co cG co cU cN cX ip1i.1 ip1i.6 cU ip1i.9 phnvi
          cU cnv wcel cA c1 cneg cB cS co cG co cX wcel ci cneg cC cS co cX
          wcel cA c1 cneg cB cS co cG co ci cneg cC cS co cG co cX wcel cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1
          cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel c1
          cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1
          ax1cn negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel ci
          cneg cc wcel cC cX wcel ci cneg cC cS co cX wcel cU ip1i.9 phnvi ci
          axicn negcli ip1i.c ci cneg cC cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
          c1 cneg cB cS co cG co ci cneg cC cS co cU cG cX ip1i.1 ip1i.2 nvgcl
          mp3an nvcli resqcli recni subcli mulcli add4i c4 cA cB cG co cC cP co
          cA c1 cneg cB cS co cG co cC cP co caddc co cmul co c4 cA cB cG co cC
          cP co cmul co c4 cA c1 cneg cB cS co cG co cC cP co cmul co caddc co
          cA cB cG co cC cG co cN cfv c2 cexp co cA cB cG co c1 cneg cC cS co
          cG co cN cfv c2 cexp co cmin co ci cA cB cG co ci cC cS co cG co cN
          cfv c2 cexp co cA cB cG co ci cneg cC cS co cG co cN cfv c2 cexp co
          cmin co cmul co caddc co cA c1 cneg cB cS co cG co cC cG co cN cfv c2
          cexp co cA c1 cneg cB cS co cG co c1 cneg cC cS co cG co cN cfv c2
          cexp co cmin co ci cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv
          c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co cG co cN cfv c2
          cexp co cmin co cmul co caddc co caddc co c4 cA cB cG co cC cP co cA
          c1 cneg cB cS co cG co cC cP co c4 4re recni cU cnv wcel cA cB cG co
          cX wcel cC cX wcel cA cB cG co cC cP co cc wcel cU ip1i.9 phnvi cU
          cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU ip1i.9 phnvi
          ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an ip1i.c cA cB
          cG co cC cP cU cX ip1i.1 ip1i.7 ipcl mp3an cU cnv wcel cA c1 cneg cB
          cS co cG co cX wcel cC cX wcel cA c1 cneg cB cS co cG co cC cP co cc
          wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel
          cA c1 cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU cnv wcel
          c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi
          c1 ax1cn negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an
          cA c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an ip1i.c cA c1
          cneg cB cS co cG co cC cP cU cX ip1i.1 ip1i.7 ipcl mp3an adddii c4 cA
          cB cG co cC cP co cmul co cA cB cG co cC cG co cN cfv c2 cexp co cA
          cB cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co ci cA cB cG
          co ci cC cS co cG co cN cfv c2 cexp co cA cB cG co ci cneg cC cS co
          cG co cN cfv c2 cexp co cmin co cmul co caddc co c4 cA c1 cneg cB cS
          co cG co cC cP co cmul co cA c1 cneg cB cS co cG co cC cG co cN cfv
          c2 cexp co cA c1 cneg cB cS co cG co c1 cneg cC cS co cG co cN cfv c2
          cexp co cmin co ci cA c1 cneg cB cS co cG co ci cC cS co cG co cN cfv
          c2 cexp co cA c1 cneg cB cS co cG co ci cneg cC cS co cG co cN cfv c2
          cexp co cmin co cmul co caddc co caddc cU cnv wcel cA cB cG co cX
          wcel cC cX wcel c4 cA cB cG co cC cP co cmul co cA cB cG co cC cG co
          cN cfv c2 cexp co cA cB cG co c1 cneg cC cS co cG co cN cfv c2 cexp
          co cmin co ci cA cB cG co ci cC cS co cG co cN cfv c2 cexp co cA cB
          cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co caddc
          co wceq cU ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG co
          cX wcel cU ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an ip1i.c cA cB cG co cC cP cS cU cG cN cX ip1i.1 ip1i.2
          ip1i.4 ip1i.6 ip1i.7 4ipval2 mp3an cU cnv wcel cA c1 cneg cB cS co cG
          co cX wcel cC cX wcel c4 cA c1 cneg cB cS co cG co cC cP co cmul co
          cA c1 cneg cB cS co cG co cC cG co cN cfv c2 cexp co cA c1 cneg cB cS
          co cG co c1 cneg cC cS co cG co cN cfv c2 cexp co cmin co ci cA c1
          cneg cB cS co cG co ci cC cS co cG co cN cfv c2 cexp co cA c1 cneg cB
          cS co cG co ci cneg cC cS co cG co cN cfv c2 cexp co cmin co cmul co
          caddc co wceq cU ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg cB cS co
          cX wcel cA c1 cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ip1i.a cU
          cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU
          ip1i.9 phnvi c1 ax1cn negcli ip1i.b c1 cneg cB cS cU cX ip1i.1 ip1i.4
          nvscl mp3an cA c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          ip1i.c cA c1 cneg cB cS co cG co cC cP cS cU cG cN cX ip1i.1 ip1i.2
          ip1i.4 ip1i.6 ip1i.7 4ipval2 mp3an opreq12i eqtr2i 3eqtri 3eqtr3ri
          opreq1i cA cB cG co cC cP co cA c1 cneg cB cS co cG co cC cP co caddc
          co c4 cA cB cG co cC cP co cA c1 cneg cB cS co cG co cC cP co cU cnv
          wcel cA cB cG co cX wcel cC cX wcel cA cB cG co cC cP co cc wcel cU
          ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU
          ip1i.9 phnvi ip1i.a ip1i.b cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
          ip1i.c cA cB cG co cC cP cU cX ip1i.1 ip1i.7 ipcl mp3an cU cnv wcel
          cA c1 cneg cB cS co cG co cX wcel cC cX wcel cA c1 cneg cB cS co cG
          co cC cP co cc wcel cU ip1i.9 phnvi cU cnv wcel cA cX wcel c1 cneg cB
          cS co cX wcel cA c1 cneg cB cS co cG co cX wcel cU ip1i.9 phnvi
          ip1i.a cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX
          wcel cU ip1i.9 phnvi c1 ax1cn negcli ip1i.b c1 cneg cB cS cU cX
          ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2
          nvgcl mp3an ip1i.c cA c1 cneg cB cS co cG co cC cP cU cX ip1i.1
          ip1i.7 ipcl mp3an addcli c4 4re recni c4 4re 4pos gt0ne0ii divcan3i
          c2 cA cC cP co cmul co c4 c2 cA cC cP co 2cn cU cnv wcel cA cX wcel
          cC cX wcel cA cC cP co cc wcel cU ip1i.9 phnvi ip1i.a ip1i.c cA cC cP
          cU cX ip1i.1 ip1i.7 ipcl mp3an mulcli c4 4re recni c4 4re 4pos
          gt0ne0ii divcan3i 3eqtr3i $.
          $( [31-Oct-2007] $) $( [21-Apr-2007] $)
      $}

      $( Equation 6.47 of [Ponnusamy] p. 362. $)
      ip1i $p |- ( ( ( A G B ) P C ) +
                       ( ( A G ( -u 1 S B ) ) P C ) ) = ( 2 x. ( A P C ) ) $=
        cA cB cC cP cS cU cG c1 cU cnm cfv cX ip1i.1 ip1i.2 ip1i.4 ip1i.7
        ip1i.9 ip1i.a ip1i.b ip1i.c cU cnm cfv eqid ax1cn ip1ilem $.
        $( [1-Nov-2007] $) $( [27-Apr-2007] $)
    $}

    ${
      ip2i.8 $e |- A e. X $.
      ip2i.9 $e |- B e. X $.
      $( Equation 6.48 of [Ponnusamy] p. 362. $)
      ip2i $p |- ( ( 2 S A ) P B ) = ( 2 x. ( A P B ) ) $=
        c2 cA cS co cB cP co cA cA cG co cB cP co cc0 caddc co cA cA cG co cB
        cP co cA c1 cneg cA cS co cG co cB cP co caddc co c2 cA cB cP co cmul
        co c2 cA cS co cB cP co cA cA cG co cB cP co cA cA cG co cB cP co cc0
        caddc co c2 cA cS co cA cA cG co cB cP c2 cA cS co c1 c1 caddc co cA cS
        co c1 cA cS co c1 cA cS co cG co cA cA cG co c2 c1 c1 caddc co cA cS
        df-2 opreq1i cU cnv wcel c1 cc wcel c1 cc wcel cA cX wcel w3a c1 c1
        caddc co cA cS co c1 cA cS co c1 cA cS co cG co wceq cU ip1i.9 phnvi c1
        cc wcel c1 cc wcel cA cX wcel ax1cn ax1cn ip2i.8 3pm3.2i c1 c1 cA cS cU
        cG cX ip1i.1 ip1i.2 ip1i.4 nvdir mp2an c1 cA cS co cA c1 cA cS co cA cG
        cU cnv wcel cA cX wcel c1 cA cS co cA wceq cU ip1i.9 phnvi ip2i.8 cA cS
        cU cX ip1i.1 ip1i.4 nvsid mp2an cU cnv wcel cA cX wcel c1 cA cS co cA
        wceq cU ip1i.9 phnvi ip2i.8 cA cS cU cX ip1i.1 ip1i.4 nvsid mp2an
        opreq12i 3eqtri opreq1i cA cA cG co cB cP co cU cnv wcel cA cA cG co cX
        wcel cB cX wcel cA cA cG co cB cP co cc wcel cU ip1i.9 phnvi cU cnv
        wcel cA cX wcel cA cX wcel cA cA cG co cX wcel cU ip1i.9 phnvi ip2i.8
        ip2i.8 cA cA cU cG cX ip1i.1 ip1i.2 nvgcl mp3an ip2i.9 cA cA cG co cB
        cP cU cX ip1i.1 ip1i.7 ipcl mp3an addid1i eqtr4i cA c1 cneg cA cS co cG
        co cB cP co cc0 cA cA cG co cB cP co caddc cA c1 cneg cA cS co cG co cB
        cP co cU cn0v cfv cB cP co cc0 cA c1 cneg cA cS co cG co cU cn0v cfv cB
        cP cU cnv wcel cA cX wcel cA c1 cneg cA cS co cG co cU cn0v cfv wceq cU
        ip1i.9 phnvi ip2i.8 cA cS cU cG cX cU cn0v cfv ip1i.1 ip1i.2 ip1i.4 cU
        cn0v cfv eqid nvrinv mp2an opreq1i cU cnv wcel cB cX wcel cU cn0v cfv
        cB cP co cc0 wceq cU ip1i.9 phnvi ip2i.9 cB cP cU cX cU cn0v cfv ip1i.1
        cU cn0v cfv eqid ip1i.7 ip0l mp2an eqtri opreq2i cA cA cB cP cS cU cG
        cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 ip2i.8 ip2i.8 ip2i.9 ip1i 3eqtr2i
        $.
        $( [3-Nov-2007] $) $( [26-Apr-2007] $)
    $}

    ${
      ipdiri.8 $e |- A e. X $.
      ipdiri.9 $e |- B e. X $.
      ipdiri.10 $e |- C e. X $.
      $( Lemma for ~ ipdiri . $)
      ipdirilem $p |- ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) $=
        cA cB cG co cC cP co c2 c1 c2 cdiv co cA cB cG co cS co cC cP co cmul
        co c1 c2 cdiv co cA cB cG co cS co c1 c2 cdiv co cA c1 cneg cB cS co cG
        co cS co cG co cC cP co c1 c2 cdiv co cA cB cG co cS co c1 cneg c1 c2
        cdiv co cA c1 cneg cB cS co cG co cS co cS co cG co cC cP co caddc co
        cA cC cP co cB cC cP co caddc co c2 c1 c2 cdiv co cA cB cG co cS co cS
        co cC cP co cA cB cG co cC cP co c2 c1 c2 cdiv co cA cB cG co cS co cC
        cP co cmul co c2 c1 c2 cdiv co cA cB cG co cS co cS co cA cB cG co cC
        cP c2 c1 c2 cdiv co cmul co cA cB cG co cS co c1 cA cB cG co cS co c2
        c1 c2 cdiv co cA cB cG co cS co cS co cA cB cG co c2 c1 c2 cdiv co cmul
        co c1 cA cB cG co cS c2 2cn 2ne0 recidi opreq1i cU cnv wcel c2 cc wcel
        c1 c2 cdiv co cc wcel cA cB cG co cX wcel w3a c2 c1 c2 cdiv co cmul co
        cA cB cG co cS co c2 c1 c2 cdiv co cA cB cG co cS co cS co wceq cU
        ip1i.9 phnvi c2 cc wcel c1 c2 cdiv co cc wcel cA cB cG co cX wcel 2cn
        c2 2cn 2ne0 reccli cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX
        wcel cU ip1i.9 phnvi ipdiri.8 ipdiri.9 cA cB cU cG cX ip1i.1 ip1i.2
        nvgcl mp3an 3pm3.2i c2 c1 c2 cdiv co cA cB cG co cS cU cX ip1i.1 ip1i.4
        nvsass mp2an cU cnv wcel cA cB cG co cX wcel c1 cA cB cG co cS co cA cB
        cG co wceq cU ip1i.9 phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG
        co cX wcel cU ip1i.9 phnvi ipdiri.8 ipdiri.9 cA cB cU cG cX ip1i.1
        ip1i.2 nvgcl mp3an cA cB cG co cS cU cX ip1i.1 ip1i.4 nvsid mp2an
        3eqtr3i opreq1i c1 c2 cdiv co cA cB cG co cS co cC cP cS cU cG cX
        ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 cU cnv wcel c1 c2 cdiv co cc wcel cA
        cB cG co cX wcel c1 c2 cdiv co cA cB cG co cS co cX wcel cU ip1i.9
        phnvi c2 2cn 2ne0 reccli cU cnv wcel cA cX wcel cB cX wcel cA cB cG co
        cX wcel cU ip1i.9 phnvi ipdiri.8 ipdiri.9 cA cB cU cG cX ip1i.1 ip1i.2
        nvgcl mp3an c1 c2 cdiv co cA cB cG co cS cU cX ip1i.1 ip1i.4 nvscl
        mp3an ipdiri.10 ip2i eqtr3i c1 c2 cdiv co cA cB cG co cS co c1 c2 cdiv
        co cA c1 cneg cB cS co cG co cS co cC cP cS cU cG cX ip1i.1 ip1i.2
        ip1i.4 ip1i.7 ip1i.9 cU cnv wcel c1 c2 cdiv co cc wcel cA cB cG co cX
        wcel c1 c2 cdiv co cA cB cG co cS co cX wcel cU ip1i.9 phnvi c2 2cn
        2ne0 reccli cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cU
        ip1i.9 phnvi ipdiri.8 ipdiri.9 cA cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
        c1 c2 cdiv co cA cB cG co cS cU cX ip1i.1 ip1i.4 nvscl mp3an cU cnv
        wcel c1 c2 cdiv co cc wcel cA c1 cneg cB cS co cG co cX wcel c1 c2 cdiv
        co cA c1 cneg cB cS co cG co cS co cX wcel cU ip1i.9 phnvi c2 2cn 2ne0
        reccli cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1 cneg cB cS
        co cG co cX wcel cU ip1i.9 phnvi ipdiri.8 cU cnv wcel c1 cneg cc wcel
        cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli
        ipdiri.9 c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS
        co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an c1 c2 cdiv co cA c1 cneg cB cS co
        cG co cS cU cX ip1i.1 ip1i.4 nvscl mp3an ipdiri.10 ip1i c1 c2 cdiv co
        cA cB cG co cS co c1 c2 cdiv co cA c1 cneg cB cS co cG co cS co cG co
        cC cP co cA cC cP co c1 c2 cdiv co cA cB cG co cS co c1 cneg c1 c2 cdiv
        co cA c1 cneg cB cS co cG co cS co cS co cG co cC cP co cB cC cP co
        caddc c1 c2 cdiv co cA cB cG co cS co c1 c2 cdiv co cA c1 cneg cB cS co
        cG co cS co cG co cA cC cP c1 c2 cdiv co cA cB cG co cA c1 cneg cB cS
        co cG co cG co cS co c1 c2 cdiv co cA cB cG co cS co c1 c2 cdiv co cA
        c1 cneg cB cS co cG co cS co cG co cA cU cnv wcel c1 c2 cdiv co cc wcel
        cA cB cG co cX wcel cA c1 cneg cB cS co cG co cX wcel w3a c1 c2 cdiv co
        cA cB cG co cA c1 cneg cB cS co cG co cG co cS co c1 c2 cdiv co cA cB
        cG co cS co c1 c2 cdiv co cA c1 cneg cB cS co cG co cS co cG co wceq cU
        ip1i.9 phnvi c1 c2 cdiv co cc wcel cA cB cG co cX wcel cA c1 cneg cB cS
        co cG co cX wcel c2 2cn 2ne0 reccli cU cnv wcel cA cX wcel cB cX wcel
        cA cB cG co cX wcel cU ip1i.9 phnvi ipdiri.8 ipdiri.9 cA cB cU cG cX
        ip1i.1 ip1i.2 nvgcl mp3an cU cnv wcel cA cX wcel c1 cneg cB cS co cX
        wcel cA c1 cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ipdiri.8 cU cnv
        wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9
        phnvi c1 ax1cn negcli ipdiri.9 c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl
        mp3an cA c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an 3pm3.2i c1
        c2 cdiv co cA cB cG co cA c1 cneg cB cS co cG co cS cU cG cX ip1i.1
        ip1i.2 ip1i.4 nvdi mp2an c1 c2 cdiv co cA cB cG co cA c1 cneg cB cS co
        cG co cG co cS co c1 c2 cdiv co c2 cA cS co cS co c1 c2 cdiv co c2 cmul
        co cA cS co cA cA cB cG co cA c1 cneg cB cS co cG co cG co c2 cA cS co
        c1 c2 cdiv co cS cA cB cG co cA c1 cneg cB cS co cG co cG co cA cA cG
        co cB c1 cneg cB cS co cG co cG co c2 cA cS co cU cn0v cfv cG co c2 cA
        cS co cG cabl wcel cA cX wcel cB cX wcel wa cA cX wcel c1 cneg cB cS co
        cX wcel wa cA cB cG co cA c1 cneg cB cS co cG co cG co cA cA cG co cB
        c1 cneg cB cS co cG co cG co wceq cU c1st cfv cvc wcel cG cabl wcel cU
        cnv wcel cU c1st cfv cvc wcel cU ip1i.9 phnvi cU cU c1st cfv cU c1st
        cfv eqid nvvc ax-mp cG cU c1st cfv cU cG ip1i.2 vafval vcabl ax-mp cA
        cX wcel cB cX wcel ipdiri.8 ipdiri.9 pm3.2i cA cX wcel c1 cneg cB cS co
        cX wcel ipdiri.8 cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cS
        co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ipdiri.9 c1 cneg cB cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an pm3.2i cA cB cA c1 cneg cB cS co cG cX cU cG
        cX ip1i.1 ip1i.2 bafval abl4 mp3an cA cA cG co c2 cA cS co cB c1 cneg
        cB cS co cG co cU cn0v cfv cG cU c1st cfv cvc wcel cA cX wcel cA cA cG
        co c2 cA cS co wceq cU cnv wcel cU c1st cfv cvc wcel cU ip1i.9 phnvi cU
        cU c1st cfv cU c1st cfv eqid nvvc ax-mp ipdiri.8 cA cS cG cU c1st cfv
        cX cU cG ip1i.2 vafval cS cU ip1i.4 smfval cU cG cX ip1i.1 ip1i.2
        bafval vc2 mp2an cU cnv wcel cB cX wcel cB c1 cneg cB cS co cG co cU
        cn0v cfv wceq cU ip1i.9 phnvi ipdiri.9 cB cS cU cG cX cU cn0v cfv
        ip1i.1 ip1i.2 ip1i.4 cU cn0v cfv eqid nvrinv mp2an opreq12i cU cnv wcel
        c2 cA cS co cX wcel c2 cA cS co cU cn0v cfv cG co c2 cA cS co wceq cU
        ip1i.9 phnvi cU cnv wcel c2 cc wcel cA cX wcel c2 cA cS co cX wcel cU
        ip1i.9 phnvi 2cn ipdiri.8 c2 cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an c2
        cA cS co cU cG cX cU cn0v cfv ip1i.1 ip1i.2 cU cn0v cfv eqid nv0rid
        mp2an 3eqtri opreq2i cU cnv wcel c1 c2 cdiv co cc wcel c2 cc wcel cA cX
        wcel w3a c1 c2 cdiv co c2 cmul co cA cS co c1 c2 cdiv co c2 cA cS co cS
        co wceq cU ip1i.9 phnvi c1 c2 cdiv co cc wcel c2 cc wcel cA cX wcel c2
        2cn 2ne0 reccli 2cn ipdiri.8 3pm3.2i c1 c2 cdiv co c2 cA cS cU cX
        ip1i.1 ip1i.4 nvsass mp2an c1 c2 cdiv co c2 cmul co cA cS co c1 cA cS
        co cA c1 c2 cdiv co c2 cmul co c1 cA cS c1 c2 ax1cn 2cn 2ne0 divcan1i
        opreq1i cU cnv wcel cA cX wcel c1 cA cS co cA wceq cU ip1i.9 phnvi
        ipdiri.8 cA cS cU cX ip1i.1 ip1i.4 nvsid mp2an eqtri 3eqtr2i eqtr3i
        opreq1i c1 c2 cdiv co cA cB cG co cS co c1 cneg c1 c2 cdiv co cA c1
        cneg cB cS co cG co cS co cS co cG co cB cC cP c1 c2 cdiv co cA cB cG
        co c1 cneg cA cS co cB cG co cG co cS co c1 c2 cdiv co cA cB cG co cS
        co c1 c2 cdiv co c1 cneg cA cS co cB cG co cS co cG co cB c1 c2 cdiv co
        cA cB cG co cS co c1 cneg c1 c2 cdiv co cA c1 cneg cB cS co cG co cS co
        cS co cG co cU cnv wcel c1 c2 cdiv co cc wcel cA cB cG co cX wcel c1
        cneg cA cS co cB cG co cX wcel w3a c1 c2 cdiv co cA cB cG co c1 cneg cA
        cS co cB cG co cG co cS co c1 c2 cdiv co cA cB cG co cS co c1 c2 cdiv
        co c1 cneg cA cS co cB cG co cS co cG co wceq cU ip1i.9 phnvi c1 c2
        cdiv co cc wcel cA cB cG co cX wcel c1 cneg cA cS co cB cG co cX wcel
        c2 2cn 2ne0 reccli cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cX
        wcel cU ip1i.9 phnvi ipdiri.8 ipdiri.9 cA cB cU cG cX ip1i.1 ip1i.2
        nvgcl mp3an cU cnv wcel c1 cneg cA cS co cX wcel cB cX wcel c1 cneg cA
        cS co cB cG co cX wcel cU ip1i.9 phnvi cU cnv wcel c1 cneg cc wcel cA
        cX wcel c1 cneg cA cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli
        ipdiri.8 c1 cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an ipdiri.9 c1 cneg
        cA cS co cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an 3pm3.2i c1 c2 cdiv co cA
        cB cG co c1 cneg cA cS co cB cG co cS cU cG cX ip1i.1 ip1i.2 ip1i.4
        nvdi mp2an c1 c2 cdiv co cA cB cG co c1 cneg cA cS co cB cG co cG co cS
        co c1 c2 cdiv co c2 cB cS co cS co c1 cB cS co cB cA cB cG co c1 cneg
        cA cS co cB cG co cG co c2 cB cS co c1 c2 cdiv co cS cA cB cG co c1
        cneg cA cS co cB cG co cG co cA c1 cneg cA cS co cG co cB cB cG co cG
        co cB cB cG co c2 cB cS co cG cabl wcel cA cX wcel cB cX wcel wa c1
        cneg cA cS co cX wcel cB cX wcel wa cA cB cG co c1 cneg cA cS co cB cG
        co cG co cA c1 cneg cA cS co cG co cB cB cG co cG co wceq cU c1st cfv
        cvc wcel cG cabl wcel cU cnv wcel cU c1st cfv cvc wcel cU ip1i.9 phnvi
        cU cU c1st cfv cU c1st cfv eqid nvvc ax-mp cG cU c1st cfv cU cG ip1i.2
        vafval vcabl ax-mp cA cX wcel cB cX wcel ipdiri.8 ipdiri.9 pm3.2i c1
        cneg cA cS co cX wcel cB cX wcel cU cnv wcel c1 cneg cc wcel cA cX wcel
        c1 cneg cA cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ipdiri.8 c1
        cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an ipdiri.9 pm3.2i cA cB c1
        cneg cA cS co cB cG cX cU cG cX ip1i.1 ip1i.2 bafval abl4 mp3an cA c1
        cneg cA cS co cG co cB cB cG co cG co cU cn0v cfv cB cB cG co cG co cB
        cB cG co cA c1 cneg cA cS co cG co cU cn0v cfv cB cB cG co cG cU cnv
        wcel cA cX wcel cA c1 cneg cA cS co cG co cU cn0v cfv wceq cU ip1i.9
        phnvi ipdiri.8 cA cS cU cG cX cU cn0v cfv ip1i.1 ip1i.2 ip1i.4 cU cn0v
        cfv eqid nvrinv mp2an opreq1i cU cnv wcel cB cB cG co cX wcel cU cn0v
        cfv cB cB cG co cG co cB cB cG co wceq cU ip1i.9 phnvi cU cnv wcel cB
        cX wcel cB cX wcel cB cB cG co cX wcel cU ip1i.9 phnvi ipdiri.9
        ipdiri.9 cB cB cU cG cX ip1i.1 ip1i.2 nvgcl mp3an cB cB cG co cU cG cX
        cU cn0v cfv ip1i.1 ip1i.2 cU cn0v cfv eqid nv0lid mp2an eqtri cU c1st
        cfv cvc wcel cB cX wcel cB cB cG co c2 cB cS co wceq cU cnv wcel cU
        c1st cfv cvc wcel cU ip1i.9 phnvi cU cU c1st cfv cU c1st cfv eqid nvvc
        ax-mp ipdiri.9 cB cS cG cU c1st cfv cX cU cG ip1i.2 vafval cS cU ip1i.4
        smfval cU cG cX ip1i.1 ip1i.2 bafval vc2 mp2an 3eqtri opreq2i c1 c2
        cdiv co c2 cmul co cB cS co c1 c2 cdiv co c2 cB cS co cS co c1 cB cS co
        cU cnv wcel c1 c2 cdiv co cc wcel c2 cc wcel cB cX wcel w3a c1 c2 cdiv
        co c2 cmul co cB cS co c1 c2 cdiv co c2 cB cS co cS co wceq cU ip1i.9
        phnvi c1 c2 cdiv co cc wcel c2 cc wcel cB cX wcel c2 2cn 2ne0 reccli
        2cn ipdiri.9 3pm3.2i c1 c2 cdiv co c2 cB cS cU cX ip1i.1 ip1i.4 nvsass
        mp2an c1 c2 cdiv co c2 cmul co c1 cB cS c1 c2 ax1cn 2cn 2ne0 divcan1i
        opreq1i eqtr3i cU cnv wcel cB cX wcel c1 cB cS co cB wceq cU ip1i.9
        phnvi ipdiri.9 cB cS cU cX ip1i.1 ip1i.4 nvsid mp2an 3eqtrri c1 cneg c1
        c2 cdiv co cA c1 cneg cB cS co cG co cS co cS co c1 c2 cdiv co c1 cneg
        cA cS co cB cG co cS co c1 c2 cdiv co cA cB cG co cS co cG c1 cneg c1
        c2 cdiv co cmul co cA c1 cneg cB cS co cG co cS co c1 cneg c1 c2 cdiv
        co cA c1 cneg cB cS co cG co cS co cS co c1 c2 cdiv co c1 cneg cA cS co
        cB cG co cS co cU cnv wcel c1 cneg cc wcel c1 c2 cdiv co cc wcel cA c1
        cneg cB cS co cG co cX wcel w3a c1 cneg c1 c2 cdiv co cmul co cA c1
        cneg cB cS co cG co cS co c1 cneg c1 c2 cdiv co cA c1 cneg cB cS co cG
        co cS co cS co wceq cU ip1i.9 phnvi c1 cneg cc wcel c1 c2 cdiv co cc
        wcel cA c1 cneg cB cS co cG co cX wcel c1 ax1cn negcli c2 2cn 2ne0
        reccli cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel cA c1 cneg cB cS
        co cG co cX wcel cU ip1i.9 phnvi ipdiri.8 cU cnv wcel c1 cneg cc wcel
        cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli
        ipdiri.9 c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA c1 cneg cB cS
        co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an 3pm3.2i c1 cneg c1 c2 cdiv co cA
        c1 cneg cB cS co cG co cS cU cX ip1i.1 ip1i.4 nvsass mp2an c1 cneg c1
        c2 cdiv co cmul co cA c1 cneg cB cS co cG co cS co c1 c2 cdiv co c1
        cneg cmul co cA c1 cneg cB cS co cG co cS co c1 c2 cdiv co c1 cneg cA
        c1 cneg cB cS co cG co cS co cS co c1 c2 cdiv co c1 cneg cA cS co cB cG
        co cS co c1 cneg c1 c2 cdiv co cmul co c1 c2 cdiv co c1 cneg cmul co cA
        c1 cneg cB cS co cG co cS c1 cneg c1 c2 cdiv co c1 ax1cn negcli c2 2cn
        2ne0 reccli mulcomi opreq1i cU cnv wcel c1 c2 cdiv co cc wcel c1 cneg
        cc wcel cA c1 cneg cB cS co cG co cX wcel w3a c1 c2 cdiv co c1 cneg
        cmul co cA c1 cneg cB cS co cG co cS co c1 c2 cdiv co c1 cneg cA c1
        cneg cB cS co cG co cS co cS co wceq cU ip1i.9 phnvi c1 c2 cdiv co cc
        wcel c1 cneg cc wcel cA c1 cneg cB cS co cG co cX wcel c2 2cn 2ne0
        reccli c1 ax1cn negcli cU cnv wcel cA cX wcel c1 cneg cB cS co cX wcel
        cA c1 cneg cB cS co cG co cX wcel cU ip1i.9 phnvi ipdiri.8 cU cnv wcel
        c1 cneg cc wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1
        ax1cn negcli ipdiri.9 c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an cA
        c1 cneg cB cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an 3pm3.2i c1 c2 cdiv
        co c1 cneg cA c1 cneg cB cS co cG co cS cU cX ip1i.1 ip1i.4 nvsass
        mp2an c1 cneg cA c1 cneg cB cS co cG co cS co c1 cneg cA cS co cB cG co
        c1 c2 cdiv co cS c1 cneg cA c1 cneg cB cS co cG co cS co c1 cneg cA cS
        co c1 cneg c1 cneg cB cS co cS co cG co c1 cneg cA cS co cB cG co cU
        cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cB cS co cX wcel w3a c1
        cneg cA c1 cneg cB cS co cG co cS co c1 cneg cA cS co c1 cneg c1 cneg
        cB cS co cS co cG co wceq cU ip1i.9 phnvi c1 cneg cc wcel cA cX wcel c1
        cneg cB cS co cX wcel c1 ax1cn negcli ipdiri.8 cU cnv wcel c1 cneg cc
        wcel cB cX wcel c1 cneg cB cS co cX wcel cU ip1i.9 phnvi c1 ax1cn
        negcli ipdiri.9 c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvscl mp3an 3pm3.2i
        c1 cneg cA c1 cneg cB cS co cS cU cG cX ip1i.1 ip1i.2 ip1i.4 nvdi mp2an
        c1 cneg c1 cneg cB cS co cS co cB c1 cneg cA cS co cG c1 cneg c1 cneg
        cmul co cB cS co c1 cB cS co c1 cneg c1 cneg cB cS co cS co cB c1 cneg
        c1 cneg cmul co c1 cB cS c1 cneg c1 cneg cmul co c1 c1 cmul co c1 c1 c1
        ax1cn ax1cn mul2negi c1 ax1cn mulid1i eqtri opreq1i cU cnv wcel c1 cneg
        cc wcel c1 cneg cc wcel cB cX wcel w3a c1 cneg c1 cneg cmul co cB cS co
        c1 cneg c1 cneg cB cS co cS co wceq cU ip1i.9 phnvi c1 cneg cc wcel c1
        cneg cc wcel cB cX wcel c1 ax1cn negcli c1 ax1cn negcli ipdiri.9
        3pm3.2i c1 cneg c1 cneg cB cS cU cX ip1i.1 ip1i.4 nvsass mp2an cU cnv
        wcel cB cX wcel c1 cB cS co cB wceq cU ip1i.9 phnvi ipdiri.9 cB cS cU
        cX ip1i.1 ip1i.4 nvsid mp2an 3eqtr3i opreq2i eqtri opreq2i 3eqtri
        eqtr3i opreq2i 3eqtr4ri opreq1i opreq12i 3eqtr2i $.
        $( [4-Nov-2007] $) $( [26-Apr-2007] $)
    $}

    $( Distributive law for inner product.  Equation I3 of [Ponnusamy]
       p. 362. $)
    ipdiri $p |- ( ( A e. X /\ B e. X /\ C e. X ) ->
                 ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) ) $=
      cA cX wcel cB cX wcel cC cX wcel cA cB cG co cC cP co cA cC cP co cB cC
      cP co caddc co wceq cA cX wcel cA cU cn0v cfv cif cB cG co cC cP co cA cX
      wcel cA cU cn0v cfv cif cC cP co cB cC cP co caddc co wceq cA cB cC cU
      cn0v cfv cU cn0v cfv cU cn0v cfv cA cX wcel cA cU cn0v cfv cif cB cX wcel
      cB cU cn0v cfv cif cG co cC cP co cA cX wcel cA cU cn0v cfv cif cC cP co
      cB cX wcel cB cU cn0v cfv cif cC cP co caddc co wceq cA cX wcel cA cU
      cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cG co cC cX wcel cC cU cn0v
      cfv cif cP co cA cX wcel cA cU cn0v cfv cif cC cX wcel cC cU cn0v cfv cif
      cP co cB cX wcel cB cU cn0v cfv cif cC cX wcel cC cU cn0v cfv cif cP co
      caddc co wceq cA cA cX wcel cA cU cn0v cfv cif wceq cA cB cG co cC cP co
      cA cX wcel cA cU cn0v cfv cif cB cG co cC cP co cA cC cP co cB cC cP co
      caddc co cA cX wcel cA cU cn0v cfv cif cC cP co cB cC cP co caddc co cA
      cA cX wcel cA cU cn0v cfv cif wceq cA cB cG co cA cX wcel cA cU cn0v cfv
      cif cB cG co cC cP cA cA cX wcel cA cU cn0v cfv cif cB cG opreq1 opreq1d
      cA cA cX wcel cA cU cn0v cfv cif wceq cA cC cP co cA cX wcel cA cU cn0v
      cfv cif cC cP co cB cC cP co caddc cA cA cX wcel cA cU cn0v cfv cif cC cP
      opreq1 opreq1d eqeq12d cB cB cX wcel cB cU cn0v cfv cif wceq cA cX wcel
      cA cU cn0v cfv cif cB cG co cC cP co cA cX wcel cA cU cn0v cfv cif cB cX
      wcel cB cU cn0v cfv cif cG co cC cP co cA cX wcel cA cU cn0v cfv cif cC
      cP co cB cC cP co caddc co cA cX wcel cA cU cn0v cfv cif cC cP co cB cX
      wcel cB cU cn0v cfv cif cC cP co caddc co cB cB cX wcel cB cU cn0v cfv
      cif wceq cA cX wcel cA cU cn0v cfv cif cB cG co cA cX wcel cA cU cn0v cfv
      cif cB cX wcel cB cU cn0v cfv cif cG co cC cP cB cB cX wcel cB cU cn0v
      cfv cif cA cX wcel cA cU cn0v cfv cif cG opreq2 opreq1d cB cB cX wcel cB
      cU cn0v cfv cif wceq cB cC cP co cB cX wcel cB cU cn0v cfv cif cC cP co
      cA cX wcel cA cU cn0v cfv cif cC cP co caddc cB cB cX wcel cB cU cn0v cfv
      cif cC cP opreq1 opreq2d eqeq12d cC cC cX wcel cC cU cn0v cfv cif wceq cA
      cX wcel cA cU cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cG co cC cP co
      cA cX wcel cA cU cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cG co cC cX
      wcel cC cU cn0v cfv cif cP co cA cX wcel cA cU cn0v cfv cif cC cP co cB
      cX wcel cB cU cn0v cfv cif cC cP co caddc co cA cX wcel cA cU cn0v cfv
      cif cC cX wcel cC cU cn0v cfv cif cP co cB cX wcel cB cU cn0v cfv cif cC
      cX wcel cC cU cn0v cfv cif cP co caddc co cC cC cX wcel cC cU cn0v cfv
      cif cA cX wcel cA cU cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cG co cP
      opreq2 cC cC cX wcel cC cU cn0v cfv cif wceq cA cX wcel cA cU cn0v cfv
      cif cC cP co cA cX wcel cA cU cn0v cfv cif cC cX wcel cC cU cn0v cfv cif
      cP co cB cX wcel cB cU cn0v cfv cif cC cP co cB cX wcel cB cU cn0v cfv
      cif cC cX wcel cC cU cn0v cfv cif cP co caddc cC cC cX wcel cC cU cn0v
      cfv cif cA cX wcel cA cU cn0v cfv cif cP opreq2 cC cC cX wcel cC cU cn0v
      cfv cif cB cX wcel cB cU cn0v cfv cif cP opreq2 opreq12d eqeq12d cA cX
      wcel cA cU cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cC cX wcel cC cU
      cn0v cfv cif cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 cA cU cX
      cU cn0v cfv ip1i.1 cU cn0v cfv eqid ip1i.9 elimph cB cU cX cU cn0v cfv
      ip1i.1 cU cn0v cfv eqid ip1i.9 elimph cC cU cX cU cn0v cfv ip1i.1 cU cn0v
      cfv eqid ip1i.9 elimph ipdirilem dedth3h $.
      $( [5-Nov-2007] $) $( [27-Apr-2007] $)

    ${
      $d j k A $.  $d j k B $.  $d j k C $.  $d j N $.  $d j k P $.
      $d j k S $.  $d j k X $.
      ipasslem1.b $e |- B e. X $.
      $( Lemma for ~ ipassi .  Show the inner product associative law for
         nonnegative integers. $)
      ipasslem1 $p |- ( ( N e. NN0 /\ A e. X ) ->
                      ( ( N S A ) P B ) = ( N x. ( A P B ) ) ) $=
        cN cn0 wcel cA cX wcel cN cA cS co cB cP co cN cA cB cP co cmul co wceq
        cA cX wcel vj cv cA cS co cB cP co vj cv cA cB cP co cmul co wceq wi cA
        cX wcel cc0 cA cS co cB cP co cc0 cA cB cP co cmul co wceq wi cA cX
        wcel vk cv cA cS co cB cP co vk cv cA cB cP co cmul co wceq wi cA cX
        wcel vk cv c1 caddc co cA cS co cB cP co vk cv c1 caddc co cA cB cP co
        cmul co wceq wi cA cX wcel cN cA cS co cB cP co cN cA cB cP co cmul co
        wceq wi vj vk cN vk cv cn0 wcel cA cX wcel vk cv cA cS co cB cP co vk
        cv cA cB cP co cmul co wceq vk cv c1 caddc co cA cS co cB cP co vk cv
        c1 caddc co cA cB cP co cmul co wceq vk cv cn0 wcel cA cX wcel vk cv cA
        cS co cB cP co vk cv cA cB cP co cmul co wceq vk cv c1 caddc co cA cS
        co cB cP co vk cv c1 caddc co cA cB cP co cmul co wceq vk cv cn0 wcel
        cA cX wcel wa vk cv cA cS co cB cP co vk cv cA cB cP co cmul co wceq wa
        vk cv c1 caddc co cA cS co cB cP co vk cv cA cB cP co cmul co c1 cA cB
        cP co cmul co caddc co vk cv c1 caddc co cA cB cP co cmul co vk cv cn0
        wcel cA cX wcel wa vk cv cA cS co cB cP co vk cv cA cB cP co cmul co
        wceq vk cv c1 caddc co cA cS co cB cP co vk cv cA cS co cB cP co c1 cA
        cB cP co cmul co caddc co vk cv cA cB cP co cmul co c1 cA cB cP co cmul
        co caddc co vk cv cn0 wcel cA cX wcel wa vk cv cA cS co cA cG co cB cP
        co vk cv cA cS co cB cP co cA cB cP co caddc co vk cv c1 caddc co cA cS
        co cB cP co vk cv cA cS co cB cP co c1 cA cB cP co cmul co caddc co vk
        cv cn0 wcel cA cX wcel vk cv cA cS co cX wcel vk cv cA cS co cA cG co
        cB cP co vk cv cA cS co cB cP co cA cB cP co caddc co wceq vk cv cc
        wcel cA cX wcel vk cv cA cS co cX wcel vk cv cn0 wcel cU cnv wcel vk cv
        cc wcel cA cX wcel vk cv cA cS co cX wcel cU ip1i.9 phnvi vk cv cA cS
        cU cX ip1i.1 ip1i.4 nvscl mp3an1 vk cv nn0cn sylan vk cv cA cS co cX
        wcel cA cX wcel cB cX wcel vk cv cA cS co cA cG co cB cP co vk cv cA cS
        co cB cP co cA cB cP co caddc co wceq ipasslem1.b vk cv cA cS co cA cB
        cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 ipdiri mp3an3
        sylancom vk cv cn0 wcel cA cX wcel wa vk cv c1 caddc co cA cS co vk cv
        cA cS co cA cG co cB cP vk cv cn0 wcel cA cX wcel wa vk cv c1 caddc co
        cA cS co vk cv cA cS co c1 cA cS co cG co vk cv cA cS co cA cG co vk cv
        cc wcel cA cX wcel vk cv c1 caddc co cA cS co vk cv cA cS co c1 cA cS
        co cG co wceq vk cv cn0 wcel vk cv cc wcel c1 cc wcel cA cX wcel vk cv
        c1 caddc co cA cS co vk cv cA cS co c1 cA cS co cG co wceq ax1cn cU cnv
        wcel vk cv cc wcel c1 cc wcel cA cX wcel w3a vk cv c1 caddc co cA cS co
        vk cv cA cS co c1 cA cS co cG co wceq cU ip1i.9 phnvi vk cv c1 cA cS cU
        cG cX ip1i.1 ip1i.2 ip1i.4 nvdir mpan mp3an2 vk cv nn0cn sylan vk cv
        cn0 wcel cA cX wcel wa c1 cA cS co cA vk cv cA cS co cG cA cX wcel c1
        cA cS co cA wceq vk cv cn0 wcel cU cnv wcel cA cX wcel c1 cA cS co cA
        wceq cU ip1i.9 phnvi cA cS cU cX ip1i.1 ip1i.4 nvsid mpan adantl
        opreq2d eqtrd opreq1d vk cv cn0 wcel cA cX wcel wa c1 cA cB cP co cmul
        co cA cB cP co vk cv cA cS co cB cP co caddc cA cX wcel c1 cA cB cP co
        cmul co cA cB cP co wceq vk cv cn0 wcel cA cX wcel cA cB cP co cc wcel
        c1 cA cB cP co cmul co cA cB cP co wceq cU cnv wcel cA cX wcel cB cX
        wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cA cB cP cU cX
        ip1i.1 ip1i.7 ipcl mp3an13 cA cB cP co mulid2 syl adantl opreq2d
        3eqtr4d vk cv cA cS co cB cP co vk cv cA cB cP co cmul co c1 cA cB cP
        co cmul co caddc opreq1 sylan9eq vk cv cn0 wcel cA cX wcel wa vk cv c1
        caddc co cA cB cP co cmul co vk cv cA cB cP co cmul co c1 cA cB cP co
        cmul co caddc co wceq vk cv cA cS co cB cP co vk cv cA cB cP co cmul co
        wceq vk cv cc wcel cA cB cP co cc wcel vk cv c1 caddc co cA cB cP co
        cmul co vk cv cA cB cP co cmul co c1 cA cB cP co cmul co caddc co wceq
        vk cv cn0 wcel cA cX wcel vk cv cc wcel c1 cc wcel cA cB cP co cc wcel
        vk cv c1 caddc co cA cB cP co cmul co vk cv cA cB cP co cmul co c1 cA
        cB cP co cmul co caddc co wceq ax1cn vk cv c1 cA cB cP co adddir mp3an2
        vk cv nn0cn cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU
        ip1i.9 phnvi ipasslem1.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13
        syl2an adantr eqtr4d exp31 a2d cA cX wcel cU cn0v cfv cB cP co cc0 cc0
        cA cS co cB cP co cc0 cA cB cP co cmul co cU cnv wcel cB cX wcel cU
        cn0v cfv cB cP co cc0 wceq cU ip1i.9 phnvi ipasslem1.b cB cP cU cX cU
        cn0v cfv ip1i.1 cU cn0v cfv eqid ip1i.7 ip0l mp2an cA cX wcel cc0 cA cS
        co cU cn0v cfv cB cP cU cnv wcel cA cX wcel cc0 cA cS co cU cn0v cfv
        wceq cU ip1i.9 phnvi cA cS cU cX cU cn0v cfv ip1i.1 ip1i.4 cU cn0v cfv
        eqid nv0 mpan opreq1d cA cX wcel cA cB cP co cc wcel cc0 cA cB cP co
        cmul co cc0 wceq cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel
        cU ip1i.9 phnvi ipasslem1.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13
        cA cB cP co mul02 syl 3eqtr4a vj cv cc0 wceq vj cv cA cS co cB cP co vj
        cv cA cB cP co cmul co wceq cc0 cA cS co cB cP co cc0 cA cB cP co cmul
        co wceq cA cX wcel vj cv cc0 wceq vj cv cA cS co cB cP co cc0 cA cS co
        cB cP co vj cv cA cB cP co cmul co cc0 cA cB cP co cmul co vj cv cc0
        wceq vj cv cA cS co cc0 cA cS co cB cP vj cv cc0 cA cS opreq1 opreq1d
        vj cv cc0 cA cB cP co cmul opreq1 eqeq12d imbi2d vj cv vk cv wceq vj cv
        cA cS co cB cP co vj cv cA cB cP co cmul co wceq vk cv cA cS co cB cP
        co vk cv cA cB cP co cmul co wceq cA cX wcel vj cv vk cv wceq vj cv cA
        cS co cB cP co vk cv cA cS co cB cP co vj cv cA cB cP co cmul co vk cv
        cA cB cP co cmul co vj cv vk cv wceq vj cv cA cS co vk cv cA cS co cB
        cP vj cv vk cv cA cS opreq1 opreq1d vj cv vk cv cA cB cP co cmul opreq1
        eqeq12d imbi2d vj cv vk cv c1 caddc co wceq vj cv cA cS co cB cP co vj
        cv cA cB cP co cmul co wceq vk cv c1 caddc co cA cS co cB cP co vk cv
        c1 caddc co cA cB cP co cmul co wceq cA cX wcel vj cv vk cv c1 caddc co
        wceq vj cv cA cS co cB cP co vk cv c1 caddc co cA cS co cB cP co vj cv
        cA cB cP co cmul co vk cv c1 caddc co cA cB cP co cmul co vj cv vk cv
        c1 caddc co wceq vj cv cA cS co vk cv c1 caddc co cA cS co cB cP vj cv
        vk cv c1 caddc co cA cS opreq1 opreq1d vj cv vk cv c1 caddc co cA cB cP
        co cmul opreq1 eqeq12d imbi2d vj cv cN wceq vj cv cA cS co cB cP co vj
        cv cA cB cP co cmul co wceq cN cA cS co cB cP co cN cA cB cP co cmul co
        wceq cA cX wcel vj cv cN wceq vj cv cA cS co cB cP co cN cA cS co cB cP
        co vj cv cA cB cP co cmul co cN cA cB cP co cmul co vj cv cN wceq vj cv
        cA cS co cN cA cS co cB cP vj cv cN cA cS opreq1 opreq1d vj cv cN cA cB
        cP co cmul opreq1 eqeq12d imbi2d nn0indALT imp $.
        $( [5-Nov-2007] $) $( [27-Apr-2007] $)

      $( Lemma for ~ ipassi .  Show the inner product associative law for
         nonpositive integers. $)
      ipasslem2 $p |- ( ( N e. NN0 /\ A e. X ) ->
              ( ( -u N S A ) P B ) = ( -u N x. ( A P B ) ) ) $=
        cN cn0 wcel cA cX wcel wa cN cneg cA cB cP co cmul co cN cneg cA cS co
        cB cP co cN cn0 wcel cA cX wcel wa cN cneg cA cB cP co cmul co cN cneg
        cA cS co cB cP co cmin co cc0 wceq cN cneg cA cB cP co cmul co cN cneg
        cA cS co cB cP co wceq cN cn0 wcel cA cX wcel wa cN cneg cA cB cP co
        cmul co cN cneg cA cS co cB cP co cmin co cN cneg cA cB cP co cmul co
        cN c1 cneg cA cS co cB cP co cmul co cmin co cN cneg cA cB cP co cmul
        co cN c1 cneg cA cS co cB cP co cmul co cneg caddc co cc0 cN cn0 wcel
        cA cX wcel wa cN cneg cA cS co cB cP co cN c1 cneg cA cS co cB cP co
        cmul co cN cneg cA cB cP co cmul co cmin cN cn0 wcel cA cX wcel wa cN
        cneg cA cS co cB cP co cN c1 cneg cA cS co cS co cB cP co cN c1 cneg cA
        cS co cB cP co cmul co cN cn0 wcel cA cX wcel wa cN cneg cA cS co cN c1
        cneg cA cS co cS co cB cP cN cc wcel cA cX wcel cN cneg cA cS co cN c1
        cneg cA cS co cS co wceq cN cn0 wcel cN cc wcel cA cX wcel wa cN cneg
        cA cS co cN c1 cneg cmul co cA cS co cN c1 cneg cA cS co cS co cN cc
        wcel cA cX wcel wa cN cneg cN c1 cneg cmul co cA cS cN cc wcel cN cneg
        cN c1 cneg cmul co wceq cA cX wcel cN cc wcel cN c1 cneg cmul co cN c1
        cmul co cneg cN cneg cN cc wcel c1 cc wcel cN c1 cneg cmul co cN c1
        cmul co cneg wceq ax1cn cN c1 mulneg2 mpan2 cN cc wcel cN c1 cmul co cN
        cN ax1id negeqd eqtr2d adantr opreq1d cN cc wcel c1 cneg cc wcel cA cX
        wcel cN c1 cneg cmul co cA cS co cN c1 cneg cA cS co cS co wceq c1
        ax1cn negcli cU cnv wcel cN cc wcel c1 cneg cc wcel cA cX wcel w3a cN
        c1 cneg cmul co cA cS co cN c1 cneg cA cS co cS co wceq cU ip1i.9 phnvi
        cN c1 cneg cA cS cU cX ip1i.1 ip1i.4 nvsass mpan mp3an2 eqtrd cN nn0cn
        sylan opreq1d cN cn0 wcel c1 cneg cA cS co cX wcel cN c1 cneg cA cS co
        cS co cB cP co cN c1 cneg cA cS co cB cP co cmul co wceq cA cX wcel c1
        cneg cA cS co cB cP cS cU cG cN cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9
        ipasslem1.b ipasslem1 cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA
        cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli c1 cneg cA cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an12 sylan2 eqtrd opreq2d cN cneg cA cB cP co
        cmul co cc wcel cN c1 cneg cA cS co cB cP co cmul co cc wcel cN cneg cA
        cB cP co cmul co cN c1 cneg cA cS co cB cP co cmul co cneg caddc co cN
        cneg cA cB cP co cmul co cN c1 cneg cA cS co cB cP co cmul co cmin co
        wceq cN cn0 wcel cA cX wcel wa cN cneg cA cB cP co cmul co cN c1 cneg
        cA cS co cB cP co cmul co negsub cN cneg cc wcel cA cB cP co cc wcel cN
        cneg cA cB cP co cmul co cc wcel cN cn0 wcel cA cX wcel cN cneg cA cB
        cP co mulcl cN cn0 wcel cN cc wcel cN cneg cc wcel cN nn0cn cN negcl
        syl cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9
        phnvi ipasslem1.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl2an cN
        cc wcel c1 cneg cA cS co cB cP co cc wcel cN c1 cneg cA cS co cB cP co
        cmul co cc wcel cN cn0 wcel cA cX wcel cN c1 cneg cA cS co cB cP co
        mulcl cN nn0cn cA cX wcel c1 cneg cA cS co cX wcel c1 cneg cA cS co cB
        cP co cc wcel cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co
        cX wcel cU ip1i.9 phnvi c1 ax1cn negcli c1 cneg cA cS cU cX ip1i.1
        ip1i.4 nvscl mp3an12 cU cnv wcel c1 cneg cA cS co cX wcel cB cX wcel c1
        cneg cA cS co cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b c1 cneg cA
        cS co cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl syl2an sylanc cN cn0
        wcel cA cX wcel wa cN cneg cA cB cP co c1 cneg cA cS co cB cP co caddc
        co cmul co cN cneg cA cB cP co cmul co cN cneg c1 cneg cA cS co cB cP
        co cmul co caddc co cc0 cN cneg cA cB cP co cmul co cN c1 cneg cA cS co
        cB cP co cmul co cneg caddc co cN cneg cc wcel cA cB cP co cc wcel c1
        cneg cA cS co cB cP co cc wcel cN cneg cA cB cP co c1 cneg cA cS co cB
        cP co caddc co cmul co cN cneg cA cB cP co cmul co cN cneg c1 cneg cA
        cS co cB cP co cmul co caddc co wceq cN cn0 wcel cA cX wcel wa cN cneg
        cA cB cP co c1 cneg cA cS co cB cP co adddi cN cn0 wcel cN cneg cc wcel
        cA cX wcel cN cn0 wcel cN cc wcel cN cneg cc wcel cN nn0cn cN negcl syl
        adantr cA cX wcel cA cB cP co cc wcel cN cn0 wcel cU cnv wcel cA cX
        wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cA cB
        cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 adantl cA cX wcel c1 cneg cA cS co
        cB cP co cc wcel cN cn0 wcel cA cX wcel c1 cneg cA cS co cX wcel c1
        cneg cA cS co cB cP co cc wcel cU cnv wcel c1 cneg cc wcel cA cX wcel
        c1 cneg cA cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli c1 cneg cA cS
        cU cX ip1i.1 ip1i.4 nvscl mp3an12 cU cnv wcel c1 cneg cA cS co cX wcel
        cB cX wcel c1 cneg cA cS co cB cP co cc wcel cU ip1i.9 phnvi
        ipasslem1.b c1 cneg cA cS co cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl
        adantl syl3anc cA cX wcel cN cn0 wcel cN cneg cA cB cP co c1 cneg cA cS
        co cB cP co caddc co cmul co cN cneg cc0 cmul co cc0 cA cX wcel cA cB
        cP co c1 cneg cA cS co cB cP co caddc co cc0 cN cneg cmul cA cX wcel cA
        c1 cneg cA cS co cG co cB cP co cA cB cP co c1 cneg cA cS co cB cP co
        caddc co cc0 cA cX wcel c1 cneg cA cS co cX wcel cA c1 cneg cA cS co cG
        co cB cP co cA cB cP co c1 cneg cA cS co cB cP co caddc co wceq cU cnv
        wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX wcel cU ip1i.9
        phnvi c1 ax1cn negcli c1 cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an12
        cA cX wcel c1 cneg cA cS co cX wcel cB cX wcel cA c1 cneg cA cS co cG
        co cB cP co cA cB cP co c1 cneg cA cS co cB cP co caddc co wceq
        ipasslem1.b cA c1 cneg cA cS co cB cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4
        ip1i.7 ip1i.9 ipdiri mp3an3 mpdan cA cX wcel cA c1 cneg cA cS co cG co
        cB cP co cU cn0v cfv cB cP co cc0 cA cX wcel cA c1 cneg cA cS co cG co
        cU cn0v cfv cB cP cU cnv wcel cA cX wcel cA c1 cneg cA cS co cG co cU
        cn0v cfv wceq cU ip1i.9 phnvi cA cS cU cG cX cU cn0v cfv ip1i.1 ip1i.2
        ip1i.4 cU cn0v cfv eqid nvrinv mpan opreq1d cU cnv wcel cB cX wcel cU
        cn0v cfv cB cP co cc0 wceq cU ip1i.9 phnvi ipasslem1.b cB cP cU cX cU
        cn0v cfv ip1i.1 cU cn0v cfv eqid ip1i.7 ip0l mp2an syl6eq eqtr3d
        opreq2d cN cn0 wcel cN cneg cc wcel cN cneg cc0 cmul co cc0 wceq cN cn0
        wcel cN cc wcel cN cneg cc wcel cN nn0cn cN negcl syl cN cneg mul01 syl
        sylan9eqr cN cn0 wcel cA cX wcel wa cN cneg c1 cneg cA cS co cB cP co
        cmul co cN c1 cneg cA cS co cB cP co cmul co cneg cN cneg cA cB cP co
        cmul co caddc cN cc wcel c1 cneg cA cS co cB cP co cc wcel cN cneg c1
        cneg cA cS co cB cP co cmul co cN c1 cneg cA cS co cB cP co cmul co
        cneg wceq cN cn0 wcel cA cX wcel cN c1 cneg cA cS co cB cP co mulneg1
        cN nn0cn cA cX wcel c1 cneg cA cS co cX wcel c1 cneg cA cS co cB cP co
        cc wcel cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX wcel
        cU ip1i.9 phnvi c1 ax1cn negcli c1 cneg cA cS cU cX ip1i.1 ip1i.4 nvscl
        mp3an12 cU cnv wcel c1 cneg cA cS co cX wcel cB cX wcel c1 cneg cA cS
        co cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b c1 cneg cA cS co cB cP
        cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl syl2an opreq2d 3eqtr3rd 3eqtr2d cN
        cneg cA cB cP co cmul co cc wcel cN cneg cA cS co cB cP co cc wcel cN
        cneg cA cB cP co cmul co cN cneg cA cS co cB cP co cmin co cc0 wceq cN
        cneg cA cB cP co cmul co cN cneg cA cS co cB cP co wceq wb cN cn0 wcel
        cA cX wcel wa cN cneg cA cB cP co cmul co cN cneg cA cS co cB cP co
        subeq0 cN cneg cc wcel cA cB cP co cc wcel cN cneg cA cB cP co cmul co
        cc wcel cN cn0 wcel cA cX wcel cN cneg cA cB cP co mulcl cN cn0 wcel cN
        cc wcel cN cneg cc wcel cN nn0cn cN negcl syl cU cnv wcel cA cX wcel cB
        cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cA cB cP cU cX
        ip1i.1 ip1i.7 ipcl mp3an13 syl2an cN cn0 wcel cA cX wcel wa cN cneg cA
        cS co cX wcel cN cneg cA cS co cB cP co cc wcel cN cneg cc wcel cA cX
        wcel cN cneg cA cS co cX wcel cN cn0 wcel cU cnv wcel cN cneg cc wcel
        cA cX wcel cN cneg cA cS co cX wcel cU ip1i.9 phnvi cN cneg cA cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an1 cN cn0 wcel cN cc wcel cN cneg cc wcel cN
        nn0cn cN negcl syl sylan cU cnv wcel cN cneg cA cS co cX wcel cB cX
        wcel cN cneg cA cS co cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cN
        cneg cA cS co cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl sylanc mpbid
        eqcomd $.
        $( [5-Nov-2007] $) $( [27-Apr-2007] $)

      $( Lemma for ~ ipassi .  Show the inner product associative law for
         all integers. $)
      ipasslem3 $p |- ( ( N e. ZZ /\ A e. X ) ->
              ( ( N S A ) P B ) = ( N x. ( A P B ) ) ) $=
        cN cn0 wcel cN cr wcel cN cneg cn wcel wa wo cA cX wcel cN cA cS co cB
        cP co cN cA cB cP co cmul co wceq cN cz wcel cN cn0 wcel cA cX wcel cN
        cA cS co cB cP co cN cA cB cP co cmul co wceq cN cr wcel cN cneg cn
        wcel wa cA cB cP cS cU cG cN cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9
        ipasslem1.b ipasslem1 cN cr wcel cN cneg cn wcel wa cA cX wcel wa cN
        cneg cneg cA cS co cB cP co cN cneg cneg cA cB cP co cmul co cN cA cS
        co cB cP co cN cA cB cP co cmul co cN cneg cn wcel cA cX wcel cN cneg
        cneg cA cS co cB cP co cN cneg cneg cA cB cP co cmul co wceq cN cr wcel
        cN cneg cn0 wcel cA cX wcel cN cneg cneg cA cS co cB cP co cN cneg cneg
        cA cB cP co cmul co wceq cN cneg cn wcel cA cB cP cS cU cG cN cneg cX
        ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 ipasslem1.b ipasslem2 cN cneg nnnn0
        sylan adantll cN cr wcel cN cneg cneg cA cS co cB cP co cN cA cS co cB
        cP co wceq cN cneg cn wcel cA cX wcel cN cr wcel cN cneg cneg cA cS co
        cN cA cS co cB cP cN cr wcel cN cneg cneg cN cA cS cN cr wcel cN cc
        wcel cN cneg cneg cN wceq cN recn cN negneg syl opreq1d opreq1d
        ad2antrr cN cr wcel cN cneg cneg cA cB cP co cmul co cN cA cB cP co
        cmul co wceq cN cneg cn wcel cA cX wcel cN cr wcel cN cneg cneg cN cA
        cB cP co cmul cN cr wcel cN cc wcel cN cneg cneg cN wceq cN recn cN
        negneg syl opreq1d ad2antrr 3eqtr3d jaoian cN elznn0nn sylanb $.
        $( [5-Nov-2007] $) $( [27-Apr-2007] $)


      $( Lemma for ~ ipassi .  Show the inner product associative law for
         positive integer reciprocals. $)
      ipasslem4 $p |- ( ( N e. NN /\ A e. X ) ->
                  ( ( ( 1 / N ) S A ) P B ) = ( ( 1 / N ) x. ( A P B ) ) ) $=
        cN cn wcel cA cX wcel wa cN c1 cN cdiv co cA cS co cB cP co cmul co cN
        c1 cN cdiv co cA cB cP co cmul co cmul co wceq c1 cN cdiv co cA cS co
        cB cP co c1 cN cdiv co cA cB cP co cmul co wceq cN cn wcel cA cX wcel
        wa cN c1 cN cdiv co cA cS co cS co cB cP co cN c1 cN cdiv co cmul co cA
        cB cP co cmul co cN c1 cN cdiv co cA cS co cB cP co cmul co cN c1 cN
        cdiv co cA cB cP co cmul co cmul co cN cn wcel cA cX wcel wa cN c1 cN
        cdiv co cmul co cA cB cP co cmul co cA cB cP co cN c1 cN cdiv co cA cS
        co cS co cB cP co cN cn wcel cA cX wcel cN c1 cN cdiv co cmul co cA cB
        cP co cmul co c1 cA cB cP co cmul co cA cB cP co cN cn wcel cN c1 cN
        cdiv co cmul co c1 cA cB cP co cmul cN cc wcel cN cc0 wne cN c1 cN cdiv
        co cmul co c1 wceq cN cn wcel cN recid cN nncn cN nnne0 sylanc opreq1d
        cA cX wcel cA cB cP co cc wcel c1 cA cB cP co cmul co cA cB cP co wceq
        cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi
        ipasslem1.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 cA cB cP co
        mulid2 syl sylan9eq cN cn wcel cA cX wcel wa cA cN c1 cN cdiv co cA cS
        co cS co cB cP cN cn wcel cA cX wcel wa cN c1 cN cdiv co cmul co cA cS
        co cA cN c1 cN cdiv co cA cS co cS co cN cn wcel cA cX wcel cN c1 cN
        cdiv co cmul co cA cS co c1 cA cS co cA cN cn wcel cN c1 cN cdiv co
        cmul co c1 cA cS cN cc wcel cN cc0 wne cN c1 cN cdiv co cmul co c1 wceq
        cN cn wcel cN recid cN nncn cN nnne0 sylanc opreq1d cU cnv wcel cA cX
        wcel c1 cA cS co cA wceq cU ip1i.9 phnvi cA cS cU cX ip1i.1 ip1i.4
        nvsid mpan sylan9eq cN cc wcel c1 cN cdiv co cc wcel cA cX wcel cN c1
        cN cdiv co cmul co cA cS co cN c1 cN cdiv co cA cS co cS co wceq cN cn
        wcel cA cX wcel wa cU cnv wcel cN cc wcel c1 cN cdiv co cc wcel cA cX
        wcel w3a cN c1 cN cdiv co cmul co cA cS co cN c1 cN cdiv co cA cS co cS
        co wceq cU ip1i.9 phnvi cN c1 cN cdiv co cA cS cU cX ip1i.1 ip1i.4
        nvsass mpan cN cn wcel cN cc wcel cA cX wcel cN nncn adantr cN cn wcel
        c1 cN cdiv co cc wcel cA cX wcel cN cn wcel c1 cN cdiv co cN nnrecre
        recnd adantr cN cn wcel cA cX wcel pm3.27 syl3anc eqtr3d opreq1d eqtr2d
        cN cn0 wcel c1 cN cdiv co cA cS co cX wcel cN c1 cN cdiv co cA cS co cS
        co cB cP co cN c1 cN cdiv co cA cS co cB cP co cmul co wceq cN cn wcel
        cA cX wcel wa c1 cN cdiv co cA cS co cB cP cS cU cG cN cX ip1i.1 ip1i.2
        ip1i.4 ip1i.7 ip1i.9 ipasslem1.b ipasslem1 cN cn wcel cN cn0 wcel cA cX
        wcel cN nnnn0 adantr c1 cN cdiv co cc wcel cA cX wcel c1 cN cdiv co cA
        cS co cX wcel cN cn wcel cU cnv wcel c1 cN cdiv co cc wcel cA cX wcel
        c1 cN cdiv co cA cS co cX wcel cU ip1i.9 phnvi c1 cN cdiv co cA cS cU
        cX ip1i.1 ip1i.4 nvscl mp3an1 cN cn wcel c1 cN cdiv co cN nnrecre recnd
        sylan sylanc cN cc wcel c1 cN cdiv co cc wcel cA cB cP co cc wcel cN c1
        cN cdiv co cmul co cA cB cP co cmul co cN c1 cN cdiv co cA cB cP co
        cmul co cmul co wceq cN cn wcel cA cX wcel wa cN c1 cN cdiv co cA cB cP
        co mulass cN cn wcel cN cc wcel cA cX wcel cN nncn adantr cN cn wcel c1
        cN cdiv co cc wcel cA cX wcel cN cn wcel c1 cN cdiv co cN nnrecre recnd
        adantr cA cX wcel cA cB cP co cc wcel cN cn wcel cU cnv wcel cA cX wcel
        cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cA cB cP cU
        cX ip1i.1 ip1i.7 ipcl mp3an13 adantl syl3anc 3eqtr3d c1 cN cdiv co cA
        cS co cB cP co cc wcel c1 cN cdiv co cA cB cP co cmul co cc wcel cN cc
        wcel cN cc0 wne wa cN c1 cN cdiv co cA cS co cB cP co cmul co cN c1 cN
        cdiv co cA cB cP co cmul co cmul co wceq c1 cN cdiv co cA cS co cB cP
        co c1 cN cdiv co cA cB cP co cmul co wceq wb cN cn wcel cA cX wcel wa
        c1 cN cdiv co cA cS co cB cP co c1 cN cdiv co cA cB cP co cmul co cN
        mulcan cN cn wcel cA cX wcel wa c1 cN cdiv co cA cS co cX wcel c1 cN
        cdiv co cA cS co cB cP co cc wcel c1 cN cdiv co cc wcel cA cX wcel c1
        cN cdiv co cA cS co cX wcel cN cn wcel cU cnv wcel c1 cN cdiv co cc
        wcel cA cX wcel c1 cN cdiv co cA cS co cX wcel cU ip1i.9 phnvi c1 cN
        cdiv co cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an1 cN cn wcel c1 cN cdiv co
        cN nnrecre recnd sylan cU cnv wcel c1 cN cdiv co cA cS co cX wcel cB cX
        wcel c1 cN cdiv co cA cS co cB cP co cc wcel cU ip1i.9 phnvi
        ipasslem1.b c1 cN cdiv co cA cS co cB cP cU cX ip1i.1 ip1i.7 ipcl
        mp3an13 syl c1 cN cdiv co cc wcel cA cB cP co cc wcel c1 cN cdiv co cA
        cB cP co cmul co cc wcel cN cn wcel cA cX wcel c1 cN cdiv co cA cB cP
        co mulcl cN cn wcel c1 cN cdiv co cN nnrecre recnd cU cnv wcel cA cX
        wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cA cB
        cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl2an cN cn wcel cA cX wcel wa cN
        cc wcel cN cc0 wne cN cn wcel cN cc wcel cA cX wcel cN nncn adantr cN
        cn wcel cN cc0 wne cA cX wcel cN nnne0 adantr jca syl3anc mpbid $.
        $( [5-Nov-2007] $) $( [27-Apr-2007] $)

      $( Lemma for ~ ipassi .  Show the inner product associative law for
         rational numbers. $)
      ipasslem5 $p |- ( ( C e. QQ /\ A e. X ) ->
                  ( ( C S A ) P B ) = ( C x. ( A P B ) ) ) $=
        cC cq wcel cA cX wcel cC cA cS co cB cP co cC cA cB cP co cmul co wceq
        cC cq wcel cC vj cv vk cv cdiv co wceq vk cn wrex vj cz wrex cA cX wcel
        cC cA cS co cB cP co cC cA cB cP co cmul co wceq wi vj vk cC elq cC vj
        cv vk cv cdiv co wceq cA cX wcel cC cA cS co cB cP co cC cA cB cP co
        cmul co wceq wi vj vk cz cn vj cv cz wcel vk cv cn wcel wa cA cX wcel
        cC vj cv vk cv cdiv co wceq cC cA cS co cB cP co cC cA cB cP co cmul co
        wceq vj cv cz wcel vk cv cn wcel cA cX wcel cC vj cv vk cv cdiv co wceq
        cC cA cS co cB cP co cC cA cB cP co cmul co wceq wi cC vj cv vk cv cdiv
        co wceq cC cA cS co cB cP co cC cA cB cP co cmul co wceq vj cv vk cv
        cdiv co cA cS co cB cP co vj cv vk cv cdiv co cA cB cP co cmul co wceq
        vj cv cz wcel vk cv cn wcel cA cX wcel w3a cC vj cv vk cv cdiv co wceq
        cC cA cS co cB cP co vj cv vk cv cdiv co cA cS co cB cP co cC cA cB cP
        co cmul co vj cv vk cv cdiv co cA cB cP co cmul co cC vj cv vk cv cdiv
        co wceq cC cA cS co vj cv vk cv cdiv co cA cS co cB cP cC vj cv vk cv
        cdiv co cA cS opreq1 opreq1d cC vj cv vk cv cdiv co cA cB cP co cmul
        opreq1 eqeq12d vj cv cz wcel vk cv cn wcel cA cX wcel w3a vj cv c1 vk
        cv cdiv co cmul co cA cB cP co cmul co vj cv c1 vk cv cdiv co cA cB cP
        co cmul co cmul co vj cv vk cv cdiv co cA cB cP co cmul co vj cv vk cv
        cdiv co cA cS co cB cP co vj cv cc wcel c1 vk cv cdiv co cc wcel cA cB
        cP co cc wcel vj cv c1 vk cv cdiv co cmul co cA cB cP co cmul co vj cv
        c1 vk cv cdiv co cA cB cP co cmul co cmul co wceq vj cv cz wcel vk cv
        cn wcel cA cX wcel vj cv c1 vk cv cdiv co cA cB cP co mulass vj cv zcn
        vk cv cn wcel c1 vk cv cdiv co vk cv nnrecre recnd cU cnv wcel cA cX
        wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem1.b cA cB
        cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl3an vj cv cz wcel vk cv cn wcel
        cA cX wcel w3a vj cv vk cv cdiv co vj cv c1 vk cv cdiv co cmul co cA cB
        cP co cmul vj cv cz wcel vk cv cn wcel vj cv vk cv cdiv co vj cv c1 vk
        cv cdiv co cmul co wceq cA cX wcel vj cv cc wcel vk cv cc wcel vk cv
        cc0 wne vj cv vk cv cdiv co vj cv c1 vk cv cdiv co cmul co wceq vj cv
        cz wcel vk cv cn wcel wa vj cv vk cv divrec vj cv cz wcel vj cv cc wcel
        vk cv cn wcel vj cv zcn adantr vk cv cn wcel vk cv cc wcel vj cv cz
        wcel vk cv nncn adantl vk cv cn wcel vk cv cc0 wne vj cv cz wcel vk cv
        nnne0 adantl syl3anc 3adant3 opreq1d vj cv cz wcel vk cv cn wcel cA cX
        wcel w3a vj cv vk cv cdiv co cA cS co cB cP co vj cv c1 vk cv cdiv co
        cA cS co cS co cB cP co vj cv c1 vk cv cdiv co cA cS co cB cP co cmul
        co vj cv c1 vk cv cdiv co cA cB cP co cmul co cmul co vj cv cz wcel vk
        cv cn wcel cA cX wcel w3a vj cv vk cv cdiv co cA cS co vj cv c1 vk cv
        cdiv co cA cS co cS co cB cP vj cv cz wcel vk cv cn wcel cA cX wcel w3a
        vj cv vk cv cdiv co cA cS co vj cv c1 vk cv cdiv co cmul co cA cS co vj
        cv c1 vk cv cdiv co cA cS co cS co vj cv cz wcel vk cv cn wcel cA cX
        wcel w3a vj cv vk cv cdiv co vj cv c1 vk cv cdiv co cmul co cA cS vj cv
        cz wcel vk cv cn wcel vj cv vk cv cdiv co vj cv c1 vk cv cdiv co cmul
        co wceq cA cX wcel vj cv cc wcel vk cv cc wcel vk cv cc0 wne vj cv vk
        cv cdiv co vj cv c1 vk cv cdiv co cmul co wceq vj cv cz wcel vk cv cn
        wcel wa vj cv vk cv divrec vj cv cz wcel vj cv cc wcel vk cv cn wcel vj
        cv zcn adantr vk cv cn wcel vk cv cc wcel vj cv cz wcel vk cv nncn
        adantl vk cv cn wcel vk cv cc0 wne vj cv cz wcel vk cv nnne0 adantl
        syl3anc 3adant3 opreq1d vj cv cc wcel c1 vk cv cdiv co cc wcel cA cX
        wcel vj cv c1 vk cv cdiv co cmul co cA cS co vj cv c1 vk cv cdiv co cA
        cS co cS co wceq vj cv cz wcel vk cv cn wcel cA cX wcel cU cnv wcel vj
        cv cc wcel c1 vk cv cdiv co cc wcel cA cX wcel w3a vj cv c1 vk cv cdiv
        co cmul co cA cS co vj cv c1 vk cv cdiv co cA cS co cS co wceq cU
        ip1i.9 phnvi vj cv c1 vk cv cdiv co cA cS cU cX ip1i.1 ip1i.4 nvsass
        mpan vj cv zcn vk cv cn wcel c1 vk cv cdiv co vk cv nnrecre recnd cA cX
        wcel id syl3an eqtrd opreq1d vj cv cz wcel vk cv cn wcel cA cX wcel vj
        cv c1 vk cv cdiv co cA cS co cS co cB cP co vj cv c1 vk cv cdiv co cA
        cS co cB cP co cmul co wceq vj cv cz wcel c1 vk cv cdiv co cA cS co cX
        wcel vj cv c1 vk cv cdiv co cA cS co cS co cB cP co vj cv c1 vk cv cdiv
        co cA cS co cB cP co cmul co wceq vk cv cn wcel cA cX wcel wa c1 vk cv
        cdiv co cA cS co cB cP cS cU cG vj cv cX ip1i.1 ip1i.2 ip1i.4 ip1i.7
        ip1i.9 ipasslem1.b ipasslem3 c1 vk cv cdiv co cc wcel cA cX wcel c1 vk
        cv cdiv co cA cS co cX wcel vk cv cn wcel cU cnv wcel c1 vk cv cdiv co
        cc wcel cA cX wcel c1 vk cv cdiv co cA cS co cX wcel cU ip1i.9 phnvi c1
        vk cv cdiv co cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an1 vk cv cn wcel c1
        vk cv cdiv co vk cv nnrecre recnd sylan sylan2 3impb vj cv cz wcel vk
        cv cn wcel cA cX wcel w3a c1 vk cv cdiv co cA cS co cB cP co c1 vk cv
        cdiv co cA cB cP co cmul co vj cv cmul vk cv cn wcel cA cX wcel c1 vk
        cv cdiv co cA cS co cB cP co c1 vk cv cdiv co cA cB cP co cmul co wceq
        vj cv cz wcel cA cB cP cS cU cG vk cv cX ip1i.1 ip1i.2 ip1i.4 ip1i.7
        ip1i.9 ipasslem1.b ipasslem4 3adant1 opreq2d 3eqtrd 3eqtr4rd syl5cbir
        3expia com23 r19.23aivv sylbi imp $.
        $( [6-Nov-2007] $) $( [27-Apr-2007] $)
    $}

    ${
      $d q r s t u v w A $.  $d q r s t u v w B $.  $d s C $.
      $d q r s u w D $.  $d r s G $.  $d s u w J $.  $d q r s t u v w P $.
      $d q r s t u v w S $.  $d r s U $.  $d r s W $.  $d r s t u X $.
      ipasslem6.a $e |- A e. X $.
      ipasslem6.b $e |- B e. X $.
      ipasslem6.d $e |- D = ( abs o. - ) $.
      ipasslem6.8 $e |- C = ( IndMet ` U ) $.
      ipasslem6.j $e |- J = ( Open ` D ) $.
      ipasslem6.f $e |- F = { <. w , v >. | ( w e. CC /\
              v = ( ( ( w S A ) P B ) - ( w x. ( A P B ) ) ) ) } $.
      $( Lemma for ~ ipassi .  Show that
         ` ( ( w S A ) P B ) - ( w x. ( A P B ) ) ` is continuous in ` w ` . $)
      ipasslem6 $p |- F e. ( J Cn J ) $=
        vu cv cc wcel vt cv vu cv cA cS co cB cP co wceq wa vu vt copab cJ cJ
        ccn co wcel vu cv cc wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt
        copab cJ cJ ccn co wcel cF cJ cJ ccn co wcel vs cv cX wcel vr cv vs cv
        cB cP co wceq wa vs vr copab vu cv cc wcel vt cv vu cv cA cS co wceq wa
        vu vt copab ccom vu cv cc wcel vt cv vu cv cA cS co cB cP co wceq wa vu
        vt copab cJ cJ ccn co vu cv cc wcel vt cv vu cv cA cS co wceq wa vu vt
        copab crn cX wss vs cv cX wcel vr cv vs cv cB cP co wceq wa vs vr copab
        vu cv cc wcel vt cv vu cv cA cS co wceq wa vu vt copab ccom vu cv cc
        wcel vt cv vu cv cA cS co cB cP co wceq wa vu vt copab wceq vu cv cA cS
        co cX wcel vu cc wral vu cv cc wcel vt cv vu cv cA cS co wceq wa vu vt
        copab crn cX wss vu cv cA cS co cX wcel vu cc cU cnv wcel vu cv cc wcel
        cA cX wcel vu cv cA cS co cX wcel cU ip1i.9 phnvi ipasslem6.a vu cv cA
        cS cU cX ip1i.1 ip1i.4 nvscl mp3an13 rgen vu vt cc cX vu cv cA cS co vu
        cv cc wcel vt cv vu cv cA cS co wceq wa vu vt copab vu cv cc wcel vt cv
        vu cv cA cS co wceq wa vu vt copab eqid vu cv cA cS oprex rnssopab mpbi
        vu vt vs vr vt cc cX vu cv cA cS co vs cv cB cP co vu cv cA cS co cB cP
        co vu cv cc wcel vt cv vu cv cA cS co wceq wa vu vt copab vs cv cX wcel
        vr cv vs cv cB cP co wceq wa vs vr copab vu cv cc wcel vt cv vu cv cA
        cS co cB cP co wceq wa vu vt copab vu cv cA cS oprex vs cv cB cP oprex
        vu cv cA cS co cB cP oprex vs cv vu cv cA cS co cB cP opreq1 vu cv cc
        wcel vt cv vu cv cA cS co wceq wa vu vt copab eqid vs cv cX wcel vr cv
        vs cv cB cP co wceq wa vs vr copab eqid vu cv cc wcel vt cv vu cv cA cS
        co cB cP co wceq wa vu vt copab eqid fopabco ax-mp cD cme wcel cC cme
        wcel cD cme wcel w3a vu cv cc wcel vt cv vu cv cA cS co wceq wa vu vt
        copab cJ cC copn cfv ccn co wcel vs cv cX wcel vr cv vs cv cB cP co
        wceq wa vs vr copab cC copn cfv cJ ccn co wcel wa vs cv cX wcel vr cv
        vs cv cB cP co wceq wa vs vr copab vu cv cc wcel vt cv vu cv cA cS co
        wceq wa vu vt copab ccom cJ cJ ccn co wcel cD cme wcel cC cme wcel cD
        cme wcel cD ipasslem6.d cnmet cU cnv wcel cC cme wcel cU ip1i.9 phnvi
        cC cU ipasslem6.8 imsmet ax-mp cD ipasslem6.d cnmet 3pm3.2i vu cv cc
        wcel vt cv vu cv cA cS co wceq wa vu vt copab cJ cC copn cfv ccn co
        wcel vs cv cX wcel vr cv vs cv cB cP co wceq wa vs vr copab cC copn cfv
        cJ ccn co wcel vu vt cA cD cC cS cU vu cv cc wcel vt cv vu cv cA cS co
        wceq wa vu vt copab cJ cC copn cfv cX ip1i.1 ip1i.4 ipasslem6.d
        ipasslem6.8 ipasslem6.j cC copn cfv eqid vu cv cc wcel vt cv vu cv cA
        cS co wceq wa vu vt copab eqid cU ip1i.9 phnvi ipasslem6.a sm1cni vs vr
        cB cC cD cP cU vs cv cX wcel vr cv vs cv cB cP co wceq wa vs vr copab
        cG cC copn cfv cJ cX ip1i.1 ip1i.2 ip1i.7 ipasslem6.8 ipasslem6.d cC
        copn cfv eqid ipasslem6.j vs cv cX wcel vr cv vs cv cB cP co wceq wa vs
        vr copab eqid cU ip1i.9 phnvi ipasslem6.b ip1cni pm3.2i cD cC cD vu cv
        cc wcel vt cv vu cv cA cS co wceq wa vu vt copab vs cv cX wcel vr cv vs
        cv cB cP co wceq wa vs vr copab cJ cC copn cfv cJ ipasslem6.j cC copn
        cfv eqid ipasslem6.j metcnco mp2an eqeltrri cA cB cP co cc wcel vu cv
        cc wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt copab cJ cJ ccn
        co wcel cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9
        phnvi ipasslem6.a ipasslem6.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an
        vs vr vq vu vt cD cD cD vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa vq
        cv vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD
        co cpr cr clt csup wceq wa vs vr vq copab2 cA cB cP co vu cv cc wcel vt
        cv vu cv cA cB cP co cmul co wceq wa vu vt copab cJ cJ vs cv cc cc cxp
        wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD co
        vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq
        copab2 copn cfv cmul cc cc cD ipasslem6.d cnmetba cD ipasslem6.d
        cnmetba cD ipasslem6.d cnmet cD ipasslem6.d cnmet cD ipasslem6.d cnmet
        vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv
        c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq
        wa vs vr vq copab2 eqid ipasslem6.j ipasslem6.j vs cv cc cc cxp wcel vr
        cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD co vs cv
        c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq copab2
        copn cfv eqid vs vr vq cD vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa
        vq cv vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv
        cD co cpr cr clt csup wceq wa vs vr vq copab2 cJ vs cv cc cc cxp wcel
        vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD co vs cv
        c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq copab2
        copn cfv ipasslem6.d vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa vq cv
        vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD co
        cpr cr clt csup wceq wa vs vr vq copab2 eqid ipasslem6.j vs cv cc cc
        cxp wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD
        co vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq
        copab2 copn cfv eqid mulcn vu cv cc wcel vt cv vu cv cA cB cP co cmul
        co wceq wa vu vt copab eqid opr1scn ax-mp vs vr vq vw vv cD cD cD vs cv
        cc cc cxp wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st
        cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa
        vs vr vq copab2 cJ vu cv cc wcel vt cv vu cv cA cS co cB cP co wceq wa
        vu vt copab vu cv cc wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt
        copab cF cD cJ cJ cJ vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa vq cv
        vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD co
        cpr cr clt csup wceq wa vs vr vq copab2 copn cfv cmin cc cc cc cD
        ipasslem6.d cnmetba cD ipasslem6.d cnmetba cD ipasslem6.d cnmetba cD
        ipasslem6.d cnmet cD ipasslem6.d cnmet cD ipasslem6.d cnmet cD
        ipasslem6.d cnmet ipasslem6.j ipasslem6.j ipasslem6.j vs cv cc cc cxp
        wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD co
        vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq
        copab2 copn cfv eqid ipasslem6.j vs cv cc cc cxp wcel vr cv cc cc cxp
        wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv
        c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq copab2 eqid vs vr vq cD
        vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv
        c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq
        wa vs vr vq copab2 cJ vs cv cc cc cxp wcel vr cv cc cc cxp wcel wa vq
        cv vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD
        co cpr cr clt csup wceq wa vs vr vq copab2 copn cfv ipasslem6.d vs cv
        cc cc cxp wcel vr cv cc cc cxp wcel wa vq cv vs cv c1st cfv vr cv c1st
        cfv cD co vs cv c2nd cfv vr cv c2nd cfv cD co cpr cr clt csup wceq wa
        vs vr vq copab2 eqid ipasslem6.j vs cv cc cc cxp wcel vr cv cc cc cxp
        wcel wa vq cv vs cv c1st cfv vr cv c1st cfv cD co vs cv c2nd cfv vr cv
        c2nd cfv cD co cpr cr clt csup wceq wa vs vr vq copab2 copn cfv eqid
        subcn cF vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co
        cmul co cmin co wceq wa vw vv copab vw cv cc wcel vv cv vw cv vu cv cc
        wcel vt cv vu cv cA cS co cB cP co wceq wa vu vt copab cfv vw cv vu cv
        cc wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt copab cfv cmin co
        wceq wa vw vv copab ipasslem6.f vw cv cc wcel vv cv vw cv vu cv cc wcel
        vt cv vu cv cA cS co cB cP co wceq wa vu vt copab cfv vw cv vu cv cc
        wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt copab cfv cmin co
        wceq wa vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co
        cmul co cmin co wceq wa vw vv vw cv cc wcel vv cv vw cv vu cv cc wcel
        vt cv vu cv cA cS co cB cP co wceq wa vu vt copab cfv vw cv vu cv cc
        wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt copab cfv cmin co
        wceq vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co
        wceq vw cv cc wcel vw cv vu cv cc wcel vt cv vu cv cA cS co cB cP co
        wceq wa vu vt copab cfv vw cv vu cv cc wcel vt cv vu cv cA cB cP co
        cmul co wceq wa vu vt copab cfv cmin co vw cv cA cS co cB cP co vw cv
        cA cB cP co cmul co cmin co vv cv vw cv cc wcel vw cv vu cv cc wcel vt
        cv vu cv cA cS co cB cP co wceq wa vu vt copab cfv vw cv cA cS co cB cP
        co vw cv vu cv cc wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt
        copab cfv vw cv cA cB cP co cmul co cmin vu vt vw cv vu cv cA cS co cB
        cP co vw cv cA cS co cB cP co cc vu cv cc wcel vt cv vu cv cA cS co cB
        cP co wceq wa vu vt copab vu cv vw cv wceq vu cv cA cS co vw cv cA cS
        co cB cP vu cv vw cv cA cS opreq1 opreq1d vu cv cc wcel vt cv vu cv cA
        cS co cB cP co wceq wa vu vt copab eqid vw cv cA cS co cB cP oprex
        fvopab4 vu vt vw cv vu cv cA cB cP co cmul co vw cv cA cB cP co cmul co
        cc vu cv cc wcel vt cv vu cv cA cB cP co cmul co wceq wa vu vt copab vu
        cv vw cv cA cB cP co cmul opreq1 vu cv cc wcel vt cv vu cv cA cB cP co
        cmul co wceq wa vu vt copab eqid vw cv cA cB cP co cmul oprex fvopab4
        opreq12d eqeq2d pm5.32i opabbii eqtr4i oprcn mp2an $.
        $( [5-Dec-2007] $) $( [23-Aug-2007] $)
    $}

    ${
      $d v w A $.  $d v w B $.  $d w D $.  $d w K $.  $d v w P $.  $d v w S $.
      ipasslem7.a $e |- A e. X $.
      ipasslem7.b $e |- B e. X $.
      ipasslem7.d $e |- D = ( abs o. - ) $.
      ipasslem7.c $e |- C = ( ( abs o. - ) |` ( RR X. RR ) ) $.
      ipasslem7.j $e |- J = ( Open ` C ) $.
      ipasslem7.k $e |- K = ( Open ` D ) $.
      ipasslem7.f $e |- F = { <. w , v >. | ( w e. RR /\
              v = ( ( ( w S A ) P B ) - ( w x. ( A P B ) ) ) ) } $.
      $( Lemma for ~ ipassi .  Show that
         ` ( ( w S A ) P B ) - ( w x. ( A P B ) ) ` is continuous on
         ` RR ` . $)
      ipasslem7 $p |- F e. ( J Cn K ) $=
        cF vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul
        co cmin co wceq wa vw vv copab cr cres cJ cK ccn co cF vw cv cr wcel vv
        cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co wceq wa vw
        vv copab vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co
        cmul co cmin co wceq wa vw vv copab cr cres ipasslem7.f cr cc wss vw cv
        cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co
        wceq wa vw vv copab cr cres vw cv cr wcel vv cv vw cv cA cS co cB cP co
        vw cv cA cB cP co cmul co cmin co wceq wa vw vv copab wceq axresscn vv
        cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co wceq vw vv
        cr cc resopab2 ax-mp eqtr4i cC cme wcel cD cme wcel cD cme wcel w3a cC
        cD wss vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co
        cmul co cmin co wceq wa vw vv copab cK cK ccn co wcel wa vw cv cc wcel
        vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co wceq wa
        vw vv copab cr cres cJ cK ccn co wcel cC cme wcel cD cme wcel cD cme
        wcel cC ipasslem7.c remet cD ipasslem7.d cnmet cD ipasslem7.d cnmet
        3pm3.2i cC cD wss vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA
        cB cP co cmul co cmin co wceq wa vw vv copab cK cK ccn co wcel cabs
        cmin ccom cr cr cxp cres cabs cmin ccom cC cD cabs cmin ccom cr cr cxp
        resss ipasslem7.c ipasslem7.d 3sstr4i vw vv cA cB cU cims cfv cD cP cS
        cU vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul
        co cmin co wceq wa vw vv copab cG cK cX ip1i.1 ip1i.2 ip1i.4 ip1i.7
        ip1i.9 ipasslem7.a ipasslem7.b ipasslem7.d cU cims cfv eqid ipasslem7.k
        vw cv cc wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co
        cmin co wceq wa vw vv copab eqid ipasslem6 pm3.2i cC cD cD vw cv cc
        wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co
        wceq wa vw vv copab cJ cK cK cr cC ipasslem7.c remetba ipasslem7.j
        ipasslem7.k ipasslem7.k metcnss2 mp2an eqeltri $.
        $( [5-Dec-2007] $) $( [23-Aug-2007] $)
    $}

    ${
      $d v w A $.  $d v w B $.  $d x F $.  $d v w P $.  $d v w S $.
      $d v w x $.
      ipasslem8.a $e |- A e. X $.
      ipasslem8.b $e |- B e. X $.
      ipasslem8.f $e |- F = { <. w , v >. | ( w e. RR /\
              v = ( ( ( w S A ) P B ) - ( w x. ( A P B ) ) ) ) } $.
      $( Lemma for ~ ipassi .  By ~ ipasslem5 , ` F ` is 0 for all ` QQ ` ;
         since it is continuous and ` QQ ` is dense in ` RR ` by ~ qdensere2 ,
         we conclude ` F ` is 0 for all ` RR ` . $)
      ipasslem8 $p |- F : RR --> { 0 } $=
        cabs cmin ccom cr cr cxp cres cme wcel cabs cmin ccom cme wcel cF cabs
        cmin ccom cr cr cxp cres copn cfv cabs cmin ccom copn cfv ccn co wcel
        w3a cc0 cc wcel cq cF ccnv cc0 csn cima wss cq cabs cmin ccom cr cr cxp
        cres copn cfv ccl cfv cfv cr wceq w3a cr cc0 csn cF wf cabs cmin ccom
        cr cr cxp cres cme wcel cabs cmin ccom cme wcel cF cabs cmin ccom cr cr
        cxp cres copn cfv cabs cmin ccom copn cfv ccn co wcel cabs cmin ccom cr
        cr cxp cres cabs cmin ccom cr cr cxp cres eqid remet cabs cmin ccom
        cabs cmin ccom eqid cnmet vw vv cA cB cabs cmin ccom cr cr cxp cres
        cabs cmin ccom cP cS cU cF cG cabs cmin ccom cr cr cxp cres copn cfv
        cabs cmin ccom copn cfv cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9
        ipasslem8.a ipasslem8.b cabs cmin ccom eqid cabs cmin ccom cr cr cxp
        cres eqid cabs cmin ccom cr cr cxp cres copn cfv eqid cabs cmin ccom
        copn cfv eqid ipasslem8.f ipasslem7 3pm3.2i cc0 cc wcel cq cF ccnv cc0
        csn cima wss cq cabs cmin ccom cr cr cxp cres copn cfv ccl cfv cfv cr
        wceq 0cn vx cv cF cfv cc0 wceq vx cq wral cq cF ccnv cc0 csn cima wss
        vx cv cF cfv cc0 wceq vx cq vx cv cq wcel vx cv cF cfv vx cv cA cS co
        cB cP co vx cv cA cB cP co cmul co cmin co cc0 vx cv cq wcel vx cv cr
        wcel vx cv cF cfv vx cv cA cS co cB cP co vx cv cA cB cP co cmul co
        cmin co wceq vx cv qre vw vv vx cv vw cv cA cS co cB cP co vw cv cA cB
        cP co cmul co cmin co vx cv cA cS co cB cP co vx cv cA cB cP co cmul co
        cmin co cr cF vw cv vx cv wceq vw cv cA cS co cB cP co vx cv cA cS co
        cB cP co vw cv cA cB cP co cmul co vx cv cA cB cP co cmul co cmin vw cv
        vx cv wceq vw cv cA cS co vx cv cA cS co cB cP vw cv vx cv cA cS opreq1
        opreq1d vw cv vx cv cA cB cP co cmul opreq1 opreq12d ipasslem8.f vx cv
        cA cS co cB cP co vx cv cA cB cP co cmul co cmin oprex fvopab4 syl vx
        cv cq wcel cA cX wcel vx cv cA cS co cB cP co vx cv cA cB cP co cmul co
        cmin co cc0 wceq ipasslem8.a vx cv cq wcel cA cX wcel wa vx cv cA cS co
        cB cP co vx cv cA cB cP co cmul co cmin co cc0 wceq vx cv cA cS co cB
        cP co vx cv cA cB cP co cmul co wceq cA cB vx cv cP cS cU cG cX ip1i.1
        ip1i.2 ip1i.4 ip1i.7 ip1i.9 ipasslem8.b ipasslem5 vx cv cA cS co cB cP
        co cc wcel vx cv cA cB cP co cmul co cc wcel vx cv cA cS co cB cP co vx
        cv cA cB cP co cmul co cmin co cc0 wceq vx cv cA cS co cB cP co vx cv
        cA cB cP co cmul co wceq wb vx cv cq wcel cA cX wcel wa vx cv cA cS co
        cB cP co vx cv cA cB cP co cmul co subeq0 vx cv cq wcel cA cX wcel wa
        vx cv cA cS co cX wcel vx cv cA cS co cB cP co cc wcel vx cv cc wcel cA
        cX wcel vx cv cA cS co cX wcel vx cv cq wcel cU cnv wcel vx cv cc wcel
        cA cX wcel vx cv cA cS co cX wcel cU ip1i.9 phnvi vx cv cA cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an1 vx cv qcn sylan cU cnv wcel vx cv cA cS co
        cX wcel cB cX wcel vx cv cA cS co cB cP co cc wcel cU ip1i.9 phnvi
        ipasslem8.b vx cv cA cS co cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl
        vx cv cc wcel cA cB cP co cc wcel vx cv cA cB cP co cmul co cc wcel vx
        cv cq wcel cA cX wcel vx cv cA cB cP co mulcl vx cv qcn cU cnv wcel cA
        cX wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem8.b cA
        cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an13 syl2an sylanc mpbird mpan2 eqtrd
        rgen cF wfun cq cF cdm wss vx cv cF cfv cc0 wceq vx cq wral cq cF ccnv
        cc0 csn cima wss wb cF cr wfn cF wfun vw vv cr vw cv cA cS co cB cP co
        vw cv cA cB cP co cmul co cmin co cF vw cv cA cS co cB cP co vw cv cA
        cB cP co cmul co cmin oprex ipasslem8.f fnopab2 cr cF fnfun ax-mp cq cr
        cF cdm qssre vw vv cr vw cv cA cS co cB cP co vw cv cA cB cP co cmul co
        cmin co cF vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin oprex
        ipasslem8.f dmopab2 sseqtr4i vx cq cc0 cF funconstss mp2an mpbi cabs
        cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres copn cfv cabs
        cmin ccom cr cr cxp cres eqid cabs cmin ccom cr cr cxp cres copn cfv
        eqid qdensere2 3pm3.2i cq cabs cmin ccom cr cr cxp cres cabs cmin ccom
        cc0 cF cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom copn cfv
        cr cc cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid
        remetba cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom cr cr
        cxp cres copn cfv eqid cabs cmin ccom copn cfv eqid metdnsconst mp2an
        $.
        $( [6-Nov-2007] $) $( [24-Aug-2007] $)
    $}

    ${
      $d v w A $.  $d v w B $.  $d v w C $.  $d v w P $.  $d v w S $.
      ipasslem9.a $e |- A e. X $.
      ipasslem9.b $e |- B e. X $.
      $( Lemma for ~ ipassi .  Conclude from ~ ipasslem8 the inner product
         associative law for real numbers. $)
      ipasslem9 $p |- ( C e. RR ->
                  ( ( C S A ) P B ) = ( C x. ( A P B ) ) ) $=
        cC cr wcel cC cA cS co cB cP co cC cA cB cP co cmul co cmin co cc0 wceq
        cC cA cS co cB cP co cC cA cB cP co cmul co wceq cC cr wcel cC vw cv cr
        wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co
        wceq wa vw vv copab cfv cC cA cS co cB cP co cC cA cB cP co cmul co
        cmin co cc0 vw vv cC vw cv cA cS co cB cP co vw cv cA cB cP co cmul co
        cmin co cC cA cS co cB cP co cC cA cB cP co cmul co cmin co cr vw cv cr
        wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co
        wceq wa vw vv copab vw cv cC wceq vw cv cA cS co cB cP co cC cA cS co
        cB cP co vw cv cA cB cP co cmul co cC cA cB cP co cmul co cmin vw cv cC
        wceq vw cv cA cS co cC cA cS co cB cP vw cv cC cA cS opreq1 opreq1d vw
        cv cC cA cB cP co cmul opreq1 opreq12d vw cv cr wcel vv cv vw cv cA cS
        co cB cP co vw cv cA cB cP co cmul co cmin co wceq wa vw vv copab eqid
        cC cA cS co cB cP co cC cA cB cP co cmul co cmin oprex fvopab4 cr cc0
        csn vw cv cr wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul
        co cmin co wceq wa vw vv copab wf cC cr wcel cC vw cv cr wcel vv cv vw
        cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co wceq wa vw vv
        copab cfv cc0 wceq vw vv cA cB cP cS cU vw cv cr wcel vv cv vw cv cA cS
        co cB cP co vw cv cA cB cP co cmul co cmin co wceq wa vw vv copab cG cX
        ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 ipasslem9.a ipasslem9.b vw cv cr
        wcel vv cv vw cv cA cS co cB cP co vw cv cA cB cP co cmul co cmin co
        wceq wa vw vv copab eqid ipasslem8 cr cc0 cC vw cv cr wcel vv cv vw cv
        cA cS co cB cP co vw cv cA cB cP co cmul co cmin co wceq wa vw vv copab
        fvconst mpan eqtr3d cC cr wcel cC cc wcel cC cA cS co cB cP co cC cA cB
        cP co cmul co cmin co cc0 wceq cC cA cS co cB cP co cC cA cB cP co cmul
        co wceq wb cC recn cC cA cS co cB cP co cc wcel cC cA cB cP co cmul co
        cc wcel cC cA cS co cB cP co cC cA cB cP co cmul co cmin co cc0 wceq cC
        cA cS co cB cP co cC cA cB cP co cmul co wceq wb cC cc wcel cC cA cS co
        cB cP co cC cA cB cP co cmul co subeq0 cC cc wcel cC cA cS co cX wcel
        cC cA cS co cB cP co cc wcel cU cnv wcel cC cc wcel cA cX wcel cC cA cS
        co cX wcel cU ip1i.9 phnvi ipasslem9.a cC cA cS cU cX ip1i.1 ip1i.4
        nvscl mp3an13 cU cnv wcel cC cA cS co cX wcel cB cX wcel cC cA cS co cB
        cP co cc wcel cU ip1i.9 phnvi ipasslem9.b cC cA cS co cB cP cU cX
        ip1i.1 ip1i.7 ipcl mp3an13 syl cC cc wcel cA cB cP co cc wcel cC cA cB
        cP co cmul co cc wcel cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc
        wcel cU ip1i.9 phnvi ipasslem9.a ipasslem9.b cA cB cP cU cX ip1i.1
        ip1i.7 ipcl mp3an cC cA cB cP co mulcl mpan2 sylanc syl mpbid $.
        $( [6-Nov-2007] $) $( [24-Aug-2007] $)
    $}

    ${
      ipasslem10.a $e |- A e. X $.
      ipasslem10.b $e |- B e. X $.
      ipasslem10.6 $e |- N = ( norm ` U ) $.
      $( Lemma for ~ ipassi .  Show the inner product associative law for
         the imaginary number ` _i ` . $)
      ipasslem10 $p |- ( ( _i S A ) P B ) = ( _i x. ( A P B ) ) $=
        cB ci cA cS co cP co ccj cfv ci cneg cB cA cP co cmul co ccj cfv ci cA
        cS co cB cP co ci cA cB cP co cmul co cB ci cA cS co cP co ci cneg cB
        cA cP co cmul co ccj c4 cB ci cA cS co cP co cmul co c4 ci cneg cB cA
        cP co cmul co cmul co wceq cB ci cA cS co cP co ci cneg cB cA cP co
        cmul co wceq cB ci cA cS co cG co cN cfv c2 cexp co cB c1 cneg ci cA cS
        co cS co cG co cN cfv c2 cexp co cmin co ci cB ci ci cA cS co cS co cG
        co cN cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co cN cfv c2 cexp
        co cmin co cmul co caddc co ci cneg c4 cB cA cP co cmul co cmul co c4
        cB ci cA cS co cP co cmul co c4 ci cneg cB cA cP co cmul co cmul co cB
        ci cA cS co cG co cN cfv c2 cexp co cB c1 cneg ci cA cS co cS co cG co
        cN cfv c2 cexp co cmin co ci cB ci ci cA cS co cS co cG co cN cfv c2
        cexp co cB ci cneg ci cA cS co cS co cG co cN cfv c2 cexp co cmin co
        cmul co caddc co ci cneg cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS
        co cG co cN cfv c2 cexp co cmin co ci cB ci cA cS co cG co cN cfv c2
        cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co
        caddc co cmul co ci cneg c4 cB cA cP co cmul co cmul co ci cB ci ci cA
        cS co cS co cG co cN cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co
        cN cfv c2 cexp co cmin co cmul co cB ci cA cS co cG co cN cfv c2 cexp
        co cB c1 cneg ci cA cS co cS co cG co cN cfv c2 cexp co cmin co caddc
        co ci cneg cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN
        cfv c2 cexp co cmin co cmul co ci cneg ci cB ci cA cS co cG co cN cfv
        c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co
        cmul co caddc co cB ci cA cS co cG co cN cfv c2 cexp co cB c1 cneg ci
        cA cS co cS co cG co cN cfv c2 cexp co cmin co ci cB ci ci cA cS co cS
        co cG co cN cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co cN cfv c2
        cexp co cmin co cmul co caddc co ci cneg cB cA cG co cN cfv c2 cexp co
        cB c1 cneg cA cS co cG co cN cfv c2 cexp co cmin co ci cB ci cA cS co
        cG co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co
        cmin co cmul co caddc co cmul co ci cB ci ci cA cS co cS co cG co cN
        cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co cN cfv c2 cexp co
        cmin co cmul co ci cneg cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS
        co cG co cN cfv c2 cexp co cmin co cmul co cB ci cA cS co cG co cN cfv
        c2 cexp co cB c1 cneg ci cA cS co cS co cG co cN cfv c2 cexp co cmin co
        ci cneg ci cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA cS co
        cG co cN cfv c2 cexp co cmin co cmul co cmul co caddc ci cB ci ci cA cS
        co cS co cG co cN cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co cN
        cfv c2 cexp co cmin co cmul co ci cB c1 cneg cA cS co cG co cN cfv c2
        cexp co cB cA cG co cN cfv c2 cexp co cmin co cmul co ci c1 cneg cmul
        co cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2
        cexp co cmin co cmul co ci cneg cB cA cG co cN cfv c2 cexp co cB c1
        cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co cB ci ci cA cS co
        cS co cG co cN cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co cN cfv
        c2 cexp co cmin co cB c1 cneg cA cS co cG co cN cfv c2 cexp co cB cA cG
        co cN cfv c2 cexp co cmin co ci cmul cB ci ci cA cS co cS co cG co cN
        cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp co cB ci cneg
        ci cA cS co cS co cG co cN cfv c2 cexp co cB cA cG co cN cfv c2 cexp co
        cmin cB ci ci cA cS co cS co cG co cN cfv cB c1 cneg cA cS co cG co cN
        cfv c2 cexp cB ci ci cA cS co cS co cG co cB c1 cneg cA cS co cG co cN
        ci ci cA cS co cS co c1 cneg cA cS co cB cG ci ci cmul co cA cS co ci
        ci cA cS co cS co c1 cneg cA cS co cU cnv wcel ci cc wcel ci cc wcel cA
        cX wcel w3a ci ci cmul co cA cS co ci ci cA cS co cS co wceq cU ip1i.9
        phnvi ci cc wcel ci cc wcel cA cX wcel axicn axicn ipasslem10.a 3pm3.2i
        ci ci cA cS cU cX ip1i.1 ip1i.4 nvsass mp2an ci ci cmul co c1 cneg cA
        cS ixi opreq1i eqtr3i opreq2i fveq2i opreq1i cB ci cneg ci cA cS co cS
        co cG co cN cfv cB cA cG co cN cfv c2 cexp cB ci cneg ci cA cS co cS co
        cG co cB cA cG co cN ci cneg ci cA cS co cS co cA cB cG ci cneg ci cmul
        co cA cS co c1 cA cS co ci cneg ci cA cS co cS co cA ci cneg ci cmul co
        c1 cA cS ci cneg ci cmul co ci ci cmul co cneg c1 cneg cneg c1 ci ci
        axicn axicn mulneg1i ci ci cmul co c1 cneg ixi negeqi c1 ax1cn negnegi
        3eqtri opreq1i cU cnv wcel ci cneg cc wcel ci cc wcel cA cX wcel w3a ci
        cneg ci cmul co cA cS co ci cneg ci cA cS co cS co wceq cU ip1i.9 phnvi
        ci cneg cc wcel ci cc wcel cA cX wcel ci axicn negcli axicn
        ipasslem10.a 3pm3.2i ci cneg ci cA cS cU cX ip1i.1 ip1i.4 nvsass mp2an
        cU cnv wcel cA cX wcel c1 cA cS co cA wceq cU ip1i.9 phnvi ipasslem10.a
        cA cS cU cX ip1i.1 ip1i.4 nvsid mp2an 3eqtr3i opreq2i fveq2i opreq1i
        opreq12i opreq2i ci cB c1 cneg cA cS co cG co cN cfv c2 cexp co cB cA
        cG co cN cfv c2 cexp co cmin co cmul co ci c1 cneg cB cA cG co cN cfv
        c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co
        cmul co ci c1 cneg cmul co cB cA cG co cN cfv c2 cexp co cB c1 cneg cA
        cS co cG co cN cfv c2 cexp co cmin co cmul co cB c1 cneg cA cS co cG co
        cN cfv c2 cexp co cB cA cG co cN cfv c2 cexp co cmin co c1 cneg cB cA
        cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp co
        cmin co cmul co ci cmul c1 cneg cB cA cG co cN cfv c2 cexp co cB c1
        cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co cB cA cG co cN
        cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp co cmin co cneg
        cB c1 cneg cA cS co cG co cN cfv c2 cexp co cB cA cG co cN cfv c2 cexp
        co cmin co cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN
        cfv c2 cexp co cmin co cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS
        co cG co cN cfv c2 cexp co cB cA cG co cN cfv cB cA cG co cN cfv cB cA
        cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX
        wcel cA cX wcel cB cA cG co cX wcel cU ip1i.9 phnvi ipasslem10.b
        ipasslem10.a cB cA cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli
        cB c1 cneg cA cS co cG co cN cfv cB c1 cneg cA cS co cG co cN cfv cB c1
        cneg cA cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv
        wcel cB cX wcel c1 cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX
        wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel c1 cneg cc wcel cA cX
        wcel c1 cneg cA cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli
        ipasslem10.a c1 cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB c1 cneg
        cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli subcli
        mulm1i cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv
        c2 cexp co cB cA cG co cN cfv cB cA cG co cN cfv cB cA cG co cU cN cX
        ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel cA cX wcel
        cB cA cG co cX wcel cU ip1i.9 phnvi ipasslem10.b ipasslem10.a cB cA cU
        cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli cB c1 cneg cA cS co
        cG co cN cfv cB c1 cneg cA cS co cG co cN cfv cB c1 cneg cA cS co cG co
        cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel c1
        cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX wcel cU ip1i.9 phnvi
        ipasslem10.b cU cnv wcel c1 cneg cc wcel cA cX wcel c1 cneg cA cS co cX
        wcel cU ip1i.9 phnvi c1 ax1cn negcli ipasslem10.a c1 cneg cA cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an cB c1 cneg cA cS co cU cG cX ip1i.1 ip1i.2
        nvgcl mp3an nvcli recni sqcli negsubdi2i eqtr2i opreq2i ci c1 cneg cB
        cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp co
        cmin co axicn c1 ax1cn negcli cB cA cG co cN cfv c2 cexp co cB c1 cneg
        cA cS co cG co cN cfv c2 cexp co cB cA cG co cN cfv cB cA cG co cN cfv
        cB cA cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB
        cX wcel cA cX wcel cB cA cG co cX wcel cU ip1i.9 phnvi ipasslem10.b
        ipasslem10.a cB cA cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli
        cB c1 cneg cA cS co cG co cN cfv cB c1 cneg cA cS co cG co cN cfv cB c1
        cneg cA cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv
        wcel cB cX wcel c1 cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX
        wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel c1 cneg cc wcel cA cX
        wcel c1 cneg cA cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli
        ipasslem10.a c1 cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB c1 cneg
        cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli subcli
        mulassi eqtr4i ci c1 cneg cmul co ci cneg cB cA cG co cN cfv c2 cexp co
        cB c1 cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul ci c1 cneg
        cmul co c1 cneg ci cmul co ci cneg ci c1 cneg axicn c1 ax1cn negcli
        mulcomi ci axicn mulm1i eqtri opreq1i 3eqtri cB ci cA cS co cG co cN
        cfv c2 cexp co cB c1 cneg ci cA cS co cS co cG co cN cfv c2 cexp co
        cmin co c1 cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA cS co
        cG co cN cfv c2 cexp co cmin co cmul co ci cneg ci cmul co cB ci cA cS
        co cG co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co
        cmin co cmul co ci cneg ci cB ci cA cS co cG co cN cfv c2 cexp co cB ci
        cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co cmul co cB ci cA
        cS co cG co cN cfv c2 cexp co cB c1 cneg ci cA cS co cS co cG co cN cfv
        c2 cexp co cmin co cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA
        cS co cG co cN cfv c2 cexp co cmin co c1 cB ci cA cS co cG co cN cfv c2
        cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co cB
        c1 cneg ci cA cS co cS co cG co cN cfv c2 cexp co cB ci cneg cA cS co
        cG co cN cfv c2 cexp co cB ci cA cS co cG co cN cfv c2 cexp co cmin cB
        c1 cneg ci cA cS co cS co cG co cN cfv cB ci cneg cA cS co cG co cN cfv
        c2 cexp cB c1 cneg ci cA cS co cS co cG co cB ci cneg cA cS co cG co cN
        c1 cneg ci cA cS co cS co ci cneg cA cS co cB cG c1 cneg ci cmul co cA
        cS co c1 cneg ci cA cS co cS co ci cneg cA cS co cU cnv wcel c1 cneg cc
        wcel ci cc wcel cA cX wcel w3a c1 cneg ci cmul co cA cS co c1 cneg ci
        cA cS co cS co wceq cU ip1i.9 phnvi c1 cneg cc wcel ci cc wcel cA cX
        wcel c1 ax1cn negcli axicn ipasslem10.a 3pm3.2i c1 cneg ci cA cS cU cX
        ip1i.1 ip1i.4 nvsass mp2an c1 cneg ci cmul co ci cneg cA cS ci axicn
        mulm1i opreq1i eqtr3i opreq2i fveq2i opreq1i opreq2i cB ci cA cS co cG
        co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin
        co cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN
        cfv c2 cexp co cB ci cA cS co cG co cN cfv cB ci cA cS co cG co cN cfv
        cB ci cA cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU
        cnv wcel cB cX wcel ci cA cS co cX wcel cB ci cA cS co cG co cX wcel cU
        ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cc wcel cA cX wcel ci cA cS co
        cX wcel cU ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU cX ip1i.1 ip1i.4
        nvscl mp3an cB ci cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli
        recni sqcli cB ci cneg cA cS co cG co cN cfv cB ci cneg cA cS co cG co
        cN cfv cB ci cneg cA cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9
        phnvi cU cnv wcel cB cX wcel ci cneg cA cS co cX wcel cB ci cneg cA cS
        co cG co cX wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cneg cc
        wcel cA cX wcel ci cneg cA cS co cX wcel cU ip1i.9 phnvi ci axicn
        negcli ipasslem10.a ci cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB ci
        cneg cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli
        subcli mulid2i eqtr4i ci cneg ci cmul co c1 cB ci cA cS co cG co cN cfv
        c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul ci
        cneg ci cmul co ci ci cmul co cneg c1 cneg cneg c1 ci ci axicn axicn
        mulneg1i ci ci cmul co c1 cneg ixi negeqi c1 ax1cn negnegi 3eqtri
        opreq1i ci cneg ci cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA
        cS co cG co cN cfv c2 cexp co cmin co ci axicn negcli axicn cB ci cA cS
        co cG co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co
        cB ci cA cS co cG co cN cfv cB ci cA cS co cG co cN cfv cB ci cA cS co
        cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX
        wcel ci cA cS co cX wcel cB ci cA cS co cG co cX wcel cU ip1i.9 phnvi
        ipasslem10.b cU cnv wcel ci cc wcel cA cX wcel ci cA cS co cX wcel cU
        ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU cX ip1i.1 ip1i.4 nvscl
        mp3an cB ci cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni
        sqcli cB ci cneg cA cS co cG co cN cfv cB ci cneg cA cS co cG co cN cfv
        cB ci cneg cA cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi
        cU cnv wcel cB cX wcel ci cneg cA cS co cX wcel cB ci cneg cA cS co cG
        co cX wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cneg cc wcel cA
        cX wcel ci cneg cA cS co cX wcel cU ip1i.9 phnvi ci axicn negcli
        ipasslem10.a ci cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB ci cneg
        cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli subcli
        mulassi 3eqtr2i opreq12i cB ci cA cS co cG co cN cfv c2 cexp co cB c1
        cneg ci cA cS co cS co cG co cN cfv c2 cexp co cmin co ci cB ci ci cA
        cS co cS co cG co cN cfv c2 cexp co cB ci cneg ci cA cS co cS co cG co
        cN cfv c2 cexp co cmin co cmul co cB ci cA cS co cG co cN cfv c2 cexp
        co cB c1 cneg ci cA cS co cS co cG co cN cfv c2 cexp co cB ci cA cS co
        cG co cN cfv cB ci cA cS co cG co cN cfv cB ci cA cS co cG co cU cN cX
        ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel ci cA cS co
        cX wcel cB ci cA cS co cG co cX wcel cU ip1i.9 phnvi ipasslem10.b cU
        cnv wcel ci cc wcel cA cX wcel ci cA cS co cX wcel cU ip1i.9 phnvi
        axicn ipasslem10.a ci cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB ci cA cS
        co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli cB c1 cneg ci
        cA cS co cS co cG co cN cfv cB c1 cneg ci cA cS co cS co cG co cN cfv
        cB c1 cneg ci cA cS co cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU
        ip1i.9 phnvi cU cnv wcel cB cX wcel c1 cneg ci cA cS co cS co cX wcel
        cB c1 cneg ci cA cS co cS co cG co cX wcel cU ip1i.9 phnvi ipasslem10.b
        cU cnv wcel c1 cneg cc wcel ci cA cS co cX wcel c1 cneg ci cA cS co cS
        co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli cU cnv wcel ci cc wcel cA cX
        wcel ci cA cS co cX wcel cU ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU
        cX ip1i.1 ip1i.4 nvscl mp3an c1 cneg ci cA cS co cS cU cX ip1i.1 ip1i.4
        nvscl mp3an cB c1 cneg ci cA cS co cS co cU cG cX ip1i.1 ip1i.2 nvgcl
        mp3an nvcli recni sqcli subcli ci cB ci ci cA cS co cS co cG co cN cfv
        c2 cexp co cB ci cneg ci cA cS co cS co cG co cN cfv c2 cexp co cmin co
        axicn cB ci ci cA cS co cS co cG co cN cfv c2 cexp co cB ci cneg ci cA
        cS co cS co cG co cN cfv c2 cexp co cB ci ci cA cS co cS co cG co cN
        cfv cB ci ci cA cS co cS co cG co cN cfv cB ci ci cA cS co cS co cG co
        cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel ci
        ci cA cS co cS co cX wcel cB ci ci cA cS co cS co cG co cX wcel cU
        ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cc wcel ci cA cS co cX wcel ci
        ci cA cS co cS co cX wcel cU ip1i.9 phnvi axicn cU cnv wcel ci cc wcel
        cA cX wcel ci cA cS co cX wcel cU ip1i.9 phnvi axicn ipasslem10.a ci cA
        cS cU cX ip1i.1 ip1i.4 nvscl mp3an ci ci cA cS co cS cU cX ip1i.1
        ip1i.4 nvscl mp3an cB ci ci cA cS co cS co cU cG cX ip1i.1 ip1i.2 nvgcl
        mp3an nvcli recni sqcli cB ci cneg ci cA cS co cS co cG co cN cfv cB ci
        cneg ci cA cS co cS co cG co cN cfv cB ci cneg ci cA cS co cS co cG co
        cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel ci
        cneg ci cA cS co cS co cX wcel cB ci cneg ci cA cS co cS co cG co cX
        wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cneg cc wcel ci cA cS
        co cX wcel ci cneg ci cA cS co cS co cX wcel cU ip1i.9 phnvi ci axicn
        negcli cU cnv wcel ci cc wcel cA cX wcel ci cA cS co cX wcel cU ip1i.9
        phnvi axicn ipasslem10.a ci cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an ci
        cneg ci cA cS co cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB ci cneg ci cA cS
        co cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli subcli
        mulcli addcomi ci cneg cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS
        co cG co cN cfv c2 cexp co cmin co ci cB ci cA cS co cG co cN cfv c2
        cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin co cmul co ci
        axicn negcli cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN
        cfv c2 cexp co cB cA cG co cN cfv cB cA cG co cN cfv cB cA cG co cU cN
        cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel cA cX
        wcel cB cA cG co cX wcel cU ip1i.9 phnvi ipasslem10.b ipasslem10.a cB
        cA cU cG cX ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli cB c1 cneg cA
        cS co cG co cN cfv cB c1 cneg cA cS co cG co cN cfv cB c1 cneg cA cS co
        cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX
        wcel c1 cneg cA cS co cX wcel cB c1 cneg cA cS co cG co cX wcel cU
        ip1i.9 phnvi ipasslem10.b cU cnv wcel c1 cneg cc wcel cA cX wcel c1
        cneg cA cS co cX wcel cU ip1i.9 phnvi c1 ax1cn negcli ipasslem10.a c1
        cneg cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an cB c1 cneg cA cS co cU cG cX
        ip1i.1 ip1i.2 nvgcl mp3an nvcli recni sqcli subcli ci cB ci cA cS co cG
        co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp co cmin
        co axicn cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA cS co cG
        co cN cfv c2 cexp co cB ci cA cS co cG co cN cfv cB ci cA cS co cG co
        cN cfv cB ci cA cS co cG co cU cN cX ip1i.1 ipasslem10.6 cU ip1i.9
        phnvi cU cnv wcel cB cX wcel ci cA cS co cX wcel cB ci cA cS co cG co
        cX wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cc wcel cA cX wcel
        ci cA cS co cX wcel cU ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an cB ci cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl
        mp3an nvcli recni sqcli cB ci cneg cA cS co cG co cN cfv cB ci cneg cA
        cS co cG co cN cfv cB ci cneg cA cS co cG co cU cN cX ip1i.1
        ipasslem10.6 cU ip1i.9 phnvi cU cnv wcel cB cX wcel ci cneg cA cS co cX
        wcel cB ci cneg cA cS co cG co cX wcel cU ip1i.9 phnvi ipasslem10.b cU
        cnv wcel ci cneg cc wcel cA cX wcel ci cneg cA cS co cX wcel cU ip1i.9
        phnvi ci axicn negcli ipasslem10.a ci cneg cA cS cU cX ip1i.1 ip1i.4
        nvscl mp3an cB ci cneg cA cS co cU cG cX ip1i.1 ip1i.2 nvgcl mp3an
        nvcli recni sqcli subcli mulcli adddii 3eqtr4i c4 cB cA cP co cmul co
        cB cA cG co cN cfv c2 cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp
        co cmin co ci cB ci cA cS co cG co cN cfv c2 cexp co cB ci cneg cA cS
        co cG co cN cfv c2 cexp co cmin co cmul co caddc co ci cneg cmul cU cnv
        wcel cB cX wcel cA cX wcel c4 cB cA cP co cmul co cB cA cG co cN cfv c2
        cexp co cB c1 cneg cA cS co cG co cN cfv c2 cexp co cmin co ci cB ci cA
        cS co cG co cN cfv c2 cexp co cB ci cneg cA cS co cG co cN cfv c2 cexp
        co cmin co cmul co caddc co wceq cU ip1i.9 phnvi ipasslem10.b
        ipasslem10.a cB cA cP cS cU cG cN cX ip1i.1 ip1i.2 ip1i.4 ipasslem10.6
        ip1i.7 4ipval2 mp3an opreq2i eqtr4i cU cnv wcel cB cX wcel ci cA cS co
        cX wcel c4 cB ci cA cS co cP co cmul co cB ci cA cS co cG co cN cfv c2
        cexp co cB c1 cneg ci cA cS co cS co cG co cN cfv c2 cexp co cmin co ci
        cB ci ci cA cS co cS co cG co cN cfv c2 cexp co cB ci cneg ci cA cS co
        cS co cG co cN cfv c2 cexp co cmin co cmul co caddc co wceq cU ip1i.9
        phnvi ipasslem10.b cU cnv wcel ci cc wcel cA cX wcel ci cA cS co cX
        wcel cU ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU cX ip1i.1 ip1i.4
        nvscl mp3an cB ci cA cS co cP cS cU cG cN cX ip1i.1 ip1i.2 ip1i.4
        ipasslem10.6 ip1i.7 4ipval2 mp3an c4 ci cneg cB cA cP co c4 4re recni
        ci axicn negcli cU cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel
        cU ip1i.9 phnvi ipasslem10.b ipasslem10.a cB cA cP cU cX ip1i.1 ip1i.7
        ipcl mp3an mul12i 3eqtr4i cB ci cA cS co cP co ci cneg cB cA cP co cmul
        co c4 cU cnv wcel cB cX wcel ci cA cS co cX wcel cB ci cA cS co cP co
        cc wcel cU ip1i.9 phnvi ipasslem10.b cU cnv wcel ci cc wcel cA cX wcel
        ci cA cS co cX wcel cU ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU cX
        ip1i.1 ip1i.4 nvscl mp3an cB ci cA cS co cP cU cX ip1i.1 ip1i.7 ipcl
        mp3an ci cneg cB cA cP co ci axicn negcli cU cnv wcel cB cX wcel cA cX
        wcel cB cA cP co cc wcel cU ip1i.9 phnvi ipasslem10.b ipasslem10.a cB
        cA cP cU cX ip1i.1 ip1i.7 ipcl mp3an mulcli c4 4re recni c4 4re 4pos
        gt0ne0ii mulcani mpbi fveq2i cU cnv wcel cB cX wcel ci cA cS co cX wcel
        cB ci cA cS co cP co ccj cfv ci cA cS co cB cP co wceq cU ip1i.9 phnvi
        ipasslem10.b cU cnv wcel ci cc wcel cA cX wcel ci cA cS co cX wcel cU
        ip1i.9 phnvi axicn ipasslem10.a ci cA cS cU cX ip1i.1 ip1i.4 nvscl
        mp3an cB ci cA cS co cP cU cX ip1i.1 ip1i.7 ipcj mp3an ci cneg cB cA cP
        co cmul co ccj cfv ci cneg ccj cfv cB cA cP co ccj cfv cmul co ci cA cB
        cP co cmul co ci cneg cB cA cP co ci axicn negcli cU cnv wcel cB cX
        wcel cA cX wcel cB cA cP co cc wcel cU ip1i.9 phnvi ipasslem10.b
        ipasslem10.a cB cA cP cU cX ip1i.1 ip1i.7 ipcl mp3an cjmuli ci cneg ccj
        cfv ci cB cA cP co ccj cfv cA cB cP co cmul ci cneg ccj cfv c1 cneg ccj
        cfv ci ccj cfv cmul co c1 cneg ci cneg cmul co ci c1 cneg ci cmul co
        ccj cfv ci cneg ccj cfv c1 cneg ccj cfv ci ccj cfv cmul co c1 cneg ci
        cmul co ci cneg ccj ci axicn mulm1i fveq2i c1 cneg ci c1 ax1cn negcli
        axicn cjmuli eqtr3i c1 cneg ccj cfv c1 cneg ci ccj cfv ci cneg cmul c1
        cneg cr wcel c1 cneg ccj cfv c1 cneg wceq c1 1re renegcli c1 cneg c1
        ax1cn negcli cjrebi mpbi cji opreq12i c1 cneg ci cneg cmul co c1 ci
        cmul co ci c1 ci ax1cn axicn mul2negi ci axicn mulid2i eqtri 3eqtri cU
        cnv wcel cB cX wcel cA cX wcel cB cA cP co ccj cfv cA cB cP co wceq cU
        ip1i.9 phnvi ipasslem10.b ipasslem10.a cB cA cP cU cX ip1i.1 ip1i.7
        ipcj mp3an opreq12i eqtri 3eqtr3i $.
        $( [4-Nov-2007] $) $( [24-Aug-2007] $)
    $}

    ${
      $d x B $.  $d x y C $.  $d x y P $.
      ipasslem11.a $e |- A e. X $.
      ipasslem11.b $e |- B e. X $.
      $( MAY BE REVISED - proof got longer with axcnreOLD -> axcnre because
         of axmulcl - is it possible to rewrite it to shorten it? $)
      $( Lemma for ~ ipassi .  Show the inner product associative law for
         all complex numbers. $)
      ipasslem11 $p |- ( C e. CC ->
                  ( ( C S A ) P B ) = ( C x. ( A P B ) ) ) $=
        cC cc wcel cC vx cv ci vy cv cmul co caddc co wceq vy cr wrex vx cr
        wrex cC cA cS co cB cP co cC cA cB cP co cmul co wceq vx vy cC axcnre
        cC vx cv ci vy cv cmul co caddc co wceq cC cA cS co cB cP co cC cA cB
        cP co cmul co wceq vx vy cr cr vx cv cr wcel vy cv cr wcel wa cC vx cv
        ci vy cv cmul co caddc co wceq cC vx cv vy cv ci cmul co caddc co wceq
        cC cA cS co cB cP co cC cA cB cP co cmul co wceq vx cv cr wcel vy cv cr
        wcel wa vx cv ci vy cv cmul co caddc co vx cv vy cv ci cmul co caddc co
        cC vx cv cr wcel vy cv cr wcel wa ci vy cv cmul co vy cv ci cmul co vx
        cv caddc vy cv cr wcel ci vy cv cmul co vy cv ci cmul co wceq vx cv cr
        wcel vy cv cr wcel vy cv cc wcel ci vy cv cmul co vy cv ci cmul co wceq
        vy cv recn ci cc wcel vy cv cc wcel ci vy cv cmul co vy cv ci cmul co
        wceq axicn ci vy cv mulcom mpan syl adantl opreq2d eqeq2d cC vx cv vy
        cv ci cmul co caddc co wceq cC cA cS co cB cP co cC cA cB cP co cmul co
        wceq vx cv vy cv ci cmul co caddc co cA cS co cB cP co vx cv vy cv ci
        cmul co caddc co cA cB cP co cmul co wceq vx cv cr wcel vy cv cr wcel
        wa cC vx cv vy cv ci cmul co caddc co wceq cC cA cS co cB cP co vx cv
        vy cv ci cmul co caddc co cA cS co cB cP co cC cA cB cP co cmul co vx
        cv vy cv ci cmul co caddc co cA cB cP co cmul co cC vx cv vy cv ci cmul
        co caddc co wceq cC cA cS co vx cv vy cv ci cmul co caddc co cA cS co
        cB cP cC vx cv vy cv ci cmul co caddc co cA cS opreq1 opreq1d cC vx cv
        vy cv ci cmul co caddc co cA cB cP co cmul opreq1 eqeq12d vx cv cr wcel
        vy cv cr wcel wa vx cv vy cv ci cmul co caddc co cA cS co cB cP co vx
        cv cA cB cP co cmul co vy cv ci cmul co cA cB cP co cmul co caddc co vx
        cv vy cv ci cmul co caddc co cA cB cP co cmul co vx cv cr wcel vy cv cr
        wcel wa vx cv vy cv ci cmul co caddc co cA cS co cB cP co vx cv cA cS
        co vy cv ci cmul co cA cS co cG co cB cP co vx cv cA cS co cB cP co vy
        cv ci cmul co cA cS co cB cP co caddc co vx cv cA cB cP co cmul co vy
        cv ci cmul co cA cB cP co cmul co caddc co vx cv cr wcel vy cv cr wcel
        wa vx cv vy cv ci cmul co caddc co cA cS co vx cv cA cS co vy cv ci
        cmul co cA cS co cG co cB cP vx cv cc wcel vy cv ci cmul co cc wcel vx
        cv vy cv ci cmul co caddc co cA cS co vx cv cA cS co vy cv ci cmul co
        cA cS co cG co wceq vx cv cr wcel vy cv cr wcel vx cv cc wcel vy cv ci
        cmul co cc wcel cA cX wcel vx cv vy cv ci cmul co caddc co cA cS co vx
        cv cA cS co vy cv ci cmul co cA cS co cG co wceq ipasslem11.a cU cnv
        wcel vx cv cc wcel vy cv ci cmul co cc wcel cA cX wcel w3a vx cv vy cv
        ci cmul co caddc co cA cS co vx cv cA cS co vy cv ci cmul co cA cS co
        cG co wceq cU ip1i.9 phnvi vx cv vy cv ci cmul co cA cS cU cG cX ip1i.1
        ip1i.2 ip1i.4 nvdir mpan mp3an3 vx cv recn vy cv cr wcel vy cv cc wcel
        vy cv ci cmul co cc wcel vy cv recn vy cv cc wcel ci cc wcel vy cv ci
        cmul co cc wcel axicn vy cv ci mulcl mpan2 syl syl2an opreq1d vx cv cA
        cS co cX wcel vy cv ci cmul co cA cS co cX wcel vx cv cA cS co vy cv ci
        cmul co cA cS co cG co cB cP co vx cv cA cS co cB cP co vy cv ci cmul
        co cA cS co cB cP co caddc co wceq vx cv cr wcel vy cv cr wcel vx cv cA
        cS co cX wcel vy cv ci cmul co cA cS co cX wcel cB cX wcel vx cv cA cS
        co vy cv ci cmul co cA cS co cG co cB cP co vx cv cA cS co cB cP co vy
        cv ci cmul co cA cS co cB cP co caddc co wceq ipasslem11.b vx cv cA cS
        co vy cv ci cmul co cA cS co cB cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4
        ip1i.7 ip1i.9 ipdiri mp3an3 vx cv cr wcel vx cv cc wcel vx cv cA cS co
        cX wcel vx cv recn cU cnv wcel vx cv cc wcel cA cX wcel vx cv cA cS co
        cX wcel cU ip1i.9 phnvi ipasslem11.a vx cv cA cS cU cX ip1i.1 ip1i.4
        nvscl mp3an13 syl vy cv cr wcel vy cv ci cmul co cc wcel vy cv ci cmul
        co cA cS co cX wcel vy cv cr wcel vy cv cc wcel vy cv ci cmul co cc
        wcel vy cv recn vy cv cc wcel ci cc wcel vy cv ci cmul co cc wcel axicn
        vy cv ci mulcl mpan2 syl cU cnv wcel vy cv ci cmul co cc wcel cA cX
        wcel vy cv ci cmul co cA cS co cX wcel cU ip1i.9 phnvi ipasslem11.a vy
        cv ci cmul co cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an13 syl syl2an vx cv
        cr wcel vy cv cr wcel vx cv cA cS co cB cP co vx cv cA cB cP co cmul co
        vy cv ci cmul co cA cS co cB cP co vy cv ci cmul co cA cB cP co cmul co
        caddc cA cB vx cv cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9
        ipasslem11.a ipasslem11.b ipasslem9 vy cv cr wcel vy cv ci cA cS co cS
        co cB cP co vy cv ci cA cS co cB cP co cmul co vy cv ci cmul co cA cS
        co cB cP co vy cv ci cmul co cA cB cP co cmul co ci cA cS co cB vy cv
        cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 cU cnv wcel ci cc
        wcel cA cX wcel ci cA cS co cX wcel cU ip1i.9 phnvi axicn ipasslem11.a
        ci cA cS cU cX ip1i.1 ip1i.4 nvscl mp3an ipasslem11.b ipasslem9 vy cv
        cr wcel vy cv ci cmul co cA cS co vy cv ci cA cS co cS co cB cP vy cv
        cr wcel vy cv cc wcel vy cv ci cmul co cA cS co vy cv ci cA cS co cS co
        wceq vy cv recn vy cv cc wcel ci cc wcel cA cX wcel vy cv ci cmul co cA
        cS co vy cv ci cA cS co cS co wceq axicn ipasslem11.a cU cnv wcel vy cv
        cc wcel ci cc wcel cA cX wcel w3a vy cv ci cmul co cA cS co vy cv ci cA
        cS co cS co wceq cU ip1i.9 phnvi vy cv ci cA cS cU cX ip1i.1 ip1i.4
        nvsass mpan mp3an23 syl opreq1d vy cv cr wcel vy cv ci cmul co cA cB cP
        co cmul co vy cv ci cA cB cP co cmul co cmul co vy cv ci cA cS co cB cP
        co cmul co vy cv cr wcel vy cv cc wcel vy cv ci cmul co cA cB cP co
        cmul co vy cv ci cA cB cP co cmul co cmul co wceq vy cv recn vy cv cc
        wcel ci cc wcel cA cB cP co cc wcel vy cv ci cmul co cA cB cP co cmul
        co vy cv ci cA cB cP co cmul co cmul co wceq axicn cU cnv wcel cA cX
        wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem11.a
        ipasslem11.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an vy cv ci cA cB cP
        co mulass mp3an23 syl ci cA cS co cB cP co ci cA cB cP co cmul co vy cv
        cmul cA cB cP cS cU cG cU cnm cfv cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9
        ipasslem11.a ipasslem11.b cU cnm cfv eqid ipasslem10 opreq2i syl6eqr
        3eqtr4d opreqan12d 3eqtrd vx cv cc wcel vy cv ci cmul co cc wcel vx cv
        vy cv ci cmul co caddc co cA cB cP co cmul co vx cv cA cB cP co cmul co
        vy cv ci cmul co cA cB cP co cmul co caddc co wceq vx cv cr wcel vy cv
        cr wcel vx cv cc wcel vy cv ci cmul co cc wcel cA cB cP co cc wcel vx
        cv vy cv ci cmul co caddc co cA cB cP co cmul co vx cv cA cB cP co cmul
        co vy cv ci cmul co cA cB cP co cmul co caddc co wceq cU cnv wcel cA cX
        wcel cB cX wcel cA cB cP co cc wcel cU ip1i.9 phnvi ipasslem11.a
        ipasslem11.b cA cB cP cU cX ip1i.1 ip1i.7 ipcl mp3an vx cv vy cv ci
        cmul co cA cB cP co adddir mp3an3 vx cv recn vy cv cr wcel vy cv cc
        wcel vy cv ci cmul co cc wcel vy cv recn vy cv cc wcel ci cc wcel vy cv
        ci cmul co cc wcel axicn vy cv ci mulcl mpan2 syl syl2an eqtr4d
        syl5cbir sylbid r19.23aivv syl $.
        $( [6-Nov-2007] $) $( [25-Aug-2007] $)
    $}

    $( Associative law for inner product.  Equation I2 of [Ponnusamy]
       p. 363. $)
    ipassi $p |- ( ( A e. CC /\ B e. X /\ C e. X ) ->
                  ( ( A S B ) P C ) = ( A x. ( B P C ) ) ) $=
      cA cc wcel cB cX wcel cC cX wcel cA cB cS co cC cP co cA cB cC cP co cmul
      co wceq cB cX wcel cC cX wcel wa cA cc wcel cA cB cS co cC cP co cA cB cC
      cP co cmul co wceq cB cX wcel cC cX wcel cA cc wcel cA cB cS co cC cP co
      cA cB cC cP co cmul co wceq wi cA cc wcel cA cB cX wcel cB cU cn0v cfv
      cif cS co cC cP co cA cB cX wcel cB cU cn0v cfv cif cC cP co cmul co wceq
      wi cA cc wcel cA cB cX wcel cB cU cn0v cfv cif cS co cC cX wcel cC cU
      cn0v cfv cif cP co cA cB cX wcel cB cU cn0v cfv cif cC cX wcel cC cU cn0v
      cfv cif cP co cmul co wceq wi cB cC cU cn0v cfv cU cn0v cfv cB cB cX wcel
      cB cU cn0v cfv cif wceq cA cB cS co cC cP co cA cB cC cP co cmul co wceq
      cA cB cX wcel cB cU cn0v cfv cif cS co cC cP co cA cB cX wcel cB cU cn0v
      cfv cif cC cP co cmul co wceq cA cc wcel cB cB cX wcel cB cU cn0v cfv cif
      wceq cA cB cS co cC cP co cA cB cX wcel cB cU cn0v cfv cif cS co cC cP co
      cA cB cC cP co cmul co cA cB cX wcel cB cU cn0v cfv cif cC cP co cmul co
      cB cB cX wcel cB cU cn0v cfv cif wceq cA cB cS co cA cB cX wcel cB cU
      cn0v cfv cif cS co cC cP cB cB cX wcel cB cU cn0v cfv cif cA cS opreq2
      opreq1d cB cB cX wcel cB cU cn0v cfv cif wceq cB cC cP co cB cX wcel cB
      cU cn0v cfv cif cC cP co cA cmul cB cB cX wcel cB cU cn0v cfv cif cC cP
      opreq1 opreq2d eqeq12d imbi2d cC cC cX wcel cC cU cn0v cfv cif wceq cA cB
      cX wcel cB cU cn0v cfv cif cS co cC cP co cA cB cX wcel cB cU cn0v cfv
      cif cC cP co cmul co wceq cA cB cX wcel cB cU cn0v cfv cif cS co cC cX
      wcel cC cU cn0v cfv cif cP co cA cB cX wcel cB cU cn0v cfv cif cC cX wcel
      cC cU cn0v cfv cif cP co cmul co wceq cA cc wcel cC cC cX wcel cC cU cn0v
      cfv cif wceq cA cB cX wcel cB cU cn0v cfv cif cS co cC cP co cA cB cX
      wcel cB cU cn0v cfv cif cS co cC cX wcel cC cU cn0v cfv cif cP co cA cB
      cX wcel cB cU cn0v cfv cif cC cP co cmul co cA cB cX wcel cB cU cn0v cfv
      cif cC cX wcel cC cU cn0v cfv cif cP co cmul co cC cC cX wcel cC cU cn0v
      cfv cif cA cB cX wcel cB cU cn0v cfv cif cS co cP opreq2 cC cC cX wcel cC
      cU cn0v cfv cif wceq cB cX wcel cB cU cn0v cfv cif cC cP co cB cX wcel cB
      cU cn0v cfv cif cC cX wcel cC cU cn0v cfv cif cP co cA cmul cC cC cX wcel
      cC cU cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cP opreq2 opreq2d
      eqeq12d imbi2d cB cX wcel cB cU cn0v cfv cif cC cX wcel cC cU cn0v cfv
      cif cA cP cS cU cG cX ip1i.1 ip1i.2 ip1i.4 ip1i.7 ip1i.9 cB cU cX cU cn0v
      cfv ip1i.1 cU cn0v cfv eqid ip1i.9 elimph cC cU cX cU cn0v cfv ip1i.1 cU
      cn0v cfv eqid ip1i.9 elimph ipasslem11 dedth2h com12 3impib $.
      $( [6-Nov-2007] $) $( [25-Aug-2007] $)
  $}

  ${
    ipdir.1 $e |- X = ( BaseSet ` U ) $.
    ipdir.2 $e |- G = ( +v ` U ) $.
    ipdir.7 $e |- P = ( .i ` U ) $.
    $( Distributive law for inner product.  Equation I3 of [Ponnusamy]
       p. 362. $)
    ipdir $p |- ( ( U e. CPreHil /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cP co cA
      cC cP co cB cC cP co caddc co wceq cU cphl wcel cA cX wcel cB cX wcel cC
      cX wcel w3a cA cB cG co cC cP co cA cC cP co cB cC cP co caddc co wceq wi
      cA cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv wcel cB cU cphl
      wcel cU caddc cmul cop cabs cop cif cba cfv wcel cC cU cphl wcel cU caddc
      cmul cop cabs cop cif cba cfv wcel w3a cA cB cU cphl wcel cU caddc cmul
      cop cabs cop cif cpv cfv co cC cU cphl wcel cU caddc cmul cop cabs cop
      cif cip cfv co cA cC cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv
      co cB cC cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv co caddc co
      wceq wi cU caddc cmul cop cabs cop cU cU cphl wcel cU caddc cmul cop cabs
      cop cif wceq cA cX wcel cB cX wcel cC cX wcel w3a cA cU cphl wcel cU
      caddc cmul cop cabs cop cif cba cfv wcel cB cU cphl wcel cU caddc cmul
      cop cabs cop cif cba cfv wcel cC cU cphl wcel cU caddc cmul cop cabs cop
      cif cba cfv wcel w3a cA cB cG co cC cP co cA cC cP co cB cC cP co caddc
      co wceq cA cB cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv co cC
      cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv co cA cC cU cphl wcel
      cU caddc cmul cop cabs cop cif cip cfv co cB cC cU cphl wcel cU caddc
      cmul cop cabs cop cif cip cfv co caddc co wceq cU cU cphl wcel cU caddc
      cmul cop cabs cop cif wceq cA cX wcel cA cU cphl wcel cU caddc cmul cop
      cabs cop cif cba cfv wcel cB cX wcel cB cU cphl wcel cU caddc cmul cop
      cabs cop cif cba cfv wcel cC cX wcel cC cU cphl wcel cU caddc cmul cop
      cabs cop cif cba cfv wcel cU cU cphl wcel cU caddc cmul cop cabs cop cif
      wceq cX cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv cA cU cU cphl
      wcel cU caddc cmul cop cabs cop cif wceq cU cba cfv cU cphl wcel cU caddc
      cmul cop cabs cop cif cba cfv cX cU cU cphl wcel cU caddc cmul cop cabs
      cop cif cba fveq2 ipdir.1 syl5eq eleq2d cU cU cphl wcel cU caddc cmul cop
      cabs cop cif wceq cX cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv
      cB cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cU cba cfv cU cphl
      wcel cU caddc cmul cop cabs cop cif cba cfv cX cU cU cphl wcel cU caddc
      cmul cop cabs cop cif cba fveq2 ipdir.1 syl5eq eleq2d cU cU cphl wcel cU
      caddc cmul cop cabs cop cif wceq cX cU cphl wcel cU caddc cmul cop cabs
      cop cif cba cfv cC cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cU
      cba cfv cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv cX cU cU cphl
      wcel cU caddc cmul cop cabs cop cif cba fveq2 ipdir.1 syl5eq eleq2d
      3anbi123d cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cA cB cG co
      cC cP co cA cB cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv co cC
      cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv co cA cC cP co cB cC
      cP co caddc co cA cC cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv
      co cB cC cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv co caddc co
      cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cA cB cG co cC cP co
      cA cB cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv co cC cP co cA
      cB cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv co cC cU cphl wcel
      cU caddc cmul cop cabs cop cif cip cfv co cU cU cphl wcel cU caddc cmul
      cop cabs cop cif wceq cA cB cG co cA cB cU cphl wcel cU caddc cmul cop
      cabs cop cif cpv cfv co cC cP cU cU cphl wcel cU caddc cmul cop cabs cop
      cif wceq cG cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv cA cB cU
      cU cphl wcel cU caddc cmul cop cabs cop cif wceq cU cpv cfv cU cphl wcel
      cU caddc cmul cop cabs cop cif cpv cfv cG cU cU cphl wcel cU caddc cmul
      cop cabs cop cif cpv fveq2 ipdir.2 syl5eq opreqd opreq1d cU cU cphl wcel
      cU caddc cmul cop cabs cop cif wceq cP cU cphl wcel cU caddc cmul cop
      cabs cop cif cip cfv cA cB cU cphl wcel cU caddc cmul cop cabs cop cif
      cpv cfv co cC cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cU cip
      cfv cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv cP cU cU cphl
      wcel cU caddc cmul cop cabs cop cif cip fveq2 ipdir.7 syl5eq opreqd eqtrd
      cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cA cC cP co cA cC cU
      cphl wcel cU caddc cmul cop cabs cop cif cip cfv co cB cC cP co cB cC cU
      cphl wcel cU caddc cmul cop cabs cop cif cip cfv co caddc cU cU cphl wcel
      cU caddc cmul cop cabs cop cif wceq cP cU cphl wcel cU caddc cmul cop
      cabs cop cif cip cfv cA cC cU cU cphl wcel cU caddc cmul cop cabs cop cif
      wceq cU cip cfv cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv cP cU
      cU cphl wcel cU caddc cmul cop cabs cop cif cip fveq2 ipdir.7 syl5eq
      opreqd cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cP cU cphl
      wcel cU caddc cmul cop cabs cop cif cip cfv cB cC cU cU cphl wcel cU
      caddc cmul cop cabs cop cif wceq cU cip cfv cU cphl wcel cU caddc cmul
      cop cabs cop cif cip cfv cP cU cU cphl wcel cU caddc cmul cop cabs cop
      cif cip fveq2 ipdir.7 syl5eq opreqd opreq12d eqeq12d imbi12d cA cB cC cU
      cphl wcel cU caddc cmul cop cabs cop cif cip cfv cU cphl wcel cU caddc
      cmul cop cabs cop cif cns cfv cU cphl wcel cU caddc cmul cop cabs cop cif
      cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv cU cphl wcel cU caddc
      cmul cop cabs cop cif cba cfv cU cphl wcel cU caddc cmul cop cabs cop cif
      cba cfv eqid cU cphl wcel cU caddc cmul cop cabs cop cif cpv cfv eqid cU
      cphl wcel cU caddc cmul cop cabs cop cif cns cfv eqid cU cphl wcel cU
      caddc cmul cop cabs cop cif cip cfv eqid cU elimphu ipdiri dedth imp $.
      $( [1-Dec-2007] $) $( [25-Aug-2007] $)

    $( Distributive law for inner product. $)
    ipdi $p |- ( ( U e. CPreHil /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( A P ( B G C ) ) = ( ( A P B ) + ( A P C ) ) ) $=
      cU cphl wcel cC cX wcel cB cX wcel cA cX wcel w3a cA cB cC cG co cP co cA
      cB cP co cA cC cP co caddc co wceq cA cX wcel cB cX wcel cC cX wcel w3a
      cU cphl wcel cC cX wcel cB cX wcel cA cX wcel w3a wa cB cC cG co cA cP co
      ccj cfv cB cA cP co cC cA cP co caddc co ccj cfv cA cB cC cG co cP co cA
      cB cP co cA cC cP co caddc co cU cphl wcel cC cX wcel cB cX wcel cA cX
      wcel w3a wa cB cC cG co cA cP co cB cA cP co cC cA cP co caddc co ccj cU
      cphl wcel cB cX wcel cC cX wcel cA cX wcel w3a cB cC cG co cA cP co cB cA
      cP co cC cA cP co caddc co wceq cC cX wcel cB cX wcel cA cX wcel w3a cB
      cC cA cP cU cG cX ipdir.1 ipdir.2 ipdir.7 ipdir cB cX wcel cC cX wcel cA
      cX wcel cB cX wcel cC cX wcel cA cX wcel w3a cB cX wcel cC cX wcel cA cX
      wcel w3a id 3com12 sylan2 fveq2d cU cnv wcel cC cX wcel cB cX wcel cA cX
      wcel w3a cB cC cG co cA cP co ccj cfv cA cB cC cG co cP co wceq cU cphl
      wcel cU cnv wcel cB cC cG co cX wcel cA cX wcel cB cC cG co cA cP co ccj
      cfv cA cB cC cG co cP co wceq cU cnv wcel cC cX wcel cB cX wcel cA cX
      wcel w3a wa cB cC cG co cA cP cU cX ipdir.1 ipdir.7 ipcj cU cnv wcel cC
      cX wcel cB cX wcel cA cX wcel w3a pm3.26 cU cnv wcel cC cX wcel cB cX
      wcel cB cC cG co cX wcel cA cX wcel cU cnv wcel cB cX wcel cC cX wcel cB
      cC cG co cX wcel cB cC cU cG cX ipdir.1 ipdir.2 nvgcl 3com23 3adant3r3 cC
      cX wcel cB cX wcel cA cX wcel w3a cA cX wcel cU cnv wcel cC cX wcel cB cX
      wcel cA cX wcel 3simp3 adantl syl3anc cU phnv sylan cU cnv wcel cC cX
      wcel cB cX wcel cA cX wcel w3a cB cA cP co cC cA cP co caddc co ccj cfv
      cA cB cP co cA cC cP co caddc co wceq cU cphl wcel cU cnv wcel cC cX wcel
      cB cX wcel cA cX wcel w3a wa cB cA cP co cC cA cP co caddc co ccj cfv cB
      cA cP co ccj cfv cC cA cP co ccj cfv caddc co cA cB cP co cA cC cP co
      caddc co cB cA cP co cc wcel cC cA cP co cc wcel cB cA cP co cC cA cP co
      caddc co ccj cfv cB cA cP co ccj cfv cC cA cP co ccj cfv caddc co wceq cU
      cnv wcel cC cX wcel cB cX wcel cA cX wcel w3a wa cB cA cP co cC cA cP co
      cjadd cU cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cC cX wcel cB
      cA cP cU cX ipdir.1 ipdir.7 ipcl 3adant3r1 cU cnv wcel cC cX wcel cA cX
      wcel cC cA cP co cc wcel cB cX wcel cC cA cP cU cX ipdir.1 ipdir.7 ipcl
      3adant3r2 sylanc cU cnv wcel cC cX wcel cB cX wcel cA cX wcel w3a wa cB
      cA cP co ccj cfv cA cB cP co cC cA cP co ccj cfv cA cC cP co caddc cU cnv
      wcel cB cX wcel cA cX wcel cB cA cP co ccj cfv cA cB cP co wceq cC cX
      wcel cB cA cP cU cX ipdir.1 ipdir.7 ipcj 3adant3r1 cU cnv wcel cC cX wcel
      cA cX wcel cC cA cP co ccj cfv cA cC cP co wceq cB cX wcel cC cA cP cU cX
      ipdir.1 ipdir.7 ipcj 3adant3r2 opreq12d eqtrd cU phnv sylan 3eqtr3d cC cX
      wcel cB cX wcel cA cX wcel cC cX wcel cB cX wcel cA cX wcel w3a cC cX
      wcel cB cX wcel cA cX wcel w3a id 3com13 sylan2 $.
      $( [6-Apr-2008] $) $( [20-Nov-2007] $)
  $}

  ${
    ip2dii.1 $e |- X = ( BaseSet ` U ) $.
    ip2dii.2 $e |- G = ( +v ` U ) $.
    ip2dii.7 $e |- P = ( .i ` U ) $.
    ip2dii.u $e |- U e. CPreHil $.
    ip2dii.a $e |- A e. X $.
    ip2dii.b $e |- B e. X $.
    ip2dii.c $e |- C e. X $.
    ip2dii.d $e |- D e. X $.
    $( Inner product of two sums. $)
    ip2dii $p |- ( ( A G B ) P ( C G D ) )
                = ( ( ( A P C ) + ( B P D ) ) + ( ( A P D ) + ( B P C ) ) ) $=
      cA cC cD cG co cP co cB cC cD cG co cP co caddc co cA cC cP co cA cD cP
      co caddc co cB cC cP co cB cD cP co caddc co caddc co cA cB cG co cC cD
      cG co cP co cA cC cP co cB cD cP co caddc co cA cD cP co cB cC cP co
      caddc co caddc co cA cC cD cG co cP co cA cC cP co cA cD cP co caddc co
      cB cC cD cG co cP co cB cC cP co cB cD cP co caddc co caddc cU cphl wcel
      cA cX wcel cC cX wcel cD cX wcel w3a cA cC cD cG co cP co cA cC cP co cA
      cD cP co caddc co wceq ip2dii.u cA cX wcel cC cX wcel cD cX wcel ip2dii.a
      ip2dii.c ip2dii.d 3pm3.2i cA cC cD cP cU cG cX ip2dii.1 ip2dii.2 ip2dii.7
      ipdi mp2an cU cphl wcel cB cX wcel cC cX wcel cD cX wcel w3a cB cC cD cG
      co cP co cB cC cP co cB cD cP co caddc co wceq ip2dii.u cB cX wcel cC cX
      wcel cD cX wcel ip2dii.b ip2dii.c ip2dii.d 3pm3.2i cB cC cD cP cU cG cX
      ip2dii.1 ip2dii.2 ip2dii.7 ipdi mp2an opreq12i cU cphl wcel cA cX wcel cB
      cX wcel cC cD cG co cX wcel w3a cA cB cG co cC cD cG co cP co cA cC cD cG
      co cP co cB cC cD cG co cP co caddc co wceq ip2dii.u cA cX wcel cB cX
      wcel cC cD cG co cX wcel ip2dii.a ip2dii.b cU cnv wcel cC cX wcel cD cX
      wcel cC cD cG co cX wcel cU ip2dii.u phnvi ip2dii.c ip2dii.d cC cD cU cG
      cX ip2dii.1 ip2dii.2 nvgcl mp3an 3pm3.2i cA cB cC cD cG co cP cU cG cX
      ip2dii.1 ip2dii.2 ip2dii.7 ipdir mp2an cA cC cP co cB cD cP co cA cD cP
      co cB cC cP co cU cnv wcel cA cX wcel cC cX wcel cA cC cP co cc wcel cU
      ip2dii.u phnvi ip2dii.a ip2dii.c cA cC cP cU cX ip2dii.1 ip2dii.7 ipcl
      mp3an cU cnv wcel cB cX wcel cD cX wcel cB cD cP co cc wcel cU ip2dii.u
      phnvi ip2dii.b ip2dii.d cB cD cP cU cX ip2dii.1 ip2dii.7 ipcl mp3an cU
      cnv wcel cA cX wcel cD cX wcel cA cD cP co cc wcel cU ip2dii.u phnvi
      ip2dii.a ip2dii.d cA cD cP cU cX ip2dii.1 ip2dii.7 ipcl mp3an cU cnv wcel
      cB cX wcel cC cX wcel cB cC cP co cc wcel cU ip2dii.u phnvi ip2dii.b
      ip2dii.c cB cC cP cU cX ip2dii.1 ip2dii.7 ipcl mp3an add42i 3eqtr4i $.
      $( [17-Apr-2008] $) $( [17-Apr-2008] $)
  $}

  ${
    ipass.1 $e |- X = ( BaseSet ` U ) $.
    ipass.4 $e |- S = ( .s ` U ) $.
    ipass.7 $e |- P = ( .i ` U ) $.
    $( Associative law for inner product.  Equation I2 of [Ponnusamy]
       p. 363. $)
    ipass $p |- ( ( U e. CPreHil /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
                 ( ( A S B ) P C ) = ( A x. ( B P C ) ) ) $=
      cU cphl wcel cA cc wcel cB cX wcel cC cX wcel w3a cA cB cS co cC cP co cA
      cB cC cP co cmul co wceq cU cphl wcel cA cc wcel cB cX wcel cC cX wcel
      w3a cA cB cS co cC cP co cA cB cC cP co cmul co wceq wi cA cc wcel cB cU
      cphl wcel cU caddc cmul cop cabs cop cif cba cfv wcel cC cU cphl wcel cU
      caddc cmul cop cabs cop cif cba cfv wcel w3a cA cB cU cphl wcel cU caddc
      cmul cop cabs cop cif cns cfv co cC cU cphl wcel cU caddc cmul cop cabs
      cop cif cip cfv co cA cB cC cU cphl wcel cU caddc cmul cop cabs cop cif
      cip cfv co cmul co wceq wi cU caddc cmul cop cabs cop cU cU cphl wcel cU
      caddc cmul cop cabs cop cif wceq cA cc wcel cB cX wcel cC cX wcel w3a cA
      cc wcel cB cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv wcel cC cU
      cphl wcel cU caddc cmul cop cabs cop cif cba cfv wcel w3a cA cB cS co cC
      cP co cA cB cC cP co cmul co wceq cA cB cU cphl wcel cU caddc cmul cop
      cabs cop cif cns cfv co cC cU cphl wcel cU caddc cmul cop cabs cop cif
      cip cfv co cA cB cC cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv
      co cmul co wceq cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cB cX
      wcel cB cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv wcel cC cX
      wcel cC cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv wcel cA cc
      wcel cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cX cU cphl wcel
      cU caddc cmul cop cabs cop cif cba cfv cB cU cU cphl wcel cU caddc cmul
      cop cabs cop cif wceq cU cba cfv cU cphl wcel cU caddc cmul cop cabs cop
      cif cba cfv cX cU cU cphl wcel cU caddc cmul cop cabs cop cif cba fveq2
      ipass.1 syl5eq eleq2d cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq
      cX cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv cC cU cU cphl wcel
      cU caddc cmul cop cabs cop cif wceq cU cba cfv cU cphl wcel cU caddc cmul
      cop cabs cop cif cba cfv cX cU cU cphl wcel cU caddc cmul cop cabs cop
      cif cba fveq2 ipass.1 syl5eq eleq2d 3anbi23d cU cU cphl wcel cU caddc
      cmul cop cabs cop cif wceq cA cB cS co cC cP co cA cB cU cphl wcel cU
      caddc cmul cop cabs cop cif cns cfv co cC cU cphl wcel cU caddc cmul cop
      cabs cop cif cip cfv co cA cB cC cP co cmul co cA cB cC cU cphl wcel cU
      caddc cmul cop cabs cop cif cip cfv co cmul co cU cU cphl wcel cU caddc
      cmul cop cabs cop cif wceq cA cB cS co cC cP co cA cB cU cphl wcel cU
      caddc cmul cop cabs cop cif cns cfv co cC cP co cA cB cU cphl wcel cU
      caddc cmul cop cabs cop cif cns cfv co cC cU cphl wcel cU caddc cmul cop
      cabs cop cif cip cfv co cU cU cphl wcel cU caddc cmul cop cabs cop cif
      wceq cA cB cS co cA cB cU cphl wcel cU caddc cmul cop cabs cop cif cns
      cfv co cC cP cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cS cU
      cphl wcel cU caddc cmul cop cabs cop cif cns cfv cA cB cU cU cphl wcel cU
      caddc cmul cop cabs cop cif wceq cU cns cfv cU cphl wcel cU caddc cmul
      cop cabs cop cif cns cfv cS cU cU cphl wcel cU caddc cmul cop cabs cop
      cif cns fveq2 ipass.4 syl5eq opreqd opreq1d cU cU cphl wcel cU caddc cmul
      cop cabs cop cif wceq cP cU cphl wcel cU caddc cmul cop cabs cop cif cip
      cfv cA cB cU cphl wcel cU caddc cmul cop cabs cop cif cns cfv co cC cU cU
      cphl wcel cU caddc cmul cop cabs cop cif wceq cU cip cfv cU cphl wcel cU
      caddc cmul cop cabs cop cif cip cfv cP cU cU cphl wcel cU caddc cmul cop
      cabs cop cif cip fveq2 ipass.7 syl5eq opreqd eqtrd cU cU cphl wcel cU
      caddc cmul cop cabs cop cif wceq cB cC cP co cB cC cU cphl wcel cU caddc
      cmul cop cabs cop cif cip cfv co cA cmul cU cU cphl wcel cU caddc cmul
      cop cabs cop cif wceq cP cU cphl wcel cU caddc cmul cop cabs cop cif cip
      cfv cB cC cU cU cphl wcel cU caddc cmul cop cabs cop cif wceq cU cip cfv
      cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv cP cU cU cphl wcel cU
      caddc cmul cop cabs cop cif cip fveq2 ipass.7 syl5eq opreqd opreq2d
      eqeq12d imbi12d cA cB cC cU cphl wcel cU caddc cmul cop cabs cop cif cip
      cfv cU cphl wcel cU caddc cmul cop cabs cop cif cns cfv cU cphl wcel cU
      caddc cmul cop cabs cop cif cU cphl wcel cU caddc cmul cop cabs cop cif
      cpv cfv cU cphl wcel cU caddc cmul cop cabs cop cif cba cfv cU cphl wcel
      cU caddc cmul cop cabs cop cif cba cfv eqid cU cphl wcel cU caddc cmul
      cop cabs cop cif cpv cfv eqid cU cphl wcel cU caddc cmul cop cabs cop cif
      cns cfv eqid cU cphl wcel cU caddc cmul cop cabs cop cif cip cfv eqid cU
      elimphu ipassi dedth imp $.
      $( [30-Nov-2007] $) $( [25-Aug-2007] $)

    $( "Associative" law for second argument of inner product (compare
       ~ ipass ). $)
    ipassr $p |- ( ( U e. CPreHil /\ ( A e. X /\ B e. CC /\ C e. X ) ) ->
                 ( A P ( B S C ) ) = ( ( * ` B ) x. ( A P C ) ) ) $=
      cU cphl wcel cA cX wcel cB cc wcel cC cX wcel w3a wa cB cC cS co cA cP co
      ccj cfv cB cC cA cP co cmul co ccj cfv cA cB cC cS co cP co cB ccj cfv cA
      cC cP co cmul co cU cphl wcel cA cX wcel cB cc wcel cC cX wcel w3a wa cB
      cC cS co cA cP co cB cC cA cP co cmul co ccj cU cphl wcel cB cc wcel cC
      cX wcel cA cX wcel w3a cB cC cS co cA cP co cB cC cA cP co cmul co wceq
      cA cX wcel cB cc wcel cC cX wcel w3a cB cC cA cP cS cU cX ipass.1 ipass.4
      ipass.7 ipass cA cX wcel cB cc wcel cC cX wcel 3anrot sylan2b fveq2d cU
      cnv wcel cA cX wcel cB cc wcel cC cX wcel w3a cB cC cS co cA cP co ccj
      cfv cA cB cC cS co cP co wceq cU cphl wcel cU cnv wcel cB cC cS co cX
      wcel cA cX wcel cB cC cS co cA cP co ccj cfv cA cB cC cS co cP co wceq cU
      cnv wcel cA cX wcel cB cc wcel cC cX wcel w3a wa cB cC cS co cA cP cU cX
      ipass.1 ipass.7 ipcj cU cnv wcel cA cX wcel cB cc wcel cC cX wcel w3a
      pm3.26 cU cnv wcel cB cc wcel cC cX wcel cB cC cS co cX wcel cA cX wcel
      cB cC cS cU cX ipass.1 ipass.4 nvscl 3adant3r1 cA cX wcel cB cc wcel cC
      cX wcel w3a cA cX wcel cU cnv wcel cA cX wcel cB cc wcel cC cX wcel
      3simp1 adantl syl3anc cU phnv sylan cU cnv wcel cA cX wcel cB cc wcel cC
      cX wcel w3a cB cC cA cP co cmul co ccj cfv cB ccj cfv cA cC cP co cmul co
      wceq cU cphl wcel cU cnv wcel cA cX wcel cB cc wcel cC cX wcel w3a wa cB
      cC cA cP co cmul co ccj cfv cB ccj cfv cC cA cP co ccj cfv cmul co cB ccj
      cfv cA cC cP co cmul co cB cc wcel cC cA cP co cc wcel cB cC cA cP co
      cmul co ccj cfv cB ccj cfv cC cA cP co ccj cfv cmul co wceq cU cnv wcel
      cA cX wcel cB cc wcel cC cX wcel w3a wa cB cC cA cP co cjmul cA cX wcel
      cB cc wcel cC cX wcel w3a cB cc wcel cU cnv wcel cA cX wcel cB cc wcel cC
      cX wcel 3simp2 adantl cU cnv wcel cA cX wcel cC cX wcel cC cA cP co cc
      wcel cB cc wcel cU cnv wcel cC cX wcel cA cX wcel cC cA cP co cc wcel cC
      cA cP cU cX ipass.1 ipass.7 ipcl 3com23 3adant3r2 sylanc cU cnv wcel cA
      cX wcel cB cc wcel cC cX wcel w3a wa cC cA cP co ccj cfv cA cC cP co cB
      ccj cfv cmul cU cnv wcel cA cX wcel cC cX wcel cC cA cP co ccj cfv cA cC
      cP co wceq cB cc wcel cU cnv wcel cC cX wcel cA cX wcel cC cA cP co ccj
      cfv cA cC cP co wceq cC cA cP cU cX ipass.1 ipass.7 ipcj 3com23 3adant3r2
      opreq2d eqtrd cU phnv sylan 3eqtr3d $.
      $( [19-Dec-2007] $) $( [22-Nov-2007] $)

    $( "Associative" law for inner product.  Conjugate version of ~ ipassr . $)
    ipassr2 $p |- ( ( U e. CPreHil /\ ( A e. X /\ B e. CC /\ C e. X ) ) ->
                 ( A P ( ( * ` B ) S C ) ) = ( B x. ( A P C ) ) ) $=
      cU cphl wcel cA cX wcel cB cc wcel cC cX wcel w3a wa cA cB ccj cfv cC cS
      co cP co cB ccj cfv ccj cfv cA cC cP co cmul co cB cA cC cP co cmul co cU
      cphl wcel cA cX wcel cB ccj cfv cc wcel cC cX wcel cA cB ccj cfv cC cS co
      cP co cB ccj cfv ccj cfv cA cC cP co cmul co wceq cB cc wcel cA cB ccj
      cfv cC cP cS cU cX ipass.1 ipass.4 ipass.7 ipassr cB cjcl syl3anr2 cU
      cphl wcel cA cX wcel cB cc wcel cC cX wcel w3a wa cB ccj cfv ccj cfv cB
      cA cC cP co cmul cA cX wcel cB cc wcel cC cX wcel w3a cB ccj cfv ccj cfv
      cB wceq cU cphl wcel cB cc wcel cA cX wcel cB ccj cfv ccj cfv cB wceq cC
      cX wcel cB cjcj 3ad2ant2 adantl opreq1d eqtrd $.
      $( [23-Dec-2007] $) $( [23-Nov-2007] $)
  $}

  ${
    ipsubdir.1 $e |- X = ( BaseSet ` U ) $.
    ipsubdir.3 $e |- M = ( -v ` U ) $.
    ipsubdir.7 $e |- P = ( .i ` U ) $.
    $( Distributive law for inner product subtraction. $)
    ipsubdir $p |- ( ( U e. CPreHil /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A M B ) P C ) = ( ( A P C ) - ( B P C ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA c1 cneg cB cU cns
      cfv co cU cpv cfv co cC cP co cA cC cP co c1 cneg cB cU cns cfv co cC cP
      co caddc co cA cB cM co cC cP co cA cC cP co cB cC cP co cmin co cU cphl
      wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cX wcel c1 cneg cB cU cns
      cfv co cX wcel cC cX wcel w3a cA c1 cneg cB cU cns cfv co cU cpv cfv co
      cC cP co cA cC cP co c1 cneg cB cU cns cfv co cC cP co caddc co wceq cU
      cphl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cX wcel c1 cneg cB cU
      cns cfv co cX wcel cC cX wcel w3a cU cphl wcel cA cX wcel cA cX wcel cB
      cX wcel c1 cneg cB cU cns cfv co cX wcel cC cX wcel cC cX wcel cU cphl
      wcel cA cX wcel idd cU cphl wcel cB cX wcel c1 cneg cB cU cns cfv co cX
      wcel cU cnv wcel cB cX wcel c1 cneg cB cU cns cfv co cX wcel cU cphl wcel
      cU cnv wcel c1 cneg cc wcel cB cX wcel c1 cneg cB cU cns cfv co cX wcel
      c1 ax1cn negcli c1 cneg cB cU cns cfv cU cX ipsubdir.1 cU cns cfv eqid
      nvscl mp3an2 cU phnv sylan ex cU cphl wcel cC cX wcel idd 3anim123d imp
      cA c1 cneg cB cU cns cfv co cC cP cU cU cpv cfv cX ipsubdir.1 cU cpv cfv
      eqid ipsubdir.7 ipdir syldan cU cphl wcel cA cX wcel cB cX wcel cC cX
      wcel w3a wa cA cB cM co cA c1 cneg cB cU cns cfv co cU cpv cfv co cC cP
      cU cphl wcel cA cX wcel cB cX wcel cA cB cM co cA c1 cneg cB cU cns cfv
      co cU cpv cfv co wceq cC cX wcel cU cnv wcel cA cX wcel cB cX wcel cA cB
      cM co cA c1 cneg cB cU cns cfv co cU cpv cfv co wceq cU cphl wcel cA cB
      cU cns cfv cU cU cpv cfv cM cX ipsubdir.1 cU cpv cfv eqid cU cns cfv eqid
      ipsubdir.3 nvmval cU phnv syl3an1 3adant3r3 opreq1d cU cphl wcel cA cX
      wcel cB cX wcel cC cX wcel w3a wa cA cC cP co c1 cneg cB cU cns cfv co cC
      cP co caddc co cA cC cP co cB cC cP co cneg caddc co cA cC cP co cB cC cP
      co cmin co cU cphl wcel cA cX wcel cB cX wcel cC cX wcel w3a wa c1 cneg
      cB cU cns cfv co cC cP co cB cC cP co cneg cA cC cP co caddc cU cphl wcel
      cB cX wcel cC cX wcel c1 cneg cB cU cns cfv co cC cP co cB cC cP co cneg
      wceq cA cX wcel cU cphl wcel cB cX wcel cC cX wcel wa wa c1 cneg cB cU
      cns cfv co cC cP co c1 cneg cB cC cP co cmul co cB cC cP co cneg cU cphl
      wcel c1 cneg cc wcel cB cX wcel cC cX wcel c1 cneg cB cU cns cfv co cC cP
      co c1 cneg cB cC cP co cmul co wceq c1 ax1cn negcli c1 cneg cB cC cP cU
      cns cfv cU cX ipsubdir.1 cU cns cfv eqid ipsubdir.7 ipass mp3anr1 cU cphl
      wcel cB cX wcel cC cX wcel wa wa cB cC cP co cc wcel c1 cneg cB cC cP co
      cmul co cB cC cP co cneg wceq cU cnv wcel cB cX wcel cC cX wcel wa cB cC
      cP co cc wcel cU cphl wcel cU cnv wcel cB cX wcel cC cX wcel cB cC cP co
      cc wcel cB cC cP cU cX ipsubdir.1 ipsubdir.7 ipcl 3expb cU phnv sylan cB
      cC cP co mulm1 syl eqtrd 3adantr1 opreq2d cU cnv wcel cA cX wcel cB cX
      wcel cC cX wcel w3a cA cC cP co cB cC cP co cneg caddc co cA cC cP co cB
      cC cP co cmin co wceq cU cphl wcel cA cC cP co cc wcel cB cC cP co cc
      wcel cA cC cP co cB cC cP co cneg caddc co cA cC cP co cB cC cP co cmin
      co wceq cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC cP co
      cB cC cP co negsub cU cnv wcel cA cX wcel cC cX wcel cA cC cP co cc wcel
      cB cX wcel cA cC cP cU cX ipsubdir.1 ipsubdir.7 ipcl 3adant3r2 cU cnv
      wcel cB cX wcel cC cX wcel cB cC cP co cc wcel cA cX wcel cB cC cP cU cX
      ipsubdir.1 ipsubdir.7 ipcl 3adant3r1 sylanc cU phnv sylan eqtr2d 3eqtr4d
      $.
      $( [18-Dec-2007] $) $( [20-Nov-2007] $)

    $( Distributive law for inner product subtraction. $)
    ipsubdi $p |- ( ( U e. CPreHil /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( A P ( B M C ) ) = ( ( A P B ) - ( A P C ) ) ) $=
      cU cphl wcel cC cX wcel cB cX wcel cA cX wcel w3a cA cB cC cM co cP co cA
      cB cP co cA cC cP co cmin co wceq cA cX wcel cB cX wcel cC cX wcel w3a cU
      cphl wcel cC cX wcel cB cX wcel cA cX wcel w3a wa cB cC cM co cA cP co
      ccj cfv cB cA cP co cC cA cP co cmin co ccj cfv cA cB cC cM co cP co cA
      cB cP co cA cC cP co cmin co cU cphl wcel cC cX wcel cB cX wcel cA cX
      wcel w3a wa cB cC cM co cA cP co cB cA cP co cC cA cP co cmin co ccj cU
      cphl wcel cB cX wcel cC cX wcel cA cX wcel w3a cB cC cM co cA cP co cB cA
      cP co cC cA cP co cmin co wceq cC cX wcel cB cX wcel cA cX wcel w3a cB cC
      cA cP cU cM cX ipsubdir.1 ipsubdir.3 ipsubdir.7 ipsubdir cB cX wcel cC cX
      wcel cA cX wcel cB cX wcel cC cX wcel cA cX wcel w3a cB cX wcel cC cX
      wcel cA cX wcel w3a id 3com12 sylan2 fveq2d cU cnv wcel cC cX wcel cB cX
      wcel cA cX wcel w3a cB cC cM co cA cP co ccj cfv cA cB cC cM co cP co
      wceq cU cphl wcel cU cnv wcel cB cC cM co cX wcel cA cX wcel cB cC cM co
      cA cP co ccj cfv cA cB cC cM co cP co wceq cU cnv wcel cC cX wcel cB cX
      wcel cA cX wcel w3a wa cB cC cM co cA cP cU cX ipsubdir.1 ipsubdir.7 ipcj
      cU cnv wcel cC cX wcel cB cX wcel cA cX wcel w3a pm3.26 cU cnv wcel cC cX
      wcel cB cX wcel cB cC cM co cX wcel cA cX wcel cU cnv wcel cB cX wcel cC
      cX wcel cB cC cM co cX wcel cB cC cU cM cX ipsubdir.1 ipsubdir.3 nvmcl
      3com23 3adant3r3 cC cX wcel cB cX wcel cA cX wcel w3a cA cX wcel cU cnv
      wcel cC cX wcel cB cX wcel cA cX wcel 3simp3 adantl syl3anc cU phnv sylan
      cU cnv wcel cC cX wcel cB cX wcel cA cX wcel w3a cB cA cP co cC cA cP co
      cmin co ccj cfv cA cB cP co cA cC cP co cmin co wceq cU cphl wcel cU cnv
      wcel cC cX wcel cB cX wcel cA cX wcel w3a wa cB cA cP co cC cA cP co cmin
      co ccj cfv cB cA cP co ccj cfv cC cA cP co ccj cfv cmin co cA cB cP co cA
      cC cP co cmin co cB cA cP co cc wcel cC cA cP co cc wcel cB cA cP co cC
      cA cP co cmin co ccj cfv cB cA cP co ccj cfv cC cA cP co ccj cfv cmin co
      wceq cU cnv wcel cC cX wcel cB cX wcel cA cX wcel w3a wa cB cA cP co cC
      cA cP co cjsub cU cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cC
      cX wcel cB cA cP cU cX ipsubdir.1 ipsubdir.7 ipcl 3adant3r1 cU cnv wcel
      cC cX wcel cA cX wcel cC cA cP co cc wcel cB cX wcel cC cA cP cU cX
      ipsubdir.1 ipsubdir.7 ipcl 3adant3r2 sylanc cU cnv wcel cC cX wcel cB cX
      wcel cA cX wcel w3a wa cB cA cP co ccj cfv cA cB cP co cC cA cP co ccj
      cfv cA cC cP co cmin cU cnv wcel cB cX wcel cA cX wcel cB cA cP co ccj
      cfv cA cB cP co wceq cC cX wcel cB cA cP cU cX ipsubdir.1 ipsubdir.7 ipcj
      3adant3r1 cU cnv wcel cC cX wcel cA cX wcel cC cA cP co ccj cfv cA cC cP
      co wceq cB cX wcel cC cA cP cU cX ipsubdir.1 ipsubdir.7 ipcj 3adant3r2
      opreq12d eqtrd cU phnv sylan 3eqtr3d cC cX wcel cB cX wcel cA cX wcel cC
      cX wcel cB cX wcel cA cX wcel w3a cC cX wcel cB cX wcel cA cX wcel w3a id
      3com13 sylan2 $.
      $( [24-Dec-2007] $) $( [20-Nov-2007] $)
  $}

  ${
    pyth.1 $e |- X = ( BaseSet ` U ) $.
    pyth.2 $e |- G = ( +v ` U ) $.
    pyth.6 $e |- N = ( norm ` U ) $.
    pyth.7 $e |- P = ( .i ` U ) $.
    pythi.u $e |- U e. CPreHil $.
    pythi.a $e |- A e. X $.
    pythi.b $e |- B e. X $.
    $( The Pythagorean theorem for an arbitrary complex inner product
       (pre-Hilbert) space ` U ` .  The square of the norm of the sum of two
       orthogonal vectors (i.e. whose inner product is 0) is the sum of the
       squares of their norms.  Problem 2 in [Kreyszig] p. 135. $)
    pythi $p |- ( ( A P B ) = 0 -> ( ( N ` ( A G B ) ) ^ 2 )
        = ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) $=
      cA cB cP co cc0 wceq cA cB cG co cA cB cG co cP co cA cA cP co cB cB cP
      co caddc co cA cB cG co cN cfv c2 cexp co cA cN cfv c2 cexp co cB cN cfv
      c2 cexp co caddc co cA cB cP co cc0 wceq cA cA cP co cB cB cP co caddc co
      cA cB cP co cB cA cP co caddc co caddc co cA cA cP co cB cB cP co caddc
      co cA cB cG co cA cB cG co cP co cA cB cP co cc0 wceq cA cA cP co cB cB
      cP co caddc co cA cB cP co cB cA cP co caddc co caddc co cA cA cP co cB
      cB cP co caddc co cc0 caddc co cA cA cP co cB cB cP co caddc co cA cB cP
      co cc0 wceq cA cB cP co cB cA cP co caddc co cc0 cA cA cP co cB cB cP co
      caddc co caddc cA cB cP co cc0 wceq cA cB cP co cB cA cP co caddc co cc0
      cc0 caddc co cc0 cA cB cP co cc0 wceq cA cB cP co cc0 cB cA cP co cc0
      caddc cA cB cP co cc0 wceq id cA cB cP co cc0 wceq cB cA cP co cc0 wceq
      cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc0 wceq cB cA cP co cc0
      wceq wb cU pythi.u phnvi pythi.a pythi.b cA cB cP cU cX pyth.1 pyth.7
      iporthcom mp3an biimpi opreq12d cc0 0cn addid1i syl6eq opreq2d cA cA cP
      co cB cB cP co caddc co cA cA cP co cB cB cP co cU cnv wcel cA cX wcel cA
      cX wcel cA cA cP co cc wcel cU pythi.u phnvi pythi.a pythi.a cA cA cP cU
      cX pyth.1 pyth.7 ipcl mp3an cU cnv wcel cB cX wcel cB cX wcel cB cB cP co
      cc wcel cU pythi.u phnvi pythi.b pythi.b cB cB cP cU cX pyth.1 pyth.7
      ipcl mp3an addcli addid1i syl6eq cA cB cA cB cP cU cG cX pyth.1 pyth.2
      pyth.7 pythi.u pythi.a pythi.b pythi.a pythi.b ip2dii syl5eq cU cnv wcel
      cA cB cG co cX wcel cA cB cG co cA cB cG co cP co cA cB cG co cN cfv c2
      cexp co wceq cU pythi.u phnvi cU cnv wcel cA cX wcel cB cX wcel cA cB cG
      co cX wcel cU pythi.u phnvi pythi.a pythi.b cA cB cU cG cX pyth.1 pyth.2
      nvgcl mp3an cA cB cG co cP cU cN cX pyth.1 pyth.6 pyth.7 ipid mp2an cA cA
      cP co cA cN cfv c2 cexp co cB cB cP co cB cN cfv c2 cexp co caddc cU cnv
      wcel cA cX wcel cA cA cP co cA cN cfv c2 cexp co wceq cU pythi.u phnvi
      pythi.a cA cP cU cN cX pyth.1 pyth.6 pyth.7 ipid mp2an cU cnv wcel cB cX
      wcel cB cB cP co cB cN cfv c2 cexp co wceq cU pythi.u phnvi pythi.b cB cP
      cU cN cX pyth.1 pyth.6 pyth.7 ipid mp2an opreq12i 3eqtr3g $.
      $( [17-Apr-2008] $) $( [17-Apr-2008] $)
  $}

  ${
    siii.1 $e |- X = ( BaseSet ` U ) $.
    siii.6 $e |- N = ( norm ` U ) $.
    siii.7 $e |- P = ( .i ` U ) $.
    siii.9 $e |- U e. CPreHil $.
    siii.a $e |- A e. X $.
    siii.b $e |- B e. X $.
    ${
      sii1.3 $e |- M = ( -v ` U ) $.
      sii1.4 $e |- S = ( .s ` U ) $.
      sii1.c $e |- C e. CC $.
      sii1.r $e |- ( C x. ( A P B ) ) e. RR $.
      sii1.z $e |- 0 <_ ( C x. ( A P B ) ) $.
      $( Lemma for ~ sii . $)
      siilem1 $p |- ( ( B P A ) = ( C x. ( ( N ` B ) ^ 2 ) ) ->
                ( sqr ` ( ( A P B ) x. ( C x. ( ( N ` B ) ^ 2 ) ) ) ) <_
                       ( ( N ` A ) x. ( N ` B ) ) ) $=
        cB cA cP co cC cB cN cfv c2 cexp co cmul co wceq cC cA cB cP co cmul co
        cB cN cfv c2 cexp co cmul co csqr cfv cA cN cfv cB cN cfv cmul co c2
        cexp co csqr cfv cA cB cP co cC cB cN cfv c2 cexp co cmul co cmul co
        csqr cfv cA cN cfv cB cN cfv cmul co cle cB cA cP co cC cB cN cfv c2
        cexp co cmul co wceq cC cA cB cP co cmul co cB cN cfv c2 cexp co cmul
        co cA cN cfv cB cN cfv cmul co c2 cexp co cle wbr cC cA cB cP co cmul
        co cB cN cfv c2 cexp co cmul co csqr cfv cA cN cfv cB cN cfv cmul co c2
        cexp co csqr cfv cle wbr cB cA cP co cC cB cN cfv c2 cexp co cmul co
        wceq cC cA cB cP co cmul co cB cN cfv c2 cexp co cmul co cA cN cfv c2
        cexp co cB cN cfv c2 cexp co cmul co cA cN cfv cB cN cfv cmul co c2
        cexp co cle cB cA cP co cC cB cN cfv c2 cexp co cmul co wceq cC cA cB
        cP co cmul co cA cN cfv c2 cexp co cle wbr cC cA cB cP co cmul co cB cN
        cfv c2 cexp co cmul co cA cN cfv c2 cexp co cB cN cfv c2 cexp co cmul
        co cle wbr cB cA cP co cC cB cN cfv c2 cexp co cmul co wceq cc0 cA cN
        cfv c2 cexp co cC cA cB cP co cmul co cmin co cle wbr cC cA cB cP co
        cmul co cA cN cfv c2 cexp co cle wbr cB cA cP co cC cB cN cfv c2 cexp
        co cmul co wceq cA cN cfv c2 cexp co cC cA cB cP co cmul co cmin co cC
        ccj cfv cB cA cP co cC cB cN cfv c2 cexp co cmul co cmin co cmul co
        cmin co cA cN cfv c2 cexp co cC cA cB cP co cmul co cmin co cc0 cle cB
        cA cP co cC cB cN cfv c2 cexp co cmul co wceq cA cN cfv c2 cexp co cC
        cA cB cP co cmul co cmin co cC ccj cfv cB cA cP co cC cB cN cfv c2 cexp
        co cmul co cmin co cmul co cmin co cA cN cfv c2 cexp co cC cA cB cP co
        cmul co cmin co cc0 cmin co cA cN cfv c2 cexp co cC cA cB cP co cmul co
        cmin co cB cA cP co cC cB cN cfv c2 cexp co cmul co wceq cC ccj cfv cB
        cA cP co cC cB cN cfv c2 cexp co cmul co cmin co cmul co cc0 cA cN cfv
        c2 cexp co cC cA cB cP co cmul co cmin co cmin cB cA cP co cC cB cN cfv
        c2 cexp co cmul co wceq cB cA cP co cC cB cN cfv c2 cexp co cmul co
        cmin co cc0 wceq cC ccj cfv cB cA cP co cC cB cN cfv c2 cexp co cmul co
        cmin co cmul co cc0 wceq cB cA cP co cC cB cN cfv c2 cexp co cmul co cU
        cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cU siii.9 phnvi
        siii.b siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an cC cB cN cfv c2
        cexp co sii1.c cB cN cfv cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9
        phnvi siii.b nvcli recni sqcli mulcli subeq0i cB cA cP co cC cB cN cfv
        c2 cexp co cmul co cmin co cc0 wceq cC ccj cfv cB cA cP co cC cB cN cfv
        c2 cexp co cmul co cmin co cmul co cC ccj cfv cc0 cmul co cc0 cB cA cP
        co cC cB cN cfv c2 cexp co cmul co cmin co cc0 cC ccj cfv cmul opreq2
        cC ccj cfv cC sii1.c cjcli mul01i syl6eq sylbir opreq2d cA cN cfv c2
        cexp co cC cA cB cP co cmul co cmin co cA cN cfv c2 cexp co cC cA cB cP
        co cmul co cA cN cfv c2 cexp co cA cN cfv cA cU cN cX siii.1 siii.6 cU
        siii.9 phnvi siii.a nvcli resqcli recni cC cA cB cP co cmul co sii1.r
        recni subcli subid1i syl6eq cc0 cA cC ccj cfv cB cS co cM co cN cfv c2
        cexp co cA cN cfv c2 cexp co cC cA cB cP co cmul co cmin co cC ccj cfv
        cB cA cP co cC cB cN cfv c2 cexp co cmul co cmin co cmul co cmin co cle
        cA cC ccj cfv cB cS co cM co cN cfv cA cC ccj cfv cB cS co cM co cU cN
        cX siii.1 siii.6 cU siii.9 phnvi cU cnv wcel cA cX wcel cC ccj cfv cB
        cS co cX wcel cA cC ccj cfv cB cS co cM co cX wcel cU siii.9 phnvi
        siii.a cU cnv wcel cC ccj cfv cc wcel cB cX wcel cC ccj cfv cB cS co cX
        wcel cU siii.9 phnvi cC sii1.c cjcli siii.b cC ccj cfv cB cS cU cX
        siii.1 sii1.4 nvscl mp3an cA cC ccj cfv cB cS co cU cM cX siii.1 sii1.3
        nvmcl mp3an nvcli sqge0i cA cC ccj cfv cB cS co cM co cA cC ccj cfv cB
        cS co cM co cP co cA cC ccj cfv cB cS co cM co cA cP co cA cC ccj cfv
        cB cS co cM co cC ccj cfv cB cS co cP co cmin co cA cC ccj cfv cB cS co
        cM co cN cfv c2 cexp co cA cN cfv c2 cexp co cC cA cB cP co cmul co
        cmin co cC ccj cfv cB cA cP co cC cB cN cfv c2 cexp co cmul co cmin co
        cmul co cmin co cU cphl wcel cA cC ccj cfv cB cS co cM co cX wcel cA cX
        wcel cC ccj cfv cB cS co cX wcel w3a cA cC ccj cfv cB cS co cM co cA cC
        ccj cfv cB cS co cM co cP co cA cC ccj cfv cB cS co cM co cA cP co cA
        cC ccj cfv cB cS co cM co cC ccj cfv cB cS co cP co cmin co wceq siii.9
        cA cC ccj cfv cB cS co cM co cX wcel cA cX wcel cC ccj cfv cB cS co cX
        wcel cU cnv wcel cA cX wcel cC ccj cfv cB cS co cX wcel cA cC ccj cfv
        cB cS co cM co cX wcel cU siii.9 phnvi siii.a cU cnv wcel cC ccj cfv cc
        wcel cB cX wcel cC ccj cfv cB cS co cX wcel cU siii.9 phnvi cC sii1.c
        cjcli siii.b cC ccj cfv cB cS cU cX siii.1 sii1.4 nvscl mp3an cA cC ccj
        cfv cB cS co cU cM cX siii.1 sii1.3 nvmcl mp3an siii.a cU cnv wcel cC
        ccj cfv cc wcel cB cX wcel cC ccj cfv cB cS co cX wcel cU siii.9 phnvi
        cC sii1.c cjcli siii.b cC ccj cfv cB cS cU cX siii.1 sii1.4 nvscl mp3an
        3pm3.2i cA cC ccj cfv cB cS co cM co cA cC ccj cfv cB cS co cP cU cM cX
        siii.1 sii1.3 siii.7 ipsubdi mp2an cU cnv wcel cA cC ccj cfv cB cS co
        cM co cX wcel cA cC ccj cfv cB cS co cM co cA cC ccj cfv cB cS co cM co
        cP co cA cC ccj cfv cB cS co cM co cN cfv c2 cexp co wceq cU siii.9
        phnvi cU cnv wcel cA cX wcel cC ccj cfv cB cS co cX wcel cA cC ccj cfv
        cB cS co cM co cX wcel cU siii.9 phnvi siii.a cU cnv wcel cC ccj cfv cc
        wcel cB cX wcel cC ccj cfv cB cS co cX wcel cU siii.9 phnvi cC sii1.c
        cjcli siii.b cC ccj cfv cB cS cU cX siii.1 sii1.4 nvscl mp3an cA cC ccj
        cfv cB cS co cU cM cX siii.1 sii1.3 nvmcl mp3an cA cC ccj cfv cB cS co
        cM co cP cU cN cX siii.1 siii.6 siii.7 ipid mp2an cA cN cfv c2 cexp co
        cC ccj cfv cB cA cP co cmul co cmin co cC cA cB cP co cmul co cC ccj
        cfv cB cS co cC ccj cfv cB cS co cP co cmin co cmin co cA cN cfv c2
        cexp co cC cA cB cP co cmul co cmin co cC ccj cfv cB cA cP co cmul co
        cC ccj cfv cC cB cN cfv c2 cexp co cmul co cmul co cmin co cmin co cA
        cC ccj cfv cB cS co cM co cA cP co cA cC ccj cfv cB cS co cM co cC ccj
        cfv cB cS co cP co cmin co cA cN cfv c2 cexp co cC cA cB cP co cmul co
        cmin co cC ccj cfv cB cA cP co cC cB cN cfv c2 cexp co cmul co cmin co
        cmul co cmin co cA cN cfv c2 cexp co cC ccj cfv cB cA cP co cmul co
        cmin co cC cA cB cP co cmul co cC ccj cfv cB cS co cC ccj cfv cB cS co
        cP co cmin co cmin co cA cN cfv c2 cexp co cC ccj cfv cB cA cP co cmul
        co cmin co cC cA cB cP co cmul co cC ccj cfv cC cB cN cfv c2 cexp co
        cmul co cmul co cmin co cmin co cA cN cfv c2 cexp co cC cA cB cP co
        cmul co cmin co cC ccj cfv cB cA cP co cmul co cC ccj cfv cC cB cN cfv
        c2 cexp co cmul co cmul co cmin co cmin co cC cA cB cP co cmul co cC
        ccj cfv cB cS co cC ccj cfv cB cS co cP co cmin co cC cA cB cP co cmul
        co cC ccj cfv cC cB cN cfv c2 cexp co cmul co cmul co cmin co cA cN cfv
        c2 cexp co cC ccj cfv cB cA cP co cmul co cmin co cmin cC ccj cfv cB cS
        co cC ccj cfv cB cS co cP co cC ccj cfv cC cB cN cfv c2 cexp co cmul co
        cmul co cC cA cB cP co cmul co cmin cC ccj cfv cB cS co cC ccj cfv cB
        cS co cP co cC ccj cfv cB cC ccj cfv cB cS co cP co cmul co cC ccj cfv
        cC cB cN cfv c2 cexp co cmul co cmul co cU cphl wcel cC ccj cfv cc wcel
        cB cX wcel cC ccj cfv cB cS co cX wcel w3a cC ccj cfv cB cS co cC ccj
        cfv cB cS co cP co cC ccj cfv cB cC ccj cfv cB cS co cP co cmul co wceq
        siii.9 cC ccj cfv cc wcel cB cX wcel cC ccj cfv cB cS co cX wcel cC
        sii1.c cjcli siii.b cU cnv wcel cC ccj cfv cc wcel cB cX wcel cC ccj
        cfv cB cS co cX wcel cU siii.9 phnvi cC sii1.c cjcli siii.b cC ccj cfv
        cB cS cU cX siii.1 sii1.4 nvscl mp3an 3pm3.2i cC ccj cfv cB cC ccj cfv
        cB cS co cP cS cU cX siii.1 sii1.4 siii.7 ipass mp2an cB cC ccj cfv cB
        cS co cP co cC cB cN cfv c2 cexp co cmul co cC ccj cfv cmul cB cC ccj
        cfv cB cS co cP co cC cB cB cP co cmul co cC cB cN cfv c2 cexp co cmul
        co cU cphl wcel cB cX wcel cC cc wcel cB cX wcel w3a cB cC ccj cfv cB
        cS co cP co cC cB cB cP co cmul co wceq siii.9 cB cX wcel cC cc wcel cB
        cX wcel siii.b sii1.c siii.b 3pm3.2i cB cC cB cP cS cU cX siii.1 sii1.4
        siii.7 ipassr2 mp2an cB cB cP co cB cN cfv c2 cexp co cC cmul cU cnv
        wcel cB cX wcel cB cB cP co cB cN cfv c2 cexp co wceq cU siii.9 phnvi
        siii.b cB cP cU cN cX siii.1 siii.6 siii.7 ipid mp2an opreq2i eqtri
        opreq2i eqtri opreq2i opreq2i cA cN cfv c2 cexp co cc wcel cC ccj cfv
        cB cA cP co cmul co cc wcel wa cC cA cB cP co cmul co cc wcel cC ccj
        cfv cC cB cN cfv c2 cexp co cmul co cmul co cc wcel wa cA cN cfv c2
        cexp co cC ccj cfv cB cA cP co cmul co cmin co cC cA cB cP co cmul co
        cC ccj cfv cC cB cN cfv c2 cexp co cmul co cmul co cmin co cmin co cA
        cN cfv c2 cexp co cC cA cB cP co cmul co cmin co cC ccj cfv cB cA cP co
        cmul co cC ccj cfv cC cB cN cfv c2 cexp co cmul co cmul co cmin co cmin
        co wceq cA cN cfv c2 cexp co cc wcel cC ccj cfv cB cA cP co cmul co cc
        wcel cA cN cfv cA cN cfv cA cU cN cX siii.1 siii.6 cU siii.9 phnvi
        siii.a nvcli recni sqcli cC ccj cfv cB cA cP co cC sii1.c cjcli cU cnv
        wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cU siii.9 phnvi siii.b
        siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an mulcli pm3.2i cC cA cB
        cP co cmul co cc wcel cC ccj cfv cC cB cN cfv c2 cexp co cmul co cmul
        co cc wcel cC cA cB cP co cmul co sii1.r recni cC ccj cfv cC cB cN cfv
        c2 cexp co cmul co cC sii1.c cjcli cC cB cN cfv c2 cexp co sii1.c cB cN
        cfv cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli
        recni sqcli mulcli mulcli pm3.2i cA cN cfv c2 cexp co cC ccj cfv cB cA
        cP co cmul co cC cA cB cP co cmul co cC ccj cfv cC cB cN cfv c2 cexp co
        cmul co cmul co sub4 mp2an eqtri cA cC ccj cfv cB cS co cM co cA cP co
        cA cN cfv c2 cexp co cC ccj cfv cB cA cP co cmul co cmin co cA cC ccj
        cfv cB cS co cM co cC ccj cfv cB cS co cP co cC cA cB cP co cmul co cC
        ccj cfv cB cS co cC ccj cfv cB cS co cP co cmin co cmin cA cC ccj cfv
        cB cS co cM co cA cP co cA cA cP co cC ccj cfv cB cS co cA cP co cmin
        co cA cN cfv c2 cexp co cC ccj cfv cB cA cP co cmul co cmin co cU cphl
        wcel cA cX wcel cC ccj cfv cB cS co cX wcel cA cX wcel w3a cA cC ccj
        cfv cB cS co cM co cA cP co cA cA cP co cC ccj cfv cB cS co cA cP co
        cmin co wceq siii.9 cA cX wcel cC ccj cfv cB cS co cX wcel cA cX wcel
        siii.a cU cnv wcel cC ccj cfv cc wcel cB cX wcel cC ccj cfv cB cS co cX
        wcel cU siii.9 phnvi cC sii1.c cjcli siii.b cC ccj cfv cB cS cU cX
        siii.1 sii1.4 nvscl mp3an siii.a 3pm3.2i cA cC ccj cfv cB cS co cA cP
        cU cM cX siii.1 sii1.3 siii.7 ipsubdir mp2an cA cA cP co cA cN cfv c2
        cexp co cC ccj cfv cB cS co cA cP co cC ccj cfv cB cA cP co cmul co
        cmin cU cnv wcel cA cX wcel cA cA cP co cA cN cfv c2 cexp co wceq cU
        siii.9 phnvi siii.a cA cP cU cN cX siii.1 siii.6 siii.7 ipid mp2an cU
        cphl wcel cC ccj cfv cc wcel cB cX wcel cA cX wcel w3a cC ccj cfv cB cS
        co cA cP co cC ccj cfv cB cA cP co cmul co wceq siii.9 cC ccj cfv cc
        wcel cB cX wcel cA cX wcel cC sii1.c cjcli siii.b siii.a 3pm3.2i cC ccj
        cfv cB cA cP cS cU cX siii.1 sii1.4 siii.7 ipass mp2an opreq12i eqtri
        cA cC ccj cfv cB cS co cM co cC ccj cfv cB cS co cP co cA cC ccj cfv cB
        cS co cP co cC ccj cfv cB cS co cC ccj cfv cB cS co cP co cmin co cC cA
        cB cP co cmul co cC ccj cfv cB cS co cC ccj cfv cB cS co cP co cmin co
        cU cphl wcel cA cX wcel cC ccj cfv cB cS co cX wcel cC ccj cfv cB cS co
        cX wcel w3a cA cC ccj cfv cB cS co cM co cC ccj cfv cB cS co cP co cA
        cC ccj cfv cB cS co cP co cC ccj cfv cB cS co cC ccj cfv cB cS co cP co
        cmin co wceq siii.9 cA cX wcel cC ccj cfv cB cS co cX wcel cC ccj cfv
        cB cS co cX wcel siii.a cU cnv wcel cC ccj cfv cc wcel cB cX wcel cC
        ccj cfv cB cS co cX wcel cU siii.9 phnvi cC sii1.c cjcli siii.b cC ccj
        cfv cB cS cU cX siii.1 sii1.4 nvscl mp3an cU cnv wcel cC ccj cfv cc
        wcel cB cX wcel cC ccj cfv cB cS co cX wcel cU siii.9 phnvi cC sii1.c
        cjcli siii.b cC ccj cfv cB cS cU cX siii.1 sii1.4 nvscl mp3an 3pm3.2i
        cA cC ccj cfv cB cS co cC ccj cfv cB cS co cP cU cM cX siii.1 sii1.3
        siii.7 ipsubdir mp2an cA cC ccj cfv cB cS co cP co cC cA cB cP co cmul
        co cC ccj cfv cB cS co cC ccj cfv cB cS co cP co cmin cU cphl wcel cA
        cX wcel cC cc wcel cB cX wcel w3a cA cC ccj cfv cB cS co cP co cC cA cB
        cP co cmul co wceq siii.9 cA cX wcel cC cc wcel cB cX wcel siii.a
        sii1.c siii.b 3pm3.2i cA cC cB cP cS cU cX siii.1 sii1.4 siii.7 ipassr2
        mp2an opreq1i eqtri opreq12i cC ccj cfv cB cA cP co cC cB cN cfv c2
        cexp co cmul co cmin co cmul co cC ccj cfv cB cA cP co cmul co cC ccj
        cfv cC cB cN cfv c2 cexp co cmul co cmul co cmin co cA cN cfv c2 cexp
        co cC cA cB cP co cmul co cmin co cmin cC ccj cfv cB cA cP co cC cB cN
        cfv c2 cexp co cmul co cC sii1.c cjcli cU cnv wcel cB cX wcel cA cX
        wcel cB cA cP co cc wcel cU siii.9 phnvi siii.b siii.a cB cA cP cU cX
        siii.1 siii.7 ipcl mp3an cC cB cN cfv c2 cexp co sii1.c cB cN cfv cB cN
        cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli recni sqcli
        mulcli subdii opreq2i 3eqtr4i 3eqtr3i breqtri syl5breq cA cN cfv c2
        cexp co cC cA cB cP co cmul co cA cN cfv cA cU cN cX siii.1 siii.6 cU
        siii.9 phnvi siii.a nvcli resqcli sii1.r subge0i sylib cC cA cB cP co
        cmul co cr wcel cA cN cfv c2 cexp co cr wcel cB cN cfv c2 cexp co cr
        wcel cc0 cB cN cfv c2 cexp co cle wbr wa w3a cC cA cB cP co cmul co cA
        cN cfv c2 cexp co cle wbr cC cA cB cP co cmul co cB cN cfv c2 cexp co
        cmul co cA cN cfv c2 cexp co cB cN cfv c2 cexp co cmul co cle wbr cC cA
        cB cP co cmul co cr wcel cA cN cfv c2 cexp co cr wcel cB cN cfv c2 cexp
        co cr wcel cc0 cB cN cfv c2 cexp co cle wbr wa sii1.r cA cN cfv cA cU
        cN cX siii.1 siii.6 cU siii.9 phnvi siii.a nvcli resqcli cB cN cfv c2
        cexp co cr wcel cc0 cB cN cfv c2 cexp co cle wbr cB cN cfv cB cU cN cX
        siii.1 siii.6 cU siii.9 phnvi siii.b nvcli resqcli cB cN cfv cB cU cN
        cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli sqge0i pm3.2i 3pm3.2i cC
        cA cB cP co cmul co cA cN cfv c2 cexp co cB cN cfv c2 cexp co lemul1a
        mpan syl cA cN cfv cB cN cfv cA cN cfv cA cU cN cX siii.1 siii.6 cU
        siii.9 phnvi siii.a nvcli recni cB cN cfv cB cU cN cX siii.1 siii.6 cU
        siii.9 phnvi siii.b nvcli recni sqmuli syl6breqr cc0 cC cA cB cP co
        cmul co cB cN cfv c2 cexp co cmul co cle wbr cc0 cA cN cfv cB cN cfv
        cmul co c2 cexp co cle wbr cC cA cB cP co cmul co cB cN cfv c2 cexp co
        cmul co cA cN cfv cB cN cfv cmul co c2 cexp co cle wbr cC cA cB cP co
        cmul co cB cN cfv c2 cexp co cmul co csqr cfv cA cN cfv cB cN cfv cmul
        co c2 cexp co csqr cfv cle wbr wb cc0 cC cA cB cP co cmul co cle wbr
        cc0 cB cN cfv c2 cexp co cle wbr cc0 cC cA cB cP co cmul co cB cN cfv
        c2 cexp co cmul co cle wbr sii1.z cB cN cfv cB cU cN cX siii.1 siii.6
        cU siii.9 phnvi siii.b nvcli sqge0i cC cA cB cP co cmul co cB cN cfv c2
        cexp co sii1.r cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi
        siii.b nvcli resqcli mulge0i mp2an cA cN cfv cB cN cfv cmul co cA cN
        cfv cB cN cfv cA cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.a nvcli cB
        cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli remulcli sqge0i cC
        cA cB cP co cmul co cB cN cfv c2 cexp co cmul co cA cN cfv cB cN cfv
        cmul co c2 cexp co cC cA cB cP co cmul co cB cN cfv c2 cexp co sii1.r
        cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli
        resqcli remulcli cA cN cfv cB cN cfv cmul co cA cN cfv cB cN cfv cA cU
        cN cX siii.1 siii.6 cU siii.9 phnvi siii.a nvcli cB cU cN cX siii.1
        siii.6 cU siii.9 phnvi siii.b nvcli remulcli resqcli sqrlei mp2an sylib
        cC cA cB cP co cmul co cB cN cfv c2 cexp co cmul co cA cB cP co cC cB
        cN cfv c2 cexp co cmul co cmul co csqr cC cA cB cP co cmul co cB cN cfv
        c2 cexp co cmul co cA cB cP co cC cmul co cB cN cfv c2 cexp co cmul co
        cA cB cP co cC cB cN cfv c2 cexp co cmul co cmul co cC cA cB cP co cmul
        co cA cB cP co cC cmul co cB cN cfv c2 cexp co cmul cC cA cB cP co
        sii1.c cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU siii.9
        phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl mp3an mulcomi
        opreq1i cA cB cP co cC cB cN cfv c2 cexp co cU cnv wcel cA cX wcel cB
        cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU
        cX siii.1 siii.7 ipcl mp3an sii1.c cB cN cfv c2 cexp co cB cN cfv cB cU
        cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli resqcli recni mulassi
        eqtri fveq2i cc0 cA cN cfv cB cN cfv cmul co cle wbr cA cN cfv cB cN
        cfv cmul co c2 cexp co csqr cfv cA cN cfv cB cN cfv cmul co wceq cc0 cA
        cN cfv cle wbr cc0 cB cN cfv cle wbr cc0 cA cN cfv cB cN cfv cmul co
        cle wbr cU cnv wcel cA cX wcel cc0 cA cN cfv cle wbr cU siii.9 phnvi
        siii.a cA cU cN cX siii.1 siii.6 nvge0 mp2an cU cnv wcel cB cX wcel cc0
        cB cN cfv cle wbr cU siii.9 phnvi siii.b cB cU cN cX siii.1 siii.6
        nvge0 mp2an cA cN cfv cB cN cfv cA cU cN cX siii.1 siii.6 cU siii.9
        phnvi siii.a nvcli cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b
        nvcli mulge0i mp2an cA cN cfv cB cN cfv cmul co cA cN cfv cB cN cfv cA
        cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.a nvcli cB cU cN cX siii.1
        siii.6 cU siii.9 phnvi siii.b nvcli remulcli sqrsqi ax-mp 3brtr3g $.
        $( [23-Jan-2008] $) $( [23-Nov-2007] $)
    $}

    ${
      siii2.3 $e |- M = ( -v ` U ) $.
      siii2.4 $e |- S = ( .s ` U ) $.
      $( Lemma for ~ sii . $)
      siilem2 $p |- ( ( C e. CC /\ ( C x. ( A P B ) ) e. RR /\
                           0 <_ ( C x. ( A P B ) ) ) ->
                ( ( B P A ) = ( C x. ( ( N ` B ) ^ 2 ) ) ->
                  ( sqr ` ( ( A P B ) x. ( C x. ( ( N ` B ) ^ 2 ) ) ) ) <_
                         ( ( N ` A ) x. ( N ` B ) ) ) ) $=
        cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co
        cle wbr w3a cB cA cP co cC cB cN cfv c2 cexp co cmul co wceq cA cB cP
        co cC cB cN cfv c2 cexp co cmul co cmul co csqr cfv cA cN cfv cB cN cfv
        cmul co cle wbr wi cB cA cP co cC cc wcel cC cA cB cP co cmul co cr
        wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cB cN cfv c2
        cexp co cmul co wceq cA cB cP co cC cc wcel cC cA cB cP co cmul co cr
        wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cB cN cfv c2
        cexp co cmul co cmul co csqr cfv cA cN cfv cB cN cfv cmul co cle wbr wi
        cC cc0 cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif wceq cB cA cP co cC cB cN cfv c2 cexp co
        cmul co wceq cB cA cP co cC cc wcel cC cA cB cP co cmul co cr wcel cc0
        cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cB cN cfv c2 cexp co cmul
        co wceq cA cB cP co cC cB cN cfv c2 cexp co cmul co cmul co csqr cfv cA
        cN cfv cB cN cfv cmul co cle wbr cA cB cP co cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cB cN
        cfv c2 cexp co cmul co cmul co csqr cfv cA cN cfv cB cN cfv cmul co cle
        wbr cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif wceq cC cB cN cfv c2 cexp co cmul co cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cB cN cfv c2 cexp co cmul co cB cA cP co cC cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif cB cN cfv c2 cexp co cmul opreq1 eqeq2d cC cC cc wcel cC
        cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC
        cc0 cif wceq cA cB cP co cC cB cN cfv c2 cexp co cmul co cmul co csqr
        cfv cA cB cP co cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB
        cP co cmul co cle wbr w3a cC cc0 cif cB cN cfv c2 cexp co cmul co cmul
        co csqr cfv cA cN cfv cB cN cfv cmul co cle cC cC cc wcel cC cA cB cP
        co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        wceq cA cB cP co cC cB cN cfv c2 cexp co cmul co cmul co cA cB cP co cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cB cN cfv c2 cexp co cmul co cmul co csqr cC cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif wceq cC cB cN cfv c2 cexp co cmul co cC cc wcel cC cA cB
        cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        cB cN cfv c2 cexp co cmul co cA cB cP co cmul cC cC cc wcel cC cA cB cP
        co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cB
        cN cfv c2 cexp co cmul opreq1 opreq2d fveq2d breq1d imbi12d cA cB cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif cP cS cU cM cN cX siii.1 siii.6 siii.7 siii.9 siii.a
        siii.b siii2.3 siii2.4 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC
        cA cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cC cc wcel cC cA cB
        cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        cA cB cP co cmul co cr wcel cc0 cC cc wcel cC cA cB cP co cmul co cr
        wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul
        co cle wbr cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA
        cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cC cc wcel cC cA cB cP
        co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA
        cB cP co cmul co cr wcel cc0 cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co
        cle wbr w3a cc0 cc wcel cc0 cA cB cP co cmul co cr wcel cc0 cc0 cA cB
        cP co cmul co cle wbr w3a cC cc0 cC cC cc wcel cC cA cB cP co cmul co
        cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq cC cc
        wcel cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul
        co cle wbr w3a cC cc0 cif cc wcel cC cA cB cP co cmul co cr wcel cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co
        cle wbr cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP
        co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cle wbr cC cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif cc eleq1 cC cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq cC cA cB cP co
        cmul co cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cr cC cC cc wcel cC
        cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC
        cc0 cif cA cB cP co cmul opreq1 eleq1d cC cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq
        cC cA cB cP co cmul co cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC
        cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cc0 cle
        cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co
        cle wbr w3a cC cc0 cif cA cB cP co cmul opreq1 breq2d 3anbi123d cc0 cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif wceq cc0 cc wcel cC cc wcel cC cA cB cP co cmul co
        cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cc0
        cA cB cP co cmul co cr wcel cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co
        cr wcel cc0 cc0 cA cB cP co cmul co cle wbr cc0 cC cc wcel cC cA cB cP
        co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA
        cB cP co cmul co cle wbr cc0 cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc eleq1 cc0 cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif wceq cc0 cA cB cP co cmul co cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB
        cP co cmul co cr cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC
        cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul opreq1
        eleq1d cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif wceq cc0 cA cB cP co cmul co cC cc wcel
        cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a
        cC cc0 cif cA cB cP co cmul co cc0 cle cc0 cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB
        cP co cmul opreq1 breq2d 3anbi123d cc0 cc wcel cc0 cA cB cP co cmul co
        cr wcel cc0 cc0 cA cB cP co cmul co cle wbr 0cn cc0 cA cB cP co cmul co
        cc0 cr cA cB cP co cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc
        wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl
        mp3an mul02i 0re eqeltri cc0 cc0 cc0 cA cB cP co cmul co cle cc0 0re
        leidi cA cB cP co cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel
        cU siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl mp3an
        mul02i breqtrri 3pm3.2i elimhyp 3simp1i cC cc wcel cC cA cB cP co cmul
        co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cA cB cP co cmul co cr wcel cc0 cC cc wcel cC cA cB
        cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        cA cB cP co cmul co cle wbr cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc wcel cC cA cB cP co cmul
        co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cA cB cP co cmul co cr wcel cc0 cC cc wcel cC cA cB
        cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        cA cB cP co cmul co cle wbr w3a cc0 cc wcel cc0 cA cB cP co cmul co cr
        wcel cc0 cc0 cA cB cP co cmul co cle wbr w3a cC cc0 cC cC cc wcel cC cA
        cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0
        cif wceq cC cc wcel cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA
        cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cC cA cB cP co cmul co
        cr wcel cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cr wcel cc0 cC cA cB
        cP co cmul co cle wbr cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0
        cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cle
        wbr cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif cc eleq1 cC cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq
        cC cA cB cP co cmul co cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC
        cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cr cC cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cA cB cP co cmul opreq1 eleq1d cC cC cc wcel cC cA
        cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0
        cif wceq cC cA cB cP co cmul co cC cc wcel cC cA cB cP co cmul co cr
        wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul
        co cc0 cle cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP
        co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul opreq1 breq2d
        3anbi123d cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP
        co cmul co cle wbr w3a cC cc0 cif wceq cc0 cc wcel cC cc wcel cC cA cB
        cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        cc wcel cc0 cA cB cP co cmul co cr wcel cC cc wcel cC cA cB cP co cmul
        co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP
        co cmul co cr wcel cc0 cc0 cA cB cP co cmul co cle wbr cc0 cC cc wcel
        cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a
        cC cc0 cif cA cB cP co cmul co cle wbr cc0 cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc
        eleq1 cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif wceq cc0 cA cB cP co cmul co cC cc wcel
        cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a
        cC cc0 cif cA cB cP co cmul co cr cc0 cC cc wcel cC cA cB cP co cmul co
        cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co
        cmul opreq1 eleq1d cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC
        cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq cc0 cA cB cP co cmul co
        cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co
        cle wbr w3a cC cc0 cif cA cB cP co cmul co cc0 cle cc0 cC cc wcel cC cA
        cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0
        cif cA cB cP co cmul opreq1 breq2d 3anbi123d cc0 cc wcel cc0 cA cB cP
        co cmul co cr wcel cc0 cc0 cA cB cP co cmul co cle wbr 0cn cc0 cA cB cP
        co cmul co cc0 cr cA cB cP co cU cnv wcel cA cX wcel cB cX wcel cA cB
        cP co cc wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1
        siii.7 ipcl mp3an mul02i 0re eqeltri cc0 cc0 cc0 cA cB cP co cmul co
        cle cc0 0re leidi cA cB cP co cU cnv wcel cA cX wcel cB cX wcel cA cB
        cP co cc wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1
        siii.7 ipcl mp3an mul02i breqtrri 3pm3.2i elimhyp 3simp2i cC cc wcel cC
        cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC
        cc0 cif cc wcel cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB
        cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cr wcel cc0 cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cA cB cP co cmul co cle wbr cC cc wcel cC cA cB cP
        co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc wcel cC
        cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC
        cc0 cif cc wcel cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB
        cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cr wcel cc0 cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cA cB cP co cmul co cle wbr w3a cc0 cc wcel cc0 cA
        cB cP co cmul co cr wcel cc0 cc0 cA cB cP co cmul co cle wbr w3a cC cc0
        cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co
        cle wbr w3a cC cc0 cif wceq cC cc wcel cC cc wcel cC cA cB cP co cmul
        co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc wcel cC
        cA cB cP co cmul co cr wcel cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co
        cr wcel cc0 cC cA cB cP co cmul co cle wbr cc0 cC cc wcel cC cA cB cP
        co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA
        cB cP co cmul co cle wbr cC cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cc eleq1 cC cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif wceq cC cA cB cP co cmul co cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB
        cP co cmul co cr cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA
        cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul opreq1 eleq1d
        cC cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co
        cle wbr w3a cC cc0 cif wceq cC cA cB cP co cmul co cC cc wcel cC cA cB
        cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif
        cA cB cP co cmul co cc0 cle cC cC cc wcel cC cA cB cP co cmul co cr
        wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul
        opreq1 breq2d 3anbi123d cc0 cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq cc0 cc wcel cC
        cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle
        wbr w3a cC cc0 cif cc wcel cc0 cA cB cP co cmul co cr wcel cC cc wcel
        cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a
        cC cc0 cif cA cB cP co cmul co cr wcel cc0 cc0 cA cB cP co cmul co cle
        wbr cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cle wbr cc0 cC cc
        wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr
        w3a cC cc0 cif cc eleq1 cc0 cC cc wcel cC cA cB cP co cmul co cr wcel
        cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq cc0 cA cB cP co
        cmul co cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cr cc0 cC cc wcel cC
        cA cB cP co cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC
        cc0 cif cA cB cP co cmul opreq1 eleq1d cc0 cC cc wcel cC cA cB cP co
        cmul co cr wcel cc0 cC cA cB cP co cmul co cle wbr w3a cC cc0 cif wceq
        cc0 cA cB cP co cmul co cC cc wcel cC cA cB cP co cmul co cr wcel cc0
        cC cA cB cP co cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul co cc0
        cle cc0 cC cc wcel cC cA cB cP co cmul co cr wcel cc0 cC cA cB cP co
        cmul co cle wbr w3a cC cc0 cif cA cB cP co cmul opreq1 breq2d 3anbi123d
        cc0 cc wcel cc0 cA cB cP co cmul co cr wcel cc0 cc0 cA cB cP co cmul co
        cle wbr 0cn cc0 cA cB cP co cmul co cc0 cr cA cB cP co cU cnv wcel cA
        cX wcel cB cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a siii.b cA
        cB cP cU cX siii.1 siii.7 ipcl mp3an mul02i 0re eqeltri cc0 cc0 cc0 cA
        cB cP co cmul co cle cc0 0re leidi cA cB cP co cU cnv wcel cA cX wcel
        cB cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a siii.b cA cB cP
        cU cX siii.1 siii.7 ipcl mp3an mul02i breqtrri 3pm3.2i elimhyp 3simp3i
        siilem1 dedth $.
        $( [23-Jan-2008] $) $( [24-Nov-2007] $)
    $}

    $( Inference from ~ sii . $)
    siii $p |- ( abs ` ( A P B ) ) <_ ( ( N ` A ) x. ( N ` B ) ) $=
      cA cB cP co cabs cfv cA cN cfv cB cN cfv cmul co cle wbr cB cU cn0v cfv
      cB cU cn0v cfv wceq cA cB cP co cabs cfv cc0 cA cN cfv cB cN cfv cmul co
      cle cB cU cn0v cfv wceq cA cB cP co cabs cfv cc0 cabs cfv cc0 cB cU cn0v
      cfv wceq cA cB cP co cc0 cabs cB cU cn0v cfv wceq cA cB cP co cA cU cn0v
      cfv cP co cc0 cB cU cn0v cfv cA cP opreq2 cU cnv wcel cA cX wcel cA cU
      cn0v cfv cP co cc0 wceq cU siii.9 phnvi siii.a cA cP cU cX cU cn0v cfv
      siii.1 cU cn0v cfv eqid siii.7 ip0r mp2an syl6eq fveq2d abs0 syl6eq cc0
      cA cN cfv cle wbr cc0 cB cN cfv cle wbr cc0 cA cN cfv cB cN cfv cmul co
      cle wbr cU cnv wcel cA cX wcel cc0 cA cN cfv cle wbr cU siii.9 phnvi
      siii.a cA cU cN cX siii.1 siii.6 nvge0 mp2an cU cnv wcel cB cX wcel cc0
      cB cN cfv cle wbr cU siii.9 phnvi siii.b cB cU cN cX siii.1 siii.6 nvge0
      mp2an cA cN cfv cB cN cfv cA cU cN cX siii.1 siii.6 cU siii.9 phnvi
      siii.a nvcli cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli
      mulge0i mp2an syl6eqbr cB cU cn0v cfv wne cA cB cP co cabs cfv cA cB cP
      co cB cA cP co cB cN cfv c2 cexp co cdiv co cB cN cfv c2 cexp co cmul co
      cmul co csqr cfv cA cN cfv cB cN cfv cmul co cle cB cU cn0v cfv wne cA cB
      cP co cB cA cP co cB cN cfv c2 cexp co cdiv co cB cN cfv c2 cexp co cmul
      co cmul co csqr cfv cA cB cP co cA cB cP co ccj cfv cmul co csqr cfv cA
      cB cP co cabs cfv cB cU cn0v cfv wne cA cB cP co cB cA cP co cB cN cfv c2
      cexp co cdiv co cB cN cfv c2 cexp co cmul co cmul co cA cB cP co cA cB cP
      co ccj cfv cmul co csqr cB cU cn0v cfv wne cB cA cP co cB cN cfv c2 cexp
      co cdiv co cB cN cfv c2 cexp co cmul co cA cB cP co ccj cfv cA cB cP co
      cmul cB cU cn0v cfv wne cB cA cP co cB cN cfv c2 cexp co cdiv co cB cN
      cfv c2 cexp co cmul co cB cA cP co cA cB cP co ccj cfv cB cU cn0v cfv wne
      cB cN cfv c2 cexp co cc0 wne cB cA cP co cB cN cfv c2 cexp co cdiv co cB
      cN cfv c2 cexp co cmul co cB cA cP co wceq cB cN cfv c2 cexp co cc0 cB cU
      cn0v cfv cB cN cfv c2 cexp co cc0 wceq cB cN cfv cc0 wceq cB cU cn0v cfv
      wceq cB cN cfv cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b
      nvcli recni sqeq0i cU cnv wcel cB cX wcel cB cN cfv cc0 wceq cB cU cn0v
      cfv wceq wb cU siii.9 phnvi siii.b cB cU cN cX cU cn0v cfv siii.1 cU cn0v
      cfv eqid siii.6 nvz mp2an bitri necon3bii cB cA cP co cB cN cfv c2 cexp
      co cU cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cU siii.9 phnvi
      siii.b siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an cB cN cfv c2 cexp
      co cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli
      resqcli recni divcan1zi sylbir cU cnv wcel cA cX wcel cB cX wcel cA cB cP
      co ccj cfv cB cA cP co wceq cU siii.9 phnvi siii.a siii.b cA cB cP cU cX
      siii.1 siii.7 ipcj mp3an syl6eqr opreq2d fveq2d cA cB cP co cc wcel cA cB
      cP co cabs cfv cA cB cP co cA cB cP co ccj cfv cmul co csqr cfv wceq cU
      cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a
      siii.b cA cB cP cU cX siii.1 siii.7 ipcl mp3an cA cB cP co absval ax-mp
      syl6reqr cB cU cn0v cfv wne cB cA cP co cB cA cP co cB cN cfv c2 cexp co
      cdiv co cB cN cfv c2 cexp co cmul co wceq cA cB cP co cB cA cP co cB cN
      cfv c2 cexp co cdiv co cB cN cfv c2 cexp co cmul co cmul co csqr cfv cA
      cN cfv cB cN cfv cmul co cle wbr cB cU cn0v cfv wne cB cA cP co cB cN cfv
      c2 cexp co cdiv co cB cN cfv c2 cexp co cmul co cB cA cP co cB cU cn0v
      cfv wne cB cN cfv c2 cexp co cc0 wne cB cA cP co cB cN cfv c2 cexp co
      cdiv co cB cN cfv c2 cexp co cmul co cB cA cP co wceq cB cN cfv c2 cexp
      co cc0 cB cU cn0v cfv cB cN cfv c2 cexp co cc0 wceq cB cN cfv cc0 wceq cB
      cU cn0v cfv wceq cB cN cfv cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9
      phnvi siii.b nvcli recni sqeq0i cU cnv wcel cB cX wcel cB cN cfv cc0 wceq
      cB cU cn0v cfv wceq wb cU siii.9 phnvi siii.b cB cU cN cX cU cn0v cfv
      siii.1 cU cn0v cfv eqid siii.6 nvz mp2an bitri necon3bii cB cA cP co cB
      cN cfv c2 cexp co cU cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel
      cU siii.9 phnvi siii.b siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an cB
      cN cfv c2 cexp co cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi
      siii.b nvcli resqcli recni divcan1zi sylbir eqcomd cB cA cP co cB cN cfv
      c2 cexp co cdiv co cc wcel cB cA cP co cB cN cfv c2 cexp co cdiv co cA cB
      cP co cmul co cr wcel cc0 cB cA cP co cB cN cfv c2 cexp co cdiv co cA cB
      cP co cmul co cle wbr cB cA cP co cB cA cP co cB cN cfv c2 cexp co cdiv
      co cB cN cfv c2 cexp co cmul co wceq cA cB cP co cB cA cP co cB cN cfv c2
      cexp co cdiv co cB cN cfv c2 cexp co cmul co cmul co csqr cfv cA cN cfv
      cB cN cfv cmul co cle wbr wi cB cU cn0v cfv wne cA cB cB cA cP co cB cN
      cfv c2 cexp co cdiv co cP cU cns cfv cU cU cnsb cfv cN cX siii.1 siii.6
      siii.7 siii.9 siii.a siii.b cU cnsb cfv eqid cU cns cfv eqid siilem2 cB
      cU cn0v cfv wne cB cN cfv c2 cexp co cc0 wne cB cA cP co cB cN cfv c2
      cexp co cdiv co cc wcel cB cN cfv c2 cexp co cc0 cB cU cn0v cfv cB cN cfv
      c2 cexp co cc0 wceq cB cN cfv cc0 wceq cB cU cn0v cfv wceq cB cN cfv cB
      cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli recni
      sqeq0i cU cnv wcel cB cX wcel cB cN cfv cc0 wceq cB cU cn0v cfv wceq wb
      cU siii.9 phnvi siii.b cB cU cN cX cU cn0v cfv siii.1 cU cn0v cfv eqid
      siii.6 nvz mp2an bitri necon3bii cB cA cP co cB cN cfv c2 cexp co cU cnv
      wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cU siii.9 phnvi siii.b
      siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an cB cN cfv c2 cexp co cB cN
      cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli resqcli recni
      divclzi sylbir cB cU cn0v cfv wne cB cA cP co cB cN cfv c2 cexp co cdiv
      co cA cB cP co cmul co cA cB cP co cabs cfv c2 cexp co cB cN cfv c2 cexp
      co cdiv co cr cB cU cn0v cfv wne cB cA cP co cA cB cP co cmul co cB cN
      cfv c2 cexp co cdiv co cB cA cP co cB cN cfv c2 cexp co cdiv co cA cB cP
      co cmul co cA cB cP co cabs cfv c2 cexp co cB cN cfv c2 cexp co cdiv co
      cB cU cn0v cfv wne cB cN cfv c2 cexp co cc0 wne cB cA cP co cA cB cP co
      cmul co cB cN cfv c2 cexp co cdiv co cB cA cP co cB cN cfv c2 cexp co
      cdiv co cA cB cP co cmul co wceq cB cN cfv c2 cexp co cc0 cB cU cn0v cfv
      cB cN cfv c2 cexp co cc0 wceq cB cN cfv cc0 wceq cB cU cn0v cfv wceq cB
      cN cfv cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli
      recni sqeq0i cU cnv wcel cB cX wcel cB cN cfv cc0 wceq cB cU cn0v cfv
      wceq wb cU siii.9 phnvi siii.b cB cU cN cX cU cn0v cfv siii.1 cU cn0v cfv
      eqid siii.6 nvz mp2an bitri necon3bii cB cN cfv c2 cexp co cc wcel cB cN
      cfv c2 cexp co cc0 wne cB cA cP co cA cB cP co cmul co cB cN cfv c2 cexp
      co cdiv co cB cA cP co cB cN cfv c2 cexp co cdiv co cA cB cP co cmul co
      wceq cB cN cfv c2 cexp co cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9
      phnvi siii.b nvcli resqcli recni cB cA cP co cc wcel cA cB cP co cc wcel
      cB cN cfv c2 cexp co cc wcel cB cN cfv c2 cexp co cc0 wne wa cB cA cP co
      cA cB cP co cmul co cB cN cfv c2 cexp co cdiv co cB cA cP co cB cN cfv c2
      cexp co cdiv co cA cB cP co cmul co wceq cU cnv wcel cB cX wcel cA cX
      wcel cB cA cP co cc wcel cU siii.9 phnvi siii.b siii.a cB cA cP cU cX
      siii.1 siii.7 ipcl mp3an cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc
      wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl
      mp3an cB cA cP co cA cB cP co cB cN cfv c2 cexp co div23 mp3an12 mpan
      sylbir cB cA cP co cA cB cP co cmul co cA cB cP co cabs cfv c2 cexp co cB
      cN cfv c2 cexp co cdiv cB cA cP co cA cB cP co cmul co cA cB cP co cB cA
      cP co cmul co cA cB cP co cabs cfv c2 cexp co cB cA cP co cA cB cP co cU
      cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cU siii.9 phnvi siii.b
      siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an cU cnv wcel cA cX wcel cB
      cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU cX
      siii.1 siii.7 ipcl mp3an mulcomi cU cnv wcel cA cX wcel cB cX wcel cA cB
      cP co cB cA cP co cmul co cA cB cP co cabs cfv c2 cexp co wceq cU siii.9
      phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipipcj mp3an eqtri
      opreq1i syl5reqr cB cU cn0v cfv wne cB cN cfv c2 cexp co cc0 wne cA cB cP
      co cabs cfv c2 cexp co cB cN cfv c2 cexp co cdiv co cr wcel cB cN cfv c2
      cexp co cc0 cB cU cn0v cfv cB cN cfv c2 cexp co cc0 wceq cB cN cfv cc0
      wceq cB cU cn0v cfv wceq cB cN cfv cB cN cfv cB cU cN cX siii.1 siii.6 cU
      siii.9 phnvi siii.b nvcli recni sqeq0i cU cnv wcel cB cX wcel cB cN cfv
      cc0 wceq cB cU cn0v cfv wceq wb cU siii.9 phnvi siii.b cB cU cN cX cU
      cn0v cfv siii.1 cU cn0v cfv eqid siii.6 nvz mp2an bitri necon3bii cA cB
      cP co cabs cfv c2 cexp co cB cN cfv c2 cexp co cA cB cP co cabs cfv cA cB
      cP co cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU siii.9
      phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl mp3an abscli
      resqcli cB cN cfv cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli
      resqcli redivclzi sylbir eqeltrd cB cU cn0v cfv wne cc0 cA cB cP co cabs
      cfv c2 cexp co cB cN cfv c2 cexp co cdiv co cB cA cP co cB cN cfv c2 cexp
      co cdiv co cA cB cP co cmul co cle cB cU cn0v cfv wne cc0 cB cN cfv c2
      cexp co clt wbr cc0 cA cB cP co cabs cfv c2 cexp co cB cN cfv c2 cexp co
      cdiv co cle wbr cB cU cn0v cfv wne cB cN cfv cc0 wne cc0 cB cN cfv c2
      cexp co clt wbr cB cN cfv cc0 cB cU cn0v cfv cU cnv wcel cB cX wcel cB cN
      cfv cc0 wceq cB cU cn0v cfv wceq wb cU siii.9 phnvi siii.b cB cU cN cX cU
      cn0v cfv siii.1 cU cn0v cfv eqid siii.6 nvz mp2an necon3bii cB cN cfv cB
      cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli sqgt0i sylbir cB cN
      cfv c2 cexp co cr wcel cc0 cB cN cfv c2 cexp co clt wbr cc0 cA cB cP co
      cabs cfv c2 cexp co cB cN cfv c2 cexp co cdiv co cle wbr cB cN cfv cB cU
      cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli resqcli cA cB cP co cabs
      cfv c2 cexp co cr wcel cc0 cA cB cP co cabs cfv c2 cexp co cle wbr cB cN
      cfv c2 cexp co cr wcel cc0 cB cN cfv c2 cexp co clt wbr wa cc0 cA cB cP
      co cabs cfv c2 cexp co cB cN cfv c2 cexp co cdiv co cle wbr cA cB cP co
      cabs cfv cA cB cP co cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc
      wcel cU siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl
      mp3an abscli resqcli cA cB cP co cabs cfv cA cB cP co cU cnv wcel cA cX
      wcel cB cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a siii.b cA cB
      cP cU cX siii.1 siii.7 ipcl mp3an abscli sqge0i cA cB cP co cabs cfv c2
      cexp co cB cN cfv c2 cexp co divge0 mpanl12 mpan syl cB cU cn0v cfv wne
      cB cA cP co cA cB cP co cmul co cB cN cfv c2 cexp co cdiv co cB cA cP co
      cB cN cfv c2 cexp co cdiv co cA cB cP co cmul co cA cB cP co cabs cfv c2
      cexp co cB cN cfv c2 cexp co cdiv co cB cU cn0v cfv wne cB cN cfv c2 cexp
      co cc0 wne cB cA cP co cA cB cP co cmul co cB cN cfv c2 cexp co cdiv co
      cB cA cP co cB cN cfv c2 cexp co cdiv co cA cB cP co cmul co wceq cB cN
      cfv c2 cexp co cc0 cB cU cn0v cfv cB cN cfv c2 cexp co cc0 wceq cB cN cfv
      cc0 wceq cB cU cn0v cfv wceq cB cN cfv cB cN cfv cB cU cN cX siii.1
      siii.6 cU siii.9 phnvi siii.b nvcli recni sqeq0i cU cnv wcel cB cX wcel
      cB cN cfv cc0 wceq cB cU cn0v cfv wceq wb cU siii.9 phnvi siii.b cB cU cN
      cX cU cn0v cfv siii.1 cU cn0v cfv eqid siii.6 nvz mp2an bitri necon3bii
      cB cN cfv c2 cexp co cc wcel cB cN cfv c2 cexp co cc0 wne cB cA cP co cA
      cB cP co cmul co cB cN cfv c2 cexp co cdiv co cB cA cP co cB cN cfv c2
      cexp co cdiv co cA cB cP co cmul co wceq cB cN cfv c2 cexp co cB cN cfv
      cB cU cN cX siii.1 siii.6 cU siii.9 phnvi siii.b nvcli resqcli recni cB
      cA cP co cc wcel cA cB cP co cc wcel cB cN cfv c2 cexp co cc wcel cB cN
      cfv c2 cexp co cc0 wne wa cB cA cP co cA cB cP co cmul co cB cN cfv c2
      cexp co cdiv co cB cA cP co cB cN cfv c2 cexp co cdiv co cA cB cP co cmul
      co wceq cU cnv wcel cB cX wcel cA cX wcel cB cA cP co cc wcel cU siii.9
      phnvi siii.b siii.a cB cA cP cU cX siii.1 siii.7 ipcl mp3an cU cnv wcel
      cA cX wcel cB cX wcel cA cB cP co cc wcel cU siii.9 phnvi siii.a siii.b
      cA cB cP cU cX siii.1 siii.7 ipcl mp3an cB cA cP co cA cB cP co cB cN cfv
      c2 cexp co div23 mp3an12 mpan sylbir cB cA cP co cA cB cP co cmul co cA
      cB cP co cabs cfv c2 cexp co cB cN cfv c2 cexp co cdiv cB cA cP co cA cB
      cP co cmul co cA cB cP co cB cA cP co cmul co cA cB cP co cabs cfv c2
      cexp co cB cA cP co cA cB cP co cU cnv wcel cB cX wcel cA cX wcel cB cA
      cP co cc wcel cU siii.9 phnvi siii.b siii.a cB cA cP cU cX siii.1 siii.7
      ipcl mp3an cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cc wcel cU
      siii.9 phnvi siii.a siii.b cA cB cP cU cX siii.1 siii.7 ipcl mp3an
      mulcomi cU cnv wcel cA cX wcel cB cX wcel cA cB cP co cB cA cP co cmul co
      cA cB cP co cabs cfv c2 cexp co wceq cU siii.9 phnvi siii.a siii.b cA cB
      cP cU cX siii.1 siii.7 ipipcj mp3an eqtri opreq1i syl5reqr breqtrrd
      syl3anc mpd eqbrtrd pm2.61ine $.
      $( [23-Jan-2008] $) $( [20-Nov-2007] $)
  $}

  ${
    sii.1 $e |- X = ( BaseSet ` U ) $.
    sii.6 $e |- N = ( norm ` U ) $.
    sii.7 $e |- P = ( .i ` U ) $.
    sii.9 $e |- U e. CPreHil $.
    $( Schwartz inequality.  Part of Lemma 3-2.1(a) of [Kreyszig] p. 137. $)
    sii $p |- ( ( A e. X /\ B e. X ) ->
               ( abs ` ( A P B ) ) <_ ( ( N ` A ) x. ( N ` B ) ) ) $=
      cA cX wcel cB cX wcel cA cB cP co cabs cfv cA cN cfv cB cN cfv cmul co
      cle wbr cA cX wcel cA cU cn0v cfv cif cB cP co cabs cfv cA cX wcel cA cU
      cn0v cfv cif cN cfv cB cN cfv cmul co cle wbr cA cX wcel cA cU cn0v cfv
      cif cB cX wcel cB cU cn0v cfv cif cP co cabs cfv cA cX wcel cA cU cn0v
      cfv cif cN cfv cB cX wcel cB cU cn0v cfv cif cN cfv cmul co cle wbr cA cB
      cU cn0v cfv cU cn0v cfv cA cA cX wcel cA cU cn0v cfv cif wceq cA cB cP co
      cabs cfv cA cX wcel cA cU cn0v cfv cif cB cP co cabs cfv cA cN cfv cB cN
      cfv cmul co cA cX wcel cA cU cn0v cfv cif cN cfv cB cN cfv cmul co cle cA
      cA cX wcel cA cU cn0v cfv cif wceq cA cB cP co cA cX wcel cA cU cn0v cfv
      cif cB cP co cabs cA cA cX wcel cA cU cn0v cfv cif cB cP opreq1 fveq2d cA
      cA cX wcel cA cU cn0v cfv cif wceq cA cN cfv cA cX wcel cA cU cn0v cfv
      cif cN cfv cB cN cfv cmul cA cA cX wcel cA cU cn0v cfv cif cN fveq2
      opreq1d breq12d cB cB cX wcel cB cU cn0v cfv cif wceq cA cX wcel cA cU
      cn0v cfv cif cB cP co cabs cfv cA cX wcel cA cU cn0v cfv cif cB cX wcel
      cB cU cn0v cfv cif cP co cabs cfv cA cX wcel cA cU cn0v cfv cif cN cfv cB
      cN cfv cmul co cA cX wcel cA cU cn0v cfv cif cN cfv cB cX wcel cB cU cn0v
      cfv cif cN cfv cmul co cle cB cB cX wcel cB cU cn0v cfv cif wceq cA cX
      wcel cA cU cn0v cfv cif cB cP co cA cX wcel cA cU cn0v cfv cif cB cX wcel
      cB cU cn0v cfv cif cP co cabs cB cB cX wcel cB cU cn0v cfv cif cA cX wcel
      cA cU cn0v cfv cif cP opreq2 fveq2d cB cB cX wcel cB cU cn0v cfv cif wceq
      cB cN cfv cB cX wcel cB cU cn0v cfv cif cN cfv cA cX wcel cA cU cn0v cfv
      cif cN cfv cmul cB cB cX wcel cB cU cn0v cfv cif cN fveq2 opreq2d breq12d
      cA cX wcel cA cU cn0v cfv cif cB cX wcel cB cU cn0v cfv cif cP cU cN cX
      sii.1 sii.6 sii.7 sii.9 cA cU cX cU cn0v cfv sii.1 cU cn0v cfv eqid sii.9
      elimph cB cU cX cU cn0v cfv sii.1 cU cn0v cfv eqid sii.9 elimph siii
      dedth2h $.
      $( [23-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    $d x y H $.  $d x y U $.  $d x y W $.
    sspph.h $e |- H = ( SubSp ` U ) $.
    $( A subspace of an inner product space is an inner product space. $)
    sspph $p |- ( ( U e. CPreHil /\ W e. H ) -> W e. CPreHil ) $=
      cU cphl wcel cW cH wcel wa cW cnv wcel vx cv vy cv cW cpv cfv co cW cnm
      cfv cfv c2 cexp co vx cv vy cv cW cnsb cfv co cW cnm cfv cfv c2 cexp co
      caddc co c2 vx cv cW cnm cfv cfv c2 cexp co vy cv cW cnm cfv cfv c2 cexp
      co caddc co cmul co wceq vy cW cba cfv wral vx cW cba cfv wral wa cW cphl
      wcel cU cphl wcel cW cH wcel wa cW cnv wcel vx cv vy cv cW cpv cfv co cW
      cnm cfv cfv c2 cexp co vx cv vy cv cW cnsb cfv co cW cnm cfv cfv c2 cexp
      co caddc co c2 vx cv cW cnm cfv cfv c2 cexp co vy cv cW cnm cfv cfv c2
      cexp co caddc co cmul co wceq vy cW cba cfv wral vx cW cba cfv wral cU
      cnv wcel cW cH wcel cW cnv wcel cU cphl wcel cU cH cW sspph.h sspnv cU
      phnv sylan cU cphl wcel cW cH wcel wa vx cv vy cv cW cpv cfv co cW cnm
      cfv cfv c2 cexp co vx cv vy cv cW cnsb cfv co cW cnm cfv cfv c2 cexp co
      caddc co c2 vx cv cW cnm cfv cfv c2 cexp co vy cv cW cnm cfv cfv c2 cexp
      co caddc co cmul co wceq vx vy cW cba cfv cW cba cfv cU cphl wcel cW cH
      wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa vx cv vy cv cW cpv
      cfv co cW cnm cfv cfv c2 cexp co vx cv vy cv cW cnsb cfv co cW cnm cfv
      cfv c2 cexp co caddc co c2 vx cv cW cnm cfv cfv c2 cexp co vy cv cW cnm
      cfv cfv c2 cexp co caddc co cmul co wceq cU cphl wcel cW cH wcel wa vx cv
      cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv vy cv cU cpv cfv co cU
      cnm cfv cfv c2 cexp co vx cv vy cv cU cnsb cfv co cU cnm cfv cfv c2 cexp
      co caddc co c2 vx cv cU cnm cfv cfv c2 cexp co vy cv cU cnm cfv cfv c2
      cexp co caddc co cmul co vx cv vy cv cW cpv cfv co cW cnm cfv cfv c2 cexp
      co vx cv vy cv cW cnsb cfv co cW cnm cfv cfv c2 cexp co caddc co c2 vx cv
      cW cnm cfv cfv c2 cexp co vy cv cW cnm cfv cfv c2 cexp co caddc co cmul
      co cU cphl wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel
      wa vx cv cU cba cfv wcel vy cv cU cba cfv wcel wa vx cv vy cv cU cpv cfv
      co cU cnm cfv cfv c2 cexp co vx cv vy cv cU cnsb cfv co cU cnm cfv cfv c2
      cexp co caddc co c2 vx cv cU cnm cfv cfv c2 cexp co vy cv cU cnm cfv cfv
      c2 cexp co caddc co cmul co wceq cU cphl wcel cW cH wcel wa vx cv cW cba
      cfv wcel vy cv cW cba cfv wcel wa vx cv cU cba cfv wcel vy cv cU cba cfv
      wcel wa cU cnv wcel cW cH wcel vx cv cW cba cfv wcel vy cv cW cba cfv
      wcel wa vx cv cU cba cfv wcel vy cv cU cba cfv wcel wa wi cU cphl wcel cU
      cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vx cv cU cba cfv wcel vy cv
      cW cba cfv wcel vy cv cU cba cfv wcel cU cnv wcel cW cH wcel wa cW cba
      cfv cU cba cfv vx cv cU cH cW cU cba cfv cW cba cfv cU cba cfv eqid cW
      cba cfv eqid sspph.h sspba sseld cU cnv wcel cW cH wcel wa cW cba cfv cU
      cba cfv vy cv cU cH cW cU cba cfv cW cba cfv cU cba cfv eqid cW cba cfv
      eqid sspph.h sspba sseld anim12d cU phnv sylan imp cU cphl wcel vx cv cU
      cba cfv wcel vy cv cU cba cfv wcel wa vx cv vy cv cU cpv cfv co cU cnm
      cfv cfv c2 cexp co vx cv vy cv cU cnsb cfv co cU cnm cfv cfv c2 cexp co
      caddc co c2 vx cv cU cnm cfv cfv c2 cexp co vy cv cU cnm cfv cfv c2 cexp
      co caddc co cmul co wceq cW cH wcel cU cphl wcel vx cv cU cba cfv wcel vy
      cv cU cba cfv wcel vx cv vy cv cU cpv cfv co cU cnm cfv cfv c2 cexp co vx
      cv vy cv cU cnsb cfv co cU cnm cfv cfv c2 cexp co caddc co c2 vx cv cU
      cnm cfv cfv c2 cexp co vy cv cU cnm cfv cfv c2 cexp co caddc co cmul co
      wceq vx cv vy cv cU cU cpv cfv cU cnsb cfv cU cnm cfv cU cba cfv cU cba
      cfv eqid cU cpv cfv eqid cU cnsb cfv eqid cU cnm cfv eqid phpar2 3expb
      adantlr syldan cU cnv wcel cW cH wcel vx cv cW cba cfv wcel vy cv cW cba
      cfv wcel wa vx cv vy cv cW cpv cfv co cW cnm cfv cfv c2 cexp co vx cv vy
      cv cW cnsb cfv co cW cnm cfv cfv c2 cexp co caddc co vx cv vy cv cU cpv
      cfv co cU cnm cfv cfv c2 cexp co vx cv vy cv cU cnsb cfv co cU cnm cfv
      cfv c2 cexp co caddc co wceq cU cphl wcel cU cnv wcel cW cH wcel wa vx cv
      cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv vy cv cW cpv cfv co cW
      cnm cfv cfv c2 cexp co vx cv vy cv cU cpv cfv co cU cnm cfv cfv c2 cexp
      co vx cv vy cv cW cnsb cfv co cW cnm cfv cfv c2 cexp co vx cv vy cv cU
      cnsb cfv co cU cnm cfv cfv c2 cexp co caddc cU cnv wcel cW cH wcel wa vx
      cv cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv vy cv cW cpv cfv co
      cW cnm cfv cfv c2 cexp co vx cv vy cv cW cpv cfv co cU cnm cfv cfv c2
      cexp co vx cv vy cv cU cpv cfv co cU cnm cfv cfv c2 cexp co cU cnv wcel
      cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv vy
      cv cW cpv cfv co cW cnm cfv cfv vx cv vy cv cW cpv cfv co cU cnm cfv cfv
      c2 cexp cU cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv
      wcel wa vx cv vy cv cW cpv cfv co cW cba cfv wcel vx cv vy cv cW cpv cfv
      co cW cnm cfv cfv vx cv vy cv cW cpv cfv co cU cnm cfv cfv wceq cW cnv
      wcel vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa vx cv vy cv cW cpv
      cfv co cW cba cfv wcel cU cnv wcel cW cH wcel wa cW cnv wcel vx cv cW cba
      cfv wcel vy cv cW cba cfv wcel vx cv vy cv cW cpv cfv co cW cba cfv wcel
      vx cv vy cv cW cW cpv cfv cW cba cfv cW cba cfv eqid cW cpv cfv eqid
      nvgcl 3expb cU cH cW sspph.h sspnv sylan cU cnv wcel cW cH wcel vx cv vy
      cv cW cpv cfv co cW cba cfv wcel vx cv vy cv cW cpv cfv co cW cnm cfv cfv
      vx cv vy cv cW cpv cfv co cU cnm cfv cfv wceq vx cv vy cv cW cpv cfv co
      cU cH cW cnm cfv cU cnm cfv cW cW cba cfv cW cba cfv eqid cU cnm cfv eqid
      cW cnm cfv eqid sspph.h sspnval 3expa syldan opreq1d cU cnv wcel cW cH
      wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv vy cv cW
      cpv cfv co cU cnm cfv cfv vx cv vy cv cU cpv cfv co cU cnm cfv cfv c2
      cexp cU cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv
      wcel wa wa vx cv vy cv cW cpv cfv co vx cv vy cv cU cpv cfv co cU cnm cfv
      vx cv vy cv cU cW cpv cfv cU cpv cfv cH cW cW cba cfv cW cba cfv eqid cU
      cpv cfv eqid cW cpv cfv eqid sspph.h sspgval fveq2d opreq1d eqtrd cU cnv
      wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx
      cv vy cv cW cnsb cfv co cW cnm cfv cfv vx cv vy cv cU cnsb cfv co cU cnm
      cfv cfv c2 cexp cU cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW
      cba cfv wcel wa wa vx cv vy cv cW cnsb cfv co cW cnm cfv cfv vx cv vy cv
      cW cnsb cfv co cU cnm cfv cfv vx cv vy cv cU cnsb cfv co cU cnm cfv cfv
      cU cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa
      vx cv vy cv cW cnsb cfv co cW cba cfv wcel vx cv vy cv cW cnsb cfv co cW
      cnm cfv cfv vx cv vy cv cW cnsb cfv co cU cnm cfv cfv wceq cW cnv wcel vx
      cv cW cba cfv wcel vy cv cW cba cfv wcel wa vx cv vy cv cW cnsb cfv co cW
      cba cfv wcel cU cnv wcel cW cH wcel wa cW cnv wcel vx cv cW cba cfv wcel
      vy cv cW cba cfv wcel vx cv vy cv cW cnsb cfv co cW cba cfv wcel vx cv vy
      cv cW cW cnsb cfv cW cba cfv cW cba cfv eqid cW cnsb cfv eqid nvmcl 3expb
      cU cH cW sspph.h sspnv sylan cU cnv wcel cW cH wcel vx cv vy cv cW cnsb
      cfv co cW cba cfv wcel vx cv vy cv cW cnsb cfv co cW cnm cfv cfv vx cv vy
      cv cW cnsb cfv co cU cnm cfv cfv wceq vx cv vy cv cW cnsb cfv co cU cH cW
      cnm cfv cU cnm cfv cW cW cba cfv cW cba cfv eqid cU cnm cfv eqid cW cnm
      cfv eqid sspph.h sspnval 3expa syldan cU cnv wcel cW cH wcel wa vx cv cW
      cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv vy cv cW cnsb cfv co vx cv
      vy cv cU cnsb cfv co cU cnm cfv vx cv vy cv cU cH cW cnsb cfv cU cnsb cfv
      cW cW cba cfv cW cba cfv eqid cU cnsb cfv eqid cW cnsb cfv eqid sspph.h
      sspmval fveq2d eqtrd opreq1d opreq12d cU phnv sylanl1 cU cphl wcel cW cH
      wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa wa vx cv cW cnm
      cfv cfv c2 cexp co vy cv cW cnm cfv cfv c2 cexp co caddc co vx cv cU cnm
      cfv cfv c2 cexp co vy cv cU cnm cfv cfv c2 cexp co caddc co c2 cmul cU
      cnv wcel cW cH wcel vx cv cW cba cfv wcel vy cv cW cba cfv wcel wa vx cv
      cW cnm cfv cfv c2 cexp co vy cv cW cnm cfv cfv c2 cexp co caddc co vx cv
      cU cnm cfv cfv c2 cexp co vy cv cU cnm cfv cfv c2 cexp co caddc co wceq
      cU cphl wcel cU cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba
      cfv wcel wa wa vx cv cW cnm cfv cfv c2 cexp co vx cv cU cnm cfv cfv c2
      cexp co vy cv cW cnm cfv cfv c2 cexp co vy cv cU cnm cfv cfv c2 cexp co
      caddc cU cnv wcel cW cH wcel wa vx cv cW cba cfv wcel vy cv cW cba cfv
      wcel wa wa vx cv cW cnm cfv cfv vx cv cU cnm cfv cfv c2 cexp cU cnv wcel
      cW cH wcel wa vx cv cW cba cfv wcel vx cv cW cnm cfv cfv vx cv cU cnm cfv
      cfv wceq vy cv cW cba cfv wcel cU cnv wcel cW cH wcel vx cv cW cba cfv
      wcel vx cv cW cnm cfv cfv vx cv cU cnm cfv cfv wceq vx cv cU cH cW cnm
      cfv cU cnm cfv cW cW cba cfv cW cba cfv eqid cU cnm cfv eqid cW cnm cfv
      eqid sspph.h sspnval 3expa adantrr opreq1d cU cnv wcel cW cH wcel wa vx
      cv cW cba cfv wcel vy cv cW cba cfv wcel wa wa vy cv cW cnm cfv cfv vy cv
      cU cnm cfv cfv c2 cexp cU cnv wcel cW cH wcel wa vy cv cW cba cfv wcel vy
      cv cW cnm cfv cfv vy cv cU cnm cfv cfv wceq vx cv cW cba cfv wcel cU cnv
      wcel cW cH wcel vy cv cW cba cfv wcel vy cv cW cnm cfv cfv vy cv cU cnm
      cfv cfv wceq vy cv cU cH cW cnm cfv cU cnm cfv cW cW cba cfv cW cba cfv
      eqid cU cnm cfv eqid cW cnm cfv eqid sspph.h sspnval 3expa adantrl
      opreq1d opreq12d cU phnv sylanl1 opreq2d 3eqtr4d ex r19.21aivv jca vx vy
      cW cW cpv cfv cW cnsb cfv cW cnm cfv cW cba cfv cW cba cfv eqid cW cpv
      cfv eqid cW cnsb cfv eqid cW cnm cfv eqid isph sylibr $.
      $( [15-Apr-2008] $) $( [1-Feb-2008] $)
  $}

  ${
    $d v w x y z A $.  $d z B $.  $d v w z C $.  $d v w z F $.  $d x y P $.
    $d v w x y z U $.  $d v w x y z X $.
    ipblnfi.1 $e |- X = ( BaseSet ` U ) $.
    ipblnfi.7 $e |- P = ( .i ` U ) $.
    ipblnfi.9 $e |- U e. CPreHil $.
    ipblnfi.c $e |- C = <. <. + , x. >. , abs >. $.
    ipblnfi.l $e |- B = ( U BLnOp C ) $.
    ipblnfi.f $e |- F = { <. x , y >. | ( x e. X /\ y = ( x P A ) ) } $.
    $( A function ` F ` generated by varying the first argument of an inner
       product (with its second argument a fixed vector ` A ` ) is a bounded
       linear functional, i.e. a bounded linear operator from the vector space
       to ` CC ` . $)
    ipblnfi $p |- ( A e. X -> F e. B ) $=
      cF cU cC clno co wcel cA cU cnm cfv cfv cr wcel vz cv cF cfv cabs cfv cA
      cU cnm cfv cfv vz cv cU cnm cfv cfv cmul co cle wbr vz cX wral cF cB wcel
      cA cX wcel vz cA cU cnm cfv cfv cB cF cU cU cC clno co cU cnm cfv cabs cC
      cX ipblnfi.1 cU cnm cfv eqid cC ipblnfi.c cnnvnm cU cC clno co eqid
      ipblnfi.l cU ipblnfi.9 phnvi cC ipblnfi.c cnnv blo3i cA cX wcel cX cc cF
      wf vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cF cfv vz cv cF cfv vw
      cv vv cv cF cfv cmul co caddc co wceq vv cX wral vw cc wral vz cX wral wa
      cF cU cC clno co wcel cA cX wcel cX cc cF wf vz cv vw cv vv cv cU cns cfv
      co cU cpv cfv co cF cfv vz cv cF cfv vw cv vv cv cF cfv cmul co caddc co
      wceq vv cX wral vw cc wral vz cX wral cA cX wcel vx cv cA cP co cc wcel
      vx cX wral cX cc cF wf cA cX wcel vx cv cA cP co cc wcel vx cX vx cv cX
      wcel cA cX wcel vx cv cA cP co cc wcel cU cnv wcel vx cv cX wcel cA cX
      wcel vx cv cA cP co cc wcel cU ipblnfi.9 phnvi vx cv cA cP cU cX
      ipblnfi.1 ipblnfi.7 ipcl mp3an1 ancoms r19.21aiva vx vy cX cc vx cv cA cP
      co cF ipblnfi.f fopab2 sylib cA cX wcel vz cv vw cv vv cv cU cns cfv co
      cU cpv cfv co cF cfv vz cv cF cfv vw cv vv cv cF cfv cmul co caddc co
      wceq vv cX wral vz vw cX cc cA cX wcel vz cv cX wcel vw cv cc wcel wa vz
      cv vw cv vv cv cU cns cfv co cU cpv cfv co cF cfv vz cv cF cfv vw cv vv
      cv cF cfv cmul co caddc co wceq vv cX cA cX wcel vz cv cX wcel vw cv cc
      wcel vv cv cX wcel vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cF cfv
      vz cv cF cfv vw cv vv cv cF cfv cmul co caddc co wceq wi vz cv cX wcel vw
      cv cc wcel vv cv cX wcel cA cX wcel vz cv vw cv vv cv cU cns cfv co cU
      cpv cfv co cF cfv vz cv cF cfv vw cv vv cv cF cfv cmul co caddc co wceq
      vz cv cX wcel vw cv cc wcel vv cv cX wcel cA cX wcel vz cv vw cv vv cv cU
      cns cfv co cU cpv cfv co cF cfv vz cv cF cfv vw cv vv cv cF cfv cmul co
      caddc co wceq vz cv cX wcel vw cv cc wcel vv cv cX wcel wa wa cA cX wcel
      wa vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cA cP co vz cv cA cP co
      vw cv vv cv cU cns cfv co cA cP co caddc co vz cv vw cv vv cv cU cns cfv
      co cU cpv cfv co cF cfv vz cv cF cfv vw cv vv cv cF cfv cmul co caddc co
      vz cv cX wcel vw cv cc wcel vv cv cX wcel wa cA cX wcel vz cv vw cv vv cv
      cU cns cfv co cU cpv cfv co cA cP co vz cv cA cP co vw cv vv cv cU cns
      cfv co cA cP co caddc co wceq vz cv cX wcel vw cv vv cv cU cns cfv co cX
      wcel cA cX wcel vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cA cP co vz
      cv cA cP co vw cv vv cv cU cns cfv co cA cP co caddc co wceq vw cv cc
      wcel vv cv cX wcel wa cU cphl wcel vz cv cX wcel vw cv vv cv cU cns cfv
      co cX wcel cA cX wcel w3a vz cv vw cv vv cv cU cns cfv co cU cpv cfv co
      cA cP co vz cv cA cP co vw cv vv cv cU cns cfv co cA cP co caddc co wceq
      ipblnfi.9 vz cv vw cv vv cv cU cns cfv co cA cP cU cU cpv cfv cX
      ipblnfi.1 cU cpv cfv eqid ipblnfi.7 ipdir mpan cU cnv wcel vw cv cc wcel
      vv cv cX wcel vw cv vv cv cU cns cfv co cX wcel cU ipblnfi.9 phnvi vw cv
      vv cv cU cns cfv cU cX ipblnfi.1 cU cns cfv eqid nvscl mp3an1 syl3an2
      3expa vz cv cX wcel vw cv cc wcel vv cv cX wcel wa wa vz cv vw cv vv cv
      cU cns cfv co cU cpv cfv co cF cfv vz cv vw cv vv cv cU cns cfv co cU cpv
      cfv co cA cP co wceq cA cX wcel vz cv cX wcel vw cv cc wcel vv cv cX wcel
      wa wa vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cX wcel vz cv vw cv
      vv cv cU cns cfv co cU cpv cfv co cF cfv vz cv vw cv vv cv cU cns cfv co
      cU cpv cfv co cA cP co wceq vz cv cX wcel vw cv vv cv cU cns cfv co cX
      wcel vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cX wcel vw cv cc wcel
      vv cv cX wcel wa cU cnv wcel vz cv cX wcel vw cv vv cv cU cns cfv co cX
      wcel vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cX wcel cU ipblnfi.9
      phnvi vz cv vw cv vv cv cU cns cfv co cU cU cpv cfv cX ipblnfi.1 cU cpv
      cfv eqid nvgcl mp3an1 cU cnv wcel vw cv cc wcel vv cv cX wcel vw cv vv cv
      cU cns cfv co cX wcel cU ipblnfi.9 phnvi vw cv vv cv cU cns cfv cU cX
      ipblnfi.1 cU cns cfv eqid nvscl mp3an1 sylan2 vx vy vz cv vw cv vv cv cU
      cns cfv co cU cpv cfv co vx cv cA cP co vz cv vw cv vv cv cU cns cfv co
      cU cpv cfv co cA cP co cX cF vx cv vz cv vw cv vv cv cU cns cfv co cU cpv
      cfv co cA cP opreq1 ipblnfi.f vz cv vw cv vv cv cU cns cfv co cU cpv cfv
      co cA cP oprex fvopab4 syl adantr vz cv cX wcel vw cv cc wcel vv cv cX
      wcel wa wa cA cX wcel wa vz cv cF cfv vz cv cA cP co vw cv vv cv cF cfv
      cmul co vw cv vv cv cU cns cfv co cA cP co caddc vz cv cX wcel vz cv cF
      cfv vz cv cA cP co wceq vw cv cc wcel vv cv cX wcel wa cA cX wcel vx vy
      vz cv vx cv cA cP co vz cv cA cP co cX cF vx cv vz cv cA cP opreq1
      ipblnfi.f vz cv cA cP oprex fvopab4 ad2antrr vz cv cX wcel vw cv cc wcel
      vv cv cX wcel wa wa cA cX wcel wa vw cv vv cv cF cfv cmul co vw cv vv cv
      cA cP co cmul co vw cv vv cv cU cns cfv co cA cP co vw cv cc wcel vv cv
      cX wcel wa vw cv vv cv cF cfv cmul co vw cv vv cv cA cP co cmul co wceq
      vz cv cX wcel cA cX wcel vv cv cX wcel vw cv vv cv cF cfv cmul co vw cv
      vv cv cA cP co cmul co wceq vw cv cc wcel vv cv cX wcel vv cv cF cfv vv
      cv cA cP co vw cv cmul vx vy vv cv vx cv cA cP co vv cv cA cP co cX cF vx
      cv vv cv cA cP opreq1 ipblnfi.f vv cv cA cP oprex fvopab4 opreq2d adantl
      ad2antlr vw cv cc wcel vv cv cX wcel wa cA cX wcel vw cv vv cv cU cns cfv
      co cA cP co vw cv vv cv cA cP co cmul co wceq vz cv cX wcel vw cv cc wcel
      vv cv cX wcel cA cX wcel vw cv vv cv cU cns cfv co cA cP co vw cv vv cv
      cA cP co cmul co wceq vw cv vv cv cA cP cU cns cfv cU cU cpv cfv cX
      ipblnfi.1 cU cpv cfv eqid cU cns cfv eqid ipblnfi.7 ipblnfi.9 ipassi
      3expa adantll eqtr4d opreq12d 3eqtr4d exp42 com4r imp3a r19.21adv
      r19.21aivv jca cU cnv wcel cC cnv wcel cF cU cC clno co wcel cX cc cF wf
      vz cv vw cv vv cv cU cns cfv co cU cpv cfv co cF cfv vz cv cF cfv vw cv
      vv cv cF cfv cmul co caddc co wceq vv cX wral vw cc wral vz cX wral wa wb
      cU ipblnfi.9 phnvi cC ipblnfi.c cnnv vz vw vv cU cns cfv cmul cF cU cU
      cpv cfv caddc cU cC clno co cC cX cc ipblnfi.1 cC ipblnfi.c cnnvba cU cpv
      cfv eqid cC ipblnfi.c cnnvg cU cns cfv eqid cC ipblnfi.c cnnvs cU cC clno
      co eqid islno mp2an sylibr cU cnv wcel cA cX wcel cA cU cnm cfv cfv cr
      wcel cU ipblnfi.9 phnvi cA cU cU cnm cfv cX ipblnfi.1 cU cnm cfv eqid
      nvcl mpan cA cX wcel vz cv cF cfv cabs cfv cA cU cnm cfv cfv vz cv cU cnm
      cfv cfv cmul co cle wbr vz cX cA cX wcel vz cv cX wcel wa vz cv cA cP co
      cabs cfv vz cv cU cnm cfv cfv cA cU cnm cfv cfv cmul co vz cv cF cfv cabs
      cfv cA cU cnm cfv cfv vz cv cU cnm cfv cfv cmul co cle vz cv cX wcel cA
      cX wcel vz cv cA cP co cabs cfv vz cv cU cnm cfv cfv cA cU cnm cfv cfv
      cmul co cle wbr vz cv cA cP cU cU cnm cfv cX ipblnfi.1 cU cnm cfv eqid
      ipblnfi.7 ipblnfi.9 sii ancoms cA cX wcel vz cv cX wcel wa vz cv cF cfv
      vz cv cA cP co cabs vz cv cX wcel vz cv cF cfv vz cv cA cP co wceq cA cX
      wcel vx vy vz cv vx cv cA cP co vz cv cA cP co cX cF vx cv vz cv cA cP
      opreq1 ipblnfi.f vz cv cA cP oprex fvopab4 adantl fveq2d cA cU cnm cfv
      cfv cc wcel vz cv cU cnm cfv cfv cc wcel cA cU cnm cfv cfv vz cv cU cnm
      cfv cfv cmul co vz cv cU cnm cfv cfv cA cU cnm cfv cfv cmul co wceq cA cX
      wcel vz cv cX wcel cA cU cnm cfv cfv vz cv cU cnm cfv cfv mulcom cA cX
      wcel cA cU cnm cfv cfv cU cnv wcel cA cX wcel cA cU cnm cfv cfv cr wcel
      cU ipblnfi.9 phnvi cA cU cU cnm cfv cX ipblnfi.1 cU cnm cfv eqid nvcl
      mpan recnd vz cv cX wcel vz cv cU cnm cfv cfv cU cnv wcel vz cv cX wcel
      vz cv cU cnm cfv cfv cr wcel cU ipblnfi.9 phnvi vz cv cU cU cnm cfv cX
      ipblnfi.1 cU cnm cfv eqid nvcl mpan recnd syl2an 3brtr4d r19.21aiva
      syl3anc $.
      $( [24-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    $d x A $.  $d x B $.  $d s t x P $.  $d s t Q $.  $d x y S $.
    $d s t x y T $.  $d x U $.  $d s t x y X $.  $d s t x y Y $.
    ip2eqi.1 $e |- X = ( BaseSet ` U ) $.
    ip2eqi.7 $e |- P = ( .i ` U ) $.
    ip2eqi.u $e |- U e. CPreHil $.
    $( Two vectors are equal iff their inner products with all other vectors
       are equal. $)
    ip2eqi $p |- ( ( A e. X /\ B e. X ) -> ( A. x e. X ( x P A
                                               ) = ( x P B ) <-> A = B ) ) $=
      cA cX wcel cB cX wcel wa vx cv cA cP co vx cv cB cP co wceq vx cX wral cA
      cB wceq cA cX wcel cB cX wcel wa vx cv cA cP co vx cv cB cP co wceq vx cX
      wral cA cB cU cnsb cfv co cA cP co cA cB cU cnsb cfv co cB cP co wceq cA
      cB wceq cA cX wcel cB cX wcel wa cA cB cU cnsb cfv co cX wcel vx cv cA cP
      co vx cv cB cP co wceq vx cX wral cA cB cU cnsb cfv co cA cP co cA cB cU
      cnsb cfv co cB cP co wceq wi cU cnv wcel cA cX wcel cB cX wcel cA cB cU
      cnsb cfv co cX wcel cU ip2eqi.u phnvi cA cB cU cU cnsb cfv cX ip2eqi.1 cU
      cnsb cfv eqid nvmcl mp3an1 vx cv cA cP co vx cv cB cP co wceq cA cB cU
      cnsb cfv co cA cP co cA cB cU cnsb cfv co cB cP co wceq vx cA cB cU cnsb
      cfv co cX vx cv cA cB cU cnsb cfv co wceq vx cv cA cP co cA cB cU cnsb
      cfv co cA cP co vx cv cB cP co cA cB cU cnsb cfv co cB cP co vx cv cA cB
      cU cnsb cfv co cA cP opreq1 vx cv cA cB cU cnsb cfv co cB cP opreq1
      eqeq12d rcla4v syl cA cX wcel cB cX wcel wa cA cB cU cnsb cfv co cA cP co
      cA cB cU cnsb cfv co cB cP co cmin co cc0 wceq cA cB cU cnsb cfv co cU
      cn0v cfv wceq cA cB cU cnsb cfv co cA cP co cA cB cU cnsb cfv co cB cP co
      wceq cA cB wceq cA cX wcel cB cX wcel wa cA cB cU cnsb cfv co cA cB cU
      cnsb cfv co cP co cc0 wceq cA cB cU cnsb cfv co cA cP co cA cB cU cnsb
      cfv co cB cP co cmin co cc0 wceq cA cB cU cnsb cfv co cU cn0v cfv wceq cA
      cX wcel cB cX wcel wa cA cB cU cnsb cfv co cA cB cU cnsb cfv co cP co cA
      cB cU cnsb cfv co cA cP co cA cB cU cnsb cfv co cB cP co cmin co cc0 cA
      cB cU cnsb cfv co cX wcel cA cX wcel cB cX wcel cA cB cU cnsb cfv co cA
      cB cU cnsb cfv co cP co cA cB cU cnsb cfv co cA cP co cA cB cU cnsb cfv
      co cB cP co cmin co wceq cA cX wcel cB cX wcel wa cU cphl wcel cA cB cU
      cnsb cfv co cX wcel cA cX wcel cB cX wcel w3a cA cB cU cnsb cfv co cA cB
      cU cnsb cfv co cP co cA cB cU cnsb cfv co cA cP co cA cB cU cnsb cfv co
      cB cP co cmin co wceq ip2eqi.u cA cB cU cnsb cfv co cA cB cP cU cU cnsb
      cfv cX ip2eqi.1 cU cnsb cfv eqid ip2eqi.7 ipsubdi mpan cU cnv wcel cA cX
      wcel cB cX wcel cA cB cU cnsb cfv co cX wcel cU ip2eqi.u phnvi cA cB cU
      cU cnsb cfv cX ip2eqi.1 cU cnsb cfv eqid nvmcl mp3an1 cA cX wcel cB cX
      wcel pm3.26 cA cX wcel cB cX wcel pm3.27 syl3anc eqeq1d cA cX wcel cB cX
      wcel wa cA cB cU cnsb cfv co cX wcel cA cB cU cnsb cfv co cA cB cU cnsb
      cfv co cP co cc0 wceq cA cB cU cnsb cfv co cU cn0v cfv wceq wb cU cnv
      wcel cA cX wcel cB cX wcel cA cB cU cnsb cfv co cX wcel cU ip2eqi.u phnvi
      cA cB cU cU cnsb cfv cX ip2eqi.1 cU cnsb cfv eqid nvmcl mp3an1 cU cnv
      wcel cA cB cU cnsb cfv co cX wcel cA cB cU cnsb cfv co cA cB cU cnsb cfv
      co cP co cc0 wceq cA cB cU cnsb cfv co cU cn0v cfv wceq wb cU ip2eqi.u
      phnvi cA cB cU cnsb cfv co cP cU cX cU cn0v cfv ip2eqi.1 cU cn0v cfv eqid
      ip2eqi.7 ipz mpan syl bitr3d cA cB cU cnsb cfv co cA cP co cc wcel cA cB
      cU cnsb cfv co cB cP co cc wcel cA cB cU cnsb cfv co cA cP co cA cB cU
      cnsb cfv co cB cP co cmin co cc0 wceq cA cB cU cnsb cfv co cA cP co cA cB
      cU cnsb cfv co cB cP co wceq wb cA cX wcel cB cX wcel wa cA cB cU cnsb
      cfv co cA cP co cA cB cU cnsb cfv co cB cP co subeq0 cA cB cU cnsb cfv co
      cX wcel cA cX wcel cA cB cU cnsb cfv co cA cP co cc wcel cA cX wcel cB cX
      wcel wa cU cnv wcel cA cB cU cnsb cfv co cX wcel cA cX wcel cA cB cU cnsb
      cfv co cA cP co cc wcel cU ip2eqi.u phnvi cA cB cU cnsb cfv co cA cP cU
      cX ip2eqi.1 ip2eqi.7 ipcl mp3an1 cU cnv wcel cA cX wcel cB cX wcel cA cB
      cU cnsb cfv co cX wcel cU ip2eqi.u phnvi cA cB cU cU cnsb cfv cX ip2eqi.1
      cU cnsb cfv eqid nvmcl mp3an1 cA cX wcel cB cX wcel pm3.26 sylanc cA cX
      wcel cB cX wcel cA cB cU cnsb cfv co cX wcel cA cB cU cnsb cfv co cB cP
      co cc wcel cU cnv wcel cA cX wcel cB cX wcel cA cB cU cnsb cfv co cX wcel
      cU ip2eqi.u phnvi cA cB cU cU cnsb cfv cX ip2eqi.1 cU cnsb cfv eqid nvmcl
      mp3an1 cU cnv wcel cA cB cU cnsb cfv co cX wcel cB cX wcel cA cB cU cnsb
      cfv co cB cP co cc wcel cU ip2eqi.u phnvi cA cB cU cnsb cfv co cB cP cU
      cX ip2eqi.1 ip2eqi.7 ipcl mp3an1 sylancom sylanc cU cnv wcel cA cX wcel
      cB cX wcel cA cB cU cnsb cfv co cU cn0v cfv wceq cA cB wceq wb cU
      ip2eqi.u phnvi cA cB cU cU cnsb cfv cX cU cn0v cfv ip2eqi.1 cU cnsb cfv
      eqid cU cn0v cfv eqid nvmeq0 mp3an1 3bitr3d sylibd cA cB wceq vx cv cA cP
      co vx cv cB cP co wceq vx cX cA cB wceq vx cv cA cP co vx cv cB cP co
      wceq vx cv cX wcel cA cB vx cv cP opreq2 a1d r19.21aiv impbid1 $.
      $( [5-Feb-2008] $) $( [24-Jan-2008] $)

    $( A condition implying that two operators are equal. $)
    phoeqi $p |- ( ( S : Y --> X /\ T : Y --> X ) -> ( A. x e. X A. y e.
      Y ( x P ( S ` y ) ) = ( x P ( T ` y ) ) <-> S = T ) ) $=
      cY cX cS wf cY cX cT wf wa vx cv vy cv cS cfv cP co vx cv vy cv cT cfv cP
      co wceq vx cX wral vy cY wral cS cT wceq vx cv vy cv cS cfv cP co vx cv
      vy cv cT cfv cP co wceq vy cY wral vx cX wral cY cX cS wf cY cX cT wf wa
      vx cv vy cv cS cfv cP co vx cv vy cv cT cfv cP co wceq vx cX wral vy cY
      wral vy cv cS cfv vy cv cT cfv wceq vy cY wral cS cT wceq cY cX cS wf cY
      cX cT wf wa vx cv vy cv cS cfv cP co vx cv vy cv cT cfv cP co wceq vx cX
      wral vy cv cS cfv vy cv cT cfv wceq vy cY cY cX cS wf cY cX cT wf vy cv
      cY wcel vx cv vy cv cS cfv cP co vx cv vy cv cT cfv cP co wceq vx cX wral
      vy cv cS cfv vy cv cT cfv wceq wb vy cv cS cfv cX wcel vy cv cT cfv cX
      wcel vx cv vy cv cS cfv cP co vx cv vy cv cT cfv cP co wceq vx cX wral vy
      cv cS cfv vy cv cT cfv wceq wb cY cX cS wf vy cv cY wcel wa cY cX cT wf
      vy cv cY wcel wa vx vy cv cS cfv vy cv cT cfv cP cU cX ip2eqi.1 ip2eqi.7
      ip2eqi.u ip2eqi cY cX vy cv cS ffvelrn cY cX vy cv cT ffvelrn syl2an
      anandirs ralbidva cS cY wfn cT cY wfn cS cT wceq vy cv cS cfv vy cv cT
      cfv wceq vy cY wral wb cY cX cS wf cY cX cT wf vy cY cS cT eqfnfv2 cY cX
      cS ffn cY cX cT ffn syl2an bitr4d vx cv vy cv cS cfv cP co vx cv vy cv cT
      cfv cP co wceq vx vy cX cY ralcom syl5bb $.
      $( [6-Feb-2008] $) $( [25-Jan-2008] $)

    $( Every operator has at most one adjoint. $)
    ajmoi $p |- E* s ( s : Y --> X /\
           A. x e. X A. y e. Y ( ( T ` x ) Q y ) = ( x P ( s ` y ) ) ) $=
      cY cX vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq
      vy cY wral vx cX wral wa vs wmo cY cX vs cv wf vx cv cT cfv vy cv cQ co
      vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral wa cY cX vt cv wf
      vx cv cT cfv vy cv cQ co vx cv vy cv vt cv cfv cP co wceq vy cY wral vx
      cX wral wa wa vs cv vt cv wceq wi vt wal vs wal cY cX vs cv wf vx cv cT
      cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral wa
      cY cX vt cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vt cv cfv cP co wceq
      vy cY wral vx cX wral wa wa vs cv vt cv wceq wi vs vt cY cX vs cv wf cY
      cX vt cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy
      cY wral vx cX wral vx cv cT cfv vy cv cQ co vx cv vy cv vt cv cfv cP co
      wceq vy cY wral vx cX wral vs cv vt cv wceq cY cX vs cv wf cY cX vt cv wf
      wa vx cv vy cv vs cv cfv cP co vx cv vy cv vt cv cfv cP co wceq vy cY
      wral vx cX wral vs cv vt cv wceq vx cv cT cfv vy cv cQ co vx cv vy cv vs
      cv cfv cP co wceq vy cY wral vx cX wral vx cv cT cfv vy cv cQ co vx cv vy
      cv vt cv cfv cP co wceq vy cY wral vx cX wral wa cY cX vs cv wf cY cX vt
      cv wf wa vx cv vy cv vs cv cfv cP co vx cv vy cv vt cv cfv cP co wceq vy
      cY wral vx cX wral vs cv vt cv wceq vx vy cP vs cv vt cv cU cX cY
      ip2eqi.1 ip2eqi.7 ip2eqi.u phoeqi biimpa vx cv cT cfv vy cv cQ co vx cv
      vy cv vs cv cfv cP co wceq vy cY wral vx cX wral vx cv cT cfv vy cv cQ co
      vx cv vy cv vt cv cfv cP co wceq vy cY wral vx cX wral wa vx cv cT cfv vy
      cv cQ co vx cv vy cv vs cv cfv cP co wceq vx cv cT cfv vy cv cQ co vx cv
      vy cv vt cv cfv cP co wceq wa vy cY wral vx cX wral vx cv vy cv vs cv cfv
      cP co vx cv vy cv vt cv cfv cP co wceq vy cY wral vx cX wral vx cv cT cfv
      vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vx cv cT cfv vy cv cQ co vx
      cv vy cv vt cv cfv cP co wceq vx vy cX cY r19.26-2 vx cv cT cfv vy cv cQ
      co vx cv vy cv vs cv cfv cP co wceq vx cv cT cfv vy cv cQ co vx cv vy cv
      vt cv cfv cP co wceq wa vy cY wral vx cv vy cv vs cv cfv cP co vx cv vy
      cv vt cv cfv cP co wceq vy cY wral vx cX vx cv cT cfv vy cv cQ co vx cv
      vy cv vs cv cfv cP co wceq vx cv cT cfv vy cv cQ co vx cv vy cv vt cv cfv
      cP co wceq wa vx cv vy cv vs cv cfv cP co vx cv vy cv vt cv cfv cP co
      wceq vy cY vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co vx cv vy
      cv vt cv cfv cP co eqtr2 r19.20si r19.20si sylbir sylan2 an4s gen2 cY cX
      vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY
      wral vx cX wral wa cY cX vt cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vt
      cv cfv cP co wceq vy cY wral vx cX wral wa vs vt vs cv vt cv wceq cY cX
      vs cv wf cY cX vt cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP
      co wceq vy cY wral vx cX wral vx cv cT cfv vy cv cQ co vx cv vy cv vt cv
      cfv cP co wceq vy cY wral vx cX wral cY cX vs cv vt cv feq1 vs cv vt cv
      wceq vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vx cv cT
      cfv vy cv cQ co vx cv vy cv vt cv cfv cP co wceq vx vy cX cY vs cv vt cv
      wceq vx cv vy cv vs cv cfv cP co vx cv vy cv vt cv cfv cP co vx cv cT cfv
      vy cv cQ co vs cv vt cv wceq vy cv vs cv cfv vy cv vt cv cfv vx cv cP vy
      cv vs cv vt cv fveq1 opreq2d eqeq2d 2ralbidv anbi12d mo4 mpbir $.
      $( [7-Feb-2008] $) $( [25-Jan-2008] $)
  $}

  ${
    $d s t x y U $.  $d s t x y W $.
    ajfuni.5 $e |- A = ( U adj W ) $.
    ajfuni.u $e |- U e. CPreHil $.
    ajfuni.w $e |- W e. NrmCVec $.
    $( The adjoint function is a function. $)
    ajfuni $p |- Fun A $=
      cA wfun cU cba cfv cW cba cfv vt cv wf cW cba cfv cU cba cfv vs cv wf vx
      cv vt cv cfv vy cv cW cip cfv co vx cv vy cv vs cv cfv cU cip cfv co wceq
      vy cW cba cfv wral vx cU cba cfv wral w3a vt vs copab wfun cU cba cfv cW
      cba cfv vt cv wf cW cba cfv cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW
      cip cfv co vx cv vy cv vs cv cfv cU cip cfv co wceq vy cW cba cfv wral vx
      cU cba cfv wral w3a vt vs copab wfun cU cba cfv cW cba cfv vt cv wf cW
      cba cfv cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv co vx cv vy
      cv vs cv cfv cU cip cfv co wceq vy cW cba cfv wral vx cU cba cfv wral w3a
      vs wmo vt cU cba cfv cW cba cfv vt cv wf cW cba cfv cU cba cfv vs cv wf
      vx cv vt cv cfv vy cv cW cip cfv co vx cv vy cv vs cv cfv cU cip cfv co
      wceq vy cW cba cfv wral vx cU cba cfv wral w3a vt vs funopab cW cba cfv
      cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv co vx cv vy cv vs cv
      cfv cU cip cfv co wceq vy cW cba cfv wral vx cU cba cfv wral wa vs wmo cU
      cba cfv cW cba cfv vt cv wf cW cba cfv cU cba cfv vs cv wf vx cv vt cv
      cfv vy cv cW cip cfv co vx cv vy cv vs cv cfv cU cip cfv co wceq vy cW
      cba cfv wral vx cU cba cfv wral w3a vs wmo vx vy cU cip cfv cW cip cfv vt
      cv cU cU cba cfv cW cba cfv vs cU cba cfv eqid cU cip cfv eqid ajfuni.u
      ajmoi cU cba cfv cW cba cfv vt cv wf cW cba cfv cU cba cfv vs cv wf vx cv
      vt cv cfv vy cv cW cip cfv co vx cv vy cv vs cv cfv cU cip cfv co wceq vy
      cW cba cfv wral vx cU cba cfv wral w3a cW cba cfv cU cba cfv vs cv wf vx
      cv vt cv cfv vy cv cW cip cfv co vx cv vy cv vs cv cfv cU cip cfv co wceq
      vy cW cba cfv wral vx cU cba cfv wral wa vs cU cba cfv cW cba cfv vt cv
      wf cW cba cfv cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv co vx
      cv vy cv vs cv cfv cU cip cfv co wceq vy cW cba cfv wral vx cU cba cfv
      wral 3simpc immoi ax-mp mpgbir cA cU cba cfv cW cba cfv vt cv wf cW cba
      cfv cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv co vx cv vy cv
      vs cv cfv cU cip cfv co wceq vy cW cba cfv wral vx cU cba cfv wral w3a vt
      vs copab wceq cA wfun cU cba cfv cW cba cfv vt cv wf cW cba cfv cU cba
      cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv co vx cv vy cv vs cv cfv cU
      cip cfv co wceq vy cW cba cfv wral vx cU cba cfv wral w3a vt vs copab
      wfun wb cU cnv wcel cW cnv wcel cA cU cba cfv cW cba cfv vt cv wf cW cba
      cfv cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv co vx cv vy cv
      vs cv cfv cU cip cfv co wceq vy cW cba cfv wral vx cU cba cfv wral w3a vt
      vs copab wceq cU ajfuni.u phnvi ajfuni.w vx vy vt cA cU cip cfv cW cip
      cfv cU cW cU cba cfv cW cba cfv vs cU cba cfv eqid cW cba cfv eqid cU cip
      cfv eqid cW cip cfv eqid ajfuni.5 ajfval mp2an cA cU cba cfv cW cba cfv
      vt cv wf cW cba cfv cU cba cfv vs cv wf vx cv vt cv cfv vy cv cW cip cfv
      co vx cv vy cv vs cv cfv cU cip cfv co wceq vy cW cba cfv wral vx cU cba
      cfv wral w3a vt vs copab funeq ax-mp mpbir $.
      $( [8-Feb-2008] $) $( [25-Jan-2008] $)
  $}

  ${
    ajfun.5 $e |- A = ( U adj W ) $.
    $( The adjoint function is a function.  This is not immediately apparent
       from ~ df-aj but results from the uniqueness shown by ~ ajmoi . $)
    ajfun $p |- ( ( U e. CPreHil /\ W e. NrmCVec ) -> Fun A ) $=
      cU cphl wcel cW cnv wcel cA wfun cU cphl wcel cU caddc cmul cop cabs cop
      cif cW caj co wfun cU cphl wcel cU caddc cmul cop cabs cop cif cW cnv
      wcel cW caddc cmul cop cabs cop cif caj co wfun cU cW caddc cmul cop cabs
      cop caddc cmul cop cabs cop cU cU cphl wcel cU caddc cmul cop cabs cop
      cif wceq cA cU cphl wcel cU caddc cmul cop cabs cop cif cW caj co wceq cA
      wfun cU cphl wcel cU caddc cmul cop cabs cop cif cW caj co wfun wb cU cU
      cphl wcel cU caddc cmul cop cabs cop cif wceq cU cW caj co cU cphl wcel
      cU caddc cmul cop cabs cop cif cW caj co cA cU cU cphl wcel cU caddc cmul
      cop cabs cop cif cW caj opreq1 ajfun.5 syl5eq cA cU cphl wcel cU caddc
      cmul cop cabs cop cif cW caj co funeq syl cW cW cnv wcel cW caddc cmul
      cop cabs cop cif wceq cU cphl wcel cU caddc cmul cop cabs cop cif cW caj
      co cU cphl wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul
      cop cabs cop cif caj co wceq cU cphl wcel cU caddc cmul cop cabs cop cif
      cW caj co wfun cU cphl wcel cU caddc cmul cop cabs cop cif cW cnv wcel cW
      caddc cmul cop cabs cop cif caj co wfun wb cW cW cnv wcel cW caddc cmul
      cop cabs cop cif cU cphl wcel cU caddc cmul cop cabs cop cif caj opreq2
      cU cphl wcel cU caddc cmul cop cabs cop cif cW caj co cU cphl wcel cU
      caddc cmul cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs cop cif
      caj co funeq syl cU cphl wcel cU caddc cmul cop cabs cop cif cW cnv wcel
      cW caddc cmul cop cabs cop cif caj co cU cphl wcel cU caddc cmul cop cabs
      cop cif cW cnv wcel cW caddc cmul cop cabs cop cif cU cphl wcel cU caddc
      cmul cop cabs cop cif cW cnv wcel cW caddc cmul cop cabs cop cif caj co
      eqid cU elimphu cW elimnvu ajfuni dedth2h $.
      $( [14-Feb-2008] $) $( [26-Jan-2008] $)
  $}

  ${
    $d t P $.  $d t Q $.  $d s t x y T $.  $d s t x y U $.  $d s t x y W $.
    $d s t x y X $.  $d s t y Y $.
    ajval.1 $e |- X = ( BaseSet ` U ) $.
    ajval.2 $e |- Y = ( BaseSet ` W ) $.
    ajval.3 $e |- P = ( .i ` U ) $.
    ajval.4 $e |- Q = ( .i ` W ) $.
    ajval.5 $e |- A = ( U adj W ) $.
    $( Value of the adjoint function. $)
    ajval $p |- ( ( U e. CPreHil /\ W e. NrmCVec /\ T : X --> Y ) ->
       ( A ` T ) = U. { s | ( s : Y --> X /\
          A. x e. X A. y e. Y ( ( T ` x ) Q y ) = ( x P ( s ` y ) ) ) } ) $=
      cU cphl wcel cW cnv wcel cX cY cT wf w3a cT cA cfv cT cX cY vt cv wf cY
      cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq
      vy cY wral vx cX wral w3a vt vs copab cfv cX cY cT wf cY cX vs cv wf vx
      cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX
      wral w3a vs cab cuni cY cX vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv
      vs cv cfv cP co wceq vy cY wral vx cX wral wa vs cab cuni cU cphl wcel cW
      cnv wcel cT cA cfv cT cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv
      cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs
      copab cfv wceq cX cY cT wf cU cphl wcel cW cnv wcel wa cT cA cX cY vt cv
      wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co
      wceq vy cY wral vx cX wral w3a vt vs copab cU cnv wcel cW cnv wcel cA cX
      cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv
      cfv cP co wceq vy cY wral vx cX wral w3a vt vs copab wceq cU cphl wcel vx
      vy vt cA cP cQ cU cW cX cY vs ajval.1 ajval.2 ajval.3 ajval.4 ajval.5
      ajfval cU phnv sylan fveq1d 3adant3 cU cphl wcel cW cnv wcel cX cY cT wf
      cT cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv
      vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs copab cfv cX cY cT
      wf cY cX vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co
      wceq vy cY wral vx cX wral w3a vs cab cuni wceq cX cY vt cv wf cY cX vs
      cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY
      wral vx cX wral w3a vt vs copab wfun cT cvv wcel cT cX cY vt cv wf cY cX
      vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy
      cY wral vx cX wral w3a vt vs copab cfv cX cY cT wf cY cX vs cv wf vx cv
      cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral
      w3a vs cab cuni wceq cU cphl wcel cW cnv wcel wa cX cY cT wf cX cY vt cv
      wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co
      wceq vy cY wral vx cX wral w3a cX cY cT wf cY cX vs cv wf vx cv cT cfv vy
      cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs
      cT cvv cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy
      cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs copab cX cY vt cv
      wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co
      wceq vy cY wral vx cX wral w3a vt vs copab eqid vt cv cT wceq cX cY vt cv
      wf cX cY cT wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co
      wceq vy cY wral vx cX wral vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv
      cP co wceq vy cY wral vx cX wral cY cX vs cv wf cX cY vt cv cT feq1 vt cv
      cT wceq vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vx
      cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vx vy cX cY vt cv
      cT wceq vx cv vt cv cfv vy cv cQ co vx cv cT cfv vy cv cQ co vx cv vy cv
      vs cv cfv cP co vt cv cT wceq vx cv vt cv cfv vx cv cT cfv vy cv cQ vx cv
      vt cv cT fveq1 opreq1d eqeq1d 2ralbidv 3anbi13d fvopab5 cU cphl wcel cW
      cnv wcel wa cA wfun cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv
      cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs
      copab wfun cA cU cW ajval.5 ajfun cU cphl wcel cW cnv wcel wa cA cX cY vt
      cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP
      co wceq vy cY wral vx cX wral w3a vt vs copab wceq cA wfun cX cY vt cv wf
      cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co
      wceq vy cY wral vx cX wral w3a vt vs copab wfun wb cU cnv wcel cW cnv
      wcel cA cX cY vt cv wf cY cX vs cv wf vx cv vt cv cfv vy cv cQ co vx cv
      vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a vt vs copab wceq cU
      cphl wcel vx vy vt cA cP cQ cU cW cX cY vs ajval.1 ajval.2 ajval.3
      ajval.4 ajval.5 ajfval cU phnv sylan cA cX cY vt cv wf cY cX vs cv wf vx
      cv vt cv cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx
      cX wral w3a vt vs copab funeq syl mpbid cX cY cT wf cX cvv wcel cT cvv
      wcel cX cU cba cfv cvv ajval.1 cU cba fvex eqeltri cX cY cvv cT fex mpan2
      syl2an 3impa cX cY cT wf cU cphl wcel cX cY cT wf cY cX vs cv wf vx cv cT
      cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral
      w3a vs cab cuni cY cX vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv
      cfv cP co wceq vy cY wral vx cX wral wa vs cab cuni wceq cW cnv wcel cX
      cY cT wf cX cY cT wf cY cX vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv
      vs cv cfv cP co wceq vy cY wral vx cX wral w3a vs cab cY cX vs cv wf vx
      cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX
      wral wa vs cab cX cY cT wf cX cY cT wf cY cX vs cv wf vx cv cT cfv vy cv
      cQ co vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a cY cX vs
      cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy cY
      wral vx cX wral wa vs cX cY cT wf cY cX vs cv wf vx cv cT cfv vy cv cQ co
      vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral w3a cX cY cT wf cY
      cX vs cv wf vx cv cT cfv vy cv cQ co vx cv vy cv vs cv cfv cP co wceq vy
      cY wral vx cX wral wa cX cY cT wf cY cX vs cv wf vx cv cT cfv vy cv cQ co
      vx cv vy cv vs cv cfv cP co wceq vy cY wral vx cX wral 3anass baib abbidv
      unieqd 3ad2ant3 3eqtrd $.
      $( [18-May-2009] $) $( [25-Jan-2008] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Complex Banach spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CBan $.

  $( Extend class notation with the class of all complex Banach spaces. $)
  cbn $a class CBan $.

  $( Define the class of all complex Banach spaces. $)
  df-bn $a |- CBan = { u e. NrmCVec | ( IndMet ` u ) e. CMet } $.

  ${
    $d u U $.  $d u D $.
    isbn.8 $e |- D = ( IndMet ` U ) $.
    $( A complex Banach space is a normed complex vector space with a complete
       induced metric. $)
    isbn $p |- ( U e. CBan <-> ( U e. NrmCVec /\ D e. CMet ) ) $=
      vu cv cims cfv cms wcel cD cms wcel vu cU cnv cbn vu cv cU wceq vu cv
      cims cfv cD cms vu cv cU wceq vu cv cims cfv cU cims cfv cD vu cv cU cims
      fveq2 isbn.8 syl6eqr eleq1d vu df-bn elrab2 $.
      $( [8-Sep-2007] $) $( [5-Dec-2006] $)

    $( The induced metric on complex Banach space is complete. $)
    bncms $p |- ( U e. CBan -> D e. CMet ) $=
      cU cbn wcel cU cnv wcel cD cms wcel cD cU isbn.8 isbn pm3.27bi $.
      $( [12-Dec-2007] $) $( [8-Sep-2007] $)
  $}

  $( Every complex Banach space is a normed complex vector space. $)
  bnnv $p |- ( U e. CBan -> U e. NrmCVec ) $=
    cU cbn wcel cU cnv wcel cU cims cfv cms wcel cU cims cfv cU cU cims cfv
    eqid isbn pm3.26bi $.
    $( [7-Sep-2007] $) $( [17-Mar-2007] $)

  $( The class of all complex Banach spaces is a relation. $)
  bnrel $p |- Rel CBan $=
    cbn cnv wss cnv wrel cbn wrel vx cbn cnv vx cv bnnv ssriv nvrel cbn cnv
    relss mp2 $.
    $( [12-Feb-2008] $) $( [17-Mar-2007] $)

  ${
    bnsscmcl.x $e |- X = ( BaseSet ` U ) $.
    bnsscmcl.d $e |- D = ( IndMet ` U ) $.
    bnsscmcl.j $e |- J = ( Open ` D ) $.
    bnsscmcl.h $e |- H = ( SubSp ` U ) $.
    bnsscmcl.y $e |- Y = ( BaseSet ` W ) $.
    $( A subspace of a Banach space is a Banach space iff it is closed in
       the norm-induced metric of the parent space. $)
    bnsscmcl $p |- ( ( U e. CBan /\ W e. H ) -> ( W e. CBan <->
                Y e. ( Clsd ` J ) ) ) $=
      cU cbn wcel cW cH wcel wa cW cbn wcel cW cims cfv cms wcel cD cY cY cxp
      cres cms wcel cY cJ ccld cfv wcel cU cbn wcel cW cH wcel wa cW cnv wcel
      cW cbn wcel cW cims cfv cms wcel wb cU cnv wcel cW cH wcel cW cnv wcel cU
      cbn wcel cU cH cW bnsscmcl.h sspnv cU bnnv sylan cW cbn wcel cW cnv wcel
      cW cims cfv cms wcel cW cims cfv cW cW cims cfv eqid isbn baib syl cU cbn
      wcel cW cH wcel wa cW cims cfv cD cY cY cxp cres cms cU cnv wcel cW cH
      wcel cW cims cfv cD cY cY cxp cres wceq cU cbn wcel cW cims cfv cD cU cH
      cW cY bnsscmcl.y bnsscmcl.d cW cims cfv eqid bnsscmcl.h sspims cU bnnv
      sylan eleq1d cD cms wcel cY cD cdm cdm wss cD cY cY cxp cres cms wcel cY
      cJ ccld cfv wcel wb cU cbn wcel cW cH wcel wa cD cJ cD cdm cdm cY cD cdm
      cdm eqid bnsscmcl.j cmsss cU cbn wcel cD cms wcel cW cH wcel cD cU
      bnsscmcl.d bncms adantr cU cnv wcel cW cH wcel cY cD cdm cdm wss cU cbn
      wcel cU cnv wcel cW cH wcel wa cY cX cD cdm cdm cU cH cW cX cY bnsscmcl.x
      bnsscmcl.y bnsscmcl.h sspba cU cnv wcel cX cD cdm cdm wceq cW cH wcel cD
      cU cX bnsscmcl.x bnsscmcl.d imsba adantr sseqtrd cU bnnv sylan sylanc
      3bitrd $.
      $( [20-May-2009] $) $( [1-Feb-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of complex Banach spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    cnbn.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is a complex Banach space.  (Contributed by
       Steve Rodriguez, 4-Jan-2007.) $)
    cnbn $p |- U e. CBan $=
      cU cbn wcel cU cnv wcel caddc cmul cop cabs cop cims cfv cms wcel caddc
      cmul cop cabs cop cims cfv cU cU cims cfv caddc cmul cop cabs cop cims
      cfv cU caddc cmul cop cabs cop cims cnbn.6 fveq2i eqcomi isbn cU cnbn.6
      cnnv caddc cmul cop cabs cop cims cfv cabs cmin ccom caddc cmul cop cabs
      cop cims cfv cabs cmin ccom caddc cmul cop cabs cop caddc cmul cop cabs
      cop eqid cabs cmin ccom eqid cnims eqcomi cncms mpbir2an $.
      $( [12-Feb-2008] $) $( [28-Apr-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Uniform Boundedness Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d p A $.  $d h j m n y z N $.  $d h n z P $.  $d h j m n y z T $.
    $d j p y z X $.  $d h j k m n p y z $.
    ubthlem1.1 $e |- X = ( BaseSet ` U ) $.
    ubthlem1.11 $e |- A = { <. j , y >. | ( j e. NN /\ y = { z e. X |
       A. h e. NN ( N ` ( ( T ` h ) ` z ) ) <_ j } ) } $.
    $( Lemma for ~ ubthi .  Membership in ` A `` k ` , the set of all vectors
        ` ( T `` n ) `` z ` whose norm is less than ` k ` . $)
    ubthlem1 $p |- ( k e. NN -> ( P e. ( A ` k ) <-> ( P e. X /\
       A. n e. NN ( N ` ( ( T ` n ) ` P ) ) <_ k ) ) ) $=
      vk cv cn wcel cP vk cv cA cfv wcel cP cX wcel cP vh cv cT cfv cfv cN cfv
      vk cv cle wbr vh cn wral wa cP cX wcel cP vn cv cT cfv cfv cN cfv vk cv
      cle wbr vn cn wral wa vk cv cn wcel cP vk cv cA cfv wcel cP vz cv vh cv
      cT cfv cfv cN cfv vk cv cle wbr vh cn wral vz cX crab wcel cP cX wcel cP
      vh cv cT cfv cfv cN cfv vk cv cle wbr vh cn wral wa vk cv cn wcel vk cv
      cA cfv vz cv vh cv cT cfv cfv cN cfv vk cv cle wbr vh cn wral vz cX crab
      cP vj vy vk cv vz cv vh cv cT cfv cfv cN cfv vj cv cle wbr vh cn wral vz
      cX crab vz cv vh cv cT cfv cfv cN cfv vk cv cle wbr vh cn wral vz cX crab
      cn cA vj cv vk cv wceq vz cv vh cv cT cfv cfv cN cfv vj cv cle wbr vh cn
      wral vz cv vh cv cT cfv cfv cN cfv vk cv cle wbr vh cn wral vz cX vj cv
      vk cv wceq vz cv vh cv cT cfv cfv cN cfv vj cv cle wbr vz cv vh cv cT cfv
      cfv cN cfv vk cv cle wbr vh cn vj cv vk cv vz cv vh cv cT cfv cfv cN cfv
      cle breq2 ralbidv rabbisdv ubthlem1.11 vz cv vh cv cT cfv cfv cN cfv vk
      cv cle wbr vh cn wral vz cX cX cU cba cfv cvv ubthlem1.1 cU cba fvex
      eqeltri rabex fvopab4 eleq2d vz cv vh cv cT cfv cfv cN cfv vk cv cle wbr
      vh cn wral cP vh cv cT cfv cfv cN cfv vk cv cle wbr vh cn wral vz cP cX
      vz cv cP wceq vz cv vh cv cT cfv cfv cN cfv vk cv cle wbr cP vh cv cT cfv
      cfv cN cfv vk cv cle wbr vh cn vz cv cP wceq vz cv vh cv cT cfv cfv cN
      cfv cP vh cv cT cfv cfv cN cfv vk cv cle vz cv cP wceq vz cv vh cv cT cfv
      cfv cP vh cv cT cfv cfv cN vz cv cP vh cv cT cfv fveq2 fveq2d breq1d
      ralbidv elrab syl6bb cP vh cv cT cfv cfv cN cfv vk cv cle wbr vh cn wral
      cP vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral cP cX wcel cP vh cv
      cT cfv cfv cN cfv vk cv cle wbr cP vn cv cT cfv cfv cN cfv vk cv cle wbr
      vh vn cn vh cv vn cv wceq cP vh cv cT cfv cfv cN cfv cP vn cv cT cfv cfv
      cN cfv vk cv cle vh cv vn cv wceq cP vh cv cT cfv cfv cP vn cv cT cfv cfv
      cN vh cv vn cv wceq cP vh cv cT cfv vn cv cT cfv vh cv vn cv cT fveq2
      fveq1d fveq2d breq1d cbvralv anbi2i syl6bb $.
      $( [8-Jan-2008] $) $( [19-Dec-2007] $)

    $( Lemma for ~ ubthi .  ` A `` k ` is a set of vectors. $)
    ubthlem2 $p |- ( k e. NN -> ( A ` k ) C_ X ) $=
      vk cv cn wcel vp vk cv cA cfv cX vk cv cn wcel vp cv vk cv cA cfv wcel vp
      cv cX wcel vk cv cn wcel vp cv vk cv cA cfv wcel vp cv cX wcel vp cv vm
      cv cT cfv cfv cN cfv vk cv cle wbr vm cn wral vy vz cA vp cv cT cU vh vj
      vk vm cN cX ubthlem1.1 ubthlem1.11 ubthlem1 pm3.26bda ex ssrdv $.
      $( [10-Jan-2008] $) $( [7-Nov-2007] $)
  $}

  ${
    $d g m A $.  $d m C $.  $d g m x D $.  $d g G $.  $d n j h z y N $.
    $d g n j m h z y x T $.  $d g W $.  $d g j z y X $.  $d g m x Y $.
    $d f g n j k m h w z y x $.
    ubthlem3.1 $e |- X = ( BaseSet ` U ) $.
    ubthlem3.2 $e |- Y = ( BaseSet ` W ) $.
    ubthlem3.3 $e |- N = ( norm ` W ) $.
    ubthlem3.5 $e |- B = ( U BLnOp W ) $.
    ubthlem3.6 $e |- T : NN --> B $.
    ubthlem3.u $e |- U e. NrmCVec $.
    ubthlem3.w $e |- W e. NrmCVec $.
    ubthlem3.9c $e |- C = ( IndMet ` U ) $.
    ubthlem3.9d $e |- D = ( IndMet ` W ) $.
    ubthlem3.11 $e |- A = { <. j , y >. | ( j e. NN /\ y = { z e. X |
       A. h e. NN ( N ` ( ( T ` h ) ` z ) ) <_ j } ) } $.
    ubthlem3.12 $e |- G = { <. m , x >. | ( m e. NN /\ x =
                 ( ( T ` n ) ` ( f ` m ) ) ) } $.
    $( Lemma for ~ ubthi .  The limit of any sequence in ` A `` k ` has
       operator value norm less than ` k ` , for any bounded linear operator
       ` T `` n ` , using ~ metcn4i (with continuity shown by ~ blocn2 ) and
       the properties of ` A `` k ` . $)
    ubthlem3 $p |- ( ( ( f : NN --> ( A ` k ) /\ f ( ~~>m ` C ) w ) /\
         ( k e. NN /\ n e. NN ) ) -> ( N ` ( ( T ` n ) ` w ) ) <_ k ) $=
      cn cY cG wf cG vw cv vn cv cT cfv cfv cD clm cfv wbr vk cv cr wcel vg cv
      cG cfv cN cfv vk cv cle wbr vg cn wral vw cv vn cv cT cfv cfv cN cfv vk
      cv cle wbr cn vk cv cA cfv vf cv wf vf cv vw cv cC clm cfv wbr wa vk cv
      cn wcel vn cv cn wcel wa wa cW cnv wcel cn cY cG wf cG vw cv vn cv cT cfv
      cfv cD clm cfv wbr vk cv cr wcel vg cv cG cfv cN cfv vk cv cle wbr vg cn
      wral wa vw cv vn cv cT cfv cfv cN cfv vk cv cle wbr ubthlem3.w cD vw cv
      vn cv cT cfv cfv vk cv cW vg cG cN cY ubthlem3.2 ubthlem3.3 ubthlem3.9d
      vw cv vn cv cT cfv fvex nvlmle mp3anl1 cn vk cv cA cfv vf cv wf vf cv vw
      cv cC clm cfv wbr wa vk cv cn wcel vn cv cn wcel wa wa vm cv vf cv cfv vn
      cv cT cfv cfv cY wcel vm cn wral cn cY cG wf cn vk cv cA cfv vf cv wf vf
      cv vw cv cC clm cfv wbr wa vk cv cn wcel vn cv cn wcel wa wa vm cv vf cv
      cfv vn cv cT cfv cfv cY wcel vm cn cn vk cv cA cfv vf cv wf vk cv cn wcel
      vn cv cn wcel wa vm cv cn wcel vm cv vf cv cfv vn cv cT cfv cfv cY wcel
      vf cv vw cv cC clm cfv wbr cX cY vn cv cT cfv wf vm cv vf cv cfv cX wcel
      vm cv vf cv cfv vn cv cT cfv cfv cY wcel cn vk cv cA cfv vf cv wf vk cv
      cn wcel vn cv cn wcel wa wa vm cv cn wcel wa cX cY vm cv vf cv cfv vn cv
      cT cfv ffvelrn vk cv cn wcel vn cv cn wcel wa cX cY vn cv cT cfv wf cn vk
      cv cA cfv vf cv wf vm cv cn wcel vn cv cn wcel cX cY vn cv cT cfv wf vk
      cv cn wcel vn cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn cB
      vn cv cT ubthlem3.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel
      cX cY vn cv cT cfv wf ubthlem3.u ubthlem3.w cB vn cv cT cfv cU cW cX cY
      ubthlem3.1 ubthlem3.2 ubthlem3.5 blof mp3an12 syl adantl ad2antlr cn vk
      cv cA cfv vf cv wf vk cv cn wcel vm cv cn wcel vm cv vf cv cfv cX wcel vn
      cv cn wcel cn cX vf cv wf vm cv cn wcel vm cv vf cv cfv cX wcel cn vk cv
      cA cfv vf cv wf vk cv cn wcel wa cn cX vm cv vf cv ffvelrn cn vk cv cA
      cfv vf cv wf vk cv cA cfv cX wss cn cX vf cv wf vk cv cn wcel cn vk cv cA
      cfv cX vf cv fss vy vz cA cT cU vh vj vk cN cX ubthlem3.1 ubthlem3.11
      ubthlem2 sylan2 sylan adantlrr sylanc adantllr r19.21aiva vm vx cn cY vm
      cv vf cv cfv vn cv cT cfv cfv cG ubthlem3.12 fopab2 sylib vn cv cT cfv cC
      copn cfv cD copn cfv ccn co wcel cn cC cdm cdm vf cv wf vf cv vw cv cC
      clm cfv wbr wa cG vw cv vn cv cT cfv cfv cD clm cfv wbr cn vk cv cA cfv
      vf cv wf vf cv vw cv cC clm cfv wbr wa vk cv cn wcel vn cv cn wcel wa wa
      cD cme wcel vn cv cT cfv cC copn cfv cD copn cfv ccn co wcel cn cC cdm
      cdm vf cv wf vf cv vw cv cC clm cfv wbr wa cG vw cv vn cv cT cfv cfv cD
      clm cfv wbr cW cnv wcel cD cme wcel ubthlem3.w cD cW ubthlem3.9d imsmet
      ax-mp cC cme wcel cD cme wcel vn cv cT cfv cC copn cfv cD copn cfv ccn co
      wcel cn cC cdm cdm vf cv wf vf cv vw cv cC clm cfv wbr wa cG vw cv vn cv
      cT cfv cfv cD clm cfv wbr cU cnv wcel cC cme wcel ubthlem3.u cC cU
      ubthlem3.9c imsmet ax-mp vx cC cD vw cv vm vn cv cT cfv vf cv cG cC copn
      cfv cD copn cfv cC cdm cdm cC cdm cdm eqid cC copn cfv eqid cD copn cfv
      eqid ubthlem3.12 vw visset metcn4i mp3anl1 mpanl1 vn cv cn wcel vn cv cT
      cfv cC copn cfv cD copn cfv ccn co wcel cn vk cv cA cfv vf cv wf vf cv vw
      cv cC clm cfv wbr wa vk cv cn wcel vn cv cn wcel vn cv cT cfv cB wcel vn
      cv cT cfv cC copn cfv cD copn cfv ccn co wcel cn cB vn cv cT ubthlem3.6
      ffvelrni cB cC cD vn cv cT cfv cU cC copn cfv cD copn cfv cW ubthlem3.9c
      ubthlem3.9d cC copn cfv eqid cD copn cfv eqid ubthlem3.5 ubthlem3.u
      ubthlem3.w blocn2 syl ad2antll cn vk cv cA cfv vf cv wf vk cv cn wcel vn
      cv cn wcel wa vf cv vw cv cC clm cfv wbr cn cC cdm cdm vf cv wf vf cv vw
      cv cC clm cfv wbr wa cn vk cv cA cfv vf cv wf vk cv cn wcel vn cv cn wcel
      wa wa cn cC cdm cdm vf cv wf vf cv vw cv cC clm cfv wbr cn vk cv cA cfv
      vf cv wf vk cv cn wcel cn cC cdm cdm vf cv wf vn cv cn wcel cn vk cv cA
      cfv vf cv wf vk cv cn wcel wa cn cX vf cv wf cn cC cdm cdm vf cv wf cn vk
      cv cA cfv vf cv wf vk cv cA cfv cX wss cn cX vf cv wf vk cv cn wcel cn vk
      cv cA cfv cX vf cv fss vy vz cA cT cU vh vj vk cN cX ubthlem3.1
      ubthlem3.11 ubthlem2 sylan2 cX cC cdm cdm wceq cn cX vf cv wf cn cC cdm
      cdm vf cv wf wb cC cU cX ubthlem3.1 ubthlem3.9c ubthlem3.u imsbai cX cC
      cdm cdm cn vf cv feq3 ax-mp sylib adantrr anim1i an1rs sylanc vk cv cn
      wcel vk cv cr wcel cn vk cv cA cfv vf cv wf vf cv vw cv cC clm cfv wbr wa
      vn cv cn wcel vk cv nnre ad2antrl cn vk cv cA cfv vf cv wf vk cv cn wcel
      vn cv cn wcel wa vg cv cG cfv cN cfv vk cv cle wbr vg cn wral vf cv vw cv
      cC clm cfv wbr cn vk cv cA cfv vf cv wf vk cv cn wcel vn cv cn wcel wa wa
      vg cv cG cfv cN cfv vk cv cle wbr vg cn cn vk cv cA cfv vf cv wf vk cv cn
      wcel vn cv cn wcel wa wa vg cv cn wcel wa vg cv cG cfv cN cfv vg cv vf cv
      cfv vn cv cT cfv cfv cN cfv vk cv cle vg cv cn wcel vg cv cG cfv cN cfv
      vg cv vf cv cfv vn cv cT cfv cfv cN cfv wceq cn vk cv cA cfv vf cv wf vk
      cv cn wcel vn cv cn wcel wa wa vg cv cn wcel vg cv cG cfv vg cv vf cv cfv
      vn cv cT cfv cfv cN vm vx vg cv vm cv vf cv cfv vn cv cT cfv cfv vg cv vf
      cv cfv vn cv cT cfv cfv cn cG vm cv vg cv wceq vm cv vf cv cfv vg cv vf
      cv cfv vn cv cT cfv vm cv vg cv vf cv fveq2 fveq2d ubthlem3.12 vg cv vf
      cv cfv vn cv cT cfv fvex fvopab4 fveq2d adantl vg cv vf cv cfv vk cv cA
      cfv wcel vk cv cn wcel wa vn cv cn wcel vg cv vf cv cfv vn cv cT cfv cfv
      cN cfv vk cv cle wbr cn vk cv cA cfv vf cv wf vk cv cn wcel vn cv cn wcel
      wa wa vg cv cn wcel wa vg cv vf cv cfv vk cv cA cfv wcel vk cv cn wcel wa
      vg cv vf cv cfv vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn vk cv cn wcel
      vg cv vf cv cfv vk cv cA cfv wcel vg cv vf cv cfv vn cv cT cfv cfv cN cfv
      vk cv cle wbr vn cn wral vk cv cn wcel vg cv vf cv cfv vk cv cA cfv wcel
      vg cv vf cv cfv cX wcel vg cv vf cv cfv vn cv cT cfv cfv cN cfv vk cv cle
      wbr vn cn wral vy vz cA vg cv vf cv cfv cT cU vh vj vk vn cN cX
      ubthlem3.1 ubthlem3.11 ubthlem1 pm3.27bda ancoms r19.21bi cn vk cv cA cfv
      vf cv wf vk cv cn wcel vn cv cn wcel wa wa vg cv cn wcel wa vg cv vf cv
      cfv vk cv cA cfv wcel vk cv cn wcel cn vk cv cA cfv vf cv wf vg cv cn
      wcel vg cv vf cv cfv vk cv cA cfv wcel vk cv cn wcel vn cv cn wcel wa cn
      vk cv cA cfv vg cv vf cv ffvelrn adantlr cn vk cv cA cfv vf cv wf vk cv
      cn wcel vn cv cn wcel wa wa vk cv cn wcel vg cv cn wcel cn vk cv cA cfv
      vf cv wf vk cv cn wcel vn cv cn wcel simprl adantr jca cn vk cv cA cfv vf
      cv wf vk cv cn wcel vn cv cn wcel wa wa vn cv cn wcel vg cv cn wcel cn vk
      cv cA cfv vf cv wf vk cv cn wcel vn cv cn wcel simprr adantr sylanc
      eqbrtrd r19.21aiva adantlr syl2anc $.
      $( [10-Jan-2008] $) $( [26-Dec-2007] $)
  $}

  ${
    $d c f k m n p r x A $.  $d f k m n r x D $.  $d f k p r x J $.
    $d h j k n y z N $.  $d h j k m n w y z T $.  $d m w W $.
    $d c f j k n x y z X $.  $d m w Y $.  $d f h w x $.
    ubthlem4.1 $e |- X = ( BaseSet ` U ) $.
    ubthlem4.2 $e |- Y = ( BaseSet ` W ) $.
    ubthlem4.3 $e |- N = ( norm ` W ) $.
    ubthlem4.5 $e |- B = ( U BLnOp W ) $.
    ubthlem4.6 $e |- T : NN --> B $.
    ubthlem4.7 $e |- U e. CBan $.
    ubthlem4.8 $e |- W e. NrmCVec $.
    ubthlem4.9 $e |- D = ( IndMet ` U ) $.
    ubthlem4.10 $e |- J = ( Open ` D ) $.
    ubthlem4.11 $e |- A = { <. j , y >. | ( j e. NN /\ y = { z e. X |
       A. h e. NN ( N ` ( ( T ` h ) ` z ) ) <_ j } ) } $.
    $( Lemma for ~ ubthi .  The set ` A `` k ` is therefore closed by
       ~ metcld .  (The hypothesis ` U e. CBan ` could be weakened to
       ` U e. NrmCVec ` .) $)
    ubthlem4 $p |- ( k e. NN -> ( A ` k ) e. ( Clsd ` J ) ) $=
      vk cv cn wcel vk cv cA cfv cJ ccld cfv wcel cn vk cv cA cfv vf cv wf vf
      cv vx cv cD clm cfv wbr wa vx cv vk cv cA cfv wcel wi vf wal vx wal vk cv
      cn wcel cn vk cv cA cfv vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv vk
      cv cA cfv wcel wi vx vf vk cv cn wcel cn vk cv cA cfv vf cv wf vf cv vx
      cv cD clm cfv wbr wa vx cv cX wcel vx cv vn cv cT cfv cfv cN cfv vk cv
      cle wbr vn cn wral wa vx cv vk cv cA cfv wcel vk cv cn wcel cn vk cv cA
      cfv vf cv wf vf cv vx cv cD clm cfv wbr wa vx cv cX wcel vx cv vn cv cT
      cfv cfv cN cfv vk cv cle wbr vn cn wral wa vk cv cn wcel cn vk cv cA cfv
      vf cv wf vf cv vx cv cD clm cfv wbr wa wa vx cv cX wcel vx cv vn cv cT
      cfv cfv cN cfv vk cv cle wbr vn cn wral vf cv vx cv cD clm cfv wbr vx cv
      cX wcel vk cv cn wcel cn vk cv cA cfv vf cv wf cU cnv wcel vf cv vx cv cD
      clm cfv wbr vx cv cX wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv
      ax-mp cD vx cv cU vf cv cX ubthlem4.1 ubthlem4.9 vx visset nvlmcl mpan
      ad2antll vk cv cn wcel cn vk cv cA cfv vf cv wf vf cv vx cv cD clm cfv
      wbr wa wa vx cv vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn vk cv cn wcel
      vn cv cn wcel cn vk cv cA cfv vf cv wf vf cv vx cv cD clm cfv wbr wa vx
      cv vn cv cT cfv cfv cN cfv vk cv cle wbr cn vk cv cA cfv vf cv wf vf cv
      vx cv cD clm cfv wbr wa vk cv cn wcel vn cv cn wcel wa vx cv vn cv cT cfv
      cfv cN cfv vk cv cle wbr vw vy vz vx cA cB cD cW cims cfv cT cU vf vh vj
      vk vm vn vm cv cn wcel vw cv vm cv vf cv cfv vn cv cT cfv cfv wceq wa vm
      vw copab cN cW cX cY ubthlem4.1 ubthlem4.2 ubthlem4.3 ubthlem4.5
      ubthlem4.6 cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp ubthlem4.8
      ubthlem4.9 cW cims cfv eqid ubthlem4.11 vm cv cn wcel vw cv vm cv vf cv
      cfv vn cv cT cfv cfv wceq wa vm vw copab eqid ubthlem3 ancoms an1rs
      r19.21aiva jca ex vy vz cA vx cv cT cU vh vj vk vn cN cX ubthlem4.1
      ubthlem4.11 ubthlem1 sylibrd 19.21aivv vk cv cn wcel vk cv cA cfv cX wss
      vk cv cA cfv cJ ccld cfv wcel cn vk cv cA cfv vf cv wf vf cv vx cv cD clm
      cfv wbr wa vx cv vk cv cA cfv wcel wi vf wal vx wal wb vy vz cA cT cU vh
      vj vk cN cX ubthlem4.1 ubthlem4.11 ubthlem2 cD cme wcel vk cv cA cfv cX
      wss vk cv cA cfv cJ ccld cfv wcel cn vk cv cA cfv vf cv wf vf cv vx cv cD
      clm cfv wbr wa vx cv vk cv cA cfv wcel wi vf wal vx wal wb cU cnv wcel cD
      cme wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp cD cU
      ubthlem4.9 imsmet ax-mp vx cD vf cJ vk cv cA cfv cX cD cU cX ubthlem4.1
      ubthlem4.9 cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp imsbai
      ubthlem4.10 metcld mpan syl mpbird $.
      $( [14-Jan-2008] $) $( [7-Nov-2007] $)

    $( Lemma for ~ ubthi .  The union of all ` A `` k ` equals the base set,
       provided the values of the operators ` T `` n ` are bounded for each
       vector ` x ` . $)
    ubthlem5 $p |- ( A. x e. X E. c e. RR A. n e. NN
   ( N ` ( ( T ` n ) ` x ) ) <_ c -> U_ k e. NN ( A ` k ) = X ) $=
      vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cX
      wral vk cn vk cv cA cfv ciun cX vk cn vk cv cA cfv ciun cX wss vx cv vn
      cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cX wral vk cn
      vk cv cA cfv ciun cX wss vk cv cA cfv cX wss vk cn vk cn vk cv cA cfv cX
      iunss vy vz cA cT cU vh vj vk cN cX ubthlem4.1 ubthlem4.11 ubthlem2
      mprgbir a1i vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr
      wrex vx cX wral vx cv vk cn vk cv cA cfv ciun wcel vx cX wral cX vk cn vk
      cv cA cfv ciun wss vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral
      vc cr wrex vx cv vk cn vk cv cA cfv ciun wcel vx cX vx cv cX wcel vx cv
      vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cv vk cv
      cA cfv wcel vk cn wrex vx cv vk cn vk cv cA cfv ciun wcel vx cv cX wcel
      vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cv
      vk cv cA cfv wcel vk cn wrex vx cv cX wcel vx cv vn cv cT cfv cfv cN cfv
      vc cv cle wbr vn cn wral vc cr wrex vx cv vk cv cA cfv wcel vk cn wrex vx
      cv cX wcel vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vx cv
      vk cv cA cfv wcel vk cn wrex vc cr vx cv cX wcel vc cv cr wcel wa vx cv
      vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vx cv vk cv cA cfv wcel
      vk cn wrex vx cv cX wcel vc cv cr wcel wa vx cv vn cv cT cfv cfv cN cfv
      vc cv cle wbr vn cn wral wa vc cv vk cv clt wbr vk cn wrex vx cv vk cv cA
      cfv wcel vk cn wrex vc cv cr wcel vc cv vk cv clt wbr vk cn wrex vx cv cX
      wcel vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cv vk arch
      ad2antlr vx cv cX wcel vc cv cr wcel wa vx cv vn cv cT cfv cfv cN cfv vc
      cv cle wbr vn cn wral wa vc cv vk cv clt wbr vx cv vk cv cA cfv wcel vk
      cn vx cv cX wcel vc cv cr wcel wa vx cv vn cv cT cfv cfv cN cfv vc cv cle
      wbr vn cn wral wa vk cv cn wcel wa vc cv vk cv clt wbr vc cv vk cv cle
      wbr vx cv vk cv cA cfv wcel vx cv cX wcel vc cv cr wcel wa vk cv cn wcel
      vc cv vk cv clt wbr vc cv vk cv cle wbr wi vx cv vn cv cT cfv cfv cN cfv
      vc cv cle wbr vn cn wral vc cv cr wcel vk cv cn wcel vc cv vk cv clt wbr
      vc cv vk cv cle wbr wi vx cv cX wcel vc cv cr wcel vk cv cr wcel vc cv vk
      cv clt wbr vc cv vk cv cle wbr wi vk cv cn wcel vc cv vk cv ltle vk cv
      nnre sylan2 adantll adantlr vx cv cX wcel vc cv cr wcel wa vk cv cn wcel
      vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cv vk cv cle
      wbr vx cv vk cv cA cfv wcel wi vx cv cX wcel vc cv cr wcel wa vk cv cn
      wcel wa vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral wa vc cv
      vk cv cle wbr vx cv cX wcel vx cv vn cv cT cfv cfv cN cfv vk cv cle wbr
      vn cn wral wa vx cv vk cv cA cfv wcel vx cv cX wcel vc cv cr wcel wa vk
      cv cn wcel wa vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral wa
      vc cv vk cv cle wbr vx cv vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn
      wral vx cv cX wcel vx cv cX wcel vc cv cr wcel wa vk cv cn wcel wa vx cv
      vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cv vk cv cle wbr vx
      cv vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral wi vx cv cX wcel vc
      cv cr wcel wa vk cv cn wcel wa vc cv vk cv cle wbr vx cv vn cv cT cfv cfv
      cN cfv vc cv cle wbr vn cn wral vx cv vn cv cT cfv cfv cN cfv vk cv cle
      wbr vn cn wral vx cv cX wcel vc cv cr wcel wa vk cv cn wcel wa vc cv vk
      cv cle wbr vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vx cv
      vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral wi vx cv cX wcel vc cv
      cr wcel wa vk cv cn wcel wa vc cv vk cv cle wbr wa vx cv vn cv cT cfv cfv
      cN cfv vc cv cle wbr vx cv vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn vx
      cv cX wcel vc cv cr wcel wa vk cv cn wcel wa vc cv vk cv cle wbr vn cv cn
      wcel vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vx cv vn cv cT cfv cfv
      cN cfv vk cv cle wbr wi vx cv cX wcel vc cv cr wcel wa vk cv cn wcel wa
      vn cv cn wcel vc cv vk cv cle wbr vx cv vn cv cT cfv cfv cN cfv vc cv cle
      wbr vx cv vn cv cT cfv cfv cN cfv vk cv cle wbr wi vx cv cX wcel vc cv cr
      wcel wa vk cv cn wcel wa vn cv cn wcel vx cv vn cv cT cfv cfv cN cfv vc
      cv cle wbr vc cv vk cv cle wbr vx cv vn cv cT cfv cfv cN cfv vk cv cle
      wbr vx cv cX wcel vc cv cr wcel wa vk cv cn wcel wa vn cv cn wcel vx cv
      vn cv cT cfv cfv cN cfv vc cv cle wbr vc cv vk cv cle wbr vx cv vn cv cT
      cfv cfv cN cfv vk cv cle wbr vx cv vn cv cT cfv cfv cN cfv cr wcel vc cv
      cr wcel vk cv cr wcel vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vc cv
      vk cv cle wbr wa vx cv vn cv cT cfv cfv cN cfv vk cv cle wbr wi vx cv cX
      wcel vc cv cr wcel wa vk cv cn wcel wa vn cv cn wcel wa vx cv vn cv cT
      cfv cfv cN cfv vc cv vk cv letr vx cv cX wcel vc cv cr wcel wa vn cv cn
      wcel vx cv vn cv cT cfv cfv cN cfv cr wcel vk cv cn wcel vx cv cX wcel vn
      cv cn wcel vx cv vn cv cT cfv cfv cN cfv cr wcel vc cv cr wcel vx cv cX
      wcel vn cv cn wcel wa vx cv vn cv cT cfv cfv cY wcel vx cv vn cv cT cfv
      cfv cN cfv cr wcel vn cv cn wcel vx cv cX wcel vx cv vn cv cT cfv cfv cY
      wcel cX cY vn cv cT cfv wf vx cv cX wcel vx cv vn cv cT cfv cfv cY wcel
      vn cv cn wcel cX cY vx cv vn cv cT cfv ffvelrn vn cv cn wcel vn cv cT cfv
      cB wcel cX cY vn cv cT cfv wf cn cB vn cv cT ubthlem4.6 ffvelrni cU cnv
      wcel cW cnv wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cU cbn wcel
      cU cnv wcel ubthlem4.7 cU bnnv ax-mp ubthlem4.8 cB vn cv cT cfv cU cW cX
      cY ubthlem4.1 ubthlem4.2 ubthlem4.5 blof mp3an12 syl sylan ancoms cW cnv
      wcel vx cv vn cv cT cfv cfv cY wcel vx cv vn cv cT cfv cfv cN cfv cr wcel
      ubthlem4.8 vx cv vn cv cT cfv cfv cW cN cY ubthlem4.2 ubthlem4.3 nvcl
      mpan syl adantlr adantlr vx cv cX wcel vc cv cr wcel wa vk cv cn wcel wa
      vc cv cr wcel vn cv cn wcel vx cv cX wcel vc cv cr wcel vk cv cn wcel
      simplr adantr vk cv cn wcel vk cv cr wcel vx cv cX wcel vc cv cr wcel wa
      vn cv cn wcel vk cv nnre ad2antlr syl3anc exp4b com34 com23 imp31
      r19.20dva ex com23 imp vx cv cX wcel vc cv cr wcel wa vk cv cn wcel wa vx
      cv cX wcel vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vx cv
      cX wcel vc cv cr wcel vk cv cn wcel simpll adantr jctild vk cv cn wcel vx
      cv vk cv cA cfv wcel vx cv cX wcel vx cv vn cv cT cfv cfv cN cfv vk cv
      cle wbr vn cn wral wa wb vx cv cX wcel vc cv cr wcel wa vx cv vn cv cT
      cfv cfv cN cfv vc cv cle wbr vn cn wral vy vz cA vx cv cT cU vh vj vk vn
      cN cX ubthlem4.1 ubthlem4.11 ubthlem1 ad2antlr sylibrd an1rs syld
      r19.22dva mpd ex r19.23adva imp ex vk vx cv cn vk cv cA cfv eliun syl6ibr
      r19.20i vx cX vk cn vk cv cA cfv ciun dfss3 sylibr eqssd $.
      $( [10-Jan-2008] $) $( [26-Dec-2007] $)

    $( Lemma for ~ ubthi .  Using ~ bcth (via ~ bcthlem33 ), at least one
       set ` A `` k ` contains a ball. $)
    ubthlem6 $p |- ( A. x e. X E. c e. RR A. n e. NN ( N ` ( ( T ` n ) ` x
        ) ) <_ c -> E. k e. NN E. p e. X E. r e. RR ( 0 < r /\
                 ( p ( ball ` D ) r ) C_ ( A ` k ) ) ) $=
      vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cX
      wral vk cv cA cfv cJ cnt cfv cfv c0 wne vk cn wrex cc0 vr cv clt wbr vp
      cv vr cv cD cbl cfv co vk cv cA cfv wss wa vr cr wrex vp cX wrex vk cn
      wrex vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx
      cX wral cA crn cuni cX wceq vk cv cA cfv cJ cnt cfv cfv c0 wne vk cn wrex
      vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cX
      wral vk cn vk cv cA cfv ciun cX cA crn cuni vx vy vz cA cB cD cT cU vh vj
      vk vn cJ cN cW cX cY vc ubthlem4.1 ubthlem4.2 ubthlem4.3 ubthlem4.5
      ubthlem4.6 ubthlem4.7 ubthlem4.8 ubthlem4.9 ubthlem4.10 ubthlem4.11
      ubthlem5 cA cn wfn vk cn vk cv cA cfv ciun cA crn cuni wceq vj vy cn vz
      cv vh cv cT cfv cfv cN cfv vj cv cle wbr vh cn wral vz cX crab cA vz cv
      vh cv cT cfv cfv cN cfv vj cv cle wbr vh cn wral vz cX cX cU cba cfv cvv
      ubthlem4.1 cU cba fvex eqeltri rabex ubthlem4.11 fnopab2 vk cn cA fniunfv
      ax-mp syl5eqr cA crn cuni cX wceq cA crn cJ ccld cfv wss vk cv cA cfv cJ
      cnt cfv cfv c0 wne vk cn wrex vx cA crn cJ ccld cfv vx cv cA crn wcel vk
      cv cA cfv vx cv wceq vk cn wrex vx cv cJ ccld cfv wcel cA cn wfn vx cv cA
      crn wcel vk cv cA cfv vx cv wceq vk cn wrex wb vj vy cn vz cv vh cv cT
      cfv cfv cN cfv vj cv cle wbr vh cn wral vz cX crab cA vz cv vh cv cT cfv
      cfv cN cfv vj cv cle wbr vh cn wral vz cX cX cU cba cfv cvv ubthlem4.1 cU
      cba fvex eqeltri rabex ubthlem4.11 fnopab2 vk cn vx cv cA fvelrnb ax-mp
      vk cv cA cfv vx cv wceq vx cv cJ ccld cfv wcel vk cn vk cv cn wcel vk cv
      cA cfv vx cv wceq wa vk cv cA cfv vx cv cJ ccld cfv vk cv cn wcel vk cv
      cA cfv vx cv wceq pm3.27 vk cv cn wcel vk cv cA cfv cJ ccld cfv wcel vk
      cv cA cfv vx cv wceq vy vz cA cB cD cT cU vh vj vk cJ cN cW cX cY
      ubthlem4.1 ubthlem4.2 ubthlem4.3 ubthlem4.5 ubthlem4.6 ubthlem4.7
      ubthlem4.8 ubthlem4.9 ubthlem4.10 ubthlem4.11 ubthlem4 adantr eqeltrrd
      r19.23aiva sylbi ssriv cD vk cJ cA cX cU cbn wcel cD cms wcel ubthlem4.7
      cD cU ubthlem4.9 bncms ax-mp cU cn0v cfv cX wcel cX c0 wne cU cnv wcel cU
      cn0v cfv cX wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp cU cX
      cU cn0v cfv ubthlem4.1 cU cn0v cfv eqid nvzcl ax-mp cX cU cn0v cfv ne0i
      ax-mp cD cU cX ubthlem4.1 ubthlem4.9 cU cbn wcel cU cnv wcel ubthlem4.7
      cU bnnv ax-mp imsbai ubthlem4.10 cn cX cpw cA wf cA cn wfn vk cv cA cfv
      cX cpw wcel vk cn wral vk cn cX cpw cA ffnfv vj vy cn vz cv vh cv cT cfv
      cfv cN cfv vj cv cle wbr vh cn wral vz cX crab cA vz cv vh cv cT cfv cfv
      cN cfv vj cv cle wbr vh cn wral vz cX cX cU cba cfv cvv ubthlem4.1 cU cba
      fvex eqeltri rabex ubthlem4.11 fnopab2 vk cv cA cfv cX cpw wcel vk cn vk
      cv cn wcel vk cv cA cfv cX wss vk cv cA cfv cX cpw wcel vy vz cA cT cU vh
      vj vk cN cX ubthlem4.1 ubthlem4.11 ubthlem2 vk cv cA cfv cX vk cv cA fvex
      elpw sylibr rgen mpbir2an bcthlem33 mpan2 syl vk cv cA cfv cJ cnt cfv cfv
      c0 wne cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa vr
      cr wrex vp cX wrex vk cn vk cv cn wcel vp cv vk cv cA cfv cJ cnt cfv cfv
      wcel vp wex vp cv cX wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk
      cv cA cfv wss wa vr cr wrex wa vp wex vk cv cA cfv cJ cnt cfv cfv c0 wne
      cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa vr cr
      wrex vp cX wrex vk cv cn wcel vp cv vk cv cA cfv cJ cnt cfv cfv wcel vp
      cv cX wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv wss
      wa vr cr wrex wa vp vk cv cn wcel vp cv vk cv cA cfv cJ cnt cfv cfv wcel
      vp cv cX wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv
      wss wa vr cr wrex vk cv cn wcel vk cv cA cfv cJ cnt cfv cfv cX vp cv vk
      cv cn wcel vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv cX vk cv cn wcel vk
      cv cA cfv cX wss vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv wss vy vz cA cT
      cU vh vj vk cN cX ubthlem4.1 ubthlem4.11 ubthlem2 cJ ctop wcel vk cv cA
      cfv cX wss vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv wss cD cme wcel cJ
      ctop wcel cU cnv wcel cD cme wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU
      bnnv ax-mp cD cU ubthlem4.9 imsmet ax-mp cD cJ ubthlem4.10 opntop ax-mp
      vk cv cA cfv cJ cX cJ cuni cX cD cme wcel cJ cuni cX wceq cU cnv wcel cD
      cme wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp cD cU
      ubthlem4.9 imsmet ax-mp cD cJ cX cD cU cX ubthlem4.1 ubthlem4.9 cU cbn
      wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp imsbai ubthlem4.10 uniopn2
      ax-mp eqcomi ntrss2 mpan syl vy vz cA cT cU vh vj vk cN cX ubthlem4.1
      ubthlem4.11 ubthlem2 sstrd sseld vk cv cn wcel vp cv vk cv cA cfv cJ cnt
      cfv cfv wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv cJ
      cnt cfv cfv wss wa vr cr wrex cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co
      vk cv cA cfv wss wa vr cr wrex vk cv cn wcel vp cv vk cv cA cfv cJ cnt
      cfv cfv wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv cJ
      cnt cfv cfv wss wa vr cr wrex vk cv cA cfv cJ cnt cfv cfv cJ wcel vp cv
      vk cv cA cfv cJ cnt cfv cfv wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv
      co vk cv cA cfv cJ cnt cfv cfv wss wa vr cr wrex vk cv cn wcel cD cme
      wcel vk cv cA cfv cJ cnt cfv cfv cJ wcel vp cv vk cv cA cfv cJ cnt cfv
      cfv wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv cJ cnt
      cfv cfv wss wa vr cr wrex cU cnv wcel cD cme wcel cU cbn wcel cU cnv wcel
      ubthlem4.7 cU bnnv ax-mp cD cU ubthlem4.9 imsmet ax-mp vr vk cv cA cfv cJ
      cnt cfv cfv cD vp cv cJ ubthlem4.10 opni2 mp3an1 vk cv cn wcel vk cv cA
      cfv cX wss vk cv cA cfv cJ cnt cfv cfv cJ wcel vy vz cA cT cU vh vj vk cN
      cX ubthlem4.1 ubthlem4.11 ubthlem2 cJ ctop wcel vk cv cA cfv cX wss vk cv
      cA cfv cJ cnt cfv cfv cJ wcel cD cme wcel cJ ctop wcel cU cnv wcel cD cme
      wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp cD cU ubthlem4.9
      imsmet ax-mp cD cJ ubthlem4.10 opntop ax-mp vk cv cA cfv cJ cX cJ cuni cX
      cD cme wcel cJ cuni cX wceq cU cnv wcel cD cme wcel cU cbn wcel cU cnv
      wcel ubthlem4.7 cU bnnv ax-mp cD cU ubthlem4.9 imsmet ax-mp cD cJ cX cD
      cU cX ubthlem4.1 ubthlem4.9 cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv
      ax-mp imsbai ubthlem4.10 uniopn2 ax-mp eqcomi ntropn mpan syl sylan ex vk
      cv cn wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv cJ
      cnt cfv cfv wss wa cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA
      cfv wss wa vr cr vk cv cn wcel vp cv vr cv cD cbl cfv co vk cv cA cfv cJ
      cnt cfv cfv wss vp cv vr cv cD cbl cfv co vk cv cA cfv wss cc0 vr cv clt
      wbr vp cv vr cv cD cbl cfv co vk cv cA cfv cJ cnt cfv cfv wss vk cv cn
      wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss vp cv vr cv cD cbl cfv co
      vk cv cA cfv cJ cnt cfv cfv wss vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv
      wss vp cv vr cv cD cbl cfv co vk cv cA cfv wss vk cv cn wcel vp cv vr cv
      cD cbl cfv co vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv sstr vk cv cn wcel
      vk cv cA cfv cX wss vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv wss vy vz cA
      cT cU vh vj vk cN cX ubthlem4.1 ubthlem4.11 ubthlem2 cJ ctop wcel vk cv
      cA cfv cX wss vk cv cA cfv cJ cnt cfv cfv vk cv cA cfv wss cD cme wcel cJ
      ctop wcel cU cnv wcel cD cme wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU
      bnnv ax-mp cD cU ubthlem4.9 imsmet ax-mp cD cJ ubthlem4.10 opntop ax-mp
      vk cv cA cfv cJ cX cJ cuni cX cD cme wcel cJ cuni cX wceq cU cnv wcel cD
      cme wcel cU cbn wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp cD cU
      ubthlem4.9 imsmet ax-mp cD cJ cX cD cU cX ubthlem4.1 ubthlem4.9 cU cbn
      wcel cU cnv wcel ubthlem4.7 cU bnnv ax-mp imsbai ubthlem4.10 uniopn2
      ax-mp eqcomi ntrss2 mpan syl sylan2 expcom anim2d r19.22sdv syld jcad
      19.22dv vp vk cv cA cfv cJ cnt cfv cfv n0 cc0 vr cv clt wbr vp cv vr cv
      cD cbl cfv co vk cv cA cfv wss wa vr cr wrex vp cX df-rex 3imtr4g r19.22i
      syl $.
      $( [18-Jan-2008] $) $( [27-Dec-2007] $)
  $}

  ${
    $d h j n y z N $.  $d h n z Q $.  $d h j n y z T $.  $d j y z X $.
    $d h j k n p y z $.
    ubthlem7.1 $e |- X = ( BaseSet ` U ) $.
    ubthlem7.7 $e |- U e. NrmCVec $.
    ubthlem7.n $e |- L = ( norm ` U ) $.
    ubthlem7.g $e |- G = ( +v ` U ) $.
    ubthlem7.m $e |- M = ( -v ` U ) $.
    ubthlem7.r $e |- R = ( .s ` U ) $.
    ubthlem7.z $e |- Z = ( 0v ` U ) $.
    ubthlem7.q $e |- Q =
            ( p G ( ( ( r / 2 ) x. ( 1 / ( L ` x ) ) ) R x ) ) $.
    $( Lemma for ~ ubthi .  Auxiliary class ` Q ` is a vector. $)
    ubthlem7 $p |- ( ( p e. X /\ ( r e. RR /\ ( x e. X /\ x =/= Z ) ) ) ->
            Q e. X ) $=
      vp cv cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG co cX cQ vp
      cv cX wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co
      cX wcel vp cv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR
      co cG co cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa wa cU cnv
      wcel vp cv cX wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv
      cR co cX wcel vp cv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx
      cv cR co cG co cX wcel ubthlem7.7 vp cv vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR co cU cG cX ubthlem7.1 ubthlem7.g nvgcl mp3an1
      vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cc wcel vx cv cX wcel vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cX wcel vr cv
      cr wcel vx cv cX wcel vx cv cZ wne wa wa cU cnv wcel vr cv c2 cdiv co c1
      vx cv cL cfv cdiv co cmul co cc wcel vx cv cX wcel vr cv c2 cdiv co c1 vx
      cv cL cfv cdiv co cmul co vx cv cR co cX wcel ubthlem7.7 vr cv c2 cdiv co
      c1 vx cv cL cfv cdiv co cmul co vx cv cR cU cX ubthlem7.1 ubthlem7.r
      nvscl mp3an1 vr cv c2 cdiv co cc wcel c1 vx cv cL cfv cdiv co cc wcel vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cc wcel vr cv cr wcel vx cv
      cX wcel vx cv cZ wne wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co mulcl vr
      cv cr wcel vr cv c2 cdiv co vr cv rehalfcl recnd vx cv cL cfv cc wcel vx
      cv cL cfv cc0 wne c1 vx cv cL cfv cdiv co cc wcel vx cv cX wcel vx cv cZ
      wne wa vx cv cL cfv reccl vx cv cX wcel vx cv cL cfv cc wcel vx cv cZ wne
      vx cv cX wcel vx cv cL cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel
      ubthlem7.7 vx cv cU cL cX ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr vx
      cv cX wcel vx cv cL cfv cc0 wne vx cv cZ wne vx cv cX wcel vx cv cL cfv
      cc0 vx cv cZ cU cnv wcel vx cv cX wcel vx cv cL cfv cc0 wceq vx cv cZ
      wceq wb ubthlem7.7 vx cv cU cL cX cZ ubthlem7.1 ubthlem7.z ubthlem7.n nvz
      mpan necon3bid biimpar sylanc syl2an vr cv cr wcel vx cv cX wcel vx cv cZ
      wne simprl sylanc sylan2 ubthlem7.q syl5eqel $.
      $( [10-Jan-2008] $) $( [28-Dec-2007] $)

    $( Lemma for ~ ubthi .  Compute ` x ` in terms of auxiliary vector
        ` Q ` . $)
    ubthlem8 $p |- ( ( p e. X /\ ( ( r e. RR /\ 0 < r ) /\
               ( x e. X /\ x =/= Z ) ) ) ->
         x = ( ( ( 2 / r ) x. ( L ` x ) ) R ( Q M p ) ) ) $=
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ
      wne wa wa wa c1 vx cv cR co vx cv c2 vr cv cdiv co vx cv cL cfv cmul co
      cQ vp cv cM co cR co vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx
      cv cZ wne wa wa c1 vx cv cR co vx cv wceq vp cv cX wcel vx cv cX wcel c1
      vx cv cR co vx cv wceq vr cv cr wcel cc0 vr cv clt wbr wa vx cv cZ wne cU
      cnv wcel vx cv cX wcel c1 vx cv cR co vx cv wceq ubthlem7.7 vx cv cR cU
      cX ubthlem7.1 ubthlem7.r nvsid mpan ad2antrl adantl vp cv cX wcel vr cv
      cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa c2 vr cv
      cdiv co vx cv cL cfv cmul co cQ vp cv cM co cR co c2 vr cv cdiv co vx cv
      cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR
      co cR co c2 vr cv cdiv co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx cv
      cL cfv cdiv co cmul co cmul co vx cv cR co c1 vx cv cR co vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ
      vp cv cM co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co
      c2 vr cv cdiv co vx cv cL cfv cmul co cR vp cv cX wcel vr cv cr wcel cc0
      vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ vp cv cM co vr cv
      c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co wceq vp cv vr cv
      c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG co cQ wceq cQ
      vp cv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG co
      ubthlem7.q eqcomi cQ cX wcel vp cv cX wcel vr cv c2 cdiv co c1 vx cv cL
      cfv cdiv co cmul co vx cv cR co cX wcel cQ vp cv cM co vr cv c2 cdiv co
      c1 vx cv cL cfv cdiv co cmul co vx cv cR co wceq vp cv vr cv c2 cdiv co
      c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG co cQ wceq wb vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa cU cnv wcel cQ cX wcel vp cv cX wcel vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR co cX wcel w3a cQ vp cv cM co vr cv c2 cdiv co
      c1 vx cv cL cfv cdiv co cmul co vx cv cR co wceq vp cv vr cv c2 cdiv co
      c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG co cQ wceq wb ubthlem7.7
      cQ vp cv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cU
      cG cM cX ubthlem7.1 ubthlem7.g ubthlem7.m nvsubadd mpan vp cv cX wcel vr
      cv cr wcel vx cv cX wcel vx cv cZ wne wa cQ cX wcel cc0 vr cv clt wbr vx
      cQ cR cU cG cL cM cX cZ vr vp ubthlem7.1 ubthlem7.7 ubthlem7.n ubthlem7.g
      ubthlem7.m ubthlem7.r ubthlem7.z ubthlem7.q ubthlem7 adantrlr vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      pm3.26 vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
      wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cX wcel
      vp cv cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa vr cv c2 cdiv
      co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cX wcel cc0 vr cv clt wbr
      vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cc wcel vx cv cX wcel vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cX wcel vr cv
      cr wcel vx cv cX wcel vx cv cZ wne wa wa cU cnv wcel vr cv c2 cdiv co c1
      vx cv cL cfv cdiv co cmul co cc wcel vx cv cX wcel vr cv c2 cdiv co c1 vx
      cv cL cfv cdiv co cmul co vx cv cR co cX wcel ubthlem7.7 vr cv c2 cdiv co
      c1 vx cv cL cfv cdiv co cmul co vx cv cR cU cX ubthlem7.1 ubthlem7.r
      nvscl mp3an1 vr cv c2 cdiv co cc wcel c1 vx cv cL cfv cdiv co cc wcel vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cc wcel vr cv cr wcel vx cv
      cX wcel vx cv cZ wne wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co mulcl vr
      cv cr wcel vr cv c2 cdiv co vr cv rehalfcl recnd vx cv cL cfv cc wcel vx
      cv cL cfv cc0 wne c1 vx cv cL cfv cdiv co cc wcel vx cv cX wcel vx cv cZ
      wne wa vx cv cL cfv reccl vx cv cX wcel vx cv cL cfv cc wcel vx cv cZ wne
      vx cv cX wcel vx cv cL cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel
      ubthlem7.7 vx cv cU cL cX ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr vx
      cv cX wcel vx cv cL cfv cc0 wne vx cv cZ wne vx cv cX wcel vx cv cL cfv
      cc0 vx cv cZ cU cnv wcel vx cv cX wcel vx cv cL cfv cc0 wceq vx cv cZ
      wceq wb ubthlem7.7 vx cv cU cL cX cZ ubthlem7.1 ubthlem7.z ubthlem7.n nvz
      mpan necon3bid biimpar sylanc syl2an vr cv cr wcel vx cv cX wcel vx cv cZ
      wne simprl sylanc adantlr adantl syl3anc mpbiri opreq2d vr cv cr wcel cc0
      vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa c2 vr cv cdiv co vx cv
      cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cmul co
      vx cv cR co c2 vr cv cdiv co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx
      cv cL cfv cdiv co cmul co vx cv cR co cR co wceq vp cv cX wcel c2 vr cv
      cdiv co vx cv cL cfv cmul co cc wcel vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co cc wcel vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv cmul
      co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cmul co vx cv cR co
      c2 vr cv cdiv co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR co cR co wceq vr cv cr wcel cc0 vr cv clt wbr wa
      vx cv cX wcel vx cv cZ wne wa wa cU cnv wcel c2 vr cv cdiv co vx cv cL
      cfv cmul co cc wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co cc
      wcel vx cv cX wcel w3a c2 vr cv cdiv co vx cv cL cfv cmul co vr cv c2
      cdiv co c1 vx cv cL cfv cdiv co cmul co cmul co vx cv cR co c2 vr cv cdiv
      co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co
      vx cv cR co cR co wceq ubthlem7.7 c2 vr cv cdiv co vx cv cL cfv cmul co
      vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR cU cX
      ubthlem7.1 ubthlem7.r nvsass mpan c2 vr cv cdiv co cc wcel vx cv cL cfv
      cc wcel c2 vr cv cdiv co vx cv cL cfv cmul co cc wcel vr cv cr wcel cc0
      vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa c2 vr cv cdiv co vx cv cL
      cfv mulcl vr cv cc wcel vr cv cc0 wne c2 vr cv cdiv co cc wcel vr cv cr
      wcel cc0 vr cv clt wbr wa c2 cc wcel vr cv cc wcel vr cv cc0 wne c2 vr cv
      cdiv co cc wcel 2cn c2 vr cv divcl mp3an1 vr cv cr wcel cc0 vr cv clt wbr
      wa vr cv vr cv cr wcel cc0 vr cv clt wbr pm3.26 recnd vr cv gt0ne0 sylanc
      vx cv cX wcel vx cv cL cfv cc wcel vx cv cZ wne vx cv cX wcel vx cv cL
      cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem7.7 vx cv cU cL
      cX ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr syl2an vr cv c2 cdiv co
      cc wcel c1 vx cv cL cfv cdiv co cc wcel vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co cc wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel
      vx cv cZ wne wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co mulcl vr cv cr
      wcel vr cv c2 cdiv co cc wcel cc0 vr cv clt wbr vr cv cr wcel vr cv c2
      cdiv co vr cv rehalfcl recnd adantr vx cv cL cfv cc wcel vx cv cL cfv cc0
      wne c1 vx cv cL cfv cdiv co cc wcel vx cv cX wcel vx cv cZ wne wa vx cv
      cL cfv reccl vx cv cX wcel vx cv cL cfv cc wcel vx cv cZ wne vx cv cX
      wcel vx cv cL cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel
      ubthlem7.7 vx cv cU cL cX ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr vx
      cv cX wcel vx cv cL cfv cc0 wne vx cv cZ wne vx cv cX wcel vx cv cL cfv
      cc0 vx cv cZ cU cnv wcel vx cv cX wcel vx cv cL cfv cc0 wceq vx cv cZ
      wceq wb ubthlem7.7 vx cv cU cL cX cZ ubthlem7.1 ubthlem7.z ubthlem7.n nvz
      mpan necon3bid biimpar sylanc syl2an vr cv cr wcel cc0 vr cv clt wbr wa
      vx cv cX wcel vx cv cZ wne simprl syl3anc adantl vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa c2 vr cv
      cdiv co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co
      cmul co cmul co c1 vx cv cR vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
      wcel vx cv cZ wne wa wa c2 vr cv cdiv co vx cv cL cfv cmul co vr cv c2
      cdiv co c1 vx cv cL cfv cdiv co cmul co cmul co c1 wceq vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa c2 vr cv
      cdiv co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co
      cmul co cmul co c2 vr cv cdiv co vr cv c2 cdiv co cmul co vx cv cL cfv c1
      vx cv cL cfv cdiv co cmul co cmul co c1 c2 vr cv cdiv co cc wcel vx cv cL
      cfv cc wcel wa vr cv c2 cdiv co cc wcel c1 vx cv cL cfv cdiv co cc wcel
      wa c2 vr cv cdiv co vx cv cL cfv cmul co vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co cmul co c2 vr cv cdiv co vr cv c2 cdiv co cmul co vx cv
      cL cfv c1 vx cv cL cfv cdiv co cmul co cmul co wceq vr cv cr wcel cc0 vr
      cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa c2 vr cv cdiv co vx cv cL
      cfv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co mul4 vr cv cr wcel cc0 vr cv
      clt wbr wa c2 vr cv cdiv co cc wcel vx cv cX wcel vx cv cZ wne wa vx cv
      cL cfv cc wcel vr cv cc wcel vr cv cc0 wne c2 vr cv cdiv co cc wcel vr cv
      cr wcel cc0 vr cv clt wbr wa c2 cc wcel vr cv cc wcel vr cv cc0 wne c2 vr
      cv cdiv co cc wcel 2cn c2 vr cv divcl mp3an1 vr cv cr wcel cc0 vr cv clt
      wbr wa vr cv vr cv cr wcel cc0 vr cv clt wbr pm3.26 recnd vr cv gt0ne0
      sylanc vx cv cX wcel vx cv cL cfv cc wcel vx cv cZ wne vx cv cX wcel vx
      cv cL cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem7.7 vx cv
      cU cL cX ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr anim12i vr cv cr
      wcel cc0 vr cv clt wbr wa vr cv c2 cdiv co cc wcel vx cv cX wcel vx cv cZ
      wne wa c1 vx cv cL cfv cdiv co cc wcel vr cv cr wcel vr cv c2 cdiv co cc
      wcel cc0 vr cv clt wbr vr cv cr wcel vr cv c2 cdiv co vr cv rehalfcl
      recnd adantr vx cv cL cfv cc wcel vx cv cL cfv cc0 wne c1 vx cv cL cfv
      cdiv co cc wcel vx cv cX wcel vx cv cZ wne wa vx cv cL cfv reccl vx cv cX
      wcel vx cv cL cfv cc wcel vx cv cZ wne vx cv cX wcel vx cv cL cfv cU cnv
      wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem7.7 vx cv cU cL cX
      ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr vx cv cX wcel vx cv cL cfv
      cc0 wne vx cv cZ wne vx cv cX wcel vx cv cL cfv cc0 vx cv cZ cU cnv wcel
      vx cv cX wcel vx cv cL cfv cc0 wceq vx cv cZ wceq wb ubthlem7.7 vx cv cU
      cL cX cZ ubthlem7.1 ubthlem7.z ubthlem7.n nvz mpan necon3bid biimpar
      sylanc anim12i sylanc vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx
      cv cZ wne wa wa c2 vr cv cdiv co vr cv c2 cdiv co cmul co vx cv cL cfv c1
      vx cv cL cfv cdiv co cmul co cmul co c1 c1 cmul co c1 vr cv cr wcel cc0
      vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa c2 vr cv cdiv co vr cv c2
      cdiv co cmul co c1 vx cv cL cfv c1 vx cv cL cfv cdiv co cmul co c1 cmul
      vr cv cc wcel vr cv cc0 wne c2 vr cv cdiv co vr cv c2 cdiv co cmul co c1
      wceq vr cv cr wcel cc0 vr cv clt wbr wa c2 cc wcel c2 cc0 wne vr cv cc
      wcel vr cv cc0 wne wa c2 vr cv cdiv co vr cv c2 cdiv co cmul co c1 wceq
      2cn 2ne0 c2 vr cv divcan6 mpanl12 vr cv cr wcel cc0 vr cv clt wbr wa vr
      cv vr cv cr wcel cc0 vr cv clt wbr pm3.26 recnd vr cv gt0ne0 sylanc vx cv
      cL cfv cc wcel vx cv cL cfv cc0 wne vx cv cL cfv c1 vx cv cL cfv cdiv co
      cmul co c1 wceq vx cv cX wcel vx cv cZ wne wa vx cv cL cfv recid vx cv cX
      wcel vx cv cL cfv cc wcel vx cv cZ wne vx cv cX wcel vx cv cL cfv cU cnv
      wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem7.7 vx cv cU cL cX
      ubthlem7.1 ubthlem7.n nvcl mpan recnd adantr vx cv cX wcel vx cv cL cfv
      cc0 wne vx cv cZ wne vx cv cX wcel vx cv cL cfv cc0 vx cv cZ cU cnv wcel
      vx cv cX wcel vx cv cL cfv cc0 wceq vx cv cZ wceq wb ubthlem7.7 vx cv cU
      cL cX cZ ubthlem7.1 ubthlem7.z ubthlem7.n nvz mpan necon3bid biimpar
      sylanc opreqan12d c1 ax1cn mulid1i syl6eq eqtrd adantl opreq1d 3eqtr2rd
      eqtr3d $.
      $( [17-Jan-2008] $) $( [28-Dec-2007] $)

    ${
      ubthlem9.5 $e |- B = ( U BLnOp W ) $.
      ubthlem9.6 $e |- T : NN --> B $.
      ubthlem9.8 $e |- W e. NrmCVec $.
      ubthlem9.s $e |- S = ( .s ` W ) $.
      $( Lemma for ~ ubthi .  Evaluate the operator value at ` x ` in terms of
         the operator value at ` Q - p ` . $)
      ubthlem9 $p |- ( ( n e. NN /\ ( p e. X /\ ( ( r e. RR /\ 0 < r ) /\
       ( x e. X /\ x =/= Z ) ) ) ) -> ( ( T ` n ) ` x ) =
           ( ( ( 2 / r ) x. ( L ` x ) ) S ( ( T ` n ) ` ( Q M p ) ) ) ) $=
        vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
        wcel vx cv cZ wne wa wa wa wa vx cv vn cv cT cfv cfv c2 vr cv cdiv co
        vx cv cL cfv cmul co cQ vp cv cM co cR co vn cv cT cfv cfv c2 vr cv
        cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cS co vp
        cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ
        wne wa wa wa vx cv vn cv cT cfv cfv c2 vr cv cdiv co vx cv cL cfv cmul
        co cQ vp cv cM co cR co vn cv cT cfv cfv wceq vn cv cn wcel vp cv cX
        wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
        wa wa vx cv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co cR co
        vn cv cT cfv vx cQ cR cU cG cL cM cX cZ vr vp ubthlem7.1 ubthlem7.7
        ubthlem7.n ubthlem7.g ubthlem7.m ubthlem7.r ubthlem7.z ubthlem7.q
        ubthlem8 fveq2d adantl vn cv cT cfv cU cW clno co wcel c2 vr cv cdiv co
        vx cv cL cfv cmul co cc wcel cQ vp cv cM co cX wcel wa c2 vr cv cdiv co
        vx cv cL cfv cmul co cQ vp cv cM co cR co vn cv cT cfv cfv c2 vr cv
        cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cS co wceq
        vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
        wcel vx cv cZ wne wa wa wa cW cnv wcel vn cv cT cfv cU cW clno co wcel
        c2 vr cv cdiv co vx cv cL cfv cmul co cc wcel cQ vp cv cM co cX wcel wa
        c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co cR co vn cv cT cfv
        cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv
        cfv cS co wceq ubthlem9.8 cU cnv wcel cW cnv wcel vn cv cT cfv cU cW
        clno co wcel c2 vr cv cdiv co vx cv cL cfv cmul co cc wcel cQ vp cv cM
        co cX wcel wa c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co cR
        co vn cv cT cfv cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM
        co vn cv cT cfv cfv cS co wceq ubthlem7.7 c2 vr cv cdiv co vx cv cL cfv
        cmul co cQ vp cv cM co cR cS vn cv cT cfv cU cU cW clno co cW cX
        ubthlem7.1 ubthlem7.r ubthlem9.s cU cW clno co eqid lnomul mp3anl1
        mpanl1 vn cv cn wcel vn cv cT cfv cB wcel vn cv cT cfv cU cW clno co
        wcel cn cB vn cv cT ubthlem9.6 ffvelrni cU cnv wcel cW cnv wcel vn cv
        cT cfv cB wcel vn cv cT cfv cU cW clno co wcel ubthlem7.7 ubthlem9.8 cB
        vn cv cT cfv cU cU cW clno co cW cU cW clno co eqid ubthlem9.5 bloln
        mp3an12 syl vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
        wcel vx cv cZ wne wa wa wa c2 vr cv cdiv co vx cv cL cfv cmul co cc
        wcel cQ vp cv cM co cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
        wcel vx cv cZ wne wa wa c2 vr cv cdiv co vx cv cL cfv cmul co cc wcel
        vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv
        cdiv co vx cv cL cfv cmul co cc wcel vx cv cZ wne c2 vr cv cdiv co cc
        wcel vx cv cL cfv cc wcel c2 vr cv cdiv co vx cv cL cfv cmul co cc wcel
        vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv
        cL cfv mulcl vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv
        cdiv co cc wcel vr cv gt0ne0 vr cv cc wcel vr cv cc0 wne c2 vr cv cdiv
        co cc wcel vr cv cr wcel c2 cc wcel vr cv cc wcel vr cv cc0 wne c2 vr
        cv cdiv co cc wcel 2cn c2 vr cv divcl mp3an1 vr cv recn sylan syldan vx
        cv cX wcel vx cv cL cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel
        ubthlem7.7 vx cv cU cL cX ubthlem7.1 ubthlem7.n nvcl mpan recnd syl2an
        adantrr adantl cQ cX wcel vp cv cX wcel cQ vp cv cM co cX wcel vp cv cX
        wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
        wa wa cU cnv wcel cQ cX wcel vp cv cX wcel cQ vp cv cM co cX wcel
        ubthlem7.7 cQ vp cv cU cM cX ubthlem7.1 ubthlem7.m nvmcl mp3an1 vp cv
        cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa cQ cX wcel cc0 vr
        cv clt wbr vx cQ cR cU cG cL cM cX cZ vr vp ubthlem7.1 ubthlem7.7
        ubthlem7.n ubthlem7.g ubthlem7.m ubthlem7.r ubthlem7.z ubthlem7.q
        ubthlem7 adantrlr vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx
        cv cX wcel vx cv cZ wne wa wa pm3.26 sylanc jca syl2an eqtrd $.
        $( [17-Jan-2008] $) $( [28-Dec-2007] $)
    $}
  $}

  ${
    $d c k n p r x A $.  $d k n p r x D $.  $d x L $.  $d h j k n x y z N $.
    $d d k p r O $.  $d h n z Q $.  $d d h j k n p r x y z T $.
    $d x U $.  $d x W $.  $d c j k n r x y z X $.
    ubthlem10.1 $e |- X = ( BaseSet ` U ) $.
    ubthlem10.2 $e |- Y = ( BaseSet ` W ) $.
    ubthlem10.3 $e |- N = ( norm ` W ) $.
    ubthlem10.4 $e |- O = ( U normOp W ) $.
    ubthlem10.5 $e |- B = ( U BLnOp W ) $.
    ubthlem10.6 $e |- T : NN --> B $.
    ubthlem10.7 $e |- U e. NrmCVec $.
    ubthlem10.8 $e |- W e. NrmCVec $.
    ubthlem10.9 $e |- D = ( IndMet ` U ) $.
    ubthlem10.n $e |- L = ( norm ` U ) $.
    ubthlem10.g $e |- G = ( +v ` U ) $.
    ubthlem10.m $e |- M = ( -v ` U ) $.
    ubthlem10.r $e |- R = ( .s ` U ) $.
    ubthlem10.z $e |- Z = ( 0v ` U ) $.
    ubthlem10.11 $e |- A = { <. j , y >. | ( j e. NN /\ y = { z e. X |
       A. h e. NN ( N ` ( ( T ` h ) ` z ) ) <_ j } ) } $.
    ubthlem10.q $e |- Q =
            ( p G ( ( ( r / 2 ) x. ( 1 / ( L ` x ) ) ) R x ) ) $.
    $( Lemma for ~ ubthi .  Upper limit for the norm of an operator value at
       auxiliary vector ` Q ` . $)
    ubthlem10 $p |- ( ( ( k e. NN /\ n e. NN ) /\ ( ( p e. X /\ ( ( r e. RR /\
   0 < r ) /\ ( x e. X /\ x =/= Z ) ) ) /\ ( p ( ball ` D ) r ) C_ ( A ` k ) )
        ) -> ( N ` ( ( T ` n ) ` Q ) ) <_ k ) $=
      vk cv cn wcel vn cv cn wcel wa cQ vk cv cA cfv wcel cQ vn cv cT cfv cfv
      cN cfv vk cv cle wbr vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx
      cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv
      wss wa vk cv cn wcel vn cv cn wcel cQ vk cv cA cfv wcel cQ vn cv cT cfv
      cfv cN cfv vk cv cle wbr cQ vk cv cA cfv wcel vk cv cn wcel vn cv cn wcel
      cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vk cv cn wcel cQ vk cv cA cfv
      wcel cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral vn cv cn wcel cQ
      vn cv cT cfv cfv cN cfv vk cv cle wbr wi vk cv cn wcel cQ vk cv cA cfv
      wcel cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral vk cv cn wcel cQ
      vk cv cA cfv wcel cQ cX wcel cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vn
      cn wral vy vz cA cQ cT cU vh vj vk vn cN cX ubthlem10.1 ubthlem10.11
      ubthlem1 pm3.27bda ex cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn ra4
      syl6com com3l imp31 cQ vp cv vr cv cD cbl cfv co wcel vp cv vr cv cD cbl
      cfv co vk cv cA cfv wss cQ vk cv cA cfv wcel vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD
      cbl cfv co vk cv cA cfv wss cQ vp cv vr cv cD cbl cfv co wcel cQ vk cv cA
      cfv wcel vp cv vr cv cD cbl cfv co vk cv cA cfv cQ ssel impcom vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa vp cv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG
      co vp cv vr cv cD cbl cfv co cQ vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv c2 cdiv co c1 vx
      cv cL cfv cdiv co cmul co vx cv cR co cG co vp cv vr cv cD cbl cfv co
      wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cL cfv
      vr cv clt wbr vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ
      wne wa wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cL
      cfv vr cv clt wbr vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv
      cX wcel vx cv cZ wne wa wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul
      co vx cv cR co cL cfv vr cv c2 cdiv co vr cv clt vr cv cr wcel cc0 vr cv
      clt wbr wa vx cv cX wcel vx cv cZ wne wa wa vr cv c2 cdiv co c1 vx cv cL
      cfv cdiv co cmul co vx cv cR co cL cfv vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co vx cv cR co cL cfv cmul co vr cv c2 cdiv co c1 cmul co vr cv c2
      cdiv co vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
      wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cL cfv vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co vx cv cR co cR co cL cfv vr cv c2
      cdiv co c1 vx cv cL cfv cdiv co vx cv cR co cL cfv cmul co vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa vr cv c2 cdiv co c1
      vx cv cL cfv cdiv co cmul co vx cv cR co vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co vx cv cR co cR co cL vr cv cr wcel vx cv cX wcel vx cv cZ wne wa
      vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co vr cv c2
      cdiv co c1 vx cv cL cfv cdiv co vx cv cR co cR co wceq cc0 vr cv clt wbr
      vr cv c2 cdiv co cc wcel c1 vx cv cL cfv cdiv co cc wcel vx cv cX wcel vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co vr cv c2 cdiv
      co c1 vx cv cL cfv cdiv co vx cv cR co cR co wceq vr cv cr wcel vx cv cX
      wcel vx cv cZ wne wa wa cU cnv wcel vr cv c2 cdiv co cc wcel c1 vx cv cL
      cfv cdiv co cc wcel vx cv cX wcel w3a vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR co vr cv c2 cdiv co c1 vx cv cL cfv cdiv co vx
      cv cR co cR co wceq ubthlem10.7 vr cv c2 cdiv co c1 vx cv cL cfv cdiv co
      vx cv cR cU cX ubthlem10.1 ubthlem10.r nvsass mpan vr cv cr wcel vr cv c2
      cdiv co cc wcel vx cv cX wcel vx cv cZ wne wa vr cv cr wcel vr cv c2 cdiv
      co vr cv rehalfcl recnd adantr vx cv cX wcel vx cv cZ wne wa c1 vx cv cL
      cfv cdiv co cc wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa c1 vx cv
      cL cfv cdiv co vx cv cL cfv cr wcel vx cv cL cfv cc0 wne c1 vx cv cL cfv
      cdiv co cr wcel vx cv cX wcel vx cv cZ wne wa vx cv cL cfv rereccl vx cv
      cX wcel vx cv cL cfv cr wcel vx cv cZ wne cU cnv wcel vx cv cX wcel vx cv
      cL cfv cr wcel ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl
      mpan adantr vx cv cX wcel vx cv cL cfv cc0 wne vx cv cZ wne vx cv cX wcel
      vx cv cL cfv cc0 vx cv cZ cU cnv wcel vx cv cX wcel vx cv cL cfv cc0 wceq
      vx cv cZ wceq wb ubthlem10.7 vx cv cU cL cX cZ ubthlem10.1 ubthlem10.z
      ubthlem10.n nvz mpan necon3bid biimpar sylanc recnd adantl vr cv cr wcel
      vx cv cX wcel vx cv cZ wne simprl syl3anc adantlr fveq2d vr cv c2 cdiv co
      cr wcel cc0 vr cv c2 cdiv co cle wbr wa c1 vx cv cL cfv cdiv co vx cv cR
      co cX wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co vx cv cR co cR co cL
      cfv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co vx cv cR co cL cfv cmul co
      wceq vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa cU
      cnv wcel vr cv c2 cdiv co cr wcel cc0 vr cv c2 cdiv co cle wbr wa c1 vx
      cv cL cfv cdiv co vx cv cR co cX wcel vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co vx cv cR co cR co cL cfv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co
      vx cv cR co cL cfv cmul co wceq ubthlem10.7 vr cv c2 cdiv co c1 vx cv cL
      cfv cdiv co vx cv cR co cR cU cL cX ubthlem10.1 ubthlem10.r ubthlem10.n
      nvsge0 mp3an1 vr cv cr wcel cc0 vr cv clt wbr wa vr cv c2 cdiv co cr wcel
      cc0 vr cv c2 cdiv co cle wbr vr cv cr wcel vr cv c2 cdiv co cr wcel cc0
      vr cv clt wbr vr cv rehalfcl adantr vr cv cr wcel cc0 vr cv clt wbr wa
      cc0 vr cv c2 cdiv co clt wbr cc0 vr cv c2 cdiv co cle wbr vr cv cr wcel
      cc0 vr cv clt wbr cc0 vr cv c2 cdiv co clt wbr vr cv halfpos2 biimpa vr
      cv cr wcel cc0 vr cv c2 cdiv co clt wbr cc0 vr cv c2 cdiv co cle wbr wi
      cc0 vr cv clt wbr vr cv cr wcel vr cv c2 cdiv co cr wcel cc0 vr cv c2
      cdiv co clt wbr cc0 vr cv c2 cdiv co cle wbr wi vr cv rehalfcl cc0 cr
      wcel vr cv c2 cdiv co cr wcel cc0 vr cv c2 cdiv co clt wbr cc0 vr cv c2
      cdiv co cle wbr wi 0re cc0 vr cv c2 cdiv co ltle mpan syl adantr mpd jca
      c1 vx cv cL cfv cdiv co cc wcel vx cv cX wcel c1 vx cv cL cfv cdiv co vx
      cv cR co cX wcel vx cv cX wcel vx cv cZ wne wa cU cnv wcel c1 vx cv cL
      cfv cdiv co cc wcel vx cv cX wcel c1 vx cv cL cfv cdiv co vx cv cR co cX
      wcel ubthlem10.7 c1 vx cv cL cfv cdiv co vx cv cR cU cX ubthlem10.1
      ubthlem10.r nvscl mp3an1 vx cv cX wcel vx cv cZ wne wa c1 vx cv cL cfv
      cdiv co vx cv cL cfv cr wcel vx cv cL cfv cc0 wne c1 vx cv cL cfv cdiv co
      cr wcel vx cv cX wcel vx cv cZ wne wa vx cv cL cfv rereccl vx cv cX wcel
      vx cv cL cfv cr wcel vx cv cZ wne cU cnv wcel vx cv cX wcel vx cv cL cfv
      cr wcel ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl mpan
      adantr vx cv cX wcel vx cv cL cfv cc0 wne vx cv cZ wne vx cv cX wcel vx
      cv cL cfv cc0 vx cv cZ cU cnv wcel vx cv cX wcel vx cv cL cfv cc0 wceq vx
      cv cZ wceq wb ubthlem10.7 vx cv cU cL cX cZ ubthlem10.1 ubthlem10.z
      ubthlem10.n nvz mpan necon3bid biimpar sylanc recnd vx cv cX wcel vx cv
      cZ wne pm3.26 sylanc syl2an eqtrd vx cv cX wcel vx cv cZ wne wa vr cv c2
      cdiv co c1 vx cv cL cfv cdiv co vx cv cR co cL cfv cmul co vr cv c2 cdiv
      co c1 cmul co wceq vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa c1 vx cv cL cfv cdiv co vx cv cR co cL cfv c1 vr cv c2 cdiv co
      cmul cU cnv wcel vx cv cX wcel vx cv cZ wne c1 vx cv cL cfv cdiv co vx cv
      cR co cL cfv c1 wceq ubthlem10.7 vx cv cR cU cL cX cZ ubthlem10.1
      ubthlem10.r ubthlem10.z ubthlem10.n nv1 mp3an1 opreq2d adantl vr cv cr
      wcel vr cv c2 cdiv co c1 cmul co vr cv c2 cdiv co wceq cc0 vr cv clt wbr
      vx cv cX wcel vx cv cZ wne wa vr cv cr wcel vr cv c2 cdiv co cc wcel vr
      cv c2 cdiv co c1 cmul co vr cv c2 cdiv co wceq vr cv cr wcel vr cv c2
      cdiv co vr cv rehalfcl recnd vr cv c2 cdiv co ax1id syl ad2antrr 3eqtrd
      vr cv cr wcel cc0 vr cv clt wbr wa vr cv c2 cdiv co vr cv clt wbr vx cv
      cX wcel vx cv cZ wne wa vr cv cr wcel cc0 vr cv clt wbr vr cv c2 cdiv co
      vr cv clt wbr vr cv halfpos biimpa adantr eqbrtrd adantl vp cv cX wcel vr
      cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cX wcel wa vr
      cv cr wcel cc0 vr cv clt wbr wa vp cv vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR co cG co vp cv vr cv cD cbl cfv co wcel vr cv c2
      cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cL cfv vr cv clt wbr
      wb vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa wa wa cU cnv wcel vp cv cX wcel vr cv c2 cdiv co c1 vx cv cL
      cfv cdiv co cmul co vx cv cR co cX wcel vr cv cr wcel cc0 vr cv clt wbr
      wa vp cv vr cv c2 cdiv co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cG
      co vp cv vr cv cD cbl cfv co wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv
      co cmul co vx cv cR co cL cfv vr cv clt wbr wb ubthlem10.7 vr cv c2 cdiv
      co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cD vp cv vr cv cU cG cL cX
      ubthlem10.1 ubthlem10.g ubthlem10.n ubthlem10.9 nvelbl2 mp3anl1 vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa vr cv c2 cdiv
      co c1 vx cv cL cfv cdiv co cmul co vx cv cR co cX wcel vp cv cX wcel vr
      cv cr wcel vx cv cX wcel vx cv cZ wne wa vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR co cX wcel cc0 vr cv clt wbr vr cv c2 cdiv co c1
      vx cv cL cfv cdiv co cmul co cc wcel vx cv cX wcel vr cv c2 cdiv co c1 vx
      cv cL cfv cdiv co cmul co vx cv cR co cX wcel vr cv cr wcel vx cv cX wcel
      vx cv cZ wne wa wa cU cnv wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co
      cmul co cc wcel vx cv cX wcel vr cv c2 cdiv co c1 vx cv cL cfv cdiv co
      cmul co vx cv cR co cX wcel ubthlem10.7 vr cv c2 cdiv co c1 vx cv cL cfv
      cdiv co cmul co vx cv cR cU cX ubthlem10.1 ubthlem10.r nvscl mp3an1 vr cv
      c2 cdiv co cc wcel c1 vx cv cL cfv cdiv co cc wcel vr cv c2 cdiv co c1 vx
      cv cL cfv cdiv co cmul co cc wcel vr cv cr wcel vx cv cX wcel vx cv cZ
      wne wa vr cv c2 cdiv co c1 vx cv cL cfv cdiv co mulcl vr cv cr wcel vr cv
      c2 cdiv co vr cv rehalfcl recnd vx cv cL cfv cc wcel vx cv cL cfv cc0 wne
      c1 vx cv cL cfv cdiv co cc wcel vx cv cX wcel vx cv cZ wne wa vx cv cL
      cfv reccl vx cv cX wcel vx cv cL cfv cc wcel vx cv cZ wne vx cv cX wcel
      vx cv cL cfv cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7
      vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl mpan recnd adantr vx cv cX
      wcel vx cv cL cfv cc0 wne vx cv cZ wne vx cv cX wcel vx cv cL cfv cc0 vx
      cv cZ cU cnv wcel vx cv cX wcel vx cv cL cfv cc0 wceq vx cv cZ wceq wb
      ubthlem10.7 vx cv cU cL cX cZ ubthlem10.1 ubthlem10.z ubthlem10.n nvz
      mpan necon3bid biimpar sylanc syl2an vr cv cr wcel vx cv cX wcel vx cv cZ
      wne simprl sylanc adantlr anim2i vp cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa vx cv cX wcel vx cv cZ wne wa simprl sylanc mpbird ubthlem10.q
      syl5eqel sylan sylan2 $.
      $( [11-Jan-2008] $) $( [27-Dec-2007] $)

    $( Lemma for ~ ubthi .  Upper limit for the norm of an operator value at
       ` Q - p ` . $)
    ubthlem11 $p |- ( ( ( k e. NN /\ n e. NN ) /\ ( ( p e. X /\ ( ( r e. RR
  /\ 0 < r ) /\ ( x e. X /\ x =/= Z ) ) ) /\ ( p ( ball ` D ) r ) C_ ( A ` k )
        ) ) -> ( N ` ( ( T ` n ) ` ( Q M p ) ) ) <_ ( 2 x. k ) ) $=
      vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk
      cv cA cfv wss wa wa cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb
      cfv co cN cfv vk cv vk cv caddc co cQ vp cv cM co vn cv cT cfv cfv cN cfv
      c2 vk cv cmul co cle vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv
      cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr
      cv cD cbl cfv co vk cv cA cfv wss wa wa cQ vn cv cT cfv cfv vp cv vn cv
      cT cfv cfv cW cnsb cfv co cN cfv cQ vn cv cT cfv cfv cN cfv vp cv vn cv
      cT cfv cfv cN cfv caddc co vk cv vk cv caddc co vn cv cn wcel vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cN cfv cr
      wcel vk cv cn wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss vn cv cn
      wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa wa wa wa cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv
      co cY wcel cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cN
      cfv cr wcel cQ vn cv cT cfv cfv cY wcel vp cv vn cv cT cfv cfv cY wcel cQ
      vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cY wcel vn cv cn
      wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa wa wa wa cW cnv wcel cQ vn cv cT cfv cfv cY wcel vp cv vn cv cT
      cfv cfv cY wcel cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co
      cY wcel ubthlem10.8 cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cW cnsb
      cfv cY ubthlem10.2 cW cnsb cfv eqid nvmcl mp3an1 cX cY vn cv cT cfv wf cQ
      cX wcel cQ vn cv cT cfv cfv cY wcel vn cv cn wcel vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cX cY cQ vn
      cv cT cfv ffvelrn vn cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv
      wf cn cB vn cv cT ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT
      cfv cB wcel cX cY vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv
      cU cW cX cY ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp cv cX
      wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa cQ cX wcel cc0 vr cv clt
      wbr vx cQ cR cU cG cL cM cX cZ vr vp ubthlem10.1 ubthlem10.7 ubthlem10.n
      ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q ubthlem7
      adantrlr syl2an vn cv cn wcel vp cv cX wcel vp cv vn cv cT cfv cfv cY
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      cX cY vn cv cT cfv wf vp cv cX wcel vp cv vn cv cT cfv cfv cY wcel vn cv
      cn wcel cX cY vp cv vn cv cT cfv ffvelrn vn cv cn wcel vn cv cT cfv cB
      wcel cX cY vn cv cT cfv wf cn cB vn cv cT ubthlem10.6 ffvelrni cU cnv
      wcel cW cnv wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf ubthlem10.7
      ubthlem10.8 cB vn cv cT cfv cU cW cX cY ubthlem10.1 ubthlem10.2
      ubthlem10.5 blof mp3an12 syl sylan adantrr sylanc cW cnv wcel cQ vn cv cT
      cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cY wcel cQ vn cv cT cfv cfv
      vp cv vn cv cT cfv cfv cW cnsb cfv co cN cfv cr wcel ubthlem10.8 cQ vn cv
      cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cW cN cY ubthlem10.2
      ubthlem10.3 nvcl mpan syl ad2ant2lr vn cv cn wcel vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ vn cv cT
      cfv cfv cN cfv vp cv vn cv cT cfv cfv cN cfv caddc co cr wcel vk cv cn
      wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss cQ vn cv cT cfv cfv cN
      cfv cr wcel vp cv vn cv cT cfv cfv cN cfv cr wcel cQ vn cv cT cfv cfv cN
      cfv vp cv vn cv cT cfv cfv cN cfv caddc co cr wcel vn cv cn wcel vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa wa cQ vn cv cT cfv cfv cN cfv vp cv vn cv cT cfv cfv cN cfv readdcl vn
      cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel
      vx cv cZ wne wa wa wa wa cQ vn cv cT cfv cfv cY wcel cQ vn cv cT cfv cfv
      cN cfv cr wcel cX cY vn cv cT cfv wf cQ cX wcel cQ vn cv cT cfv cfv cY
      wcel vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv
      cX wcel vx cv cZ wne wa wa wa cX cY cQ vn cv cT cfv ffvelrn vn cv cn wcel
      vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn cB vn cv cT ubthlem10.6
      ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv
      wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW cX cY ubthlem10.1
      ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp cv cX wcel vr cv cr wcel vx
      cv cX wcel vx cv cZ wne wa cQ cX wcel cc0 vr cv clt wbr vx cQ cR cU cG cL
      cM cX cZ vr vp ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g
      ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q ubthlem7 adantrlr syl2an
      cW cnv wcel cQ vn cv cT cfv cfv cY wcel cQ vn cv cT cfv cfv cN cfv cr
      wcel ubthlem10.8 cQ vn cv cT cfv cfv cW cN cY ubthlem10.2 ubthlem10.3
      nvcl mpan syl vn cv cn wcel vp cv cX wcel vp cv vn cv cT cfv cfv cN cfv
      cr wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
      wa vn cv cn wcel vp cv cX wcel wa vp cv vn cv cT cfv cfv cY wcel vp cv vn
      cv cT cfv cfv cN cfv cr wcel cX cY vn cv cT cfv wf vp cv cX wcel vp cv vn
      cv cT cfv cfv cY wcel vn cv cn wcel cX cY vp cv vn cv cT cfv ffvelrn vn
      cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn cB vn cv cT
      ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel cX cY
      vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW cX cY
      ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl sylan cW cnv wcel vp
      cv vn cv cT cfv cfv cY wcel vp cv vn cv cT cfv cfv cN cfv cr wcel
      ubthlem10.8 vp cv vn cv cT cfv cfv cW cN cY ubthlem10.2 ubthlem10.3 nvcl
      mpan syl adantrr sylanc ad2ant2lr vk cv cn wcel vk cv vk cv caddc co cr
      wcel vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv
      cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss
      wa vk cv cr wcel vk cv cr wcel vk cv vk cv caddc co cr wcel vk cv cn wcel
      vk cv vk cv readdcl vk cv nnre vk cv nnre sylanc ad2antrr vn cv cn wcel
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ
      wne wa wa wa cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cN
      cfv cQ vn cv cT cfv cfv cN cfv vp cv vn cv cT cfv cfv cN cfv caddc co cle
      wbr vk cv cn wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss cQ vn cv cT
      cfv cfv cY wcel vp cv vn cv cT cfv cfv cY wcel cQ vn cv cT cfv cfv vp cv
      vn cv cT cfv cfv cW cnsb cfv co cN cfv cQ vn cv cT cfv cfv cN cfv vp cv
      vn cv cT cfv cfv cN cfv caddc co cle wbr vn cv cn wcel vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa cW
      cnv wcel cQ vn cv cT cfv cfv cY wcel vp cv vn cv cT cfv cfv cY wcel cQ vn
      cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cN cfv cQ vn cv cT
      cfv cfv cN cfv vp cv vn cv cT cfv cfv cN cfv caddc co cle wbr ubthlem10.8
      cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cW cnsb cfv cN cY
      ubthlem10.2 cW cnsb cfv eqid ubthlem10.3 nvmtri mp3an1 cX cY vn cv cT cfv
      wf cQ cX wcel cQ vn cv cT cfv cfv cY wcel vn cv cn wcel vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cX cY
      cQ vn cv cT cfv ffvelrn vn cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT
      cfv wf cn cB vn cv cT ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv
      cT cfv cB wcel cX cY vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT
      cfv cU cW cX cY ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp
      cv cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa cQ cX wcel cc0 vr
      cv clt wbr vx cQ cR cU cG cL cM cX cZ vr vp ubthlem10.1 ubthlem10.7
      ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q
      ubthlem7 adantrlr syl2an vn cv cn wcel vp cv cX wcel vp cv vn cv cT cfv
      cfv cY wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne
      wa wa cX cY vn cv cT cfv wf vp cv cX wcel vp cv vn cv cT cfv cfv cY wcel
      vn cv cn wcel cX cY vp cv vn cv cT cfv ffvelrn vn cv cn wcel vn cv cT cfv
      cB wcel cX cY vn cv cT cfv wf cn cB vn cv cT ubthlem10.6 ffvelrni cU cnv
      wcel cW cnv wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf ubthlem10.7
      ubthlem10.8 cB vn cv cT cfv cU cW cX cY ubthlem10.1 ubthlem10.2
      ubthlem10.5 blof mp3an12 syl sylan adantrr sylanc ad2ant2lr vk cv cn wcel
      vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv
      cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss
      wa wa cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vp cv vn cv cT cfv cfv cN
      cfv vk cv cle wbr cQ vn cv cT cfv cfv cN cfv vp cv vn cv cT cfv cfv cN
      cfv caddc co vk cv vk cv caddc co cle wbr vx vy vz cA cB cD cQ cR cT cU
      vh vj vk vn cG cL cM cN cO cW cX cY cZ vr vp ubthlem10.1 ubthlem10.2
      ubthlem10.3 ubthlem10.4 ubthlem10.5 ubthlem10.6 ubthlem10.7 ubthlem10.8
      ubthlem10.9 ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z
      ubthlem10.11 ubthlem10.q ubthlem10 vk cv cn wcel vn cv cn wcel wa vp cv
      vk cv cA cfv wcel vp cv vn cv cT cfv cfv cN cfv vk cv cle wbr vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa vk cv cn wcel vn cv cn
      wcel vp cv vk cv cA cfv wcel vp cv vn cv cT cfv cfv cN cfv vk cv cle wbr
      vp cv vk cv cA cfv wcel vk cv cn wcel vn cv cn wcel vp cv vn cv cT cfv
      cfv cN cfv vk cv cle wbr vk cv cn wcel vp cv vk cv cA cfv wcel vp cv vn
      cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral vn cv cn wcel vp cv vn cv
      cT cfv cfv cN cfv vk cv cle wbr wi vk cv cn wcel vp cv vk cv cA cfv wcel
      vp cv vn cv cT cfv cfv cN cfv vk cv cle wbr vn cn wral vk cv cn wcel vp
      cv vk cv cA cfv wcel vp cv cX wcel vp cv vn cv cT cfv cfv cN cfv vk cv
      cle wbr vn cn wral vy vz cA vp cv cT cU vh vj vk vn cN cX ubthlem10.1
      ubthlem10.11 ubthlem1 pm3.27bda ex vp cv vn cv cT cfv cfv cN cfv vk cv
      cle wbr vn cn ra4 syl6com com3l imp31 vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss vp cv vk cv cA
      cfv wcel vx cv cX wcel vx cv cZ wne wa vp cv vp cv vr cv cD cbl cfv co
      wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss vp cv vk cv cA cfv wcel
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl
      cfv co vk cv cA cfv wss vp cv vp cv vr cv cD cbl cfv co wcel vp cv vk cv
      cA cfv wcel vp cv vr cv cD cbl cfv co vk cv cA cfv vp cv ssel2 ancoms cD
      cme wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vp cv vp cv vr
      cv cD cbl cfv co wcel cU cnv wcel cD cme wcel ubthlem10.7 cD cU
      ubthlem10.9 imsmet ax-mp cD vp cv vr cv cX cD cU cX ubthlem10.1
      ubthlem10.9 ubthlem10.7 imsbai blcntr mpanl1 sylan adantlrr sylan2 cQ vn
      cv cT cfv cfv cN cfv cr wcel vp cv vn cv cT cfv cfv cN cfv cr wcel wa vk
      cv cr wcel vk cv cr wcel wa cQ vn cv cT cfv cfv cN cfv vk cv cle wbr vp
      cv vn cv cT cfv cfv cN cfv vk cv cle wbr wa cQ vn cv cT cfv cfv cN cfv vp
      cv vn cv cT cfv cfv cN cfv caddc co vk cv vk cv caddc co cle wbr wi vk cv
      cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
      vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk cv cA
      cfv wss wa wa cQ vn cv cT cfv cfv cN cfv vp cv vn cv cT cfv cfv cN cfv vk
      cv vk cv le2add vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ vn cv cT cfv cfv cN cfv cr
      wcel vp cv vn cv cT cfv cfv cN cfv cr wcel wa vk cv cn wcel vp cv vr cv
      cD cbl cfv co vk cv cA cfv wss vn cv cn wcel vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa cQ vn cv cT
      cfv cfv cN cfv cr wcel vp cv vn cv cT cfv cfv cN cfv cr wcel vn cv cn
      wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa wa wa wa cQ vn cv cT cfv cfv cY wcel cQ vn cv cT cfv cfv cN cfv
      cr wcel cX cY vn cv cT cfv wf cQ cX wcel cQ vn cv cT cfv cfv cY wcel vn
      cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel
      vx cv cZ wne wa wa wa cX cY cQ vn cv cT cfv ffvelrn vn cv cn wcel vn cv
      cT cfv cB wcel cX cY vn cv cT cfv wf cn cB vn cv cT ubthlem10.6 ffvelrni
      cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf
      ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW cX cY ubthlem10.1
      ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp cv cX wcel vr cv cr wcel vx
      cv cX wcel vx cv cZ wne wa cQ cX wcel cc0 vr cv clt wbr vx cQ cR cU cG cL
      cM cX cZ vr vp ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g
      ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q ubthlem7 adantrlr syl2an
      cW cnv wcel cQ vn cv cT cfv cfv cY wcel cQ vn cv cT cfv cfv cN cfv cr
      wcel ubthlem10.8 cQ vn cv cT cfv cfv cW cN cY ubthlem10.2 ubthlem10.3
      nvcl mpan syl vn cv cn wcel vp cv cX wcel vp cv vn cv cT cfv cfv cN cfv
      cr wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
      wa vn cv cn wcel vp cv cX wcel wa vp cv vn cv cT cfv cfv cY wcel vp cv vn
      cv cT cfv cfv cN cfv cr wcel cX cY vn cv cT cfv wf vp cv cX wcel vp cv vn
      cv cT cfv cfv cY wcel vn cv cn wcel cX cY vp cv vn cv cT cfv ffvelrn vn
      cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn cB vn cv cT
      ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel cX cY
      vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW cX cY
      ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl sylan cW cnv wcel vp
      cv vn cv cT cfv cfv cY wcel vp cv vn cv cT cfv cfv cN cfv cr wcel
      ubthlem10.8 vp cv vn cv cT cfv cfv cW cN cY ubthlem10.2 ubthlem10.3 nvcl
      mpan syl adantrr jca ad2ant2lr vk cv cn wcel vk cv cr wcel vk cv cr wcel
      wa vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv
      cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss
      wa vk cv cn wcel vk cv cr wcel vk cv cr wcel vk cv nnre vk cv nnre jca
      ad2antrr sylanc mp2and letrd vn cv cn wcel vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ vp cv cM co
      vn cv cT cfv cfv cN cfv cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW
      cnsb cfv co cN cfv wceq vk cv cn wcel vp cv vr cv cD cbl cfv co vk cv cA
      cfv wss vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx
      cv cX wcel vx cv cZ wne wa wa wa wa cQ vp cv cM co vn cv cT cfv cfv cQ vn
      cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co cN vn cv cT cfv cU cW
      clno co wcel cQ cX wcel vp cv cX wcel wa cQ vp cv cM co vn cv cT cfv cfv
      cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb cfv co wceq vn cv cn
      wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa wa wa cW cnv wcel vn cv cT cfv cU cW clno co wcel cQ cX wcel vp
      cv cX wcel wa cQ vp cv cM co vn cv cT cfv cfv cQ vn cv cT cfv cfv vp cv
      vn cv cT cfv cfv cW cnsb cfv co wceq ubthlem10.8 cU cnv wcel cW cnv wcel
      vn cv cT cfv cU cW clno co wcel cQ cX wcel vp cv cX wcel wa cQ vp cv cM
      co vn cv cT cfv cfv cQ vn cv cT cfv cfv vp cv vn cv cT cfv cfv cW cnsb
      cfv co wceq ubthlem10.7 cQ vp cv vn cv cT cfv cU cU cW clno co cM cW cnsb
      cfv cW cX ubthlem10.1 ubthlem10.m cW cnsb cfv eqid cU cW clno co eqid
      lnosub mp3anl1 mpanl1 vn cv cn wcel vn cv cT cfv cB wcel vn cv cT cfv cU
      cW clno co wcel cn cB vn cv cT ubthlem10.6 ffvelrni cU cnv wcel cW cnv
      wcel vn cv cT cfv cB wcel vn cv cT cfv cU cW clno co wcel ubthlem10.7
      ubthlem10.8 cB vn cv cT cfv cU cU cW clno co cW cU cW clno co eqid
      ubthlem10.5 bloln mp3an12 syl vp cv cX wcel vr cv cr wcel vx cv cX wcel
      vx cv cZ wne wa cQ cX wcel vp cv cX wcel wa cc0 vr cv clt wbr vp cv cX
      wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa wa wa cQ cX wcel vp cv
      cX wcel vx cQ cR cU cG cL cM cX cZ vr vp ubthlem10.1 ubthlem10.7
      ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q
      ubthlem7 vp cv cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa wa
      pm3.26 jca adantrlr syl2an fveq2d ad2ant2lr vk cv cn wcel c2 vk cv cmul
      co vk cv vk cv caddc co wceq vn cv cn wcel vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD
      cbl cfv co vk cv cA cfv wss wa vk cv cn wcel vk cv cc wcel c2 vk cv cmul
      co vk cv vk cv caddc co wceq vk cv nncn vk cv 2times syl ad2antrr 3brtr4d
      $.
      $( [13-Jan-2008] $) $( [31-Dec-2007] $)

    $( Lemma for ~ ubthi .  Upper limit for the norm of an operator value at
       ` x ` . $)
    ubthlem12 $p |- ( ( ( k e. NN /\ n e. NN ) /\ ( ( p e. X /\ (
  ( r e. RR /\ 0 < r ) /\ ( x e. X /\ x =/= Z ) ) ) /\ ( p ( ball ` D ) r ) C_
  ( A ` k ) ) ) -> ( N ` ( ( T ` n ) ` x ) ) <_ ( ( ( 2 / r ) x. ( 2 x. k ) )
         x. ( L ` x ) ) ) $=
      vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk
      cv cA cfv wss wa wa c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co
      vn cv cT cfv cfv cN cfv cmul co c2 vr cv cdiv co vx cv cL cfv cmul co c2
      vk cv cmul co cmul co vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2
      vk cv cmul co cmul co vx cv cL cfv cmul co cle cQ vp cv cM co vn cv cT
      cfv cfv cN cfv cr wcel c2 vk cv cmul co cr wcel c2 vr cv cdiv co vx cv cL
      cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa
      w3a cQ vp cv cM co vn cv cT cfv cfv cN cfv c2 vk cv cmul co cle wbr c2 vr
      cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv
      cmul co c2 vr cv cdiv co vx cv cL cfv cmul co c2 vk cv cmul co cmul co
      cle wbr vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv
      co vk cv cA cfv wss wa wa cQ vp cv cM co vn cv cT cfv cfv cN cfv c2 vk cv
      cmul co c2 vr cv cdiv co vx cv cL cfv cmul co lemul2a vk cv cn wcel vn cv
      cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel
      vx cv cZ wne wa wa wa cQ vp cv cM co vn cv cT cfv cfv cN cfv cr wcel c2
      vk cv cmul co cr wcel c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0
      c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa w3a vp cv vr cv cD cbl
      cfv co vk cv cA cfv wss vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa cQ
      vp cv cM co vn cv cT cfv cfv cN cfv cr wcel c2 vk cv cmul co cr wcel c2
      vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL
      cfv cmul co cle wbr wa vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ vp cv cM co vn cv cT
      cfv cfv cN cfv cr wcel vk cv cn wcel vn cv cn wcel vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa cQ vp cv
      cM co vn cv cT cfv cfv cY wcel cQ vp cv cM co vn cv cT cfv cfv cN cfv cr
      wcel cX cY vn cv cT cfv wf cQ vp cv cM co cX wcel cQ vp cv cM co vn cv cT
      cfv cfv cY wcel vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cX cY cQ vp cv cM co vn cv cT
      cfv ffvelrn vn cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn
      cB vn cv cT ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB
      wcel cX cY vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW
      cX cY ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa cQ cX
      wcel cQ vp cv cM co cX wcel vp cv cX wcel vr cv cr wcel vx cv cX wcel vx
      cv cZ wne wa cQ cX wcel cc0 vr cv clt wbr vx cQ cR cU cG cL cM cX cZ vr
      vp ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g ubthlem10.m
      ubthlem10.r ubthlem10.z ubthlem10.q ubthlem7 adantrlr cQ cX wcel vp cv cX
      wcel cQ vp cv cM co cX wcel cU cnv wcel cQ cX wcel vp cv cX wcel cQ vp cv
      cM co cX wcel ubthlem10.7 cQ vp cv cU cM cX ubthlem10.1 ubthlem10.m nvmcl
      mp3an1 ancoms syldan syl2an cW cnv wcel cQ vp cv cM co vn cv cT cfv cfv
      cY wcel cQ vp cv cM co vn cv cT cfv cfv cN cfv cr wcel ubthlem10.8 cQ vp
      cv cM co vn cv cT cfv cfv cW cN cY ubthlem10.2 ubthlem10.3 nvcl mpan syl
      adantll vk cv cn wcel c2 vk cv cmul co cr wcel vn cv cn wcel vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa vk cv cn wcel vk cv cr wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr
      wcel vk cv cr wcel c2 vk cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl
      ad2antrr vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
      wa c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx
      cv cL cfv cmul co cle wbr wa vk cv cn wcel vn cv cn wcel wa vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv
      cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr
      wa vx cv cZ wne vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel wa c2 vr
      cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv
      cmul co cle wbr c2 vr cv cdiv co cr wcel vx cv cL cfv cr wcel c2 vr cv
      cdiv co vx cv cL cfv cmul co cr wcel vr cv cr wcel cc0 vr cv clt wbr wa
      vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv remulcl vr cv cr wcel cc0 vr
      cv clt wbr vr cv cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel
      vr cv cr wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl
      mp3an1 syldan cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7
      vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl mpan syl2an c2 vr cv cdiv co
      cr wcel cc0 c2 vr cv cdiv co cle wbr wa vx cv cL cfv cr wcel cc0 vx cv cL
      cfv cle wbr wa cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv
      mulge0 vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co cr wcel cc0 c2
      vr cv cdiv co cle wbr vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr
      cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2
      vr cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan c2 cr wcel cc0
      c2 cle wbr vr cv cr wcel cc0 vr cv clt wbr wa cc0 c2 vr cv cdiv co cle
      wbr 2re cc0 c2 0re 2re 2pos ltleii c2 vr cv divge0 mpanl12 jca vx cv cX
      wcel vx cv cL cfv cr wcel cc0 vx cv cL cfv cle wbr cU cnv wcel vx cv cX
      wcel vx cv cL cfv cr wcel ubthlem10.7 vx cv cU cL cX ubthlem10.1
      ubthlem10.n nvcl mpan cU cnv wcel vx cv cX wcel cc0 vx cv cL cfv cle wbr
      ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n nvge0 mpan jca syl2an
      jca adantrr ad2antll 3jca adantrr vx vy vz cA cB cD cQ cR cT cU vh vj vk
      vn cG cL cM cN cO cW cX cY cZ vr vp ubthlem10.1 ubthlem10.2 ubthlem10.3
      ubthlem10.4 ubthlem10.5 ubthlem10.6 ubthlem10.7 ubthlem10.8 ubthlem10.9
      ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.11
      ubthlem10.q ubthlem11 sylanc vn cv cn wcel vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa c2 vr cv cdiv co
      vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv cmul co vx cv
      vn cv cT cfv cfv cN cfv wceq vk cv cn wcel vp cv vr cv cD cbl cfv co vk
      cv cA cfv wss vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr
      wa vx cv cX wcel vx cv cZ wne wa wa wa wa vx cv vn cv cT cfv cfv cN cfv
      c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cW
      cns cfv co cN cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn
      cv cT cfv cfv cN cfv cmul co vn cv cn wcel vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa vx cv vn cv
      cT cfv cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT
      cfv cfv cW cns cfv co cN vx cB cQ cR cW cns cfv cT cU vn cG cL cM cW cX
      cZ vr vp ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g ubthlem10.m
      ubthlem10.r ubthlem10.z ubthlem10.q ubthlem10.5 ubthlem10.6 ubthlem10.8
      cW cns cfv eqid ubthlem9 fveq2d c2 vr cv cdiv co vx cv cL cfv cmul co cr
      wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa cQ vp cv cM co
      vn cv cT cfv cfv cY wcel c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv
      cM co vn cv cT cfv cfv cW cns cfv co cN cfv c2 vr cv cdiv co vx cv cL cfv
      cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv cmul co wceq vn cv cn wcel
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ
      wne wa wa wa wa cW cnv wcel c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel
      cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa cQ vp cv cM co vn cv
      cT cfv cfv cY wcel c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co
      vn cv cT cfv cfv cW cns cfv co cN cfv c2 vr cv cdiv co vx cv cL cfv cmul
      co cQ vp cv cM co vn cv cT cfv cfv cN cfv cmul co wceq ubthlem10.8 c2 vr
      cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cW cns
      cfv cW cN cY ubthlem10.2 cW cns cfv eqid ubthlem10.3 nvsge0 mp3an1 vr cv
      cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa c2 vr cv
      cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv
      cmul co cle wbr wa vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv
      clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel
      cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa vx cv cZ wne vr cv
      cr wcel cc0 vr cv clt wbr wa vx cv cX wcel wa c2 vr cv cdiv co vx cv cL
      cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr c2
      vr cv cdiv co cr wcel vx cv cL cfv cr wcel c2 vr cv cdiv co vx cv cL cfv
      cmul co cr wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv
      cdiv co vx cv cL cfv remulcl vr cv cr wcel cc0 vr cv clt wbr vr cv cc0
      wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv
      cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan cU
      cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7 vx cv cU cL cX
      ubthlem10.1 ubthlem10.n nvcl mpan syl2an c2 vr cv cdiv co cr wcel cc0 c2
      vr cv cdiv co cle wbr wa vx cv cL cfv cr wcel cc0 vx cv cL cfv cle wbr wa
      cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr vr cv cr wcel cc0 vr cv
      clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv mulge0 vr cv cr
      wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co cr wcel cc0 c2 vr cv cdiv co
      cle wbr vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv cdiv co cr
      wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2 vr cv cdiv co
      cr wcel 2re c2 vr cv redivcl mp3an1 syldan c2 cr wcel cc0 c2 cle wbr vr
      cv cr wcel cc0 vr cv clt wbr wa cc0 c2 vr cv cdiv co cle wbr 2re cc0 c2
      0re 2re 2pos ltleii c2 vr cv divge0 mpanl12 jca vx cv cX wcel vx cv cL
      cfv cr wcel cc0 vx cv cL cfv cle wbr cU cnv wcel vx cv cX wcel vx cv cL
      cfv cr wcel ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl mpan
      cU cnv wcel vx cv cX wcel cc0 vx cv cL cfv cle wbr ubthlem10.7 vx cv cU
      cL cX ubthlem10.1 ubthlem10.n nvge0 mpan jca syl2an jca adantrr ad2antll
      cX cY vn cv cT cfv wf cQ vp cv cM co cX wcel cQ vp cv cM co vn cv cT cfv
      cfv cY wcel vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr
      wa vx cv cX wcel vx cv cZ wne wa wa wa cX cY cQ vp cv cM co vn cv cT cfv
      ffvelrn vn cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn cB vn
      cv cT ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel
      cX cY vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW cX cY
      ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp cv cX wcel vr cv
      cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa cQ cX wcel
      cQ vp cv cM co cX wcel vp cv cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ
      wne wa cQ cX wcel cc0 vr cv clt wbr vx cQ cR cU cG cL cM cX cZ vr vp
      ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r
      ubthlem10.z ubthlem10.q ubthlem7 adantrlr cQ cX wcel vp cv cX wcel cQ vp
      cv cM co cX wcel cU cnv wcel cQ cX wcel vp cv cX wcel cQ vp cv cM co cX
      wcel ubthlem10.7 cQ vp cv cU cM cX ubthlem10.1 ubthlem10.m nvmcl mp3an1
      ancoms syldan syl2an sylanc eqtr2d ad2ant2lr vk cv cn wcel vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa c2
      vr cv cdiv co vx cv cL cfv cmul co c2 vk cv cmul co cmul co c2 vr cv cdiv
      co c2 vk cv cmul co cmul co vx cv cL cfv cmul co wceq vn cv cn wcel vp cv
      vr cv cD cbl cfv co vk cv cA cfv wss vk cv cn wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa c2 vr cv cdiv co vx cv cL
      cfv cmul co c2 vk cv cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul co
      cmul co vx cv cL cfv cmul co wceq vp cv cX wcel vk cv cn wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv
      cmul co c2 vk cv cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul co cmul
      co vx cv cL cfv cmul co wceq vx cv cZ wne vk cv cn wcel vr cv cr wcel cc0
      vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv cmul co c2
      vk cv cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL
      cfv cmul co wceq vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vk cv
      cn wcel c2 vr cv cdiv co vx cv cL cfv cmul co c2 vk cv cmul co cmul co c2
      vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co wceq c2 vr cv
      cdiv co cc wcel vx cv cL cfv cc wcel c2 vk cv cmul co cc wcel c2 vr cv
      cdiv co vx cv cL cfv cmul co c2 vk cv cmul co cmul co c2 vr cv cdiv co c2
      vk cv cmul co cmul co vx cv cL cfv cmul co wceq vr cv cr wcel cc0 vr cv
      clt wbr wa vx cv cX wcel vk cv cn wcel c2 vr cv cdiv co vx cv cL cfv c2
      vk cv cmul co mul23 vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co
      vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv cdiv co cr wcel vr
      cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel
      2re c2 vr cv redivcl mp3an1 syldan recnd vx cv cX wcel vx cv cL cfv cU
      cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7 vx cv cU cL cX
      ubthlem10.1 ubthlem10.n nvcl mpan recnd vk cv cn wcel c2 vk cv cmul co vk
      cv cn wcel vk cv cr wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr wcel
      vk cv cr wcel c2 vk cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl
      recnd syl3an 3comr 3expb adantrrr adantrl ad2ant2r 3brtr3d $.
      $( [18-Jan-2008] $) $( [1-Jan-2008] $)

    $( Lemma for ~ ubthi .  Upper limit for the norm of an operator value at
       ` x ` . $)
    ubthlem12OLD $p |- ( ( ( k e. NN /\ n e. NN ) /\ ( ( p e. X /\ (
  ( r e. RR /\ 0 < r ) /\ ( x e. X /\ x =/= Z ) ) ) /\ ( p ( ball ` D ) r ) C_
  ( A ` k ) ) ) -> ( N ` ( ( T ` n ) ` x ) ) <_ ( ( ( 2 / r ) x. ( 2 x. k ) )
         x. ( L ` x ) ) ) $=
      vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk
      cv cA cfv wss wa wa c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co
      vn cv cT cfv cfv cN cfv cmul co c2 vr cv cdiv co vx cv cL cfv cmul co c2
      vk cv cmul co cmul co vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2
      vk cv cmul co cmul co vx cv cL cfv cmul co cle cQ vp cv cM co vn cv cT
      cfv cfv cN cfv cr wcel c2 vk cv cmul co cr wcel c2 vr cv cdiv co vx cv cL
      cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa
      w3a cQ vp cv cM co vn cv cT cfv cfv cN cfv c2 vk cv cmul co cle wbr c2 vr
      cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv
      cmul co c2 vr cv cdiv co vx cv cL cfv cmul co c2 vk cv cmul co cmul co
      cle wbr vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp cv vr cv cD cbl cfv
      co vk cv cA cfv wss wa wa cQ vp cv cM co vn cv cT cfv cfv cN cfv c2 vk cv
      cmul co c2 vr cv cdiv co vx cv cL cfv cmul co lemul2a vk cv cn wcel vn cv
      cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel
      vx cv cZ wne wa wa wa cQ vp cv cM co vn cv cT cfv cfv cN cfv cr wcel c2
      vk cv cmul co cr wcel c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0
      c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa w3a vp cv vr cv cD cbl
      cfv co vk cv cA cfv wss vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa cQ
      vp cv cM co vn cv cT cfv cfv cN cfv cr wcel c2 vk cv cmul co cr wcel c2
      vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL
      cfv cmul co cle wbr wa vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cQ vp cv cM co vn cv cT
      cfv cfv cN cfv cr wcel vk cv cn wcel vn cv cn wcel vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa cQ vp cv
      cM co vn cv cT cfv cfv cY wcel cQ vp cv cM co vn cv cT cfv cfv cN cfv cr
      wcel cX cY vn cv cT cfv wf cQ vp cv cM co cX wcel cQ vp cv cM co vn cv cT
      cfv cfv cY wcel vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cX cY cQ vp cv cM co vn cv cT
      cfv ffvelrn vn cv cn wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf cn
      cB vn cv cT ubthlem10.6 ffvelrni cU cnv wcel cW cnv wcel vn cv cT cfv cB
      wcel cX cY vn cv cT cfv wf ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cW
      cX cY ubthlem10.1 ubthlem10.2 ubthlem10.5 blof mp3an12 syl vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa cQ cX
      wcel cQ vp cv cM co cX wcel vp cv cX wcel vr cv cr wcel vx cv cX wcel vx
      cv cZ wne wa cQ cX wcel cc0 vr cv clt wbr vx cQ cR cU cG cL cM cX cZ vr
      vp ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g ubthlem10.m
      ubthlem10.r ubthlem10.z ubthlem10.q ubthlem7 adantrlr cQ cX wcel vp cv cX
      wcel cQ vp cv cM co cX wcel cU cnv wcel cQ cX wcel vp cv cX wcel cQ vp cv
      cM co cX wcel ubthlem10.7 cQ vp cv cU cM cX ubthlem10.1 ubthlem10.m nvmcl
      mp3an1 ancoms syldan syl2an cW cnv wcel cQ vp cv cM co vn cv cT cfv cfv
      cY wcel cQ vp cv cM co vn cv cT cfv cfv cN cfv cr wcel ubthlem10.8 cQ vp
      cv cM co vn cv cT cfv cfv cW cN cY ubthlem10.2 ubthlem10.3 nvcl mpan syl
      adantll vk cv cn wcel c2 vk cv cmul co cr wcel vn cv cn wcel vp cv cX
      wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa
      wa vk cv cn wcel vk cv cr wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr
      wcel vk cv cr wcel c2 vk cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl
      ad2antrr vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa
      wa c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx
      cv cL cfv cmul co cle wbr wa vk cv cn wcel vn cv cn wcel wa vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv
      cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr
      wa vx cv cZ wne vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel wa c2 vr
      cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv
      cmul co cle wbr c2 vr cv cdiv co cr wcel vx cv cL cfv cr wcel c2 vr cv
      cdiv co vx cv cL cfv cmul co cr wcel vr cv cr wcel cc0 vr cv clt wbr wa
      vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv remulcl vr cv cr wcel cc0 vr
      cv clt wbr vr cv cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel
      vr cv cr wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl
      mp3an1 syldan cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7
      vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl mpan syl2an c2 vr cv cdiv co
      cr wcel cc0 c2 vr cv cdiv co cle wbr wa vx cv cL cfv cr wcel cc0 vx cv cL
      cfv cle wbr wa cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co cr wcel vx cv cL
      cfv cr wcel cc0 c2 vr cv cdiv co cle wbr cc0 vx cv cL cfv cle wbr cc0 c2
      vr cv cdiv co vx cv cL cfv cmul co cle wbr c2 vr cv cdiv co vx cv cL cfv
      mulge0OLD an4s vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co cr
      wcel cc0 c2 vr cv cdiv co cle wbr vr cv cr wcel cc0 vr cv clt wbr vr cv
      cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr
      cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan c2
      cr wcel cc0 c2 cle wbr vr cv cr wcel cc0 vr cv clt wbr wa cc0 c2 vr cv
      cdiv co cle wbr 2re cc0 c2 0re 2re 2pos ltleii c2 vr cv divge0 mpanl12
      jca vx cv cX wcel vx cv cL cfv cr wcel cc0 vx cv cL cfv cle wbr cU cnv
      wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7 vx cv cU cL cX
      ubthlem10.1 ubthlem10.n nvcl mpan cU cnv wcel vx cv cX wcel cc0 vx cv cL
      cfv cle wbr ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n nvge0 mpan
      jca syl2an jca adantrr ad2antll 3jca adantrr vx vy vz cA cB cD cQ cR cT
      cU vh vj vk vn cG cL cM cN cO cW cX cY cZ vr vp ubthlem10.1 ubthlem10.2
      ubthlem10.3 ubthlem10.4 ubthlem10.5 ubthlem10.6 ubthlem10.7 ubthlem10.8
      ubthlem10.9 ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z
      ubthlem10.11 ubthlem10.q ubthlem11 sylanc vn cv cn wcel vp cv cX wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa c2 vr
      cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv
      cmul co vx cv vn cv cT cfv cfv cN cfv wceq vk cv cn wcel vp cv vr cv cD
      cbl cfv co vk cv cA cfv wss vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0
      vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa vx cv vn cv cT
      cfv cfv cN cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv
      cT cfv cfv cW cns cfv co cN cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ
      vp cv cM co vn cv cT cfv cfv cN cfv cmul co vn cv cn wcel vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa wa
      vx cv vn cv cT cfv cfv c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM
      co vn cv cT cfv cfv cW cns cfv co cN vx cB cQ cR cW cns cfv cT cU vn cG
      cL cM cW cX cZ vr vp ubthlem10.1 ubthlem10.7 ubthlem10.n ubthlem10.g
      ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q ubthlem10.5 ubthlem10.6
      ubthlem10.8 cW cns cfv eqid ubthlem9 fveq2d c2 vr cv cdiv co vx cv cL cfv
      cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa cQ
      vp cv cM co vn cv cT cfv cfv cY wcel c2 vr cv cdiv co vx cv cL cfv cmul
      co cQ vp cv cM co vn cv cT cfv cfv cW cns cfv co cN cfv c2 vr cv cdiv co
      vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv cmul co wceq
      vn cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
      wcel vx cv cZ wne wa wa wa wa cW cnv wcel c2 vr cv cdiv co vx cv cL cfv
      cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa cQ
      vp cv cM co vn cv cT cfv cfv cY wcel c2 vr cv cdiv co vx cv cL cfv cmul
      co cQ vp cv cM co vn cv cT cfv cfv cW cns cfv co cN cfv c2 vr cv cdiv co
      vx cv cL cfv cmul co cQ vp cv cM co vn cv cT cfv cfv cN cfv cmul co wceq
      ubthlem10.8 c2 vr cv cdiv co vx cv cL cfv cmul co cQ vp cv cM co vn cv cT
      cfv cfv cW cns cfv cW cN cY ubthlem10.2 cW cns cfv eqid ubthlem10.3
      nvsge0 mp3an1 vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ
      wne wa wa c2 vr cv cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv
      co vx cv cL cfv cmul co cle wbr wa vn cv cn wcel vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv
      cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr wa vx
      cv cZ wne vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel wa c2 vr cv
      cdiv co vx cv cL cfv cmul co cr wcel cc0 c2 vr cv cdiv co vx cv cL cfv
      cmul co cle wbr c2 vr cv cdiv co cr wcel vx cv cL cfv cr wcel c2 vr cv
      cdiv co vx cv cL cfv cmul co cr wcel vr cv cr wcel cc0 vr cv clt wbr wa
      vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv remulcl vr cv cr wcel cc0 vr
      cv clt wbr vr cv cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel
      vr cv cr wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl
      mp3an1 syldan cU cnv wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7
      vx cv cU cL cX ubthlem10.1 ubthlem10.n nvcl mpan syl2an c2 vr cv cdiv co
      cr wcel cc0 c2 vr cv cdiv co cle wbr wa vx cv cL cfv cr wcel cc0 vx cv cL
      cfv cle wbr wa cc0 c2 vr cv cdiv co vx cv cL cfv cmul co cle wbr vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel c2 vr cv cdiv co cr wcel vx cv cL
      cfv cr wcel cc0 c2 vr cv cdiv co cle wbr cc0 vx cv cL cfv cle wbr cc0 c2
      vr cv cdiv co vx cv cL cfv cmul co cle wbr c2 vr cv cdiv co vx cv cL cfv
      mulge0OLD an4s vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co cr
      wcel cc0 c2 vr cv cdiv co cle wbr vr cv cr wcel cc0 vr cv clt wbr vr cv
      cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr
      cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan c2
      cr wcel cc0 c2 cle wbr vr cv cr wcel cc0 vr cv clt wbr wa cc0 c2 vr cv
      cdiv co cle wbr 2re cc0 c2 0re 2re 2pos ltleii c2 vr cv divge0 mpanl12
      jca vx cv cX wcel vx cv cL cfv cr wcel cc0 vx cv cL cfv cle wbr cU cnv
      wcel vx cv cX wcel vx cv cL cfv cr wcel ubthlem10.7 vx cv cU cL cX
      ubthlem10.1 ubthlem10.n nvcl mpan cU cnv wcel vx cv cX wcel cc0 vx cv cL
      cfv cle wbr ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n nvge0 mpan
      jca syl2an jca adantrr ad2antll cX cY vn cv cT cfv wf cQ vp cv cM co cX
      wcel cQ vp cv cM co vn cv cT cfv cfv cY wcel vn cv cn wcel vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa cX
      cY cQ vp cv cM co vn cv cT cfv ffvelrn vn cv cn wcel vn cv cT cfv cB wcel
      cX cY vn cv cT cfv wf cn cB vn cv cT ubthlem10.6 ffvelrni cU cnv wcel cW
      cnv wcel vn cv cT cfv cB wcel cX cY vn cv cT cfv wf ubthlem10.7
      ubthlem10.8 cB vn cv cT cfv cU cW cX cY ubthlem10.1 ubthlem10.2
      ubthlem10.5 blof mp3an12 syl vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa cQ cX wcel cQ vp cv cM co cX wcel
      vp cv cX wcel vr cv cr wcel vx cv cX wcel vx cv cZ wne wa cQ cX wcel cc0
      vr cv clt wbr vx cQ cR cU cG cL cM cX cZ vr vp ubthlem10.1 ubthlem10.7
      ubthlem10.n ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.q
      ubthlem7 adantrlr cQ cX wcel vp cv cX wcel cQ vp cv cM co cX wcel cU cnv
      wcel cQ cX wcel vp cv cX wcel cQ vp cv cM co cX wcel ubthlem10.7 cQ vp cv
      cU cM cX ubthlem10.1 ubthlem10.m nvmcl mp3an1 ancoms syldan syl2an sylanc
      eqtr2d ad2ant2lr vk cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa vx cv cX wcel vx cv cZ wne wa wa wa c2 vr cv cdiv co vx cv cL cfv
      cmul co c2 vk cv cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul co cmul
      co vx cv cL cfv cmul co wceq vn cv cn wcel vp cv vr cv cD cbl cfv co vk
      cv cA cfv wss vk cv cn wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX
      wcel vx cv cZ wne wa wa c2 vr cv cdiv co vx cv cL cfv cmul co c2 vk cv
      cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv
      cmul co wceq vp cv cX wcel vk cv cn wcel vr cv cr wcel cc0 vr cv clt wbr
      wa vx cv cX wcel c2 vr cv cdiv co vx cv cL cfv cmul co c2 vk cv cmul co
      cmul co c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co
      wceq vx cv cZ wne vk cv cn wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv
      cX wcel c2 vr cv cdiv co vx cv cL cfv cmul co c2 vk cv cmul co cmul co c2
      vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co wceq vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vk cv cn wcel c2 vr cv cdiv co vx
      cv cL cfv cmul co c2 vk cv cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul
      co cmul co vx cv cL cfv cmul co wceq c2 vr cv cdiv co cc wcel vx cv cL
      cfv cc wcel c2 vk cv cmul co cc wcel c2 vr cv cdiv co vx cv cL cfv cmul
      co c2 vk cv cmul co cmul co c2 vr cv cdiv co c2 vk cv cmul co cmul co vx
      cv cL cfv cmul co wceq vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel
      vk cv cn wcel c2 vr cv cdiv co vx cv cL cfv c2 vk cv cmul co mul23 vr cv
      cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co vr cv cr wcel cc0 vr cv clt
      wbr vr cv cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv
      cr wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl
      mp3an1 syldan recnd vx cv cX wcel vx cv cL cfv cU cnv wcel vx cv cX wcel
      vx cv cL cfv cr wcel ubthlem10.7 vx cv cU cL cX ubthlem10.1 ubthlem10.n
      nvcl mpan recnd vk cv cn wcel c2 vk cv cmul co vk cv cn wcel vk cv cr
      wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr wcel vk cv cr wcel c2 vk
      cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl recnd syl3an 3comr 3expb
      adantrrr adantrl ad2ant2r 3brtr3d $.
      $( [18-Jan-2008] $) $( [1-Jan-2008] $)

    $( Lemma for ~ ubthi .  Upper bound for the operator norm of any
       operator ` T `` n ` . $)
    ubthlem13 $p |- ( ( ( k e. NN /\ n e. NN ) /\ ( ( p e. X /\
  ( r e. RR /\ 0 < r ) ) /\ ( p ( ball ` D ) r ) C_ ( A ` k ) ) ) ->
         ( O ` ( T ` n ) ) <_ ( ( 2 / r ) x. ( 2 x. k ) ) ) $=
      vn cv cT cfv cU cW clno co wcel c2 vr cv cdiv co c2 vk cv cmul co cmul co
      cr wcel cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr wa vx cv cZ
      wne vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul
      co vx cv cL cfv cmul co cle wbr wi vx cX wral vn cv cT cfv cO cfv c2 vr
      cv cdiv co c2 vk cv cmul co cmul co cle wbr vk cv cn wcel vn cv cn wcel
      wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl
      cfv co vk cv cA cfv wss wa wa vx c2 vr cv cdiv co c2 vk cv cmul co cmul
      co vn cv cT cfv cU cL cU cW clno co cN cO cW cX cZ ubthlem10.1
      ubthlem10.z ubthlem10.n ubthlem10.3 ubthlem10.4 cU cW clno co eqid
      ubthlem10.7 ubthlem10.8 nmlnoubi vn cv cn wcel vn cv cT cfv cU cW clno co
      wcel vk cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp
      cv vr cv cD cbl cfv co vk cv cA cfv wss wa vn cv cn wcel vn cv cT cfv cB
      wcel vn cv cT cfv cU cW clno co wcel cn cB vn cv cT ubthlem10.6 ffvelrni
      cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel vn cv cT cfv cU cW clno co
      wcel ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cU cW clno co cW cU cW
      clno co eqid ubthlem10.5 bloln mp3an12 syl ad2antlr vk cv cn wcel vp cv
      cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa c2 vr cv cdiv co c2 vk cv
      cmul co cmul co cr wcel cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle
      wbr wa vn cv cn wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss vk cv cn
      wcel vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co c2 vk cv cmul co
      cmul co cr wcel cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr wa
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv
      cdiv co c2 vk cv cmul co cmul co cr wcel cc0 c2 vr cv cdiv co c2 vk cv
      cmul co cmul co cle wbr wa vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn
      wcel wa c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel cc0 c2 vr cv
      cdiv co c2 vk cv cmul co cmul co cle wbr c2 vr cv cdiv co cr wcel c2 vk
      cv cmul co cr wcel c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv cdiv co c2 vk cv
      cmul co remulcl vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv
      cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2 vr
      cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan vk cv cn wcel vk cv
      cr wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr wcel vk cv cr wcel c2
      vk cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl syl2an c2 vr cv cdiv
      co cr wcel cc0 c2 vr cv cdiv co cle wbr wa c2 vk cv cmul co cr wcel cc0
      c2 vk cv cmul co cle wbr wa cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co
      cle wbr vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv cdiv co
      c2 vk cv cmul co mulge0 vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv
      co cr wcel cc0 c2 vr cv cdiv co cle wbr vr cv cr wcel cc0 vr cv clt wbr
      vr cv cc0 wne c2 vr cv cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr
      wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1
      syldan c2 cr wcel cc0 c2 cle wbr vr cv cr wcel cc0 vr cv clt wbr wa cc0
      c2 vr cv cdiv co cle wbr 2re cc0 c2 0re 2re 2pos ltleii c2 vr cv divge0
      mpanl12 jca vk cv cn wcel c2 vk cv cmul co cr wcel cc0 c2 vk cv cmul co
      cle wbr vk cv cn wcel vk cv cr wcel c2 vk cv cmul co cr wcel vk cv nnre
      c2 cr wcel vk cv cr wcel c2 vk cv cmul co cr wcel 2re c2 vk cv remulcl
      mpan syl vk cv cr wcel cc0 vk cv cle wbr cc0 c2 vk cv cmul co cle wbr vk
      cv cn wcel c2 cr wcel cc0 c2 cle wbr vk cv cr wcel cc0 vk cv cle wbr wa
      cc0 c2 vk cv cmul co cle wbr 2re cc0 c2 0re 2re 2pos ltleii c2 vk cv
      mulge0 mpanl12 vk cv nnre vk cv cr wcel cc0 vk cv clt wbr cc0 vk cv cle
      wbr vk cv cn wcel cc0 cr wcel vk cv cr wcel cc0 vk cv clt wbr cc0 vk cv
      cle wbr wi 0re cc0 vk cv ltle mpan vk cv nnre vk cv nngt0 sylc sylanc jca
      syl2an jca ancoms adantrl ad2ant2r vk cv cn wcel vn cv cn wcel wa vp cv
      cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl cfv co
      vk cv cA cfv wss wa wa vx cv cZ wne vx cv vn cv cT cfv cfv cN cfv c2 vr
      cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co cle wbr wi vx cX
      vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa wa vx cv cX wcel
      vx cv cZ wne vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul
      co cmul co vx cv cL cfv cmul co cle wbr vk cv cn wcel vn cv cn wcel wa vp
      cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl cfv
      co vk cv cA cfv wss vx cv cX wcel vx cv cZ wne wa vx cv vn cv cT cfv cfv
      cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co cle
      wbr wi vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa wa vx cv cX wcel vx cv cZ wne wa vp cv vr cv cD cbl cfv co
      vk cv cA cfv wss vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv
      cmul co cmul co vx cv cL cfv cmul co cle wbr vk cv cn wcel vn cv cn wcel
      wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv
      cZ wne wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss vx cv vn cv cT cfv
      cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co
      cle wbr wi wi vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel
      cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa vp cv vr cv cD cbl cfv
      co vk cv cA cfv wss vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk
      cv cmul co cmul co vx cv cL cfv cmul co cle wbr wi vk cv cn wcel vn cv cn
      wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx
      cv cZ wne wa wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss vx cv vn cv
      cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv
      cmul co cle wbr vx vy vz cA cB cD cQ cR cT cU vh vj vk vn cG cL cM cN cO
      cW cX cY cZ vr vp ubthlem10.1 ubthlem10.2 ubthlem10.3 ubthlem10.4
      ubthlem10.5 ubthlem10.6 ubthlem10.7 ubthlem10.8 ubthlem10.9 ubthlem10.n
      ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.11 ubthlem10.q
      ubthlem12 exp32 exp4d imp3a com34 imp32 exp3a r19.21aiv syl3anc $.
      $( [25-Jul-2009] $) $( [1-Jan-2008] $)

    $( Lemma for ~ ubthi .  Upper bound for the operator norm of any
       operator ` T `` n ` . $)
    ubthlem13OLD $p |- ( ( ( k e. NN /\ n e. NN ) /\ ( ( p e. X /\
  ( r e. RR /\ 0 < r ) ) /\ ( p ( ball ` D ) r ) C_ ( A ` k ) ) ) ->
         ( O ` ( T ` n ) ) <_ ( ( 2 / r ) x. ( 2 x. k ) ) ) $=
      vn cv cT cfv cU cW clno co wcel c2 vr cv cdiv co c2 vk cv cmul co cmul co
      cr wcel cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr wa vx cv cZ
      wne vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul
      co vx cv cL cfv cmul co cle wbr wi vx cX wral vn cv cT cfv cO cfv c2 vr
      cv cdiv co c2 vk cv cmul co cmul co cle wbr vk cv cn wcel vn cv cn wcel
      wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl
      cfv co vk cv cA cfv wss wa wa vx c2 vr cv cdiv co c2 vk cv cmul co cmul
      co vn cv cT cfv cU cL cU cW clno co cN cO cW cX cZ ubthlem10.1
      ubthlem10.z ubthlem10.n ubthlem10.3 ubthlem10.4 cU cW clno co eqid
      ubthlem10.7 ubthlem10.8 nmlnoubi vn cv cn wcel vn cv cT cfv cU cW clno co
      wcel vk cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp
      cv vr cv cD cbl cfv co vk cv cA cfv wss wa vn cv cn wcel vn cv cT cfv cB
      wcel vn cv cT cfv cU cW clno co wcel cn cB vn cv cT ubthlem10.6 ffvelrni
      cU cnv wcel cW cnv wcel vn cv cT cfv cB wcel vn cv cT cfv cU cW clno co
      wcel ubthlem10.7 ubthlem10.8 cB vn cv cT cfv cU cU cW clno co cW cU cW
      clno co eqid ubthlem10.5 bloln mp3an12 syl ad2antlr vk cv cn wcel vp cv
      cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa c2 vr cv cdiv co c2 vk cv
      cmul co cmul co cr wcel cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle
      wbr wa vn cv cn wcel vp cv vr cv cD cbl cfv co vk cv cA cfv wss vk cv cn
      wcel vr cv cr wcel cc0 vr cv clt wbr wa c2 vr cv cdiv co c2 vk cv cmul co
      cmul co cr wcel cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr wa
      vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv
      cdiv co c2 vk cv cmul co cmul co cr wcel cc0 c2 vr cv cdiv co c2 vk cv
      cmul co cmul co cle wbr wa vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn
      wcel wa c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel cc0 c2 vr cv
      cdiv co c2 vk cv cmul co cmul co cle wbr c2 vr cv cdiv co cr wcel c2 vk
      cv cmul co cr wcel c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv cdiv co c2 vk cv
      cmul co remulcl vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv
      cdiv co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2 vr
      cv cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan vk cv cn wcel vk cv
      cr wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr wcel vk cv cr wcel c2
      vk cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl syl2an c2 vr cv cdiv
      co cr wcel cc0 c2 vr cv cdiv co cle wbr wa c2 vk cv cmul co cr wcel cc0
      c2 vk cv cmul co cle wbr wa cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co
      cle wbr vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv cdiv co
      cr wcel c2 vk cv cmul co cr wcel cc0 c2 vr cv cdiv co cle wbr cc0 c2 vk
      cv cmul co cle wbr cc0 c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr
      c2 vr cv cdiv co c2 vk cv cmul co mulge0OLD an4s vr cv cr wcel cc0 vr cv
      clt wbr wa c2 vr cv cdiv co cr wcel cc0 c2 vr cv cdiv co cle wbr vr cv cr
      wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv cdiv co cr wcel vr cv
      gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2 vr cv cdiv co cr wcel
      2re c2 vr cv redivcl mp3an1 syldan c2 cr wcel cc0 c2 cle wbr vr cv cr
      wcel cc0 vr cv clt wbr wa cc0 c2 vr cv cdiv co cle wbr 2re cc0 c2 0re 2re
      2pos ltleii c2 vr cv divge0 mpanl12 jca vk cv cn wcel c2 vk cv cmul co cr
      wcel cc0 c2 vk cv cmul co cle wbr vk cv cn wcel vk cv cr wcel c2 vk cv
      cmul co cr wcel vk cv nnre c2 cr wcel vk cv cr wcel c2 vk cv cmul co cr
      wcel 2re c2 vk cv remulcl mpan syl vk cv cr wcel cc0 vk cv cle wbr cc0 c2
      vk cv cmul co cle wbr vk cv cn wcel c2 cr wcel cc0 c2 cle wbr vk cv cr
      wcel cc0 vk cv cle wbr wa cc0 c2 vk cv cmul co cle wbr 2re cc0 c2 0re 2re
      2pos ltleii c2 cr wcel vk cv cr wcel cc0 c2 cle wbr cc0 vk cv cle wbr cc0
      c2 vk cv cmul co cle wbr c2 vk cv mulge0OLD an4s mpanl12 vk cv nnre vk cv
      cr wcel cc0 vk cv clt wbr cc0 vk cv cle wbr vk cv cn wcel cc0 cr wcel vk
      cv cr wcel cc0 vk cv clt wbr cc0 vk cv cle wbr wi 0re cc0 vk cv ltle mpan
      vk cv nnre vk cv nngt0 sylc sylanc jca syl2an jca ancoms adantrl ad2ant2r
      vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt
      wbr wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa wa vx cv cZ wne
      vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co
      vx cv cL cfv cmul co cle wbr wi vx cX vk cv cn wcel vn cv cn wcel wa vp
      cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl cfv
      co vk cv cA cfv wss wa wa vx cv cX wcel vx cv cZ wne vx cv vn cv cT cfv
      cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co
      cle wbr vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr
      cv clt wbr wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss vx cv cX wcel
      vx cv cZ wne wa vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv
      cmul co cmul co vx cv cL cfv cmul co cle wbr wi vk cv cn wcel vn cv cn
      wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vx cv cX wcel
      vx cv cZ wne wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss vx cv vn cv cT
      cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv
      cmul co cle wbr vk cv cn wcel vn cv cn wcel wa vp cv cX wcel vr cv cr
      wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa vp cv vr cv cD
      cbl cfv co vk cv cA cfv wss vx cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv
      co c2 vk cv cmul co cmul co vx cv cL cfv cmul co cle wbr wi wi vk cv cn
      wcel vn cv cn wcel wa vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vx
      cv cX wcel vx cv cZ wne wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss vx
      cv vn cv cT cfv cfv cN cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co vx
      cv cL cfv cmul co cle wbr wi vk cv cn wcel vn cv cn wcel wa vp cv cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa vx cv cX wcel vx cv cZ wne wa wa wa vp
      cv vr cv cD cbl cfv co vk cv cA cfv wss vx cv vn cv cT cfv cfv cN cfv c2
      vr cv cdiv co c2 vk cv cmul co cmul co vx cv cL cfv cmul co cle wbr vx vy
      vz cA cB cD cQ cR cT cU vh vj vk vn cG cL cM cN cO cW cX cY cZ vr vp
      ubthlem10.1 ubthlem10.2 ubthlem10.3 ubthlem10.4 ubthlem10.5 ubthlem10.6
      ubthlem10.7 ubthlem10.8 ubthlem10.9 ubthlem10.n ubthlem10.g ubthlem10.m
      ubthlem10.r ubthlem10.z ubthlem10.11 ubthlem10.q ubthlem12 exp32 exp4d
      imp3a com34 imp32 exp3a r19.21aiv syl3anc $.
      $( [19-Jan-2008] $) $( [1-Jan-2008] $)

    ${
      ubthlem14.7 $e |- U e. CBan $.
      $( Lemma for ~ ubthi .  The operator norms of the operators ` T `` n `
         have an upper bound. $)
      ubthlem14 $p |- ( A. x e. X E. c e. RR A. n e. NN ( N ` ( ( T ` n ) ` x
           ) ) <_ c -> E. d e. RR A. n e. NN ( O ` ( T ` n ) ) <_ d ) $=
        vx cv vn cv cT cfv cfv cN cfv vc cv cle wbr vn cn wral vc cr wrex vx cX
        wral cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa vr
        cr wrex vp cX wrex vk cn wrex vn cv cT cfv cO cfv vd cv cle wbr vn cn
        wral vd cr wrex vx vy vz cA cB cD cT cU vh vj vk vn cD copn cfv cN cW
        cX cY vr vp vc ubthlem10.1 ubthlem10.2 ubthlem10.3 ubthlem10.5
        ubthlem10.6 ubthlem14.7 ubthlem10.8 ubthlem10.9 cD copn cfv eqid
        ubthlem10.11 ubthlem6 cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv
        cA cfv wss wa vr cr wrex vn cv cT cfv cO cfv vd cv cle wbr vn cn wral
        vd cr wrex vk vp cn cX vk cv cn wcel vp cv cX wcel wa cc0 vr cv clt wbr
        vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa vn cv cT cfv cO cfv vd cv
        cle wbr vn cn wral vd cr wrex vr cr vk cv cn wcel vp cv cX wcel wa vr
        cv cr wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv co vk cv cA cfv wss
        vn cv cT cfv cO cfv vd cv cle wbr vn cn wral vd cr wrex vk cv cn wcel
        vp cv cX wcel wa vr cv cr wcel cc0 vr cv clt wbr vp cv vr cv cD cbl cfv
        co vk cv cA cfv wss vn cv cT cfv cO cfv vd cv cle wbr vn cn wral vd cr
        wrex wi vk cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa
        vp cv vr cv cD cbl cfv co vk cv cA cfv wss vn cv cT cfv cO cfv vd cv
        cle wbr vn cn wral vd cr wrex wi wi vk cv cn wcel vp cv cX wcel vr cv
        cr wcel cc0 vr cv clt wbr wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss
        vn cv cT cfv cO cfv vd cv cle wbr vn cn wral vd cr wrex c2 vr cv cdiv
        co c2 vk cv cmul co cmul co cr wcel vn cv cT cfv cO cfv c2 vr cv cdiv
        co c2 vk cv cmul co cmul co cle wbr vn cn wral vn cv cT cfv cO cfv vd
        cv cle wbr vn cn wral vd cr wrex vk cv cn wcel vp cv cX wcel vr cv cr
        wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss
        wa wa vn cv cT cfv cO cfv vd cv cle wbr vn cn wral vn cv cT cfv cO cfv
        c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr vn cn wral vd c2 vr
        cv cdiv co c2 vk cv cmul co cmul co cr vd cv c2 vr cv cdiv co c2 vk cv
        cmul co cmul co wceq vn cv cT cfv cO cfv vd cv cle wbr vn cv cT cfv cO
        cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr vn cn vd cv c2 vr
        cv cdiv co c2 vk cv cmul co cmul co vn cv cT cfv cO cfv cle breq2
        ralbidv rcla4ev vk cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt
        wbr wa wa c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel vp cv vr cv
        cD cbl cfv co vk cv cA cfv wss vk cv cn wcel vr cv cr wcel cc0 vr cv
        clt wbr wa c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel vp cv cX
        wcel vr cv cr wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv cdiv co
        c2 vk cv cmul co cmul co cr wcel c2 vr cv cdiv co cr wcel c2 vk cv cmul
        co cr wcel c2 vr cv cdiv co c2 vk cv cmul co cmul co cr wcel vr cv cr
        wcel cc0 vr cv clt wbr wa vk cv cn wcel c2 vr cv cdiv co c2 vk cv cmul
        co remulcl vr cv cr wcel cc0 vr cv clt wbr vr cv cc0 wne c2 vr cv cdiv
        co cr wcel vr cv gt0ne0 c2 cr wcel vr cv cr wcel vr cv cc0 wne c2 vr cv
        cdiv co cr wcel 2re c2 vr cv redivcl mp3an1 syldan vk cv cn wcel vk cv
        cr wcel c2 vk cv cmul co cr wcel vk cv nnre c2 cr wcel vk cv cr wcel c2
        vk cv cmul co cr wcel 2re c2 vk cv remulcl mpan syl syl2an ancoms
        adantrl adantrr vk cv cn wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt
        wbr wa wa vp cv vr cv cD cbl cfv co vk cv cA cfv wss wa wa vn cv cT cfv
        cO cfv c2 vr cv cdiv co c2 vk cv cmul co cmul co cle wbr vn cn vk cv cn
        wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD
        cbl cfv co vk cv cA cfv wss wa vn cv cn wcel vn cv cT cfv cO cfv c2 vr
        cv cdiv co c2 vk cv cmul co cmul co cle wbr wi vk cv cn wcel vn cv cn
        wcel vp cv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD
        cbl cfv co vk cv cA cfv wss wa vn cv cT cfv cO cfv c2 vr cv cdiv co c2
        vk cv cmul co cmul co cle wbr vk cv cn wcel vn cv cn wcel vp cv cX wcel
        vr cv cr wcel cc0 vr cv clt wbr wa wa vp cv vr cv cD cbl cfv co vk cv
        cA cfv wss wa vn cv cT cfv cO cfv c2 vr cv cdiv co c2 vk cv cmul co
        cmul co cle wbr vx vy vz cA cB cD cQ cR cT cU vh vj vk vn cG cL cM cN
        cO cW cX cY cZ vr vp ubthlem10.1 ubthlem10.2 ubthlem10.3 ubthlem10.4
        ubthlem10.5 ubthlem10.6 ubthlem10.7 ubthlem10.8 ubthlem10.9 ubthlem10.n
        ubthlem10.g ubthlem10.m ubthlem10.r ubthlem10.z ubthlem10.11
        ubthlem10.q ubthlem13 exp31 com23 imp r19.21aiv sylanc exp44 imp exp3a
        imp4a r19.23adv r19.23aivv syl $.
        $( [20-Jan-2008] $) $( [1-Jan-2008] $)
    $}
  $}

  ${
    $d c d n x B $.  $d c h j n p r x y z M $.  $d d p r N $.
    $d c d h j n p r x y z T $.  $d c d h n p r x z U $.  $d c d n x W $.
    $d c j n p r x y z X $.
    ubthi.1 $e |- X = ( BaseSet ` U ) $.
    ubthi.3 $e |- M = ( norm ` W ) $.
    ubthi.4 $e |- N = ( U normOp W ) $.
    ubthi.5 $e |- B = ( U BLnOp W ) $.
    ubthi.7 $e |- U e. CBan $.
    ubthi.8 $e |- W e. NrmCVec $.
    ${
      ubthii.6 $e |- T : NN --> B $.
      $( Inference from ~ ubthi . $)
      ubthii $p |- ( A. x e. X E. c e. RR A. n e. NN ( M ` ( ( T ` n ) ` x ) )
        <_ c -> E. d e. RR A. n e. NN ( N ` ( T ` n ) ) <_ d ) $=
        vx vy vz vj cv cn wcel vy cv vz cv vh cv cT cfv cfv cM cfv vj cv cle
        wbr vh cn wral vz cX crab wceq wa vj vy copab cB cU cims cfv vp cv vr
        cv c2 cdiv co c1 vx cv cU cnm cfv cfv cdiv co cmul co vx cv cU cns cfv
        co cU cpv cfv co cU cns cfv cT cU vh vj vn cU cpv cfv cU cnm cfv cU
        cnsb cfv cM cN cW cX cW cba cfv cU cn0v cfv vr vp vc vd ubthi.1 cW cba
        cfv eqid ubthi.3 ubthi.4 ubthi.5 ubthii.6 cU cbn wcel cU cnv wcel
        ubthi.7 cU bnnv ax-mp ubthi.8 cU cims cfv eqid cU cnm cfv eqid cU cpv
        cfv eqid cU cnsb cfv eqid cU cns cfv eqid cU cn0v cfv eqid vj cv cn
        wcel vy cv vz cv vh cv cT cfv cfv cM cfv vj cv cle wbr vh cn wral vz cX
        crab wceq wa vj vy copab eqid vp cv vr cv c2 cdiv co c1 vx cv cU cnm
        cfv cfv cdiv co cmul co vx cv cU cns cfv co cU cpv cfv co eqid ubthi.7
        ubthlem14 $.
        $( [21-Jan-2008] $) $( [7-Nov-2007] $)
    $}

    $( Uniform Boundedness Theorem.  Let ` T ` be a sequence of bounded linear
       operators on a Banach space.  If, for every vector ` x ` , the norms of
       the operators' values are bounded, then the operators' norms are also
       bounded.  Theorem 4.7-3 of [Kreyszig] p. 249.  See also
       ~ http://en.wikipedia.org/wiki/Uniform_boundedness_principle . $)
    ubthi $p |- ( ( T : NN --> B /\ A. x e. X E. c e. RR A. n e. NN ( M ` ( (
    T ` n ) ` x ) ) <_ c ) -> E. d e. RR A. n e. NN ( N ` ( T ` n ) ) <_ d ) $=
      cn cB cT wf vx cv vn cv cT cfv cfv cM cfv vc cv cle wbr vn cn wral vc cr
      wrex vx cX wral vn cv cT cfv cN cfv vd cv cle wbr vn cn wral vd cr wrex
      cn cB cT wf vx cv vn cv cT cfv cfv cM cfv vc cv cle wbr vn cn wral vc cr
      wrex vx cX wral vn cv cT cfv cN cfv vd cv cle wbr vn cn wral vd cr wrex
      wi vx cv vn cv cn cB cT wf cT cn cU cW c0o co csn cxp cif cfv cfv cM cfv
      vc cv cle wbr vn cn wral vc cr wrex vx cX wral vn cv cn cB cT wf cT cn cU
      cW c0o co csn cxp cif cfv cN cfv vd cv cle wbr vn cn wral vd cr wrex wi
      cT cn cU cW c0o co csn cxp cT cn cB cT wf cT cn cU cW c0o co csn cxp cif
      wceq vx cv vn cv cT cfv cfv cM cfv vc cv cle wbr vn cn wral vc cr wrex vx
      cX wral vx cv vn cv cn cB cT wf cT cn cU cW c0o co csn cxp cif cfv cfv cM
      cfv vc cv cle wbr vn cn wral vc cr wrex vx cX wral vn cv cT cfv cN cfv vd
      cv cle wbr vn cn wral vd cr wrex vn cv cn cB cT wf cT cn cU cW c0o co csn
      cxp cif cfv cN cfv vd cv cle wbr vn cn wral vd cr wrex cT cn cB cT wf cT
      cn cU cW c0o co csn cxp cif wceq vx cv vn cv cT cfv cfv cM cfv vc cv cle
      wbr vn cn wral vc cr wrex vx cv vn cv cn cB cT wf cT cn cU cW c0o co csn
      cxp cif cfv cfv cM cfv vc cv cle wbr vn cn wral vc cr wrex vx cX cT cn cB
      cT wf cT cn cU cW c0o co csn cxp cif wceq vx cv vn cv cT cfv cfv cM cfv
      vc cv cle wbr vx cv vn cv cn cB cT wf cT cn cU cW c0o co csn cxp cif cfv
      cfv cM cfv vc cv cle wbr vc vn cr cn cT cn cB cT wf cT cn cU cW c0o co
      csn cxp cif wceq vx cv vn cv cT cfv cfv cM cfv vx cv vn cv cn cB cT wf cT
      cn cU cW c0o co csn cxp cif cfv cfv cM cfv vc cv cle cT cn cB cT wf cT cn
      cU cW c0o co csn cxp cif wceq vx cv vn cv cT cfv cfv vx cv vn cv cn cB cT
      wf cT cn cU cW c0o co csn cxp cif cfv cfv cM cT cn cB cT wf cT cn cU cW
      c0o co csn cxp cif wceq vx cv vn cv cT cfv vn cv cn cB cT wf cT cn cU cW
      c0o co csn cxp cif cfv vn cv cT cn cB cT wf cT cn cU cW c0o co csn cxp
      cif fveq1 fveq1d fveq2d breq1d rexralbidv ralbidv cT cn cB cT wf cT cn cU
      cW c0o co csn cxp cif wceq vn cv cT cfv cN cfv vd cv cle wbr vn cv cn cB
      cT wf cT cn cU cW c0o co csn cxp cif cfv cN cfv vd cv cle wbr vd vn cr cn
      cT cn cB cT wf cT cn cU cW c0o co csn cxp cif wceq vn cv cT cfv cN cfv vn
      cv cn cB cT wf cT cn cU cW c0o co csn cxp cif cfv cN cfv vd cv cle cT cn
      cB cT wf cT cn cU cW c0o co csn cxp cif wceq vn cv cT cfv vn cv cn cB cT
      wf cT cn cU cW c0o co csn cxp cif cfv cN vn cv cT cn cB cT wf cT cn cU cW
      c0o co csn cxp cif fveq1 fveq2d breq1d rexralbidv imbi12d vx cB cn cB cT
      wf cT cn cU cW c0o co csn cxp cif cU vn cM cN cW cX vc vd ubthi.1 ubthi.3
      ubthi.4 ubthi.5 ubthi.7 ubthi.8 cn cB cT cn cU cW c0o co csn cxp cn cU cW
      c0o co csn cn cU cW c0o co csn cxp wf cU cW c0o co csn cB wss cn cB cn cU
      cW c0o co csn cxp wf cn cU cW c0o co cU cW c0o oprex fconst cU cW c0o co
      cB wcel cU cW c0o co csn cB wss cU cnv wcel cW cnv wcel cU cW c0o co cB
      wcel cU cbn wcel cU cnv wcel ubthi.7 cU bnnv ax-mp ubthi.8 cB cU cW cU cW
      c0o co cU cW c0o co eqid ubthi.5 0blo mp2an cU cW c0o co cB snssi ax-mp
      cn cU cW c0o co csn cB cn cU cW c0o co csn cxp fss mp2an elimf ubthii
      dedth imp $.
      $( [21-Jan-2008] $) $( [7-Nov-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Minimizing Vector Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    minvec1.u $e |- U e. CPreHil $.
    minvec1.w1 $e |- W e. ( SubSp ` U ) $.
    $( Lemma for ~ minvecex . $)
    minveclem1 $p |- W e. NrmCVec $=
      cU cnv wcel cW cU css cfv wcel cW cnv wcel cU minvec1.u phnvi minvec1.w1
      cU cU css cfv cW cU css cfv eqid sspnv mp2an $.
      $( [7-Apr-2008] $) $( [4-Mar-2008] $)

    minvec2.y $e |- Y = ( BaseSet ` W ) $.
    $( Lemma for ~ minvecex . $)
    minveclem2 $p |- ( 0v ` W ) e. Y $=
      cW cnv wcel cW cn0v cfv cY wcel cU cW minvec1.u minvec1.w1 minveclem1 cW
      cY cW cn0v cfv minvec2.y cW cn0v cfv eqid nvzcl ax-mp $.
      $( [7-Apr-2008] $) $( [4-Mar-2008] $)

    minvec3.x $e |- X = ( BaseSet ` U ) $.
    $( Lemma for ~ minvecex . $)
    minveclem3 $p |- Y C_ X $=
      cU cnv wcel cW cU css cfv wcel cY cX wss cU minvec1.u phnvi minvec1.w1 cU
      cU css cfv cW cX cY minvec3.x minvec2.y cU css cfv eqid sspba mp2an $.
      $( [7-Apr-2008] $) $( [29-Feb-2008] $)

    $( Lemma for ~ minvecex . $)
    minveclem4 $p |- ( ( f : NN --> Y /\ n e. NN ) -> ( f ` n ) e. X ) $=
      cn cY vf cv wf vn cv cn wcel wa vn cv vf cv cfv cY wcel vn cv vf cv cfv
      cX wcel cn cY vn cv vf cv ffvelrn cY cX vn cv vf cv cfv cU cW cX cY
      minvec1.u minvec1.w1 minvec2.y minvec3.x minveclem3 sseli syl $.
      $( [7-Apr-2008] $) $( [5-Mar-2008] $)

    minvec5.m $e |- M = ( -v ` U ) $.
    minvec5.n $e |- N = ( norm ` U ) $.
    minvec5.a $e |- A e. X $.
    $( Lemma for ~ minvecex . $)
    minveclem5 $p |- ( y e. Y -> ( N ` ( A M y ) ) e. RR ) $=
      vy cv cY wcel cA vy cv cM co cX wcel cA vy cv cM co cN cfv cr wcel vy cv
      cY wcel vy cv cX wcel cA vy cv cM co cX wcel cY cX vy cv cU cW cX cY
      minvec1.u minvec1.w1 minvec2.y minvec3.x minveclem3 sseli cU cnv wcel cA
      cX wcel vy cv cX wcel cA vy cv cM co cX wcel cU minvec1.u phnvi minvec5.a
      cA vy cv cU cM cX minvec3.x minvec5.m nvmcl mp3an12 syl cU cnv wcel cA vy
      cv cM co cX wcel cA vy cv cM co cN cfv cr wcel cU minvec1.u phnvi cA vy
      cv cM co cU cN cX minvec3.x minvec5.n nvcl mpan syl $.
      $( [7-Apr-2008] $) $( [4-Mar-2008] $)
  $}

  ${
    $d j A $.  $d j H $.  $d j M $.  $d f j m $.
    minvec6.h $e |- ( j e. NN -> ( H ` j ) = ( A M ( f ` j ) ) ) $.
    $( Lemma for ~ minvecex . $)
    minveclem6 $p |- ( m e. NN -> ( H ` m ) = ( A M ( f ` m ) ) ) $=
      vj cv cH cfv cA vj cv vf cv cfv cM co wceq vm cv cH cfv cA vm cv vf cv
      cfv cM co wceq vj vm cv cn vj cv vm cv wceq vj cv cH cfv vm cv cH cfv cA
      vj cv vf cv cfv cM co cA vm cv vf cv cfv cM co vj cv vm cv cH fveq2 vj cv
      vm cv wceq vj cv vf cv cfv vm cv vf cv cfv cA cM vj cv vm cv vf cv fveq2
      opreq2d eqeq12d minvec6.h vtoclga $.
      $( [7-Apr-2008] $) $( [5-Mar-2008] $)
  $}

  ${
    $d j F $.  $d j H $.  $d j N $.  $d j n $.
    minvec7.f $e |- ( j e. NN -> ( F ` j ) = ( N ` ( H ` j ) ) ) $.
    $( Lemma for ~ minvecex . $)
    minveclem7 $p |- ( n e. NN -> ( F ` n ) = ( N ` ( H ` n ) ) ) $=
      vj cv cF cfv vj cv cH cfv cN cfv wceq vn cv cF cfv vn cv cH cfv cN cfv
      wceq vj vn cv cn vj cv vn cv wceq vj cv cF cfv vn cv cF cfv vj cv cH cfv
      cN cfv vn cv cH cfv cN cfv vj cv vn cv cF fveq2 vj cv vn cv wceq vj cv cH
      cfv vn cv cH cfv cN vj cv vn cv cH fveq2 fveq2d eqeq12d minvec7.f vtoclga
      $.
      $( [7-Apr-2008] $) $( [6-Mar-2008] $)
  $}

  ${
    $d j A $.  $d j F $.  $d j M $.  $d j N $.  $d f j n $.
    minvec8.hf $e |- ( j e. NN -> ( F ` j ) = ( N ` ( A M ( f ` j ) ) ) ) $.
    $( Lemma for ~ minvecex . $)
    minveclem8 $p |- ( n e. NN -> ( F ` n ) = ( N ` ( A M ( f ` n ) ) ) ) $=
      vj cv cF cfv cA vj cv vf cv cfv cM co cN cfv wceq vn cv cF cfv cA vn cv
      vf cv cfv cM co cN cfv wceq vj vn cv cn vj cv vn cv wceq vj cv cF cfv vn
      cv cF cfv cA vj cv vf cv cfv cM co cN cfv cA vn cv vf cv cfv cM co cN cfv
      vj cv vn cv cF fveq2 vj cv vn cv wceq cA vj cv vf cv cfv cM co cA vn cv
      vf cv cfv cM co cN vj cv vn cv wceq vj cv vf cv cfv vn cv vf cv cfv cA cM
      vj cv vn cv vf cv fveq2 opreq2d fveq2d eqeq12d minvec8.hf vtoclga $.
      $( [7-Apr-2008] $) $( [16-Feb-2008] $)
  $}

  ${
    $d k m u D $.  $d k m u J $.  $d k u M $.  $d k u N $.  $d k m u Y $.
    $d a f k m u $.
    minvec9.u $e |- U e. CPreHil $.
    minvec9.m $e |- M = ( -v ` U ) $.
    minvec9.n $e |- N = ( norm ` U ) $.
    minvec9.x $e |- X = ( BaseSet ` U ) $.
    minvec9.w1 $e |- W e. ( SubSp ` U ) $.
    minvec9.y $e |- Y = ( BaseSet ` W ) $.
    minvec9.d $e |- D = ( IndMet ` W ) $.
    minvec9.j $e |- J e. _V $.
    minvec9.k $e |- ( m e. NN -> ( J ` m ) = ( N ` ( ( f ` m ) M a ) ) ) $.
    $( Lemma for ~ minvecex . $)
    minveclem9 $p |- ( ( ( f : NN --> Y /\ f ( ~~>m ` D ) a ) /\ a e. Y ) ->
                J ~~> 0 ) $=
      cn cY vf cv wf vf cv va cv cD clm cfv wbr wa va cv cY wcel wa cJ cc0 cli
      wbr vk cv vm cv cle wbr vm cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv
      clt wbr wi vm cn wral vk cn wrex vu crp wral cn cY vf cv wf vf cv va cv
      cD clm cfv wbr wa va cv cY wcel wa vk cv vm cv cle wbr vm cv vf cv cfv va
      cv cM co cN cfv cabs cfv vu cv clt wbr wi vm cn wral vk cn wrex vu crp cn
      cY vf cv wf vf cv va cv cD clm cfv wbr wa va cv cY wcel wa vu cv crp wcel
      wa vk cv vm cv cle wbr vm cv vf cv cfv va cv cD co vu cv clt wbr wi vm cn
      wral vk cn wrex vk cv vm cv cle wbr vm cv vf cv cfv va cv cM co cN cfv
      cabs cfv vu cv clt wbr wi vm cn wral vk cn wrex vf cv va cv cD clm cfv
      wbr va cv cY wcel vu cv crp wcel vk cv vm cv cle wbr vm cv vf cv cfv va
      cv cD co vu cv clt wbr wi vm cn wral vk cn wrex cn cY vf cv wf vf cv va
      cv cD clm cfv wbr va cv cY wcel vu cv crp wcel vk cv vm cv cle wbr vm cv
      vf cv cfv va cv cD co vu cv clt wbr wi vm cn wral vk cn wrex va cv cY
      wcel vf cv va cv cD clm cfv wbr vu cv crp wcel vk cv vm cv cle wbr vm cv
      vf cv cfv va cv cD co vu cv clt wbr wi vm cn wral vk cn wrex cD cme wcel
      va cv cY wcel vf cv va cv cD clm cfv wbr vu cv crp wcel wa vk cv vm cv
      cle wbr vm cv vf cv cfv va cv cD co vu cv clt wbr wi vm cn wral vk cn
      wrex cW cnv wcel cD cme wcel cU cnv wcel cW cU css cfv wcel cW cnv wcel
      cU minvec9.u phnvi minvec9.w1 cU cU css cfv cW cU css cfv eqid sspnv
      mp2an cD cW minvec9.d imsmet ax-mp vm cv vf cv cfv cY cD va cv vu cv vk
      vm vf cv cY cD cW cY minvec9.y minvec9.d cU cnv wcel cW cU css cfv wcel
      cW cnv wcel cU minvec9.u phnvi minvec9.w1 cU cU css cfv cW cU css cfv
      eqid sspnv mp2an imsbai vm cv cn wcel vm cv vf cv cfv eqidd lmcvgnns
      mpanl1 an1s anassrs adantlll cn cY vf cv wf vf cv va cv cD clm cfv wbr wa
      va cv cY wcel wa vk cv vm cv cle wbr vm cv vf cv cfv va cv cD co vu cv
      clt wbr wi vm cn wral vk cn wrex vk cv vm cv cle wbr vm cv vf cv cfv va
      cv cM co cN cfv cabs cfv vu cv clt wbr wi vm cn wral vk cn wrex wb vu cv
      crp wcel cn cY vf cv wf va cv cY wcel vk cv vm cv cle wbr vm cv vf cv cfv
      va cv cD co vu cv clt wbr wi vm cn wral vk cn wrex vk cv vm cv cle wbr vm
      cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv clt wbr wi vm cn wral vk
      cn wrex wb vf cv va cv cD clm cfv wbr cn cY vf cv wf va cv cY wcel wa vk
      cv vm cv cle wbr vm cv vf cv cfv va cv cD co vu cv clt wbr wi vm cn wral
      vk cv vm cv cle wbr vm cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv clt
      wbr wi vm cn wral vk cn cn cY vf cv wf va cv cY wcel wa vk cv vm cv cle
      wbr vm cv vf cv cfv va cv cD co vu cv clt wbr wi vk cv vm cv cle wbr vm
      cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv clt wbr wi vm cn cn cY vf
      cv wf va cv cY wcel wa vm cv cn wcel wa vm cv vf cv cfv va cv cD co vu cv
      clt wbr vm cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv clt wbr vk cv
      vm cv cle wbr cn cY vf cv wf va cv cY wcel wa vm cv cn wcel wa vm cv vf
      cv cfv va cv cD co vm cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv clt
      cn cY vf cv wf vm cv cn wcel va cv cY wcel vm cv vf cv cfv va cv cD co vm
      cv vf cv cfv va cv cM co cN cfv cabs cfv wceq vm cv vf cv cfv cY wcel va
      cv cY wcel vm cv vf cv cfv va cv cD co vm cv vf cv cfv va cv cM co cN cfv
      cabs cfv wceq cn cY vf cv wf vm cv cn wcel wa vm cv vf cv cfv cY wcel va
      cv cY wcel wa vm cv vf cv cfv va cv cD co vm cv vf cv cfv va cv cU cims
      cfv co vm cv vf cv cfv va cv cM co cN cfv cabs cfv cU cnv wcel cW cU css
      cfv wcel vm cv vf cv cfv cY wcel va cv cY wcel wa vm cv vf cv cfv va cv
      cD co vm cv vf cv cfv va cv cU cims cfv co wceq cU minvec9.u phnvi
      minvec9.w1 vm cv vf cv cfv va cv cD cU cims cfv cU cU css cfv cW cY
      minvec9.y cU cims cfv eqid minvec9.d cU css cfv eqid sspimsval mpanl12 vm
      cv vf cv cfv cX wcel va cv cX wcel vm cv vf cv cfv va cv cU cims cfv co
      vm cv vf cv cfv va cv cM co cN cfv cabs cfv wceq vm cv vf cv cfv cY wcel
      va cv cY wcel vm cv vf cv cfv cX wcel va cv cX wcel wa vm cv vf cv cfv va
      cv cU cims cfv co vm cv vf cv cfv va cv cM co cN cfv vm cv vf cv cfv va
      cv cM co cN cfv cabs cfv cU cnv wcel vm cv vf cv cfv cX wcel va cv cX
      wcel vm cv vf cv cfv va cv cU cims cfv co vm cv vf cv cfv va cv cM co cN
      cfv wceq cU minvec9.u phnvi vm cv vf cv cfv va cv cU cims cfv cU cM cN cX
      minvec9.x minvec9.m minvec9.n cU cims cfv eqid imsdval mp3an1 vm cv vf cv
      cfv va cv cM co cN cfv cr wcel cc0 vm cv vf cv cfv va cv cM co cN cfv cle
      wbr vm cv vf cv cfv va cv cM co cN cfv cabs cfv vm cv vf cv cfv va cv cM
      co cN cfv wceq vm cv vf cv cfv cX wcel va cv cX wcel wa vm cv vf cv cfv
      va cv cM co cN cfv absid vm cv vf cv cfv cX wcel va cv cX wcel wa vm cv
      vf cv cfv va cv cM co cX wcel vm cv vf cv cfv va cv cM co cN cfv cr wcel
      cU cnv wcel vm cv vf cv cfv cX wcel va cv cX wcel vm cv vf cv cfv va cv
      cM co cX wcel cU minvec9.u phnvi vm cv vf cv cfv va cv cU cM cX minvec9.x
      minvec9.m nvmcl mp3an1 cU cnv wcel vm cv vf cv cfv va cv cM co cX wcel vm
      cv vf cv cfv va cv cM co cN cfv cr wcel cU minvec9.u phnvi vm cv vf cv
      cfv va cv cM co cU cN cX minvec9.x minvec9.n nvcl mpan syl vm cv vf cv
      cfv cX wcel va cv cX wcel wa vm cv vf cv cfv va cv cM co cX wcel cc0 vm
      cv vf cv cfv va cv cM co cN cfv cle wbr cU cnv wcel vm cv vf cv cfv cX
      wcel va cv cX wcel vm cv vf cv cfv va cv cM co cX wcel cU minvec9.u phnvi
      vm cv vf cv cfv va cv cU cM cX minvec9.x minvec9.m nvmcl mp3an1 cU cnv
      wcel vm cv vf cv cfv va cv cM co cX wcel cc0 vm cv vf cv cfv va cv cM co
      cN cfv cle wbr cU minvec9.u phnvi vm cv vf cv cfv va cv cM co cU cN cX
      minvec9.x minvec9.n nvge0 mpan syl sylanc eqtr4d cY cX vm cv vf cv cfv cU
      cW cX cY minvec9.u minvec9.w1 minvec9.y minvec9.x minveclem3 sseli cY cX
      va cv cU cW cX cY minvec9.u minvec9.w1 minvec9.y minvec9.x minveclem3
      sseli syl2an eqtrd cn cY vm cv vf cv ffvelrn sylan an1rs breq1d imbi2d
      ralbidva rexbidv adantlr adantr mpbid r19.21aiva cn cY vf cv wf va cv cY
      wcel cJ cc0 cli wbr vk cv vm cv cle wbr vm cv vf cv cfv va cv cM co cN
      cfv cabs cfv vu cv clt wbr wi vm cn wral vk cn wrex vu crp wral wb vf cv
      va cv cD clm cfv wbr cn cY vf cv wf va cv cY wcel wa vm cv vf cv cfv va
      cv cM co cN cfv cc wcel vm cn wral cJ cc0 cli wbr vk cv vm cv cle wbr vm
      cv vf cv cfv va cv cM co cN cfv cabs cfv vu cv clt wbr wi vm cn wral vk
      cn wrex vu crp wral wb cn cY vf cv wf va cv cY wcel wa vm cv vf cv cfv va
      cv cM co cN cfv cc wcel vm cn cn cY vf cv wf vm cv cn wcel va cv cY wcel
      vm cv vf cv cfv va cv cM co cN cfv cc wcel vm cv vf cv cfv cX wcel va cv
      cX wcel vm cv vf cv cfv va cv cM co cN cfv cc wcel cn cY vf cv wf vm cv
      cn wcel wa va cv cY wcel vm cv vf cv cfv cX wcel va cv cX wcel wa vm cv
      vf cv cfv va cv cM co cN cfv vm cv vf cv cfv cX wcel va cv cX wcel wa vm
      cv vf cv cfv va cv cM co cX wcel vm cv vf cv cfv va cv cM co cN cfv cr
      wcel cU cnv wcel vm cv vf cv cfv cX wcel va cv cX wcel vm cv vf cv cfv va
      cv cM co cX wcel cU minvec9.u phnvi vm cv vf cv cfv va cv cU cM cX
      minvec9.x minvec9.m nvmcl mp3an1 cU cnv wcel vm cv vf cv cfv va cv cM co
      cX wcel vm cv vf cv cfv va cv cM co cN cfv cr wcel cU minvec9.u phnvi vm
      cv vf cv cfv va cv cM co cU cN cX minvec9.x minvec9.n nvcl mpan syl recnd
      cU vf vm cW cX cY minvec9.u minvec9.w1 minvec9.y minvec9.x minveclem4 cY
      cX va cv cU cW cX cY minvec9.u minvec9.w1 minvec9.y minvec9.x minveclem3
      sseli syl2an an1rs r19.21aiva vu vm cv vf cv cfv va cv cM co cN cfv vk vm
      cJ minvec9.j minvec9.k clm0nnsi syl adantlr mpbird $.
      $( [7-Apr-2008] $) $( [24-Feb-2008] $)
  $}

  ${
    $d f j k m t u x y A $.  $d k m n x y B $.  $d a k m D $.
    $d a j k m n u F $.  $d x y G $.  $d j H $.  $d f j k m n t u x y M $.
    $d f j k m n u t x y N $.  $d a f j k m n t u P $.  $d a t u R $.
    $d x y S $.  $d t u x y U $.  $d t u x y W $.  $d a f j k m n t u x y Y $.
    minvec10.1 $e |- R = { x | E. y e. Y x = -u ( N ` ( A M y ) ) } $.
    minvec10.u $e |- U e. CPreHil $.
    minvec10.m $e |- M = ( -v ` U ) $.
    minvec10.n $e |- N = ( norm ` U ) $.
    minvec10.x $e |- X = ( BaseSet ` U ) $.
    minvec10.w1 $e |- W e. ( SubSp ` U ) $.
    minvec10.y $e |- Y = ( BaseSet ` W ) $.
    minvec10.a $e |- A e. X $.
    $( Lemma for ~ minvecex .  The set of reals ` R ` is bounded above. $)
    minveclem10 $p |- E. u e. RR A. t e. R t <_ u $=
      cc0 cr wcel vt cv cc0 cle wbr vt cR wral vt cv vu cv cle wbr vt cR wral
      vu cr wrex 0re vt cv cc0 cle wbr vt cR vt cv cR wcel vt cv cA vy cv cM co
      cN cfv cneg wceq vy cY wrex vt cv cc0 cle wbr vx cv cA vy cv cM co cN cfv
      cneg wceq vy cY wrex vt cv cA vy cv cM co cN cfv cneg wceq vy cY wrex vx
      vt cv cR vt visset vx cv vt cv wceq vx cv cA vy cv cM co cN cfv cneg wceq
      vt cv cA vy cv cM co cN cfv cneg wceq vy cY vx cv vt cv cA vy cv cM co cN
      cfv cneg eqeq1 rexbidv minvec10.1 elab2 vt cv cA vy cv cM co cN cfv cneg
      wceq vt cv cc0 cle wbr vy cY vt cv cA vy cv cM co cN cfv cneg wceq vt cv
      cc0 cle wbr cA vy cv cM co cN cfv cneg cc0 cle wbr vy cv cY wcel vt cv cA
      vy cv cM co cN cfv cneg cc0 cle breq1 vy cv cY wcel cc0 cA vy cv cM co cN
      cfv cle wbr cA vy cv cM co cN cfv cneg cc0 cle wbr vy cv cY wcel cA vy cv
      cM co cX wcel cc0 cA vy cv cM co cN cfv cle wbr vy cv cY wcel vy cv cX
      wcel cA vy cv cM co cX wcel cY cX vy cv cU cW cX cY minvec10.u
      minvec10.w1 minvec10.y minvec10.x minveclem3 sseli cU cnv wcel cA cX wcel
      vy cv cX wcel cA vy cv cM co cX wcel cU minvec10.u phnvi minvec10.a cA vy
      cv cU cM cX minvec10.x minvec10.m nvmcl mp3an12 syl cU cnv wcel cA vy cv
      cM co cX wcel cc0 cA vy cv cM co cN cfv cle wbr cU minvec10.u phnvi cA vy
      cv cM co cU cN cX minvec10.x minvec10.n nvge0 mpan syl vy cv cY wcel cA
      vy cv cM co cN cfv cr wcel cc0 cA vy cv cM co cN cfv cle wbr cA vy cv cM
      co cN cfv cneg cc0 cle wbr wb vy cv cY wcel cA vy cv cM co cX wcel cA vy
      cv cM co cN cfv cr wcel vy cv cY wcel vy cv cX wcel cA vy cv cM co cX
      wcel cY cX vy cv cU cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x
      minveclem3 sseli cU cnv wcel cA cX wcel vy cv cX wcel cA vy cv cM co cX
      wcel cU minvec10.u phnvi minvec10.a cA vy cv cU cM cX minvec10.x
      minvec10.m nvmcl mp3an12 syl cU cnv wcel cA vy cv cM co cX wcel cA vy cv
      cM co cN cfv cr wcel cU minvec10.u phnvi cA vy cv cM co cU cN cX
      minvec10.x minvec10.n nvcl mpan syl cA vy cv cM co cN cfv le0neg2 syl
      mpbid syl5cbir r19.23aiv sylbi rgen vt cv vu cv cle wbr vt cR wral vt cv
      cc0 cle wbr vt cR wral vu cc0 cr vu cv cc0 wceq vt cv vu cv cle wbr vt cv
      cc0 cle wbr vt cR vu cv cc0 vt cv cle breq2 ralbidv rcla4ev mp2an $.
      $( [7-Apr-2008] $) $( [10-Feb-2008] $)

    $( Lemma for ~ minvecex . $)
    minveclem11 $p |- sup ( R , RR , < ) e. RR $=
      vu vt cR vx vy vu vt cA vy cv cM co cN cfv cR cY cW cn0v cfv minvec10.1
      vy cA cU cM cN cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x
      minvec10.m minvec10.n minvec10.a minveclem5 cU cW cY minvec10.u
      minvec10.w1 minvec10.y minveclem2 vx vy vu vt cA cR cU cM cN cW cX cY
      minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
      minvec10.y minvec10.a minveclem10 infcvgaux1i suprclii $.
      $( [7-Apr-2008] $) $( [6-Mar-2008] $)

    ${
      minvec12.2 $e |- P = -u sup ( R , RR , < ) $.
      $( Lemma for ~ minvecex . $)
      minveclem12 $p |- P e. RR $=
        cP cR cr clt csup cneg cr minvec12.2 cR cr clt csup vx vy cA cR cU cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minveclem11 renegcli eqeltri $.
        $( [7-Apr-2008] $) $( [3-Mar-2008] $)

      $( Lemma for ~ minvecex . $)
      minveclem13 $p |- ( B e. Y -> P <_ ( N ` ( A M B ) ) ) $=
        vx vy vu vt cA vy cv cM co cN cfv cA cB cM co cN cfv cB cR cP cY cW
        cn0v cfv minvec10.1 vy cA cU cM cN cW cX cY minvec10.u minvec10.w1
        minvec10.y minvec10.x minvec10.m minvec10.n minvec10.a minveclem5 cU cW
        cY minvec10.u minvec10.w1 minvec10.y minveclem2 vx vy vu vt cA cR cU cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minveclem10 minvec12.2 vy cv cB wceq
        cA vy cv cM co cA cB cM co cN vy cv cB cA cM opreq2 fveq2d infcvgaux2i
        $.
        $( [7-Apr-2008] $) $( [9-Feb-2008] $)

      $( Lemma for ~ minvecex . $)
      minveclem14 $p |- 0 <_ P $=
        cc0 cR cr clt csup cneg cP cle cR cr clt csup cc0 cle wbr cc0 cR cr clt
        csup cneg cle wbr cc0 cr wcel va cv cc0 cle wbr va cR wral cR cr clt
        csup cc0 cle wbr 0re va cv cc0 cle wbr va cR va cv cR wcel va cv cA vy
        cv cM co cN cfv cneg wceq vy cY wrex va cv cc0 cle wbr vx cv cA vy cv
        cM co cN cfv cneg wceq vy cY wrex va cv cA vy cv cM co cN cfv cneg wceq
        vy cY wrex vx va cv cR va visset vx cv va cv wceq vx cv cA vy cv cM co
        cN cfv cneg wceq va cv cA vy cv cM co cN cfv cneg wceq vy cY vx cv va
        cv cA vy cv cM co cN cfv cneg eqeq1 rexbidv minvec10.1 elab2 va cv cA
        vy cv cM co cN cfv cneg wceq va cv cc0 cle wbr vy cY vy cv cY wcel va
        cv cA vy cv cM co cN cfv cneg wceq wa va cv cA vy cv cM co cN cfv cneg
        cc0 cle vy cv cY wcel va cv cA vy cv cM co cN cfv cneg wceq pm3.27 vy
        cv cY wcel cA vy cv cM co cN cfv cneg cc0 cle wbr va cv cA vy cv cM co
        cN cfv cneg wceq vy cv cY wcel vy cv cX wcel cA vy cv cM co cN cfv cneg
        cc0 cle wbr cY cX vy cv cU cW cX cY minvec10.u minvec10.w1 minvec10.y
        minvec10.x minveclem3 sseli vy cv cX wcel cA vy cv cM co cX wcel cA vy
        cv cM co cN cfv cneg cc0 cle wbr cU cnv wcel cA cX wcel vy cv cX wcel
        cA vy cv cM co cX wcel cU minvec10.u phnvi minvec10.a cA vy cv cU cM cX
        minvec10.x minvec10.m nvmcl mp3an12 cA vy cv cM co cX wcel cc0 cA vy cv
        cM co cN cfv cle wbr cA vy cv cM co cN cfv cneg cc0 cle wbr cU cnv wcel
        cA vy cv cM co cX wcel cc0 cA vy cv cM co cN cfv cle wbr cU minvec10.u
        phnvi cA vy cv cM co cU cN cX minvec10.x minvec10.n nvge0 mpan cA vy cv
        cM co cX wcel cA vy cv cM co cN cfv cr wcel cc0 cA vy cv cM co cN cfv
        cle wbr cA vy cv cM co cN cfv cneg cc0 cle wbr wb cU cnv wcel cA vy cv
        cM co cX wcel cA vy cv cM co cN cfv cr wcel cU minvec10.u phnvi cA vy
        cv cM co cU cN cX minvec10.x minvec10.n nvcl mpan cA vy cv cM co cN cfv
        le0neg2 syl mpbid syl syl adantr eqbrtrd r19.23aiva sylbi rgen vu vt va
        cR cc0 vx vy vu vt cA vy cv cM co cN cfv cR cY cW cn0v cfv minvec10.1
        vy cA cU cM cN cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x
        minvec10.m minvec10.n minvec10.a minveclem5 cU cW cY minvec10.u
        minvec10.w1 minvec10.y minveclem2 vx vy vu vt cA cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minveclem10 infcvgaux1i suprleubii mp2an cR cr
        clt csup cr wcel cR cr clt csup cc0 cle wbr cc0 cR cr clt csup cneg cle
        wbr wb vx vy cA cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minveclem11 cR
        cr clt csup le0neg1 ax-mp mpbi minvec12.2 breqtrri $.
        $( [7-Apr-2008] $) $( [17-Feb-2008] $)

      $( Lemma for ~ minvecex . $)
      minveclem15 $p |- ( ( F ~~> P /\ B e. RR+ ) ->
       E. k e. NN A. n e. NN ( k <_ n -> ( abs ` ( ( F ` n ) - P ) ) < B ) ) $=
        cP cr wcel cF cP cli wbr cB crp wcel vk cv vn cv cle wbr vn cv cF cfv
        cP cmin co cabs cfv cB clt wbr wi vn cn wral vk cn wrex vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec12.2 minveclem12 cP
        cB cr vk vn cF c1 cn cn 1z cn c1 cuz cfv nnuz eqimss2i nnssz clmi2rpi
        mp3an1 $.
        $( [7-Apr-2008] $) $( [21-Feb-2008] $)

      minvec16.g $e |- G = ( +v ` U ) $.
      minvec16.s $e |- S = ( .s ` U ) $.
      $( ??? reuse f'nGf'm antecedent computation in mnvc3lem3 $)
      $( Lemma for ~ minvecex . $)
      minveclem16 $p |- ( ( ( f : NN --> Y /\ n e. NN ) /\ ( f : NN --> Y /\
   m e. NN ) ) -> ( 2 x. P ) <_
         ( N ` ( 2 S ( A M ( ( 1 / 2 ) S ( ( f ` n ) G ( f ` m ) ) ) ) ) ) ) $=
        vn cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel c2 cP cmul co c2 cA c1
        c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cS co cN
        cfv cle wbr cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn
        wcel wa vn cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa vn cv vf cv
        cfv vm cv vf cv cfv cG co cY wcel c2 cP cmul co c2 cA c1 c2 cdiv co vn
        cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cS co cN cfv cle wbr vn
        cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa vn cv vf cv cfv vm cv
        vf cv cfv cW cpv cfv co vn cv vf cv cfv vm cv vf cv cfv cG co cY cU cnv
        wcel cW cU css cfv wcel vn cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel
        wa vn cv vf cv cfv vm cv vf cv cfv cW cpv cfv co vn cv vf cv cfv vm cv
        vf cv cfv cG co wceq cU minvec10.u phnvi minvec10.w1 vn cv vf cv cfv vm
        cv vf cv cfv cU cW cpv cfv cG cU css cfv cW cY minvec10.y minvec16.g cW
        cpv cfv eqid cU css cfv eqid sspgval mpanl12 cW cnv wcel vn cv vf cv
        cfv cY wcel vm cv vf cv cfv cY wcel vn cv vf cv cfv vm cv vf cv cfv cW
        cpv cfv co cY wcel cU cW minvec10.u minvec10.w1 minveclem1 vn cv vf cv
        cfv vm cv vf cv cfv cW cW cpv cfv cY minvec10.y cW cpv cfv eqid nvgcl
        mp3an1 eqeltrrd vn cv vf cv cfv vm cv vf cv cfv cG co cY wcel c2 cP
        cmul co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co
        cM co cN cfv cmul co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv
        cfv cG co cS co cM co cS co cN cfv cle vn cv vf cv cfv vm cv vf cv cfv
        cG co cY wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co
        cY wcel c2 cP cmul co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv
        cfv cG co cS co cM co cN cfv cmul co cle wbr vn cv vf cv cfv vm cv vf
        cv cfv cG co cY wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG
        co cW cns cfv co c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS
        co cY c1 c2 cdiv co cc wcel vn cv vf cv cfv vm cv vf cv cfv cG co cY
        wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cW cns cfv co
        c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co wceq c2 2cn
        2ne0 reccli cU cnv wcel cW cU css cfv wcel c1 c2 cdiv co cc wcel vn cv
        vf cv cfv vm cv vf cv cfv cG co cY wcel wa c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cW cns cfv co c1 c2 cdiv co vn cv vf cv cfv
        vm cv vf cv cfv cG co cS co wceq cU minvec10.u phnvi minvec10.w1 c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cW cns cfv cS cU cU css
        cfv cW cY minvec10.y minvec16.s cW cns cfv eqid cU css cfv eqid sspsval
        mpanl12 mpan cW cnv wcel c1 c2 cdiv co cc wcel vn cv vf cv cfv vm cv vf
        cv cfv cG co cY wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG
        co cW cns cfv co cY wcel cU cW minvec10.u minvec10.w1 minveclem1 c2 2cn
        2ne0 reccli c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cW cns
        cfv cW cY minvec10.y cW cns cfv eqid nvscl mp3an12 eqeltrrd cA c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cN cfv cr
        wcel cP cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM
        co cN cfv cle wbr c2 cP cmul co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm
        cv vf cv cfv cG co cS co cM co cN cfv cmul co cle wbr c1 c2 cdiv co vn
        cv vf cv cfv vm cv vf cv cfv cG co cS co cY wcel cP cr wcel cA c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cN cfv cr
        wcel cP cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM
        co cN cfv cle wbr c2 cP cmul co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm
        cv vf cv cfv cG co cS co cM co cN cfv cmul co cle wbr vx vy cA cP cR cU
        cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec12.2 minveclem12 cP cr wcel cA
        c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cN cfv
        cr wcel c2 cr wcel cc0 c2 cle wbr wa cP cA c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cS co cM co cN cfv cle wbr c2 cP cmul co c2
        cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cN
        cfv cmul co cle wbr c2 cr wcel cc0 c2 cle wbr 2re cc0 c2 0re 2re 2pos
        ltleii pm3.2i cP cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co
        cS co cM co cN cfv c2 lemul2a mp3anl3 mpanl1 c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cS co cY wcel cA c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cS co cM co cX wcel cA c1 c2 cdiv co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co cM co cN cfv cr wcel c1 c2 cdiv co
        vn cv vf cv cfv vm cv vf cv cfv cG co cS co cY wcel c1 c2 cdiv co vn cv
        vf cv cfv vm cv vf cv cfv cG co cS co cX wcel cA c1 c2 cdiv co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co cM co cX wcel cY cX c1 c2 cdiv co vn
        cv vf cv cfv vm cv vf cv cfv cG co cS co cU cW cX cY minvec10.u
        minvec10.w1 minvec10.y minvec10.x minveclem3 sseli cU cnv wcel cA cX
        wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cX wcel
        cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cX
        wcel cU minvec10.u phnvi minvec10.a cA c1 c2 cdiv co vn cv vf cv cfv vm
        cv vf cv cfv cG co cS co cU cM cX minvec10.x minvec10.m nvmcl mp3an12
        syl cU cnv wcel cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co
        cS co cM co cX wcel cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG
        co cS co cM co cN cfv cr wcel cU minvec10.u phnvi cA c1 c2 cdiv co vn
        cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cU cN cX minvec10.x
        minvec10.n nvcl mpan syl vx vy cA c1 c2 cdiv co vn cv vf cv cfv vm cv
        vf cv cfv cG co cS co cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec12.2 minveclem13 sylanc syl vn cv vf cv cfv vm cv vf cv cfv cG co
        cY wcel vn cv vf cv cfv vm cv vf cv cfv cG co cX wcel c2 cA c1 c2 cdiv
        co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cS co cN cfv c2 cA
        c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cN cfv
        cmul co wceq cY cX vn cv vf cv cfv vm cv vf cv cfv cG co cU cW cX cY
        minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem3 sseli vn cv vf
        cv cfv vm cv vf cv cfv cG co cX wcel cA c1 c2 cdiv co vn cv vf cv cfv
        vm cv vf cv cfv cG co cS co cM co cX wcel c2 cA c1 c2 cdiv co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co cM co cS co cN cfv c2 cA c1 c2 cdiv
        co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cN cfv cmul co
        wceq vn cv vf cv cfv vm cv vf cv cfv cG co cX wcel c1 c2 cdiv co vn cv
        vf cv cfv vm cv vf cv cfv cG co cS co cX wcel cA c1 c2 cdiv co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co cM co cX wcel cU cnv wcel c1 c2 cdiv
        co cc wcel vn cv vf cv cfv vm cv vf cv cfv cG co cX wcel c1 c2 cdiv co
        vn cv vf cv cfv vm cv vf cv cfv cG co cS co cX wcel cU minvec10.u phnvi
        c2 2cn 2ne0 reccli c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co
        cS cU cX minvec10.x minvec16.s nvscl mp3an12 cU cnv wcel cA cX wcel c1
        c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cX wcel cA c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cX wcel cU
        minvec10.u phnvi minvec10.a cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf
        cv cfv cG co cS co cU cM cX minvec10.x minvec10.m nvmcl mp3an12 syl c2
        cr wcel cc0 c2 cle wbr cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv
        cG co cS co cM co cX wcel c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf
        cv cfv cG co cS co cM co cS co cN cfv c2 cA c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cS co cM co cN cfv cmul co wceq 2re cc0 c2
        0re 2re 2pos ltleii cU cnv wcel c2 cr wcel cc0 c2 cle wbr wa cA c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cX wcel c2 cA
        c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cS co
        cN cfv c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co
        cM co cN cfv cmul co wceq cU minvec10.u phnvi c2 cA c1 c2 cdiv co vn cv
        vf cv cfv vm cv vf cv cfv cG co cS co cM co cS cU cN cX minvec10.x
        minvec16.s minvec10.n nvsge0 mp3an1 mpanl12 syl syl breqtrrd syl cn cY
        vn cv vf cv ffvelrn cn cY vm cv vf cv ffvelrn syl2an $.
        $( [7-Apr-2008] $) $( [6-Mar-2008] $)
    $}

    ${
      minvec17.h $e |- ( j e. NN -> ( H ` j ) = ( A M ( f ` j ) ) ) $.
      $( Lemma for ~ minvecex . $)
      minveclem17 $p |- ( ( f : NN --> Y /\ n e. NN ) -> ( H ` n ) e. X ) $=
        cn cY vf cv wf vn cv cn wcel wa vn cv cH cfv cA vn cv vf cv cfv cM co
        cX vn cv cn wcel vn cv cH cfv cA vn cv vf cv cfv cM co wceq cn cY vf cv
        wf cA vf vj vn cH cM minvec17.h minveclem6 adantl cn cY vf cv wf vn cv
        cn wcel wa vn cv vf cv cfv cY wcel cA vn cv vf cv cfv cM co cX wcel cn
        cY vn cv vf cv ffvelrn vn cv vf cv cfv cY wcel vn cv vf cv cfv cX wcel
        cA vn cv vf cv cfv cM co cX wcel cY cX vn cv vf cv cfv cU cW cX cY
        minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem3 sseli cU cnv
        wcel cA cX wcel vn cv vf cv cfv cX wcel cA vn cv vf cv cfv cM co cX
        wcel cU minvec10.u phnvi minvec10.a cA vn cv vf cv cfv cU cM cX
        minvec10.x minvec10.m nvmcl mp3an12 syl syl eqeltrd $.
        $( [7-Apr-2008] $) $( [4-Mar-2008] $)

      minvec18.g $e |- G = ( +v ` U ) $.
      $( Lemma for ~ minvecex . $)
      minveclem18 $p |- ( ( ( f : NN --> Y /\ n e. NN ) /\ ( f : NN --> Y /\
   m e. NN ) ) -> ( ( 2 x. ( ( ( N ` ( H ` n ) ) ^ 2 ) + ( ( N ` ( H ` m ) ) ^
   2 ) ) ) - ( ( N ` ( ( H ` n ) G ( H ` m ) ) ) ^ 2 ) ) =
      ( ( N ` ( ( f ` n ) M ( f ` m ) ) ) ^ 2 ) ) $=
        cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa c2
        vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co caddc co
        cmul co vn cv cH cfv vm cv cH cfv cG co cN cfv c2 cexp co cmin co vn cv
        cH cfv vm cv cH cfv cM co cN cfv c2 cexp co vn cv vf cv cfv vm cv vf cv
        cfv cM co cN cfv c2 cexp co vn cv cH cfv cX wcel vm cv cH cfv cX wcel
        c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co caddc
        co cmul co vn cv cH cfv vm cv cH cfv cG co cN cfv c2 cexp co cmin co vn
        cv cH cfv vm cv cH cfv cM co cN cfv c2 cexp co wceq cn cY vf cv wf vn
        cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa vn cv cH cfv cX wcel vm
        cv cH cfv cX wcel wa c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN
        cfv c2 cexp co caddc co cmul co vn cv cH cfv vm cv cH cfv cG co cN cfv
        c2 cexp co cmin co vn cv cH cfv vm cv cH cfv cM co cN cfv c2 cexp co
        wceq vn cv cH cfv vm cv cH cfv cG co cN cfv c2 cexp co vn cv cH cfv vm
        cv cH cfv cM co cN cfv c2 cexp co caddc co c2 vn cv cH cfv cN cfv c2
        cexp co vm cv cH cfv cN cfv c2 cexp co caddc co cmul co wceq cU cphl
        wcel vn cv cH cfv cX wcel vm cv cH cfv cX wcel vn cv cH cfv vm cv cH
        cfv cG co cN cfv c2 cexp co vn cv cH cfv vm cv cH cfv cM co cN cfv c2
        cexp co caddc co c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv
        c2 cexp co caddc co cmul co wceq minvec10.u vn cv cH cfv vm cv cH cfv
        cU cG cM cN cX minvec10.x minvec18.g minvec10.m minvec10.n phpar2
        mp3an1 c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co
        caddc co cmul co cc wcel vn cv cH cfv vm cv cH cfv cG co cN cfv c2 cexp
        co cc wcel vn cv cH cfv vm cv cH cfv cM co cN cfv c2 cexp co cc wcel c2
        vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co caddc co
        cmul co vn cv cH cfv vm cv cH cfv cG co cN cfv c2 cexp co cmin co vn cv
        cH cfv vm cv cH cfv cM co cN cfv c2 cexp co wceq vn cv cH cfv vm cv cH
        cfv cG co cN cfv c2 cexp co vn cv cH cfv vm cv cH cfv cM co cN cfv c2
        cexp co caddc co c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv
        c2 cexp co caddc co cmul co wceq wb vn cv cH cfv cX wcel vm cv cH cfv
        cX wcel wa c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2
        cexp co caddc co cmul co vn cv cH cfv vm cv cH cfv cG co cN cfv c2 cexp
        co vn cv cH cfv vm cv cH cfv cM co cN cfv c2 cexp co subadd vn cv cH
        cfv cX wcel vm cv cH cfv cX wcel wa vn cv cH cfv cN cfv c2 cexp co vm
        cv cH cfv cN cfv c2 cexp co caddc co cc wcel c2 vn cv cH cfv cN cfv c2
        cexp co vm cv cH cfv cN cfv c2 cexp co caddc co cmul co cc wcel vn cv
        cH cfv cN cfv c2 cexp co cc wcel vm cv cH cfv cN cfv c2 cexp co cc wcel
        vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co caddc co
        cc wcel vn cv cH cfv cX wcel vm cv cH cfv cX wcel vn cv cH cfv cN cfv
        c2 cexp co vm cv cH cfv cN cfv c2 cexp co addcl vn cv cH cfv cX wcel vn
        cv cH cfv cN cfv cc wcel vn cv cH cfv cN cfv c2 cexp co cc wcel vn cv
        cH cfv cX wcel vn cv cH cfv cN cfv cU cnv wcel vn cv cH cfv cX wcel vn
        cv cH cfv cN cfv cr wcel cU minvec10.u phnvi vn cv cH cfv cU cN cX
        minvec10.x minvec10.n nvcl mpan recnd vn cv cH cfv cN cfv sqcl syl vm
        cv cH cfv cX wcel vm cv cH cfv cN cfv cc wcel vm cv cH cfv cN cfv c2
        cexp co cc wcel vm cv cH cfv cX wcel vm cv cH cfv cN cfv cU cnv wcel vm
        cv cH cfv cX wcel vm cv cH cfv cN cfv cr wcel cU minvec10.u phnvi vm cv
        cH cfv cU cN cX minvec10.x minvec10.n nvcl mpan recnd vm cv cH cfv cN
        cfv sqcl syl syl2an c2 cc wcel vn cv cH cfv cN cfv c2 cexp co vm cv cH
        cfv cN cfv c2 cexp co caddc co cc wcel c2 vn cv cH cfv cN cfv c2 cexp
        co vm cv cH cfv cN cfv c2 cexp co caddc co cmul co cc wcel 2cn c2 vn cv
        cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co caddc co mulcl
        mpan syl vn cv cH cfv cX wcel vm cv cH cfv cX wcel wa vn cv cH cfv vm
        cv cH cfv cG co cN cfv cc wcel vn cv cH cfv vm cv cH cfv cG co cN cfv
        c2 cexp co cc wcel vn cv cH cfv cX wcel vm cv cH cfv cX wcel wa vn cv
        cH cfv vm cv cH cfv cG co cN cfv vn cv cH cfv cX wcel vm cv cH cfv cX
        wcel wa vn cv cH cfv vm cv cH cfv cG co cX wcel vn cv cH cfv vm cv cH
        cfv cG co cN cfv cr wcel cU cnv wcel vn cv cH cfv cX wcel vm cv cH cfv
        cX wcel vn cv cH cfv vm cv cH cfv cG co cX wcel cU minvec10.u phnvi vn
        cv cH cfv vm cv cH cfv cU cG cX minvec10.x minvec18.g nvgcl mp3an1 cU
        cnv wcel vn cv cH cfv vm cv cH cfv cG co cX wcel vn cv cH cfv vm cv cH
        cfv cG co cN cfv cr wcel cU minvec10.u phnvi vn cv cH cfv vm cv cH cfv
        cG co cU cN cX minvec10.x minvec10.n nvcl mpan syl recnd vn cv cH cfv
        vm cv cH cfv cG co cN cfv sqcl syl vn cv cH cfv cX wcel vm cv cH cfv cX
        wcel wa vn cv cH cfv vm cv cH cfv cM co cN cfv cc wcel vn cv cH cfv vm
        cv cH cfv cM co cN cfv c2 cexp co cc wcel vn cv cH cfv cX wcel vm cv cH
        cfv cX wcel wa vn cv cH cfv vm cv cH cfv cM co cN cfv vn cv cH cfv cX
        wcel vm cv cH cfv cX wcel wa vn cv cH cfv vm cv cH cfv cM co cX wcel vn
        cv cH cfv vm cv cH cfv cM co cN cfv cr wcel cU cnv wcel vn cv cH cfv cX
        wcel vm cv cH cfv cX wcel vn cv cH cfv vm cv cH cfv cM co cX wcel cU
        minvec10.u phnvi vn cv cH cfv vm cv cH cfv cU cM cX minvec10.x
        minvec10.m nvmcl mp3an1 cU cnv wcel vn cv cH cfv vm cv cH cfv cM co cX
        wcel vn cv cH cfv vm cv cH cfv cM co cN cfv cr wcel cU minvec10.u phnvi
        vn cv cH cfv vm cv cH cfv cM co cU cN cX minvec10.x minvec10.n nvcl
        mpan syl recnd vn cv cH cfv vm cv cH cfv cM co cN cfv sqcl syl syl3anc
        mpbird vx vy cA cR cU vf vj vn cH cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec17.h minveclem17 vx vy cA cR cU vf vj vm cH cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec17.h minveclem17 syl2an cn cY vf cv wf vn
        cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa vn cv cH cfv vm cv cH
        cfv cM co cN cfv vn cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp
        cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa vn
        cv cH cfv vm cv cH cfv cM co cN cfv vm cv vf cv cfv vn cv vf cv cfv cM
        co cN cfv vn cv vf cv cfv vm cv vf cv cfv cM co cN cfv cn cY vf cv wf
        vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa vn cv cH cfv vm cv
        cH cfv cM co vm cv vf cv cfv vn cv vf cv cfv cM co cN cn cY vf cv wf vn
        cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa vn cv cH cfv vm cv cH
        cfv cM co cA vn cv vf cv cfv cM co cA vm cv vf cv cfv cM co cM co vm cv
        vf cv cfv vn cv vf cv cfv cM co vn cv cn wcel vm cv cn wcel vn cv cH
        cfv vm cv cH cfv cM co cA vn cv vf cv cfv cM co cA vm cv vf cv cfv cM
        co cM co wceq cn cY vf cv wf cn cY vf cv wf vn cv cn wcel vm cv cn wcel
        vn cv cH cfv cA vn cv vf cv cfv cM co vm cv cH cfv cA vm cv vf cv cfv
        cM co cM cA vf vj vn cH cM minvec17.h minveclem6 cA vf vj vm cH cM
        minvec17.h minveclem6 opreqan12d ad2ant2l vn cv vf cv cfv cX wcel vm cv
        vf cv cfv cX wcel cA vn cv vf cv cfv cM co cA vm cv vf cv cfv cM co cM
        co vm cv vf cv cfv vn cv vf cv cfv cM co wceq cn cY vf cv wf vn cv cn
        wcel wa cn cY vf cv wf vm cv cn wcel wa cA cX wcel vn cv vf cv cfv cX
        wcel vm cv vf cv cfv cX wcel cA vn cv vf cv cfv cM co cA vm cv vf cv
        cfv cM co cM co vm cv vf cv cfv vn cv vf cv cfv cM co wceq minvec10.a
        cU cnv wcel cA cX wcel vn cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel
        w3a cA vn cv vf cv cfv cM co cA vm cv vf cv cfv cM co cM co vm cv vf cv
        cfv vn cv vf cv cfv cM co wceq cU minvec10.u phnvi cA vn cv vf cv cfv
        vm cv vf cv cfv cU cM cX minvec10.x minvec10.m nvnnncan1 mpan mp3an1 cU
        vf vn cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem4
        cU vf vm cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x
        minveclem4 syl2an eqtrd fveq2d vn cv vf cv cfv cX wcel vm cv vf cv cfv
        cX wcel vn cv vf cv cfv vm cv vf cv cfv cM co cN cfv vm cv vf cv cfv vn
        cv vf cv cfv cM co cN cfv wceq cn cY vf cv wf vn cv cn wcel wa cn cY vf
        cv wf vm cv cn wcel wa cU cnv wcel vn cv vf cv cfv cX wcel vm cv vf cv
        cfv cX wcel vn cv vf cv cfv vm cv vf cv cfv cM co cN cfv vm cv vf cv
        cfv vn cv vf cv cfv cM co cN cfv wceq cU minvec10.u phnvi vn cv vf cv
        cfv vm cv vf cv cfv cU cM cN cX minvec10.x minvec10.m minvec10.n nvsub
        mp3an1 cU vf vn cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x
        minveclem4 cU vf vm cW cX cY minvec10.u minvec10.w1 minvec10.y
        minvec10.x minveclem4 syl2an eqtr4d opreq1d eqtrd $.
        $( [7-Apr-2008] $) $( [9-Mar-2008] $)

      minvec19.s $e |- S = ( .s ` U ) $.
      minvec19.2 $e |- P = -u sup ( R , RR , < ) $.
      $( Lemma for ~ minvecex . $)
      minveclem19 $p |- ( ( ( f : NN --> Y /\ n e. NN ) /\ ( f : NN --> Y /\
            m e. NN ) ) -> ( 2 x. P ) <_
          ( N ` ( ( H ` n ) G ( H ` m ) ) ) ) $=
        cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa c2
        cP cmul co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS
        co cM co cS co cN cfv vn cv cH cfv vm cv cH cfv cG co cN cfv cle vx vy
        cA cP cR cS cU vf vm vn cG cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec19.2 minvec18.g minvec19.s minveclem16 cn cY vf cv wf vn cv cn
        wcel wa cn cY vf cv wf vm cv cn wcel wa wa c2 cA c1 c2 cdiv co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co cM co cS co vn cv cH cfv vm cv cH
        cfv cG co cN cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn
        wcel wa wa vn cv cH cfv vm cv cH cfv cG co c2 cA cS co vn cv vf cv cfv
        vm cv vf cv cfv cG co cM co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv
        vf cv cfv cG co cS co cM co cS co cn cY vf cv wf vn cv cn wcel wa cn cY
        vf cv wf vm cv cn wcel wa wa vn cv cH cfv vm cv cH cfv cG co cA cA cG
        co vn cv vf cv cfv vm cv vf cv cfv cG co cM co c2 cA cS co vn cv vf cv
        cfv vm cv vf cv cfv cG co cM co cn cY vf cv wf vn cv cn wcel wa cn cY
        vf cv wf vm cv cn wcel wa wa vn cv cH cfv vm cv cH cfv cG co cA vn cv
        vf cv cfv cM co cA vm cv vf cv cfv cM co cG co cA cA cG co vn cv vf cv
        cfv vm cv vf cv cfv cG co cM co vn cv cn wcel vm cv cn wcel vn cv cH
        cfv vm cv cH cfv cG co cA vn cv vf cv cfv cM co cA vm cv vf cv cfv cM
        co cG co wceq cn cY vf cv wf cn cY vf cv wf vn cv cn wcel vm cv cn wcel
        vn cv cH cfv cA vn cv vf cv cfv cM co vm cv cH cfv cA vm cv vf cv cfv
        cM co cG cA vf vj vn cH cM minvec17.h minveclem6 cA vf vj vm cH cM
        minvec17.h minveclem6 opreqan12d ad2ant2l vn cv vf cv cfv cX wcel vm cv
        vf cv cfv cX wcel cA cA cG co vn cv vf cv cfv vm cv vf cv cfv cG co cM
        co cA vn cv vf cv cfv cM co cA vm cv vf cv cfv cM co cG co wceq cn cY
        vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa cU cnv wcel
        cA cX wcel cA cX wcel wa vn cv vf cv cfv cX wcel vm cv vf cv cfv cX
        wcel wa cA cA cG co vn cv vf cv cfv vm cv vf cv cfv cG co cM co cA vn
        cv vf cv cfv cM co cA vm cv vf cv cfv cM co cG co wceq cU minvec10.u
        phnvi cA cX wcel cA cX wcel minvec10.a minvec10.a pm3.2i cA cA vn cv vf
        cv cfv vm cv vf cv cfv cU cG cM cX minvec10.x minvec18.g minvec10.m
        nvaddsub4 mp3an12 cU vf vn cW cX cY minvec10.u minvec10.w1 minvec10.y
        minvec10.x minveclem4 cU vf vm cW cX cY minvec10.u minvec10.w1
        minvec10.y minvec10.x minveclem4 syl2an eqtr4d cA cA cG co c2 cA cS co
        vn cv vf cv cfv vm cv vf cv cfv cG co cM cU cnv wcel cA cX wcel cA cA
        cG co c2 cA cS co wceq cU minvec10.u phnvi minvec10.a cA cS cU cG cX
        minvec10.x minvec18.g minvec19.s nv2 mp2an opreq1i syl6eq vn cv vf cv
        cfv cX wcel vm cv vf cv cfv cX wcel c2 cA cS co vn cv vf cv cfv vm cv
        vf cv cfv cG co cM co c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv
        cfv cG co cS co cM co cS co wceq cn cY vf cv wf vn cv cn wcel wa cn cY
        vf cv wf vm cv cn wcel wa vn cv vf cv cfv cX wcel vm cv vf cv cfv cX
        wcel wa vn cv vf cv cfv vm cv vf cv cfv cG co cX wcel c2 cA cS co vn cv
        vf cv cfv vm cv vf cv cfv cG co cM co c2 cA c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cS co cM co cS co wceq cU cnv wcel vn cv vf
        cv cfv cX wcel vm cv vf cv cfv cX wcel vn cv vf cv cfv vm cv vf cv cfv
        cG co cX wcel cU minvec10.u phnvi vn cv vf cv cfv vm cv vf cv cfv cU cG
        cX minvec10.x minvec18.g nvgcl mp3an1 vn cv vf cv cfv vm cv vf cv cfv
        cG co cX wcel c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co
        cS co cM co cS co c2 cA cS co c2 c1 c2 cdiv co vn cv vf cv cfv vm cv vf
        cv cfv cG co cS co cS co cM co c2 cA cS co vn cv vf cv cfv vm cv vf cv
        cfv cG co cM co vn cv vf cv cfv vm cv vf cv cfv cG co cX wcel c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cX wcel c2 cA c1 c2
        cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cM co cS co c2 cA
        cS co c2 c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cS
        co cM co wceq cU cnv wcel c1 c2 cdiv co cc wcel vn cv vf cv cfv vm cv
        vf cv cfv cG co cX wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv
        cG co cS co cX wcel cU minvec10.u phnvi c2 2cn 2ne0 reccli c1 c2 cdiv
        co vn cv vf cv cfv vm cv vf cv cfv cG co cS cU cX minvec10.x minvec19.s
        nvscl mp3an12 c2 cc wcel cA cX wcel c1 c2 cdiv co vn cv vf cv cfv vm cv
        vf cv cfv cG co cS co cX wcel c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv
        vf cv cfv cG co cS co cM co cS co c2 cA cS co c2 c1 c2 cdiv co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co cS co cM co wceq 2cn minvec10.a cU
        cnv wcel c2 cc wcel cA cX wcel c1 c2 cdiv co vn cv vf cv cfv vm cv vf
        cv cfv cG co cS co cX wcel w3a c2 cA c1 c2 cdiv co vn cv vf cv cfv vm
        cv vf cv cfv cG co cS co cM co cS co c2 cA cS co c2 c1 c2 cdiv co vn cv
        vf cv cfv vm cv vf cv cfv cG co cS co cS co cM co wceq cU minvec10.u
        phnvi c2 cA c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co
        cS cU cM cX minvec10.x minvec10.m minvec19.s nvmdi mpan mp3an12 syl vn
        cv vf cv cfv vm cv vf cv cfv cG co cX wcel c2 c1 c2 cdiv co vn cv vf cv
        cfv vm cv vf cv cfv cG co cS co cS co vn cv vf cv cfv vm cv vf cv cfv
        cG co c2 cA cS co cM vn cv vf cv cfv vm cv vf cv cfv cG co cX wcel c2
        c1 c2 cdiv co cmul co vn cv vf cv cfv vm cv vf cv cfv cG co cS co c2 c1
        c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cS co vn cv vf
        cv cfv vm cv vf cv cfv cG co c2 cc wcel c1 c2 cdiv co cc wcel vn cv vf
        cv cfv vm cv vf cv cfv cG co cX wcel c2 c1 c2 cdiv co cmul co vn cv vf
        cv cfv vm cv vf cv cfv cG co cS co c2 c1 c2 cdiv co vn cv vf cv cfv vm
        cv vf cv cfv cG co cS co cS co wceq 2cn c2 2cn 2ne0 reccli cU cnv wcel
        c2 cc wcel c1 c2 cdiv co cc wcel vn cv vf cv cfv vm cv vf cv cfv cG co
        cX wcel w3a c2 c1 c2 cdiv co cmul co vn cv vf cv cfv vm cv vf cv cfv cG
        co cS co c2 c1 c2 cdiv co vn cv vf cv cfv vm cv vf cv cfv cG co cS co
        cS co wceq cU minvec10.u phnvi c2 c1 c2 cdiv co vn cv vf cv cfv vm cv
        vf cv cfv cG co cS cU cX minvec10.x minvec19.s nvsass mpan mp3an12 vn
        cv vf cv cfv vm cv vf cv cfv cG co cX wcel c1 vn cv vf cv cfv vm cv vf
        cv cfv cG co cS co vn cv vf cv cfv vm cv vf cv cfv cG co c2 c1 c2 cdiv
        co cmul co vn cv vf cv cfv vm cv vf cv cfv cG co cS co cU cnv wcel vn
        cv vf cv cfv vm cv vf cv cfv cG co cX wcel c1 vn cv vf cv cfv vm cv vf
        cv cfv cG co cS co vn cv vf cv cfv vm cv vf cv cfv cG co wceq cU
        minvec10.u phnvi vn cv vf cv cfv vm cv vf cv cfv cG co cS cU cX
        minvec10.x minvec19.s nvsid mpan c2 c1 c2 cdiv co cmul co c1 vn cv vf
        cv cfv vm cv vf cv cfv cG co cS c2 2cn 2ne0 recidi opreq1i syl5eq
        eqtr3d opreq2d eqtr2d syl cU vf vn cW cX cY minvec10.u minvec10.w1
        minvec10.y minvec10.x minveclem4 cU vf vm cW cX cY minvec10.u
        minvec10.w1 minvec10.y minvec10.x minveclem4 syl2an eqtr2d fveq2d
        breqtrd $.
        $( [7-Apr-2008] $) $( [17-Feb-2008] $)
    $}

    ${
      minvec20.h $e |- ( j e. NN -> ( H ` j ) = ( A M ( f ` j ) ) ) $.
      minvec20.f $e |- ( j e. NN -> ( F ` j ) = ( N ` ( H ` j ) ) ) $.
      $( Lemma for ~ minvecex . $)
      minveclem20 $p |- ( ( f : NN --> Y /\ n e. NN ) -> ( F ` n ) e. RR ) $=
        cn cY vf cv wf vn cv cn wcel wa vn cv cF cfv cA vn cv vf cv cfv cM co
        cN cfv cr vn cv cn wcel vn cv cF cfv cA vn cv vf cv cfv cM co cN cfv
        wceq cn cY vf cv wf vn cv cn wcel vn cv cF cfv vn cv cH cfv cN cfv cA
        vn cv vf cv cfv cM co cN cfv vj vn cF cH cN minvec20.f minveclem7 vn cv
        cn wcel vn cv cH cfv cA vn cv vf cv cfv cM co cN cA vf vj vn cH cM
        minvec20.h minveclem6 fveq2d eqtrd adantl cn cY vf cv wf vn cv cn wcel
        wa vn cv vf cv cfv cX wcel cA vn cv vf cv cfv cM co cN cfv cr wcel cU
        vf vn cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem4
        vn cv vf cv cfv cX wcel cA vn cv vf cv cfv cM co cX wcel cA vn cv vf cv
        cfv cM co cN cfv cr wcel cU cnv wcel cA cX wcel vn cv vf cv cfv cX wcel
        cA vn cv vf cv cfv cM co cX wcel cU minvec10.u phnvi minvec10.a cA vn
        cv vf cv cfv cU cM cX minvec10.x minvec10.m nvmcl mp3an12 cU cnv wcel
        cA vn cv vf cv cfv cM co cX wcel cA vn cv vf cv cfv cM co cN cfv cr
        wcel cU minvec10.u phnvi cA vn cv vf cv cfv cM co cU cN cX minvec10.x
        minvec10.n nvcl mpan syl syl eqeltrd $.
        $( [7-Apr-2008] $) $( [17-Feb-2008] $)

      minvec21.2 $e |- P = -u sup ( R , RR , < ) $.
      $( Lemma for ~ minvecex . $)
      minveclem21 $p |- ( ( ( f : NN --> Y /\ n e. NN ) /\ ( f : NN --> Y /\
        m e. NN ) ) -> ( ( N ` ( ( f ` n ) M ( f ` m ) ) ) ^ 2 ) <_ ( ( 2 x.
        ( ( ( F ` n ) ^ 2 ) + ( ( F ` m ) ^ 2 ) ) ) - ( ( 2 x. P ) ^ 2 ) ) ) $=
        cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa vn
        cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co c2 vn cv cF cfv c2
        cexp co vm cv cF cfv c2 cexp co caddc co cmul co vn cv cH cfv vm cv cH
        cfv cU cpv cfv co cN cfv c2 cexp co cmin co c2 vn cv cF cfv c2 cexp co
        vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin
        co cle cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa
        wa c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co
        vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co cmin co c2 vn
        cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2 cexp co caddc co
        cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co cmin
        co vn cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co vn cv cn
        wcel vm cv cn wcel c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp
        co cmin co c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2
        cexp co caddc co cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv
        c2 cexp co cmin co wceq cn cY vf cv wf cn cY vf cv wf vn cv cn wcel vm
        cv cn wcel wa c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc
        co cmul co c2 vn cv cH cfv cN cfv c2 cexp co vm cv cH cfv cN cfv c2
        cexp co caddc co cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv
        c2 cexp co cmin vn cv cn wcel vm cv cn wcel wa vn cv cF cfv c2 cexp co
        vm cv cF cfv c2 cexp co caddc co vn cv cH cfv cN cfv c2 cexp co vm cv
        cH cfv cN cfv c2 cexp co caddc co c2 cmul vn cv cn wcel vm cv cn wcel
        vn cv cF cfv c2 cexp co vn cv cH cfv cN cfv c2 cexp co vm cv cF cfv c2
        cexp co vm cv cH cfv cN cfv c2 cexp co caddc vn cv cn wcel vn cv cF cfv
        vn cv cH cfv cN cfv c2 cexp vj vn cF cH cN minvec20.f minveclem7
        opreq1d vm cv cn wcel vm cv cF cfv vm cv cH cfv cN cfv c2 cexp vj vm cF
        cH cN minvec20.f minveclem7 opreq1d opreqan12d opreq2d opreq1d ad2ant2l
        vx vy cA cR cU vf vj vm vn cU cpv cfv cH cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec20.h cU cpv cfv eqid minveclem18 eqtr2d cn cY vf cv wf
        vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa c2 cP cmul co c2
        cexp co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co cle
        wbr c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co
        vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co cmin co c2 vn
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 cP
        cmul co c2 cexp co cmin co cle wbr vn cv cH cfv vm cv cH cfv cU cpv cfv
        co cN cfv cr wcel c2 cP cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co
        cN cfv cle wbr c2 cP cmul co c2 cexp co vn cv cH cfv vm cv cH cfv cU
        cpv cfv co cN cfv c2 cexp co cle wbr cn cY vf cv wf vn cv cn wcel wa cn
        cY vf cv wf vm cv cn wcel wa wa c2 cP cmul co cr wcel cc0 c2 cP cmul co
        cle wbr vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv cr wcel c2 cP
        cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv cle wbr wa c2 cP
        cmul co c2 cexp co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2
        cexp co cle wbr c2 cP 2re vx vy cA cP cR cU cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec21.2 minveclem12 remulcli cc0 c2 cle wbr cc0 cP cle
        wbr cc0 c2 cP cmul co cle wbr cc0 c2 0re 2re 2pos ltleii vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec21.2 minveclem14 c2
        cP 2re vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec21.2 minveclem12 mulge0i mp2an c2 cP cmul co vn cv cH cfv vm cv
        cH cfv cU cpv cfv co cN cfv le2sq2 mpanl12 vn cv cH cfv cX wcel vm cv
        cH cfv cX wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv cr wcel
        cn cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa vn cv
        cH cfv cX wcel vm cv cH cfv cX wcel wa vn cv cH cfv vm cv cH cfv cU cpv
        cfv co cX wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv cr wcel
        cU cnv wcel vn cv cH cfv cX wcel vm cv cH cfv cX wcel vn cv cH cfv vm
        cv cH cfv cU cpv cfv co cX wcel cU minvec10.u phnvi vn cv cH cfv vm cv
        cH cfv cU cU cpv cfv cX minvec10.x cU cpv cfv eqid nvgcl mp3an1 cU cnv
        wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cX wcel vn cv cH cfv vm cv
        cH cfv cU cpv cfv co cN cfv cr wcel cU minvec10.u phnvi vn cv cH cfv vm
        cv cH cfv cU cpv cfv co cU cN cX minvec10.x minvec10.n nvcl mpan syl vx
        vy cA cR cU vf vj vn cH cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec20.h
        minveclem17 vx vy cA cR cU vf vj vm cH cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec20.h minveclem17 syl2an vx vy cA cP cR cU cns cfv cU
        vf vj vm vn cU cpv cfv cH cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec20.h cU cpv cfv eqid cU cns cfv eqid minvec21.2 minveclem19
        sylanc vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co cr
        wcel c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul
        co cr wcel c2 cP cmul co c2 cexp co vn cv cH cfv vm cv cH cfv cU cpv
        cfv co cN cfv c2 cexp co cle wbr c2 vn cv cF cfv c2 cexp co vm cv cF
        cfv c2 cexp co caddc co cmul co vn cv cH cfv vm cv cH cfv cU cpv cfv co
        cN cfv c2 cexp co cmin co c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin co cle wbr wb cn
        cY vf cv wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa wa c2 cP
        cmul co c2 cexp co cr wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cN
        cfv c2 cexp co cr wcel c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co cmul co cr wcel c2 cP cmul co c2 cexp co vn cv cH cfv vm cv
        cH cfv cU cpv cfv co cN cfv c2 cexp co cle wbr c2 vn cv cF cfv c2 cexp
        co vm cv cF cfv c2 cexp co caddc co cmul co vn cv cH cfv vm cv cH cfv
        cU cpv cfv co cN cfv c2 cexp co cmin co c2 vn cv cF cfv c2 cexp co vm
        cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin co
        cle wbr wb c2 cP cmul co c2 cP 2re vx vy cA cP cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec21.2 minveclem12 remulcli resqcli c2 cP
        cmul co c2 cexp co vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2
        cexp co c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co
        cmul co lesub2 mp3an1 vn cv cH cfv cX wcel vm cv cH cfv cX wcel vn cv
        cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co cr wcel cn cY vf cv
        wf vn cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa vn cv cH cfv cX
        wcel vm cv cH cfv cX wcel wa vn cv cH cfv vm cv cH cfv cU cpv cfv co cN
        cfv cr wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv c2 cexp co
        cr wcel vn cv cH cfv cX wcel vm cv cH cfv cX wcel wa vn cv cH cfv vm cv
        cH cfv cU cpv cfv co cX wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cN
        cfv cr wcel cU cnv wcel vn cv cH cfv cX wcel vm cv cH cfv cX wcel vn cv
        cH cfv vm cv cH cfv cU cpv cfv co cX wcel cU minvec10.u phnvi vn cv cH
        cfv vm cv cH cfv cU cU cpv cfv cX minvec10.x cU cpv cfv eqid nvgcl
        mp3an1 cU cnv wcel vn cv cH cfv vm cv cH cfv cU cpv cfv co cX wcel vn
        cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv cr wcel cU minvec10.u phnvi
        vn cv cH cfv vm cv cH cfv cU cpv cfv co cU cN cX minvec10.x minvec10.n
        nvcl mpan syl vn cv cH cfv vm cv cH cfv cU cpv cfv co cN cfv resqcl syl
        vx vy cA cR cU vf vj vn cH cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec20.h minveclem17 vx vy cA cR cU vf vj vm cH cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec20.h minveclem17 syl2an vn cv cF cfv cr
        wcel vm cv cF cfv cr wcel c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co cmul co cr wcel cn cY vf cv wf vn cv cn wcel wa cn cY
        vf cv wf vm cv cn wcel wa vn cv cF cfv cr wcel vm cv cF cfv cr wcel wa
        vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cr wcel c2 vn
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co cr wcel
        vn cv cF cfv c2 cexp co cr wcel vm cv cF cfv c2 cexp co cr wcel vn cv
        cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cr wcel vn cv cF cfv
        cr wcel vm cv cF cfv cr wcel vn cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co readdcl vn cv cF cfv resqcl vm cv cF cfv resqcl syl2an c2 cr
        wcel vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cr wcel
        c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co cr
        wcel 2re c2 vn cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co
        remulcl mpan syl vx vy cA cR cU vf vj vn cF cH cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec20.h minvec20.f minveclem20 vx vy cA cR cU
        vf vj vm cF cH cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec20.h
        minvec20.f minveclem20 syl2an sylanc mpbid eqbrtrd $.
        $( [7-Apr-2008] $) $( [7-Mar-2008] $)
    $}

    ${
      minvec22.hf $e |- ( j e. NN -> ( F ` j ) = ( N ` ( A M ( f ` j ) ) ) ) $.
      $( Lemma for ~ minvecex . $)
      minveclem22 $p |- ( ( f : NN --> Y /\ n e. NN ) -> ( F ` n ) e. RR ) $=
        cn cY vf cv wf vn cv cn wcel wa vn cv cF cfv cA vn cv vf cv cfv cM co
        cN cfv cr vn cv cn wcel vn cv cF cfv cA vn cv vf cv cfv cM co cN cfv
        wceq cn cY vf cv wf cA vf vj vn cF cM cN minvec22.hf minveclem8 adantl
        cn cY vf cv wf vn cv cn wcel wa vn cv vf cv cfv cX wcel cA vn cv vf cv
        cfv cM co cN cfv cr wcel cU vf vn cW cX cY minvec10.u minvec10.w1
        minvec10.y minvec10.x minveclem4 vn cv vf cv cfv cX wcel cA vn cv vf cv
        cfv cM co cX wcel cA vn cv vf cv cfv cM co cN cfv cr wcel cU cnv wcel
        cA cX wcel vn cv vf cv cfv cX wcel cA vn cv vf cv cfv cM co cX wcel cU
        minvec10.u phnvi minvec10.a cA vn cv vf cv cfv cU cM cX minvec10.x
        minvec10.m nvmcl mp3an12 cU cnv wcel cA vn cv vf cv cfv cM co cX wcel
        cA vn cv vf cv cfv cM co cN cfv cr wcel cU minvec10.u phnvi cA vn cv vf
        cv cfv cM co cU cN cX minvec10.x minvec10.n nvcl mpan syl syl eqeltrd
        $.
        $( [7-Apr-2008] $) $( [17-Feb-2008] $)

      minvec23.2 $e |- P = -u sup ( R , RR , < ) $.
      $( Lemma for ~ minvecex .  Eliminate ` H ` . $)
      minveclem23 $p |- ( ( ( f : NN --> Y /\ n e. NN ) /\ ( f : NN --> Y /\
        m e. NN ) ) -> ( ( N ` ( ( f ` n ) M ( f ` m ) ) ) ^ 2 ) <_ ( ( 2 x.
        ( ( ( F ` n ) ^ 2 ) + ( ( F ` m ) ^ 2 ) ) ) - ( ( 2 x. P ) ^ 2 ) ) ) $=
        vx vy cA cP cR cU vf vj vm vn cF vk cv cn wcel vu cv cA vk cv vf cv cfv
        cM co wceq wa vk vu copab cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a vk
        vu vj cv cA vk cv vf cv cfv cM co cA vj cv vf cv cfv cM co cn vk cv cn
        wcel vu cv cA vk cv vf cv cfv cM co wceq wa vk vu copab vk cv vj cv
        wceq vk cv vf cv cfv vj cv vf cv cfv cA cM vk cv vj cv vf cv fveq2
        opreq2d vk cv cn wcel vu cv cA vk cv vf cv cfv cM co wceq wa vk vu
        copab eqid cA vj cv vf cv cfv cM oprex fvopab4 vj cv cn wcel vj cv cF
        cfv cA vj cv vf cv cfv cM co cN cfv vj cv vk cv cn wcel vu cv cA vk cv
        vf cv cfv cM co wceq wa vk vu copab cfv cN cfv minvec22.hf vj cv cn
        wcel vj cv vk cv cn wcel vu cv cA vk cv vf cv cfv cM co wceq wa vk vu
        copab cfv cN cfv cA vj cv vf cv cfv cM co cN cfv vj cv cn wcel vj cv vk
        cv cn wcel vu cv cA vk cv vf cv cfv cM co wceq wa vk vu copab cfv cA vj
        cv vf cv cfv cM co cN vk vu vj cv cA vk cv vf cv cfv cM co cA vj cv vf
        cv cfv cM co cn vk cv cn wcel vu cv cA vk cv vf cv cfv cM co wceq wa vk
        vu copab vk cv vj cv wceq vk cv vf cv cfv vj cv vf cv cfv cA cM vk cv
        vj cv vf cv fveq2 opreq2d vk cv cn wcel vu cv cA vk cv vf cv cfv cM co
        wceq wa vk vu copab eqid cA vj cv vf cv cfv cM oprex fvopab4 fveq2d
        eqcomd eqtrd minvec23.2 minveclem21 $.
        $( [7-Apr-2008] $) $( [8-Mar-2008] $)

      $( Use F - P g.e. 0 instead of abs for lt2sqt?  check hyp chaining $)
      $( Lemma for ~ minvecex . $)
      minveclem24 $p |- ( ( f : NN --> Y /\ F ~~> P /\ B e. RR+ ) ->
         E. k e. NN A. n e. NN ( k <_ n -> ( ( ( F ` n ) - P ) ^ 2 ) < B ) ) $=
        cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv cle wbr vn cv
        cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr wi vn cn wral vk cn wrex
        vk cv vn cv cle wbr vn cv cF cfv cP cmin co c2 cexp co cB clt wbr wi vn
        cn wral vk cn wrex cF cP cli wbr cB crp wcel vk cv vn cv cle wbr vn cv
        cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr wi vn cn wral vk cn wrex
        cn cY vf cv wf cF cP cli wbr cB csqr cfv crp wcel vk cv vn cv cle wbr
        vn cv cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr wi vn cn wral vk
        cn wrex cB crp wcel vx vy cA cB csqr cfv cP cR cU vk vn cF cM cN cW cX
        cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem15 cB rpsqrcl sylan2 3adant1
        cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv cle wbr vn cv
        cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr wi vn cn wral vk cv vn
        cv cle wbr vn cv cF cfv cP cmin co c2 cexp co cB clt wbr wi vn cn wral
        vk cn cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv cle wbr
        vn cv cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr wi vk cv vn cv cle
        wbr vn cv cF cfv cP cmin co c2 cexp co cB clt wbr wi vn cn cn cY vf cv
        wf cF cP cli wbr cB crp wcel w3a vn cv cn wcel wa vn cv cF cfv cP cmin
        co cabs cfv cB csqr cfv clt wbr vn cv cF cfv cP cmin co c2 cexp co cB
        clt wbr vk cv vn cv cle wbr cn cY vf cv wf cB crp wcel vn cv cn wcel vn
        cv cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr vn cv cF cfv cP cmin
        co c2 cexp co cB clt wbr wb cF cP cli wbr cn cY vf cv wf vn cv cn wcel
        cB crp wcel vn cv cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr vn cv
        cF cfv cP cmin co c2 cexp co cB clt wbr wb vn cv cF cfv cP cmin co cr
        wcel cn cY vf cv wf vn cv cn wcel wa wa cB cr wcel cc0 cB cle wbr wa vn
        cv cF cfv cP cmin co cabs cfv cB csqr cfv clt wbr vn cv cF cfv cP cmin
        co c2 cexp co cB clt wbr wb cn cY vf cv wf vn cv cn wcel wa cB crp wcel
        vn cv cF cfv cP cmin co cr wcel cn cY vf cv wf vn cv cn wcel wa wa cB
        cr wcel cc0 cB cle wbr wa wa vn cv cF cfv cP cmin co cabs cfv cB csqr
        cfv clt wbr vn cv cF cfv cP cmin co cabs cfv c2 cexp co cB csqr cfv c2
        cexp co clt wbr vn cv cF cfv cP cmin co c2 cexp co cB csqr cfv c2 cexp
        co clt wbr vn cv cF cfv cP cmin co c2 cexp co cB clt wbr vn cv cF cfv
        cP cmin co cabs cfv cr wcel cc0 vn cv cF cfv cP cmin co cabs cfv cle
        wbr wa cB csqr cfv cr wcel cc0 cB csqr cfv cle wbr wa vn cv cF cfv cP
        cmin co cabs cfv cB csqr cfv clt wbr vn cv cF cfv cP cmin co cabs cfv
        c2 cexp co cB csqr cfv c2 cexp co clt wbr wb vn cv cF cfv cP cmin co cr
        wcel cn cY vf cv wf vn cv cn wcel wa wa cB cr wcel cc0 cB cle wbr wa vn
        cv cF cfv cP cmin co cabs cfv cB csqr cfv lt2sq vn cv cF cfv cP cmin co
        cr wcel vn cv cF cfv cP cmin co cabs cfv cr wcel cc0 vn cv cF cfv cP
        cmin co cabs cfv cle wbr wa cn cY vf cv wf vn cv cn wcel wa vn cv cF
        cfv cP cmin co cr wcel vn cv cF cfv cP cmin co cabs cfv cr wcel cc0 vn
        cv cF cfv cP cmin co cabs cfv cle wbr vn cv cF cfv cP cmin co cr wcel
        vn cv cF cfv cP cmin co cc wcel vn cv cF cfv cP cmin co cabs cfv cr
        wcel vn cv cF cfv cP cmin co recn vn cv cF cfv cP cmin co abscl syl vn
        cv cF cfv cP cmin co cr wcel vn cv cF cfv cP cmin co cc wcel cc0 vn cv
        cF cfv cP cmin co cabs cfv cle wbr vn cv cF cfv cP cmin co recn vn cv
        cF cfv cP cmin co absge0 syl jca adantr cB cr wcel cc0 cB cle wbr wa cB
        csqr cfv cr wcel cc0 cB csqr cfv cle wbr cB sqrcl cB sqrge0 jca syl2an
        vn cv cF cfv cP cmin co cr wcel vn cv cF cfv cP cmin co cabs cfv c2
        cexp co cB csqr cfv c2 cexp co clt wbr vn cv cF cfv cP cmin co c2 cexp
        co cB csqr cfv c2 cexp co clt wbr wb cn cY vf cv wf vn cv cn wcel wa cB
        cr wcel cc0 cB cle wbr wa vn cv cF cfv cP cmin co cr wcel vn cv cF cfv
        cP cmin co cabs cfv c2 cexp co vn cv cF cfv cP cmin co c2 cexp co cB
        csqr cfv c2 cexp co clt vn cv cF cfv cP cmin co absresq breq1d ad2antrr
        vn cv cF cfv cP cmin co cr wcel cn cY vf cv wf vn cv cn wcel wa wa cB
        cr wcel cc0 cB cle wbr wa wa cB csqr cfv c2 cexp co cB vn cv cF cfv cP
        cmin co c2 cexp co clt cB cr wcel cc0 cB cle wbr wa cB csqr cfv c2 cexp
        co cB wceq vn cv cF cfv cP cmin co cr wcel cn cY vf cv wf vn cv cn wcel
        wa wa cB sqsqr adantl breq2d 3bitrd cn cY vf cv wf vn cv cn wcel wa vn
        cv cF cfv cP cmin co cr wcel cn cY vf cv wf vn cv cn wcel wa vn cv cF
        cfv cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cR cU vf vj vn cF
        cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec22.hf minveclem22 vn cv cF cfv
        cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cP cR cU cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn cv cF cfv
        cP resubcl mpan2 syl ancri cB crp wcel cB cr wcel cc0 cB cle wbr cB
        rpre cB rpge0 jca syl2an an1rs 3adantl2 imbi2d ralbidva rexbidv mpbid
        $.
        $( [7-Apr-2008] $) $( [21-Feb-2008] $)

      $d x y P $.
      $( Lemma for ~ minvecex . $)
      minveclem25 $p |- ( ( f : NN --> Y /\ F ~~> P /\ B e. RR+ ) ->
          E. k e. NN A. n e. NN
                ( k <_ n -> ( ( 2 x. P ) x. ( ( F ` n ) - P ) ) < B ) ) $=
        cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv cle wbr vn cv
        cF cfv cP cmin co cabs cfv cB c2 cP cmul co c1 caddc co cdiv co clt wbr
        wi vn cn wral vk cn wrex vk cv vn cv cle wbr c2 cP cmul co vn cv cF cfv
        cP cmin co cmul co cB clt wbr wi vn cn wral vk cn wrex cF cP cli wbr cB
        crp wcel vk cv vn cv cle wbr vn cv cF cfv cP cmin co cabs cfv cB c2 cP
        cmul co c1 caddc co cdiv co clt wbr wi vn cn wral vk cn wrex cn cY vf
        cv wf cF cP cli wbr cB c2 cP cmul co c1 caddc co cdiv co crp wcel vk cv
        vn cv cle wbr vn cv cF cfv cP cmin co cabs cfv cB c2 cP cmul co c1
        caddc co cdiv co clt wbr wi vn cn wral vk cn wrex cB crp wcel vx vy cA
        cB c2 cP cmul co c1 caddc co cdiv co cP cR cU vk vn cF cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem15 cB crp wcel c2 cP cmul co
        c1 caddc co crp wcel cB c2 cP cmul co c1 caddc co cdiv co crp wcel c2
        cP cmul co c1 caddc co c2 cP cmul co c1 c2 cP 2re vx vy cA cP cR cU cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 remulcli 1re
        readdcli cc0 c2 cP cmul co cle wbr cc0 c1 clt wbr cc0 c2 cP cmul co c1
        caddc co clt wbr cc0 c2 cle wbr cc0 cP cle wbr cc0 c2 cP cmul co cle
        wbr cc0 c2 0re 2re 2pos ltleii vx vy cA cP cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem14 c2 cP 2re vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12
        mulge0i mp2an lt01 c2 cP cmul co c1 c2 cP 2re vx vy cA cP cR cU cM cN
        cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 remulcli 1re
        addgegt0i mp2an elrpii cB c2 cP cmul co c1 caddc co rpdivcl mpan2
        sylan2 3adant1 cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv
        cle wbr vn cv cF cfv cP cmin co cabs cfv cB c2 cP cmul co c1 caddc co
        cdiv co clt wbr wi vn cn wral vk cv vn cv cle wbr c2 cP cmul co vn cv
        cF cfv cP cmin co cmul co cB clt wbr wi vn cn wral vk cn cn cY vf cv wf
        cF cP cli wbr cB crp wcel w3a vk cv vn cv cle wbr vn cv cF cfv cP cmin
        co cabs cfv cB c2 cP cmul co c1 caddc co cdiv co clt wbr wi vk cv vn cv
        cle wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB clt wbr wi vn
        cn cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vn cv cn wcel wa vn cv
        cF cfv cP cmin co cabs cfv cB c2 cP cmul co c1 caddc co cdiv co clt wbr
        c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB clt wbr vk cv vn cv
        cle wbr cn cY vf cv wf cB crp wcel vn cv cn wcel vn cv cF cfv cP cmin
        co cabs cfv cB c2 cP cmul co c1 caddc co cdiv co clt wbr c2 cP cmul co
        vn cv cF cfv cP cmin co cmul co cB clt wbr wi cF cP cli wbr cn cY vf cv
        wf vn cv cn wcel cB crp wcel vn cv cF cfv cP cmin co cabs cfv cB c2 cP
        cmul co c1 caddc co cdiv co clt wbr c2 cP cmul co vn cv cF cfv cP cmin
        co cmul co cB clt wbr wi vn cv cF cfv cr wcel cB crp wcel vn cv cF cfv
        cP cmin co cabs cfv cB c2 cP cmul co c1 caddc co cdiv co clt wbr c2 cP
        cmul co vn cv cF cfv cP cmin co cmul co cB clt wbr wi cn cY vf cv wf vn
        cv cn wcel wa vn cv cF cfv cr wcel cB crp wcel wa vn cv cF cfv cP cmin
        co cabs cfv cB c2 cP cmul co c1 caddc co cdiv co clt wbr c2 cP cmul co
        c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co cB clt wbr c2 cP
        cmul co vn cv cF cfv cP cmin co cmul co cB clt wbr vn cv cF cfv cP cmin
        co cabs cfv cr wcel cB cr wcel c2 cP cmul co c1 caddc co vn cv cF cfv
        cP cmin co cabs cfv cmul co cB clt wbr vn cv cF cfv cP cmin co cabs cfv
        cB c2 cP cmul co c1 caddc co cdiv co clt wbr wb vn cv cF cfv cr wcel cB
        crp wcel c2 cP cmul co c1 caddc co cr wcel vn cv cF cfv cP cmin co cabs
        cfv cr wcel cB cr wcel c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin
        co cabs cfv cmul co cB clt wbr vn cv cF cfv cP cmin co cabs cfv cB c2
        cP cmul co c1 caddc co cdiv co clt wbr wb c2 cP cmul co c1 c2 cP 2re vx
        vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 remulcli 1re readdcli c2 cP cmul co c1 caddc co cr wcel vn
        cv cF cfv cP cmin co cabs cfv cr wcel cB cr wcel w3a cc0 c2 cP cmul co
        c1 caddc co clt wbr c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co
        cabs cfv cmul co cB clt wbr vn cv cF cfv cP cmin co cabs cfv cB c2 cP
        cmul co c1 caddc co cdiv co clt wbr wb cc0 c2 cP cmul co cle wbr cc0 c1
        clt wbr cc0 c2 cP cmul co c1 caddc co clt wbr cc0 c2 cle wbr cc0 cP cle
        wbr cc0 c2 cP cmul co cle wbr cc0 c2 0re 2re 2pos ltleii vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem14 c2
        cP 2re vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec23.2 minveclem12 mulge0i mp2an lt01 c2 cP cmul co c1 c2 cP 2re vx
        vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 remulcli 1re addgegt0i mp2an c2 cP cmul co c1 caddc co vn
        cv cF cfv cP cmin co cabs cfv cB ltmuldiv2OLD mpan2 mp3an1 vn cv cF cfv
        cr wcel vn cv cF cfv cP cmin co cc wcel vn cv cF cfv cP cmin co cabs
        cfv cr wcel vn cv cF cfv cr wcel vn cv cF cfv cP cmin co vn cv cF cfv
        cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cP cR cU cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn cv cF cfv
        cP resubcl mpan2 recnd vn cv cF cfv cP cmin co abscl syl cB rpre syl2an
        vn cv cF cfv cr wcel cB crp wcel wa c2 cP cmul co vn cv cF cfv cP cmin
        co cmul co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv
        cmul co cle wbr c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs
        cfv cmul co cB clt wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB
        clt wbr vn cv cF cfv cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul
        co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co
        cle wbr cB crp wcel vn cv cF cfv cr wcel vn cv cF cfv cP cmin co vn cv
        cF cfv cP cmin co cabs cfv cle wbr c2 cP cmul co vn cv cF cfv cP cmin
        co cmul co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv
        cmul co cle wbr vn cv cF cfv cr wcel vn cv cF cfv cP cmin co cr wcel vn
        cv cF cfv cP cmin co vn cv cF cfv cP cmin co cabs cfv cle wbr vn cv cF
        cfv cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn
        cv cF cfv cP resubcl mpan2 vn cv cF cfv cP cmin co leabs syl vn cv cF
        cfv cr wcel c2 cP cmul co c2 cP cmul co c1 caddc co cle wbr vn cv cF
        cfv cP cmin co vn cv cF cfv cP cmin co cabs cfv cle wbr c2 cP cmul co
        vn cv cF cfv cP cmin co cmul co c2 cP cmul co c1 caddc co vn cv cF cfv
        cP cmin co cabs cfv cmul co cle wbr c2 cP cmul co c2 cP cmul co c1
        caddc co c2 cP 2re vx vy cA cP cR cU cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec23.2 minveclem12 remulcli c2 cP cmul co c1 c2 cP 2re
        vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 remulcli 1re readdcli c2 cP cmul co c2 cP 2re vx vy cA cP
        cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12
        remulcli ltp1i ltleii vn cv cF cfv cP cmin co cr wcel vn cv cF cfv cP
        cmin co cabs cfv cr wcel cc0 vn cv cF cfv cP cmin co cabs cfv cle wbr
        wa c2 cP cmul co c2 cP cmul co c1 caddc co cle wbr vn cv cF cfv cP cmin
        co vn cv cF cfv cP cmin co cabs cfv cle wbr wa c2 cP cmul co vn cv cF
        cfv cP cmin co cmul co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin
        co cabs cfv cmul co cle wbr wi vn cv cF cfv cr wcel c2 cP cmul co cr
        wcel cc0 c2 cP cmul co cle wbr wa c2 cP cmul co c1 caddc co cr wcel vn
        cv cF cfv cP cmin co cr wcel vn cv cF cfv cP cmin co cabs cfv cr wcel
        cc0 vn cv cF cfv cP cmin co cabs cfv cle wbr wa wa c2 cP cmul co c2 cP
        cmul co c1 caddc co cle wbr vn cv cF cfv cP cmin co vn cv cF cfv cP
        cmin co cabs cfv cle wbr wa c2 cP cmul co vn cv cF cfv cP cmin co cmul
        co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co
        cle wbr wi c2 cP cmul co cr wcel cc0 c2 cP cmul co cle wbr c2 cP 2re vx
        vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 remulcli cc0 c2 cle wbr cc0 cP cle wbr cc0 c2 cP cmul co
        cle wbr cc0 c2 0re 2re 2pos ltleii vx vy cA cP cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem14 c2 cP 2re vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12
        mulge0i mp2an pm3.2i c2 cP cmul co c1 c2 cP 2re vx vy cA cP cR cU cM cN
        cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 remulcli 1re
        readdcli c2 cP cmul co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin
        co vn cv cF cfv cP cmin co cabs cfv lemul12b mpanl12 vn cv cF cfv cr
        wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cP cR cU cM cN
        cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn cv cF cfv
        cP resubcl mpan2 vn cv cF cfv cr wcel vn cv cF cfv cP cmin co cabs cfv
        cr wcel cc0 vn cv cF cfv cP cmin co cabs cfv cle wbr vn cv cF cfv cr
        wcel vn cv cF cfv cP cmin co cc wcel vn cv cF cfv cP cmin co cabs cfv
        cr wcel vn cv cF cfv cr wcel vn cv cF cfv cP cmin co vn cv cF cfv cr
        wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cP cR cU cM cN
        cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn cv cF cfv
        cP resubcl mpan2 recnd vn cv cF cfv cP cmin co abscl syl vn cv cF cfv
        cr wcel vn cv cF cfv cP cmin co cc wcel cc0 vn cv cF cfv cP cmin co
        cabs cfv cle wbr vn cv cF cfv cr wcel vn cv cF cfv cP cmin co vn cv cF
        cfv cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy cA cP cR
        cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn
        cv cF cfv cP resubcl mpan2 recnd vn cv cF cfv cP cmin co absge0 syl jca
        sylanc mpani mpd adantr c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        cr wcel c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul
        co cr wcel cB cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul co c2
        cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co cle wbr
        c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co cB
        clt wbr wa c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB clt wbr wi
        vn cv cF cfv cr wcel cB crp wcel wa c2 cP cmul co vn cv cF cfv cP cmin
        co cmul co c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv
        cmul co cB lelttr vn cv cF cfv cr wcel c2 cP cmul co vn cv cF cfv cP
        cmin co cmul co cr wcel cB crp wcel vn cv cF cfv cr wcel vn cv cF cfv
        cP cmin co cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul co cr
        wcel vn cv cF cfv cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx
        vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 vn cv cF cfv cP resubcl mpan2 c2 cP cmul co cr wcel vn cv
        cF cfv cP cmin co cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        cr wcel c2 cP 2re vx vy cA cP cR cU cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec23.2 minveclem12 remulcli c2 cP cmul co vn cv cF cfv
        cP cmin co remulcl mpan syl adantr vn cv cF cfv cr wcel c2 cP cmul co
        c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co cr wcel cB crp
        wcel vn cv cF cfv cr wcel vn cv cF cfv cP cmin co cabs cfv cr wcel c2
        cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co cr wcel
        vn cv cF cfv cr wcel vn cv cF cfv cP cmin co cc wcel vn cv cF cfv cP
        cmin co cabs cfv cr wcel vn cv cF cfv cr wcel vn cv cF cfv cP cmin co
        vn cv cF cfv cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx vy
        cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 vn
        cv cF cfv cP resubcl mpan2 recnd vn cv cF cfv cP cmin co abscl syl c2
        cP cmul co c1 caddc co cr wcel vn cv cF cfv cP cmin co cabs cfv cr wcel
        c2 cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv cmul co cr
        wcel c2 cP cmul co c1 c2 cP 2re vx vy cA cP cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem12 remulcli 1re readdcli c2
        cP cmul co c1 caddc co vn cv cF cfv cP cmin co cabs cfv remulcl mpan
        syl adantr cB crp wcel cB cr wcel vn cv cF cfv cr wcel cB rpre adantl
        syl3anc mpand sylbird vx vy cA cR cU vf vj vn cF cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec22.hf minveclem22 sylan an1rs 3adantl2
        imim2d r19.20dva r19.22sdv mpd $.
        $( [7-Apr-2008] $) $( [21-Feb-2008] $)

      $( ?? r19.22dv/r19.20dva could be combined w mnvc3lemm3OLD ? $)
      $( Lemma for ~ minvecex . $)
      minveclem26 $p |- ( ( f : NN --> Y /\ F ~~> P /\ B e. RR+ ) -> E. k e. NN
            A. n e. NN ( k <_ n -> ( ( ( F ` n ) ^ 2 ) - ( P ^ 2 ) ) < B ) ) $=
        cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv cle wbr vn cv
        cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt wbr c2 cP cmul co vn cv
        cF cfv cP cmin co cmul co cB c2 cdiv co clt wbr wa wi vn cn wral vk cn
        wrex vk cv vn cv cle wbr vn cv cF cfv c2 cexp co cP c2 cexp co cmin co
        cB clt wbr wi vn cn wral vk cn wrex cn cY vf cv wf cF cP cli wbr cB c2
        cdiv co crp wcel vk cv vn cv cle wbr vn cv cF cfv cP cmin co c2 cexp co
        cB c2 cdiv co clt wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB
        c2 cdiv co clt wbr wa wi vn cn wral vk cn wrex cB crp wcel cn cY vf cv
        wf cF cP cli wbr cB c2 cdiv co crp wcel w3a vk cv vn cv cle wbr vn cv
        cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt wbr wi vn cn wral vk cn
        wrex vk cv vn cv cle wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        cB c2 cdiv co clt wbr wi vn cn wral vk cn wrex wa vk cv vn cv cle wbr
        vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt wbr c2 cP cmul co
        vn cv cF cfv cP cmin co cmul co cB c2 cdiv co clt wbr wa wi vn cn wral
        vk cn wrex cn cY vf cv wf cF cP cli wbr cB c2 cdiv co crp wcel w3a vk
        cv vn cv cle wbr vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt
        wbr wi vn cn wral vk cn wrex vk cv vn cv cle wbr c2 cP cmul co vn cv cF
        cfv cP cmin co cmul co cB c2 cdiv co clt wbr wi vn cn wral vk cn wrex
        vx vy cA cB c2 cdiv co cP cR cU vf vj vk vn cF cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec22.hf minvec23.2 minveclem24 vx vy cA cB c2
        cdiv co cP cR cU vf vj vk vn cF cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec22.hf minvec23.2 minveclem25 jca vn cv cF cfv cP cmin co c2 cexp
        co cB c2 cdiv co clt wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        cB c2 cdiv co clt wbr vk vn c1 cn 1z nnuz cvganuzi sylib cB crp wcel c2
        crp wcel cB c2 cdiv co crp wcel c2 2re 2pos elrpii cB c2 rpdivcl mpan2
        syl3an3 cn cY vf cv wf cF cP cli wbr cB crp wcel w3a vk cv vn cv cle
        wbr vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt wbr c2 cP cmul
        co vn cv cF cfv cP cmin co cmul co cB c2 cdiv co clt wbr wa wi vn cn
        wral vk cv vn cv cle wbr vn cv cF cfv c2 cexp co cP c2 cexp co cmin co
        cB clt wbr wi vn cn wral vk cn cn cY vf cv wf cF cP cli wbr cB crp wcel
        w3a vk cv vn cv cle wbr vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv
        co clt wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB c2 cdiv co
        clt wbr wa wi vk cv vn cv cle wbr vn cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cB clt wbr wi vn cn cn cY vf cv wf cF cP cli wbr cB crp wcel
        w3a vn cv cn wcel wa vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co
        clt wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB c2 cdiv co clt
        wbr wa vn cv cF cfv c2 cexp co cP c2 cexp co cmin co cB clt wbr vk cv
        vn cv cle wbr cn cY vf cv wf cB crp wcel vn cv cn wcel vn cv cF cfv cP
        cmin co c2 cexp co cB c2 cdiv co clt wbr c2 cP cmul co vn cv cF cfv cP
        cmin co cmul co cB c2 cdiv co clt wbr wa vn cv cF cfv c2 cexp co cP c2
        cexp co cmin co cB clt wbr wi cF cP cli wbr cn cY vf cv wf vn cv cn
        wcel cB crp wcel vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt
        wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB c2 cdiv co clt wbr
        wa vn cv cF cfv c2 cexp co cP c2 cexp co cmin co cB clt wbr wi vn cv cF
        cfv cr wcel cB cr wcel vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co
        clt wbr c2 cP cmul co vn cv cF cfv cP cmin co cmul co cB c2 cdiv co clt
        wbr wa vn cv cF cfv c2 cexp co cP c2 cexp co cmin co cB clt wbr wi cn
        cY vf cv wf vn cv cn wcel wa cB crp wcel vn cv cF cfv cr wcel cB cr
        wcel wa vn cv cF cfv cP cmin co c2 cexp co cB c2 cdiv co clt wbr c2 cP
        cmul co vn cv cF cfv cP cmin co cmul co cB c2 cdiv co clt wbr wa vn cv
        cF cfv cP cmin co c2 cexp co c2 cP cmul co vn cv cF cfv cP cmin co cmul
        co caddc co cB c2 cdiv co cB c2 cdiv co caddc co clt wbr vn cv cF cfv
        c2 cexp co cP c2 cexp co cmin co cB clt wbr vn cv cF cfv cP cmin co c2
        cexp co cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul co cr wcel
        wa cB c2 cdiv co cr wcel cB c2 cdiv co cr wcel wa vn cv cF cfv cP cmin
        co c2 cexp co cB c2 cdiv co clt wbr c2 cP cmul co vn cv cF cfv cP cmin
        co cmul co cB c2 cdiv co clt wbr wa vn cv cF cfv cP cmin co c2 cexp co
        c2 cP cmul co vn cv cF cfv cP cmin co cmul co caddc co cB c2 cdiv co cB
        c2 cdiv co caddc co clt wbr wi vn cv cF cfv cr wcel cB cr wcel vn cv cF
        cfv cP cmin co c2 cexp co c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        cB c2 cdiv co cB c2 cdiv co lt2add vn cv cF cfv cr wcel vn cv cF cfv cP
        cmin co c2 cexp co cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul
        co cr wcel vn cv cF cfv cr wcel vn cv cF cfv cP cmin co cr wcel vn cv
        cF cfv cP cmin co c2 cexp co cr wcel vn cv cF cfv cr wcel cP cr wcel vn
        cv cF cfv cP cmin co cr wcel vx vy cA cP cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem12 vn cv cF cfv cP resubcl
        mpan2 vn cv cF cfv cP cmin co resqcl syl vn cv cF cfv cr wcel vn cv cF
        cfv cP cmin co cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul co cr
        wcel vn cv cF cfv cr wcel cP cr wcel vn cv cF cfv cP cmin co cr wcel vx
        vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 vn cv cF cfv cP resubcl mpan2 c2 cP cmul co cr wcel vn cv
        cF cfv cP cmin co cr wcel c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        cr wcel c2 cP 2re vx vy cA cP cR cU cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec23.2 minveclem12 remulcli c2 cP cmul co vn cv cF cfv
        cP cmin co remulcl mpan syl jca cB cr wcel cB c2 cdiv co cr wcel cB c2
        cdiv co cr wcel cB rehalfcl cB rehalfcl jca syl2an vn cv cF cfv cr wcel
        cB cr wcel vn cv cF cfv c2 cexp co cP c2 cexp co cmin co vn cv cF cfv
        cP cmin co c2 cexp co c2 cP cmul co vn cv cF cfv cP cmin co cmul co
        caddc co cB cB c2 cdiv co cB c2 cdiv co caddc co clt vn cv cF cfv cr
        wcel vn cv cF cfv cc wcel vn cv cF cfv c2 cexp co cP c2 cexp co cmin co
        vn cv cF cfv cP cmin co c2 cexp co c2 cP cmul co vn cv cF cfv cP cmin
        co cmul co caddc co wceq vn cv cF cfv recn vn cv cF cfv cc wcel cP cc
        wcel vn cv cF cfv c2 cexp co cP c2 cexp co cmin co vn cv cF cfv cP cmin
        co c2 cexp co c2 cP cmul co vn cv cF cfv cP cmin co cmul co caddc co
        wceq cP vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec23.2 minveclem12 recni vn cv cF cfv cP subsq2 mpan2 syl cB cr
        wcel cB c2 cdiv co cB c2 cdiv co caddc co cB cB cr wcel cB cc wcel cB
        c2 cdiv co cB c2 cdiv co caddc co cB wceq cB recn cB 2halves syl eqcomd
        breqan12d sylibrd vx vy cA cR cU vf vj vn cF cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec22.hf minveclem22 cB rpre syl2an an1rs 3adantl2 imim2d
        r19.20dva r19.22sdv mpd $.
        $( [7-Apr-2008] $) $( [23-Feb-2008] $)

      $( Lemma for ~ minvecex . $)
      minveclem27 $p |- ( ( ( f : NN --> Y /\ F ~~> P ) /\ B e. RR+ ) ->
         E. k e. NN A. m e. NN ( k <_ m ->
               ( ( N ` ( ( f ` k ) M ( f ` m ) ) ) ^ 2 ) < B ) ) $=
        cn cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk cv vm cv cle wbr vm
        cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt
        wbr wi vm cn wral vk cn wrex vk cv vm cv cle wbr vk cv vf cv cfv vm cv
        vf cv cfv cM co cN cfv c2 cexp co cB clt wbr wi vm cn wral vk cn wrex
        cn cY vf cv wf cF cP cli wbr cB crp wcel vk cv vm cv cle wbr vm cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr
        wi vm cn wral vk cn wrex cn cY vf cv wf cF cP cli wbr cB c2 cdiv co c2
        cdiv co crp wcel vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp
        co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vm cn wral vk cn wrex cB
        crp wcel vx vy cA cB c2 cdiv co c2 cdiv co cP cR cU vf vj vk vm cF cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec22.hf minvec23.2 minveclem26 cB
        crp wcel cB c2 cdiv co crp wcel cB c2 cdiv co c2 cdiv co crp wcel cB
        crp wcel c2 crp wcel cB c2 cdiv co crp wcel c2 2re 2pos elrpii cB c2
        rpdivcl mpan2 cB c2 cdiv co crp wcel c2 crp wcel cB c2 cdiv co c2 cdiv
        co crp wcel c2 2re 2pos elrpii cB c2 cdiv co c2 rpdivcl mpan2 syl
        syl3an3 3expa cn cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk cv vm
        cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co
        c2 cdiv co clt wbr wi vm cn wral vk cv vm cv cle wbr vk cv vf cv cfv vm
        cv vf cv cfv cM co cN cfv c2 cexp co cB clt wbr wi vm cn wral vk cn cn
        cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk cv cn wcel wa vk cv vm
        cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co
        c2 cdiv co clt wbr wi vm cn wral vk cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cB c2 cdiv co c2 cdiv co clt wbr vk cv vm cv cle wbr vm cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr
        wi wa vm cn wral vk cv vm cv cle wbr vk cv vf cv cfv vm cv vf cv cfv cM
        co cN cfv c2 cexp co cB clt wbr wi vm cn wral cn cY vf cv wf cF cP cli
        wbr wa cB crp wcel wa vk cv cn wcel wa vk cv vm cv cle wbr vm cv cF cfv
        c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vm
        cn wral vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2
        cdiv co clt wbr vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp
        co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vm cn wral wa vk cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr
        vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2
        cdiv co c2 cdiv co clt wbr wi wa vm cn wral cn cY vf cv wf cF cP cli
        wbr wa cB crp wcel wa vk cv cn wcel wa vk cv vm cv cle wbr vm cv cF cfv
        c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vm
        cn wral vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2
        cdiv co clt wbr vk cv cn wcel vk cv vm cv cle wbr vm cv cF cfv c2 cexp
        co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vm cn wral
        vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co
        clt wbr wi cn cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk cv cn wcel
        vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2
        cdiv co c2 cdiv co clt wbr wi vm cn wral vk cv vk cv cle wbr vk cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr
        vk cv cn wcel vk cv cr wcel vk cv vk cv cle wbr vk cv nnre vk cv leid
        syl vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co
        cB c2 cdiv co c2 cdiv co clt wbr wi vk cv vk cv cle wbr vk cv cF cfv c2
        cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vm vk
        cv cn vm cv vk cv wceq vk cv vm cv cle wbr vk cv vk cv cle wbr vm cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr
        vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co
        clt wbr vm cv vk cv vk cv cle breq2 vm cv vk cv wceq vm cv cF cfv c2
        cexp co cP c2 cexp co cmin co vk cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cB c2 cdiv co c2 cdiv co clt vm cv vk cv wceq vm cv cF cfv c2
        cexp co vk cv cF cfv c2 cexp co cP c2 cexp co cmin vm cv vk cv wceq vm
        cv cF cfv vk cv cF cfv c2 cexp vm cv vk cv cF fveq2 opreq1d opreq1d
        breq1d imbi12d rcla4v mpid adantl ancrd vk cv cF cfv c2 cexp co cP c2
        cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr vk cv vm cv cle wbr vm
        cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt
        wbr wi vm cn r19.28av syl6 cn cY vf cv wf cB crp wcel vk cv cn wcel vk
        cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt
        wbr vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co
        cB c2 cdiv co c2 cdiv co clt wbr wi wa vm cn wral vk cv vm cv cle wbr
        vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB clt wbr wi
        vm cn wral wi cF cP cli wbr cn cY vf cv wf cB crp wcel wa vk cv cn wcel
        wa vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv
        co clt wbr vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cB c2 cdiv co c2 cdiv co clt wbr wi wa vk cv vm cv cle wbr vk
        cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB clt wbr wi vm
        cn vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv
        co clt wbr vk cv vm cv cle wbr vm cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cB c2 cdiv co c2 cdiv co clt wbr wi wa vk cv vm cv cle wbr vk
        cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt
        wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv
        co clt wbr wa cn cY vf cv wf cB crp wcel wa vk cv cn wcel wa vm cv cn
        wcel wa vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB clt
        wbr vk cv vm cv cle wbr vk cv cF cfv c2 cexp co cP c2 cexp co cmin co
        cB c2 cdiv co c2 cdiv co clt wbr wi vk cv vm cv cle wbr vm cv cF cfv c2
        cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wi vk cv
        vm cv cle wbr vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv
        co c2 cdiv co clt wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB
        c2 cdiv co c2 cdiv co clt wbr wa wi vk cv cF cfv c2 cexp co cP c2 cexp
        co cmin co cB c2 cdiv co c2 cdiv co clt wbr vk cv vm cv cle wbr vk cv
        cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt
        wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv
        co clt wbr pm3.43 vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2
        cdiv co c2 cdiv co clt wbr vk cv vm cv cle wbr ax-1 sylan cn cY vf cv
        wf cB crp wcel wa vk cv cn wcel vm cv cn wcel vk cv cF cfv c2 cexp co
        cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr vm cv cF cfv c2
        cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wa vk cv
        vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB clt wbr wi cn cY
        vf cv wf cB crp wcel wa vk cv cn wcel vm cv cn wcel wa wa vk cv cF cfv
        c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr vm cv
        cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt
        wbr wa c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul
        co c2 cP cmul co c2 cexp co cmin co cB clt wbr vk cv vf cv cfv vm cv vf
        cv cfv cM co cN cfv c2 cexp co cB clt wbr cn cY vf cv wf vk cv cn wcel
        vm cv cn wcel wa cB crp wcel vk cv cF cfv c2 cexp co cP c2 cexp co cmin
        co cB c2 cdiv co c2 cdiv co clt wbr vm cv cF cfv c2 cexp co cP c2 cexp
        co cmin co cB c2 cdiv co c2 cdiv co clt wbr wa c2 vk cv cF cfv c2 cexp
        co vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co
        cmin co cB clt wbr wi vk cv cF cfv cr wcel vm cv cF cfv cr wcel wa cB
        crp wcel vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2 cdiv co c2
        cdiv co clt wbr vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cB c2
        cdiv co c2 cdiv co clt wbr wa c2 vk cv cF cfv c2 cexp co vm cv cF cfv
        c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin co cB clt wbr
        wi cn cY vf cv wf vk cv cn wcel vm cv cn wcel wa wa vk cv cF cfv cr
        wcel vm cv cF cfv cr wcel wa cB crp wcel wa vk cv cF cfv c2 cexp co cP
        c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr vm cv cF cfv c2
        cexp co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wa vk cv
        cF cfv c2 cexp co cP c2 cexp co cmin co vm cv cF cfv c2 cexp co cP c2
        cexp co cmin co caddc co cB c2 cdiv co c2 cdiv co cB c2 cdiv co c2 cdiv
        co caddc co clt wbr c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co cmul co c2 cP cmul co c2 cexp co cmin co cB clt wbr vk cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cr wcel vm cv cF cfv c2 cexp co cP
        c2 cexp co cmin co cr wcel wa cB c2 cdiv co c2 cdiv co cr wcel cB c2
        cdiv co c2 cdiv co cr wcel wa vk cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cB c2 cdiv co c2 cdiv co clt wbr vm cv cF cfv c2 cexp co cP c2
        cexp co cmin co cB c2 cdiv co c2 cdiv co clt wbr wa vk cv cF cfv c2
        cexp co cP c2 cexp co cmin co vm cv cF cfv c2 cexp co cP c2 cexp co
        cmin co caddc co cB c2 cdiv co c2 cdiv co cB c2 cdiv co c2 cdiv co
        caddc co clt wbr wi vk cv cF cfv cr wcel vm cv cF cfv cr wcel wa cB crp
        wcel vk cv cF cfv c2 cexp co cP c2 cexp co cmin co vm cv cF cfv c2 cexp
        co cP c2 cexp co cmin co cB c2 cdiv co c2 cdiv co cB c2 cdiv co c2 cdiv
        co lt2add vk cv cF cfv cr wcel vk cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cr wcel vm cv cF cfv cr wcel vm cv cF cfv c2 cexp co cP c2 cexp
        co cmin co cr wcel vk cv cF cfv cr wcel vk cv cF cfv c2 cexp co cr wcel
        vk cv cF cfv c2 cexp co cP c2 cexp co cmin co cr wcel vk cv cF cfv
        resqcl vk cv cF cfv c2 cexp co cr wcel cP c2 cexp co cr wcel vk cv cF
        cfv c2 cexp co cP c2 cexp co cmin co cr wcel cP vx vy cA cP cR cU cM cN
        cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 resqcli vk cv
        cF cfv c2 cexp co cP c2 cexp co resubcl mpan2 syl vm cv cF cfv cr wcel
        vm cv cF cfv c2 cexp co cr wcel vm cv cF cfv c2 cexp co cP c2 cexp co
        cmin co cr wcel vm cv cF cfv resqcl vm cv cF cfv c2 cexp co cr wcel cP
        c2 cexp co cr wcel vm cv cF cfv c2 cexp co cP c2 cexp co cmin co cr
        wcel cP vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec23.2 minveclem12 resqcli vm cv cF cfv c2 cexp co cP c2 cexp co
        resubcl mpan2 syl anim12i cB crp wcel cB cr wcel cB c2 cdiv co c2 cdiv
        co cr wcel cB c2 cdiv co c2 cdiv co cr wcel wa cB rpre cB cr wcel cB c2
        cdiv co cr wcel cB c2 cdiv co c2 cdiv co cr wcel cB c2 cdiv co c2 cdiv
        co cr wcel wa cB rehalfcl cB c2 cdiv co cr wcel cB c2 cdiv co c2 cdiv
        co cr wcel cB c2 cdiv co c2 cdiv co cr wcel cB c2 cdiv co rehalfcl cB
        c2 cdiv co rehalfcl jca syl syl syl2an vk cv cF cfv cr wcel vm cv cF
        cfv cr wcel wa cB crp wcel wa vk cv cF cfv c2 cexp co cP c2 cexp co
        cmin co vm cv cF cfv c2 cexp co cP c2 cexp co cmin co caddc co cB c2
        cdiv co c2 cdiv co cB c2 cdiv co c2 cdiv co caddc co clt wbr vk cv cF
        cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co cmul
        co cmin co cB c2 cdiv co clt wbr c2 vk cv cF cfv c2 cexp co vm cv cF
        cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co cmin co cmul co c2 cB
        c2 cdiv co cmul co clt wbr c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin co cB clt wbr vk
        cv cF cfv cr wcel vm cv cF cfv cr wcel wa cB crp wcel vk cv cF cfv c2
        cexp co cP c2 cexp co cmin co vm cv cF cfv c2 cexp co cP c2 cexp co
        cmin co caddc co vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc
        co c2 cP c2 cexp co cmul co cmin co cB c2 cdiv co c2 cdiv co cB c2 cdiv
        co c2 cdiv co caddc co cB c2 cdiv co clt vk cv cF cfv cr wcel vm cv cF
        cfv cr wcel wa vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co
        cP c2 cexp co cP c2 cexp co caddc co cmin co vk cv cF cfv c2 cexp co cP
        c2 cexp co cmin co vm cv cF cfv c2 cexp co cP c2 cexp co cmin co caddc
        co vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP c2
        cexp co cmul co cmin co vk cv cF cfv c2 cexp co cc wcel vm cv cF cfv c2
        cexp co cc wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc
        co cP c2 cexp co cP c2 cexp co caddc co cmin co vk cv cF cfv c2 cexp co
        cP c2 cexp co cmin co vm cv cF cfv c2 cexp co cP c2 cexp co cmin co
        caddc co wceq vk cv cF cfv cr wcel vm cv cF cfv cr wcel vk cv cF cfv c2
        cexp co cc wcel vm cv cF cfv c2 cexp co cc wcel wa cP c2 cexp co cc
        wcel cP c2 cexp co cc wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co cP c2 cexp co cP c2 cexp co caddc co cmin co vk cv cF cfv
        c2 cexp co cP c2 cexp co cmin co vm cv cF cfv c2 cexp co cP c2 cexp co
        cmin co caddc co wceq cP c2 cexp co cP vx vy cA cP cR cU cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem12 resqcli recni cP c2 cexp
        co cP vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 resqcli recni vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co cP c2 cexp co cP c2 cexp co addsub4 mpanr12 vk cv cF cfv cr wcel vk
        cv cF cfv c2 cexp co vk cv cF cfv resqcl recnd vm cv cF cfv cr wcel vm
        cv cF cfv c2 cexp co vm cv cF cfv resqcl recnd syl2an c2 cP c2 cexp co
        cmul co cP c2 cexp co cP c2 cexp co caddc co vk cv cF cfv c2 cexp co vm
        cv cF cfv c2 cexp co caddc co cmin cP c2 cexp co cP c2 cexp co cP vx vy
        cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12
        resqcli recni 2timesi opreq2i syl5req cB crp wcel cB c2 cdiv co cc wcel
        cB c2 cdiv co c2 cdiv co cB c2 cdiv co c2 cdiv co caddc co cB c2 cdiv
        co wceq cB crp wcel cB cc wcel cB c2 cdiv co cc wcel cB rpcn cB halfcl
        syl cB c2 cdiv co 2halves syl breqan12d vk cv cF cfv c2 cexp co vm cv
        cF cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co cmin co cr wcel cB
        c2 cdiv co cr wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co c2 cP c2 cexp co cmul co cmin co cB c2 cdiv co clt wbr c2 vk
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co
        cmul co cmin co cmul co c2 cB c2 cdiv co cmul co clt wbr wb vk cv cF
        cfv cr wcel vm cv cF cfv cr wcel wa cB crp wcel vk cv cF cfv c2 cexp co
        vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co cmin co cr
        wcel cB c2 cdiv co cr wcel c2 cr wcel vk cv cF cfv c2 cexp co vm cv cF
        cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co cmin co cB c2 cdiv co
        clt wbr c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2
        cP c2 cexp co cmul co cmin co cmul co c2 cB c2 cdiv co cmul co clt wbr
        wb 2re vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP
        c2 cexp co cmul co cmin co cr wcel cB c2 cdiv co cr wcel c2 cr wcel w3a
        cc0 c2 clt wbr vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co
        c2 cP c2 cexp co cmul co cmin co cB c2 cdiv co clt wbr c2 vk cv cF cfv
        c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co
        cmin co cmul co c2 cB c2 cdiv co cmul co clt wbr wb 2pos vk cv cF cfv
        c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co
        cmin co cB c2 cdiv co c2 ltmul2OLD mpan2 mp3an3 vk cv cF cfv cr wcel vm
        cv cF cfv cr wcel wa vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co cr wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc
        co c2 cP c2 cexp co cmul co cmin co cr wcel vk cv cF cfv c2 cexp co cr
        wcel vm cv cF cfv c2 cexp co cr wcel vk cv cF cfv c2 cexp co vm cv cF
        cfv c2 cexp co caddc co cr wcel vk cv cF cfv cr wcel vm cv cF cfv cr
        wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co readdcl vk cv cF
        cfv resqcl vm cv cF cfv resqcl syl2an vk cv cF cfv c2 cexp co vm cv cF
        cfv c2 cexp co caddc co cr wcel c2 cP c2 cexp co cmul co cr wcel vk cv
        cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co
        cmul co cmin co cr wcel c2 cP c2 cexp co 2re cP vx vy cA cP cR cU cM cN
        cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec23.2 minveclem12 resqcli
        remulcli vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co c2 cP
        c2 cexp co cmul co resubcl mpan2 syl cB crp wcel cB cr wcel cB c2 cdiv
        co cr wcel cB rpre cB rehalfcl syl syl2an vk cv cF cfv cr wcel vm cv cF
        cfv cr wcel wa cB crp wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co c2 cP c2 cexp co cmul co cmin co cmul co c2 vk cv cF
        cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co
        c2 cexp co cmin co c2 cB c2 cdiv co cmul co cB clt vk cv cF cfv cr wcel
        vm cv cF cfv cr wcel wa c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co c2 cP c2 cexp co cmul co cmin co cmul co c2 vk cv cF cfv c2
        cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 c2 cP c2 cexp co
        cmul co cmul co cmin co c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co cmul co c2 cP cmul co c2 cexp co cmin co vk cv cF cfv cr
        wcel vm cv cF cfv cr wcel wa vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co cc wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co c2 cP c2 cexp co cmul co cmin co cmul co c2 vk cv cF
        cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 c2 cP c2
        cexp co cmul co cmul co cmin co wceq vk cv cF cfv c2 cexp co cc wcel vm
        cv cF cfv c2 cexp co cc wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co cc wcel vk cv cF cfv cr wcel vm cv cF cfv cr wcel vk
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co addcl vk cv cF cfv cr wcel
        vk cv cF cfv c2 cexp co vk cv cF cfv resqcl recnd vm cv cF cfv cr wcel
        vm cv cF cfv c2 cexp co vm cv cF cfv resqcl recnd syl2an c2 cc wcel vk
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cc wcel c2 cP c2
        cexp co cmul co cc wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co c2 cP c2 cexp co cmul co cmin co cmul co c2 vk cv cF cfv c2
        cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 c2 cP c2 cexp co
        cmul co cmul co cmin co wceq 2cn c2 cP c2 cexp co cmul co c2 cP c2 cexp
        co 2re cP vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec23.2 minveclem12 resqcli remulcli recni c2 vk cv cF cfv c2 cexp
        co vm cv cF cfv c2 cexp co caddc co c2 cP c2 cexp co cmul co subdi
        mp3an13 syl c2 c2 cP c2 cexp co cmul co cmul co c2 cP cmul co c2 cexp
        co c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co
        cmin c2 cP cmul co c2 cexp co c2 c2 cexp co cP c2 cexp co cmul co c2 c2
        cmul co cP c2 cexp co cmul co c2 c2 cP c2 cexp co cmul co cmul co c2 cP
        2cn cP vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec23.2 minveclem12 recni sqmuli c2 c2 cexp co c2 c2 cmul co cP c2
        cexp co cmul c2 c2 cexp co c4 c2 c2 cmul co sq2 2t2e4 eqtr4i opreq1i c2
        c2 cP c2 cexp co 2cn 2cn cP c2 cexp co cP vx vy cA cP cR cU cM cN cW cX
        cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec23.2 minveclem12 resqcli recni mulassi
        3eqtrri opreq2i syl6eq cB crp wcel cB cc wcel c2 cB c2 cdiv co cmul co
        cB wceq cB rpcn cB cc wcel c2 cc wcel c2 cc0 wne c2 cB c2 cdiv co cmul
        co cB wceq 2cn 2ne0 cB c2 divcan2 mp3an23 syl breqan12d 3bitrd sylibd
        cn cY vf cv wf vk cv cn wcel vm cv cn wcel vk cv cF cfv cr wcel vm cv
        cF cfv cr wcel wa cn cY vf cv wf vk cv cn wcel wa vk cv cF cfv cr wcel
        cn cY vf cv wf vm cv cn wcel wa vm cv cF cfv cr wcel vx vy cA cR cU vf
        vj vk cF cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec22.hf minveclem22 vx
        vy cA cR cU vf vj vm cF cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec22.hf
        minveclem22 anim12i anandis sylan an1rs cn cY vf cv wf cB crp wcel wa
        vk cv cn wcel vm cv cn wcel wa wa vk cv vf cv cfv vm cv vf cv cfv cM co
        cN cfv c2 cexp co c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co cmul co c2 cP cmul co c2 cexp co cmin co cle wbr c2 vk cv cF
        cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co
        c2 cexp co cmin co cB clt wbr vk cv vf cv cfv vm cv vf cv cfv cM co cN
        cfv c2 cexp co cB clt wbr cn cY vf cv wf vk cv cn wcel vm cv cn wcel wa
        vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co c2 vk cv cF cfv
        c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co c2
        cexp co cmin co cle wbr cB crp wcel cn cY vf cv wf vk cv cn wcel vm cv
        cn wcel vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co c2 vk
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co c2 cP
        cmul co c2 cexp co cmin co cle wbr vx vy cA cP cR cU vf vj vm vk cF cM
        cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec22.hf minvec23.2 minveclem23
        anandis adantlr vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co
        cr wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co
        cmul co c2 cP cmul co c2 cexp co cmin co cr wcel cB cr wcel vk cv vf cv
        cfv vm cv vf cv cfv cM co cN cfv c2 cexp co c2 vk cv cF cfv c2 cexp co
        vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin
        co cle wbr c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co
        cmul co c2 cP cmul co c2 cexp co cmin co cB clt wbr wa vk cv vf cv cfv
        vm cv vf cv cfv cM co cN cfv c2 cexp co cB clt wbr wi cn cY vf cv wf cB
        crp wcel wa vk cv cn wcel vm cv cn wcel wa wa vk cv vf cv cfv vm cv vf
        cv cfv cM co cN cfv c2 cexp co c2 vk cv cF cfv c2 cexp co vm cv cF cfv
        c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin co cB lelttr
        cn cY vf cv wf vk cv cn wcel vm cv cn wcel wa vk cv vf cv cfv vm cv vf
        cv cfv cM co cN cfv c2 cexp co cr wcel cB crp wcel cn cY vf cv wf vk cv
        cn wcel vm cv cn wcel wa wa vk cv vf cv cfv vm cv vf cv cfv cM co cN
        cfv cr wcel vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cr
        wcel cn cY vf cv wf vk cv cn wcel vm cv cn wcel wa wa vk cv vf cv cfv
        vm cv vf cv cfv cM co cX wcel vk cv vf cv cfv vm cv vf cv cfv cM co cN
        cfv cr wcel cn cY vf cv wf vk cv cn wcel vm cv cn wcel vk cv vf cv cfv
        vm cv vf cv cfv cM co cX wcel vk cv vf cv cfv cX wcel vm cv vf cv cfv
        cX wcel vk cv vf cv cfv vm cv vf cv cfv cM co cX wcel cn cY vf cv wf vk
        cv cn wcel wa cn cY vf cv wf vm cv cn wcel wa cU cnv wcel vk cv vf cv
        cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv cfv cM
        co cX wcel cU minvec10.u phnvi vk cv vf cv cfv vm cv vf cv cfv cU cM cX
        minvec10.x minvec10.m nvmcl mp3an1 cU vf vk cW cX cY minvec10.u
        minvec10.w1 minvec10.y minvec10.x minveclem4 cU vf vm cW cX cY
        minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem4 syl2an anandis
        cU cnv wcel vk cv vf cv cfv vm cv vf cv cfv cM co cX wcel vk cv vf cv
        cfv vm cv vf cv cfv cM co cN cfv cr wcel cU minvec10.u phnvi vk cv vf
        cv cfv vm cv vf cv cfv cM co cU cN cX minvec10.x minvec10.n nvcl mpan
        syl vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv resqcl syl adantlr cn
        cY vf cv wf vk cv cn wcel vm cv cn wcel wa c2 vk cv cF cfv c2 cexp co
        vm cv cF cfv c2 cexp co caddc co cmul co c2 cP cmul co c2 cexp co cmin
        co cr wcel cB crp wcel cn cY vf cv wf vk cv cn wcel vm cv cn wcel wa wa
        c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul co cr
        wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul
        co c2 cP cmul co c2 cexp co cmin co cr wcel cn cY vf cv wf vk cv cn
        wcel vm cv cn wcel wa wa vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co cr wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co cmul co cr wcel cn cY vf cv wf vk cv cn wcel vm cv cn wcel vk
        cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cr wcel vk cv cF
        cfv c2 cexp co cr wcel vm cv cF cfv c2 cexp co cr wcel vk cv cF cfv c2
        cexp co vm cv cF cfv c2 cexp co caddc co cr wcel cn cY vf cv wf vk cv
        cn wcel wa cn cY vf cv wf vm cv cn wcel wa vk cv cF cfv c2 cexp co vm
        cv cF cfv c2 cexp co readdcl cn cY vf cv wf vk cv cn wcel wa vk cv cF
        cfv cr wcel vk cv cF cfv c2 cexp co cr wcel vx vy cA cR cU vf vj vk cF
        cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec22.hf minveclem22 vk cv cF cfv
        resqcl syl cn cY vf cv wf vm cv cn wcel wa vm cv cF cfv cr wcel vm cv
        cF cfv c2 cexp co cr wcel vx vy cA cR cU vf vj vm cF cM cN cW cX cY
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec22.hf minveclem22 vm cv cF cfv resqcl syl
        syl2an anandis c2 cr wcel vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp
        co caddc co cr wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co
        caddc co cmul co cr wcel 2re c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co remulcl mpan syl c2 vk cv cF cfv c2 cexp co vm cv cF
        cfv c2 cexp co caddc co cmul co cr wcel c2 cP cmul co c2 cexp co cr
        wcel c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2 cexp co caddc co cmul
        co c2 cP cmul co c2 cexp co cmin co cr wcel c2 cP cmul co c2 cP 2re vx
        vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec23.2
        minveclem12 remulcli resqcli c2 vk cv cF cfv c2 cexp co vm cv cF cfv c2
        cexp co caddc co cmul co c2 cP cmul co c2 cexp co resubcl mpan2 syl
        adantlr cB crp wcel cB cr wcel cn cY vf cv wf vk cv cn wcel vm cv cn
        wcel wa cB rpre ad2antlr syl3anc mpand syld anassrs syl9r r19.20dva
        adantllr syld r19.22dva mpd $.
        $( [7-Apr-2008] $) $( [23-Feb-2008] $)

      minvec28.d $e |- D = ( IndMet ` W ) $.
      $( Lemma for ~ minvecex . $)
      minveclem28 $p |- ( ( ( f : NN --> Y /\ F ~~> P ) /\ B e. RR+ ) ->
         E. k e. NN A. m e. NN ( k <_ m -> ( ( f ` k ) D ( f ` m ) ) < B ) ) $=
        cn cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk cv vm cv cle wbr vk
        cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB c2 cexp co clt
        wbr wi vm cn wral vk cn wrex vk cv vm cv cle wbr vk cv vf cv cfv vm cv
        vf cv cfv cD co cB clt wbr wi vm cn wral vk cn wrex cn cY vf cv wf cF
        cP cli wbr wa cB c2 cexp co crp wcel vk cv vm cv cle wbr vk cv vf cv
        cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB c2 cexp co clt wbr wi vm
        cn wral vk cn wrex cB crp wcel vx vy cA cB c2 cexp co cP cR cU vf vj vk
        vm cF cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec22.hf minvec23.2
        minveclem27 cB crp wcel c2 cn0 wcel cB c2 cexp co crp wcel 2nn0 cB c2
        rpexpcl mpan2 sylan2 cn cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk
        cv vm cv cle wbr vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp
        co cB c2 cexp co clt wbr wi vm cn wral vk cv vm cv cle wbr vk cv vf cv
        cfv vm cv vf cv cfv cD co cB clt wbr wi vm cn wral vk cn cn cY vf cv wf
        cF cP cli wbr wa cB crp wcel wa vk cv cn wcel wa vk cv vm cv cle wbr vk
        cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB c2 cexp co clt
        wbr wi vk cv vm cv cle wbr vk cv vf cv cfv vm cv vf cv cfv cD co cB clt
        wbr wi vm cn cn cY vf cv wf cF cP cli wbr wa cB crp wcel wa vk cv cn
        wcel wa vm cv cn wcel wa vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv
        c2 cexp co cB c2 cexp co clt wbr vk cv vf cv cfv vm cv vf cv cfv cD co
        cB clt wbr vk cv vm cv cle wbr cn cY vf cv wf cF cP cli wbr wa cB crp
        wcel wa vk cv cn wcel vm cv cn wcel vk cv vf cv cfv vm cv vf cv cfv cM
        co cN cfv c2 cexp co cB c2 cexp co clt wbr vk cv vf cv cfv vm cv vf cv
        cfv cD co cB clt wbr wb cn cY vf cv wf cB crp wcel vk cv cn wcel vm cv
        cn wcel wa vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB
        c2 cexp co clt wbr vk cv vf cv cfv vm cv vf cv cfv cD co cB clt wbr wb
        cF cP cli wbr cn cY vf cv wf vk cv cn wcel vm cv cn wcel wa cB crp wcel
        vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB c2 cexp co
        clt wbr vk cv vf cv cfv vm cv vf cv cfv cD co cB clt wbr wb vk cv vf cv
        cfv cY wcel vm cv vf cv cfv cY wcel wa cB crp wcel vk cv vf cv cfv vm
        cv vf cv cfv cM co cN cfv c2 cexp co cB c2 cexp co clt wbr vk cv vf cv
        cfv vm cv vf cv cfv cD co cB clt wbr wb cn cY vf cv wf vk cv cn wcel vm
        cv cn wcel wa wa vk cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa cB
        crp wcel wa vk cv vf cv cfv vm cv vf cv cfv cD co cB clt wbr vk cv vf
        cv cfv vm cv vf cv cfv cM co cN cfv cB clt wbr vk cv vf cv cfv vm cv vf
        cv cfv cM co cN cfv c2 cexp co cB c2 cexp co clt wbr vk cv vf cv cfv cY
        wcel vm cv vf cv cfv cY wcel wa cB crp wcel wa vk cv vf cv cfv vm cv vf
        cv cfv cD co vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cB clt vk cv
        vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa vk cv vf cv cfv vm cv vf
        cv cfv cD co vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv wceq cB crp
        wcel vk cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa vk cv vf cv cfv
        vm cv vf cv cfv cD co vk cv vf cv cfv vm cv vf cv cfv cW cnsb cfv co cW
        cnm cfv cfv vk cv vf cv cfv vm cv vf cv cfv cW cnsb cfv co cN cfv vk cv
        vf cv cfv vm cv vf cv cfv cM co cN cfv cW cnv wcel vk cv vf cv cfv cY
        wcel vm cv vf cv cfv cY wcel vk cv vf cv cfv vm cv vf cv cfv cD co vk
        cv vf cv cfv vm cv vf cv cfv cW cnsb cfv co cW cnm cfv cfv wceq cU cnv
        wcel cW cU css cfv wcel cW cnv wcel cU minvec10.u phnvi minvec10.w1 cU
        cU css cfv cW cU css cfv eqid sspnv mp2an vk cv vf cv cfv vm cv vf cv
        cfv cD cW cW cnsb cfv cW cnm cfv cY minvec10.y cW cnsb cfv eqid cW cnm
        cfv eqid minvec28.d imsdval mp3an1 vk cv vf cv cfv cY wcel vm cv vf cv
        cfv cY wcel wa vk cv vf cv cfv vm cv vf cv cfv cW cnsb cfv co cY wcel
        vk cv vf cv cfv vm cv vf cv cfv cW cnsb cfv co cW cnm cfv cfv vk cv vf
        cv cfv vm cv vf cv cfv cW cnsb cfv co cN cfv wceq cW cnv wcel vk cv vf
        cv cfv cY wcel vm cv vf cv cfv cY wcel vk cv vf cv cfv vm cv vf cv cfv
        cW cnsb cfv co cY wcel cU cnv wcel cW cU css cfv wcel cW cnv wcel cU
        minvec10.u phnvi minvec10.w1 cU cU css cfv cW cU css cfv eqid sspnv
        mp2an vk cv vf cv cfv vm cv vf cv cfv cW cW cnsb cfv cY minvec10.y cW
        cnsb cfv eqid nvmcl mp3an1 cU cnv wcel cW cU css cfv wcel vk cv vf cv
        cfv vm cv vf cv cfv cW cnsb cfv co cY wcel vk cv vf cv cfv vm cv vf cv
        cfv cW cnsb cfv co cW cnm cfv cfv vk cv vf cv cfv vm cv vf cv cfv cW
        cnsb cfv co cN cfv wceq cU minvec10.u phnvi minvec10.w1 vk cv vf cv cfv
        vm cv vf cv cfv cW cnsb cfv co cU cU css cfv cW cnm cfv cN cW cY
        minvec10.y minvec10.n cW cnm cfv eqid cU css cfv eqid sspnval mp3an12
        syl vk cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa vk cv vf cv cfv
        vm cv vf cv cfv cW cnsb cfv co vk cv vf cv cfv vm cv vf cv cfv cM co cN
        cU cnv wcel cW cU css cfv wcel vk cv vf cv cfv cY wcel vm cv vf cv cfv
        cY wcel wa vk cv vf cv cfv vm cv vf cv cfv cW cnsb cfv co vk cv vf cv
        cfv vm cv vf cv cfv cM co wceq cU minvec10.u phnvi minvec10.w1 vk cv vf
        cv cfv vm cv vf cv cfv cU cU css cfv cW cnsb cfv cM cW cY minvec10.y
        minvec10.m cW cnsb cfv eqid cU css cfv eqid sspmval mpanl12 fveq2d
        3eqtrd adantr breq1d vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cr
        wcel cc0 vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cle wbr wa cB cr
        wcel cc0 cB cle wbr wa vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cB
        clt wbr vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv c2 cexp co cB c2
        cexp co clt wbr wb vk cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa
        cB crp wcel vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cB lt2sq vk cv
        vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv vf cv
        cfv cM co cN cfv cr wcel cc0 vk cv vf cv cfv vm cv vf cv cfv cM co cN
        cfv cle wbr wa vk cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel vk cv vf
        cv cfv cX wcel vm cv vf cv cfv cX wcel wa vk cv vf cv cfv vm cv vf cv
        cfv cM co cX wcel vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cr wcel
        cc0 vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cle wbr wa cU cnv wcel
        vk cv vf cv cfv cX wcel vm cv vf cv cfv cX wcel vk cv vf cv cfv vm cv
        vf cv cfv cM co cX wcel cU minvec10.u phnvi vk cv vf cv cfv vm cv vf cv
        cfv cU cM cX minvec10.x minvec10.m nvmcl mp3an1 vk cv vf cv cfv vm cv
        vf cv cfv cM co cX wcel vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cr
        wcel cc0 vk cv vf cv cfv vm cv vf cv cfv cM co cN cfv cle wbr cU cnv
        wcel vk cv vf cv cfv vm cv vf cv cfv cM co cX wcel vk cv vf cv cfv vm
        cv vf cv cfv cM co cN cfv cr wcel cU minvec10.u phnvi vk cv vf cv cfv
        vm cv vf cv cfv cM co cU cN cX minvec10.x minvec10.n nvcl mpan cU cnv
        wcel vk cv vf cv cfv vm cv vf cv cfv cM co cX wcel cc0 vk cv vf cv cfv
        vm cv vf cv cfv cM co cN cfv cle wbr cU minvec10.u phnvi vk cv vf cv
        cfv vm cv vf cv cfv cM co cU cN cX minvec10.x minvec10.n nvge0 mpan jca
        syl cY cX vk cv vf cv cfv cU cnv wcel cW cU css cfv wcel cY cX wss cU
        minvec10.u phnvi minvec10.w1 cU cU css cfv cW cX cY minvec10.x
        minvec10.y cU css cfv eqid sspba mp2an sseli cY cX vm cv vf cv cfv cU
        cnv wcel cW cU css cfv wcel cY cX wss cU minvec10.u phnvi minvec10.w1
        cU cU css cfv cW cX cY minvec10.x minvec10.y cU css cfv eqid sspba
        mp2an sseli syl2an cB crp wcel cB cr wcel cc0 cB cle wbr cB rpre cB
        rpge0 jca syl2an bitr2d cn cY vf cv wf vk cv cn wcel vm cv cn wcel vk
        cv vf cv cfv cY wcel vm cv vf cv cfv cY wcel wa cn cY vf cv wf vk cv cn
        wcel wa vk cv vf cv cfv cY wcel cn cY vf cv wf vm cv cn wcel wa vm cv
        vf cv cfv cY wcel cn cY vk cv vf cv ffvelrn cn cY vm cv vf cv ffvelrn
        anim12i anandis sylan an1rs adantllr anassrs imbi2d ralbidva rexbidva
        mpbid $.
        $( [7-Apr-2008] $) $( [23-Feb-2008] $)

      minvec29.w2 $e |- W e. CBan $.
      $( Lemma for ~ minvecex .  Sequence ` f ` is Cauchy, and since vector
         subspace ` W ` is complete, ` f ` therefore converges to a vector in
         ` W ` . $)
      minveclem29 $p |- ( ( f : NN --> Y /\ F ~~> P ) ->
                E. a e. Y f ( ~~>m ` D ) a ) $=
        cn cY vf cv wf cF cP cli wbr wa vf cv cD cca cfv wcel vf cv va cv cD
        clm cfv wbr va cY wrex cn cY vf cv wf cF cP cli wbr wa vf cv cD cca cfv
        wcel vk cv vm cv cle wbr vk cv vf cv cfv vm cv vf cv cfv cD co va cv
        clt wbr wi vm cn wral vk cn wrex va crp wral cn cY vf cv wf cF cP cli
        wbr wa vk cv vm cv cle wbr vk cv vf cv cfv vm cv vf cv cfv cD co va cv
        clt wbr wi vm cn wral vk cn wrex va crp vx vy cA va cv cD cP cR cU vf
        vj vk vm cF cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec22.hf minvec23.2
        minvec28.d minveclem28 r19.21aiva cn cY vf cv wf vf cv cD cca cfv wcel
        vk cv vm cv cle wbr vk cv vf cv cfv vm cv vf cv cfv cD co va cv clt wbr
        wi vm cn wral vk cn wrex va crp wral wb cF cP cli wbr cD cme wcel cn cY
        vf cv wf vf cv cD cca cfv wcel vk cv vm cv cle wbr vk cv vf cv cfv vm
        cv vf cv cfv cD co va cv clt wbr wi vm cn wral vk cn wrex va crp wral
        wb cW cnv wcel cD cme wcel cU cnv wcel cW cU css cfv wcel cW cnv wcel
        cU minvec10.u phnvi minvec10.w1 cU cU css cfv cW cU css cfv eqid sspnv
        mp2an cD cW minvec28.d imsmet ax-mp va cD vk vm vf cv cY cD cW cY
        minvec10.y minvec28.d cU cnv wcel cW cU css cfv wcel cW cnv wcel cU
        minvec10.u phnvi minvec10.w1 cU cU css cfv cW cU css cfv eqid sspnv
        mp2an imsbai iscau5 mpan adantr mpbird cD cms wcel vf cv cD cca cfv
        wcel vf cv va cv cD clm cfv wbr va cY wrex cW cbn wcel cD cms wcel
        minvec29.w2 cD cW minvec28.d bncms ax-mp va cD vf cv cY cD cW cY
        minvec10.y minvec28.d cW cbn wcel cW cnv wcel minvec29.w2 cW bnnv ax-mp
        imsbai cmscvg mpan syl $.
        $( [7-Apr-2008] $) $( [24-Feb-2008] $)
    $}

    ${
      $d m A $.  $d u D $.  $d k m u J $.  $d k m u M $.  $d k m u N $.
      $d m T $.  $d u Y $.  $d f u $.
      minvec30.2 $e |- P = -u sup ( R , RR , < ) $.
      minvec30.hf $e |- ( j e. NN -> ( F ` j ) = ( N ` ( A M ( f ` j ) ) ) ) $.
      minvec30.d $e |- D = ( IndMet ` W ) $.
      minvec30.jv $e |- J e. _V $.
      minvec30.j $e |- ( m e. NN -> ( J ` m ) = ( N ` ( ( f ` m ) M a ) ) ) $.
      minvec30.fv $e |- F e. _V $.
      minvec30.tv $e |- T e. _V $.
      minvec30.t $e |- ( m e. NN -> ( T ` m ) =
                         ( ( F ` m ) + ( N ` ( ( f ` m ) M a ) ) ) ) $.
      $( Lemma for ~ minvecex . $)
      minveclem30 $p |- ( ( ( f : NN --> Y /\ f ( ~~>m ` D ) a ) /\
          ( F ~~> P /\ a e. Y ) ) -> T ~~> P ) $=
        cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY
        wcel wa wa cT cP cc0 caddc co cP cli cF cP cli wbr cJ cc0 cli wbr wa vm
        cv cF cfv cc wcel vm cv cJ cfv cc wcel vm cv cT cfv vm cv cF cfv vm cv
        cJ cfv caddc co wceq w3a vm cn wral cT cP cc0 caddc co cli wbr cn cY vf
        cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa
        cF cP cli wbr cJ cc0 cli wbr wa vm cv cF cfv cc wcel vm cv cJ cfv cc
        wcel vm cv cT cfv vm cv cF cfv vm cv cJ cfv caddc co wceq w3a vm c1 cuz
        cfv wral cT cP cc0 caddc co cli wbr vm cv cF cfv cc wcel vm cv cJ cfv
        cc wcel vm cv cT cfv vm cv cF cfv vm cv cJ cfv caddc co wceq w3a vm cn
        wral cF cP cli wbr cJ cc0 cli wbr wa c1 cz wcel vm cv cF cfv cc wcel vm
        cv cJ cfv cc wcel vm cv cT cfv vm cv cF cfv vm cv cJ cfv caddc co wceq
        w3a vm c1 cuz cfv wral cT cP cc0 caddc co cli wbr 1z cP cc0 vm cF cJ cT
        c1 minvec30.fv minvec30.jv minvec30.tv cP cr vx vy cA cP cR cU cM cN cW
        cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec30.2 minveclem12 elisseti cc0
        cc 0cn elisseti climadd mpanr1 cn c1 cuz cfv wceq vm cv cF cfv cc wcel
        vm cv cJ cfv cc wcel vm cv cT cfv vm cv cF cfv vm cv cJ cfv caddc co
        wceq w3a vm cn wral vm cv cF cfv cc wcel vm cv cJ cfv cc wcel vm cv cT
        cfv vm cv cF cfv vm cv cJ cfv caddc co wceq w3a vm c1 cuz cfv wral wb
        nnuz vm cv cF cfv cc wcel vm cv cJ cfv cc wcel vm cv cT cfv vm cv cF
        cfv vm cv cJ cfv caddc co wceq w3a vm cn c1 cuz cfv raleq1 ax-mp
        sylan2b cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va
        cv cY wcel wa wa cF cP cli wbr cJ cc0 cli wbr cn cY vf cv wf vf cv va
        cv cD clm cfv wbr wa cF cP cli wbr va cv cY wcel simprl cn cY vf cv wf
        vf cv va cv cD clm cfv wbr wa va cv cY wcel cJ cc0 cli wbr cF cP cli
        wbr cD cU vf vm cJ cM cN cW cX cY va minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec30.d minvec30.jv minvec30.j
        minveclem9 adantrl jca cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF
        cP cli wbr va cv cY wcel wa wa vm cv cF cfv cc wcel vm cv cJ cfv cc
        wcel vm cv cT cfv vm cv cF cfv vm cv cJ cfv caddc co wceq w3a vm cn cn
        cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY wcel
        wa wa vm cv cn wcel wa vm cv cF cfv cc wcel vm cv cJ cfv cc wcel vm cv
        cT cfv vm cv cF cfv vm cv cJ cfv caddc co wceq cn cY vf cv wf vf cv va
        cv cD clm cfv wbr wa vm cv cn wcel vm cv cF cfv cc wcel cF cP cli wbr
        va cv cY wcel wa cn cY vf cv wf vm cv cn wcel vm cv cF cfv cc wcel vf
        cv va cv cD clm cfv wbr cn cY vf cv wf vm cv cn wcel wa vm cv cF cfv vx
        vy cA cR cU vf vj vm cF cM cN cW cX cY minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec30.hf
        minveclem22 recnd adantlr adantlr cn cY vf cv wf vf cv va cv cD clm cfv
        wbr wa va cv cY wcel vm cv cn wcel vm cv cJ cfv cc wcel cF cP cli wbr
        cn cY vf cv wf va cv cY wcel vm cv cn wcel vm cv cJ cfv cc wcel vf cv
        va cv cD clm cfv wbr cn cY vf cv wf va cv cY wcel wa vm cv cn wcel wa
        vm cv cJ cfv cn cY vf cv wf va cv cY wcel wa vm cv cn wcel wa vm cv cJ
        cfv vm cv vf cv cfv va cv cM co cN cfv cr vm cv cn wcel vm cv cJ cfv vm
        cv vf cv cfv va cv cM co cN cfv wceq cn cY vf cv wf va cv cY wcel wa
        minvec30.j adantl cn cY vf cv wf vm cv cn wcel va cv cY wcel vm cv vf
        cv cfv va cv cM co cN cfv cr wcel vm cv vf cv cfv cX wcel va cv cX wcel
        vm cv vf cv cfv va cv cM co cN cfv cr wcel cn cY vf cv wf vm cv cn wcel
        wa va cv cY wcel vm cv vf cv cfv cX wcel va cv cX wcel wa vm cv vf cv
        cfv va cv cM co cX wcel vm cv vf cv cfv va cv cM co cN cfv cr wcel cU
        cnv wcel vm cv vf cv cfv cX wcel va cv cX wcel vm cv vf cv cfv va cv cM
        co cX wcel cU minvec10.u phnvi vm cv vf cv cfv va cv cU cM cX
        minvec10.x minvec10.m nvmcl mp3an1 cU cnv wcel vm cv vf cv cfv va cv cM
        co cX wcel vm cv vf cv cfv va cv cM co cN cfv cr wcel cU minvec10.u
        phnvi vm cv vf cv cfv va cv cM co cU cN cX minvec10.x minvec10.n nvcl
        mpan syl cU vf vm cW cX cY minvec10.u minvec10.w1 minvec10.y minvec10.x
        minveclem4 cY cX va cv cU cW cX cY minvec10.u minvec10.w1 minvec10.y
        minvec10.x minveclem3 sseli syl2an an1rs eqeltrd recnd adantllr
        adantlrl vm cv cn wcel vm cv cT cfv vm cv cF cfv vm cv cJ cfv caddc co
        wceq cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv
        cY wcel wa wa vm cv cn wcel vm cv cT cfv vm cv cF cfv vm cv vf cv cfv
        va cv cM co cN cfv caddc co vm cv cF cfv vm cv cJ cfv caddc co
        minvec30.t vm cv cn wcel vm cv cJ cfv vm cv vf cv cfv va cv cM co cN
        cfv vm cv cF cfv caddc minvec30.j opreq2d eqtr4d adantl 3jca r19.21aiva
        sylanc cP cP vx vy cA cP cR cU cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec30.2 minveclem12 recni addid1i syl6breq $.
        $( [7-Apr-2008] $) $( [28-Feb-2008] $)

      $( Lemma for ~ minvecex . $)
      minveclem31 $p |- ( ( ( f : NN --> Y /\ f ( ~~>m ` D ) a ) /\
          ( F ~~> P /\ a e. Y ) ) -> ( N ` ( A M a ) ) <_ P ) $=
        cA va cv cM co cN cfv cr wcel cT cP cli wbr wa c1 cz wcel vm cv cT cfv
        cr wcel cA va cv cM co cN cfv vm cv cT cfv cle wbr wa vm c1 cuz cfv
        wral wa cA va cv cM co cN cfv cP cle wbr cn cY vf cv wf vf cv va cv cD
        clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa cA va cv cM co cN cfv
        cP vm cT c1 minvec30.tv cA va cv cM co cN fvex cP cr vx vy cA cP cR cU
        cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec30.2 minveclem12 elisseti
        climcmpc1 cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va
        cv cY wcel wa wa cA va cv cM co cN cfv cr wcel cT cP cli wbr va cv cY
        wcel cA va cv cM co cN cfv cr wcel cn cY vf cv wf vf cv va cv cD clm
        cfv wbr wa cF cP cli wbr va cA cU cM cN cW cX cY minvec10.u minvec10.w1
        minvec10.y minvec10.x minvec10.m minvec10.n minvec10.a minveclem5
        ad2antll vx vy cA cD cP cR cT cU vf vj vm cF cJ cM cN cW cX cY va
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec30.2 minvec30.hf minvec30.d minvec30.jv
        minvec30.j minvec30.fv minvec30.tv minvec30.t minveclem30 jca cn cY vf
        cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa
        vm cv cT cfv cr wcel cA va cv cM co cN cfv vm cv cT cfv cle wbr wa vm
        c1 cuz cfv wral c1 cz wcel cn cY vf cv wf vf cv va cv cD clm cfv wbr wa
        cF cP cli wbr va cv cY wcel wa wa vm cv cT cfv cr wcel cA va cv cM co
        cN cfv vm cv cT cfv cle wbr wa vm c1 cuz cfv cn cY vf cv wf vf cv va cv
        cD clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa vm cv cn wcel vm cv
        cT cfv cr wcel cA va cv cM co cN cfv vm cv cT cfv cle wbr wa vm cv c1
        cuz cfv wcel cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr
        va cv cY wcel wa wa vm cv cn wcel wa vm cv cT cfv cr wcel cA va cv cM
        co cN cfv vm cv cT cfv cle wbr cn cY vf cv wf vf cv va cv cD clm cfv
        wbr wa cF cP cli wbr va cv cY wcel wa wa vm cv cn wcel wa vm cv cT cfv
        vm cv cF cfv vm cv vf cv cfv va cv cM co cN cfv caddc co cr vm cv cn
        wcel vm cv cT cfv vm cv cF cfv vm cv vf cv cfv va cv cM co cN cfv caddc
        co wceq cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va
        cv cY wcel wa wa minvec30.t adantl vm cv cF cfv cr wcel vm cv vf cv cfv
        va cv cM co cN cfv cr wcel vm cv cF cfv vm cv vf cv cfv va cv cM co cN
        cfv caddc co cr wcel cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP
        cli wbr va cv cY wcel wa wa vm cv cn wcel wa vm cv cF cfv vm cv vf cv
        cfv va cv cM co cN cfv readdcl cn cY vf cv wf vf cv va cv cD clm cfv
        wbr wa vm cv cn wcel vm cv cF cfv cr wcel cF cP cli wbr va cv cY wcel
        wa cn cY vf cv wf vm cv cn wcel vm cv cF cfv cr wcel vf cv va cv cD clm
        cfv wbr vx vy cA cR cU vf vj vm cF cM cN cW cX cY minvec10.1 minvec10.u
        minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a
        minvec30.hf minveclem22 adantlr adantlr cn cY vf cv wf cF cP cli wbr va
        cv cY wcel wa vm cv cn wcel vm cv vf cv cfv va cv cM co cN cfv cr wcel
        vf cv va cv cD clm cfv wbr cn cY vf cv wf va cv cY wcel vm cv cn wcel
        vm cv vf cv cfv va cv cM co cN cfv cr wcel cF cP cli wbr cn cY vf cv wf
        vm cv cn wcel va cv cY wcel vm cv vf cv cfv va cv cM co cN cfv cr wcel
        vm cv vf cv cfv cX wcel va cv cX wcel vm cv vf cv cfv va cv cM co cN
        cfv cr wcel cn cY vf cv wf vm cv cn wcel wa va cv cY wcel vm cv vf cv
        cfv cX wcel va cv cX wcel wa vm cv vf cv cfv va cv cM co cX wcel vm cv
        vf cv cfv va cv cM co cN cfv cr wcel cU cnv wcel vm cv vf cv cfv cX
        wcel va cv cX wcel vm cv vf cv cfv va cv cM co cX wcel cU minvec10.u
        phnvi vm cv vf cv cfv va cv cU cM cX minvec10.x minvec10.m nvmcl mp3an1
        cU cnv wcel vm cv vf cv cfv va cv cM co cX wcel vm cv vf cv cfv va cv
        cM co cN cfv cr wcel cU minvec10.u phnvi vm cv vf cv cfv va cv cM co cU
        cN cX minvec10.x minvec10.n nvcl mpan syl cU vf vm cW cX cY minvec10.u
        minvec10.w1 minvec10.y minvec10.x minveclem4 cY cX va cv cU cW cX cY
        minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem3 sseli syl2an
        an1rs adantlrl adantllr sylanc eqeltrd cn cY vf cv wf vf cv va cv cD
        clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa vm cv cn wcel wa cA va
        cv cM co cN cfv vm cv cF cfv vm cv vf cv cfv va cv cM co cN cfv caddc
        co vm cv cT cfv cle cn cY vf cv wf cF cP cli wbr va cv cY wcel wa vm cv
        cn wcel cA va cv cM co cN cfv vm cv cF cfv vm cv vf cv cfv va cv cM co
        cN cfv caddc co cle wbr vf cv va cv cD clm cfv wbr cn cY vf cv wf va cv
        cY wcel vm cv cn wcel cA va cv cM co cN cfv vm cv cF cfv vm cv vf cv
        cfv va cv cM co cN cfv caddc co cle wbr cF cP cli wbr cn cY vf cv wf vm
        cv cn wcel va cv cY wcel cA va cv cM co cN cfv vm cv cF cfv vm cv vf cv
        cfv va cv cM co cN cfv caddc co cle wbr cn cY vf cv wf vm cv cn wcel wa
        va cv cY wcel wa cA va cv cM co cN cfv cA vm cv vf cv cfv cM co cN cfv
        vm cv vf cv cfv va cv cM co cN cfv caddc co vm cv cF cfv vm cv vf cv
        cfv va cv cM co cN cfv caddc co cle vm cv vf cv cfv cX wcel va cv cX
        wcel cA va cv cM co cN cfv cA vm cv vf cv cfv cM co cN cfv vm cv vf cv
        cfv va cv cM co cN cfv caddc co cle wbr cn cY vf cv wf vm cv cn wcel wa
        va cv cY wcel cA cX wcel vm cv vf cv cfv cX wcel va cv cX wcel cA va cv
        cM co cN cfv cA vm cv vf cv cfv cM co cN cfv vm cv vf cv cfv va cv cM
        co cN cfv caddc co cle wbr minvec10.a cU cnv wcel cA cX wcel vm cv vf
        cv cfv cX wcel va cv cX wcel w3a cA va cv cM co cN cfv cA vm cv vf cv
        cfv cM co cN cfv vm cv vf cv cfv va cv cM co cN cfv caddc co cle wbr cU
        minvec10.u phnvi cA vm cv vf cv cfv va cv cU cM cN cX minvec10.x
        minvec10.m minvec10.n nvmtri2 mpan mp3an1 cU vf vm cW cX cY minvec10.u
        minvec10.w1 minvec10.y minvec10.x minveclem4 cY cX va cv cU cW cX cY
        minvec10.u minvec10.w1 minvec10.y minvec10.x minveclem3 sseli syl2an cn
        cY vf cv wf vm cv cn wcel wa va cv cY wcel wa vm cv cF cfv cA vm cv vf
        cv cfv cM co cN cfv vm cv vf cv cfv va cv cM co cN cfv caddc vm cv cn
        wcel vm cv cF cfv cA vm cv vf cv cfv cM co cN cfv wceq cn cY vf cv wf
        va cv cY wcel cA vf vj vm cF cM cN minvec30.hf minveclem8 ad2antlr
        opreq1d breqtrrd an1rs adantlrl adantllr vm cv cn wcel vm cv cT cfv vm
        cv cF cfv vm cv vf cv cfv va cv cM co cN cfv caddc co wceq cn cY vf cv
        wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa
        minvec30.t adantl breqtrrd jca vm cv elnnuz sylan2br r19.21aiva 1z
        jctil sylanc $.
        $( [7-Apr-2008] $) $( [28-Feb-2008] $)

      $( Lemma for ~ minvecex . $)
      minveclem32 $p |- ( ( ( f : NN --> Y /\ f ( ~~>m ` D ) a ) /\
          ( F ~~> P /\ a e. Y ) ) -> ( N ` ( A M a ) ) = P ) $=
        cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY
        wcel wa wa cA va cv cM co cN cfv cP wceq cA va cv cM co cN cfv cP cle
        wbr cP cA va cv cM co cN cfv cle wbr wa cn cY vf cv wf vf cv va cv cD
        clm cfv wbr wa cF cP cli wbr va cv cY wcel wa wa cA va cv cM co cN cfv
        cP cle wbr cP cA va cv cM co cN cfv cle wbr vx vy cA cD cP cR cT cU vf
        vj vm cF cJ cM cN cW cX cY va minvec10.1 minvec10.u minvec10.m
        minvec10.n minvec10.x minvec10.w1 minvec10.y minvec10.a minvec30.2
        minvec30.hf minvec30.d minvec30.jv minvec30.j minvec30.fv minvec30.tv
        minvec30.t minveclem31 va cv cY wcel cP cA va cv cM co cN cfv cle wbr
        cn cY vf cv wf vf cv va cv cD clm cfv wbr wa cF cP cli wbr vx vy cA va
        cv cP cR cU cM cN cW cX cY minvec10.1 minvec10.u minvec10.m minvec10.n
        minvec10.x minvec10.w1 minvec10.y minvec10.a minvec30.2 minveclem13
        ad2antll jca va cv cY wcel cA va cv cM co cN cfv cP wceq cA va cv cM co
        cN cfv cP cle wbr cP cA va cv cM co cN cfv cle wbr wa wb cn cY vf cv wf
        vf cv va cv cD clm cfv wbr wa cF cP cli wbr va cv cY wcel cA va cv cM
        co cN cfv cr wcel cA va cv cM co cN cfv cP wceq cA va cv cM co cN cfv
        cP cle wbr cP cA va cv cM co cN cfv cle wbr wa wb va cA cU cM cN cW cX
        cY minvec10.u minvec10.w1 minvec10.y minvec10.x minvec10.m minvec10.n
        minvec10.a minveclem5 cA va cv cM co cN cfv cr wcel cP cr wcel cA va cv
        cM co cN cfv cP wceq cA va cv cM co cN cfv cP cle wbr cP cA va cv cM co
        cN cfv cle wbr wa wb vx vy cA cP cR cU cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minvec30.2 minveclem12 cA va cv cM co cN cfv cP letri3 mpan2
        syl ad2antll mpbird $.
        $( [7-Apr-2008] $) $( [28-Feb-2008] $)
    $}

    ${
      minvec33.2 $e |- P = -u sup ( R , RR , < ) $.
      minvec33.hf $e |- ( j e. NN -> ( F ` j ) = ( N ` ( A M ( f ` j ) ) ) ) $.
      minvec33.d $e |- D = ( IndMet ` W ) $.
      minvec33.t1 $e |- F e. _V $.
        $( Lemma for ~ minvecex . $)
      minveclem33 $p |- ( ( ( f : NN --> Y /\ f ( ~~>m ` D ) a ) /\
          ( F ~~> P /\ a e. Y ) ) -> ( N ` ( A M a ) ) = P ) $=
        vx vy cA cD cP cR vn cv cn wcel vu cv vn cv cF cfv vn cv vf cv cfv va
        cv cM co cN cfv caddc co wceq wa vn vu copab cU vf vj vm cF vn cv cn
        wcel vu cv vn cv vf cv cfv va cv cM co cN cfv wceq wa vn vu copab cM cN
        cW cX cY va minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x
        minvec10.w1 minvec10.y minvec10.a minvec33.2 minvec33.hf minvec33.d vn
        vu cn vn cv vf cv cfv va cv cM co cN cfv vn cv cn wcel vu cv vn cv vf
        cv cfv va cv cM co cN cfv wceq wa vn vu copab nnex vn cv cn wcel vu cv
        vn cv vf cv cfv va cv cM co cN cfv wceq wa vn vu copab eqid fopabex2 vn
        vu vm cv vn cv vf cv cfv va cv cM co cN cfv vm cv vf cv cfv va cv cM co
        cN cfv cn vn cv cn wcel vu cv vn cv vf cv cfv va cv cM co cN cfv wceq
        wa vn vu copab vn cv vm cv wceq vn cv vf cv cfv va cv cM co vm cv vf cv
        cfv va cv cM co cN vn cv vm cv wceq vn cv vf cv cfv vm cv vf cv cfv va
        cv cM vn cv vm cv vf cv fveq2 opreq1d fveq2d vn cv cn wcel vu cv vn cv
        vf cv cfv va cv cM co cN cfv wceq wa vn vu copab eqid vm cv vf cv cfv
        va cv cM co cN fvex fvopab4 minvec33.t1 vn vu cn vn cv cF cfv vn cv vf
        cv cfv va cv cM co cN cfv caddc co vn cv cn wcel vu cv vn cv cF cfv vn
        cv vf cv cfv va cv cM co cN cfv caddc co wceq wa vn vu copab nnex vn cv
        cn wcel vu cv vn cv cF cfv vn cv vf cv cfv va cv cM co cN cfv caddc co
        wceq wa vn vu copab eqid fopabex2 vn vu vm cv vn cv cF cfv vn cv vf cv
        cfv va cv cM co cN cfv caddc co vm cv cF cfv vm cv vf cv cfv va cv cM
        co cN cfv caddc co cn vn cv cn wcel vu cv vn cv cF cfv vn cv vf cv cfv
        va cv cM co cN cfv caddc co wceq wa vn vu copab vn cv vm cv wceq vn cv
        cF cfv vm cv cF cfv vn cv vf cv cfv va cv cM co cN cfv vm cv vf cv cfv
        va cv cM co cN cfv caddc vn cv vm cv cF fveq2 vn cv vm cv wceq vn cv vf
        cv cfv va cv cM co vm cv vf cv cfv va cv cM co cN vn cv vm cv wceq vn
        cv vf cv cfv vm cv vf cv cfv va cv cM vn cv vm cv vf cv fveq2 opreq1d
        fveq2d opreq12d vn cv cn wcel vu cv vn cv cF cfv vn cv vf cv cfv va cv
        cM co cN cfv caddc co wceq wa vn vu copab eqid vm cv cF cfv vm cv vf cv
        cfv va cv cM co cN cfv caddc oprex fvopab4 minveclem32 $.
        $( [7-Apr-2008] $) $( [28-Feb-2008] $)

      minvec34.w2 $e |- W e. CBan $.
      $( Minimizing vector theorem (existence part).  There is exactly one
         vector in a complete subspace ` W ` that minimizes the distance to an
         arbitrary vector ` A ` in a parent inner product space.  Part of
         Theorem 3.3-1 of [Kreyszig] p. 144, specialized to subspaces instead
         of convex subsets.  Note that we work with the negative of supremum
         instead of infimum in order to use theorems we already have
         available. $)
      minvecex $p |- E. a e. Y ( N ` ( A M a ) ) = P $=
        cn cY vf cv wf cF cP cli wbr wa vf wex cA va cv cM co cN cfv cP wceq va
        cY wrex vu vt vu vt cA vt cv cM co cN cfv cA vj cv vf cv cfv cM co cN
        cfv cR cP vf vj cF cY cW cn0v cfv cR vx cv cA vy cv cM co cN cfv cneg
        wceq vy cY wrex vx cab vu cv cA vt cv cM co cN cfv cneg wceq vt cY wrex
        vu cab minvec10.1 vx cv cA vy cv cM co cN cfv cneg wceq vy cY wrex vx
        cab vu cv cA vy cv cM co cN cfv cneg wceq vy cY wrex vu cab vu cv cA vt
        cv cM co cN cfv cneg wceq vt cY wrex vu cab vx cv cA vy cv cM co cN cfv
        cneg wceq vy cY wrex vu cv cA vy cv cM co cN cfv cneg wceq vy cY wrex
        vx vu vx cv vu cv wceq vx cv cA vy cv cM co cN cfv cneg wceq vu cv cA
        vy cv cM co cN cfv cneg wceq vy cY vx cv vu cv cA vy cv cM co cN cfv
        cneg eqeq1 rexbidv cbvabv vu cv cA vy cv cM co cN cfv cneg wceq vy cY
        wrex vu cv cA vt cv cM co cN cfv cneg wceq vt cY wrex vu vu cv cA vy cv
        cM co cN cfv cneg wceq vu cv cA vt cv cM co cN cfv cneg wceq vy vt cY
        vy cv vt cv wceq cA vy cv cM co cN cfv cneg cA vt cv cM co cN cfv cneg
        vu cv vy cv vt cv wceq cA vy cv cM co cN cfv cA vt cv cM co cN cfv vy
        cv vt cv wceq cA vy cv cM co cA vt cv cM co cN vy cv vt cv cA cM opreq2
        fveq2d negeqd eqeq2d cbvrexv abbii eqtri eqtri vt cA cU cM cN cW cX cY
        minvec10.u minvec10.w1 minvec10.y minvec10.x minvec10.m minvec10.n
        minvec10.a minveclem5 cW cnv wcel cW cn0v cfv cY wcel cU cnv wcel cW cU
        css cfv wcel cW cnv wcel cU minvec10.u phnvi minvec10.w1 cU cU css cfv
        cW cU css cfv eqid sspnv mp2an cW cY cW cn0v cfv minvec10.y cW cn0v cfv
        eqid nvzcl ax-mp vx vy vu vt cA cR cU cM cN cW cX cY minvec10.1
        minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1 minvec10.y
        minvec10.a minveclem10 minvec33.2 minvec33.t1 vt cv vj cv vf cv cfv
        wceq cA vt cv cM co cA vj cv vf cv cfv cM co cN vt cv vj cv vf cv cfv
        cA cM opreq2 fveq2d minvec33.hf infcvgi cn cY vf cv wf cF cP cli wbr wa
        cA va cv cM co cN cfv cP wceq va cY wrex vf cn cY vf cv wf cF cP cli
        wbr wa vf cv va cv cD clm cfv wbr va cY wrex cA va cv cM co cN cfv cP
        wceq va cY wrex vu vt cA cD cP cR cU vf vj cF cM cN cW cX cY va cR vx
        cv cA vy cv cM co cN cfv cneg wceq vy cY wrex vx cab vu cv cA vt cv cM
        co cN cfv cneg wceq vt cY wrex vu cab minvec10.1 vx cv cA vy cv cM co
        cN cfv cneg wceq vy cY wrex vx cab vu cv cA vy cv cM co cN cfv cneg
        wceq vy cY wrex vu cab vu cv cA vt cv cM co cN cfv cneg wceq vt cY wrex
        vu cab vx cv cA vy cv cM co cN cfv cneg wceq vy cY wrex vu cv cA vy cv
        cM co cN cfv cneg wceq vy cY wrex vx vu vx cv vu cv wceq vx cv cA vy cv
        cM co cN cfv cneg wceq vu cv cA vy cv cM co cN cfv cneg wceq vy cY vx
        cv vu cv cA vy cv cM co cN cfv cneg eqeq1 rexbidv cbvabv vu cv cA vy cv
        cM co cN cfv cneg wceq vy cY wrex vu cv cA vt cv cM co cN cfv cneg wceq
        vt cY wrex vu vu cv cA vy cv cM co cN cfv cneg wceq vu cv cA vt cv cM
        co cN cfv cneg wceq vy vt cY vy cv vt cv wceq cA vy cv cM co cN cfv
        cneg cA vt cv cM co cN cfv cneg vu cv vy cv vt cv wceq cA vy cv cM co
        cN cfv cA vt cv cM co cN cfv vy cv vt cv wceq cA vy cv cM co cA vt cv
        cM co cN vy cv vt cv cA cM opreq2 fveq2d negeqd eqeq2d cbvrexv abbii
        eqtri eqtri minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec33.hf minvec33.2 minvec33.d minvec34.w2
        minveclem29 cn cY vf cv wf cF cP cli wbr wa vf cv va cv cD clm cfv wbr
        cA va cv cM co cN cfv cP wceq va cY cn cY vf cv wf cF cP cli wbr va cv
        cY wcel vf cv va cv cD clm cfv wbr cA va cv cM co cN cfv cP wceq wi cn
        cY vf cv wf cF cP cli wbr vf cv va cv cD clm cfv wbr va cv cY wcel cA
        va cv cM co cN cfv cP wceq cn cY vf cv wf vf cv va cv cD clm cfv wbr cF
        cP cli wbr va cv cY wcel cA va cv cM co cN cfv cP wceq wi cn cY vf cv
        wf vf cv va cv cD clm cfv wbr cF cP cli wbr va cv cY wcel cA va cv cM
        co cN cfv cP wceq vx vy cA cD cP cR cU vf vj cF cM cN cW cX cY va
        minvec10.1 minvec10.u minvec10.m minvec10.n minvec10.x minvec10.w1
        minvec10.y minvec10.a minvec33.2 minvec33.hf minvec33.d minvec33.t1
        minveclem33 exp43 com23 com34 imp31 r19.22dva mpd 19.23aiv ax-mp $.
        $( [7-Apr-2008] $) $( [28-Feb-2008] $)
    $}
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y M $.  $d x y N $.  $d x y S $.
    $d x y U $.  $d x y W $.  $d x y Y $.  $d a b x y $.
    minvec35.x $e |- X = ( BaseSet ` U ) $.
    minvec35.g $e |- G = ( +v ` U ) $.
    minvec35.m $e |- M = ( -v ` U ) $.
    minvec35.s $e |- S = ( .s ` U ) $.
    minvec35.n $e |- N = ( norm ` U ) $.
    minvec35.y $e |- Y = ( BaseSet ` W ) $.
    minvec35.u $e |- U e. CPreHil $.
    minvec35.a $e |- A e. X $.
    $( Lemma for ~ minveceu . $)
    minveclem35 $p |- ( ( a e. X /\ b e. X ) -> ( N ` ( ( A M a ) G ( A M b )
         ) ) = ( 2 x. ( N ` ( A M ( ( 1 / 2 ) S ( a G b ) ) ) ) ) ) $=
      va cv cX wcel vb cv cX wcel wa cA va cv cM co cA vb cv cM co cG co cN cfv
      c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cS co cN cfv c2 cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co va cv cX wcel vb
      cv cX wcel wa cA va cv cM co cA vb cv cM co cG co c2 cA c1 c2 cdiv co va
      cv vb cv cG co cS co cM co cS co cN va cv cX wcel vb cv cX wcel wa cA cA
      cG co va cv vb cv cG co cM co cA va cv cM co cA vb cv cM co cG co c2 cA
      c1 c2 cdiv co va cv vb cv cG co cS co cM co cS co cA cX wcel cA cX wcel
      va cv cX wcel vb cv cX wcel wa cA cA cG co va cv vb cv cG co cM co cA va
      cv cM co cA vb cv cM co cG co wceq minvec35.a minvec35.a cU cnv wcel cA
      cX wcel cA cX wcel wa va cv cX wcel vb cv cX wcel wa cA cA cG co va cv vb
      cv cG co cM co cA va cv cM co cA vb cv cM co cG co wceq cU minvec35.u
      phnvi cA cA va cv vb cv cU cG cM cX minvec35.x minvec35.g minvec35.m
      nvaddsub4 mp3an1 mpanl12 va cv cX wcel vb cv cX wcel wa va cv vb cv cG co
      cX wcel cA cA cG co va cv vb cv cG co cM co c2 cA c1 c2 cdiv co va cv vb
      cv cG co cS co cM co cS co wceq cU cnv wcel va cv cX wcel vb cv cX wcel
      va cv vb cv cG co cX wcel cU minvec35.u phnvi va cv vb cv cU cG cX
      minvec35.x minvec35.g nvgcl mp3an1 va cv vb cv cG co cX wcel cA cA cG co
      va cv vb cv cG co cM co c2 cA cS co c2 c1 c2 cdiv co va cv vb cv cG co cS
      co cS co cM co c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cS co va
      cv vb cv cG co cX wcel cA cA cG co c2 cA cS co va cv vb cv cG co c2 c1 c2
      cdiv co va cv vb cv cG co cS co cS co cM cA cA cG co c2 cA cS co wceq va
      cv vb cv cG co cX wcel cU cnv wcel cA cX wcel cA cA cG co c2 cA cS co
      wceq cU minvec35.u phnvi minvec35.a cA cS cU cG cX minvec35.x minvec35.g
      minvec35.s nv2 mp2an a1i va cv vb cv cG co cX wcel c2 c1 c2 cdiv co cmul
      co va cv vb cv cG co cS co c1 va cv vb cv cG co cS co c2 c1 c2 cdiv co va
      cv vb cv cG co cS co cS co va cv vb cv cG co c2 c1 c2 cdiv co cmul co va
      cv vb cv cG co cS co c1 va cv vb cv cG co cS co wceq va cv vb cv cG co cX
      wcel c2 c1 c2 cdiv co cmul co c1 va cv vb cv cG co cS c2 2cn 2ne0 recidi
      opreq1i a1i c2 cc wcel c1 c2 cdiv co cc wcel va cv vb cv cG co cX wcel c2
      c1 c2 cdiv co cmul co va cv vb cv cG co cS co c2 c1 c2 cdiv co va cv vb
      cv cG co cS co cS co wceq 2cn c2 2cn 2ne0 reccli cU cnv wcel c2 cc wcel
      c1 c2 cdiv co cc wcel va cv vb cv cG co cX wcel w3a c2 c1 c2 cdiv co cmul
      co va cv vb cv cG co cS co c2 c1 c2 cdiv co va cv vb cv cG co cS co cS co
      wceq cU minvec35.u phnvi c2 c1 c2 cdiv co va cv vb cv cG co cS cU cX
      minvec35.x minvec35.s nvsass mpan mp3an12 cU cnv wcel va cv vb cv cG co
      cX wcel c1 va cv vb cv cG co cS co va cv vb cv cG co wceq cU minvec35.u
      phnvi va cv vb cv cG co cS cU cX minvec35.x minvec35.s nvsid mpan
      3eqtr3rd opreq12d va cv vb cv cG co cX wcel c1 c2 cdiv co va cv vb cv cG
      co cS co cX wcel c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cS co
      c2 cA cS co c2 c1 c2 cdiv co va cv vb cv cG co cS co cS co cM co wceq cU
      cnv wcel c1 c2 cdiv co cc wcel va cv vb cv cG co cX wcel c1 c2 cdiv co va
      cv vb cv cG co cS co cX wcel cU minvec35.u phnvi c2 2cn 2ne0 reccli c1 c2
      cdiv co va cv vb cv cG co cS cU cX minvec35.x minvec35.s nvscl mp3an12 c2
      cc wcel cA cX wcel c1 c2 cdiv co va cv vb cv cG co cS co cX wcel c2 cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cS co c2 cA cS co c2 c1 c2 cdiv
      co va cv vb cv cG co cS co cS co cM co wceq 2cn minvec35.a cU cnv wcel c2
      cc wcel cA cX wcel c1 c2 cdiv co va cv vb cv cG co cS co cX wcel w3a c2
      cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cS co c2 cA cS co c2 c1 c2
      cdiv co va cv vb cv cG co cS co cS co cM co wceq cU minvec35.u phnvi c2
      cA c1 c2 cdiv co va cv vb cv cG co cS co cS cU cM cX minvec35.x
      minvec35.m minvec35.s nvmdi mpan mp3an12 syl eqtr4d syl eqtr3d fveq2d va
      cv cX wcel vb cv cX wcel wa cA c1 c2 cdiv co va cv vb cv cG co cS co cM
      co cX wcel c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cS co cN cfv
      c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co wceq va
      cv cX wcel vb cv cX wcel wa c1 c2 cdiv co va cv vb cv cG co cS co cX wcel
      cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cX wcel va cv cX wcel vb
      cv cX wcel wa va cv vb cv cG co cX wcel c1 c2 cdiv co va cv vb cv cG co
      cS co cX wcel cU cnv wcel va cv cX wcel vb cv cX wcel va cv vb cv cG co
      cX wcel cU minvec35.u phnvi va cv vb cv cU cG cX minvec35.x minvec35.g
      nvgcl mp3an1 cU cnv wcel c1 c2 cdiv co cc wcel va cv vb cv cG co cX wcel
      c1 c2 cdiv co va cv vb cv cG co cS co cX wcel cU minvec35.u phnvi c2 2cn
      2ne0 reccli c1 c2 cdiv co va cv vb cv cG co cS cU cX minvec35.x
      minvec35.s nvscl mp3an12 syl cU cnv wcel cA cX wcel c1 c2 cdiv co va cv
      vb cv cG co cS co cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co
      cX wcel cU minvec35.u phnvi minvec35.a cA c1 c2 cdiv co va cv vb cv cG co
      cS co cU cM cX minvec35.x minvec35.m nvmcl mp3an12 syl c2 cr wcel cc0 c2
      cle wbr cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cX wcel c2 cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cS co cN cfv c2 cA c1 c2 cdiv co
      va cv vb cv cG co cS co cM co cN cfv cmul co wceq 2re cc0 c2 0re 2re 2pos
      ltleii cU cnv wcel c2 cr wcel cc0 c2 cle wbr wa cA c1 c2 cdiv co va cv vb
      cv cG co cS co cM co cX wcel c2 cA c1 c2 cdiv co va cv vb cv cG co cS co
      cM co cS co cN cfv c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN
      cfv cmul co wceq cU minvec35.u phnvi c2 cA c1 c2 cdiv co va cv vb cv cG
      co cS co cM co cS cU cN cX minvec35.x minvec35.s minvec35.n nvsge0 mp3an1
      mpanl12 syl eqtrd $.
      $( [27-Apr-2008] $) $( [19-Mar-2008] $)

    minvec36.w $e |- W e. ( SubSp ` U ) $.
    minvec36.2 $e |- P = -u sup ( R , RR , < ) $.
    minvec36.1 $e |- R = { x | E. y e. Y x = -u ( N ` ( A M y ) ) } $.
    $( Lemma for ~ minveceu . $)
    minveclem36 $p |- ( ( ( a e. X /\ b e. X ) /\ ( ( N ` ( A M a ) ) = P /\
    ( N ` ( A M b ) ) = P ) ) -> ( ( N ` ( a M b ) ) ^ 2 ) = ( ( 2 x. ( ( P
       ^ 2 ) + ( P ^ 2 ) ) ) - ( ( N ` ( ( A M a ) G ( A M b ) ) ) ^ 2 ) ) ) $=
      va cv cX wcel vb cv cX wcel wa cA va cv cM co cN cfv cP wceq cA vb cv cM
      co cN cfv cP wceq wa wa c2 cP c2 cexp co cP c2 cexp co caddc co cmul co
      cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cmin co va cv vb cv
      cM co cN cfv c2 cexp co va cv cX wcel vb cv cX wcel wa cA va cv cM co cN
      cfv cP wceq cA vb cv cM co cN cfv cP wceq wa wa c2 cP c2 cexp co cP c2
      cexp co caddc co cmul co cA va cv cM co cA vb cv cM co cG co cN cfv c2
      cexp co cmin co va cv vb cv cM co cN cfv c2 cexp co wceq cA va cv cM co
      cA vb cv cM co cG co cN cfv c2 cexp co va cv vb cv cM co cN cfv c2 cexp
      co caddc co c2 cP c2 cexp co cP c2 cexp co caddc co cmul co wceq va cv cX
      wcel vb cv cX wcel wa cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv
      cP wceq wa cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co va cv vb
      cv cM co cN cfv c2 cexp co caddc co c2 cA va cv cM co cN cfv c2 cexp co
      cA vb cv cM co cN cfv c2 cexp co caddc co cmul co c2 cP c2 cexp co cP c2
      cexp co caddc co cmul co va cv cX wcel vb cv cX wcel wa cA va cv cM co cA
      vb cv cM co cG co cN cfv c2 cexp co cA va cv cM co cA vb cv cM co cM co
      cN cfv c2 cexp co caddc co cA va cv cM co cA vb cv cM co cG co cN cfv c2
      cexp co va cv vb cv cM co cN cfv c2 cexp co caddc co c2 cA va cv cM co cN
      cfv c2 cexp co cA vb cv cM co cN cfv c2 cexp co caddc co cmul co va cv cX
      wcel vb cv cX wcel wa cA va cv cM co cA vb cv cM co cM co cN cfv c2 cexp
      co va cv vb cv cM co cN cfv c2 cexp co cA va cv cM co cA vb cv cM co cG
      co cN cfv c2 cexp co caddc va cv cX wcel vb cv cX wcel wa cA va cv cM co
      cA vb cv cM co cM co cN cfv va cv vb cv cM co cN cfv c2 cexp va cv cX
      wcel vb cv cX wcel wa cA va cv cM co cA vb cv cM co cM co cN cfv vb cv va
      cv cM co cN cfv va cv vb cv cM co cN cfv va cv cX wcel vb cv cX wcel wa
      cA va cv cM co cA vb cv cM co cM co vb cv va cv cM co cN cA cX wcel va cv
      cX wcel vb cv cX wcel cA va cv cM co cA vb cv cM co cM co vb cv va cv cM
      co wceq minvec35.a cU cnv wcel cA cX wcel va cv cX wcel vb cv cX wcel w3a
      cA va cv cM co cA vb cv cM co cM co vb cv va cv cM co wceq cU minvec35.u
      phnvi cA va cv vb cv cU cM cX minvec35.x minvec35.m nvnnncan1 mpan mp3an1
      fveq2d cU cnv wcel va cv cX wcel vb cv cX wcel va cv vb cv cM co cN cfv
      vb cv va cv cM co cN cfv wceq cU minvec35.u phnvi va cv vb cv cU cM cN cX
      minvec35.x minvec35.m minvec35.n nvsub mp3an1 eqtr4d opreq1d opreq2d cA
      va cv cM co cX wcel cA vb cv cM co cX wcel cA va cv cM co cA vb cv cM co
      cG co cN cfv c2 cexp co cA va cv cM co cA vb cv cM co cM co cN cfv c2
      cexp co caddc co c2 cA va cv cM co cN cfv c2 cexp co cA vb cv cM co cN
      cfv c2 cexp co caddc co cmul co wceq va cv cX wcel vb cv cX wcel cU cphl
      wcel cA va cv cM co cX wcel cA vb cv cM co cX wcel cA va cv cM co cA vb
      cv cM co cG co cN cfv c2 cexp co cA va cv cM co cA vb cv cM co cM co cN
      cfv c2 cexp co caddc co c2 cA va cv cM co cN cfv c2 cexp co cA vb cv cM
      co cN cfv c2 cexp co caddc co cmul co wceq minvec35.u cA va cv cM co cA
      vb cv cM co cU cG cM cN cX minvec35.x minvec35.g minvec35.m minvec35.n
      phpar2 mp3an1 cU cnv wcel cA cX wcel va cv cX wcel cA va cv cM co cX wcel
      cU minvec35.u phnvi minvec35.a cA va cv cU cM cX minvec35.x minvec35.m
      nvmcl mp3an12 cU cnv wcel cA cX wcel vb cv cX wcel cA vb cv cM co cX wcel
      cU minvec35.u phnvi minvec35.a cA vb cv cU cM cX minvec35.x minvec35.m
      nvmcl mp3an12 syl2an eqtr3d cA va cv cM co cN cfv cP wceq cA vb cv cM co
      cN cfv cP wceq wa cA va cv cM co cN cfv c2 cexp co cA vb cv cM co cN cfv
      c2 cexp co caddc co cP c2 cexp co cP c2 cexp co caddc co c2 cmul cA va cv
      cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq cA va cv cM co cN cfv
      c2 cexp co cP c2 cexp co cA vb cv cM co cN cfv c2 cexp co cP c2 cexp co
      caddc cA va cv cM co cN cfv cP c2 cexp opreq1 cA vb cv cM co cN cfv cP c2
      cexp opreq1 opreqan12d opreq2d sylan9eq va cv cX wcel vb cv cX wcel wa c2
      cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv cM
      co cG co cN cfv c2 cexp co cmin co va cv vb cv cM co cN cfv c2 cexp co
      wceq cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co va cv vb cv cM
      co cN cfv c2 cexp co caddc co c2 cP c2 cexp co cP c2 cexp co caddc co
      cmul co wceq wb cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP
      wceq wa cA va cv cM co cA vb cv cM co cG co cX wcel va cv vb cv cM co cX
      wcel c2 cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb
      cv cM co cG co cN cfv c2 cexp co cmin co va cv vb cv cM co cN cfv c2 cexp
      co wceq cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co va cv vb cv
      cM co cN cfv c2 cexp co caddc co c2 cP c2 cexp co cP c2 cexp co caddc co
      cmul co wceq wb va cv cX wcel vb cv cX wcel wa cA va cv cM co cA vb cv cM
      co cG co cN cfv cc wcel va cv vb cv cM co cN cfv cc wcel c2 cP c2 cexp co
      cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv cM co cG co cN cfv
      c2 cexp co cmin co va cv vb cv cM co cN cfv c2 cexp co wceq cA va cv cM
      co cA vb cv cM co cG co cN cfv c2 cexp co va cv vb cv cM co cN cfv c2
      cexp co caddc co c2 cP c2 cexp co cP c2 cexp co caddc co cmul co wceq wb
      cA va cv cM co cA vb cv cM co cG co cX wcel va cv vb cv cM co cX wcel cA
      va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cc wcel va cv vb cv cM
      co cN cfv c2 cexp co cc wcel c2 cP c2 cexp co cP c2 cexp co caddc co cmul
      co cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cmin co va cv vb
      cv cM co cN cfv c2 cexp co wceq cA va cv cM co cA vb cv cM co cG co cN
      cfv c2 cexp co va cv vb cv cM co cN cfv c2 cexp co caddc co c2 cP c2 cexp
      co cP c2 cexp co caddc co cmul co wceq wb cA va cv cM co cA vb cv cM co
      cG co cN cfv cc wcel va cv vb cv cM co cN cfv cc wcel c2 cP c2 cexp co cP
      c2 cexp co caddc co cmul co cc wcel cA va cv cM co cA vb cv cM co cG co
      cN cfv c2 cexp co cc wcel va cv vb cv cM co cN cfv c2 cexp co cc wcel c2
      cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv cM
      co cG co cN cfv c2 cexp co cmin co va cv vb cv cM co cN cfv c2 cexp co
      wceq cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co va cv vb cv cM
      co cN cfv c2 cexp co caddc co c2 cP c2 cexp co cP c2 cexp co caddc co
      cmul co wceq wb c2 cP c2 cexp co cP c2 cexp co caddc co 2cn cP c2 cexp co
      cP c2 cexp co caddc co cP c2 cexp co cP c2 cexp co cP vx vy cA cP cR cU
      cM cN cW cX cY minvec36.1 minvec35.u minvec35.m minvec35.n minvec35.x
      minvec36.w minvec35.y minvec35.a minvec36.2 minveclem12 resqcli cP vx vy
      cA cP cR cU cM cN cW cX cY minvec36.1 minvec35.u minvec35.m minvec35.n
      minvec35.x minvec36.w minvec35.y minvec35.a minvec36.2 minveclem12
      resqcli readdcli recni mulcli c2 cP c2 cexp co cP c2 cexp co caddc co
      cmul co cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co va cv vb cv
      cM co cN cfv c2 cexp co subadd mp3an1 cA va cv cM co cA vb cv cM co cG co
      cN cfv sqcl va cv vb cv cM co cN cfv sqcl syl2an cA va cv cM co cA vb cv
      cM co cG co cX wcel cA va cv cM co cA vb cv cM co cG co cN cfv cU cnv
      wcel cA va cv cM co cA vb cv cM co cG co cX wcel cA va cv cM co cA vb cv
      cM co cG co cN cfv cr wcel cU minvec35.u phnvi cA va cv cM co cA vb cv cM
      co cG co cU cN cX minvec35.x minvec35.n nvcl mpan recnd va cv vb cv cM co
      cX wcel va cv vb cv cM co cN cfv cU cnv wcel va cv vb cv cM co cX wcel va
      cv vb cv cM co cN cfv cr wcel cU minvec35.u phnvi va cv vb cv cM co cU cN
      cX minvec35.x minvec35.n nvcl mpan recnd syl2an cA va cv cM co cX wcel cA
      vb cv cM co cX wcel cA va cv cM co cA vb cv cM co cG co cX wcel va cv cX
      wcel vb cv cX wcel cU cnv wcel cA va cv cM co cX wcel cA vb cv cM co cX
      wcel cA va cv cM co cA vb cv cM co cG co cX wcel cU minvec35.u phnvi cA
      va cv cM co cA vb cv cM co cU cG cX minvec35.x minvec35.g nvgcl mp3an1 cU
      cnv wcel cA cX wcel va cv cX wcel cA va cv cM co cX wcel cU minvec35.u
      phnvi minvec35.a cA va cv cU cM cX minvec35.x minvec35.m nvmcl mp3an12 cU
      cnv wcel cA cX wcel vb cv cX wcel cA vb cv cM co cX wcel cU minvec35.u
      phnvi minvec35.a cA vb cv cU cM cX minvec35.x minvec35.m nvmcl mp3an12
      syl2an cU cnv wcel va cv cX wcel vb cv cX wcel va cv vb cv cM co cX wcel
      cU minvec35.u phnvi va cv vb cv cU cM cX minvec35.x minvec35.m nvmcl
      mp3an1 sylanc adantr mpbird eqcomd $.
      $( [1-May-2008] $) $( [19-Mar-2008] $)

    $( Lemma for ~ minveceu . $)
    minveclem37 $p |- ( ( a e. Y /\ b e. Y ) ->
              P <_ ( N ` ( A M ( ( 1 / 2 ) S ( a G b ) ) ) ) ) $=
      va cv cY wcel vb cv cY wcel wa c1 c2 cdiv co va cv vb cv cG co cS co cY
      wcel cP cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cle wbr va
      cv cY wcel vb cv cY wcel wa va cv vb cv cG co cY wcel c1 c2 cdiv co va cv
      vb cv cG co cS co cY wcel va cv cY wcel vb cv cY wcel wa va cv vb cv cW
      cpv cfv co va cv vb cv cG co cY cU cnv wcel cW cU css cfv wcel va cv cY
      wcel vb cv cY wcel wa va cv vb cv cW cpv cfv co va cv vb cv cG co wceq cU
      minvec35.u phnvi minvec36.w va cv vb cv cU cW cpv cfv cG cU css cfv cW cY
      minvec35.y minvec35.g cW cpv cfv eqid cU css cfv eqid sspgval mpanl12 cW
      cnv wcel va cv cY wcel vb cv cY wcel va cv vb cv cW cpv cfv co cY wcel cU
      cW minvec35.u minvec36.w minveclem1 va cv vb cv cW cW cpv cfv cY
      minvec35.y cW cpv cfv eqid nvgcl mp3an1 eqeltrrd va cv vb cv cG co cY
      wcel c1 c2 cdiv co va cv vb cv cG co cW cns cfv co c1 c2 cdiv co va cv vb
      cv cG co cS co cY c1 c2 cdiv co cc wcel va cv vb cv cG co cY wcel c1 c2
      cdiv co va cv vb cv cG co cW cns cfv co c1 c2 cdiv co va cv vb cv cG co
      cS co wceq c2 2cn 2ne0 reccli cU cnv wcel cW cU css cfv wcel c1 c2 cdiv
      co cc wcel va cv vb cv cG co cY wcel wa c1 c2 cdiv co va cv vb cv cG co
      cW cns cfv co c1 c2 cdiv co va cv vb cv cG co cS co wceq cU minvec35.u
      phnvi minvec36.w c1 c2 cdiv co va cv vb cv cG co cW cns cfv cS cU cU css
      cfv cW cY minvec35.y minvec35.s cW cns cfv eqid cU css cfv eqid sspsval
      mpanl12 mpan cW cnv wcel c1 c2 cdiv co cc wcel va cv vb cv cG co cY wcel
      c1 c2 cdiv co va cv vb cv cG co cW cns cfv co cY wcel cU cW minvec35.u
      minvec36.w minveclem1 c2 2cn 2ne0 reccli c1 c2 cdiv co va cv vb cv cG co
      cW cns cfv cW cY minvec35.y cW cns cfv eqid nvscl mp3an12 eqeltrrd syl vx
      vy cA c1 c2 cdiv co va cv vb cv cG co cS co cP cR cU cM cN cW cX cY
      minvec36.1 minvec35.u minvec35.m minvec35.n minvec35.x minvec36.w
      minvec35.y minvec35.a minvec36.2 minveclem13 syl $.
      $( [1-May-2008] $) $( [19-Mar-2008] $)

    $( Lemma for ~ minveceu . $)
    minveclem38 $p |- ( ( ( a e. Y /\ b e. Y ) /\ ( ( N ` ( A M a ) ) = P /\
    ( N ` ( A M b ) ) = P ) ) -> ( N ` ( a M b ) ) <_ 0 ) $=
      va cv cY wcel vb cv cY wcel wa cA va cv cM co cN cfv cP wceq cA vb cv cM
      co cN cfv cP wceq wa wa va cv vb cv cM co cN cfv cc0 cle wbr va cv vb cv
      cM co cN cfv c2 cexp co cc0 c2 cexp co cle wbr va cv cY wcel vb cv cY
      wcel wa cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq wa wa
      va cv vb cv cM co cN cfv c2 cexp co cc0 cc0 c2 cexp co cle va cv cY wcel
      vb cv cY wcel wa cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP
      wceq wa wa va cv vb cv cM co cN cfv c2 cexp co c2 cP c2 cexp co cP c2
      cexp co caddc co cmul co cA va cv cM co cA vb cv cM co cG co cN cfv c2
      cexp co cmin co cc0 cle va cv cX wcel vb cv cX wcel wa cA va cv cM co cN
      cfv cP wceq cA vb cv cM co cN cfv cP wceq wa va cv vb cv cM co cN cfv c2
      cexp co c2 cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA
      vb cv cM co cG co cN cfv c2 cexp co cmin co wceq va cv cY wcel vb cv cY
      wcel wa vx vy cA cP cR cS cU cG cM cN cW cX cY va vb minvec35.x
      minvec35.g minvec35.m minvec35.s minvec35.n minvec35.y minvec35.u
      minvec35.a minvec36.w minvec36.2 minvec36.1 minveclem36 va cv cY wcel va
      cv cX wcel vb cv cY wcel vb cv cX wcel cY cX va cv cU cW cX cY minvec35.u
      minvec36.w minvec35.y minvec35.x minveclem3 sseli cY cX vb cv cU cW cX cY
      minvec35.u minvec36.w minvec35.y minvec35.x minveclem3 sseli anim12i
      sylan va cv cY wcel vb cv cY wcel wa c2 cP c2 cexp co cP c2 cexp co caddc
      co cmul co cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cmin co
      cc0 cle wbr cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq
      wa va cv cY wcel vb cv cY wcel wa c2 cP c2 cexp co cP c2 cexp co caddc co
      cmul co cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cmin co cc0
      cle wbr c2 cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA
      vb cv cM co cG co cN cfv c2 cexp co cle wbr va cv cY wcel vb cv cY wcel
      wa c2 cP c2 cexp co cP c2 cexp co caddc co cmul co c4 cA c1 c2 cdiv co va
      cv vb cv cG co cS co cM co cN cfv c2 cexp co cmul co cA va cv cM co cA vb
      cv cM co cG co cN cfv c2 cexp co cle va cv cY wcel vb cv cY wcel wa c4 cP
      c2 cexp co cmul co c4 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN
      cfv c2 cexp co cmul co c2 cP c2 cexp co cP c2 cexp co caddc co cmul co
      cle cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co cr
      wcel cP c2 cexp co cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv
      c2 cexp co cle wbr c4 cP c2 cexp co cmul co c4 cA c1 c2 cdiv co va cv vb
      cv cG co cS co cM co cN cfv c2 cexp co cmul co cle wbr va cv cY wcel vb
      cv cY wcel wa cP c2 cexp co cr wcel cA c1 c2 cdiv co va cv vb cv cG co cS
      co cM co cN cfv c2 cexp co cr wcel cP c2 cexp co cA c1 c2 cdiv co va cv
      vb cv cG co cS co cM co cN cfv c2 cexp co cle wbr c4 cP c2 cexp co cmul
      co c4 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co
      cmul co cle wbr cP vx vy cA cP cR cU cM cN cW cX cY minvec36.1 minvec35.u
      minvec35.m minvec35.n minvec35.x minvec36.w minvec35.y minvec35.a
      minvec36.2 minveclem12 resqcli cP c2 cexp co cr wcel cA c1 c2 cdiv co va
      cv vb cv cG co cS co cM co cN cfv c2 cexp co cr wcel c4 cr wcel cc0 c4
      cle wbr wa cP c2 cexp co cA c1 c2 cdiv co va cv vb cv cG co cS co cM co
      cN cfv c2 cexp co cle wbr c4 cP c2 cexp co cmul co c4 cA c1 c2 cdiv co va
      cv vb cv cG co cS co cM co cN cfv c2 cexp co cmul co cle wbr c4 cr wcel
      cc0 c4 cle wbr 4re cc0 c4 0re 4re 4pos ltleii pm3.2i cP c2 cexp co cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co c4 lemul2a
      mp3anl3 mpanl1 va cv cY wcel vb cv cY wcel wa cA c1 c2 cdiv co va cv vb
      cv cG co cS co cM co cN cfv cr wcel cA c1 c2 cdiv co va cv vb cv cG co cS
      co cM co cN cfv c2 cexp co cr wcel va cv cY wcel vb cv cY wcel wa cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cX wcel cA c1 c2 cdiv co va cv
      vb cv cG co cS co cM co cN cfv cr wcel va cv cY wcel vb cv cY wcel wa c1
      c2 cdiv co va cv vb cv cG co cS co cX wcel cA c1 c2 cdiv co va cv vb cv
      cG co cS co cM co cX wcel va cv cY wcel vb cv cY wcel wa va cv vb cv cG
      co cX wcel c1 c2 cdiv co va cv vb cv cG co cS co cX wcel va cv cX wcel vb
      cv cX wcel va cv vb cv cG co cX wcel va cv cY wcel vb cv cY wcel cU cnv
      wcel va cv cX wcel vb cv cX wcel va cv vb cv cG co cX wcel cU minvec35.u
      phnvi va cv vb cv cU cG cX minvec35.x minvec35.g nvgcl mp3an1 cY cX va cv
      cU cW cX cY minvec35.u minvec36.w minvec35.y minvec35.x minveclem3 sseli
      cY cX vb cv cU cW cX cY minvec35.u minvec36.w minvec35.y minvec35.x
      minveclem3 sseli syl2an cU cnv wcel c1 c2 cdiv co cc wcel va cv vb cv cG
      co cX wcel c1 c2 cdiv co va cv vb cv cG co cS co cX wcel cU minvec35.u
      phnvi c2 2cn 2ne0 reccli c1 c2 cdiv co va cv vb cv cG co cS cU cX
      minvec35.x minvec35.s nvscl mp3an12 syl cU cnv wcel cA cX wcel c1 c2 cdiv
      co va cv vb cv cG co cS co cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS
      co cM co cX wcel cU minvec35.u phnvi minvec35.a cA c1 c2 cdiv co va cv vb
      cv cG co cS co cU cM cX minvec35.x minvec35.m nvmcl mp3an12 syl cU cnv
      wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cX wcel cA c1 c2 cdiv
      co va cv vb cv cG co cS co cM co cN cfv cr wcel cU minvec35.u phnvi cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cU cN cX minvec35.x minvec35.n
      nvcl mpan syl cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv
      resqcl syl cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cr wcel
      cP cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cle wbr cP c2
      cexp co cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co
      cle wbr va cv cY wcel vb cv cY wcel wa cP cr wcel cc0 cP cle wbr cA c1 c2
      cdiv co va cv vb cv cG co cS co cM co cN cfv cr wcel cP cA c1 c2 cdiv co
      va cv vb cv cG co cS co cM co cN cfv cle wbr wa cP c2 cexp co cA c1 c2
      cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co cle wbr vx vy cA
      cP cR cU cM cN cW cX cY minvec36.1 minvec35.u minvec35.m minvec35.n
      minvec35.x minvec36.w minvec35.y minvec35.a minvec36.2 minveclem12 vx vy
      cA cP cR cU cM cN cW cX cY minvec36.1 minvec35.u minvec35.m minvec35.n
      minvec35.x minvec36.w minvec35.y minvec35.a minvec36.2 minveclem14 cP cA
      c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv le2sq2 mpanl12 va cv
      cY wcel vb cv cY wcel wa cA c1 c2 cdiv co va cv vb cv cG co cS co cM co
      cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cr wcel va
      cv cY wcel vb cv cY wcel wa c1 c2 cdiv co va cv vb cv cG co cS co cX wcel
      cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cX wcel va cv cY wcel vb
      cv cY wcel wa va cv vb cv cG co cX wcel c1 c2 cdiv co va cv vb cv cG co
      cS co cX wcel va cv cX wcel vb cv cX wcel va cv vb cv cG co cX wcel va cv
      cY wcel vb cv cY wcel cU cnv wcel va cv cX wcel vb cv cX wcel va cv vb cv
      cG co cX wcel cU minvec35.u phnvi va cv vb cv cU cG cX minvec35.x
      minvec35.g nvgcl mp3an1 cY cX va cv cU cW cX cY minvec35.u minvec36.w
      minvec35.y minvec35.x minveclem3 sseli cY cX vb cv cU cW cX cY minvec35.u
      minvec36.w minvec35.y minvec35.x minveclem3 sseli syl2an cU cnv wcel c1
      c2 cdiv co cc wcel va cv vb cv cG co cX wcel c1 c2 cdiv co va cv vb cv cG
      co cS co cX wcel cU minvec35.u phnvi c2 2cn 2ne0 reccli c1 c2 cdiv co va
      cv vb cv cG co cS cU cX minvec35.x minvec35.s nvscl mp3an12 syl cU cnv
      wcel cA cX wcel c1 c2 cdiv co va cv vb cv cG co cS co cX wcel cA c1 c2
      cdiv co va cv vb cv cG co cS co cM co cX wcel cU minvec35.u phnvi
      minvec35.a cA c1 c2 cdiv co va cv vb cv cG co cS co cU cM cX minvec35.x
      minvec35.m nvmcl mp3an12 syl cU cnv wcel cA c1 c2 cdiv co va cv vb cv cG
      co cS co cM co cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN
      cfv cr wcel cU minvec35.u phnvi cA c1 c2 cdiv co va cv vb cv cG co cS co
      cM co cU cN cX minvec35.x minvec35.n nvcl mpan syl vx vy cA cP cR cS cU
      cG cM cN cW cX cY va vb minvec35.x minvec35.g minvec35.m minvec35.s
      minvec35.n minvec35.y minvec35.u minvec35.a minvec36.w minvec36.2
      minvec36.1 minveclem37 sylanc sylanc c2 c2 cmul co cP c2 cexp co cmul co
      c2 c2 cP c2 cexp co cmul co cmul co c4 cP c2 cexp co cmul co c2 cP c2
      cexp co cP c2 cexp co caddc co cmul co c2 c2 cP c2 cexp co 2cn 2cn cP c2
      cexp co cP vx vy cA cP cR cU cM cN cW cX cY minvec36.1 minvec35.u
      minvec35.m minvec35.n minvec35.x minvec36.w minvec35.y minvec35.a
      minvec36.2 minveclem12 resqcli recni mulassi c2 c2 cmul co c4 cP c2 cexp
      co cmul 2t2e4 opreq1i c2 cP c2 cexp co cmul co cP c2 cexp co cP c2 cexp
      co caddc co c2 cmul cP c2 cexp co cP c2 cexp co cP vx vy cA cP cR cU cM
      cN cW cX cY minvec36.1 minvec35.u minvec35.m minvec35.n minvec35.x
      minvec36.w minvec35.y minvec35.a minvec36.2 minveclem12 resqcli recni
      2timesi opreq2i 3eqtr3ri syl5eqbr va cv cY wcel vb cv cY wcel wa c4 cA c1
      c2 cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co cmul co c2 cA
      c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co c2 cexp co cA
      va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co va cv cY wcel vb cv cY
      wcel wa c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co
      c2 cexp co c2 c2 cexp co cA c1 c2 cdiv co va cv vb cv cG co cS co cM co
      cN cfv c2 cexp co cmul co c4 cA c1 c2 cdiv co va cv vb cv cG co cS co cM
      co cN cfv c2 cexp co cmul co va cv cY wcel vb cv cY wcel wa cA c1 c2 cdiv
      co va cv vb cv cG co cS co cM co cN cfv cc wcel c2 cA c1 c2 cdiv co va cv
      vb cv cG co cS co cM co cN cfv cmul co c2 cexp co c2 c2 cexp co cA c1 c2
      cdiv co va cv vb cv cG co cS co cM co cN cfv c2 cexp co cmul co wceq va
      cv cY wcel vb cv cY wcel wa cA c1 c2 cdiv co va cv vb cv cG co cS co cM
      co cN cfv va cv cY wcel vb cv cY wcel wa cA c1 c2 cdiv co va cv vb cv cG
      co cS co cM co cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN
      cfv cr wcel va cv cY wcel vb cv cY wcel wa c1 c2 cdiv co va cv vb cv cG
      co cS co cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cX wcel
      va cv cY wcel vb cv cY wcel wa va cv vb cv cG co cX wcel c1 c2 cdiv co va
      cv vb cv cG co cS co cX wcel va cv cX wcel vb cv cX wcel va cv vb cv cG
      co cX wcel va cv cY wcel vb cv cY wcel cU cnv wcel va cv cX wcel vb cv cX
      wcel va cv vb cv cG co cX wcel cU minvec35.u phnvi va cv vb cv cU cG cX
      minvec35.x minvec35.g nvgcl mp3an1 cY cX va cv cU cW cX cY minvec35.u
      minvec36.w minvec35.y minvec35.x minveclem3 sseli cY cX vb cv cU cW cX cY
      minvec35.u minvec36.w minvec35.y minvec35.x minveclem3 sseli syl2an cU
      cnv wcel c1 c2 cdiv co cc wcel va cv vb cv cG co cX wcel c1 c2 cdiv co va
      cv vb cv cG co cS co cX wcel cU minvec35.u phnvi c2 2cn 2ne0 reccli c1 c2
      cdiv co va cv vb cv cG co cS cU cX minvec35.x minvec35.s nvscl mp3an12
      syl cU cnv wcel cA cX wcel c1 c2 cdiv co va cv vb cv cG co cS co cX wcel
      cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cX wcel cU minvec35.u
      phnvi minvec35.a cA c1 c2 cdiv co va cv vb cv cG co cS co cU cM cX
      minvec35.x minvec35.m nvmcl mp3an12 syl cU cnv wcel cA c1 c2 cdiv co va
      cv vb cv cG co cS co cM co cX wcel cA c1 c2 cdiv co va cv vb cv cG co cS
      co cM co cN cfv cr wcel cU minvec35.u phnvi cA c1 c2 cdiv co va cv vb cv
      cG co cS co cM co cU cN cX minvec35.x minvec35.n nvcl mpan syl recnd c2
      cc wcel cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cc wcel c2
      cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co c2 cexp co
      c2 c2 cexp co cA c1 c2 cdiv co va cv vb cv cG co cS co cM co cN cfv c2
      cexp co cmul co wceq 2cn c2 cA c1 c2 cdiv co va cv vb cv cG co cS co cM
      co cN cfv sqmul mpan syl c2 c2 cexp co c4 cA c1 c2 cdiv co va cv vb cv cG
      co cS co cM co cN cfv c2 cexp co cmul sq2 opreq1i syl6req va cv cY wcel
      vb cv cY wcel wa cA va cv cM co cA vb cv cM co cG co cN cfv c2 cA c1 c2
      cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co c2 cexp va cv cX
      wcel vb cv cX wcel cA va cv cM co cA vb cv cM co cG co cN cfv c2 cA c1 c2
      cdiv co va cv vb cv cG co cS co cM co cN cfv cmul co wceq va cv cY wcel
      vb cv cY wcel cA cS cU cG cM cN cW cX cY va vb minvec35.x minvec35.g
      minvec35.m minvec35.s minvec35.n minvec35.y minvec35.u minvec35.a
      minveclem35 cY cX va cv cU cW cX cY minvec35.u minvec36.w minvec35.y
      minvec35.x minveclem3 sseli cY cX vb cv cU cW cX cY minvec35.u minvec36.w
      minvec35.y minvec35.x minveclem3 sseli syl2an opreq1d eqtr4d breqtrd va
      cv cX wcel vb cv cX wcel c2 cP c2 cexp co cP c2 cexp co caddc co cmul co
      cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cmin co cc0 cle wbr
      c2 cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv
      cM co cG co cN cfv c2 cexp co cle wbr wb va cv cY wcel vb cv cY wcel va
      cv cX wcel vb cv cX wcel wa cA va cv cM co cA vb cv cM co cG co cN cfv c2
      cexp co cr wcel c2 cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv
      cM co cA vb cv cM co cG co cN cfv c2 cexp co cmin co cc0 cle wbr c2 cP c2
      cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv cM co cG
      co cN cfv c2 cexp co cle wbr wb va cv cX wcel vb cv cX wcel wa cA va cv
      cM co cA vb cv cM co cG co cN cfv cr wcel cA va cv cM co cA vb cv cM co
      cG co cN cfv c2 cexp co cr wcel va cv cX wcel vb cv cX wcel wa cA va cv
      cM co cA vb cv cM co cG co cX wcel cA va cv cM co cA vb cv cM co cG co cN
      cfv cr wcel cA va cv cM co cX wcel cA vb cv cM co cX wcel cA va cv cM co
      cA vb cv cM co cG co cX wcel va cv cX wcel vb cv cX wcel cU cnv wcel cA
      va cv cM co cX wcel cA vb cv cM co cX wcel cA va cv cM co cA vb cv cM co
      cG co cX wcel cU minvec35.u phnvi cA va cv cM co cA vb cv cM co cU cG cX
      minvec35.x minvec35.g nvgcl mp3an1 cU cnv wcel cA cX wcel va cv cX wcel
      cA va cv cM co cX wcel cU minvec35.u phnvi minvec35.a cA va cv cU cM cX
      minvec35.x minvec35.m nvmcl mp3an12 cU cnv wcel cA cX wcel vb cv cX wcel
      cA vb cv cM co cX wcel cU minvec35.u phnvi minvec35.a cA vb cv cU cM cX
      minvec35.x minvec35.m nvmcl mp3an12 syl2an cU cnv wcel cA va cv cM co cA
      vb cv cM co cG co cX wcel cA va cv cM co cA vb cv cM co cG co cN cfv cr
      wcel cU minvec35.u phnvi cA va cv cM co cA vb cv cM co cG co cU cN cX
      minvec35.x minvec35.n nvcl mpan syl cA va cv cM co cA vb cv cM co cG co
      cN cfv resqcl syl c2 cP c2 cexp co cP c2 cexp co caddc co cmul co cr wcel
      cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co cr wcel c2 cP c2
      cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv cM co cG
      co cN cfv c2 cexp co cmin co cc0 cle wbr c2 cP c2 cexp co cP c2 cexp co
      caddc co cmul co cA va cv cM co cA vb cv cM co cG co cN cfv c2 cexp co
      cle wbr wb c2 cP c2 cexp co cP c2 cexp co caddc co 2re cP c2 cexp co cP
      c2 cexp co cP vx vy cA cP cR cU cM cN cW cX cY minvec36.1 minvec35.u
      minvec35.m minvec35.n minvec35.x minvec36.w minvec35.y minvec35.a
      minvec36.2 minveclem12 resqcli cP vx vy cA cP cR cU cM cN cW cX cY
      minvec36.1 minvec35.u minvec35.m minvec35.n minvec35.x minvec36.w
      minvec35.y minvec35.a minvec36.2 minveclem12 resqcli readdcli remulcli c2
      cP c2 cexp co cP c2 cexp co caddc co cmul co cA va cv cM co cA vb cv cM
      co cG co cN cfv c2 cexp co suble0 mpan syl cY cX va cv cU cW cX cY
      minvec35.u minvec36.w minvec35.y minvec35.x minveclem3 sseli cY cX vb cv
      cU cW cX cY minvec35.u minvec36.w minvec35.y minvec35.x minveclem3 sseli
      syl2an mpbird adantr eqbrtrd sq0 syl6breqr va cv cY wcel vb cv cY wcel wa
      va cv vb cv cM co cN cfv cc0 cle wbr va cv vb cv cM co cN cfv c2 cexp co
      cc0 c2 cexp co cle wbr wb cA va cv cM co cN cfv cP wceq cA vb cv cM co cN
      cfv cP wceq wa va cv cX wcel vb cv cX wcel va cv vb cv cM co cN cfv cc0
      cle wbr va cv vb cv cM co cN cfv c2 cexp co cc0 c2 cexp co cle wbr wb va
      cv cY wcel vb cv cY wcel va cv cX wcel vb cv cX wcel wa va cv vb cv cM co
      cX wcel va cv vb cv cM co cN cfv cc0 cle wbr va cv vb cv cM co cN cfv c2
      cexp co cc0 c2 cexp co cle wbr wb cU cnv wcel va cv cX wcel vb cv cX wcel
      va cv vb cv cM co cX wcel cU minvec35.u phnvi va cv vb cv cU cM cX
      minvec35.x minvec35.m nvmcl mp3an1 va cv vb cv cM co cN cfv cr wcel cc0
      va cv vb cv cM co cN cfv cle wbr va cv vb cv cM co cN cfv cc0 cle wbr va
      cv vb cv cM co cN cfv c2 cexp co cc0 c2 cexp co cle wbr wb va cv vb cv cM
      co cX wcel va cv vb cv cM co cN cfv cr wcel cc0 va cv vb cv cM co cN cfv
      cle wbr wa cc0 cr wcel cc0 cc0 cle wbr va cv vb cv cM co cN cfv cc0 cle
      wbr va cv vb cv cM co cN cfv c2 cexp co cc0 c2 cexp co cle wbr wb 0re cc0
      0re leidi va cv vb cv cM co cN cfv cc0 le2sq mpanr12 cU cnv wcel va cv vb
      cv cM co cX wcel va cv vb cv cM co cN cfv cr wcel cU minvec35.u phnvi va
      cv vb cv cM co cU cN cX minvec35.x minvec35.n nvcl mpan cU cnv wcel va cv
      vb cv cM co cX wcel cc0 va cv vb cv cM co cN cfv cle wbr cU minvec35.u
      phnvi va cv vb cv cM co cU cN cX minvec35.x minvec35.n nvge0 mpan sylanc
      syl cY cX va cv cU cW cX cY minvec35.u minvec36.w minvec35.y minvec35.x
      minveclem3 sseli cY cX vb cv cU cW cX cY minvec35.u minvec36.w minvec35.y
      minvec35.x minveclem3 sseli syl2an adantr mpbird $.
      $( [2-May-2008] $) $( [23-Mar-2008] $)
  $}

  ${
    $d a b f j n v x y A $.  $d x y B $.  $d a b f j n v x y M $.
    $d a b f j n v x y N $.  $d a b f n P $.  $d a f Q $.  $d a b R $.
    $d x y U $.  $d a b x y W $.  $d a b f n x y Y $.
    minvec.x $e |- X = ( BaseSet ` U ) $.
    minvec.m $e |- M = ( -v ` U ) $.
    minvec.n $e |- N = ( norm ` U ) $.
    minvec.y $e |- Y = ( BaseSet ` W ) $.
    minvec.1 $e |- R = { x | E. y e. Y x = -u ( N ` ( A M y ) ) } $.
    minvec.2 $e |- P = -u sup ( R , RR , < ) $.
    minvec.u $e |- U e. CPreHil $.
    minvec.w $e |- W e. ( ( SubSp ` U ) i^i CBan ) $.
    minvec.a $e |- A e. X $.
    $( Minimizing vector theorem.  There is exactly one vector in a complete
       subspace ` W ` that minimizes the distance to an arbitrary vector ` A `
       in a parent inner product space.  Theorem 3.3-1 of [Kreyszig] p. 144,
       specialized to subspaces instead of convex subsets.  Note that we work
       with the negative of the supremum of negatives instead of infimum in
       order to use theorems we already have available. $)
    minveceu $p |- E! a e. Y ( N ` ( A M a ) ) = P $=
      cA va cv cM co cN cfv cP wceq va cY wreu cA va cv cM co cN cfv cP wceq va
      cY wrex cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq wa va
      cv vb cv wceq wi vb cY wral va cY wral cA va cv cM co cN cfv cP wceq cA
      vb cv cM co cN cfv cP wceq va vb cY va cv vb cv wceq cA va cv cM co cN
      cfv cA vb cv cM co cN cfv cP va cv vb cv wceq cA va cv cM co cA vb cv cM
      co cN va cv vb cv cA cM opreq2 fveq2d eqeq1d reu4 vx vy cA cW cims cfv cP
      cR cU vf vn vj cv cn wcel vv cv cA vj cv vf cv cfv cM co cN cfv wceq wa
      vj vv copab cM cN cW cX cY va minvec.1 minvec.u minvec.m minvec.n
      minvec.x cW cU css cfv cbn cin wcel cW cU css cfv wcel minvec.w cU css
      cfv cbn cin cU css cfv cW cU css cfv cbn inss1 sseli ax-mp minvec.y
      minvec.a minvec.2 vj vv vn cv cA vj cv vf cv cfv cM co cN cfv cA vn cv vf
      cv cfv cM co cN cfv cn vj cv cn wcel vv cv cA vj cv vf cv cfv cM co cN
      cfv wceq wa vj vv copab vj cv vn cv wceq cA vj cv vf cv cfv cM co cA vn
      cv vf cv cfv cM co cN vj cv vn cv wceq vj cv vf cv cfv vn cv vf cv cfv cA
      cM vj cv vn cv vf cv fveq2 opreq2d fveq2d vj cv cn wcel vv cv cA vj cv vf
      cv cfv cM co cN cfv wceq wa vj vv copab eqid cA vn cv vf cv cfv cM co cN
      fvex fvopab4 cW cims cfv eqid vj vv cn cA vj cv vf cv cfv cM co cN cfv
      nnex opabex2 cW cU css cfv cbn cin wcel cW cbn wcel minvec.w cU css cfv
      cbn cin cbn cW cU css cfv cbn inss2 sseli ax-mp minvecex cA va cv cM co
      cN cfv cP wceq cA vb cv cM co cN cfv cP wceq wa va cv vb cv wceq wi va vb
      cY va cv cY wcel vb cv cY wcel wa cA va cv cM co cN cfv cP wceq cA vb cv
      cM co cN cfv cP wceq wa va cv vb cv wceq va cv cY wcel vb cv cY wcel wa
      cA va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq wa wa va cv
      vb cv cM co cN cfv cc0 cle wbr va cv vb cv wceq vx vy cA cP cR cU cns cfv
      cU cU cpv cfv cM cN cW cX cY va vb minvec.x cU cpv cfv eqid minvec.m cU
      cns cfv eqid minvec.n minvec.y minvec.u minvec.a cW cU css cfv cbn cin
      wcel cW cU css cfv wcel minvec.w cU css cfv cbn cin cU css cfv cW cU css
      cfv cbn inss1 sseli ax-mp minvec.2 minvec.1 minveclem38 va cv cY wcel vb
      cv cY wcel wa va cv vb cv cM co cN cfv cc0 cle wbr va cv vb cv wceq wi cA
      va cv cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq wa va cv cX wcel
      vb cv cX wcel va cv vb cv cM co cN cfv cc0 cle wbr va cv vb cv wceq wi va
      cv cY wcel vb cv cY wcel va cv cX wcel vb cv cX wcel wa va cv vb cv cM co
      cN cfv cc0 cle wbr va cv vb cv cM co cN cfv cc0 cle wbr cc0 va cv vb cv
      cM co cN cfv cle wbr wa va cv vb cv wceq va cv cX wcel vb cv cX wcel wa
      va cv vb cv cM co cN cfv cc0 cle wbr cc0 va cv vb cv cM co cN cfv cle wbr
      va cv vb cv cM co cN cfv cc0 cle wbr cc0 va cv vb cv cM co cN cfv cle wbr
      wa va cv cX wcel vb cv cX wcel wa va cv vb cv cM co cX wcel cc0 va cv vb
      cv cM co cN cfv cle wbr cU cnv wcel va cv cX wcel vb cv cX wcel va cv vb
      cv cM co cX wcel cU minvec.u phnvi va cv vb cv cU cM cX minvec.x minvec.m
      nvmcl mp3an1 cU cnv wcel va cv vb cv cM co cX wcel cc0 va cv vb cv cM co
      cN cfv cle wbr cU minvec.u phnvi va cv vb cv cM co cU cN cX minvec.x
      minvec.n nvge0 mpan syl va cv cX wcel vb cv cX wcel wa va cv vb cv cM co
      cN cfv cc0 cle wbr cc0 va cv vb cv cM co cN cfv cle wbr wa idd mpan2d va
      cv cX wcel vb cv cX wcel wa va cv vb cv cM co cN cfv cc0 wceq va cv vb cv
      cM co cU cn0v cfv wceq va cv vb cv cM co cN cfv cc0 cle wbr cc0 va cv vb
      cv cM co cN cfv cle wbr wa va cv vb cv wceq va cv cX wcel vb cv cX wcel
      wa va cv vb cv cM co cX wcel va cv vb cv cM co cN cfv cc0 wceq va cv vb
      cv cM co cU cn0v cfv wceq wb cU cnv wcel va cv cX wcel vb cv cX wcel va
      cv vb cv cM co cX wcel cU minvec.u phnvi va cv vb cv cU cM cX minvec.x
      minvec.m nvmcl mp3an1 cU cnv wcel va cv vb cv cM co cX wcel va cv vb cv
      cM co cN cfv cc0 wceq va cv vb cv cM co cU cn0v cfv wceq wb cU minvec.u
      phnvi va cv vb cv cM co cU cN cX cU cn0v cfv minvec.x cU cn0v cfv eqid
      minvec.n nvz mpan syl va cv cX wcel vb cv cX wcel wa va cv vb cv cM co cN
      cfv cr wcel va cv vb cv cM co cN cfv cc0 wceq va cv vb cv cM co cN cfv
      cc0 cle wbr cc0 va cv vb cv cM co cN cfv cle wbr wa wb va cv cX wcel vb
      cv cX wcel wa va cv vb cv cM co cX wcel va cv vb cv cM co cN cfv cr wcel
      cU cnv wcel va cv cX wcel vb cv cX wcel va cv vb cv cM co cX wcel cU
      minvec.u phnvi va cv vb cv cU cM cX minvec.x minvec.m nvmcl mp3an1 cU cnv
      wcel va cv vb cv cM co cX wcel va cv vb cv cM co cN cfv cr wcel cU
      minvec.u phnvi va cv vb cv cM co cU cN cX minvec.x minvec.n nvcl mpan syl
      va cv vb cv cM co cN cfv cr wcel cc0 cr wcel va cv vb cv cM co cN cfv cc0
      wceq va cv vb cv cM co cN cfv cc0 cle wbr cc0 va cv vb cv cM co cN cfv
      cle wbr wa wb 0re va cv vb cv cM co cN cfv cc0 letri3 mpan2 syl cU cnv
      wcel va cv cX wcel vb cv cX wcel va cv vb cv cM co cU cn0v cfv wceq va cv
      vb cv wceq wb cU minvec.u phnvi va cv vb cv cU cM cX cU cn0v cfv minvec.x
      minvec.m cU cn0v cfv eqid nvmeq0 mp3an1 3bitr3d sylibd cY cX va cv cU cW
      cX cY minvec.u cW cU css cfv cbn cin wcel cW cU css cfv wcel minvec.w cU
      css cfv cbn cin cU css cfv cW cU css cfv cbn inss1 sseli ax-mp minvec.y
      minvec.x minveclem3 sseli cY cX vb cv cU cW cX cY minvec.u cW cU css cfv
      cbn cin wcel cW cU css cfv wcel minvec.w cU css cfv cbn cin cU css cfv cW
      cU css cfv cbn inss1 sseli ax-mp minvec.y minvec.x minveclem3 sseli
      syl2an adantr mpd ex rgen2a mpbir2an $.
      $( [2-May-2008] $) $( [8-Feb-2008] $)

    minveccl.q $e |- Q = U. { b e. Y | ( N ` ( A M b ) ) = P } $.
    $( The minimizing vector of ~ minveceu belongs to the subspace ` Y ` . $)
    minveccl $p |- Q e. Y $=
      cQ cA vb cv cM co cN cfv cP wceq vb cY crab cuni cY minveccl.q cA vb cv
      cM co cN cfv cP wceq vb cY wreu cA vb cv cM co cN cfv cP wceq vb cY crab
      cuni cY wcel vx vy cA cP cR cU cM cN cW cX cY vb minvec.x minvec.m
      minvec.n minvec.y minvec.1 minvec.2 minvec.u minvec.w minvec.a minveceu
      cA vb cv cM co cN cfv cP wceq vb cY reucl ax-mp eqeltri $.
      $( [3-May-2008] $) $( [24-Mar-2008] $)

    $( Distance of the minimizing vector of ~ minveceu . $)
    minvecdist $p |- ( N ` ( A M Q ) ) = P $=
      cA cQ cM co cN cfv cP wceq cA vb cv cM co cN cfv cP wceq vb cY crab cuni
      cQ wceq cQ cA vb cv cM co cN cfv cP wceq vb cY crab cuni minveccl.q
      eqcomi cQ cY wcel cA vb cv cM co cN cfv cP wceq vb cY wreu cA cQ cM co cN
      cfv cP wceq cA vb cv cM co cN cfv cP wceq vb cY crab cuni cQ wceq wb vx
      vy cA cP cQ cR cU cM cN cW cX cY vb minvec.x minvec.m minvec.n minvec.y
      minvec.1 minvec.2 minvec.u minvec.w minvec.a minveccl.q minveccl vx vy cA
      cP cR cU cM cN cW cX cY vb minvec.x minvec.m minvec.n minvec.y minvec.1
      minvec.2 minvec.u minvec.w minvec.a minveceu cA vb cv cM co cN cfv cP
      wceq cA cQ cM co cN cfv cP wceq vb vf cY cQ vb vf cQ cA vb cv cM co cN
      cfv cP wceq vb cY crab cuni minveccl.q vb vf cA vb cv cM co cN cfv cP
      wceq vb cY crab cA vb cv cM co cN cfv cP wceq vb vf cY hbrab1 hbuni hbxfr
      cA cQ cM co cN cfv cP wceq cA cQ cM co cN cfv cP wceq vb wal wi cQ cY
      wcel vb vf vf cA cQ cM co cN cfv cP vb vf cA cQ cM co cN vf cv cN wcel vb
      ax-17 vb vf cA cQ cM vf cv cA wcel vb ax-17 vf cv cM wcel vb ax-17 vb vf
      cQ cA vb cv cM co cN cfv cP wceq vb cY crab cuni minveccl.q vb vf cA vb
      cv cM co cN cfv cP wceq vb cY crab cA vb cv cM co cN cfv cP wceq vb vf cY
      hbrab1 hbuni hbxfr hbopr hbfv vf cv cP wcel vb ax-17 hbeq a1i vb cv cQ
      wceq cA vb cv cM co cN cfv cA cQ cM co cN cfv cP vb cv cQ wceq cA vb cv
      cM co cA cQ cM co cN vb cv cQ cA cM opreq2 fveq2d eqeq1d reuuni2f mp2an
      mpbir $.
      $( [3-May-2008] $) $( [24-Mar-2008] $)

    $( The minimizing vector from ~ minveceu has the smallest distance. $)
    minvecle $p |- ( B e. Y -> ( N ` ( A M Q ) ) <_ ( N ` ( A M B ) ) ) $=
      cB cY wcel cP cA cB cM co cN cfv cA cQ cM co cN cfv cle vx vy cA cB cP cR
      cU cM cN cW cX cY minvec.1 minvec.u minvec.m minvec.n minvec.x cU css cfv
      cbn cin cU css cfv cW cU css cfv cbn inss1 minvec.w sselii minvec.y
      minvec.a minvec.2 minveclem13 vx vy cA cP cQ cR cU cM cN cW cX cY vb
      minvec.x minvec.m minvec.n minvec.y minvec.1 minvec.2 minvec.u minvec.w
      minvec.a minveccl.q minvecdist syl5eqbr $.
      $( [3-May-2008] $) $( [24-Mar-2008] $)

    $( Lemma for ~ minvecex2 . $)
    minveclem39 $p |- E. a e. Y A. f e. Y
           ( N ` ( A M a ) ) <_ ( N ` ( A M f ) ) $=
      cQ cY wcel cA cQ cM co cN cfv cA vf cv cM co cN cfv cle wbr vf cY wral cA
      va cv cM co cN cfv cA vf cv cM co cN cfv cle wbr vf cY wral va cY wrex vx
      vy cA cP cQ cR cU cM cN cW cX cY vb minvec.x minvec.m minvec.n minvec.y
      minvec.1 minvec.2 minvec.u minvec.w minvec.a minveccl.q minveccl cA cQ cM
      co cN cfv cA vf cv cM co cN cfv cle wbr vf cY vx vy cA vf cv cP cQ cR cU
      cM cN cW cX cY vb minvec.x minvec.m minvec.n minvec.y minvec.1 minvec.2
      minvec.u minvec.w minvec.a minveccl.q minvecle rgen cA va cv cM co cN cfv
      cA vf cv cM co cN cfv cle wbr vf cY wral cA cQ cM co cN cfv cA vf cv cM
      co cN cfv cle wbr vf cY wral va cQ cY va cv cQ wceq cA va cv cM co cN cfv
      cA vf cv cM co cN cfv cle wbr cA cQ cM co cN cfv cA vf cv cM co cN cfv
      cle wbr vf cY va cv cQ wceq cA va cv cM co cN cfv cA cQ cM co cN cfv cA
      vf cv cM co cN cfv cle va cv cQ wceq cA va cv cM co cA cQ cM co cN va cv
      cQ cA cM opreq2 fveq2d breq1d ralbidv rcla4ev mp2an $.
      $( [4-May-2008] $) $( [11-Apr-2008] $)
  $}

  ${
    $d v w x y z A $.  $d v w x y z M $.  $d v w x y z N $.  $d w z U $.
    $d v w x z W $.  $d v w x y z Y $.
    minvec2.x $e |- X = ( BaseSet ` U ) $.
    minvec2.m $e |- M = ( -v ` U ) $.
    minvec2.n $e |- N = ( norm ` U ) $.
    minvecx2.y $e |- Y = ( BaseSet ` W ) $.
    minvec2.u $e |- U e. CPreHil $.
    minvec2.w $e |- W e. ( ( SubSp ` U ) i^i CBan ) $.
    minvec2.a $e |- A e. X $.
    $( Existence version of ~ minvecle . $)
    minvecex2 $p |- E. x e. Y A. y e. Y
           ( N ` ( A M x ) ) <_ ( N ` ( A M y ) ) $=
      vz vw cA vz cv cA vw cv cM co cN cfv cneg wceq vw cY wrex vz cab cr clt
      csup cneg cA vv cv cM co cN cfv vz cv cA vw cv cM co cN cfv cneg wceq vw
      cY wrex vz cab cr clt csup cneg wceq vv cY crab cuni vz cv cA vw cv cM co
      cN cfv cneg wceq vw cY wrex vz cab cU vy cM cN cW cX cY vx vv minvec2.x
      minvec2.m minvec2.n minvecx2.y vz cv cA vw cv cM co cN cfv cneg wceq vw
      cY wrex vz cab eqid vz cv cA vw cv cM co cN cfv cneg wceq vw cY wrex vz
      cab cr clt csup cneg eqid minvec2.u minvec2.w minvec2.a cA vv cv cM co cN
      cfv vz cv cA vw cv cM co cN cfv cneg wceq vw cY wrex vz cab cr clt csup
      cneg wceq vv cY crab cuni eqid minveclem39 $.
      $( [4-May-2008] $) $( [11-Apr-2008] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Complex Hilbert spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CHil $.

  $( Extend class notation with the class of all complex Hilbert spaces. $)
  chl $a class CHil $.

  $( Define the class of all complex Hilbert spaces.  A Hilbert space is a
     Banach space which is also an inner product space. $)
  df-hl $a |- CHil = ( CBan i^i CPreHil ) $.

  $( The predicate "is a complex Hilbert space."  A Hilbert space is a
     Banach space which is also an inner product space, i.e. whose norm
     satisfies the parallelogram law.  (Contributed by Steve Rodriguez,
     28-Apr-2007.) $)
  ishl $p |- ( U e. CHil <-> ( U e. CBan /\ U e. CPreHil ) ) $=
    cU chl wcel cU cbn cphl cin wcel cU cbn wcel cU cphl wcel wa chl cbn cphl
    cin cU df-hl eleq2i cU cbn cphl elin bitri $.
    $( [8-Sep-2007] $) $( [28-Apr-2007] $)

  $( Every complex Hilbert space is a complex Banach space.  (Contributed by
      Steve Rodriguez, 28-Apr-2007.) $)
  hlbn $p |- ( U e. CHil -> U e. CBan ) $=
    cU chl wcel cU cbn wcel cU cphl wcel cU ishl pm3.26bi $.
    $( [8-Sep-2007] $) $( [28-Apr-2007] $)

  $( Every complex Hilbert space is an inner product space (also called a
     pre-Hilbert space). $)
  hlph $p |- ( U e. CHil -> U e. CPreHil ) $=
    cU chl wcel cU cbn wcel cU cphl wcel cU ishl pm3.27bi $.
    $( [17-Dec-2007] $) $( [28-Apr-2007] $)

  $( The class of all complex Hilbert spaces is a relation. $)
  hlrel $p |- Rel CHil $=
    chl cbn wss cbn wrel chl wrel vx chl cbn vx cv hlbn ssriv bnrel chl cbn
    relss mp2 $.
    $( [8-Apr-2008] $) $( [17-Mar-2007] $)

  $( Every complex Hilbert space is a normed complex vector space. $)
  hlnv $p |- ( U e. CHil -> U e. NrmCVec ) $=
    cU chl wcel cU cbn wcel cU cnv wcel cU hlbn cU bnnv syl $.
    $( [9-Sep-2007] $) $( [17-Mar-2007] $)

  ${
    hlnvi.1 $e |- U e. CHil $.
    $( Every complex Hilbert space is a normed complex vector space. $)
    hlnvi $p |- U e. NrmCVec $=
      cU chl wcel cU cnv wcel hlnvi.1 cU hlnv ax-mp $.
      $( [10-Jun-2008] $) $( [6-Jun-2008] $)
  $}

  ${
    hlvc.1 $e |- W = ( 1st ` U ) $.
    $( Every complex Hilbert space is a complex vector space. $)
    hlvc $p |- ( U e. CHil -> W e. CVec ) $=
      cU chl wcel cU cnv wcel cW cvc wcel cU hlnv cU cW hlvc.1 nvvc syl $.
      $( [9-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hlcms.8 $e |- D = ( IndMet ` U ) $.
    $( The induced metric on a complex Hilbert space is complete. $)
    hlcms $p |- ( U e. CHil -> D e. CMet ) $=
      cU chl wcel cU cbn wcel cD cms wcel cU hlbn cD cU hlcms.8 bncms syl $.
      $( [16-Dec-2007] $) $( [8-Sep-2007] $)

    $( The induced metric on a complex Hilbert space. $)
    hlmet $p |- ( U e. CHil -> D e. Met ) $=
      cU chl wcel cU cnv wcel cD cme wcel cU hlnv cD cU hlcms.8 imsmet syl $.
      $( [15-Aug-2008] $) $( [7-Sep-2007] $)
  $}

  ${
    hlpar2.1 $e |- X = ( BaseSet ` U ) $.
    hlpar2.2 $e |- G = ( +v ` U ) $.
    hlpar2.3 $e |- M = ( -v ` U ) $.
    hlpar2.6 $e |- N = ( norm ` U ) $.
    $( The parallelogram law satified by Hilbert space vectors.  (Contributed
       by Steve Rodriguez, 28-Apr-2007.) $)
    hlpar2 $p |- ( ( U e. CHil /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A M B ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel cA cB cG co cN cfv c2 cexp co cA cB cM
      co cN cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp co cB cN cfv c2 cexp
      co caddc co cmul co wceq cU chl wcel cA cB cU cG cM cN cX hlpar2.1
      hlpar2.2 hlpar2.3 hlpar2.6 phpar2 cU hlph syl3an1 $.
      $( [22-May-2009] $) $( [28-Apr-2007] $)
  $}

  ${
    hlpar.1 $e |- X = ( BaseSet ` U ) $.
    hlpar.2 $e |- G = ( +v ` U ) $.
    hlpar.4 $e |- S = ( .s ` U ) $.
    hlpar.6 $e |- N = ( norm ` U ) $.
    $( The parallelogram law satified by Hilbert space vectors.  (Contributed
       by Steve Rodriguez, 28-Apr-2007.) $)
    hlpar $p |- ( ( U e. CHil /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel cA cB cG co cN cfv c2 cexp co cA c1
      cneg cB cS co cG co cN cfv c2 cexp co caddc co c2 cA cN cfv c2 cexp co cB
      cN cfv c2 cexp co caddc co cmul co wceq cU chl wcel cA cB cS cU cG cN cX
      hlpar.1 hlpar.2 hlpar.4 hlpar.6 phpar cU hlph syl3an1 $.
      $( [2-Jun-2009] $) $( [28-Apr-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Standard axioms for a complex Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    hlex.1 $e |- X = ( BaseSet ` U ) $.
    $( The base set of a Hilbert space is a set. $)
    hlex $p |- X e. _V $=
      cX cU cba cfv cvv hlex.1 cU cba fvex eqeltri $.
      $( [17-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hladdf.1 $e |- X = ( BaseSet ` U ) $.
    hladdf.2 $e |- G = ( +v ` U ) $.
    $( Mapping for Hilbert space vector addition. $)
    hladdf $p |- ( U e. CHil -> G : ( X X. X ) --> X ) $=
      cU chl wcel cU cnv wcel cX cX cxp cX cG wf cU hlnv cU cG cX hladdf.1
      hladdf.2 nvgf syl $.
      $( [17-Sep-2007] $) $( [7-Sep-2007] $)

    $( Hilbert space vector addition is commutative. $)
    hlcom $p |- ( ( U e. CHil /\ A e. X /\ B e. X ) ->
                ( A G B ) = ( B G A ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cU chl
      wcel cA cB cU cG cX hladdf.1 hladdf.2 nvcom cU hlnv syl3an1 $.
      $( [8-Sep-2007] $) $( [7-Sep-2007] $)

    $( Hilbert space vector addition is associative. $)
    hlass $p |- ( ( U e. CHil /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                   ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cU cnv wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cG co cA
      cB cC cG co cG co wceq cU chl wcel cA cB cC cU cG cX hladdf.1 hladdf.2
      nvass cU hlnv sylan $.
      $( [11-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hl0cl.1 $e |- X = ( BaseSet ` U ) $.
    hl0cl.5 $e |- Z = ( 0v ` U ) $.
    $( The Hilbert space zero vector. $)
    hl0cl $p |- ( U e. CHil -> Z e. X ) $=
      cU chl wcel cU cnv wcel cZ cX wcel cU hlnv cU cX cZ hl0cl.1 hl0cl.5 nvzcl
      syl $.
      $( [11-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hladdid.1 $e |- X = ( BaseSet ` U ) $.
    hladdid.2 $e |- G = ( +v ` U ) $.
    hladdid.5 $e |- Z = ( 0v ` U ) $.
    $( Hilbert space addition with the zero vector. $)
    hladdid $p |- ( ( U e. CHil /\ A e. X ) -> ( A G Z ) = A ) $=
      cU cnv wcel cA cX wcel cA cZ cG co cA wceq cU chl wcel cA cU cG cX cZ
      hladdid.1 hladdid.2 hladdid.5 nv0rid cU hlnv sylan $.
      $( [13-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hlmulf.1 $e |- X = ( BaseSet ` U ) $.
    hlmulf.4 $e |- S = ( .s ` U ) $.
    $( Mapping for Hilbert space scalar multiplication. $)
    hlmulf $p |- ( U e. CHil -> S : ( CC X. X ) --> X ) $=
      cU chl wcel cU cnv wcel cc cX cxp cX cS wf cU hlnv cS cU cX hlmulf.1
      hlmulf.4 nvsf syl $.
      $( [12-Dec-2007] $) $( [7-Sep-2007] $)

    $( Hilbert space scalar multiplication by one. $)
    hlmulid $p |- ( ( U e. CHil /\ A e. X ) -> ( 1 S A ) = A ) $=
      cU cnv wcel cA cX wcel c1 cA cS co cA wceq cU chl wcel cA cS cU cX
      hlmulf.1 hlmulf.4 nvsid cU hlnv sylan $.
      $( [21-Dec-2007] $) $( [7-Sep-2007] $)

    $( Hilbert space scalar multiplication associative law. $)
    hlmulass $p |- ( ( U e. CHil /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
                   ( ( A x. B ) S C ) = ( A S ( B S C ) ) ) $=
      cU cnv wcel cA cc wcel cB cc wcel cC cX wcel w3a cA cB cmul co cC cS co
      cA cB cC cS co cS co wceq cU chl wcel cA cB cC cS cU cX hlmulf.1 hlmulf.4
      nvsass cU hlnv sylan $.
      $( [21-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hldi.1 $e |- X = ( BaseSet ` U ) $.
    hldi.2 $e |- G = ( +v ` U ) $.
    hldi.4 $e |- S = ( .s ` U ) $.
    $( Hilbert space scalar multiplication distributive law. $)
    hldi $p |- ( ( U e. CHil /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
                  ( A S ( B G C ) ) = ( ( A S B ) G ( A S C ) ) ) $=
      cU cnv wcel cA cc wcel cB cX wcel cC cX wcel w3a cA cB cC cG co cS co cA
      cB cS co cA cC cS co cG co wceq cU chl wcel cA cB cC cS cU cG cX hldi.1
      hldi.2 hldi.4 nvdi cU hlnv sylan $.
      $( [15-Dec-2007] $) $( [7-Sep-2007] $)

    $( Hilbert space scalar multiplication distributive law. $)
    hldir $p |- ( ( U e. CHil /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
                  ( ( A + B ) S C ) = ( ( A S C ) G ( B S C ) ) ) $=
      cU cnv wcel cA cc wcel cB cc wcel cC cX wcel w3a cA cB caddc co cC cS co
      cA cC cS co cB cC cS co cG co wceq cU chl wcel cA cB cC cS cU cG cX
      hldi.1 hldi.2 hldi.4 nvdir cU hlnv sylan $.
      $( [22-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hlmul0.1 $e |- X = ( BaseSet ` U ) $.
    hlmul0.4 $e |- S = ( .s ` U ) $.
    hlmul0.5 $e |- Z = ( 0v ` U ) $.
    $( Hilbert space scalar multiplication by zero. $)
    hlmul0 $p |- ( ( U e. CHil /\ A e. X ) -> ( 0 S A ) = Z ) $=
      cU cnv wcel cA cX wcel cc0 cA cS co cZ wceq cU chl wcel cA cS cU cX cZ
      hlmul0.1 hlmul0.4 hlmul0.5 nv0 cU hlnv sylan $.
      $( [15-Dec-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    hlipf.1 $e |- X = ( BaseSet ` U ) $.
    hlipf.7 $e |- P = ( .i ` U ) $.
    $( Mapping for Hilbert space inner product. $)
    hlipf $p |- ( U e. CHil -> P : ( X X. X ) --> CC ) $=
      cU chl wcel cU cnv wcel cX cX cxp cc cP wf cU hlnv cP cU cX hlipf.1
      hlipf.7 ipf syl $.
      $( [16-Dec-2007] $) $( [19-Nov-2007] $)

    $( Conjugate law for Hilbert space inner product. $)
    hlipcj $p |- ( ( U e. CHil /\ A e. X /\ B e. X ) ->
                  ( A P B ) = ( * ` ( B P A ) ) ) $=
      cU chl wcel cA cX wcel cB cX wcel w3a cB cA cP co ccj cfv cA cB cP co cU
      chl wcel cB cX wcel cA cX wcel cB cA cP co ccj cfv cA cB cP co wceq cU
      cnv wcel cB cX wcel cA cX wcel cB cA cP co ccj cfv cA cB cP co wceq cU
      chl wcel cB cA cP cU cX hlipf.1 hlipf.7 ipcj cU hlnv syl3an1 3com23
      eqcomd $.
      $( [21-Dec-2007] $) $( [8-Sep-2007] $)
  $}

  ${
    hlipdir.1 $e |- X = ( BaseSet ` U ) $.
    hlipdir.2 $e |- G = ( +v ` U ) $.
    hlipdir.7 $e |- P = ( .i ` U ) $.
    $( Distributive law for Hilbert space inner product. $)
    hlipdir $p |- ( ( U e. CHil /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) ) $=
      cU cphl wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cG co cC cP co cA
      cC cP co cB cC cP co caddc co wceq cU chl wcel cA cB cC cP cU cG cX
      hlipdir.1 hlipdir.2 hlipdir.7 ipdir cU hlph sylan $.
      $( [17-Dec-2007] $) $( [8-Sep-2007] $)
  $}

  ${
    hlipass.1 $e |- X = ( BaseSet ` U ) $.
    hlipass.4 $e |- S = ( .s ` U ) $.
    hlipass.7 $e |- P = ( .i ` U ) $.
    $( Associative law for Hilbert space inner product. $)
    hlipass $p |- ( ( U e. CHil /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
                  ( ( A S B ) P C ) = ( A x. ( B P C ) ) ) $=
      cU cphl wcel cA cc wcel cB cX wcel cC cX wcel w3a cA cB cS co cC cP co cA
      cB cC cP co cmul co wceq cU chl wcel cA cB cC cP cS cU cX hlipass.1
      hlipass.4 hlipass.7 ipass cU hlph sylan $.
      $( [18-Dec-2007] $) $( [8-Sep-2007] $)
  $}

  ${
    hlipgt0.1 $e |- X = ( BaseSet ` U ) $.
    hlipgt0.5 $e |- Z = ( 0v ` U ) $.
    hlipgt0.7 $e |- P = ( .i ` U ) $.
    $( The inner product of a Hilbert space vector by itself is positive. $)
    hlipgt0 $p |- ( ( U e. CHil /\ A e. X /\  A =/= Z ) -> 0 < ( A P A ) ) $=
      cU cnv wcel cA cX wcel cA cZ wne cc0 cA cA cP co clt wbr cU chl wcel cU
      cnv wcel cA cX wcel cA cZ wne w3a cc0 cA cU cnm cfv cfv c2 cexp co cA cA
      cP co clt cA cU cnm cfv cfv cr wcel cA cU cnm cfv cfv cc0 wne cc0 cA cU
      cnm cfv cfv c2 cexp co clt wbr cU cnv wcel cA cX wcel cA cZ wne w3a cA cU
      cnm cfv cfv sqgt0 cU cnv wcel cA cX wcel cA cU cnm cfv cfv cr wcel cA cZ
      wne cA cU cU cnm cfv cX hlipgt0.1 cU cnm cfv eqid nvcl 3adant3 cU cnv
      wcel cA cX wcel cA cZ wne cA cU cnm cfv cfv cc0 wne cU cnv wcel cA cX
      wcel wa cA cU cnm cfv cfv cc0 cA cZ cU cnv wcel cA cX wcel wa cA cU cnm
      cfv cfv cc0 wceq cA cZ wceq cA cU cU cnm cfv cX cZ hlipgt0.1 hlipgt0.5 cU
      cnm cfv eqid nvz biimpd necon3d 3impia sylanc cU cnv wcel cA cX wcel cA
      cA cP co cA cU cnm cfv cfv c2 cexp co wceq cA cZ wne cA cP cU cU cnm cfv
      cX hlipgt0.1 cU cnm cfv eqid hlipgt0.7 ipid 3adant3 breqtrrd cU hlnv
      syl3an1 $.
      $( [18-Dec-2007] $) $( [8-Sep-2007] $)
  $}

  ${
    $d x D $.  $d x F $.  $d x X $.
    hlcompl.1 $e |- X = ( BaseSet ` U ) $.
    hlcompl.8 $e |- D = ( IndMet ` U ) $.
    $( Completeness of a Hilbert space. $)
    hlcompl $p |- ( ( U e. CHil /\ F e. ( Cau ` D ) ) ->
                  E. x e. X F ( ~~>m ` D ) x ) $=
      cU chl wcel cF cD cca cfv wcel wa cF vx cv cD clm cfv wbr vx cX wrex cF
      vx cv cD clm cfv wbr vx cD cdm cdm wrex cD cms wcel cF cD cca cfv wcel cF
      vx cv cD clm cfv wbr vx cD cdm cdm wrex cU chl wcel vx cD cF cD cdm cdm
      cD cdm cdm eqid cmscvg cD cU hlcompl.8 hlcms sylan cU chl wcel cF vx cv
      cD clm cfv wbr vx cX wrex cF vx cv cD clm cfv wbr vx cD cdm cdm wrex wb
      cF cD cca cfv wcel cU chl wcel cU cnv wcel cF vx cv cD clm cfv wbr vx cX
      wrex cF vx cv cD clm cfv wbr vx cD cdm cdm wrex wb cU hlnv cU cnv wcel cF
      vx cv cD clm cfv wbr vx cX cD cdm cdm cD cU cX hlcompl.1 hlcompl.8 imsba
      rexeq1d syl adantr mpbird $.
      $( [19-Dec-2007] $) $( [8-Sep-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of complex Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    cnhl.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is a complex Hilbert space.  (Contributed by
       Steve Rodriguez, 28-Apr-2007.) $)
    cnhl $p |- U e. CHil $=
      cU chl wcel cU cbn wcel cU cphl wcel cU ishl cU cnhl.6 cnbn cU cnhl.6
      cnph mpbir2an $.
      $( [22-Feb-2008] $) $( [28-Apr-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    ssphl.h $e |- H = ( SubSp ` U ) $.
    $( A Banach subspace of an inner product space is a Hilbert space. $)
    ssphl $p |- ( ( U e. CPreHil /\ W e. H /\ W e. CBan ) -> W e. CHil ) $=
      cU cphl wcel cW cH wcel cW cbn wcel w3a cW cbn wcel cW cphl wcel wa cW
      chl wcel cU cphl wcel cW cH wcel cW cbn wcel w3a cW cbn wcel cW cphl wcel
      cU cphl wcel cW cH wcel cW cbn wcel 3simp3 cU cphl wcel cW cH wcel cW
      cphl wcel cW cbn wcel cU cH cW ssphl.h sspph 3adant3 jca cW ishl sylibr
      $.
      $( [18-Apr-2008] $) $( [11-Apr-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Self-adjoint operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Hellinger-Toeplitz Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    htthlem1.1 $e |- X = ( BaseSet ` U ) $.
    htthlem1.l $e |- L = ( U LnOp U ) $.
    htthlem1.u $e |- U e. CHil $.
    htthlem1.t $e |- T e. L $.
    $( Lemma for ~ htthi .  Closure of values of an operator ` T ` on an
       auxiliary sequence of vectors ` f ` . $)
    htthlem1 $p |- ( ( f : NN --> X /\ k e. NN ) ->
            ( T ` ( f ` k ) ) e. X ) $=
      cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cX wcel vk cv vf cv cfv
      cT cfv cX wcel cn cX vk cv vf cv ffvelrn cX cX vk cv vf cv cfv cT cU cnv
      wcel cU cnv wcel cT cL wcel cX cX cT wf cU htthlem1.u hlnvi cU htthlem1.u
      hlnvi htthlem1.t cT cU cL cU cX cX htthlem1.1 htthlem1.1 htthlem1.l lnof
      mp3an ffvelrni syl $.
      $( [25-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    $d x y A $.  $d x y P $.  $d y Q $.  $d x y T $.  $d x y X $.
    htthlem2.a $e |- ( ( x e. X /\ y e. X ) ->
                  ( ( T ` x ) P y ) = ( x P ( T ` y ) ) ) $.
    $( Lemma for ~ htthi .  Elevate set variables to class variables in the
       self-adjoint hypothesis. $)
    htthlem2 $p |- ( ( A e. X /\ Q e. X ) ->
                  ( ( T ` A ) P Q ) = ( A P ( T ` Q ) ) ) $=
      vx cv cT cfv vy cv cP co vx cv vy cv cT cfv cP co wceq cA cT cfv vy cv cP
      co cA vy cv cT cfv cP co wceq cA cT cfv cQ cP co cA cQ cT cfv cP co wceq
      vx vy cA cQ cX cX vx cv cA wceq vx cv cT cfv vy cv cP co cA cT cfv vy cv
      cP co vx cv vy cv cT cfv cP co cA vy cv cT cfv cP co vx cv cA wceq vx cv
      cT cfv cA cT cfv vy cv cP vx cv cA cT fveq2 opreq1d vx cv cA vy cv cT cfv
      cP opreq1 eqeq12d vy cv cQ wceq cA cT cfv vy cv cP co cA cT cfv cQ cP co
      cA vy cv cT cfv cP co cA cQ cT cfv cP co vy cv cQ cA cT cfv cP opreq2 vy
      cv cQ wceq vy cv cT cfv cQ cT cfv cA cP vy cv cQ cT fveq2 opreq2d eqeq12d
      htthlem2.a vtocl2ga $.
      $( [25-Jan-2008] $) $( [12-Jan-2008] $)
  $}

  ${
    $d c  u v x y A $.  $d c d k z C $.  $d c d k z D $.  $d c d k z F $.
    $d c f k z N $.  $d d z O $.  $d m u v w x y P $.  $d c k u v x y Q $.
    $d c f k m u v w x y z T $.  $d c d k u v z U $.
    $d c d f k m u v w x y z X $.  $d d f k m u v w x y z $.
    htthlem3.1 $e |- X = ( BaseSet ` U ) $.
    htthlem3.p $e |- P = ( .i ` U ) $.
    htthlem3.l $e |- L = ( U LnOp U ) $.
    htthlem3.b $e |- B = ( U BLnOp U ) $.
    htthlem3.u $e |- U e. CHil $.
    htthlem3.t $e |- T e. L $.
    htthlem3.a $e |- ( ( x e. X /\ y e. X ) ->
                  ( ( T ` x ) P y ) = ( x P ( T ` y ) ) ) $.
    htthlem3.f $e |- F = { <. m , w >. | ( m e. NN /\ w = { <. v , u >. |
        ( v e. X /\ u = ( ( T ` v ) P ( f ` m ) ) ) } ) } $.
    htthlem3.c $e |- C = <. <. + , x. >. , abs >. $.
    htthlem3.d $e |- D = ( U BLnOp C ) $.
    htthlem3.n $e |- N = ( norm ` U ) $.
    htthlem3.o $e |- O = ( U normOp C ) $.
    $( Lemma for ~ htthi .  Construct an auxiliary sequence of functionals
       ` F `` k ` from inner products of the given function ` T ` and
       auxiliary vector sequence ` f ` . $)
    htthlem3 $p |- ( k e. NN -> ( F ` k ) = { <. v , u >. | ( v e. X /\
        u = ( ( T ` v ) P ( f ` k ) ) ) } ) $=
      vm vw vk cv vv cv cX wcel vu cv vv cv cT cfv vm cv vf cv cfv cP co wceq
      wa vv vu copab vv cv cX wcel vu cv vv cv cT cfv vk cv vf cv cfv cP co
      wceq wa vv vu copab cn cF vm cv vk cv wceq vv cv cX wcel vu cv vv cv cT
      cfv vm cv vf cv cfv cP co wceq wa vv cv cX wcel vu cv vv cv cT cfv vk cv
      vf cv cfv cP co wceq wa vv vu vm cv vk cv wceq vu cv vv cv cT cfv vm cv
      vf cv cfv cP co wceq vu cv vv cv cT cfv vk cv vf cv cfv cP co wceq vv cv
      cX wcel vm cv vk cv wceq vv cv cT cfv vm cv vf cv cfv cP co vv cv cT cfv
      vk cv vf cv cfv cP co vu cv vm cv vk cv wceq vm cv vf cv cfv vk cv vf cv
      cfv vv cv cT cfv cP vm cv vk cv vf cv fveq2 opreq2d eqeq2d anbi2d
      opabbidv htthlem3.f vv vu cX vv cv cT cfv vk cv vf cv cfv cP co cU cX
      htthlem3.1 hlex opabex2 fvopab4 $.
      $( [25-Jan-2008] $) $( [11-Jan-2008] $)

    $( Lemma for ~ htthi .  Value of a functional ` F `` k ` . $)
    htthlem4 $p |- ( ( A e. X /\ k e. NN ) -> ( ( F ` k ) ` A ) =
          ( ( T ` A ) P ( f ` k ) ) ) $=
      vk cv cn wcel cA cX wcel cA vk cv cF cfv cfv cA vv cv cX wcel vu cv vv cv
      cT cfv vk cv vf cv cfv cP co wceq wa vv vu copab cfv cA cT cfv vk cv vf
      cv cfv cP co vk cv cn wcel cA vk cv cF cfv vv cv cX wcel vu cv vv cv cT
      cfv vk cv vf cv cfv cP co wceq wa vv vu copab vx vy vw vv vu cB cC cD cP
      cT cU vf vk vm cF cL cN cO cX htthlem3.1 htthlem3.p htthlem3.l htthlem3.b
      htthlem3.u htthlem3.t htthlem3.a htthlem3.f htthlem3.c htthlem3.d
      htthlem3.n htthlem3.o htthlem3 fveq1d vv vu cA vv cv cT cfv vk cv vf cv
      cfv cP co cA cT cfv vk cv vf cv cfv cP co cX vv cv cX wcel vu cv vv cv cT
      cfv vk cv vf cv cfv cP co wceq wa vv vu copab vv cv cA wceq vv cv cT cfv
      cA cT cfv vk cv vf cv cfv cP vv cv cA cT fveq2 opreq1d vv cv cX wcel vu
      cv vv cv cT cfv vk cv vf cv cfv cP co wceq wa vv vu copab eqid cA cT cfv
      vk cv vf cv cfv cP oprex fvopab4 sylan9eqr $.
      $( [25-Jan-2008] $) $( [12-Jan-2008] $)

    $( Lemma for ~ htthi .  Each ` F `` k ` is a bounded linear functional
       (i.e. a bounded linear operator from the vector space to ` CC ` ). $)
    htthlem5 $p |- ( ( f : NN --> X /\ k e. NN ) -> ( F ` k ) e. D ) $=
      cn cX vf cv wf vk cv cn wcel wa vk cv cF cfv vv cv cX wcel vu cv vv cv vk
      cv vf cv cfv cT cfv cP co wceq wa vv vu copab cD cn cX vf cv wf vk cv cn
      wcel wa vk cv cF cfv vv cv cX wcel vu cv vv cv cT cfv vk cv vf cv cfv cP
      co wceq wa vv vu copab vv cv cX wcel vu cv vv cv vk cv vf cv cfv cT cfv
      cP co wceq wa vv vu copab vk cv cn wcel vk cv cF cfv vv cv cX wcel vu cv
      vv cv cT cfv vk cv vf cv cfv cP co wceq wa vv vu copab wceq cn cX vf cv
      wf vx vy vw vv vu cB cC cD cP cT cU vf vk vm cF cL cN cO cX htthlem3.1
      htthlem3.p htthlem3.l htthlem3.b htthlem3.u htthlem3.t htthlem3.a
      htthlem3.f htthlem3.c htthlem3.d htthlem3.n htthlem3.o htthlem3 adantl cn
      cX vf cv wf vk cv cn wcel wa vv cv cX wcel vu cv vv cv cT cfv vk cv vf cv
      cfv cP co wceq wa vv cv cX wcel vu cv vv cv vk cv vf cv cfv cT cfv cP co
      wceq wa vv vu cn cX vf cv wf vk cv cn wcel wa vv cv cX wcel vu cv vv cv
      cT cfv vk cv vf cv cfv cP co wceq vu cv vv cv vk cv vf cv cfv cT cfv cP
      co wceq cn cX vf cv wf vk cv cn wcel wa vv cv cX wcel wa vv cv cT cfv vk
      cv vf cv cfv cP co vv cv vk cv vf cv cfv cT cfv cP co vu cv vk cv vf cv
      cfv cX wcel vv cv cX wcel vv cv cT cfv vk cv vf cv cfv cP co vv cv vk cv
      vf cv cfv cT cfv cP co wceq cn cX vf cv wf vk cv cn wcel wa vv cv cX wcel
      vk cv vf cv cfv cX wcel vv cv cT cfv vk cv vf cv cfv cP co vv cv vk cv vf
      cv cfv cT cfv cP co wceq vx vy vv cv cP vk cv vf cv cfv cT cX htthlem3.a
      htthlem2 ancoms cn cX vk cv vf cv ffvelrn sylan eqeq2d pm5.32da opabbidv
      eqtrd cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv cX wcel vv
      cv cX wcel vu cv vv cv vk cv vf cv cfv cT cfv cP co wceq wa vv vu copab
      cD wcel cT cU vf vk cL cX htthlem3.1 htthlem3.l htthlem3.u htthlem3.t
      htthlem1 vv vu vk cv vf cv cfv cT cfv cD cC cP cU vv cv cX wcel vu cv vv
      cv vk cv vf cv cfv cT cfv cP co wceq wa vv vu copab cX htthlem3.1
      htthlem3.p cU chl wcel cU cphl wcel htthlem3.u cU hlph ax-mp htthlem3.c
      htthlem3.d vv cv cX wcel vu cv vv cv vk cv vf cv cfv cT cfv cP co wceq wa
      vv vu copab eqid ipblnfi syl eqeltrd $.
      $( [26-Jan-2008] $) $( [13-Jan-2008] $)

    $( Lemma for ~ htthi .  An upper bound of all ` F `` k ` at a given vector
       ` A ` , when the norms of auxiliary vector sequence ` f ` are all 1 or
       less. $)
    htthlem6 $p |- ( ( ( A e. X /\ ( f : NN --> X /\ k e. NN ) ) /\ ( N ` (
    f ` k ) ) <_ 1 ) -> ( abs ` ( ( F ` k ) ` A ) ) <_ ( N ` ( T ` A ) ) ) $=
      cA cX wcel cn cX vf cv wf vk cv cn wcel wa wa vk cv vf cv cfv cN cfv c1
      cle wbr wa cA vk cv cF cfv cfv cabs cfv cA cT cfv vk cv vf cv cfv cP co
      cabs cfv cA cT cfv cN cfv cle cA cX wcel cn cX vf cv wf vk cv cn wcel wa
      wa cA vk cv cF cfv cfv cabs cfv cA cT cfv vk cv vf cv cfv cP co cabs cfv
      wceq vk cv vf cv cfv cN cfv c1 cle wbr cA cX wcel vk cv cn wcel cA vk cv
      cF cfv cfv cabs cfv cA cT cfv vk cv vf cv cfv cP co cabs cfv wceq cn cX
      vf cv wf cA cX wcel vk cv cn wcel wa cA vk cv cF cfv cfv cA cT cfv vk cv
      vf cv cfv cP co cabs vx vy vw vv vu cA cB cC cD cP cT cU vf vk vm cF cL
      cN cO cX htthlem3.1 htthlem3.p htthlem3.l htthlem3.b htthlem3.u
      htthlem3.t htthlem3.a htthlem3.f htthlem3.c htthlem3.d htthlem3.n
      htthlem3.o htthlem4 fveq2d adantrl adantr cA cT cfv cX wcel vk cv vf cv
      cfv cX wcel wa vk cv vf cv cfv cN cfv c1 cle wbr cA cT cfv vk cv vf cv
      cfv cP co cabs cfv cA cT cfv cN cfv cle wbr cA cX wcel cn cX vf cv wf vk
      cv cn wcel wa wa cA cT cfv cX wcel vk cv vf cv cfv cX wcel wa vk cv vf cv
      cfv cN cfv c1 cle wbr wa cA cT cfv vk cv vf cv cfv cP co cabs cfv cA cT
      cfv cN cfv vk cv vf cv cfv cN cfv cmul co cA cT cfv cN cfv cA cT cfv cX
      wcel vk cv vf cv cfv cX wcel wa cA cT cfv vk cv vf cv cfv cP co cabs cfv
      cr wcel vk cv vf cv cfv cN cfv c1 cle wbr cA cT cfv cX wcel vk cv vf cv
      cfv cX wcel wa cA cT cfv vk cv vf cv cfv cP co cc wcel cA cT cfv vk cv vf
      cv cfv cP co cabs cfv cr wcel cU cnv wcel cA cT cfv cX wcel vk cv vf cv
      cfv cX wcel cA cT cfv vk cv vf cv cfv cP co cc wcel cU htthlem3.u hlnvi
      cA cT cfv vk cv vf cv cfv cP cU cX htthlem3.1 htthlem3.p ipcl mp3an1 cA
      cT cfv vk cv vf cv cfv cP co abscl syl adantr cA cT cfv cX wcel vk cv vf
      cv cfv cX wcel wa cA cT cfv cN cfv vk cv vf cv cfv cN cfv cmul co cr wcel
      vk cv vf cv cfv cN cfv c1 cle wbr cA cT cfv cN cfv cr wcel vk cv vf cv
      cfv cN cfv cr wcel cA cT cfv cN cfv vk cv vf cv cfv cN cfv cmul co cr
      wcel cA cT cfv cX wcel vk cv vf cv cfv cX wcel cA cT cfv cN cfv vk cv vf
      cv cfv cN cfv remulcl cU cnv wcel cA cT cfv cX wcel cA cT cfv cN cfv cr
      wcel cU htthlem3.u hlnvi cA cT cfv cU cN cX htthlem3.1 htthlem3.n nvcl
      mpan cU cnv wcel vk cv vf cv cfv cX wcel vk cv vf cv cfv cN cfv cr wcel
      cU htthlem3.u hlnvi vk cv vf cv cfv cU cN cX htthlem3.1 htthlem3.n nvcl
      mpan syl2an adantr cA cT cfv cX wcel cA cT cfv cN cfv cr wcel vk cv vf cv
      cfv cX wcel vk cv vf cv cfv cN cfv c1 cle wbr cU cnv wcel cA cT cfv cX
      wcel cA cT cfv cN cfv cr wcel cU htthlem3.u hlnvi cA cT cfv cU cN cX
      htthlem3.1 htthlem3.n nvcl mpan ad2antrr cA cT cfv cX wcel vk cv vf cv
      cfv cX wcel wa cA cT cfv vk cv vf cv cfv cP co cabs cfv cA cT cfv cN cfv
      vk cv vf cv cfv cN cfv cmul co cle wbr vk cv vf cv cfv cN cfv c1 cle wbr
      cA cT cfv vk cv vf cv cfv cP cU cN cX htthlem3.1 htthlem3.n htthlem3.p cU
      chl wcel cU cphl wcel htthlem3.u cU hlph ax-mp sii adantr cA cT cfv cX
      wcel vk cv vf cv cfv cX wcel wa vk cv vf cv cfv cN cfv c1 cle wbr wa cA
      cT cfv cN cfv vk cv vf cv cfv cN cfv cmul co cA cT cfv cN cfv c1 cmul co
      cA cT cfv cN cfv cle vk cv vf cv cfv cN cfv cr wcel cA cT cfv cN cfv cr
      wcel cc0 cA cT cfv cN cfv cle wbr wa wa vk cv vf cv cfv cN cfv c1 cle wbr
      cA cT cfv cN cfv vk cv vf cv cfv cN cfv cmul co cA cT cfv cN cfv c1 cmul
      co cle wbr cA cT cfv cX wcel vk cv vf cv cfv cX wcel wa vk cv vf cv cfv
      cN cfv cr wcel c1 cr wcel cA cT cfv cN cfv cr wcel cc0 cA cT cfv cN cfv
      cle wbr wa vk cv vf cv cfv cN cfv c1 cle wbr cA cT cfv cN cfv vk cv vf cv
      cfv cN cfv cmul co cA cT cfv cN cfv c1 cmul co cle wbr 1re vk cv vf cv
      cfv cN cfv c1 cA cT cfv cN cfv lemul2a mp3anl2 vk cv vf cv cfv cX wcel cA
      cT cfv cX wcel vk cv vf cv cfv cN cfv cr wcel cA cT cfv cN cfv cr wcel
      cc0 cA cT cfv cN cfv cle wbr wa wa vk cv vf cv cfv cX wcel vk cv vf cv
      cfv cN cfv cr wcel cA cT cfv cX wcel cA cT cfv cN cfv cr wcel cc0 cA cT
      cfv cN cfv cle wbr wa cU cnv wcel vk cv vf cv cfv cX wcel vk cv vf cv cfv
      cN cfv cr wcel cU htthlem3.u hlnvi vk cv vf cv cfv cU cN cX htthlem3.1
      htthlem3.n nvcl mpan cA cT cfv cX wcel cA cT cfv cN cfv cr wcel cc0 cA cT
      cfv cN cfv cle wbr cU cnv wcel cA cT cfv cX wcel cA cT cfv cN cfv cr wcel
      cU htthlem3.u hlnvi cA cT cfv cU cN cX htthlem3.1 htthlem3.n nvcl mpan cU
      cnv wcel cA cT cfv cX wcel cc0 cA cT cfv cN cfv cle wbr cU htthlem3.u
      hlnvi cA cT cfv cU cN cX htthlem3.1 htthlem3.n nvge0 mpan jca anim12i
      ancoms sylan cA cT cfv cX wcel cA cT cfv cN cfv c1 cmul co cA cT cfv cN
      cfv wceq vk cv vf cv cfv cX wcel vk cv vf cv cfv cN cfv c1 cle wbr cA cT
      cfv cX wcel cA cT cfv cN cfv cc wcel cA cT cfv cN cfv c1 cmul co cA cT
      cfv cN cfv wceq cA cT cfv cX wcel cA cT cfv cN cfv cU cnv wcel cA cT cfv
      cX wcel cA cT cfv cN cfv cr wcel cU htthlem3.u hlnvi cA cT cfv cU cN cX
      htthlem3.1 htthlem3.n nvcl mpan recnd cA cT cfv cN cfv ax1id syl ad2antrr
      breqtrd letrd cA cX wcel cA cT cfv cX wcel cn cX vf cv wf vk cv cn wcel
      wa vk cv vf cv cfv cX wcel cX cX cA cT cU cnv wcel cU cnv wcel cT cL wcel
      cX cX cT wf cU htthlem3.u hlnvi cU htthlem3.u hlnvi htthlem3.t cT cU cL
      cU cX cX htthlem3.1 htthlem3.1 htthlem3.l lnof mp3an ffvelrni cn cX vk cv
      vf cv ffvelrn anim12i sylan eqbrtrd $.
      $( [27-Jan-2008] $) $( [16-Jan-2008] $)

    $( Lemma for ~ htthi .  Convert upper bound in ~ htthlem6 to an existence
       condition. $)
    htthlem7 $p |- ( ( ( Q e. X /\ f : NN --> X ) /\ A. k e. NN ( N ` ( f `
    k ) ) <_ 1 ) -> E. c e. RR A. k e. NN ( abs ` ( ( F ` k ) ` Q ) ) <_ c ) $=
      cQ cT cfv cN cfv cr wcel cQ vk cv cF cfv cfv cabs cfv cQ cT cfv cN cfv
      cle wbr vk cn wral cQ vk cv cF cfv cfv cabs cfv vc cv cle wbr vk cn wral
      vc cr wrex cQ cX wcel cn cX vf cv wf wa vk cv vf cv cfv cN cfv c1 cle wbr
      vk cn wral wa cQ vk cv cF cfv cfv cabs cfv vc cv cle wbr vk cn wral cQ vk
      cv cF cfv cfv cabs cfv cQ cT cfv cN cfv cle wbr vk cn wral vc cQ cT cfv
      cN cfv cr vc cv cQ cT cfv cN cfv wceq cQ vk cv cF cfv cfv cabs cfv vc cv
      cle wbr cQ vk cv cF cfv cfv cabs cfv cQ cT cfv cN cfv cle wbr vk cn vc cv
      cQ cT cfv cN cfv cQ vk cv cF cfv cfv cabs cfv cle breq2 ralbidv rcla4ev
      cQ cX wcel cQ cT cfv cN cfv cr wcel cn cX vf cv wf vk cv vf cv cfv cN cfv
      c1 cle wbr vk cn wral cQ cX wcel cQ cT cfv cX wcel cQ cT cfv cN cfv cr
      wcel cX cX cQ cT cU cnv wcel cU cnv wcel cT cL wcel cX cX cT wf cU
      htthlem3.u hlnvi cU htthlem3.u hlnvi htthlem3.t cT cU cL cU cX cX
      htthlem3.1 htthlem3.1 htthlem3.l lnof mp3an ffvelrni cU cnv wcel cQ cT
      cfv cX wcel cQ cT cfv cN cfv cr wcel cU htthlem3.u hlnvi cQ cT cfv cU cN
      cX htthlem3.1 htthlem3.n nvcl mpan syl ad2antrr cQ cX wcel cn cX vf cv wf
      wa vk cv vf cv cfv cN cfv c1 cle wbr vk cn wral cQ vk cv cF cfv cfv cabs
      cfv cQ cT cfv cN cfv cle wbr vk cn wral cQ cX wcel cn cX vf cv wf wa vk
      cv vf cv cfv cN cfv c1 cle wbr cQ vk cv cF cfv cfv cabs cfv cQ cT cfv cN
      cfv cle wbr vk cn cQ cX wcel cn cX vf cv wf vk cv cn wcel vk cv vf cv cfv
      cN cfv c1 cle wbr cQ vk cv cF cfv cfv cabs cfv cQ cT cfv cN cfv cle wbr
      wi cQ cX wcel cn cX vf cv wf vk cv cn wcel wa wa vk cv vf cv cfv cN cfv
      c1 cle wbr cQ vk cv cF cfv cfv cabs cfv cQ cT cfv cN cfv cle wbr vx vy vw
      vv vu cQ cB cC cD cP cT cU vf vk vm cF cL cN cO cX htthlem3.1 htthlem3.p
      htthlem3.l htthlem3.b htthlem3.u htthlem3.t htthlem3.a htthlem3.f
      htthlem3.c htthlem3.d htthlem3.n htthlem3.o htthlem6 ex anassrs r19.20dva
      imp sylanc $.
      $( [27-Jan-2008] $) $( [16-Jan-2008] $)

    $( Lemma for ~ htthi . $)
    htthlem8 $p |- ( ( ( ( F ` k ) e. D /\ d e. RR /\ A e. X ) /\ ( O ` ( F
       ` k ) ) <_ d ) -> ( abs ` ( ( F ` k ) ` A ) ) <_ ( d x. ( N ` A ) ) ) $=
      vk cv cF cfv cD wcel vd cv cr wcel cA cX wcel w3a vk cv cF cfv cO cfv vd
      cv cle wbr wa cA vk cv cF cfv cfv cabs cfv vk cv cF cfv cO cfv cA cN cfv
      cmul co vd cv cA cN cfv cmul co vk cv cF cfv cD wcel vd cv cr wcel cA cX
      wcel w3a cA vk cv cF cfv cfv cabs cfv cr wcel vk cv cF cfv cO cfv vd cv
      cle wbr vk cv cF cfv cD wcel cA cX wcel cA vk cv cF cfv cfv cabs cfv cr
      wcel vd cv cr wcel vk cv cF cfv cD wcel cA cX wcel wa cA vk cv cF cfv cfv
      cc wcel cA vk cv cF cfv cfv cabs cfv cr wcel cX cc vk cv cF cfv wf cA cX
      wcel cA vk cv cF cfv cfv cc wcel vk cv cF cfv cD wcel cX cc cA vk cv cF
      cfv ffvelrn cU cnv wcel cC cnv wcel vk cv cF cfv cD wcel cX cc vk cv cF
      cfv wf cU htthlem3.u hlnvi cC htthlem3.c cnnv cD vk cv cF cfv cU cC cX cc
      htthlem3.1 cC htthlem3.c cnnvba htthlem3.d blof mp3an12 sylan cA vk cv cF
      cfv cfv abscl syl 3adant2 adantr vk cv cF cfv cD wcel vd cv cr wcel cA cX
      wcel w3a vk cv cF cfv cO cfv cA cN cfv cmul co cr wcel vk cv cF cfv cO
      cfv vd cv cle wbr vk cv cF cfv cD wcel cA cX wcel vk cv cF cfv cO cfv cA
      cN cfv cmul co cr wcel vd cv cr wcel vk cv cF cfv cO cfv cr wcel cA cN
      cfv cr wcel vk cv cF cfv cO cfv cA cN cfv cmul co cr wcel vk cv cF cfv cD
      wcel cA cX wcel vk cv cF cfv cO cfv cA cN cfv remulcl cU cnv wcel cC cnv
      wcel vk cv cF cfv cD wcel vk cv cF cfv cO cfv cr wcel cU htthlem3.u hlnvi
      cC htthlem3.c cnnv cD vk cv cF cfv cU cO cC cX cc htthlem3.1 cC
      htthlem3.c cnnvba htthlem3.o htthlem3.d nmblore mp3an12 cU cnv wcel cA cX
      wcel cA cN cfv cr wcel cU htthlem3.u hlnvi cA cU cN cX htthlem3.1
      htthlem3.n nvcl mpan syl2an 3adant2 adantr vk cv cF cfv cD wcel vd cv cr
      wcel cA cX wcel w3a vd cv cA cN cfv cmul co cr wcel vk cv cF cfv cO cfv
      vd cv cle wbr vd cv cr wcel cA cX wcel vd cv cA cN cfv cmul co cr wcel vk
      cv cF cfv cD wcel vd cv cr wcel cA cN cfv cr wcel vd cv cA cN cfv cmul co
      cr wcel cA cX wcel vd cv cA cN cfv remulcl cU cnv wcel cA cX wcel cA cN
      cfv cr wcel cU htthlem3.u hlnvi cA cU cN cX htthlem3.1 htthlem3.n nvcl
      mpan sylan2 3adant1 adantr vk cv cF cfv cD wcel vd cv cr wcel cA cX wcel
      w3a cA vk cv cF cfv cfv cabs cfv vk cv cF cfv cO cfv cA cN cfv cmul co
      cle wbr vk cv cF cfv cO cfv vd cv cle wbr vk cv cF cfv cD wcel cA cX wcel
      cA vk cv cF cfv cfv cabs cfv vk cv cF cfv cO cfv cA cN cfv cmul co cle
      wbr vd cv cr wcel cA cD vk cv cF cfv cU cN cabs cO cC cX htthlem3.1
      htthlem3.n cC htthlem3.c cnnvnm htthlem3.o htthlem3.d cU htthlem3.u hlnvi
      cC htthlem3.c cnnv nmblolbi 3adant2 adantr vk cv cF cfv cO cfv cr wcel vd
      cv cr wcel cA cN cfv cr wcel cc0 cA cN cfv cle wbr wa vk cv cF cfv cO cfv
      vd cv cle wbr vk cv cF cfv cO cfv cA cN cfv cmul co vd cv cA cN cfv cmul
      co cle wbr vk cv cF cfv cD wcel vd cv cr wcel cA cX wcel vk cv cF cfv cO
      cfv vd cv cA cN cfv lemul1a cU cnv wcel cC cnv wcel vk cv cF cfv cD wcel
      vk cv cF cfv cO cfv cr wcel cU htthlem3.u hlnvi cC htthlem3.c cnnv cD vk
      cv cF cfv cU cO cC cX cc htthlem3.1 cC htthlem3.c cnnvba htthlem3.o
      htthlem3.d nmblore mp3an12 vd cv cr wcel id cA cX wcel cA cN cfv cr wcel
      cc0 cA cN cfv cle wbr cU cnv wcel cA cX wcel cA cN cfv cr wcel cU
      htthlem3.u hlnvi cA cU cN cX htthlem3.1 htthlem3.n nvcl mpan cU cnv wcel
      cA cX wcel cc0 cA cN cfv cle wbr cU htthlem3.u hlnvi cA cU cN cX
      htthlem3.1 htthlem3.n nvge0 mpan jca syl3anl letrd $.
      $( [26-Jan-2008] $) $( [17-Jan-2008] $)

    $( Lemma for ~ htthi . $)
    htthlem9 $p |- ( ( f : NN --> X /\ k e. NN ) -> ( ( N ` ( T ` ( f `
           k ) ) ) ^ 2 ) = ( abs ` ( ( F ` k ) ` ( T ` ( f ` k ) ) ) ) ) $=
      cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv cN cfv c2 cexp co
      cabs cfv vk cv vf cv cfv cT cfv cN cfv c2 cexp co vk cv vf cv cfv cT cfv
      vk cv cF cfv cfv cabs cfv cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv
      cT cfv cX wcel vk cv vf cv cfv cT cfv cN cfv c2 cexp co cabs cfv vk cv vf
      cv cfv cT cfv cN cfv c2 cexp co wceq cT cU vf vk cL cX htthlem3.1
      htthlem3.l htthlem3.u htthlem3.t htthlem1 vk cv vf cv cfv cT cfv cN cfv
      c2 cexp co cr wcel cc0 vk cv vf cv cfv cT cfv cN cfv c2 cexp co cle wbr
      vk cv vf cv cfv cT cfv cN cfv c2 cexp co cabs cfv vk cv vf cv cfv cT cfv
      cN cfv c2 cexp co wceq vk cv vf cv cfv cT cfv cX wcel vk cv vf cv cfv cT
      cfv cN cfv c2 cexp co absid vk cv vf cv cfv cT cfv cX wcel vk cv vf cv
      cfv cT cfv cN cfv cr wcel vk cv vf cv cfv cT cfv cN cfv c2 cexp co cr
      wcel cU cnv wcel vk cv vf cv cfv cT cfv cX wcel vk cv vf cv cfv cT cfv cN
      cfv cr wcel cU htthlem3.u hlnvi vk cv vf cv cfv cT cfv cU cN cX
      htthlem3.1 htthlem3.n nvcl mpan vk cv vf cv cfv cT cfv cN cfv resqcl syl
      vk cv vf cv cfv cT cfv cX wcel vk cv vf cv cfv cT cfv cN cfv cr wcel cc0
      vk cv vf cv cfv cT cfv cN cfv c2 cexp co cle wbr cU cnv wcel vk cv vf cv
      cfv cT cfv cX wcel vk cv vf cv cfv cT cfv cN cfv cr wcel cU htthlem3.u
      hlnvi vk cv vf cv cfv cT cfv cU cN cX htthlem3.1 htthlem3.n nvcl mpan vk
      cv vf cv cfv cT cfv cN cfv sqge0 syl sylanc syl cn cX vf cv wf vk cv cn
      wcel wa vk cv vf cv cfv cT cfv cN cfv c2 cexp co vk cv vf cv cfv cT cfv
      vk cv cF cfv cfv cabs cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT
      cfv vk cv cF cfv cfv vk cv vf cv cfv cT cfv vk cv vf cv cfv cT cfv cP co
      vk cv vf cv cfv cT cfv cN cfv c2 cexp co vk cv vf cv cfv cT cfv cX wcel
      cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv vk cv cF cfv cfv
      vk cv vf cv cfv cT cfv vk cv vf cv cfv cT cfv cP co wceq cT cU vf vk cL
      cX htthlem3.1 htthlem3.l htthlem3.u htthlem3.t htthlem1 vk cv vf cv cfv
      cT cfv cX wcel cn cX vf cv wf vk cv cn wcel wa wa vk cv vf cv cfv cT cfv
      vk cv cF cfv cfv vk cv vf cv cfv cT cfv cT cfv vk cv vf cv cfv cP co vk
      cv vf cv cfv cT cfv vk cv vf cv cfv cT cfv cP co vk cv vf cv cfv cT cfv
      cX wcel vk cv cn wcel vk cv vf cv cfv cT cfv vk cv cF cfv cfv vk cv vf cv
      cfv cT cfv cT cfv vk cv vf cv cfv cP co wceq cn cX vf cv wf vx vy vw vv
      vu vk cv vf cv cfv cT cfv cB cC cD cP cT cU vf vk vm cF cL cN cO cX
      htthlem3.1 htthlem3.p htthlem3.l htthlem3.b htthlem3.u htthlem3.t
      htthlem3.a htthlem3.f htthlem3.c htthlem3.d htthlem3.n htthlem3.o
      htthlem4 adantrl vk cv vf cv cfv cT cfv cX wcel vk cv vf cv cfv cX wcel
      vk cv vf cv cfv cT cfv cT cfv vk cv vf cv cfv cP co vk cv vf cv cfv cT
      cfv vk cv vf cv cfv cT cfv cP co wceq cn cX vf cv wf vk cv cn wcel wa vx
      vy vk cv vf cv cfv cT cfv cP vk cv vf cv cfv cT cX htthlem3.a htthlem2 cn
      cX vk cv vf cv ffvelrn sylan2 eqtrd mpancom cn cX vf cv wf vk cv cn wcel
      wa vk cv vf cv cfv cT cfv cX wcel vk cv vf cv cfv cT cfv vk cv vf cv cfv
      cT cfv cP co vk cv vf cv cfv cT cfv cN cfv c2 cexp co wceq cT cU vf vk cL
      cX htthlem3.1 htthlem3.l htthlem3.u htthlem3.t htthlem1 cU cnv wcel vk cv
      vf cv cfv cT cfv cX wcel vk cv vf cv cfv cT cfv vk cv vf cv cfv cT cfv cP
      co vk cv vf cv cfv cT cfv cN cfv c2 cexp co wceq cU htthlem3.u hlnvi vk
      cv vf cv cfv cT cfv cP cU cN cX htthlem3.1 htthlem3.n htthlem3.p ipid
      mpan syl eqtr2d fveq2d eqtr3d $.
      $( [26-Jan-2008] $) $( [18-Jan-2008] $)

    $( Look at reworking triple conj in htthlem8(?) to shorten this? $)
    $( Lemma for ~ htthi . $)
    htthlem10 $p |- ( ( ( f : NN --> X /\ k e. NN ) /\ ( d e. RR /\
        ( O ` ( F ` k ) ) <_ d ) ) -> ( N ` ( T ` ( f ` k ) ) ) <_ d ) $=
      cn cX vf cv wf vk cv cn wcel wa vd cv cr wcel vk cv cF cfv cO cfv vd cv
      cle wbr wa wa vk cv vf cv cfv cT cfv cN cfv c2 cexp co vd cv vk cv vf cv
      cfv cT cfv cN cfv cmul co cle wbr vk cv vf cv cfv cT cfv cN cfv vd cv cle
      wbr cn cX vf cv wf vk cv cn wcel wa vd cv cr wcel vk cv cF cfv cO cfv vd
      cv cle wbr wa wa vk cv vf cv cfv cT cfv cN cfv c2 cexp co vk cv vf cv cfv
      cT cfv vk cv cF cfv cfv cabs cfv vd cv vk cv vf cv cfv cT cfv cN cfv cmul
      co cle cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv cN cfv c2
      cexp co vk cv vf cv cfv cT cfv vk cv cF cfv cfv cabs cfv wceq vd cv cr
      wcel vk cv cF cfv cO cfv vd cv cle wbr wa vx vy vw vv vu cB cC cD cP cT
      cU vf vk vm cF cL cN cO cX htthlem3.1 htthlem3.p htthlem3.l htthlem3.b
      htthlem3.u htthlem3.t htthlem3.a htthlem3.f htthlem3.c htthlem3.d
      htthlem3.n htthlem3.o htthlem9 adantr cn cX vf cv wf vk cv cn wcel wa vd
      cv cr wcel vk cv cF cfv cO cfv vd cv cle wbr vk cv vf cv cfv cT cfv vk cv
      cF cfv cfv cabs cfv vd cv vk cv vf cv cfv cT cfv cN cfv cmul co cle wbr
      vk cv cF cfv cD wcel vd cv cr wcel vk cv vf cv cfv cT cfv cX wcel w3a vk
      cv cF cfv cO cfv vd cv cle wbr vk cv vf cv cfv cT cfv vk cv cF cfv cfv
      cabs cfv vd cv vk cv vf cv cfv cT cfv cN cfv cmul co cle wbr cn cX vf cv
      wf vk cv cn wcel wa vd cv cr wcel wa vx vy vw vv vu vk cv vf cv cfv cT
      cfv cB cC cD cP cT cU vf vk vm cF cL cN cO cX vd htthlem3.1 htthlem3.p
      htthlem3.l htthlem3.b htthlem3.u htthlem3.t htthlem3.a htthlem3.f
      htthlem3.c htthlem3.d htthlem3.n htthlem3.o htthlem8 cn cX vf cv wf vk cv
      cn wcel wa vd cv cr wcel wa vk cv cF cfv cD wcel vd cv cr wcel vk cv vf
      cv cfv cT cfv cX wcel cn cX vf cv wf vk cv cn wcel wa vk cv cF cfv cD
      wcel vd cv cr wcel vx vy vw vv vu cB cC cD cP cT cU vf vk vm cF cL cN cO
      cX htthlem3.1 htthlem3.p htthlem3.l htthlem3.b htthlem3.u htthlem3.t
      htthlem3.a htthlem3.f htthlem3.c htthlem3.d htthlem3.n htthlem3.o
      htthlem5 adantr cn cX vf cv wf vk cv cn wcel wa vd cv cr wcel pm3.27 cn
      cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv cX wcel vd cv cr wcel
      cT cU vf vk cL cX htthlem3.1 htthlem3.l htthlem3.u htthlem3.t htthlem1
      adantr 3jca sylan anasss eqbrtrd vk cv vf cv cfv cT cfv cN cfv cr wcel
      cc0 vk cv vf cv cfv cT cfv cN cfv cle wbr vd cv cr wcel cc0 vd cv cle wbr
      vk cv vf cv cfv cT cfv cN cfv c2 cexp co vd cv vk cv vf cv cfv cT cfv cN
      cfv cmul co cle wbr vk cv vf cv cfv cT cfv cN cfv vd cv cle wbr wb cn cX
      vf cv wf vk cv cn wcel wa vd cv cr wcel vk cv cF cfv cO cfv vd cv cle wbr
      wa wa vk cv vf cv cfv cT cfv cN cfv vd cv sqlecan cn cX vf cv wf vk cv cn
      wcel wa vk cv vf cv cfv cT cfv cN cfv cr wcel vd cv cr wcel vk cv cF cfv
      cO cfv vd cv cle wbr wa cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv
      cT cfv cX wcel vk cv vf cv cfv cT cfv cN cfv cr wcel cT cU vf vk cL cX
      htthlem3.1 htthlem3.l htthlem3.u htthlem3.t htthlem1 cU cnv wcel vk cv vf
      cv cfv cT cfv cX wcel vk cv vf cv cfv cT cfv cN cfv cr wcel cU htthlem3.u
      hlnvi vk cv vf cv cfv cT cfv cU cN cX htthlem3.1 htthlem3.n nvcl mpan syl
      adantr cn cX vf cv wf vk cv cn wcel wa cc0 vk cv vf cv cfv cT cfv cN cfv
      cle wbr vd cv cr wcel vk cv cF cfv cO cfv vd cv cle wbr wa cn cX vf cv wf
      vk cv cn wcel wa vk cv vf cv cfv cT cfv cX wcel cc0 vk cv vf cv cfv cT
      cfv cN cfv cle wbr cT cU vf vk cL cX htthlem3.1 htthlem3.l htthlem3.u
      htthlem3.t htthlem1 cU cnv wcel vk cv vf cv cfv cT cfv cX wcel cc0 vk cv
      vf cv cfv cT cfv cN cfv cle wbr cU htthlem3.u hlnvi vk cv vf cv cfv cT
      cfv cU cN cX htthlem3.1 htthlem3.n nvge0 mpan syl adantr cn cX vf cv wf
      vk cv cn wcel wa vd cv cr wcel vk cv cF cfv cO cfv vd cv cle wbr simprl
      vk cv cF cfv cD wcel vd cv cr wcel vk cv cF cfv cO cfv vd cv cle wbr wa
      cc0 vd cv cle wbr cn cX vf cv wf vk cv cn wcel wa vk cv cF cfv cD wcel vd
      cv cr wcel vk cv cF cfv cO cfv vd cv cle wbr cc0 vd cv cle wbr vk cv cF
      cfv cD wcel vd cv cr wcel wa vk cv cF cfv cO cfv vd cv cle wbr cc0 vd cv
      cle wbr vk cv cF cfv cD wcel vd cv cr wcel wa cc0 vk cv cF cfv cO cfv cle
      wbr vk cv cF cfv cO cfv vd cv cle wbr cc0 vd cv cle wbr vk cv cF cfv cD
      wcel cc0 vk cv cF cfv cO cfv cle wbr vd cv cr wcel vk cv cF cfv cD wcel
      cX cc vk cv cF cfv wf cc0 vk cv cF cfv cO cfv cle wbr cU cnv wcel cC cnv
      wcel vk cv cF cfv cD wcel cX cc vk cv cF cfv wf cU htthlem3.u hlnvi cC
      htthlem3.c cnnv cD vk cv cF cfv cU cC cX cc htthlem3.1 cC htthlem3.c
      cnnvba htthlem3.d blof mp3an12 cU cnv wcel cC cnv wcel cX cc vk cv cF cfv
      wf cc0 vk cv cF cfv cO cfv cle wbr cU htthlem3.u hlnvi cC htthlem3.c cnnv
      vk cv cF cfv cU cO cC cX cc htthlem3.1 cC htthlem3.c cnnvba htthlem3.o
      nmoge0 mp3an12 syl adantr vk cv cF cfv cO cfv cr wcel vd cv cr wcel cc0
      vk cv cF cfv cO cfv cle wbr vk cv cF cfv cO cfv vd cv cle wbr wa cc0 vd
      cv cle wbr wi vk cv cF cfv cD wcel cc0 cr wcel vk cv cF cfv cO cfv cr
      wcel vd cv cr wcel cc0 vk cv cF cfv cO cfv cle wbr vk cv cF cfv cO cfv vd
      cv cle wbr wa cc0 vd cv cle wbr wi 0re cc0 vk cv cF cfv cO cfv vd cv letr
      mp3an1 cU cnv wcel cC cnv wcel vk cv cF cfv cD wcel vk cv cF cfv cO cfv
      cr wcel cU htthlem3.u hlnvi cC htthlem3.c cnnv cD vk cv cF cfv cU cO cC
      cX cc htthlem3.1 cC htthlem3.c cnnvba htthlem3.o htthlem3.d nmblore
      mp3an12 sylan mpand imp anasss vx vy vw vv vu cB cC cD cP cT cU vf vk vm
      cF cL cN cO cX htthlem3.1 htthlem3.p htthlem3.l htthlem3.b htthlem3.u
      htthlem3.t htthlem3.a htthlem3.f htthlem3.c htthlem3.d htthlem3.n
      htthlem3.o htthlem5 sylan syl2anc mpbid $.
      $( [26-Jan-2008] $) $( [18-Jan-2008] $)

    $( Lemma for ~ htthi .  Use the Uniform Boundedness Theorem ~ ubthi to show
       that the functional ` F `` k ` is bounded. $)
    htthlem11 $p |- ( ( f : NN --> X /\ A. k e. NN ( N ` ( f ` k ) ) <_ 1 )
          -> E. d e. RR A. k e. NN ( O ` ( F ` k ) ) <_ d ) $=
      cn cD cF wf vz cv vk cv cF cfv cfv cabs cfv vc cv cle wbr vk cn wral vc
      cr wrex vz cX wral vk cv cF cfv cO cfv vd cv cle wbr vk cn wral vd cr
      wrex cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk cn wral wa vz cD
      cF cU vk cabs cO cC cX vc vd htthlem3.1 cC htthlem3.c cnnvnm htthlem3.o
      htthlem3.d cU chl wcel cU cbn wcel htthlem3.u cU hlbn ax-mp cC htthlem3.c
      cnnv ubthi cn cX vf cv wf cn cD cF wf vk cv vf cv cfv cN cfv c1 cle wbr
      vk cn wral cn cX vf cv wf cF cn wfn vk cv cF cfv cD wcel vk cn wral wa cn
      cD cF wf cn cX vf cv wf cF cn wfn vk cv cF cfv cD wcel vk cn wral cF cn
      wfn cn cX vf cv wf vm vw cn vv cv cX wcel vu cv vv cv cT cfv vm cv vf cv
      cfv cP co wceq wa vv vu copab cF vv vu cX vv cv cT cfv vm cv vf cv cfv cP
      co cX cU cba cfv cvv htthlem3.1 cU cba fvex eqeltri opabex2 htthlem3.f
      fnopab2 a1i cn cX vf cv wf vk cv cF cfv cD wcel vk cn vx vy vw vv vu cB
      cC cD cP cT cU vf vk vm cF cL cN cO cX htthlem3.1 htthlem3.p htthlem3.l
      htthlem3.b htthlem3.u htthlem3.t htthlem3.a htthlem3.f htthlem3.c
      htthlem3.d htthlem3.n htthlem3.o htthlem5 r19.21aiva jca vk cn cD cF
      ffnfv sylibr adantr cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk
      cn wral wa vz cv vk cv cF cfv cfv cabs cfv vc cv cle wbr vk cn wral vc cr
      wrex vz cX cn cX vf cv wf vz cv cX wcel vk cv vf cv cfv cN cfv c1 cle wbr
      vk cn wral vz cv vk cv cF cfv cfv cabs cfv vc cv cle wbr vk cn wral vc cr
      wrex vz cv cX wcel cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk cn
      wral vz cv vk cv cF cfv cfv cabs cfv vc cv cle wbr vk cn wral vc cr wrex
      vx vy vw vv vu cB cC cD cP vz cv cT cU vf vk vm cF cL cN cO cX vc
      htthlem3.1 htthlem3.p htthlem3.l htthlem3.b htthlem3.u htthlem3.t
      htthlem3.a htthlem3.f htthlem3.c htthlem3.d htthlem3.n htthlem3.o
      htthlem7 ancom1s an1rs r19.21aiva sylanc $.
      $( [27-Jan-2008] $) $( [16-Jan-2008] $)

    $( Lemma for ~ htthi .  Linear operator ` T ` is bounded. $)
    htthlem12 $p |- T e. B $=
      cT cB wcel cT cL wcel cT cU cU cnmo co cfv cr wcel cU cnv wcel cU cnv
      wcel cT cB wcel cT cL wcel cT cU cU cnmo co cfv cr wcel wa wb cU
      htthlem3.u hlnvi cU htthlem3.u hlnvi cB cT cU cL cU cU cnmo co cU cU cU
      cnmo co eqid htthlem3.l htthlem3.b isblo2 mp2an htthlem3.t cX cX cT wf cn
      cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk cn wral wa vk cv vf cv
      cfv cT cfv cN cfv vk cv cle wbr vk cn wrex wi vf wal wa cT cU cU cnmo co
      cfv cr wcel cX cX cT wf cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr
      vk cn wral wa vk cv vf cv cfv cT cfv cN cfv vk cv cle wbr vk cn wrex wi
      vf wal cU cnv wcel cU cnv wcel cT cL wcel cX cX cT wf cU htthlem3.u hlnvi
      cU htthlem3.u hlnvi htthlem3.t cT cU cL cU cX cX htthlem3.1 htthlem3.1
      htthlem3.l lnof mp3an cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk
      cn wral wa vk cv vf cv cfv cT cfv cN cfv vk cv cle wbr vk cn wrex wi vf
      cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk cn wral wa vk cv vf
      cv cfv cT cfv cN cfv cr wcel vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr
      wa vk cn wral vz cr wrex vk cv vf cv cfv cT cfv cN cfv vk cv cle wbr vk
      cn wrex cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr vk cn wral wa vk
      cv vf cv cfv cT cfv cN cfv vz cv cle wbr vk cn wral vz cr wrex vk cv vf
      cv cfv cT cfv cN cfv cr wcel vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr
      wa vk cn wral vz cr wrex cn cX vf cv wf vk cv vf cv cfv cN cfv c1 cle wbr
      vk cn wral wa vk cv cF cfv cO cfv vz cv cle wbr vk cn wral vz cr wrex vk
      cv vf cv cfv cT cfv cN cfv vz cv cle wbr vk cn wral vz cr wrex vx vy vw
      vv vu cB cC cD cP cT cU vf vk vm cF cL cN cO cX vz htthlem3.1 htthlem3.p
      htthlem3.l htthlem3.b htthlem3.u htthlem3.t htthlem3.a htthlem3.f
      htthlem3.c htthlem3.d htthlem3.n htthlem3.o htthlem11 cn cX vf cv wf vk
      cv cF cfv cO cfv vz cv cle wbr vk cn wral vz cr wrex vk cv vf cv cfv cT
      cfv cN cfv vz cv cle wbr vk cn wral vz cr wrex wi vk cv vf cv cfv cN cfv
      c1 cle wbr vk cn wral cn cX vf cv wf vk cv cF cfv cO cfv vz cv cle wbr vk
      cn wral vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr vk cn wral vz cr cn
      cX vf cv wf vz cv cr wcel wa vk cv cF cfv cO cfv vz cv cle wbr vk cv vf
      cv cfv cT cfv cN cfv vz cv cle wbr vk cn cn cX vf cv wf vk cv cn wcel vz
      cv cr wcel vk cv cF cfv cO cfv vz cv cle wbr vk cv vf cv cfv cT cfv cN
      cfv vz cv cle wbr wi cn cX vf cv wf vk cv cn wcel wa vz cv cr wcel vk cv
      cF cfv cO cfv vz cv cle wbr vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr
      wi cn cX vf cv wf vk cv cn wcel wa vz cv cr wcel vk cv cF cfv cO cfv vz
      cv cle wbr vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr vx vy vw vv vu cB
      cC cD cP cT cU vf vk vm cF cL cN cO cX vz htthlem3.1 htthlem3.p
      htthlem3.l htthlem3.b htthlem3.u htthlem3.t htthlem3.a htthlem3.f
      htthlem3.c htthlem3.d htthlem3.n htthlem3.o htthlem10 exp32 imp an1rs
      r19.20dva r19.22dva adantr mpd cn cX vf cv wf vk cv vf cv cfv cT cfv cN
      cfv vz cv cle wbr vk cn wral vz cr wrex vk cv vf cv cfv cT cfv cN cfv cr
      wcel vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr wa vk cn wral vz cr wrex
      wi vk cv vf cv cfv cN cfv c1 cle wbr vk cn wral cn cX vf cv wf vk cv vf
      cv cfv cT cfv cN cfv vz cv cle wbr vk cn wral vk cv vf cv cfv cT cfv cN
      cfv cr wcel vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr wa vk cn wral vz
      cr cn cX vf cv wf vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr vk cv vf cv
      cfv cT cfv cN cfv cr wcel vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr wa
      vk cn cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv cN cfv vz cv
      cle wbr vk cv vf cv cfv cT cfv cN cfv cr wcel vk cv vf cv cfv cT cfv cN
      cfv vz cv cle wbr wa cn cX vf cv wf vk cv cn wcel wa vk cv vf cv cfv cT
      cfv cN cfv cr wcel vk cv vf cv cfv cT cfv cN cfv vz cv cle wbr cn cX vf
      cv wf vk cv cn wcel wa vk cv vf cv cfv cT cfv cX wcel vk cv vf cv cfv cT
      cfv cN cfv cr wcel cT cU vf vk cL cX htthlem3.1 htthlem3.l htthlem3.u
      htthlem3.t htthlem1 cU cnv wcel vk cv vf cv cfv cT cfv cX wcel vk cv vf
      cv cfv cT cfv cN cfv cr wcel cU htthlem3.u hlnvi vk cv vf cv cfv cT cfv
      cU cN cX htthlem3.1 htthlem3.n nvcl mpan syl anim1i ex r19.20dva
      r19.22sdv adantr mpd vz vk cv vf cv cfv cT cfv cN cfv vk bndndx syl
      ax-gen pm3.2i cT cU vf vk cN cN cU cU cnmo co cU cX cX htthlem3.1
      htthlem3.1 htthlem3.n htthlem3.n cU cU cnmo co eqid cU htthlem3.u hlnvi
      cU htthlem3.u hlnvi nmobndseqi ax-mp mpbir2an $.
      $( [27-Jan-2008] $) $( [18-Jan-2008] $)
  $}

  ${
    $d m u v w x y P $.  $d f m u v w x y T $.  $d f u v U $.
    $d f m u v w x y X $.
    htthi.1 $e |- X = ( BaseSet ` U ) $.
    htthi.p $e |- P = ( .i ` U ) $.
    htthi.l $e |- L = ( U LnOp U ) $.
    htthi.b $e |- B = ( U BLnOp U ) $.
    htthi.u $e |- U e. CHil $.
    htthi.t $e |- T e. L $.
    htthi.a $e |- ( ( x e. X /\ y e. X ) ->
                  ( ( T ` x ) P y ) = ( x P ( T ` y ) ) ) $.
    $( Hellinger-Toeplitz Theorem:  any self-adjoint linear operator defined on
       all of Hilbert space is bounded.  Theorem 10.1-1 of [Kreyszig] p. 525.
       Discovered by E. Hellinger and O. Toeplitz in 1910, "it aroused both
       admiration and puzzlement since the theorem establishes a relation
       between properties of two different kinds, namely, the properties of
       being defined everywhere and being bounded." $)
    htthi $p |- T e. B $=
      vx vy vw vv vu cB caddc cmul cop cabs cop cU caddc cmul cop cabs cop cblo
      co cP cT cU vf vm vm cv cn wcel vw cv vv cv cX wcel vu cv vv cv cT cfv vm
      cv vf cv cfv cP co wceq wa vv vu copab wceq wa vm vw copab cL cU cnm cfv
      cU caddc cmul cop cabs cop cnmo co cX htthi.1 htthi.p htthi.l htthi.b
      htthi.u htthi.t htthi.a vm cv cn wcel vw cv vv cv cX wcel vu cv vv cv cT
      cfv vm cv vf cv cfv cP co wceq wa vv vu copab wceq wa vm vw copab eqid
      caddc cmul cop cabs cop eqid cU caddc cmul cop cabs cop cblo co eqid cU
      cnm cfv eqid cU caddc cmul cop cabs cop cnmo co eqid htthlem12 $.
      $( [27-Jan-2008] $) $( [11-Jan-2008] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                         Posets and lattices
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Poset $.
  $c supw $.
  $c infw $.
  $c join $.
  $c meet $.
  $c Lat $.

  $( Extend class notation with the class of all posets. $)
  cps $a class Poset $.

  $( Extend class notation with the supremum of an ordered set. $)
  cspw $a class supw $.

  $( Extend class notation with the infimum of an ordered set. $)
  cinf $a class infw $.

  $( Extend class notation with the join of two ordered sets. $)
  cjn $a class join $.

  $( Extend class notation with the meet of two ordered sets. $)
  cmee $a class meet $.

  $( Extend class notation with the class of all lattices. $)
  cla $a class Lat $.

  $( Define the class of all posets (partially ordered sets) with weak
     ordering (e.g. "less than or equal to" instead of "less than").  A poset
     is a relation which is transitive, reflexive, and antisymmetric. $)
  df-ps $a |- Poset = { r | ( Rel r /\ ( r o. r ) C_ r /\
              ( r i^i `' r ) = ( _I |` U. U. r ) ) } $.

  ${
    $d r x y z w v u $.
    $( Define suprema under weak orderings.  Unlike ~ df-sup for
       strong orderings, ` supw ` is evaluates to a member of the field of
       ` R ` iff the supremum exists.  Read ` R supw A ` as the ` R ` -supremum
       of set ` A ` . $)
    df-spw $a |- supw = { <. <. r , x >. , y >. | E. z ( z = { w e. U. U. r |
       ( A. v e. x v r w /\ A. v e. U. U. r ( A. u e. x u r v -> w r v ) ) } /\
      y = if ( z =/= (/) , U. z , ~P U. U. U. r ) ) } $.

    $( Define the class of all infima of a weak ordering relation. $)
    df-nfw $a |- infw = { <. <. r , x >. , y >. | y = ( `' r supw x ) } $.

    $( Define the class of all join operations on weak orderings. $)
    df-jn $a |- join = { <. r , w >. | w = { <. <. x , y >. , z >. |
        ( ( x e. U. U. r /\ y e. U. U. r ) /\
          z = ( r supw { x , y } ) ) } } $.

    $( Define the class of all meet operations on weak orderings. $)
    df-mee $a |- meet = { <. r , w >. | w = { <. <. x , y >. , z >. |
        ( ( x e. U. U. r /\ y e. U. U. r ) /\
          z = ( r infw { x , y } ) ) } } $.

    $( Define the class of all lattices, which are posets in which every two
       elements have upper and lower bounds. $)
    df-la $a |- Lat = { r e. Poset | A. x e. dom r A. y e. dom r
        ( ( r supw { x , y } ) e. dom r /\ ( r infw { x , y } ) e. dom r ) } $.
  $}

  ${
    $d r x y R $.
    $( The predicate "is a poset" i.e. a transitive, reflexive,
       antisymmetric relation. $)
    isps $p |- ( R e. A -> ( R e. Poset <-> ( Rel R /\ ( R o. R ) C_ R /\
                ( R i^i `' R ) = ( _I |` U. U. R ) ) ) ) $=
      vr cv wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccnv cin cid vr cv cuni
      cuni cres wceq w3a cR wrel cR cR ccom cR wss cR cR ccnv cin cid cR cuni
      cuni cres wceq w3a vr cR cps cA vr cv cR wceq vr cv wrel cR wrel vr cv vr
      cv ccom vr cv wss cR cR ccom cR wss vr cv vr cv ccnv cin cid vr cv cuni
      cuni cres wceq cR cR ccnv cin cid cR cuni cuni cres wceq vr cv cR releq
      vr cv cR wceq vr cv vr cv ccom cR cR ccom vr cv cR vr cv cR wceq vr cv vr
      cv ccom cR vr cv ccom cR cR ccom vr cv cR vr cv coeq1 vr cv cR cR coeq2
      eqtrd vr cv cR wceq id sseq12d vr cv cR wceq vr cv vr cv ccnv cin cR cR
      ccnv cin cid vr cv cuni cuni cres cid cR cuni cuni cres vr cv cR wceq vr
      cv cR vr cv ccnv cR ccnv vr cv cR wceq id vr cv cR cnveq ineq12d vr cv cR
      wceq vr cv cuni cuni cR cuni cuni wceq cid vr cv cuni cuni cres cid cR
      cuni cuni cres wceq vr cv cR wceq vr cv cuni cR cuni vr cv cR unieq
      unieqd vr cv cuni cuni cR cuni cuni cid reseq2 syl eqeq12d 3anbi123d vr
      df-ps elab2g $.
      $( [15-May-2008] $) $( [11-May-2008] $)
  $}

  $( A poset is a relation. $)
  psrel $p |- ( A e. Poset -> Rel A ) $=
    cA cps wcel cA wrel cA cA ccom cA wss cA cA ccnv cin cid cA cuni cuni cres
    wceq w3a cA wrel cA cps wcel cA wrel cA cA ccom cA wss cA cA ccnv cin cid
    cA cuni cuni cres wceq w3a cps cA isps ibi cA wrel cA cA ccom cA wss cA cA
    ccnv cin cid cA cuni cuni cres wceq 3simp1 syl $.
    $( [16-May-2008] $) $( [12-May-2008] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    $( Lemma for ~ psref and others. $)
    pslem $p |- ( R e. Poset -> ( ( A e. S /\ B e. T /\ C e. U )
       -> ( ( ( A R B /\ B R C ) -> A R C ) /\ ( ( A e. U. U. R -> A R A ) /\ (
      ( A R B /\ B R A ) -> A = B ) ) ) ) ) $=
      cR cps wcel cR wrel cR cR ccom cR wss cR cR ccnv cin cid cR cuni cuni
      cres wceq w3a cA cS wcel cB cT wcel cC cU wcel w3a cA cB cR wbr cB cC cR
      wbr wa cA cC cR wbr wi cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr
      cB cA cR wbr wa cA cB wceq wi wa wa wi cR cps wcel cR wrel cR cR ccom cR
      wss cR cR ccnv cin cid cR cuni cuni cres wceq w3a cps cR isps ibi cR cR
      ccom cR wss cR cR ccnv cin cid cR cuni cuni cres wceq cA cS wcel cB cT
      wcel cC cU wcel w3a cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi cA cR
      cuni cuni wcel cA cA cR wbr wi cA cB cR wbr cB cA cR wbr wa cA cB wceq wi
      wa wa wi cR wrel vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi vz wal vy wal vx wal vx cv vx cv cR wbr vx cR cuni cuni wral vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq wi vy wal vx wal wa
      cA cS wcel cB cT wcel cC cU wcel w3a cA cB cR wbr cB cC cR wbr wa cA cC
      cR wbr wi cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr cB cA cR wbr
      wa cA cB wceq wi wa wa wi cR cR ccom cR wss cR cR ccnv cin cid cR cuni
      cuni cres wceq cA cS wcel cB cT wcel cC cU wcel w3a vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal vx cv vx cv
      cR wbr vx cR cuni cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx
      cv vy cv wceq wi vy wal vx wal wa wa cA cB cR wbr cB cC cR wbr wa cA cC
      cR wbr wi cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr cB cA cR wbr
      wa cA cB wceq wi wa wa cA cS wcel cB cT wcel cC cU wcel w3a vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal
      cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi vx cv vx cv cR wbr vx cR
      cuni cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx cv vy cv wceq
      wi vy wal vx wal wa cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr cB
      cA cR wbr wa cA cB wceq wi wa vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx
      cv vz cv cR wbr wi cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi vx vy vz
      cA cB cC cS cT cU vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a vx cv vy
      cv cR wbr vy cv vz cv cR wbr wa cA cB cR wbr cB cC cR wbr wa vx cv vz cv
      cR wbr cA cC cR wbr vx cv cA wceq vy cv cB wceq vz cv cC wceq w3a vx cv
      vy cv cR wbr cA cB cR wbr vy cv vz cv cR wbr cB cC cR wbr vx cv cA wceq
      vy cv cB wceq vx cv vy cv cR wbr cA cB cR wbr wb vz cv cC wceq vx cv cA
      vy cv cB cR breq12 3adant3 vy cv cB wceq vz cv cC wceq vy cv vz cv cR wbr
      cB cC cR wbr wb vx cv cA wceq vy cv cB vz cv cC cR breq12 3adant1 anbi12d
      vx cv cA wceq vz cv cC wceq vx cv vz cv cR wbr cA cC cR wbr wb vy cv cB
      wceq vx cv cA vz cv cC cR breq12 3adant2 imbi12d cla43gv cA cS wcel cB cT
      wcel vx cv vx cv cR wbr vx cR cuni cuni wral vx cv vy cv cR wbr vy cv vx
      cv cR wbr wa vx cv vy cv wceq wi vy wal vx wal wa cA cR cuni cuni wcel cA
      cA cR wbr wi cA cB cR wbr cB cA cR wbr wa cA cB wceq wi wa wi cC cU wcel
      cA cS wcel cB cT wcel wa vx cv vx cv cR wbr vx cR cuni cuni wral cA cR
      cuni cuni wcel cA cA cR wbr wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa
      vx cv vy cv wceq wi vy wal vx wal cA cB cR wbr cB cA cR wbr wa cA cB wceq
      wi vx cv vx cv cR wbr vx cR cuni cuni wral cA cR cuni cuni wcel cA cA cR
      wbr wi wi cA cS wcel cB cT wcel wa vx cv vx cv cR wbr cA cA cR wbr vx cA
      cR cuni cuni vx cv cA wceq vx cv vx cv cR wbr cA cA cR wbr wb vx cv cA vx
      cv cA cR breq12 anidms rcla4cv a1i vx cv vy cv cR wbr vy cv vx cv cR wbr
      wa vx cv vy cv wceq wi cA cB cR wbr cB cA cR wbr wa cA cB wceq wi vx vy
      cA cB cS cT vx cv cA wceq vy cv cB wceq wa vx cv vy cv cR wbr vy cv vx cv
      cR wbr wa cA cB cR wbr cB cA cR wbr wa vx cv vy cv wceq cA cB wceq vx cv
      cA wceq vy cv cB wceq wa vx cv vy cv cR wbr cA cB cR wbr vy cv vx cv cR
      wbr cB cA cR wbr vx cv cA vy cv cB cR breq12 vy cv cB wceq vx cv cA wceq
      vy cv vx cv cR wbr cB cA cR wbr wb vy cv cB vx cv cA cR breq12 ancoms
      anbi12d vx cv cA vy cv cB eqeq12 imbi12d cla42gv anim12d 3adant3 anim12d
      com12 vx vy vz cR cotr vx vy cR asymref2 syl2anb 3adant1 syl $.
      $( [15-May-2008] $) $( [12-May-2008] $)

    $( The domain and range of a poset equal its field. $)
    psdmrn $p |- ( R e. Poset -> ( dom R = U. U. R /\ ran R = U. U. R ) ) $=
      cR cps wcel cR cdm cR cuni cuni wceq cR crn cR cuni cuni wceq cR cps wcel
      cR cdm cR cuni cuni cR cdm cR cuni cuni wss cR cps wcel cR cdm cR cdm cR
      crn cun cR cuni cuni cR cdm cR crn ssun1 cR dmrnssfld sstri a1i cR cps
      wcel vx cR cuni cuni cR cdm cR cps wcel vx cv cR cuni cuni wcel vx cv vx
      cv cR wbr vx cv cR cdm wcel cR cps wcel vx cv cR cuni cuni wcel vx cv vx
      cv cR wbr cR cps wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx
      cv vx cv cR wbr wi cR cps wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni
      wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi wi cR cps wcel vx cv
      cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv
      cR cuni cuni wcel vx cv vx cv cR wbr wi cR cps wcel vx cv cR cuni cuni
      wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel w3a vx cv vx cv cR
      wbr vx cv vx cv cR wbr wa vx cv vx cv cR wbr wi vx cv cR cuni cuni wcel
      vx cv vx cv cR wbr wi vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx
      cv wceq wi wa wa vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx
      cv vx cv cR cR cuni cuni cR cuni cuni cR cuni cuni pslem vx cv vx cv cR
      wbr vx cv vx cv cR wbr wa vx cv vx cv cR wbr wi vx cv cR cuni cuni wcel
      vx cv vx cv cR wbr wi vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx
      cv wceq wi simprl syl6 3expd pm2.43d pm2.43d pm2.43d vx cv vx cv cR vx
      visset breldm syl6 ssrdv eqssd cR cps wcel cR crn cR cuni cuni cR crn cR
      cuni cuni wss cR cps wcel cR crn cR cdm cR crn cun cR cuni cuni cR crn cR
      cdm ssun2 cR dmrnssfld sstri a1i cR cps wcel vx cR cuni cuni cR crn cR
      cps wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr vx cv cR crn wcel cR
      cps wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr cR cps wcel vx cv cR
      cuni cuni wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi cR cps wcel
      vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel
      vx cv vx cv cR wbr wi wi cR cps wcel vx cv cR cuni cuni wcel vx cv cR
      cuni cuni wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vx
      cv cR wbr wi cR cps wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel
      vx cv cR cuni cuni wcel w3a vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx
      cv vx cv cR wbr wi vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx
      cv cR wbr vx cv vx cv cR wbr wa vx cv vx cv wceq wi wa wa vx cv cR cuni
      cuni wcel vx cv vx cv cR wbr wi vx cv vx cv vx cv cR cR cuni cuni cR cuni
      cuni cR cuni cuni pslem vx cv vx cv cR wbr vx cv vx cv cR wbr wa vx cv vx
      cv cR wbr wi vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx cv cR
      wbr vx cv vx cv cR wbr wa vx cv vx cv wceq wi simprl syl6 3expd pm2.43d
      pm2.43d pm2.43d vx cv vx cv cR vx visset vx visset brelrn syl6 ssrdv
      eqssd jca $.
      $( [19-May-2008] $) $( [13-May-2008] $)
  $}

  ${
    psref.1 $e |- X = dom R $.
    $( A poset is reflexive. $)
    psref $p |- ( ( R e. Poset /\ A e. X ) -> A R A ) $=
      cR cps wcel cA cX wcel cA cA cR wbr cR cps wcel cA cX wcel cA cR cuni
      cuni wcel cA cA cR wbr cR cps wcel cX cR cuni cuni cA cR cps wcel cR cdm
      cR cuni cuni cX cR cps wcel cR cdm cR cuni cuni wceq cR crn cR cuni cuni
      wceq cR psdmrn pm3.26d psref.1 syl5eq eleq2d cR cps wcel cA cR cuni cuni
      wcel cA cA cR wbr cR cps wcel cA cR cuni cuni wcel cA cR cuni cuni wcel
      cA cA cR wbr wi cR cps wcel cA cR cuni cuni wcel cA cR cuni cuni wcel cA
      cR cuni cuni wcel cA cA cR wbr wi wi cR cps wcel cA cR cuni cuni wcel cA
      cR cuni cuni wcel cA cR cuni cuni wcel cA cR cuni cuni wcel cA cA cR wbr
      wi cR cps wcel cA cR cuni cuni wcel cA cR cuni cuni wcel cA cR cuni cuni
      wcel w3a cA cA cR wbr cA cA cR wbr wa cA cA cR wbr wi cA cR cuni cuni
      wcel cA cA cR wbr wi cA cA cR wbr cA cA cR wbr wa cA cA wceq wi wa wa cA
      cR cuni cuni wcel cA cA cR wbr wi cA cA cA cR cR cuni cuni cR cuni cuni
      cR cuni cuni pslem cA cA cR wbr cA cA cR wbr wa cA cA cR wbr wi cA cR
      cuni cuni wcel cA cA cR wbr wi cA cA cR wbr cA cA cR wbr wa cA cA wceq wi
      simprl syl6 3expd pm2.43d pm2.43d pm2.43d sylbid imp $.
      $( [21-May-2008] $) $( [13-May-2008] $)

    $( The range of a poset equals it domain. $)
    psrn $p |- ( R e. Poset -> X = ran R ) $=
      cR cps wcel cR cdm cR crn cX cR cps wcel cR cdm cR cuni cuni wceq cR crn
      cR cuni cuni wceq wa cR cdm cR crn wceq cR psdmrn cR cdm cR crn cR cuni
      cuni eqtr3 syl psref.1 syl5eq $.
      $( [30-Jul-2008] $) $( [7-Jul-2008] $)
  $}

  $( A poset is antisymmetric. $)
  psasym $p |- ( ( R e. Poset /\ A R B /\ B R A ) -> A = B ) $=
    cR cps wcel cA cvv wcel cB cvv wcel cB cvv wcel w3a cA cB cR wbr cB cA cR
    wbr wa cA cB wceq cR cps wcel cA cB cR wbr cB cA cR wbr w3a cR cps wcel cA
    cvv wcel cB cvv wcel cB cvv wcel w3a cA cB cR wbr cB cA cR wbr wa cA cB
    wceq cR cps wcel cA cvv wcel cB cvv wcel cB cvv wcel w3a cA cB cR wbr cB cB
    cR wbr wa cA cB cR wbr wi cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr
    cB cA cR wbr wa cA cB wceq wi wa wa cA cB cR wbr cB cA cR wbr wa cA cB wceq
    wi cA cB cB cR cvv cvv cvv pslem cA cB cR wbr cB cB cR wbr wa cA cB cR wbr
    wi cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr cB cA cR wbr wa cA cB
    wceq wi simprr syl6 3imp cR cps wcel cA cB cR wbr cB cA cR wbr 3simp1 cR
    wrel cA cB cR wbr cB cA cR wbr cA cvv wcel cB cvv wcel cB cvv wcel w3a cR
    cps wcel cR wrel cA cB cR wbr cB cA cR wbr w3a cA cvv wcel cB cvv wcel cB
    cvv wcel cR wrel cA cB cR wbr cA cvv wcel cB cA cR wbr cA cB cR brrelex
    3adant3 cR wrel cB cA cR wbr cB cvv wcel cA cB cR wbr cB cA cR brrelex
    3adant2 cR wrel cB cA cR wbr cB cvv wcel cA cB cR wbr cB cA cR brrelex
    3adant2 3jca cR psrel syl3an1 cR cps wcel cA cB cR wbr cB cA cR wbr 3simpc
    syl3anc $.
    $( [16-May-2008] $) $( [12-May-2008] $)

  $( A poset is transitive. $)
  pstr $p |- ( ( R e. Poset /\ A R B /\ B R C ) -> A R C ) $=
    cR cps wcel cA cB cR wbr cB cC cR wbr w3a cC cvv wcel cA cC cR wbr cR cps
    wcel cA cvv wcel cB cvv wcel cC cvv wcel w3a cA cB cR wbr cB cC cR wbr wa
    cA cC cR wbr cR cps wcel cA cB cR wbr cB cC cR wbr w3a cC cvv wcel wa cR
    cps wcel cA cvv wcel cB cvv wcel cC cvv wcel w3a cA cB cR wbr cB cC cR wbr
    wa cA cC cR wbr cR cps wcel cA cvv wcel cB cvv wcel cC cvv wcel w3a cA cB
    cR wbr cB cC cR wbr wa cA cC cR wbr wi cA cR cuni cuni wcel cA cA cR wbr wi
    cA cB cR wbr cB cA cR wbr wa cA cB wceq wi wa wa cA cB cR wbr cB cC cR wbr
    wa cA cC cR wbr wi cA cB cC cR cvv cvv cvv pslem cA cB cR wbr cB cC cR wbr
    wa cA cC cR wbr wi cA cR cuni cuni wcel cA cA cR wbr wi cA cB cR wbr cB cA
    cR wbr wa cA cB wceq wi wa pm3.26 syl6 3imp cR cps wcel cA cB cR wbr cB cC
    cR wbr w3a cR cps wcel cC cvv wcel cR cps wcel cA cB cR wbr cB cC cR wbr
    3simp1 adantr cR wrel cA cB cR wbr cB cC cR wbr cC cvv wcel cA cvv wcel cB
    cvv wcel cC cvv wcel w3a cR cps wcel cR wrel cA cB cR wbr cB cC cR wbr w3a
    cC cvv wcel wa cA cvv wcel cB cvv wcel cC cvv wcel cR wrel cA cB cR wbr cB
    cC cR wbr w3a cA cvv wcel cC cvv wcel cR wrel cA cB cR wbr cA cvv wcel cB
    cC cR wbr cA cB cR brrelex 3adant3 adantr cR wrel cA cB cR wbr cB cC cR wbr
    w3a cB cvv wcel cC cvv wcel cR wrel cB cC cR wbr cB cvv wcel cA cB cR wbr
    cB cC cR brrelex 3adant2 adantr cR wrel cA cB cR wbr cB cC cR wbr w3a cC
    cvv wcel pm3.27 3jca cR psrel syl3anl1 cR cps wcel cA cB cR wbr cB cC cR
    wbr w3a cA cB cR wbr cB cC cR wbr wa cC cvv wcel cR cps wcel cA cB cR wbr
    cB cC cR wbr 3simpc adantr syl3anc cR cps wcel cA cB cR wbr cB cC cR wbr
    w3a cC cvv wcel wn wa cA cC cR wbr cA cA cR wbr cR cps wcel cA cB cR wbr cB
    cC cR wbr w3a cA cA cR wbr cC cvv wcel wn cR cps wcel cA cB cR wbr cA cA cR
    wbr cB cC cR wbr cR cps wcel cA cB cR wbr cA cR cdm wcel cA cA cR wbr cR
    cps wcel cA cB cR wbr cA cvv wcel cA cR cdm wcel cR wrel cA cB cR wbr cA
    cvv wcel cR cps wcel cA cB cR brrelex cR psrel sylan cA cB cvv cR breldmg
    sylancom cA cR cR cdm cR cdm eqid psref syldan 3adant3 adantr cC cvv wcel
    wn cA cC cR wbr cA cA cR wbr wb cR cps wcel cA cB cR wbr cB cC cR wbr w3a
    cA cC cR brprc adantl mpbird pm2.61dan $.
    $( [18-Jun-2008] $) $( [12-May-2008] $)

  ${
    $d r u v w x y z A $.  $d r u v w x y z R $.  $d r u v w x y X $.
    $d r u v w Z $.
    spwval2.1 $e |- X = U. U. R $.
    spwval2.2 $e |- Z = { x e. X |
       ( A. y e. A y R x /\ A. y e. X ( A. z e. A z R y -> x R y ) ) } $.
    $( Value of supremum under a weak ordering.  Read ` R supw A ` as "the
       ` R ` -supremum of ` A ` ."   ` U. U. R ` is the field of a relation
       ` R ` by ~ relfld .  Unlike ~ df-sup for strong orderings, the supremum
       exists iff ` R supw A ` belongs to the field. $)
    spwval2 $p |- ( ( R e. U /\ A e. W )
            -> ( R supw A ) = if ( Z =/= (/) , U. Z , ~P U. X ) ) $=
      cR cU wcel cA cW wcel cZ c0 wne cZ cuni cX cuni cpw cif cvv wcel cR cA
      cspw co cZ c0 wne cZ cuni cX cuni cpw cif wceq cR cU wcel cZ c0 wne cZ
      cuni cX cuni cpw cif cvv wcel cA cW wcel cX cuni cpw cvv wcel cZ cuni cvv
      wcel cZ c0 wne cZ cuni cX cuni cpw cif cvv wcel cR cU wcel cZ cuni cvv
      wcel cX cuni cpw cvv wcel cZ c0 wne cZ cuni cX cuni cpw cif cvv wcel cZ
      c0 wne cZ cuni cX cuni cpw cvv ifcl ancoms cR cU wcel cX cuni cvv wcel cX
      cuni cpw cvv wcel cR cU wcel cX cvv wcel cX cuni cvv wcel cR cU wcel cR
      cuni cuni cvv cX cR cU wcel cR cuni cvv wcel cR cuni cuni cvv wcel cR cU
      uniexg cR cuni cvv uniexg syl spwval2.1 syl5eqel cX cvv uniexg syl cX
      cuni cvv pwexg syl cR cU wcel cZ cvv wcel cZ cuni cvv wcel cR cU wcel vy
      cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR
      wbr wi vy cX wral wa vx cX crab cvv cZ cR cU wcel cX cvv wcel vy cv vx cv
      cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy
      cX wral wa vx cX crab cvv wcel cR cU wcel cR cuni cuni cvv cX cR cU wcel
      cR cuni cvv wcel cR cuni cuni cvv wcel cR cU uniexg cR cuni cvv uniexg
      syl spwval2.1 syl5eqel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr
      vz cA wral vx cv vy cv cR wbr wi vy cX wral wa vx cX cvv rabexg syl
      spwval2.2 syl5eqel cZ cvv uniexg syl sylanc adantr cR cU wcel cA cW wcel
      cZ c0 wne cZ cuni cX cuni cpw cif cvv wcel w3a cZ c0 wne cZ cuni cX cuni
      cpw cif cZ c0 wne cZ cuni cX cuni cpw cif wceq cR cA cspw co cZ c0 wne cZ
      cuni cX cuni cpw cif wceq cZ c0 wne cZ cuni cX cuni cpw cif eqid cR cU
      wcel cA cW wcel cZ c0 wne cZ cuni cX cuni cpw cif cvv wcel w3a cZ c0 wne
      cZ cuni cX cuni cpw cif cZ c0 wne cZ cuni cX cuni cpw cif wceq vu cv cZ
      wceq cZ c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cX cuni
      cpw cif wceq wa vu wex cR cA cspw co cZ c0 wne cZ cuni cX cuni cpw cif
      wceq cR cU wcel cA cW wcel vu cv cZ wceq cZ c0 wne cZ cuni cX cuni cpw
      cif vu cv c0 wne vu cv cuni cX cuni cpw cif wceq wa vu wex cZ c0 wne cZ
      cuni cX cuni cpw cif cZ c0 wne cZ cuni cX cuni cpw cif wceq wb cZ c0 wne
      cZ cuni cX cuni cpw cif cvv wcel cR cU wcel cZ cvv wcel vu cv cZ wceq cZ
      c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cX cuni cpw cif
      wceq wa vu wex cZ c0 wne cZ cuni cX cuni cpw cif cZ c0 wne cZ cuni cX
      cuni cpw cif wceq wb cR cU wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv
      cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa vx cX crab cvv cZ
      cR cU wcel cX cvv wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr
      vz cA wral vx cv vy cv cR wbr wi vy cX wral wa vx cX crab cvv wcel cR cU
      wcel cR cuni cuni cvv cX cR cU wcel cR cuni cvv wcel cR cuni cuni cvv
      wcel cR cU uniexg cR cuni cvv uniexg syl spwval2.1 syl5eqel vy cv vx cv
      cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy
      cX wral wa vx cX cvv rabexg syl spwval2.2 syl5eqel cZ c0 wne cZ cuni cX
      cuni cpw cif vu cv c0 wne vu cv cuni cX cuni cpw cif wceq cZ c0 wne cZ
      cuni cX cuni cpw cif cZ c0 wne cZ cuni cX cuni cpw cif wceq vu cZ cvv vu
      cv cZ wceq vu cv c0 wne vu cv cuni cX cuni cpw cif cZ c0 wne cZ cuni cX
      cuni cpw cif cZ c0 wne cZ cuni cX cuni cpw cif vu cv cZ wceq vu cv c0 wne
      vu cv cuni cX cuni cpw cif vu cv c0 wne cZ cuni cX cuni cpw cif cZ c0 wne
      cZ cuni cX cuni cpw cif vu cv cZ wceq vu cv c0 wne vu cv cuni cZ cuni cX
      cuni cpw vu cv cZ unieq ifeq1d vu cv cZ wceq vu cv c0 wne cZ c0 wne cZ
      cuni cX cuni cpw vu cv cZ c0 neeq1 ifbid eqtrd eqeq2d ceqsexgv syl
      3ad2ant1 cR cU wcel cA cW wcel cZ c0 wne cZ cuni cX cuni cpw cif cvv wcel
      w3a vu cv vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx
      cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab wceq cZ
      c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cR cuni cuni cuni
      cpw cif wceq wa vu wex cR cA cspw co cZ c0 wne cZ cuni cX cuni cpw cif
      wceq vu cv cZ wceq cZ c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu cv
      cuni cX cuni cpw cif wceq wa vu wex cR cvv wcel cA cvv wcel cZ c0 wne cZ
      cuni cX cuni cpw cif cvv wcel vu cv vy cv vx cv cR wbr vy cA wral vz cv
      vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx
      cR cuni cuni crab wceq cZ c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu
      cv cuni cR cuni cuni cuni cpw cif wceq wa vu wex cR cA cspw co cZ c0 wne
      cZ cuni cX cuni cpw cif wceq wi cR cU wcel cA cW wcel cZ c0 wne cZ cuni
      cX cuni cpw cif cvv wcel vu cv vy cv vx cv vr cv wbr vy vw cv wral vz cv
      vy cv vr cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni
      wral wa vx vr cv cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni vr cv
      cuni cuni cuni cpw cif wceq wa vu wex vu cv vy cv vx cv cR wbr vy vw cv
      wral vz cv vy cv cR wbr vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni
      cuni wral wa vx cR cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni cR
      cuni cuni cuni cpw cif wceq wa vu wex vu cv vy cv vx cv cR wbr vy cA wral
      vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral
      wa vx cR cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni cR cuni cuni
      cuni cpw cif wceq wa vu wex vu cv vy cv vx cv cR wbr vy cA wral vz cv vy
      cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR
      cuni cuni crab wceq cZ c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu cv
      cuni cR cuni cuni cuni cpw cif wceq wa vu wex vr vw vv cR cA cZ c0 wne cZ
      cuni cX cuni cpw cif cvv cvv cvv cspw vr cv cR wceq vu cv vy cv vx cv vr
      cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv vr
      cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni cuni crab wceq vv cv
      vu cv c0 wne vu cv cuni vr cv cuni cuni cuni cpw cif wceq wa vu cv vy cv
      vx cv cR wbr vy vw cv wral vz cv vy cv cR wbr vz vw cv wral vx cv vy cv
      cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab wceq vv cv vu cv
      c0 wne vu cv cuni cR cuni cuni cuni cpw cif wceq wa vu vr cv cR wceq vu
      cv vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv
      wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni
      cuni crab wceq vu cv vy cv vx cv cR wbr vy vw cv wral vz cv vy cv cR wbr
      vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni
      cuni crab wceq vv cv vu cv c0 wne vu cv cuni vr cv cuni cuni cuni cpw cif
      wceq vv cv vu cv c0 wne vu cv cuni cR cuni cuni cuni cpw cif wceq vr cv
      cR wceq vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw
      cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni
      cuni crab vy cv vx cv cR wbr vy vw cv wral vz cv vy cv cR wbr vz vw cv
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab
      vu cv vr cv cR wceq vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr cv
      wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa vx
      vr cv cuni cuni crab vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr
      cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa
      vx cR cuni cuni crab vy cv vx cv cR wbr vy vw cv wral vz cv vy cv cR wbr
      vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni
      cuni crab vr cv cR wceq vr cv cuni cuni cR cuni cuni wceq vy cv vx cv vr
      cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv vr
      cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni cuni crab vy cv vx cv
      vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv
      vr cv wbr wi vy vr cv cuni cuni wral wa vx cR cuni cuni crab wceq vr cv
      cR wceq vr cv cuni cR cuni vr cv cR unieq unieqd vy cv vx cv vr cv wbr vy
      vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi
      vy vr cv cuni cuni wral wa vx vr cv cuni cuni cR cuni cuni rabeq syl vr
      cv cR wceq vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz
      vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa vy cv vx
      cv cR wbr vy vw cv wral vz cv vy cv cR wbr vz vw cv wral vx cv vy cv cR
      wbr wi vy cR cuni cuni wral wa vx cR cuni cuni vr cv cR wceq vy cv vx cv
      vr cv wbr vy vw cv wral vy cv vx cv cR wbr vy vw cv wral vz cv vy cv vr
      cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral vz
      cv vy cv cR wbr vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni cuni wral
      vr cv cR wceq vy cv vx cv vr cv wbr vy cv vx cv cR wbr vy vw cv vy cv vx
      cv vr cv cR breq ralbidv vr cv cR wceq vz cv vy cv vr cv wbr vz vw cv
      wral vx cv vy cv vr cv wbr wi vz cv vy cv cR wbr vz vw cv wral vx cv vy
      cv cR wbr wi vy vr cv cuni cuni cR cuni cuni vr cv cR wceq vr cv cuni cR
      cuni vr cv cR unieq unieqd vr cv cR wceq vz cv vy cv vr cv wbr vz vw cv
      wral vz cv vy cv cR wbr vz vw cv wral vx cv vy cv vr cv wbr vx cv vy cv
      cR wbr vr cv cR wceq vz cv vy cv vr cv wbr vz cv vy cv cR wbr vz vw cv vz
      cv vy cv vr cv cR breq ralbidv vx cv vy cv vr cv cR breq imbi12d raleq12d
      anbi12d rabbisdv eqtrd eqeq2d vr cv cR wceq vu cv c0 wne vu cv cuni vr cv
      cuni cuni cuni cpw cif vu cv c0 wne vu cv cuni cR cuni cuni cuni cpw cif
      vv cv vr cv cR wceq vu cv c0 wne vr cv cuni cuni cuni cpw cR cuni cuni
      cuni cpw vu cv cuni vr cv cR wceq vr cv cuni cuni cuni cR cuni cuni cuni
      wceq vr cv cuni cuni cuni cpw cR cuni cuni cuni cpw wceq vr cv cR wceq vr
      cv cuni cuni cR cuni cuni vr cv cR wceq vr cv cuni cR cuni vr cv cR unieq
      unieqd unieqd vr cv cuni cuni cuni cR cuni cuni cuni pweq syl ifeq2d
      eqeq2d anbi12d exbidv vw cv cA wceq vu cv vy cv vx cv cR wbr vy vw cv
      wral vz cv vy cv cR wbr vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni
      cuni wral wa vx cR cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni cR
      cuni cuni cuni cpw cif wceq wa vu cv vy cv vx cv cR wbr vy cA wral vz cv
      vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx
      cR cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni cR cuni cuni cuni
      cpw cif wceq wa vu vw cv cA wceq vu cv vy cv vx cv cR wbr vy vw cv wral
      vz cv vy cv cR wbr vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni cuni
      wral wa vx cR cuni cuni crab wceq vu cv vy cv vx cv cR wbr vy cA wral vz
      cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa
      vx cR cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni cR cuni cuni cuni
      cpw cif wceq vw cv cA wceq vy cv vx cv cR wbr vy vw cv wral vz cv vy cv
      cR wbr vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR
      cuni cuni crab vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab
      vu cv vw cv cA wceq vy cv vx cv cR wbr vy vw cv wral vz cv vy cv cR wbr
      vz vw cv wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vy cv vx cv
      cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy
      cR cuni cuni wral wa vx cR cuni cuni vw cv cA wceq vy cv vx cv cR wbr vy
      vw cv wral vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz vw cv wral
      vx cv vy cv cR wbr wi vy cR cuni cuni wral vz cv vy cv cR wbr vz cA wral
      vx cv vy cv cR wbr wi vy cR cuni cuni wral vy cv vx cv cR wbr vy vw cv cA
      raleq1 vw cv cA wceq vz cv vy cv cR wbr vz vw cv wral vx cv vy cv cR wbr
      wi vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni vw
      cv cA wceq vz cv vy cv cR wbr vz vw cv wral vz cv vy cv cR wbr vz cA wral
      vx cv vy cv cR wbr vz cv vy cv cR wbr vz vw cv cA raleq1 imbi1d ralbidv
      anbi12d rabbisdv eqeq2d anbi1d exbidv vv cv cZ c0 wne cZ cuni cX cuni cpw
      cif wceq vu cv vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab
      wceq vv cv vu cv c0 wne vu cv cuni cR cuni cuni cuni cpw cif wceq wa vu
      cv vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy
      cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab wceq cZ c0 wne
      cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cR cuni cuni cuni cpw cif
      wceq wa vu vv cv cZ c0 wne cZ cuni cX cuni cpw cif wceq vv cv vu cv c0
      wne vu cv cuni cR cuni cuni cuni cpw cif wceq cZ c0 wne cZ cuni cX cuni
      cpw cif vu cv c0 wne vu cv cuni cR cuni cuni cuni cpw cif wceq vu cv vy
      cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR
      wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab wceq vv cv cZ c0 wne
      cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cR cuni cuni cuni cpw cif
      eqeq1 anbi2d exbidv vu cv vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv
      vr cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral
      wa vx vr cv cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni vr cv cuni
      cuni cuni cpw cif wceq wa vu wex vv wmo vr cv cvv wcel vw cv cvv wcel wa
      vu cv vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv
      wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni
      cuni crab wceq vu wmo vv cv vu cv c0 wne vu cv cuni vr cv cuni cuni cuni
      cpw cif wceq vv wmo vu wal vu cv vy cv vx cv vr cv wbr vy vw cv wral vz
      cv vy cv vr cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni
      cuni wral wa vx vr cv cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni
      vr cv cuni cuni cuni cpw cif wceq wa vu wex vv wmo vu vy cv vx cv vr cv
      wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv vr cv
      wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni cuni crab moeq vv cv vu
      cv c0 wne vu cv cuni vr cv cuni cuni cuni cpw cif wceq vv wmo vu vv vu cv
      c0 wne vu cv cuni vr cv cuni cuni cuni cpw cif moeq ax-gen vu cv vy cv vx
      cv vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy
      cv vr cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni cuni crab wceq
      vv cv vu cv c0 wne vu cv cuni vr cv cuni cuni cuni cpw cif wceq vu vv
      moexexv mp2an a1i cspw vu cv vy cv vx cv vr cv wbr vy vw cv wral vz cv vy
      cv vr cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni
      wral wa vx vr cv cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni vr cv
      cuni cuni cuni cpw cif wceq wa vu wex vr vw vv copab2 vr cv cvv wcel vw
      cv cvv wcel wa vu cv vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr
      cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa
      vx vr cv cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni vr cv cuni
      cuni cuni cpw cif wceq wa vu wex wa vr vw vv copab2 vw vv vu vx vy vz vr
      df-spw vu cv vy cv vx cv vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz
      vw cv wral vx cv vy cv vr cv wbr wi vy vr cv cuni cuni wral wa vx vr cv
      cuni cuni crab wceq vv cv vu cv c0 wne vu cv cuni vr cv cuni cuni cuni
      cpw cif wceq wa vu wex vr cv cvv wcel vw cv cvv wcel wa vu cv vy cv vx cv
      vr cv wbr vy vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv
      vr cv wbr wi vy vr cv cuni cuni wral wa vx vr cv cuni cuni crab wceq vv
      cv vu cv c0 wne vu cv cuni vr cv cuni cuni cuni cpw cif wceq wa vu wex wa
      vr vw vv vr cv cvv wcel vw cv cvv wcel wa vu cv vy cv vx cv vr cv wbr vy
      vw cv wral vz cv vy cv vr cv wbr vz vw cv wral vx cv vy cv vr cv wbr wi
      vy vr cv cuni cuni wral wa vx vr cv cuni cuni crab wceq vv cv vu cv c0
      wne vu cv cuni vr cv cuni cuni cuni cpw cif wceq wa vu wex vr cv cvv wcel
      vw cv cvv wcel vr visset vw visset pm3.2i biantrur oprabbii eqtri
      oprabvalig cR cU elisset cA cW elisset cZ c0 wne cZ cuni cX cuni cpw cif
      cvv wcel id syl3an vu cv cZ wceq cZ c0 wne cZ cuni cX cuni cpw cif vu cv
      c0 wne vu cv cuni cX cuni cpw cif wceq wa vu cv vy cv vx cv cR wbr vy cA
      wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni
      wral wa vx cR cuni cuni crab wceq cZ c0 wne cZ cuni cX cuni cpw cif vu cv
      c0 wne vu cv cuni cR cuni cuni cuni cpw cif wceq wa vu vu cv cZ wceq vu
      cv vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy
      cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab wceq cZ c0 wne
      cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cX cuni cpw cif wceq cZ
      c0 wne cZ cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cR cuni cuni cuni
      cpw cif wceq cZ vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab
      vu cv cZ vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx
      cv vy cv cR wbr wi vy cX wral wa vx cX crab vy cv vx cv cR wbr vy cA wral
      vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral
      wa vx cX crab vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral
      vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab
      spwval2.2 vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx
      cv vy cv cR wbr wi vy cX wral wa vy cv vx cv cR wbr vy cA wral vz cv vy
      cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cX
      vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv
      cR wbr wi vy cX wral wa vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr
      vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa wb vx cv cX wcel
      vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral vz cv vy
      cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral vy cv vx
      cv cR wbr vy cA wral cX cR cuni cuni wceq vz cv vy cv cR wbr vz cA wral
      vx cv vy cv cR wbr wi vy cX wral vz cv vy cv cR wbr vz cA wral vx cv vy
      cv cR wbr wi vy cR cuni cuni wral wb spwval2.1 vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cX cR cuni cuni raleq1 ax-mp anbi2i a1i
      rabbii cX cR cuni cuni wceq vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cX crab
      vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv
      cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab wceq spwval2.1 vy
      cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR
      wbr wi vy cR cuni cuni wral wa vx cX cR cuni cuni rabeq ax-mp 3eqtri
      eqeq2i vu cv c0 wne vu cv cuni cX cuni cpw cif vu cv c0 wne vu cv cuni cR
      cuni cuni cuni cpw cif cZ c0 wne cZ cuni cX cuni cpw cif cX cuni cpw cR
      cuni cuni cuni cpw wceq vu cv c0 wne vu cv cuni cX cuni cpw cif vu cv c0
      wne vu cv cuni cR cuni cuni cuni cpw cif wceq cX cuni cR cuni cuni cuni
      wceq cX cuni cpw cR cuni cuni cuni cpw wceq cX cR cuni cuni spwval2.1
      unieqi cX cuni cR cuni cuni cuni pweq ax-mp vu cv c0 wne cX cuni cpw cR
      cuni cuni cuni cpw vu cv cuni ifeq2 ax-mp eqeq2i anbi12i exbii syl5ib
      sylbird mpi mpd3an3 $.
      $( [14-May-2008] $) $( [13-May-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z R $.  $d x y X $.
    spwval3.1 $e |- X = U. U. R $.
    spwval3.2 $e |- ( ph
         <-> ( A. y e. A y R x /\ A. y e. X ( A. z e. A z R y -> x R y ) ) ) $.
    $( Value of a supremum. $)
    spwval3 $p |- ( ( R e. U /\ A e. W /\ E. x e. X ph )
           -> ( R supw A ) = U. { x e. X | ph } ) $=
      cR cU wcel cA cW wcel wph vx cX wrex w3a cR cA cspw co wph vx cX crab c0
      wne wph vx cX crab cuni cX cuni cpw cif wph vx cX crab cuni cR cU wcel cA
      cW wcel cR cA cspw co wph vx cX crab c0 wne wph vx cX crab cuni cX cuni
      cpw cif wceq wph vx cX wrex vx vy vz cA cR cU cW cX wph vx cX crab
      spwval3.1 wph vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral
      vx cv vy cv cR wbr wi vy cX wral wa vx cX wph vy cv vx cv cR wbr vy cA
      wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa wb
      vx cv cX wcel spwval3.2 a1i rabbii spwval2 3adant3 wph vx cX wrex cR cU
      wcel wph vx cX crab c0 wne wph vx cX crab cuni cX cuni cpw cif wph vx cX
      crab cuni wceq cA cW wcel wph vx cX wrex wph vx cX crab c0 wne wph vx cX
      crab c0 wne wph vx cX crab cuni cX cuni cpw cif wph vx cX crab cuni wceq
      wph vx cX rabn0 wph vx cX crab c0 wne wph vx cX crab cuni cX cuni cpw
      iftrue sylbir 3ad2ant3 eqtrd $.
      $( [24-May-2008] $) $( [13-May-2008] $)

    $( When the supremum of set ` A ` doesn't exist, ` R supw A ` isn't in the
       the field of order relation ` R ` . $)
    spwnex3 $p |- ( ( R e. U /\ A e. W /\ -. E. x e. X ph )
         -> -. ( R supw A ) e. X ) $=
      cR cU wcel cA cW wcel wph vx cX wrex wn w3a cR cA cspw co cX wcel cX cuni
      cpw cX wcel cX pwuninel cR cU wcel cA cW wcel wph vx cX wrex wn w3a cR cA
      cspw co cX cuni cpw cX cR cU wcel cA cW wcel wph vx cX wrex wn w3a cR cA
      cspw co wph vx cX crab c0 wne wph vx cX crab cuni cX cuni cpw cif cX cuni
      cpw cR cU wcel cA cW wcel cR cA cspw co wph vx cX crab c0 wne wph vx cX
      crab cuni cX cuni cpw cif wceq wph vx cX wrex wn vx vy vz cA cR cU cW cX
      wph vx cX crab spwval3.1 wph vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa vx cX wph vy cv vx cv
      cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy
      cX wral wa wb vx cv cX wcel spwval3.2 a1i rabbii spwval2 3adant3 wph vx
      cX wrex wn cR cU wcel wph vx cX crab c0 wne wph vx cX crab cuni cX cuni
      cpw cif cX cuni cpw wceq cA cW wcel wph vx cX wrex wn wph vx cX crab c0
      wne wn wph vx cX crab c0 wne wph vx cX crab cuni cX cuni cpw cif cX cuni
      cpw wceq wph vx cX crab c0 wne wph vx cX wrex wph vx cX rabn0 notbii wph
      vx cX crab c0 wne wph vx cX crab cuni cX cuni cpw iffalse sylbir 3ad2ant3
      eqtrd eleq1d mtbiri $.
      $( [14-May-2008] $) $( [13-May-2008] $)
  $}

  ${
    $d w x y z A $.  $d y z B $.  $d y z C $.  $d w x y z R $.  $d w x y X $.
    $d y U $.  $d y W $.
    spwmo.1 $e |- ( ph
         <-> ( A. y e. A y R x /\ A. y e. X ( A. z e. A z R y -> x R y ) ) ) $.
    $( A poset has at most one supremum. $)
    spwmo $p |- ( R e. Poset -> E* x ( x e. X /\ ph ) ) $=
      cR cps wcel vx cv cX wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa wa vw cv cX wcel vz cv
      vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr
      wi vy cX wral wa wa wa vx cv vw cv wceq wi vw wal vx wal vx cv cX wcel
      wph wa vx wmo cR cps wcel vx cv cX wcel vy cv vx cv cR wbr vy cA wral vz
      cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa wa vw cv
      cX wcel vz cv vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral vw cv
      vy cv cR wbr wi vy cX wral wa wa wa vx cv vw cv wceq wi vx vw vx cv cX
      wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy
      cv cR wbr wi vy cX wral wa wa vw cv cX wcel vz cv vw cv cR wbr vz cA wral
      vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy cX wral wa wa wa
      cR cps wcel vx cv vw cv wceq vx cv cX wcel vw cv cX wcel vy cv vx cv cR
      wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX
      wral wa vz cv vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral vw cv
      vy cv cR wbr wi vy cX wral wa cR cps wcel vx cv vw cv wceq wi vx cv cX
      wcel vw cv cX wcel wa vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz
      cA wral vx cv vy cv cR wbr wi vy cX wral wa vz cv vw cv cR wbr vz cA wral
      vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy cX wral wa wa cR
      cps wcel vx cv vw cv wceq wi vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa vz cv vw cv cR wbr vz
      cA wral vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy cX wral wa
      wa cR cps wcel vx cv cX wcel vw cv cX wcel wa vx cv vw cv wceq vy cv vx
      cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi
      vy cX wral vz cv vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral vw
      cv vy cv cR wbr wi vy cX wral cR cps wcel vx cv cX wcel vw cv cX wcel wa
      vx cv vw cv wceq wi wi vy cv vx cv cR wbr vy cA wral vz cv vx cv cR wbr
      vz cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral
      vz cv vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral vw cv vy cv
      cR wbr wi vy cX wral cR cps wcel vx cv cX wcel vw cv cX wcel wa vx cv vw
      cv wceq wi wi wi wi wi vy cv vx cv cR wbr vz cv vx cv cR wbr vy vz cA vy
      cv vz cv vx cv cR breq1 cbvralv vz cv vy cv cR wbr vz cA wral vx cv vy cv
      cR wbr wi vy cX wral vz cv vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz
      cA wral vw cv vy cv cR wbr wi vy cX wral vz cv vx cv cR wbr vz cA wral cR
      cps wcel vx cv cX wcel vw cv cX wcel wa vx cv vw cv wceq wi wi vz cv vy
      cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral vz cv vw cv cR wbr
      vz cA wral vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy cX wral
      vz cv vx cv cR wbr vz cA wral cR cps wcel vx cv cX wcel vw cv cX wcel wa
      vx cv vw cv wceq wi wi vx cv cX wcel vw cv cX wcel wa cR cps wcel vz cv
      vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral vz cv vw cv cR
      wbr vz cA wral wa vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy
      cX wral vz cv vx cv cR wbr vz cA wral wa wa vx cv vw cv wceq vx cv cX
      wcel vw cv cX wcel wa vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi
      vy cX wral vz cv vw cv cR wbr vz cA wral wa vz cv vy cv cR wbr vz cA wral
      vw cv vy cv cR wbr wi vy cX wral vz cv vx cv cR wbr vz cA wral wa wa vx
      cv vw cv cR wbr vw cv vx cv cR wbr wa cR cps wcel vx cv vw cv wceq vw cv
      cX wcel vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral vz
      cv vw cv cR wbr vz cA wral wa vx cv vw cv cR wbr vx cv cX wcel vz cv vy
      cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy cX wral vz cv vx cv cR wbr
      vz cA wral wa vw cv vx cv cR wbr vw cv cX wcel vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cX wral vz cv vw cv cR wbr vz cA wral vx cv
      vw cv cR wbr vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vz cv vw
      cv cR wbr vz cA wral vx cv vw cv cR wbr wi vy vw cv cX vy cv vw cv wceq
      vz cv vy cv cR wbr vz cA wral vz cv vw cv cR wbr vz cA wral vx cv vy cv
      cR wbr vx cv vw cv cR wbr vy cv vw cv wceq vz cv vy cv cR wbr vz cv vw cv
      cR wbr vz cA vy cv vw cv vz cv cR breq2 ralbidv vy cv vw cv vx cv cR
      breq2 imbi12d rcla4v imp3a vx cv cX wcel vz cv vy cv cR wbr vz cA wral vw
      cv vy cv cR wbr wi vy cX wral vz cv vx cv cR wbr vz cA wral vw cv vx cv
      cR wbr vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vz cv vx cv cR
      wbr vz cA wral vw cv vx cv cR wbr wi vy vx cv cX vy cv vx cv wceq vz cv
      vy cv cR wbr vz cA wral vz cv vx cv cR wbr vz cA wral vw cv vy cv cR wbr
      vw cv vx cv cR wbr vy cv vx cv wceq vz cv vy cv cR wbr vz cv vx cv cR wbr
      vz cA vy cv vx cv vz cv cR breq2 ralbidv vy cv vx cv vw cv cR breq2
      imbi12d rcla4v imp3a im2anan9r cR cps wcel vx cv vw cv cR wbr vw cv vx cv
      cR wbr vx cv vw cv wceq vx cv vw cv cR psasym 3expib syl9 com13 exp43
      com4r sylbi imp43 com3r imp an4s com12 19.21aivv vx cv cX wcel wph wa vx
      wmo vx cv cX wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cX wral wa wa vx wmo vx cv cX wcel vy cv vx
      cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi
      vy cX wral wa wa vw cv cX wcel vz cv vw cv cR wbr vz cA wral vz cv vy cv
      cR wbr vz cA wral vw cv vy cv cR wbr wi vy cX wral wa wa wa vx cv vw cv
      wceq wi vw wal vx wal vx cv cX wcel wph wa vx cv cX wcel vy cv vx cv cR
      wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX
      wral wa wa vx wph vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cX wral wa vx cv cX wcel spwmo.1 anbi2i
      mobii vx cv cX wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz
      cA wral vx cv vy cv cR wbr wi vy cX wral wa wa vw cv cX wcel vz cv vw cv
      cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral vw cv vy cv cR wbr wi vy
      cX wral wa wa vx vw vx cv vw cv wceq vx cv cX wcel vw cv cX wcel vy cv vx
      cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi
      vy cX wral wa vz cv vw cv cR wbr vz cA wral vz cv vy cv cR wbr vz cA wral
      vw cv vy cv cR wbr wi vy cX wral wa vx cv vw cv cX eleq1 vx cv vw cv wceq
      vy cv vx cv cR wbr vy cA wral vz cv vw cv cR wbr vz cA wral vz cv vy cv
      cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral vz cv vy cv cR wbr vz
      cA wral vw cv vy cv cR wbr wi vy cX wral vx cv vw cv wceq vy cv vx cv cR
      wbr vy cA wral vy cv vw cv cR wbr vy cA wral vz cv vw cv cR wbr vz cA
      wral vx cv vw cv wceq vy cv vx cv cR wbr vy cv vw cv cR wbr vy cA vx cv
      vw cv vy cv cR breq2 ralbidv vy cv vw cv cR wbr vz cv vw cv cR wbr vy vz
      cA vy cv vz cv vw cv cR breq1 cbvralv syl6bb vx cv vw cv wceq vz cv vy cv
      cR wbr vz cA wral vx cv vy cv cR wbr wi vz cv vy cv cR wbr vz cA wral vw
      cv vy cv cR wbr wi vy cX vx cv vw cv wceq vx cv vy cv cR wbr vw cv vy cv
      cR wbr vz cv vy cv cR wbr vz cA wral vx cv vw cv vy cv cR breq1 imbi2d
      ralbidv anbi12d anbi12d mo4 bitri sylibr $.
      $( [19-May-2008] $) $( [13-May-2008] $)

    $( A supremum is unique. $)
    spweu $p |- ( ( R e. Poset /\ E. x e. X ph ) -> E! x e. X ph ) $=
      wph vx cX wrex cR cps wcel wph vx cX wreu wph vx cX wrex cR cps wcel wa
      wph vx cX wrex vx cv cX wcel wph wa vx wmo wa wph vx cX wreu cR cps wcel
      vx cv cX wcel wph wa vx wmo wph vx cX wrex wph vx vy vz cA cR cX spwmo.1
      spwmo anim2i wph vx cX reu5 sylibr ancoms $.
      $( [25-May-2008] $) $( [15-May-2008] $)

    $( Property of supremum defining condition for an unordered pair. $)
    spwpr2 $p |- ( ( ( R e. T /\ A = { B , C } ) /\ ( B e. U /\ C e. W ) )
       -> ( ph <->
     ( ( B R x /\ C R x ) /\ A. y e. X ( ( B R y /\ C R y ) -> x R y ) ) ) ) $=
      cR cT wcel cA cB cC cpr wceq wa cB cU wcel cC cW wcel wa wa vy cv vx cv
      cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy
      cX wral wa cB vx cv cR wbr cC vx cv cR wbr wa cB vy cv cR wbr cC vy cv cR
      wbr wa vx cv vy cv cR wbr wi vy cX wral wa wph cA cB cC cpr wceq cB cU
      wcel cC cW wcel wa vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cX wral wa cB vx cv cR wbr cC vx cv cR wbr
      wa cB vy cv cR wbr cC vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa
      wb cR cT wcel cA cB cC cpr wceq cB cU wcel cC cW wcel wa wa vy cv vx cv
      cR wbr vy cA wral cB vx cv cR wbr cC vx cv cR wbr wa vz cv vy cv cR wbr
      vz cA wral vx cv vy cv cR wbr wi vy cX wral cB vy cv cR wbr cC vy cv cR
      wbr wa vx cv vy cv cR wbr wi vy cX wral cA cB cC cpr wceq vy cv vx cv cR
      wbr vy cA wral vy cv vx cv cR wbr vy cB cC cpr wral cB cU wcel cC cW wcel
      wa cB vx cv cR wbr cC vx cv cR wbr wa vy cv vx cv cR wbr vy cA cB cC cpr
      raleq1 cB cU wcel cC cW wcel wa vy cv cB wceq vy cv vx cv cR wbr wi vy
      wal vy cv cC wceq vy cv vx cv cR wbr wi vy wal wa cB vx cv cR wbr cC vx
      cv cR wbr wa vy cv vx cv cR wbr vy cB cC cpr wral cB cU wcel vy cv cB
      wceq vy cv vx cv cR wbr wi vy wal cB vx cv cR wbr cC cW wcel vy cv cC
      wceq vy cv vx cv cR wbr wi vy wal cC vx cv cR wbr vy cv vx cv cR wbr cB
      vx cv cR wbr vy cB cU cB vx cv cR wbr vy ax-17 vy cv cB vx cv cR breq1
      ceqsalg vy cv vx cv cR wbr cC vx cv cR wbr vy cC cW cC vx cv cR wbr vy
      ax-17 vy cv cC vx cv cR breq1 ceqsalg bi2anan9 vy cv vx cv cR wbr vy cB
      cC cpr wral vy cv cB cC cpr wcel vy cv vx cv cR wbr wi vy wal vy cv cB
      wceq vy cv vx cv cR wbr wi vy cv cC wceq vy cv vx cv cR wbr wi wa vy wal
      vy cv cB wceq vy cv vx cv cR wbr wi vy wal vy cv cC wceq vy cv vx cv cR
      wbr wi vy wal wa vy cv vx cv cR wbr vy cB cC cpr df-ral vy cv cB cC cpr
      wcel vy cv vx cv cR wbr wi vy cv cB wceq vy cv vx cv cR wbr wi vy cv cC
      wceq vy cv vx cv cR wbr wi wa vy vy cv cB cC cpr wcel vy cv vx cv cR wbr
      wi vy cv cB wceq vy cv cC wceq wo vy cv vx cv cR wbr wi vy cv cB wceq vy
      cv vx cv cR wbr wi vy cv cC wceq vy cv vx cv cR wbr wi wa vy cv cB cC cpr
      wcel vy cv cB wceq vy cv cC wceq wo vy cv vx cv cR wbr vy cv cB cC vy
      visset elpr imbi1i vy cv cB wceq vy cv vx cv cR wbr vy cv cC wceq jaob
      bitri albii vy cv cB wceq vy cv vx cv cR wbr wi vy cv cC wceq vy cv vx cv
      cR wbr wi vy 19.26 3bitri syl5bb sylan9bb cA cB cC cpr wceq cB cU wcel cC
      cW wcel wa wa vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi cB vy
      cv cR wbr cC vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX cA cB cC cpr
      wceq cB cU wcel cC cW wcel wa wa vz cv vy cv cR wbr vz cA wral cB vy cv
      cR wbr cC vy cv cR wbr wa vx cv vy cv cR wbr cA cB cC cpr wceq vz cv vy
      cv cR wbr vz cA wral vz cv vy cv cR wbr vz cB cC cpr wral cB cU wcel cC
      cW wcel wa cB vy cv cR wbr cC vy cv cR wbr wa vz cv vy cv cR wbr vz cA cB
      cC cpr raleq1 cB cU wcel cC cW wcel wa vz cv cB wceq vz cv vy cv cR wbr
      wi vz wal vz cv cC wceq vz cv vy cv cR wbr wi vz wal wa cB vy cv cR wbr
      cC vy cv cR wbr wa vz cv vy cv cR wbr vz cB cC cpr wral cB cU wcel vz cv
      cB wceq vz cv vy cv cR wbr wi vz wal cB vy cv cR wbr cC cW wcel vz cv cC
      wceq vz cv vy cv cR wbr wi vz wal cC vy cv cR wbr vz cv vy cv cR wbr cB
      vy cv cR wbr vz cB cU cB vy cv cR wbr vz ax-17 vz cv cB vy cv cR breq1
      ceqsalg vz cv vy cv cR wbr cC vy cv cR wbr vz cC cW cC vy cv cR wbr vz
      ax-17 vz cv cC vy cv cR breq1 ceqsalg bi2anan9 vz cv vy cv cR wbr vz cB
      cC cpr wral vz cv cB cC cpr wcel vz cv vy cv cR wbr wi vz wal vz cv cB
      wceq vz cv vy cv cR wbr wi vz cv cC wceq vz cv vy cv cR wbr wi wa vz wal
      vz cv cB wceq vz cv vy cv cR wbr wi vz wal vz cv cC wceq vz cv vy cv cR
      wbr wi vz wal wa vz cv vy cv cR wbr vz cB cC cpr df-ral vz cv cB cC cpr
      wcel vz cv vy cv cR wbr wi vz cv cB wceq vz cv vy cv cR wbr wi vz cv cC
      wceq vz cv vy cv cR wbr wi wa vz vz cv cB cC cpr wcel vz cv vy cv cR wbr
      wi vz cv cB wceq vz cv cC wceq wo vz cv vy cv cR wbr wi vz cv cB wceq vz
      cv vy cv cR wbr wi vz cv cC wceq vz cv vy cv cR wbr wi wa vz cv cB cC cpr
      wcel vz cv cB wceq vz cv cC wceq wo vz cv vy cv cR wbr vz cv cB cC vz
      visset elpr imbi1i vz cv cB wceq vz cv vy cv cR wbr vz cv cC wceq jaob
      bitri albii vz cv cB wceq vz cv vy cv cR wbr wi vz cv cC wceq vz cv vy cv
      cR wbr wi vz 19.26 3bitri syl5bb sylan9bb imbi1d ralbidv anbi12d adantll
      spwmo.1 syl5bb $.
      $( [7-Jul-2008] $) $( [24-Jun-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x U $.
    $d x y X $.
    spwval.1 $e |- X = dom R $.
    spwval.2 $e |- ( ph
         <-> ( A. y e. A y R x /\ A. y e. X ( A. z e. A z R y -> x R y ) ) ) $.
    $( Value of a supremum. $)
    spwval $p |- ( ( R e. Poset /\ A e. W /\ E. x e. X ph )
           -> ( R supw A ) = U. { x e. X | ph } ) $=
      cR cps wcel cA cW wcel wph vx cX wrex cR cA cspw co wph vx cX crab cuni
      wceq cR cps wcel cA cW wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni
      cuni wrex wa cR cA cspw co vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni
      cuni crab cuni wceq cA cW wcel wph vx cX wrex wa cR cA cspw co wph vx cX
      crab cuni wceq cR cps wcel cA cW wcel vy cv vx cv cR wbr vy cA wral vz cv
      vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx
      cR cuni cuni wrex cR cA cspw co vy cv vx cv cR wbr vy cA wral vz cv vy cv
      cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR
      cuni cuni crab cuni wceq vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr
      vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx vy vz cA cR
      cps cW cR cuni cuni cR cuni cuni eqid vy cv vx cv cR wbr vy cA wral vz cv
      vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa
      biid spwval3 3expib cR cps wcel wph vx cX wrex vy cv vx cv cR wbr vy cA
      wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni
      wral wa vx cR cuni cuni wrex cA cW wcel cR cps wcel cX cR cuni cuni wceq
      wph vx cX wrex vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni wrex
      wb cR cps wcel cR cdm cR cuni cuni cX cR cps wcel cR cdm cR cuni cuni
      wceq cR crn cR cuni cuni wceq cR psdmrn pm3.26d spwval.1 syl5eq wph vy cv
      vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr
      wi vy cR cuni cuni wral wa vx cX cR cuni cuni cX cR cuni cuni wceq vy cv
      vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr
      wi vy cX wral wa vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa wph cX cR cuni cuni
      wceq vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral vz cv
      vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral vy cv
      vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr
      wi vy cX cR cuni cuni raleq1 anbi2d spwval.2 syl5bb rexeqd syl anbi2d cR
      cps wcel wph vx cX crab cuni vy cv vx cv cR wbr vy cA wral vz cv vy cv cR
      wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni
      cuni crab cuni cR cA cspw co cR cps wcel wph vx cX crab vy cv vx cv cR
      wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR
      cuni cuni wral wa vx cR cuni cuni crab cR cps wcel cX cR cuni cuni wceq
      wph vx cX crab vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni crab
      wceq cR cps wcel cR cdm cR cuni cuni cX cR cps wcel cR cdm cR cuni cuni
      wceq cR crn cR cuni cuni wceq cR psdmrn pm3.26d spwval.1 syl5eq cX cR
      cuni cuni wceq wph vx cX crab wph vx cR cuni cuni crab vy cv vx cv cR wbr
      vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni
      cuni wral wa vx cR cuni cuni crab wph vx cX cR cuni cuni rabeq cX cR cuni
      cuni wceq wph vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral
      vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni cX cR cuni
      cuni wceq vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx
      cv vy cv cR wbr wi vy cX wral wa vy cv vx cv cR wbr vy cA wral vz cv vy
      cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa wph cX
      cR cuni cuni wceq vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy
      cX wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni
      cuni wral vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx
      cv vy cv cR wbr wi vy cX cR cuni cuni raleq1 anbi2d spwval.2 syl5bb
      rabbisdv eqtrd syl unieqd eqeq2d 3imtr4d 3impib $.
      $( [26-May-2008] $) $( [13-May-2008] $)

    $( Closure of a supremum. $)
    spwcl $p |- ( ( R e. Poset /\ A e. W /\ E. x e. X ph )
           -> ( R supw A ) e. X ) $=
      cR cps wcel cA cW wcel wph vx cX wrex w3a cR cA cspw co wph vx cX crab
      cuni cX wph vx vy vz cA cR cW cX spwval.1 spwval.2 spwval cR cps wcel wph
      vx cX wrex wph vx cX crab cuni cX wcel cA cW wcel cR cps wcel wph vx cX
      wrex wa wph vx cX wreu wph vx cX crab cuni cX wcel wph vx vy vz cA cR cX
      spwval.2 spweu wph vx cX reucl syl 3adant2 eqeltrd $.
      $( [4-Jun-2008] $) $( [15-May-2008] $)

    $( Non-closure when the supremum doesn't exist. $)
    spwnex $p |- ( ( R e. Poset /\ A e. W /\ -. E. x e. X ph )
         -> -. ( R supw A ) e. X ) $=
      cR cps wcel cA cW wcel wph vx cX wrex wn cR cA cspw co cX wcel wn cR cps
      wcel cA cW wcel wa vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA
      wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni wrex
      wn cR cA cspw co cR cuni cuni wcel wn wph vx cX wrex wn cR cA cspw co cX
      wcel wn cR cps wcel cA cW wcel vy cv vx cv cR wbr vy cA wral vz cv vy cv
      cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR
      cuni cuni wrex wn cR cA cspw co cR cuni cuni wcel wn vy cv vx cv cR wbr
      vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni
      cuni wral wa vx vy vz cA cR cps cW cR cuni cuni cR cuni cuni eqid vy cv
      vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr
      wi vy cR cuni cuni wral wa biid spwnex3 3expia cR cps wcel wph vx cX wrex
      wn vy cv vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy
      cv cR wbr wi vy cR cuni cuni wral wa vx cR cuni cuni wrex wn wb cA cW
      wcel cR cps wcel wph vx cX wrex vy cv vx cv cR wbr vy cA wral vz cv vy cv
      cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral wa vx cR
      cuni cuni wrex cR cps wcel cX cR cuni cuni wceq wph vx cX wrex vy cv vx
      cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi
      vy cR cuni cuni wral wa vx cR cuni cuni wrex wb cR cps wcel cR cdm cR
      cuni cuni cX cR cps wcel cR cdm cR cuni cuni wceq cR crn cR cuni cuni
      wceq cR psdmrn pm3.26d spwval.1 syl5eq wph vy cv vx cv cR wbr vy cA wral
      vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cR cuni cuni wral
      wa vx cX cR cuni cuni cX cR cuni cuni wceq vy cv vx cv cR wbr vy cA wral
      vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX wral wa vy cv
      vx cv cR wbr vy cA wral vz cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr
      wi vy cR cuni cuni wral wa wph cX cR cuni cuni wceq vz cv vy cv cR wbr vz
      cA wral vx cv vy cv cR wbr wi vy cX wral vz cv vy cv cR wbr vz cA wral vx
      cv vy cv cR wbr wi vy cR cuni cuni wral vy cv vx cv cR wbr vy cA wral vz
      cv vy cv cR wbr vz cA wral vx cv vy cv cR wbr wi vy cX cR cuni cuni
      raleq1 anbi2d spwval.2 syl5bb rexeqd syl notbid adantr cR cps wcel cR cA
      cspw co cX wcel wn cR cA cspw co cR cuni cuni wcel wn wb cA cW wcel cR
      cps wcel cR cA cspw co cX wcel cR cA cspw co cR cuni cuni wcel cR cps
      wcel cX cR cuni cuni cR cA cspw co cR cps wcel cR cdm cR cuni cuni cX cR
      cps wcel cR cdm cR cuni cuni wceq cR crn cR cuni cuni wceq cR psdmrn
      pm3.26d spwval.1 syl5eq eleq2d notbid adantr 3imtr4d 3impia $.
      $( [24-Jun-2008] $) $( [15-May-2008] $)

    $( A supremum exists iff ` R supw A ` belongs to the domain of ` R ` . $)
    spwex $p |- ( ( R e. Poset /\ A e. W )
               -> ( E. x e. X ph <-> ( R supw A ) e. X ) ) $=
      cR cps wcel cA cW wcel wa wph vx cX wrex cR cA cspw co cX wcel cR cps
      wcel cA cW wcel wph vx cX wrex cR cA cspw co cX wcel wph vx vy vz cA cR
      cW cX spwval.1 spwval.2 spwcl 3expia cR cps wcel cA cW wcel wa wph vx cX
      wrex cR cA cspw co cX wcel cR cps wcel cA cW wcel wph vx cX wrex wn cR cA
      cspw co cX wcel wn wph vx vy vz cA cR cW cX spwval.1 spwval.2 spwnex
      3expia con4d impbid $.
      $( [25-May-2009] $) $( [15-May-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y C $.  $d x y z R $.  $d x y X $.
    spwpr4.1 $e |- X = dom R $.
    $( Supremum of an unordered pair. $)
    spwpr4 $p |- ( ( ( R e. Poset /\ C e. D ) /\ ( A R C /\ B R C ) /\
   A. x e. X ( ( A R x /\ B R x ) -> C R x ) ) -> ( R supw { A , B } ) = C ) $=
      cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB
      vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cR cA cB cpr cspw co cC
      wceq cR cps wcel cC cD wcel wa cR cps wcel cC cX wcel wa cA cC cR wbr cB
      cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral w3a cR cA cB cpr cspw co vx cv vy cv cR wbr vx cA cB cpr wral vz cv
      vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX
      crab cuni cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX crab cuni cC cR cps wcel
      cA cB cpr cvv wcel vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR
      wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cR
      cA cB cpr cspw co vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr
      vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX crab cuni
      wceq cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a vx cv vy cv cR
      wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR
      wbr wi vx cX wral wa vy vx vz cA cB cpr cR cvv cX spwpr4.1 vx cv vy cv cR
      wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR
      wbr wi vx cX wral wa biid spwval cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa cR cps wcel cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv
      cR wbr wi vx cX wral cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa
      simpll 3adant3 cA cB cpr cvv wcel cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx
      cX wral w3a cA cB prex a1i cR cps wcel cC cX wcel wa cA cC cR wbr cB cC
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral w3a vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB
      cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR wbr
      cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr
      wi vx cX wral wa vy cX wrex cC cX wcel cA cC cR wbr cB cC cR wbr wa cA vx
      cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cA vy cv cR
      wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR
      wbr wi vx cX wral wa vy cX wrex cR cps wcel cC cX wcel cA cC cR wbr cB cC
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR wbr cB vy
      cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx
      cX wral wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa cC vx cv cR wbr wi vx cX wral wa vy cC cX vy cv cC wceq cA vy cv cR
      wbr cB vy cv cR wbr wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx
      cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral vy cv cC wceq cA vy cv cR wbr cA cC
      cR wbr cB vy cv cR wbr cB cC cR wbr vy cv cC cA cR breq2 vy cv cC cB cR
      breq2 anbi12d vy cv cC wceq cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx
      cv cR wbr wi cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      vy cv cC wceq vy cv vx cv cR wbr cC vx cv cR wbr cA vx cv cR wbr cB vx cv
      cR wbr wa vy cv cC vx cv cR breq1 imbi2d ralbidv anbi12d rcla4ev 3impb
      3adant1l cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR wbr cB vy cv cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy
      cX wrex wb cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX cR cps
      wcel cA cvv wcel cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz
      cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA
      vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv
      vx cv cR wbr wi vx cX wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa wa cR cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB
      cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA
      cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa wb cA cB cpr eqid vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx
      cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz
      cA cB cpr cA cB cR cps cvv cvv cX vx cv vy cv cR wbr vx cA cB cpr wral vz
      cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      biid spwpr2 mpanl2 cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa
      simpll cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel
      wa cC cX wcel cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv
      wcel wa cR cps wcel cR wrel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB
      cvv wcel wa wi cR psrel cR wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB
      cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB
      cC cR wbr cB cvv wcel cB cC cR brrelex ex anim12d syl imp adantlr sylanc
      rexbidv 3adant3 mpbird syl3anc cR cps wcel cC cX wcel wa cA cC cR wbr cB
      cC cR wbr wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz
      cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX crab cuni cA vy
      cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx
      cv cR wbr wi vx cX wral wa vy cX crab cuni wceq cA vx cv cR wbr cB vx cv
      cR wbr wa cC vx cv cR wbr wi vx cX wral cR cps wcel cC cX wcel wa cA cC
      cR wbr cB cC cR wbr wa wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx
      cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX
      crab cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa vy cv vx cv cR wbr wi vx cX wral wa vy cX crab cR cps wcel cC cX wcel
      wa cA cC cR wbr cB cC cR wbr wa wa vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy
      cv vx cv cR wbr wi vx cX wral wa vy cX cR cps wcel cA cvv wcel cB cvv
      wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB
      cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa cR
      cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB cvv wcel wa vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa wb cA cB cpr
      eqid vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr
      wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz cA cB cpr cA cB cR cps
      cvv cvv cX vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA
      cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa biid spwpr2 mpanl2 cR cps
      wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR
      wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA
      cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel
      cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR
      wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR
      wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB
      cC cR brrelex ex anim12d syl imp adantlr sylanc rabbisdv unieqd 3adant3
      cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB
      vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a cA cC cR wbr cB cC cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral
      wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa
      vy cv vx cv cR wbr wi vx cX wral wa vy cX crab cuni cC wceq cR cps wcel
      cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral 3simpc cC cX wcel cA vy cv cR wbr cB
      vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi
      vx cX wral wa vy cX wreu cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB
      vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa vy cX crab cuni cC wceq wb cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx
      cX wral w3a cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv
      cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa cA cC cR wbr cB cC cR wbr
      wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral wa vy
      cX cC vy cv cC wceq cA vy cv cR wbr cB vy cv cR wbr wa cA cC cR wbr cB cC
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral vy
      cv cC wceq cA vy cv cR wbr cA cC cR wbr cB vy cv cR wbr cB cC cR wbr vy
      cv cC cA cR breq2 vy cv cC cB cR breq2 anbi12d vy cv cC wceq cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX vy cv cC wceq vy cv vx cv cR wbr cC vx cv
      cR wbr cA vx cv cR wbr cB vx cv cR wbr wa vy cv cC vx cv cR breq1 imbi2d
      ralbidv anbi12d reuuni2 cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR
      wbr wa cC cX wcel cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi
      vx cX wral cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simplr
      3adant3 cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv
      cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa vy cX wreu cA vy cv cR wbr cB vy cv cR wbr wa cA
      vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX
      wreu cR cps wcel vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr
      vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa vy cX wreu cR cps wcel cC cX wcel wa cA cC cR
      wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi
      vx cX wral w3a vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz
      cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz cA cB cpr cR
      cX vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr
      wral vy cv vx cv cR wbr wi vx cX wral wa biid spweu cR cps wcel cC cX
      wcel wa cA cC cR wbr cB cC cR wbr wa cR cps wcel cA vx cv cR wbr cB vx cv
      cR wbr wa cC vx cv cR wbr wi vx cX wral cR cps wcel cC cX wcel cA cC cR
      wbr cB cC cR wbr wa simpll 3adant3 cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx
      cX wral w3a vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA
      cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR
      wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR
      wbr wi vx cX wral wa vy cX wrex cC cX wcel cA cC cR wbr cB cC cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cA vy cv
      cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv
      cR wbr wi vx cX wral wa vy cX wrex cR cps wcel cC cX wcel cA cC cR wbr cB
      cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR wbr cB vy
      cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx
      cX wral wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa cC vx cv cR wbr wi vx cX wral wa vy cC cX vy cv cC wceq cA vy cv cR
      wbr cB vy cv cR wbr wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx
      cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral vy cv cC wceq cA vy cv cR wbr cA cC
      cR wbr cB vy cv cR wbr cB cC cR wbr vy cv cC cA cR breq2 vy cv cC cB cR
      breq2 anbi12d vy cv cC wceq cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx
      cv cR wbr wi cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      vy cv cC wceq vy cv vx cv cR wbr cC vx cv cR wbr cA vx cv cR wbr cB vx cv
      cR wbr wa vy cv cC vx cv cR breq1 imbi2d ralbidv anbi12d rcla4ev 3impb
      3adant1l cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR wbr cB vy cv cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy
      cX wrex wb cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX cR cps
      wcel cA cvv wcel cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz
      cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA
      vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv
      vx cv cR wbr wi vx cX wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa wa cR cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB
      cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA
      cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa wb cA cB cpr eqid vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx
      cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz
      cA cB cpr cA cB cR cps cvv cvv cX vx cv vy cv cR wbr vx cA cB cpr wral vz
      cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      biid spwpr2 mpanl2 cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa
      simpll cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel
      wa cC cX wcel cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv
      wcel wa cR cps wcel cR wrel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB
      cvv wcel wa wi cR psrel cR wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB
      cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB
      cC cR wbr cB cvv wcel cB cC cR brrelex ex anim12d syl imp adantlr sylanc
      rexbidv 3adant3 mpbird sylanc cR cps wcel cC cX wcel wa cA cC cR wbr cB
      cC cR wbr wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz
      cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX wreu cA vy cv cR
      wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR
      wbr wi vx cX wral wa vy cX wreu wb cA vx cv cR wbr cB vx cv cR wbr wa cC
      vx cv cR wbr wi vx cX wral cR cps wcel cC cX wcel wa cA cC cR wbr cB cC
      cR wbr wa wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz
      cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy
      cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx
      cX wral wa vy cX cR cps wcel cA cvv wcel cB cvv wcel wa vx cv vy cv cR
      wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR
      wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr
      cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa wb cR cps wcel cC
      cX wcel wa cA cC cR wbr cB cC cR wbr wa wa cR cps wcel cA cB cpr cA cB
      cpr wceq cA cvv wcel cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy
      cv vx cv cR wbr wi vx cX wral wa wb cA cB cpr eqid vx cv vy cv cR wbr vx
      cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi
      vx cX wral wa vy vx vz cA cB cpr cA cB cR cps cvv cvv cX vx cv vy cv cR
      wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR
      wbr wi vx cX wral wa biid spwpr2 mpanl2 cR cps wcel cC cX wcel cA cC cR
      wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR wbr cB cC cR wbr wa cA
      cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA cC cR wbr cB cC cR wbr
      wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel cA cC cR wbr cB cC cR
      wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR wrel cA cC cR wbr cA cvv
      wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA cC cR
      brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB cC cR brrelex ex anim12d
      syl imp adantlr sylanc reubidv 3adant3 mpbid sylanc mpbid 3eqtrd cR cps
      wcel cC cD wcel wa cA cC cR wbr cB cC cR wbr wa cR cps wcel cC cX wcel wa
      cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cR cps
      wcel cC cD wcel wa cA cC cR wbr cB cC cR wbr wa wa cR cps wcel cC cX wcel
      cR cps wcel cC cD wcel cA cC cR wbr cB cC cR wbr wa simpll cR cps wcel cC
      cD wcel wa cA cC cR wbr cC cX wcel cB cC cR wbr cR cps wcel cC cD wcel wa
      cA cC cR wbr wa cC cR crn cX cR cps wcel cC cD wcel cA cC cR wbr cC cR
      crn wcel cC cD wcel cR cps wcel cA cC cR wbr cC cR crn wcel cC cD wcel cR
      wrel cA cC cR wbr cC cR crn wcel cR cps wcel cA cC cD cR relelrng cR
      psrel syl3an2 3com12 3expa cR cps wcel cX cR crn wceq cC cD wcel cA cC cR
      wbr cR cX spwpr4.1 psrn ad2antrr eleqtrrd adantrr jca 3adant3 syld3an1 $.
      $( [8-Jun-2009] $) $( [7-Jul-2008] $)

    ${
      spwpr5.2 $e |- C = ( R supw { A , B } ) $.
    $}

    $( Supremum of an unordered pair. $)
    spwpr4OLD $p |- ( ( ( R e. Poset /\ C e. X ) /\ ( A R C /\ B R C ) /\
   A. x e. X ( ( A R x /\ B R x ) -> C R x ) ) -> ( R supw { A , B } ) = C ) $=
      cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB
      vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a cR cA cB cpr cspw co vx
      cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy
      cv vx cv cR wbr wi vx cX wral wa vy cX crab cuni cA vy cv cR wbr cB vy cv
      cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa vy cX crab cuni cC cR cps wcel cA cB cpr cvv wcel vx cv vy cv cR
      wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR
      wbr wi vx cX wral wa vy cX wrex cR cA cB cpr cspw co vx cv vy cv cR wbr
      vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr
      wi vx cX wral wa vy cX crab cuni wceq cR cps wcel cC cX wcel wa cA cC cR
      wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi
      vx cX wral w3a vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz
      cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz cA cB cpr cR
      cvv cX spwpr4.1 vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr
      vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa biid spwval cR cps
      wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cR cps wcel cA vx cv cR
      wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cR cps wcel cC cX
      wcel cA cC cR wbr cB cC cR wbr wa simpll 3adant3 cA cB cpr cvv wcel cR
      cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx
      cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a cA cB prex a1i cR cps wcel
      cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral w3a vx cv vy cv cR wbr vx cA cB cpr
      wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX
      wral wa vy cX wrex cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB
      vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cC cX wcel
      cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv
      cR wbr wi vx cX wral cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr
      cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cR cps
      wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral cA vy cv cR wbr cB vy cv cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy
      cX wrex cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa vy cv vx cv cR wbr wi vx cX wral wa cA cC cR wbr cB cC cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral wa vy cC
      cX vy cv cC wceq cA vy cv cR wbr cB vy cv cR wbr wa cA cC cR wbr cB cC cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral vy
      cv cC wceq cA vy cv cR wbr cA cC cR wbr cB vy cv cR wbr cB cC cR wbr vy
      cv cC cA cR breq2 vy cv cC cB cR breq2 anbi12d vy cv cC wceq cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX vy cv cC wceq vy cv vx cv cR wbr cC vx cv
      cR wbr cA vx cv cR wbr cB vx cv cR wbr wa vy cv cC vx cv cR breq1 imbi2d
      ralbidv anbi12d rcla4ev 3impb 3adant1l cR cps wcel cC cX wcel wa cA cC cR
      wbr cB cC cR wbr wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR
      wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex cA
      vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv
      vx cv cR wbr wi vx cX wral wa vy cX wrex wb cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral cR cps wcel cC cX wcel wa cA cC cR
      wbr cB cC cR wbr wa wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv
      cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR
      wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR
      wbr wi vx cX wral wa vy cX cR cps wcel cA cvv wcel cB cvv wcel wa vx cv
      vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv
      vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv
      cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa wb cR cps
      wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa cR cps wcel cA cB cpr
      cA cB cpr wceq cA cvv wcel cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr
      wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX
      wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa vy cv vx cv cR wbr wi vx cX wral wa wb cA cB cpr eqid vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa vy vx vz cA cB cpr cA cB cR cps cvv cvv cX vx cv
      vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv
      vx cv cR wbr wi vx cX wral wa biid spwpr2 mpanl2 cR cps wcel cC cX wcel
      cA cC cR wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR wbr cB cC cR wbr
      wa cA cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA cC cR wbr cB cC
      cR wbr wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel cA cC cR wbr cB
      cC cR wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR wrel cA cC cR wbr
      cA cvv wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA
      cC cR brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB cC cR brrelex ex
      anim12d syl imp adantlr sylanc rexbidv 3adant3 mpbird syl3anc cR cps wcel
      cC cX wcel wa cA cC cR wbr cB cC cR wbr wa vx cv vy cv cR wbr vx cA cB
      cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX
      wral wa vy cX crab cuni cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX crab
      cuni wceq cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      wral cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa vy cX crab cA vy cv cR wbr cB vy cv cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy
      cX crab cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa vx cv
      vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv
      vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv
      cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX cR
      cps wcel cA cvv wcel cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy
      cv vx cv cR wbr wi vx cX wral wa wb cR cps wcel cC cX wcel wa cA cC cR
      wbr cB cC cR wbr wa wa cR cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel
      cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz
      cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy
      cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx
      cX wral wa wb cA cB cpr eqid vx cv vy cv cR wbr vx cA cB cpr wral vz cv
      vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy vx
      vz cA cB cpr cA cB cR cps cvv cvv cX vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      biid spwpr2 mpanl2 cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa
      simpll cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel
      wa cC cX wcel cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv
      wcel wa cR cps wcel cR wrel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB
      cvv wcel wa wi cR psrel cR wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB
      cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB
      cC cR wbr cB cvv wcel cB cC cR brrelex ex anim12d syl imp adantlr sylanc
      rabbisdv unieqd 3adant3 cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral
      w3a cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx
      cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX crab
      cuni cC wceq cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx
      cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral 3simpc cC cX
      wcel cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wreu cA cC cR wbr cB cC cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral
      wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa
      vy cv vx cv cR wbr wi vx cX wral wa vy cX crab cuni cC wceq wb cR cps
      wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv
      cR wbr wa cC vx cv cR wbr wi vx cX wral w3a cA vy cv cR wbr cB vy cv cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa
      cC vx cv cR wbr wi vx cX wral wa vy cX cC vy cv cC wceq cA vy cv cR wbr
      cB vy cv cR wbr wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv
      cR wbr wa vy cv vx cv cR wbr wi vx cX wral cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral vy cv cC wceq cA vy cv cR wbr cA cC
      cR wbr cB vy cv cR wbr cB cC cR wbr vy cv cC cA cR breq2 vy cv cC cB cR
      breq2 anbi12d vy cv cC wceq cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx
      cv cR wbr wi cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX
      vy cv cC wceq vy cv vx cv cR wbr cC vx cv cR wbr cA vx cv cR wbr cB vx cv
      cR wbr wa vy cv cC vx cv cR breq1 imbi2d ralbidv anbi12d reuuni2 cR cps
      wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cC cX wcel cA vx cv cR
      wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cR cps wcel cC cX
      wcel cA cC cR wbr cB cC cR wbr wa simplr 3adant3 cR cps wcel cC cX wcel
      wa cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx
      cv cR wbr wi vx cX wral w3a vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx
      cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy cX
      wreu cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr
      wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wreu cR cps wcel vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa vy cX wrex vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      vy cX wreu cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx
      cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a vx cv vy
      cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx
      cv cR wbr wi vx cX wral wa vy vx vz cA cB cpr cR cX vx cv vy cv cR wbr vx
      cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi
      vx cX wral wa biid spweu cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR
      wbr wa cR cps wcel cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi
      vx cX wral cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simpll
      3adant3 cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vx cv
      cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral w3a vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa vy cX wrex cA vy cv cR wbr cB vy cv cR wbr wa cA
      vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX
      wrex cC cX wcel cA cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa cC vx cv cR wbr wi vx cX wral cA vy cv cR wbr cB vy cv cR wbr wa
      cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy
      cX wrex cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cA vy cv cR wbr cB
      vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi
      vx cX wral wa vy cX wrex cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa cA cC cR wbr
      cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx
      cX wral wa vy cC cX vy cv cC wceq cA vy cv cR wbr cB vy cv cR wbr wa cA
      cC cR wbr cB cC cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv
      cR wbr wi vx cX wral cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr
      wi vx cX wral vy cv cC wceq cA vy cv cR wbr cA cC cR wbr cB vy cv cR wbr
      cB cC cR wbr vy cv cC cA cR breq2 vy cv cC cB cR breq2 anbi12d vy cv cC
      wceq cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi cA vx cv cR
      wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX vy cv cC wceq vy cv vx cv
      cR wbr cC vx cv cR wbr cA vx cv cR wbr cB vx cv cR wbr wa vy cv cC vx cv
      cR breq1 imbi2d ralbidv anbi12d rcla4ev 3impb 3adant1l cR cps wcel cC cX
      wcel wa cA cC cR wbr cB cC cR wbr wa vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      vy cX wrex cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR
      wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX wrex wb cA vx cv cR wbr
      cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral cR cps wcel cC cX wcel
      wa cA cC cR wbr cB cC cR wbr wa wa vx cv vy cv cR wbr vx cA cB cpr wral
      vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa
      cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy
      cv vx cv cR wbr wi vx cX wral wa vy cX cR cps wcel cA cvv wcel cB cvv
      wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB
      cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR
      wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX
      wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa cR
      cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB cvv wcel wa vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR
      wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa wb cA cB cpr
      eqid vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr
      wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz cA cB cpr cA cB cR cps
      cvv cvv cX vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA
      cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa biid spwpr2 mpanl2 cR cps
      wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR
      wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA
      cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel
      cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR
      wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR
      wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB
      cC cR brrelex ex anim12d syl imp adantlr sylanc rexbidv 3adant3 mpbird
      sylanc cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa vx cv vy cv
      cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv
      cR wbr wi vx cX wral wa vy cX wreu cA vy cv cR wbr cB vy cv cR wbr wa cA
      vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX
      wreu wb cA vx cv cR wbr cB vx cv cR wbr wa cC vx cv cR wbr wi vx cX wral
      cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa vx cv vy cv cR
      wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr wral vy cv vx cv cR
      wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr wa cA vx cv cR wbr
      cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa vy cX cR cps wcel
      cA cvv wcel cB cvv wcel wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx
      cv cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv
      cR wbr cB vy cv cR wbr wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv
      cR wbr wi vx cX wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr cB cC
      cR wbr wa wa cR cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB cvv wcel
      wa vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr vz cA cB cpr
      wral vy cv vx cv cR wbr wi vx cX wral wa cA vy cv cR wbr cB vy cv cR wbr
      wa cA vx cv cR wbr cB vx cv cR wbr wa vy cv vx cv cR wbr wi vx cX wral wa
      wb cA cB cpr eqid vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv cR wbr
      vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa vy vx vz cA cB cpr
      cA cB cR cps cvv cvv cX vx cv vy cv cR wbr vx cA cB cpr wral vz cv vx cv
      cR wbr vz cA cB cpr wral vy cv vx cv cR wbr wi vx cX wral wa biid spwpr2
      mpanl2 cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simpll cR cps
      wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cC cX wcel
      cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cR
      cps wcel cR wrel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa
      wi cR psrel cR wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB cvv wcel cR
      wrel cA cC cR wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB cC cR wbr cB
      cvv wcel cB cC cR brrelex ex anim12d syl imp adantlr sylanc reubidv
      3adant3 mpbid sylanc mpbid 3eqtrd $.
      $( [29-Jul-2008] $) $( [7-Jul-2008] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y C $.  $d x y z R $.  $d x y X $.
    spwpr4a.1 $e |- X = dom R $.
    spwpr4a.2 $e |- ( ph <-> ( A. y e. { A , B } y R x /\
            A. y e. X ( A. z e. { A , B } z R y -> x R y ) ) ) $.
    $( Supremum of an unordered pair. $)
    spwpr4aOLD $p |- ( ( ( R e. Poset /\ C e. X ) /\ ( A R C /\ B R C ) /\
   A. y e. X ( ( A R y /\ B R y ) -> C R y ) ) -> ( R supw { A , B } ) = C ) $=
      cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB
      vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral w3a cR cA cB cpr cspw co
      wph vx cX crab cuni cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB
      vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX crab cuni cC cR
      cps wcel cA cB cpr cvv wcel wph vx cX wrex cR cA cB cpr cspw co wph vx cX
      crab cuni wceq cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA
      vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral w3a wph vx
      vy vz cA cB cpr cR cvv cX spwpr4a.1 spwpr4a.2 spwval cR cps wcel cC cX
      wcel wa cA cC cR wbr cB cC cR wbr wa cR cps wcel cA vy cv cR wbr cB vy cv
      cR wbr wa cC vy cv cR wbr wi vy cX wral cR cps wcel cC cX wcel cA cC cR
      wbr cB cC cR wbr wa simpll 3adant3 cA cB cpr cvv wcel cR cps wcel cC cX
      wcel wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa
      cC vy cv cR wbr wi vy cX wral w3a cA cB prex a1i cR cps wcel cC cX wcel
      wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa cC vy
      cv cR wbr wi vy cX wral w3a wph vx cX wrex cA vx cv cR wbr cB vx cv cR
      wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX
      wral wa vx cX wrex cC cX wcel cA cC cR wbr cB cC cR wbr wa cA vy cv cR
      wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral cA vx cv cR wbr cB
      vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi
      vy cX wral wa vx cX wrex cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr
      wa cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral cA vx
      cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy
      cv cR wbr wi vy cX wral wa vx cX wrex cA vx cv cR wbr cB vx cv cR wbr wa
      cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa cA
      cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR
      wbr wi vy cX wral wa vx cC cX vx cv cC wceq cA vx cv cR wbr cB vx cv cR
      wbr wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx
      cv vy cv cR wbr wi vy cX wral cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv
      cR wbr wi vy cX wral vx cv cC wceq cA vx cv cR wbr cA cC cR wbr cB vx cv
      cR wbr cB cC cR wbr vx cv cC cA cR breq2 vx cv cC cB cR breq2 anbi12d vx
      cv cC wceq cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi cA vy
      cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX vx cv cC wceq vx cv
      vy cv cR wbr cC vy cv cR wbr cA vy cv cR wbr cB vy cv cR wbr wa vx cv cC
      vy cv cR breq1 imbi2d ralbidv anbi12d rcla4ev 3impb 3adant1l cR cps wcel
      cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wph vx cX wrex cA vx cv cR wbr
      cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr
      wi vy cX wral wa vx cX wrex wb cA vy cv cR wbr cB vy cv cR wbr wa cC vy
      cv cR wbr wi vy cX wral cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR
      wbr wa wa wph cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv
      cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX cR cps wcel cA cvv
      wcel cB cvv wcel wa wph cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR
      wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa wb cR cps wcel
      cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa cR cps wcel cA cB cpr cA cB
      cpr wceq cA cvv wcel cB cvv wcel wa wph cA vx cv cR wbr cB vx cv cR wbr
      wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa
      wb cA cB cpr eqid wph vx vy vz cA cB cpr cA cB cR cps cvv cvv cX
      spwpr4a.2 spwpr2 mpanl2 cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr
      wa simpll cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv
      wcel wa cC cX wcel cR cps wcel cA cC cR wbr cB cC cR wbr wa cA cvv wcel
      cB cvv wcel wa cR cps wcel cR wrel cA cC cR wbr cB cC cR wbr wa cA cvv
      wcel cB cvv wcel wa wi cR psrel cR wrel cA cC cR wbr cA cvv wcel cB cC cR
      wbr cB cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA cC cR brrelex ex cR
      wrel cB cC cR wbr cB cvv wcel cB cC cR brrelex ex anim12d syl imp adantlr
      sylanc rexbidv 3adant3 mpbird syl3anc cR cps wcel cC cX wcel wa cA cC cR
      wbr cB cC cR wbr wa wph vx cX crab cuni cA vx cv cR wbr cB vx cv cR wbr
      wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa
      vx cX crab cuni wceq cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr
      wi vy cX wral cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa
      wph vx cX crab cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy
      cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX crab cR cps wcel
      cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa wph cA vx cv cR wbr cB vx
      cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy
      cX wral wa vx cX cR cps wcel cA cvv wcel cB cvv wcel wa wph cA vx cv cR
      wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR
      wbr wi vy cX wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR
      wbr wa wa cR cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB cvv wcel wa
      wph cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa
      vx cv vy cv cR wbr wi vy cX wral wa wb cA cB cpr eqid wph vx vy vz cA cB
      cpr cA cB cR cps cvv cvv cX spwpr4a.2 spwpr2 mpanl2 cR cps wcel cC cX
      wcel cA cC cR wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR wbr cB cC
      cR wbr wa cA cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA cC cR wbr
      cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel cA cC cR
      wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR wrel cA cC
      cR wbr cA cvv wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR wbr cA cvv
      wcel cA cC cR brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB cC cR
      brrelex ex anim12d syl imp adantlr sylanc rabbisdv unieqd 3adant3 cR cps
      wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv
      cR wbr wa cC vy cv cR wbr wi vy cX wral w3a cA cC cR wbr cB cC cR wbr wa
      cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral wa cA vx
      cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy
      cv cR wbr wi vy cX wral wa vx cX crab cuni cC wceq cR cps wcel cC cX wcel
      wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa cC vy
      cv cR wbr wi vy cX wral 3simpc cC cX wcel cA vx cv cR wbr cB vx cv cR wbr
      wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa
      vx cX wreu cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr
      wa cC vy cv cR wbr wi vy cX wral wa cA vx cv cR wbr cB vx cv cR wbr wa cA
      vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX
      crab cuni cC wceq wb cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr
      wa cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral w3a
      cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx
      cv vy cv cR wbr wi vy cX wral wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR
      wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral wa vx cX cC vx cv cC
      wceq cA vx cv cR wbr cB vx cv cR wbr wa cA cC cR wbr cB cC cR wbr wa cA
      vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral cA vy cv
      cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral vx cv cC wceq cA
      vx cv cR wbr cA cC cR wbr cB vx cv cR wbr cB cC cR wbr vx cv cC cA cR
      breq2 vx cv cC cB cR breq2 anbi12d vx cv cC wceq cA vy cv cR wbr cB vy cv
      cR wbr wa vx cv vy cv cR wbr wi cA vy cv cR wbr cB vy cv cR wbr wa cC vy
      cv cR wbr wi vy cX vx cv cC wceq vx cv vy cv cR wbr cC vy cv cR wbr cA vy
      cv cR wbr cB vy cv cR wbr wa vx cv cC vy cv cR breq1 imbi2d ralbidv
      anbi12d reuuni2 cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cC
      cX wcel cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral
      cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simplr 3adant3 cR cps
      wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv
      cR wbr wa cC vy cv cR wbr wi vy cX wral w3a wph vx cX wreu cA vx cv cR
      wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR
      wbr wi vy cX wral wa vx cX wreu cR cps wcel wph vx cX wrex wph vx cX wreu
      cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB
      vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral w3a wph vx vy vz cA cB cpr
      cR cX spwpr4a.2 spweu cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr
      wa cR cps wcel cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy
      cX wral cR cps wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simpll
      3adant3 cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa cA vy cv
      cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral w3a wph vx cX
      wrex cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr
      wa vx cv vy cv cR wbr wi vy cX wral wa vx cX wrex cC cX wcel cA cC cR wbr
      cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy
      cX wral cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR
      wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX wrex cR cps wcel cC cX
      wcel cA cC cR wbr cB cC cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa cC
      vy cv cR wbr wi vy cX wral cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR
      wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX wrex cA
      vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv
      vy cv cR wbr wi vy cX wral wa cA cC cR wbr cB cC cR wbr wa cA vy cv cR
      wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral wa vx cC cX vx cv cC
      wceq cA vx cv cR wbr cB vx cv cR wbr wa cA cC cR wbr cB cC cR wbr wa cA
      vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral cA vy cv
      cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral vx cv cC wceq cA
      vx cv cR wbr cA cC cR wbr cB vx cv cR wbr cB cC cR wbr vx cv cC cA cR
      breq2 vx cv cC cB cR breq2 anbi12d vx cv cC wceq cA vy cv cR wbr cB vy cv
      cR wbr wa vx cv vy cv cR wbr wi cA vy cv cR wbr cB vy cv cR wbr wa cC vy
      cv cR wbr wi vy cX vx cv cC wceq vx cv vy cv cR wbr cC vy cv cR wbr cA vy
      cv cR wbr cB vy cv cR wbr wa vx cv cC vy cv cR breq1 imbi2d ralbidv
      anbi12d rcla4ev 3impb 3adant1l cR cps wcel cC cX wcel wa cA cC cR wbr cB
      cC cR wbr wa wph vx cX wrex cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv
      cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX wrex
      wb cA vy cv cR wbr cB vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral cR
      cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa wph cA vx cv cR
      wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR
      wbr wi vy cX wral wa vx cX cR cps wcel cA cvv wcel cB cvv wcel wa wph cA
      vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv
      vy cv cR wbr wi vy cX wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr
      cB cC cR wbr wa wa cR cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB
      cvv wcel wa wph cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy
      cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa wb cA cB cpr eqid wph vx
      vy vz cA cB cpr cA cB cR cps cvv cvv cX spwpr4a.2 spwpr2 mpanl2 cR cps
      wcel cC cX wcel cA cC cR wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR
      wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA
      cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel
      cA cC cR wbr cB cC cR wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR
      wrel cA cC cR wbr cA cvv wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR
      wbr cA cvv wcel cA cC cR brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB
      cC cR brrelex ex anim12d syl imp adantlr sylanc rexbidv 3adant3 mpbird
      sylanc cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wph vx cX
      wreu cA vx cv cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr
      wa vx cv vy cv cR wbr wi vy cX wral wa vx cX wreu wb cA vy cv cR wbr cB
      vy cv cR wbr wa cC vy cv cR wbr wi vy cX wral cR cps wcel cC cX wcel wa
      cA cC cR wbr cB cC cR wbr wa wa wph cA vx cv cR wbr cB vx cv cR wbr wa cA
      vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX wral wa vx cX
      cR cps wcel cA cvv wcel cB cvv wcel wa wph cA vx cv cR wbr cB vx cv cR
      wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv cR wbr wi vy cX
      wral wa wb cR cps wcel cC cX wcel wa cA cC cR wbr cB cC cR wbr wa wa cR
      cps wcel cA cB cpr cA cB cpr wceq cA cvv wcel cB cvv wcel wa wph cA vx cv
      cR wbr cB vx cv cR wbr wa cA vy cv cR wbr cB vy cv cR wbr wa vx cv vy cv
      cR wbr wi vy cX wral wa wb cA cB cpr eqid wph vx vy vz cA cB cpr cA cB cR
      cps cvv cvv cX spwpr4a.2 spwpr2 mpanl2 cR cps wcel cC cX wcel cA cC cR
      wbr cB cC cR wbr wa simpll cR cps wcel cA cC cR wbr cB cC cR wbr wa cA
      cvv wcel cB cvv wcel wa cC cX wcel cR cps wcel cA cC cR wbr cB cC cR wbr
      wa cA cvv wcel cB cvv wcel wa cR cps wcel cR wrel cA cC cR wbr cB cC cR
      wbr wa cA cvv wcel cB cvv wcel wa wi cR psrel cR wrel cA cC cR wbr cA cvv
      wcel cB cC cR wbr cB cvv wcel cR wrel cA cC cR wbr cA cvv wcel cA cC cR
      brrelex ex cR wrel cB cC cR wbr cB cvv wcel cB cC cR brrelex ex anim12d
      syl imp adantlr sylanc reubidv 3adant3 mpbid sylanc mpbid 3eqtrd $.
      $( [1-Aug-2008] $) $( [7-Jul-2008] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    $( Supremum of an unordered pair of comparable elements. $)
    spwpr4c $p |- ( ( R e. Poset /\ B e. U /\ A R B )
         -> ( R supw { A , B } ) = B ) $=
      cR cps wcel cB cU wcel wa cA cB cR wbr cB cB cR wbr wa cA vx cv cR wbr cB
      vx cv cR wbr wa cB vx cv cR wbr wi vx cR cdm wral cR cA cB cpr cspw co cB
      wceq cR cps wcel cB cU wcel cA cB cR wbr w3a vx cA cB cB cU cR cR cdm cR
      cdm eqid spwpr4 cR cps wcel cB cU wcel cA cB cR wbr 3simpa cR cps wcel cB
      cU wcel cA cB cR wbr w3a cA cB cR wbr cB cB cR wbr cR cps wcel cB cU wcel
      cA cB cR wbr 3simp3 cR cps wcel cB cR cdm wcel cB cB cR wbr cR cps wcel
      cB cU wcel cA cB cR wbr w3a cB cR cR cdm cR cdm eqid psref cR cps wcel cB
      cU wcel cA cB cR wbr 3simp1 cR cps wcel cB cU wcel cA cB cR wbr w3a cB cR
      crn cR cdm cA cvv wcel cB cU wcel cA cB cR wbr cB cR crn wcel cR cps wcel
      cA cB cR cvv cU brelrng cR cps wcel cA cB cR wbr cA cvv wcel cB cU wcel
      cR wrel cA cB cR wbr cA cvv wcel cR cps wcel cA cB cR brrelex cR psrel
      sylan 3adant2 syld3an1 cR cps wcel cB cU wcel cR cdm cR crn wceq cA cB cR
      wbr cR cR cdm cR cdm eqid psrn 3ad2ant1 eleqtrrd sylanc jca cA vx cv cR
      wbr cB vx cv cR wbr wa cB vx cv cR wbr wi vx cR cdm wral cR cps wcel cB
      cU wcel cA cB cR wbr w3a cA vx cv cR wbr cB vx cv cR wbr wa cB vx cv cR
      wbr wi vx cR cdm cA vx cv cR wbr cB vx cv cR wbr wa cB vx cv cR wbr wi vx
      cv cR cdm wcel cA vx cv cR wbr cB vx cv cR wbr pm3.27 a1i rgen a1i
      syl3anc $.
      $( [9-Jun-2009] $) $( [7-Jul-2008] $)
  $}

  ${
    $d x y A $.  $d y B $.  $d r x y R $.  $d r x y X $.
    isla.1 $e |- X = dom R $.
    $( The predicate "is a lattice" i.e. a poset in which any two elements have
       upper and lower bounds. $)
    isla $p |- ( R e. Lat <-> ( R e. Poset /\ A. x e. X A. y e. X
      ( ( R supw { x , y } ) e. X /\ ( R infw { x , y } ) e. X ) ) ) $=
      vr cv vx cv vy cv cpr cspw co vr cv cdm wcel vr cv vx cv vy cv cpr cinf
      co vr cv cdm wcel wa vy vr cv cdm wral vx vr cv cdm wral cR vx cv vy cv
      cpr cspw co cX wcel cR vx cv vy cv cpr cinf co cX wcel wa vy cX wral vx
      cX wral vr cR cps cla vr cv cR wceq vr cv vx cv vy cv cpr cspw co vr cv
      cdm wcel vr cv vx cv vy cv cpr cinf co vr cv cdm wcel wa vy vr cv cdm
      wral cR vx cv vy cv cpr cspw co cX wcel cR vx cv vy cv cpr cinf co cX
      wcel wa vy cX wral vx vr cv cdm cX vr cv cR wceq vr cv cdm cR cdm cX vr
      cv cR dmeq isla.1 syl6eqr vr cv cR wceq vr cv vx cv vy cv cpr cspw co vr
      cv cdm wcel vr cv vx cv vy cv cpr cinf co vr cv cdm wcel wa cR vx cv vy
      cv cpr cspw co cX wcel cR vx cv vy cv cpr cinf co cX wcel wa vy vr cv cdm
      cX vr cv cR wceq vr cv cdm cR cdm cX vr cv cR dmeq isla.1 syl6eqr vr cv
      cR wceq vr cv vx cv vy cv cpr cspw co vr cv cdm wcel cR vx cv vy cv cpr
      cspw co cX wcel vr cv vx cv vy cv cpr cinf co vr cv cdm wcel cR vx cv vy
      cv cpr cinf co cX wcel vr cv cR wceq vr cv vx cv vy cv cpr cspw co cR vx
      cv vy cv cpr cspw co vr cv cdm cX vr cv cR vx cv vy cv cpr cspw opreq1 vr
      cv cR wceq vr cv cdm cR cdm cX vr cv cR dmeq isla.1 syl6eqr eleq12d vr cv
      cR wceq vr cv vx cv vy cv cpr cinf co cR vx cv vy cv cpr cinf co vr cv
      cdm cX vr cv cR vx cv vy cv cpr cinf opreq1 vr cv cR wceq vr cv cdm cR
      cdm cX vr cv cR dmeq isla.1 syl6eqr eleq12d anbi12d raleq12d raleq12d vx
      vy vr df-la elrab2 $.
      $( [10-Jun-2009] $) $( [12-Jun-2008] $)

    $( Closure of the supremum (join) of two lattice elements. $)
    laspwcl $p |- ( ( R e. Lat /\ A e. X /\ B e. X )
                -> ( R supw { A , B } ) e. X ) $=
      cR cla wcel cA cX wcel cB cX wcel cR cA cB cpr cspw co cX wcel cR cla
      wcel cR vx cv vy cv cpr cspw co cX wcel vy cX wral vx cX wral cA cX wcel
      cB cX wcel wa cR cA cB cpr cspw co cX wcel cR cla wcel cR cps wcel cR vx
      cv vy cv cpr cspw co cX wcel cR vx cv vy cv cpr cinf co cX wcel wa vy cX
      wral vx cX wral wa cR vx cv vy cv cpr cspw co cX wcel vy cX wral vx cX
      wral vx vy cR cX isla.1 isla cR vx cv vy cv cpr cspw co cX wcel cR vx cv
      vy cv cpr cinf co cX wcel wa vy cX wral vx cX wral cR vx cv vy cv cpr
      cspw co cX wcel vy cX wral vx cX wral cR cps wcel cR vx cv vy cv cpr cspw
      co cX wcel cR vx cv vy cv cpr cinf co cX wcel wa vy cX wral cR vx cv vy
      cv cpr cspw co cX wcel vy cX wral vx cX cR vx cv vy cv cpr cspw co cX
      wcel cR vx cv vy cv cpr cinf co cX wcel wa cR vx cv vy cv cpr cspw co cX
      wcel vy cX cR vx cv vy cv cpr cspw co cX wcel cR vx cv vy cv cpr cinf co
      cX wcel pm3.26 r19.20si r19.20si adantl sylbi cR vx cv vy cv cpr cspw co
      cX wcel cR cA cB cpr cspw co cX wcel cR cA vy cv cpr cspw co cX wcel vx
      vy cA cB cX cX vx cv cA wceq cR vx cv vy cv cpr cspw co cR cA vy cv cpr
      cspw co cX vx cv cA wceq vx cv vy cv cpr cA vy cv cpr cR cspw vx cv cA vy
      cv preq1 opreq2d eleq1d vy cv cB wceq cR cA vy cv cpr cspw co cR cA cB
      cpr cspw co cX vy cv cB wceq cA vy cv cpr cA cB cpr cR cspw vy cv cB cA
      preq2 opreq2d eleq1d rcla42v mpan9 3impb $.
      $( [1-Jul-2009] $) $( [12-Jun-2008] $)

    $( Closure of the infimum (meet) of two lattice elements. $)
    lanfwcl $p |- ( ( R e. Lat /\ A e. X /\ B e. X )
                -> ( R infw { A , B } ) e. X ) $=
      cR cla wcel cA cX wcel cB cX wcel cR cA cB cpr cinf co cX wcel cR cla
      wcel cR vx cv vy cv cpr cinf co cX wcel vy cX wral vx cX wral cA cX wcel
      cB cX wcel wa cR cA cB cpr cinf co cX wcel cR cla wcel cR cps wcel cR vx
      cv vy cv cpr cspw co cX wcel cR vx cv vy cv cpr cinf co cX wcel wa vy cX
      wral vx cX wral wa cR vx cv vy cv cpr cinf co cX wcel vy cX wral vx cX
      wral vx vy cR cX isla.1 isla cR vx cv vy cv cpr cspw co cX wcel cR vx cv
      vy cv cpr cinf co cX wcel wa vy cX wral vx cX wral cR vx cv vy cv cpr
      cinf co cX wcel vy cX wral vx cX wral cR cps wcel cR vx cv vy cv cpr cspw
      co cX wcel cR vx cv vy cv cpr cinf co cX wcel wa vy cX wral cR vx cv vy
      cv cpr cinf co cX wcel vy cX wral vx cX cR vx cv vy cv cpr cspw co cX
      wcel cR vx cv vy cv cpr cinf co cX wcel wa cR vx cv vy cv cpr cinf co cX
      wcel vy cX cR vx cv vy cv cpr cspw co cX wcel cR vx cv vy cv cpr cinf co
      cX wcel pm3.27 r19.20si r19.20si adantl sylbi cR vx cv vy cv cpr cinf co
      cX wcel cR cA cB cpr cinf co cX wcel cR cA vy cv cpr cinf co cX wcel vx
      vy cA cB cX cX vx cv cA wceq cR vx cv vy cv cpr cinf co cR cA vy cv cpr
      cinf co cX vx cv cA wceq vx cv vy cv cpr cA vy cv cpr cR cinf vx cv cA vy
      cv preq1 opreq2d eleq1d vy cv cB wceq cR cA vy cv cpr cinf co cR cA cB
      cpr cinf co cX vy cv cB wceq cA vy cv cpr cA cB cpr cR cinf vy cv cB cA
      preq2 opreq2d eleq1d rcla42v mpan9 3impb $.
      $( [15-Jul-2009] $) $( [20-Jun-2008] $)
  $}

  ${
    $d x y R $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
              Real and complex numbers (cont.)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The exponential, sine, and cosine functions (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d F p q r v w z $.  $d G p q r v w z $.  $d O v w x y z $.  $d A x y $.
    $d H z $.  $d J z $.  $d C p q r w $.

    sinco.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( _i x. x ) ) } $.
    sinco.2 $e |- G = { <. x , y >. | ( x e. CC /\ y = ( -u _i x. x ) ) } $.

    ${
      sincolem.3 $e |- J = { <. x , y >. | ( x e. CC /\ y = ( x / A ) ) } $.
      sincolem.4 $e |- H = { <. w , v >. | ( w e. CC /\ v =
                 ( ( ( exp o. F ) ` w ) O ( ( exp o. G ) ` w ) ) ) } $.

      ${
        sincolem.5 $e |- ( ( ( ( exp o. F ) ` z ) e. CC /\
                             ( ( exp o. G ) ` z ) e. CC ) ->
               ( ( ( exp o. F ) ` z ) O ( ( exp o. G ) ` z ) ) e. CC ) $.
        sincolem.6 $e |- A e. CC $.
        sincolem.7 $e |- A =/= 0 $.
        $( Lemma for ~ sinco and ~ cosco . $)
        sincolem $p |- ( ( J o. H ) Fn CC /\
                         ( z e. CC -> ( ( J o. H ) ` z ) =
          ( ( ( exp ` ( _i x. z ) ) O ( exp ` ( -u _i x. z ) ) ) / A ) ) ) $=
          cJ cH ccom cc wfn vz cv cc wcel vz cv cJ cH ccom cfv ci vz cv cmul co
          ce cfv ci cneg vz cv cmul co ce cfv cO co cA cdiv co wceq wi cJ cc
          wfn cc cc cH wf cJ cH ccom cc wfn vx vy cc vx cv cA cdiv co cJ vx cv
          cA cdiv oprex sincolem.3 fnopab2 vw cv ce cF ccom cfv vw cv ce cG
          ccom cfv cO co cc wcel vw cc wral cc cc cH wf vw cv ce cF ccom cfv vw
          cv ce cG ccom cfv cO co cc wcel vw cc wral vz cv ce cF ccom cfv vz cv
          ce cG ccom cfv cO co cc wcel vz cc vw cv ce cF ccom cfv vw cv ce cG
          ccom cfv cO co cc wcel vz cv ce cF ccom cfv vz cv ce cG ccom cfv cO
          co cc wcel vw vz cc vw cv vz cv wceq vw cv ce cF ccom cfv vw cv ce cG
          ccom cfv cO co vz cv ce cF ccom cfv vz cv ce cG ccom cfv cO co cc vw
          cv vz cv wceq vw cv ce cF ccom cfv vz cv ce cF ccom cfv vw cv ce cG
          ccom cfv vz cv ce cG ccom cfv cO vw cv vz cv ce cF ccom fveq2 vw cv
          vz cv ce cG ccom fveq2 opreq12d eleq1d cbvralv vz cv ce cF ccom cfv
          cc wcel vz cv ce cG ccom cfv cc wcel vz cv ce cF ccom cfv vz cv ce cG
          ccom cfv cO co cc wcel vz cv cc wcel sincolem.5 cc cc vz cv ce cF
          ccom cc cc ce wf cc cc cF wf cc cc ce cF ccom wf eff vx vy cc cc ci
          vx cv cmul co cF sinco.1 ci cc wcel vx cv cc wcel ci vx cv cmul co cc
          wcel axicn ci vx cv mulcl mpan fopab cc cc cc ce cF fco mp2an
          ffvelrni cc cc vz cv ce cG ccom cc cc ce wf cc cc cG wf cc cc ce cG
          ccom wf eff vx vy cc cc ci cneg vx cv cmul co cG sinco.2 ci cneg cc
          wcel vx cv cc wcel ci cneg vx cv cmul co cc wcel ci axicn negcli ci
          cneg vx cv mulcl mpan fopab cc cc cc ce cG fco mp2an ffvelrni sylanc
          mprgbir vw vv cc cc vw cv ce cF ccom cfv vw cv ce cG ccom cfv cO co
          cH sincolem.4 fopab2 mpbi cc cc cJ cH fnfco mp2an vz cv cc wcel vz cv
          cJ cH ccom cfv vz cv cH cfv cJ cfv ci vz cv cmul co ce cfv ci cneg vz
          cv cmul co ce cfv cO co cJ cfv ci vz cv cmul co ce cfv ci cneg vz cv
          cmul co ce cfv cO co cA cdiv co cJ wfun cc cc cH wf vz cv cc wcel vz
          cv cJ cH ccom cfv vz cv cH cfv cJ cfv wceq cJ cc wfn cJ wfun vx vy cc
          vx cv cA cdiv co cJ vx cv cA cdiv oprex sincolem.3 fnopab2 cc cJ
          fnfun ax-mp vw cv ce cF ccom cfv vw cv ce cG ccom cfv cO co cc wcel
          vw cc wral cc cc cH wf vw cv ce cF ccom cfv vw cv ce cG ccom cfv cO
          co cc wcel vw cc wral vz cv ce cF ccom cfv vz cv ce cG ccom cfv cO co
          cc wcel vz cc vw cv ce cF ccom cfv vw cv ce cG ccom cfv cO co cc wcel
          vz cv ce cF ccom cfv vz cv ce cG ccom cfv cO co cc wcel vw vz cc vw
          cv vz cv wceq vw cv ce cF ccom cfv vw cv ce cG ccom cfv cO co vz cv
          ce cF ccom cfv vz cv ce cG ccom cfv cO co cc vw cv vz cv wceq vw cv
          ce cF ccom cfv vz cv ce cF ccom cfv vw cv ce cG ccom cfv vz cv ce cG
          ccom cfv cO vw cv vz cv ce cF ccom fveq2 vw cv vz cv ce cG ccom fveq2
          opreq12d eleq1d cbvralv vz cv ce cF ccom cfv cc wcel vz cv ce cG ccom
          cfv cc wcel vz cv ce cF ccom cfv vz cv ce cG ccom cfv cO co cc wcel
          vz cv cc wcel sincolem.5 cc cc vz cv ce cF ccom cc cc ce wf cc cc cF
          wf cc cc ce cF ccom wf eff vx vy cc cc ci vx cv cmul co cF sinco.1 ci
          cc wcel vx cv cc wcel ci vx cv cmul co cc wcel axicn ci vx cv mulcl
          mpan fopab cc cc cc ce cF fco mp2an ffvelrni cc cc vz cv ce cG ccom
          cc cc ce wf cc cc cG wf cc cc ce cG ccom wf eff vx vy cc cc ci cneg
          vx cv cmul co cG sinco.2 ci cneg cc wcel vx cv cc wcel ci cneg vx cv
          cmul co cc wcel ci axicn negcli ci cneg vx cv mulcl mpan fopab cc cc
          cc ce cG fco mp2an ffvelrni sylanc mprgbir vw vv cc cc vw cv ce cF
          ccom cfv vw cv ce cG ccom cfv cO co cH sincolem.4 fopab2 mpbi cc cc
          vz cv cJ cH fvco3 mp3an12 vz cv cc wcel vz cv cH cfv ci vz cv cmul co
          ce cfv ci cneg vz cv cmul co ce cfv cO co cJ vz cv cc wcel vz cv cH
          cfv vz cv ce cF ccom cfv vz cv ce cG ccom cfv cO co ci vz cv cmul co
          ce cfv ci cneg vz cv cmul co ce cfv cO co vz cv cc wcel vz cv ce cF
          ccom cfv vz cv ce cG ccom cfv cO co cc wcel vz cv cH cfv vz cv ce cF
          ccom cfv vz cv ce cG ccom cfv cO co wceq vz cv ce cF ccom cfv cc wcel
          vz cv ce cG ccom cfv cc wcel vz cv ce cF ccom cfv vz cv ce cG ccom
          cfv cO co cc wcel vz cv cc wcel sincolem.5 cc cc vz cv ce cF ccom cc
          cc ce wf cc cc cF wf cc cc ce cF ccom wf eff vx vy cc cc ci vx cv
          cmul co cF sinco.1 ci cc wcel vx cv cc wcel ci vx cv cmul co cc wcel
          axicn ci vx cv mulcl mpan fopab cc cc cc ce cF fco mp2an ffvelrni cc
          cc vz cv ce cG ccom cc cc ce wf cc cc cG wf cc cc ce cG ccom wf eff
          vx vy cc cc ci cneg vx cv cmul co cG sinco.2 ci cneg cc wcel vx cv cc
          wcel ci cneg vx cv cmul co cc wcel ci axicn negcli ci cneg vx cv
          mulcl mpan fopab cc cc cc ce cG fco mp2an ffvelrni sylanc vw vv vz cv
          vw cv ce cF ccom cfv vw cv ce cG ccom cfv cO co vz cv ce cF ccom cfv
          vz cv ce cG ccom cfv cO co cc cc cH vw cv vz cv wceq vw cv ce cF ccom
          cfv vz cv ce cF ccom cfv vw cv ce cG ccom cfv vz cv ce cG ccom cfv cO
          vw cv vz cv ce cF ccom fveq2 vw cv vz cv ce cG ccom fveq2 opreq12d
          sincolem.4 fvopab4g mpdan vz cv cc wcel vz cv ce cF ccom cfv ci vz cv
          cmul co ce cfv vz cv ce cG ccom cfv ci cneg vz cv cmul co ce cfv cO
          vz cv cc wcel vz cv ce cF ccom cfv vz cv cF cfv ce cfv ci vz cv cmul
          co ce cfv ce wfun cc cc cF wf vz cv cc wcel vz cv ce cF ccom cfv vz
          cv cF cfv ce cfv wceq cc cc ce wf ce wfun eff cc cc ce ffun ax-mp vx
          vy cc cc ci vx cv cmul co cF sinco.1 ci cc wcel vx cv cc wcel ci vx
          cv cmul co cc wcel axicn ci vx cv mulcl mpan fopab cc cc vz cv ce cF
          fvco3 mp3an12 vz cv cc wcel vz cv cF cfv ci vz cv cmul co ce vz cv cc
          wcel ci vz cv cmul co cc wcel vz cv cF cfv ci vz cv cmul co wceq ci
          cc wcel vz cv cc wcel ci vz cv cmul co cc wcel axicn ci vz cv mulcl
          mpan vx vy vz cv ci vx cv cmul co ci vz cv cmul co cc cc cF vx cv vz
          cv ci cmul opreq2 sinco.1 fvopab4g mpdan fveq2d eqtrd vz cv cc wcel
          vz cv ce cG ccom cfv vz cv cG cfv ce cfv ci cneg vz cv cmul co ce cfv
          ce wfun cc cc cG wf vz cv cc wcel vz cv ce cG ccom cfv vz cv cG cfv
          ce cfv wceq cc cc ce wf ce wfun eff cc cc ce ffun ax-mp vx vy cc cc
          ci cneg vx cv cmul co cG sinco.2 ci cneg cc wcel vx cv cc wcel ci
          cneg vx cv cmul co cc wcel ci axicn negcli ci cneg vx cv mulcl mpan
          fopab cc cc vz cv ce cG fvco3 mp3an12 vz cv cc wcel vz cv cG cfv ci
          cneg vz cv cmul co ce vz cv cc wcel ci cneg vz cv cmul co cc wcel vz
          cv cG cfv ci cneg vz cv cmul co wceq ci cneg cc wcel vz cv cc wcel ci
          cneg vz cv cmul co cc wcel ci axicn negcli ci cneg vz cv mulcl mpan
          vx vy vz cv ci cneg vx cv cmul co ci cneg vz cv cmul co cc cc cG vx
          cv vz cv ci cneg cmul opreq2 sinco.2 fvopab4g mpdan fveq2d eqtrd
          opreq12d eqtrd fveq2d vz cv cc wcel ci vz cv cmul co ce cfv ci cneg
          vz cv cmul co ce cfv cO co cc wcel ci vz cv cmul co ce cfv ci cneg vz
          cv cmul co ce cfv cO co cJ cfv ci vz cv cmul co ce cfv ci cneg vz cv
          cmul co ce cfv cO co cA cdiv co wceq vz cv cc wcel vz cv ce cF ccom
          cfv vz cv ce cG ccom cfv cO co ci vz cv cmul co ce cfv ci cneg vz cv
          cmul co ce cfv cO co cc vz cv cc wcel vz cv ce cF ccom cfv ci vz cv
          cmul co ce cfv vz cv ce cG ccom cfv ci cneg vz cv cmul co ce cfv cO
          vz cv cc wcel vz cv ce cF ccom cfv vz cv cF cfv ce cfv ci vz cv cmul
          co ce cfv ce wfun cc cc cF wf vz cv cc wcel vz cv ce cF ccom cfv vz
          cv cF cfv ce cfv wceq cc cc ce wf ce wfun eff cc cc ce ffun ax-mp vx
          vy cc cc ci vx cv cmul co cF sinco.1 ci cc wcel vx cv cc wcel ci vx
          cv cmul co cc wcel axicn ci vx cv mulcl mpan fopab cc cc vz cv ce cF
          fvco3 mp3an12 vz cv cc wcel vz cv cF cfv ci vz cv cmul co ce vz cv cc
          wcel ci vz cv cmul co cc wcel vz cv cF cfv ci vz cv cmul co wceq ci
          cc wcel vz cv cc wcel ci vz cv cmul co cc wcel axicn ci vz cv mulcl
          mpan vx vy vz cv ci vx cv cmul co ci vz cv cmul co cc cc cF vx cv vz
          cv ci cmul opreq2 sinco.1 fvopab4g mpdan fveq2d eqtrd vz cv cc wcel
          vz cv ce cG ccom cfv vz cv cG cfv ce cfv ci cneg vz cv cmul co ce cfv
          ce wfun cc cc cG wf vz cv cc wcel vz cv ce cG ccom cfv vz cv cG cfv
          ce cfv wceq cc cc ce wf ce wfun eff cc cc ce ffun ax-mp vx vy cc cc
          ci cneg vx cv cmul co cG sinco.2 ci cneg cc wcel vx cv cc wcel ci
          cneg vx cv cmul co cc wcel ci axicn negcli ci cneg vx cv mulcl mpan
          fopab cc cc vz cv ce cG fvco3 mp3an12 vz cv cc wcel vz cv cG cfv ci
          cneg vz cv cmul co ce vz cv cc wcel ci cneg vz cv cmul co cc wcel vz
          cv cG cfv ci cneg vz cv cmul co wceq ci cneg cc wcel vz cv cc wcel ci
          cneg vz cv cmul co cc wcel ci axicn negcli ci cneg vz cv mulcl mpan
          vx vy vz cv ci cneg vx cv cmul co ci cneg vz cv cmul co cc cc cG vx
          cv vz cv ci cneg cmul opreq2 sinco.2 fvopab4g mpdan fveq2d eqtrd
          opreq12d vz cv ce cF ccom cfv cc wcel vz cv ce cG ccom cfv cc wcel vz
          cv ce cF ccom cfv vz cv ce cG ccom cfv cO co cc wcel vz cv cc wcel
          sincolem.5 cc cc vz cv ce cF ccom cc cc ce wf cc cc cF wf cc cc ce cF
          ccom wf eff vx vy cc cc ci vx cv cmul co cF sinco.1 ci cc wcel vx cv
          cc wcel ci vx cv cmul co cc wcel axicn ci vx cv mulcl mpan fopab cc
          cc cc ce cF fco mp2an ffvelrni cc cc vz cv ce cG ccom cc cc ce wf cc
          cc cG wf cc cc ce cG ccom wf eff vx vy cc cc ci cneg vx cv cmul co cG
          sinco.2 ci cneg cc wcel vx cv cc wcel ci cneg vx cv cmul co cc wcel
          ci axicn negcli ci cneg vx cv mulcl mpan fopab cc cc cc ce cG fco
          mp2an ffvelrni sylanc eqeltrrd ci vz cv cmul co ce cfv ci cneg vz cv
          cmul co ce cfv cO co cc wcel ci vz cv cmul co ce cfv ci cneg vz cv
          cmul co ce cfv cO co cA cdiv co cc wcel ci vz cv cmul co ce cfv ci
          cneg vz cv cmul co ce cfv cO co cJ cfv ci vz cv cmul co ce cfv ci
          cneg vz cv cmul co ce cfv cO co cA cdiv co wceq ci vz cv cmul co ce
          cfv ci cneg vz cv cmul co ce cfv cO co cc wcel cA cc wcel cA cc0 wne
          ci vz cv cmul co ce cfv ci cneg vz cv cmul co ce cfv cO co cA cdiv co
          cc wcel sincolem.6 sincolem.7 ci vz cv cmul co ce cfv ci cneg vz cv
          cmul co ce cfv cO co cA divcl mp3an23 vx vy ci vz cv cmul co ce cfv
          ci cneg vz cv cmul co ce cfv cO co vx cv cA cdiv co ci vz cv cmul co
          ce cfv ci cneg vz cv cmul co ce cfv cO co cA cdiv co cc cc cJ vx cv
          ci vz cv cmul co ce cfv ci cneg vz cv cmul co ce cfv cO co cA cdiv
          opreq1 sincolem.3 fvopab4g mpdan syl 3eqtrd pm3.2i $.
          $( [28-Nov-2007] $) $( [28-Nov-2007] $)
      $}

      ${
        sincnlem.5 $e |- A e. CC $.
        sincnlem.6 $e |- A =/= 0 $.
        sincnlem.7 $e |- C = ( abs o. - ) $.
        sincnlem.8 $e |- D = { <. <. p , q >. , r >. |
                               ( ( p e. ( CC X. CC ) /\ q e. ( CC X. CC ) ) /\
          r = sup ( { ( ( 1st ` p ) C ( 1st ` q ) ) ,
                      ( ( 2nd ` p ) C ( 2nd ` q ) ) } , RR , < ) ) } $.
        sincnlem.9 $e |- O e. ( ( Open ` D ) Cn ( Open ` C ) ) $.
        $( Lemma for ~ sincn and ~ coscn . $)
        sincnlem $p |- ( J o. H ) e. ( CC -cn-> CC ) $=
          cJ cH ccom cC copn cfv cC copn cfv ccn co cc cc ccncf co cH cC copn
          cfv cC copn cfv ccn co wcel cJ cC copn cfv cC copn cfv ccn co wcel cJ
          cH ccom cC copn cfv cC copn cfv ccn co wcel ce cF ccom cC copn cfv cC
          copn cfv ccn co wcel ce cG ccom cC copn cfv cC copn cfv ccn co wcel
          cH cC copn cfv cC copn cfv ccn co wcel cF cC copn cfv cC copn cfv ccn
          co wcel ce cC copn cfv cC copn cfv ccn co wcel ce cF ccom cC copn cfv
          cC copn cfv ccn co wcel cF cc cc ccncf co cC copn cfv cC copn cfv ccn
          co ci cc wcel cF cc cc ccncf co wcel axicn vx vy ci cF sinco.1
          mulc1cncf ax-mp cC cC copn cfv sincnlem.7 cC copn cfv eqid cncfmet1
          eleqtri ce cc cc ccncf co cC copn cfv cC copn cfv ccn co efcn cC cC
          copn cfv sincnlem.7 cC copn cfv eqid cncfmet1 eleqtri cC cme wcel cC
          cme wcel cC cme wcel w3a cF cC copn cfv cC copn cfv ccn co wcel ce cC
          copn cfv cC copn cfv ccn co wcel wa ce cF ccom cC copn cfv cC copn
          cfv ccn co wcel cC cme wcel cC cme wcel cC cme wcel cC sincnlem.7
          cnmet cC sincnlem.7 cnmet cC sincnlem.7 cnmet 3pm3.2i cC cC cC cF ce
          cC copn cfv cC copn cfv cC copn cfv cC copn cfv eqid cC copn cfv eqid
          cC copn cfv eqid metcnco mpan mp2an cG cC copn cfv cC copn cfv ccn co
          wcel ce cC copn cfv cC copn cfv ccn co wcel ce cG ccom cC copn cfv cC
          copn cfv ccn co wcel cG cc cc ccncf co cC copn cfv cC copn cfv ccn co
          ci cneg cc wcel cG cc cc ccncf co wcel ci axicn negcli vx vy ci cneg
          cG sinco.2 mulc1cncf ax-mp cC cC copn cfv sincnlem.7 cC copn cfv eqid
          cncfmet1 eleqtri ce cc cc ccncf co cC copn cfv cC copn cfv ccn co
          efcn cC cC copn cfv sincnlem.7 cC copn cfv eqid cncfmet1 eleqtri cC
          cme wcel cC cme wcel cC cme wcel w3a cG cC copn cfv cC copn cfv ccn
          co wcel ce cC copn cfv cC copn cfv ccn co wcel wa ce cG ccom cC copn
          cfv cC copn cfv ccn co wcel cC cme wcel cC cme wcel cC cme wcel cC
          sincnlem.7 cnmet cC sincnlem.7 cnmet cC sincnlem.7 cnmet 3pm3.2i cC
          cC cC cG ce cC copn cfv cC copn cfv cC copn cfv cC copn cfv eqid cC
          copn cfv eqid cC copn cfv eqid metcnco mpan mp2an vp vq vr vw vv cC
          cC cC cD cC copn cfv ce cF ccom ce cG ccom cH cC cC copn cfv cC copn
          cfv cC copn cfv cD copn cfv cO cc cc cc cC sincnlem.7 cnmetba cC
          sincnlem.7 cnmetba cC sincnlem.7 cnmetba cC sincnlem.7 cnmet cC
          sincnlem.7 cnmet cC sincnlem.7 cnmet cC sincnlem.7 cnmet cC copn cfv
          eqid cC copn cfv eqid cC copn cfv eqid cD copn cfv eqid cC copn cfv
          eqid sincnlem.8 sincnlem.9 sincolem.4 oprcn mp2an cJ cc cc ccncf co
          cC copn cfv cC copn cfv ccn co cA cc wcel cA cc0 wne cJ cc cc ccncf
          co wcel sincnlem.5 sincnlem.6 vx vy cA cJ sincolem.3 divccncf mp2an
          cC cC copn cfv sincnlem.7 cC copn cfv eqid cncfmet1 eleqtri cC cme
          wcel cC cme wcel cC cme wcel w3a cH cC copn cfv cC copn cfv ccn co
          wcel cJ cC copn cfv cC copn cfv ccn co wcel wa cJ cH ccom cC copn cfv
          cC copn cfv ccn co wcel cC cme wcel cC cme wcel cC cme wcel cC
          sincnlem.7 cnmet cC sincnlem.7 cnmet cC sincnlem.7 cnmet 3pm3.2i cC
          cC cC cH cJ cC copn cfv cC copn cfv cC copn cfv cC copn cfv eqid cC
          copn cfv eqid cC copn cfv eqid metcnco mpan mp2an cC cC copn cfv
          sincnlem.7 cC copn cfv eqid cncfmet1 eleqtrri $.
          $( [28-Nov-2007] $) $( [28-Nov-2007] $)
      $}
    $}

    ${
      sinco.3 $e |- J = { <. x , y >. |
                          ( x e. CC /\ y = ( x / ( 2 x. _i ) ) ) } $.
      sinco.4 $e |- H = { <. w , v >. | ( w e. CC /\
                     v = ( ( ( exp o. F ) ` w ) - ( ( exp o. G ) ` w ) ) ) } $.
      $( Sine expressed as a function composition.  (Contributed by Paul
         Chapman, 28-Nov-2007.) $)
      sinco $p |- sin = ( J o. H ) $=
        csin cJ cH ccom wceq vz cv csin cfv vz cv cJ cH ccom cfv wceq vz cc
        wral vz cv csin cfv vz cv cJ cH ccom cfv wceq vz cc vz cv cc wcel vz cv
        csin cfv ci vz cv cmul co ce cfv ci cneg vz cv cmul co ce cfv cmin co
        c2 ci cmul co cdiv co vz cv cJ cH ccom cfv vz cv sinval cJ cH ccom cc
        wfn vz cv cc wcel vz cv cJ cH ccom cfv ci vz cv cmul co ce cfv ci cneg
        vz cv cmul co ce cfv cmin co c2 ci cmul co cdiv co wceq wi vx vy vz vw
        vv c2 ci cmul co cF cG cH cJ cmin sinco.1 sinco.2 sinco.3 sinco.4 vz cv
        ce cF ccom cfv vz cv ce cG ccom cfv subcl c2 ci 2cn axicn mulcli c2 ci
        2cn axicn 2ne0 ine0 muln0i sincolem pm3.27i eqtr4d rgen csin cc wfn cJ
        cH ccom cc wfn csin cJ cH ccom wceq vz cv csin cfv vz cv cJ cH ccom cfv
        wceq vz cc wral wb cc cc csin wf csin cc wfn sinf cc cc csin ffn ax-mp
        cJ cH ccom cc wfn vz cv cc wcel vz cv cJ cH ccom cfv ci vz cv cmul co
        ce cfv ci cneg vz cv cmul co ce cfv cmin co c2 ci cmul co cdiv co wceq
        wi vx vy vz vw vv c2 ci cmul co cF cG cH cJ cmin sinco.1 sinco.2
        sinco.3 sinco.4 vz cv ce cF ccom cfv vz cv ce cG ccom cfv subcl c2 ci
        2cn axicn mulcli c2 ci 2cn axicn 2ne0 ine0 muln0i sincolem pm3.26i vz
        cc csin cJ cH ccom eqfnfv2 mp2an mpbir $.
        $( [28-Nov-2007] $) $( [28-Nov-2007] $)
    $}

    ${
      cosco.3 $e |- J = { <. x , y >. |
                          ( x e. CC /\ y = ( x / 2 ) ) } $.
      cosco.4 $e |- H = { <. w , v >. | ( w e. CC /\
                     v = ( ( ( exp o. F ) ` w ) + ( ( exp o. G ) ` w ) ) ) } $.
      $( Cosine expressed as a function composition.  (Contributed by Paul
         Chapman, 28-Nov-2007.) $)
      cosco $p |- cos = ( J o. H ) $=
        ccos cJ cH ccom wceq vz cv ccos cfv vz cv cJ cH ccom cfv wceq vz cc
        wral vz cv ccos cfv vz cv cJ cH ccom cfv wceq vz cc vz cv cc wcel vz cv
        ccos cfv ci vz cv cmul co ce cfv ci cneg vz cv cmul co ce cfv caddc co
        c2 cdiv co vz cv cJ cH ccom cfv vz cv cosval cJ cH ccom cc wfn vz cv cc
        wcel vz cv cJ cH ccom cfv ci vz cv cmul co ce cfv ci cneg vz cv cmul co
        ce cfv caddc co c2 cdiv co wceq wi vx vy vz vw vv c2 cF cG cH cJ caddc
        sinco.1 sinco.2 cosco.3 cosco.4 vz cv ce cF ccom cfv vz cv ce cG ccom
        cfv addcl 2cn 2ne0 sincolem pm3.27i eqtr4d rgen ccos cc wfn cJ cH ccom
        cc wfn ccos cJ cH ccom wceq vz cv ccos cfv vz cv cJ cH ccom cfv wceq vz
        cc wral wb cc cc ccos wf ccos cc wfn cosf cc cc ccos ffn ax-mp cJ cH
        ccom cc wfn vz cv cc wcel vz cv cJ cH ccom cfv ci vz cv cmul co ce cfv
        ci cneg vz cv cmul co ce cfv caddc co c2 cdiv co wceq wi vx vy vz vw vv
        c2 cF cG cH cJ caddc sinco.1 sinco.2 cosco.3 cosco.4 vz cv ce cF ccom
        cfv vz cv ce cG ccom cfv addcl 2cn 2ne0 sincolem pm3.26i vz cc ccos cJ
        cH ccom eqfnfv2 mp2an mpbir $.
        $( [28-Nov-2007] $) $( [28-Nov-2007] $)
    $}
  $}

  ${
    $d p q r v w x y $.
    $( Sine is continuous.  (Contributed by Paul Chapman, 28-Nov-2007.) $)
    sincn $p |- sin e. ( CC -cn-> CC ) $=
      csin vx cv cc wcel vy cv vx cv c2 ci cmul co cdiv co wceq wa vx vy copab
      vw cv cc wcel vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa
      vx vy copab ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co
      wceq wa vx vy copab ccom cfv cmin co wceq wa vw vv copab ccom cc cc ccncf
      co vx vy vw vv vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab
      vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy copab vw cv cc
      wcel vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy
      copab ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa
      vx vy copab ccom cfv cmin co wceq wa vw vv copab vx cv cc wcel vy cv vx
      cv c2 ci cmul co cdiv co wceq wa vx vy copab vx cv cc wcel vy cv ci vx cv
      cmul co wceq wa vx vy copab eqid vx cv cc wcel vy cv ci cneg vx cv cmul
      co wceq wa vx vy copab eqid vx cv cc wcel vy cv vx cv c2 ci cmul co cdiv
      co wceq wa vx vy copab eqid vw cv cc wcel vv cv vw cv ce vx cv cc wcel vy
      cv ci vx cv cmul co wceq wa vx vy copab ccom cfv vw cv ce vx cv cc wcel
      vy cv ci cneg vx cv cmul co wceq wa vx vy copab ccom cfv cmin co wceq wa
      vw vv copab eqid sinco vx vy vw vv c2 ci cmul co cabs cmin ccom vp cv cc
      cc cxp wcel vq cv cc cc cxp wcel wa vr cv vp cv c1st cfv vq cv c1st cfv
      cabs cmin ccom co vp cv c2nd cfv vq cv c2nd cfv cabs cmin ccom co cpr cr
      clt csup wceq wa vp vq vr copab2 vx cv cc wcel vy cv ci vx cv cmul co
      wceq wa vx vy copab vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx
      vy copab vw cv cc wcel vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul
      co wceq wa vx vy copab ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx
      cv cmul co wceq wa vx vy copab ccom cfv cmin co wceq wa vw vv copab vx cv
      cc wcel vy cv vx cv c2 ci cmul co cdiv co wceq wa vx vy copab cmin vr vq
      vp vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab eqid vx cv cc
      wcel vy cv ci cneg vx cv cmul co wceq wa vx vy copab eqid vx cv cc wcel
      vy cv vx cv c2 ci cmul co cdiv co wceq wa vx vy copab eqid vw cv cc wcel
      vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab
      ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy
      copab ccom cfv cmin co wceq wa vw vv copab eqid c2 ci 2cn axicn mulcli c2
      ci 2cn axicn 2ne0 ine0 muln0i cabs cmin ccom eqid vp cv cc cc cxp wcel vq
      cv cc cc cxp wcel wa vr cv vp cv c1st cfv vq cv c1st cfv cabs cmin ccom
      co vp cv c2nd cfv vq cv c2nd cfv cabs cmin ccom co cpr cr clt csup wceq
      wa vp vq vr copab2 eqid vp vq vr cabs cmin ccom vp cv cc cc cxp wcel vq
      cv cc cc cxp wcel wa vr cv vp cv c1st cfv vq cv c1st cfv cabs cmin ccom
      co vp cv c2nd cfv vq cv c2nd cfv cabs cmin ccom co cpr cr clt csup wceq
      wa vp vq vr copab2 cabs cmin ccom copn cfv vp cv cc cc cxp wcel vq cv cc
      cc cxp wcel wa vr cv vp cv c1st cfv vq cv c1st cfv cabs cmin ccom co vp
      cv c2nd cfv vq cv c2nd cfv cabs cmin ccom co cpr cr clt csup wceq wa vp
      vq vr copab2 copn cfv cabs cmin ccom eqid vp cv cc cc cxp wcel vq cv cc
      cc cxp wcel wa vr cv vp cv c1st cfv vq cv c1st cfv cabs cmin ccom co vp
      cv c2nd cfv vq cv c2nd cfv cabs cmin ccom co cpr cr clt csup wceq wa vp
      vq vr copab2 eqid cabs cmin ccom copn cfv eqid vp cv cc cc cxp wcel vq cv
      cc cc cxp wcel wa vr cv vp cv c1st cfv vq cv c1st cfv cabs cmin ccom co
      vp cv c2nd cfv vq cv c2nd cfv cabs cmin ccom co cpr cr clt csup wceq wa
      vp vq vr copab2 copn cfv eqid subcn sincnlem eqeltri $.
      $( [28-Nov-2007] $) $( [28-Nov-2007] $)

    $( Cosine is continuous.  (Contributed by Paul Chapman, 28-Nov-2007.) $)
    coscn $p |- cos e. ( CC -cn-> CC ) $=
      ccos vx cv cc wcel vy cv vx cv c2 cdiv co wceq wa vx vy copab vw cv cc
      wcel vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy
      copab ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa
      vx vy copab ccom cfv caddc co wceq wa vw vv copab ccom cc cc ccncf co vx
      vy vw vv vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab vx cv
      cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy copab vw cv cc wcel vv
      cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab ccom
      cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy
      copab ccom cfv caddc co wceq wa vw vv copab vx cv cc wcel vy cv vx cv c2
      cdiv co wceq wa vx vy copab vx cv cc wcel vy cv ci vx cv cmul co wceq wa
      vx vy copab eqid vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy
      copab eqid vx cv cc wcel vy cv vx cv c2 cdiv co wceq wa vx vy copab eqid
      vw cv cc wcel vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa
      vx vy copab ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co
      wceq wa vx vy copab ccom cfv caddc co wceq wa vw vv copab eqid cosco vx
      vy vw vv c2 cabs cmin ccom vp cv cc cc cxp wcel vq cv cc cc cxp wcel wa
      vr cv vp cv c1st cfv vq cv c1st cfv cabs cmin ccom co vp cv c2nd cfv vq
      cv c2nd cfv cabs cmin ccom co cpr cr clt csup wceq wa vp vq vr copab2 vx
      cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab vx cv cc wcel vy cv
      ci cneg vx cv cmul co wceq wa vx vy copab vw cv cc wcel vv cv vw cv ce vx
      cv cc wcel vy cv ci vx cv cmul co wceq wa vx vy copab ccom cfv vw cv ce
      vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy copab ccom cfv
      caddc co wceq wa vw vv copab vx cv cc wcel vy cv vx cv c2 cdiv co wceq wa
      vx vy copab caddc vr vq vp vx cv cc wcel vy cv ci vx cv cmul co wceq wa
      vx vy copab eqid vx cv cc wcel vy cv ci cneg vx cv cmul co wceq wa vx vy
      copab eqid vx cv cc wcel vy cv vx cv c2 cdiv co wceq wa vx vy copab eqid
      vw cv cc wcel vv cv vw cv ce vx cv cc wcel vy cv ci vx cv cmul co wceq wa
      vx vy copab ccom cfv vw cv ce vx cv cc wcel vy cv ci cneg vx cv cmul co
      wceq wa vx vy copab ccom cfv caddc co wceq wa vw vv copab eqid 2cn 2ne0
      cabs cmin ccom eqid vp cv cc cc cxp wcel vq cv cc cc cxp wcel wa vr cv vp
      cv c1st cfv vq cv c1st cfv cabs cmin ccom co vp cv c2nd cfv vq cv c2nd
      cfv cabs cmin ccom co cpr cr clt csup wceq wa vp vq vr copab2 eqid vp vq
      vr cabs cmin ccom vp cv cc cc cxp wcel vq cv cc cc cxp wcel wa vr cv vp
      cv c1st cfv vq cv c1st cfv cabs cmin ccom co vp cv c2nd cfv vq cv c2nd
      cfv cabs cmin ccom co cpr cr clt csup wceq wa vp vq vr copab2 cabs cmin
      ccom copn cfv vp cv cc cc cxp wcel vq cv cc cc cxp wcel wa vr cv vp cv
      c1st cfv vq cv c1st cfv cabs cmin ccom co vp cv c2nd cfv vq cv c2nd cfv
      cabs cmin ccom co cpr cr clt csup wceq wa vp vq vr copab2 copn cfv cabs
      cmin ccom eqid vp cv cc cc cxp wcel vq cv cc cc cxp wcel wa vr cv vp cv
      c1st cfv vq cv c1st cfv cabs cmin ccom co vp cv c2nd cfv vq cv c2nd cfv
      cabs cmin ccom co cpr cr clt csup wceq wa vp vq vr copab2 eqid cabs cmin
      ccom copn cfv eqid vp cv cc cc cxp wcel vq cv cc cc cxp wcel wa vr cv vp
      cv c1st cfv vq cv c1st cfv cabs cmin ccom co vp cv c2nd cfv vq cv c2nd
      cfv cabs cmin ccom co cpr cr clt csup wceq wa vp vq vr copab2 copn cfv
      eqid addcn sincnlem eqeltri $.
      $( [28-Nov-2007] $) $( [28-Nov-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Properties of pi = 3.14159...
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d C w x y $.  $d P v w x $.  $d P v w z $.  $d S w y z $.    $d T w y z $.
    pilem1.1 $e |- S = { x e. ( -u 4 [,) 0 ) | ( sin ` x ) = 0 } $.
    pilem1.2 $e |- C = sup ( S , RR , < ) $.

    ${
      pilem1.3 $e |- T = { x e. ( -u 4 [,] -u 2 ) | ( sin ` x ) = 0 } $.
      $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi . $)
      pilem1 $p |- ( C e. ( -u 4 (,) -u 2 ) /\ ( sin ` C ) = 0 ) $=
        vx c4 cneg c2 cneg cC cc cS cc0 csin c4 4re renegcli c2 2re renegcli
        0re c2 c4 clt wbr c4 cneg c2 cneg clt wbr cc0 c2 caddc co c2 c2 caddc
        co c2 c4 clt cc0 c2 clt wbr cc0 c2 caddc co c2 c2 caddc co clt wbr 2pos
        cc0 c2 c2 0re 2re 2re ltadd1i mpbi c2 2cn addid2i 2p2e4 3brtr3i c2 c4
        2re 4re ltnegi mpbi c4 cneg c2 cneg cicc co cr cc c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cicc co cr wss c4 4re renegcli c2 2re
        renegcli c4 cneg c2 cneg iccssre mp2an axresscn sstri cc ssid sincn vx
        cv c4 cneg c2 cneg cicc co wcel vx cv cr wcel vx cv csin cfv cr wcel c4
        cneg c2 cneg cicc co cr vx cv c4 cneg cr wcel c2 cneg cr wcel c4 cneg
        c2 cneg cicc co cr wss c4 4re renegcli c2 2re renegcli c4 cneg c2 cneg
        iccssre mp2an sseli vx cv resincl syl cS cT vx cv csin cfv cc0 wceq vx
        c4 cneg c2 cneg cicc co crab vy cS cT c4 cneg vy cv cle wbr vy cv cr
        wcel vy cv cc0 clt wbr vy cv csin cfv cc0 wceq wa wa wa c4 cneg vy cv
        cle wbr vy cv cr wcel vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa
        wa wa vy cv cS wcel vy cv cT wcel vy cv cr wcel vy cv cc0 clt wbr vy cv
        csin cfv cc0 wceq wa wa vy cv cr wcel vy cv c2 cneg cle wbr vy cv csin
        cfv cc0 wceq wa wa c4 cneg vy cv cle wbr vy cv cr wcel vy cv cc0 clt
        wbr vy cv csin cfv cc0 wceq wa vy cv c2 cneg cle wbr vy cv csin cfv cc0
        wceq wa vy cv cr wcel vy cv cc0 clt wbr vy cv csin cfv cc0 wceq wa vy
        cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa c2 cneg vy cv cle wbr vy
        cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa wo vy cv c2 cneg cle wbr
        vy cv csin cfv cc0 wceq wa vy cv cr wcel vy cv cc0 clt wbr vy cv csin
        cfv cc0 wceq wa vy cv c2 cneg cle wbr c2 cneg vy cv cle wbr vy cv cc0
        clt wbr wa wo vy cv csin cfv cc0 wceq wa vy cv c2 cneg cle wbr vy cv
        csin cfv cc0 wceq wa c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa vy cv
        csin cfv cc0 wceq wa wo vy cv cr wcel vy cv cc0 clt wbr vy cv c2 cneg
        cle wbr c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa wo vy cv csin cfv
        cc0 wceq vy cv cr wcel vy cv cc0 clt wbr vy cv c2 cneg cle wbr vy cv
        cc0 clt wbr wa c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa wo vy cv c2
        cneg cle wbr c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa wo vy cv cr
        wcel vy cv cc0 clt wbr vy cv c2 cneg cle wbr c2 cneg vy cv cle wbr wo
        vy cv cc0 clt wbr wa vy cv c2 cneg cle wbr vy cv cc0 clt wbr wa c2 cneg
        vy cv cle wbr vy cv cc0 clt wbr wa wo vy cv cr wcel vy cv c2 cneg cle
        wbr c2 cneg vy cv cle wbr wo vy cv cc0 clt wbr vy cv cr wcel c2 cneg cr
        wcel vy cv c2 cneg cle wbr c2 cneg vy cv cle wbr wo c2 2re renegcli vy
        cv c2 cneg letric mpan2 biantrurd vy cv c2 cneg cle wbr c2 cneg vy cv
        cle wbr vy cv cc0 clt wbr andir syl6bb vy cv cr wcel vy cv c2 cneg cle
        wbr vy cv c2 cneg cle wbr vy cv cc0 clt wbr wa c2 cneg vy cv cle wbr vy
        cv cc0 clt wbr wa vy cv cr wcel vy cv c2 cneg cle wbr vy cv cc0 clt wbr
        wi vy cv c2 cneg cle wbr vy cv c2 cneg cle wbr vy cv cc0 clt wbr wa wb
        vy cv cr wcel vy cv c2 cneg cle wbr c2 cneg cc0 clt wbr vy cv cc0 clt
        wbr cc0 c2 clt wbr c2 cneg cc0 clt wbr 2pos c2 cr wcel cc0 c2 clt wbr
        c2 cneg cc0 clt wbr wb 2re c2 lt0neg2 ax-mp mpbi vy cv cr wcel c2 cneg
        cr wcel cc0 cr wcel vy cv c2 cneg cle wbr c2 cneg cc0 clt wbr wa vy cv
        cc0 clt wbr wi c2 2re renegcli 0re vy cv c2 cneg cc0 lelttr mp3an23
        mpan2i vy cv c2 cneg cle wbr vy cv cc0 clt wbr pm4.71 sylib orbi1d
        bitr4d anbi1d vy cv c2 cneg cle wbr c2 cneg vy cv cle wbr vy cv cc0 clt
        wbr wa vy cv csin cfv cc0 wceq andir syl6bb vy cv cr wcel c2 cneg vy cv
        cle wbr vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa wn vy cv c2
        cneg cle wbr vy cv csin cfv cc0 wceq wa vy cv c2 cneg cle wbr vy cv
        csin cfv cc0 wceq wa c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa vy cv
        csin cfv cc0 wceq wa wo wb vy cv cr wcel c2 cneg vy cv cle wbr vy cv
        cc0 clt wbr wa vy cv csin cfv cc0 wceq wn wi c2 cneg vy cv cle wbr vy
        cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa wn vy cv cr wcel c2 cneg
        vy cv cle wbr vy cv cc0 clt wbr vy cv csin cfv cc0 wceq wn vy cv cr
        wcel c2 cneg vy cv cle wbr vy cv cc0 clt wbr w3a cc0 vy cv cneg csin
        cfv clt wbr vy cv csin cfv cc0 wceq wn vy cv cr wcel c2 cneg vy cv cle
        wbr vy cv cc0 clt wbr w3a vy cv cneg cr wcel cc0 vy cv cneg clt wbr vy
        cv cneg c2 cle wbr w3a vy cv cneg cc0 c2 cioc co wcel cc0 vy cv cneg
        csin cfv clt wbr vy cv cr wcel c2 cneg vy cv cle wbr vy cv cc0 clt wbr
        w3a vy cv cneg cr wcel cc0 vy cv cneg clt wbr vy cv cneg c2 cle wbr vy
        cv cr wcel c2 cneg vy cv cle wbr vy cv cneg cr wcel vy cv cc0 clt wbr
        vy cv renegcl 3ad2ant1 vy cv cr wcel c2 cneg vy cv cle wbr vy cv cc0
        clt wbr cc0 vy cv cneg clt wbr vy cv cr wcel vy cv cc0 clt wbr cc0 vy
        cv cneg clt wbr wb c2 cneg vy cv cle wbr vy cv lt0neg1 adantr biimp3a
        vy cv cr wcel c2 cneg vy cv cle wbr vy cv cneg c2 cle wbr vy cv cc0 clt
        wbr vy cv cr wcel c2 cneg vy cv cle wbr vy cv cneg c2 cle wbr c2 cr
        wcel vy cv cr wcel c2 cneg vy cv cle wbr vy cv cneg c2 cle wbr wb 2re
        c2 vy cv lenegcon1 mpan biimpa 3adant3 3jca vy cv cneg cc0 c2 cioc co
        wcel vy cv cneg cr wcel cc0 vy cv cneg clt wbr vy cv cneg c2 cle wbr
        w3a cc0 cr wcel c2 cr wcel vy cv cneg cc0 c2 cioc co wcel vy cv cneg cr
        wcel cc0 vy cv cneg clt wbr vy cv cneg c2 cle wbr w3a wb 0re 2re cc0 c2
        vy cv cneg elioc2 mp2an biimpri vy cv cneg sin02gt0 3syl vy cv cr wcel
        c2 cneg vy cv cle wbr cc0 vy cv cneg csin cfv clt wbr vy cv csin cfv
        cc0 wceq wn wi vy cv cc0 clt wbr vy cv cr wcel cc0 vy cv cneg csin cfv
        clt wbr cc0 vy cv csin cfv wne vy cv csin cfv cc0 wceq wn vy cv cr wcel
        cc0 vy cv cneg csin cfv clt wbr vy cv csin cfv cc0 clt wbr cc0 vy cv
        csin cfv wne vy cv cr wcel cc0 vy cv cneg csin cfv clt wbr cc0 vy cv
        csin cfv cneg clt wbr vy cv csin cfv cc0 clt wbr vy cv cr wcel vy cv
        cneg csin cfv vy cv csin cfv cneg cc0 clt vy cv cr wcel vy cv cc wcel
        vy cv cneg csin cfv vy cv csin cfv cneg wceq vy cv recn vy cv sinneg
        syl breq2d vy cv cr wcel vy cv csin cfv cr wcel vy cv csin cfv cc0 clt
        wbr cc0 vy cv csin cfv cneg clt wbr wb vy cv resincl vy cv csin cfv
        lt0neg1 syl bitr4d vy cv cr wcel vy cv csin cfv cr wcel vy cv csin cfv
        cc0 clt wbr cc0 vy cv csin cfv wne wi vy cv resincl vy cv csin cfv cr
        wcel vy cv csin cfv cc0 clt wbr cc0 vy cv csin cfv wne vy cv csin cfv
        cr wcel cc0 cr wcel vy cv csin cfv cc0 clt wbr cc0 vy cv csin cfv wne
        0re vy cv csin cfv cc0 ltne mp3an2 ex syl sylbid cc0 vy cv csin cfv wne
        vy cv csin cfv cc0 wne vy cv csin cfv cc0 wceq wn cc0 vy cv csin cfv
        necom vy cv csin cfv cc0 df-ne bitri syl6ib 3ad2ant1 mpd 3expib c2 cneg
        vy cv cle wbr vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq imnan sylib
        c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa
        wn vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa c2 cneg vy cv cle
        wbr vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa vy cv c2 cneg cle
        wbr vy cv csin cfv cc0 wceq wa wo vy cv c2 cneg cle wbr vy cv csin cfv
        cc0 wceq wa c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa vy cv csin cfv
        cc0 wceq wa wo c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa vy cv csin
        cfv cc0 wceq wa vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa biorf
        c2 cneg vy cv cle wbr vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa
        vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa orcom syl6bb syl
        bitr4d pm5.32i anbi2i vy cv cS wcel vy cv c4 cneg cc0 cico co wcel vy
        cv csin cfv cc0 wceq wa c4 cneg vy cv cle wbr vy cv cr wcel vy cv cc0
        clt wbr vy cv csin cfv cc0 wceq wa wa wa vx cv csin cfv cc0 wceq vy cv
        csin cfv cc0 wceq vx vy cv c4 cneg cc0 cico co cS vx cv vy cv wceq vx
        cv csin cfv vy cv csin cfv cc0 vx cv vy cv csin fveq2 eqeq1d pilem1.1
        elrab2 vy cv c4 cneg cc0 cico co wcel vy cv csin cfv cc0 wceq wa c4
        cneg vy cv cle wbr vy cv cr wcel vy cv cc0 clt wbr wa wa vy cv csin cfv
        cc0 wceq wa c4 cneg vy cv cle wbr vy cv cr wcel vy cv cc0 clt wbr wa vy
        cv csin cfv cc0 wceq wa wa c4 cneg vy cv cle wbr vy cv cr wcel vy cv
        cc0 clt wbr vy cv csin cfv cc0 wceq wa wa wa vy cv c4 cneg cc0 cico co
        wcel c4 cneg vy cv cle wbr vy cv cr wcel vy cv cc0 clt wbr wa wa vy cv
        csin cfv cc0 wceq vy cv c4 cneg cc0 cico co wcel vy cv cr wcel c4 cneg
        vy cv cle wbr vy cv cc0 clt wbr w3a c4 cneg vy cv cle wbr vy cv cr wcel
        vy cv cc0 clt wbr w3a c4 cneg vy cv cle wbr vy cv cr wcel vy cv cc0 clt
        wbr wa wa c4 cneg cr wcel cc0 cr wcel vy cv c4 cneg cc0 cico co wcel vy
        cv cr wcel c4 cneg vy cv cle wbr vy cv cc0 clt wbr w3a wb c4 4re
        renegcli 0re c4 cneg cc0 vy cv elico2 mp2an vy cv cr wcel c4 cneg vy cv
        cle wbr vy cv cc0 clt wbr 3ancoma c4 cneg vy cv cle wbr vy cv cr wcel
        vy cv cc0 clt wbr 3anass 3bitri anbi1i c4 cneg vy cv cle wbr vy cv cr
        wcel vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq anass vy cv cr wcel
        vy cv cc0 clt wbr wa vy cv csin cfv cc0 wceq wa vy cv cr wcel vy cv cc0
        clt wbr vy cv csin cfv cc0 wceq wa wa c4 cneg vy cv cle wbr vy cv cr
        wcel vy cv cc0 clt wbr vy cv csin cfv cc0 wceq anass anbi2i 3bitri
        bitri vy cv cT wcel vy cv c4 cneg c2 cneg cicc co wcel vy cv csin cfv
        cc0 wceq wa c4 cneg vy cv cle wbr vy cv cr wcel vy cv c2 cneg cle wbr
        vy cv csin cfv cc0 wceq wa wa wa vx cv csin cfv cc0 wceq vy cv csin cfv
        cc0 wceq vx vy cv c4 cneg c2 cneg cicc co cT vx cv vy cv wceq vx cv
        csin cfv vy cv csin cfv cc0 vx cv vy cv csin fveq2 eqeq1d pilem1.3
        elrab2 vy cv c4 cneg c2 cneg cicc co wcel vy cv csin cfv cc0 wceq wa c4
        cneg vy cv cle wbr vy cv cr wcel vy cv c2 cneg cle wbr wa wa vy cv csin
        cfv cc0 wceq wa c4 cneg vy cv cle wbr vy cv cr wcel vy cv c2 cneg cle
        wbr wa vy cv csin cfv cc0 wceq wa wa c4 cneg vy cv cle wbr vy cv cr
        wcel vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa wa wa vy cv c4
        cneg c2 cneg cicc co wcel c4 cneg vy cv cle wbr vy cv cr wcel vy cv c2
        cneg cle wbr wa wa vy cv csin cfv cc0 wceq vy cv c4 cneg c2 cneg cicc
        co wcel vy cv cr wcel c4 cneg vy cv cle wbr vy cv c2 cneg cle wbr w3a
        c4 cneg vy cv cle wbr vy cv cr wcel vy cv c2 cneg cle wbr w3a c4 cneg
        vy cv cle wbr vy cv cr wcel vy cv c2 cneg cle wbr wa wa c4 cneg cr wcel
        c2 cneg cr wcel vy cv c4 cneg c2 cneg cicc co wcel vy cv cr wcel c4
        cneg vy cv cle wbr vy cv c2 cneg cle wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg c2 cneg vy cv elicc2 mp2an vy cv cr wcel c4 cneg vy cv
        cle wbr vy cv c2 cneg cle wbr 3ancoma c4 cneg vy cv cle wbr vy cv cr
        wcel vy cv c2 cneg cle wbr 3anass 3bitri anbi1i c4 cneg vy cv cle wbr
        vy cv cr wcel vy cv c2 cneg cle wbr wa vy cv csin cfv cc0 wceq anass vy
        cv cr wcel vy cv c2 cneg cle wbr wa vy cv csin cfv cc0 wceq wa vy cv cr
        wcel vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq wa wa c4 cneg vy cv
        cle wbr vy cv cr wcel vy cv c2 cneg cle wbr vy cv csin cfv cc0 wceq
        anass anbi2i 3bitri bitri 3bitr4i eqriv pilem1.3 eqtri c2 cneg csin cfv
        cc0 clt wbr cc0 c4 cneg csin cfv clt wbr c2 cneg csin cfv c2 csin cfv
        cneg cc0 clt c2 cc wcel c2 cneg csin cfv c2 csin cfv cneg wceq 2cn c2
        sinneg ax-mp cc0 c2 csin cfv clt wbr c2 csin cfv cneg cc0 clt wbr cc0
        c2 csin cfv clt wbr c2 ccos cfv cc0 clt wbr sincos2sgn pm3.26i c2 csin
        cfv cr wcel cc0 c2 csin cfv clt wbr c2 csin cfv cneg cc0 clt wbr wb c2
        cr wcel c2 csin cfv cr wcel 2re c2 resincl ax-mp c2 csin cfv lt0neg2
        ax-mp mpbi eqbrtri cc0 c4 csin cfv cneg c4 cneg csin cfv clt c4 csin
        cfv cc0 clt wbr cc0 c4 csin cfv cneg clt wbr sin4lt0 c4 csin cfv cr
        wcel c4 csin cfv cc0 clt wbr cc0 c4 csin cfv cneg clt wbr wb c4 cr wcel
        c4 csin cfv cr wcel 4re c4 resincl ax-mp c4 csin cfv lt0neg1 ax-mp mpbi
        c4 cc wcel c4 cneg csin cfv c4 csin cfv cneg wceq c4 4re recni c4
        sinneg ax-mp breqtrri pm3.2i pilem1.2 dsupivthi $.
        $( [23-Jan-2008] $) $( [23-Jan-2008] $)
    $}

    ${
      pilem2.3 $e |- T = { x e. RR | ( x < 0 /\ ( sin ` x ) = 0 ) } $.
      $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi . $)
      pilem2 $p |- C = sup ( T , RR , < ) $=
        cC cT cr clt csup wceq cC cT cr clt csup cle wbr cT cr clt csup cC cle
        wbr cC cT cr clt csup cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i vz vw cT cT
        cr wss cT c0 wne vw cv vz cv cle wbr vw cT wral vz cr wrex cT vx cv cc0
        clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr pilem2.3 vx cv cc0 clt
        wbr vx cv csin cfv cc0 wceq wa vx cr ssrab2 eqsstri cC cT wcel cT c0
        wne cC cT wcel cC cr wcel cC cc0 clt wbr cC csin cfv cc0 wceq wa vx cv
        cc0 clt wbr vx cv csin cfv cc0 wceq wa cC cc0 clt wbr cC csin cfv cc0
        wceq wa vx cC cr cT vx cv cC wceq vx cv cc0 clt wbr cC cc0 clt wbr vx
        cv csin cfv cc0 wceq cC csin cfv cc0 wceq vx cv cC cc0 clt breq1 vx cv
        cC wceq vx cv csin cfv cC csin cfv cc0 vx cv cC csin fveq2 eqeq1d
        anbi12d pilem2.3 elrab2 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i cC cc0 clt
        wbr cC csin cfv cc0 wceq cC c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0
        clt wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr
        2pos c2 cr wcel cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2
        ax-mp mpbi cC c2 cneg cc0 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i c2 2re
        renegcli 0re lttri mp2an cC c4 cneg c2 cneg cioo co wcel cC csin cfv
        cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab eqid pilem1 pm3.27i pm3.2i mpbir2an cT cC ne0i ax-mp cc0 cr
        wcel vw cv cc0 cle wbr vw cT wral vw cv vz cv cle wbr vw cT wral vz cr
        wrex 0re vw cv cc0 cle wbr vw cT vw cv cr wcel vw cv cc0 clt wbr vw cv
        cc0 cle wbr vw cv cT wcel vw cv cr wcel cc0 cr wcel vw cv cc0 clt wbr
        vw cv cc0 cle wbr wi 0re vw cv cc0 ltle mpan2 cT cr vw cv cT vx cv cc0
        clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr pilem2.3 vx cv cc0 clt
        wbr vx cv csin cfv cc0 wceq wa vx cr ssrab2 eqsstri sseli vw cv cT wcel
        vw cv cc0 clt wbr vw cv csin cfv cc0 wceq vw cv cT wcel vw cv cr wcel
        vw cv cc0 clt wbr vw cv csin cfv cc0 wceq wa vx cv cc0 clt wbr vx cv
        csin cfv cc0 wceq wa vw cv cc0 clt wbr vw cv csin cfv cc0 wceq wa vx vw
        cv cr cT vx cv vw cv wceq vx cv cc0 clt wbr vw cv cc0 clt wbr vx cv
        csin cfv cc0 wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0 clt breq1 vx
        cv vw cv wceq vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2
        eqeq1d anbi12d pilem2.3 elrab2 pm3.27bi pm3.26d sylc rgen vw cv vz cv
        cle wbr vw cT wral vw cv cc0 cle wbr vw cT wral vz cc0 cr vz cv cc0
        wceq vw cv vz cv cle wbr vw cv cc0 cle wbr vw cT vz cv cc0 vw cv cle
        breq2 ralbidv rcla4ev mp2an 3pm3.2i suprclii letri3i cC cT wcel cC cT
        cr clt csup cle wbr cC cT wcel cC cr wcel cC cc0 clt wbr cC csin cfv
        cc0 wceq wa vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa cC cc0 clt wbr
        cC csin cfv cc0 wceq wa vx cC cr cT vx cv cC wceq vx cv cc0 clt wbr cC
        cc0 clt wbr vx cv csin cfv cc0 wceq cC csin cfv cc0 wceq vx cv cC cc0
        clt breq1 vx cv cC wceq vx cv csin cfv cC csin cfv cc0 vx cv cC csin
        fveq2 eqeq1d anbi12d pilem2.3 elrab2 cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC
        clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin
        cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg
        cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4
        cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg
        cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i cC cc0
        clt wbr cC csin cfv cc0 wceq cC c2 cneg clt wbr c2 cneg cc0 clt wbr cC
        cc0 clt wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr
        2pos c2 cr wcel cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2
        ax-mp mpbi cC c2 cneg cc0 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i c2 2re
        renegcli 0re lttri mp2an cC c4 cneg c2 cneg cioo co wcel cC csin cfv
        cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab eqid pilem1 pm3.27i pm3.2i mpbir2an vz vw cT cC cT cr wss cT c0
        wne vw cv vz cv cle wbr vw cT wral vz cr wrex cT vx cv cc0 clt wbr vx
        cv csin cfv cc0 wceq wa vx cr crab cr pilem2.3 vx cv cc0 clt wbr vx cv
        csin cfv cc0 wceq wa vx cr ssrab2 eqsstri cC cT wcel cT c0 wne cC cT
        wcel cC cr wcel cC cc0 clt wbr cC csin cfv cc0 wceq wa vx cv cc0 clt
        wbr vx cv csin cfv cc0 wceq wa cC cc0 clt wbr cC csin cfv cc0 wceq wa
        vx cC cr cT vx cv cC wceq vx cv cc0 clt wbr cC cc0 clt wbr vx cv csin
        cfv cc0 wceq cC csin cfv cc0 wceq vx cv cC cc0 clt breq1 vx cv cC wceq
        vx cv csin cfv cC csin cfv cc0 vx cv cC csin fveq2 eqeq1d anbi12d
        pilem2.3 elrab2 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4
        cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS
        vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i cC cc0 clt wbr cC csin
        cfv cc0 wceq cC c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0 clt wbr cC
        cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg
        c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr
        wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4
        cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an
        mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr 2pos c2 cr wcel
        cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2 ax-mp mpbi cC c2
        cneg cc0 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp1i c2 2re renegcli 0re lttri mp2an cC
        c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.27i
        pm3.2i mpbir2an cT cC ne0i ax-mp cc0 cr wcel vw cv cc0 cle wbr vw cT
        wral vw cv vz cv cle wbr vw cT wral vz cr wrex 0re vw cv cc0 cle wbr vw
        cT vw cv cr wcel vw cv cc0 clt wbr vw cv cc0 cle wbr vw cv cT wcel vw
        cv cr wcel cc0 cr wcel vw cv cc0 clt wbr vw cv cc0 cle wbr wi 0re vw cv
        cc0 ltle mpan2 cT cr vw cv cT vx cv cc0 clt wbr vx cv csin cfv cc0 wceq
        wa vx cr crab cr pilem2.3 vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa
        vx cr ssrab2 eqsstri sseli vw cv cT wcel vw cv cc0 clt wbr vw cv csin
        cfv cc0 wceq vw cv cT wcel vw cv cr wcel vw cv cc0 clt wbr vw cv csin
        cfv cc0 wceq wa vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa vw cv cc0
        clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cT vx cv vw cv wceq vx
        cv cc0 clt wbr vw cv cc0 clt wbr vx cv csin cfv cc0 wceq vw cv csin cfv
        cc0 wceq vx cv vw cv cc0 clt breq1 vx cv vw cv wceq vx cv csin cfv vw
        cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d pilem2.3 elrab2
        pm3.27bi pm3.26d sylc rgen vw cv vz cv cle wbr vw cT wral vw cv cc0 cle
        wbr vw cT wral vz cc0 cr vz cv cc0 wceq vw cv vz cv cle wbr vw cv cc0
        cle wbr vw cT vz cv cc0 vw cv cle breq2 ralbidv rcla4ev mp2an 3pm3.2i
        suprubii ax-mp cC cr wcel vy cv cC cle wbr vy cT wral cT cr clt csup cC
        cle wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp1i vw cv cC cle wbr vw cT wral vy cv
        cC cle wbr vy cT wral vw cv cC cle wbr vw cT vw cv cT wcel vw cv cr
        wcel vw cv cc0 clt wbr vw cv csin cfv cc0 wceq wa wa vw cv cC cle wbr
        vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa vw cv cc0 clt wbr vw cv
        csin cfv cc0 wceq wa vx vw cv cr cT vx cv vw cv wceq vx cv cc0 clt wbr
        vw cv cc0 clt wbr vx cv csin cfv cc0 wceq vw cv csin cfv cc0 wceq vx cv
        vw cv cc0 clt breq1 vx cv vw cv wceq vx cv csin cfv vw cv csin cfv cc0
        vx cv vw cv csin fveq2 eqeq1d anbi12d pilem2.3 elrab2 vw cv cc0 clt wbr
        vw cv csin cfv cc0 wceq wa vw cv cr wcel vw cv cC cle wbr vw cv cc0 clt
        wbr vw cv csin cfv cc0 wceq wa vw cv cr wcel wa c4 cneg vw cv cle wbr
        vw cv c4 cneg cle wbr wo vw cv cC cle wbr vw cv cr wcel c4 cneg vw cv
        cle wbr vw cv c4 cneg cle wbr wo vw cv cc0 clt wbr vw cv csin cfv cc0
        wceq wa c4 cneg cr wcel vw cv cr wcel c4 cneg vw cv cle wbr vw cv c4
        cneg cle wbr wo c4 4re renegcli c4 cneg vw cv letric mpan adantl vw cv
        cc0 clt wbr vw cv csin cfv cc0 wceq wa vw cv cr wcel wa c4 cneg vw cv
        cle wbr vw cv cC cle wbr vw cv c4 cneg cle wbr vw cv cc0 clt wbr vw cv
        csin cfv cc0 wceq vw cv cr wcel c4 cneg vw cv cle wbr vw cv cC cle wbr
        wi vw cv cr wcel c4 cneg vw cv cle wbr vw cv cc0 clt wbr vw cv csin cfv
        cc0 wceq vw cv cC cle wbr vw cv cr wcel c4 cneg vw cv cle wbr vw cv cc0
        clt wbr vw cv csin cfv cc0 wceq vw cv cC cle wbr vw cv c4 cneg cc0 cico
        co wcel vw cv csin cfv cc0 wceq vw cv cC cle wbr vw cv cr wcel c4 cneg
        vw cv cle wbr vw cv cc0 clt wbr w3a vw cv c4 cneg cc0 cico co wcel vw
        cv csin cfv cc0 wceq wa vw cv cS wcel vw cv cC cle wbr vx cv csin cfv
        cc0 wceq vw cv csin cfv cc0 wceq vx vw cv c4 cneg cc0 cico co cS vx cv
        vw cv wceq vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2
        eqeq1d pilem1.1 elrab2 vw cv cS wcel vw cv cS cr clt csup cC cle vz vw
        cS vw cv cS cr wss cS c0 wne vw cv vz cv cle wbr vw cS wral vz cr wrex
        cS c4 cneg cc0 cico co cr cS vx cv csin cfv cc0 wceq vx c4 cneg cc0
        cico co crab c4 cneg cc0 cico co pilem1.1 vx cv csin cfv cc0 wceq vx c4
        cneg cc0 cico co ssrab2 eqsstri vw c4 cneg cc0 cico co cr vw cv c4 cneg
        cc0 cico co wcel vw cv cr wcel c4 cneg vw cv cle wbr vw cv cc0 clt wbr
        vw cv c4 cneg cc0 cico co wcel vw cv cr wcel c4 cneg vw cv cle wbr vw
        cv cc0 clt wbr w3a c4 cneg cr wcel cc0 cr wcel vw cv c4 cneg cc0 cico
        co wcel vw cv cr wcel c4 cneg vw cv cle wbr vw cv cc0 clt wbr w3a wb c4
        4re renegcli 0re c4 cneg cc0 vw cv elico2 mp2an biimpi 3simp1d ssriv
        sstri cC cS wcel cS c0 wne cC cS wcel cC c4 cneg cc0 cico co wcel cC
        csin cfv cc0 wceq vx cv csin cfv cc0 wceq cC csin cfv cc0 wceq vx cC c4
        cneg cc0 cico co cS vx cv cC wceq vx cv csin cfv cC csin cfv cc0 vx cv
        cC csin fveq2 eqeq1d pilem1.1 elrab2 cC c4 cneg cc0 cico co wcel cC cr
        wcel c4 cneg cC cle wbr cC cc0 clt wbr w3a cC cr wcel c4 cneg cC cle
        wbr cC cc0 clt wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC
        cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i c4 cneg cC c4 4re
        renegcli cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp1i cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv
        cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg
        cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp2i ltleii cC
        c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0 clt wbr cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo
        co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4
        cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx
        c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2
        cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg
        cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr
        wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an
        mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr 2pos c2 cr wcel cc0 c2
        clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2 ax-mp mpbi cC c2 cneg cc0
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i c2 2re renegcli 0re lttri mp2an 3pm3.2i
        c4 cneg cr wcel cc0 cr wcel cC c4 cneg cc0 cico co wcel cC cr wcel c4
        cneg cC cle wbr cC cc0 clt wbr w3a wb c4 4re renegcli 0re c4 cneg cc0
        cC elico2 mp2an mpbir cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0
        wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.27i mpbir2an cS cC ne0i ax-mp cc0 cr wcel vw cv
        cc0 cle wbr vw cS wral vw cv vz cv cle wbr vw cS wral vz cr wrex 0re vw
        cv cc0 cle wbr vw cS vw cv cr wcel vw cv cc0 clt wbr vw cv cc0 cle wbr
        vw cv cS wcel vw cv cr wcel cc0 cr wcel vw cv cc0 clt wbr vw cv cc0 cle
        wbr wi 0re vw cv cc0 ltle mpan2 cS cr vw cv cS c4 cneg cc0 cico co cr
        cS vx cv csin cfv cc0 wceq vx c4 cneg cc0 cico co crab c4 cneg cc0 cico
        co pilem1.1 vx cv csin cfv cc0 wceq vx c4 cneg cc0 cico co ssrab2
        eqsstri vw c4 cneg cc0 cico co cr vw cv c4 cneg cc0 cico co wcel vw cv
        cr wcel c4 cneg vw cv cle wbr vw cv cc0 clt wbr vw cv c4 cneg cc0 cico
        co wcel vw cv cr wcel c4 cneg vw cv cle wbr vw cv cc0 clt wbr w3a c4
        cneg cr wcel cc0 cr wcel vw cv c4 cneg cc0 cico co wcel vw cv cr wcel
        c4 cneg vw cv cle wbr vw cv cc0 clt wbr w3a wb c4 4re renegcli 0re c4
        cneg cc0 vw cv elico2 mp2an biimpi 3simp1d ssriv sstri sseli vw cv cS
        wcel vw cv cr wcel c4 cneg vw cv cle wbr vw cv cc0 clt wbr vw cv cS
        wcel vw cv c4 cneg cc0 cico co wcel vw cv cr wcel c4 cneg vw cv cle wbr
        vw cv cc0 clt wbr w3a vw cv cS wcel vw cv c4 cneg cc0 cico co wcel vw
        cv csin cfv cc0 wceq vx cv csin cfv cc0 wceq vw cv csin cfv cc0 wceq vx
        vw cv c4 cneg cc0 cico co cS vx cv vw cv wceq vx cv csin cfv vw cv csin
        cfv cc0 vx cv vw cv csin fveq2 eqeq1d pilem1.1 elrab2 pm3.26bi c4 cneg
        cr wcel cc0 cr wcel vw cv c4 cneg cc0 cico co wcel vw cv cr wcel c4
        cneg vw cv cle wbr vw cv cc0 clt wbr w3a wb c4 4re renegcli 0re c4 cneg
        cc0 vw cv elico2 mp2an sylib 3simp3d sylc rgen vw cv vz cv cle wbr vw
        cS wral vw cv cc0 cle wbr vw cS wral vz cc0 cr vz cv cc0 wceq vw cv vz
        cv cle wbr vw cv cc0 cle wbr vw cS vz cv cc0 vw cv cle breq2 ralbidv
        rcla4ev mp2an 3pm3.2i suprubii pilem1.2 syl6breqr sylbir c4 cneg cr
        wcel cc0 cr wcel vw cv c4 cneg cc0 cico co wcel vw cv cr wcel c4 cneg
        vw cv cle wbr vw cv cc0 clt wbr w3a wb c4 4re renegcli 0re c4 cneg cc0
        vw cv elico2 mp2an sylanbr 3exp1 com4t imp31 vw cv cr wcel vw cv c4
        cneg cle wbr vw cv cC cle wbr wi vw cv cc0 clt wbr vw cv csin cfv cc0
        wceq wa vw cv cr wcel vw cv c4 cneg cle wbr c4 cneg cC cle wbr vw cv cC
        cle wbr c4 cneg cC c4 4re renegcli cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv
        cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg
        cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr
        wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4
        cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an
        mp2an mpbi 3simp2i ltleii vw cv cr wcel c4 cneg cr wcel cC cr wcel vw
        cv c4 cneg cle wbr c4 cneg cC cle wbr wa vw cv cC cle wbr wi c4 4re
        renegcli cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp1i vw cv c4 cneg cC letr mp3an23
        mpan2i adantl jaod mpd ancoms sylbi rgen vw cv cC cle wbr vy cv cC cle
        wbr vw vy cT vw cv vy cv cC cle breq1 cbvralv mpbi vz vw vy cT cC cT cr
        wss cT c0 wne vw cv vz cv cle wbr vw cT wral vz cr wrex cT vx cv cc0
        clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr pilem2.3 vx cv cc0 clt
        wbr vx cv csin cfv cc0 wceq wa vx cr ssrab2 eqsstri cC cT wcel cT c0
        wne cC cT wcel cC cr wcel cC cc0 clt wbr cC csin cfv cc0 wceq wa vx cv
        cc0 clt wbr vx cv csin cfv cc0 wceq wa cC cc0 clt wbr cC csin cfv cc0
        wceq wa vx cC cr cT vx cv cC wceq vx cv cc0 clt wbr cC cc0 clt wbr vx
        cv csin cfv cc0 wceq cC csin cfv cc0 wceq vx cv cC cc0 clt breq1 vx cv
        cC wceq vx cv csin cfv cC csin cfv cc0 vx cv cC csin fveq2 eqeq1d
        anbi12d pilem2.3 elrab2 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i cC cc0 clt
        wbr cC csin cfv cc0 wceq cC c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0
        clt wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr
        2pos c2 cr wcel cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2
        ax-mp mpbi cC c2 cneg cc0 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i c2 2re
        renegcli 0re lttri mp2an cC c4 cneg c2 cneg cioo co wcel cC csin cfv
        cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab eqid pilem1 pm3.27i pm3.2i mpbir2an cT cC ne0i ax-mp cc0 cr
        wcel vw cv cc0 cle wbr vw cT wral vw cv vz cv cle wbr vw cT wral vz cr
        wrex 0re vw cv cc0 cle wbr vw cT vw cv cr wcel vw cv cc0 clt wbr vw cv
        cc0 cle wbr vw cv cT wcel vw cv cr wcel cc0 cr wcel vw cv cc0 clt wbr
        vw cv cc0 cle wbr wi 0re vw cv cc0 ltle mpan2 cT cr vw cv cT vx cv cc0
        clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr pilem2.3 vx cv cc0 clt
        wbr vx cv csin cfv cc0 wceq wa vx cr ssrab2 eqsstri sseli vw cv cT wcel
        vw cv cc0 clt wbr vw cv csin cfv cc0 wceq vw cv cT wcel vw cv cr wcel
        vw cv cc0 clt wbr vw cv csin cfv cc0 wceq wa vx cv cc0 clt wbr vx cv
        csin cfv cc0 wceq wa vw cv cc0 clt wbr vw cv csin cfv cc0 wceq wa vx vw
        cv cr cT vx cv vw cv wceq vx cv cc0 clt wbr vw cv cc0 clt wbr vx cv
        csin cfv cc0 wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0 clt breq1 vx
        cv vw cv wceq vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2
        eqeq1d anbi12d pilem2.3 elrab2 pm3.27bi pm3.26d sylc rgen vw cv vz cv
        cle wbr vw cT wral vw cv cc0 cle wbr vw cT wral vz cc0 cr vz cv cc0
        wceq vw cv vz cv cle wbr vw cv cc0 cle wbr vw cT vz cv cc0 vw cv cle
        breq2 ralbidv rcla4ev mp2an 3pm3.2i suprleubii mp2an mpbir2an $.
        $( [23-Jan-2008] $) $( [23-Jan-2008] $)
    $}

    ${
      pilem3.3 $e |- T = { x e. RR | ( x < 0 /\ ( sin ` x ) = 0 ) } $.
      pilem3.4 $e |- P = { x e. RR | ( 0 < x /\ ( sin ` x ) = 0 ) } $.
      $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi . $)
      pilem3 $p |- ( pi e. RR+ /\ pi e. ( 2 (,) 4 ) /\ ( sin ` pi ) = 0 ) $=
        cpi crp wcel cpi c2 c4 cioo co wcel cpi csin cfv cc0 wceq cpi cpi cC
        cneg cr cpi vv cv cneg cP wcel vv cr crab cr clt csup cneg cC cneg cP
        cr wss cP c0 wne vz cv vw cv cle wbr vw cP wral vz cr wrex cpi vv cv
        cneg cP wcel vv cr crab cr clt csup cneg wceq cP cc0 vx cv clt wbr vx
        cv csin cfv cc0 wceq wa vx cr crab cr pilem3.4 cc0 vx cv clt wbr vx cv
        csin cfv cc0 wceq wa vx cr ssrab2 eqsstri cC cneg cP wcel cP c0 wne cc0
        cC cneg clt wbr cC cneg csin cfv cc0 wceq cC cneg cP wcel cC cc0 clt
        wbr cc0 cC cneg clt wbr cC c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0
        clt wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr
        2pos c2 cr wcel cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2
        ax-mp mpbi cC c2 cneg cc0 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq
        vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC
        elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i c2 2re
        renegcli 0re lttri mp2an cC cr wcel cC cc0 clt wbr cc0 cC cneg clt wbr
        wb cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i cC lt0neg1 ax-mp mpbi cC cneg csin cfv
        cC csin cfv cneg cc0 cneg cc0 cC cc wcel cC cneg csin cfv cC csin cfv
        cneg wceq cC cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4
        cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS
        vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i recni cC sinneg ax-mp
        cC csin cfv cc0 cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx
        cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.27i negeqi neg0 3eqtri cC cneg cr wcel cc0 cC cneg clt wbr
        cC cneg csin cfv cc0 wceq wa cC cneg cP wcel cC cC cr wcel c4 cneg cC
        clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co
        wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg
        c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4
        cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg
        cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr
        cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr
        wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr
        wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an
        mpbi 3simp1i renegcli cC cneg cP wcel cC cneg cr wcel cc0 cC cneg clt
        wbr cC cneg csin cfv cc0 wceq wa wa cc0 vx cv clt wbr vx cv csin cfv
        cc0 wceq wa cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa vx cC cneg
        cr cP vx cv cC cneg wceq cc0 vx cv clt wbr cc0 cC cneg clt wbr vx cv
        csin cfv cc0 wceq cC cneg csin cfv cc0 wceq vx cv cC cneg cc0 clt breq2
        vx cv cC cneg wceq vx cv csin cfv cC cneg csin cfv cc0 vx cv cC cneg
        csin fveq2 eqeq1d anbi12d pilem3.4 elrab2 biimpri mpan mp2an cP cC cneg
        ne0i ax-mp cc0 cr wcel cc0 vw cv cle wbr vw cP wral vz cv vw cv cle wbr
        vw cP wral vz cr wrex 0re cc0 vw cv cle wbr vw cP vw cv cr wcel cc0 vw
        cv clt wbr cc0 vw cv cle wbr vw cv cP wcel cc0 cr wcel vw cv cr wcel
        cc0 vw cv clt wbr cc0 vw cv cle wbr wi 0re cc0 vw cv ltle mpan vw cv cP
        wcel vw cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq wa cc0 vx
        cv clt wbr vx cv csin cfv cc0 wceq wa cc0 vw cv clt wbr vw cv csin cfv
        cc0 wceq wa vx vw cv cr cP vx cv vw cv wceq cc0 vx cv clt wbr cc0 vw cv
        clt wbr vx cv csin cfv cc0 wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0
        clt breq2 vx cv vw cv wceq vx cv csin cfv vw cv csin cfv cc0 vx cv vw
        cv csin fveq2 eqeq1d anbi12d pilem3.4 elrab2 pm3.26bi vw cv cP wcel vw
        cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq vw cv cP wcel vw
        cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq w3a vw cv cP wcel
        vw cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq wa wa vw cv cr
        wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq w3a cc0 vx cv clt wbr vx
        cv csin cfv cc0 wceq wa cc0 vw cv clt wbr vw cv csin cfv cc0 wceq wa vx
        vw cv cr cP vx cv vw cv wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv
        csin cfv cc0 wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx
        cv vw cv wceq vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2
        eqeq1d anbi12d pilem3.4 elrab2 vw cv cr wcel cc0 vw cv clt wbr vw cv
        csin cfv cc0 wceq 3anass bitr4i biimpi 3simp2d sylc rgen vz cv vw cv
        cle wbr vw cP wral cc0 vw cv cle wbr vw cP wral vz cc0 cr vz cv cc0
        wceq vz cv vw cv cle wbr cc0 vw cv cle wbr vw cP vz cv cc0 vw cv cle
        breq1 ralbidv rcla4ev mp2an cP cr wss cP c0 wne vz cv vw cv cle wbr vw
        cP wral vz cr wrex w3a cP cr clt ccnv csup vv cv cneg cP wcel vv cr
        crab cr clt csup cneg cpi vz vw vv cP infmsup cpi cc0 vx cv clt wbr vx
        cv csin cfv cc0 wceq wa vx cr crab cr clt ccnv csup cP cr clt ccnv csup
        vx df-pi cP cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab
        wceq cP cr clt ccnv csup cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa
        vx cr crab cr clt ccnv csup wceq pilem3.4 cr cP cc0 vx cv clt wbr vx cv
        csin cfv cc0 wceq wa vx cr crab clt ccnv supeq1 ax-mp eqtr4i syl5eq
        mp3an cC vv cv cneg cP wcel vv cr crab cr clt csup cC cT cr clt csup vv
        cv cneg cP wcel vv cr crab cr clt csup vx cC cS cT pilem1.1 pilem1.2
        pilem3.3 pilem2 cT vv cv cneg cP wcel vv cr crab wceq cT cr clt csup vv
        cv cneg cP wcel vv cr crab cr clt csup wceq cT vx cv cc0 clt wbr vx cv
        csin cfv cc0 wceq wa vx cr crab vv cv cc0 clt wbr vv cv csin cfv cc0
        wceq wa vv cr crab vv cv cneg cP wcel vv cr crab pilem3.3 vx cv cc0 clt
        wbr vx cv csin cfv cc0 wceq wa vv cv cc0 clt wbr vv cv csin cfv cc0
        wceq wa vx vv cr vx cv vv cv wceq vx cv cc0 clt wbr vv cv cc0 clt wbr
        vx cv csin cfv cc0 wceq vv cv csin cfv cc0 wceq vx cv vv cv cc0 clt
        breq1 vx cv vv cv wceq vx cv csin cfv vv cv csin cfv cc0 vx cv vv cv
        csin fveq2 eqeq1d anbi12d cbvrabv vv cv cc0 clt wbr vv cv csin cfv cc0
        wceq wa vv cv cneg cP wcel vv cr vv cv cr wcel vv cv cc0 clt wbr vv cv
        csin cfv cc0 wceq wa vv cv cneg cr wcel cc0 vv cv cneg clt wbr vv cv
        cneg csin cfv cc0 wceq wa wa vv cv cneg cP wcel vv cv cr wcel vv cv cc0
        clt wbr vv cv csin cfv cc0 wceq wa cc0 vv cv cneg clt wbr vv cv cneg
        csin cfv cc0 wceq wa vv cv cneg cr wcel cc0 vv cv cneg clt wbr vv cv
        cneg csin cfv cc0 wceq wa wa vv cv cr wcel vv cv cc0 clt wbr cc0 vv cv
        cneg clt wbr vv cv csin cfv cc0 wceq vv cv cneg csin cfv cc0 wceq vv cv
        lt0neg1 vv cv cr wcel vv cv csin cfv cc0 wceq vv cv csin cfv cneg cc0
        wceq vv cv cneg csin cfv cc0 wceq vv cv cr wcel vv cv csin cfv cc wcel
        vv cv csin cfv cc0 wceq vv cv csin cfv cneg cc0 wceq wb vv cv cr wcel
        vv cv csin cfv vv cv resincl recnd vv cv csin cfv negeq0 syl vv cv cr
        wcel vv cv cneg csin cfv vv cv csin cfv cneg cc0 vv cv cr wcel vv cv cc
        wcel vv cv cneg csin cfv vv cv csin cfv cneg wceq vv cv recn vv cv
        sinneg syl eqeq1d bitr4d anbi12d vv cv cr wcel vv cv cneg cr wcel cc0
        vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa vv cv renegcl
        biantrurd bitrd cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0 vv cv
        cneg clt wbr vv cv cneg csin cfv cc0 wceq wa vx vv cv cneg cr cP vx cv
        vv cv cneg wceq cc0 vx cv clt wbr cc0 vv cv cneg clt wbr vx cv csin cfv
        cc0 wceq vv cv cneg csin cfv cc0 wceq vx cv vv cv cneg cc0 clt breq2 vx
        cv vv cv cneg wceq vx cv csin cfv vv cv cneg csin cfv cc0 vx cv vv cv
        cneg csin fveq2 eqeq1d anbi12d pilem3.4 elrab2 syl6bbr rabbii 3eqtri cr
        cT vv cv cneg cP wcel vv cr crab clt supeq1 ax-mp eqtri negeqi eqtr4i
        cC cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i renegcli eqeltri cc0 cC cneg cpi clt cC
        cc0 clt wbr cc0 cC cneg clt wbr cC c2 cneg clt wbr c2 cneg cc0 clt wbr
        cC cc0 clt wbr cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4
        cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS
        vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg
        cc0 clt wbr 2pos c2 cr wcel cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re
        c2 lt0neg2 ax-mp mpbi cC c2 cneg cc0 cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC
        clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin
        cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg
        cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4
        cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt
        wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg
        cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i c2 2re
        renegcli 0re lttri mp2an cC cr wcel cC cc0 clt wbr cc0 cC cneg clt wbr
        wb cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i cC lt0neg1 ax-mp mpbi cpi vv cv cneg cP
        wcel vv cr crab cr clt csup cneg cC cneg cP cr wss cP c0 wne vz cv vw
        cv cle wbr vw cP wral vz cr wrex cpi vv cv cneg cP wcel vv cr crab cr
        clt csup cneg wceq cP cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx
        cr crab cr pilem3.4 cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr
        ssrab2 eqsstri cC cneg cP wcel cP c0 wne cc0 cC cneg clt wbr cC cneg
        csin cfv cc0 wceq cC cneg cP wcel cC cc0 clt wbr cc0 cC cneg clt wbr cC
        c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0 clt wbr cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo
        co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4
        cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx
        c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2
        cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg
        cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr
        wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an
        mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr 2pos c2 cr wcel cc0 c2
        clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2 ax-mp mpbi cC c2 cneg cc0
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i c2 2re renegcli 0re lttri mp2an cC cr
        wcel cC cc0 clt wbr cc0 cC cneg clt wbr wb cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel
        cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2
        cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg
        c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel
        c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC
        clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4
        cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi
        3simp1i cC lt0neg1 ax-mp mpbi cC cneg csin cfv cC csin cfv cneg cc0
        cneg cc0 cC cc wcel cC cneg csin cfv cC csin cfv cneg wceq cC cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr
        wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4
        cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an
        mp2an mpbi 3simp1i recni cC sinneg ax-mp cC csin cfv cc0 cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.27i negeqi neg0
        3eqtri cC cneg cr wcel cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa
        cC cneg cP wcel cC cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC
        cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i renegcli cC cneg cP
        wcel cC cneg cr wcel cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa
        wa cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0 cC cneg clt wbr cC
        cneg csin cfv cc0 wceq wa vx cC cneg cr cP vx cv cC cneg wceq cc0 vx cv
        clt wbr cc0 cC cneg clt wbr vx cv csin cfv cc0 wceq cC cneg csin cfv
        cc0 wceq vx cv cC cneg cc0 clt breq2 vx cv cC cneg wceq vx cv csin cfv
        cC cneg csin cfv cc0 vx cv cC cneg csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 biimpri mpan mp2an cP cC cneg ne0i ax-mp cc0 cr wcel cc0 vw cv
        cle wbr vw cP wral vz cv vw cv cle wbr vw cP wral vz cr wrex 0re cc0 vw
        cv cle wbr vw cP vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv cle wbr vw
        cv cP wcel cc0 cr wcel vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv cle
        wbr wi 0re cc0 vw cv ltle mpan vw cv cP wcel vw cv cr wcel cc0 vw cv
        clt wbr vw cv csin cfv cc0 wceq wa cc0 vx cv clt wbr vx cv csin cfv cc0
        wceq wa cc0 vw cv clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cP vx
        cv vw cv wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv csin cfv cc0
        wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx cv vw cv wceq
        vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d
        pilem3.4 elrab2 pm3.26bi vw cv cP wcel vw cv cr wcel cc0 vw cv clt wbr
        vw cv csin cfv cc0 wceq vw cv cP wcel vw cv cr wcel cc0 vw cv clt wbr
        vw cv csin cfv cc0 wceq w3a vw cv cP wcel vw cv cr wcel cc0 vw cv clt
        wbr vw cv csin cfv cc0 wceq wa wa vw cv cr wcel cc0 vw cv clt wbr vw cv
        csin cfv cc0 wceq w3a cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0
        vw cv clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cP vx cv vw cv
        wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv csin cfv cc0 wceq vw cv
        csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx cv vw cv wceq vx cv csin
        cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 vw cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq 3anass
        bitr4i biimpi 3simp2d sylc rgen vz cv vw cv cle wbr vw cP wral cc0 vw
        cv cle wbr vw cP wral vz cc0 cr vz cv cc0 wceq vz cv vw cv cle wbr cc0
        vw cv cle wbr vw cP vz cv cc0 vw cv cle breq1 ralbidv rcla4ev mp2an cP
        cr wss cP c0 wne vz cv vw cv cle wbr vw cP wral vz cr wrex w3a cP cr
        clt ccnv csup vv cv cneg cP wcel vv cr crab cr clt csup cneg cpi vz vw
        vv cP infmsup cpi cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr
        crab cr clt ccnv csup cP cr clt ccnv csup vx df-pi cP cc0 vx cv clt wbr
        vx cv csin cfv cc0 wceq wa vx cr crab wceq cP cr clt ccnv csup cc0 vx
        cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr clt ccnv csup wceq
        pilem3.4 cr cP cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab
        clt ccnv supeq1 ax-mp eqtr4i syl5eq mp3an cC vv cv cneg cP wcel vv cr
        crab cr clt csup cC cT cr clt csup vv cv cneg cP wcel vv cr crab cr clt
        csup vx cC cS cT pilem1.1 pilem1.2 pilem3.3 pilem2 cT vv cv cneg cP
        wcel vv cr crab wceq cT cr clt csup vv cv cneg cP wcel vv cr crab cr
        clt csup wceq cT vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa vx cr
        crab vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cr crab vv cv cneg
        cP wcel vv cr crab pilem3.3 vx cv cc0 clt wbr vx cv csin cfv cc0 wceq
        wa vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vx vv cr vx cv vv cv
        wceq vx cv cc0 clt wbr vv cv cc0 clt wbr vx cv csin cfv cc0 wceq vv cv
        csin cfv cc0 wceq vx cv vv cv cc0 clt breq1 vx cv vv cv wceq vx cv csin
        cfv vv cv csin cfv cc0 vx cv vv cv csin fveq2 eqeq1d anbi12d cbvrabv vv
        cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cv cneg cP wcel vv cr vv
        cv cr wcel vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cv cneg cr
        wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa wa vv cv
        cneg cP wcel vv cv cr wcel vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa
        cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa vv cv cneg cr
        wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa wa vv cv cr
        wcel vv cv cc0 clt wbr cc0 vv cv cneg clt wbr vv cv csin cfv cc0 wceq
        vv cv cneg csin cfv cc0 wceq vv cv lt0neg1 vv cv cr wcel vv cv csin cfv
        cc0 wceq vv cv csin cfv cneg cc0 wceq vv cv cneg csin cfv cc0 wceq vv
        cv cr wcel vv cv csin cfv cc wcel vv cv csin cfv cc0 wceq vv cv csin
        cfv cneg cc0 wceq wb vv cv cr wcel vv cv csin cfv vv cv resincl recnd
        vv cv csin cfv negeq0 syl vv cv cr wcel vv cv cneg csin cfv vv cv csin
        cfv cneg cc0 vv cv cr wcel vv cv cc wcel vv cv cneg csin cfv vv cv csin
        cfv cneg wceq vv cv recn vv cv sinneg syl eqeq1d bitr4d anbi12d vv cv
        cr wcel vv cv cneg cr wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv
        cc0 wceq wa vv cv renegcl biantrurd bitrd cc0 vx cv clt wbr vx cv csin
        cfv cc0 wceq wa cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa
        vx vv cv cneg cr cP vx cv vv cv cneg wceq cc0 vx cv clt wbr cc0 vv cv
        cneg clt wbr vx cv csin cfv cc0 wceq vv cv cneg csin cfv cc0 wceq vx cv
        vv cv cneg cc0 clt breq2 vx cv vv cv cneg wceq vx cv csin cfv vv cv
        cneg csin cfv cc0 vx cv vv cv cneg csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 syl6bbr rabbii 3eqtri cr cT vv cv cneg cP wcel vv cr crab clt
        supeq1 ax-mp eqtri negeqi eqtr4i breqtrri elrpii cpi cC cneg c2 c4 cioo
        co cpi vv cv cneg cP wcel vv cr crab cr clt csup cneg cC cneg cP cr wss
        cP c0 wne vz cv vw cv cle wbr vw cP wral vz cr wrex cpi vv cv cneg cP
        wcel vv cr crab cr clt csup cneg wceq cP cc0 vx cv clt wbr vx cv csin
        cfv cc0 wceq wa vx cr crab cr pilem3.4 cc0 vx cv clt wbr vx cv csin cfv
        cc0 wceq wa vx cr ssrab2 eqsstri cC cneg cP wcel cP c0 wne cc0 cC cneg
        clt wbr cC cneg csin cfv cc0 wceq cC cneg cP wcel cC cc0 clt wbr cc0 cC
        cneg clt wbr cC c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0 clt wbr cC
        cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg
        c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr
        wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4
        cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an
        mp2an mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr 2pos c2 cr wcel
        cc0 c2 clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2 ax-mp mpbi cC c2
        cneg cc0 cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2
        cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a
        cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx
        cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1
        pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli
        c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4
        cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2
        cneg rexr syl2an mp2an mpbi 3simp1i c2 2re renegcli 0re lttri mp2an cC
        cr wcel cC cc0 clt wbr cc0 cC cneg clt wbr wb cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel
        cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2
        cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg
        c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel
        c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC
        clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4
        cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi
        3simp1i cC lt0neg1 ax-mp mpbi cC cneg csin cfv cC csin cfv cneg cc0
        cneg cc0 cC cc wcel cC cneg csin cfv cC csin cfv cneg wceq cC cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr
        wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4
        cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an
        mp2an mpbi 3simp1i recni cC sinneg ax-mp cC csin cfv cc0 cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.27i negeqi neg0
        3eqtri cC cneg cr wcel cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa
        cC cneg cP wcel cC cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC
        cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i renegcli cC cneg cP
        wcel cC cneg cr wcel cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa
        wa cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0 cC cneg clt wbr cC
        cneg csin cfv cc0 wceq wa vx cC cneg cr cP vx cv cC cneg wceq cc0 vx cv
        clt wbr cc0 cC cneg clt wbr vx cv csin cfv cc0 wceq cC cneg csin cfv
        cc0 wceq vx cv cC cneg cc0 clt breq2 vx cv cC cneg wceq vx cv csin cfv
        cC cneg csin cfv cc0 vx cv cC cneg csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 biimpri mpan mp2an cP cC cneg ne0i ax-mp cc0 cr wcel cc0 vw cv
        cle wbr vw cP wral vz cv vw cv cle wbr vw cP wral vz cr wrex 0re cc0 vw
        cv cle wbr vw cP vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv cle wbr vw
        cv cP wcel cc0 cr wcel vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv cle
        wbr wi 0re cc0 vw cv ltle mpan vw cv cP wcel vw cv cr wcel cc0 vw cv
        clt wbr vw cv csin cfv cc0 wceq wa cc0 vx cv clt wbr vx cv csin cfv cc0
        wceq wa cc0 vw cv clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cP vx
        cv vw cv wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv csin cfv cc0
        wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx cv vw cv wceq
        vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d
        pilem3.4 elrab2 pm3.26bi vw cv cP wcel vw cv cr wcel cc0 vw cv clt wbr
        vw cv csin cfv cc0 wceq vw cv cP wcel vw cv cr wcel cc0 vw cv clt wbr
        vw cv csin cfv cc0 wceq w3a vw cv cP wcel vw cv cr wcel cc0 vw cv clt
        wbr vw cv csin cfv cc0 wceq wa wa vw cv cr wcel cc0 vw cv clt wbr vw cv
        csin cfv cc0 wceq w3a cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0
        vw cv clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cP vx cv vw cv
        wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv csin cfv cc0 wceq vw cv
        csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx cv vw cv wceq vx cv csin
        cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 vw cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq 3anass
        bitr4i biimpi 3simp2d sylc rgen vz cv vw cv cle wbr vw cP wral cc0 vw
        cv cle wbr vw cP wral vz cc0 cr vz cv cc0 wceq vz cv vw cv cle wbr cc0
        vw cv cle wbr vw cP vz cv cc0 vw cv cle breq1 ralbidv rcla4ev mp2an cP
        cr wss cP c0 wne vz cv vw cv cle wbr vw cP wral vz cr wrex w3a cP cr
        clt ccnv csup vv cv cneg cP wcel vv cr crab cr clt csup cneg cpi vz vw
        vv cP infmsup cpi cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr
        crab cr clt ccnv csup cP cr clt ccnv csup vx df-pi cP cc0 vx cv clt wbr
        vx cv csin cfv cc0 wceq wa vx cr crab wceq cP cr clt ccnv csup cc0 vx
        cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr clt ccnv csup wceq
        pilem3.4 cr cP cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab
        clt ccnv supeq1 ax-mp eqtr4i syl5eq mp3an cC vv cv cneg cP wcel vv cr
        crab cr clt csup cC cT cr clt csup vv cv cneg cP wcel vv cr crab cr clt
        csup vx cC cS cT pilem1.1 pilem1.2 pilem3.3 pilem2 cT vv cv cneg cP
        wcel vv cr crab wceq cT cr clt csup vv cv cneg cP wcel vv cr crab cr
        clt csup wceq cT vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa vx cr
        crab vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cr crab vv cv cneg
        cP wcel vv cr crab pilem3.3 vx cv cc0 clt wbr vx cv csin cfv cc0 wceq
        wa vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vx vv cr vx cv vv cv
        wceq vx cv cc0 clt wbr vv cv cc0 clt wbr vx cv csin cfv cc0 wceq vv cv
        csin cfv cc0 wceq vx cv vv cv cc0 clt breq1 vx cv vv cv wceq vx cv csin
        cfv vv cv csin cfv cc0 vx cv vv cv csin fveq2 eqeq1d anbi12d cbvrabv vv
        cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cv cneg cP wcel vv cr vv
        cv cr wcel vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cv cneg cr
        wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa wa vv cv
        cneg cP wcel vv cv cr wcel vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa
        cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa vv cv cneg cr
        wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa wa vv cv cr
        wcel vv cv cc0 clt wbr cc0 vv cv cneg clt wbr vv cv csin cfv cc0 wceq
        vv cv cneg csin cfv cc0 wceq vv cv lt0neg1 vv cv cr wcel vv cv csin cfv
        cc0 wceq vv cv csin cfv cneg cc0 wceq vv cv cneg csin cfv cc0 wceq vv
        cv cr wcel vv cv csin cfv cc wcel vv cv csin cfv cc0 wceq vv cv csin
        cfv cneg cc0 wceq wb vv cv cr wcel vv cv csin cfv vv cv resincl recnd
        vv cv csin cfv negeq0 syl vv cv cr wcel vv cv cneg csin cfv vv cv csin
        cfv cneg cc0 vv cv cr wcel vv cv cc wcel vv cv cneg csin cfv vv cv csin
        cfv cneg wceq vv cv recn vv cv sinneg syl eqeq1d bitr4d anbi12d vv cv
        cr wcel vv cv cneg cr wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv
        cc0 wceq wa vv cv renegcl biantrurd bitrd cc0 vx cv clt wbr vx cv csin
        cfv cc0 wceq wa cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa
        vx vv cv cneg cr cP vx cv vv cv cneg wceq cc0 vx cv clt wbr cc0 vv cv
        cneg clt wbr vx cv csin cfv cc0 wceq vv cv cneg csin cfv cc0 wceq vx cv
        vv cv cneg cc0 clt breq2 vx cv vv cv cneg wceq vx cv csin cfv vv cv
        cneg csin cfv cc0 vx cv vv cv cneg csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 syl6bbr rabbii 3eqtri cr cT vv cv cneg cP wcel vv cr crab clt
        supeq1 ax-mp eqtri negeqi eqtr4i cC c4 cneg c2 cneg cioo co wcel cC
        cneg c2 c4 cioo co wcel cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0
        wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab
        pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab eqid pilem1 pm3.26i cC cneg c2 c4 cioo co wcel cC cneg cneg c4
        cneg c2 cneg cioo co wcel cC c4 cneg c2 cneg cioo co wcel c2 cr wcel c4
        cr wcel cC cneg cr wcel cC cneg c2 c4 cioo co wcel cC cneg cneg c4 cneg
        c2 cneg cioo co wcel wb 2re 4re cC cC cr wcel c4 cneg cC clt wbr cC c2
        cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv
        cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co
        crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc
        co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg
        cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i renegcli
        c2 c4 cC cneg iooneg mp3an cC cneg cneg cC c4 cneg c2 cneg cioo co cC
        cC cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i recni negnegi eleq1i bitr2i mpbi eqeltri
        cpi csin cfv cC cneg csin cfv cc0 cpi cC cneg csin cpi vv cv cneg cP
        wcel vv cr crab cr clt csup cneg cC cneg cP cr wss cP c0 wne vz cv vw
        cv cle wbr vw cP wral vz cr wrex cpi vv cv cneg cP wcel vv cr crab cr
        clt csup cneg wceq cP cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx
        cr crab cr pilem3.4 cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr
        ssrab2 eqsstri cC cneg cP wcel cP c0 wne cc0 cC cneg clt wbr cC cneg
        csin cfv cc0 wceq cC cneg cP wcel cC cc0 clt wbr cc0 cC cneg clt wbr cC
        c2 cneg clt wbr c2 cneg cc0 clt wbr cC cc0 clt wbr cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo
        co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4
        cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx
        c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2
        cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg
        cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr
        wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an
        mpbi 3simp3i cc0 c2 clt wbr c2 cneg cc0 clt wbr 2pos c2 cr wcel cc0 c2
        clt wbr c2 cneg cc0 clt wbr wb 2re c2 lt0neg2 ax-mp mpbi cC c2 cneg cc0
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i c2 2re renegcli 0re lttri mp2an cC cr
        wcel cC cc0 clt wbr cc0 cC cneg clt wbr wb cC cr wcel c4 cneg cC clt
        wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4
        cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2 cneg cioo co wcel
        cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq vx c4 cneg c2
        cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg
        c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr
        wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC
        c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4 cneg cxr wcel
        c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC
        clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2 cneg cr wcel c4
        cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an mp2an mpbi
        3simp1i cC lt0neg1 ax-mp mpbi cC cneg csin cfv cC csin cfv cneg cc0
        cneg cc0 cC cc wcel cC cneg csin cfv cC csin cfv cneg wceq cC cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4 cneg cr
        wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg
        cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re renegcli c4
        cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co wcel cC cr
        wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr wcel c2
        cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg rexr syl2an
        mp2an mpbi 3simp1i recni cC sinneg ax-mp cC csin cfv cc0 cC c4 cneg c2
        cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv cc0 wceq
        vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin cfv cc0
        wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.27i negeqi neg0
        3eqtri cC cneg cr wcel cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa
        cC cneg cP wcel cC cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC
        c4 cneg c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg
        clt wbr w3a cC c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC
        cS vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1
        pilem1.2 vx cv csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid
        pilem1 pm3.26i c4 cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo
        co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re
        renegcli c2 2re renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg
        c2 cneg cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr
        w3a wb c4 cneg cr wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4
        cneg rexr c2 cneg rexr syl2an mp2an mpbi 3simp1i renegcli cC cneg cP
        wcel cC cneg cr wcel cc0 cC cneg clt wbr cC cneg csin cfv cc0 wceq wa
        wa cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0 cC cneg clt wbr cC
        cneg csin cfv cc0 wceq wa vx cC cneg cr cP vx cv cC cneg wceq cc0 vx cv
        clt wbr cc0 cC cneg clt wbr vx cv csin cfv cc0 wceq cC cneg csin cfv
        cc0 wceq vx cv cC cneg cc0 clt breq2 vx cv cC cneg wceq vx cv csin cfv
        cC cneg csin cfv cc0 vx cv cC cneg csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 biimpri mpan mp2an cP cC cneg ne0i ax-mp cc0 cr wcel cc0 vw cv
        cle wbr vw cP wral vz cv vw cv cle wbr vw cP wral vz cr wrex 0re cc0 vw
        cv cle wbr vw cP vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv cle wbr vw
        cv cP wcel cc0 cr wcel vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv cle
        wbr wi 0re cc0 vw cv ltle mpan vw cv cP wcel vw cv cr wcel cc0 vw cv
        clt wbr vw cv csin cfv cc0 wceq wa cc0 vx cv clt wbr vx cv csin cfv cc0
        wceq wa cc0 vw cv clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cP vx
        cv vw cv wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv csin cfv cc0
        wceq vw cv csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx cv vw cv wceq
        vx cv csin cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d
        pilem3.4 elrab2 pm3.26bi vw cv cP wcel vw cv cr wcel cc0 vw cv clt wbr
        vw cv csin cfv cc0 wceq vw cv cP wcel vw cv cr wcel cc0 vw cv clt wbr
        vw cv csin cfv cc0 wceq w3a vw cv cP wcel vw cv cr wcel cc0 vw cv clt
        wbr vw cv csin cfv cc0 wceq wa wa vw cv cr wcel cc0 vw cv clt wbr vw cv
        csin cfv cc0 wceq w3a cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa cc0
        vw cv clt wbr vw cv csin cfv cc0 wceq wa vx vw cv cr cP vx cv vw cv
        wceq cc0 vx cv clt wbr cc0 vw cv clt wbr vx cv csin cfv cc0 wceq vw cv
        csin cfv cc0 wceq vx cv vw cv cc0 clt breq2 vx cv vw cv wceq vx cv csin
        cfv vw cv csin cfv cc0 vx cv vw cv csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 vw cv cr wcel cc0 vw cv clt wbr vw cv csin cfv cc0 wceq 3anass
        bitr4i biimpi 3simp2d sylc rgen vz cv vw cv cle wbr vw cP wral cc0 vw
        cv cle wbr vw cP wral vz cc0 cr vz cv cc0 wceq vz cv vw cv cle wbr cc0
        vw cv cle wbr vw cP vz cv cc0 vw cv cle breq1 ralbidv rcla4ev mp2an cP
        cr wss cP c0 wne vz cv vw cv cle wbr vw cP wral vz cr wrex w3a cP cr
        clt ccnv csup vv cv cneg cP wcel vv cr crab cr clt csup cneg cpi vz vw
        vv cP infmsup cpi cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr
        crab cr clt ccnv csup cP cr clt ccnv csup vx df-pi cP cc0 vx cv clt wbr
        vx cv csin cfv cc0 wceq wa vx cr crab wceq cP cr clt ccnv csup cc0 vx
        cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab cr clt ccnv csup wceq
        pilem3.4 cr cP cc0 vx cv clt wbr vx cv csin cfv cc0 wceq wa vx cr crab
        clt ccnv supeq1 ax-mp eqtr4i syl5eq mp3an cC vv cv cneg cP wcel vv cr
        crab cr clt csup cC cT cr clt csup vv cv cneg cP wcel vv cr crab cr clt
        csup vx cC cS cT pilem1.1 pilem1.2 pilem3.3 pilem2 cT vv cv cneg cP
        wcel vv cr crab wceq cT cr clt csup vv cv cneg cP wcel vv cr crab cr
        clt csup wceq cT vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa vx cr
        crab vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cr crab vv cv cneg
        cP wcel vv cr crab pilem3.3 vx cv cc0 clt wbr vx cv csin cfv cc0 wceq
        wa vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vx vv cr vx cv vv cv
        wceq vx cv cc0 clt wbr vv cv cc0 clt wbr vx cv csin cfv cc0 wceq vv cv
        csin cfv cc0 wceq vx cv vv cv cc0 clt breq1 vx cv vv cv wceq vx cv csin
        cfv vv cv csin cfv cc0 vx cv vv cv csin fveq2 eqeq1d anbi12d cbvrabv vv
        cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cv cneg cP wcel vv cr vv
        cv cr wcel vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa vv cv cneg cr
        wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa wa vv cv
        cneg cP wcel vv cv cr wcel vv cv cc0 clt wbr vv cv csin cfv cc0 wceq wa
        cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa vv cv cneg cr
        wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa wa vv cv cr
        wcel vv cv cc0 clt wbr cc0 vv cv cneg clt wbr vv cv csin cfv cc0 wceq
        vv cv cneg csin cfv cc0 wceq vv cv lt0neg1 vv cv cr wcel vv cv csin cfv
        cc0 wceq vv cv csin cfv cneg cc0 wceq vv cv cneg csin cfv cc0 wceq vv
        cv cr wcel vv cv csin cfv cc wcel vv cv csin cfv cc0 wceq vv cv csin
        cfv cneg cc0 wceq wb vv cv cr wcel vv cv csin cfv vv cv resincl recnd
        vv cv csin cfv negeq0 syl vv cv cr wcel vv cv cneg csin cfv vv cv csin
        cfv cneg cc0 vv cv cr wcel vv cv cc wcel vv cv cneg csin cfv vv cv csin
        cfv cneg wceq vv cv recn vv cv sinneg syl eqeq1d bitr4d anbi12d vv cv
        cr wcel vv cv cneg cr wcel cc0 vv cv cneg clt wbr vv cv cneg csin cfv
        cc0 wceq wa vv cv renegcl biantrurd bitrd cc0 vx cv clt wbr vx cv csin
        cfv cc0 wceq wa cc0 vv cv cneg clt wbr vv cv cneg csin cfv cc0 wceq wa
        vx vv cv cneg cr cP vx cv vv cv cneg wceq cc0 vx cv clt wbr cc0 vv cv
        cneg clt wbr vx cv csin cfv cc0 wceq vv cv cneg csin cfv cc0 wceq vx cv
        vv cv cneg cc0 clt breq2 vx cv vv cv cneg wceq vx cv csin cfv vv cv
        cneg csin cfv cc0 vx cv vv cv cneg csin fveq2 eqeq1d anbi12d pilem3.4
        elrab2 syl6bbr rabbii 3eqtri cr cT vv cv cneg cP wcel vv cr crab clt
        supeq1 ax-mp eqtri negeqi eqtr4i fveq2i cC cneg csin cfv cC csin cfv
        cneg cc0 cneg cc0 cC cc wcel cC cneg csin cfv cC csin cfv cneg wceq cC
        cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr cC c4 cneg c2 cneg
        cioo co wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a cC c4
        cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin cfv
        cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.26i c4
        cneg cr wcel c2 cneg cr wcel cC c4 cneg c2 cneg cioo co wcel cC cr wcel
        c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 4re renegcli c2 2re
        renegcli c4 cneg cxr wcel c2 cneg cxr wcel cC c4 cneg c2 cneg cioo co
        wcel cC cr wcel c4 cneg cC clt wbr cC c2 cneg clt wbr w3a wb c4 cneg cr
        wcel c2 cneg cr wcel c4 cneg c2 cneg cC elioo2 c4 cneg rexr c2 cneg
        rexr syl2an mp2an mpbi 3simp1i recni cC sinneg ax-mp cC csin cfv cc0 cC
        c4 cneg c2 cneg cioo co wcel cC csin cfv cc0 wceq vx cC cS vx cv csin
        cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab pilem1.1 pilem1.2 vx cv
        csin cfv cc0 wceq vx c4 cneg c2 cneg cicc co crab eqid pilem1 pm3.27i
        negeqi neg0 3eqtri eqtri 3pm3.2i $.
        $( [23-Jan-2008] $) $( [23-Jan-2008] $)
    $}
  $}

  ${
    $d x y $.
    $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi . $)
    pilem4 $p |- ( pi e. RR+ /\ pi e. ( 2 (,) 4 ) /\ ( sin ` pi ) = 0 ) $=
      vx vy cv csin cfv cc0 wceq vy c4 cneg cc0 cico co crab cr clt csup cc0 vy
      cv clt wbr vy cv csin cfv cc0 wceq wa vy cr crab vx cv csin cfv cc0 wceq
      vx c4 cneg cc0 cico co crab vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa
      vx cr crab vx cv csin cfv cc0 wceq vx c4 cneg cc0 cico co crab eqid vy cv
      csin cfv cc0 wceq vy c4 cneg cc0 cico co crab vx cv csin cfv cc0 wceq vx
      c4 cneg cc0 cico co crab wceq vy cv csin cfv cc0 wceq vy c4 cneg cc0 cico
      co crab cr clt csup vx cv csin cfv cc0 wceq vx c4 cneg cc0 cico co crab
      cr clt csup wceq vy cv csin cfv cc0 wceq vx cv csin cfv cc0 wceq vy vx c4
      cneg cc0 cico co vy cv vx cv wceq vy cv csin cfv vx cv csin cfv cc0 vy cv
      vx cv csin fveq2 eqeq1d cbvrabv cr vy cv csin cfv cc0 wceq vy c4 cneg cc0
      cico co crab vx cv csin cfv cc0 wceq vx c4 cneg cc0 cico co crab clt
      supeq1 ax-mp vx cv cc0 clt wbr vx cv csin cfv cc0 wceq wa vx cr crab eqid
      cc0 vy cv clt wbr vy cv csin cfv cc0 wceq wa cc0 vx cv clt wbr vx cv csin
      cfv cc0 wceq wa vy vx cr vy cv vx cv wceq cc0 vy cv clt wbr cc0 vx cv clt
      wbr vy cv csin cfv cc0 wceq vx cv csin cfv cc0 wceq vy cv vx cv cc0 clt
      breq2 vy cv vx cv wceq vy cv csin cfv vx cv csin cfv cc0 vy cv vx cv csin
      fveq2 eqeq1d anbi12d cbvrabv pilem3 $.
      $( [23-Jan-2008] $) $( [23-Jan-2008] $)
  $}

  $( ` pi ` is between 2 and 4.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  pigt2lt4 $p |- ( 2 < pi /\ pi < 4 ) $=
    cpi cr wcel c2 cpi clt wbr cpi c4 clt wbr w3a c2 cpi clt wbr cpi c4 clt wbr
    wa cpi c2 c4 cioo co wcel cpi cr wcel c2 cpi clt wbr cpi c4 clt wbr w3a cpi
    crp wcel cpi c2 c4 cioo co wcel cpi csin cfv cc0 wceq pilem4 3simp2i c2 cr
    wcel c4 cr wcel cpi c2 c4 cioo co wcel cpi cr wcel c2 cpi clt wbr cpi c4
    clt wbr w3a wb 2re 4re c2 cxr wcel c4 cxr wcel cpi c2 c4 cioo co wcel cpi
    cr wcel c2 cpi clt wbr cpi c4 clt wbr w3a wb c2 cr wcel c4 cr wcel c2 c4
    cpi elioo2 c2 rexr c4 rexr syl2an mp2an mpbi cpi cr wcel c2 cpi clt wbr cpi
    c4 clt wbr 3simpc ax-mp $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The sine of ` pi ` is 0.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  sinpi $p |- ( sin ` pi ) = 0 $=
    cpi crp wcel cpi c2 c4 cioo co wcel cpi csin cfv cc0 wceq pilem4 3simp3i $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( ` pi ` is a real number.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  pire $p |- pi e. RR $=
    cpi crp wcel cpi cr wcel cpi crp wcel cpi c2 c4 cioo co wcel cpi csin cfv
    cc0 wceq pilem4 3simp1i cpi rpre ax-mp $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( ` pi ` is positive.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  pipos $p |- 0 < pi $=
    cpi crp wcel cc0 cpi clt wbr cpi crp wcel cpi c2 c4 cioo co wcel cpi csin
    cfv cc0 wceq pilem4 3simp1i cpi rpgt0 ax-mp $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( Lemma for ~ sinhalfpi and ~ coshalfpi . $)
  sinhalfpilem $p |- ( ( sin ` ( pi / 2 ) ) = 1 /\
                      ( cos ` ( pi / 2 ) ) = 0 ) $=
    cpi c2 cdiv co csin cfv c1 wceq cpi c2 cdiv co ccos cfv cc0 wceq cpi c2
    cdiv co csin cfv c1 wceq cpi c2 cdiv co csin cfv c1 cneg wceq cpi c2 cdiv
    co csin cfv c1 cneg wceq cc0 c1 cneg clt wbr c1 cc0 clt wbr cc0 c1 cneg clt
    wbr cc0 c1 clt wbr c1 cc0 clt wbr wn lt01 cc0 c1 0re 1re ltnsymi ax-mp c1
    cr wcel c1 cc0 clt wbr cc0 c1 cneg clt wbr wb 1re c1 lt0neg1 ax-mp mtbi cpi
    c2 cdiv co csin cfv c1 cneg wceq cc0 cpi c2 cdiv co csin cfv clt wbr cc0 c1
    cneg clt wbr cpi c2 cdiv co cc0 c2 cioc co wcel cc0 cpi c2 cdiv co csin cfv
    clt wbr cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co clt wbr cpi c2 cdiv co c2
    cle wbr cpi c2 cdiv co cc0 c2 cioc co wcel cpi c2 pire 2re 2ne0 redivcli
    cpi c2 pire 2re pipos 2pos divgt0ii cpi c4 cle wbr cpi c2 cdiv co c2 cle
    wbr cpi c4 pire 4re c2 cpi clt wbr cpi c4 clt wbr pigt2lt4 pm3.27i ltleii
    cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle wbr cpi c4 cle wbr cpi cr
    wcel c2 cr wcel c2 cr wcel cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle
    wbr wb pire 2re 2re cpi cr wcel c2 cr wcel c2 cr wcel w3a cc0 c2 clt wbr
    cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle wbr wb 2pos cpi c2 c2
    ledivmulOLD mpan2 mp3an c2 c2 cmul co c4 cpi cle 2t2e4 breq2i bitr2i mpbi
    cpi c2 cdiv co cc0 c2 cioc co wcel cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv
    co clt wbr cpi c2 cdiv co c2 cle wbr w3a cc0 cr wcel c2 cr wcel cpi c2 cdiv
    co cc0 c2 cioc co wcel cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co clt wbr
    cpi c2 cdiv co c2 cle wbr w3a wb 0re 2re cc0 c2 cpi c2 cdiv co elioc2 mp2an
    biimpri mp3an cpi c2 cdiv co sin02gt0 ax-mp cpi c2 cdiv co csin cfv c1 cneg
    cc0 clt breq2 mpbii mto cpi c2 cdiv co csin cfv c1 wceq cpi c2 cdiv co csin
    cfv c1 cneg wceq cpi c2 cdiv co csin cfv c2 cexp co c1 c2 cexp co wceq cpi
    c2 cdiv co csin cfv c1 wceq cpi c2 cdiv co csin cfv c1 cneg wceq wo cpi c2
    cdiv co csin cfv c2 cexp co c1 c1 c2 cexp co cpi c2 cdiv co csin cfv c2
    cexp co cpi c2 cdiv co ccos cfv c2 cexp co caddc co cpi c2 cdiv co csin cfv
    c2 cexp co cc0 caddc co c1 cpi c2 cdiv co csin cfv c2 cexp co cpi c2 cdiv
    co ccos cfv c2 cexp co cc0 cpi c2 cdiv co csin cfv c2 cexp co caddc cpi c2
    cdiv co ccos cfv c2 cexp co cc0 c2 cexp co cc0 cpi c2 cdiv co ccos cfv cc0
    c2 cexp cpi c2 cdiv co csin cfv cc0 wceq wn cpi c2 cdiv co ccos cfv cc0
    wceq cpi c2 cdiv co csin cfv cc0 wne cpi c2 cdiv co csin cfv cc0 wceq wn
    cpi c2 cdiv co csin cfv cpi c2 cdiv co cr wcel cpi c2 cdiv co csin cfv cr
    wcel cpi c2 pire 2re 2ne0 redivcli cpi c2 cdiv co resincl ax-mp cpi c2 cdiv
    co cc0 c2 cioc co wcel cc0 cpi c2 cdiv co csin cfv clt wbr cpi c2 cdiv co
    cr wcel cc0 cpi c2 cdiv co clt wbr cpi c2 cdiv co c2 cle wbr cpi c2 cdiv co
    cc0 c2 cioc co wcel cpi c2 pire 2re 2ne0 redivcli cpi c2 pire 2re pipos
    2pos divgt0ii cpi c4 cle wbr cpi c2 cdiv co c2 cle wbr cpi c4 pire 4re c2
    cpi clt wbr cpi c4 clt wbr pigt2lt4 pm3.27i ltleii cpi c2 cdiv co c2 cle
    wbr cpi c2 c2 cmul co cle wbr cpi c4 cle wbr cpi cr wcel c2 cr wcel c2 cr
    wcel cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle wbr wb pire 2re 2re
    cpi cr wcel c2 cr wcel c2 cr wcel w3a cc0 c2 clt wbr cpi c2 cdiv co c2 cle
    wbr cpi c2 c2 cmul co cle wbr wb 2pos cpi c2 c2 ledivmulOLD mpan2 mp3an c2
    c2 cmul co c4 cpi cle 2t2e4 breq2i bitr2i mpbi cpi c2 cdiv co cc0 c2 cioc
    co wcel cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co clt wbr cpi c2 cdiv co c2
    cle wbr w3a cc0 cr wcel c2 cr wcel cpi c2 cdiv co cc0 c2 cioc co wcel cpi
    c2 cdiv co cr wcel cc0 cpi c2 cdiv co clt wbr cpi c2 cdiv co c2 cle wbr w3a
    wb 0re 2re cc0 c2 cpi c2 cdiv co elioc2 mp2an biimpri mp3an cpi c2 cdiv co
    sin02gt0 ax-mp gt0ne0ii cpi c2 cdiv co csin cfv cc0 df-ne mpbi cpi c2 cdiv
    co csin cfv cc0 wceq cpi c2 cdiv co ccos cfv cc0 wceq cpi c2 cdiv co csin
    cfv cpi c2 cdiv co ccos cfv cmul co cc0 wceq cpi c2 cdiv co csin cfv cc0
    wceq cpi c2 cdiv co ccos cfv cc0 wceq wo c2 cc0 wceq wn cpi c2 cdiv co csin
    cfv cpi c2 cdiv co ccos cfv cmul co cc0 wceq c2 cc0 wne c2 cc0 wceq wn 2ne0
    c2 cc0 df-ne mpbi c2 cc0 wceq cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos
    cfv cmul co cc0 wceq c2 cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv
    cmul co cmul co cc0 wceq c2 cc0 wceq cpi c2 cdiv co csin cfv cpi c2 cdiv co
    ccos cfv cmul co cc0 wceq wo c2 cpi c2 cdiv co cmul co csin cfv cpi csin
    cfv c2 cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul co cmul co cc0
    c2 cpi c2 cdiv co cmul co cpi csin cpi c2 cpi pire recni 2cn 2ne0 divcan2i
    fveq2i cpi c2 cdiv co cc wcel c2 cpi c2 cdiv co cmul co csin cfv c2 cpi c2
    cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul co cmul co wceq cpi c2 cdiv
    co cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co sin2t ax-mp sinpi
    3eqtr3i c2 cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul co 2cn cpi
    c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cpi c2 cdiv co cc wcel cpi c2
    cdiv co csin cfv cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni
    cpi c2 cdiv co sincl ax-mp cpi c2 cdiv co cc wcel cpi c2 cdiv co ccos cfv
    cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co
    coscl ax-mp mulcli mul0ori mpbi ori ax-mp cpi c2 cdiv co csin cfv cpi c2
    cdiv co ccos cfv cpi c2 cdiv co cc wcel cpi c2 cdiv co csin cfv cc wcel cpi
    c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co sincl ax-mp
    cpi c2 cdiv co cc wcel cpi c2 cdiv co ccos cfv cc wcel cpi c2 cdiv co cpi
    c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co coscl ax-mp mul0ori mpbi ori
    ax-mp opreq1i sq0 eqtri opreq2i cpi c2 cdiv co cc wcel cpi c2 cdiv co csin
    cfv c2 cexp co cpi c2 cdiv co ccos cfv c2 cexp co caddc co c1 wceq cpi c2
    cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co sincossq ax-mp
    cpi c2 cdiv co csin cfv c2 cexp co cpi c2 cdiv co csin cfv cpi c2 cdiv co
    cc wcel cpi c2 cdiv co csin cfv cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0
    redivcli recni cpi c2 cdiv co sincl ax-mp sqcli addid1i 3eqtr3ri sq1 eqtr4i
    cpi c2 cdiv co csin cfv c1 cpi c2 cdiv co cc wcel cpi c2 cdiv co csin cfv
    cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co
    sincl ax-mp ax1cn sqeqori mpbi ori mt3 cpi c2 cdiv co csin cfv cc0 wceq wn
    cpi c2 cdiv co ccos cfv cc0 wceq cpi c2 cdiv co csin cfv cc0 wne cpi c2
    cdiv co csin cfv cc0 wceq wn cpi c2 cdiv co csin cfv cpi c2 cdiv co cr wcel
    cpi c2 cdiv co csin cfv cr wcel cpi c2 pire 2re 2ne0 redivcli cpi c2 cdiv
    co resincl ax-mp cpi c2 cdiv co cc0 c2 cioc co wcel cc0 cpi c2 cdiv co csin
    cfv clt wbr cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co clt wbr cpi c2 cdiv
    co c2 cle wbr cpi c2 cdiv co cc0 c2 cioc co wcel cpi c2 pire 2re 2ne0
    redivcli cpi c2 pire 2re pipos 2pos divgt0ii cpi c4 cle wbr cpi c2 cdiv co
    c2 cle wbr cpi c4 pire 4re c2 cpi clt wbr cpi c4 clt wbr pigt2lt4 pm3.27i
    ltleii cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle wbr cpi c4 cle wbr
    cpi cr wcel c2 cr wcel c2 cr wcel cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul
    co cle wbr wb pire 2re 2re cpi cr wcel c2 cr wcel c2 cr wcel w3a cc0 c2 clt
    wbr cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle wbr wb 2pos cpi c2 c2
    ledivmulOLD mpan2 mp3an c2 c2 cmul co c4 cpi cle 2t2e4 breq2i bitr2i mpbi
    cpi c2 cdiv co cc0 c2 cioc co wcel cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv
    co clt wbr cpi c2 cdiv co c2 cle wbr w3a cc0 cr wcel c2 cr wcel cpi c2 cdiv
    co cc0 c2 cioc co wcel cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co clt wbr
    cpi c2 cdiv co c2 cle wbr w3a wb 0re 2re cc0 c2 cpi c2 cdiv co elioc2 mp2an
    biimpri mp3an cpi c2 cdiv co sin02gt0 ax-mp gt0ne0ii cpi c2 cdiv co csin
    cfv cc0 df-ne mpbi cpi c2 cdiv co csin cfv cc0 wceq cpi c2 cdiv co ccos cfv
    cc0 wceq cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul co cc0 wceq
    cpi c2 cdiv co csin cfv cc0 wceq cpi c2 cdiv co ccos cfv cc0 wceq wo c2 cc0
    wceq wn cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul co cc0 wceq c2
    cc0 wne c2 cc0 wceq wn 2ne0 c2 cc0 df-ne mpbi c2 cc0 wceq cpi c2 cdiv co
    csin cfv cpi c2 cdiv co ccos cfv cmul co cc0 wceq c2 cpi c2 cdiv co csin
    cfv cpi c2 cdiv co ccos cfv cmul co cmul co cc0 wceq c2 cc0 wceq cpi c2
    cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul co cc0 wceq wo c2 cpi c2 cdiv
    co cmul co csin cfv cpi csin cfv c2 cpi c2 cdiv co csin cfv cpi c2 cdiv co
    ccos cfv cmul co cmul co cc0 c2 cpi c2 cdiv co cmul co cpi csin cpi c2 cpi
    pire recni 2cn 2ne0 divcan2i fveq2i cpi c2 cdiv co cc wcel c2 cpi c2 cdiv
    co cmul co csin cfv c2 cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cmul
    co cmul co wceq cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2
    cdiv co sin2t ax-mp sinpi 3eqtr3i c2 cpi c2 cdiv co csin cfv cpi c2 cdiv co
    ccos cfv cmul co 2cn cpi c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cpi c2
    cdiv co cc wcel cpi c2 cdiv co csin cfv cc wcel cpi c2 cdiv co cpi c2 pire
    2re 2ne0 redivcli recni cpi c2 cdiv co sincl ax-mp cpi c2 cdiv co cc wcel
    cpi c2 cdiv co ccos cfv cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0
    redivcli recni cpi c2 cdiv co coscl ax-mp mulcli mul0ori mpbi ori ax-mp cpi
    c2 cdiv co csin cfv cpi c2 cdiv co ccos cfv cpi c2 cdiv co cc wcel cpi c2
    cdiv co csin cfv cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni
    cpi c2 cdiv co sincl ax-mp cpi c2 cdiv co cc wcel cpi c2 cdiv co ccos cfv
    cc wcel cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co
    coscl ax-mp mul0ori mpbi ori ax-mp pm3.2i $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The sine of ` pi / 2 ` is 1.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  sinhalfpi $p |- ( sin ` ( pi / 2 ) ) = 1 $=
    cpi c2 cdiv co csin cfv c1 wceq cpi c2 cdiv co ccos cfv cc0 wceq
    sinhalfpilem pm3.26i $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The cosine of ` pi / 2 ` is 0.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  coshalfpi $p |- ( cos ` ( pi / 2 ) ) = 0 $=
    cpi c2 cdiv co csin cfv c1 wceq cpi c2 cdiv co ccos cfv cc0 wceq
    sinhalfpilem pm3.27i $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The cosine of ` pi ` is ` -u 1 ` .  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  cospi $p |- ( cos ` pi ) = -u 1 $=
    c2 cpi c2 cdiv co cmul co ccos cfv c2 cpi c2 cdiv co ccos cfv c2 cexp co
    cmul co c1 cmin co cpi ccos cfv c1 cneg cpi c2 cdiv co cpi c2 cpi pire
    recni 2cn 2ne0 divcli cos2OLD c2 cpi c2 cdiv co cmul co cpi ccos cpi c2 cpi
    pire recni 2cn 2ne0 divcan2i fveq2i c2 cpi c2 cdiv co ccos cfv c2 cexp co
    cmul co c1 cmin co cc0 c1 cmin co c1 cneg c2 cpi c2 cdiv co ccos cfv c2
    cexp co cmul co cc0 c1 cmin c2 cpi c2 cdiv co ccos cfv c2 cexp co cmul co
    c2 cc0 cmul co cc0 cpi c2 cdiv co ccos cfv c2 cexp co cc0 c2 cmul cpi c2
    cdiv co ccos cfv c2 cexp co cc0 c2 cexp co cc0 cpi c2 cdiv co ccos cfv cc0
    c2 cexp coshalfpi opreq1i sq0 eqtri opreq2i c2 2cn mul01i eqtri opreq1i c1
    df-neg eqtr4i 3eqtr3i $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( Euler's identity.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  eulerid $p |- ( ( exp ` ( _i x. pi ) ) + 1 ) = 0 $=
    ci cpi cmul co ce cfv c1 caddc co c1 cneg c1 caddc co c1 c1 cmin co cneg
    cc0 ci cpi cmul co ce cfv c1 cneg c1 caddc ci cpi cmul co ce cfv cpi ccos
    cfv ci cpi csin cfv cmul co caddc co c1 cneg cc0 caddc co c1 cneg cpi cc
    wcel ci cpi cmul co ce cfv cpi ccos cfv ci cpi csin cfv cmul co caddc co
    wceq cpi pire recni cpi efival ax-mp cpi ccos cfv c1 cneg ci cpi csin cfv
    cmul co cc0 caddc cospi ci cpi csin cfv cmul co ci cc0 cmul co cc0 cpi csin
    cfv cc0 ci cmul sinpi opreq2i ci axicn mul01i eqtri opreq12i c1 cneg c1
    ax1cn negcli addid1i 3eqtri opreq1i c1 c1 ax1cn ax1cn negsubdii c1 c1 cmin
    co cneg cc0 cneg cc0 c1 c1 cmin co cc0 c1 ax1cn subidi negeqi neg0 eqtri
    3eqtr2i $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The sine of ` 2 pi ` is 0.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  sin2pi $p |- ( sin ` ( 2 x. pi ) ) = 0 $=
    c2 cpi cmul co csin cfv c2 cpi csin cfv cpi ccos cfv cmul co cmul co c2 cc0
    cmul co cc0 cpi cc wcel c2 cpi cmul co csin cfv c2 cpi csin cfv cpi ccos
    cfv cmul co cmul co wceq cpi pire recni cpi sin2t ax-mp cpi csin cfv cpi
    ccos cfv cmul co cc0 c2 cmul cpi csin cfv cpi ccos cfv cmul co cc0 c1 cneg
    cmul co cc0 cpi csin cfv cc0 cpi ccos cfv c1 cneg cmul sinpi cospi opreq12i
    c1 cneg c1 ax1cn negcli mul02i eqtri opreq2i c2 2cn mul01i 3eqtri $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The cosine of ` 2 pi ` is 1.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  cos2pi $p |- ( cos ` ( 2 x. pi ) ) = 1 $=
    c2 cpi cmul co ccos cfv c2 cpi ccos cfv c2 cexp co cmul co c1 cmin co c2 c1
    cmin co c1 cpi cpi pire recni cos2OLD c2 cpi ccos cfv c2 cexp co cmul co c2
    c1 cmin c2 cpi ccos cfv c2 cexp co cmul co c2 c1 cmul co c2 cpi ccos cfv c2
    cexp co c1 c2 cmul cpi ccos cfv c2 cexp co c1 cneg c2 cexp co c1 c2 cexp co
    c1 cpi ccos cfv c1 cneg c2 cexp cospi opreq1i c1 cc wcel c1 cneg c2 cexp co
    c1 c2 cexp co wceq ax1cn c1 sqneg ax-mp sq1 3eqtri opreq2i c2 2cn mulid1i
    eqtri opreq1i c2 c1 c1 2cn ax1cn ax1cn c2 c1 c1 caddc co df-2 eqcomi
    subaddrii 3eqtri $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( Lemma for ~ sin2kpi and ~ cos2kpi . $)
  sinperlem1 $p  |- ( K e. NN0 ->
                      ( ( cos ` ( K x. ( 2 x. pi ) ) ) = 1 /\
                        ( sin ` ( K x. ( 2 x. pi ) ) ) = 0 ) ) $=
    cK cn0 wcel cK c2 cpi cmul co cmul co ccos cfv ci cK c2 cpi cmul co cmul co
    csin cfv cmul co caddc co c1 ci cc0 cmul co caddc co wceq cK c2 cpi cmul co
    cmul co ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa cK
    cn0 wcel cK c2 cpi cmul co cmul co ccos cfv ci cK c2 cpi cmul co cmul co
    csin cfv cmul co caddc co c1 c1 ci cc0 cmul co caddc co cK cn0 wcel c2 cpi
    cmul co ccos cfv ci c2 cpi cmul co csin cfv cmul co caddc co cK cexp co cK
    c2 cpi cmul co cmul co ccos cfv ci cK c2 cpi cmul co cmul co csin cfv cmul
    co caddc co c1 c2 cpi cmul co cc wcel cK cn0 wcel c2 cpi cmul co ccos cfv
    ci c2 cpi cmul co csin cfv cmul co caddc co cK cexp co cK c2 cpi cmul co
    cmul co ccos cfv ci cK c2 cpi cmul co cmul co csin cfv cmul co caddc co
    wceq c2 cpi cmul co c2 cpi 2re pire remulcli recni c2 cpi cmul co cK
    demoivre mpan cK cn0 wcel c1 cK cexp co c1 c2 cpi cmul co ccos cfv ci c2
    cpi cmul co csin cfv cmul co caddc co cK cexp co cK 1exp c2 cpi cmul co
    ccos cfv ci c2 cpi cmul co csin cfv cmul co caddc co c1 cK cexp c2 cpi cmul
    co ccos cfv ci c2 cpi cmul co csin cfv cmul co caddc co c1 cc0 caddc co c1
    c2 cpi cmul co ccos cfv c1 ci c2 cpi cmul co csin cfv cmul co cc0 caddc
    cos2pi ci c2 cpi cmul co csin cfv cmul co ci cc0 cmul co cc0 c2 cpi cmul co
    csin cfv cc0 ci cmul sin2pi opreq2i ci axicn mul01i eqtri opreq12i c1 ax1cn
    addid1i eqtri opreq1i syl5eq eqtr3d c1 ci cc0 cmul co caddc co c1 wceq cK
    cn0 wcel c1 ci cc0 cmul co caddc co c1 cc0 caddc co c1 ci cc0 cmul co cc0
    c1 caddc ci axicn mul01i opreq2i c1 ax1cn addid1i eqtri a1i eqtr4d cK c2
    cpi cmul co cmul co ccos cfv cr wcel cK c2 cpi cmul co cmul co csin cfv cr
    wcel cK c2 cpi cmul co cmul co ccos cfv ci cK c2 cpi cmul co cmul co csin
    cfv cmul co caddc co c1 ci cc0 cmul co caddc co wceq cK c2 cpi cmul co cmul
    co ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa wb cK
    cn0 wcel cK c2 cpi cmul co cmul co ccos cfv cr wcel cK c2 cpi cmul co cmul
    co csin cfv cr wcel wa c1 cr wcel cc0 cr wcel cK c2 cpi cmul co cmul co
    ccos cfv ci cK c2 cpi cmul co cmul co csin cfv cmul co caddc co c1 ci cc0
    cmul co caddc co wceq cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi
    cmul co cmul co csin cfv cc0 wceq wa wb 1re 0re cK c2 cpi cmul co cmul co
    ccos cfv cK c2 cpi cmul co cmul co csin cfv c1 cc0 cru mpanr12 cK cn0 wcel
    cK c2 cpi cmul co cmul co cr wcel cK c2 cpi cmul co cmul co ccos cfv cr
    wcel cK cn0 wcel cK cr wcel cK c2 cpi cmul co cmul co cr wcel cK nn0re cK
    cr wcel c2 cpi cmul co cr wcel cK c2 cpi cmul co cmul co cr wcel c2 cpi 2re
    pire remulcli cK c2 cpi cmul co remulcl mpan2 syl cK c2 cpi cmul co cmul co
    recoscl syl cK cn0 wcel cK c2 cpi cmul co cmul co cr wcel cK c2 cpi cmul co
    cmul co csin cfv cr wcel cK cn0 wcel cK cr wcel cK c2 cpi cmul co cmul co
    cr wcel cK nn0re cK cr wcel c2 cpi cmul co cr wcel cK c2 cpi cmul co cmul
    co cr wcel c2 cpi 2re pire remulcli cK c2 cpi cmul co remulcl mpan2 syl cK
    c2 cpi cmul co cmul co resincl syl sylanc mpbid $.
    $( [15-Mar-2008] $) $( [23-Jan-2008] $)

  $( Lemma for ~ sin2kpi and ~ cos2kpi . $)
  sinperlem2 $p |- ( K e. ZZ ->
                     ( ( cos ` ( K x. ( 2 x. pi ) ) ) = 1 /\
                       ( sin ` ( K x. ( 2 x. pi ) ) ) = 0 ) ) $=
    cK cz wcel cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi cmul co
    cmul co csin cfv cc0 wceq wa cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK
    c2 cpi cmul co cmul co csin cfv cc0 wceq wa wo cK c2 cpi cmul co cmul co
    ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa cK cz wcel
    cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin
    cfv cc0 wceq wa cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi cmul
    co cmul co csin cfv cc0 wceq wa wo cK c2 cpi cmul co cmul co ccos cfv c1
    wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa cK cneg c2 cpi cmul co
    cmul co ccos cfv c1 wceq cK cneg c2 cpi cmul co cmul co csin cfv cc0 wceq
    wa wo cK cz wcel cK cn0 wcel cK cneg cn0 wcel wo cK c2 cpi cmul co cmul co
    ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa cK cneg c2
    cpi cmul co cmul co ccos cfv c1 wceq cK cneg c2 cpi cmul co cmul co csin
    cfv cc0 wceq wa wo cK cz wcel cK cr wcel cK cn0 wcel cK cneg cn0 wcel wo cK
    elznn0 pm3.27bi cK cn0 wcel cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK
    c2 cpi cmul co cmul co csin cfv cc0 wceq wa cK cneg cn0 wcel cK cneg c2 cpi
    cmul co cmul co ccos cfv c1 wceq cK cneg c2 cpi cmul co cmul co csin cfv
    cc0 wceq wa cK sinperlem1 cK cneg sinperlem1 orim12i syl cK cz wcel cK c2
    cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin cfv cc0
    wceq wa cK cneg c2 cpi cmul co cmul co ccos cfv c1 wceq cK cneg c2 cpi cmul
    co cmul co csin cfv cc0 wceq wa cK c2 cpi cmul co cmul co ccos cfv c1 wceq
    cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa cK cz wcel cK c2 cpi cmul co
    cmul co ccos cfv c1 wceq cK cneg c2 cpi cmul co cmul co ccos cfv c1 wceq cK
    c2 cpi cmul co cmul co csin cfv cc0 wceq cK cneg c2 cpi cmul co cmul co
    csin cfv cc0 wceq cK cz wcel cK cneg c2 cpi cmul co cmul co ccos cfv c1
    wceq cK c2 cpi cmul co cmul co cneg ccos cfv c1 wceq cK c2 cpi cmul co cmul
    co ccos cfv c1 wceq cK cz wcel cK cneg c2 cpi cmul co cmul co ccos cfv cK
    c2 cpi cmul co cmul co cneg ccos cfv c1 cK cz wcel cK cneg c2 cpi cmul co
    cmul co cK c2 cpi cmul co cmul co cneg ccos cK cc wcel c2 cpi cmul co cc
    wcel cK cneg c2 cpi cmul co cmul co cK c2 cpi cmul co cmul co cneg wceq cK
    cz wcel cK c2 cpi cmul co mulneg1 cK zcn c2 cpi cmul co cc wcel cK cz wcel
    c2 cpi 2cn cpi pire recni mulcli a1i sylanc fveq2d eqeq1d cK cz wcel cK c2
    cpi cmul co cmul co cneg ccos cfv cK c2 cpi cmul co cmul co ccos cfv c1 cK
    cz wcel cK c2 cpi cmul co cmul co cc wcel cK c2 cpi cmul co cmul co cneg
    ccos cfv cK c2 cpi cmul co cmul co ccos cfv wceq cK cc wcel c2 cpi cmul co
    cc wcel cK c2 cpi cmul co cmul co cc wcel cK cz wcel cK c2 cpi cmul co
    mulcl cK zcn c2 cpi cmul co cc wcel cK cz wcel c2 cpi 2cn cpi pire recni
    mulcli a1i sylanc cK c2 cpi cmul co cmul co cosneg syl eqeq1d bitr2d cK cz
    wcel cK c2 cpi cmul co cmul co cneg csin cfv cc0 wceq cK c2 cpi cmul co
    cmul co csin cfv cneg cc0 wceq cK cneg c2 cpi cmul co cmul co csin cfv cc0
    wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq cK cz wcel cK c2 cpi cmul
    co cmul co cneg csin cfv cK c2 cpi cmul co cmul co csin cfv cneg cc0 cK cz
    wcel cK c2 cpi cmul co cmul co cc wcel cK c2 cpi cmul co cmul co cneg csin
    cfv cK c2 cpi cmul co cmul co csin cfv cneg wceq cK cc wcel c2 cpi cmul co
    cc wcel cK c2 cpi cmul co cmul co cc wcel cK cz wcel cK c2 cpi cmul co
    mulcl cK zcn c2 cpi cmul co cc wcel cK cz wcel c2 cpi 2cn cpi pire recni
    mulcli a1i sylanc cK c2 cpi cmul co cmul co sinneg syl eqeq1d cK cz wcel cK
    cneg c2 cpi cmul co cmul co csin cfv cK c2 cpi cmul co cmul co cneg csin
    cfv cc0 cK cz wcel cK cneg c2 cpi cmul co cmul co cK c2 cpi cmul co cmul co
    cneg csin cK cc wcel c2 cpi cmul co cc wcel cK cneg c2 cpi cmul co cmul co
    cK c2 cpi cmul co cmul co cneg wceq cK cz wcel cK c2 cpi cmul co mulneg1 cK
    zcn c2 cpi cmul co cc wcel cK cz wcel c2 cpi 2cn cpi pire recni mulcli a1i
    sylanc fveq2d eqeq1d cK cz wcel cK c2 cpi cmul co cmul co cc wcel cK c2 cpi
    cmul co cmul co csin cfv cc wcel cK c2 cpi cmul co cmul co csin cfv cc0
    wceq cK c2 cpi cmul co cmul co csin cfv cneg cc0 wceq wb cK cc wcel c2 cpi
    cmul co cc wcel cK c2 cpi cmul co cmul co cc wcel cK cz wcel cK c2 cpi cmul
    co mulcl cK zcn c2 cpi cmul co cc wcel cK cz wcel c2 cpi 2cn cpi pire recni
    mulcli a1i sylanc cK c2 cpi cmul co cmul co sincl cK c2 cpi cmul co cmul co
    csin cfv negeq0 3syl 3bitr4rd anbi12d orbi2d mpbird cK c2 cpi cmul co cmul
    co ccos cfv c1 wceq cK c2 cpi cmul co cmul co csin cfv cc0 wceq wa oridm
    sylib $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( If ` K ` is an integer, the sine of ` 2 K pi ` is 0.
     (Contributed by Paul Chapman, 23-Jan-2008.) $)
  sin2kpi $p |- ( K e. ZZ -> ( sin ` ( K x. ( 2 x. pi ) ) ) = 0 ) $=
    cK cz wcel cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi cmul co
    cmul co csin cfv cc0 wceq cK sinperlem2 pm3.27d $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( If ` K ` is an integer, the cosine of ` 2 K pi ` is 1.
     (Contributed by Paul Chapman, 23-Jan-2008.) $)
  cos2kpi $p |- ( K e. ZZ -> ( cos ` ( K x. ( 2 x. pi ) ) ) = 1 ) $=
    cK cz wcel cK c2 cpi cmul co cmul co ccos cfv c1 wceq cK c2 cpi cmul co
    cmul co csin cfv cc0 wceq cK sinperlem2 pm3.26d $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The sine function is periodic.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  sinper $p |- ( ( A e. CC /\ K e. ZZ ) ->
                 ( sin ` ( A + ( K x. ( 2 x. pi ) ) ) ) = ( sin ` A ) ) $=
    cA cc wcel cK cz wcel wa cA cK c2 cpi cmul co cmul co caddc co csin cfv cA
    csin cfv cK c2 cpi cmul co cmul co ccos cfv cmul co cA ccos cfv cK c2 cpi
    cmul co cmul co csin cfv cmul co caddc co cA csin cfv cc0 caddc co cA csin
    cfv cA cc wcel cK c2 cpi cmul co cmul co cc wcel cA cK c2 cpi cmul co cmul
    co caddc co csin cfv cA csin cfv cK c2 cpi cmul co cmul co ccos cfv cmul co
    cA ccos cfv cK c2 cpi cmul co cmul co csin cfv cmul co caddc co wceq cK cz
    wcel cA cK c2 cpi cmul co cmul co sinadd cK cz wcel cK cc wcel cK c2 cpi
    cmul co cmul co cc wcel cK zcn cK cc wcel c2 cpi cmul co cc wcel cK c2 cpi
    cmul co cmul co cc wcel c2 cpi 2cn cpi pire recni mulcli cK c2 cpi cmul co
    mulcl mpan2 syl sylan2 cA cc wcel cK cz wcel wa cA csin cfv cK c2 cpi cmul
    co cmul co ccos cfv cmul co cA csin cfv cA ccos cfv cK c2 cpi cmul co cmul
    co csin cfv cmul co cc0 caddc cK cz wcel cA cc wcel cA csin cfv cK c2 cpi
    cmul co cmul co ccos cfv cmul co cA csin cfv c1 cmul co cA csin cfv cK cz
    wcel cK c2 cpi cmul co cmul co ccos cfv c1 cA csin cfv cmul cK cos2kpi
    opreq2d cA cc wcel cA csin cfv cc wcel cA csin cfv c1 cmul co cA csin cfv
    wceq cA sincl cA csin cfv ax1id syl sylan9eqr cK cz wcel cA cc wcel cA ccos
    cfv cK c2 cpi cmul co cmul co csin cfv cmul co cA ccos cfv cc0 cmul co cc0
    cK cz wcel cK c2 cpi cmul co cmul co csin cfv cc0 cA ccos cfv cmul cK
    sin2kpi opreq2d cA cc wcel cA ccos cfv cc wcel cA ccos cfv cc0 cmul co cc0
    wceq cA coscl cA ccos cfv mul01 syl sylan9eqr opreq12d cA cc wcel cA csin
    cfv cc0 caddc co cA csin cfv wceq cK cz wcel cA cc wcel cA csin cfv cc wcel
    cA csin cfv cc0 caddc co cA csin cfv wceq cA sincl cA csin cfv addid1 syl
    adantr 3eqtrd $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( The cosine function is periodic.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  cosper $p |- ( ( A e. CC /\ K e. ZZ ) ->
                 ( cos ` ( A + ( K x. ( 2 x. pi ) ) ) ) = ( cos ` A ) ) $=
    cA cc wcel cK cz wcel wa cA cK c2 cpi cmul co cmul co caddc co ccos cfv cA
    ccos cfv cK c2 cpi cmul co cmul co ccos cfv cmul co cA csin cfv cK c2 cpi
    cmul co cmul co csin cfv cmul co cmin co cA ccos cfv cc0 cmin co cA ccos
    cfv cA cc wcel cK c2 cpi cmul co cmul co cc wcel cA cK c2 cpi cmul co cmul
    co caddc co ccos cfv cA ccos cfv cK c2 cpi cmul co cmul co ccos cfv cmul co
    cA csin cfv cK c2 cpi cmul co cmul co csin cfv cmul co cmin co wceq cK cz
    wcel cA cK c2 cpi cmul co cmul co cosadd cK cz wcel cK cc wcel cK c2 cpi
    cmul co cmul co cc wcel cK zcn cK cc wcel c2 cpi cmul co cc wcel cK c2 cpi
    cmul co cmul co cc wcel c2 cpi 2cn cpi pire recni mulcli cK c2 cpi cmul co
    mulcl mpan2 syl sylan2 cA cc wcel cK cz wcel wa cA ccos cfv cK c2 cpi cmul
    co cmul co ccos cfv cmul co cA ccos cfv cA csin cfv cK c2 cpi cmul co cmul
    co csin cfv cmul co cc0 cmin cK cz wcel cA cc wcel cA ccos cfv cK c2 cpi
    cmul co cmul co ccos cfv cmul co cA ccos cfv c1 cmul co cA ccos cfv cK cz
    wcel cK c2 cpi cmul co cmul co ccos cfv c1 cA ccos cfv cmul cK cos2kpi
    opreq2d cA cc wcel cA ccos cfv cc wcel cA ccos cfv c1 cmul co cA ccos cfv
    wceq cA coscl cA ccos cfv ax1id syl sylan9eqr cK cz wcel cA cc wcel cA csin
    cfv cK c2 cpi cmul co cmul co csin cfv cmul co cA csin cfv cc0 cmul co cc0
    cK cz wcel cK c2 cpi cmul co cmul co csin cfv cc0 cA csin cfv cmul cK
    sin2kpi opreq2d cA cc wcel cA csin cfv cc wcel cA csin cfv cc0 cmul co cc0
    wceq cA sincl cA csin cfv mul01 syl sylan9eqr opreq12d cA cc wcel cA ccos
    cfv cc0 cmin co cA ccos cfv wceq cK cz wcel cA cc wcel cA ccos cfv cc wcel
    cA ccos cfv cc0 cmin co cA ccos cfv wceq cA coscl cA ccos cfv subid1 syl
    adantr 3eqtrd $.
    $( [23-Jan-2008] $) $( [23-Jan-2008] $)

  $( Sine of a number subtracted from ` 2 x. pi ` . (Contributed by Paul
     Chapman, 15-Mar-2008.) $)
  sin2pim $p |- ( A e. CC ->
                ( sin ` ( ( 2 x. pi ) - A ) ) = -u ( sin ` A ) ) $=
    cA cc wcel cA cneg c1 c2 cpi cmul co cmul co caddc co csin cfv cA cneg csin
    cfv c2 cpi cmul co cA cmin co csin cfv cA csin cfv cneg cA cc wcel cA cneg
    cc wcel cA cneg c1 c2 cpi cmul co cmul co caddc co csin cfv cA cneg csin
    cfv wceq cA negcl cA cneg cc wcel c1 cz wcel cA cneg c1 c2 cpi cmul co cmul
    co caddc co csin cfv cA cneg csin cfv wceq 1z cA cneg c1 sinper mpan2 syl
    cA cc wcel cA cneg c1 c2 cpi cmul co cmul co caddc co c2 cpi cmul co cA
    cmin co csin cA cc wcel cA cneg c2 cpi cmul co caddc co c2 cpi cmul co cA
    cmin co cA cneg c1 c2 cpi cmul co cmul co caddc co cA cc wcel c2 cpi cmul
    co cc wcel cA cneg c2 cpi cmul co caddc co c2 cpi cmul co cA cmin co wceq
    c2 cpi 2cn cpi pire recni mulcli cA cc wcel c2 cpi cmul co cc wcel wa cA c2
    cpi cmul co cmin co cneg cA cneg c2 cpi cmul co caddc co c2 cpi cmul co cA
    cmin co cA c2 cpi cmul co negsubdi cA c2 cpi cmul co negsubdi2 eqtr3d mpan2
    c1 c2 cpi cmul co cmul co c2 cpi cmul co cA cneg caddc c2 cpi cmul co c2
    cpi 2cn cpi pire recni mulcli mulid2i opreq2i syl5eq fveq2d cA sinneg
    3eqtr3d $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( Cosine of a number subtracted from ` 2 x. pi ` . (Contributed by Paul
     Chapman, 15-Mar-2008.) $)
  cos2pim $p |- ( A e. CC -> ( cos ` ( ( 2 x. pi ) - A ) ) = ( cos ` A ) ) $=
    cA cc wcel cA cneg c1 c2 cpi cmul co cmul co caddc co ccos cfv cA cneg ccos
    cfv c2 cpi cmul co cA cmin co ccos cfv cA ccos cfv cA cc wcel cA cneg cc
    wcel cA cneg c1 c2 cpi cmul co cmul co caddc co ccos cfv cA cneg ccos cfv
    wceq cA negcl cA cneg cc wcel c1 cz wcel cA cneg c1 c2 cpi cmul co cmul co
    caddc co ccos cfv cA cneg ccos cfv wceq 1z cA cneg c1 cosper mpan2 syl cA
    cc wcel cA cneg c1 c2 cpi cmul co cmul co caddc co c2 cpi cmul co cA cmin
    co ccos cA cc wcel cA cneg c2 cpi cmul co caddc co c2 cpi cmul co cA cmin
    co cA cneg c1 c2 cpi cmul co cmul co caddc co cA cc wcel c2 cpi cmul co cc
    wcel cA cneg c2 cpi cmul co caddc co c2 cpi cmul co cA cmin co wceq c2 cpi
    2cn cpi pire recni mulcli cA cc wcel c2 cpi cmul co cc wcel wa cA c2 cpi
    cmul co cmin co cneg cA cneg c2 cpi cmul co caddc co c2 cpi cmul co cA cmin
    co cA c2 cpi cmul co negsubdi cA c2 cpi cmul co negsubdi2 eqtr3d mpan2 c1
    c2 cpi cmul co cmul co c2 cpi cmul co cA cneg caddc c2 cpi cmul co c2 cpi
    2cn cpi pire recni mulcli mulid2i opreq2i syl5eq fveq2d cA cosneg 3eqtr3d
    $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( Sine of a number less ` pi ` . (Contributed by Paul Chapman,
     15-Mar-2008.) $)
  sinmpi $p |- ( A e. CC -> ( sin ` ( A - pi ) ) = -u ( sin ` A ) ) $=
    cA cc wcel cA cpi cmin co csin cfv cA csin cfv cpi ccos cfv cmul co cA ccos
    cfv cpi csin cfv cmul co cmin co cA csin cfv cneg cc0 cmin co cA csin cfv
    cneg cA cc wcel cpi cc wcel cA cpi cmin co csin cfv cA csin cfv cpi ccos
    cfv cmul co cA ccos cfv cpi csin cfv cmul co cmin co wceq cpi pire recni cA
    cpi sinsub mpan2 cA cc wcel cA csin cfv cpi ccos cfv cmul co cA csin cfv
    cneg cA ccos cfv cpi csin cfv cmul co cc0 cmin cA cc wcel cA csin cfv c1
    cneg cmul co cA csin cfv cneg cA csin cfv cpi ccos cfv cmul co cA cc wcel
    cA csin cfv cc wcel cA csin cfv c1 cneg cmul co cA csin cfv cneg wceq cA
    sincl cA csin cfv cc wcel cA csin cfv c1 cneg cmul co c1 cneg cA csin cfv
    cmul co cA csin cfv cneg cA csin cfv cc wcel c1 cneg cc wcel cA csin cfv c1
    cneg cmul co c1 cneg cA csin cfv cmul co wceq c1 ax1cn negcli cA csin cfv
    c1 cneg mulcom mpan2 cA csin cfv mulm1 eqtrd syl cpi ccos cfv c1 cneg cA
    csin cfv cmul cospi opreq2i syl5eq cA cc wcel cA ccos cfv cc0 cmul co cc0
    cA ccos cfv cpi csin cfv cmul co cA cc wcel cA ccos cfv cc wcel cA ccos cfv
    cc0 cmul co cc0 wceq cA coscl cA ccos cfv mul01 syl cpi csin cfv cc0 cA
    ccos cfv cmul sinpi opreq2i syl5eq opreq12d cA cc wcel cA csin cfv cc wcel
    cA csin cfv cneg cc wcel cA csin cfv cneg cc0 cmin co cA csin cfv cneg wceq
    cA sincl cA csin cfv negcl cA csin cfv cneg subid1 3syl 3eqtrd $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( Cosine of a number less ` pi ` . (Contributed by Paul Chapman,
     15-Mar-2008.) $)
  cosmpi $p |- ( A e. CC -> ( cos ` ( A - pi ) ) = -u ( cos ` A ) ) $=
    cA cc wcel cA cpi cmin co ccos cfv cA ccos cfv cpi ccos cfv cmul co cA csin
    cfv cpi csin cfv cmul co caddc co cA ccos cfv cneg cc0 caddc co cA ccos cfv
    cneg cA cc wcel cpi cc wcel cA cpi cmin co ccos cfv cA ccos cfv cpi ccos
    cfv cmul co cA csin cfv cpi csin cfv cmul co caddc co wceq cpi pire recni
    cA cpi cossub mpan2 cA cc wcel cA ccos cfv cpi ccos cfv cmul co cA ccos cfv
    cneg cA csin cfv cpi csin cfv cmul co cc0 caddc cA cc wcel cA ccos cfv c1
    cneg cmul co cA ccos cfv cneg cA ccos cfv cpi ccos cfv cmul co cA cc wcel
    cA ccos cfv cc wcel cA ccos cfv c1 cneg cmul co cA ccos cfv cneg wceq cA
    coscl cA ccos cfv cc wcel cA ccos cfv c1 cneg cmul co c1 cneg cA ccos cfv
    cmul co cA ccos cfv cneg cA ccos cfv cc wcel c1 cneg cc wcel cA ccos cfv c1
    cneg cmul co c1 cneg cA ccos cfv cmul co wceq c1 ax1cn negcli cA ccos cfv
    c1 cneg mulcom mpan2 cA ccos cfv mulm1 eqtrd syl cpi ccos cfv c1 cneg cA
    ccos cfv cmul cospi opreq2i syl5eq cA cc wcel cA csin cfv cc0 cmul co cc0
    cA csin cfv cpi csin cfv cmul co cA cc wcel cA csin cfv cc wcel cA csin cfv
    cc0 cmul co cc0 wceq cA sincl cA csin cfv mul01 syl cpi csin cfv cc0 cA
    csin cfv cmul sinpi opreq2i syl5eq opreq12d cA cc wcel cA ccos cfv cc wcel
    cA ccos cfv cneg cc wcel cA ccos cfv cneg cc0 caddc co cA ccos cfv cneg
    wceq cA coscl cA ccos cfv negcl cA ccos cfv cneg addid1 3syl 3eqtrd $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( Sine of a number plus ` pi ` . $)
  sinppi $p |- ( A e. CC -> ( sin ` ( A + pi ) ) = -u ( sin ` A ) ) $=
    cA cc wcel cA cpi caddc co csin cfv cA csin cfv cpi ccos cfv cmul co cA
    ccos cfv cpi csin cfv cmul co caddc co cA csin cfv cneg cc0 caddc co cA
    csin cfv cneg cA cc wcel cpi cc wcel cA cpi caddc co csin cfv cA csin cfv
    cpi ccos cfv cmul co cA ccos cfv cpi csin cfv cmul co caddc co wceq cpi
    pire recni cA cpi sinadd mpan2 cA cc wcel cA csin cfv cpi ccos cfv cmul co
    cA csin cfv cneg cA ccos cfv cpi csin cfv cmul co cc0 caddc cA cc wcel cA
    csin cfv c1 cneg cmul co cA csin cfv cneg cA csin cfv cpi ccos cfv cmul co
    cA cc wcel cA csin cfv cc wcel cA csin cfv c1 cneg cmul co cA csin cfv cneg
    wceq cA sincl cA csin cfv cc wcel cA csin cfv c1 cneg cmul co c1 cneg cA
    csin cfv cmul co cA csin cfv cneg cA csin cfv cc wcel c1 cneg cc wcel cA
    csin cfv c1 cneg cmul co c1 cneg cA csin cfv cmul co wceq c1 ax1cn negcli
    cA csin cfv c1 cneg mulcom mpan2 cA csin cfv mulm1 eqtrd syl cpi ccos cfv
    c1 cneg cA csin cfv cmul cospi opreq2i syl5eq cA cc wcel cA ccos cfv cc0
    cmul co cc0 cA ccos cfv cpi csin cfv cmul co cA cc wcel cA ccos cfv cc wcel
    cA ccos cfv cc0 cmul co cc0 wceq cA coscl cA ccos cfv mul01 syl cpi csin
    cfv cc0 cA ccos cfv cmul sinpi opreq2i syl5eq opreq12d cA cc wcel cA csin
    cfv cc wcel cA csin cfv cneg cc wcel cA csin cfv cneg cc0 caddc co cA csin
    cfv cneg wceq cA sincl cA csin cfv negcl cA csin cfv cneg addid1 3syl
    3eqtrd $.
    $( [10-Aug-2008] $) $( [10-Aug-2008] $)

  $( Cosine of a complex number plus ` pi ` . $)
  cosppi $p |- ( A e. CC -> ( cos ` ( A + pi ) ) = -u ( cos ` A ) ) $=
    cA cc wcel cA cpi caddc co ccos cfv cA ccos cfv cpi ccos cfv cmul co cA
    csin cfv cpi csin cfv cmul co cmin co cA ccos cfv cneg cc0 cmin co cA ccos
    cfv cneg cA cc wcel cpi cc wcel cA cpi caddc co ccos cfv cA ccos cfv cpi
    ccos cfv cmul co cA csin cfv cpi csin cfv cmul co cmin co wceq cpi pire
    recni cA cpi cosadd mpan2 cA cc wcel cA ccos cfv cpi ccos cfv cmul co cA
    ccos cfv cneg cA csin cfv cpi csin cfv cmul co cc0 cmin cA cc wcel cA ccos
    cfv c1 cneg cmul co cA ccos cfv cneg cA ccos cfv cpi ccos cfv cmul co cA cc
    wcel cA ccos cfv cc wcel cA ccos cfv c1 cneg cmul co cA ccos cfv cneg wceq
    cA coscl cA ccos cfv cc wcel cA ccos cfv c1 cneg cmul co c1 cneg cA ccos
    cfv cmul co cA ccos cfv cneg cA ccos cfv cc wcel c1 cneg cc wcel cA ccos
    cfv c1 cneg cmul co c1 cneg cA ccos cfv cmul co wceq c1 ax1cn negcli cA
    ccos cfv c1 cneg mulcom mpan2 cA ccos cfv mulm1 eqtrd syl cpi ccos cfv c1
    cneg cA ccos cfv cmul cospi opreq2i syl5eq cA cc wcel cA csin cfv cc0 cmul
    co cc0 cA csin cfv cpi csin cfv cmul co cA cc wcel cA csin cfv cc wcel cA
    csin cfv cc0 cmul co cc0 wceq cA sincl cA csin cfv mul01 syl cpi csin cfv
    cc0 cA csin cfv cmul sinpi opreq2i syl5eq opreq12d cA cc wcel cA ccos cfv
    cc wcel cA ccos cfv cneg cc wcel cA ccos cfv cneg cc0 cmin co cA ccos cfv
    cneg wceq cA coscl cA ccos cfv negcl cA ccos cfv cneg subid1 3syl 3eqtrd $.
    $( [21-Dec-2008] $) $( [18-Aug-2008] $)

  $( The exponential function of ` _i ` times a real number less ` pi ` .
     (Contributed by Paul Chapman, 15-Mar-2008.) $)
  efimpi $p |- ( A e. CC ->
                 ( exp ` ( _i x. ( A - pi ) ) ) = -u ( exp ` ( _i x. A ) ) ) $=
    cA cc wcel cA ccos cfv ci cA csin cfv cmul co caddc co cneg cA cpi cmin co
    ccos cfv ci cA cpi cmin co csin cfv cmul co caddc co ci cA cmul co ce cfv
    cneg ci cA cpi cmin co cmul co ce cfv cA cc wcel cA ccos cfv ci cA csin cfv
    cmul co caddc co cneg cA ccos cfv cneg ci cA csin cfv cmul co cneg caddc co
    cA cpi cmin co ccos cfv ci cA cpi cmin co csin cfv cmul co caddc co cA ccos
    cfv cc wcel ci cA csin cfv cmul co cc wcel cA ccos cfv ci cA csin cfv cmul
    co caddc co cneg cA ccos cfv cneg ci cA csin cfv cmul co cneg caddc co wceq
    cA cc wcel cA ccos cfv ci cA csin cfv cmul co negdi cA coscl cA cc wcel cA
    csin cfv cc wcel ci cA csin cfv cmul co cc wcel cA sincl ci cc wcel cA csin
    cfv cc wcel ci cA csin cfv cmul co cc wcel axicn ci cA csin cfv mulcl mpan
    syl sylanc cA cc wcel cA cpi cmin co ccos cfv cA ccos cfv cneg ci cA cpi
    cmin co csin cfv cmul co ci cA csin cfv cmul co cneg caddc cA cosmpi cA cc
    wcel ci cA cpi cmin co csin cfv cmul co ci cA csin cfv cneg cmul co ci cA
    csin cfv cmul co cneg cA cc wcel cA cpi cmin co csin cfv cA csin cfv cneg
    ci cmul cA sinmpi opreq2d cA cc wcel cA csin cfv cc wcel ci cA csin cfv
    cneg cmul co ci cA csin cfv cmul co cneg wceq cA sincl ci cc wcel cA csin
    cfv cc wcel ci cA csin cfv cneg cmul co ci cA csin cfv cmul co cneg wceq
    axicn ci cA csin cfv mulneg2 mpan syl eqtrd opreq12d eqtr4d cA cc wcel ci
    cA cmul co ce cfv cA ccos cfv ci cA csin cfv cmul co caddc co cA efival
    negeqd cA cc wcel cA cpi cmin co cc wcel ci cA cpi cmin co cmul co ce cfv
    cA cpi cmin co ccos cfv ci cA cpi cmin co csin cfv cmul co caddc co wceq cA
    cc wcel cpi cc wcel cA cpi cmin co cc wcel cpi pire recni cA cpi subcl
    mpan2 cA cpi cmin co efival syl 3eqtr4rd $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( The sine of ` pi / 2 ` plus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  sinhalfpip $p |- ( A e. CC -> ( sin ` ( ( pi / 2 ) + A ) ) = ( cos ` A ) ) $=
    cA cc wcel cpi c2 cdiv co cA caddc co csin cfv cpi c2 cdiv co csin cfv cA
    ccos cfv cmul co cpi c2 cdiv co ccos cfv cA csin cfv cmul co caddc co cA
    ccos cfv cc0 caddc co cA ccos cfv cpi c2 cdiv co cc wcel cA cc wcel cpi c2
    cdiv co cA caddc co csin cfv cpi c2 cdiv co csin cfv cA ccos cfv cmul co
    cpi c2 cdiv co ccos cfv cA csin cfv cmul co caddc co wceq cpi c2 cpi pire
    recni 2cn 2ne0 divcli cpi c2 cdiv co cA sinadd mpan cA cc wcel cpi c2 cdiv
    co csin cfv cA ccos cfv cmul co cA ccos cfv cpi c2 cdiv co ccos cfv cA csin
    cfv cmul co cc0 caddc cA cc wcel c1 cA ccos cfv cmul co cA ccos cfv cpi c2
    cdiv co csin cfv cA ccos cfv cmul co cA cc wcel cA ccos cfv cc wcel c1 cA
    ccos cfv cmul co cA ccos cfv wceq cA coscl cA ccos cfv mulid2 syl cpi c2
    cdiv co csin cfv c1 cA ccos cfv cmul sinhalfpi opreq1i syl5eq cA cc wcel
    cc0 cA csin cfv cmul co cc0 cpi c2 cdiv co ccos cfv cA csin cfv cmul co cA
    cc wcel cA csin cfv cc wcel cc0 cA csin cfv cmul co cc0 wceq cA sincl cA
    csin cfv mul02 syl cpi c2 cdiv co ccos cfv cc0 cA csin cfv cmul coshalfpi
    opreq1i syl5eq opreq12d cA cc wcel cA ccos cfv cc wcel cA ccos cfv cc0
    caddc co cA ccos cfv wceq cA coscl cA ccos cfv addid1 syl 3eqtrd $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The sine of ` pi / 2 ` minus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  sinhalfpim $p |- ( A e. CC -> ( sin ` ( ( pi / 2 ) - A ) ) = ( cos ` A ) ) $=
    cA cc wcel cpi c2 cdiv co cA cmin co csin cfv cpi c2 cdiv co csin cfv cA
    ccos cfv cmul co cpi c2 cdiv co ccos cfv cA csin cfv cmul co cmin co cA
    ccos cfv cc0 cmin co cA ccos cfv cpi c2 cdiv co cc wcel cA cc wcel cpi c2
    cdiv co cA cmin co csin cfv cpi c2 cdiv co csin cfv cA ccos cfv cmul co cpi
    c2 cdiv co ccos cfv cA csin cfv cmul co cmin co wceq cpi c2 cpi pire recni
    2cn 2ne0 divcli cpi c2 cdiv co cA sinsub mpan cA cc wcel cpi c2 cdiv co
    csin cfv cA ccos cfv cmul co cA ccos cfv cpi c2 cdiv co ccos cfv cA csin
    cfv cmul co cc0 cmin cA cc wcel c1 cA ccos cfv cmul co cA ccos cfv cpi c2
    cdiv co csin cfv cA ccos cfv cmul co cA cc wcel cA ccos cfv cc wcel c1 cA
    ccos cfv cmul co cA ccos cfv wceq cA coscl cA ccos cfv mulid2 syl cpi c2
    cdiv co csin cfv c1 cA ccos cfv cmul sinhalfpi opreq1i syl5eq cA cc wcel
    cc0 cA csin cfv cmul co cc0 cpi c2 cdiv co ccos cfv cA csin cfv cmul co cA
    cc wcel cA csin cfv cc wcel cc0 cA csin cfv cmul co cc0 wceq cA sincl cA
    csin cfv mul02 syl cpi c2 cdiv co ccos cfv cc0 cA csin cfv cmul coshalfpi
    opreq1i syl5eq opreq12d cA cc wcel cA ccos cfv cc wcel cA ccos cfv cc0 cmin
    co cA ccos cfv wceq cA coscl cA ccos cfv subid1 syl 3eqtrd $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The cosine of ` pi / 2 ` plus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  coshalfpip $p |- ( A e. CC ->
                     ( cos ` ( ( pi / 2 ) + A ) ) = -u ( sin ` A ) ) $=
    cA cc wcel cpi c2 cdiv co ccos cfv cA ccos cfv cmul co cpi c2 cdiv co csin
    cfv cA csin cfv cmul co cmin co cc0 cA csin cfv cmin co cpi c2 cdiv co cA
    caddc co ccos cfv cA csin cfv cneg cA cc wcel cpi c2 cdiv co ccos cfv cA
    ccos cfv cmul co cc0 cpi c2 cdiv co csin cfv cA csin cfv cmul co cA csin
    cfv cmin cA cc wcel cc0 cA ccos cfv cmul co cc0 cpi c2 cdiv co ccos cfv cA
    ccos cfv cmul co cA cc wcel cA ccos cfv cc wcel cc0 cA ccos cfv cmul co cc0
    wceq cA coscl cA ccos cfv mul02 syl cpi c2 cdiv co ccos cfv cc0 cA ccos cfv
    cmul coshalfpi opreq1i syl5eq cA cc wcel c1 cA csin cfv cmul co cA csin cfv
    cpi c2 cdiv co csin cfv cA csin cfv cmul co cA cc wcel cA csin cfv cc wcel
    c1 cA csin cfv cmul co cA csin cfv wceq cA sincl cA csin cfv mulid2 syl cpi
    c2 cdiv co csin cfv c1 cA csin cfv cmul sinhalfpi opreq1i syl5eq opreq12d
    cpi c2 cdiv co cc wcel cA cc wcel cpi c2 cdiv co cA caddc co ccos cfv cpi
    c2 cdiv co ccos cfv cA ccos cfv cmul co cpi c2 cdiv co csin cfv cA csin cfv
    cmul co cmin co wceq cpi c2 cpi pire recni 2cn 2ne0 divcli cpi c2 cdiv co
    cA cosadd mpan cA csin cfv cneg cc0 cA csin cfv cmin co wceq cA cc wcel cA
    csin cfv df-neg a1i 3eqtr4d $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The cosine of ` pi / 2 ` minus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  coshalfpim $p |- ( A e. CC -> ( cos ` ( ( pi / 2 ) - A ) ) = ( sin ` A ) ) $=
    cA cc wcel cpi c2 cdiv co cA cmin co ccos cfv cpi c2 cdiv co ccos cfv cA
    ccos cfv cmul co cpi c2 cdiv co csin cfv cA csin cfv cmul co caddc co cc0
    cA csin cfv caddc co cA csin cfv cpi c2 cdiv co cc wcel cA cc wcel cpi c2
    cdiv co cA cmin co ccos cfv cpi c2 cdiv co ccos cfv cA ccos cfv cmul co cpi
    c2 cdiv co csin cfv cA csin cfv cmul co caddc co wceq cpi c2 cpi pire recni
    2cn 2ne0 divcli cpi c2 cdiv co cA cossub mpan cA cc wcel cpi c2 cdiv co
    ccos cfv cA ccos cfv cmul co cc0 cpi c2 cdiv co csin cfv cA csin cfv cmul
    co cA csin cfv caddc cA cc wcel cc0 cA ccos cfv cmul co cc0 cpi c2 cdiv co
    ccos cfv cA ccos cfv cmul co cA cc wcel cA ccos cfv cc wcel cc0 cA ccos cfv
    cmul co cc0 wceq cA coscl cA ccos cfv mul02 syl cpi c2 cdiv co ccos cfv cc0
    cA ccos cfv cmul coshalfpi opreq1i syl5eq cA cc wcel c1 cA csin cfv cmul co
    cA csin cfv cpi c2 cdiv co csin cfv cA csin cfv cmul co cA cc wcel cA csin
    cfv cc wcel c1 cA csin cfv cmul co cA csin cfv wceq cA sincl cA csin cfv
    mulid2 syl cpi c2 cdiv co csin cfv c1 cA csin cfv cmul sinhalfpi opreq1i
    syl5eq opreq12d cA cc wcel cA csin cfv cc wcel cc0 cA csin cfv caddc co cA
    csin cfv wceq cA sincl cA csin cfv addid2 syl 3eqtrd $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( Lemma for ~ sincosq1sgn . $)
  sincosq1lem $p |- ( ( A e. RR /\ 0 < A /\ A < ( pi / 2 ) ) ->
                      0 < ( sin ` A ) ) $=
    cA cr wcel cc0 cA clt wbr cA c2 cle wbr cc0 cA csin cfv clt wbr cA cpi c2
    cdiv co clt wbr cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a cA cc0 c2 cioc
    co wcel cc0 cA csin cfv clt wbr cc0 cr wcel c2 cr wcel cA cc0 c2 cioc co
    wcel cA cr wcel cc0 cA clt wbr cA c2 cle wbr w3a wb 0re 2re cc0 c2 cA
    elioc2 mp2an cA sin02gt0 sylbir cA cr wcel cc0 cA clt wbr cA cpi c2 cdiv co
    clt wbr cA c2 cle wbr cA cr wcel cA cpi c2 cdiv co clt wbr cA c2 cle wbr wi
    cc0 cA clt wbr cA cr wcel cA cpi c2 cdiv co clt wbr cA cpi c2 cdiv co cle
    wbr cA c2 cle wbr cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co clt
    wbr cA cpi c2 cdiv co cle wbr wi cpi c2 pire 2re 2ne0 redivcli cA cpi c2
    cdiv co ltle mpan2 cA cr wcel cA cpi c2 cdiv co cle wbr cpi c2 cdiv co c2
    cle wbr cA c2 cle wbr cpi c2 cdiv co c2 cle wbr cpi c4 cle wbr cpi c4 pire
    4re c2 cpi clt wbr cpi c4 clt wbr pigt2lt4 pm3.27i ltleii cpi c2 cdiv co c2
    cle wbr cpi c2 c2 cmul co cle wbr cpi c4 cle wbr cpi cr wcel c2 cr wcel c2
    cr wcel cpi c2 cdiv co c2 cle wbr cpi c2 c2 cmul co cle wbr wb pire 2re 2re
    cpi cr wcel c2 cr wcel c2 cr wcel w3a cc0 c2 clt wbr cpi c2 cdiv co c2 cle
    wbr cpi c2 c2 cmul co cle wbr wb 2pos cpi c2 c2 ledivmulOLD mpan2 mp3an c2
    c2 cmul co c4 cpi cle 2t2e4 breq2i bitri mpbir cA cr wcel cpi c2 cdiv co cr
    wcel c2 cr wcel cA cpi c2 cdiv co cle wbr cpi c2 cdiv co c2 cle wbr wa cA
    c2 cle wbr wi cpi c2 pire 2re 2ne0 redivcli 2re cA cpi c2 cdiv co c2 letr
    mp3an23 mpan2i syld adantr 3impia syld3an3 $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The signs of the sine and cosine functions in the first quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq1sgn $p |- ( A e. ( 0 (,) ( pi / 2 ) ) ->
                      ( 0 < ( sin ` A ) /\ 0 < ( cos ` A ) ) ) $=
    cA cc0 cpi c2 cdiv co cioo co wcel cA cr wcel cc0 cA clt wbr cA cpi c2 cdiv
    co clt wbr w3a cc0 cA csin cfv clt wbr cc0 cA ccos cfv clt wbr wa cc0 cr
    wcel cpi c2 cdiv co cr wcel cA cc0 cpi c2 cdiv co cioo co wcel cA cr wcel
    cc0 cA clt wbr cA cpi c2 cdiv co clt wbr w3a wb 0re cpi c2 pire 2re 2ne0
    redivcli cc0 cxr wcel cpi c2 cdiv co cxr wcel cA cc0 cpi c2 cdiv co cioo co
    wcel cA cr wcel cc0 cA clt wbr cA cpi c2 cdiv co clt wbr w3a wb cc0 cr wcel
    cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co cA elioo2 cc0 rexr cpi c2 cdiv co
    rexr syl2an mp2an cA cr wcel cc0 cA clt wbr cA cpi c2 cdiv co clt wbr w3a
    cc0 cA csin cfv clt wbr cc0 cA ccos cfv clt wbr cA sincosq1lem cA cr wcel
    cc0 cA clt wbr cA cpi c2 cdiv co clt wbr cc0 cA ccos cfv clt wbr cA cr wcel
    cc0 cpi c2 cdiv co cA cmin co clt wbr cpi c2 cdiv co cA cmin co cpi c2 cdiv
    co clt wbr wa cc0 cpi c2 cdiv co cA cmin co csin cfv clt wbr cc0 cA clt wbr
    cA cpi c2 cdiv co clt wbr wa cc0 cA ccos cfv clt wbr cA cr wcel cc0 cpi c2
    cdiv co cA cmin co clt wbr cpi c2 cdiv co cA cmin co cpi c2 cdiv co clt wbr
    cc0 cpi c2 cdiv co cA cmin co csin cfv clt wbr cpi c2 cdiv co cA cmin co cr
    wcel cc0 cpi c2 cdiv co cA cmin co clt wbr cpi c2 cdiv co cA cmin co cpi c2
    cdiv co clt wbr cc0 cpi c2 cdiv co cA cmin co csin cfv clt wbr cA cr wcel
    cpi c2 cdiv co cA cmin co sincosq1lem cpi c2 cdiv co cr wcel cA cr wcel cpi
    c2 cdiv co cA cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cpi c2 cdiv co
    cA resubcl mpan syl3an1 3expib cA cr wcel cc0 cpi c2 cdiv co cA cmin co clt
    wbr cpi c2 cdiv co cA cmin co cpi c2 cdiv co clt wbr wa cA cpi c2 cdiv co
    clt wbr cc0 cA clt wbr wa cc0 cA clt wbr cA cpi c2 cdiv co clt wbr wa cA cr
    wcel cc0 cpi c2 cdiv co cA cmin co clt wbr cA cpi c2 cdiv co clt wbr cpi c2
    cdiv co cA cmin co cpi c2 cdiv co clt wbr cc0 cA clt wbr cA cr wcel cc0 cpi
    c2 cdiv co cA cmin co clt wbr cA cpi c2 cdiv co cc0 cmin co clt wbr cA cpi
    c2 cdiv co clt wbr cc0 cr wcel cpi c2 cdiv co cr wcel cA cr wcel cc0 cpi c2
    cdiv co cA cmin co clt wbr cA cpi c2 cdiv co cc0 cmin co clt wbr wb 0re cpi
    c2 pire 2re 2ne0 redivcli cc0 cpi c2 cdiv co cA ltsub13 mp3an12 cpi c2 cdiv
    co cc0 cmin co cpi c2 cdiv co cA clt cpi c2 cdiv co cpi c2 cdiv co cpi c2
    pire 2re 2ne0 redivcli recni subid1i breq2i syl6bb cA cr wcel cpi c2 cdiv
    co cA cmin co cpi c2 cdiv co clt wbr cpi c2 cdiv co cpi c2 cdiv co cmin co
    cA clt wbr cc0 cA clt wbr cpi c2 cdiv co cr wcel cA cr wcel cpi c2 cdiv co
    cr wcel cpi c2 cdiv co cA cmin co cpi c2 cdiv co clt wbr cpi c2 cdiv co cpi
    c2 cdiv co cmin co cA clt wbr wb cpi c2 pire 2re 2ne0 redivcli cpi c2 pire
    2re 2ne0 redivcli cpi c2 cdiv co cA cpi c2 cdiv co ltsub23 mp3an13 cpi c2
    cdiv co cpi c2 cdiv co cmin co cc0 cA clt cpi c2 cdiv co cpi c2 cdiv co cpi
    c2 pire 2re 2ne0 redivcli recni subidi breq1i syl6bb anbi12d cA cpi c2 cdiv
    co clt wbr cc0 cA clt wbr ancom syl6bb cA cr wcel cpi c2 cdiv co cA cmin co
    csin cfv cA ccos cfv cc0 clt cA cr wcel cA cc wcel cpi c2 cdiv co cA cmin
    co csin cfv cA ccos cfv wceq cA recn cA sinhalfpim syl breq2d 3imtr3d
    3impib jca sylbi $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The signs of the sine and cosine functions in the second quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq2sgn $p |- ( A e. ( ( pi / 2 ) (,) pi ) ->
                      ( 0 < ( sin ` A ) /\ ( cos ` A ) < 0 ) ) $=
    cA cpi c2 cdiv co cpi cioo co wcel cA cr wcel cpi c2 cdiv co cA clt wbr cA
    cpi clt wbr w3a cc0 cA csin cfv clt wbr cA ccos cfv cc0 clt wbr wa cpi c2
    cdiv co cr wcel cpi cr wcel cA cpi c2 cdiv co cpi cioo co wcel cA cr wcel
    cpi c2 cdiv co cA clt wbr cA cpi clt wbr w3a wb cpi c2 pire 2re 2ne0
    redivcli pire cpi c2 cdiv co cxr wcel cpi cxr wcel cA cpi c2 cdiv co cpi
    cioo co wcel cA cr wcel cpi c2 cdiv co cA clt wbr cA cpi clt wbr w3a wb cpi
    c2 cdiv co cr wcel cpi cr wcel cpi c2 cdiv co cpi cA elioo2 cpi c2 cdiv co
    rexr cpi rexr syl2an mp2an cA cr wcel cpi c2 cdiv co cA clt wbr cA cpi clt
    wbr w3a cA ccos cfv cc0 clt wbr cc0 cA csin cfv clt wbr wa cc0 cA csin cfv
    clt wbr cA ccos cfv cc0 clt wbr wa cA cr wcel cpi c2 cdiv co cA clt wbr cA
    cpi clt wbr cA ccos cfv cc0 clt wbr cc0 cA csin cfv clt wbr wa cA cr wcel
    cpi c2 cdiv co cA clt wbr cA cpi clt wbr wa cA cpi c2 cdiv co cmin co csin
    cfv cneg cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co ccos cfv clt wbr wa cA
    ccos cfv cc0 clt wbr cc0 cA csin cfv clt wbr wa cA cr wcel cc0 cA cpi c2
    cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co cpi c2 cdiv co clt wbr wa
    cc0 cA cpi c2 cdiv co cmin co csin cfv clt wbr cc0 cA cpi c2 cdiv co cmin
    co ccos cfv clt wbr wa cpi c2 cdiv co cA clt wbr cA cpi clt wbr wa cA cpi
    c2 cdiv co cmin co csin cfv cneg cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co
    ccos cfv clt wbr wa cA cr wcel cc0 cA cpi c2 cdiv co cmin co clt wbr cA cpi
    c2 cdiv co cmin co cpi c2 cdiv co clt wbr cc0 cA cpi c2 cdiv co cmin co
    csin cfv clt wbr cc0 cA cpi c2 cdiv co cmin co ccos cfv clt wbr wa cA cpi
    c2 cdiv co cmin co cr wcel cc0 cA cpi c2 cdiv co cmin co clt wbr cA cpi c2
    cdiv co cmin co cpi c2 cdiv co clt wbr cc0 cA cpi c2 cdiv co cmin co csin
    cfv clt wbr cc0 cA cpi c2 cdiv co cmin co ccos cfv clt wbr wa cA cr wcel cA
    cpi c2 cdiv co cmin co cr wcel cc0 cA cpi c2 cdiv co cmin co clt wbr cA cpi
    c2 cdiv co cmin co cpi c2 cdiv co clt wbr w3a cA cpi c2 cdiv co cmin co cc0
    cpi c2 cdiv co cioo co wcel cc0 cA cpi c2 cdiv co cmin co csin cfv clt wbr
    cc0 cA cpi c2 cdiv co cmin co ccos cfv clt wbr wa cc0 cr wcel cpi c2 cdiv
    co cr wcel cA cpi c2 cdiv co cmin co cc0 cpi c2 cdiv co cioo co wcel cA cpi
    c2 cdiv co cmin co cr wcel cc0 cA cpi c2 cdiv co cmin co clt wbr cA cpi c2
    cdiv co cmin co cpi c2 cdiv co clt wbr w3a wb 0re cpi c2 pire 2re 2ne0
    redivcli cc0 cxr wcel cpi c2 cdiv co cxr wcel cA cpi c2 cdiv co cmin co cc0
    cpi c2 cdiv co cioo co wcel cA cpi c2 cdiv co cmin co cr wcel cc0 cA cpi c2
    cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co cpi c2 cdiv co clt wbr
    w3a wb cc0 cr wcel cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co cA cpi c2 cdiv
    co cmin co elioo2 cc0 rexr cpi c2 cdiv co rexr syl2an mp2an cA cpi c2 cdiv
    co cmin co sincosq1sgn sylbir cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2
    cdiv co cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co
    resubcl mpan2 syl3an1 3expib cA cr wcel cc0 cA cpi c2 cdiv co cmin co clt
    wbr cpi c2 cdiv co cA clt wbr cA cpi c2 cdiv co cmin co cpi c2 cdiv co clt
    wbr cA cpi clt wbr cA cr wcel cc0 cA cpi c2 cdiv co cmin co clt wbr cpi c2
    cdiv co cA cc0 cmin co clt wbr cpi c2 cdiv co cA clt wbr cc0 cr wcel cA cr
    wcel cpi c2 cdiv co cr wcel cc0 cA cpi c2 cdiv co cmin co clt wbr cpi c2
    cdiv co cA cc0 cmin co clt wbr wb 0re cpi c2 pire 2re 2ne0 redivcli cc0 cA
    cpi c2 cdiv co ltsub13 mp3an13 cA cr wcel cA cc0 cmin co cA cpi c2 cdiv co
    clt cA cr wcel cA cc wcel cA cc0 cmin co cA wceq cA recn cA subid1 syl
    breq2d bitrd cA cr wcel cA cpi c2 cdiv co cmin co cpi c2 cdiv co clt wbr cA
    cpi c2 cdiv co cpi c2 cdiv co caddc co clt wbr cA cpi clt wbr cA cr wcel
    cpi c2 cdiv co cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co cmin co cpi
    c2 cdiv co clt wbr cA cpi c2 cdiv co cpi c2 cdiv co caddc co clt wbr wb cpi
    c2 pire 2re 2ne0 redivcli cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co
    cpi c2 cdiv co ltsubadd mp3an23 cpi c2 cdiv co cpi c2 cdiv co caddc co cpi
    cA clt cpi cc wcel cpi c2 cdiv co cpi c2 cdiv co caddc co cpi wceq cpi pire
    recni cpi 2halves ax-mp breq2i syl6bb anbi12d cA cr wcel cc0 cA cpi c2 cdiv
    co cmin co csin cfv clt wbr cA cpi c2 cdiv co cmin co csin cfv cneg cc0 clt
    wbr cc0 cA cpi c2 cdiv co cmin co ccos cfv clt wbr cA cr wcel cA cpi c2
    cdiv co cmin co cr wcel cA cpi c2 cdiv co cmin co csin cfv cr wcel cc0 cA
    cpi c2 cdiv co cmin co csin cfv clt wbr cA cpi c2 cdiv co cmin co csin cfv
    cneg cc0 clt wbr wb cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co
    cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl
    mpan2 cA cpi c2 cdiv co cmin co resincl cA cpi c2 cdiv co cmin co csin cfv
    lt0neg2 3syl anbi1d 3imtr3d cA cr wcel cA ccos cfv cc0 clt wbr cA cpi c2
    cdiv co cmin co csin cfv cneg cc0 clt wbr cc0 cA csin cfv clt wbr cc0 cA
    cpi c2 cdiv co cmin co ccos cfv clt wbr cA cr wcel cA ccos cfv cA cpi c2
    cdiv co cmin co csin cfv cneg cc0 clt cA cr wcel cpi c2 cdiv co cA cpi c2
    cdiv co cmin co caddc co ccos cfv cA ccos cfv cA cpi c2 cdiv co cmin co
    csin cfv cneg cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co
    cA ccos cA cr wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co
    caddc co cA wceq cA recn cpi c2 cdiv co cc wcel cA cc wcel cpi c2 cdiv co
    cA cpi c2 cdiv co cmin co caddc co cA wceq cpi c2 cdiv co cpi c2 pire 2re
    2ne0 redivcli recni cpi c2 cdiv co cA pncan3 mpan syl fveq2d cA cr wcel cA
    cpi c2 cdiv co cmin co cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co
    caddc co ccos cfv cA cpi c2 cdiv co cmin co csin cfv cneg wceq cA cr wcel
    cA cpi c2 cdiv co cmin co cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv
    co cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl
    mpan2 recnd cA cpi c2 cdiv co cmin co coshalfpip syl eqtr3d breq1d cA cr
    wcel cA csin cfv cA cpi c2 cdiv co cmin co ccos cfv cc0 clt cA cr wcel cpi
    c2 cdiv co cA cpi c2 cdiv co cmin co caddc co csin cfv cA csin cfv cA cpi
    c2 cdiv co cmin co ccos cfv cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv co
    cmin co caddc co cA csin cA cr wcel cA cc wcel cpi c2 cdiv co cA cpi c2
    cdiv co cmin co caddc co cA wceq cA recn cpi c2 cdiv co cc wcel cA cc wcel
    cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA wceq cpi c2 cdiv co
    cpi c2 pire 2re 2ne0 redivcli recni cpi c2 cdiv co cA pncan3 mpan syl
    fveq2d cA cr wcel cA cpi c2 cdiv co cmin co cc wcel cpi c2 cdiv co cA cpi
    c2 cdiv co cmin co caddc co csin cfv cA cpi c2 cdiv co cmin co ccos cfv
    wceq cA cr wcel cA cpi c2 cdiv co cmin co cA cr wcel cpi c2 cdiv co cr wcel
    cA cpi c2 cdiv co cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2
    cdiv co resubcl mpan2 recnd cA cpi c2 cdiv co cmin co sinhalfpip syl eqtr3d
    breq2d anbi12d sylibrd 3impib cA ccos cfv cc0 clt wbr cc0 cA csin cfv clt
    wbr ancom sylib sylbi $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The signs of the sine and cosine functions in the third quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq3sgn $p |- ( A e. ( pi (,) ( 3 x. ( pi / 2 ) ) ) ->
                      ( ( sin ` A ) < 0 /\ ( cos ` A ) < 0 ) ) $=
    cA cpi c3 cpi c2 cdiv co cmul co cioo co wcel cA cr wcel cpi cA clt wbr cA
    c3 cpi c2 cdiv co cmul co clt wbr w3a cA csin cfv cc0 clt wbr cA ccos cfv
    cc0 clt wbr wa cpi cr wcel c3 cpi c2 cdiv co cmul co cr wcel cA cpi c3 cpi
    c2 cdiv co cmul co cioo co wcel cA cr wcel cpi cA clt wbr cA c3 cpi c2 cdiv
    co cmul co clt wbr w3a wb pire c3 cpi c2 cdiv co 3re cpi c2 pire 2re 2ne0
    redivcli remulcli cpi cxr wcel c3 cpi c2 cdiv co cmul co cxr wcel cA cpi c3
    cpi c2 cdiv co cmul co cioo co wcel cA cr wcel cpi cA clt wbr cA c3 cpi c2
    cdiv co cmul co clt wbr w3a wb cpi cr wcel c3 cpi c2 cdiv co cmul co cr
    wcel cpi c3 cpi c2 cdiv co cmul co cA elioo2 cpi rexr c3 cpi c2 cdiv co
    cmul co rexr syl2an mp2an cA cr wcel cpi cA clt wbr cA c3 cpi c2 cdiv co
    cmul co clt wbr cA csin cfv cc0 clt wbr cA ccos cfv cc0 clt wbr wa cA cr
    wcel cpi cA clt wbr cA c3 cpi c2 cdiv co cmul co clt wbr wa cA cpi c2 cdiv
    co cmin co ccos cfv cc0 clt wbr cA cpi c2 cdiv co cmin co csin cfv cneg cc0
    clt wbr wa cA csin cfv cc0 clt wbr cA ccos cfv cc0 clt wbr wa cA cr wcel
    cpi cA clt wbr cA c3 cpi c2 cdiv co cmul co clt wbr wa cA cpi c2 cdiv co
    cmin co ccos cfv cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co csin cfv clt wbr
    wa cA cpi c2 cdiv co cmin co ccos cfv cc0 clt wbr cA cpi c2 cdiv co cmin co
    csin cfv cneg cc0 clt wbr wa cA cr wcel cpi cA clt wbr cA c3 cpi c2 cdiv co
    cmul co clt wbr wa cpi c2 cdiv co cA cpi c2 cdiv co cmin co clt wbr cA cpi
    c2 cdiv co cmin co cpi clt wbr wa cA cpi c2 cdiv co cmin co ccos cfv cc0
    clt wbr cc0 cA cpi c2 cdiv co cmin co csin cfv clt wbr wa cA cr wcel cpi cA
    clt wbr cpi c2 cdiv co cA cpi c2 cdiv co cmin co clt wbr cA c3 cpi c2 cdiv
    co cmul co clt wbr cA cpi c2 cdiv co cmin co cpi clt wbr cA cr wcel cpi c2
    cdiv co cpi c2 cdiv co caddc co cA clt wbr cpi c2 cdiv co cA cpi c2 cdiv co
    cmin co clt wbr cpi cA clt wbr cpi c2 cdiv co cr wcel cpi c2 cdiv co cr
    wcel cA cr wcel cpi c2 cdiv co cpi c2 cdiv co caddc co cA clt wbr cpi c2
    cdiv co cA cpi c2 cdiv co cmin co clt wbr wb cpi c2 pire 2re 2ne0 redivcli
    cpi c2 pire 2re 2ne0 redivcli cpi c2 cdiv co cpi c2 cdiv co cA ltaddsub
    mp3an12 cpi c2 cdiv co cpi c2 cdiv co caddc co cpi cA clt cpi cc wcel cpi
    c2 cdiv co cpi c2 cdiv co caddc co cpi wceq cpi pire recni cpi 2halves
    ax-mp breq1i syl5bbr cA cr wcel cA cpi c2 cdiv co cmin co cpi clt wbr cA
    cpi cpi c2 cdiv co caddc co clt wbr cA c3 cpi c2 cdiv co cmul co clt wbr cA
    cr wcel cpi c2 cdiv co cr wcel cpi cr wcel cA cpi c2 cdiv co cmin co cpi
    clt wbr cA cpi cpi c2 cdiv co caddc co clt wbr wb cpi c2 pire 2re 2ne0
    redivcli pire cA cpi c2 cdiv co cpi ltsubadd mp3an23 cpi cpi c2 cdiv co
    caddc co c3 cpi c2 cdiv co cmul co cA clt c3 cpi c2 cdiv co cmul co c2 c1
    caddc co cpi c2 cdiv co cmul co c2 cpi c2 cdiv co cmul co c1 cpi c2 cdiv co
    cmul co caddc co cpi cpi c2 cdiv co caddc co c3 c2 c1 caddc co cpi c2 cdiv
    co cmul df-3 opreq1i c2 c1 cpi c2 cdiv co 2cn ax1cn cpi c2 cdiv co cpi c2
    pire 2re 2ne0 redivcli recni adddiri c2 cpi c2 cdiv co cmul co cpi c1 cpi
    c2 cdiv co cmul co cpi c2 cdiv co caddc cpi c2 cpi pire recni 2cn 2ne0
    divcan2i cpi c2 cdiv co cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni
    mulid2i opreq12i 3eqtrri breq2i syl6rbb anbi12d cA cr wcel cpi c2 cdiv co
    cA cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co cpi clt wbr cA
    cpi c2 cdiv co cmin co ccos cfv cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co
    csin cfv clt wbr wa cA cpi c2 cdiv co cmin co cr wcel cpi c2 cdiv co cA cpi
    c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co cpi clt wbr cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co csin cfv
    clt wbr wa cA cr wcel cA cpi c2 cdiv co cmin co cpi c2 cdiv co cpi cioo co
    wcel cc0 cA cpi c2 cdiv co cmin co csin cfv clt wbr cA cpi c2 cdiv co cmin
    co ccos cfv cc0 clt wbr wa cA cpi c2 cdiv co cmin co cr wcel cpi c2 cdiv co
    cA cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co cpi clt wbr w3a
    cA cpi c2 cdiv co cmin co ccos cfv cc0 clt wbr cc0 cA cpi c2 cdiv co cmin
    co csin cfv clt wbr wa cA cpi c2 cdiv co cmin co sincosq2sgn cpi c2 cdiv co
    cr wcel cpi cr wcel cA cpi c2 cdiv co cmin co cpi c2 cdiv co cpi cioo co
    wcel cA cpi c2 cdiv co cmin co cr wcel cpi c2 cdiv co cA cpi c2 cdiv co
    cmin co clt wbr cA cpi c2 cdiv co cmin co cpi clt wbr w3a wb cpi c2 pire
    2re 2ne0 redivcli pire cpi c2 cdiv co cxr wcel cpi cxr wcel cA cpi c2 cdiv
    co cmin co cpi c2 cdiv co cpi cioo co wcel cA cpi c2 cdiv co cmin co cr
    wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co
    cmin co cpi clt wbr w3a wb cpi c2 cdiv co cr wcel cpi cr wcel cpi c2 cdiv
    co cpi cA cpi c2 cdiv co cmin co elioo2 cpi c2 cdiv co rexr cpi rexr syl2an
    mp2an cc0 cA cpi c2 cdiv co cmin co csin cfv clt wbr cA cpi c2 cdiv co cmin
    co ccos cfv cc0 clt wbr ancom 3imtr3i cA cr wcel cpi c2 cdiv co cr wcel cA
    cpi c2 cdiv co cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv
    co resubcl mpan2 syl3an1 3expib sylbid cA cr wcel cc0 cA cpi c2 cdiv co
    cmin co csin cfv clt wbr cA cpi c2 cdiv co cmin co csin cfv cneg cc0 clt
    wbr cA cpi c2 cdiv co cmin co ccos cfv cc0 clt wbr cA cr wcel cA cpi c2
    cdiv co cmin co cr wcel cA cpi c2 cdiv co cmin co csin cfv cr wcel cc0 cA
    cpi c2 cdiv co cmin co csin cfv clt wbr cA cpi c2 cdiv co cmin co csin cfv
    cneg cc0 clt wbr wb cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co
    cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl
    mpan2 cA cpi c2 cdiv co cmin co resincl cA cpi c2 cdiv co cmin co csin cfv
    lt0neg2 3syl anbi2d sylibd cA cr wcel cA csin cfv cc0 clt wbr cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt wbr cA ccos cfv cc0 clt wbr cA cpi c2 cdiv
    co cmin co csin cfv cneg cc0 clt wbr cA cr wcel cA csin cfv cA cpi c2 cdiv
    co cmin co ccos cfv cc0 clt cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv co
    cmin co caddc co csin cfv cA csin cfv cA cpi c2 cdiv co cmin co ccos cfv cA
    cr wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA csin cA cr
    wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA wceq
    cA recn cpi c2 cdiv co cc wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co
    cmin co caddc co cA wceq cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni
    cpi c2 cdiv co cA pncan3 mpan syl fveq2d cA cr wcel cA cpi c2 cdiv co cmin
    co cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co csin cfv cA
    cpi c2 cdiv co cmin co ccos cfv wceq cA cr wcel cA cpi c2 cdiv co cmin co
    cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co cmin co cr wcel cpi c2
    pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl mpan2 recnd cA cpi c2 cdiv
    co cmin co sinhalfpip syl eqtr3d breq1d cA cr wcel cA ccos cfv cA cpi c2
    cdiv co cmin co csin cfv cneg cc0 clt cA cr wcel cpi c2 cdiv co cA cpi c2
    cdiv co cmin co caddc co ccos cfv cA ccos cfv cA cpi c2 cdiv co cmin co
    csin cfv cneg cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co
    cA ccos cA cr wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co
    caddc co cA wceq cA recn cpi c2 cdiv co cc wcel cA cc wcel cpi c2 cdiv co
    cA cpi c2 cdiv co cmin co caddc co cA wceq cpi c2 cdiv co cpi c2 pire 2re
    2ne0 redivcli recni cpi c2 cdiv co cA pncan3 mpan syl fveq2d cA cr wcel cA
    cpi c2 cdiv co cmin co cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co
    caddc co ccos cfv cA cpi c2 cdiv co cmin co csin cfv cneg wceq cA cr wcel
    cA cpi c2 cdiv co cmin co cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv
    co cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl
    mpan2 recnd cA cpi c2 cdiv co cmin co coshalfpip syl eqtr3d breq1d anbi12d
    sylibrd 3impib sylbi $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The signs of the sine and cosine functions in the fourth quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq4sgn $p |- ( A e. ( ( 3 x. ( pi / 2 ) ) (,) ( 2 x. pi ) ) ->
                      ( ( sin ` A ) < 0 /\ 0 < ( cos ` A ) ) ) $=
    cA c3 cpi c2 cdiv co cmul co c2 cpi cmul co cioo co wcel cA cr wcel c3 cpi
    c2 cdiv co cmul co cA clt wbr cA c2 cpi cmul co clt wbr w3a cA csin cfv cc0
    clt wbr cc0 cA ccos cfv clt wbr wa c3 cpi c2 cdiv co cmul co cr wcel c2 cpi
    cmul co cr wcel cA c3 cpi c2 cdiv co cmul co c2 cpi cmul co cioo co wcel cA
    cr wcel c3 cpi c2 cdiv co cmul co cA clt wbr cA c2 cpi cmul co clt wbr w3a
    wb c3 cpi c2 cdiv co 3re cpi c2 pire 2re 2ne0 redivcli remulcli c2 cpi 2re
    pire remulcli c3 cpi c2 cdiv co cmul co cxr wcel c2 cpi cmul co cxr wcel cA
    c3 cpi c2 cdiv co cmul co c2 cpi cmul co cioo co wcel cA cr wcel c3 cpi c2
    cdiv co cmul co cA clt wbr cA c2 cpi cmul co clt wbr w3a wb c3 cpi c2 cdiv
    co cmul co cr wcel c2 cpi cmul co cr wcel c3 cpi c2 cdiv co cmul co c2 cpi
    cmul co cA elioo2 c3 cpi c2 cdiv co cmul co rexr c2 cpi cmul co rexr syl2an
    mp2an cA cr wcel c3 cpi c2 cdiv co cmul co cA clt wbr cA c2 cpi cmul co clt
    wbr w3a cc0 cA ccos cfv clt wbr cA csin cfv cc0 clt wbr wa cA csin cfv cc0
    clt wbr cc0 cA ccos cfv clt wbr wa cA cr wcel c3 cpi c2 cdiv co cmul co cA
    clt wbr cA c2 cpi cmul co clt wbr cc0 cA ccos cfv clt wbr cA csin cfv cc0
    clt wbr wa cA cr wcel c3 cpi c2 cdiv co cmul co cA clt wbr cA c2 cpi cmul
    co clt wbr wa cc0 cA cpi c2 cdiv co cmin co csin cfv cneg clt wbr cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt wbr wa cc0 cA ccos cfv clt wbr cA csin cfv
    cc0 clt wbr wa cA cr wcel c3 cpi c2 cdiv co cmul co cA clt wbr cA c2 cpi
    cmul co clt wbr wa cA cpi c2 cdiv co cmin co csin cfv cc0 clt wbr cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt wbr wa cc0 cA cpi c2 cdiv co cmin co csin
    cfv cneg clt wbr cA cpi c2 cdiv co cmin co ccos cfv cc0 clt wbr wa cA cr
    wcel c3 cpi c2 cdiv co cmul co cA clt wbr cA c2 cpi cmul co clt wbr wa cpi
    cA cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv
    co cmul co clt wbr wa cA cpi c2 cdiv co cmin co csin cfv cc0 clt wbr cA cpi
    c2 cdiv co cmin co ccos cfv cc0 clt wbr wa cA cr wcel c3 cpi c2 cdiv co
    cmul co cA clt wbr cpi cA cpi c2 cdiv co cmin co clt wbr cA c2 cpi cmul co
    clt wbr cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv co cmul co clt wbr cA cr
    wcel cpi cpi c2 cdiv co caddc co cA clt wbr cpi cA cpi c2 cdiv co cmin co
    clt wbr c3 cpi c2 cdiv co cmul co cA clt wbr cpi cr wcel cpi c2 cdiv co cr
    wcel cA cr wcel cpi cpi c2 cdiv co caddc co cA clt wbr cpi cA cpi c2 cdiv
    co cmin co clt wbr wb pire cpi c2 pire 2re 2ne0 redivcli cpi cpi c2 cdiv co
    cA ltaddsub mp3an12 cpi cpi c2 cdiv co caddc co c3 cpi c2 cdiv co cmul co
    cA clt c3 cpi c2 cdiv co cmul co c2 c1 caddc co cpi c2 cdiv co cmul co c2
    cpi c2 cdiv co cmul co c1 cpi c2 cdiv co cmul co caddc co cpi cpi c2 cdiv
    co caddc co c3 c2 c1 caddc co cpi c2 cdiv co cmul df-3 opreq1i c2 c1 cpi c2
    cdiv co 2cn ax1cn cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni
    adddiri c2 cpi c2 cdiv co cmul co cpi c1 cpi c2 cdiv co cmul co cpi c2 cdiv
    co caddc cpi c2 cpi pire recni 2cn 2ne0 divcan2i cpi c2 cdiv co cpi c2 cdiv
    co cpi c2 pire 2re 2ne0 redivcli recni mulid2i opreq12i 3eqtrri breq1i
    syl5bbr cA cr wcel cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv co cmul co clt
    wbr cA c3 cpi c2 cdiv co cmul co cpi c2 cdiv co caddc co clt wbr cA c2 cpi
    cmul co clt wbr cA cr wcel cpi c2 cdiv co cr wcel c3 cpi c2 cdiv co cmul co
    cr wcel cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv co cmul co clt wbr cA c3
    cpi c2 cdiv co cmul co cpi c2 cdiv co caddc co clt wbr wb cpi c2 pire 2re
    2ne0 redivcli c3 cpi c2 cdiv co 3re cpi c2 pire 2re 2ne0 redivcli remulcli
    cA cpi c2 cdiv co c3 cpi c2 cdiv co cmul co ltsubadd mp3an23 c3 cpi c2 cdiv
    co cmul co cpi c2 cdiv co caddc co c2 cpi cmul co cA clt c3 cpi c2 cdiv co
    cmul co cpi c2 cdiv co caddc co c4 cpi c2 cdiv co cmul co c2 cpi cmul co c4
    cpi c2 cdiv co cmul co c3 c1 caddc co cpi c2 cdiv co cmul co c3 cpi c2 cdiv
    co cmul co c1 cpi c2 cdiv co cmul co caddc co c3 cpi c2 cdiv co cmul co cpi
    c2 cdiv co caddc co c4 c3 c1 caddc co cpi c2 cdiv co cmul df-4 opreq1i c3
    c1 cpi c2 cdiv co c3 3re recni ax1cn cpi c2 cdiv co cpi c2 pire 2re 2ne0
    redivcli recni adddiri c1 cpi c2 cdiv co cmul co cpi c2 cdiv co c3 cpi c2
    cdiv co cmul co caddc cpi c2 cdiv co cpi c2 cdiv co cpi c2 pire 2re 2ne0
    redivcli recni mulid2i opreq2i 3eqtrri c4 cpi c2 cdiv co cmul co cpi c4 c2
    cdiv co cmul co cpi c2 cmul co c2 cpi cmul co c4 cc wcel cpi cc wcel c2 cc
    wcel c2 cc0 wne wa c4 cpi c2 cdiv co cmul co cpi c4 c2 cdiv co cmul co wceq
    c4 4re recni cpi pire recni c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i c4 cpi c2
    div12 mp3an c4 c2 cdiv co c2 cpi cmul 4d2e2 opreq2i cpi c2 cpi pire recni
    2cn mulcomi 3eqtri eqtri breq2i syl6rbb anbi12d cA cr wcel cpi cA cpi c2
    cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv co cmul co
    clt wbr cA cpi c2 cdiv co cmin co csin cfv cc0 clt wbr cA cpi c2 cdiv co
    cmin co ccos cfv cc0 clt wbr wa cA cpi c2 cdiv co cmin co cr wcel cpi cA
    cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv co
    cmul co clt wbr cA cpi c2 cdiv co cmin co csin cfv cc0 clt wbr cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt wbr wa cA cr wcel cA cpi c2 cdiv co cmin
    co cr wcel cpi cA cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co
    c3 cpi c2 cdiv co cmul co clt wbr w3a cA cpi c2 cdiv co cmin co cpi c3 cpi
    c2 cdiv co cmul co cioo co wcel cA cpi c2 cdiv co cmin co csin cfv cc0 clt
    wbr cA cpi c2 cdiv co cmin co ccos cfv cc0 clt wbr wa cpi cr wcel c3 cpi c2
    cdiv co cmul co cr wcel cA cpi c2 cdiv co cmin co cpi c3 cpi c2 cdiv co
    cmul co cioo co wcel cA cpi c2 cdiv co cmin co cr wcel cpi cA cpi c2 cdiv
    co cmin co clt wbr cA cpi c2 cdiv co cmin co c3 cpi c2 cdiv co cmul co clt
    wbr w3a wb pire c3 cpi c2 cdiv co 3re cpi c2 pire 2re 2ne0 redivcli
    remulcli cpi cxr wcel c3 cpi c2 cdiv co cmul co cxr wcel cA cpi c2 cdiv co
    cmin co cpi c3 cpi c2 cdiv co cmul co cioo co wcel cA cpi c2 cdiv co cmin
    co cr wcel cpi cA cpi c2 cdiv co cmin co clt wbr cA cpi c2 cdiv co cmin co
    c3 cpi c2 cdiv co cmul co clt wbr w3a wb cpi cr wcel c3 cpi c2 cdiv co cmul
    co cr wcel cpi c3 cpi c2 cdiv co cmul co cA cpi c2 cdiv co cmin co elioo2
    cpi rexr c3 cpi c2 cdiv co cmul co rexr syl2an mp2an cA cpi c2 cdiv co cmin
    co sincosq3sgn sylbir cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co
    cmin co cr wcel cpi c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl
    mpan2 syl3an1 3expib sylbid cA cr wcel cA cpi c2 cdiv co cmin co csin cfv
    cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co csin cfv cneg clt wbr cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt wbr cA cr wcel cA cpi c2 cdiv co cmin co
    cr wcel cA cpi c2 cdiv co cmin co csin cfv cr wcel cA cpi c2 cdiv co cmin
    co csin cfv cc0 clt wbr cc0 cA cpi c2 cdiv co cmin co csin cfv cneg clt wbr
    wb cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co cmin co cr wcel cpi
    c2 pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl mpan2 cA cpi c2 cdiv co
    cmin co resincl cA cpi c2 cdiv co cmin co csin cfv lt0neg1 3syl anbi1d
    sylibd cA cr wcel cc0 cA ccos cfv clt wbr cc0 cA cpi c2 cdiv co cmin co
    csin cfv cneg clt wbr cA csin cfv cc0 clt wbr cA cpi c2 cdiv co cmin co
    ccos cfv cc0 clt wbr cA cr wcel cA ccos cfv cA cpi c2 cdiv co cmin co csin
    cfv cneg cc0 clt cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc
    co ccos cfv cA ccos cfv cA cpi c2 cdiv co cmin co csin cfv cneg cA cr wcel
    cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA ccos cA cr wcel cA cc
    wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA wceq cA recn cpi
    c2 cdiv co cc wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co
    caddc co cA wceq cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni cpi c2
    cdiv co cA pncan3 mpan syl fveq2d cA cr wcel cA cpi c2 cdiv co cmin co cc
    wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co ccos cfv cA cpi c2
    cdiv co cmin co csin cfv cneg wceq cA cr wcel cA cpi c2 cdiv co cmin co cA
    cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co cmin co cr wcel cpi c2
    pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl mpan2 recnd cA cpi c2 cdiv
    co cmin co coshalfpip syl eqtr3d breq2d cA cr wcel cA csin cfv cA cpi c2
    cdiv co cmin co ccos cfv cc0 clt cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv
    co cmin co caddc co csin cfv cA csin cfv cA cpi c2 cdiv co cmin co ccos cfv
    cA cr wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA csin cA cr
    wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co cA wceq
    cA recn cpi c2 cdiv co cc wcel cA cc wcel cpi c2 cdiv co cA cpi c2 cdiv co
    cmin co caddc co cA wceq cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni
    cpi c2 cdiv co cA pncan3 mpan syl fveq2d cA cr wcel cA cpi c2 cdiv co cmin
    co cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmin co caddc co csin cfv cA
    cpi c2 cdiv co cmin co ccos cfv wceq cA cr wcel cA cpi c2 cdiv co cmin co
    cA cr wcel cpi c2 cdiv co cr wcel cA cpi c2 cdiv co cmin co cr wcel cpi c2
    pire 2re 2ne0 redivcli cA cpi c2 cdiv co resubcl mpan2 recnd cA cpi c2 cdiv
    co cmin co sinhalfpip syl eqtr3d breq1d anbi12d sylibrd 3impib cc0 cA ccos
    cfv clt wbr cA csin cfv cc0 clt wbr ancom sylib sylbi $.
    $( [24-Jan-2008] $) $( [24-Jan-2008] $)

  $( The sine of a number strictly between ` 0 ` and ` pi ` is positive.
     (Contributed by Paul Chapman, 15-Mar-2008.) $)
  sinq12gt0t $p |- ( A e. ( 0 (,) pi ) -> 0 < ( sin ` A ) ) $=
    cA cc0 cpi cioo co wcel cA cr wcel cc0 cA clt wbr cA cpi clt wbr w3a cc0 cA
    csin cfv clt wbr cc0 cr wcel cpi cr wcel cA cc0 cpi cioo co wcel cA cr wcel
    cc0 cA clt wbr cA cpi clt wbr w3a wb 0re pire cc0 cxr wcel cpi cxr wcel cA
    cc0 cpi cioo co wcel cA cr wcel cc0 cA clt wbr cA cpi clt wbr w3a wb cc0 cr
    wcel cpi cr wcel cc0 cpi cA elioo2 cc0 rexr cpi rexr syl2an mp2an cA cr
    wcel cc0 cA clt wbr cA cpi clt wbr w3a cc0 c2 cA c2 cdiv co csin cfv cA c2
    cdiv co ccos cfv cmul co cmul co cA csin cfv clt cA cr wcel cc0 cA clt wbr
    cA cpi clt wbr w3a cc0 cA c2 cdiv co csin cfv clt wbr cc0 cA c2 cdiv co
    ccos cfv clt wbr cc0 c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul
    co cmul co clt wbr cA c2 cdiv co cr wcel cc0 cA c2 cdiv co clt wbr cA c2
    cdiv co cpi c2 cdiv co clt wbr cc0 cA c2 cdiv co csin cfv clt wbr cA cr
    wcel cc0 cA clt wbr cA cpi clt wbr w3a cA c2 cdiv co sincosq1lem cA cr wcel
    cc0 cA clt wbr cA c2 cdiv co cr wcel cA cpi clt wbr cA rehalfcl 3ad2ant1 cA
    cr wcel cc0 cA clt wbr cc0 cA c2 cdiv co clt wbr cA cpi clt wbr cA cr wcel
    cc0 cA clt wbr cc0 cA c2 cdiv co clt wbr cA halfpos2 biimpa 3adant3 cA cr
    wcel cc0 cA clt wbr cA cpi clt wbr cA c2 cdiv co cpi c2 cdiv co clt wbr cA
    cr wcel cA cpi clt wbr cA c2 cdiv co cpi c2 cdiv co clt wbr wb cc0 cA clt
    wbr cA cr wcel cpi cr wcel c2 cr wcel cA cpi clt wbr cA c2 cdiv co cpi c2
    cdiv co clt wbr wb pire 2re cA cr wcel cpi cr wcel c2 cr wcel w3a cc0 c2
    clt wbr cA cpi clt wbr cA c2 cdiv co cpi c2 cdiv co clt wbr wb 2pos cA cpi
    c2 ltdiv1OLD mpan2 mp3an23 adantr biimp3a syl3anc cA cr wcel cc0 cA clt wbr
    cA cpi clt wbr w3a cc0 cpi cA cmin co c2 cdiv co csin cfv cA c2 cdiv co
    ccos cfv clt cpi cA cmin co c2 cdiv co cr wcel cc0 cpi cA cmin co c2 cdiv
    co clt wbr cpi cA cmin co c2 cdiv co cpi c2 cdiv co clt wbr cc0 cpi cA cmin
    co c2 cdiv co csin cfv clt wbr cA cr wcel cc0 cA clt wbr cA cpi clt wbr w3a
    cpi cA cmin co c2 cdiv co sincosq1lem cA cr wcel cc0 cA clt wbr cpi cA cmin
    co c2 cdiv co cr wcel cA cpi clt wbr cA cr wcel cpi cA cmin co cr wcel cpi
    cA cmin co c2 cdiv co cr wcel cpi cr wcel cA cr wcel cpi cA cmin co cr wcel
    pire cpi cA resubcl mpan cpi cA cmin co rehalfcl syl 3ad2ant1 cA cr wcel
    cc0 cA clt wbr cA cpi clt wbr cc0 cpi cA cmin co c2 cdiv co clt wbr cA cr
    wcel cA cpi clt wbr cc0 cpi cA cmin co c2 cdiv co clt wbr wb cc0 cA clt wbr
    cA cr wcel cA cpi clt wbr cc0 cpi cA cmin co clt wbr cc0 cpi cA cmin co c2
    cdiv co clt wbr cA cr wcel cpi cr wcel cA cpi clt wbr cc0 cpi cA cmin co
    clt wbr wb pire cA cpi posdif mpan2 cA cr wcel cpi cA cmin co cr wcel cc0
    cpi cA cmin co clt wbr cc0 cpi cA cmin co c2 cdiv co clt wbr wb cpi cr wcel
    cA cr wcel cpi cA cmin co cr wcel pire cpi cA resubcl mpan cpi cA cmin co
    halfpos2 syl bitrd adantr biimp3a cA cr wcel cc0 cA clt wbr cpi cA cmin co
    c2 cdiv co cpi c2 cdiv co clt wbr cA cpi clt wbr cA cr wcel cc0 cA clt wbr
    cpi cA cmin co c2 cdiv co cpi c2 cdiv co clt wbr cA cr wcel cc0 cA clt wbr
    cpi cA cmin co cpi clt wbr cpi cA cmin co c2 cdiv co cpi c2 cdiv co clt wbr
    cA cr wcel cpi cr wcel cc0 cA clt wbr cpi cA cmin co cpi clt wbr wb pire cA
    cpi ltsubpos mpan2 cA cr wcel cpi cA cmin co cr wcel cpi cA cmin co cpi clt
    wbr cpi cA cmin co c2 cdiv co cpi c2 cdiv co clt wbr wb cpi cr wcel cA cr
    wcel cpi cA cmin co cr wcel pire cpi cA resubcl mpan cpi cA cmin co cr wcel
    cpi cr wcel c2 cr wcel cpi cA cmin co cpi clt wbr cpi cA cmin co c2 cdiv co
    cpi c2 cdiv co clt wbr wb pire 2re cpi cA cmin co cr wcel cpi cr wcel c2 cr
    wcel w3a cc0 c2 clt wbr cpi cA cmin co cpi clt wbr cpi cA cmin co c2 cdiv
    co cpi c2 cdiv co clt wbr wb 2pos cpi cA cmin co cpi c2 ltdiv1OLD mpan2
    mp3an23 syl bitrd biimpa 3adant3 syl3anc cA cr wcel cc0 cA clt wbr cpi cA
    cmin co c2 cdiv co csin cfv cA c2 cdiv co ccos cfv wceq cA cpi clt wbr cA
    cr wcel cpi cA cmin co c2 cdiv co csin cfv cpi c2 cdiv co cA c2 cdiv co
    cmin co csin cfv cA c2 cdiv co ccos cfv cA cr wcel cpi cA cmin co c2 cdiv
    co cpi c2 cdiv co cA c2 cdiv co cmin co csin cA cr wcel cA cc wcel cpi cA
    cmin co c2 cdiv co cpi c2 cdiv co cA c2 cdiv co cmin co wceq cA recn cpi cc
    wcel cA cc wcel c2 cc wcel c2 cc0 wne wa cpi cA cmin co c2 cdiv co cpi c2
    cdiv co cA c2 cdiv co cmin co wceq cpi pire recni c2 cc wcel c2 cc0 wne 2cn
    2ne0 pm3.2i cpi cA c2 divsubdir mp3an13 syl fveq2d cA cr wcel cA c2 cdiv co
    cc wcel cpi c2 cdiv co cA c2 cdiv co cmin co csin cfv cA c2 cdiv co ccos
    cfv wceq cA cr wcel cA c2 cdiv co cA rehalfcl recnd cA c2 cdiv co
    sinhalfpim syl eqtrd 3ad2ant1 breqtrd cA cr wcel cc0 cA clt wbr cc0 cA c2
    cdiv co csin cfv clt wbr cc0 cA c2 cdiv co ccos cfv clt wbr wa cc0 c2 cA c2
    cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cmul co clt wbr wi cA cpi
    clt wbr cA cr wcel cc0 cA c2 cdiv co csin cfv clt wbr cc0 cA c2 cdiv co
    ccos cfv clt wbr wa cc0 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul
    co clt wbr cc0 c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co
    cmul co clt wbr cA cr wcel cA c2 cdiv co cr wcel cA c2 cdiv co csin cfv cr
    wcel cA c2 cdiv co ccos cfv cr wcel wa cc0 cA c2 cdiv co csin cfv clt wbr
    cc0 cA c2 cdiv co ccos cfv clt wbr wa cc0 cA c2 cdiv co csin cfv cA c2 cdiv
    co ccos cfv cmul co clt wbr wi cA rehalfcl cA c2 cdiv co cr wcel cA c2 cdiv
    co csin cfv cr wcel cA c2 cdiv co ccos cfv cr wcel cA c2 cdiv co resincl cA
    c2 cdiv co recoscl jca cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv
    axmulgt0 3syl cA cr wcel cc0 c2 clt wbr cc0 cA c2 cdiv co csin cfv cA c2
    cdiv co ccos cfv cmul co clt wbr cc0 c2 cA c2 cdiv co csin cfv cA c2 cdiv
    co ccos cfv cmul co cmul co clt wbr 2pos cA cr wcel cA c2 cdiv co csin cfv
    cA c2 cdiv co ccos cfv cmul co cr wcel cc0 c2 clt wbr cc0 cA c2 cdiv co
    csin cfv cA c2 cdiv co ccos cfv cmul co clt wbr wa cc0 c2 cA c2 cdiv co
    csin cfv cA c2 cdiv co ccos cfv cmul co cmul co clt wbr wi cA cr wcel cA c2
    cdiv co cr wcel cA c2 cdiv co csin cfv cr wcel cA c2 cdiv co ccos cfv cr
    wcel wa cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cr wcel cA
    rehalfcl cA c2 cdiv co cr wcel cA c2 cdiv co csin cfv cr wcel cA c2 cdiv co
    ccos cfv cr wcel cA c2 cdiv co resincl cA c2 cdiv co recoscl jca cA c2 cdiv
    co csin cfv cA c2 cdiv co ccos cfv remulcl 3syl c2 cr wcel cA c2 cdiv co
    csin cfv cA c2 cdiv co ccos cfv cmul co cr wcel cc0 c2 clt wbr cc0 cA c2
    cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co clt wbr wa cc0 c2 cA c2
    cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cmul co clt wbr wi 2re c2
    cA c2 cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co axmulgt0 mpan syl
    mpani syld 3ad2ant1 mp2and cA cr wcel cc0 cA clt wbr cA csin cfv c2 cA c2
    cdiv co csin cfv cA c2 cdiv co ccos cfv cmul co cmul co wceq cA cpi clt wbr
    cA cr wcel c2 cA c2 cdiv co cmul co csin cfv cA csin cfv c2 cA c2 cdiv co
    csin cfv cA c2 cdiv co ccos cfv cmul co cmul co cA cr wcel c2 cA c2 cdiv co
    cmul co cA csin cA cr wcel cA cc wcel c2 cA c2 cdiv co cmul co cA wceq cA
    recn cA cc wcel c2 cc wcel c2 cc0 wne c2 cA c2 cdiv co cmul co cA wceq 2cn
    2ne0 cA c2 divcan2 mp3an23 syl fveq2d cA cr wcel cA c2 cdiv co cc wcel c2
    cA c2 cdiv co cmul co csin cfv c2 cA c2 cdiv co csin cfv cA c2 cdiv co ccos
    cfv cmul co cmul co wceq cA cr wcel cA c2 cdiv co cA rehalfcl recnd cA c2
    cdiv co sin2t syl eqtr3d 3ad2ant1 breqtrrd sylbi $.
    $( [15-Mar-2008] $) $( [15-Mar-2008] $)

  $( The sine of a number strictly between ` pi ` and ` 2 x. pi ` is
     negative. $)
  sinq34lt0t $p |- ( A e. ( pi (,) ( 2 x. pi ) ) -> ( sin ` A ) < 0 ) $=
    cA cpi c2 cpi cmul co cioo co wcel cA csin cfv cc0 clt wbr cc0 cA csin cfv
    cneg clt wbr cA cpi c2 cpi cmul co cioo co wcel cc0 cA cpi cmin co csin cfv
    cA csin cfv cneg clt cA cpi c2 cpi cmul co cioo co wcel cA cpi cmin co cc0
    cpi cioo co wcel cc0 cA cpi cmin co csin cfv clt wbr cA cpi c2 cpi cmul co
    cioo co wcel cA cpi cmin co cc0 cpi cioo co wcel cA cpi c2 cpi cmul co cioo
    co wcel cA cr wcel cA cpi c2 cpi cmul co cioo co wcel cA cpi cmin co cc0
    cpi cioo co wcel wb cA cpi c2 cpi cmul co elioore cA cr wcel cA cpi cmin co
    cc0 cpi cioo co wcel cA cc0 cpi caddc co cpi cpi caddc co cioo co wcel cA
    cpi c2 cpi cmul co cioo co wcel cA cr wcel cpi cr wcel cA cpi cmin co cc0
    cpi cioo co wcel cA cc0 cpi caddc co cpi cpi caddc co cioo co wcel wb pire
    cA cr wcel cpi cr wcel wa cc0 cr wcel cpi cr wcel cA cpi cmin co cc0 cpi
    cioo co wcel cA cc0 cpi caddc co cpi cpi caddc co cioo co wcel wb 0re pire
    cA cpi cc0 cpi iooshf mpanr12 mpan2 cpi c2 cpi cmul co cioo co cc0 cpi
    caddc co cpi cpi caddc co cioo co cA cpi cc0 cpi caddc co c2 cpi cmul co
    cpi cpi caddc co cioo cc0 cpi caddc co cpi cpi cpi pire recni addid2i
    eqcomi cpi cpi pire recni 2timesi opreq12i eleq2i syl6rbbr syl ibi cA cpi
    cmin co sinq12gt0t syl cA cpi c2 cpi cmul co cioo co wcel cA cc wcel cA cpi
    cmin co csin cfv cA csin cfv cneg wceq cA cpi c2 cpi cmul co cioo co wcel
    cA cA cpi c2 cpi cmul co elioore recnd cA sinmpi syl breqtrd cA cpi c2 cpi
    cmul co cioo co wcel cA csin cfv cr wcel cA csin cfv cc0 clt wbr cc0 cA
    csin cfv cneg clt wbr wb cA cpi c2 cpi cmul co cioo co wcel cA cr wcel cA
    csin cfv cr wcel cA cpi c2 cpi cmul co elioore cA resincl syl cA csin cfv
    lt0neg1 syl mpbird $.
    $( [18-Jan-2009] $) $( [17-Aug-2008] $)

  $( Complementarity of the sine and cosine functions in the first quadrant.
     (Contributed by Paul Chapman, 25-Jan-2008.) $)
  sincosq1eq $p |- ( ( A e. CC /\ B e. CC /\ ( A + B ) = 1 ) ->
           ( sin ` ( A x. ( pi / 2 ) ) ) = ( cos ` ( B x. ( pi / 2 ) ) ) ) $=
    cA cc wcel cB cc wcel cA cB caddc co c1 wceq w3a cpi c2 cdiv co cA cpi c2
    cdiv co cmul co cmin co ccos cfv cA cpi c2 cdiv co cmul co csin cfv cB cpi
    c2 cdiv co cmul co ccos cfv cA cc wcel cB cc wcel cpi c2 cdiv co cA cpi c2
    cdiv co cmul co cmin co ccos cfv cA cpi c2 cdiv co cmul co csin cfv wceq cA
    cB caddc co c1 wceq cA cc wcel cA cpi c2 cdiv co cmul co cc wcel cpi c2
    cdiv co cA cpi c2 cdiv co cmul co cmin co ccos cfv cA cpi c2 cdiv co cmul
    co csin cfv wceq cA cc wcel cpi c2 cdiv co cc wcel cA cpi c2 cdiv co cmul
    co cc wcel cpi c2 cpi pire recni 2cn 2ne0 divcli cA cpi c2 cdiv co mulcl
    mpan2 cA cpi c2 cdiv co cmul co coshalfpim syl 3ad2ant1 cA cc wcel cB cc
    wcel cA cB caddc co c1 wceq w3a cpi c2 cdiv co cA cpi c2 cdiv co cmul co
    cmin co cB cpi c2 cdiv co cmul co ccos cA cc wcel cB cc wcel cA cB caddc co
    c1 wceq w3a cpi c2 cdiv co cA cpi c2 cdiv co cmul co cmin co cB cpi c2 cdiv
    co cmul co wceq cA cpi c2 cdiv co cmul co cB cpi c2 cdiv co cmul co caddc
    co cpi c2 cdiv co wceq cA cc wcel cB cc wcel cA cB caddc co c1 wceq w3a cA
    cB caddc co cpi c2 cdiv co cmul co cA cpi c2 cdiv co cmul co cB cpi c2 cdiv
    co cmul co caddc co cpi c2 cdiv co cA cc wcel cB cc wcel cA cB caddc co cpi
    c2 cdiv co cmul co cA cpi c2 cdiv co cmul co cB cpi c2 cdiv co cmul co
    caddc co wceq cA cB caddc co c1 wceq cA cc wcel cB cc wcel cpi c2 cdiv co
    cc wcel cA cB caddc co cpi c2 cdiv co cmul co cA cpi c2 cdiv co cmul co cB
    cpi c2 cdiv co cmul co caddc co wceq cpi c2 cpi pire recni 2cn 2ne0 divcli
    cA cB cpi c2 cdiv co adddir mp3an3 3adant3 cA cB caddc co c1 wceq cA cc
    wcel cA cB caddc co cpi c2 cdiv co cmul co cpi c2 cdiv co wceq cB cc wcel
    cA cB caddc co c1 wceq cA cB caddc co cpi c2 cdiv co cmul co c1 cpi c2 cdiv
    co cmul co cpi c2 cdiv co cA cB caddc co c1 cpi c2 cdiv co cmul opreq1 cpi
    c2 cdiv co cpi c2 cpi pire recni 2cn 2ne0 divcli mulid2i syl6eq 3ad2ant3
    eqtr3d cA cc wcel cB cc wcel cpi c2 cdiv co cA cpi c2 cdiv co cmul co cmin
    co cB cpi c2 cdiv co cmul co wceq cA cpi c2 cdiv co cmul co cB cpi c2 cdiv
    co cmul co caddc co cpi c2 cdiv co wceq wb cA cB caddc co c1 wceq cA cpi c2
    cdiv co cmul co cc wcel cB cpi c2 cdiv co cmul co cc wcel cpi c2 cdiv co cA
    cpi c2 cdiv co cmul co cmin co cB cpi c2 cdiv co cmul co wceq cA cpi c2
    cdiv co cmul co cB cpi c2 cdiv co cmul co caddc co cpi c2 cdiv co wceq wb
    cA cc wcel cB cc wcel cpi c2 cdiv co cc wcel cA cpi c2 cdiv co cmul co cc
    wcel cB cpi c2 cdiv co cmul co cc wcel cpi c2 cdiv co cA cpi c2 cdiv co
    cmul co cmin co cB cpi c2 cdiv co cmul co wceq cA cpi c2 cdiv co cmul co cB
    cpi c2 cdiv co cmul co caddc co cpi c2 cdiv co wceq wb cpi c2 cpi pire
    recni 2cn 2ne0 divcli cpi c2 cdiv co cA cpi c2 cdiv co cmul co cB cpi c2
    cdiv co cmul co subadd mp3an1 cA cc wcel cpi c2 cdiv co cc wcel cA cpi c2
    cdiv co cmul co cc wcel cpi c2 cpi pire recni 2cn 2ne0 divcli cA cpi c2
    cdiv co mulcl mpan2 cB cc wcel cpi c2 cdiv co cc wcel cB cpi c2 cdiv co
    cmul co cc wcel cpi c2 cpi pire recni 2cn 2ne0 divcli cB cpi c2 cdiv co
    mulcl mpan2 syl2an 3adant3 mpbird fveq2d eqtr3d $.
    $( [25-Jan-2008] $) $( [25-Jan-2008] $)

  $( The sine and cosine of ` pi / 4 ` .  (Contributed by Paul Chapman,
     25-Jan-2008.) $)
  sincos4thpi $p |- ( ( sin ` ( pi / 4 ) ) = ( 1 / ( sqr ` 2 ) ) /\
                      ( cos ` ( pi / 4 ) ) = ( 1 / ( sqr ` 2 ) ) ) $=
    cpi c4 cdiv co csin cfv c1 c2 csqr cfv cdiv co wceq cpi c4 cdiv co ccos cfv
    c1 c2 csqr cfv cdiv co wceq c1 c2 csqr cfv cdiv co cpi c4 cdiv co csin cfv
    cpi c4 cdiv co csin cfv cmul co csqr cfv cpi c4 cdiv co csin cfv c1 c2 csqr
    cfv cdiv co cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co csqr
    cfv wceq c1 c2 csqr cfv cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv
    cmul co csqr cfv cmul co wceq c2 cpi c4 cdiv co csin cfv cpi c4 cdiv co
    csin cfv cmul co cmul co csqr cfv c1 csqr cfv c2 csqr cfv cpi c4 cdiv co
    csin cfv cpi c4 cdiv co csin cfv cmul co csqr cfv cmul co c1 c2 cpi c4 cdiv
    co csin cfv cpi c4 cdiv co csin cfv cmul co cmul co c1 csqr c2 c1 c2 cdiv
    co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co
    csin cfv cmul co cmul co c2 c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv
    c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv cmul co cmul co c2 cpi c4
    cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co cmul co c1 c1 c2 cdiv co
    cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co csin
    cfv cmul co c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi
    c2 cdiv co cmul co ccos cfv cmul co c2 cmul c1 c2 cdiv co cpi c2 cdiv co
    cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv c1 c2 cdiv
    co cpi c2 cdiv co cmul co csin cfv cmul c1 c2 cdiv co cc wcel c1 c2 cdiv co
    cc wcel c1 c2 cdiv co c1 c2 cdiv co caddc co c1 wceq c1 c2 cdiv co cpi c2
    cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv wceq
    c1 c2 cdiv co c2 2re 2ne0 rereccli recni c1 c2 cdiv co c2 2re 2ne0 rereccli
    recni c1 cc wcel c1 c2 cdiv co c1 c2 cdiv co caddc co c1 wceq ax1cn c1
    2halves ax-mp c1 c2 cdiv co c1 c2 cdiv co sincosq1eq mp3an opreq2i opreq2i
    c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co
    cmul co csin cfv cmul co cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv
    cmul co c2 cmul c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv cpi c4 cdiv
    co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv cpi c4 cdiv co
    csin cfv cmul c1 c2 cdiv co cpi c2 cdiv co cmul co cpi c4 cdiv co csin c1
    c2 cdiv co cpi c2 cdiv co cmul co c1 cpi cmul co c2 c2 cmul co cdiv co cpi
    c4 cdiv co c1 c2 cpi c2 ax1cn 2cn cpi pire recni 2cn 2ne0 2ne0 divmuldivi
    c1 cpi cmul co cpi c2 c2 cmul co c4 cdiv cpi cpi pire recni mulid2i 2t2e4
    opreq12i eqtri fveq2i c1 c2 cdiv co cpi c2 cdiv co cmul co cpi c4 cdiv co
    csin c1 c2 cdiv co cpi c2 cdiv co cmul co c1 cpi cmul co c2 c2 cmul co cdiv
    co cpi c4 cdiv co c1 c2 cpi c2 ax1cn 2cn cpi pire recni 2cn 2ne0 2ne0
    divmuldivi c1 cpi cmul co cpi c2 c2 cmul co c4 cdiv cpi cpi pire recni
    mulid2i 2t2e4 opreq12i eqtri fveq2i opreq12i opreq2i c2 c1 c2 cdiv co cpi
    c2 cdiv co cmul co cmul co csin cfv cpi c2 cdiv co csin cfv c2 c1 c2 cdiv
    co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co
    ccos cfv cmul co cmul co c1 c2 c1 c2 cdiv co cpi c2 cdiv co cmul co cmul co
    cpi c2 cdiv co csin c2 c1 c2 cdiv co cmul co cpi c2 cdiv co cmul co c1 cpi
    c2 cdiv co cmul co c2 c1 c2 cdiv co cpi c2 cdiv co cmul co cmul co cpi c2
    cdiv co c2 c1 c2 cdiv co cmul co c1 cpi c2 cdiv co cmul c2 2cn 2ne0 recidi
    opreq1i c2 c1 c2 cdiv co cpi c2 cdiv co 2cn c1 c2 cdiv co c2 2re 2ne0
    rereccli recni cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni mulassi
    cpi c2 cdiv co cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni mulid2i
    3eqtr3i fveq2i c1 c2 cdiv co cpi c2 cdiv co cmul co cc wcel c2 c1 c2 cdiv
    co cpi c2 cdiv co cmul co cmul co csin cfv c2 c1 c2 cdiv co cpi c2 cdiv co
    cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv cmul co cmul
    co wceq c1 c2 cdiv co cpi c2 cdiv co c1 c2 cdiv co c2 2re 2ne0 rereccli
    recni cpi c2 cdiv co cpi c2 pire 2re 2ne0 redivcli recni mulcli c1 c2 cdiv
    co cpi c2 cdiv co cmul co sin2t ax-mp sinhalfpi 3eqtr3i 3eqtr3i fveq2i c2
    cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co 2re cpi c4 cdiv co
    csin cfv cpi c4 cdiv co csin cfv cpi c4 cdiv co cr wcel cpi c4 cdiv co csin
    cfv cr wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv co
    resincl ax-mp cpi c4 cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4
    pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp
    remulcli cc0 c2 0re 2re 2pos ltleii cpi c4 cdiv co csin cfv cpi c4 cdiv co
    cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp msqge0i sqrmulii sqr1
    3eqtr3ri c1 cc wcel cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co
    csqr cfv cc wcel c2 csqr cfv cc wcel c2 csqr cfv cc0 wne wa c1 c2 csqr cfv
    cdiv co cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co csqr cfv
    wceq c1 c2 csqr cfv cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co
    csqr cfv cmul co wceq wb ax1cn cpi c4 cdiv co csin cfv cpi c4 cdiv co csin
    cfv cmul co csqr cfv cc0 cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv
    cmul co cle wbr cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co
    csqr cfv cr wcel cpi c4 cdiv co csin cfv cpi c4 cdiv co cr wcel cpi c4 cdiv
    co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4
    cdiv co resincl ax-mp msqge0i cpi c4 cdiv co csin cfv cpi c4 cdiv co csin
    cfv cmul co cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cpi c4 cdiv co
    cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp cpi c4 cdiv co cr wcel cpi
    c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli
    cpi c4 cdiv co resincl ax-mp remulcli sqrcli ax-mp recni c2 csqr cfv cc
    wcel c2 csqr cfv cc0 wne c2 csqr cfv sqr2re recni c2 csqr cfv cc0 wne c2
    cc0 wne 2ne0 c2 csqr cfv cc0 c2 cc0 c2 cr wcel cc0 c2 cle wbr c2 csqr cfv
    cc0 wceq c2 cc0 wceq wb 2re cc0 c2 0re 2re 2pos ltleii c2 sqr00 mp2an
    necon3bii mpbir pm3.2i c1 cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv
    cmul co csqr cfv c2 csqr cfv divmul2 mp3an mpbir cc0 cpi c4 cdiv co csin
    cfv cle wbr cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co csqr
    cfv cpi c4 cdiv co csin cfv wceq cc0 cpi c4 cdiv co csin cfv 0re cpi c4
    cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp cpi c4 cdiv co cc0 c1 cioc
    co wcel cc0 cpi c4 cdiv co csin cfv clt wbr cpi c4 cdiv co cr wcel cc0 cpi
    c4 cdiv co clt wbr cpi c4 cdiv co c1 cle wbr cpi c4 cdiv co cc0 c1 cioc co
    wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4 pire 4re pipos
    4pos divgt0ii cpi c4 cdiv co c1 cpi c4 pire 4re c4 4re 4pos gt0ne0ii
    redivcli 1re cpi c4 cdiv co c4 c4 cdiv co c1 clt cpi c4 clt wbr cpi c4 cdiv
    co c4 c4 cdiv co clt wbr c2 cpi clt wbr cpi c4 clt wbr pigt2lt4 pm3.27i cpi
    c4 c4 pire 4re 4re 4pos ltdiv1ii mpbi c4 c4 4re recni c4 4re 4pos gt0ne0ii
    dividi breqtri ltleii cpi c4 cdiv co cc0 c1 cioc co wcel cpi c4 cdiv co cr
    wcel cc0 cpi c4 cdiv co clt wbr cpi c4 cdiv co c1 cle wbr w3a cc0 cr wcel
    c1 cr wcel cpi c4 cdiv co cc0 c1 cioc co wcel cpi c4 cdiv co cr wcel cc0
    cpi c4 cdiv co clt wbr cpi c4 cdiv co c1 cle wbr w3a wb 0re 1re cc0 c1 cpi
    c4 cdiv co elioc2 mp2an biimpri mp3an cpi c4 cdiv co sin01gt0 ax-mp ltleii
    cpi c4 cdiv co csin cfv cpi c4 cdiv co cr wcel cpi c4 cdiv co csin cfv cr
    wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv co resincl
    ax-mp sqrmsqi ax-mp eqtr2i c1 c2 csqr cfv cdiv co cpi c4 cdiv co csin cfv
    cpi c4 cdiv co csin cfv cmul co csqr cfv cpi c4 cdiv co csin cfv cpi c4
    cdiv co ccos cfv c1 c2 csqr cfv cdiv co cpi c4 cdiv co csin cfv cpi c4 cdiv
    co csin cfv cmul co csqr cfv wceq c1 c2 csqr cfv cpi c4 cdiv co csin cfv
    cpi c4 cdiv co csin cfv cmul co csqr cfv cmul co wceq c2 cpi c4 cdiv co
    csin cfv cpi c4 cdiv co csin cfv cmul co cmul co csqr cfv c1 csqr cfv c2
    csqr cfv cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co csqr cfv
    cmul co c1 c2 cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co cmul
    co c1 csqr c2 c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co
    cpi c2 cdiv co cmul co csin cfv cmul co cmul co c2 c1 c2 cdiv co cpi c2
    cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv cmul
    co cmul co c2 cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cmul co cmul
    co c1 c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2
    cdiv co cmul co csin cfv cmul co c1 c2 cdiv co cpi c2 cdiv co cmul co csin
    cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv cmul co c2 cmul c1 c2
    cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul
    co ccos cfv c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv cmul c1 c2 cdiv
    co cc wcel c1 c2 cdiv co cc wcel c1 c2 cdiv co c1 c2 cdiv co caddc co c1
    wceq c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2
    cdiv co cmul co ccos cfv wceq c1 c2 cdiv co c2 2re 2ne0 rereccli recni c1
    c2 cdiv co c2 2re 2ne0 rereccli recni c1 cc wcel c1 c2 cdiv co c1 c2 cdiv
    co caddc co c1 wceq ax1cn c1 2halves ax-mp c1 c2 cdiv co c1 c2 cdiv co
    sincosq1eq mp3an opreq2i opreq2i c1 c2 cdiv co cpi c2 cdiv co cmul co csin
    cfv c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv cmul co cpi c4 cdiv co
    csin cfv cpi c4 cdiv co csin cfv cmul co c2 cmul c1 c2 cdiv co cpi c2 cdiv
    co cmul co csin cfv cpi c4 cdiv co csin cfv c1 c2 cdiv co cpi c2 cdiv co
    cmul co csin cfv cpi c4 cdiv co csin cfv cmul c1 c2 cdiv co cpi c2 cdiv co
    cmul co cpi c4 cdiv co csin c1 c2 cdiv co cpi c2 cdiv co cmul co c1 cpi
    cmul co c2 c2 cmul co cdiv co cpi c4 cdiv co c1 c2 cpi c2 ax1cn 2cn cpi
    pire recni 2cn 2ne0 2ne0 divmuldivi c1 cpi cmul co cpi c2 c2 cmul co c4
    cdiv cpi cpi pire recni mulid2i 2t2e4 opreq12i eqtri fveq2i c1 c2 cdiv co
    cpi c2 cdiv co cmul co cpi c4 cdiv co csin c1 c2 cdiv co cpi c2 cdiv co
    cmul co c1 cpi cmul co c2 c2 cmul co cdiv co cpi c4 cdiv co c1 c2 cpi c2
    ax1cn 2cn cpi pire recni 2cn 2ne0 2ne0 divmuldivi c1 cpi cmul co cpi c2 c2
    cmul co c4 cdiv cpi cpi pire recni mulid2i 2t2e4 opreq12i eqtri fveq2i
    opreq12i opreq2i c2 c1 c2 cdiv co cpi c2 cdiv co cmul co cmul co csin cfv
    cpi c2 cdiv co csin cfv c2 c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1
    c2 cdiv co cpi c2 cdiv co cmul co ccos cfv cmul co cmul co c1 c2 c1 c2 cdiv
    co cpi c2 cdiv co cmul co cmul co cpi c2 cdiv co csin c2 c1 c2 cdiv co cmul
    co cpi c2 cdiv co cmul co c1 cpi c2 cdiv co cmul co c2 c1 c2 cdiv co cpi c2
    cdiv co cmul co cmul co cpi c2 cdiv co c2 c1 c2 cdiv co cmul co c1 cpi c2
    cdiv co cmul c2 2cn 2ne0 recidi opreq1i c2 c1 c2 cdiv co cpi c2 cdiv co 2cn
    c1 c2 cdiv co c2 2re 2ne0 rereccli recni cpi c2 cdiv co cpi c2 pire 2re
    2ne0 redivcli recni mulassi cpi c2 cdiv co cpi c2 cdiv co cpi c2 pire 2re
    2ne0 redivcli recni mulid2i 3eqtr3i fveq2i c1 c2 cdiv co cpi c2 cdiv co
    cmul co cc wcel c2 c1 c2 cdiv co cpi c2 cdiv co cmul co cmul co csin cfv c2
    c1 c2 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c2 cdiv co cpi c2 cdiv co
    cmul co ccos cfv cmul co cmul co wceq c1 c2 cdiv co cpi c2 cdiv co c1 c2
    cdiv co c2 2re 2ne0 rereccli recni cpi c2 cdiv co cpi c2 pire 2re 2ne0
    redivcli recni mulcli c1 c2 cdiv co cpi c2 cdiv co cmul co sin2t ax-mp
    sinhalfpi 3eqtr3i 3eqtr3i fveq2i c2 cpi c4 cdiv co csin cfv cpi c4 cdiv co
    csin cfv cmul co 2re cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv cpi c4
    cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp cpi c4 cdiv co cr wcel cpi
    c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli
    cpi c4 cdiv co resincl ax-mp remulcli cc0 c2 0re 2re 2pos ltleii cpi c4
    cdiv co csin cfv cpi c4 cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi
    c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp
    msqge0i sqrmulii sqr1 3eqtr3ri c1 cc wcel cpi c4 cdiv co csin cfv cpi c4
    cdiv co csin cfv cmul co csqr cfv cc wcel c2 csqr cfv cc wcel c2 csqr cfv
    cc0 wne wa c1 c2 csqr cfv cdiv co cpi c4 cdiv co csin cfv cpi c4 cdiv co
    csin cfv cmul co csqr cfv wceq c1 c2 csqr cfv cpi c4 cdiv co csin cfv cpi
    c4 cdiv co csin cfv cmul co csqr cfv cmul co wceq wb ax1cn cpi c4 cdiv co
    csin cfv cpi c4 cdiv co csin cfv cmul co csqr cfv cc0 cpi c4 cdiv co csin
    cfv cpi c4 cdiv co csin cfv cmul co cle wbr cpi c4 cdiv co csin cfv cpi c4
    cdiv co csin cfv cmul co csqr cfv cr wcel cpi c4 cdiv co csin cfv cpi c4
    cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp msqge0i cpi c4 cdiv co csin
    cfv cpi c4 cdiv co csin cfv cmul co cpi c4 cdiv co csin cfv cpi c4 cdiv co
    csin cfv cpi c4 cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire
    4re c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp cpi c4 cdiv
    co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp remulcli sqrcli ax-mp recni
    c2 csqr cfv cc wcel c2 csqr cfv cc0 wne c2 csqr cfv sqr2re recni c2 csqr
    cfv cc0 wne c2 cc0 wne 2ne0 c2 csqr cfv cc0 c2 cc0 c2 cr wcel cc0 c2 cle
    wbr c2 csqr cfv cc0 wceq c2 cc0 wceq wb 2re cc0 c2 0re 2re 2pos ltleii c2
    sqr00 mp2an necon3bii mpbir pm3.2i c1 cpi c4 cdiv co csin cfv cpi c4 cdiv
    co csin cfv cmul co csqr cfv c2 csqr cfv divmul2 mp3an mpbir cc0 cpi c4
    cdiv co csin cfv cle wbr cpi c4 cdiv co csin cfv cpi c4 cdiv co csin cfv
    cmul co csqr cfv cpi c4 cdiv co csin cfv wceq cc0 cpi c4 cdiv co csin cfv
    0re cpi c4 cdiv co cr wcel cpi c4 cdiv co csin cfv cr wcel cpi c4 pire 4re
    c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv co resincl ax-mp cpi c4 cdiv co
    cc0 c1 cioc co wcel cc0 cpi c4 cdiv co csin cfv clt wbr cpi c4 cdiv co cr
    wcel cc0 cpi c4 cdiv co clt wbr cpi c4 cdiv co c1 cle wbr cpi c4 cdiv co
    cc0 c1 cioc co wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4
    pire 4re pipos 4pos divgt0ii cpi c4 cdiv co c1 cpi c4 pire 4re c4 4re 4pos
    gt0ne0ii redivcli 1re cpi c4 cdiv co c4 c4 cdiv co c1 clt cpi c4 clt wbr
    cpi c4 cdiv co c4 c4 cdiv co clt wbr c2 cpi clt wbr cpi c4 clt wbr pigt2lt4
    pm3.27i cpi c4 c4 pire 4re 4re 4pos ltdiv1ii mpbi c4 c4 4re recni c4 4re
    4pos gt0ne0ii dividi breqtri ltleii cpi c4 cdiv co cc0 c1 cioc co wcel cpi
    c4 cdiv co cr wcel cc0 cpi c4 cdiv co clt wbr cpi c4 cdiv co c1 cle wbr w3a
    cc0 cr wcel c1 cr wcel cpi c4 cdiv co cc0 c1 cioc co wcel cpi c4 cdiv co cr
    wcel cc0 cpi c4 cdiv co clt wbr cpi c4 cdiv co c1 cle wbr w3a wb 0re 1re
    cc0 c1 cpi c4 cdiv co elioc2 mp2an biimpri mp3an cpi c4 cdiv co sin01gt0
    ax-mp ltleii cpi c4 cdiv co csin cfv cpi c4 cdiv co cr wcel cpi c4 cdiv co
    csin cfv cr wcel cpi c4 pire 4re c4 4re 4pos gt0ne0ii redivcli cpi c4 cdiv
    co resincl ax-mp sqrmsqi ax-mp c1 c2 cdiv co cpi c2 cdiv co cmul co csin
    cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv cpi c4 cdiv co csin cfv
    cpi c4 cdiv co ccos cfv c1 c2 cdiv co cc wcel c1 c2 cdiv co cc wcel c1 c2
    cdiv co c1 c2 cdiv co caddc co c1 wceq c1 c2 cdiv co cpi c2 cdiv co cmul co
    csin cfv c1 c2 cdiv co cpi c2 cdiv co cmul co ccos cfv wceq c1 c2 cdiv co
    c2 2re 2ne0 rereccli recni c1 c2 cdiv co c2 2re 2ne0 rereccli recni c1 cc
    wcel c1 c2 cdiv co c1 c2 cdiv co caddc co c1 wceq ax1cn c1 2halves ax-mp c1
    c2 cdiv co c1 c2 cdiv co sincosq1eq mp3an c1 c2 cdiv co cpi c2 cdiv co cmul
    co cpi c4 cdiv co csin c1 c2 cdiv co cpi c2 cdiv co cmul co c1 cpi cmul co
    c2 c2 cmul co cdiv co cpi c4 cdiv co c1 c2 cpi c2 ax1cn 2cn cpi pire recni
    2cn 2ne0 2ne0 divmuldivi c1 cpi cmul co cpi c2 c2 cmul co c4 cdiv cpi cpi
    pire recni mulid2i 2t2e4 opreq12i eqtri fveq2i c1 c2 cdiv co cpi c2 cdiv co
    cmul co cpi c4 cdiv co ccos c1 c2 cdiv co cpi c2 cdiv co cmul co c1 cpi
    cmul co c2 c2 cmul co cdiv co cpi c4 cdiv co c1 c2 cpi c2 ax1cn 2cn cpi
    pire recni 2cn 2ne0 2ne0 divmuldivi c1 cpi cmul co cpi c2 c2 cmul co c4
    cdiv cpi cpi pire recni mulid2i 2t2e4 opreq12i eqtri fveq2i 3eqtr3i 3eqtrri
    pm3.2i $.
    $( [25-Jan-2008] $) $( [25-Jan-2008] $)

  $( The sine and cosine of ` pi / 6 ` .  (Contributed by Paul Chapman,
     25-Jan-2008.) $)
  sincos6thpi $p |- ( ( sin ` ( pi / 6 ) ) = ( 1 / 2 ) /\
                      ( cos ` ( pi / 6 ) ) = ( ( sqr ` 3 ) / 2 ) ) $=
    cpi c6 cdiv co csin cfv c1 c2 cdiv co wceq cpi c6 cdiv co ccos cfv c3 csqr
    cfv c2 cdiv co wceq c1 c2 cdiv co cpi c6 cdiv co csin cfv c1 c2 cdiv co cpi
    c6 cdiv co csin cfv wceq c2 cpi c6 cdiv co csin cfv cmul co c1 wceq c2 cpi
    c6 cdiv co csin cfv cmul co cpi c6 cdiv co ccos cfv cmul co c1 cpi c6 cdiv
    co ccos cfv cmul co wceq c2 cpi c6 cdiv co csin cfv cmul co c1 wceq c2 cpi
    c6 cdiv co csin cfv cmul co cpi c6 cdiv co ccos cfv cmul co cpi c6 cdiv co
    ccos cfv c1 cpi c6 cdiv co ccos cfv cmul co c2 cpi c6 cdiv co csin cfv cmul
    co cpi c6 cdiv co ccos cfv cmul co c2 cpi c6 cdiv co csin cfv cpi c6 cdiv
    co ccos cfv cmul co cmul co c2 cpi c6 cdiv co cmul co csin cfv cpi c6 cdiv
    co ccos cfv c2 cpi c6 cdiv co csin cfv cpi c6 cdiv co ccos cfv 2cn cpi c6
    cdiv co cc wcel cpi c6 cdiv co csin cfv cc wcel cpi c6 cdiv co cpi c6 pire
    6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co sincl ax-mp cpi c6
    cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos cfv cr wcel cpi
    c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co recoscl ax-mp
    recni mulassi cpi c6 cdiv co cc wcel c2 cpi c6 cdiv co cmul co csin cfv c2
    cpi c6 cdiv co csin cfv cpi c6 cdiv co ccos cfv cmul co cmul co wceq cpi c6
    cdiv co cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co
    sin2t ax-mp c2 c3 cdiv co cpi c2 cdiv co cmul co csin cfv c1 c3 cdiv co cpi
    c2 cdiv co cmul co ccos cfv c2 cpi c6 cdiv co cmul co csin cfv cpi c6 cdiv
    co ccos cfv c2 c3 cdiv co cc wcel c1 c3 cdiv co cc wcel c2 c3 cdiv co c1 c3
    cdiv co caddc co c1 wceq c2 c3 cdiv co cpi c2 cdiv co cmul co csin cfv c1
    c3 cdiv co cpi c2 cdiv co cmul co ccos cfv wceq c2 c3 2cn c3 3re recni c3
    3re 3pos gt0ne0ii divcli c3 c3 3re recni c3 3re 3pos gt0ne0ii reccli c3 c3
    cdiv co c2 c1 caddc co c3 cdiv co c1 c2 c3 cdiv co c1 c3 cdiv co caddc co
    c3 c2 c1 caddc co c3 cdiv df-3 opreq1i c3 c3 3re recni c3 3re 3pos gt0ne0ii
    dividi c2 c1 c3 2cn ax1cn c3 3re recni c3 3re 3pos gt0ne0ii divdiri
    3eqtr3ri c2 c3 cdiv co c1 c3 cdiv co sincosq1eq mp3an c2 c3 cdiv co cpi c2
    cdiv co cmul co c2 cpi c6 cdiv co cmul co csin c2 c3 cdiv co cpi c2 cdiv co
    cmul co c2 cpi cmul co c3 c2 cmul co cdiv co c2 cpi cmul co c6 cdiv co c2
    cpi c6 cdiv co cmul co c2 c3 cpi c2 2cn c3 3re recni cpi pire recni 2cn c3
    3re 3pos gt0ne0ii 2ne0 divmuldivi c3 c2 cmul co c6 c2 cpi cmul co cdiv
    3t2e6 opreq2i c2 cpi c6 2cn cpi pire recni c6 6re recni c6 6re 6pos
    gt0ne0ii divassi 3eqtri fveq2i c1 c3 cdiv co cpi c2 cdiv co cmul co cpi c6
    cdiv co ccos c1 c3 cdiv co cpi c2 cdiv co cmul co c1 cpi cmul co c3 c2 cmul
    co cdiv co cpi c6 cdiv co c1 c3 cpi c2 ax1cn c3 3re recni cpi pire recni
    2cn c3 3re 3pos gt0ne0ii 2ne0 divmuldivi c1 cpi cmul co cpi c3 c2 cmul co
    c6 cdiv cpi cpi pire recni mulid2i 3t2e6 opreq12i eqtri fveq2i 3eqtr3i
    3eqtr2i cpi c6 cdiv co ccos cfv cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr
    wcel cpi c6 cdiv co ccos cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii
    redivcli cpi c6 cdiv co recoscl ax-mp recni mulid2i eqtr4i c2 cpi c6 cdiv
    co csin cfv cmul co cc wcel c1 cc wcel cpi c6 cdiv co ccos cfv cc wcel cpi
    c6 cdiv co ccos cfv cc0 wne wa c2 cpi c6 cdiv co csin cfv cmul co cpi c6
    cdiv co ccos cfv cmul co c1 cpi c6 cdiv co ccos cfv cmul co wceq c2 cpi c6
    cdiv co csin cfv cmul co c1 wceq wb c2 cpi c6 cdiv co csin cfv 2cn cpi c6
    cdiv co cc wcel cpi c6 cdiv co csin cfv cc wcel cpi c6 cdiv co cpi c6 pire
    6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co sincl ax-mp mulcli
    ax1cn cpi c6 cdiv co ccos cfv cc wcel cpi c6 cdiv co ccos cfv cc0 wne cpi
    c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos cfv cr wcel
    cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co recoscl ax-mp
    recni cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos
    cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co
    recoscl ax-mp cc0 cpi c6 cdiv co csin cfv clt wbr cc0 cpi c6 cdiv co ccos
    cfv clt wbr cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cc0 cpi c6 cdiv
    co csin cfv clt wbr cc0 cpi c6 cdiv co ccos cfv clt wbr wa cpi c6 cdiv co
    cr wcel cc0 cpi c6 cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr
    cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 pire 6re c6 6re 6pos
    gt0ne0ii redivcli cpi c6 pire 6re pipos 6pos divgt0ii c2 c6 clt wbr cpi c6
    cdiv co cpi c2 cdiv co clt wbr c1 c2 cmul co c3 c2 cmul co c2 c6 clt c1 c3
    clt wbr c1 c2 cmul co c3 c2 cmul co clt wbr c1 c2 c1 caddc co c3 clt cc0 c1
    caddc co c1 c2 c1 caddc co clt c1 ax1cn addid2i cc0 c2 clt wbr cc0 c1 caddc
    co c2 c1 caddc co clt wbr 2pos cc0 c2 c1 0re 2re 1re ltadd1i mpbi eqbrtrri
    df-3 breqtrri c1 c3 c2 1re 3re 2re 2pos ltmul1ii mpbi c2 2cn mulid2i 3t2e6
    3brtr3i cc0 c2 clt wbr cc0 c6 clt wbr cc0 cpi clt wbr c2 c6 clt wbr cpi c6
    cdiv co cpi c2 cdiv co clt wbr wb 2pos 6pos pipos c2 cr wcel c6 cr wcel cpi
    cr wcel w3a cc0 c2 clt wbr cc0 c6 clt wbr cc0 cpi clt wbr w3a c2 c6 clt wbr
    cpi c6 cdiv co cpi c2 cdiv co clt wbr wb c2 cr wcel c6 cr wcel cpi cr wcel
    2re 6re pire 3pm3.2i c2 c6 cpi ltdiv2 mpan mp3an mpbi cpi c6 cdiv co cc0
    cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel cc0 cpi c6 cdiv co clt
    wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a cc0 cr wcel cpi c2 cdiv co cr
    wcel cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel
    cc0 cpi c6 cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a wb 0re
    cpi c2 pire 2re 2ne0 redivcli cc0 cxr wcel cpi c2 cdiv co cxr wcel cpi c6
    cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel cc0 cpi c6
    cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a wb cc0 cr wcel
    cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co cpi c6 cdiv co elioo2 cc0 rexr
    cpi c2 cdiv co rexr syl2an mp2an biimpri mp3an cpi c6 cdiv co sincosq1sgn
    ax-mp pm3.27i gt0ne0ii pm3.2i c2 cpi c6 cdiv co csin cfv cmul co c1 cpi c6
    cdiv co ccos cfv mulcan2 mp3an mpbi c1 c2 cpi c6 cdiv co csin cfv ax1cn 2cn
    cpi c6 cdiv co cc wcel cpi c6 cdiv co csin cfv cc wcel cpi c6 cdiv co cpi
    c6 pire 6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co sincl ax-mp
    2ne0 divmuli mpbir eqcomi cpi c6 cdiv co ccos cfv c2 cexp co csqr cfv c3 c4
    cdiv co csqr cfv cpi c6 cdiv co ccos cfv c3 csqr cfv c2 cdiv co cpi c6 cdiv
    co ccos cfv c2 cexp co c3 c4 cdiv co csqr c1 c1 c4 cdiv co cmin co cpi c6
    cdiv co ccos cfv c2 cexp co c3 c4 cdiv co c1 c1 c4 cdiv co cpi c6 cdiv co
    ccos cfv c2 cexp co ax1cn c4 c4 4re recni c4 4re 4pos gt0ne0ii reccli cpi
    c6 cdiv co ccos cfv cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6
    cdiv co ccos cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi
    c6 cdiv co recoscl ax-mp recni sqcli cpi c6 cdiv co csin cfv c2 cexp co cpi
    c6 cdiv co ccos cfv c2 cexp co caddc co c1 c4 cdiv co cpi c6 cdiv co ccos
    cfv c2 cexp co caddc co c1 cpi c6 cdiv co csin cfv c2 cexp co c1 c4 cdiv co
    cpi c6 cdiv co ccos cfv c2 cexp co caddc cpi c6 cdiv co csin cfv c2 cexp co
    c1 c2 cdiv co c2 cexp co c1 c2 c2 cexp co cdiv co c1 c4 cdiv co cpi c6 cdiv
    co csin cfv c1 c2 cdiv co c2 cexp c1 c2 cdiv co cpi c6 cdiv co csin cfv c1
    c2 cdiv co cpi c6 cdiv co csin cfv wceq c2 cpi c6 cdiv co csin cfv cmul co
    c1 wceq c2 cpi c6 cdiv co csin cfv cmul co cpi c6 cdiv co ccos cfv cmul co
    c1 cpi c6 cdiv co ccos cfv cmul co wceq c2 cpi c6 cdiv co csin cfv cmul co
    c1 wceq c2 cpi c6 cdiv co csin cfv cmul co cpi c6 cdiv co ccos cfv cmul co
    cpi c6 cdiv co ccos cfv c1 cpi c6 cdiv co ccos cfv cmul co c2 cpi c6 cdiv
    co csin cfv cmul co cpi c6 cdiv co ccos cfv cmul co c2 cpi c6 cdiv co csin
    cfv cpi c6 cdiv co ccos cfv cmul co cmul co c2 cpi c6 cdiv co cmul co csin
    cfv cpi c6 cdiv co ccos cfv c2 cpi c6 cdiv co csin cfv cpi c6 cdiv co ccos
    cfv 2cn cpi c6 cdiv co cc wcel cpi c6 cdiv co csin cfv cc wcel cpi c6 cdiv
    co cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co sincl
    ax-mp cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos
    cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co
    recoscl ax-mp recni mulassi cpi c6 cdiv co cc wcel c2 cpi c6 cdiv co cmul
    co csin cfv c2 cpi c6 cdiv co csin cfv cpi c6 cdiv co ccos cfv cmul co cmul
    co wceq cpi c6 cdiv co cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli recni
    cpi c6 cdiv co sin2t ax-mp c2 c3 cdiv co cpi c2 cdiv co cmul co csin cfv c1
    c3 cdiv co cpi c2 cdiv co cmul co ccos cfv c2 cpi c6 cdiv co cmul co csin
    cfv cpi c6 cdiv co ccos cfv c2 c3 cdiv co cc wcel c1 c3 cdiv co cc wcel c2
    c3 cdiv co c1 c3 cdiv co caddc co c1 wceq c2 c3 cdiv co cpi c2 cdiv co cmul
    co csin cfv c1 c3 cdiv co cpi c2 cdiv co cmul co ccos cfv wceq c2 c3 2cn c3
    3re recni c3 3re 3pos gt0ne0ii divcli c3 c3 3re recni c3 3re 3pos gt0ne0ii
    reccli c3 c3 cdiv co c2 c1 caddc co c3 cdiv co c1 c2 c3 cdiv co c1 c3 cdiv
    co caddc co c3 c2 c1 caddc co c3 cdiv df-3 opreq1i c3 c3 3re recni c3 3re
    3pos gt0ne0ii dividi c2 c1 c3 2cn ax1cn c3 3re recni c3 3re 3pos gt0ne0ii
    divdiri 3eqtr3ri c2 c3 cdiv co c1 c3 cdiv co sincosq1eq mp3an c2 c3 cdiv co
    cpi c2 cdiv co cmul co c2 cpi c6 cdiv co cmul co csin c2 c3 cdiv co cpi c2
    cdiv co cmul co c2 cpi cmul co c3 c2 cmul co cdiv co c2 cpi cmul co c6 cdiv
    co c2 cpi c6 cdiv co cmul co c2 c3 cpi c2 2cn c3 3re recni cpi pire recni
    2cn c3 3re 3pos gt0ne0ii 2ne0 divmuldivi c3 c2 cmul co c6 c2 cpi cmul co
    cdiv 3t2e6 opreq2i c2 cpi c6 2cn cpi pire recni c6 6re recni c6 6re 6pos
    gt0ne0ii divassi 3eqtri fveq2i c1 c3 cdiv co cpi c2 cdiv co cmul co cpi c6
    cdiv co ccos c1 c3 cdiv co cpi c2 cdiv co cmul co c1 cpi cmul co c3 c2 cmul
    co cdiv co cpi c6 cdiv co c1 c3 cpi c2 ax1cn c3 3re recni cpi pire recni
    2cn c3 3re 3pos gt0ne0ii 2ne0 divmuldivi c1 cpi cmul co cpi c3 c2 cmul co
    c6 cdiv cpi cpi pire recni mulid2i 3t2e6 opreq12i eqtri fveq2i 3eqtr3i
    3eqtr2i cpi c6 cdiv co ccos cfv cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr
    wcel cpi c6 cdiv co ccos cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii
    redivcli cpi c6 cdiv co recoscl ax-mp recni mulid2i eqtr4i c2 cpi c6 cdiv
    co csin cfv cmul co cc wcel c1 cc wcel cpi c6 cdiv co ccos cfv cc wcel cpi
    c6 cdiv co ccos cfv cc0 wne wa c2 cpi c6 cdiv co csin cfv cmul co cpi c6
    cdiv co ccos cfv cmul co c1 cpi c6 cdiv co ccos cfv cmul co wceq c2 cpi c6
    cdiv co csin cfv cmul co c1 wceq wb c2 cpi c6 cdiv co csin cfv 2cn cpi c6
    cdiv co cc wcel cpi c6 cdiv co csin cfv cc wcel cpi c6 cdiv co cpi c6 pire
    6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co sincl ax-mp mulcli
    ax1cn cpi c6 cdiv co ccos cfv cc wcel cpi c6 cdiv co ccos cfv cc0 wne cpi
    c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos cfv cr wcel
    cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co recoscl ax-mp
    recni cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos
    cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co
    recoscl ax-mp cc0 cpi c6 cdiv co csin cfv clt wbr cc0 cpi c6 cdiv co ccos
    cfv clt wbr cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cc0 cpi c6 cdiv
    co csin cfv clt wbr cc0 cpi c6 cdiv co ccos cfv clt wbr wa cpi c6 cdiv co
    cr wcel cc0 cpi c6 cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr
    cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 pire 6re c6 6re 6pos
    gt0ne0ii redivcli cpi c6 pire 6re pipos 6pos divgt0ii c2 c6 clt wbr cpi c6
    cdiv co cpi c2 cdiv co clt wbr c1 c2 cmul co c3 c2 cmul co c2 c6 clt c1 c3
    clt wbr c1 c2 cmul co c3 c2 cmul co clt wbr c1 c2 c1 caddc co c3 clt cc0 c1
    caddc co c1 c2 c1 caddc co clt c1 ax1cn addid2i cc0 c2 clt wbr cc0 c1 caddc
    co c2 c1 caddc co clt wbr 2pos cc0 c2 c1 0re 2re 1re ltadd1i mpbi eqbrtrri
    df-3 breqtrri c1 c3 c2 1re 3re 2re 2pos ltmul1ii mpbi c2 2cn mulid2i 3t2e6
    3brtr3i cc0 c2 clt wbr cc0 c6 clt wbr cc0 cpi clt wbr c2 c6 clt wbr cpi c6
    cdiv co cpi c2 cdiv co clt wbr wb 2pos 6pos pipos c2 cr wcel c6 cr wcel cpi
    cr wcel w3a cc0 c2 clt wbr cc0 c6 clt wbr cc0 cpi clt wbr w3a c2 c6 clt wbr
    cpi c6 cdiv co cpi c2 cdiv co clt wbr wb c2 cr wcel c6 cr wcel cpi cr wcel
    2re 6re pire 3pm3.2i c2 c6 cpi ltdiv2 mpan mp3an mpbi cpi c6 cdiv co cc0
    cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel cc0 cpi c6 cdiv co clt
    wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a cc0 cr wcel cpi c2 cdiv co cr
    wcel cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel
    cc0 cpi c6 cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a wb 0re
    cpi c2 pire 2re 2ne0 redivcli cc0 cxr wcel cpi c2 cdiv co cxr wcel cpi c6
    cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel cc0 cpi c6
    cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a wb cc0 cr wcel
    cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co cpi c6 cdiv co elioo2 cc0 rexr
    cpi c2 cdiv co rexr syl2an mp2an biimpri mp3an cpi c6 cdiv co sincosq1sgn
    ax-mp pm3.27i gt0ne0ii pm3.2i c2 cpi c6 cdiv co csin cfv cmul co c1 cpi c6
    cdiv co ccos cfv mulcan2 mp3an mpbi c1 c2 cpi c6 cdiv co csin cfv ax1cn 2cn
    cpi c6 cdiv co cc wcel cpi c6 cdiv co csin cfv cc wcel cpi c6 cdiv co cpi
    c6 pire 6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co sincl ax-mp
    2ne0 divmuli mpbir eqcomi opreq1i c2 2cn 2ne0 sqrecii c2 c2 cexp co c4 c1
    cdiv sq2 opreq2i 3eqtri opreq1i cpi c6 cdiv co cc wcel cpi c6 cdiv co csin
    cfv c2 cexp co cpi c6 cdiv co ccos cfv c2 cexp co caddc co c1 wceq cpi c6
    cdiv co cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli recni cpi c6 cdiv co
    sincossq ax-mp eqtr3i subaddrii c4 c1 cmin co c4 cdiv co c4 c4 cdiv co c1
    c4 cdiv co cmin co c3 c4 cdiv co c1 c1 c4 cdiv co cmin co c4 cc wcel c1 cc
    wcel c4 cc wcel c4 cc0 wne wa c4 c1 cmin co c4 cdiv co c4 c4 cdiv co c1 c4
    cdiv co cmin co wceq c4 4re recni ax1cn c4 cc wcel c4 cc0 wne c4 4re recni
    c4 4re 4pos gt0ne0ii pm3.2i c4 c1 c4 divsubdir mp3an c4 c1 cmin co c3 c4
    cdiv c4 c1 cmin co c3 wceq c3 c1 caddc co c4 wceq c4 c3 c1 caddc co df-4
    eqcomi c4 c1 c3 c4 4re recni ax1cn c3 3re recni subadd2i mpbir opreq1i c4
    c4 cdiv co c1 c1 c4 cdiv co cmin c4 c4 4re recni c4 4re 4pos gt0ne0ii
    dividi opreq1i 3eqtr3ri eqtr3i fveq2i cc0 cpi c6 cdiv co ccos cfv cle wbr
    cpi c6 cdiv co ccos cfv c2 cexp co csqr cfv cpi c6 cdiv co ccos cfv wceq
    cc0 cpi c6 cdiv co ccos cfv 0re cpi c6 cdiv co cr wcel cpi c6 cdiv co ccos
    cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi c6 cdiv co
    recoscl ax-mp cc0 cpi c6 cdiv co csin cfv clt wbr cc0 cpi c6 cdiv co ccos
    cfv clt wbr cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cc0 cpi c6 cdiv
    co csin cfv clt wbr cc0 cpi c6 cdiv co ccos cfv clt wbr wa cpi c6 cdiv co
    cr wcel cc0 cpi c6 cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr
    cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 pire 6re c6 6re 6pos
    gt0ne0ii redivcli cpi c6 pire 6re pipos 6pos divgt0ii c2 c6 clt wbr cpi c6
    cdiv co cpi c2 cdiv co clt wbr c1 c2 cmul co c3 c2 cmul co c2 c6 clt c1 c3
    clt wbr c1 c2 cmul co c3 c2 cmul co clt wbr c1 c2 c1 caddc co c3 clt cc0 c1
    caddc co c1 c2 c1 caddc co clt c1 ax1cn addid2i cc0 c2 clt wbr cc0 c1 caddc
    co c2 c1 caddc co clt wbr 2pos cc0 c2 c1 0re 2re 1re ltadd1i mpbi eqbrtrri
    df-3 breqtrri c1 c3 c2 1re 3re 2re 2pos ltmul1ii mpbi c2 2cn mulid2i 3t2e6
    3brtr3i cc0 c2 clt wbr cc0 c6 clt wbr cc0 cpi clt wbr c2 c6 clt wbr cpi c6
    cdiv co cpi c2 cdiv co clt wbr wb 2pos 6pos pipos c2 cr wcel c6 cr wcel cpi
    cr wcel w3a cc0 c2 clt wbr cc0 c6 clt wbr cc0 cpi clt wbr w3a c2 c6 clt wbr
    cpi c6 cdiv co cpi c2 cdiv co clt wbr wb c2 cr wcel c6 cr wcel cpi cr wcel
    2re 6re pire 3pm3.2i c2 c6 cpi ltdiv2 mpan mp3an mpbi cpi c6 cdiv co cc0
    cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel cc0 cpi c6 cdiv co clt
    wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a cc0 cr wcel cpi c2 cdiv co cr
    wcel cpi c6 cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel
    cc0 cpi c6 cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a wb 0re
    cpi c2 pire 2re 2ne0 redivcli cc0 cxr wcel cpi c2 cdiv co cxr wcel cpi c6
    cdiv co cc0 cpi c2 cdiv co cioo co wcel cpi c6 cdiv co cr wcel cc0 cpi c6
    cdiv co clt wbr cpi c6 cdiv co cpi c2 cdiv co clt wbr w3a wb cc0 cr wcel
    cpi c2 cdiv co cr wcel cc0 cpi c2 cdiv co cpi c6 cdiv co elioo2 cc0 rexr
    cpi c2 cdiv co rexr syl2an mp2an biimpri mp3an cpi c6 cdiv co sincosq1sgn
    ax-mp pm3.27i ltleii cpi c6 cdiv co ccos cfv cpi c6 cdiv co cr wcel cpi c6
    cdiv co ccos cfv cr wcel cpi c6 pire 6re c6 6re 6pos gt0ne0ii redivcli cpi
    c6 cdiv co recoscl ax-mp sqrsqi ax-mp c3 csqr cfv c2 cdiv co c2 cexp co
    csqr cfv c3 c4 cdiv co csqr cfv c3 csqr cfv c2 cdiv co c3 csqr cfv c2 cdiv
    co c2 cexp co c3 c4 cdiv co csqr c3 csqr cfv c2 cdiv co c2 cexp co c3 csqr
    cfv c2 cexp co c2 c2 cexp co cdiv co c3 c4 cdiv co c3 csqr cfv c2 c3 csqr
    cfv c3 3re 3pos sqrlem24 recni 2cn 2ne0 sqdivi c3 csqr cfv c2 cexp co c3 c2
    c2 cexp co c4 cdiv cc0 c3 cle wbr c3 csqr cfv c2 cexp co c3 wceq cc0 c3 0re
    3re 3pos ltleii c3 3re sqsqri ax-mp sq2 opreq12i eqtri fveq2i cc0 c3 csqr
    cfv c2 cdiv co cle wbr c3 csqr cfv c2 cdiv co c2 cexp co csqr cfv c3 csqr
    cfv c2 cdiv co wceq cc0 c3 csqr cfv cle wbr cc0 c2 clt wbr cc0 c3 csqr cfv
    c2 cdiv co cle wbr cc0 c3 cle wbr cc0 c3 csqr cfv cle wbr cc0 c3 0re 3re
    3pos ltleii c3 3re sqrge0i ax-mp 2pos c3 csqr cfv c2 c3 3re 3pos sqrlem24
    2re divge0i mp2an c3 csqr cfv c2 cdiv co c3 csqr cfv c2 c3 3re 3pos
    sqrlem24 2re 2ne0 redivcli sqrsqi ax-mp eqtr3i 3eqtr3i pm3.2i $.
    $( [25-Jan-2008] $) $( [25-Jan-2008] $)

  $( The absolute value of sine has period ` pi ` . $)
  abssinper $p |- ( ( A e. CC /\ K e. ZZ )
      -> ( abs ` ( sin ` ( A + ( K x. pi ) ) ) ) = ( abs ` ( sin ` A ) ) ) $=
    cA cc wcel cK cz wcel wa cK c2 cdiv co cz wcel cK c1 caddc co c2 cdiv co cz
    wcel wo cA cK cpi cmul co caddc co csin cfv cabs cfv cA csin cfv cabs cfv
    wceq cK cz wcel cK c2 cdiv co cz wcel cK c1 caddc co c2 cdiv co cz wcel wo
    cA cc wcel cK zeo adantl cA cc wcel cK cz wcel wa cK c2 cdiv co cz wcel cA
    cK cpi cmul co caddc co csin cfv cabs cfv cA csin cfv cabs cfv wceq cK c1
    caddc co c2 cdiv co cz wcel cA cc wcel cK cz wcel wa cK c2 cdiv co cz wcel
    wa cA cK cpi cmul co caddc co csin cfv cA csin cfv cabs cA cc wcel cK cz
    wcel wa cK c2 cdiv co cz wcel wa cA cK cpi cmul co caddc co csin cfv cA cK
    c2 cdiv co c2 cpi cmul co cmul co caddc co csin cfv cA csin cfv cA cc wcel
    cK cz wcel wa cA cK cpi cmul co caddc co csin cfv cA cK c2 cdiv co c2 cpi
    cmul co cmul co caddc co csin cfv wceq cK c2 cdiv co cz wcel cA cc wcel cK
    cz wcel wa cA cK c2 cdiv co c2 cpi cmul co cmul co caddc co csin cfv cA cK
    cpi cmul co caddc co csin cfv cA cc wcel cK cz wcel wa cA cK c2 cdiv co c2
    cpi cmul co cmul co caddc co cA cK cpi cmul co caddc co csin cA cc wcel cK
    cz wcel wa cK c2 cdiv co c2 cpi cmul co cmul co cK cpi cmul co cA caddc cK
    cz wcel cK c2 cdiv co c2 cpi cmul co cmul co cK cpi cmul co wceq cA cc wcel
    cK cz wcel cK cc wcel cK c2 cdiv co c2 cpi cmul co cmul co cK cpi cmul co
    wceq cK zcn cK cc wcel cK c2 cdiv co c2 cmul co cpi cmul co cK c2 cdiv co
    c2 cpi cmul co cmul co cK cpi cmul co cK cc wcel cK c2 cdiv co cc wcel cK
    c2 cdiv co c2 cmul co cpi cmul co cK c2 cdiv co c2 cpi cmul co cmul co wceq
    cK halfcl cK c2 cdiv co cc wcel c2 cc wcel cpi cc wcel cK c2 cdiv co c2
    cmul co cpi cmul co cK c2 cdiv co c2 cpi cmul co cmul co wceq 2cn cpi pire
    recni cK c2 cdiv co c2 cpi mulass mp3an23 syl cK cc wcel cK c2 cdiv co c2
    cmul co cK cpi cmul cK cc wcel c2 cc wcel c2 cc0 wne cK c2 cdiv co c2 cmul
    co cK wceq 2cn 2ne0 cK c2 divcan1 mp3an23 opreq1d eqtr3d syl adantl opreq2d
    fveq2d eqcomd adantr cA cc wcel cK c2 cdiv co cz wcel cA cK c2 cdiv co c2
    cpi cmul co cmul co caddc co csin cfv cA csin cfv wceq cK cz wcel cA cK c2
    cdiv co sinper adantlr eqtrd fveq2d cA cc wcel cK cz wcel wa cK c1 caddc co
    c2 cdiv co cz wcel wa cA cK cpi cmul co caddc co csin cfv cabs cfv cA csin
    cfv cneg cabs cfv cA csin cfv cabs cfv cA cc wcel cK cz wcel wa cK c1 caddc
    co c2 cdiv co cz wcel wa cA cK cpi cmul co caddc co csin cfv cA csin cfv
    cneg cabs cA cc wcel cK cz wcel wa cK c1 caddc co c2 cdiv co cz wcel wa cA
    cK cpi cmul co caddc co csin cfv cA cpi cmin co cK c1 caddc co c2 cdiv co
    c2 cpi cmul co cmul co caddc co csin cfv cA cpi cmin co csin cfv cA csin
    cfv cneg cA cc wcel cK cz wcel wa cA cK cpi cmul co caddc co csin cfv cA
    cpi cmin co cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co caddc co csin
    cfv wceq cK c1 caddc co c2 cdiv co cz wcel cA cc wcel cK cz wcel wa cA cK
    cpi cmul co caddc co cA cpi cmin co cK c1 caddc co c2 cdiv co c2 cpi cmul
    co cmul co caddc co csin cA cc wcel cK cc wcel cA cK cpi cmul co caddc co
    cA cpi cmin co cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co caddc co
    wceq cK cz wcel cA cc wcel cK cc wcel wa cA cpi cmin co cK c1 caddc co c2
    cdiv co c2 cpi cmul co cmul co caddc co cA cK c1 caddc co c2 cdiv co c2 cpi
    cmul co cmul co cpi cmin co caddc co cA cK cpi cmul co caddc co cA cc wcel
    cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co cc wcel cA cpi cmin co cK
    c1 caddc co c2 cdiv co c2 cpi cmul co cmul co caddc co cA cK c1 caddc co c2
    cdiv co c2 cpi cmul co cmul co cpi cmin co caddc co wceq cK cc wcel cA cc
    wcel cpi cc wcel cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co cc wcel
    cA cpi cmin co cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co caddc co cA
    cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co cpi cmin co caddc co wceq
    cpi pire recni cA cpi cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co
    subadd23 mp3an2 cK cc wcel cK c1 caddc co c2 cdiv co cc wcel cK c1 caddc co
    c2 cdiv co c2 cpi cmul co cmul co cc wcel cK cc wcel cK c1 caddc co cc wcel
    cK c1 caddc co c2 cdiv co cc wcel cK peano2cn cK c1 caddc co halfcl syl cK
    c1 caddc co c2 cdiv co cc wcel c2 cpi cmul co cc wcel cK c1 caddc co c2
    cdiv co c2 cpi cmul co cmul co cc wcel c2 cpi 2cn cpi pire recni mulcli cK
    c1 caddc co c2 cdiv co c2 cpi cmul co mulcl mpan2 syl sylan2 cA cc wcel cK
    cc wcel wa cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co cpi cmin co cK
    cpi cmul co cA caddc cK cc wcel cK c1 caddc co c2 cdiv co c2 cpi cmul co
    cmul co cpi cmin co cK cpi cmul co wceq cA cc wcel cK cc wcel cK c1 caddc
    co c2 cdiv co c2 cpi cmul co cmul co cpi cmin co cK cpi cmul co cpi caddc
    co cpi cmin co cK cpi cmul co cK cc wcel cK c1 caddc co c2 cdiv co c2 cpi
    cmul co cmul co cK cpi cmul co cpi caddc co cpi cmin cK cc wcel cK cpi cmul
    co cpi caddc co cK c1 caddc co c2 cdiv co c2 cmul co cpi cmul co cK c1
    caddc co c2 cdiv co c2 cpi cmul co cmul co cK cc wcel cK c1 caddc co c2
    cdiv co c2 cmul co cpi cmul co cK c1 caddc co cpi cmul co cK cpi cmul co c1
    cpi cmul co caddc co cK cpi cmul co cpi caddc co cK cc wcel cK c1 caddc co
    c2 cdiv co c2 cmul co cK c1 caddc co cpi cmul cK cc wcel cK c1 caddc co cc
    wcel cK c1 caddc co c2 cdiv co c2 cmul co cK c1 caddc co wceq cK peano2cn
    cK c1 caddc co cc wcel c2 cc wcel c2 cc0 wne cK c1 caddc co c2 cdiv co c2
    cmul co cK c1 caddc co wceq 2cn 2ne0 cK c1 caddc co c2 divcan1 mp3an23 syl
    opreq1d cK cc wcel c1 cc wcel cpi cc wcel cK c1 caddc co cpi cmul co cK cpi
    cmul co c1 cpi cmul co caddc co wceq ax1cn cpi pire recni cK c1 cpi adddir
    mp3an23 cK cpi cmul co c1 cpi cmul co caddc co cK cpi cmul co cpi caddc co
    wceq cK cc wcel c1 cpi cmul co cpi cK cpi cmul co caddc cpi cpi pire recni
    mulid2i opreq2i a1i 3eqtrrd cK cc wcel cK c1 caddc co c2 cdiv co cc wcel cK
    c1 caddc co c2 cdiv co c2 cmul co cpi cmul co cK c1 caddc co c2 cdiv co c2
    cpi cmul co cmul co wceq cK cc wcel cK c1 caddc co cc wcel cK c1 caddc co
    c2 cdiv co cc wcel cK peano2cn cK c1 caddc co halfcl syl cK c1 caddc co c2
    cdiv co cc wcel c2 cc wcel cpi cc wcel cK c1 caddc co c2 cdiv co c2 cmul co
    cpi cmul co cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co wceq 2cn cpi
    pire recni cK c1 caddc co c2 cdiv co c2 cpi mulass mp3an23 syl eqtr2d
    opreq1d cK cc wcel cK cpi cmul co cc wcel cK cpi cmul co cpi caddc co cpi
    cmin co cK cpi cmul co wceq cK cc wcel cpi cc wcel cK cpi cmul co cc wcel
    cpi pire recni cK cpi mulcl mpan2 cK cpi cmul co cc wcel cpi cc wcel cK cpi
    cmul co cpi caddc co cpi cmin co cK cpi cmul co wceq cpi pire recni cK cpi
    cmul co cpi pncan mpan2 syl eqtrd adantl opreq2d eqtr2d cK zcn sylan2
    fveq2d adantr cA cc wcel cK c1 caddc co c2 cdiv co cz wcel cA cpi cmin co
    cK c1 caddc co c2 cdiv co c2 cpi cmul co cmul co caddc co csin cfv cA cpi
    cmin co csin cfv wceq cK cz wcel cA cpi cmin co cc wcel cK c1 caddc co c2
    cdiv co cz wcel cA cpi cmin co cK c1 caddc co c2 cdiv co c2 cpi cmul co
    cmul co caddc co csin cfv cA cpi cmin co csin cfv wceq cA cc wcel cA cpi
    cmin co cK c1 caddc co c2 cdiv co sinper cA cc wcel cpi cc wcel cA cpi cmin
    co cc wcel cpi pire recni cA cpi subcl mpan2 sylan adantlr cA cc wcel cA
    cpi cmin co csin cfv cA csin cfv cneg wceq cK cz wcel cK c1 caddc co c2
    cdiv co cz wcel cA sinmpi ad2antrr 3eqtrd fveq2d cA cc wcel cA csin cfv
    cneg cabs cfv cA csin cfv cabs cfv wceq cK cz wcel cK c1 caddc co c2 cdiv
    co cz wcel cA cc wcel cA csin cfv cc wcel cA csin cfv cneg cabs cfv cA csin
    cfv cabs cfv wceq cA sincl cA csin cfv absneg syl ad2antrr eqtrd jaodan
    mpdan $.
    $( [18-Aug-2008] $) $( [17-Aug-2008] $)

  $( The sine of an integer multiple of ` pi ` is 0. $)
  sinkpi $p |- ( K e. ZZ -> ( sin ` ( K x. pi ) ) = 0 ) $=
    cK cz wcel cc0 cK cpi cmul co caddc co csin cfv cK cpi cmul co csin cfv cc0
    cK cz wcel cc0 cK cpi cmul co caddc co cK cpi cmul co csin cK cz wcel cK cc
    wcel cK cpi cmul co cc wcel cc0 cK cpi cmul co caddc co cK cpi cmul co wceq
    cK zcn cK cc wcel cpi cc wcel cK cpi cmul co cc wcel cpi pire recni cK cpi
    mulcl mpan2 cK cpi cmul co addid2 3syl fveq2d cK cz wcel cc0 cK cpi cmul co
    caddc co csin cfv cabs cfv cc0 wceq cc0 cK cpi cmul co caddc co csin cfv
    cc0 wceq cK cz wcel cc0 cK cpi cmul co caddc co csin cfv cabs cfv cc0 csin
    cfv cabs cfv cc0 cc0 cc wcel cK cz wcel cc0 cK cpi cmul co caddc co csin
    cfv cabs cfv cc0 csin cfv cabs cfv wceq 0cn cc0 cK abssinper mpan cc0 csin
    cfv cabs cfv cc0 cabs cfv cc0 cc0 csin cfv cc0 cabs sin0 fveq2i abs0 eqtri
    syl6eq cK cz wcel cc0 cK cpi cmul co caddc co cc wcel cc0 cK cpi cmul co
    caddc co csin cfv cc wcel cc0 cK cpi cmul co caddc co csin cfv cabs cfv cc0
    wceq cc0 cK cpi cmul co caddc co csin cfv cc0 wceq wb cK cz wcel cK cc wcel
    cK cpi cmul co cc wcel cc0 cK cpi cmul co caddc co cc wcel cK zcn cK cc
    wcel cpi cc wcel cK cpi cmul co cc wcel cpi pire recni cK cpi mulcl mpan2
    cc0 cc wcel cK cpi cmul co cc wcel cc0 cK cpi cmul co caddc co cc wcel 0cn
    cc0 cK cpi cmul co addcl mpan 3syl cc0 cK cpi cmul co caddc co sincl cc0 cK
    cpi cmul co caddc co csin cfv abs00 3syl mpbid eqtr3d $.
    $( [11-Aug-2008] $) $( [11-Aug-2008] $)

  $( The absolute value of the cosine of an integer multiple of ` pi ` is 1. $)
  coskpi $p |- ( K e. ZZ -> ( abs ` ( cos ` ( K x. pi ) ) ) = 1 ) $=
    cK cz wcel cK cpi cmul co ccos cfv cabs cfv c1 cabs cfv c1 cK cz wcel cK
    cpi cmul co ccos cfv c2 cexp co c1 c2 cexp co wceq cK cpi cmul co ccos cfv
    cabs cfv c1 cabs cfv wceq cK cz wcel cK cpi cmul co ccos cfv c2 cexp co c1
    c1 c2 cexp co cK cz wcel c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c2
    c1 cmul co wceq cK cpi cmul co ccos cfv c2 cexp co c1 wceq cK cz wcel c1 c1
    caddc co c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c2 c1 cmul co cK cz
    wcel c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c1 cmin co c1 wceq c1 c1
    caddc co c2 cK cpi cmul co ccos cfv c2 cexp co cmul co wceq cK cz wcel c2
    cK cpi cmul co ccos cfv c2 cexp co cmul co c1 cmin co cK c2 cpi cmul co
    cmul co ccos cfv c1 cK cz wcel cK c2 cpi cmul co cmul co ccos cfv c2 cK cpi
    cmul co cmul co ccos cfv c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c1
    cmin co cK cz wcel cK c2 cpi cmul co cmul co c2 cK cpi cmul co cmul co ccos
    cK cz wcel cK cc wcel cK c2 cpi cmul co cmul co c2 cK cpi cmul co cmul co
    wceq cK zcn cK cc wcel c2 cc wcel cpi cc wcel cK c2 cpi cmul co cmul co c2
    cK cpi cmul co cmul co wceq 2cn cpi pire recni cK c2 cpi mul12 mp3an23 syl
    fveq2d cK cz wcel cK cpi cmul co cc wcel c2 cK cpi cmul co cmul co ccos cfv
    c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c1 cmin co wceq cK cz wcel cK
    cpi cmul co cK cz wcel cK cr wcel cK cpi cmul co cr wcel cK zre cK cr wcel
    cpi cr wcel cK cpi cmul co cr wcel pire cK cpi remulcl mpan2 syl recnd cK
    cpi cmul co cos2t syl eqtr2d cK cos2kpi eqtrd cK cz wcel c2 cK cpi cmul co
    ccos cfv c2 cexp co cmul co cc wcel c2 cK cpi cmul co ccos cfv c2 cexp co
    cmul co c1 cmin co c1 wceq c1 c1 caddc co c2 cK cpi cmul co ccos cfv c2
    cexp co cmul co wceq wb cK cz wcel cK cpi cmul co ccos cfv c2 cexp co cc
    wcel c2 cK cpi cmul co ccos cfv c2 cexp co cmul co cc wcel cK cz wcel cK
    cpi cmul co ccos cfv cc wcel cK cpi cmul co ccos cfv c2 cexp co cc wcel cK
    cz wcel cK cpi cmul co ccos cfv cK cz wcel cK cpi cmul co cr wcel cK cpi
    cmul co ccos cfv cr wcel cK cz wcel cK cr wcel cK cpi cmul co cr wcel cK
    zre cK cr wcel cpi cr wcel cK cpi cmul co cr wcel pire cK cpi remulcl mpan2
    syl cK cpi cmul co recoscl syl recnd cK cpi cmul co ccos cfv sqcl syl c2 cc
    wcel cK cpi cmul co ccos cfv c2 cexp co cc wcel c2 cK cpi cmul co ccos cfv
    c2 cexp co cmul co cc wcel 2cn c2 cK cpi cmul co ccos cfv c2 cexp co mulcl
    mpan syl c2 cK cpi cmul co ccos cfv c2 cexp co cmul co cc wcel c1 cc wcel
    c1 cc wcel c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c1 cmin co c1 wceq
    c1 c1 caddc co c2 cK cpi cmul co ccos cfv c2 cexp co cmul co wceq wb ax1cn
    ax1cn c2 cK cpi cmul co ccos cfv c2 cexp co cmul co c1 c1 subadd mp3an23
    syl mpbid c2 c1 cmul co c2 c1 c1 caddc co c2 2cn mulid1i df-2 eqtr2i
    syl5reqr cK cz wcel cK cpi cmul co ccos cfv c2 cexp co cc wcel c2 cK cpi
    cmul co ccos cfv c2 cexp co cmul co c2 c1 cmul co wceq cK cpi cmul co ccos
    cfv c2 cexp co c1 wceq wb cK cz wcel cK cpi cmul co ccos cfv cc wcel cK cpi
    cmul co ccos cfv c2 cexp co cc wcel cK cz wcel cK cpi cmul co ccos cfv cK
    cz wcel cK cpi cmul co cr wcel cK cpi cmul co ccos cfv cr wcel cK cz wcel
    cK cr wcel cK cpi cmul co cr wcel cK zre cK cr wcel cpi cr wcel cK cpi cmul
    co cr wcel pire cK cpi remulcl mpan2 syl cK cpi cmul co recoscl syl recnd
    cK cpi cmul co ccos cfv sqcl syl cK cpi cmul co ccos cfv c2 cexp co cc wcel
    c1 cc wcel c2 cc wcel c2 cc0 wne wa c2 cK cpi cmul co ccos cfv c2 cexp co
    cmul co c2 c1 cmul co wceq cK cpi cmul co ccos cfv c2 cexp co c1 wceq wb
    ax1cn c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i cK cpi cmul co ccos cfv c2 cexp
    co c1 c2 mulcan mp3an23 syl mpbid sq1 syl6eqr cK cz wcel cK cpi cmul co
    ccos cfv cr wcel cK cpi cmul co ccos cfv c2 cexp co c1 c2 cexp co wceq cK
    cpi cmul co ccos cfv cabs cfv c1 cabs cfv wceq wb cK cz wcel cK cpi cmul co
    cr wcel cK cpi cmul co ccos cfv cr wcel cK cz wcel cK cr wcel cK cpi cmul
    co cr wcel cK zre cK cr wcel cpi cr wcel cK cpi cmul co cr wcel pire cK cpi
    remulcl mpan2 syl cK cpi cmul co recoscl syl cK cpi cmul co ccos cfv cr
    wcel c1 cr wcel cK cpi cmul co ccos cfv c2 cexp co c1 c2 cexp co wceq cK
    cpi cmul co ccos cfv cabs cfv c1 cabs cfv wceq wb 1re cK cpi cmul co ccos
    cfv c1 sqabs mpan2 syl mpbid cc0 c1 cle wbr c1 cabs cfv c1 wceq cc0 c1 0re
    1re lt01 ltleii c1 1re absidi ax-mp syl6eq $.
    $( [15-Jan-2009] $) $( [19-Aug-2008] $)

  $( A real number whose sine is zero is an integer multiple of ` pi ` . $)
  sineq0 $p |- ( ( A e. RR /\ ( sin ` A ) = 0 )
       -> A = ( ( |_ ` ( A / pi ) ) x. pi ) ) $=
    cA cr wcel cA csin cfv cc0 wceq wa cA cA cpi cdiv co cfl cfv cpi cmul co cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co cA cpi cdiv
    co cfl cfv cpi cmul co cc0 caddc co cA cpi cdiv co cfl cfv cpi cmul co cA
    cr wcel cA cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co caddc co wceq cA csin cfv cc0 wceq cA cr wcel
    cA cpi cdiv co cpi cmul co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co caddc co cpi cmul co cA cA cpi cdiv co cfl cfv cpi
    cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co
    cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co caddc co cpi cmul cA cr wcel cA cpi cdiv co cr wcel cA
    cpi cdiv co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co caddc co wceq cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr
    wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co cr
    wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv co cA cpi cdiv co
    cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co wceq cA cpi
    cdiv co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi cdiv co cfl
    cfv cA cpi cdiv co cfl cfv eqid cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co eqid intfrac2 3simp3d syl opreq1d cA cr wcel cA cc wcel cA cpi cdiv co
    cpi cmul co cA wceq cA recn cA cc wcel cpi cc wcel cpi cc0 wne cA cpi cdiv
    co cpi cmul co cA wceq cpi pire recni cpi pire pipos gt0ne0ii cA cpi
    divcan1 mp3an23 syl cA cpi cdiv co cfl cfv cc wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cc wcel cA cpi cdiv co cfl cfv cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv co cfl cfv cpi
    cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co
    wceq cA cr wcel cA cpi cdiv co cfl cfv cc wcel cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cc wcel cpi cc wcel cA cpi cdiv co cfl cfv cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv co cfl
    cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    caddc co wceq cpi pire recni cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi adddir mp3an3 cA cr wcel cA cpi cdiv co cfl cfv
    cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel
    cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii
    cA cpi redivcl mp3an23 cA cpi cdiv co reflcl syl recnd cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi cdiv co cr wcel cA cpi cdiv
    co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cA
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv resubcl cA cr wcel cpi cr
    wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi
    redivcl mp3an23 cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr
    wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co reflcl syl sylanc
    recnd sylanc 3eqtr3d adantr cA cr wcel cA csin cfv cc0 wceq wa cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 cA cpi cdiv co cfl cfv
    cpi cmul co caddc cA cr wcel cA csin cfv cc0 wceq wa cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wceq cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co cc0 wceq cA cr wcel cA csin cfv cc0
    wceq wa cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv
    cabs cfv cc0 wceq cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cc0 wceq cA cr wcel cA csin cfv cc0 wceq wa cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co csin cfv cabs cfv cA csin cfv cabs cfv
    cc0 cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cabs cfv cA csin cfv cabs cfv wceq cA csin cfv cc0 wceq cA cr wcel
    cA csin cfv cabs cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cA cpi cdiv co cfl cfv cpi cmul co caddc co csin cfv cabs cfv cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cabs cfv cA cr
    wcel cA csin cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cA cpi cdiv co cfl cfv cpi cmul co caddc co csin cfv cabs cA cr wcel cA cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv co cfl
    cfv cpi cmul co caddc co csin cA cr wcel cA cpi cdiv co cpi cmul co cA cpi
    cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co caddc co cA cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co cA cpi cdiv co cfl cfv cpi cmul co caddc co cA cr wcel cA cpi cdiv
    co cpi cmul co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co caddc co cpi cmul co cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co caddc co cpi cmul cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co
    wceq cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co cr wcel cc0 cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co wceq cA cpi cdiv co cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi cdiv co cfl cfv cA cpi
    cdiv co cfl cfv eqid cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co eqid
    intfrac2 3simp3d syl opreq1d cA cpi cdiv co cfl cfv cc wcel cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cc wcel cA cpi cdiv co cfl cfv cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv co cfl
    cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    caddc co wceq cA cr wcel cA cpi cdiv co cfl cfv cc wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cc wcel cpi cc wcel cA cpi cdiv co cfl cfv cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv
    co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co caddc co wceq cpi pire recni cA cpi cdiv co cfl cfv cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cpi adddir mp3an3 cA cr wcel cA cpi cdiv co
    cfl cfv cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA
    cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos
    gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co reflcl syl recnd cA cr wcel
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi cdiv co cr wcel cA cpi
    cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr
    wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv resubcl cA cr wcel
    cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii
    cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl
    cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire
    cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co reflcl syl
    sylanc recnd sylanc eqtrd cA cr wcel cA cc wcel cA cpi cdiv co cpi cmul co
    cA wceq cA recn cA cc wcel cpi cc wcel cpi cc0 wne cA cpi cdiv co cpi cmul
    co cA wceq cpi pire recni cpi pire pipos gt0ne0ii cA cpi divcan1 mp3an23
    syl cA cpi cdiv co cfl cfv cpi cmul co cc wcel cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cc wcel cA cpi cdiv co cfl cfv cpi cmul co
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv co cfl cfv
    cpi cmul co caddc co wceq cA cr wcel cA cpi cdiv co cfl cfv cpi cmul co cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co addcom cA cr wcel cA
    cpi cdiv co cfl cfv cpi cmul co cA cr wcel cA cpi cdiv co cfl cfv cr wcel
    cA cpi cdiv co cfl cfv cpi cmul co cr wcel cA cr wcel cA cpi cdiv co cr
    wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co reflcl syl cA cpi cdiv co cfl cfv cr wcel cpi cr wcel cA cpi
    cdiv co cfl cfv cpi cmul co cr wcel pire cA cpi cdiv co cfl cfv cpi remulcl
    mpan2 syl recnd cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi remulcl mpan2 syl recnd sylanc 3eqtr3d fveq2d fveq2d cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co cc wcel cA cpi cdiv co cfl cfv cz
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv
    co cfl cfv cpi cmul co caddc co csin cfv cabs cfv cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co csin cfv cabs cfv wceq cA cr wcel cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv co cfl
    cfv abssinper cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr
    wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi remulcl
    mpan2 syl recnd cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cz
    wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co flcl syl sylanc
    eqtr2d adantr cA cr wcel cA csin cfv cabs cfv cc0 wceq cA csin cfv cc0 wceq
    cA cr wcel cA csin cfv cc wcel cA csin cfv cabs cfv cc0 wceq cA csin cfv
    cc0 wceq wb cA cr wcel cA csin cfv cA resincl recnd cA csin cfv abs00 syl
    biimpar eqtrd cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co csin cfv cabs cfv cc0 wceq cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co csin cfv cc0 wceq wb cA csin cfv cc0 wceq cA cr wcel cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc wcel cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cabs cfv
    cc0 wceq cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv
    cc0 wceq wb cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co csin cfv cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co csin cfv cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr
    wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co
    cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel
    cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi
    redivcl mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co resincl syl recnd cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co csin cfv abs00 syl adantr mpbid cA cr wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wceq cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wceq wi cA csin cfv cc0 wceq cA
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 cA cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wne cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wne cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cr wcel cc0
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv clt wbr
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wne
    cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0
    wne wa cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv
    gt0ne0 cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cc0 wne cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin
    cfv cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co resincl syl adantr cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cc0 wne wa cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co csin cfv clt wbr cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co cc0 wne wa cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cpi clt wbr wa cA cr wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wne wa cc0 cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cpi clt wbr cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co cc0 wne cc0 cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cr wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cle wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cc0 wne cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co clt wbr wb cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co ne0gt0 cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel
    cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel
    cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cc0 cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co cle wbr cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cc0 cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cle wbr wa cpi cr wcel cc0 cpi cle wbr cc0 cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cle wbr pire cc0 cpi 0re
    pire pipos ltleii cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi mulge0
    mpanr12 cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co
    cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel
    cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi
    redivcl mp3an23 cA cpi cdiv co reflcl syl sylanc cA cr wcel cA cpi cdiv co
    cr wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cA cr
    wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos
    gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co fracge0 syl sylanc sylanc
    biimpa cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cpi clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0
    wne cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co c1
    cpi cmul co cpi clt cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co c1 clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co c1
    cpi cmul co clt wbr cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co c1 clt wbr cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co fraclt1 syl cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co c1 cpi cmul co clt
    wbr wb cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co
    cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel
    cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi
    redivcl mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cr wcel c1 cr wcel cpi cr wcel cc0 cpi clt wbr wa cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co c1 cpi cmul co clt wbr wb 1re cpi cr
    wcel cc0 cpi clt wbr pire pipos pm3.2i cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co c1 cpi ltmul1 mp3an23 syl mpbid cpi cpi pire recni mulid2i
    syl6breq adantr jca cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cpi clt wbr wa wb cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cc0 wne cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cxr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cpi clt wbr wa wb cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cxr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co
    cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel
    cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi
    redivcl mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co rexr syl cc0 cxr wcel cpi cxr wcel cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cxr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cpi clt wbr wa wb cc0 cr wcel cc0 cxr wcel 0re cc0
    rexr ax-mp cpi cr wcel cpi cxr wcel pire cpi rexr ax-mp cc0 cpi cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co elioo5 mp3an12 syl adantr
    mpbird cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co sinq12gt0t
    syl sylanc ex necon4d adantr mpd opreq2d cA cr wcel cA cpi cdiv co cfl cfv
    cpi cmul co cc0 caddc co cA cpi cdiv co cfl cfv cpi cmul co wceq cA csin
    cfv cc0 wceq cA cr wcel cA cpi cdiv co cfl cfv cpi cmul co cc wcel cA cpi
    cdiv co cfl cfv cpi cmul co cc0 caddc co cA cpi cdiv co cfl cfv cpi cmul co
    wceq cA cr wcel cA cpi cdiv co cfl cfv cpi cmul co cA cr wcel cA cpi cdiv
    co cfl cfv cr wcel cA cpi cdiv co cfl cfv cpi cmul co cr wcel cA cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel
    cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi
    redivcl mp3an23 cA cpi cdiv co reflcl syl cA cpi cdiv co cfl cfv cr wcel
    cpi cr wcel cA cpi cdiv co cfl cfv cpi cmul co cr wcel pire cA cpi cdiv co
    cfl cfv cpi remulcl mpan2 syl recnd cA cpi cdiv co cfl cfv cpi cmul co
    addid1 syl adantr 3eqtrd $.
    $( [19-Aug-2008] $) $( [17-Aug-2008] $)

  $( A real number whose sine is zero is an integer multiple of ` pi ` . $)
  sineq0OLD $p |- ( ( A e. RR /\ ( sin ` A ) = 0 )
       -> A = ( ( |_ ` ( A / pi ) ) x. pi ) ) $=
    cA cr wcel cA csin cfv cc0 wceq wa cA cA cpi cdiv co cfl cfv cpi cmul co
    cc0 caddc co cA cpi cdiv co cfl cfv cpi cmul co cA cr wcel cA csin cfv cc0
    wceq wa cA cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co caddc co cA cpi cdiv co cfl cfv cpi cmul co cc0
    caddc co cA cr wcel cA cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co caddc co wceq cA csin cfv cc0 wceq
    cA cr wcel cA cpi cdiv co cpi cmul co cA cA cpi cdiv co cfl cfv cpi cmul co
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co cA cr
    wcel cA cc wcel cA cpi cdiv co cpi cmul co cA wceq cA recn cA cc wcel cpi
    cc wcel cpi cc0 wne cA cpi cdiv co cpi cmul co cA wceq cpi pire recni cpi
    pire pipos gt0ne0ii cA cpi divcan1 mp3an23 syl cA cr wcel cA cpi cdiv co
    cpi cmul co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co caddc co cpi cmul co cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co caddc co cpi cmul cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co
    wceq cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co cr wcel cc0 cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co wceq cA cpi cdiv co cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi cdiv co cfl cfv cA cpi
    cdiv co cfl cfv eqid cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co eqid
    intfrac2 3simp3d syl opreq1d cA cpi cdiv co cfl cfv cc wcel cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cc wcel cA cpi cdiv co cfl cfv cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv co cfl
    cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    caddc co wceq cA cr wcel cA cpi cdiv co cfl cfv cc wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cc wcel cpi cc wcel cA cpi cdiv co cfl cfv cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv
    co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co caddc co wceq cpi pire recni cA cpi cdiv co cfl cfv cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cpi adddir mp3an3 cA cr wcel cA cpi cdiv co
    cfl cfv cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA
    cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos
    gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co reflcl syl recnd cA cr wcel
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi cdiv co cr wcel cA cpi
    cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr
    wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv resubcl cA cr wcel
    cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii
    cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl
    cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire
    cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co reflcl syl
    sylanc recnd sylanc eqtrd eqtr3d adantr cA cr wcel cA csin cfv cc0 wceq wa
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 cA cpi cdiv
    co cfl cfv cpi cmul co caddc cA cr wcel cA csin cfv cc0 wceq wa cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wceq cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wceq cA cr wcel cA csin
    cfv cc0 wceq wa cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cabs cfv cc0 wceq cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co csin cfv cc0 wceq cA cr wcel cA csin cfv cc0 wceq wa cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cabs cfv cA
    csin cfv cabs cfv cc0 cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co csin cfv cabs cfv cA csin cfv cabs cfv wceq cA csin cfv cc0
    wceq cA cr wcel cA csin cfv cabs cfv cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cA cpi cdiv co cfl cfv cpi cmul co caddc co csin cfv
    cabs cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv
    cabs cfv cA cr wcel cA csin cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cA cpi cdiv co cfl cfv cpi cmul co caddc co csin cfv cabs cA
    cr wcel cA cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi
    cdiv co cfl cfv cpi cmul co caddc co csin cA cr wcel cA cA cpi cdiv co cfl
    cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    caddc co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi
    cdiv co cfl cfv cpi cmul co caddc co cA cr wcel cA cpi cdiv co cpi cmul co
    cA cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co caddc co cA cr wcel cA cc wcel cA cpi cdiv co cpi cmul
    co cA wceq cA recn cA cc wcel cpi cc wcel cpi cc0 wne cA cpi cdiv co cpi
    cmul co cA wceq cpi pire recni cpi pire pipos gt0ne0ii cA cpi divcan1
    mp3an23 syl cA cr wcel cA cpi cdiv co cpi cmul co cA cpi cdiv co cfl cfv cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co cA cpi cdiv
    co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co caddc co cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul cA cr wcel cA cpi
    cdiv co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co caddc co wceq cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co cr wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle
    wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv co
    cA cpi cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc
    co wceq cA cpi cdiv co cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cA cpi
    cdiv co cfl cfv cA cpi cdiv co cfl cfv eqid cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co eqid intfrac2 3simp3d syl opreq1d cA cpi cdiv co cfl cfv cc
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cc wcel cA cpi cdiv co
    cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co cpi cmul co
    cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co caddc co wceq cA cr wcel cA cpi cdiv co cfl cfv cc wcel
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cc wcel cpi cc wcel cA cpi
    cdiv co cfl cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co caddc co cpi
    cmul co cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co caddc co wceq cpi pire recni cA cpi cdiv co cfl
    cfv cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi adddir mp3an3 cA cr
    wcel cA cpi cdiv co cfl cfv cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv
    co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr
    wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co
    reflcl syl recnd cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc recnd sylanc eqtrd eqtr3d cA cpi
    cdiv co cfl cfv cpi cmul co cc wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cc wcel cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co caddc co cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv co cfl cfv cpi cmul co
    caddc co wceq cA cr wcel cA cpi cdiv co cfl cfv cpi cmul co cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cpi cmul co addcom cA cr wcel cA cpi cdiv co
    cfl cfv cpi cmul co cA cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv
    co cfl cfv cpi cmul co cr wcel cA cr wcel cA cpi cdiv co cr wcel cA cpi
    cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co
    cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co
    reflcl syl cA cpi cdiv co cfl cfv cr wcel cpi cr wcel cA cpi cdiv co cfl
    cfv cpi cmul co cr wcel pire cA cpi cdiv co cfl cfv cpi remulcl mpan2 syl
    recnd cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA cpi cdiv co
    cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr
    wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi remulcl
    mpan2 syl recnd sylanc eqtrd fveq2d fveq2d cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co cc wcel cA cpi cdiv co cfl cfv cz wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv co cfl cfv
    cpi cmul co caddc co csin cfv cabs cfv cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co csin cfv cabs cfv wceq cA cr wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co cA cpi cdiv co cfl cfv abssinper cA
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cA cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA cpi cdiv co cr wcel
    cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv resubcl cA cr
    wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos
    gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr wcel cA cpi
    cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co
    cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co
    reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cpi
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel
    pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi remulcl mpan2 syl
    recnd cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cz wcel cA
    cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos
    gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co flcl syl sylanc eqtr2d
    adantr cA cr wcel cA csin cfv cabs cfv cc0 wceq cA csin cfv cc0 wceq cA cr
    wcel cA csin cfv cc wcel cA csin cfv cabs cfv cc0 wceq cA csin cfv cc0 wceq
    wb cA cr wcel cA csin cfv cA resincl recnd cA csin cfv abs00 syl biimpar
    eqtrd cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cabs cfv cc0 wceq cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co csin cfv cc0 wceq wb cA csin cfv cc0 wceq cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cabs cfv cc0
    wceq cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0
    wceq wb cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co csin cfv cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel
    cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co resincl syl recnd cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co csin cfv abs00 syl adantr mpbid cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wceq cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co cc0 wceq wi cA csin cfv cc0 wceq cA cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 cA cr wcel
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wne cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wne cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cr wcel cc0 cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv clt wbr cA
    cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv cc0 wne cA
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wne
    wa cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin cfv
    gt0ne0 cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    csin cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cc0 wne cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co csin
    cfv cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co resincl syl adantr cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cc0 wne wa cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co csin cfv clt wbr cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co cc0 wne wa cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cpi clt wbr wa cA cr wcel cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wne wa cc0 cA cpi cdiv co cA
    cpi cdiv co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co cpi clt wbr cA cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cpi cmul co cc0 wne cc0 cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cr wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co cpi cmul co cle wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cc0 wne cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co clt wbr wb cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co ne0gt0 cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel
    cA cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin
    co cpi cmul co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi remulcl mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel
    cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cc0 cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co cle wbr cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel cpi cr wcel cc0 cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cle wbr cc0 cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co cle wbr pire cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cpi cr wcel wa cc0 cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cle wbr cc0 cpi cle wbr cc0 cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cpi cmul co cle wbr cc0 cpi 0re pire pipos ltleii cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi mulge0OLD mpanr2 mpanl2 cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr
    wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co reflcl syl sylanc cA cr wcel cA cpi cdiv co cr wcel cc0 cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cle wbr cA cr wcel cpi cr wcel cpi
    cc0 wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co fracge0 syl sylanc sylanc biimpa cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cpi clt wbr cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0 wne cA cr wcel cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co c1 cpi cmul co cpi clt
    cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA cpi
    cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co c1 cpi cmul co clt wbr
    cA cr wcel cA cpi cdiv co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    cmin co c1 clt wbr cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr
    wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cpi cdiv co
    fraclt1 syl cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr
    wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co cpi cmul co c1 cpi cmul co clt wbr wb cA
    cpi cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi
    cdiv co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co
    cfl cfv resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel
    pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv
    co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0
    wne cA cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl
    mp3an23 cA cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl
    cfv cmin co cr wcel c1 cr wcel cpi cr wcel cc0 cpi clt wbr wa cA cpi cdiv
    co cA cpi cdiv co cfl cfv cmin co c1 clt wbr cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co c1 cpi cmul co clt wbr wb 1re cpi cr wcel cc0
    cpi clt wbr pire pipos pm3.2i cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    c1 cpi ltmul1 mp3an23 syl mpbid cpi cpi pire recni mulid2i syl6breq adantr
    jca cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cpi clt wbr wa wb cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cc0 wne cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cxr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cc0
    cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cpi
    clt wbr wa wb cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi
    cmul co cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co
    cxr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cr wcel
    cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co cr wcel cA cpi
    cdiv co cr wcel cA cpi cdiv co cfl cfv cr wcel cA cpi cdiv co cA cpi cdiv
    co cfl cfv cmin co cr wcel cA cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv
    resubcl cA cr wcel cpi cr wcel cpi cc0 wne cA cpi cdiv co cr wcel pire cpi
    pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA cr wcel cA cpi cdiv co cr
    wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co reflcl syl sylanc cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cr wcel cpi cr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cr wcel pire cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi remulcl
    mpan2 syl cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul co rexr
    syl cc0 cxr wcel cpi cxr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co cxr wcel cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cc0 cpi cioo co wcel cc0 cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co
    cpi cmul co clt wbr cA cpi cdiv co cA cpi cdiv co cfl cfv cmin co cpi cmul
    co cpi clt wbr wa wb cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cpi cr
    wcel cpi cxr wcel pire cpi rexr ax-mp cc0 cpi cA cpi cdiv co cA cpi cdiv co
    cfl cfv cmin co cpi cmul co elioo5 mp3an12 syl adantr mpbird cA cpi cdiv co
    cA cpi cdiv co cfl cfv cmin co cpi cmul co sinq12gt0t syl sylanc ex necon4d
    adantr mpd opreq2d eqtrd cA cr wcel cA cpi cdiv co cfl cfv cpi cmul co cc0
    caddc co cA cpi cdiv co cfl cfv cpi cmul co wceq cA csin cfv cc0 wceq cA cr
    wcel cA cpi cdiv co cfl cfv cpi cmul co cc wcel cA cpi cdiv co cfl cfv cpi
    cmul co cc0 caddc co cA cpi cdiv co cfl cfv cpi cmul co wceq cA cr wcel cA
    cpi cdiv co cfl cfv cpi cmul co cA cr wcel cA cpi cdiv co cfl cfv cr wcel
    cA cpi cdiv co cfl cfv cpi cmul co cr wcel cA cr wcel cA cpi cdiv co cr
    wcel cA cpi cdiv co cfl cfv cr wcel cA cr wcel cpi cr wcel cpi cc0 wne cA
    cpi cdiv co cr wcel pire cpi pire pipos gt0ne0ii cA cpi redivcl mp3an23 cA
    cpi cdiv co reflcl syl cA cpi cdiv co cfl cfv cr wcel cpi cr wcel cA cpi
    cdiv co cfl cfv cpi cmul co cr wcel pire cA cpi cdiv co cfl cfv cpi remulcl
    mpan2 syl recnd cA cpi cdiv co cfl cfv cpi cmul co addid1 syl adantr eqtrd
    $.
    $( [19-Aug-2008] $) $( [17-Aug-2008] $)

  $( A number whose sine is zero is real.  This theorem can be used to extend
     ~ sineq0 to complex numbers. $)
  sineq0re $p |- ( ( A e. CC /\ ( sin ` A ) = 0 ) -> A e. RR ) $=
    cA cc wcel cA csin cfv cc0 wceq cA cr wcel cA cc wcel cA csin cfv cc0 wceq
    ci c2 cA cmul co cmul co ce cfv cabs cfv c1 cabs cfv wceq cA cr wcel cA cc
    wcel cA csin cfv cc0 wceq ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    wceq ci c2 cA cmul co cmul co ce cfv cabs cfv c1 cabs cfv wceq cA cc wcel
    cA csin cfv cc0 wceq ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co
    c2 ci cmul co cdiv co cc0 wceq ci cA cmul co ce cfv ci cneg cA cmul co ce
    cfv cmin co cc0 wceq ci cA cmul co ce cfv ci cneg cA cmul co ce cfv wceq cA
    cc wcel cA csin cfv ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co
    c2 ci cmul co cdiv co cc0 cA sinval eqeq1d cA cc wcel ci cA cmul co ce cfv
    ci cneg cA cmul co ce cfv cmin co cc wcel ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv cmin co c2 ci cmul co cdiv co cc0 wceq ci cA cmul co ce cfv
    ci cneg cA cmul co ce cfv cmin co cc0 wceq wb ci cA cmul co ce cfv cc wcel
    ci cneg cA cmul co ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA cmul co
    ce cfv cmin co cc wcel cA cc wcel ci cA cmul co ce cfv ci cneg cA cmul co
    ce cfv subcl cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv cc wcel
    ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA
    cmul co efcl syl cA cc wcel ci cneg cA cmul co cc wcel ci cneg cA cmul co
    ce cfv cc wcel ci cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci
    axicn negcli ci cneg cA mulcl mpan ci cneg cA cmul co efcl syl sylanc ci cA
    cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc wcel c2 ci cmul co cc
    wcel c2 ci cmul co cc0 wne ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    cmin co c2 ci cmul co cdiv co cc0 wceq ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmin co cc0 wceq wb c2 ci 2cn axicn mulcli c2 ci 2cn axicn 2ne0
    ine0 muln0i ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co c2 ci
    cmul co diveq0 mp3an23 syl ci cA cmul co ce cfv cc wcel ci cneg cA cmul co
    ce cfv cc wcel ci cA cmul co ce cfv ci cneg cA cmul co ce cfv cmin co cc0
    wceq ci cA cmul co ce cfv ci cneg cA cmul co ce cfv wceq wb cA cc wcel ci
    cA cmul co ce cfv ci cneg cA cmul co ce cfv subeq0 cA cc wcel ci cA cmul co
    cc wcel ci cA cmul co ce cfv cc wcel ci cc wcel cA cc wcel ci cA cmul co cc
    wcel axicn ci cA mulcl mpan ci cA cmul co efcl syl cA cc wcel ci cneg cA
    cmul co cc wcel ci cneg cA cmul co ce cfv cc wcel ci cneg cc wcel cA cc
    wcel ci cneg cA cmul co cc wcel ci axicn negcli ci cneg cA mulcl mpan ci
    cneg cA cmul co efcl syl sylanc 3bitrd cA cc wcel ci cA cmul co ce cfv ci
    cA cmul co ce cfv cmul co ci cA cmul co ce cfv ci cneg cA cmul co ce cfv
    cmul co wceq ci c2 cA cmul co cmul co ce cfv cabs cfv c1 cabs cfv wceq ci
    cA cmul co ce cfv ci cneg cA cmul co ce cfv wceq cA cc wcel ci cA cmul co
    ce cfv ci cA cmul co ce cfv cmul co ci cA cmul co ce cfv ci cneg cA cmul co
    ce cfv cmul co wceq ci c2 cA cmul co cmul co ce cfv c1 wceq ci c2 cA cmul
    co cmul co ce cfv cabs cfv c1 cabs cfv wceq cA cc wcel ci cA cmul co ce cfv
    ci cA cmul co ce cfv cmul co ci c2 cA cmul co cmul co ce cfv ci cA cmul co
    ce cfv ci cneg cA cmul co ce cfv cmul co c1 cA cc wcel ci c2 cA cmul co
    cmul co ce cfv ci cA cmul co ci cA cmul co caddc co ce cfv ci cA cmul co ce
    cfv ci cA cmul co ce cfv cmul co cA cc wcel ci c2 cA cmul co cmul co ci cA
    cmul co ci cA cmul co caddc co ce cA cc wcel ci c2 cA cmul co cmul co c2 ci
    cA cmul co cmul co ci cA cmul co ci cA cmul co caddc co ci cc wcel c2 cc
    wcel cA cc wcel ci c2 cA cmul co cmul co c2 ci cA cmul co cmul co wceq
    axicn 2cn ci c2 cA mul12 mp3an12 cA cc wcel ci cA cmul co cc wcel c2 ci cA
    cmul co cmul co ci cA cmul co ci cA cmul co caddc co wceq ci cc wcel cA cc
    wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA cmul co 2times syl
    eqtrd fveq2d ci cA cmul co cc wcel ci cA cmul co cc wcel ci cA cmul co ci
    cA cmul co caddc co ce cfv ci cA cmul co ce cfv ci cA cmul co ce cfv cmul
    co wceq cA cc wcel ci cA cmul co ci cA cmul co efadd ci cc wcel cA cc wcel
    ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cc wcel cA cc wcel ci cA
    cmul co cc wcel axicn ci cA mulcl mpan sylanc eqtr2d cA cc wcel ci cA cmul
    co ci cneg cA cmul co caddc co ce cfv ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv cmul co c1 ci cA cmul co cc wcel ci cneg cA cmul co cc wcel ci cA
    cmul co ci cneg cA cmul co caddc co ce cfv ci cA cmul co ce cfv ci cneg cA
    cmul co ce cfv cmul co wceq cA cc wcel ci cA cmul co ci cneg cA cmul co
    efadd ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci
    cneg cc wcel cA cc wcel ci cneg cA cmul co cc wcel ci axicn negcli ci cneg
    cA mulcl mpan sylanc cA cc wcel ci cA cmul co ci cneg cA cmul co caddc co
    ce cfv cc0 ce cfv c1 cA cc wcel ci cA cmul co ci cneg cA cmul co caddc co
    cc0 ce cA cc wcel ci ci cneg caddc co cA cmul co ci cA cmul co ci cneg cA
    cmul co caddc co cc0 ci cc wcel ci cneg cc wcel cA cc wcel ci ci cneg caddc
    co cA cmul co ci cA cmul co ci cneg cA cmul co caddc co wceq axicn ci axicn
    negcli ci ci cneg cA adddir mp3an12 cA cc wcel cc0 cA cmul co cc0 ci ci
    cneg caddc co cA cmul co cA mul02 ci ci cneg caddc co cc0 cA cmul ci axicn
    negidi opreq1i syl5eq eqtr3d fveq2d ef0 syl6eq eqtr3d eqeq12d ci c2 cA cmul
    co cmul co ce cfv c1 cabs fveq2 syl6bi ci cA cmul co ce cfv ci cneg cA cmul
    co ce cfv ci cA cmul co ce cfv cmul opreq2 syl5 sylbid cA cc wcel ci c2 cA
    cmul co cmul co ce cfv cabs cfv c1 wceq cA cr wcel ci c2 cA cmul co cmul co
    ce cfv cabs cfv c1 cabs cfv wceq cA cc wcel cA cr wcel c2 cA cmul co cr
    wcel ci c2 cA cmul co cmul co ce cfv cabs cfv c1 wceq cA cc wcel c2 cr wcel
    c2 cc0 wne cA cr wcel c2 cA cmul co cr wcel wb 2re 2ne0 cA c2 mulre mp3an23
    cA cc wcel c2 cA cmul co cc wcel c2 cA cmul co cr wcel ci c2 cA cmul co
    cmul co ce cfv cabs cfv c1 wceq wb c2 cc wcel cA cc wcel c2 cA cmul co cc
    wcel 2cn c2 cA mulcl mpan c2 cA cmul co absefib syl bitr2d c1 cabs cfv c1
    ci c2 cA cmul co cmul co ce cfv cabs cfv cc0 c1 cle wbr c1 cabs cfv c1 wceq
    cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp eqeq2i syl5bb sylibd imp $.
    $( [30-Mar-2009] $) $( [21-Aug-2008] $)

  ${
    cosh111lem1.1 $e |- A e. RR $.
    cosh111lem1.2 $e |- B e. RR $.
    cosh111lem1.3 $e |- 0 <_ A $.
    cosh111lem1.4 $e |- 0 <_ B $.
    cosh111lem1.5 $e |- A < pi $.
    cosh111lem1.6 $e |- B < pi $.
    $( Lemma for ~ cosh111 . $)
    cosh111lem1 $p |- ( A < B -> ( cos ` B ) < ( cos ` A ) ) $=
      cA cB clt wbr cc0 cA ccos cfv cB ccos cfv cmin co clt wbr cB ccos cfv cA
      ccos cfv clt wbr cA cB clt wbr cc0 c2 cB cA caddc co c2 cdiv co csin cfv
      cB cA cmin co c2 cdiv co csin cfv cmul co cmul co cA ccos cfv cB ccos cfv
      cmin co clt cA cB clt wbr cc0 cB cA caddc co c2 cdiv co csin cfv cB cA
      cmin co c2 cdiv co csin cfv cmul co clt wbr cc0 c2 cB cA caddc co c2 cdiv
      co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co cmul co clt wbr cc0
      cB cA caddc co c2 cdiv co csin cfv clt wbr cc0 cB cA cmin co c2 cdiv co
      csin cfv clt wbr cc0 cB cA caddc co c2 cdiv co csin cfv cB cA cmin co c2
      cdiv co csin cfv cmul co clt wbr cA cB clt wbr cB cA caddc co c2 cdiv co
      csin cfv cB cA cmin co c2 cdiv co csin cfv cB cA caddc co c2 cdiv co cr
      wcel cB cA caddc co c2 cdiv co csin cfv cr wcel cB cA caddc co c2 cB cA
      cosh111lem1.2 cosh111lem1.1 readdcli 2re 2ne0 redivcli cB cA caddc co c2
      cdiv co resincl ax-mp cB cA cmin co c2 cdiv co cr wcel cB cA cmin co c2
      cdiv co csin cfv cr wcel cB cA cmin co c2 cB cA cosh111lem1.2
      cosh111lem1.1 resubcli 2re 2ne0 redivcli cB cA cmin co c2 cdiv co resincl
      ax-mp mulgt0i cA cB clt wbr cc0 cB clt wbr cc0 cB cA caddc co c2 cdiv co
      clt wbr cc0 cB cA caddc co c2 cdiv co csin cfv clt wbr cc0 cA cle wbr cA
      cB clt wbr cc0 cB clt wbr cosh111lem1.3 cc0 cA cB 0re cosh111lem1.1
      cosh111lem1.2 lelttri mpan cc0 cB clt wbr cc0 cB cA caddc co clt wbr cc0
      cB cA caddc co c2 cdiv co clt wbr cc0 cB clt wbr cc0 cA cle wbr cc0 cB cA
      caddc co clt wbr cosh111lem1.3 cB cr wcel cA cr wcel cc0 cB clt wbr cc0
      cA cle wbr wa cc0 cB cA caddc co clt wbr cosh111lem1.2 cosh111lem1.1 cB
      cA addgtge0 mpanl12 mpan2 cB cA caddc co c2 cB cA cosh111lem1.2
      cosh111lem1.1 readdcli 2re 2pos divgt0i2i syl cB cA caddc co c2 cdiv co
      cr wcel cc0 cB cA caddc co c2 cdiv co clt wbr cB cA caddc co c2 cdiv co
      cpi clt wbr cc0 cB cA caddc co c2 cdiv co csin cfv clt wbr cB cA caddc co
      c2 cB cA cosh111lem1.2 cosh111lem1.1 readdcli 2re 2ne0 redivcli cB cA
      caddc co c2 cdiv co c2 cpi cmul co c2 cdiv co cpi clt cB cA caddc co c2
      cpi cmul co clt wbr cB cA caddc co c2 cdiv co c2 cpi cmul co c2 cdiv co
      clt wbr cB cA caddc co cpi cpi caddc co c2 cpi cmul co clt cB cpi clt wbr
      cA cpi clt wbr cB cA caddc co cpi cpi caddc co clt wbr cosh111lem1.6
      cosh111lem1.5 cB cA cpi cpi cosh111lem1.2 cosh111lem1.1 pire pire lt2addi
      mp2an cpi cpi pire recni 2timesi breqtrri cB cA caddc co c2 cpi cmul co
      c2 cB cA cosh111lem1.2 cosh111lem1.1 readdcli c2 cpi 2re pire remulcli
      2re 2pos ltdiv1ii mpbi cpi c2 cpi pire recni 2cn 2ne0 divcan3i breqtri cB
      cA caddc co c2 cdiv co cr wcel cc0 cB cA caddc co c2 cdiv co clt wbr cB
      cA caddc co c2 cdiv co cpi clt wbr w3a cB cA caddc co c2 cdiv co cc0 cpi
      cioo co wcel cc0 cB cA caddc co c2 cdiv co csin cfv clt wbr cc0 cr wcel
      cpi cr wcel cB cA caddc co c2 cdiv co cc0 cpi cioo co wcel cB cA caddc co
      c2 cdiv co cr wcel cc0 cB cA caddc co c2 cdiv co clt wbr cB cA caddc co
      c2 cdiv co cpi clt wbr w3a wb 0re pire cc0 cxr wcel cpi cxr wcel cB cA
      caddc co c2 cdiv co cc0 cpi cioo co wcel cB cA caddc co c2 cdiv co cr
      wcel cc0 cB cA caddc co c2 cdiv co clt wbr cB cA caddc co c2 cdiv co cpi
      clt wbr w3a wb cc0 cr wcel cpi cr wcel cc0 cpi cB cA caddc co c2 cdiv co
      elioo2 cc0 rexr cpi rexr syl2an mp2an cB cA caddc co c2 cdiv co
      sinq12gt0t sylbir mp3an13 3syl cA cB clt wbr cc0 cB cA cmin co c2 cdiv co
      clt wbr cc0 cB cA cmin co c2 cdiv co csin cfv clt wbr cA cB clt wbr cc0
      cB cA cmin co clt wbr cc0 cB cA cmin co c2 cdiv co clt wbr cA cB
      cosh111lem1.1 cosh111lem1.2 posdifi cB cA cmin co cr wcel c2 cr wcel cc0
      c2 clt wbr cc0 cB cA cmin co clt wbr cc0 cB cA cmin co c2 cdiv co clt wbr
      wb cB cA cosh111lem1.2 cosh111lem1.1 resubcli 2re 2pos cB cA cmin co c2
      gt0div mp3an bitri cB cA cmin co c2 cdiv co cr wcel cc0 cB cA cmin co c2
      cdiv co clt wbr cB cA cmin co c2 cdiv co cpi clt wbr cc0 cB cA cmin co c2
      cdiv co csin cfv clt wbr cB cA cmin co c2 cB cA cosh111lem1.2
      cosh111lem1.1 resubcli 2re 2ne0 redivcli cB cA cmin co c2 cdiv co c2 cpi
      cmul co c2 cdiv co cpi clt cB cA cmin co c2 cpi cmul co clt wbr cB cA
      cmin co c2 cdiv co c2 cpi cmul co c2 cdiv co clt wbr cB cA cmin co cpi
      clt wbr cpi c2 cpi cmul co clt wbr cB cA cmin co c2 cpi cmul co clt wbr
      cB cA cmin co cpi clt wbr cB cA cpi caddc co clt wbr cB cpi clt wbr cpi
      cA cpi caddc co cle wbr cB cA cpi caddc co clt wbr cosh111lem1.6 cc0 cpi
      caddc co cpi cA cpi caddc co cle cpi cpi pire recni addid2i cc0 cA cle
      wbr cc0 cpi caddc co cA cpi caddc co cle wbr cosh111lem1.3 cc0 cA cpi 0re
      cosh111lem1.1 pire leadd1i mpbi eqbrtrri cB cpi cA cpi caddc co
      cosh111lem1.2 pire cA cpi cosh111lem1.1 pire readdcli ltletri mp2an cB cA
      cpi cosh111lem1.2 cosh111lem1.1 pire ltsubadd2i mpbir c1 c2 clt wbr cpi
      c2 cpi cmul co clt wbr 1lt2 cpi cr wcel c2 cr wcel cc0 cpi clt wbr c1 c2
      clt wbr cpi c2 cpi cmul co clt wbr wb pire 2re pipos cpi c2 ltmulgt12
      mp3an mpbi cB cA cmin co cpi c2 cpi cmul co cB cA cosh111lem1.2
      cosh111lem1.1 resubcli pire c2 cpi 2re pire remulcli lttri mp2an cB cA
      cmin co c2 cpi cmul co c2 cB cA cosh111lem1.2 cosh111lem1.1 resubcli c2
      cpi 2re pire remulcli 2re 2pos ltdiv1ii mpbi cpi c2 cpi pire recni 2cn
      2ne0 divcan3i breqtri cB cA cmin co c2 cdiv co cr wcel cc0 cB cA cmin co
      c2 cdiv co clt wbr cB cA cmin co c2 cdiv co cpi clt wbr w3a cB cA cmin co
      c2 cdiv co cc0 cpi cioo co wcel cc0 cB cA cmin co c2 cdiv co csin cfv clt
      wbr cc0 cr wcel cpi cr wcel cB cA cmin co c2 cdiv co cc0 cpi cioo co wcel
      cB cA cmin co c2 cdiv co cr wcel cc0 cB cA cmin co c2 cdiv co clt wbr cB
      cA cmin co c2 cdiv co cpi clt wbr w3a wb 0re pire cc0 cxr wcel cpi cxr
      wcel cB cA cmin co c2 cdiv co cc0 cpi cioo co wcel cB cA cmin co c2 cdiv
      co cr wcel cc0 cB cA cmin co c2 cdiv co clt wbr cB cA cmin co c2 cdiv co
      cpi clt wbr w3a wb cc0 cr wcel cpi cr wcel cc0 cpi cB cA cmin co c2 cdiv
      co elioo2 cc0 rexr cpi rexr syl2an mp2an cB cA cmin co c2 cdiv co
      sinq12gt0t sylbir mp3an13 sylbi sylanc cc0 c2 clt wbr cc0 cB cA caddc co
      c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co clt wbr cc0
      c2 cB cA caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv
      cmul co cmul co clt wbr 2pos c2 cB cA caddc co c2 cdiv co csin cfv cB cA
      cmin co c2 cdiv co csin cfv cmul co 2re cB cA caddc co c2 cdiv co csin
      cfv cB cA cmin co c2 cdiv co csin cfv cB cA caddc co c2 cdiv co cr wcel
      cB cA caddc co c2 cdiv co csin cfv cr wcel cB cA caddc co c2 cB cA
      cosh111lem1.2 cosh111lem1.1 readdcli 2re 2ne0 redivcli cB cA caddc co c2
      cdiv co resincl ax-mp cB cA cmin co c2 cdiv co cr wcel cB cA cmin co c2
      cdiv co csin cfv cr wcel cB cA cmin co c2 cB cA cosh111lem1.2
      cosh111lem1.1 resubcli 2re 2ne0 redivcli cB cA cmin co c2 cdiv co resincl
      ax-mp remulcli mulgt0i mpan syl c2 cB cA caddc co c2 cdiv co csin cfv cB
      cA cmin co c2 cdiv co csin cfv cmul co cmul co cB ccos cfv cA ccos cfv
      cmin co cneg cA ccos cfv cB ccos cfv cmin co cB ccos cfv cA ccos cfv cmin
      co c2 cB cA caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin
      cfv cmul co cmul co cneg wceq c2 cB cA caddc co c2 cdiv co csin cfv cB cA
      cmin co c2 cdiv co csin cfv cmul co cmul co cB ccos cfv cA ccos cfv cmin
      co cneg wceq cB ccos cfv cA ccos cfv cmin co c2 cneg cB cA caddc co c2
      cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co cmul co c2 cB
      cA caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co
      cmul co cneg cB cc wcel cA cc wcel cB ccos cfv cA ccos cfv cmin co c2
      cneg cB cA caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv
      cmul co cmul co wceq cB cosh111lem1.2 recni cA cosh111lem1.1 recni cB cA
      subcos mp2an c2 cB cA caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv
      co csin cfv cmul co 2cn cB cA caddc co c2 cdiv co csin cfv cB cA cmin co
      c2 cdiv co csin cfv cmul co cB cA caddc co c2 cdiv co csin cfv cB cA cmin
      co c2 cdiv co csin cfv cB cA caddc co c2 cdiv co cr wcel cB cA caddc co
      c2 cdiv co csin cfv cr wcel cB cA caddc co c2 cB cA cosh111lem1.2
      cosh111lem1.1 readdcli 2re 2ne0 redivcli cB cA caddc co c2 cdiv co
      resincl ax-mp cB cA cmin co c2 cdiv co cr wcel cB cA cmin co c2 cdiv co
      csin cfv cr wcel cB cA cmin co c2 cB cA cosh111lem1.2 cosh111lem1.1
      resubcli 2re 2ne0 redivcli cB cA cmin co c2 cdiv co resincl ax-mp
      remulcli recni mulneg1i eqtri cB ccos cfv cA ccos cfv cmin co c2 cB cA
      caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co
      cmul co cB ccos cfv cA ccos cfv cB ccos cfv cB cr wcel cB ccos cfv cr
      wcel cosh111lem1.2 cB recoscl ax-mp recni cA ccos cfv cA cr wcel cA ccos
      cfv cr wcel cosh111lem1.1 cA recoscl ax-mp recni subcli c2 cB cA caddc co
      c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co 2cn cB cA
      caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cmul co cB
      cA caddc co c2 cdiv co csin cfv cB cA cmin co c2 cdiv co csin cfv cB cA
      caddc co c2 cdiv co cr wcel cB cA caddc co c2 cdiv co csin cfv cr wcel cB
      cA caddc co c2 cB cA cosh111lem1.2 cosh111lem1.1 readdcli 2re 2ne0
      redivcli cB cA caddc co c2 cdiv co resincl ax-mp cB cA cmin co c2 cdiv co
      cr wcel cB cA cmin co c2 cdiv co csin cfv cr wcel cB cA cmin co c2 cB cA
      cosh111lem1.2 cosh111lem1.1 resubcli 2re 2ne0 redivcli cB cA cmin co c2
      cdiv co resincl ax-mp remulcli recni mulcli negcon2i mpbi cB ccos cfv cA
      ccos cfv cB ccos cfv cB cr wcel cB ccos cfv cr wcel cosh111lem1.2 cB
      recoscl ax-mp recni cA ccos cfv cA cr wcel cA ccos cfv cr wcel
      cosh111lem1.1 cA recoscl ax-mp recni negsubdi2i eqtr2i syl6breqr cB ccos
      cfv cA ccos cfv cB cr wcel cB ccos cfv cr wcel cosh111lem1.2 cB recoscl
      ax-mp cA cr wcel cA ccos cfv cr wcel cosh111lem1.1 cA recoscl ax-mp
      posdifi sylibr $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( Lemma for ~ cosh111 . $)
    cosh111lem2 $p |- ( A < B <-> ( cos ` B ) < ( cos ` A ) ) $=
      cA cB clt wbr cB ccos cfv cA ccos cfv clt wbr cA cB cosh111lem1.1
      cosh111lem1.2 cosh111lem1.3 cosh111lem1.4 cosh111lem1.5 cosh111lem1.6
      cosh111lem1 cA cB clt wbr cB ccos cfv cA ccos cfv clt wbr cB cA cle wbr
      cA ccos cfv cB ccos cfv cle wbr cA cB clt wbr wn cB ccos cfv cA ccos cfv
      clt wbr wn cB cA clt wbr cB cA wceq wo cA ccos cfv cB ccos cfv clt wbr cA
      ccos cfv cB ccos cfv wceq wo cB cA cle wbr cA ccos cfv cB ccos cfv cle
      wbr cB cA clt wbr cA ccos cfv cB ccos cfv clt wbr cB cA wceq cA ccos cfv
      cB ccos cfv wceq cB cA cosh111lem1.2 cosh111lem1.1 cosh111lem1.4
      cosh111lem1.3 cosh111lem1.6 cosh111lem1.5 cosh111lem1 cB cA wceq cB ccos
      cfv cA ccos cfv cB cA ccos fveq2 eqcomd orim12i cB cA cosh111lem1.2
      cosh111lem1.1 leloei cA ccos cfv cB ccos cfv cA cr wcel cA ccos cfv cr
      wcel cosh111lem1.1 cA recoscl ax-mp cB cr wcel cB ccos cfv cr wcel
      cosh111lem1.2 cB recoscl ax-mp leloei 3imtr4i cB cA cosh111lem1.2
      cosh111lem1.1 lenlti cA ccos cfv cB ccos cfv cA cr wcel cA ccos cfv cr
      wcel cosh111lem1.1 cA recoscl ax-mp cB cr wcel cB ccos cfv cr wcel
      cosh111lem1.2 cB recoscl ax-mp lenlti 3imtr3i con4i impbii $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( Lemma for ~ cosh111 . $)
    cosh111lem3 $p |- ( A = B <-> ( cos ` A ) = ( cos ` B ) ) $=
      cA cB wceq cB ccos cfv cA ccos cfv wceq cA ccos cfv cB ccos cfv wceq cA
      cB clt wbr wn cB cA clt wbr wn wa cB ccos cfv cA ccos cfv clt wbr wn cA
      ccos cfv cB ccos cfv clt wbr wn wa cA cB wceq cB ccos cfv cA ccos cfv
      wceq cA cB clt wbr wn cB ccos cfv cA ccos cfv clt wbr wn cB cA clt wbr wn
      cA ccos cfv cB ccos cfv clt wbr wn cA cB clt wbr cB ccos cfv cA ccos cfv
      clt wbr cA cB cosh111lem1.1 cosh111lem1.2 cosh111lem1.3 cosh111lem1.4
      cosh111lem1.5 cosh111lem1.6 cosh111lem2 notbii cB cA clt wbr cA ccos cfv
      cB ccos cfv clt wbr cB cA cosh111lem1.2 cosh111lem1.1 cosh111lem1.4
      cosh111lem1.3 cosh111lem1.6 cosh111lem1.5 cosh111lem2 notbii anbi12i cA
      cB cosh111lem1.1 cosh111lem1.2 lttri3i cB ccos cfv cA ccos cfv cB cr wcel
      cB ccos cfv cr wcel cosh111lem1.2 cB recoscl ax-mp cA cr wcel cA ccos cfv
      cr wcel cosh111lem1.1 cA recoscl ax-mp lttri3i 3bitr4i cB ccos cfv cA
      ccos cfv eqcom bitri $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  $( Cosine is one-to-one over the closed-below, open-above interval from ` 0 `
     to ` pi ` .  (Contributed by Paul Chapman, 16-Mar-2008.) $)
  cosh111 $p |- ( ( A e. ( 0 [,) pi ) /\ B e. ( 0 [,) pi ) ) ->
                   ( A = B <-> ( cos ` A ) = ( cos ` B ) ) ) $=
    cA cc0 cpi cico co wcel cB cc0 cpi cico co wcel cA cB wceq cA ccos cfv cB
    ccos cfv wceq wb cA cc0 cpi cico co wcel cA cc0 cif cB wceq cA cc0 cpi cico
    co wcel cA cc0 cif ccos cfv cB ccos cfv wceq wb cA cc0 cpi cico co wcel cA
    cc0 cif cB cc0 cpi cico co wcel cB cc0 cif wceq cA cc0 cpi cico co wcel cA
    cc0 cif ccos cfv cB cc0 cpi cico co wcel cB cc0 cif ccos cfv wceq wb cA cB
    cc0 cc0 cA cA cc0 cpi cico co wcel cA cc0 cif wceq cA cB wceq cA cc0 cpi
    cico co wcel cA cc0 cif cB wceq cA ccos cfv cB ccos cfv wceq cA cc0 cpi
    cico co wcel cA cc0 cif ccos cfv cB ccos cfv wceq cA cA cc0 cpi cico co
    wcel cA cc0 cif cB eqeq1 cA cA cc0 cpi cico co wcel cA cc0 cif wceq cA ccos
    cfv cA cc0 cpi cico co wcel cA cc0 cif ccos cfv cB ccos cfv cA cA cc0 cpi
    cico co wcel cA cc0 cif ccos fveq2 eqeq1d bibi12d cB cB cc0 cpi cico co
    wcel cB cc0 cif wceq cA cc0 cpi cico co wcel cA cc0 cif cB wceq cA cc0 cpi
    cico co wcel cA cc0 cif cB cc0 cpi cico co wcel cB cc0 cif wceq cA cc0 cpi
    cico co wcel cA cc0 cif ccos cfv cB ccos cfv wceq cA cc0 cpi cico co wcel
    cA cc0 cif ccos cfv cB cc0 cpi cico co wcel cB cc0 cif ccos cfv wceq cB cB
    cc0 cpi cico co wcel cB cc0 cif cA cc0 cpi cico co wcel cA cc0 cif eqeq2 cB
    cB cc0 cpi cico co wcel cB cc0 cif wceq cB ccos cfv cB cc0 cpi cico co wcel
    cB cc0 cif ccos cfv cA cc0 cpi cico co wcel cA cc0 cif ccos cfv cB cB cc0
    cpi cico co wcel cB cc0 cif ccos fveq2 eqeq2d bibi12d cA cc0 cpi cico co
    wcel cA cc0 cif cB cc0 cpi cico co wcel cB cc0 cif cA cc0 cpi cico co wcel
    cA cc0 cif cr wcel cc0 cA cc0 cpi cico co wcel cA cc0 cif cle wbr cA cc0
    cpi cico co wcel cA cc0 cif cpi clt wbr cA cc0 cpi cico co wcel cA cc0 cif
    cc0 cpi cico co wcel cA cc0 cpi cico co wcel cA cc0 cif cr wcel cc0 cA cc0
    cpi cico co wcel cA cc0 cif cle wbr cA cc0 cpi cico co wcel cA cc0 cif cpi
    clt wbr w3a cA cc0 cc0 cpi cico co cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt
    wbr cc0 cc0 cpi cico co wcel 0re cc0 0re leidi pipos cc0 cc0 cpi cico co
    wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a cc0 cr wcel cpi cr
    wcel cc0 cc0 cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr
    w3a wb 0re pire cc0 cpi cc0 elico2 mp2an biimpri mp3an elimel cc0 cr wcel
    cpi cr wcel cA cc0 cpi cico co wcel cA cc0 cif cc0 cpi cico co wcel cA cc0
    cpi cico co wcel cA cc0 cif cr wcel cc0 cA cc0 cpi cico co wcel cA cc0 cif
    cle wbr cA cc0 cpi cico co wcel cA cc0 cif cpi clt wbr w3a wb 0re pire cc0
    cpi cA cc0 cpi cico co wcel cA cc0 cif elico2 mp2an mpbi 3simp1i cB cc0 cpi
    cico co wcel cB cc0 cif cr wcel cc0 cB cc0 cpi cico co wcel cB cc0 cif cle
    wbr cB cc0 cpi cico co wcel cB cc0 cif cpi clt wbr cB cc0 cpi cico co wcel
    cB cc0 cif cc0 cpi cico co wcel cB cc0 cpi cico co wcel cB cc0 cif cr wcel
    cc0 cB cc0 cpi cico co wcel cB cc0 cif cle wbr cB cc0 cpi cico co wcel cB
    cc0 cif cpi clt wbr w3a cB cc0 cc0 cpi cico co cc0 cr wcel cc0 cc0 cle wbr
    cc0 cpi clt wbr cc0 cc0 cpi cico co wcel 0re cc0 0re leidi pipos cc0 cc0
    cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a cc0 cr
    wcel cpi cr wcel cc0 cc0 cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0
    cpi clt wbr w3a wb 0re pire cc0 cpi cc0 elico2 mp2an biimpri mp3an elimel
    cc0 cr wcel cpi cr wcel cB cc0 cpi cico co wcel cB cc0 cif cc0 cpi cico co
    wcel cB cc0 cpi cico co wcel cB cc0 cif cr wcel cc0 cB cc0 cpi cico co wcel
    cB cc0 cif cle wbr cB cc0 cpi cico co wcel cB cc0 cif cpi clt wbr w3a wb
    0re pire cc0 cpi cB cc0 cpi cico co wcel cB cc0 cif elico2 mp2an mpbi
    3simp1i cA cc0 cpi cico co wcel cA cc0 cif cr wcel cc0 cA cc0 cpi cico co
    wcel cA cc0 cif cle wbr cA cc0 cpi cico co wcel cA cc0 cif cpi clt wbr cA
    cc0 cpi cico co wcel cA cc0 cif cc0 cpi cico co wcel cA cc0 cpi cico co
    wcel cA cc0 cif cr wcel cc0 cA cc0 cpi cico co wcel cA cc0 cif cle wbr cA
    cc0 cpi cico co wcel cA cc0 cif cpi clt wbr w3a cA cc0 cc0 cpi cico co cc0
    cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr cc0 cc0 cpi cico co wcel 0re cc0
    0re leidi pipos cc0 cc0 cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0
    cpi clt wbr w3a cc0 cr wcel cpi cr wcel cc0 cc0 cpi cico co wcel cc0 cr
    wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a wb 0re pire cc0 cpi cc0 elico2
    mp2an biimpri mp3an elimel cc0 cr wcel cpi cr wcel cA cc0 cpi cico co wcel
    cA cc0 cif cc0 cpi cico co wcel cA cc0 cpi cico co wcel cA cc0 cif cr wcel
    cc0 cA cc0 cpi cico co wcel cA cc0 cif cle wbr cA cc0 cpi cico co wcel cA
    cc0 cif cpi clt wbr w3a wb 0re pire cc0 cpi cA cc0 cpi cico co wcel cA cc0
    cif elico2 mp2an mpbi 3simp2i cB cc0 cpi cico co wcel cB cc0 cif cr wcel
    cc0 cB cc0 cpi cico co wcel cB cc0 cif cle wbr cB cc0 cpi cico co wcel cB
    cc0 cif cpi clt wbr cB cc0 cpi cico co wcel cB cc0 cif cc0 cpi cico co wcel
    cB cc0 cpi cico co wcel cB cc0 cif cr wcel cc0 cB cc0 cpi cico co wcel cB
    cc0 cif cle wbr cB cc0 cpi cico co wcel cB cc0 cif cpi clt wbr w3a cB cc0
    cc0 cpi cico co cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr cc0 cc0 cpi
    cico co wcel 0re cc0 0re leidi pipos cc0 cc0 cpi cico co wcel cc0 cr wcel
    cc0 cc0 cle wbr cc0 cpi clt wbr w3a cc0 cr wcel cpi cr wcel cc0 cc0 cpi
    cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a wb 0re pire
    cc0 cpi cc0 elico2 mp2an biimpri mp3an elimel cc0 cr wcel cpi cr wcel cB
    cc0 cpi cico co wcel cB cc0 cif cc0 cpi cico co wcel cB cc0 cpi cico co
    wcel cB cc0 cif cr wcel cc0 cB cc0 cpi cico co wcel cB cc0 cif cle wbr cB
    cc0 cpi cico co wcel cB cc0 cif cpi clt wbr w3a wb 0re pire cc0 cpi cB cc0
    cpi cico co wcel cB cc0 cif elico2 mp2an mpbi 3simp2i cA cc0 cpi cico co
    wcel cA cc0 cif cr wcel cc0 cA cc0 cpi cico co wcel cA cc0 cif cle wbr cA
    cc0 cpi cico co wcel cA cc0 cif cpi clt wbr cA cc0 cpi cico co wcel cA cc0
    cif cc0 cpi cico co wcel cA cc0 cpi cico co wcel cA cc0 cif cr wcel cc0 cA
    cc0 cpi cico co wcel cA cc0 cif cle wbr cA cc0 cpi cico co wcel cA cc0 cif
    cpi clt wbr w3a cA cc0 cc0 cpi cico co cc0 cr wcel cc0 cc0 cle wbr cc0 cpi
    clt wbr cc0 cc0 cpi cico co wcel 0re cc0 0re leidi pipos cc0 cc0 cpi cico
    co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a cc0 cr wcel cpi cr
    wcel cc0 cc0 cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr
    w3a wb 0re pire cc0 cpi cc0 elico2 mp2an biimpri mp3an elimel cc0 cr wcel
    cpi cr wcel cA cc0 cpi cico co wcel cA cc0 cif cc0 cpi cico co wcel cA cc0
    cpi cico co wcel cA cc0 cif cr wcel cc0 cA cc0 cpi cico co wcel cA cc0 cif
    cle wbr cA cc0 cpi cico co wcel cA cc0 cif cpi clt wbr w3a wb 0re pire cc0
    cpi cA cc0 cpi cico co wcel cA cc0 cif elico2 mp2an mpbi 3simp3i cB cc0 cpi
    cico co wcel cB cc0 cif cr wcel cc0 cB cc0 cpi cico co wcel cB cc0 cif cle
    wbr cB cc0 cpi cico co wcel cB cc0 cif cpi clt wbr cB cc0 cpi cico co wcel
    cB cc0 cif cc0 cpi cico co wcel cB cc0 cpi cico co wcel cB cc0 cif cr wcel
    cc0 cB cc0 cpi cico co wcel cB cc0 cif cle wbr cB cc0 cpi cico co wcel cB
    cc0 cif cpi clt wbr w3a cB cc0 cc0 cpi cico co cc0 cr wcel cc0 cc0 cle wbr
    cc0 cpi clt wbr cc0 cc0 cpi cico co wcel 0re cc0 0re leidi pipos cc0 cc0
    cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a cc0 cr
    wcel cpi cr wcel cc0 cc0 cpi cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0
    cpi clt wbr w3a wb 0re pire cc0 cpi cc0 elico2 mp2an biimpri mp3an elimel
    cc0 cr wcel cpi cr wcel cB cc0 cpi cico co wcel cB cc0 cif cc0 cpi cico co
    wcel cB cc0 cpi cico co wcel cB cc0 cif cr wcel cc0 cB cc0 cpi cico co wcel
    cB cc0 cif cle wbr cB cc0 cpi cico co wcel cB cc0 cif cpi clt wbr w3a wb
    0re pire cc0 cpi cB cc0 cpi cico co wcel cB cc0 cif elico2 mp2an mpbi
    3simp3i cosh111lem3 dedth2h $.
    $( [16-Mar-2008] $) $( [16-Mar-2008] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Mapping of the exponential function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.  $d B x y $.  $d C x y $.
    efgh.1 $e |- F = { <. x , y >. | ( x e. CC /\
                                       y = ( exp ` ( A x. x ) ) ) } $.
    $( The exponential function of a scaled complex number is a group
       homomorphism from the group of complex numbers under addition to the set
       of complex numbers under multiplication.  (Contributed by Paul Chapman,
       25-Apr-2008.) $)
    efgh $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( F ` ( B + C ) ) = ( ( F ` B ) x. ( F ` C ) ) ) $=
      cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC caddc co cmul co ce cfv cA
      cB cmul co ce cfv cA cC cmul co ce cfv cmul co cB cC caddc co cF cfv cB
      cF cfv cC cF cfv cmul co cA cc wcel cB cc wcel cC cc wcel w3a cA cB cC
      caddc co cmul co ce cfv cA cB cmul co cA cC cmul co caddc co ce cfv cA cB
      cmul co ce cfv cA cC cmul co ce cfv cmul co cA cc wcel cB cc wcel cC cc
      wcel w3a cA cB cC caddc co cmul co cA cB cmul co cA cC cmul co caddc co
      ce cA cB cC adddi fveq2d cA cc wcel cB cc wcel cC cc wcel cA cB cmul co
      cA cC cmul co caddc co ce cfv cA cB cmul co ce cfv cA cC cmul co ce cfv
      cmul co wceq cA cB cmul co cc wcel cA cC cmul co cc wcel cA cB cmul co cA
      cC cmul co caddc co ce cfv cA cB cmul co ce cfv cA cC cmul co ce cfv cmul
      co wceq cA cc wcel cB cc wcel wa cA cc wcel cC cc wcel wa cA cB cmul co
      cA cC cmul co efadd cA cB mulcl cA cC mulcl syl2an 3impdi eqtrd cB cc
      wcel cC cc wcel cB cC caddc co cF cfv cA cB cC caddc co cmul co ce cfv
      wceq cA cc wcel cB cc wcel cC cc wcel wa cB cC caddc co cc wcel cB cC
      caddc co cF cfv cA cB cC caddc co cmul co ce cfv wceq cB cC addcl vx vy
      cB cC caddc co cA vx cv cmul co ce cfv cA cB cC caddc co cmul co ce cfv
      cc cF vx cv cB cC caddc co wceq cA vx cv cmul co cA cB cC caddc co cmul
      co ce vx cv cB cC caddc co cA cmul opreq2 fveq2d efgh.1 cA cB cC caddc co
      cmul co ce fvex fvopab4 syl 3adant1 cB cc wcel cC cc wcel cB cF cfv cC cF
      cfv cmul co cA cB cmul co ce cfv cA cC cmul co ce cfv cmul co wceq cA cc
      wcel cB cc wcel cC cc wcel cB cF cfv cA cB cmul co ce cfv cC cF cfv cA cC
      cmul co ce cfv cmul vx vy cB cA vx cv cmul co ce cfv cA cB cmul co ce cfv
      cc cF vx cv cB wceq cA vx cv cmul co cA cB cmul co ce vx cv cB cA cmul
      opreq2 fveq2d efgh.1 cA cB cmul co ce fvex fvopab4 vx vy cC cA vx cv cmul
      co ce cfv cA cC cmul co ce cfv cc cF vx cv cC wceq cA vx cv cmul co cA cC
      cmul co ce vx cv cC cA cmul opreq2 fveq2d efgh.1 cA cC cmul co ce fvex
      fvopab4 opreqan12d 3adant1 3eqtr4d $.
      $( [25-Apr-2008] $) $( [25-Apr-2008] $)
  $}

  ${
    $d A x y $.  $d X x y $.
    efghgrpi.1 $e |- S = { y | E. x e. X y = ( exp ` ( A x. x ) ) } $.
    efghgrpi.2 $e |- G = ( x. |` ( S X. S ) ) $.
    efghgrpi.3 $e |- A e. CC $.
    efghgrpi.4 $e |- X C_ CC $.
    efghgrpi.5 $e |- ( + |` ( X X. X ) ) e. ( SubGrp ` + ) $.

    ${
      $d A w x y z $.  $d F w z $.  $d G w z $.  $d S w z $.  $d X w z $.
      efghgrpi.6 $e |- F = { <. x , y >. | ( x e. CC /\
                                             y = ( exp ` ( A x. x ) ) ) } $.
      $( Lemma for ~ efghgrpi , $)
      efghgrpilem $p |- G e. Abel $=
        caddc cabl wcel caddc cX cX cxp cres caddc csubg cfv wcel cG cabl wcel
        cnaddabl efghgrpi.5 caddc cabl wcel caddc cX cX cxp cres caddc csubg
        cfv wcel wa caddc cX cX cxp cres cabl wcel cG cabl wcel caddc caddc cX
        cX cxp cres subgabl cG cgr wcel caddc cX cX cxp cres cabl wcel cG cabl
        wcel wi vz vw cc caddc cX cX cxp cres cF caddc cG cmul cS cc cc cX
        efghgrpi.5 caddc cc caddc cgr wcel caddc cX cX cxp cres cgr wcel caddc
        cX cX cxp cres caddc wss caddc cX cX cxp cres caddc csubg cfv wcel
        caddc cgr wcel caddc cX cX cxp cres cgr wcel caddc cX cX cxp cres caddc
        wss w3a efghgrpi.5 caddc caddc cX cX cxp cres issubg mpbi 3simp1i cc cc
        cxp cc caddc axaddopr fdmi grprn vx vy cc cc cA vx cv cmul co ce cfv cF
        efghgrpi.6 vx cv cc wcel cA vx cv cmul co cc wcel cA vx cv cmul co ce
        cfv cc wcel cA cc wcel vx cv cc wcel cA vx cv cmul co cc wcel
        efghgrpi.3 cA vx cv mulcl mpan cA vx cv cmul co efcl syl fopab cc ssid
        cc cc cxp cc cmul wf cmul cc cc cxp wfn axmulopr cc cc cxp cc cmul ffn
        ax-mp cA cc wcel vz cv cc wcel vw cv cc wcel vz cv vw cv caddc co cF
        cfv vz cv cF cfv vw cv cF cfv cmul co wceq efghgrpi.3 vx vy cA vz cv vw
        cv cF efghgrpi.6 efgh mp3an1 caddc cdm cc cc cxp wceq caddc cX cX cxp
        cres cgr wcel cX cc wss cX caddc cX cX cxp cres crn wceq cc cc cxp cc
        caddc axaddopr fdmi caddc cgr wcel caddc cX cX cxp cres cgr wcel caddc
        cX cX cxp cres caddc wss caddc cX cX cxp cres caddc csubg cfv wcel
        caddc cgr wcel caddc cX cX cxp cres cgr wcel caddc cX cX cxp cres caddc
        wss w3a efghgrpi.5 caddc caddc cX cX cxp cres issubg mpbi 3simp2i
        efghgrpi.4 caddc caddc cX cX cxp cres cc cX caddc cX cX cxp cres eqid
        resgrprn mp3an cF cX cres crn vw cv vz cv cF cX cres cfv wceq vz cX
        wrex vw cab cF cX cima cS cF cc wfn cX cc wss cF cX cres crn vw cv vz
        cv cF cX cres cfv wceq vz cX wrex vw cab wceq vx vy cc cA vx cv cmul co
        ce cfv cF cA vx cv cmul co ce fvex efghgrpi.6 fnopab2 efghgrpi.4 cF cc
        wfn cX cc wss wa cF cX cres cX wfn cF cX cres crn vw cv vz cv cF cX
        cres cfv wceq vz cX wrex vw cab wceq cc cX cF fnssres vz vw cX cF cX
        cres fnrnfv syl mp2an cF cX df-ima vy cv cA vx cv cmul co ce cfv wceq
        vx cX wrex vy cab vw cv cA vz cv cmul co ce cfv wceq vz cX wrex vw cab
        cS vw cv vz cv cF cX cres cfv wceq vz cX wrex vw cab vy cv cA vx cv
        cmul co ce cfv wceq vx cX wrex vw cv cA vz cv cmul co ce cfv wceq vz cX
        wrex vy vw vy cv vw cv wceq vy cv cA vx cv cmul co ce cfv wceq vx cX
        wrex vw cv cA vx cv cmul co ce cfv wceq vx cX wrex vw cv cA vz cv cmul
        co ce cfv wceq vz cX wrex vy cv vw cv wceq vy cv cA vx cv cmul co ce
        cfv wceq vw cv cA vx cv cmul co ce cfv wceq vx cX vy cv vw cv cA vx cv
        cmul co ce cfv eqeq1 rexbidv vw cv cA vx cv cmul co ce cfv wceq vw cv
        cA vz cv cmul co ce cfv wceq vx vz cX vx cv vz cv wceq cA vx cv cmul co
        ce cfv cA vz cv cmul co ce cfv vw cv vx cv vz cv wceq cA vx cv cmul co
        cA vz cv cmul co ce vx cv vz cv cA cmul opreq2 fveq2d eqeq2d cbvrexv
        syl6bb cbvabv efghgrpi.1 vw cv vz cv cF cX cres cfv wceq vz cX wrex vw
        cv cA vz cv cmul co ce cfv wceq vz cX wrex vw vw cv vz cv cF cX cres
        cfv wceq vw cv cA vz cv cmul co ce cfv wceq vz cX vz cv cX wcel vz cv
        cF cX cres cfv cA vz cv cmul co ce cfv vw cv vz cv cX wcel vz cv cF cX
        cres cfv vz cv cF cfv cA vz cv cmul co ce cfv vz cv cX cF fvres vz cv
        cX wcel vz cv cc wcel vz cv cF cfv cA vz cv cmul co ce cfv wceq cX cc
        vz cv efghgrpi.4 sseli vx vy vz cv cA vx cv cmul co ce cfv cA vz cv
        cmul co ce cfv cc cF vx cv vz cv wceq cA vx cv cmul co cA vz cv cmul co
        ce vx cv vz cv cA cmul opreq2 fveq2d efghgrpi.6 cA vz cv cmul co ce
        fvex fvopab4 syl eqtrd eqeq2d rexbiia abbii 3eqtr4i 3eqtr4ri efghgrpi.2
        ghsubgi pm3.27i syl mp2an $.
        $( [25-Apr-2008] $) $( [25-Apr-2008] $)
    $}

    $( The image of a subgroup of the group ` + ` , under the exponential
       function of a scaled complex number, is an Abelian group.  (Contributed
       by Paul Chapman, 25-Apr-2008.) $)
    efghgrpi $p |- G e. Abel $=
      vx vy cA cS vx cv cc wcel vy cv cA vx cv cmul co ce cfv wceq wa vx vy
      copab cG cX efghgrpi.1 efghgrpi.2 efghgrpi.3 efghgrpi.4 efghgrpi.5 vx cv
      cc wcel vy cv cA vx cv cmul co ce cfv wceq wa vx vy copab eqid
      efghgrpilem $.
      $( [25-Apr-2008] $) $( [25-Apr-2008] $)
  $}

  ${
    $d F a z $.  $d S a $.  $d a x y $.
    efif.1 $e |- F = { <. x , y >. | ( x e. ( 0 [,) ( 2 x. pi ) ) /\
                       y = ( exp ` ( _i x. x ) ) ) } $.
    efif.2 $e |- S = { z e. CC | ( abs ` z ) = 1 } $.
    $( The exponential function of an imaginary number maps the closed-below,
       open-above interval from ` 0 ` to ` 2 x. pi ` to the unit circle.
       (Contributed by Paul Chapman, 16-Mar-2008.) $)
    efif $p |- F : ( 0 [,) ( 2 x. pi ) ) --> S $=
      cc0 c2 cpi cmul co cico co cS cF wf cF cc0 c2 cpi cmul co cico co wfn va
      cv cF cfv cS wcel va cc0 c2 cpi cmul co cico co wral va cc0 c2 cpi cmul
      co cico co cS cF ffnfv vx vy cc0 c2 cpi cmul co cico co ci vx cv cmul co
      ce cfv cF ci vx cv cmul co ce fvex efif.1 fnopab2 va cv cF cfv cS wcel va
      cc0 c2 cpi cmul co cico co va cv cF cfv cc wcel va cv cF cfv cabs cfv c1
      wceq va cv cF cfv cS wcel va cv cc0 c2 cpi cmul co cico co wcel va cv cF
      cfv cS wcel va cv cF cfv cc wcel va cv cF cfv cabs cfv c1 wceq wa vz cv
      cabs cfv c1 wceq va cv cF cfv cabs cfv c1 wceq vz va cv cF cfv cc cS vz
      cv va cv cF cfv wceq vz cv cabs cfv va cv cF cfv cabs cfv c1 vz cv va cv
      cF cfv cabs fveq2 eqeq1d efif.2 elrab2 biimpri va cv cc0 c2 cpi cmul co
      cico co wcel va cv cF cfv ci va cv cmul co ce cfv cc vx vy va cv ci vx cv
      cmul co ce cfv ci va cv cmul co ce cfv cc0 c2 cpi cmul co cico co cF vx
      cv va cv wceq ci vx cv cmul co ci va cv cmul co ce vx cv va cv ci cmul
      opreq2 fveq2d efif.1 ci va cv cmul co ce fvex fvopab4 va cv cc0 c2 cpi
      cmul co cico co wcel va cv cr wcel va cv cc wcel ci va cv cmul co ce cfv
      cc wcel va cv cc0 c2 cpi cmul co cico co wcel va cv cr wcel cc0 va cv cle
      wbr va cv c2 cpi cmul co clt wbr va cv cc0 c2 cpi cmul co cico co wcel va
      cv cr wcel cc0 va cv cle wbr va cv c2 cpi cmul co clt wbr w3a cc0 cr wcel
      c2 cpi cmul co cr wcel va cv cc0 c2 cpi cmul co cico co wcel va cv cr
      wcel cc0 va cv cle wbr va cv c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re
      pire remulcli cc0 c2 cpi cmul co va cv elico2 mp2an biimpi 3simp1d va cv
      recn va cv cc wcel ci va cv cmul co cc wcel ci va cv cmul co ce cfv cc
      wcel ci cc wcel va cv cc wcel ci va cv cmul co cc wcel axicn ci va cv
      mulcl mpan ci va cv cmul co efcl syl 3syl eqeltrd va cv cc0 c2 cpi cmul
      co cico co wcel va cv cF cfv cabs cfv ci va cv cmul co ce cfv cabs cfv c1
      va cv cc0 c2 cpi cmul co cico co wcel va cv cF cfv ci va cv cmul co ce
      cfv cabs vx vy va cv ci vx cv cmul co ce cfv ci va cv cmul co ce cfv cc0
      c2 cpi cmul co cico co cF vx cv va cv wceq ci vx cv cmul co ci va cv cmul
      co ce vx cv va cv ci cmul opreq2 fveq2d efif.1 ci va cv cmul co ce fvex
      fvopab4 fveq2d va cv cc0 c2 cpi cmul co cico co wcel va cv cr wcel ci va
      cv cmul co ce cfv cabs cfv c1 wceq va cv cc0 c2 cpi cmul co cico co wcel
      va cv cr wcel cc0 va cv cle wbr va cv c2 cpi cmul co clt wbr va cv cc0 c2
      cpi cmul co cico co wcel va cv cr wcel cc0 va cv cle wbr va cv c2 cpi
      cmul co clt wbr w3a cc0 cr wcel c2 cpi cmul co cr wcel va cv cc0 c2 cpi
      cmul co cico co wcel va cv cr wcel cc0 va cv cle wbr va cv c2 cpi cmul co
      clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 c2 cpi cmul co va cv
      elico2 mp2an biimpi 3simp1d va cv absefi syl eqtrd sylanc rgen mpbir2an
      $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  ${
    $d C x $.  $d U c $.  $d U x $.
    efifolem1.1 $e |- C = sup ( { c e. ( 0 [,] pi ) |
      ( cos ` c ) = if ( U e. ( -u 1 (,) 1 ) , U , 0 ) } , RR , < ) $.
    $( Lemma for ~ efifo . $)
    efifolem1 $p |- ( U e. ( -u 1 (,) 1 ) ->
                      E. x e. ( 0 (,) pi ) U = ( cos ` x ) ) $=
      cU c1 cneg c1 cioo co wcel cU cC ccos cfv wceq cU vx cv ccos cfv wceq vx
      cc0 cpi cioo co wrex cU c1 cneg c1 cioo co wcel cC ccos cfv cU cU c1 cneg
      c1 cioo co wcel cC ccos cfv cU wceq cC ccos cfv cU c1 cneg c1 cioo co
      wcel cU cc0 cif wceq cU cc0 cU cU c1 cneg c1 cioo co wcel cU cc0 cif cC
      ccos cfv eqeq2 cC cc0 cpi cioo co wcel cC ccos cfv cU c1 cneg c1 cioo co
      wcel cU cc0 cif wceq vc cc0 cpi cC cc vc cv ccos cfv cU c1 cneg c1 cioo
      co wcel cU cc0 cif wceq vc cc0 cpi cicc co crab cU c1 cneg c1 cioo co
      wcel cU cc0 cif ccos 0re pire cU c1 cneg c1 cioo co wcel cU cc0 cif cr
      wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1
      cioo co wcel cU cc0 cif c1 clt wbr cU c1 cneg c1 cioo co wcel cU cc0 cif
      c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1
      cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co
      wcel cU cc0 cif c1 clt wbr w3a cU cc0 c1 cneg c1 cioo co cc0 cr wcel c1
      cneg cc0 clt wbr cc0 c1 clt wbr cc0 c1 cneg c1 cioo co wcel 0re cc0 c1
      clt wbr c1 cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1 cneg cc0
      clt wbr wb 1re c1 lt0neg2 ax-mp mpbi lt01 cc0 c1 cneg c1 cioo co wcel cc0
      cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a c1 cneg cr wcel c1 cr wcel
      cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt
      wbr w3a wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cc0 c1 cneg
      c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a wb c1
      cneg cr wcel c1 cr wcel c1 cneg c1 cc0 elioo2 c1 cneg rexr c1 rexr syl2an
      mp2an biimpri mp3an elimel c1 cneg cr wcel c1 cr wcel cU c1 cneg c1 cioo
      co wcel cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU
      cc0 cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU
      c1 cneg c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 1re renegcli 1re
      c1 cneg cxr wcel c1 cxr wcel cU c1 cneg c1 cioo co wcel cU cc0 cif c1
      cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1
      cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co
      wcel cU cc0 cif c1 clt wbr w3a wb c1 cneg cr wcel c1 cr wcel c1 cneg c1
      cU c1 cneg c1 cioo co wcel cU cc0 cif elioo2 c1 cneg rexr c1 rexr syl2an
      mp2an mpbi 3simp1i pipos cc0 cpi cicc co cr cc cc0 cr wcel cpi cr wcel
      cc0 cpi cicc co cr wss 0re pire cc0 cpi iccssre mp2an axresscn sstri cc
      ssid coscn vc cv cc0 cpi cicc co wcel vc cv cr wcel vc cv ccos cfv cr
      wcel cc0 cpi cicc co cr vc cv cc0 cr wcel cpi cr wcel cc0 cpi cicc co cr
      wss 0re pire cc0 cpi iccssre mp2an sseli vc cv recoscl syl vc cv ccos cfv
      cU c1 cneg c1 cioo co wcel cU cc0 cif wceq vc cc0 cpi cicc co crab eqid
      cpi ccos cfv cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1
      cioo co wcel cU cc0 cif cc0 ccos cfv clt wbr cpi ccos cfv c1 cneg cU c1
      cneg c1 cioo co wcel cU cc0 cif clt cospi cU c1 cneg c1 cioo co wcel cU
      cc0 cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU
      c1 cneg c1 cioo co wcel cU cc0 cif c1 clt wbr cU c1 cneg c1 cioo co wcel
      cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif
      cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg
      c1 cioo co wcel cU cc0 cif c1 clt wbr w3a cU cc0 c1 cneg c1 cioo co cc0
      cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr cc0 c1 cneg c1 cioo co wcel
      0re cc0 c1 clt wbr c1 cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1
      cneg cc0 clt wbr wb 1re c1 lt0neg2 ax-mp mpbi lt01 cc0 c1 cneg c1 cioo co
      wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a c1 cneg cr wcel
      c1 cr wcel cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr
      cc0 c1 clt wbr w3a wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel
      cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt
      wbr w3a wb c1 cneg cr wcel c1 cr wcel c1 cneg c1 cc0 elioo2 c1 cneg rexr
      c1 rexr syl2an mp2an biimpri mp3an elimel c1 cneg cr wcel c1 cr wcel cU
      c1 cneg c1 cioo co wcel cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1
      cioo co wcel cU cc0 cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0
      cif clt wbr cU c1 cneg c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1
      1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cU c1 cneg c1 cioo co wcel
      cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif
      cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg
      c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 cneg cr wcel c1 cr wcel
      c1 cneg c1 cU c1 cneg c1 cioo co wcel cU cc0 cif elioo2 c1 cneg rexr c1
      rexr syl2an mp2an mpbi 3simp2i eqbrtri cU c1 cneg c1 cioo co wcel cU cc0
      cif c1 cc0 ccos cfv clt cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1
      cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co
      wcel cU cc0 cif c1 clt wbr cU c1 cneg c1 cioo co wcel cU cc0 cif c1 cneg
      c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1 cneg cU
      c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co wcel cU
      cc0 cif c1 clt wbr w3a cU cc0 c1 cneg c1 cioo co cc0 cr wcel c1 cneg cc0
      clt wbr cc0 c1 clt wbr cc0 c1 cneg c1 cioo co wcel 0re cc0 c1 clt wbr c1
      cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr wb
      1re c1 lt0neg2 ax-mp mpbi lt01 cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1
      cneg cc0 clt wbr cc0 c1 clt wbr w3a c1 cneg cr wcel c1 cr wcel cc0 c1
      cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a
      wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cc0 c1 cneg c1 cioo
      co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a wb c1 cneg cr
      wcel c1 cr wcel c1 cneg c1 cc0 elioo2 c1 cneg rexr c1 rexr syl2an mp2an
      biimpri mp3an elimel c1 cneg cr wcel c1 cr wcel cU c1 cneg c1 cioo co
      wcel cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0
      cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1
      cneg c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 1re renegcli 1re c1
      cneg cxr wcel c1 cxr wcel cU c1 cneg c1 cioo co wcel cU cc0 cif c1 cneg
      c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1 cneg cU
      c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co wcel cU
      cc0 cif c1 clt wbr w3a wb c1 cneg cr wcel c1 cr wcel c1 cneg c1 cU c1
      cneg c1 cioo co wcel cU cc0 cif elioo2 c1 cneg rexr c1 rexr syl2an mp2an
      mpbi 3simp3i cos0 breqtrri pm3.2i efifolem1.1 dsupivthi pm3.27i dedth
      eqcomd cC cc0 cpi cioo co wcel cU cC ccos cfv wceq cU vx cv ccos cfv wceq
      vx cc0 cpi cioo co wrex cC cc0 cpi cioo co wcel cC ccos cfv cU c1 cneg c1
      cioo co wcel cU cc0 cif wceq vc cc0 cpi cC cc vc cv ccos cfv cU c1 cneg
      c1 cioo co wcel cU cc0 cif wceq vc cc0 cpi cicc co crab cU c1 cneg c1
      cioo co wcel cU cc0 cif ccos 0re pire cU c1 cneg c1 cioo co wcel cU cc0
      cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1
      cneg c1 cioo co wcel cU cc0 cif c1 clt wbr cU c1 cneg c1 cioo co wcel cU
      cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr
      wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1
      cioo co wcel cU cc0 cif c1 clt wbr w3a cU cc0 c1 cneg c1 cioo co cc0 cr
      wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr cc0 c1 cneg c1 cioo co wcel 0re
      cc0 c1 clt wbr c1 cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1 cneg
      cc0 clt wbr wb 1re c1 lt0neg2 ax-mp mpbi lt01 cc0 c1 cneg c1 cioo co wcel
      cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a c1 cneg cr wcel c1 cr
      wcel cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1
      clt wbr w3a wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cc0 c1
      cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a
      wb c1 cneg cr wcel c1 cr wcel c1 cneg c1 cc0 elioo2 c1 cneg rexr c1 rexr
      syl2an mp2an biimpri mp3an elimel c1 cneg cr wcel c1 cr wcel cU c1 cneg
      c1 cioo co wcel cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co
      wcel cU cc0 cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt
      wbr cU c1 cneg c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 1re
      renegcli 1re c1 cneg cxr wcel c1 cxr wcel cU c1 cneg c1 cioo co wcel cU
      cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr
      wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1
      cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 cneg cr wcel c1 cr wcel c1
      cneg c1 cU c1 cneg c1 cioo co wcel cU cc0 cif elioo2 c1 cneg rexr c1 rexr
      syl2an mp2an mpbi 3simp1i pipos cc0 cpi cicc co cr cc cc0 cr wcel cpi cr
      wcel cc0 cpi cicc co cr wss 0re pire cc0 cpi iccssre mp2an axresscn sstri
      cc ssid coscn vc cv cc0 cpi cicc co wcel vc cv cr wcel vc cv ccos cfv cr
      wcel cc0 cpi cicc co cr vc cv cc0 cr wcel cpi cr wcel cc0 cpi cicc co cr
      wss 0re pire cc0 cpi iccssre mp2an sseli vc cv recoscl syl vc cv ccos cfv
      cU c1 cneg c1 cioo co wcel cU cc0 cif wceq vc cc0 cpi cicc co crab eqid
      cpi ccos cfv cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1
      cioo co wcel cU cc0 cif cc0 ccos cfv clt wbr cpi ccos cfv c1 cneg cU c1
      cneg c1 cioo co wcel cU cc0 cif clt cospi cU c1 cneg c1 cioo co wcel cU
      cc0 cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU
      c1 cneg c1 cioo co wcel cU cc0 cif c1 clt wbr cU c1 cneg c1 cioo co wcel
      cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif
      cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg
      c1 cioo co wcel cU cc0 cif c1 clt wbr w3a cU cc0 c1 cneg c1 cioo co cc0
      cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr cc0 c1 cneg c1 cioo co wcel
      0re cc0 c1 clt wbr c1 cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1
      cneg cc0 clt wbr wb 1re c1 lt0neg2 ax-mp mpbi lt01 cc0 c1 cneg c1 cioo co
      wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a c1 cneg cr wcel
      c1 cr wcel cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr
      cc0 c1 clt wbr w3a wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel
      cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt
      wbr w3a wb c1 cneg cr wcel c1 cr wcel c1 cneg c1 cc0 elioo2 c1 cneg rexr
      c1 rexr syl2an mp2an biimpri mp3an elimel c1 cneg cr wcel c1 cr wcel cU
      c1 cneg c1 cioo co wcel cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1
      cioo co wcel cU cc0 cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0
      cif clt wbr cU c1 cneg c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1
      1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cU c1 cneg c1 cioo co wcel
      cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif
      cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg
      c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 cneg cr wcel c1 cr wcel
      c1 cneg c1 cU c1 cneg c1 cioo co wcel cU cc0 cif elioo2 c1 cneg rexr c1
      rexr syl2an mp2an mpbi 3simp2i eqbrtri cU c1 cneg c1 cioo co wcel cU cc0
      cif c1 cc0 ccos cfv clt cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1
      cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co
      wcel cU cc0 cif c1 clt wbr cU c1 cneg c1 cioo co wcel cU cc0 cif c1 cneg
      c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1 cneg cU
      c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co wcel cU
      cc0 cif c1 clt wbr w3a cU cc0 c1 cneg c1 cioo co cc0 cr wcel c1 cneg cc0
      clt wbr cc0 c1 clt wbr cc0 c1 cneg c1 cioo co wcel 0re cc0 c1 clt wbr c1
      cneg cc0 clt wbr lt01 c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr wb
      1re c1 lt0neg2 ax-mp mpbi lt01 cc0 c1 cneg c1 cioo co wcel cc0 cr wcel c1
      cneg cc0 clt wbr cc0 c1 clt wbr w3a c1 cneg cr wcel c1 cr wcel cc0 c1
      cneg c1 cioo co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a
      wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cc0 c1 cneg c1 cioo
      co wcel cc0 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr w3a wb c1 cneg cr
      wcel c1 cr wcel c1 cneg c1 cc0 elioo2 c1 cneg rexr c1 rexr syl2an mp2an
      biimpri mp3an elimel c1 cneg cr wcel c1 cr wcel cU c1 cneg c1 cioo co
      wcel cU cc0 cif c1 cneg c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0
      cif cr wcel c1 cneg cU c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1
      cneg c1 cioo co wcel cU cc0 cif c1 clt wbr w3a wb c1 1re renegcli 1re c1
      cneg cxr wcel c1 cxr wcel cU c1 cneg c1 cioo co wcel cU cc0 cif c1 cneg
      c1 cioo co wcel cU c1 cneg c1 cioo co wcel cU cc0 cif cr wcel c1 cneg cU
      c1 cneg c1 cioo co wcel cU cc0 cif clt wbr cU c1 cneg c1 cioo co wcel cU
      cc0 cif c1 clt wbr w3a wb c1 cneg cr wcel c1 cr wcel c1 cneg c1 cU c1
      cneg c1 cioo co wcel cU cc0 cif elioo2 c1 cneg rexr c1 rexr syl2an mp2an
      mpbi 3simp3i cos0 breqtrri pm3.2i efifolem1.1 dsupivthi pm3.26i cU vx cv
      ccos cfv wceq cU cC ccos cfv wceq vx cC cc0 cpi cioo co vx cv cC wceq vx
      cv ccos cfv cC ccos cfv cU vx cv cC ccos fveq2 eqeq2d rcla4ev mpan syl $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  ${
    $d A a $.  $d X a $.  $d Y a $.
    efifolem2.1 $e |- A e. ( 0 (,) ( 2 x. pi ) ) $.
    efifolem2.2 $e |- X e. RR $.
    efifolem2.3 $e |- Y e. RR $.
    $( Lemma for ~ efifo . $)
    efifolem2 $p |- ( ( ( ( X ^ 2 ) + ( Y ^ 2 ) ) = 1 /\ X = ( cos ` A ) ) ->
      E. a e. ( 0 (,) ( 2 x. pi ) ) ( X = ( cos ` a ) /\ Y = ( sin ` a ) ) ) $=
      cX c2 cexp co cY c2 cexp co caddc co c1 wceq cX cA ccos cfv wceq wa cX cA
      ccos cfv wceq cY cA csin cfv wceq wa cX cA ccos cfv wceq cY cA csin cfv
      cneg wceq wa wo cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0
      c2 cpi cmul co cioo co wrex cX c2 cexp co cY c2 cexp co caddc co c1 wceq
      cX cA ccos cfv wceq wa cX cA ccos cfv wceq cY cA csin cfv wceq cY cA csin
      cfv cneg wceq wo wa cX cA ccos cfv wceq cY cA csin cfv wceq wa cX cA ccos
      cfv wceq cY cA csin cfv cneg wceq wa wo cX c2 cexp co cY c2 cexp co caddc
      co c1 wceq cX cA ccos cfv wceq cX cA ccos cfv wceq cY cA csin cfv wceq cY
      cA csin cfv cneg wceq wo wa cX c2 cexp co cY c2 cexp co caddc co c1 wceq
      cX cA ccos cfv wceq cY cA csin cfv wceq cY cA csin cfv cneg wceq wo cX c2
      cexp co cY c2 cexp co caddc co c1 wceq cX cA ccos cfv wceq cY cA csin cfv
      wceq cY cA csin cfv cneg wceq wo cX c2 cexp co cY c2 cexp co caddc co c1
      wceq cX cA ccos cfv wceq wa cY c2 cexp co cA csin cfv c2 cexp co wceq cY
      cA csin cfv wceq cY cA csin cfv cneg wceq wo cX c2 cexp co cY c2 cexp co
      caddc co c1 wceq cX cA ccos cfv wceq wa cY c2 cexp co c1 cA ccos cfv c2
      cexp co cmin co cA csin cfv c2 cexp co cX c2 cexp co cY c2 cexp co caddc
      co c1 wceq cX cA ccos cfv wceq cY c2 cexp co c1 cX c2 cexp co cmin co c1
      cA ccos cfv c2 cexp co cmin co c1 cX c2 cexp co cmin co cY c2 cexp co
      wceq cX c2 cexp co cY c2 cexp co caddc co c1 wceq c1 cX c2 cexp co cY c2
      cexp co ax1cn cX cX efifolem2.2 recni sqcli cY cY efifolem2.3 recni sqcli
      subaddi biimpri cX cA ccos cfv wceq cX c2 cexp co cA ccos cfv c2 cexp co
      c1 cmin cX cA ccos cfv c2 cexp opreq1 opreq2d sylan9req c1 cA ccos cfv c2
      cexp co cmin co cA csin cfv c2 cexp co wceq cA csin cfv c2 cexp co cA
      ccos cfv c2 cexp co caddc co c1 wceq cA cc wcel cA csin cfv c2 cexp co cA
      ccos cfv c2 cexp co caddc co c1 wceq cA cA cr wcel cc0 cA clt wbr cA c2
      cpi cmul co clt wbr cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA
      clt wbr cA c2 cpi cmul co clt wbr w3a efifolem2.1 cc0 cr wcel c2 cpi cmul
      co cr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr
      cA c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr
      wcel c2 cpi cmul co cxr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr
      wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi
      cmul co cr wcel cc0 c2 cpi cmul co cA elioo2 cc0 rexr c2 cpi cmul co rexr
      syl2an mp2an mpbi 3simp1i recni cA sincossq ax-mp c1 cA ccos cfv c2 cexp
      co cA csin cfv c2 cexp co ax1cn cA ccos cfv cA cc wcel cA ccos cfv cc
      wcel cA cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr cA cc0 c2 cpi
      cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr
      w3a efifolem2.1 cc0 cr wcel c2 cpi cmul co cr wcel cA cc0 c2 cpi cmul co
      cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb
      0re c2 cpi 2re pire remulcli cc0 cxr wcel c2 cpi cmul co cxr wcel cA cc0
      c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co
      clt wbr w3a wb cc0 cr wcel c2 cpi cmul co cr wcel cc0 c2 cpi cmul co cA
      elioo2 cc0 rexr c2 cpi cmul co rexr syl2an mp2an mpbi 3simp1i recni cA
      coscl ax-mp sqcli cA csin cfv cA cc wcel cA csin cfv cc wcel cA cA cr
      wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr cA cc0 c2 cpi cmul co cioo
      co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a
      efifolem2.1 cc0 cr wcel c2 cpi cmul co cr wcel cA cc0 c2 cpi cmul co cioo
      co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb 0re c2
      cpi 2re pire remulcli cc0 cxr wcel c2 cpi cmul co cxr wcel cA cc0 c2 cpi
      cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr
      w3a wb cc0 cr wcel c2 cpi cmul co cr wcel cc0 c2 cpi cmul co cA elioo2
      cc0 rexr c2 cpi cmul co rexr syl2an mp2an mpbi 3simp1i recni cA sincl
      ax-mp sqcli subadd2i mpbir syl6eq cY cA csin cfv cY efifolem2.3 recni cA
      cc wcel cA csin cfv cc wcel cA cA cr wcel cc0 cA clt wbr cA c2 cpi cmul
      co clt wbr cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr
      cA c2 cpi cmul co clt wbr w3a efifolem2.1 cc0 cr wcel c2 cpi cmul co cr
      wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2
      cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr wcel c2
      cpi cmul co cxr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA
      clt wbr cA c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi cmul co cr
      wcel cc0 c2 cpi cmul co cA elioo2 cc0 rexr c2 cpi cmul co rexr syl2an
      mp2an mpbi 3simp1i recni cA sincl ax-mp sqeqori sylib ex ancld imp cX cA
      ccos cfv wceq cY cA csin cfv wceq cY cA csin cfv cneg wceq andi sylib cX
      cA ccos cfv wceq cY cA csin cfv wceq wa cX va cv ccos cfv wceq cY va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex cX cA ccos cfv wceq
      cY cA csin cfv cneg wceq wa cA cc0 c2 cpi cmul co cioo co wcel cX cA ccos
      cfv wceq cY cA csin cfv wceq wa cX va cv ccos cfv wceq cY va cv csin cfv
      wceq wa va cc0 c2 cpi cmul co cioo co wrex efifolem2.1 cX va cv ccos cfv
      wceq cY va cv csin cfv wceq wa cX cA ccos cfv wceq cY cA csin cfv wceq wa
      va cA cc0 c2 cpi cmul co cioo co va cv cA wceq cX va cv ccos cfv wceq cX
      cA ccos cfv wceq cY va cv csin cfv wceq cY cA csin cfv wceq va cv cA wceq
      va cv ccos cfv cA ccos cfv cX va cv cA ccos fveq2 eqeq2d va cv cA wceq va
      cv csin cfv cA csin cfv cY va cv cA csin fveq2 eqeq2d anbi12d rcla4ev
      mpan cX c2 cpi cmul co cA cmin co ccos cfv wceq cY c2 cpi cmul co cA cmin
      co csin cfv wceq cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0
      c2 cpi cmul co cioo co wrex cX cA ccos cfv wceq cY cA csin cfv cneg wceq
      c2 cpi cmul co cA cmin co cc0 c2 cpi cmul co cioo co wcel cX c2 cpi cmul
      co cA cmin co ccos cfv wceq cY c2 cpi cmul co cA cmin co csin cfv wceq wa
      cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co
      cioo co wrex cA cc0 c2 cpi cmul co cioo co wcel c2 cpi cmul co cA cmin co
      cc0 c2 cpi cmul co cioo co wcel efifolem2.1 cA cr wcel cc0 cA clt wbr cA
      c2 cpi cmul co clt wbr w3a c2 cpi cmul co cA cmin co cr wcel cc0 c2 cpi
      cmul co cA cmin co clt wbr c2 cpi cmul co cA cmin co c2 cpi cmul co clt
      wbr w3a cA cc0 c2 cpi cmul co cioo co wcel c2 cpi cmul co cA cmin co cc0
      c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co
      clt wbr w3a cA cr wcel cA c2 cpi cmul co clt wbr cc0 cA clt wbr w3a c2
      cpi cmul co cA cmin co cr wcel cc0 c2 cpi cmul co cA cmin co clt wbr c2
      cpi cmul co cA cmin co c2 cpi cmul co clt wbr w3a cA cr wcel cA c2 cpi
      cmul co clt wbr cc0 cA clt wbr 3ancomb cA cr wcel c2 cpi cmul co cA cmin
      co cr wcel cA c2 cpi cmul co clt wbr cc0 c2 cpi cmul co cA cmin co clt
      wbr cc0 cA clt wbr c2 cpi cmul co cA cmin co c2 cpi cmul co clt wbr cA cr
      wcel c2 cpi cmul co cA cmin co cr wcel cA cr wcel cc0 cA clt wbr cA c2
      cpi cmul co clt wbr cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA
      clt wbr cA c2 cpi cmul co clt wbr w3a efifolem2.1 cc0 cr wcel c2 cpi cmul
      co cr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr
      cA c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr
      wcel c2 cpi cmul co cxr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr
      wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi
      cmul co cr wcel cc0 c2 cpi cmul co cA elioo2 cc0 rexr c2 cpi cmul co rexr
      syl2an mp2an mpbi 3simp1i c2 cpi cmul co cA c2 cpi 2re pire remulcli cA
      cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr cA cc0 c2 cpi cmul co
      cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a
      efifolem2.1 cc0 cr wcel c2 cpi cmul co cr wcel cA cc0 c2 cpi cmul co cioo
      co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb 0re c2
      cpi 2re pire remulcli cc0 cxr wcel c2 cpi cmul co cxr wcel cA cc0 c2 cpi
      cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr
      w3a wb cc0 cr wcel c2 cpi cmul co cr wcel cc0 c2 cpi cmul co cA elioo2
      cc0 rexr c2 cpi cmul co rexr syl2an mp2an mpbi 3simp1i resubcli 2th cA c2
      cpi cmul co cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr cA cc0 c2
      cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt
      wbr w3a efifolem2.1 cc0 cr wcel c2 cpi cmul co cr wcel cA cc0 c2 cpi cmul
      co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a
      wb 0re c2 cpi 2re pire remulcli cc0 cxr wcel c2 cpi cmul co cxr wcel cA
      cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul
      co clt wbr w3a wb cc0 cr wcel c2 cpi cmul co cr wcel cc0 c2 cpi cmul co
      cA elioo2 cc0 rexr c2 cpi cmul co rexr syl2an mp2an mpbi 3simp1i c2 cpi
      2re pire remulcli posdifi cA cr wcel c2 cpi cmul co cr wcel cc0 cA clt
      wbr c2 cpi cmul co cA cmin co c2 cpi cmul co clt wbr wb cA cr wcel cc0 cA
      clt wbr cA c2 cpi cmul co clt wbr cA cc0 c2 cpi cmul co cioo co wcel cA
      cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a efifolem2.1 cc0 cr
      wcel c2 cpi cmul co cr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel
      cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire
      remulcli cc0 cxr wcel c2 cpi cmul co cxr wcel cA cc0 c2 cpi cmul co cioo
      co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr w3a wb cc0 cr
      wcel c2 cpi cmul co cr wcel cc0 c2 cpi cmul co cA elioo2 cc0 rexr c2 cpi
      cmul co rexr syl2an mp2an mpbi 3simp1i c2 cpi 2re pire remulcli cA c2 cpi
      cmul co ltsubpos mp2an 3anbi123i bitr3i cc0 cr wcel c2 cpi cmul co cr
      wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2
      cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr wcel c2
      cpi cmul co cxr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA
      clt wbr cA c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi cmul co cr
      wcel cc0 c2 cpi cmul co cA elioo2 cc0 rexr c2 cpi cmul co rexr syl2an
      mp2an cc0 cr wcel c2 cpi cmul co cr wcel c2 cpi cmul co cA cmin co cc0 c2
      cpi cmul co cioo co wcel c2 cpi cmul co cA cmin co cr wcel cc0 c2 cpi
      cmul co cA cmin co clt wbr c2 cpi cmul co cA cmin co c2 cpi cmul co clt
      wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr wcel c2 cpi cmul co cxr
      wcel c2 cpi cmul co cA cmin co cc0 c2 cpi cmul co cioo co wcel c2 cpi
      cmul co cA cmin co cr wcel cc0 c2 cpi cmul co cA cmin co clt wbr c2 cpi
      cmul co cA cmin co c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi cmul
      co cr wcel cc0 c2 cpi cmul co c2 cpi cmul co cA cmin co elioo2 cc0 rexr
      c2 cpi cmul co rexr syl2an mp2an 3bitr4i mpbi cX va cv ccos cfv wceq cY
      va cv csin cfv wceq wa cX c2 cpi cmul co cA cmin co ccos cfv wceq cY c2
      cpi cmul co cA cmin co csin cfv wceq wa va c2 cpi cmul co cA cmin co cc0
      c2 cpi cmul co cioo co va cv c2 cpi cmul co cA cmin co wceq cX va cv ccos
      cfv wceq cX c2 cpi cmul co cA cmin co ccos cfv wceq cY va cv csin cfv
      wceq cY c2 cpi cmul co cA cmin co csin cfv wceq va cv c2 cpi cmul co cA
      cmin co wceq va cv ccos cfv c2 cpi cmul co cA cmin co ccos cfv cX va cv
      c2 cpi cmul co cA cmin co ccos fveq2 eqeq2d va cv c2 cpi cmul co cA cmin
      co wceq va cv csin cfv c2 cpi cmul co cA cmin co csin cfv cY va cv c2 cpi
      cmul co cA cmin co csin fveq2 eqeq2d anbi12d rcla4ev mpan c2 cpi cmul co
      cA cmin co ccos cfv cA ccos cfv cX cA cc wcel c2 cpi cmul co cA cmin co
      ccos cfv cA ccos cfv wceq cA cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co
      clt wbr cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA
      c2 cpi cmul co clt wbr w3a efifolem2.1 cc0 cr wcel c2 cpi cmul co cr wcel
      cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi
      cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr wcel c2 cpi
      cmul co cxr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt
      wbr cA c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi cmul co cr wcel
      cc0 c2 cpi cmul co cA elioo2 cc0 rexr c2 cpi cmul co rexr syl2an mp2an
      mpbi 3simp1i recni cA cos2pim ax-mp eqeq2i c2 cpi cmul co cA cmin co csin
      cfv cA csin cfv cneg cY cA cc wcel c2 cpi cmul co cA cmin co csin cfv cA
      csin cfv cneg wceq cA cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co clt wbr
      cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi
      cmul co clt wbr w3a efifolem2.1 cc0 cr wcel c2 cpi cmul co cr wcel cA cc0
      c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA c2 cpi cmul co
      clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr wcel c2 cpi cmul co
      cxr wcel cA cc0 c2 cpi cmul co cioo co wcel cA cr wcel cc0 cA clt wbr cA
      c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi cmul co cr wcel cc0 c2
      cpi cmul co cA elioo2 cc0 rexr c2 cpi cmul co rexr syl2an mp2an mpbi
      3simp1i recni cA sin2pim ax-mp eqeq2i syl2anbr jaoi syl $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  ${
    $d A a $.  $d X a z $.  $d Y a z $.  $d Z a $.

    $( Lemma for ~ efifo . $)
    efifolem3 $p |- ( ( X e. RR /\ Y e. RR /\ A e. ( 0 (,) ( 2 x. pi ) ) ) ->
      ( ( ( ( X ^ 2 ) + ( Y ^ 2 ) ) = 1 /\ X = ( cos ` A ) ) ->
    E. a e. ( 0 (,) ( 2 x. pi ) ) ( X = ( cos ` a ) /\ Y = ( sin ` a ) ) ) ) $=
      cX cr wcel cY cr wcel cA cc0 c2 cpi cmul co cioo co wcel cX c2 cexp co cY
      c2 cexp co caddc co c1 wceq cX cA ccos cfv wceq wa cX va cv ccos cfv wceq
      cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex wi cX cr
      wcel cX cc0 cif c2 cexp co cY c2 cexp co caddc co c1 wceq cX cr wcel cX
      cc0 cif cA ccos cfv wceq wa cX cr wcel cX cc0 cif va cv ccos cfv wceq cY
      va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex wi cX cY cA cc0
      cc0 cpi cX cr wcel cX cc0 cif c2 cexp co cY cr wcel cY cc0 cif c2 cexp co
      caddc co c1 wceq cX cr wcel cX cc0 cif cA ccos cfv wceq wa cX cr wcel cX
      cc0 cif va cv ccos cfv wceq cY cr wcel cY cc0 cif va cv csin cfv wceq wa
      va cc0 c2 cpi cmul co cioo co wrex wi cX cr wcel cX cc0 cif c2 cexp co cY
      cr wcel cY cc0 cif c2 cexp co caddc co c1 wceq cX cr wcel cX cc0 cif cA
      cc0 c2 cpi cmul co cioo co wcel cA cpi cif ccos cfv wceq wa cX cr wcel cX
      cc0 cif va cv ccos cfv wceq cY cr wcel cY cc0 cif va cv csin cfv wceq wa
      va cc0 c2 cpi cmul co cioo co wrex wi cX cX cr wcel cX cc0 cif wceq cX c2
      cexp co cY c2 cexp co caddc co c1 wceq cX cA ccos cfv wceq wa cX cr wcel
      cX cc0 cif c2 cexp co cY c2 cexp co caddc co c1 wceq cX cr wcel cX cc0
      cif cA ccos cfv wceq wa cX va cv ccos cfv wceq cY va cv csin cfv wceq wa
      va cc0 c2 cpi cmul co cioo co wrex cX cr wcel cX cc0 cif va cv ccos cfv
      wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex cX cX
      cr wcel cX cc0 cif wceq cX c2 cexp co cY c2 cexp co caddc co c1 wceq cX
      cr wcel cX cc0 cif c2 cexp co cY c2 cexp co caddc co c1 wceq cX cA ccos
      cfv wceq cX cr wcel cX cc0 cif cA ccos cfv wceq cX cX cr wcel cX cc0 cif
      wceq cX c2 cexp co cY c2 cexp co caddc co cX cr wcel cX cc0 cif c2 cexp
      co cY c2 cexp co caddc co c1 cX cX cr wcel cX cc0 cif wceq cX c2 cexp co
      cX cr wcel cX cc0 cif c2 cexp co cY c2 cexp co caddc cX cX cr wcel cX cc0
      cif c2 cexp opreq1 opreq1d eqeq1d cX cX cr wcel cX cc0 cif cA ccos cfv
      eqeq1 anbi12d cX cX cr wcel cX cc0 cif wceq cX va cv ccos cfv wceq cY va
      cv csin cfv wceq wa cX cr wcel cX cc0 cif va cv ccos cfv wceq cY va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cioo co cX cX cr wcel cX cc0 cif
      wceq cX va cv ccos cfv wceq cX cr wcel cX cc0 cif va cv ccos cfv wceq cY
      va cv csin cfv wceq cX cX cr wcel cX cc0 cif va cv ccos cfv eqeq1 anbi1d
      rexbidv imbi12d cY cY cr wcel cY cc0 cif wceq cX cr wcel cX cc0 cif c2
      cexp co cY c2 cexp co caddc co c1 wceq cX cr wcel cX cc0 cif cA ccos cfv
      wceq wa cX cr wcel cX cc0 cif c2 cexp co cY cr wcel cY cc0 cif c2 cexp co
      caddc co c1 wceq cX cr wcel cX cc0 cif cA ccos cfv wceq wa cX cr wcel cX
      cc0 cif va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul
      co cioo co wrex cX cr wcel cX cc0 cif va cv ccos cfv wceq cY cr wcel cY
      cc0 cif va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex cY cY
      cr wcel cY cc0 cif wceq cX cr wcel cX cc0 cif c2 cexp co cY c2 cexp co
      caddc co c1 wceq cX cr wcel cX cc0 cif c2 cexp co cY cr wcel cY cc0 cif
      c2 cexp co caddc co c1 wceq cX cr wcel cX cc0 cif cA ccos cfv wceq cY cY
      cr wcel cY cc0 cif wceq cX cr wcel cX cc0 cif c2 cexp co cY c2 cexp co
      caddc co cX cr wcel cX cc0 cif c2 cexp co cY cr wcel cY cc0 cif c2 cexp
      co caddc co c1 cY cY cr wcel cY cc0 cif wceq cY c2 cexp co cY cr wcel cY
      cc0 cif c2 cexp co cX cr wcel cX cc0 cif c2 cexp co caddc cY cY cr wcel
      cY cc0 cif c2 cexp opreq1 opreq2d eqeq1d anbi1d cY cY cr wcel cY cc0 cif
      wceq cX cr wcel cX cc0 cif va cv ccos cfv wceq cY va cv csin cfv wceq wa
      cX cr wcel cX cc0 cif va cv ccos cfv wceq cY cr wcel cY cc0 cif va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cioo co cY cY cr wcel cY cc0 cif
      wceq cY va cv csin cfv wceq cY cr wcel cY cc0 cif va cv csin cfv wceq cX
      cr wcel cX cc0 cif va cv ccos cfv wceq cY cY cr wcel cY cc0 cif va cv
      csin cfv eqeq1 anbi2d rexbidv imbi12d cA cA cc0 c2 cpi cmul co cioo co
      wcel cA cpi cif wceq cX cr wcel cX cc0 cif c2 cexp co cY cr wcel cY cc0
      cif c2 cexp co caddc co c1 wceq cX cr wcel cX cc0 cif cA ccos cfv wceq wa
      cX cr wcel cX cc0 cif c2 cexp co cY cr wcel cY cc0 cif c2 cexp co caddc
      co c1 wceq cX cr wcel cX cc0 cif cA cc0 c2 cpi cmul co cioo co wcel cA
      cpi cif ccos cfv wceq wa cX cr wcel cX cc0 cif va cv ccos cfv wceq cY cr
      wcel cY cc0 cif va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex
      cA cA cc0 c2 cpi cmul co cioo co wcel cA cpi cif wceq cX cr wcel cX cc0
      cif cA ccos cfv wceq cX cr wcel cX cc0 cif cA cc0 c2 cpi cmul co cioo co
      wcel cA cpi cif ccos cfv wceq cX cr wcel cX cc0 cif c2 cexp co cY cr wcel
      cY cc0 cif c2 cexp co caddc co c1 wceq cA cA cc0 c2 cpi cmul co cioo co
      wcel cA cpi cif wceq cA ccos cfv cA cc0 c2 cpi cmul co cioo co wcel cA
      cpi cif ccos cfv cX cr wcel cX cc0 cif cA cA cc0 c2 cpi cmul co cioo co
      wcel cA cpi cif ccos fveq2 eqeq2d anbi2d imbi1d cA cc0 c2 cpi cmul co
      cioo co wcel cA cpi cif cX cr wcel cX cc0 cif cY cr wcel cY cc0 cif va cA
      cpi cc0 c2 cpi cmul co cioo co cpi cr wcel cc0 cpi clt wbr cpi c2 cpi
      cmul co clt wbr cpi cc0 c2 cpi cmul co cioo co wcel pire pipos c1 cpi
      cmul co cpi c2 cpi cmul co clt cpi cpi pire recni mulid2i c1 c2 clt wbr
      c1 cpi cmul co c2 cpi cmul co clt wbr 1lt2 c1 c2 cpi 1re 2re pire pipos
      ltmul1ii mpbi eqbrtrri cpi cc0 c2 cpi cmul co cioo co wcel cpi cr wcel
      cc0 cpi clt wbr cpi c2 cpi cmul co clt wbr w3a cc0 cr wcel c2 cpi cmul co
      cr wcel cpi cc0 c2 cpi cmul co cioo co wcel cpi cr wcel cc0 cpi clt wbr
      cpi c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 cxr
      wcel c2 cpi cmul co cxr wcel cpi cc0 c2 cpi cmul co cioo co wcel cpi cr
      wcel cc0 cpi clt wbr cpi c2 cpi cmul co clt wbr w3a wb cc0 cr wcel c2 cpi
      cmul co cr wcel cc0 c2 cpi cmul co cpi elioo2 cc0 rexr c2 cpi cmul co
      rexr syl2an mp2an biimpri mp3an elimel cX cc0 cr 0re elimel cY cc0 cr 0re
      elimel efifolem2 dedth3h $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( Lemma for ~ efifo . $)
    efifolem4 $p |- ( ( X e. ( -u 1 (,) 1 ) /\ Y e. RR /\
                        ( ( X ^ 2 ) + ( Y ^ 2 ) ) = 1 ) ->
      E. a e. ( 0 [,) ( 2 x. pi ) ) ( X = ( cos ` a ) /\ Y = ( sin ` a ) ) ) $=
      cX c1 cneg c1 cioo co wcel cY cr wcel cX c2 cexp co cY c2 cexp co caddc
      co c1 wceq w3a cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2
      cpi cmul co cioo co wrex cX va cv ccos cfv wceq cY va cv csin cfv wceq wa
      va cc0 c2 cpi cmul co cico co wrex cX c1 cneg c1 cioo co wcel cY cr wcel
      cX c2 cexp co cY c2 cexp co caddc co c1 wceq cX va cv ccos cfv wceq cY va
      cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex cX c1 cneg c1 cioo
      co wcel cX cr wcel cY cr wcel cX c2 cexp co cY c2 cexp co caddc co c1
      wceq wa cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi
      cmul co cioo co wrex wi cX c1 cneg c1 elioore cX cr wcel cY cr wcel cX c2
      cexp co cY c2 cexp co caddc co c1 wceq wa cX c1 cneg c1 cioo co wcel cX
      va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo
      co wrex cX cr wcel cY cr wcel cX c2 cexp co cY c2 cexp co caddc co c1
      wceq cX c1 cneg c1 cioo co wcel cX va cv ccos cfv wceq cY va cv csin cfv
      wceq wa va cc0 c2 cpi cmul co cioo co wrex wi cX cr wcel cY cr wcel cX c2
      cexp co cY c2 cexp co caddc co c1 wceq w3a cX vz cv ccos cfv wceq vz cc0
      c2 cpi cmul co cioo co wrex cX va cv ccos cfv wceq cY va cv csin cfv wceq
      wa va cc0 c2 cpi cmul co cioo co wrex cX c1 cneg c1 cioo co wcel cX cr
      wcel cY cr wcel cX c2 cexp co cY c2 cexp co caddc co c1 wceq w3a cX vz cv
      ccos cfv wceq cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2
      cpi cmul co cioo co wrex vz cc0 c2 cpi cmul co cioo co cX cr wcel cY cr
      wcel cX c2 cexp co cY c2 cexp co caddc co c1 wceq vz cv cc0 c2 cpi cmul
      co cioo co wcel cX vz cv ccos cfv wceq cX va cv ccos cfv wceq cY va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex wi wi cX cr wcel cY
      cr wcel wa vz cv cc0 c2 cpi cmul co cioo co wcel cX c2 cexp co cY c2 cexp
      co caddc co c1 wceq cX vz cv ccos cfv wceq cX va cv ccos cfv wceq cY va
      cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex wi cX cr wcel cY
      cr wcel vz cv cc0 c2 cpi cmul co cioo co wcel cX c2 cexp co cY c2 cexp co
      caddc co c1 wceq cX vz cv ccos cfv wceq cX va cv ccos cfv wceq cY va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex wi wi cX cr wcel cY
      cr wcel vz cv cc0 c2 cpi cmul co cioo co wcel w3a cX c2 cexp co cY c2
      cexp co caddc co c1 wceq cX vz cv ccos cfv wceq cX va cv ccos cfv wceq cY
      va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co wrex vz cv cX cY va
      efifolem3 exp3a 3expia com23 3impia r19.23adv cX c1 cneg c1 cioo co wcel
      cX vz cv ccos cfv wceq vz cc0 cpi cioo co wrex cX vz cv ccos cfv wceq vz
      cc0 c2 cpi cmul co cioo co wrex vz va cv ccos cfv cX c1 cneg c1 cioo co
      wcel cX cc0 cif wceq va cc0 cpi cicc co crab cr clt csup cX va va cv ccos
      cfv cX c1 cneg c1 cioo co wcel cX cc0 cif wceq va cc0 cpi cicc co crab cr
      clt csup eqid efifolem1 cc0 cpi cioo co cc0 c2 cpi cmul co cioo co wss cX
      vz cv ccos cfv wceq vz cc0 cpi cioo co wrex cX vz cv ccos cfv wceq vz cc0
      c2 cpi cmul co cioo co wrex wi cc0 cr wcel cpi cr wcel c2 cpi cmul co cr
      wcel cc0 cpi cioo co cc0 c2 cpi cmul co cioo co wss 0re pire c2 cpi 2re
      pire remulcli cc0 cxr wcel cpi cxr wcel c2 cpi cmul co cxr wcel cc0 cpi
      cioo co cc0 c2 cpi cmul co cioo co wss cc0 cr wcel cpi cr wcel c2 cpi
      cmul co cr wcel cc0 cxr wcel cpi cxr wcel c2 cpi cmul co cxr wcel w3a cpi
      c2 cpi cmul co cle wbr cc0 cpi cioo co cc0 c2 cpi cmul co cioo co wss c1
      cpi cmul co cpi c2 cpi cmul co cle cpi cpi pire recni mulid2i c1 c2 cle
      wbr c1 cpi cmul co c2 cpi cmul co cle wbr c1 c2 1re 2re 1lt2 ltleii cc0
      cpi clt wbr c1 c2 cle wbr c1 cpi cmul co c2 cpi cmul co cle wbr wb pipos
      c1 c2 cpi 1re 2re pire lemul1i ax-mp mpbi eqbrtrri cc0 cpi c2 cpi cmul co
      iooss2 mpan2 cc0 rexr cpi rexr c2 cpi cmul co rexr syl3an mp3an cX vz cv
      ccos cfv wceq vz cc0 cpi cioo co cc0 c2 cpi cmul co cioo co ssrexv ax-mp
      syl syl5 3expib com3r mpd 3impib cc0 c2 cpi cmul co cioo co cc0 c2 cpi
      cmul co cico co wss cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va
      cc0 c2 cpi cmul co cioo co wrex cX va cv ccos cfv wceq cY va cv csin cfv
      wceq wa va cc0 c2 cpi cmul co cico co wrex wi vz cc0 c2 cpi cmul co cioo
      co cc0 c2 cpi cmul co cico co vz cv cr wcel cc0 vz cv clt wbr vz cv c2
      cpi cmul co clt wbr w3a vz cv cr wcel cc0 vz cv cle wbr wa vz cv c2 cpi
      cmul co clt wbr wa vz cv cc0 c2 cpi cmul co cioo co wcel vz cv cc0 c2 cpi
      cmul co cico co wcel vz cv cr wcel cc0 vz cv clt wbr vz cv c2 cpi cmul co
      clt wbr vz cv cr wcel cc0 vz cv cle wbr wa vz cv c2 cpi cmul co clt wbr
      wa vz cv cr wcel cc0 vz cv clt wbr wa vz cv cr wcel cc0 vz cv cle wbr wa
      vz cv c2 cpi cmul co clt wbr vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv
      cle wbr cc0 cr wcel vz cv cr wcel cc0 vz cv clt wbr cc0 vz cv cle wbr wi
      0re cc0 vz cv ltle mpan imdistani anim1i 3impa cc0 cr wcel c2 cpi cmul co
      cr wcel vz cv cc0 c2 cpi cmul co cioo co wcel vz cv cr wcel cc0 vz cv clt
      wbr vz cv c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0
      cxr wcel c2 cpi cmul co cxr wcel vz cv cc0 c2 cpi cmul co cioo co wcel vz
      cv cr wcel cc0 vz cv clt wbr vz cv c2 cpi cmul co clt wbr w3a wb cc0 cr
      wcel c2 cpi cmul co cr wcel cc0 c2 cpi cmul co vz cv elioo2 cc0 rexr c2
      cpi cmul co rexr syl2an mp2an vz cv cc0 c2 cpi cmul co cico co wcel vz cv
      cr wcel cc0 vz cv cle wbr vz cv c2 cpi cmul co clt wbr w3a vz cv cr wcel
      cc0 vz cv cle wbr wa vz cv c2 cpi cmul co clt wbr wa cc0 cr wcel c2 cpi
      cmul co cr wcel vz cv cc0 c2 cpi cmul co cico co wcel vz cv cr wcel cc0
      vz cv cle wbr vz cv c2 cpi cmul co clt wbr w3a wb 0re c2 cpi 2re pire
      remulcli cc0 c2 cpi cmul co vz cv elico2 mp2an vz cv cr wcel cc0 vz cv
      cle wbr vz cv c2 cpi cmul co clt wbr df-3an bitri 3imtr4i ssriv cX va cv
      ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cioo co cc0
      c2 cpi cmul co cico co ssrexv ax-mp syl $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( Lemma for ~ efifo . $)
    efifolem5 $p |- ( ( X e. RR /\ Y e. RR /\ ( ( X ^ 2 ) + ( Y ^ 2 ) ) = 1 )
      -> ( Y =/= 0 -> E. a e. ( 0 [,) ( 2 x. pi ) )
                         ( X = ( cos ` a ) /\ Y = ( sin ` a ) ) ) ) $=
      cX cr wcel cY cr wcel cX c2 cexp co cY c2 cexp co caddc co c1 wceq cY cc0
      wne cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul
      co cico co wrex wi cX cr wcel cY cr wcel wa cY cc0 wne cX c2 cexp co cY
      c2 cexp co caddc co c1 wceq cX va cv ccos cfv wceq cY va cv csin cfv wceq
      wa va cc0 c2 cpi cmul co cico co wrex cX cr wcel cY cr wcel cY cc0 wne cX
      c2 cexp co cY c2 cexp co caddc co c1 wceq cX va cv ccos cfv wceq cY va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex wi cX cr wcel cY cr
      wcel cY cc0 wne w3a cX c2 cexp co cY c2 cexp co caddc co c1 wceq cX c1
      cneg c1 cioo co wcel cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va
      cc0 c2 cpi cmul co cico co wrex cX cr wcel cY cr wcel cY cc0 wne w3a cX
      c2 cexp co cY c2 cexp co caddc co c1 wceq c1 cX c2 cexp co cmin co cY c2
      cexp co wceq cX c1 cneg c1 cioo co wcel cX cr wcel cY cr wcel c1 cX c2
      cexp co cmin co cY c2 cexp co wceq cX c2 cexp co cY c2 cexp co caddc co
      c1 wceq wb cY cc0 wne cX c2 cexp co cr wcel cY c2 cexp co cr wcel c1 cX
      c2 cexp co cmin co cY c2 cexp co wceq cX c2 cexp co cY c2 cexp co caddc
      co c1 wceq wb cX cr wcel cY cr wcel cX c2 cexp co cc wcel cY c2 cexp co
      cc wcel c1 cX c2 cexp co cmin co cY c2 cexp co wceq cX c2 cexp co cY c2
      cexp co caddc co c1 wceq wb cX c2 cexp co cr wcel cY c2 cexp co cr wcel
      c1 cc wcel cX c2 cexp co cc wcel cY c2 cexp co cc wcel c1 cX c2 cexp co
      cmin co cY c2 cexp co wceq cX c2 cexp co cY c2 cexp co caddc co c1 wceq
      wb ax1cn c1 cX c2 cexp co cY c2 cexp co subadd mp3an1 cX c2 cexp co recn
      cY c2 cexp co recn syl2an cX resqcl cY resqcl syl2an 3adant3 cX cr wcel
      cY cr wcel cY cc0 wne w3a c1 cX c2 cexp co cmin co cY c2 cexp co wceq cX
      cr wcel cc0 c1 cX c2 cexp co cmin co clt wbr wa cX c1 cneg c1 cioo co
      wcel cX cr wcel cY cr wcel cY cc0 wne w3a c1 cX c2 cexp co cmin co cY c2
      cexp co wceq cc0 c1 cX c2 cexp co cmin co clt wbr cX cr wcel cY cr wcel
      cY cc0 wne c1 cX c2 cexp co cmin co cY c2 cexp co wceq cc0 c1 cX c2 cexp
      co cmin co clt wbr wi cX cr wcel c1 cX c2 cexp co cmin co cY c2 cexp co
      wceq cc0 c1 cX c2 cexp co cmin co clt wbr cc0 cY c2 cexp co clt wbr cY cr
      wcel cY cc0 wne wa c1 cX c2 cexp co cmin co cY c2 cexp co cc0 clt breq2
      cY sqgt0 syl5cbir 3adant1 cX cr wcel cY cr wcel cY cc0 wne 3simp1 jctild
      cX cr wcel cc0 c1 cX c2 cexp co cmin co clt wbr wa cX cr wcel cX c2 cexp
      co c1 clt wbr wa cX c1 cneg c1 cioo co wcel cX cr wcel cc0 c1 cX c2 cexp
      co cmin co clt wbr cX c2 cexp co c1 clt wbr cX cr wcel cX c2 cexp co c1
      clt wbr cc0 c1 cX c2 cexp co cmin co clt wbr cX cr wcel cX c2 cexp co cr
      wcel cX c2 cexp co c1 clt wbr cc0 c1 cX c2 cexp co cmin co clt wbr wb cX
      resqcl cX c2 cexp co cr wcel c1 cr wcel cX c2 cexp co c1 clt wbr cc0 c1
      cX c2 cexp co cmin co clt wbr wb 1re cX c2 cexp co c1 posdif mpan2 syl
      biimprd imdistani cX cr wcel cX c2 cexp co c1 clt wbr wa cX cr wcel c1
      cneg cX clt wbr cX c1 clt wbr wa wa cX c1 cneg c1 cioo co wcel cX cr wcel
      cX c2 cexp co c1 clt wbr c1 cneg cX clt wbr cX c1 clt wbr wa cX cr wcel
      cX cabs cfv c1 clt wbr cX cabs cfv c2 cexp co c1 c2 cexp co clt wbr c1
      cneg cX clt wbr cX c1 clt wbr wa cX c2 cexp co c1 clt wbr cX cr wcel cX
      cc wcel cX cabs cfv c1 clt wbr cX cabs cfv c2 cexp co c1 c2 cexp co clt
      wbr wb cX recn cX cabs cfv cr wcel cc0 cX cabs cfv cle wbr cX cabs cfv c1
      clt wbr cX cabs cfv c2 cexp co c1 c2 cexp co clt wbr wb cX cc wcel cX
      cabs cfv cr wcel cc0 cX cabs cfv cle wbr wa c1 cr wcel cc0 c1 cle wbr cX
      cabs cfv c1 clt wbr cX cabs cfv c2 cexp co c1 c2 cexp co clt wbr wb 1re
      cc0 c1 0re 1re lt01 ltleii cX cabs cfv c1 lt2sq mpanr12 cX abscl cX
      absge0 sylanc syl cX cr wcel c1 cr wcel cX cabs cfv c1 clt wbr c1 cneg cX
      clt wbr cX c1 clt wbr wa wb 1re cX c1 abslt mpan2 cX cr wcel cX cabs cfv
      c2 cexp co cX c2 cexp co c1 c2 cexp co c1 clt cX absresq c1 c2 cexp co c1
      wceq cX cr wcel sq1 a1i breq12d 3bitr3rd pm5.32i cX cr wcel c1 cneg cX
      clt wbr cX c1 clt wbr cX c1 cneg c1 cioo co wcel cX c1 cneg c1 cioo co
      wcel cX cr wcel c1 cneg cX clt wbr cX c1 clt wbr w3a c1 cneg cr wcel c1
      cr wcel cX c1 cneg c1 cioo co wcel cX cr wcel c1 cneg cX clt wbr cX c1
      clt wbr w3a wb c1 1re renegcli 1re c1 cneg cxr wcel c1 cxr wcel cX c1
      cneg c1 cioo co wcel cX cr wcel c1 cneg cX clt wbr cX c1 clt wbr w3a wb
      c1 cneg cr wcel c1 cr wcel c1 cneg c1 cX elioo2 c1 cneg rexr c1 rexr
      syl2an mp2an biimpri 3expb sylbi syl syl6 sylbird cY cr wcel cX cr wcel
      cX c2 cexp co cY c2 cexp co caddc co c1 wceq cX c1 cneg c1 cioo co wcel
      cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co
      cico co wrex wi wi cY cc0 wne cY cr wcel cX c2 cexp co cY c2 cexp co
      caddc co c1 wceq cX c1 cneg c1 cioo co wcel cX va cv ccos cfv wceq cY va
      cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex wi cX c1 cneg c1
      cioo co wcel cY cr wcel cX c2 cexp co cY c2 cexp co caddc co c1 wceq wa
      cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co
      cico co wrex cX c1 cneg c1 cioo co wcel cY cr wcel cX c2 cexp co cY c2
      cexp co caddc co c1 wceq cX va cv ccos cfv wceq cY va cv csin cfv wceq wa
      va cc0 c2 cpi cmul co cico co wrex cX cY va efifolem4 3expib com12 ex
      3ad2ant2 mpdd 3expia com23 3impia $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( Lemma for ~ efifo . $)
    efifolem6 $p |- ( ( X e. RR /\ Y e. RR /\ ( ( X ^ 2 ) + ( Y ^ 2 ) ) = 1 )
       -> ( Y = 0 -> E. a e. ( 0 [,) ( 2 x. pi ) )
                     ( X = ( cos ` a ) /\ Y = ( sin ` a ) ) ) ) $=
      cX cr wcel cX c2 cexp co cY c2 cexp co caddc co c1 wceq cY cc0 wceq cX va
      cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co
      wrex wi cY cr wcel cX cr wcel cX c2 cexp co cY c2 cexp co caddc co c1
      wceq cY cc0 wceq cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0
      c2 cpi cmul co cico co wrex cX cr wcel cX c2 cexp co cY c2 cexp co caddc
      co c1 wceq cY cc0 wceq cX va cv ccos cfv wceq cY va cv csin cfv wceq wa
      va cc0 c2 cpi cmul co cico co wrex cX cr wcel cX c2 cexp co cY c2 cexp co
      caddc co c1 wceq cY cc0 wceq wa cX c1 wceq cX c1 cneg wceq wo cY cc0 wceq
      wa cX va cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co
      cico co wrex cX cr wcel cY cc0 wceq cX c2 cexp co cY c2 cexp co caddc co
      c1 wceq cX c1 wceq cX c1 cneg wceq wo cX cr wcel cY cc0 wceq cX c2 cexp
      co cY c2 cexp co caddc co c1 wceq cX c1 wceq cX c1 cneg wceq wo wb cX cr
      wcel cY cc0 wceq wa cX c2 cexp co cY c2 cexp co caddc co c1 wceq cX c2
      cexp co c1 wceq cX c1 wceq cX c1 cneg wceq wo cX cr wcel cY cc0 wceq wa
      cX c2 cexp co cY c2 cexp co caddc co cX c2 cexp co c1 cY cc0 wceq cX cr
      wcel cX c2 cexp co cY c2 cexp co caddc co cX c2 cexp co cc0 caddc co cX
      c2 cexp co cY cc0 wceq cY c2 cexp co cc0 cX c2 cexp co caddc cY sq0i
      opreq2d cX cr wcel cX cc wcel cX c2 cexp co cc wcel cX c2 cexp co cc0
      caddc co cX c2 cexp co wceq cX recn cX sqcl cX c2 cexp co addid1 3syl
      sylan9eqr eqeq1d cX cr wcel cX c2 cexp co c1 wceq cX c1 wceq cX c1 cneg
      wceq wo wb cY cc0 wceq cX cr wcel cX c2 cexp co c1 c2 cexp co wceq cX c1
      wceq cX c1 cneg wceq wo cX c2 cexp co c1 wceq cX cr wcel cX cc wcel cX c2
      cexp co c1 c2 cexp co wceq cX c1 wceq cX c1 cneg wceq wo wb cX recn cX cc
      wcel c1 cc wcel cX c2 cexp co c1 c2 cexp co wceq cX c1 wceq cX c1 cneg
      wceq wo wb ax1cn cX c1 sqeqor mpan2 syl c1 c2 cexp co c1 cX c2 cexp co
      sq1 eqeq2i syl5bbr adantr bitrd ex pm5.32rd cX c1 wceq cY cc0 wceq cX va
      cv ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co
      wrex cX c1 cneg wceq cX cc0 ccos cfv wceq cY cc0 csin cfv wceq cX va cv
      ccos cfv wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co
      wrex cX c1 wceq cY cc0 wceq cc0 cc0 c2 cpi cmul co cico co wcel cX cc0
      ccos cfv wceq cY cc0 csin cfv wceq wa cX va cv ccos cfv wceq cY va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex cc0 cr wcel cc0 cc0
      cle wbr cc0 c2 cpi cmul co clt wbr cc0 cc0 c2 cpi cmul co cico co wcel
      0re cc0 0re leidi c2 cpi 2re pire 2pos pipos mulgt0ii cc0 cc0 c2 cpi cmul
      co cico co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 c2 cpi cmul co clt wbr
      w3a cc0 cr wcel c2 cpi cmul co cr wcel cc0 cc0 c2 cpi cmul co cico co
      wcel cc0 cr wcel cc0 cc0 cle wbr cc0 c2 cpi cmul co clt wbr w3a wb 0re c2
      cpi 2re pire remulcli cc0 c2 cpi cmul co cc0 elico2 mp2an biimpri mp3an
      cX va cv ccos cfv wceq cY va cv csin cfv wceq wa cX cc0 ccos cfv wceq cY
      cc0 csin cfv wceq wa va cc0 cc0 c2 cpi cmul co cico co va cv cc0 wceq cX
      va cv ccos cfv wceq cX cc0 ccos cfv wceq cY va cv csin cfv wceq cY cc0
      csin cfv wceq va cv cc0 wceq va cv ccos cfv cc0 ccos cfv cX va cv cc0
      ccos fveq2 eqeq2d va cv cc0 wceq va cv csin cfv cc0 csin cfv cY va cv cc0
      csin fveq2 eqeq2d anbi12d rcla4ev mpan cX c1 wceq cc0 ccos cfv cX cX c1
      wceq cc0 ccos cfv cX wceq cc0 ccos cfv c1 wceq cos0 cX c1 cc0 ccos cfv
      eqeq2 mpbiri eqcomd cY cc0 wceq cc0 csin cfv cY cY cc0 wceq cc0 csin cfv
      cY wceq cc0 csin cfv cc0 wceq sin0 cY cc0 cc0 csin cfv eqeq2 mpbiri
      eqcomd syl2an cX cpi ccos cfv wceq cY cpi csin cfv wceq cX va cv ccos cfv
      wceq cY va cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex cX c1
      cneg wceq cY cc0 wceq cpi cc0 c2 cpi cmul co cico co wcel cX cpi ccos cfv
      wceq cY cpi csin cfv wceq wa cX va cv ccos cfv wceq cY va cv csin cfv
      wceq wa va cc0 c2 cpi cmul co cico co wrex cpi cr wcel cc0 cpi cle wbr
      cpi c2 cpi cmul co clt wbr cpi cc0 c2 cpi cmul co cico co wcel pire cc0
      cpi 0re pire pipos ltleii c1 cpi cmul co cpi c2 cpi cmul co clt cpi cpi
      pire recni mulid2i c1 c2 clt wbr c1 cpi cmul co c2 cpi cmul co clt wbr
      1lt2 c1 c2 cpi 1re 2re pire pipos ltmul1ii mpbi eqbrtrri cpi cc0 c2 cpi
      cmul co cico co wcel cpi cr wcel cc0 cpi cle wbr cpi c2 cpi cmul co clt
      wbr w3a cc0 cr wcel c2 cpi cmul co cr wcel cpi cc0 c2 cpi cmul co cico co
      wcel cpi cr wcel cc0 cpi cle wbr cpi c2 cpi cmul co clt wbr w3a wb 0re c2
      cpi 2re pire remulcli cc0 c2 cpi cmul co cpi elico2 mp2an biimpri mp3an
      cX va cv ccos cfv wceq cY va cv csin cfv wceq wa cX cpi ccos cfv wceq cY
      cpi csin cfv wceq wa va cpi cc0 c2 cpi cmul co cico co va cv cpi wceq cX
      va cv ccos cfv wceq cX cpi ccos cfv wceq cY va cv csin cfv wceq cY cpi
      csin cfv wceq va cv cpi wceq va cv ccos cfv cpi ccos cfv cX va cv cpi
      ccos fveq2 eqeq2d va cv cpi wceq va cv csin cfv cpi csin cfv cY va cv cpi
      csin fveq2 eqeq2d anbi12d rcla4ev mpan cX c1 cneg wceq cpi ccos cfv cX cX
      c1 cneg wceq cpi ccos cfv cX wceq cpi ccos cfv c1 cneg wceq cospi cX c1
      cneg cpi ccos cfv eqeq2 mpbiri eqcomd cY cc0 wceq cpi csin cfv cY cY cc0
      wceq cpi csin cfv cY wceq cpi csin cfv cc0 wceq sinpi cY cc0 cpi csin cfv
      eqeq2 mpbiri eqcomd syl2an jaoian syl6bi 3impib 3expia 3adant2 $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( Lemma for ~ efifo . $)
    efifolem7 $p |- ( ( Z e. CC /\ ( abs ` Z ) = 1 ) ->
                 E. a e. ( 0 [,) ( 2 x. pi ) ) Z = ( exp ` ( _i x. a ) ) ) $=
      cZ cc wcel cZ cabs cfv c1 wceq wa cZ ci va cv cmul co ce cfv wceq va cc0
      c2 cpi cmul co cico co wrex cZ cre cfv va cv ccos cfv wceq cZ cim cfv va
      cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex cZ cc wcel cZ cabs
      cfv c1 wceq cZ cabs cfv c2 cexp co c1 wceq cZ cre cfv va cv ccos cfv wceq
      cZ cim cfv va cv csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex cZ
      cc wcel cZ cabs cfv c1 wceq wa cZ cabs cfv c2 cexp co c1 c2 cexp co c1 cZ
      cc wcel cZ cabs cfv c2 cexp co c1 c2 cexp co wceq cZ cabs cfv c1 wceq cZ
      cabs cfv cr wcel cc0 cZ cabs cfv cle wbr cZ cabs cfv c2 cexp co c1 c2
      cexp co wceq cZ cabs cfv c1 wceq wb cZ cc wcel cZ cabs cfv cr wcel cc0 cZ
      cabs cfv cle wbr wa c1 cr wcel cc0 c1 cle wbr cZ cabs cfv c2 cexp co c1
      c2 cexp co wceq cZ cabs cfv c1 wceq wb 1re cc0 c1 0re 1re lt01 ltleii cZ
      cabs cfv c1 sq11 mpanr12 cZ abscl cZ absge0 sylanc biimpar sq1 syl6eq cZ
      cre cfv cr wcel cZ cim cfv cr wcel cZ cre cfv c2 cexp co cZ cim cfv c2
      cexp co caddc co c1 wceq cZ cre cfv va cv ccos cfv wceq cZ cim cfv va cv
      csin cfv wceq wa va cc0 c2 cpi cmul co cico co wrex cZ cc wcel cZ cabs
      cfv c2 cexp co c1 wceq wa cZ cre cfv cr wcel cZ cim cfv cr wcel cZ cre
      cfv c2 cexp co cZ cim cfv c2 cexp co caddc co c1 wceq w3a cZ cre cfv va
      cv ccos cfv wceq cZ cim cfv va cv csin cfv wceq wa va cc0 c2 cpi cmul co
      cico co wrex cZ cim cfv cc0 cZ cre cfv cZ cim cfv va efifolem6 cZ cre cfv
      cZ cim cfv va efifolem5 pm2.61dne cZ cc wcel cZ cre cfv cr wcel cZ cabs
      cfv c2 cexp co c1 wceq cZ recl adantr cZ cc wcel cZ cim cfv cr wcel cZ
      cabs cfv c2 cexp co c1 wceq cZ imcl adantr cZ cc wcel cZ cabs cfv c2 cexp
      co c1 wceq cZ cre cfv c2 cexp co cZ cim cfv c2 cexp co caddc co c1 wceq
      cZ cc wcel cZ cabs cfv c2 cexp co cZ cre cfv c2 cexp co cZ cim cfv c2
      cexp co caddc co c1 cZ absvalsq2 eqeq1d biimpa syl3anc syldan cZ cc wcel
      cZ ci va cv cmul co ce cfv wceq va cc0 c2 cpi cmul co cico co wrex cZ cre
      cfv va cv ccos cfv wceq cZ cim cfv va cv csin cfv wceq wa va cc0 c2 cpi
      cmul co cico co wrex wb cZ cabs cfv c1 wceq cZ cc wcel cZ ci va cv cmul
      co ce cfv wceq cZ cre cfv va cv ccos cfv wceq cZ cim cfv va cv csin cfv
      wceq wa va cc0 c2 cpi cmul co cico co cZ cc wcel va cv cr wcel cZ ci va
      cv cmul co ce cfv wceq cZ cre cfv va cv ccos cfv wceq cZ cim cfv va cv
      csin cfv wceq wa wb va cv cc0 c2 cpi cmul co cico co wcel cZ cc wcel va
      cv cr wcel wa cZ ci va cv cmul co ce cfv wceq cZ cre cfv ci cZ cim cfv
      cmul co caddc co va cv ccos cfv ci va cv csin cfv cmul co caddc co wceq
      cZ cre cfv va cv ccos cfv wceq cZ cim cfv va cv csin cfv wceq wa cZ cc
      wcel va cv cr wcel cZ cZ cre cfv ci cZ cim cfv cmul co caddc co ci va cv
      cmul co ce cfv va cv ccos cfv ci va cv csin cfv cmul co caddc co cZ
      replim va cv cr wcel va cv cc wcel ci va cv cmul co ce cfv va cv ccos cfv
      ci va cv csin cfv cmul co caddc co wceq va cv recn va cv efival syl
      eqeqan12d cZ cre cfv cr wcel cZ cim cfv cr wcel wa va cv ccos cfv cr wcel
      va cv csin cfv cr wcel wa cZ cre cfv ci cZ cim cfv cmul co caddc co va cv
      ccos cfv ci va cv csin cfv cmul co caddc co wceq cZ cre cfv va cv ccos
      cfv wceq cZ cim cfv va cv csin cfv wceq wa wb cZ cc wcel va cv cr wcel cZ
      cre cfv cZ cim cfv va cv ccos cfv va cv csin cfv cru cZ cc wcel cZ cre
      cfv cr wcel cZ cim cfv cr wcel cZ recl cZ imcl jca va cv cr wcel va cv
      ccos cfv cr wcel va cv csin cfv cr wcel va cv recoscl va cv resincl jca
      syl2an bitrd va cv cc0 c2 cpi cmul co cico co wcel va cv cr wcel cc0 va
      cv cle wbr va cv c2 cpi cmul co clt wbr va cv cc0 c2 cpi cmul co cico co
      wcel va cv cr wcel cc0 va cv cle wbr va cv c2 cpi cmul co clt wbr w3a cc0
      cr wcel c2 cpi cmul co cr wcel va cv cc0 c2 cpi cmul co cico co wcel va
      cv cr wcel cc0 va cv cle wbr va cv c2 cpi cmul co clt wbr w3a wb 0re c2
      cpi 2re pire remulcli cc0 c2 cpi cmul co va cv elico2 mp2an biimpi
      3simp1d sylan2 rexbidva adantr mpbird $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  ${
    $d F a w $.  $d F w z $.  $d S a w $.  $d a x y $.
    efifo.1 $e |- F = { <. x , y >. | ( x e. ( 0 [,) ( 2 x. pi ) ) /\
                        y = ( exp ` ( _i x. x ) ) ) } $.
    efifo.2 $e |- S = { z e. CC | ( abs ` z ) = 1 } $.
    $( The exponential function of an imaginary number maps the closed-below,
       open-above interval from ` 0 ` to ` 2 x. pi ` onto the unit circle.
       (Contributed by Paul Chapman, 16-Mar-2008.) $)
    efifo $p |- F : ( 0 [,) ( 2 x. pi ) ) -onto-> S $=
      cc0 c2 cpi cmul co cico co cS cF wfo cc0 c2 cpi cmul co cico co cS cF wf
      vw cv va cv cF cfv wceq va cc0 c2 cpi cmul co cico co wrex vw cS wral va
      vw cc0 c2 cpi cmul co cico co cS cF dffo3 vx vy vz cS cF efifo.1 efifo.2
      efif vw cv va cv cF cfv wceq va cc0 c2 cpi cmul co cico co wrex vw cS vw
      cv cc wcel vw cv cabs cfv c1 wceq wa vw cv ci va cv cmul co ce cfv wceq
      va cc0 c2 cpi cmul co cico co wrex vw cv cS wcel vw cv va cv cF cfv wceq
      va cc0 c2 cpi cmul co cico co wrex vw cv va efifolem7 vz cv cabs cfv c1
      wceq vw cv cabs cfv c1 wceq vz vw cv cc cS vz cv vw cv wceq vz cv cabs
      cfv vw cv cabs cfv c1 vz cv vw cv cabs fveq2 eqeq1d efifo.2 elrab2 vw cv
      va cv cF cfv wceq vw cv ci va cv cmul co ce cfv wceq va cc0 c2 cpi cmul
      co cico co va cv cc0 c2 cpi cmul co cico co wcel va cv cF cfv ci va cv
      cmul co ce cfv vw cv vx vy va cv ci vx cv cmul co ce cfv ci va cv cmul co
      ce cfv cc0 c2 cpi cmul co cico co cF vx cv va cv wceq ci vx cv cmul co ci
      va cv cmul co ce vx cv va cv ci cmul opreq2 fveq2d efifo.1 ci va cv cmul
      co ce fvex fvopab4 eqeq2d rexbiia 3imtr4i rgen mpbir2an $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  $( Lemma for ~ efif1 . $)
  efif1lem1 $p |- ( A e. ( pi (,) ( 2 x. pi ) ) ->
                    ( A - pi ) e. ( 0 (,) pi ) ) $=
    cA cr wcel cpi cA clt wbr cA c2 cpi cmul co clt wbr w3a cA cpi cmin co cr
    wcel cc0 cA cpi cmin co clt wbr cA cpi cmin co cpi clt wbr w3a cA cpi c2
    cpi cmul co cioo co wcel cA cpi cmin co cc0 cpi cioo co wcel cA cr wcel cpi
    cA clt wbr cA c2 cpi cmul co clt wbr w3a cA cpi cmin co cr wcel cc0 cA cpi
    cmin co clt wbr cA cpi cmin co cpi clt wbr cA cr wcel cpi cA clt wbr cA cpi
    cmin co cr wcel cA c2 cpi cmul co clt wbr cA cr wcel cpi cr wcel cA cpi
    cmin co cr wcel pire cA cpi resubcl mpan2 3ad2ant1 cA cr wcel cpi cA clt
    wbr cc0 cA cpi cmin co clt wbr cA c2 cpi cmul co clt wbr cA cr wcel cpi cA
    clt wbr cc0 cA cpi cmin co clt wbr cpi cr wcel cA cr wcel cpi cA clt wbr
    cc0 cA cpi cmin co clt wbr wb pire cpi cA posdif mpan biimpa 3adant3 cA cr
    wcel cA c2 cpi cmul co clt wbr cA cpi cmin co cpi clt wbr cpi cA clt wbr cA
    cr wcel cA cpi cmin co cpi clt wbr cA c2 cpi cmul co clt wbr cA cr wcel cA
    cpi cmin co cpi clt wbr cA cpi cpi caddc co clt wbr cA c2 cpi cmul co clt
    wbr cA cr wcel cpi cr wcel cpi cr wcel cA cpi cmin co cpi clt wbr cA cpi
    cpi caddc co clt wbr wb pire pire cA cpi cpi ltsubadd mp3an23 c2 cpi cmul
    co cpi cpi caddc co cA clt cpi cpi pire recni 2timesi breq2i syl6bbr
    biimpar 3adant2 3jca cpi cr wcel c2 cpi cmul co cr wcel cA cpi c2 cpi cmul
    co cioo co wcel cA cr wcel cpi cA clt wbr cA c2 cpi cmul co clt wbr w3a wb
    pire c2 cpi 2re pire remulcli cpi cxr wcel c2 cpi cmul co cxr wcel cA cpi
    c2 cpi cmul co cioo co wcel cA cr wcel cpi cA clt wbr cA c2 cpi cmul co clt
    wbr w3a wb cpi cr wcel c2 cpi cmul co cr wcel cpi c2 cpi cmul co cA elioo2
    cpi rexr c2 cpi cmul co rexr syl2an mp2an cc0 cr wcel cpi cr wcel cA cpi
    cmin co cc0 cpi cioo co wcel cA cpi cmin co cr wcel cc0 cA cpi cmin co clt
    wbr cA cpi cmin co cpi clt wbr w3a wb 0re pire cc0 cxr wcel cpi cxr wcel cA
    cpi cmin co cc0 cpi cioo co wcel cA cpi cmin co cr wcel cc0 cA cpi cmin co
    clt wbr cA cpi cmin co cpi clt wbr w3a wb cc0 cr wcel cpi cr wcel cc0 cpi
    cA cpi cmin co elioo2 cc0 rexr cpi rexr syl2an mp2an 3imtr4i $.
    $( [16-Mar-2008] $) $( [16-Mar-2008] $)

  $( Lemma for ~ efif1 . $)
  efif1lem2 $p |- ( A e. ( pi [,) ( 2 x. pi ) ) ->
                    ( A - pi ) e. ( 0 [,) pi ) ) $=
    cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr w3a cA cpi cmin co cr
    wcel cc0 cA cpi cmin co cle wbr cA cpi cmin co cpi clt wbr w3a cA cpi c2
    cpi cmul co cico co wcel cA cpi cmin co cc0 cpi cico co wcel cA cr wcel cpi
    cA cle wbr cA c2 cpi cmul co clt wbr w3a cA cpi cmin co cr wcel cc0 cA cpi
    cmin co cle wbr cA cpi cmin co cpi clt wbr cA cr wcel cpi cA cle wbr cA cpi
    cmin co cr wcel cA c2 cpi cmul co clt wbr cA cr wcel cpi cr wcel cA cpi
    cmin co cr wcel pire cA cpi resubcl mpan2 3ad2ant1 cA cr wcel cpi cA cle
    wbr cc0 cA cpi cmin co cle wbr cA c2 cpi cmul co clt wbr cA cr wcel cc0 cA
    cpi cmin co cle wbr cpi cA cle wbr cA cr wcel cpi cr wcel cc0 cA cpi cmin
    co cle wbr cpi cA cle wbr wb pire cA cpi subge0 mpan2 biimpar 3adant3 cA cr
    wcel cA c2 cpi cmul co clt wbr cA cpi cmin co cpi clt wbr cpi cA cle wbr cA
    cr wcel cA cpi cmin co cpi clt wbr cA c2 cpi cmul co clt wbr cA cr wcel cA
    cpi cmin co cpi clt wbr cA cpi cpi caddc co clt wbr cA c2 cpi cmul co clt
    wbr cA cr wcel cpi cr wcel cpi cr wcel cA cpi cmin co cpi clt wbr cA cpi
    cpi caddc co clt wbr wb pire pire cA cpi cpi ltsubadd mp3an23 c2 cpi cmul
    co cpi cpi caddc co cA clt cpi cpi pire recni 2timesi breq2i syl6bbr
    biimpar 3adant2 3jca cpi cr wcel c2 cpi cmul co cr wcel cA cpi c2 cpi cmul
    co cico co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr w3a wb
    pire c2 cpi 2re pire remulcli cpi c2 cpi cmul co cA elico2 mp2an cc0 cr
    wcel cpi cr wcel cA cpi cmin co cc0 cpi cico co wcel cA cpi cmin co cr wcel
    cc0 cA cpi cmin co cle wbr cA cpi cmin co cpi clt wbr w3a wb 0re pire cc0
    cpi cA cpi cmin co elico2 mp2an 3imtr4i $.
    $( [16-Mar-2008] $) $( [16-Mar-2008] $)

  $( Lemma for ~ efif1 . $)
  efif1lem3 $p |- ( ( A e. ( 0 [,) pi ) /\ B e. ( 0 [,) pi ) ) ->
                ( ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) -> A = B ) ) $=
    cA cc0 cpi cico co wcel cB cc0 cpi cico co wcel wa ci cA cmul co ce cfv ci
    cB cmul co ce cfv wceq cA ccos cfv cB ccos cfv wceq cA cB wceq cA cc0 cpi
    cico co wcel cB cc0 cpi cico co wcel wa ci cA cmul co ce cfv ci cB cmul co
    ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa cA
    ccos cfv cB ccos cfv wceq cA cc0 cpi cico co wcel cB cc0 cpi cico co wcel
    wa ci cA cmul co ce cfv ci cB cmul co ce cfv wceq cA ccos cfv ci cA csin
    cfv cmul co caddc co cB ccos cfv ci cB csin cfv cmul co caddc co wceq cA
    ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa cA cc0 cpi cico
    co wcel cB cc0 cpi cico co wcel ci cA cmul co ce cfv cA ccos cfv ci cA csin
    cfv cmul co caddc co ci cB cmul co ce cfv cB ccos cfv ci cB csin cfv cmul
    co caddc co cA cc0 cpi cico co wcel cA cr wcel cA cc wcel ci cA cmul co ce
    cfv cA ccos cfv ci cA csin cfv cmul co caddc co wceq cA cc0 cpi cico co
    wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr cA cc0 cpi cico co wcel cA cr
    wcel cc0 cA cle wbr cA cpi clt wbr w3a cc0 cr wcel cpi cr wcel cA cc0 cpi
    cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a wb 0re pire cc0
    cpi cA elico2 mp2an biimpi 3simp1d cA recn cA efival 3syl cB cc0 cpi cico
    co wcel cB cr wcel cB cc wcel ci cB cmul co ce cfv cB ccos cfv ci cB csin
    cfv cmul co caddc co wceq cB cc0 cpi cico co wcel cB cr wcel cc0 cB cle wbr
    cB cpi clt wbr cB cc0 cpi cico co wcel cB cr wcel cc0 cB cle wbr cB cpi clt
    wbr w3a cc0 cr wcel cpi cr wcel cB cc0 cpi cico co wcel cB cr wcel cc0 cB
    cle wbr cB cpi clt wbr w3a wb 0re pire cc0 cpi cB elico2 mp2an biimpi
    3simp1d cB recn cB efival 3syl eqeqan12d cA cc0 cpi cico co wcel cB cc0 cpi
    cico co wcel wa cA ccos cfv ci cA csin cfv cmul co caddc co cB ccos cfv ci
    cB csin cfv cmul co caddc co wceq cA ccos cfv cB ccos cfv wceq cA csin cfv
    cB csin cfv wceq wa cA ccos cfv cr wcel cA csin cfv cr wcel wa cB ccos cfv
    cr wcel cB csin cfv cr wcel wa cA ccos cfv ci cA csin cfv cmul co caddc co
    cB ccos cfv ci cB csin cfv cmul co caddc co wceq cA ccos cfv cB ccos cfv
    wceq cA csin cfv cB csin cfv wceq wa wb cA cc0 cpi cico co wcel cB cc0 cpi
    cico co wcel cA ccos cfv cA csin cfv cB ccos cfv cB csin cfv cru cA cc0 cpi
    cico co wcel cA cr wcel cA ccos cfv cr wcel cA csin cfv cr wcel wa cA cc0
    cpi cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr cA cc0 cpi cico
    co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a cc0 cr wcel cpi cr
    wcel cA cc0 cpi cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a
    wb 0re pire cc0 cpi cA elico2 mp2an biimpi 3simp1d cA cr wcel cA ccos cfv
    cr wcel cA csin cfv cr wcel cA recoscl cA resincl jca syl cB cc0 cpi cico
    co wcel cB cr wcel cB ccos cfv cr wcel cB csin cfv cr wcel wa cB cc0 cpi
    cico co wcel cB cr wcel cc0 cB cle wbr cB cpi clt wbr cB cc0 cpi cico co
    wcel cB cr wcel cc0 cB cle wbr cB cpi clt wbr w3a cc0 cr wcel cpi cr wcel
    cB cc0 cpi cico co wcel cB cr wcel cc0 cB cle wbr cB cpi clt wbr w3a wb 0re
    pire cc0 cpi cB elico2 mp2an biimpi 3simp1d cB cr wcel cB ccos cfv cr wcel
    cB csin cfv cr wcel cB recoscl cB resincl jca syl syl2an biimpd sylbid cA
    ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq pm3.26 syl6 cA cB
    cosh111 sylibrd $.
    $( [16-Mar-2008] $) $( [16-Mar-2008] $)

  $( Lemma for ~ efif1 . $)
  efif1lem4 $p |- ( ( A e. ( pi [,) ( 2 x. pi ) ) /\
                      B e. ( pi [,) ( 2 x. pi ) ) ) ->
      ( ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) -> A = B ) ) $=
    cA cpi c2 cpi cmul co cico co wcel cB cpi c2 cpi cmul co cico co wcel wa ci
    cA cmul co ce cfv cneg ci cB cmul co ce cfv cneg wceq cA cpi cmin co cB cpi
    cmin co wceq ci cA cmul co ce cfv ci cB cmul co ce cfv wceq cA cB wceq cA
    cpi c2 cpi cmul co cico co wcel cB cpi c2 cpi cmul co cico co wcel wa ci cA
    cmul co ce cfv cneg ci cB cmul co ce cfv cneg wceq ci cA cpi cmin co cmul
    co ce cfv ci cB cpi cmin co cmul co ce cfv wceq cA cpi cmin co cB cpi cmin
    co wceq cA cpi c2 cpi cmul co cico co wcel cB cpi c2 cpi cmul co cico co
    wcel ci cA cpi cmin co cmul co ce cfv ci cA cmul co ce cfv cneg ci cB cpi
    cmin co cmul co ce cfv ci cB cmul co ce cfv cneg cA cpi c2 cpi cmul co cico
    co wcel cA cc wcel ci cA cpi cmin co cmul co ce cfv ci cA cmul co ce cfv
    cneg wceq cA cpi c2 cpi cmul co cico co wcel cA cA cpi c2 cpi cmul co cico
    co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr cA cpi c2 cpi
    cmul co cico co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr
    w3a cpi cr wcel c2 cpi cmul co cr wcel cA cpi c2 cpi cmul co cico co wcel
    cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re
    pire remulcli cpi c2 cpi cmul co cA elico2 mp2an biimpi 3simp1d recnd cA
    efimpi syl cB cpi c2 cpi cmul co cico co wcel cB cc wcel ci cB cpi cmin co
    cmul co ce cfv ci cB cmul co ce cfv cneg wceq cB cpi c2 cpi cmul co cico co
    wcel cB cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2
    cpi cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB
    cle wbr cB c2 cpi cmul co clt wbr w3a cpi cr wcel c2 cpi cmul co cr wcel cB
    cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co
    clt wbr w3a wb pire c2 cpi 2re pire remulcli cpi c2 cpi cmul co cB elico2
    mp2an biimpi 3simp1d recnd cB efimpi syl eqeqan12d cA cpi cmin co cc0 cpi
    cico co wcel cB cpi cmin co cc0 cpi cico co wcel ci cA cpi cmin co cmul co
    ce cfv ci cB cpi cmin co cmul co ce cfv wceq cA cpi cmin co cB cpi cmin co
    wceq wi cA cpi c2 cpi cmul co cico co wcel cB cpi c2 cpi cmul co cico co
    wcel cA cpi cmin co cB cpi cmin co efif1lem3 cA efif1lem2 cB efif1lem2
    syl2an sylbird ci cA cmul co ce cfv cc wcel ci cB cmul co ce cfv cc wcel ci
    cA cmul co ce cfv cneg ci cB cmul co ce cfv cneg wceq ci cA cmul co ce cfv
    ci cB cmul co ce cfv wceq wb cA cpi c2 cpi cmul co cico co wcel cB cpi c2
    cpi cmul co cico co wcel ci cA cmul co ce cfv ci cB cmul co ce cfv neg11 cA
    cpi c2 cpi cmul co cico co wcel cA cc wcel ci cA cmul co cc wcel ci cA cmul
    co ce cfv cc wcel cA cpi c2 cpi cmul co cico co wcel cA cA cpi c2 cpi cmul
    co cico co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr cA cpi
    c2 cpi cmul co cico co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt
    wbr w3a cpi cr wcel c2 cpi cmul co cr wcel cA cpi c2 cpi cmul co cico co
    wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr w3a wb pire c2 cpi
    2re pire remulcli cpi c2 cpi cmul co cA elico2 mp2an biimpi 3simp1d recnd
    ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA mulcl mpan ci cA
    cmul co efcl 3syl cB cpi c2 cpi cmul co cico co wcel cB cc wcel ci cB cmul
    co cc wcel ci cB cmul co ce cfv cc wcel cB cpi c2 cpi cmul co cico co wcel
    cB cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi
    cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle
    wbr cB c2 cpi cmul co clt wbr w3a cpi cr wcel c2 cpi cmul co cr wcel cB cpi
    c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt
    wbr w3a wb pire c2 cpi 2re pire remulcli cpi c2 cpi cmul co cB elico2 mp2an
    biimpi 3simp1d recnd ci cc wcel cB cc wcel ci cB cmul co cc wcel axicn ci
    cB mulcl mpan ci cB cmul co efcl 3syl syl2an cA cc wcel cB cc wcel cA cpi
    cmin co cB cpi cmin co wceq cA cB wceq wb cA cpi c2 cpi cmul co cico co
    wcel cB cpi c2 cpi cmul co cico co wcel cA cc wcel cB cc wcel cpi cc wcel
    cA cpi cmin co cB cpi cmin co wceq cA cB wceq wb cpi pire recni cA cB cpi
    subcan2 mp3an3 cA cpi c2 cpi cmul co cico co wcel cA cA cpi c2 cpi cmul co
    cico co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr cA cpi c2
    cpi cmul co cico co wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt
    wbr w3a cpi cr wcel c2 cpi cmul co cr wcel cA cpi c2 cpi cmul co cico co
    wcel cA cr wcel cpi cA cle wbr cA c2 cpi cmul co clt wbr w3a wb pire c2 cpi
    2re pire remulcli cpi c2 cpi cmul co cA elico2 mp2an biimpi 3simp1d recnd
    cB cpi c2 cpi cmul co cico co wcel cB cB cpi c2 cpi cmul co cico co wcel cB
    cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co cico
    co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a cpi cr wcel
    c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB
    cle wbr cB c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire remulcli cpi
    c2 cpi cmul co cB elico2 mp2an biimpi 3simp1d recnd syl2an 3imtr3d $.
    $( [16-Mar-2008] $) $( [16-Mar-2008] $)

  ${
    efif1lem5.1 $e |- A e. ( 0 [,) pi ) $.
    efif1lem5.2 $e |- B e. ( pi [,) ( 2 x. pi ) ) $.
    $( Lemma for ~ efif1 . $)
    efif1lem5 $p |- -. ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) $=
      cA cc0 wceq cA cc0 cpi cioo co wcel wo cB cpi wceq cB cpi c2 cpi cmul co
      cioo co wcel wo ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn cA cc0
      csn wcel cA cc0 cpi cioo co wcel wo cA cc0 wceq cA cc0 cpi cioo co wcel
      wo cA cc0 cpi cico co wcel cA cc0 csn wcel cA cc0 cpi cioo co wcel wo
      efif1lem5.1 cA cc0 cpi cico co wcel cA cc0 csn cc0 cpi cioo co cun wcel
      cA cc0 csn wcel cA cc0 cpi cioo co wcel wo cc0 csn cc0 cpi cioo co cun
      cc0 cpi cico co cA cc0 cr wcel cpi cr wcel cc0 cpi clt wbr cc0 csn cc0
      cpi cioo co cun cc0 cpi cico co wceq 0re pire pipos cc0 cpi snunioo mp3an
      eleq2i cA cc0 csn cc0 cpi cioo co elun bitr3i mpbi cA cc0 csn wcel cA cc0
      wceq cA cc0 cpi cioo co wcel cc0 cr wcel cA cc0 csn wcel cA cc0 wceq wb
      0re cA cc0 cr elsnc2g ax-mp orbi1i mpbi cB cpi csn wcel cB cpi c2 cpi
      cmul co cioo co wcel wo cB cpi wceq cB cpi c2 cpi cmul co cioo co wcel wo
      cB cpi c2 cpi cmul co cico co wcel cB cpi csn wcel cB cpi c2 cpi cmul co
      cioo co wcel wo efif1lem5.2 cB cpi c2 cpi cmul co cico co wcel cB cpi csn
      cpi c2 cpi cmul co cioo co cun wcel cB cpi csn wcel cB cpi c2 cpi cmul co
      cioo co wcel wo cpi csn cpi c2 cpi cmul co cioo co cun cpi c2 cpi cmul co
      cico co cB cpi cr wcel c2 cpi cmul co cr wcel cpi c2 cpi cmul co clt wbr
      cpi csn cpi c2 cpi cmul co cioo co cun cpi c2 cpi cmul co cico co wceq
      pire c2 cpi 2re pire remulcli c1 c2 clt wbr cpi c2 cpi cmul co clt wbr
      1lt2 cpi cr wcel c2 cr wcel cc0 cpi clt wbr c1 c2 clt wbr cpi c2 cpi cmul
      co clt wbr wb pire 2re pipos cpi c2 ltmulgt12 mp3an mpbi cpi c2 cpi cmul
      co snunioo mp3an eleq2i cB cpi csn cpi c2 cpi cmul co cioo co elun bitr3i
      mpbi cB cpi csn wcel cB cpi wceq cB cpi c2 cpi cmul co cioo co wcel cpi
      cr wcel cB cpi csn wcel cB cpi wceq wb pire cB cpi cr elsnc2g ax-mp
      orbi1i mpbi cA cc0 wceq cB cpi wceq cA cc0 cpi cioo co wcel cB cpi c2 cpi
      cmul co cioo co wcel ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn cA
      cc0 wceq cB cpi wceq wa cA ccos cfv cB ccos cfv wceq wn ci cA cmul co ce
      cfv ci cB cmul co ce cfv wceq wn cA cc0 wceq cB cpi wceq wa cA ccos cfv
      cB ccos cfv wceq c1 cc0 wceq c1 cc0 wne c1 cc0 wceq wn ax1ne0 c1 cc0
      df-ne mpbi cA cc0 wceq cB cpi wceq wa cA ccos cfv cB ccos cfv wceq c1 c1
      cneg wceq c1 cc0 wceq cA cc0 wceq cB cpi wceq cA ccos cfv c1 cB ccos cfv
      c1 cneg cA cc0 wceq cA ccos cfv cc0 ccos cfv c1 cA cc0 ccos fveq2 cos0
      syl6eq cB cpi wceq cB ccos cfv cpi ccos cfv c1 cneg cB cpi ccos fveq2
      cospi syl6eq eqeqan12d c1 ax1cn eqnegi syl6bb mtbiri cA ccos cfv cB ccos
      cfv wceq wn cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa
      wn ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn cA ccos cfv cB ccos
      cfv wceq wn cA ccos cfv cB ccos cfv wceq wn cA csin cfv cB csin cfv wceq
      wn wo cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn cA
      ccos cfv cB ccos cfv wceq wn cA csin cfv cB csin cfv wceq wn orc cA ccos
      cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq ianor sylibr ci cA cmul
      co ce cfv ci cB cmul co ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin
      cfv cB csin cfv wceq wa cA cr wcel cB cr wcel ci cA cmul co ce cfv ci cB
      cmul co ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv
      wceq wa wb cA cr wcel cc0 cA cle wbr cA cpi clt wbr cA cc0 cpi cico co
      wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a efif1lem5.1 cc0 cr wcel
      cpi cr wcel cA cc0 cpi cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt
      wbr w3a wb 0re pire cc0 cpi cA elico2 mp2an mpbi 3simp1i cB cr wcel cpi
      cB cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel
      cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a efif1lem5.2 cpi
      cr wcel c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr
      wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire
      remulcli cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i cA cB efieq
      mp2an notbii sylibr syl cA cc0 cpi cioo co wcel cB cpi wceq wa cA csin
      cfv cB csin cfv wceq wn ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn
      cA cc0 cpi cioo co wcel cB cpi wceq wa cA csin cfv cB csin cfv wceq cA
      csin cfv cc0 wceq cA cc0 cpi cioo co wcel cA csin cfv cc0 wceq wn cB cpi
      wceq cA cc0 cpi cioo co wcel cA csin cfv cc0 wne cA csin cfv cc0 wceq wn
      cA cc0 cpi cioo co wcel cc0 cA csin cfv clt wbr cA csin cfv cc0 wne cA
      sinq12gt0t cA csin cfv cA cr wcel cA csin cfv cr wcel cA cr wcel cc0 cA
      cle wbr cA cpi clt wbr cA cc0 cpi cico co wcel cA cr wcel cc0 cA cle wbr
      cA cpi clt wbr w3a efif1lem5.1 cc0 cr wcel cpi cr wcel cA cc0 cpi cico co
      wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a wb 0re pire cc0 cpi cA
      elico2 mp2an mpbi 3simp1i cA resincl ax-mp gt0ne0i syl cA csin cfv cc0
      df-ne sylib adantr cA csin cfv cB csin cfv wceq cA cc0 cpi cioo co wcel
      cB cpi wceq wa cA csin cfv cc0 wceq cA csin cfv cB csin cfv wceq cB csin
      cfv cc0 wceq cA csin cfv cc0 wceq cA cc0 cpi cioo co wcel cB cpi wceq wa
      cA csin cfv cB csin cfv cc0 eqtr cB cpi wceq cB csin cfv cc0 wceq cA cc0
      cpi cioo co wcel cB cpi wceq cB csin cfv cpi csin cfv cc0 cB cpi csin
      fveq2 sinpi syl6eq adantl sylan2 expcom mtod cA csin cfv cB csin cfv wceq
      wn cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn ci cA
      cmul co ce cfv ci cB cmul co ce cfv wceq wn cA csin cfv cB csin cfv wceq
      wn cA ccos cfv cB ccos cfv wceq wn cA csin cfv cB csin cfv wceq wn wo cA
      ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn cA csin cfv
      cB csin cfv wceq wn cA ccos cfv cB ccos cfv wceq wn olc cA ccos cfv cB
      ccos cfv wceq cA csin cfv cB csin cfv wceq ianor sylibr ci cA cmul co ce
      cfv ci cB cmul co ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB
      csin cfv wceq wa cA cr wcel cB cr wcel ci cA cmul co ce cfv ci cB cmul co
      ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa
      wb cA cr wcel cc0 cA cle wbr cA cpi clt wbr cA cc0 cpi cico co wcel cA cr
      wcel cc0 cA cle wbr cA cpi clt wbr w3a efif1lem5.1 cc0 cr wcel cpi cr
      wcel cA cc0 cpi cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a
      wb 0re pire cc0 cpi cA elico2 mp2an mpbi 3simp1i cB cr wcel cpi cB cle
      wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB cr
      wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a efif1lem5.2 cpi cr wcel
      c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi
      cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire remulcli
      cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i cA cB efieq mp2an notbii
      sylibr syl cA cc0 wceq cB cpi c2 cpi cmul co cioo co wcel wa cA csin cfv
      cB csin cfv wceq wn ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn cA
      cc0 wceq cB cpi c2 cpi cmul co cioo co wcel wa cA csin cfv cB csin cfv
      wceq cc0 cB csin cfv wceq cB cpi c2 cpi cmul co cioo co wcel cc0 cB csin
      cfv wceq wn cA cc0 wceq cB cpi c2 cpi cmul co cioo co wcel cc0 cB csin
      cfv wne cc0 cB csin cfv wceq wn cB cpi c2 cpi cmul co cioo co wcel cB
      csin cfv cc0 clt wbr cc0 cB csin cfv wne cB cpi c2 cpi cmul co cioo co
      wcel cc0 cB cpi cmin co csin cfv clt wbr cB csin cfv cc0 clt wbr cB cpi
      c2 cpi cmul co cioo co wcel cB cpi cmin co cc0 cpi cioo co wcel cc0 cB
      cpi cmin co csin cfv clt wbr cB efif1lem1 cB cpi cmin co sinq12gt0t syl
      cc0 cB cpi cmin co csin cfv clt wbr cc0 cB csin cfv cneg clt wbr cB csin
      cfv cc0 clt wbr cB cpi cmin co csin cfv cB csin cfv cneg cc0 clt cB cc
      wcel cB cpi cmin co csin cfv cB csin cfv cneg wceq cB cB cr wcel cpi cB
      cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB
      cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a efif1lem5.2 cpi cr
      wcel c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr wcel
      cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire
      remulcli cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i recni cB sinmpi
      ax-mp breq2i cB cr wcel cB csin cfv cc0 clt wbr cc0 cB csin cfv cneg clt
      wbr wb cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi
      cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr
      w3a efif1lem5.2 cpi cr wcel c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co
      cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a wb
      pire c2 cpi 2re pire remulcli cpi c2 cpi cmul co cB elico2 mp2an mpbi
      3simp1i cB cr wcel cB csin cfv cr wcel cB csin cfv cc0 clt wbr cc0 cB
      csin cfv cneg clt wbr wb cB resincl cB csin cfv lt0neg1 syl ax-mp bitr4i
      sylib cB csin cfv cc0 cB cr wcel cB csin cfv cr wcel cB cr wcel cpi cB
      cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB
      cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a efif1lem5.2 cpi cr
      wcel c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr wcel
      cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire
      remulcli cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i cB resincl ax-mp
      0re ltnei syl cc0 cB csin cfv df-ne sylib adantl cA cc0 wceq cB cpi c2
      cpi cmul co cioo co wcel wa cA csin cfv cB csin cfv wceq cc0 cB csin cfv
      wceq cc0 cA csin cfv wceq cA csin cfv cB csin cfv wceq cc0 cB csin cfv
      wceq cA cc0 wceq cB cpi c2 cpi cmul co cioo co wcel wa cc0 cA csin cfv cB
      csin cfv eqtr cA cc0 wceq cc0 cA csin cfv wceq cB cpi c2 cpi cmul co cioo
      co wcel cA cc0 wceq cA csin cfv cc0 csin cfv cc0 cA cc0 csin fveq2 sin0
      syl6req adantr sylan ex mtod cA csin cfv cB csin cfv wceq wn cA ccos cfv
      cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn ci cA cmul co ce cfv
      ci cB cmul co ce cfv wceq wn cA csin cfv cB csin cfv wceq wn cA ccos cfv
      cB ccos cfv wceq wn cA csin cfv cB csin cfv wceq wn wo cA ccos cfv cB
      ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn cA csin cfv cB csin cfv
      wceq wn cA ccos cfv cB ccos cfv wceq wn olc cA ccos cfv cB ccos cfv wceq
      cA csin cfv cB csin cfv wceq ianor sylibr ci cA cmul co ce cfv ci cB cmul
      co ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq
      wa cA cr wcel cB cr wcel ci cA cmul co ce cfv ci cB cmul co ce cfv wceq
      cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wb cA cr
      wcel cc0 cA cle wbr cA cpi clt wbr cA cc0 cpi cico co wcel cA cr wcel cc0
      cA cle wbr cA cpi clt wbr w3a efif1lem5.1 cc0 cr wcel cpi cr wcel cA cc0
      cpi cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a wb 0re pire
      cc0 cpi cA elico2 mp2an mpbi 3simp1i cB cr wcel cpi cB cle wbr cB c2 cpi
      cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle
      wbr cB c2 cpi cmul co clt wbr w3a efif1lem5.2 cpi cr wcel c2 cpi cmul co
      cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB
      c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire remulcli cpi c2 cpi
      cmul co cB elico2 mp2an mpbi 3simp1i cA cB efieq mp2an notbii sylibr syl
      cA cc0 cpi cioo co wcel cB cpi c2 cpi cmul co cioo co wcel wa cA csin cfv
      cB csin cfv wceq wn ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn cA
      cc0 cpi cioo co wcel cB cpi c2 cpi cmul co cioo co wcel wa cA csin cfv cB
      csin cfv wceq cc0 cB csin cfv clt wbr cB cpi c2 cpi cmul co cioo co wcel
      cc0 cB csin cfv clt wbr wn cA cc0 cpi cioo co wcel cB cpi c2 cpi cmul co
      cioo co wcel cB csin cfv cc0 clt wbr cc0 cB csin cfv clt wbr wn cB cpi c2
      cpi cmul co cioo co wcel cc0 cB cpi cmin co csin cfv clt wbr cB csin cfv
      cc0 clt wbr cB cpi c2 cpi cmul co cioo co wcel cB cpi cmin co cc0 cpi
      cioo co wcel cc0 cB cpi cmin co csin cfv clt wbr cB efif1lem1 cB cpi cmin
      co sinq12gt0t syl cc0 cB cpi cmin co csin cfv clt wbr cc0 cB csin cfv
      cneg clt wbr cB csin cfv cc0 clt wbr cB cpi cmin co csin cfv cB csin cfv
      cneg cc0 clt cB cc wcel cB cpi cmin co csin cfv cB csin cfv cneg wceq cB
      cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co
      cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a
      efif1lem5.2 cpi cr wcel c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico
      co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire
      c2 cpi 2re pire remulcli cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i
      recni cB sinmpi ax-mp breq2i cB cr wcel cB csin cfv cc0 clt wbr cc0 cB
      csin cfv cneg clt wbr wb cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt
      wbr cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2
      cpi cmul co clt wbr w3a efif1lem5.2 cpi cr wcel c2 cpi cmul co cr wcel cB
      cpi c2 cpi cmul co cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul
      co clt wbr w3a wb pire c2 cpi 2re pire remulcli cpi c2 cpi cmul co cB
      elico2 mp2an mpbi 3simp1i cB cr wcel cB csin cfv cr wcel cB csin cfv cc0
      clt wbr cc0 cB csin cfv cneg clt wbr wb cB resincl cB csin cfv lt0neg1
      syl ax-mp bitr4i sylib cB csin cfv cc0 cB cr wcel cB csin cfv cr wcel cB
      cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co
      cico co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a
      efif1lem5.2 cpi cr wcel c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico
      co wcel cB cr wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire
      c2 cpi 2re pire remulcli cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i
      cB resincl ax-mp 0re ltnsymi syl adantl cA cc0 cpi cioo co wcel cA csin
      cfv cB csin cfv wceq cc0 cB csin cfv clt wbr wi cB cpi c2 cpi cmul co
      cioo co wcel cA csin cfv cB csin cfv wceq cc0 cA csin cfv clt wbr cc0 cB
      csin cfv clt wbr cA cc0 cpi cioo co wcel cA csin cfv cB csin cfv cc0 clt
      breq2 cA sinq12gt0t syl5cbi adantr mtod cA csin cfv cB csin cfv wceq wn
      cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn ci cA
      cmul co ce cfv ci cB cmul co ce cfv wceq wn cA csin cfv cB csin cfv wceq
      wn cA ccos cfv cB ccos cfv wceq wn cA csin cfv cB csin cfv wceq wn wo cA
      ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa wn cA csin cfv
      cB csin cfv wceq wn cA ccos cfv cB ccos cfv wceq wn olc cA ccos cfv cB
      ccos cfv wceq cA csin cfv cB csin cfv wceq ianor sylibr ci cA cmul co ce
      cfv ci cB cmul co ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB
      csin cfv wceq wa cA cr wcel cB cr wcel ci cA cmul co ce cfv ci cB cmul co
      ce cfv wceq cA ccos cfv cB ccos cfv wceq cA csin cfv cB csin cfv wceq wa
      wb cA cr wcel cc0 cA cle wbr cA cpi clt wbr cA cc0 cpi cico co wcel cA cr
      wcel cc0 cA cle wbr cA cpi clt wbr w3a efif1lem5.1 cc0 cr wcel cpi cr
      wcel cA cc0 cpi cico co wcel cA cr wcel cc0 cA cle wbr cA cpi clt wbr w3a
      wb 0re pire cc0 cpi cA elico2 mp2an mpbi 3simp1i cB cr wcel cpi cB cle
      wbr cB c2 cpi cmul co clt wbr cB cpi c2 cpi cmul co cico co wcel cB cr
      wcel cpi cB cle wbr cB c2 cpi cmul co clt wbr w3a efif1lem5.2 cpi cr wcel
      c2 cpi cmul co cr wcel cB cpi c2 cpi cmul co cico co wcel cB cr wcel cpi
      cB cle wbr cB c2 cpi cmul co clt wbr w3a wb pire c2 cpi 2re pire remulcli
      cpi c2 cpi cmul co cB elico2 mp2an mpbi 3simp1i cA cB efieq mp2an notbii
      sylibr syl ccase mp2an $.
      $( [26-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  $( Lemma for ~ efif1 . $)
  efif1lem6 $p |- ( ( A e. ( 0 [,) pi ) /\ B e. ( pi [,) ( 2 x. pi ) ) ) ->
                     -. ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) ) $=
    cA cc0 cpi cico co wcel cB cpi c2 cpi cmul co cico co wcel ci cA cmul co ce
    cfv ci cB cmul co ce cfv wceq wn ci cA cc0 cpi cico co wcel cA cc0 cif cmul
    co ce cfv ci cB cmul co ce cfv wceq wn ci cA cc0 cpi cico co wcel cA cc0
    cif cmul co ce cfv ci cB cpi c2 cpi cmul co cico co wcel cB cpi cif cmul co
    ce cfv wceq wn cA cB cc0 cpi cA cA cc0 cpi cico co wcel cA cc0 cif wceq ci
    cA cmul co ce cfv ci cB cmul co ce cfv wceq ci cA cc0 cpi cico co wcel cA
    cc0 cif cmul co ce cfv ci cB cmul co ce cfv wceq cA cA cc0 cpi cico co wcel
    cA cc0 cif wceq ci cA cmul co ce cfv ci cA cc0 cpi cico co wcel cA cc0 cif
    cmul co ce cfv ci cB cmul co ce cfv cA cA cc0 cpi cico co wcel cA cc0 cif
    wceq ci cA cmul co ci cA cc0 cpi cico co wcel cA cc0 cif cmul co ce cA cA
    cc0 cpi cico co wcel cA cc0 cif ci cmul opreq2 fveq2d eqeq1d notbid cB cB
    cpi c2 cpi cmul co cico co wcel cB cpi cif wceq ci cA cc0 cpi cico co wcel
    cA cc0 cif cmul co ce cfv ci cB cmul co ce cfv wceq ci cA cc0 cpi cico co
    wcel cA cc0 cif cmul co ce cfv ci cB cpi c2 cpi cmul co cico co wcel cB cpi
    cif cmul co ce cfv wceq cB cB cpi c2 cpi cmul co cico co wcel cB cpi cif
    wceq ci cB cmul co ce cfv ci cB cpi c2 cpi cmul co cico co wcel cB cpi cif
    cmul co ce cfv ci cA cc0 cpi cico co wcel cA cc0 cif cmul co ce cfv cB cB
    cpi c2 cpi cmul co cico co wcel cB cpi cif wceq ci cB cmul co ci cB cpi c2
    cpi cmul co cico co wcel cB cpi cif cmul co ce cB cB cpi c2 cpi cmul co
    cico co wcel cB cpi cif ci cmul opreq2 fveq2d eqeq2d notbid cA cc0 cpi cico
    co wcel cA cc0 cif cB cpi c2 cpi cmul co cico co wcel cB cpi cif cA cc0 cc0
    cpi cico co cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr cc0 cc0 cpi cico co
    wcel 0re cc0 0re leidi pipos cc0 cc0 cpi cico co wcel cc0 cr wcel cc0 cc0
    cle wbr cc0 cpi clt wbr w3a cc0 cr wcel cpi cr wcel cc0 cc0 cpi cico co
    wcel cc0 cr wcel cc0 cc0 cle wbr cc0 cpi clt wbr w3a wb 0re pire cc0 cpi
    cc0 elico2 mp2an biimpri mp3an elimel cB cpi cpi c2 cpi cmul co cico co cpi
    cr wcel cpi cpi cle wbr cpi c2 cpi cmul co clt wbr cpi cpi c2 cpi cmul co
    cico co wcel pire cpi pire leidi c1 c2 clt wbr cpi c2 cpi cmul co clt wbr
    1lt2 cpi cr wcel c2 cr wcel cc0 cpi clt wbr c1 c2 clt wbr cpi c2 cpi cmul
    co clt wbr wb pire 2re pipos cpi c2 ltmulgt12 mp3an mpbi cpi cpi c2 cpi
    cmul co cico co wcel cpi cr wcel cpi cpi cle wbr cpi c2 cpi cmul co clt wbr
    w3a cpi cr wcel c2 cpi cmul co cr wcel cpi cpi c2 cpi cmul co cico co wcel
    cpi cr wcel cpi cpi cle wbr cpi c2 cpi cmul co clt wbr w3a wb pire c2 cpi
    2re pire remulcli cpi c2 cpi cmul co cpi elico2 mp2an biimpri mp3an elimel
    efif1lem5 dedth2h $.
    $( [16-Mar-2008] $) $( [16-Mar-2008] $)

  $( Lemma for ~ efif1 . $)
  efif1lem7 $p |- ( ( A e. ( 0 [,) ( 2 x. pi ) ) /\
                       B e. ( 0 [,) ( 2 x. pi ) ) ) ->
        ( ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) -> A = B ) ) $=
    cA cc0 cpi cico co wcel cA cpi c2 cpi cmul co cico co wcel wo cB cc0 cpi
    cico co wcel cB cpi c2 cpi cmul co cico co wcel wo ci cA cmul co ce cfv ci
    cB cmul co ce cfv wceq cA cB wceq wi cA cc0 c2 cpi cmul co cico co wcel cB
    cc0 c2 cpi cmul co cico co wcel cA cc0 cpi cico co wcel cB cc0 cpi cico co
    wcel cA cpi c2 cpi cmul co cico co wcel cB cpi c2 cpi cmul co cico co wcel
    ci cA cmul co ce cfv ci cB cmul co ce cfv wceq cA cB wceq wi cA cB
    efif1lem3 cA cpi c2 cpi cmul co cico co wcel cB cc0 cpi cico co wcel wa ci
    cA cmul co ce cfv ci cB cmul co ce cfv wceq cA cB wceq cA cpi c2 cpi cmul
    co cico co wcel cB cc0 cpi cico co wcel wa ci cB cmul co ce cfv ci cA cmul
    co ce cfv wceq wn ci cA cmul co ce cfv ci cB cmul co ce cfv wceq wn cB cc0
    cpi cico co wcel cA cpi c2 cpi cmul co cico co wcel ci cB cmul co ce cfv ci
    cA cmul co ce cfv wceq wn cB cA efif1lem6 ancoms ci cB cmul co ce cfv ci cA
    cmul co ce cfv wceq ci cA cmul co ce cfv ci cB cmul co ce cfv wceq ci cB
    cmul co ce cfv ci cA cmul co ce cfv eqcom notbii sylib pm2.21d cA cc0 cpi
    cico co wcel cB cpi c2 cpi cmul co cico co wcel wa ci cA cmul co ce cfv ci
    cB cmul co ce cfv wceq cA cB wceq cA cB efif1lem6 pm2.21d cA cB efif1lem4
    ccase cA cc0 c2 cpi cmul co cico co wcel cA cc0 cpi cico co cpi c2 cpi cmul
    co cico co cun wcel cA cc0 cpi cico co wcel cA cpi c2 cpi cmul co cico co
    wcel wo cc0 cpi cico co cpi c2 cpi cmul co cico co cun cc0 c2 cpi cmul co
    cico co cA cc0 cr wcel cpi cr wcel c2 cpi cmul co cr wcel w3a cc0 cpi cle
    wbr cpi c2 cpi cmul co cle wbr wa cc0 cpi cico co cpi c2 cpi cmul co cico
    co cun cc0 c2 cpi cmul co cico co wceq cc0 cr wcel cpi cr wcel c2 cpi cmul
    co cr wcel 0re pire c2 cpi 2re pire remulcli 3pm3.2i cc0 cpi cle wbr cpi c2
    cpi cmul co cle wbr cc0 cpi 0re pire pipos ltleii cpi c2 cpi cmul co pire
    c2 cpi 2re pire remulcli c1 c2 clt wbr cpi c2 cpi cmul co clt wbr 1lt2 cpi
    cr wcel c2 cr wcel cc0 cpi clt wbr c1 c2 clt wbr cpi c2 cpi cmul co clt wbr
    wb pire 2re pipos cpi c2 ltmulgt12 mp3an mpbi ltleii pm3.2i cc0 cpi c2 cpi
    cmul co icoun mp2an eleq2i cA cc0 cpi cico co cpi c2 cpi cmul co cico co
    elun bitr3i cB cc0 c2 cpi cmul co cico co wcel cB cc0 cpi cico co cpi c2
    cpi cmul co cico co cun wcel cB cc0 cpi cico co wcel cB cpi c2 cpi cmul co
    cico co wcel wo cc0 cpi cico co cpi c2 cpi cmul co cico co cun cc0 c2 cpi
    cmul co cico co cB cc0 cr wcel cpi cr wcel c2 cpi cmul co cr wcel w3a cc0
    cpi cle wbr cpi c2 cpi cmul co cle wbr wa cc0 cpi cico co cpi c2 cpi cmul
    co cico co cun cc0 c2 cpi cmul co cico co wceq cc0 cr wcel cpi cr wcel c2
    cpi cmul co cr wcel 0re pire c2 cpi 2re pire remulcli 3pm3.2i cc0 cpi cle
    wbr cpi c2 cpi cmul co cle wbr cc0 cpi 0re pire pipos ltleii cpi c2 cpi
    cmul co pire c2 cpi 2re pire remulcli c1 c2 clt wbr cpi c2 cpi cmul co clt
    wbr 1lt2 cpi cr wcel c2 cr wcel cc0 cpi clt wbr c1 c2 clt wbr cpi c2 cpi
    cmul co clt wbr wb pire 2re pipos cpi c2 ltmulgt12 mp3an mpbi ltleii pm3.2i
    cc0 cpi c2 cpi cmul co icoun mp2an eleq2i cB cc0 cpi cico co cpi c2 cpi
    cmul co cico co elun bitr3i syl2anb $.
    $( [26-Mar-2008] $) $( [16-Mar-2008] $)

  ${
    $d F a b $.  $d F z $.  $d a b x y $.
    efif1.1 $e |- F = { <. x , y >. | ( x e. ( 0 [,) ( 2 x. pi ) ) /\
                        y = ( exp ` ( _i x. x ) ) ) } $.
    efif1.2 $e |- S = { z e. CC | ( abs ` z ) = 1 } $.
    $( The exponential function of an imaginary number maps the closed-below,
       open-above interval from ` 0 ` to ` 2 x. pi ` one-to-one to the unit
       circle.  (Contributed by Paul Chapman, 16-Mar-2008.) $)
    efif1 $p |- F : ( 0 [,) ( 2 x. pi ) ) -1-1-> S $=
      cc0 c2 cpi cmul co cico co cS cF wf1 cc0 c2 cpi cmul co cico co cS cF wf
      va cv cF cfv vb cv cF cfv wceq va cv vb cv wceq wi vb cc0 c2 cpi cmul co
      cico co wral va cc0 c2 cpi cmul co cico co wral va vb cc0 c2 cpi cmul co
      cico co cS cF dff13 vx vy vz cS cF efif1.1 efif1.2 efif va cv cF cfv vb
      cv cF cfv wceq va cv vb cv wceq wi va vb cc0 c2 cpi cmul co cico co va cv
      cc0 c2 cpi cmul co cico co wcel vb cv cc0 c2 cpi cmul co cico co wcel wa
      va cv cF cfv vb cv cF cfv wceq ci va cv cmul co ce cfv ci vb cv cmul co
      ce cfv wceq va cv vb cv wceq va cv cc0 c2 cpi cmul co cico co wcel vb cv
      cc0 c2 cpi cmul co cico co wcel va cv cF cfv ci va cv cmul co ce cfv vb
      cv cF cfv ci vb cv cmul co ce cfv vx vy va cv ci vx cv cmul co ce cfv ci
      va cv cmul co ce cfv cc0 c2 cpi cmul co cico co cF vx cv va cv wceq ci vx
      cv cmul co ci va cv cmul co ce vx cv va cv ci cmul opreq2 fveq2d efif1.1
      ci va cv cmul co ce fvex fvopab4 vx vy vb cv ci vx cv cmul co ce cfv ci
      vb cv cmul co ce cfv cc0 c2 cpi cmul co cico co cF vx cv vb cv wceq ci vx
      cv cmul co ci vb cv cmul co ce vx cv vb cv ci cmul opreq2 fveq2d efif1.1
      ci vb cv cmul co ce fvex fvopab4 eqeqan12d va cv vb cv efif1lem7 sylbid
      rgen2a mpbir2an $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)

    $( The exponential function of an imaginary number maps the closed-below,
       open-above interval from ` 0 ` to ` 2 x. pi ` one-to-one onto the unit
       circle.  (Contributed by Paul Chapman, 16-Mar-2008.) $)
    efif1o $p |- F : ( 0 [,) ( 2 x. pi ) ) -1-1-onto-> S $=
      cc0 c2 cpi cmul co cico co cS cF wf1o cc0 c2 cpi cmul co cico co cS cF
      wf1 cc0 c2 cpi cmul co cico co cS cF wfo cc0 c2 cpi cmul co cico co cS cF
      df-f1o vx vy vz cS cF efif1.1 efif1.2 efif1 vx vy vz cS cF efif1.1
      efif1.2 efifo mpbir2an $.
      $( [16-Mar-2008] $) $( [16-Mar-2008] $)
  $}

  ${
    $d A w $.  $d C x z $.  $d w x y z $.
    circgrp.1 $e |- C = { w e. CC | ( abs ` w ) = 1 } $.
    $( Membership of the exponential function of ` _i ` times a real number in
       the unit circle.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
    efielcirc $p |- ( A e. RR -> ( exp ` ( _i x. A ) ) e. C ) $=
      ci cA cmul co ce cfv cc wcel ci cA cmul co ce cfv cabs cfv c1 wceq ci cA
      cmul co ce cfv cC wcel cA cr wcel ci cA cmul co ce cfv cC wcel ci cA cmul
      co ce cfv cc wcel ci cA cmul co ce cfv cabs cfv c1 wceq wa vw cv cabs cfv
      c1 wceq ci cA cmul co ce cfv cabs cfv c1 wceq vw ci cA cmul co ce cfv cc
      cC vw cv ci cA cmul co ce cfv wceq vw cv cabs cfv ci cA cmul co ce cfv
      cabs cfv c1 vw cv ci cA cmul co ce cfv cabs fveq2 eqeq1d circgrp.1 elrab2
      biimpri cA cr wcel cA cc wcel ci cA cmul co cc wcel ci cA cmul co ce cfv
      cc wcel cA recn ci cc wcel cA cc wcel ci cA cmul co cc wcel axicn ci cA
      mulcl mpan ci cA cmul co efcl 3syl cA absefi sylanc $.
      $( [26-Apr-2008] $) $( [25-Mar-2008] $)

    circgrp.2 $e |- T = ( x. |` ( C X. C ) ) $.
    $( The circle group ` T ` is an Abelian group.  (Contributed by Paul
       Chapman, 25-Mar-2008.) $)
    circgrp $p |- T e. Abel $=
      vx vy ci cC cT cr vz cC vy cv ci vx cv cmul co ce cfv wceq vx cr wrex vy
      cab vz cv cC wcel vz cv vy cv ci vx cv cmul co ce cfv wceq vx cr wrex vy
      cab wcel vz cv cC wcel vz cv ci vx cv cmul co ce cfv wceq vx cr wrex vz
      cv vy cv ci vx cv cmul co ce cfv wceq vx cr wrex vy cab wcel vz cv cC
      wcel vz cv ci vx cv cmul co ce cfv wceq vx cc0 c2 cpi cmul co cico co
      wrex vz cv ci vx cv cmul co ce cfv wceq vx cr wrex vz cv cC wcel vz cv cc
      wcel vz cv cabs cfv c1 wceq wa vz cv ci vx cv cmul co ce cfv wceq vx cc0
      c2 cpi cmul co cico co wrex vw cv cabs cfv c1 wceq vz cv cabs cfv c1 wceq
      vw vz cv cc cC vw cv vz cv wceq vw cv cabs cfv vz cv cabs cfv c1 vw cv vz
      cv cabs fveq2 eqeq1d circgrp.1 elrab2 vz cv vx efifolem7 sylbi vz cv ci
      vx cv cmul co ce cfv wceq vz cv ci vx cv cmul co ce cfv wceq vx cc0 c2
      cpi cmul co cico co cr vx cv cc0 c2 cpi cmul co cico co wcel vx cv cr
      wcel vz cv ci vx cv cmul co ce cfv wceq vx cv cc0 c2 cpi cmul co cico co
      wcel vx cv cr wcel cc0 vx cv cle wbr vx cv c2 cpi cmul co clt wbr vx cv
      cc0 c2 cpi cmul co cico co wcel vx cv cr wcel cc0 vx cv cle wbr vx cv c2
      cpi cmul co clt wbr w3a cc0 cr wcel c2 cpi cmul co cr wcel vx cv cc0 c2
      cpi cmul co cico co wcel vx cv cr wcel cc0 vx cv cle wbr vx cv c2 cpi
      cmul co clt wbr w3a wb 0re c2 cpi 2re pire remulcli cc0 c2 cpi cmul co vx
      cv elico2 mp2an biimpi 3simp1d anim1i r19.22i2 syl vy cv ci vx cv cmul co
      ce cfv wceq vx cr wrex vz cv ci vx cv cmul co ce cfv wceq vx cr wrex vy
      vz cv vz visset vy cv vz cv wceq vy cv ci vx cv cmul co ce cfv wceq vz cv
      ci vx cv cmul co ce cfv wceq vx cr vy cv vz cv ci vx cv cmul co ce cfv
      eqeq1 rexbidv elab sylibr vz cv vy cv ci vx cv cmul co ce cfv wceq vx cr
      wrex vy cab wcel vz cv ci vx cv cmul co ce cfv wceq vx cr wrex vz cv cC
      wcel vy cv ci vx cv cmul co ce cfv wceq vx cr wrex vz cv ci vx cv cmul co
      ce cfv wceq vx cr wrex vy vz cv vz visset vy cv vz cv wceq vy cv ci vx cv
      cmul co ce cfv wceq vz cv ci vx cv cmul co ce cfv wceq vx cr vy cv vz cv
      ci vx cv cmul co ce cfv eqeq1 rexbidv elab vz cv ci vx cv cmul co ce cfv
      wceq vz cv cC wcel vx cr vz cv ci vx cv cmul co ce cfv wceq vz cv cC wcel
      ci vx cv cmul co ce cfv cC wcel vx cv cr wcel vz cv ci vx cv cmul co ce
      cfv cC eleq1 vw vx cv cC circgrp.1 efielcirc syl5cbir r19.23aiv sylbi
      impbii eqriv circgrp.2 axicn axresscn readdsubg efghgrpi $.
      $( [26-Apr-2008] $) $( [25-Mar-2008] $)
  $}

  ${
    $d A v x y z $.  $d A w x y $.  $d C v x y z $.  $d D x y $.  $d w v z $.
    shftefif1o.1 $e |- D = ( A [,) ( A + ( 2 x. pi ) ) ) $.
    shftefif1o.2 $e |- G = { <. x , y >. | ( x e. D /\
                             y = ( exp ` ( _i x. x ) ) ) } $.
    shftefif1o.3 $e |- C = { w e. CC | ( abs ` w ) = 1 } $.

    ${
      $d A u w $.  $d C u $.  $d D z $.  $d F w $.  $d G z $.  $d H z $.
      $d T u v x y $.

      shftefif1o.4 $e |- F = { <. x , y >. | ( x e. ( 0 [,) ( 2 x. pi ) ) /\
                               y = ( exp ` ( _i x. x ) ) ) } $.
      shftefif1o.5 $e |- S = { <. x , y >. |
              ( x e. ( A [,) ( A + ( 2 x. pi ) ) ) /\ y = ( x + -u A ) ) } $.
      shftefif1o.6 $e |- T = ( x. |` ( C X. C ) ) $.
      shftefif1o.7 $e |- L = { <. u , v >. | ( u e. C /\ v = { <. x , y >. |
                               ( x e. C /\ y = ( u T x ) ) } ) } $.
      shftefif1o.8 $e |- H = ( ( L ` ( exp ` ( _i x. A ) ) ) o. ( F o. S ) ) $.
      $( Lemma for ~ shftefif1o . $)
      shftefif1olem $p |- ( A e. RR -> G : D -1-1-onto-> C ) $=
        cA cr wcel cD cC cG wf1o cD cC cH wf1o cC cC ci cA cmul co ce cfv cL
        cfv wf1o cD cC cF cS ccom wf1o cD cC cH wf1o cA cr wcel cC cC ci cA
        cmul co ce cfv cL cfv wf1o cD cC cF cS ccom wf1o wa cD cC ci cA cmul co
        ce cfv cL cfv cF cS ccom ccom wf1o cD cC cH wf1o cD cC cC ci cA cmul co
        ce cfv cL cfv cF cS ccom f1oco cH ci cA cmul co ce cfv cL cfv cF cS
        ccom ccom wceq cD cC cH wf1o cD cC ci cA cmul co ce cfv cL cfv cF cS
        ccom ccom wf1o wb shftefif1o.8 cD cC cH ci cA cmul co ce cfv cL cfv cF
        cS ccom ccom f1oeq1 ax-mp sylibr cA cr wcel ci cA cmul co ce cfv cC
        wcel cC cC ci cA cmul co ce cfv cL cfv wf1o vw cA cC shftefif1o.3
        efielcirc cT cgr wcel ci cA cmul co ce cfv cC wcel cC cC ci cA cmul co
        ce cfv cL cfv wf1o cT cabl wcel cT cgr wcel vw cC cT shftefif1o.3
        shftefif1o.6 circgrp cT ablgrp ax-mp ci cA cmul co ce cfv vu vv cL cT
        cC vx vy shftefif1o.7 cmul cdm cc cc cxp wceq cT cgr wcel cC cc wss cC
        cT crn wceq cc cc cxp cc cmul axmulopr fdmi cT cabl wcel cT cgr wcel vw
        cC cT shftefif1o.3 shftefif1o.6 circgrp cT ablgrp ax-mp cC vw cv cabs
        cfv c1 wceq vw cc crab cc shftefif1o.3 vw cv cabs cfv c1 wceq vw cc
        ssrab2 eqsstri cmul cT cc cC shftefif1o.6 resgrprn mp3an grplactf1o
        mpan syl cA cr wcel cD cc0 c2 cpi cmul co cico co cS wf1o cD cC cF cS
        ccom wf1o cA cr wcel cD cA cA cneg caddc co cA c2 cpi cmul co caddc co
        cA cneg caddc co cico co cS wf1o cD cc0 c2 cpi cmul co cico co cS wf1o
        cA cr wcel cA c2 cpi cmul co caddc co cr wcel cA cneg cr wcel cD cA cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS
        wf1o cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi cmul co caddc co cr
        wcel c2 cpi 2re pire remulcli cA c2 cpi cmul co readdcl mpan2 cA
        renegcl cA cr wcel cA c2 cpi cmul co caddc co cr wcel cA cneg cr wcel
        w3a cA cA c2 cpi cmul co caddc co cico co cA cA cneg caddc co cA c2 cpi
        cmul co caddc co cA cneg caddc co cico co cS wf1o cD cA cA cneg caddc
        co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o vx vy cA
        cA c2 cpi cmul co caddc co cA cneg cS shftefif1o.5 icoshftf1o cD cA cA
        c2 cpi cmul co caddc co cico co wceq cD cA cA cneg caddc co cA c2 cpi
        cmul co caddc co cA cneg caddc co cico co cS wf1o cA cA c2 cpi cmul co
        caddc co cico co cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg
        caddc co cico co cS wf1o wb shftefif1o.1 cD cA cA c2 cpi cmul co caddc
        co cico co cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc
        co cico co cS f1oeq2 ax-mp sylibr mpd3an23 cA cr wcel cA cA cneg caddc
        co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cc0 c2 cpi cmul
        co cico co wceq cD cA cA cneg caddc co cA c2 cpi cmul co caddc co cA
        cneg caddc co cico co cS wf1o cD cc0 c2 cpi cmul co cico co cS wf1o wb
        cA cr wcel cA cA cneg caddc co cc0 cA c2 cpi cmul co caddc co cA cneg
        caddc co c2 cpi cmul co cico cA cr wcel cA cc wcel cA cA cneg caddc co
        cc0 wceq cA recn cA negid syl cA cr wcel cA c2 cpi cmul co caddc co cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cmin co c2 cpi cmul co cA
        c2 cpi cmul co caddc co cc wcel cA cc wcel cA c2 cpi cmul co caddc co
        cA cneg caddc co cA c2 cpi cmul co caddc co cA cmin co wceq cA cr wcel
        cA c2 cpi cmul co caddc co cA negsub cA cr wcel cA c2 cpi cmul co caddc
        co cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel
        c2 cpi 2re pire remulcli cA c2 cpi cmul co readdcl mpan2 recnd cA recn
        sylanc cA cr wcel cA cc wcel cA c2 cpi cmul co caddc co cA cmin co c2
        cpi cmul co wceq cA recn cA cc wcel c2 cpi cmul co cc wcel cA c2 cpi
        cmul co caddc co cA cmin co c2 cpi cmul co wceq c2 cpi cmul co c2 cpi
        2re pire remulcli recni cA c2 cpi cmul co pncan2 mpan2 syl eqtrd
        opreq12d cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc
        co cico co cc0 c2 cpi cmul co cico co cD cS f1oeq3 syl mpbid cc0 c2 cpi
        cmul co cico co cC cF wf1o cD cc0 c2 cpi cmul co cico co cS wf1o cD cC
        cF cS ccom wf1o vx vy vw cC cF shftefif1o.4 shftefif1o.3 efif1o cD cc0
        c2 cpi cmul co cico co cC cF cS f1oco mpan syl sylanc cA cr wcel cG cH
        wceq cD cC cG wf1o cD cC cH wf1o wb cA cr wcel vz cv cG cfv vz cv cH
        cfv wceq vz cD wral cG cH wceq cA cr wcel vz cv cG cfv vz cv cH cfv
        wceq vz cD cA cr wcel vz cv cD wcel wa vz cv cG cfv ci vz cv cmul co ce
        cfv vz cv cH cfv vz cv cD wcel vz cv cG cfv ci vz cv cmul co ce cfv
        wceq cA cr wcel vx vy vz cv ci vx cv cmul co ce cfv ci vz cv cmul co ce
        cfv cD cG vx cv vz cv wceq ci vx cv cmul co ci vz cv cmul co ce vx cv
        vz cv ci cmul opreq2 fveq2d shftefif1o.2 ci vz cv cmul co ce fvex
        fvopab4 adantl cA cr wcel vz cv cD wcel wa vz cv cH cfv ci cA cmul co
        ce cfv ci vz cv cA cmin co cmul co ce cfv cmul co ci cA cmul co ci vz
        cv cA cmin co cmul co caddc co ce cfv ci vz cv cmul co ce cfv cA cr
        wcel vz cv cD wcel wa vz cv cH cfv vz cv cS cfv cF cfv ci cA cmul co ce
        cfv cL cfv cfv ci vz cv cA cmin co cmul co ce cfv ci cA cmul co ce cfv
        cL cfv cfv ci cA cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cmul
        co cA cr wcel vz cv cD wcel wa vz cv cH cfv vz cv cF cS ccom cfv ci cA
        cmul co ce cfv cL cfv cfv vz cv cS cfv cF cfv ci cA cmul co ce cfv cL
        cfv cfv cA cr wcel vz cv cD wcel wa vz cv ci cA cmul co ce cfv cL cfv
        cF cS ccom ccom cfv vz cv cF cS ccom cfv ci cA cmul co ce cfv cL cfv
        cfv vz cv cH cfv ci cA cmul co ce cfv cL cfv wfun cD cC cF cS ccom wf
        wa vz cv cD wcel vz cv ci cA cmul co ce cfv cL cfv cF cS ccom ccom cfv
        vz cv cF cS ccom cfv ci cA cmul co ce cfv cL cfv cfv wceq cA cr wcel ci
        cA cmul co ce cfv cL cfv wfun cD cC cF cS ccom wf vz cv cD wcel vz cv
        ci cA cmul co ce cfv cL cfv cF cS ccom ccom cfv vz cv cF cS ccom cfv ci
        cA cmul co ce cfv cL cfv cfv wceq cD cC vz cv ci cA cmul co ce cfv cL
        cfv cF cS ccom fvco3 3expa cA cr wcel ci cA cmul co ce cfv cL cfv wfun
        cD cC cF cS ccom wf cA cr wcel cC cC ci cA cmul co ce cfv cL cfv wf1o
        ci cA cmul co ce cfv cL cfv wfun cA cr wcel ci cA cmul co ce cfv cC
        wcel cC cC ci cA cmul co ce cfv cL cfv wf1o vw cA cC shftefif1o.3
        efielcirc cT cgr wcel ci cA cmul co ce cfv cC wcel cC cC ci cA cmul co
        ce cfv cL cfv wf1o cT cabl wcel cT cgr wcel vw cC cT shftefif1o.3
        shftefif1o.6 circgrp cT ablgrp ax-mp ci cA cmul co ce cfv vu vv cL cT
        cC vx vy shftefif1o.7 cmul cdm cc cc cxp wceq cT cgr wcel cC cc wss cC
        cT crn wceq cc cc cxp cc cmul axmulopr fdmi cT cabl wcel cT cgr wcel vw
        cC cT shftefif1o.3 shftefif1o.6 circgrp cT ablgrp ax-mp cC vw cv cabs
        cfv c1 wceq vw cc crab cc shftefif1o.3 vw cv cabs cfv c1 wceq vw cc
        ssrab2 eqsstri cmul cT cc cC shftefif1o.6 resgrprn mp3an grplactf1o
        mpan syl cC cC ci cA cmul co ce cfv cL cfv f1ofun syl cA cr wcel cD cC
        cF cS ccom wf1o cD cC cF cS ccom wf cA cr wcel cD cc0 c2 cpi cmul co
        cico co cS wf1o cD cC cF cS ccom wf1o cA cr wcel cD cA cA cneg caddc co
        cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o cD cc0 c2
        cpi cmul co cico co cS wf1o cA cr wcel cA c2 cpi cmul co caddc co cr
        wcel cA cneg cr wcel cD cA cA cneg caddc co cA c2 cpi cmul co caddc co
        cA cneg caddc co cico co cS wf1o cA cr wcel c2 cpi cmul co cr wcel cA
        c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire remulcli cA c2 cpi cmul
        co readdcl mpan2 cA renegcl cA cr wcel cA c2 cpi cmul co caddc co cr
        wcel cA cneg cr wcel w3a cA cA c2 cpi cmul co caddc co cico co cA cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS
        wf1o cD cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co
        cico co cS wf1o vx vy cA cA c2 cpi cmul co caddc co cA cneg cS
        shftefif1o.5 icoshftf1o cD cA cA c2 cpi cmul co caddc co cico co wceq
        cD cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico
        co cS wf1o cA cA c2 cpi cmul co caddc co cico co cA cA cneg caddc co cA
        c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o wb
        shftefif1o.1 cD cA cA c2 cpi cmul co caddc co cico co cA cA cneg caddc
        co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS f1oeq2 ax-mp
        sylibr mpd3an23 cA cr wcel cA cA cneg caddc co cA c2 cpi cmul co caddc
        co cA cneg caddc co cico co cc0 c2 cpi cmul co cico co wceq cD cA cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS
        wf1o cD cc0 c2 cpi cmul co cico co cS wf1o wb cA cr wcel cA cA cneg
        caddc co cc0 cA c2 cpi cmul co caddc co cA cneg caddc co c2 cpi cmul co
        cico cA cr wcel cA cc wcel cA cA cneg caddc co cc0 wceq cA recn cA
        negid syl cA cr wcel cA c2 cpi cmul co caddc co cA cneg caddc co cA c2
        cpi cmul co caddc co cA cmin co c2 cpi cmul co cA c2 cpi cmul co caddc
        co cc wcel cA cc wcel cA c2 cpi cmul co caddc co cA cneg caddc co cA c2
        cpi cmul co caddc co cA cmin co wceq cA cr wcel cA c2 cpi cmul co caddc
        co cA negsub cA cr wcel cA c2 cpi cmul co caddc co cA cr wcel c2 cpi
        cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire
        remulcli cA c2 cpi cmul co readdcl mpan2 recnd cA recn sylanc cA cr
        wcel cA cc wcel cA c2 cpi cmul co caddc co cA cmin co c2 cpi cmul co
        wceq cA recn cA cc wcel c2 cpi cmul co cc wcel cA c2 cpi cmul co caddc
        co cA cmin co c2 cpi cmul co wceq c2 cpi cmul co c2 cpi 2re pire
        remulcli recni cA c2 cpi cmul co pncan2 mpan2 syl eqtrd opreq12d cA cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cc0
        c2 cpi cmul co cico co cD cS f1oeq3 syl mpbid cc0 c2 cpi cmul co cico
        co cC cF wf1o cD cc0 c2 cpi cmul co cico co cS wf1o cD cC cF cS ccom
        wf1o vx vy vw cC cF shftefif1o.4 shftefif1o.3 efif1o cD cc0 c2 cpi cmul
        co cico co cC cF cS f1oco mpan syl cD cC cF cS ccom f1of syl jca sylan
        vz cv cH ci cA cmul co ce cfv cL cfv cF cS ccom ccom shftefif1o.8
        fveq1i syl5eq cA cr wcel vz cv cD wcel wa vz cv cF cS ccom cfv vz cv cS
        cfv cF cfv ci cA cmul co ce cfv cL cfv cD cc0 c2 cpi cmul co cico co cS
        wf vz cv cD wcel vz cv cF cS ccom cfv vz cv cS cfv cF cfv wceq cA cr
        wcel cF wfun cD cc0 c2 cpi cmul co cico co cS wf vz cv cD wcel vz cv cF
        cS ccom cfv vz cv cS cfv cF cfv wceq cc0 c2 cpi cmul co cico co cC cF
        wf1o cF wfun vx vy vw cC cF shftefif1o.4 shftefif1o.3 efif1o cc0 c2 cpi
        cmul co cico co cC cF f1ofun ax-mp cD cc0 c2 cpi cmul co cico co vz cv
        cF cS fvco3 mp3an1 cA cr wcel cD cc0 c2 cpi cmul co cico co cS wf1o cD
        cc0 c2 cpi cmul co cico co cS wf cA cr wcel cD cA cA cneg caddc co cA
        c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o cD cc0 c2 cpi
        cmul co cico co cS wf1o cA cr wcel cA c2 cpi cmul co caddc co cr wcel
        cA cneg cr wcel cD cA cA cneg caddc co cA c2 cpi cmul co caddc co cA
        cneg caddc co cico co cS wf1o cA cr wcel c2 cpi cmul co cr wcel cA c2
        cpi cmul co caddc co cr wcel c2 cpi 2re pire remulcli cA c2 cpi cmul co
        readdcl mpan2 cA renegcl cA cr wcel cA c2 cpi cmul co caddc co cr wcel
        cA cneg cr wcel w3a cA cA c2 cpi cmul co caddc co cico co cA cA cneg
        caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o cD
        cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co
        cS wf1o vx vy cA cA c2 cpi cmul co caddc co cA cneg cS shftefif1o.5
        icoshftf1o cD cA cA c2 cpi cmul co caddc co cico co wceq cD cA cA cneg
        caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o cA
        cA c2 cpi cmul co caddc co cico co cA cA cneg caddc co cA c2 cpi cmul
        co caddc co cA cneg caddc co cico co cS wf1o wb shftefif1o.1 cD cA cA
        c2 cpi cmul co caddc co cico co cA cA cneg caddc co cA c2 cpi cmul co
        caddc co cA cneg caddc co cico co cS f1oeq2 ax-mp sylibr mpd3an23 cA cr
        wcel cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co
        cico co cc0 c2 cpi cmul co cico co wceq cD cA cA cneg caddc co cA c2
        cpi cmul co caddc co cA cneg caddc co cico co cS wf1o cD cc0 c2 cpi
        cmul co cico co cS wf1o wb cA cr wcel cA cA cneg caddc co cc0 cA c2 cpi
        cmul co caddc co cA cneg caddc co c2 cpi cmul co cico cA cr wcel cA cc
        wcel cA cA cneg caddc co cc0 wceq cA recn cA negid syl cA cr wcel cA c2
        cpi cmul co caddc co cA cneg caddc co cA c2 cpi cmul co caddc co cA
        cmin co c2 cpi cmul co cA c2 cpi cmul co caddc co cc wcel cA cc wcel cA
        c2 cpi cmul co caddc co cA cneg caddc co cA c2 cpi cmul co caddc co cA
        cmin co wceq cA cr wcel cA c2 cpi cmul co caddc co cA negsub cA cr wcel
        cA c2 cpi cmul co caddc co cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi
        cmul co caddc co cr wcel c2 cpi 2re pire remulcli cA c2 cpi cmul co
        readdcl mpan2 recnd cA recn sylanc cA cr wcel cA cc wcel cA c2 cpi cmul
        co caddc co cA cmin co c2 cpi cmul co wceq cA recn cA cc wcel c2 cpi
        cmul co cc wcel cA c2 cpi cmul co caddc co cA cmin co c2 cpi cmul co
        wceq c2 cpi cmul co c2 cpi 2re pire remulcli recni cA c2 cpi cmul co
        pncan2 mpan2 syl eqtrd opreq12d cA cA cneg caddc co cA c2 cpi cmul co
        caddc co cA cneg caddc co cico co cc0 c2 cpi cmul co cico co cD cS
        f1oeq3 syl mpbid cD cc0 c2 cpi cmul co cico co cS f1of syl sylan fveq2d
        eqtrd cA cr wcel vz cv cD wcel wa vz cv cS cfv cF cfv ci vz cv cA cmin
        co cmul co ce cfv ci cA cmul co ce cfv cL cfv cA cr wcel vz cv cD wcel
        wa vz cv cS cfv cF cfv vz cv cA cmin co cF cfv ci vz cv cA cmin co cmul
        co ce cfv cA cr wcel vz cv cD wcel wa vz cv cS cfv vz cv cA cmin co cF
        cA cr wcel vz cv cD wcel wa vz cv cS cfv vz cv cA cneg caddc co vz cv
        cA cmin co vz cv cD wcel vz cv cS cfv vz cv cA cneg caddc co wceq cA cr
        wcel vz cv cD wcel vz cv cA cA c2 cpi cmul co caddc co cico co wcel vz
        cv cS cfv vz cv cA cneg caddc co wceq cD cA cA c2 cpi cmul co caddc co
        cico co vz cv shftefif1o.1 eleq2i vx vy vz cv vx cv cA cneg caddc co vz
        cv cA cneg caddc co cA cA c2 cpi cmul co caddc co cico co cS vx cv vz
        cv cA cneg caddc opreq1 shftefif1o.5 vz cv cA cneg caddc oprex fvopab4
        sylbi adantl vz cv cc wcel cA cc wcel vz cv cA cneg caddc co vz cv cA
        cmin co wceq cA cr wcel vz cv cD wcel wa vz cv cA negsub cA cr wcel vz
        cv cD wcel wa vz cv cA cr wcel vz cv cD wcel wa vz cv cr wcel cA vz cv
        cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr cA cr wcel vz cv cD
        wcel vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co
        clt wbr w3a cA cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co wcel
        vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr
        w3a vz cv cD wcel cA cr wcel cA c2 cpi cmul co caddc co cr wcel vz cv
        cA cA c2 cpi cmul co caddc co cico co wcel vz cv cr wcel cA vz cv cle
        wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a wb cA cr wcel c2 cpi
        cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire
        remulcli cA c2 cpi cmul co readdcl mpan2 cA cA c2 cpi cmul co caddc co
        vz cv elico2 mpdan cD cA cA c2 cpi cmul co caddc co cico co vz cv
        shftefif1o.1 eleq2i syl5bb biimpa 3simp1d recnd cA cr wcel cA cc wcel
        vz cv cD wcel cA recn adantr sylanc eqtrd fveq2d cA cr wcel vz cv cD
        wcel wa vz cv cA cmin co cc0 c2 cpi cmul co cico co wcel vz cv cA cmin
        co cF cfv ci vz cv cA cmin co cmul co ce cfv wceq cA cr wcel vz cv cD
        wcel wa vz cv cA cneg caddc co cA cA cneg caddc co cA c2 cpi cmul co
        caddc co cA cneg caddc co cico co wcel vz cv cA cmin co cc0 c2 cpi cmul
        co cico co wcel cA cr wcel vz cv cD wcel vz cv cA cneg caddc co cA cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico co wcel
        cA cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co wcel vz cv cA
        cneg caddc co cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg
        caddc co cico co wcel vz cv cD wcel cA cr wcel cA c2 cpi cmul co caddc
        co cr wcel cA cneg cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co
        wcel vz cv cA cneg caddc co cA cA cneg caddc co cA c2 cpi cmul co caddc
        co cA cneg caddc co cico co wcel wi cA cr wcel c2 cpi cmul co cr wcel
        cA c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire remulcli cA c2 cpi
        cmul co readdcl mpan2 cA renegcl cA cA c2 cpi cmul co caddc co cA cneg
        vz cv icoshft mpd3an23 cD cA cA c2 cpi cmul co caddc co cico co vz cv
        shftefif1o.1 eleq2i syl5ib imp cA cr wcel vz cv cD wcel wa vz cv cA
        cneg caddc co vz cv cA cmin co cA cA cneg caddc co cA c2 cpi cmul co
        caddc co cA cneg caddc co cico co cc0 c2 cpi cmul co cico co vz cv cc
        wcel cA cc wcel vz cv cA cneg caddc co vz cv cA cmin co wceq cA cr wcel
        vz cv cD wcel wa vz cv cA negsub cA cr wcel vz cv cD wcel wa vz cv cA
        cr wcel vz cv cD wcel wa vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi
        cmul co caddc co clt wbr cA cr wcel vz cv cD wcel vz cv cr wcel cA vz
        cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a cA cr wcel vz
        cv cA cA c2 cpi cmul co caddc co cico co wcel vz cv cr wcel cA vz cv
        cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a vz cv cD wcel cA
        cr wcel cA c2 cpi cmul co caddc co cr wcel vz cv cA cA c2 cpi cmul co
        caddc co cico co wcel vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi
        cmul co caddc co clt wbr w3a wb cA cr wcel c2 cpi cmul co cr wcel cA c2
        cpi cmul co caddc co cr wcel c2 cpi 2re pire remulcli cA c2 cpi cmul co
        readdcl mpan2 cA cA c2 cpi cmul co caddc co vz cv elico2 mpdan cD cA cA
        c2 cpi cmul co caddc co cico co vz cv shftefif1o.1 eleq2i syl5bb biimpa
        3simp1d recnd cA cr wcel cA cc wcel vz cv cD wcel cA recn adantr sylanc
        cA cr wcel cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc
        co cico co cc0 c2 cpi cmul co cico co wceq vz cv cD wcel cA cr wcel cA
        cA cneg caddc co cc0 cA c2 cpi cmul co caddc co cA cneg caddc co c2 cpi
        cmul co cico cA cr wcel cA cc wcel cA cA cneg caddc co cc0 wceq cA recn
        cA negid syl cA cr wcel cA c2 cpi cmul co caddc co cA cneg caddc co cA
        c2 cpi cmul co caddc co cA cmin co c2 cpi cmul co cA c2 cpi cmul co
        caddc co cc wcel cA cc wcel cA c2 cpi cmul co caddc co cA cneg caddc co
        cA c2 cpi cmul co caddc co cA cmin co wceq cA cr wcel cA c2 cpi cmul co
        caddc co cA negsub cA cr wcel cA c2 cpi cmul co caddc co cA cr wcel c2
        cpi cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire
        remulcli cA c2 cpi cmul co readdcl mpan2 recnd cA recn sylanc cA cr
        wcel cA cc wcel cA c2 cpi cmul co caddc co cA cmin co c2 cpi cmul co
        wceq cA recn cA cc wcel c2 cpi cmul co cc wcel cA c2 cpi cmul co caddc
        co cA cmin co c2 cpi cmul co wceq c2 cpi cmul co c2 cpi 2re pire
        remulcli recni cA c2 cpi cmul co pncan2 mpan2 syl eqtrd opreq12d adantr
        eleq12d mpbid vx vy vz cv cA cmin co ci vx cv cmul co ce cfv ci vz cv
        cA cmin co cmul co ce cfv cc0 c2 cpi cmul co cico co cF vx cv vz cv cA
        cmin co wceq ci vx cv cmul co ci vz cv cA cmin co cmul co ce vx cv vz
        cv cA cmin co ci cmul opreq2 fveq2d shftefif1o.4 ci vz cv cA cmin co
        cmul co ce fvex fvopab4 syl eqtrd fveq2d ci cA cmul co ce cfv cC wcel
        ci vz cv cA cmin co cmul co ce cfv cC wcel ci vz cv cA cmin co cmul co
        ce cfv ci cA cmul co ce cfv cL cfv cfv ci cA cmul co ce cfv ci vz cv cA
        cmin co cmul co ce cfv cmul co wceq cA cr wcel vz cv cD wcel wa ci cA
        cmul co ce cfv cC wcel ci vz cv cA cmin co cmul co ce cfv cC wcel wa ci
        vz cv cA cmin co cmul co ce cfv ci cA cmul co ce cfv cL cfv cfv ci cA
        cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cT co ci cA cmul co
        ce cfv ci vz cv cA cmin co cmul co ce cfv cmul co cT cgr wcel ci cA
        cmul co ce cfv cC wcel ci vz cv cA cmin co cmul co ce cfv cC wcel ci vz
        cv cA cmin co cmul co ce cfv ci cA cmul co ce cfv cL cfv cfv ci cA cmul
        co ce cfv ci vz cv cA cmin co cmul co ce cfv cT co wceq cT cabl wcel cT
        cgr wcel vw cC cT shftefif1o.3 shftefif1o.6 circgrp cT ablgrp ax-mp ci
        cA cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv vu vv cL cT cC vx
        vy shftefif1o.7 cmul cdm cc cc cxp wceq cT cgr wcel cC cc wss cC cT crn
        wceq cc cc cxp cc cmul axmulopr fdmi cT cabl wcel cT cgr wcel vw cC cT
        shftefif1o.3 shftefif1o.6 circgrp cT ablgrp ax-mp cC vw cv cabs cfv c1
        wceq vw cc crab cc shftefif1o.3 vw cv cabs cfv c1 wceq vw cc ssrab2
        eqsstri cmul cT cc cC shftefif1o.6 resgrprn mp3an grplactval mp3an1 ci
        cA cmul co ce cfv cC wcel ci vz cv cA cmin co cmul co ce cfv cC wcel wa
        ci cA cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cmul cC cC cxp
        cres co ci cA cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cmul co
        ci cA cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cT co ci cA
        cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cC cC cmul oprvres cT
        cmul cC cC cxp cres ci cA cmul co ce cfv ci vz cv cA cmin co cmul co ce
        cfv shftefif1o.6 opreqi syl5eq eqtrd cA cr wcel ci cA cmul co ce cfv cC
        wcel vz cv cD wcel vw cA cC shftefif1o.3 efielcirc adantr cA cr wcel vz
        cv cD wcel wa vz cv cA cmin co cr wcel ci vz cv cA cmin co cmul co ce
        cfv cC wcel vz cv cr wcel cA cr wcel vz cv cA cmin co cr wcel cA cr
        wcel vz cv cD wcel wa vz cv cA resubcl cA cr wcel vz cv cD wcel wa vz
        cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr cA
        cr wcel vz cv cD wcel vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi
        cmul co caddc co clt wbr w3a cA cr wcel vz cv cA cA c2 cpi cmul co
        caddc co cico co wcel vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi
        cmul co caddc co clt wbr w3a vz cv cD wcel cA cr wcel cA c2 cpi cmul co
        caddc co cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co wcel vz cv
        cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a
        wb cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel
        c2 cpi 2re pire remulcli cA c2 cpi cmul co readdcl mpan2 cA cA c2 cpi
        cmul co caddc co vz cv elico2 mpdan cD cA cA c2 cpi cmul co caddc co
        cico co vz cv shftefif1o.1 eleq2i syl5bb biimpa 3simp1d cA cr wcel vz
        cv cD wcel pm3.26 sylanc vw vz cv cA cmin co cC shftefif1o.3 efielcirc
        syl sylanc 3eqtrd ci cA cmul co cc wcel ci vz cv cA cmin co cmul co cc
        wcel ci cA cmul co ci vz cv cA cmin co cmul co caddc co ce cfv ci cA
        cmul co ce cfv ci vz cv cA cmin co cmul co ce cfv cmul co wceq cA cr
        wcel vz cv cD wcel wa ci cA cmul co ci vz cv cA cmin co cmul co efadd
        cA cr wcel ci cA cmul co cc wcel vz cv cD wcel cA cr wcel cA cc wcel ci
        cA cmul co cc wcel cA recn ci cc wcel cA cc wcel ci cA cmul co cc wcel
        axicn ci cA mulcl mpan syl adantr cA cr wcel vz cv cD wcel wa vz cv cA
        cmin co cc wcel ci vz cv cA cmin co cmul co cc wcel cA cr wcel vz cv cD
        wcel wa vz cv cA cmin co vz cv cr wcel cA cr wcel vz cv cA cmin co cr
        wcel cA cr wcel vz cv cD wcel wa vz cv cA resubcl cA cr wcel vz cv cD
        wcel wa vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co
        clt wbr cA cr wcel vz cv cD wcel vz cv cr wcel cA vz cv cle wbr vz cv
        cA c2 cpi cmul co caddc co clt wbr w3a cA cr wcel vz cv cA cA c2 cpi
        cmul co caddc co cico co wcel vz cv cr wcel cA vz cv cle wbr vz cv cA
        c2 cpi cmul co caddc co clt wbr w3a vz cv cD wcel cA cr wcel cA c2 cpi
        cmul co caddc co cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co
        wcel vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co
        clt wbr w3a wb cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi cmul co
        caddc co cr wcel c2 cpi 2re pire remulcli cA c2 cpi cmul co readdcl
        mpan2 cA cA c2 cpi cmul co caddc co vz cv elico2 mpdan cD cA cA c2 cpi
        cmul co caddc co cico co vz cv shftefif1o.1 eleq2i syl5bb biimpa
        3simp1d cA cr wcel vz cv cD wcel pm3.26 sylanc recnd ci cc wcel vz cv
        cA cmin co cc wcel ci vz cv cA cmin co cmul co cc wcel axicn ci vz cv
        cA cmin co mulcl mpan syl sylanc cA cr wcel vz cv cD wcel wa ci cA cmul
        co ci vz cv cA cmin co cmul co caddc co ci vz cv cmul co ce cA cr wcel
        vz cv cD wcel wa ci cA vz cv cA cmin co caddc co cmul co ci cA cmul co
        ci vz cv cA cmin co cmul co caddc co ci vz cv cmul co cA cc wcel vz cv
        cA cmin co cc wcel ci cA vz cv cA cmin co caddc co cmul co ci cA cmul
        co ci vz cv cA cmin co cmul co caddc co wceq cA cr wcel vz cv cD wcel
        wa ci cc wcel cA cc wcel vz cv cA cmin co cc wcel ci cA vz cv cA cmin
        co caddc co cmul co ci cA cmul co ci vz cv cA cmin co cmul co caddc co
        wceq axicn ci cA vz cv cA cmin co adddi mp3an1 cA cr wcel cA cc wcel vz
        cv cD wcel cA recn adantr cA cr wcel vz cv cD wcel wa vz cv cA cmin co
        vz cv cr wcel cA cr wcel vz cv cA cmin co cr wcel cA cr wcel vz cv cD
        wcel wa vz cv cA resubcl cA cr wcel vz cv cD wcel wa vz cv cr wcel cA
        vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr cA cr wcel vz cv
        cD wcel vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co
        clt wbr w3a cA cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co wcel
        vz cv cr wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr
        w3a vz cv cD wcel cA cr wcel cA c2 cpi cmul co caddc co cr wcel vz cv
        cA cA c2 cpi cmul co caddc co cico co wcel vz cv cr wcel cA vz cv cle
        wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a wb cA cr wcel c2 cpi
        cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire
        remulcli cA c2 cpi cmul co readdcl mpan2 cA cA c2 cpi cmul co caddc co
        vz cv elico2 mpdan cD cA cA c2 cpi cmul co caddc co cico co vz cv
        shftefif1o.1 eleq2i syl5bb biimpa 3simp1d cA cr wcel vz cv cD wcel
        pm3.26 sylanc recnd sylanc cA cr wcel vz cv cD wcel wa cA vz cv cA cmin
        co caddc co vz cv ci cmul cA cc wcel vz cv cc wcel cA vz cv cA cmin co
        caddc co vz cv wceq cA cr wcel vz cv cD wcel wa cA vz cv pncan3 cA cr
        wcel cA cc wcel vz cv cD wcel cA recn adantr cA cr wcel vz cv cD wcel
        wa vz cv cA cr wcel vz cv cD wcel wa vz cv cr wcel cA vz cv cle wbr vz
        cv cA c2 cpi cmul co caddc co clt wbr cA cr wcel vz cv cD wcel vz cv cr
        wcel cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a cA
        cr wcel vz cv cA cA c2 cpi cmul co caddc co cico co wcel vz cv cr wcel
        cA vz cv cle wbr vz cv cA c2 cpi cmul co caddc co clt wbr w3a vz cv cD
        wcel cA cr wcel cA c2 cpi cmul co caddc co cr wcel vz cv cA cA c2 cpi
        cmul co caddc co cico co wcel vz cv cr wcel cA vz cv cle wbr vz cv cA
        c2 cpi cmul co caddc co clt wbr w3a wb cA cr wcel c2 cpi cmul co cr
        wcel cA c2 cpi cmul co caddc co cr wcel c2 cpi 2re pire remulcli cA c2
        cpi cmul co readdcl mpan2 cA cA c2 cpi cmul co caddc co vz cv elico2
        mpdan cD cA cA c2 cpi cmul co caddc co cico co vz cv shftefif1o.1
        eleq2i syl5bb biimpa 3simp1d recnd sylanc opreq2d eqtr3d fveq2d 3eqtr2d
        eqtr4d r19.21aiva cA cr wcel cG cH wceq vz cv cG cfv vz cv cH cfv wceq
        vz cD wral cA cr wcel cH cD wfn cG cH wceq vz cv cG cfv vz cv cH cfv
        wceq vz cD wral wb cA cr wcel cD cC cH wf1o cH cD wfn cC cC ci cA cmul
        co ce cfv cL cfv wf1o cD cC cF cS ccom wf1o cD cC cH wf1o cA cr wcel cC
        cC ci cA cmul co ce cfv cL cfv wf1o cD cC cF cS ccom wf1o wa cD cC ci
        cA cmul co ce cfv cL cfv cF cS ccom ccom wf1o cD cC cH wf1o cD cC cC ci
        cA cmul co ce cfv cL cfv cF cS ccom f1oco cH ci cA cmul co ce cfv cL
        cfv cF cS ccom ccom wceq cD cC cH wf1o cD cC ci cA cmul co ce cfv cL
        cfv cF cS ccom ccom wf1o wb shftefif1o.8 cD cC cH ci cA cmul co ce cfv
        cL cfv cF cS ccom ccom f1oeq1 ax-mp sylibr cA cr wcel ci cA cmul co ce
        cfv cC wcel cC cC ci cA cmul co ce cfv cL cfv wf1o vw cA cC
        shftefif1o.3 efielcirc cT cgr wcel ci cA cmul co ce cfv cC wcel cC cC
        ci cA cmul co ce cfv cL cfv wf1o cT cabl wcel cT cgr wcel vw cC cT
        shftefif1o.3 shftefif1o.6 circgrp cT ablgrp ax-mp ci cA cmul co ce cfv
        vu vv cL cT cC vx vy shftefif1o.7 cmul cdm cc cc cxp wceq cT cgr wcel
        cC cc wss cC cT crn wceq cc cc cxp cc cmul axmulopr fdmi cT cabl wcel
        cT cgr wcel vw cC cT shftefif1o.3 shftefif1o.6 circgrp cT ablgrp ax-mp
        cC vw cv cabs cfv c1 wceq vw cc crab cc shftefif1o.3 vw cv cabs cfv c1
        wceq vw cc ssrab2 eqsstri cmul cT cc cC shftefif1o.6 resgrprn mp3an
        grplactf1o mpan syl cA cr wcel cD cc0 c2 cpi cmul co cico co cS wf1o cD
        cC cF cS ccom wf1o cA cr wcel cD cA cA cneg caddc co cA c2 cpi cmul co
        caddc co cA cneg caddc co cico co cS wf1o cD cc0 c2 cpi cmul co cico co
        cS wf1o cA cr wcel cA c2 cpi cmul co caddc co cr wcel cA cneg cr wcel
        cD cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc co cico
        co cS wf1o cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi cmul co caddc co
        cr wcel c2 cpi 2re pire remulcli cA c2 cpi cmul co readdcl mpan2 cA
        renegcl cA cr wcel cA c2 cpi cmul co caddc co cr wcel cA cneg cr wcel
        w3a cA cA c2 cpi cmul co caddc co cico co cA cA cneg caddc co cA c2 cpi
        cmul co caddc co cA cneg caddc co cico co cS wf1o cD cA cA cneg caddc
        co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cS wf1o vx vy cA
        cA c2 cpi cmul co caddc co cA cneg cS shftefif1o.5 icoshftf1o cD cA cA
        c2 cpi cmul co caddc co cico co wceq cD cA cA cneg caddc co cA c2 cpi
        cmul co caddc co cA cneg caddc co cico co cS wf1o cA cA c2 cpi cmul co
        caddc co cico co cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg
        caddc co cico co cS wf1o wb shftefif1o.1 cD cA cA c2 cpi cmul co caddc
        co cico co cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc
        co cico co cS f1oeq2 ax-mp sylibr mpd3an23 cA cr wcel cA cA cneg caddc
        co cA c2 cpi cmul co caddc co cA cneg caddc co cico co cc0 c2 cpi cmul
        co cico co wceq cD cA cA cneg caddc co cA c2 cpi cmul co caddc co cA
        cneg caddc co cico co cS wf1o cD cc0 c2 cpi cmul co cico co cS wf1o wb
        cA cr wcel cA cA cneg caddc co cc0 cA c2 cpi cmul co caddc co cA cneg
        caddc co c2 cpi cmul co cico cA cr wcel cA cc wcel cA cA cneg caddc co
        cc0 wceq cA recn cA negid syl cA cr wcel cA c2 cpi cmul co caddc co cA
        cneg caddc co cA c2 cpi cmul co caddc co cA cmin co c2 cpi cmul co cA
        c2 cpi cmul co caddc co cc wcel cA cc wcel cA c2 cpi cmul co caddc co
        cA cneg caddc co cA c2 cpi cmul co caddc co cA cmin co wceq cA cr wcel
        cA c2 cpi cmul co caddc co cA negsub cA cr wcel cA c2 cpi cmul co caddc
        co cA cr wcel c2 cpi cmul co cr wcel cA c2 cpi cmul co caddc co cr wcel
        c2 cpi 2re pire remulcli cA c2 cpi cmul co readdcl mpan2 recnd cA recn
        sylanc cA cr wcel cA cc wcel cA c2 cpi cmul co caddc co cA cmin co c2
        cpi cmul co wceq cA recn cA cc wcel c2 cpi cmul co cc wcel cA c2 cpi
        cmul co caddc co cA cmin co c2 cpi cmul co wceq c2 cpi cmul co c2 cpi
        2re pire remulcli recni cA c2 cpi cmul co pncan2 mpan2 syl eqtrd
        opreq12d cA cA cneg caddc co cA c2 cpi cmul co caddc co cA cneg caddc
        co cico co cc0 c2 cpi cmul co cico co cD cS f1oeq3 syl mpbid cc0 c2 cpi
        cmul co cico co cC cF wf1o cD cc0 c2 cpi cmul co cico co cS wf1o cD cC
        cF cS ccom wf1o vx vy vw cC cF shftefif1o.4 shftefif1o.3 efif1o cD cc0
        c2 cpi cmul co cico co cC cF cS f1oco mpan syl sylanc cD cC cH f1ofn
        syl cG cD wfn cH cD wfn cG cH wceq vz cv cG cfv vz cv cH cfv wceq vz cD
        wral wb vx vy cD ci vx cv cmul co ce cfv cG ci vx cv cmul co ce fvex
        shftefif1o.2 fnopab2 vz cD cG cH eqfnfv2 mpan syl biimprd mpd cD cC cG
        cH f1oeq1 syl mpbird $.
        $( [26-Apr-2008] $) $( [25-Mar-2008] $)
    $}

    $( The exponential function of ` _i ` times a real number maps any
       closed-below, open-above real interval of length ` 2 x. pi ` one-to-one
       onto the unit circle.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
    shftefif1o $p  |- ( A e. RR -> G : D -1-1-onto-> C ) $=
      vx vy vw vz vv cA cC cD vx cv cA cA c2 cpi cmul co caddc co cico co wcel
      vy cv vx cv cA cneg caddc co wceq wa vx vy copab cmul cC cC cxp cres vx
      cv cc0 c2 cpi cmul co cico co wcel vy cv ci vx cv cmul co ce cfv wceq wa
      vx vy copab cG ci cA cmul co ce cfv vv cv cC wcel vz cv vx cv cC wcel vy
      cv vv cv vx cv cmul cC cC cxp cres co wceq wa vx vy copab wceq wa vv vz
      copab cfv vx cv cc0 c2 cpi cmul co cico co wcel vy cv ci vx cv cmul co ce
      cfv wceq wa vx vy copab vx cv cA cA c2 cpi cmul co caddc co cico co wcel
      vy cv vx cv cA cneg caddc co wceq wa vx vy copab ccom ccom vv cv cC wcel
      vz cv vx cv cC wcel vy cv vv cv vx cv cmul cC cC cxp cres co wceq wa vx
      vy copab wceq wa vv vz copab shftefif1o.1 shftefif1o.2 shftefif1o.3 vx cv
      cc0 c2 cpi cmul co cico co wcel vy cv ci vx cv cmul co ce cfv wceq wa vx
      vy copab eqid vx cv cA cA c2 cpi cmul co caddc co cico co wcel vy cv vx
      cv cA cneg caddc co wceq wa vx vy copab eqid cmul cC cC cxp cres eqid vv
      cv cC wcel vz cv vx cv cC wcel vy cv vv cv vx cv cmul cC cC cxp cres co
      wceq wa vx vy copab wceq wa vv vz copab eqid ci cA cmul co ce cfv vv cv
      cC wcel vz cv vx cv cC wcel vy cv vv cv vx cv cmul cC cC cxp cres co wceq
      wa vx vy copab wceq wa vv vz copab cfv vx cv cc0 c2 cpi cmul co cico co
      wcel vy cv ci vx cv cmul co ce cfv wceq wa vx vy copab vx cv cA cA c2 cpi
      cmul co caddc co cico co wcel vy cv vx cv cA cneg caddc co wceq wa vx vy
      copab ccom ccom eqid shftefif1olem $.
      $( [27-Mar-2008] $) $( [25-Mar-2008] $)
  $}

  $( Lemma for ~ eff1i . $)
  eff1lem $p |- ( A e. CC -> ( exp ` A ) =
      ( ( abs ` ( exp ` A ) ) x. ( exp ` ( _i x. ( Im ` A ) ) ) ) ) $=
    cA cc wcel cA cre cfv ci cA cim cfv cmul co caddc co ce cfv cA cre cfv ce
    cfv ci cA cim cfv cmul co ce cfv cmul co cA ce cfv cA ce cfv cabs cfv ci cA
    cim cfv cmul co ce cfv cmul co cA cre cfv cc wcel ci cA cim cfv cmul co cc
    wcel cA cre cfv ci cA cim cfv cmul co caddc co ce cfv cA cre cfv ce cfv ci
    cA cim cfv cmul co ce cfv cmul co wceq cA cc wcel cA cre cfv ci cA cim cfv
    cmul co efadd cA cc wcel cA cre cfv cA recl recnd cA cc wcel cA cim cfv cc
    wcel ci cA cim cfv cmul co cc wcel cA cc wcel cA cim cfv cA imcl recnd ci
    cc wcel cA cim cfv cc wcel ci cA cim cfv cmul co cc wcel axicn ci cA cim
    cfv mulcl mpan syl sylanc cA cc wcel cA cA cre cfv ci cA cim cfv cmul co
    caddc co ce cA replim fveq2d cA cc wcel cA ce cfv cabs cfv cA cre cfv ce
    cfv ci cA cim cfv cmul co ce cfv cmul cA absef opreq1d 3eqtr4d $.
    $( [16-Apr-2008] $) $( [16-Apr-2008] $)

  ${
    $d A v w z $.  $d D v w z $.

    eff1i.1 $e |- A e. RR $.
    eff1i.2 $e |- D = ( A [,) ( A + ( 2 x. pi ) ) ) $.
    eff1i.3 $e |- S = { v e. CC | ( Im ` v ) e. D } $.

    ${
      $d A a b $.  $d C a b w z $.  $d D a b $.  $d F a b v x $.  $d S x y $.
      $d a b v w x y z $.

      eff1i.4 $e |- F = { <. z , w >. | ( z e. D /\
                                          w = ( exp ` ( _i x. z ) ) ) } $.
      eff1i.5 $e |- C = { v e. CC | ( abs ` v ) = 1 } $.

      $( The exponential function maps the set ` S ` , of complex numbers with
         imaginary part in a closed-below, open-above real interval of length
         ` 2 x. pi ` starting at ` A ` , one-to-one to the nonzero complex
         numbers.  (Contributed by Paul Chapman, 16-Apr-2008.) $)
      eff1i $p |- ( exp |` S ) : S -1-1-> ( CC \ { 0 } ) $=
        cS cc cc0 csn cdif ce cS cres wf1 cS cc cc0 csn cdif ce cS cres wf vx
        cv ce cS cres cfv vy cv ce cS cres cfv wceq vx cv vy cv wceq wi vy cS
        wral vx cS wral vx vy cS cc cc0 csn cdif ce cS cres dff13 cc cc cc0 csn
        cdif ce wf cS cc wss cS cc cc0 csn cdif ce cS cres wf eff2 vx cS cc vx
        cv cS wcel vx cv cc wcel vx cv cim cfv cD wcel vv cv cim cfv cD wcel vx
        cv cim cfv cD wcel vv vx cv cc cS vv cv vx cv wceq vv cv cim cfv vx cv
        cim cfv cD vv cv vx cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi ssriv
        cc cc cc0 csn cdif cS ce fssres mp2an vx cv ce cS cres cfv vy cv ce cS
        cres cfv wceq vx cv vy cv wceq wi vx vy cS vx cv cS wcel vy cv cS wcel
        wa vx cv ce cS cres cfv vy cv ce cS cres cfv wceq vx cv ce cfv vy cv ce
        cfv wceq vx cv vy cv wceq vx cv cS wcel vy cv cS wcel vx cv ce cS cres
        cfv vx cv ce cfv vy cv ce cS cres cfv vy cv ce cfv vx cv cS ce fvres vy
        cv cS ce fvres eqeqan12d vx cv cS wcel vy cv cS wcel wa vx cv ce cfv vy
        cv ce cfv wceq vx cv vy cv wceq vx cv cS wcel vy cv cS wcel wa vx cv ce
        cfv vy cv ce cfv wceq wa vx cv cre cfv vy cv cre cfv wceq vx cv cim cfv
        vy cv cim cfv wceq vx cv vy cv wceq vx cv cS wcel vy cv cS wcel wa vx
        cv ce cfv vy cv ce cfv wceq vx cv cre cfv vy cv cre cfv wceq vx cv cc
        wcel vy cv cc wcel vx cv ce cfv vy cv ce cfv wceq vx cv cre cfv vy cv
        cre cfv wceq wi vx cv cS wcel vy cv cS wcel vx cv cc wcel vy cv cc wcel
        wa vx cv ce cfv cabs cfv vy cv ce cfv cabs cfv wceq vx cv cre cfv vy cv
        cre cfv wceq vx cv ce cfv vy cv ce cfv wceq vx cv cc wcel vy cv cc wcel
        wa vx cv ce cfv cabs cfv vy cv ce cfv cabs cfv wceq vx cv cre cfv ce
        cfv vy cv cre cfv ce cfv wceq vx cv cre cfv vy cv cre cfv wceq vx cv cc
        wcel vy cv cc wcel vx cv ce cfv cabs cfv vx cv cre cfv ce cfv vy cv ce
        cfv cabs cfv vy cv cre cfv ce cfv vx cv absef vy cv absef eqeqan12d vx
        cv cre cfv cr wcel vy cv cre cfv cr wcel vx cv cre cfv ce cfv vy cv cre
        cfv ce cfv wceq vx cv cre cfv vy cv cre cfv wceq wb vx cv cc wcel vy cv
        cc wcel vx cv cre cfv vy cv cre cfv reef11 vx cv recl vy cv recl syl2an
        bitrd vx cv ce cfv vy cv ce cfv cabs fveq2 syl5bi vx cv cS wcel vx cv
        cc wcel vx cv cim cfv cD wcel vv cv cim cfv cD wcel vx cv cim cfv cD
        wcel vv vx cv cc cS vv cv vx cv wceq vv cv cim cfv vx cv cim cfv cD vv
        cv vx cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi vy cv cS wcel vy cv
        cc wcel vy cv cim cfv cD wcel vv cv cim cfv cD wcel vy cv cim cfv cD
        wcel vv vy cv cc cS vv cv vy cv wceq vv cv cim cfv vy cv cim cfv cD vv
        cv vy cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi syl2an imp vx cv cS
        wcel vy cv cS wcel wa vx cv ce cfv vy cv ce cfv wceq vx cv cim cfv vy
        cv cim cfv wceq vx cv cS wcel vy cv cS wcel wa vx cv ce cfv vy cv ce
        cfv wceq ci vx cv cim cfv cmul co ce cfv ci vy cv cim cfv cmul co ce
        cfv wceq vx cv cim cfv vy cv cim cfv wceq vx cv cc wcel vy cv cc wcel
        vx cv ce cfv vy cv ce cfv wceq ci vx cv cim cfv cmul co ce cfv ci vy cv
        cim cfv cmul co ce cfv wceq wi vx cv cS wcel vy cv cS wcel vx cv cc
        wcel vy cv cc wcel wa vx cv ce cfv vy cv ce cfv wceq ci vx cv cim cfv
        cmul co ce cfv ci vy cv cim cfv cmul co ce cfv wceq vx cv cc wcel vy cv
        cc wcel wa vx cv ce cfv vy cv ce cfv wceq wa vx cv ce cfv cabs cfv ci
        vx cv cim cfv cmul co ce cfv cmul co vy cv ce cfv cabs cfv ci vy cv cim
        cfv cmul co ce cfv cmul co wceq ci vx cv cim cfv cmul co ce cfv ci vy
        cv cim cfv cmul co ce cfv wceq vx cv cc wcel vy cv cc wcel wa vx cv ce
        cfv vy cv ce cfv wceq vx cv ce cfv cabs cfv ci vx cv cim cfv cmul co ce
        cfv cmul co vy cv ce cfv cabs cfv ci vy cv cim cfv cmul co ce cfv cmul
        co wceq vx cv cc wcel vy cv cc wcel vx cv ce cfv vx cv ce cfv cabs cfv
        ci vx cv cim cfv cmul co ce cfv cmul co vy cv ce cfv vy cv ce cfv cabs
        cfv ci vy cv cim cfv cmul co ce cfv cmul co vx cv eff1lem vy cv eff1lem
        eqeqan12d biimpa vx cv cc wcel vy cv cc wcel wa vx cv ce cfv vy cv ce
        cfv wceq wa vx cv ce cfv cabs cfv ci vx cv cim cfv cmul co ce cfv cmul
        co vx cv ce cfv cabs cfv ci vy cv cim cfv cmul co ce cfv cmul co wceq
        vx cv ce cfv cabs cfv ci vx cv cim cfv cmul co ce cfv cmul co vy cv ce
        cfv cabs cfv ci vy cv cim cfv cmul co ce cfv cmul co wceq ci vx cv cim
        cfv cmul co ce cfv ci vy cv cim cfv cmul co ce cfv wceq vx cv cc wcel
        vy cv cc wcel wa vx cv ce cfv vy cv ce cfv wceq wa vx cv ce cfv cabs
        cfv ci vy cv cim cfv cmul co ce cfv cmul co vy cv ce cfv cabs cfv ci vy
        cv cim cfv cmul co ce cfv cmul co vx cv ce cfv cabs cfv ci vx cv cim
        cfv cmul co ce cfv cmul co vx cv ce cfv vy cv ce cfv wceq vx cv ce cfv
        cabs cfv ci vy cv cim cfv cmul co ce cfv cmul co vy cv ce cfv cabs cfv
        ci vy cv cim cfv cmul co ce cfv cmul co wceq vx cv cc wcel vy cv cc
        wcel wa vx cv ce cfv vy cv ce cfv wceq vx cv ce cfv cabs cfv vy cv ce
        cfv cabs cfv ci vy cv cim cfv cmul co ce cfv cmul vx cv ce cfv vy cv ce
        cfv cabs fveq2 opreq1d adantl eqeq2d vx cv cc wcel vy cv cc wcel wa vx
        cv ce cfv cabs cfv ci vx cv cim cfv cmul co ce cfv cmul co vx cv ce cfv
        cabs cfv ci vy cv cim cfv cmul co ce cfv cmul co wceq ci vx cv cim cfv
        cmul co ce cfv ci vy cv cim cfv cmul co ce cfv wceq wb vx cv ce cfv vy
        cv ce cfv wceq ci vx cv cim cfv cmul co ce cfv cc wcel ci vy cv cim cfv
        cmul co ce cfv cc wcel vx cv ce cfv cabs cfv cc wcel vx cv ce cfv cabs
        cfv cc0 wne wa vx cv ce cfv cabs cfv ci vx cv cim cfv cmul co ce cfv
        cmul co vx cv ce cfv cabs cfv ci vy cv cim cfv cmul co ce cfv cmul co
        wceq ci vx cv cim cfv cmul co ce cfv ci vy cv cim cfv cmul co ce cfv
        wceq wb vx cv cc wcel vy cv cc wcel wa ci vx cv cim cfv cmul co ce cfv
        ci vy cv cim cfv cmul co ce cfv vx cv ce cfv cabs cfv mulcan vx cv cc
        wcel ci vx cv cim cfv cmul co ce cfv cc wcel vy cv cc wcel vx cv cc
        wcel ci vx cv cim cfv cmul co cc wcel ci vx cv cim cfv cmul co ce cfv
        cc wcel vx cv cc wcel vx cv cim cfv cc wcel ci vx cv cim cfv cmul co cc
        wcel vx cv cc wcel vx cv cim cfv vx cv imcl recnd ci cc wcel vx cv cim
        cfv cc wcel ci vx cv cim cfv cmul co cc wcel axicn ci vx cv cim cfv
        mulcl mpan syl ci vx cv cim cfv cmul co efcl syl adantr vy cv cc wcel
        ci vy cv cim cfv cmul co ce cfv cc wcel vx cv cc wcel vy cv cc wcel ci
        vy cv cim cfv cmul co cc wcel ci vy cv cim cfv cmul co ce cfv cc wcel
        vy cv cc wcel vy cv cim cfv cc wcel ci vy cv cim cfv cmul co cc wcel vy
        cv cc wcel vy cv cim cfv vy cv imcl recnd ci cc wcel vy cv cim cfv cc
        wcel ci vy cv cim cfv cmul co cc wcel axicn ci vy cv cim cfv mulcl mpan
        syl ci vy cv cim cfv cmul co efcl syl adantl vx cv cc wcel vy cv cc
        wcel wa vx cv ce cfv cabs cfv cc wcel vx cv ce cfv cabs cfv cc0 wne vx
        cv cc wcel vx cv ce cfv cabs cfv cc wcel vy cv cc wcel vx cv cc wcel vx
        cv ce cfv cabs cfv vx cv cc wcel vx cv ce cfv cc wcel vx cv ce cfv cabs
        cfv cr wcel vx cv efcl vx cv ce cfv abscl syl recnd adantr vx cv cc
        wcel vx cv ce cfv cabs cfv cc0 wne vy cv cc wcel vx cv ce cfv cabs cfv
        cr wcel cc0 vx cv ce cfv cabs cfv clt wbr vx cv ce cfv cabs cfv cc0 wne
        vx cv cc wcel vx cv ce cfv cabs cfv gt0ne0 vx cv cc wcel vx cv ce cfv
        cc wcel vx cv ce cfv cabs cfv cr wcel vx cv efcl vx cv ce cfv abscl syl
        vx cv ce cfv cc wcel vx cv ce cfv cc0 wne cc0 vx cv ce cfv cabs cfv clt
        wbr vx cv cc wcel vx cv ce cfv cc wcel vx cv ce cfv cc0 wne cc0 vx cv
        ce cfv cabs cfv clt wbr vx cv ce cfv absgt0 biimpa vx cv efcl vx cv
        efne0 sylanc sylanc adantr jca syl3anc adantr bitr3d mpbid ex vx cv cS
        wcel vx cv cc wcel vx cv cim cfv cD wcel vv cv cim cfv cD wcel vx cv
        cim cfv cD wcel vv vx cv cc cS vv cv vx cv wceq vv cv cim cfv vx cv cim
        cfv cD vv cv vx cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi vy cv cS
        wcel vy cv cc wcel vy cv cim cfv cD wcel vv cv cim cfv cD wcel vy cv
        cim cfv cD wcel vv vy cv cc cS vv cv vy cv wceq vv cv cim cfv vy cv cim
        cfv cD vv cv vy cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi syl2an vx
        cv cim cfv cD wcel vy cv cim cfv cD wcel ci vx cv cim cfv cmul co ce
        cfv ci vy cv cim cfv cmul co ce cfv wceq vx cv cim cfv vy cv cim cfv
        wceq wb vx cv cS wcel vy cv cS wcel vx cv cim cfv cD wcel vy cv cim cfv
        cD wcel wa vx cv cim cfv cF cfv vy cv cim cfv cF cfv wceq ci vx cv cim
        cfv cmul co ce cfv ci vy cv cim cfv cmul co ce cfv wceq vx cv cim cfv
        vy cv cim cfv wceq vx cv cim cfv cD wcel vy cv cim cfv cD wcel vx cv
        cim cfv cF cfv ci vx cv cim cfv cmul co ce cfv vy cv cim cfv cF cfv ci
        vy cv cim cfv cmul co ce cfv vz vw vx cv cim cfv ci vz cv cmul co ce
        cfv ci vx cv cim cfv cmul co ce cfv cD cF vz cv vx cv cim cfv wceq ci
        vz cv cmul co ci vx cv cim cfv cmul co ce vz cv vx cv cim cfv ci cmul
        opreq2 fveq2d eff1i.4 ci vx cv cim cfv cmul co ce fvex fvopab4 vz vw vy
        cv cim cfv ci vz cv cmul co ce cfv ci vy cv cim cfv cmul co ce cfv cD
        cF vz cv vy cv cim cfv wceq ci vz cv cmul co ci vy cv cim cfv cmul co
        ce vz cv vy cv cim cfv ci cmul opreq2 fveq2d eff1i.4 ci vy cv cim cfv
        cmul co ce fvex fvopab4 eqeqan12d cD cC cF wf1 vx cv cim cfv cD wcel vy
        cv cim cfv cD wcel wa vx cv cim cfv cF cfv vy cv cim cfv cF cfv wceq vx
        cv cim cfv vy cv cim cfv wceq wb cD cC cF wf1o cD cC cF wf1 cA cr wcel
        cD cC cF wf1o eff1i.1 vz vw vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5
        shftefif1o ax-mp cD cC cF f1of1 ax-mp cD cC vx cv cim cfv vy cv cim cfv
        cF f1fveq mpan bitr3d vx cv cS wcel vx cv cc wcel vx cv cim cfv cD wcel
        vv cv cim cfv cD wcel vx cv cim cfv cD wcel vv vx cv cc cS vv cv vx cv
        wceq vv cv cim cfv vx cv cim cfv cD vv cv vx cv cim fveq2 eleq1d
        eff1i.3 elrab2 pm3.27bi vy cv cS wcel vy cv cc wcel vy cv cim cfv cD
        wcel vv cv cim cfv cD wcel vy cv cim cfv cD wcel vv vy cv cc cS vv cv
        vy cv wceq vv cv cim cfv vy cv cim cfv cD vv cv vy cv cim fveq2 eleq1d
        eff1i.3 elrab2 pm3.27bi syl2an sylibd imp vx cv cS wcel vy cv cS wcel
        wa vx cv cre cfv vy cv cre cfv wceq vx cv cim cfv vy cv cim cfv wceq wa
        vx cv vy cv wceq wi vx cv ce cfv vy cv ce cfv wceq vx cv cc wcel vy cv
        cc wcel vx cv cre cfv vy cv cre cfv wceq vx cv cim cfv vy cv cim cfv
        wceq wa vx cv vy cv wceq wi vx cv cS wcel vy cv cS wcel vx cv cc wcel
        vy cv cc wcel wa vx cv vy cv wceq vx cv cre cfv vy cv cre cfv wceq vx
        cv cim cfv vy cv cim cfv wceq wa vx cv cc wcel vy cv cc wcel wa vx cv
        vy cv wceq vx cv cre cfv ci vx cv cim cfv cmul co caddc co vy cv cre
        cfv ci vy cv cim cfv cmul co caddc co wceq vx cv cre cfv vy cv cre cfv
        wceq vx cv cim cfv vy cv cim cfv wceq wa vx cv cc wcel vy cv cc wcel vx
        cv vx cv cre cfv ci vx cv cim cfv cmul co caddc co vy cv vy cv cre cfv
        ci vy cv cim cfv cmul co caddc co vx cv replim vy cv replim eqeqan12d
        vx cv cre cfv cr wcel vx cv cim cfv cr wcel wa vy cv cre cfv cr wcel vy
        cv cim cfv cr wcel wa vx cv cre cfv ci vx cv cim cfv cmul co caddc co
        vy cv cre cfv ci vy cv cim cfv cmul co caddc co wceq vx cv cre cfv vy
        cv cre cfv wceq vx cv cim cfv vy cv cim cfv wceq wa wb vx cv cc wcel vy
        cv cc wcel vx cv cre cfv vx cv cim cfv vy cv cre cfv vy cv cim cfv cru
        vx cv cc wcel vx cv cre cfv cr wcel vx cv cim cfv cr wcel vx cv recl vx
        cv imcl jca vy cv cc wcel vy cv cre cfv cr wcel vy cv cim cfv cr wcel
        vy cv recl vy cv imcl jca syl2an bitrd biimprd vx cv cS wcel vx cv cc
        wcel vx cv cim cfv cD wcel vv cv cim cfv cD wcel vx cv cim cfv cD wcel
        vv vx cv cc cS vv cv vx cv wceq vv cv cim cfv vx cv cim cfv cD vv cv vx
        cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi vy cv cS wcel vy cv cc wcel
        vy cv cim cfv cD wcel vv cv cim cfv cD wcel vy cv cim cfv cD wcel vv vy
        cv cc cS vv cv vy cv wceq vv cv cim cfv vy cv cim cfv cD vv cv vy cv
        cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi syl2an adantr mp2and ex sylbid
        rgen2a mpbir2an $.
        $( [16-Apr-2008] $) $( [16-Apr-2008] $)

      $( The exponential function maps the set ` S ` , of complex numbers with
         imaginary part in a closed-below, open-above real interval of length
         ` 2 x. pi ` starting at ` A ` , onto the nonzero complex numbers.
         (Contributed by Paul Chapman, 16-Apr-2008.) $)
      effoi $p |- ( exp |` S ) : S -onto-> ( CC \ { 0 } ) $=
        cS cc cc0 csn cdif ce cS cres wfo cS cc cc0 csn cdif ce cS cres wf vy
        cv vx cv ce cS cres cfv wceq vx cS wrex vy cc cc0 csn cdif wral vx vy
        cS cc cc0 csn cdif ce cS cres dffo3 cc cc cc0 csn cdif ce wf cS cc wss
        cS cc cc0 csn cdif ce cS cres wf eff2 vx cS cc vx cv cS wcel vx cv cc
        wcel vx cv cim cfv cD wcel vv cv cim cfv cD wcel vx cv cim cfv cD wcel
        vv vx cv cc cS vv cv vx cv wceq vv cv cim cfv vx cv cim cfv cD vv cv vx
        cv cim fveq2 eleq1d eff1i.3 elrab2 pm3.26bi ssriv cc cc cc0 csn cdif cS
        ce fssres mp2an vy cv vx cv ce cS cres cfv wceq vx cS wrex vy cc cc0
        csn cdif vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cmul co caddc co cS wcel vy cv vy cv cabs cfv ce cr
        cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc
        co ce cS cres cfv wceq vy cv vx cv ce cS cres cfv wceq vx cS wrex vy cv
        cc cc0 csn cdif wcel vy cv vx cv ce cS cres cfv wceq vy cv vy cv cabs
        cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cmul co caddc co ce cS cres cfv wceq vx vy cv cabs cfv ce cr cres ccnv
        cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cS vx
        cv vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cmul co caddc co wceq vx cv ce cS cres cfv vy cv cabs cfv
        ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co
        caddc co ce cS cres cfv vy cv vx cv vy cv cabs cfv ce cr cres ccnv cfv
        ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co ce cS cres
        fveq2 eqeq2d rcla4ev vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cmul co caddc co cc wcel vy cv cabs cfv ce
        cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co
        caddc co cim cfv cD wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cS wcel vy cv cc cc0
        csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cmul co caddc co cS wcel vy cv cabs cfv ce cr
        cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc
        co cc wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cmul co caddc co cim cfv cD wcel wa vv cv cim cfv
        cD wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cmul co caddc co cim cfv cD wcel vv vy cv cabs cfv ce cr
        cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc
        co cc cS vv cv vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cmul co caddc co wceq vv cv cim cfv vy cv cabs
        cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cmul co caddc co cim cfv cD vv cv vy cv cabs cfv ce cr cres ccnv cfv ci
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cim fveq2
        eleq1d eff1i.3 elrab2 biimpri vy cv cabs cfv ce cr cres ccnv cfv cc
        wcel ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co cc wcel vy cv
        cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cmul co caddc co cc wcel vy cv cc cc0 csn cdif wcel vy cv cabs cfv
        ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co
        addcl vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv vy
        cv cc cc0 csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv ce cr
        cres ccnv cfv cr wcel vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr
        vy cv cabs cfv crp wcel vy cv cc cc0 csn cdif wcel vy cv cabs cfv crp
        wcel vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr wa vy cv cabs
        cfv elrp biimpri vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs
        cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn
        cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy
        cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt
        wbr vy cv absgt0 biimpa sylbi sylanc crp cr vy cv cabs cfv ce cr cres
        ccnv crp cr ce cr cres ccnv wf1o crp cr ce cr cres ccnv wf cr crp ce cr
        cres wf1o crp cr ce cr cres ccnv wf1o reeff1o2 cr crp ce cr cres f1ocnv
        ax-mp crp cr ce cr cres ccnv f1of ax-mp ffvelrni syl recnd vy cv cc cc0
        csn cdif wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cc wcel ci vy cv
        vy cv cabs cfv cdiv co cF ccnv cfv cmul co cc wcel vy cv cc cc0 csn
        cdif wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv vy cv cc cc0 csn
        cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr
        wcel vy cv vy cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co
        cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv co cC wcel vy cv cc cc0 csn
        cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv
        cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq wa vv cv
        cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vv vy cv
        vy cv cabs cfv cdiv co cc cC vv cv vy cv vy cv cabs cfv cdiv co wceq vv
        cv cabs cfv vy cv vy cv cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy cv
        cabs cfv cdiv co cabs fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc wcel
        vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv
        co cc wcel vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl vy cv
        cc cc0 csn eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv
        clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr
        wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel
        vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0
        eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv
        absgt0 biimpa sylbi sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv vy
        cv cabs cfv cdiv co cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv
        cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv
        cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co
        cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc
        cc0 csn cdif wcel vy cv vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs
        cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv
        cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv
        vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co
        wceq vy cv cc cc0 csn eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy
        cv cabs cfv vy cv cabs cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv
        cc wcel vy cv cabs cfv cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1
        wceq vy cv cc cc0 csn cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv
        cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv
        cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy
        cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc
        3eqtrd sylanc cC cD vy cv vy cv cabs cfv cdiv co cF ccnv cC cD cF ccnv
        wf1o cC cD cF ccnv wf cD cC cF wf1o cC cD cF ccnv wf1o cA cr wcel cD cC
        cF wf1o eff1i.1 vz vw vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o
        ax-mp cD cC cF f1ocnv ax-mp cC cD cF ccnv f1of ax-mp ffvelrni vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co caddc co clt
        wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co
        caddc co clt wbr w3a vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA cA c2 cpi cmul co caddc co
        cico co wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv
        vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr w3a cD cA cA c2 cpi cmul
        co caddc co cico co vy cv vy cv cabs cfv cdiv co cF ccnv cfv eff1i.2
        eleq2i cA cr wcel cA c2 cpi cmul co caddc co cr wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cA cA c2 cpi cmul co caddc co cico co wcel vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA
        c2 cpi cmul co caddc co clt wbr w3a wb eff1i.1 cA c2 cpi cmul co
        eff1i.1 c2 cpi 2re pire remulcli readdcli cA cA c2 cpi cmul co caddc co
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv elico2 mp2an bitri biimpi
        3simp1d 3syl recnd ci cc wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cc wcel ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co cc wcel
        axicn ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv mulcl mpan syl sylanc
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv
        vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cim cfv vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cD vy cv cabs cfv ce cr cres ccnv cfv cr
        wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel vy cv cabs cfv ce
        cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co
        caddc co cim cfv vy cv vy cv cabs cfv cdiv co cF ccnv cfv wceq vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv crim vy cv cc cc0 csn cdif wcel vy cv cabs cfv
        crp wcel vy cv cabs cfv ce cr cres ccnv cfv cr wcel vy cv cabs cfv cr
        wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv crp wcel vy cv cc cc0
        csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv cr wcel cc0 vy cv
        cabs cfv clt wbr wa vy cv cabs cfv elrp biimpri vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc crp cr vy
        cv cabs cfv ce cr cres ccnv crp cr ce cr cres ccnv wf1o crp cr ce cr
        cres ccnv wf cr crp ce cr cres wf1o crp cr ce cr cres ccnv wf1o
        reeff1o2 cr crp ce cr cres f1ocnv ax-mp crp cr ce cr cres ccnv f1of
        ax-mp ffvelrni syl vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv
        co cC wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cr wcel vy cv vy cv cabs cfv cdiv co cc
        wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vy cv vy cv cabs cfv
        cdiv co cC wcel vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co
        cC wcel vy cv vy cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv
        co cabs cfv c1 wceq wa vv cv cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv
        co cabs cfv c1 wceq vv vy cv vy cv cabs cfv cdiv co cc cC vv cv vy cv
        vy cv cabs cfv cdiv co wceq vv cv cabs cfv vy cv vy cv cabs cfv cdiv co
        cabs cfv c1 vv cv vy cv vy cv cabs cfv cdiv co cabs fveq2 eqeq1d
        eff1i.5 elrab2 biimpri vy cv cc wcel vy cv cabs cfv cc wcel vy cv cabs
        cfv cc0 wne vy cv vy cv cabs cfv cdiv co cc wcel vy cv cc cc0 csn cdif
        wcel vy cv vy cv cabs cfv divcl vy cv cc cc0 csn eldifi vy cv cc cc0
        csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel
        vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy
        cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy
        cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co cabs cfv vy cv
        cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv vy cv cabs cfv
        cdiv co c1 vy cv cc wcel vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne
        vy cv vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv vy cv cabs cfv
        cabs cfv cdiv co wceq vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv
        absdiv vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy
        cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0
        vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt
        wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv
        clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv
        cabs cfv vy cv cabs cfv cdiv co wceq vy cv cc cc0 csn eldifi vy cv cc
        wcel vy cv cabs cfv cabs cfv vy cv cabs cfv vy cv cabs cfv cdiv vy cv
        absidm opreq2d syl vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv
        cabs cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc cc0 csn cdif wcel vy
        cv cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv
        clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr
        wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel
        vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0
        eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv
        absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc cC cD vy cv vy cv cabs
        cfv cdiv co cF ccnv cC cD cF ccnv wf1o cC cD cF ccnv wf cD cC cF wf1o
        cC cD cF ccnv wf1o cA cr wcel cD cC cF wf1o eff1i.1 vz vw vv cA cC cD
        cF eff1i.2 eff1i.4 eff1i.5 shftefif1o ax-mp cD cC cF f1ocnv ax-mp cC cD
        cF ccnv f1of ax-mp ffvelrni vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD
        wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cA c2 cpi cmul co caddc co clt wbr vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel
        cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr w3a vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cA cA c2 cpi cmul co caddc co cico co wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co
        caddc co clt wbr w3a cD cA cA c2 cpi cmul co caddc co cico co vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv eff1i.2 eleq2i cA cr wcel cA c2 cpi
        cmul co caddc co cr wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA cA
        c2 cpi cmul co caddc co cico co wcel vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co caddc co clt
        wbr w3a wb eff1i.1 cA c2 cpi cmul co eff1i.1 c2 cpi 2re pire remulcli
        readdcli cA cA c2 cpi cmul co caddc co vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv elico2 mp2an bitri biimpi 3simp1d 3syl sylanc vy cv cc cc0 csn
        cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cc wcel vy cv
        vy cv cabs cfv cdiv co cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv co cC
        wcel vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy
        cv vy cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv
        c1 wceq wa vv cv cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv co cabs cfv
        c1 wceq vv vy cv vy cv cabs cfv cdiv co cc cC vv cv vy cv vy cv cabs
        cfv cdiv co wceq vv cv cabs cfv vy cv vy cv cabs cfv cdiv co cabs cfv
        c1 vv cv vy cv vy cv cabs cfv cdiv co cabs fveq2 eqeq1d eff1i.5 elrab2
        biimpri vy cv cc wcel vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy
        cv vy cv cabs cfv cdiv co cc wcel vy cv cc cc0 csn cdif wcel vy cv vy
        cv cabs cfv divcl vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif wcel vy
        cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr
        wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr
        wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc
        wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy
        cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs
        cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv
        cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy cv cc cc0
        csn cdif wcel vy cv vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv vy
        cv cabs cfv cabs cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co c1
        vy cv cc wcel vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv
        cabs cfv cdiv co cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv
        co wceq vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv absdiv vy cv cc
        cc0 csn eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0
        csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv
        clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr
        wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel
        vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0
        eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv
        absgt0 biimpa sylbi sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv cc
        wcel vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv vy
        cv cabs cfv cdiv co wceq vy cv cc cc0 csn eldifi vy cv cc wcel vy cv
        cabs cfv cabs cfv vy cv cabs cfv vy cv cabs cfv cdiv vy cv absidm
        opreq2d syl vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv cabs
        cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc cc0 csn cdif wcel vy cv
        cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0
        csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv
        clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr
        wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel
        vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0
        eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv
        absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc cC cD vy cv vy cv cabs
        cfv cdiv co cF ccnv cC cD cF ccnv wf1o cC cD cF ccnv wf cD cC cF wf1o
        cC cD cF ccnv wf1o cA cr wcel cD cC cF wf1o eff1i.1 vz vw vv cA cC cD
        cF eff1i.2 eff1i.4 eff1i.5 shftefif1o ax-mp cD cC cF f1ocnv ax-mp cC cD
        cF ccnv f1of ax-mp ffvelrni syl eqeltrd sylanc vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cmul co caddc co ce cS cres cfv vy cv cabs cfv ce cr cres
        ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co
        ce cfv vy cv vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv
        cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cS
        wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cmul co caddc co ce cS cres cfv vy cv cabs cfv ce cr cres
        ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co
        ce cfv wceq vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cmul co caddc co cc wcel vy cv cabs cfv ce cr cres
        ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co
        cim cfv cD wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cmul co caddc co cS wcel vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cmul co caddc co cS wcel vy cv cabs cfv ce cr cres ccnv cfv
        ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cc wcel vy
        cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cmul co caddc co cim cfv cD wcel wa vv cv cim cfv cD wcel vy cv
        cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cmul co caddc co cim cfv cD wcel vv vy cv cabs cfv ce cr cres ccnv
        cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cc cS
        vv cv vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cmul co caddc co wceq vv cv cim cfv vy cv cabs cfv ce cr
        cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc
        co cim cfv cD vv cv vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cmul co caddc co cim fveq2 eleq1d eff1i.3
        elrab2 biimpri vy cv cabs cfv ce cr cres ccnv cfv cc wcel ci vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv cmul co cc wcel vy cv cabs cfv ce cr
        cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc
        co cc wcel vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv
        cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co addcl vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv ce cr cres ccnv cfv cr
        wcel vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv
        crp wcel vy cv cc cc0 csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs
        cfv cr wcel cc0 vy cv cabs cfv clt wbr wa vy cv cabs cfv elrp biimpri
        vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv
        cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc
        wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn
        vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0
        biimpa sylbi sylanc crp cr vy cv cabs cfv ce cr cres ccnv crp cr ce cr
        cres ccnv wf1o crp cr ce cr cres ccnv wf cr crp ce cr cres wf1o crp cr
        ce cr cres ccnv wf1o reeff1o2 cr crp ce cr cres f1ocnv ax-mp crp cr ce
        cr cres ccnv f1of ax-mp ffvelrni syl recnd vy cv cc cc0 csn cdif wcel
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv cc wcel ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cmul co cc wcel vy cv cc cc0 csn cdif wcel vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel vy cv vy cv
        cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq
        vy cv vy cv cabs cfv cdiv co cC wcel vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cc wcel vy
        cv vy cv cabs cfv cdiv co cabs cfv c1 wceq wa vv cv cabs cfv c1 wceq vy
        cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vv vy cv vy cv cabs cfv cdiv
        co cc cC vv cv vy cv vy cv cabs cfv cdiv co wceq vv cv cabs cfv vy cv
        vy cv cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy cv cabs cfv cdiv co
        cabs fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc wcel vy cv cabs cfv
        cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cc wcel vy
        cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl vy cv cc cc0 csn
        eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv
        cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0
        csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co
        cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv
        vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv cabs cfv cc wcel vy cv
        cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv
        vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs
        cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs
        cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv
        cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0
        vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv vy cv cabs cfv cabs
        cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co wceq vy cv cc cc0 csn
        eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy cv cabs cfv vy cv cabs
        cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv cc wcel vy cv cabs cfv
        cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy
        cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0
        vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt
        wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv
        clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc cC cD vy
        cv vy cv cabs cfv cdiv co cF ccnv cC cD cF ccnv wf1o cC cD cF ccnv wf
        cD cC cF wf1o cC cD cF ccnv wf1o cA cr wcel cD cC cF wf1o eff1i.1 vz vw
        vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o ax-mp cD cC cF f1ocnv
        ax-mp cC cD cF ccnv f1of ax-mp ffvelrni vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr
        wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr w3a vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cA cA c2 cpi cmul co caddc co cico co wcel vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi
        cmul co caddc co clt wbr w3a cD cA cA c2 cpi cmul co caddc co cico co
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv eff1i.2 eleq2i cA cr wcel cA
        c2 cpi cmul co caddc co cr wcel vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cA cA c2 cpi cmul co caddc co cico co wcel vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co
        caddc co clt wbr w3a wb eff1i.1 cA c2 cpi cmul co eff1i.1 c2 cpi 2re
        pire remulcli readdcli cA cA c2 cpi cmul co caddc co vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv elico2 mp2an bitri biimpi 3simp1d 3syl recnd ci
        cc wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cc wcel ci vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cmul co cc wcel axicn ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv mulcl mpan syl sylanc vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cmul co caddc co cim cfv vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cD vy cv cabs cfv ce cr cres ccnv cfv cr wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cr wcel vy cv cabs cfv ce cr cres ccnv cfv ci
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co caddc co cim cfv vy cv
        vy cv cabs cfv cdiv co cF ccnv cfv wceq vy cv cc cc0 csn cdif wcel vy
        cv cabs cfv ce cr cres ccnv cfv vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv crim vy cv cc cc0 csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs
        cfv ce cr cres ccnv cfv cr wcel vy cv cabs cfv cr wcel cc0 vy cv cabs
        cfv clt wbr vy cv cabs cfv crp wcel vy cv cc cc0 csn cdif wcel vy cv
        cabs cfv crp wcel vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr wa
        vy cv cabs cfv elrp biimpri vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt
        wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv
        clt wbr vy cv absgt0 biimpa sylbi sylanc crp cr vy cv cabs cfv ce cr
        cres ccnv crp cr ce cr cres ccnv wf1o crp cr ce cr cres ccnv wf cr crp
        ce cr cres wf1o crp cr ce cr cres ccnv wf1o reeff1o2 cr crp ce cr cres
        f1ocnv ax-mp crp cr ce cr cres ccnv f1of ax-mp ffvelrni syl vy cv cc
        cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cr wcel vy cv vy cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv
        cdiv co cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv co cC wcel vy cv cc
        cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs
        cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq wa vv
        cv cabs cfv c1 wceq vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vv vy
        cv vy cv cabs cfv cdiv co cc cC vv cv vy cv vy cv cabs cfv cdiv co wceq
        vv cv cabs cfv vy cv vy cv cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy
        cv cabs cfv cdiv co cabs fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc
        wcel vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv
        cdiv co cc wcel vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl
        vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0
        csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs
        cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv
        cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv
        cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc
        cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy
        cv absgt0 biimpa sylbi sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv
        cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv
        cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co
        cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc
        cc0 csn cdif wcel vy cv vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs
        cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv
        cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv
        vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co
        wceq vy cv cc cc0 csn eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy
        cv cabs cfv vy cv cabs cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv
        cc wcel vy cv cabs cfv cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1
        wceq vy cv cc cc0 csn cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv
        cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv
        cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy
        cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc
        3eqtrd sylanc cC cD vy cv vy cv cabs cfv cdiv co cF ccnv cC cD cF ccnv
        wf1o cC cD cF ccnv wf cD cC cF wf1o cC cD cF ccnv wf1o cA cr wcel cD cC
        cF wf1o eff1i.1 vz vw vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o
        ax-mp cD cC cF f1ocnv ax-mp cC cD cF ccnv f1of ax-mp ffvelrni vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co caddc co clt
        wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co
        caddc co clt wbr w3a vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA cA c2 cpi cmul co caddc co
        cico co wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv
        vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr w3a cD cA cA c2 cpi cmul
        co caddc co cico co vy cv vy cv cabs cfv cdiv co cF ccnv cfv eff1i.2
        eleq2i cA cr wcel cA c2 cpi cmul co caddc co cr wcel vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cA cA c2 cpi cmul co caddc co cico co wcel vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA
        c2 cpi cmul co caddc co clt wbr w3a wb eff1i.1 cA c2 cpi cmul co
        eff1i.1 c2 cpi 2re pire remulcli readdcli cA cA c2 cpi cmul co caddc co
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv elico2 mp2an bitri biimpi
        3simp1d 3syl sylanc vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv
        cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv
        vy cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1
        wceq vy cv vy cv cabs cfv cdiv co cC wcel vy cv cc cc0 csn cdif wcel vy
        cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cc wcel
        vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq wa vv cv cabs cfv c1 wceq
        vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vv vy cv vy cv cabs cfv
        cdiv co cc cC vv cv vy cv vy cv cabs cfv cdiv co wceq vv cv cabs cfv vy
        cv vy cv cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy cv cabs cfv cdiv
        co cabs fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc wcel vy cv cabs
        cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cc wcel
        vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl vy cv cc cc0 csn
        eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv
        cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0
        csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co
        cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv
        vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv cabs cfv cc wcel vy cv
        cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv
        vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs
        cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs
        cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv
        cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0
        vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv vy cv cabs cfv cabs
        cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co wceq vy cv cc cc0 csn
        eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy cv cabs cfv vy cv cabs
        cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv cc wcel vy cv cabs cfv
        cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy
        cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0
        vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt
        wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv
        clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc cC cD vy
        cv vy cv cabs cfv cdiv co cF ccnv cC cD cF ccnv wf1o cC cD cF ccnv wf
        cD cC cF wf1o cC cD cF ccnv wf1o cA cr wcel cD cC cF wf1o eff1i.1 vz vw
        vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o ax-mp cD cC cF f1ocnv
        ax-mp cC cD cF ccnv f1of ax-mp ffvelrni syl eqeltrd sylanc vy cv cabs
        cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cmul co caddc co cS ce fvres syl vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cmul co caddc co ce cfv vy cv cabs cfv ce cr cres ccnv cfv ce cfv ci vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co ce cfv cmul co vy cv cabs
        cfv vy cv vy cv cabs cfv cdiv co cmul co vy cv vy cv cabs cfv ce cr
        cres ccnv cfv cc wcel ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul
        co cc wcel vy cv cabs cfv ce cr cres ccnv cfv ci vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cmul co caddc co ce cfv vy cv cabs cfv ce cr cres
        ccnv cfv ce cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co ce
        cfv cmul co wceq vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres
        ccnv cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co efadd vy
        cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv vy cv cc cc0
        csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv ce cr cres ccnv
        cfv cr wcel vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv
        cabs cfv crp wcel vy cv cc cc0 csn cdif wcel vy cv cabs cfv crp wcel vy
        cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr wa vy cv cabs cfv elrp
        biimpri vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel
        vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0
        eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv
        absgt0 biimpa sylbi sylanc crp cr vy cv cabs cfv ce cr cres ccnv crp cr
        ce cr cres ccnv wf1o crp cr ce cr cres ccnv wf cr crp ce cr cres wf1o
        crp cr ce cr cres ccnv wf1o reeff1o2 cr crp ce cr cres f1ocnv ax-mp crp
        cr ce cr cres ccnv f1of ax-mp ffvelrni syl recnd vy cv cc cc0 csn cdif
        wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cc wcel ci vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cmul co cc wcel vy cv cc cc0 csn cdif wcel
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv vy cv cc cc0 csn cdif wcel vy
        cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel vy cv vy
        cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1
        wceq vy cv vy cv cabs cfv cdiv co cC wcel vy cv cc cc0 csn cdif wcel vy
        cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cc wcel
        vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq wa vv cv cabs cfv c1 wceq
        vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vv vy cv vy cv cabs cfv
        cdiv co cc cC vv cv vy cv vy cv cabs cfv cdiv co wceq vv cv cabs cfv vy
        cv vy cv cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy cv cabs cfv cdiv
        co cabs fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc wcel vy cv cabs
        cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cc wcel
        vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl vy cv cc cc0 csn
        eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv
        cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0
        csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co
        cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv
        vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv cabs cfv cc wcel vy cv
        cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv
        vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs
        cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs
        cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv
        cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0
        vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv vy cv cabs cfv cabs
        cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co wceq vy cv cc cc0 csn
        eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy cv cabs cfv vy cv cabs
        cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv cc wcel vy cv cabs cfv
        cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy
        cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0
        vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt
        wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv
        clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc cC cD vy
        cv vy cv cabs cfv cdiv co cF ccnv cC cD cF ccnv wf1o cC cD cF ccnv wf
        cD cC cF wf1o cC cD cF ccnv wf1o cA cr wcel cD cC cF wf1o eff1i.1 vz vw
        vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o ax-mp cD cC cF f1ocnv
        ax-mp cC cD cF ccnv f1of ax-mp ffvelrni vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr wcel cA vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cr
        wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv cle wbr vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co caddc co clt wbr w3a vy
        cv vy cv cabs cfv cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv
        co cF ccnv cfv cA cA c2 cpi cmul co caddc co cico co wcel vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi
        cmul co caddc co clt wbr w3a cD cA cA c2 cpi cmul co caddc co cico co
        vy cv vy cv cabs cfv cdiv co cF ccnv cfv eff1i.2 eleq2i cA cr wcel cA
        c2 cpi cmul co caddc co cr wcel vy cv vy cv cabs cfv cdiv co cF ccnv
        cfv cA cA c2 cpi cmul co caddc co cico co wcel vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cr wcel cA vy cv vy cv cabs cfv cdiv co cF ccnv cfv
        cle wbr vy cv vy cv cabs cfv cdiv co cF ccnv cfv cA c2 cpi cmul co
        caddc co clt wbr w3a wb eff1i.1 cA c2 cpi cmul co eff1i.1 c2 cpi 2re
        pire remulcli readdcli cA cA c2 cpi cmul co caddc co vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv elico2 mp2an bitri biimpi 3simp1d 3syl recnd ci
        cc wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cc wcel ci vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cmul co cc wcel axicn ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv mulcl mpan syl sylanc vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv ce cr cres ccnv cfv ce cfv vy cv cabs cfv ci vy cv
        vy cv cabs cfv cdiv co cF ccnv cfv cmul co ce cfv vy cv vy cv cabs cfv
        cdiv co cmul vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv
        cfv ce cr cres cfv vy cv cabs cfv ce cr cres ccnv cfv ce cfv vy cv cabs
        cfv vy cv cc cc0 csn cdif wcel vy cv cabs cfv ce cr cres ccnv cfv cr
        wcel vy cv cabs cfv ce cr cres ccnv cfv ce cr cres cfv vy cv cabs cfv
        ce cr cres ccnv cfv ce cfv wceq vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv crp wcel vy cv cabs cfv ce cr cres ccnv cfv cr wcel vy cv cabs cfv
        cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv crp wcel vy cv cc cc0
        csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv cr wcel cc0 vy cv
        cabs cfv clt wbr wa vy cv cabs cfv elrp biimpri vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc crp cr vy
        cv cabs cfv ce cr cres ccnv crp cr ce cr cres ccnv wf1o crp cr ce cr
        cres ccnv wf cr crp ce cr cres wf1o crp cr ce cr cres ccnv wf1o
        reeff1o2 cr crp ce cr cres f1ocnv ax-mp crp cr ce cr cres ccnv f1of
        ax-mp ffvelrni syl vy cv cabs cfv ce cr cres ccnv cfv cr ce fvres syl
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv ce cr
        cres ccnv cfv ce cr cres cfv vy cv cabs cfv wceq vy cv cabs cfv cr wcel
        cc0 vy cv cabs cfv clt wbr vy cv cabs cfv crp wcel vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv crp wcel vy cv cabs cfv cr wcel cc0 vy cv cabs
        cfv clt wbr wa vy cv cabs cfv elrp biimpri vy cv cc cc0 csn cdif wcel
        vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc cr crp ce
        cr cres wf1o vy cv cabs cfv crp wcel vy cv cabs cfv ce cr cres ccnv cfv
        ce cr cres cfv vy cv cabs cfv wceq reeff1o2 cr crp vy cv cabs cfv ce cr
        cres f1ocnvfv2 mpan syl eqtr3d vy cv cc cc0 csn cdif wcel vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cF cfv ci vy cv vy cv cabs cfv cdiv co cF
        ccnv cfv cmul co ce cfv vy cv vy cv cabs cfv cdiv co vy cv cc cc0 csn
        cdif wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cD wcel vy cv vy cv cabs cfv cdiv co cF ccnv cfv cF
        cfv ci vy cv vy cv cabs cfv cdiv co cF ccnv cfv cmul co ce cfv wceq vy
        cv vy cv cabs cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv
        c1 wceq vy cv vy cv cabs cfv cdiv co cC wcel vy cv cc cc0 csn cdif wcel
        vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cc
        wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq wa vv cv cabs cfv c1
        wceq vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vv vy cv vy cv cabs
        cfv cdiv co cc cC vv cv vy cv vy cv cabs cfv cdiv co wceq vv cv cabs
        cfv vy cv vy cv cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy cv cabs cfv
        cdiv co cabs fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc wcel vy cv
        cabs cfv cc wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cc
        wcel vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl vy cv cc cc0
        csn eldifi vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn
        cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi
        vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr
        vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0
        vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv
        cc cc0 csn eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc
        wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn
        vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0
        biimpa sylbi sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv vy cv cabs
        cfv cdiv co cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy
        cv cabs cfv vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv cabs cfv cc
        wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cabs cfv vy cv
        cabs cfv vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc cc0 csn cdif
        wcel vy cv vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi vy cv cc cc0
        csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel
        vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy
        cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif
        wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv
        abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0
        vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne
        cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy
        cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv vy cv cabs cfv
        cabs cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co wceq vy cv cc
        cc0 csn eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy cv cabs cfv vy
        cv cabs cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv cc wcel vy cv
        cabs cfv cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv
        cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr
        wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr
        wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc
        wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy
        cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs
        cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv
        cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc
        cC cD vy cv vy cv cabs cfv cdiv co cF ccnv cC cD cF ccnv wf1o cC cD cF
        ccnv wf cD cC cF wf1o cC cD cF ccnv wf1o cA cr wcel cD cC cF wf1o
        eff1i.1 vz vw vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o ax-mp
        cD cC cF f1ocnv ax-mp cC cD cF ccnv f1of ax-mp ffvelrni va vb vy cv vy
        cv cabs cfv cdiv co cF ccnv cfv ci va cv cmul co ce cfv ci vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv cmul co ce cfv cD cF va cv vy cv vy cv
        cabs cfv cdiv co cF ccnv cfv wceq ci va cv cmul co ci vy cv vy cv cabs
        cfv cdiv co cF ccnv cfv cmul co ce va cv vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv ci cmul opreq2 fveq2d cF vz cv cD wcel vw cv ci vz cv cmul
        co ce cfv wceq wa vz vw copab va cv cD wcel vb cv ci va cv cmul co ce
        cfv wceq wa va vb copab eff1i.4 vz cv cD wcel vw cv ci vz cv cmul co ce
        cfv wceq wa va cv cD wcel vb cv ci va cv cmul co ce cfv wceq wa vz vw
        va vb vz cv va cv wceq vw cv vb cv wceq wa vz cv cD wcel va cv cD wcel
        vw cv ci vz cv cmul co ce cfv wceq vb cv ci va cv cmul co ce cfv wceq
        vz cv va cv wceq vz cv cD wcel va cv cD wcel wb vw cv vb cv wceq vz cv
        va cv cD eleq1 adantr vw cv vb cv wceq vz cv va cv wceq vw cv vb cv ci
        vz cv cmul co ce cfv ci va cv cmul co ce cfv vw cv vb cv wceq id vz cv
        va cv wceq ci vz cv cmul co ci va cv cmul co ce vz cv va cv ci cmul
        opreq2 fveq2d eqeqan12rd anbi12d cbvopabv eqtri ci vy cv vy cv cabs cfv
        cdiv co cF ccnv cfv cmul co ce fvex fvopab4 3syl vy cv cc cc0 csn cdif
        wcel vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cF cfv vy cv vy cv cabs cfv cdiv co wceq vy cv vy cv cabs
        cfv cdiv co cc wcel vy cv vy cv cabs cfv cdiv co cabs cfv c1 wceq vy cv
        vy cv cabs cfv cdiv co cC wcel vy cv cc cc0 csn cdif wcel vy cv vy cv
        cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co cc wcel vy cv vy
        cv cabs cfv cdiv co cabs cfv c1 wceq wa vv cv cabs cfv c1 wceq vy cv vy
        cv cabs cfv cdiv co cabs cfv c1 wceq vv vy cv vy cv cabs cfv cdiv co cc
        cC vv cv vy cv vy cv cabs cfv cdiv co wceq vv cv cabs cfv vy cv vy cv
        cabs cfv cdiv co cabs cfv c1 vv cv vy cv vy cv cabs cfv cdiv co cabs
        fveq2 eqeq1d eff1i.5 elrab2 biimpri vy cv cc wcel vy cv cabs cfv cc
        wcel vy cv cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cc wcel vy cv
        cc cc0 csn cdif wcel vy cv vy cv cabs cfv divcl vy cv cc cc0 csn eldifi
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs
        cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv
        cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc vy cv cc cc0 csn cdif wcel vy cv vy cv cabs cfv cdiv co
        cabs cfv vy cv cabs cfv vy cv cabs cfv cabs cfv cdiv co vy cv cabs cfv
        vy cv cabs cfv cdiv co c1 vy cv cc wcel vy cv cabs cfv cc wcel vy cv
        cabs cfv cc0 wne vy cv vy cv cabs cfv cdiv co cabs cfv vy cv cabs cfv
        vy cv cabs cfv cabs cfv cdiv co wceq vy cv cc cc0 csn cdif wcel vy cv
        vy cv cabs cfv absdiv vy cv cc cc0 csn eldifi vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs
        cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs
        cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc
        cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv
        cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0
        vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi sylanc syl3anc vy cv
        cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv vy cv cabs cfv cabs
        cfv cdiv co vy cv cabs cfv vy cv cabs cfv cdiv co wceq vy cv cc cc0 csn
        eldifi vy cv cc wcel vy cv cabs cfv cabs cfv vy cv cabs cfv vy cv cabs
        cfv cdiv vy cv absidm opreq2d syl vy cv cabs cfv cc wcel vy cv cabs cfv
        cc0 wne vy cv cabs cfv vy cv cabs cfv cdiv co c1 wceq vy cv cc cc0 csn
        cdif wcel vy cv cabs cfv divid vy cv cc cc0 csn cdif wcel vy cv cabs
        cfv vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy
        cv cc cc0 csn eldifi vy cv abscl syl recnd vy cv cabs cfv cr wcel cc0
        vy cv cabs cfv clt wbr vy cv cabs cfv cc0 wne vy cv cc cc0 csn cdif
        wcel vy cv cabs cfv gt0ne0 vy cv cc cc0 csn cdif wcel vy cv cc wcel vy
        cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl syl vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cc0 wne wa cc0 vy cv cabs cfv clt
        wbr vy cv cc cc0 eldifsn vy cv cc wcel vy cv cc0 wne cc0 vy cv cabs cfv
        clt wbr vy cv absgt0 biimpa sylbi sylanc sylanc 3eqtrd sylanc cD cC cF
        wf1o vy cv vy cv cabs cfv cdiv co cC wcel vy cv vy cv cabs cfv cdiv co
        cF ccnv cfv cF cfv vy cv vy cv cabs cfv cdiv co wceq cA cr wcel cD cC
        cF wf1o eff1i.1 vz vw vv cA cC cD cF eff1i.2 eff1i.4 eff1i.5 shftefif1o
        ax-mp cD cC vy cv vy cv cabs cfv cdiv co cF f1ocnvfv2 mpan syl eqtr3d
        opreq12d vy cv cc wcel vy cv cabs cfv cc wcel vy cv cabs cfv cc0 wne vy
        cv cabs cfv vy cv vy cv cabs cfv cdiv co cmul co vy cv wceq vy cv cc
        cc0 csn cdif wcel vy cv vy cv cabs cfv divcan2 vy cv cc cc0 csn eldifi
        vy cv cc cc0 csn cdif wcel vy cv cabs cfv vy cv cc cc0 csn cdif wcel vy
        cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn eldifi vy cv abscl
        syl recnd vy cv cabs cfv cr wcel cc0 vy cv cabs cfv clt wbr vy cv cabs
        cfv cc0 wne vy cv cc cc0 csn cdif wcel vy cv cabs cfv gt0ne0 vy cv cc
        cc0 csn cdif wcel vy cv cc wcel vy cv cabs cfv cr wcel vy cv cc cc0 csn
        eldifi vy cv abscl syl vy cv cc cc0 csn cdif wcel vy cv cc wcel vy cv
        cc0 wne wa cc0 vy cv cabs cfv clt wbr vy cv cc cc0 eldifsn vy cv cc
        wcel vy cv cc0 wne cc0 vy cv cabs cfv clt wbr vy cv absgt0 biimpa sylbi
        sylanc syl3anc 3eqtrd eqtr2d sylanc rgen mpbir2an $.
        $( [26-Apr-2008] $) $( [16-Apr-2008] $)
    $}

    $( The exponential function maps the set ` S ` , of complex numbers with
       imaginary part in a closed-below, open-above real interval of length
       ` 2 x. pi ` starting at ` A ` , one-to-one onto the nonzero complex
       numbers.  ` A ` would normally be fixed at ` 0 ` or ` -u pi ` ,
       according to choice of principal domain for the exponential function.
       (Contributed by Paul Chapman, 16-Apr-2008.) $)
    eff1oi $p |- ( exp |` S ) : S -1-1-onto-> ( CC \ { 0 } ) $=
      cS cc cc0 csn cdif ce cS cres wf1o cS cc cc0 csn cdif ce cS cres wf1 cS
      cc cc0 csn cdif ce cS cres wfo cS cc cc0 csn cdif ce cS cres df-f1o vz vw
      vv cA vv cv cabs cfv c1 wceq vv cc crab cD cS vz cv cD wcel vw cv ci vz
      cv cmul co ce cfv wceq wa vz vw copab eff1i.1 eff1i.2 eff1i.3 vz cv cD
      wcel vw cv ci vz cv cmul co ce cfv wceq wa vz vw copab eqid vv cv cabs
      cfv c1 wceq vv cc crab eqid eff1i vz vw vv cA vv cv cabs cfv c1 wceq vv
      cc crab cD cS vz cv cD wcel vw cv ci vz cv cmul co ce cfv wceq wa vz vw
      copab eff1i.1 eff1i.2 eff1i.3 vz cv cD wcel vw cv ci vz cv cmul co ce cfv
      wceq wa vz vw copab eqid vv cv cabs cfv c1 wceq vv cc crab eqid effoi
      mpbir2an $.
      $( [16-Apr-2008] $) $( [16-Apr-2008] $)
  $}

  $( The exponential function is periodic.  (Contributed by Paul Chapman,
     21-Apr-2008.) $)
  efper $p |- ( ( A e. CC /\ K e. ZZ ) ->
           ( exp ` ( A + ( ( _i x. ( 2 x. pi ) ) x. K ) ) ) = ( exp ` A ) ) $=
    cA cc wcel cK cz wcel wa cA ci c2 cpi cmul co cmul co cK cmul co caddc co
    ce cfv cA ce cfv ci c2 cpi cmul co cmul co cK cmul co ce cfv cmul co cA ce
    cfv cA cc wcel ci c2 cpi cmul co cmul co cK cmul co cc wcel cA ci c2 cpi
    cmul co cmul co cK cmul co caddc co ce cfv cA ce cfv ci c2 cpi cmul co cmul
    co cK cmul co ce cfv cmul co wceq cK cz wcel cA ci c2 cpi cmul co cmul co
    cK cmul co efadd cK cz wcel cK cc wcel ci c2 cpi cmul co cmul co cK cmul co
    cc wcel cK zcn ci c2 cpi cmul co cmul co cc wcel cK cc wcel ci c2 cpi cmul
    co cmul co cK cmul co cc wcel ci c2 cpi cmul co axicn c2 cpi cmul co c2 cpi
    2re pire remulcli recni mulcli ci c2 cpi cmul co cmul co cK mulcl mpan syl
    sylan2 cK cz wcel cA cc wcel cA ce cfv ci c2 cpi cmul co cmul co cK cmul co
    ce cfv cmul co cA ce cfv c1 cmul co cA ce cfv cK cz wcel ci c2 cpi cmul co
    cmul co cK cmul co ce cfv c1 cA ce cfv cmul cK cz wcel ci cK c2 cpi cmul co
    cmul co cmul co ce cfv cK c2 cpi cmul co cmul co ccos cfv ci cK c2 cpi cmul
    co cmul co csin cfv cmul co caddc co ci c2 cpi cmul co cmul co cK cmul co
    ce cfv c1 cK cz wcel cK cc wcel cK c2 cpi cmul co cmul co cc wcel ci cK c2
    cpi cmul co cmul co cmul co ce cfv cK c2 cpi cmul co cmul co ccos cfv ci cK
    c2 cpi cmul co cmul co csin cfv cmul co caddc co wceq cK zcn cK cc wcel c2
    cpi cmul co cc wcel cK c2 cpi cmul co cmul co cc wcel c2 cpi cmul co c2 cpi
    2re pire remulcli recni cK c2 cpi cmul co mulcl mpan2 cK c2 cpi cmul co
    cmul co efival 3syl cK cz wcel ci cK c2 cpi cmul co cmul co cmul co ci c2
    cpi cmul co cmul co cK cmul co ce cK cz wcel cK cc wcel ci cK c2 cpi cmul
    co cmul co cmul co ci c2 cpi cmul co cmul co cK cmul co wceq cK zcn cK cc
    wcel ci cK c2 cpi cmul co cmul co cmul co cK ci c2 cpi cmul co cmul co cmul
    co ci c2 cpi cmul co cmul co cK cmul co ci cc wcel cK cc wcel c2 cpi cmul
    co cc wcel ci cK c2 cpi cmul co cmul co cmul co cK ci c2 cpi cmul co cmul
    co cmul co wceq axicn c2 cpi cmul co c2 cpi 2re pire remulcli recni ci cK
    c2 cpi cmul co mul12 mp3an13 cK cc wcel ci c2 cpi cmul co cmul co cc wcel
    cK ci c2 cpi cmul co cmul co cmul co ci c2 cpi cmul co cmul co cK cmul co
    wceq ci c2 cpi cmul co axicn c2 cpi cmul co c2 cpi 2re pire remulcli recni
    mulcli cK ci c2 cpi cmul co cmul co mulcom mpan2 eqtrd syl fveq2d cK cz
    wcel cK c2 cpi cmul co cmul co ccos cfv ci cK c2 cpi cmul co cmul co csin
    cfv cmul co caddc co c1 cc0 caddc co c1 cK cz wcel cK c2 cpi cmul co cmul
    co ccos cfv c1 ci cK c2 cpi cmul co cmul co csin cfv cmul co cc0 caddc cK
    cos2kpi cK cz wcel ci cK c2 cpi cmul co cmul co csin cfv cmul co ci cc0
    cmul co cc0 cK cz wcel cK c2 cpi cmul co cmul co csin cfv cc0 ci cmul cK
    sin2kpi opreq2d ci axicn mul01i syl6eq opreq12d c1 ax1cn addid1i syl6eq
    3eqtr3d opreq2d cA cc wcel cA ce cfv cc wcel cA ce cfv c1 cmul co cA ce cfv
    wceq cA efcl cA ce cfv mulid1 syl sylan9eqr eqtrd $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The exponential function restricted to its principal domain maps
     one-to-one onto the nonzero complex numbers.  (Contributed by Paul
     Chapman, 21-Apr-2008.) $)
  eff1o $p |- ( exp |` { x e. CC | ( Im ` x ) e. ( -u pi [,) pi ) } ) :
    { x e. CC | ( Im ` x ) e. ( -u pi [,) pi ) } -1-1-onto-> ( CC \ { 0 } ) $=
    vx cpi cneg cpi cneg cpi cneg c2 cpi cmul co caddc co cico co vx cv cim cfv
    cpi cneg cpi cico co wcel vx cc crab cpi pire renegcli cpi cneg cpi cneg c2
    cpi cmul co caddc co cico co eqid vx cv cim cfv cpi cneg cpi cneg c2 cpi
    cmul co caddc co cico co wcel vx cc crab vx cv cim cfv cpi cneg cpi cico co
    wcel vx cc crab vx cv cim cfv cpi cneg cpi cneg c2 cpi cmul co caddc co
    cico co wcel vx cv cim cfv cpi cneg cpi cico co wcel vx cc vx cv cim cfv
    cpi cneg cpi cneg c2 cpi cmul co caddc co cico co wcel vx cv cim cfv cpi
    cneg cpi cico co wcel wb vx cv cc wcel cpi cneg cpi cneg c2 cpi cmul co
    caddc co cico co cpi cneg cpi cico co vx cv cim cfv cpi cneg c2 cpi cmul co
    caddc co cpi cpi cneg cico c2 cpi cmul co cpi cneg caddc co c2 cpi cmul co
    cpi cmin co cpi cneg c2 cpi cmul co caddc co cpi c2 cpi cmul co cpi c2 cpi
    2cn cpi pire recni mulcli cpi pire recni negsubi c2 cpi cmul co cpi cneg c2
    cpi 2cn cpi pire recni mulcli cpi cneg cpi pire renegcli recni addcomi c2
    cpi cmul co cpi cpi c2 cpi 2cn cpi pire recni mulcli cpi pire recni cpi
    pire recni c2 cpi cmul co cpi cpi caddc co cpi cpi pire recni 2timesi
    eqcomi subaddrii 3eqtr3i opreq2i eleq2i a1i rabbii eqcomi eff1oi $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The natural logarithm on complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c log $.

  $( Extend class notation with the natural logarithm function on complex
     numbers. $)
  clog $a class log $.

  $( Define the natural logarithm function on complex numbers.  See
     ~ http://en.wikipedia.org/wiki/Natural_logarithm ("The natural logarithm
     function can also be defined as the inverse function of the exponential
     function"). $)
  df-log $a |- log =
               `' ( exp |` { x e. CC | ( Im ` x ) e. ( -u pi [,) pi ) } ) $.

  $( The range of the natural logarithm function, also the principal domain of
     the exponential function.  This allows us to write the longer class
     abstraction as simply ` ran log ` .  (Contributed by Paul Chapman,
     21-Apr-2008.) $)
  logrn $p |- ran log = { x e. CC | ( Im ` x ) e. ( -u pi [,) pi ) } $=
    cc cc0 csn cdif vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab clog wf1
    clog crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab wceq cc cc0 csn
    cdif vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab clog wf1o cc cc0
    csn cdif vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab clog wf1 clog
    crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab wceq wa cc cc0 csn
    cdif vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab clog wf1o cc cc0
    csn cdif vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab ce vx cv cim
    cfv cpi cneg cpi cico co wcel vx cc crab cres ccnv wf1o vx cv cim cfv cpi
    cneg cpi cico co wcel vx cc crab cc cc0 csn cdif ce vx cv cim cfv cpi cneg
    cpi cico co wcel vx cc crab cres wf1o cc cc0 csn cdif vx cv cim cfv cpi
    cneg cpi cico co wcel vx cc crab ce vx cv cim cfv cpi cneg cpi cico co wcel
    vx cc crab cres ccnv wf1o vx eff1o vx cv cim cfv cpi cneg cpi cico co wcel
    vx cc crab cc cc0 csn cdif ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc
    crab cres f1ocnv ax-mp clog ce vx cv cim cfv cpi cneg cpi cico co wcel vx
    cc crab cres ccnv wceq cc cc0 csn cdif vx cv cim cfv cpi cneg cpi cico co
    wcel vx cc crab clog wf1o cc cc0 csn cdif vx cv cim cfv cpi cneg cpi cico
    co wcel vx cc crab ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab
    cres ccnv wf1o wb vx df-log cc cc0 csn cdif vx cv cim cfv cpi cneg cpi cico
    co wcel vx cc crab clog ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc
    crab cres ccnv f1oeq1 ax-mp mpbir cc cc0 csn cdif vx cv cim cfv cpi cneg
    cpi cico co wcel vx cc crab clog dff1o5 mpbi pm3.27i $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The natural logarithm function in terms of the exponential function
     restricted to its principal domain.  (Contributed by Paul Chapman,
     21-Apr-2008.) $)
  dflog2 $p |- log = `' ( exp |` ran log ) $=
    clog ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cres ccnv ce
    clog crn cres ccnv vx df-log ce clog crn cres ce vx cv cim cfv cpi cneg cpi
    cico co wcel vx cc crab cres clog crn vx cv cim cfv cpi cneg cpi cico co
    wcel vx cc crab wceq ce clog crn cres ce vx cv cim cfv cpi cneg cpi cico co
    wcel vx cc crab cres wceq vx logrn clog crn vx cv cim cfv cpi cneg cpi cico
    co wcel vx cc crab ce reseq2 ax-mp cnveqi eqtr4i $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The range of the natural logarithm function includes the real numbers.
     (Contributed by Paul Chapman, 21-Apr-2008.) $)
  resslogrn $p |- RR C_ ran log $=
    vx cr clog crn vx cv cr wcel vx cv vx cv cim cfv cpi cneg cpi cico co wcel
    vx cc crab clog crn vx cv cc wcel vx cv cim cfv cpi cneg cpi cico co wcel
    vx cv vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab wcel vx cv cr wcel
    vx cv vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab wcel vx cv cc wcel
    vx cv cim cfv cpi cneg cpi cico co wcel wa vx cv cim cfv cpi cneg cpi cico
    co wcel vx cc rabid biimpri vx cv recn vx cv cr wcel vx cv cim cfv cc0 cpi
    cneg cpi cico co vx cv reim0 cc0 cr wcel cpi cneg cc0 cle wbr cc0 cpi clt
    wbr cc0 cpi cneg cpi cico co wcel 0re cpi cneg cc0 cpi pire renegcli 0re
    cc0 cpi clt wbr cpi cneg cc0 clt wbr pipos cpi cr wcel cc0 cpi clt wbr cpi
    cneg cc0 clt wbr wb pire cpi lt0neg2 ax-mp mpbi ltleii pipos cc0 cpi cneg
    cpi cico co wcel cc0 cr wcel cpi cneg cc0 cle wbr cc0 cpi clt wbr w3a cpi
    cneg cr wcel cpi cr wcel cc0 cpi cneg cpi cico co wcel cc0 cr wcel cpi cneg
    cc0 cle wbr cc0 cpi clt wbr w3a wb cpi pire renegcli pire cpi cneg cpi cc0
    elico2 mp2an biimpri mp3an syl6eqel sylanc vx logrn syl6eleqr ssriv $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The exponential function restricted to its principal domain maps
     one-to-one onto the nonzero complex numbers.  (Contributed by Paul
     Chapman, 21-Apr-2008.) $)
  eff1o2 $p |- ( exp |` ran log ) : ran log -1-1-onto-> ( CC \ { 0 } ) $=
    clog crn cc cc0 csn cdif ce clog crn cres wf1o vx cv cim cfv cpi cneg cpi
    cico co wcel vx cc crab cc cc0 csn cdif ce clog crn cres wf1o vx cv cim cfv
    cpi cneg cpi cico co wcel vx cc crab cc cc0 csn cdif ce clog crn cres wf1o
    vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cc cc0 csn cdif ce vx cv
    cim cfv cpi cneg cpi cico co wcel vx cc crab cres wf1o vx eff1o ce clog crn
    cres ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cres wceq vx cv
    cim cfv cpi cneg cpi cico co wcel vx cc crab cc cc0 csn cdif ce clog crn
    cres wf1o vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cc cc0 csn
    cdif ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cres wf1o wb
    clog crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab wceq ce clog
    crn cres ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cres wceq vx
    logrn clog crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab ce reseq2
    ax-mp vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cc cc0 csn cdif ce
    clog crn cres ce vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cres
    f1oeq1 ax-mp mpbir clog crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc
    crab wceq clog crn cc cc0 csn cdif ce clog crn cres wf1o vx cv cim cfv cpi
    cneg cpi cico co wcel vx cc crab cc cc0 csn cdif ce clog crn cres wf1o wb
    vx logrn clog crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cc cc0
    csn cdif ce clog crn cres f1oeq2 ax-mp mpbir $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The natural logarithm function maps the nonzero complex numbers one-to-one
     onto its range.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  logf1o $p |- log : ( CC \ { 0 } ) -1-1-onto-> ran log $=
    cc cc0 csn cdif clog crn clog wf1o cc cc0 csn cdif clog crn ce clog crn
    cres ccnv wf1o clog crn cc cc0 csn cdif ce clog crn cres wf1o cc cc0 csn
    cdif clog crn ce clog crn cres ccnv wf1o eff1o2 clog crn cc cc0 csn cdif ce
    clog crn cres f1ocnv ax-mp clog ce clog crn cres ccnv wceq cc cc0 csn cdif
    clog crn clog wf1o cc cc0 csn cdif clog crn ce clog crn cres ccnv wf1o wb
    dflog2 cc cc0 csn cdif clog crn clog ce clog crn cres ccnv f1oeq1 ax-mp
    mpbir $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The natural logarithm function on the positive reals in terms of the real
     exponential function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  dfrelog $p |- ( log |` RR+ ) = `' ( exp |` RR ) $=
    ce clog crn cres ccnv ce clog crn cres cr cima cres ce clog crn cres ccnv
    crp cres ce cr cres ccnv clog crp cres ce clog crn cres cr cima crp wceq ce
    clog crn cres ccnv ce clog crn cres cr cima cres ce clog crn cres ccnv crp
    cres wceq ce clog crn cres cr cima ce clog crn cres cr cres crn ce cr cres
    crn crp ce clog crn cres cr df-ima ce clog crn cres cr cres ce cr cres cr
    clog crn wss ce clog crn cres cr cres ce cr cres wceq resslogrn ce cr clog
    crn resabs1 ax-mp rneqi ce cr cres cr wfn ce cr cres ccnv wfun ce cr cres
    crn crp wceq cr crp ce cr cres wf1o ce cr cres cr wfn ce cr cres ccnv wfun
    ce cr cres crn crp wceq w3a reeff1o2 cr crp ce cr cres dff1o2 mpbi 3simp3i
    3eqtri ce clog crn cres cr cima crp ce clog crn cres ccnv reseq2 ax-mp ce
    clog crn cres cr cres ccnv ce cr cres ccnv ce clog crn cres ccnv ce clog
    crn cres cr cima cres ce clog crn cres cr cres ce cr cres cr clog crn wss
    ce clog crn cres cr cres ce cr cres wceq resslogrn ce cr clog crn resabs1
    ax-mp cnveqi ce clog crn cres ccnv wfun ce clog crn cres cr cres ccnv ce
    clog crn cres ccnv ce clog crn cres cr cima cres wceq clog wfun ce clog crn
    cres ccnv wfun cc cc0 csn cdif clog crn clog wf1o clog wfun logf1o cc cc0
    csn cdif clog crn clog f1ofun ax-mp clog ce clog crn cres ccnv wceq clog
    wfun ce clog crn cres ccnv wfun wb dflog2 clog ce clog crn cres ccnv funeq
    ax-mp mpbi cr ce clog crn cres funcnvres ax-mp eqtr3i clog ce clog crn cres
    ccnv wceq clog crp cres ce clog crn cres ccnv crp cres wceq dflog2 clog ce
    clog crn cres ccnv crp reseq1 ax-mp 3eqtr4ri $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( The natural logarithm function maps the positive reals one-to-one onto the
     real numbers.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  relogf1o $p |- ( log |` RR+ ) : RR+ -1-1-onto-> RR $=
    crp cr clog crp cres wf1o crp cr ce clog crn cres ccnv crp cres wf1o ce
    clog crn cres ccnv wfun cr crp ce clog crn cres cr cres wf1o crp cr ce clog
    crn cres ccnv crp cres wf1o clog crn cc cc0 csn cdif ce clog crn cres wf1o
    ce clog crn cres ccnv wfun eff1o2 clog crn cc cc0 csn cdif ce clog crn cres
    wf1o clog crn cc cc0 csn cdif ce clog crn cres wfo ce clog crn cres ccnv
    wfun clog crn cc cc0 csn cdif ce clog crn cres dff1o3 pm3.27bi ax-mp cr crp
    ce clog crn cres cr cres wf1o cr crp ce cr cres wf1o reeff1o2 ce clog crn
    cres cr cres ce cr cres wceq cr crp ce clog crn cres cr cres wf1o cr crp ce
    cr cres wf1o wb cr clog crn wss ce clog crn cres cr cres ce cr cres wceq
    resslogrn ce cr clog crn resabs1 ax-mp cr crp ce clog crn cres cr cres ce
    cr cres f1oeq1 ax-mp mpbir crp cr ce clog crn cres f1orescnv mp2an clog crp
    cres ce clog crn cres ccnv crp cres wceq crp cr clog crp cres wf1o crp cr
    ce clog crn cres ccnv crp cres wf1o wb clog ce clog crn cres ccnv wceq clog
    crp cres ce clog crn cres ccnv crp cres wceq dflog2 clog ce clog crn cres
    ccnv crp reseq1 ax-mp crp cr clog crp cres ce clog crn cres ccnv crp cres
    f1oeq1 ax-mp mpbir $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( Closure of the natural logarithm function.  (Contributed by Paul Chapman,
     21-Apr-2008.) $)
  logcl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( log ` A ) e. ran log ) $=
    cA cc wcel cA cc0 wne wa cA cc cc0 csn cdif wcel cA clog cfv clog crn wcel
    cA cc cc0 eldifsn cc cc0 csn cdif clog crn cA clog cc cc0 csn cdif clog crn
    clog wf1o cc cc0 csn cdif clog crn clog wf logf1o cc cc0 csn cdif clog crn
    clog f1of ax-mp ffvelrni sylbir $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( Closure of the natural logarithm function on positive reals.  (Contributed
     by Steve Rodriguez, 25-Nov-2007.) $)
  relogcl $p |- ( A e. RR+ -> ( log ` A ) e. RR ) $=
    cA crp wcel cA clog crp cres cfv cA clog cfv cr cA crp clog fvres crp cr cA
    clog crp cres crp cr clog crp cres wf1o crp cr clog crp cres wf relogf1o
    crp cr clog crp cres f1of ax-mp ffvelrni eqeltrrd $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  eflog $p |- ( ( A e. CC /\ A =/= 0 ) -> ( exp ` ( log ` A ) ) = A ) $=
    cA cc wcel cA cc0 wne wa cA clog cfv ce clog crn cres cfv cA clog cfv ce
    cfv cA cA cc wcel cA cc0 wne wa cA clog cfv clog crn wcel cA clog cfv ce
    clog crn cres cfv cA clog cfv ce cfv wceq cA logcl cA clog cfv clog crn ce
    fvres syl cA cc wcel cA cc0 wne wa cA ce clog crn cres ccnv cfv ce clog crn
    cres cfv cA cA clog cfv ce clog crn cres cfv cA cc wcel cA cc0 wne wa cA cc
    cc0 csn cdif wcel cA ce clog crn cres ccnv cfv ce clog crn cres cfv cA wceq
    cA cc cc0 eldifsn clog crn cc cc0 csn cdif ce clog crn cres wf1o cA cc cc0
    csn cdif wcel cA ce clog crn cres ccnv cfv ce clog crn cres cfv cA wceq
    eff1o2 clog crn cc cc0 csn cdif cA ce clog crn cres f1ocnvfv2 mpan sylbir
    cA clog cfv cA ce clog crn cres ccnv cfv ce clog crn cres cA clog ce clog
    crn cres ccnv dflog2 fveq1i fveq2i syl5eq eqtr3d $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  reeflog $p |- ( A e. RR+ -> ( exp ` ( log ` A ) ) = A ) $=
    cA crp wcel cA cc wcel cA cc0 wne wa cA clog cfv ce cfv cA wceq cA rpcnne0
    cA eflog syl $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  logef $p |- ( A e. ran log -> ( log ` ( exp ` A ) ) = A ) $=
    cA clog crn wcel cA ce clog crn cres cfv clog cfv cA ce cfv clog cfv cA cA
    clog crn wcel cA ce clog crn cres cfv cA ce cfv clog cA clog crn ce fvres
    fveq2d cA clog crn wcel cA ce clog crn cres cfv ce clog crn cres ccnv cfv
    cA cA ce clog crn cres cfv clog cfv clog crn cc cc0 csn cdif ce clog crn
    cres wf1o cA clog crn wcel cA ce clog crn cres cfv ce clog crn cres ccnv
    cfv cA wceq eff1o2 clog crn cc cc0 csn cdif cA ce clog crn cres f1ocnvfv1
    mpan cA ce clog crn cres cfv clog ce clog crn cres ccnv dflog2 fveq1i
    syl5eq eqtr3d $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogef $p |- ( A e. RR -> ( log ` ( exp ` A ) ) = A ) $=
    cA cr wcel cA clog crn wcel cA ce cfv clog cfv cA wceq cr clog crn cA
    resslogrn sseli cA logef syl $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  logeftb $p |- ( ( A e. CC /\ A =/= 0 /\ B e. ran log ) ->
                  ( ( log ` A ) = B <-> ( exp ` B ) = A ) ) $=
    cA cc wcel cA cc0 wne cB clog crn wcel cA clog cfv cB wceq cB ce cfv cA
    wceq wb cA cc cc0 csn cdif wcel cB clog crn wcel cA clog cfv cB wceq cB ce
    cfv cA wceq wb cA cc wcel cA cc0 wne wa cA cc cc0 csn cdif wcel cB clog crn
    wcel wa cB ce cfv cA wceq cA ce clog crn cres ccnv cfv cB wceq cA clog cfv
    cB wceq cB clog crn wcel cA cc cc0 csn cdif wcel cB ce cfv cA wceq cA ce
    clog crn cres ccnv cfv cB wceq wb cB clog crn wcel cA cc cc0 csn cdif wcel
    wa cB ce clog crn cres cfv cA wceq cB ce cfv cA wceq cA ce clog crn cres
    ccnv cfv cB wceq cB clog crn wcel cB ce clog crn cres cfv cA wceq cB ce cfv
    cA wceq wb cA cc cc0 csn cdif wcel cB clog crn wcel cB ce clog crn cres cfv
    cB ce cfv cA cB clog crn ce fvres eqeq1d adantr clog crn cc cc0 csn cdif ce
    clog crn cres wf1o cB clog crn wcel cA cc cc0 csn cdif wcel cB ce clog crn
    cres cfv cA wceq cA ce clog crn cres ccnv cfv cB wceq wb eff1o2 clog crn cc
    cc0 csn cdif cB cA ce clog crn cres f1ocnvfvb mp3an1 bitr3d ancoms cA clog
    cfv cA ce clog crn cres ccnv cfv cB cA clog ce clog crn cres ccnv dflog2
    fveq1i eqeq1i syl6rbbr cA cc cc0 eldifsn sylanbr 3impa $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogeftb $p |- ( ( A e. RR+ /\ B e. RR ) ->
                    ( ( log ` A ) = B <-> ( exp ` B ) = A ) ) $=
    cA cc wcel cA cc0 wne wa cB clog crn wcel cA clog cfv cB wceq cB ce cfv cA
    wceq wb cA crp wcel cB cr wcel cA cc wcel cA cc0 wne cB clog crn wcel cA
    clog cfv cB wceq cB ce cfv cA wceq wb cA cB logeftb 3expa cA rpcnne0 cr
    clog crn cB resslogrn sseli syl2an $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( The natural logarithm of ` 1 ` .  One case of Property 1a of [Cohen] p.
     301.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  log1 $p |- ( log ` 1 ) = 0 $=
    c1 clog cfv cc0 wceq cc0 ce cfv c1 wceq ef0 c1 crp wcel cc0 cr wcel c1 clog
    cfv cc0 wceq cc0 ce cfv c1 wceq wb 1rp 0re c1 cc0 relogeftb mp2an mpbir $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( The natural logarithm of ` _e ` .  One case of Property 1b of [Cohen]
     p. 301.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  loge $p |- ( log ` _e ) = 1 $=
    ceu clog cfv c1 wceq c1 ce cfv ceu wceq ceu c1 ce cfv df-e eqcomi ceu crp
    wcel c1 cr wcel ceu clog cfv c1 wceq c1 ce cfv ceu wceq wb ceu ere cc0 c1
    ce cfv ceu clt c1 1re efgt0i df-e breqtrri elrpii 1re ceu c1 relogeftb
    mp2an mpbir $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( Relationship between ` pi ` and the natural logarithm function.
     (Contributed by Paul Chapman, 21-Apr-2008.) $)
  pilog $p |- pi = ( _i x. ( log ` -u 1 ) ) $=
    ci c1 cneg clog cfv cmul co ci ci cpi cmul co cneg cmul co cpi c1 cneg clog
    cfv ci cpi cmul co cneg ci cmul c1 cneg clog cfv ci cpi cmul co cneg wceq
    ci cpi cmul co cneg ce cfv c1 cneg wceq ci cpi cmul co ci c2 cpi cmul co
    cmul co c1 cneg cmul co caddc co ce cfv ci cpi cmul co ce cfv ci cpi cmul
    co cneg ce cfv c1 cneg ci cpi cmul co cc wcel c1 cneg cz wcel ci cpi cmul
    co ci c2 cpi cmul co cmul co c1 cneg cmul co caddc co ce cfv ci cpi cmul co
    ce cfv wceq ci cpi axicn cpi pire recni mulcli c1 cz wcel c1 cneg cz wcel
    1z c1 znegcl ax-mp ci cpi cmul co c1 cneg efper mp2an ci cpi cmul co ci c2
    cpi cmul co cmul co c1 cneg cmul co caddc co ci cpi cmul co cneg ce ci cpi
    cmul co ci c2 cpi cmul co cmul co c1 cneg cmul co caddc co ci cpi c2 cpi
    cmul co cmin co cmul co ci cpi cneg cmul co ci cpi cmul co cneg ci cpi cmul
    co ci c2 cpi cmul co cmul co cneg caddc co ci cpi cmul co ci c2 cpi cmul co
    cmul co cmin co ci cpi cmul co ci c2 cpi cmul co cmul co c1 cneg cmul co
    caddc co ci cpi c2 cpi cmul co cmin co cmul co ci cpi cmul co ci c2 cpi
    cmul co cmul co ci cpi axicn cpi pire recni mulcli ci c2 cpi cmul co axicn
    c2 cpi 2cn cpi pire recni mulcli mulcli negsubi ci c2 cpi cmul co cmul co
    c1 cneg cmul co ci c2 cpi cmul co cmul co cneg ci cpi cmul co caddc ci c2
    cpi cmul co cmul co c1 cneg cmul co c1 cneg ci c2 cpi cmul co cmul co cmul
    co ci c2 cpi cmul co cmul co cneg ci c2 cpi cmul co cmul co c1 cneg ci c2
    cpi cmul co axicn c2 cpi 2cn cpi pire recni mulcli mulcli c1 cneg cz wcel
    c1 cneg cc wcel c1 cz wcel c1 cneg cz wcel 1z c1 znegcl ax-mp c1 cneg zcn
    ax-mp mulcomi ci c2 cpi cmul co cmul co ci c2 cpi cmul co axicn c2 cpi 2cn
    cpi pire recni mulcli mulcli mulm1i eqtri opreq2i ci cpi c2 cpi cmul co
    axicn cpi pire recni c2 cpi 2cn cpi pire recni mulcli subdii 3eqtr4i cpi c2
    cpi cmul co cmin co cpi cneg ci cmul c2 cpi cmul co cpi cmin co cneg cpi c2
    cpi cmul co cmin co cpi cneg c2 cpi cmul co cpi c2 cpi 2cn cpi pire recni
    mulcli cpi pire recni negsubdi2i c2 cpi cmul co cpi cmin co cpi c2 cpi cmul
    co cpi cpi c2 cpi 2cn cpi pire recni mulcli cpi pire recni cpi pire recni
    c2 cpi cmul co cpi cpi caddc co cpi cpi pire recni 2timesi eqcomi subaddrii
    negeqi eqtr3i opreq2i ci cpi axicn cpi pire recni mulneg2i 3eqtri fveq2i c1
    cneg cc0 c1 cmin co ci cpi cmul co ce cfv c1 df-neg cc0 c1 cmin co ci cpi
    cmul co ce cfv wceq ci cpi cmul co ce cfv c1 caddc co cc0 wceq eulerid cc0
    c1 ci cpi cmul co ce cfv 0cn ax1cn ci cpi cmul co cc wcel ci cpi cmul co ce
    cfv cc wcel ci cpi axicn cpi pire recni mulcli ci cpi cmul co efcl ax-mp
    subadd2i mpbir eqtr2i 3eqtr3i c1 cneg cc wcel c1 cneg cc0 wne ci cpi cmul
    co cneg clog crn wcel c1 cneg clog cfv ci cpi cmul co cneg wceq ci cpi cmul
    co cneg ce cfv c1 cneg wceq wb c1 cneg cz wcel c1 cneg cc wcel c1 cz wcel
    c1 cneg cz wcel 1z c1 znegcl ax-mp c1 cneg zcn ax-mp c1 ax1cn ax1ne0
    negne0i ci cpi cmul co cneg vx cv cim cfv cpi cneg cpi cico co wcel vx cc
    crab clog crn ci cpi cmul co cneg vx cv cim cfv cpi cneg cpi cico co wcel
    vx cc crab wcel ci cpi cmul co cneg cc wcel ci cpi cmul co cneg cim cfv cpi
    cneg cpi cico co wcel vx cv cim cfv cpi cneg cpi cico co wcel ci cpi cmul
    co cneg cim cfv cpi cneg cpi cico co wcel vx ci cpi cmul co cneg cc vx cv
    ci cpi cmul co cneg wceq vx cv cim cfv ci cpi cmul co cneg cim cfv cpi cneg
    cpi cico co vx cv ci cpi cmul co cneg cim fveq2 eleq1d elrab ci cpi cmul co
    ci cpi axicn cpi pire recni mulcli negcli ci cpi cmul co cneg cim cfv cpi
    cneg cpi cneg cpi cico co ci cpi cmul co cneg cim cfv ci cpi cmul co cim
    cfv cneg cpi cneg ci cpi cmul co ci cpi axicn cpi pire recni mulcli imnegi
    ci cpi cmul co cim cfv cpi cc0 ci cpi cmul co caddc co cim cfv ci cpi cmul
    co cim cfv cpi cc0 ci cpi cmul co caddc co ci cpi cmul co cim ci cpi cmul
    co ci cpi axicn cpi pire recni mulcli addid2i fveq2i cc0 cpi 0re pire crimi
    eqtr3i negeqi eqtri cpi cneg cr wcel cpi cneg cpi cneg cle wbr cpi cneg cpi
    clt wbr cpi cneg cpi cneg cpi cico co wcel cpi pire renegcli cpi cneg cpi
    pire renegcli leidi cpi cneg cc0 clt wbr cc0 cpi clt wbr cpi cneg cpi clt
    wbr cc0 cpi clt wbr cpi cneg cc0 clt wbr pipos cpi cr wcel cc0 cpi clt wbr
    cpi cneg cc0 clt wbr wb pire cpi lt0neg2 ax-mp mpbi pipos cpi cneg cc0 cpi
    cpi pire renegcli 0re pire lttri mp2an cpi cneg cpi cneg cpi cico co wcel
    cpi cneg cr wcel cpi cneg cpi cneg cle wbr cpi cneg cpi clt wbr w3a cpi
    cneg cr wcel cpi cr wcel cpi cneg cpi cneg cpi cico co wcel cpi cneg cr
    wcel cpi cneg cpi cneg cle wbr cpi cneg cpi clt wbr w3a wb cpi pire
    renegcli pire cpi cneg cpi cpi cneg elico2 mp2an biimpri mp3an eqeltri
    mpbir2an vx logrn eleqtrri c1 cneg ci cpi cmul co cneg logeftb mp3an mpbir
    opreq2i ci ci cpi cmul co cneg cmul co ci ci cpi cmul co cmul co cneg cpi
    cneg cneg cpi ci ci cpi cmul co axicn ci cpi axicn cpi pire recni mulcli
    mulneg2i ci ci cpi cmul co cmul co cpi cneg ci ci cmul co cpi cmul co c1
    cneg cpi cmul co ci ci cpi cmul co cmul co cpi cneg ci ci cmul co c1 cneg
    cpi cmul ixi opreq1i ci ci cpi axicn axicn cpi pire recni mulassi cpi cpi
    pire recni mulm1i 3eqtr3i negeqi cpi cpi pire recni negnegi 3eqtri eqtr2i
    $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  ${
    relogoprlem.1 $e |- ( ( ( log ` A ) e. CC /\ ( log ` B ) e. CC ) ->
                        ( exp ` ( ( log ` A ) F ( log ` B ) ) ) =
                        ( ( exp ` ( log ` A ) ) G ( exp ` ( log ` B ) ) ) ) $.
    relogoprlem.2 $e |- ( ( ( log ` A ) e. RR /\ ( log ` B ) e. RR ) ->
                          ( ( log ` A ) F ( log ` B ) ) e. RR ) $.
    $( Lemma for ~ relogmul and ~ relogdiv .  Remark of [Cohen] p. 301 ("The
       proof of Property 3 is quite similar to the proof given for Property
       2"). $)
    relogoprlem $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
        ( log ` ( A G B ) ) = ( ( log ` A ) F ( log ` B ) ) ) $=
      cA crp wcel cB crp wcel wa cA clog cfv ce cfv cB clog cfv ce cfv cG co
      clog cfv cA cB cG co clog cfv cA clog cfv cB clog cfv cF co cA crp wcel
      cB crp wcel wa cA clog cfv ce cfv cB clog cfv ce cfv cG co cA cB cG co
      clog cA crp wcel cB crp wcel cA clog cfv ce cfv cA cB clog cfv ce cfv cB
      cG cA reeflog cB reeflog opreqan12d fveq2d cA clog cfv cr wcel cB clog
      cfv cr wcel cA clog cfv ce cfv cB clog cfv ce cfv cG co clog cfv cA clog
      cfv cB clog cfv cF co wceq cA crp wcel cB crp wcel cA clog cfv cr wcel cB
      clog cfv cr wcel wa cA clog cfv cB clog cfv cF co ce cfv clog cfv cA clog
      cfv ce cfv cB clog cfv ce cfv cG co clog cfv cA clog cfv cB clog cfv cF
      co cA clog cfv cc wcel cB clog cfv cc wcel cA clog cfv cB clog cfv cF co
      ce cfv clog cfv cA clog cfv ce cfv cB clog cfv ce cfv cG co clog cfv wceq
      cA clog cfv cr wcel cB clog cfv cr wcel cA clog cfv cc wcel cB clog cfv
      cc wcel wa cA clog cfv cB clog cfv cF co ce cfv cA clog cfv ce cfv cB
      clog cfv ce cfv cG co clog relogoprlem.1 fveq2d cA clog cfv recn cB clog
      cfv recn syl2an cA clog cfv cr wcel cB clog cfv cr wcel wa cA clog cfv cB
      clog cfv cF co cr wcel cA clog cfv cB clog cfv cF co ce cfv clog cfv cA
      clog cfv cB clog cfv cF co wceq relogoprlem.2 cA clog cfv cB clog cfv cF
      co relogef syl eqtr3d cA relogcl cB relogcl syl2an eqtr3d $.
      $( [21-Apr-2008] $) $( [25-Nov-2007] $)
  $}

  $( The natural logarithm of the product of two positive real numbers is the
     sum of natural logarithms.  Property 2 of [Cohen] p. 301, restricted to
     natural logarithms.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogmul $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
                    ( log ` ( A x. B ) ) = ( ( log ` A ) + ( log ` B ) ) ) $=
    cA cB caddc cmul cA clog cfv cB clog cfv efadd cA clog cfv cB clog cfv
    readdcl relogoprlem $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( The natural logarithm of the quotient of two positive real numbers is the
     difference of natural logarithms.  Exercise 72(a) and Property 3 of
     [Cohen] p. 301, restricted to natural logarithms.  (Contributed by Steve
     Rodriguez, 25-Nov-2007.) $)
  relogdiv $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
                    ( log ` ( A / B ) ) = ( ( log ` A ) - ( log ` B ) ) ) $=
    cA cB cmin cdiv cA clog cfv cB clog cfv efsub cA clog cfv cB clog cfv
    resubcl relogoprlem $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( Exponentiation of a nonzero complex number to a nonnegative integer power.
     (Contributed by Paul Chapman, 21-Apr-2008.) $)
  explog $p |- ( ( A e. CC /\ A =/= 0 /\ N e. NN0 ) ->
                  ( A ^ N ) = ( exp ` ( N x. ( log ` A ) ) ) ) $=
    cA cc wcel cA cc0 wne cN cn0 wcel w3a cN cA clog cfv cmul co ce cfv cA clog
    cfv ce cfv cN cexp co cA cN cexp co cA cc wcel cA cc0 wne cN cn0 wcel cN cA
    clog cfv cmul co ce cfv cA clog cfv ce cfv cN cexp co wceq cA clog cfv cc
    wcel cN cn0 wcel cN cA clog cfv cmul co ce cfv cA clog cfv ce cfv cN cexp
    co wceq cA cc wcel cA cc0 wne wa cA clog cfv cN efexp cA cc wcel cA cc0 wne
    wa cA clog cfv clog crn wcel cA clog cfv cc wcel cA logcl clog crn cc cA
    clog cfv clog crn vx cv cim cfv cpi cneg cpi cico co wcel vx cc crab cc vx
    logrn vx cv cim cfv cpi cneg cpi cico co wcel vx cc ssrab2 eqsstri sseli
    syl sylan 3impa cA cc wcel cA cc0 wne cA clog cfv ce cfv cN cexp co cA cN
    cexp co wceq cN cn0 wcel cA cc wcel cA cc0 wne wa cA clog cfv ce cfv cA cN
    cexp cA eflog opreq1d 3adant3 eqtr2d $.
    $( [21-Apr-2008] $) $( [21-Apr-2008] $)

  $( Exponentiation of a positive real number to a nonnegative integer power.
     (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  reexplog $p |- ( ( A e. RR+ /\ N e. NN0 ) ->
                    ( A ^ N ) = ( exp ` ( N x. ( log ` A ) ) ) ) $=
    cA crp wcel cN cn0 wcel wa cN cA clog cfv cmul co ce cfv cA clog cfv ce cfv
    cN cexp co cA cN cexp co cA clog cfv cc wcel cN cn0 wcel cN cA clog cfv
    cmul co ce cfv cA clog cfv ce cfv cN cexp co wceq cA crp wcel cA clog cfv
    cN efexp cA crp wcel cA clog cfv cA relogcl recnd sylan cA crp wcel cA clog
    cfv ce cfv cN cexp co cA cN cexp co wceq cN cn0 wcel cA crp wcel cA clog
    cfv ce cfv cA cN cexp cA reeflog opreq1d adantr eqtr2d $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( The natural logarithm of positive ` A ` raised to an nonnegative integer
     power.  Property 4 of [Cohen] p. 301-302, restricted to natural logarithms
     and nonnegative-integer powers ` N ` .  (Contributed by Steve Rodriguez,
     25-Nov-2007.) $)
  relogexp $p |- ( ( A e. RR+ /\ N e. NN0 ) ->
                    ( log ` ( A ^ N ) ) = ( N x. ( log ` A ) ) ) $=
    cA crp wcel cN cn0 wcel wa cN cA clog cfv cmul co ce cfv clog cfv cA cN
    cexp co clog cfv cN cA clog cfv cmul co cA crp wcel cN cn0 wcel wa cN cA
    clog cfv cmul co ce cfv cA cN cexp co clog cA crp wcel cN cn0 wcel wa cN cA
    clog cfv cmul co ce cfv cA clog cfv ce cfv cN cexp co cA cN cexp co cA clog
    cfv cc wcel cN cn0 wcel cN cA clog cfv cmul co ce cfv cA clog cfv ce cfv cN
    cexp co wceq cA crp wcel cA clog cfv cN efexp cA crp wcel cA clog cfv cA
    relogcl recnd sylan cA crp wcel cA clog cfv ce cfv cN cexp co cA cN cexp co
    wceq cN cn0 wcel cA crp wcel cA clog cfv ce cfv cA cN cexp cA reeflog
    opreq1d adantr eqtrd fveq2d cA crp wcel cN cn0 wcel wa cN cA clog cfv cmul
    co cr wcel cN cA clog cfv cmul co ce cfv clog cfv cN cA clog cfv cmul co
    wceq cA clog cfv cr wcel cN cr wcel cN cA clog cfv cmul co cr wcel cA crp
    wcel cN cn0 wcel cN cr wcel cA clog cfv cr wcel cN cA clog cfv cmul co cr
    wcel cN cA clog cfv remulcl ancoms cA relogcl cN nn0re syl2an cN cA clog
    cfv cmul co relogef syl eqtr3d $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  $( The natural logarithm function on positive reals determines an isomorphism
     from the positive reals onto the reals.  (Contributed by Steve Rodriguez,
     25-Nov-2007.)  $)
  relogiso $p |- ( log |` RR+ ) Isom < , < ( RR+ , RR ) $=
    crp cr clt clt clog crp cres wiso crp cr clt clt ce cr cres ccnv wiso cr
    crp clt clt ce cr cres wiso crp cr clt clt ce cr cres ccnv wiso reefiso cr
    crp clt clt ce cr cres isocnv ax-mp clog crp cres ce cr cres ccnv wceq crp
    cr clt clt clog crp cres wiso crp cr clt clt ce cr cres ccnv wiso wb
    dfrelog crp cr clt clt ce cr cres ccnv clog crp cres isoeq1 ax-mp mpbir $.
    $( [21-Apr-2008] $) $( [25-Nov-2007] $)

  ${
    $d A x y $.  $d B y $.
    $( The natural logarithm function on positive reals is strictly monotonic.
       (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
    logltb $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
                    ( A < B <-> ( log ` A ) < ( log ` B ) ) ) $=
      cA crp wcel cB crp wcel wa cA cB clt wbr cA clog crp cres cfv cB clog crp
      cres cfv clt wbr cA clog cfv cB clog cfv clt wbr cA crp wcel cB crp wcel
      wa vx cv vy cv clt wbr vx cv clog crp cres cfv vy cv clog crp cres cfv
      clt wbr wb vy crp wral vx crp wral cA cB clt wbr cA clog crp cres cfv cB
      clog crp cres cfv clt wbr wb crp cr clog crp cres wf1o vx cv vy cv clt
      wbr vx cv clog crp cres cfv vy cv clog crp cres cfv clt wbr wb vy crp
      wral vx crp wral crp cr clt clt clog crp cres wiso crp cr clog crp cres
      wf1o vx cv vy cv clt wbr vx cv clog crp cres cfv vy cv clog crp cres cfv
      clt wbr wb vy crp wral vx crp wral wa relogiso vx vy crp cr clt clt clog
      crp cres df-iso mpbi pm3.27i vx cv vy cv clt wbr vx cv clog crp cres cfv
      vy cv clog crp cres cfv clt wbr wb cA cB clt wbr cA clog crp cres cfv cB
      clog crp cres cfv clt wbr wb cA vy cv clt wbr cA clog crp cres cfv vy cv
      clog crp cres cfv clt wbr wb vx vy cA cB crp crp vx cv cA wceq vx cv vy
      cv clt wbr cA vy cv clt wbr vx cv clog crp cres cfv vy cv clog crp cres
      cfv clt wbr cA clog crp cres cfv vy cv clog crp cres cfv clt wbr vx cv cA
      vy cv clt breq1 vx cv cA wceq vx cv clog crp cres cfv cA clog crp cres
      cfv vy cv clog crp cres cfv clt vx cv cA clog crp cres fveq2 breq1d
      bibi12d vy cv cB wceq cA vy cv clt wbr cA cB clt wbr cA clog crp cres cfv
      vy cv clog crp cres cfv clt wbr cA clog crp cres cfv cB clog crp cres cfv
      clt wbr vy cv cB cA clt breq2 vy cv cB wceq vy cv clog crp cres cfv cB
      clog crp cres cfv cA clog crp cres cfv clt vy cv cB clog crp cres fveq2
      breq2d bibi12d rcla42v mpi cA crp wcel cB crp wcel cA clog crp cres cfv
      cA clog cfv cB clog crp cres cfv cB clog cfv clt cA crp clog fvres cB crp
      clog fvres breqan12d bitrd $.
      $( [21-Apr-2008] $) $( [25-Nov-2007] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
          ZFC Set Theory plus the Tarksi-Grothendieck Axiom
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Introduce the Tarksi-Grothendieck Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u f $.
    $( The Tarksi-Grothendieck Axiom.  For every set ` x ` there is an
       inaccessible cardinal ` y ` such that ` y ` is not in ` x ` . The
       addition of this axiom to ZFC set theory provides a framework for
       category theory, thus for all practical purposes giving us a complete
       foundation for "all of mathematics."  This version of the axiom is used
       by the Mizar project ( ~ http://www.mizar.org/JFM/Axiomatics/tarski.html
       ). Unlike the ZFC axioms, this axiom is very long when expressed in
       terms of primitive symbols - see ~ grothprim . An open problem is
       finding a shorter equivalent. $)
    ax-groth $a |- E. y ( x e. y /\ A. z e. y ( A. w ( w C_ z -> w e. y ) /\
                       E. w e. y A. v ( v C_ z -> v e. w ) ) /\
                     A. z ( z C_ y -> ( z ~~ y \/ z e. y ) ) ) $.

    $( The Tarski-Grothendieck axiom using abbreviations. $)
    axgroth5 $p |- E. y ( x e. y /\ A. z e. y ( ~P z C_ y
             /\ E. w e. y ~P z C_ w ) /\ A. z e. ~P y ( z ~~ y \/ z e. y ) ) $=
      vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa
      vz vy cv wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral
      w3a vy wex vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv
      cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz
      cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal w3a vy wex
      vx vy vz vw vv ax-groth vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw
      cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv vy cv
      wcel wo vz vy cv cpw wral w3a vx cv vy cv wcel vw cv vz cv wss vw cv vy
      cv wcel wi vw wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv
      wrex wa vz vy cv wral vz cv vy cv wss vz cv vy cv cen wbr vz cv vy cv
      wcel wo wi vz wal w3a vy vx cv vy cv wcel vx cv vy cv wcel vz cv cpw vy
      cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vw cv vz cv wss
      vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw
      vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy
      cv cpw wral vz cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz
      wal vx cv vy cv wcel biid vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy
      cv wrex wa vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv
      cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv vz cv cpw vy cv wss vw
      cv vz cv wss vw cv vy cv wcel wi vw wal vz cv cpw vw cv wss vw vy cv wrex
      vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex vw vz cv vy cv
      pwss vz cv cpw vw cv wss vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy
      cv vv vz cv vw cv pwss rexbii anbi12i ralbii vz cv vy cv cen wbr vz cv vy
      cv wcel wo vz vy cv cpw wral vz cv vy cv cpw wcel vz cv vy cv cen wbr vz
      cv vy cv wcel wo wi vz wal vz cv vy cv wss vz cv vy cv cen wbr vz cv vy
      cv wcel wo wi vz wal vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw
      df-ral vz cv vy cv cpw wcel vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz
      cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz vz cv vy cv
      cpw wcel vz cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo vz cv vy
      cv vz visset elpw imbi1i albii bitri 3anbi123i exbii mpbir $.
      $( [24-Jun-2009] $) $( [22-Jun-2009] $)

    $( Alternate version of the Tarksi-Grothendieck Axiom. $)
    axgroth2 $p |- E. y ( x e. y /\ A. z e. y ( A. w ( w C_ z -> w e. y ) /\
                       E. w e. y A. v ( v C_ z -> v e. w ) ) /\
                     A. z ( z C_ y -> ( y ~<_ z \/ z e. y ) ) ) $=
      vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv
      wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv
      wss vy cv vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vy wex vx cv
      vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv
      cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vz
      cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal w3a vy wex vx vy vz vw vv
      ax-groth vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv
      cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz
      cv vy cv wss vy cv vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vx cv
      vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv
      cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vz
      cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal w3a vy vz cv vy cv wss vy
      cv vz cv cdom wbr vz cv vy cv wcel wo wi vz wal vz cv vy cv wss vz cv vy
      cv cen wbr vz cv vy cv wcel wo wi vz wal vx cv vy cv wcel vw cv vz cv wss
      vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw
      vy cv wrex wa vz vy cv wral vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy
      cv wcel wo wi vz cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo wi
      vz vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy cv wcel wo vz cv vy cv
      cen wbr vz cv vy cv wcel wo vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy
      cv cen wbr vz cv vy cv wcel vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy
      cv cdom wbr vy cv vz cv cdom wbr wa vz cv vy cv cen wbr vz cv vy cv wss
      vz cv vy cv cdom wbr vy cv vz cv cdom wbr vz cv cvv wcel vz cv vy cv wss
      vz cv vy cv cdom wbr wi vz visset vz cv vy cv cvv ssdomg ax-mp biantrurd
      vy cv cvv wcel vz cv vy cv cdom wbr vy cv vz cv cdom wbr wa vz cv vy cv
      cen wbr wb vy visset vz cv vy cv cvv sbthbg ax-mp syl6bb orbi1d pm5.74i
      albii 3anbi3i exbii mpbir $.
      $( [25-Mar-2007] $) $( [18-Mar-2007] $)

    $( Derive the Axiom of Power Sets ~ ax-pow from the Tarksi-Grothendieck
       axiom ~ ax-groth .  That it follows is mentioned by Bob Solovay at
       ~ http://www.cs.nyu.edu/pipermail/fom/2008-March/012783.html .
       Note that ~ ax-pow is not used by the proof.  (Contributed by
       G&eacute;rard Lang, 22-Jun-2009.) $)
    grothpw $p |- E. y A. z ( A. w ( w e. z -> w e. x ) -> z e. y ) $=
      vx cv cpw cvv wcel vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy
      cv wcel wi vz wal vy wex vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw
      vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv vy cv
      wcel wo vz vy cv cpw wral w3a vy wex vx cv cpw cvv wcel vx cv vy cv wcel
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz
      cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral w3a vy wex vx cv
      vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv
      cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vz
      cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal w3a vy wex vx vy vz vw vv
      ax-groth vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy
      cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv
      cpw wral w3a vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal
      vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral
      vz cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal w3a vy
      vx cv vy cv wcel vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv wss
      vw vy cv wrex wa vz vy cv wral vw cv vz cv wss vw cv vy cv wcel wi vw wal
      vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral
      vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral vz cv vy cv wss
      vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal vx cv vy cv wcel biid
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vw cv vz cv wss
      vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw
      vy cv wrex wa vz vy cv vz cv cpw vy cv wss vw cv vz cv wss vw cv vy cv
      wcel wi vw wal vz cv cpw vw cv wss vw vy cv wrex vv cv vz cv wss vv cv vw
      cv wcel wi vv wal vw vy cv wrex vz cv cpw vy cv wss vw cv vz cv cpw wcel
      vw cv vy cv wcel wi vw wal vw cv vz cv wss vw cv vy cv wcel wi vw wal vw
      vz cv cpw vy cv dfss2 vw cv vz cv cpw wcel vw cv vy cv wcel wi vw cv vz
      cv wss vw cv vy cv wcel wi vw vw cv vz cv cpw wcel vw cv vz cv wss vw cv
      vy cv wcel vw cv vz cv wss vw vz cv cpw vw vz cv df-pw abeq2i imbi1i
      albii bitri vz cv cpw vw cv wss vv cv vz cv wss vv cv vw cv wcel wi vv
      wal vw vy cv vz cv cpw vw cv wss vv cv vz cv cpw wcel vv cv vw cv wcel wi
      vv wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vv vz cv cpw vw cv
      dfss2 vv cv vz cv cpw wcel vv cv vw cv wcel wi vv cv vz cv wss vv cv vw
      cv wcel wi vv vv cv vz cv cpw wcel vv cv vz cv wss vv cv vw cv wcel vv cv
      vz cv wss vv vz cv cpw vv vz cv df-pw abeq2i imbi1i albii bitri rexbii
      anbi12i ralbii vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral
      vz cv vy cv cpw wcel vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal vz
      cv vy cv wss vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz wal vz cv vy
      cv cen wbr vz cv vy cv wcel wo vz vy cv cpw df-ral vz cv vy cv cpw wcel
      vz cv vy cv cen wbr vz cv vy cv wcel wo wi vz cv vy cv wss vz cv vy cv
      cen wbr vz cv vy cv wcel wo wi vz vz cv vy cv cpw wcel vz cv vy cv wss vz
      cv vy cv cen wbr vz cv vy cv wcel wo vz cv vy cv vz visset elpw imbi1i
      albii bitri 3anbi123i exbii mpbir vx cv vy cv wcel vz cv cpw vy cv wss vz
      cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv
      vy cv wcel wo vz vy cv cpw wral w3a vx cv cpw cvv wcel vy vx cv vy cv
      wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv
      wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral w3a vx cv
      vy cv wcel vx cv vy cv wcel vx cv cpw vy cv wss wi wa vx cv cpw vy cv wss
      vx cv cpw cvv wcel vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv
      wss vw vy cv wrex wa vz vy cv wral vx cv vy cv wcel vx cv vy cv wcel vx
      cv cpw vy cv wss wi wa vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv
      cpw wral vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy
      cv wral vx cv vy cv wcel vx cv cpw vy cv wss wi vx cv vy cv wcel vz cv
      cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv
      cpw vy cv wss vz vy cv wral vx cv vy cv wcel vx cv cpw vy cv wss wi vz cv
      cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz cv cpw vy cv wss vz
      vy cv vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex pm3.26
      r19.20si vz cv cpw vy cv wss vx cv cpw vy cv wss vz vx cv vy cv vz cv vx
      cv wceq vz cv cpw vx cv cpw vy cv vz cv vx cv pweq sseq1d rcla4cv syl
      anim2i 3adant3 vx cv vy cv wcel vx cv cpw vy cv wss pm3.35 vx cv cpw vy
      cv vy visset ssex 3syl 19.23aiv ax-mp vx cv cpw cvv wcel vx cv cpw vy cv
      cpw wcel vy wex vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy cv
      wcel wi vz wal vy wex vx cv cpw cvv wcel vx cv cpw vy cv cpw wcel vy wex
      vx cv cpw cvv wcel vx cv cpw vx cv cpw cpw wcel vx cv cpw vy cv cpw wcel
      vy wex vx cv cpw cvv wcel vx cv cpw vx cv cpw cpw wcel vx cv cpw vx cv
      cpw wss vx cv cpw ssid vx cv cpw vx cv cpw cvv elpwg mpbiri vx cv cpw vy
      cv cpw wcel vx cv cpw vx cv cpw cpw wcel vy vx cv cpw cvv vy cv vx cv cpw
      wceq vy cv cpw vx cv cpw cpw vx cv cpw vy cv vx cv cpw pweq eleq2d
      cla4egv mpd vx cv cpw vy cv cpw wcel vx cv cpw cvv wcel vy vx cv cpw vy
      cv cpw elisset 19.23aiv impbii vx cv cpw vy cv cpw wcel vw cv vz cv wcel
      vw cv vx cv wcel wi vw wal vz cv vy cv wcel wi vz wal vy vx cv cpw vy cv
      cpw wcel vx cv cpw vy cv wss vz cv vx cv wss vz cv vy cv wcel wi vz wal
      vw cv vz cv wcel vw cv vx cv wcel wi vw wal vz cv vy cv wcel wi vz wal vx
      cv cpw vy cv vy visset elpw2 vx cv cpw vy cv wss vz cv vx cv cpw wcel vz
      cv vy cv wcel wi vz wal vz cv vx cv wss vz cv vy cv wcel wi vz wal vz vx
      cv cpw vy cv dfss2 vz cv vx cv cpw wcel vz cv vy cv wcel wi vz cv vx cv
      wss vz cv vy cv wcel wi vz vz cv vx cv cpw wcel vz cv vx cv wss vz cv vy
      cv wcel vz cv vx cv wss vz vx cv cpw vz vx cv df-pw abeq2i imbi1i albii
      bitri vz cv vx cv wss vz cv vy cv wcel wi vw cv vz cv wcel vw cv vx cv
      wcel wi vw wal vz cv vy cv wcel wi vz vz cv vx cv wss vw cv vz cv wcel vw
      cv vx cv wcel wi vw wal vz cv vy cv wcel vw vz cv vx cv dfss2 imbi1i
      albii 3bitri exbii bitri mpbi $.
      $( [22-Jun-2009] $) $( [22-Jun-2009] $)

    $( Derive the Axiom of Power Sets from the Tarksi-Grothendieck axiom
       ~ ax-groth .  Note that ~ ax-pow is not used by the proof.  Use ~ axpweq
       to obtain ~ ax-pow . $)
    grothpwex $p |- ~P x e. _V $=
      vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa
      vz vy cv wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral
      w3a vy wex vx cv cpw cvv wcel vx vy vz vw axgroth5 vx cv vy cv wcel vz cv
      cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy
      cv cen wbr vz cv vy cv wcel wo vz vy cv cpw wral w3a vx cv cpw cvv wcel
      vy vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex
      wa vz vy cv wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv cpw
      wral w3a vx cv vy cv wcel vx cv vy cv wcel vx cv cpw vy cv wss wi wa vx
      cv cpw vy cv wss vx cv cpw cvv wcel vx cv vy cv wcel vz cv cpw vy cv wss
      vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vx cv vy cv wcel vx cv
      vy cv wcel vx cv cpw vy cv wss wi wa vz cv vy cv cen wbr vz cv vy cv wcel
      wo vz vy cv cpw wral vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv
      wrex wa vz vy cv wral vx cv vy cv wcel vx cv cpw vy cv wss wi vx cv vy cv
      wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv
      wral vz cv cpw vy cv wss vz vy cv wral vx cv vy cv wcel vx cv cpw vy cv
      wss wi vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz cv cpw
      vy cv wss vz vy cv vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex
      pm3.26 r19.20si vz cv cpw vy cv wss vx cv cpw vy cv wss vz vx cv vy cv vz
      cv vx cv wceq vz cv cpw vx cv cpw vy cv vz cv vx cv pweq sseq1d rcla4cv
      syl anim2i 3adant3 vx cv vy cv wcel vx cv cpw vy cv wss pm3.35 vx cv cpw
      vy cv vy visset ssex 3syl 19.23aiv ax-mp $.
      $( [16-Jan-2011] $) $( [22-Jun-2009] $)

    $( The Tarksi-Grothendieck Axiom implies the Axiom of Infinity (in the form
       of ~ omex ).  Note that our proof does not depend on the Axiom of
       Infinity. $)
    grothomex $p |- om e. _V $=
      vy vy vx vz vx cv vy cv wcel vz cv vw cv wss vz cv vy cv wcel wi vz wal
      vv cv vw cv wss vv cv vz cv wcel wi vv wal vz vy cv wrex wa vw vy cv wral
      vw cv vy cv wss vw cv vy cv cen wbr vw cv vy cv wcel wo wi vw wal w3a vy
      wex vx cv vy cv wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wcel
      wa vz wex wi vx wal wa vy wex vx vy vw vz vv ax-groth vx cv vy cv wcel vz
      cv vw cv wss vz cv vy cv wcel wi vz wal vv cv vw cv wss vv cv vz cv wcel
      wi vv wal vz vy cv wrex wa vw vy cv wral vw cv vy cv wss vw cv vy cv cen
      wbr vw cv vy cv wcel wo wi vw wal w3a vx cv vy cv wcel vx cv vy cv wcel
      vx cv vz cv wcel vz cv vy cv wcel wa vz wex wi vx wal wa vy vx cv vy cv
      wcel vz cv vw cv wss vz cv vy cv wcel wi vz wal vv cv vw cv wss vv cv vz
      cv wcel wi vv wal vz vy cv wrex wa vw vy cv wral vx cv vy cv wcel vx cv
      vy cv wcel vx cv vz cv wcel vz cv vy cv wcel wa vz wex wi vx wal wa vw cv
      vy cv wss vw cv vy cv cen wbr vw cv vy cv wcel wo wi vw wal vz cv vw cv
      wss vz cv vy cv wcel wi vz wal vv cv vw cv wss vv cv vz cv wcel wi vv wal
      vz vy cv wrex wa vw vy cv wral vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wcel wa vz wex wi vx wal vx cv vy cv wcel vz cv vw cv wss vz cv vy cv
      wcel wi vz wal vv cv vw cv wss vv cv vz cv wcel wi vv wal vz vy cv wrex
      wa vw vy cv wral vw cv vz cv wcel vz vy cv wrex vw vy cv wral vx cv vy cv
      wcel vx cv vz cv wcel vz cv vy cv wcel wa vz wex wi vx wal vz cv vw cv
      wss vz cv vy cv wcel wi vz wal vv cv vw cv wss vv cv vz cv wcel wi vv wal
      vz vy cv wrex wa vw cv vz cv wcel vz vy cv wrex vw vy cv vv cv vw cv wss
      vv cv vz cv wcel wi vv wal vz vy cv wrex vw cv vz cv wcel vz vy cv wrex
      vz cv vw cv wss vz cv vy cv wcel wi vz wal vv cv vw cv wss vv cv vz cv
      wcel wi vv wal vw cv vz cv wcel vz vy cv vv cv vw cv wss vv cv vz cv wcel
      wi vv wal vw cv vw cv wss vw cv vz cv wcel vw cv ssid vv cv vw cv wss vv
      cv vz cv wcel wi vw cv vw cv wss vw cv vz cv wcel wi vv vw vv cv vw cv
      wceq vv cv vw cv wss vw cv vw cv wss vv cv vz cv wcel vw cv vz cv wcel vv
      cv vw cv vw cv sseq1 vv vw vz elequ1 imbi12d a4v mpi r19.22si adantl
      r19.20si vw cv vz cv wcel vz vy cv wrex vw vy cv wral vx cv vz cv wcel vz
      cv vy cv wcel wa vz wex vx vy cv wral vx cv vy cv wcel vx cv vz cv wcel
      vz cv vy cv wcel wa vz wex wi vx wal vw cv vz cv wcel vz vy cv wrex vx cv
      vz cv wcel vz cv vy cv wcel wa vz wex vw vx vy cv vw cv vx cv wceq vw cv
      vz cv wcel vz vy cv wrex vx cv vz cv wcel vz vy cv wrex vx cv vz cv wcel
      vz cv vy cv wcel wa vz wex vw cv vx cv wceq vw cv vz cv wcel vx cv vz cv
      wcel vz vy cv vw vx vz elequ1 rexbidv vx cv vz cv wcel vz vy cv wrex vz
      cv vy cv wcel vx cv vz cv wcel wa vz wex vx cv vz cv wcel vz cv vy cv
      wcel wa vz wex vx cv vz cv wcel vz vy cv df-rex vz cv vy cv wcel vx cv vz
      cv wcel vz exancom bitri syl6bb cbvralv vx cv vz cv wcel vz cv vy cv wcel
      wa vz wex vx vy cv df-ral bitri sylib anim2i 3adant3 19.22i ax-mp inf2
      inf3 $.
      $( [24-Mar-2007] $) $( [23-Mar-2007] $)

    $( The Tarski-Grothendieck axiom using abbreviations.  This version is
       called Tarski's axiom: given a set ` x ` , there exists a set ` y `
       containing ` x ` , the subsets of the members of ` y ` , the power sets
       of the members of ` y ` , and the subsets of ` y ` of cardinality
       less than that of ` y ` . $)
    axgroth6 $p |- E. y ( x e. y /\ A. z e. y ( ~P z C_ y /\ ~P z e. y )
                   /\ A. z e. ~P y ( z ~< y -> z e. y ) ) $=
      vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv
      wral vz cv vy cv csdm wbr vz cv vy cv wcel wi vz vy cv cpw wral w3a vy
      wex vx cv vy cv wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv
      wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv vy cv wcel wo vz vy cv
      cpw wral w3a vy wex vx vy vz vw axgroth5 vx cv vy cv wcel vz cv cpw vy cv
      wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv vy cv csdm wbr vz cv vy
      cv wcel wi vz vy cv cpw wral w3a vx cv vy cv wcel vz cv cpw vy cv wss vz
      cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz cv
      vy cv wcel wo vz vy cv cpw wral w3a vy vx cv vy cv wcel vx cv vy cv wcel
      vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv cpw vy cv
      wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv csdm
      wbr vz cv vy cv wcel wi vz vy cv cpw wral vz cv vy cv cen wbr vz cv vy cv
      wcel wo vz vy cv cpw wral vx cv vy cv wcel biid vz cv cpw vy cv wss vz vy
      cv wral vz cv cpw vy cv wcel vz vy cv wral wa vz cv cpw vy cv wss vz vy
      cv wral vz cv cpw vw cv wss vw vy cv wrex vz vy cv wral wa vz cv cpw vy
      cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv cpw vy cv wss vz cv
      cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv cpw vy cv wss vz vy cv
      wral vz cv cpw vy cv wcel vz vy cv wral vz cv cpw vw cv wss vw vy cv wrex
      vz vy cv wral vz cv cpw vy cv wss vz vy cv wral vv cv cpw vy cv wss vv vy
      cv wral vz cv cpw vy cv wcel vz vy cv wral vz cv cpw vw cv wss vw vy cv
      wrex vz vy cv wral wb vz cv cpw vy cv wss vv cv cpw vy cv wss vz vv vy cv
      vz cv vv cv wceq vz cv cpw vv cv cpw vy cv vz cv vv cv pweq sseq1d
      cbvralv vv cv cpw vy cv wss vv vy cv wral vz cv cpw vy cv wcel vz cv cpw
      vw cv wss vw vy cv wrex vz vy cv vv cv cpw vy cv wss vv vy cv wral vz cv
      cpw vy cv wcel vz cv cpw vw cv wss vw vy cv wrex vz cv cpw vy cv wcel vz
      cv cpw vz cv cpw wss vz cv cpw vw cv wss vw vy cv wrex vz cv cpw ssid vz
      cv cpw vw cv wss vz cv cpw vz cv cpw wss vw vz cv cpw vy cv vw cv vz cv
      cpw vz cv cpw sseq2 rcla4ev mpan2 vv cv cpw vy cv wss vv vy cv wral vz cv
      cpw vw cv wss vz cv cpw vy cv wcel vw vy cv vv cv cpw vy cv wss vv vy cv
      wral vw cv vy cv wcel vw cv cpw vy cv wss vz cv cpw vw cv wss vz cv cpw
      vy cv wcel wi vv cv cpw vy cv wss vw cv cpw vy cv wss vv vw cv vy cv vv
      cv vw cv wceq vv cv cpw vw cv cpw vy cv vv cv vw cv pweq sseq1d rcla4cv
      vw cv cpw vy cv wss vv cv vw cv wss vv cv vy cv wcel wi vv wal vz cv cpw
      vw cv wss vz cv cpw vy cv wcel wi vv vw cv vy cv pwss vv cv vw cv wss vv
      cv vy cv wcel wi vz cv cpw vw cv wss vz cv cpw vy cv wcel wi vv vz cv cpw
      vz cv vz visset pwex vv cv vz cv cpw wceq vv cv vw cv wss vz cv cpw vw cv
      wss vv cv vy cv wcel vz cv cpw vy cv wcel vv cv vz cv cpw vw cv sseq1 vv
      cv vz cv cpw vy cv eleq1 imbi12d cla4v sylbi syl6 r19.23adv impbid2
      ralbidv sylbi pm5.32i vz cv cpw vy cv wss vz cv cpw vy cv wcel vz vy cv
      r19.26 vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex vz vy cv
      r19.26 3bitr4i vz cv vy cv csdm wbr vz cv vy cv wcel wi vz cv vy cv cen
      wbr vz cv vy cv wcel wo vz vy cv cpw vz cv vy cv cpw wcel vz cv vy cv wss
      vz cv vy cv csdm wbr vz cv vy cv wcel wi vz cv vy cv cen wbr vz cv vy cv
      wcel wo wb vz cv vy cv vz visset elpw vz cv vy cv wss vz cv vy cv csdm
      wbr vz cv vy cv wcel wi vz cv vy cv cen wbr wn vz cv vy cv wcel wi vz cv
      vy cv cen wbr vz cv vy cv wcel wo vz cv vy cv wss vz cv vy cv csdm wbr vz
      cv vy cv wcel wi vz cv vy cv cen wbr wn vz cv vy cv wcel wi vz cv vy cv
      wss vz cv vy cv cdom wbr wa vz cv vy cv cen wbr wn vz cv vy cv wcel wi wi
      vz cv vy cv wss vz cv vy cv cdom wbr vz cv vy cv cen wbr wn vz cv vy cv
      wcel wi wi wi vz cv vy cv wss vz cv vy cv cen wbr wn vz cv vy cv wcel wi
      wi vz cv vy cv wss vz cv vy cv csdm wbr vz cv vy cv wcel wi wi vz cv vy
      cv wss vz cv vy cv cdom wbr vz cv vy cv cen wbr wn vz cv vy cv wcel wi
      impexp vz cv vy cv wss vz cv vy cv wss vz cv vy cv cdom wbr wa vz cv vy
      cv cen wbr wn vz cv vy cv wcel wi vz cv vy cv wss vz cv vy cv cdom wbr vz
      cv cvv wcel vz cv vy cv wss vz cv vy cv cdom wbr wi vz visset vz cv vy cv
      cvv ssdomg ax-mp pm4.71i imbi1i vz cv vy cv csdm wbr vz cv vy cv wcel wi
      vz cv vy cv cdom wbr vz cv vy cv cen wbr wn vz cv vy cv wcel wi wi vz cv
      vy cv wss vz cv vy cv csdm wbr vz cv vy cv wcel wi vz cv vy cv cdom wbr
      vz cv vy cv cen wbr wn wa vz cv vy cv wcel wi vz cv vy cv cdom wbr vz cv
      vy cv cen wbr wn vz cv vy cv wcel wi wi vz cv vy cv csdm wbr vz cv vy cv
      cdom wbr vz cv vy cv cen wbr wn wa vz cv vy cv wcel vz cv vy cv brsdom
      imbi1i vz cv vy cv cdom wbr vz cv vy cv cen wbr wn vz cv vy cv wcel
      impexp bitri imbi2i 3bitr4ri pm5.74ri vz cv vy cv cen wbr vz cv vy cv
      wcel pm4.64 syl6bb sylbi ralbiia 3anbi123i exbii mpbir $.
      $( [16-Jan-2011] $) $( [21-Jun-2009] $)

    $( Alternate version of the Tarksi-Grothendieck Axiom.  ~ ax-ac is used to
       derive this version. $)
    axgroth3 $p |- E. y ( x e. y /\ A. z e. y ( A. w ( w C_ z -> w e. y ) /\
                       E. w e. y A. v ( v C_ z -> v e. w ) ) /\
                     A. z ( z C_ y -> ( ( y \ z ) ~<_ z \/ z e. y ) ) ) $=
      vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv
      wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv
      wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vy
      wex vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz
      cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy
      cv wss vy cv vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vy wex vx
      vy vz vw vv axgroth2 vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi
      vw wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy
      cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel
      wo wi vz wal w3a vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw
      wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv
      wral vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy cv wcel wo wi vz wal
      w3a vy vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv
      vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral wa vz
      cv vy cv wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz
      wal wa vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv
      vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral wa vz
      cv vy cv wss vy cv vz cv cdom wbr vz cv vy cv wcel wo wi vz wal wa vx cv
      vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv
      cv vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vy
      cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vx cv vy
      cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv
      vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vy cv
      vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vx cv vy cv wcel vw cv
      vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv wcel wi
      vv wal vw vy cv wrex wa vz vy cv wral wa vz cv vy cv wss vy cv vz cv cdif
      vz cv cdom wbr vz cv vy cv wcel wo wi vz wal vz cv vy cv wss vy cv vz cv
      cdom wbr vz cv vy cv wcel wo wi vz wal vx cv vy cv wcel vy cv vy cv cuni
      wss vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo
      wi vz wal vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy cv wcel wo wi vz
      wal wb vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv
      vw cv wcel wi vv wal vw vy cv wrex wa vz vy cv wral vx cv vy cv wcel vy
      cv vy cv cuni wss wa vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr vz
      cv vy cv wcel wo wi vz cv vy cv wss vy cv vz cv cdom wbr vz cv vy cv wcel
      wo wi vz vx cv vy cv wcel vy cv vy cv cuni wss wa vy cv vz cv cdif vz cv
      cdom wbr vz cv vy cv wcel wo vy cv vz cv cdom wbr vz cv vy cv wcel wo vz
      cv vy cv wss vx cv vy cv wcel vy cv vy cv cuni wss wa vy cv vz cv cdif vz
      cv cdom wbr vy cv vz cv cdom wbr vz cv vy cv wcel vx cv vy cv wcel vy cv
      vy cv cuni wss wa com vy cv cdom wbr vy cv vz cv cdif vz cv cdom wbr vy
      cv vz cv cdom wbr wb vy cv c0 wne vy cv vy cv cuni wss com vy cv cdom wbr
      vx cv vy cv wcel vy cv vy visset dominf vy cv vx cv ne0i sylan vy cv vz
      cv vy visset vz visset infdif2 syl orbi1d imbi2d albidv vw cv vz cv wss
      vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv wcel wi vv wal vw
      vy cv wrex wa vz vy cv wral vz cv vy cv cuni wcel vz vy cv wral vy cv vy
      cv cuni wss vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv
      cv vw cv wcel wi vv wal vw vy cv wrex wa vz cv vy cv cuni wcel vz vy cv
      vv cv vz cv wss vv cv vw cv wcel wi vv wal vw vy cv wrex vz cv vy cv cuni
      wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw
      cv wcel wi vv wal vw vy cv wrex vz cv vw cv wcel vw vy cv wrex vz cv vy
      cv cuni wcel vv cv vz cv wss vv cv vw cv wcel wi vv wal vz cv vw cv wcel
      vw vy cv vv cv vz cv wss vv cv vw cv wcel wi vv wal vz cv vz cv wss vz cv
      vw cv wcel vz cv ssid vv cv vz cv wss vv cv vw cv wcel wi vz cv vz cv wss
      vz cv vw cv wcel wi vv vz vv cv vz cv wceq vv cv vz cv wss vz cv vz cv
      wss vv cv vw cv wcel vz cv vw cv wcel vv cv vz cv vz cv sseq1 vv vz vw
      elequ1 imbi12d a4v mpi r19.22si vw vz cv vy cv eluni2 sylibr adantl
      r19.20si vz vy cv vy cv cuni dfss3 sylibr sylan2 pm5.32i vx cv vy cv wcel
      vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv
      wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vy cv vz cv
      cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal df-3an vx cv vy cv wcel
      vw cv vz cv wss vw cv vy cv wcel wi vw wal vv cv vz cv wss vv cv vw cv
      wcel wi vv wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss vy cv vz cv
      cdom wbr vz cv vy cv wcel wo wi vz wal df-3an 3bitr4i exbii mpbir $.
      $( [31-Mar-2007] $) $( [26-Mar-2007] $)

    $( Alternate version of the Tarksi-Grothendieck Axiom.  ~ ax-ac is used to
       derive this version. $)
    axgroth4 $p |- E. y ( x e. y /\ A. z e. y E. v e. y A. w ( w C_ z ->
    w e. ( y i^i v ) ) /\ A. z ( z C_ y -> ( ( y \ z ) ~<_ z \/ z e. y ) ) ) $=
      vx cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vu cv vz cv
      wss vu cv vw cv wcel wi vu wal vw vy cv wrex wa vz vy cv wral vz cv vy cv
      wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vy
      wex vx cv vy cv wcel vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal
      vv vy cv wrex vz vy cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom
      wbr vz cv vy cv wcel wo wi vz wal w3a vy wex vx vy vz vw vu axgroth3 vx
      cv vy cv wcel vw cv vz cv wss vw cv vy cv wcel wi vw wal vu cv vz cv wss
      vu cv vw cv wcel wi vu wal vw vy cv wrex wa vz vy cv wral vz cv vy cv wss
      vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vx cv
      vy cv wcel vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv vy cv
      wrex vz vy cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr vz cv
      vy cv wcel wo wi vz wal w3a vy vw cv vz cv wss vw cv vy cv wcel wi vw wal
      vu cv vz cv wss vu cv vw cv wcel wi vu wal vw vy cv wrex wa vz vy cv wral
      vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv vy cv wrex vz vy
      cv wral vx cv vy cv wcel vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr
      vz cv vy cv wcel wo wi vz wal vw cv vz cv wss vw cv vy cv wcel wi vw wal
      vu cv vz cv wss vu cv vw cv wcel wi vu wal vw vy cv wrex wa vw cv vz cv
      wss vw cv vy cv vv cv cin wcel wi vw wal vv vy cv wrex vz vy cv vw cv vz
      cv wss vw cv vy cv wcel wi vw wal vu cv vz cv wss vu cv vw cv wcel wi vu
      wal vw vy cv wrex wa vw cv vz cv wss vw cv vy cv wcel wi vw wal vu cv vz
      cv wss vu cv vv cv wcel wi vu wal vv vy cv wrex wa vw cv vz cv wss vw cv
      vy cv wcel wi vw wal vu cv vz cv wss vu cv vv cv wcel wi vu wal wa vv vy
      cv wrex vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv vy cv
      wrex vu cv vz cv wss vu cv vw cv wcel wi vu wal vw vy cv wrex vu cv vz cv
      wss vu cv vv cv wcel wi vu wal vv vy cv wrex vw cv vz cv wss vw cv vy cv
      wcel wi vw wal vu cv vz cv wss vu cv vw cv wcel wi vu wal vu cv vz cv wss
      vu cv vv cv wcel wi vu wal vw vv vy cv vw cv vv cv wceq vu cv vz cv wss
      vu cv vw cv wcel wi vu cv vz cv wss vu cv vv cv wcel wi vu vw cv vv cv
      wceq vu cv vw cv wcel vu cv vv cv wcel vu cv vz cv wss vw vv vu elequ2
      imbi2d albidv cbvrexv anbi2i vw cv vz cv wss vw cv vy cv wcel wi vw wal
      vu cv vz cv wss vu cv vv cv wcel wi vu wal vv vy cv r19.42v vw cv vz cv
      wss vw cv vy cv wcel wi vw wal vu cv vz cv wss vu cv vv cv wcel wi vu wal
      wa vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv vy cv vw cv vz
      cv wss vw cv vy cv wcel wi vw wal vu cv vz cv wss vu cv vv cv wcel wi vu
      wal wa vw cv vz cv wss vw cv vy cv wcel wi vw wal vw cv vz cv wss vw cv
      vv cv wcel wi vw wal wa vw cv vz cv wss vw cv vy cv wcel wi vw cv vz cv
      wss vw cv vv cv wcel wi wa vw wal vw cv vz cv wss vw cv vy cv vv cv cin
      wcel wi vw wal vu cv vz cv wss vu cv vv cv wcel wi vu wal vw cv vz cv wss
      vw cv vv cv wcel wi vw wal vw cv vz cv wss vw cv vy cv wcel wi vw wal vu
      cv vz cv wss vu cv vv cv wcel wi vw cv vz cv wss vw cv vv cv wcel wi vu
      vw vu cv vw cv wceq vu cv vz cv wss vw cv vz cv wss vu cv vv cv wcel vw
      cv vv cv wcel vu cv vw cv vz cv sseq1 vu vw vv elequ1 imbi12d cbvalv
      anbi2i vw cv vz cv wss vw cv vy cv wcel wi vw cv vz cv wss vw cv vv cv
      wcel wi vw 19.26 vw cv vz cv wss vw cv vy cv wcel wi vw cv vz cv wss vw
      cv vv cv wcel wi wa vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw vw
      cv vz cv wss vw cv vy cv wcel wi vw cv vz cv wss vw cv vv cv wcel wi wa
      vw cv vz cv wss vw cv vy cv wcel vw cv vv cv wcel wa wi vw cv vz cv wss
      vw cv vy cv vv cv cin wcel wi vw cv vz cv wss vw cv vy cv wcel vw cv vv
      cv wcel pm4.76 vw cv vy cv vv cv cin wcel vw cv vy cv wcel vw cv vv cv
      wcel wa vw cv vz cv wss vw cv vy cv vv cv elin imbi2i bitr4i albii
      3bitr2i rexbii 3bitr2i ralbii 3anbi2i exbii mpbi $.
      $( [16-Apr-2007] $) $( [16-Apr-2007] $)
  $}

  ${
    $d x y z w v u t h g f n m k j $.
    $( Lemma for ~ grothprim .  Expand the membership of an unordered pair into
       primitives. $)
    grothprimlem $p |- ( { u , v } e. w <-> E. g ( g e. w /\ A. h
      ( h e. g <-> ( h = u \/ h = v ) ) ) ) $=
      vu cv vv cv cpr vw cv wcel vh cv vu cv wceq vh cv vv cv wceq wo vh cab vw
      cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv
      wceq wo wb vh wal wa vg wex vu cv vv cv cpr vh cv vu cv wceq vh cv vv cv
      wceq wo vh cab vw cv vh vu cv vv cv dfpr2 eleq1i vh cv vu cv wceq vh cv
      vv cv wceq wo vh vg vw cv clabel bitri $.
      $( [31-Mar-2007] $) $( [29-Mar-2007] $)

    $( The Tarksi-Grothendieck Axiom ~ ax-groth expanded into set theory
       primitives using 163 symbols.  An open problem is whether a shorter
       equivalent exists (when expanded to primitives). $)
    grothprim $p |- E. y ( x e. y /\ A. z ( ( z e. y -> E. v ( v e. y /\
       A. w ( A. u ( u e. w -> u e. z ) -> ( w e. y /\ w e. v ) ) ) ) /\ E. w
      ( ( w e. z -> w e. y ) -> ( A. v ( ( v e. z -> E. t A. u ( E. g ( g e. w
      /\ A. h ( h e. g <-> ( h = v \/ h = u ) ) ) -> u = t ) ) /\ ( v e. y ->
      ( v e. z \/ E. u ( u e. z /\ E. g ( g e. w /\ A. h ( h e. g <-> ( h = u
      \/ h = v ) ) ) ) ) ) ) \/ z e. y ) ) ) ) $=
      vx cv vy cv wcel vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv
      vy cv wrex vz vy cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr
      vz cv vy cv wcel wo wi vz wal w3a vy wex vx cv vy cv wcel vz cv vy cv
      wcel vv cv vy cv wcel vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv
      vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv wex wi vw cv vz cv wcel vw
      cv vy cv wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv
      vv cv wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu
      wal vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw
      cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal
      wa vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex wa vz
      wal wa vy wex vx vy vz vw vv axgroth4 vx cv vy cv wcel vw cv vz cv wss vw
      cv vy cv vv cv cin wcel wi vw wal vv vy cv wrex vz vy cv wral vz cv vy cv
      wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a vx
      cv vy cv wcel vz cv vy cv wcel vv cv vy cv wcel vu cv vw cv wcel vu cv vz
      cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv
      wex wi vw cv vz cv wcel vw cv vy cv wcel wi vv cv vz cv wcel vg cv vw cv
      wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb vh wal wa
      vg wex vu cv vt cv wceq wi vu wal vt wex wi vv cv vy cv wcel vv cv vz cv
      wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv wceq
      vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi wa vv wal vz cv
      vy cv wcel wo wi vw wex wa vz wal wa vy vx cv vy cv wcel vw cv vz cv wss
      vw cv vy cv vv cv cin wcel wi vw wal vv vy cv wrex vz vy cv wral vz cv vy
      cv wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal w3a
      vx cv vy cv wcel vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv
      vy cv wrex vz vy cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr
      vz cv vy cv wcel wo wi vz wal wa wa vx cv vy cv wcel vz cv vy cv wcel vv
      cv vy cv wcel vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv
      wcel vw cv vv cv wcel wa wi vw wal wa vv wex wi vw cv vz cv wcel vw cv vy
      cv wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv
      wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal
      vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv
      wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa
      vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex wa vz wal
      wa vx cv vy cv wcel vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal
      vv vy cv wrex vz vy cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom
      wbr vz cv vy cv wcel wo wi vz wal 3anass vw cv vz cv wss vw cv vy cv vv
      cv cin wcel wi vw wal vv vy cv wrex vz vy cv wral vz cv vy cv wss vy cv
      vz cv cdif vz cv cdom wbr vz cv vy cv wcel wo wi vz wal wa vz cv vy cv
      wcel vv cv vy cv wcel vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv
      vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv wex wi vw cv vz cv wcel vw
      cv vy cv wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv
      vv cv wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu
      wal vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw
      cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal
      wa vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex wa vz
      wal vx cv vy cv wcel vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal
      vv vy cv wrex vz vy cv wral vz cv vy cv wss vy cv vz cv cdif vz cv cdom
      wbr vz cv vy cv wcel wo wi vz wal wa vz cv vy cv wcel vv cv vy cv wcel vu
      cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv
      wcel wa wi vw wal wa vv wex wi vz wal vw cv vz cv wcel vw cv vy cv wcel
      wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh
      cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex wi
      vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv
      vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu
      wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex vz wal wa vz cv vy cv
      wcel vv cv vy cv wcel vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv
      vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv wex wi vw cv vz cv wcel vw
      cv vy cv wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv
      vv cv wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu
      wal vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw
      cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal
      wa vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex wa vz
      wal vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv vy cv wrex vz
      vy cv wral vz cv vy cv wcel vv cv vy cv wcel vu cv vw cv wcel vu cv vz cv
      wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv wex
      wi vz wal vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr vz cv vy cv
      wcel wo wi vz wal vw cv vz cv wcel vw cv vy cv wcel wi vv cv vz cv wcel
      vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb
      vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv cv vy cv wcel vv
      cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu
      cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi wa vv wal
      vz cv vy cv wcel wo wi vw wex vz wal vw cv vz cv wss vw cv vy cv vv cv
      cin wcel wi vw wal vv vy cv wrex vz vy cv wral vv cv vy cv wcel vu cv vw
      cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa
      wi vw wal wa vv wex vz vy cv wral vz cv vy cv wcel vv cv vy cv wcel vu cv
      vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel
      wa wi vw wal wa vv wex wi vz wal vw cv vz cv wss vw cv vy cv vv cv cin
      wcel wi vw wal vv vy cv wrex vv cv vy cv wcel vu cv vw cv wcel vu cv vz
      cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv
      wex vz vy cv vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vv vy
      cv wrex vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw
      cv vv cv wcel wa wi vw wal vv vy cv wrex vv cv vy cv wcel vu cv vw cv
      wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa wi
      vw wal wa vv wex vw cv vz cv wss vw cv vy cv vv cv cin wcel wi vw wal vu
      cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv
      wcel wa wi vw wal vv vy cv vw cv vz cv wss vw cv vy cv vv cv cin wcel wi
      vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv
      wcel wa wi vw vw cv vz cv wss vu cv vw cv wcel vu cv vz cv wcel wi vu wal
      vw cv vy cv vv cv cin wcel vw cv vy cv wcel vw cv vv cv wcel wa vu vw cv
      vz cv dfss2 vw cv vy cv vv cv elin imbi12i albii rexbii vu cv vw cv wcel
      vu cv vz cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa wi vw wal
      vv vy cv df-rex bitri ralbii vv cv vy cv wcel vu cv vw cv wcel vu cv vz
      cv wcel wi vu wal vw cv vy cv wcel vw cv vv cv wcel wa wi vw wal wa vv
      wex vz vy cv df-ral bitri vz cv vy cv wss vy cv vz cv cdif vz cv cdom wbr
      vz cv vy cv wcel wo wi vw cv vz cv wcel vw cv vy cv wcel wi vv cv vz cv
      wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq
      wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv cv vy cv
      wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel
      vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi
      wa vv wal vz cv vy cv wcel wo wi vw wex vz vz cv vy cv wss vy cv vz cv
      cdif vz cv cdom wbr vz cv vy cv wcel wo wi vw cv vz cv wcel vw cv vy cv
      wcel wi vw wal vv cv vu cv cpr vw cv wcel vu wmo vv vz cv wral vu cv vv
      cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif wral wa vz cv vy cv
      wcel wo vw wex wi vw cv vz cv wcel vw cv vy cv wcel wi vv cv vu cv cpr vw
      cv wcel vu wmo vv vz cv wral vu cv vv cv cpr vw cv wcel vu vz cv wrex vv
      vy cv vz cv cdif wral wa vz cv vy cv wcel wo wi vw wex vw cv vz cv wcel
      vw cv vy cv wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh
      cv vv cv wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi
      vu wal vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv
      vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh
      wal wa vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex vz
      cv vy cv wss vw cv vz cv wcel vw cv vy cv wcel wi vw wal vy cv vz cv cdif
      vz cv cdom wbr vz cv vy cv wcel wo vv cv vu cv cpr vw cv wcel vu wmo vv
      vz cv wral vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif
      wral wa vz cv vy cv wcel wo vw wex vw vz cv vy cv dfss2 vy cv vz cv cdif
      vz cv cdom wbr vz cv vy cv wcel wo vv cv vu cv cpr vw cv wcel vu wmo vv
      vz cv wral vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif
      wral wa vw wex vz cv vy cv wcel wo vv cv vu cv cpr vw cv wcel vu wmo vv
      vz cv wral vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif
      wral wa vz cv vy cv wcel wo vw wex vy cv vz cv cdif vz cv cdom wbr vv cv
      vu cv cpr vw cv wcel vu wmo vv vz cv wral vu cv vv cv cpr vw cv wcel vu
      vz cv wrex vv vy cv vz cv cdif wral wa vw wex vz cv vy cv wcel vv vu vy
      cv vz cv cdif vz cv vw vy cv cvv wcel vy cv vz cv cdif cvv wcel vy visset
      vy cv vz cv cvv difexg ax-mp vz visset vy cv vz cv cdif vz cv cin vz cv
      vy cv vz cv cdif cin c0 vy cv vz cv cdif vz cv incom vz cv vy cv difdisj
      eqtri brdom6disj orbi1i vv cv vu cv cpr vw cv wcel vu wmo vv vz cv wral
      vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif wral wa vz
      cv vy cv wcel vw vz cv vy cv wcel vw ax-17 19.44 bitr4i imbi12i vw cv vz
      cv wcel vw cv vy cv wcel wi vv cv vu cv cpr vw cv wcel vu wmo vv vz cv
      wral vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif wral wa
      vz cv vy cv wcel wo vw 19.35 vw cv vz cv wcel vw cv vy cv wcel wi vv cv
      vu cv cpr vw cv wcel vu wmo vv vz cv wral vu cv vv cv cpr vw cv wcel vu
      vz cv wrex vv vy cv vz cv cdif wral wa vz cv vy cv wcel wo wi vw cv vz cv
      wcel vw cv vy cv wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv
      wcel vh cv vv cv wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv
      wceq wi vu wal vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv
      wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq
      wo wb vh wal wa vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi
      vw vv cv vu cv cpr vw cv wcel vu wmo vv vz cv wral vu cv vv cv cpr vw cv
      wcel vu vz cv wrex vv vy cv vz cv cdif wral wa vz cv vy cv wcel wo vv cv
      vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv
      wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv cv vy
      cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv
      wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex
      wo wi wa vv wal vz cv vy cv wcel wo vw cv vz cv wcel vw cv vy cv wcel wi
      vv cv vu cv cpr vw cv wcel vu wmo vv vz cv wral vu cv vv cv cpr vw cv
      wcel vu vz cv wrex vv vy cv vz cv cdif wral wa vv cv vz cv wcel vg cv vw
      cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb vh wal
      wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv cv vy cv wcel vv cv vz
      cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv
      wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi wa vv wal vz
      cv vy cv wcel vv cv vu cv cpr vw cv wcel vu wmo vv vz cv wral vu cv vv cv
      cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif wral wa vv cv vz cv wcel
      vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb
      vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv wal vv cv vy cv
      wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel
      vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi
      vv wal wa vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv
      wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal
      vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv
      wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa
      vg wex wa vu wex wo wi wa vv wal vv cv vu cv cpr vw cv wcel vu wmo vv vz
      cv wral vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv
      wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal
      vt wex wi vv wal vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv
      cdif wral vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv
      wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa
      vg wex wa vu wex wo wi vv wal vv cv vu cv cpr vw cv wcel vu wmo vv vz cv
      wral vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq
      wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex vv vz cv wral vv
      cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu
      cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv
      wal vv cv vu cv cpr vw cv wcel vu wmo vg cv vw cv wcel vh cv vg cv wcel
      vh cv vv cv wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq
      wi vu wal vt wex vv vz cv vv cv vu cv cpr vw cv wcel vu wmo vg cv vw cv
      wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb vh wal wa
      vg wex vu wmo vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu
      cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal vt wex vv cv vu
      cv cpr vw cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh
      cv vu cv wceq wo wb vh wal wa vg wex vu vw vu vv vg vh grothprimlem mobii
      vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb
      vh wal wa vg wex vu vt vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv wceq
      vh cv vu cv wceq wo wb vh wal wa vg wex vt ax-17 mo2 bitri ralbii vg cv
      vw cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb vh
      wal wa vg wex vu cv vt cv wceq wi vu wal vt wex vv vz cv df-ral bitri vu
      cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv cdif wral vv cv vy
      cv vz cv cdif wcel vu cv vv cv cpr vw cv wcel vu vz cv wrex wi vv wal vv
      cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg
      cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu
      wex wo wi vv wal vu cv vv cv cpr vw cv wcel vu vz cv wrex vv vy cv vz cv
      cdif df-ral vv cv vy cv vz cv cdif wcel vu cv vv cv cpr vw cv wcel vu vz
      cv wrex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv
      wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa
      vg wex wa vu wex wo wi vv vv cv vy cv wcel vv cv vz cv wcel wn wa vu cv
      vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv
      wceq wo wb vh wal wa vg wex wa vu wex wi vv cv vy cv wcel vv cv vz cv
      wcel wn vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv
      wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wi wi vv cv vy cv
      vz cv cdif wcel vu cv vv cv cpr vw cv wcel vu vz cv wrex wi vv cv vy cv
      wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel
      vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi
      vv cv vy cv wcel vv cv vz cv wcel wn vu cv vz cv wcel vg cv vw cv wcel vh
      cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa
      vu wex impexp vv cv vy cv vz cv cdif wcel vv cv vy cv wcel vv cv vz cv
      wcel wn wa vu cv vv cv cpr vw cv wcel vu vz cv wrex vu cv vz cv wcel vg
      cv vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh
      wal wa vg wex wa vu wex vv cv vy cv vz cv eldif vu cv vv cv cpr vw cv
      wcel vu vz cv wrex vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh
      cv vv cv wceq wo wb vh wal wa vg wex vu vz cv wrex vu cv vz cv wcel vg cv
      vw cv wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh
      wal wa vg wex wa vu wex vu cv vv cv cpr vw cv wcel vg cv vw cv wcel vh cv
      vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex vu vz
      cv vw vv vu vg vh grothprimlem rexbii vg cv vw cv wcel vh cv vg cv wcel
      vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex vu vz cv df-rex
      bitri imbi12i vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg
      cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu
      wex wo vv cv vz cv wcel wn vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv
      wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex
      wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv wcel vh
      cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa
      vu wex df-or imbi2i 3bitr4i albii bitri anbi12i vv cv vz cv wcel vg cv vw
      cv wcel vh cv vg cv wcel vh cv vv cv wceq vh cv vu cv wceq wo wb vh wal
      wa vg wex vu cv vt cv wceq wi vu wal vt wex wi vv cv vy cv wcel vv cv vz
      cv wcel vu cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vu cv
      wceq vh cv vv cv wceq wo wb vh wal wa vg wex wa vu wex wo wi vv 19.26
      bitr4i orbi1i imbi2i exbii 3bitr2i albii anbi12i vz cv vy cv wcel vv cv
      vy cv wcel vu cv vw cv wcel vu cv vz cv wcel wi vu wal vw cv vy cv wcel
      vw cv vv cv wcel wa wi vw wal wa vv wex wi vw cv vz cv wcel vw cv vy cv
      wcel wi vv cv vz cv wcel vg cv vw cv wcel vh cv vg cv wcel vh cv vv cv
      wceq vh cv vu cv wceq wo wb vh wal wa vg wex vu cv vt cv wceq wi vu wal
      vt wex wi vv cv vy cv wcel vv cv vz cv wcel vu cv vz cv wcel vg cv vw cv
      wcel vh cv vg cv wcel vh cv vu cv wceq vh cv vv cv wceq wo wb vh wal wa
      vg wex wa vu wex wo wi wa vv wal vz cv vy cv wcel wo wi vw wex vz 19.26
      bitr4i anbi2i bitri exbii mpbi $.
      $( [16-Apr-2007] $) $( [16-Apr-2007] $)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 Humor
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              April Fool's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x F $.
    $( Poisson d'Avril's Theorem.  This theorem is noted for its
       _Selbstdokumentieren_ property, which means, literally,
       "self-documenting" and recalls the principle of _quidquid germanus
       dictum sit, altum viditur_, often used in set theory.  Starting with the
       seemingly simple yet profound fact that any object ` x ` equals itself
       (proved by Tarski in 1965; see Lemma 6 of [Tarski] p. 68), we
       demonstrate that the power set of the real numbers, as a relation on the
       value of the imaginary unit, does not conjoin with an empty relation on
       the product of the additive and multiplicative identity elements,
       leading to this startling conclusion that has left even seasoned
       professional mathematicians scratching their heads.  (Contributed by
       Prof. Loof Lirpa, 1-Apr-2005.)

       _A reply to skeptics can be found at
       ~ http://us.metamath.org/mpegif/mmnotes.txt , under the 1-Apr-2006
       entry_. $)
    avril1 $p |- -. ( A ~P RR ( _i ` 1 ) /\ F (/) ( 0 x. 1 ) ) $=
      cA c1 ci cfv cr cpw wbr cF cc0 c1 cmul co c0 wbr wa wn cA c0r c1r cop c1
      csn cima vy cv csn wceq vy cab cuni cnr c0r csn cxp cpw wbr cF cc0 c1
      cmul co c0 wbr wa wn cF cc0 c1 cmul co c0 wbr cA c0r c1r cop c1 csn cima
      vy cv csn wceq vy cab cuni cnr c0r csn cxp cpw wbr cF cc0 c1 cmul co c0
      wbr cF cc0 cop c0 wcel cF cc0 cop cvv wcel cF cc0 cop c0 wcel wn cF cc0
      cop c0 wcel wn vx cF cc0 cop cvv vx cv cF cc0 cop wceq vx cv c0 wcel cF
      cc0 cop c0 wcel vx cv vx cv wceq vx cv c0 wcel wn vx equid vx cv c0 wcel
      vx cv vx cv wceq vx cv vx cv wceq wn vx c0 vx dfnul2 abeq2i con2bii mpbi
      vx cv cF cc0 cop c0 eleq1 mtbii vtocleg cF cc0 cop c0 wcel cF cc0 cop cvv
      wcel cF cc0 cop c0 elisset con3i pm2.61i cF cc0 c1 cmul co c0 wbr cF cc0
      c1 cmul co cop c0 wcel cF cc0 cop c0 wcel cF cc0 c1 cmul co c0 df-br cF
      cc0 c1 cmul co cop cF cc0 cop c0 cc0 c1 cmul co cc0 cF cc0 0cn mulid1i
      opeq2i eleq1i bitri mtbir intnan cA c1 ci cfv cr cpw wbr cF cc0 c1 cmul
      co c0 wbr wa cA c0r c1r cop c1 csn cima vy cv csn wceq vy cab cuni cnr
      c0r csn cxp cpw wbr cF cc0 c1 cmul co c0 wbr wa cA c1 ci cfv cr cpw wbr
      cA c0r c1r cop c1 csn cima vy cv csn wceq vy cab cuni cnr c0r csn cxp cpw
      wbr cF cc0 c1 cmul co c0 wbr cA c1 ci cfv cr cpw wbr cA c0r c1r cop c1
      csn cima vy cv csn wceq vy cab cuni cr cpw wbr cA c0r c1r cop c1 csn cima
      vy cv csn wceq vy cab cuni cnr c0r csn cxp cpw wbr c1 ci cfv c0r c1r cop
      c1 csn cima vy cv csn wceq vy cab cuni cA cr cpw c1 ci cfv c1 c0r c1r cop
      cfv c0r c1r cop c1 csn cima vy cv csn wceq vy cab cuni c1 ci c0r c1r cop
      df-i fveq1i vy c1 c0r c1r cop df-fv eqtri breq2i cA c0r c1r cop c1 csn
      cima vy cv csn wceq vy cab cuni cr cpw cnr c0r csn cxp cpw cr cnr c0r csn
      cxp wceq cr cpw cnr c0r csn cxp cpw wceq df-r cr cnr c0r csn cxp wceq vz
      cv cr wss vz cab vz cv cnr c0r csn cxp wss vz cab cr cpw cnr c0r csn cxp
      cpw cr cnr c0r csn cxp wceq vz cv cr wss vz cv cnr c0r csn cxp wss vz cr
      cnr c0r csn cxp vz cv sseq2 abbidv vz cr df-pw vz cnr c0r csn cxp df-pw
      3eqtr4g ax-mp breqi bitri anbi1i notbii mpbir $.
      $( [1-Apr-2005] $) $( [1-Apr-2005] $)
  $}

  $( The law of excluded middle.  Act III, Theorem 1 of Shakespeare,
     _Hamlet, Prince of Denmark_ (1602).  Its author leaves its proof as an
     exercise for the reader - "To be, or not to be: that is the question" -
     starting a trend that has become standard in modern-day textbooks,
     serving to make the frustrated reader feel inferior, or in some cases to
     mask the fact that the author does not know its solution. (Contributed by
     Prof. Loof Lirpa, 1-Apr-2006.) $)
  2bornot2b $p |- ( 2 x. B \/ -. 2 x. B ) $=
    c2 cB cmul wbr c2 cB cmul wbr wn wo c2 cB cmul wbr wn c2 cB cmul wbr wn wi
    c2 cB cmul wbr wn c2 cB cmul wbr c2 cB cmul wbr wn wi c2 cB cmul wbr wn c2
    cB cmul wbr wn c2 cB cmul wbr ax-1 c2 cB cmul wbr wn c2 cB cmul wbr c2 cB
    cmul wbr wn wi ax-1 mpd c2 cB cmul wbr c2 cB cmul wbr wn df-or mpbir $.
    $( [1-Apr-2006] $) $( [1-Apr-2006] $)

  $( The classic "Hello world" benchmark has been translated into 314 computer
     programming languages - see ~ http://www.roesler-ac.de/wolfram/hello.htm .
     However, for many years it eluded a proof that it is more than just a
     conjecture, even though a wily mathematician once claimed,
     "I have discovered a truly marvelous proof of this, which this margin is
     too narrow to contain."  Using an IBM 709 mainframe, a team of
     mathematicians led by Prof. Loof Lirpa, at the New College of Tahiti,
     were finally able put it rest with a remarkably short proof only 4 lines
     long.  (Contributed by Prof. Loof Lirpa, 1-Apr-2007.) $)
  helloworld $p |- -. ( h e. ( L L 0 ) /\ W (/) ( R. 1 d ) ) $=
    cW cnr vd cv c1 co c0 wbr vh cv cL cc0 cL co wcel cW cnr vd cv c1 co c0 wbr
    cW cnr vd cv c1 co cop c0 wcel cW cnr vd cv c1 co cop noel cW cnr vd cv c1
    co c0 df-br mtbir intnan $.
    $( [1-Apr-2007] $) $( [1-Apr-2007] $)

  $( One plus one equals two.  Using proof-shortening techniques pioneered by
     Mr. Mel O'Cat, along with the latest supercomputer technology, Prof. Loof
     Lirpa and colleagues were able to shorten Whitehead and Russell's 360-page
     proof that 1+1=2 in _Principia Mathematica_ to this remarkable proof only
     two steps long, thus establishing a new world's record for this famous
     theorem.  (Contributed by Prof. Loof Lirpa, 1-Apr-2008.) $)
  1p1e2 $p |- ( 1 + 1 ) = 2 $=
    c2 c1 c1 caddc co df-2 eqcomi $.
    $( [1-Apr-2008] $) $( [1-Apr-2008] $)

  ${
    $d x A $.
    $( Law of identity (reflexivity of class equality).  Theorem 6.4 of
       [Quine] p. 41.

       This law is thought to have originated with Aristotle (_Metaphysics_,
       Book VII, Part 17).  It is one of the three axioms of Ayn Rand's
       philosophy (_Atlas Shrugged_, Part Three, Chapter VII).  While some have
       proposed extending Rand's axiomatization to include Compassion and
       Kindness, others fear that such an extension may flirt with logical
       inconsistency.  (Thanks to Stefan Allan and Prof. Loof Lirpa for this
       information.)  $)
    eqid1 $p |- A = A $=
      vx cA cA vx cv cA wcel biid eqriv $.
      $( [1-Apr-2009] $) $( [5-Aug-1993] $)
  $}



  ${
    $d j k m x y A $.  $d j k m y B $.  $d y D $.  $d j m x F $.  $d j k y K $.
    $d k F $.  $( <- bad! $)
    numexp.1 $e |- B e. NN $.
    numexp.2 $e |- 2 <_ B $.
    $( ` k ` th decimal digit. $)
    numexp.3 $e |- D = ( ( |_ ` ( ( B ^ k ) x. A ) ) mod B ) $.
    ${
      numexplem1.4 $e |- F
          = { <. k , y >. | ( k e. NN /\ y = ( D / ( B ^ k ) ) ) } $.
    $}
  $}

  ${
    $d j k m x y A $.  $d j k m y B $.  $d y D $.  $d j m x F $.  $d j k y K $.
    numexpOLDNEW.1 $e |- B e. NN $.
    numexpOLDNEW.2 $e |- 2 <_ B $.
    $( ` k ` th decimal digit. $)
    numexpOLDNEW.3 $e |- D = ( ( A mod ( 1 / ( B ^ k ) ) ) -
                         ( A mod ( 1 / ( B ^ ( k - 1 ) ) ) ) ) $.
    ${
      numexpOLDlem1NEW.4 $e |- F
          = { <. k , y >. | ( k e. NN /\ y = D ) } $.
    $}
  $}

  ${
    $d j k m x y A $.  $d j k m y B $.  $d y D $.  $d j m x F $.  $d j k y K $.
    numexpOLD.1 $e |- B e. NN $.
    numexpOLD.2 $e |- 2 <_ B $.
    numexpOLD.3 $e |- D = ( ( |_ ` ( ( B ^ k ) x. A ) )
          - ( B x. ( |_ ` ( ( B ^ ( k - 1 ) ) x. A ) ) ) ) $.
    ${
      numexpOLDlem1.4 $e |- F
          = { <. k , y >. | ( k e. NN /\ y = ( D / ( B ^ k ) ) ) } $.
    $}
  $}

  ${
    $d x y $.
  $}

  ${
    $d v w x y z $.
  $}

$( ------------- unsorted stuff ---------------- $)


  ${
    mtand.1 $e |- ( ph -> -. ch ) $.
    mtand.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( A modus tollens deduction.  (Contributed by Jeff Hankins,
       19-Aug-2009.) $)
    mtand $p |- ( ph -> -. ps ) $=
      wph wps wch mtand.1 wph wps wch mtand.2 ex mtod $.
      $( [1-Dec-2010] $) $( [15-Jul-2009] $)
  $}

  ${
    impr.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Import a wff into a right conjunct.  (Contributed by Jeff Hankins,
       30-Aug-2009.) $)
    impr $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      wph wps wch wth wph wps wch wth wi impr.1 ex imp32 $.
      $( [1-Dec-2010] $) $( [28-Aug-2009] $)
  $}

  ${
    expr.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Export a wff from a right conjunct. (Contributed by Jeff Hankins,
       30-Aug-2009.) $)
    expr $p |- ( ( ph /\ ps ) -> ( ch -> th ) ) $=
      wph wps wch wth wi wph wps wch wth expr.1 exp32 imp $.
      $( [1-Dec-2010] $) $( [28-Aug-2009] $)
  $}

  ${
    $v et $.
    imp5d.et $f wff et $.
    imp5d.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( An importation inference.  (Contributed by Jeff Hankins,
       15-Jul-2009.) $)
    imp5d $p |- ( ( ( ph /\ ps ) /\ ch ) -> ( ( th /\ ta ) -> et ) ) $=
      wph wps wa wch wa wth wta imp5d.et wph wps wch wth wta imp5d.et wi wi
      imp5d.1 imp31 imp3a $.
      $( [1-Dec-2010] $) $( [7-Jul-2009] $)
  $}

  ${
    $v et $.
    3exp5.et $f wff et $.
    ${
      exp5o.1 $e |- ( ( ph /\ ps /\ ch ) -> ( ( th /\ ta ) -> et ) ) $.
      $( A triple exportation inference.  (Contributed by Jeff Hankins,
         30-Aug-2009.) $)
      exp5o $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta 3exp5.et wi wi wph wps wch w3a wth wta 3exp5.et
        exp5o.1 exp3a 3exp $.
        $( [1-Dec-2010] $) $( [8-Jul-2009] $)
    $}

    ${
      exp516.1 $e |- ( ( ( ph /\ ( ps /\ ch /\ th ) ) /\ ta ) -> et ) $.
      $( A triple exportation inference.  (Contributed by Jeff Hankins,
        22-Sep-2009.) $)
      exp516 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta 3exp5.et wi wph wps wch wth w3a wa wta 3exp5.et
        exp516.1 ex 3exp2 $.
        $( [1-Dec-2010] $) $( [8-Jul-2009] $)
    $}

    ${
      exp520.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ ( th /\ ta ) ) -> et ) $.
      $( A triple exportation inference.  (Contributed by Jeff Hankins,
         22-Sep-2009.) $)
      exp520 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta 3exp5.et wph wps wch w3a wth wta wa 3exp5.et
        exp520.1 ex exp5o $.
        $( [1-Dec-2010] $) $( [8-Jul-2009] $)
    $}

    ${
      exp53.1 $e |- ( ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) /\ ta ) -> et ) $.
      $( An exportation inference.  (Contributed by Jeff Hankins,
         30-Aug-2009.) $)
      exp53 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta 3exp5.et wi wph wps wa wch wth wa wa wta 3exp5.et
        exp53.1 ex exp43 $.
        $( [1-Dec-2010] $) $( [7-Jul-2009] $)
    $}
  $}

  ${
    ompfl3.1 $e |- ( ( ph /\ ps /\ ch ) -> ( th <-> ( ch /\ ta ) ) ) $.
    $( Remove a hypothesis from the second member of a biimplication.
       (Contributed by FL, 22-Jul-2008.) $)
    ompfl3 $p |- ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) $=
      wph wps wch w3a wth wch wta wa wta ompfl3.1 wch wph wta wch wta wa wb wps
      wch wta ibar 3ad2ant3 bitr4d $.
      $( [1-Dec-2010] $) $( [14-Jul-2008] $)
  $}

  ${
    3animi.1 $e |- ( ph -> ps ) $.
    $( Add two conjuncts to antecedent and consequent.  (Contributed by Jeff
       Hankins, 16-Aug-2009.) $)
    3anim1i $p |- ( ( ph /\ ch /\ th ) -> ( ps /\ ch /\ th ) ) $=
      wph wps wch wch wth wth 3animi.1 wch id wth id 3anim123i $.
      $( [1-Dec-2010] $) $( [16-Aug-2009] $)

    $( Add two conjuncts to antecedent and consequent.  (Contributed by Jeff
       Hankins, 19-Aug-2009.) $)
    3anim3i $p |- ( ( ch /\ th /\ ph ) -> ( ch /\ th /\ ps ) ) $=
      wch wch wth wth wph wps wch id wth id 3animi.1 3anim123i $.
      $( [1-Dec-2010] $) $( [16-Aug-2009] $)
  $}

  ${
    $v et $.
    $v ze $.
    3jaao.et $f wff et $.
    3jaao.ze $f wff ze $.
    3jaao.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3jaao.2 $e |- ( th -> ( ta -> ch ) ) $.
    3jaao.3 $e |- ( et -> ( ze -> ch ) ) $.
    $( Inference conjoining and disjoining the antecedents of three
       implications.  (Contributed by Jeff Hankins, 15-Aug-2009.) $)
    3jaao $p |- ( ( ph /\ th /\ et ) -> ( ( ps \/ ta \/ ze ) -> ch ) ) $=
      wph wth 3jaao.et wps wta 3jaao.ze w3o wch wi wph wth wa 3jaao.et wa wps
      wta wo 3jaao.ze wo wch wps wta 3jaao.ze w3o wph wth wa wps wta wo wch
      3jaao.et 3jaao.ze wph wps wch wth wta 3jaao.1 3jaao.2 jaao 3jaao.3 jaao
      wps wta 3jaao.ze df-3or syl5ib 3impa $.
      $( [1-Dec-2010] $) $( [3-Aug-2009] $)
  $}

  $( Triple conjunction expressed in terms of triple disjunction.
       (Contributed by Jeff Hankins, 15-Aug-2009.) $)
  3anor $p |- ( ( ph /\ ps /\ ch ) <-> -. ( -. ph \/ -. ps \/ -. ch ) ) $=
    wph wps wa wch wa wph wn wps wn wo wch wn wo wn wph wps wch w3a wph wn wps
    wn wch wn w3o wn wph wps wa wch wa wph wps wa wn wch wn wo wn wph wn wps wn
    wo wch wn wo wn wph wps wa wch anor wph wps wa wn wch wn wo wph wn wps wn
    wo wch wn wo wph wps wa wn wph wn wps wn wo wch wn wph wps ianor orbi1i
    notbii bitri wph wps wch df-3an wph wn wps wn wch wn w3o wph wn wps wn wo
    wch wn wo wph wn wps wn wch wn df-3or notbii 3bitr4i $.
    $( [1-Dec-2010] $) $( [28-Jul-2009] $)

  $( Negated triple conjunction expressed in terms of triple disjunction.
       (Contributed by Jeff Hankins, 15-Aug-2009.) $)
  3ianor $p |- ( -. ( ph /\ ps /\ ch ) <-> ( -. ph \/ -. ps \/ -. ch ) ) $=
    wph wps wch w3a wn wph wn wps wn wch wn w3o wn wn wph wn wps wn wch wn w3o
    wph wps wch w3a wph wn wps wn wch wn w3o wn wph wps wch 3anor notbii wph wn
    wps wn wch wn w3o notnot bitr4i $.
    $( [1-Dec-2010] $) $( [28-Jul-2009] $)

  ${
    $d A x $.
    $( A case of equivalence of "at most one" and "only one".  (Contributed by
       FL, 6-Dec-2010.) $)
    equnamo $p |- ( A =/= (/) -> ( E* x x e. A <-> E! x x e. A ) ) $=
      cA c0 wne vx cv cA wcel vx wmo vx cv cA wcel vx wex vx cv cA wcel vx wmo
      wa vx cv cA wcel vx weu cA c0 wne vx cv cA wcel vx wex vx cv cA wcel vx
      wmo cA c0 wne vx cv cA wcel vx wex vx cA n0 biimpi biantrurd vx cv cA
      wcel vx eu5 syl6bbr $.
      $( [1-Dec-2010] $) $( [14-Nov-2010] $)
  $}

  $( The intersection of a pair is the intersection of its members.  Closed
     form of ~ intpr .  Theorem 71 of [Suppes] p. 42.  (Contributed by FL,
     27-Apr-2008.) $)
  intprd $p |- ( ( A e. _V /\ B e. _V ) -> |^| { A , B } = ( A i^i B ) ) $=
    cA cvv wcel cB cvv wcel cA cB cpr cint cA cB cin wceq cA cvv wcel cA c0 cif
    cB cpr cint cA cvv wcel cA c0 cif cB cin wceq cA cvv wcel cA c0 cif cB cvv
    wcel cB c0 cif cpr cint cA cvv wcel cA c0 cif cB cvv wcel cB c0 cif cin
    wceq cA cB c0 c0 cA cA cvv wcel cA c0 cif wceq cA cB cpr cint cA cvv wcel
    cA c0 cif cB cpr cint cA cB cin cA cvv wcel cA c0 cif cB cin cA cA cvv wcel
    cA c0 cif wceq cA cB cpr cA cvv wcel cA c0 cif cB cpr cA cA cvv wcel cA c0
    cif cB preq1 inteqd cA cA cvv wcel cA c0 cif cB ineq1 eqeq12d cB cB cvv
    wcel cB c0 cif wceq cA cvv wcel cA c0 cif cB cpr cint cA cvv wcel cA c0 cif
    cB cvv wcel cB c0 cif cpr cint cA cvv wcel cA c0 cif cB cin cA cvv wcel cA
    c0 cif cB cvv wcel cB c0 cif cin cB cB cvv wcel cB c0 cif wceq cA cvv wcel
    cA c0 cif cB cpr cA cvv wcel cA c0 cif cB cvv wcel cB c0 cif cpr cB cB cvv
    wcel cB c0 cif cA cvv wcel cA c0 cif preq2 inteqd cB cB cvv wcel cB c0 cif
    cA cvv wcel cA c0 cif ineq2 eqeq12d cA cvv wcel cA c0 cif cB cvv wcel cB c0
    cif cA c0 cvv 0ex elimel cB c0 cvv 0ex elimel intpr dedth2h $.
    $( [1-Dec-2010] $) $( [27-Apr-2008] $)

  ${
    $d A x y z $.  $d B x y z $.
    $( The intersection of a union ` U. A ` with a class ` B ` is equal to the
       union of the intersections of each element of ` A ` with ` B ` .
       (Contributed by FL, 24-Mar-2007.) $)
    ntunte $p |- ( U. A i^i B ) = U. { x | E. y e. A x = ( y i^i B ) } $=
      vz cA cuni cB cin vx cv vy cv cB cin wceq vy cA wrex vx cab cuni vz cv cA
      cuni cB cin wcel vz cv vx cv wcel vx cv vy cv cB cin wceq vy cA wrex wa
      vx wex vz cv vx cv vy cv cB cin wceq vy cA wrex vx cab cuni wcel vz cv cA
      cuni wcel vz cv cB wcel wa vz cv vy cv wcel vy cA wrex vz cv cB wcel wa
      vz cv cA cuni cB cin wcel vz cv vx cv wcel vx cv vy cv cB cin wceq vy cA
      wrex wa vx wex vz cv cA cuni wcel vz cv vy cv wcel vy cA wrex vz cv cB
      wcel vy vz cv cA eluni2 anbi1i vz cv cA cuni cB elin vz cv vx cv wcel vx
      cv vy cv cB cin wceq vy cA wrex wa vx wex vx cv vy cv cB cin wceq vz cv
      vx cv wcel wa vx wex vy cA wrex vz cv vy cv wcel vz cv cB wcel wa vy cA
      wrex vz cv vy cv wcel vy cA wrex vz cv cB wcel wa vz cv vx cv wcel vx cv
      vy cv cB cin wceq vy cA wrex wa vx wex vx cv vy cv cB cin wceq vz cv vx
      cv wcel wa vy cA wrex vx wex vx cv vy cv cB cin wceq vz cv vx cv wcel wa
      vx wex vy cA wrex vz cv vx cv wcel vx cv vy cv cB cin wceq vy cA wrex wa
      vx cv vy cv cB cin wceq vz cv vx cv wcel wa vy cA wrex vx vz cv vx cv
      wcel vx cv vy cv cB cin wceq vy cA wrex wa vx cv vy cv cB cin wceq vy cA
      wrex vz cv vx cv wcel wa vx cv vy cv cB cin wceq vz cv vx cv wcel wa vy
      cA wrex vz cv vx cv wcel vx cv vy cv cB cin wceq vy cA wrex ancom vx cv
      vy cv cB cin wceq vz cv vx cv wcel vy cA r19.41v bitr4i exbii vx cv vy cv
      cB cin wceq vz cv vx cv wcel wa vy vx cA rexcom4 bitr4i vx cv vy cv cB
      cin wceq vz cv vx cv wcel wa vx wex vz cv vy cv wcel vz cv cB wcel wa vy
      cA vx cv vy cv cB cin wceq vz cv vx cv wcel wa vx wex vz cv vy cv cB cin
      wcel vz cv vy cv wcel vz cv cB wcel wa vz cv vx cv wcel vz cv vy cv cB
      cin wcel vx vy cv cB cin vy cv cB vy visset inex1 vx cv vy cv cB cin vz
      cv eleq2 ceqsexv vz cv vy cv cB elin bitri rexbii vz cv vy cv wcel vz cv
      cB wcel vy cA r19.41v 3bitri 3bitr4i vx cv vy cv cB cin wceq vy cA wrex
      vx vz cv eluniab bitr4i eqriv $.
      $( [1-Dec-2010] $) $( [24-Mar-2007] $)
  $}

  $( If ` A ` belongs to a part of ` C ` then ` A ` belongs to ` C ` .
     (Contributed by FL, 3-Aug-2009.) $)
  bepart $p |- ( ( A e. B /\ B e. ~P C ) -> A e. C ) $=
    cB cC cpw wcel cA cB wcel cA cC wcel cB cC cpw wcel cB cC cA cB cC elpwi
    sseld impcom $.
    $( [1-Dec-2010] $) $( [2-Aug-2009] $)

  ${
    $d t u v A $. $d t u v B $. $d t u v C $.
    $( Subset relation for cross product.
       (Contributed by Jeff Hankins, 30-Aug-2009.) $)
    xpss1 $p |- ( A C_ B -> ( A X. C ) C_ ( B X. C ) ) $=
      cA cB wss vt cA cC cxp cB cC cxp cA cB wss vt cv vu cv vv cv cop wceq vu
      cv cA wcel vv cv cC wcel wa wa vv wex vu wex vt cv cB cC cxp wcel vt cv
      cA cC cxp wcel cA cB wss vt cv vu cv vv cv cop wceq vu cv cA wcel vv cv
      cC wcel wa wa vt cv cB cC cxp wcel vu vv cA cB wss vt cv vu cv vv cv cop
      wceq vu cv cA wcel vv cv cC wcel wa wa vt cv cB cC cxp wcel cA cB wss vt
      cv vu cv vv cv cop wceq vu cv cA wcel vv cv cC wcel wa wa wa vt cv cB cC
      cxp wcel vu cv vv cv cop cB cC cxp wcel cA cB wss vu cv cA wcel vv cv cC
      wcel wa vu cv vv cv cop cB cC cxp wcel vt cv vu cv vv cv cop wceq vu cv
      cB wcel vv cv cC wcel vu cv vv cv cop cB cC cxp wcel cA cB wss vu cv cA
      wcel vv cv cC wcel wa wa vu cv vv cv cB cC opelxpi cA cB wss vu cv cA
      wcel vu cv cB wcel vv cv cC wcel cA cB vu cv ssel2 adantrr cA cB wss vu
      cv cA wcel vv cv cC wcel simprr sylanc adantrl vt cv vu cv vv cv cop wceq
      vt cv cB cC cxp wcel vu cv vv cv cop cB cC cxp wcel wb cA cB wss vu cv cA
      wcel vv cv cC wcel wa vt cv vu cv vv cv cop cB cC cxp eleq1 ad2antrl
      mpbird ex 19.23advv vu vv vt cv cA cC elxp syl5ib ssrdv $.
      $( [1-Dec-2010] $) $( [14-Aug-2009] $)
  $}

  ${
    $d t u v A $. $d t u v B $. $d t u v C $.
    $( Subset relation for cross product.
       (Contributed by Jeff Hankins, 30-Aug-2009.) $)
    xpss2 $p |- ( A C_ B -> ( C X. A ) C_ ( C X. B ) ) $=
      cA cB wss vt cC cA cxp cC cB cxp cA cB wss vt cv vu cv vv cv cop wceq vu
      cv cC wcel vv cv cA wcel wa wa vv wex vu wex vt cv cC cB cxp wcel vt cv
      cC cA cxp wcel cA cB wss vt cv vu cv vv cv cop wceq vu cv cC wcel vv cv
      cA wcel wa wa vt cv cC cB cxp wcel vu vv cA cB wss vt cv vu cv vv cv cop
      wceq vu cv cC wcel vv cv cA wcel wa wa vt cv cC cB cxp wcel cA cB wss vt
      cv vu cv vv cv cop wceq vu cv cC wcel vv cv cA wcel wa wa wa vt cv cC cB
      cxp wcel vu cv vv cv cop cC cB cxp wcel cA cB wss vu cv cC wcel vv cv cA
      wcel wa vu cv vv cv cop cC cB cxp wcel vt cv vu cv vv cv cop wceq vu cv
      cC wcel vv cv cB wcel vu cv vv cv cop cC cB cxp wcel cA cB wss vu cv cC
      wcel vv cv cA wcel wa wa vu cv vv cv cC cB opelxpi cA cB wss vu cv cC
      wcel vv cv cA wcel simprl cA cB wss vv cv cA wcel vv cv cB wcel vu cv cC
      wcel cA cB vv cv ssel2 adantrl sylanc adantrl vt cv vu cv vv cv cop wceq
      vt cv cC cB cxp wcel vu cv vv cv cop cC cB cxp wcel wb cA cB wss vu cv cC
      wcel vv cv cA wcel wa vt cv vu cv vv cv cop cC cB cxp eleq1 ad2antrl
      mpbird ex 19.23advv vu vv vt cv cC cA elxp syl5ib ssrdv $.
      $( [1-Dec-2010] $) $( [14-Aug-2009] $)
  $}

  $( Two ways to say that ` A ` and ` B ` partition ` C ` (when ` A ` and
     ` B ` don't overlap and ` A ` is a part of ` C ` ).    (Contributed by FL,
     17-Nov-2008.) $)
  twpar2 $p |- ( ( A C_ C /\ ( A i^i B ) = (/) )
     -> ( ( A u. B ) = C <-> ( C \ A ) = B ) ) $=
    cA cC wss cA cB cin c0 wceq wa cA cB cun cC wceq cC cA cdif cB wceq cA cB
    cin c0 wceq cA cB cun cC wceq cC cA cdif cB wceq wi cA cC wss cA cB cun cC
    wceq cA cB cin c0 wceq cC cA cdif cB wceq cB cA cun cA cB cun wceq cA cB
    cun cC wceq cA cB cin c0 wceq cC cA cdif cB wceq wi cB cA uncom cB cA cun
    cA cB cun wceq cA cB cun cC wceq wa cB cA cun cC wceq cC cB cA cun wceq cA
    cB cin c0 wceq cC cA cdif cB wceq wi cB cA cun cA cB cun cC eqtr cB cA cun
    cC wceq cC cB cA cun wceq cB cA cun cC eqcom biimpi cC cB cA cun wceq cC cA
    cdif cB cA cun cA cdif wceq cA cB cin c0 wceq cC cA cdif cB wceq wi cC cB
    cA cun cA difeq1 cC cA cdif cB cA cun cA cdif wceq cB cA cun cA cdif cB cA
    cdif wceq cA cB cin c0 wceq cC cA cdif cB wceq wi cB cA difun2 cA cB cin c0
    wceq cC cA cdif cB cA cdif wceq cC cA cdif cB wceq cC cA cdif cB cA cun cA
    cdif wceq cB cA cun cA cdif cB cA cdif wceq wa cA cB cin c0 wceq cB cB cA
    cdif wceq cC cA cdif cB cA cdif wceq cC cA cdif cB wceq wi cA cB cin c0
    wceq cB cA cin c0 wceq cB cB cA cdif wceq cA cB cin cB cA cin c0 cA cB
    incom eqeq1i cB cA disj3 bitri cC cA cdif cB cA cdif wceq cC cA cdif cB
    wceq wi cB cA cdif cB cC cA cdif cB cA cdif wceq cB cA cdif cB wceq cC cA
    cdif cB wceq cC cA cdif cB cA cdif cB eqtr expcom eqcoms sylbi cC cA cdif
    cB cA cun cA cdif cB cA cdif eqtr syl5com mpan2 syl 3syl mpan com12 adantl
    cA cC wss cA cB cin c0 wceq wa cC cA cdif cB wceq cA cB cun cC wceq cA cC
    wss cA cB cin c0 wceq wa cC cA cdif cB wceq wa cA cB cun cC cA cC wss cA cB
    cin c0 wceq wa cC cA cdif cB wceq cA cB cun cC wss cA cC wss cC cA cdif cB
    wceq cA cB cun cC wss wi cA cB cin c0 wceq cC cA cdif cB wceq cA cC wss cA
    cB cun cC wss cC cA cdif cB wceq cC cA cdif cC wss cA cC wss cA cB cun cC
    wss wi cC cA difss cC cA cdif cB wceq cC cA cdif cC wss cB cC wss cA cC wss
    cA cB cun cC wss wi cC cA cdif cB cC sseq1 cA cC wss cB cC wss cA cB cun cC
    wss cA cC wss cB cC wss wa cA cB cun cC wss cA cB cC unss biimpi expcom
    syl6bi mpi com12 adantr imp cA cC wss cC cA cdif cB wceq cC cA cB cun wss
    cA cB cin c0 wceq cA cC wss cC cA cdif cB wceq wa cC cA cdif cB wss cC cA
    cB cun wss cC cA cdif cB wceq cC cA cdif cB wss cA cC wss cC cA cdif cB
    eqimss adantl cC cA cB ssundif sylibr adantlr eqssd ex impbid $.
    $( [1-Dec-2010] $) $( [16-Nov-2008] $)

  $( Bring an intersection in and out of a class difference.  (Contributed by
     Jeff Hankins, 15-Jul-2009.) $)
  indif2 $p |- ( A i^i ( B \ C ) ) = ( ( A i^i B ) \ C ) $=
    cA cB cin cvv cC cdif cin cA cB cvv cC cdif cin cin cA cB cin cC cdif cA cB
    cC cdif cin cA cB cvv cC cdif inass cA cB cin cC invdif cB cvv cC cdif cin
    cB cC cdif cA cB cC invdif ineq2i 3eqtr3ri $.
    $( [1-Dec-2010] $) $( [12-Jul-2009] $)

  $( Subset relation for cross product.  (Contributed by Jeff Hankins,
     30-Aug-2009.) $)
  xpss12 $p |- ( ( A C_ B /\ C C_ D ) -> ( A X. C ) C_ ( B X. D ) ) $=
    cA cB wss cC cD wss cA cC cxp cB cC cxp cB cD cxp cA cB cC xpss1 cC cD cB
    xpss2 sylan9ss $.
    $( [1-Dec-2010] $) $( [14-Aug-2009] $)

  $( The intersection of two relations is equivalent to a conjunction
     of those relations.  (Contributed by FL, 7-Oct-2008.) $)
  int2rel $p |- ( A ( R i^i S ) B <-> ( A R B /\ A S B ) ) $=
    cA cB cop cR cS cin wcel cA cB cop cR wcel cA cB cop cS wcel wa cA cB cR cS
    cin wbr cA cB cR wbr cA cB cS wbr wa cA cB cop cR cS elin cA cB cR cS cin
    df-br cA cB cR wbr cA cB cop cR wcel cA cB cS wbr cA cB cop cS wcel cA cB
    cR df-br cA cB cS df-br anbi12i 3bitr4i $.
    $( [1-Dec-2010] $) $( [6-Oct-2008] $)

  $( The pre-image of the range of a class is the domain of the class.
     (Contributed by Jeff Hankins, 15-Jul-2009.) $)
  cvimarndm $p |- ( `' A " ran A ) = dom A $=
    cA ccnv cA ccnv cdm cima cA ccnv crn cA ccnv cA crn cima cA cdm cA ccnv
    imadmrn cA crn cA ccnv cdm cA ccnv cA df-rn imaeq2i cA dfdm4 3eqtr4i $.
    $( [1-Dec-2010] $) $( [12-Jul-2009] $)

  ${
    fveq12d.1 $e |- ( ph -> F = G ) $.
    fveq12d.2 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function value.  (Contributed by FL,
       22-Dec-2008.) $)
    fveq12d $p |- ( ph -> ( F ` A ) = ( G ` B ) ) $=
      wph cA cF cfv cA cG cfv cB cG cfv wph cA cF cG fveq12d.1 fveq1d wph cA cB
      cG fveq12d.2 fveq2d eqtrd $.
      $( [1-Dec-2010] $) $( [22-Dec-2008] $)
  $}

  ${
    $d A b c $. $d B b c $. $d C b c $.
    $( Location of the first element of a Cartesian product.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    xp1st $p |- ( A e. ( B X. C ) -> ( 1st ` A ) e. B ) $=
      cA cB cC cxp wcel cA vb cv vc cv cop wceq vb cv cB wcel vc cv cC wcel wa
      wa vc wex vb wex cA c1st cfv cB wcel vb vc cA cB cC elxp cA vb cv vc cv
      cop wceq vb cv cB wcel vc cv cC wcel wa wa cA c1st cfv cB wcel vb vc cA
      vb cv vc cv cop wceq vb cv cB wcel cA c1st cfv cB wcel vc cv cC wcel cA
      vb cv vc cv cop wceq cA c1st cfv cB wcel vb cv cB wcel cA vb cv vc cv cop
      wceq cA c1st cfv vb cv cB cA vb cv vc cv cop wceq cA c1st cfv vb cv vc cv
      cop c1st cfv vb cv cA vb cv vc cv cop c1st fveq2 vb cv vc cv vb visset
      op1st syl6eq eleq1d biimpar adantrr 19.23aivv sylbi $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d A b c $. $d B b c $. $d C b c $.
    $( Location of the second element of a Cartesian product.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    xp2nd $p |- ( A e. ( B X. C ) -> ( 2nd ` A ) e. C ) $=
      cA cB cC cxp wcel cA vb cv vc cv cop wceq vb cv cB wcel vc cv cC wcel wa
      wa vc wex vb wex cA c2nd cfv cC wcel vb vc cA cB cC elxp cA vb cv vc cv
      cop wceq vb cv cB wcel vc cv cC wcel wa wa cA c2nd cfv cC wcel vb vc cA
      vb cv vc cv cop wceq vc cv cC wcel cA c2nd cfv cC wcel vb cv cB wcel cA
      vb cv vc cv cop wceq cA c2nd cfv cC wcel vc cv cC wcel cA vb cv vc cv cop
      wceq cA c2nd cfv vc cv cC cA vb cv vc cv cop wceq cA c2nd cfv vb cv vc cv
      cop c2nd cfv vc cv cA vb cv vc cv cop c2nd fveq2 vb cv vc cv vb visset vc
      visset op2nd syl6eq eleq1d biimpar adantrl 19.23aivv sylbi $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y z $. $d B u v w x y z $.
    $d ph u v w $. $d ps u v $. $d ch u v $.
    oprabopabf.1 $e |- ( ps -> A. x ps ) $.
    oprabopabf.2 $e |- ( ch -> A. y ch ) $.
    oprabopabf.3 $e |- ( x = ( 1st ` w ) -> ( ph <-> ps ) ) $.
    oprabopabf.4 $e |- ( y = ( 2nd ` w ) -> ( ps <-> ch ) ) $.
    $( Convert between operator and function class abstractions using
       ` 1st ` and ` 2nd ` . (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    oprabopabf $p |- { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ph ) }
                          = { <. w , z >. | ( w e. ( A X. B ) /\ ch ) } $=
      vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph
      wa wa vz wex vy wex vx wex vu cab vu cv vw cv vz cv cop wceq vw cv cA cB
      cxp wcel wch wa wa vz wex vw wex vu cab vx cv cA wcel vy cv cB wcel wa
      wph wa vx vy vz copab2 vw cv cA cB cxp wcel wch wa vw vz copab vu cv vx
      cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vz
      wex vy wex vx wex vu cv vw cv vz cv cop wceq vw cv cA cB cxp wcel wch wa
      wa vz wex vw wex vu vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy
      cv cB wcel wa wph wa wa vy wex vx wex vz wex vu cv vw cv vz cv cop wceq
      vw cv cA cB cxp wcel wch wa wa vw wex vz wex vu cv vx cv vy cv cop vz cv
      cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vz wex vy wex vx wex vu
      cv vw cv vz cv cop wceq vw cv cA cB cxp wcel wch wa wa vz wex vw wex vu
      cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa
      wa vy wex vx wex vu cv vw cv vz cv cop wceq vw cv cA cB cxp wcel wch wa
      wa vw wex vz vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB
      wcel wa wph wa wa vy wex vx wex vu cv vw cv vz cv cop wceq vw cv cA cB
      cxp wcel wch wa wa vw wex vu cv vx cv vy cv cop vz cv cop wceq vx cv cA
      wcel vy cv cB wcel wa wph wa wa vy wex vu cv vw cv vz cv cop wceq vw cv
      cA cB cxp wcel wch wa wa vw wex vx vu cv vw cv vz cv cop wceq vw cv cA cB
      cxp wcel wch wa wa vx vw vu cv vw cv vz cv cop wceq vw cv cA cB cxp wcel
      wch wa vx vu cv vw cv vz cv cop wceq vx ax-17 vw cv cA cB cxp wcel wch vx
      vw cv cA cB cxp wcel vx ax-17 vy cv vw cv c2nd cfv wceq vy wex wch wch vx
      wal wi vy vw cv c2nd cfv vw cv c2nd fvex isseti vy cv vw cv c2nd cfv wceq
      wch wch vx wal wi vy wch wch vx wal vy oprabopabf.2 wch vy vx
      oprabopabf.2 hbal hbim vy cv vw cv c2nd cfv wceq wps wps vx wal wi wch
      wch vx wal wi oprabopabf.1 vy cv vw cv c2nd cfv wceq wps wch wps vx wal
      wch vx wal oprabopabf.4 vy cv vw cv c2nd cfv wceq wps wch vx oprabopabf.4
      albidv imbi12d mpbii 19.23ai ax-mp hban hban hbex vu cv vx cv vy cv cop
      vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vu cv vw cv vz cv
      cop wceq vw cv cA cB cxp wcel wch wa wa vw wex vy vu cv vw cv vz cv cop
      wceq vw cv cA cB cxp wcel wch wa wa vy vw vu cv vw cv vz cv cop wceq vw
      cv cA cB cxp wcel wch wa vy vu cv vw cv vz cv cop wceq vy ax-17 vw cv cA
      cB cxp wcel wch vy vw cv cA cB cxp wcel vy ax-17 oprabopabf.2 hban hban
      hbex vu cv vx cv vy cv cop vz cv cop wceq vx cv vy cv cop cA cB cxp wcel
      wph vu cv vw cv vz cv cop wceq vw cv cA cB cxp wcel wch wa wa vw wex vx
      cv cA wcel vy cv cB wcel wa vu cv vw cv vz cv cop wceq vw cv cA cB cxp
      wcel wch wa wa vu cv vx cv vy cv cop vz cv cop wceq vx cv vy cv cop cA cB
      cxp wcel wph wa wa vw vx cv vy cv cop vx cv vy cv opex vw cv vx cv vy cv
      cop wceq vu cv vw cv vz cv cop wceq vu cv vx cv vy cv cop vz cv cop wceq
      vw cv cA cB cxp wcel wch wa vx cv vy cv cop cA cB cxp wcel wph wa vw cv
      vx cv vy cv cop wceq vw cv vz cv cop vx cv vy cv cop vz cv cop vu cv vw
      cv vx cv vy cv cop vz cv opeq1 eqeq2d vw cv vx cv vy cv cop wceq vw cv cA
      cB cxp wcel vx cv vy cv cop cA cB cxp wcel wch wph vw cv vx cv vy cv cop
      cA cB cxp eleq1 vw cv vx cv vy cv cop wceq wph wps wch vw cv vx cv vy cv
      cop wceq vx cv vw cv c1st cfv wceq wph wps wb vw cv vx cv vy cv cop wceq
      vw cv c1st cfv vx cv vy cv cop c1st cfv vx cv vw cv vx cv vy cv cop c1st
      fveq2 vx cv vy cv vx visset op1st syl6req oprabopabf.3 syl vw cv vx cv vy
      cv cop wceq vy cv vw cv c2nd cfv wceq wps wch wb vw cv vx cv vy cv cop
      wceq vw cv c2nd cfv vx cv vy cv cop c2nd cfv vy cv vw cv vx cv vy cv cop
      c2nd fveq2 vx cv vy cv vx visset vy visset op2nd syl6req oprabopabf.4 syl
      bitr2d anbi12d anbi12d cla4ev vx cv vy cv cA cB opelxpi sylanr1 19.23ai
      19.23ai vu cv vw cv vz cv cop wceq vw cv cA cB cxp wcel wch wa wa vu cv
      vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa
      vy wex vx wex vw vu cv vw cv c1st cfv vw cv c2nd cfv cop vz cv cop wceq
      vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa wch vu cv vx cv vy cv
      cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vy wex vx wex
      vu cv vw cv vz cv cop wceq vw cv cA cB cxp wcel wch wa wa vu cv vw cv vz
      cv cop wceq vw cv cA cB cxp wcel vu cv vw cv c1st cfv vw cv c2nd cfv cop
      vz cv cop wceq wch vw cv cA cB cxp wcel vu cv vw cv vz cv cop wceq vu cv
      vw cv c1st cfv vw cv c2nd cfv cop vz cv cop wceq vw cv cA cB cxp wcel vw
      cv vz cv cop vw cv c1st cfv vw cv c2nd cfv cop vz cv cop vu cv vw cv cA
      cB cxp wcel vw cv vw cv c1st cfv vw cv c2nd cfv cop vz cv cA cB cxp wrel
      vw cv cA cB cxp wcel vw cv vw cv c1st cfv vw cv c2nd cfv cop wceq cA cB
      relxp vw cv cA cB cxp 1st2nd mpan opeq1d eqeq2d biimpac adantrr vw cv cA
      cB cxp wcel vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa vu cv vw cv
      vz cv cop wceq wch vw cv cA cB cxp wcel vw cv c1st cfv cA wcel vw cv c2nd
      cfv cB wcel vw cv cA cB xp1st vw cv cA cB xp2nd jca ad2antrl vu cv vw cv
      vz cv cop wceq vw cv cA cB cxp wcel wch simprr vu cv vw cv c1st cfv vw cv
      c2nd cfv cop vz cv cop wceq vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel
      wa wch wa wa vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB
      wcel wa wph wa wa vx wex vy wex vu cv vx cv vy cv cop vz cv cop wceq vx
      cv cA wcel vy cv cB wcel wa wph wa wa vy wex vx wex vu cv vw cv c1st cfv
      vw cv c2nd cfv cop vz cv cop wceq vw cv c1st cfv cA wcel vw cv c2nd cfv
      cB wcel wa wch wa wa vu cv vw cv c1st cfv vy cv cop vz cv cop wceq vw cv
      c1st cfv cA wcel vy cv cB wcel wa wps wa wa vy wex vu cv vx cv vy cv cop
      vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vx wex vy wex vw
      cv c2nd cfv cvv wcel vu cv vw cv c1st cfv vw cv c2nd cfv cop vz cv cop
      wceq vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa wch wa wa vu cv vw
      cv c1st cfv vy cv cop vz cv cop wceq vw cv c1st cfv cA wcel vy cv cB wcel
      wa wps wa wa vy wex wi vw cv c2nd fvex vu cv vw cv c1st cfv vy cv cop vz
      cv cop wceq vw cv c1st cfv cA wcel vy cv cB wcel wa wps wa wa vu cv vw cv
      c1st cfv vw cv c2nd cfv cop vz cv cop wceq vw cv c1st cfv cA wcel vw cv
      c2nd cfv cB wcel wa wch wa wa vy vv vw cv c2nd cfv cvv vv cv vw cv c2nd
      cfv wcel vy ax-17 vu cv vw cv c1st cfv vw cv c2nd cfv cop vz cv cop wceq
      vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa wch wa vy vu cv vw cv
      c1st cfv vw cv c2nd cfv cop vz cv cop wceq vy ax-17 vw cv c1st cfv cA
      wcel vw cv c2nd cfv cB wcel wa wch vy vw cv c1st cfv cA wcel vw cv c2nd
      cfv cB wcel wa vy ax-17 oprabopabf.2 hban hban vy cv vw cv c2nd cfv wceq
      vu cv vw cv c1st cfv vy cv cop vz cv cop wceq vu cv vw cv c1st cfv vw cv
      c2nd cfv cop vz cv cop wceq vw cv c1st cfv cA wcel vy cv cB wcel wa wps
      wa vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa wch wa vy cv vw cv
      c2nd cfv wceq vw cv c1st cfv vy cv cop vz cv cop vw cv c1st cfv vw cv
      c2nd cfv cop vz cv cop vu cv vy cv vw cv c2nd cfv wceq vw cv c1st cfv vy
      cv cop vw cv c1st cfv vw cv c2nd cfv cop vz cv vy cv vw cv c2nd cfv vw cv
      c1st cfv opeq2 opeq1d eqeq2d vy cv vw cv c2nd cfv wceq vw cv c1st cfv cA
      wcel vy cv cB wcel wa vw cv c1st cfv cA wcel vw cv c2nd cfv cB wcel wa
      wps wch vy cv vw cv c2nd cfv wceq vy cv cB wcel vw cv c2nd cfv cB wcel vw
      cv c1st cfv cA wcel vy cv vw cv c2nd cfv cB eleq1 anbi2d oprabopabf.4
      anbi12d anbi12d cla4egf ax-mp vu cv vw cv c1st cfv vy cv cop vz cv cop
      wceq vw cv c1st cfv cA wcel vy cv cB wcel wa wps wa wa vu cv vx cv vy cv
      cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vx wex vy vw
      cv c1st cfv cvv wcel vu cv vw cv c1st cfv vy cv cop vz cv cop wceq vw cv
      c1st cfv cA wcel vy cv cB wcel wa wps wa wa vu cv vx cv vy cv cop vz cv
      cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vx wex wi vw cv c1st
      fvex vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa
      wph wa wa vu cv vw cv c1st cfv vy cv cop vz cv cop wceq vw cv c1st cfv cA
      wcel vy cv cB wcel wa wps wa wa vx vv vw cv c1st cfv cvv vv cv vw cv c1st
      cfv wcel vx ax-17 vu cv vw cv c1st cfv vy cv cop vz cv cop wceq vw cv
      c1st cfv cA wcel vy cv cB wcel wa wps wa vx vu cv vw cv c1st cfv vy cv
      cop vz cv cop wceq vx ax-17 vw cv c1st cfv cA wcel vy cv cB wcel wa wps
      vx vw cv c1st cfv cA wcel vy cv cB wcel wa vx ax-17 oprabopabf.1 hban
      hban vx cv vw cv c1st cfv wceq vu cv vx cv vy cv cop vz cv cop wceq vu cv
      vw cv c1st cfv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa
      wph wa vw cv c1st cfv cA wcel vy cv cB wcel wa wps wa vx cv vw cv c1st
      cfv wceq vx cv vy cv cop vz cv cop vw cv c1st cfv vy cv cop vz cv cop vu
      cv vx cv vw cv c1st cfv wceq vx cv vy cv cop vw cv c1st cfv vy cv cop vz
      cv vx cv vw cv c1st cfv vy cv opeq1 opeq1d eqeq2d vx cv vw cv c1st cfv
      wceq vx cv cA wcel vy cv cB wcel wa vw cv c1st cfv cA wcel vy cv cB wcel
      wa wph wps vx cv vw cv c1st cfv wceq vx cv cA wcel vw cv c1st cfv cA wcel
      vy cv cB wcel vx cv vw cv c1st cfv cA eleq1 anbi1d oprabopabf.3 anbi12d
      anbi12d cla4egf ax-mp 19.22i syl vu cv vx cv vy cv cop vz cv cop wceq vx
      cv cA wcel vy cv cB wcel wa wph wa wa vy vx excom sylib sylan32c 19.23aiv
      impbii exbii vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB
      wcel wa wph wa wa vz wex vy wex vx wex vu cv vx cv vy cv cop vz cv cop
      wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vy wex vz wex vx wex vu cv
      vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa
      vy wex vx wex vz wex vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel
      vy cv cB wcel wa wph wa wa vz wex vy wex vu cv vx cv vy cv cop vz cv cop
      wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vy wex vz wex vx vu cv vx
      cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv cB wcel wa wph wa wa vy
      vz excom exbii vu cv vx cv vy cv cop vz cv cop wceq vx cv cA wcel vy cv
      cB wcel wa wph wa wa vy wex vx vz excom bitri vu cv vw cv vz cv cop wceq
      vw cv cA cB cxp wcel wch wa wa vw vz excom 3bitr4i abbii vx cv cA wcel vy
      cv cB wcel wa wph wa vx vy vz vu df-oprab vw cv cA cB cxp wcel wch wa vw
      vz vu df-opab 3eqtr4i $.
      $( [1-Dec-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d A w x y z $. $d B w x y z $. $d ph w $. $d ps x $. $d ch y $.
    oprabopab.1 $e |- ( x = ( 1st ` w ) -> ( ph <-> ps ) ) $.
    oprabopab.2 $e |- ( y = ( 2nd ` w ) -> ( ps <-> ch ) ) $.
    $( Convert between operator and function class abstractions using
       ` 1st ` and ` 2nd ` . (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    oprabopab $p |- { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ph ) }
                          = { <. w , z >. | ( w e. ( A X. B ) /\ ch ) } $=
      wph wps wch vx vy vz vw cA cB wps vx ax-17 wch vy ax-17 oprabopab.1
      oprabopab.2 oprabopabf $.
      $( [1-Dec-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y z $. $d B u v w x y z $. $d C u v w z $.
    $d D u v w x y z $. $d F u v $. $d G u v z $. $d H u v w x y z $.
    oprabco.1 $e |- ( ( x e. A /\ y e. B ) -> C e. D ) $.
    oprabco.2 $e |- F = { <. <. x , y >. , z >. |
                                ( ( x e. A /\ y e. B ) /\ z = C ) } $.
    oprabco.3 $e |- G = { <. <. x , y >. , w >. |
                                ( ( x e. A /\ y e. B ) /\ w = ( H ` C ) ) } $.
    $( Composition of a function with an operator abstraction.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    oprabco $p |- ( H Fn D -> G = ( H o. F ) ) $=
      cH cD wfn cG cH cF ccom wceq cA cB cxp cA cB cxp wceq vu cv cG cfv vu cv
      cH cF ccom cfv wceq vu cA cB cxp wral wa cH cD wfn cA cB cxp cA cB cxp
      wceq vu cv cG cfv vu cv cH cF ccom cfv wceq vu cA cB cxp wral cH cD wfn
      cA cB cxp eqidd cH cD wfn vu cv cG cfv vu cv cH cF ccom cfv wceq vu cA cB
      cxp cH cD wfn vu cv cA cB cxp wcel wa vu cv cF cfv cH cfv vy vu cv c2nd
      cfv vx vu cv c1st cfv cC cH cfv csb csb vu cv cH cF ccom cfv vu cv cG cfv
      cH cD wfn vu cv cA cB cxp wcel wa vu cv cF cfv cH cfv vy vu cv c2nd cfv
      vx vu cv c1st cfv cC csb csb cH cfv vy vu cv c2nd cfv vx vu cv c1st cfv
      cC cH cfv csb csb cH cD wfn vu cv cA cB cxp wcel wa vu cv cF cfv vy vu cv
      c2nd cfv vx vu cv c1st cfv cC csb csb cH vu cv cA cB cxp wcel vu cv cF
      cfv vy vu cv c2nd cfv vx vu cv c1st cfv cC csb csb wceq cH cD wfn vu cv
      cA cB cxp wcel vy vu cv c2nd cfv vx vu cv c1st cfv cC csb csb cD wcel vu
      cv cF cfv vy vu cv c2nd cfv vx vu cv c1st cfv cC csb csb wceq vu cv c1st
      cfv cA wcel vu cv c2nd cfv cB wcel vy vu cv c2nd cfv vx vu cv c1st cfv cC
      csb csb cD wcel vu cv cA cB cxp wcel vu cv c1st cfv cA wcel vu cv c2nd
      cfv cB wcel wa cC cD wcel vy cB wral vx cA wral vy vu cv c2nd cfv vx vu
      cv c1st cfv cC csb csb cD wcel cC cD wcel vx vy cA cB oprabco.1 rgen2 vu
      cv c1st cfv cA wcel cC cD wcel vy cB wral vx cA wral vx vu cv c1st cfv cC
      csb cD wcel vy cB wral vu cv c2nd cfv cB wcel vy vu cv c2nd cfv vx vu cv
      c1st cfv cC csb csb cD wcel cC cD wcel vy cB wral vx vu cv c1st cfv cC
      csb cD wcel vy cB wral vx vu cv c1st cfv cA vx vu cv c1st cfv cC csb cD
      wcel vx vy cB vy cv cB wcel vx ax-17 vx vv vv vx vu cv c1st cfv cC csb cD
      vx vv vu cv c1st cfv cC vu cv c1st fvex vv cv vu cv c1st cfv wcel vx
      ax-17 hbcsb1 vv cv cD wcel vx ax-17 hbel hbral vx cv vu cv c1st cfv wceq
      cC cD wcel vx vu cv c1st cfv cC csb cD wcel vy cB vx cv vu cv c1st cfv
      wceq cC vx vu cv c1st cfv cC csb cD vx vu cv c1st cfv cC csbeq1a eleq1d
      ralbidv rcla4 vx vu cv c1st cfv cC csb cD wcel vy vu cv c2nd cfv vx vu cv
      c1st cfv cC csb csb cD wcel vy vu cv c2nd cfv cB vy vv vv vy vu cv c2nd
      cfv vx vu cv c1st cfv cC csb csb cD vy vv vu cv c2nd cfv vx vu cv c1st
      cfv cC csb vu cv c2nd fvex vv cv vu cv c2nd cfv wcel vy ax-17 hbcsb1 vv
      cv cD wcel vy ax-17 hbel vy cv vu cv c2nd cfv wceq vx vu cv c1st cfv cC
      csb vy vu cv c2nd cfv vx vu cv c1st cfv cC csb csb cD vy vu cv c2nd cfv
      vx vu cv c1st cfv cC csb csbeq1a eleq1d rcla4 sylan9 mpi vu cv cA cB
      xp1st vu cv cA cB xp2nd sylanc vv vz vu cv vy vv cv c2nd cfv vx vv cv
      c1st cfv cC csb csb vy vu cv c2nd cfv vx vu cv c1st cfv cC csb csb cA cB
      cxp cD cF vv cv vu cv wceq vy vv cv c2nd cfv vx vv cv c1st cfv cC csb csb
      vy vu cv c2nd cfv vx vv cv c1st cfv cC csb csb vy vu cv c2nd cfv vx vu cv
      c1st cfv cC csb csb vv cv vu cv wceq vy vv cv c2nd cfv vu cv c2nd cfv vx
      vv cv c1st cfv cC csb vv cv vu cv c2nd fveq2 csbeq1d vv cv vu cv wceq vu
      cv c2nd cfv cvv wcel vy vu cv c2nd cfv vx vv cv c1st cfv cC csb csb vy vu
      cv c2nd cfv vx vu cv c1st cfv cC csb csb wceq vu cv c2nd fvex vv cv vu cv
      wceq vy vu cv c2nd cfv vx vv cv c1st cfv cC csb vx vu cv c1st cfv cC csb
      cvv vv cv vu cv wceq vx vv cv c1st cfv vu cv c1st cfv cC vv cv vu cv c1st
      fveq2 csbeq1d csbeq2dv mpan2 eqtrd cF vx cv cA wcel vy cv cB wcel wa vz
      cv cC wceq wa vx vy vz copab2 vv cv cA cB cxp wcel vz cv vy vv cv c2nd
      cfv vx vv cv c1st cfv cC csb csb wceq wa vv vz copab oprabco.2 vz cv cC
      wceq vz cv vx vv cv c1st cfv cC csb wceq vz cv vy vv cv c2nd cfv vx vv cv
      c1st cfv cC csb csb wceq vx vy vz vv cA cB vx vu vu vz cv vx vv cv c1st
      cfv cC csb vu cv vz cv wcel vx ax-17 vx vu vv cv c1st cfv cC vv cv c1st
      fvex vu cv vv cv c1st cfv wcel vx ax-17 hbcsb1 hbeq vy vu vu vz cv vy vv
      cv c2nd cfv vx vv cv c1st cfv cC csb csb vu cv vz cv wcel vy ax-17 vy vu
      vv cv c2nd cfv vx vv cv c1st cfv cC csb vv cv c2nd fvex vu cv vv cv c2nd
      cfv wcel vy ax-17 hbcsb1 hbeq vx cv vv cv c1st cfv wceq cC vx vv cv c1st
      cfv cC csb vz cv vx vv cv c1st cfv cC csbeq1a eqeq2d vy cv vv cv c2nd cfv
      wceq vx vv cv c1st cfv cC csb vy vv cv c2nd cfv vx vv cv c1st cfv cC csb
      csb vz cv vy vv cv c2nd cfv vx vv cv c1st cfv cC csb csbeq1a eqeq2d
      oprabopabf eqtri fvopab4g mpdan adantl fveq2d vy vu cv c2nd cfv vx vu cv
      c1st cfv cC cH cfv csb csb vy vu cv c2nd cfv vx vu cv c1st cfv cC csb cH
      cfv csb vy vu cv c2nd cfv vx vu cv c1st cfv cC csb csb cH cfv vu cv c2nd
      cfv cvv wcel vy vu cv c2nd cfv vx vu cv c1st cfv cC cH cfv csb csb vy vu
      cv c2nd cfv vx vu cv c1st cfv cC csb cH cfv csb wceq vu cv c2nd fvex vy
      vu cv c2nd cfv vx vu cv c1st cfv cC cH cfv csb vx vu cv c1st cfv cC csb
      cH cfv cvv vu cv c1st cfv cvv wcel vx vu cv c1st cfv cC cH cfv csb vx vu
      cv c1st cfv cC csb cH cfv wceq vu cv c1st fvex vx vu cv c1st cfv cC cvv
      cH csbfv2g ax-mp csbeq2i ax-mp vu cv c2nd cfv cvv wcel vy vu cv c2nd cfv
      vx vu cv c1st cfv cC csb cH cfv csb vy vu cv c2nd cfv vx vu cv c1st cfv
      cC csb csb cH cfv wceq vu cv c2nd fvex vy vu cv c2nd cfv vx vu cv c1st
      cfv cC csb cvv cH csbfv2g ax-mp eqtri syl6eqr cH wfun cF wfun vu cv cF
      cdm wcel vu cv cH cF ccom cfv vu cv cF cfv cH cfv wceq cH cD wfn vu cv cA
      cB cxp wcel wa vu cv cH cF fvco cH cD wfn cH wfun vu cv cA cB cxp wcel cD
      cH fnfun adantr cF wfun cH cD wfn vu cv cA cB cxp wcel wa cF cA cB cxp
      wfn cF wfun cA cB cxp cD cF wf cF cA cB cxp wfn vx vy vz cA cB cC cD cF
      oprabco.2 oprabco.1 foprab cA cB cxp cD cF ffn ax-mp cA cB cxp cF fnfun
      ax-mp a1i vu cv cA cB cxp wcel vu cv cF cdm wcel cH cD wfn vu cv cF cdm
      wcel vu cv cA cB cxp wcel cF cdm cA cB cxp vu cv cA cB cxp cD cF vx vy vz
      cA cB cC cD cF oprabco.2 oprabco.1 foprab fdmi eleq2i biimpri adantl
      syl3anc vu cv cA cB cxp wcel vu cv cG cfv vy vu cv c2nd cfv vx vu cv c1st
      cfv cC cH cfv csb csb wceq cH cD wfn vu cv cA cB cxp wcel vy vu cv c2nd
      cfv vx vu cv c1st cfv cC cH cfv csb csb cvv wcel vu cv cG cfv vy vu cv
      c2nd cfv vx vu cv c1st cfv cC cH cfv csb csb wceq vy vu cv c2nd cfv vx vu
      cv c1st cfv cC cH cfv csb vu cv c2nd fvex vx vu cv c1st cfv cC cH cfv vu
      cv c1st fvex cC cH fvex csbex csbex vv vw vu cv vy vv cv c2nd cfv vx vv
      cv c1st cfv cC cH cfv csb csb vy vu cv c2nd cfv vx vu cv c1st cfv cC cH
      cfv csb csb cA cB cxp cvv cG vv cv vu cv wceq vy vv cv c2nd cfv vx vv cv
      c1st cfv cC cH cfv csb csb vy vu cv c2nd cfv vx vv cv c1st cfv cC cH cfv
      csb csb vy vu cv c2nd cfv vx vu cv c1st cfv cC cH cfv csb csb vv cv vu cv
      wceq vy vv cv c2nd cfv vu cv c2nd cfv vx vv cv c1st cfv cC cH cfv csb vv
      cv vu cv c2nd fveq2 csbeq1d vv cv vu cv wceq vu cv c2nd cfv cvv wcel vy
      vu cv c2nd cfv vx vv cv c1st cfv cC cH cfv csb csb vy vu cv c2nd cfv vx
      vu cv c1st cfv cC cH cfv csb csb wceq vu cv c2nd fvex vv cv vu cv wceq vy
      vu cv c2nd cfv vx vv cv c1st cfv cC cH cfv csb vx vu cv c1st cfv cC cH
      cfv csb cvv vv cv vu cv wceq vx vv cv c1st cfv vu cv c1st cfv cC cH cfv
      vv cv vu cv c1st fveq2 csbeq1d csbeq2dv mpan2 eqtrd cG vx cv cA wcel vy
      cv cB wcel wa vw cv cC cH cfv wceq wa vx vy vw copab2 vv cv cA cB cxp
      wcel vw cv vy vv cv c2nd cfv vx vv cv c1st cfv cC cH cfv csb csb wceq wa
      vv vw copab oprabco.3 vw cv cC cH cfv wceq vw cv vx vv cv c1st cfv cC cH
      cfv csb wceq vw cv vy vv cv c2nd cfv vx vv cv c1st cfv cC cH cfv csb csb
      wceq vx vy vw vv cA cB vx vu vu vw cv vx vv cv c1st cfv cC cH cfv csb vu
      cv vw cv wcel vx ax-17 vx vu vv cv c1st cfv cC cH cfv vv cv c1st fvex vu
      cv vv cv c1st cfv wcel vx ax-17 hbcsb1 hbeq vy vu vu vw cv vy vv cv c2nd
      cfv vx vv cv c1st cfv cC cH cfv csb csb vu cv vw cv wcel vy ax-17 vy vu
      vv cv c2nd cfv vx vv cv c1st cfv cC cH cfv csb vv cv c2nd fvex vu cv vv
      cv c2nd cfv wcel vy ax-17 hbcsb1 hbeq vx cv vv cv c1st cfv wceq cC cH cfv
      vx vv cv c1st cfv cC cH cfv csb vw cv vx vv cv c1st cfv cC cH cfv csbeq1a
      eqeq2d vy cv vv cv c2nd cfv wceq vx vv cv c1st cfv cC cH cfv csb vy vv cv
      c2nd cfv vx vv cv c1st cfv cC cH cfv csb csb vw cv vy vv cv c2nd cfv vx
      vv cv c1st cfv cC cH cfv csb csbeq1a eqeq2d oprabopabf eqtri fvopab4g
      mpan2 adantl 3eqtr4rd r19.21aiva jca cG cA cB cxp wfn cH cF ccom cA cB
      cxp wfn cG cH cF ccom wceq cA cB cxp cA cB cxp wceq vu cv cG cfv vu cv cH
      cF ccom cfv wceq vu cA cB cxp wral wa wb cH cD wfn vu cA cB cxp cA cB cxp
      cG cH cF ccom eqfnfv vx vy vw cA cB cC cH cfv cG cC cH fvex oprabco.3
      fnoprab2 cH cD wfn cF cA cB cxp wfn cF crn cD wss cH cF ccom cA cB cxp
      wfn cA cB cxp cD cF wf cF cA cB cxp wfn vx vy vz cA cB cC cD cF oprabco.2
      oprabco.1 foprab cA cB cxp cD cF ffn ax-mp cA cB cxp cD cF wf cF crn cD
      wss vx vy vz cA cB cC cD cF oprabco.2 oprabco.1 foprab cA cB cxp cD cF
      frn ax-mp cD cA cB cxp cH cF fnco mp3an23 sylancr mpbird $.
      $( [1-Dec-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z w $. $d B x y z w $. $d C z w $. $d D z w $.
    $d R x y z w $. $d S x y z w $. $d M x y z w $. $d F w $. $d G z $.
    oprab2co.1 $e |- ( ( x e. A /\ y e. B ) -> C e. R ) $.
    oprab2co.2 $e |- ( ( x e. A /\ y e. B ) -> D e. S ) $.
    oprab2co.3 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
                                                  /\ z = <. C , D >. ) } $.
    oprab2co.4 $e |- G = { <. <. x , y >. , w >. | ( ( x e. A /\ y e. B )
                                                  /\ w = ( C M D ) ) } $.
    $( Composition of operator abstractions.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    oprab2co $p |- ( M Fn ( R X. S ) -> G = ( M o. F ) ) $=
      vx vy vz vw cA cB cC cD cop cR cS cxp cF cG cM cC cR wcel cD cS wcel cC
      cD cop cR cS cxp wcel vx cv cA wcel vy cv cB wcel wa cC cD cR cS opelxpi
      oprab2co.1 oprab2co.2 sylanc oprab2co.3 cG vx cv cA wcel vy cv cB wcel wa
      vw cv cC cD cM co wceq wa vx vy vw copab2 vx cv cA wcel vy cv cB wcel wa
      vw cv cC cD cop cM cfv wceq wa vx vy vw copab2 oprab2co.4 vx cv cA wcel
      vy cv cB wcel wa vw cv cC cD cM co wceq wa vx cv cA wcel vy cv cB wcel wa
      vw cv cC cD cop cM cfv wceq wa vx vy vw vw cv cC cD cM co wceq vw cv cC
      cD cop cM cfv wceq vx cv cA wcel vy cv cB wcel wa cC cD cM co cC cD cop
      cM cfv vw cv cC cD cM df-opr eqeq2i anbi2i oprabbii eqtri oprabco $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $( Membership in the preimage of a set under a function.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    elpreima $p |- ( F Fn A -> ( B e. ( `' F " C )
                                <-> ( B e. A /\ ( F ` B ) e. C ) ) ) $=
      cF cA wfn cB cF ccnv cC cima wcel cB cA wcel cB cF cfv cC wcel wa cF cA
      wfn cB cF ccnv cC cima wcel cB cA wcel cB cF cfv cC wcel cF cA wfn cB cF
      cdm wcel cB cA wcel cB cF ccnv cC cima wcel cF cA wfn cF cdm cA cB cA cF
      fndm eleq2d cF ccnv cC cima cF cdm cB cF cC cnvimass sseli syl5bi cF cA
      wfn cB cF ccnv cC cima wcel cB cF cfv cC wcel cF wfun cB cF ccnv cC cima
      wcel cB cF cfv cC wcel cF cA wfn cB cC cF fvimacnvi cA cF fnfun sylan ex
      jcad cF cA wfn cB cA wcel cB cF cfv cC wcel cB cF ccnv cC cima wcel cF cA
      wfn cB cA wcel wa cB cF cfv cC wcel cB cF ccnv cC cima wcel cB cF cfv cC
      wcel cB cF ccnv cC cima wcel wb cA cB cF cB cC cF fvimacnv funfni biimpd
      expimpd impbid $.
      $( [1-Dec-2010] $)  $( [2-Sep-2009] $)
  $}

  $( The empty set is finite.  (Contributed by FL, 2-Sep-2008.) $)
  emfin $p |- (/) e. Fin $=
    c0 com wcel c0 c0 wss c0 cfn wcel peano1 c0 ssid c0 c0 ssnnfi mp2an $.
    $( [1-Dec-2010] $) $( [14-Jul-2008] $)

  $( If a union is finite, the operands are finite.  (Contributed by FL,
     3-Aug-2009.) $)
  unfin $p |- ( ( A u. B ) e. Fin -> ( A e. Fin /\ B e. Fin ) ) $=
    cA cB cun cfn wcel cA cfn wcel cB cfn wcel cA cB cun cfn wcel cA cA cB cun
    wss cA cfn wcel cA cB ssun1 cA cB cun cA ssfi mpan2 cA cB cun cfn wcel cB
    cA cB cun wss cB cfn wcel cB cA ssun2 cA cB cun cB ssfi mpan2 jca $.
    $( [1-Dec-2010] $) $( [10-Jul-2009] $)

  $( If ` A ` is finite, ` ( A \ B ) ` is finite.  (Contributed by FL,
     3-Aug-2009.) $)
  finfin $p |- ( A e. Fin -> ( A \ B ) e. Fin ) $=
    cA cfn wcel cA cB cdif cA wss cA cB cdif cfn wcel cA cB difss cA cA cB cdif
    ssfi mpan2 $.
    $( [1-Dec-2010] $) $( [10-Jul-2009] $)

  $( An infinite set ` A ` minus a finite set is infinite.
     (Contributed by FL, 3-Aug-2009.) $)
  islfin $p |- ( ( -. A e. Fin /\ B e. Fin  ) -> -. ( A \ B ) e. Fin ) $=
    cB cfn wcel cA cfn wcel wn cA cB cdif cfn wcel wn cB cfn wcel cA cB cdif
    cfn wcel cA cfn wcel cA cB cdif cfn wcel cB cfn wcel cA cfn wcel cA cB cdif
    cfn wcel cB cfn wcel wa cA cB cdif cB cun cfn wcel cA cfn wcel cA cB cdif
    cB unfi cA cB cdif cB cun cfn wcel cA cB cun cfn wcel cA cfn wcel cA cB
    cdif cB cun cA cB cun cfn cA cB undif1 eleq1i cA cB cun cfn wcel cA cfn
    wcel cB cfn wcel cA cB unfin pm3.26d sylbi syl expcom con3d impcom $.
    $( [1-Dec-2010] $) $( [10-Jul-2009] $)

  ${
    $( Multiplication of both sides of 'less than or equal to' by a nonnegative
       number.  (Contributed by Paul Chapman, 7-Sep-2007.) $)
    lemul2aALT $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 <_ C ) ) ->
                        ( A <_ B -> ( C x. A ) <_ ( C x. B ) ) ) $=
      cA cr wcel cB cr wcel cC cr wcel cc0 cC cle wbr wa w3a cA cB cle wbr cC
      cA cmul co cC cB cmul co cle wbr cA cB cC lemul2a ex $.
      $( [1-Dec-2010] $) $( [7-Sep-2007] $)
  $}

  ${
    $d M m $.
    $( A finite interval of integers with one element.  (Contributed by
       Jeff Madsen, 2-Sep-2009 ) $)
    fzsn $p |- ( M e. ZZ -> ( M ... M ) = { M } ) $=
      cM cz wcel vm cM cM cfz co cM csn cM cz wcel vm cv cM cM cfz co wcel vm
      cv cM wceq vm cv cM csn wcel cM cz wcel vm cv cM cM cfz co wcel vm cv cM
      wceq vm cv cM elfz1eq vm cv cM wceq vm cv cM cM cfz co wcel cM cM cM cfz
      co wcel cM cz wcel vm cv cM cM cM cfz co eleq1 cM elfz3 syl5cbir impbid2
      vm cM elsn syl6bbr eqrdv $.
      $( [1-Dec-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d M m $.
    $( A finite interval of integers with two elements. (Contributed by
       Jeff Madsen, 2-Sep-2009 ) $)
    fzpr $p |- ( M e. ZZ -> ( M ... ( M + 1 ) ) = { M , ( M + 1 ) } ) $=
      cM cz wcel vm cM cM c1 caddc co cfz co cM cM c1 caddc co cpr cM cz wcel
      vm cv cM cM c1 caddc co cfz co wcel vm cv cM wceq vm cv cM c1 caddc co
      wceq wo vm cv cM cM c1 caddc co cpr wcel cM cz wcel vm cv cM cM c1 caddc
      co cfz co wcel vm cv cM cM cfz co wcel vm cv cM c1 caddc co wceq wo vm cv
      cM wceq vm cv cM c1 caddc co wceq wo cM cz wcel cM cM cuz cfv wcel vm cv
      cM cM c1 caddc co cfz co wcel vm cv cM cM cfz co wcel vm cv cM c1 caddc
      co wceq wo wb cM uzid vm cv cM cM elfzp1 syl cM cz wcel vm cv cM cM cfz
      co wcel vm cv cM wceq vm cv cM c1 caddc co wceq cM cz wcel vm cv cM cM
      cfz co wcel vm cv cM csn wcel vm cv cM wceq cM cz wcel cM cM cfz co cM
      csn vm cv cM fzsn eleq2d vm cM elsn syl6bb orbi1d bitrd vm cv cM cM c1
      caddc co vm visset elpr syl6bbr eqrdv $.
      $( [1-Dec-2010] $)  $( [2-Sep-2009] $)
  $}

  ${
    $d A x $.  $d B x $.
    $( The class difference of ` RR ` and a closed interval.  (Contributed by
       FL, 18-Jun-2007.) $)
    cdrci $p |- ( ( A e. RR /\ B e. RR ) -> ( RR \ ( A [,] B ) ) =
      U. { ( -oo (,) A ) , ( B (,) +oo ) } ) $=
      cA cr wcel cB cr wcel wa vx cr cA cB cicc co cdif cmnf cA cioo co cB cpnf
      cioo co cpr cuni cA cr wcel cB cr wcel wa vx cv cr wcel vx cv cA cB cicc
      co wcel wn wa vx cv cmnf cA cioo co cB cpnf cioo co cpr cuni wcel vx cv
      cr cA cB cicc co cdif wcel cA cr wcel cB cr wcel wa vx cv cr wcel vx cv
      cA cB cicc co wcel wn wa vx cv cmnf cA cioo co cB cpnf cioo co cun wcel
      vx cv cmnf cA cioo co cB cpnf cioo co cpr cuni wcel cA cr wcel cB cr wcel
      wa vx cv cr wcel vx cv cA cB cicc co wcel wn wa vx cv cmnf cA cioo co cB
      cpnf cioo co cun wcel cA cr wcel cB cr wcel wa vx cv cr wcel vx cv cA cB
      cicc co wcel wn wa vx cv cmnf cA cioo co wcel vx cv cB cpnf cioo co wcel
      wo vx cv cmnf cA cioo co cB cpnf cioo co cun wcel cA cr wcel cB cr wcel
      wa vx cv cr wcel vx cv cA cB cicc co wcel wn vx cv cmnf cA cioo co wcel
      vx cv cB cpnf cioo co wcel wo cA cr wcel cB cr wcel wa vx cv cr wcel wa
      vx cv cA cB cicc co wcel wn vx cv cxr wcel cA vx cv cle wbr vx cv cB cle
      wbr w3a wn vx cv cmnf cA cioo co wcel vx cv cB cpnf cioo co wcel wo cA cr
      wcel cB cr wcel wa vx cv cr wcel wa vx cv cA cB cicc co wcel vx cv cxr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel wa vx cv
      cA cB cicc co wcel vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      wb vx cv cr wcel cA cxr wcel cB cxr wcel vx cv cA cB cicc co wcel vx cv
      cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wb cA cr wcel cB cr wcel
      cA cB vx cv elicc1 cA rexr cB rexr syl2an adantr notbid cA cr wcel cB cr
      wcel wa vx cv cr wcel wa vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr
      wa wa wn vx cv cmnf cA cioo co wcel vx cv cB cpnf cioo co wcel wo vx cv
      cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wn cA cr wcel cB cr wcel
      wa vx cv cr wcel wa vx cv cxr wcel wn cA vx cv cle wbr vx cv cB cle wbr
      wa wn wo vx cv cmnf cA cioo co wcel vx cv cB cpnf cioo co wcel wo vx cv
      cxr wcel cA vx cv cle wbr vx cv cB cle wbr wa wa wn cA cr wcel cB cr wcel
      wa vx cv cr wcel wa vx cv cxr wcel wn vx cv cmnf cA cioo co wcel vx cv cB
      cpnf cioo co wcel wo cA vx cv cle wbr vx cv cB cle wbr wa wn vx cv cr
      wcel vx cv cxr wcel wn vx cv cmnf cA cioo co wcel vx cv cB cpnf cioo co
      wcel wo wi cA cr wcel cB cr wcel wa vx cv cr wcel vx cv cxr wcel vx cv
      cmnf cA cioo co wcel vx cv cB cpnf cioo co wcel wo vx cv rexr pm2.24d
      adantl cA cr wcel cB cr wcel wa vx cv cr wcel wa cA vx cv cle wbr wn vx
      cv cB cle wbr wn wo vx cv cmnf cA cioo co wcel vx cv cB cpnf cioo co wcel
      wo cA vx cv cle wbr vx cv cB cle wbr wa wn cA cr wcel cB cr wcel wa vx cv
      cr wcel wa cA vx cv cle wbr wn vx cv cmnf cA cioo co wcel vx cv cB cle
      wbr wn vx cv cB cpnf cioo co wcel cA cr wcel cB cr wcel wa vx cv cr wcel
      wa cA vx cv cle wbr wn vx cv cmnf cA cioo co wcel cA cr wcel cB cr wcel
      wa vx cv cr wcel wa cA vx cv cle wbr wn wa vx cv cmnf cA cioo co wcel vx
      cv cxr wcel cmnf vx cv clt wbr vx cv cA clt wbr w3a cA cr wcel cB cr wcel
      wa vx cv cr wcel wa cA vx cv cle wbr wn wa vx cv cxr wcel cmnf vx cv clt
      wbr vx cv cA clt wbr vx cv cr wcel vx cv cxr wcel cA cr wcel cB cr wcel
      wa cA vx cv cle wbr wn vx cv rexr ad2antlr vx cv cr wcel cmnf vx cv clt
      wbr cA cr wcel cB cr wcel wa cA vx cv cle wbr wn vx cv mnflt ad2antlr cA
      cr wcel cB cr wcel wa vx cv cr wcel wa cA vx cv cle wbr wn vx cv cA clt
      wbr vx cv cr wcel cA cr wcel cA vx cv cle wbr wn vx cv cA clt wbr wb cA
      cr wcel cB cr wcel wa vx cv cr wcel wa vx cv cr wcel cA cr wcel wa vx cv
      cA clt wbr cA vx cv cle wbr wn vx cv cA ltnle bicomd cA cr wcel cB cr
      wcel wa vx cv cr wcel pm3.27 cA cr wcel cB cr wcel vx cv cr wcel simpll
      sylanc biimpa 3jca cA cr wcel cB cr wcel wa vx cv cr wcel wa cA vx cv cle
      wbr wn wa cmnf cxr wcel cA cxr wcel wa vx cv cmnf cA cioo co wcel vx cv
      cxr wcel cmnf vx cv clt wbr vx cv cA clt wbr w3a wb cA cr wcel cB cr wcel
      wa vx cv cr wcel wa cA vx cv cle wbr wn wa cA cxr wcel cmnf cxr wcel cA
      cr wcel cB cr wcel wa cA cxr wcel vx cv cr wcel cA vx cv cle wbr wn cA cr
      wcel cA cxr wcel cB cr wcel cA rexr adantr ad2antrr mnfxr jctil cmnf cA
      vx cv elioo1 syl mpbird ex cA cr wcel cB cr wcel wa vx cv cr wcel wa vx
      cv cB cle wbr wn cB vx cv clt wbr vx cv cB cpnf cioo co wcel cB cr wcel
      vx cv cr wcel cB vx cv clt wbr vx cv cB cle wbr wn wb cA cr wcel cB vx cv
      ltnle adantll cA cr wcel cB cr wcel wa vx cv cr wcel wa cB vx cv clt wbr
      vx cv cB cpnf cioo co wcel cA cr wcel cB cr wcel wa vx cv cr wcel wa cB
      vx cv clt wbr wa vx cv cB cpnf cioo co wcel vx cv cxr wcel cB vx cv clt
      wbr vx cv cpnf clt wbr w3a cA cr wcel cB cr wcel wa vx cv cr wcel wa cB
      vx cv clt wbr wa vx cv cxr wcel cB vx cv clt wbr vx cv cpnf clt wbr vx cv
      cr wcel vx cv cxr wcel cA cr wcel cB cr wcel wa cB vx cv clt wbr vx cv
      rexr ad2antlr cA cr wcel cB cr wcel wa vx cv cr wcel wa cB vx cv clt wbr
      pm3.27 vx cv cr wcel vx cv cpnf clt wbr cA cr wcel cB cr wcel wa cB vx cv
      clt wbr vx cv ltpnf ad2antlr 3jca cA cr wcel cB cr wcel wa vx cv cr wcel
      wa cB vx cv clt wbr wa cB cxr wcel cpnf cxr wcel wa vx cv cB cpnf cioo co
      wcel vx cv cxr wcel cB vx cv clt wbr vx cv cpnf clt wbr w3a wb cA cr wcel
      cB cr wcel wa vx cv cr wcel wa cB vx cv clt wbr wa cB cxr wcel cpnf cxr
      wcel cA cr wcel cB cr wcel wa cB cxr wcel vx cv cr wcel cB vx cv clt wbr
      cB cr wcel cB cxr wcel cA cr wcel cB rexr adantl ad2antrr pnfxr jctir cB
      cpnf vx cv elioo1 syl mpbird ex sylbird orim12d cA vx cv cle wbr vx cv cB
      cle wbr ianor syl5ib jaod vx cv cxr wcel cA vx cv cle wbr vx cv cB cle
      wbr wa ianor syl5ib vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr wa wa vx cv cxr wcel cA
      vx cv cle wbr vx cv cB cle wbr 3anass notbii syl5ib sylbid expimpd vx cv
      cmnf cA cioo co cB cpnf cioo co elun syl6ibr cA cr wcel cB cr wcel wa vx
      cv cmnf cA cioo co cB cpnf cioo co cun wcel vx cv cr wcel vx cv cA cB
      cicc co wcel wn wa cA cr wcel cB cr wcel wa vx cv cmnf cA cioo co cB cpnf
      cioo co cun wcel wa vx cv cr wcel vx cv cA cB cicc co wcel wn vx cv cmnf
      cA cioo co cB cpnf cioo co cun wcel vx cv cr wcel cA cr wcel cB cr wcel
      wa cmnf cA cioo co cB cpnf cioo co cun cr vx cv cmnf cA cioo co cB cpnf
      cioo co cr cmnf cA ioossre cB cpnf ioossre unssi sseli adantl cA cr wcel
      cB cr wcel wa vx cv cmnf cA cioo co cB cpnf cioo co cun wcel wa vx cv cA
      cB cicc co wcel wn vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      wn cA cr wcel cB cr wcel wa vx cv cmnf cA cioo co cB cpnf cioo co cun
      wcel wa vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr wa wa wn vx cv
      cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wn cA cr wcel cB cr wcel
      wa vx cv cmnf cA cioo co cB cpnf cioo co cun wcel wa cA vx cv cle wbr vx
      cv cB cle wbr wa vx cv cxr wcel cA cr wcel cB cr wcel wa vx cv cmnf cA
      cioo co cB cpnf cioo co cun wcel wa cA vx cv cle wbr wn vx cv cB cle wbr
      wn wo cA vx cv cle wbr vx cv cB cle wbr wa wn cA cr wcel cB cr wcel wa vx
      cv cmnf cA cioo co cB cpnf cioo co cun wcel cA vx cv cle wbr wn vx cv cB
      cle wbr wn wo cA cr wcel cB cr wcel wa vx cv cmnf cA cioo co wcel vx cv
      cB cpnf cioo co wcel wo cA vx cv cle wbr wn vx cv cB cle wbr wn wo vx cv
      cmnf cA cioo co cB cpnf cioo co cun wcel cA cr wcel cB cr wcel wa vx cv
      cmnf cA cioo co wcel cA vx cv cle wbr wn vx cv cB cpnf cioo co wcel vx cv
      cB cle wbr wn cA cr wcel cB cr wcel wa vx cv cmnf cA cioo co wcel vx cv
      cr wcel cmnf vx cv clt wbr vx cv cA clt wbr w3a cA vx cv cle wbr wn cA cr
      wcel vx cv cmnf cA cioo co wcel vx cv cr wcel cmnf vx cv clt wbr vx cv cA
      clt wbr w3a wb cB cr wcel cmnf cxr wcel cA cr wcel vx cv cmnf cA cioo co
      wcel vx cv cr wcel cmnf vx cv clt wbr vx cv cA clt wbr w3a wb wi mnfxr
      cmnf cxr wcel cA cxr wcel vx cv cmnf cA cioo co wcel vx cv cr wcel cmnf
      vx cv clt wbr vx cv cA clt wbr w3a wb cA cr wcel cmnf cxr wcel cA cxr
      wcel vx cv cmnf cA cioo co wcel vx cv cr wcel cmnf vx cv clt wbr vx cv cA
      clt wbr w3a wb cmnf cA vx cv elioo2 ex cA rexr syl5 ax-mp adantr cA cr
      wcel cB cr wcel wa vx cv cr wcel cmnf vx cv clt wbr vx cv cA clt wbr cA
      vx cv cle wbr wn cA cr wcel vx cv cr wcel cmnf vx cv clt wbr vx cv cA clt
      wbr cA vx cv cle wbr wn wi wi wi cB cr wcel cmnf vx cv clt wbr vx cv cr
      wcel cA cr wcel vx cv cA clt wbr cA vx cv cle wbr wn wi vx cv cr wcel cA
      cr wcel vx cv cA clt wbr cA vx cv cle wbr wn wi wi wi cmnf vx cv clt wbr
      vx cv cr wcel cA cr wcel vx cv cA clt wbr cA vx cv cle wbr wn wi vx cv cr
      wcel cA cr wcel wa vx cv cA clt wbr cA vx cv cle wbr wn vx cv cA ltnle
      biimpd ex a1i com13 adantr 3impd sylbid cA cr wcel cB cr wcel wa vx cv cB
      cpnf cioo co wcel vx cv cxr wcel cB vx cv clt wbr vx cv cpnf clt wbr w3a
      vx cv cB cle wbr wn cA cr wcel cB cr wcel wa cB cxr wcel cpnf cxr wcel wa
      vx cv cB cpnf cioo co wcel vx cv cxr wcel cB vx cv clt wbr vx cv cpnf clt
      wbr w3a wb cA cr wcel cB cr wcel wa cB cxr wcel cpnf cxr wcel cB cr wcel
      cB cxr wcel cA cr wcel cB rexr adantl pnfxr jctir cB cpnf vx cv elioo1
      syl cA cr wcel cB cr wcel wa vx cv cxr wcel cB vx cv clt wbr vx cv cpnf
      clt wbr vx cv cB cle wbr wn cB cr wcel vx cv cxr wcel cB vx cv clt wbr vx
      cv cpnf clt wbr vx cv cB cle wbr wn wi wi wi cA cr wcel cB cr wcel cB cxr
      wcel vx cv cxr wcel cB vx cv clt wbr vx cv cpnf clt wbr vx cv cB cle wbr
      wn wi wi wi cB rexr vx cv cpnf clt wbr vx cv cxr wcel cB vx cv clt wbr cB
      cxr wcel vx cv cB cle wbr wn vx cv cxr wcel cB vx cv clt wbr cB cxr wcel
      vx cv cB cle wbr wn wi wi wi vx cv cpnf clt wbr cB cxr wcel vx cv cxr
      wcel cB vx cv clt wbr vx cv cB cle wbr wn cB cxr wcel vx cv cxr wcel cB
      vx cv clt wbr vx cv cB cle wbr wn wi cB cxr wcel vx cv cxr wcel wa cB vx
      cv clt wbr vx cv cB cle wbr wn cB vx cv xrltnle biimpd ex com3l a1i com14
      syl adantl 3impd sylbid orim12d vx cv cmnf cA cioo co cB cpnf cioo co
      elun syl5ib imp cA vx cv cle wbr vx cv cB cle wbr ianor sylibr intnand vx
      cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cxr wcel cA vx cv
      cle wbr vx cv cB cle wbr wa wa vx cv cxr wcel cA vx cv cle wbr vx cv cB
      cle wbr 3anass notbii sylibr cA cr wcel cB cr wcel wa vx cv cmnf cA cioo
      co cB cpnf cioo co cun wcel wa cA cxr wcel cB cxr wcel wa vx cv cA cB
      cicc co wcel wn vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wn
      wb cA cr wcel cB cr wcel wa cA cxr wcel cB cxr wcel wa vx cv cmnf cA cioo
      co cB cpnf cioo co cun wcel cA cr wcel cA cxr wcel cB cr wcel cB cxr wcel
      cA rexr cB rexr anim12i adantr cA cxr wcel cB cxr wcel wa vx cv cA cB
      cicc co wcel vx cv cxr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cB
      vx cv elicc1 notbid syl mpbird jca ex impbid cA cr wcel cB cr wcel wa
      cmnf cA cioo co cB cpnf cioo co cun cmnf cA cioo co cB cpnf cioo co cpr
      cuni vx cv cA cr wcel cB cr wcel wa cmnf cA cioo co cvv wcel cB cpnf cioo
      co cvv wcel wa cmnf cA cioo co cB cpnf cioo co cun cmnf cA cioo co cB
      cpnf cioo co cpr cuni wceq cmnf cA cioo co cvv wcel cB cpnf cioo co cvv
      wcel wa cA cr wcel cB cr wcel wa cmnf cA cioo co cvv wcel cB cpnf cioo co
      cvv wcel cmnf cA cioo oprex cB cpnf cioo oprex pm3.2i a1i cmnf cA cioo co
      cvv wcel cB cpnf cioo co cvv wcel wa cmnf cA cioo co cB cpnf cioo co cpr
      cuni cmnf cA cioo co cB cpnf cioo co cun cmnf cA cioo co cB cpnf cioo co
      cvv cvv uniprg eqcomd syl eleq2d bitrd vx cv cr cA cB cicc co eldif
      syl5bb eqrdv $.
      $( [1-Dec-2010] $) $( [7-Jun-2007] $)
  $}

  $( Closed intervals are closed sets of the standard topology on ` RR ` .
     (Contributed by FL, 14-Sep-2007.) $)
  clicls $p |- ( ( A e. RR /\ B e. RR ) -> ( A [,] B ) e.
        ( Clsd ` ( topGen ` ran (,) ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB cicc co cioo crn ctg cfv ccld cfv wcel cr cA
    cB cicc co cdif cioo crn ctg cfv wcel cA cr wcel cB cr wcel wa cr cA cB
    cicc co cdif cmnf cA cioo co cB cpnf cioo co cpr cuni cioo crn ctg cfv cA
    cB cdrci cA cr wcel cB cr wcel wa cioo crn ctg cfv ctop wcel cmnf cA cioo
    co cB cpnf cioo co cpr cioo crn ctg cfv wss wa cmnf cA cioo co cB cpnf cioo
    co cpr cuni cioo crn ctg cfv wcel cioo crn ctg cfv ctop wcel cmnf cA cioo
    co cB cpnf cioo co cpr cioo crn ctg cfv wss wa cA cr wcel cB cr wcel wa
    cioo crn ctg cfv ctop wcel cmnf cA cioo co cB cpnf cioo co cpr cioo crn ctg
    cfv wss retop cmnf cA cioo co cioo crn ctg cfv wcel cB cpnf cioo co cioo
    crn ctg cfv wcel wa cmnf cA cioo co cB cpnf cioo co cpr cioo crn ctg cfv
    wss cmnf cA cioo co cioo crn ctg cfv wcel cB cpnf cioo co cioo crn ctg cfv
    wcel cmnf cA iooretop cB cpnf iooretop pm3.2i cmnf cA cioo co cB cpnf cioo
    co cioo crn ctg cfv cmnf cA cioo oprex cB cpnf cioo oprex prss mpbi pm3.2i
    a1i cmnf cA cioo co cB cpnf cioo co cpr cioo crn ctg cfv uniopn syl eqeltrd
    cA cr wcel cB cr wcel wa cioo crn ctg cfv ctop wcel cA cB cicc co cr wss wa
    cA cB cicc co cioo crn ctg cfv ccld cfv wcel cr cA cB cicc co cdif cioo crn
    ctg cfv wcel wb cA cr wcel cB cr wcel wa cA cB cicc co cr wss cioo crn ctg
    cfv ctop wcel cA cB iccssre retop jctil cA cB cicc co cioo crn ctg cfv cr
    cioo crn ctg cfv cuni cr uniretop eqcomi iscld2 syl mpbird $.
    $( [1-Dec-2010] $) $( [14-Sep-2007] $)

  $( A closed interval is a closed set.  (Contributed by FL, 28-Jan-2009.) $)
  clint3 $p |- ( ( A e. RR /\ B e. RR ) ->  ( A [,] B ) e.
     ( Clsd ` ( topGen ` ran (,) ) ) ) $=
    cA cr wcel cB cr wcel wa cA cB cicc co cr wss cr cA cB cicc co cdif cioo
    crn ctg cfv wcel wa cA cB cicc co cioo crn ctg cfv ccld cfv wcel cA cr wcel
    cB cr wcel wa cA cB cicc co cr wss cr cA cB cicc co cdif cioo crn ctg cfv
    wcel cA cB iccssre cA cr wcel cB cr wcel wa cr cA cB cicc co cdif cmnf cA
    cioo co cB cpnf cioo co cpr cuni cioo crn ctg cfv cA cB cdrci cA cr wcel cB
    cr wcel wa cioo crn ctg cfv ctop wcel cmnf cA cioo co cB cpnf cioo co cpr
    cioo crn ctg cfv wss wa cmnf cA cioo co cB cpnf cioo co cpr cuni cioo crn
    ctg cfv wcel cA cr wcel cB cr wcel wa cmnf cA cioo co cB cpnf cioo co cpr
    cioo crn ctg cfv wss cioo crn ctg cfv ctop wcel cA cr wcel cB cr wcel wa
    cmnf cA cioo co cioo crn ctg cfv wcel cB cpnf cioo co cioo crn ctg cfv wcel
    wa cmnf cA cioo co cB cpnf cioo co cpr cioo crn ctg cfv wss cmnf cA cioo co
    cioo crn ctg cfv wcel cB cpnf cioo co cioo crn ctg cfv wcel cmnf cA
    iooretop cB cpnf iooretop pm3.2i cA cr wcel cB cr wcel wa cmnf cA cioo co
    cioo crn ctg cfv wcel cB cpnf cioo co cioo crn ctg cfv wcel wa cmnf cA cioo
    co cioo crn ctg cfv wcel cB cpnf cioo co cioo crn ctg cfv wcel wa cmnf cA
    cioo co cB cpnf cioo co cpr cioo crn ctg cfv wss wb cmnf cA cioo co cioo
    crn ctg cfv wcel cB cpnf cioo co cioo crn ctg cfv wcel wa cA cr wcel cB cr
    wcel wa cmnf cA cioo co cioo crn ctg cfv wcel cB cpnf cioo co cioo crn ctg
    cfv wcel cmnf cA iooretop cB cpnf iooretop pm3.2i a1i cmnf cA cioo co cB
    cpnf cioo co cioo crn ctg cfv cioo crn ctg cfv cioo crn ctg cfv prssg syl
    mpbii retop jctil cmnf cA cioo co cB cpnf cioo co cpr cioo crn ctg cfv
    uniopn syl eqeltrd jca cioo crn ctg cfv ctop wcel cA cB cicc co cioo crn
    ctg cfv ccld cfv wcel cA cB cicc co cr wss cr cA cB cicc co cdif cioo crn
    ctg cfv wcel wa wb retop cA cB cicc co cioo crn ctg cfv cr cioo crn ctg cfv
    cuni cr uniretop eqcomi iscld ax-mp sylibr $.
    $( [1-Dec-2010] $) $( [5-Jan-2009] $)

  ${
    basmetres.1 $e |- D = ( C |` ( Y X. Y ) ) $.
    basmetres.2 $e |- X = dom dom C $.
    $( The base set of a submetric.  (Contributed by Jeff Hankins,
       30-Aug-2009.) $)
    basmetres $p |- ( ( C e. Met /\ Y C_ X ) -> Y = dom dom D ) $=
      cC cme wcel cY cX wss wa cY cY cY cxp cC cdm cin cdm cD cdm cdm cC cme
      wcel cY cX wss wa cY cY cY cxp cX cX cxp cin cdm cY cY cxp cC cdm cin cdm
      cC cme wcel cY cX wss wa cY cY cxp cX cX cxp cin cdm cY cY cxp cdm cY cY
      cX wss cY cY cxp cX cX cxp cin cdm cY cY cxp cdm wceq cC cme wcel cY cX
      wss cY cY cxp cX cX cxp cin cY cY cxp cY cX wss cY cY cxp cX cX cxp wss
      cY cY cxp cX cX cxp cin cY cY cxp wceq cY cX wss cY cY cxp cX cX cxp wss
      cY cX cY cX xpss12 anidms cY cY cxp cX cX cxp df-ss sylib dmeqd adantl cY
      dmxpid syl6req cC cme wcel cY cY cxp cX cX cxp cin cdm cY cY cxp cC cdm
      cin cdm wceq cY cX wss cC cme wcel cY cY cxp cC cdm cin cdm cY cY cxp cX
      cX cxp cin cdm cC cme wcel cY cY cxp cC cdm cin cY cY cxp cX cX cxp cin
      cC cme wcel cC cdm cX cX cxp cY cY cxp cC cme wcel cX cX cxp cr cC wf cC
      cdm cX cX cxp wceq cC cX basmetres.2 metf cX cX cxp cr cC fdm syl ineq2d
      dmeqd eqcomd adantr eqtrd cD cdm cY cY cxp cC cdm cin cD cdm cC cY cY cxp
      cres cdm cY cY cxp cC cdm cin cD cC cY cY cxp cres basmetres.1 dmeqi cC
      cY cY cxp dmres eqtri dmeqi syl6eqr $.
      $( [1-Dec-2010] $) $( [21-Aug-2009] $)
  $}

  $( A poset is antisymmetric and reflexive.  (Contributed by FL,
     3-Aug-2009.) $)
  posanref $p |- ( R e. Poset -> ( R i^i `' R ) = ( _I |` U. U. R ) ) $=
    cR cps wcel cR wrel cR cR ccom cR wss cR cR ccnv cin cid cR cuni cuni cres
    wceq cR cps wcel cR wrel cR cR ccom cR wss cR cR ccnv cin cid cR cuni cuni
    cres wceq w3a cps cR isps ibi 3simp3d $.
    $( [1-Dec-2010] $) $( [2-Aug-2009] $)

  $( A poset is transitive.  (Contributed by FL, 3-Aug-2009.) $)
  postr $p |- ( R e. Poset -> ( R o. R ) C_ R ) $=
    cR cps wcel cR wrel cR cR ccom cR wss cR cR ccnv cin cid cR cuni cuni cres
    wceq cR cps wcel cR wrel cR cR ccom cR wss cR cR ccnv cin cid cR cuni cuni
    cres wceq w3a cps cR isps ibi 3simp2d $.
    $( [1-Dec-2010] $) $( [2-Aug-2009] $)

  ${ $d A f x y $. $d B f x y $. $d f ph $. $d ps y $.
    ac6sg.1 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( ~ ac6s with the first premise turned into a antecedent.  (Contributed by
       FL, 3-Aug-2009.) $)
    ac6sg $p |- ( A e. _V -> ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) ) $=
      cA cvv wcel wph vy cB wrex vx cA wral cA cB vf cv wf wps vx cA wral wa vf
      wex wi wph vy cB wrex vx cA cvv wcel cA c0 cif wral cA cvv wcel cA c0 cif
      cB vf cv wf wps vx cA cvv wcel cA c0 cif wral wa vf wex wi cA c0 cA cA
      cvv wcel cA c0 cif wceq wph vy cB wrex vx cA wral wph vy cB wrex vx cA
      cvv wcel cA c0 cif wral cA cB vf cv wf wps vx cA wral wa vf wex cA cvv
      wcel cA c0 cif cB vf cv wf wps vx cA cvv wcel cA c0 cif wral wa vf wex
      wph vy cB wrex vx cA cA cvv wcel cA c0 cif raleq1 cA cA cvv wcel cA c0
      cif wceq cA cB vf cv wf wps vx cA wral wa cA cvv wcel cA c0 cif cB vf cv
      wf wps vx cA cvv wcel cA c0 cif wral wa vf cA cA cvv wcel cA c0 cif wceq
      cA cB vf cv wf cA cvv wcel cA c0 cif cB vf cv wf wps vx cA wral wps vx cA
      cvv wcel cA c0 cif wral cA cA cvv wcel cA c0 cif cB vf cv feq2 wps vx cA
      cA cvv wcel cA c0 cif raleq1 anbi12d exbidv imbi12d wph wps vx vy cA cvv
      wcel cA c0 cif cB vf cA c0 cvv 0ex elimel ac6sg.1 ac6s dedth $.
      $( [1-Dec-2010] $) $( [2-Aug-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Group homomorphism and isomorphism
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpHom $.

  $( Extend class notation to include the class of group homomorphisms. $)
  cghom $a class GrpHom $.

  ${
    $d f g h s x y $.
    $( Define the set of group homomorphisms from ` g ` to ` h ` .
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    df-ghom $a |- GrpHom = { <. <. g , h >. , s >. | ( ( g e. Grp /\ h e. Grp )
        /\ s = { f | ( f : ran g --> ran h /\ A. x e. ran g A. y e. ran g
                     ( ( f ` x ) h ( f ` y ) ) = ( f ` ( x g y ) ) ) } ) } $.
  $}

  $c GrpIso $.

  $( Extend class notation to include the class of group isomorphisms. $)
  cgiso $a class GrpIso $.

  ${
    $d f g h s $.
    $( Define the set of group isomorphisms from ` g ` to ` h ` .
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    df-giso $a |- GrpIso = { <. <. g , h >. , s >. | ( ( g e. Grp /\ h e. Grp )
        /\ s = { f e. ( g GrpHom h ) | f : ran g -1-1-onto-> ran h } ) } $.
  $}

  ${
    $d F f x y $.  $d G f g h x y z $.  $d H f g h x y z $.  $d S h z $.
    elghomlem1.1 $e |- S = { f | ( f : ran G --> ran H /\ A. x e. ran G
      A. y e. ran G ( ( f ` x ) H ( f ` y ) ) = ( f ` ( x G y ) ) ) } $.

    $( Lemma for ~ elghom . $)
    elghomlem1 $p |- ( ( G e. Grp /\ H e. Grp ) -> ( G GrpHom H ) = S ) $=
      cG cgr wcel cH cgr wcel cS cvv wcel cG cH cghom co cS wceq cG crn cvv
      wcel cH crn cvv wcel cS cvv wcel cG cgr wcel cH cgr wcel vx cv vf cv cfv
      vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral vx
      cG crn wral vf cG crn cH crn cvv cvv cS elghomlem1.1 fabexg cG cgr rnexg
      cH cgr rnexg syl2an vg vh vz cG cH cgr cgr vg cv crn vh cv crn vf cv wf
      vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vy cv vg cv co vf cv cfv
      wceq vy vg cv crn wral vx vg cv crn wral wa vf cab cS cghom cG crn vh cv
      crn vf cv wf vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vy cv cG co
      vf cv cfv wceq vy cG crn wral vx cG crn wral wa vf cab cvv vg cv cG wceq
      vg cv crn vh cv crn vf cv wf vx cv vf cv cfv vy cv vf cv cfv vh cv co vx
      cv vy cv vg cv co vf cv cfv wceq vy vg cv crn wral vx vg cv crn wral wa
      cG crn vh cv crn vf cv wf vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv
      vy cv cG co vf cv cfv wceq vy cG crn wral vx cG crn wral wa vf vg cv cG
      wceq vg cv crn vh cv crn vf cv wf cG crn vh cv crn vf cv wf vx cv vf cv
      cfv vy cv vf cv cfv vh cv co vx cv vy cv vg cv co vf cv cfv wceq vy vg cv
      crn wral vx vg cv crn wral vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv
      vy cv cG co vf cv cfv wceq vy cG crn wral vx cG crn wral vg cv cG wceq vg
      cv crn cG crn wceq vg cv crn vh cv crn vf cv wf cG crn vh cv crn vf cv wf
      wb vg cv cG rneq vg cv crn cG crn vh cv crn vf cv feq2 syl vg cv cG wceq
      vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vy cv vg cv co vf cv cfv
      wceq vy vg cv crn wral vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vy
      cv cG co vf cv cfv wceq vy cG crn wral vx vg cv crn cG crn vg cv cG rneq
      vg cv cG wceq vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vy cv vg cv
      co vf cv cfv wceq vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vy cv cG
      co vf cv cfv wceq vy vg cv crn cG crn vg cv cG rneq vg cv cG wceq vx cv
      vy cv vg cv co vf cv cfv vx cv vy cv cG co vf cv cfv vx cv vf cv cfv vy
      cv vf cv cfv vh cv co vg cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG
      co vf cv vx cv vy cv vg cv cG opreq fveq2d eqeq2d raleq12d raleq12d
      anbi12d abbidv vh cv cH wceq cG crn vh cv crn vf cv wf vx cv vf cv cfv vy
      cv vf cv cfv vh cv co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral vx
      cG crn wral wa vf cab cG crn cH crn vf cv wf vx cv vf cv cfv vy cv vf cv
      cfv cH co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral vx cG crn wral
      wa vf cab cS vh cv cH wceq cG crn vh cv crn vf cv wf vx cv vf cv cfv vy
      cv vf cv cfv vh cv co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral vx
      cG crn wral wa cG crn cH crn vf cv wf vx cv vf cv cfv vy cv vf cv cfv cH
      co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral vx cG crn wral wa vf
      vh cv cH wceq cG crn vh cv crn vf cv wf cG crn cH crn vf cv wf vx cv vf
      cv cfv vy cv vf cv cfv vh cv co vx cv vy cv cG co vf cv cfv wceq vy cG
      crn wral vx cG crn wral vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv
      cG co vf cv cfv wceq vy cG crn wral vx cG crn wral vh cv cH wceq vh cv
      crn cH crn wceq cG crn vh cv crn vf cv wf cG crn cH crn vf cv wf wb vh cv
      cH rneq vh cv crn cH crn cG crn vf cv feq3 syl vh cv cH wceq vx cv vf cv
      cfv vy cv vf cv cfv vh cv co vx cv vy cv cG co vf cv cfv wceq vx cv vf cv
      cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vx vy cG crn
      cG crn vh cv cH wceq vx cv vf cv cfv vy cv vf cv cfv vh cv co vx cv vf cv
      cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv vx cv vf cv cfv vy
      cv vf cv cfv vh cv cH opreq eqeq1d 2ralbidv anbi12d abbidv elghomlem1.1
      syl6eqr vx vy vf vg vh vz df-ghom oprabval2g mpd3an3 $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)

    $( Lemma for ~ elghom . $)
    elghomlem2 $p |- ( ( G e. Grp /\ H e. Grp ) -> ( F e. ( G GrpHom H ) <->
        ( F : ran G --> ran H /\ A. x e. ran G A. y e. ran G
          ( ( F ` x ) H ( F ` y ) ) = ( F ` ( x G y ) ) ) ) ) $=
      cG cgr wcel cH cgr wcel wa cF cG cH cghom co wcel cF cS wcel cG crn cH
      crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq
      vy cG crn wral vx cG crn wral wa cG cgr wcel cH cgr wcel wa cG cH cghom
      co cS cF vx vy cS vf cG cH elghomlem1.1 elghomlem1 eleq2d cG cgr wcel cF
      cS wcel cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv
      cG co cF cfv wceq vy cG crn wral vx cG crn wral wa wb cH cgr wcel cG cgr
      wcel cF cS wcel cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa cF cvv wcel cF
      cS wcel cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv
      cG co cF cfv wceq vy cG crn wral vx cG crn wral wa cF cS elisset cF cvv
      wcel cF cS wcel cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa cG crn cH crn vf
      cv wf vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv
      wceq vy cG crn wral vx cG crn wral wa cG crn cH crn cF wf vx cv cF cfv vy
      cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn
      wral wa vf cF cS cvv vf cv cF wceq cG crn cH crn vf cv wf cG crn cH crn
      cF wf vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv
      wceq vy cG crn wral vx cG crn wral vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral cG crn cH crn vf cv
      cF feq1 vf cv cF wceq vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv
      cG co vf cv cfv wceq vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vx vy cG crn cG crn vf cv cF wceq vx cv vf cv cfv vy cv vf cv
      cfv cH co vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co vf cv cfv vx
      cv vy cv cG co cF cfv vf cv cF wceq vx cv vf cv cfv vx cv cF cfv vy cv vf
      cv cfv vy cv cF cfv cH vx cv vf cv cF fveq1 vy cv vf cv cF fveq1 opreq12d
      vx cv vy cv cG co vf cv cF fveq1 eqeq12d 2ralbidv anbi12d elghomlem1.1
      elab2g biimpd mpcom cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co
      vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa cG cgr
      wcel cF cvv wcel cF cS wcel cG cgr wcel cG crn cH crn cF wf cF cvv wcel
      vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cG crn
      wral vx cG crn wral cG cgr wcel cG crn cvv wcel cG crn cH crn cF wf cF
      cvv wcel wi cG cgr rnexg cG crn cH crn cF wf cG crn cvv wcel cF cvv wcel
      cG crn cH crn cvv cF fex expcom syl adantrd cF cvv wcel cF cS wcel cG crn
      cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv
      wceq vy cG crn wral vx cG crn wral wa cG crn cH crn vf cv wf vx cv vf cv
      cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral
      vx cG crn wral wa cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx
      cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa vf cF cS cvv
      vf cv cF wceq cG crn cH crn vf cv wf cG crn cH crn cF wf vx cv vf cv cfv
      vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vy cG crn wral vx
      cG crn wral vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq
      vy cG crn wral vx cG crn wral cG crn cH crn vf cv cF feq1 vf cv cF wceq
      vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vx
      cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vx vy cG crn
      cG crn vf cv cF wceq vx cv vf cv cfv vy cv vf cv cfv cH co vx cv cF cfv
      vy cv cF cfv cH co vx cv vy cv cG co vf cv cfv vx cv vy cv cG co cF cfv
      vf cv cF wceq vx cv vf cv cfv vx cv cF cfv vy cv vf cv cfv vy cv cF cfv
      cH vx cv vf cv cF fveq1 vy cv vf cv cF fveq1 opreq12d vx cv vy cv cG co
      vf cv cF fveq1 eqeq12d 2ralbidv anbi12d elghomlem1.1 elab2g biimprd syli
      impbid2 adantr bitrd $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)
  $}

  ${
    $d F f x y $.  $d G f x y $.  $d H f x y $.  $d X x y $.
    elghom.1 $e |- X = ran G $.
    elghom.2 $e |- W = ran H $.
    $( Membership in the set of group homomorphisms from ` G ` to ` H ` .
       (Contributed by Paul Chapman, 3-Mar-2008.) $)
    elghom $p |- ( ( G e. Grp /\ H e. Grp ) ->
      ( F e. ( G GrpHom H ) <-> ( F : X --> W /\ A. x e. X A. y e. X
        ( ( F ` x ) H ( F ` y ) ) = ( F ` ( x G y ) ) ) ) ) $=
      cG cgr wcel cH cgr wcel wa cF cG cH cghom co wcel cG crn cH crn cF wf vx
      cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cG crn wral
      vx cG crn wral wa cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv
      cG co cF cfv wceq vy cX wral vx cX wral wa vx vy cG crn cH crn vf cv wf
      vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vy
      cG crn wral vx cG crn wral wa vf cab vf cF cG cH cG crn cH crn vf cv wf
      vx cv vf cv cfv vy cv vf cv cfv cH co vx cv vy cv cG co vf cv cfv wceq vy
      cG crn wral vx cG crn wral wa vf cab eqid elghomlem2 cX cW cF wf cG crn
      cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv
      wceq vy cX wral vx cX wral vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG
      co cF cfv wceq vy cG crn wral vx cG crn wral cX cG crn wceq cW cH crn
      wceq cX cW cF wf cG crn cH crn cF wf wb elghom.1 elghom.2 cX cW cG crn cH
      crn cF feq23 mp2an vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cX wral vx cX wral vx cv cF cfv vy cv cF cfv cH co vx cv vy
      cv cG co cF cfv wceq vy cG crn wral vx cX wral vx cv cF cfv vy cv cF cfv
      cH co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx
      cX cX cG crn wceq vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cX wral vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cG crn wral wb elghom.1 vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cX cG crn raleq1 ax-mp ralbii cX cG crn wceq
      vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cG crn
      wral vx cX wral vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv
      wceq vy cG crn wral vx cG crn wral wb elghom.1 vx cv cF cfv vy cv cF cfv
      cH co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cX cG crn raleq1
      ax-mp bitri anbi12i syl6bbr $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Symmetry groups and Cayley's Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SymGrp $.

  $( Extend class notation to include the class of symmetry groups. $)
  csymgrp $a class SymGrp $.

  ${
    $d x y f g h $.
    $( Define the symmetry group on set ` x ` .  We represent the group as the
       set of 1-1-onto functions from ` x ` to itself under function
       composition.  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    df-symgrp $a |- SymGrp = { <. x , y >. | y = { <. <. f , g >. , h >. |
      ( f : x -1-1-onto-> x /\ g : x -1-1-onto-> x /\ h = ( f o. g ) ) } } $.
  $}

  ${
    $d A f g h x $.  $d F f g h $.  $d F x $.  $d G f g h $.  $d P f g h $.
    $d f g h x y $.
    elsymgrn.1 $e |- A e. _V $.
    elsymgrn.2 $e |- P = { x | x : A -1-1-onto-> A } $.

    $( Two ways of saying a function is a 1-1-onto mapping of A to itself.
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    elsymgrn $p |- ( F e. P <-> F : A -1-1-onto-> A ) $=
      cF cP wcel cF cvv wcel cA cA cF wf1o cF cP elisset cA cA cF wf1o cA cA cF
      wf cF cvv wcel cA cA cF f1of cA cA cF wf cA cvv wcel cF cvv wcel
      elsymgrn.1 cA cA cvv cF fex mpan2 syl cA cA vx cv wf1o cA cA cF wf1o vx
      cF cP cvv cA cA vx cv cF f1oeq1 elsymgrn.2 elab2g pm5.21nii $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)

    $( Two ways to express the symmetry-group operator class abstraction.
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    symgoprab $p |- { <. <. f , g >. , h >. | ( f : A -1-1-onto-> A /\
                      g : A -1-1-onto-> A /\ h = ( f o. g ) ) } =
      { <. <. f , g >. , h >. | ( ( f e. P /\ g e. P ) /\ h = ( f o. g ) ) } $=
      vf cv cP wcel vg cv cP wcel wa vh cv vf cv vg cv ccom wceq wa vf vg vh
      copab2 cA cA vf cv wf1o cA cA vg cv wf1o vh cv vf cv vg cv ccom wceq w3a
      vf vg vh copab2 vf cv cP wcel vg cv cP wcel wa vh cv vf cv vg cv ccom
      wceq wa cA cA vf cv wf1o cA cA vg cv wf1o vh cv vf cv vg cv ccom wceq w3a
      vf vg vh vf cv cP wcel vg cv cP wcel wa vh cv vf cv vg cv ccom wceq wa cA
      cA vf cv wf1o cA cA vg cv wf1o wa vh cv vf cv vg cv ccom wceq wa cA cA vf
      cv wf1o cA cA vg cv wf1o vh cv vf cv vg cv ccom wceq w3a vf cv cP wcel vg
      cv cP wcel wa cA cA vf cv wf1o cA cA vg cv wf1o wa vh cv vf cv vg cv ccom
      wceq vf cv cP wcel cA cA vf cv wf1o vg cv cP wcel cA cA vg cv wf1o vx cA
      cP vf cv elsymgrn.1 elsymgrn.2 elsymgrn vx cA cP vg cv elsymgrn.1
      elsymgrn.2 elsymgrn anbi12i anbi1i cA cA vf cv wf1o cA cA vg cv wf1o vh
      cv vf cv vg cv ccom wceq df-3an bitr4i oprabbii eqcomi $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)

    $( The value of the symmetry group function at ` A ` .  (Contributed by
       Paul Chapman, 25-Feb-2008.) $)
    symgval $p |- ( SymGrp ` A ) = { <. <. f , g >. , h >. |
                    ( ( f e. P /\ g e. P ) /\ h = ( f o. g ) ) } $=
      cA csymgrp cfv cA vy cv vx cv vx cv vf cv wf1o vx cv vx cv vg cv wf1o vh
      cv vf cv vg cv ccom wceq w3a vf vg vh copab2 wceq vx vy copab cfv cA cA
      vf cv wf1o cA cA vg cv wf1o vh cv vf cv vg cv ccom wceq w3a vf vg vh
      copab2 vf cv cP wcel vg cv cP wcel wa vh cv vf cv vg cv ccom wceq wa vf
      vg vh copab2 cA csymgrp vy cv vx cv vx cv vf cv wf1o vx cv vx cv vg cv
      wf1o vh cv vf cv vg cv ccom wceq w3a vf vg vh copab2 wceq vx vy copab vx
      vy vf vg vh df-symgrp fveq1i vx vy cA vx cv vx cv vf cv wf1o vx cv vx cv
      vg cv wf1o vh cv vf cv vg cv ccom wceq w3a vf vg vh copab2 cA cA vf cv
      wf1o cA cA vg cv wf1o vh cv vf cv vg cv ccom wceq w3a vf vg vh copab2
      elsymgrn.1 vf vg vh cP cP vf cv vg cv ccom cA cA vf cv wf1o cA cA vg cv
      wf1o vh cv vf cv vg cv ccom wceq w3a vf vg vh copab2 cA cvv wcel cA cvv
      wcel cP cvv wcel elsymgrn.1 elsymgrn.1 vx cv vx cv wceq cA cA cvv cvv vx
      cP cP cA cA vx cv wf1o vx cab cA cA vx cv wf1o vx cv vx cv wceq wa vx cab
      elsymgrn.2 cA cA vx cv wf1o cA cA vx cv wf1o vx cv vx cv wceq wa vx vx cv
      vx cv wceq cA cA vx cv wf1o vx equid biantru abbii eqtri f1oabexg mp2an
      cA cvv wcel cA cvv wcel cP cvv wcel elsymgrn.1 elsymgrn.1 vx cv vx cv
      wceq cA cA cvv cvv vx cP cP cA cA vx cv wf1o vx cab cA cA vx cv wf1o vx
      cv vx cv wceq wa vx cab elsymgrn.2 cA cA vx cv wf1o cA cA vx cv wf1o vx
      cv vx cv wceq wa vx vx cv vx cv wceq cA cA vx cv wf1o vx equid biantru
      abbii eqtri f1oabexg mp2an vx cA cP vf vg vh elsymgrn.1 elsymgrn.2
      symgoprab oprabex2 vx cv cA wceq vx cv vx cv vf cv wf1o vx cv vx cv vg cv
      wf1o vh cv vf cv vg cv ccom wceq w3a cA cA vf cv wf1o cA cA vg cv wf1o vh
      cv vf cv vg cv ccom wceq w3a vf vg vh vx cv cA wceq vx cv vx cv vf cv
      wf1o cA cA vf cv wf1o vx cv vx cv vg cv wf1o cA cA vg cv wf1o vh cv vf cv
      vg cv ccom wceq vx cv cA wceq vx cv vx cv vf cv wf1o cA vx cv vf cv wf1o
      cA cA vf cv wf1o vx cv cA vx cv vf cv f1oeq2 vx cv cA cA vf cv f1oeq3
      bitrd vx cv cA wceq vx cv vx cv vg cv wf1o cA vx cv vg cv wf1o cA cA vg
      cv wf1o vx cv cA vx cv vg cv f1oeq2 vx cv cA cA vg cv f1oeq3 bitrd
      3anbi12d oprabbidv fvopab vx cA cP vf vg vh elsymgrn.1 elsymgrn.2
      symgoprab 3eqtri $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)

    $( The value of the group operation of the symmetry group on ` A ` .
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    symgoprv $p |- ( ( F e. P /\ G e. P ) ->
                       ( F ( SymGrp ` A ) G ) = ( F o. G ) ) $=
      cF cP wcel cG cP wcel wa cF cG vf cv cP wcel vg cv cP wcel wa vh cv vf cv
      vg cv ccom wceq wa vf vg vh copab2 co cF cG ccom cF cG cA csymgrp cfv co
      cF cP wcel cG cP wcel cF cG ccom cvv wcel cF cG vf cv cP wcel vg cv cP
      wcel wa vh cv vf cv vg cv ccom wceq wa vf vg vh copab2 co cF cG ccom wceq
      cF cG cP cP coexg vf vg vh cF cG cP cP vf cv vg cv ccom cF cG ccom vf cv
      cP wcel vg cv cP wcel wa vh cv vf cv vg cv ccom wceq wa vf vg vh copab2
      cF vg cv ccom cvv vf cv cF vg cv coeq1 vg cv cG cF coeq2 vf cv cP wcel vg
      cv cP wcel wa vh cv vf cv vg cv ccom wceq wa vf vg vh copab2 eqid
      oprabval2g mpd3an3 cA csymgrp cfv vf cv cP wcel vg cv cP wcel wa vh cv vf
      cv vg cv ccom wceq wa vf vg vh copab2 cF cG vx cA cP vf vg vh elsymgrn.1
      elsymgrn.2 symgval opreqi syl5eq $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)

    $( The domain and codomain of the group operation of the symmetry group on
       ` A ` .  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    symgf $p |- ( SymGrp ` A ) : ( P X. P ) --> P $=
      vf vg vh cP cP vf cv vg cv ccom cP cA csymgrp cfv vx cA cP vf vg vh
      elsymgrn.1 elsymgrn.2 symgval cA cA vf cv wf1o cA cA vg cv wf1o wa cA cA
      vf cv vg cv ccom wf1o vf cv cP wcel vg cv cP wcel wa vf cv vg cv ccom cP
      wcel cA cA cA vf cv vg cv f1oco vf cv cP wcel cA cA vf cv wf1o vg cv cP
      wcel cA cA vg cv wf1o vx cA cP vf cv elsymgrn.1 elsymgrn.2 elsymgrn vx cA
      cP vg cv elsymgrn.1 elsymgrn.2 elsymgrn anbi12i vx cA cP vf cv vg cv ccom
      elsymgrn.1 elsymgrn.2 elsymgrn 3imtr4i foprab $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)
  $}

  ${
    $d A f g h x $.  $d F f g h $.  $d F x $.  $d G f g h $.  $d P f g h $.
    $d f g h x y $.
    symggrpi.1 $e |- A e. _V $.
    $( The symmetry group on ` A ` is a group (inference version).
       (Contributed by Paul Chapman, 4-Jun-2008.) $)
    symggrpi $p |- ( SymGrp ` A ) e. Grp $=
      vf vg vh cid cA cres cA csymgrp cfv vf cv ccnv cA cA vx cv wf1o vx cab cA
      cvv wcel cA cvv wcel cA cA vx cv wf1o vx cab cvv wcel symggrpi.1
      symggrpi.1 vx cv vx cv wceq cA cA cvv cvv vx cA cA vx cv wf1o vx cab cA
      cA vx cv wf1o vx cab cA cA vx cv wf1o vx cab cA cA vx cv wf1o vx cv vx cv
      wceq wa vx cab cA cA vx cv wf1o vx cab eqid cA cA vx cv wf1o cA cA vx cv
      wf1o vx cv vx cv wceq wa vx vx cv vx cv wceq cA cA vx cv wf1o vx equid
      biantru abbii eqtri f1oabexg mp2an vx cA cA cA vx cv wf1o vx cab
      symggrpi.1 cA cA vx cv wf1o vx cab eqid symgf vf cv cA cA vx cv wf1o vx
      cab wcel vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA vx cv wf1o vx cab
      wcel w3a vf cv vg cv ccom vh cv ccom vf cv vg cv vh cv ccom ccom vf cv vg
      cv cA csymgrp cfv co vh cv cA csymgrp cfv co vf cv vg cv vh cv cA csymgrp
      cfv co cA csymgrp cfv co vf cv vg cv vh cv coass vf cv cA cA vx cv wf1o
      vx cab wcel vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA vx cv wf1o vx
      cab wcel w3a vf cv vg cv cA csymgrp cfv co vh cv cA csymgrp cfv co vf cv
      vg cv ccom vh cv cA csymgrp cfv co vf cv vg cv ccom vh cv ccom vf cv cA
      cA vx cv wf1o vx cab wcel vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA
      vx cv wf1o vx cab wcel w3a vf cv vg cv cA csymgrp cfv co vf cv vg cv ccom
      vh cv cA csymgrp cfv vf cv cA cA vx cv wf1o vx cab wcel vg cv cA cA vx cv
      wf1o vx cab wcel vf cv vg cv cA csymgrp cfv co vf cv vg cv ccom wceq vh
      cv cA cA vx cv wf1o vx cab wcel vx cA cA cA vx cv wf1o vx cab vf cv vg cv
      symggrpi.1 cA cA vx cv wf1o vx cab eqid symgoprv 3adant3 opreq1d vf cv cA
      cA vx cv wf1o vx cab wcel vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA
      vx cv wf1o vx cab wcel vf cv vg cv ccom vh cv cA csymgrp cfv co vf cv vg
      cv ccom vh cv ccom wceq vf cv vg cv ccom cA cA vx cv wf1o vx cab wcel vh
      cv cA cA vx cv wf1o vx cab wcel vf cv vg cv ccom vh cv cA csymgrp cfv co
      vf cv vg cv ccom vh cv ccom wceq vf cv cA cA vx cv wf1o vx cab wcel vg cv
      cA cA vx cv wf1o vx cab wcel wa vx cA cA cA vx cv wf1o vx cab vf cv vg cv
      ccom vh cv symggrpi.1 cA cA vx cv wf1o vx cab eqid symgoprv cA cA vf cv
      wf1o cA cA vg cv wf1o wa cA cA vf cv vg cv ccom wf1o vf cv cA cA vx cv
      wf1o vx cab wcel vg cv cA cA vx cv wf1o vx cab wcel wa vf cv vg cv ccom
      cA cA vx cv wf1o vx cab wcel cA cA cA vf cv vg cv f1oco vf cv cA cA vx cv
      wf1o vx cab wcel cA cA vf cv wf1o vg cv cA cA vx cv wf1o vx cab wcel cA
      cA vg cv wf1o vx cA cA cA vx cv wf1o vx cab vf cv symggrpi.1 cA cA vx cv
      wf1o vx cab eqid elsymgrn vx cA cA cA vx cv wf1o vx cab vg cv symggrpi.1
      cA cA vx cv wf1o vx cab eqid elsymgrn anbi12i vx cA cA cA vx cv wf1o vx
      cab vf cv vg cv ccom symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn
      3imtr4i sylan 3impa eqtrd vf cv cA cA vx cv wf1o vx cab wcel vg cv cA cA
      vx cv wf1o vx cab wcel vh cv cA cA vx cv wf1o vx cab wcel w3a vf cv vg cv
      vh cv cA csymgrp cfv co cA csymgrp cfv co vf cv vg cv vh cv ccom cA
      csymgrp cfv co vf cv vg cv vh cv ccom ccom vf cv cA cA vx cv wf1o vx cab
      wcel vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA vx cv wf1o vx cab
      wcel w3a vg cv vh cv cA csymgrp cfv co vg cv vh cv ccom vf cv cA csymgrp
      cfv vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA vx cv wf1o vx cab wcel
      vg cv vh cv cA csymgrp cfv co vg cv vh cv ccom wceq vf cv cA cA vx cv
      wf1o vx cab wcel vx cA cA cA vx cv wf1o vx cab vg cv vh cv symggrpi.1 cA
      cA vx cv wf1o vx cab eqid symgoprv 3adant1 opreq2d vf cv cA cA vx cv wf1o
      vx cab wcel vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA vx cv wf1o vx
      cab wcel vf cv vg cv vh cv ccom cA csymgrp cfv co vf cv vg cv vh cv ccom
      ccom wceq vf cv cA cA vx cv wf1o vx cab wcel vg cv vh cv ccom cA cA vx cv
      wf1o vx cab wcel vf cv vg cv vh cv ccom cA csymgrp cfv co vf cv vg cv vh
      cv ccom ccom wceq vg cv cA cA vx cv wf1o vx cab wcel vh cv cA cA vx cv
      wf1o vx cab wcel wa vx cA cA cA vx cv wf1o vx cab vf cv vg cv vh cv ccom
      symggrpi.1 cA cA vx cv wf1o vx cab eqid symgoprv cA cA vg cv wf1o cA cA
      vh cv wf1o wa cA cA vg cv vh cv ccom wf1o vg cv cA cA vx cv wf1o vx cab
      wcel vh cv cA cA vx cv wf1o vx cab wcel wa vg cv vh cv ccom cA cA vx cv
      wf1o vx cab wcel cA cA cA vg cv vh cv f1oco vg cv cA cA vx cv wf1o vx cab
      wcel cA cA vg cv wf1o vh cv cA cA vx cv wf1o vx cab wcel cA cA vh cv wf1o
      vx cA cA cA vx cv wf1o vx cab vg cv symggrpi.1 cA cA vx cv wf1o vx cab
      eqid elsymgrn vx cA cA cA vx cv wf1o vx cab vh cv symggrpi.1 cA cA vx cv
      wf1o vx cab eqid elsymgrn anbi12i vx cA cA cA vx cv wf1o vx cab vg cv vh
      cv ccom symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn 3imtr4i sylan2
      3impb eqtrd 3eqtr4a cid cA cres cA cA vx cv wf1o vx cab wcel cA cA cid cA
      cres wf1o cA f1oi vx cA cA cA vx cv wf1o vx cab cid cA cres symggrpi.1 cA
      cA vx cv wf1o vx cab eqid elsymgrn mpbir vf cv cA cA vx cv wf1o vx cab
      wcel cid cA cres vf cv cA csymgrp cfv co cid cA cres vf cv ccom vf cv cid
      cA cres cA cA vx cv wf1o vx cab wcel vf cv cA cA vx cv wf1o vx cab wcel
      cid cA cres vf cv cA csymgrp cfv co cid cA cres vf cv ccom wceq cid cA
      cres cA cA vx cv wf1o vx cab wcel cA cA cid cA cres wf1o cA f1oi vx cA cA
      cA vx cv wf1o vx cab cid cA cres symggrpi.1 cA cA vx cv wf1o vx cab eqid
      elsymgrn mpbir vx cA cA cA vx cv wf1o vx cab cid cA cres vf cv symggrpi.1
      cA cA vx cv wf1o vx cab eqid symgoprv mpan vf cv cA cA vx cv wf1o vx cab
      wcel cA cA vf cv wf1o cid cA cres vf cv ccom vf cv wceq vx cA cA cA vx cv
      wf1o vx cab vf cv symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn cA cA
      vf cv wf1o cA cA vf cv wf cid cA cres vf cv ccom vf cv wceq cA cA vf cv
      f1of cA cA vf cv fcoi2 syl sylbi eqtrd cA cA vf cv wf1o cA cA vf cv ccnv
      wf1o vf cv cA cA vx cv wf1o vx cab wcel vf cv ccnv cA cA vx cv wf1o vx
      cab wcel cA cA vf cv f1ocnv vx cA cA cA vx cv wf1o vx cab vf cv
      symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn vx cA cA cA vx cv wf1o
      vx cab vf cv ccnv symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn
      3imtr4i vf cv cA cA vx cv wf1o vx cab wcel vf cv ccnv vf cv cA csymgrp
      cfv co vf cv ccnv vf cv ccom cid cA cres vf cv ccnv cA cA vx cv wf1o vx
      cab wcel vf cv cA cA vx cv wf1o vx cab wcel vf cv ccnv vf cv cA csymgrp
      cfv co vf cv ccnv vf cv ccom wceq cA cA vf cv wf1o cA cA vf cv ccnv wf1o
      vf cv cA cA vx cv wf1o vx cab wcel vf cv ccnv cA cA vx cv wf1o vx cab
      wcel cA cA vf cv f1ocnv vx cA cA cA vx cv wf1o vx cab vf cv symggrpi.1 cA
      cA vx cv wf1o vx cab eqid elsymgrn vx cA cA cA vx cv wf1o vx cab vf cv
      ccnv symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn 3imtr4i vx cA cA cA
      vx cv wf1o vx cab vf cv ccnv vf cv symggrpi.1 cA cA vx cv wf1o vx cab
      eqid symgoprv mpancom vf cv cA cA vx cv wf1o vx cab wcel cA cA vf cv wf1o
      vf cv ccnv vf cv ccom cid cA cres wceq vx cA cA cA vx cv wf1o vx cab vf
      cv symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn cA cA vf cv f1ococnv1
      sylbi eqtrd isgrpi $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)

    $( The value of the identity element of the symmetry group on ` A `
       (Contributed by Paul Chapman, 25-Jul-2008.) $)
    symgidi $p |- ( Id ` ( SymGrp ` A ) ) = ( _I |` A ) $=
      cid cA cres cA csymgrp cfv cgi cfv cid cA cres cA csymgrp cfv cgi cfv
      wceq cid cA cres cid cA cres cA csymgrp cfv co cid cA cres wceq cid cA
      cres cid cA cres cA csymgrp cfv co cid cA cres cid cA cres ccom cid cA
      cres cid cA cres cA cA vx cv wf1o vx cab wcel cid cA cres cA cA vx cv
      wf1o vx cab wcel cid cA cres cid cA cres cA csymgrp cfv co cid cA cres
      cid cA cres ccom wceq cid cA cres cA cA vx cv wf1o vx cab wcel cA cA cid
      cA cres wf1o cA f1oi vx cA cA cA vx cv wf1o vx cab cid cA cres symggrpi.1
      cA cA vx cv wf1o vx cab eqid elsymgrn mpbir cid cA cres cA cA vx cv wf1o
      vx cab wcel cA cA cid cA cres wf1o cA f1oi vx cA cA cA vx cv wf1o vx cab
      cid cA cres symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn mpbir vx cA
      cA cA vx cv wf1o vx cab cid cA cres cid cA cres symggrpi.1 cA cA vx cv
      wf1o vx cab eqid symgoprv mp2an cA cA cid cA cres wf cid cA cres cid cA
      cres ccom cid cA cres wceq cA cA cid cA cres wf1o cA cA cid cA cres wf cA
      f1oi cA cA cid cA cres f1of ax-mp cA cA cid cA cres fcoi2 ax-mp eqtri cA
      csymgrp cfv cgr wcel cid cA cres cA cA vx cv wf1o vx cab wcel cid cA cres
      cA csymgrp cfv cgi cfv wceq cid cA cres cid cA cres cA csymgrp cfv co cid
      cA cres wceq wb cA symggrpi.1 symggrpi cid cA cres cA cA vx cv wf1o vx
      cab wcel cA cA cid cA cres wf1o cA f1oi vx cA cA cA vx cv wf1o vx cab cid
      cA cres symggrpi.1 cA cA vx cv wf1o vx cab eqid elsymgrn mpbir cid cA
      cres cA csymgrp cfv cgi cfv cA csymgrp cfv cA cA vx cv wf1o vx cab cA
      csymgrp cfv cA cA vx cv wf1o vx cab cA symggrpi.1 symggrpi cA cA vx cv
      wf1o vx cab cA cA vx cv wf1o vx cab cxp cA cA vx cv wf1o vx cab cA
      csymgrp cfv vx cA cA cA vx cv wf1o vx cab symggrpi.1 cA cA vx cv wf1o vx
      cab eqid symgf fdmi grprn cA csymgrp cfv cgi cfv eqid grpid mp2an mpbir
      eqcomi $.
      $( [1-Dec-2010] $) $( [25-Feb-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Order theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Toset $.

  $( Extend class notation with the class of all totally ordered sets. $)
  ccha $a class Toset $.

  ${ $d r x y $.
    $( Define the class of all totally ordered sets.  (Contributed by FL,
       3-Nov-2009.) $)
    df-toset $a |- Toset = ( Poset i^i { r  | A. x e. U. U. r A. y e. U. U. r
      ( x r y \/ y r x ) } ) $.
  $}

  ${ $d R r x y $. $d X r x y $.
    istoset.1 $e |- X = U. U. R $.
    $( The predicate is a toset.  (Contributed by FL, 3-Nov-2009.) $)
    istoset $p |- ( R e. A -> ( R e. Toset <->
      ( R e. Poset /\ A. x e. X A. y e. X ( x R y \/ y R x ) ) ) ) $=
      cR cA wcel cR cps vx cv vy cv vr cv wbr vy cv vx cv vr cv wbr wo vy vr cv
      cuni cuni wral vx vr cv cuni cuni wral vr cab cin wcel cR cps wcel vx cv
      vy cv cR wbr vy cv vx cv cR wbr wo vy cX wral vx cX wral wa cR ccha wcel
      cR cA wcel cR cps wcel cR vx cv vy cv vr cv wbr vy cv vx cv vr cv wbr wo
      vy vr cv cuni cuni wral vx vr cv cuni cuni wral vr cab wcel wa cR cps
      wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cX wral vx cX wral wa cR
      cps vx cv vy cv vr cv wbr vy cv vx cv vr cv wbr wo vy vr cv cuni cuni
      wral vx vr cv cuni cuni wral vr cab cin wcel cR cA wcel cR vx cv vy cv vr
      cv wbr vy cv vx cv vr cv wbr wo vy vr cv cuni cuni wral vx vr cv cuni
      cuni wral vr cab wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cX wral
      vx cX wral cR cps wcel vx cv vy cv vr cv wbr vy cv vx cv vr cv wbr wo vy
      vr cv cuni cuni wral vx vr cv cuni cuni wral vx cv vy cv cR wbr vy cv vx
      cv cR wbr wo vy cX wral vx cX wral vr cR cA vr cv cR wceq vx cv vy cv vr
      cv wbr vy cv vx cv vr cv wbr wo vy vr cv cuni cuni wral vx vr cv cuni
      cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral
      vx cR cuni cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cX wral
      vx cX wral vr cv cR wceq vx cv vy cv vr cv wbr vy cv vx cv vr cv wbr wo
      vy vr cv cuni cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR
      cuni cuni wral vx vr cv cuni cuni cR cuni cuni vr cv cR wceq vr cv cuni
      cR cuni vr cv cR unieq unieqd vr cv cR wceq vx cv vy cv vr cv wbr vy cv
      vx cv vr cv wbr wo vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy vr cv cuni
      cuni cR cuni cuni vr cv cR wceq vr cv cuni cR cuni vr cv cR unieq unieqd
      vr cv cR wceq vx cv vy cv vr cv wbr vx cv vy cv cR wbr vy cv vx cv vr cv
      wbr vy cv vx cv cR wbr vx cv vy cv vr cv cR breq vy cv vx cv vr cv cR
      breq orbi12d raleq12d raleq12d vr cv cR wceq vx cv vy cv cR wbr vy cv vx
      cv cR wbr wo vy cR cuni cuni wral vx cv vy cv cR wbr vy cv vx cv cR wbr
      wo vy cX wral vx cR cuni cuni cX cR cuni cuni cX wceq vr cv cR wceq cX cR
      cuni cuni istoset.1 eqcomi a1i vr cv cR wceq vx cv vy cv cR wbr vy cv vx
      cv cR wbr wo vy cR cuni cuni cX cR cuni cuni cX wceq vr cv cR wceq cX cR
      cuni cuni istoset.1 eqcomi a1i raleq1d raleq12d bitrd elabg anbi2d cR cps
      vx cv vy cv vr cv wbr vy cv vx cv vr cv wbr wo vy vr cv cuni cuni wral vx
      vr cv cuni cuni wral vr cab elin syl5bb ccha cps vx cv vy cv vr cv wbr vy
      cv vx cv vr cv wbr wo vy vr cv cuni cuni wral vx vr cv cuni cuni wral vr
      cab cin cR vx vy vr df-toset eleq2i syl5bb $.
      $( [1-Dec-2010] $) $( [1-Nov-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Finite intersections
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c fi $.
  $( Extend class notation with the function whose value is the class of  all
     the finite intersections of the elements of a given set. $)
  cfi $a class fi $.

  ${
    $d x y u z $.
    $( Function whose value is the class of all the finite intersections of the
       elements of ` x ` .  (Contributed by FL, 2-Sep-2008.) $)
    df-fi $a |- fi = { <. x , y >. | y
            = { u | E. z ( z C_ x /\ z e. Fin /\ u = |^| z ) } } $.
  $}

  ${
    $d A u x y z $.
    $( The set of all the finite intersections of the elements of ` A ` .
       (Contributed by FL, 2-Sep-2008.) $)
    fiv $p |- ( A e. B -> ( fi ` A ) = { u | E. z ( z C_ A /\
        z e. Fin /\ u = |^| z ) } ) $=
      cA cvv wcel vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex
      vu cab cvv wcel cA cfi cfv vz cv cA wss vz cv cfn wcel vu cv vz cv cint
      wceq w3a vz wex vu cab wceq cA cB wcel vx vy cA vz cv vx cv wss vz cv cfn
      wcel vu cv vz cv cint wceq w3a vz wex vu cab vz cv cA wss vz cv cfn wcel
      vu cv vz cv cint wceq w3a vz wex vu cab cvv cvv cfi vx cv cA wceq vz cv
      vx cv wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vz cv cA wss vz
      cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu vx cv cA wceq vz cv vx cv
      wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz cv cA wss vz cv cfn wcel
      vu cv vz cv cint wceq w3a vz vx cv cA wceq vz cv vx cv wss vz cv cA wss
      vz cv cfn wcel vu cv vz cv cint wceq vx cv cA vz cv sseq2 3anbi1d exbidv
      abbidv cfi vy cv vz cv vx cv wss vz cv cfn wcel vu cv vz cv cint wceq w3a
      vz wex vu cab wceq vx vy copab vy cv vz cv vx cv wss vz cv cfn wcel vu cv
      vz cv cint wceq w3a vz wex vu cab wceq vx vy copab cvv cres vx cv cvv
      wcel vy cv vz cv vx cv wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz
      wex vu cab wceq wa vx vy copab vx vy vz vu df-fi vy cv vz cv vx cv wss vz
      cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cab wceq vx vy copab wrel
      vy cv vz cv vx cv wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu
      cab wceq vx vy copab cvv cres vy cv vz cv vx cv wss vz cv cfn wcel vu cv
      vz cv cint wceq w3a vz wex vu cab wceq vx vy copab wceq vy cv vz cv vx cv
      wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cab wceq vx vy
      relopab vy cv vz cv vx cv wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz
      wex vu cab wceq vx vy copab resid ax-mp vy cv vz cv vx cv wss vz cv cfn
      wcel vu cv vz cv cint wceq w3a vz wex vu cab wceq vx vy cvv resopab
      3eqtr2i fvopab4g cA cB elisset cA cB wcel vu cv cA cuni cpw wcel vz cv cA
      wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex wa vu cab cvv vz cv
      cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cab cA cB wcel
      vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cA cuni
      cpw crab cvv vu cv cA cuni cpw wcel vz cv cA wss vz cv cfn wcel vu cv vz
      cv cint wceq w3a vz wex wa vu cab cA cB wcel cA cuni cpw cvv wcel vz cv
      cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cA cuni cpw
      crab cvv wcel cA cB wcel cA cuni cvv wcel cA cuni cpw cvv wcel cA cB
      uniexg cA cuni cvv pwexg syl vz cv cA wss vz cv cfn wcel vu cv vz cv cint
      wceq w3a vz wex vu cA cuni cpw cvv rabexg syl vz cv cA wss vz cv cfn wcel
      vu cv vz cv cint wceq w3a vz wex vu cA cuni cpw df-rab syl5eqelr vu cv cA
      cuni cpw wcel vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz
      wex wa vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu vu
      cv cA cuni cpw wcel vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a
      vz wex wa vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu
      cv cA cuni cpw wcel vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a
      vz wex pm3.27 vz cv cA wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz
      wex vu cv cA cuni cpw wcel vz cv cA wss vz cv cfn wcel vu cv vz cv cint
      wceq w3a vu cv cA cuni cpw wcel vz vz cv cA wss vz cv cfn wcel vu cv vz
      cv cint wceq vu cv cA cuni cpw wcel vu cv cvv wcel vz cv cA wss vz cv cfn
      wcel vu cv vz cv cint wceq vu cv cA cuni cpw wcel wi wi wi vu visset vu
      cv vz cv cint wceq vu cv cvv wcel vz cv cA wss vz cv cfn wcel vu cv cA
      cuni cpw wcel vu cv cvv wcel vu cv vz cv cint wceq vz cv cA wss vz cv cfn
      wcel vu cv cA cuni cpw wcel wi wi vu cv vz cv cint wceq vu cv cvv wcel vz
      cv cint cvv wcel vu cv vz cv cint wceq vz cv cA wss vz cv cfn wcel vu cv
      cA cuni cpw wcel wi wi wi vu cv vz cv cint cvv eleq1 vz cv cint cvv wcel
      vz cv c0 wne vu cv vz cv cint wceq vz cv cA wss vz cv cfn wcel vu cv cA
      cuni cpw wcel wi wi wi vz cv intex vz cv cA wss vz cv c0 wne vu cv vz cv
      cint wceq vz cv cfn wcel vu cv cA cuni cpw wcel wi vz cv cA wss vz cv c0
      wne vz cv cint cA cuni wss vu cv vz cv cint wceq vz cv cfn wcel vu cv cA
      cuni cpw wcel wi wi vz cv cA wss vz cv c0 wne vz cv cint cA cuni wss vz
      cv cA intssuni2 ex vu cv vz cv cint wceq vz cv cint cA cuni wss vu cv cA
      cuni wss vz cv cfn wcel vu cv cA cuni cpw wcel wi vu cv vz cv cint wceq
      vu cv cA cuni wss vz cv cint cA cuni wss vu cv vz cv cint cA cuni sseq1
      biimprd vu cv cA cuni wss vu cv cA cuni cpw wcel vz cv cfn wcel vu cv cA
      cuni cpw wcel vu cv cA cuni wss vu cv cA cuni vu visset elpw biimpri a1d
      syl6com syl6 com3l sylbir syl6bi pm2.43a com4l ax-mp 3imp 19.23aiv ancri
      impbii abbii syl5eqelr sylanc $.
      $( [1-Dec-2010] $) $( [27-Apr-2008] $)
  $}

  ${
    $d A a x y $.
    $( Condition required for a nonempty finite intersection.  (Contributed by
       FL, 2-Sep-2008.) $)
    fine $p |- ( A =/= (/)
               -> { x | E. y ( y C_ A /\ y e. Fin /\ x = |^| y ) } =/= (/) ) $=
      va cv cA wcel va wex vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx wex cA c0 wne vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab c0 wne va cv cA wcel vy cv cA wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx wex va va cv cA wcel vy cv cA wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx va va cv cA wcel vx ax-17
      vx cv va cv wceq va cv cA wcel vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex va cv csn cA wss va cv csn cfn wcel vx cv va cv csn
      cint wceq vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cv va cv wceq va cv cA wcel wa va cv csn cvv wcel va cv csn cA wss va cv
      csn cfn wcel vx cv va cv csn cint wceq w3a vy cv cA wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex wi va cv snex vy cv cA wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a va cv csn cA wss va cv csn cfn wcel vx cv va cv
      csn cint wceq w3a vy va cv csn cvv vy cv va cv csn wceq vy cv cA wss va
      cv csn cA wss vy cv cfn wcel va cv csn cfn wcel vx cv vy cv cint wceq vx
      cv va cv csn cint wceq vy cv va cv csn cA sseq1 vy cv va cv csn cfn eleq1
      vy cv va cv csn wceq vy cv cint va cv csn cint vx cv vy cv va cv csn
      inteq eqeq2d 3anbi123d cla4egv ax-mp va cv cA wcel va cv csn cA wss vx cv
      va cv wceq va cv cA snssi adantl va cv csn cfn wcel vx cv va cv wceq va
      cv cA wcel wa va cv snfi a1i vx cv va cv wceq vx cv va cv csn cint wceq
      va cv cA wcel vx cv va cv wceq vx cv va cv csn cint wceq va cv va cv csn
      cint vx cv va cv csn cint va cv va cv va visset intsn eqcomi eqeq2i
      biimpi adantr syl3anc ex a4ime 19.23aiv va cA n0 vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx abn0 3imtr4i $.
      $( [1-Dec-2010] $) $( [16-Nov-2007] $)
  $}

  ${
    $d A x y $.
    $( If ` A ` is not empty, the class of all the finite intersections of
       ` A ` is not empty either.  (Contributed by FL, 2-Sep-2008.) $)
    fine2 $p |- ( A e. B -> (  A =/= (/) -> ( fi ` A ) =/= (/) ) ) $=
      cA cB wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vx cab c0 wne cA cfi cfv c0 wne cA c0 wne cA cB wcel vy cv cA wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab cA cfi cfv c0 cA cB wcel
      cA cfi cfv vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vx cab vy vx cA cB fiv eqcomd neeq1d vx vy cA fine syl5bi $.
      $( [1-Dec-2010] $) $( [27-Apr-2008] $)
  $}

  ${
    $d A x y  $.
    $( Any element of ` A ` is the intersection of a finite subclass of
       ` A ` .  (Contributed by FL, 2-Sep-2008.) $)
    abfi $p |- A
               C_ { x | E. y ( y C_ A /\ y e. Fin /\ x = |^| y ) } $=
      cA vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wss vx cv cA wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex wi vx vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vx cA ssab vx cv csn cA cpw wcel vy cv cfn wcel vx cv vy cv cint wceq wa
      vy cA cpw wrex vx cv cA wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cv csn cA cpw wcel vx cv csn cfn wcel vx cv vx cv csn
      cint wceq vy cv cfn wcel vx cv vy cv cint wceq wa vy cA cpw wrex vx cv
      snfi vx cv csn cint vx cv vx cv vx visset intsn eqcomi vx cv csn cA cpw
      wcel vx cv csn cfn wcel vx cv vx cv csn cint wceq wa vy cv cfn wcel vx cv
      vy cv cint wceq wa vy cA cpw wrex vy cv cfn wcel vx cv vy cv cint wceq wa
      vx cv csn cfn wcel vx cv vx cv csn cint wceq wa vy vx cv csn cA cpw vy cv
      vx cv csn wceq vy cv cfn wcel vx cv csn cfn wcel vx cv vy cv cint wceq vx
      cv vx cv csn cint wceq vy cv vx cv csn cfn eleq1 vy cv vx cv csn wceq vy
      cv cint vx cv csn cint vx cv vy cv vx cv csn inteq eqeq2d anbi12d rcla4ev
      ex mp2ani vx cv cA vx visset snelpw vy cv cfn wcel vx cv vy cv cint wceq
      wa vy cA cpw wrex vy cv cA cpw wcel vy cv cfn wcel vx cv vy cv cint wceq
      wa wa vy wex vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vy cv cfn wcel vx cv vy cv cint wceq wa vy cA cpw df-rex vy cv cA cpw
      wcel vy cv cfn wcel vx cv vy cv cint wceq wa wa vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy vy cv cA cpw wcel vy cv cfn wcel vx cv
      vy cv cint wceq wa wa vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      wa wa vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy cv cA cpw
      wcel vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq wa vy cv cA vy
      visset elpw anbi1i vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      3anass bitr4i exbii bitr2i 3imtr4i mpgbir $.
      $( [1-Dec-2010] $) $( [18-Nov-2007] $)
  $}

  ${
    $d A x y $.
    $( Any element of a set ` A ` is the intersection of a finite subset of
       ` A ` .  (Contributed by FL, 27-Apr-2008.) $)
    abfi2 $p |- ( A e. B -> A C_ ( fi ` A ) ) $=
      cA cB wcel cA cA cfi cfv wss cA vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx wex vy cab wss vy vx cA abfi cA cB wcel cA cfi cfv vx cv
      cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cab cA vx vy cA
      cB fiv sseq2d mpbiri $.
      $( [1-Dec-2010] $) $( [27-Apr-2008] $)
  $}

  ${
    $d A x y $.  $d C x $.
    $( Specific properties of a finite intersection.  (Contributed by FL,
       2-Sep-2008.) $)
    spfi $p |- ( A e. B -> ( A e. { x | E. y ( y C_ C /\ y e. Fin
         /\ x = |^| y ) } <-> E. y ( y C_ C /\ y e. Fin /\ A = |^| y ) ) ) $=
      vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vy cv cC wss
      vy cv cfn wcel cA vy cv cint wceq w3a vy wex vx cA cB vx cv cA wceq vy cv
      cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy cv cC wss vy cv cfn
      wcel cA vy cv cint wceq w3a vy vx cv cA wceq vx cv vy cv cint wceq cA vy
      cv cint wceq vy cv cC wss vy cv cfn wcel vx cv cA vy cv cint eqeq1
      3anbi3d exbidv elabg $.
      $( [1-Dec-2010] $) $( [30-Oct-2007] $)
  $}

  ${ $d A u z $.  $d C u z $.
    $( Specific properties of an element of ` ( fi `` C ) ` .  (Contributed by
       FL, 2-Sep-2008.) $)
    sppfi $p |- ( ( A e. B /\ C e. D )
       -> ( A e. ( fi ` C ) <-> E. z ( z C_ C /\ z e. Fin /\ A = |^| z ) ) ) $=
      cA cB wcel cC cD wcel wa cA cC cfi cfv wcel cA vz cv cC wss vz cv cfn
      wcel vu cv vz cv cint wceq w3a vz wex vu cab wcel vz cv cC wss vz cv cfn
      wcel cA vz cv cint wceq w3a vz wex cA cB wcel cC cD wcel wa cC cfi cfv vz
      cv cC wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cab cA cC cD
      wcel cC cfi cfv vz cv cC wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz
      wex vu cab wceq cA cB wcel vz vu cC cD fiv adantl eleq2d cA cB wcel cA vz
      cv cC wss vz cv cfn wcel vu cv vz cv cint wceq w3a vz wex vu cab wcel vz
      cv cC wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex wb cC cD wcel vu
      vz cA cB cC spfi adantr bitrd $.
      $( [1-Dec-2010] $) $( [27-Apr-2008] $)
  $}

  ${
    $d w x y z A $. $d w x y z B $.
    $( The union of the finite intersections of a set is simply the union of
       the set itself. (Contributed by Jeff Hankins, 5-Sep-2009.) $)
    fiuni $p |- ( A e. B -> U. A = U. ( fi ` A ) ) $=
      cA cB wcel cA cuni cA cfi cfv cuni cA cB wcel cA cA cfi cfv wss cA cuni
      cA cfi cfv cuni wss cA cB abfi2 cA cA cfi cfv uniss syl cA cB wcel vx cv
      vy cv wss vy cA wrex vx cA cfi cfv wral cA cfi cfv cuni cA cuni wss cA cB
      wcel vx cv vy cv wss vy cA wrex vx cA cfi cfv cA cB wcel vx cv cA cfi cfv
      wcel vz cv cA wss vz cv cfn wcel vx cv vz cv cint wceq w3a vz wex vx cv
      vy cv wss vy cA wrex vx cv cvv wcel cA cB wcel vx cv cA cfi cfv wcel vz
      cv cA wss vz cv cfn wcel vx cv vz cv cint wceq w3a vz wex wb vx visset vz
      vx cv cvv cA cB sppfi mpan cA cB wcel vz cv cA wss vz cv cfn wcel vx cv
      vz cv cint wceq w3a vx cv vy cv wss vy cA wrex vz cA cB wcel vz cv cA wss
      vz cv cfn wcel vx cv vz cv cint wceq w3a vx cv vy cv wss vy cA wrex cA cB
      wcel vz cv cA wss vz cv cfn wcel vx cv vz cv cint wceq w3a wa vz cv c0
      wne vx cv vy cv wss vy cA wrex cA cB wcel vz cv cA wss vz cv cfn wcel vx
      cv vz cv cint wceq w3a wa vz cv c0 wceq wn vz cv c0 wne cA cB wcel vz cv
      cA wss vz cv cfn wcel vx cv vz cv cint wceq w3a wa vz cv c0 wceq vx cv c0
      cint wceq vx cv c0 cint wceq vx cvv cvv wcel vx cv c0 cint wceq vx wex
      vprc cvv cvv wcel c0 cint cvv wcel vx cv c0 cint wceq vx wex c0 cint cvv
      cvv int0 eleq1i vx c0 cint isset bitr3i mtbi nexr vz cv cA wss vz cv cfn
      wcel vx cv vz cv cint wceq w3a vz cv c0 wceq vx cv c0 cint wceq wi cA cB
      wcel vx cv vz cv cint wceq vz cv cA wss vz cv c0 wceq vx cv c0 cint wceq
      wi vz cv cfn wcel vz cv c0 wceq vx cv vz cv cint wceq vx cv c0 cint wceq
      vz cv c0 wceq vz cv cint c0 cint vx cv vz cv c0 inteq eqeq2d biimpcd
      3ad2ant3 adantl mtoi vz cv c0 df-ne sylibr cA cB wcel vz cv cA wss vz cv
      cfn wcel vx cv vz cv cint wceq w3a wa vw cv vz cv wcel vw wex vx cv vy cv
      wss vy cA wrex vz cv c0 wne cA cB wcel vz cv cA wss vz cv cfn wcel vx cv
      vz cv cint wceq w3a wa vw cv vz cv wcel vx cv vy cv wss vy cA wrex vw cA
      cB wcel vz cv cA wss vz cv cfn wcel vx cv vz cv cint wceq w3a wa vw cv vz
      cv wcel vx cv vy cv wss vy cA wrex vz cv cA wss vz cv cfn wcel vx cv vz
      cv cint wceq w3a vw cv vz cv wcel vx cv vy cv wss vy cA wrex cA cB wcel
      vw cv cA wcel vx cv vw cv wss vx cv vy cv wss vy cA wrex vz cv cA wss vz
      cv cfn wcel vx cv vz cv cint wceq w3a vw cv vz cv wcel wa vx cv vy cv wss
      vx cv vw cv wss vy vw cv cA vy cv vw cv vx cv sseq2 rcla4ev vz cv cA wss
      vz cv cfn wcel vw cv vz cv wcel vw cv cA wcel vx cv vz cv cint wceq vz cv
      cA vw cv ssel2 3ad2antl1 vx cv vz cv cint wceq vz cv cA wss vw cv vz cv
      wcel vx cv vw cv wss vz cv cfn wcel vx cv vz cv cint wceq vw cv vz cv
      wcel wa vx cv vw cv wss vz cv cint vw cv wss vw cv vz cv wcel vz cv cint
      vw cv wss vx cv vz cv cint wceq vw cv vz cv intss1 adantl vx cv vz cv
      cint wceq vx cv vw cv wss vz cv cint vw cv wss wb vw cv vz cv wcel vx cv
      vz cv cint vw cv sseq1 adantr mpbird 3ad2antl3 sylanc adantll ex 19.23adv
      vw vz cv n0 syl5ib mpd ex 19.23adv sylbid r19.21aiv vx vy cA cfi cfv cA
      uniss2 syl eqssd $.
      $( [1-Dec-2010] $) $( [5-Sep-2009] $)
  $}

  ${ $d A y $.  $d B y $.
    $( If ` A ` is the intersection of a finite set of elements of ` B ` then
       ` A C_ U. B ` .  (Contributed by FL, 2-Sep-2008.) $)
    fiiu2 $p |- ( B e. C -> ( A e. ( fi ` B )
       -> A C_ U. B ) ) $=
      cA cB cfi cfv wcel cB cC wcel cA cB cuni wss cA cB cfi cfv wcel cB cC
      wcel cA cB cuni wss wi cA cB cfi cfv wcel cA cB cfi cfv wcel cA cvv wceq
      wn cB cC wcel cA cB cuni wss wi cA cB cfi cfv wcel cA cvv wceq cvv cB cfi
      cfv wcel cB cfi cfv nvel cA cvv wceq cA cB cfi cfv wcel cvv cB cfi cfv
      wcel cA cvv cB cfi cfv eleq1 biimpcd mtoi cA cB cfi cfv wcel cA cB cfi
      cfv wcel cB cC wcel cA cvv wceq wn cA cB cuni wss cA cB cfi cfv wcel cB
      cC wcel cA cB cfi cfv wcel cA cvv wceq wn cA cB cuni wss wi cA cB cfi cfv
      wcel cB cC wcel cA cB cfi cfv wcel cA cvv wceq wn cA cB cuni wss wi wi cA
      cB cfi cfv wcel cB cC wcel wa cA cB cfi cfv wcel vy cv cB wss vy cv cfn
      wcel cA vy cv cint wceq w3a vy wex cA cvv wceq wn cA cB cuni wss wi vy cA
      cB cfi cfv cB cC sppfi vy cv cB wss vy cv cfn wcel cA vy cv cint wceq w3a
      cA cvv wceq wn cA cB cuni wss wi vy vy cv cB wss cA vy cv cint wceq cA
      cvv wceq wn cA cB cuni wss wi vy cv cfn wcel cA vy cv cint wceq vy cv cB
      wss cA cvv wceq wn cA cB cuni wss wi cA vy cv cint wceq vy cv cB wss cA
      cvv wceq wn cA cB cuni wss wi wi cA vy cv cint wceq cA cvv wceq wn vy cv
      cB wss cA vy cv cint wceq cA cB cuni wss cA vy cv cint wceq cA cvv wceq
      wn vy cv c0 wne vy cv cB wss cA vy cv cint wceq cA cB cuni wss wi wi cA
      vy cv cint wceq cA cvv wceq wn vy cv cint cvv wceq wn vy cv c0 wne cA vy
      cv cint wceq cA cvv wceq vy cv cint cvv wceq cA vy cv cint cvv eqeq1
      notbid c0 cint cvv wceq vy cv cint cvv wceq wn vy cv c0 wne wi int0 c0
      cint cvv wceq vy cv cint cvv wne vy cv c0 wne vy cv cint cvv wceq wn c0
      cint cvv wceq vy cv cint cvv wne vy cv cint c0 cint wne vy cv c0 wne c0
      cint cvv vy cv cint neeq2 vy cv c0 vy cv cint c0 cint vy cv c0 inteq
      necon3i syl6bir vy cv cint cvv df-ne syl5ibr ax-mp syl6bi vy cv cB wss vy
      cv c0 wne cA vy cv cint wceq cA cB cuni wss wi cA vy cv cint wceq vy cv
      cint cB cuni wss cA cB cuni wss vy cv cB wss vy cv c0 wne wa vy cv cint
      cB cuni wss cA cB cuni wss wi vy cv cint cA vy cv cint cA wceq vy cv cint
      cB cuni wss cA cB cuni wss vy cv cint cA cB cuni sseq1 biimpd eqcoms vy
      cv cB intssuni2 syl5com expcom syl6 com24 pm2.43i impcom 3adant2 19.23aiv
      syl6bi ex com23 com34 mpid pm2.43i com12 $.
      $( [1-Dec-2010] $) $( [27-Apr-2008] $)
  $}





  ${
    $d m n u v x y J $. $d m n x y X $.
    hausnei2.1 $e |- X = U. J $.
    $( The Hausdorff condition still holds if one considers general
       neighborhoods instead of open sets. (Contributed by Jeff Hankins,
       5-Sep-2009.) $)
    hausnei2 $p |- ( J e. Top -> ( J e. Haus <-> A. x e. X A. y e. X ( x =/= y
    -> E. u e. ( ( nei ` J ) ` { x } ) E. v e. ( ( nei ` J ) ` { y } ) ( u i^i
    v ) = (/) ) ) ) $=
      cJ ctop wcel cJ cha wcel vx cv vy cv wne vx cv vm cv wcel vy cv vn cv
      wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ wrex wi vy cX wral vx
      cX wral vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv
      cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi vy cX wral vx cX wral cJ
      cha wcel cJ ctop wcel vx cv vy cv wne vx cv vm cv wcel vy cv vn cv wcel
      vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ wrex wi vy cX wral vx cX
      wral vx vy vn vm cJ cX hausnei2.1 ishaus baib cJ ctop wcel vx cv vy cv
      wne vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ
      wrex vm cJ wrex wi vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn
      cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi vx vy cX cX cJ
      ctop wcel vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a
      vn cJ wrex vm cJ wrex vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv
      cfv wrex vu vx cv csn cJ cnei cfv cfv wrex vx cv vy cv wne cJ ctop wcel
      vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex
      vm cJ wrex vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu
      vx cv csn cJ cnei cfv cfv wrex cJ ctop wcel vx cv vm cv wcel vy cv vn cv
      wcel vm cv vn cv cin c0 wceq w3a vu cv vv cv cin c0 wceq vv vy cv csn cJ
      cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex vm vn cJ cJ cJ ctop
      wcel vm cv cJ wcel vn cv cJ wcel vx cv vm cv wcel vy cv vn cv wcel vm cv
      vn cv cin c0 wceq w3a vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv
      cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi cJ ctop wcel vm cv cJ wcel
      vn cv cJ wcel w3a vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0
      wceq w3a vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu vx
      cv csn cJ cnei cfv cfv wrex vm cv vx cv csn cJ cnei cfv cfv wcel vn cv vy
      cv csn cJ cnei cfv cfv wcel vm cv vn cv cin c0 wceq vu cv vv cv cin c0
      wceq vv vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex
      cJ ctop wcel vm cv cJ wcel vn cv cJ wcel w3a vx cv vm cv wcel vy cv vn cv
      wcel vm cv vn cv cin c0 wceq w3a wa vu cv vv cv cin c0 wceq vm cv vn cv
      cin c0 wceq vm cv vv cv cin c0 wceq vu vv vm cv vn cv vx cv csn cJ cnei
      cfv cfv vy cv csn cJ cnei cfv cfv vu cv vm cv wceq vu cv vv cv cin vm cv
      vv cv cin c0 vu cv vm cv vv cv ineq1 eqeq1d vv cv vn cv wceq vm cv vv cv
      cin vm cv vn cv cin c0 vv cv vn cv vm cv ineq2 eqeq1d rcla42ev cJ ctop
      wcel vm cv cJ wcel vx cv vm cv wcel vm cv vx cv csn cJ cnei cfv cfv wcel
      cJ ctop wcel vm cv cJ wcel vn cv cJ wcel w3a vx cv vm cv wcel vy cv vn cv
      wcel vm cv vn cv cin c0 wceq w3a wa vx cv cJ vm cv opnneip cJ ctop wcel
      vm cv cJ wcel vn cv cJ wcel w3a cJ ctop wcel vx cv vm cv wcel vy cv vn cv
      wcel vm cv vn cv cin c0 wceq w3a cJ ctop wcel vm cv cJ wcel vn cv cJ wcel
      3simp1 adantr cJ ctop wcel vm cv cJ wcel vn cv cJ wcel w3a vm cv cJ wcel
      vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a cJ ctop
      wcel vm cv cJ wcel vn cv cJ wcel 3simp2 adantr vx cv vm cv wcel vy cv vn
      cv wcel vm cv vn cv cin c0 wceq w3a vx cv vm cv wcel cJ ctop wcel vm cv
      cJ wcel vn cv cJ wcel w3a vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv
      cin c0 wceq 3simp1 adantl syl3anc cJ ctop wcel vn cv cJ wcel vy cv vn cv
      wcel vn cv vy cv csn cJ cnei cfv cfv wcel cJ ctop wcel vm cv cJ wcel vn
      cv cJ wcel w3a vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq
      w3a wa vy cv cJ vn cv opnneip cJ ctop wcel vm cv cJ wcel vn cv cJ wcel
      w3a cJ ctop wcel vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0
      wceq w3a cJ ctop wcel vm cv cJ wcel vn cv cJ wcel 3simp1 adantr cJ ctop
      wcel vm cv cJ wcel vn cv cJ wcel w3a vn cv cJ wcel vx cv vm cv wcel vy cv
      vn cv wcel vm cv vn cv cin c0 wceq w3a cJ ctop wcel vm cv cJ wcel vn cv
      cJ wcel 3simp3 adantr vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin
      c0 wceq w3a vy cv vn cv wcel cJ ctop wcel vm cv cJ wcel vn cv cJ wcel w3a
      vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq 3simp2 adantl
      syl3anc vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vm
      cv vn cv cin c0 wceq cJ ctop wcel vm cv cJ wcel vn cv cJ wcel w3a vx cv
      vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq 3simp3 adantl syl3anc
      ex 3expib r19.23advv cJ ctop wcel vu cv vv cv cin c0 wceq vx cv vm cv
      wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ wrex
      vu vv vx cv csn cJ cnei cfv cfv vy cv csn cJ cnei cfv cfv cJ ctop wcel vx
      cv csn vm cv wss vm cv vu cv wss wa vm cJ wrex vy cv csn vn cv wss vn cv
      vv cv wss wa vn cJ wrex vu cv vv cv cin c0 wceq vx cv vm cv wcel vy cv vn
      cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ wrex wi vu cv vx cv
      csn cJ cnei cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel cJ ctop
      wcel vx cv csn vm cv wss vm cv vu cv wss wa vm cJ wrex vy cv csn vn cv
      wss vn cv vv cv wss wa vn cJ wrex vu cv vv cv cin c0 wceq vx cv vm cv
      wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ wrex
      wi cJ ctop wcel vu cv vv cv cin c0 wceq vy cv csn vn cv wss vn cv vv cv
      wss wa vn cJ wrex vx cv csn vm cv wss vm cv vu cv wss wa vm cJ wrex vx cv
      vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ
      wrex cJ ctop wcel vu cv vv cv cin c0 wceq vy cv csn vn cv wss vn cv vv cv
      wss wa vn cJ wrex vx cv csn vm cv wss vm cv vu cv wss wa vm cJ wrex vx cv
      vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ
      wrex wi cJ ctop wcel vu cv vv cv cin c0 wceq vy cv csn vn cv wss vn cv vv
      cv wss wa vn cJ wrex w3a vx cv csn vm cv wss vm cv vu cv wss wa vx cv vm
      cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vm cJ cJ
      ctop wcel vu cv vv cv cin c0 wceq vy cv csn vn cv wss vn cv vv cv wss wa
      vn cJ wrex w3a vx cv vm cv wcel vm cv vu cv wss wa vx cv vm cv wcel vy cv
      vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex vx cv csn vm cv wss vm
      cv vu cv wss wa cJ ctop wcel vu cv vv cv cin c0 wceq vy cv csn vn cv wss
      vn cv vv cv wss wa vn cJ wrex vx cv vm cv wcel vm cv vu cv wss wa vx cv
      vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex wi cJ
      ctop wcel vu cv vv cv cin c0 wceq vx cv vm cv wcel vm cv vu cv wss wa vy
      cv csn vn cv wss vn cv vv cv wss wa vn cJ wrex vx cv vm cv wcel vy cv vn
      cv wcel vm cv vn cv cin c0 wceq w3a vn cJ wrex cJ ctop wcel vu cv vv cv
      cin c0 wceq vx cv vm cv wcel vm cv vu cv wss wa vy cv csn vn cv wss vn cv
      vv cv wss wa vn cJ wrex vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin
      c0 wceq w3a vn cJ wrex wi cJ ctop wcel vu cv vv cv cin c0 wceq vx cv vm
      cv wcel vm cv vu cv wss wa w3a vy cv csn vn cv wss vn cv vv cv wss wa vx
      cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vn cJ vu cv vv
      cv cin c0 wceq vx cv vm cv wcel vm cv vu cv wss wa vy cv csn vn cv wss vn
      cv vv cv wss wa vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq
      w3a wi cJ ctop wcel vu cv vv cv cin c0 wceq vx cv vm cv wcel vm cv vu cv
      wss wa vy cv csn vn cv wss vn cv vv cv wss wa vx cv vm cv wcel vy cv vn
      cv wcel vm cv vn cv cin c0 wceq w3a wi vx cv vm cv wcel vm cv vu cv wss
      wa vy cv csn vn cv wss vn cv vv cv wss wa vu cv vv cv cin c0 wceq vx cv
      vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vx cv vm cv wcel
      vm cv vu cv wss wa vy cv vn cv wcel vn cv vv cv wss wa vu cv vv cv cin c0
      wceq vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a wi vy
      cv csn vn cv wss vn cv vv cv wss wa vx cv vm cv wcel vm cv vu cv wss wa
      vy cv vn cv wcel vn cv vv cv wss wa vu cv vv cv cin c0 wceq vx cv vm cv
      wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq w3a vx cv vm cv wcel vm cv
      vu cv wss wa vy cv vn cv wcel vn cv vv cv wss wa vu cv vv cv cin c0 wceq
      w3a vx cv vm cv wcel vy cv vn cv wcel vm cv vn cv cin c0 wceq vx cv vm cv
      wcel vm cv vu cv wss wa vy cv vn cv wcel vn cv vv cv wss wa vx cv vm cv
      wcel vu cv vv cv cin c0 wceq vx cv vm cv wcel vm cv vu cv wss pm3.26
      3ad2ant1 vy cv vn cv wcel vn cv vv cv wss wa vx cv vm cv wcel vm cv vu cv
      wss wa vy cv vn cv wcel vu cv vv cv cin c0 wceq vy cv vn cv wcel vn cv vv
      cv wss pm3.26 3ad2ant2 vx cv vm cv wcel vm cv vu cv wss wa vy cv vn cv
      wcel vn cv vv cv wss wa vu cv vv cv cin c0 wceq vm cv vn cv cin c0 wceq
      vm cv vu cv wss vn cv vv cv wss vu cv vv cv cin c0 wceq vm cv vn cv cin
      c0 wceq wi vx cv vm cv wcel vy cv vn cv wcel vm cv vu cv wss vn cv vv cv
      wss wa vm cv vn cv cin vu cv vv cv cin wss vu cv vv cv cin c0 wceq vm cv
      vn cv cin c0 wceq wi vm cv vu cv vn cv vv cv ss2in vm cv vn cv cin vu cv
      vv cv cin wss vm cv vn cv cin c0 vu cv vv cv cin c0 vm cv vn cv cin vu cv
      vv cv cin wss vm cv vn cv cin c0 wne vu cv vv cv cin c0 wne vm cv vn cv
      cin vu cv vv cv cin ssn0 ex necon4d syl ad2ant2l 3impia 3jca 3exp vy cv
      vn cv wcel vy cv csn vn cv wss vn cv vv cv wss vy cv vn cv vy visset snss
      anbi1i syl5ibr com3r imp 3adant1 r19.22sdv 3exp com34 3imp vx cv vm cv
      wcel vx cv csn vm cv wss vm cv vu cv wss vx cv vm cv vx visset snss
      anbi1i syl5ibr r19.22sdv 3exp com24 imp3a cJ ctop wcel vu cv vx cv csn cJ
      cnei cfv cfv wcel vx cv csn vm cv wss vm cv vu cv wss wa vm cJ wrex vx cv
      csn vm cJ vu cv neii2 ex cJ ctop wcel vv cv vy cv csn cJ cnei cfv cfv
      wcel vy cv csn vn cv wss vn cv vv cv wss wa vn cJ wrex vy cv csn vn cJ vv
      cv neii2 ex syl2and r19.23advv impbid imbi2d 2ralbidv bitrd $.
      $( [1-Dec-2010] $) $( [5-Sep-2009] $)
  $}

  ${
    $d R u v w x z $. $d S u v w x z $. $d T u v w x z $.
    $d X u v w x z $. $d Y u v w x z $. $d Z u v w x z $.
    tx1cn.1 $e |- T = ( R tX S ) $.
    tx1cn.2 $e |- X = U. R $.
    tx1cn.3 $e |- Y = U. S $.
    tx1cn.4 $e |- Z = ( X X. Y ) $.
    $( Continuity of the first projection map of a topological product.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    tx1cn $p |- ( ( R e. Top /\ S e. Top ) -> ( 1st |` Z ) e. ( T Cn R ) ) $=
      cR ctop wcel cS ctop wcel wa c1st cZ cres cT cR ccn co wcel cT cuni cX
      c1st cZ cres wf c1st cZ cres ccnv vw cv cima cT wcel vw cR wral wa cR
      ctop wcel cS ctop wcel wa cT cuni cX c1st cZ cres wf c1st cZ cres ccnv vw
      cv cima cT wcel vw cR wral cR ctop wcel cS ctop wcel wa cT cuni cX c1st
      cZ cres wf cX cY cxp cX c1st cX cY cxp cres wf cX cY f1stres cR ctop wcel
      cS ctop wcel wa cT cuni cX c1st cZ cres wf cT cuni cX c1st cX cY cxp cres
      wf cX cY cxp cX c1st cX cY cxp cres wf cR ctop wcel cS ctop wcel wa cT
      cuni cX c1st cZ cres c1st cX cY cxp cres cR ctop wcel cS ctop wcel wa cZ
      cX cY cxp wceq c1st cZ cres c1st cX cY cxp cres wceq cZ cX cY cxp wceq cR
      ctop wcel cS ctop wcel wa tx1cn.4 a1i cZ cX cY cxp c1st reseq2 syl feq1d
      cR ctop wcel cS ctop wcel wa cT cuni cX cY cxp wceq cT cuni cX c1st cX cY
      cxp cres wf cX cY cxp cX c1st cX cY cxp cres wf wb cR cS cT cX cY tx1cn.1
      tx1cn.2 tx1cn.3 txuni cT cuni cX cY cxp cX c1st cX cY cxp cres feq2 syl
      bitrd mpbiri cR ctop wcel cS ctop wcel wa c1st cZ cres ccnv vw cv cima cT
      wcel vw cR cR ctop wcel cS ctop wcel wa vw cv cR wcel wa vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab cT c1st cZ cres ccnv vw cv cima
      cR ctop wcel cS ctop wcel wa vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab cT wss vw cv cR wcel cR ctop wcel cS ctop wcel wa vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vz cab ctg cfv cT cR ctop wcel cS ctop wcel wa vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctb wcel vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab ctg cfv wss vz vv vu cR cS txbas vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab bastg syl cR ctop wcel cS ctop wcel
      wa cR cS ctx co vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      ctg cfv cT vz vv vu cR cS txval tx1cn.1 syl5eq sseqtr4d adantr cR ctop
      wcel cS ctop wcel wa vw cv cR wcel wa c1st cZ cres ccnv vw cv cima vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel c1st cZ cres ccnv
      vw cv cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cv cR wcel cY cS
      wcel c1st cZ cres ccnv vw cv cima vw cv cY cxp wceq c1st cZ cres ccnv vw
      cv cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex cR ctop wcel cS ctop
      wcel wa vw cv cR wcel wa c1st cZ cres ccnv vw cv cima vu cv vv cv cxp
      wceq c1st cZ cres ccnv vw cv cima vw cv cY cxp wceq c1st cZ cres ccnv vw
      cv cima vw cv vv cv cxp wceq vu vv vw cv cY cR cS vu cv vw cv wceq vu cv
      vv cv cxp vw cv vv cv cxp c1st cZ cres ccnv vw cv cima vu cv vw cv vv cv
      xpeq1 eqeq2d vv cv cY wceq vw cv vv cv cxp vw cv cY cxp c1st cZ cres ccnv
      vw cv cima vv cv cY vw cv xpeq2 eqeq2d rcla42ev cR ctop wcel cS ctop wcel
      wa vw cv cR wcel pm3.27 cS ctop wcel cY cS wcel cR ctop wcel vw cv cR
      wcel cS cY tx1cn.3 topopn ad2antlr cR ctop wcel cS ctop wcel wa vw cv cR
      wcel wa c1st cX cY cxp cres ccnv vw cv cima vw cv cY cxp c1st cZ cres
      ccnv vw cv cima cR ctop wcel cS ctop wcel wa vw cv cR wcel wa c1st cX cY
      cxp cres ccnv vw cv cima vw cv cY cxp cR ctop wcel cS ctop wcel wa vw cv
      cR wcel wa vz c1st cX cY cxp cres ccnv vw cv cima vw cv cY cxp cR ctop
      wcel cS ctop wcel wa vw cv cR wcel wa vz cv c1st cX cY cxp cres ccnv vw
      cv cima wcel vz cv cX cY cxp wcel vz cv vw cv cY cxp wcel vz cv c1st cX
      cY cxp cres ccnv vw cv cima wcel vz cv c1st cX cY cxp cres ccnv crn cX cY
      cxp c1st cX cY cxp cres ccnv vw cv cima c1st cX cY cxp cres ccnv crn vz
      cv c1st cX cY cxp cres ccnv vw cv imassrn sseli c1st cX cY cxp cres ccnv
      crn cX cY cxp c1st cdm cin cX cY cxp cvv cin cX cY cxp c1st cX cY cxp
      cres cdm c1st cX cY cxp cres ccnv crn cX cY cxp c1st cdm cin c1st cX cY
      cxp cres dfdm4 c1st cX cY cxp dmres eqtr3i c1st cdm cvv cX cY cxp cvv cvv
      c1st wfo c1st cdm cvv wceq fo1st cvv cvv c1st wfo cvv cvv c1st wf c1st
      cdm cvv wceq cvv cvv c1st fof cvv cvv c1st fdm syl ax-mp ineq2i cX cY cxp
      inv1 3eqtri syl6eleq cR ctop wcel cS ctop wcel wa vw cv cR wcel wa vz cv
      c1st cX cY cxp cres cfv vw cv wcel vz cv cX cY cxp wcel vz cv vw cv cY
      cxp wcel wi vz cv c1st cX cY cxp cres ccnv vw cv cima wcel cR ctop wcel
      cS ctop wcel wa vw cv cR wcel wa vz cv cX cY cxp wcel vz cv c1st cX cY
      cxp cres cfv vw cv wcel vz cv vw cv cY cxp wcel cR ctop wcel cS ctop wcel
      wa vw cv cR wcel wa vz cv cX cY cxp wcel vz cv c1st cX cY cxp cres cfv vw
      cv wcel vz cv c1st cfv vw cv wcel vz cv vw cv cY cxp wcel vz cv cX cY cxp
      wcel vz cv c1st cX cY cxp cres cfv vw cv wcel vz cv c1st cfv vw cv wcel
      wi wi cR ctop wcel cS ctop wcel wa vw cv cR wcel wa vz cv cX cY cxp wcel
      vz cv c1st cX cY cxp cres cfv vw cv wcel vz cv c1st cfv vw cv wcel vz cv
      cX cY cxp wcel vz cv c1st cX cY cxp cres cfv vz cv c1st cfv vw cv vz cv
      cX cY cxp c1st fvres eleq1d biimpd a1i vz cv cX cY cxp wcel vz cv c1st
      cfv vw cv wcel vz cv vw cv cY cxp wcel wi wi cR ctop wcel cS ctop wcel wa
      vw cv cR wcel wa vz cv cX cY cxp wcel vz cv c1st cfv vw cv wcel vz cv vw
      cv cY cxp wcel vz cv cvv cvv cxp wcel vz cv c1st cfv vw cv wcel vz cv
      c2nd cfv cY wcel vz cv vw cv cY cxp wcel vz cv cX cY cxp wcel vz cv c1st
      cfv vw cv wcel wa vz cv cX cY cxp wcel vz cv cvv cvv cxp wcel vz cv c1st
      cfv vw cv wcel cX cY cxp cvv cvv cxp vz cv cX cY xpss sseli adantr vz cv
      cX cY cxp wcel vz cv c1st cfv vw cv wcel pm3.27 vz cv cX cY cxp wcel vz
      cv c2nd cfv cY wcel vz cv c1st cfv vw cv wcel vz cv cX cY xp2nd adantr vz
      cv vw cv cY cxp wcel vz cv cvv cvv cxp wcel vz cv c1st cfv vw cv wcel vz
      cv c2nd cfv cY wcel wa wa vz cv vw cv cY elxp7 biimpri sylan32c ex a1i
      syldd com23 c1st cX cY cxp cres wfun vz cv c1st cX cY cxp cres ccnv vw cv
      cima wcel vz cv c1st cX cY cxp cres cfv vw cv wcel cX cY cxp cX c1st cX
      cY cxp cres wf c1st cX cY cxp cres wfun cX cY f1stres cX cY cxp cX c1st
      cX cY cxp cres ffun ax-mp vz cv vw cv c1st cX cY cxp cres fvimacnvi mpan
      syl5 mpdi ssrdv cR ctop wcel cS ctop wcel wa vw cv cR wcel wa c1st cX cY
      cxp cres vw cv cY cxp cima vw cv wss vw cv cY cxp c1st cX cY cxp cres
      ccnv vw cv cima wss cR ctop wcel cS ctop wcel wa vw cv cR wcel wa c1st cX
      cY cxp cres vw cv cY cxp cima vw cv wss vz cv c1st cX cY cxp cres cfv vw
      cv wcel vz vw cv cY cxp wral cR ctop wcel cS ctop wcel wa vw cv cR wcel
      wa vz cv c1st cX cY cxp cres cfv vw cv wcel vz vw cv cY cxp cR ctop wcel
      cS ctop wcel wa vw cv cR wcel wa vz cv vw cv cY cxp wcel wa vz cv c1st cX
      cY cxp cres cfv vz cv c1st cfv vw cv cR ctop wcel cS ctop wcel wa vw cv
      cR wcel wa vz cv vw cv cY cxp wcel wa vz cv cX cY cxp wcel vz cv c1st cX
      cY cxp cres cfv vz cv c1st cfv wceq cR ctop wcel vw cv cR wcel vz cv vw
      cv cY cxp wcel vz cv cX cY cxp wcel cS ctop wcel cR ctop wcel vw cv cR
      wcel wa vz cv vw cv cY cxp wcel vz cv cX cY cxp wcel cR ctop wcel vw cv
      cR wcel wa vw cv cY cxp cX cY cxp vz cv cR ctop wcel vw cv cR wcel wa vw
      cv cX wss vw cv cY cxp cX cY cxp wss vw cv cR cX tx1cn.2 eltopss vw cv cX
      cY xpss1 syl sseld imp adantllr vz cv cX cY cxp c1st fvres syl vz cv vw
      cv cY cxp wcel vz cv c1st cfv vw cv wcel cR ctop wcel cS ctop wcel wa vw
      cv cR wcel wa vz cv vw cv cY xp1st adantl eqeltrd r19.21aiva c1st cX cY
      cxp cres wfun vw cv cY cxp c1st cX cY cxp cres cdm wss c1st cX cY cxp
      cres vw cv cY cxp cima vw cv wss vz cv c1st cX cY cxp cres cfv vw cv wcel
      vz vw cv cY cxp wral wb cR ctop wcel cS ctop wcel wa vw cv cR wcel wa vz
      vw cv cY cxp vw cv c1st cX cY cxp cres funimass4 cX cY cxp cX c1st cX cY
      cxp cres wf c1st cX cY cxp cres wfun cX cY f1stres cX cY cxp cX c1st cX
      cY cxp cres ffun ax-mp cR ctop wcel cS ctop wcel wa vw cv cR wcel wa vw
      cv cY cxp cX cY cxp c1st cX cY cxp cres cdm cR ctop wcel vw cv cR wcel vw
      cv cY cxp cX cY cxp wss cS ctop wcel cR ctop wcel vw cv cR wcel wa vw cv
      cX wss vw cv cY cxp cX cY cxp wss vw cv cR cX tx1cn.2 eltopss vw cv cX cY
      xpss1 syl adantlr cX cY cxp cX c1st cX cY cxp cres cX cY f1stres fdmi
      syl6ssr sylancr mpbird c1st cX cY cxp cres wfun vw cv cY cxp c1st cX cY
      cxp cres cdm wss c1st cX cY cxp cres vw cv cY cxp cima vw cv wss vw cv cY
      cxp c1st cX cY cxp cres ccnv vw cv cima wss wb cR ctop wcel cS ctop wcel
      wa vw cv cR wcel wa vw cv cY cxp vw cv c1st cX cY cxp cres funimass3 cX
      cY cxp cX c1st cX cY cxp cres wf c1st cX cY cxp cres wfun cX cY f1stres
      cX cY cxp cX c1st cX cY cxp cres ffun ax-mp cR ctop wcel cS ctop wcel wa
      vw cv cR wcel wa vw cv cY cxp cX cY cxp c1st cX cY cxp cres cdm cR ctop
      wcel vw cv cR wcel vw cv cY cxp cX cY cxp wss cS ctop wcel cR ctop wcel
      vw cv cR wcel wa vw cv cX wss vw cv cY cxp cX cY cxp wss vw cv cR cX
      tx1cn.2 eltopss vw cv cX cY xpss1 syl adantlr cX cY cxp cX c1st cX cY cxp
      cres cX cY f1stres fdmi syl6ssr sylancr mpbid eqssd c1st cZ cres ccnv
      c1st cX cY cxp cres ccnv vw cv c1st cZ cres c1st cX cY cxp cres cZ cX cY
      cxp wceq c1st cZ cres c1st cX cY cxp cres wceq tx1cn.4 cZ cX cY cxp c1st
      reseq2 ax-mp cnveqi imaeq1i syl5eq syl3anc cR ctop wcel cS ctop wcel wa
      vw cv cR wcel wa c1st cZ cres ccnv vw cv cima cvv wcel c1st cZ cres ccnv
      vw cv cima vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel
      c1st cZ cres ccnv vw cv cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      wb cR ctop wcel cS ctop wcel wa vw cv cR wcel wa c1st cZ cres cvv wcel
      c1st cZ cres ccnv cvv wcel c1st cZ cres ccnv vw cv cima cvv wcel cR ctop
      wcel cS ctop wcel wa vw cv cR wcel wa c1st cX cY cxp cres cvv c1st cZ
      cres cR ctop wcel cS ctop wcel wa c1st cX cY cxp cres cvv wcel vw cv cR
      wcel cX cY cxp cX c1st cX cY cxp cres wf cX cY cxp cvv wcel c1st cX cY
      cxp cres cvv wcel cR ctop wcel cS ctop wcel wa cX cY cxp cX cvv c1st cX
      cY cxp cres fex cX cY f1stres cX cvv wcel cY cvv wcel cX cY cxp cvv wcel
      cR ctop wcel cS ctop wcel cX cY cvv cvv xpexg cR ctop wcel cR cuni cvv cX
      cR ctop uniexg tx1cn.2 syl5eqel cS ctop wcel cS cuni cvv cY cS ctop
      uniexg tx1cn.3 syl5eqel syl2an sylancr adantr cZ cX cY cxp wceq c1st cZ
      cres c1st cX cY cxp cres wceq tx1cn.4 cZ cX cY cxp c1st reseq2 ax-mp
      syl5eqel c1st cZ cres cvv cnvexg c1st cZ cres ccnv vw cv cvv imaexg 3syl
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex c1st cZ cres ccnv vw cv
      cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz c1st cZ cres ccnv vw
      cv cima cvv vz cv c1st cZ cres ccnv vw cv cima wceq vz cv vu cv vv cv cxp
      wceq c1st cZ cres ccnv vw cv cima vu cv vv cv cxp wceq vu vv cR cS vz cv
      c1st cZ cres ccnv vw cv cima vu cv vv cv cxp eqeq1 2rexbidv elabg syl
      mpbird sseldd r19.21aiva jca cT ctop wcel cR ctop wcel c1st cZ cres cT cR
      ccn co wcel cT cuni cX c1st cZ cres wf c1st cZ cres ccnv vw cv cima cT
      wcel vw cR wral wa wb cR ctop wcel cS ctop wcel wa vw c1st cZ cres cT cR
      cT cuni cX cT cuni eqid tx1cn.2 iscn cR cS cT tx1cn.1 txtop cR ctop wcel
      cS ctop wcel pm3.26 sylanc mpbird $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d R u v w x z $. $d S u v w x z $. $d T u v w x z $.
    $d X u v w x z $. $d Y u v w x z $. $d Z u v w x z $.
    tx2cn.1 $e |- T = ( R tX S ) $.
    tx2cn.2 $e |- X = U. R $.
    tx2cn.3 $e |- Y = U. S $.
    tx2cn.4 $e |- Z = ( X X. Y ) $.
    $( Continuity of the second projection map of a topological product.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  $)
    tx2cn $p |- ( ( R e. Top /\ S e. Top ) -> ( 2nd |` Z ) e. ( T Cn S ) ) $=
      cR ctop wcel cS ctop wcel wa c2nd cZ cres cT cS ccn co wcel cT cuni cY
      c2nd cZ cres wf c2nd cZ cres ccnv vw cv cima cT wcel vw cS wral wa cR
      ctop wcel cS ctop wcel wa cT cuni cY c2nd cZ cres wf c2nd cZ cres ccnv vw
      cv cima cT wcel vw cS wral cR ctop wcel cS ctop wcel wa cT cuni cY c2nd
      cZ cres wf cX cY cxp cY c2nd cX cY cxp cres wf cX cY f2ndres cR ctop wcel
      cS ctop wcel wa cT cuni cY c2nd cZ cres wf cT cuni cY c2nd cX cY cxp cres
      wf cX cY cxp cY c2nd cX cY cxp cres wf cR ctop wcel cS ctop wcel wa cT
      cuni cY c2nd cZ cres c2nd cX cY cxp cres cR ctop wcel cS ctop wcel wa cZ
      cX cY cxp wceq c2nd cZ cres c2nd cX cY cxp cres wceq cZ cX cY cxp wceq cR
      ctop wcel cS ctop wcel wa tx2cn.4 a1i cZ cX cY cxp c2nd reseq2 syl feq1d
      cR ctop wcel cS ctop wcel wa cT cuni cX cY cxp wceq cT cuni cY c2nd cX cY
      cxp cres wf cX cY cxp cY c2nd cX cY cxp cres wf wb cR cS cT cX cY tx2cn.1
      tx2cn.2 tx2cn.3 txuni cT cuni cX cY cxp cY c2nd cX cY cxp cres feq2 syl
      bitrd mpbiri cR ctop wcel cS ctop wcel wa c2nd cZ cres ccnv vw cv cima cT
      wcel vw cS cR ctop wcel cS ctop wcel wa vw cv cS wcel wa vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab cT c2nd cZ cres ccnv vw cv cima
      cR ctop wcel cS ctop wcel wa vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab cT wss vw cv cS wcel cR ctop wcel cS ctop wcel wa vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vz cab ctg cfv cT cR ctop wcel cS ctop wcel wa vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctb wcel vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab ctg cfv wss vz vv vu cR cS txbas vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab bastg syl cR ctop wcel cS ctop wcel
      wa cR cS ctx co vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      ctg cfv cT vz vv vu cR cS txval tx2cn.1 syl5eq sseqtr4d adantr cR ctop
      wcel cS ctop wcel wa vw cv cS wcel wa c2nd cZ cres ccnv vw cv cima vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel c2nd cZ cres ccnv
      vw cv cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex cX cR wcel vw cv cS
      wcel c2nd cZ cres ccnv vw cv cima cX vw cv cxp wceq c2nd cZ cres ccnv vw
      cv cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex cR ctop wcel cS ctop
      wcel wa vw cv cS wcel wa c2nd cZ cres ccnv vw cv cima vu cv vv cv cxp
      wceq c2nd cZ cres ccnv vw cv cima cX vw cv cxp wceq c2nd cZ cres ccnv vw
      cv cima cX vv cv cxp wceq vu vv cX vw cv cR cS vu cv cX wceq vu cv vv cv
      cxp cX vv cv cxp c2nd cZ cres ccnv vw cv cima vu cv cX vv cv xpeq1 eqeq2d
      vv cv vw cv wceq cX vv cv cxp cX vw cv cxp c2nd cZ cres ccnv vw cv cima
      vv cv vw cv cX xpeq2 eqeq2d rcla42ev cR ctop wcel cX cR wcel cS ctop wcel
      vw cv cS wcel cR cX tx2cn.2 topopn ad2antrr cR ctop wcel cS ctop wcel wa
      vw cv cS wcel pm3.27 cR ctop wcel cS ctop wcel wa vw cv cS wcel wa c2nd
      cX cY cxp cres ccnv vw cv cima cX vw cv cxp c2nd cZ cres ccnv vw cv cima
      cR ctop wcel cS ctop wcel wa vw cv cS wcel wa c2nd cX cY cxp cres ccnv vw
      cv cima cX vw cv cxp cR ctop wcel cS ctop wcel wa vw cv cS wcel wa vz
      c2nd cX cY cxp cres ccnv vw cv cima cX vw cv cxp cR ctop wcel cS ctop
      wcel wa vw cv cS wcel wa vz cv c2nd cX cY cxp cres ccnv vw cv cima wcel
      vz cv cX cY cxp wcel vz cv cX vw cv cxp wcel vz cv c2nd cX cY cxp cres
      ccnv vw cv cima wcel vz cv c2nd cX cY cxp cres ccnv crn cX cY cxp c2nd cX
      cY cxp cres ccnv vw cv cima c2nd cX cY cxp cres ccnv crn vz cv c2nd cX cY
      cxp cres ccnv vw cv imassrn sseli c2nd cX cY cxp cres ccnv crn cX cY cxp
      c2nd cdm cin cX cY cxp cvv cin cX cY cxp c2nd cX cY cxp cres cdm c2nd cX
      cY cxp cres ccnv crn cX cY cxp c2nd cdm cin c2nd cX cY cxp cres dfdm4
      c2nd cX cY cxp dmres eqtr3i c2nd cdm cvv cX cY cxp cvv cvv c2nd wfo c2nd
      cdm cvv wceq fo2nd cvv cvv c2nd wfo cvv cvv c2nd wf c2nd cdm cvv wceq cvv
      cvv c2nd fof cvv cvv c2nd fdm syl ax-mp ineq2i cX cY cxp inv1 3eqtri
      syl6eleq cR ctop wcel cS ctop wcel wa vw cv cS wcel wa vz cv c2nd cX cY
      cxp cres cfv vw cv wcel vz cv cX cY cxp wcel vz cv cX vw cv cxp wcel wi
      vz cv c2nd cX cY cxp cres ccnv vw cv cima wcel cR ctop wcel cS ctop wcel
      wa vw cv cS wcel wa vz cv cX cY cxp wcel vz cv c2nd cX cY cxp cres cfv vw
      cv wcel vz cv cX vw cv cxp wcel cR ctop wcel cS ctop wcel wa vw cv cS
      wcel wa vz cv cX cY cxp wcel vz cv c2nd cX cY cxp cres cfv vw cv wcel vz
      cv c2nd cfv vw cv wcel vz cv cX vw cv cxp wcel vz cv cX cY cxp wcel vz cv
      c2nd cX cY cxp cres cfv vw cv wcel vz cv c2nd cfv vw cv wcel wi wi cR
      ctop wcel cS ctop wcel wa vw cv cS wcel wa vz cv cX cY cxp wcel vz cv
      c2nd cX cY cxp cres cfv vw cv wcel vz cv c2nd cfv vw cv wcel vz cv cX cY
      cxp wcel vz cv c2nd cX cY cxp cres cfv vz cv c2nd cfv vw cv vz cv cX cY
      cxp c2nd fvres eleq1d biimpd a1i vz cv cX cY cxp wcel vz cv c2nd cfv vw
      cv wcel vz cv cX vw cv cxp wcel wi wi cR ctop wcel cS ctop wcel wa vw cv
      cS wcel wa vz cv cX cY cxp wcel vz cv c2nd cfv vw cv wcel vz cv cX vw cv
      cxp wcel vz cv cvv cvv cxp wcel vz cv c1st cfv cX wcel vz cv c2nd cfv vw
      cv wcel vz cv cX vw cv cxp wcel vz cv cX cY cxp wcel vz cv c2nd cfv vw cv
      wcel wa vz cv cX cY cxp wcel vz cv cvv cvv cxp wcel vz cv c2nd cfv vw cv
      wcel cX cY cxp cvv cvv cxp vz cv cX cY xpss sseli adantr vz cv cX cY cxp
      wcel vz cv c1st cfv cX wcel vz cv c2nd cfv vw cv wcel vz cv cX cY xp1st
      adantr vz cv cX cY cxp wcel vz cv c2nd cfv vw cv wcel pm3.27 vz cv cX vw
      cv cxp wcel vz cv cvv cvv cxp wcel vz cv c1st cfv cX wcel vz cv c2nd cfv
      vw cv wcel wa wa vz cv cX vw cv elxp7 biimpri sylan32c ex a1i syldd com23
      c2nd cX cY cxp cres wfun vz cv c2nd cX cY cxp cres ccnv vw cv cima wcel
      vz cv c2nd cX cY cxp cres cfv vw cv wcel cX cY cxp cY c2nd cX cY cxp cres
      wf c2nd cX cY cxp cres wfun cX cY f2ndres cX cY cxp cY c2nd cX cY cxp
      cres ffun ax-mp vz cv vw cv c2nd cX cY cxp cres fvimacnvi mpan syl5 mpdi
      ssrdv cR ctop wcel cS ctop wcel wa vw cv cS wcel wa c2nd cX cY cxp cres
      cX vw cv cxp cima vw cv wss cX vw cv cxp c2nd cX cY cxp cres ccnv vw cv
      cima wss cR ctop wcel cS ctop wcel wa vw cv cS wcel wa c2nd cX cY cxp
      cres cX vw cv cxp cima vw cv wss vz cv c2nd cX cY cxp cres cfv vw cv wcel
      vz cX vw cv cxp wral cR ctop wcel cS ctop wcel wa vw cv cS wcel wa vz cv
      c2nd cX cY cxp cres cfv vw cv wcel vz cX vw cv cxp cR ctop wcel cS ctop
      wcel wa vw cv cS wcel wa vz cv cX vw cv cxp wcel wa vz cv c2nd cX cY cxp
      cres cfv vz cv c2nd cfv vw cv cR ctop wcel cS ctop wcel wa vw cv cS wcel
      wa vz cv cX vw cv cxp wcel wa vz cv cX cY cxp wcel vz cv c2nd cX cY cxp
      cres cfv vz cv c2nd cfv wceq cS ctop wcel vw cv cS wcel vz cv cX vw cv
      cxp wcel vz cv cX cY cxp wcel cR ctop wcel cS ctop wcel vw cv cS wcel wa
      vz cv cX vw cv cxp wcel vz cv cX cY cxp wcel cS ctop wcel vw cv cS wcel
      wa cX vw cv cxp cX cY cxp vz cv cS ctop wcel vw cv cS wcel wa vw cv cY
      wss cX vw cv cxp cX cY cxp wss vw cv cS cY tx2cn.3 eltopss vw cv cY cX
      xpss2 syl sseld imp adantlll vz cv cX cY cxp c2nd fvres syl vz cv cX vw
      cv cxp wcel vz cv c2nd cfv vw cv wcel cR ctop wcel cS ctop wcel wa vw cv
      cS wcel wa vz cv cX vw cv xp2nd adantl eqeltrd r19.21aiva c2nd cX cY cxp
      cres wfun cX vw cv cxp c2nd cX cY cxp cres cdm wss c2nd cX cY cxp cres cX
      vw cv cxp cima vw cv wss vz cv c2nd cX cY cxp cres cfv vw cv wcel vz cX
      vw cv cxp wral wb cR ctop wcel cS ctop wcel wa vw cv cS wcel wa vz cX vw
      cv cxp vw cv c2nd cX cY cxp cres funimass4 cX cY cxp cY c2nd cX cY cxp
      cres wf c2nd cX cY cxp cres wfun cX cY f2ndres cX cY cxp cY c2nd cX cY
      cxp cres ffun ax-mp cR ctop wcel cS ctop wcel wa vw cv cS wcel wa cX vw
      cv cxp cX cY cxp c2nd cX cY cxp cres cdm cS ctop wcel vw cv cS wcel cX vw
      cv cxp cX cY cxp wss cR ctop wcel cS ctop wcel vw cv cS wcel wa vw cv cY
      wss cX vw cv cxp cX cY cxp wss vw cv cS cY tx2cn.3 eltopss vw cv cY cX
      xpss2 syl adantll cX cY cxp cY c2nd cX cY cxp cres cX cY f2ndres fdmi
      syl6ssr sylancr mpbird c2nd cX cY cxp cres wfun cX vw cv cxp c2nd cX cY
      cxp cres cdm wss c2nd cX cY cxp cres cX vw cv cxp cima vw cv wss cX vw cv
      cxp c2nd cX cY cxp cres ccnv vw cv cima wss wb cR ctop wcel cS ctop wcel
      wa vw cv cS wcel wa cX vw cv cxp vw cv c2nd cX cY cxp cres funimass3 cX
      cY cxp cY c2nd cX cY cxp cres wf c2nd cX cY cxp cres wfun cX cY f2ndres
      cX cY cxp cY c2nd cX cY cxp cres ffun ax-mp cR ctop wcel cS ctop wcel wa
      vw cv cS wcel wa cX vw cv cxp cX cY cxp c2nd cX cY cxp cres cdm cS ctop
      wcel vw cv cS wcel cX vw cv cxp cX cY cxp wss cR ctop wcel cS ctop wcel
      vw cv cS wcel wa vw cv cY wss cX vw cv cxp cX cY cxp wss vw cv cS cY
      tx2cn.3 eltopss vw cv cY cX xpss2 syl adantll cX cY cxp cY c2nd cX cY cxp
      cres cX cY f2ndres fdmi syl6ssr sylancr mpbid eqssd c2nd cZ cres ccnv
      c2nd cX cY cxp cres ccnv vw cv c2nd cZ cres c2nd cX cY cxp cres cZ cX cY
      cxp wceq c2nd cZ cres c2nd cX cY cxp cres wceq tx2cn.4 cZ cX cY cxp c2nd
      reseq2 ax-mp cnveqi imaeq1i syl5eq syl3anc cR ctop wcel cS ctop wcel wa
      vw cv cS wcel wa c2nd cZ cres ccnv vw cv cima cvv wcel c2nd cZ cres ccnv
      vw cv cima vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel
      c2nd cZ cres ccnv vw cv cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      wb cR ctop wcel cS ctop wcel wa vw cv cS wcel wa c2nd cZ cres cvv wcel
      c2nd cZ cres ccnv cvv wcel c2nd cZ cres ccnv vw cv cima cvv wcel cR ctop
      wcel cS ctop wcel wa vw cv cS wcel wa c2nd cX cY cxp cres cvv c2nd cZ
      cres cR ctop wcel cS ctop wcel wa c2nd cX cY cxp cres cvv wcel vw cv cS
      wcel cX cY cxp cY c2nd cX cY cxp cres wf cX cY cxp cvv wcel c2nd cX cY
      cxp cres cvv wcel cR ctop wcel cS ctop wcel wa cX cY cxp cY cvv c2nd cX
      cY cxp cres fex cX cY f2ndres cX cvv wcel cY cvv wcel cX cY cxp cvv wcel
      cR ctop wcel cS ctop wcel cX cY cvv cvv xpexg cR ctop wcel cR cuni cvv cX
      cR ctop uniexg tx2cn.2 syl5eqel cS ctop wcel cS cuni cvv cY cS ctop
      uniexg tx2cn.3 syl5eqel syl2an sylancr adantr cZ cX cY cxp wceq c2nd cZ
      cres c2nd cX cY cxp cres wceq tx2cn.4 cZ cX cY cxp c2nd reseq2 ax-mp
      syl5eqel c2nd cZ cres cvv cnvexg c2nd cZ cres ccnv vw cv cvv imaexg 3syl
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex c2nd cZ cres ccnv vw cv
      cima vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz c2nd cZ cres ccnv vw
      cv cima cvv vz cv c2nd cZ cres ccnv vw cv cima wceq vz cv vu cv vv cv cxp
      wceq c2nd cZ cres ccnv vw cv cima vu cv vv cv cxp wceq vu vv cR cS vz cv
      c2nd cZ cres ccnv vw cv cima vu cv vv cv cxp eqeq1 2rexbidv elabg syl
      mpbird sseldd r19.21aiva jca cR ctop wcel cS ctop wcel cT ctop wcel c2nd
      cZ cres cT cS ccn co wcel cT cuni cY c2nd cZ cres wf c2nd cZ cres ccnv vw
      cv cima cT wcel vw cS wral wa wb cR cS cT tx2cn.1 txtop vw c2nd cZ cres
      cT cS cT cuni cY cT cuni eqid tx2cn.3 iscn sylancom mpbird $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d A h x y z $. $d B h x y z $. $d C h x y z $. $d D h x y z $.
    $d F h x y z $. $d G h x y z $. $d P h x y z $. $d Q h x y z $.
    upxp.1 $e |- P = ( 1st |` ( B X. C ) ) $.
    upxp.2 $e |- Q = ( 2nd |` ( B X. C ) ) $.
    $( Universal property of the Cartesian product considered as a categorical
       product in the category of sets.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    upxp $p |- ( ( A e. D /\ F : A --> B /\ G : A --> C ) ->
        E! h ( h : A --> ( B X. C ) /\ F = ( P o. h ) /\ G = ( Q o. h ) ) ) $=
      cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv
      ccom wceq cG cQ vh cv ccom wceq w3a vh weu vh cv vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wceq vh weu cA cD wcel cA
      cB cF wf vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab wceq vh weu cA cC cG wf cA cD wcel vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab cvv wcel vh cv vx cv cA wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wceq vh weu vx vy
      cA vx cv cF cfv vx cv cG cfv cop cD opabex2g vh vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab eueq sylib 3ad2ant1 cA cD
      wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom
      wceq cG cQ vh cv ccom wceq w3a vh cv vx cv cA wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab wceq vh cA cD wcel cA cB cF wf cA cC cG
      wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq
      w3a vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wceq cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf
      cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh cv vx cv cA wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wceq cA cD wcel cA cB
      cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ
      vh cv ccom wceq w3a wa vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab wceq cA cA wceq vz cv vh cv cfv vz cv vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv wceq
      vz cA wral wa cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv
      wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa cA cA wceq vz cv vh
      cv cfv vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab cfv wceq vz cA wral cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB
      cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa cA
      eqidd cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP
      vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vz cv vh cv cfv vz cv vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv wceq
      vz cA cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP
      vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vz cv cA wcel wa vz cv vh cv
      cfv vz cv cF cfv vz cv cG cfv cop vz cv vx cv cA wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab cfv vz cv vh cv cfv cvv cvv cxp wcel
      vz cv vh cv cfv c1st cfv vz cv cF cfv wceq vz cv vh cv cfv c2nd cfv vz cv
      cG cfv wceq vz cv vh cv cfv vz cv cF cfv vz cv cG cfv cop wceq cA cD wcel
      cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom wceq
      cG cQ vh cv ccom wceq w3a wa vz cv cA wcel wa cA cB cC cxp vh cv wf cF cP
      vh cv ccom wceq cG cQ vh cv ccom wceq w3a vz cv cA wcel vz cv vh cv cfv
      cvv cvv cxp wcel cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh
      cv wf cF cP vh cv ccom wceq vz cv cA wcel vz cv vh cv cfv cvv cvv cxp
      wcel cG cQ vh cv ccom wceq cA cB cC cxp vh cv wf vz cv cA wcel wa vz cv
      vh cv cfv cB cC cxp wcel vz cv vh cv cfv cvv cvv cxp wcel cA cB cC cxp vz
      cv vh cv ffvelrn cB cC cxp cvv cvv cxp vz cv vh cv cfv cB cC xpss sseli
      syl 3ad2antl1 adantll cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp
      vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vz cv cA wcel
      wa vz cv cF cfv vz cv c1st cB cC cxp cres vh cv ccom cfv vz cv vh cv cfv
      c1st cB cC cxp cres cfv vz cv vh cv cfv c1st cfv cA cB cC cxp vh cv wf cF
      cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vz cv cF cfv vz cv c1st cB
      cC cxp cres vh cv ccom cfv wceq cA cD wcel cA cB cF wf cA cC cG wf w3a vz
      cv cA wcel cF cP vh cv ccom wceq cA cB cC cxp vh cv wf vz cv cF cfv vz cv
      c1st cB cC cxp cres vh cv ccom cfv wceq cG cQ vh cv ccom wceq cF cP vh cv
      ccom wceq vz cv cF cfv vz cv cP vh cv ccom cfv vz cv c1st cB cC cxp cres
      vh cv ccom cfv vz cv cF cP vh cv ccom fveq1 vz cv cP vh cv ccom c1st cB
      cC cxp cres vh cv ccom cP c1st cB cC cxp cres vh cv upxp.1 coeq1i fveq1i
      syl6eq 3ad2ant2 ad2antlr c1st cB cC cxp cres wfun vh cv wfun vz cv vh cv
      cdm wcel vz cv c1st cB cC cxp cres vh cv ccom cfv vz cv vh cv cfv c1st cB
      cC cxp cres cfv wceq cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp
      vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vz cv cA wcel
      wa vz cv c1st cB cC cxp cres vh cv fvco c1st cB cC cxp cres wfun cA cD
      wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom
      wceq cG cQ vh cv ccom wceq w3a wa vz cv cA wcel wa c1st cB cC cxp cres cB
      cC cxp wfn c1st cB cC cxp cres wfun c1st cvv wfn cB cC cxp cvv wss c1st
      cB cC cxp cres cB cC cxp wfn cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv
      c1st fofn ax-mp cB cC cxp ssv cvv cB cC cxp c1st fnssres mp2an cB cC cxp
      c1st cB cC cxp cres fnfun ax-mp a1i cA cB cC cxp vh cv wf cF cP vh cv
      ccom wceq cG cQ vh cv ccom wceq w3a vh cv wfun cA cD wcel cA cB cF wf cA
      cC cG wf w3a vz cv cA wcel cA cB cC cxp vh cv wf cF cP vh cv ccom wceq vh
      cv wfun cG cQ vh cv ccom wceq cA cB cC cxp vh cv ffun 3ad2ant1 ad2antlr
      cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vz
      cv cA wcel vz cv vh cv cdm wcel cA cD wcel cA cB cF wf cA cC cG wf w3a cA
      cB cC cxp vh cv wf cF cP vh cv ccom wceq vz cv cA wcel vz cv vh cv cdm
      wcel cG cQ vh cv ccom wceq cA cB cC cxp vh cv wf vz cv vh cv cdm wcel vz
      cv cA wcel cA cB cC cxp vh cv wf vh cv cdm cA vz cv cA cB cC cxp vh cv
      fdm eleq2d biimpar 3ad2antl1 adantll syl3anc cA cD wcel cA cB cF wf cA cC
      cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom
      wceq w3a wa vz cv cA wcel wa vz cv vh cv cfv cB cC cxp wcel vz cv vh cv
      cfv c1st cB cC cxp cres cfv vz cv vh cv cfv c1st cfv wceq cA cB cC cxp vh
      cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vz cv cA wcel vz cv
      vh cv cfv cB cC cxp wcel cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC
      cxp vh cv wf cF cP vh cv ccom wceq vz cv cA wcel vz cv vh cv cfv cB cC
      cxp wcel cG cQ vh cv ccom wceq cA cB cC cxp vz cv vh cv ffvelrn 3ad2antl1
      adantll vz cv vh cv cfv cB cC cxp c1st fvres syl 3eqtrrd cA cD wcel cA cB
      cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ
      vh cv ccom wceq w3a wa vz cv cA wcel wa vz cv cG cfv vz cv c2nd cB cC cxp
      cres vh cv ccom cfv vz cv vh cv cfv c2nd cB cC cxp cres cfv vz cv vh cv
      cfv c2nd cfv cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom
      wceq w3a vz cv cG cfv vz cv c2nd cB cC cxp cres vh cv ccom cfv wceq cA cD
      wcel cA cB cF wf cA cC cG wf w3a vz cv cA wcel cG cQ vh cv ccom wceq cA
      cB cC cxp vh cv wf vz cv cG cfv vz cv c2nd cB cC cxp cres vh cv ccom cfv
      wceq cF cP vh cv ccom wceq cG cQ vh cv ccom wceq vz cv cG cfv vz cv cQ vh
      cv ccom cfv vz cv c2nd cB cC cxp cres vh cv ccom cfv vz cv cG cQ vh cv
      ccom fveq1 vz cv cQ vh cv ccom c2nd cB cC cxp cres vh cv ccom cQ c2nd cB
      cC cxp cres vh cv upxp.2 coeq1i fveq1i syl6eq 3ad2ant3 ad2antlr c2nd cB
      cC cxp cres wfun vh cv wfun vz cv vh cv cdm wcel vz cv c2nd cB cC cxp
      cres vh cv ccom cfv vz cv vh cv cfv c2nd cB cC cxp cres cfv wceq cA cD
      wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom
      wceq cG cQ vh cv ccom wceq w3a wa vz cv cA wcel wa vz cv c2nd cB cC cxp
      cres vh cv fvco c2nd cB cC cxp cres wfun cA cD wcel cA cB cF wf cA cC cG
      wf w3a cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq
      w3a wa vz cv cA wcel wa c2nd cB cC cxp cres cB cC cxp wfn c2nd cB cC cxp
      cres wfun c2nd cvv wfn cB cC cxp cvv wss c2nd cB cC cxp cres cB cC cxp
      wfn cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cB cC cxp
      ssv cvv cB cC cxp c2nd fnssres mp2an cB cC cxp c2nd cB cC cxp cres fnfun
      ax-mp a1i cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom
      wceq w3a vh cv wfun cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA wcel
      cA cB cC cxp vh cv wf cF cP vh cv ccom wceq vh cv wfun cG cQ vh cv ccom
      wceq cA cB cC cxp vh cv ffun 3ad2ant1 ad2antlr cA cB cC cxp vh cv wf cF
      cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vz cv cA wcel vz cv vh cv
      cdm wcel cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF
      cP vh cv ccom wceq vz cv cA wcel vz cv vh cv cdm wcel cG cQ vh cv ccom
      wceq cA cB cC cxp vh cv wf vz cv vh cv cdm wcel vz cv cA wcel cA cB cC
      cxp vh cv wf vh cv cdm cA vz cv cA cB cC cxp vh cv fdm eleq2d biimpar
      3ad2antl1 adantll syl3anc cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC
      cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vz cv cA
      wcel wa vz cv vh cv cfv cB cC cxp wcel vz cv vh cv cfv c2nd cB cC cxp
      cres cfv vz cv vh cv cfv c2nd cfv wceq cA cB cC cxp vh cv wf cF cP vh cv
      ccom wceq cG cQ vh cv ccom wceq w3a vz cv cA wcel vz cv vh cv cfv cB cC
      cxp wcel cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF
      cP vh cv ccom wceq vz cv cA wcel vz cv vh cv cfv cB cC cxp wcel cG cQ vh
      cv ccom wceq cA cB cC cxp vz cv vh cv ffvelrn 3ad2antl1 adantll vz cv vh
      cv cfv cB cC cxp c2nd fvres syl 3eqtrrd vz cv vh cv cfv vz cv cF cfv vz
      cv cG cfv eqopi sylan32c vz cv cA wcel vz cv vx cv cA wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab cfv vz cv cF cfv vz cv cG cfv
      cop wceq cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vh cv wf cF
      cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vx vy vz cv vx cv cF cfv
      vx cv cG cfv cop vz cv cF cfv vz cv cG cfv cop cA vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv vz cv wceq vx cv cF
      cfv vz cv cF cfv vx cv cG cfv vz cv cG cfv vx cv vz cv cF fveq2 vx cv vz
      cv cG fveq2 opeq12d vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab eqid vz cv cF cfv vz cv cG cfv opex fvopab4 adantl
      eqtr4d r19.21aiva jca vh cv cA wfn vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cA wfn vh cv vx cv cA wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab wceq cA cA wceq vz cv vh cv cfv
      vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab cfv wceq vz cA wral wa wb cA cD wcel cA cB cF wf cA cC cG wf w3a cA
      cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wa vz
      cA cA vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab eqfnfv cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv
      ccom wceq w3a vh cv cA wfn cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB
      cC cxp vh cv wf cF cP vh cv ccom wceq vh cv cA wfn cG cQ vh cv ccom wceq
      cA cB cC cxp vh cv ffn 3ad2ant1 adantl cA cD wcel cA cB cF wf cA cC cG wf
      w3a vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      cA wfn cA cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq
      w3a cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vx cv cA wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf vx cv cA wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cA wfn cA cD wcel cA
      cB cF wf cA cC cG wf w3a vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx
      cA wral cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab wf cA cB cF wf cA cC cG wf vx cv cF cfv vx cv cG cfv
      cop cB cC cxp wcel vx cA wral cA cD wcel cA cB cF wf cA cC cG wf wa vx cv
      cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA cA cB cF wf cA cC cG wf vx
      cv cA wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cv cF cfv cB
      wcel vx cv cG cfv cC wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel cA
      cB cF wf vx cv cA wcel wa cA cC cG wf vx cv cA wcel wa vx cv cF cfv vx cv
      cG cfv cB cC opelxpi cA cB vx cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an
      anandirs r19.21aiva 3adant1 vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv
      cop vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      eqid fopab2 sylib cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab ffn syl adantr sylanc mpbird ex vh cv vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wceq cA
      cB cC cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a cA cB
      cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf cF cP vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ccom wceq cG cQ vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom wceq w3a cA cD wcel cA cB cF wf cA cC cG wf
      w3a vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wceq cA cB cC cxp vh cv wf cA cB cC cxp vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab wf cF cP vh cv ccom wceq cF
      cP vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccom wceq cG cQ vh cv ccom wceq cG cQ vx cv cA wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab ccom wceq cA cB cC cxp vh cv vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab feq1 vh cv
      vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      wceq cP vh cv ccom cP vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom cF vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cP coeq2 eqeq2d vh cv vx cv cA wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wceq cQ vh cv ccom cQ
      vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccom cG vh cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cQ coeq2 eqeq2d 3anbi123d cA cD wcel cA cB cF wf cA cC cG wf
      w3a cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab wf cF cP vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom wceq cG cQ vx cv cA wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab ccom wceq cA cD wcel cA cB cF wf cA cC
      cG wf w3a vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cB
      cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf cA cB cF wf cA cC cG wf vx cv cF cfv vx cv cG cfv cop cB cC cxp
      wcel vx cA wral cA cD wcel cA cB cF wf cA cC cG wf wa vx cv cF cfv vx cv
      cG cfv cop cB cC cxp wcel vx cA cA cB cF wf cA cC cG wf vx cv cA wcel vx
      cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cv cF cfv cB wcel vx cv cG
      cfv cC wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel cA cB cF wf vx
      cv cA wcel wa cA cC cG wf vx cv cA wcel wa vx cv cF cfv vx cv cG cfv cB
      cC opelxpi cA cB vx cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an anandirs
      r19.21aiva 3adant1 vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv cop vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2
      sylib cA cD wcel cA cB cF wf cA cC cG wf w3a cF c1st cB cC cxp cres vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cP
      vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccom cA cD wcel cA cB cF wf cA cC cG wf w3a cF c1st cB cC cxp cres vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq
      cA cA wceq vz cv cF cfv vz cv c1st cB cC cxp cres vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cA wral
      wa cA cD wcel cA cB cF wf cA cC cG wf w3a cA cA wceq vz cv cF cfv vz cv
      c1st cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom cfv wceq vz cA wral cA cD wcel cA cB cF wf cA cC
      cG wf w3a cA eqidd cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cF cfv vz
      cv c1st cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom cfv wceq vz cA cA cD wcel cA cB cF wf cA cC cG
      wf w3a vz cv cA wcel wa vz cv c1st cB cC cxp cres vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv vz cv vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv c1st cB
      cC cxp cres cfv vz cv cF cfv c1st cB cC cxp cres wfun vx cv cA wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wfun vz cv vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm wcel vz
      cv c1st cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom cfv vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cfv c1st cB cC cxp cres cfv wceq cA cD
      wcel cA cB cF wf cA cC cG wf w3a vz cv cA wcel wa vz cv c1st cB cC cxp
      cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab fvco c1st cB cC cxp cres wfun cA cD wcel cA cB cF wf cA cC cG wf
      w3a vz cv cA wcel wa c1st cB cC cxp cres cB cC cxp wfn c1st cB cC cxp
      cres wfun c1st cvv wfn cB cC cxp cvv wss c1st cB cC cxp cres cB cC cxp
      wfn cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp cB cC cxp
      ssv cvv cB cC cxp c1st fnssres mp2an cB cC cxp c1st cB cC cxp cres fnfun
      ax-mp a1i cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA wcel wa cA cB
      cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wfun cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC cxp vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf vz cv cA
      wcel cA cD wcel cA cB cF wf cA cC cG wf w3a vx cv cF cfv vx cv cG cfv cop
      cB cC cxp wcel vx cA wral cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab wf cA cB cF wf cA cC cG wf vx cv cF
      cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cD wcel cA cB cF wf cA
      cC cG wf wa vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA cA cB cF
      wf cA cC cG wf vx cv cA wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel
      vx cv cF cfv cB wcel vx cv cG cfv cC wcel vx cv cF cfv vx cv cG cfv cop
      cB cC cxp wcel cA cB cF wf vx cv cA wcel wa cA cC cG wf vx cv cA wcel wa
      vx cv cF cfv vx cv cG cfv cB cC opelxpi cA cB vx cv cF ffvelrn cA cC vx
      cv cG ffvelrn syl2an anandirs r19.21aiva 3adant1 vx vy cA cB cC cxp vx cv
      cF cfv vx cv cG cfv cop vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab eqid fopab2 sylib adantr cA cB cC cxp vx cv cA wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ffun syl cA cD
      wcel cA cB cF wf cA cC cG wf w3a vz cv vx cv cA wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab cdm wcel vz cv cA wcel cA cD wcel cA
      cB cF wf cA cC cG wf w3a vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab cdm cA vz cv cA cD wcel cA cB cF wf cA cC cG wf
      w3a cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab wf vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab cdm cA wceq cA cD wcel cA cB cF wf cA cC cG wf w3a vx cv
      cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cB cC cxp vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf cA cB cF
      wf cA cC cG wf vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA
      cD wcel cA cB cF wf cA cC cG wf wa vx cv cF cfv vx cv cG cfv cop cB cC
      cxp wcel vx cA cA cB cF wf cA cC cG wf vx cv cA wcel vx cv cF cfv vx cv
      cG cfv cop cB cC cxp wcel vx cv cF cfv cB wcel vx cv cG cfv cC wcel vx cv
      cF cfv vx cv cG cfv cop cB cC cxp wcel cA cB cF wf vx cv cA wcel wa cA cC
      cG wf vx cv cA wcel wa vx cv cF cfv vx cv cG cfv cB cC opelxpi cA cB vx
      cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an anandirs r19.21aiva 3adant1
      vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv cop vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2 sylib cA cB cC
      cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      fdm syl eleq2d biimpar syl3anc cA cD wcel cA cB cF wf cA cC cG wf w3a vz
      cv cA wcel wa vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab cfv c1st cB cC cxp cres cfv vz cv cF cfv vz cv cG cfv
      cop c1st cB cC cxp cres cfv vz cv cF cfv vz cv cG cfv cop c1st cfv vz cv
      cF cfv cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA wcel wa vz cv vx
      cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv vz
      cv cF cfv vz cv cG cfv cop c1st cB cC cxp cres vz cv cA wcel vz cv vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv vz cv
      cF cfv vz cv cG cfv cop wceq cA cD wcel cA cB cF wf cA cC cG wf w3a vx vy
      vz cv vx cv cF cfv vx cv cG cfv cop vz cv cF cfv vz cv cG cfv cop cA vx
      cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv
      vz cv wceq vx cv cF cfv vz cv cF cfv vx cv cG cfv vz cv cG cfv vx cv vz
      cv cF fveq2 vx cv vz cv cG fveq2 opeq12d vx cv cA wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab eqid vz cv cF cfv vz cv cG cfv opex
      fvopab4 adantl fveq2d cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA
      wcel wa vz cv cF cfv vz cv cG cfv cop cB cC cxp wcel vz cv cF cfv vz cv
      cG cfv cop c1st cB cC cxp cres cfv vz cv cF cfv vz cv cG cfv cop c1st cfv
      wceq cA cB cF wf cA cC cG wf vz cv cA wcel vz cv cF cfv vz cv cG cfv cop
      cB cC cxp wcel cA cD wcel cA cB cF wf cA cC cG wf vz cv cA wcel vz cv cF
      cfv vz cv cG cfv cop cB cC cxp wcel vz cv cF cfv cB wcel vz cv cG cfv cC
      wcel vz cv cF cfv vz cv cG cfv cop cB cC cxp wcel cA cB cF wf vz cv cA
      wcel wa cA cC cG wf vz cv cA wcel wa vz cv cF cfv vz cv cG cfv cB cC
      opelxpi cA cB vz cv cF ffvelrn cA cC vz cv cG ffvelrn syl2an anandirs
      3adantl1 vz cv cF cfv vz cv cG cfv cop cB cC cxp c1st fvres syl vz cv cF
      cfv vz cv cG cfv cop c1st cfv vz cv cF cfv wceq cA cD wcel cA cB cF wf cA
      cC cG wf w3a vz cv cA wcel wa vz cv cF cfv vz cv cG cfv vz cv cF fvex
      op1st a1i 3eqtrd eqtr2d r19.21aiva jca cF cA wfn c1st cB cC cxp cres vx
      cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom
      cA wfn cF c1st cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab ccom wceq cA cA wceq vz cv cF cfv vz cv c1st
      cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ccom cfv wceq vz cA wral wa wb cA cD wcel cA cB cF wf cA cC
      cG wf w3a vz cA cA cF c1st cB cC cxp cres vx cv cA wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab ccom eqfnfv cA cB cF wf cA cD
      wcel cF cA wfn cA cC cG wf cA cB cF ffn 3ad2ant2 c1st cB cC cxp cres cB
      cC cxp wfn vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab cA wfn vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab crn cB cC cxp wss c1st cB cC cxp cres vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cA wfn cA cD wcel cA
      cB cF wf cA cC cG wf w3a cB cC cxp cA c1st cB cC cxp cres vx cv cA wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab fnco c1st cB cC
      cxp cres cB cC cxp wfn cA cD wcel cA cB cF wf cA cC cG wf w3a c1st cvv
      wfn cB cC cxp cvv wss c1st cB cC cxp cres cB cC cxp wfn cvv cvv c1st wfo
      c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp cB cC cxp ssv cvv cB cC cxp
      c1st fnssres mp2an a1i cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB cC
      cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      wf vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      cA wfn cA cD wcel cA cB cF wf cA cC cG wf w3a vx cv cF cfv vx cv cG cfv
      cop cB cC cxp wcel vx cA wral cA cB cC cxp vx cv cA wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab wf cA cB cF wf cA cC cG wf vx cv
      cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cD wcel cA cB cF wf
      cA cC cG wf wa vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA cA cB
      cF wf cA cC cG wf vx cv cA wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp
      wcel vx cv cF cfv cB wcel vx cv cG cfv cC wcel vx cv cF cfv vx cv cG cfv
      cop cB cC cxp wcel cA cB cF wf vx cv cA wcel wa cA cC cG wf vx cv cA wcel
      wa vx cv cF cfv vx cv cG cfv cB cC opelxpi cA cB vx cv cF ffvelrn cA cC
      vx cv cG ffvelrn syl2an anandirs r19.21aiva 3adant1 vx vy cA cB cC cxp vx
      cv cF cfv vx cv cG cfv cop vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab eqid fopab2 sylib cA cB cC cxp vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ffn syl cA cD wcel cA cB
      cF wf cA cC cG wf w3a cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wf vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab crn cB cC cxp wss cA cD wcel cA cB cF wf
      cA cC cG wf w3a vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral
      cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab wf cA cB cF wf cA cC cG wf vx cv cF cfv vx cv cG cfv cop cB cC
      cxp wcel vx cA wral cA cD wcel cA cB cF wf cA cC cG wf wa vx cv cF cfv vx
      cv cG cfv cop cB cC cxp wcel vx cA cA cB cF wf cA cC cG wf vx cv cA wcel
      vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cv cF cfv cB wcel vx cv
      cG cfv cC wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel cA cB cF wf
      vx cv cA wcel wa cA cC cG wf vx cv cA wcel wa vx cv cF cfv vx cv cG cfv
      cB cC opelxpi cA cB vx cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an
      anandirs r19.21aiva 3adant1 vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv
      cop vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      eqid fopab2 sylib cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab frn syl syl3anc sylanc mpbird cP c1st cB cC
      cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab upxp.1 coeq1i syl6eqr cA cD wcel cA cB cF wf cA cC cG wf w3a cG
      c2nd cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom cQ vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom cA cD wcel cA cB cF wf cA cC cG wf w3a cG
      c2nd cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom wceq cA cA wceq vz cv cG cfv vz cv c2nd cB cC
      cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccom cfv wceq vz cA wral wa cA cD wcel cA cB cF wf cA cC cG wf w3a
      cA cA wceq vz cv cG cfv vz cv c2nd cB cC cxp cres vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cA wral
      cA cD wcel cA cB cF wf cA cC cG wf w3a cA eqidd cA cD wcel cA cB cF wf cA
      cC cG wf w3a vz cv cG cfv vz cv c2nd cB cC cxp cres vx cv cA wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cA cA
      cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA wcel wa vz cv c2nd cB cC cxp
      cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccom cfv vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab cfv c2nd cB cC cxp cres cfv vz cv cG cfv c2nd cB cC
      cxp cres wfun vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab wfun vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab cdm wcel vz cv c2nd cB cC cxp cres vx cv cA wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv vz cv vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv c2nd
      cB cC cxp cres cfv wceq cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA
      wcel wa vz cv c2nd cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab fvco c2nd cB cC cxp cres wfun cA cD wcel
      cA cB cF wf cA cC cG wf w3a vz cv cA wcel wa c2nd cB cC cxp cres cB cC
      cxp wfn c2nd cB cC cxp cres wfun c2nd cvv wfn cB cC cxp cvv wss c2nd cB
      cC cxp cres cB cC cxp wfn cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv
      c2nd fofn ax-mp cB cC cxp ssv cvv cB cC cxp c2nd fnssres mp2an cB cC cxp
      c2nd cB cC cxp cres fnfun ax-mp a1i cA cD wcel cA cB cF wf cA cC cG wf
      w3a vz cv cA wcel wa cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wf vx cv cA wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wfun cA cD wcel cA cB cF wf cA cC cG wf
      w3a cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab wf vz cv cA wcel cA cD wcel cA cB cF wf cA cC cG wf w3a vx
      cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cB cC cxp vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf cA cB
      cF wf cA cC cG wf vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral
      cA cD wcel cA cB cF wf cA cC cG wf wa vx cv cF cfv vx cv cG cfv cop cB cC
      cxp wcel vx cA cA cB cF wf cA cC cG wf vx cv cA wcel vx cv cF cfv vx cv
      cG cfv cop cB cC cxp wcel vx cv cF cfv cB wcel vx cv cG cfv cC wcel vx cv
      cF cfv vx cv cG cfv cop cB cC cxp wcel cA cB cF wf vx cv cA wcel wa cA cC
      cG wf vx cv cA wcel wa vx cv cF cfv vx cv cG cfv cB cC opelxpi cA cB vx
      cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an anandirs r19.21aiva 3adant1
      vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv cop vx cv cA wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2 sylib adantr cA
      cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ffun syl cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv vx cv cA wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm wcel vz cv cA
      wcel cA cD wcel cA cB cF wf cA cC cG wf w3a vx cv cA wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab cdm cA vz cv cA cD wcel cA cB cF
      wf cA cC cG wf w3a cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab wf vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cdm cA wceq cA cD wcel cA cB cF wf cA cC cG
      wf w3a vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cB cC
      cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      wf cA cB cF wf cA cC cG wf vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel
      vx cA wral cA cD wcel cA cB cF wf cA cC cG wf wa vx cv cF cfv vx cv cG
      cfv cop cB cC cxp wcel vx cA cA cB cF wf cA cC cG wf vx cv cA wcel vx cv
      cF cfv vx cv cG cfv cop cB cC cxp wcel vx cv cF cfv cB wcel vx cv cG cfv
      cC wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel cA cB cF wf vx cv cA
      wcel wa cA cC cG wf vx cv cA wcel wa vx cv cF cfv vx cv cG cfv cB cC
      opelxpi cA cB vx cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an anandirs
      r19.21aiva 3adant1 vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv cop vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv cA
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2
      sylib cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab fdm syl eleq2d biimpar syl3anc cA cD wcel cA cB cF wf cA
      cC cG wf w3a vz cv cA wcel wa vz cv vx cv cA wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab cfv c2nd cB cC cxp cres cfv vz cv cF
      cfv vz cv cG cfv cop c2nd cB cC cxp cres cfv vz cv cF cfv vz cv cG cfv
      cop c2nd cfv vz cv cG cfv cA cD wcel cA cB cF wf cA cC cG wf w3a vz cv cA
      wcel wa vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cfv vz cv cF cfv vz cv cG cfv cop c2nd cB cC cxp cres vz cv
      cA wcel vz cv vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cfv vz cv cF cfv vz cv cG cfv cop wceq cA cD wcel cA cB cF wf
      cA cC cG wf w3a vx vy vz cv vx cv cF cfv vx cv cG cfv cop vz cv cF cfv vz
      cv cG cfv cop cA vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab vx cv vz cv wceq vx cv cF cfv vz cv cF cfv vx cv cG cfv vz
      cv cG cfv vx cv vz cv cF fveq2 vx cv vz cv cG fveq2 opeq12d vx cv cA wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid vz cv cF cfv
      vz cv cG cfv opex fvopab4 adantl fveq2d cA cD wcel cA cB cF wf cA cC cG
      wf w3a vz cv cA wcel wa vz cv cF cfv vz cv cG cfv cop cB cC cxp wcel vz
      cv cF cfv vz cv cG cfv cop c2nd cB cC cxp cres cfv vz cv cF cfv vz cv cG
      cfv cop c2nd cfv wceq cA cB cF wf cA cC cG wf vz cv cA wcel vz cv cF cfv
      vz cv cG cfv cop cB cC cxp wcel cA cD wcel cA cB cF wf cA cC cG wf vz cv
      cA wcel vz cv cF cfv vz cv cG cfv cop cB cC cxp wcel vz cv cF cfv cB wcel
      vz cv cG cfv cC wcel vz cv cF cfv vz cv cG cfv cop cB cC cxp wcel cA cB
      cF wf vz cv cA wcel wa cA cC cG wf vz cv cA wcel wa vz cv cF cfv vz cv cG
      cfv cB cC opelxpi cA cB vz cv cF ffvelrn cA cC vz cv cG ffvelrn syl2an
      anandirs 3adantl1 vz cv cF cfv vz cv cG cfv cop cB cC cxp c2nd fvres syl
      vz cv cF cfv vz cv cG cfv cop c2nd cfv vz cv cG cfv wceq cA cD wcel cA cB
      cF wf cA cC cG wf w3a vz cv cA wcel wa vz cv cF cfv vz cv cG cfv vz cv cF
      fvex vz cv cG fvex op2nd a1i 3eqtrd eqtr2d r19.21aiva jca cG cA wfn c2nd
      cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ccom cA wfn cG c2nd cB cC cxp cres vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq cA cA wceq vz cv cG
      cfv vz cv c2nd cB cC cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab ccom cfv wceq vz cA wral wa wb cA cD wcel cA
      cB cF wf cA cC cG wf w3a vz cA cA cG c2nd cB cC cxp cres vx cv cA wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom eqfnfv cA cC cG
      wf cA cD wcel cG cA wfn cA cB cF wf cA cC cG ffn 3ad2ant3 c2nd cB cC cxp
      cres cB cC cxp wfn vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab cA wfn vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab crn cB cC cxp wss c2nd cB cC cxp cres vx cv cA wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cA wfn cA cD
      wcel cA cB cF wf cA cC cG wf w3a cB cC cxp cA c2nd cB cC cxp cres vx cv
      cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab fnco c2nd
      cB cC cxp cres cB cC cxp wfn cA cD wcel cA cB cF wf cA cC cG wf w3a c2nd
      cvv wfn cB cC cxp cvv wss c2nd cB cC cxp cres cB cC cxp wfn cvv cvv c2nd
      wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cB cC cxp ssv cvv cB cC
      cxp c2nd fnssres mp2an a1i cA cD wcel cA cB cF wf cA cC cG wf w3a cA cB
      cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab cA wfn cA cD wcel cA cB cF wf cA cC cG wf w3a vx cv cF cfv vx cv cG
      cfv cop cB cC cxp wcel vx cA wral cA cB cC cxp vx cv cA wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab wf cA cB cF wf cA cC cG wf vx
      cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA wral cA cD wcel cA cB cF
      wf cA cC cG wf wa vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA cA
      cB cF wf cA cC cG wf vx cv cA wcel vx cv cF cfv vx cv cG cfv cop cB cC
      cxp wcel vx cv cF cfv cB wcel vx cv cG cfv cC wcel vx cv cF cfv vx cv cG
      cfv cop cB cC cxp wcel cA cB cF wf vx cv cA wcel wa cA cC cG wf vx cv cA
      wcel wa vx cv cF cfv vx cv cG cfv cB cC opelxpi cA cB vx cv cF ffvelrn cA
      cC vx cv cG ffvelrn syl2an anandirs r19.21aiva 3adant1 vx vy cA cB cC cxp
      vx cv cF cfv vx cv cG cfv cop vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab eqid fopab2 sylib cA cB cC cxp vx cv cA wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ffn syl cA cD wcel
      cA cB cF wf cA cC cG wf w3a cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab wf vx cv cA wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab crn cB cC cxp wss cA cD wcel cA cB
      cF wf cA cC cG wf w3a vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cA
      wral cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab wf cA cB cF wf cA cC cG wf vx cv cF cfv vx cv cG cfv cop
      cB cC cxp wcel vx cA wral cA cD wcel cA cB cF wf cA cC cG wf wa vx cv cF
      cfv vx cv cG cfv cop cB cC cxp wcel vx cA cA cB cF wf cA cC cG wf vx cv
      cA wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel vx cv cF cfv cB wcel
      vx cv cG cfv cC wcel vx cv cF cfv vx cv cG cfv cop cB cC cxp wcel cA cB
      cF wf vx cv cA wcel wa cA cC cG wf vx cv cA wcel wa vx cv cF cfv vx cv cG
      cfv cB cC opelxpi cA cB vx cv cF ffvelrn cA cC vx cv cG ffvelrn syl2an
      anandirs r19.21aiva 3adant1 vx vy cA cB cC cxp vx cv cF cfv vx cv cG cfv
      cop vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      eqid fopab2 sylib cA cB cC cxp vx cv cA wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab frn syl syl3anc sylanc mpbird cQ c2nd cB cC
      cxp cres vx cv cA wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab upxp.2 coeq1i syl6eqr 3jca syl5cbir impbid eubidv mpbird $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d R h s t u v w x y z $. $d S h s t u v w x y z $.
    $d X h s t u v w x y z $.
    $d T h s t u v w x y z $. $d U h s t u v w x y z $.
    $d Y h s t u v w x y z $.
    $d P h s t u v w x y z $. $d Q h s t u v w x y z $.
    $d Z h s t u v w x y z $.
    $d F h s t u v w x y z $. $d G h s t u v w x y z $.
    uptx.1 $e |- T = ( R tX S ) $.
    uptx.2 $e |- X = U. R $.
    uptx.3 $e |- Y = U. S $.
    uptx.4 $e |- Z = ( X X. Y ) $.
    uptx.5 $e |- P = ( 1st |` Z ) $.
    uptx.6 $e |- Q = ( 2nd |` Z ) $.
    $( Universal property of the binary topological product.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    uptx $p |- ( ( ( R e. Top /\ S e. Top /\ U e. Top ) /\
                          ( F e. ( U Cn R ) /\ G e. ( U Cn S ) ) ) ->
                  E! h e. ( U Cn T ) ( F = ( P o. h ) /\ G = ( Q o. h ) ) ) $=
      cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa vh cU cT ccn co wreu vh cv
      cU cT ccn co wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa wa vh
      wex vh cv cU cT ccn co wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq
      wa wa vh wmo cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co
      wcel cG cU cS ccn co wcel wa wa cF cP vh cv ccom wceq cG cQ vh cv ccom
      wceq wa vh cU cT ccn co wreu vh cv cU cT ccn co wcel cF cP vh cv ccom
      wceq cG cQ vh cv ccom wceq wa wa vh weu vh cv cU cT ccn co wcel cF cP vh
      cv ccom wceq cG cQ vh cv ccom wceq wa wa vh wex vh cv cU cT ccn co wcel
      cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa wa vh wmo wa cF cP vh cv
      ccom wceq cG cQ vh cv ccom wceq wa vh cU cT ccn co df-reu vh cv cU cT ccn
      co wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa wa vh eu5 bitri vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      cvv wcel vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cU cT ccn co wcel cF cP vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccom wceq cG cQ vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq wa wa
      vh cv cU cT ccn co wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa wa
      vh wex cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG
      cU cS ccn co wcel wa wa vh cv cU cT ccn co wcel cF cP vh cv ccom wceq cG
      cQ vh cv ccom wceq wa wa vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cU cT ccn co wcel cF cP vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq cG cQ vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccom wceq wa wa vh vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab cvv vh cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wceq vh cv cU cT ccn co wcel vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cU cT ccn co
      wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa cF cP vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq cG
      cQ vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccom wceq wa vh cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cU cT ccn co eleq1 vh cv vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wceq cF cP vh cv
      ccom wceq cF cP vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccom wceq cG cQ vh cv ccom wceq cG cQ vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq vh
      cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wceq cP vh cv ccom cP vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab ccom cF vh cv vx cv cU cuni wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cP coeq2 eqeq2d vh cv vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      wceq cQ vh cv ccom cQ vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom cG vh cv vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab cQ coeq2 eqeq2d anbi12d anbi12d
      cla4egv cR ctop wcel cS ctop wcel cU ctop wcel w3a vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cvv wcel cF cU cR
      ccn co wcel cG cU cS ccn co wcel wa cU ctop wcel cR ctop wcel vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cvv
      wcel cS ctop wcel cU ctop wcel cU cuni cvv wcel vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cvv wcel cU ctop uniexg
      vx vy cU cuni vx cv cF cfv vx cv cG cfv cop cvv opabex2g syl 3ad2ant3
      adantr cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG
      cU cS ccn co wcel wa wa vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cU cT ccn co wcel cF cP vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq cG cQ vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccom wceq cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel
      cG cU cS ccn co wcel wa wa vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cU cT ccn co wcel cU cuni cT cuni vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccnv vz cv cima cU wcel vz cT wral wa cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa cU cuni cT cuni
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ccnv vz cv cima cU wcel vz cT wral cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa cU cuni
      cT cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab wf cU cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wf cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa cU cuni cX cF wf cU
      cuni cY cG wf wa cU cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab wf cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa cU cuni cX cF wf cU
      cuni cY cG wf wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn
      co wcel cU cuni cX cF wf cG cU cS ccn co wcel cU cuni cY cG wf cR ctop
      wcel cU ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf wi cS ctop wcel
      cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf wi cU
      ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf cF cU cR cU
      cuni cX cU cuni eqid uptx.2 cnf 3expia ancoms 3adant2 cS ctop wcel cU
      ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cR ctop wcel cU ctop
      wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cU ctop wcel
      cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf cG cU cS cU cuni cY cU
      cuni eqid uptx.3 cnf 3expia ancoms 3adant1 anim12d imp cU cuni cX cF wf
      cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU
      cuni wral cU cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wf cU cuni cX cF wf cU cuni cY cG wf wa vx
      cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU cuni cU cuni cX cF wf cU
      cuni cY cG wf vx cv cU cuni wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp
      wcel vx cv cF cfv cX wcel vx cv cG cfv cY wcel vx cv cF cfv vx cv cG cfv
      cop cX cY cxp wcel cU cuni cX cF wf vx cv cU cuni wcel wa cU cuni cY cG
      wf vx cv cU cuni wcel wa vx cv cF cfv vx cv cG cfv cX cY opelxpi cU cuni
      cX vx cv cF ffvelrn cU cuni cY vx cv cG ffvelrn syl2an anandirs
      r19.21aiva vx vy cU cuni cX cY cxp vx cv cF cfv vx cv cG cfv cop vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid
      fopab2 sylib syl cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn
      co wcel cG cU cS ccn co wcel wa wa cT cuni cX cY cxp wceq cU cuni cT cuni
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf cU cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab wf wb cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cT cuni cX cY cxp wceq cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      cR ctop wcel cS ctop wcel cT cuni cX cY cxp wceq cU ctop wcel cR cS cT cX
      cY uptx.1 uptx.2 uptx.3 txuni 3adant3 adantr cT cuni cX cY cxp cU cuni vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      feq3 syl mpbird cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn
      co wcel cG cU cS ccn co wcel wa wa vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccnv vz cv cima cU wcel vz cT cR
      ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn
      co wcel wa wa vz cv cT wcel vs cv vw cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vw cab wss vz cv vs cv cuni wceq wa vs wex vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vz cv cima
      cU wcel cR ctop wcel cS ctop wcel cU ctop wcel w3a vz cv cT wcel vs cv vw
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss vz cv vs cv cuni
      wceq wa vs wex wb cF cU cR ccn co wcel cG cU cS ccn co wcel wa cR ctop
      wcel cS ctop wcel vz cv cT wcel vs cv vw cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vw cab wss vz cv vs cv cuni wceq wa vs wex wb cU ctop
      wcel cR ctop wcel cS ctop wcel wa vz cv cT wcel vz cv vw cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vw cab ctg cfv wcel vs cv vw cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vw cab wss vz cv vs cv cuni wceq wa vs
      wex cR ctop wcel cS ctop wcel wa cT vw cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vw cab ctg cfv vz cv cR ctop wcel cS ctop wcel wa cR cS ctx co
      vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab ctg cfv cT vw vv
      vu cR cS txval uptx.1 syl5eq eleq2d cR ctop wcel cS ctop wcel wa vw cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab ctb wcel vz cv vw cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vw cab ctg cfv wcel vs cv vw cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss vz cv vs cv cuni wceq
      wa vs wex wb vw vv vu cR cS txbas vs vz cv vw cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vw cab eltg3 syl bitrd 3adant3 adantr cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      wa vs cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss vz
      cv vs cv cuni wceq wa vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccnv vz cv cima cU wcel vs cR ctop wcel cS ctop
      wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa vs
      cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss vz cv vs
      cv cuni wceq vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab ccnv vz cv cima cU wcel vz cv vs cv cuni wceq vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vz
      cv cima cU wcel vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccnv vs cv cuni cima cU wcel cR ctop wcel cS ctop
      wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa vs
      cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss wa vz cv
      vs cv cuni wceq vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccnv vz cv cima vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccnv vs cv cuni cima cU vz cv vs cv
      cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccnv imaeq2 eleq1d cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU
      cR ccn co wcel cG cU cS ccn co wcel wa wa vs cv vw cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vw cab wss wa vt vs cv vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vt cv cima ciun
      cU vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccnv vs cv cuni cima cU ctop wcel vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vt cv cima cU wcel vt vs cv
      wral vt vs cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab ccnv vt cv cima ciun cU wcel cR ctop wcel cS ctop wcel cU
      ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa vs cv vw cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss wa vt vs cv vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv
      vt cv cima cU iunopn cR ctop wcel cS ctop wcel cU ctop wcel w3a cU ctop
      wcel cF cU cR ccn co wcel cG cU cS ccn co wcel wa vs cv vw cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vw cab wss cR ctop wcel cS ctop wcel cU
      ctop wcel 3simp3 ad2antrr cR ctop wcel cS ctop wcel cU ctop wcel w3a cF
      cU cR ccn co wcel cG cU cS ccn co wcel wa wa vs cv vw cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vw cab wss wa vx cv cU cuni wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vt cv cima cU wcel vt vs
      cv cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU
      cS ccn co wcel wa wa vs cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vw cab wss vt cv vs cv wcel vx cv cU cuni wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab ccnv vt cv cima cU wcel cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      wa vt cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vt cv cima cU
      wcel vs cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab wss vt
      cv vs cv wcel wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn
      co wcel cG cU cS ccn co wcel wa wa vt cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ccnv vt cv cima cU wcel cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa vt cv vu cv vv
      cv cxp wceq vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab ccnv vt cv cima cU wcel vu vv cR cS cR ctop wcel cS ctop
      wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa vu
      cv cR wcel vv cv cS wcel wa vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima cU wcel vt cv vu
      cv vv cv cxp wceq vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccnv vt cv cima cU wcel wi cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa vu cv cR
      wcel vv cv cS wcel wa vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima cU wcel cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      wa vu cv cR wcel vv cv cS wcel wa wa vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima cF
      ccnv vu cv cima cG ccnv vv cv cima cin cU cU cuni cX cF wf cU cuni cY cG
      wf wa vu cv cR wcel vv cv cS wcel wa vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima cF
      ccnv vu cv cima cG ccnv vv cv cima cin wceq cR ctop wcel cS ctop wcel cU
      ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa cU cuni cX
      cF wf cU cuni cY cG wf wa vu cv cR wcel vv cv cS wcel wa wa vz vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vu
      cv vv cv cxp cima cF ccnv vu cv cima cG ccnv vv cv cima cin cU cuni cX cF
      wf cU cuni cY cG wf wa vu cv cR wcel vv cv cS wcel wa wa vz cv cU cuni
      wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cfv vu cv vv cv cxp wcel wa vz cv cU cuni wcel vz cv cF cfv
      vu cv wcel wa vz cv cU cuni wcel vz cv cG cfv vv cv wcel wa wa vz cv vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccnv vu cv vv cv cxp cima wcel vz cv cF ccnv vu cv cima cG ccnv vv cv
      cima cin wcel cU cuni cX cF wf cU cuni cY cG wf wa vu cv cR wcel vv cv cS
      wcel wa wa vz cv cU cuni wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab cfv vu cv vv cv cxp wcel wa vz cv cU
      cuni wcel vz cv cF cfv vu cv wcel vz cv cG cfv vv cv wcel wa wa vz cv cU
      cuni wcel vz cv cF cfv vu cv wcel wa vz cv cU cuni wcel vz cv cG cfv vv
      cv wcel wa wa cU cuni cX cF wf cU cuni cY cG wf wa vu cv cR wcel vv cv cS
      wcel wa wa vz cv cU cuni wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab cfv vu cv vv cv cxp wcel vz cv cF
      cfv vu cv wcel vz cv cG cfv vv cv wcel wa vz cv cU cuni wcel vz cv vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cfv
      vu cv vv cv cxp wcel vz cv cF cfv vu cv wcel vz cv cG cfv vv cv wcel wa
      wb cU cuni cX cF wf cU cuni cY cG wf wa vu cv cR wcel vv cv cS wcel wa wa
      vz cv cU cuni wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cfv vu cv vv cv cxp wcel vz cv cF cfv vz cv
      cG cfv cop vu cv vv cv cxp wcel vz cv cF cfv vu cv wcel vz cv cG cfv vv
      cv wcel wa vz cv cU cuni wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab cfv vz cv cF cfv vz cv cG cfv cop vu
      cv vv cv cxp vx vy vz cv vx cv cF cfv vx cv cG cfv cop vz cv cF cfv vz cv
      cG cfv cop cU cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab vx cv vz cv wceq vx cv cF cfv vz cv cF cfv vx cv cG
      cfv vz cv cG cfv vx cv vz cv cF fveq2 vx cv vz cv cG fveq2 opeq12d vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid
      vz cv cF cfv vz cv cG cfv opex fvopab4 eleq1d vz cv cF cfv vz cv cG cfv
      vu cv vv cv vz cv cG fvex opelxp syl6bb adantl pm5.32da vz cv cU cuni
      wcel vz cv cF cfv vu cv wcel vz cv cG cfv vv cv wcel anandi syl6bb cU
      cuni cX cF wf cU cuni cY cG wf wa vz cv vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima wcel
      vz cv cU cuni wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab cfv vu cv vv cv cxp wcel wa wb vu cv cR wcel
      vv cv cS wcel wa cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cU cuni wfn vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima wcel vz cv cU
      cuni wcel vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab cfv vu cv vv cv cxp wcel wa wb cU cuni cX cF wf cU
      cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU cuni
      wral cU cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab wf cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF
      cfv vx cv cG cfv cop cX cY cxp wcel vx cU cuni cU cuni cX cF wf cU cuni
      cY cG wf vx cv cU cuni wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel
      vx cv cF cfv cX wcel vx cv cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop
      cX cY cxp wcel cU cuni cX cF wf vx cv cU cuni wcel wa cU cuni cY cG wf vx
      cv cU cuni wcel wa vx cv cF cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx
      cv cF ffvelrn cU cuni cY vx cv cG ffvelrn syl2an anandirs r19.21aiva vx
      vy cU cuni cX cY cxp vx cv cF cfv vx cv cG cfv cop vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2 sylib
      cU cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ffn cU cuni vz cv vu cv vv cv cxp vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab elpreima 3syl
      adantr cU cuni cX cF wf cU cuni cY cG wf wa vz cv cF ccnv vu cv cima cG
      ccnv vv cv cima cin wcel vz cv cU cuni wcel vz cv cF cfv vu cv wcel wa vz
      cv cU cuni wcel vz cv cG cfv vv cv wcel wa wa wb vu cv cR wcel vv cv cS
      wcel wa cU cuni cX cF wf cU cuni cY cG wf wa vz cv cF ccnv vu cv cima
      wcel vz cv cG ccnv vv cv cima wcel wa vz cv cU cuni wcel vz cv cF cfv vu
      cv wcel wa vz cv cU cuni wcel vz cv cG cfv vv cv wcel wa wa vz cv cF ccnv
      vu cv cima cG ccnv vv cv cima cin wcel cU cuni cX cF wf vz cv cF ccnv vu
      cv cima wcel vz cv cU cuni wcel vz cv cF cfv vu cv wcel wa cU cuni cY cG
      wf vz cv cG ccnv vv cv cima wcel vz cv cU cuni wcel vz cv cG cfv vv cv
      wcel wa cU cuni cX cF wf cF cU cuni wfn vz cv cF ccnv vu cv cima wcel vz
      cv cU cuni wcel vz cv cF cfv vu cv wcel wa wb cU cuni cX cF ffn cU cuni
      vz cv vu cv cF elpreima syl cU cuni cY cG wf cG cU cuni wfn vz cv cG ccnv
      vv cv cima wcel vz cv cU cuni wcel vz cv cG cfv vv cv wcel wa wb cU cuni
      cY cG ffn cU cuni vz cv vv cv cG elpreima syl bi2anan9 vz cv cF ccnv vu
      cv cima cG ccnv vv cv cima elin syl5bb adantr 3bitr4d eqrdv cR ctop wcel
      cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel
      wa cU cuni cX cF wf cU cuni cY cG wf wa cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cF cU cR ccn co wcel cU cuni cX cF wf cG cU cS ccn co wcel cU
      cuni cY cG wf cR ctop wcel cU ctop wcel cF cU cR ccn co wcel cU cuni cX
      cF wf wi cS ctop wcel cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU
      cuni cX cF wf wi cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni
      cX cF wf cF cU cR cU cuni cX cU cuni eqid uptx.2 cnf 3expia ancoms
      3adant2 cS ctop wcel cU ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf
      wi cR ctop wcel cU ctop wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY
      cG wf wi cU ctop wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf
      cG cU cS cU cuni cY cU cuni eqid uptx.3 cnf 3expia ancoms 3adant1 anim12d
      imp sylan cU ctop wcel cF ccnv vu cv cima cU wcel cG ccnv vv cv cima cU
      wcel cF ccnv vu cv cima cG ccnv vv cv cima cin cU wcel cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      wa vu cv cR wcel vv cv cS wcel wa wa cF ccnv vu cv cima cG ccnv vv cv
      cima cU inopn cR ctop wcel cS ctop wcel cU ctop wcel w3a cU ctop wcel cF
      cU cR ccn co wcel cG cU cS ccn co wcel wa vu cv cR wcel vv cv cS wcel wa
      cR ctop wcel cS ctop wcel cU ctop wcel 3simp3 ad2antrr cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      wa vu cv cR wcel cF ccnv vu cv cima cU wcel vv cv cS wcel cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel vu cv cR wcel cF ccnv vu
      cv cima cU wcel cG cU cS ccn co wcel cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cF cU cR ccn co wcel wa vu cv cR wcel cF ccnv vu cv cima cU wcel
      cR ctop wcel cU ctop wcel cF cU cR ccn co wcel vu cv cR wcel cF ccnv vu
      cv cima cU wcel wi cS ctop wcel cU ctop wcel cR ctop wcel cF cU cR ccn co
      wcel vu cv cR wcel cF ccnv vu cv cima cU wcel wi cU ctop wcel cR ctop
      wcel cF cU cR ccn co wcel vu cv cR wcel cF ccnv vu cv cima cU wcel wi cU
      ctop wcel cR ctop wcel cF cU cR ccn co wcel w3a vu cv cR wcel cF ccnv vu
      cv cima cU wcel vu cv cF cU cR cnima ex 3expa ancom1s 3adantl2 imp
      adantlrr adantrr cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn
      co wcel cG cU cS ccn co wcel wa wa vv cv cS wcel cG ccnv vv cv cima cU
      wcel vu cv cR wcel cR ctop wcel cS ctop wcel cU ctop wcel w3a cG cU cS
      ccn co wcel vv cv cS wcel cG ccnv vv cv cima cU wcel cF cU cR ccn co wcel
      cR ctop wcel cS ctop wcel cU ctop wcel w3a cG cU cS ccn co wcel wa vv cv
      cS wcel cG ccnv vv cv cima cU wcel cS ctop wcel cU ctop wcel cG cU cS ccn
      co wcel vv cv cS wcel cG ccnv vv cv cima cU wcel wi cR ctop wcel cU ctop
      wcel cS ctop wcel cG cU cS ccn co wcel vv cv cS wcel cG ccnv vv cv cima
      cU wcel wi cU ctop wcel cS ctop wcel cG cU cS ccn co wcel vv cv cS wcel
      cG ccnv vv cv cima cU wcel wi cU ctop wcel cS ctop wcel cG cU cS ccn co
      wcel w3a vv cv cS wcel cG ccnv vv cv cima cU wcel vv cv cG cU cS cnima ex
      3expa ancom1s 3adantl1 imp adantlrl adantrl syl3anc eqeltrd ex vt cv vu
      cv vv cv cxp wceq vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab ccnv vt cv cima cU wcel vx cv cU cuni wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv cxp cima
      cU wcel vt cv vu cv vv cv cxp wceq vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccnv vt cv cima vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vu cv vv cv
      cxp cima cU vt cv vu cv vv cv cxp vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccnv imaeq2 eleq1d biimprcd syl6
      r19.23advv imp vs cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw
      cab wss vt cv vs cv wcel wa vt cv vw cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vw cab wcel vt cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex
      vs cv vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vw cab vt cv ssel2
      vw cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vt cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vw vt cv vt visset vw cv vt cv wceq vw cv vu
      cv vv cv cxp wceq vt cv vu cv vv cv cxp wceq vu vv cR cS vw cv vt cv vu
      cv vv cv cxp eqeq1 2rexbidv elab sylib sylan2 anassrs r19.21aiva sylanc
      vt vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccnv vs cv imaiun syl5eqel syl5cbir expimpd 19.23adv sylbid
      r19.21aiv jca cR ctop wcel cS ctop wcel cU ctop wcel w3a vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cU cT ccn co
      wcel cU cuni cT cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab ccnv vz cv cima cU wcel vz cT wral wa wb cF
      cU cR ccn co wcel cG cU cS ccn co wcel wa cR ctop wcel cS ctop wcel cU
      ctop wcel vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cU cT ccn co wcel cU cuni cT cuni vx cv cU cuni wcel vy cv vx
      cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccnv vz cv cima cU
      wcel vz cT wral wa wb cU ctop wcel cR ctop wcel cS ctop wcel wa vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cU cT
      ccn co wcel cU cuni cT cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab wf vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccnv vz cv cima cU wcel vz cT wral
      wa wb cU ctop wcel cT ctop wcel vx cv cU cuni wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab cU cT ccn co wcel cU cuni cT cuni vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab ccnv vz cv cima cU wcel vz cT wral wa wb cR ctop wcel cS ctop wcel
      wa vz vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab cU cT cU cuni cT cuni cU cuni eqid cT cuni eqid iscn cR cS cT
      uptx.1 txtop sylan2 ancoms 3impa adantr mpbird cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa cU cuni
      cX cF wf cU cuni cY cG wf wa cF cP vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccom wceq cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa cU cuni cX
      cF wf cU cuni cY cG wf wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF
      cU cR ccn co wcel cU cuni cX cF wf cG cU cS ccn co wcel cU cuni cY cG wf
      cR ctop wcel cU ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf wi cS
      ctop wcel cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf
      wi cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf cF cU
      cR cU cuni cX cU cuni eqid uptx.2 cnf 3expia ancoms 3adant2 cS ctop wcel
      cU ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cR ctop wcel cU
      ctop wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cU ctop
      wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf cG cU cS cU cuni
      cY cU cuni eqid uptx.3 cnf 3expia ancoms 3adant1 anim12d imp cU cuni cX
      cF wf cU cuni cY cG wf wa cF c1st cX cY cxp cres vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cP vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cU cuni
      cX cF wf cU cuni cY cG wf wa cF c1st cX cY cxp cres vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq cU cuni cU
      cuni wceq vz cv cF cfv vz cv c1st cX cY cxp cres vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cU
      cuni wral wa cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cU cuni wceq vz
      cv cF cfv vz cv c1st cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cU cuni wral cU
      cuni cX cF wf cU cuni cY cG wf wa cU cuni eqidd cU cuni cX cF wf cU cuni
      cY cG wf wa vz cv cF cfv vz cv c1st cX cY cxp cres vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cU
      cuni cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa vz cv
      c1st cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom cfv vz cv vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab cfv c1st cX cY cxp cres cfv vz
      cv cF cfv c1st cX cY cxp cres wfun vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab wfun vz cv vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm wcel vz cv c1st cX
      cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab ccom cfv vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cfv c1st cX cY cxp cres cfv wceq cU cuni
      cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa vz cv c1st cX cY cxp
      cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab fvco c1st cX cY cxp cres wfun cU cuni cX cF wf cU cuni cY cG wf wa
      vz cv cU cuni wcel wa c1st cX cY cxp cres cX cY cxp wfn c1st cX cY cxp
      cres wfun c1st cvv wfn cX cY cxp cvv wss c1st cX cY cxp cres cX cY cxp
      wfn cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp cX cY cxp
      ssv cvv cX cY cxp c1st fnssres mp2an cX cY cxp c1st cX cY cxp cres fnfun
      ax-mp a1i cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa cU
      cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab wfun cU cuni cX cF wf cU cuni cY cG wf wa cU cuni
      cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab wf vz cv cU cuni wcel cU cuni cX cF wf cU cuni cY cG wf wa vx
      cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY
      cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv
      cop cX cY cxp wcel vx cU cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU
      cuni wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX
      wcel vx cv cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU
      cuni cX cF wf vx cv cU cuni wcel wa cU cuni cY cG wf vx cv cU cuni wcel
      wa vx cv cF cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU
      cuni cY vx cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cU cuni cX cY
      cxp vx cv cF cfv vx cv cG cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2 sylib adantr cU cuni
      cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ffun syl cU cuni cX cF wf cU cuni cY cG wf wa vz cv vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm
      wcel vz cv cU cuni wcel cU cuni cX cF wf cU cuni cY cG wf wa vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm cU
      cuni vz cv cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab cdm cU cuni wceq cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv
      vx cv cG cfv cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY cxp vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY
      cxp wcel vx cU cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU cuni wcel
      vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX wcel vx cv
      cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU cuni cX cF
      wf vx cv cU cuni wcel wa cU cuni cY cG wf vx cv cU cuni wcel wa vx cv cF
      cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU cuni cY vx
      cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cU cuni cX cY cxp vx cv cF
      cfv vx cv cG cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab eqid fopab2 sylib cU cuni cX cY cxp vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab fdm syl
      eleq2d biimpar syl3anc cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni
      wcel wa vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab cfv c1st cX cY cxp cres cfv vz cv cF cfv vz cv cG cfv cop
      c1st cX cY cxp cres cfv vz cv cF cfv vz cv cG cfv cop c1st cfv vz cv cF
      cfv cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa vz cv vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      cfv vz cv cF cfv vz cv cG cfv cop c1st cX cY cxp cres vz cv cU cuni wcel
      vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab cfv vz cv cF cfv vz cv cG cfv cop wceq cU cuni cX cF wf cU cuni
      cY cG wf wa vx vy vz cv vx cv cF cfv vx cv cG cfv cop vz cv cF cfv vz cv
      cG cfv cop cU cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab vx cv vz cv wceq vx cv cF cfv vz cv cF cfv vx cv cG
      cfv vz cv cG cfv vx cv vz cv cF fveq2 vx cv vz cv cG fveq2 opeq12d vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid
      vz cv cF cfv vz cv cG cfv opex fvopab4 adantl fveq2d cU cuni cX cF wf cU
      cuni cY cG wf wa vz cv cU cuni wcel wa vz cv cF cfv vz cv cG cfv cop cX
      cY cxp wcel vz cv cF cfv vz cv cG cfv cop c1st cX cY cxp cres cfv vz cv
      cF cfv vz cv cG cfv cop c1st cfv wceq cU cuni cX cF wf cU cuni cY cG wf
      vz cv cU cuni wcel vz cv cF cfv vz cv cG cfv cop cX cY cxp wcel vz cv cF
      cfv cX wcel vz cv cG cfv cY wcel vz cv cF cfv vz cv cG cfv cop cX cY cxp
      wcel cU cuni cX cF wf vz cv cU cuni wcel wa cU cuni cY cG wf vz cv cU
      cuni wcel wa vz cv cF cfv vz cv cG cfv cX cY opelxpi cU cuni cX vz cv cF
      ffvelrn cU cuni cY vz cv cG ffvelrn syl2an anandirs vz cv cF cfv vz cv cG
      cfv cop cX cY cxp c1st fvres syl vz cv cF cfv vz cv cG cfv cop c1st cfv
      vz cv cF cfv wceq cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel
      wa vz cv cF cfv vz cv cG cfv vz cv cF fvex op1st a1i 3eqtrd eqtr2d
      r19.21aiva jca cF cU cuni wfn c1st cX cY cxp cres vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cU cuni wfn cF
      c1st cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom wceq cU cuni cU cuni wceq vz cv cF cfv vz cv
      c1st cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom cfv wceq vz cU cuni wral wa wb cU cuni cX cF
      wf cU cuni cY cG wf wa vz cU cuni cU cuni cF c1st cX cY cxp cres vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom
      eqfnfv cU cuni cX cF wf cF cU cuni wfn cU cuni cY cG wf cU cuni cX cF ffn
      adantr c1st cX cY cxp cres cX cY cxp wfn vx cv cU cuni wcel vy cv vx cv
      cF cfv vx cv cG cfv cop wceq wa vx vy copab cU cuni wfn vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab crn cX cY
      cxp wss c1st cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab ccom cU cuni wfn cU cuni cX cF wf cU cuni
      cY cG wf wa cX cY cxp cU cuni c1st cX cY cxp cres vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab fnco c1st cX cY cxp
      cres cX cY cxp wfn cU cuni cX cF wf cU cuni cY cG wf wa c1st cvv wfn cX
      cY cxp cvv wss c1st cX cY cxp cres cX cY cxp wfn cvv cvv c1st wfo c1st
      cvv wfn fo1st cvv cvv c1st fofn ax-mp cX cY cxp ssv cvv cX cY cxp c1st
      fnssres mp2an a1i cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cU cuni wfn cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv
      vx cv cG cfv cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY cxp vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY
      cxp wcel vx cU cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU cuni wcel
      vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX wcel vx cv
      cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU cuni cX cF
      wf vx cv cU cuni wcel wa cU cuni cY cG wf vx cv cU cuni wcel wa vx cv cF
      cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU cuni cY vx
      cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cU cuni cX cY cxp vx cv cF
      cfv vx cv cG cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab eqid fopab2 sylib cU cuni cX cY cxp vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ffn syl
      cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab crn cX cY
      cxp wss cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv
      cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY cxp vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf cU cuni cX cF
      wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU
      cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU cuni wcel vx cv cF cfv vx
      cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX wcel vx cv cG cfv cY wcel vx
      cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU cuni cX cF wf vx cv cU cuni
      wcel wa cU cuni cY cG wf vx cv cU cuni wcel wa vx cv cF cfv vx cv cG cfv
      cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU cuni cY vx cv cG ffvelrn
      syl2an anandirs r19.21aiva vx vy cU cuni cX cY cxp vx cv cF cfv vx cv cG
      cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab eqid fopab2 sylib cU cuni cX cY cxp vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab frn syl syl3anc sylanc
      mpbird cP c1st cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cP c1st cZ cres c1st cX cY cxp cres uptx.5
      cZ cX cY cxp wceq c1st cZ cres c1st cX cY cxp cres wceq uptx.4 cZ cX cY
      cxp c1st reseq2 ax-mp eqtri coeq1i syl6eqr syl cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa wa cU cuni
      cX cF wf cU cuni cY cG wf wa cG cQ vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccom wceq cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa cU cuni cX
      cF wf cU cuni cY cG wf wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF
      cU cR ccn co wcel cU cuni cX cF wf cG cU cS ccn co wcel cU cuni cY cG wf
      cR ctop wcel cU ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf wi cS
      ctop wcel cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf
      wi cU ctop wcel cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf cF cU
      cR cU cuni cX cU cuni eqid uptx.2 cnf 3expia ancoms 3adant2 cS ctop wcel
      cU ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cR ctop wcel cU
      ctop wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cU ctop
      wcel cS ctop wcel cG cU cS ccn co wcel cU cuni cY cG wf cG cU cS cU cuni
      cY cU cuni eqid uptx.3 cnf 3expia ancoms 3adant1 anim12d imp cU cuni cX
      cF wf cU cuni cY cG wf wa cG c2nd cX cY cxp cres vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cQ vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cU cuni
      cX cF wf cU cuni cY cG wf wa cG c2nd cX cY cxp cres vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom wceq cU cuni cU
      cuni wceq vz cv cG cfv vz cv c2nd cX cY cxp cres vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cU
      cuni wral wa cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cU cuni wceq vz
      cv cG cfv vz cv c2nd cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cU cuni wral cU
      cuni cX cF wf cU cuni cY cG wf wa cU cuni eqidd cU cuni cX cF wf cU cuni
      cY cG wf wa vz cv cG cfv vz cv c2nd cX cY cxp cres vx cv cU cuni wcel vy
      cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cfv wceq vz cU
      cuni cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa vz cv
      c2nd cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab ccom cfv vz cv vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab cfv c2nd cX cY cxp cres cfv vz
      cv cG cfv c2nd cX cY cxp cres wfun vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab wfun vz cv vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm wcel vz cv c2nd cX
      cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab ccom cfv vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cfv c2nd cX cY cxp cres cfv wceq cU cuni
      cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa vz cv c2nd cX cY cxp
      cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab fvco c2nd cX cY cxp cres wfun cU cuni cX cF wf cU cuni cY cG wf wa
      vz cv cU cuni wcel wa c2nd cX cY cxp cres cX cY cxp wfn c2nd cX cY cxp
      cres wfun c2nd cvv wfn cX cY cxp cvv wss c2nd cX cY cxp cres cX cY cxp
      wfn cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cX cY cxp
      ssv cvv cX cY cxp c2nd fnssres mp2an cX cY cxp c2nd cX cY cxp cres fnfun
      ax-mp a1i cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa cU
      cuni cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab wfun cU cuni cX cF wf cU cuni cY cG wf wa cU cuni
      cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab wf vz cv cU cuni wcel cU cuni cX cF wf cU cuni cY cG wf wa vx
      cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY
      cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv
      cop cX cY cxp wcel vx cU cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU
      cuni wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX
      wcel vx cv cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU
      cuni cX cF wf vx cv cU cuni wcel wa cU cuni cY cG wf vx cv cU cuni wcel
      wa vx cv cF cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU
      cuni cY vx cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cU cuni cX cY
      cxp vx cv cF cfv vx cv cG cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv
      vx cv cG cfv cop wceq wa vx vy copab vx cv cU cuni wcel vy cv vx cv cF
      cfv vx cv cG cfv cop wceq wa vx vy copab eqid fopab2 sylib adantr cU cuni
      cX cY cxp vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab ffun syl cU cuni cX cF wf cU cuni cY cG wf wa vz cv vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm
      wcel vz cv cU cuni wcel cU cuni cX cF wf cU cuni cY cG wf wa vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cdm cU
      cuni vz cv cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab cdm cU cuni wceq cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv
      vx cv cG cfv cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY cxp vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY
      cxp wcel vx cU cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU cuni wcel
      vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX wcel vx cv
      cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU cuni cX cF
      wf vx cv cU cuni wcel wa cU cuni cY cG wf vx cv cU cuni wcel wa vx cv cF
      cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU cuni cY vx
      cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cU cuni cX cY cxp vx cv cF
      cfv vx cv cG cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab eqid fopab2 sylib cU cuni cX cY cxp vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab fdm syl
      eleq2d biimpar syl3anc cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni
      wcel wa vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq
      wa vx vy copab cfv c2nd cX cY cxp cres cfv vz cv cF cfv vz cv cG cfv cop
      c2nd cX cY cxp cres cfv vz cv cF cfv vz cv cG cfv cop c2nd cfv vz cv cG
      cfv cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel wa vz cv vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      cfv vz cv cF cfv vz cv cG cfv cop c2nd cX cY cxp cres vz cv cU cuni wcel
      vz cv vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab cfv vz cv cF cfv vz cv cG cfv cop wceq cU cuni cX cF wf cU cuni
      cY cG wf wa vx vy vz cv vx cv cF cfv vx cv cG cfv cop vz cv cF cfv vz cv
      cG cfv cop cU cuni vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop
      wceq wa vx vy copab vx cv vz cv wceq vx cv cF cfv vz cv cF cfv vx cv cG
      cfv vz cv cG cfv vx cv vz cv cF fveq2 vx cv vz cv cG fveq2 opeq12d vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab eqid
      vz cv cF cfv vz cv cG cfv opex fvopab4 adantl fveq2d cU cuni cX cF wf cU
      cuni cY cG wf wa vz cv cU cuni wcel wa vz cv cF cfv vz cv cG cfv cop cX
      cY cxp wcel vz cv cF cfv vz cv cG cfv cop c2nd cX cY cxp cres cfv vz cv
      cF cfv vz cv cG cfv cop c2nd cfv wceq cU cuni cX cF wf cU cuni cY cG wf
      vz cv cU cuni wcel vz cv cF cfv vz cv cG cfv cop cX cY cxp wcel vz cv cF
      cfv cX wcel vz cv cG cfv cY wcel vz cv cF cfv vz cv cG cfv cop cX cY cxp
      wcel cU cuni cX cF wf vz cv cU cuni wcel wa cU cuni cY cG wf vz cv cU
      cuni wcel wa vz cv cF cfv vz cv cG cfv cX cY opelxpi cU cuni cX vz cv cF
      ffvelrn cU cuni cY vz cv cG ffvelrn syl2an anandirs vz cv cF cfv vz cv cG
      cfv cop cX cY cxp c2nd fvres syl vz cv cF cfv vz cv cG cfv cop c2nd cfv
      vz cv cG cfv wceq cU cuni cX cF wf cU cuni cY cG wf wa vz cv cU cuni wcel
      wa vz cv cF cfv vz cv cG cfv vz cv cF fvex vz cv cG fvex op2nd a1i 3eqtrd
      eqtr2d r19.21aiva jca cG cU cuni wfn c2nd cX cY cxp cres vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ccom cU cuni
      wfn cG c2nd cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab ccom wceq cU cuni cU cuni wceq vz cv cG cfv
      vz cv c2nd cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab ccom cfv wceq vz cU cuni wral wa wb cU cuni
      cX cF wf cU cuni cY cG wf wa vz cU cuni cU cuni cG c2nd cX cY cxp cres vx
      cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab
      ccom eqfnfv cU cuni cY cG wf cG cU cuni wfn cU cuni cX cF wf cU cuni cY
      cG ffn adantl c2nd cX cY cxp cres cX cY cxp wfn vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab cU cuni wfn vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab crn cX
      cY cxp wss c2nd cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx
      cv cG cfv cop wceq wa vx vy copab ccom cU cuni wfn cU cuni cX cF wf cU
      cuni cY cG wf wa cX cY cxp cU cuni c2nd cX cY cxp cres vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab fnco c2nd cX cY
      cxp cres cX cY cxp wfn cU cuni cX cF wf cU cuni cY cG wf wa c2nd cvv wfn
      cX cY cxp cvv wss c2nd cX cY cxp cres cX cY cxp wfn cvv cvv c2nd wfo c2nd
      cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cX cY cxp ssv cvv cX cY cxp c2nd
      fnssres mp2an a1i cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp
      vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy
      copab wf vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab cU cuni wfn cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv
      vx cv cG cfv cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY cxp vx cv
      cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf
      cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY
      cxp wcel vx cU cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU cuni wcel
      vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX wcel vx cv
      cG cfv cY wcel vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU cuni cX cF
      wf vx cv cU cuni wcel wa cU cuni cY cG wf vx cv cU cuni wcel wa vx cv cF
      cfv vx cv cG cfv cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU cuni cY vx
      cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cU cuni cX cY cxp vx cv cF
      cfv vx cv cG cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv
      cop wceq wa vx vy copab vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG
      cfv cop wceq wa vx vy copab eqid fopab2 sylib cU cuni cX cY cxp vx cv cU
      cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab ffn syl
      cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY cxp vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf vx cv cU cuni
      wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab crn cX cY
      cxp wss cU cuni cX cF wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv
      cop cX cY cxp wcel vx cU cuni wral cU cuni cX cY cxp vx cv cU cuni wcel
      vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab wf cU cuni cX cF
      wf cU cuni cY cG wf wa vx cv cF cfv vx cv cG cfv cop cX cY cxp wcel vx cU
      cuni cU cuni cX cF wf cU cuni cY cG wf vx cv cU cuni wcel vx cv cF cfv vx
      cv cG cfv cop cX cY cxp wcel vx cv cF cfv cX wcel vx cv cG cfv cY wcel vx
      cv cF cfv vx cv cG cfv cop cX cY cxp wcel cU cuni cX cF wf vx cv cU cuni
      wcel wa cU cuni cY cG wf vx cv cU cuni wcel wa vx cv cF cfv vx cv cG cfv
      cX cY opelxpi cU cuni cX vx cv cF ffvelrn cU cuni cY vx cv cG ffvelrn
      syl2an anandirs r19.21aiva vx vy cU cuni cX cY cxp vx cv cF cfv vx cv cG
      cfv cop vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa vx
      vy copab vx cv cU cuni wcel vy cv vx cv cF cfv vx cv cG cfv cop wceq wa
      vx vy copab eqid fopab2 sylib cU cuni cX cY cxp vx cv cU cuni wcel vy cv
      vx cv cF cfv vx cv cG cfv cop wceq wa vx vy copab frn syl syl3anc sylanc
      mpbird cQ c2nd cX cY cxp cres vx cv cU cuni wcel vy cv vx cv cF cfv vx cv
      cG cfv cop wceq wa vx vy copab cQ c2nd cZ cres c2nd cX cY cxp cres uptx.6
      cZ cX cY cxp wceq c2nd cZ cres c2nd cX cY cxp cres wceq uptx.4 cZ cX cY
      cxp c2nd reseq2 ax-mp eqtri coeq1i syl6eqr syl jca32 sylc cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa
      wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cU cuni cX cF wf cU cuni cY
      cG wf wa wa vh cv cU cT ccn co wcel cF cP vh cv ccom wceq cG cQ vh cv
      ccom wceq wa wa vh wmo cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU
      cR ccn co wcel cG cU cS ccn co wcel wa cU cuni cX cF wf cU cuni cY cG wf
      wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cU
      cuni cX cF wf cG cU cS ccn co wcel cU cuni cY cG wf cR ctop wcel cU ctop
      wcel cF cU cR ccn co wcel cU cuni cX cF wf wi cS ctop wcel cU ctop wcel
      cR ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf wi cU ctop wcel cR
      ctop wcel cF cU cR ccn co wcel cU cuni cX cF wf cF cU cR cU cuni cX cU
      cuni eqid uptx.2 cnf 3expia ancoms 3adant2 cS ctop wcel cU ctop wcel cG
      cU cS ccn co wcel cU cuni cY cG wf wi cR ctop wcel cU ctop wcel cS ctop
      wcel cG cU cS ccn co wcel cU cuni cY cG wf wi cU ctop wcel cS ctop wcel
      cG cU cS ccn co wcel cU cuni cY cG wf cG cU cS cU cuni cY cU cuni eqid
      uptx.3 cnf 3expia ancoms 3adant1 anim12d imdistani vh cv cU cT ccn co
      wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa wa cU cuni cX cY cxp
      vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wi vh wal cU
      cuni cX cY cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a
      vh wmo vh cv cU cT ccn co wcel cF cP vh cv ccom wceq cG cQ vh cv ccom
      wceq wa wa vh wmo cR ctop wcel cS ctop wcel cU ctop wcel w3a cU cuni cX
      cF wf cU cuni cY cG wf wa wa vh cv cU cT ccn co wcel cF cP vh cv ccom
      wceq cG cQ vh cv ccom wceq wa wa cU cuni cX cY cxp vh cv wf cF cP vh cv
      ccom wceq cG cQ vh cv ccom wceq w3a vh immo cR ctop wcel cS ctop wcel cU
      ctop wcel w3a cU cuni cX cF wf cU cuni cY cG wf wa wa vh cv cU cT ccn co
      wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa wa cU cuni cX cY cxp
      vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a wi vh cR ctop
      wcel cS ctop wcel cU ctop wcel w3a cU cuni cX cF wf cU cuni cY cG wf wa
      wa vh cv cU cT ccn co wcel cF cP vh cv ccom wceq cG cQ vh cv ccom wceq wa
      wa cU cuni cX cY cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq
      wa wa cU cuni cX cY cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom
      wceq w3a cR ctop wcel cS ctop wcel cU ctop wcel w3a cU cuni cX cF wf cU
      cuni cY cG wf wa wa vh cv cU cT ccn co wcel cU cuni cX cY cxp vh cv wf cF
      cP vh cv ccom wceq cG cQ vh cv ccom wceq wa cR ctop wcel cS ctop wcel cU
      ctop wcel w3a vh cv cU cT ccn co wcel cU cuni cX cY cxp vh cv wf wi cU
      cuni cX cF wf cU cuni cY cG wf wa cR ctop wcel cS ctop wcel cU ctop wcel
      w3a vh cv cU cT ccn co wcel cU cuni cT cuni vh cv wf cU cuni cX cY cxp vh
      cv wf cR ctop wcel cS ctop wcel cU ctop wcel vh cv cU cT ccn co wcel cU
      cuni cT cuni vh cv wf wi cU ctop wcel cR ctop wcel cS ctop wcel wa vh cv
      cU cT ccn co wcel cU cuni cT cuni vh cv wf wi cU ctop wcel cT ctop wcel
      vh cv cU cT ccn co wcel cU cuni cT cuni vh cv wf wi cR ctop wcel cS ctop
      wcel wa cU ctop wcel cT ctop wcel vh cv cU cT ccn co wcel cU cuni cT cuni
      vh cv wf vh cv cU cT cU cuni cT cuni cU cuni eqid cT cuni eqid cnf 3expia
      cR cS cT uptx.1 txtop sylan2 ancoms 3impa cR ctop wcel cS ctop wcel cU
      ctop wcel w3a cT cuni cX cY cxp wceq cU cuni cT cuni vh cv wf cU cuni cX
      cY cxp vh cv wf wb cR ctop wcel cS ctop wcel cT cuni cX cY cxp wceq cU
      ctop wcel cR cS cT cX cY uptx.1 uptx.2 uptx.3 txuni 3adant3 cT cuni cX cY
      cxp cU cuni vh cv feq3 syl sylibd adantr anim1d cU cuni cX cY cxp vh cv
      wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq 3anass syl6ibr 19.21aiv cU
      ctop wcel cR ctop wcel cU cuni cX cF wf cU cuni cY cG wf wa cU cuni cX cY
      cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh wmo cS
      ctop wcel cU cuni cvv wcel cU cuni cX cF wf cU cuni cY cG wf wa cU cuni
      cX cY cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh wmo
      cU ctop wcel cU cuni cvv wcel cU cuni cX cF wf cU cuni cY cG wf cU cuni
      cX cY cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh wmo
      cU cuni cvv wcel cU cuni cX cF wf cU cuni cY cG wf w3a cU cuni cX cY cxp
      vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh weu cU cuni
      cX cY cxp vh cv wf cF cP vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh wmo
      cU cuni cX cY cvv cP cQ vh cF cG cP c1st cZ cres c1st cX cY cxp cres
      uptx.5 cZ cX cY cxp wceq c1st cZ cres c1st cX cY cxp cres wceq uptx.4 cZ
      cX cY cxp c1st reseq2 ax-mp eqtri cQ c2nd cZ cres c2nd cX cY cxp cres
      uptx.6 cZ cX cY cxp wceq c2nd cZ cres c2nd cX cY cxp cres wceq uptx.4 cZ
      cX cY cxp c2nd reseq2 ax-mp eqtri upxp cU cuni cX cY cxp vh cv wf cF cP
      vh cv ccom wceq cG cQ vh cv ccom wceq w3a vh eumo syl 3expb cU ctop
      uniexg sylan 3ad2antl3 sylc syl sylanbrc $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d R h x y $. $d S h x y $. $d T h x y $. $d U h x y $. $d W h x y $.
    $d X h x y $. $d Y h x y $. $d Z h x y $. $d P h x y $. $d Q h x y $.
    $d F h x y $.
    txcn.1 $e |- T = ( R tX S ) $.
    txcn.2 $e |- X = U. R $.
    txcn.3 $e |- Y = U. S $.
    txcn.4 $e |- Z = ( X X. Y ) $.
    txcn.5 $e |- W = U. U $.
    txcn.6 $e |- P = ( 1st |` Z ) $.
    txcn.7 $e |- Q = ( 2nd |` Z ) $.
    $( A map into the product of two topological spaces is continuous iff both
       of its projections are continuous.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    txcn $p |- ( ( ( R e. Top /\ S e. Top /\ U e. Top ) /\ F : W --> Z ) ->
                  ( F e. ( U Cn T ) <-> ( ( P o. F ) e. ( U Cn R ) /\
                                          ( Q o. F ) e. ( U Cn S ) ) ) ) $=
      cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa cF cU cT ccn co
      wcel cP cF ccom cU cR ccn co wcel cQ cF ccom cU cS ccn co wcel wa cR ctop
      wcel cS ctop wcel cU ctop wcel w3a cF cU cT ccn co wcel cP cF ccom cU cR
      ccn co wcel cQ cF ccom cU cS ccn co wcel wa wi cW cZ cF wf cR ctop wcel
      cS ctop wcel cU ctop wcel w3a cF cU cT ccn co wcel cP cF ccom cU cR ccn
      co wcel cQ cF ccom cU cS ccn co wcel cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cF cU cT ccn co wcel cP cT cR ccn co wcel cP cF ccom cU cR ccn
      co wcel cR ctop wcel cS ctop wcel cP cT cR ccn co wcel cU ctop wcel cR
      ctop wcel cS ctop wcel wa c1st cZ cres cT cR ccn co cP cR cS cT cX cY cZ
      txcn.1 txcn.2 txcn.3 txcn.4 tx1cn txcn.6 syl5eqel 3adant3 cU ctop wcel cT
      ctop wcel cR ctop wcel cF cU cT ccn co wcel cP cT cR ccn co wcel wa cP cF
      ccom cU cR ccn co wcel wi cR ctop wcel cS ctop wcel cU ctop wcel w3a cU
      ctop wcel cT ctop wcel cR ctop wcel w3a cF cU cT ccn co wcel cP cT cR ccn
      co wcel wa cP cF ccom cU cR ccn co wcel cF cP cU cT cR cnco ex cR ctop
      wcel cS ctop wcel cU ctop wcel 3simp3 cR ctop wcel cS ctop wcel cT ctop
      wcel cU ctop wcel cR cS cT txcn.1 txtop 3adant3 cR ctop wcel cS ctop wcel
      cU ctop wcel 3simp1 syl3anc mpan2d cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cF cU cT ccn co wcel cQ cT cS ccn co wcel cQ cF ccom cU cS ccn co
      wcel cR ctop wcel cS ctop wcel cQ cT cS ccn co wcel cU ctop wcel cR ctop
      wcel cS ctop wcel wa c2nd cZ cres cT cS ccn co cQ cR cS cT cX cY cZ
      txcn.1 txcn.2 txcn.3 txcn.4 tx2cn txcn.7 syl5eqel 3adant3 cU ctop wcel cT
      ctop wcel cS ctop wcel cF cU cT ccn co wcel cQ cT cS ccn co wcel wa cQ cF
      ccom cU cS ccn co wcel wi cR ctop wcel cS ctop wcel cU ctop wcel w3a cU
      ctop wcel cT ctop wcel cS ctop wcel w3a cF cU cT ccn co wcel cQ cT cS ccn
      co wcel wa cQ cF ccom cU cS ccn co wcel cF cQ cU cT cS cnco ex cR ctop
      wcel cS ctop wcel cU ctop wcel 3simp3 cR ctop wcel cS ctop wcel cT ctop
      wcel cU ctop wcel cR cS cT txcn.1 txtop 3adant3 cR ctop wcel cS ctop wcel
      cU ctop wcel 3simp2 syl3anc mpan2d jcad adantr cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cW cZ cF wf wa cP cF ccom cU cR ccn co wcel cQ cF ccom
      cU cS ccn co wcel wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv
      ccom wceq wa vh cU cT ccn co wrex cF cU cT ccn co wcel cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cP cF ccom cU cR ccn co wcel cQ cF ccom cU cS
      ccn co wcel wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom
      wceq wa vh cU cT ccn co wrex wi cW cZ cF wf cR ctop wcel cS ctop wcel cU
      ctop wcel w3a cP cF ccom cU cR ccn co wcel cQ cF ccom cU cS ccn co wcel
      wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa vh cU
      cT ccn co wrex cR ctop wcel cS ctop wcel cU ctop wcel w3a cP cF ccom cU
      cR ccn co wcel cQ cF ccom cU cS ccn co wcel wa wa cP cF ccom cP vh cv
      ccom wceq cQ cF ccom cQ vh cv ccom wceq wa vh cU cT ccn co wreu cP cF
      ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa vh cU cT ccn co
      wrex cP cQ cR cS cT cU vh cP cF ccom cQ cF ccom cX cY cZ txcn.1 txcn.2
      txcn.3 txcn.4 txcn.6 txcn.7 uptx cP cF ccom cP vh cv ccom wceq cQ cF ccom
      cQ vh cv ccom wceq wa vh cU cT ccn co reurex syl ex adantr cR ctop wcel
      cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa cP cF ccom cU cR ccn co wcel
      cQ cF ccom cU cS ccn co wcel wa cW cX cP cF ccom wf cW cY cQ cF ccom wf
      wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa vh cU
      cT ccn co wrex cF cU cT ccn co wcel wi cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cP cF ccom cU cR ccn co wcel cQ cF ccom cU cS ccn co wcel wa cW
      cX cP cF ccom wf cW cY cQ cF ccom wf wa wi cW cZ cF wf cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cP cF ccom cU cR ccn co wcel cW cX cP cF ccom
      wf cQ cF ccom cU cS ccn co wcel cW cY cQ cF ccom wf cR ctop wcel cU ctop
      wcel cP cF ccom cU cR ccn co wcel cW cX cP cF ccom wf wi cS ctop wcel cU
      ctop wcel cR ctop wcel cP cF ccom cU cR ccn co wcel cW cX cP cF ccom wf
      wi cU ctop wcel cR ctop wcel cP cF ccom cU cR ccn co wcel cW cX cP cF
      ccom wf cP cF ccom cU cR cW cX txcn.5 txcn.2 cnf 3expia ancoms 3adant2 cS
      ctop wcel cU ctop wcel cQ cF ccom cU cS ccn co wcel cW cY cQ cF ccom wf
      wi cR ctop wcel cU ctop wcel cS ctop wcel cQ cF ccom cU cS ccn co wcel cW
      cY cQ cF ccom wf wi cU ctop wcel cS ctop wcel cQ cF ccom cU cS ccn co
      wcel cW cY cQ cF ccom wf cQ cF ccom cU cS cW cY txcn.5 txcn.3 cnf 3expia
      ancoms 3adant1 anim12d adantr cR ctop wcel cS ctop wcel cU ctop wcel w3a
      cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa cP cF ccom cP
      vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa vh cU cT ccn co wrex cF
      cU cT ccn co wcel wi cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ cF
      wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa wa cP cF ccom cP vh cv
      ccom wceq cQ cF ccom cQ vh cv ccom wceq wa cF cU cT ccn co wcel vh cU cT
      ccn co cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa cW cX cP
      cF ccom wf cW cY cQ cF ccom wf wa wa vh cv cU cT ccn co wcel cW cX cY cxp
      vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa
      cF cU cT ccn co wcel wi cR ctop wcel cS ctop wcel cU ctop wcel w3a vh cv
      cU cT ccn co wcel cW cX cY cxp vh cv wf wi cW cZ cF wf cW cX cP cF ccom
      wf cW cY cQ cF ccom wf wa cR ctop wcel cS ctop wcel cU ctop wcel w3a vh
      cv cU cT ccn co wcel cW cT cuni vh cv wf cW cX cY cxp vh cv wf cR ctop
      wcel cS ctop wcel cU ctop wcel vh cv cU cT ccn co wcel cW cT cuni vh cv
      wf wi cU ctop wcel cR ctop wcel cS ctop wcel wa vh cv cU cT ccn co wcel
      cW cT cuni vh cv wf wi cU ctop wcel cT ctop wcel vh cv cU cT ccn co wcel
      cW cT cuni vh cv wf wi cR ctop wcel cS ctop wcel wa cU ctop wcel cT ctop
      wcel vh cv cU cT ccn co wcel cW cT cuni vh cv wf vh cv cU cT cW cT cuni
      txcn.5 cT cuni eqid cnf 3expia cR cS cT txcn.1 txtop sylan2 ancoms 3impa
      cR ctop wcel cS ctop wcel cU ctop wcel w3a cT cuni cX cY cxp wceq cW cT
      cuni vh cv wf cW cX cY cxp vh cv wf wb cR ctop wcel cS ctop wcel cT cuni
      cX cY cxp wceq cU ctop wcel cR cS cT cX cY txcn.1 txcn.2 txcn.3 txuni
      3adant3 cT cuni cX cY cxp cW vh cv feq3 syl sylibd ad2antrr cR ctop wcel
      cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ
      cF ccom wf wa wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom
      wceq wa cW cX cY cxp vh cv wf vh cv cU cT ccn co wcel cF cU cT ccn co
      wcel cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa cW cX cP
      cF ccom wf cW cY cQ cF ccom wf wa wa cP cF ccom cP vh cv ccom wceq cQ cF
      ccom cQ vh cv ccom wceq wa cW cX cY cxp vh cv wf vh cv cF wceq vh cv cU
      cT ccn co wcel cF cU cT ccn co wcel wi cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa wa cP
      cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa cW cX cY cxp
      vh cv wf vh cv cF wceq cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ
      cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa wa cP cF ccom cP vh
      cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa wa cW cX cY cxp vh cv wf wa
      cW cX cY cxp vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv
      ccom wceq w3a cW cX cY cxp cF wf cP cF ccom cP cF ccom wceq cQ cF ccom cQ
      cF ccom wceq w3a vh cv cF wceq cP cF ccom cP vh cv ccom wceq cQ cF ccom
      cQ vh cv ccom wceq wa cW cX cY cxp vh cv wf cW cX cY cxp vh cv wf cP cF
      ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq w3a cR ctop wcel cS
      ctop wcel cU ctop wcel w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF
      ccom wf wa wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq
      wa cW cX cY cxp vh cv wf wa cW cX cY cxp vh cv wf cP cF ccom cP vh cv
      ccom wceq cQ cF ccom cQ vh cv ccom wceq cP cF ccom cP vh cv ccom wceq cQ
      cF ccom cQ vh cv ccom wceq wa cW cX cY cxp vh cv wf pm3.27 cP cF ccom cP
      vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq cW cX cY cxp vh cv wf
      simpll cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq cW cX
      cY cxp vh cv wf simplr 3jca adantll cR ctop wcel cS ctop wcel cU ctop
      wcel w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa wa cW
      cX cY cxp cF wf cP cF ccom cP cF ccom wceq cQ cF ccom cQ cF ccom wceq w3a
      cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa cW cX cY
      cxp vh cv wf cW cZ cF wf cW cX cY cxp cF wf cP cF ccom cP cF ccom wceq cQ
      cF ccom cQ cF ccom wceq w3a cR ctop wcel cS ctop wcel cU ctop wcel w3a cW
      cX cP cF ccom wf cW cY cQ cF ccom wf wa cW cZ cF wf cW cX cY cxp cF wf cP
      cF ccom cP cF ccom wceq cQ cF ccom cQ cF ccom wceq cW cZ cF wf cW cX cY
      cxp cF wf cZ cX cY cxp wceq cW cZ cF wf cW cX cY cxp cF wf wb txcn.4 cZ
      cX cY cxp cW cF feq3 ax-mp biimpi cW cZ cF wf cP cF ccom eqidd cW cZ cF
      wf cQ cF ccom eqidd 3jca ad2antlr ad2antrr cR ctop wcel cS ctop wcel cU
      ctop wcel w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa
      wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa wa cW
      cX cY cxp vh cv wf wa cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom wceq
      cQ cF ccom cQ vx cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF ccom cP vy
      cv ccom wceq cQ cF ccom cQ vy cv ccom wceq w3a wa vx cv vy cv wceq wi vy
      wal vx wal cW cX cY cxp vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom
      cQ vh cv ccom wceq w3a cW cX cY cxp cF wf cP cF ccom cP cF ccom wceq cQ
      cF ccom cQ cF ccom wceq w3a wa vh cv cF wceq wi cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf
      wa wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa wa
      cW cX cY cxp vh cv wf wa cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom
      wceq cQ cF ccom cQ vx cv ccom wceq w3a vx weu cW cX cY cxp vx cv wf cP cF
      ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a cW cX cY cxp vy
      cv wf cP cF ccom cP vy cv ccom wceq cQ cF ccom cQ vy cv ccom wceq w3a wa
      vx cv vy cv wceq wi vy wal vx wal cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa wa cW cX cY
      cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq
      w3a vx weu cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa
      cW cX cY cxp vh cv wf cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cX cP
      cF ccom wf cW cY cQ cF ccom wf wa cW cX cY cxp vx cv wf cP cF ccom cP vx
      cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a vx weu cW cZ cF wf cU ctop
      wcel cR ctop wcel cW cX cP cF ccom wf cW cY cQ cF ccom wf wa cW cX cY cxp
      vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a
      vx weu cS ctop wcel cW cvv wcel cW cX cP cF ccom wf cW cY cQ cF ccom wf
      wa cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx
      cv ccom wceq w3a vx weu cU ctop wcel cW cvv wcel cW cX cP cF ccom wf cW
      cY cQ cF ccom wf cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ
      cF ccom cQ vx cv ccom wceq w3a vx weu cW cX cY cvv cP cQ vx cP cF ccom cQ
      cF ccom cP c1st cZ cres c1st cX cY cxp cres txcn.6 cZ cX cY cxp wceq c1st
      cZ cres c1st cX cY cxp cres wceq txcn.4 cZ cX cY cxp c1st reseq2 ax-mp
      eqtri cQ c2nd cZ cres c2nd cX cY cxp cres txcn.7 cZ cX cY cxp wceq c2nd
      cZ cres c2nd cX cY cxp cres wceq txcn.4 cZ cX cY cxp c2nd reseq2 ax-mp
      eqtri upxp 3expb cU ctop wcel cU cuni cvv cW cU ctop uniexg txcn.5
      syl5eqel sylan 3ad2antl3 adantlr ad2antrr cW cX cY cxp vx cv wf cP cF
      ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a vx weu cW cX cY
      cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq
      w3a vx wex cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF ccom
      cQ vx cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF ccom cP vy cv ccom
      wceq cQ cF ccom cQ vy cv ccom wceq w3a wa vx cv vy cv wceq wi vy wal vx
      wal cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx
      cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF ccom cP vy cv ccom wceq cQ
      cF ccom cQ vy cv ccom wceq w3a vx vy vx cv vy cv wceq cW cX cY cxp vx cv
      wf cW cX cY cxp vy cv wf cP cF ccom cP vx cv ccom wceq cP cF ccom cP vy
      cv ccom wceq cQ cF ccom cQ vx cv ccom wceq cQ cF ccom cQ vy cv ccom wceq
      cW cX cY cxp vx cv vy cv feq1 vx cv vy cv wceq cP vx cv ccom cP vy cv
      ccom cP cF ccom vx cv vy cv cP coeq2 eqeq2d vx cv vy cv wceq cQ vx cv
      ccom cQ vy cv ccom cQ cF ccom vx cv vy cv cQ coeq2 eqeq2d 3anbi123d eu4
      pm3.27bi syl vh cv cvv wcel cF cvv wcel cW cX cY cxp vx cv wf cP cF ccom
      cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a cW cX cY cxp vy cv
      wf cP cF ccom cP vy cv ccom wceq cQ cF ccom cQ vy cv ccom wceq w3a wa vx
      cv vy cv wceq wi vy wal vx wal cW cX cY cxp vh cv wf cP cF ccom cP vh cv
      ccom wceq cQ cF ccom cQ vh cv ccom wceq w3a cW cX cY cxp cF wf cP cF ccom
      cP cF ccom wceq cQ cF ccom cQ cF ccom wceq w3a wa vh cv cF wceq wi wi cR
      ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa cW cX cP cF ccom
      wf cW cY cQ cF ccom wf wa wa cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ
      vh cv ccom wceq wa wa cW cX cY cxp vh cv wf wa cW cX cY cxp vx cv wf cP
      cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a cW cX cY cxp
      vy cv wf cP cF ccom cP vy cv ccom wceq cQ cF ccom cQ vy cv ccom wceq w3a
      wa vx cv vy cv wceq wi cW cX cY cxp vh cv wf cP cF ccom cP vh cv ccom
      wceq cQ cF ccom cQ vh cv ccom wceq w3a cW cX cY cxp cF wf cP cF ccom cP
      cF ccom wceq cQ cF ccom cQ cF ccom wceq w3a wa vh cv cF wceq wi vx vy vh
      cv cF cvv cvv vx cv vh cv wceq cW cX cY cxp vx cv wf cP cF ccom cP vx cv
      ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF
      ccom cP vy cv ccom wceq cQ cF ccom cQ vy cv ccom wceq w3a wa vx cv vy cv
      wceq wi cW cX cY cxp vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ
      vh cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF ccom cP vy cv ccom wceq
      cQ cF ccom cQ vy cv ccom wceq w3a wa vh cv vy cv wceq wi vy cv cF wceq cW
      cX cY cxp vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom
      wceq w3a cW cX cY cxp cF wf cP cF ccom cP cF ccom wceq cQ cF ccom cQ cF
      ccom wceq w3a wa vh cv cF wceq wi vx cv vh cv wceq cW cX cY cxp vx cv wf
      cP cF ccom cP vx cv ccom wceq cQ cF ccom cQ vx cv ccom wceq w3a cW cX cY
      cxp vy cv wf cP cF ccom cP vy cv ccom wceq cQ cF ccom cQ vy cv ccom wceq
      w3a wa cW cX cY cxp vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ
      vh cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF ccom cP vy cv ccom wceq
      cQ cF ccom cQ vy cv ccom wceq w3a wa vx cv vy cv wceq vh cv vy cv wceq vx
      cv vh cv wceq cW cX cY cxp vx cv wf cP cF ccom cP vx cv ccom wceq cQ cF
      ccom cQ vx cv ccom wceq w3a cW cX cY cxp vh cv wf cP cF ccom cP vh cv
      ccom wceq cQ cF ccom cQ vh cv ccom wceq w3a cW cX cY cxp vy cv wf cP cF
      ccom cP vy cv ccom wceq cQ cF ccom cQ vy cv ccom wceq w3a vx cv vh cv
      wceq cW cX cY cxp vx cv wf cW cX cY cxp vh cv wf cP cF ccom cP vx cv ccom
      wceq cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vx cv ccom wceq cQ cF
      ccom cQ vh cv ccom wceq cW cX cY cxp vx cv vh cv feq1 vx cv vh cv wceq cP
      vx cv ccom cP vh cv ccom cP cF ccom vx cv vh cv cP coeq2 eqeq2d vx cv vh
      cv wceq cQ vx cv ccom cQ vh cv ccom cQ cF ccom vx cv vh cv cQ coeq2
      eqeq2d 3anbi123d anbi1d vx vh vy equequ1 imbi12d vy cv cF wceq cW cX cY
      cxp vh cv wf cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq
      w3a cW cX cY cxp vy cv wf cP cF ccom cP vy cv ccom wceq cQ cF ccom cQ vy
      cv ccom wceq w3a wa cW cX cY cxp vh cv wf cP cF ccom cP vh cv ccom wceq
      cQ cF ccom cQ vh cv ccom wceq w3a cW cX cY cxp cF wf cP cF ccom cP cF
      ccom wceq cQ cF ccom cQ cF ccom wceq w3a wa vh cv vy cv wceq vh cv cF
      wceq vy cv cF wceq cW cX cY cxp vy cv wf cP cF ccom cP vy cv ccom wceq cQ
      cF ccom cQ vy cv ccom wceq w3a cW cX cY cxp cF wf cP cF ccom cP cF ccom
      wceq cQ cF ccom cQ cF ccom wceq w3a cW cX cY cxp vh cv wf cP cF ccom cP
      vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq w3a vy cv cF wceq cW cX cY
      cxp vy cv wf cW cX cY cxp cF wf cP cF ccom cP vy cv ccom wceq cP cF ccom
      cP cF ccom wceq cQ cF ccom cQ vy cv ccom wceq cQ cF ccom cQ cF ccom wceq
      cW cX cY cxp vy cv cF feq1 vy cv cF wceq cP vy cv ccom cP cF ccom cP cF
      ccom vy cv cF cP coeq2 eqeq2d vy cv cF wceq cQ vy cv ccom cQ cF ccom cQ
      cF ccom vy cv cF cQ coeq2 eqeq2d 3anbi123d anbi2d vy cv cF vh cv eqeq2
      imbi12d sylan9bb cla42gv vh visset cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cW cZ cF wf wa cW cX cP cF ccom wf cW cY cQ cF ccom wf wa wa cF cvv
      wcel cP cF ccom cP vh cv ccom wceq cQ cF ccom cQ vh cv ccom wceq wa cW cX
      cY cxp vh cv wf cR ctop wcel cS ctop wcel cU ctop wcel w3a cW cZ cF wf wa
      cF cvv wcel cW cX cP cF ccom wf cW cY cQ cF ccom wf wa cU ctop wcel cR
      ctop wcel cW cZ cF wf cF cvv wcel cS ctop wcel cW cZ cF wf cU ctop wcel
      cF cvv wcel cW cZ cF wf cW cvv wcel cF cvv wcel cU ctop wcel cW cZ cvv cF
      fex cU ctop wcel cU cuni cvv cW cU ctop uniexg txcn.5 syl5eqel sylan2
      ancoms 3ad2antl3 adantr ad2antrr sylancr mpd mp2and exp31 vh cv cF wceq
      vh cv cU cT ccn co wcel cF cU cT ccn co wcel vh cv cF cU cT ccn co eleq1
      biimpd syl8 com24 mpdd r19.23adv ex syld mpdd impbid $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d T x y z $. $d R x y z $. $d S x y z $. $d U x y z $.
    $d W x y z $. $d F x y z $. $d G x y z $. $d H z $.
    txcnopab.1 $e |- T = ( R tX S ) $.
    txcnopab.2 $e |- W = U. U $.
    txcnopab.3 $e |- H = { <. x , y >. | ( x e. W /\
                                      y = <. ( F ` x ) , ( G ` x ) >. ) } $.
    $( A map into the product of two topological spaces is continuous if both
       of its projections are continuous. (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    txcnopab $p |- ( ( ( R e. Top /\ S e. Top /\ U e. Top ) /\
                ( F e. ( U Cn R ) /\ G e. ( U Cn S ) ) )
                 -> H e. ( U Cn T ) ) $=
      cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS
      ccn co wcel wa wa cH cU cT ccn co wcel c1st cR cuni cS cuni cxp cres cH
      ccom cU cR ccn co wcel c2nd cR cuni cS cuni cxp cres cH ccom cU cS ccn co
      wcel wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel
      cG cU cS ccn co wcel wa wa cW cR cuni cF wf cW cS cuni cG wf wa c1st cR
      cuni cS cuni cxp cres cH ccom cU cR ccn co wcel c2nd cR cuni cS cuni cxp
      cres cH ccom cU cS ccn co wcel wa cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa cW cR cuni cF wf cW cS
      cuni cG wf wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co
      wcel cW cR cuni cF wf cG cU cS ccn co wcel cW cS cuni cG wf cR ctop wcel
      cU ctop wcel cF cU cR ccn co wcel cW cR cuni cF wf wi cS ctop wcel cU
      ctop wcel cR ctop wcel cF cU cR ccn co wcel cW cR cuni cF wf wi cU ctop
      wcel cR ctop wcel cF cU cR ccn co wcel cW cR cuni cF wf cF cU cR cW cR
      cuni txcnopab.2 cR cuni eqid cnf 3expia ancoms 3adant2 cS ctop wcel cU
      ctop wcel cG cU cS ccn co wcel cW cS cuni cG wf wi cR ctop wcel cU ctop
      wcel cS ctop wcel cG cU cS ccn co wcel cW cS cuni cG wf wi cU ctop wcel
      cS ctop wcel cG cU cS ccn co wcel cW cS cuni cG wf cG cU cS cW cS cuni
      txcnopab.2 cS cuni eqid cnf 3expia ancoms 3adant1 anim12d imp cF cU cR
      ccn co wcel cG cU cS ccn co wcel wa cW cR cuni cF wf cW cS cuni cG wf wa
      c1st cR cuni cS cuni cxp cres cH ccom cU cR ccn co wcel c2nd cR cuni cS
      cuni cxp cres cH ccom cU cS ccn co wcel wa wi cR ctop wcel cS ctop wcel
      cU ctop wcel w3a cW cR cuni cF wf cW cS cuni cG wf wa c1st cR cuni cS
      cuni cxp cres cH ccom cU cR ccn co wcel c2nd cR cuni cS cuni cxp cres cH
      ccom cU cS ccn co wcel wa cF cU cR ccn co wcel cG cU cS ccn co wcel wa cW
      cR cuni cF wf cW cS cuni cG wf wa c1st cR cuni cS cuni cxp cres cH ccom
      cU cR ccn co wcel cF cU cR ccn co wcel c2nd cR cuni cS cuni cxp cres cH
      ccom cU cS ccn co wcel cG cU cS ccn co wcel cW cR cuni cF wf cW cS cuni
      cG wf wa c1st cR cuni cS cuni cxp cres cH ccom cF cU cR ccn co cW cR cuni
      cF wf cW cS cuni cG wf wa c1st cR cuni cS cuni cxp cres cH ccom cF wceq
      cW cW wceq vz cv c1st cR cuni cS cuni cxp cres cH ccom cfv vz cv cF cfv
      wceq vz cW wral wa cW cR cuni cF wf cW cS cuni cG wf wa cW cW wceq vz cv
      c1st cR cuni cS cuni cxp cres cH ccom cfv vz cv cF cfv wceq vz cW wral cW
      cR cuni cF wf cW cS cuni cG wf wa cW eqidd cW cR cuni cF wf cW cS cuni cG
      wf wa vz cv c1st cR cuni cS cuni cxp cres cH ccom cfv vz cv cF cfv wceq
      vz cW cW cR cuni cF wf cW cS cuni cG wf wa vz cv cW wcel wa vz cv c1st cR
      cuni cS cuni cxp cres cH ccom cfv vz cv cH cfv c1st cR cuni cS cuni cxp
      cres cfv vz cv cF cfv vz cv cG cfv cop c1st cR cuni cS cuni cxp cres cfv
      vz cv cF cfv c1st cR cuni cS cuni cxp cres wfun cH wfun vz cv cH cdm wcel
      vz cv c1st cR cuni cS cuni cxp cres cH ccom cfv vz cv cH cfv c1st cR cuni
      cS cuni cxp cres cfv wceq cW cR cuni cF wf cW cS cuni cG wf wa vz cv cW
      wcel wa vz cv c1st cR cuni cS cuni cxp cres cH fvco c1st cR cuni cS cuni
      cxp cres wfun cW cR cuni cF wf cW cS cuni cG wf wa vz cv cW wcel wa c1st
      cR cuni cS cuni cxp cres cR cuni cS cuni cxp wfn c1st cR cuni cS cuni cxp
      cres wfun c1st cvv wfn cR cuni cS cuni cxp cvv wss c1st cR cuni cS cuni
      cxp cres cR cuni cS cuni cxp wfn cvv cvv c1st wfo c1st cvv wfn fo1st cvv
      cvv c1st fofn ax-mp cR cuni cS cuni cxp ssv cvv cR cuni cS cuni cxp c1st
      fnssres mp2an cR cuni cS cuni cxp c1st cR cuni cS cuni cxp cres fnfun
      ax-mp a1i cW cR cuni cF wf cW cS cuni cG wf wa vz cv cW wcel wa cW cR
      cuni cS cuni cxp cH wf cH wfun cW cR cuni cF wf cW cS cuni cG wf wa cW cR
      cuni cS cuni cxp cH wf vz cv cW wcel cW cR cuni cF wf cW cS cuni cG wf wa
      vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cW wral cW cR
      cuni cS cuni cxp cH wf cW cR cuni cF wf cW cS cuni cG wf wa vx cv cF cfv
      vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cW cW cR cuni cF wf cW cS
      cuni cG wf vx cv cW wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni
      cxp wcel vx cv cF cfv cR cuni wcel vx cv cG cfv cS cuni wcel vx cv cF cfv
      vx cv cG cfv cop cR cuni cS cuni cxp wcel cW cR cuni cF wf vx cv cW wcel
      wa cW cS cuni cG wf vx cv cW wcel wa vx cv cF cfv vx cv cG cfv cR cuni cS
      cuni opelxpi cW cR cuni vx cv cF ffvelrn cW cS cuni vx cv cG ffvelrn
      syl2an anandirs r19.21aiva vx vy cW cR cuni cS cuni cxp vx cv cF cfv vx
      cv cG cfv cop cH txcnopab.3 fopab2 sylib adantr cW cR cuni cS cuni cxp cH
      ffun syl cW cR cuni cF wf cW cS cuni cG wf wa vz cv cH cdm wcel vz cv cW
      wcel cW cR cuni cF wf cW cS cuni cG wf wa cH cdm cW vz cv cW cR cuni cF
      wf cW cS cuni cG wf wa cW cR cuni cS cuni cxp cH wf cH cdm cW wceq cW cR
      cuni cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS
      cuni cxp wcel vx cW wral cW cR cuni cS cuni cxp cH wf cW cR cuni cF wf cW
      cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel
      vx cW cW cR cuni cF wf cW cS cuni cG wf vx cv cW wcel vx cv cF cfv vx cv
      cG cfv cop cR cuni cS cuni cxp wcel vx cv cF cfv cR cuni wcel vx cv cG
      cfv cS cuni wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel
      cW cR cuni cF wf vx cv cW wcel wa cW cS cuni cG wf vx cv cW wcel wa vx cv
      cF cfv vx cv cG cfv cR cuni cS cuni opelxpi cW cR cuni vx cv cF ffvelrn
      cW cS cuni vx cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cW cR cuni
      cS cuni cxp vx cv cF cfv vx cv cG cfv cop cH txcnopab.3 fopab2 sylib cW
      cR cuni cS cuni cxp cH fdm syl eleq2d biimpar syl3anc cW cR cuni cF wf cW
      cS cuni cG wf wa vz cv cW wcel wa vz cv cH cfv vz cv cF cfv vz cv cG cfv
      cop c1st cR cuni cS cuni cxp cres vz cv cW wcel vz cv cH cfv vz cv cF cfv
      vz cv cG cfv cop wceq cW cR cuni cF wf cW cS cuni cG wf wa vx vy vz cv vx
      cv cF cfv vx cv cG cfv cop vz cv cF cfv vz cv cG cfv cop cW cH vx cv vz
      cv wceq vx cv cF cfv vz cv cF cfv vx cv cG cfv vz cv cG cfv vx cv vz cv
      cF fveq2 vx cv vz cv cG fveq2 opeq12d txcnopab.3 vz cv cF cfv vz cv cG
      cfv opex fvopab4 adantl fveq2d cW cR cuni cF wf cW cS cuni cG wf wa vz cv
      cW wcel wa vz cv cF cfv vz cv cG cfv cop c1st cR cuni cS cuni cxp cres
      cfv vz cv cF cfv vz cv cG cfv cop c1st cfv vz cv cF cfv cW cR cuni cF wf
      cW cS cuni cG wf wa vz cv cW wcel wa vz cv cF cfv vz cv cG cfv cop cR
      cuni cS cuni cxp wcel vz cv cF cfv vz cv cG cfv cop c1st cR cuni cS cuni
      cxp cres cfv vz cv cF cfv vz cv cG cfv cop c1st cfv wceq cW cR cuni cF wf
      cW cS cuni cG wf vz cv cW wcel vz cv cF cfv vz cv cG cfv cop cR cuni cS
      cuni cxp wcel vz cv cF cfv cR cuni wcel vz cv cG cfv cS cuni wcel vz cv
      cF cfv vz cv cG cfv cop cR cuni cS cuni cxp wcel cW cR cuni cF wf vz cv
      cW wcel wa cW cS cuni cG wf vz cv cW wcel wa vz cv cF cfv vz cv cG cfv cR
      cuni cS cuni opelxpi cW cR cuni vz cv cF ffvelrn cW cS cuni vz cv cG
      ffvelrn syl2an anandirs vz cv cF cfv vz cv cG cfv cop cR cuni cS cuni cxp
      c1st fvres syl vz cv cF cfv vz cv cG cfv vz cv cF fvex op1st syl6eq
      3eqtrd r19.21aiva jca c1st cR cuni cS cuni cxp cres cH ccom cW wfn cF cW
      wfn c1st cR cuni cS cuni cxp cres cH ccom cF wceq cW cW wceq vz cv c1st
      cR cuni cS cuni cxp cres cH ccom cfv vz cv cF cfv wceq vz cW wral wa wb
      cW cR cuni cF wf cW cS cuni cG wf wa vz cW cW c1st cR cuni cS cuni cxp
      cres cH ccom cF eqfnfv c1st cR cuni cS cuni cxp cres cR cuni cS cuni cxp
      wfn cH cW wfn cH crn cR cuni cS cuni cxp wss c1st cR cuni cS cuni cxp
      cres cH ccom cW wfn cW cR cuni cF wf cW cS cuni cG wf wa cR cuni cS cuni
      cxp cW c1st cR cuni cS cuni cxp cres cH fnco c1st cR cuni cS cuni cxp
      cres cR cuni cS cuni cxp wfn cW cR cuni cF wf cW cS cuni cG wf wa c1st
      cvv wfn cR cuni cS cuni cxp cvv wss c1st cR cuni cS cuni cxp cres cR cuni
      cS cuni cxp wfn cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn
      ax-mp cR cuni cS cuni cxp ssv cvv cR cuni cS cuni cxp c1st fnssres mp2an
      a1i cW cR cuni cF wf cW cS cuni cG wf wa cW cR cuni cS cuni cxp cH wf cH
      cW wfn cW cR cuni cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop
      cR cuni cS cuni cxp wcel vx cW wral cW cR cuni cS cuni cxp cH wf cW cR
      cuni cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS
      cuni cxp wcel vx cW cW cR cuni cF wf cW cS cuni cG wf vx cv cW wcel vx cv
      cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cv cF cfv cR cuni
      wcel vx cv cG cfv cS cuni wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS
      cuni cxp wcel cW cR cuni cF wf vx cv cW wcel wa cW cS cuni cG wf vx cv cW
      wcel wa vx cv cF cfv vx cv cG cfv cR cuni cS cuni opelxpi cW cR cuni vx
      cv cF ffvelrn cW cS cuni vx cv cG ffvelrn syl2an anandirs r19.21aiva vx
      vy cW cR cuni cS cuni cxp vx cv cF cfv vx cv cG cfv cop cH txcnopab.3
      fopab2 sylib cW cR cuni cS cuni cxp cH ffn syl cW cR cuni cF wf cW cS
      cuni cG wf wa cW cR cuni cS cuni cxp cH wf cH crn cR cuni cS cuni cxp wss
      cW cR cuni cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR
      cuni cS cuni cxp wcel vx cW wral cW cR cuni cS cuni cxp cH wf cW cR cuni
      cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni
      cxp wcel vx cW cW cR cuni cF wf cW cS cuni cG wf vx cv cW wcel vx cv cF
      cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cv cF cfv cR cuni wcel
      vx cv cG cfv cS cuni wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni
      cxp wcel cW cR cuni cF wf vx cv cW wcel wa cW cS cuni cG wf vx cv cW wcel
      wa vx cv cF cfv vx cv cG cfv cR cuni cS cuni opelxpi cW cR cuni vx cv cF
      ffvelrn cW cS cuni vx cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cW
      cR cuni cS cuni cxp vx cv cF cfv vx cv cG cfv cop cH txcnopab.3 fopab2
      sylib cW cR cuni cS cuni cxp cH frn syl syl3anc cW cR cuni cF wf cF cW
      wfn cW cS cuni cG wf cW cR cuni cF ffn adantr sylanc mpbird eleq1d cW cR
      cuni cF wf cW cS cuni cG wf wa c2nd cR cuni cS cuni cxp cres cH ccom cG
      cU cS ccn co cW cR cuni cF wf cW cS cuni cG wf wa c2nd cR cuni cS cuni
      cxp cres cH ccom cG wceq cW cW wceq vz cv c2nd cR cuni cS cuni cxp cres
      cH ccom cfv vz cv cG cfv wceq vz cW wral wa cW cR cuni cF wf cW cS cuni
      cG wf wa cW cW wceq vz cv c2nd cR cuni cS cuni cxp cres cH ccom cfv vz cv
      cG cfv wceq vz cW wral cW cR cuni cF wf cW cS cuni cG wf wa cW eqidd cW
      cR cuni cF wf cW cS cuni cG wf wa vz cv c2nd cR cuni cS cuni cxp cres cH
      ccom cfv vz cv cG cfv wceq vz cW cW cR cuni cF wf cW cS cuni cG wf wa vz
      cv cW wcel wa vz cv c2nd cR cuni cS cuni cxp cres cH ccom cfv vz cv cH
      cfv c2nd cR cuni cS cuni cxp cres cfv vz cv cF cfv vz cv cG cfv cop c2nd
      cR cuni cS cuni cxp cres cfv vz cv cG cfv c2nd cR cuni cS cuni cxp cres
      wfun cH wfun vz cv cH cdm wcel vz cv c2nd cR cuni cS cuni cxp cres cH
      ccom cfv vz cv cH cfv c2nd cR cuni cS cuni cxp cres cfv wceq cW cR cuni
      cF wf cW cS cuni cG wf wa vz cv cW wcel wa vz cv c2nd cR cuni cS cuni cxp
      cres cH fvco c2nd cR cuni cS cuni cxp cres wfun cW cR cuni cF wf cW cS
      cuni cG wf wa vz cv cW wcel wa c2nd cR cuni cS cuni cxp cres cR cuni cS
      cuni cxp wfn c2nd cR cuni cS cuni cxp cres wfun c2nd cvv wfn cR cuni cS
      cuni cxp cvv wss c2nd cR cuni cS cuni cxp cres cR cuni cS cuni cxp wfn
      cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cR cuni cS
      cuni cxp ssv cvv cR cuni cS cuni cxp c2nd fnssres mp2an cR cuni cS cuni
      cxp c2nd cR cuni cS cuni cxp cres fnfun ax-mp a1i cW cR cuni cF wf cW cS
      cuni cG wf wa vz cv cW wcel wa cW cR cuni cS cuni cxp cH wf cH wfun cW cR
      cuni cF wf cW cS cuni cG wf wa cW cR cuni cS cuni cxp cH wf vz cv cW wcel
      cW cR cuni cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR
      cuni cS cuni cxp wcel vx cW wral cW cR cuni cS cuni cxp cH wf cW cR cuni
      cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni
      cxp wcel vx cW cW cR cuni cF wf cW cS cuni cG wf vx cv cW wcel vx cv cF
      cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cv cF cfv cR cuni wcel
      vx cv cG cfv cS cuni wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni
      cxp wcel cW cR cuni cF wf vx cv cW wcel wa cW cS cuni cG wf vx cv cW wcel
      wa vx cv cF cfv vx cv cG cfv cR cuni cS cuni opelxpi cW cR cuni vx cv cF
      ffvelrn cW cS cuni vx cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cW
      cR cuni cS cuni cxp vx cv cF cfv vx cv cG cfv cop cH txcnopab.3 fopab2
      sylib adantr cW cR cuni cS cuni cxp cH ffun syl cW cR cuni cF wf cW cS
      cuni cG wf wa vz cv cH cdm wcel vz cv cW wcel cW cR cuni cF wf cW cS cuni
      cG wf wa cH cdm cW vz cv cW cR cuni cF wf cW cS cuni cG wf wa cW cR cuni
      cS cuni cxp cH wf cH cdm cW wceq cW cR cuni cF wf cW cS cuni cG wf wa vx
      cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cW wral cW cR cuni
      cS cuni cxp cH wf cW cR cuni cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv
      cG cfv cop cR cuni cS cuni cxp wcel vx cW cW cR cuni cF wf cW cS cuni cG
      wf vx cv cW wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel
      vx cv cF cfv cR cuni wcel vx cv cG cfv cS cuni wcel vx cv cF cfv vx cv cG
      cfv cop cR cuni cS cuni cxp wcel cW cR cuni cF wf vx cv cW wcel wa cW cS
      cuni cG wf vx cv cW wcel wa vx cv cF cfv vx cv cG cfv cR cuni cS cuni
      opelxpi cW cR cuni vx cv cF ffvelrn cW cS cuni vx cv cG ffvelrn syl2an
      anandirs r19.21aiva vx vy cW cR cuni cS cuni cxp vx cv cF cfv vx cv cG
      cfv cop cH txcnopab.3 fopab2 sylib cW cR cuni cS cuni cxp cH fdm syl
      eleq2d biimpar syl3anc cW cR cuni cF wf cW cS cuni cG wf wa vz cv cW wcel
      wa vz cv cH cfv vz cv cF cfv vz cv cG cfv cop c2nd cR cuni cS cuni cxp
      cres vz cv cW wcel vz cv cH cfv vz cv cF cfv vz cv cG cfv cop wceq cW cR
      cuni cF wf cW cS cuni cG wf wa vx vy vz cv vx cv cF cfv vx cv cG cfv cop
      vz cv cF cfv vz cv cG cfv cop cW cH vx cv vz cv wceq vx cv cF cfv vz cv
      cF cfv vx cv cG cfv vz cv cG cfv vx cv vz cv cF fveq2 vx cv vz cv cG
      fveq2 opeq12d txcnopab.3 vz cv cF cfv vz cv cG cfv opex fvopab4 adantl
      fveq2d cW cR cuni cF wf cW cS cuni cG wf wa vz cv cW wcel wa vz cv cF cfv
      vz cv cG cfv cop c2nd cR cuni cS cuni cxp cres cfv vz cv cF cfv vz cv cG
      cfv cop c2nd cfv vz cv cG cfv cW cR cuni cF wf cW cS cuni cG wf wa vz cv
      cW wcel wa vz cv cF cfv vz cv cG cfv cop cR cuni cS cuni cxp wcel vz cv
      cF cfv vz cv cG cfv cop c2nd cR cuni cS cuni cxp cres cfv vz cv cF cfv vz
      cv cG cfv cop c2nd cfv wceq cW cR cuni cF wf cW cS cuni cG wf vz cv cW
      wcel vz cv cF cfv vz cv cG cfv cop cR cuni cS cuni cxp wcel vz cv cF cfv
      cR cuni wcel vz cv cG cfv cS cuni wcel vz cv cF cfv vz cv cG cfv cop cR
      cuni cS cuni cxp wcel cW cR cuni cF wf vz cv cW wcel wa cW cS cuni cG wf
      vz cv cW wcel wa vz cv cF cfv vz cv cG cfv cR cuni cS cuni opelxpi cW cR
      cuni vz cv cF ffvelrn cW cS cuni vz cv cG ffvelrn syl2an anandirs vz cv
      cF cfv vz cv cG cfv cop cR cuni cS cuni cxp c2nd fvres syl vz cv cF cfv
      vz cv cG cfv vz cv cF fvex vz cv cG fvex op2nd syl6eq 3eqtrd r19.21aiva
      jca c2nd cR cuni cS cuni cxp cres cH ccom cW wfn cG cW wfn c2nd cR cuni
      cS cuni cxp cres cH ccom cG wceq cW cW wceq vz cv c2nd cR cuni cS cuni
      cxp cres cH ccom cfv vz cv cG cfv wceq vz cW wral wa wb cW cR cuni cF wf
      cW cS cuni cG wf wa vz cW cW c2nd cR cuni cS cuni cxp cres cH ccom cG
      eqfnfv c2nd cR cuni cS cuni cxp cres cR cuni cS cuni cxp wfn cH cW wfn cH
      crn cR cuni cS cuni cxp wss c2nd cR cuni cS cuni cxp cres cH ccom cW wfn
      cW cR cuni cF wf cW cS cuni cG wf wa cR cuni cS cuni cxp cW c2nd cR cuni
      cS cuni cxp cres cH fnco c2nd cR cuni cS cuni cxp cres cR cuni cS cuni
      cxp wfn cW cR cuni cF wf cW cS cuni cG wf wa c2nd cvv wfn cR cuni cS cuni
      cxp cvv wss c2nd cR cuni cS cuni cxp cres cR cuni cS cuni cxp wfn cvv cvv
      c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cR cuni cS cuni cxp
      ssv cvv cR cuni cS cuni cxp c2nd fnssres mp2an a1i cW cR cuni cF wf cW cS
      cuni cG wf wa cW cR cuni cS cuni cxp cH wf cH cW wfn cW cR cuni cF wf cW
      cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel
      vx cW wral cW cR cuni cS cuni cxp cH wf cW cR cuni cF wf cW cS cuni cG wf
      wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cW cW cR
      cuni cF wf cW cS cuni cG wf vx cv cW wcel vx cv cF cfv vx cv cG cfv cop
      cR cuni cS cuni cxp wcel vx cv cF cfv cR cuni wcel vx cv cG cfv cS cuni
      wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel cW cR cuni cF
      wf vx cv cW wcel wa cW cS cuni cG wf vx cv cW wcel wa vx cv cF cfv vx cv
      cG cfv cR cuni cS cuni opelxpi cW cR cuni vx cv cF ffvelrn cW cS cuni vx
      cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cW cR cuni cS cuni cxp vx
      cv cF cfv vx cv cG cfv cop cH txcnopab.3 fopab2 sylib cW cR cuni cS cuni
      cxp cH ffn syl cW cR cuni cF wf cW cS cuni cG wf wa cW cR cuni cS cuni
      cxp cH wf cH crn cR cuni cS cuni cxp wss cW cR cuni cF wf cW cS cuni cG
      wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cW wral
      cW cR cuni cS cuni cxp cH wf cW cR cuni cF wf cW cS cuni cG wf wa vx cv
      cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx cW cW cR cuni cF wf
      cW cS cuni cG wf vx cv cW wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS
      cuni cxp wcel vx cv cF cfv cR cuni wcel vx cv cG cfv cS cuni wcel vx cv
      cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel cW cR cuni cF wf vx cv
      cW wcel wa cW cS cuni cG wf vx cv cW wcel wa vx cv cF cfv vx cv cG cfv cR
      cuni cS cuni opelxpi cW cR cuni vx cv cF ffvelrn cW cS cuni vx cv cG
      ffvelrn syl2an anandirs r19.21aiva vx vy cW cR cuni cS cuni cxp vx cv cF
      cfv vx cv cG cfv cop cH txcnopab.3 fopab2 sylib cW cR cuni cS cuni cxp cH
      frn syl syl3anc cW cS cuni cG wf cG cW wfn cW cR cuni cF wf cW cS cuni cG
      ffn adantl sylanc mpbird eleq1d anbi12d biimprcd adantl mpd cR ctop wcel
      cS ctop wcel cU ctop wcel w3a cF cU cR ccn co wcel cG cU cS ccn co wcel
      wa cW cR cuni cS cuni cxp cH wf cH cU cT ccn co wcel c1st cR cuni cS cuni
      cxp cres cH ccom cU cR ccn co wcel c2nd cR cuni cS cuni cxp cres cH ccom
      cU cS ccn co wcel wa wb cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU
      cR ccn co wcel cG cU cS ccn co wcel wa wa cW cR cuni cF wf cW cS cuni cG
      wf wa cW cR cuni cS cuni cxp cH wf cR ctop wcel cS ctop wcel cU ctop wcel
      w3a cF cU cR ccn co wcel cG cU cS ccn co wcel wa cW cR cuni cF wf cW cS
      cuni cG wf wa cR ctop wcel cS ctop wcel cU ctop wcel w3a cF cU cR ccn co
      wcel cW cR cuni cF wf cG cU cS ccn co wcel cW cS cuni cG wf cR ctop wcel
      cU ctop wcel cF cU cR ccn co wcel cW cR cuni cF wf wi cS ctop wcel cU
      ctop wcel cR ctop wcel cF cU cR ccn co wcel cW cR cuni cF wf wi cU ctop
      wcel cR ctop wcel cF cU cR ccn co wcel cW cR cuni cF wf cF cU cR cW cR
      cuni txcnopab.2 cR cuni eqid cnf 3expia ancoms 3adant2 cS ctop wcel cU
      ctop wcel cG cU cS ccn co wcel cW cS cuni cG wf wi cR ctop wcel cU ctop
      wcel cS ctop wcel cG cU cS ccn co wcel cW cS cuni cG wf wi cU ctop wcel
      cS ctop wcel cG cU cS ccn co wcel cW cS cuni cG wf cG cU cS cW cS cuni
      txcnopab.2 cS cuni eqid cnf 3expia ancoms 3adant1 anim12d imp cW cR cuni
      cF wf cW cS cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni
      cxp wcel vx cW wral cW cR cuni cS cuni cxp cH wf cW cR cuni cF wf cW cS
      cuni cG wf wa vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel vx
      cW cW cR cuni cF wf cW cS cuni cG wf vx cv cW wcel vx cv cF cfv vx cv cG
      cfv cop cR cuni cS cuni cxp wcel vx cv cF cfv cR cuni wcel vx cv cG cfv
      cS cuni wcel vx cv cF cfv vx cv cG cfv cop cR cuni cS cuni cxp wcel cW cR
      cuni cF wf vx cv cW wcel wa cW cS cuni cG wf vx cv cW wcel wa vx cv cF
      cfv vx cv cG cfv cR cuni cS cuni opelxpi cW cR cuni vx cv cF ffvelrn cW
      cS cuni vx cv cG ffvelrn syl2an anandirs r19.21aiva vx vy cW cR cuni cS
      cuni cxp vx cv cF cfv vx cv cG cfv cop cH txcnopab.3 fopab2 sylib syl
      c1st cR cuni cS cuni cxp cres c2nd cR cuni cS cuni cxp cres cR cS cT cU
      cH cW cR cuni cS cuni cR cuni cS cuni cxp txcnopab.1 cR cuni eqid cS cuni
      eqid cR cuni cS cuni cxp eqid txcnopab.2 c1st cR cuni cS cuni cxp cres
      eqid c2nd cR cuni cS cuni cxp cres eqid txcn syldan mpbird $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d R w x y z $. $d S w x y z $. $d T w x y z $. $d X w x y z $.
    $d Y w x y z $. $d J w x y z $. $d K w x y z $. $d L w x y z $.
    $d F w x y z $. $d G w x y z $. $d H w $.
    2txcn.1 $e |- T = ( R tX S ) $.
    2txcn.2 $e |- L = ( J tX K ) $.
    2txcn.3 $e |- X = U. R $.
    2txcn.4 $e |- Y = U. S $.
    2txcn.5 $e |- H = { <. <. x , y >. , z >. | ( ( x e. X /\ y e. Y )
                                  /\ z = <. ( F ` x ) , ( G ` y ) >. ) } $.
    $( The product map between two topological product spaces is continuous.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    2txcn $p |- ( ( ( R e. Top /\ S e. Top ) /\ ( J e. Top /\ K e. Top ) /\
            ( F e. ( R Cn J ) /\ G e. ( S Cn K ) ) ) -> H e. ( T Cn L ) ) $=
      cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co
      wcel cG cS cK ccn co wcel wa w3a cH vw cv cT cuni wcel vz cv vw cv cF
      c1st cX cY cxp cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop
      wceq wa vw vz copab cT cL ccn co cR ctop wcel cS ctop wcel wa cJ ctop
      wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa w3a vw
      cv cX cY cxp wcel vz cv vw cv c1st cfv cF cfv vw cv c2nd cfv cG cfv cop
      wceq wa vw vz copab vw cv cT cuni wcel vz cv vw cv cF c1st cX cY cxp cres
      ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop wceq wa vw vz copab cH
      cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co
      wcel cG cS cK ccn co wcel wa w3a vw cv cX cY cxp wcel vz cv vw cv c1st
      cfv cF cfv vw cv c2nd cfv cG cfv cop wceq wa vw cv cT cuni wcel vz cv vw
      cv cF c1st cX cY cxp cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv
      cop wceq wa vw vz cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel
      wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa w3a vw cv cX cY cxp wcel
      vz cv vw cv c1st cfv cF cfv vw cv c2nd cfv cG cfv cop wceq wa vw cv cX cY
      cxp wcel vz cv vw cv cF c1st cX cY cxp cres ccom cfv vw cv cG c2nd cX cY
      cxp cres ccom cfv cop wceq wa vw cv cT cuni wcel vz cv vw cv cF c1st cX
      cY cxp cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop wceq wa cR
      ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co
      wcel cG cS cK ccn co wcel wa w3a vw cv cX cY cxp wcel vz cv vw cv c1st
      cfv cF cfv vw cv c2nd cfv cG cfv cop wceq vz cv vw cv cF c1st cX cY cxp
      cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop wceq cR ctop wcel
      cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS
      cK ccn co wcel wa w3a vw cv cX cY cxp wcel wa vw cv c1st cfv cF cfv vw cv
      c2nd cfv cG cfv cop vw cv cF c1st cX cY cxp cres ccom cfv vw cv cG c2nd
      cX cY cxp cres ccom cfv cop vz cv cX cJ cuni cF wf cY cK cuni cG wf wa vw
      cv cX cY cxp wcel vw cv c1st cfv cF cfv vw cv c2nd cfv cG cfv cop vw cv
      cF c1st cX cY cxp cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop
      wceq cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ
      ccn co wcel cG cS cK ccn co wcel wa w3a cX cJ cuni cF wf cY cK cuni cG wf
      wa vw cv cX cY cxp wcel wa vw cv c1st cfv cF cfv vw cv cF c1st cX cY cxp
      cres ccom cfv vw cv c2nd cfv cG cfv vw cv cG c2nd cX cY cxp cres ccom cfv
      cX cJ cuni cF wf cY cK cuni cG wf wa vw cv cX cY cxp wcel wa vw cv cF
      c1st cX cY cxp cres ccom cfv vw cv c1st cX cY cxp cres cfv cF cfv vw cv
      c1st cfv cF cfv cF wfun c1st cX cY cxp cres wfun vw cv c1st cX cY cxp
      cres cdm wcel vw cv cF c1st cX cY cxp cres ccom cfv vw cv c1st cX cY cxp
      cres cfv cF cfv wceq cX cJ cuni cF wf cY cK cuni cG wf wa vw cv cX cY cxp
      wcel wa vw cv cF c1st cX cY cxp cres fvco cX cJ cuni cF wf cF wfun cY cK
      cuni cG wf vw cv cX cY cxp wcel cX cJ cuni cF ffun ad2antrr c1st cX cY
      cxp cres wfun cX cJ cuni cF wf cY cK cuni cG wf wa vw cv cX cY cxp wcel
      wa c1st cX cY cxp cres cX cY cxp wfn c1st cX cY cxp cres wfun c1st cvv
      wfn cX cY cxp cvv wss c1st cX cY cxp cres cX cY cxp wfn cvv cvv c1st wfo
      c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp cX cY cxp ssv cvv cX cY cxp
      c1st fnssres mp2an cX cY cxp c1st cX cY cxp cres fnfun ax-mp a1i vw cv cX
      cY cxp wcel vw cv c1st cX cY cxp cres cdm wcel cX cJ cuni cF wf cY cK
      cuni cG wf wa vw cv c1st cX cY cxp cres cdm wcel vw cv cX cY cxp wcel
      c1st cX cY cxp cres cdm cX cY cxp vw cv c1st cX cY cxp cres cX cY cxp wfn
      c1st cX cY cxp cres cdm cX cY cxp wceq c1st cvv wfn cX cY cxp cvv wss
      c1st cX cY cxp cres cX cY cxp wfn cvv cvv c1st wfo c1st cvv wfn fo1st cvv
      cvv c1st fofn ax-mp cX cY cxp ssv cvv cX cY cxp c1st fnssres mp2an cX cY
      cxp c1st cX cY cxp cres fndm ax-mp eleq2i biimpri adantl syl3anc cX cJ
      cuni cF wf cY cK cuni cG wf wa vw cv cX cY cxp wcel wa vw cv c1st cX cY
      cxp cres cfv vw cv c1st cfv cF vw cv cX cY cxp wcel vw cv c1st cX cY cxp
      cres cfv vw cv c1st cfv wceq cX cJ cuni cF wf cY cK cuni cG wf wa vw cv
      cX cY cxp c1st fvres adantl fveq2d eqtr2d cX cJ cuni cF wf cY cK cuni cG
      wf wa vw cv cX cY cxp wcel wa vw cv cG c2nd cX cY cxp cres ccom cfv vw cv
      c2nd cX cY cxp cres cfv cG cfv vw cv c2nd cfv cG cfv cG wfun c2nd cX cY
      cxp cres wfun vw cv c2nd cX cY cxp cres cdm wcel vw cv cG c2nd cX cY cxp
      cres ccom cfv vw cv c2nd cX cY cxp cres cfv cG cfv wceq cX cJ cuni cF wf
      cY cK cuni cG wf wa vw cv cX cY cxp wcel wa vw cv cG c2nd cX cY cxp cres
      fvco cY cK cuni cG wf cG wfun cX cJ cuni cF wf vw cv cX cY cxp wcel cY cK
      cuni cG ffun ad2antlr c2nd cX cY cxp cres wfun cX cJ cuni cF wf cY cK
      cuni cG wf wa vw cv cX cY cxp wcel wa c2nd cX cY cxp cres cX cY cxp wfn
      c2nd cX cY cxp cres wfun c2nd cvv wfn cX cY cxp cvv wss c2nd cX cY cxp
      cres cX cY cxp wfn cvv cvv c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn
      ax-mp cX cY cxp ssv cvv cX cY cxp c2nd fnssres mp2an cX cY cxp c2nd cX cY
      cxp cres fnfun ax-mp a1i vw cv cX cY cxp wcel vw cv c2nd cX cY cxp cres
      cdm wcel cX cJ cuni cF wf cY cK cuni cG wf wa vw cv c2nd cX cY cxp cres
      cdm wcel vw cv cX cY cxp wcel c2nd cX cY cxp cres cdm cX cY cxp vw cv
      c2nd cX cY cxp cres cX cY cxp wfn c2nd cX cY cxp cres cdm cX cY cxp wceq
      c2nd cvv wfn cX cY cxp cvv wss c2nd cX cY cxp cres cX cY cxp wfn cvv cvv
      c2nd wfo c2nd cvv wfn fo2nd cvv cvv c2nd fofn ax-mp cX cY cxp ssv cvv cX
      cY cxp c2nd fnssres mp2an cX cY cxp c2nd cX cY cxp cres fndm ax-mp eleq2i
      biimpri adantl syl3anc cX cJ cuni cF wf cY cK cuni cG wf wa vw cv cX cY
      cxp wcel wa vw cv c2nd cX cY cxp cres cfv vw cv c2nd cfv cG vw cv cX cY
      cxp wcel vw cv c2nd cX cY cxp cres cfv vw cv c2nd cfv wceq cX cJ cuni cF
      wf cY cK cuni cG wf wa vw cv cX cY cxp c2nd fvres adantl fveq2d eqtr2d
      opeq12d cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR
      cJ ccn co wcel cG cS cK ccn co wcel wa w3a cX cJ cuni cF wf cY cK cuni cG
      wf cR ctop wcel cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS
      cK ccn co wcel wa cX cJ cuni cF wf cS ctop wcel cR ctop wcel cJ ctop wcel
      cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cX cJ cuni cF wf cK ctop
      wcel cR ctop wcel cJ ctop wcel cF cR cJ ccn co wcel cX cJ cuni cF wf cG
      cS cK ccn co wcel cF cR cJ cX cJ cuni 2txcn.3 cJ cuni eqid cnf 3adant3r
      3adant2r 3adant1r cS ctop wcel cJ ctop wcel cK ctop wcel wa cF cR cJ ccn
      co wcel cG cS cK ccn co wcel wa cY cK cuni cG wf cR ctop wcel cS ctop
      wcel cK ctop wcel cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cY cK cuni
      cG wf cJ ctop wcel cS ctop wcel cK ctop wcel cG cS cK ccn co wcel cY cK
      cuni cG wf cF cR cJ ccn co wcel cG cS cK cY cK cuni 2txcn.4 cK cuni eqid
      cnf 3adant3l 3adant2l 3adant1l jca sylan eqeq2d pm5.32da cR ctop wcel cS
      ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS cK
      ccn co wcel wa w3a vw cv cT cuni wcel vw cv cX cY cxp wcel vz cv vw cv cF
      c1st cX cY cxp cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop
      wceq cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ
      ccn co wcel cG cS cK ccn co wcel wa w3a cT cuni cX cY cxp vw cv cR ctop
      wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cT cuni cX cY cxp wceq
      cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cR cS cT cX cY 2txcn.1
      2txcn.3 2txcn.4 txuni 3ad2ant1 eleq2d anbi1d bitr4d opabbidv cH vx cv cX
      wcel vy cv cY wcel wa vz cv vx cv cF cfv vy cv cG cfv cop wceq wa vx vy
      vz copab2 vw cv cX cY cxp wcel vz cv vw cv c1st cfv cF cfv vw cv c2nd cfv
      cG cfv cop wceq wa vw vz copab 2txcn.5 vz cv vx cv cF cfv vy cv cG cfv
      cop wceq vz cv vw cv c1st cfv cF cfv vy cv cG cfv cop wceq vz cv vw cv
      c1st cfv cF cfv vw cv c2nd cfv cG cfv cop wceq vx vy vz vw cX cY vx cv vw
      cv c1st cfv wceq vx cv cF cfv vy cv cG cfv cop vw cv c1st cfv cF cfv vy
      cv cG cfv cop vz cv vx cv vw cv c1st cfv wceq vx cv cF cfv vw cv c1st cfv
      cF cfv vy cv cG cfv vx cv vw cv c1st cfv cF fveq2 opeq1d eqeq2d vy cv vw
      cv c2nd cfv wceq vw cv c1st cfv cF cfv vy cv cG cfv cop vw cv c1st cfv cF
      cfv vw cv c2nd cfv cG cfv cop vz cv vy cv vw cv c2nd cfv wceq vy cv cG
      cfv vw cv c2nd cfv cG cfv vw cv c1st cfv cF cfv vy cv vw cv c2nd cfv cG
      fveq2 opeq2d eqeq2d oprabopab eqtri syl5eq cJ ctop wcel cK ctop wcel cT
      ctop wcel w3a cF c1st cX cY cxp cres ccom cT cJ ccn co wcel cG c2nd cX cY
      cxp cres ccom cT cK ccn co wcel vw cv cT cuni wcel vz cv vw cv cF c1st cX
      cY cxp cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop wceq wa vw
      vz copab cT cL ccn co wcel cR ctop wcel cS ctop wcel wa cJ ctop wcel cK
      ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa w3a cR ctop
      wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG
      cS cK ccn co wcel wa w3a cJ ctop wcel cK ctop wcel cT ctop wcel cJ ctop
      wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cJ ctop
      wcel cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel cF cR cJ ccn
      co wcel cG cS cK ccn co wcel wa simpll 3adant1 cJ ctop wcel cK ctop wcel
      wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cK ctop wcel cR ctop wcel
      cS ctop wcel wa cJ ctop wcel cK ctop wcel cF cR cJ ccn co wcel cG cS cK
      ccn co wcel wa simplr 3adant1 cR ctop wcel cS ctop wcel wa cJ ctop wcel
      cK ctop wcel wa cT ctop wcel cF cR cJ ccn co wcel cG cS cK ccn co wcel wa
      cR cS cT 2txcn.1 txtop 3ad2ant1 3jca cT ctop wcel cR ctop wcel cJ ctop
      wcel w3a c1st cX cY cxp cres cT cR ccn co wcel cF cR cJ ccn co wcel cF
      c1st cX cY cxp cres ccom cT cJ ccn co wcel cR ctop wcel cS ctop wcel wa
      cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa
      w3a cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ
      ccn co wcel cG cS cK ccn co wcel wa w3a cT ctop wcel cR ctop wcel cJ ctop
      wcel cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cT ctop
      wcel cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cR cS cT 2txcn.1 txtop
      3ad2ant1 cR ctop wcel cS ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn
      co wcel wa cR ctop wcel cJ ctop wcel cK ctop wcel wa cR ctop wcel cS ctop
      wcel cF cR cJ ccn co wcel cG cS cK ccn co wcel wa simpll 3adant2 cJ ctop
      wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cJ ctop
      wcel cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel cF cR cJ ccn
      co wcel cG cS cK ccn co wcel wa simpll 3adant1 3jca cR ctop wcel cS ctop
      wcel wa cJ ctop wcel cK ctop wcel wa c1st cX cY cxp cres cT cR ccn co
      wcel cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cR cS cT cX cY cX cY
      cxp 2txcn.1 2txcn.3 2txcn.4 cX cY cxp eqid tx1cn 3ad2ant1 cJ ctop wcel cK
      ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cF cR cJ ccn co
      wcel cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ
      ccn co wcel cG cS cK ccn co wcel simprl 3adant1 c1st cX cY cxp cres cF cT
      cR cJ cnco sylan32c cT ctop wcel cS ctop wcel cK ctop wcel w3a c2nd cX cY
      cxp cres cT cS ccn co wcel cG cS cK ccn co wcel cG c2nd cX cY cxp cres
      ccom cT cK ccn co wcel cR ctop wcel cS ctop wcel wa cJ ctop wcel cK ctop
      wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa w3a cR ctop wcel cS
      ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS cK
      ccn co wcel wa w3a cT ctop wcel cS ctop wcel cK ctop wcel cR ctop wcel cS
      ctop wcel wa cJ ctop wcel cK ctop wcel wa cT ctop wcel cF cR cJ ccn co
      wcel cG cS cK ccn co wcel wa cR cS cT 2txcn.1 txtop 3ad2ant1 cR ctop wcel
      cS ctop wcel wa cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cS ctop wcel
      cJ ctop wcel cK ctop wcel wa cR ctop wcel cS ctop wcel cF cR cJ ccn co
      wcel cG cS cK ccn co wcel wa simplr 3adant2 cJ ctop wcel cK ctop wcel wa
      cF cR cJ ccn co wcel cG cS cK ccn co wcel wa cK ctop wcel cR ctop wcel cS
      ctop wcel wa cJ ctop wcel cK ctop wcel cF cR cJ ccn co wcel cG cS cK ccn
      co wcel wa simplr 3adant1 3jca cR ctop wcel cS ctop wcel wa cJ ctop wcel
      cK ctop wcel wa c2nd cX cY cxp cres cT cS ccn co wcel cF cR cJ ccn co
      wcel cG cS cK ccn co wcel wa cR cS cT cX cY cX cY cxp 2txcn.1 2txcn.3
      2txcn.4 cX cY cxp eqid tx2cn 3ad2ant1 cJ ctop wcel cK ctop wcel wa cF cR
      cJ ccn co wcel cG cS cK ccn co wcel wa cG cS cK ccn co wcel cR ctop wcel
      cS ctop wcel wa cJ ctop wcel cK ctop wcel wa cF cR cJ ccn co wcel cG cS
      cK ccn co wcel simprr 3adant1 c2nd cX cY cxp cres cG cT cS cK cnco
      sylan32c vw vz cJ cK cL cT cF c1st cX cY cxp cres ccom cG c2nd cX cY cxp
      cres ccom vw cv cT cuni wcel vz cv vw cv cF c1st cX cY cxp cres ccom cfv
      vw cv cG c2nd cX cY cxp cres ccom cfv cop wceq wa vw vz copab cT cuni
      2txcn.2 cT cuni eqid vw cv cT cuni wcel vz cv vw cv cF c1st cX cY cxp
      cres ccom cfv vw cv cG c2nd cX cY cxp cres ccom cfv cop wceq wa vw vz
      copab eqid txcnopab sylan32c eqeltrd $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Homeomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Homeo $. $( Class of all homeomorphisms. $)
  $c ~= $. $( The relation "is homeomorph to." $)

  $( Extend class notation with the class of all homeomorphisms. $)
  chomeosm $a class Homeo $.

  $( Extend class notation with the relation "is homeomorph to.". $)
  chomeo $a class ~= $.

  ${
    $d j k z f x $.
    $( Function returning all the  homeomorphisms from topology ` j `
       to topology ` k ` . $)
    df-homeo $a |-  Homeo = { <. <. j , k >. , z >. | ( ( j e. Top /\
     k e. Top ) /\  z = { f | ( f : U. j -1-1-onto-> U. k /\
     A. x e. j ( f " x ) e. k /\
     A. x e. k ( `' f " x ) e. j ) } ) } $.
  $}

  ${ $d x y f $.
    $( Definition of the relation ` x ` is homeomorph to ` y ` . $)
    df-hmph $a |- ~= = { <. x , y >. | ( x e. Top /\ y e. Top /\
      E. f f e. ( x Homeo y ) ) } $.
  $}

  ${ $d J f j k x z $.  $d K f j k x z $.  $d X f j k z $.  $d Y f k z $.
    homeofval.1 $e |- X = U. J $.
    homeofval.2 $e |- Y = U. K $.
    $( The set of all the homeomorphisms between two topologies.  (Contributed
       by FL, 20-Feb-2007.) $)
    homeofval $p |- ( ( J e. Top /\ K e. Top ) -> ( J Homeo K ) =
    { f | ( f : X -1-1-onto-> Y /\ A. x e. J ( f " x ) e. K /\
    A. x e. K ( `' f " x ) e. J ) } ) $=
      cJ ctop wcel cK ctop wcel cX cY vf cv wf1o vf cv vx cv cima cK wcel vx cJ
      wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf cab cvv wcel cJ cK
      chomeosm co cX cY vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv
      ccnv vx cv cima cJ wcel vx cK wral w3a vf cab wceq cX cY vf cv wf1o vf cv
      vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral
      w3a vf cab cX cY vf cv wf vf cab wss cX cY vf cv wf vf cab cvv wcel cX cY
      vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ
      wcel vx cK wral w3a vf cab cvv wcel cJ ctop wcel cK ctop wcel wa cX cY vf
      cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel
      vx cK wral w3a vf cab cX cY vf cv wf vf cab cvv ssexg cJ ctop wcel cK
      ctop wcel wa cX cY vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv
      ccnv vx cv cima cJ wcel vx cK wral w3a cX cY vf cv wf wi vf wal cX cY vf
      cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel
      vx cK wral w3a vf cab cX cY vf cv wf vf cab wss cJ ctop wcel cK ctop wcel
      wa cX cY vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv
      cima cJ wcel vx cK wral w3a cX cY vf cv wf wi vf cX cY vf cv wf1o vf cv
      vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral
      w3a cX cY vf cv wf wi cJ ctop wcel cK ctop wcel wa cX cY vf cv wf1o vf cv
      vx cv cima cK wcel vx cJ wral cX cY vf cv wf vf cv ccnv vx cv cima cJ
      wcel vx cK wral cX cY vf cv f1of 3ad2ant1 a1i 19.21aiv cX cY vf cv wf1o
      vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK
      wral w3a cX cY vf cv wf vf ss2ab sylibr cX cvv wcel cY cvv wcel cX cY vf
      cv wf vf cab cvv wcel cJ ctop wcel cK ctop wcel cX cY cvv cvv vf mapex cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg homeofval.1 syl5eqel cK ctop wcel
      cK cuni cvv cY cK ctop uniexg homeofval.2 syl5eqel syl2an sylanc vj vk vz
      cJ cK ctop ctop vj cv cuni vk cv cuni vf cv wf1o vf cv vx cv cima vk cv
      wcel vx vj cv wral vf cv ccnv vx cv cima vj cv wcel vx vk cv wral w3a vf
      cab cX cY vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv
      cima cJ wcel vx cK wral w3a vf cab chomeosm cX vk cv cuni vf cv wf1o vf
      cv vx cv cima vk cv wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx vk
      cv wral w3a vf cab cvv vj cv cJ wceq vj cv cuni vk cv cuni vf cv wf1o vf
      cv vx cv cima vk cv wcel vx vj cv wral vf cv ccnv vx cv cima vj cv wcel
      vx vk cv wral w3a cX vk cv cuni vf cv wf1o vf cv vx cv cima vk cv wcel vx
      cJ wral vf cv ccnv vx cv cima cJ wcel vx vk cv wral w3a vf vj cv cJ wceq
      vj cv cuni vk cv cuni vf cv wf1o cX vk cv cuni vf cv wf1o vf cv vx cv
      cima vk cv wcel vx vj cv wral vf cv vx cv cima vk cv wcel vx cJ wral vf
      cv ccnv vx cv cima vj cv wcel vx vk cv wral vf cv ccnv vx cv cima cJ wcel
      vx vk cv wral vj cv cJ wceq vj cv cuni cX wceq vj cv cuni vk cv cuni vf
      cv wf1o cX vk cv cuni vf cv wf1o wb vj cv cJ wceq vj cv cuni cJ cuni cX
      vj cv cJ unieq homeofval.1 syl6eqr vj cv cuni cX vk cv cuni vf cv f1oeq2
      syl vf cv vx cv cima vk cv wcel vx vj cv cJ raleq1 vj cv cJ wceq vf cv
      ccnv vx cv cima vj cv wcel vf cv ccnv vx cv cima cJ wcel vx vk cv vj cv
      cJ vf cv ccnv vx cv cima eleq2 ralbidv 3anbi123d abbidv vk cv cK wceq cX
      vk cv cuni vf cv wf1o vf cv vx cv cima vk cv wcel vx cJ wral vf cv ccnv
      vx cv cima cJ wcel vx vk cv wral w3a cX cY vf cv wf1o vf cv vx cv cima cK
      wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf vk cv cK
      wceq cX vk cv cuni vf cv wf1o cX cY vf cv wf1o vf cv vx cv cima vk cv
      wcel vx cJ wral vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima
      cJ wcel vx vk cv wral vf cv ccnv vx cv cima cJ wcel vx cK wral vk cv cK
      wceq vk cv cuni cY wceq cX vk cv cuni vf cv wf1o cX cY vf cv wf1o wb vk
      cv cK wceq vk cv cuni cK cuni cY vk cv cK unieq homeofval.2 syl6eqr vk cv
      cuni cY cX vf cv f1oeq3 syl vk cv cK wceq vf cv vx cv cima vk cv wcel vf
      cv vx cv cima cK wcel vx cJ vk cv cK vf cv vx cv cima eleq2 ralbidv vf cv
      ccnv vx cv cima cJ wcel vx vk cv cK raleq1 3anbi123d abbidv vx vz vf vj
      vk df-homeo oprabval2g mpd3an3 $.
      $( [1-Dec-2010] $) $( [14-Feb-2007] $)
  $}

  ${ $d F f x $.  $d J f x $.  $d K f x $.  $d X f $.  $d Y f $.
    ishomeo.1 $e |- X = U. J $.
    ishomeo.2 $e |- Y = U. K $.
    $( The predicate F is a homeomorphism between topology ` J ` and
       topology ` K ` .  Based on Bourbaki TG I.2.  (Contributed by FL,
       20-Feb-2007.) $)
    ishomeo $p |- ( ( J e. Top /\ K e. Top /\ F e. A ) ->
      ( F e. ( J Homeo K ) <-> ( F : X -1-1-onto-> Y /\
        A. x e. J ( F " x ) e. K /\
        A. x e. K ( `' F " x ) e. J ) ) ) $=
      cJ ctop wcel cK ctop wcel cF cA wcel w3a cF cJ cK chomeosm co wcel cF cX
      cY vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima
      cJ wcel vx cK wral w3a vf cab wcel cX cY cF wf1o cF vx cv cima cK wcel vx
      cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a cJ ctop wcel cK ctop
      wcel cF cA wcel w3a cJ cK chomeosm co cX cY vf cv wf1o vf cv vx cv cima
      cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf cab cF
      cJ ctop wcel cK ctop wcel cJ cK chomeosm co cX cY vf cv wf1o vf cv vx cv
      cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf
      cab wceq cF cA wcel vx vf cJ cK cX cY ishomeo.1 ishomeo.2 homeofval
      3adant3 eleq2d cF cA wcel cJ ctop wcel cF cX cY vf cv wf1o vf cv vx cv
      cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf
      cab wcel cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv
      cima cJ wcel vx cK wral w3a wb cK ctop wcel cX cY vf cv wf1o vf cv vx cv
      cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a cX
      cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx
      cK wral w3a vf cF cA vf cv cF wceq cX cY vf cv wf1o cX cY cF wf1o vf cv
      vx cv cima cK wcel vx cJ wral cF vx cv cima cK wcel vx cJ wral vf cv ccnv
      vx cv cima cJ wcel vx cK wral cF ccnv vx cv cima cJ wcel vx cK wral cX cY
      vf cv cF f1oeq1 vf cv cF wceq vf cv vx cv cima cK wcel cF vx cv cima cK
      wcel vx cJ vf cv cF wceq vf cv vx cv cima cF vx cv cima cK vf cv cF vx cv
      imaeq1 eleq1d ralbidv vf cv cF wceq vf cv ccnv vx cv cima cJ wcel cF ccnv
      vx cv cima cJ wcel vx cK vf cv cF wceq vf cv ccnv vx cv cima cF ccnv vx
      cv cima cJ vf cv cF wceq vf cv ccnv cF ccnv vx cv vf cv cF cnveq imaeq1d
      eleq1d ralbidv 3anbi123d elabg 3ad2ant3 bitrd $.
      $( [1-Dec-2010] $) $( [14-Feb-2007] $)
  $}

  ${ $d F x $.  $d J x $.  $d K x $.
    hmeomap.1 $e |- X = U. J $.
    hmeomap.2 $e |- Y = U. K $.
    $( A homeomorphism is a 1-1-onto mapping.  (Contributed by FL,
       5-Mar-2007.) $)
    hmeomap $p |- ( ( J e. Top /\ K e. Top ) ->
      ( F e. ( J Homeo K ) -> F : X -1-1-onto-> Y  ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cX cY cF wf1o cJ
      ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF cJ cK chomeosm co
      wcel cX cY cF wf1o wi wi cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co
      wcel cF cJ cK chomeosm co wcel cX cY cF wf1o cJ ctop wcel cK ctop wcel cF
      cJ cK chomeosm co wcel w3a cF cJ cK chomeosm co wcel wa cX cY cF wf1o cF
      vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK wral cJ
      ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel w3a cF cJ cK chomeosm co
      wcel cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ
      wcel vx cK wral w3a vx cJ cK chomeosm co cF cJ cK cX cY hmeomap.1
      hmeomap.2 ishomeo biimpa 3simp1d 3exp1 imp pm2.43d $.
      $( [1-Dec-2010] $) $( [5-Mar-2007] $)
  $}

  ${ $d F x $.  $d J x $.  $d K x $.
    $( The image of an open set by the converse of a homeomorphism is an open
       set.  (Contributed by FL, 5-Mar-2007.) $)
    hmeocna $p |- ( ( J e. Top /\ K e. Top ) ->
      ( F e. ( J Homeo K ) -> A. x e. K ( `' F " x ) e. J  ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cF ccnv vx cv cima
      cJ wcel vx cK wral cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF
      cJ cK chomeosm co wcel cF ccnv vx cv cima cJ wcel vx cK wral wi wi cJ
      ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF cJ cK chomeosm co
      wcel cF ccnv vx cv cima cJ wcel vx cK wral cJ ctop wcel cK ctop wcel cF
      cJ cK chomeosm co wcel w3a cF cJ cK chomeosm co wcel wa cJ cuni cK cuni
      cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel w3a cF cJ cK
      chomeosm co wcel cJ cuni cK cuni cF wf1o cF vx cv cima cK wcel vx cJ wral
      cF ccnv vx cv cima cJ wcel vx cK wral w3a vx cJ cK chomeosm co cF cJ cK
      cJ cuni cK cuni cJ cuni eqid cK cuni eqid ishomeo biimpa 3simp3d 3exp1
      imp pm2.43d $.
      $( [1-Dec-2010] $) $( [5-Mar-2007] $)
  $}

  ${ $d F x $.  $d J x $.  $d K x $.
    $( The image of an open set by a homeomorphism is an open set.
       (Contributed by FL, 5-Mar-2007.) $)
    hmeocnb $p |- ( ( J e. Top /\ K e. Top ) ->
      ( F e. ( J Homeo K ) -> A. x e. J ( F " x ) e. K  ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cF vx cv cima cK
      wcel vx cJ wral cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF cJ
      cK chomeosm co wcel cF vx cv cima cK wcel vx cJ wral wi wi cJ ctop wcel
      cK ctop wcel cF cJ cK chomeosm co wcel cF cJ cK chomeosm co wcel cF vx cv
      cima cK wcel vx cJ wral cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co
      wcel w3a cF cJ cK chomeosm co wcel wa cJ cuni cK cuni cF wf1o cF vx cv
      cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK wral cJ ctop
      wcel cK ctop wcel cF cJ cK chomeosm co wcel w3a cF cJ cK chomeosm co wcel
      cJ cuni cK cuni cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv
      cima cJ wcel vx cK wral w3a vx cJ cK chomeosm co cF cJ cK cJ cuni cK cuni
      cJ cuni eqid cK cuni eqid ishomeo biimpa 3simp2d 3exp1 imp pm2.43d $.
      $( [1-Dec-2010] $) $( [5-Mar-2007] $)
  $}

  ${
    $d F x $.  $d J x $.  $d K x $.  $d X x $.  $d Y x $.
    hmeobc.1 $e |- X = U. J $.
    hmeobc.2 $e |- Y = U. K $.
    $( F e. A is useless see ~ iscn $)
    $( A homeomorphism is a bicontinuous bijection.  (Contributed by FL,
       1-Sep-2008.) $)
    hmeobc $p |- ( ( J e. Top /\ K e. Top /\ F e. A ) -> ( F e. ( J Homeo K )
      <-> ( F : X -1-1-onto-> Y /\
          F e. ( J Cn K ) /\ `' F e. ( K Cn J ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cF cA wcel w3a cX cY cF wf1o cF vx cv cima cK
      wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a cX cY cF wf1o
      cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa cY cX cF ccnv wf cF
      ccnv ccnv vx cv cima cK wcel vx cJ wral wa w3a cF cJ cK chomeosm co wcel
      cX cY cF wf1o cF cJ cK ccn co wcel cF ccnv cK cJ ccn co wcel w3a cJ ctop
      wcel cK ctop wcel cF cA wcel w3a cX cY cF wf1o cF vx cv cima cK wcel vx
      cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a cX cY cF wf1o cX cY cF
      wf cF ccnv vx cv cima cJ wcel vx cK wral wa cY cX cF ccnv wf cF ccnv ccnv
      vx cv cima cK wcel vx cJ wral wa w3a cJ ctop wcel cK ctop wcel cF cA wcel
      w3a cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ
      wcel vx cK wral w3a wa cX cY cF wf1o cX cY cF wf cF ccnv vx cv cima cJ
      wcel vx cK wral wa cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ
      wral wa cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima
      cJ wcel vx cK wral w3a cX cY cF wf1o cJ ctop wcel cK ctop wcel cF cA wcel
      w3a cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ
      wcel vx cK wral 3simp1 adantl cJ ctop wcel cK ctop wcel cF cA wcel w3a cX
      cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx
      cK wral w3a wa cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral cX cY cF
      wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral w3a cX cY cF wf cJ ctop wcel cK ctop wcel cF cA wcel w3a cX cY cF
      wf1o cF vx cv cima cK wcel vx cJ wral cX cY cF wf cF ccnv vx cv cima cJ
      wcel vx cK wral cX cY cF f1of 3ad2ant1 adantl cX cY cF wf1o cF vx cv cima
      cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a cF ccnv vx
      cv cima cJ wcel vx cK wral cJ ctop wcel cK ctop wcel cF cA wcel w3a cX cY
      cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral 3simp3 adantl jca cJ ctop wcel cK ctop wcel cF cA wcel w3a cX cY cF
      wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral w3a wa cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral
      cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel
      vx cK wral w3a cY cX cF ccnv wf cJ ctop wcel cK ctop wcel cF cA wcel w3a
      cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cY cX cF ccnv wf cF ccnv
      vx cv cima cJ wcel vx cK wral cX cY cF wf1o cY cX cF ccnv wf1o cY cX cF
      ccnv wf cX cY cF f1ocnv cY cX cF ccnv f1of syl 3ad2ant1 adantl cX cY cF
      wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral w3a cF ccnv ccnv vx cv cima cK wcel vx cJ wral cJ ctop wcel cK ctop
      wcel cF cA wcel w3a cF vx cv cima cK wcel vx cJ wral cX cY cF wf1o cF
      ccnv ccnv vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral cF vx cv cima cK wcel vx cJ wral cF ccnv ccnv vx cv cima cK wcel vx
      cJ wral cF vx cv cima cK wcel cF ccnv ccnv vx cv cima cK wcel vx cJ cF vx
      cv cima cF ccnv ccnv vx cv cima cK cF ccnv ccnv vx cv cima cF vx cv cima
      cF vx cv imacnvcnv eqcomi eleq1i ralbii biimpi 3ad2ant2 adantl jca 3jca
      cJ ctop wcel cK ctop wcel cF cA wcel w3a cX cY cF wf1o cX cY cF wf cF
      ccnv vx cv cima cJ wcel vx cK wral wa cY cX cF ccnv wf cF ccnv ccnv vx cv
      cima cK wcel vx cJ wral wa w3a wa cX cY cF wf1o cF vx cv cima cK wcel vx
      cJ wral cF ccnv vx cv cima cJ wcel vx cK wral cX cY cF wf1o cX cY cF wf
      cF ccnv vx cv cima cJ wcel vx cK wral wa cY cX cF ccnv wf cF ccnv ccnv vx
      cv cima cK wcel vx cJ wral wa w3a cX cY cF wf1o cJ ctop wcel cK ctop wcel
      cF cA wcel w3a cX cY cF wf1o cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK
      wral wa cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa
      3simp1 adantl cX cY cF wf1o cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK
      wral wa cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa
      w3a cF vx cv cima cK wcel vx cJ wral cJ ctop wcel cK ctop wcel cF cA wcel
      w3a cX cY cF wf1o cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa cY
      cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa cF vx cv cima
      cK wcel vx cJ wral cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa
      cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa cF vx cv
      cima cK wcel vx cJ wral wi wi cX cY cF wf1o cX cY cF wf cF ccnv vx cv
      cima cJ wcel vx cK wral cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel
      vx cJ wral wa cF vx cv cima cK wcel vx cJ wral wi cX cY cF wf cF wrel cF
      ccnv vx cv cima cJ wcel vx cK wral cY cX cF ccnv wf cF ccnv ccnv vx cv
      cima cK wcel vx cJ wral wa cF vx cv cima cK wcel vx cJ wral wi wi cX cY
      cF frel cF wrel cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ
      wral wa cF vx cv cima cK wcel vx cJ wral wi cF ccnv vx cv cima cJ wcel vx
      cK wral cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa cF
      wrel cF vx cv cima cK wcel vx cJ wral cF ccnv ccnv vx cv cima cK wcel vx
      cJ wral cF wrel cF vx cv cima cK wcel vx cJ wral wi cY cX cF ccnv wf cF
      wrel cF ccnv ccnv vx cv cima cK wcel vx cJ wral cF vx cv cima cK wcel vx
      cJ wral cF wrel cF ccnv ccnv vx cv cima cK wcel cF vx cv cima cK wcel vx
      cJ cF wrel cF ccnv ccnv vx cv cima cF vx cv cima cK cF ccnv ccnv vx cv
      cima cF vx cv cima wceq cF wrel cF vx cv imacnvcnv a1i eleq1d ralbidv
      biimpcd adantl com12 a1d syl imp a1i 3imp adantl cJ ctop wcel cK ctop
      wcel cF cA wcel w3a cX cY cF wf1o cX cY cF wf cF ccnv vx cv cima cJ wcel
      vx cK wral wa cF ccnv vx cv cima cJ wcel vx cK wral cY cX cF ccnv wf cF
      ccnv ccnv vx cv cima cK wcel vx cJ wral wa cJ ctop wcel cK ctop wcel cF
      cA wcel w3a cX cY cF wf cF ccnv vx cv cima cJ wcel vx cK wral simprr
      3ad2antr2 3jca impbida vx cA cF cJ cK cX cY hmeobc.1 hmeobc.2 ishomeo cJ
      ctop wcel cK ctop wcel cF cA wcel w3a cF cJ cK ccn co wcel cX cY cF wf cF
      ccnv vx cv cima cJ wcel vx cK wral wa cF ccnv cK cJ ccn co wcel cY cX cF
      ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa cX cY cF wf1o cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel cX cY cF wf cF ccnv vx cv
      cima cJ wcel vx cK wral wa wb cF cA wcel vx cF cJ cK cX cY hmeobc.1
      hmeobc.2 iscn 3adant3 cJ ctop wcel cK ctop wcel cF ccnv cK cJ ccn co wcel
      cY cX cF ccnv wf cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa wb cF cA
      wcel cK ctop wcel cJ ctop wcel cF ccnv cK cJ ccn co wcel cY cX cF ccnv wf
      cF ccnv ccnv vx cv cima cK wcel vx cJ wral wa wb vx cF ccnv cK cJ cY cX
      hmeobc.2 hmeobc.1 iscn ancoms 3adant3 3anbi23d 3bitr4d $.
      $( [1-Dec-2010] $) $( [23-Aug-2008] $)
  $}

  ${ $d F x $.  $d J x $.  $d K x $.
    $( The converse of a homeomorphism is a homeomorphism.  (Contributed by
       FL, 5-Mar-2007.) $)
    cnvhmpha $p |- ( ( J e. Top /\ K e. Top ) ->
      ( F e. ( J Homeo K ) -> `' F e. ( K Homeo J ) ) ) $=
      cF cJ cK chomeosm co wcel cJ ctop wcel cK ctop wcel wa cF ccnv cK cJ
      chomeosm co wcel cF ccnv cvv wcel cF cJ cK chomeosm co wcel cJ ctop wcel
      cK ctop wcel wa cF ccnv cK cJ chomeosm co wcel wi cF cJ cK chomeosm co
      cnvexg cJ ctop wcel cK ctop wcel wa cF ccnv cvv wcel cF cJ cK chomeosm co
      wcel cF ccnv cK cJ chomeosm co wcel cK ctop wcel cJ ctop wcel cF ccnv cvv
      wcel cF cJ cK chomeosm co wcel cF ccnv cK cJ chomeosm co wcel wi wi cK
      ctop wcel cJ ctop wcel cF ccnv cvv wcel cF cJ cK chomeosm co wcel cF ccnv
      cK cJ chomeosm co wcel wi cK ctop wcel cJ ctop wcel cF ccnv cvv wcel w3a
      cF cJ cK chomeosm co wcel cK cuni cJ cuni cF ccnv wf1o cF ccnv vx cv cima
      cJ wcel vx cK wral cF ccnv ccnv vx cv cima cK wcel vx cJ wral w3a cF ccnv
      cK cJ chomeosm co wcel cK ctop wcel cJ ctop wcel cF cJ cK chomeosm co
      wcel cK cuni cJ cuni cF ccnv wf1o cF ccnv vx cv cima cJ wcel vx cK wral
      cF ccnv ccnv vx cv cima cK wcel vx cJ wral w3a wi cF ccnv cvv wcel cJ
      ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cK cuni cJ cuni cF ccnv
      wf1o cF ccnv vx cv cima cJ wcel vx cK wral cF ccnv ccnv vx cv cima cK
      wcel vx cJ wral w3a wi cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cK cuni cJ cuni cF ccnv wf1o cF ccnv vx cv cima cJ wcel vx cK wral
      cF ccnv ccnv vx cv cima cK wcel vx cJ wral w3a cJ ctop wcel cK ctop wcel
      wa cF cJ cK chomeosm co wcel wa cK cuni cJ cuni cF ccnv wf1o cF ccnv vx
      cv cima cJ wcel vx cK wral cF ccnv ccnv vx cv cima cK wcel vx cJ wral cJ
      ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cK cuni cJ cuni cF
      ccnv wf1o cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cJ cuni
      cK cuni cF wf1o cK cuni cJ cuni cF ccnv wf1o cF cJ cK cJ cuni cK cuni cJ
      cuni eqid cK cuni eqid hmeomap cJ cuni cK cuni cF f1ocnv syl6 imp cJ ctop
      wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cF ccnv vx cv cima cJ wcel
      vx cK wral vx cF cJ cK hmeocna imp cJ ctop wcel cK ctop wcel wa cF cJ cK
      chomeosm co wcel wa cF ccnv ccnv vx cv cima cK wcel vx cJ wral cF vx cv
      cima cK wcel vx cJ wral cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cF vx cv cima cK wcel vx cJ wral vx cF cJ cK hmeocnb imp cJ ctop
      wcel cK ctop wcel wa cF cJ cK chomeosm co wcel wa cF ccnv ccnv vx cv cima
      cK wcel cF vx cv cima cK wcel vx cJ cJ ctop wcel cK ctop wcel wa cF cJ cK
      chomeosm co wcel wa vx cv cJ wcel wa cF ccnv ccnv vx cv cima cF vx cv
      cima cK cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel wa vx cv
      cJ wcel wa cF ccnv ccnv cF vx cv cJ ctop wcel cK ctop wcel wa cF cJ cK
      chomeosm co wcel wa cF ccnv ccnv cF wceq vx cv cJ wcel cJ ctop wcel cK
      ctop wcel wa cF cJ cK chomeosm co wcel cF ccnv ccnv cF wceq cJ ctop wcel
      cK ctop wcel wa cF cJ cK chomeosm co wcel cJ cuni cK cuni cF wf1o cF ccnv
      ccnv cF wceq cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid hmeomap
      cJ cuni cK cuni cF wf1o cF wrel cF ccnv ccnv cF wceq cJ cuni cK cuni cF
      f1orel cF dfrel2 sylib syl6 imp adantr imaeq1d eleq1d ralbidva mpbird
      3jca ex ancoms 3adant3 vx cvv cF ccnv cK cJ cK cuni cJ cuni cK cuni eqid
      cJ cuni eqid ishomeo sylibrd 3exp impcom com3l mpcom com12 $.
      $( [1-Dec-2010] $) $( [5-Mar-2007] $)
  $}

  ${ $d J f j k $.  $d K f j k $.
    $( Express the predicate ` J ` is homeomorph to ` K ` .  (Contributed by
       FL, 20-Feb-2007.) $)
    hmph $p |- ( ( J e. Top /\ K e. Top ) -> ( J ~= K <->
      E. f f e. ( J Homeo K ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cJ cK chomeo wbr vf cv cJ cK chomeosm co
      wcel vf wex vj cv ctop wcel vk cv ctop wcel vf cv vj cv vk cv chomeosm co
      wcel vf wex w3a cJ ctop wcel vk cv ctop wcel vf cv cJ vk cv chomeosm co
      wcel vf wex w3a cJ ctop wcel cK ctop wcel wa vf cv cJ cK chomeosm co wcel
      vf wex wa vj vk cJ cK ctop ctop chomeo vj cv cJ wceq vj cv ctop wcel cJ
      ctop wcel vf cv vj cv vk cv chomeosm co wcel vf wex vf cv cJ vk cv
      chomeosm co wcel vf wex vk cv ctop wcel vj cv cJ ctop eleq1 vj cv cJ wceq
      vf cv vj cv vk cv chomeosm co wcel vf cv cJ vk cv chomeosm co wcel vf vj
      cv cJ wceq vj cv vk cv chomeosm co cJ vk cv chomeosm co vf cv vj cv cJ vk
      cv chomeosm opreq1 eleq2d exbidv 3anbi13d vk cv cK wceq cJ ctop wcel cK
      ctop wcel vf cv cJ cK chomeosm co wcel vf wex w3a cJ ctop wcel vk cv ctop
      wcel vf cv cJ vk cv chomeosm co wcel vf wex w3a cJ ctop wcel cK ctop wcel
      wa vf cv cJ cK chomeosm co wcel vf wex wa vk cv cK wceq cK ctop wcel vk
      cv ctop wcel vf cv cJ cK chomeosm co wcel vf wex vf cv cJ vk cv chomeosm
      co wcel vf wex cJ ctop wcel vk cv cK wceq vk cv ctop wcel cK ctop wcel vk
      cv cK ctop eleq1 bicomd vk cv cK wceq vf cv cJ cK chomeosm co wcel vf cv
      cJ vk cv chomeosm co wcel vf vk cv cK wceq cJ cK chomeosm co cJ vk cv
      chomeosm co vf cv cJ cK chomeosm co cJ vk cv chomeosm co wceq cK vk cv cK
      vk cv cJ chomeosm opreq2 eqcoms eleq2d exbidv 3anbi23d cJ ctop wcel cK
      ctop wcel vf cv cJ cK chomeosm co wcel vf wex df-3an syl5rbbr vj vk vf
      df-hmph brabg bianabs $.
      $( [1-Dec-2010] $) $( [14-Feb-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Initial and final topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $c subSp $. $( Function returning a subspace topology. $)

  $( Extend class notation with the function returning a subspace topology. $)
  csubsp $a class subSp $.


  ${
    $d x y z u v $.
    $( Function returning the subspace topology induced by the topology
       ` y ` and the set ` x ` . $)
    df-subsp $a |- subSp = { <. <. x , y >. , z >. |
       ( y e. Top /\ z = { u | E. v e. y u = ( v i^i x ) } ) } $.
  $}

  ${
    $d A u v x y z $.  $d J u v x y z $.
    subsp.1 $e |- J e. Top $.
    subsp.2 $e |- A e. _V $.
    $( The subspace topology induced by the topology ` J ` on the set
       ` A ` .  (Contributed by FL, 4-Jun-2007.) $)
    subsp $p |- ( subSp ` <. A , J >. ) = { u | E. v e. J u = ( v i^i A ) }
      $=
      cA cJ csubsp co cA cJ vx cv cvv wcel vy cv ctop wcel wa vz cv vu cv vv cv
      vx cv cin wceq vv vy cv wrex vu cab wceq wa vx vy vz copab2 co cA cJ cop
      csubsp cfv vu cv vv cv cA cin wceq vv cJ wrex vu cab csubsp vx cv cvv
      wcel vy cv ctop wcel wa vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu
      cab wceq wa vx vy vz copab2 cA cJ csubsp vy cv ctop wcel vz cv vu cv vv
      cv vx cv cin wceq vv vy cv wrex vu cab wceq wa vx vy vz copab2 vx cv cvv
      wcel vy cv ctop wcel wa vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu
      cab wceq wa vx vy vz copab2 vx vy vz vv vu df-subsp vy cv ctop wcel vz cv
      vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab wceq wa vx cv cvv wcel vy
      cv ctop wcel wa vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab
      wceq wa vx vy vz vx cv cvv wcel vy cv ctop wcel vz cv vu cv vv cv vx cv
      cin wceq vv vy cv wrex vu cab wceq wa vx cv cvv wcel vy cv ctop wcel wa
      vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab wceq wa wb vx
      visset vx cv cvv wcel vy cv ctop wcel vx cv cvv wcel vy cv ctop wcel wa
      vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab wceq vx cv cvv wcel
      vy cv ctop wcel ibar anbi1d ax-mp oprabbii eqtri opreqi cA cJ csubsp
      df-opr cA cvv wcel cJ ctop wcel cA cJ vx cv cvv wcel vy cv ctop wcel wa
      vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab wceq wa vx vy vz
      copab2 co vu cv vv cv cA cin wceq vv cJ wrex vu cab wceq subsp.2 subsp.1
      vx vy vz cA cJ cvv ctop vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab
      vu cv vv cv cA cin wceq vv cJ wrex vu cab vx cv cvv wcel vy cv ctop wcel
      wa vz cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab wceq wa vx vy vz
      copab2 vu cv vv cv cA cin wceq vv vy cv wrex vu cab vu cv vv cv cA cin
      wceq vv cJ wrex vu cab vu cv cA wss vu cv vv cv cA cin wceq vv cJ wrex wa
      vu cab cvv vu cv vv cv cA cin wceq vv cJ wrex vu cv cA wss vu cv vv cv cA
      cin wceq vv cJ wrex wa vu vu cv vv cv cA cin wceq vv cJ wrex vu cv cA wss
      vu cv vv cv cA cin wceq wa vv cJ wrex vu cv cA wss vu cv vv cv cA cin
      wceq vv cJ wrex wa vu cv vv cv cA cin wceq vu cv cA wss vu cv vv cv cA
      cin wceq wa vv cJ vu cv vv cv cA cin wceq vu cv cA wss vu cv vv cv cA cin
      wceq vu cv vv cv cA cin cA vu cv vv cv cA cin wceq id vv cv cA cin cA wss
      vu cv vv cv cA cin wceq vv cv cA inss2 a1i eqsstrd pm4.71ri rexbii vu cv
      cA wss vu cv vv cv cA cin wceq vv cJ r19.42v bitri abbii cA cvv wcel vu
      cv cA wss vu cv vv cv cA cin wceq vv cJ wrex wa vu cab cvv wcel subsp.2
      vu cv vv cv cA cin wceq vv cJ wrex vu cA cvv abssexg ax-mp eqeltri vx cv
      cA wceq vu cv vv cv vx cv cin wceq vv vy cv wrex vu cv vv cv cA cin wceq
      vv vy cv wrex vu vx cv cA wceq vu cv vv cv vx cv cin wceq vu cv vv cv cA
      cin wceq vv vy cv vx cv cA wceq vv cv vx cv cin vv cv cA cin vu cv vx cv
      cA vv cv ineq2 eqeq2d rexbidv abbidv vy cv cJ wceq vu cv vv cv cA cin
      wceq vv vy cv wrex vu cv vv cv cA cin wceq vv cJ wrex vu vu cv vv cv cA
      cin wceq vv vy cv cJ rexeq1 abbidv vx cv cvv wcel vy cv ctop wcel wa vz
      cv vu cv vv cv vx cv cin wceq vv vy cv wrex vu cab wceq wa vx vy vz
      copab2 eqid oprabval2 mp2an 3eqtr3i $.
      $( [1-Dec-2010] $) $( [29-May-2007] $)
  $}

  ${ $d A u v $. $d B u v $. $d J u v $.
    issubsp.1 $e |- B e. _V $.
    issubsp.2 $e |- J e. Top $.
    $( The predicate "is a subspace topology".  (Contributed by FL,
       22-Dec-2008.) $)
    issubsp $p |- ( A e. C -> ( A e. ( subSp ` <. B , J >. )
      <-> E. v e. J A = ( v i^i B ) ) ) $=
      cA cC wcel cA cB cJ cop csubsp cfv wcel cA vu cv vv cv cB cin wceq vv cJ
      wrex vu cab wcel cA vv cv cB cin wceq vv cJ wrex cA cC wcel cB cJ cop
      csubsp cfv vu cv vv cv cB cin wceq vv cJ wrex vu cab cA cB cJ cop csubsp
      cfv vu cv vv cv cB cin wceq vv cJ wrex vu cab wceq cA cC wcel vv vu cB cJ
      issubsp.2 issubsp.1 subsp a1i eleq2d vu cv vv cv cB cin wceq vv cJ wrex
      cA vv cv cB cin wceq vv cJ wrex vu cA cC vu cv cA wceq vu cv vv cv cB cin
      wceq cA vv cv cB cin wceq vv cJ vu cv cA vv cv cB cin eqeq1 rexbidv elabg
      bitrd $.
      $( [1-Dec-2010] $) $( [22-Dec-2008] $)
  $}

  ${ $d A v $. $d B v $. $d J v $.
    issubsplem1.1 $e |- J e. Top $.
    $( The predicate "is a subspace topology".  (Contributed by FL,
       28-Jan-2009.) $)
    issubsplem1 $p |- ( ( A e. C /\ B e. _V ) -> ( A e. ( subSp ` <. B , J >. )
      <-> E. v e. J A = ( v i^i B ) ) ) $=
      cB cvv wcel cA cC wcel cA cB cJ cop csubsp cfv wcel cA vv cv cB cin wceq
      vv cJ wrex wb cB cvv wcel cA cC wcel cA cB cJ cop csubsp cfv wcel cA vv
      cv cB cin wceq vv cJ wrex wb wi cA cC wcel cA cB cvv wcel cB c0 cif cJ
      cop csubsp cfv wcel cA vv cv cB cvv wcel cB c0 cif cin wceq vv cJ wrex wb
      wi cB c0 cB cB cvv wcel cB c0 cif wceq cA cB cJ cop csubsp cfv wcel cA vv
      cv cB cin wceq vv cJ wrex wb cA cB cvv wcel cB c0 cif cJ cop csubsp cfv
      wcel cA vv cv cB cvv wcel cB c0 cif cin wceq vv cJ wrex wb cA cC wcel cB
      cB cvv wcel cB c0 cif wceq cA cB cJ cop csubsp cfv wcel cA cB cvv wcel cB
      c0 cif cJ cop csubsp cfv wcel cA vv cv cB cin wceq vv cJ wrex cA vv cv cB
      cvv wcel cB c0 cif cin wceq vv cJ wrex cB cB cvv wcel cB c0 cif wceq cB
      cJ cop csubsp cfv cB cvv wcel cB c0 cif cJ cop csubsp cfv cA cB cB cvv
      wcel cB c0 cif wceq cB cJ cop cB cvv wcel cB c0 cif cJ cop csubsp cB cB
      cvv wcel cB c0 cif cJ opeq1 fveq2d eleq2d cB cB cvv wcel cB c0 cif wceq
      cA vv cv cB cin wceq cA vv cv cB cvv wcel cB c0 cif cin wceq vv cJ cB cB
      cvv wcel cB c0 cif wceq vv cv cB cin vv cv cB cvv wcel cB c0 cif cin cA
      cB cB cvv wcel cB c0 cif vv cv ineq2 eqeq2d rexbidv bibi12d imbi2d vv cA
      cB cvv wcel cB c0 cif cC cJ cB c0 cvv 0ex elimel issubsplem1.1 issubsp
      dedth impcom $.
      $( [1-Dec-2010] $) $( [5-Jan-2009] $)
  $}

  ${ $d A v $. $d B v $. $d J v $.
    $( The predicate "is an open set of a subspace topology".  (Contributed by
        FL, 28-Jan-2009.) $)
    issubspt $p |- ( ( J e. Top /\ A e. C /\ B e. _V ) ->
      ( A e. ( subSp ` <. B , J >. ) <-> E. v e. J A = ( v i^i B ) ) ) $=
      cJ ctop wcel cA cC wcel cB cvv wcel cA cB cJ cop csubsp cfv wcel cA vv cv
      cB cin wceq vv cJ wrex wb cJ ctop wcel cA cC wcel cB cvv wcel cA cB cJ
      cop csubsp cfv wcel cA vv cv cB cin wceq vv cJ wrex wb wi wi cA cC wcel
      cB cvv wcel cA cB cJ ctop wcel cJ c0 csn cif cop csubsp cfv wcel cA vv cv
      cB cin wceq vv cJ ctop wcel cJ c0 csn cif wrex wb wi wi cJ c0 csn cJ cJ
      ctop wcel cJ c0 csn cif wceq cB cvv wcel cA cB cJ cop csubsp cfv wcel cA
      vv cv cB cin wceq vv cJ wrex wb wi cB cvv wcel cA cB cJ ctop wcel cJ c0
      csn cif cop csubsp cfv wcel cA vv cv cB cin wceq vv cJ ctop wcel cJ c0
      csn cif wrex wb wi cA cC wcel cJ cJ ctop wcel cJ c0 csn cif wceq cA cB cJ
      cop csubsp cfv wcel cA vv cv cB cin wceq vv cJ wrex wb cA cB cJ ctop wcel
      cJ c0 csn cif cop csubsp cfv wcel cA vv cv cB cin wceq vv cJ ctop wcel cJ
      c0 csn cif wrex wb cB cvv wcel cJ cJ ctop wcel cJ c0 csn cif wceq cA cB
      cJ cop csubsp cfv wcel cA cB cJ ctop wcel cJ c0 csn cif cop csubsp cfv
      wcel cA vv cv cB cin wceq vv cJ wrex cA vv cv cB cin wceq vv cJ ctop wcel
      cJ c0 csn cif wrex cJ cJ ctop wcel cJ c0 csn cif wceq cB cJ cop csubsp
      cfv cB cJ ctop wcel cJ c0 csn cif cop csubsp cfv cA cJ cJ ctop wcel cJ c0
      csn cif wceq cB cJ cop cB cJ ctop wcel cJ c0 csn cif cop csubsp cJ cJ
      ctop wcel cJ c0 csn cif cB opeq2 fveq2d eleq2d cA vv cv cB cin wceq vv cJ
      cJ ctop wcel cJ c0 csn cif rexeq1 bibi12d imbi2d imbi2d cA cC wcel cB cvv
      wcel cA cB cJ ctop wcel cJ c0 csn cif cop csubsp cfv wcel cA vv cv cB cin
      wceq vv cJ ctop wcel cJ c0 csn cif wrex wb vv cA cB cC cJ ctop wcel cJ c0
      csn cif cJ c0 csn ctop sn0top elimel issubsplem1 ex dedth 3imp $.
      $( [1-Dec-2010] $) $( [5-Jan-2009] $)
  $}

  ${
    $d o A $. $d o B $. $d o J $. $d o S $. $d o X $.
    elsubsp.1 $e |- X = U. J $.
    $( Result used many times.   (Contributed by Jeff Hankins, 11-Jul-2009.) $)
    elsubsp $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( A e. J /\ B = ( A i^i S ) ) )
                  -> B e. ( subSp ` <. S , J >. ) ) $=
      cJ ctop wcel cS cX wss wa cA cJ wcel cB cA cS cin wceq wa wa cB cS cJ cop
      csubsp cfv wcel cB vo cv cS cin wceq vo cJ wrex cA cJ wcel cB cA cS cin
      wceq wa cB vo cv cS cin wceq vo cJ wrex cJ ctop wcel cS cX wss wa cB vo
      cv cS cin wceq cB cA cS cin wceq vo cA cJ vo cv cA wceq vo cv cS cin cA
      cS cin cB vo cv cA cS ineq1 eqeq2d rcla4ev adantl cJ ctop wcel cB cvv
      wcel cS cvv wcel cB cS cJ cop csubsp cfv wcel cB vo cv cS cin wceq vo cJ
      wrex wb cJ ctop wcel cS cX wss wa cA cJ wcel cB cA cS cin wceq wa wa vo
      cB cS cvv cJ issubspt cJ ctop wcel cS cX wss cA cJ wcel cB cA cS cin wceq
      wa simpll cB cA wss cA cJ wcel cB cvv wcel cJ ctop wcel cS cX wss wa cA
      cJ wcel cB cA cS cin wceq wa wa cB cA cJ ssexg cB cA cS cin wceq cB cA
      wss cJ ctop wcel cS cX wss wa cA cJ wcel cB cA cS cin wceq cB cA wss cA
      cS cin cA wss cA cS inss1 cB cA cS cin cA sseq1 mpbiri ad2antll cJ ctop
      wcel cS cX wss wa cA cJ wcel cB cA cS cin wceq simprl sylanc cJ ctop wcel
      cS cX wss wa cS cvv wcel cA cJ wcel cB cA cS cin wceq wa cJ ctop wcel cS
      cJ cuni wss cS cvv wcel cS cX wss cJ cuni cvv wcel cS cJ cuni wss cS cvv
      wcel cJ ctop wcel cS cJ cuni wss cJ cuni cvv wcel cS cvv wcel cS cJ cuni
      cvv ssexg ancoms cJ ctop uniexg sylan cX cJ cuni cS elsubsp.1 sseq2i
      sylan2b adantr syl3anc mpbird $.
      $( [1-Dec-2010] $) $( [11-Jul-2009] $)
  $}

  ${
    $d o t J $. $d o t X $.
    subspid.1 $e |- X = U. J $.
    $( The subspace topology of the base set is the original topology.
       (Contributed by Jeff Hankins, 9-Jul-2009.) $)
    subspid $p |- ( J e. Top -> ( subSp ` <. X , J >. ) = J ) $=
      cJ ctop wcel vo cX cJ cop csubsp cfv cJ cJ ctop wcel vo cv cX cJ cop
      csubsp cfv wcel vo cv vt cv cX cin wceq vt cJ wrex vo cv cJ wcel cJ ctop
      wcel cX cvv wcel vo cv cX cJ cop csubsp cfv wcel vo cv vt cv cX cin wceq
      vt cJ wrex wb cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg subspid.1
      syl5eqel cJ ctop wcel vo cv cvv wcel cX cvv wcel vo cv cX cJ cop csubsp
      cfv wcel vo cv vt cv cX cin wceq vt cJ wrex wb vo visset vt vo cv cX cvv
      cJ issubspt mp3an2 mpdan cJ ctop wcel vo cv vt cv cX cin wceq vt cJ wrex
      vo cv cJ wcel cJ ctop wcel vo cv vt cv cX cin wceq vo cv cJ wcel vt cJ vo
      cv vt cv cX cin wceq vo cv cJ wcel vt cv cX cin cJ wcel cJ ctop wcel vt
      cv cJ wcel wa vo cv vt cv cX cin cJ eleq1 cJ ctop wcel vt cv cJ wcel cX
      cJ wcel vt cv cX cin cJ wcel cJ ctop wcel cX cJ wcel vt cv cJ wcel cJ cX
      subspid.1 topopn adantr vt cv cX cJ inopn mpd3an3 syl5cbir r19.23adva cJ
      ctop wcel vo cv cJ wcel vo cv vt cv cX cin wceq vt cJ wrex vo cv cJ wcel
      vo cv vo cv cX cin wceq vo cv vt cv cX cin wceq vt cJ wrex cJ ctop wcel
      vo cv cJ wcel wa vo cv vt cv cX cin wceq vo cv vo cv cX cin wceq vt vo cv
      cJ vt cv vo cv wceq vt cv cX cin vo cv cX cin vo cv vt cv vo cv cX ineq1
      eqeq2d rcla4ev cJ ctop wcel vo cv cJ wcel pm3.27 cJ ctop wcel vo cv cJ
      wcel wa vo cv cX cin vo cv cJ ctop wcel vo cv cJ wcel wa vo cv cX wss vo
      cv cX cin vo cv wceq vo cv cJ cX subspid.1 eltopss vo cv cX df-ss sylib
      eqcomd sylanc ex impbid bitrd eqrdv $.
      $( [1-Dec-2010] $) $( [9-Jul-2009] $)
  $}

  ${
    $d A x y $. $d J x y $.
    stoiglem.1 $e |- J e. Top $.
    stoiglem.2 $e |- A C_ U. J $.
    $( The underlying set of a subspace topology.  (Contributed by
       FL, 28-Jan-2009.) $)
    stoiglem $p |- <. A , ( subSp ` <. A , J >. ) >. e. TopSp $=
      cA cA cJ cop csubsp cfv cop ctps wcel cA cJ cop csubsp cfv ctop wcel cA
      cA cJ cop csubsp cfv cuni wceq cA cA cJ cop csubsp cfv istps cA cJ cop
      csubsp cfv vy cv vx cv cA cin wceq vx cJ wrex vy cab ctop vx vy cA cJ
      stoiglem.1 cA cJ cuni cJ ctop wcel cJ cuni cvv wcel stoiglem.1 cJ ctop
      uniexg ax-mp stoiglem.2 ssexi subsp cJ ctop wcel vy cv vx cv cA cin wceq
      vx cJ wrex vy cab ctop wcel stoiglem.1 vy vx cJ cA subtop ax-mp eqeltri
      cA vy cv vx cv cA cin wceq vx cJ wrex vy cab cuni cA cJ cop csubsp cfv
      cuni cA cA cJ cuni cin cJ cuni cA cin vy cv vx cv cA cin wceq vx cJ wrex
      vy cab cuni cA cJ cuni wss cA cA cJ cuni cin wceq stoiglem.2 cA cJ cuni
      dfss mpbi cA cJ cuni incom vy vx cJ cA ntunte 3eqtri cA cJ cop csubsp cfv
      vy cv vx cv cA cin wceq vx cJ wrex vy cab vx vy cA cJ stoiglem.1 cA cJ
      cuni cJ ctop wcel cJ cuni cvv wcel stoiglem.1 cJ ctop uniexg ax-mp
      stoiglem.2 ssexi subsp unieqi eqtr4i mpbir2an $.
      $( [1-Dec-2010] $) $( [5-Jan-2009] $)
  $}

  $( The topological space built with a subspace topology.  (Contributed by
     FL, 28-Jan-2009.) $)
  stoig $p |- ( ( J e. Top /\ A C_ U. J ) ->
   <. A , ( subSp ` <. A , J >. ) >. e. TopSp ) $=
    cJ ctop wcel cA cJ cuni wss wa cA cA cJ cop csubsp cfv cop ctps wcel cA cA
    cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cop csubsp cfv cop ctps wcel
    cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cA
    c0 cif cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cop csubsp cfv cop ctps
    wcel cJ cA c0 csn c0 cJ cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif wceq
    cA cA cJ cop csubsp cfv cop cA cA cJ ctop wcel cA cJ cuni wss wa cJ c0 csn
    cif cop csubsp cfv cop ctps cJ cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif
    wceq cA cJ cop csubsp cfv cA cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif
    cop csubsp cfv cA cJ cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif wceq cA
    cJ cop cA cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cop csubsp cJ cJ
    ctop wcel cA cJ cuni wss wa cJ c0 csn cif cA opeq2 fveq2d opeq2d eleq1d cA
    cJ ctop wcel cA cJ cuni wss wa cA c0 cif wceq cA cA cJ ctop wcel cA cJ cuni
    wss wa cJ c0 csn cif cop csubsp cfv cop cJ ctop wcel cA cJ cuni wss wa cA
    c0 cif cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss
    wa cJ c0 csn cif cop csubsp cfv cop ctps cA cJ ctop wcel cA cJ cuni wss wa
    cA c0 cif wceq cA cJ ctop wcel cA cJ cuni wss wa cA c0 cif cA cJ ctop wcel
    cA cJ cuni wss wa cJ c0 csn cif cop csubsp cfv cJ ctop wcel cA cJ cuni wss
    wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cop csubsp cfv cA
    cJ ctop wcel cA cJ cuni wss wa cA c0 cif wceq id cA cJ ctop wcel cA cJ cuni
    wss wa cA c0 cif wceq cA cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cop
    cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cJ
    c0 csn cif cop csubsp cA cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop
    wcel cA cJ cuni wss wa cJ c0 csn cif opeq1 fveq2d opeq12d eleq1d cJ ctop
    wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cJ c0 csn
    cif cJ ctop wcel cA cJ cuni wss wa cJ ctop wcel cA cJ cuni wss wa cJ c0 csn
    cif ctop wcel cJ ctop wcel cA cJ cuni wss wa cJ ctop wcel cA cJ cuni wss wa
    cJ c0 csn cif cJ ctop cJ ctop wcel cA cJ cuni wss wa cJ c0 csn iftrue cJ
    ctop wcel cA cJ cuni wss pm3.26 eqeltrd cJ ctop wcel cA cJ cuni wss wa wn
    cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif c0 csn ctop cJ ctop wcel cA cJ
    cuni wss wa cJ c0 csn iffalse sn0top syl6eqel pm2.61i cJ ctop wcel cA cJ
    cuni wss wa cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ
    cuni wss wa cJ c0 csn cif cuni wss cJ ctop wcel cA cJ cuni wss wa cJ ctop
    wcel cA cJ cuni wss wa cA c0 cif cA wceq cJ ctop wcel cA cJ cuni wss wa cJ
    c0 csn cif cJ wceq cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA
    cJ cuni wss wa cJ c0 csn cif cuni wss cJ ctop wcel cA cJ cuni wss wa cA c0
    iftrue cJ ctop wcel cA cJ cuni wss wa cJ c0 csn iftrue cJ ctop wcel cA cJ
    cuni wss wa cA c0 cif cA wceq cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif
    cJ wceq wa cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ cuni
    wss wa cJ c0 csn cif cuni wss cA cJ cuni wss cJ ctop wcel cA cJ cuni wss wa
    cJ ctop wcel cA cJ cuni wss wa cA c0 cif cA wceq cJ ctop wcel cA cJ cuni
    wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cuni wss cA
    cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cuni wss cJ ctop wcel cA cJ
    cuni wss wa cJ c0 csn cif cJ wceq cA cJ cuni wss cJ ctop wcel cA cJ cuni
    wss wa cA c0 cif cA cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cuni sseq1
    cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cJ wceq cJ ctop wcel cA cJ
    cuni wss wa cJ c0 csn cif cuni cJ cuni cA cJ ctop wcel cA cJ cuni wss wa cJ
    c0 csn cif cJ unieq sseq2d sylan9bb cJ ctop wcel cA cJ cuni wss pm3.27
    syl5cbir mp2and cJ ctop wcel cA cJ cuni wss wa cA c0 cif c0 wceq cJ ctop
    wcel cA cJ cuni wss wa cJ c0 csn cif c0 csn wceq cJ ctop wcel cA cJ cuni
    wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif cuni wss cJ
    ctop wcel cA cJ cuni wss wa wn cJ ctop wcel cA cJ cuni wss wa cA c0 cif c0
    wceq cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif c0 csn wceq wa cJ ctop
    wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel cA cJ cuni wss wa cJ c0 csn
    cif cuni wss c0 c0 csn cuni wss c0 csn cuni 0ss cJ ctop wcel cA cJ cuni wss
    wa cA c0 cif c0 wceq cJ ctop wcel cA cJ cuni wss wa cA c0 cif cJ ctop wcel
    cA cJ cuni wss wa cJ c0 csn cif cuni wss c0 cJ ctop wcel cA cJ cuni wss wa
    cJ c0 csn cif cuni wss cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif c0 csn
    wceq c0 c0 csn cuni wss cJ ctop wcel cA cJ cuni wss wa cA c0 cif c0 cJ ctop
    wcel cA cJ cuni wss wa cJ c0 csn cif cuni sseq1 cJ ctop wcel cA cJ cuni wss
    wa cJ c0 csn cif c0 csn wceq cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif
    cuni c0 csn cuni c0 cJ ctop wcel cA cJ cuni wss wa cJ c0 csn cif c0 csn
    unieq sseq2d sylan9bb mpbiri cJ ctop wcel cA cJ cuni wss wa cA c0 iffalse
    cJ ctop wcel cA cJ cuni wss wa cJ c0 csn iffalse sylanc pm2.61i stoiglem
    dedth2v $.
    $( [1-Dec-2010] $) $( [5-Jan-2009] $)

  $( The underlying set of a subspace topology.  (Contributed by FL,
     28-Jan-2009.) $)
  stoig2 $p |- ( ( J e. Top /\ A C_ U. J ) ->
   U. ( subSp ` <. A , J >. ) = A ) $=
    cJ ctop wcel cA cJ cuni wss wa cA cA cJ cop csubsp cfv cop ctps wcel cA cJ
    cop csubsp cfv cuni cA wceq cA cJ stoig cA cA cJ cop csubsp cfv cop ctps
    wcel cA cJ cop csubsp cfv ctop wcel cA cA cJ cop csubsp cfv cuni wceq wa cA
    cJ cop csubsp cfv cuni cA wceq cA cA cJ cop csubsp cfv istps cA cA cJ cop
    csubsp cfv cuni wceq cA cJ cop csubsp cfv cuni cA wceq cA cJ cop csubsp cfv
    ctop wcel cA cJ cop csubsp cfv cuni cA wceq cA cJ cop csubsp cfv cuni cA cA
    cJ cop csubsp cfv cuni cA wceq id eqcoms adantl sylbi syl $.
    $( [1-Dec-2010] $) $( [5-Jan-2009] $)

  $( A subspace topology is a topology.  (Contributed by FL, 28-Jan-2009.) $)
  stoig3 $p |- ( ( J e. Top /\ A C_ U. J ) ->
    ( subSp ` <. A , J >. ) e. Top ) $=
    cJ ctop wcel cA cJ cuni wss wa cA cA cJ cop csubsp cfv cop ctps wcel cA cJ
    cop csubsp cfv ctop wcel cA cJ stoig cA cA cJ cop csubsp cfv cop ctps wcel
    cA cJ cop csubsp cfv ctop wcel cA cA cJ cop csubsp cfv cuni wceq cA cA cJ
    cop csubsp cfv istps pm3.26bi syl $.
    $( [1-Dec-2010] $) $( [5-Jan-2009] $)

  ${
    $d o x A $. $d o x J $. $d o x S $. $d o x X $.
    subcld.1 $e |- X = U. J $.
    $( A closed set of a subspace topology is a closed set of the original
    topology intersected with the subset.  (Contributed by FL, 11-Jul-2009.) $)
    subcld $p |- ( ( J e. Top /\ S C_ X ) -> ( A e. ( Clsd ` ( subSp ` <. S , J
    >. ) ) <-> E. x e. ( Clsd ` J ) A = ( x i^i S ) ) ) $=
      cJ ctop wcel cS cX wss wa cA cS cJ cop csubsp cfv ccld cfv wcel cA cS cJ
      cop csubsp cfv cuni wss cS cJ cop csubsp cfv cuni cA cdif cS cJ cop
      csubsp cfv wcel wa cA cS wss cS cA cdif cS cJ cop csubsp cfv wcel wa cA
      vx cv cS cin wceq vx cJ ccld cfv wrex cJ ctop wcel cS cX wss wa cS cJ cop
      csubsp cfv ctop wcel cA cS cJ cop csubsp cfv ccld cfv wcel cA cS cJ cop
      csubsp cfv cuni wss cS cJ cop csubsp cfv cuni cA cdif cS cJ cop csubsp
      cfv wcel wa wb cJ ctop wcel cS cJ cuni wss cS cJ cop csubsp cfv ctop wcel
      cS cX wss cS cJ stoig3 cX cJ cuni cS subcld.1 sseq2i sylan2b cA cS cJ cop
      csubsp cfv cS cJ cop csubsp cfv cuni cS cJ cop csubsp cfv cuni eqid iscld
      syl cJ ctop wcel cS cJ cuni wss cA cS cJ cop csubsp cfv cuni wss cS cJ
      cop csubsp cfv cuni cA cdif cS cJ cop csubsp cfv wcel wa cA cS wss cS cA
      cdif cS cJ cop csubsp cfv wcel wa wb cS cX wss cJ ctop wcel cS cJ cuni
      wss wa cA cS cJ cop csubsp cfv cuni wss cA cS wss cS cJ cop csubsp cfv
      cuni cA cdif cS cJ cop csubsp cfv wcel cS cA cdif cS cJ cop csubsp cfv
      wcel cJ ctop wcel cS cJ cuni wss wa cS cJ cop csubsp cfv cuni cS cA cS cJ
      stoig2 sseq2d cJ ctop wcel cS cJ cuni wss wa cS cJ cop csubsp cfv cuni cA
      cdif cS cA cdif cS cJ cop csubsp cfv cJ ctop wcel cS cJ cuni wss wa cS cJ
      cop csubsp cfv cuni cS cA cS cJ stoig2 difeq1d eleq1d anbi12d cX cJ cuni
      cS subcld.1 sseq2i sylan2b cJ ctop wcel cS cX wss wa cA cS wss cS cA cdif
      cS cJ cop csubsp cfv wcel wa cA vx cv cS cin wceq vx cJ ccld cfv wrex cJ
      ctop wcel cS cX wss wa cA cS wss cS cA cdif cS cJ cop csubsp cfv wcel wa
      cA cS wss cS cA cdif vo cv cS cin wceq vo cJ wrex wa cA vx cv cS cin wceq
      vx cJ ccld cfv wrex cJ ctop wcel cS cX wss wa cS cA cdif cS cJ cop csubsp
      cfv wcel cS cA cdif vo cv cS cin wceq vo cJ wrex cA cS wss cJ ctop wcel
      cS cA cdif cvv wcel cS cvv wcel cS cA cdif cS cJ cop csubsp cfv wcel cS
      cA cdif vo cv cS cin wceq vo cJ wrex wb cJ ctop wcel cS cX wss wa vo cS
      cA cdif cS cvv cJ issubspt cJ ctop wcel cS cX wss pm3.26 cJ cuni cvv wcel
      cS cJ cuni wss cS cA cdif cvv wcel cJ ctop wcel cS cX wss cS cJ cuni wss
      cJ cuni cvv wcel cS cA cdif cvv wcel cS cA cdif cJ cuni wss cJ cuni cvv
      wcel cS cA cdif cvv wcel cS cJ cuni wss cS cA cdif cJ cuni cvv ssexg cS
      cJ cuni cA ssdifss sylan ancoms cJ ctop uniexg cS cX wss cS cJ cuni wss
      cX cJ cuni cS subcld.1 sseq2i biimpi syl2an cJ cuni cvv wcel cS cJ cuni
      wss cS cvv wcel cJ ctop wcel cS cX wss cS cJ cuni wss cJ cuni cvv wcel cS
      cvv wcel cS cJ cuni cvv ssexg ancoms cJ ctop uniexg cS cX wss cS cJ cuni
      wss cX cJ cuni cS subcld.1 sseq2i biimpi syl2an syl3anc anbi2d cJ ctop
      wcel cS cX wss wa cA cS wss cS cA cdif vo cv cS cin wceq vo cJ wrex cA vx
      cv cS cin wceq vx cJ ccld cfv wrex cJ ctop wcel cS cX wss wa cA cS wss wa
      cS cA cdif vo cv cS cin wceq cA vx cv cS cin wceq vx cJ ccld cfv wrex vo
      cJ cJ ctop wcel cS cX wss wa cA cS wss wa vo cv cJ wcel wa cS cA cdif vo
      cv cS cin wceq cA vx cv cS cin wceq vx cJ ccld cfv wrex cX vo cv cdif cJ
      ccld cfv wcel cA cX vo cv cdif cS cin wceq cA vx cv cS cin wceq vx cJ
      ccld cfv wrex cJ ctop wcel cS cX wss wa cA cS wss wa vo cv cJ wcel wa cS
      cA cdif vo cv cS cin wceq wa cA vx cv cS cin wceq cA cX vo cv cdif cS cin
      wceq vx cX vo cv cdif cJ ccld cfv vx cv cX vo cv cdif wceq vx cv cS cin
      cX vo cv cdif cS cin cA vx cv cX vo cv cdif cS ineq1 eqeq2d rcla4ev cJ
      ctop wcel cS cX wss wa cA cS wss wa vo cv cJ wcel wa cX vo cv cdif cJ
      ccld cfv wcel cS cA cdif vo cv cS cin wceq cJ ctop wcel cS cX wss wa vo
      cv cJ wcel cX vo cv cdif cJ ccld cfv wcel cA cS wss cJ ctop wcel vo cv cJ
      wcel cX vo cv cdif cJ ccld cfv wcel cS cX wss vo cv cJ cX subcld.1 opncld
      adantlr adantlr adantr cJ ctop wcel cS cX wss wa cA cS wss wa vo cv cJ
      wcel wa cS cA cdif vo cv cS cin wceq wa cA cX cS cin vo cv cdif cX vo cv
      cdif cS cin cJ ctop wcel cS cX wss wa cA cS wss wa vo cv cJ wcel wa cS cA
      cdif vo cv cS cin wceq wa cX cS cin vo cv cdif cS vo cv cdif cS cS cA
      cdif cdif cA cJ ctop wcel cS cX wss wa cA cS wss wa vo cv cJ wcel wa cS
      cA cdif vo cv cS cin wceq wa cX cS cin cS vo cv cJ ctop wcel cS cX wss wa
      cA cS wss wa cX cS cin cS wceq vo cv cJ wcel cS cA cdif vo cv cS cin wceq
      cS cX wss cX cS cin cS wceq cJ ctop wcel cA cS wss cS cX wss cS cX cin cS
      cX cS cin cS cX wss cS cX cin cS wceq cS cX df-ss biimpi cX cS incom
      syl5eq ad2antlr ad2antrr difeq1d cS cA cdif vo cv cS cin wceq cS cS cA
      cdif cdif cS vo cv cdif wceq cJ ctop wcel cS cX wss wa cA cS wss wa vo cv
      cJ wcel wa cS cA cdif vo cv cS cin wceq cS cS cA cdif cdif cS vo cv cS
      cin cdif cS vo cv cdif cS cA cdif vo cv cS cin cS difeq2 cS vo cv cS cin
      cdif cS vo cv cdif cS cS cdif cun cS vo cv cdif c0 cun cS vo cv cdif cS
      vo cv cS difindi cS cS cdif c0 cS vo cv cdif cS difid uneq2i cS vo cv
      cdif un0 3eqtri syl6eq adantl cJ ctop wcel cS cX wss wa cA cS wss wa cS
      cS cA cdif cdif cA wceq vo cv cJ wcel cS cA cdif vo cv cS cin wceq cA cS
      wss cS cS cA cdif cdif cA wceq cJ ctop wcel cS cX wss wa cA cS wss cS cS
      cA cdif cdif cA wceq cA cS dfss4 biimpi adantl ad2antrr 3eqtr2rd cX cS
      cin vo cv cdif cS cX cin vo cv cdif cS cX vo cv cdif cin cX vo cv cdif cS
      cin cX cS cin cS cX cin vo cv cX cS incom difeq1i cS cX vo cv indif2 cS
      cX vo cv cdif incom 3eqtr2i syl6eq sylanc ex r19.23adva expimpd sylbid cJ
      ctop wcel cS cX wss wa cA vx cv cS cin wceq cA cS wss cS cA cdif cS cJ
      cop csubsp cfv wcel wa vx cJ ccld cfv cJ ctop wcel cS cX wss wa vx cv cJ
      ccld cfv wcel wa cA vx cv cS cin wceq cA cS wss cS cA cdif cS cJ cop
      csubsp cfv wcel cA vx cv cS cin wceq cA cS wss wi cJ ctop wcel cS cX wss
      wa vx cv cJ ccld cfv wcel wa cA vx cv cS cin wceq cA cS wss vx cv cS cin
      cS wss vx cv cS inss2 cA vx cv cS cin cS sseq1 mpbiri a1i cJ ctop wcel cS
      cX wss wa vx cv cJ ccld cfv wcel wa cA vx cv cS cin wceq cS cA cdif cS cJ
      cop csubsp cfv wcel cJ ctop wcel cS cX wss wa cX vx cv cdif cJ wcel cS cA
      cdif cX vx cv cdif cS cin wceq cS cA cdif cS cJ cop csubsp cfv wcel cJ
      ctop wcel cS cX wss wa vx cv cJ ccld cfv wcel wa cA vx cv cS cin wceq wa
      cJ ctop wcel cS cX wss wa vx cv cJ ccld cfv wcel cA vx cv cS cin wceq
      simpll cJ ctop wcel cS cX wss wa vx cv cJ ccld cfv wcel wa cX vx cv cdif
      cJ wcel cA vx cv cS cin wceq cJ ctop wcel vx cv cJ ccld cfv wcel cX vx cv
      cdif cJ wcel cS cX wss vx cv cJ cX subcld.1 cldopn adantlr adantr cJ ctop
      wcel cS cX wss wa vx cv cJ ccld cfv wcel wa cA vx cv cS cin wceq wa cS cA
      cdif cS vx cv cS cin cdif cS vx cv cdif cX vx cv cdif cS cin cA vx cv cS
      cin wceq cS cA cdif cS vx cv cS cin cdif wceq cJ ctop wcel cS cX wss wa
      vx cv cJ ccld cfv wcel wa cA vx cv cS cin cS difeq2 adantl cS vx cv cS
      cin cdif cS vx cv cdif wceq cJ ctop wcel cS cX wss wa vx cv cJ ccld cfv
      wcel wa cA vx cv cS cin wceq wa cS vx cv cS cin cdif cS vx cv cdif cS cS
      cdif cun cS vx cv cdif c0 cun cS vx cv cdif cS vx cv cS difindi cS cS
      cdif c0 cS vx cv cdif cS difid uneq2i cS vx cv cdif un0 3eqtri a1i cJ
      ctop wcel cS cX wss wa cS vx cv cdif cX vx cv cdif cS cin wceq vx cv cJ
      ccld cfv wcel cA vx cv cS cin wceq cS cX wss cS vx cv cdif cX vx cv cdif
      cS cin wceq cJ ctop wcel cS cX wss cS vx cv cdif cX cS cin vx cv cdif cX
      vx cv cdif cS cin cS cX wss cS cX cS cin vx cv cS cX wss cS cX cin cS cX
      cS cin cS cX wss cS cX cin cS wceq cS cX df-ss biimpi cX cS incom syl5req
      difeq1d cX vx cv cdif cS cin cS cX vx cv cdif cin cS cX cin vx cv cdif cX
      cS cin vx cv cdif cX vx cv cdif cS incom cS cX vx cv indif2 cS cX cin cX
      cS cin vx cv cS cX incom difeq1i 3eqtrri syl6eq adantl ad2antrr 3eqtrd cX
      vx cv cdif cS cA cdif cS cJ cX subcld.1 elsubsp sylan32c ex jcad
      r19.23adva impbid 3bitrd $.
      $( [1-Dec-2010] $) $( [11-Jul-2009] $)
  $}

  ${
    $d o r s t x y z A $. $d o r s t x y z C $. $d o r s t x y z D $. $d o r s
    t x y z J $. $d o r s t x y z K $. $d o r s t x y z X $. $d o r s t x y z Y
    $.
    subtopmet.1 $e |- D = ( C |` ( Y X. Y ) ) $.
    subtopmet.2 $e |- X = dom dom C $.
    subtopmet.j $e |- J = ( Open ` C ) $.
    subtopmet.k $e |- K = ( Open ` D ) $.
    ${
      subtopmet.a $e |- A e. _V $.
      $( Lemma for ~ subtopmet .   (Contributed by Jeff Hankins,
         21-Aug-2009.) $)
      subtopmetlem $p |- ( ( C e. Met /\ Y C_ X ) -> ( A e. ( subSp ` <. Y , J
      >. ) -> A e. K ) ) $=
        cC cme wcel cY cX wss wa cA vy cv cY cin wceq vy cJ wrex cA cD cdm cdm
        wss vx cv vo cv wcel vo cv cA wss wa vo cD cbl cfv crn wrex vx cA wral
        wa cA cY cJ cop csubsp cfv wcel cA cK wcel cC cme wcel cY cX wss wa cA
        vy cv cY cin wceq cA cD cdm cdm wss vx cv vo cv wcel vo cv cA wss wa vo
        cD cbl cfv crn wrex vx cA wral wa vy cJ cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq cA cD cdm cdm wss vx cv vo cv wcel vo cv
        cA wss wa vo cD cbl cfv crn wrex vx cA wral wa cC cme wcel cY cX wss wa
        vy cv cJ wcel cA vy cv cY cin wceq w3a cA cD cdm cdm wss vx cv vo cv
        wcel vo cv cA wss wa vo cD cbl cfv crn wrex vx cA wral cC cme wcel cY
        cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a cA cY cD cdm cdm cA vy
        cv cY cin wceq cC cme wcel cY cX wss wa cA cY wss vy cv cJ wcel cA vy
        cv cY cin wceq cA cY wss vy cv cY cin cY wss vy cv cY inss2 cA vy cv cY
        cin cY sseq1 mpbiri 3ad2ant3 cC cme wcel cY cX wss wa vy cv cJ wcel cY
        cD cdm cdm wceq cA vy cv cY cin wceq cC cD cX cY subtopmet.1
        subtopmet.2 basmetres 3ad2ant1 sseqtrd cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv vo cv wcel vo cv cA wss wa vo cD
        cbl cfv crn wrex vx cA cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv
        cY cin wceq w3a vx cv cA wcel wa cc0 vr cv clt wbr vx cv vr cv cC cbl
        cfv co vy cv wss wa vr cr wrex vx cv vo cv wcel vo cv cA wss wa vo cD
        cbl cfv crn wrex cC cme wcel vy cv cJ wcel vx cv vy cv wcel cc0 vr cv
        clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa vr cr wrex cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel wa vr
        vy cv cC vx cv cJ subtopmet.j opni2 cC cme wcel cY cX wss wa vy cv cJ
        wcel cA vy cv cY cin wceq w3a cC cme wcel vx cv cA wcel cC cme wcel cY
        cX wss wa vy cv cJ wcel cC cme wcel cA vy cv cY cin wceq cC cme wcel cY
        cX wss pm3.26 3ad2ant1 adantr cC cme wcel cY cX wss wa vy cv cJ wcel cA
        vy cv cY cin wceq w3a vy cv cJ wcel vx cv cA wcel cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq 3simp2 adantr cA vy cv wss vx cv
        cA wcel vx cv vy cv wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA vy
        cv cY cin wceq w3a cA vy cv vx cv ssel2 cA vy cv cY cin wceq cC cme
        wcel cY cX wss wa cA vy cv wss vy cv cJ wcel cA vy cv cY cin wceq cA vy
        cv wss vy cv cY cin vy cv wss vy cv cY inss1 cA vy cv cY cin vy cv
        sseq1 mpbiri 3ad2ant3 sylan syl3anc cC cme wcel cY cX wss wa vy cv cJ
        wcel cA vy cv cY cin wceq w3a vx cv cA wcel wa cc0 vr cv clt wbr vx cv
        vr cv cC cbl cfv co vy cv wss wa vx cv vo cv wcel vo cv cA wss wa vo cD
        cbl cfv crn wrex vr cr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv
        cY cin wceq w3a vx cv cA wcel vr cv cr wcel cc0 vr cv clt wbr vx cv vr
        cv cC cbl cfv co vy cv wss wa vx cv vo cv wcel vo cv cA wss wa vo cD
        cbl cfv crn wrex wi cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY
        cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr
        cv cC cbl cfv co vy cv wss wa vx cv vo cv wcel vo cv cA wss wa vo cD
        cbl cfv crn wrex vx cv vr cv cD cbl cfv co cD cbl cfv crn wcel vx cv vx
        cv vr cv cD cbl cfv co wcel vx cv vr cv cD cbl cfv co cA wss vx cv vo
        cv wcel vo cv cA wss wa vo cD cbl cfv crn wrex cC cme wcel cY cX wss wa
        vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a
        cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa cD cme wcel
        vx cv cD cdm cdm wcel vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cD
        cbl cfv co cD cbl cfv crn wcel cC cme wcel cY cX wss wa vy cv cJ wcel
        cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt
        wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa cD vx cv vr cv cD cdm cdm
        cD cdm cdm eqid blelrn cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv
        cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cD cme wcel cc0 vr cv
        clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa cC cme wcel cY cX wss wa
        vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel cD cme wcel vr cv
        cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel cD cme wcel cA vy cv cY
        cin wceq cC cme wcel cD cme wcel cY cX wss cC cme wcel cC cY cY cxp
        cres cme cD cC cY metres subtopmet.1 syl5eqel adantr 3ad2ant1 3ad2ant1
        adantr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a
        vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl
        cfv co vy cv wss wa wa vx cv cY cD cdm cdm cC cme wcel cY cX wss wa vy
        cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a vx
        cv cY wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa cA
        cY wss vx cv cA wcel vr cv cr wcel vx cv cY wcel cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq w3a cA cY wss vx cv cA wcel vx cv
        cY wcel vr cv cr wcel cA cY vx cv ssel2 3adant3 cA vy cv cY cin wceq cC
        cme wcel cY cX wss wa cA cY wss vy cv cJ wcel cA vy cv cY cin wceq cA
        cY wss vy cv cY cin cY wss vy cv cY inss2 cA vy cv cY cin cY sseq1
        mpbiri 3ad2ant3 syl3an1 adantr cC cme wcel cY cX wss wa vy cv cJ wcel
        cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cY cD cdm cdm
        wceq cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        cY cD cdm cdm wceq vr cv cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel
        cY cD cdm cdm wceq cA vy cv cY cin wceq cC cD cX cY subtopmet.1
        subtopmet.2 basmetres 3ad2ant1 3ad2ant1 adantr eleqtrd cC cme wcel cY
        cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr
        wcel w3a vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy
        cv wss wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq
        w3a vx cv cA wcel vr cv cr wcel 3simp3 adantr cC cme wcel cY cX wss wa
        vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a
        cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss simprl syl2anc cD
        cme wcel vx cv cD cdm cdm wcel vr cv cr wcel cc0 vr cv clt wbr vx cv vx
        cv vr cv cD cbl cfv co wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA
        vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr
        vx cv vr cv cC cbl cfv co vy cv wss wa wa cD vx cv vr cv cD cdm cdm cD
        cdm cdm eqid blcntr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY
        cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cD cme wcel cc0 vr cv clt
        wbr vx cv vr cv cC cbl cfv co vy cv wss wa cC cme wcel cY cX wss wa vy
        cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel cD cme wcel vr cv cr
        wcel cC cme wcel cY cX wss wa vy cv cJ wcel cD cme wcel cA vy cv cY cin
        wceq cC cme wcel cD cme wcel cY cX wss cC cme wcel cC cY cY cxp cres
        cme cD cC cY metres subtopmet.1 syl5eqel adantr 3ad2ant1 3ad2ant1
        adantr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a
        vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl
        cfv co vy cv wss wa wa vx cv cY cD cdm cdm cC cme wcel cY cX wss wa vy
        cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a vx
        cv cY wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa cA
        cY wss vx cv cA wcel vr cv cr wcel vx cv cY wcel cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq w3a cA cY wss vx cv cA wcel vx cv
        cY wcel vr cv cr wcel cA cY vx cv ssel2 3adant3 cA vy cv cY cin wceq cC
        cme wcel cY cX wss wa cA cY wss vy cv cJ wcel cA vy cv cY cin wceq cA
        cY wss vy cv cY cin cY wss vy cv cY inss2 cA vy cv cY cin cY sseq1
        mpbiri 3ad2ant3 syl3an1 adantr cC cme wcel cY cX wss wa vy cv cJ wcel
        cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cY cD cdm cdm
        wceq cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        cY cD cdm cdm wceq vr cv cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel
        cY cD cdm cdm wceq cA vy cv cY cin wceq cC cD cX cY subtopmet.1
        subtopmet.2 basmetres 3ad2ant1 3ad2ant1 adantr eleqtrd cC cme wcel cY
        cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr
        wcel w3a vr cv cr wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy
        cv wss wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq
        w3a vx cv cA wcel vr cv cr wcel 3simp3 adantr cC cme wcel cY cX wss wa
        vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a
        cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss simprl syl2anc cC
        cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA
        wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy
        cv wss wa wa vz vx cv vr cv cD cbl cfv co cA cC cme wcel cY cX wss wa
        vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a
        cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz cv cD
        cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa vz cv vy cv cY cin wcel
        vz cv vx cv vr cv cD cbl cfv co wcel vz cv cA wcel cC cme wcel cY cX
        wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr
        wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz
        cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa vz cv vy cv wcel
        vz cv cY wcel wa vz cv vy cv cY cin wcel cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr
        cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm
        wcel vx cv vz cv cD co vr cv clt wbr wa vz cv vy cv wcel vz cv cY wcel
        cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv
        cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
        vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr
        wa vz cv vy cv wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY
        cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr
        cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD
        co vr cv clt wbr wa wa vx cv vr cv cC cbl cfv co vy cv vz cv cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss
        vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa simplrr cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss
        wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa vz cv
        vx cv vr cv cC cbl cfv co wcel vx cv vz cv cC co vr cv clt wbr cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss
        wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa vx cv
        vz cv cC co vx cv vz cv cD co vr cv clt cC wfun cD cY cY cxp wfn cD cC
        wss w3a vx cv cY wcel vz cv cY wcel vx cv vz cv cC co vx cv vz cv cD co
        wceq cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx
        cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
        co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt
        wbr wa wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq
        w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC
        cbl cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr
        cv clt wbr wa wa cC wfun cD cY cY cxp wfn cD cC wss cC cme wcel cY cX
        wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr
        wcel w3a cC wfun cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss
        wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel cC
        wfun vr cv cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel cC wfun cA vy
        cv cY cin wceq cC cme wcel cC wfun cY cX wss cC cme wcel cX cX cxp cr
        cC wf cC wfun cC cX subtopmet.2 metf cX cX cxp cr cC ffun syl adantr
        3ad2ant1 3ad2ant1 ad2antrr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy
        cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx
        cv vr cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz
        cv cD co vr cv clt wbr wa wa cD wfun cD cdm cY cY cxp wceq wa cD cY cY
        cxp wfn cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a
        vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl
        cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv
        clt wbr wa wa cD wfun cD cdm cY cY cxp wceq cC cme wcel cY cX wss wa vy
        cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0
        vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm
        cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa cC wfun cD wfun cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        vr cv cr wcel w3a cC wfun cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
        vy cv wss wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa
        cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv
        cA wcel cC wfun vr cv cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel cC
        wfun cA vy cv cY cin wceq cC cme wcel cC wfun cY cX wss cC cme wcel cX
        cX cxp cr cC wf cC wfun cC cX subtopmet.2 metf cX cX cxp cr cC ffun syl
        adantr 3ad2ant1 3ad2ant1 ad2antrr cD cC wss cC wfun cD wfun wi cD cC cY
        cY cxp cres cC subtopmet.1 cC cY cY cxp resss eqsstri cD cC funss ax-mp
        syl cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx
        cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv
        co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt
        wbr wa wa cY cY cxp cC cdm cin cY cY cxp cD cdm cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel
        w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz cv
        cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa cY cY cxp cC cdm
        wss cY cY cxp cC cdm cin cY cY cxp wceq cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr
        cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm
        wcel vx cv vz cv cD co vr cv clt wbr wa wa cY cY cxp cX cX cxp cC cdm
        cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv
        cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
        vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr
        wa wa cY cX wss cY cY cxp cX cX cxp wss cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cY cX
        wss cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa vz cv cD
        cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel cY cX wss vr cv
        cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel cY cX wss cA vy cv cY
        cin wceq cC cme wcel cY cX wss pm3.27 3ad2ant1 3ad2ant1 ad2antrr cY cX
        wss cY cY cxp cX cX cxp wss cY cX cY cX xpss12 anidms syl cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv
        cr wcel w3a cC cdm cX cX cxp wceq cc0 vr cv clt wbr vx cv vr cv cC cbl
        cfv co vy cv wss wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt
        wbr wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a
        vx cv cA wcel cC cdm cX cX cxp wceq vr cv cr wcel cC cme wcel cY cX wss
        wa vy cv cJ wcel cC cdm cX cX cxp wceq cA vy cv cY cin wceq cC cme wcel
        cC cdm cX cX cxp wceq cY cX wss cC cme wcel cX cX cxp cr cC wf cC cdm
        cX cX cxp wceq cC cX subtopmet.2 metf cX cX cxp cr cC fdm syl adantr
        3ad2ant1 3ad2ant1 ad2antrr sseqtr4d cY cY cxp cC cdm df-ss sylib cD cdm
        cC cY cY cxp cres cdm cY cY cxp cC cdm cin cD cC cY cY cxp cres
        subtopmet.1 dmeqi cC cY cY cxp dmres eqtri syl5eq jca cD cY cY cxp
        df-fn sylibr cD cC wss cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv
        cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv
        vr cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vx cv vz cv
        cD co vr cv clt wbr wa wa cD cC cY cY cxp cres cC subtopmet.1 cC cY cY
        cxp resss eqsstri a1i 3jca cC cme wcel cY cX wss wa vy cv cJ wcel cA vy
        cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a vx cv cY wcel cc0 vr
        cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa vz cv cD cdm cdm wcel
        vx cv vz cv cD co vr cv clt wbr wa cA cY wss vx cv cA wcel vr cv cr
        wcel vx cv cY wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY
        cin wceq w3a cA cY wss vx cv cA wcel vx cv cY wcel vr cv cr wcel cA cY
        vx cv ssel2 3adant3 cA vy cv cY cin wceq cC cme wcel cY cX wss wa cA cY
        wss vy cv cJ wcel cA vy cv cY cin wceq cA cY wss vy cv cY cin cY wss vy
        cv cY inss2 cA vy cv cY cin cY sseq1 mpbiri 3ad2ant3 syl3an1 ad2antrr
        cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv
        cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co
        vy cv wss wa wa vz cv cD cdm cdm wcel vz cv cY wcel vx cv vz cv cD co
        vr cv clt wbr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin
        wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv
        cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vz cv cY wcel cC
        cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA
        wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy
        cv wss wa wa cD cdm cdm cY vz cv cC cme wcel cY cX wss wa vy cv cJ wcel
        cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt
        wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa cY cD cdm cdm wceq cD cdm
        cdm cY wss cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq
        w3a vx cv cA wcel vr cv cr wcel w3a cY cD cdm cdm wceq cc0 vr cv clt
        wbr vx cv vr cv cC cbl cfv co vy cv wss wa cC cme wcel cY cX wss wa vy
        cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel cY cD cdm cdm wceq vr
        cv cr wcel cC cme wcel cY cX wss wa vy cv cJ wcel cY cD cdm cdm wceq cA
        vy cv cY cin wceq cC cD cX cY subtopmet.1 subtopmet.2 basmetres
        3ad2ant1 3ad2ant1 adantr cD cdm cdm cY eqimss2 syl sseld imp adantrr vx
        cv vz cv cY cY cC cD oprssoprv sylan32c cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr
        cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm
        wcel vx cv vz cv cD co vr cv clt wbr simprr eqbrtrd cC cme wcel vx cv
        cX wcel vz cv cX wcel w3a vr cv cr wcel cc0 vr cv clt wbr vz cv vx cv
        vr cv cC cbl cfv co wcel vx cv vz cv cC co vr cv clt wbr wb cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv
        cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa
        vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv
        cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa
        vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa cC cme wcel
        vx cv cX wcel vz cv cX wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA
        vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cC cme wcel cc0
        vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa vz cv cD cdm cdm
        wcel vx cv vz cv cD co vr cv clt wbr wa cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel cC cme wcel vr cv cr
        wcel cC cme wcel cY cX wss wa vy cv cJ wcel cC cme wcel cA vy cv cY cin
        wceq cC cme wcel cY cX wss pm3.26 3ad2ant1 3ad2ant1 ad2antrr cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss
        wa wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wa cY cX
        vx cv cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a
        vx cv cA wcel vr cv cr wcel w3a cY cX wss cc0 vr cv clt wbr vx cv vr cv
        cC cbl cfv co vy cv wss wa vz cv cD cdm cdm wcel vx cv vz cv cD co vr
        cv clt wbr wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin
        wceq w3a vx cv cA wcel cY cX wss vr cv cr wcel cC cme wcel cY cX wss wa
        vy cv cJ wcel cY cX wss cA vy cv cY cin wceq cC cme wcel cY cX wss
        pm3.27 3ad2ant1 3ad2ant1 ad2antrr cC cme wcel cY cX wss wa vy cv cJ
        wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a vx cv cY
        wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa vz cv cD
        cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa cA cY wss vx cv cA wcel
        vr cv cr wcel vx cv cY wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA
        vy cv cY cin wceq w3a cA cY wss vx cv cA wcel vx cv cY wcel vr cv cr
        wcel cA cY vx cv ssel2 3adant3 cA vy cv cY cin wceq cC cme wcel cY cX
        wss wa cA cY wss vy cv cJ wcel cA vy cv cY cin wceq cA cY wss vy cv cY
        cin cY wss vy cv cY inss2 cA vy cv cY cin cY sseq1 mpbiri 3ad2ant3
        syl3an1 ad2antrr sseldd vz cv cD cdm cdm wcel vz cv cX wcel cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv
        cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa
        vx cv vz cv cD co vr cv clt wbr vz cv cD cdm cdm wcel vz cv cC cdm cdm
        cX cD cdm cdm cC cdm cdm vz cv cD cdm cC cdm wss cD cdm cdm cC cdm cdm
        wss cD cC wss cD cdm cC cdm wss cD cC cY cY cxp cres cC subtopmet.1 cC
        cY cY cxp resss eqsstri cD cC dmss ax-mp cD cdm cC cdm dmss ax-mp sseli
        subtopmet.2 syl6eleqr ad2antrl 3jca cC cme wcel cY cX wss wa vy cv cJ
        wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a vr cv cr
        wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa vz cv cD
        cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel
        3simp3 ad2antrr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin
        wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv
        cC cbl cfv co vy cv wss vz cv cD cdm cdm wcel vx cv vz cv cD co vr cv
        clt wbr wa simplrl vz cv cC vx cv vr cv cX subtopmet.2 elbl2 sylan32c
        mpbird sseldd ex cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin
        wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv
        cC cbl cfv co vy cv wss wa wa vz cv cD cdm cdm wcel vz cv cY wcel vx cv
        vz cv cD co vr cv clt wbr cC cme wcel cY cX wss wa vy cv cJ wcel cA vy
        cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx
        cv vr cv cC cbl cfv co vy cv wss wa wa cD cdm cdm cY vz cv cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv
        cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa
        cY cY cxp cC cdm cin cdm cY cD cdm cdm cC cme wcel cY cX wss wa vy cv
        cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr
        cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa cY cY cxp cC cdm
        cin cdm cY cY cxp cdm cY cY cY cxp cC cdm cin cdm cY cY cxp cdm wss cC
        cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA
        wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy
        cv wss wa wa cY cY cxp cC cdm cin cY cY cxp wss cY cY cxp cC cdm cin
        cdm cY cY cxp cdm wss cY cY cxp cC cdm inss1 cY cY cxp cC cdm cin cY cY
        cxp dmss ax-mp a1i cY dmxpid syl6ss cD cdm cY cY cxp cC cdm cin cD cdm
        cC cY cY cxp cres cdm cY cY cxp cC cdm cin cD cC cY cY cxp cres
        subtopmet.1 dmeqi cC cY cY cxp dmres eqtri dmeqi syl5ss sseld adantrd
        jcad vz cv vy cv cY elin syl6ibr cD cme wcel vx cv cD cdm cdm wcel vr
        cv cr wcel cc0 vr cv clt wbr vz cv vx cv vr cv cD cbl cfv co wcel vz cv
        cD cdm cdm wcel vx cv vz cv cD co vr cv clt wbr wa wb cC cme wcel cY cX
        wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr
        wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vz
        cv cD vx cv vr cv cD cdm cdm cD cdm cdm eqid elbl cC cme wcel cY cX wss
        wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel
        w3a cD cme wcel cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy cv wss
        wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx
        cv cA wcel cD cme wcel vr cv cr wcel cC cme wcel cY cX wss wa vy cv cJ
        wcel cD cme wcel cA vy cv cY cin wceq cC cme wcel cD cme wcel cY cX wss
        cC cme wcel cC cY cY cxp cres cme cD cC cY metres subtopmet.1 syl5eqel
        adantr 3ad2ant1 3ad2ant1 adantr cC cme wcel cY cX wss wa vy cv cJ wcel
        cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt
        wbr vx cv vr cv cC cbl cfv co vy cv wss wa wa vx cv cY cD cdm cdm cC
        cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA
        wcel vr cv cr wcel w3a vx cv cY wcel cc0 vr cv clt wbr vx cv vr cv cC
        cbl cfv co vy cv wss wa cA cY wss vx cv cA wcel vr cv cr wcel vx cv cY
        wcel cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a cA
        cY wss vx cv cA wcel vx cv cY wcel vr cv cr wcel cA cY vx cv ssel2
        3adant3 cA vy cv cY cin wceq cC cme wcel cY cX wss wa cA cY wss vy cv
        cJ wcel cA vy cv cY cin wceq cA cY wss vy cv cY cin cY wss vy cv cY
        inss2 cA vy cv cY cin cY sseq1 mpbiri 3ad2ant3 syl3an1 adantr cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel
        vr cv cr wcel w3a cY cD cdm cdm wceq cc0 vr cv clt wbr vx cv vr cv cC
        cbl cfv co vy cv wss wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv
        cY cin wceq w3a vx cv cA wcel cY cD cdm cdm wceq vr cv cr wcel cC cme
        wcel cY cX wss wa vy cv cJ wcel cY cD cdm cdm wceq cA vy cv cY cin wceq
        cC cD cX cY subtopmet.1 subtopmet.2 basmetres 3ad2ant1 3ad2ant1 adantr
        eleqtrd cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a
        vx cv cA wcel vr cv cr wcel w3a vr cv cr wcel cc0 vr cv clt wbr vx cv
        vr cv cC cbl cfv co vy cv wss wa cC cme wcel cY cX wss wa vy cv cJ wcel
        cA vy cv cY cin wceq w3a vx cv cA wcel vr cv cr wcel 3simp3 adantr cC
        cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA
        wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv vr cv cC cbl cfv co vy
        cv wss simprl syl2anc cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv
        cY cin wceq w3a vx cv cA wcel vr cv cr wcel w3a cc0 vr cv clt wbr vx cv
        vr cv cC cbl cfv co vy cv wss wa wa cA vy cv cY cin vz cv cC cme wcel
        cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq w3a vx cv cA wcel vr cv
        cr wcel w3a cA vy cv cY cin wceq cc0 vr cv clt wbr vx cv vr cv cC cbl
        cfv co vy cv wss wa cC cme wcel cY cX wss wa vy cv cJ wcel cA vy cv cY
        cin wceq w3a vx cv cA wcel cA vy cv cY cin wceq vr cv cr wcel cC cme
        wcel cY cX wss wa vy cv cJ wcel cA vy cv cY cin wceq 3simp3 3ad2ant1
        adantr eleq2d 3imtr4d ssrdv vx cv vo cv wcel vo cv cA wss wa vx cv vx
        cv vr cv cD cbl cfv co wcel vx cv vr cv cD cbl cfv co cA wss wa vo vx
        cv vr cv cD cbl cfv co cD cbl cfv crn vo cv vx cv vr cv cD cbl cfv co
        wceq vx cv vo cv wcel vx cv vx cv vr cv cD cbl cfv co wcel vo cv cA wss
        vx cv vr cv cD cbl cfv co cA wss vo cv vx cv vr cv cD cbl cfv co vx cv
        eleq2 vo cv vx cv vr cv cD cbl cfv co cA sseq1 anbi12d rcla4ev sylan32c
        ex 3expia r19.23adv mpd r19.21aiva jca 3exp r19.23adv cJ ctop wcel cA
        cvv wcel cY cvv wcel cA cY cJ cop csubsp cfv wcel cA vy cv cY cin wceq
        vy cJ wrex wb cC cme wcel cY cX wss wa vy cA cY cvv cJ issubspt cC cme
        wcel cJ ctop wcel cY cX wss cC cJ subtopmet.j opntop adantr cA cvv wcel
        cC cme wcel cY cX wss wa subtopmet.a a1i cY cX wss cC cme wcel cY cvv
        wcel cY cC cdm cdm wss cC cme wcel cY cvv wcel cY cX wss cY cC cdm cdm
        wss cC cdm cdm cvv wcel cY cvv wcel cC cme wcel cY cC cdm cdm cvv ssexg
        cC cme wcel cC cdm cvv wcel cC cdm cdm cvv wcel cC cme dmexg cC cdm cvv
        dmexg syl sylan2 cX cC cdm cdm cY subtopmet.2 sseq2i sylanb ancoms
        syl3anc cC cme wcel cY cX wss wa cD cme wcel cA cK wcel cA cD cdm cdm
        wss vx cv vo cv wcel vo cv cA wss wa vo cD cbl cfv crn wrex vx cA wral
        wa wb cC cme wcel cY cX wss wa cC cY cY cxp cres cme cD cC cme wcel cC
        cY cY cxp cres cme wcel cY cX wss cC cY metres adantr subtopmet.1
        syl5eqel vx vo cA cD cK cD cdm cdm cD cdm cdm eqid subtopmet.k isopn
        syl 3imtr4d $.
        $( [1-Dec-2010] $) $( [21-Aug-2009] $)
    $}

    $( Two alternate formulations of a subspace topology of a metric space
       topology.   (Contributed by Jeff Hankins, 21-Aug-2009.) $)
    subtopmet $p |- ( ( C e. Met /\ Y C_ X ) -> ( subSp ` <. Y , J >. ) = K )
    $=
      cC cme wcel cY cX wss wa vt cY cJ cop csubsp cfv cK cC cme wcel cY cX wss
      wa vt cv cY cJ cop csubsp cfv wcel vt cv cK wcel vt cv cC cD cJ cK cX cY
      subtopmet.1 subtopmet.2 subtopmet.j subtopmet.k vt visset subtopmetlem cC
      cme wcel cY cX wss wa vt cv cK wcel vt cv cY cJ cop csubsp cfv wcel cJ
      ctop wcel cY cJ cuni wss vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex vx cab cuni cJ wcel vt
      cv vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co
      wceq wa vr crp wrex vy cY wrex vx cab cuni cY cin wceq vt cv cY cJ cop
      csubsp cfv wcel cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv vr cv cD
      cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex
      vy cY wrex vx cab cuni vt cv cY cJ cJ cuni cJ cuni eqid elsubsp cC cme
      wcel cJ ctop wcel cY cX wss vt cv cK wcel cC cJ subtopmet.j opntop
      ad2antrr cC cme wcel cY cX wss wa cY cJ cuni wss vt cv cK wcel cC cme
      wcel cY cX wss wa cY cX cJ cuni cC cme wcel cY cX wss pm3.27 cC cme wcel
      cJ cuni cX wceq cY cX wss cC cJ cX subtopmet.2 subtopmet.j uniopn2 adantr
      sseqtr4d adantr cJ ctop wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy
      cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex vx cab cJ wss vy cv
      vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr
      crp wrex vy cY wrex vx cab cuni cJ wcel cC cme wcel cY cX wss wa vt cv cK
      wcel wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv
      co wceq wa vr crp wrex vy cY wrex vx cab cJ uniopn cC cme wcel cJ ctop
      wcel cY cX wss vt cv cK wcel cC cJ subtopmet.j opntop ad2antrr cC cme
      wcel cY cX wss wa vt cv cK wcel wa vy cv vr cv cD cbl cfv co vt cv wss vx
      cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex vx cJ cC cme
      wcel cY cX wss wa vt cv cK wcel wa vy cv vr cv cD cbl cfv co vt cv wss vx
      cv vy cv vr cv cC cbl cfv co wceq wa vx cv cJ wcel vy vr cY crp cC cme
      wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa vy cv
      vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vx
      cv cJ wcel cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl
      cfv co wceq wa w3a vx cv cJ wcel vy cv vr cv cC cbl cfv co cJ wcel cC cme
      wcel vy cv cX wcel vr cv cr wcel cc0 vr cv clt wbr vy cv vr cv cC cbl cfv
      co cJ wcel cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl
      cfv co wceq wa w3a cC vy cv vr cv cJ cX subtopmet.2 subtopmet.j blopn cC
      cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa cC
      cme wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv
      co wceq wa cC cme wcel cY cX wss vt cv cK wcel simpll 3ad2ant1 cC cme
      wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa vy cv
      cX wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv
      co wceq wa cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vy cv
      cX wcel vr cv crp wcel cY cX wss vy cv cY wcel vy cv cX wcel cC cme wcel
      cY cX wss wa vt cv cK wcel wa cY cX vy cv ssel2 cC cme wcel cY cX wss vt
      cv cK wcel simplr sylan adantrr 3adant3 vy cv cY wcel vr cv crp wcel wa
      cC cme wcel cY cX wss wa vt cv cK wcel wa vr cv cr wcel vy cv vr cv cD
      cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr cv crp
      wcel vr cv cr wcel vy cv cY wcel vr cv rpre adantl 3ad2ant2 vy cv cY wcel
      vr cv crp wcel wa cC cme wcel cY cX wss wa vt cv cK wcel wa cc0 vr cv clt
      wbr vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co
      wceq wa vr cv crp wcel cc0 vr cv clt wbr vy cv cY wcel vr cv rpgt0 adantl
      3ad2ant2 syl2anc vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa cC cme wcel cY cX wss wa vt cv cK wcel wa vx cv cJ
      wcel vy cv vr cv cC cbl cfv co cJ wcel wb vy cv cY wcel vr cv crp wcel wa
      vx cv vy cv vr cv cC cbl cfv co wceq vx cv cJ wcel vy cv vr cv cC cbl cfv
      co cJ wcel wb vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co cJ eleq1 adantl 3ad2ant3 mpbird 3exp r19.23advv abssdv sylanc
      cC cme wcel cY cX wss wa vt cv cK wcel wa vz vt cv vy cv vr cv cD cbl cfv
      co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY
      wrex vx cab cuni cY cin cC cme wcel cY cX wss wa vt cv cK wcel wa vz cv
      vt cv wcel vz cv vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vr crp wrex vy cY wrex vx cab cuni cY cin wcel cC cme
      wcel cY cX wss wa vt cv cK wcel wa vz cv vt cv wcel vz cv vy cv vr cv cD
      cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex
      vy cY wrex vx cab cuni wcel vz cv cY wcel wa vz cv vy cv vr cv cD cbl cfv
      co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY
      wrex vx cab cuni cY cin wcel cC cme wcel cY cX wss wa vt cv cK wcel wa vz
      cv vt cv wcel vz cv vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv
      cC cbl cfv co wceq wa vr crp wrex vy cY wrex vx cab cuni wcel vz cv cY
      wcel cC cme wcel cY cX wss wa vt cv cK wcel wa vz cv vt cv wcel vz cv vx
      cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv
      co wceq wa vr crp wrex vy cY wrex wa vx wex vz cv vy cv vr cv cD cbl cfv
      co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY
      wrex vx cab cuni wcel cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv
      wcel vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr
      cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa vx wex cC cme wcel cY
      cX wss wa vt cv cK wcel vz cv vt cv wcel wa vz cv vx cv wcel vy cv vr cv
      cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp
      wrex vy cY wrex wa vx wex cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt
      cv wcel wa wa cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt cv wss wa vs
      cr wrex vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa vx wex cD cme wcel
      vt cv cK wcel vz cv vt cv wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv
      co vt cv wss wa vs cr wrex cC cme wcel cY cX wss wa vt cv cK wcel vz cv
      vt cv wcel wa wa vs vt cv cD vz cv cK subtopmet.k opni2 cC cme wcel cD
      cme wcel cY cX wss vt cv cK wcel vz cv vt cv wcel wa cC cme wcel cC cY cY
      cxp cres cme cD cC cY metres subtopmet.1 syl5eqel ad2antrr cC cme wcel cY
      cX wss wa vt cv cK wcel vz cv vt cv wcel simprl cC cme wcel cY cX wss wa
      vt cv cK wcel vz cv vt cv wcel simprr syl3anc cC cme wcel cY cX wss wa vt
      cv cK wcel vz cv vt cv wcel wa wa cc0 vs cv clt wbr vz cv vs cv cD cbl
      cfv co vt cv wss wa vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss
      vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa vx wex
      vs cr cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa vs cv
      cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt cv wss wa vz cv vx
      cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv
      co wceq wa vr crp wrex vy cY wrex wa vx wex vz cv vz cv vs cv cC cbl cfv
      co wcel vy cv vr cv cD cbl cfv co vt cv wss vz cv vs cv cC cbl cfv co vy
      cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex vz cv vx cv wcel vy
      cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa
      vr crp wrex vy cY wrex wa vx wex cC cme wcel cY cX wss wa vt cv cK wcel
      vz cv vt cv wcel wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl
      cfv co vt cv wss wa wa wa vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt
      cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa
      vz cv vz cv vs cv cC cbl cfv co wcel vy cv vr cv cD cbl cfv co vt cv wss
      vz cv vs cv cC cbl cfv co vy cv vr cv cC cbl cfv co wceq wa vr crp wrex
      vy cY wrex wa vx vz cv vs cv cC cbl cfv co vz cv vs cv cC cbl cfv oprex
      vx cv vz cv vs cv cC cbl cfv co wceq vz cv vx cv wcel vz cv vz cv vs cv
      cC cbl cfv co wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv
      cC cbl cfv co wceq wa vr crp wrex vy cY wrex vy cv vr cv cD cbl cfv co vt
      cv wss vz cv vs cv cC cbl cfv co vy cv vr cv cC cbl cfv co wceq wa vr crp
      wrex vy cY wrex vx cv vz cv vs cv cC cbl cfv co vz cv eleq2 vx cv vz cv
      vs cv cC cbl cfv co wceq vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vy cv vr cv cD cbl cfv co vt cv wss vz cv vs
      cv cC cbl cfv co vy cv vr cv cC cbl cfv co wceq wa vy vr cY crp vx cv vz
      cv vs cv cC cbl cfv co wceq vx cv vy cv vr cv cC cbl cfv co wceq vz cv vs
      cv cC cbl cfv co vy cv vr cv cC cbl cfv co wceq vy cv vr cv cD cbl cfv co
      vt cv wss vx cv vz cv vs cv cC cbl cfv co vy cv vr cv cC cbl cfv co eqeq1
      anbi2d 2rexbidv anbi12d cla4ev cC cme wcel vz cv cX wcel vs cv cr wcel
      cc0 vs cv clt wbr vz cv vz cv vs cv cC cbl cfv co wcel cC cme wcel cY cX
      wss wa vt cv cK wcel vz cv vt cv wcel wa wa vs cv cr wcel cc0 vs cv clt
      wbr vz cv vs cv cD cbl cfv co vt cv wss wa wa wa cC vz cv vs cv cX
      subtopmet.2 blcntr cC cme wcel cY cX wss vt cv cK wcel vz cv vt cv wcel
      wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt cv wss wa
      wa simplll cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa
      vz cv cX wcel vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co
      vt cv wss wa wa cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel
      wa wa cY cX vz cv cC cme wcel cY cX wss vt cv cK wcel vz cv vt cv wcel wa
      simplr cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa vt
      cv cY vz cv cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa
      vt cv cD cdm cdm cY cC cme wcel vt cv cK wcel vt cv cD cdm cdm wss cY cX
      wss vz cv vt cv wcel cD cme wcel vt cv cK wcel vt cv cD cdm cdm wss cC
      cme wcel vt cv cD cK cD cdm cdm cD cdm cdm eqid subtopmet.k opnss cC cme
      wcel cC cY cY cxp cres cme cD cC cY metres subtopmet.1 syl5eqel sylan
      ad2ant2r cC cme wcel cY cX wss wa cY cD cdm cdm wceq vt cv cK wcel vz cv
      vt cv wcel wa cC cD cX cY subtopmet.1 subtopmet.2 basmetres adantr
      sseqtr4d cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel simprr
      sseldd sseldd adantr cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv
      wcel wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt
      cv wss wa simprl cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel
      wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt cv wss
      simprrl syl2anc vz cv cY wcel vs cv crp wcel vz cv vs cv cD cbl cfv co vt
      cv wss vz cv vs cv cC cbl cfv co vz cv vs cv cC cbl cfv co wceq wa vy cv
      vr cv cD cbl cfv co vt cv wss vz cv vs cv cC cbl cfv co vy cv vr cv cC
      cbl cfv co wceq wa vr crp wrex vy cY wrex cC cme wcel cY cX wss wa vt cv
      cK wcel vz cv vt cv wcel wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs
      cv cD cbl cfv co vt cv wss wa wa wa vy cv vr cv cD cbl cfv co vt cv wss
      vz cv vs cv cC cbl cfv co vy cv vr cv cC cbl cfv co wceq wa vz cv vs cv
      cD cbl cfv co vt cv wss vz cv vs cv cC cbl cfv co vz cv vs cv cC cbl cfv
      co wceq wa vz cv vr cv cD cbl cfv co vt cv wss vz cv vs cv cC cbl cfv co
      vz cv vr cv cC cbl cfv co wceq wa vy vr vz cv vs cv cY crp vy cv vz cv
      wceq vy cv vr cv cD cbl cfv co vt cv wss vz cv vr cv cD cbl cfv co vt cv
      wss vz cv vs cv cC cbl cfv co vy cv vr cv cC cbl cfv co wceq vz cv vs cv
      cC cbl cfv co vz cv vr cv cC cbl cfv co wceq vy cv vz cv wceq vy cv vr cv
      cD cbl cfv co vz cv vr cv cD cbl cfv co vt cv vy cv vz cv vr cv cD cbl
      cfv opreq1 sseq1d vy cv vz cv wceq vy cv vr cv cC cbl cfv co vz cv vr cv
      cC cbl cfv co vz cv vs cv cC cbl cfv co vy cv vz cv vr cv cC cbl cfv
      opreq1 eqeq2d anbi12d vr cv vs cv wceq vz cv vr cv cD cbl cfv co vt cv
      wss vz cv vs cv cD cbl cfv co vt cv wss vz cv vs cv cC cbl cfv co vz cv
      vr cv cC cbl cfv co wceq vz cv vs cv cC cbl cfv co vz cv vs cv cC cbl cfv
      co wceq vr cv vs cv wceq vz cv vr cv cD cbl cfv co vz cv vs cv cD cbl cfv
      co vt cv vr cv vs cv vz cv cD cbl cfv opreq2 sseq1d vr cv vs cv wceq vz
      cv vr cv cC cbl cfv co vz cv vs cv cC cbl cfv co vz cv vs cv cC cbl cfv
      co vr cv vs cv vz cv cC cbl cfv opreq2 eqeq2d anbi12d rcla42ev cC cme
      wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa vz cv cY wcel vs
      cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt cv wss wa wa cC
      cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa vt cv cY vz cv
      cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa vt cv cD
      cdm cdm cY cC cme wcel vt cv cK wcel vt cv cD cdm cdm wss cY cX wss vz cv
      vt cv wcel cD cme wcel vt cv cK wcel vt cv cD cdm cdm wss cC cme wcel vt
      cv cD cK cD cdm cdm cD cdm cdm eqid subtopmet.k opnss cC cme wcel cC cY
      cY cxp cres cme cD cC cY metres subtopmet.1 syl5eqel sylan ad2ant2r cC
      cme wcel cY cX wss wa cY cD cdm cdm wceq vt cv cK wcel vz cv vt cv wcel
      wa cC cD cX cY subtopmet.1 subtopmet.2 basmetres adantr sseqtr4d cC cme
      wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel simprr sseldd adantr vs
      cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt cv wss wa wa vs
      cv crp wcel cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv wcel wa wa
      vs cv cr wcel cc0 vs cv clt wbr vs cv crp wcel vz cv vs cv cD cbl cfv co
      vt cv wss vs cv crp wcel vs cv cr wcel cc0 vs cv clt wbr wa vs cv elrp
      biimpri adantrr adantl cC cme wcel cY cX wss wa vt cv cK wcel vz cv vt cv
      wcel wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl cfv co vt
      cv wss wa wa wa vz cv vs cv cD cbl cfv co vt cv wss vz cv vs cv cC cbl
      cfv co vz cv vs cv cC cbl cfv co wceq cC cme wcel cY cX wss wa vt cv cK
      wcel vz cv vt cv wcel wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv
      cD cbl cfv co vt cv wss simprrr cC cme wcel cY cX wss wa vt cv cK wcel vz
      cv vt cv wcel wa wa vs cv cr wcel cc0 vs cv clt wbr vz cv vs cv cD cbl
      cfv co vt cv wss wa wa wa vz cv vs cv cC cbl cfv co eqidd jca syl3anc
      sylanc exp32 r19.23adv mpd ex expdimp vy cv vr cv cD cbl cfv co vt cv wss
      vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex vx vz cv
      eluniab syl6ibr cC cme wcel cY cX wss wa vt cv cK wcel wa vt cv cY vz cv
      cC cme wcel cY cX wss wa vt cv cK wcel wa vt cv cD cdm cdm cY cD cme wcel
      vt cv cK wcel vt cv cD cdm cdm wss cC cme wcel cY cX wss wa vt cv cD cK
      cD cdm cdm cD cdm cdm eqid subtopmet.k opnss cC cme wcel cD cme wcel cY
      cX wss cC cme wcel cC cY cY cxp cres cme cD cC cY metres subtopmet.1
      syl5eqel adantr sylan cC cme wcel cY cX wss wa cY cD cdm cdm wceq vt cv
      cK wcel cC cD cX cY subtopmet.1 subtopmet.2 basmetres adantr sseqtr4d
      sseld jcad vz cv vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vr crp wrex vy cY wrex vx cab cuni cY elin syl6ibr cC
      cme wcel cY cX wss wa vt cv cK wcel wa vz cv vy cv vr cv cD cbl cfv co vt
      cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex vx
      cab cuni wcel vz cv cY wcel wa vz cv vt cv wcel vz cv vy cv vr cv cD cbl
      cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy
      cY wrex vx cab cuni cY cin wcel cC cme wcel cY cX wss wa vt cv cK wcel wa
      vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vr crp wrex vy cY wrex wa vx wex vz cv cY wcel vz cv
      vt cv wcel vz cv vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vr crp wrex vy cY wrex vx cab cuni wcel cC cme wcel cY
      cX wss wa vt cv cK wcel wa vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt
      cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa
      vx wex vz cv cY wcel vz cv vt cv wcel cC cme wcel cY cX wss wa vt cv cK
      wcel wa vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa vz cv cY wcel vz cv
      vt cv wcel wi vx vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx
      cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa cC cme
      wcel cY cX wss wa vt cv cK wcel wa vz cv cY wcel vz cv vt cv wcel wi vz
      cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vr crp wrex vy cY wrex cC cme wcel cY cX wss wa vt cv
      cK wcel wa vz cv cY wcel vz cv vt cv wcel wi wi vz cv vx cv wcel vy cv vr
      cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa cC cme
      wcel cY cX wss wa vt cv cK wcel wa vz cv cY wcel vz cv vt cv wcel wi wi
      vy vr cY crp cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr
      cv crp wcel wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vz cv vx cv wcel vz cv cY wcel vz cv vt cv wcel wi cC
      cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa vy
      cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa
      vz cv vx cv wcel vz cv cY wcel vz cv vt cv wcel cC cme wcel cY cX wss wa
      vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD cbl
      cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel
      wa wa vz cv cY wcel wa vy cv vr cv cD cbl cfv co vt cv vz cv vy cv vr cv
      cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx
      cv wcel wa vy cv vr cv cD cbl cfv co vt cv wss cC cme wcel cY cX wss wa
      vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vz cv cY wcel vy cv
      vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq vz cv
      vx cv wcel simpll ad2antlr cC cme wcel cY cX wss wa vt cv cK wcel wa vy
      cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv
      vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel wa
      vz cv vy cv vr cv cD cbl cfv co wcel vz cv cD cdm cdm wcel vy cv vz cv cD
      co vr cv clt wbr wa cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY
      wcel vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel wa vz cv
      cD cdm cdm wcel vy cv vz cv cD co vr cv clt wbr cC cme wcel cY cX wss wa
      vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vz cv cY wcel vz cv
      cD cdm cdm wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vz cv vx cv wcel wa cC cme wcel cY cX wss wa vt cv cK
      wcel wa vz cv cY wcel vz cv cD cdm cdm wcel vy cv cY wcel vr cv crp wcel
      wa cC cme wcel cY cX wss wa vz cv cY wcel vz cv cD cdm cdm wcel vt cv cK
      wcel cC cme wcel cY cX wss wa vz cv cY wcel wa vz cv cY cD cdm cdm cC cme
      wcel cY cX wss wa vz cv cY wcel pm3.27 cC cme wcel cY cX wss wa cY cD cdm
      cdm wceq vz cv cY wcel cC cD cX cY subtopmet.1 subtopmet.2 basmetres
      adantr eleqtrd adantlr adantlr adantlr cC cme wcel cY cX wss wa vt cv cK
      wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt
      cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz
      cv cY wcel wa vy cv vz cv cC co vy cv vz cv cD co vr cv clt cC wfun cD cD
      cdm cdm cD cdm cdm cxp wfn cD cC wss w3a vy cv cD cdm cdm wcel vz cv cD
      cdm cdm wcel vy cv vz cv cC co vy cv vz cv cD co wceq cC cme wcel cY cX
      wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD
      cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv
      wcel wa wa vz cv cY wcel wa cC cme wcel cY cX wss wa vt cv cK wcel wa vy
      cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv
      vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel wa
      cC wfun cD cD cdm cdm cD cdm cdm cxp wfn cD cC wss cC cme wcel cY cX wss
      wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa cC wfun vy cv vr
      cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv
      vx cv wcel wa vz cv cY wcel cC cme wcel cY cX wss wa cC wfun vt cv cK
      wcel vy cv cY wcel vr cv crp wcel wa cC cme wcel cC wfun cY cX wss cC cme
      wcel cX cX cxp cr cC wf cC wfun cC cX subtopmet.2 metf cX cX cxp cr cC
      ffun syl adantr ad2antrr ad2antrr cC cme wcel cY cX wss wa vt cv cK wcel
      wa vy cv cY wcel vr cv crp wcel wa wa cD cD cdm cdm cD cdm cdm cxp wfn vy
      cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa
      vz cv vx cv wcel wa vz cv cY wcel cC cme wcel cY cX wss wa cD cD cdm cdm
      cD cdm cdm cxp wfn vt cv cK wcel vy cv cY wcel vr cv crp wcel wa cC cme
      wcel cD cD cdm cdm cD cdm cdm cxp wfn cY cX wss cC cme wcel cD cme wcel
      cD cdm cdm cD cdm cdm cxp cr cD wf cD cD cdm cdm cD cdm cdm cxp wfn cC
      cme wcel cC cY cY cxp cres cme cD cC cY metres subtopmet.1 syl5eqel cD cD
      cdm cdm cD cdm cdm eqid metf cD cdm cdm cD cdm cdm cxp cr cD ffn 3syl
      adantr ad2antrr ad2antrr cD cC wss cC cme wcel cY cX wss wa vt cv cK wcel
      wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss
      vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY
      wcel wa cD cC cY cY cxp cres cC subtopmet.1 cC cY cY cxp resss eqsstri
      a1i 3jca cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel wa vy cv cY cD
      cdm cdm cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp
      wcel wa wa vy cv cY wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa vz cv cY wcel cC cme wcel
      cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel simprl
      ad2antrr cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa wa cY cD cdm cdm wceq vy cv vr cv cD cbl cfv co vt cv wss vx
      cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa vz cv cY wcel cC
      cme wcel cY cX wss wa cY cD cdm cdm wceq vt cv cK wcel vy cv cY wcel vr
      cv crp wcel wa cC cD cX cY subtopmet.1 subtopmet.2 basmetres ad2antrr
      ad2antrr eleqtrd cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel
      vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr
      cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel wa vz cv cY
      cD cdm cdm cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel pm3.27 cC cme
      wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa cY
      cD cdm cdm wceq vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vz cv vx cv wcel wa vz cv cY wcel cC cme wcel cY cX
      wss wa cY cD cdm cdm wceq vt cv cK wcel vy cv cY wcel vr cv crp wcel wa
      cC cD cX cY subtopmet.1 subtopmet.2 basmetres ad2antrr ad2antrr eleqtrd
      vy cv vz cv cD cdm cdm cD cdm cdm cC cD oprssoprv sylan32c cC cme wcel cY
      cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv
      cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx
      cv wcel wa wa vz cv cY wcel wa vz cv vy cv vr cv cC cbl cfv co wcel vy cv
      vz cv cC co vr cv clt wbr vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv
      vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa vz cv vy cv vr cv cC cbl
      cfv co wcel cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa wa vz cv cY wcel vx cv vy cv vr cv cC cbl cfv co wceq vz cv
      vx cv wcel vz cv vy cv vr cv cC cbl cfv co wcel vy cv vr cv cD cbl cfv co
      vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq vz cv vx cv wcel wa vz cv
      vx cv vy cv vr cv cC cbl cfv co vx cv vy cv vr cv cC cbl cfv co wceq vz
      cv vx cv wcel pm3.27 vx cv vy cv vr cv cC cbl cfv co wceq vz cv vx cv
      wcel pm3.26 eleqtrd adantll ad2antlr cC cme wcel vy cv cX wcel vz cv cX
      wcel w3a vr cv cr wcel cc0 vr cv clt wbr wa vz cv vy cv vr cv cC cbl cfv
      co wcel vy cv vz cv cC co vr cv clt wbr wb cC cme wcel cY cX wss wa vt cv
      cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv cD cbl cfv co
      vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa wa
      vz cv cY wcel wa vz cv cC vy cv vr cv cX subtopmet.2 elbl2 cC cme wcel cY
      cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv vr cv
      cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx
      cv wcel wa wa vz cv cY wcel wa cC cme wcel vy cv cX wcel vz cv cX wcel cC
      cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa
      cC cme wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl
      cfv co wceq wa vz cv vx cv wcel wa vz cv cY wcel cC cme wcel cY cX wss vt
      cv cK wcel vy cv cY wcel vr cv crp wcel wa simplll ad2antrr cC cme wcel
      cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vy cv cX
      wcel vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co
      wceq wa vz cv vx cv wcel wa vz cv cY wcel cC cme wcel cY cX wss wa vy cv
      cY wcel vy cv cX wcel vt cv cK wcel vr cv crp wcel cY cX wss vy cv cY
      wcel vy cv cX wcel cC cme wcel cY cX vy cv ssel2 adantll ad2ant2r
      ad2antrr cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa wa vz cv cY wcel vz cv cX wcel vy cv vr cv cD cbl cfv co vt
      cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa cC cme
      wcel cY cX wss wa vt cv cK wcel wa vz cv cY wcel vz cv cX wcel vy cv cY
      wcel vr cv crp wcel wa cC cme wcel cY cX wss wa vz cv cY wcel vz cv cX
      wcel vt cv cK wcel cY cX wss vz cv cY wcel vz cv cX wcel cC cme wcel cY
      cX vz cv ssel2 adantll adantlr adantlr adantlr 3jca cC cme wcel cY cX wss
      wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vr cv cr wcel cc0
      vr cv clt wbr wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC
      cbl cfv co wceq wa vz cv vx cv wcel wa vz cv cY wcel vr cv crp wcel vr cv
      cr wcel cc0 vr cv clt wbr wa cC cme wcel cY cX wss wa vt cv cK wcel wa vy
      cv cY wcel vr cv rpregt0 ad2antll ad2antrr sylanc mpbid eqbrtrrd jca cD
      cme wcel vy cv cD cdm cdm wcel vr cv cr wcel cc0 vr cv clt wbr vz cv vy
      cv vr cv cD cbl cfv co wcel vz cv cD cdm cdm wcel vy cv vz cv cD co vr cv
      clt wbr wa wb cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr
      cv crp wcel wa wa vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv
      cC cbl cfv co wceq wa vz cv vx cv wcel wa wa vz cv cY wcel wa vz cv cD vy
      cv vr cv cD cdm cdm cD cdm cdm eqid elbl cC cme wcel cY cX wss wa vt cv
      cK wcel wa vy cv cY wcel vr cv crp wcel wa wa cD cme wcel vy cv vr cv cD
      cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv
      wcel wa vz cv cY wcel cC cme wcel cY cX wss wa cD cme wcel vt cv cK wcel
      vy cv cY wcel vr cv crp wcel wa cC cme wcel cD cme wcel cY cX wss cC cme
      wcel cC cY cY cxp cres cme cD cC cY metres subtopmet.1 syl5eqel adantr
      ad2antrr ad2antrr cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel
      vr cv crp wcel wa wa vy cv cD cdm cdm wcel vy cv vr cv cD cbl cfv co vt
      cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa vz cv
      cY wcel cC cme wcel cY cX wss wa vy cv cY wcel vy cv cD cdm cdm wcel vt
      cv cK wcel vr cv crp wcel cC cme wcel cY cX wss wa vy cv cY wcel wa vy cv
      cY cD cdm cdm cC cme wcel cY cX wss wa vy cv cY wcel pm3.27 cC cme wcel
      cY cX wss wa cY cD cdm cdm wceq vy cv cY wcel cC cD cX cY subtopmet.1
      subtopmet.2 basmetres adantr eleqtrd ad2ant2r ad2antrr cC cme wcel cY cX
      wss wa vt cv cK wcel wa vy cv cY wcel vr cv crp wcel wa wa vr cv cr wcel
      vy cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq
      wa vz cv vx cv wcel wa vz cv cY wcel vr cv crp wcel vr cv cr wcel cC cme
      wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv rpre ad2antll
      ad2antrr cC cme wcel cY cX wss wa vt cv cK wcel wa vy cv cY wcel vr cv
      crp wcel wa wa cc0 vr cv clt wbr vy cv vr cv cD cbl cfv co vt cv wss vx
      cv vy cv vr cv cC cbl cfv co wceq wa vz cv vx cv wcel wa vz cv cY wcel vr
      cv crp wcel cc0 vr cv clt wbr cC cme wcel cY cX wss wa vt cv cK wcel wa
      vy cv cY wcel vr cv rpgt0 ad2antll ad2antrr syl2anc mpbird sseldd exp53
      com14 r19.23advv imp com12 19.23adv imp3a vz cv vy cv vr cv cD cbl cfv co
      vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex
      vx cab cuni wcel vz cv vx cv wcel vy cv vr cv cD cbl cfv co vt cv wss vx
      cv vy cv vr cv cC cbl cfv co wceq wa vr crp wrex vy cY wrex wa vx wex vy
      cv vr cv cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa
      vr crp wrex vy cY wrex vx vz cv eluniab biimpi sylani vz cv vy cv vr cv
      cD cbl cfv co vt cv wss vx cv vy cv vr cv cC cbl cfv co wceq wa vr crp
      wrex vy cY wrex vx cab cuni cY elin syl5ib impbid eqrdv syl2anc ex impbid
      eqrdv $.
      $( [1-Dec-2010] $) $( [19-Aug-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filter Bases
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c fBas $.
  $( Extend class definition to include the class of filter bases. $)
  cfbas $a class fBas $.

  $c filGen $.
  $( Extend class definition to include the filter generating function. $)
  cfg $a class filGen $.

  ${
    $d x y z $.
    $( Define the class of all filter bases. (Contributed by Jeff Hankins,
       1-Sep-2009.) $)
    df-fbas $a |- fBas = { x | ( x =/= (/) /\ (/) e/ x /\ A. y e. x A. z e. x (
    x i^i ~P ( y i^i z ) ) =/= (/) ) } $.
  $}

  ${
    $d x y z $.
    $( Define the filter generating function. (Contributed by Jeff Hankins,
       1-Sep-2009.) $)
    df-fg $a |- filGen = { <. x , y >. | ( x e. fBas /\ y = { z e. ~P U. x | (
    x i^i ~P z ) =/= (/) } ) } $.
  $}

  ${
    $d x y z F $.
    $( The predicate " ` F ` is a filter base." Note that some authors require
       filter bases to be closed under pairwise intersections, but that is not
       necessary under our definition. One advantage of this definition is that
       tails in a directed set form a filter base under our meaning.
       (Contributed by Jeff Hankins, 1-Sep-2009.) $)
    isfbas $p |- ( F e. A -> ( F e. fBas <-> ( F =/= (/) /\ (/) e/ F /\ A. x e.
    F A. y e. F ( F i^i ~P ( x i^i y ) ) =/= (/) ) ) ) $=
      vz cv c0 wne c0 vz cv wnel vz cv vx cv vy cv cin cpw cin c0 wne vy vz cv
      wral vx vz cv wral w3a cF c0 wne c0 cF wnel cF vx cv vy cv cin cpw cin c0
      wne vy cF wral vx cF wral w3a vz cF cfbas cA vz cv cF wceq vz cv c0 wne
      cF c0 wne c0 vz cv wnel c0 cF wnel vz cv vx cv vy cv cin cpw cin c0 wne
      vy vz cv wral vx vz cv wral cF vx cv vy cv cin cpw cin c0 wne vy cF wral
      vx cF wral vz cv cF c0 neeq1 vz cv cF c0 neleq2 vz cv vx cv vy cv cin cpw
      cin c0 wne vy vz cv wral cF vx cv vy cv cin cpw cin c0 wne vy cF wral vx
      vz cv cF vz cv vx cv vy cv cin cpw cin c0 wne cF vx cv vy cv cin cpw cin
      c0 wne vy vz cv cF vz cv cF wceq vz cv vx cv vy cv cin cpw cin cF vx cv
      vy cv cin cpw cin c0 vz cv cF vx cv vy cv cin cpw ineq1 neeq1d raleqd
      raleqd 3anbi123d vz vx vy df-fbas elab2g $.
      $( [1-Dec-2010] $) $( [1-Sep-2009] $)
  $}

  ${
    $d x y F $.
    $( There are no empty filter bases. (Contributed by Jeff Hankins,
       1-Sep-2009.) $)
    fbasne0 $p |- ( F e. fBas -> F =/= (/) ) $=
      cF cfbas wcel cF c0 wne c0 cF wnel cF vx cv vy cv cin cpw cin c0 wne vy
      cF wral vx cF wral cF cfbas wcel cF c0 wne c0 cF wnel cF vx cv vy cv cin
      cpw cin c0 wne vy cF wral vx cF wral w3a vx vy cfbas cF isfbas ibi
      3simp1d $.
      $( [1-Dec-2010] $) $( [1-Sep-2009] $)
  $}

  ${
    $d x y z F $.
    $( The predicate " ` F ` is a filter base." (Contributed by Jeff Hankins,
       1-Sep-2009.) $)
    isfbas2 $p |- ( F e. A -> ( F e. fBas <-> ( F =/= (/) /\ (/) e/ F /\ A. x
    e. F A. y e. F E. z e. F z C_ ( x i^i y ) ) ) ) $=
      cF cA wcel cF cfbas wcel cF c0 wne c0 cF wnel cF vx cv vy cv cin cpw cin
      c0 wne vy cF wral vx cF wral w3a cF c0 wne c0 cF wnel vz cv vx cv vy cv
      cin wss vz cF wrex vy cF wral vx cF wral w3a vx vy cA cF isfbas cF vx cv
      vy cv cin cpw cin c0 wne vy cF wral vx cF wral vz cv vx cv vy cv cin wss
      vz cF wrex vy cF wral vx cF wral cF c0 wne c0 cF wnel cF vx cv vy cv cin
      cpw cin c0 wne vz cv vx cv vy cv cin wss vz cF wrex vx vy cF cF vz cv cF
      vx cv vy cv cin cpw cin wcel vz wex vz cv cF wcel vz cv vx cv vy cv cin
      wss wa vz wex cF vx cv vy cv cin cpw cin c0 wne vz cv vx cv vy cv cin wss
      vz cF wrex vz cv cF vx cv vy cv cin cpw cin wcel vz cv cF wcel vz cv vx
      cv vy cv cin wss wa vz vz cv cF vx cv vy cv cin cpw cin wcel vz cv cF
      wcel vz cv vx cv vy cv cin cpw wcel wa vz cv cF wcel vz cv vx cv vy cv
      cin wss wa vz cv cF vx cv vy cv cin cpw elin vz cv vx cv vy cv cin cpw
      wcel vz cv vx cv vy cv cin wss vz cv cF wcel vz cv vx cv vy cv cin vz
      visset elpw anbi2i bitri exbii vz cF vx cv vy cv cin cpw cin n0 vz cv vx
      cv vy cv cin wss vz cF df-rex 3bitr4i 2ralbii 3anbi3i syl6bb $.
      $( [1-Dec-2010] $) $( [1-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filters
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Fil $. $( The class of all filters. $)

  $( Extend class notation with the class of all filters. $)
  cfil $a class Fil $.

  ${
    $d f x y $.
    $( The class  of all filters.  Bourbaki TG I.36  def. 1 axioms FI,
       FIIa, FIIb,  FIII.  Filters are  used to define the  concept of
       limit in the  general case.  It's a generalization  of the idea
       of   neighborhoods.   Suppose  you   are  in   `  RR   `.  With
       neighborhoods you can express the idea of a variable that tends
       to  a specific  number  but you  can't  express the  idea of  a
       variable that tends to  infinity. Filters relax the "axioms" of
       neighborhoods  and  then  succeed  in expressing  the  idea  of
       something  that tends  to infinity.   Filters were  invented by
       Cartan in 1937 and made  famous by Bourbaki in his treatise.  A
       notion similar  to the notion of  filter is the  concept of net
       invented by Moore and Smith in 1922.  (Contributed by FL,
       20-Jul-2007.) $)
    df-fil $a |- Fil = { f | ( ( -. (/) e. f /\ U. f e. f ) /\
      A. x A. y ( ( x e. f /\ y C_ U. f  /\ x C_ y ) -> y e. f ) /\
      A. x e. f A. y e. f ( x i^i y ) e. f ) } $.
  $}

  ${ $d F f x y $.  $d X f $.
    isfil.1 $e |- X = U. F $.
    $( The predicate "is a filter."  (Contributed by FL, 20-Jul-2007.) $)
    isfil $p |- ( F e. A -> ( F e. Fil <-> ( ( -. (/) e. F /\ X e. F ) /\
    A. x A. y ( ( x e. F /\ y C_ X /\ x C_ y ) -> y e. F ) /\
    A. x e. F A. y e. F ( x i^i y ) e. F ) ) ) $=
      c0 vf cv wcel wn vf cv cuni vf cv wcel wa vx cv vf cv wcel vy cv vf cv
      cuni wss vx cv vy cv wss w3a vy cv vf cv wcel wi vy wal vx wal vx cv vy
      cv cin vf cv wcel vy vf cv wral vx vf cv wral w3a c0 cF wcel wn cX cF
      wcel wa vx cv cF wcel vy cv cX wss vx cv vy cv wss w3a vy cv cF wcel wi
      vy wal vx wal vx cv vy cv cin cF wcel vy cF wral vx cF wral w3a vf cF
      cfil cA vf cv cF wceq c0 vf cv wcel wn vf cv cuni vf cv wcel wa c0 cF
      wcel wn cX cF wcel wa vx cv vf cv wcel vy cv vf cv cuni wss vx cv vy cv
      wss w3a vy cv vf cv wcel wi vy wal vx wal vx cv cF wcel vy cv cX wss vx
      cv vy cv wss w3a vy cv cF wcel wi vy wal vx wal vx cv vy cv cin vf cv
      wcel vy vf cv wral vx vf cv wral vx cv vy cv cin cF wcel vy cF wral vx cF
      wral vf cv cF wceq c0 vf cv wcel wn c0 cF wcel wn vf cv cuni vf cv wcel
      cX cF wcel vf cv cF wceq c0 vf cv wcel c0 cF wcel vf cv cF c0 eleq2
      notbid vf cv cF wceq vf cv cuni cX vf cv cF vf cv cF wceq vf cv cuni cF
      cuni cX vf cv cF unieq isfil.1 syl6eqr vf cv cF wceq id eleq12d anbi12d
      vf cv cF wceq vx cv vf cv wcel vy cv vf cv cuni wss vx cv vy cv wss w3a
      vy cv vf cv wcel wi vx cv cF wcel vy cv cX wss vx cv vy cv wss w3a vy cv
      cF wcel wi vx vy vf cv cF wceq vx cv vf cv wcel vy cv vf cv cuni wss vx
      cv vy cv wss w3a vx cv cF wcel vy cv cX wss vx cv vy cv wss w3a vy cv vf
      cv wcel vy cv cF wcel vf cv cF wceq vx cv vf cv wcel vx cv cF wcel vy cv
      vf cv cuni wss vy cv cX wss vx cv vy cv wss vf cv cF vx cv eleq2 vf cv cF
      wceq vf cv cuni cX vy cv vf cv cF wceq vf cv cuni cF cuni cX vf cv cF
      unieq isfil.1 syl6eqr sseq2d 3anbi12d vf cv cF vy cv eleq2 imbi12d
      2albidv vx cv vy cv cin vf cv wcel vy vf cv wral vx cv vy cv cin cF wcel
      vy cF wral vx vf cv cF vx cv vy cv cin vf cv wcel vx cv vy cv cin cF wcel
      vy vf cv cF vf cv cF vx cv vy cv cin eleq2 raleqd raleqd 3anbi123d vx vy
      vf df-fil elab2g $.
      $( [1-Dec-2010] $) $( [20-Jul-2007] $)
  $}

  ${ $d F x y $.
    filusb.1 $e |- X = U. F $.
    $( The underlying set belongs to the filter.  (Contributed by FL,
       20-Jul-2007.) $)
    filusb $p |- ( F e. Fil -> X e. F ) $=
      cF cfil wcel c0 cF wcel wn cX cF wcel cF cfil wcel c0 cF wcel wn cX cF
      wcel wa vx cv cF wcel vy cv cX wss vx cv vy cv wss w3a vy cv cF wcel wi
      vy wal vx wal vx cv vy cv cin cF wcel vy cF wral vx cF wral cF cfil wcel
      c0 cF wcel wn cX cF wcel wa vx cv cF wcel vy cv cX wss vx cv vy cv wss
      w3a vy cv cF wcel wi vy wal vx wal vx cv vy cv cin cF wcel vy cF wral vx
      cF wral w3a vx vy cfil cF cX filusb.1 isfil ibi 3simp1d pm3.27d $.
      $( [1-Dec-2010] $) $( [20-Jul-2007] $)
  $}

  ${
    $d F x y $.
    $( The empty set doesn't belong to a filter.  (Contributed by FL,
        20-Jul-2007.) $)
    filesn $p |- ( F e. Fil -> -. (/) e. F ) $=
      cF cfil wcel c0 cF wcel wn cF cuni cF wcel cF cfil wcel c0 cF wcel wn cF
      cuni cF wcel wa vx cv cF wcel vy cv cF cuni wss vx cv vy cv wss w3a vy cv
      cF wcel wi vy wal vx wal vx cv vy cv cin cF wcel vy cF wral vx cF wral cF
      cfil wcel c0 cF wcel wn cF cuni cF wcel wa vx cv cF wcel vy cv cF cuni
      wss vx cv vy cv wss w3a vy cv cF wcel wi vy wal vx wal vx cv vy cv cin cF
      wcel vy cF wral vx cF wral w3a vx vy cfil cF cF cuni cF cuni eqid isfil
      ibi 3simp1d pm3.26d $.
      $( [1-Dec-2010] $) $( [20-Jul-2007] $)
  $}

  ${
    $d A x y $.  $d B y $.  $d F x y $.
    $( A filter is closed under taking intersections.  (Contributed by FL,
       20-Jul-2007.) $)
    filint $p |- ( ( F e. Fil /\ A e. F /\ B e. F ) -> ( A i^i B ) e. F ) $=
      cF cfil wcel cA cF wcel cB cF wcel cA cB cin cF wcel cF cfil wcel cA cF
      wcel cB cF wcel wa cA cB cin cF wcel wi cF cfil wcel cF cfil wcel vx cv
      vy cv cin cF wcel vy cF wral vx cF wral cA cF wcel cB cF wcel wa cA cB
      cin cF wcel wi cF cfil wcel cF cfil wcel vx cv vy cv cin cF wcel vy cF
      wral vx cF wral cF cfil wcel cF cfil wcel wa c0 cF wcel wn cF cuni cF
      wcel wa vx cv cF wcel vy cv cF cuni wss vx cv vy cv wss w3a vy cv cF wcel
      wi vy wal vx wal vx cv vy cv cin cF wcel vy cF wral vx cF wral cF cfil
      wcel cF cfil wcel c0 cF wcel wn cF cuni cF wcel wa vx cv cF wcel vy cv cF
      cuni wss vx cv vy cv wss w3a vy cv cF wcel wi vy wal vx wal vx cv vy cv
      cin cF wcel vy cF wral vx cF wral w3a vx vy cfil cF cF cuni cF cuni eqid
      isfil biimpa 3simp3d ex cA cF wcel cB cF wcel wa vx cv vy cv cin cF wcel
      vy cF wral vx cF wral cA cB cin cF wcel vx cv vy cv cin cF wcel cA cB cin
      cF wcel cA vy cv cin cF wcel vx vy cA cB cF cF vx cv cA wceq vx cv vy cv
      cin cA vy cv cin cF vx cv cA vy cv ineq1 eleq1d vy cv cB wceq cA vy cv
      cin cA cB cin cF vy cv cB cA ineq2 eleq1d rcla42v com12 syl6 pm2.43i
      3impib $.
      $( [1-Dec-2010] $) $( [20-Jul-2007] $)
  $}

  ${ $d A x y $.  $d B y $.  $d F x y $.  $d X x y $.
    fillsb.1 $e |- X = U. F $.
    $( A filter is closed under taking supersets.  (Contributed by FL,
       20-Jul-2007.) $)
    fillsb $p |- ( F e. Fil -> ( ( A e. F /\
      B C_ X /\ A C_ B ) -> B e. F ) ) $=
      cF cfil wcel cA cF wcel cB cX wss cA cB wss w3a cB cF wcel cX cvv wcel cF
      cfil wcel cA cF wcel cB cX wss cA cB wss w3a cA cF wcel cB cX wss cA cB
      wss w3a cB cF wcel wi wi cF cfil wcel cF cuni cvv cX cF cfil uniexg
      fillsb.1 syl5eqel cX cvv wcel cA cF wcel cB cX wss cA cB wss w3a cF cfil
      wcel cA cF wcel cB cX wss cA cB wss w3a cB cF wcel wi cX cvv wcel cA cF
      wcel cB cX wss cA cB wss w3a cA cF wcel cB cX cpw wcel wa cF cfil wcel cA
      cF wcel cB cX wss cA cB wss w3a cB cF wcel wi wi cX cvv wcel cA cF wcel
      cB cX wss wa cA cF wcel cB cX cpw wcel wa cA cF wcel cB cX wss cA cB wss
      w3a cX cvv wcel cB cX wss cB cX cpw wcel cA cF wcel cX cvv wcel cB cX cpw
      wcel cB cX wss cB cX cvv elpw2g bicomd anbi2d cA cF wcel cB cX wss cA cB
      wss 3simpa syl5bi cF cfil wcel vx cv cF wcel vy cv cX wss vx cv vy cv wss
      w3a vy cv cF wcel wi wi cF cfil wcel cA cF wcel vy cv cX wss cA vy cv wss
      w3a vy cv cF wcel wi wi cF cfil wcel cA cF wcel cB cX wss cA cB wss w3a
      cB cF wcel wi wi vx vy cA cB cF cX cpw vx cv cA wceq vx cv cF wcel vy cv
      cX wss vx cv vy cv wss w3a vy cv cF wcel wi cA cF wcel vy cv cX wss cA vy
      cv wss w3a vy cv cF wcel wi cF cfil wcel vx cv cA wceq vx cv cF wcel vy
      cv cX wss vx cv vy cv wss w3a cA cF wcel vy cv cX wss cA vy cv wss w3a vy
      cv cF wcel vx cv cA wceq vx cv cF wcel cA cF wcel vx cv vy cv wss cA vy
      cv wss vy cv cX wss vx cv cA cF eleq1 vx cv cA vy cv sseq1 3anbi13d
      imbi1d imbi2d vy cv cB wceq cA cF wcel vy cv cX wss cA vy cv wss w3a vy
      cv cF wcel wi cA cF wcel cB cX wss cA cB wss w3a cB cF wcel wi cF cfil
      wcel vy cv cB wceq cA cF wcel vy cv cX wss cA vy cv wss w3a cA cF wcel cB
      cX wss cA cB wss w3a vy cv cF wcel cB cF wcel vy cv cB wceq vy cv cX wss
      cB cX wss cA vy cv wss cA cB wss cA cF wcel vy cv cB cX sseq1 vy cv cB cA
      sseq2 3anbi23d vy cv cB cF eleq1 imbi12d imbi2d cF cfil wcel vx cv cF
      wcel vy cv cX wss vx cv vy cv wss w3a vy cv cF wcel wi vx vy cF cfil wcel
      c0 cF wcel wn cX cF wcel wa vx cv cF wcel vy cv cX wss vx cv vy cv wss
      w3a vy cv cF wcel wi vy wal vx wal vx cv vy cv cin cF wcel vy cF wral vx
      cF wral cF cfil wcel c0 cF wcel wn cX cF wcel wa vx cv cF wcel vy cv cX
      wss vx cv vy cv wss w3a vy cv cF wcel wi vy wal vx wal vx cv vy cv cin cF
      wcel vy cF wral vx cF wral w3a vx vy cfil cF cX fillsb.1 isfil ibi
      3simp2d 19.21bbi vtocl2g syl6 com23 mpcom pm2.43d $.
      $( [1-Dec-2010] $) $( [20-Jul-2007] $)
  $}

  $( The intersection of two elements of a filter can't be empty.  (Contributed
     by FL, 19-Sep-2007.) $)
  fipfil $p |- ( F e. Fil -> ( ( A e. F /\ B e. F ) ->
    ( A i^i B ) =/= (/) ) ) $=
    cF cfil wcel cA cF wcel cB cF wcel wa cA cB cin c0 wceq wn cA cB cin c0 wne
    cF cfil wcel cA cF wcel cB cF wcel wa cA cB cin c0 wceq wn cA cB cin cF
    wcel c0 cF wcel wn cA cB cin c0 wceq wn cF cfil wcel cA cF wcel cB cF wcel
    wa wa cA cB cin c0 cF nelneq cF cfil wcel cA cF wcel cB cF wcel cA cB cin
    cF wcel cA cB cF filint 3expb cF cfil wcel c0 cF wcel wn cA cF wcel cB cF
    wcel wa cF filesn adantr sylanc ex cA cB cin c0 df-ne syl6ibr $.
    $( [1-Dec-2010] $) $( [16-Sep-2007] $)

  ${
    $d A y $.  $d F x y $.
    $( A filter has the finite intersection property.  Bourbaki TG I.36 note
       of def. 1.  (Contributed by FL, 2-Sep-2007.) $)
    fipfil2 $p |- ( F e. Fil
         -> ( ( A C_ F /\ A =/= (/) /\ A e. Fin ) -> |^| A =/= (/) ) ) $=
      cF cfil wcel cA cF wss cA c0 wne cA cfn wcel w3a cA cint c0 wceq wn cA
      cint c0 wne cA cF wss cA c0 wne cA cfn wcel w3a cF cfil wcel cA cint c0
      wceq wn cA cF wss cA c0 wne cA cfn wcel w3a cF cfil wcel cA cint c0 wceq
      wn wi cA cF wss cA c0 wne cA cF wss cA c0 wne cA cfn wcel w3a cF cfil
      wcel cA cint c0 wceq wn wi wi cA cfn wcel cF cfil wcel cA cF wss cA c0
      wne cA cfn wcel w3a cA cF wss cA cint c0 wceq wn cF cfil wcel cA cF wss
      cA c0 wne cA cfn wcel w3a cA cF wss cA cint c0 wceq wn wi wi cA cF wss cF
      cfil wcel cA cF wss cA c0 wne cA cfn wcel w3a cF cfil wcel cA cint c0
      wceq wn cA cF wss cF cfil wcel cA cF wss cA c0 wne cA cfn wcel w3a cF
      cfil wcel cA cint c0 wceq wn wi wi cA cF wss cF cfil wcel wa cA cvv wcel
      cA cF wss cA c0 wne cA cfn wcel w3a cF cfil wcel cA cint c0 wceq wn wi wi
      cA cF cfil ssexg cA cvv wcel cF cfil wcel cA cF wss cA c0 wne cA cfn wcel
      w3a cA cint c0 wceq wn cA cvv wcel vy cv cF wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint c0 wceq wn wi vy wal cA cF wss cA c0 wne cA cfn wcel
      w3a cA cint c0 wceq wn wi cF cfil wcel vy cv cF wss vy cv c0 wne vy cv
      cfn wcel w3a vy cv cint c0 wceq wn wi cA cF wss cA c0 wne cA cfn wcel w3a
      cA cint c0 wceq wn wi vy cA cvv vy cv cA wceq vy cv cF wss vy cv c0 wne
      vy cv cfn wcel w3a cA cF wss cA c0 wne cA cfn wcel w3a vy cv cint c0 wceq
      wn cA cint c0 wceq wn vy cv cA wceq vy cv cF wss cA cF wss vy cv c0 wne
      cA c0 wne vy cv cfn wcel cA cfn wcel vy cv cA cF sseq1 vy cv cA c0 neeq1
      vy cv cA cfn eleq1 3anbi123d vy cv cA wceq vy cv cint cA cint wceq vy cv
      cint c0 wceq wn cA cint c0 wceq wn wb vy cv cA inteq vy cv cint cA cint
      wceq vy cv cint c0 wceq cA cint c0 wceq vy cv cint cA cint c0 eqeq1
      notbid syl imbi12d cla4gv cF cfil wcel vy cv cF wss vy cv c0 wne vy cv
      cfn wcel w3a vy cv cint c0 wceq wn wi vy cF cfil wcel vy cv cF wss vy cv
      c0 wne vy cv cfn wcel w3a vy cv cint c0 wceq wn vy cv cint cF wcel c0 cF
      wcel wn vy cv cint c0 wceq wn cF cfil wcel vy cv cF wss vy cv c0 wne vy
      cv cfn wcel w3a wa vy cv cint c0 cF nelneq cF cfil wcel vy cv cF wss vy
      cv c0 wne vy cv cfn wcel w3a vy cv cint cF wcel cF cfil wcel vy cv cF wss
      vy cv c0 wne vy cv cfn wcel w3a vy cv cint cF wcel wi vy cF cfil wcel vy
      cv vx cv cin cF wcel vx cF wral vy cF wral vy cv cF wss vy cv c0 wne vy
      cv cfn wcel w3a vy cv cint cF wcel wi vy wal cF cfil wcel vy cv vx cv cin
      cF wcel vx cF wral vy cF wral cF cfil wcel cF cfil wcel wa c0 cF wcel wn
      cF cuni cF wcel wa vy cv cF wcel vx cv cF cuni wss vy cv vx cv wss w3a vx
      cv cF wcel wi vx wal vy wal vy cv vx cv cin cF wcel vx cF wral vy cF wral
      cF cfil wcel cF cfil wcel c0 cF wcel wn cF cuni cF wcel wa vy cv cF wcel
      vx cv cF cuni wss vy cv vx cv wss w3a vx cv cF wcel wi vx wal vy wal vy
      cv vx cv cin cF wcel vx cF wral vy cF wral w3a vy vx cfil cF cF cuni cF
      cuni eqid isfil biimpa 3simp3d anidms vy vx cF fiint sylib 19.21bi imp cF
      cfil wcel c0 cF wcel wn vy cv cF wss vy cv c0 wne vy cv cfn wcel w3a cF
      filesn adantr sylanc ex 19.21aiv syl5 com23 syl ex com14 pm2.43i com13
      3ad2ant1 pm2.43i com12 cA cint c0 df-ne syl6ibr $.
      $( [1-Dec-2010] $) $( [20-Sep-2007] $)
  $}

  $( The empty set is not a filter.  Bourbaki TG I.36 def 1 note.  (Contributed
     by FL, 31-Oct-2007.) $)
  emnfil $p |- -. (/) e. Fil $=
    c0 cfil wcel c0 cuni c0 wcel c0 cuni noel c0 c0 cuni c0 cuni eqid filusb
    mto $.
    $( [1-Dec-2010] $) $( [30-Oct-2007] $)

  ${ $d F x y $.  $d G x y $.
  $( The intersection of two filters is a filter.  Use  ~ fiint to extend this
     property to the intersection of a finite set of filters.  Bourbaki TG I.36
     par. 3.  (Contributed by FL, 19-Sep-2007.) $)
  filintf $p |- ( ( F e. Fil /\ G e. Fil /\ U. F = U. G ) ->
      ( F i^i G ) e. Fil ) $=
    cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a cF cG cin cfil wcel cF
    cfil wcel cG cfil wcel cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a
    cF cG cin cfil wcel wi cF cuni cG cuni wceq cF cfil wcel cG cfil wcel cF
    cuni cG cuni wceq w3a cF cG cin cvv wcel cF cG cin cfil wcel cF cfil wcel
    cF cG cin cvv wcel cF cG cin cfil wcel c0 cF cG cin wcel wn cF cG cin cuni
    cF cG cin wcel wa vx cv cF cG cin wcel vy cv cF cG cin cuni wss vx cv vy cv
    wss w3a vy cv cF cG cin wcel wi vy wal vx wal vx cv vy cv cin cF cG cin
    wcel vy cF cG cin wral vx cF cG cin wral w3a cF cfil wcel cG cfil wcel cF
    cuni cG cuni wceq w3a vx vy cvv cF cG cin cF cG cin cuni cF cG cin cuni
    eqid isfil cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a c0 cF cG cin
    wcel wn cF cG cin cuni cF cG cin wcel wa vx cv cF cG cin wcel vy cv cF cG
    cin cuni wss vx cv vy cv wss w3a vy cv cF cG cin wcel wi vy wal vx wal vx
    cv vy cv cin cF cG cin wcel vy cF cG cin wral vx cF cG cin wral cF cfil
    wcel cG cfil wcel cF cuni cG cuni wceq w3a c0 cF cG cin wcel wn cF cG cin
    cuni cF cG cin wcel cF cfil wcel cG cfil wcel c0 cF cG cin wcel wn cF cuni
    cG cuni wceq cF cfil wcel c0 cF wcel c0 cF cG cin wcel cF filesn c0 cF cG
    cin wcel c0 cF wcel c0 cG wcel c0 cF cG elin pm3.26bi nsyl 3ad2ant1 cF cfil
    wcel cG cfil wcel cF cuni cG cuni wceq w3a cF cG cin cuni cF cuni cG cuni
    cin cF cG cin cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a cF cG cin
    cuni cF cuni cG cuni cin wss cF cuni cG cuni cin cF cG cin cuni wss wa cF
    cG cin cuni cF cuni cG cuni cin wceq cF cfil wcel cG cfil wcel cF cuni cG
    cuni wceq w3a cF cuni cG cuni cin cF cG cin cuni wss cF cG cin cuni cF cuni
    cG cuni cin wss cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a cF cuni
    cG cuni cin cF cG cin wcel cF cuni cG cuni cin cF cG cin cuni wss cF cfil
    wcel cG cfil wcel cF cuni cG cuni wceq w3a cF cuni cF cuni cG cuni cin cF
    cG cin cF cuni cG cuni wceq cF cfil wcel cF cuni cF cuni cG cuni cin wceq
    cG cfil wcel cF cuni cG cuni wceq cF cuni cF cuni cin cF cuni cG cuni cin
    cF cuni cF cuni cG cuni cF cuni ineq2 cF cuni inidm syl5eqr 3ad2ant3 cF
    cfil wcel cG cfil wcel cF cuni cG cuni wceq cF cuni cF cG cin wcel cG cfil
    wcel cF cuni cF wcel cF cuni cG cuni wceq cF cuni cF cG cin wcel wi cF cfil
    wcel cG cfil wcel cG cuni cG wcel cF cuni cF wcel cF cuni cG cuni wceq cF
    cuni cF cG cin wcel wi wi cG cG cuni cG cuni eqid filusb cF cuni cG cuni
    wceq cG cuni cG wcel cF cuni cF wcel cF cuni cF cG cin wcel cF cuni cG cuni
    wceq cG cuni cG wcel cF cuni cG wcel cF cuni cF wcel cF cuni cF cG cin wcel
    wi cF cuni cG cuni cG eleq1 cF cuni cF wcel cF cuni cG wcel cF cuni cF cG
    cin wcel cF cuni cF cG cin wcel cF cuni cF wcel cF cuni cG wcel wa cF cuni
    cF cG elin biimpri expcom syl6bir com3l syl cF cF cuni cF cuni eqid filusb
    syl5com 3imp eqeltrrd cF cuni cG cuni cin cF cG cin elssuni syl cF cG uniin
    jctil cF cG cin cuni cF cuni cG cuni cin eqss sylibr cF cfil wcel cG cfil
    wcel cF cuni cG cuni wceq w3a cF cuni cF cuni cG cuni cin cF cG cin cF cuni
    cG cuni wceq cF cfil wcel cF cuni cF cuni cG cuni cin wceq cG cfil wcel cF
    cuni cG cuni wceq cF cuni cF cuni cin cF cuni cG cuni cin cF cuni cF cuni
    cG cuni cF cuni ineq2 cF cuni inidm syl5eqr 3ad2ant3 cF cfil wcel cG cfil
    wcel cF cuni cG cuni wceq cF cuni cF cG cin wcel cG cfil wcel cF cuni cF
    wcel cF cuni cG cuni wceq cF cuni cF cG cin wcel wi cF cfil wcel cG cfil
    wcel cG cuni cG wcel cF cuni cF wcel cF cuni cG cuni wceq cF cuni cF cG cin
    wcel wi wi cG cG cuni cG cuni eqid filusb cF cuni cG cuni wceq cG cuni cG
    wcel cF cuni cF wcel cF cuni cF cG cin wcel cF cuni cG cuni wceq cG cuni cG
    wcel cF cuni cG wcel cF cuni cF wcel cF cuni cF cG cin wcel wi cF cuni cG
    cuni cG eleq1 cF cuni cF wcel cF cuni cG wcel cF cuni cF cG cin wcel cF
    cuni cF cG cin wcel cF cuni cF wcel cF cuni cG wcel wa cF cuni cF cG elin
    biimpri expcom syl6bir com3l syl cF cF cuni cF cuni eqid filusb syl5com
    3imp eqeltrrd eqeltrd jca cF cfil wcel cG cfil wcel cF cuni cG cuni wceq
    w3a vx cv cF cG cin wcel vy cv cF cG cin cuni wss vx cv vy cv wss w3a vy cv
    cF cG cin wcel wi vx vy cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a
    vx cv cF cG cin wcel vy cv cF cG cin cuni wss vx cv vy cv wss w3a vy cv cF
    wcel vy cv cG wcel wa vy cv cF cG cin wcel cF cfil wcel cG cfil wcel cF
    cuni cG cuni wceq w3a vx cv cF wcel vy cv cF cuni wss vx cv vy cv wss w3a
    vx cv cG wcel vy cv cG cuni wss vx cv vy cv wss w3a wa vy cv cF wcel vy cv
    cG wcel wa vx cv cF cG cin wcel vy cv cF cG cin cuni wss vx cv vy cv wss
    w3a cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a vx cv cF wcel vy cv
    cF cuni wss vx cv vy cv wss w3a vy cv cF wcel vx cv cG wcel vy cv cG cuni
    wss vx cv vy cv wss w3a vy cv cG wcel cF cfil wcel cG cfil wcel vx cv cF
    wcel vy cv cF cuni wss vx cv vy cv wss w3a vy cv cF wcel wi cF cuni cG cuni
    wceq vx cv vy cv cF cF cuni cF cuni eqid fillsb 3ad2ant1 cG cfil wcel cF
    cfil wcel vx cv cG wcel vy cv cG cuni wss vx cv vy cv wss w3a vy cv cG wcel
    wi cF cuni cG cuni wceq vx cv vy cv cG cG cuni cG cuni eqid fillsb 3ad2ant2
    anim12d vx cv cF cG cin wcel vy cv cF cG cin cuni wss vx cv vy cv wss w3a
    vx cv cF wcel vx cv cG wcel wa vy cv cF cuni wss vy cv cG cuni wss wa vx cv
    vy cv wss vx cv vy cv wss wa w3a vx cv cF wcel vy cv cF cuni wss vx cv vy
    cv wss w3a vx cv cG wcel vy cv cG cuni wss vx cv vy cv wss w3a wa vx cv cF
    cG cin wcel vx cv cF wcel vx cv cG wcel wa vy cv cF cG cin cuni wss vy cv
    cF cuni wss vy cv cG cuni wss wa vx cv vy cv wss vx cv vy cv wss vx cv vy
    cv wss wa vx cv cF cG cin wcel vx cv cF wcel vx cv cG wcel wa vx cv cF cG
    elin biimpi vy cv cF cG cin cuni wss vy cv cF cuni cG cuni cin wss vy cv cF
    cuni wss vy cv cG cuni wss wa vy cv cF cG cin cuni wss cF cG cin cuni cF
    cuni cG cuni cin wss vy cv cF cuni cG cuni cin wss cF cG uniin vy cv cF cG
    cin cuni cF cuni cG cuni cin sstr2 mpi vy cv cF cuni cG cuni ssin sylibr vx
    cv vy cv wss vx cv vy cv wss vx cv vy cv wss wa vx cv vy cv wss pm4.24
    biimpi 3anim123i vx cv cF wcel vy cv cF cuni wss vx cv vy cv wss vx cv cG
    wcel vy cv cG cuni wss vx cv vy cv wss an6 sylibr syl5 vy cv cF cG elin
    syl6ibr 19.21aivv cF cfil wcel cG cfil wcel cF cuni cG cuni wceq w3a vx cv
    vy cv cin cF cG cin wcel vx vy cF cG cin cF cG cin cF cfil wcel cG cfil
    wcel vx cv cF cG cin wcel vy cv cF cG cin wcel wa vx cv vy cv cin cF cG cin
    wcel wi cF cuni cG cuni wceq vx cv cF cG cin wcel vy cv cF cG cin wcel wa
    cF cfil wcel cG cfil wcel wa vx cv vy cv cin cF cG cin wcel vx cv cF wcel
    vx cv cG wcel wa vy cv cF wcel vy cv cG wcel wa cF cfil wcel cG cfil wcel
    wa vx cv vy cv cin cF cG cin wcel wi vx cv cF cG cin wcel vy cv cF cG cin
    wcel vx cv cF wcel vy cv cF wcel vx cv cG wcel vy cv cG wcel cF cfil wcel
    cG cfil wcel wa vx cv vy cv cin cF cG cin wcel wi cF cfil wcel cG cfil wcel
    wa vx cv cF wcel vy cv cF wcel wa vx cv cG wcel vy cv cG wcel wa wa vx cv
    vy cv cin cF cG cin wcel cF cfil wcel cG cfil wcel wa vx cv cF wcel vy cv
    cF wcel wa vx cv cG wcel vy cv cG wcel wa wa vx cv vy cv cin cF wcel vx cv
    vy cv cin cG wcel wa vx cv vy cv cin cF cG cin wcel cF cfil wcel vx cv cF
    wcel vy cv cF wcel wa vx cv vy cv cin cF wcel cG cfil wcel vx cv cG wcel vy
    cv cG wcel wa vx cv vy cv cin cG wcel cF cfil wcel vx cv cF wcel vy cv cF
    wcel vx cv vy cv cin cF wcel vx cv vy cv cF filint 3expib cG cfil wcel vx
    cv cG wcel vy cv cG wcel vx cv vy cv cin cG wcel vx cv vy cv cG filint
    3expib im2anan9 vx cv vy cv cin cF cG elin syl6ibr com12 an4s vx cv cF cG
    elin vy cv cF cG elin syl2anb com12 3adant3 r19.21aivv 3jca syl5cbir cF cG
    cfil inex1g syl5com 3ad2ant1 pm2.43i $.
    $( [1-Dec-2010] $) $( [17-Sep-2007] $)
  $}

  ${ $d A x y $.  $d B x y $.
    $( A singleton is a filter.  Bourbaki TG I.36, example 1.  (Contributed by
       FL, 19-Sep-2007.) $)
    oefil2 $p |- ( ( A e. B /\ A =/= (/) ) -> { A } e. Fil ) $=
      cA cB wcel cA c0 wne wa c0 cA csn wcel wn cA csn cuni cA csn wcel wa vx
      cv cA csn wcel vy cv cA csn cuni wss vx cv vy cv wss w3a vy cv cA csn
      wcel wi vy wal vx wal vx cv vy cv cin cA csn wcel vy cA csn wral vx cA
      csn wral w3a cA csn cfil wcel cA cB wcel cA c0 wne wa c0 cA csn wcel wn
      cA csn cuni cA csn wcel wa vx cv cA csn wcel vy cv cA csn cuni wss vx cv
      vy cv wss w3a vy cv cA csn wcel wi vy wal vx wal vx cv vy cv cin cA csn
      wcel vy cA csn wral vx cA csn wral cA cB wcel cA c0 wne wa c0 cA csn wcel
      wn cA csn cuni cA csn wcel cA c0 wne c0 cA csn wcel wn cA cB wcel c0 cA
      csn wcel cA c0 c0 cA csn wcel c0 cA c0 cA elsni eqcomd necon3ai adantl cA
      cB wcel cA c0 wne wa cA csn cuni cA cA csn cA cB wcel cA csn cuni cA wceq
      cA c0 wne cA cB unisng adantr cA cB wcel cA cA csn wcel cA c0 wne cA cB
      snidg adantr eqeltrd jca cA cB wcel vx cv cA csn wcel vy cv cA csn cuni
      wss vx cv vy cv wss w3a vy cv cA csn wcel wi vy wal vx wal cA c0 wne cA
      cB wcel vx cv cA csn wcel vy cv cA csn cuni wss vx cv vy cv wss w3a vy cv
      cA csn wcel wi vx vy cA cB wcel vx cv cA csn wcel vy cv cA csn cuni wss
      vx cv vy cv wss vy cv cA csn wcel cA cB wcel vx cv cA wceq vy cv cA csn
      cuni wss vx cv vy cv wss vy cv cA csn wcel wi wi vx cv cA csn wcel cA cB
      wcel vy cv cA csn cuni wss vx cv cA wceq vx cv vy cv wss vy cv cA csn
      wcel wi cA cB wcel vy cv cA csn cuni wss vy cv cA wss vx cv cA wceq vx cv
      vy cv wss vy cv cA csn wcel wi wi cA cB wcel cA csn cuni cA vy cv cA cB
      unisng sseq2d vx cv cA wceq vx cv vy cv wss vy cv cA wss vy cv cA csn
      wcel vx cv cA wceq vx cv vy cv wss cA vy cv wss vy cv cA wss vy cv cA csn
      wcel wi vx cv cA vy cv sseq1 cA vy cv wss vy cv cA wss vy cv cA csn wcel
      cA vy cv wss vy cv cA wss wa vy cv cA wceq vy cv cA csn wcel vy cv cA wss
      cA vy cv wss vy cv cA wceq vy cv cA wceq vy cv cA wss cA vy cv wss wa vy
      cv cA eqss biimpri ancoms vy cA elsn sylibr ex syl6bi com3r syl6bi com23
      vx cA elsn syl5ib 3impd 19.21aivv adantr vx cv vy cv cin cA csn wcel vy
      cA csn wral vx cA csn wral cA cB wcel cA c0 wne wa vx cv vy cv cin cA csn
      wcel vx vy cA csn vx cv cA wceq vy cv cA wceq vx cv vy cv cin cA csn wcel
      vx cv cA csn wcel vy cv cA csn wcel vx cv cA wceq vy cv cA wceq wa vx cv
      vy cv cin cA wceq vx cv vy cv cin cA csn wcel vx cv cA wceq vy cv cA wceq
      wa vx cv vy cv cin cA cA cin cA vx cv cA vy cv cA ineq12 cA inidm syl6eq
      vx cv vy cv cin cA vx cv vy cv vx visset inex1 elsnc sylibr vx cA elsn vy
      cA elsn syl2anb rgen2a a1i 3jca cA csn cvv wcel cA csn cfil wcel c0 cA
      csn wcel wn cA csn cuni cA csn wcel wa vx cv cA csn wcel vy cv cA csn
      cuni wss vx cv vy cv wss w3a vy cv cA csn wcel wi vy wal vx wal vx cv vy
      cv cin cA csn wcel vy cA csn wral vx cA csn wral w3a wb cA snex vx vy cvv
      cA csn cA csn cuni cA csn cuni eqid isfil ax-mp sylibr $.
      $( [1-Dec-2010] $) $( [16-Sep-2007] $)
  $}

  ${
    $d x y z F $.
    $( A filter is a filter base. (Contributed by Jeff Hankins,
       2-Sep-2009.) $)
    filfbas $p |- ( F e. Fil -> F e. fBas ) $=
      cF cfil wcel cF cfbas wcel cF c0 wne c0 cF wnel vz cv vx cv vy cv cin wss
      vz cF wrex vy cF wral vx cF wral w3a cF cfil wcel cF c0 wne c0 cF wnel vz
      cv vx cv vy cv cin wss vz cF wrex vy cF wral vx cF wral cF cfil wcel cF
      cuni cF wcel cF c0 wne cF cF cuni cF cuni eqid filusb cF cF cuni ne0i syl
      cF cfil wcel c0 cF wcel wn c0 cF wnel cF filesn c0 cF df-nel sylibr cF
      cfil wcel vz cv vx cv vy cv cin wss vz cF wrex vx vy cF cF cF cfil wcel
      vx cv cF wcel vy cv cF wcel vz cv vx cv vy cv cin wss vz cF wrex vx cv vy
      cv cin cF wcel vx cv vy cv cin vx cv vy cv cin wss vz cv vx cv vy cv cin
      wss vz cF wrex cF cfil wcel vx cv cF wcel vy cv cF wcel w3a vz cv vx cv
      vy cv cin wss vx cv vy cv cin vx cv vy cv cin wss vz vx cv vy cv cin cF
      vz cv vx cv vy cv cin vx cv vy cv cin sseq1 rcla4ev vx cv vy cv cF filint
      vx cv vy cv cin vx cv vy cv cin wss cF cfil wcel vx cv cF wcel vy cv cF
      wcel w3a vx cv vy cv cin ssid a1i sylanc 3expib r19.21aivv 3jca vx vy vz
      cfil cF isfbas2 mpbird $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d x y F $.
    $( No filter base contains the empty set.
       (Contributed by Jeff Hankins, 1-Sep-2009.) $)
    0nelfb $p |- ( F e. fBas -> (/) e/ F ) $=
      cF cfbas wcel cF c0 wne c0 cF wnel cF vx cv vy cv cin cpw cin c0 wne vy
      cF wral vx cF wral cF cfbas wcel cF c0 wne c0 cF wnel cF vx cv vy cv cin
      cpw cin c0 wne vy cF wral vx cF wral w3a vx vy cfbas cF isfbas ibi
      3simp2d $.
      $( [1-Dec-2010] $) $( [1-Sep-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z F $.
    $( A filter base contains subsets of its pairwise intersections.
       (Contributed by Jeff Hankins, 1-Sep-2009.) $)
    fbasssin $p |- ( ( F e. fBas /\ A e. F /\ B e. F ) -> E. x e. F x C_ ( A
    i^i B ) ) $=
      cF cfbas wcel cA cF wcel cB cF wcel vx cv cA cB cin wss vx cF wrex cA cF
      wcel cB cF wcel wa vx cv vy cv vz cv cin wss vx cF wrex vz cF wral vy cF
      wral vx cv cA cB cin wss vx cF wrex cF cfbas wcel vx cv vy cv vz cv cin
      wss vx cF wrex vx cv cA cB cin wss vx cF wrex vx cv cA vz cv cin wss vx
      cF wrex vy vz cA cB cF cF vy cv cA wceq vx cv vy cv vz cv cin wss vx cv
      cA vz cv cin wss vx cF vy cv cA wceq vy cv vz cv cin cA vz cv cin vx cv
      vy cv cA vz cv ineq1 sseq2d rexbidv vz cv cB wceq vx cv cA vz cv cin wss
      vx cv cA cB cin wss vx cF vz cv cB wceq cA vz cv cin cA cB cin vx cv vz
      cv cB cA ineq2 sseq2d rexbidv rcla42v cF cfbas wcel cF c0 wne c0 cF wnel
      vx cv vy cv vz cv cin wss vx cF wrex vz cF wral vy cF wral cF cfbas wcel
      cF c0 wne c0 cF wnel vx cv vy cv vz cv cin wss vx cF wrex vz cF wral vy
      cF wral w3a vy vz vx cfbas cF isfbas2 ibi 3simp3d syl5com 3impib $.
      $( [1-Dec-2010] $) $( [1-Sep-2009] $)
  $}

  ${
    $d f g k n t x y z A $. $d f g k n t x y z F $.
    $( A filter base contains subsets of its finite intersections.
       (Contributed by Jeff Hankins, 1-Sep-2009.) $)
    fbssint $p |- ( ( F e. fBas /\ A C_ F /\ A e. Fin ) ->
    E. x e. F x C_ |^| A ) $=
      cF cfbas wcel cA cF wss cA cfn wcel vx cv cA cint wss vx cF wrex cA cfn
      wcel cF cfbas wcel cA cF wss wa vx cv cA cint wss vx cF wrex cA cfn wcel
      cA vn cv cen wbr vn com wrex cF cfbas wcel cA cF wss wa vx cv cA cint wss
      vx cF wrex wi vn cA isfi cA vn cv cen wbr cF cfbas wcel cA cF wss wa vx
      cv cA cint wss vx cF wrex wi vn com cA vn cv cen wbr vn cv com wcel cF
      cfbas wcel cA cF wss wa vx cv cA cint wss vx cF wrex wi cA vn cv cen wbr
      cA cvv wcel vn cv com wcel cF cfbas wcel cA cF wss wa vx cv cA cint wss
      vx cF wrex wi wi cA vn cv cen relen brrelexi cA vn cv cen wbr cA vn cv vf
      cv wf1o vf wex cA cvv wcel vn cv com wcel cF cfbas wcel cA cF wss wa vx
      cv cA cint wss vx cF wrex wi wi wi cA vn cv vf vn visset bren cA cvv wcel
      vn cv com wcel cA vn cv vf cv wf1o vf wex cF cfbas wcel cA cF wss wa vx
      cv cA cint wss vx cF wrex wi cA cvv wcel vy cv vn cv vf cv wf1o vf wex cF
      cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi vy wal
      cA vn cv vf cv wf1o vf wex cF cfbas wcel cA cF wss wa vx cv cA cint wss
      vx cF wrex wi wi vn cv com wcel vy cv vn cv vf cv wf1o vf wex cF cfbas
      wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi cA vn cv vf cv
      wf1o vf wex cF cfbas wcel cA cF wss wa vx cv cA cint wss vx cF wrex wi wi
      vy cA cvv vy cv cA wceq vy cv vn cv vf cv wf1o vf wex cA vn cv vf cv wf1o
      vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi
      cF cfbas wcel cA cF wss wa vx cv cA cint wss vx cF wrex wi vy cv cA wceq
      vy cv vn cv vf cv wf1o cA vn cv vf cv wf1o vf vy cv cA vn cv vf cv f1oeq2
      exbidv vy cv cA wceq cF cfbas wcel vy cv cF wss wa cF cfbas wcel cA cF
      wss wa vx cv vy cv cint wss vx cF wrex vx cv cA cint wss vx cF wrex vy cv
      cA wceq vy cv cF wss cA cF wss cF cfbas wcel vy cv cA cF sseq1 anbi2d vy
      cv cA wceq vx cv vy cv cint wss vx cv cA cint wss vx cF vy cv cA wceq vy
      cv cint cA cint vx cv vy cv cA inteq sseq2d rexbidv imbi12d imbi12d
      cla4gv vy cv vk cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv
      vy cv cint wss vx cF wrex wi wi vy wal vy cv c0 vf cv wf1o vf wex cF
      cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi vy wal
      vy cv vt cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi wi vy wal vy cv vt cv csuc vf cv wf1o vf wex cF
      cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi vy wal
      vy cv vn cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi wi vy wal vk vt vn cv vk cv c0 wceq vy cv vk cv vf
      cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF
      wrex wi wi vy cv c0 vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv
      vy cv cint wss vx cF wrex wi wi vy vk cv c0 wceq vy cv vk cv vf cv wf1o
      vf wex vy cv c0 vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy
      cv cint wss vx cF wrex wi vk cv c0 wceq vy cv vk cv vf cv wf1o vy cv c0
      vf cv wf1o vf vk cv c0 vy cv vf cv f1oeq3 exbidv imbi1d albidv vk cv vt
      cv wceq vy cv vk cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv
      vy cv cint wss vx cF wrex wi wi vy cv vt cv vf cv wf1o vf wex cF cfbas
      wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi vy vk cv vt cv
      wceq vy cv vk cv vf cv wf1o vf wex vy cv vt cv vf cv wf1o vf wex cF cfbas
      wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi vk cv vt cv wceq
      vy cv vk cv vf cv wf1o vy cv vt cv vf cv wf1o vf vk cv vt cv vy cv vf cv
      f1oeq3 exbidv imbi1d albidv vk cv vt cv csuc wceq vy cv vk cv vf cv wf1o
      vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi
      wi vy cv vt cv csuc vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv
      vy cv cint wss vx cF wrex wi wi vy vk cv vt cv csuc wceq vy cv vk cv vf
      cv wf1o vf wex vy cv vt cv csuc vf cv wf1o vf wex cF cfbas wcel vy cv cF
      wss wa vx cv vy cv cint wss vx cF wrex wi vk cv vt cv csuc wceq vy cv vk
      cv vf cv wf1o vy cv vt cv csuc vf cv wf1o vf vk cv vt cv csuc vy cv vf cv
      f1oeq3 exbidv imbi1d albidv vk cv vn cv wceq vy cv vk cv vf cv wf1o vf
      wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi
      vy cv vn cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi wi vy vk cv vn cv wceq vy cv vk cv vf cv wf1o vf
      wex vy cv vn cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy
      cv cint wss vx cF wrex wi vk cv vn cv wceq vy cv vk cv vf cv wf1o vy cv
      vn cv vf cv wf1o vf vk cv vn cv vy cv vf cv f1oeq3 exbidv imbi1d albidv
      vy cv c0 vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint
      wss vx cF wrex wi wi vy vy cv c0 vf cv wf1o cF cfbas wcel vy cv cF wss wa
      vx cv vy cv cint wss vx cF wrex wi vf vy cv c0 vf cv wf1o cF cfbas wcel
      vx cv vy cv cint wss vx cF wrex vy cv cF wss vy cv c0 vf cv wf1o cF c0
      wne vx cv vy cv cint wss vx cF wrex cF cfbas wcel vy cv c0 vf cv wf1o vx
      cv cF wcel vx wex vx cv cF wcel vx cv vy cv cint wss wa vx wex cF c0 wne
      vx cv vy cv cint wss vx cF wrex vy cv c0 vf cv wf1o vx cv cF wcel vx cv
      cF wcel vx cv vy cv cint wss wa vx vy cv c0 vf cv wf1o vx cv cF wcel vx
      cv vy cv cint wss vy cv c0 vf cv wf1o vx cv vy cv cint wss vx cv cF wcel
      vy cv c0 vf cv wf1o c0 vy cv vf cv ccnv wf1o vy cv c0 wceq vx cv vy cv
      cint wss vy cv c0 vf cv f1ocnv c0 vy cv vf cv ccnv wf1o vf cv ccnv c0
      wceq vy cv c0 wceq vy cv vf cv ccnv f1o00 pm3.27bi vy cv c0 wceq vx cv vy
      cv cint wss vx cv c0 cint wss vx cv cvv c0 cint vx cv ssv int0 sseqtr4i
      vy cv c0 wceq vy cv cint c0 cint vx cv vy cv c0 inteq sseq2d mpbiri 3syl
      a1d ancld 19.22dv vx cF n0 vx cv vy cv cint wss vx cF df-rex 3imtr4g cF
      fbasne0 syl5 adantrd 19.23aiv ax-gen vt cv com wcel vz cv vt cv vg cv
      wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx cF wrex
      wi wi vz wal vy cv vt cv csuc vf cv wf1o vf wex cF cfbas wcel vy cv cF
      wss wa vx cv vy cv cint wss vx cF wrex wi wi vy wal vy cv vt cv vf cv
      wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex
      wi wi vy wal vt cv com wcel vz cv vt cv vg cv wf1o vg wex cF cfbas wcel
      vz cv cF wss wa vx cv vz cv cint wss vx cF wrex wi wi vz wal vy cv vt cv
      csuc vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss
      vx cF wrex wi wi vy vt cv com wcel vz cv vt cv vg cv wf1o vg wex cF cfbas
      wcel vz cv cF wss wa vx cv vz cv cint wss vx cF wrex wi wi vz wal vy cv
      vt cv csuc vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi wi vt cv com wcel vz cv vt cv vg cv wf1o vg wex cF
      cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx cF wrex wi wi vz wal
      wa vy cv vt cv csuc vf cv wf1o cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi vf vt cv com wcel vz cv vt cv vg cv wf1o vg wex cF
      cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx cF wrex wi wi vz wal
      vy cv vt cv csuc vf cv wf1o cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi wi vt cv com wcel vy cv vt cv csuc vf cv wf1o vz
      cv vt cv vg cv wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint
      wss vx cF wrex wi wi vz wal cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi vt cv com wcel vy cv vt cv csuc vf cv wf1o vz cv
      vt cv vg cv wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint
      wss vx cF wrex wi wi vz wal cF cfbas wcel vy cv cF wss wa vx cv vy cv
      cint wss vx cF wrex wi wi vt cv com wcel vy cv vt cv csuc vf cv wf1o wa
      vf cv ccnv vt cv cima vt cv vg cv wf1o vg wex cF cfbas wcel vf cv ccnv vt
      cv cima cF wss wa vx cv vf cv ccnv vt cv cima cint wss vx cF wrex wi wi
      cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi vz cv vt
      cv vg cv wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint wss
      vx cF wrex wi wi vz wal vt cv com wcel vy cv vt cv csuc vf cv wf1o wa vf
      cv ccnv vt cv cima vt cv vg cv wf1o vg wex vf cv ccnv vt cv cima vt cv vg
      cv wf1o vg wex cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv
      ccnv vt cv cima cint wss vx cF wrex wi wi cF cfbas wcel vy cv cF wss wa
      vx cv vy cv cint wss vx cF wrex wi wi vt cv com wcel vy cv vt cv csuc vf
      cv wf1o wa vt cv vf cv ccnv vt cv cima vf cv ccnv vt cv cres wf1o vf cv
      ccnv vt cv cima vt cv vf cv ccnv vt cv cres ccnv wf1o vf cv ccnv vt cv
      cima vt cv vg cv wf1o vg wex vt cv com wcel vt cv csuc vy cv vf cv ccnv
      wf1o vt cv vf cv ccnv vt cv cima vf cv ccnv vt cv cres wf1o vy cv vt cv
      csuc vf cv wf1o vt cv csuc vy cv vf cv ccnv wf1o vt cv vf cv ccnv vt cv
      cima vf cv ccnv vt cv cres wf1o vt cv com wcel vt cv csuc vy cv vf cv
      ccnv wf1 vt cv vt cv csuc wss vt cv vf cv ccnv vt cv cima vf cv ccnv vt
      cv cres wf1o vt cv csuc vy cv vf cv ccnv wf1o vt cv csuc vy cv vt cv vf
      cv ccnv f1ores vt cv csuc vy cv vf cv ccnv f1of1 vt cv vt cv csuc wss vt
      cv csuc vy cv vf cv ccnv wf1o vt cv sssucid a1i sylanc adantl vy cv vt cv
      csuc vf cv f1ocnv sylan2 vt cv vf cv ccnv vt cv cima vf cv ccnv vt cv
      cres f1ocnv vf cv ccnv vt cv cima vt cv vg cv wf1o vf cv ccnv vt cv cima
      vt cv vf cv ccnv vt cv cres ccnv wf1o vg vf cv ccnv vt cv cres ccnv vf cv
      ccnv vt cv cres vf cv ccnv cvv wcel vf cv ccnv vt cv cres cvv wcel vf cv
      vf visset cnvex vf cv ccnv vt cv cvv resexg ax-mp cnvex vf cv ccnv vt cv
      cima vt cv vg cv vf cv ccnv vt cv cres ccnv f1oeq1 cla4ev 3syl vf cv ccnv
      vt cv cima vt cv vg cv wf1o vg wex vf cv ccnv vt cv cima vt cv vg cv wf1o
      vg wex cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv ccnv vt
      cv cima cint wss vx cF wrex wi wi vt cv com wcel vy cv vt cv csuc vf cv
      wf1o wa cF cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi
      vf cv ccnv vt cv cima vt cv vg cv wf1o vg wex vf cv ccnv vt cv cima vt cv
      vg cv wf1o vg wex cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf
      cv ccnv vt cv cima cint wss vx cF wrex wi wi cF cfbas wcel vf cv ccnv vt
      cv cima cF wss wa vx cv vf cv ccnv vt cv cima cint wss vx cF wrex wi vt
      cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa
      vx cv vy cv cint wss vx cF wrex wi wi vf cv ccnv vt cv cima vt cv vg cv
      wf1o vg wex cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv
      ccnv vt cv cima cint wss vx cF wrex wi pm2.27 vt cv com wcel vy cv vt cv
      csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa cF cfbas wcel vf cv ccnv
      vt cv cima cF wss wa vx cv vf cv ccnv vt cv cima cint wss vx cF wrex wi
      vx cv vy cv cint wss vx cF wrex vt cv com wcel vy cv vt cv csuc vf cv
      wf1o wa cF cfbas wcel vy cv cF wss wa cF cfbas wcel vf cv ccnv vt cv cima
      cF wss wa vx cv vf cv ccnv vt cv cima cint wss vx cF wrex wi vx cv vy cv
      cint wss vx cF wrex wi vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF
      cfbas wcel vy cv cF wss wa wa cF cfbas wcel vf cv ccnv vt cv cima cF wss
      cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv ccnv vt cv cima
      cint wss vx cF wrex wi vx cv vy cv cint wss vx cF wrex wi vt cv com wcel
      vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss simprl vy cv vt
      cv csuc vf cv wf1o vy cv cF wss vf cv ccnv vt cv cima cF wss vt cv com
      wcel cF cfbas wcel vf cv ccnv vt cv cima vy cv wss vy cv cF wss vf cv
      ccnv vt cv cima cF wss vy cv vt cv csuc vf cv wf1o vf cv ccnv vt cv cima
      vy cv cF sstr vy cv vt cv csuc vf cv wf1o vf cv ccnv vt cv cima vf cv cdm
      wss vf cv ccnv vt cv cima vy cv wss vf cv vt cv cnvimass vy cv vt cv csuc
      vf cv wf1o vf cv vy cv wfn vf cv cdm vy cv wceq vf cv ccnv vt cv cima vf
      cv cdm wss vf cv ccnv vt cv cima vy cv wss wb vy cv vt cv csuc vf cv
      f1ofn vy cv vf cv fndm vf cv cdm vy cv vf cv ccnv vt cv cima sseq2 3syl
      mpbii sylan ad2ant2l cF cfbas wcel vf cv ccnv vt cv cima cF wss wa cF
      cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv ccnv vt cv cima
      cint wss vx cF wrex wi vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF
      cfbas wcel vy cv cF wss wa wa vx cv vy cv cint wss vx cF wrex cF cfbas
      wcel vf cv ccnv vt cv cima cF wss wa cF cfbas wcel vf cv ccnv vt cv cima
      cF wss wa vx cv vf cv ccnv vt cv cima cint wss vx cF wrex wi vx cv vf cv
      ccnv vt cv cima cint wss vx cF wrex vt cv com wcel vy cv vt cv csuc vf cv
      wf1o wa cF cfbas wcel vy cv cF wss wa wa vx cv vy cv cint wss vx cF wrex
      wi cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv ccnv vt cv
      cima cint wss vx cF wrex pm2.27 vx cv vf cv ccnv vt cv cima cint wss vx
      cF wrex vz cv vf cv ccnv vt cv cima cint wss vz cF wrex vt cv com wcel vy
      cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa vx cv vy cv
      cint wss vx cF wrex wi vx cv vf cv ccnv vt cv cima cint wss vz cv vf cv
      ccnv vt cv cima cint wss vx vz cF vx cv vz cv vf cv ccnv vt cv cima cint
      sseq1 cbvrexv vz cv vf cv ccnv vt cv cima cint wss vt cv com wcel vy cv
      vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa vx cv vy cv
      cint wss vx cF wrex wi vz cF vz cv cF wcel vz cv vf cv ccnv vt cv cima
      cint wss vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy
      cv cF wss wa wa vx cv vy cv cint wss vx cF wrex vz cv cF wcel vz cv vf cv
      ccnv vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa
      cF cfbas wcel vy cv cF wss wa wa wa vx cv vf cv ccnv vt cv cima cint vt
      cv vf cv ccnv cfv cin wss vx cF wrex vx cv vy cv cint wss vx cF wrex vz
      cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv
      vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vx cv vz cv
      vt cv vf cv ccnv cfv cin wss vx cF wrex vx cv vf cv ccnv vt cv cima cint
      vt cv vf cv ccnv cfv cin wss vx cF wrex cF cfbas wcel vz cv cF wcel vt cv
      vf cv ccnv cfv cF wcel vx cv vz cv vt cv vf cv ccnv cfv cin wss vx cF
      wrex vz cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel
      vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vx vz
      cv vt cv vf cv ccnv cfv cF fbasssin vz cv cF wcel vz cv vf cv ccnv vt cv
      cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas
      wcel vy cv cF wss simprrl vz cv cF wcel vz cv vf cv ccnv vt cv cima cint
      wss vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF
      wss wa wa simpll vz cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa vt
      cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa
      wa wa vy cv cF vt cv vf cv ccnv cfv vz cv cF wcel vz cv vf cv ccnv vt cv
      cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas
      wcel vy cv cF wss simprrr vt cv com wcel vy cv vt cv csuc vf cv wf1o wa
      cF cfbas wcel vy cv cF wss wa wa vt cv vf cv ccnv cfv vy cv wcel vz cv cF
      wcel vz cv vf cv ccnv vt cv cima cint wss wa vy cv vt cv csuc vf cv wf1o
      vt cv vf cv ccnv cfv vy cv wcel vt cv com wcel cF cfbas wcel vy cv cF wss
      wa vy cv vt cv csuc vf cv wf1o vt cv csuc vy cv vf cv ccnv wf1o vt cv
      csuc vy cv vf cv ccnv wf vt cv vf cv ccnv cfv vy cv wcel vy cv vt cv csuc
      vf cv f1ocnv vt cv csuc vy cv vf cv ccnv f1of vt cv csuc vy cv vf cv ccnv
      wf vt cv vt cv csuc wcel vt cv vf cv ccnv cfv vy cv wcel vt cv vt visset
      sucid vt cv csuc vy cv vt cv vf cv ccnv ffvelrn mpan2 3syl ad2antlr
      adantl sseldd syl3anc vz cv cF wcel vz cv vf cv ccnv vt cv cima cint wss
      wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF
      wss wa wa wa vx cv vz cv vt cv vf cv ccnv cfv cin wss vx cv vf cv ccnv vt
      cv cima cint vt cv vf cv ccnv cfv cin wss vx cF vz cv vf cv ccnv vt cv
      cima cint wss vx cv vz cv vt cv vf cv ccnv cfv cin wss vx cv vf cv ccnv
      vt cv cima cint vt cv vf cv ccnv cfv cin wss wi vz cv cF wcel vt cv com
      wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa vx
      cv vz cv vt cv vf cv ccnv cfv cin wss vz cv vt cv vf cv ccnv cfv cin vf
      cv ccnv vt cv cima cint vt cv vf cv ccnv cfv cin wss vx cv vf cv ccnv vt
      cv cima cint vt cv vf cv ccnv cfv cin wss vz cv vf cv ccnv vt cv cima
      cint wss vx cv vz cv vt cv vf cv ccnv cfv cin vf cv ccnv vt cv cima cint
      vt cv vf cv ccnv cfv cin sstr2 vz cv vf cv ccnv vt cv cima cint vt cv vf
      cv ccnv cfv ssrin syl5com ad2antlr r19.22sdv mpd vz cv cF wcel vz cv vf
      cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o
      wa cF cfbas wcel vy cv cF wss wa wa wa vx cv vf cv ccnv vt cv cima cint
      vt cv vf cv ccnv cfv cin wss vx cv vy cv cint wss vx cF vz cv cF wcel vz
      cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc vf
      cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vf cv ccnv vt cv cima cint
      vt cv vf cv ccnv cfv cin vy cv cint vx cv vz cv cF wcel vz cv vf cv ccnv
      vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF
      cfbas wcel vy cv cF wss wa wa wa vf cv ccnv vt cv cima cint vt cv vf cv
      ccnv cfv cin vf cv ccnv vt cv cima vf cv ccnv vt cv csn cima cun cint vy
      cv cint vz cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa vt cv com
      wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa
      vf cv ccnv vt cv cima vt cv vf cv ccnv cfv csn cun cint vf cv ccnv vt cv
      cima cint vt cv vf cv ccnv cfv csn cint cin vf cv ccnv vt cv cima vf cv
      ccnv vt cv csn cima cun cint vf cv ccnv vt cv cima cint vt cv vf cv ccnv
      cfv cin vf cv ccnv vt cv cima vt cv vf cv ccnv cfv csn cun cint vf cv
      ccnv vt cv cima cint vt cv vf cv ccnv cfv csn cint cin wceq vz cv cF wcel
      vz cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc
      vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vf cv ccnv vt cv cima
      vt cv vf cv ccnv cfv csn intun a1i vz cv cF wcel vz cv vf cv ccnv vt cv
      cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF cfbas
      wcel vy cv cF wss wa wa wa vf cv ccnv vt cv cima vt cv vf cv ccnv cfv csn
      cun vf cv ccnv vt cv cima vf cv ccnv vt cv csn cima cun vz cv cF wcel vz
      cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc vf
      cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vt cv vf cv ccnv cfv csn
      vf cv ccnv vt cv csn cima vf cv ccnv vt cv cima vt cv com wcel vy cv vt
      cv csuc vf cv wf1o wa vt cv vf cv ccnv cfv csn vf cv ccnv vt cv csn cima
      wceq vz cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa cF cfbas wcel
      vy cv cF wss wa vy cv vt cv csuc vf cv wf1o vt cv vf cv ccnv cfv csn vf
      cv ccnv vt cv csn cima wceq vt cv com wcel vy cv vt cv csuc vf cv wf1o vt
      cv csuc vy cv vf cv ccnv wf1o vf cv ccnv vt cv csuc wfn vt cv vf cv ccnv
      cfv csn vf cv ccnv vt cv csn cima wceq vy cv vt cv csuc vf cv f1ocnv vt
      cv csuc vy cv vf cv ccnv f1ofn vf cv ccnv vt cv csuc wfn vt cv vt cv csuc
      wcel vt cv vf cv ccnv cfv csn vf cv ccnv vt cv csn cima wceq vt cv vt
      visset sucid vt cv csuc vt cv vf cv ccnv fnsnfv mpan2 3syl adantl
      ad2antrl uneq2d inteqd vf cv ccnv vt cv cima cint vt cv vf cv ccnv cfv
      csn cint cin vf cv ccnv vt cv cima cint vt cv vf cv ccnv cfv cin wceq vz
      cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv
      vt cv csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vt cv vf cv
      ccnv cfv csn cint vt cv vf cv ccnv cfv vf cv ccnv vt cv cima cint vt cv
      vf cv ccnv cfv vt cv vf cv ccnv fvex intsn ineq2i a1i 3eqtr3rd vz cv cF
      wcel vz cv vf cv ccnv vt cv cima cint wss wa vt cv com wcel vy cv vt cv
      csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa wa vf cv ccnv vt cv
      cima vf cv ccnv vt cv csn cima cun vy cv vz cv cF wcel vz cv vf cv ccnv
      vt cv cima cint wss wa vt cv com wcel vy cv vt cv csuc vf cv wf1o wa cF
      cfbas wcel vy cv cF wss wa wa wa vf cv ccnv vt cv csuc cima vy cv vf cv
      ccnv vt cv cima vf cv ccnv vt cv csn cima cun vt cv com wcel vy cv vt cv
      csuc vf cv wf1o wa cF cfbas wcel vy cv cF wss wa wa vf cv ccnv vt cv csuc
      cima vy cv wceq vz cv cF wcel vz cv vf cv ccnv vt cv cima cint wss wa vy
      cv vt cv csuc vf cv wf1o vf cv ccnv vt cv csuc cima vy cv wceq vt cv com
      wcel cF cfbas wcel vy cv cF wss wa vy cv vt cv csuc vf cv wf1o vt cv csuc
      vy cv vf cv ccnv wf1o vt cv csuc vy cv vf cv ccnv wfo vf cv ccnv vt cv
      csuc cima vy cv wceq vy cv vt cv csuc vf cv f1ocnv vt cv csuc vy cv vf cv
      ccnv f1ofo vt cv csuc vy cv vf cv ccnv foima 3syl ad2antlr adantl vf cv
      ccnv vt cv csuc cima vf cv ccnv vt cv vt cv csn cun cima vf cv ccnv vt cv
      cima vf cv ccnv vt cv csn cima cun vt cv csuc vt cv vt cv csn cun vf cv
      ccnv vt cv df-suc imaeq2i vf cv ccnv vt cv vt cv csn imaundi eqtri
      syl5eqr inteqd eqtrd sseq2d rexbidv mpbid exp31 r19.23aiv sylbi syl6
      com3r mp2and ex com3r syl6 com3r mpd vz cv vt cv vg cv wf1o vg wex cF
      cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx cF wrex wi wi vf cv
      ccnv vt cv cima vt cv vg cv wf1o vg wex cF cfbas wcel vf cv ccnv vt cv
      cima cF wss wa vx cv vf cv ccnv vt cv cima cint wss vx cF wrex wi wi vz
      vf cv ccnv vt cv cima vf cv ccnv cvv wcel vf cv ccnv vt cv cima cvv wcel
      vf cv vf visset cnvex vf cv ccnv vt cv cvv imaexg ax-mp vz cv vf cv ccnv
      vt cv cima wceq vz cv vt cv vg cv wf1o vg wex vf cv ccnv vt cv cima vt cv
      vg cv wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx
      cF wrex wi cF cfbas wcel vf cv ccnv vt cv cima cF wss wa vx cv vf cv ccnv
      vt cv cima cint wss vx cF wrex wi vz cv vf cv ccnv vt cv cima wceq vz cv
      vt cv vg cv wf1o vf cv ccnv vt cv cima vt cv vg cv wf1o vg vz cv vf cv
      ccnv vt cv cima vt cv vg cv f1oeq2 exbidv vz cv vf cv ccnv vt cv cima
      wceq cF cfbas wcel vz cv cF wss wa cF cfbas wcel vf cv ccnv vt cv cima cF
      wss wa vx cv vz cv cint wss vx cF wrex vx cv vf cv ccnv vt cv cima cint
      wss vx cF wrex vz cv vf cv ccnv vt cv cima wceq vz cv cF wss vf cv ccnv
      vt cv cima cF wss cF cfbas wcel vz cv vf cv ccnv vt cv cima cF sseq1
      anbi2d vz cv vf cv ccnv vt cv cima wceq vx cv vz cv cint wss vx cv vf cv
      ccnv vt cv cima cint wss vx cF vz cv vf cv ccnv vt cv cima wceq vz cv
      cint vf cv ccnv vt cv cima cint vx cv vz cv vf cv ccnv vt cv cima inteq
      sseq2d rexbidv imbi12d imbi12d cla4v syl5 ex com23 imp 19.23adv ex
      19.21adv vy cv vt cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx
      cv vy cv cint wss vx cF wrex wi wi vy wal vz cv vt cv vf cv wf1o vf wex
      cF cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx cF wrex wi wi vz
      wal vz cv vt cv vg cv wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz
      cv cint wss vx cF wrex wi wi vz wal vy cv vt cv vf cv wf1o vf wex cF
      cfbas wcel vy cv cF wss wa vx cv vy cv cint wss vx cF wrex wi wi vz cv vt
      cv vf cv wf1o vf wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint wss
      vx cF wrex wi wi vy vz vy cv vz cv wceq vy cv vt cv vf cv wf1o vf wex vz
      cv vt cv vf cv wf1o vf wex cF cfbas wcel vy cv cF wss wa vx cv vy cv cint
      wss vx cF wrex wi cF cfbas wcel vz cv cF wss wa vx cv vz cv cint wss vx
      cF wrex wi vy cv vz cv wceq vy cv vt cv vf cv wf1o vz cv vt cv vf cv wf1o
      vf vy cv vz cv vt cv vf cv f1oeq2 exbidv vy cv vz cv wceq cF cfbas wcel
      vy cv cF wss wa cF cfbas wcel vz cv cF wss wa vx cv vy cv cint wss vx cF
      wrex vx cv vz cv cint wss vx cF wrex vy cv vz cv wceq vy cv cF wss vz cv
      cF wss cF cfbas wcel vy cv vz cv cF sseq1 anbi2d vy cv vz cv wceq vx cv
      vy cv cint wss vx cv vz cv cint wss vx cF vy cv vz cv wceq vy cv cint vz
      cv cint vx cv vy cv vz cv inteq sseq2d rexbidv imbi12d imbi12d cbvalv vz
      cv vt cv vf cv wf1o vf wex cF cfbas wcel vz cv cF wss wa vx cv vz cv cint
      wss vx cF wrex wi wi vz cv vt cv vg cv wf1o vg wex cF cfbas wcel vz cv cF
      wss wa vx cv vz cv cint wss vx cF wrex wi wi vz vz cv vt cv vf cv wf1o vf
      wex vz cv vt cv vg cv wf1o vg wex cF cfbas wcel vz cv cF wss wa vx cv vz
      cv cint wss vx cF wrex wi vz cv vt cv vf cv wf1o vz cv vt cv vg cv wf1o
      vf vg vz cv vt cv vf cv vg cv f1oeq1 cbvexv imbi1i albii bitri syl5ib
      finds syl5 com3r sylbi mpd com12 r19.23aiv sylbi com12 3impia $.
      $( [1-Dec-2010] $) $( [1-Sep-2009] $)
  $}

  ${ $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( The intersection of two finite intersections is a finite
       intersection.  (Contributed by FL, 2-Sep-2008.) $)
    infi $p |- ( C e. D -> ( ( A e. ( fi ` C ) /\  B e. ( fi ` C ) ) ->
    ( A i^i B ) e. ( fi ` C ) ) ) $=
      cC cD wcel cA cC cfi cfv wcel cB cC cfi cfv wcel wa cA cB cin cC cfi cfv
      wcel cC cD wcel cA cC cfi cfv wcel cB cC cfi cfv wcel wa wa cA cB cin cC
      cfi cfv wcel vz cv cC wss vz cv cfn wcel cA cB cin vz cv cint wceq w3a vz
      wex cC cD wcel cA cC cfi cfv wcel cB cC cfi cfv wcel wa vz cv cC wss vz
      cv cfn wcel cA cB cin vz cv cint wceq w3a vz wex cC cD wcel vx cv cC wss
      vx cv cfn wcel cA vx cv cint wceq w3a vx wex vy cv cC wss vy cv cfn wcel
      cB vy cv cint wceq w3a vy wex vz cv cC wss vz cv cfn wcel cA cB cin vz cv
      cint wceq w3a vz wex cA cC cfi cfv wcel cB cC cfi cfv wcel vx cv cC wss
      vx cv cfn wcel cA vx cv cint wceq w3a vx wex vy cv cC wss vy cv cfn wcel
      cB vy cv cint wceq w3a vy wex wa vz cv cC wss vz cv cfn wcel cA cB cin vz
      cv cint wceq w3a vz wex wi cC cD wcel vx cv cC wss vx cv cfn wcel cA vx
      cv cint wceq w3a vx wex vy cv cC wss vy cv cfn wcel cB vy cv cint wceq
      w3a vy wex vz cv cC wss vz cv cfn wcel cA cB cin vz cv cint wceq w3a vz
      wex vx cv cC wss vx cv cfn wcel cA vx cv cint wceq w3a vy cv cC wss vy cv
      cfn wcel cB vy cv cint wceq w3a vy wex vz cv cC wss vz cv cfn wcel cA cB
      cin vz cv cint wceq w3a vz wex wi vx vy cv cC wss vy cv cfn wcel cB vy cv
      cint wceq w3a vy wex vx cv cC wss vx cv cfn wcel cA vx cv cint wceq w3a
      vz cv cC wss vz cv cfn wcel cA cB cin vz cv cint wceq w3a vz wex vy cv cC
      wss vy cv cfn wcel cB vy cv cint wceq w3a vx cv cC wss vx cv cfn wcel cA
      vx cv cint wceq w3a vz cv cC wss vz cv cfn wcel cA cB cin vz cv cint wceq
      w3a vz wex wi vy vx cv cC wss vx cv cfn wcel cA vx cv cint wceq w3a vy cv
      cC wss vy cv cfn wcel cB vy cv cint wceq w3a vx cv vy cv cun cC wss vx cv
      vy cv cun cfn wcel cA cB cin vx cv vy cv cun cint wceq w3a vz cv cC wss
      vz cv cfn wcel cA cB cin vz cv cint wceq w3a vz wex vx cv cC wss vx cv
      cfn wcel cA vx cv cint wceq w3a vy cv cC wss vy cv cfn wcel cB vy cv cint
      wceq w3a vx cv vy cv cun cC wss vx cv vy cv cun cfn wcel cA cB cin vx cv
      vy cv cun cint wceq w3a vx cv cC wss vx cv cfn wcel cA vx cv cint wceq
      w3a vy cv cC wss vy cv cfn wcel cB vy cv cint wceq w3a wa vx cv cC wss vy
      cv cC wss wa vx cv cfn wcel vy cv cfn wcel wa cA vx cv cint wceq cB vy cv
      cint wceq wa w3a vx cv vy cv cun cC wss vx cv vy cv cun cfn wcel cA cB
      cin vx cv vy cv cun cint wceq w3a vx cv cC wss vx cv cfn wcel cA vx cv
      cint wceq vy cv cC wss vy cv cfn wcel cB vy cv cint wceq an6 vx cv cC wss
      vy cv cC wss wa vx cv vy cv cun cC wss vx cv cfn wcel vy cv cfn wcel wa
      vx cv vy cv cun cfn wcel cA vx cv cint wceq cB vy cv cint wceq wa cA cB
      cin vx cv vy cv cun cint wceq vx cv cC wss vy cv cC wss wa vx cv vy cv
      cun cC wss vx cv vy cv cC unss biimpi vx cv vy cv unfi cA vx cv cint wceq
      cB vy cv cint wceq wa cA cB cin vx cv cint vy cv cint cin vx cv vy cv cun
      cint cA vx cv cint cB vy cv cint ineq12 vx cv vy cv intun syl6eqr
      3anim123i sylbi ex vz cv cC wss vz cv cfn wcel cA cB cin vz cv cint wceq
      w3a vx cv vy cv cun cC wss vx cv vy cv cun cfn wcel cA cB cin vx cv vy cv
      cun cint wceq w3a vz vx cv vy cv cun vx cv vy cv vx visset vy visset unex
      vz cv vx cv vy cv cun wceq vz cv cC wss vx cv vy cv cun cC wss vz cv cfn
      wcel vx cv vy cv cun cfn wcel cA cB cin vz cv cint wceq cA cB cin vx cv
      vy cv cun cint wceq vz cv vx cv vy cv cun cC sseq1 vz cv vx cv vy cv cun
      cfn eleq1 vz cv vx cv vy cv cun wceq vz cv cint vx cv vy cv cun cint cA
      cB cin vz cv vx cv vy cv cun inteq eqeq2d 3anbi123d cla4ev syl6com
      19.23aiv com12 19.23aiv imp a1i cC cD wcel cA cC cfi cfv wcel vx cv cC
      wss vx cv cfn wcel cA vx cv cint wceq w3a vx wex cA cC cfi cfv wcel cC cD
      wcel cA cC cfi cfv wcel vx cv cC wss vx cv cfn wcel cA vx cv cint wceq
      w3a vx wex wi cA cC cfi cfv wcel cC cD wcel wa cA cC cfi cfv wcel vx cv
      cC wss vx cv cfn wcel cA vx cv cint wceq w3a vx wex vx cA cC cfi cfv cC
      cD sppfi biimpd ex pm2.43b cC cD wcel cB cC cfi cfv wcel vy cv cC wss vy
      cv cfn wcel cB vy cv cint wceq w3a vy wex cB cC cfi cfv wcel cC cD wcel
      cB cC cfi cfv wcel vy cv cC wss vy cv cfn wcel cB vy cv cint wceq w3a vy
      wex wi cB cC cfi cfv wcel cC cD wcel wa cB cC cfi cfv wcel vy cv cC wss
      vy cv cfn wcel cB vy cv cint wceq w3a vy wex vy cB cC cfi cfv cC cD sppfi
      biimpd ex pm2.43b syl2and imp cC cD wcel cA cC cfi cfv wcel cB cC cfi cfv
      wcel wa wa cA cB cin cvv wcel cC cD wcel wa cA cB cin cC cfi cfv wcel vz
      cv cC wss vz cv cfn wcel cA cB cin vz cv cint wceq w3a vz wex wb cA cC
      cfi cfv wcel cB cC cfi cfv wcel wa cC cD wcel cA cB cin cvv wcel cC cD
      wcel wa cA cC cfi cfv wcel cB cC cfi cfv wcel wa cA cB cin cvv wcel cC cD
      wcel cA cC cfi cfv wcel cA cB cin cvv wcel cB cC cfi cfv wcel cA cB cC
      cfi cfv inex1g adantr anim1i ancoms vz cA cB cin cvv cC cD sppfi syl
      mpbird ex $.
      $( [1-Dec-2010] $) $( [27-Apr-2008] $)
  $}

  ${
    $d t x y z A $. $d t x y z B $.
    $( A condition for a set to generate a filter base.  (Contributed by
       Jeff Hankins, 2-Sep-2009.) $)
    fsubbas $p |- ( A e. B -> ( ( fi ` A ) e. fBas <-> ( A =/= (/) /\ (/) e/ (
    fi ` A ) ) ) ) $=
      cA cB wcel cA cfi cfv cfbas wcel cA c0 wne c0 cA cfi cfv wnel wa cA cB
      wcel cA cfi cfv cfbas wcel cA c0 wne c0 cA cfi cfv wnel wa cA cB wcel cA
      cfi cfv cfbas wcel wa cA c0 wne c0 cA cfi cfv wnel cA cB wcel cA cfi cfv
      c0 wne cA c0 wne cA cfi cfv cfbas wcel cA cB wcel cA cfi cfv c0 wne cA c0
      wne cA cB wcel cA c0 cA cfi cfv c0 cA c0 wceq cA cfi cfv c0 wceq wi cA cB
      wcel cA c0 wceq cA cfi cfv c0 cfi cfv c0 cA c0 cfi fveq2 c0 cfi cfv c0
      wceq vt cv c0 cfi cfv wcel wn vt vt c0 cfi cfv eq0 vt cv c0 cfi cfv wcel
      vy cv c0 wss vy cv cfn wcel vt cv vy cv cint wceq w3a vy wex vy cv c0 wss
      vy cv cfn wcel vt cv vy cv cint wceq w3a vy vy cv c0 wss vy cv cfn wcel
      vt cv vy cv cint wceq w3a vy cv c0 wss vt cv vy cv cint wceq wa vy cv c0
      wss vt cv vy cv cint wceq wn wi vy cv c0 wss vt cv vy cv cint wceq wa wn
      vy cv c0 wss vy cv c0 wceq vt cv vy cv cint wceq wn vy cv ss0 vy cv c0
      wceq vt cv vy cv cint wceq vt cv c0 cint wceq vt cv c0 cint wceq vt c0
      cint cvv wcel vt cv c0 cint wceq vt wex c0 cint cvv wcel cvv cvv wcel
      vprc c0 cint cvv cvv int0 eleq1i mtbir vt c0 cint isset mtbi nexr vy cv
      c0 wceq vy cv cint c0 cint vt cv vy cv c0 inteq eqeq2d mtbiri syl vy cv
      c0 wss vt cv vy cv cint wceq imnan mpbi vy cv c0 wss vy cv cfn wcel vt cv
      vy cv cint wceq 3simpb mto nex vy cv c0 wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vy cv c0 wss vy cv cfn wcel vt cv vy cv cint wceq
      w3a vy wex vx vt cv c0 cfi cfv vt visset vx cv vt cv wceq vy cv c0 wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy cv c0 wss vy cv cfn wcel vt cv
      vy cv cint wceq w3a vy vx cv vt cv wceq vx cv vy cv cint wceq vt cv vy cv
      cint wceq vy cv c0 wss vy cv cfn wcel vx cv vt cv vy cv cint eqeq1
      3anbi3d exbidv c0 cvv wcel c0 cfi cfv vy cv c0 wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wceq 0ex vy vx c0 cvv fiv ax-mp elab2
      mtbir mpgbir syl6eq a1i necon3d imp cA cfi cfv fbasne0 sylan2 cA cfi cfv
      cfbas wcel c0 cA cfi cfv wnel cA cB wcel cA cfi cfv 0nelfb adantl jca ex
      cA cB wcel cA c0 wne c0 cA cfi cfv wnel cA cfi cfv cfbas wcel cA cB wcel
      cA c0 wne c0 cA cfi cfv wnel w3a cA cfi cfv c0 wne c0 cA cfi cfv wnel vz
      cv vx cv vy cv cin wss vz cA cfi cfv wrex vy cA cfi cfv wral vx cA cfi
      cfv wral w3a cA cfi cfv cfbas wcel cA cB wcel cA c0 wne c0 cA cfi cfv
      wnel w3a cA cfi cfv c0 wne c0 cA cfi cfv wnel vz cv vx cv vy cv cin wss
      vz cA cfi cfv wrex vy cA cfi cfv wral vx cA cfi cfv wral cA cB wcel cA c0
      wne cA cfi cfv c0 wne c0 cA cfi cfv wnel cA cB wcel cA c0 wne cA cfi cfv
      c0 wne cA cB fine2 imp 3adant3 cA cB wcel cA c0 wne c0 cA cfi cfv wnel
      3simp3 cA cB wcel cA c0 wne vz cv vx cv vy cv cin wss vz cA cfi cfv wrex
      vy cA cfi cfv wral vx cA cfi cfv wral c0 cA cfi cfv wnel cA cB wcel vz cv
      vx cv vy cv cin wss vz cA cfi cfv wrex vx vy cA cfi cfv cA cfi cfv cA cB
      wcel vx cv cA cfi cfv wcel vy cv cA cfi cfv wcel wa vx cv vy cv cin cA
      cfi cfv wcel vz cv vx cv vy cv cin wss vz cA cfi cfv wrex vx cv vy cv cA
      cB infi vx cv vy cv cin cA cfi cfv wcel vx cv vy cv cin vx cv vy cv cin
      wss vz cv vx cv vy cv cin wss vz cA cfi cfv wrex vx cv vy cv cin ssid vz
      cv vx cv vy cv cin wss vx cv vy cv cin vx cv vy cv cin wss vz vx cv vy cv
      cin cA cfi cfv vz cv vx cv vy cv cin vx cv vy cv cin sseq1 rcla4ev mpan2
      syl6 r19.21aivv 3ad2ant1 3jca cA cfi cfv cvv wcel cA cfi cfv cfbas wcel
      cA cfi cfv c0 wne c0 cA cfi cfv wnel vz cv vx cv vy cv cin wss vz cA cfi
      cfv wrex vy cA cfi cfv wral vx cA cfi cfv wral w3a wb cA cfi fvex vx vy
      vz cvv cA cfi cfv isfbas2 ax-mp sylibr 3expib impbid $.
      $( [1-Dec-2010] $) $( [2-Sep-2009] $)
  $}

  ${
    $d r s u v x y F $. $d r s u v x y G $.
    $( A helpful lemma for showing that certain sets generate filters.
       (Contributed by Jeff Hankins, 3-Sep-2009.) $)
    fbunfip $p |- ( ( F e. fBas /\ G e. fBas ) -> ( (/) e/ ( fi ` ( F u. G ) )
    <-> A. x e. F A. y e. G ( x i^i y ) =/= (/) ) ) $=
      cF cfbas wcel cG cfbas wcel wa c0 cF cG cun cfi cfv wnel vv cv cF cG cun
      wss vv cv cfn wcel c0 vv cv cint wceq w3a wn vv wal vx cv vy cv cin c0
      wne vy cG wral vx cF wral cF cfbas wcel cG cfbas wcel wa c0 cF cG cun cfi
      cfv wcel wn vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq w3a vv
      wex wn c0 cF cG cun cfi cfv wnel vv cv cF cG cun wss vv cv cfn wcel c0 vv
      cv cint wceq w3a wn vv wal cF cfbas wcel cG cfbas wcel wa c0 cF cG cun
      cfi cfv wcel vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq w3a vv
      wex cF cfbas wcel cG cfbas wcel wa c0 cF cG cun cfi cfv wcel c0 vv cv cF
      cG cun wss vv cv cfn wcel vu cv vv cv cint wceq w3a vv wex vu cab wcel vv
      cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq w3a vv wex cF cfbas
      wcel cG cfbas wcel wa cF cG cun cfi cfv vv cv cF cG cun wss vv cv cfn
      wcel vu cv vv cv cint wceq w3a vv wex vu cab c0 cF cfbas wcel cG cfbas
      wcel wa cF cG cun cvv wcel cF cG cun cfi cfv vv cv cF cG cun wss vv cv
      cfn wcel vu cv vv cv cint wceq w3a vv wex vu cab wceq cF cG cfbas cfbas
      unexg vv vu cF cG cun cvv fiv syl eleq2d vv cv cF cG cun wss vv cv cfn
      wcel vu cv vv cv cint wceq w3a vv wex vv cv cF cG cun wss vv cv cfn wcel
      c0 vv cv cint wceq w3a vv wex vu c0 0ex vu cv c0 wceq vv cv cF cG cun wss
      vv cv cfn wcel vu cv vv cv cint wceq w3a vv cv cF cG cun wss vv cv cfn
      wcel c0 vv cv cint wceq w3a vv vu cv c0 wceq vu cv vv cv cint wceq c0 vv
      cv cint wceq vv cv cF cG cun wss vv cv cfn wcel vu cv c0 vv cv cint eqeq1
      3anbi3d exbidv elab syl6bb notbid c0 cF cG cun cfi cfv df-nel vv cv cF cG
      cun wss vv cv cfn wcel c0 vv cv cint wceq w3a vv alnex 3bitr4g cF cfbas
      wcel cG cfbas wcel wa vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint
      wceq w3a wn vv wal vx cv vy cv cin c0 wne vy cG wral vx cF wral cF cfbas
      wcel cG cfbas wcel wa vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint
      wceq w3a wn vv wal vx cv vy cv cin c0 wne vx vy cF cG cF cfbas wcel cG
      cfbas wcel wa vx cv cF wcel vy cv cG wcel wa wa vx cv vy cv cpr cF cG cun
      wss vx cv vy cv cpr cfn wcel c0 vx cv vy cv cpr cint wceq w3a wn vx cv vy
      cv cin c0 wne vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq w3a
      wn vv wal cF cfbas wcel cG cfbas wcel wa vx cv cF wcel vy cv cG wcel wa
      wa vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel wa c0 vx cv vy
      cv cpr cint wceq wn wi vx cv vy cv cin c0 wne vx cv vy cv cpr cF cG cun
      wss vx cv vy cv cpr cfn wcel c0 vx cv vy cv cpr cint wceq w3a wn cF cfbas
      wcel cG cfbas wcel wa vx cv cF wcel vy cv cG wcel wa wa vx cv vy cv cpr
      cF cG cun wss vx cv vy cv cpr cfn wcel wa vx cv vy cv cpr cF cG cun wss
      vx cv vy cv cpr cfn wcel wa c0 vx cv vy cv cpr cint wceq wn wi vx cv vy
      cv cin c0 wne wi cF cfbas wcel cG cfbas wcel wa vx cv cF wcel vy cv cG
      wcel wa wa vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel cF
      cfbas wcel cG cfbas wcel wa vx cv cF wcel vy cv cG wcel wa wa vx cv cF cG
      cun wcel vy cv cF cG cun wcel wa vx cv vy cv cpr cF cG cun wss cF cfbas
      wcel cG cfbas wcel wa vx cv cF wcel vy cv cG wcel wa wa vx cv cF cG cun
      wcel vy cv cF cG cun wcel cF cfbas wcel cG cfbas wcel wa vx cv cF wcel vy
      cv cG wcel wa wa cF cF cG cun vx cv cF cF cG cun wss cF cfbas wcel cG
      cfbas wcel wa vx cv cF wcel vy cv cG wcel wa wa cF cG ssun1 a1i cF cfbas
      wcel cG cfbas wcel wa vx cv cF wcel vy cv cG wcel simprl sseldd cF cfbas
      wcel cG cfbas wcel wa vx cv cF wcel vy cv cG wcel wa wa cG cF cG cun vy
      cv cG cF cG cun wss cF cfbas wcel cG cfbas wcel wa vx cv cF wcel vy cv cG
      wcel wa wa cG cF ssun2 a1i cF cfbas wcel cG cfbas wcel wa vx cv cF wcel
      vy cv cG wcel simprr sseldd jca vx cv vy cv cF cG cun vx visset vy visset
      prss sylib vx cv vy cv prfi jctir vx cv vy cv cpr cF cG cun wss vx cv vy
      cv cpr cfn wcel wa vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel
      wa c0 vx cv vy cv cpr cint wceq wn wi cF cfbas wcel cG cfbas wcel wa vx
      cv cF wcel vy cv cG wcel wa wa vx cv vy cv cin c0 wne vx cv vy cv cpr cF
      cG cun wss vx cv vy cv cpr cfn wcel wa vx cv vy cv cpr cF cG cun wss vx
      cv vy cv cpr cfn wcel wa c0 vx cv vy cv cpr cint wceq wn wi c0 vx cv vy
      cv cpr cint wceq wn cF cfbas wcel cG cfbas wcel wa vx cv cF wcel vy cv cG
      wcel wa wa vx cv vy cv cin c0 wne wi vx cv vy cv cpr cF cG cun wss vx cv
      vy cv cpr cfn wcel wa c0 vx cv vy cv cpr cint wceq wn pm2.27 c0 vx cv vy
      cv cpr cint wceq wn vx cv vy cv cin c0 wne cF cfbas wcel cG cfbas wcel wa
      vx cv cF wcel vy cv cG wcel wa wa c0 vx cv vy cv cpr cint wceq wn vx cv
      vy cv cin c0 wne c0 vx cv vy cv cpr cint wne vx cv vy cv cpr cint c0 wne
      c0 vx cv vy cv cpr cint wceq wn vx cv vy cv cin c0 wne c0 vx cv vy cv cpr
      cint necom c0 vx cv vy cv cpr cint df-ne vx cv vy cv cpr cint vx cv vy cv
      cin c0 vx cv vy cv vx visset vy visset intpr neeq1i 3bitr3i biimpi a1d
      syl6 com3r mpd vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel c0
      vx cv vy cv cpr cint wceq w3a wn vx cv vy cv cpr cF cG cun wss vx cv vy
      cv cpr cfn wcel wa c0 vx cv vy cv cpr cint wceq wa wn vx cv vy cv cpr cF
      cG cun wss vx cv vy cv cpr cfn wcel wa c0 vx cv vy cv cpr cint wceq wn wi
      vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel c0 vx cv vy cv cpr
      cint wceq w3a vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel wa
      c0 vx cv vy cv cpr cint wceq wa vx cv vy cv cpr cF cG cun wss vx cv vy cv
      cpr cfn wcel c0 vx cv vy cv cpr cint wceq df-3an notbii vx cv vy cv cpr
      cF cG cun wss vx cv vy cv cpr cfn wcel wa c0 vx cv vy cv cpr cint wceq
      imnan bitr4i syl5ib vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq
      w3a wn vx cv vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel c0 vx cv vy
      cv cpr cint wceq w3a wn vv vx cv vy cv cpr vx vy zfpair vv cv vx cv vy cv
      cpr wceq vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq w3a vx cv
      vy cv cpr cF cG cun wss vx cv vy cv cpr cfn wcel c0 vx cv vy cv cpr cint
      wceq w3a vv cv vx cv vy cv cpr wceq vv cv cF cG cun wss vx cv vy cv cpr
      cF cG cun wss vv cv cfn wcel vx cv vy cv cpr cfn wcel c0 vv cv cint wceq
      c0 vx cv vy cv cpr cint wceq vv cv vx cv vy cv cpr cF cG cun sseq1 vv cv
      vx cv vy cv cpr cfn eleq1 vv cv vx cv vy cv cpr wceq vv cv cint vx cv vy
      cv cpr cint c0 vv cv vx cv vy cv cpr inteq eqeq2d 3anbi123d notbid cla4v
      syl5 r19.21advva cF cfbas wcel cG cfbas wcel wa vx cv vy cv cin c0 wne vy
      cG wral vx cF wral vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq
      w3a wn vv cF cfbas wcel cG cfbas wcel wa vx cv vy cv cin c0 wne vy cG
      wral vx cF wral vv cv cF cG cun wss vv cv cfn wcel wa c0 vv cv cint wceq
      wn wi vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq w3a wn cF
      cfbas wcel cG cfbas wcel wa vv cv cF cG cun wss vv cv cfn wcel wa vx cv
      vy cv cin c0 wne vy cG wral vx cF wral c0 vv cv cint wceq wn cF cfbas
      wcel cG cfbas wcel wa vv cv cF cin vv cv cG cin cun vv cv wceq vv cv cfn
      wcel wa vx cv vy cv cin c0 wne vy cG wral vx cF wral c0 vv cv cint wceq
      wn wi vv cv cF cG cun wss vv cv cfn wcel wa cF cfbas wcel cG cfbas wcel
      wa vv cv cF cin vv cv cG cin cun vv cv wceq vv cv cF cin cfn wcel vv cv
      cG cin cfn wcel wa vx cv vy cv cin c0 wne vy cG wral vx cF wral c0 vv cv
      cint wceq wn wi vv cv cfn wcel cF cfbas wcel cG cfbas wcel wa vv cv cF
      cin vv cv cG cin cun vv cv wceq vv cv cF cin cfn wcel vv cv cG cin cfn
      wcel wa wa vx cv vy cv cin c0 wne vy cG wral vx cF wral c0 vv cv cint
      wceq wn wi cF cfbas wcel cG cfbas wcel wa vv cv cF cin vv cv cG cin cun
      vv cv wceq vv cv cF cin cfn wcel vv cv cG cin cfn wcel wa wa wa vx cv vy
      cv cin c0 wne vy cG wral vx cF wral c0 vv cv cF cin vv cv cG cin cun cint
      wceq wn c0 vv cv cint wceq wn cF cfbas wcel cG cfbas wcel wa vv cv cF cin
      vv cv cG cin cun vv cv wceq vv cv cF cin cfn wcel vv cv cG cin cfn wcel
      wa wa wa vx cv vy cv cin c0 wne vy cG wral vx cF wral c0 vv cv cF cin
      cint vv cv cG cin cint cin wceq wn c0 vv cv cF cin vv cv cG cin cun cint
      wceq wn cF cfbas wcel cG cfbas wcel wa vv cv cF cin cfn wcel vv cv cG cin
      cfn wcel wa vx cv vy cv cin c0 wne vy cG wral vx cF wral c0 vv cv cF cin
      cint vv cv cG cin cint cin wceq wn wi vv cv cF cin vv cv cG cin cun vv cv
      wceq cF cfbas wcel cG cfbas wcel wa vv cv cF cin cfn wcel vv cv cG cin
      cfn wcel wa wa vx cv vy cv cin c0 wne vy cG wral vx cF wral vv cv cF cin
      cint vv cv cG cin cint cin c0 wne c0 vv cv cF cin cint vv cv cG cin cint
      cin wceq wn cF cfbas wcel cG cfbas wcel wa vv cv cF cin cfn wcel vv cv cG
      cin cfn wcel wa vr cv vv cv cF cin cint wss vr cF wrex vs cv vv cv cG cin
      cint wss vs cG wrex wa vx cv vy cv cin c0 wne vy cG wral vx cF wral vv cv
      cF cin cint vv cv cG cin cint cin c0 wne wi cF cfbas wcel cG cfbas wcel
      wa vv cv cF cin cfn wcel vv cv cG cin cfn wcel wa wa vr cv vv cv cF cin
      cint wss vr cF wrex vs cv vv cv cG cin cint wss vs cG wrex cF cfbas wcel
      vv cv cF cin cfn wcel vr cv vv cv cF cin cint wss vr cF wrex cG cfbas
      wcel vv cv cG cin cfn wcel cF cfbas wcel vv cv cF cin cF wss vv cv cF cin
      cfn wcel vr cv vv cv cF cin cint wss vr cF wrex vv cv cF inss2 vr vv cv
      cF cin cF fbssint mp3an2 ad2ant2r cG cfbas wcel vv cv cG cin cfn wcel vs
      cv vv cv cG cin cint wss vs cG wrex cF cfbas wcel vv cv cF cin cfn wcel
      cG cfbas wcel vv cv cG cin cG wss vv cv cG cin cfn wcel vs cv vv cv cG
      cin cint wss vs cG wrex vv cv cG inss2 vs vv cv cG cin cG fbssint mp3an2
      ad2ant2l jca cF cfbas wcel cG cfbas wcel wa vr cv vv cv cF cin cint wss
      vs cv vv cv cG cin cint wss wa vs cG wrex vr cF wrex vx cv vy cv cin c0
      wne vy cG wral vx cF wral vv cv cF cin cint vv cv cG cin cint cin c0 wne
      wi vr cv vv cv cF cin cint wss vr cF wrex vs cv vv cv cG cin cint wss vs
      cG wrex wa vr cv vv cv cF cin cint wss vs cv vv cv cG cin cint wss wa vs
      cG wrex vr cF wrex cF cfbas wcel cG cfbas wcel wa vx cv vy cv cin c0 wne
      vy cG wral vx cF wral vv cv cF cin cint vv cv cG cin cint cin c0 wne wi
      vr cv vv cv cF cin cint wss vs cv vv cv cG cin cint wss wa cF cfbas wcel
      cG cfbas wcel wa vx cv vy cv cin c0 wne vy cG wral vx cF wral vv cv cF
      cin cint vv cv cG cin cint cin c0 wne wi wi vr vs cF cG cF cfbas wcel cG
      cfbas wcel wa vr cv cF wcel vs cv cG wcel wa vr cv vv cv cF cin cint wss
      vs cv vv cv cG cin cint wss wa vx cv vy cv cin c0 wne vy cG wral vx cF
      wral vv cv cF cin cint vv cv cG cin cint cin c0 wne wi cF cfbas wcel cG
      cfbas wcel wa vr cv cF wcel vs cv cG wcel wa vr cv vv cv cF cin cint wss
      vs cv vv cv cG cin cint wss wa vx cv vy cv cin c0 wne vy cG wral vx cF
      wral vv cv cF cin cint vv cv cG cin cint cin c0 wne wi cF cfbas wcel cG
      cfbas wcel wa vr cv cF wcel vs cv cG wcel wa vr cv vv cv cF cin cint wss
      vs cv vv cv cG cin cint wss wa wa wa vx cv vy cv cin c0 wne vy cG wral vx
      cF wral vr cv vs cv cin c0 wne vv cv cF cin cint vv cv cG cin cint cin c0
      wne vr cv cF wcel vs cv cG wcel wa vx cv vy cv cin c0 wne vy cG wral vx
      cF wral vr cv vs cv cin c0 wne wi cF cfbas wcel cG cfbas wcel wa vr cv vv
      cv cF cin cint wss vs cv vv cv cG cin cint wss wa vx cv vy cv cin c0 wne
      vr cv vs cv cin c0 wne vr cv vy cv cin c0 wne vx vy vr cv vs cv cF cG vx
      cv vr cv wceq vx cv vy cv cin vr cv vy cv cin c0 vx cv vr cv vy cv ineq1
      neeq1d vy cv vs cv wceq vr cv vy cv cin vr cv vs cv cin c0 vy cv vs cv vr
      cv ineq2 neeq1d rcla42v ad2antrl cF cfbas wcel cG cfbas wcel wa vr cv cF
      wcel vs cv cG wcel wa vr cv vv cv cF cin cint wss vs cv vv cv cG cin cint
      wss wa wa wa vr cv vs cv cin vv cv cF cin cint vv cv cG cin cint cin wss
      vr cv vs cv cin c0 wne vv cv cF cin cint vv cv cG cin cint cin c0 wne wi
      vr cv vv cv cF cin cint wss vs cv vv cv cG cin cint wss wa vr cv vs cv
      cin vv cv cF cin cint vv cv cG cin cint cin wss cF cfbas wcel cG cfbas
      wcel wa vr cv cF wcel vs cv cG wcel wa vr cv vv cv cF cin cint vs cv vv
      cv cG cin cint ss2in ad2antll vr cv vs cv cin vv cv cF cin cint vv cv cG
      cin cint cin wss vr cv vs cv cin c0 wne vv cv cF cin cint vv cv cG cin
      cint cin c0 wne vr cv vs cv cin vv cv cF cin cint vv cv cG cin cint cin
      ssn0 ex syl syld exp32 com3l r19.23aivv impcom vr cv vv cv cF cin cint
      wss vs cv vv cv cG cin cint wss vr vs cF cG reeanv sylan2br syldan vv cv
      cF cin cint vv cv cG cin cint cin c0 wne c0 vv cv cF cin cint vv cv cG
      cin cint cin wne c0 vv cv cF cin cint vv cv cG cin cint cin wceq wn vv cv
      cF cin cint vv cv cG cin cint cin c0 necom c0 vv cv cF cin cint vv cv cG
      cin cint cin df-ne bitri syl6ib adantrl c0 vv cv cF cin vv cv cG cin cun
      cint wceq c0 vv cv cF cin cint vv cv cG cin cint cin wceq vv cv cF cin vv
      cv cG cin cun cint vv cv cF cin cint vv cv cG cin cint cin c0 vv cv cF
      cin vv cv cG cin intun eqeq2i notbii syl6ibr cF cfbas wcel cG cfbas wcel
      wa vv cv cF cin vv cv cG cin cun vv cv wceq vv cv cF cin cfn wcel vv cv
      cG cin cfn wcel wa wa wa c0 vv cv cF cin vv cv cG cin cun cint wceq c0 vv
      cv cint wceq cF cfbas wcel cG cfbas wcel wa vv cv cF cin vv cv cG cin cun
      vv cv wceq vv cv cF cin cfn wcel vv cv cG cin cfn wcel wa wa wa vv cv cF
      cin vv cv cG cin cun cint vv cv cint c0 cF cfbas wcel cG cfbas wcel wa vv
      cv cF cin vv cv cG cin cun vv cv wceq vv cv cF cin cfn wcel vv cv cG cin
      cfn wcel wa wa wa vv cv cF cin vv cv cG cin cun vv cv cF cfbas wcel cG
      cfbas wcel wa vv cv cF cin vv cv cG cin cun vv cv wceq vv cv cF cin cfn
      wcel vv cv cG cin cfn wcel wa simprl inteqd eqeq2d notbid sylibd ex vv cv
      cfn wcel vv cv cF cin cfn wcel vv cv cG cin cfn wcel vv cv cfn wcel vv cv
      cF cin vv cv wss vv cv cF cin cfn wcel vv cv cF inss1 vv cv vv cv cF cin
      ssfi mpan2 vv cv cfn wcel vv cv cG cin vv cv wss vv cv cG cin cfn wcel vv
      cv cG inss1 vv cv vv cv cG cin ssfi mpan2 jca sylan2i vv cv cF cG cun wss
      vv cv cF cin vv cv cG cin cun vv cv wceq vv cv cfn wcel vv cv cF cG cun
      wss vv cv cF cG cun cin vv cv wceq vv cv cF cin vv cv cG cin cun vv cv
      wceq vv cv cF cG cun df-ss vv cv cF cG cun cin vv cv cF cin vv cv cG cin
      cun vv cv vv cv cF cG indi eqeq1i bitri anbi1i syl5ib com23 vv cv cF cG
      cun wss vv cv cfn wcel wa c0 vv cv cint wceq wn wi vv cv cF cG cun wss vv
      cv cfn wcel wa c0 vv cv cint wceq wa wn vv cv cF cG cun wss vv cv cfn
      wcel c0 vv cv cint wceq w3a wn vv cv cF cG cun wss vv cv cfn wcel wa c0
      vv cv cint wceq imnan vv cv cF cG cun wss vv cv cfn wcel c0 vv cv cint
      wceq w3a vv cv cF cG cun wss vv cv cfn wcel wa c0 vv cv cint wceq wa vv
      cv cF cG cun wss vv cv cfn wcel c0 vv cv cint wceq df-3an notbii bitr4i
      syl6ib 19.21adv impbid bitrd $.
      $( [1-Dec-2010] $) $( [3-Sep-2009] $)
  $}

  ${
    $d w x y z F $. $d w x y z X $. $d w x y z $.
    fgf.1 $e |- X = U. F $.
    $( The filter generating class gives a filter for every filter base.
       (Contributed by Jeff Hankins, 3-Sep-2009.) $)
    fgf $p |- ( F e. fBas -> ( filGen ` F ) = { x e. ~P X | ( F i^i ~P x ) =/=
    (/) } ) $=
      cF cfbas wcel cF vy cv cfbas wcel vz cv vy cv vx cv cpw cin c0 wne vx vy
      cv cuni cpw crab wceq wa vy vz copab cfv cF vx cv cpw cin c0 wne vx cX
      cpw crab cF cfg cfv vw cv vy cv cfbas wcel vz cv vy cv vx cv cpw cin c0
      wne vx vy cv cuni cpw crab wceq wa vy vz copab cfv vw cv vx cv cpw cin c0
      wne vx vw cv cuni cpw crab wceq cF vy cv cfbas wcel vz cv vy cv vx cv cpw
      cin c0 wne vx vy cv cuni cpw crab wceq wa vy vz copab cfv cF vx cv cpw
      cin c0 wne vx cX cpw crab wceq vw cF cfbas vw cv cF wceq vw cv vy cv
      cfbas wcel vz cv vy cv vx cv cpw cin c0 wne vx vy cv cuni cpw crab wceq
      wa vy vz copab cfv cF vy cv cfbas wcel vz cv vy cv vx cv cpw cin c0 wne
      vx vy cv cuni cpw crab wceq wa vy vz copab cfv vw cv vx cv cpw cin c0 wne
      vx vw cv cuni cpw crab cF vx cv cpw cin c0 wne vx cX cpw crab vw cv cF vy
      cv cfbas wcel vz cv vy cv vx cv cpw cin c0 wne vx vy cv cuni cpw crab
      wceq wa vy vz copab fveq2 vw cv cF wceq vw cv vx cv cpw cin c0 wne vx vw
      cv cuni cpw crab cF vx cv cpw cin c0 wne vx vw cv cuni cpw crab cF vx cv
      cpw cin c0 wne vx cX cpw crab vw cv cF wceq vw cv vx cv cpw cin c0 wne cF
      vx cv cpw cin c0 wne vx vw cv cuni cpw vw cv cF wceq vw cv vx cv cpw cin
      cF vx cv cpw cin c0 vw cv cF vx cv cpw ineq1 neeq1d rabbisdv vw cv cF
      wceq vw cv cuni cpw cX cpw wceq cF vx cv cpw cin c0 wne vx vw cv cuni cpw
      crab cF vx cv cpw cin c0 wne vx cX cpw crab wceq vw cv cF wceq vw cv cuni
      cpw cF cuni cpw cX cpw vw cv cF wceq vw cv cuni cF cuni wceq vw cv cuni
      cpw cF cuni cpw wceq vw cv cF unieq vw cv cuni cF cuni pweq syl cX cF
      cuni wceq cX cpw cF cuni cpw wceq fgf.1 cX cF cuni pweq ax-mp syl6eqr cF
      vx cv cpw cin c0 wne vx vw cv cuni cpw cX cpw rabeq syl eqtrd eqeq12d vw
      cv cfbas wcel vw cv vx cv cpw cin c0 wne vx vw cv cuni cpw crab cvv wcel
      vw cv vy cv cfbas wcel vz cv vy cv vx cv cpw cin c0 wne vx vy cv cuni cpw
      crab wceq wa vy vz copab cfv vw cv vx cv cpw cin c0 wne vx vw cv cuni cpw
      crab wceq vw cv cfbas wcel vw cv cuni cvv wcel vw cv cuni cpw cvv wcel vw
      cv vx cv cpw cin c0 wne vx vw cv cuni cpw crab cvv wcel vw cv cfbas
      uniexg vw cv cuni cvv pwexg vw cv vx cv cpw cin c0 wne vx vw cv cuni cpw
      cvv rabexg 3syl vy vz vw cv vy cv vx cv cpw cin c0 wne vx vy cv cuni cpw
      crab vw cv vx cv cpw cin c0 wne vx vw cv cuni cpw crab cfbas cvv vy cv
      cfbas wcel vz cv vy cv vx cv cpw cin c0 wne vx vy cv cuni cpw crab wceq
      wa vy vz copab vy cv vw cv wceq vy cv vx cv cpw cin c0 wne vx vy cv cuni
      cpw crab vw cv vx cv cpw cin c0 wne vx vy cv cuni cpw crab vw cv vx cv
      cpw cin c0 wne vx vw cv cuni cpw crab vy cv vw cv wceq vy cv vx cv cpw
      cin c0 wne vw cv vx cv cpw cin c0 wne vx vy cv cuni cpw vy cv vw cv wceq
      vy cv vx cv cpw cin vw cv vx cv cpw cin c0 vy cv vw cv vx cv cpw ineq1
      neeq1d rabbisdv vy cv vw cv wceq vy cv cuni vw cv cuni wceq vy cv cuni
      cpw vw cv cuni cpw wceq vw cv vx cv cpw cin c0 wne vx vy cv cuni cpw crab
      vw cv vx cv cpw cin c0 wne vx vw cv cuni cpw crab wceq vy cv vw cv unieq
      vy cv cuni vw cv cuni pweq vw cv vx cv cpw cin c0 wne vx vy cv cuni cpw
      vw cv cuni cpw rabeq 3syl eqtrd vy cv cfbas wcel vz cv vy cv vx cv cpw
      cin c0 wne vx vy cv cuni cpw crab wceq wa vy vz copab eqid fvopab4g mpdan
      vtoclga cF cfg vy cv cfbas wcel vz cv vy cv vx cv cpw cin c0 wne vx vy cv
      cuni cpw crab wceq wa vy vz copab vy vz vx df-fg fveq1i syl5eq $.
      $( [1-Dec-2010] $) $( [3-Sep-2009] $)
  $}

  ${
    $d x y A $. $d y B $. $d x y F $. $d y X $. $d x y $.
    elfg.1 $e |- X = U. F $.
    $( A condition for elements of a generated filter.  (Contributed by Jeff
       Hankins, 3-Sep-2009.) $)
    elfg $p |- ( F e. fBas -> ( A e. ( filGen ` F ) <-> ( A C_ X
    /\ E. x e. F x C_ A ) ) ) $=
      cF cfbas wcel cA cF cfg cfv wcel cA cF vy cv cpw cin c0 wne vy cX cpw
      crab wcel cA cX wss vx cv cA wss vx cF wrex wa cF cfbas wcel cF cfg cfv
      cF vy cv cpw cin c0 wne vy cX cpw crab cA vy cF cX elfg.1 fgf eleq2d cF
      cfbas wcel cA cX cpw wcel cF cA cpw cin c0 wne wa cA cX wss vx cv cA wss
      vx cF wrex wa cA cF vy cv cpw cin c0 wne vy cX cpw crab wcel cF cfbas
      wcel cA cX cpw wcel cA cX wss cF cA cpw cin c0 wne vx cv cA wss vx cF
      wrex cF cfbas wcel cX cvv wcel cA cX cpw wcel cA cX wss wb cF cfbas wcel
      cF cuni cvv cX cF cfbas uniexg elfg.1 syl5eqel cA cX cvv elpw2g syl cF cA
      cpw cin c0 wne vx cv cA wss vx cF wrex wb cF cfbas wcel vx cv cF cA cpw
      cin wcel vx wex vx cv cF wcel vx cv cA wss wa vx wex cF cA cpw cin c0 wne
      vx cv cA wss vx cF wrex vx cv cF cA cpw cin wcel vx cv cF wcel vx cv cA
      wss wa vx vx cv cF cA cpw cin wcel vx cv cF wcel vx cv cA cpw wcel wa vx
      cv cF wcel vx cv cA wss wa vx cv cF cA cpw elin vx cv cA cpw wcel vx cv
      cA wss vx cv cF wcel vx cv cA vx visset elpw anbi2i bitri exbii vx cF cA
      cpw cin n0 vx cv cA wss vx cF df-rex 3bitr4i a1i anbi12d cF vy cv cpw cin
      c0 wne cF cA cpw cin c0 wne vy cA cX cpw vy cv cA wceq cF vy cv cpw cin
      cF cA cpw cin c0 vy cv cA wceq vy cv cpw cA cpw cF vy cv cA pweq ineq2d
      neeq1d elrab syl5bb bitrd $.
      $( [1-Dec-2010] $) $( [3-Sep-2009] $)
  $}

  ${
    $d t x F $.
    $( A filter base is a subset of its generated filter.  (Contributed by Jeff
       Hankins, 3-Sep-2009.) $)
    fbssfg $p |- ( F e. fBas -> F C_ ( filGen ` F ) ) $=
      cF cfbas wcel vt cF cF cfg cfv cF cfbas wcel vt cv cF cfg cfv wcel vt cv
      cF cuni wss vx cv vt cv wss vx cF wrex wa vt cv cF wcel vx vt cv cF cF
      cuni cF cuni eqid elfg vt cv cF wcel vt cv cF cuni wss vx cv vt cv wss vx
      cF wrex vt cv cF elssuni vt cv cF wcel vt cv vt cv wss vx cv vt cv wss vx
      cF wrex vt cv ssid vx cv vt cv wss vt cv vt cv wss vx vt cv cF vx cv vt
      cv vt cv sseq1 rcla4ev mpan2 jca syl5bir ssrdv $.
      $( [1-Dec-2010] $) $( [3-Sep-2009] $)
  $}

  ${
    $d t x y F $. $d t x y X $.
    fgbas.1 $e |- X = U. F $.
    $( The base set of a generated filter is the base set of the parent base.
       (Contributed by Jeff Hankins, 3-Sep-2009.) $)
    fgbas $p |- ( F e. fBas -> X = U. ( filGen ` F ) ) $=
      cF cfbas wcel cX cF cfg cfv cuni cF cfbas wcel cF cuni cF cfg cfv cuni cX
      cF cfbas wcel cF cF cfg cfv wss cF cuni cF cfg cfv cuni wss cF fbssfg cF
      cF cfg cfv uniss syl fgbas.1 syl5ss cF cfbas wcel vt cF cfg cfv cuni cX
      cF cfbas wcel vt cv vx cv wcel vx cv cF cfg cfv wcel wa vx wex vt cv cX
      wcel vt cv cF cfg cfv cuni wcel cF cfbas wcel vt cv vx cv wcel vx cv cF
      cfg cfv wcel wa vt cv cX wcel vx cF cfbas wcel vt cv vx cv wcel vx cv cF
      cfg cfv wcel wa vt cv vx cv wcel vx cv cX wss vy cv vx cv wss vy cF wrex
      wa wa vt cv cX wcel cF cfbas wcel vx cv cF cfg cfv wcel vx cv cX wss vy
      cv vx cv wss vy cF wrex wa vt cv vx cv wcel vy vx cv cF cX fgbas.1 elfg
      anbi2d vt cv vx cv wcel vx cv cX wss vt cv cX wcel vy cv vx cv wss vy cF
      wrex vx cv cX wss vt cv vx cv wcel vt cv cX wcel vx cv cX vt cv ssel2
      ancoms adantrr syl6bi 19.23adv vx vt cv cF cfg cfv eluni syl5ib ssrdv
      eqssd $.
      $( [1-Dec-2010] $) $( [3-Sep-2009] $)
  $}


  ${
    $d u v w x y z F $.
    $( A generated filter is a filter.  (Contributed by Jeff Hankins,
       3-Sep-2009.) $)
    fgfil $p |- ( F e. fBas -> ( filGen ` F ) e. Fil ) $=
      cF cfbas wcel c0 cF cfg cfv wcel wn cF cfg cfv cuni cF cfg cfv wcel wa vx
      cv cF cfg cfv wcel vy cv cF cfg cfv cuni wss vx cv vy cv wss w3a vy cv cF
      cfg cfv wcel wi vy wal vx wal vx cv vy cv cin cF cfg cfv wcel vy cF cfg
      cfv wral vx cF cfg cfv wral w3a cF cfg cfv cfil wcel cF cfbas wcel c0 cF
      cfg cfv wcel wn cF cfg cfv cuni cF cfg cfv wcel wa vx cv cF cfg cfv wcel
      vy cv cF cfg cfv cuni wss vx cv vy cv wss w3a vy cv cF cfg cfv wcel wi vy
      wal vx wal vx cv vy cv cin cF cfg cfv wcel vy cF cfg cfv wral vx cF cfg
      cfv wral cF cfbas wcel c0 cF cfg cfv wcel wn cF cfg cfv cuni cF cfg cfv
      wcel cF cfbas wcel c0 cF cfg cfv wcel c0 cF cuni wss vx cv c0 wss vx cF
      wrex wa cF cfbas wcel vx cv c0 wss vx cF wrex c0 cF cuni wss cF cfbas
      wcel vx cv c0 wss vx cF cF cfbas wcel vx cv cF wcel wa vx cv c0 wceq vx
      cv c0 wss cF cfbas wcel vx cv cF wcel vx cv c0 wceq wn cF cfbas wcel vx
      cv c0 wceq vx cv cF wcel vx cv c0 wceq vx cv cF wcel wn c0 cF wcel wn cF
      cfbas wcel vx cv c0 wceq vx cv cF wcel c0 cF wcel vx cv c0 cF eleq1
      notbid cF cfbas wcel c0 cF wnel c0 cF wcel wn cF 0nelfb c0 cF df-nel
      sylib syl5cbir con2d imp vx cv ss0 nsyl nrexdv intnand vx c0 cF cF cuni
      cF cuni eqid elfg mtbird cF cfbas wcel cF cuni cF cfg cfv cuni cF cfg cfv
      cF cF cuni cF cuni eqid fgbas cF cfbas wcel cF cuni cF cfg cfv wcel cF
      cuni cF cuni wss vx cv cF cuni wss vx cF wrex wa cF cfbas wcel vx cv cF
      cuni wss vx cF wrex cF cuni cF cuni wss cF cfbas wcel cF c0 wne vx cv cF
      cuni wss vx cF wrex cF fbasne0 vx cv cF wcel vx wex vx cv cF wcel vx cv
      cF cuni wss wa vx wex cF c0 wne vx cv cF cuni wss vx cF wrex vx cv cF
      wcel vx cv cF wcel vx cv cF cuni wss wa vx vx cv cF wcel vx cv cF cuni
      wss vx cv cF elssuni ancli 19.22i vx cF n0 vx cv cF cuni wss vx cF df-rex
      3imtr4i syl cF cuni ssid jctil vx cF cuni cF cF cuni cF cuni eqid elfg
      mpbird eqeltrrd jca cF cfbas wcel vx cv cF cfg cfv wcel vy cv cF cfg cfv
      cuni wss vx cv vy cv wss w3a vy cv cF cfg cfv wcel wi vx vy cF cfbas wcel
      vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy cv cF cuni wss vx cv
      vy cv wss w3a vy cv cF cuni wss vw cv vy cv wss vw cF wrex wa vx cv cF
      cfg cfv wcel vy cv cF cfg cfv cuni wss vx cv vy cv wss w3a vy cv cF cfg
      cfv wcel cF cfbas wcel vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy
      cv cF cuni wss vx cv vy cv wss w3a vy cv cF cuni wss vw cv vy cv wss vw
      cF wrex vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy cv cF cuni wss
      vx cv vy cv wss w3a vy cv cF cuni wss wi cF cfbas wcel vx cv cF cuni wss
      vz cv vx cv wss vz cF wrex wa vy cv cF cuni wss vx cv vy cv wss 3simp2
      a1i vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy cv cF cuni wss vx
      cv vy cv wss w3a vw cv vy cv wss vw cF wrex wi cF cfbas wcel vx cv cF
      cuni wss vz cv vx cv wss vz cF wrex wa vx cv vy cv wss vw cv vy cv wss vw
      cF wrex vy cv cF cuni wss vz cv vx cv wss vz cF wrex vx cv vy cv wss vw
      cv vy cv wss vw cF wrex vx cv cF cuni wss vz cv vx cv wss vz cF wrex vx
      cv vy cv wss vw cv vy cv wss vw cF wrex vz cv vx cv wss vx cv vy cv wss
      vw cv vy cv wss vw cF wrex wi vz cF vz cv cF wcel vz cv vx cv wss vx cv
      vy cv wss vw cv vy cv wss vw cF wrex vz cv cF wcel vz cv vy cv wss vw cv
      vy cv wss vw cF wrex vz cv vx cv wss vx cv vy cv wss wa vz cv cF wcel vz
      cv vy cv wss vw cv vy cv wss vw cF wrex vw cv vy cv wss vz cv vy cv wss
      vw vz cv cF vw cv vz cv vy cv sseq1 rcla4ev ex vz cv vx cv vy cv sstr
      syl5 exp3a r19.23aiv imp adantll 3adant2 a1i jcad cF cfbas wcel vx cv cF
      cfg cfv wcel vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy cv cF cfg
      cfv cuni wss vy cv cF cuni wss vx cv vy cv wss vz vx cv cF cF cuni cF
      cuni eqid elfg cF cfbas wcel cF cfg cfv cuni cF cuni vy cv cF cfbas wcel
      cF cuni cF cfg cfv cuni cF cF cuni cF cuni eqid fgbas eqcomd sseq2d
      3anbi12d vw vy cv cF cF cuni cF cuni eqid elfg 3imtr4d 19.21aivv cF cfbas
      wcel vx cv vy cv cin cF cfg cfv wcel vx vy cF cfg cfv cF cfg cfv cF cfbas
      wcel vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy cv cF cuni wss vu
      cv vy cv wss vu cF wrex wa wa vx cv vy cv cin cF cuni wss vv cv vx cv vy
      cv cin wss vv cF wrex wa vx cv cF cfg cfv wcel vy cv cF cfg cfv wcel wa
      vx cv vy cv cin cF cfg cfv wcel cF cfbas wcel vx cv cF cuni wss vz cv vx
      cv wss vz cF wrex vy cv cF cuni wss vu cv vy cv wss vu cF wrex wa vx cv
      vy cv cin cF cuni wss vv cv vx cv vy cv cin wss vv cF wrex wa cF cfbas
      wcel vz cv vx cv wss vz cF wrex vx cv cF cuni wss vy cv cF cuni wss vu cv
      vy cv wss vu cF wrex wa vx cv vy cv cin cF cuni wss vv cv vx cv vy cv cin
      wss vv cF wrex wa wi cF cfbas wcel vz cv vx cv wss vx cv cF cuni wss vy
      cv cF cuni wss vu cv vy cv wss vu cF wrex wa vx cv vy cv cin cF cuni wss
      vv cv vx cv vy cv cin wss vv cF wrex wa wi wi vz cF cF cfbas wcel vy cv
      cF cuni wss vu cv vy cv wss vu cF wrex wa vz cv vx cv wss vx cv cF cuni
      wss vz cv cF wcel vx cv vy cv cin cF cuni wss vv cv vx cv vy cv cin wss
      vv cF wrex wa cF cfbas wcel vy cv cF cuni wss vu cv vy cv wss vu cF wrex
      vz cv vx cv wss vx cv cF cuni wss vz cv cF wcel vx cv vy cv cin cF cuni
      wss vv cv vx cv vy cv cin wss vv cF wrex wa wi wi wi cF cfbas wcel vu cv
      vy cv wss vu cF wrex vy cv cF cuni wss vz cv vx cv wss vx cv cF cuni wss
      vz cv cF wcel vx cv vy cv cin cF cuni wss vv cv vx cv vy cv cin wss vv cF
      wrex wa wi wi wi cF cfbas wcel vu cv vy cv wss vy cv cF cuni wss vz cv vx
      cv wss vx cv cF cuni wss vz cv cF wcel vx cv vy cv cin cF cuni wss vv cv
      vx cv vy cv cin wss vv cF wrex wa wi wi wi wi vu cF cF cfbas wcel vu cv
      cF wcel vu cv vy cv wss vy cv cF cuni wss vz cv vx cv wss vx cv cF cuni
      wss vz cv cF wcel vx cv vy cv cin cF cuni wss vv cv vx cv vy cv cin wss
      vv cF wrex wa wi wi wi wi cF cfbas wcel vu cv cF wcel vu cv vy cv wss w3a
      vy cv cF cuni wss vz cv vx cv wss vx cv cF cuni wss vz cv cF wcel vx cv
      vy cv cin cF cuni wss vv cv vx cv vy cv cin wss vv cF wrex wa cF cfbas
      wcel vu cv cF wcel vu cv vy cv wss w3a vy cv cF cuni wss vz cv vx cv wss
      vx cv cF cuni wss w3a wa vz cv cF wcel wa vx cv vy cv cin cF cuni wss vv
      cv vx cv vy cv cin wss vv cF wrex vy cv cF cuni wss vz cv vx cv wss vx cv
      cF cuni wss w3a vx cv vy cv cin cF cuni wss cF cfbas wcel vu cv cF wcel
      vu cv vy cv wss w3a vz cv cF wcel vy cv cF cuni wss vz cv vx cv wss vx cv
      vy cv cin cF cuni wss vx cv cF cuni wss vx cv vy cv cin vy cv wss vy cv
      cF cuni wss vx cv vy cv cin cF cuni wss vx cv vy cv inss2 vx cv vy cv cin
      vy cv cF cuni sstr mpan 3ad2ant1 ad2antlr cF cfbas wcel vu cv cF wcel vu
      cv vy cv wss w3a vy cv cF cuni wss vz cv vx cv wss vx cv cF cuni wss w3a
      wa vz cv cF wcel wa vv cv vz cv vu cv cin wss vv cF wrex vv cv vx cv vy
      cv cin wss vv cF wrex cF cfbas wcel vu cv cF wcel vu cv vy cv wss w3a vy
      cv cF cuni wss vz cv vx cv wss vx cv cF cuni wss w3a wa vz cv cF wcel vv
      cv vz cv vu cv cin wss vv cF wrex cF cfbas wcel vu cv cF wcel vu cv vy cv
      wss w3a vz cv cF wcel vv cv vz cv vu cv cin wss vv cF wrex wi vy cv cF
      cuni wss vz cv vx cv wss vx cv cF cuni wss w3a cF cfbas wcel vu cv cF
      wcel vz cv cF wcel vv cv vz cv vu cv cin wss vv cF wrex wi vu cv vy cv
      wss cF cfbas wcel vu cv cF wcel vz cv cF wcel vv cv vz cv vu cv cin wss
      vv cF wrex cF cfbas wcel vz cv cF wcel vu cv cF wcel vv cv vz cv vu cv
      cin wss vv cF wrex vv vz cv vu cv cF fbasssin 3com23 3expia 3adant3
      adantr imp cF cfbas wcel vu cv cF wcel vu cv vy cv wss w3a vy cv cF cuni
      wss vz cv vx cv wss vx cv cF cuni wss w3a wa vz cv cF wcel wa vv cv vz cv
      vu cv cin wss vv cv vx cv vy cv cin wss vv cF cF cfbas wcel vu cv cF wcel
      vu cv vy cv wss w3a vy cv cF cuni wss vz cv vx cv wss vx cv cF cuni wss
      w3a wa vv cv vz cv vu cv cin wss vv cv vx cv vy cv cin wss wi vz cv cF
      wcel cF cfbas wcel vu cv cF wcel vu cv vy cv wss w3a vy cv cF cuni wss vz
      cv vx cv wss vv cv vz cv vu cv cin wss vv cv vx cv vy cv cin wss wi vx cv
      cF cuni wss vu cv vy cv wss cF cfbas wcel vz cv vx cv wss vv cv vz cv vu
      cv cin wss vv cv vx cv vy cv cin wss wi vu cv cF wcel vz cv vx cv wss vu
      cv vy cv wss vv cv vz cv vu cv cin wss vv cv vx cv vy cv cin wss wi vz cv
      vx cv wss vu cv vy cv wss wa vz cv vu cv cin vx cv vy cv cin wss vv cv vz
      cv vu cv cin wss vv cv vx cv vy cv cin wss wi vz cv vx cv vu cv vy cv
      ss2in vv cv vz cv vu cv cin wss vz cv vu cv cin vx cv vy cv cin wss vv cv
      vx cv vy cv cin wss vv cv vz cv vu cv cin vx cv vy cv cin sstr expcom syl
      ancoms 3ad2antl3 3ad2antr2 adantr r19.22sdv mpd jca exp516 3exp r19.23adv
      com23 imp3a com25 r19.23adv com23 imp4c cF cfbas wcel vx cv cF cfg cfv
      wcel vx cv cF cuni wss vz cv vx cv wss vz cF wrex wa vy cv cF cfg cfv
      wcel vy cv cF cuni wss vu cv vy cv wss vu cF wrex wa vz vx cv cF cF cuni
      cF cuni eqid elfg vu vy cv cF cF cuni cF cuni eqid elfg anbi12d vv vx cv
      vy cv cin cF cF cuni cF cuni eqid elfg 3imtr4d r19.21aivv 3jca cF cfg cfv
      cvv wcel cF cfg cfv cfil wcel c0 cF cfg cfv wcel wn cF cfg cfv cuni cF
      cfg cfv wcel wa vx cv cF cfg cfv wcel vy cv cF cfg cfv cuni wss vx cv vy
      cv wss w3a vy cv cF cfg cfv wcel wi vy wal vx wal vx cv vy cv cin cF cfg
      cfv wcel vy cF cfg cfv wral vx cF cfg cfv wral w3a wb cF cfg fvex vx vy
      cvv cF cfg cfv cF cfg cfv cuni cF cfg cfv cuni eqid isfil ax-mp sylibr $.
      $( [1-Dec-2010] $) $( [3-Sep-2009] $)
  $}

  ${
    $d t w x y z A $. $d t w x y z F $. $d t w x y z X $.
    extbas.1 $e |- X = U. F $.
    $( A way to extend the base set of a filter.  (Contributed by Jeff Hankins,
       6-Sep-2009.) $)
    extbas1 $p |- ( ( F e. fBas /\ X C_ A ) -> ( F u. { A } ) e. fBas ) $=
      cF cfbas wcel cX cA wss wa cF cA csn cun cfbas wcel cF cA csn cun c0 wne
      c0 cF cA csn cun wnel vz cv vx cv vy cv cin wss vz cF cA csn cun wrex vy
      cF cA csn cun wral vx cF cA csn cun wral w3a cF cfbas wcel cX cA wss wa
      cF cA csn cun c0 wne c0 cF cA csn cun wnel vz cv vx cv vy cv cin wss vz
      cF cA csn cun wrex vy cF cA csn cun wral vx cF cA csn cun wral cF cfbas
      wcel cF cA csn cun c0 wne cX cA wss cF cfbas wcel cF c0 wne cF cA csn cun
      c0 wne cF fbasne0 cF cF cA csn cun wss cF c0 wne cF cA csn cun c0 wne cF
      cA csn ssun1 cF cF cA csn cun ssn0 mpan syl adantr cF cfbas wcel cX cA
      wss wa c0 cF wcel wn c0 cA csn wcel wn wa c0 cF cA csn cun wnel cF cfbas
      wcel cX cA wss wa c0 cF wcel wn c0 cA csn wcel wn cF cfbas wcel c0 cF
      wcel wn cX cA wss cF cfbas wcel c0 cF wnel c0 cF wcel wn cF 0nelfb c0 cF
      df-nel sylib adantr cF cfbas wcel cX cA wss wa c0 cA wceq c0 cA csn wcel
      cF cfbas wcel cX cA wss wa cA c0 wne c0 cA wceq wn cX cA wss cF cfbas
      wcel cA c0 wne cX cA wss cX c0 wne cA c0 wne cF cfbas wcel cX cA ssn0 cF
      cfbas wcel vw cv vt cv wcel vt cv cF wcel wa vw wex vt wex cX c0 wne cF
      cfbas wcel vt cv c0 wne vt cv cF wcel wa vt wex vw cv vt cv wcel vt cv cF
      wcel wa vw wex vt wex cF cfbas wcel vt cv cF wcel vt wex vt cv c0 wne vt
      cv cF wcel wa vt wex cF cfbas wcel cF c0 wne vt cv cF wcel vt wex cF
      fbasne0 vt cF n0 sylib cF cfbas wcel vt cv cF wcel vt cv c0 wne vt cv cF
      wcel wa vt cF cfbas wcel vt cv cF wcel vt cv c0 wne cF cfbas wcel vt cv
      cF wcel vt cv c0 vt cv c0 wceq vt cv cF wcel wn c0 cF wcel wn cF cfbas
      wcel vt cv c0 wceq vt cv cF wcel c0 cF wcel vt cv c0 cF eleq1 notbid cF
      cfbas wcel c0 cF wnel c0 cF wcel wn cF 0nelfb c0 cF df-nel sylib syl5cbir
      necon2ad ancrd 19.22dv mpd vt cv c0 wne vt cv cF wcel wa vw cv vt cv wcel
      vt cv cF wcel wa vw wex vt vt cv c0 wne vt cv cF wcel wa vw cv vt cv wcel
      vw wex vt cv cF wcel wa vw cv vt cv wcel vt cv cF wcel wa vw wex vt cv c0
      wne vw cv vt cv wcel vw wex vt cv cF wcel vw vt cv n0 anbi1i vw cv vt cv
      wcel vt cv cF wcel vw 19.41v bitr4i exbii sylib cF cuni c0 wne vw cv cF
      cuni wcel vw wex cX c0 wne vw cv vt cv wcel vt cv cF wcel wa vw wex vt
      wex vw cF cuni n0 cX cF cuni c0 extbas.1 neeq1i vw cv vt cv wcel vt cv cF
      wcel wa vw wex vt wex vw cv vt cv wcel vt cv cF wcel wa vt wex vw wex vw
      cv cF cuni wcel vw wex vw cv vt cv wcel vt cv cF wcel wa vt vw excom vw
      cv cF cuni wcel vw cv vt cv wcel vt cv cF wcel wa vt wex vw vt vw cv cF
      eluni exbii bitr4i 3bitr4ri sylib sylan2 ancoms cA c0 wne c0 cA wne c0 cA
      wceq wn cA c0 necom c0 cA df-ne bitri sylib c0 cA elsni nsyl jca c0 cF cA
      csn cun wnel c0 cF cA csn cun wcel wn c0 cF wcel c0 cA csn wcel wo wn c0
      cF wcel wn c0 cA csn wcel wn wa c0 cF cA csn cun df-nel c0 cF cA csn cun
      wcel c0 cF wcel c0 cA csn wcel wo c0 cF cA csn elun notbii c0 cF wcel c0
      cA csn wcel ioran 3bitrri sylib cF cfbas wcel cX cA wss wa vz cv vx cv vy
      cv cin wss vz cF cA csn cun wrex vx vy cF cA csn cun cF cA csn cun cF
      cfbas wcel cX cA wss wa vx cv cF wcel vx cv cA csn wcel wo vy cv cF wcel
      vy cv cA csn wcel wo wa vz cv vx cv vy cv cin wss vz cF cA csn cun wrex
      vx cv cF cA csn cun wcel vy cv cF cA csn cun wcel wa cF cfbas wcel cX cA
      wss wa vx cv cF wcel vx cv cA csn wcel wo vy cv cF wcel vy cv cA csn wcel
      wo vz cv vx cv vy cv cin wss vz cF cA csn cun wrex cF cfbas wcel cX cA
      wss wa vx cv cF wcel vy cv cF wcel vy cv cA csn wcel wo vz cv vx cv vy cv
      cin wss vz cF cA csn cun wrex wi vx cv cA csn wcel cF cfbas wcel cX cA
      wss wa vy cv cF wcel vy cv cA csn wcel wo vx cv cF wcel vz cv vx cv vy cv
      cin wss vz cF cA csn cun wrex cF cfbas wcel cX cA wss wa vy cv cF wcel vx
      cv cF wcel vz cv vx cv vy cv cin wss vz cF cA csn cun wrex wi vy cv cA
      csn wcel cF cfbas wcel vy cv cF wcel vx cv cF wcel vz cv vx cv vy cv cin
      wss vz cF cA csn cun wrex wi wi cX cA wss cF cfbas wcel vy cv cF wcel vx
      cv cF wcel vz cv vx cv vy cv cin wss vz cF cA csn cun wrex cF cfbas wcel
      vx cv cF wcel vy cv cF wcel vz cv vx cv vy cv cin wss vz cF cA csn cun
      wrex cF cfbas wcel vx cv cF wcel vy cv cF wcel w3a vz cv vx cv vy cv cin
      wss vz cF wrex vz cv vx cv vy cv cin wss vz cF cA csn cun wrex vz vx cv
      vy cv cF fbasssin vz cv vx cv vy cv cin wss vz cv vx cv vy cv cin wss vz
      cF cF cA csn cun vz cv cF wcel vz cv cF cA csn cun wcel vz cv vx cv vy cv
      cin wss vz cv cF cA csn elun1 anim1i r19.22i2 syl 3com23 3exp adantr cF
      cfbas wcel cX cA wss wa vy cv cA wceq vx cv cF wcel vz cv vx cv vy cv cin
      wss vz cF cA csn cun wrex wi vy cv cA csn wcel cF cfbas wcel cX cA wss wa
      vy cv cA wceq vx cv cF wcel vz cv vx cv vy cv cin wss vz cF cA csn cun
      wrex vx cv cF cA csn cun wcel vx cv vx cv vy cv cin wss vz cv vx cv vy cv
      cin wss vz cF cA csn cun wrex cF cfbas wcel cX cA wss wa vy cv cA wceq vx
      cv cF wcel wa wa vz cv vx cv vy cv cin wss vx cv vx cv vy cv cin wss vz
      vx cv cF cA csn cun vz cv vx cv vx cv vy cv cin sseq1 rcla4ev vx cv cF
      wcel vx cv cF cA csn cun wcel cF cfbas wcel cX cA wss wa vy cv cA wceq vx
      cv cF cA csn elun1 ad2antll cF cfbas wcel cX cA wss wa vy cv cA wceq vx
      cv cF wcel wa wa vx cv vx cv vy cv cin wceq vx cv vx cv vy cv cin wss cF
      cfbas wcel cX cA wss wa vy cv cA wceq vx cv cF wcel wa wa vx cv vy cv cin
      vx cv cF cfbas wcel cX cA wss wa vy cv cA wceq vx cv cF wcel wa wa vx cv
      vy cv wss vx cv vy cv cin vx cv wceq cF cfbas wcel cX cA wss wa vy cv cA
      wceq vx cv cF wcel wa wa vx cv vy cv wss vx cv cA wss cX cA wss vx cv cF
      wcel vx cv cA wss cF cfbas wcel vy cv cA wceq cF cuni cA wss vx cv cF
      wcel vx cv cA wss cX cA wss cF cuni cA wss vx cv cF cuni wss vx cv cA wss
      vx cv cF wcel vx cv cF cuni wss cF cuni cA wss vx cv cA wss vx cv cF cuni
      cA sstr ancoms vx cv cF elssuni sylan2 cX cF cuni cA extbas.1 sseq1i
      sylanb ad2ant2l vy cv cA wceq vx cv vy cv wss vx cv cA wss wb cF cfbas
      wcel cX cA wss wa vx cv cF wcel vy cv cA vx cv sseq2 ad2antrl mpbird vx
      cv vy cv df-ss sylib eqcomd vx cv vx cv vy cv cin eqimss syl sylanc exp32
      vy cv cA elsni syl5 jaod com23 cF cfbas wcel cX cA wss wa vx cv cA wceq
      vy cv cF wcel vy cv cA csn wcel wo vz cv vx cv vy cv cin wss vz cF cA csn
      cun wrex wi vx cv cA csn wcel cF cfbas wcel cX cA wss wa vy cv cF wcel vy
      cv cA csn wcel wo vx cv cA wceq vz cv vx cv vy cv cin wss vz cF cA csn
      cun wrex cF cfbas wcel cX cA wss wa vy cv cF wcel vx cv cA wceq vz cv vx
      cv vy cv cin wss vz cF cA csn cun wrex wi vy cv cA csn wcel cF cfbas wcel
      cX cA wss wa vy cv cF wcel vx cv cA wceq vz cv vx cv vy cv cin wss vz cF
      cA csn cun wrex vy cv cF cA csn cun wcel vy cv vx cv vy cv cin wss vz cv
      vx cv vy cv cin wss vz cF cA csn cun wrex cF cfbas wcel cX cA wss wa vy
      cv cF wcel vx cv cA wceq wa wa vz cv vx cv vy cv cin wss vy cv vx cv vy
      cv cin wss vz vy cv cF cA csn cun vz cv vy cv vx cv vy cv cin sseq1
      rcla4ev vy cv cF wcel vy cv cF cA csn cun wcel cF cfbas wcel cX cA wss wa
      vx cv cA wceq vy cv cF cA csn elun1 ad2antrl cF cfbas wcel cX cA wss wa
      vy cv cF wcel vx cv cA wceq wa wa vy cv vy cv vx cv cin vx cv vy cv cin
      cF cfbas wcel cX cA wss wa vy cv cF wcel vx cv cA wceq wa wa vy cv vy cv
      vx cv cin wceq vy cv vy cv vx cv cin wss cF cfbas wcel cX cA wss wa vy cv
      cF wcel vx cv cA wceq wa wa vy cv vx cv cin vy cv cF cfbas wcel cX cA wss
      wa vy cv cF wcel vx cv cA wceq wa wa vy cv vx cv wss vy cv vx cv cin vy
      cv wceq cF cfbas wcel cX cA wss wa vy cv cF wcel vx cv cA wceq wa wa vy
      cv vx cv wss vy cv cA wss cX cA wss vy cv cF wcel vy cv cA wss cF cfbas
      wcel vx cv cA wceq cF cuni cA wss vy cv cF wcel vy cv cA wss cX cA wss cF
      cuni cA wss vy cv cF cuni wss vy cv cA wss vy cv cF wcel vy cv cF cuni
      wss cF cuni cA wss vy cv cA wss vy cv cF cuni cA sstr ancoms vy cv cF
      elssuni sylan2 cX cF cuni cA extbas.1 sseq1i sylanb ad2ant2lr vx cv cA
      wceq vy cv vx cv wss vy cv cA wss wb cF cfbas wcel cX cA wss wa vy cv cF
      wcel vx cv cA vy cv sseq2 ad2antll mpbird vy cv vx cv df-ss sylib eqcomd
      vy cv vy cv vx cv cin eqimss syl vy cv vx cv incom syl6ss sylanc exp32 cF
      cfbas wcel cX cA wss wa cA cvv wcel vy cv cA csn wcel vx cv cA wceq vz cv
      vx cv vy cv cin wss vz cF cA csn cun wrex wi wi cF cfbas wcel cX cA wss
      cA cvv wcel vy cv cA csn wcel vx cv cA wceq vz cv vx cv vy cv cin wss vz
      cF cA csn cun wrex wi wi cF cfbas wcel cX cA wss cA cvv wcel w3a vy cv cA
      wceq vx cv cA wceq vz cv vx cv vy cv cin wss vz cF cA csn cun wrex wi vy
      cv cA csn wcel cF cfbas wcel cX cA wss cA cvv wcel w3a vy cv cA wceq vx
      cv cA wceq vz cv vx cv vy cv cin wss vz cF cA csn cun wrex cA cF cA csn
      cun wcel cA vx cv vy cv cin wss vz cv vx cv vy cv cin wss vz cF cA csn
      cun wrex cF cfbas wcel cX cA wss cA cvv wcel w3a vy cv cA wceq vx cv cA
      wceq wa wa vz cv vx cv vy cv cin wss cA vx cv vy cv cin wss vz cA cF cA
      csn cun vz cv cA vx cv vy cv cin sseq1 rcla4ev cF cfbas wcel cX cA wss cA
      cvv wcel w3a vy cv cA wceq vx cv cA wceq wa wa cA csn cF cA csn cun cA cA
      csn cF cA csn cun wss cF cfbas wcel cX cA wss cA cvv wcel w3a vy cv cA
      wceq vx cv cA wceq wa wa cA csn cF ssun2 a1i cF cfbas wcel cX cA wss cA
      cvv wcel w3a cA cA csn wcel vy cv cA wceq vx cv cA wceq wa cA cvv wcel cF
      cfbas wcel cA cA csn wcel cX cA wss cA cvv snidg 3ad2ant3 adantr sseldd
      cF cfbas wcel cX cA wss cA cvv wcel w3a vy cv cA wceq vx cv cA wceq wa wa
      cA vx cv vy cv cin wceq cA vx cv vy cv cin wss vy cv cA wceq vx cv cA
      wceq wa cA vx cv vy cv cin wceq cF cfbas wcel cX cA wss cA cvv wcel w3a
      vy cv cA wceq vx cv cA wceq wa vx cv vy cv cin cA cA cin cA vy cv cA wceq
      vx cv cA wceq wa vx cv cA vy cv cA vy cv cA wceq vx cv cA wceq pm3.27 vy
      cv cA wceq vx cv cA wceq pm3.26 ineq12d cA inidm syl6req adantl cA vx cv
      vy cv cin eqimss syl sylanc exp32 vy cv cA elsni syl5 3expia cA cvv wcel
      wn vy cv cA csn wcel vx cv cA wceq vz cv vx cv vy cv cin wss vz cF cA csn
      cun wrex wi cA cvv wcel wn cA csn c0 wceq vy cv cA csn wcel wn cA snprc
      cA csn c0 wceq vy cv cA csn wcel vy cv c0 wcel vy cv noel cA csn c0 vy cv
      eleq2 mtbiri sylbi pm2.21d pm2.61d1 jaod com23 vx cv cA elsni syl5 jaod
      imp3a vx cv cF cA csn cun wcel vx cv cF wcel vx cv cA csn wcel wo vy cv
      cF cA csn cun wcel vy cv cF wcel vy cv cA csn wcel wo vx cv cF cA csn
      elun vy cv cF cA csn elun anbi12i syl5ib r19.21aivv 3jca cF cfbas wcel cF
      cA csn cun cfbas wcel cF cA csn cun c0 wne c0 cF cA csn cun wnel vz cv vx
      cv vy cv cin wss vz cF cA csn cun wrex vy cF cA csn cun wral vx cF cA csn
      cun wral w3a wb cX cA wss cF cfbas wcel cF cA csn cun cvv wcel cF cA csn
      cun cfbas wcel cF cA csn cun c0 wne c0 cF cA csn cun wnel vz cv vx cv vy
      cv cin wss vz cF cA csn cun wrex vy cF cA csn cun wral vx cF cA csn cun
      wral w3a wb cF cfbas wcel cA csn cvv wcel cF cA csn cun cvv wcel cA snex
      cF cA csn cfbas cvv unexg mpan2 vx vy vz cvv cF cA csn cun isfbas2 syl
      adantr mpbird $.
      $( [1-Dec-2010] $) $( [6-Sep-2009] $)

      $( The base set of an extended filter.  (Contributed by Jeff Hankins,
         7-Sep-2009.) $)
      extbas2 $p |- ( ( X C_ A /\ A e. B ) -> U. ( F u. { A } ) =
      A ) $=
        cX cA wss cA cB wcel wa cX cA csn cuni cun cA cF cA csn cun cuni cA cB
        wcel cX cA wss cX cA csn cuni cun cX cA cun cA cA cB wcel cA csn cuni
        cA cX cA cB unisng uneq2d cX cA wss cX cA cun cA cX cA wss cX cA wss cA
        cA wss wa cX cA cun cA wss cX cA wss cA cA wss cA ssid jctr cX cA cA
        unss sylib cA cX cA cun wss cX cA wss cA cX ssun2 a1i eqssd sylan9eqr
        cF cA csn cun cuni cF cuni cA csn cuni cun cX cA csn cuni cun cF cA csn
        uniun cX cF cuni cA csn cuni extbas.1 uneq1i eqtr4i syl5eq $.
        $( [1-Dec-2010] $) $( [7-Sep-2009] $)
  $}

  ${
    $d b c r s t u v x y B $. $d b c r s t u v C $. $d b c r s t u v x y F $.
    $d b c r s t u v x X $. $d b c r s t u v x y $.
    filrn.1 $e |- X = U. B $.
    filrn.2 $e |- C = { y | E. x e. B y = ( F " x ) } $.
    $( Given a filter on a domain, produce a filter on the range.  (Contributed
       by Jeff Hankins, 7-Sep-2009.) $)
    filrn $p |- ( ( B e. fBas /\ F Fn X ) -> C e. fBas ) $=
      cB cfbas wcel cF cX wfn wa cC cfbas wcel cC c0 wne c0 cC wnel vt cv vr cv
      vs cv cin wss vt cC wrex vs cC wral vr cC wral w3a cB cfbas wcel cF cX
      wfn wa cC c0 wne c0 cC wnel vt cv vr cv vs cv cin wss vt cC wrex vs cC
      wral vr cC wral vb cv cB wcel vb wex cF cX wfn cC c0 wne cB cfbas wcel vb
      cv cB wcel vb wex cF cX wfn cC c0 wne vb cv cB wcel cF cX wfn cC c0 wne
      wi vb vb cv cB wcel cF cX wfn vc cv cF vx cv cima wceq vx cB wrex vc wex
      cC c0 wne vb cv cB wcel cF cX wfn vc cv cF vx cv cima wceq vx cB wrex vc
      wex cF vb cv cima cvv wcel cF vb cv cima cF vx cv cima wceq vx cB wrex vc
      cv cF vx cv cima wceq vx cB wrex vc wex vb cv cB wcel cF cX wfn wa vc cv
      cF vx cv cima wceq vx cB wrex cF vb cv cima cF vx cv cima wceq vx cB wrex
      vc cF vb cv cima cvv vc cv cF vb cv cima wceq vc cv cF vx cv cima wceq cF
      vb cv cima cF vx cv cima wceq vx cB vc cv cF vb cv cima cF vx cv cima
      eqeq1 rexbidv cla4egv cF cX wfn vb cv cB wcel cF vb cv cima cvv wcel cF
      wfun vb cv cB wcel cF vb cv cima cvv wcel cF cX wfn cF vb cv cB funimaexg
      cX cF fnfun sylan ancoms vb cv cB wcel cF vb cv cima cF vx cv cima wceq
      vx cB wrex cF cX wfn vb cv cB wcel cF vb cv cima cF vb cv cima wceq cF vb
      cv cima cF vx cv cima wceq vx cB wrex cF vb cv cima eqid cF vb cv cima cF
      vx cv cima wceq cF vb cv cima cF vb cv cima wceq vx vb cv cB vx cv vb cv
      wceq cF vx cv cima cF vb cv cima cF vb cv cima vx cv vb cv cF imaeq2
      eqeq2d rcla4ev mpan2 adantr sylc ex vc cv cF vx cv cima wceq vx cB wrex
      vc wex vc cv cC wcel vc wex cC c0 wne vc cv cF vx cv cima wceq vx cB wrex
      vc cv cC wcel vc vc cv cC wcel vc cv vy cv cF vx cv cima wceq vx cB wrex
      vy cab wcel vc cv cF vx cv cima wceq vx cB wrex cC vy cv cF vx cv cima
      wceq vx cB wrex vy cab vc cv filrn.2 eleq2i vy cv cF vx cv cima wceq vx
      cB wrex vc cv cF vx cv cima wceq vx cB wrex vy vc cv vc visset vy cv vc
      cv wceq vy cv cF vx cv cima wceq vc cv cF vx cv cima wceq vx cB vy cv vc
      cv cF vx cv cima eqeq1 rexbidv elab bitr2i exbii vc cC n0 bitr4i syl6ib
      19.23aiv imp cB cfbas wcel cB c0 wne vb cv cB wcel vb wex cB fbasne0 vb
      cB n0 sylib sylan cB cfbas wcel cF cX wfn wa c0 cF vx cv cima wceq wn vx
      cB wral c0 cC wnel cB cfbas wcel cF cX wfn wa c0 cF vx cv cima wceq wn vx
      cB cB cfbas wcel cF cX wfn wa vx cv cB wcel vx cv cB cuni wss vx cv c0
      wceq wn wa c0 cF vx cv cima wceq wn cB cfbas wcel cF cX wfn wa vx cv cB
      wcel vx cv cB cuni wss vx cv c0 wceq wn vx cv cB wcel vx cv cB cuni wss
      wi cB cfbas wcel cF cX wfn wa vx cv cB elssuni a1i cB cfbas wcel vx cv cB
      wcel vx cv c0 wceq wn wi cF cX wfn cB cfbas wcel vx cv c0 wceq vx cv cB
      wcel vx cv c0 wceq vx cv cB wcel wn c0 cB wcel wn cB cfbas wcel vx cv c0
      wceq vx cv cB wcel c0 cB wcel vx cv c0 cB eleq1 notbid cB cfbas wcel c0
      cB wnel c0 cB wcel wn cB 0nelfb c0 cB df-nel sylib syl5cbir con2d adantr
      jcad cB cfbas wcel cF cX wfn wa vx cv cB cuni wss vx cv c0 wceq wn wa cF
      cdm vx cv cin c0 wceq wn c0 cF vx cv cima wceq wn cB cfbas wcel cF cX wfn
      wa vx cv cB cuni wss vx cv c0 wceq wn cF cdm vx cv cin c0 wceq wn cB
      cfbas wcel cF cX wfn wa vx cv cB cuni wss wa cF cdm vx cv cin c0 wceq vx
      cv c0 wceq cB cfbas wcel cF cX wfn wa vx cv cB cuni wss wa cF cdm vx cv
      cin c0 wceq vx cv c0 wceq cB cfbas wcel cF cX wfn wa vx cv cB cuni wss wa
      cF cdm vx cv cin vx cv c0 cB cfbas wcel cF cX wfn wa vx cv cB cuni wss wa
      vx cv cF cdm wss cF cdm vx cv cin vx cv wceq cB cfbas wcel cF cX wfn wa
      vx cv cF cdm wss vx cv cB cuni wss cB cfbas wcel cF cX wfn wa cF cdm cB
      cuni vx cv cB cfbas wcel cF cX wfn wa cF cdm cX cB cuni cF cX wfn cF cdm
      cX wceq cB cfbas wcel cX cF fndm adantl filrn.1 syl6eq sseq2d biimpar vx
      cv cF cdm sseqin2 sylib eqeq1d biimpd con3d expimpd c0 cF vx cv cima wceq
      cF cdm vx cv cin c0 wceq c0 cF vx cv cima wceq cF vx cv cima c0 wceq cF
      cdm vx cv cin c0 wceq c0 cF vx cv cima eqcom cF vx cv imadisj bitri
      notbii syl6ibr syld r19.21aiv c0 cF vx cv cima wceq vx cB wrex wn c0 cC
      wcel wn c0 cF vx cv cima wceq wn vx cB wral c0 cC wnel c0 cF vx cv cima
      wceq vx cB wrex c0 cC wcel c0 cC wcel c0 vy cv cF vx cv cima wceq vx cB
      wrex vy cab wcel c0 cF vx cv cima wceq vx cB wrex cC vy cv cF vx cv cima
      wceq vx cB wrex vy cab c0 filrn.2 eleq2i vy cv cF vx cv cima wceq vx cB
      wrex c0 cF vx cv cima wceq vx cB wrex vy c0 0ex vy cv c0 wceq vy cv cF vx
      cv cima wceq c0 cF vx cv cima wceq vx cB vy cv c0 cF vx cv cima eqeq1
      rexbidv elab bitr2i notbii c0 cF vx cv cima wceq vx cB ralnex c0 cC
      df-nel 3bitr4i sylib cB cfbas wcel cF cX wfn wa vt cv vr cv vs cv cin wss
      vt cC wrex vr vs cC cC cB cfbas wcel cF cX wfn wa vr cv cF vu cv cima
      wceq vs cv cF vv cv cima wceq wa vv cB wrex vu cB wrex vt cv vr cv vs cv
      cin wss vt cC wrex vr cv cC wcel vs cv cC wcel wa cB cfbas wcel cF cX wfn
      wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq wa vt cv vr cv vs cv
      cin wss vt cC wrex vu vv cB cB cB cfbas wcel cF cX wfn wa vu cv cB wcel
      vv cv cB wcel wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq wa vt
      cv vr cv vs cv cin wss vt cC wrex cB cfbas wcel cF cX wfn wa vu cv cB
      wcel vv cv cB wcel wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq
      wa wa wa vb cv vu cv vv cv cin wss vb cB wrex vt cv vr cv vs cv cin wss
      vt cC wrex cB cfbas wcel vu cv cB wcel vv cv cB wcel wa vb cv vu cv vv cv
      cin wss vb cB wrex cF cX wfn vr cv cF vu cv cima wceq vs cv cF vv cv cima
      wceq wa cB cfbas wcel vu cv cB wcel vv cv cB wcel vb cv vu cv vv cv cin
      wss vb cB wrex vb vu cv vv cv cB fbasssin 3expb ad2ant2r cB cfbas wcel cF
      cX wfn wa vu cv cB wcel vv cv cB wcel wa vr cv cF vu cv cima wceq vs cv
      cF vv cv cima wceq wa wa wa vb cv vu cv vv cv cin wss vt cv vr cv vs cv
      cin wss vt cC wrex vb cB cB cfbas wcel cF cX wfn wa vu cv cB wcel vv cv
      cB wcel wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq wa wa wa vb
      cv cB wcel vb cv vu cv vv cv cin wss vt cv vr cv vs cv cin wss vt cC wrex
      cB cfbas wcel cF cX wfn wa vr cv cF vu cv cima wceq vs cv cF vv cv cima
      wceq wa vb cv cB wcel vb cv vu cv vv cv cin wss wa vt cv vr cv vs cv cin
      wss vt cC wrex vu cv cB wcel vv cv cB wcel wa cF vb cv cima cC wcel cF vb
      cv cima vr cv vs cv cin wss vt cv vr cv vs cv cin wss vt cC wrex cB cfbas
      wcel cF cX wfn wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq wa wa
      vb cv cB wcel vb cv vu cv vv cv cin wss wa wa vt cv vr cv vs cv cin wss
      cF vb cv cima vr cv vs cv cin wss vt cF vb cv cima cC vt cv cF vb cv cima
      vr cv vs cv cin sseq1 rcla4ev cB cfbas wcel cF cX wfn wa vr cv cF vu cv
      cima wceq vs cv cF vv cv cima wceq wa wa vb cv cB wcel vb cv vu cv vv cv
      cin wss wa wa cF vb cv cima cC wcel cF vb cv cima cF vx cv cima wceq vx
      cB wrex vb cv cB wcel cF vb cv cima cF vx cv cima wceq vx cB wrex cB
      cfbas wcel cF cX wfn wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq
      wa wa vb cv vu cv vv cv cin wss vb cv cB wcel cF vb cv cima cF vb cv cima
      wceq cF vb cv cima cF vx cv cima wceq vx cB wrex cF vb cv cima eqid cF vb
      cv cima cF vx cv cima wceq cF vb cv cima cF vb cv cima wceq vx vb cv cB
      vx cv vb cv wceq cF vx cv cima cF vb cv cima cF vb cv cima vx cv vb cv cF
      imaeq2 eqeq2d rcla4ev mpan2 ad2antrl cB cfbas wcel cF cX wfn wa cF vb cv
      cima cC wcel cF vb cv cima cF vx cv cima wceq vx cB wrex wb vr cv cF vu
      cv cima wceq vs cv cF vv cv cima wceq wa vb cv cB wcel vb cv vu cv vv cv
      cin wss wa cF cX wfn cF vb cv cima cC wcel cF vb cv cima cF vx cv cima
      wceq vx cB wrex wb cB cfbas wcel cF cX wfn cF vb cv cima vy cv cF vx cv
      cima wceq vx cB wrex vy cab wcel cF vb cv cima cF vx cv cima wceq vx cB
      wrex cF vb cv cima cC wcel cF cX wfn cF wfun cF vb cv cima cvv wcel cF vb
      cv cima vy cv cF vx cv cima wceq vx cB wrex vy cab wcel cF vb cv cima cF
      vx cv cima wceq vx cB wrex wb cX cF fnfun cF vb cv vb visset funimaex vy
      cv cF vx cv cima wceq vx cB wrex cF vb cv cima cF vx cv cima wceq vx cB
      wrex vy cF vb cv cima cvv vy cv cF vb cv cima wceq vy cv cF vx cv cima
      wceq cF vb cv cima cF vx cv cima wceq vx cB vy cv cF vb cv cima cF vx cv
      cima eqeq1 rexbidv elabg 3syl cC vy cv cF vx cv cima wceq vx cB wrex vy
      cab cF vb cv cima filrn.2 eleq2i syl5bb adantl ad2antrr mpbird cB cfbas
      wcel cF cX wfn wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq wa wa
      vb cv cB wcel vb cv vu cv vv cv cin wss wa wa cF vb cv cima cF vu cv vv
      cv cin cima vr cv vs cv cin vb cv vu cv vv cv cin wss cF vb cv cima cF vu
      cv vv cv cin cima wss cB cfbas wcel cF cX wfn wa vr cv cF vu cv cima wceq
      vs cv cF vv cv cima wceq wa wa vb cv cB wcel vb cv vu cv vv cv cin cF
      imass2 ad2antll cB cfbas wcel cF cX wfn wa vr cv cF vu cv cima wceq vs cv
      cF vv cv cima wceq wa wa vb cv cB wcel vb cv vu cv vv cv cin wss wa wa cF
      vu cv vv cv cin cima cF vu cv cima cF vv cv cima cin vr cv vs cv cin cF
      vu cv vv cv cin cima cF vu cv cima cF vv cv cima cin wss cB cfbas wcel cF
      cX wfn wa vr cv cF vu cv cima wceq vs cv cF vv cv cima wceq wa wa vb cv
      cB wcel vb cv vu cv vv cv cin wss wa wa cF vu cv vv cv cin cima cF vu cv
      cima cF vv cv cima vu cv vv cv cin vu cv wss cF vu cv vv cv cin cima cF
      vu cv cima wss vu cv vv cv inss1 vu cv vv cv cin vu cv cF imass2 ax-mp vu
      cv vv cv cin vv cv wss cF vu cv vv cv cin cima cF vv cv cima wss vu cv vv
      cv inss2 vu cv vv cv cin vv cv cF imass2 ax-mp ssini a1i vr cv cF vu cv
      cima wceq vs cv cF vv cv cima wceq wa vr cv vs cv cin cF vu cv cima cF vv
      cv cima cin wceq cB cfbas wcel cF cX wfn wa vb cv cB wcel vb cv vu cv vv
      cv cin wss wa vr cv cF vu cv cima vs cv cF vv cv cima ineq12 ad2antlr
      sseqtr4d sstrd sylanc adantlrl exp32 r19.23adv mpd exp32 r19.23advv vr cv
      cC wcel vs cv cC wcel wa vr cv cF vu cv cima wceq vu cB wrex vs cv cF vv
      cv cima wceq vv cB wrex wa vr cv cF vu cv cima wceq vs cv cF vv cv cima
      wceq wa vv cB wrex vu cB wrex vr cv cC wcel vr cv cF vu cv cima wceq vu
      cB wrex vs cv cC wcel vs cv cF vv cv cima wceq vv cB wrex vr cv cC wcel
      vr cv vy cv cF vx cv cima wceq vx cB wrex vy cab wcel vr cv cF vx cv cima
      wceq vx cB wrex vr cv cF vu cv cima wceq vu cB wrex cC vy cv cF vx cv
      cima wceq vx cB wrex vy cab vr cv filrn.2 eleq2i vy cv cF vx cv cima wceq
      vx cB wrex vr cv cF vx cv cima wceq vx cB wrex vy vr cv vr visset vy cv
      vr cv wceq vy cv cF vx cv cima wceq vr cv cF vx cv cima wceq vx cB vy cv
      vr cv cF vx cv cima eqeq1 rexbidv elab vr cv cF vx cv cima wceq vr cv cF
      vu cv cima wceq vx vu cB vx cv vu cv wceq cF vx cv cima cF vu cv cima vr
      cv vx cv vu cv cF imaeq2 eqeq2d cbvrexv 3bitri vs cv cC wcel vs cv vy cv
      cF vx cv cima wceq vx cB wrex vy cab wcel vs cv cF vx cv cima wceq vx cB
      wrex vs cv cF vv cv cima wceq vv cB wrex cC vy cv cF vx cv cima wceq vx
      cB wrex vy cab vs cv filrn.2 eleq2i vy cv cF vx cv cima wceq vx cB wrex
      vs cv cF vx cv cima wceq vx cB wrex vy vs cv vs visset vy cv vs cv wceq
      vy cv cF vx cv cima wceq vs cv cF vx cv cima wceq vx cB vy cv vs cv cF vx
      cv cima eqeq1 rexbidv elab vs cv cF vx cv cima wceq vs cv cF vv cv cima
      wceq vx vv cB vx cv vv cv wceq cF vx cv cima cF vv cv cima vs cv vx cv vv
      cv cF imaeq2 eqeq2d cbvrexv 3bitri anbi12i vr cv cF vu cv cima wceq vs cv
      cF vv cv cima wceq vu vv cB cB reeanv bitr4i syl5ib r19.21aivv 3jca cB
      cfbas wcel cC cfbas wcel cC c0 wne c0 cC wnel vt cv vr cv vs cv cin wss
      vt cC wrex vs cC wral vr cC wral w3a wb cF cX wfn cB cfbas wcel cC cvv
      wcel cC cfbas wcel cC c0 wne c0 cC wnel vt cv vr cv vs cv cin wss vt cC
      wrex vs cC wral vr cC wral w3a wb cB cfbas wcel vy cv cF vx cv cima wceq
      vx cB wrex vy cab cvv cC vx vy cB cF vx cv cima cfbas abrexexg filrn.2
      syl5eqel vr vs vt cvv cC isfbas2 syl adantr mpbird $.
      $( [1-Dec-2010] $) $( [7-Sep-2009] $)
  $}



$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $c fLim1 $.

  $( Extend class notation with a function returning the limit of a filter. $)
  cflim1 $a class fLim1 $.

  $c fLim2 $.

  $( Extend class notation with a function returning the limit of a
     function. $)
  cflim2 $a class fLim2 $.

  ${ $d x y a b l $.
    $( Define a function (indexed by a topology ` x `) whose value is the
       limits of a filter ` a ` . $)
    df-flim1 $a |- fLim1 = { <. x , y >. | ( x e. Top /\ y = { <. a , b >. |
      ( a e. Fil /\ U. a = U. x /\
        b = { l e. U. x | ( ( nei ` x ) ` { l } ) C_ a } ) } ) } $.
  $}

  ${ $d J a b l x y $.  $d X a b l x y $.
    sfvlim.1 $e |- X = U. J $.
    $( Functions whose values are the limits of the filters.  (Contributed by
       FL, 1-Sep-2008.) $)
    sfvlim $p |- ( J e. Top -> ( fLim1 ` J ) = { <. a , b >. |
      ( a e. Fil /\ U. a = X /\
        b = { l e. X | ( ( nei ` J ) ` { l } ) C_ a } ) } ) $=
      cJ ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei
      cfv cfv va cv wss vl cX crab wceq w3a va vb copab cvv wcel cJ cflim1 cfv
      va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv
      wss vl cX crab wceq w3a va vb copab wceq va cv cfil wcel va cv cuni cX
      wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq w3a va vb
      copab va cv cfil cX cpw cpw cin wcel vb cv vl cv csn cJ cnei cfv cfv va
      cv wss vl cX crab wceq wa va vb copab wss va cv cfil cX cpw cpw cin wcel
      vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa va vb copab
      cvv wcel va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv
      cfv va cv wss vl cX crab wceq w3a va vb copab cvv wcel cJ ctop wcel va cv
      cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl
      cX crab wceq w3a va vb copab va cv cfil cX cpw cpw cin wcel vb cv vl cv
      csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa va vb copab cvv ssexg cJ
      ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv
      cfv va cv wss vl cX crab wceq w3a va cv cfil cX cpw cpw cin wcel vb cv vl
      cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa wi vb wal va wal va
      cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss
      vl cX crab wceq w3a va vb copab va cv cfil cX cpw cpw cin wcel vb cv vl
      cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa va vb copab wss cJ
      ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv
      cfv va cv wss vl cX crab wceq w3a va cv cfil cX cpw cpw cin wcel vb cv vl
      cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa wi va vb cJ ctop wcel
      va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv
      wss vl cX crab wceq w3a va cv cfil cX cpw cpw cin wcel vb cv vl cv csn cJ
      cnei cfv cfv va cv wss vl cX crab wceq wa cJ ctop wcel va cv cfil wcel va
      cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq
      w3a wa va cv cfil cX cpw cpw cin wcel vb cv vl cv csn cJ cnei cfv cfv va
      cv wss vl cX crab wceq va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn
      cJ cnei cfv cfv va cv wss vl cX crab wceq w3a cJ ctop wcel va cv cfil cX
      cpw cpw cin wcel va cv cfil wcel va cv cuni cX wceq cJ ctop wcel va cv
      cfil cX cpw cpw cin wcel wi vb cv vl cv csn cJ cnei cfv cfv va cv wss vl
      cX crab wceq va cv cfil wcel va cv cuni cX wceq wa cJ ctop wcel va cv
      cfil cX cpw cpw cin wcel va cv cfil wcel va cv cuni cX wceq wa cJ ctop
      wcel wa va cv cfil wcel va cv cX cpw cpw wcel wa va cv cfil cX cpw cpw
      cin wcel va cv cfil wcel va cv cuni cX wceq wa cJ ctop wcel wa va cv cfil
      wcel va cv cX cpw cpw wcel va cv cfil wcel va cv cuni cX wceq cJ ctop
      wcel simpll va cv cuni cX wceq va cv cX cpw cpw wcel va cv cfil wcel cJ
      ctop wcel va cv cuni cX wceq va cv cuni cX wss va cv cX cpw cpw wcel va
      cv cuni cX eqimss va cv cuni cX wss va cv cX cpw wss va cv cX cpw cpw
      wcel va cv cX sspwuni va cv cX cpw cpw wcel va cv cX cpw wss va cv cX cpw
      va visset elpw biimpri sylbir syl ad2antlr jca va cv cfil cX cpw cpw elin
      sylibr ex 3adant3 impcom va cv cfil wcel va cv cuni cX wceq vb cv vl cv
      csn cJ cnei cfv cfv va cv wss vl cX crab wceq w3a vb cv vl cv csn cJ cnei
      cfv cfv va cv wss vl cX crab wceq cJ ctop wcel va cv cfil wcel va cv cuni
      cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq 3simp3
      adantl jca ex 19.21aivv va cv cfil wcel va cv cuni cX wceq vb cv vl cv
      csn cJ cnei cfv cfv va cv wss vl cX crab wceq w3a va cv cfil cX cpw cpw
      cin wcel vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa va
      vb ssopab2 sylibr cJ ctop wcel cfil cX cpw cpw cin cvv wcel va cv cfil cX
      cpw cpw cin wcel vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab
      wceq wa va vb copab cvv wcel cJ ctop wcel cX cpw cpw cvv wcel cX cpw cpw
      cfil cin cvv wcel cfil cX cpw cpw cin cvv wcel cJ ctop wcel cX cvv wcel
      cX cpw cvv wcel cX cpw cpw cvv wcel cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg sfvlim.1 syl5eqel cX cvv pwexg cX cpw cvv pwexg 3syl cX cpw cpw
      cfil cvv inex1g cX cpw cpw cfil cin cvv wcel cfil cX cpw cpw cin cvv wcel
      cX cpw cpw cfil cin cfil cX cpw cpw cin cvv cX cpw cpw cfil incom eleq1i
      biimpi 3syl va vb cfil cX cpw cpw cin vl cv csn cJ cnei cfv cfv va cv wss
      vl cX crab cvv opabex2g syl sylanc vx vy cJ va cv cfil wcel va cv cuni vx
      cv cuni wceq vb cv vl cv csn vx cv cnei cfv cfv va cv wss vl vx cv cuni
      crab wceq w3a va vb copab va cv cfil wcel va cv cuni cX wceq vb cv vl cv
      csn cJ cnei cfv cfv va cv wss vl cX crab wceq w3a va vb copab ctop cvv
      cflim1 vx cv cJ wceq va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vl
      cv csn vx cv cnei cfv cfv va cv wss vl vx cv cuni crab wceq w3a va cv
      cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl
      cX crab wceq w3a va vb vx cv cJ wceq va cv cuni vx cv cuni wceq va cv
      cuni cX wceq vb cv vl cv csn vx cv cnei cfv cfv va cv wss vl vx cv cuni
      crab wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq va cv
      cfil wcel vx cv cJ wceq vx cv cuni cX va cv cuni vx cv cJ wceq vx cv cuni
      cJ cuni cX vx cv cJ unieq sfvlim.1 syl6eqr eqeq2d vx cv cJ wceq vl cv csn
      vx cv cnei cfv cfv va cv wss vl vx cv cuni crab vl cv csn cJ cnei cfv cfv
      va cv wss vl cX crab vb cv vx cv cJ wceq vl cv csn vx cv cnei cfv cfv va
      cv wss vl vx cv cuni crab vl cv csn vx cv cnei cfv cfv va cv wss vl cX
      crab vl cv csn cJ cnei cfv cfv va cv wss vl cX crab vx cv cJ wceq vx cv
      cuni cX wceq vl cv csn vx cv cnei cfv cfv va cv wss vl vx cv cuni crab vl
      cv csn vx cv cnei cfv cfv va cv wss vl cX crab wceq vx cv cJ wceq vx cv
      cuni cJ cuni cX vx cv cJ unieq sfvlim.1 syl6eqr vl cv csn vx cv cnei cfv
      cfv va cv wss vl vx cv cuni cX rabeq syl vx cv cJ wceq vl cv csn vx cv
      cnei cfv cfv va cv wss vl cv csn cJ cnei cfv cfv va cv wss vl cX vx cv cJ
      wceq vl cv csn vx cv cnei cfv cfv vl cv csn cJ cnei cfv cfv va cv vx cv
      cJ wceq vl cv csn vx cv cnei cfv cJ cnei cfv vx cv cJ cnei fveq2 fveq1d
      sseq1d rabbisdv eqtrd eqeq2d 3anbi23d opabbidv vx vy va vb vl df-flim1
      fvopab4g mpdan $.
      $( [1-Dec-2010] $) $( [17-Aug-2008] $)
  $}


  ${
    $d l x y F $. $d l x y J $. $d l x y X $. $d x y Y $.
    limfil.1 $e |- X = U. J $.
    limfil.2 $e |- Y = U. F $.
    $( The set of limit points of a filter. (Contributed by Jeff Hankins,
       4-Sep-2009.) $)
    limfil $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( ( fLim1 ` J ) ` F ) =
    { l e. X | ( ( nei ` J ) ` { l } ) C_ F } ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cJ cflim1 cfv cfv cF vx cv
      cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl
      cX crab wceq w3a vx vy copab cfv vl cv csn cJ cnei cfv cfv cF wss vl cX
      crab cJ ctop wcel cF cfil wcel cF cJ cflim1 cfv cfv cF vx cv cfil wcel vx
      cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab wceq
      w3a vx vy copab cfv wceq cX cY wceq cJ ctop wcel cF cJ cflim1 cfv vx cv
      cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl
      cX crab wceq w3a vx vy copab cJ cX vx vy vl limfil.1 sfvlim fveq1d
      3ad2ant1 vl cv csn cJ cnei cfv cfv cF wss vl cX crab cvv wcel vx cv cfil
      wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX
      crab wceq w3a vx vy copab wfun wa cF vl cv csn cJ cnei cfv cfv cF wss vl
      cX crab cop vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei
      cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab wcel cF vx cv cfil wcel
      vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab
      wceq w3a vx vy copab cfv vl cv csn cJ cnei cfv cfv cF wss vl cX crab wceq
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cF vl cv csn cJ cnei cfv cfv cF
      wss vl cX crab cvv vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ
      cnei cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab funopfvg cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vl cv csn cJ cnei cfv cfv cF wss vl cX
      crab cvv wcel vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei
      cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab wfun cJ ctop wcel cF
      cfil wcel vl cv csn cJ cnei cfv cfv cF wss vl cX crab cvv wcel cX cY wceq
      cJ ctop wcel cX cvv wcel vl cv csn cJ cnei cfv cfv cF wss vl cX crab cvv
      wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg limfil.1 syl5eqel vl cv
      csn cJ cnei cfv cfv cF wss vl cX cvv rabexg syl 3ad2ant1 vx cv cfil wcel
      vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab
      wceq w3a vx vy copab vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab
      wceq vx vy copab wss vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab
      wceq vx vy copab wfun vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn
      cJ cnei cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab wfun vx cv cfil
      wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX
      crab wceq w3a vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab wceq
      vx vy vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv
      vx cv wss vl cX crab wceq 3simp3 ssopab2i vx vy vl cv csn cJ cnei cfv cfv
      vx cv wss vl cX crab funopabeq vx cv cfil wcel vx cv cuni cX wceq vy cv
      vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab vy cv
      vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab wceq vx vy copab funss mp2
      jctir cJ ctop wcel cF cfil wcel cX cY wceq w3a cF vl cv csn cJ cnei cfv
      cfv cF wss vl cX crab cop vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv
      csn cJ cnei cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab wcel cF
      cfil wcel cY cX wceq vl cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv
      csn cJ cnei cfv cfv cF wss vl cX crab wceq w3a cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cfil wcel cY cX wceq vl cv csn cJ cnei cfv cfv cF wss
      vl cX crab vl cv csn cJ cnei cfv cfv cF wss vl cX crab wceq cJ ctop wcel
      cF cfil wcel cX cY wceq 3simp2 cX cY wceq cJ ctop wcel cY cX wceq cF cfil
      wcel cX cY wceq cY cX wceq cX cY eqcom biimpi 3ad2ant3 cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vl cv csn cJ cnei cfv cfv cF wss vl cX crab
      eqidd 3jca cJ ctop wcel cF cfil wcel cF vl cv csn cJ cnei cfv cfv cF wss
      vl cX crab cop vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei
      cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab wcel cF cfil wcel cY cX
      wceq vl cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv
      cfv cF wss vl cX crab wceq w3a wb cX cY wceq cX cvv wcel cF cfil wcel cF
      vl cv csn cJ cnei cfv cfv cF wss vl cX crab cop vx cv cfil wcel vx cv
      cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab wceq
      w3a vx vy copab wcel cF cfil wcel cY cX wceq vl cv csn cJ cnei cfv cfv cF
      wss vl cX crab vl cv csn cJ cnei cfv cfv cF wss vl cX crab wceq w3a wb cJ
      ctop wcel cF cfil wcel cX cvv wcel cF vl cv csn cJ cnei cfv cfv cF wss vl
      cX crab cop vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei
      cfv cfv vx cv wss vl cX crab wceq w3a vx vy copab wcel cF cfil wcel cY cX
      wceq vl cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv
      cfv cF wss vl cX crab wceq w3a wb cF cfil wcel vl cv csn cJ cnei cfv cfv
      cF wss vl cX crab cvv wcel cF vl cv csn cJ cnei cfv cfv cF wss vl cX crab
      cop vx cv cfil wcel vx cv cuni cX wceq vy cv vl cv csn cJ cnei cfv cfv vx
      cv wss vl cX crab wceq w3a vx vy copab wcel cF cfil wcel cY cX wceq vl cv
      csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv cfv cF wss vl
      cX crab wceq w3a wb cX cvv wcel vx cv cfil wcel vx cv cuni cX wceq vy cv
      vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab wceq w3a cF cfil wcel cY
      cX wceq vy cv vl cv csn cJ cnei cfv cfv cF wss vl cX crab wceq w3a cF
      cfil wcel cY cX wceq vl cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv
      csn cJ cnei cfv cfv cF wss vl cX crab wceq w3a vx vy cF vl cv csn cJ cnei
      cfv cfv cF wss vl cX crab cfil cvv vx cv cF wceq vx cv cfil wcel cF cfil
      wcel vx cv cuni cX wceq cY cX wceq vy cv vl cv csn cJ cnei cfv cfv vx cv
      wss vl cX crab wceq vy cv vl cv csn cJ cnei cfv cfv cF wss vl cX crab
      wceq vx cv cF cfil eleq1 vx cv cF wceq vx cv cuni cY cX vx cv cF wceq vx
      cv cuni cF cuni cY vx cv cF unieq limfil.2 syl6eqr eqeq1d vx cv cF wceq
      vl cv csn cJ cnei cfv cfv vx cv wss vl cX crab vl cv csn cJ cnei cfv cfv
      cF wss vl cX crab vy cv vx cv cF wceq vl cv csn cJ cnei cfv cfv vx cv wss
      vl cv csn cJ cnei cfv cfv cF wss vl cX vx cv cF vl cv csn cJ cnei cfv cfv
      sseq2 rabbisdv eqeq2d 3anbi123d vy cv vl cv csn cJ cnei cfv cfv cF wss vl
      cX crab wceq vy cv vl cv csn cJ cnei cfv cfv cF wss vl cX crab wceq vl cv
      csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv cfv cF wss vl
      cX crab wceq cF cfil wcel cY cX wceq vy cv vl cv csn cJ cnei cfv cfv cF
      wss vl cX crab vl cv csn cJ cnei cfv cfv cF wss vl cX crab eqeq1 3anbi3d
      opelopabg vl cv csn cJ cnei cfv cfv cF wss vl cX cvv rabexg sylan2 ancoms
      cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg limfil.1 syl5eqel sylan
      3adant3 mpbird sylc eqtrd $.
      $( [1-Dec-2010] $) $( [4-Sep-2009] $)
  $}

  ${
    $d l A $. $d l F $. $d l J $. $d l X $. $d l Y $.
    isfillim.1 $e |- X = U. J $.
    isfillim.2 $e |- Y = U. F $.
    $( The predicate "is a limit point of a filter."  (Contributed by
       Jeff Hankins, 4-Sep-2009.) $)
    isfillim $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( A e. ( ( fLim1 ` J
    ) ` F ) <-> ( A e. X /\ ( ( nei ` J ) ` { A } ) C_ F ) ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cA
      vl cv csn cJ cnei cfv cfv cF wss vl cX crab wcel cA cX wcel cA csn cJ
      cnei cfv cfv cF wss wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cJ
      cflim1 cfv cfv vl cv csn cJ cnei cfv cfv cF wss vl cX crab cA cF cJ cX cY
      vl isfillim.1 isfillim.2 limfil eleq2d vl cv csn cJ cnei cfv cfv cF wss
      cA csn cJ cnei cfv cfv cF wss vl cA cX vl cv cA wceq vl cv csn cJ cnei
      cfv cfv cA csn cJ cnei cfv cfv cF vl cv cA wceq vl cv csn cA csn cJ cnei
      cfv vl cv cA sneq fveq2d sseq1d elrab syl6bb $.
      $( [1-Dec-2010] $) $( [4-Sep-2009] $)
  $}

  ${
    flimelbas.1 $e |- X = U. J $.
    flimelbas.2 $e |- Y = U. F $.
    $( A limit point of a filter belongs to its base set. (Contributed by Jeff
       Hankins, 4-Sep-2009.) $)
    flimelbas $p |- ( ( ( J e. Top /\ F e. Fil /\ X = Y ) /\ A e. ( ( fLim1 ` J
    ) ` F ) ) -> A e. X ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cA
      cX wcel cA csn cJ cnei cfv cfv cF wss cA cF cJ cX cY flimelbas.1
      flimelbas.2 isfillim pm3.26bda $.
      $( [1-Dec-2010] $) $( [4-Sep-2009] $)
  $}

  ${
    flimnei.1 $e |- X = U. J $.
    flimnei.2 $e |- Y = U. F $.
    $( A filter contains all of the neighborhoods of its limit points.
       (Contributed by Jeff Hankins, 4-Sep-2009.) $)
    flimnei $p |- ( ( ( J e. Top /\ F e. Fil /\ X = Y ) /\ A e. ( ( fLim1 ` J )
    ` F ) /\ N e. ( ( nei ` J ) ` { A } ) ) -> N e. F ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cN
      cA csn cJ cnei cfv cfv wcel cN cF wcel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cflim1 cfv cfv wcel wa cA csn cJ cnei cfv cfv cF cN cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cA cX
      wcel cA csn cJ cnei cfv cfv cF wss cA cF cJ cX cY flimnei.1 flimnei.2
      isfillim pm3.27bda sseld 3impia $.
      $( [1-Dec-2010] $) $( [4-Sep-2009] $)
  $}

  ${ $d J x y $.  $d S x y $.  $d X x y $.
    neifil.1 $e |- X = U. J $.
    $( The neighborhoods of a non empty set is a filter.  Bourbaki TG I.36,
       example 2.  (Contributed by FL, 19-Sep-2007.) $)
    neifil $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) ->
      ( ( nei ` J ) ` S ) e. Fil ) $=
      cJ ctop wcel cS cX wss cS c0 wne w3a c0 cS cJ cnei cfv cfv wcel wn cS cJ
      cnei cfv cfv cuni cS cJ cnei cfv cfv wcel wa vx cv cS cJ cnei cfv cfv
      wcel vy cv cS cJ cnei cfv cfv cuni wss vx cv vy cv wss w3a vy cv cS cJ
      cnei cfv cfv wcel wi vy wal vx wal vx cv vy cv cin cS cJ cnei cfv cfv
      wcel vy cS cJ cnei cfv cfv wral vx cS cJ cnei cfv cfv wral w3a cS cJ cnei
      cfv cfv cfil wcel cJ ctop wcel cS cX wss cS c0 wne w3a c0 cS cJ cnei cfv
      cfv wcel wn cS cJ cnei cfv cfv cuni cS cJ cnei cfv cfv wcel wa vx cv cS
      cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv cfv cuni wss vx cv vy cv wss
      w3a vy cv cS cJ cnei cfv cfv wcel wi vy wal vx wal vx cv vy cv cin cS cJ
      cnei cfv cfv wcel vy cS cJ cnei cfv cfv wral vx cS cJ cnei cfv cfv wral
      cJ ctop wcel cS cX wss cS c0 wne w3a c0 cS cJ cnei cfv cfv wcel wn cS cJ
      cnei cfv cfv cuni cS cJ cnei cfv cfv wcel cJ ctop wcel cS c0 wne c0 cS cJ
      cnei cfv cfv wcel wn cS cX wss cS cJ 0nnei 3adant2 cJ ctop wcel cS cX wss
      cS cJ cnei cfv cfv cuni cS cJ cnei cfv cfv wcel cS c0 wne cJ ctop wcel cS
      cX wss wa cS cJ cnei cfv cfv cuni cX cS cJ cnei cfv cfv cS cJ cX neifil.1
      unnei cJ ctop wcel cS cX wss cX cS cJ cnei cfv cfv wcel cS cJ cX neifil.1
      tpnei biimpa eqeltrd 3adant3 jca cJ ctop wcel cS cX wss cS c0 wne w3a vx
      cv cS cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv cfv cuni wss vx cv vy cv
      wss w3a vy cv cS cJ cnei cfv cfv wcel wi vx vy cJ ctop wcel cS cX wss vx
      cv cS cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv cfv cuni wss vx cv vy cv
      wss w3a vy cv cS cJ cnei cfv cfv wcel wi cS c0 wne cS cJ cnei cfv cfv
      cuni cX wceq cJ ctop wcel cS cX wss wa vx cv cS cJ cnei cfv cfv wcel vy
      cv cS cJ cnei cfv cfv cuni wss vx cv vy cv wss w3a vy cv cS cJ cnei cfv
      cfv wcel wi cS cJ cX neifil.1 unnei cS cJ cnei cfv cfv cuni cX wceq vx cv
      cS cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv cfv cuni wss vx cv vy cv wss
      w3a cJ ctop wcel cS cX wss wa vy cv cS cJ cnei cfv cfv wcel cS cJ cnei
      cfv cfv cuni cX wceq vx cv cS cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv
      cfv cuni wss vx cv vy cv wss cJ ctop wcel cS cX wss wa vy cv cS cJ cnei
      cfv cfv wcel wi cS cJ cnei cfv cfv cuni cX wceq vy cv cS cJ cnei cfv cfv
      cuni wss vx cv cS cJ cnei cfv cfv wcel vx cv vy cv wss cJ ctop wcel cS cX
      wss wa vy cv cS cJ cnei cfv cfv wcel wi wi cS cJ cnei cfv cfv cuni cX
      wceq vy cv cS cJ cnei cfv cfv cuni wss vy cv cX wss vx cv cS cJ cnei cfv
      cfv wcel vx cv vy cv wss cJ ctop wcel cS cX wss wa vy cv cS cJ cnei cfv
      cfv wcel wi wi wi cS cJ cnei cfv cfv cuni cX vy cv sseq2 cJ ctop wcel cS
      cX wss wa vx cv cS cJ cnei cfv cfv wcel vx cv vy cv wss vy cv cX wss vy
      cv cS cJ cnei cfv cfv wcel cJ ctop wcel vx cv cS cJ cnei cfv cfv wcel vx
      cv vy cv wss vy cv cX wss vy cv cS cJ cnei cfv cfv wcel wi wi wi cS cX
      wss cJ ctop wcel vx cv cS cJ cnei cfv cfv wcel vx cv vy cv wss vy cv cX
      wss vy cv cS cJ cnei cfv cfv wcel cS cJ vy cv vx cv cX neifil.1 ssnei2
      exp43 adantr com14 syl6bi com23 3impd com23 mpcom 3adant3 19.21aivv cJ
      ctop wcel cS cX wss cS c0 wne w3a vx cv vy cv cin cS cJ cnei cfv cfv wcel
      vx vy cS cJ cnei cfv cfv cS cJ cnei cfv cfv cJ ctop wcel cS cX wss vx cv
      cS cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv cfv wcel wa vx cv vy cv cin
      cS cJ cnei cfv cfv wcel wi cS c0 wne cJ ctop wcel vx cv cS cJ cnei cfv
      cfv wcel vy cv cS cJ cnei cfv cfv wcel vx cv vy cv cin cS cJ cnei cfv cfv
      wcel cS cJ vy cv vx cv innei 3expib 3ad2ant1 r19.21aivv 3jca cS cJ cnei
      cfv cfv cvv wcel cS cJ cnei cfv cfv cfil wcel c0 cS cJ cnei cfv cfv wcel
      wn cS cJ cnei cfv cfv cuni cS cJ cnei cfv cfv wcel wa vx cv cS cJ cnei
      cfv cfv wcel vy cv cS cJ cnei cfv cfv cuni wss vx cv vy cv wss w3a vy cv
      cS cJ cnei cfv cfv wcel wi vy wal vx wal vx cv vy cv cin cS cJ cnei cfv
      cfv wcel vy cS cJ cnei cfv cfv wral vx cS cJ cnei cfv cfv wral w3a wb cS
      cJ cnei cfv fvex vx vy cvv cS cJ cnei cfv cfv cS cJ cnei cfv cfv cuni cS
      cJ cnei cfv cfv cuni eqid isfil ax-mp sylibr $.
      $( [1-Dec-2010] $) $( [18-Sep-2007] $)
  $}

  ${
    $d f u v w x y z J $. $d f u v w x y z X $.
    hausfillim.1 $e |- X = U. J $.
    $( A condition for a topology to be Hausdorff in terms of filters. A
       topology is Hausdorff iff every filter has at most one limit point.
       (Contributed by Jeff Hankins, 5-Sep-2009.) $)
    hausfillim $p |- ( J e. Top -> ( J e. Haus <-> A. f e. Fil ( X = U. f -> E*
    x x e. ( ( fLim1 ` J ) ` f ) ) ) ) $=
      cJ ctop wcel cJ cha wcel vz cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv
      csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex wi vw cX wral
      vz cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx wmo
      wi vf cfil wral vz vw vv vu cJ cX hausfillim.1 hausnei2 cJ ctop wcel vz
      cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu
      vz cv csn cJ cnei cfv cfv wrex wi vw cX wral vz cX wral cX vf cv cuni
      wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv
      wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf cfil wral cX vf cv cuni
      wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx wmo wi vf cfil wral cJ ctop
      wcel vz cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv
      wrex vu vz cv csn cJ cnei cfv cfv wrex wi vw cX wral vz cX wral cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv
      cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf cfil wral cJ ctop
      wcel vz cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv
      wrex vu vz cv csn cJ cnei cfv cfv wrex wi vw cX wral vz cX wral cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv
      cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf cfil cJ ctop wcel vz
      cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu
      vz cv csn cJ cnei cfv cfv wrex wi vw cX wral vz cX wral vf cv cfil wcel
      cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq wa vz cv vw cv wne vu cv vv cv cin c0
      wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex
      wi vw cX wral vz cX wral vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv
      cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq vz cv vw cv wne vu cv vv cv cin c0
      wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex
      wi vw cX wral vz cX wral vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv
      cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vz cv vw cv wne vu cv vv cv
      cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv
      cfv wrex wi vw cX wral vz cX wral vx cv vf cv cJ cflim1 cfv cfv wcel vy
      cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vz cv vw cv wne vu cv vv cv
      cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv
      cfv wrex wi vw cX wral vz cX wral vx cv vf cv cJ cflim1 cfv cfv wcel vy
      cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy
      cv vf cv cJ cflim1 cfv cfv wcel wa vz cv vw cv wne vu cv vv cv cin c0
      wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex
      wi vw cX wral vz cX wral vx cv vy cv wceq cJ ctop wcel vf cv cfil wcel cX
      vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ
      cflim1 cfv cfv wcel wa vz cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv
      csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex wi vw cX wral
      vz cX wral vx cv vy cv wceq wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv
      wcel wa wa vz cv vw cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei
      cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex wi vw cX wral vz cX wral
      vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex
      vu vx cv csn cJ cnei cfv cfv wrex wi vx cv vy cv wceq cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv
      vf cv cJ cflim1 cfv cfv wcel wa wa vx cv cX wcel vy cv cX wcel wa vz cv
      vw cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz
      cv csn cJ cnei cfv cfv wrex wi vw cX wral vz cX wral vx cv vy cv wne vu
      cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ
      cnei cfv cfv wrex wi wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq
      w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel
      wa vx cv cX wcel vy cv cX wcel wa cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cX wcel vy cv vf
      cv cJ cflim1 cfv cfv wcel vy cv cX wcel cJ ctop wcel vf cv cfil wcel cX
      vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cX wcel vx
      cv vf cv cJ cX vf cv cuni hausfillim.1 vf cv cuni eqid flimelbas ex cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vy cv vf cv cJ cflim1
      cfv cfv wcel vy cv cX wcel vy cv vf cv cJ cX vf cv cuni hausfillim.1 vf
      cv cuni eqid flimelbas ex anim12d imp vz cv vw cv wne vu cv vv cv cin c0
      wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex
      wi vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv
      wrex vu vx cv csn cJ cnei cfv cfv wrex wi vx cv vw cv wne vu cv vv cv cin
      c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv
      wrex wi vz vw vx cv vy cv cX cX vz cv vx cv wceq vz cv vw cv wne vx cv vw
      cv wne vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv
      csn cJ cnei cfv cfv wrex vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv
      cfv wrex vu vx cv csn cJ cnei cfv cfv wrex vz cv vx cv vw cv neeq1 vz cv
      vx cv wceq vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu
      vz cv csn cJ cnei cfv cfv vx cv csn cJ cnei cfv cfv vz cv vx cv wceq vz
      cv csn vx cv csn cJ cnei cfv vz cv vx cv sneq fveq2d rexeq1d imbi12d vw
      cv vy cv wceq vx cv vw cv wne vx cv vy cv wne vu cv vv cv cin c0 wceq vv
      vw cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex vu cv vv
      cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv
      cfv wrex vw cv vy cv vx cv neeq2 vw cv vy cv wceq vu cv vv cv cin c0 wceq
      vv vw cv csn cJ cnei cfv cfv wrex vu cv vv cv cin c0 wceq vv vy cv csn cJ
      cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv vw cv vy cv wceq vu cv vv
      cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv vy cv csn cJ cnei cfv cfv vw
      cv vy cv wceq vw cv csn vy cv csn cJ cnei cfv vw cv vy cv sneq fveq2d
      rexeq1d rexbidv imbi12d rcla42v syl cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1
      cfv cfv wcel wa vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ
      cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi vx cv vy cv wceq
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wne vu cv
      vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei
      cfv cfv wrex wi wa wa vx cv vy cv wceq c0 vf cv wcel cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a c0 vf cv wcel wn vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wne vu cv
      vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei
      cfv cfv wrex wi wa vf cv cfil wcel cJ ctop wcel c0 vf cv wcel wn cX vf cv
      cuni wceq vf cv filesn 3ad2ant2 adantr cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1
      cfv cfv wcel wa vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ
      cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi wa wa vx cv vy cv
      wne c0 vf cv wcel vx cv vy cv wceq wn cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1
      cfv cfv wcel wa vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ
      cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi vx cv vy cv wne c0
      vf cv wcel wi vx cv vy cv wne vx cv vy cv wne vu cv vv cv cin c0 wceq vv
      vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa wa c0 vf cv wcel vx cv
      vy cv wne vx cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei
      cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex wi vu cv vv cv cin c0 wceq
      vv vy cv csn cJ cnei cfv cfv wrex vu vx cv csn cJ cnei cfv cfv wrex cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa wa c0 vf cv wcel wi vx
      cv vy cv wne vu cv vv cv cin c0 wceq vv vy cv csn cJ cnei cfv cfv wrex vu
      vx cv csn cJ cnei cfv cfv wrex pm2.27 vu cv vv cv cin c0 wceq cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv
      wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa wa c0 vf cv wcel wi vu vv vx
      cv csn cJ cnei cfv cfv vy cv csn cJ cnei cfv cfv cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf
      cv cJ cflim1 cfv cfv wcel wa wa vu cv vx cv csn cJ cnei cfv cfv wcel vv
      cv vy cv csn cJ cnei cfv cfv wcel wa vu cv vv cv cin c0 wceq c0 vf cv
      wcel cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa wa vu cv vx cv
      csn cJ cnei cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel wa vu cv vv
      cv cin c0 wceq c0 vf cv wcel cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv
      wcel wa wa vu cv vx cv csn cJ cnei cfv cfv wcel vv cv vy cv csn cJ cnei
      cfv cfv wcel wa vu cv vv cv cin c0 wceq w3a vu cv vv cv cin c0 vf cv cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa wa vu cv vx cv csn cJ
      cnei cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel wa vu cv vv cv cin
      c0 wceq 3simp3 cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv
      vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa wa vu
      cv vx cv csn cJ cnei cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel wa
      vu cv vv cv cin vf cv wcel vu cv vv cv cin c0 wceq vf cv cfil wcel vu cv
      vf cv wcel vv cv vf cv wcel vu cv vv cv cin vf cv wcel cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vy cv
      vf cv cJ cflim1 cfv cfv wcel wa wa vu cv vx cv csn cJ cnei cfv cfv wcel
      vv cv vy cv csn cJ cnei cfv cfv wcel wa wa vu cv vv cv vf cv filint cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vf cv cfil wcel vx cv vf
      cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vu cv vx
      cv csn cJ cnei cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel wa cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq 3simp2 ad2antrr cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel
      vu cv vx cv csn cJ cnei cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel
      wa vu cv vf cv wcel vy cv vf cv cJ cflim1 cfv cfv wcel cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel wa vu
      cv vx cv csn cJ cnei cfv cfv wcel vu cv vf cv wcel vv cv vy cv csn cJ
      cnei cfv cfv wcel cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx
      cv vf cv cJ cflim1 cfv cfv wcel vu cv vx cv csn cJ cnei cfv cfv wcel vu
      cv vf cv wcel vx cv vf cv cJ vu cv cX vf cv cuni hausfillim.1 vf cv cuni
      eqid flimnei 3expa adantrr adantlrr cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vy cv vf cv cJ cflim1 cfv cfv wcel vu cv vx cv csn cJ cnei
      cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel wa vv cv vf cv wcel vx
      cv vf cv cJ cflim1 cfv cfv wcel cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vy cv vf cv cJ cflim1 cfv cfv wcel wa vv cv vy cv csn cJ
      cnei cfv cfv wcel vv cv vf cv wcel vu cv vx cv csn cJ cnei cfv cfv wcel
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vy cv vf cv cJ cflim1
      cfv cfv wcel vv cv vy cv csn cJ cnei cfv cfv wcel vv cv vf cv wcel vy cv
      vf cv cJ vv cv cX vf cv cuni hausfillim.1 vf cv cuni eqid flimnei 3expa
      adantrl adantlrl syl3anc 3adant3 eqeltrrd 3exp com3l r19.23aivv syl6
      com13 impr vx cv vy cv df-ne syl5ibr mt3d expr syld ex com23 19.21adv
      19.21adv 3expib com23 exp4a r19.21adv cJ ctop wcel cX vf cv cuni wceq vx
      cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx
      cv vy cv wceq wi vy wal vx wal wi vf cfil wral vz cv vw cv wne vu cv vv
      cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv
      cfv wrex wi vz vw cX cX cJ ctop wcel vz cv vw cv wne vz cv cX wcel vw cv
      cX wcel wa cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf
      cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf cfil
      wral vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv
      csn cJ cnei cfv cfv wrex cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv
      vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf
      cfil wral vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz
      cv csn cJ cnei cfv cfv wrex wi cJ ctop wcel vz cv cX wcel vw cv cX wcel
      wa vz cv vw cv wne cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel
      vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal
      wi vf cfil wral vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex
      vu vz cv csn cJ cnei cfv cfv wrex wi cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei
      cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex cX vf cv cuni wceq vx cv
      vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv
      vy cv wceq wi vy wal vx wal wi vf cfil wral cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cX vf cv cuni wceq
      vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa
      vx cv vy cv wceq wi vy wal vx wal wi vf cfil wral wn vu cv vv cv cin c0
      wceq vv vw cv csn cJ cnei cfv cfv wrex vu vz cv csn cJ cnei cfv cfv wrex
      wn cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel
      vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex vx
      wex wa vf cfil wrex cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel
      vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal
      wi vf cfil wral wn cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw
      cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral
      vu vz cv csn cJ cnei cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vf cv cuni wceq vx cv vf cv
      cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wn wa vy wex vx wex wa vf cfil wrex cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0
      wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wa vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cfil wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv
      vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv wnel wa cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ
      cnei cfv cfv c0 wne vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun c0 wne cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne
      w3a vz cv csn cJ cnei cfv cfv c0 wne vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a cX vz cv csn cJ cnei
      cfv cfv wcel vz cv csn cJ cnei cfv cfv c0 wne cJ ctop wcel vz cv cX wcel
      vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cX wss cX vz cv csn cJ
      cnei cfv cfv wcel vz cv cX wcel vw cv cX wcel wa cJ ctop wcel vz cv csn
      cX wss vz cv vw cv wne vz cv cX wcel vz cv csn cX wss vw cv cX wcel vz cv
      cX snssi adantr 3ad2ant2 cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz
      cv csn cX wss cX vz cv csn cJ cnei cfv cfv wcel wb vz cv vw cv wne vz cv
      csn cJ cX hausfillim.1 tpnei 3ad2ant1 mpbid vz cv csn cJ cnei cfv cfv cX
      ne0i syl adantr vz cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun wss vz cv csn cJ cnei cfv cfv c0 wne vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv ssun1 vz cv csn cJ cnei cfv cfv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun ssn0 mpan syl cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0
      wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wa c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz
      cv csn cJ cnei cfv cfv wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne w3a vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral vu cv vv cv cin c0 wne vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vu cv vv cv
      cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv
      cfv wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a
      vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral pm3.27 vu cv vv cv cin c0 wne vu cv vv cv cin c0 wceq
      wn vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv vu cv vv cv
      cin c0 df-ne 2ralbii sylan2br cJ ctop wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne w3a c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wb vu cv vv cv cin c0 wceq wn vv
      vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cJ ctop
      wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cJ cnei
      cfv cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa c0 vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel vu cv vv cv
      cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wb cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv csn cJ cnei cfv
      cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa vz cv vw cv wne cJ
      ctop wcel vz cv cX wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv
      cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX
      wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv cfil wcel vz cv csn cJ
      cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX wcel vz cv csn cJ cnei cfv
      cfv cfil wcel vw cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv csn cJ
      cnei cfv cfv cfil wcel vz cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv
      csn c0 wne vz cv csn cJ cnei cfv cfv cfil wcel vz cv vz visset snnz vz cv
      csn cJ cX hausfillim.1 neifil mp3an3 vz cv cX snssi sylan2 adantrr vz cv
      csn cJ cnei cfv cfv filfbas syl cJ ctop wcel vw cv cX wcel vw cv csn cJ
      cnei cfv cfv cfbas wcel vz cv cX wcel cJ ctop wcel vw cv cX wcel wa vw cv
      csn cJ cnei cfv cfv cfil wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ
      ctop wcel vw cv csn cX wss vw cv csn cJ cnei cfv cfv cfil wcel vw cv cX
      wcel cJ ctop wcel vw cv csn cX wss vw cv csn c0 wne vw cv csn cJ cnei cfv
      cfv cfil wcel vw cv vw visset snnz vw cv csn cJ cX hausfillim.1 neifil
      mp3an3 vw cv cX snssi sylan2 vw cv csn cJ cnei cfv cfv filfbas syl
      adantrl jca 3adant3 vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv fbunfip syl adantr mpbird jca cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv wnel wa wb vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cvv wcel cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv fvex vw cv csn cJ
      cnei cfv fvex unex a1i vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cvv fsubbas syl mpbird vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv fgfil syl ex cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vf cv cuni
      wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv
      wcel wa vx cv vy cv wceq wn wa vy wex vx wex wa vf cfil wrex wi vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel
      cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv
      cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei
      cfv cfv wral wa cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy
      cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex vx wex
      wa vf cfil wrex vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cfil wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wa cX vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vx cv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv
      cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex
      vx wex wa cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf
      cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex vx wex wa vf
      cfil wrex vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv cfil wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv
      wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu
      vz cv csn cJ cnei cfv cfv wral wa wa cX vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vx cv vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv
      wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex vx
      wex cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral wa cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa cX vz cv csn cJ
      cnei cfv cfv cuni vw cv csn cJ cnei cfv cfv cuni cun vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a cX vz cv csn cJ cnei
      cfv cfv cuni vw cv csn cJ cnei cfv cfv cuni cun wceq vu cv vv cv cin c0
      wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa cX vz cv csn cJ cnei cfv
      cfv cuni vw cv csn cJ cnei cfv cfv cuni cun wceq vz cv vw cv wne cJ ctop
      wcel vz cv cX wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv cuni vw
      cv csn cJ cnei cfv cfv cuni cun cX cX cun cX cJ ctop wcel vz cv cX wcel
      vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv cuni cX vw cv csn cJ cnei
      cfv cfv cuni cX cJ ctop wcel vz cv cX wcel vz cv csn cJ cnei cfv cfv cuni
      cX wceq vw cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv csn cJ cnei cfv
      cfv cuni cX wceq vz cv cX wcel vz cv csn cJ cX hausfillim.1 unnei vz cv
      cX snssi sylan2 adantrr cJ ctop wcel vw cv cX wcel vw cv csn cJ cnei cfv
      cfv cuni cX wceq vz cv cX wcel cJ ctop wcel vw cv csn cX wss vw cv csn cJ
      cnei cfv cfv cuni cX wceq vw cv cX wcel vw cv csn cJ cX hausfillim.1
      unnei vw cv cX snssi sylan2 adantrl uneq12d cX unidm syl6req 3adant3
      adantr cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu
      cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv cfv cuni vw cv csn cJ cnei
      cfv cfv cuni cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cuni wceq cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv wnel wa cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ
      cnei cfv cfv c0 wne vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun c0 wne cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne
      w3a vz cv csn cJ cnei cfv cfv c0 wne vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a cX vz cv csn cJ cnei
      cfv cfv wcel vz cv csn cJ cnei cfv cfv c0 wne cJ ctop wcel vz cv cX wcel
      vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cX wss cX vz cv csn cJ
      cnei cfv cfv wcel vz cv cX wcel vw cv cX wcel wa cJ ctop wcel vz cv csn
      cX wss vz cv vw cv wne vz cv cX wcel vz cv csn cX wss vw cv cX wcel vz cv
      cX snssi adantr 3ad2ant2 cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz
      cv csn cX wss cX vz cv csn cJ cnei cfv cfv wcel wb vz cv vw cv wne vz cv
      csn cJ cX hausfillim.1 tpnei 3ad2ant1 mpbid vz cv csn cJ cnei cfv cfv cX
      ne0i syl adantr vz cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun wss vz cv csn cJ cnei cfv cfv c0 wne vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv ssun1 vz cv csn cJ cnei cfv cfv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun ssn0 mpan syl cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0
      wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wa c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz
      cv csn cJ cnei cfv cfv wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne w3a vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral vu cv vv cv cin c0 wne vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vu cv vv cv
      cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv
      cfv wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a
      vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral pm3.27 vu cv vv cv cin c0 wne vu cv vv cv cin c0 wceq
      wn vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv vu cv vv cv
      cin c0 df-ne 2ralbii sylan2br cJ ctop wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne w3a c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wb vu cv vv cv cin c0 wceq wn vv
      vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cJ ctop
      wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cJ cnei
      cfv cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa c0 vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel vu cv vv cv
      cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wb cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv csn cJ cnei cfv
      cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa vz cv vw cv wne cJ
      ctop wcel vz cv cX wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv
      cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX
      wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv cfil wcel vz cv csn cJ
      cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX wcel vz cv csn cJ cnei cfv
      cfv cfil wcel vw cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv csn cJ
      cnei cfv cfv cfil wcel vz cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv
      csn c0 wne vz cv csn cJ cnei cfv cfv cfil wcel vz cv vz visset snnz vz cv
      csn cJ cX hausfillim.1 neifil mp3an3 vz cv cX snssi sylan2 adantrr vz cv
      csn cJ cnei cfv cfv filfbas syl cJ ctop wcel vw cv cX wcel vw cv csn cJ
      cnei cfv cfv cfbas wcel vz cv cX wcel cJ ctop wcel vw cv cX wcel wa vw cv
      csn cJ cnei cfv cfv cfil wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ
      ctop wcel vw cv csn cX wss vw cv csn cJ cnei cfv cfv cfil wcel vw cv cX
      wcel cJ ctop wcel vw cv csn cX wss vw cv csn c0 wne vw cv csn cJ cnei cfv
      cfv cfil wcel vw cv vw visset snnz vw cv csn cJ cX hausfillim.1 neifil
      mp3an3 vw cv cX snssi sylan2 vw cv csn cJ cnei cfv cfv filfbas syl
      adantrl jca 3adant3 vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv fbunfip syl adantr mpbird jca cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv wnel wa wb vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cvv wcel cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv fvex vw cv csn cJ
      cnei cfv fvex unex a1i vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cvv fsubbas syl mpbird vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv cuni vw cv csn cJ cnei
      cfv cfv cuni cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cvv wcel vz cv csn cJ cnei cfv cfv cuni vw cv csn cJ cnei cfv cfv cuni
      cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cuni
      wceq vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv vz cv csn cJ
      cnei cfv fvex vw cv csn cJ cnei cfv fvex unex vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cuni vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cuni vz cv csn cJ cnei cfv cfv cuni vw cv csn cJ cnei
      cfv cfv cuni cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cvv fiuni vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv uniun
      syl5eqr ax-mp fgbas syl eqtrd adantl vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cJ ctop wcel vz cv cX wcel
      vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa cX vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni
      wceq vx cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cJ cflim1 cfv cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv
      vy cv wceq wn wa vy wex vx wex vz cv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vw cv vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ
      cflim1 cfv cfv wcel vz cv vw cv wceq wn vx cv vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vy
      cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex vx wex vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil
      wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu
      cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral wa wa cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cuni wceq wa vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cJ ctop wcel vz cv cX
      wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv
      vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa cX
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cuni wceq vz cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni
      wceq vz cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cJ cflim1 cfv cfv wcel wi cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq
      vz cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel wi wi cJ ctop wcel vz cv cX wcel vw cv cX wcel
      wa vz cv vw cv wne w3a cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cfil wcel vu cv vv cv cin c0 wceq wn vv
      vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv vz
      cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ
      cflim1 cfv cfv wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw
      cv wne w3a vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv
      cfv wcel wi cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cuni wceq vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      wi wi wi cJ ctop wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cfil wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv wral vz cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      wi cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cuni wceq vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral vz cv vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wi wi
      cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq vz cv cX wcel vw cv cX wcel wa vz cv vw
      cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu
      vz cv csn cJ cnei cfv cfv wral vz cv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cJ ctop wcel
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cuni wceq w3a vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne
      wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv
      csn cJ cnei cfv cfv wral wa wa vz cv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vz cv cX wcel
      vz cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv wss wa cJ ctop wcel vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv
      cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv
      vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa vz
      cv cX wcel vz cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv wss vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne wa vz cv cX wcel cJ ctop wcel vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral vz cv cX wcel vw cv cX wcel vz cv vw cv wne simpll
      ad2antrl cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa vz cv csn cJ
      cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv vz cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv wss cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX
      wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw
      cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa vz cv
      csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv ssun1 vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv wss vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv vz cv csn cJ cnei cfv fvex vw cv csn cJ cnei cfv fvex unex vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cvv abfi2 ax-mp sstri a1i
      cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv wss cJ ctop wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel vz cv cX wcel
      vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss wi cX vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq
      cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv
      cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei
      cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv wss cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv wss wi cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv
      wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu
      vz cv csn cJ cnei cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv wss cJ ctop wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel wa cJ ctop wcel vz cv
      cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn
      vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz
      cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0
      wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wa vz cv csn cJ cnei cfv cfv c0 wne vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun c0 wne cJ ctop wcel vz cv cX wcel vw cv cX wcel
      wa vz cv vw cv wne w3a vz cv csn cJ cnei cfv cfv c0 wne vu cv vv cv cin
      c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a cX
      vz cv csn cJ cnei cfv cfv wcel vz cv csn cJ cnei cfv cfv c0 wne cJ ctop
      wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cX wss
      cX vz cv csn cJ cnei cfv cfv wcel vz cv cX wcel vw cv cX wcel wa cJ ctop
      wcel vz cv csn cX wss vz cv vw cv wne vz cv cX wcel vz cv csn cX wss vw
      cv cX wcel vz cv cX snssi adantr 3ad2ant2 cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv csn cX wss cX vz cv csn cJ cnei cfv cfv wcel wb vz cv
      vw cv wne vz cv csn cJ cX hausfillim.1 tpnei 3ad2ant1 mpbid vz cv csn cJ
      cnei cfv cfv cX ne0i syl adantr vz cv csn cJ cnei cfv cfv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun wss vz cv csn cJ cnei cfv cfv
      c0 wne vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne vz
      cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv ssun1 vz cv csn cJ cnei
      cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun ssn0 mpan
      syl cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral wa c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wne vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vu cv vv cv cin c0
      wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral
      vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn
      cJ cnei cfv cfv wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw
      cv wne w3a vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz
      cv csn cJ cnei cfv cfv wral pm3.27 vu cv vv cv cin c0 wne vu cv vv cv cin
      c0 wceq wn vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv vu
      cv vv cv cin c0 df-ne 2ralbii sylan2br cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei
      cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wb vu cv vv cv cin c0 wceq
      wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cJ
      ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cJ
      cnei cfv cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa c0 vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel vu cv vv
      cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv
      cfv wral wb cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv csn cJ cnei
      cfv cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa vz cv vw cv
      wne cJ ctop wcel vz cv cX wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv
      cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX
      wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv cfil wcel vz cv csn cJ
      cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX wcel vz cv csn cJ cnei cfv
      cfv cfil wcel vw cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv csn cJ
      cnei cfv cfv cfil wcel vz cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv
      csn c0 wne vz cv csn cJ cnei cfv cfv cfil wcel vz cv vz visset snnz vz cv
      csn cJ cX hausfillim.1 neifil mp3an3 vz cv cX snssi sylan2 adantrr vz cv
      csn cJ cnei cfv cfv filfbas syl cJ ctop wcel vw cv cX wcel vw cv csn cJ
      cnei cfv cfv cfbas wcel vz cv cX wcel cJ ctop wcel vw cv cX wcel wa vw cv
      csn cJ cnei cfv cfv cfil wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ
      ctop wcel vw cv csn cX wss vw cv csn cJ cnei cfv cfv cfil wcel vw cv cX
      wcel cJ ctop wcel vw cv csn cX wss vw cv csn c0 wne vw cv csn cJ cnei cfv
      cfv cfil wcel vw cv vw visset snnz vw cv csn cJ cX hausfillim.1 neifil
      mp3an3 vw cv cX snssi sylan2 vw cv csn cJ cnei cfv cfv filfbas syl
      adantrl jca 3adant3 vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv fbunfip syl adantr mpbird jca cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv wnel wa wb vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cvv wcel cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv fvex vw cv csn cJ
      cnei cfv fvex unex a1i vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cvv fsubbas syl mpbird vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv fbssfg syl ex 3expib imp3a 3ad2ant1 imp sstrd
      jca cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vz
      cv cX wcel vz cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv wss wa wb vz cv cX wcel vw cv cX wcel
      wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cX vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni hausfillim.1
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cuni eqid isfillim adantr mpbird exp520 com23 com24 3impib com23 com24
      imp impcom imp vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cfil wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wa wa cX vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vw cv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne
      w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv
      csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vw cv vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv
      wcel wi cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a
      vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn
      cJ cnei cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vw cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      wi wi cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a cX
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cuni wceq vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv cfil wcel vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral vw cv vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cJ ctop
      wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni
      wceq vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz
      cv csn cJ cnei cfv cfv wral vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wi cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vu
      cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wi wi wi cJ ctop wcel cX
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cuni wceq vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv cfil wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wi cJ ctop wcel vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel
      cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cuni wceq vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv
      cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei
      cfv cfv wral vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wi wi cJ ctop wcel vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel
      cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cuni wceq vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv
      cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei
      cfv cfv wral vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cJ ctop wcel vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni
      wceq w3a vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv
      cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv
      cfv wral wa wa vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vw cv cX wcel vw cv csn cJ
      cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv wss wa cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX wcel
      vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa vw cv cX
      wcel vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv wss vz cv cX wcel vw cv cX wcel wa vz cv
      vw cv wne wa vw cv cX wcel cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral vz cv cX wcel vw cv cX wcel vz cv vw cv wne simplr
      ad2antrl cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa vw cv csn cJ
      cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv wss cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX
      wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw
      cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa wa vw cv
      csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv vw cv
      csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv ssun2 vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv wss vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv vz cv csn cJ cnei cfv fvex vw cv csn cJ cnei cfv fvex unex vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cvv abfi2 ax-mp sstri a1i
      cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cuni wceq w3a vz cv cX wcel vw cv cX wcel wa vz
      cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv wss cJ ctop wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel vz cv cX wcel
      vw cv cX wcel wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss wi cX vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq
      cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne wa vu cv vv
      cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei
      cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv wss cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv wss wi cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv
      wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu
      vz cv csn cJ cnei cfv cfv wral vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv wss cJ ctop wcel vz cv cX wcel vw cv cX wcel wa
      vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn
      cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel wa cJ ctop wcel vz cv
      cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn
      vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz
      cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel
      vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0
      wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral wa vz cv csn cJ cnei cfv cfv c0 wne vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun c0 wne cJ ctop wcel vz cv cX wcel vw cv cX wcel
      wa vz cv vw cv wne w3a vz cv csn cJ cnei cfv cfv c0 wne vu cv vv cv cin
      c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv
      wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a cX
      vz cv csn cJ cnei cfv cfv wcel vz cv csn cJ cnei cfv cfv c0 wne cJ ctop
      wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cX wss
      cX vz cv csn cJ cnei cfv cfv wcel vz cv cX wcel vw cv cX wcel wa cJ ctop
      wcel vz cv csn cX wss vz cv vw cv wne vz cv cX wcel vz cv csn cX wss vw
      cv cX wcel vz cv cX snssi adantr 3ad2ant2 cJ ctop wcel vz cv cX wcel vw
      cv cX wcel wa vz cv csn cX wss cX vz cv csn cJ cnei cfv cfv wcel wb vz cv
      vw cv wne vz cv csn cJ cX hausfillim.1 tpnei 3ad2ant1 mpbid vz cv csn cJ
      cnei cfv cfv cX ne0i syl adantr vz cv csn cJ cnei cfv cfv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun wss vz cv csn cJ cnei cfv cfv
      c0 wne vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun c0 wne vz
      cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv ssun1 vz cv csn cJ cnei
      cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun ssn0 mpan
      syl cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vu cv
      vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ
      cnei cfv cfv wral wa c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wne vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral vu cv vv cv cin c0
      wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral
      vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn
      cJ cnei cfv cfv wral cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw
      cv wne w3a vu cv vv cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz
      cv csn cJ cnei cfv cfv wral pm3.27 vu cv vv cv cin c0 wne vu cv vv cv cin
      c0 wceq wn vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv vu
      cv vv cv cin c0 df-ne 2ralbii sylan2br cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a c0 vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv wnel vu cv vv cv cin c0 wne vv vw cv csn cJ cnei
      cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wb vu cv vv cv cin c0 wceq
      wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral cJ
      ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz cv csn cJ
      cnei cfv cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa c0 vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv wnel vu cv vv
      cv cin c0 wne vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei cfv
      cfv wral wb cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv csn cJ cnei
      cfv cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel wa vz cv vw cv
      wne cJ ctop wcel vz cv cX wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv
      cfv cfbas wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX
      wcel vw cv cX wcel wa wa vz cv csn cJ cnei cfv cfv cfil wcel vz cv csn cJ
      cnei cfv cfv cfbas wcel cJ ctop wcel vz cv cX wcel vz cv csn cJ cnei cfv
      cfv cfil wcel vw cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv csn cJ
      cnei cfv cfv cfil wcel vz cv cX wcel cJ ctop wcel vz cv csn cX wss vz cv
      csn c0 wne vz cv csn cJ cnei cfv cfv cfil wcel vz cv vz visset snnz vz cv
      csn cJ cX hausfillim.1 neifil mp3an3 vz cv cX snssi sylan2 adantrr vz cv
      csn cJ cnei cfv cfv filfbas syl cJ ctop wcel vw cv cX wcel vw cv csn cJ
      cnei cfv cfv cfbas wcel vz cv cX wcel cJ ctop wcel vw cv cX wcel wa vw cv
      csn cJ cnei cfv cfv cfil wcel vw cv csn cJ cnei cfv cfv cfbas wcel cJ
      ctop wcel vw cv csn cX wss vw cv csn cJ cnei cfv cfv cfil wcel vw cv cX
      wcel cJ ctop wcel vw cv csn cX wss vw cv csn c0 wne vw cv csn cJ cnei cfv
      cfv cfil wcel vw cv vw visset snnz vw cv csn cJ cX hausfillim.1 neifil
      mp3an3 vw cv cX snssi sylan2 vw cv csn cJ cnei cfv cfv filfbas syl
      adantrl jca 3adant3 vu vv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv fbunfip syl adantr mpbird jca cJ ctop wcel vz cv cX wcel vw cv cX
      wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cvv wcel vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfbas wcel vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun c0 wne c0 vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv wnel wa wb vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cvv wcel cJ ctop wcel vz cv cX wcel vw cv
      cX wcel wa vz cv vw cv wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ
      cnei cfv cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv fvex vw cv csn cJ
      cnei cfv fvex unex a1i vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cvv fsubbas syl mpbird vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv fbssfg syl ex 3expib imp3a 3ad2ant1 imp sstrd
      jca cJ ctop wcel vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cfil wcel cX vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cuni wceq w3a vw cv vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vw
      cv cX wcel vw cv csn cJ cnei cfv cfv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv wss wa wb vz cv cX wcel vw cv cX wcel
      wa vz cv vw cv wne wa vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv wral wa vw cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cX vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni hausfillim.1
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cuni eqid isfillim adantr mpbird exp520 com23 com24 3impib com23 com24
      imp impcom imp cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv
      wne w3a vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu
      vz cv csn cJ cnei cfv cfv wral wa vz cv vw cv wceq wn vz cv csn cJ cnei
      cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni
      wceq cJ ctop wcel vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne w3a vz
      cv vw cv wceq wn vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv
      wral vu vz cv csn cJ cnei cfv cfv wral vz cv vw cv wne cJ ctop wcel vz cv
      vw cv wceq wn vz cv cX wcel vw cv cX wcel wa vz cv vw cv wne vz cv vw cv
      wceq wn vz cv vw cv df-ne biimpi 3ad2ant3 adantr ad2antlr vx cv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vz
      cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vz cv vw cv
      wceq wn wa vx vy vz cv vw cv vz visset vw visset vx cv vz cv wceq vx cv
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cJ cflim1 cfv cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn
      wa vz cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv cJ cflim1 cfv cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vz cv vy cv
      wceq wn wa vy cv vw cv wceq vz cv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vw cv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel wa vz cv vw cv wceq wn wa vx cv vz cv wceq vx cv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vz cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn vz cv vy cv wceq wn vx
      cv vz cv wceq vx cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vz cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel vx cv vz cv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv eleq1 anbi1d vx
      cv vz cv wceq vx cv vy cv wceq vz cv vy cv wceq vx cv vz cv vy cv eqeq1
      notbid anbi12d vy cv vw cv wceq vz cv vz cv csn cJ cnei cfv cfv vw cv csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vy cv vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ
      cflim1 cfv cfv wcel wa vz cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vw cv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv
      cfv wcel wa vz cv vy cv wceq wn vz cv vw cv wceq wn vy cv vw cv wceq vy
      cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vz cv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel vy cv vw cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv eleq1 anbi2d vy cv vw cv wceq
      vz cv vy cv wceq vz cv vw cv wceq vy cv vw cv vz cv eqeq2 notbid anbi12d
      sylan9bb cla42ev sylan31c ex jcai cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wn wa vy wex vx wex wa cX vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vx cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex vx wex wa vf
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cfil vf cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv wceq cX vf cv cuni wceq cX vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa
      vy wex vx wex vx cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vy cv vz cv csn cJ cnei cfv
      cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel
      wa vx cv vy cv wceq wn wa vy wex vx wex vf cv vz cv csn cJ cnei cfv cfv
      vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv wceq vf cv cuni vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni cX vf
      cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv unieq eqeq2d vf cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf
      cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vx cv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv
      cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vx vy vf
      cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv
      wcel wa vx cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cJ cflim1 cfv cfv wcel vy cv vz cv csn cJ cnei cfv cfv vw cv
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel wa vx cv
      vy cv wceq wn vf cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv vz cv
      csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel vy cv vz cv csn cJ
      cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv
      cfv wcel vf cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv wceq vf cv cJ cflim1 cfv cfv vz cv csn cJ cnei cfv cfv vw
      cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv vx cv vf cv
      vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cJ cflim1 cfv fveq2 eleq2d vf cv vz cv csn cJ cnei cfv cfv vw cv csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv wceq vf cv cJ cflim1 cfv cfv vz cv csn
      cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv vy cv vf cv vz cv csn cJ cnei cfv cfv vw cv csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cJ cflim1 cfv fveq2 eleq2d anbi12d anbi1d 2exbidv
      anbi12d rcla4ev syldan expcom ex mpdd cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wn wa vy wex vx wex wa vf cfil wrex cX vf cv cuni wceq vx cv vf cv
      cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wi vy wal vx wal wi wn vf cfil wrex cX vf cv cuni wceq vx cv vf cv
      cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wi vy wal vx wal wi vf cfil wral wn cX vf cv cuni wceq vx cv vf cv
      cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wn wa vy wex vx wex wa cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv
      cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal
      vx wal wi wn vf cfil cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv
      wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wn wa vy wex
      vx wex wa cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf
      cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wn wa cX
      vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1
      cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi wn vx cv vf cv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wn wa vy wex vx wex vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv
      cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wn cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv
      cfv wcel wa vx cv vy cv wceq wn wa vy wex vx wex vx cv vf cv cJ cflim1
      cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy
      wal wn vx wex vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1
      cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wn vx cv vf cv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq wn wa vy wex vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal wn vx vx cv vf cv cJ
      cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv wcel wa vx cv vy cv
      wceq vy exanali exbii vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx exnal bitri anbi2i
      cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal annim bitri
      rexbii cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv
      cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf cfil
      rexnal bitri syl6ib vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv
      wrex vu vz cv csn cJ cnei cfv cfv wrex wn vu cv vv cv cin c0 wceq vv vw
      cv csn cJ cnei cfv cfv wrex wn vu vz cv csn cJ cnei cfv cfv wral vu cv vv
      cv cin c0 wceq wn vv vw cv csn cJ cnei cfv cfv wral vu vz cv csn cJ cnei
      cfv cfv wral vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv wrex vu
      vz cv csn cJ cnei cfv cfv ralnex vu cv vv cv cin c0 wceq vv vw cv csn cJ
      cnei cfv cfv wrex wn vu cv vv cv cin c0 wceq wn vv vw cv csn cJ cnei cfv
      cfv wral vu vz cv csn cJ cnei cfv cfv vu cv vv cv cin c0 wceq wn vv vw cv
      csn cJ cnei cfv cfv wral vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv
      cfv wrex wn vu cv vv cv cin c0 wceq vv vw cv csn cJ cnei cfv cfv ralnex
      bicomi ralbii bitr3i syl5ib con4d 3exp com23 com24 r19.21advv impbid cX
      vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx wmo wi cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv
      cfv wcel wa vx cv vy cv wceq wi vy wal vx wal wi vf cfil vx cv vf cv cJ
      cflim1 cfv cfv wcel vx wmo vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv
      cJ cflim1 cfv cfv wcel wa vx cv vy cv wceq wi vy wal vx wal cX vf cv cuni
      wceq vx cv vf cv cJ cflim1 cfv cfv wcel vy cv vf cv cJ cflim1 cfv cfv
      wcel vx vy vx cv vy cv vf cv cJ cflim1 cfv cfv eleq1 mo4 imbi2i ralbii
      syl6bbr bitrd $.
      $( [1-Dec-2010] $) $( [5-Sep-2009] $)
  $}


  $c FilMap $.
  $( Extend class definition to include the neighborhood filter mapping
  function. $)
  cfilmap $a class FilMap $.

  $c fLimf $.
  $( Extend class definition to include the function for filter-based function
  limits. $)
  cflimf $a class fLimf $.

  $c fClus $.
  $( Extend class definition to include the cluster point function on filters.
  $)
  cfclus $a class fClus $.

  $c fClusf $.
  $( Extend class definition to include the function for cluster points of a
  function. $)
  cfclusf $a class fClusf $.

  ${
    $d f s t w x y z $.
    $( Define a function that takes a filter to a neighborhood filter of the
    range.  (Contributed by Jeff Hankins, 5-Sep-2009.) $)
    df-filmap $a |- FilMap = { <. <. x , y >. , z >. | ( y e. fBas
    /\ z = { <. f , s >. | ( f : U. y --> x /\ s = ( filGen ` ( { w | E. t e. y
    w = ( f " t ) } u. { x } ) ) ) } ) } $.
  $}

  ${
    $d f s A $. $d f s t w x y z B $. $d f s x y z X $. $d f s x y z
    Y $.
    filmapf.1 $e |- Y = U. B $.
    $( Given a function from a filtered set to a topology, return the filter of
       supersets of images of filter elements. (Contributed by Jeff Hankins,
       5-Sep-2009.) $)
    filmapf $p |- ( ( X e. A /\ B e. fBas ) -> ( X FilMap B ) = { <. f , s >.
    | ( f : Y --> X /\ s = ( filGen ` ( { w | E. t e. B w = ( f " t ) } u. { X
    } ) ) ) } ) $=
      cX cA wcel cB cfbas wcel cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq
      vt cB wrex vw cab cX csn cun cfg cfv wceq wa vf vs copab cvv wcel cX cB
      cfilmap co cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv wceq wa vf vs copab wceq cX cA wcel cB cfbas wcel
      wa cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX
      csn cun cfg cfv wceq wa vf vs copab vf cv cX cY cm co wcel vs cv vw cv vf
      cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa vf vs
      copab cvv cX cA wcel cB cfbas wcel wa vf cv cX cY cm co wcel vs cv vw cv
      vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa cY cX
      vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun
      cfg cfv wceq wa vf vs cX cA wcel cB cfbas wcel wa vf cv cX cY cm co wcel
      cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn
      cun cfg cfv wceq cX cA wcel cY cvv wcel vf cv cX cY cm co wcel cY cX vf
      cv wf wb cB cfbas wcel cX cY vf cv cA cvv elmapg cB cfbas wcel cB cuni
      cvv cY cB cfbas uniexg filmapf.1 syl5eqel sylan2 anbi1d opabbidv vf vs cX
      cY cm co vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv
      cX cY cm oprex opabex2 syl6eqelr cX cvv wcel cB cfbas wcel cY cX vf cv wf
      vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv
      wceq wa vf vs copab cvv wcel cX cB cfilmap co cY cX vf cv wf vs cv vw cv
      vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa vf vs
      copab wceq cX cA wcel vx vy vz cX cB cvv cfbas vy cv cuni vx cv vf cv wf
      vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab vx cv csn cun cfg
      cfv wceq wa vf vs copab cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq
      vt cB wrex vw cab cX csn cun cfg cfv wceq wa vf vs copab cfilmap vy cv
      cuni cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab
      cX csn cun cfg cfv wceq wa vf vs copab cvv vx cv cX wceq vy cv cuni vx cv
      vf cv wf vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab vx cv csn
      cun cfg cfv wceq wa vy cv cuni cX vf cv wf vs cv vw cv vf cv vt cv cima
      wceq vt vy cv wrex vw cab cX csn cun cfg cfv wceq wa vf vs vx cv cX wceq
      vy cv cuni vx cv vf cv wf vy cv cuni cX vf cv wf vs cv vw cv vf cv vt cv
      cima wceq vt vy cv wrex vw cab vx cv csn cun cfg cfv wceq vs cv vw cv vf
      cv vt cv cima wceq vt vy cv wrex vw cab cX csn cun cfg cfv wceq vx cv cX
      vy cv cuni vf cv feq3 vx cv cX wceq vw cv vf cv vt cv cima wceq vt vy cv
      wrex vw cab vx cv csn cun cfg cfv vw cv vf cv vt cv cima wceq vt vy cv
      wrex vw cab cX csn cun cfg cfv vs cv vx cv cX wceq vw cv vf cv vt cv cima
      wceq vt vy cv wrex vw cab vx cv csn cun vw cv vf cv vt cv cima wceq vt vy
      cv wrex vw cab cX csn cun cfg vx cv cX wceq vx cv csn cX csn vw cv vf cv
      vt cv cima wceq vt vy cv wrex vw cab vx cv cX sneq uneq2d fveq2d eqeq2d
      anbi12d opabbidv vy cv cB wceq vy cv cuni cX vf cv wf vs cv vw cv vf cv
      vt cv cima wceq vt vy cv wrex vw cab cX csn cun cfg cfv wceq wa cY cX vf
      cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg
      cfv wceq wa vf vs vy cv cB wceq vy cv cuni cX vf cv wf cY cX vf cv wf vs
      cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab cX csn cun cfg cfv
      wceq vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg
      cfv wceq vy cv cB wceq vy cv cuni cY wceq vy cv cuni cX vf cv wf cY cX vf
      cv wf wb vy cv cB wceq vy cv cuni cB cuni cY vy cv cB unieq filmapf.1
      syl6eqr vy cv cuni cY cX vf cv feq2 syl vy cv cB wceq vw cv vf cv vt cv
      cima wceq vt vy cv wrex vw cab cX csn cun cfg cfv vw cv vf cv vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg cfv vs cv vy cv cB wceq vw cv vf cv
      vt cv cima wceq vt vy cv wrex vw cab cX csn cun vw cv vf cv vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg vy cv cB wceq vw cv vf cv vt cv
      cima wceq vt vy cv wrex vw cab vw cv vf cv vt cv cima wceq vt cB wrex vw
      cab cX csn vy cv cB wceq vw cv vf cv vt cv cima wceq vt vy cv wrex vw cv
      vf cv vt cv cima wceq vt cB wrex vw vw cv vf cv vt cv cima wceq vt vy cv
      cB rexeq1 abbidv uneq1d fveq2d eqeq2d anbi12d opabbidv cfilmap vy cv
      cfbas wcel vz cv vy cv cuni vx cv vf cv wf vs cv vw cv vf cv vt cv cima
      wceq vt vy cv wrex vw cab vx cv csn cun cfg cfv wceq wa vf vs copab wceq
      wa vx vy vz copab2 vx cv cvv wcel vy cv cfbas wcel wa vz cv vy cv cuni vx
      cv vf cv wf vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab vx cv
      csn cun cfg cfv wceq wa vf vs copab wceq wa vx vy vz copab2 vx vy vz vw
      vt vf vs df-filmap vy cv cfbas wcel vz cv vy cv cuni vx cv vf cv wf vs cv
      vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab vx cv csn cun cfg cfv
      wceq wa vf vs copab wceq wa vx cv cvv wcel vy cv cfbas wcel wa vz cv vy
      cv cuni vx cv vf cv wf vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw
      cab vx cv csn cun cfg cfv wceq wa vf vs copab wceq wa vx vy vz vy cv
      cfbas wcel vz cv vy cv cuni vx cv vf cv wf vs cv vw cv vf cv vt cv cima
      wceq vt vy cv wrex vw cab vx cv csn cun cfg cfv wceq wa vf vs copab wceq
      wa vx cv cvv wcel vy cv cfbas wcel vz cv vy cv cuni vx cv vf cv wf vs cv
      vw cv vf cv vt cv cima wceq vt vy cv wrex vw cab vx cv csn cun cfg cfv
      wceq wa vf vs copab wceq wa wa vx cv cvv wcel vy cv cfbas wcel wa vz cv
      vy cv cuni vx cv vf cv wf vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex
      vw cab vx cv csn cun cfg cfv wceq wa vf vs copab wceq wa vx cv cvv wcel
      vy cv cfbas wcel vz cv vy cv cuni vx cv vf cv wf vs cv vw cv vf cv vt cv
      cima wceq vt vy cv wrex vw cab vx cv csn cun cfg cfv wceq wa vf vs copab
      wceq wa vx visset biantrur vx cv cvv wcel vy cv cfbas wcel vz cv vy cv
      cuni vx cv vf cv wf vs cv vw cv vf cv vt cv cima wceq vt vy cv wrex vw
      cab vx cv csn cun cfg cfv wceq wa vf vs copab wceq anass bitr4i oprabbii
      eqtri oprabval2g cX cA elisset syl3an1 mpd3an3 $.
      $( [1-Dec-2010] $) $( [5-Sep-2009] $)
  $}

  ${
    $d f s A $. $d f s t w B $. $d f s t w F $. $d f s X $. $d f s Y $.
    isfilmap.1 $e |- Y = U. B $.
    $( Introduce a function that takes a function from a filtered domain to a
       set and produces a filter which consists of supersets of images of
       filter elements.  The functions which are dealt with by this function
       are similar to nets in topology.  For example, suppose we have a
       sequence filtered by the filter generated by its tails under the usual
       natural number ordering.  Then the elements of this filter are precisely
       the supersets of tails of this sequence.  Under this definition, it is
       not too difficult to see that the limit of a function in the filter
       sense captures the notion of convergence of a sequence.  As a result,
       the notion of a filter generalizes many ideas associated with sequences,
       and this function is one way to make that relationship precise in
       Metamath.  (Contributed by Jeff Hankins, 5-Sep-2009.)  $)
    isfilmap $p |- ( ( X e. A /\ B e. fBas /\ F : Y --> X ) -> ( ( X FilMap B
    ) ` F ) = ( filGen ` ( { w | E. t e. B w = ( F " t ) } u. { X } ) ) ) $=
      cX cA wcel cB cfbas wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cF cY cX
      vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun
      cfg cfv wceq wa vf vs copab cfv vw cv cF vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv cX cA wcel cB cfbas wcel cF cX cB cfilmap co cfv
      cF cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX
      csn cun cfg cfv wceq wa vf vs copab cfv wceq cY cX cF wf cX cA wcel cB
      cfbas wcel wa cF cX cB cfilmap co cY cX vf cv wf vs cv vw cv vf cv vt cv
      cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa vf vs copab vw vt
      cA cB vf cX cY vs isfilmap.1 filmapf fveq1d 3adant3 cY cX vf cv wf vs cv
      vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa
      vf vs copab wfun cF vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun
      cfg cfv cop cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex
      vw cab cX csn cun cfg cfv wceq wa vf vs copab wcel cF cY cX vf cv wf vs
      cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq
      wa vf vs copab cfv vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun
      cfg cfv wceq cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vw cv cF vt cv
      cima wceq vt cB wrex vw cab cX csn cun cfg cfv cY cX vf cv wf vs cv vw cv
      vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa vf vs
      copab vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg fvex
      funopfv cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv wceq wa vf vs copab wfun cX cA wcel cB cfbas wcel
      cY cX cF wf w3a cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB
      wrex vw cab cX csn cun cfg cfv wceq wa vf vs copab vs cv vw cv vf cv vt
      cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq vf vs copab wss vs
      cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq
      vf vs copab wfun cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB
      wrex vw cab cX csn cun cfg cfv wceq wa vf vs copab wfun cY cX vf cv wf vs
      cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq
      wa vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv
      wceq vf vs cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv wceq pm3.27 ssopab2i vf vs vw cv vf cv vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg cfv funopabeq cY cX vf cv wf vs cv
      vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa
      vf vs copab vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn
      cun cfg cfv wceq vf vs copab funss mp2 a1i cX cA wcel cB cfbas wcel cY cX
      cF wf w3a cF vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg
      cfv cop cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv wceq wa vf vs copab wcel cY cX cF wf vw cv cF vt
      cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg cfv wceq wa cX cA wcel cB cfbas
      wcel cY cX cF wf w3a cY cX cF wf vw cv cF vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn
      cun cfg cfv wceq cX cA wcel cB cfbas wcel cY cX cF wf 3simp3 vw cv cF vt
      cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv eqid jctir cF cX cY cm
      co wcel vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv cvv
      wcel cF vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv cop
      cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX csn
      cun cfg cfv wceq wa vf vs copab wcel cY cX cF wf vw cv cF vt cv cima wceq
      vt cB wrex vw cab cX csn cun cfg cfv vw cv cF vt cv cima wceq vt cB wrex
      vw cab cX csn cun cfg cfv wceq wa wb cX cA wcel cB cfbas wcel cY cX cF wf
      w3a cY cX vf cv wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab cX
      csn cun cfg cfv wceq wa cY cX cF wf vs cv vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun cfg cfv wceq wa cY cX cF wf vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg cfv vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun cfg cfv wceq wa vf vs cF vw cv cF vt cv cima wceq
      vt cB wrex vw cab cX csn cun cfg cfv cX cY cm co cvv vf cv cF wceq cY cX
      vf cv wf cY cX cF wf vs cv vw cv vf cv vt cv cima wceq vt cB wrex vw cab
      cX csn cun cfg cfv wceq vs cv vw cv cF vt cv cima wceq vt cB wrex vw cab
      cX csn cun cfg cfv wceq cY cX vf cv cF feq1 vf cv cF wceq vw cv vf cv vt
      cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg cfv vs cv vf cv cF wceq vw cv vf cv
      vt cv cima wceq vt cB wrex vw cab cX csn cun vw cv cF vt cv cima wceq vt
      cB wrex vw cab cX csn cun cfg vf cv cF wceq vw cv vf cv vt cv cima wceq
      vt cB wrex vw cab vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn vf cv
      cF wceq vw cv vf cv vt cv cima wceq vt cB wrex vw cv cF vt cv cima wceq
      vt cB wrex vw vf cv cF wceq vw cv vf cv vt cv cima wceq vw cv cF vt cv
      cima wceq vt cB vf cv cF wceq vf cv vt cv cima cF vt cv cima vw cv vf cv
      cF vt cv imaeq1 eqeq2d rexbidv abbidv uneq1d fveq2d eqeq2d anbi12d vs cv
      vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq vs cv
      vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq vw cv
      cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv vw cv cF vt cv
      cima wceq vt cB wrex vw cab cX csn cun cfg cfv wceq cY cX cF wf vs cv vw
      cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv vw cv cF vt cv
      cima wceq vt cB wrex vw cab cX csn cun cfg cfv eqeq1 anbi2d opelopabg cX
      cA wcel cB cfbas wcel cF cX cY cm co wcel cY cX cF wf cX cA wcel cY cvv
      wcel cF cX cY cm co wcel cY cX cF wf wb cB cfbas wcel cX cY cF cA cvv
      elmapg cB cfbas wcel cB cuni cvv cY cB cfbas uniexg isfilmap.1 syl5eqel
      sylan2 biimp3ar vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg
      cfv cvv wcel cX cA wcel cB cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg fvex a1i sylanc mpbird sylc eqtrd
      $.
      $( [1-Dec-2010] $) $( [5-Sep-2009] $)
  $}

  ${
    $d t w A $. $d t w B $. $d t w F $. $d t w X $. $d t w Y $.
    fmf.1 $e |- Y = U. B $.
    $( A mapping filter is a filter.  (Contributed by Jeff Hankins,
       18-Sep-2009.) $)
    fmf $p |- ( ( X e. A /\ B e. fBas /\ F : Y --> X ) -> ( ( X FilMap B ) ` F
    ) e. Fil ) $=
      cX cA wcel cB cfbas wcel cY cX cF wf w3a cF cX cB cfilmap co cfv vw cv cF
      vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv cfil vw vt cA cB cF
      cX cY fmf.1 isfilmap cX cA wcel cB cfbas wcel cY cX cF wf w3a vw cv cF vt
      cv cima wceq vt cB wrex vw cab cX csn cun cfbas wcel vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cfg cfv cfil wcel vw cv cF vt cv cima
      wceq vt cB wrex vw cab cfbas wcel vw cv cF vt cv cima wceq vt cB wrex vw
      cab cuni cX wss vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun
      cfbas wcel cX cA wcel cB cfbas wcel cY cX cF wf w3a cX vw cv cF vt cv
      cima wceq vt cB wrex vw cab vw cv cF vt cv cima wceq vt cB wrex vw cab
      cuni vw cv cF vt cv cima wceq vt cB wrex vw cab cuni eqid extbas1 cB
      cfbas wcel cY cX cF wf vw cv cF vt cv cima wceq vt cB wrex vw cab cfbas
      wcel cX cA wcel cB cfbas wcel cF cY wfn vw cv cF vt cv cima wceq vt cB
      wrex vw cab cfbas wcel cY cX cF wf vt vw cB vw cv cF vt cv cima wceq vt
      cB wrex vw cab cF cY fmf.1 vw cv cF vt cv cima wceq vt cB wrex vw cab
      eqid filrn cY cX cF ffn sylan2 3adant1 cX cA wcel cB cfbas wcel cY cX cF
      wf w3a vw cv cF vt cv cima wceq vt cB wrex vw cab cuni vt cB cF vt cv
      cima ciun cX cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vt cv cima cvv
      wcel vt cB wral vt cB cF vt cv cima ciun vw cv cF vt cv cima wceq vt cB
      wrex vw cab cuni wceq cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vt cv
      cima cvv wcel vt cB cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vt cv
      cima cvv wcel vt cv cB wcel cY cX cF wf cX cA wcel cF vt cv cima cvv wcel
      cB cfbas wcel cY cX cF wf cF wfun cF vt cv cima cvv wcel cY cX cF ffun cF
      vt cv vt visset funimaex syl 3ad2ant3 a1d r19.21aiv vt vw cB cF vt cv
      cima cvv dfiun2g syl cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vt cv
      cima cX wss vt cB wral vt cB cF vt cv cima ciun cX wss cY cX cF wf cX cA
      wcel cF vt cv cima cX wss vt cB wral cB cfbas wcel cY cX cF wf cF vt cv
      cima cX wss vt cB cY cX cF wf cF vt cv cima cX wss vt cv cB wcel cY cX cF
      wf cF vt cv cima cF crn cX cF vt cv cima cF crn wss cY cX cF wf cF vt cv
      imassrn a1i cY cX cF frn sstrd a1d r19.21aiv 3ad2ant3 vt cB cF vt cv cima
      cX iunss sylibr eqsstr3d sylanc vw cv cF vt cv cima wceq vt cB wrex vw
      cab cX csn cun fgfil syl eqeltrd $.
      $( [1-Dec-2010] $) $( [18-Sep-2009] $)
  $}

  ${
    $d t w A $. $d t w B $. $d t w F $. $d t w X $. $d t w Y $.
    fmbas.1 $e |- Y = U. B $.
    $( The base set of a mapping filter is the first argument.  (Contributed by
       Jeff Hankins, 18-Sep-2009.) $)
    fmbas $p |- ( ( X e. A /\ B e. fBas /\ F : Y --> X ) -> U. ( ( X FilMap B )
    ` F ) = X ) $=
      cX cA wcel cB cfbas wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cuni vw
      cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv cuni vw cv cF
      vt cv cima wceq vt cB wrex vw cab cX csn cun cuni cX cX cA wcel cB cfbas
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv vw cv cF vt cv cima wceq vt
      cB wrex vw cab cX csn cun cfg cfv vw vt cA cB cF cX cY fmbas.1 isfilmap
      unieqd cX cA wcel cB cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima wceq
      vt cB wrex vw cab cX csn cun cfbas wcel vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun cuni vw cv cF vt cv cima wceq vt cB wrex vw cab cX
      csn cun cfg cfv cuni wceq vw cv cF vt cv cima wceq vt cB wrex vw cab
      cfbas wcel vw cv cF vt cv cima wceq vt cB wrex vw cab cuni cX wss vw cv
      cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfbas wcel cX cA wcel cB
      cfbas wcel cY cX cF wf w3a cX vw cv cF vt cv cima wceq vt cB wrex vw cab
      vw cv cF vt cv cima wceq vt cB wrex vw cab cuni vw cv cF vt cv cima wceq
      vt cB wrex vw cab cuni eqid extbas1 cB cfbas wcel cY cX cF wf vw cv cF vt
      cv cima wceq vt cB wrex vw cab cfbas wcel cX cA wcel cB cfbas wcel cF cY
      wfn vw cv cF vt cv cima wceq vt cB wrex vw cab cfbas wcel cY cX cF wf vt
      vw cB vw cv cF vt cv cima wceq vt cB wrex vw cab cF cY fmbas.1 vw cv cF
      vt cv cima wceq vt cB wrex vw cab eqid filrn cY cX cF ffn sylan2 3adant1
      cX cA wcel cB cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima wceq vt cB
      wrex vw cab cuni vt cB cF vt cv cima ciun cX cX cA wcel cB cfbas wcel cY
      cX cF wf w3a cF vt cv cima cvv wcel vt cB wral vt cB cF vt cv cima ciun
      vw cv cF vt cv cima wceq vt cB wrex vw cab cuni wceq cY cX cF wf cX cA
      wcel cF vt cv cima cvv wcel vt cB wral cB cfbas wcel cY cX cF wf cF vt cv
      cima cvv wcel vt cB cY cX cF wf cF vt cv cima cvv wcel vt cv cB wcel cY
      cX cF wf cF wfun cF vt cv cima cvv wcel cY cX cF ffun cF vt cv vt visset
      funimaex syl a1d r19.21aiv 3ad2ant3 vt vw cB cF vt cv cima cvv dfiun2g
      syl cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vt cv cima cX wss vt cB
      wral vt cB cF vt cv cima ciun cX wss cY cX cF wf cX cA wcel cF vt cv cima
      cX wss vt cB wral cB cfbas wcel cY cX cF wf cF vt cv cima cX wss vt cB cY
      cX cF wf cF vt cv cima cX wss vt cv cB wcel cY cX cF wf cF vt cv cima cF
      crn cX cF vt cv cima cF crn wss cY cX cF wf cF vt cv imassrn a1i cY cX cF
      frn sstrd a1d r19.21aiv 3ad2ant3 vt cB cF vt cv cima cX iunss sylibr
      eqsstr3d sylanc vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun vw
      cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cuni vw cv cF vt cv
      cima wceq vt cB wrex vw cab cX csn cun cuni eqid fgbas syl vw cv cF vt cv
      cima wceq vt cB wrex vw cab cuni cX wss cX cA wcel vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cuni cX wceq cX cA wcel cB cfbas wcel
      cY cX cF wf w3a cX cA vw cv cF vt cv cima wceq vt cB wrex vw cab vw cv cF
      vt cv cima wceq vt cB wrex vw cab cuni vw cv cF vt cv cima wceq vt cB
      wrex vw cab cuni eqid extbas2 cX cA wcel cB cfbas wcel cY cX cF wf w3a vw
      cv cF vt cv cima wceq vt cB wrex vw cab cuni vt cB cF vt cv cima ciun cX
      cX cA wcel cB cfbas wcel cY cX cF wf w3a cF vt cv cima cvv wcel vt cB
      wral vt cB cF vt cv cima ciun vw cv cF vt cv cima wceq vt cB wrex vw cab
      cuni wceq cY cX cF wf cX cA wcel cF vt cv cima cvv wcel vt cB wral cB
      cfbas wcel cY cX cF wf cF vt cv cima cvv wcel vt cB cY cX cF wf cF vt cv
      cima cvv wcel vt cv cB wcel cY cX cF wf cF wfun cF vt cv cima cvv wcel cY
      cX cF ffun cF vt cv vt visset funimaex syl a1d r19.21aiv 3ad2ant3 vt vw
      cB cF vt cv cima cvv dfiun2g syl cX cA wcel cB cfbas wcel cY cX cF wf w3a
      cF vt cv cima cX wss vt cB wral vt cB cF vt cv cima ciun cX wss cY cX cF
      wf cX cA wcel cF vt cv cima cX wss vt cB wral cB cfbas wcel cY cX cF wf
      cF vt cv cima cX wss vt cB cY cX cF wf cF vt cv cima cX wss vt cv cB wcel
      cY cX cF wf cF vt cv cima cF crn cX cF vt cv cima cF crn wss cY cX cF wf
      cF vt cv imassrn a1i cY cX cF frn sstrd a1d r19.21aiv 3ad2ant3 vt cB cF
      vt cv cima cX iunss sylibr eqsstr3d cX cA wcel cB cfbas wcel cY cX cF wf
      3simp1 sylanc 3eqtr2d $.
      $( [1-Dec-2010] $) $( [18-Sep-2009] $)
  $}

  ${
    $d t w x y z A $.  $d t w x y z B $. $d t w x y C $. $d t w x y z F $. $d x
    y z L $. $d t w x y z X $. $d t w x y z Y $.
    elfilmap.1 $e |- Y = U. B $.
    $( An element of a mapping filter. (Contributed by Jeff Hankins,
       8-Sep-2009.) $)
    elfilmap $p |- ( ( X e. C /\ B e. fBas /\ F : Y --> X ) -> ( A e. ( ( X
    FilMap B ) ` F ) <-> ( A C_ X /\ E. x e. B ( F " x ) C_ A ) ) ) $=
      cX cC wcel cB cfbas wcel cY cX cF wf w3a cA cF cX cB cfilmap co cfv wcel
      cA vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfg cfv wcel cA
      vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cuni wss vy cv cA
      wss vy vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun wrex wa cA
      cX wss cF vx cv cima cA wss vx cB wrex wa cX cC wcel cB cfbas wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv vw cv cF vt cv cima wceq vt cB wrex vw
      cab cX csn cun cfg cfv cA vw vt cC cB cF cX cY elfilmap.1 isfilmap eleq2d
      cX cC wcel cB cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun cfbas wcel cA vw cv cF vt cv cima wceq vt cB wrex
      vw cab cX csn cun cfg cfv wcel cA vw cv cF vt cv cima wceq vt cB wrex vw
      cab cX csn cun cuni wss vy cv cA wss vy vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun wrex wa wb vw cv cF vt cv cima wceq vt cB wrex vw
      cab cfbas wcel vw cv cF vt cv cima wceq vt cB wrex vw cab cuni cX wss vw
      cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cfbas wcel cX cC wcel
      cB cfbas wcel cY cX cF wf w3a cX vw cv cF vt cv cima wceq vt cB wrex vw
      cab vw cv cF vt cv cima wceq vt cB wrex vw cab cuni vw cv cF vt cv cima
      wceq vt cB wrex vw cab cuni eqid extbas1 cB cfbas wcel cY cX cF wf vw cv
      cF vt cv cima wceq vt cB wrex vw cab cfbas wcel cX cC wcel cB cfbas wcel
      cF cY wfn vw cv cF vt cv cima wceq vt cB wrex vw cab cfbas wcel cY cX cF
      wf vt vw cB vw cv cF vt cv cima wceq vt cB wrex vw cab cF cY elfilmap.1
      vw cv cF vt cv cima wceq vt cB wrex vw cab eqid filrn cY cX cF ffn sylan2
      3adant1 cX cC wcel cB cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima wceq
      vt cB wrex vw cab cuni vt cB cF vt cv cima ciun cX cX cC wcel cB cfbas
      wcel cY cX cF wf w3a cF vt cv cima cvv wcel vt cB wral vt cB cF vt cv
      cima ciun vw cv cF vt cv cima wceq vt cB wrex vw cab cuni wceq cX cC wcel
      cB cfbas wcel cY cX cF wf w3a cF vt cv cima cvv wcel vt cB cX cC wcel cB
      cfbas wcel cY cX cF wf w3a cF vt cv cima cvv wcel vt cv cB wcel cY cX cF
      wf cX cC wcel cF vt cv cima cvv wcel cB cfbas wcel cY cX cF wf cF wfun cF
      vt cv cima cvv wcel cY cX cF ffun cF vt cv vt visset funimaex syl
      3ad2ant3 a1d r19.21aiv vt vw cB cF vt cv cima cvv dfiun2g syl cX cC wcel
      cB cfbas wcel cY cX cF wf w3a cF vt cv cima cX wss vt cB wral vt cB cF vt
      cv cima ciun cX wss cY cX cF wf cX cC wcel cF vt cv cima cX wss vt cB
      wral cB cfbas wcel cY cX cF wf cF vt cv cima cX wss vt cB cY cX cF wf cF
      vt cv cima cX wss vt cv cB wcel cY cX cF wf cF vt cv cima cF crn cX cF vt
      cv cima cF crn wss cY cX cF wf cF vt cv imassrn a1i cY cX cF frn sstrd
      a1d r19.21aiv 3ad2ant3 vt cB cF vt cv cima cX iunss sylibr eqsstr3d
      sylanc vy cA vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun vw cv
      cF vt cv cima wceq vt cB wrex vw cab cX csn cun cuni vw cv cF vt cv cima
      wceq vt cB wrex vw cab cX csn cun cuni eqid elfg syl cX cC wcel cB cfbas
      wcel cY cX cF wf w3a cA vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn
      cun cuni wss cA cX wss vy cv cA wss vy vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun wrex cF vx cv cima cA wss vx cB wrex cX cC wcel cB
      cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima wceq vt cB wrex vw cab cX
      csn cun cuni cX cA vw cv cF vt cv cima wceq vt cB wrex vw cab cuni cX wss
      cX cC wcel vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cuni cX
      wceq cX cC wcel cB cfbas wcel cY cX cF wf w3a cX cC vw cv cF vt cv cima
      wceq vt cB wrex vw cab vw cv cF vt cv cima wceq vt cB wrex vw cab cuni vw
      cv cF vt cv cima wceq vt cB wrex vw cab cuni eqid extbas2 cX cC wcel cB
      cfbas wcel cY cX cF wf w3a vw cv cF vt cv cima wceq vt cB wrex vw cab
      cuni vt cB cF vt cv cima ciun cX cX cC wcel cB cfbas wcel cY cX cF wf w3a
      cF vt cv cima cvv wcel vt cB wral vt cB cF vt cv cima ciun vw cv cF vt cv
      cima wceq vt cB wrex vw cab cuni wceq cX cC wcel cB cfbas wcel cY cX cF
      wf w3a cF vt cv cima cvv wcel vt cB cX cC wcel cB cfbas wcel cY cX cF wf
      w3a cF vt cv cima cvv wcel vt cv cB wcel cY cX cF wf cX cC wcel cF vt cv
      cima cvv wcel cB cfbas wcel cY cX cF wf cF wfun cF vt cv cima cvv wcel cY
      cX cF ffun cF vt cv vt visset funimaex syl 3ad2ant3 a1d r19.21aiv vt vw
      cB cF vt cv cima cvv dfiun2g syl cX cC wcel cB cfbas wcel cY cX cF wf w3a
      cF vt cv cima cX wss vt cB wral vt cB cF vt cv cima ciun cX wss cY cX cF
      wf cX cC wcel cF vt cv cima cX wss vt cB wral cB cfbas wcel cY cX cF wf
      cF vt cv cima cX wss vt cB cY cX cF wf cF vt cv cima cX wss vt cv cB wcel
      cY cX cF wf cF vt cv cima cF crn cX cF vt cv cima cF crn wss cY cX cF wf
      cF vt cv imassrn a1i cY cX cF frn sstrd a1d r19.21aiv 3ad2ant3 vt cB cF
      vt cv cima cX iunss sylibr eqsstr3d cX cC wcel cB cfbas wcel cY cX cF wf
      3simp1 sylanc sseq2d cX cC wcel cB cfbas wcel cY cX cF wf w3a vy cv cA
      wss vy vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun wrex cF vx
      cv cima cA wss vx cB wrex cX cC wcel cB cfbas wcel cY cX cF wf w3a vy cv
      cA wss cF vx cv cima cA wss vx cB wrex vy vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn cun cX cC wcel cB cfbas wcel cY cX cF wf w3a vy cv cF
      vt cv cima wceq vt cB wrex vy cv cX wceq wo vy cv cA wss cF vx cv cima cA
      wss vx cB wrex wi vy cv vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn
      cun wcel cX cC wcel cB cfbas wcel cY cX cF wf w3a vy cv cF vt cv cima
      wceq vt cB wrex vy cv cA wss cF vx cv cima cA wss vx cB wrex wi vy cv cX
      wceq cX cC wcel cB cfbas wcel cY cX cF wf w3a vy cv cF vt cv cima wceq vy
      cv cA wss cF vx cv cima cA wss vx cB wrex wi vt cB cY cX cF wf cX cC wcel
      vt cv cB wcel vy cv cF vt cv cima wceq vy cv cA wss cF vx cv cima cA wss
      vx cB wrex wi wi wi cB cfbas wcel cY cX cF wf vt cv cB wcel vy cv cF vt
      cv cima wceq vy cv cA wss cF vx cv cima cA wss vx cB wrex vt cv cB wcel
      cF vt cv cima cA wss cF vx cv cima cA wss vx cB wrex cY cX cF wf vt cv cB
      wcel vy cv cF vt cv cima wceq w3a vy cv cA wss wa cF vx cv cima cA wss cF
      vt cv cima cA wss vx vt cv cB vx cv vt cv wceq cF vx cv cima cF vt cv
      cima cA vx cv vt cv cF imaeq2 sseq1d rcla4ev cY cX cF wf vt cv cB wcel vy
      cv cF vt cv cima wceq w3a vt cv cB wcel vy cv cA wss cY cX cF wf vt cv cB
      wcel vy cv cF vt cv cima wceq 3simp2 adantr cY cX cF wf vt cv cB wcel vy
      cv cF vt cv cima wceq w3a vy cv cA wss cF vt cv cima cA wss vy cv cF vt
      cv cima wceq cY cX cF wf vy cv cA wss cF vt cv cima cA wss wb vt cv cB
      wcel vy cv cF vt cv cima cA sseq1 3ad2ant3 biimpa sylanc 3exp1 3ad2ant3
      r19.23adv cX cC wcel vt cv cB wcel vt wex cY cX cF wf vy cv cX wceq vy cv
      cA wss cF vx cv cima cA wss vx cB wrex wi wi cB cfbas wcel cX cC wcel vt
      cv cB wcel vt wex cY cX cF wf vy cv cX wceq vy cv cA wss cF vx cv cima cA
      wss vx cB wrex wi wi cX cC wcel vt cv cB wcel cY cX cF wf vy cv cX wceq
      vy cv cA wss cF vx cv cima cA wss vx cB wrex wi wi wi vt vt cv cB wcel cY
      cX cF wf vy cv cX wceq vy cv cA wss cF vx cv cima cA wss vx cB wrex wi wi
      wi wi cX cC wcel vt cv cB wcel cY cX cF wf vy cv cX wceq vy cv cA wss cF
      vx cv cima cA wss vx cB wrex vt cv cB wcel cF vt cv cima cA wss cF vx cv
      cima cA wss vx cB wrex vt cv cB wcel cY cX cF wf vy cv cX wceq w3a vy cv
      cA wss wa cF vx cv cima cA wss cF vt cv cima cA wss vx vt cv cB vx cv vt
      cv wceq cF vx cv cima cF vt cv cima cA vx cv vt cv cF imaeq2 sseq1d
      rcla4ev vt cv cB wcel cY cX cF wf vy cv cX wceq w3a vt cv cB wcel vy cv
      cA wss vt cv cB wcel cY cX cF wf vy cv cX wceq 3simp1 adantr vt cv cB
      wcel cY cX cF wf vy cv cX wceq w3a vy cv cA wss cF vt cv cima cA wss vt
      cv cB wcel cY cX cF wf vy cv cX wceq w3a vy cv cA wss cX cA wss cF vt cv
      cima cA wss vy cv cX wceq vt cv cB wcel vy cv cA wss cX cA wss wb cY cX
      cF wf vy cv cX cA sseq1 3ad2ant3 cY cX cF wf vt cv cB wcel cX cA wss cF
      vt cv cima cA wss wi vy cv cX wceq cY cX cF wf cF vt cv cima cX wss cX cA
      wss cF vt cv cima cA wss wi cY cX cF wf cF vt cv cima cF crn cX cF vt cv
      cima cF crn wss cY cX cF wf cF vt cv imassrn a1i cY cX cF frn sstrd cF vt
      cv cima cX cA sstr2 syl 3ad2ant2 sylbid imp sylanc 3exp1 a1i 19.23adv
      3imp cB cfbas wcel cB c0 wne vt cv cB wcel vt wex cB fbasne0 vt cB n0
      sylib syl3an2 jaod vy cv vw cv cF vt cv cima wceq vt cB wrex vw cab cX
      csn cun wcel vy cv vw cv cF vt cv cima wceq vt cB wrex vw cab wcel vy cv
      cX csn wcel wo vy cv cF vt cv cima wceq vt cB wrex vy cv cX wceq wo vy cv
      vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn elun vy cv vw cv cF vt
      cv cima wceq vt cB wrex vw cab wcel vy cv cF vt cv cima wceq vt cB wrex
      vy cv cX csn wcel vy cv cX wceq vw cv cF vt cv cima wceq vt cB wrex vy cv
      cF vt cv cima wceq vt cB wrex vw vy cv vy visset vw cv vy cv wceq vw cv
      cF vt cv cima wceq vy cv cF vt cv cima wceq vt cB vw cv vy cv cF vt cv
      cima eqeq1 rexbidv elab vy cX elsn orbi12i bitri syl5ib r19.23adv cX cC
      wcel cB cfbas wcel cY cX cF wf w3a cF vx cv cima cA wss vy cv cA wss vy
      vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun wrex vx cB cX cC
      wcel cB cfbas wcel cY cX cF wf w3a vx cv cB wcel cF vx cv cima cA wss vy
      cv cA wss vy vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun wrex
      cF vx cv cima vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun wcel
      cF vx cv cima cA wss vy cv cA wss vy vw cv cF vt cv cima wceq vt cB wrex
      vw cab cX csn cun wrex cX cC wcel cB cfbas wcel cY cX cF wf w3a vx cv cB
      wcel cF vx cv cima cA wss wa wa vy cv cA wss cF vx cv cima cA wss vy cF
      vx cv cima vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun vy cv cF
      vx cv cima cA sseq1 rcla4ev cX cC wcel cB cfbas wcel cY cX cF wf w3a vx
      cv cB wcel cF vx cv cima cA wss wa wa vw cv cF vt cv cima wceq vt cB wrex
      vw cab vw cv cF vt cv cima wceq vt cB wrex vw cab cX csn cun cF vx cv
      cima vw cv cF vt cv cima wceq vt cB wrex vw cab vw cv cF vt cv cima wceq
      vt cB wrex vw cab cX csn cun wss cX cC wcel cB cfbas wcel cY cX cF wf w3a
      vx cv cB wcel cF vx cv cima cA wss wa wa vw cv cF vt cv cima wceq vt cB
      wrex vw cab cX csn ssun1 a1i cX cC wcel cB cfbas wcel cY cX cF wf w3a vx
      cv cB wcel cF vx cv cima cA wss wa wa cF vx cv cima vw cv cF vt cv cima
      wceq vt cB wrex vw cab wcel cF vx cv cima cF vt cv cima wceq vt cB wrex
      vx cv cB wcel cF vx cv cima cF vt cv cima wceq vt cB wrex cX cC wcel cB
      cfbas wcel cY cX cF wf w3a cF vx cv cima cA wss vx cv cB wcel cF vx cv
      cima cF vx cv cima wceq cF vx cv cima cF vt cv cima wceq vt cB wrex cF vx
      cv cima eqid cF vx cv cima cF vt cv cima wceq cF vx cv cima cF vx cv cima
      wceq vt vx cv cB vt cv vx cv wceq cF vt cv cima cF vx cv cima cF vx cv
      cima vt cv vx cv cF imaeq2 eqeq2d rcla4ev mpan2 ad2antrl cX cC wcel cB
      cfbas wcel cY cX cF wf w3a cF vx cv cima vw cv cF vt cv cima wceq vt cB
      wrex vw cab wcel cF vx cv cima cF vt cv cima wceq vt cB wrex wb vx cv cB
      wcel cF vx cv cima cA wss wa cY cX cF wf cX cC wcel cF vx cv cima vw cv
      cF vt cv cima wceq vt cB wrex vw cab wcel cF vx cv cima cF vt cv cima
      wceq vt cB wrex wb cB cfbas wcel cY cX cF wf cF wfun cF vx cv cima cvv
      wcel cF vx cv cima vw cv cF vt cv cima wceq vt cB wrex vw cab wcel cF vx
      cv cima cF vt cv cima wceq vt cB wrex wb cY cX cF ffun cF vx cv vx visset
      funimaex vw cv cF vt cv cima wceq vt cB wrex cF vx cv cima cF vt cv cima
      wceq vt cB wrex vw cF vx cv cima cvv vw cv cF vx cv cima wceq vw cv cF vt
      cv cima wceq cF vx cv cima cF vt cv cima wceq vt cB vw cv cF vx cv cima
      cF vt cv cima eqeq1 rexbidv elabg 3syl 3ad2ant3 adantr mpbird sseldd cX
      cC wcel cB cfbas wcel cY cX cF wf w3a vx cv cB wcel cF vx cv cima cA wss
      simprr sylanc exp32 r19.23adv impbid anbi12d 3bitrd $.
      $( [1-Dec-2010] $) $( [8-Sep-2009] $)

      elfilmap2.2 $e |- L = ( filGen ` B ) $.
      $( An element of a mapping filter. (Contributed by Jeff Hankins,
         26-Sep-2009.) $)
      elfilmap2 $p |- ( ( X e. C /\ B e. fBas /\ F : Y --> X ) -> ( A e. ( ( X
    FilMap B ) ` F ) <-> ( A C_ X /\ E. x e. L ( F " x ) C_ A ) ) ) $=
        cX cC wcel cB cfbas wcel cY cX cF wf w3a cA cF cX cB cfilmap co cfv
        wcel cA cX wss cF vy cv cima cA wss vy cB wrex wa cA cX wss cF vx cv
        cima cA wss vx cL wrex wa vy cA cB cC cF cX cY elfilmap.1 elfilmap cX
        cC wcel cB cfbas wcel cY cX cF wf w3a cF vy cv cima cA wss vy cB wrex
        cF vx cv cima cA wss vx cL wrex cA cX wss cX cC wcel cB cfbas wcel cY
        cX cF wf w3a cF vy cv cima cA wss vy cB wrex cF vx cv cima cA wss vx cL
        wrex cX cC wcel cB cfbas wcel cY cX cF wf w3a cF vy cv cima cA wss cF
        vx cv cima cA wss vx cL wrex vy cB cX cC wcel cB cfbas wcel cY cX cF wf
        w3a vy cv cB wcel cF vy cv cima cA wss cF vx cv cima cA wss vx cL wrex
        vy cv cL wcel cF vy cv cima cA wss cF vx cv cima cA wss vx cL wrex cX
        cC wcel cB cfbas wcel cY cX cF wf w3a vy cv cB wcel cF vy cv cima cA
        wss wa wa cF vx cv cima cA wss cF vy cv cima cA wss vx vy cv cL vx cv
        vy cv wceq cF vx cv cima cF vy cv cima cA vx cv vy cv cF imaeq2 sseq1d
        rcla4ev cB cfbas wcel cX cC wcel vy cv cB wcel cF vy cv cima cA wss wa
        vy cv cL wcel cY cX cF wf cB cfbas wcel vy cv cB wcel vy cv cL wcel cF
        vy cv cima cA wss cB cfbas wcel vy cv cB wcel vy cv cL wcel cB cfbas
        wcel cB cL vy cv cB cfbas wcel cB cB cfg cfv cL cB fbssfg elfilmap2.2
        syl6ssr sseld imp adantrr 3ad2antl2 cX cC wcel cB cfbas wcel cY cX cF
        wf w3a vy cv cB wcel cF vy cv cima cA wss simprr sylanc exp32 r19.23adv
        cX cC wcel cB cfbas wcel cY cX cF wf w3a cF vx cv cima cA wss cF vy cv
        cima cA wss vy cB wrex vx cL cX cC wcel cB cfbas wcel cY cX cF wf w3a
        vx cv cL wcel vx cv cY wss vy cv vx cv wss vy cB wrex wa cF vx cv cima
        cA wss cF vy cv cima cA wss vy cB wrex wi cB cfbas wcel cX cC wcel vx
        cv cL wcel vx cv cY wss vy cv vx cv wss vy cB wrex wa wb cY cX cF wf cB
        cfbas wcel vx cv cB cfg cfv wcel vx cv cY wss vy cv vx cv wss vy cB
        wrex wa vx cv cL wcel vy vx cv cB cY elfilmap.1 elfg cL cB cfg cfv vx
        cv elfilmap2.2 eleq2i syl5bb 3ad2ant2 cX cC wcel cB cfbas wcel cY cX cF
        wf w3a vx cv cY wss vy cv vx cv wss vy cB wrex cF vx cv cima cA wss cF
        vy cv cima cA wss vy cB wrex wi cX cC wcel cB cfbas wcel cY cX cF wf
        w3a vx cv cY wss wa cF vx cv cima cA wss vy cv vx cv wss vy cB wrex cF
        vy cv cima cA wss vy cB wrex cX cC wcel cB cfbas wcel cY cX cF wf w3a
        vx cv cY wss cF vx cv cima cA wss vy cv vx cv wss vy cB wrex cF vy cv
        cima cA wss vy cB wrex wi cX cC wcel cB cfbas wcel cY cX cF wf w3a vx
        cv cY wss cF vx cv cima cA wss wa wa vy cv vx cv wss cF vy cv cima cA
        wss vy cB cX cC wcel cB cfbas wcel cY cX cF wf w3a vx cv cY wss cF vx
        cv cima cA wss wa wa cF vy cv cima cF vx cv cima wss cF vy cv cima cA
        wss vy cv vx cv wss cF vx cv cima cA wss cF vy cv cima cF vx cv cima
        wss cF vy cv cima cA wss wi cX cC wcel cB cfbas wcel cY cX cF wf w3a vx
        cv cY wss cF vy cv cima cF vx cv cima wss cF vx cv cima cA wss cF vy cv
        cima cA wss cF vy cv cima cF vx cv cima cA sstr2 com12 ad2antll vy cv
        vx cv cF imass2 syl5 r19.22sdv expr com23 expimpd sylbid r19.23adv
        impbid anbi2d bitrd $.
        $( [1-Dec-2010] $) $( [26-Sep-2009] $)

    $( An alternate formulation of elementhood in a mapping filter that
       requires ` F ` to be onto. (Contributed by Jeff Hankins, 1-Oct-2009.) $)
    elfilmap3 $p |- ( ( B e. fBas /\ F : Y -onto-> X ) -> ( A e. ( ( X FilMap B
    ) ` F ) <-> E. x e. L A = ( F " x ) ) ) $=
      cB cfbas wcel cY cX cF wfo cX cvv wcel cA cF cX cB cfilmap co cfv wcel cA
      cF vx cv cima wceq vx cL wrex wb cB cfbas wcel cY cX cF wfo wa cF cY cima
      cX cvv cY cX cF wfo cF cY cima cX wceq cB cfbas wcel cY cX cF foima
      adantl cF wfun cY cvv wcel cF cY cima cvv wcel cB cfbas wcel cY cX cF wfo
      wa cF cY cvv funimaexg cY cX cF wfo cF wfun cB cfbas wcel cY cX cF fofun
      adantl cB cfbas wcel cY cvv wcel cY cX cF wfo cB cfbas wcel cB cuni cvv
      cY cB cfbas uniexg elfilmap.1 syl5eqel adantr sylanc eqeltrrd cX cvv wcel
      cB cfbas wcel cY cX cF wfo cA cF cX cB cfilmap co cfv wcel cA cF vx cv
      cima wceq vx cL wrex wb cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cF
      cX cB cfilmap co cfv wcel cA cX wss cF vy cv cima cA wss vy cL wrex wa cA
      cF vx cv cima wceq vx cL wrex cX cvv wcel cB cfbas wcel cY cX cF wf cA cF
      cX cB cfilmap co cfv wcel cA cX wss cF vy cv cima cA wss vy cL wrex wa wb
      cY cX cF wfo vy cA cB cvv cF cL cX cY elfilmap.1 elfilmap2.2 elfilmap2 cY
      cX cF fof syl3an3 cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss cF
      vy cv cima cA wss vy cL wrex wa cA cF vx cv cima wceq vx cL wrex cX cvv
      wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss cF vy cv cima cA wss vy cL
      wrex cA cF vx cv cima wceq vx cL wrex cX cvv wcel cB cfbas wcel cY cX cF
      wfo w3a cA cX wss wa cF vy cv cima cA wss cA cF vx cv cima wceq vx cL
      wrex vy cL cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy cv
      cL wcel cF vy cv cima cA wss cA cF vx cv cima wceq vx cL wrex cF ccnv cA
      cima cL wcel cA cF cF ccnv cA cima cima wceq cA cF vx cv cima wceq vx cL
      wrex cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy cv cL
      wcel cF vy cv cima cA wss wa wa cA cF vx cv cima wceq cA cF cF ccnv cA
      cima cima wceq vx cF ccnv cA cima cL vx cv cF ccnv cA cima wceq cF vx cv
      cima cF cF ccnv cA cima cima cA vx cv cF ccnv cA cima cF imaeq2 eqeq2d
      rcla4ev cL cfil wcel vy cv cL wcel cF ccnv cA cima cL cuni wss vy cv cF
      ccnv cA cima wss w3a cF ccnv cA cima cL wcel cX cvv wcel cB cfbas wcel cY
      cX cF wfo w3a cA cX wss wa vy cv cL wcel cF vy cv cima cA wss wa wa vy cv
      cF ccnv cA cima cL cL cuni cL cuni eqid fillsb cX cvv wcel cB cfbas wcel
      cY cX cF wfo w3a cL cfil wcel cA cX wss vy cv cL wcel cF vy cv cima cA
      wss wa cB cfbas wcel cX cvv wcel cL cfil wcel cY cX cF wfo cB cfbas wcel
      cB cfg cfv cfil cL cB fgfil elfilmap2.2 syl5eqel 3ad2ant2 ad2antrr cX cvv
      wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy cv cL wcel cF vy cv
      cima cA wss wa wa vy cv cL wcel cF ccnv cA cima cL cuni wss vy cv cF ccnv
      cA cima wss cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy cv
      cL wcel cF vy cv cima cA wss simprl cX cvv wcel cB cfbas wcel cY cX cF
      wfo w3a cF ccnv cA cima cL cuni wss cA cX wss vy cv cL wcel cF vy cv cima
      cA wss wa cB cfbas wcel cY cX cF wfo cF ccnv cA cima cL cuni wss cX cvv
      wcel cB cfbas wcel cY cX cF wfo wa cF ccnv cA cima cY cL cuni cY cX cF
      wfo cF ccnv cA cima cY wss cB cfbas wcel cY cX cF wfo cF ccnv cA cima cF
      cdm cY cF ccnv cA cima cF cdm wss cY cX cF wfo cF cA cnvimass a1i cY cX
      cF wfo cF cY wfn cF cdm cY wceq cY cX cF fofn cY cF fndm syl sseqtrd
      adantl cB cfbas wcel cY cX cF wfo wa cY cB cfg cfv cuni cL cuni cB cfbas
      wcel cY cB cfg cfv cuni wceq cY cX cF wfo cB cY elfilmap.1 fgbas adantr
      cL cB cfg cfv elfilmap2.2 unieqi syl6eqr sseqtrd 3adant1 ad2antrr cX cvv
      wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy cv cL wcel cF vy cv
      cima cA wss vy cv cF ccnv cA cima wss cX cvv wcel cB cfbas wcel cY cX cF
      wfo w3a cA cX wss wa vy cv cL wcel wa cF vy cv cima cA wss vy cv cF ccnv
      cA cima wss cF wfun vy cv cF cdm wss cF vy cv cima cA wss vy cv cF ccnv
      cA cima wss wb cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy
      cv cL wcel wa vy cv cA cF funimass3 cX cvv wcel cB cfbas wcel cY cX cF
      wfo w3a cF wfun cA cX wss vy cv cL wcel cY cX cF wfo cX cvv wcel cF wfun
      cB cfbas wcel cY cX cF fofun 3ad2ant3 ad2antrr cX cvv wcel cB cfbas wcel
      cY cX cF wfo w3a cA cX wss wa vy cv cL wcel vy cv cY wss vy cv cF cdm wss
      cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cX wss wa vy cv cL wcel vy
      cv cY wss vz cv vy cv wss vz cB wrex cX cvv wcel cB cfbas wcel cY cX cF
      wfo w3a cA cX wss wa vy cv cB cfg cfv wcel vy cv cY wss vz cv vy cv wss
      vz cB wrex wa vy cv cL wcel cX cvv wcel cB cfbas wcel cY cX cF wfo w3a vy
      cv cB cfg cfv wcel vy cv cY wss vz cv vy cv wss vz cB wrex wa wb cA cX
      wss cB cfbas wcel cX cvv wcel vy cv cB cfg cfv wcel vy cv cY wss vz cv vy
      cv wss vz cB wrex wa wb cY cX cF wfo vz vy cv cB cY elfilmap.1 elfg
      3ad2ant2 adantr cL cB cfg cfv vy cv elfilmap2.2 eleq2i syl5bb pm3.26bda
      cX cvv wcel cB cfbas wcel cY cX cF wfo w3a vy cv cY wss vy cv cF cdm wss
      cA cX wss cY cX cF wfo cX cvv wcel vy cv cY wss vy cv cF cdm wss cB cfbas
      wcel cF cdm cY wceq vy cv cY wss vy cv cF cdm wss cY cX cF wfo cF cdm cY
      wceq vy cv cF cdm wss vy cv cY wss cF cdm cY vy cv sseq2 biimpar cY cX cF
      wfo cF cY wfn cF cdm cY wceq cY cX cF fofn cY cF fndm syl sylan 3ad2antl3
      adantlr syldan sylanc biimpd impr 3jca sylc cX cvv wcel cB cfbas wcel cY
      cX cF wfo w3a cA cX wss wa cA cF cF ccnv cA cima cima wceq vy cv cL wcel
      cF vy cv cima cA wss wa cY cX cF wfo cX cvv wcel cA cX wss cA cF cF ccnv
      cA cima cima wceq cB cfbas wcel cY cX cF wfo cA cX wss wa cF cF ccnv cA
      cima cima cA cY cX cA cF foimacnv eqcomd 3ad2antl3 adantr sylanc exp32
      r19.23adv expimpd cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cA cF vx cv
      cima wceq cA cX wss cF vy cv cima cA wss vy cL wrex wa vx cL cX cvv wcel
      cB cfbas wcel cY cX cF wfo w3a vx cv cL wcel cA cF vx cv cima wceq cA cX
      wss cF vy cv cima cA wss vy cL wrex wa cX cvv wcel cB cfbas wcel cY cX cF
      wfo w3a vx cv cL wcel cA cF vx cv cima wceq wa wa cA cX wss cF vy cv cima
      cA wss vy cL wrex cX cvv wcel cB cfbas wcel cY cX cF wfo w3a vx cv cL
      wcel cA cF vx cv cima wceq wa wa cA cF vx cv cima cX cX cvv wcel cB cfbas
      wcel cY cX cF wfo w3a vx cv cL wcel cA cF vx cv cima wceq simprr cX cvv
      wcel cB cfbas wcel cY cX cF wfo w3a vx cv cL wcel cA cF vx cv cima wceq
      wa wa cF vx cv cima cF crn cX cF vx cv cima cF crn wss cX cvv wcel cB
      cfbas wcel cY cX cF wfo w3a vx cv cL wcel cA cF vx cv cima wceq wa wa cF
      vx cv imassrn a1i cX cvv wcel cB cfbas wcel cY cX cF wfo w3a cF crn cX
      wceq vx cv cL wcel cA cF vx cv cima wceq wa cY cX cF wfo cX cvv wcel cF
      crn cX wceq cB cfbas wcel cY cX cF forn 3ad2ant3 adantr sseqtrd eqsstrd
      vx cv cL wcel cA cF vx cv cima wceq wa cF vy cv cima cA wss vy cL wrex cX
      cvv wcel cB cfbas wcel cY cX cF wfo w3a vx cv cL wcel cF vx cv cima cA
      wss cF vy cv cima cA wss vy cL wrex cA cF vx cv cima wceq cF vy cv cima
      cA wss cF vx cv cima cA wss vy vx cv cL vy cv vx cv wceq cF vy cv cima cF
      vx cv cima cA vy cv vx cv cF imaeq2 sseq1d rcla4ev cF vx cv cima cA
      eqimss2 sylan2 adantl jca exp32 r19.23adv impbid bitrd 3coml mpd3an3 $.
      $( [1-Dec-2010] $) $( [1-Oct-2009] $)
  $}


  ${
    $d f s x y z $.
    $( Define a function that gives the limits of a function ` f ` in the
    filter sense.  (Contributed by Jeff Hankins, 5-Sep-2009.) $)
    df-flimf $a |- fLimf = { <. <. x , y >. , z >. | ( x e. Top /\ y e. Fil /\
    z = { <. f , s >. | ( f : U. y --> U. x /\ s = ( ( fLim1 ` x ) ` ( ( U. x
    FilMap y ) ` f ) ) ) } ) } $.
  $}

  ${
    $d f j l s z F $. $d f j l s z J $. $d f j l s z X $. $d f j l s z Y $. $d
    j l z f $.
    flimff.1 $e |- X = U. J $.
    flimff.2 $e |- Y = U. F $.
    $( Given a topology and a filtered set, return the convergence function on
       the functions from the filtered set to the base set of the topological
       space.  (Contributed by Jeff Hankins, 14-Oct-2009.)  $)
    flimff $p |- ( ( J e. Top /\ F e. Fil ) -> ( J fLimf F ) = { <. f , s >. |
    ( f : Y --> X /\ s = ( ( fLim1 ` J ) ` ( ( X FilMap F ) ` f ) ) ) } ) $=
      cJ ctop wcel cF cfil wcel cY cX vf cv wf vs cv vf cv cX cF cfilmap co cfv
      cJ cflim1 cfv cfv wceq wa vf vs copab cvv wcel cJ cF cflimf co cY cX vf
      cv wf vs cv vf cv cX cF cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs
      copab wceq cJ ctop wcel cF cfil wcel wa cY cX vf cv wf vs cv vf cv cX cF
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab vf cv cX cY cm co
      wcel vs cv vf cv cX cF cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs
      copab cvv cJ ctop wcel cF cfil wcel wa vf cv cX cY cm co wcel vs cv vf cv
      cX cF cfilmap co cfv cJ cflim1 cfv cfv wceq wa cY cX vf cv wf vs cv vf cv
      cX cF cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs cJ ctop wcel cF cfil
      wcel wa vf cv cX cY cm co wcel cY cX vf cv wf vs cv vf cv cX cF cfilmap
      co cfv cJ cflim1 cfv cfv wceq cX cvv wcel cY cvv wcel vf cv cX cY cm co
      wcel cY cX vf cv wf wb cJ ctop wcel cF cfil wcel cX cY vf cv cvv cvv
      elmapg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimff.1 syl5eqel cF
      cfil wcel cF cuni cvv cY cF cfil uniexg flimff.2 syl5eqel syl2an anbi1d
      opabbidv vf vs cX cY cm co vf cv cX cF cfilmap co cfv cJ cflim1 cfv cfv
      cX cY cm oprex opabex2 syl6eqelr vj vl vz cJ cF ctop cfil vl cv cuni vj
      cv cuni vf cv wf vs cv vf cv vj cv cuni vl cv cfilmap co cfv vj cv cflim1
      cfv cfv wceq wa vf vs copab cY cX vf cv wf vs cv vf cv cX cF cfilmap co
      cfv cJ cflim1 cfv cfv wceq wa vf vs copab cflimf vl cv cuni cX vf cv wf
      vs cv vf cv cX vl cv cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab
      cvv vj cv cJ wceq vl cv cuni vj cv cuni vf cv wf vs cv vf cv vj cv cuni
      vl cv cfilmap co cfv vj cv cflim1 cfv cfv wceq wa vl cv cuni cX vf cv wf
      vs cv vf cv cX vl cv cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs vj cv
      cJ wceq vl cv cuni vj cv cuni vf cv wf vl cv cuni cX vf cv wf vs cv vf cv
      vj cv cuni vl cv cfilmap co cfv vj cv cflim1 cfv cfv wceq vs cv vf cv cX
      vl cv cfilmap co cfv cJ cflim1 cfv cfv wceq vj cv cJ wceq vj cv cuni cX
      wceq vl cv cuni vj cv cuni vf cv wf vl cv cuni cX vf cv wf wb vj cv cJ
      wceq vj cv cuni cJ cuni cX vj cv cJ unieq flimff.1 syl6eqr vj cv cuni cX
      vl cv cuni vf cv feq3 syl vj cv cJ wceq vf cv vj cv cuni vl cv cfilmap co
      cfv vj cv cflim1 cfv cfv vf cv cX vl cv cfilmap co cfv cJ cflim1 cfv cfv
      vs cv vj cv cJ wceq vf cv vj cv cuni vl cv cfilmap co cfv vf cv cX vl cv
      cfilmap co cfv vj cv cflim1 cfv cJ cflim1 cfv vj cv cJ cflim1 fveq2 vj cv
      cJ wceq vf cv vj cv cuni vl cv cfilmap co cX vl cv cfilmap co vj cv cJ
      wceq vj cv cuni cX vl cv cfilmap vj cv cJ wceq vj cv cuni cJ cuni cX vj
      cv cJ unieq flimff.1 syl6eqr opreq1d fveq1d fveq12d eqeq2d anbi12d
      opabbidv vl cv cF wceq vl cv cuni cX vf cv wf vs cv vf cv cX vl cv
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa cY cX vf cv wf vs cv vf cv cX cF
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs vl cv cF wceq vl cv cuni
      cX vf cv wf cY cX vf cv wf vs cv vf cv cX vl cv cfilmap co cfv cJ cflim1
      cfv cfv wceq vs cv vf cv cX cF cfilmap co cfv cJ cflim1 cfv cfv wceq vl
      cv cF wceq vl cv cuni cY wceq vl cv cuni cX vf cv wf cY cX vf cv wf wb vl
      cv cF wceq vl cv cuni cF cuni cY vl cv cF unieq flimff.2 syl6eqr vl cv
      cuni cY cX vf cv feq2 syl vl cv cF wceq vf cv cX vl cv cfilmap co cfv cJ
      cflim1 cfv cfv vf cv cX cF cfilmap co cfv cJ cflim1 cfv cfv vs cv vl cv
      cF wceq vf cv cX vl cv cfilmap co cfv vf cv cX cF cfilmap co cfv cJ
      cflim1 cfv vl cv cF wceq vf cv cX vl cv cfilmap co cX cF cfilmap co vl cv
      cF cX cfilmap opreq2 fveq1d fveq2d eqeq2d anbi12d opabbidv cflimf vj cv
      ctop wcel vl cv cfil wcel vz cv vl cv cuni vj cv cuni vf cv wf vs cv vf
      cv vj cv cuni vl cv cfilmap co cfv vj cv cflim1 cfv cfv wceq wa vf vs
      copab wceq w3a vj vl vz copab2 vj cv ctop wcel vl cv cfil wcel wa vz cv
      vl cv cuni vj cv cuni vf cv wf vs cv vf cv vj cv cuni vl cv cfilmap co
      cfv vj cv cflim1 cfv cfv wceq wa vf vs copab wceq wa vj vl vz copab2 vj
      vl vz vf vs df-flimf vj cv ctop wcel vl cv cfil wcel vz cv vl cv cuni vj
      cv cuni vf cv wf vs cv vf cv vj cv cuni vl cv cfilmap co cfv vj cv cflim1
      cfv cfv wceq wa vf vs copab wceq w3a vj cv ctop wcel vl cv cfil wcel wa
      vz cv vl cv cuni vj cv cuni vf cv wf vs cv vf cv vj cv cuni vl cv cfilmap
      co cfv vj cv cflim1 cfv cfv wceq wa vf vs copab wceq wa vj vl vz vj cv
      ctop wcel vl cv cfil wcel vz cv vl cv cuni vj cv cuni vf cv wf vs cv vf
      cv vj cv cuni vl cv cfilmap co cfv vj cv cflim1 cfv cfv wceq wa vf vs
      copab wceq df-3an oprabbii eqtri oprabval2g mpd3an3 $.
      $( [1-Dec-2010] $) $( [14-Oct-2009] $)
  $}

  ${
    $d f s F $. $d f s J $. $d f s L $. $d f s X $. $d f s Y $.
    sflimf.1 $e |- X = U. J $.
    sflimf.2 $e |- Y = U. L $.
    $( Given a function from a filtered set to a topological space, define the
       set of limit points of the function.  (Contributed by Jeff Hankins,
       8-Nov-2009.) $)
    sflimf $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( ( J fLimf L ) `
    F ) = ( ( fLim1 ` J ) ` ( ( X FilMap L ) ` F ) ) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv cF cY cX
      vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs
      copab cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cF cJ cL cflimf co cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab cJ ctop wcel cL cfil
      wcel cJ cL cflimf co cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ
      cflim1 cfv cfv wceq wa vf vs copab wceq cY cX cF wf vf cL cJ cX cY vs
      sflimf.1 sflimf.2 flimff 3adant3 fveq1d cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab wfun cF cF cX cL
      cfilmap co cfv cJ cflim1 cfv cfv cop cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab wcel cF cY cX vf cv
      wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab
      cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cF cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cY cX
      vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs
      copab cF cX cL cfilmap co cfv cJ cflim1 cfv fvex funopfv cY cX vf cv wf
      vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab
      wfun cJ ctop wcel cL cfil wcel cY cX cF wf w3a cY cX vf cv wf vs cv vf cv
      cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab vs cv vf cv cX
      cL cfilmap co cfv cJ cflim1 cfv cfv wceq vf vs copab wss vs cv vf cv cX
      cL cfilmap co cfv cJ cflim1 cfv cfv wceq vf vs copab wfun cY cX vf cv wf
      vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab
      wfun cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv
      wceq wa vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq vf vs cY
      cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq
      pm3.27 ssopab2i vf vs vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv
      funopabeq cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv
      cfv wceq wa vf vs copab vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv
      cfv wceq vf vs copab funss mp2 a1i cJ ctop wcel cL cfil wcel cY cX cF wf
      w3a cF cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cop cY cX vf cv wf vs cv
      vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa vf vs copab wcel cY
      cX cF wf cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv wceq wa cJ ctop wcel cL cfil wcel cY cX cF wf w3a
      cY cX cF wf cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv wceq cJ ctop wcel cL cfil wcel cY cX cF wf 3simp3
      cF cX cL cfilmap co cfv cJ cflim1 cfv cfv eqid jctir cF cvv wcel cF cX cL
      cfilmap co cfv cJ cflim1 cfv cfv cvv wcel cF cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv cop cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ
      cflim1 cfv cfv wceq wa vf vs copab wcel cY cX cF wf cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa
      wb cJ ctop wcel cL cfil wcel cY cX cF wf w3a cY cX vf cv wf vs cv vf cv
      cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa cY cX cF wf vs cv cF cX cL
      cfilmap co cfv cJ cflim1 cfv cfv wceq wa cY cX cF wf cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq wa
      vf vs cF cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cvv cvv vf cv cF wceq
      cY cX vf cv wf cY cX cF wf vs cv vf cv cX cL cfilmap co cfv cJ cflim1 cfv
      cfv wceq vs cv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq cY cX vf cv
      cF feq1 vf cv cF wceq vf cv cX cL cfilmap co cfv cJ cflim1 cfv cfv cF cX
      cL cfilmap co cfv cJ cflim1 cfv cfv vs cv vf cv cF wceq vf cv cX cL
      cfilmap co cfv cF cX cL cfilmap co cfv cJ cflim1 cfv vf cv cF cX cL
      cfilmap co fveq2 fveq2d eqeq2d anbi12d vs cv cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv wceq vs cv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq
      cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv wceq cY cX cF wf vs cv cF cX cL cfilmap co cfv cJ cflim1
      cfv cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv eqeq1 anbi2d opelopabg
      cY cX cF wf cY cvv wcel cF cvv wcel cJ ctop wcel cL cfil wcel cY cX cF wf
      w3a cY cX cvv cF fex cJ ctop wcel cL cfil wcel cY cX cF wf 3simp3 cL cfil
      wcel cJ ctop wcel cY cvv wcel cY cX cF wf cL cfil wcel cL cuni cvv cY cL
      cfil uniexg sflimf.2 syl5eqel 3ad2ant2 sylanc cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv cvv wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cX
      cL cfilmap co cfv cJ cflim1 cfv fvex a1i sylanc mpbird sylc eqtrd $.
      $( [1-Dec-2010] $) $( [8-Nov-2009] $)
  $}

  ${
    $d n A $. $d n s F $. $d n J $. $d n s L $. $d n s X $. $d n s Y $.
    flimfnei.1 $e |- X = U. J $.
    flimfnei.2 $e |- Y = U. L $.
    $( The property of being a limit point of a function in terms of
       neighborhoods.  (Contributed by Jeff Hankins, 9-Nov-2009.) $)
    flimfnei $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( A e. ( ( J
    fLimf L ) ` F ) <-> ( A e. X /\ A. n e. ( ( nei ` J ) ` { A } ) E. s e. L (
    F " s ) C_ n ) ) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel
      cA cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel cA cX wcel cA csn cJ
      cnei cfv cfv cF cX cL cfilmap co cfv wss wa cA cX wcel cF vs cv cima vn
      cv wss vs cL wrex vn cA csn cJ cnei cfv cfv wral wa cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cF cJ cL cflimf co cfv cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv cA cF cJ cL cX cY flimfnei.1 flimfnei.2 sflimf eleq2d cJ
      ctop wcel cF cX cL cfilmap co cfv cfil wcel cX cF cX cL cfilmap co cfv
      cuni wceq cA cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel cA cX wcel cA
      csn cJ cnei cfv cfv cF cX cL cfilmap co cfv wss wa wb cJ ctop wcel cL
      cfil wcel cY cX cF wf w3a cA cF cX cL cfilmap co cfv cJ cX cF cX cL
      cfilmap co cfv cuni flimfnei.1 cF cX cL cfilmap co cfv cuni eqid isfillim
      cJ ctop wcel cL cfil wcel cY cX cF wf 3simp1 cX cvv wcel cL cfbas wcel cY
      cX cF wf cF cX cL cfilmap co cfv cfil wcel cJ ctop wcel cL cfil wcel cY
      cX cF wf w3a cvv cL cF cX cY flimfnei.2 fmf cJ ctop wcel cL cfil wcel cX
      cvv wcel cY cX cF wf cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      flimfnei.1 syl5eqel 3ad2ant1 cL cfil wcel cJ ctop wcel cL cfbas wcel cY
      cX cF wf cL filfbas 3ad2ant2 cJ ctop wcel cL cfil wcel cY cX cF wf 3simp3
      syl3anc cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv
      cuni cX cX cvv wcel cL cfbas wcel cY cX cF wf cF cX cL cfilmap co cfv
      cuni cX wceq cJ ctop wcel cL cfil wcel cY cX cF wf w3a cvv cL cF cX cY
      flimfnei.2 fmbas cJ ctop wcel cL cfil wcel cX cvv wcel cY cX cF wf cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnei.1 syl5eqel 3ad2ant1 cL
      cfil wcel cJ ctop wcel cL cfbas wcel cY cX cF wf cL filfbas 3ad2ant2 cJ
      ctop wcel cL cfil wcel cY cX cF wf 3simp3 syl3anc eqcomd syl3anc cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA csn cJ cnei cfv cfv cF cX cL cfilmap
      co cfv wss cF vs cv cima vn cv wss vs cL wrex vn cA csn cJ cnei cfv cfv
      wral cA cX wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a vn cv cF cX cL
      cfilmap co cfv wcel vn cA csn cJ cnei cfv cfv wral cF vs cv cima vn cv
      wss vs cL wrex vn cA csn cJ cnei cfv cfv wral cA csn cJ cnei cfv cfv cF
      cX cL cfilmap co cfv wss cJ ctop wcel cL cfil wcel cY cX cF wf w3a vn cv
      cF cX cL cfilmap co cfv wcel cF vs cv cima vn cv wss vs cL wrex vn cA csn
      cJ cnei cfv cfv cJ ctop wcel cL cfil wcel cY cX cF wf w3a vn cv cA csn cJ
      cnei cfv cfv wcel vn cv cX wss vn cv cF cX cL cfilmap co cfv wcel cF vs
      cv cima vn cv wss vs cL wrex wb cJ ctop wcel cL cfil wcel vn cv cA csn cJ
      cnei cfv cfv wcel vn cv cX wss cY cX cF wf cA csn cJ vn cv cX flimfnei.1
      neii1 3ad2antl1 cJ ctop wcel cL cfil wcel cY cX cF wf w3a vn cv cX wss wa
      vn cv cF cX cL cfilmap co cfv wcel vn cv cX wss cF vs cv cima vn cv wss
      vs cL wrex wa cF vs cv cima vn cv wss vs cL wrex cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a vn cv cF cX cL cfilmap co cfv wcel vn cv cX wss cF
      vs cv cima vn cv wss vs cL wrex wa wb vn cv cX wss cX cvv wcel cL cfbas
      wcel cY cX cF wf vn cv cF cX cL cfilmap co cfv wcel vn cv cX wss cF vs cv
      cima vn cv wss vs cL wrex wa wb cJ ctop wcel cL cfil wcel cY cX cF wf vs
      vn cv cL cvv cF cX cY flimfnei.2 elfilmap cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg flimfnei.1 syl5eqel cL filfbas cY cX cF wf id syl3an adantr
      vn cv cX wss cF vs cv cima vn cv wss vs cL wrex vn cv cX wss cF vs cv
      cima vn cv wss vs cL wrex wa wb cJ ctop wcel cL cfil wcel cY cX cF wf w3a
      vn cv cX wss cF vs cv cima vn cv wss vs cL wrex ibar adantl bitr4d syldan
      ralbidva vn cA csn cJ cnei cfv cfv cF cX cL cfilmap co cfv dfss3 syl5bb
      anbi2d 3bitrd $.
      $( [1-Dec-2010] $) $( [9-Nov-2009] $)
  $}

  ${
    $d n A $. $d n s F $. $d n J $. $d n s L $. $d n s N $. $d n s X $. $d n s
    Y $.
    flimfneii.1 $e |- X = U. J $.
    flimfneii.2 $e |- Y = U. L $.
    $( A neighborhood of a limit point of a function contains the image of a
       filter element.  (Contributed by Jeff Hankins, 11-Nov-2009.) $)
    flimfneii $p |- ( ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) /\ A e. ( ( J
    fLimf L ) ` F ) /\ N e. ( ( nei ` J ) ` { A } ) ) -> E. s e. L ( F " s ) C_
    N ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel
      cN cA csn cJ cnei cfv cfv wcel w3a cF vs cv cima vn cv wss vs cL wrex vn
      cA csn cJ cnei cfv cfv wral cF vs cv cima cN wss vs cL wrex cJ ctop wcel
      cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel cF vs cv cima
      vn cv wss vs cL wrex vn cA csn cJ cnei cfv cfv wral cN cA csn cJ cnei cfv
      cfv wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co
      cfv wcel cA cX wcel cF vs cv cima vn cv wss vs cL wrex vn cA csn cJ cnei
      cfv cfv wral cA vn cF cJ cL cX cY vs flimfneii.1 flimfneii.2 flimfnei
      pm3.27bda 3adant3 cN cA csn cJ cnei cfv cfv wcel cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cF vs cv cima vn cv wss vs cL wrex vn cA csn cJ cnei
      cfv cfv wral cF vs cv cima cN wss vs cL wrex wi cA cF cJ cL cflimf co cfv
      wcel cF vs cv cima vn cv wss vs cL wrex cF vs cv cima cN wss vs cL wrex
      vn cN cA csn cJ cnei cfv cfv vn cv cN wceq cF vs cv cima vn cv wss cF vs
      cv cima cN wss vs cL vn cv cN cF vs cv cima sseq2 rexbidv rcla4v 3ad2ant3
      mpd $.
      $( [1-Dec-2010] $) $( [11-Nov-2009] $)
  $}

  ${
    $d n o s A $. $d n o s F $. $d n o s J $. $d n o s X $. $d n o s Y $.
    flimopn.1 $e |- X = U. J $.
    flimopn.2 $e |- Y = U. F $.
    $( The condition for being a limit point of a filter still holds if one
       only considers open neighborhoods.  (Contributed by Jeff Hankins,
       4-Sep-2009.) $)
    flimopn $p |- ( ( ( J e. Top /\ F e. Fil /\ X = Y ) /\ A e. X ) -> ( A e. (
    ( fLim1 ` J ) ` F ) <-> A. o e. J ( A e. o -> o e. F ) ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA cF cJ cflim1
      cfv cfv wcel cA csn cJ cnei cfv cfv cF wss cA vo cv wcel vo cv cF wcel wi
      vo cJ wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel cA cF cJ
      cflim1 cfv cfv wcel cA csn cJ cnei cfv cfv cF wss wb cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel cA cF cJ cflim1 cfv cfv wcel wa cA cX wcel
      cA csn cJ cnei cfv cfv cF wss wa wb cA cX wcel cA cF cJ cflim1 cfv cfv
      wcel cA csn cJ cnei cfv cfv cF wss wb wi cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cflim1 cfv cfv wcel cA cX wcel cA cF cJ cflim1 cfv cfv
      wcel wa cA cX wcel cA csn cJ cnei cfv cfv cF wss wa cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cA cX wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cA cX wcel cA cF
      cJ cX cY flimopn.1 flimopn.2 flimelbas ex pm4.71rd cA cF cJ cX cY
      flimopn.1 flimopn.2 isfillim bitr3d cA cX wcel cA cF cJ cflim1 cfv cfv
      wcel cA csn cJ cnei cfv cfv cF wss pm5.32 sylibr imp cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa cA csn cJ cnei cfv cfv cF wss cA vo cv
      wcel vo cv cF wcel wi vo cJ wral cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa cA csn cJ cnei cfv cfv cF wss cA vo cv wcel vo cv cF wcel
      wi vo cJ cJ ctop wcel cF cfil wcel cA cX wcel cA csn cJ cnei cfv cfv cF
      wss vo cv cJ wcel cA vo cv wcel vo cv cF wcel wi wi wi cX cY wceq cJ ctop
      wcel cA cX wcel wa cA csn cJ cnei cfv cfv cF wss vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel cJ ctop wcel cA cX wcel wa vo cv cJ wcel cA vo cv wcel
      wa vo cv cA csn cJ cnei cfv cfv wcel cA csn cJ cnei cfv cfv cF wss vo cv
      cF wcel cJ ctop wcel vo cv cJ wcel cA vo cv wcel wa vo cv cA csn cJ cnei
      cfv cfv wcel wi cA cX wcel cJ ctop wcel vo cv cJ wcel cA vo cv wcel vo cv
      cA csn cJ cnei cfv cfv wcel cA cJ vo cv opnneip 3expib adantr cA csn cJ
      cnei cfv cfv cF vo cv ssel syl9 exp4a 3ad2antl1 r19.21adv cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv cF wcel wi vo
      cJ wral cA csn cJ cnei cfv cfv cF wss cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa cA vo cv wcel vo cv cF wcel wi vo cJ wral wa vn cA
      csn cJ cnei cfv cfv cF cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa cA vo cv wcel vo cv cF wcel wi vo cJ wral wa vn cv cA csn cJ cnei
      cfv cfv wcel vn cv cX wss cA csn vs cv wss vs cv vn cv wss wa vs cJ wrex
      wa vn cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vn cv cA csn cJ cnei cfv cfv wcel vn cv cX wss cA csn vs cv wss vs cv vn
      cv wss wa vs cJ wrex wa wb cA vo cv wcel vo cv cF wcel wi vo cJ wral cJ
      ctop wcel cF cfil wcel cA cX wcel vn cv cA csn cJ cnei cfv cfv wcel vn cv
      cX wss cA csn vs cv wss vs cv vn cv wss wa vs cJ wrex wa wb cX cY wceq cJ
      ctop wcel cA csn cX wss vn cv cA csn cJ cnei cfv cfv wcel vn cv cX wss cA
      csn vs cv wss vs cv vn cv wss wa vs cJ wrex wa wb cA cX wcel cA csn vs cJ
      vn cv cX flimopn.1 isnei cA cX snssi sylan2 3ad2antl1 adantr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv cF wcel wi
      vo cJ wral wa vn cv cX wss cA csn vs cv wss vs cv vn cv wss wa vs cJ wrex
      vn cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA
      vo cv wcel vo cv cF wcel wi vo cJ wral wa cA csn vs cv wss vs cv vn cv
      wss wa vs cJ wrex vn cv cX wss vn cv cF wcel cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv cF wcel wi vo cJ wral wa cA
      csn vs cv wss vs cv vn cv wss wa vn cv cX wss vn cv cF wcel wi vs cJ cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv
      cF wcel wi vo cJ wral vs cv cJ wcel cA csn vs cv wss vs cv vn cv wss wa
      vn cv cX wss vn cv cF wcel wi wi wi cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vs cv cJ wcel cA vo cv wcel vo cv cF wcel wi vo cJ wral
      cA csn vs cv wss vs cv vn cv wss wa vn cv cX wss vn cv cF wcel wi wi cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vs cv cJ wcel cA vo
      cv wcel vo cv cF wcel wi vo cJ wral cA csn vs cv wss vs cv vn cv wss wa
      vn cv cX wss vn cv cF wcel wi wi wi cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vs cv cJ wcel wa cA vo cv wcel vo cv cF wcel wi vo cJ
      wral cA vs cv wcel vs cv cF wcel wi cA csn vs cv wss vs cv vn cv wss wa
      vn cv cX wss vn cv cF wcel wi wi vs cv cJ wcel cA vo cv wcel vo cv cF
      wcel wi vo cJ wral cA vs cv wcel vs cv cF wcel wi wi cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv cF wcel wi cA vs cv
      wcel vs cv cF wcel wi vo vs cv cJ vo cv vs cv wceq cA vo cv wcel cA vs cv
      wcel vo cv cF wcel vs cv cF wcel vo cv vs cv cA eleq2 vo cv vs cv cF
      eleq1 imbi12d rcla4v adantl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vs cv cJ wcel wa cA csn vs cv wss vs cv vn cv wss wa cA vs cv
      wcel vs cv cF wcel wi vn cv cX wss vn cv cF wcel wi cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vs cv cJ wcel wa cA csn vs cv wss vs cv
      vn cv wss wa cA vs cv wcel vs cv vn cv wss wa cA vs cv wcel vs cv cF wcel
      wi vn cv cX wss vn cv cF wcel wi wi cA cX wcel cA vs cv wcel vs cv vn cv
      wss wa cA csn vs cv wss vs cv vn cv wss wa wb cJ ctop wcel cF cfil wcel
      cX cY wceq w3a vs cv cJ wcel cA cX wcel cA vs cv wcel cA csn vs cv wss vs
      cv vn cv wss cA vs cv cX snssg anbi1d ad2antlr cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vs cv cJ wcel wa cA vs cv wcel vs cv vn cv
      wss cA vs cv wcel vs cv cF wcel wi vn cv cX wss vn cv cF wcel wi wi cA vs
      cv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vs cv cJ
      wcel wa vs cv vn cv wss cA vs cv wcel vs cv cF wcel wi vn cv cX wss vn cv
      cF wcel wi wi wi cA vs cv wcel cA vs cv wcel vs cv cF wcel wi vs cv vn cv
      wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vs cv cJ wcel
      wa vn cv cX wss vn cv cF wcel wi cA vs cv wcel cA vs cv wcel vs cv cF
      wcel wi vs cv cF wcel vs cv vn cv wss cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vs cv cJ wcel wa vn cv cX wss vn cv cF wcel wi wi
      wi cA vs cv wcel vs cv cF wcel pm2.27 cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vs cv cJ wcel wa vs cv vn cv wss vs cv cF wcel vn
      cv cX wss vn cv cF wcel wi cJ ctop wcel cF cfil wcel cX cY wceq w3a vs cv
      vn cv wss vs cv cF wcel vn cv cX wss vn cv cF wcel wi wi wi cA cX wcel vs
      cv cJ wcel cF cfil wcel cX cY wceq vs cv vn cv wss vs cv cF wcel vn cv cX
      wss vn cv cF wcel wi wi wi cJ ctop wcel cF cfil wcel cX cY wceq wa vn cv
      cX wss vs cv cF wcel vs cv vn cv wss vn cv cF wcel cF cfil wcel cX cY
      wceq wa vn cv cX wss vn cv cY wss vs cv cF wcel vs cv vn cv wss vn cv cF
      wcel wi wi cX cY wceq vn cv cX wss vn cv cY wss wb cF cfil wcel cX cY vn
      cv sseq2 adantl cF cfil wcel vn cv cY wss vs cv cF wcel vs cv vn cv wss
      vn cv cF wcel wi wi wi cX cY wceq cF cfil wcel vs cv cF wcel vn cv cY wss
      vs cv vn cv wss vn cv cF wcel wi cF cfil wcel vs cv cF wcel vn cv cY wss
      vs cv vn cv wss vn cv cF wcel vs cv vn cv cF cY flimopn.2 fillsb 3expd
      com23 adantr sylbid com24 3adant1 ad2antrr com13 syl6 com24 com12 imp3a
      sylbird com23 syld ex com23 imp r19.23adv com23 imp3a sylbid ssrdv ex
      impbid bitrd $.
      $( [1-Dec-2010] $) $( [4-Sep-2009] $)
  $}

  ${
    $d o A $. $d o s F $. $d o J $. $d o s L $. $d o s X $. $d o s Y $.
    isflimf.1 $e |- X = U. J $.
    isflimf.2 $e |- Y = U. L $.
    $( The property of being a limit point of a function.  (Contributed by Jeff
       Hankins, 8-Nov-2009.) $)
    isflimf $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( A e. ( ( J
    fLimf L ) ` F ) <-> ( A e. X /\ A. o e. J ( A e. o -> E. s e. L ( F " s )
    C_ o ) ) ) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel
      cA cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel cA cX wcel cA vo cv
      wcel vo cv cF cX cL cfilmap co cfv wcel wi vo cJ wral wa cA cX wcel cA vo
      cv wcel cF vs cv cima vo cv wss vs cL wrex wi vo cJ wral wa cJ ctop wcel
      cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv cA cF cJ cL cX cY isflimf.1 isflimf.2 sflimf eleq2d
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv wcel cA cX wcel cA vo cv wcel vo cv cF cX cL cfilmap co
      cfv wcel wi vo cJ wral wa cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX
      wcel wa cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv wcel wa cJ ctop wcel cL cfil wcel cY cX cF wf w3a
      cA cX wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cX cL cfilmap
      co cfv cJ cflim1 cfv cfv wcel pm3.26 cJ ctop wcel cF cX cL cfilmap co cfv
      cfil wcel cX cF cX cL cfilmap co cfv cuni wceq w3a cA cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv wcel cA cX wcel cJ ctop wcel cL cfil wcel cY cX cF
      wf w3a cA cF cX cL cfilmap co cfv cJ cX cF cX cL cfilmap co cfv cuni
      isflimf.1 cF cX cL cfilmap co cfv cuni eqid flimelbas cJ ctop wcel cL
      cfil wcel cY cX cF wf w3a cJ ctop wcel cF cX cL cfilmap co cfv cfil wcel
      cX cF cX cL cfilmap co cfv cuni wceq cJ ctop wcel cL cfil wcel cY cX cF
      wf 3simp1 cX cvv wcel cL cfbas wcel cY cX cF wf cF cX cL cfilmap co cfv
      cfil wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cvv cL cF cX cY
      isflimf.2 fmf cJ ctop wcel cL cfil wcel cX cvv wcel cY cX cF wf cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg isflimf.1 syl5eqel 3ad2ant1 cL cfil
      wcel cJ ctop wcel cL cfbas wcel cY cX cF wf cL filfbas 3ad2ant2 cJ ctop
      wcel cL cfil wcel cY cX cF wf 3simp3 syl3anc cX cvv wcel cL cfbas wcel cY
      cX cF wf cX cF cX cL cfilmap co cfv cuni wceq cJ ctop wcel cL cfil wcel
      cY cX cF wf w3a cX cvv wcel cL cfbas wcel cY cX cF wf w3a cF cX cL
      cfilmap co cfv cuni cX cvv cL cF cX cY isflimf.2 fmbas eqcomd cJ ctop
      wcel cL cfil wcel cX cvv wcel cY cX cF wf cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg isflimf.1 syl5eqel 3ad2ant1 cL cfil wcel cJ ctop wcel cL
      cfbas wcel cY cX cF wf cL filfbas 3ad2ant2 cJ ctop wcel cL cfil wcel cY
      cX cF wf 3simp3 syl3anc 3jca sylan jca cA cX wcel cA vo cv wcel vo cv cF
      cX cL cfilmap co cfv wcel wi vo cJ wral wa cA cX wcel cJ ctop wcel cL
      cfil wcel cY cX cF wf w3a cA cX wcel cA vo cv wcel vo cv cF cX cL cfilmap
      co cfv wcel wi vo cJ wral pm3.26 anim2i cJ ctop wcel cL cfil wcel cY cX
      cF wf w3a cA cX wcel wa cA cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel
      cA vo cv wcel vo cv cF cX cL cfilmap co cfv wcel wi vo cJ wral cA cX wcel
      cA vo cv wcel vo cv cF cX cL cfilmap co cfv wcel wi vo cJ wral wa cJ ctop
      wcel cF cX cL cfilmap co cfv cfil wcel cX cF cX cL cfilmap co cfv cuni
      wceq w3a cA cX wcel cA cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel cA
      vo cv wcel vo cv cF cX cL cfilmap co cfv wcel wi vo cJ wral wb cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA vo cF cX cL cfilmap co cfv cJ cX cF
      cX cL cfilmap co cfv cuni isflimf.1 cF cX cL cfilmap co cfv cuni eqid
      flimopn cJ ctop wcel cL cfil wcel cY cX cF wf w3a cJ ctop wcel cF cX cL
      cfilmap co cfv cfil wcel cX cF cX cL cfilmap co cfv cuni wceq cJ ctop
      wcel cL cfil wcel cY cX cF wf 3simp1 cX cvv wcel cL cfbas wcel cY cX cF
      wf cF cX cL cfilmap co cfv cfil wcel cJ ctop wcel cL cfil wcel cY cX cF
      wf w3a cvv cL cF cX cY isflimf.2 fmf cJ ctop wcel cL cfil wcel cX cvv
      wcel cY cX cF wf cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg isflimf.1
      syl5eqel 3ad2ant1 cL cfil wcel cJ ctop wcel cL cfbas wcel cY cX cF wf cL
      filfbas 3ad2ant2 cJ ctop wcel cL cfil wcel cY cX cF wf 3simp3 syl3anc cX
      cvv wcel cL cfbas wcel cY cX cF wf cX cF cX cL cfilmap co cfv cuni wceq
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cX cvv wcel cL cfbas wcel cY cX
      cF wf w3a cF cX cL cfilmap co cfv cuni cX cvv cL cF cX cY isflimf.2 fmbas
      eqcomd cJ ctop wcel cL cfil wcel cX cvv wcel cY cX cF wf cJ ctop wcel cJ
      cuni cvv cX cJ ctop uniexg isflimf.1 syl5eqel 3ad2ant1 cL cfil wcel cJ
      ctop wcel cL cfbas wcel cY cX cF wf cL filfbas 3ad2ant2 cJ ctop wcel cL
      cfil wcel cY cX cF wf 3simp3 syl3anc 3jca sylan cA cX wcel cA vo cv wcel
      vo cv cF cX cL cfilmap co cfv wcel wi vo cJ wral cA cX wcel cA vo cv wcel
      vo cv cF cX cL cfilmap co cfv wcel wi vo cJ wral wa wb cJ ctop wcel cL
      cfil wcel cY cX cF wf w3a cA cX wcel cA vo cv wcel vo cv cF cX cL cfilmap
      co cfv wcel wi vo cJ wral ibar adantl bitrd pm5.21nd cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cA vo cv wcel vo cv cF cX cL cfilmap co cfv wcel wi
      vo cJ wral cA vo cv wcel cF vs cv cima vo cv wss vs cL wrex wi vo cJ wral
      cA cX wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA vo cv wcel vo cv
      cF cX cL cfilmap co cfv wcel wi cA vo cv wcel cF vs cv cima vo cv wss vs
      cL wrex wi vo cJ cJ ctop wcel cL cfil wcel cY cX cF wf w3a vo cv cJ wcel
      wa vo cv cF cX cL cfilmap co cfv wcel cF vs cv cima vo cv wss vs cL wrex
      cA vo cv wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a vo cv cJ wcel wa
      vo cv cF cX cL cfilmap co cfv wcel vo cv cX wss cF vs cv cima vo cv wss
      vs cL wrex wa cF vs cv cima vo cv wss vs cL wrex cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a vo cv cF cX cL cfilmap co cfv wcel vo cv cX wss cF
      vs cv cima vo cv wss vs cL wrex wa wb vo cv cJ wcel cX cvv wcel cL cfbas
      wcel cY cX cF wf vo cv cF cX cL cfilmap co cfv wcel vo cv cX wss cF vs cv
      cima vo cv wss vs cL wrex wa wb cJ ctop wcel cL cfil wcel cY cX cF wf w3a
      vs vo cv cL cvv cF cX cY isflimf.2 elfilmap cJ ctop wcel cL cfil wcel cX
      cvv wcel cY cX cF wf cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg isflimf.1
      syl5eqel 3ad2ant1 cL cfil wcel cJ ctop wcel cL cfbas wcel cY cX cF wf cL
      filfbas 3ad2ant2 cJ ctop wcel cL cfil wcel cY cX cF wf 3simp3 syl3anc
      adantr vo cv cJ wcel cF vs cv cima vo cv wss vs cL wrex vo cv cX wss cF
      vs cv cima vo cv wss vs cL wrex wa wb cJ ctop wcel cL cfil wcel cY cX cF
      wf w3a vo cv cJ wcel vo cv cX wss cF vs cv cima vo cv wss vs cL wrex vo
      cv cJ wcel vo cv cJ cuni cX vo cv cJ elssuni isflimf.1 syl6ssr biantrurd
      adantl bitr4d imbi2d ralbidva anbi2d 3bitrd $.
      $( [1-Dec-2010] $) $( [8-Nov-2009] $)
  $}

  ${
    $d o s A $. $d o s F $. $d o s J $. $d o s L $. $d o s X $. $d o s Y $.
    flimfelbas.1 $e |- X = U. J $.
    flimfelbas.2 $e |- Y = U. L $.
    $( A limit point of a function is in the topological space.  (Contributed
       by Jeff Hankins, 10-Nov-2009.) $)
    flimfelbas $p |- ( ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) /\ A e. ( ( J
    fLimf L ) ` F ) ) -> A e. X ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel
      cA cX wcel cA vo cv wcel cF vs cv cima vo cv wss vs cL wrex wi vo cJ wral
      cA vo cF cJ cL cX cY vs flimfelbas.1 flimfelbas.2 isflimf pm3.26bda $.
      $( [1-Dec-2010] $) $( [10-Nov-2009] $)
  $}


  ${
    $d F f x $. $d J f x $. $d X f x $.
    hausfillim2.1 $e |- X = U. J $.
    $( A condition for a topology to be Hausdorff in terms of filters.  A
       topology is Hausdorff iff every filter has at most one limit point.
       (Contributed by FL, 6-Dec-2010.) $)
    hausfillim2 $p |- ( ( J e. Haus /\ F e. Fil /\ X = U. F ) -> E*
    x x e. ( ( fLim1 ` J ) ` F ) ) $=
      cJ cha wcel cF cfil wcel cX cF cuni wceq vx cv cF cJ cflim1 cfv cfv wcel
      vx wmo cJ ctop wcel cJ cha wcel cF cfil wcel cX cF cuni wceq vx cv cF cJ
      cflim1 cfv cfv wcel vx wmo wi wi cJ haustop cJ ctop wcel cJ cha wcel cX
      vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx wmo wi vf cfil wral
      cF cfil wcel cX cF cuni wceq vx cv cF cJ cflim1 cfv cfv wcel vx wmo wi wi
      vx vf cJ cX hausfillim2.1 hausfillim cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel vx wmo wi cX cF cuni wceq vx cv cF cJ cflim1 cfv cfv
      wcel vx wmo wi vf cF cfil vf cv cF wceq cX vf cv cuni wceq cX cF cuni
      wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx wmo vx cv cF cJ cflim1 cfv cfv
      wcel vx wmo vf cv cF wceq vf cv cuni cF cuni cX vf cv cF unieq eqeq2d vf
      cv cF wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cJ cflim1 cfv cfv
      wcel vx vf cv cF wceq vx ax-17 vf cv cF wceq vf cv cJ cflim1 cfv cfv cF
      cJ cflim1 cfv cfv vx cv vf cv cF cJ cflim1 cfv fveq2 eleq2d mobid imbi12d
      rcla4cv syl6bi mpcom 3imp $.
      $( [1-Dec-2010] $) $( [14-Nov-2010] $)
  $}

  ${

    holimf.1 $e |- Y = U. L $.
    holimf.2 $e |- X = U. J $.
    ${
    $d F x $. $d J x $. $d L x $. $d X x $. $d Y x $.
    $( If a function has its values in a Hausdorff space then it has at most
       one limit value.  (Contributed by FL, 6-Dec-2010.) $)
    holimf $p |- ( ( L e. Fil /\ J e. Haus /\ F : Y --> X )
       -> E* x  x e. ( ( J fLimf L ) ` F ) ) $=
      cL cfil wcel cJ cha wcel cY cX cF wf w3a vx cv cF cJ cL cflimf co cfv
      wcel vx wmo vx cv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel vx wmo
      cJ cha wcel cF cX cL cfilmap co cfv cfil wcel cX cF cX cL cfilmap co cfv
      cuni wceq vx cv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wcel vx wmo cL
      cfil wcel cJ cha wcel cY cX cF wf w3a vx cF cX cL cfilmap co cfv cJ cX
      holimf.2 hausfillim2 cL cfil wcel cJ cha wcel cY cX cF wf 3simp2 cX cvv
      wcel cL cfbas wcel cY cX cF wf cF cX cL cfilmap co cfv cfil wcel cL cfil
      wcel cJ cha wcel cY cX cF wf w3a cvv cL cF cX cY holimf.1 fmf cJ cha wcel
      cL cfil wcel cX cvv wcel cY cX cF wf cJ cha wcel cJ cuni cvv cX cJ cha
      uniexg holimf.2 syl5eqel 3ad2ant2 cL cfil wcel cJ cha wcel cL cfbas wcel
      cY cX cF wf cL filfbas 3ad2ant1 cL cfil wcel cJ cha wcel cY cX cF wf
      3simp3 syl3anc cL cfil wcel cJ cha wcel cY cX cF wf w3a cF cX cL cfilmap
      co cfv cuni cX cX cvv wcel cL cfbas wcel cY cX cF wf cF cX cL cfilmap co
      cfv cuni cX wceq cL cfil wcel cJ cha wcel cY cX cF wf w3a cvv cL cF cX cY
      holimf.1 fmbas cJ cha wcel cL cfil wcel cX cvv wcel cY cX cF wf cJ cha
      wcel cJ cuni cvv cX cJ cha uniexg holimf.2 syl5eqel 3ad2ant2 cL cfil wcel
      cJ cha wcel cL cfbas wcel cY cX cF wf cL filfbas 3ad2ant1 cL cfil wcel cJ
      cha wcel cY cX cF wf 3simp3 syl3anc eqcomd syl3anc cL cfil wcel cJ cha
      wcel cY cX cF wf w3a vx cv cF cJ cL cflimf co cfv wcel vx cv cF cX cL
      cfilmap co cfv cJ cflim1 cfv cfv wcel vx cL cfil wcel cJ cha wcel cY cX
      cF wf w3a vx ax-17 cL cfil wcel cJ cha wcel cY cX cF wf w3a cF cJ cL
      cflimf co cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv vx cv cJ ctop
      wcel cL cfil wcel cY cX cF wf cF cJ cL cflimf co cfv cF cX cL cfilmap co
      cfv cJ cflim1 cfv cfv wceq cL cfil wcel cJ cha wcel cY cX cF wf w3a cF cJ
      cL cX cY holimf.2 holimf.1 sflimf cJ cha wcel cL cfil wcel cJ ctop wcel
      cY cX cF wf cJ haustop 3ad2ant2 cL cfil wcel cJ cha wcel cY cX cF wf
      3simp1 cL cfil wcel cJ cha wcel cY cX cF wf 3simp3 syl3anc eleq2d mobid
      mpbird $.
      $( [1-Dec-2010] $) $( [14-Nov-2010] $)
    $}

    ${
      $d F x $. $d J x $. $d L x $. $d X x $. $d Y x $.
    $( If a convergent function has its values in a Hausdorff space then it has
       only one limit value.  (Contributed by FL, 6-Dec-2010.) $)
    holimf2 $p |- ( ( ( L e. Fil /\ J e. Haus /\ F : Y --> X ) /\
                   ( ( J fLimf L ) ` F ) =/= (/) )
       -> E! x  x e. ( ( J fLimf L ) ` F ) ) $=
      cL cfil wcel cJ cha wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa
      vx cv cF cJ cL cflimf co cfv wcel vx wmo vx cv cF cJ cL cflimf co cfv
      wcel vx weu cL cfil wcel cJ cha wcel cY cX cF wf w3a vx cv cF cJ cL
      cflimf co cfv wcel vx wmo cF cJ cL cflimf co cfv c0 wne vx cF cJ cL cX cY
      holimf.1 holimf.2 holimf adantr cF cJ cL cflimf co cfv c0 wne vx cv cF cJ
      cL cflimf co cfv wcel vx wmo vx cv cF cJ cL cflimf co cfv wcel vx weu wb
      cL cfil wcel cJ cha wcel cY cX cF wf w3a vx cF cJ cL cflimf co cfv
      equnamo adantl mpbid $.
      $( [1-Dec-2010] $) $( [14-Nov-2010] $)
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Compactness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Comp $.

  $( Extend class notation with the class of all compact spaces. $)
  ccomp $a class Comp $.

  ${ $d x y z $.
    $( Definition of a compact topology. A topology is compact iff any open
    covering of its underlying set contains a finite sub-covering
    (Heine-Borel property).
    Bourbaki TG I.59  prop C''' . Note: Bourbaki
    uses the term quasi-compact topology but it is not the modern usage
    (which we follow).  (Contributed by FL, 22-Dec-2008.) $)
    df-comp $a  |- Comp = { x e. Top | A. y e. ~P x ( U. x = U. y
      -> E. z e. ( ~P y i^i Fin )  U. x = U. z ) } $.
  $}

  ${ $d J x y z $.
    $( The predicate "is a compact topology".  (Contributed by FL,
       22-Dec-2008.) $)
    iscomp $p |- ( J e. Comp <-> ( J e. Top /\ A. y e. ~P J
      ( U. J = U. y -> E. z e. ( ~P y i^i Fin )  U. J = U. z ) ) ) $=
      vx cv cuni vy cv cuni wceq vx cv cuni vz cv cuni wceq vz vy cv cpw cfn
      cin wrex wi vy vx cv cpw wral cJ cuni vy cv cuni wceq cJ cuni vz cv cuni
      wceq vz vy cv cpw cfn cin wrex wi vy cJ cpw wral vx cJ ctop ccomp vx cv
      cJ wceq vx cv cuni vy cv cuni wceq vx cv cuni vz cv cuni wceq vz vy cv
      cpw cfn cin wrex wi cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq vz vy
      cv cpw cfn cin wrex wi vy vx cv cpw cJ cpw vx cv cJ pweq vx cv cJ wceq vx
      cv cuni vy cv cuni wceq cJ cuni vy cv cuni wceq vx cv cuni vz cv cuni
      wceq vz vy cv cpw cfn cin wrex cJ cuni vz cv cuni wceq vz vy cv cpw cfn
      cin wrex vx cv cJ wceq vx cv cuni cJ cuni vy cv cuni vx cv cJ unieq
      eqeq1d vx cv cJ wceq vx cv cuni vz cv cuni wceq cJ cuni vz cv cuni wceq
      vz vy cv cpw cfn cin vx cv cJ wceq vx cv cuni cJ cuni vz cv cuni vx cv cJ
      unieq eqeq1d rexbidv imbi12d raleq12d vx vy vz df-comp elrab2 $.
      $( [1-Dec-2010] $) $( [22-Dec-2008] $)
  $}

  ${
    $d c d o r s u v x y F $. $d c d o r s u v x y J $. $d c d o r s u v x y K
    $. $d c d o r s u v x y X $. $d c d o r s u v x y Y $.
    cncomp.1 $e |- X = U. J $.
    cncomp.2 $e |- Y = U. K $.
    $( Compactness is respected by a continuous onto map.  (Contributed by
       Jeff Hankins, 12-Jul-2009.) $)
    cncomp $p |- ( ( ( J e. Comp /\ K e. Top ) /\ ( F : X -onto-> Y /\ F e. ( J
    Cn K ) ) ) -> K e. Comp ) $=
      cJ ccomp wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK
      ctop wcel cK cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw
      cfn cin wrex wi vu cK cpw wral wa cK ccomp wcel cJ ccomp wcel cK ctop
      wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK ctop wcel cK cuni vu
      cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex wi vu cK
      cpw wral cJ ccomp wcel cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel wa
      simplr cJ ccomp wcel cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel cK
      cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex wi
      vu cK cpw wral cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel cJ ccomp
      wcel cK cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin
      wrex wi vu cK cpw wral cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel cJ
      ccomp wcel cK cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw
      cfn cin wrex wi vu cK cpw wral wi cK ctop wcel cX cY cF wfo wa cF cJ cK
      ccn co wcel wa cJ ctop wcel cJ cuni vr cv cuni wceq cJ cuni vs cv cuni
      wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw wral wa cK cuni vu cv cuni
      wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex wi vu cK cpw wral
      cJ ccomp wcel cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel cJ ctop wcel
      cJ cuni vr cv cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex
      wi vr cJ cpw wral cK cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu
      cv cpw cfn cin wrex wi vu cK cpw wral cJ ctop wcel cK ctop wcel cX cY cF
      wfo cF cJ cK ccn co wcel cJ cuni vr cv cuni wceq cJ cuni vs cv cuni wceq
      vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cK cuni vu cv cuni wceq cK
      cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex wi vu cK cpw wral wi cJ
      ctop wcel cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel cJ cuni vr cv
      cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw
      wral cK cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin
      wrex wi vu cK cpw wral wi cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ
      cK ccn co wcel wa wa cJ cuni vr cv cuni wceq cJ cuni vs cv cuni wceq vs
      vr cv cpw cfn cin wrex wi vr cJ cpw wral cK cuni vu cv cuni wceq cK cuni
      vv cv cuni wceq vv vu cv cpw cfn cin wrex wi vu cK cpw cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cJ cuni vr cv cuni
      wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw wral
      vu cv cK wss cK cuni vu cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw
      cfn cin wrex wi vu cv cK cpw wcel cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss cJ
      cuni vr cv cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi
      vr cJ cpw wral cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu
      cv cuni wceq vu cv cK wss cJ cuni vr cv cuni wceq cJ cuni vs cv cuni wceq
      vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cK cuni vv cv cuni wceq vv vu
      cv cpw cfn cin wrex wi cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK
      ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a cJ cuni vr cv
      cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw
      wral cJ cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni wceq
      cJ cuni vs cv cuni wceq vs vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx
      cab cpw cfn cin wrex wi cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex
      cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK
      cuni vu cv cuni wceq vu cv cK wss w3a vx cv cF ccnv vy cv cima wceq vy vu
      cv wrex vx cab cJ cpw wcel cJ cuni vr cv cuni wceq cJ cuni vs cv cuni
      wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cJ cuni vx cv cF ccnv vy
      cv cima wceq vy vu cv wrex vx cab cuni wceq cJ cuni vs cv cuni wceq vs vx
      cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw cfn cin wrex wi wi cJ
      ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni
      vu cv cuni wceq vu cv cK wss w3a vx cv cF ccnv vy cv cima wceq vy vu cv
      wrex vx cab cJ wss vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cJ
      cpw wcel cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel
      wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vo vx cv cF ccnv vy cv
      cima wceq vy vu cv wrex vx cab cJ cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a
      vo cv cF ccnv vy cv cima wceq vy vu cv wrex vo cv cJ wcel vo cv vx cv cF
      ccnv vy cv cima wceq vy vu cv wrex vx cab wcel cJ ctop wcel cK ctop wcel
      wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv
      cK wss w3a vo cv cF ccnv vy cv cima wceq vo cv cJ wcel vy vu cv cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu
      cv cuni wceq vu cv cK wss w3a vy cv vu cv wcel vo cv cF ccnv vy cv cima
      wceq vo cv cJ wcel cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn
      co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vy cv vu cv wcel
      vo cv cF ccnv vy cv cima wceq w3a vo cv cF ccnv vy cv cima cJ cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu
      cv cuni wceq vu cv cK wss w3a vy cv vu cv wcel vo cv cF ccnv vy cv cima
      wceq 3simp3 cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vy cv vu cv wcel cF
      ccnv vy cv cima cJ wcel vo cv cF ccnv vy cv cima wceq cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vu cv cK wss vy cv
      vu cv wcel cF ccnv vy cv cima cJ wcel cK cuni vu cv cuni wceq cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vu cv cK wss
      vy cv vu cv wcel cF ccnv vy cv cima cJ wcel cJ ctop wcel cK ctop wcel wa
      cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel cF ccnv vy cv cima
      cJ wcel vu cv cK wss vy cv vu cv wcel wa cJ ctop wcel cK ctop wcel wa cF
      cJ cK ccn co wcel vy cv cK wcel cF ccnv vy cv cima cJ wcel cX cY cF wfo
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel wa vy cv cK wcel cF
      ccnv vy cv cima cJ wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel vy
      cv cK wcel cF ccnv vy cv cima cJ wcel wi cJ ctop wcel cK ctop wcel cF cJ
      cK ccn co wcel w3a vy cv cK wcel cF ccnv vy cv cima cJ wcel vy cv cF cJ
      cK cnima ex 3expa imp adantlrl vu cv cK vy cv ssel2 sylan2 anassrs
      3adantl2 3adant3 eqeltrd 3exp r19.23adv vx cv cF ccnv vy cv cima wceq vy
      vu cv wrex vo cv cF ccnv vy cv cima wceq vy vu cv wrex vx vo cv vo visset
      vx cv vo cv wceq vx cv cF ccnv vy cv cima wceq vo cv cF ccnv vy cv cima
      wceq vy vu cv vx cv vo cv cF ccnv vy cv cima eqeq1 rexbidv elab syl5ib
      ssrdv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cJ vy vx vu cv
      cF ccnv vy cv cima vu visset abrexex elpw sylibr cJ cuni vr cv cuni wceq
      cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi cJ cuni vx cv cF
      ccnv vy cv cima wceq vy vu cv wrex vx cab cuni wceq cJ cuni vs cv cuni
      wceq vs vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw cfn cin
      wrex wi vr vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cJ cpw vr
      cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wceq cJ cuni vr cv
      cuni wceq cJ cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni
      wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex cJ cuni vs cv cuni
      wceq vs vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw cfn cin
      wrex vr cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wceq vr cv
      cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni cJ cuni vr
      cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab unieq eqeq2d vr cv
      vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wceq cJ cuni vs cv
      cuni wceq vs vr cv cpw cfn cin vx cv cF ccnv vy cv cima wceq vy vu cv
      wrex vx cab cpw cfn cin vr cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex
      vx cab wceq vr cv cpw vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab
      cpw cfn vr cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab pweq
      ineq1d rexeq1d imbi12d rcla4v syl cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a
      cJ cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni wceq cJ
      cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni wceq cJ cuni
      vs cv cuni wceq vs vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw
      cfn cin wrex wi cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex wi cJ
      ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni
      vu cv cuni wceq vu cv cK wss w3a cJ cuni vy vu cv cF ccnv vy cv cima ciun
      vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni
      wceq vu cv cK wss w3a cJ cuni cF ccnv vu cv cuni cima vy vu cv cF ccnv vy
      cv cima ciun cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a cJ cuni cF ccnv cK
      cuni cima cF ccnv vu cv cuni cima cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq cJ cuni cF ccnv cK
      cuni cima wceq vu cv cK wss cX cY cF wfo cJ cuni cF ccnv cK cuni cima
      wceq cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cF cdm cX wceq cF
      crn cY wceq cJ cuni cF ccnv cK cuni cima wceq cX cY cF wfo cF cdm cX wceq
      cF crn cY wceq wa cX cF ccnv cY cima cJ cuni cF ccnv cK cuni cima cF cdm
      cX wceq cF crn cY wceq wa cF ccnv cF crn cima cF cdm cF ccnv cY cima cX
      cF ccnv cF crn cima cF cdm wceq cF cdm cX wceq cF crn cY wceq wa cF
      cvimarndm a1i cF cdm cX wceq cF crn cY wceq wa cF crn cY cF ccnv cF cdm
      cX wceq cF crn cY wceq pm3.27 imaeq2d cF cdm cX wceq cF crn cY wceq
      pm3.26 3eqtr3rd cncomp.1 cY cK cuni cF ccnv cncomp.2 imaeq2i 3eqtr3g cX
      cY cF wfo cF cX wfn cF cdm cX wceq cX cY cF fofn cX cF fndm syl cX cY cF
      forn sylanc ad2antrl 3ad2ant1 cK cuni vu cv cuni wceq cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cF ccnv cK cuni cima
      cF ccnv vu cv cuni cima wceq vu cv cK wss cK cuni vu cv cuni cF ccnv
      imaeq2 3ad2ant2 eqtrd vy cF ccnv vu cv imaiun syl6eq cJ ctop wcel cK ctop
      wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq
      vu cv cK wss w3a cF ccnv vy cv cima cvv wcel vy vu cv wral vy vu cv cF
      ccnv vy cv cima ciun vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab
      cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel
      wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a cF ccnv vy cv cima cvv
      wcel vy vu cv cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a cF ccnv vy cv cima
      cvv wcel vy cv vu cv wcel cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ
      cK ccn co wcel wa wa cK cuni vu cv cuni wceq cF ccnv vy cv cima cvv wcel
      vu cv cK wss cF cJ cK ccn co wcel cF ccnv vy cv cima cvv wcel cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel cF ccnv cvv wcel
      cF ccnv vy cv cima cvv wcel cF cJ cK ccn co cnvexg cF ccnv vy cv cvv
      imaexg syl ad2antll 3ad2ant1 a1d r19.21aiv vy vx vu cv cF ccnv vy cv cima
      cvv dfiun2g syl eqtrd cJ cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex
      vx cab cuni wceq cJ cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx
      cab cuni wceq cJ cuni vs cv cuni wceq vs vx cv cF ccnv vy cv cima wceq vy
      vu cv wrex vx cab cpw cfn cin wrex wi cJ cuni vs cv cuni wceq vs vx cv cF
      ccnv vy cv cima wceq vy vu cv wrex vx cab cpw cfn cin wrex cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv
      cuni wceq vu cv cK wss w3a cK cuni vv cv cuni wceq vv vu cv cpw cfn cin
      wrex cJ cuni vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cuni wceq
      cJ cuni vs cv cuni wceq vs vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx
      cab cpw cfn cin wrex pm2.27 cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF
      cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a cJ cuni
      vs cv cuni wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex vs vx
      cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw cfn cin cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv
      cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv
      wrex vx cab wss vs cv cfn wcel wa cJ cuni vs cv cuni wceq cK cuni vv cv
      cuni wceq vv vu cv cpw cfn cin wrex wi vs cv vx cv cF ccnv vy cv cima
      wceq vy vu cv wrex vx cab cpw cfn cin wcel cJ ctop wcel cK ctop wcel wa
      cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK
      wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs
      cv cfn wcel wa cJ cuni vs cv cuni wceq cK cuni vv cv cuni wceq vv vu cv
      cpw cfn cin wrex vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv cpw
      cfn cin wcel cK cuni vd cv cF vc cv cima wceq vc vs cv wrex vd cab cuni
      wceq cK cuni vv cv cuni wceq vv vu cv cpw cfn cin wrex cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni
      wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex
      vx cab wss vs cv cfn wcel wa cJ cuni vs cv cuni wceq w3a cK cuni vv cv
      cuni wceq cK cuni vd cv cF vc cv cima wceq vc vs cv wrex vd cab cuni wceq
      vv vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv cpw cfn cin vv cv
      vd cv cF vc cv cima wceq vc vs cv wrex vd cab wceq vv cv cuni vd cv cF vc
      cv cima wceq vc vs cv wrex vd cab cuni cK cuni vv cv vd cv cF vc cv cima
      wceq vc vs cv wrex vd cab unieq eqeq2d rcla4ev cJ ctop wcel cK ctop wcel
      wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv
      cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss
      vs cv cfn wcel wa cJ cuni vs cv cuni wceq w3a vd cv cF vc cv cima wceq vc
      vs cv wrex vd cab vu cv wss vd cv cF vc cv cima wceq vc vs cv wrex vd cab
      cfn wcel wa vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv cpw cfn
      cin wcel cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel
      wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv
      cima wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa cJ cuni vs cv cuni
      wceq w3a vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv wss vd cv cF
      vc cv cima wceq vc vs cv wrex vd cab cfn wcel cJ ctop wcel cK ctop wcel
      wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv
      cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss
      vs cv cfn wcel wa cJ cuni vs cv cuni wceq w3a vo vd cv cF vc cv cima wceq
      vc vs cv wrex vd cab vu cv cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF
      cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vs cv vx
      cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa cJ
      cuni vs cv cuni wceq w3a vo cv cF vc cv cima wceq vc vs cv wrex vo cv vu
      cv wcel vo cv vd cv cF vc cv cima wceq vc vs cv wrex vd cab wcel cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu
      cv cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu
      cv wrex vx cab wss vs cv cfn wcel wa cJ cuni vs cv cuni wceq w3a vo cv cF
      vc cv cima wceq vo cv vu cv wcel vc vs cv cJ ctop wcel cK ctop wcel wa cX
      cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss
      w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv
      cfn wcel wa vc cv vs cv wcel vo cv cF vc cv cima wceq vo cv vu cv wcel wi
      wi cJ cuni vs cv cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF
      cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vs cv vx
      cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vc cv vs cv wcel vo
      cv cF vc cv cima wceq vo cv vu cv wcel wi wi vs cv cfn wcel cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv
      cuni wceq vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vc
      cv vs cv wcel vo cv cF vc cv cima wceq vo cv vu cv wcel wi wi vu cv cK
      wss cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa
      cK cuni vu cv cuni wceq vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex
      vx cab wss vc cv vs cv wcel vo cv cF vc cv cima wceq vo cv vu cv wcel wi
      wi vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vc cv vs
      cv wcel cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa
      wa cK cuni vu cv cuni wceq vo cv cF vc cv cima wceq vo cv vu cv wcel wi
      vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vc cv vs cv
      wcel vc cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wcel cJ
      ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni
      vu cv cuni wceq vo cv cF vc cv cima wceq vo cv vu cv wcel wi wi wi vs cv
      vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab vc cv ssel vc cv vx cv
      cF ccnv vy cv cima wceq vy vu cv wrex vx cab wcel vc cv cF ccnv vy cv
      cima wceq vy vu cv wrex cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ
      cK ccn co wcel wa wa cK cuni vu cv cuni wceq vo cv cF vc cv cima wceq vo
      cv vu cv wcel wi wi wi vx cv cF ccnv vy cv cima wceq vy vu cv wrex vc cv
      cF ccnv vy cv cima wceq vy vu cv wrex vx vc cv vc visset vx cv vc cv wceq
      vx cv cF ccnv vy cv cima wceq vc cv cF ccnv vy cv cima wceq vy vu cv vx
      cv vc cv cF ccnv vy cv cima eqeq1 rexbidv elab vc cv cF ccnv vy cv cima
      wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa
      cK cuni vu cv cuni wceq vo cv cF vc cv cima wceq vo cv vu cv wcel wi wi
      wi vy vu cv vy cv vu cv wcel cF vc cv cima cF cF ccnv vy cv cima cima
      wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa
      cK cuni vu cv cuni wceq vo cv cF vc cv cima wceq vo cv vu cv wcel wi wi
      wi vc cv cF ccnv vy cv cima wceq vo cv cF vc cv cima wceq cF vc cv cima
      cF cF ccnv vy cv cima cima wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo
      cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vy cv vu cv wcel vo cv
      vu cv wcel vo cv cF vc cv cima wceq cF vc cv cima cF cF ccnv vy cv cima
      cima wceq vo cv cF cF ccnv vy cv cima cima wceq cJ ctop wcel cK ctop wcel
      wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vy cv
      vu cv wcel vo cv vu cv wcel wi wi wi vo cv cF vc cv cima wceq cF vc cv
      cima cF cF ccnv vy cv cima cima wceq vo cv cF cF ccnv vy cv cima cima
      wceq vo cv cF vc cv cima cF cF ccnv vy cv cima cima eqtr ex cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vo cv cF cF ccnv
      vy cv cima cima wceq cK cuni vu cv cuni wceq vy cv vu cv wcel vo cv vu cv
      wcel wi wi cX cY cF wfo vo cv cF cF ccnv vy cv cima cima wceq cK cuni vu
      cv cuni wceq vy cv vu cv wcel vo cv vu cv wcel wi wi wi cJ ctop wcel cK
      ctop wcel wa cF cJ cK ccn co wcel cK cuni vu cv cuni wceq vy cv vu cv
      wcel cX cY cF wfo vo cv cF cF ccnv vy cv cima cima wceq vo cv vu cv wcel
      cK cuni vu cv cuni wceq vy cv vu cv wcel vy cv cK cuni wss cX cY cF wfo
      vo cv cF cF ccnv vy cv cima cima wceq vo cv vu cv wcel wi wi cK cuni vu
      cv cuni wceq vy cv cK cuni wss vy cv vu cv cuni wss vy cv vu cv wcel cK
      cuni vu cv cuni vy cv sseq2 vy cv vu cv elssuni syl5bir vo cv cF cF ccnv
      vy cv cima cima wceq vy cv cK cuni wss cX cY cF wfo vy cv vu cv wcel vo
      cv vu cv wcel cX cY cF wfo vy cv cK cuni wss vo cv cF cF ccnv vy cv cima
      cima wceq vy cv vu cv wcel vo cv vu cv wcel wi cX cY cF wfo vy cv cK cuni
      wss vo cv cF cF ccnv vy cv cima cima wceq vy cv vu cv wcel vo cv vu cv
      wcel wi wi cX cY cF wfo vy cv cK cuni wss wa vo cv cF cF ccnv vy cv cima
      cima wceq vo cv vy cv wceq vy cv vu cv wcel vo cv vu cv wcel wi cX cY cF
      wfo vy cv cK cuni wss wa vy cv cF cF ccnv vy cv cima cima vo cv cX cY cF
      wfo vy cv cY wss vy cv cF cF ccnv vy cv cima cima wceq vy cv cK cuni wss
      cX cY cF wfo vy cv cY wss wa cF cF ccnv vy cv cima cima vy cv cX cY vy cv
      cF foimacnv eqcomd cY cK cuni vy cv cncomp.2 sseq2i sylan2br eqeq2d vo cv
      vy cv wceq vo cv vu cv wcel vy cv vu cv wcel vo cv vy cv vu cv eleq1
      biimprd syl6bir ex com13 com14 sylcom com4t ad2antrl com12 syl6 com15 vc
      cv cF ccnv vy cv cima cF imaeq2 syl5 r19.23aiv sylbi syl6 com4t imp31
      3adantl3 adantrr 3adant3 r19.23adv vd cv cF vc cv cima wceq vc vs cv wrex
      vo cv cF vc cv cima wceq vc vs cv wrex vd vo cv vo visset vd cv vo cv
      wceq vd cv cF vc cv cima wceq vo cv cF vc cv cima wceq vc vs cv vd cv vo
      cv cF vc cv cima eqeq1 rexbidv elab syl5ib ssrdv cJ ctop wcel cK ctop
      wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq
      vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab
      wss vs cv cfn wcel wa vd cv cF vc cv cima wceq vc vs cv wrex vd cab cfn
      wcel cJ cuni vs cv cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF
      cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss vs cv vx cv
      cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa vd cv
      cF vc cv cima wceq vc vs cv wrex vd cab cfn wcel cJ ctop wcel cK ctop
      wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vu cv cK wss vs cv vx cv
      cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa vd cv
      cF vc cv cima wceq vc vs cv wrex vd cab cfn wcel wi wi cK cuni vu cv cuni
      wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa
      vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn
      wcel wa vd cv cF vc cv cima wceq vc vs cv wrex vd cab cfn wcel wi vu cv
      cK wss cF cJ cK ccn co wcel vs cv vx cv cF ccnv vy cv cima wceq vy vu cv
      wrex vx cab wss vs cv cfn wcel wa vd cv cF vc cv cima wceq vc vs cv wrex
      vd cab cfn wcel wi cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn
      co wcel vs cv cfn wcel vd cv cF vc cv cima wceq vc vs cv wrex vd cab cfn
      wcel vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss cF cJ
      cK ccn co wcel vs cv cfn wcel vd cv cF vc cv cima wceq vc vs cv wrex vd
      cab cfn wcel cF cJ cK ccn co wcel vs cv cfn wcel wa vc cv vs cv wcel vd
      cv cF vc cv cima wceq wa vc vd copab crn cfn vd cv cF vc cv cima wceq vc
      vs cv wrex vd cab cF cJ cK ccn co wcel vs cv cfn wcel wa vc cv vs cv wcel
      vd cv cF vc cv cima wceq wa vc vd copab crn vs cv cdom wbr vc cv vs cv
      wcel vd cv cF vc cv cima wceq wa vc vd copab crn cfn wcel vs cv vc cv vs
      cv wcel vd cv cF vc cv cima wceq wa vc vd copab crn vc cv vs cv wcel vd
      cv cF vc cv cima wceq wa vc vd copab wfo vs cv cfn wcel vc cv vs cv wcel
      vd cv cF vc cv cima wceq wa vc vd copab crn vs cv cdom wbr cF cJ cK ccn
      co wcel vs cv cfn wcel vs cv vc cv vs cv wcel vd cv cF vc cv cima wceq wa
      vc vd copab crn vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab
      wfo vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab crn vs cv
      cdom wbr vs cv vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab
      crn vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab fodomfi
      ancoms cF cJ cK ccn co wcel vc cv vs cv wcel vd cv cF vc cv cima wceq wa
      vc vd copab vs cv wfn vs cv vc cv vs cv wcel vd cv cF vc cv cima wceq wa
      vc vd copab crn vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab
      wfo cF cJ cK ccn co wcel cF vc cv cima cvv wcel vc vs cv wral vc cv vs cv
      wcel vd cv cF vc cv cima wceq wa vc vd copab vs cv wfn cF cJ cK ccn co
      wcel cF vc cv cima cvv wcel vc vs cv cF cJ cK ccn co wcel cF vc cv cima
      cvv wcel vc cv vs cv wcel cF vc cv cJ cK ccn co imaexg a1d r19.21aiv vc
      vd vs cv cF vc cv cima vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd
      copab vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab eqid
      fnopab2g sylib vs cv vc cv vs cv wcel vd cv cF vc cv cima wceq wa vc vd
      copab dffn4 sylib sylan vs cv cfn wcel vc cv vs cv wcel vd cv cF vc cv
      cima wceq wa vc vd copab crn vs cv cdom wbr vc cv vs cv wcel vd cv cF vc
      cv cima wceq wa vc vd copab crn cfn wcel cF cJ cK ccn co wcel vs cv vc cv
      vs cv wcel vd cv cF vc cv cima wceq wa vc vd copab crn domfi adantll
      mpdan vc vd vs cv cF vc cv cima rnopab2 syl5eqelr ex adantld ad2antll a1d
      a1d 3imp1 3adant3 jca vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv
      cpw cfn cin wcel vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv cpw
      wcel vd cv cF vc cv cima wceq vc vs cv wrex vd cab cfn wcel wa vd cv cF
      vc cv cima wceq vc vs cv wrex vd cab vu cv wss vd cv cF vc cv cima wceq
      vc vs cv wrex vd cab cfn wcel wa vd cv cF vc cv cima wceq vc vs cv wrex
      vd cab vu cv cpw cfn elin vd cv cF vc cv cima wceq vc vs cv wrex vd cab
      vu cv cpw wcel vd cv cF vc cv cima wceq vc vs cv wrex vd cab vu cv wss vd
      cv cF vc cv cima wceq vc vs cv wrex vd cab cfn wcel vd cv cF vc cv cima
      wceq vc vs cv wrex vd cab vu cv vc vd vs cv cF vc cv cima vs visset
      abrexex elpw anbi1i bitri sylibr cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a
      vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn
      wcel wa cJ cuni vs cv cuni wceq w3a cK cuni vc vs cv cF vc cv cima ciun
      vd cv cF vc cv cima wceq vc vs cv wrex vd cab cuni cJ ctop wcel cK ctop
      wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq
      vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab
      wss vs cv cfn wcel wa cJ cuni vs cv cuni wceq w3a cK cuni cF vs cv cuni
      cima vc vs cv cF vc cv cima ciun cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a
      vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn
      wcel wa cJ cuni vs cv cuni wceq w3a cK cuni cF cJ cuni cima cF vs cv cuni
      cima cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa
      cK cuni vu cv cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima
      wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa cK cuni cF cJ cuni cima
      wceq cJ cuni vs cv cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF
      cJ cK ccn co wcel wa wa cK cuni vu cv cuni wceq cK cuni cF cJ cuni cima
      wceq vu cv cK wss cX cY cF wfo cK cuni cF cJ cuni cima wceq cJ ctop wcel
      cK ctop wcel wa cF cJ cK ccn co wcel cX cY cF wfo cF cX cima cY cF cJ
      cuni cima cK cuni cX cY cF foima cF cX cima cF cJ cuni cima wceq cX cY cF
      wfo cX cJ cuni cF cncomp.1 imaeq2i a1i cY cK cuni wceq cX cY cF wfo
      cncomp.2 a1i 3eqtr3rd ad2antrl 3ad2ant1 3ad2ant1 cJ cuni vs cv cuni wceq
      cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK
      cuni vu cv cuni wceq vu cv cK wss w3a cF cJ cuni cima cF vs cv cuni cima
      wceq vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv
      cfn wcel wa cJ cuni vs cv cuni cF imaeq2 3ad2ant3 eqtrd vc cF vs cv
      imaiun syl6eq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv
      vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa cJ cuni vs cv
      cuni wceq w3a cF vc cv cima cvv wcel vc vs cv wral vc vs cv cF vc cv cima
      ciun vd cv cF vc cv cima wceq vc vs cv wrex vd cab cuni wceq cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv
      cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv
      wrex vx cab wss vs cv cfn wcel wa cJ cuni vs cv cuni wceq w3a cF vc cv
      cima cvv wcel vc vs cv cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK
      ccn co wcel wa wa cK cuni vu cv cuni wceq vu cv cK wss w3a vs cv vx cv cF
      ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv cfn wcel wa cJ cuni
      vs cv cuni wceq w3a cF vc cv cima cvv wcel vc cv vs cv wcel cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK cuni vu cv
      cuni wceq vu cv cK wss w3a vs cv vx cv cF ccnv vy cv cima wceq vy vu cv
      wrex vx cab wss vs cv cfn wcel wa cF vc cv cima cvv wcel cJ cuni vs cv
      cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel
      wa wa cK cuni vu cv cuni wceq cF vc cv cima cvv wcel vu cv cK wss cF cJ
      cK ccn co wcel cF vc cv cima cvv wcel cJ ctop wcel cK ctop wcel wa cX cY
      cF wfo cF vc cv cJ cK ccn co imaexg ad2antll 3ad2ant1 3ad2ant1 a1d
      r19.21aiv vc vd vs cv cF vc cv cima cvv dfiun2g syl eqtrd sylanc 3exp vs
      cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw cfn cin wcel vs
      cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw wcel vs cv cfn
      wcel wa vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs
      cv cfn wcel wa vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab
      cpw cfn elin vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab cpw
      wcel vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab wss vs cv
      cfn wcel vs cv vx cv cF ccnv vy cv cima wceq vy vu cv wrex vx cab vs
      visset elpw anbi1i bitri syl5ib r19.23adv syl9r mpd syld 3exp com24 vu cv
      cK vu visset elpw syl7ib r19.21adv exp43 com4l imp5d vr vs cJ iscomp
      syl5ib exp31 com4r imp43 jca vu vv cK iscomp sylibr $.
      $( [1-Dec-2010] $) $( [12-Jul-2009] $)
  $}

  ${
    $d f J $. $d f K $.
    $( Compactness is a topological property-that is, for any two homeomorphic
       topologies, either both are compact or neither is.  (Contributed by
       Jeff Hankins, 30-Jun-2009.) $)
    comptoppr $p |- ( ( J e. Top /\ K e. Top /\ J ~= K ) -> ( J e. Comp <-> K
    e. Comp ) ) $=
      cJ ctop wcel cK ctop wcel cJ cK chomeo wbr cJ ccomp wcel cK ccomp wcel wb
      cJ ctop wcel cK ctop wcel wa cJ cK chomeo wbr vf cv cJ cK chomeosm co
      wcel vf wex cJ ccomp wcel cK ccomp wcel wb vf cJ cK hmph cJ ctop wcel cK
      ctop wcel wa vf cv cJ cK chomeosm co wcel cJ ccomp wcel cK ccomp wcel wb
      vf cJ ctop wcel cK ctop wcel wa vf cv cJ cK chomeosm co wcel cJ cuni cK
      cuni vf cv wf1o vf cv cJ cK ccn co wcel vf cv ccnv cK cJ ccn co wcel w3a
      cJ ccomp wcel cK ccomp wcel wb cJ ctop wcel cK ctop wcel vf cv cvv wcel
      vf cv cJ cK chomeosm co wcel cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn
      co wcel vf cv ccnv cK cJ ccn co wcel w3a wb vf visset cvv vf cv cJ cK cJ
      cuni cK cuni cJ cuni eqid cK cuni eqid hmeobc mp3an3 cJ ctop wcel cK ctop
      wcel wa cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel vf cv ccnv cK
      cJ ccn co wcel w3a cJ ccomp wcel cK ccomp wcel wb cJ ctop wcel cK ctop
      wcel wa cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel vf cv ccnv cK
      cJ ccn co wcel w3a wa cJ ccomp wcel cK ccomp wcel cJ ctop wcel cK ctop
      wcel wa cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel cJ ccomp wcel
      cK ccomp wcel wi vf cv ccnv cK cJ ccn co wcel cK ctop wcel cJ cuni cK
      cuni vf cv wf1o vf cv cJ cK ccn co wcel wa cJ ccomp wcel cK ccomp wcel wi
      cJ ctop wcel cK ctop wcel cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co
      wcel cJ ccomp wcel cK ccomp wcel wi cK ctop wcel cJ cuni cK cuni vf cv
      wfo vf cv cJ cK ccn co wcel cJ ccomp wcel cK ccomp wcel wi wi cJ cuni cK
      cuni vf cv wf1o cJ ccomp wcel cK ctop wcel cJ cuni cK cuni vf cv wfo vf
      cv cJ cK ccn co wcel cK ccomp wcel cJ ccomp wcel cK ctop wcel cJ cuni cK
      cuni vf cv wfo vf cv cJ cK ccn co wcel cK ccomp wcel vf cv cJ cK cJ cuni
      cK cuni cJ cuni eqid cK cuni eqid cncomp exp43 com4l cJ cuni cK cuni vf
      cv f1ofo syl5 imp32 adantll 3adantr3 cJ ctop wcel cK ctop wcel wa cJ cuni
      cK cuni vf cv wf1o vf cv ccnv cK cJ ccn co wcel cK ccomp wcel cJ ccomp
      wcel wi vf cv cJ cK ccn co wcel cJ ctop wcel cJ cuni cK cuni vf cv wf1o
      vf cv ccnv cK cJ ccn co wcel wa cK ccomp wcel cJ ccomp wcel wi cK ctop
      wcel cJ ctop wcel cJ cuni cK cuni vf cv wf1o vf cv ccnv cK cJ ccn co wcel
      cK ccomp wcel cJ ccomp wcel wi cJ ctop wcel cK cuni cJ cuni vf cv ccnv
      wfo vf cv ccnv cK cJ ccn co wcel cK ccomp wcel cJ ccomp wcel wi wi cJ
      cuni cK cuni vf cv wf1o cK ccomp wcel cJ ctop wcel cK cuni cJ cuni vf cv
      ccnv wfo vf cv ccnv cK cJ ccn co wcel cJ ccomp wcel cK ccomp wcel cJ ctop
      wcel cK cuni cJ cuni vf cv ccnv wfo vf cv ccnv cK cJ ccn co wcel cJ ccomp
      wcel vf cv ccnv cK cJ cK cuni cJ cuni cK cuni eqid cJ cuni eqid cncomp
      exp43 com4l cJ cuni cK cuni vf cv wf1o cK cuni cJ cuni vf cv ccnv wf1o cK
      cuni cJ cuni vf cv ccnv wfo cJ cuni cK cuni vf cv f1ocnv cK cuni cJ cuni
      vf cv ccnv f1ofo syl syl5 imp32 adantlr 3adantr2 impbid ex sylbid
      19.23adv sylbid 3impia $.
      $( [1-Dec-2010] $) $( [30-Jun-2009] $)
  $}

  ${ $d J y z $.
  $( A finite topology is compact.  (Contributed by FL, 22-Dec-2008.) $)
  fintopcomp $p |- ( J e. ( Top i^i Fin ) -> J e. Comp ) $=
    cJ ctop cfn cin wcel cJ ctop wcel cJ cuni vy cv cuni wceq cJ cuni vz cv
    cuni wceq vz vy cv cpw cfn cin wrex wi vy cJ cpw wral wa cJ ccomp wcel cJ
    ctop cfn cin wcel cJ ctop wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni
    wceq vz vy cv cpw cfn cin wrex wi vy cJ cpw wral ctop cfn cin ctop cJ ctop
    cfn inss1 sseli cJ ctop cfn cin wcel cJ cfn wcel cJ cuni vy cv cuni wceq cJ
    cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wi vy cJ cpw wral ctop cfn
    cin cfn cJ ctop cfn inss2 sseli cJ cfn wcel cJ cuni vy cv cuni wceq cJ cuni
    vz cv cuni wceq vz vy cv cpw cfn cin wrex wi vy cJ cpw cJ cfn wcel vy cv cJ
    cpw wcel wa vy cv cfn wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq
    vz vy cv cpw cfn cin wrex wi cJ cfn wcel vy cv cJ wss vy cv cfn wcel vy cv
    cJ cpw wcel cJ vy cv ssfi vy cv cJ vy visset elpw sylan2b vy cv vy cv cpw
    wcel vy cv cfn wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq vz vy
    cv cpw cfn cin wrex wi vy cv vy visset pwid vy cv vy cv cpw wcel vy cv cfn
    wcel wa vy cv vy cv cpw cfn cin wcel cJ cuni vy cv cuni wceq cJ cuni vz cv
    cuni wceq vz vy cv cpw cfn cin wrex wi vy cv vy cv cpw cfn elin vy cv vy cv
    cpw cfn cin wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq vz vy cv
    cpw cfn cin wrex cJ cuni vz cv cuni wceq cJ cuni vy cv cuni wceq vz vy cv
    vy cv cpw cfn cin vz cv vy cv wceq vz cv cuni vy cv cuni cJ cuni vz cv vy
    cv unieq eqeq2d rcla4ev ex sylbir mpan syl r19.21aiva syl jca vy vz cJ
    iscomp sylibr $.
    $( [1-Dec-2010] $) $( [22-Dec-2008] $) $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Separated spaces: T0, T1, T2 (Hausdorff) ...
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Fre $. $( The class of all the T1-spaces
    (also called Frechet spaces). $)

  $( Extend class notation to include T1-spaces. $)
  ct1 $a class Fre $.

  ${
    $d x a $.
    $( The class of all T1-spaces also called Frechet spaces.  Morris, Topology
       without tears, p. 30 ex. 3.  (Contributed by FL, 18-Jun-2007.) $)
    df-t1 $a |- Fre = { x e. Top | A. a e. U. x { a } e. ( Clsd ` x ) } $.
  $}

  ${
    $d J a x $.  $d X x $.
    ist1.1 $e |- X = U. J $.
    $( The predicate ` J ` is T1.  (Contributed by FL, 18-Jun-2007.) $)
    ist1 $p |- ( J e. Fre <->
      ( J e. Top /\ A. a e. X { a } e. ( Clsd ` J ) ) ) $=
      va cv csn vx cv ccld cfv wcel va vx cv cuni wral va cv csn cJ ccld cfv
      wcel va cX wral vx cJ ctop ct1 vx cv cJ wceq va cv csn vx cv ccld cfv
      wcel va cv csn cJ ccld cfv wcel va vx cv cuni cX vx cv cJ wceq va cv vx
      cv cuni wcel va cv cX wcel va cv csn vx cv ccld cfv wcel va cv csn cJ
      ccld cfv wcel vx cv cJ wceq vx cv cuni cX va cv vx cv cJ wceq vx cv cuni
      cJ cuni cX vx cv cJ unieq ist1.1 syl6eqr eleq2d vx cv cJ wceq vx cv ccld
      cfv cJ ccld cfv va cv csn vx cv cJ ccld fveq2 eleq2d imbi12d ralbidv2 vx
      va df-t1 elrab2 $.
      $( [1-Dec-2010] $) $( [7-Jun-2007] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Connectedness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Con $.
  $( Extend class notation with the the class of all connected topologies. $)
  ccon $a class Con $.

  $( Topologies are connected when only ` (/) ` and ` U. j ` are
     both open and closed. $)
  df-con $a |- Con = { j e. Top | ( j i^i ( Clsd ` j ) ) = { (/) , U. j } } $.

  ${ $d J j $.
    $( The predicate ` J ` is a connected topology .  (Contributed by FL,
       17-Nov-2008.) $)
    iscon $p |- ( J e. Top -> ( J e. Con <-> ( J i^i ( Clsd ` J ) ) =
      { (/) , U. J } ) ) $=
      cJ ccon wcel cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vj cv vj
      cv ccld cfv cin c0 vj cv cuni cpr wceq cJ cJ ccld cfv cin c0 cJ cuni cpr
      wceq vj cJ ctop ccon vj cv cJ wceq vj cv vj cv ccld cfv cin cJ cJ ccld
      cfv cin c0 vj cv cuni cpr c0 cJ cuni cpr vj cv cJ wceq vj cv cJ vj cv
      ccld cfv cJ ccld cfv vj cv cJ wceq id vj cv cJ ccld fveq2 ineq12d vj cv
      cJ wceq vj cv cuni cJ cuni wceq c0 vj cv cuni cpr c0 cJ cuni cpr wceq vj
      cv cJ unieq vj cv cuni cJ cuni c0 preq2 syl eqeq12d vj df-con elrab2 baib
      $.
      $( [1-Dec-2010] $) $( [16-Nov-2008] $)

    $( The predicate ` J ` is a connected topology .  (Contributed by FL,
       17-Nov-2008.) $)
    iscon2 $p |- ( J e. Con <-> ( J e. Top /\ ( J i^i ( Clsd ` J ) ) =
      { (/) , U. J } ) ) $=
      vj cv vj cv ccld cfv cin c0 vj cv cuni cpr wceq cJ cJ ccld cfv cin c0 cJ
      cuni cpr wceq vj cJ ctop ccon vj cv cJ wceq vj cv vj cv ccld cfv cin cJ
      cJ ccld cfv cin c0 vj cv cuni cpr c0 cJ cuni cpr vj cv cJ wceq vj cv cJ
      vj cv ccld cfv cJ ccld cfv vj cv cJ wceq id vj cv cJ ccld fveq2 ineq12d
      vj cv cJ wceq vj cv cuni cJ cuni wceq c0 vj cv cuni cpr c0 cJ cuni cpr
      wceq vj cv cJ unieq vj cv cuni cJ cuni c0 preq2 syl eqeq12d vj df-con
      elrab2 $.
      $( [1-Dec-2010] $) $( [16-Nov-2008] $)

  $}

  ${ $d J x y $. $d X y $.
    usinuniop.1 $e |- X = U. J $.
    $( If a topology is connected, its underlying set can't be partitioned
       into two non empty non-overlapping open sets.  (Contributed by FL,
       17-Nov-2008.) $)
    usinuniop $p |- ( J e. Con -> A. x e. J A. y e. J
       ( ( x =/= (/) /\ y =/= (/) /\ ( x i^i y ) = (/) )
         -> X =/= ( x u. y ) ) ) $=
      cJ ccon wcel vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx
      cv vy cv cun wne wi vx vy cJ cJ cJ ccon wcel vx cv cJ wcel vy cv cJ wcel
      wa vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv
      cun wne cJ ccon wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv c0 wne vy cv
      c0 wne vx cv vy cv cin c0 wceq w3a wa cX vx cv vy cv cun wne cX vx cv
      cdif vy cv wceq wn vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a
      cJ ccon wcel vx cv cJ wcel vy cv cJ wcel wa wa cX vx cv cdif vy cv wceq
      wn vx cv c0 wne vy cv c0 wne cJ ccon wcel vx cv cJ wcel vy cv cJ wcel wa
      wa cX vx cv cdif vy cv wceq wn wi vx cv vy cv cin c0 wceq cJ ccon wcel vx
      cv cJ wcel vy cv cJ wcel wa wa vx cv c0 wne vy cv c0 wne wa cX vx cv cdif
      vy cv wceq wn cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq wa vx
      cv cJ wcel vy cv cJ wcel wa vx cv c0 wne vy cv c0 wne wa cX vx cv cdif vy
      cv wceq wn wi cJ ccon wcel cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni cpr
      wceq wa vx cv cJ wcel vy cv cJ wcel wa wa cX vx cv cdif vy cv wceq vx cv
      c0 wne vy cv c0 wne wa cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni cpr
      wceq wa vx cv cJ wcel vy cv cJ wcel wa wa cX vx cv cdif vy cv wceq vx cv
      c0 wne vy cv c0 wne wa wn cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni cpr
      wceq wa vx cv cJ wcel vy cv cJ wcel wa wa cX vx cv cdif vy cv wceq wa vx
      cv c0 wne wn vy cv c0 wne wn wo vx cv c0 wne vy cv c0 wne wa wn cJ ctop
      wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq wa vx cv cJ wcel vy cv cJ
      wcel wa wa cX vx cv cdif vy cv wceq wa vx cv c0 wceq vy cv c0 wceq wo vx
      cv c0 wne wn vy cv c0 wne wn wo cJ ctop wcel cJ cJ ccld cfv cin c0 cJ
      cuni cpr wceq vx cv cJ wcel vy cv cJ wcel wa cX vx cv cdif vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wo vx cv cJ wcel vy cv cJ wcel wa cJ cJ ccld cfv
      cin c0 cJ cuni cpr wceq cJ ctop wcel cX vx cv cdif vy cv wceq vx cv c0
      wceq vy cv c0 wceq wo wi vy cv cJ wcel vx cv cJ wcel cJ cJ ccld cfv cin
      c0 cJ cuni cpr wceq cJ ctop wcel cX vx cv cdif vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wo wi wi wi cJ ctop wcel vx cv cJ wcel cJ cJ ccld cfv cin
      c0 cJ cuni cpr wceq vy cv cJ wcel cX vx cv cdif vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wo wi cJ ctop wcel vx cv cJ wcel cJ cJ ccld cfv cin c0 cJ
      cuni cpr wceq vy cv cJ wcel cX vx cv cdif vy cv wceq vx cv c0 wceq vy cv
      c0 wceq wo wi wi wi cX vx cv cdif cJ ccld cfv wcel cJ ctop wcel vx cv cJ
      wcel wa cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vy cv cJ wcel cX vx cv
      cdif vy cv wceq vx cv c0 wceq vy cv c0 wceq wo wi wi wi vx cv cJ cX
      usinuniop.1 opncld cX vx cv cdif cJ ccld cfv wcel cJ ctop wcel vx cv cJ
      wcel wa wa cX vx cv cdif vy cv wceq vy cv cJ wcel cJ cJ ccld cfv cin c0
      cJ cuni cpr wceq vx cv c0 wceq vy cv c0 wceq wo cX vx cv cdif cJ ccld cfv
      wcel cJ ctop wcel vx cv cJ wcel wa cX vx cv cdif vy cv wceq vy cv cJ wcel
      cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vx cv c0 wceq vy cv c0 wceq wo wi
      wi wi cX vx cv cdif vy cv wceq cX vx cv cdif cJ ccld cfv wcel cJ ctop
      wcel vx cv cJ wcel wa vy cv cJ wcel cJ cJ ccld cfv cin c0 cJ cuni cpr
      wceq vx cv c0 wceq vy cv c0 wceq wo wi wi cX vx cv cdif cJ ccld cfv wcel
      cX vx cv cdif vy cv wceq cJ ctop wcel vx cv cJ wcel wa vy cv cJ wcel cJ
      cJ ccld cfv cin c0 cJ cuni cpr wceq vx cv c0 wceq vy cv c0 wceq wo wi wi
      wi cX vx cv cdif vy cv wceq cX vx cv cdif cJ ccld cfv wcel vy cv cJ ccld
      cfv wcel cX vx cv cdif vy cv wceq cJ ctop wcel vx cv cJ wcel wa vy cv cJ
      wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vx cv c0 wceq vy cv c0 wceq
      wo wi wi wi wi cX vx cv cdif vy cv cJ ccld cfv eleq1 vy cv cJ ccld cfv
      wcel vy cv cJ wcel cJ ctop wcel vx cv cJ wcel wa cX vx cv cdif vy cv wceq
      cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vx cv c0 wceq vy cv c0 wceq wo wi
      vy cv cJ wcel vy cv cJ ccld cfv wcel cJ ctop wcel vx cv cJ wcel wa cX vx
      cv cdif vy cv wceq cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vx cv c0 wceq
      vy cv c0 wceq wo wi wi wi vy cv cJ wcel vy cv cJ ccld cfv wcel wa vy cv
      cJ cJ ccld cfv cin wcel cJ ctop wcel vx cv cJ wcel wa cX vx cv cdif vy cv
      wceq cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vx cv c0 wceq vy cv c0 wceq
      wo wi wi wi vy cv cJ cJ ccld cfv elin vy cv cJ cJ ccld cfv cin wcel cJ cJ
      ccld cfv cin c0 cJ cuni cpr wceq cX vx cv cdif vy cv wceq cJ ctop wcel vx
      cv cJ wcel wa vx cv c0 wceq vy cv c0 wceq wo cJ cJ ccld cfv cin c0 cJ
      cuni cpr wceq vy cv cJ cJ ccld cfv cin wcel vy cv c0 cJ cuni cpr wcel cX
      vx cv cdif vy cv wceq cJ ctop wcel vx cv cJ wcel wa vx cv c0 wceq vy cv
      c0 wceq wo wi wi cJ cJ ccld cfv cin c0 cJ cuni cpr wceq vy cv cJ cJ ccld
      cfv cin wcel vy cv c0 cJ cuni cpr wcel cJ cJ ccld cfv cin c0 cJ cuni cpr
      vy cv eleq2 biimpd vy cv c0 cJ cuni cpr wcel vy cv c0 wceq vy cv cJ cuni
      wceq wo cX vx cv cdif vy cv wceq cJ ctop wcel vx cv cJ wcel wa vx cv c0
      wceq vy cv c0 wceq wo wi wi vy cv c0 cJ cuni vy visset elpr vy cv c0 wceq
      cX vx cv cdif vy cv wceq cJ ctop wcel vx cv cJ wcel wa vx cv c0 wceq vy
      cv c0 wceq wo wi wi vy cv cJ cuni wceq cJ ctop wcel vx cv cJ wcel wa cX
      vx cv cdif vy cv wceq vy cv c0 wceq vx cv c0 wceq vy cv c0 wceq wo cX vx
      cv cdif vy cv wceq vy cv c0 wceq vx cv c0 wceq vy cv c0 wceq wo wi wi cJ
      ctop wcel vx cv cJ wcel wa vy cv c0 wceq vx cv c0 wceq vy cv c0 wceq wo
      wi cX vx cv cdif vy cv wceq vy cv c0 wceq vx cv c0 wceq olc a1i a1i com13
      vy cv cJ cuni wceq vy cv cX wceq cX vx cv cdif vy cv wceq cJ ctop wcel vx
      cv cJ wcel wa vx cv c0 wceq vy cv c0 wceq wo wi wi cJ cuni cX vy cv cX cJ
      cuni usinuniop.1 eqcomi eqeq2i vy cv cX wceq cX vx cv cdif vy cv wceq cX
      vx cv cdif cX wceq cJ ctop wcel vx cv cJ wcel wa vx cv c0 wceq vy cv c0
      wceq wo wi vy cv cX cX vx cv cdif eqeq2 cJ ctop wcel vx cv cJ wcel wa cX
      vx cv cdif cX wceq vx cv c0 wceq vy cv c0 wceq wo cJ ctop wcel vx cv cJ
      wcel wa vx cv cX wss cX vx cv cdif cX wceq vx cv c0 wceq vy cv c0 wceq wo
      wi vx cv cJ cX usinuniop.1 eltopss vx cv cX wss cX vx cv cdif cX wceq vx
      cv c0 wceq vy cv c0 wceq wo vx cv cX wss cX vx cv cdif cX wceq wa vx cv
      c0 wceq vy cv c0 wceq vx cv cX wss cX vx cv cdif cX wceq vx cv c0 wceq vx
      cv cX wss vy cv vx cv wcel vy cv cX wcel wi vy wal cX vx cv cdif cX wceq
      vx cv c0 wceq wi vy vx cv cX dfss2 cX vx cv cdif cX wceq vy cv vx cv wcel
      vy cv cX wcel wi vy wal vx cv c0 wceq cX vx cv cdif cX wceq cX vx cv cdif
      vy cv cX wcel vy cv vx cv wcel wn wa vy cab wceq vy cv vx cv wcel vy cv
      cX wcel wi vy wal vx cv c0 wceq wi vy cX vx cv df-dif cX vx cv cdif vy cv
      cX wcel vy cv vx cv wcel wn wa vy cab wceq vy cv vx cv wcel vy cv cX wcel
      wi vy wal vx cv c0 wceq wi wi cX cX vx cv cdif cX cX vx cv cdif wceq cX
      vx cv cdif vy cv cX wcel vy cv vx cv wcel wn wa vy cab wceq vy cv vx cv
      wcel vy cv cX wcel wi vy wal vx cv c0 wceq wi cX cX vx cv cdif wceq cX vx
      cv cdif vy cv cX wcel vy cv vx cv wcel wn wa vy cab wceq wa cX vy cv cX
      wcel vy cv vx cv wcel wn wa vy cab wceq vy cv vx cv wcel vy cv cX wcel wi
      vy wal vx cv c0 wceq wi cX cX vx cv cdif vy cv cX wcel vy cv vx cv wcel
      wn wa vy cab eqtr cX vy cv cX wcel vy cv vx cv wcel wn wa vy cab wceq vy
      cv cX wcel vy cv cX wcel vy cv vx cv wcel wn wa wb vy wal vy cv vx cv
      wcel vy cv cX wcel wi vy wal vx cv c0 wceq wi vy cv cX wcel vy cv vx cv
      wcel wn wa vy cX abeq2 vy cv cX wcel vy cv cX wcel vy cv vx cv wcel wn wa
      wb vy wal vy cv cX wcel vy cv vx cv wcel wn wi vy wal vy cv vx cv wcel vy
      cv cX wcel wi vy wal vx cv c0 wceq wi vy cv cX wcel vy cv vx cv wcel wn
      wi vy cv cX wcel vy cv cX wcel vy cv vx cv wcel wn wa wb vy vy cv cX wcel
      vy cv vx cv wcel wn pm4.71 albii vy cv cX wcel vy cv vx cv wcel wn wi vy
      wal vy cv vx cv wcel vy cv cX wcel wi vy wal vx cv c0 wceq vy cv cX wcel
      vy cv vx cv wcel wn wi vy wal vy cv vx cv wcel vy cv cX wcel wi vy wal wa
      vy cv cX wcel vy cv vx cv wcel wn wi vy cv vx cv wcel vy cv cX wcel wi wa
      vy wal vx cv c0 wceq vy cv cX wcel vy cv vx cv wcel wn wi vy cv vx cv
      wcel vy cv cX wcel wi vy 19.26 vy cv cX wcel vy cv vx cv wcel wn wi vy cv
      vx cv wcel vy cv cX wcel wi wa vy wal vy cv vx cv wcel wn vy wal vx cv c0
      wceq vy cv cX wcel vy cv vx cv wcel wn wi vy cv vx cv wcel vy cv cX wcel
      wi wa vy cv vx cv wcel wn vy vy cv vx cv wcel vy cv cX wcel wi vy cv cX
      wcel vy cv vx cv wcel wn wi vy cv vx cv wcel wn vy cv vx cv wcel vy cv cX
      wcel wi vy cv cX wcel vy cv vx cv wcel wn wi vy cv vx cv wcel vy cv vx cv
      wcel wn wi vy cv vx cv wcel wn vy cv vx cv wcel vy cv cX wcel vy cv vx cv
      wcel wn imim1 vy cv vx cv wcel pm2.01 syl6 impcom 19.20i vy vx cv eq0
      sylibr sylbir ex sylbir sylbi syl ex eqcoms mpi com12 sylbi imp orcd ex
      syl com12 syl6bi sylbi jaoi sylbi syl6com com24 sylbir expcom com24
      syl6bi pm2.43a com3l imp com24 mpancom ex com14 impcom com13 imp41 vx cv
      c0 wne wn vx cv c0 wceq vy cv c0 wne wn vy cv c0 wceq vx cv c0 nne vy cv
      c0 nne orbi12i sylibr vx cv c0 wne vy cv c0 wne ianor sylibr ex con2d cJ
      iscon2 sylanb com12 3adant3 impcom cJ ccon wcel vx cv cJ wcel vy cv cJ
      wcel wa wa vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a wa cX vx
      cv cdif vy cv wceq cX vx cv vy cv cun cJ ccon wcel vx cv cJ wcel vy cv cJ
      wcel wa wa vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv
      vy cv cun wceq cX vx cv cdif vy cv wceq wb vx cv cJ wcel vx cv c0 wne vy
      cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv cun wceq cX vx cv
      cdif vy cv wceq wb wi cJ ccon wcel vy cv cJ wcel vx cv c0 wne vy cv c0
      wne vx cv vy cv cin c0 wceq w3a vx cv cJ cuni wss cX vx cv vy cv cun wceq
      cX vx cv cdif vy cv wceq wb vx cv cJ wcel vx cv vy cv cin c0 wceq vx cv
      c0 wne vx cv cJ cuni wss cX vx cv vy cv cun wceq cX vx cv cdif vy cv wceq
      wb wi vy cv c0 wne vx cv cJ cuni wss vx cv vy cv cin c0 wceq cX vx cv vy
      cv cun wceq cX vx cv cdif vy cv wceq wb vx cv cJ cuni wss vx cv vy cv cin
      c0 wceq wa vx cv vy cv cun cX wceq cX vx cv cdif vy cv wceq cX vx cv vy
      cv cun wceq vx cv cX wss vx cv vy cv cin c0 wceq vx cv vy cv cun cX wceq
      cX vx cv cdif vy cv wceq wb vx cv cJ cuni wss vx cv vy cv cX twpar2 cJ
      cuni cX vx cv cX cJ cuni usinuniop.1 eqcomi sseq2i sylanb cX vx cv vy cv
      cun eqcom syl5bb expcom 3ad2ant3 vx cv cJ elssuni syl5com ad2antrl imp
      necon3abid mpbird exp31 r19.21aivv $.
      $( [1-Dec-2010] $) $( [16-Nov-2008] $)
  $}

  $( A connected topology is a topology.  (Contributed by FL, 22-Dec-2008.) $)
  contop $p |- Con C_ Top $=
    vx ccon ctop vx cv ccon wcel vx cv ctop wcel vx cv vx cv ccld cfv cin c0 vx
    cv cuni cpr wceq vx cv iscon2 pm3.26bi ssriv $.
    $( [1-Dec-2010] $) $( [22-Dec-2008] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Planar incidence geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Plig $.

  $( Extend class notation with the class of all planar incidence
     geometries. $)
  cplig $a class Plig $.

  ${ $d x a b l c $.
    $( Planar incidence geometry. I use Hilbert's "axioms" adapted to
       planar geometry. ` e. ` is the incidence relation. I could take a
       generic incidence relation but I'm lazy and I'm not sure the
       gain is worth the extra work. Much of what follows is directly borrowed
       from Aitken.
       ~ http://public.csusm.edu/aitken_html/m410/betweenness.pdf
       (Contributed by FL, 2-Aug-2009.) $)
    df-plig $a |- Plig = { x | ( A. a e. U. x  A. b e. U. x
          ( a =/= b -> E! l e. x ( a e. l /\ b e. l ) )
      /\ A. l e. x E. a e. U. x E. b e. U. x ( a =/= b /\ a e. l /\ b e. l )
      /\  E. a e. U. x E. b e. U. x E. c e. U. x A. l e. x
           -. ( a e. l /\ b e. l /\ c e. l ) ) } $.
  $}

  ${ $d L a b c l x $. $d P a b c x $.
   isplig.1 $e |- P = U. L $.
   $( The predicate "is a planar incidence geometry".  (Contributed by FL,
      2-Aug-2009.) $)
   isplig $p |- ( L e. A -> ( L e. Plig <->
     ( A. a e. P A. b e. P ( a =/= b -> E! l e. L ( a e. l /\ b e. l ) )
     /\ A. l e. L E. a e. P E. b e. P ( a =/= b /\  a e. l /\ b e. l )
     /\ E. a e. P E. b e. P E. c e. P A. l e. L
           -. ( a e. l /\ b e. l /\ c e. l ) ) ) )  $=
     va cv vb cv wne va vl wel vb vl wel wa vl vx cv wreu wi vb vx cv cuni wral
     va vx cv cuni wral va cv vb cv wne va vl wel vb vl wel w3a vb vx cv cuni
     wrex va vx cv cuni wrex vl vx cv wral va vl wel vb vl wel vc vl wel w3a wn
     vl vx cv wral vc vx cv cuni wrex vb vx cv cuni wrex va vx cv cuni wrex w3a
     va cv vb cv wne va vl wel vb vl wel wa vl cL wreu wi vb cP wral va cP wral
     va cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va cP wrex vl cL wral
     va vl wel vb vl wel vc vl wel w3a wn vl cL wral vc cP wrex vb cP wrex va
     cP wrex w3a vx cL cplig cA vx cv cL wceq va cv vb cv wne va vl wel vb vl
     wel wa vl vx cv wreu wi vb vx cv cuni wral va vx cv cuni wral va cv vb cv
     wne va vl wel vb vl wel wa vl cL wreu wi vb cP wral va cP wral va cv vb cv
     wne va vl wel vb vl wel w3a vb vx cv cuni wrex va vx cv cuni wrex vl vx cv
     wral va cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va cP wrex vl cL
     wral va vl wel vb vl wel vc vl wel w3a wn vl vx cv wral vc vx cv cuni wrex
     vb vx cv cuni wrex va vx cv cuni wrex va vl wel vb vl wel vc vl wel w3a wn
     vl cL wral vc cP wrex vb cP wrex va cP wrex vx cv cL wceq va cv vb cv wne
     va vl wel vb vl wel wa vl vx cv wreu wi vb vx cv cuni wral va cv vb cv wne
     va vl wel vb vl wel wa vl cL wreu wi vb cP wral va vx cv cuni cP vx cv cL
     wceq vx cv cuni cL cuni cP vx cv cL unieq isplig.1 syl6eqr vx cv cL wceq
     va cv vb cv wne va vl wel vb vl wel wa vl vx cv wreu wi va cv vb cv wne va
     vl wel vb vl wel wa vl cL wreu wi vb vx cv cuni cP vx cv cL wceq vx cv
     cuni cL cuni cP vx cv cL unieq isplig.1 syl6eqr vx cv cL wceq va vl wel vb
     vl wel wa vl vx cv wreu va vl wel vb vl wel wa vl cL wreu va cv vb cv wne
     va vl wel vb vl wel wa vl vx cv cL reueq1 imbi2d raleq12d raleq12d va cv
     vb cv wne va vl wel vb vl wel w3a vb vx cv cuni wrex va vx cv cuni wrex va
     cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va cP wrex vl vx cv cL vx
     cv cL wceq va cv vb cv wne va vl wel vb vl wel w3a vb vx cv cuni wrex va
     cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va vx cv cuni cP vx cv cL
     wceq vx cv cuni cL cuni cP vx cv cL unieq isplig.1 syl6eqr vx cv cL wceq
     va cv vb cv wne va vl wel vb vl wel w3a vb vx cv cuni cP vx cv cL wceq vx
     cv cuni cL cuni cP vx cv cL unieq isplig.1 syl6eqr rexeq1d rexeq12d raleqd
     vx cv cL wceq va vl wel vb vl wel vc vl wel w3a wn vl vx cv wral vc vx cv
     cuni wrex vb vx cv cuni wrex va vl wel vb vl wel vc vl wel w3a wn vl cL
     wral vc cP wrex vb cP wrex va vx cv cuni cP vx cv cL wceq vx cv cuni cL
     cuni cP vx cv cL unieq isplig.1 syl6eqr vx cv cL wceq va vl wel vb vl wel
     vc vl wel w3a wn vl vx cv wral vc vx cv cuni wrex va vl wel vb vl wel vc
     vl wel w3a wn vl cL wral vc cP wrex vb vx cv cuni cP vx cv cL wceq vx cv
     cuni cL cuni cP vx cv cL unieq isplig.1 syl6eqr vx cv cL wceq va vl wel vb
     vl wel vc vl wel w3a wn vl vx cv wral va vl wel vb vl wel vc vl wel w3a wn
     vl cL wral vc vx cv cuni cP vx cv cL wceq vx cv cuni cL cuni cP vx cv cL
     unieq isplig.1 syl6eqr va vl wel vb vl wel vc vl wel w3a wn vl vx cv cL
     raleq1 rexeq12d rexeq12d rexeq12d 3anbi123d vx va vb vc vl df-plig elab2g
     $.
     $( [1-Dec-2010] $) $( [2-Aug-2009] $)
  $}

  ${ $d L a b c l $. $d P a b c $.
    tncp.1 $e |- P = U. L $.
    $( There exist three non colinear points.  (Contributed by FL,
       3-Aug-2009.) $)
    tncp $p |- ( L e. Plig -> E. a e. P E. b e. P E. c e. P A. l e. L
           -. ( a e. l /\ b e. l /\ c e. l ) ) $=
      cL cplig wcel va cv vb cv wne va vl wel vb vl wel wa vl cL wreu wi vb cP
      wral va cP wral va cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va cP
      wrex vl cL wral va vl wel vb vl wel vc vl wel w3a wn vl cL wral vc cP
      wrex vb cP wrex va cP wrex cL cplig wcel va cv vb cv wne va vl wel vb vl
      wel wa vl cL wreu wi vb cP wral va cP wral va cv vb cv wne va vl wel vb
      vl wel w3a vb cP wrex va cP wrex vl cL wral va vl wel vb vl wel vc vl wel
      w3a wn vl cL wral vc cP wrex vb cP wrex va cP wrex w3a cplig cP cL va vb
      vc vl tncp.1 isplig ibi 3simp3d $.
      $( [1-Dec-2010] $) $( [2-Aug-2009] $)
  $}

  ${
    $d a b c d l G $. $d a b c d l L $. $d a b c d l P $.
    lpni.1 $e |- P = U. G $.
    $( For any line, there exists a point not on the line.  (Contributed by
       Jeff Hankins, 15-Aug-2009.)  $)
    lpni $p |- ( ( G e. Plig /\ L e. G ) -> E. a e. P a e/ L ) $=
      cG cplig wcel cL cG wcel va cv cL wnel va cP wrex cG cplig wcel vb cv vl
      cv wcel vc cv vl cv wcel vd cv vl cv wcel w3a wn vl cG wral vd cP wrex vc
      cP wrex vb cP wrex cL cG wcel va cv cL wnel va cP wrex wi cP cG vb vc vd
      vl lpni.1 tncp vb cv vl cv wcel vc cv vl cv wcel vd cv vl cv wcel w3a wn
      vl cG wral vd cP wrex cL cG wcel va cv cL wnel va cP wrex wi vb vc cP cP
      vb cv cP wcel vc cv cP wcel wa vb cv vl cv wcel vc cv vl cv wcel vd cv vl
      cv wcel w3a wn vl cG wral cL cG wcel va cv cL wnel va cP wrex wi vd cP vb
      cv cP wcel vc cv cP wcel vd cv cP wcel vb cv vl cv wcel vc cv vl cv wcel
      vd cv vl cv wcel w3a wn vl cG wral cL cG wcel va cv cL wnel va cP wrex wi
      wi vb cv vl cv wcel vc cv vl cv wcel vd cv vl cv wcel w3a wn vl cG wral
      cL cG wcel vb cv cL wcel vc cv cL wcel vd cv cL wcel w3a wn vb cv cP wcel
      vc cv cP wcel vd cv cP wcel w3a va cv cL wnel va cP wrex vb cv vl cv wcel
      vc cv vl cv wcel vd cv vl cv wcel w3a wn vb cv cL wcel vc cv cL wcel vd
      cv cL wcel w3a wn vl cL cG vl cv cL wceq vb cv vl cv wcel vc cv vl cv
      wcel vd cv vl cv wcel w3a vb cv cL wcel vc cv cL wcel vd cv cL wcel w3a
      vl cv cL wceq vb cv vl cv wcel vb cv cL wcel vc cv vl cv wcel vc cv cL
      wcel vd cv vl cv wcel vd cv cL wcel vl cv cL vb cv eleq2 vl cv cL vc cv
      eleq2 vl cv cL vd cv eleq2 3anbi123d notbid rcla4cv vb cv cP wcel vc cv
      cP wcel vd cv cP wcel w3a vb cv cL wcel wn vc cv cL wcel wn vd cv cL wcel
      wn w3o va cv cL wcel wn va cP wrex vb cv cL wcel vc cv cL wcel vd cv cL
      wcel w3a wn va cv cL wnel va cP wrex vb cv cP wcel vb cv cL wcel wn va cv
      cL wcel wn va cP wrex vc cv cP wcel vc cv cL wcel wn vd cv cP wcel vd cv
      cL wcel wn vb cv cP wcel vb cv cL wcel wn va cv cL wcel wn va cP wrex va
      cv cL wcel wn vb cv cL wcel wn va vb cv cP va cv vb cv wceq va cv cL wcel
      vb cv cL wcel va cv vb cv cL eleq1 notbid rcla4ev ex vc cv cP wcel vc cv
      cL wcel wn va cv cL wcel wn va cP wrex va cv cL wcel wn vc cv cL wcel wn
      va vc cv cP va cv vc cv wceq va cv cL wcel vc cv cL wcel va cv vc cv cL
      eleq1 notbid rcla4ev ex vd cv cP wcel vd cv cL wcel wn va cv cL wcel wn
      va cP wrex va cv cL wcel wn vd cv cL wcel wn va vd cv cP va cv vd cv wceq
      va cv cL wcel vd cv cL wcel va cv vd cv cL eleq1 notbid rcla4ev ex 3jaao
      vb cv cL wcel vc cv cL wcel vd cv cL wcel 3ianor va cv cL wnel va cv cL
      wcel wn va cP va cv cL df-nel rexbii 3imtr4g syl9r 3expia r19.23adv
      r19.23aivv syl imp $.
      $( [1-Dec-2010] $) $( [3-Aug-2009] $)
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Hilbert Space Explorer
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $( Include set.mm as the starting point (commented out since it's above) $)
  $( $[ set.mm $] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Hilbert space vocabulary
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axioms for a Hilbert space $)
  $( We assume we've constructed a fixed constant class ` ~H ` and
     associated operations, and we postulate their properties. $)

  $c ~H $.
  $c +h $.
  $c .h $.
  $c 0h $.
  $c -h $.
  $c .ih $.
  $c normh $.

  $c Cauchy $.
  $c ~~>v $.
  $c SH $.
  $c CH $.
  $c _|_ $.
  $c +H $.
  $c span $.
  $c vH $.
  $c \/H $.
  $c 0H $.
  $c C_H $.
  $c proj $.
  $c 0hop $.
  $c Iop $.
  $c +op $.
  $c .op $.
  $c -op $.
  $c +fn $.
  $c .fn $.
  $c normop $.
  $c ConOp $.
  $c LinOp $.
  $c BndLinOp $.
  $c UniOp $.
  $c HrmOp $.
  $c normfn $.
  $c null $.
  $c ConFn $.
  $c LinFn $.
  $c adjh $.
  $c bra $.
  $c ketbra $.
  $c <_op $.
  $c eigvec $.
  $c eigval $.
  $c Lambda $.
  $c States $.
  $c CHStates $.
  $c Atoms $.
  $c <o $.
  $c MH $.
  $c MH* $.

  $( Extend class notation with Hilbert vector space. $)
  chil $a class ~H $.
  $( Extend class notation with vector addition in Hilbert space.  In
     the literature, the subscript "v" is omitted, but we need it to
     avoid ambiguity with complex number addition ` + ` ~ caddc . $)
  cva $a class +h $.
  $( Extend class notation with scalar multiplication in Hilbert space.
     In the literature scalar multiplication is usually indicated by
     juxtaposition, but we need an explicit symbol to prevent ambiguity. $)
  csm $a class .h $.
  $( Extend class notation with zero vector in Hilbert space. $)
  c0v $a class 0h $.
  $( Extend class notation with vector subtraction in Hilbert space. $)
  cmv $a class -h $.
  $( Extend class notation with inner (scalar) product in Hilbert space.
     In the literature, the inner product of ` A ` and ` B ` is usually
     written ` <. A , B >. ` but our operation notation allows us to use
     existing theorems about operations and also eliminates ambiguity with
     the definition of an ordered pair ~ df-op . $)
  csp $a class .ih $.
  $( Extend class notation with the norm function in Hilbert space.
     In the literature, the norm of ` A ` is usually  written "|| ` A ` ||",
     but we use function notation to take advantage of our existing theorems
     about functions. $)
  cno $a class normh $.
  $( Extend class notation with set of Cauchy sequences in Hilbert space. $)
  ccau $a class Cauchy $.
  $( Extend class notation with convergence relation in Hilbert space. $)
  chli $a class ~~>v $.
  $( Extend class notation with set of subspaces of a Hilbert space. $)
  csh $a class SH $.
  $( Extend class notation with set of closed subspaces of a Hilbert space. $)
  cch $a class CH $.
  $( Extend class notation with orthogonal complement in ` CH ` . $)
  cort $a class _|_ $.
  $( Extend class notation with subspace sum in ` CH ` . $)
  cph $a class +H $.
  $( Extend class notation with subspace span in ` CH ` . $)
  cspn $a class span $.
  $( Extend class notation with join in ` CH ` . $)
  chj $a class vH $.
  $( Extend class notation with supremum of a collection in ` CH ` . $)
  chsup $a class \/H $.
  $( Extend class notation with zero of ` CH ` . $)
  c0h $a class 0H $.
  $( Extend class notation with the commutes relation on a Hilbert lattice. $)
  ccm $a class C_H $.
  $( Extend class notation with set of projections on a Hilbert space. $)
  cpj $a class proj $.
  $( Extend class notation with sum of Hilbert space operators. $)
  chos $a class +op $.
  $( Extend class notation with scalar product of a Hilbert space operator. $)
  chot $a class .op $.
  $( Extend class notation with difference of Hilbert space operators. $)
  chod $a class -op $.
  $( Extend class notation with sum of Hilbert space functionals. $)
  chfs $a class +fn $.
  $( Extend class notation with scalar product of Hilbert space functional. $)
  chft $a class .fn $.
  $( Extend class notation with the Hilbert space zero operator. $)
  ch0o $a class 0hop $.
  $( Extend class notation with Hilbert space identity operator. $)
  chio $a class Iop $.
  $( Extend class notation with the operator norm function. $)
  cnop $a class normop $.
  $( Extend class notation with set of continuous Hilbert space operators. $)
  cco $a class ConOp $.
  $( Extend class notation with set of linear Hilbert space operators. $)
  clo $a class LinOp $.
  $( Extend class notation with set of bounded linear operators. $)
  cbo $a class BndLinOp $.
  $( Extend class notation with set of unitary Hilbert space operators. $)
  cuo $a class UniOp $.
  $( Extend class notation with set of Hermitian Hilbert space operators. $)
  cho $a class HrmOp $.
  $( Extend class notation with the functional norm function. $)
  cnmf $a class normfn $.
  $( Extend class notation with the functional nullspace function. $)
  cnl $a class null $.
  $( Extend class notation with set of continuous Hilbert space functionals. $)
  ccnf $a class ConFn $.
  $( Extend class notation with set of linear Hilbert space functionals. $)
  clf $a class LinFn $.
  $( Extend class notation with Hilbert space adjoint function. $)
  cado $a class adjh $.
  $( Extend class notation with the bra of a vector in Dirac bra-ket
     notation. $)
  cbr $a class bra $.
  $( Extend class notation with the outer product of two vectors in Dirac
     bra-ket notation. $)
  ck $a class ketbra $.
  $( Extend class notation with positive operator ordering. $)
  cleo $a class <_op $.
  $( Extend class notation with Hilbert space eigenvector function. $)
  cei $a class eigvec $.
  $( Extend class notation with Hilbert space eigenvalue function. $)
  cel $a class eigval $.
  $( Extend class notation with the spectrum of an operator. $)
  cspc $a class Lambda $.
  $( Extend class notation with set of states on a Hilbert lattice. $)
  cst $a class States $.
  $( Extend class notation with set of Hilbert-space-valued states on a
     Hilbert lattice. $)
  chst $a class CHStates $.
  $( Extend class notation with set of atoms on a Hilbert lattice. $)
  cat $a class Atoms $.
  $( Extend class notation with the covers relation on a Hilbert lattice. $)
  ccv $a class <o $.
  $( Extend class notation with the modular pair relation on a Hilbert
     lattice. $)
  cmd $a class MH $.
  $( Extend class notation with the dual modular pair relation on a Hilbert
     lattice. $)
  cdmd $a class MH* $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Preliminary ZFC lemmas
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( To convert to pure ZFC, put the definitions of ` +h ` , ` .h ` ,
     and ` .ih ` here. $)

  ${
    $d x y $.
    $( Define the function for the norm of a vector of Hilbert space.  See
       ~ normval for its value and ~ normcl for its closure.  Theorems
       ~ norm-i.i , ~ norm-ii.i , and ~ norm-iii.i show it has the expected
       properties of a norm.  In the literature, the norm of ` A ` is usually
       written "|| ` A ` ||", but we use function notation to take advantage
       of our existing theorems about functions.  Definition of norm
       in [Beran] p. 96. $)
    df-hnorm $a |- normh =
         { <. x , y >. | ( x e. dom dom .ih /\ y = ( sqr ` ( x .ih x ) ) ) } $.
  $}

  $( Define base set of Hilbert space, for use if we want to develop Hilbert
     space independently from the axioms (see comments in ~ ax-hilex ). Note
     that ` ~H ` is considered a primitive in the Hilbert space axioms below,
     and we don't use this definition outside of this section.  This definition
     can be proved independently from those axioms as as theorem  ~ hhba . $)
  df-hba $a |- ~H = ( BaseSet ` <. <. +h , .h >. , normh >. ) $.

  $( Define the zero vector of Hilbert space.  Note that ` 0v ` is considered
     a primitive in the Hilbert space axioms below, and we don't use this
     definition outside of this section.  It is proved from the axioms as
     theorem ~ hh0v . $)
  df-h0v $a |- 0h = ( 0v ` <. <. +h , .h >. , normh >. ) $.

  ${
    $d x y z $.
    $( Define vector subtraction.  See ~ hvsubvali for its value and
       ~ hvsubcli for its closure. $)
    df-hvsub $a |- -h = { <. <. x , y >. , z >. | ( ( x e. ~H /\ y e. ~H )
                   /\ z = ( x +h ( -u 1 .h y ) ) ) } $.
  $}

  ${
    $d x y z f w $.
    $( Define the limit relation for Hilbert space.   See ~ hlimi
       for its relational expression.  Note that ` f : NN --> ~H ` is an
       infinite sequence of vectors, i.e. a mapping from integers to
       vectors.  Definition of converge in [Beran] p. 96. $)
    df-hlim $a |- ~~>v = { <. f , w >. | ( ( f : NN --> ~H /\ w e. ~H ) /\
          A. x e. RR ( 0 < x ->
             E. y e. NN A. z e. NN ( y <_ z ->
                ( normh ` ( ( f ` z ) -h w ) ) < x ) ) ) } $.
  $}

  ${
    $d x y z w f $.
    $( Define the set of Cauchy sequences on a Hilbert space.  See ~ hcau
       for its membership relation.  Note that ` f : NN --> ~H ` is an
       infinite sequence of vectors, i.e. a mapping from integers to
       vectors.  Definition of Cauchy sequence in [Beran] p. 96. $)
    df-hcau $a |- Cauchy = { f | ( f : NN --> ~H /\
          A. x e. RR ( 0 < x ->
          E. y e. NN A. z e. NN A. w e. NN ( ( y <_ z /\ y <_ w ) ->
             ( normh ` ( ( f ` z ) -h ( f ` w ) ) ) < x ) ) ) } $.
  $}

  ${
    $d x y z U $.
    h2h.1 $e |- U = <. <. +h , .h >. , normh >. $.
    h2h.2 $e |- U e. NrmCVec $.
    $( The group (addition) operation of Hilbert space. $)
    h2hva $p |- +h = ( +v ` U ) $=
      cva cva csm cop cno cop cpv cfv cU cpv cfv cva csm cop cno cop cpv cfv
      cva csm cop cno cop c1st cfv c1st cfv cva csm cop c1st cfv cva cva csm
      cop cno cop cva csm cop cno cop cpv cfv cva csm cop cno cop cpv cfv eqid
      vafval cva csm cop cno cop c1st cfv cva csm cop c1st cva csm cop cno cva
      csm opex op1st fveq2i cva csm cva cvv wcel csm cvv wcel cno cvv wcel cva
      csm cop cno cop cnv wcel cva cvv wcel csm cvv wcel cno cvv wcel w3a cU
      cva csm cop cno cop cnv h2h.1 h2h.2 eqeltrri csm cva cno nvex ax-mp
      3simp1i op1st 3eqtrri cU cva csm cop cno cop cpv h2h.1 fveq2i eqtr4i $.
      $( [11-Jun-2008] $) $( [31-May-2008] $)

    $( The scalar product operation of Hilbert space. $)
    h2hsm $p |- .h = ( .s ` U ) $=
      csm cva csm cop cno cop cns cfv cU cns cfv cva csm cop cno cop cns cfv
      cva csm cop cno cop c1st cfv c2nd cfv cva csm cop c2nd cfv csm cva csm
      cop cno cop cns cfv cva csm cop cno cop cva csm cop cno cop cns cfv eqid
      smfval cva csm cop cno cop c1st cfv cva csm cop c2nd cva csm cop cno cva
      csm opex op1st fveq2i cva csm cva cvv wcel csm cvv wcel cva csm cop cvc
      wcel cva cvv wcel csm cvv wcel wa cva csm cop cno cop cnv wcel cva csm
      cop cvc wcel cU cva csm cop cno cop cnv h2h.1 h2h.2 eqeltrri csm cva cno
      nvvcop ax-mp csm cva vcex ax-mp pm3.26i cva cvv wcel csm cvv wcel cva csm
      cop cvc wcel cva cvv wcel csm cvv wcel wa cva csm cop cno cop cnv wcel
      cva csm cop cvc wcel cU cva csm cop cno cop cnv h2h.1 h2h.2 eqeltrri csm
      cva cno nvvcop ax-mp csm cva vcex ax-mp pm3.27i op2nd 3eqtrri cU cva csm
      cop cno cop cns h2h.1 fveq2i eqtr4i $.
      $( [11-Jun-2008] $) $( [31-May-2008] $)

    $( The norm function of Hilbert space. $)
    h2hnm $p |- normh = ( norm ` U ) $=
      cU cnm cfv cva csm cop cno cop cnm cfv cva csm cop cno cop c2nd cfv cno
      cU cva csm cop cno cop cnm h2h.1 fveq2i cva csm cop cno cop cva csm cop
      cno cop cnm cfv cva csm cop cno cop cnm cfv eqid nmfval cva csm cop cno
      cva csm opex cva cvv wcel csm cvv wcel cno cvv wcel cva csm cop cno cop
      cnv wcel cva cvv wcel csm cvv wcel cno cvv wcel w3a cU cva csm cop cno
      cop cnv h2h.1 h2h.2 eqeltrri csm cva cno nvex ax-mp 3simp3i op2nd 3eqtrri
      $.
      $( [11-Jun-2008] $) $( [5-Jun-2008] $)

    ${
      h2h.4 $e |- ~H = ( BaseSet ` U ) $.
      $( The vector subtraction operation of Hilbert space. $)
      h2hvs $p |- -h = ( -v ` U ) $=
        cmv vx cv chil wcel vy cv chil wcel wa vz cv vx cv c1 cneg vy cv csm co
        cva co wceq wa vx vy vz copab2 cU cnsb cfv vx vy vz df-hvsub cU cnv
        wcel cU cnsb cfv vx cv chil wcel vy cv chil wcel wa vz cv vx cv c1 cneg
        vy cv csm co cva co wceq wa vx vy vz copab2 wceq h2h.2 vx vy vz csm cU
        cva cU cnsb cfv chil h2h.4 cU h2h.1 h2h.2 h2hva cU h2h.1 h2h.2 h2hsm cU
        cnsb cfv eqid nvmfval ax-mp eqtr4i $.
        $( [11-Jun-2008] $) $( [6-Jun-2008] $)
    $}

    ${
      h2hm.4 $e |- ~H = ( BaseSet ` U ) $.
      h2hm.5 $e |- D = ( IndMet ` U ) $.
      $( The base set for the metric for Hilbert space. $)
      h2hmetba $p |- ~H = dom dom D $=
        cD cU chil h2hm.4 h2hm.5 h2h.2 imsbai $.
        $( [11-Jun-2008] $) $( [6-Jun-2008] $)

      $( Value of the distance function of the metric space of Hilbert
         space. $)
      h2hmetdval $p |- ( ( A e. ~H /\ B e. ~H )
                  -> ( A D B ) = ( normh ` ( A -h B ) ) ) $=
        cU cnv wcel cA chil wcel cB chil wcel cA cB cD co cA cB cmv co cno cfv
        wceq h2h.2 cA cB cD cU cmv cno chil h2hm.4 cU h2h.1 h2h.2 h2hm.4 h2hvs
        cU h2h.1 h2h.2 h2hnm h2hm.5 imsdval mp3an1 $.
        $( [11-Jun-2008] $) $( [6-Jun-2008] $)
     $}
  $}

  ${
    $d x y z U $.  $d f w x y z D $.
    h2hc.1 $e |- U = <. <. +h , .h >. , normh >. $.
    h2hc.2 $e |- U e. NrmCVec $.
    h2hc.4 $e |- ~H = ( BaseSet ` U ) $.
    h2hc.3 $e |- D = ( IndMet ` U ) $.
    $( The Cauchy sequences of Hilbert space. $)
    h2hcau $p |- Cauchy = ( ( Cau ` D ) i^i ( ~H ^m NN ) ) $=
      cn chil vf cv wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle
      wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr wi vw
      cn wral vz cn wral vy cn wrex wi vx cr wral wa vf cab vf cv cc chil cxp
      wss cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf
      cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv
      cfv cD co vx cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr
      wral wa vf cab cn chil vf cv wf vf cab cin ccau cD cca cfv chil cn cm co
      cin cn chil vf cv wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv
      cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr
      wi vw cn wral vz cn wral vy cn wrex wi vx cr wral wa vf cab vf cv cc chil
      cxp wss cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz
      cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf
      cv cfv cD co vx cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx
      cr wral wa cn chil vf cv wf wa vf cab vf cv cc chil cxp wss cc0 vx cv clt
      wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil wcel
      vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt
      wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr wral wa vf cab cn
      chil vf cv wf vf cab cin cn chil vf cv wf cc0 vx cv clt wbr vy cv vz cv
      cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno
      cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex wi vx cr wral wa vf
      cv cc chil cxp wss cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle
      wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv
      cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw cz wral vz cz wral vy
      cz wrex wi vx cr wral wa cn chil vf cv wf wa vf cn chil vf cv wf cc0 vx
      cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw
      cv vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn
      wrex wi vx cr wral wa cn chil vf cv wf vf cv cc chil cxp wss cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr wral wa wa vf
      cv cc chil cxp wss cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle
      wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv
      cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw cz wral vz cz wral vy
      cz wrex wi vx cr wral wa cn chil vf cv wf wa cn chil vf cv wf cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv
      vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn
      wrex wi vx cr wral vf cv cc chil cxp wss cc0 vx cv clt wbr vy cv vz cv
      cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv
      chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw
      cz wral vz cz wral vy cz wrex wi vx cr wral wa cn chil vf cv wf cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr wral cc0 vx
      cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw
      cv vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn
      wrex wi vx cr wral vf cv cc chil cxp wss cc0 vx cv clt wbr vy cv vz cv
      cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv
      chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw
      cz wral vz cz wral vy cz wrex wi vx cr wral wa cn chil vf cv wf cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi cc0 vx cv clt wbr
      vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv vf cv
      cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex wi
      vx cr cn chil vf cv wf vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv
      vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv
      cfv cD co vx cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex vy cv vz
      cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co
      cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex cc0 vx cv clt
      wbr cn chil vf cv wf vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf
      cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn
      wral vy cn wrex vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv
      cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv
      cD co vx cv clt wbr w3a wi vw cn wral vz cn wral vy cn wrex vy cv vz cv
      cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv
      chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw
      cz wral vz cz wral vy cz wrex cn chil vf cv wf vy cv vz cv cle wbr vy cv
      vw cv cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt
      wbr wi vw cn wral vz cn wral vy cv vz cv cle wbr vy cv vw cv cle wbr wa
      vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv
      vf cv cfv cD co vx cv clt wbr w3a wi vw cn wral vz cn wral vy cn cn chil
      vf cv wf vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv
      vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vy cv vz cv cle wbr
      vy cv vw cv cle wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw cn
      wral vz cn cn chil vf cv wf vz cv cn wcel wa vy cv vz cv cle wbr vy cv vw
      cv cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt
      wbr wi vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cn cn chil vf cv wf vz cv cn wcel wa vw cv cn wcel
      wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr vz cv vf
      cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv
      cfv cD co vx cv clt wbr w3a vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz
      cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf
      cv cfv cmv co cno cfv vx cv clt wbr vz cv vf cv cfv chil wcel vw cv vf cv
      cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wb
      cn chil vf cv wf vz cv cn wcel wa vw cv cn wcel wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel wa vz cv vf cv cfv vw cv vf cv cfv cmv co
      cno cfv vx cv clt wbr vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel
      wa vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr wa vz cv vf cv cfv
      chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co
      vx cv clt wbr w3a vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel wa
      vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr vz cv vf cv cfv vw cv
      vf cv cfv cmv co cno cfv vx cv clt wbr vz cv vf cv cfv chil wcel vw cv vf
      cv cfv chil wcel wa vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr
      wa vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel wa vz cv vf cv cfv
      vw cv vf cv cfv cD co vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx
      cv clt vz cv vf cv cfv vw cv vf cv cfv cD cU h2hc.1 h2hc.2 h2hc.4 h2hc.3
      h2hmetdval breq1d vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel wa
      vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr ibar bitr3d vz cv vf
      cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv
      cfv cD co vx cv clt wbr df-3an syl6bbr cn chil vf cv wf vz cv cn wcel wa
      vz cv vf cv cfv chil wcel vw cv cn wcel cn chil vz cv vf cv ffvelrn
      adantr cn chil vf cv wf vw cv cn wcel vw cv vf cv cfv chil wcel vz cv cn
      wcel cn chil vw cv vf cv ffvelrn adantlr sylanc imbi2d ralbidva ralbidva
      rexbidv vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv
      cfv vw cv vf cv cfv cD co vx cv clt wbr w3a vz vw vy c1 cn 1z nnuz cau5i
      syl6rbbr imbi2d ralbidv cn chil vf cv wf vf cv cc chil cxp wss cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr wral cn chil
      vf cv wf vf cv cn chil cxp wss vf cv cc chil cxp wss cn chil vf cv fssxp
      vf cv cn chil cxp wss cn chil cxp cc chil cxp wss vf cv cc chil cxp wss
      cn cc wss chil chil wss cn chil cxp cc chil cxp wss nnsscn chil ssid cn
      cc chil chil ssxp mp2an vf cv cn chil cxp cc chil cxp sstr mpan2 syl
      biantrurd bitr3d pm5.32i cn chil vf cv wf vf cv cc chil cxp wss cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr wral wa ancom
      bitri abbii vf cv cc chil cxp wss cc0 vx cv clt wbr vy cv vz cv cle wbr
      vy cv vw cv cle wbr wa vz cv vf cv cfv chil wcel vw cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx cv clt wbr w3a wi vw cz
      wral vz cz wral vy cz wrex wi vx cr wral wa cn chil vf cv wf vf inab
      eqtr4i vx vy vz vw vf df-hcau cD cca cfv vf cv cc chil cxp wss cc0 vx cv
      clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv chil
      wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv vf cv cfv cD co vx
      cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi vx cr wral wa vf
      cab chil cn cm co cn chil vf cv wf vf cab cD cme wcel cD cca cfv vf cv cc
      chil cxp wss cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa
      vz cv vf cv cfv chil wcel vw cv vf cv cfv chil wcel vz cv vf cv cfv vw cv
      vf cv cfv cD co vx cv clt wbr w3a wi vw cz wral vz cz wral vy cz wrex wi
      vx cr wral wa vf cab wceq cU cnv wcel cD cme wcel h2hc.2 cD cU h2hc.3
      imsmet ax-mp vx cD vf vy vz vw chil cD cU chil h2hc.4 h2hc.3 h2hc.2
      imsbai caufval ax-mp chil cn vf cU chil h2hc.4 hlex nnex mapval ineq12i
      3eqtr4i $.
      $( [12-Jun-2008] $) $( [6-Jun-2008] $)

  $}

  ${
    $d x y z U $.  $d f w x y z D $.
    h2hl.1 $e |- U = <. <. +h , .h >. , normh >. $.
    h2hl.2 $e |- U e. NrmCVec $.
    h2hl.4 $e |- ~H = ( BaseSet ` U ) $.
    h2hl.3 $e |- D = ( IndMet ` U ) $.
    $( The limit sequences of Hilbert space. $)
    h2hlm $p |- ~~>v = ( ( ~~>m ` D ) |` ( ~H ^m NN ) ) $=
      cn chil vf cv wf vw cv chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr
      vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn
      wrex wi vx cr wral wa vf vw copab vf cv cc chil cxp wss vw cv chil wcel
      cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf
      cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr
      wral w3a vf vw copab chil cn cm co cres chli cD clm cfv chil cn cm co
      cres cn chil vf cv wf vw cv chil wcel wa cc0 vx cv clt wbr vy cv vz cv
      cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral
      vy cn wrex wi vx cr wral wa vf vw copab vf cv chil cn cm co wcel vf cv cc
      chil cxp wss vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv
      vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz
      wral vy cz wrex wi vx cr wral w3a wa vf vw copab vf cv cc chil cxp wss vw
      cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz
      wrex wi vx cr wral w3a vf vw copab chil cn cm co cres cn chil vf cv wf vw
      cv chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv vw
      cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral wa
      vf cv chil cn cm co wcel vf cv cc chil cxp wss vw cv chil wcel cc0 vx cv
      clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw
      cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr wral w3a wa
      vf vw cn chil vf cv wf vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle
      wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy
      cn wrex wi vx cr wral wa wa cn chil vf cv wf vf cv cc chil cxp wss vw cv
      chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel
      vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi
      vx cr wral w3a wa cn chil vf cv wf vw cv chil wcel wa cc0 vx cv clt wbr
      vy cv vz cv cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi
      vz cn wral vy cn wrex wi vx cr wral wa vf cv chil cn cm co wcel vf cv cc
      chil cxp wss vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv
      vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz
      wral vy cz wrex wi vx cr wral w3a wa cn chil vf cv wf vw cv chil wcel cc0
      vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx
      cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral wa vf cv cc chil cxp
      wss vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv
      chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy
      cz wrex wi vx cr wral w3a cn chil vf cv wf vw cv chil wcel cc0 vx cv clt
      wbr vy cv vz cv cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt
      wbr wi vz cn wral vy cn wrex wi vx cr wral wa vf cv cc chil cxp wss vw cv
      chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel
      vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi
      vx cr wral wa wa vf cv cc chil cxp wss vw cv chil wcel cc0 vx cv clt wbr
      vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co
      vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr wral w3a cn chil vf cv
      wf vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv
      vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral
      wa vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv
      chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy
      cz wrex wi vx cr wral wa vf cv cc chil cxp wss vw cv chil wcel cc0 vx cv
      clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw
      cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr wral wa wa cn
      chil vf cv wf vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv
      vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi
      vx cr wral cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz
      wrex wi vx cr wral cn chil vf cv wf vw cv chil wcel wa cc0 vx cv clt wbr
      vy cv vz cv cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi
      vz cn wral vy cn wrex wi cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf
      cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz
      wral vy cz wrex wi vx cr cn chil vf cv wf vw cv chil wcel wa vy cv vz cv
      cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral
      vy cn wrex vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv
      vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex cc0 vx cv clt wbr
      cn chil vf cv wf vw cv chil wcel wa vy cv vz cv cle wbr vz cv vf cv cfv
      vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex vy cv vz cv
      cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt
      wbr wa wi vz cn wral vy cn wrex vy cv vz cv cle wbr vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz
      wrex cn chil vf cv wf vw cv chil wcel wa vy cv vz cv cle wbr vz cv vf cv
      cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cv vz cv cle wbr
      vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi
      vz cn wral vy cn cn chil vf cv wf vw cv chil wcel wa vy cv vz cv cle wbr
      vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vy cv vz cv cle wbr
      vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi
      vz cn cn chil vf cv wf vw cv chil wcel wa vz cv cn wcel wa vz cv vf cv
      cfv vw cv cmv co cno cfv vx cv clt wbr vz cv vf cv cfv chil wcel vz cv vf
      cv cfv vw cv cD co vx cv clt wbr wa vy cv vz cv cle wbr cn chil vf cv wf
      vz cv cn wcel vw cv chil wcel vz cv vf cv cfv vw cv cmv co cno cfv vx cv
      clt wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt
      wbr wa wb vz cv vf cv cfv chil wcel vw cv chil wcel vz cv vf cv cfv vw cv
      cmv co cno cfv vx cv clt wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw
      cv cD co vx cv clt wbr wa wb cn chil vf cv wf vz cv cn wcel wa vz cv vf
      cv cfv chil wcel vw cv chil wcel wa vz cv vf cv cfv vw cv cD co vx cv clt
      wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr vz cv vf cv cfv
      chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa vz cv vf cv cfv
      chil wcel vw cv chil wcel wa vz cv vf cv cfv vw cv cD co vz cv vf cv cfv
      vw cv cmv co cno cfv vx cv clt vz cv vf cv cfv vw cv cD cU h2hl.1 h2hl.2
      h2hl.4 h2hl.3 h2hmetdval breq1d vz cv vf cv cfv chil wcel vz cv vf cv cfv
      vw cv cD co vx cv clt wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv
      cD co vx cv clt wbr wa wb vw cv chil wcel vz cv vf cv cfv chil wcel vz cv
      vf cv cfv vw cv cD co vx cv clt wbr ibar adantr bitr3d cn chil vz cv vf
      cv ffvelrn sylan an1rs imbi2d ralbidva rexbidv vz cv vf cv cfv chil wcel
      vz cv vf cv cfv vw cv cD co vx cv clt wbr wa vy vz c1 c1 cn cn 1z cn c1
      cuz cfv nnuz eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz cvg3i
      syl6bbr imbi2d ralbidv pm5.32da cn chil vf cv wf vf cv cc chil cxp wss vw
      cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz
      wrex wi vx cr wral wa cn chil vf cv wf vf cv cn chil cxp wss vf cv cc
      chil cxp wss cn chil vf cv fssxp vf cv cn chil cxp wss cn chil cxp cc
      chil cxp wss vf cv cc chil cxp wss cn cc wss chil chil wss cn chil cxp cc
      chil cxp wss nnsscn chil ssid cn cc chil chil ssxp mp2an vf cv cn chil
      cxp cc chil cxp sstr mpan2 syl biantrurd bitrd vf cv cc chil cxp wss vw
      cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz
      wrex wi vx cr wral 3anass syl6bbr pm5.32i cn chil vf cv wf vw cv chil
      wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv vw cv cmv co
      cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral anass vf cv
      chil cn cm co wcel cn chil vf cv wf vf cv cc chil cxp wss vw cv chil wcel
      cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf
      cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr
      wral w3a chil cn vf cv cU chil h2hl.4 hlex nnex elmap anbi1i 3bitr4i
      opabbii vf cv cc chil cxp wss vw cv chil wcel cc0 vx cv clt wbr vy cv vz
      cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv
      clt wbr wa wi vz cz wral vy cz wrex wi vx cr wral w3a vf vw chil cn cm co
      resopab eqtr4i vx vy vz vw vf df-hlim cD clm cfv vf cv cc chil cxp wss vw
      cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz
      wrex wi vx cr wral w3a vf vw copab wceq cD clm cfv chil cn cm co cres vf
      cv cc chil cxp wss vw cv chil wcel cc0 vx cv clt wbr vy cv vz cv cle wbr
      vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co vx cv clt wbr wa wi
      vz cz wral vy cz wrex wi vx cr wral w3a vf vw copab chil cn cm co cres
      wceq cD cme wcel cD clm cfv vf cv cc chil cxp wss vw cv chil wcel cc0 vx
      cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv
      vw cv cD co vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr wral w3a
      vf vw copab wceq cU cnv wcel cD cme wcel h2hl.2 cD cU h2hl.3 imsmet ax-mp
      vx vw cD vf vy vz chil cD cU chil h2hl.4 h2hl.3 h2hl.2 imsbai lmfval
      ax-mp cD clm cfv vf cv cc chil cxp wss vw cv chil wcel cc0 vx cv clt wbr
      vy cv vz cv cle wbr vz cv vf cv cfv chil wcel vz cv vf cv cfv vw cv cD co
      vx cv clt wbr wa wi vz cz wral vy cz wrex wi vx cr wral w3a vf vw copab
      chil cn cm co reseq1 ax-mp 3eqtr4i $.
      $( [12-Jun-2008] $) $( [6-Jun-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Derive the Hilbert space axioms from ZFC set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y F $.  $d y U $.
    axhil.1 $e |- U = <. <. +h , .h >. , normh >. $.
    axhil.2 $e |- U e. CHil $.
    $( Derive axiom ~ ax-hilex from Hilbert space under ZF set theory.

       Before introducing the 18 axioms for Hilbert space, we first prove them
       as the conclusions of theorems ~ axhilex through ~ axhcompl , using ZFC
       set theory only.  These show that if we are given a known, fixed Hilbert
       space ` U = <. <. +h , .h >. , normh >. ` that satisfies their
       hypotheses, then we can derive the Hilbert space axioms as theorems of
       ZFC set theory.  In practice, in order to use these theorems to convert
       the Hilbert Space explorer to a ZFC-only subtheory, we would also
       have to provide definitions for the 3 (otherwise primitive) class
       constants ` +h ` , ` .h ` , and ` .ih ` before ~ df-hnorm above.  See
       also the comment in ~ ax-hilex . $)
    axhilex $p |- ~H e. _V $=
      cva csm cop cno cop chil df-hba hlex $.
      $( [23-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hfvadd from Hilbert space under ZF set theory. $)
    axhfvadd $p |- +h : ( ~H X. ~H ) --> ~H $=
      cU chl wcel chil chil cxp chil cva wf axhil.2 cU cva chil chil cva csm
      cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba axhil.1
      fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hva hladdf ax-mp $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvcom from Hilbert space under ZF set theory. $)
    axhvcom $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h B ) = ( B +h A ) ) $=
      cU chl wcel cA chil wcel cB chil wcel cA cB cva co cB cA cva co wceq
      axhil.2 cA cB cU cva chil chil cva csm cop cno cop cba cfv cU cba cfv
      df-hba cU cva csm cop cno cop cba axhil.1 fveq2i eqtr4i cU axhil.1 cU
      axhil.2 hlnvi h2hva hlcom mp3an1 $.
      $( [14-Jun-2008] $) $( [27-May-2008] $)

    $( Derive axiom  ~ ax-hvass from Hilbert space under ZF set theory. $)
    axhvass $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( ( A +h B ) +h C )
      = ( A +h ( B +h C ) ) ) $=
      cU chl wcel cA chil wcel cB chil wcel cC chil wcel w3a cA cB cva co cC
      cva co cA cB cC cva co cva co wceq axhil.2 cA cB cC cU cva chil chil cva
      csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba
      axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hva hlass mpan $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hv0cl from Hilbert space under ZF set theory. $)
    axhv0cl $p |- 0h e. ~H $=
      cU chl wcel c0v chil wcel axhil.2 cU chil c0v chil cva csm cop cno cop
      cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba axhil.1 fveq2i
      eqtr4i c0v cva csm cop cno cop cn0v cfv cU cn0v cfv df-h0v cU cva csm cop
      cno cop cn0v axhil.1 fveq2i eqtr4i hl0cl ax-mp $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvaddid from Hilbert space under ZF set theory. $)
    axhvaddid $p |- ( A e. ~H -> ( A +h 0h ) = A ) $=
      cU chl wcel cA chil wcel cA c0v cva co cA wceq axhil.2 cA cU cva chil c0v
      chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop
      cba axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hva c0v cva csm
      cop cno cop cn0v cfv cU cn0v cfv df-h0v cU cva csm cop cno cop cn0v
      axhil.1 fveq2i eqtr4i hladdid mpan $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hfvmul from Hilbert space under ZF set theory. $)
    axhfvmul $p |- .h : ( CC X. ~H ) --> ~H $=
      cU chl wcel cc chil cxp chil csm wf axhil.2 csm cU chil chil cva csm cop
      cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba axhil.1
      fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hsm hlmulf ax-mp $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvmulid from Hilbert space under ZF set theory. $)
    axhvmulid $p |- ( A e. ~H -> ( 1 .h A ) = A ) $=
      cU chl wcel cA chil wcel c1 cA csm co cA wceq axhil.2 cA csm cU chil chil
      cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba
      axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hsm hlmulid mpan $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvmulass from Hilbert space under ZF set theory. $)
    axhvmulass $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H )
      -> ( ( A x. B ) .h C ) = ( A .h ( B .h C ) ) ) $=
      cU chl wcel cA cc wcel cB cc wcel cC chil wcel w3a cA cB cmul co cC csm
      co cA cB cC csm co csm co wceq axhil.2 cA cB cC csm cU chil chil cva csm
      cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba axhil.1
      fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hsm hlmulass mpan $.
      $( [14-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvdistr1 from Hilbert space under ZF set theory. $)
    axhvdistr1 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H )
      -> ( A .h ( B +h C ) ) = ( ( A .h B ) +h ( A .h C ) ) ) $=
      cU chl wcel cA cc wcel cB chil wcel cC chil wcel w3a cA cB cC cva co csm
      co cA cB csm co cA cC csm co cva co wceq axhil.2 cA cB cC csm cU cva chil
      chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop
      cba axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hva cU axhil.1 cU
      axhil.2 hlnvi h2hsm hldi mpan $.
      $( [17-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvdistr2 from Hilbert space under ZF set theory. $)
    axhvdistr2 $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H )
      -> ( ( A + B ) .h C ) = ( ( A .h C ) +h ( B .h C ) ) ) $=
      cU chl wcel cA cc wcel cB cc wcel cC chil wcel w3a cA cB caddc co cC csm
      co cA cC csm co cB cC csm co cva co wceq axhil.2 cA cB cC csm cU cva chil
      chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop
      cba axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hva cU axhil.1 cU
      axhil.2 hlnvi h2hsm hldir mpan $.
      $( [19-Jun-2008] $) $( [31-May-2008] $)

    $( Derive axiom  ~ ax-hvmul0 from Hilbert space under ZF set theory. $)
    axhvmul0 $p |- ( A e. ~H -> ( 0 .h A ) = 0h ) $=
      cU chl wcel cA chil wcel cc0 cA csm co c0v wceq axhil.2 cA csm cU chil
      c0v chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno
      cop cba axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hsm c0v cva
      csm cop cno cop cn0v cfv cU cn0v cfv df-h0v cU cva csm cop cno cop cn0v
      axhil.1 fveq2i eqtr4i hlmul0 mpan $.
      $( [19-Jun-2008] $) $( [31-May-2008] $)

    ${
      axhfi.1 $e |- .ih = ( .i ` U ) $.
      $( Derive axiom  ~ ax-hfi from Hilbert space under ZF set theory. $)
      axhfi $p |- .ih : ( ~H X. ~H ) --> CC $=
        cU chl wcel chil chil cxp cc csp wf axhil.2 csp cU chil chil cva csm
        cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno cop cba
        axhil.1 fveq2i eqtr4i axhfi.1 hlipf ax-mp $.
        $( [21-Jun-2008] $) $( [31-May-2008] $)

      $( Derive axiom  ~ ax-his1 from Hilbert space under ZF set theory. $)
      axhis1 $p |- ( ( A e. ~H /\ B e. ~H )
        -> ( A .ih B ) = ( * ` ( B .ih A ) ) ) $=
        cU chl wcel cA chil wcel cB chil wcel cA cB csp co cB cA csp co ccj cfv
        wceq axhil.2 cA cB csp cU chil chil cva csm cop cno cop cba cfv cU cba
        cfv df-hba cU cva csm cop cno cop cba axhil.1 fveq2i eqtr4i axhfi.1
        hlipcj mp3an1 $.
        $( [21-Jun-2008] $) $( [31-May-2008] $)

      $( Derive axiom  ~ ax-his2 from Hilbert space under ZF set theory. $)
      axhis2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H )
        -> ( ( A +h B ) .ih C ) = ( ( A .ih C ) + ( B .ih C ) ) ) $=
        cU chl wcel cA chil wcel cB chil wcel cC chil wcel w3a cA cB cva co cC
        csp co cA cC csp co cB cC csp co caddc co wceq axhil.2 cA cB cC csp cU
        cva chil chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm
        cop cno cop cba axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hva
        axhfi.1 hlipdir mpan $.
        $( [21-Jun-2008] $) $( [31-May-2008] $)

      $( Derive axiom  ~ ax-his3 from Hilbert space under ZF set theory. $)
      axhis3 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H )
        -> ( ( A .h B ) .ih C ) = ( A x. ( B .ih C ) ) ) $=
        cU chl wcel cA cc wcel cB chil wcel cC chil wcel w3a cA cB csm co cC
        csp co cA cB cC csp co cmul co wceq axhil.2 cA cB cC csp csm cU chil
        chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop cno
        cop cba axhil.1 fveq2i eqtr4i cU axhil.1 cU axhil.2 hlnvi h2hsm axhfi.1
        hlipass mpan $.
        $( [21-Jun-2008] $) $( [31-May-2008] $)

      $( Derive axiom  ~ ax-his4 from Hilbert space under ZF set theory. $)
      axhis4 $p |- ( ( A e. ~H /\ A =/= 0h ) -> 0 < ( A .ih A ) ) $=
        cU chl wcel cA chil wcel cA c0v wne cc0 cA cA csp co clt wbr axhil.2 cA
        csp cU chil c0v chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU
        cva csm cop cno cop cba axhil.1 fveq2i eqtr4i c0v cva csm cop cno cop
        cn0v cfv cU cn0v cfv df-h0v cU cva csm cop cno cop cn0v axhil.1 fveq2i
        eqtr4i axhfi.1 hlipgt0 mp3an1 $.
        $( [22-Jun-2008] $) $( [31-May-2008] $)
    $}

    $( Derive axiom  ~ ax-hcompl from Hilbert space under ZF set theory. $)
    axhcompl $p |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $=
      cF ccau wcel cF vy cv chli wbr vy chil wrex cF vx cv chli wbr vx chil
      wrex cF cU cims cfv cca cfv wcel cF chil cn cm co wcel wa cF vy cv cU
      cims cfv clm cfv wbr vy chil wrex cF chil cn cm co wcel wa cF ccau wcel
      cF vy cv chli wbr vy chil wrex cF cU cims cfv cca cfv wcel cF vy cv cU
      cims cfv clm cfv wbr vy chil wrex cF chil cn cm co wcel cU chl wcel cF cU
      cims cfv cca cfv wcel cF vy cv cU cims cfv clm cfv wbr vy chil wrex
      axhil.2 vy cU cims cfv cU cF chil chil cva csm cop cno cop cba cfv cU cba
      cfv df-hba cU cva csm cop cno cop cba axhil.1 fveq2i eqtr4i cU cims cfv
      eqid hlcompl mpan anim1i cF ccau wcel cF cU cims cfv cca cfv chil cn cm
      co cin wcel cF cU cims cfv cca cfv wcel cF chil cn cm co wcel wa ccau cU
      cims cfv cca cfv chil cn cm co cin cF cU cims cfv cU axhil.1 cU axhil.2
      hlnvi chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva csm cop
      cno cop cba axhil.1 fveq2i eqtr4i cU cims cfv eqid h2hcau eleq2i cF cU
      cims cfv cca cfv chil cn cm co elin bitri cF vy cv chli wbr vy chil wrex
      cF vy cv cU cims cfv clm cfv wbr cF chil cn cm co wcel wa vy chil wrex cF
      vy cv cU cims cfv clm cfv wbr vy chil wrex cF chil cn cm co wcel wa cF vy
      cv chli wbr cF vy cv cU cims cfv clm cfv wbr cF chil cn cm co wcel wa vy
      chil cF vy cv chli wbr cF vy cv cU cims cfv clm cfv chil cn cm co cres
      wbr cF vy cv cU cims cfv clm cfv wbr cF chil cn cm co wcel wa cF vy cv
      chli cU cims cfv clm cfv chil cn cm co cres cU cims cfv cU axhil.1 cU
      axhil.2 hlnvi chil cva csm cop cno cop cba cfv cU cba cfv df-hba cU cva
      csm cop cno cop cba axhil.1 fveq2i eqtr4i cU cims cfv eqid h2hlm breqi cF
      vy cv cU cims cfv clm cfv chil cn cm co vy visset brres bitri rexbii cF
      vy cv cU cims cfv clm cfv wbr cF chil cn cm co wcel vy chil r19.41v bitri
      3imtr4i cF vy cv chli wbr cF vx cv chli wbr vy vx chil vy cv vx cv cF
      chli breq2 cbvrexv sylib $.
      $( [22-Jun-2008] $) $( [6-Jun-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Introduce the vector space axioms for a Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( This is our first axiom for a complex Hilbert space, which is the
     foundation for quantum mechanics and quantum field theory.  We assume
     that there exists a primitive class, ` ~H ` , which contains objects
     called vectors.

     The 18 axioms for a complex Hilbert space consist of ~ ax-hilex ,
     ~ ax-hfvadd , ~ ax-hvcom , ~ ax-hvass , ~ ax-hv0cl , ~ ax-hvaddid ,
     ~ ax-hfvmul , ~ ax-hvmulid , ~ ax-hvmulass , ~ ax-hvdistr1 ,
     ~ ax-hvdistr2 , ~ ax-hvmul0 , ~ ax-hfi , ~ ax-his1 , ~ ax-his2 ,
     ~ ax-his3 , ~ ax-his4 , and ~ ax-hcompl .

     The axioms specify the properties of 5 primitive symbols, ` ~H ` ,
     ` +h ` , ` .h ` , ` 0h ` , and ` .ih ` .

     If we can prove in ZFC set theory that a class
     ` U = <. <. +h , .h >. , normh >. ` is a complex Hilbert space, i.e.
     that ` U e. CHil ` , then these axioms can be proved as theorems
     ~ axhilex , ~ axhfvadd , ~ axhvcom , ~ axhvass , ~ axhv0cl , ~ axhvaddid
     , ~ axhfvmul , ~ axhvmulid , ~ axhvmulass , ~ axhvdistr1 , ~ axhvdistr2
     , ~ axhvmul0 , ~ axhfi , ~ axhis1 , ~ axhis2 , ~ axhis3 , ~ axhis4 , and
     ~ axhcompl respectively.  In that case, the theorems of the Hilbert
     Space Explorer will become theorems of ZFC set theory.  See also the
     comments in ~ axhilex . $)
  ax-hilex $a |- ~H e. _V $.

  $( Vector addition is an operation on ` ~H ` . $)
  ax-hfvadd $a |- +h : ( ~H X. ~H ) --> ~H $.

  $( Vector addition is commutative. $)
  ax-hvcom $a |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h B ) = ( B +h A ) ) $.

  $( Vector addition is associative. $)
  ax-hvass $a |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                 ( ( A +h B ) +h C ) = ( A +h ( B +h C ) ) ) $.

  $( The zero vector is in the vector space. $)
  ax-hv0cl $a |- 0h e. ~H $.

  $( Addition with the zero vector. $)
  ax-hvaddid $a |- ( A e. ~H -> ( A +h 0h ) = A ) $.

  $( Scalar multiplication is an operation on ` CC ` and ` ~H ` . $)
  ax-hfvmul $a |- .h : ( CC X. ~H ) --> ~H $.

  $( Scalar multiplication by one. $)
  ax-hvmulid $a |- ( A e. ~H -> ( 1 .h A ) = A ) $.

  $( Scalar multiplication associative law $)
  ax-hvmulass $a |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) ->
                 ( ( A x. B ) .h C ) = ( A .h ( B .h C ) ) ) $.

  $( Scalar multiplication distributive law $)
  ax-hvdistr1 $a |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( A .h ( B +h C ) ) = ( ( A .h B ) +h ( A .h C ) ) ) $.

  $( Scalar multiplication distributive law $)
  ax-hvdistr2 $a |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) ->
                ( ( A + B ) .h C ) = ( ( A .h C ) +h ( B .h C ) ) ) $.

  $( Scalar multiplication by zero.  We can derive the existence of the
     negative of a vector from this axiom (see ~ hvsubid and ~ hvsubval ). $)
  ax-hvmul0 $a |- ( A e. ~H -> ( 0 .h A ) = 0h ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Vector operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The Hilbert space scalar product operation is a set. $)
  hvmulex $p |- .h e. _V $=
    cc chil cxp chil csm wf cc chil cxp cvv wcel csm cvv wcel ax-hfvmul cc chil
    axcnex ax-hilex xpex cc chil cxp chil cvv csm fex mp2an $.
    $( [22-Apr-2007] $) $( [17-Apr-2007] $)

  $( Closure of vector addition. $)
  hvaddcl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h B ) e. ~H ) $=
    cA cB chil chil chil cva ax-hfvadd foprcl $.
    $( [18-Apr-2007] $) $( [18-Apr-2007] $)

  $( Closure of scalar multiplication. $)
  hvmulcl $p |- ( ( A e. CC /\ B e. ~H ) -> ( A .h B ) e. ~H ) $=
    cA cB chil cc chil csm ax-hfvmul foprcl $.
    $( [19-Apr-2007] $) $( [19-Apr-2007] $)

  ${
    hvmulcl.1 $e |- A e. CC $.
    hvmulcl.2 $e |- B e. ~H $.
    $( Closure inference for scalar multiplication. $)
    hvmulcli $p |- ( A .h B ) e. ~H $=
      cA cc wcel cB chil wcel cA cB csm co chil wcel hvmulcl.1 hvmulcl.2 cA cB
      hvmulcl mp2an $.
      $( [1-Aug-1999] $)
  $}

  ${
    $d x y z $.
    $( Mapping domain and codomain of vector subtraction. $)
    hvsubopr $p |- -h : ( ~H X. ~H ) --> ~H $=
      vx vy vz chil chil vx cv c1 cneg vy cv csm co cva co chil cmv vx vy vz
      df-hvsub vx cv chil wcel c1 cneg vy cv csm co chil wcel vx cv c1 cneg vy
      cv csm co cva co chil wcel vy cv chil wcel vx cv c1 cneg vy cv csm co
      hvaddcl c1 cneg cc wcel vy cv chil wcel c1 cneg vy cv csm co chil wcel c1
      ax1cn negcli c1 cneg vy cv hvmulcl mpan sylan2 foprab $.
      $( [19-Sep-2007] $) $( [6-Sep-2007] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( Value of vector subtraction. $)
    hvsubval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                    ( A -h B ) = ( A +h ( -u 1 .h B ) ) ) $=
      vx vy vz cA cB chil chil vx cv c1 cneg vy cv csm co cva co cA c1 cneg cB
      csm co cva co cmv cA c1 cneg vy cv csm co cva co cA c1 cneg cB csm co cva
      oprex vx cv cA c1 cneg vy cv csm co cva opreq1 vy cv cB wceq c1 cneg vy
      cv csm co c1 cneg cB csm co cA cva vy cv cB c1 cneg csm opreq2 opreq2d vx
      vy vz df-hvsub oprabval2 $.
      $( [5-Sep-1999] $)
  $}

  $( Closure of vector subtraction. $)
  hvsubcl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A -h B ) e. ~H ) $=
    cA chil wcel cB chil wcel wa cA cB cmv co cA c1 cneg cB csm co cva co chil
    cA cB hvsubval cA chil wcel c1 cneg cB csm co chil wcel cA c1 cneg cB csm
    co cva co chil wcel cB chil wcel cA c1 cneg cB csm co hvaddcl c1 cneg cc
    wcel cB chil wcel c1 cneg cB csm co chil wcel c1 ax1cn negcli c1 cneg cB
    hvmulcl mpan sylan2 eqeltrd $.
    $( [17-Aug-1999] $)

  ${
    hvaddcl.1 $e |- A e. ~H $.
    hvaddcl.2 $e |- B e. ~H $.
    $( Closure of vector addition. $)
    hvaddcli $p |- ( A +h B ) e. ~H $=
      cA chil wcel cB chil wcel cA cB cva co chil wcel hvaddcl.1 hvaddcl.2 cA
      cB hvaddcl mp2an $.
      $( [1-Aug-1999] $)

    $( Commutation of vector addition. $)
    hvcomi $p |- ( A +h B ) = ( B +h A ) $=
      cA chil wcel cB chil wcel cA cB cva co cB cA cva co wceq hvaddcl.1
      hvaddcl.2 cA cB ax-hvcom mp2an $.
      $( [3-Sep-1999] $)

    $( Value of vector subtraction definition. $)
    hvsubvali $p |- ( A -h B ) = ( A +h ( -u 1 .h B ) ) $=
      cA chil wcel cB chil wcel cA cB cmv co cA c1 cneg cB csm co cva co wceq
      hvaddcl.1 hvaddcl.2 cA cB hvsubval mp2an $.
      $( [3-Sep-1999] $)

    $( Closure of vector subtraction. $)
    hvsubcli $p |- ( A -h B ) e. ~H $=
      cA chil wcel cB chil wcel cA cB cmv co chil wcel hvaddcl.1 hvaddcl.2 cA
      cB hvsubcl mp2an $.
      $( [2-Aug-1999] $)
  $}

  $( Addition with the zero vector. $)
  hvaddid2 $p |- ( A e. ~H -> ( 0h +h A ) = A ) $=
    cA chil wcel cA c0v cva co c0v cA cva co cA cA chil wcel c0v chil wcel cA
    c0v cva co c0v cA cva co wceq ax-hv0cl cA c0v ax-hvcom mpan2 cA ax-hvaddid
    eqtr3d $.
    $( [18-Oct-1999] $)

  $( Scalar multiplication with the zero vector. $)
  hvmul0 $p |- ( A e. CC -> ( A .h 0h ) = 0h ) $=
    cA cc wcel c0v cA cc0 c0v csm co csm co cA c0v csm co cA cc wcel cA cc0
    cmul co c0v csm co c0v cA cc0 c0v csm co csm co cA cc wcel cA cc0 cmul co
    c0v csm co cc0 c0v csm co c0v cA cc wcel cA cc0 cmul co cc0 c0v csm cA
    mul01 opreq1d c0v chil wcel cc0 c0v csm co c0v wceq ax-hv0cl c0v ax-hvmul0
    ax-mp syl6eq cA cc wcel cc0 cc wcel c0v chil wcel cA cc0 cmul co c0v csm co
    cA cc0 c0v csm co csm co wceq 0cn ax-hv0cl cA cc0 c0v ax-hvmulass mp3an23
    eqtr3d cc0 c0v csm co c0v cA csm c0v chil wcel cc0 c0v csm co c0v wceq
    ax-hv0cl c0v ax-hvmul0 ax-mp opreq2i syl6req $.
    $( [30-May-1999] $)

  $( If a scalar product is zero, one of its factors must be zero. $)
  hvmul0or $p |- ( ( A e. CC /\ B e. ~H ) ->
                  ( ( A .h B ) = 0h <-> ( A = 0 \/ B = 0h ) ) ) $=
    cA cc wcel cB chil wcel wa cA cB csm co c0v wceq cA cc0 wceq cB c0v wceq wo
    cA cc wcel cB chil wcel wa cA cB csm co c0v wceq cA cc0 wceq cB c0v wceq wo
    cA cc wcel cB chil wcel wa cA cB csm co c0v wceq wa cA cc0 wceq cB c0v wceq
    cA cc wcel cB chil wcel wa cA cB csm co c0v wceq wa cA cc0 wne cB c0v wceq
    cA cc0 wceq wn cA cc wcel cB chil wcel wa cA cB csm co c0v wceq wa cA cc0
    wne cB c0v wceq cA cc wcel cB chil wcel wa cA cB csm co c0v wceq wa cA cc0
    wne wa c1 cA cdiv co cA cB csm co csm co c1 cA cdiv co c0v csm co cB c0v cA
    cB csm co c0v wceq c1 cA cdiv co cA cB csm co csm co c1 cA cdiv co c0v csm
    co wceq cA cc wcel cB chil wcel wa cA cc0 wne cA cB csm co c0v c1 cA cdiv
    co csm opreq2 ad2antlr cA cc wcel cB chil wcel wa cA cc0 wne c1 cA cdiv co
    cA cB csm co csm co cB wceq cA cB csm co c0v wceq cA cc wcel cB chil wcel
    wa cA cc0 wne wa c1 cA cdiv co cA cmul co cB csm co c1 cB csm co c1 cA cdiv
    co cA cB csm co csm co cB cA cc wcel cA cc0 wne c1 cA cdiv co cA cmul co cB
    csm co c1 cB csm co wceq cB chil wcel cA cc wcel cA cc0 wne wa c1 cA cdiv
    co cA cmul co c1 cB csm cA recid2 opreq1d adantlr c1 cA cdiv co cc wcel cA
    cc wcel cB chil wcel c1 cA cdiv co cA cmul co cB csm co c1 cA cdiv co cA cB
    csm co csm co wceq cA cc wcel cB chil wcel wa cA cc0 wne wa c1 cA cdiv co
    cA cB ax-hvmulass cA cc wcel cA cc0 wne c1 cA cdiv co cc wcel cB chil wcel
    cA reccl adantlr cA cc wcel cB chil wcel cA cc0 wne simpll cA cc wcel cB
    chil wcel cA cc0 wne simplr syl3anc cB chil wcel c1 cB csm co cB wceq cA cc
    wcel cA cc0 wne cB ax-hvmulid ad2antlr 3eqtr3d adantlr cA cc wcel cB chil
    wcel wa cA cc0 wne c1 cA cdiv co c0v csm co c0v wceq cA cB csm co c0v wceq
    cA cc wcel cA cc0 wne c1 cA cdiv co c0v csm co c0v wceq cB chil wcel cA cc
    wcel cA cc0 wne wa c1 cA cdiv co cc wcel c1 cA cdiv co c0v csm co c0v wceq
    cA reccl c1 cA cdiv co hvmul0 syl adantlr adantlr 3eqtr3d ex cA cc0 df-ne
    syl5ibr orrd ex cA cc wcel cB chil wcel wa cA cc0 wceq cA cB csm co c0v
    wceq cB c0v wceq cB chil wcel cA cc0 wceq cA cB csm co c0v wceq wi cA cc
    wcel cA cc0 wceq cA cB csm co c0v wceq cc0 cB csm co c0v wceq cB chil wcel
    cA cc0 wceq cA cB csm co cc0 cB csm co c0v cA cc0 cB csm opreq1 eqeq1d cB
    ax-hvmul0 syl5cbir adantl cA cc wcel cB c0v wceq cA cB csm co c0v wceq wi
    cB chil wcel cB c0v wceq cA cB csm co c0v wceq cA c0v csm co c0v wceq cA cc
    wcel cB c0v wceq cA cB csm co cA c0v csm co c0v cB c0v cA csm opreq2 eqeq1d
    cA hvmul0 syl5cbir adantr jaod impbid $.
    $( [21-May-2005] $) $( [19-May-2005] $)

  $( Subtraction of a vector from itself. $)
  hvsubid $p |- ( A e. ~H -> ( A -h A ) = 0h ) $=
    cA chil wcel cA cA cmv co cc0 cA csm co c0v cA chil wcel cA cA cmv co c1 c1
    cneg caddc co cA csm co cc0 cA csm co cA chil wcel c1 cA csm co c1 cneg cA
    csm co cva co cA c1 cneg cA csm co cva co c1 c1 cneg caddc co cA csm co cA
    cA cmv co cA chil wcel c1 cA csm co cA c1 cneg cA csm co cva cA ax-hvmulid
    opreq1d c1 cc wcel c1 cneg cc wcel cA chil wcel c1 c1 cneg caddc co cA csm
    co c1 cA csm co c1 cneg cA csm co cva co wceq ax1cn c1 ax1cn negcli c1 c1
    cneg cA ax-hvdistr2 mp3an12 cA chil wcel cA cA cmv co cA c1 cneg cA csm co
    cva co wceq cA cA hvsubval anidms 3eqtr4rd c1 c1 cneg caddc co cc0 cA csm
    c1 ax1cn negidi opreq1i syl6eq cA ax-hvmul0 eqtrd $.
    $( [30-May-1999] $)

  $( Addition of negative of a vector to itself. $)
  hvnegid $p |- ( A e. ~H -> ( A +h ( -u 1 .h A ) ) = 0h ) $=
    cA chil wcel cA cA cmv co cA c1 cneg cA csm co cva co c0v cA chil wcel cA
    cA cmv co cA c1 cneg cA csm co cva co wceq cA cA hvsubval anidms cA hvsubid
    eqtr3d $.
    $( [3-Jun-2004] $) $( [4-Jun-2004] $)

  $( Two ways to express the negative of a vector. $)
  hv2neg $p |- ( A e. ~H -> ( 0h -h A ) = ( -u 1 .h A ) ) $=
    cA chil wcel c0v cA cmv co c0v c1 cneg cA csm co cva co c1 cneg cA csm co
    c0v chil wcel cA chil wcel c0v cA cmv co c0v c1 cneg cA csm co cva co wceq
    ax-hv0cl c0v cA hvsubval mpan cA chil wcel c1 cneg cA csm co chil wcel c0v
    c1 cneg cA csm co cva co c1 cneg cA csm co wceq c1 cneg cc wcel cA chil
    wcel c1 cneg cA csm co chil wcel c1 ax1cn negcli c1 cneg cA hvmulcl mpan c1
    cneg cA csm co hvaddid2 syl eqtrd $.
    $( [24-May-2005] $) $( [23-May-2005] $)

  ${
    hvaddid2.1 $e |- A e. ~H $.
    $( Addition with the zero vector. $)
    hvaddid2i $p |- ( 0h +h A ) = A $=
      cA chil wcel c0v cA cva co cA wceq hvaddid2.1 cA hvaddid2 ax-mp $.
      $( [18-Aug-1999] $)

    $( Addition of negative of a vector to itself. $)
    hvnegidi $p |- ( A +h ( -u 1 .h A ) ) = 0h $=
      cA chil wcel cA c1 cneg cA csm co cva co c0v wceq hvaddid2.1 cA hvnegid
      ax-mp $.
      $( [18-Aug-1999] $)

    $( Two ways to express the negative of a vector. $)
    hv2negi $p |- ( 0h -h A ) = ( -u 1 .h A ) $=
      cA chil wcel c0v cA cmv co c1 cneg cA csm co wceq hvaddid2.1 cA hv2neg
      ax-mp $.
      $( [31-Oct-1999] $)
  $}

  $( Convert minus one times a scalar product to the negative of the scalar. $)
  hvm1neg $p |- ( ( A e. CC /\ B e. ~H ) ->
                 ( -u 1 .h ( A .h B ) ) = ( -u A .h B ) ) $=
    cA cc wcel cB chil wcel wa c1 cneg cA cmul co cB csm co c1 cneg cA cB csm
    co csm co cA cneg cB csm co c1 cneg cc wcel cA cc wcel cB chil wcel c1 cneg
    cA cmul co cB csm co c1 cneg cA cB csm co csm co wceq c1 ax1cn negcli c1
    cneg cA cB ax-hvmulass mp3an1 cA cc wcel cB chil wcel wa c1 cneg cA cmul co
    cA cneg cB csm cA cc wcel c1 cneg cA cmul co cA cneg wceq cB chil wcel cA
    mulm1 adantr opreq1d eqtr3d $.
    $( [8-Jun-2004] $) $( [4-Jun-2004] $)

  $( Value of vector addition in terms of vector subtraction. $)
  hvaddsubval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( A +h B ) = ( A -h ( -u 1 .h B ) ) ) $=
    cA chil wcel cB chil wcel wa cA c1 cneg cB csm co cmv co cA c1 cneg c1 cneg
    cB csm co csm co cva co cA cB cva co cA chil wcel c1 cneg cB csm co chil
    wcel cA c1 cneg cB csm co cmv co cA c1 cneg c1 cneg cB csm co csm co cva co
    wceq cB chil wcel cA c1 cneg cB csm co hvsubval c1 cneg cc wcel cB chil
    wcel c1 cneg cB csm co chil wcel c1 ax1cn negcli c1 cneg cB hvmulcl mpan
    sylan2 cA chil wcel cB chil wcel wa c1 cneg c1 cneg cB csm co csm co cB cA
    cva cB chil wcel c1 cneg c1 cneg cB csm co csm co cB wceq cA chil wcel cB
    chil wcel c1 cneg c1 cneg cB csm co csm co c1 cB csm co cB cB chil wcel c1
    cneg c1 cneg cB csm co csm co c1 cneg cneg cB csm co c1 cB csm co c1 cneg
    cc wcel cB chil wcel c1 cneg c1 cneg cB csm co csm co c1 cneg cneg cB csm
    co wceq c1 ax1cn negcli c1 cneg cB hvm1neg mpan c1 cneg cneg c1 cB csm c1
    ax1cn negnegi opreq1i syl6eq cB ax-hvmulid eqtrd adantl opreq2d eqtr2d $.
    $( [19-Jun-2006] $) $( [10-Jun-2006] $)

  $( Commutative/associative law. $)
  hvadd23 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
               ( ( A +h B ) +h C ) = ( ( A +h C ) +h B ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB cC cva co cva co cA cC cB
    cva co cva co cA cB cva co cC cva co cA cC cva co cB cva co cB chil wcel cC
    chil wcel cA cB cC cva co cva co cA cC cB cva co cva co wceq cA chil wcel
    cB chil wcel cC chil wcel wa cB cC cva co cC cB cva co cA cva cB cC
    ax-hvcom opreq2d 3adant1 cA cB cC ax-hvass cA chil wcel cC chil wcel cB
    chil wcel cA cC cva co cB cva co cA cC cB cva co cva co wceq cA cC cB
    ax-hvass 3com23 3eqtr4d $.
    $( [16-Oct-1999] $)

  $( Commutative/associative law. $)
  hvadd12 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
               ( A +h ( B +h C ) ) = ( B +h ( A +h C ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB cva co cC cva co cB cA cva
    co cC cva co cA cB cC cva co cva co cB cA cC cva co cva co cA chil wcel cB
    chil wcel cA cB cva co cC cva co cB cA cva co cC cva co wceq cC chil wcel
    cA chil wcel cB chil wcel wa cA cB cva co cB cA cva co cC cva cA cB
    ax-hvcom opreq1d 3adant3 cA cB cC ax-hvass cB chil wcel cA chil wcel cC
    chil wcel cB cA cva co cC cva co cB cA cC cva co cva co wceq cB cA cC
    ax-hvass 3com12 3eqtr3d $.
    $( [19-Oct-1999] $)

  $( Hilbert vector space addition law. $)
  hvadd4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
               ( ( A +h B ) +h ( C +h D ) ) = ( ( A +h C ) +h ( B +h D ) ) ) $=
    cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB cva co
    cC cva co cD cva co cA cC cva co cB cva co cD cva co cA cB cva co cC cD cva
    co cva co cA cC cva co cB cD cva co cva co cA chil wcel cB chil wcel wa cC
    chil wcel cA cB cva co cC cva co cD cva co cA cC cva co cB cva co cD cva co
    wceq cD chil wcel cA chil wcel cB chil wcel cC chil wcel cA cB cva co cC
    cva co cD cva co cA cC cva co cB cva co cD cva co wceq cA chil wcel cB chil
    wcel cC chil wcel w3a cA cB cva co cC cva co cA cC cva co cB cva co cD cva
    cA cB cC hvadd23 opreq1d 3expa adantrr cA cB cva co chil wcel cC chil wcel
    cD chil wcel wa cA cB cva co cC cva co cD cva co cA cB cva co cC cD cva co
    cva co wceq cA chil wcel cB chil wcel wa cA cB cva co chil wcel cC chil
    wcel cD chil wcel cA cB cva co cC cva co cD cva co cA cB cva co cC cD cva
    co cva co wceq cA cB cva co cC cD ax-hvass 3expb cA cB hvaddcl sylan cA
    chil wcel cC chil wcel cB chil wcel cD chil wcel cA cC cva co cB cva co cD
    cva co cA cC cva co cB cD cva co cva co wceq cA cC cva co chil wcel cB chil
    wcel cD chil wcel wa cA cC cva co cB cva co cD cva co cA cC cva co cB cD
    cva co cva co wceq cA chil wcel cC chil wcel wa cA cC cva co chil wcel cB
    chil wcel cD chil wcel cA cC cva co cB cva co cD cva co cA cC cva co cB cD
    cva co cva co wceq cA cC cva co cB cD ax-hvass 3expb cA cC hvaddcl sylan
    an4s 3eqtr3d $.
    $( [16-Oct-1999] $)

  $( Hilbert vector space addition/subtraction law. $)
  hvsub4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
               ( ( A +h B ) -h ( C +h D ) ) = ( ( A -h C ) +h ( B -h D ) ) ) $=
    cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB cva co
    c1 cneg cC cD cva co csm co cva co cA c1 cneg cC csm co cva co cB c1 cneg
    cD csm co cva co cva co cA cB cva co cC cD cva co cmv co cA cC cmv co cB cD
    cmv co cva co cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa
    cA cB cva co c1 cneg cC cD cva co csm co cva co cA cB cva co c1 cneg cC csm
    co c1 cneg cD csm co cva co cva co cA c1 cneg cC csm co cva co cB c1 cneg
    cD csm co cva co cva co cA chil wcel cB chil wcel wa cC chil wcel cD chil
    wcel wa wa c1 cneg cC cD cva co csm co c1 cneg cC csm co c1 cneg cD csm co
    cva co cA cB cva co cva cC chil wcel cD chil wcel wa c1 cneg cC cD cva co
    csm co c1 cneg cC csm co c1 cneg cD csm co cva co wceq cA chil wcel cB chil
    wcel wa c1 cneg cc wcel cC chil wcel cD chil wcel c1 cneg cC cD cva co csm
    co c1 cneg cC csm co c1 cneg cD csm co cva co wceq c1 ax1cn negcli c1 cneg
    cC cD ax-hvdistr1 mp3an1 adantl opreq2d cA chil wcel cB chil wcel wa cC
    chil wcel cD chil wcel wa wa cA chil wcel c1 cneg cC csm co chil wcel wa cB
    chil wcel c1 cneg cD csm co chil wcel wa wa cA c1 cneg cC csm co cva co cB
    c1 cneg cD csm co cva co cva co cA cB cva co c1 cneg cC csm co c1 cneg cD
    csm co cva co cva co wceq cA chil wcel cC chil wcel cB chil wcel cD chil
    wcel cA chil wcel c1 cneg cC csm co chil wcel wa cB chil wcel c1 cneg cD
    csm co chil wcel wa wa cA chil wcel cC chil wcel wa cA chil wcel c1 cneg cC
    csm co chil wcel wa cB chil wcel cD chil wcel wa cB chil wcel c1 cneg cD
    csm co chil wcel wa cC chil wcel c1 cneg cC csm co chil wcel cA chil wcel
    c1 cneg cc wcel cC chil wcel c1 cneg cC csm co chil wcel c1 ax1cn negcli c1
    cneg cC hvmulcl mpan anim2i cD chil wcel c1 cneg cD csm co chil wcel cB
    chil wcel c1 cneg cc wcel cD chil wcel c1 cneg cD csm co chil wcel c1 ax1cn
    negcli c1 cneg cD hvmulcl mpan anim2i anim12i an4s cA c1 cneg cC csm co cB
    c1 cneg cD csm co hvadd4 syl eqtr4d cA cB cva co chil wcel cC cD cva co
    chil wcel cA cB cva co cC cD cva co cmv co cA cB cva co c1 cneg cC cD cva
    co csm co cva co wceq cA chil wcel cB chil wcel wa cC chil wcel cD chil
    wcel wa cA cB cva co cC cD cva co hvsubval cA cB hvaddcl cC cD hvaddcl
    syl2an cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cC
    cmv co cA c1 cneg cC csm co cva co cB cD cmv co cB c1 cneg cD csm co cva co
    cva cA chil wcel cC chil wcel cA cC cmv co cA c1 cneg cC csm co cva co wceq
    cB chil wcel cD chil wcel cA cC hvsubval ad2ant2r cB chil wcel cD chil wcel
    cB cD cmv co cB c1 cneg cD csm co cva co wceq cA chil wcel cC chil wcel cB
    cD hvsubval ad2ant2l opreq12d 3eqtr4d $.
    $( [17-Oct-1999] $)

  $( Commutative/associative law. $)
  hvaddsub12 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
               ( A +h ( B -h C ) ) = ( B +h ( A -h C ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB c1 cneg cC csm co cva co
    cva co cB cA c1 cneg cC csm co cva co cva co cA cB cC cmv co cva co cB cA
    cC cmv co cva co cA chil wcel cB chil wcel c1 cneg cC csm co chil wcel cA
    cB c1 cneg cC csm co cva co cva co cB cA c1 cneg cC csm co cva co cva co
    wceq cC chil wcel cA cB c1 cneg cC csm co hvadd12 c1 cneg cc wcel cC chil
    wcel c1 cneg cC csm co chil wcel c1 ax1cn negcli c1 cneg cC hvmulcl mpan
    syl3an3 cB chil wcel cC chil wcel cA cB cC cmv co cva co cA cB c1 cneg cC
    csm co cva co cva co wceq cA chil wcel cB chil wcel cC chil wcel wa cB cC
    cmv co cB c1 cneg cC csm co cva co cA cva cB cC hvsubval opreq2d 3adant1 cA
    chil wcel cC chil wcel cB cA cC cmv co cva co cB cA c1 cneg cC csm co cva
    co cva co wceq cB chil wcel cA chil wcel cC chil wcel wa cA cC cmv co cA c1
    cneg cC csm co cva co cB cva cA cC hvsubval opreq2d 3adant2 3eqtr4d $.
    $( [19-Oct-1999] $)

  $( Addition/subtraction cancellation law for vectors in Hilbert space. $)
  hvpncan $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( A +h B ) -h B ) = A ) $=
    cA chil wcel cB chil wcel wa cA cB cva co cB cmv co cA cB c1 cneg cB csm co
    cva co cva co cA c0v cva co cA cA chil wcel cB chil wcel wa cA cB cva co cB
    cmv co cA cB cva co c1 cneg cB csm co cva co cA cB c1 cneg cB csm co cva co
    cva co cA chil wcel cB chil wcel cA cB cva co chil wcel cA cB cva co cB cmv
    co cA cB cva co c1 cneg cB csm co cva co wceq cA cB hvaddcl cA cB cva co cB
    hvsubval sylancom cA chil wcel cB chil wcel c1 cneg cB csm co chil wcel wa
    cA cB cva co c1 cneg cB csm co cva co cA cB c1 cneg cB csm co cva co cva co
    wceq cB chil wcel cA chil wcel cB chil wcel c1 cneg cB csm co chil wcel cA
    cB cva co c1 cneg cB csm co cva co cA cB c1 cneg cB csm co cva co cva co
    wceq cA cB c1 cneg cB csm co ax-hvass 3expb cB chil wcel c1 cneg cB csm co
    chil wcel c1 cneg cc wcel cB chil wcel c1 cneg cB csm co chil wcel c1 ax1cn
    negcli c1 cneg cB hvmulcl mpan ancli sylan2 eqtrd cB chil wcel cA cB c1
    cneg cB csm co cva co cva co cA c0v cva co wceq cA chil wcel cB chil wcel
    cB c1 cneg cB csm co cva co c0v cA cva cB hvnegid opreq2d adantl cA chil
    wcel cA c0v cva co cA wceq cB chil wcel cA ax-hvaddid adantr 3eqtrd $.
    $( [8-Jun-2004] $) $( [7-Jun-2004] $)

  $( Addition/subtraction cancellation law for vectors in Hilbert space. $)
  hvpncan2 $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( A +h B ) -h A ) = B ) $=
    cB chil wcel cA chil wcel cA cB cva co cA cmv co cB wceq cB chil wcel cA
    chil wcel wa cB cA cva co cA cmv co cA cB cva co cA cmv co cB cB chil wcel
    cA chil wcel wa cB cA cva co cA cB cva co cA cmv cB cA ax-hvcom opreq1d cB
    cA hvpncan eqtr3d ancoms $.
    $( [8-Jun-2004] $) $( [7-Jun-2004] $)

  $( Associativity of sum and difference of Hilbert space vectors. $)
  hvaddsubass $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( ( A +h B ) -h C )
                     = ( A +h ( B -h C ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB cva co c1 cneg cC csm co
    cva co cA cB c1 cneg cC csm co cva co cva co cA cB cva co cC cmv co cA cB
    cC cmv co cva co cA chil wcel cB chil wcel c1 cneg cC csm co chil wcel cA
    cB cva co c1 cneg cC csm co cva co cA cB c1 cneg cC csm co cva co cva co
    wceq cC chil wcel cA cB c1 cneg cC csm co ax-hvass c1 cneg cc wcel cC chil
    wcel c1 cneg cC csm co chil wcel c1 ax1cn negcli c1 cneg cC hvmulcl mpan
    syl3an3 cA chil wcel cB chil wcel cC chil wcel cA cB cva co cC cmv co cA cB
    cva co c1 cneg cC csm co cva co wceq cA cB cva co chil wcel cC chil wcel cA
    cB cva co cC cmv co cA cB cva co c1 cneg cC csm co cva co wceq cA chil wcel
    cB chil wcel wa cA cB cva co cC hvsubval cA cB hvaddcl sylan 3impa cA chil
    wcel cB chil wcel cC chil wcel w3a cB cC cmv co cB c1 cneg cC csm co cva co
    cA cva cB chil wcel cC chil wcel cB cC cmv co cB c1 cneg cC csm co cva co
    wceq cA chil wcel cB cC hvsubval 3adant1 opreq2d 3eqtr4d $.
    $( [28-Aug-2004] $) $( [27-Aug-2004] $)

  $( Subtraction and addition of equal Hilbert space vectors.. $)
  hvpncan3 $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h ( B -h A ) ) = B ) $=
    cA chil wcel cB chil wcel wa cA cB cva co cA cmv co cA cB cA cmv co cva co
    cB cA chil wcel cB chil wcel cA cB cva co cA cmv co cA cB cA cmv co cva co
    wceq cA cB cA hvaddsubass 3anidm13 cA cB hvpncan2 eqtr3d $.
    $( [2-Sep-2004] $) $( [27-Aug-2004] $)

  $( Scalar multiplication commutative law. $)
  hvmulcom $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) ->
                 ( A .h ( B .h C ) ) = ( B .h ( A .h C ) ) ) $=
    cA cc wcel cB cc wcel cC chil wcel w3a cA cB cmul co cC csm co cB cA cmul
    co cC csm co cA cB cC csm co csm co cB cA cC csm co csm co cA cc wcel cB cc
    wcel cA cB cmul co cC csm co cB cA cmul co cC csm co wceq cC chil wcel cA
    cc wcel cB cc wcel wa cA cB cmul co cB cA cmul co cC csm cA cB mulcom
    opreq1d 3adant3 cA cB cC ax-hvmulass cB cc wcel cA cc wcel cC chil wcel cB
    cA cmul co cC csm co cB cA cC csm co csm co wceq cB cA cC ax-hvmulass
    3com12 3eqtr3d $.
    $( [19-May-2005] $) $( [19-May-2005] $)

  ${
    hvmulcom.1 $e |- A e. CC $.
    hvmulcom.2 $e |- B e. CC $.
    hvmulcom.3 $e |- C e. ~H $.
    $( Scalar multiplication associative law. $)
    hvmulassi $p |- ( ( A x. B ) .h C ) = ( A .h ( B .h C ) ) $=
      cA cc wcel cB cc wcel cC chil wcel cA cB cmul co cC csm co cA cB cC csm
      co csm co wceq hvmulcom.1 hvmulcom.2 hvmulcom.3 cA cB cC ax-hvmulass
      mp3an $.
      $( [3-Sep-1999] $)

    $( Scalar multiplication commutative law. $)
    hvmulcomi $p |- ( A .h ( B .h C ) ) = ( B .h ( A .h C ) ) $=
      cA cc wcel cB cc wcel cC chil wcel cA cB cC csm co csm co cB cA cC csm co
      csm co wceq hvmulcom.1 hvmulcom.2 hvmulcom.3 cA cB cC hvmulcom mp3an $.
      $( [3-Sep-1999] $)

    $( Double negative in scalar multiplication. $)
    hvmul2negi $p |- ( -u A .h ( -u B .h C ) ) = ( A .h ( B .h C ) ) $=
      cA cneg cB cneg cmul co cC csm co cA cB cmul co cC csm co cA cneg cB cneg
      cC csm co csm co cA cB cC csm co csm co cA cneg cB cneg cmul co cA cB
      cmul co cC csm cA cB hvmulcom.1 hvmulcom.2 mul2negi opreq1i cA cneg cB
      cneg cC cA hvmulcom.1 negcli cB hvmulcom.2 negcli hvmulcom.3 hvmulassi cA
      cB cC hvmulcom.1 hvmulcom.2 hvmulcom.3 hvmulassi 3eqtr3i $.
      $( [3-Sep-1999] $)
  $}

  $( Scalar multiplication distributive law for subtraction. $)
  hvsubdistr1 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                    ( A .h ( B -h C ) ) = ( ( A .h B ) -h ( A .h C ) ) ) $=
    cA cc wcel cB chil wcel cC chil wcel w3a cA cB c1 cneg cC csm co cva co csm
    co cA cB csm co c1 cneg cA cC csm co csm co cva co cA cB cC cmv co csm co
    cA cB csm co cA cC csm co cmv co cA cc wcel cB chil wcel cC chil wcel w3a
    cA cB c1 cneg cC csm co cva co csm co cA cB csm co cA c1 cneg cC csm co csm
    co cva co cA cB csm co c1 cneg cA cC csm co csm co cva co cA cc wcel cB
    chil wcel c1 cneg cC csm co chil wcel cA cB c1 cneg cC csm co cva co csm co
    cA cB csm co cA c1 cneg cC csm co csm co cva co wceq cC chil wcel cA cB c1
    cneg cC csm co ax-hvdistr1 c1 cneg cc wcel cC chil wcel c1 cneg cC csm co
    chil wcel c1 ax1cn negcli c1 cneg cC hvmulcl mpan syl3an3 cA cc wcel cC
    chil wcel cA cB csm co cA c1 cneg cC csm co csm co cva co cA cB csm co c1
    cneg cA cC csm co csm co cva co wceq cB chil wcel cA cc wcel cC chil wcel
    wa cA c1 cneg cC csm co csm co c1 cneg cA cC csm co csm co cA cB csm co cva
    cA cc wcel c1 cneg cc wcel cC chil wcel cA c1 cneg cC csm co csm co c1 cneg
    cA cC csm co csm co wceq c1 ax1cn negcli cA c1 cneg cC hvmulcom mp3an2
    opreq2d 3adant2 eqtrd cA cc wcel cB chil wcel cC chil wcel w3a cB cC cmv co
    cB c1 cneg cC csm co cva co cA csm cB chil wcel cC chil wcel cB cC cmv co
    cB c1 cneg cC csm co cva co wceq cA cc wcel cB cC hvsubval 3adant1 opreq2d
    cA cB csm co chil wcel cA cC csm co chil wcel cA cB csm co cA cC csm co cmv
    co cA cB csm co c1 cneg cA cC csm co csm co cva co wceq cA cc wcel cB chil
    wcel cC chil wcel w3a cA cB csm co cA cC csm co hvsubval cA cc wcel cB chil
    wcel cA cB csm co chil wcel cC chil wcel cA cB hvmulcl 3adant3 cA cc wcel
    cC chil wcel cA cC csm co chil wcel cB chil wcel cA cC hvmulcl 3adant2
    sylanc 3eqtr4d $.
    $( [19-May-2005] $) $( [19-May-2005] $)

  $( Scalar multiplication distributive law for subtraction. $)
  hvsubdistr2 $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) -> ( ( A - B ) .h C
      ) = ( ( A .h C ) -h ( B .h C ) ) ) $=
    cA cc wcel cB cc wcel cC chil wcel w3a cA cB cmin co cC csm co cA cC csm co
    c1 cneg cB cC csm co csm co cva co cA cC csm co cB cC csm co cmv co cA cc
    wcel cB cc wcel cC chil wcel w3a cA cB cneg caddc co cC csm co cA cC csm co
    cB cneg cC csm co cva co cA cB cmin co cC csm co cA cC csm co c1 cneg cB cC
    csm co csm co cva co cA cc wcel cB cneg cc wcel cC chil wcel cA cB cneg
    caddc co cC csm co cA cC csm co cB cneg cC csm co cva co wceq cB cc wcel cA
    cB cneg cC ax-hvdistr2 cB negcl syl3an2 cA cc wcel cB cc wcel cC chil wcel
    w3a cA cB cneg caddc co cA cB cmin co cC csm cA cc wcel cB cc wcel cA cB
    cneg caddc co cA cB cmin co wceq cC chil wcel cA cB negsub 3adant3 opreq1d
    cA cc wcel cB cc wcel cC chil wcel w3a cB cneg cC csm co c1 cneg cB cC csm
    co csm co cA cC csm co cva cB cc wcel cC chil wcel cB cneg cC csm co c1
    cneg cB cC csm co csm co wceq cA cc wcel cB cc wcel cC chil wcel wa c1 cneg
    cB cmul co cC csm co cB cneg cC csm co c1 cneg cB cC csm co csm co cB cc
    wcel c1 cneg cB cmul co cC csm co cB cneg cC csm co wceq cC chil wcel cB cc
    wcel c1 cneg cB cmul co cB cneg cC csm cB mulm1 opreq1d adantr c1 cneg cc
    wcel cB cc wcel cC chil wcel c1 cneg cB cmul co cC csm co c1 cneg cB cC csm
    co csm co wceq c1 ax1cn negcli c1 cneg cB cC ax-hvmulass mp3an1 eqtr3d
    3adant1 opreq2d 3eqtr3d cA cC csm co chil wcel cB cC csm co chil wcel cA cC
    csm co cB cC csm co cmv co cA cC csm co c1 cneg cB cC csm co csm co cva co
    wceq cA cc wcel cB cc wcel cC chil wcel w3a cA cC csm co cB cC csm co
    hvsubval cA cc wcel cC chil wcel cA cC csm co chil wcel cB cc wcel cA cC
    hvmulcl 3adant2 cB cc wcel cC chil wcel cB cC csm co chil wcel cA cc wcel
    cB cC hvmulcl 3adant1 sylanc eqtr4d $.
    $( [1-Aug-2006] $) $( [19-May-2005] $)

  ${
    hvdistr1.1 $e |- A e. CC $.
    hvdistr1.2 $e |- B e. ~H $.
    hvdistr1.3 $e |- C e. ~H $.
    $( Scalar multiplication distributive law. $)
    hvdistr1i $p |- ( A .h ( B +h C ) ) = ( ( A .h B ) +h ( A .h C ) ) $=
      cA cc wcel cB chil wcel cC chil wcel cA cB cC cva co csm co cA cB csm co
      cA cC csm co cva co wceq hvdistr1.1 hvdistr1.2 hvdistr1.3 cA cB cC
      ax-hvdistr1 mp3an $.
      $( [3-Sep-1999] $)

    $( Scalar multiplication distributive law. $)
    hvsubdistr1i $p |- ( A .h ( B -h C ) ) = ( ( A .h B ) -h ( A .h C ) ) $=
      cA cc wcel cB chil wcel cC chil wcel cA cB cC cmv co csm co cA cB csm co
      cA cC csm co cmv co wceq hvdistr1.1 hvdistr1.2 hvdistr1.3 cA cB cC
      hvsubdistr1 mp3an $.
      $( [3-Sep-1999] $)
  $}

  ${
    hvass.1 $e |- A e. ~H $.
    hvass.2 $e |- B e. ~H $.
    hvass.3 $e |- C e. ~H $.
    $( Hilbert vector space associative law. $)
    hvassi $p |- ( ( A +h B ) +h C ) = ( A +h ( B +h C ) ) $=
      cA chil wcel cB chil wcel cC chil wcel cA cB cva co cC cva co cA cB cC
      cva co cva co wceq hvass.1 hvass.2 hvass.3 cA cB cC ax-hvass mp3an $.
      $( [3-Sep-1999] $)

    $( Hilbert vector space commutative/associative law. $)
    hvadd23i $p |- ( ( A +h B ) +h C ) = ( ( A +h C ) +h B ) $=
      cA chil wcel cB chil wcel cC chil wcel cA cB cva co cC cva co cA cC cva
      co cB cva co wceq hvass.1 hvass.2 hvass.3 cA cB cC hvadd23 mp3an $.
      $( [18-Aug-1999] $)

    $( Hilbert vector space associative law for subtraction. $)
    hvsubassi $p |- ( ( A -h B ) -h C ) = ( A -h ( B +h C ) ) $=
      cA cB cmv co cC cmv co cA cB cmv co c1 cneg cC csm co cva co cA cB cC cva
      co cmv co cA cB cmv co cC cA cB hvass.1 hvass.2 hvsubcli hvass.3
      hvsubvali cA c1 cneg cB csm co cva co c1 cneg cC csm co cva co cA c1 cneg
      cB cC cva co csm co cva co cA cB cmv co c1 cneg cC csm co cva co cA cB cC
      cva co cmv co cA c1 cneg cB csm co cva co c1 cneg cC csm co cva co cA c1
      cneg cB csm co c1 cneg cC csm co cva co cva co cA c1 cneg cB cC cva co
      csm co cva co cA c1 cneg cB csm co c1 cneg cC csm co hvass.1 c1 cneg cB
      c1 ax1cn negcli hvass.2 hvmulcli c1 cneg cC c1 ax1cn negcli hvass.3
      hvmulcli hvassi c1 cneg cB cC cva co csm co c1 cneg cB csm co c1 cneg cC
      csm co cva co cA cva c1 cneg cB cC c1 ax1cn negcli hvass.2 hvass.3
      hvdistr1i opreq2i eqtr4i cA cB cmv co cA c1 cneg cB csm co cva co c1 cneg
      cC csm co cva cA cB hvass.1 hvass.2 hvsubvali opreq1i cA cB cC cva co
      hvass.1 cB cC hvass.2 hvass.3 hvaddcli hvsubvali 3eqtr4i eqtri $.
      $( [7-Oct-1999] $)

    $( Hilbert vector space commutative/associative law. $)
    hvsub23i $p |- ( ( A -h B ) -h C ) = ( ( A -h C ) -h B ) $=
      cA cB cC cva co cmv co cA cC cB cva co cmv co cA cB cmv co cC cmv co cA
      cC cmv co cB cmv co cB cC cva co cC cB cva co cA cmv cB cC hvass.2
      hvass.3 hvcomi opreq2i cA cB cC hvass.1 hvass.2 hvass.3 hvsubassi cA cC
      cB hvass.1 hvass.3 hvass.2 hvsubassi 3eqtr4i $.
      $( [7-Oct-1999] $)

    $( Hilbert vector space commutative/associative law. $)
    hvadd12i $p |- ( A +h ( B +h C ) ) = ( B +h ( A +h C ) ) $=
      cA cB cva co cC cva co cB cA cva co cC cva co cA cB cC cva co cva co cB
      cA cC cva co cva co cA cB cva co cB cA cva co cC cva cA cB hvass.1
      hvass.2 hvcomi opreq1i cA cB cC hvass.1 hvass.2 hvass.3 hvassi cB cA cC
      hvass.2 hvass.1 hvass.3 hvassi 3eqtr3i $.
      $( [11-Sep-1999] $)

    ${
      hvadd4.4 $e |- D e. ~H $.
      $( Hilbert vector space addition law. $)
      hvadd4i $p |- ( ( A +h B ) +h ( C +h D ) ) =
                   ( ( A +h C ) +h ( B +h D ) ) $=
        cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa cA cB cva co
        cC cD cva co cva co cA cC cva co cB cD cva co cva co wceq cA chil wcel
        cB chil wcel hvass.1 hvass.2 pm3.2i cC chil wcel cD chil wcel hvass.3
        hvadd4.4 pm3.2i cA cB cC cD hvadd4 mp2an $.
        $( [3-Sep-1999] $)

      $( Hilbert vector space addition law. $)
      hvsubsub4i $p |- ( ( A -h B ) -h ( C -h D ) ) =
                      ( ( A -h C ) -h ( B -h D ) ) $=
        cA c1 cneg cB csm co cva co cC c1 cneg cD csm co cva co cmv co cA c1
        cneg cC csm co cva co cB c1 cneg cD csm co cva co cmv co cA cB cmv co
        cC cD cmv co cmv co cA cC cmv co cB cD cmv co cmv co cA c1 cneg cB csm
        co cva co c1 cneg cC c1 cneg cD csm co cva co csm co cva co cA c1 cneg
        cC csm co cva co c1 cneg cB c1 cneg cD csm co cva co csm co cva co cA
        c1 cneg cB csm co cva co cC c1 cneg cD csm co cva co cmv co cA c1 cneg
        cC csm co cva co cB c1 cneg cD csm co cva co cmv co cA c1 cneg cB csm
        co cva co c1 cneg cC csm co c1 cneg c1 cneg cD csm co csm co cva co cva
        co cA c1 cneg cC csm co cva co c1 cneg cB csm co c1 cneg c1 cneg cD csm
        co csm co cva co cva co cA c1 cneg cB csm co cva co c1 cneg cC c1 cneg
        cD csm co cva co csm co cva co cA c1 cneg cC csm co cva co c1 cneg cB
        c1 cneg cD csm co cva co csm co cva co cA c1 cneg cB csm co c1 cneg cC
        csm co c1 cneg c1 cneg cD csm co csm co hvass.1 c1 cneg cB c1 ax1cn
        negcli hvass.2 hvmulcli c1 cneg cC c1 ax1cn negcli hvass.3 hvmulcli c1
        cneg c1 cneg cD csm co c1 ax1cn negcli c1 cneg cD c1 ax1cn negcli
        hvadd4.4 hvmulcli hvmulcli hvadd4i c1 cneg cC c1 cneg cD csm co cva co
        csm co c1 cneg cC csm co c1 cneg c1 cneg cD csm co csm co cva co cA c1
        cneg cB csm co cva co cva c1 cneg cC c1 cneg cD csm co c1 ax1cn negcli
        hvass.3 c1 cneg cD c1 ax1cn negcli hvadd4.4 hvmulcli hvdistr1i opreq2i
        c1 cneg cB c1 cneg cD csm co cva co csm co c1 cneg cB csm co c1 cneg c1
        cneg cD csm co csm co cva co cA c1 cneg cC csm co cva co cva c1 cneg cB
        c1 cneg cD csm co c1 ax1cn negcli hvass.2 c1 cneg cD c1 ax1cn negcli
        hvadd4.4 hvmulcli hvdistr1i opreq2i 3eqtr4i cA c1 cneg cB csm co cva co
        cC c1 cneg cD csm co cva co cA c1 cneg cB csm co hvass.1 c1 cneg cB c1
        ax1cn negcli hvass.2 hvmulcli hvaddcli cC c1 cneg cD csm co hvass.3 c1
        cneg cD c1 ax1cn negcli hvadd4.4 hvmulcli hvaddcli hvsubvali cA c1 cneg
        cC csm co cva co cB c1 cneg cD csm co cva co cA c1 cneg cC csm co
        hvass.1 c1 cneg cC c1 ax1cn negcli hvass.3 hvmulcli hvaddcli cB c1 cneg
        cD csm co hvass.2 c1 cneg cD c1 ax1cn negcli hvadd4.4 hvmulcli hvaddcli
        hvsubvali 3eqtr4i cA cB cmv co cA c1 cneg cB csm co cva co cC cD cmv co
        cC c1 cneg cD csm co cva co cmv cA cB hvass.1 hvass.2 hvsubvali cC cD
        hvass.3 hvadd4.4 hvsubvali opreq12i cA cC cmv co cA c1 cneg cC csm co
        cva co cB cD cmv co cB c1 cneg cD csm co cva co cmv cA cC hvass.1
        hvass.3 hvsubvali cB cD hvass.2 hvadd4.4 hvsubvali opreq12i 3eqtr4i $.
        $( [31-Oct-1999] $)
    $}
  $}

  $( Hilbert vector space addition/subtraction law. $)
  hvsubsub4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) )
            -> ( ( A -h B ) -h ( C -h D ) ) = ( ( A -h C ) -h ( B -h D ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel cD chil wcel cA cB cmv co cC cD cmv
    co cmv co cA cC cmv co cB cD cmv co cmv co wceq cA cB cC cD c0v c0v cA chil
    wcel cA c0v cif cB cmv co cC cD cmv co cmv co cA chil wcel cA c0v cif cC
    cmv co cB cD cmv co cmv co wceq cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif cmv co cC cD cmv co cmv co cA chil wcel cA c0v cif cC cmv co cB chil
    wcel cB c0v cif cD cmv co cmv co wceq cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cmv co cC chil wcel cC c0v cif cD cmv co cmv co cA chil wcel cA
    c0v cif cC chil wcel cC c0v cif cmv co cB chil wcel cB c0v cif cD cmv co
    cmv co wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cC chil
    wcel cC c0v cif cD chil wcel cD c0v cif cmv co cmv co cA chil wcel cA c0v
    cif cC chil wcel cC c0v cif cmv co cB chil wcel cB c0v cif cD chil wcel cD
    c0v cif cmv co cmv co wceq c0v c0v cA cA chil wcel cA c0v cif wceq cA cB
    cmv co cC cD cmv co cmv co cA chil wcel cA c0v cif cB cmv co cC cD cmv co
    cmv co cA cC cmv co cB cD cmv co cmv co cA chil wcel cA c0v cif cC cmv co
    cB cD cmv co cmv co cA cA chil wcel cA c0v cif wceq cA cB cmv co cA chil
    wcel cA c0v cif cB cmv co cC cD cmv co cmv cA cA chil wcel cA c0v cif cB
    cmv opreq1 opreq1d cA cA chil wcel cA c0v cif wceq cA cC cmv co cA chil
    wcel cA c0v cif cC cmv co cB cD cmv co cmv cA cA chil wcel cA c0v cif cC
    cmv opreq1 opreq1d eqeq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA
    c0v cif cB cmv co cC cD cmv co cmv co cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cmv co cC cD cmv co cmv co cA chil wcel cA c0v cif cC cmv co cB
    cD cmv co cmv co cA chil wcel cA c0v cif cC cmv co cB chil wcel cB c0v cif
    cD cmv co cmv co cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cC cD cmv co
    cmv cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2 opreq1d
    cB cB chil wcel cB c0v cif wceq cB cD cmv co cB chil wcel cB c0v cif cD cmv
    co cA chil wcel cA c0v cif cC cmv co cmv cB cB chil wcel cB c0v cif cD cmv
    opreq1 opreq2d eqeq12d cC cC chil wcel cC c0v cif wceq cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif cmv co cC cD cmv co cmv co cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif cmv co cC chil wcel cC c0v cif cD cmv co cmv co
    cA chil wcel cA c0v cif cC cmv co cB chil wcel cB c0v cif cD cmv co cmv co
    cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cB chil wcel cB c0v
    cif cD cmv co cmv co cC cC chil wcel cC c0v cif wceq cC cD cmv co cC chil
    wcel cC c0v cif cD cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif
    cmv co cmv cC cC chil wcel cC c0v cif cD cmv opreq1 opreq2d cC cC chil wcel
    cC c0v cif wceq cA chil wcel cA c0v cif cC cmv co cA chil wcel cA c0v cif
    cC chil wcel cC c0v cif cmv co cB chil wcel cB c0v cif cD cmv co cmv cC cC
    chil wcel cC c0v cif cA chil wcel cA c0v cif cmv opreq2 opreq1d eqeq12d cD
    cD chil wcel cD c0v cif wceq cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif cmv co cC chil wcel cC c0v cif cD cmv co cmv co cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cmv co cC chil wcel cC c0v cif cD chil wcel cD c0v
    cif cmv co cmv co cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cB
    chil wcel cB c0v cif cD cmv co cmv co cA chil wcel cA c0v cif cC chil wcel
    cC c0v cif cmv co cB chil wcel cB c0v cif cD chil wcel cD c0v cif cmv co
    cmv co cD cD chil wcel cD c0v cif wceq cC chil wcel cC c0v cif cD cmv co cC
    chil wcel cC c0v cif cD chil wcel cD c0v cif cmv co cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cmv co cmv cD cD chil wcel cD c0v cif cC chil wcel
    cC c0v cif cmv opreq2 opreq2d cD cD chil wcel cD c0v cif wceq cB chil wcel
    cB c0v cif cD cmv co cB chil wcel cB c0v cif cD chil wcel cD c0v cif cmv co
    cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cmv cD cD chil wcel
    cD c0v cif cB chil wcel cB c0v cif cmv opreq2 opreq2d eqeq12d cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cC chil wcel cC c0v cif cD chil wcel cD
    c0v cif cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel cC c0v chil
    ax-hv0cl elimel cD c0v chil ax-hv0cl elimel hvsubsub4i dedth4h $.
    $( [2-Apr-2000] $)

  $( Two times a vector. $)
  hv2times $p |- ( A e. ~H -> ( 2 .h A ) = ( A +h A ) ) $=
    cA chil wcel c2 cA csm co c1 cA csm co c1 cA csm co cva co c1 cA cA cva co
    csm co cA cA cva co cA chil wcel c1 c1 caddc co cA csm co c1 cA csm co c1
    cA csm co cva co c2 cA csm co c1 cc wcel c1 cc wcel cA chil wcel c1 c1
    caddc co cA csm co c1 cA csm co c1 cA csm co cva co wceq ax1cn ax1cn c1 c1
    cA ax-hvdistr2 mp3an12 c2 c1 c1 caddc co cA csm df-2 opreq1i syl5eq cA chil
    wcel c1 cA cA cva co csm co c1 cA csm co c1 cA csm co cva co wceq c1 cc
    wcel cA chil wcel cA chil wcel c1 cA cA cva co csm co c1 cA csm co c1 cA
    csm co cva co wceq ax1cn c1 cA cA ax-hvdistr1 mp3an1 anidms cA chil wcel cA
    cA cva co chil wcel c1 cA cA cva co csm co cA cA cva co wceq cA chil wcel
    cA cA cva co chil wcel cA cA hvaddcl anidms cA cA cva co ax-hvmulid syl
    3eqtr2d $.
    $( [22-Jun-2006] $) $( [22-Jun-2006] $)

  ${
    hvnegdi.1 $e |- A e. ~H $.
    hvnegdi.2 $e |- B e. ~H $.
    $( Distribution of negative over subtraction. $)
    hvnegdii $p |- ( -u 1 .h ( A -h B ) ) = ( B -h A ) $=
      c1 cneg cA cB cmv co csm co c1 cneg cA c1 cneg cB csm co cva co csm co c1
      cneg cA csm co c1 cneg c1 cneg cB csm co csm co cva co cB cA cmv co cA cB
      cmv co cA c1 cneg cB csm co cva co c1 cneg csm cA cB hvnegdi.1 hvnegdi.2
      hvsubvali opreq2i c1 cneg cA c1 cneg cB csm co c1 ax1cn negcli hvnegdi.1
      c1 cneg cB c1 ax1cn negcli hvnegdi.2 hvmulcli hvdistr1i c1 cneg c1 cneg
      cB csm co csm co c1 cneg cA csm co cva co cB c1 cneg cA csm co cva co c1
      cneg cA csm co c1 cneg c1 cneg cB csm co csm co cva co cB cA cmv co c1
      cneg c1 cneg cB csm co csm co cB c1 cneg cA csm co cva c1 cneg c1 cneg
      cmul co cB csm co c1 cB csm co c1 cneg c1 cneg cB csm co csm co cB c1
      cneg c1 cneg cmul co c1 cB csm c1 cneg c1 cneg cmul co c1 c1 cmul co c1
      c1 c1 ax1cn ax1cn mul2negi c1 ax1cn mulid1i eqtri opreq1i c1 cneg c1 cneg
      cB c1 ax1cn negcli c1 ax1cn negcli hvnegdi.2 hvmulassi cB chil wcel c1 cB
      csm co cB wceq hvnegdi.2 cB ax-hvmulid ax-mp 3eqtr3i opreq1i c1 cneg cA
      csm co c1 cneg c1 cneg cB csm co csm co c1 cneg cA c1 ax1cn negcli
      hvnegdi.1 hvmulcli c1 cneg c1 cneg cB csm co c1 ax1cn negcli c1 cneg cB
      c1 ax1cn negcli hvnegdi.2 hvmulcli hvmulcli hvcomi cB cA hvnegdi.2
      hvnegdi.1 hvsubvali 3eqtr4i 3eqtri $.
      $( [31-Oct-1999] $)

    $( If the difference between two vectors is zero, they are equal. $)
    hvsubeq0i $p |- ( ( A -h B ) = 0h <-> A = B ) $=
      cA cB cmv co c0v wceq cA cB wceq cA cB cmv co c0v wceq cA c1 cneg cB csm
      co cva co cB cva co c0v cB cva co cA cB cA cB cmv co c0v wceq cA c1 cneg
      cB csm co cva co c0v wceq cA c1 cneg cB csm co cva co cB cva co c0v cB
      cva co wceq cA cB cmv co cA c1 cneg cB csm co cva co c0v cA cB hvnegdi.1
      hvnegdi.2 hvsubvali eqeq1i cA c1 cneg cB csm co cva co c0v cB cva opreq1
      sylbi cA c1 cneg cB csm co cva co cB cva co cA cB cva co c1 cneg cB csm
      co cva co cA cB c1 cneg cB csm co cva co cva co cA cA c1 cneg cB csm co
      cB hvnegdi.1 c1 cneg cB c1 ax1cn negcli hvnegdi.2 hvmulcli hvnegdi.2
      hvadd23i cA cB c1 cneg cB csm co hvnegdi.1 hvnegdi.2 c1 cneg cB c1 ax1cn
      negcli hvnegdi.2 hvmulcli hvassi cA cB c1 cneg cB csm co cva co cva co cA
      c0v cva co cA cB c1 cneg cB csm co cva co c0v cA cva cB hvnegdi.2
      hvnegidi opreq2i cA chil wcel cA c0v cva co cA wceq hvnegdi.1 cA
      ax-hvaddid ax-mp eqtri 3eqtri cB hvnegdi.2 hvaddid2i 3eqtr3g cA cB wceq
      cA cB cmv co cB cB cmv co c0v cA cB cB cmv opreq1 cB chil wcel cB cB cmv
      co c0v wceq hvnegdi.2 cB hvsubid ax-mp syl6eq impbii $.
      $( [18-Aug-1999] $)

    $( Vector cancellation law. $)
    hvsubcan2i $p |- ( ( A +h B ) +h ( A -h B ) ) = ( 2 .h A ) $=
      cA cB cva co cA cB cmv co cva co cA cB cva co cA c1 cneg cB csm co cva co
      cva co c2 cA csm co c0v cva co c2 cA csm co cA cB cmv co cA c1 cneg cB
      csm co cva co cA cB cva co cva cA cB hvnegdi.1 hvnegdi.2 hvsubvali
      opreq2i cA cB cva co cA c1 cneg cB csm co cva co cva co cA cA cva co cB
      c1 cneg cB csm co cva co cva co c2 cA csm co c0v cva co cA cB cA c1 cneg
      cB csm co hvnegdi.1 hvnegdi.2 hvnegdi.1 c1 cneg cB c1 ax1cn negcli
      hvnegdi.2 hvmulcli hvadd4i cA cA cva co c2 cA csm co cB c1 cneg cB csm co
      cva co c0v cva c2 cA csm co cA cA cva co cA chil wcel c2 cA csm co cA cA
      cva co wceq hvnegdi.1 cA hv2times ax-mp eqcomi cB hvnegdi.2 hvnegidi
      opreq12i eqtri c2 cA csm co chil wcel c2 cA csm co c0v cva co c2 cA csm
      co wceq c2 cA 2cn hvnegdi.1 hvmulcli c2 cA csm co ax-hvaddid ax-mp 3eqtri
      $.
      $( [3-Sep-1999] $)

    ${
      hvaddcan.3 $e |- C e. ~H $.
      $( Cancellation law for vector addition. $)
      hvaddcani $p |- ( ( A +h B ) = ( A +h C ) <-> B = C ) $=
        cA cB cva co cA cC cva co wceq cB cC wceq cA cB cva co cA cC cva co
        wceq cA cB cva co c1 cneg cA csm co cva co cA cC cva co c1 cneg cA csm
        co cva co cB cC cA cB cva co cA cC cva co c1 cneg cA csm co cva opreq1
        cA cB cva co c1 cneg cA csm co cva co cA c1 cneg cA csm co cva co cB
        cva co c0v cB cva co cB cA cB c1 cneg cA csm co hvnegdi.1 hvnegdi.2 c1
        cneg cA c1 ax1cn negcli hvnegdi.1 hvmulcli hvadd23i cA c1 cneg cA csm
        co cva co c0v cB cva cA hvnegdi.1 hvnegidi opreq1i cB hvnegdi.2
        hvaddid2i 3eqtri cA cC cva co c1 cneg cA csm co cva co cA c1 cneg cA
        csm co cva co cC cva co c0v cC cva co cC cA cC c1 cneg cA csm co
        hvnegdi.1 hvaddcan.3 c1 cneg cA c1 ax1cn negcli hvnegdi.1 hvmulcli
        hvadd23i cA c1 cneg cA csm co cva co c0v cC cva cA hvnegdi.1 hvnegidi
        opreq1i cC hvaddcan.3 hvaddid2i 3eqtri 3eqtr3g cB cC cA cva opreq2
        impbii $.
        $( [11-Sep-1999] $)

      $( Relationship between vector subtraction and addition. $)
      hvsubaddi $p |- ( ( A -h B ) = C <-> ( B +h C ) = A ) $=
        cA cB cmv co cC wceq cA c1 cneg cB csm co cva co cC wceq cB cC cva co
        cA wceq cA cB cmv co cA c1 cneg cB csm co cva co cC cA cB hvnegdi.1
        hvnegdi.2 hvsubvali eqeq1i cB cA c1 cneg cB csm co cva co cva co cB cC
        cva co wceq cA cB cC cva co wceq cA c1 cneg cB csm co cva co cC wceq cB
        cC cva co cA wceq cB cA c1 cneg cB csm co cva co cva co cA cB cC cva co
        cB cA c1 cneg cB csm co cva co cva co cA cB c1 cneg cB csm co cva co
        cva co cA c0v cva co cA cB cA c1 cneg cB csm co hvnegdi.2 hvnegdi.1 c1
        cneg cB c1 ax1cn negcli hvnegdi.2 hvmulcli hvadd12i cB c1 cneg cB csm
        co cva co c0v cA cva cB hvnegdi.2 hvnegidi opreq2i cA chil wcel cA c0v
        cva co cA wceq hvnegdi.1 cA ax-hvaddid ax-mp 3eqtri eqeq1i cB cA c1
        cneg cB csm co cva co cC hvnegdi.2 cA c1 cneg cB csm co hvnegdi.1 c1
        cneg cB c1 ax1cn negcli hvnegdi.2 hvmulcli hvaddcli hvaddcan.3
        hvaddcani cA cB cC cva co eqcom 3bitr3i bitri $.
        $( [11-Sep-1999] $)
    $}
  $}

  $( Distribution of negative over subtraction. $)
  hvnegdi $p |- ( ( A e. ~H /\ B e. ~H ) ->
                ( -u 1 .h ( A -h B ) ) = ( B -h A ) ) $=
    cA chil wcel cB chil wcel c1 cneg cA cB cmv co csm co cB cA cmv co wceq c1
    cneg cA chil wcel cA c0v cif cB cmv co csm co cB cA chil wcel cA c0v cif
    cmv co wceq c1 cneg cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co
    csm co cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv co wceq cA cB
    c0v c0v cA cA chil wcel cA c0v cif wceq c1 cneg cA cB cmv co csm co c1 cneg
    cA chil wcel cA c0v cif cB cmv co csm co cB cA cmv co cB cA chil wcel cA
    c0v cif cmv co cA cA chil wcel cA c0v cif wceq cA cB cmv co cA chil wcel cA
    c0v cif cB cmv co c1 cneg csm cA cA chil wcel cA c0v cif cB cmv opreq1
    opreq2d cA cA chil wcel cA c0v cif cB cmv opreq2 eqeq12d cB cB chil wcel cB
    c0v cif wceq c1 cneg cA chil wcel cA c0v cif cB cmv co csm co c1 cneg cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co csm co cB cA chil wcel
    cA c0v cif cmv co cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv co cB
    cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cmv co c1 cneg csm cB cB chil wcel cB
    c0v cif cA chil wcel cA c0v cif cmv opreq2 opreq2d cB cB chil wcel cB c0v
    cif cA chil wcel cA c0v cif cmv opreq1 eqeq12d cA chil wcel cA c0v cif cB
    chil wcel cB c0v cif cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl
    elimel hvnegdii dedth2h $.
    $( [2-Apr-2000] $)

  $( If the difference between two vectors is zero, they are equal. $)
  hvsubeq0 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( A -h B ) = 0h <-> A = B ) ) $=
    cA chil wcel cB chil wcel cA cB cmv co c0v wceq cA cB wceq wb cA chil wcel
    cA c0v cif cB cmv co c0v wceq cA chil wcel cA c0v cif cB wceq wb cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif cmv co c0v wceq cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif wceq wb cA cB c0v c0v cA cA chil wcel cA c0v
    cif wceq cA cB cmv co c0v wceq cA chil wcel cA c0v cif cB cmv co c0v wceq
    cA cB wceq cA chil wcel cA c0v cif cB wceq cA cA chil wcel cA c0v cif wceq
    cA cB cmv co cA chil wcel cA c0v cif cB cmv co c0v cA cA chil wcel cA c0v
    cif cB cmv opreq1 eqeq1d cA cA chil wcel cA c0v cif cB eqeq1 bibi12d cB cB
    chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co c0v wceq cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co c0v wceq cA chil wcel
    cA c0v cif cB wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif wceq cB
    cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cmv co c0v cB cB chil wcel cB c0v cif cA
    chil wcel cA c0v cif cmv opreq2 eqeq1d cB cB chil wcel cB c0v cif cA chil
    wcel cA c0v cif eqeq2 bibi12d cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel hvsubeq0i
    dedth2h $.
    $( [23-Oct-1999] $)

  $( If the sum of two vectors is zero, one is the negative of the other. $)
  hvaddeq0 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( A +h B ) = 0h <-> A = ( -u 1 .h B ) ) ) $=
    cA chil wcel cB chil wcel wa cA cB cva co c0v wceq cA c1 cneg cB csm co cmv
    co c0v wceq cA c1 cneg cB csm co wceq cA chil wcel cB chil wcel wa cA cB
    cva co cA c1 cneg cB csm co cmv co c0v cA cB hvaddsubval eqeq1d cA chil
    wcel c1 cneg cB csm co chil wcel cA c1 cneg cB csm co cmv co c0v wceq cA c1
    cneg cB csm co wceq wb cB chil wcel cA c1 cneg cB csm co hvsubeq0 c1 cneg
    cc wcel cB chil wcel c1 cneg cB csm co chil wcel c1 ax1cn negcli c1 cneg cB
    hvmulcl mpan sylan2 bitrd $.
    $( [19-Jun-2006] $) $( [10-Jun-2006] $)

  $( Cancellation law for vector addition. $)
  hvaddcan $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A +h B ) = ( A +h C ) <-> B = C ) ) $=
    cA chil wcel cB chil wcel cC chil wcel cA cB cva co cA cC cva co wceq cB cC
    wceq wb cA chil wcel cA c0v cif cB cva co cA chil wcel cA c0v cif cC cva co
    wceq cB cC wceq wb cA cB cC c0v c0v c0v cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cva co cA chil wcel cA c0v cif cC cva co wceq cB chil wcel
    cB c0v cif cC wceq wb cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva
    co cA chil wcel cA c0v cif cC chil wcel cC c0v cif cva co wceq cB chil wcel
    cB c0v cif cC chil wcel cC c0v cif wceq wb cA cA chil wcel cA c0v cif wceq
    cA cB cva co cA cC cva co wceq cA chil wcel cA c0v cif cB cva co cA chil
    wcel cA c0v cif cC cva co wceq cB cC wceq cA cA chil wcel cA c0v cif wceq
    cA cB cva co cA chil wcel cA c0v cif cB cva co cA cC cva co cA chil wcel cA
    c0v cif cC cva co cA cA chil wcel cA c0v cif cB cva opreq1 cA cA chil wcel
    cA c0v cif cC cva opreq1 eqeq12d bibi1d cB cB chil wcel cB c0v cif wceq cA
    chil wcel cA c0v cif cB cva co cA chil wcel cA c0v cif cC cva co wceq cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cA chil wcel cA c0v cif
    cC cva co wceq cB cC wceq cB chil wcel cB c0v cif cC wceq cB cB chil wcel
    cB c0v cif wceq cA chil wcel cA c0v cif cB cva co cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cva co cA chil wcel cA c0v cif cC cva co cB cB chil
    wcel cB c0v cif cA chil wcel cA c0v cif cva opreq2 eqeq1d cB cB chil wcel
    cB c0v cif cC eqeq1 bibi12d cC cC chil wcel cC c0v cif wceq cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif cva co cA chil wcel cA c0v cif cC cva co
    wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cA chil wcel cA
    c0v cif cC chil wcel cC c0v cif cva co wceq cB chil wcel cB c0v cif cC wceq
    cB chil wcel cB c0v cif cC chil wcel cC c0v cif wceq cC cC chil wcel cC c0v
    cif wceq cA chil wcel cA c0v cif cC cva co cA chil wcel cA c0v cif cC chil
    wcel cC c0v cif cva co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva
    co cC cC chil wcel cC c0v cif cA chil wcel cA c0v cif cva opreq2 eqeq2d cC
    cC chil wcel cC c0v cif cB chil wcel cB c0v cif eqeq2 bibi12d cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cC chil wcel cC c0v cif cA c0v chil
    ax-hv0cl elimel cB c0v chil ax-hv0cl elimel cC c0v chil ax-hv0cl elimel
    hvaddcani dedth3h $.
    $( [27-May-2005] $) $( [18-May-2005] $)

  $( Cancellation law for vector addition. $)
  hvaddcan2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A +h C ) = ( B +h C ) <-> A = B ) ) $=
    cC chil wcel cA chil wcel cB chil wcel cA cC cva co cB cC cva co wceq cA cB
    wceq wb cC chil wcel cA chil wcel cB chil wcel w3a cC cA cva co cC cB cva
    co wceq cA cC cva co cB cC cva co wceq cA cB wceq cC chil wcel cA chil wcel
    cB chil wcel w3a cC cA cva co cA cC cva co cC cB cva co cB cC cva co cC
    chil wcel cA chil wcel cC cA cva co cA cC cva co wceq cB chil wcel cC cA
    ax-hvcom 3adant3 cC chil wcel cB chil wcel cC cB cva co cB cC cva co wceq
    cA chil wcel cC cB ax-hvcom 3adant2 eqeq12d cC cA cB hvaddcan bitr3d 3coml
    $.
    $( [2-Jun-2005] $) $( [18-May-2005] $)

  $( Cancellation law for scalar multiplication. $)
  hvmulcan $p |- ( ( ( A e. CC  /\ A =/= 0 ) /\ B e. ~H /\ C e. ~H )
               -> ( ( A .h B ) = ( A .h C ) <-> B = C ) ) $=
    cA cc wcel cA cc0 wne wa cB chil wcel cC chil wcel w3a cB cC cmv co c0v
    wceq cA cc0 wceq cB cC cmv co c0v wceq wo cB cC wceq cA cB csm co cA cC csm
    co wceq cA cc wcel cA cc0 wne wa cB chil wcel cB cC cmv co c0v wceq cA cc0
    wceq cB cC cmv co c0v wceq wo wb cC chil wcel cA cc0 wne cB cC cmv co c0v
    wceq cA cc0 wceq cB cC cmv co c0v wceq wo wb cA cc wcel cB chil wcel cA cc0
    wne cA cc0 wceq wn cB cC cmv co c0v wceq cA cc0 wceq cB cC cmv co c0v wceq
    wo wb cA cc0 df-ne cA cc0 wceq cB cC cmv co c0v wceq biorf sylbi ad2antlr
    3adant3 cB chil wcel cC chil wcel cB cC cmv co c0v wceq cB cC wceq wb cA cc
    wcel cA cc0 wne wa cB cC hvsubeq0 3adant1 cA cc wcel cB chil wcel cC chil
    wcel cA cc0 wceq cB cC cmv co c0v wceq wo cA cB csm co cA cC csm co wceq wb
    cA cc0 wne cA cc wcel cB chil wcel cC chil wcel w3a cA cB cC cmv co csm co
    c0v wceq cA cB csm co cA cC csm co cmv co c0v wceq cA cc0 wceq cB cC cmv co
    c0v wceq wo cA cB csm co cA cC csm co wceq cA cc wcel cB chil wcel cC chil
    wcel w3a cA cB cC cmv co csm co cA cB csm co cA cC csm co cmv co c0v cA cB
    cC hvsubdistr1 eqeq1d cA cc wcel cB chil wcel cC chil wcel cA cB cC cmv co
    csm co c0v wceq cA cc0 wceq cB cC cmv co c0v wceq wo wb cA cc wcel cB cC
    cmv co chil wcel cA cB cC cmv co csm co c0v wceq cA cc0 wceq cB cC cmv co
    c0v wceq wo wb cB chil wcel cC chil wcel wa cA cB cC cmv co hvmul0or cB cC
    hvsubcl sylan2 3impb cA cB csm co chil wcel cA cC csm co chil wcel cA cB
    csm co cA cC csm co cmv co c0v wceq cA cB csm co cA cC csm co wceq wb cA cc
    wcel cB chil wcel cC chil wcel w3a cA cB csm co cA cC csm co hvsubeq0 cA cc
    wcel cB chil wcel cA cB csm co chil wcel cC chil wcel cA cB hvmulcl 3adant3
    cA cc wcel cC chil wcel cA cC csm co chil wcel cB chil wcel cA cC hvmulcl
    3adant2 sylanc 3bitr3d 3adant1r 3bitr3rd $.
    $( [30-Dec-2008] $) $( [19-May-2005] $)

  $( Cancellation law for scalar multiplication. $)
  hvmulcanOLD $p |- ( ( ( A e. CC /\ B e. ~H /\ C e. ~H ) /\ A =/= 0 ) ->
                  ( ( A .h B ) = ( A .h C ) <-> B = C ) ) $=
    cA cc wcel cB chil wcel cC chil wcel w3a cA cc0 wne wa cB cC cmv co c0v
    wceq cA cB csm co cA cC csm co wceq cB cC wceq cA cc wcel cB chil wcel cC
    chil wcel w3a cA cc0 wne wa cB cC cmv co c0v wceq cA cB cC cmv co csm co
    c0v wceq cA cB csm co cA cC csm co cmv co c0v wceq cA cB csm co cA cC csm
    co wceq cA cc wcel cB chil wcel cC chil wcel w3a cA cc0 wne wa cB cC cmv co
    c0v wceq cA cc0 wceq cB cC cmv co c0v wceq wo cA cB cC cmv co csm co c0v
    wceq cA cc0 wne cB cC cmv co c0v wceq cA cc0 wceq cB cC cmv co c0v wceq wo
    wb cA cc wcel cB chil wcel cC chil wcel w3a cA cc0 wne cA cc0 wceq wn cB cC
    cmv co c0v wceq cA cc0 wceq cB cC cmv co c0v wceq wo wb cA cc0 df-ne cA cc0
    wceq cB cC cmv co c0v wceq biorf sylbi adantl cA cc wcel cB chil wcel cC
    chil wcel w3a cA cB cC cmv co csm co c0v wceq cA cc0 wceq cB cC cmv co c0v
    wceq wo wb cA cc0 wne cA cc wcel cB chil wcel cC chil wcel cA cB cC cmv co
    csm co c0v wceq cA cc0 wceq cB cC cmv co c0v wceq wo wb cA cc wcel cB cC
    cmv co chil wcel cA cB cC cmv co csm co c0v wceq cA cc0 wceq cB cC cmv co
    c0v wceq wo wb cB chil wcel cC chil wcel wa cA cB cC cmv co hvmul0or cB cC
    hvsubcl sylan2 3impb adantr bitr4d cA cc wcel cB chil wcel cC chil wcel w3a
    cA cc0 wne wa cA cB cC cmv co csm co cA cB csm co cA cC csm co cmv co c0v
    cA cc wcel cB chil wcel cC chil wcel w3a cA cB cC cmv co csm co cA cB csm
    co cA cC csm co cmv co wceq cA cc0 wne cA cB cC hvsubdistr1 adantr eqeq1d
    cA cc wcel cB chil wcel cC chil wcel w3a cA cB csm co cA cC csm co cmv co
    c0v wceq cA cB csm co cA cC csm co wceq wb cA cc0 wne cA cB csm co chil
    wcel cA cC csm co chil wcel cA cB csm co cA cC csm co cmv co c0v wceq cA cB
    csm co cA cC csm co wceq wb cA cc wcel cB chil wcel cC chil wcel w3a cA cB
    csm co cA cC csm co hvsubeq0 cA cc wcel cB chil wcel cA cB csm co chil wcel
    cC chil wcel cA cB hvmulcl 3adant3 cA cc wcel cC chil wcel cA cC csm co
    chil wcel cB chil wcel cA cC hvmulcl 3adant2 sylanc adantr 3bitrd cA cc
    wcel cB chil wcel cC chil wcel w3a cB cC cmv co c0v wceq cB cC wceq wb cA
    cc0 wne cB chil wcel cC chil wcel cB cC cmv co c0v wceq cB cC wceq wb cA cc
    wcel cB cC hvsubeq0 3adant1 adantr bitr3d $.
    $( [22-May-2005] $) $( [19-May-2005] $)

  $( Cancellation law for scalar multiplication. $)
  hvmulcan2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. ~H /\ C =/= 0h ) ) ->
                  ( ( A .h C ) = ( B .h C ) <-> A = B ) ) $=
    cA cc wcel cB cc wcel cC chil wcel cC c0v wne wa w3a cA cC csm co cB cC csm
    co cmv co c0v wceq cA cC csm co cB cC csm co wceq cA cB wceq cA cc wcel cB
    cc wcel cC chil wcel cA cC csm co cB cC csm co cmv co c0v wceq cA cC csm co
    cB cC csm co wceq wb cC c0v wne cA cC csm co chil wcel cB cC csm co chil
    wcel cA cC csm co cB cC csm co cmv co c0v wceq cA cC csm co cB cC csm co
    wceq wb cA cc wcel cB cc wcel cC chil wcel w3a cA cC csm co cB cC csm co
    hvsubeq0 cA cc wcel cC chil wcel cA cC csm co chil wcel cB cc wcel cA cC
    hvmulcl 3adant2 cB cc wcel cC chil wcel cB cC csm co chil wcel cA cc wcel
    cB cC hvmulcl 3adant1 sylanc 3adant3r cA cc wcel cB cc wcel cC chil wcel cC
    c0v wne wa w3a cA cC csm co cB cC csm co cmv co c0v wceq cA cB cmin co cc0
    wceq cC c0v wceq wo cA cB cmin co cc0 wceq cA cB wceq cA cc wcel cB cc wcel
    cC chil wcel cA cC csm co cB cC csm co cmv co c0v wceq cA cB cmin co cc0
    wceq cC c0v wceq wo wb cC c0v wne cA cc wcel cB cc wcel cC chil wcel w3a cA
    cB cmin co cC csm co c0v wceq cA cC csm co cB cC csm co cmv co c0v wceq cA
    cB cmin co cc0 wceq cC c0v wceq wo cA cc wcel cB cc wcel cC chil wcel w3a
    cA cB cmin co cC csm co cA cC csm co cB cC csm co cmv co c0v cA cB cC
    hvsubdistr2 eqeq1d cA cc wcel cB cc wcel cC chil wcel cA cB cmin co cC csm
    co c0v wceq cA cB cmin co cc0 wceq cC c0v wceq wo wb cA cB cmin co cc wcel
    cC chil wcel cA cB cmin co cC csm co c0v wceq cA cB cmin co cc0 wceq cC c0v
    wceq wo wb cA cc wcel cB cc wcel wa cA cB cmin co cC hvmul0or cA cB subcl
    sylan 3impa bitr3d 3adant3r cB cc wcel cC chil wcel cC c0v wne wa cA cB
    cmin co cc0 wceq cA cB cmin co cc0 wceq cC c0v wceq wo wb cA cc wcel cC c0v
    wne cA cB cmin co cc0 wceq cA cB cmin co cc0 wceq cC c0v wceq wo wb cB cc
    wcel cC chil wcel cC c0v wne cC c0v wceq wn cA cB cmin co cc0 wceq cA cB
    cmin co cc0 wceq cC c0v wceq wo wb cC c0v df-ne cC c0v wceq wn cA cB cmin
    co cc0 wceq cC c0v wceq cA cB cmin co cc0 wceq wo cA cB cmin co cc0 wceq cC
    c0v wceq wo cC c0v wceq cA cB cmin co cc0 wceq biorf cC c0v wceq cA cB cmin
    co cc0 wceq orcom syl6bb sylbi ad2antll 3adant1 cA cc wcel cB cc wcel cA cB
    cmin co cc0 wceq cA cB wceq wb cC chil wcel cC c0v wne wa cA cB subeq0
    3adant3 3bitr2d bitr3d $.
    $( [2-Jan-2009] $) $( [19-May-2005] $)

  $( Cancellation law for vector addition. $)
  hvsubcan $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h B ) = ( A -h C ) <-> B = C ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB cmv co cA cC cmv co wceq
    cA c1 cneg cB csm co cva co cA c1 cneg cC csm co cva co wceq c1 cneg cB csm
    co c1 cneg cC csm co wceq cB cC wceq cA chil wcel cB chil wcel cC chil wcel
    w3a cA cB cmv co cA c1 cneg cB csm co cva co cA cC cmv co cA c1 cneg cC csm
    co cva co cA chil wcel cB chil wcel cA cB cmv co cA c1 cneg cB csm co cva
    co wceq cC chil wcel cA cB hvsubval 3adant3 cA chil wcel cC chil wcel cA cC
    cmv co cA c1 cneg cC csm co cva co wceq cB chil wcel cA cC hvsubval 3adant2
    eqeq12d cA chil wcel c1 cneg cB csm co chil wcel cC chil wcel cA c1 cneg cB
    csm co cva co cA c1 cneg cC csm co cva co wceq c1 cneg cB csm co c1 cneg cC
    csm co wceq wb cB chil wcel cA chil wcel c1 cneg cB csm co chil wcel c1
    cneg cC csm co chil wcel cA c1 cneg cB csm co cva co cA c1 cneg cC csm co
    cva co wceq c1 cneg cB csm co c1 cneg cC csm co wceq wb cC chil wcel cA c1
    cneg cB csm co c1 cneg cC csm co hvaddcan c1 cneg cc wcel cC chil wcel c1
    cneg cC csm co chil wcel c1 ax1cn negcli c1 cneg cC hvmulcl mpan syl3an3 c1
    cneg cc wcel cB chil wcel c1 cneg cB csm co chil wcel c1 ax1cn negcli c1
    cneg cB hvmulcl mpan syl3an2 cB chil wcel cC chil wcel c1 cneg cB csm co c1
    cneg cC csm co wceq cB cC wceq wb cA chil wcel c1 cneg cc wcel cB chil wcel
    cC chil wcel c1 cneg cB csm co c1 cneg cC csm co wceq cB cC wceq wb c1
    ax1cn negcli c1 cneg cc wcel cB chil wcel cC chil wcel w3a c1 cneg cc0 wne
    c1 cneg cB csm co c1 cneg cC csm co wceq cB cC wceq wb c1 ax1cn ax1ne0
    negne0i c1 cneg cB cC hvmulcanOLD mpan2 mp3an1 3adant1 3bitrd $.
    $( [5-Jun-2005] $) $( [18-May-2005] $)

  $( Cancellation law for vector addition. $)
  hvsubcan2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h C ) = ( B -h C ) <-> A = B ) ) $=
    cC chil wcel cA chil wcel cB chil wcel cA cC cmv co cB cC cmv co wceq cA cB
    wceq wb cC chil wcel cA chil wcel cB chil wcel w3a c1 cneg cC cA cmv co csm
    co c1 cneg cC cB cmv co csm co wceq cC cA cmv co cC cB cmv co wceq cA cC
    cmv co cB cC cmv co wceq cA cB wceq cC cA cmv co chil wcel cC cB cmv co
    chil wcel c1 cneg cC cA cmv co csm co c1 cneg cC cB cmv co csm co wceq cC
    cA cmv co cC cB cmv co wceq wb cC chil wcel cA chil wcel cB chil wcel w3a
    c1 cneg cc wcel cC cA cmv co chil wcel cC cB cmv co chil wcel c1 cneg cC cA
    cmv co csm co c1 cneg cC cB cmv co csm co wceq cC cA cmv co cC cB cmv co
    wceq wb c1 ax1cn negcli c1 cneg cc wcel cC cA cmv co chil wcel cC cB cmv co
    chil wcel w3a c1 cneg cc0 wne c1 cneg cC cA cmv co csm co c1 cneg cC cB cmv
    co csm co wceq cC cA cmv co cC cB cmv co wceq wb c1 ax1cn ax1ne0 negne0i c1
    cneg cC cA cmv co cC cB cmv co hvmulcanOLD mpan2 mp3an1 cC chil wcel cA
    chil wcel cC cA cmv co chil wcel cB chil wcel cC cA hvsubcl 3adant3 cC chil
    wcel cB chil wcel cC cB cmv co chil wcel cA chil wcel cC cB hvsubcl 3adant2
    sylanc cC chil wcel cA chil wcel cB chil wcel w3a c1 cneg cC cA cmv co csm
    co cA cC cmv co c1 cneg cC cB cmv co csm co cB cC cmv co cC chil wcel cA
    chil wcel c1 cneg cC cA cmv co csm co cA cC cmv co wceq cB chil wcel cC cA
    hvnegdi 3adant3 cC chil wcel cB chil wcel c1 cneg cC cB cmv co csm co cB cC
    cmv co wceq cA chil wcel cC cB hvnegdi 3adant2 eqeq12d cC cA cB hvsubcan
    3bitr3d 3coml $.
    $( [26-Jun-2005] $) $( [18-May-2005] $)

  $( Subtraction of a zero vector. $)
  hvsub0 $p |- ( A e. ~H -> ( A -h 0h ) = A ) $=
    cA chil wcel cA c0v cmv co cA c0v cva co cA cA chil wcel cA c0v cmv co cA
    c1 cneg c0v csm co cva co cA c0v cva co cA chil wcel c0v chil wcel cA c0v
    cmv co cA c1 cneg c0v csm co cva co wceq ax-hv0cl cA c0v hvsubval mpan2 c1
    cneg c0v csm co c0v cA cva c1 cneg cc wcel c1 cneg c0v csm co c0v wceq c1
    ax1cn negcli c1 cneg hvmul0 ax-mp opreq2i syl6eq cA ax-hvaddid eqtrd $.
    $( [2-Apr-2000] $)

  $( Relationship between vector subtraction and addition. $)
  hvsubadd $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h B ) = C <-> ( B +h C ) = A ) ) $=
    cA chil wcel cB chil wcel cC chil wcel cA cB cmv co cC wceq cB cC cva co cA
    wceq wb cA chil wcel cA c0v cif cB cmv co cC wceq cB cC cva co cA chil wcel
    cA c0v cif wceq wb cA cB cC c0v c0v c0v cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cmv co cC wceq cB chil wcel cB c0v cif cC cva co cA chil
    wcel cA c0v cif wceq wb cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv
    co cC chil wcel cC c0v cif wceq cB chil wcel cB c0v cif cC chil wcel cC c0v
    cif cva co cA chil wcel cA c0v cif wceq wb cA cA chil wcel cA c0v cif wceq
    cA cB cmv co cC wceq cA chil wcel cA c0v cif cB cmv co cC wceq cB cC cva co
    cA wceq cB cC cva co cA chil wcel cA c0v cif wceq cA cA chil wcel cA c0v
    cif wceq cA cB cmv co cA chil wcel cA c0v cif cB cmv co cC cA cA chil wcel
    cA c0v cif cB cmv opreq1 eqeq1d cA cA chil wcel cA c0v cif cB cC cva co
    eqeq2 bibi12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    cmv co cC wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cC
    wceq cB cC cva co cA chil wcel cA c0v cif wceq cB chil wcel cB c0v cif cC
    cva co cA chil wcel cA c0v cif wceq cB cB chil wcel cB c0v cif wceq cA chil
    wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif
    cmv co cC cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2
    eqeq1d cB cB chil wcel cB c0v cif wceq cB cC cva co cB chil wcel cB c0v cif
    cC cva co cA chil wcel cA c0v cif cB cB chil wcel cB c0v cif cC cva opreq1
    eqeq1d bibi12d cC cC chil wcel cC c0v cif wceq cA chil wcel cA c0v cif cB
    chil wcel cB c0v cif cmv co cC wceq cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif cmv co cC chil wcel cC c0v cif wceq cB chil wcel cB c0v cif cC cva
    co cA chil wcel cA c0v cif wceq cB chil wcel cB c0v cif cC chil wcel cC c0v
    cif cva co cA chil wcel cA c0v cif wceq cC cC chil wcel cC c0v cif cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif cmv co eqeq2 cC cC chil wcel cC c0v
    cif wceq cB chil wcel cB c0v cif cC cva co cB chil wcel cB c0v cif cC chil
    wcel cC c0v cif cva co cA chil wcel cA c0v cif cC cC chil wcel cC c0v cif
    cB chil wcel cB c0v cif cva opreq2 eqeq1d bibi12d cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cC chil wcel cC c0v cif cA c0v chil ax-hv0cl elimel
    cB c0v chil ax-hv0cl elimel cC c0v chil ax-hv0cl elimel hvsubaddi dedth3h
    $.
    $( [30-Oct-1999] $)

  $( Hilbert vector space addition/subtraction law. $)
  hvaddsub4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
          ( ( A +h B ) = ( C +h D ) <-> ( A -h C ) = ( D -h B ) ) ) $=
    cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB cva co
    cC cB cva co cmv co cC cD cva co cC cB cva co cmv co wceq cA cB cva co cC
    cD cva co wceq cA cC cmv co cD cB cmv co wceq cA cB cva co chil wcel cC cD
    cva co chil wcel cC cB cva co chil wcel cA cB cva co cC cB cva co cmv co cC
    cD cva co cC cB cva co cmv co wceq cA cB cva co cC cD cva co wceq wb cA
    chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB cva co cC
    cD cva co cC cB cva co hvsubcan2 cA chil wcel cB chil wcel wa cA cB cva co
    chil wcel cC chil wcel cD chil wcel wa cA cB hvaddcl adantr cC chil wcel cD
    chil wcel wa cC cD cva co chil wcel cA chil wcel cB chil wcel wa cC cD
    hvaddcl adantl cB chil wcel cC chil wcel cC cB cva co chil wcel cA chil
    wcel cD chil wcel cC chil wcel cB chil wcel cC cB cva co chil wcel cC cB
    hvaddcl ancoms ad2ant2lr syl3anc cA chil wcel cB chil wcel wa cC chil wcel
    cD chil wcel wa wa cA cB cva co cC cB cva co cmv co cA cC cmv co cC cD cva
    co cC cB cva co cmv co cD cB cmv co cA chil wcel cB chil wcel wa cC chil
    wcel cA cB cva co cC cB cva co cmv co cA cC cmv co wceq cD chil wcel cA
    chil wcel cB chil wcel wa cC chil wcel wa cA cB cva co cC cB cva co cmv co
    cA cC cmv co cB cB cmv co cva co cA cC cmv co c0v cva co cA cC cmv co cA
    chil wcel cB chil wcel wa cC chil wcel cC chil wcel cB chil wcel wa cA cB
    cva co cC cB cva co cmv co cA cC cmv co cB cB cmv co cva co wceq cC chil
    wcel cA chil wcel cB chil wcel wa cC chil wcel cB chil wcel wa cA chil wcel
    cB chil wcel wa cB chil wcel cC chil wcel cA chil wcel cB chil wcel pm3.27
    anim2i ancoms cA cB cC cB hvsub4 syldan cA chil wcel cB chil wcel wa cC
    chil wcel wa cB cB cmv co c0v cA cC cmv co cva cB chil wcel cB cB cmv co
    c0v wceq cA chil wcel cC chil wcel cB hvsubid ad2antlr opreq2d cA chil wcel
    cC chil wcel cA cC cmv co c0v cva co cA cC cmv co wceq cB chil wcel cA chil
    wcel cC chil wcel wa cA cC cmv co chil wcel cA cC cmv co c0v cva co cA cC
    cmv co wceq cA cC hvsubcl cA cC cmv co ax-hvaddid syl adantlr 3eqtrd
    adantrr cB chil wcel cC chil wcel cD chil wcel wa cC cD cva co cC cB cva co
    cmv co cD cB cmv co wceq cA chil wcel cC chil wcel cD chil wcel wa cB chil
    wcel cC cD cva co cC cB cva co cmv co cD cB cmv co wceq cC chil wcel cD
    chil wcel wa cB chil wcel wa cC cD cva co cC cB cva co cmv co cC cC cmv co
    cD cB cmv co cva co c0v cD cB cmv co cva co cD cB cmv co cC chil wcel cD
    chil wcel wa cB chil wcel cC chil wcel cB chil wcel wa cC cD cva co cC cB
    cva co cmv co cC cC cmv co cD cB cmv co cva co wceq cC chil wcel cD chil
    wcel wa cC chil wcel cB chil wcel cC chil wcel cD chil wcel pm3.26 anim1i
    cC cD cC cB hvsub4 syldan cC chil wcel cD chil wcel wa cB chil wcel wa cC
    cC cmv co c0v cD cB cmv co cva cC chil wcel cC cC cmv co c0v wceq cD chil
    wcel cB chil wcel cC hvsubid ad2antrr opreq1d cD chil wcel cB chil wcel c0v
    cD cB cmv co cva co cD cB cmv co wceq cC chil wcel cD chil wcel cB chil
    wcel wa cD cB cmv co chil wcel c0v cD cB cmv co cva co cD cB cmv co wceq cD
    cB hvsubcl cD cB cmv co hvaddid2 syl adantll 3eqtrd ancoms adantll eqeq12d
    bitr3d $.
    $( [30-Jun-2005] $) $( [18-May-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Inner product postulates for a Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Inner product maps pairs from ` ~H ` to ` CC ` . $)
  ax-hfi $a |- .ih : ( ~H X. ~H ) --> CC $.

  $( Closure of inner product. $)
  hicl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A .ih B ) e. CC ) $=
    cA cB cc chil chil csp ax-hfi foprcl $.
    $( [20-Nov-2007] $) $( [17-Nov-2007] $)

  ${
    hicl.1 $e |- A e. ~H $.
    hicl.2 $e |- B e. ~H $.
    $( Closure inference for inner product. $)
    hicli $p |- ( A .ih B ) e. CC $=
      cA chil wcel cB chil wcel cA cB csp co cc wcel hicl.1 hicl.2 cA cB hicl
      mp2an $.
      $( [1-Aug-1999] $)
  $}

  $( Conjugate law for inner product.  Postulate (S1) of [Beran] p. 95.
     Note that ` * `` x ` is the complex conjugate ~ cjval of ` x ` .
     In the literature, the inner product of ` A ` and ` B ` is usually
     written ` <. A , B >. ` , but our operation notation ~ co allows us to use
     existing theorems about operations and also avoids a clash with the
     definition of an ordered pair ~ df-op .  Physicists use ` <. B | A >. ` ,
     called Dirac bra-ket notation, to represent this operation; see comments
     in ~ df-bra . $)
  ax-his1 $a |- ( ( A e. ~H /\ B e. ~H ) ->
                ( A .ih B ) = ( * ` ( B .ih A ) ) ) $.

  $( Distributive law for inner product.  Postulate (S2) of [Beran] p. 95. $)
  ax-his2 $a |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( ( A +h B ) .ih C ) = ( ( A .ih C ) + ( B .ih C ) ) ) $.

  $( Associative law for inner product.  Postulate (S3) of [Beran] p. 95.
     Warning:  Mathematics textbooks usually use our version of the axiom.
     Physics textbooks, on the other hand, usually replace the left-hand side
     with ` ( B .ih ( A .h C ) ) ` (e.g. Equation 1.21b of [Hughes] p. 44;
     Definition (iii) of [ReedSimon] p. 36).  See the comments in ~ df-bra
     for why the physics definition is swapped. $)
  ax-his3 $a |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( ( A .h B ) .ih C ) = ( A x. ( B .ih C ) ) ) $.

  $( Identity law for inner product.  Postulate (S4) of [Beran] p. 95. $)
  ax-his4 $a |- ( ( A e. ~H /\  A =/= 0h ) -> 0 < ( A .ih A ) ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Inner product
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Associative law for inner product.  Lemma 3.1(S5) of [Beran] p. 95. $)
  his5 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( B .ih ( A .h C ) ) = ( ( * ` A ) x. ( B .ih C ) ) ) $=
    cA cc wcel cB chil wcel cC chil wcel w3a cB cA cC csm co csp co cA cC csm
    co cB csp co ccj cfv cA cC cB csp co cmul co ccj cfv cA ccj cfv cB cC csp
    co cmul co cB chil wcel cA cc wcel cC chil wcel cB cA cC csm co csp co cA
    cC csm co cB csp co ccj cfv wceq cB chil wcel cA cc wcel cC chil wcel cB cA
    cC csm co csp co cA cC csm co cB csp co ccj cfv wceq cB chil wcel cA cC csm
    co chil wcel cB cA cC csm co csp co cA cC csm co cB csp co ccj cfv wceq cA
    cc wcel cC chil wcel wa cB cA cC csm co ax-his1 cA cC hvmulcl sylan2 3impb
    3com12 cA cc wcel cB chil wcel cC chil wcel w3a cA cC csm co cB csp co cA
    cC cB csp co cmul co ccj cA cc wcel cC chil wcel cB chil wcel cA cC csm co
    cB csp co cA cC cB csp co cmul co wceq cA cC cB ax-his3 3com23 fveq2d cA cc
    wcel cB chil wcel cC chil wcel w3a cA cC cB csp co cmul co ccj cfv cA ccj
    cfv cC cB csp co ccj cfv cmul co cA ccj cfv cB cC csp co cmul co cA cc wcel
    cC chil wcel cB chil wcel cA cC cB csp co cmul co ccj cfv cA ccj cfv cC cB
    csp co ccj cfv cmul co wceq cA cc wcel cC chil wcel cB chil wcel cA cC cB
    csp co cmul co ccj cfv cA ccj cfv cC cB csp co ccj cfv cmul co wceq cA cc
    wcel cC cB csp co cc wcel cA cC cB csp co cmul co ccj cfv cA ccj cfv cC cB
    csp co ccj cfv cmul co wceq cC chil wcel cB chil wcel wa cA cC cB csp co
    cjmul cC cB hicl sylan2 3impb 3com23 cA cc wcel cB chil wcel cC chil wcel
    w3a cB cC csp co cC cB csp co ccj cfv cA ccj cfv cmul cB chil wcel cC chil
    wcel cB cC csp co cC cB csp co ccj cfv wceq cA cc wcel cB cC ax-his1
    3adant1 opreq2d eqtr4d 3eqtrd $.
    $( [29-Jul-1999] $)

  $( Associative law for inner product. $)
  his52 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( B .ih ( ( * ` A ) .h C ) ) = ( A x. ( B .ih C ) ) ) $=
    cA cc wcel cB chil wcel cC chil wcel w3a cB cA ccj cfv cC csm co csp co cA
    ccj cfv ccj cfv cB cC csp co cmul co cA cB cC csp co cmul co cA ccj cfv cc
    wcel cB chil wcel cC chil wcel cB cA ccj cfv cC csm co csp co cA ccj cfv
    ccj cfv cB cC csp co cmul co wceq cA cc wcel cA ccj cfv cB cC his5 cA cjcl
    syl3an1 cA cc wcel cB chil wcel cA ccj cfv ccj cfv cB cC csp co cmul co cA
    cB cC csp co cmul co wceq cC chil wcel cA cc wcel cA ccj cfv ccj cfv cA cB
    cC csp co cmul cA cjcj opreq1d 3ad2ant1 eqtrd $.
    $( [19-Feb-2006] $) $( [13-Feb-2006] $)

  ${
    his35.1 $e |- A e. CC $.
    his35.2 $e |- B e. CC $.
    his35.3 $e |- C e. ~H $.
    his35.4 $e |- D e. ~H $.
    $( Move scalar multiplication to outside of inner product. $)
    his35i $p |- ( ( A .h C ) .ih ( B .h D ) ) =
              ( ( A x. ( * ` B ) ) x. ( C .ih D ) ) $=
      cA cC cB cD csm co csp co cmul co cA cB ccj cfv cC cD csp co cmul co cmul
      co cA cC csm co cB cD csm co csp co cA cB ccj cfv cmul co cC cD csp co
      cmul co cC cB cD csm co csp co cB ccj cfv cC cD csp co cmul co cA cmul cB
      cc wcel cC chil wcel cD chil wcel cC cB cD csm co csp co cB ccj cfv cC cD
      csp co cmul co wceq his35.2 his35.3 his35.4 cB cC cD his5 mp3an opreq2i
      cA cc wcel cC chil wcel cB cD csm co chil wcel cA cC csm co cB cD csm co
      csp co cA cC cB cD csm co csp co cmul co wceq his35.1 his35.3 cB cD
      his35.2 his35.4 hvmulcli cA cC cB cD csm co ax-his3 mp3an cA cB ccj cfv
      cC cD csp co his35.1 cB his35.2 cjcli cC cD his35.3 his35.4 hicli mulassi
      3eqtr4i $.
      $( [1-Jul-2005] $) $( [1-Jul-2005] $)
  $}

  $( Distributive law for inner product.  Lemma 3.1(S7) of [Beran] p. 95. $)
  his7 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( A .ih ( B +h C ) ) = ( ( A .ih B ) + ( A .ih C ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cB cC cva co cA csp co ccj cfv
    cB cA csp co ccj cfv cC cA csp co ccj cfv caddc co cA cB cC cva co csp co
    cA cB csp co cA cC csp co caddc co cB chil wcel cC chil wcel cA chil wcel
    cB cC cva co cA csp co ccj cfv cB cA csp co ccj cfv cC cA csp co ccj cfv
    caddc co wceq cB chil wcel cC chil wcel cA chil wcel w3a cB cC cva co cA
    csp co ccj cfv cB cA csp co cC cA csp co caddc co ccj cfv cB cA csp co ccj
    cfv cC cA csp co ccj cfv caddc co cB chil wcel cC chil wcel cA chil wcel
    w3a cB cC cva co cA csp co cB cA csp co cC cA csp co caddc co ccj cB cC cA
    ax-his2 fveq2d cB chil wcel cA chil wcel cC chil wcel cB cA csp co cC cA
    csp co caddc co ccj cfv cB cA csp co ccj cfv cC cA csp co ccj cfv caddc co
    wceq cB cA csp co cc wcel cC cA csp co cc wcel cB cA csp co cC cA csp co
    caddc co ccj cfv cB cA csp co ccj cfv cC cA csp co ccj cfv caddc co wceq cB
    chil wcel cA chil wcel wa cC chil wcel cA chil wcel wa cB cA csp co cC cA
    csp co cjadd cB cA hicl cC cA hicl syl2an 3impdir eqtrd 3comr cA chil wcel
    cB chil wcel cC chil wcel cA cB cC cva co csp co cB cC cva co cA csp co ccj
    cfv wceq cA chil wcel cB cC cva co chil wcel cA cB cC cva co csp co cB cC
    cva co cA csp co ccj cfv wceq cB chil wcel cC chil wcel wa cA cB cC cva co
    ax-his1 cB cC hvaddcl sylan2 3impb cA chil wcel cB chil wcel cC chil wcel
    w3a cA cB csp co cB cA csp co ccj cfv cA cC csp co cC cA csp co ccj cfv
    caddc cA chil wcel cB chil wcel cA cB csp co cB cA csp co ccj cfv wceq cC
    chil wcel cA cB ax-his1 3adant3 cA chil wcel cC chil wcel cA cC csp co cC
    cA csp co ccj cfv wceq cB chil wcel cA cC ax-his1 3adant2 opreq12d 3eqtr4d
    $.
    $( [31-Jul-1999] $)

  $( Distributive/associative law for inner product, useful for linearity
     proofs. $)
  hiassdi $p |- ( ( ( A e. CC /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
    ( ( ( A .h B ) +h C ) .ih D ) = ( ( A x. ( B .ih D ) ) + ( C .ih D ) ) ) $=
    cA cc wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB csm co cC
    cva co cD csp co cA cB csm co cD csp co cC cD csp co caddc co cA cB cD csp
    co cmul co cC cD csp co caddc co cA cB csm co chil wcel cC chil wcel cD
    chil wcel wa cA cB csm co cC cva co cD csp co cA cB csm co cD csp co cC cD
    csp co caddc co wceq cA cc wcel cB chil wcel wa cA cB csm co chil wcel cC
    chil wcel cD chil wcel cA cB csm co cC cva co cD csp co cA cB csm co cD csp
    co cC cD csp co caddc co wceq cA cB csm co cC cD ax-his2 3expb cA cB
    hvmulcl sylan cA cc wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA
    cB csm co cD csp co cA cB cD csp co cmul co cC cD csp co caddc cA cc wcel
    cB chil wcel wa cD chil wcel cA cB csm co cD csp co cA cB cD csp co cmul co
    wceq cC chil wcel cA cc wcel cB chil wcel cD chil wcel cA cB csm co cD csp
    co cA cB cD csp co cmul co wceq cA cB cD ax-his3 3expa adantrl opreq1d
    eqtrd $.
    $( [7-Jun-2005] $) $( [10-May-2005] $)

  $( Distributive law for inner product of vector subtraction. $)
  his2sub $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( ( A -h B ) .ih C ) = ( ( A .ih C ) - ( B .ih C ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB cmv co cC csp co cA c1
    cneg cB csm co cva co cC csp co cA cC csp co cB cC csp co cneg caddc co cA
    cC csp co cB cC csp co cmin co cA chil wcel cB chil wcel cA cB cmv co cC
    csp co cA c1 cneg cB csm co cva co cC csp co wceq cC chil wcel cA chil wcel
    cB chil wcel wa cA cB cmv co cA c1 cneg cB csm co cva co cC csp cA cB
    hvsubval opreq1d 3adant3 cA chil wcel cB chil wcel cC chil wcel w3a cA c1
    cneg cB csm co cva co cC csp co cA cC csp co c1 cneg cB csm co cC csp co
    caddc co cA cC csp co cB cC csp co cneg caddc co cA chil wcel c1 cneg cB
    csm co chil wcel cC chil wcel cA c1 cneg cB csm co cva co cC csp co cA cC
    csp co c1 cneg cB csm co cC csp co caddc co wceq cB chil wcel cA c1 cneg cB
    csm co cC ax-his2 c1 cneg cc wcel cB chil wcel c1 cneg cB csm co chil wcel
    c1 ax1cn negcli c1 cneg cB hvmulcl mpan syl3an2 cB chil wcel cC chil wcel
    cA cC csp co c1 cneg cB csm co cC csp co caddc co cA cC csp co cB cC csp co
    cneg caddc co wceq cA chil wcel cB chil wcel cC chil wcel wa c1 cneg cB csm
    co cC csp co cB cC csp co cneg cA cC csp co caddc cB chil wcel cC chil wcel
    wa c1 cneg cB csm co cC csp co c1 cneg cB cC csp co cmul co cB cC csp co
    cneg c1 cneg cc wcel cB chil wcel cC chil wcel c1 cneg cB csm co cC csp co
    c1 cneg cB cC csp co cmul co wceq c1 ax1cn negcli c1 cneg cB cC ax-his3
    mp3an1 cB chil wcel cC chil wcel wa cB cC csp co cc wcel c1 cneg cB cC csp
    co cmul co cB cC csp co cneg wceq cB cC hicl cB cC csp co mulm1 syl eqtrd
    opreq2d 3adant1 eqtrd cA cC csp co cc wcel cB cC csp co cc wcel cA cC csp
    co cB cC csp co cneg caddc co cA cC csp co cB cC csp co cmin co wceq cA
    chil wcel cB chil wcel cC chil wcel w3a cA cC csp co cB cC csp co negsub cA
    chil wcel cC chil wcel cA cC csp co cc wcel cB chil wcel cA cC hicl 3adant2
    cB chil wcel cC chil wcel cB cC csp co cc wcel cA chil wcel cB cC hicl
    3adant1 sylanc 3eqtrd $.
    $( [1-Aug-2006] $) $( [16-Nov-1999] $)

  $( Distributive law for inner product of vector subtraction. $)
  his2sub2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( A .ih ( B -h C ) ) = ( ( A .ih B ) - ( A .ih C ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cB cC cmv co cA csp co ccj cfv
    cB cA csp co ccj cfv cC cA csp co ccj cfv cmin co cA cB cC cmv co csp co cA
    cB csp co cA cC csp co cmin co cB chil wcel cC chil wcel cA chil wcel cB cC
    cmv co cA csp co ccj cfv cB cA csp co ccj cfv cC cA csp co ccj cfv cmin co
    wceq cB chil wcel cC chil wcel cA chil wcel w3a cB cC cmv co cA csp co ccj
    cfv cB cA csp co cC cA csp co cmin co ccj cfv cB cA csp co ccj cfv cC cA
    csp co ccj cfv cmin co cB chil wcel cC chil wcel cA chil wcel w3a cB cC cmv
    co cA csp co cB cA csp co cC cA csp co cmin co ccj cB cC cA his2sub fveq2d
    cB chil wcel cA chil wcel cC chil wcel cB cA csp co cC cA csp co cmin co
    ccj cfv cB cA csp co ccj cfv cC cA csp co ccj cfv cmin co wceq cB cA csp co
    cc wcel cC cA csp co cc wcel cB cA csp co cC cA csp co cmin co ccj cfv cB
    cA csp co ccj cfv cC cA csp co ccj cfv cmin co wceq cB chil wcel cA chil
    wcel wa cC chil wcel cA chil wcel wa cB cA csp co cC cA csp co cjsub cB cA
    hicl cC cA hicl syl2an 3impdir eqtrd 3comr cA chil wcel cB chil wcel cC
    chil wcel cA cB cC cmv co csp co cB cC cmv co cA csp co ccj cfv wceq cA
    chil wcel cB cC cmv co chil wcel cA cB cC cmv co csp co cB cC cmv co cA csp
    co ccj cfv wceq cB chil wcel cC chil wcel wa cA cB cC cmv co ax-his1 cB cC
    hvsubcl sylan2 3impb cA chil wcel cB chil wcel cC chil wcel w3a cA cB csp
    co cB cA csp co ccj cfv cA cC csp co cC cA csp co ccj cfv cmin cA chil wcel
    cB chil wcel cA cB csp co cB cA csp co ccj cfv wceq cC chil wcel cA cB
    ax-his1 3adant3 cA chil wcel cC chil wcel cA cC csp co cC cA csp co ccj cfv
    wceq cB chil wcel cA cC ax-his1 3adant2 opreq12d 3eqtr4d $.
    $( [19-Feb-2006] $) $( [13-Feb-2006] $)

  $( A necessary and sufficient condition for an inner product to be real. $)
  hire $p |- ( ( A e. ~H /\ B e. ~H ) ->
              ( ( A .ih B ) e. RR <-> ( A .ih B ) = ( B .ih A ) ) ) $=
    cA chil wcel cB chil wcel wa cA cB csp co cr wcel cA cB csp co cA cB csp co
    ccj cfv wceq cA cB csp co cB cA csp co wceq cA chil wcel cB chil wcel wa cA
    cB csp co cr wcel cA cB csp co ccj cfv cA cB csp co wceq cA cB csp co cA cB
    csp co ccj cfv wceq cA chil wcel cB chil wcel wa cA cB csp co cc wcel cA cB
    csp co cr wcel cA cB csp co ccj cfv cA cB csp co wceq wb cA cB hicl cA cB
    csp co cjreb syl cA cB csp co ccj cfv cA cB csp co eqcom syl6bb cA chil
    wcel cB chil wcel wa cB cA csp co cA cB csp co ccj cfv cA cB csp co cB chil
    wcel cA chil wcel cB cA csp co cA cB csp co ccj cfv wceq cB cA ax-his1
    ancoms eqeq2d bitr4d $.
    $( [3-Jul-2005] $) $( [2-Jul-2005] $)

  $( Real closure of inner product with self. $)
  hiidrcl $p |- ( A e. ~H -> ( A .ih A ) e. RR ) $=
    cA chil wcel cA cA csp co cr wcel cA chil wcel cA chil wcel wa cA cA csp co
    cr wcel cA cA csp co cA cA csp co wceq cA cA csp co eqid cA cA hire mpbiri
    anidms $.
    $( [29-May-1999] $)

  $( Inner product with the 0 vector. $)
  hi01 $p |- ( A e. ~H -> ( 0h .ih A ) = 0 ) $=
    cA chil wcel c0v cA csp co cc0 c0v cA csp co cmul co cc0 cA chil wcel cc0
    c0v csm co cA csp co cc0 c0v cA csp co cmul co c0v cA csp co cc0 cc wcel
    c0v chil wcel cA chil wcel cc0 c0v csm co cA csp co cc0 c0v cA csp co cmul
    co wceq 0cn ax-hv0cl cc0 c0v cA ax-his3 mp3an12 cc0 c0v csm co c0v cA csp
    c0v chil wcel cc0 c0v csm co c0v wceq ax-hv0cl c0v ax-hvmul0 ax-mp opreq1i
    syl5eqr cA chil wcel c0v cA csp co cc wcel cc0 c0v cA csp co cmul co cc0
    wceq c0v chil wcel cA chil wcel c0v cA csp co cc wcel ax-hv0cl c0v cA hicl
    mpan c0v cA csp co mul02 syl eqtrd $.
    $( [29-May-1999] $)

  $( Inner product with the 0 vector. $)
  hi02 $p |- ( A e. ~H -> ( A .ih 0h ) = 0 ) $=
    cA chil wcel cA c0v csp co c0v cA csp co ccj cfv cc0 cA chil wcel c0v chil
    wcel cA c0v csp co c0v cA csp co ccj cfv wceq ax-hv0cl cA c0v ax-his1 mpan2
    cA chil wcel c0v cA csp co ccj cfv cc0 ccj cfv cc0 cA chil wcel c0v cA csp
    co cc0 ccj cA hi01 fveq2d cj0 syl6eq eqtrd $.
    $( [13-Oct-1999] $)

  $( Inner product with self is not negative. $)
  hiidge0 $p |- ( A e. ~H -> 0 <_ ( A .ih A ) ) $=
    cA chil wcel cc0 cA cA csp co cle wbr cc0 cA cA csp co clt wbr cc0 cA cA
    csp co wceq wo cA chil wcel cA c0v wceq wn cA c0v wceq wo cc0 cA cA csp co
    clt wbr cc0 cA cA csp co wceq wo cA c0v wceq pm2.1 cA chil wcel cA c0v wceq
    wn cc0 cA cA csp co clt wbr cA c0v wceq cc0 cA cA csp co wceq cA chil wcel
    cA c0v wceq wn cc0 cA cA csp co clt wbr cA chil wcel cA c0v wne cc0 cA cA
    csp co clt wbr cA c0v wceq wn cA ax-his4 cA c0v df-ne sylan2br ex cA chil
    wcel cA c0v wceq cc0 cA cA csp co wceq cA chil wcel cA c0v wceq wa cA cA
    csp co cc0 cA c0v wceq cA chil wcel cA cA csp co c0v cA csp co cc0 cA c0v
    cA csp opreq1 cA hi01 sylan9eqr eqcomd ex orim12d mpi cA chil wcel cc0 cr
    wcel cA cA csp co cr wcel wa cc0 cA cA csp co cle wbr cc0 cA cA csp co clt
    wbr cc0 cA cA csp co wceq wo wb cA chil wcel cA cA csp co cr wcel cc0 cr
    wcel cA hiidrcl 0re jctil cc0 cA cA csp co leloe syl mpbird $.
    $( [29-May-1999] $)

  $( Zero inner product with self means vector is zero.  Lemma 3.1(S6) of
     [Beran] p. 95. $)
  his6 $p |- ( A e. ~H -> ( ( A .ih A ) = 0 <-> A = 0h ) ) $=
    cA chil wcel cA cA csp co cc0 wceq cA c0v wceq cA chil wcel cA c0v cA cA
    csp co cc0 cA chil wcel cA c0v wne cA cA csp co cc0 wne cA chil wcel cA c0v
    wne wa cc0 cA cA csp co clt wbr cA cA csp co cc0 wne cA ax-his4 cA chil
    wcel cc0 cA cA csp co clt wbr cA cA csp co cc0 wne wb cA c0v wne cA cA csp
    co cr wcel cc0 cA cA csp co cle wbr cc0 cA cA csp co clt wbr cA cA csp co
    cc0 wne wb cA chil wcel cc0 cr wcel cA cA csp co cr wcel cc0 cA cA csp co
    cle wbr cc0 cA cA csp co clt wbr cA cA csp co cc0 wne wb 0re cc0 cA cA csp
    co leltne mp3an1 cA hiidrcl cA hiidge0 sylanc adantr mpbid ex necon4d cA
    c0v wceq cA cA csp co cc0 wceq c0v cA csp co cc0 wceq cA chil wcel cA c0v
    wceq cA cA csp co c0v cA csp co cc0 cA c0v cA csp opreq1 eqeq1d cA hi01
    syl5cbir impbid $.
    $( [27-Jul-1999] $)

  ${
    his1.1 $e |- A e. ~H $.
    his1.2 $e |- B e. ~H $.
    $( Conjugate law for inner product.  Postulate (S1) of [Beran] p. 95. $)
    his1i $p |- ( A .ih B ) = ( * ` ( B .ih A ) ) $=
      cA chil wcel cB chil wcel cA cB csp co cB cA csp co ccj cfv wceq his1.1
      his1.2 cA cB ax-his1 mp2an $.
      $( [15-May-2005] $) $( [15-May-2005] $)
  $}

  $( Commuted inner products have the same absolute values. $)
  abshicom $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( abs ` ( A .ih B ) ) = ( abs ` ( B .ih A ) ) ) $=
    cA chil wcel cB chil wcel wa cA cB csp co cabs cfv cB cA csp co ccj cfv
    cabs cfv cB cA csp co cabs cfv cA chil wcel cB chil wcel wa cA cB csp co cB
    cA csp co ccj cfv cabs cA cB ax-his1 fveq2d cA chil wcel cB chil wcel wa cB
    cA csp co cc wcel cB cA csp co ccj cfv cabs cfv cB cA csp co cabs cfv wceq
    cB chil wcel cA chil wcel cB cA csp co cc wcel cB cA hicl ancoms cB cA csp
    co abscj syl eqtrd $.
    $( [20-Jun-2006] $) $( [26-May-2006] $)

  ${
    $d x A $.
    $( A vector whose inner product is always zero is zero. $)
    hial0 $p |- ( A e. ~H -> ( A. x e. ~H ( A .ih x ) = 0 <-> A = 0h ) ) $=
      cA chil wcel cA vx cv csp co cc0 wceq vx chil wral cA c0v wceq cA chil
      wcel cA vx cv csp co cc0 wceq vx chil wral cA cA csp co cc0 wceq cA c0v
      wceq cA vx cv csp co cc0 wceq cA cA csp co cc0 wceq vx cA chil vx cv cA
      wceq cA vx cv csp co cA cA csp co cc0 vx cv cA cA csp opreq2 eqeq1d
      rcla4v cA his6 sylibd cA chil wcel cA c0v wceq cA vx cv csp co cc0 wceq
      vx chil cA c0v wceq vx cv chil wcel cA vx cv csp co cc0 wceq wi wi cA
      chil wcel cA c0v wceq vx cv chil wcel cA vx cv csp co cc0 wceq cA c0v
      wceq vx cv chil wcel cA vx cv csp co c0v vx cv csp co cc0 cA c0v vx cv
      csp opreq1 vx cv hi01 sylan9eq ex a1i r19.21adv impbid $.
      $( [24-Oct-1999] $)

    $( A vector whose inner product is always zero is zero. $)
    hial02 $p |- ( A e. ~H -> ( A. x e. ~H ( x .ih A ) = 0 <-> A = 0h ) ) $=
      cA chil wcel vx cv cA csp co cc0 wceq vx chil wral cA c0v wceq cA chil
      wcel vx cv cA csp co cc0 wceq vx chil wral cA cA csp co cc0 wceq cA c0v
      wceq vx cv cA csp co cc0 wceq cA cA csp co cc0 wceq vx cA chil vx cv cA
      wceq vx cv cA csp co cA cA csp co cc0 vx cv cA cA csp opreq1 eqeq1d
      rcla4v cA his6 sylibd cA chil wcel cA c0v wceq vx cv cA csp co cc0 wceq
      vx chil cA c0v wceq vx cv chil wcel vx cv cA csp co cc0 wceq wi wi cA
      chil wcel cA c0v wceq vx cv chil wcel vx cv cA csp co cc0 wceq cA c0v
      wceq vx cv chil wcel vx cv cA csp co vx cv c0v csp co cc0 cA c0v vx cv
      csp opreq2 vx cv hi02 sylan9eq ex a1i r19.21adv impbid $.
      $( [28-Jan-2006] $) $( [28-Jan-2006] $)
  $}

  ${
    hisubcom.1 $e |- A e. ~H $.
    hisubcom.2 $e |- B e. ~H $.
    hisubcom.3 $e |- C e. ~H $.
    hisubcom.4 $e |- D e. ~H $.
    $( Two vector subtractions simultaneously commute in an inner product. $)
    hisubcomi $p |- ( ( A -h B ) .ih ( C -h D ) ) =
                   ( ( B -h A ) .ih ( D -h C ) ) $=
      c1 cneg cB cA cmv co csm co c1 cneg cD cC cmv co csm co csp co cA cB cmv
      co cC cD cmv co csp co cB cA cmv co cD cC cmv co csp co c1 cneg cB cA cmv
      co csm co cA cB cmv co c1 cneg cD cC cmv co csm co cC cD cmv co csp cB cA
      hisubcom.2 hisubcom.1 hvnegdii cD cC hisubcom.4 hisubcom.3 hvnegdii
      opreq12i c1 cneg cB cA cmv co csm co c1 cneg cD cC cmv co csm co csp co
      c1 cneg c1 cneg ccj cfv cmul co cB cA cmv co cD cC cmv co csp co cmul co
      c1 cB cA cmv co cD cC cmv co csp co cmul co cB cA cmv co cD cC cmv co csp
      co c1 cneg c1 cneg cB cA cmv co cD cC cmv co c1 ax1cn negcli c1 ax1cn
      negcli cB cA hisubcom.2 hisubcom.1 hvsubcli cD cC hisubcom.4 hisubcom.3
      hvsubcli his35i c1 cneg c1 cneg ccj cfv cmul co c1 cB cA cmv co cD cC cmv
      co csp co cmul c1 cneg c1 cneg ccj cfv cmul co c1 cneg c1 cneg cmul co c1
      c1 cmul co c1 c1 cneg ccj cfv c1 cneg c1 cneg cmul c1 cneg cr wcel c1
      cneg ccj cfv c1 cneg wceq c1 1re renegcli c1 cneg cjre ax-mp opreq2i c1
      c1 ax1cn ax1cn mul2negi c1 ax1cn mulid1i 3eqtri opreq1i cB cA cmv co cD
      cC cmv co csp co cB cA cmv co cD cC cmv co cB cA hisubcom.2 hisubcom.1
      hvsubcli cD cC hisubcom.4 hisubcom.3 hvsubcli hicli mulid2i 3eqtri eqtr3i
      $.
      $( [3-Jul-2005] $) $( [1-Jul-2005] $)
  $}

  $( Lemma used to prove equality of vectors. $)
  hi2eq $p |- ( ( A e. ~H /\ B e. ~H ) ->
               ( ( A .ih ( A -h B ) ) = ( B .ih ( A -h B ) ) <-> A = B ) ) $=
    cA chil wcel cB chil wcel wa cA cA cB cmv co csp co cB cA cB cmv co csp co
    cmin co cc0 wceq cA cB cmv co c0v wceq cA cA cB cmv co csp co cB cA cB cmv
    co csp co wceq cA cB wceq cA chil wcel cB chil wcel wa cA cB cmv co cA cB
    cmv co csp co cc0 wceq cA cA cB cmv co csp co cB cA cB cmv co csp co cmin
    co cc0 wceq cA cB cmv co c0v wceq cA chil wcel cB chil wcel wa cA cB cmv co
    cA cB cmv co csp co cA cA cB cmv co csp co cB cA cB cmv co csp co cmin co
    cc0 cA chil wcel cB chil wcel cA cB cmv co chil wcel cA cB cmv co cA cB cmv
    co csp co cA cA cB cmv co csp co cB cA cB cmv co csp co cmin co wceq cA cB
    hvsubcl cA cB cA cB cmv co his2sub mpd3an3 eqeq1d cA chil wcel cB chil wcel
    wa cA cB cmv co chil wcel cA cB cmv co cA cB cmv co csp co cc0 wceq cA cB
    cmv co c0v wceq wb cA cB hvsubcl cA cB cmv co his6 syl bitr3d cA cA cB cmv
    co csp co cc wcel cB cA cB cmv co csp co cc wcel cA cA cB cmv co csp co cB
    cA cB cmv co csp co cmin co cc0 wceq cA cA cB cmv co csp co cB cA cB cmv co
    csp co wceq wb cA chil wcel cB chil wcel wa cA cA cB cmv co csp co cB cA cB
    cmv co csp co subeq0 cA chil wcel cB chil wcel cA cB cmv co chil wcel cA cA
    cB cmv co csp co cc wcel cA cB hvsubcl cA cA cB cmv co hicl syldan cB chil
    wcel cA cB cmv co chil wcel cB cA cB cmv co csp co cc wcel cA chil wcel cB
    chil wcel wa cB cA cB cmv co hicl cA chil wcel cB chil wcel pm3.27 cA cB
    hvsubcl sylanc sylanc cA cB hvsubeq0 3bitr3d $.
    $( [16-Nov-1999] $)

  ${
    $d x A $.  $d x B $.
    $( Two vectors whose inner product is always equal are equal. $)
    hial2eq $p |- ( ( A e. ~H /\ B e. ~H ) ->
                   ( A. x e. ~H ( A .ih x ) = ( B .ih x ) <-> A = B ) ) $=
      cA chil wcel cB chil wcel wa cA vx cv csp co cB vx cv csp co wceq vx chil
      wral cA cB wceq cA chil wcel cB chil wcel wa cA vx cv csp co cB vx cv csp
      co wceq vx chil wral cA cA cB cmv co csp co cB cA cB cmv co csp co wceq
      cA cB wceq cA chil wcel cB chil wcel wa cA cB cmv co chil wcel cA vx cv
      csp co cB vx cv csp co wceq vx chil wral cA cA cB cmv co csp co cB cA cB
      cmv co csp co wceq wi cA cB hvsubcl cA vx cv csp co cB vx cv csp co wceq
      cA cA cB cmv co csp co cB cA cB cmv co csp co wceq vx cA cB cmv co chil
      vx cv cA cB cmv co wceq cA vx cv csp co cA cA cB cmv co csp co cB vx cv
      csp co cB cA cB cmv co csp co vx cv cA cB cmv co cA csp opreq2 vx cv cA
      cB cmv co cB csp opreq2 eqeq12d rcla4v syl cA cB hi2eq sylibd cA cB wceq
      cA vx cv csp co cB vx cv csp co wceq vx chil cA cB wceq cA vx cv csp co
      cB vx cv csp co wceq vx cv chil wcel cA cB vx cv csp opreq1 a1d r19.21aiv
      impbid1 $.
      $( [16-Nov-1999] $)

    $( Two vectors whose inner product is always equal are equal. $)
    hial2eq2 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                   ( A. x e. ~H ( x .ih A ) = ( x .ih B ) <-> A = B ) ) $=
      cA chil wcel cB chil wcel wa vx cv cA csp co vx cv cB csp co wceq vx chil
      wral cA vx cv csp co cB vx cv csp co wceq vx chil wral cA cB wceq cA chil
      wcel cB chil wcel wa vx cv cA csp co vx cv cB csp co wceq cA vx cv csp co
      cB vx cv csp co wceq vx chil cA chil wcel cB chil wcel vx cv chil wcel vx
      cv cA csp co vx cv cB csp co wceq cA vx cv csp co cB vx cv csp co wceq wb
      cA chil wcel vx cv chil wcel wa cB chil wcel vx cv chil wcel wa wa cA vx
      cv csp co cB vx cv csp co wceq vx cv cA csp co ccj cfv vx cv cB csp co
      ccj cfv wceq vx cv cA csp co vx cv cB csp co wceq cA chil wcel vx cv chil
      wcel wa cB chil wcel vx cv chil wcel wa cA vx cv csp co vx cv cA csp co
      ccj cfv cB vx cv csp co vx cv cB csp co ccj cfv cA vx cv ax-his1 cB vx cv
      ax-his1 eqeqan12d vx cv cA csp co cc wcel vx cv cB csp co cc wcel vx cv
      cA csp co ccj cfv vx cv cB csp co ccj cfv wceq vx cv cA csp co vx cv cB
      csp co wceq wb cA chil wcel vx cv chil wcel wa cB chil wcel vx cv chil
      wcel wa vx cv cA csp co vx cv cB csp co cj11 vx cv chil wcel cA chil wcel
      vx cv cA csp co cc wcel vx cv cA hicl ancoms vx cv chil wcel cB chil wcel
      vx cv cB csp co cc wcel vx cv cB hicl ancoms syl2an bitr2d anandirs
      ralbidva vx cA cB hial2eq bitrd $.
      $( [2-Feb-2006] $) $( [28-Jan-2006] $)
  $}

  $( Orthogonality commutes. $)
  orthcom $p |- ( ( A e. ~H /\ B e. ~H ) ->
                ( ( A .ih B ) = 0 <-> ( B .ih A ) = 0 ) ) $=
    cA chil wcel cB chil wcel wa cA cB csp co cc0 wceq cB cA csp co cc0 wceq cA
    chil wcel cB chil wcel wa cB cA csp co cc0 wceq cA cB csp co ccj cfv cc0
    wceq cA cB csp co cc0 wceq cA chil wcel cB chil wcel wa cB cA csp co cA cB
    csp co ccj cfv cc0 cB chil wcel cA chil wcel cB cA csp co cA cB csp co ccj
    cfv wceq cB cA ax-his1 ancoms eqeq1d cA cB csp co cc0 wceq cA cB csp co ccj
    cfv cc0 ccj cfv cc0 cA cB csp co cc0 ccj fveq2 cj0 syl6eq syl5bir cA chil
    wcel cB chil wcel wa cA cB csp co cc0 wceq cB cA csp co ccj cfv cc0 wceq cB
    cA csp co cc0 wceq cA chil wcel cB chil wcel wa cA cB csp co cB cA csp co
    ccj cfv cc0 cA cB ax-his1 eqeq1d cB cA csp co cc0 wceq cB cA csp co ccj cfv
    cc0 ccj cfv cc0 cB cA csp co cc0 ccj fveq2 cj0 syl6eq syl5bir impbid $.
    $( [10-Oct-1999] $)

  ${
    normlem1.1 $e |- S e. CC $.
    normlem1.2 $e |- F e. ~H $.
    normlem1.3 $e |- G e. ~H $.
    $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
       [Beran] p. 97. $)
    normlem0 $p |- ( ( F -h ( S .h G ) ) .ih
                         ( F -h ( S .h G ) ) ) =
                ( ( ( F .ih F ) + ( -u ( * ` S ) x. ( F .ih G ) ) ) +
  ( ( -u S x. ( G .ih F ) ) + ( ( S x. ( * ` S ) ) x. ( G .ih G ) ) ) ) $=
      cF cS cG csm co cmv co cF cS cG csm co cmv co csp co cF cS cneg cG csm co
      cva co cF cS cneg cG csm co cva co csp co cF cF cS cneg cG csm co cva co
      csp co cS cneg cG csm co cF cS cneg cG csm co cva co csp co caddc co cF
      cF csp co cS ccj cfv cneg cF cG csp co cmul co caddc co cS cneg cG cF csp
      co cmul co cS cS ccj cfv cmul co cG cG csp co cmul co caddc co caddc co
      cF cS cG csm co cmv co cF cS cneg cG csm co cva co cF cS cG csm co cmv co
      cF cS cneg cG csm co cva co csp cF cS cG csm co cmv co cF c1 cneg cS cG
      csm co csm co cva co cF cS cneg cG csm co cva co cF cS cG csm co
      normlem1.2 cS cG normlem1.1 normlem1.3 hvmulcli hvsubvali cS cneg cG csm
      co c1 cneg cS cG csm co csm co cF cva c1 cneg cS cmul co cG csm co cS
      cneg cG csm co c1 cneg cS cG csm co csm co c1 cneg cS cmul co cS cneg cG
      csm cS normlem1.1 mulm1i opreq1i c1 cneg cS cG c1 ax1cn negcli normlem1.1
      normlem1.3 hvmulassi eqtr3i opreq2i eqtr4i cF cS cG csm co cmv co cF c1
      cneg cS cG csm co csm co cva co cF cS cneg cG csm co cva co cF cS cG csm
      co normlem1.2 cS cG normlem1.1 normlem1.3 hvmulcli hvsubvali cS cneg cG
      csm co c1 cneg cS cG csm co csm co cF cva c1 cneg cS cmul co cG csm co cS
      cneg cG csm co c1 cneg cS cG csm co csm co c1 cneg cS cmul co cS cneg cG
      csm cS normlem1.1 mulm1i opreq1i c1 cneg cS cG c1 ax1cn negcli normlem1.1
      normlem1.3 hvmulassi eqtr3i opreq2i eqtr4i opreq12i cF chil wcel cS cneg
      cG csm co chil wcel cF cS cneg cG csm co cva co chil wcel cF cS cneg cG
      csm co cva co cF cS cneg cG csm co cva co csp co cF cF cS cneg cG csm co
      cva co csp co cS cneg cG csm co cF cS cneg cG csm co cva co csp co caddc
      co wceq normlem1.2 cS cneg cG cS normlem1.1 negcli normlem1.3 hvmulcli cF
      cS cneg cG csm co normlem1.2 cS cneg cG cS normlem1.1 negcli normlem1.3
      hvmulcli hvaddcli cF cS cneg cG csm co cF cS cneg cG csm co cva co
      ax-his2 mp3an cF cF cS cneg cG csm co cva co csp co cF cF csp co cS ccj
      cfv cneg cF cG csp co cmul co caddc co cS cneg cG csm co cF cS cneg cG
      csm co cva co csp co cS cneg cG cF csp co cmul co cS cS ccj cfv cmul co
      cG cG csp co cmul co caddc co caddc cF cF cS cneg cG csm co cva co csp co
      cF cF csp co cF cS cneg cG csm co csp co caddc co cF cF csp co cS ccj cfv
      cneg cF cG csp co cmul co caddc co cF chil wcel cF chil wcel cS cneg cG
      csm co chil wcel cF cF cS cneg cG csm co cva co csp co cF cF csp co cF cS
      cneg cG csm co csp co caddc co wceq normlem1.2 normlem1.2 cS cneg cG cS
      normlem1.1 negcli normlem1.3 hvmulcli cF cF cS cneg cG csm co his7 mp3an
      cF cS cneg cG csm co csp co cS ccj cfv cneg cF cG csp co cmul co cF cF
      csp co caddc cF cS cneg cG csm co csp co cS cneg ccj cfv cF cG csp co
      cmul co cS ccj cfv cneg cF cG csp co cmul co cS cneg cc wcel cF chil wcel
      cG chil wcel cF cS cneg cG csm co csp co cS cneg ccj cfv cF cG csp co
      cmul co wceq cS normlem1.1 negcli normlem1.2 normlem1.3 cS cneg cF cG
      his5 mp3an cS cneg ccj cfv cS ccj cfv cneg cF cG csp co cmul cS
      normlem1.1 cjnegi opreq1i eqtri opreq2i eqtri cS cneg cG csm co cF cS
      cneg cG csm co cva co csp co cS cneg cG cF cS cneg cG csm co cva co csp
      co cmul co cS cneg cG cF csp co cS cneg ccj cfv cG cG csp co cmul co
      caddc co cmul co cS cneg cG cF csp co cmul co cS cS ccj cfv cmul co cG cG
      csp co cmul co caddc co cS cneg cc wcel cG chil wcel cF cS cneg cG csm co
      cva co chil wcel cS cneg cG csm co cF cS cneg cG csm co cva co csp co cS
      cneg cG cF cS cneg cG csm co cva co csp co cmul co wceq cS normlem1.1
      negcli normlem1.3 cF cS cneg cG csm co normlem1.2 cS cneg cG cS
      normlem1.1 negcli normlem1.3 hvmulcli hvaddcli cS cneg cG cF cS cneg cG
      csm co cva co ax-his3 mp3an cG cF cS cneg cG csm co cva co csp co cG cF
      csp co cS cneg ccj cfv cG cG csp co cmul co caddc co cS cneg cmul cG cF
      cS cneg cG csm co cva co csp co cG cF csp co cG cS cneg cG csm co csp co
      caddc co cG cF csp co cS cneg ccj cfv cG cG csp co cmul co caddc co cG
      chil wcel cF chil wcel cS cneg cG csm co chil wcel cG cF cS cneg cG csm
      co cva co csp co cG cF csp co cG cS cneg cG csm co csp co caddc co wceq
      normlem1.3 normlem1.2 cS cneg cG cS normlem1.1 negcli normlem1.3 hvmulcli
      cG cF cS cneg cG csm co his7 mp3an cG cS cneg cG csm co csp co cS cneg
      ccj cfv cG cG csp co cmul co cG cF csp co caddc cS cneg cc wcel cG chil
      wcel cG chil wcel cG cS cneg cG csm co csp co cS cneg ccj cfv cG cG csp
      co cmul co wceq cS normlem1.1 negcli normlem1.3 normlem1.3 cS cneg cG cG
      his5 mp3an opreq2i eqtri opreq2i cS cneg cG cF csp co cS cneg ccj cfv cG
      cG csp co cmul co caddc co cmul co cS cneg cG cF csp co cmul co cS cneg
      cS cneg ccj cfv cG cG csp co cmul co cmul co caddc co cS cneg cG cF csp
      co cmul co cS cS ccj cfv cmul co cG cG csp co cmul co caddc co cS cneg cG
      cF csp co cS cneg ccj cfv cG cG csp co cmul co cS normlem1.1 negcli cG cF
      normlem1.3 normlem1.2 hicli cS cneg ccj cfv cG cG csp co cS cneg cS
      normlem1.1 negcli cjcli cG cG normlem1.3 normlem1.3 hicli mulcli adddii
      cS cneg cS cneg ccj cfv cG cG csp co cmul co cmul co cS cS ccj cfv cmul
      co cG cG csp co cmul co cS cneg cG cF csp co cmul co caddc cS cneg cS
      cneg ccj cfv cmul co cG cG csp co cmul co cS cneg cS cneg ccj cfv cG cG
      csp co cmul co cmul co cS cS ccj cfv cmul co cG cG csp co cmul co cS cneg
      cS cneg ccj cfv cG cG csp co cS normlem1.1 negcli cS cneg cS normlem1.1
      negcli cjcli cG cG normlem1.3 normlem1.3 hicli mulassi cS cneg cS cneg
      ccj cfv cmul co cS cS ccj cfv cmul co cG cG csp co cmul cS cneg cS cneg
      ccj cfv cmul co cS cneg cS ccj cfv cneg cmul co cS cS ccj cfv cmul co cS
      cneg ccj cfv cS ccj cfv cneg cS cneg cmul cS normlem1.1 cjnegi opreq2i cS
      cS ccj cfv normlem1.1 cS normlem1.1 cjcli mul2negi eqtri opreq1i eqtr3i
      opreq2i eqtri 3eqtri opreq12i 3eqtri $.
      $( [7-Oct-1999] $)

    ${
      normlem1.4 $e |- R e. RR $.
      normlem1.5 $e |- ( abs ` S ) = 1 $.
      $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
         [Beran] p. 97. $)
      normlem1 $p |- ( ( F -h ( ( S x. R ) .h G ) ) .ih
                         ( F -h ( ( S x. R ) .h G ) ) ) =
                ( ( ( F .ih F ) + ( ( ( * ` S ) x. -u R ) x. ( F .ih G ) ) ) +
  ( ( ( S x. -u R ) x. ( G .ih F ) ) + ( ( R ^ 2 ) x. ( G .ih G ) ) ) ) $=
        cF cS cR cmul co cG csm co cmv co cF cS cR cmul co cG csm co cmv co csp
        co cF cF csp co cS cR cmul co ccj cfv cneg cF cG csp co cmul co caddc
        co cS cR cmul co cneg cG cF csp co cmul co cS cR cmul co cS cR cmul co
        ccj cfv cmul co cG cG csp co cmul co caddc co caddc co cF cF csp co cS
        ccj cfv cR cneg cmul co cF cG csp co cmul co caddc co cS cR cneg cmul
        co cG cF csp co cmul co cR c2 cexp co cG cG csp co cmul co caddc co
        caddc co cS cR cmul co cF cG cS cR normlem1.1 cR normlem1.4 recni
        mulcli normlem1.2 normlem1.3 normlem0 cF cF csp co cS cR cmul co ccj
        cfv cneg cF cG csp co cmul co caddc co cF cF csp co cS ccj cfv cR cneg
        cmul co cF cG csp co cmul co caddc co cS cR cmul co cneg cG cF csp co
        cmul co cS cR cmul co cS cR cmul co ccj cfv cmul co cG cG csp co cmul
        co caddc co cS cR cneg cmul co cG cF csp co cmul co cR c2 cexp co cG cG
        csp co cmul co caddc co caddc cS cR cmul co ccj cfv cneg cF cG csp co
        cmul co cS ccj cfv cR cneg cmul co cF cG csp co cmul co cF cF csp co
        caddc cS cR cmul co ccj cfv cneg cS ccj cfv cR cneg cmul co cF cG csp
        co cmul cS cR cmul co ccj cfv cneg cS ccj cfv cR cmul co cneg cS ccj
        cfv cR cneg cmul co cS cR cmul co ccj cfv cS ccj cfv cR cmul co cS cR
        cmul co ccj cfv cS ccj cfv cR ccj cfv cmul co cS ccj cfv cR cmul co cS
        cR normlem1.1 cR normlem1.4 recni cjmuli cR ccj cfv cR cS ccj cfv cmul
        cR cr wcel cR ccj cfv cR wceq normlem1.4 cR cR normlem1.4 recni cjrebi
        mpbi opreq2i eqtri negeqi cS ccj cfv cR cS normlem1.1 cjcli cR
        normlem1.4 recni mulneg2i eqtr4i opreq1i opreq2i cS cR cmul co cneg cG
        cF csp co cmul co cS cR cneg cmul co cG cF csp co cmul co cS cR cmul co
        cS cR cmul co ccj cfv cmul co cG cG csp co cmul co cR c2 cexp co cG cG
        csp co cmul co caddc cS cR cmul co cneg cS cR cneg cmul co cG cF csp co
        cmul cS cR cneg cmul co cS cR cmul co cneg cS cR normlem1.1 cR
        normlem1.4 recni mulneg2i eqcomi opreq1i cS cR cmul co cS cR cmul co
        ccj cfv cmul co cR c2 cexp co cG cG csp co cmul cS cR cmul co cS cR
        cmul co ccj cfv cmul co cR cR cmul co cR c2 cexp co cS cR cmul co cS cR
        cmul co ccj cfv cmul co cS cR cmul co cS ccj cfv cR ccj cfv cmul co
        cmul co cS cS ccj cfv cmul co cR cR ccj cfv cmul co cmul co cR cR cmul
        co cS cR cmul co ccj cfv cS ccj cfv cR ccj cfv cmul co cS cR cmul co
        cmul cS cR normlem1.1 cR normlem1.4 recni cjmuli opreq2i cS cR cS ccj
        cfv cR ccj cfv normlem1.1 cR normlem1.4 recni cS normlem1.1 cjcli cR cR
        normlem1.4 recni cjcli mul4i cS cS ccj cfv cmul co cR cR ccj cfv cmul
        co cmul co c1 cR cR cmul co cmul co cR cR cmul co cS cS ccj cfv cmul co
        c1 cR cR ccj cfv cmul co cR cR cmul co cmul cS cabs cfv c2 cexp co c1
        c2 cexp co cS cS ccj cfv cmul co c1 cS cabs cfv c1 c2 cexp normlem1.5
        opreq1i cS normlem1.1 absvalsqi sq1 3eqtr3i cR ccj cfv cR cR cmul cR cr
        wcel cR ccj cfv cR wceq normlem1.4 cR cR normlem1.4 recni cjrebi mpbi
        opreq2i opreq12i cR cR cmul co cR cR cR normlem1.4 recni cR normlem1.4
        recni mulcli mulid2i eqtri 3eqtri cR cR normlem1.4 recni sqvali eqtr4i
        opreq1i opreq12i opreq12i eqtri $.
        $( [22-Aug-1999] $)
    $}

    ${
      normlem2.4 $e |- B = -u ( ( ( * ` S ) x. ( F .ih G ) ) +
                    ( S x. ( G .ih F ) ) ) $.
      $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
         [Beran] p. 97. $)
      normlem2 $p |- B e. RR $=
        cB cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co
        cneg cr normlem2.4 cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul
        co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
        caddc co cr wcel cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul
        co caddc co ccj cfv cS ccj cfv cF cG csp co cmul co cS cG cF csp co
        cmul co caddc co wceq cS cG cF csp co cmul co cS ccj cfv cF cG csp co
        cmul co caddc co cS ccj cfv cF cG csp co cmul co ccj cfv cS cG cF csp
        co cmul co ccj cfv caddc co cS ccj cfv cF cG csp co cmul co cS cG cF
        csp co cmul co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp co
        cmul co caddc co ccj cfv cS cG cF csp co cmul co cS ccj cfv cF cG csp
        co cmul co ccj cfv cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul
        co ccj cfv caddc cS cG cF csp co cmul co cS ccj cfv ccj cfv cF cG csp
        co ccj cfv cmul co cS ccj cfv cF cG csp co cmul co ccj cfv cS cS ccj
        cfv ccj cfv cG cF csp co cF cG csp co ccj cfv cmul cS ccj cfv ccj cfv
        cS cS normlem1.1 cjcji eqcomi cG cF normlem1.3 normlem1.2 his1i
        opreq12i cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG normlem1.2
        normlem1.3 hicli cjmuli eqtr4i cS ccj cfv cF cG csp co cmul co cS ccj
        cfv cG cF csp co ccj cfv cmul co cS cG cF csp co cmul co ccj cfv cF cG
        csp co cG cF csp co ccj cfv cS ccj cfv cmul cF cG normlem1.2 normlem1.3
        his1i opreq2i cS cG cF csp co normlem1.1 cG cF normlem1.3 normlem1.2
        hicli cjmuli eqtr4i opreq12i cS ccj cfv cF cG csp co cmul co cS cG cF
        csp co cmul co cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG
        normlem1.2 normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG cF
        normlem1.3 normlem1.2 hicli mulcli addcomi cS ccj cfv cF cG csp co cmul
        co cS cG cF csp co cmul co cS ccj cfv cF cG csp co cS normlem1.1 cjcli
        cF cG normlem1.2 normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG
        cF normlem1.3 normlem1.2 hicli mulcli cjaddi 3eqtr4ri cS ccj cfv cF cG
        csp co cmul co cS cG cF csp co cmul co caddc co cS ccj cfv cF cG csp co
        cmul co cS cG cF csp co cmul co cS ccj cfv cF cG csp co cS normlem1.1
        cjcli cF cG normlem1.2 normlem1.3 hicli mulcli cS cG cF csp co
        normlem1.1 cG cF normlem1.3 normlem1.2 hicli mulcli addcli cjrebi mpbir
        renegcli eqeltri $.
        $( [27-Jul-1999] $)

      ${
        normlem3.5 $e |- A = ( G .ih G ) $.
        normlem3.6 $e |- C = ( F .ih F ) $.
        ${
          normlem3.7 $e |- R e. RR $.
          $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii)
             of [Beran] p. 97. $)
          normlem3 $p |- ( ( ( A x. ( R ^ 2 ) ) + ( B x. R ) ) + C ) =
                ( ( ( F .ih F ) + ( ( ( * ` S ) x. -u R ) x. ( F .ih G ) ) ) +
  ( ( ( S x. -u R ) x. ( G .ih F ) ) + ( ( R ^ 2 ) x. ( G .ih G ) ) ) ) $=
            cC cA cR c2 cexp co cmul co cB cR cmul co caddc co caddc co cF cF
            csp co cS ccj cfv cR cneg cmul co cF cG csp co cmul co cS cR cneg
            cmul co cG cF csp co cmul co cR c2 cexp co cG cG csp co cmul co
            caddc co caddc co caddc co cA cR c2 cexp co cmul co cB cR cmul co
            caddc co cC caddc co cF cF csp co cS ccj cfv cR cneg cmul co cF cG
            csp co cmul co caddc co cS cR cneg cmul co cG cF csp co cmul co cR
            c2 cexp co cG cG csp co cmul co caddc co caddc co cC cF cF csp co
            cA cR c2 cexp co cmul co cB cR cmul co caddc co cS ccj cfv cR cneg
            cmul co cF cG csp co cmul co cS cR cneg cmul co cG cF csp co cmul
            co cR c2 cexp co cG cG csp co cmul co caddc co caddc co caddc
            normlem3.6 cA cR c2 cexp co cmul co cB cR cmul co caddc co cB cR
            cmul co cA cR c2 cexp co cmul co caddc co cS ccj cfv cR cneg cmul
            co cF cG csp co cmul co cS cR cneg cmul co cG cF csp co cmul co
            caddc co cR c2 cexp co cG cG csp co cmul co caddc co cS ccj cfv cR
            cneg cmul co cF cG csp co cmul co cS cR cneg cmul co cG cF csp co
            cmul co cR c2 cexp co cG cG csp co cmul co caddc co caddc co cA cR
            c2 cexp co cmul co cB cR cmul co cA cR c2 cexp co cA cG cG csp co
            cc normlem3.5 cG cG normlem1.3 normlem1.3 hicli eqeltri cR cR
            normlem3.7 recni sqcli mulcli cB cR cB cB cS cF cG normlem1.1
            normlem1.2 normlem1.3 normlem2.4 normlem2 recni cR normlem3.7 recni
            mulcli addcomi cB cR cmul co cS ccj cfv cR cneg cmul co cF cG csp
            co cmul co cS cR cneg cmul co cG cF csp co cmul co caddc co cA cR
            c2 cexp co cmul co cR c2 cexp co cG cG csp co cmul co caddc cB cR
            cmul co cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
            caddc co cR cneg cmul co cS ccj cfv cF cG csp co cmul co cR cneg
            cmul co cS cG cF csp co cmul co cR cneg cmul co caddc co cS ccj cfv
            cR cneg cmul co cF cG csp co cmul co cS cR cneg cmul co cG cF csp
            co cmul co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp co
            cmul co caddc co cneg cR cmul co cS ccj cfv cF cG csp co cmul co cS
            cG cF csp co cmul co caddc co cR cmul co cneg cB cR cmul co cS ccj
            cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co cR cneg
            cmul co cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
            caddc co cR cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
            cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG normlem1.2
            normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG cF normlem1.3
            normlem1.2 hicli mulcli addcli cR normlem3.7 recni mulneg1i cB cS
            ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co cneg
            cR cmul normlem2.4 opreq1i cS ccj cfv cF cG csp co cmul co cS cG cF
            csp co cmul co caddc co cR cS ccj cfv cF cG csp co cmul co cS cG cF
            csp co cmul co cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG
            normlem1.2 normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG cF
            normlem1.3 normlem1.2 hicli mulcli addcli cR normlem3.7 recni
            mulneg2i 3eqtr4i cS ccj cfv cF cG csp co cmul co cS cG cF csp co
            cmul co cR cneg cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG
            normlem1.2 normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG cF
            normlem1.3 normlem1.2 hicli mulcli cR cR normlem3.7 recni negcli
            adddiri cS ccj cfv cF cG csp co cmul co cR cneg cmul co cS ccj cfv
            cR cneg cmul co cF cG csp co cmul co cS cG cF csp co cmul co cR
            cneg cmul co cS cR cneg cmul co cG cF csp co cmul co caddc cS ccj
            cfv cF cG csp co cR cneg cS normlem1.1 cjcli cF cG normlem1.2
            normlem1.3 hicli cR cR normlem3.7 recni negcli mul23i cS cG cF csp
            co cR cneg normlem1.1 cG cF normlem1.3 normlem1.2 hicli cR cR
            normlem3.7 recni negcli mul23i opreq12i 3eqtri cR c2 cexp co cA
            cmul co cA cR c2 cexp co cmul co cR c2 cexp co cG cG csp co cmul co
            cR c2 cexp co cA cR cR normlem3.7 recni sqcli cA cG cG csp co cc
            normlem3.5 cG cG normlem1.3 normlem1.3 hicli eqeltri mulcomi cA cG
            cG csp co cR c2 cexp co cmul normlem3.5 opreq2i eqtr3i opreq12i cS
            ccj cfv cR cneg cmul co cF cG csp co cmul co cS cR cneg cmul co cG
            cF csp co cmul co cR c2 cexp co cG cG csp co cmul co cS ccj cfv cR
            cneg cmul co cF cG csp co cS ccj cfv cR cneg cS normlem1.1 cjcli cR
            cR normlem3.7 recni negcli mulcli cF cG normlem1.2 normlem1.3 hicli
            mulcli cS cR cneg cmul co cG cF csp co cS cR cneg normlem1.1 cR cR
            normlem3.7 recni negcli mulcli cG cF normlem1.3 normlem1.2 hicli
            mulcli cR c2 cexp co cG cG csp co cR cR normlem3.7 recni sqcli cG
            cG normlem1.3 normlem1.3 hicli mulcli addassi 3eqtri opreq12i cA cR
            c2 cexp co cmul co cB cR cmul co caddc co cC cA cR c2 cexp co cmul
            co cB cR cmul co cA cR c2 cexp co cA cG cG csp co cc normlem3.5 cG
            cG normlem1.3 normlem1.3 hicli eqeltri cR cR normlem3.7 recni sqcli
            mulcli cB cR cB cB cS cF cG normlem1.1 normlem1.2 normlem1.3
            normlem2.4 normlem2 recni cR normlem3.7 recni mulcli addcli cC cF
            cF csp co cc normlem3.6 cF cF normlem1.2 normlem1.2 hicli eqeltri
            addcomi cF cF csp co cS ccj cfv cR cneg cmul co cF cG csp co cmul
            co cS cR cneg cmul co cG cF csp co cmul co cR c2 cexp co cG cG csp
            co cmul co caddc co cF cF normlem1.2 normlem1.2 hicli cS ccj cfv cR
            cneg cmul co cF cG csp co cS ccj cfv cR cneg cS normlem1.1 cjcli cR
            cR normlem3.7 recni negcli mulcli cF cG normlem1.2 normlem1.3 hicli
            mulcli cS cR cneg cmul co cG cF csp co cmul co cR c2 cexp co cG cG
            csp co cmul co cS cR cneg cmul co cG cF csp co cS cR cneg
            normlem1.1 cR cR normlem3.7 recni negcli mulcli cG cF normlem1.3
            normlem1.2 hicli mulcli cR c2 cexp co cG cG csp co cR cR normlem3.7
            recni sqcli cG cG normlem1.3 normlem1.3 hicli mulcli addcli addassi
            3eqtr4i $.
            $( [21-Aug-1999] $)
        $}


        ${
          normlem4.7 $e |- R e. RR $.
          normlem4.8 $e |- ( abs ` S ) = 1 $.
          $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii)
             of [Beran] p. 97. $)
          normlem4 $p |- ( ( F -h ( ( S x. R ) .h G ) ) .ih
                       ( F -h ( ( S x. R ) .h G ) ) ) =
                       ( ( ( A x. ( R ^ 2 ) ) + ( B x. R ) ) + C ) $=
            cF cS cR cmul co cG csm co cmv co cF cS cR cmul co cG csm co cmv co
            csp co cF cF csp co cS ccj cfv cR cneg cmul co cF cG csp co cmul co
            caddc co cS cR cneg cmul co cG cF csp co cmul co cR c2 cexp co cG
            cG csp co cmul co caddc co caddc co cA cR c2 cexp co cmul co cB cR
            cmul co caddc co cC caddc co cR cS cF cG normlem1.1 normlem1.2
            normlem1.3 normlem4.7 normlem4.8 normlem1 cA cB cC cR cS cF cG
            normlem1.1 normlem1.2 normlem1.3 normlem2.4 normlem3.5 normlem3.6
            normlem4.7 normlem3 eqtr4i $.
            $( [29-Jul-1999] $)

          $( Lemma used to derive properties of norm.  Part of Theorem
             3.3(ii) of [Beran] p. 97. $)
          normlem5 $p |- 0 <_
                       ( ( ( A x. ( R ^ 2 ) ) + ( B x. R ) ) + C ) $=
            cc0 cF cS cR cmul co cG csm co cmv co cF cS cR cmul co cG csm co
            cmv co csp co cA cR c2 cexp co cmul co cB cR cmul co caddc co cC
            caddc co cle cF cS cR cmul co cG csm co cmv co chil wcel cc0 cF cS
            cR cmul co cG csm co cmv co cF cS cR cmul co cG csm co cmv co csp
            co cle wbr cF cS cR cmul co cG csm co normlem1.2 cS cR cmul co cG
            cS cR normlem1.1 cR normlem4.7 recni mulcli normlem1.3 hvmulcli
            hvsubcli cF cS cR cmul co cG csm co cmv co hiidge0 ax-mp cA cB cC
            cR cS cF cG normlem1.1 normlem1.2 normlem1.3 normlem2.4 normlem3.5
            normlem3.6 normlem4.7 normlem4.8 normlem4 breqtri $.
            $( [10-Aug-1999] $)
        $}

        ${
          $d x A $.  $d x B $.  $d x C $.
          normlem6.7 $e |- ( abs ` S ) = 1 $.
          $( Lemma used to derive properties of norm.  Part of Theorem
             3.3(ii) of [Beran] p. 97. $)
          normlem6 $p |- ( abs ` B ) <_
                       ( 2 x. ( ( sqr ` A ) x. ( sqr ` C ) ) ) $=
            cB c2 cexp co csqr cfv c4 cA cC cmul co cmul co csqr cfv cB cabs
            cfv c2 cA csqr cfv cC csqr cfv cmul co cmul co cle cB c2 cexp co c4
            cA cC cmul co cmul co cle wbr cB c2 cexp co csqr cfv c4 cA cC cmul
            co cmul co csqr cfv cle wbr cB c2 cexp co c4 cA cC cmul co cmul co
            cc0 caddc co c4 cA cC cmul co cmul co cle cB c2 cexp co c4 cA cC
            cmul co cmul co cmin co cc0 cle wbr cB c2 cexp co c4 cA cC cmul co
            cmul co cc0 caddc co cle wbr cc0 cA cle wbr cB c2 cexp co c4 cA cC
            cmul co cmul co cmin co cc0 cle wbr cc0 cG cG csp co cA cle cG chil
            wcel cc0 cG cG csp co cle wbr normlem1.3 cG hiidge0 ax-mp
            normlem3.5 breqtrri vx cA cB cC cA cG cG csp co cr normlem3.5 cG
            chil wcel cG cG csp co cr wcel normlem1.3 cG hiidrcl ax-mp eqeltri
            cB cS cF cG normlem1.1 normlem1.2 normlem1.3 normlem2.4 normlem2 cC
            cF cF csp co cr normlem3.6 cF chil wcel cF cF csp co cr wcel
            normlem1.2 cF hiidrcl ax-mp eqeltri cc0 cA vx cv c2 cexp co cmul co
            cB vx cv cmul co caddc co cC caddc co cle wbr vx cr vx cv cr wcel
            cc0 cA vx cv c2 cexp co cmul co cB vx cv cmul co caddc co cC caddc
            co cle wbr cc0 cA vx cv cr wcel vx cv cc0 cif c2 cexp co cmul co cB
            vx cv cr wcel vx cv cc0 cif cmul co caddc co cC caddc co cle wbr vx
            cv cc0 vx cv vx cv cr wcel vx cv cc0 cif wceq cA vx cv c2 cexp co
            cmul co cB vx cv cmul co caddc co cC caddc co cA vx cv cr wcel vx
            cv cc0 cif c2 cexp co cmul co cB vx cv cr wcel vx cv cc0 cif cmul
            co caddc co cC caddc co cc0 cle vx cv vx cv cr wcel vx cv cc0 cif
            wceq cA vx cv c2 cexp co cmul co cB vx cv cmul co caddc co cA vx cv
            cr wcel vx cv cc0 cif c2 cexp co cmul co cB vx cv cr wcel vx cv cc0
            cif cmul co caddc co cC caddc vx cv vx cv cr wcel vx cv cc0 cif
            wceq cA vx cv c2 cexp co cmul co cA vx cv cr wcel vx cv cc0 cif c2
            cexp co cmul co cB vx cv cmul co cB vx cv cr wcel vx cv cc0 cif
            cmul co caddc vx cv vx cv cr wcel vx cv cc0 cif wceq vx cv c2 cexp
            co vx cv cr wcel vx cv cc0 cif c2 cexp co cA cmul vx cv vx cv cr
            wcel vx cv cc0 cif c2 cexp opreq1 opreq2d vx cv vx cv cr wcel vx cv
            cc0 cif cB cmul opreq2 opreq12d opreq1d breq2d cA cB cC vx cv cr
            wcel vx cv cc0 cif cS cF cG normlem1.1 normlem1.2 normlem1.3
            normlem2.4 normlem3.5 normlem3.6 vx cv cc0 cr 0re elimel normlem6.7
            normlem5 dedth rgen discrlem ax-mp cB c2 cexp co c4 cA cC cmul co
            cmul co cc0 cB cB cS cF cG normlem1.1 normlem1.2 normlem1.3
            normlem2.4 normlem2 resqcli c4 cA cC cmul co 4re cA cC cA cG cG csp
            co cr normlem3.5 cG chil wcel cG cG csp co cr wcel normlem1.3 cG
            hiidrcl ax-mp eqeltri cC cF cF csp co cr normlem3.6 cF chil wcel cF
            cF csp co cr wcel normlem1.2 cF hiidrcl ax-mp eqeltri remulcli
            remulcli 0re lesubadd2i mpbi c4 cA cC cmul co cmul co c4 cA cC cmul
            co cmul co c4 cA cC cmul co 4re cA cC cA cG cG csp co cr normlem3.5
            cG chil wcel cG cG csp co cr wcel normlem1.3 cG hiidrcl ax-mp
            eqeltri cC cF cF csp co cr normlem3.6 cF chil wcel cF cF csp co cr
            wcel normlem1.2 cF hiidrcl ax-mp eqeltri remulcli remulcli recni
            addid1i breqtri cc0 cB c2 cexp co cle wbr cc0 c4 cA cC cmul co cmul
            co cle wbr cB c2 cexp co c4 cA cC cmul co cmul co cle wbr cB c2
            cexp co csqr cfv c4 cA cC cmul co cmul co csqr cfv cle wbr wb cB cB
            cS cF cG normlem1.1 normlem1.2 normlem1.3 normlem2.4 normlem2
            sqge0i cc0 c4 cle wbr cc0 cA cC cmul co cle wbr cc0 c4 cA cC cmul
            co cmul co cle wbr cc0 c4 0re 4re 4pos ltleii cc0 cA cle wbr cc0 cC
            cle wbr cc0 cA cC cmul co cle wbr cc0 cG cG csp co cA cle cG chil
            wcel cc0 cG cG csp co cle wbr normlem1.3 cG hiidge0 ax-mp
            normlem3.5 breqtrri cc0 cF cF csp co cC cle cF chil wcel cc0 cF cF
            csp co cle wbr normlem1.2 cF hiidge0 ax-mp normlem3.6 breqtrri cA
            cC cA cG cG csp co cr normlem3.5 cG chil wcel cG cG csp co cr wcel
            normlem1.3 cG hiidrcl ax-mp eqeltri cC cF cF csp co cr normlem3.6
            cF chil wcel cF cF csp co cr wcel normlem1.2 cF hiidrcl ax-mp
            eqeltri mulge0i mp2an c4 cA cC cmul co 4re cA cC cA cG cG csp co cr
            normlem3.5 cG chil wcel cG cG csp co cr wcel normlem1.3 cG hiidrcl
            ax-mp eqeltri cC cF cF csp co cr normlem3.6 cF chil wcel cF cF csp
            co cr wcel normlem1.2 cF hiidrcl ax-mp eqeltri remulcli mulge0i
            mp2an cB c2 cexp co c4 cA cC cmul co cmul co cB cB cS cF cG
            normlem1.1 normlem1.2 normlem1.3 normlem2.4 normlem2 resqcli c4 cA
            cC cmul co 4re cA cC cA cG cG csp co cr normlem3.5 cG chil wcel cG
            cG csp co cr wcel normlem1.3 cG hiidrcl ax-mp eqeltri cC cF cF csp
            co cr normlem3.6 cF chil wcel cF cF csp co cr wcel normlem1.2 cF
            hiidrcl ax-mp eqeltri remulcli remulcli sqrlei mp2an mpbi cB cB cS
            cF cG normlem1.1 normlem1.2 normlem1.3 normlem2.4 normlem2 absrei
            c4 cA cC cmul co cmul co csqr cfv c4 csqr cfv cA cC cmul co csqr
            cfv cmul co c2 cA csqr cfv cC csqr cfv cmul co cmul co c4 cA cC
            cmul co 4re cA cC cA cG cG csp co cr normlem3.5 cG chil wcel cG cG
            csp co cr wcel normlem1.3 cG hiidrcl ax-mp eqeltri cC cF cF csp co
            cr normlem3.6 cF chil wcel cF cF csp co cr wcel normlem1.2 cF
            hiidrcl ax-mp eqeltri remulcli cc0 c4 0re 4re 4pos ltleii cc0 cA
            cle wbr cc0 cC cle wbr cc0 cA cC cmul co cle wbr cc0 cG cG csp co
            cA cle cG chil wcel cc0 cG cG csp co cle wbr normlem1.3 cG hiidge0
            ax-mp normlem3.5 breqtrri cc0 cF cF csp co cC cle cF chil wcel cc0
            cF cF csp co cle wbr normlem1.2 cF hiidge0 ax-mp normlem3.6
            breqtrri cA cC cA cG cG csp co cr normlem3.5 cG chil wcel cG cG csp
            co cr wcel normlem1.3 cG hiidrcl ax-mp eqeltri cC cF cF csp co cr
            normlem3.6 cF chil wcel cF cF csp co cr wcel normlem1.2 cF hiidrcl
            ax-mp eqeltri mulge0i mp2an sqrmulii c4 csqr cfv c2 cA cC cmul co
            csqr cfv cA csqr cfv cC csqr cfv cmul co cmul sqr4 cA cC cA cG cG
            csp co cr normlem3.5 cG chil wcel cG cG csp co cr wcel normlem1.3
            cG hiidrcl ax-mp eqeltri cC cF cF csp co cr normlem3.6 cF chil wcel
            cF cF csp co cr wcel normlem1.2 cF hiidrcl ax-mp eqeltri cc0 cG cG
            csp co cA cle cG chil wcel cc0 cG cG csp co cle wbr normlem1.3 cG
            hiidge0 ax-mp normlem3.5 breqtrri cc0 cF cF csp co cC cle cF chil
            wcel cc0 cF cF csp co cle wbr normlem1.2 cF hiidge0 ax-mp
            normlem3.6 breqtrri sqrmulii opreq12i eqtr2i 3brtr4i $.
            $( [2-Aug-1999] $)

        $}
      $}
    $}

    ${
      normlem7.4 $e |- ( abs ` S ) = 1 $.
      $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
         [Beran] p. 97. $)
      normlem7 $p |- ( ( ( * ` S ) x. ( F .ih G ) ) + ( S x. ( G .ih F ) ) ) <_
                ( 2 x. ( ( sqr ` ( G .ih G ) ) x. ( sqr ` ( F .ih F ) ) ) ) $=
        cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co cS ccj
        cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co cneg cabs cfv
        cle wbr cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc
        co cneg cabs cfv c2 cG cG csp co csqr cfv cF cF csp co csqr cfv cmul co
        cmul co cle wbr cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
        caddc co c2 cG cG csp co csqr cfv cF cF csp co csqr cfv cmul co cmul co
        cle wbr cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc
        co cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co
        cabs cfv cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc
        co cneg cabs cfv cle cS ccj cfv cF cG csp co cmul co cS cG cF csp co
        cmul co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul
        co caddc co cneg cr wcel cS ccj cfv cF cG csp co cmul co cS cG cF csp
        co cmul co caddc co cr wcel cS ccj cfv cF cG csp co cmul co cS cG cF
        csp co cmul co caddc co cneg cS cF cG normlem1.1 normlem1.2 normlem1.3
        cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co caddc co cneg
        eqid normlem2 cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
        caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co cS ccj
        cfv cF cG csp co cS normlem1.1 cjcli cF cG normlem1.2 normlem1.3 hicli
        mulcli cS cG cF csp co normlem1.1 cG cF normlem1.3 normlem1.2 hicli
        mulcli addcli negrebi mpbi leabsi cS ccj cfv cF cG csp co cmul co cS cG
        cF csp co cmul co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp
        co cmul co cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG normlem1.2
        normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG cF normlem1.3
        normlem1.2 hicli mulcli addcli absnegi breqtrri cG cG csp co cS ccj cfv
        cF cG csp co cmul co cS cG cF csp co cmul co caddc co cneg cF cF csp co
        cS cF cG normlem1.1 normlem1.2 normlem1.3 cS ccj cfv cF cG csp co cmul
        co cS cG cF csp co cmul co caddc co cneg eqid cG cG csp co eqid cF cF
        csp co eqid normlem7.4 normlem6 cS ccj cfv cF cG csp co cmul co cS cG
        cF csp co cmul co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp
        co cmul co caddc co cneg cabs cfv c2 cG cG csp co csqr cfv cF cF csp co
        csqr cfv cmul co cmul co cS ccj cfv cF cG csp co cmul co cS cG cF csp
        co cmul co caddc co cneg cr wcel cS ccj cfv cF cG csp co cmul co cS cG
        cF csp co cmul co caddc co cr wcel cS ccj cfv cF cG csp co cmul co cS
        cG cF csp co cmul co caddc co cneg cS cF cG normlem1.1 normlem1.2
        normlem1.3 cS ccj cfv cF cG csp co cmul co cS cG cF csp co cmul co
        caddc co cneg eqid normlem2 cS ccj cfv cF cG csp co cmul co cS cG cF
        csp co cmul co caddc co cS ccj cfv cF cG csp co cmul co cS cG cF csp co
        cmul co cS ccj cfv cF cG csp co cS normlem1.1 cjcli cF cG normlem1.2
        normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG cF normlem1.3
        normlem1.2 hicli mulcli addcli negrebi mpbi cS ccj cfv cF cG csp co
        cmul co cS cG cF csp co cmul co caddc co cneg cS ccj cfv cF cG csp co
        cmul co cS cG cF csp co cmul co caddc co cS ccj cfv cF cG csp co cmul
        co cS cG cF csp co cmul co cS ccj cfv cF cG csp co cS normlem1.1 cjcli
        cF cG normlem1.2 normlem1.3 hicli mulcli cS cG cF csp co normlem1.1 cG
        cF normlem1.3 normlem1.2 hicli mulcli addcli negcli abscli c2 cG cG csp
        co csqr cfv cF cF csp co csqr cfv cmul co 2re cG cG csp co csqr cfv cF
        cF csp co csqr cfv cc0 cG cG csp co cle wbr cG cG csp co csqr cfv cr
        wcel cG chil wcel cc0 cG cG csp co cle wbr normlem1.3 cG hiidge0 ax-mp
        cG cG csp co cG chil wcel cG cG csp co cr wcel normlem1.3 cG hiidrcl
        ax-mp sqrcli ax-mp cc0 cF cF csp co cle wbr cF cF csp co csqr cfv cr
        wcel cF chil wcel cc0 cF cF csp co cle wbr normlem1.2 cF hiidge0 ax-mp
        cF cF csp co cF chil wcel cF cF csp co cr wcel normlem1.2 cF hiidrcl
        ax-mp sqrcli ax-mp remulcli remulcli letri mp2an $.
        $( [11-Aug-1999] $)
    $}
  $}

  ${
    normlem8.1 $e |- A e. ~H $.
    normlem8.2 $e |- B e. ~H $.
    normlem8.3 $e |- C e. ~H $.
    normlem8.4 $e |- D e. ~H $.
    $( Lemma used to derive properties of norm. $)
    normlem8 $p |- ( ( A +h B ) .ih ( C +h D ) ) =
        ( ( ( A .ih C ) + ( B .ih D ) ) + ( ( A .ih D ) + ( B .ih C ) ) ) $=
      cA cC cD cva co csp co cB cC cD cva co csp co caddc co cA cC csp co cA cD
      csp co caddc co cB cC csp co cB cD csp co caddc co caddc co cA cB cva co
      cC cD cva co csp co cA cC csp co cB cD csp co caddc co cA cD csp co cB cC
      csp co caddc co caddc co cA cC cD cva co csp co cA cC csp co cA cD csp co
      caddc co cB cC cD cva co csp co cB cC csp co cB cD csp co caddc co caddc
      cA chil wcel cC chil wcel cD chil wcel cA cC cD cva co csp co cA cC csp
      co cA cD csp co caddc co wceq normlem8.1 normlem8.3 normlem8.4 cA cC cD
      his7 mp3an cB chil wcel cC chil wcel cD chil wcel cB cC cD cva co csp co
      cB cC csp co cB cD csp co caddc co wceq normlem8.2 normlem8.3 normlem8.4
      cB cC cD his7 mp3an opreq12i cA chil wcel cB chil wcel cC cD cva co chil
      wcel cA cB cva co cC cD cva co csp co cA cC cD cva co csp co cB cC cD cva
      co csp co caddc co wceq normlem8.1 normlem8.2 cC cD normlem8.3 normlem8.4
      hvaddcli cA cB cC cD cva co ax-his2 mp3an cA cC csp co cB cD csp co cA cD
      csp co cB cC csp co cA cC normlem8.1 normlem8.3 hicli cB cD normlem8.2
      normlem8.4 hicli cA cD normlem8.1 normlem8.4 hicli cB cC normlem8.2
      normlem8.3 hicli add42i 3eqtr4i $.
      $( [1-Jul-2005] $) $( [30-Jun-2005] $)

    $( Lemma used to derive properties of norm. $)
    normlem9 $p |- ( ( A -h B ) .ih ( C -h D ) ) =
        ( ( ( A .ih C ) + ( B .ih D ) ) - ( ( A .ih D ) + ( B .ih C ) ) ) $=
      cA cB cmv co cC cD cmv co csp co cA c1 cneg cB csm co cva co cC c1 cneg
      cD csm co cva co csp co cA cC csp co c1 cneg cB csm co c1 cneg cD csm co
      csp co caddc co cA c1 cneg cD csm co csp co c1 cneg cB csm co cC csp co
      caddc co caddc co cA cC csp co cB cD csp co caddc co cA cD csp co cB cC
      csp co caddc co cmin co cA cB cmv co cA c1 cneg cB csm co cva co cC cD
      cmv co cC c1 cneg cD csm co cva co csp cA cB normlem8.1 normlem8.2
      hvsubvali cC cD normlem8.3 normlem8.4 hvsubvali opreq12i cA c1 cneg cB
      csm co cC c1 cneg cD csm co normlem8.1 c1 cneg cB c1 ax1cn negcli
      normlem8.2 hvmulcli normlem8.3 c1 cneg cD c1 ax1cn negcli normlem8.4
      hvmulcli normlem8 cA cC csp co c1 cneg cB csm co c1 cneg cD csm co csp co
      caddc co cA c1 cneg cD csm co csp co c1 cneg cB csm co cC csp co caddc co
      caddc co cA cC csp co cB cD csp co caddc co cA cD csp co cB cC csp co
      caddc co cneg caddc co cA cC csp co cB cD csp co caddc co cA cD csp co cB
      cC csp co caddc co cmin co cA cC csp co c1 cneg cB csm co c1 cneg cD csm
      co csp co caddc co cA cC csp co cB cD csp co caddc co cA c1 cneg cD csm
      co csp co c1 cneg cB csm co cC csp co caddc co cA cD csp co cB cC csp co
      caddc co cneg caddc c1 cneg cB csm co c1 cneg cD csm co csp co cB cD csp
      co cA cC csp co caddc c1 cneg cB csm co c1 cneg cD csm co csp co c1 cneg
      cB c1 cneg cD csm co csp co cmul co c1 cneg c1 cneg ccj cfv cB cD csp co
      cmul co cmul co cB cD csp co c1 cneg cc wcel cB chil wcel c1 cneg cD csm
      co chil wcel c1 cneg cB csm co c1 cneg cD csm co csp co c1 cneg cB c1
      cneg cD csm co csp co cmul co wceq c1 ax1cn negcli normlem8.2 c1 cneg cD
      c1 ax1cn negcli normlem8.4 hvmulcli c1 cneg cB c1 cneg cD csm co ax-his3
      mp3an cB c1 cneg cD csm co csp co c1 cneg ccj cfv cB cD csp co cmul co c1
      cneg cmul c1 cneg cc wcel cB chil wcel cD chil wcel cB c1 cneg cD csm co
      csp co c1 cneg ccj cfv cB cD csp co cmul co wceq c1 ax1cn negcli
      normlem8.2 normlem8.4 c1 cneg cB cD his5 mp3an opreq2i c1 cneg c1 cneg
      ccj cfv cmul co cB cD csp co cmul co c1 cB cD csp co cmul co c1 cneg c1
      cneg ccj cfv cB cD csp co cmul co cmul co cB cD csp co c1 cneg c1 cneg
      ccj cfv cmul co c1 cB cD csp co cmul c1 cneg c1 cneg ccj cfv cmul co c1
      cneg c1 cneg cmul co c1 c1 cmul co c1 c1 cneg ccj cfv c1 cneg c1 cneg
      cmul c1 cneg cr wcel c1 cneg ccj cfv c1 cneg wceq c1 1re renegcli c1 cneg
      cjre ax-mp opreq2i c1 c1 ax1cn ax1cn mul2negi c1 ax1cn mulid2i 3eqtri
      opreq1i c1 cneg c1 cneg ccj cfv cB cD csp co c1 ax1cn negcli c1 cneg c1
      ax1cn negcli cjcli cB cD normlem8.2 normlem8.4 hicli mulassi cB cD csp co
      cB cD normlem8.2 normlem8.4 hicli mulid2i 3eqtr3i 3eqtri opreq2i cA c1
      cneg cD csm co csp co c1 cneg cB csm co cC csp co caddc co cA cD csp co
      cneg cB cC csp co cneg caddc co cA cD csp co cB cC csp co caddc co cneg
      cA c1 cneg cD csm co csp co cA cD csp co cneg c1 cneg cB csm co cC csp co
      cB cC csp co cneg caddc cA c1 cneg cD csm co csp co c1 cneg ccj cfv cA cD
      csp co cmul co c1 cneg cA cD csp co cmul co cA cD csp co cneg c1 cneg cc
      wcel cA chil wcel cD chil wcel cA c1 cneg cD csm co csp co c1 cneg ccj
      cfv cA cD csp co cmul co wceq c1 ax1cn negcli normlem8.1 normlem8.4 c1
      cneg cA cD his5 mp3an c1 cneg ccj cfv c1 cneg cA cD csp co cmul c1 cneg
      cr wcel c1 cneg ccj cfv c1 cneg wceq c1 1re renegcli c1 cneg cjre ax-mp
      opreq1i cA cD csp co cA cD normlem8.1 normlem8.4 hicli mulm1i 3eqtri c1
      cneg cB csm co cC csp co c1 cneg cB cC csp co cmul co cB cC csp co cneg
      c1 cneg cc wcel cB chil wcel cC chil wcel c1 cneg cB csm co cC csp co c1
      cneg cB cC csp co cmul co wceq c1 ax1cn negcli normlem8.2 normlem8.3 c1
      cneg cB cC ax-his3 mp3an cB cC csp co cB cC normlem8.2 normlem8.3 hicli
      mulm1i eqtri opreq12i cA cD csp co cB cC csp co cA cD normlem8.1
      normlem8.4 hicli cB cC normlem8.2 normlem8.3 hicli negdii eqtr4i opreq12i
      cA cC csp co cB cD csp co caddc co cA cD csp co cB cC csp co caddc co cA
      cC csp co cB cD csp co cA cC normlem8.1 normlem8.3 hicli cB cD normlem8.2
      normlem8.4 hicli addcli cA cD csp co cB cC csp co cA cD normlem8.1
      normlem8.4 hicli cB cC normlem8.2 normlem8.3 hicli addcli negsubi eqtri
      3eqtri $.
      $( [1-Jul-2005] $) $( [30-Jun-2005] $)
  $}

  ${
    normlem7t.1 $e |- A e. ~H $.
    normlem7t.2 $e |- B e. ~H $.
    $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
       [Beran] p. 97. $)
    normlem7tALT $p |- ( ( S e. CC /\ ( abs ` S ) = 1 ) ->
              ( ( ( * ` S ) x. ( A .ih B ) ) + ( S x. ( B .ih A ) ) ) <_
              ( 2 x. ( ( sqr ` ( B .ih B ) ) x. ( sqr ` ( A .ih A ) ) ) ) ) $=
      cS cc wcel cS cabs cfv c1 wceq wa cS ccj cfv cA cB csp co cmul co cS cB
      cA csp co cmul co caddc co c2 cB cB csp co csqr cfv cA cA csp co csqr cfv
      cmul co cmul co cle wbr cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif ccj
      cfv cA cB csp co cmul co cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cB
      cA csp co cmul co caddc co c2 cB cB csp co csqr cfv cA cA csp co csqr cfv
      cmul co cmul co cle wbr cS c1 cS cS cc wcel cS cabs cfv c1 wceq wa cS c1
      cif wceq cS ccj cfv cA cB csp co cmul co cS cB cA csp co cmul co caddc co
      cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif ccj cfv cA cB csp co cmul co
      cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cB cA csp co cmul co caddc co
      c2 cB cB csp co csqr cfv cA cA csp co csqr cfv cmul co cmul co cle cS cS
      cc wcel cS cabs cfv c1 wceq wa cS c1 cif wceq cS ccj cfv cA cB csp co
      cmul co cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif ccj cfv cA cB csp co
      cmul co cS cB cA csp co cmul co cS cc wcel cS cabs cfv c1 wceq wa cS c1
      cif cB cA csp co cmul co caddc cS cS cc wcel cS cabs cfv c1 wceq wa cS c1
      cif wceq cS ccj cfv cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif ccj cfv
      cA cB csp co cmul cS cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif ccj
      fveq2 opreq1d cS cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cB cA csp co
      cmul opreq1 opreq12d breq1d cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif
      cA cB cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc wcel cS cc wcel cS
      cabs cfv c1 wceq wa cS c1 cif cabs cfv c1 wceq cS cc wcel cS cabs cfv c1
      wceq wa cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc wcel cS cc wcel cS
      cabs cfv c1 wceq wa cS c1 cif cabs cfv c1 wceq wa c1 cc wcel c1 cabs cfv
      c1 wceq wa cS c1 cS cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif wceq cS
      cc wcel cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc wcel cS cabs cfv
      c1 wceq cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cabs cfv c1 wceq cS
      cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc eleq1 cS cS cc wcel cS
      cabs cfv c1 wceq wa cS c1 cif wceq cS cabs cfv cS cc wcel cS cabs cfv c1
      wceq wa cS c1 cif cabs cfv c1 cS cS cc wcel cS cabs cfv c1 wceq wa cS c1
      cif cabs fveq2 eqeq1d anbi12d c1 cS cc wcel cS cabs cfv c1 wceq wa cS c1
      cif wceq c1 cc wcel cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc wcel
      c1 cabs cfv c1 wceq cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cabs cfv
      c1 wceq c1 cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc eleq1 c1 cS cc
      wcel cS cabs cfv c1 wceq wa cS c1 cif wceq c1 cabs cfv cS cc wcel cS cabs
      cfv c1 wceq wa cS c1 cif cabs cfv c1 c1 cS cc wcel cS cabs cfv c1 wceq wa
      cS c1 cif cabs fveq2 eqeq1d anbi12d c1 cc wcel c1 cabs cfv c1 wceq ax1cn
      cc0 c1 cle wbr c1 cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re
      absidi ax-mp pm3.2i elimhyp pm3.26i normlem7t.1 normlem7t.2 cS cc wcel cS
      cabs cfv c1 wceq wa cS c1 cif cc wcel cS cc wcel cS cabs cfv c1 wceq wa
      cS c1 cif cabs cfv c1 wceq cS cc wcel cS cabs cfv c1 wceq wa cS cc wcel
      cS cabs cfv c1 wceq wa cS c1 cif cc wcel cS cc wcel cS cabs cfv c1 wceq
      wa cS c1 cif cabs cfv c1 wceq wa c1 cc wcel c1 cabs cfv c1 wceq wa cS c1
      cS cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif wceq cS cc wcel cS cc wcel
      cS cabs cfv c1 wceq wa cS c1 cif cc wcel cS cabs cfv c1 wceq cS cc wcel
      cS cabs cfv c1 wceq wa cS c1 cif cabs cfv c1 wceq cS cS cc wcel cS cabs
      cfv c1 wceq wa cS c1 cif cc eleq1 cS cS cc wcel cS cabs cfv c1 wceq wa cS
      c1 cif wceq cS cabs cfv cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cabs
      cfv c1 cS cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cabs fveq2 eqeq1d
      anbi12d c1 cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif wceq c1 cc wcel cS
      cc wcel cS cabs cfv c1 wceq wa cS c1 cif cc wcel c1 cabs cfv c1 wceq cS
      cc wcel cS cabs cfv c1 wceq wa cS c1 cif cabs cfv c1 wceq c1 cS cc wcel
      cS cabs cfv c1 wceq wa cS c1 cif cc eleq1 c1 cS cc wcel cS cabs cfv c1
      wceq wa cS c1 cif wceq c1 cabs cfv cS cc wcel cS cabs cfv c1 wceq wa cS
      c1 cif cabs cfv c1 c1 cS cc wcel cS cabs cfv c1 wceq wa cS c1 cif cabs
      fveq2 eqeq1d anbi12d c1 cc wcel c1 cabs cfv c1 wceq ax1cn cc0 c1 cle wbr
      c1 cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp pm3.2i
      elimhyp pm3.27i normlem7 dedth $.
      $( [11-Oct-1999] $)

    $( Equality case of Bunjakovaskij-Cauchy-Schwarz inequality.  Specifically,
       in the equality case the two vectors are collinear.  Compare
       ~ bcsiHIL . $)
    bcseqi $p |- ( ( ( A .ih B ) x. ( B .ih A ) ) = ( ( A .ih A ) x.
             ( B .ih B ) ) <-> ( ( B .ih B ) .h A ) = ( ( A .ih B ) .h B ) ) $=
      cA cB csp co cB cA csp co cmul co cA cA csp co cB cB csp co cmul co wceq
      cB cB csp co cA csm co cA cB csp co cB csm co wceq cA cB csp co cB cA csp
      co cmul co cA cA csp co cB cB csp co cmul co wceq cB cB csp co cA csm co
      cA cB csp co cB csm co cmv co c0v wceq cB cB csp co cA csm co cA cB csp
      co cB csm co wceq cA cB csp co cB cA csp co cmul co cA cA csp co cB cB
      csp co cmul co wceq cB cB csp co cA csm co cA cB csp co cB csm co cmv co
      cB cB csp co cA csm co cA cB csp co cB csm co cmv co csp co cc0 wceq cB
      cB csp co cA csm co cA cB csp co cB csm co cmv co c0v wceq cA cB csp co
      cB cA csp co cmul co cA cA csp co cB cB csp co cmul co wceq cB cB csp co
      cA csm co cB cB csp co cA csm co csp co cA cB csp co cB csm co cA cB csp
      co cB csm co csp co caddc co cB cB csp co cA csm co cA cB csp co cB csm
      co csp co cA cB csp co cB csm co cB cB csp co cA csm co csp co caddc co
      cmin co cc0 cB cB csp co cA csm co cA cB csp co cB csm co cmv co cB cB
      csp co cA csm co cA cB csp co cB csm co cmv co csp co cA cB csp co cB cA
      csp co cmul co cA cA csp co cB cB csp co cmul co wceq cB cB csp co cA csm
      co cB cB csp co cA csm co csp co cA cB csp co cB csm co cA cB csp co cB
      csm co csp co caddc co cB cB csp co cA csm co cA cB csp co cB csm co csp
      co cA cB csp co cB csm co cB cB csp co cA csm co csp co caddc co cmin co
      cB cB csp co cA csm co cA cB csp co cB csm co csp co cA cB csp co cB csm
      co cB cB csp co cA csm co csp co caddc co cB cB csp co cA csm co cA cB
      csp co cB csm co csp co cA cB csp co cB csm co cB cB csp co cA csm co csp
      co caddc co cmin co cc0 cA cB csp co cB cA csp co cmul co cA cA csp co cB
      cB csp co cmul co wceq cB cB csp co cA csm co cB cB csp co cA csm co csp
      co cA cB csp co cB csm co cA cB csp co cB csm co csp co caddc co cB cB
      csp co cA csm co cA cB csp co cB csm co csp co cA cB csp co cB csm co cB
      cB csp co cA csm co csp co caddc co cB cB csp co cA csm co cA cB csp co
      cB csm co csp co cA cB csp co cB csm co cB cB csp co cA csm co csp co
      caddc co cmin cA cB csp co cB cA csp co cmul co cA cA csp co cB cB csp co
      cmul co wceq cB cB csp co cA csm co cB cB csp co cA csm co csp co cB cB
      csp co cA csm co cA cB csp co cB csm co csp co cA cB csp co cB csm co cA
      cB csp co cB csm co csp co cA cB csp co cB csm co cB cB csp co cA csm co
      csp co caddc cA cB csp co cB cA csp co cmul co cA cA csp co cB cB csp co
      cmul co wceq cA cA csp co cB cB csp co cmul co cB cB csp co cmul co cA cB
      csp co cB cA csp co cmul co cB cB csp co cmul co cB cB csp co cA csm co
      cB cB csp co cA csm co csp co cB cB csp co cA csm co cA cB csp co cB csm
      co csp co cA cB csp co cB cA csp co cmul co cA cA csp co cB cB csp co
      cmul co wceq cA cB csp co cB cA csp co cmul co cB cB csp co cmul co cA cA
      csp co cB cB csp co cmul co cB cB csp co cmul co cA cB csp co cB cA csp
      co cmul co cA cA csp co cB cB csp co cmul co cB cB csp co cmul opreq1
      eqcomd cB cB csp co cA csm co cB cB csp co cA csm co csp co cB cB csp co
      ccj cfv cB cB csp co cA csm co cA csp co cmul co cB cB csp co cB cB csp
      co cA cA csp co cmul co cmul co cA cA csp co cB cB csp co cmul co cB cB
      csp co cmul co cB cB csp co cc wcel cB cB csp co cA csm co chil wcel cA
      chil wcel cB cB csp co cA csm co cB cB csp co cA csm co csp co cB cB csp
      co ccj cfv cB cB csp co cA csm co cA csp co cmul co wceq cB cB
      normlem7t.2 normlem7t.2 hicli cB cB csp co cA cB cB normlem7t.2
      normlem7t.2 hicli normlem7t.1 hvmulcli normlem7t.1 cB cB csp co cB cB csp
      co cA csm co cA his5 mp3an cB cB csp co ccj cfv cB cB csp co cB cB csp co
      cA csm co cA csp co cB cB csp co cA cA csp co cmul co cmul cB cB csp co
      cr wcel cB cB csp co ccj cfv cB cB csp co wceq cB chil wcel cB cB csp co
      cr wcel normlem7t.2 cB hiidrcl ax-mp cB cB csp co cjre ax-mp cB cB csp co
      cc wcel cA chil wcel cA chil wcel cB cB csp co cA csm co cA csp co cB cB
      csp co cA cA csp co cmul co wceq cB cB normlem7t.2 normlem7t.2 hicli
      normlem7t.1 normlem7t.1 cB cB csp co cA cA ax-his3 mp3an opreq12i cB cB
      csp co cB cB csp co cA cA csp co cmul co cmul co cB cB csp co cA cA csp
      co cmul co cB cB csp co cmul co cA cA csp co cB cB csp co cmul co cB cB
      csp co cmul co cB cB csp co cB cB csp co cA cA csp co cmul co cB cB
      normlem7t.2 normlem7t.2 hicli cB cB csp co cA cA csp co cB cB normlem7t.2
      normlem7t.2 hicli cA cA normlem7t.1 normlem7t.1 hicli mulcli mulcomi cA
      cA csp co cB cB csp co cmul co cB cB csp co cA cA csp co cmul co cB cB
      csp co cmul cA cA csp co cB cB csp co cA cA normlem7t.1 normlem7t.1 hicli
      cB cB normlem7t.2 normlem7t.2 hicli mulcomi opreq1i eqtr4i 3eqtri cB cB
      csp co cA csm co cA cB csp co cB csm co csp co cA cB csp co ccj cfv cB cB
      csp co cA csm co cB csp co cmul co cB cA csp co cB cB csp co cA cB csp co
      cmul co cmul co cA cB csp co cB cA csp co cmul co cB cB csp co cmul co cA
      cB csp co cc wcel cB cB csp co cA csm co chil wcel cB chil wcel cB cB csp
      co cA csm co cA cB csp co cB csm co csp co cA cB csp co ccj cfv cB cB csp
      co cA csm co cB csp co cmul co wceq cA cB normlem7t.1 normlem7t.2 hicli
      cB cB csp co cA cB cB normlem7t.2 normlem7t.2 hicli normlem7t.1 hvmulcli
      normlem7t.2 cA cB csp co cB cB csp co cA csm co cB his5 mp3an cA cB csp
      co ccj cfv cB cA csp co cB cB csp co cA csm co cB csp co cB cB csp co cA
      cB csp co cmul co cmul cB cA csp co cA cB csp co ccj cfv cB cA
      normlem7t.2 normlem7t.1 his1i eqcomi cB cB csp co cc wcel cA chil wcel cB
      chil wcel cB cB csp co cA csm co cB csp co cB cB csp co cA cB csp co cmul
      co wceq cB cB normlem7t.2 normlem7t.2 hicli normlem7t.1 normlem7t.2 cB cB
      csp co cA cB ax-his3 mp3an opreq12i cB cA csp co cB cB csp co cA cB csp
      co cmul co cmul co cB cB csp co cA cB csp co cmul co cB cA csp co cmul co
      cB cB csp co cA cB csp co cB cA csp co cmul co cmul co cA cB csp co cB cA
      csp co cmul co cB cB csp co cmul co cB cA csp co cB cB csp co cA cB csp
      co cmul co cB cA normlem7t.2 normlem7t.1 hicli cB cB csp co cA cB csp co
      cB cB normlem7t.2 normlem7t.2 hicli cA cB normlem7t.1 normlem7t.2 hicli
      mulcli mulcomi cB cB csp co cA cB csp co cB cA csp co cB cB normlem7t.2
      normlem7t.2 hicli cA cB normlem7t.1 normlem7t.2 hicli cB cA normlem7t.2
      normlem7t.1 hicli mulassi cB cB csp co cA cB csp co cB cA csp co cmul co
      cB cB normlem7t.2 normlem7t.2 hicli cA cB csp co cB cA csp co cA cB
      normlem7t.1 normlem7t.2 hicli cB cA normlem7t.2 normlem7t.1 hicli mulcli
      mulcomi 3eqtri 3eqtri 3eqtr4g cA cB csp co cB csm co cA cB csp co cB csm
      co csp co cA cB csp co cB csm co cB cB csp co cA csm co csp co wceq cA cB
      csp co cB cA csp co cmul co cA cA csp co cB cB csp co cmul co wceq cB cB
      csp co ccj cfv cA cB csp co cB csm co cA csp co cmul co cB cB csp co cA
      cB csp co cB cA csp co cmul co cmul co cA cB csp co cB csm co cB cB csp
      co cA csm co csp co cA cB csp co cB csm co cA cB csp co cB csm co csp co
      cB cB csp co ccj cfv cB cB csp co cA cB csp co cB csm co cA csp co cA cB
      csp co cB cA csp co cmul co cmul cB cB csp co cr wcel cB cB csp co ccj
      cfv cB cB csp co wceq cB chil wcel cB cB csp co cr wcel normlem7t.2 cB
      hiidrcl ax-mp cB cB csp co cjre ax-mp cA cB csp co cc wcel cB chil wcel
      cA chil wcel cA cB csp co cB csm co cA csp co cA cB csp co cB cA csp co
      cmul co wceq cA cB normlem7t.1 normlem7t.2 hicli normlem7t.2 normlem7t.1
      cA cB csp co cB cA ax-his3 mp3an opreq12i cB cB csp co cc wcel cA cB csp
      co cB csm co chil wcel cA chil wcel cA cB csp co cB csm co cB cB csp co
      cA csm co csp co cB cB csp co ccj cfv cA cB csp co cB csm co cA csp co
      cmul co wceq cB cB normlem7t.2 normlem7t.2 hicli cA cB csp co cB cA cB
      normlem7t.1 normlem7t.2 hicli normlem7t.2 hvmulcli normlem7t.1 cB cB csp
      co cA cB csp co cB csm co cA his5 mp3an cA cB csp co cB csm co cA cB csp
      co cB csm co csp co cA cB csp co ccj cfv cA cB csp co cB csm co cB csp co
      cmul co cB cA csp co cA cB csp co cB cB csp co cmul co cmul co cB cB csp
      co cA cB csp co cB cA csp co cmul co cmul co cA cB csp co cc wcel cA cB
      csp co cB csm co chil wcel cB chil wcel cA cB csp co cB csm co cA cB csp
      co cB csm co csp co cA cB csp co ccj cfv cA cB csp co cB csm co cB csp co
      cmul co wceq cA cB normlem7t.1 normlem7t.2 hicli cA cB csp co cB cA cB
      normlem7t.1 normlem7t.2 hicli normlem7t.2 hvmulcli normlem7t.2 cA cB csp
      co cA cB csp co cB csm co cB his5 mp3an cA cB csp co ccj cfv cB cA csp co
      cA cB csp co cB csm co cB csp co cA cB csp co cB cB csp co cmul co cmul
      cB cA csp co cA cB csp co ccj cfv cB cA normlem7t.2 normlem7t.1 his1i
      eqcomi cA cB csp co cc wcel cB chil wcel cB chil wcel cA cB csp co cB csm
      co cB csp co cA cB csp co cB cB csp co cmul co wceq cA cB normlem7t.1
      normlem7t.2 hicli normlem7t.2 normlem7t.2 cA cB csp co cB cB ax-his3
      mp3an opreq12i cB cA csp co cA cB csp co cB cB csp co cmul co cmul co cA
      cB csp co cB cB csp co cmul co cB cA csp co cmul co cA cB csp co cB cA
      csp co cmul co cB cB csp co cmul co cB cB csp co cA cB csp co cB cA csp
      co cmul co cmul co cB cA csp co cA cB csp co cB cB csp co cmul co cB cA
      normlem7t.2 normlem7t.1 hicli cA cB csp co cB cB csp co cA cB normlem7t.1
      normlem7t.2 hicli cB cB normlem7t.2 normlem7t.2 hicli mulcli mulcomi cA
      cB csp co cB cB csp co cB cA csp co cA cB normlem7t.1 normlem7t.2 hicli
      cB cB normlem7t.2 normlem7t.2 hicli cB cA normlem7t.2 normlem7t.1 hicli
      mul23i cA cB csp co cB cA csp co cmul co cB cB csp co cA cB csp co cB cA
      csp co cA cB normlem7t.1 normlem7t.2 hicli cB cA normlem7t.2 normlem7t.1
      hicli mulcli cB cB normlem7t.2 normlem7t.2 hicli mulcomi 3eqtri 3eqtri
      3eqtr4ri a1i opreq12d opreq1d cB cB csp co cA csm co cA cB csp co cB csm
      co csp co cA cB csp co cB csm co cB cB csp co cA csm co csp co caddc co
      cB cB csp co cA csm co cA cB csp co cB csm co csp co cA cB csp co cB csm
      co cB cB csp co cA csm co csp co cB cB csp co cA csm co cA cB csp co cB
      csm co cB cB csp co cA cB cB normlem7t.2 normlem7t.2 hicli normlem7t.1
      hvmulcli cA cB csp co cB cA cB normlem7t.1 normlem7t.2 hicli normlem7t.2
      hvmulcli hicli cA cB csp co cB csm co cB cB csp co cA csm co cA cB csp co
      cB cA cB normlem7t.1 normlem7t.2 hicli normlem7t.2 hvmulcli cB cB csp co
      cA cB cB normlem7t.2 normlem7t.2 hicli normlem7t.1 hvmulcli hicli addcli
      subidi syl6eq cB cB csp co cA csm co cA cB csp co cB csm co cB cB csp co
      cA csm co cA cB csp co cB csm co cB cB csp co cA cB cB normlem7t.2
      normlem7t.2 hicli normlem7t.1 hvmulcli cA cB csp co cB cA cB normlem7t.1
      normlem7t.2 hicli normlem7t.2 hvmulcli cB cB csp co cA cB cB normlem7t.2
      normlem7t.2 hicli normlem7t.1 hvmulcli cA cB csp co cB cA cB normlem7t.1
      normlem7t.2 hicli normlem7t.2 hvmulcli normlem9 syl5eq cB cB csp co cA
      csm co cA cB csp co cB csm co cmv co chil wcel cB cB csp co cA csm co cA
      cB csp co cB csm co cmv co cB cB csp co cA csm co cA cB csp co cB csm co
      cmv co csp co cc0 wceq cB cB csp co cA csm co cA cB csp co cB csm co cmv
      co c0v wceq wb cB cB csp co cA csm co cA cB csp co cB csm co cB cB csp co
      cA cB cB normlem7t.2 normlem7t.2 hicli normlem7t.1 hvmulcli cA cB csp co
      cB cA cB normlem7t.1 normlem7t.2 hicli normlem7t.2 hvmulcli hvsubcli cB
      cB csp co cA csm co cA cB csp co cB csm co cmv co his6 ax-mp sylib cB cB
      csp co cA csm co cA cB csp co cB csm co cB cB csp co cA cB cB normlem7t.2
      normlem7t.2 hicli normlem7t.1 hvmulcli cA cB csp co cB cA cB normlem7t.1
      normlem7t.2 hicli normlem7t.2 hvmulcli hvsubeq0i sylib cB cB csp co cA
      csm co cA cB csp co cB csm co wceq cA cA csp co cB cB csp co cmul co cA
      cB csp co cB cA csp co cmul co cB cB csp co cA csm co cA cB csp co cB csm
      co wceq cB cB csp co cA csm co cA csp co cA cB csp co cB csm co cA csp co
      cA cA csp co cB cB csp co cmul co cA cB csp co cB cA csp co cmul co cB cB
      csp co cA csm co cA cB csp co cB csm co cA csp opreq1 cA cA csp co cB cB
      csp co cmul co cB cB csp co cA cA csp co cmul co cB cB csp co cA csm co
      cA csp co cA cA csp co cB cB csp co cA cA normlem7t.1 normlem7t.1 hicli
      cB cB normlem7t.2 normlem7t.2 hicli mulcomi cB cB csp co cc wcel cA chil
      wcel cA chil wcel cB cB csp co cA csm co cA csp co cB cB csp co cA cA csp
      co cmul co wceq cB cB normlem7t.2 normlem7t.2 hicli normlem7t.1
      normlem7t.1 cB cB csp co cA cA ax-his3 mp3an eqtr4i cA cB csp co cB csm
      co cA csp co cA cB csp co cB cA csp co cmul co cA cB csp co cc wcel cB
      chil wcel cA chil wcel cA cB csp co cB csm co cA csp co cA cB csp co cB
      cA csp co cmul co wceq cA cB normlem7t.1 normlem7t.2 hicli normlem7t.2
      normlem7t.1 cA cB csp co cB cA ax-his3 mp3an eqcomi 3eqtr4g eqcomd impbii
      $.
      $( [16-Jul-2001] $)
  $}

  $( Lemma used to derive properties of norm.  Part of Remark 3.4(B) of
     [Beran] p. 98. $)
  normlem9at $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( A -h B ) .ih ( A -h B ) ) =
      ( ( ( A .ih A ) + ( B .ih B ) ) - ( ( A .ih B ) + ( B .ih A ) ) ) ) $=
    cA chil wcel cB chil wcel cA cB cmv co cA cB cmv co csp co cA cA csp co cB
    cB csp co caddc co cA cB csp co cB cA csp co caddc co cmin co wceq cA chil
    wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif cB cmv co csp co cA chil
    wcel cA c0v cif cA chil wcel cA c0v cif csp co cB cB csp co caddc co cA
    chil wcel cA c0v cif cB csp co cB cA chil wcel cA c0v cif csp co caddc co
    cmin co wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif cmv co csp co cA chil wcel cA c0v
    cif cA chil wcel cA c0v cif csp co cB chil wcel cB c0v cif cB chil wcel cB
    c0v cif csp co caddc co cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp
    co cB chil wcel cB c0v cif cA chil wcel cA c0v cif csp co caddc co cmin co
    wceq cA cB c0v c0v cA cA chil wcel cA c0v cif wceq cA cB cmv co cA cB cmv
    co csp co cA chil wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif cB cmv
    co csp co cA cA csp co cB cB csp co caddc co cA cB csp co cB cA csp co
    caddc co cmin co cA chil wcel cA c0v cif cA chil wcel cA c0v cif csp co cB
    cB csp co caddc co cA chil wcel cA c0v cif cB csp co cB cA chil wcel cA c0v
    cif csp co caddc co cmin co cA cA chil wcel cA c0v cif wceq cA cB cmv co cA
    chil wcel cA c0v cif cB cmv co cA cB cmv co cA chil wcel cA c0v cif cB cmv
    co csp cA cA chil wcel cA c0v cif cB cmv opreq1 cA cA chil wcel cA c0v cif
    cB cmv opreq1 opreq12d cA cA chil wcel cA c0v cif wceq cA cA csp co cB cB
    csp co caddc co cA chil wcel cA c0v cif cA chil wcel cA c0v cif csp co cB
    cB csp co caddc co cA cB csp co cB cA csp co caddc co cA chil wcel cA c0v
    cif cB csp co cB cA chil wcel cA c0v cif csp co caddc co cmin cA cA chil
    wcel cA c0v cif wceq cA cA csp co cA chil wcel cA c0v cif cA chil wcel cA
    c0v cif csp co cB cB csp co caddc cA cA chil wcel cA c0v cif wceq cA cA
    chil wcel cA c0v cif cA cA chil wcel cA c0v cif csp cA cA chil wcel cA c0v
    cif wceq id cA cA chil wcel cA c0v cif wceq id opreq12d opreq1d cA cA chil
    wcel cA c0v cif wceq cA cB csp co cA chil wcel cA c0v cif cB csp co cB cA
    csp co cB cA chil wcel cA c0v cif csp co caddc cA cA chil wcel cA c0v cif
    cB csp opreq1 cA cA chil wcel cA c0v cif cB csp opreq2 opreq12d opreq12d
    eqeq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co
    cA chil wcel cA c0v cif cB cmv co csp co cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv
    co csp co cA chil wcel cA c0v cif cA chil wcel cA c0v cif csp co cB cB csp
    co caddc co cA chil wcel cA c0v cif cB csp co cB cA chil wcel cA c0v cif
    csp co caddc co cmin co cA chil wcel cA c0v cif cA chil wcel cA c0v cif csp
    co cB chil wcel cB c0v cif cB chil wcel cB c0v cif csp co caddc co cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif csp co cB chil wcel cB c0v cif cA
    chil wcel cA c0v cif csp co caddc co cmin co cB cB chil wcel cB c0v cif
    wceq cA chil wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cmv co cA chil wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cmv co csp cB cB chil wcel cB c0v cif cA chil wcel
    cA c0v cif cmv opreq2 cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif
    cmv opreq2 opreq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif
    cA chil wcel cA c0v cif csp co cB cB csp co caddc co cA chil wcel cA c0v
    cif cA chil wcel cA c0v cif csp co cB chil wcel cB c0v cif cB chil wcel cB
    c0v cif csp co caddc co cA chil wcel cA c0v cif cB csp co cB cA chil wcel
    cA c0v cif csp co caddc co cA chil wcel cA c0v cif cB chil wcel cB c0v cif
    csp co cB chil wcel cB c0v cif cA chil wcel cA c0v cif csp co caddc co cmin
    cB cB chil wcel cB c0v cif wceq cB cB csp co cB chil wcel cB c0v cif cB
    chil wcel cB c0v cif csp co cA chil wcel cA c0v cif cA chil wcel cA c0v cif
    csp co caddc cB cB chil wcel cB c0v cif wceq cB cB chil wcel cB c0v cif cB
    cB chil wcel cB c0v cif csp cB cB chil wcel cB c0v cif wceq id cB cB chil
    wcel cB c0v cif wceq id opreq12d opreq2d cB cB chil wcel cB c0v cif wceq cA
    chil wcel cA c0v cif cB csp co cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif csp co cB cA chil wcel cA c0v cif csp co cB chil wcel cB c0v cif cA
    chil wcel cA c0v cif csp co caddc cB cB chil wcel cB c0v cif cA chil wcel
    cA c0v cif csp opreq2 cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif
    csp opreq1 opreq12d opreq12d eqeq12d cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cA chil wcel cA c0v cif cB chil wcel cB c0v cif cA c0v chil
    ax-hv0cl elimel cB c0v chil ax-hv0cl elimel cA c0v chil ax-hv0cl elimel cB
    c0v chil ax-hv0cl elimel normlem9 dedth2h $.
    $( [30-May-2005] $) $( [10-May-2005] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Norms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Alternate definition of the norm of a vector of Hilbert space.
       Definition of norm in [Beran] p. 96. $)
    dfhnorm2 $p |- normh =
                  { <. x , y >. | ( x e. ~H /\ y = ( sqr ` ( x .ih x ) ) ) } $=
      cno vx cv csp cdm cdm wcel vy cv vx cv vx cv csp co csqr cfv wceq wa vx
      vy copab vx cv chil wcel vy cv vx cv vx cv csp co csqr cfv wceq wa vx vy
      copab vx vy df-hnorm vx cv chil wcel vy cv vx cv vx cv csp co csqr cfv
      wceq wa vx cv csp cdm cdm wcel vy cv vx cv vx cv csp co csqr cfv wceq wa
      vx vy vx cv chil wcel vx cv csp cdm cdm wcel vy cv vx cv vx cv csp co
      csqr cfv wceq chil csp cdm cdm vx cv csp cdm cdm chil chil cxp cdm chil
      csp cdm chil chil cxp chil chil cxp cc csp ax-hfi fdmi dmeqi chil dmxpid
      eqtr2i eleq2i anbi1i opabbii eqtr4i $.
      $( [12-Jun-2008] $) $( [6-Jun-2008] $)

    $( The norm function maps from Hilbert space to reals. $)
    normf $p |- normh : ~H --> RR $=
      vx vy chil cr vx cv vx cv csp co csqr cfv cno vx vy dfhnorm2 vx cv vx cv
      csp co cr wcel cc0 vx cv vx cv csp co cle wbr vx cv vx cv csp co csqr cfv
      cr wcel vx cv chil wcel vx cv vx cv csp co sqrcl vx cv hiidrcl vx cv
      hiidge0 sylanc fopab $.
      $( [6-Sep-2007] $) $( [6-Sep-2007] $)
  $}

  ${
    $d x y A $.
    $( The value of the norm of a vector in Hilbert space.  Definition of
       norm in [Beran] p. 96.  In the literature, the norm of ` A ` is
       usually written as "|| ` A ` ||", but we use function value notation
       to take advantage of our existing theorems about functions. $)
    normval $p |- ( A e. ~H -> ( normh ` A ) = ( sqr ` ( A .ih A ) ) ) $=
      vx vy cA vx cv vx cv csp co csqr cfv cA cA csp co csqr cfv chil cno vx cv
      cA wceq vx cv vx cv csp co cA cA csp co csqr vx cv cA wceq vx cv vx cv
      csp co cA cA csp co wceq vx cv cA vx cv cA csp opreq12 anidms fveq2d vx
      vy dfhnorm2 cA cA csp co csqr fvex fvopab4 $.
      $( [29-May-1999] $)
  $}

  $( Real closure of the norm of a vector. $)
  normcl $p |- ( A e. ~H -> ( normh ` A ) e. RR ) $=
    chil cr cA cno normf ffvelrni $.
    $( [29-May-1999] $)

  $( The norm of a vector is nonnegative. $)
  normge0 $p |- ( A e. ~H -> 0 <_ ( normh ` A ) ) $=
    cA chil wcel cc0 cA cA csp co csqr cfv cA cno cfv cle cA cA csp co cr wcel
    cc0 cA cA csp co cle wbr cc0 cA cA csp co csqr cfv cle wbr cA chil wcel cA
    cA csp co sqrge0 cA hiidrcl cA hiidge0 sylanc cA normval breqtrrd $.
    $( [29-May-1999] $)

  $( The norm of non-zero vector is positive. $)
  normgt0OLD $p |- ( A e. ~H -> ( -. A = 0h <-> 0 < ( normh ` A ) ) ) $=
    cA chil wcel cA c0v wceq wn cc0 cA cA csp co csqr cfv clt wbr cc0 cA cno
    cfv clt wbr cA chil wcel cA c0v wceq wn cc0 cA cA csp co csqr cfv clt wbr
    cA chil wcel cA c0v wceq wn cc0 cA cA csp co csqr cfv clt wbr cA cA csp co
    cr wcel cc0 cA cA csp co clt wbr cc0 cA cA csp co csqr cfv clt wbr cA chil
    wcel cA c0v wceq wn wa cA cA csp co sqrgt0 cA chil wcel cA cA csp co cr
    wcel cA c0v wceq wn cA hiidrcl adantr cA chil wcel cA c0v wne cc0 cA cA csp
    co clt wbr cA c0v wceq wn cA ax-his4 cA c0v df-ne sylan2br sylanc ex cA
    chil wcel cA c0v wceq cc0 cA cA csp co csqr cfv clt wbr cA chil wcel cA c0v
    wceq cA cA csp co csqr cfv cc0 wceq cc0 cA cA csp co csqr cfv clt wbr wn cA
    chil wcel cA c0v wceq cA cA csp co csqr cfv cc0 wceq cA chil wcel cA c0v
    wceq wa cA cA csp co csqr cfv cc0 csqr cfv cc0 cA chil wcel cA c0v wceq wa
    cA cA csp co cc0 csqr cA c0v wceq cA chil wcel cA cA csp co c0v cA csp co
    cc0 cA c0v cA csp opreq1 cA hi01 sylan9eqr fveq2d sqr0 syl6eq ex cA chil
    wcel cA cA csp co csqr cfv cc0 wceq cA cA csp co csqr cfv cc0 clt wbr wn
    cc0 cA cA csp co csqr cfv clt wbr wn wa cc0 cA cA csp co csqr cfv clt wbr
    wn cA chil wcel cA cA csp co csqr cfv cr wcel cc0 cr wcel wa cA cA csp co
    csqr cfv cc0 wceq cA cA csp co csqr cfv cc0 clt wbr wn cc0 cA cA csp co
    csqr cfv clt wbr wn wa wb cA chil wcel cA cA csp co csqr cfv cr wcel cc0 cr
    wcel cA cA csp co cr wcel cc0 cA cA csp co cle wbr cA cA csp co csqr cfv cr
    wcel cA chil wcel cA cA csp co sqrcl cA hiidrcl cA hiidge0 sylanc 0re jctir
    cA cA csp co csqr cfv cc0 lttri3 syl cA cA csp co csqr cfv cc0 clt wbr wn
    cc0 cA cA csp co csqr cfv clt wbr wn pm3.27 syl6bi syld con2d impbid cA
    chil wcel cA cno cfv cA cA csp co csqr cfv cc0 clt cA normval breq2d bitr4d
    $.
    $( [29-May-1999] $)

  $( The norm of non-zero vector is positive. $)
  normgt0 $p |- ( A e. ~H -> ( A =/= 0h <-> 0 < ( normh ` A ) ) ) $=
    cA chil wcel cA c0v wne cc0 cA cA csp co csqr cfv clt wbr cc0 cA cno cfv
    clt wbr cA chil wcel cA c0v wne cc0 cA cA csp co csqr cfv clt wbr cA chil
    wcel cA c0v wne cc0 cA cA csp co csqr cfv clt wbr cA cA csp co cr wcel cc0
    cA cA csp co clt wbr cc0 cA cA csp co csqr cfv clt wbr cA chil wcel cA c0v
    wne wa cA cA csp co sqrgt0 cA chil wcel cA cA csp co cr wcel cA c0v wne cA
    hiidrcl adantr cA ax-his4 sylanc ex cA chil wcel cc0 cA cA csp co csqr cfv
    clt wbr cA c0v cA chil wcel cA c0v wceq cA cA csp co csqr cfv cc0 wceq cc0
    cA cA csp co csqr cfv clt wbr wn cA chil wcel cA c0v wceq cA cA csp co csqr
    cfv cc0 wceq cA chil wcel cA c0v wceq wa cA cA csp co csqr cfv cc0 csqr cfv
    cc0 cA chil wcel cA c0v wceq wa cA cA csp co cc0 csqr cA c0v wceq cA chil
    wcel cA cA csp co c0v cA csp co cc0 cA c0v cA csp opreq1 cA hi01 sylan9eqr
    fveq2d sqr0 syl6eq ex cA chil wcel cA cA csp co csqr cfv cc0 wceq cA cA csp
    co csqr cfv cc0 clt wbr wn cc0 cA cA csp co csqr cfv clt wbr wn wa cc0 cA
    cA csp co csqr cfv clt wbr wn cA chil wcel cA cA csp co csqr cfv cr wcel
    cc0 cr wcel wa cA cA csp co csqr cfv cc0 wceq cA cA csp co csqr cfv cc0 clt
    wbr wn cc0 cA cA csp co csqr cfv clt wbr wn wa wb cA chil wcel cA cA csp co
    csqr cfv cr wcel cc0 cr wcel cA cA csp co cr wcel cc0 cA cA csp co cle wbr
    cA cA csp co csqr cfv cr wcel cA chil wcel cA cA csp co sqrcl cA hiidrcl cA
    hiidge0 sylanc 0re jctir cA cA csp co csqr cfv cc0 lttri3 syl cA cA csp co
    csqr cfv cc0 clt wbr wn cc0 cA cA csp co csqr cfv clt wbr wn pm3.27 syl6bi
    syld necon2ad impbid cA chil wcel cA cno cfv cA cA csp co csqr cfv cc0 clt
    cA normval breq2d bitr4d $.
    $( [3-May-2006] $) $( [10-Apr-2006] $)

  $( The norm of a zero vector. $)
  norm0 $p |- ( normh ` 0h ) = 0 $=
    c0v cno cfv c0v c0v csp co csqr cfv cc0 csqr cfv cc0 c0v chil wcel c0v cno
    cfv c0v c0v csp co csqr cfv wceq ax-hv0cl c0v normval ax-mp c0v chil wcel
    c0v c0v csp co csqr cfv cc0 csqr cfv wceq ax-hv0cl c0v chil wcel c0v c0v
    csp co cc0 csqr c0v hi01 fveq2d ax-mp sqr0 3eqtri $.
    $( [30-May-1999] $)

  $( Theorem 3.3(i) of [Beran] p. 97. $)
  norm-i $p |- ( A e. ~H -> ( ( normh ` A ) = 0 <-> A = 0h ) ) $=
    cA chil wcel cA c0v wceq cA cno cfv cc0 wceq cA chil wcel cA c0v cA cno cfv
    cc0 cA chil wcel cA c0v wne cc0 cA cno cfv clt wbr cA cno cfv cc0 wne cA
    normgt0 cA cno cfv cr wcel cc0 cA cno cfv cle wbr cc0 cA cno cfv clt wbr cA
    cno cfv cc0 wne wb cA chil wcel cc0 cr wcel cA cno cfv cr wcel cc0 cA cno
    cfv cle wbr cc0 cA cno cfv clt wbr cA cno cfv cc0 wne wb 0re cc0 cA cno cfv
    leltne mp3an1 cA normcl cA normge0 sylanc bitrd necon4bid bicomd $.
    $( [29-Jul-1999] $)

  $( A norm is nonzero iff its argument is a nonzero vector. $)
  normne0 $p |- ( A e. ~H -> ( ( normh ` A ) =/= 0 <-> A =/= 0h ) ) $=
    cA chil wcel cA cno cfv cc0 cA c0v cA norm-i necon3bid $.
    $( [12-Mar-2006] $) $( [11-Mar-2006] $)

  ${
    normcl.1 $e |- A e. ~H $.
    $( Real closure of the norm of a vector. $)
    normcli $p |- ( normh ` A ) e. RR $=
      cA chil wcel cA cno cfv cr wcel normcl.1 cA normcl ax-mp $.
      $( [30-Sep-1999] $)

    $( The square of a norm. $)
    normsqi $p |- ( ( normh ` A ) ^ 2 ) = ( A .ih A ) $=
      cA cno cfv c2 cexp co cA cA csp co csqr cfv c2 cexp co cA cA csp co cA
      cno cfv cA cA csp co csqr cfv c2 cexp cA chil wcel cA cno cfv cA cA csp
      co csqr cfv wceq normcl.1 cA normval ax-mp opreq1i cc0 cA cA csp co cle
      wbr cA cA csp co csqr cfv c2 cexp co cA cA csp co wceq cA chil wcel cc0
      cA cA csp co cle wbr normcl.1 cA hiidge0 ax-mp cA cA csp co cA chil wcel
      cA cA csp co cr wcel normcl.1 cA hiidrcl ax-mp sqsqri ax-mp eqtri $.
      $( [21-Aug-1999] $)

    $( Theorem 3.3(i) of [Beran] p. 97. $)
    norm-i.i $p |- ( ( normh ` A ) = 0 <-> A = 0h ) $=
      cA chil wcel cA cno cfv cc0 wceq cA c0v wceq wb normcl.1 cA norm-i ax-mp
      $.
      $( [5-Sep-1999] $)
  $}

  $( The square of a norm. $)
  normsq $p |- ( A e. ~H -> ( ( normh ` A ) ^ 2 ) = ( A .ih A ) ) $=
    cA chil wcel cA cno cfv c2 cexp co cA cA csp co wceq cA chil wcel cA c0v
    cif cno cfv c2 cexp co cA chil wcel cA c0v cif cA chil wcel cA c0v cif csp
    co wceq cA c0v cA cA chil wcel cA c0v cif wceq cA cno cfv c2 cexp co cA
    chil wcel cA c0v cif cno cfv c2 cexp co cA cA csp co cA chil wcel cA c0v
    cif cA chil wcel cA c0v cif csp co cA cA chil wcel cA c0v cif wceq cA cno
    cfv cA chil wcel cA c0v cif cno cfv c2 cexp cA cA chil wcel cA c0v cif cno
    fveq2 opreq1d cA cA chil wcel cA c0v cif wceq cA cA chil wcel cA c0v cif cA
    cA chil wcel cA c0v cif csp cA cA chil wcel cA c0v cif wceq id cA cA chil
    wcel cA c0v cif wceq id opreq12d eqeq12d cA chil wcel cA c0v cif cA c0v
    chil ax-hv0cl elimel normsqi dedth $.
    $( [3-Jul-2005] $) $( [12-May-2005] $)

  ${
    normsub0.1 $e |- A e. ~H $.
    normsub0.2 $e |- B e. ~H $.
    $( Two vectors are equal iff the norm of their difference is zero. $)
    normsub0i $p |- ( ( normh ` ( A -h B ) ) = 0 <-> A = B ) $=
      cA cB cmv co cno cfv cc0 wceq cA cB cmv co c0v wceq cA cB wceq cA cB cmv
      co cA cB normsub0.1 normsub0.2 hvsubcli norm-i.i cA cB normsub0.1
      normsub0.2 hvsubeq0i bitri $.
      $( [18-Aug-1999] $)
  $}

  $( Two vectors are equal iff the norm of their difference is zero. $)
  normsub0 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( normh ` ( A -h B ) ) = 0 <-> A = B ) ) $=
    cA chil wcel cB chil wcel cA cB cmv co cno cfv cc0 wceq cA cB wceq wb cA
    chil wcel cA c0v cif cB cmv co cno cfv cc0 wceq cA chil wcel cA c0v cif cB
    wceq wb cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cc0
    wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif wceq wb cA cB c0v c0v
    cA cA chil wcel cA c0v cif wceq cA cB cmv co cno cfv cc0 wceq cA chil wcel
    cA c0v cif cB cmv co cno cfv cc0 wceq cA cB wceq cA chil wcel cA c0v cif cB
    wceq cA cA chil wcel cA c0v cif wceq cA cB cmv co cno cfv cA chil wcel cA
    c0v cif cB cmv co cno cfv cc0 cA cA chil wcel cA c0v cif wceq cA cB cmv co
    cA chil wcel cA c0v cif cB cmv co cno cA cA chil wcel cA c0v cif cB cmv
    opreq1 fveq2d eqeq1d cA cA chil wcel cA c0v cif cB eqeq1 bibi12d cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cno cfv cc0 wceq cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cc0 wceq cA
    chil wcel cA c0v cif cB wceq cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif wceq cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co
    cno cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cc0
    cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cB cB chil wcel cB c0v
    cif cA chil wcel cA c0v cif cmv opreq2 fveq2d eqeq1d cB cB chil wcel cB c0v
    cif cA chil wcel cA c0v cif eqeq2 bibi12d cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel
    normsub0i dedth2h $.
    $( [18-Aug-1999] $)

  ${
    norm-ii.1 $e |- A e. ~H $.
    norm-ii.2 $e |- B e. ~H $.
    $( Triangle inequality for norms.  Theorem 3.3(ii) of [Beran] p. 97. $)
    norm-ii.i $p |- ( normh ` ( A +h B ) ) <_
                  ( ( normh ` A ) + ( normh ` B ) ) $=
      cA cB cva co cA cB cva co csp co csqr cfv cA cA csp co csqr cfv cB cB csp
      co csqr cfv caddc co cA cB cva co cno cfv cA cno cfv cB cno cfv caddc co
      cle cA cB cva co cA cB cva co csp co csqr cfv cA cA csp co csqr cfv cB cB
      csp co csqr cfv caddc co c2 cexp co csqr cfv cA cA csp co csqr cfv cB cB
      csp co csqr cfv caddc co cle cA cB cva co cA cB cva co csp co cA cA csp
      co csqr cfv cB cB csp co csqr cfv caddc co c2 cexp co cle wbr cA cB cva
      co cA cB cva co csp co csqr cfv cA cA csp co csqr cfv cB cB csp co csqr
      cfv caddc co c2 cexp co csqr cfv cle wbr cA cA csp co cB cB csp co caddc
      co cB cA csp co cA cB csp co caddc co caddc co cA cA csp co cB cB csp co
      caddc co c2 cA cA csp co csqr cfv cB cB csp co csqr cfv cmul co cmul co
      caddc co cA cB cva co cA cB cva co csp co cA cA csp co csqr cfv cB cB csp
      co csqr cfv caddc co c2 cexp co cle cB cA csp co cA cB csp co caddc co c2
      cA cA csp co csqr cfv cB cB csp co csqr cfv cmul co cmul co cle wbr cA cA
      csp co cB cB csp co caddc co cB cA csp co cA cB csp co caddc co caddc co
      cA cA csp co cB cB csp co caddc co c2 cA cA csp co csqr cfv cB cB csp co
      csqr cfv cmul co cmul co caddc co cle wbr c1 ccj cfv cB cA csp co cmul co
      c1 cA cB csp co cmul co caddc co cB cA csp co cA cB csp co caddc co c2 cA
      cA csp co csqr cfv cB cB csp co csqr cfv cmul co cmul co cle c1 ccj cfv
      cB cA csp co cmul co cB cA csp co c1 cA cB csp co cmul co cA cB csp co
      caddc c1 ccj cfv cB cA csp co cmul co c1 cB cA csp co cmul co cB cA csp
      co c1 ccj cfv c1 cB cA csp co cmul c1 cr wcel c1 ccj cfv c1 wceq 1re c1
      ax1cn cjrebi mpbi opreq1i cB cA csp co cB cA norm-ii.2 norm-ii.1 hicli
      mulid2i eqtri cA cB csp co cA cB norm-ii.1 norm-ii.2 hicli mulid2i
      opreq12i c1 cB cA ax1cn norm-ii.2 norm-ii.1 cc0 c1 cle wbr c1 cabs cfv c1
      wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi ax-mp normlem7 eqbrtrri cB
      cA csp co cA cB csp co caddc co c2 cA cA csp co csqr cfv cB cB csp co
      csqr cfv cmul co cmul co cA cA csp co cB cB csp co caddc co c1 ccj cfv cB
      cA csp co cmul co c1 cA cB csp co cmul co caddc co cB cA csp co cA cB csp
      co caddc co cr c1 ccj cfv cB cA csp co cmul co cB cA csp co c1 cA cB csp
      co cmul co cA cB csp co caddc c1 ccj cfv cB cA csp co cmul co c1 cB cA
      csp co cmul co cB cA csp co c1 ccj cfv c1 cB cA csp co cmul c1 cr wcel c1
      ccj cfv c1 wceq 1re c1 ax1cn cjrebi mpbi opreq1i cB cA csp co cB cA
      norm-ii.2 norm-ii.1 hicli mulid2i eqtri cA cB csp co cA cB norm-ii.1
      norm-ii.2 hicli mulid2i opreq12i c1 ccj cfv cB cA csp co cmul co c1 cA cB
      csp co cmul co caddc co cneg cr wcel c1 ccj cfv cB cA csp co cmul co c1
      cA cB csp co cmul co caddc co cr wcel c1 ccj cfv cB cA csp co cmul co c1
      cA cB csp co cmul co caddc co cneg c1 cB cA ax1cn norm-ii.2 norm-ii.1 c1
      ccj cfv cB cA csp co cmul co c1 cA cB csp co cmul co caddc co cneg eqid
      normlem2 c1 ccj cfv cB cA csp co cmul co c1 cA cB csp co cmul co caddc co
      c1 ccj cfv cB cA csp co cmul co c1 cA cB csp co cmul co c1 ccj cfv cB cA
      csp co c1 ax1cn cjcli cB cA norm-ii.2 norm-ii.1 hicli mulcli c1 cA cB csp
      co ax1cn cA cB norm-ii.1 norm-ii.2 hicli mulcli addcli negrebi mpbi
      eqeltrri c2 cA cA csp co csqr cfv cB cB csp co csqr cfv cmul co 2re cA cA
      csp co csqr cfv cB cB csp co csqr cfv cc0 cA cA csp co cle wbr cA cA csp
      co csqr cfv cr wcel cA chil wcel cc0 cA cA csp co cle wbr norm-ii.1 cA
      hiidge0 ax-mp cA cA csp co cA chil wcel cA cA csp co cr wcel norm-ii.1 cA
      hiidrcl ax-mp sqrcli ax-mp cc0 cB cB csp co cle wbr cB cB csp co csqr cfv
      cr wcel cB chil wcel cc0 cB cB csp co cle wbr norm-ii.2 cB hiidge0 ax-mp
      cB cB csp co cB chil wcel cB cB csp co cr wcel norm-ii.2 cB hiidrcl ax-mp
      sqrcli ax-mp remulcli remulcli cA cA csp co cB cB csp co cA chil wcel cA
      cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp cB chil wcel cB cB csp co cr
      wcel norm-ii.2 cB hiidrcl ax-mp readdcli leadd2i mpbi cA cB cva co cA cB
      cva co csp co cA cA csp co cB cB csp co caddc co cA cB csp co cB cA csp
      co caddc co caddc co cA cA csp co cB cB csp co caddc co cB cA csp co cA
      cB csp co caddc co caddc co cA cB cA cB norm-ii.1 norm-ii.2 norm-ii.1
      norm-ii.2 normlem8 cA cB csp co cB cA csp co caddc co cB cA csp co cA cB
      csp co caddc co cA cA csp co cB cB csp co caddc co caddc cA cB csp co cB
      cA csp co cA cB norm-ii.1 norm-ii.2 hicli cB cA norm-ii.2 norm-ii.1 hicli
      addcomi opreq2i eqtri cA cA csp co csqr cfv cB cB csp co csqr cfv caddc
      co c2 cexp co cA cA csp co csqr cfv c2 cexp co c2 cA cA csp co csqr cfv
      cB cB csp co csqr cfv cmul co cmul co caddc co cB cB csp co csqr cfv c2
      cexp co caddc co cA cA csp co csqr cfv c2 cexp co cB cB csp co csqr cfv
      c2 cexp co caddc co c2 cA cA csp co csqr cfv cB cB csp co csqr cfv cmul
      co cmul co caddc co cA cA csp co cB cB csp co caddc co c2 cA cA csp co
      csqr cfv cB cB csp co csqr cfv cmul co cmul co caddc co cA cA csp co csqr
      cfv cB cB csp co csqr cfv cA cA csp co csqr cfv cc0 cA cA csp co cle wbr
      cA cA csp co csqr cfv cr wcel cA chil wcel cc0 cA cA csp co cle wbr
      norm-ii.1 cA hiidge0 ax-mp cA cA csp co cA chil wcel cA cA csp co cr wcel
      norm-ii.1 cA hiidrcl ax-mp sqrcli ax-mp recni cB cB csp co csqr cfv cc0
      cB cB csp co cle wbr cB cB csp co csqr cfv cr wcel cB chil wcel cc0 cB cB
      csp co cle wbr norm-ii.2 cB hiidge0 ax-mp cB cB csp co cB chil wcel cB cB
      csp co cr wcel norm-ii.2 cB hiidrcl ax-mp sqrcli ax-mp recni binom2i cA
      cA csp co csqr cfv c2 cexp co c2 cA cA csp co csqr cfv cB cB csp co csqr
      cfv cmul co cmul co cB cB csp co csqr cfv c2 cexp co cA cA csp co csqr
      cfv cA cA csp co csqr cfv cc0 cA cA csp co cle wbr cA cA csp co csqr cfv
      cr wcel cA chil wcel cc0 cA cA csp co cle wbr norm-ii.1 cA hiidge0 ax-mp
      cA cA csp co cA chil wcel cA cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp
      sqrcli ax-mp recni sqcli c2 cA cA csp co csqr cfv cB cB csp co csqr cfv
      cmul co 2cn cA cA csp co csqr cfv cB cB csp co csqr cfv cA cA csp co csqr
      cfv cc0 cA cA csp co cle wbr cA cA csp co csqr cfv cr wcel cA chil wcel
      cc0 cA cA csp co cle wbr norm-ii.1 cA hiidge0 ax-mp cA cA csp co cA chil
      wcel cA cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp sqrcli ax-mp recni
      cB cB csp co csqr cfv cc0 cB cB csp co cle wbr cB cB csp co csqr cfv cr
      wcel cB chil wcel cc0 cB cB csp co cle wbr norm-ii.2 cB hiidge0 ax-mp cB
      cB csp co cB chil wcel cB cB csp co cr wcel norm-ii.2 cB hiidrcl ax-mp
      sqrcli ax-mp recni mulcli mulcli cB cB csp co csqr cfv cB cB csp co csqr
      cfv cc0 cB cB csp co cle wbr cB cB csp co csqr cfv cr wcel cB chil wcel
      cc0 cB cB csp co cle wbr norm-ii.2 cB hiidge0 ax-mp cB cB csp co cB chil
      wcel cB cB csp co cr wcel norm-ii.2 cB hiidrcl ax-mp sqrcli ax-mp recni
      sqcli add23i cA cA csp co csqr cfv c2 cexp co cB cB csp co csqr cfv c2
      cexp co caddc co cA cA csp co cB cB csp co caddc co c2 cA cA csp co csqr
      cfv cB cB csp co csqr cfv cmul co cmul co caddc cA cA csp co csqr cfv c2
      cexp co cA cA csp co cB cB csp co csqr cfv c2 cexp co cB cB csp co caddc
      cc0 cA cA csp co cle wbr cA cA csp co csqr cfv c2 cexp co cA cA csp co
      wceq cA chil wcel cc0 cA cA csp co cle wbr norm-ii.1 cA hiidge0 ax-mp cA
      cA csp co cA chil wcel cA cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp
      sqsqri ax-mp cc0 cB cB csp co cle wbr cB cB csp co csqr cfv c2 cexp co cB
      cB csp co wceq cB chil wcel cc0 cB cB csp co cle wbr norm-ii.2 cB hiidge0
      ax-mp cB cB csp co cB chil wcel cB cB csp co cr wcel norm-ii.2 cB hiidrcl
      ax-mp sqsqri ax-mp opreq12i opreq1i 3eqtri 3brtr4i cc0 cA cB cva co cA cB
      cva co csp co cle wbr cc0 cA cA csp co csqr cfv cB cB csp co csqr cfv
      caddc co c2 cexp co cle wbr cA cB cva co cA cB cva co csp co cA cA csp co
      csqr cfv cB cB csp co csqr cfv caddc co c2 cexp co cle wbr cA cB cva co
      cA cB cva co csp co csqr cfv cA cA csp co csqr cfv cB cB csp co csqr cfv
      caddc co c2 cexp co csqr cfv cle wbr wb cA cB cva co chil wcel cc0 cA cB
      cva co cA cB cva co csp co cle wbr cA cB norm-ii.1 norm-ii.2 hvaddcli cA
      cB cva co hiidge0 ax-mp cA cA csp co csqr cfv cB cB csp co csqr cfv caddc
      co cA cA csp co csqr cfv cB cB csp co csqr cfv cc0 cA cA csp co cle wbr
      cA cA csp co csqr cfv cr wcel cA chil wcel cc0 cA cA csp co cle wbr
      norm-ii.1 cA hiidge0 ax-mp cA cA csp co cA chil wcel cA cA csp co cr wcel
      norm-ii.1 cA hiidrcl ax-mp sqrcli ax-mp cc0 cB cB csp co cle wbr cB cB
      csp co csqr cfv cr wcel cB chil wcel cc0 cB cB csp co cle wbr norm-ii.2
      cB hiidge0 ax-mp cB cB csp co cB chil wcel cB cB csp co cr wcel norm-ii.2
      cB hiidrcl ax-mp sqrcli ax-mp readdcli sqge0i cA cB cva co cA cB cva co
      csp co cA cA csp co csqr cfv cB cB csp co csqr cfv caddc co c2 cexp co cA
      cB cva co chil wcel cA cB cva co cA cB cva co csp co cr wcel cA cB
      norm-ii.1 norm-ii.2 hvaddcli cA cB cva co hiidrcl ax-mp cA cA csp co csqr
      cfv cB cB csp co csqr cfv caddc co cA cA csp co csqr cfv cB cB csp co
      csqr cfv cc0 cA cA csp co cle wbr cA cA csp co csqr cfv cr wcel cA chil
      wcel cc0 cA cA csp co cle wbr norm-ii.1 cA hiidge0 ax-mp cA cA csp co cA
      chil wcel cA cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp sqrcli ax-mp
      cc0 cB cB csp co cle wbr cB cB csp co csqr cfv cr wcel cB chil wcel cc0
      cB cB csp co cle wbr norm-ii.2 cB hiidge0 ax-mp cB cB csp co cB chil wcel
      cB cB csp co cr wcel norm-ii.2 cB hiidrcl ax-mp sqrcli ax-mp readdcli
      resqcli sqrlei mp2an mpbi cc0 cA cA csp co csqr cfv cB cB csp co csqr cfv
      caddc co cle wbr cA cA csp co csqr cfv cB cB csp co csqr cfv caddc co c2
      cexp co csqr cfv cA cA csp co csqr cfv cB cB csp co csqr cfv caddc co
      wceq cc0 cA cA csp co csqr cfv cle wbr cc0 cB cB csp co csqr cfv cle wbr
      cc0 cA cA csp co csqr cfv cB cB csp co csqr cfv caddc co cle wbr cc0 cA
      cA csp co cle wbr cc0 cA cA csp co csqr cfv cle wbr cA chil wcel cc0 cA
      cA csp co cle wbr norm-ii.1 cA hiidge0 ax-mp cA cA csp co cA chil wcel cA
      cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp sqrge0i ax-mp cc0 cB cB csp
      co cle wbr cc0 cB cB csp co csqr cfv cle wbr cB chil wcel cc0 cB cB csp
      co cle wbr norm-ii.2 cB hiidge0 ax-mp cB cB csp co cB chil wcel cB cB csp
      co cr wcel norm-ii.2 cB hiidrcl ax-mp sqrge0i ax-mp cA cA csp co csqr cfv
      cB cB csp co csqr cfv cc0 cA cA csp co cle wbr cA cA csp co csqr cfv cr
      wcel cA chil wcel cc0 cA cA csp co cle wbr norm-ii.1 cA hiidge0 ax-mp cA
      cA csp co cA chil wcel cA cA csp co cr wcel norm-ii.1 cA hiidrcl ax-mp
      sqrcli ax-mp cc0 cB cB csp co cle wbr cB cB csp co csqr cfv cr wcel cB
      chil wcel cc0 cB cB csp co cle wbr norm-ii.2 cB hiidge0 ax-mp cB cB csp
      co cB chil wcel cB cB csp co cr wcel norm-ii.2 cB hiidrcl ax-mp sqrcli
      ax-mp addge0i mp2an cA cA csp co csqr cfv cB cB csp co csqr cfv caddc co
      cA cA csp co csqr cfv cB cB csp co csqr cfv cc0 cA cA csp co cle wbr cA
      cA csp co csqr cfv cr wcel cA chil wcel cc0 cA cA csp co cle wbr
      norm-ii.1 cA hiidge0 ax-mp cA cA csp co cA chil wcel cA cA csp co cr wcel
      norm-ii.1 cA hiidrcl ax-mp sqrcli ax-mp cc0 cB cB csp co cle wbr cB cB
      csp co csqr cfv cr wcel cB chil wcel cc0 cB cB csp co cle wbr norm-ii.2
      cB hiidge0 ax-mp cB cB csp co cB chil wcel cB cB csp co cr wcel norm-ii.2
      cB hiidrcl ax-mp sqrcli ax-mp readdcli sqrsqi ax-mp breqtri cA cB cva co
      chil wcel cA cB cva co cno cfv cA cB cva co cA cB cva co csp co csqr cfv
      wceq cA cB norm-ii.1 norm-ii.2 hvaddcli cA cB cva co normval ax-mp cA cno
      cfv cA cA csp co csqr cfv cB cno cfv cB cB csp co csqr cfv caddc cA chil
      wcel cA cno cfv cA cA csp co csqr cfv wceq norm-ii.1 cA normval ax-mp cB
      chil wcel cB cno cfv cB cB csp co csqr cfv wceq norm-ii.2 cB normval
      ax-mp opreq12i 3brtr4i $.
      $( [11-Aug-1999] $)
  $}

  $( Triangle inequality for norms.  Theorem 3.3(ii) of [Beran] p. 97. $)
  norm-ii $p |- ( ( A e. ~H /\ B e. ~H ) ->
               ( normh ` ( A +h B ) ) <_ ( ( normh ` A ) + ( normh ` B ) ) ) $=
    cA chil wcel cB chil wcel cA cB cva co cno cfv cA cno cfv cB cno cfv caddc
    co cle wbr cA chil wcel cA c0v cif cB cva co cno cfv cA chil wcel cA c0v
    cif cno cfv cB cno cfv caddc co cle wbr cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cva co cno cfv cA chil wcel cA c0v cif cno cfv cB chil wcel
    cB c0v cif cno cfv caddc co cle wbr cA cB c0v c0v cA cA chil wcel cA c0v
    cif wceq cA cB cva co cno cfv cA chil wcel cA c0v cif cB cva co cno cfv cA
    cno cfv cB cno cfv caddc co cA chil wcel cA c0v cif cno cfv cB cno cfv
    caddc co cle cA cA chil wcel cA c0v cif wceq cA cB cva co cA chil wcel cA
    c0v cif cB cva co cno cA cA chil wcel cA c0v cif cB cva opreq1 fveq2d cA cA
    chil wcel cA c0v cif wceq cA cno cfv cA chil wcel cA c0v cif cno cfv cB cno
    cfv caddc cA cA chil wcel cA c0v cif cno fveq2 opreq1d breq12d cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cva co cno cfv cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cva co cno cfv cA chil wcel cA c0v cif
    cno cfv cB cno cfv caddc co cA chil wcel cA c0v cif cno cfv cB chil wcel cB
    c0v cif cno cfv caddc co cle cB cB chil wcel cB c0v cif wceq cA chil wcel
    cA c0v cif cB cva co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co
    cno cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cva opreq2 fveq2d cB
    cB chil wcel cB c0v cif wceq cB cno cfv cB chil wcel cB c0v cif cno cfv cA
    chil wcel cA c0v cif cno cfv caddc cB cB chil wcel cB c0v cif cno fveq2
    opreq2d breq12d cA chil wcel cA c0v cif cB chil wcel cB c0v cif cA c0v chil
    ax-hv0cl elimel cB c0v chil ax-hv0cl elimel norm-ii.i dedth2h $.
    $( [11-Mar-2006] $) $( [10-Mar-2006] $)

  ${
    norm-iii.1 $e |- A e. CC $.
    norm-iii.2 $e |- B e. ~H $.
    $( Theorem 3.3(iii) of [Beran] p. 97. $)
    norm-iii.i $p |- ( normh ` ( A .h B ) )
         = ( ( abs ` A ) x. ( normh ` B ) ) $=
      cA cB csm co cA cB csm co csp co csqr cfv cA cA ccj cfv cmul co csqr cfv
      cB cB csp co csqr cfv cmul co cA cB csm co cno cfv cA cabs cfv cB cno cfv
      cmul co cA cB csm co cA cB csm co csp co csqr cfv cA cA ccj cfv cmul co
      cB cB csp co cmul co csqr cfv cA cA ccj cfv cmul co csqr cfv cB cB csp co
      csqr cfv cmul co cA cB csm co cA cB csm co csp co cA cA ccj cfv cmul co
      cB cB csp co cmul co csqr cA cA cB cB norm-iii.1 norm-iii.1 norm-iii.2
      norm-iii.2 his35i fveq2i cA cA ccj cfv cmul co cB cB csp co cA norm-iii.1
      cjmulrcli cB chil wcel cB cB csp co cr wcel norm-iii.2 cB hiidrcl ax-mp
      cA norm-iii.1 cjmulge0i cB chil wcel cc0 cB cB csp co cle wbr norm-iii.2
      cB hiidge0 ax-mp sqrmulii eqtri cA cB csm co chil wcel cA cB csm co cno
      cfv cA cB csm co cA cB csm co csp co csqr cfv wceq cA cB norm-iii.1
      norm-iii.2 hvmulcli cA cB csm co normval ax-mp cA cabs cfv cA cA ccj cfv
      cmul co csqr cfv cB cno cfv cB cB csp co csqr cfv cmul cA cc wcel cA cabs
      cfv cA cA ccj cfv cmul co csqr cfv wceq norm-iii.1 cA absval ax-mp cB
      chil wcel cB cno cfv cB cB csp co csqr cfv wceq norm-iii.2 cB normval
      ax-mp opreq12i 3eqtr4i $.
      $( [29-Jul-1999] $)
  $}

  $( Theorem 3.3(iii) of [Beran] p. 97. $)
  norm-iii $p |- ( ( A e. CC /\ B e. ~H )
             -> ( normh ` ( A .h B ) ) = ( ( abs ` A ) x. ( normh ` B ) ) ) $=
    cA cc wcel cB chil wcel cA cB csm co cno cfv cA cabs cfv cB cno cfv cmul co
    wceq cA cc wcel cA cc0 cif cB csm co cno cfv cA cc wcel cA cc0 cif cabs cfv
    cB cno cfv cmul co wceq cA cc wcel cA cc0 cif cB chil wcel cB c0v cif csm
    co cno cfv cA cc wcel cA cc0 cif cabs cfv cB chil wcel cB c0v cif cno cfv
    cmul co wceq cA cB cc0 c0v cA cA cc wcel cA cc0 cif wceq cA cB csm co cno
    cfv cA cc wcel cA cc0 cif cB csm co cno cfv cA cabs cfv cB cno cfv cmul co
    cA cc wcel cA cc0 cif cabs cfv cB cno cfv cmul co cA cA cc wcel cA cc0 cif
    wceq cA cB csm co cA cc wcel cA cc0 cif cB csm co cno cA cA cc wcel cA cc0
    cif cB csm opreq1 fveq2d cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc
    wcel cA cc0 cif cabs cfv cB cno cfv cmul cA cA cc wcel cA cc0 cif cabs
    fveq2 opreq1d eqeq12d cB cB chil wcel cB c0v cif wceq cA cc wcel cA cc0 cif
    cB csm co cno cfv cA cc wcel cA cc0 cif cB chil wcel cB c0v cif csm co cno
    cfv cA cc wcel cA cc0 cif cabs cfv cB cno cfv cmul co cA cc wcel cA cc0 cif
    cabs cfv cB chil wcel cB c0v cif cno cfv cmul co cB cB chil wcel cB c0v cif
    wceq cA cc wcel cA cc0 cif cB csm co cA cc wcel cA cc0 cif cB chil wcel cB
    c0v cif csm co cno cB cB chil wcel cB c0v cif cA cc wcel cA cc0 cif csm
    opreq2 fveq2d cB cB chil wcel cB c0v cif wceq cB cno cfv cB chil wcel cB
    c0v cif cno cfv cA cc wcel cA cc0 cif cabs cfv cmul cB cB chil wcel cB c0v
    cif cno fveq2 opreq2d eqeq12d cA cc wcel cA cc0 cif cB chil wcel cB c0v cif
    cA cc0 cc 0cn elimel cB c0v chil ax-hv0cl elimel norm-iii.i dedth2h $.
    $( [25-Oct-1999] $)

  ${
    normsub.1 $e |- A e. ~H $.
    normsub.2 $e |- B e. ~H $.
    $( Negative doesn't change the norm of a Hilbert space vector. $)
    normsubi $p |- ( normh ` ( A -h B ) ) = ( normh ` ( B -h A ) ) $=
      cA cB cmv co cno cfv c1 cneg cabs cfv cB cA cmv co cno cfv cmul co c1 cB
      cA cmv co cno cfv cmul co cB cA cmv co cno cfv c1 cneg cB cA cmv co csm
      co cno cfv cA cB cmv co cno cfv c1 cneg cabs cfv cB cA cmv co cno cfv
      cmul co c1 cneg cB cA cmv co csm co cA cB cmv co cno cB cA normsub.2
      normsub.1 hvnegdii fveq2i c1 cneg cB cA cmv co c1 ax1cn negcli cB cA
      normsub.2 normsub.1 hvsubcli norm-iii.i eqtr3i c1 cneg cabs cfv c1 cB cA
      cmv co cno cfv cmul c1 cneg cabs cfv c1 cabs cfv c1 c1 ax1cn absnegi cc0
      c1 cle wbr c1 cabs cfv c1 wceq cc0 c1 0re 1re lt01 ltleii c1 1re absidi
      ax-mp eqtri opreq1i cB cA cmv co cno cfv cB cA cmv co cno cfv cB cA cmv
      co cB cA normsub.2 normsub.1 hvsubcli normcli recni mulid2i 3eqtri $.
      $( [11-Aug-1999] $)

    $( Analogy to Pythagorean theorem for orthogonal vectors.  Remark 3.4(C) of
       [Beran] p. 98. $)
    normpythi $p |- ( ( A .ih B ) = 0 -> ( ( normh ` ( A +h B ) ) ^ 2 ) =
                   ( ( ( normh ` A ) ^ 2 ) + ( ( normh ` B ) ^ 2 ) ) ) $=
      cA cB csp co cc0 wceq cA cB cva co cA cB cva co csp co cA cA csp co cB cB
      csp co caddc co cA cB cva co cno cfv c2 cexp co cA cno cfv c2 cexp co cB
      cno cfv c2 cexp co caddc co cA cB csp co cc0 wceq cA cA csp co cB cB csp
      co caddc co cA cB csp co cB cA csp co caddc co caddc co cA cA csp co cB
      cB csp co caddc co cA cB cva co cA cB cva co csp co cA cB csp co cc0 wceq
      cA cA csp co cB cB csp co caddc co cA cB csp co cB cA csp co caddc co
      caddc co cA cA csp co cB cB csp co caddc co cc0 caddc co cA cA csp co cB
      cB csp co caddc co cA cB csp co cc0 wceq cA cB csp co cB cA csp co caddc
      co cc0 cA cA csp co cB cB csp co caddc co caddc cA cB csp co cc0 wceq cA
      cB csp co cB cA csp co caddc co cc0 cc0 caddc co cc0 cA cB csp co cc0
      wceq cA cB csp co cc0 cB cA csp co cc0 caddc cA cB csp co cc0 wceq id cA
      cB csp co cc0 wceq cB cA csp co cc0 wceq cA chil wcel cB chil wcel cA cB
      csp co cc0 wceq cB cA csp co cc0 wceq wb normsub.1 normsub.2 cA cB
      orthcom mp2an biimpi opreq12d cc0 0cn addid1i syl6eq opreq2d cA cA csp co
      cB cB csp co caddc co cA cA csp co cB cB csp co cA cA normsub.1 normsub.1
      hicli cB cB normsub.2 normsub.2 hicli addcli addid1i syl6eq cA cB cA cB
      normsub.1 normsub.2 normsub.1 normsub.2 normlem8 syl5eq cA cB cva co cA
      cB normsub.1 normsub.2 hvaddcli normsqi cA cno cfv c2 cexp co cA cA csp
      co cB cno cfv c2 cexp co cB cB csp co caddc cA normsub.1 normsqi cB
      normsub.2 normsqi opreq12i 3eqtr4g $.
      $( [17-Oct-1999] $)
  $}

  $( Swapping order of subtraction doesn't change the norm of a vector. $)
  normsub $p |- ( ( A e. ~H /\ B e. ~H ) ->
                 ( normh ` ( A -h B ) ) = ( normh ` ( B -h A ) ) ) $=
    cA chil wcel cB chil wcel cA cB cmv co cno cfv cB cA cmv co cno cfv wceq cA
    chil wcel cA c0v cif cB cmv co cno cfv cB cA chil wcel cA c0v cif cmv co
    cno cfv wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv
    cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv co cno cfv wceq cA cB
    c0v c0v cA cA chil wcel cA c0v cif wceq cA cB cmv co cno cfv cA chil wcel
    cA c0v cif cB cmv co cno cfv cB cA cmv co cno cfv cB cA chil wcel cA c0v
    cif cmv co cno cfv cA cA chil wcel cA c0v cif wceq cA cB cmv co cA chil
    wcel cA c0v cif cB cmv co cno cA cA chil wcel cA c0v cif cB cmv opreq1
    fveq2d cA cA chil wcel cA c0v cif wceq cB cA cmv co cB cA chil wcel cA c0v
    cif cmv co cno cA cA chil wcel cA c0v cif cB cmv opreq2 fveq2d eqeq12d cB
    cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cno cfv cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cB cA chil wcel
    cA c0v cif cmv co cno cfv cB chil wcel cB c0v cif cA chil wcel cA c0v cif
    cmv co cno cfv cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cB cB
    chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d cB cB chil
    wcel cB c0v cif wceq cB cA chil wcel cA c0v cif cmv co cB chil wcel cB c0v
    cif cA chil wcel cA c0v cif cmv co cno cB cB chil wcel cB c0v cif cA chil
    wcel cA c0v cif cmv opreq1 fveq2d eqeq12d cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel
    normsubi dedth2h $.
    $( [14-Aug-1999] $)

  $( The norm of a vector equals the norm of its negative. $)
  normneg $p |- ( A e. ~H ->
                 ( normh ` ( -u 1 .h A ) ) = ( normh ` A ) ) $=
    cA chil wcel c0v cA cmv co cno cfv cA c0v cmv co cno cfv c1 cneg cA csm co
    cno cfv cA cno cfv c0v chil wcel cA chil wcel c0v cA cmv co cno cfv cA c0v
    cmv co cno cfv wceq ax-hv0cl c0v cA normsub mpan cA chil wcel c0v cA cmv co
    c1 cneg cA csm co cno cA hv2neg fveq2d cA chil wcel cA c0v cmv co cA cno cA
    hvsub0 fveq2d 3eqtr3d $.
    $( [10-Jun-2005] $) $( [23-May-2005] $)

  $( Analogy to Pythagorean theorem for orthogonal vectors.  Remark 3.4(C) of
     [Beran] p. 98. $)
  normpyth $p |- ( ( A e. ~H /\ B e. ~H ) ->
                 ( ( A .ih B ) = 0 -> ( ( normh ` ( A +h B ) ) ^ 2 ) =
                 ( ( ( normh ` A ) ^ 2 ) + ( ( normh ` B ) ^ 2 ) ) ) ) $=
    cA chil wcel cB chil wcel cA cB csp co cc0 wceq cA cB cva co cno cfv c2
    cexp co cA cno cfv c2 cexp co cB cno cfv c2 cexp co caddc co wceq wi cA
    chil wcel cA c0v cif cB csp co cc0 wceq cA chil wcel cA c0v cif cB cva co
    cno cfv c2 cexp co cA chil wcel cA c0v cif cno cfv c2 cexp co cB cno cfv c2
    cexp co caddc co wceq wi cA chil wcel cA c0v cif cB chil wcel cB c0v cif
    csp co cc0 wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno
    cfv c2 cexp co cA chil wcel cA c0v cif cno cfv c2 cexp co cB chil wcel cB
    c0v cif cno cfv c2 cexp co caddc co wceq wi cA cB c0v c0v cA cA chil wcel
    cA c0v cif wceq cA cB csp co cc0 wceq cA chil wcel cA c0v cif cB csp co cc0
    wceq cA cB cva co cno cfv c2 cexp co cA cno cfv c2 cexp co cB cno cfv c2
    cexp co caddc co wceq cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co
    cA chil wcel cA c0v cif cno cfv c2 cexp co cB cno cfv c2 cexp co caddc co
    wceq cA cA chil wcel cA c0v cif wceq cA cB csp co cA chil wcel cA c0v cif
    cB csp co cc0 cA cA chil wcel cA c0v cif cB csp opreq1 eqeq1d cA cA chil
    wcel cA c0v cif wceq cA cB cva co cno cfv c2 cexp co cA chil wcel cA c0v
    cif cB cva co cno cfv c2 cexp co cA cno cfv c2 cexp co cB cno cfv c2 cexp
    co caddc co cA chil wcel cA c0v cif cno cfv c2 cexp co cB cno cfv c2 cexp
    co caddc co cA cA chil wcel cA c0v cif wceq cA cB cva co cno cfv cA chil
    wcel cA c0v cif cB cva co cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq
    cA cB cva co cA chil wcel cA c0v cif cB cva co cno cA cA chil wcel cA c0v
    cif cB cva opreq1 fveq2d opreq1d cA cA chil wcel cA c0v cif wceq cA cno cfv
    c2 cexp co cA chil wcel cA c0v cif cno cfv c2 cexp co cB cno cfv c2 cexp co
    caddc cA cA chil wcel cA c0v cif wceq cA cno cfv cA chil wcel cA c0v cif
    cno cfv c2 cexp cA cA chil wcel cA c0v cif cno fveq2 opreq1d opreq1d
    eqeq12d imbi12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    csp co cc0 wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cc0
    wceq cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co cA chil wcel cA
    c0v cif cno cfv c2 cexp co cB cno cfv c2 cexp co caddc co wceq cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cva co cno cfv c2 cexp co cA chil wcel
    cA c0v cif cno cfv c2 cexp co cB chil wcel cB c0v cif cno cfv c2 cexp co
    caddc co wceq cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cc0 cB cB
    chil wcel cB c0v cif cA chil wcel cA c0v cif csp opreq2 eqeq1d cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co
    cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno cfv c2 cexp co
    cA chil wcel cA c0v cif cno cfv c2 cexp co cB cno cfv c2 cexp co caddc co
    cA chil wcel cA c0v cif cno cfv c2 cexp co cB chil wcel cB c0v cif cno cfv
    c2 cexp co caddc co cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif
    cB cva co cno cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co
    cno cfv c2 cexp cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    cva co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno cB cB
    chil wcel cB c0v cif cA chil wcel cA c0v cif cva opreq2 fveq2d opreq1d cB
    cB chil wcel cB c0v cif wceq cB cno cfv c2 cexp co cB chil wcel cB c0v cif
    cno cfv c2 cexp co cA chil wcel cA c0v cif cno cfv c2 cexp co caddc cB cB
    chil wcel cB c0v cif wceq cB cno cfv cB chil wcel cB c0v cif cno cfv c2
    cexp cB cB chil wcel cB c0v cif cno fveq2 opreq1d opreq2d eqeq12d imbi12d
    cA chil wcel cA c0v cif cB chil wcel cB c0v cif cA c0v chil ax-hv0cl elimel
    cB c0v chil ax-hv0cl elimel normpythi dedth2h $.
    $( [17-Oct-1999] $)

  $( Corollary to Pythagorean theorem for orthogonal vectors.  Remark 3.4(C) of
     [Beran] p. 98. $)
  normpyc $p |- ( ( A e. ~H /\ B e. ~H ) ->
            ( ( A .ih B ) = 0 -> ( normh ` A ) <_ ( normh ` ( A +h B ) ) ) ) $=
    cA chil wcel cB chil wcel wa cA cB csp co cc0 wceq cA cno cfv c2 cexp co cA
    cB cva co cno cfv c2 cexp co cle wbr cA cno cfv cA cB cva co cno cfv cle
    wbr cA chil wcel cB chil wcel wa cA cB csp co cc0 wceq cA cno cfv c2 cexp
    co cA cB cva co cno cfv c2 cexp co cle wbr cA chil wcel cB chil wcel wa cA
    cB csp co cc0 wceq wa cA cno cfv c2 cexp co cA cno cfv c2 cexp co cB cno
    cfv c2 cexp co caddc co cA cB cva co cno cfv c2 cexp co cle cA chil wcel cB
    chil wcel wa cA cno cfv c2 cexp co cA cno cfv c2 cexp co cB cno cfv c2 cexp
    co caddc co cle wbr cA cB csp co cc0 wceq cA chil wcel cB chil wcel wa cA
    cno cfv c2 cexp co cc0 caddc co cA cno cfv c2 cexp co cA cno cfv c2 cexp co
    cB cno cfv c2 cexp co caddc co cle cA chil wcel cA cno cfv c2 cexp co cc0
    caddc co cA cno cfv c2 cexp co wceq cB chil wcel cA chil wcel cA cno cfv c2
    cexp co cc wcel cA cno cfv c2 cexp co cc0 caddc co cA cno cfv c2 cexp co
    wceq cA chil wcel cA cno cfv c2 cexp co cA chil wcel cA cno cfv cr wcel cA
    cno cfv c2 cexp co cr wcel cA normcl cA cno cfv resqcl syl recnd cA cno cfv
    c2 cexp co addid1 syl adantr cA chil wcel cB chil wcel wa cc0 cB cno cfv c2
    cexp co cle wbr cA cno cfv c2 cexp co cc0 caddc co cA cno cfv c2 cexp co cB
    cno cfv c2 cexp co caddc co cle wbr cB chil wcel cc0 cB cno cfv c2 cexp co
    cle wbr cA chil wcel cB chil wcel cB cno cfv cr wcel cc0 cB cno cfv c2 cexp
    co cle wbr cB normcl cB cno cfv sqge0 syl adantl cA cno cfv c2 cexp co cr
    wcel cB cno cfv c2 cexp co cr wcel cc0 cB cno cfv c2 cexp co cle wbr cA cno
    cfv c2 cexp co cc0 caddc co cA cno cfv c2 cexp co cB cno cfv c2 cexp co
    caddc co cle wbr wb cA chil wcel cB chil wcel cB cno cfv c2 cexp co cr wcel
    cA cno cfv c2 cexp co cr wcel cc0 cB cno cfv c2 cexp co cle wbr cA cno cfv
    c2 cexp co cc0 caddc co cA cno cfv c2 cexp co cB cno cfv c2 cexp co caddc
    co cle wbr wb cc0 cr wcel cB cno cfv c2 cexp co cr wcel cA cno cfv c2 cexp
    co cr wcel cc0 cB cno cfv c2 cexp co cle wbr cA cno cfv c2 cexp co cc0
    caddc co cA cno cfv c2 cexp co cB cno cfv c2 cexp co caddc co cle wbr wb
    0re cc0 cB cno cfv c2 cexp co cA cno cfv c2 cexp co leadd2 mp3an1 ancoms cA
    chil wcel cA cno cfv cr wcel cA cno cfv c2 cexp co cr wcel cA normcl cA cno
    cfv resqcl syl cB chil wcel cB cno cfv cr wcel cB cno cfv c2 cexp co cr
    wcel cB normcl cB cno cfv resqcl syl syl2an mpbid eqbrtrrd adantr cA chil
    wcel cB chil wcel wa cA cB csp co cc0 wceq cA cB cva co cno cfv c2 cexp co
    cA cno cfv c2 cexp co cB cno cfv c2 cexp co caddc co wceq cA cB normpyth
    imp breqtrrd ex cA cno cfv cr wcel cc0 cA cno cfv cle wbr cA cB cva co cno
    cfv cr wcel cc0 cA cB cva co cno cfv cle wbr cA cno cfv cA cB cva co cno
    cfv cle wbr cA cno cfv c2 cexp co cA cB cva co cno cfv c2 cexp co cle wbr
    wb cA chil wcel cB chil wcel wa cA cno cfv cA cB cva co cno cfv le2sq cA
    chil wcel cA cno cfv cr wcel cB chil wcel cA normcl adantr cA chil wcel cc0
    cA cno cfv cle wbr cB chil wcel cA normge0 adantr cA chil wcel cB chil wcel
    wa cA cB cva co chil wcel cA cB cva co cno cfv cr wcel cA cB hvaddcl cA cB
    cva co normcl syl cA chil wcel cB chil wcel wa cA cB cva co chil wcel cc0
    cA cB cva co cno cfv cle wbr cA cB hvaddcl cA cB cva co normge0 syl syl2anc
    sylibrd $.
    $( [26-Oct-1999] $)

  ${
    norm3dif.1 $e |- A e. ~H $.
    norm3dif.2 $e |- B e. ~H $.
    norm3dif.3 $e |- C e. ~H $.
    $( Norm of differences around common element.  Part of Lemma 3.6 of
       [Beran] p. 101. $)
    norm3difi $p |- ( normh ` ( A -h B ) ) <_ ( ( normh ` ( A -h C ) ) +
                   ( normh ` ( C -h B ) ) ) $=
      cA cB cmv co cno cfv cA cC cmv co cC cB cmv co cva co cno cfv cA cC cmv
      co cno cfv cC cB cmv co cno cfv caddc co cle cA cB cmv co cA cC cmv co cC
      cB cmv co cva co cno cA c1 cneg cB csm co cva co cA c1 cneg cC csm co cva
      co cC c1 cneg cB csm co cva co cva co cA cB cmv co cA cC cmv co cC cB cmv
      co cva co cA c1 cneg cC csm co cva co cC c1 cneg cB csm co cva co cva co
      cA c1 cneg cC csm co cC c1 cneg cB csm co cva co cva co cva co cA c1 cneg
      cB csm co cva co cA c1 cneg cC csm co cC c1 cneg cB csm co cva co
      norm3dif.1 c1 cneg cC c1 ax1cn negcli norm3dif.3 hvmulcli cC c1 cneg cB
      csm co norm3dif.3 c1 cneg cB c1 ax1cn negcli norm3dif.2 hvmulcli hvaddcli
      hvassi c1 cneg cC csm co cC c1 cneg cB csm co cva co cva co c1 cneg cB
      csm co cA cva c1 cneg cC csm co cC cva co c1 cneg cB csm co cva co c1
      cneg cC csm co cC c1 cneg cB csm co cva co cva co c1 cneg cB csm co c1
      cneg cC csm co cC c1 cneg cB csm co c1 cneg cC c1 ax1cn negcli norm3dif.3
      hvmulcli norm3dif.3 c1 cneg cB c1 ax1cn negcli norm3dif.2 hvmulcli hvassi
      c1 cneg cC csm co cC cva co c1 cneg cB csm co cva co c0v c1 cneg cB csm
      co cva co c1 cneg cB csm co c0v cva co c1 cneg cB csm co c1 cneg cC csm
      co cC cva co c0v c1 cneg cB csm co cva c1 cneg cC csm co cC cva co cC c1
      cneg cC csm co cva co cC cC cmv co c0v c1 cneg cC csm co cC c1 cneg cC c1
      ax1cn negcli norm3dif.3 hvmulcli norm3dif.3 hvcomi cC cC norm3dif.3
      norm3dif.3 hvsubvali cC chil wcel cC cC cmv co c0v wceq norm3dif.3 cC
      hvsubid ax-mp 3eqtr2i opreq1i c0v c1 cneg cB csm co ax-hv0cl c1 cneg cB
      c1 ax1cn negcli norm3dif.2 hvmulcli hvcomi c1 cneg cB csm co chil wcel c1
      cneg cB csm co c0v cva co c1 cneg cB csm co wceq c1 cneg cB c1 ax1cn
      negcli norm3dif.2 hvmulcli c1 cneg cB csm co ax-hvaddid ax-mp 3eqtri
      eqtr3i opreq2i eqtr2i cA cB norm3dif.1 norm3dif.2 hvsubvali cA cC cmv co
      cA c1 cneg cC csm co cva co cC cB cmv co cC c1 cneg cB csm co cva co cva
      cA cC norm3dif.1 norm3dif.3 hvsubvali cC cB norm3dif.3 norm3dif.2
      hvsubvali opreq12i 3eqtr4i fveq2i cA cC cmv co cC cB cmv co cA cC
      norm3dif.1 norm3dif.3 hvsubcli cC cB norm3dif.3 norm3dif.2 hvsubcli
      norm-ii.i eqbrtri $.
      $( [16-Aug-1999] $)

    $( Norm of differences around common element.  Part of Lemma 3.6 of [Beran]
       p. 101. $)
    norm3adifii $p |- ( abs ` ( ( normh ` ( A -h C ) ) -
         ( normh ` ( B -h C ) ) ) ) <_ ( normh ` ( A -h B ) ) $=
      cA cC cmv co cno cfv cB cC cmv co cno cfv cmin co cabs cfv cA cB cmv co
      cno cfv cle wbr cA cB cmv co cno cfv cneg cA cC cmv co cno cfv cB cC cmv
      co cno cfv cmin co cle wbr cA cC cmv co cno cfv cB cC cmv co cno cfv cmin
      co cA cB cmv co cno cfv cle wbr cA cC cmv co cno cfv cB cC cmv co cno cfv
      cmin co cA cB cmv co cno cfv cA cC cmv co cno cfv cB cC cmv co cno cfv cA
      cC cmv co cA cC norm3dif.1 norm3dif.3 hvsubcli normcli cB cC cmv co cB cC
      norm3dif.2 norm3dif.3 hvsubcli normcli resubcli cA cB cmv co cA cB
      norm3dif.1 norm3dif.2 hvsubcli normcli abslei cA cC cmv co cno cfv cB cC
      cmv co cno cfv cmin co cneg cA cB cmv co cno cfv cle wbr cA cB cmv co cno
      cfv cneg cA cC cmv co cno cfv cB cC cmv co cno cfv cmin co cle wbr cA cC
      cmv co cno cfv cB cC cmv co cno cfv cmin co cneg cB cC cmv co cno cfv cA
      cC cmv co cno cfv cmin co cA cB cmv co cno cfv cle cA cC cmv co cno cfv
      cB cC cmv co cno cfv cA cC cmv co cno cfv cA cC cmv co cA cC norm3dif.1
      norm3dif.3 hvsubcli normcli recni cB cC cmv co cno cfv cB cC cmv co cB cC
      norm3dif.2 norm3dif.3 hvsubcli normcli recni negsubdi2i cB cC cmv co cno
      cfv cA cC cmv co cno cfv cmin co cA cB cmv co cno cfv cle wbr cB cC cmv
      co cno cfv cA cB cmv co cno cfv cA cC cmv co cno cfv caddc co cle wbr cB
      cC cmv co cno cfv cB cA cmv co cno cfv cA cC cmv co cno cfv caddc co cA
      cB cmv co cno cfv cA cC cmv co cno cfv caddc co cle cB cC cA norm3dif.2
      norm3dif.3 norm3dif.1 norm3difi cB cA cmv co cno cfv cA cB cmv co cno cfv
      cA cC cmv co cno cfv caddc cB cA norm3dif.2 norm3dif.1 normsubi opreq1i
      breqtri cB cC cmv co cno cfv cA cC cmv co cno cfv cA cB cmv co cno cfv cB
      cC cmv co cB cC norm3dif.2 norm3dif.3 hvsubcli normcli cA cC cmv co cA cC
      norm3dif.1 norm3dif.3 hvsubcli normcli cA cB cmv co cA cB norm3dif.1
      norm3dif.2 hvsubcli normcli lesubaddi mpbir eqbrtri cA cC cmv co cno cfv
      cB cC cmv co cno cfv cmin co cA cB cmv co cno cfv cA cC cmv co cno cfv cB
      cC cmv co cno cfv cA cC cmv co cA cC norm3dif.1 norm3dif.3 hvsubcli
      normcli cB cC cmv co cB cC norm3dif.2 norm3dif.3 hvsubcli normcli
      resubcli cA cB cmv co cA cB norm3dif.1 norm3dif.2 hvsubcli normcli
      lenegcon1i mpbi cA cC cmv co cno cfv cB cC cmv co cno cfv cmin co cA cB
      cmv co cno cfv cle wbr cA cC cmv co cno cfv cA cB cmv co cno cfv cB cC
      cmv co cno cfv caddc co cle wbr cA cC cB norm3dif.1 norm3dif.3 norm3dif.2
      norm3difi cA cC cmv co cno cfv cB cC cmv co cno cfv cA cB cmv co cno cfv
      cA cC cmv co cA cC norm3dif.1 norm3dif.3 hvsubcli normcli cB cC cmv co cB
      cC norm3dif.2 norm3dif.3 hvsubcli normcli cA cB cmv co cA cB norm3dif.1
      norm3dif.2 hvsubcli normcli lesubaddi mpbir mpbir2an $.
      $( [30-Sep-1999] $)

    ${
      norm3lem.4 $e |- D e. RR $.
      $( Lemma involving norm of differences in Hilbert space. $)
      norm3lem $p |- ( ( ( normh ` ( A -h C ) ) < ( D / 2 ) /\
                         ( normh ` ( C -h B ) ) < ( D / 2 ) ) ->
                         ( normh ` ( A -h B ) ) < D ) $=
        cA cC cmv co cno cfv cD c2 cdiv co clt wbr cC cB cmv co cno cfv cD c2
        cdiv co clt wbr wa cA cB cmv co cno cfv cD c2 cdiv co cD c2 cdiv co
        caddc co cD clt cA cC cmv co cno cfv cD c2 cdiv co clt wbr cC cB cmv co
        cno cfv cD c2 cdiv co clt wbr wa cA cC cmv co cno cfv cC cB cmv co cno
        cfv caddc co cD c2 cdiv co cD c2 cdiv co caddc co clt wbr cA cB cmv co
        cno cfv cD c2 cdiv co cD c2 cdiv co caddc co clt wbr cA cC cmv co cno
        cfv cC cB cmv co cno cfv cD c2 cdiv co cD c2 cdiv co cA cC cmv co cA cC
        norm3dif.1 norm3dif.3 hvsubcli normcli cC cB cmv co cC cB norm3dif.3
        norm3dif.2 hvsubcli normcli cD c2 norm3lem.4 2re 2ne0 redivcli cD c2
        norm3lem.4 2re 2ne0 redivcli lt2addi cA cB cmv co cno cfv cA cC cmv co
        cno cfv cC cB cmv co cno cfv caddc co cle wbr cA cC cmv co cno cfv cC
        cB cmv co cno cfv caddc co cD c2 cdiv co cD c2 cdiv co caddc co clt wbr
        cA cB cmv co cno cfv cD c2 cdiv co cD c2 cdiv co caddc co clt wbr cA cB
        cC norm3dif.1 norm3dif.2 norm3dif.3 norm3difi cA cB cmv co cno cfv cA
        cC cmv co cno cfv cC cB cmv co cno cfv caddc co cD c2 cdiv co cD c2
        cdiv co caddc co cA cB cmv co cA cB norm3dif.1 norm3dif.2 hvsubcli
        normcli cA cC cmv co cno cfv cC cB cmv co cno cfv cA cC cmv co cA cC
        norm3dif.1 norm3dif.3 hvsubcli normcli cC cB cmv co cC cB norm3dif.3
        norm3dif.2 hvsubcli normcli readdcli cD c2 cdiv co cD c2 cdiv co cD c2
        norm3lem.4 2re 2ne0 redivcli cD c2 norm3lem.4 2re 2ne0 redivcli
        readdcli lelttri mpan syl c2 cD c2 cdiv co cmul co cD c2 cdiv co cD c2
        cdiv co caddc co cD cD c2 cdiv co cD c2 cdiv co cD c2 norm3lem.4 2re
        2ne0 redivcli recni 2timesi cD c2 cD norm3lem.4 recni 2cn 2ne0 divcan2i
        eqtr3i syl6breq $.
        $( [18-Aug-1999] $)
    $}
  $}

  $( Norm of differences around common element.  Part of Lemma 3.6 of
     [Beran] p. 101. $)
  norm3dif $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( normh ` ( A -h B ) )
                  <_ ( ( normh ` ( A -h C ) ) + ( normh ` ( C -h B ) ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel cA cB cmv co cno cfv cA cC cmv co
    cno cfv cC cB cmv co cno cfv caddc co cle wbr cA chil wcel cA c0v cif cB
    cmv co cno cfv cA chil wcel cA c0v cif cC cmv co cno cfv cC cB cmv co cno
    cfv caddc co cle wbr cA cB cC c0v c0v c0v cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cmv co cno cfv cA chil wcel cA c0v cif cC cmv co cno cfv cC
    cB chil wcel cB c0v cif cmv co cno cfv caddc co cle wbr cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif cmv co cno cfv cA chil wcel cA c0v cif cC chil
    wcel cC c0v cif cmv co cno cfv cC chil wcel cC c0v cif cB chil wcel cB c0v
    cif cmv co cno cfv caddc co cle wbr cA cA chil wcel cA c0v cif wceq cA cB
    cmv co cno cfv cA chil wcel cA c0v cif cB cmv co cno cfv cA cC cmv co cno
    cfv cC cB cmv co cno cfv caddc co cA chil wcel cA c0v cif cC cmv co cno cfv
    cC cB cmv co cno cfv caddc co cle cA cA chil wcel cA c0v cif wceq cA cB cmv
    co cA chil wcel cA c0v cif cB cmv co cno cA cA chil wcel cA c0v cif cB cmv
    opreq1 fveq2d cA cA chil wcel cA c0v cif wceq cA cC cmv co cno cfv cA chil
    wcel cA c0v cif cC cmv co cno cfv cC cB cmv co cno cfv caddc cA cA chil
    wcel cA c0v cif wceq cA cC cmv co cA chil wcel cA c0v cif cC cmv co cno cA
    cA chil wcel cA c0v cif cC cmv opreq1 fveq2d opreq1d breq12d cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cno cfv cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cA chil wcel cA c0v cif
    cC cmv co cno cfv cC cB cmv co cno cfv caddc co cA chil wcel cA c0v cif cC
    cmv co cno cfv cC cB chil wcel cB c0v cif cmv co cno cfv caddc co cle cB cB
    chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif cmv co cno cB cB chil wcel cB c0v cif cA
    chil wcel cA c0v cif cmv opreq2 fveq2d cB cB chil wcel cB c0v cif wceq cC
    cB cmv co cno cfv cC cB chil wcel cB c0v cif cmv co cno cfv cA chil wcel cA
    c0v cif cC cmv co cno cfv caddc cB cB chil wcel cB c0v cif wceq cC cB cmv
    co cC cB chil wcel cB c0v cif cmv co cno cB cB chil wcel cB c0v cif cC cmv
    opreq2 fveq2d opreq2d breq12d cC cC chil wcel cC c0v cif wceq cA chil wcel
    cA c0v cif cC cmv co cno cfv cC cB chil wcel cB c0v cif cmv co cno cfv
    caddc co cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cC
    chil wcel cC c0v cif cB chil wcel cB c0v cif cmv co cno cfv caddc co cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cle cC cC chil
    wcel cC c0v cif wceq cA chil wcel cA c0v cif cC cmv co cno cfv cA chil wcel
    cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cC cB chil wcel cB c0v
    cif cmv co cno cfv cC chil wcel cC c0v cif cB chil wcel cB c0v cif cmv co
    cno cfv caddc cC cC chil wcel cC c0v cif wceq cA chil wcel cA c0v cif cC
    cmv co cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cC cC
    chil wcel cC c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d cC cC chil
    wcel cC c0v cif wceq cC cB chil wcel cB c0v cif cmv co cC chil wcel cC c0v
    cif cB chil wcel cB c0v cif cmv co cno cC cC chil wcel cC c0v cif cB chil
    wcel cB c0v cif cmv opreq1 fveq2d opreq12d breq2d cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cC chil wcel cC c0v cif cA c0v chil ax-hv0cl elimel
    cB c0v chil ax-hv0cl elimel cC c0v chil ax-hv0cl elimel norm3difi dedth3h
    $.
    $( [11-May-2006] $) $( [20-Apr-2006] $)

  $( Norm of differences around common element. $)
  norm3dif2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( normh ` ( A -h B )
                  ) <_ ( ( normh ` ( C -h A ) ) + ( normh ` ( C -h B ) ) ) ) $=
    cA chil wcel cB chil wcel cC chil wcel w3a cA cB cmv co cno cfv cA cC cmv
    co cno cfv cC cB cmv co cno cfv caddc co cC cA cmv co cno cfv cC cB cmv co
    cno cfv caddc co cle cA cB cC norm3dif cA chil wcel cB chil wcel cC chil
    wcel w3a cA cC cmv co cno cfv cC cA cmv co cno cfv cC cB cmv co cno cfv
    caddc cA chil wcel cC chil wcel cA cC cmv co cno cfv cC cA cmv co cno cfv
    wceq cB chil wcel cA cC normsub 3adant2 opreq1d breqtrd $.
    $( [20-Apr-2007] $) $( [18-Apr-2007] $)

  $( Lemma involving norm of differences in Hilbert space. $)
  norm3lemt $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\
                   D e. RR ) ) -> (
          ( ( normh ` ( A -h C ) ) < ( D / 2 ) /\
            ( normh ` ( C -h B ) ) < ( D / 2 ) ) ->
            ( normh ` ( A -h B ) ) < D ) ) $=
    cA chil wcel cB chil wcel cC chil wcel cD cr wcel cA cC cmv co cno cfv cD
    c2 cdiv co clt wbr cC cB cmv co cno cfv cD c2 cdiv co clt wbr wa cA cB cmv
    co cno cfv cD clt wbr wi cA cB cC cD c0v c0v cA chil wcel cA c0v cif cC cmv
    co cno cfv cD c2 cdiv co clt wbr cC cB cmv co cno cfv cD c2 cdiv co clt wbr
    wa cA chil wcel cA c0v cif cB cmv co cno cfv cD clt wbr wi cA chil wcel cA
    c0v cif cC cmv co cno cfv cD c2 cdiv co clt wbr cC cB chil wcel cB c0v cif
    cmv co cno cfv cD c2 cdiv co clt wbr wa cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cmv co cno cfv cD clt wbr wi cA chil wcel cA c0v cif cC
    chil wcel cC c0v cif cmv co cno cfv cD c2 cdiv co clt wbr cC chil wcel cC
    c0v cif cB chil wcel cB c0v cif cmv co cno cfv cD c2 cdiv co clt wbr wa cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cD clt wbr wi
    cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cD cr wcel
    cD c2 cif c2 cdiv co clt wbr cC chil wcel cC c0v cif cB chil wcel cB c0v
    cif cmv co cno cfv cD cr wcel cD c2 cif c2 cdiv co clt wbr wa cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cD cr wcel cD c2 cif clt
    wbr wi c0v c2 cA cA chil wcel cA c0v cif wceq cA cC cmv co cno cfv cD c2
    cdiv co clt wbr cC cB cmv co cno cfv cD c2 cdiv co clt wbr wa cA chil wcel
    cA c0v cif cC cmv co cno cfv cD c2 cdiv co clt wbr cC cB cmv co cno cfv cD
    c2 cdiv co clt wbr wa cA cB cmv co cno cfv cD clt wbr cA chil wcel cA c0v
    cif cB cmv co cno cfv cD clt wbr cA cA chil wcel cA c0v cif wceq cA cC cmv
    co cno cfv cD c2 cdiv co clt wbr cA chil wcel cA c0v cif cC cmv co cno cfv
    cD c2 cdiv co clt wbr cC cB cmv co cno cfv cD c2 cdiv co clt wbr cA cA chil
    wcel cA c0v cif wceq cA cC cmv co cno cfv cA chil wcel cA c0v cif cC cmv co
    cno cfv cD c2 cdiv co clt cA cA chil wcel cA c0v cif wceq cA cC cmv co cA
    chil wcel cA c0v cif cC cmv co cno cA cA chil wcel cA c0v cif cC cmv opreq1
    fveq2d breq1d anbi1d cA cA chil wcel cA c0v cif wceq cA cB cmv co cno cfv
    cA chil wcel cA c0v cif cB cmv co cno cfv cD clt cA cA chil wcel cA c0v cif
    wceq cA cB cmv co cA chil wcel cA c0v cif cB cmv co cno cA cA chil wcel cA
    c0v cif cB cmv opreq1 fveq2d breq1d imbi12d cB cB chil wcel cB c0v cif wceq
    cA chil wcel cA c0v cif cC cmv co cno cfv cD c2 cdiv co clt wbr cC cB cmv
    co cno cfv cD c2 cdiv co clt wbr wa cA chil wcel cA c0v cif cC cmv co cno
    cfv cD c2 cdiv co clt wbr cC cB chil wcel cB c0v cif cmv co cno cfv cD c2
    cdiv co clt wbr wa cA chil wcel cA c0v cif cB cmv co cno cfv cD clt wbr cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv cD clt wbr cB
    cB chil wcel cB c0v cif wceq cC cB cmv co cno cfv cD c2 cdiv co clt wbr cC
    cB chil wcel cB c0v cif cmv co cno cfv cD c2 cdiv co clt wbr cA chil wcel
    cA c0v cif cC cmv co cno cfv cD c2 cdiv co clt wbr cB cB chil wcel cB c0v
    cif wceq cC cB cmv co cno cfv cC cB chil wcel cB c0v cif cmv co cno cfv cD
    c2 cdiv co clt cB cB chil wcel cB c0v cif wceq cC cB cmv co cC cB chil wcel
    cB c0v cif cmv co cno cB cB chil wcel cB c0v cif cC cmv opreq2 fveq2d
    breq1d anbi2d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    cmv co cno cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno
    cfv cD clt cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv
    co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cB cB chil
    wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d breq1d imbi12d cC
    cC chil wcel cC c0v cif wceq cA chil wcel cA c0v cif cC cmv co cno cfv cD
    c2 cdiv co clt wbr cC cB chil wcel cB c0v cif cmv co cno cfv cD c2 cdiv co
    clt wbr wa cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv
    cD c2 cdiv co clt wbr cC chil wcel cC c0v cif cB chil wcel cB c0v cif cmv
    co cno cfv cD c2 cdiv co clt wbr wa cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif cmv co cno cfv cD clt wbr cC cC chil wcel cC c0v cif wceq cA chil
    wcel cA c0v cif cC cmv co cno cfv cD c2 cdiv co clt wbr cA chil wcel cA c0v
    cif cC chil wcel cC c0v cif cmv co cno cfv cD c2 cdiv co clt wbr cC cB chil
    wcel cB c0v cif cmv co cno cfv cD c2 cdiv co clt wbr cC chil wcel cC c0v
    cif cB chil wcel cB c0v cif cmv co cno cfv cD c2 cdiv co clt wbr cC cC chil
    wcel cC c0v cif wceq cA chil wcel cA c0v cif cC cmv co cno cfv cA chil wcel
    cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cD c2 cdiv co clt cC cC
    chil wcel cC c0v cif wceq cA chil wcel cA c0v cif cC cmv co cA chil wcel cA
    c0v cif cC chil wcel cC c0v cif cmv co cno cC cC chil wcel cC c0v cif cA
    chil wcel cA c0v cif cmv opreq2 fveq2d breq1d cC cC chil wcel cC c0v cif
    wceq cC cB chil wcel cB c0v cif cmv co cno cfv cC chil wcel cC c0v cif cB
    chil wcel cB c0v cif cmv co cno cfv cD c2 cdiv co clt cC cC chil wcel cC
    c0v cif wceq cC cB chil wcel cB c0v cif cmv co cC chil wcel cC c0v cif cB
    chil wcel cB c0v cif cmv co cno cC cC chil wcel cC c0v cif cB chil wcel cB
    c0v cif cmv opreq1 fveq2d breq1d anbi12d imbi1d cD cD cr wcel cD c2 cif
    wceq cA chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cD c2
    cdiv co clt wbr cC chil wcel cC c0v cif cB chil wcel cB c0v cif cmv co cno
    cfv cD c2 cdiv co clt wbr wa cA chil wcel cA c0v cif cC chil wcel cC c0v
    cif cmv co cno cfv cD cr wcel cD c2 cif c2 cdiv co clt wbr cC chil wcel cC
    c0v cif cB chil wcel cB c0v cif cmv co cno cfv cD cr wcel cD c2 cif c2 cdiv
    co clt wbr wa cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno
    cfv cD clt wbr cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno
    cfv cD cr wcel cD c2 cif clt wbr cD cD cr wcel cD c2 cif wceq cA chil wcel
    cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cD c2 cdiv co clt wbr cA
    chil wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv cD cr wcel cD
    c2 cif c2 cdiv co clt wbr cC chil wcel cC c0v cif cB chil wcel cB c0v cif
    cmv co cno cfv cD c2 cdiv co clt wbr cC chil wcel cC c0v cif cB chil wcel
    cB c0v cif cmv co cno cfv cD cr wcel cD c2 cif c2 cdiv co clt wbr cD cD cr
    wcel cD c2 cif wceq cD c2 cdiv co cD cr wcel cD c2 cif c2 cdiv co cA chil
    wcel cA c0v cif cC chil wcel cC c0v cif cmv co cno cfv clt cD cD cr wcel cD
    c2 cif c2 cdiv opreq1 breq2d cD cD cr wcel cD c2 cif wceq cD c2 cdiv co cD
    cr wcel cD c2 cif c2 cdiv co cC chil wcel cC c0v cif cB chil wcel cB c0v
    cif cmv co cno cfv clt cD cD cr wcel cD c2 cif c2 cdiv opreq1 breq2d
    anbi12d cD cD cr wcel cD c2 cif cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif cmv co cno cfv clt breq2 imbi12d cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cC chil wcel cC c0v cif cD cr wcel cD c2 cif cA c0v chil
    ax-hv0cl elimel cB c0v chil ax-hv0cl elimel cC c0v chil ax-hv0cl elimel cD
    c2 cr 2re elimel norm3lem dedth4h $.
    $( [18-Aug-1999] $)

  ${
    norm3adift.1 $e |- C e. ~H $.
    $( Norm of differences around common element.  Part of Lemma 3.6 of [Beran]
       p. 101. $)
    norm3adifi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( abs ` ( ( normh ` ( A -h C ) ) -
         ( normh ` ( B -h C ) ) ) ) <_ ( normh ` ( A -h B ) ) ) $=
      cA chil wcel cB chil wcel cA cC cmv co cno cfv cB cC cmv co cno cfv cmin
      co cabs cfv cA cB cmv co cno cfv cle wbr cA chil wcel cA c0v cif cC cmv
      co cno cfv cB cC cmv co cno cfv cmin co cabs cfv cA chil wcel cA c0v cif
      cB cmv co cno cfv cle wbr cA chil wcel cA c0v cif cC cmv co cno cfv cB
      chil wcel cB c0v cif cC cmv co cno cfv cmin co cabs cfv cA chil wcel cA
      c0v cif cB chil wcel cB c0v cif cmv co cno cfv cle wbr cA cB c0v c0v cA
      cA chil wcel cA c0v cif wceq cA cC cmv co cno cfv cB cC cmv co cno cfv
      cmin co cabs cfv cA chil wcel cA c0v cif cC cmv co cno cfv cB cC cmv co
      cno cfv cmin co cabs cfv cA cB cmv co cno cfv cA chil wcel cA c0v cif cB
      cmv co cno cfv cle cA cA chil wcel cA c0v cif wceq cA cC cmv co cno cfv
      cB cC cmv co cno cfv cmin co cA chil wcel cA c0v cif cC cmv co cno cfv cB
      cC cmv co cno cfv cmin co cabs cA cA chil wcel cA c0v cif wceq cA cC cmv
      co cno cfv cA chil wcel cA c0v cif cC cmv co cno cfv cB cC cmv co cno cfv
      cmin cA cA chil wcel cA c0v cif wceq cA cC cmv co cA chil wcel cA c0v cif
      cC cmv co cno cA cA chil wcel cA c0v cif cC cmv opreq1 fveq2d opreq1d
      fveq2d cA cA chil wcel cA c0v cif wceq cA cB cmv co cA chil wcel cA c0v
      cif cB cmv co cno cA cA chil wcel cA c0v cif cB cmv opreq1 fveq2d breq12d
      cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cC cmv co cno cfv
      cB cC cmv co cno cfv cmin co cabs cfv cA chil wcel cA c0v cif cC cmv co
      cno cfv cB chil wcel cB c0v cif cC cmv co cno cfv cmin co cabs cfv cA
      chil wcel cA c0v cif cB cmv co cno cfv cA chil wcel cA c0v cif cB chil
      wcel cB c0v cif cmv co cno cfv cle cB cB chil wcel cB c0v cif wceq cA
      chil wcel cA c0v cif cC cmv co cno cfv cB cC cmv co cno cfv cmin co cA
      chil wcel cA c0v cif cC cmv co cno cfv cB chil wcel cB c0v cif cC cmv co
      cno cfv cmin co cabs cB cB chil wcel cB c0v cif wceq cB cC cmv co cno cfv
      cB chil wcel cB c0v cif cC cmv co cno cfv cA chil wcel cA c0v cif cC cmv
      co cno cfv cmin cB cB chil wcel cB c0v cif wceq cB cC cmv co cB chil wcel
      cB c0v cif cC cmv co cno cB cB chil wcel cB c0v cif cC cmv opreq1 fveq2d
      opreq2d fveq2d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
      cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cB cB
      chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d breq12d cA
      chil wcel cA c0v cif cB chil wcel cB c0v cif cC cA c0v chil ax-hv0cl
      elimel cB c0v chil ax-hv0cl elimel norm3adift.1 norm3adifii dedth2h $.
      $( [3-Oct-1999] $)
  $}

  ${
    normpar.1 $e |- A e. ~H $.
    normpar.2 $e |- B e. ~H $.
    $( Parallelogram law for norms.  Remark 3.4(B) of [Beran] p. 98. $)
    normpari $p |- ( ( ( normh ` ( A -h B ) ) ^ 2 ) +
                    ( ( normh ` ( A +h B ) ) ^ 2 ) ) =
                  ( ( 2 x. ( ( normh ` A ) ^ 2 ) ) +
                    ( 2 x. ( ( normh ` B ) ^ 2 ) ) ) $=
      cA cB cmv co cA cB cmv co csp co cA cB cva co cA cB cva co csp co caddc
      co cA cA csp co cA cA csp co caddc co cB cB csp co cB cB csp co caddc co
      caddc co cA cB cmv co cno cfv c2 cexp co cA cB cva co cno cfv c2 cexp co
      caddc co c2 cA cno cfv c2 cexp co cmul co c2 cB cno cfv c2 cexp co cmul
      co caddc co cA cB cmv co cA cB cmv co csp co cA cB cva co cA cB cva co
      csp co caddc co cA cA csp co cB cB csp co caddc co cA cB csp co cB cA csp
      co caddc co cneg caddc co cA cA csp co cB cB csp co caddc co cA cB csp co
      cB cA csp co caddc co caddc co caddc co cA cA csp co cB cB csp co caddc
      co cA cA csp co cB cB csp co caddc co caddc co cA cB csp co cB cA csp co
      caddc co cA cB csp co cB cA csp co caddc co cneg caddc co caddc co cA cA
      csp co cA cA csp co caddc co cB cB csp co cB cB csp co caddc co caddc co
      cA cB cmv co cA cB cmv co csp co cA cA csp co cB cB csp co caddc co cA cB
      csp co cB cA csp co caddc co cneg caddc co cA cB cva co cA cB cva co csp
      co cA cA csp co cB cB csp co caddc co cA cB csp co cB cA csp co caddc co
      caddc co caddc cA cB cmv co cA cB cmv co csp co cA cA csp co cB cB csp co
      caddc co cA cB csp co cB cA csp co caddc co cmin co cA cA csp co cB cB
      csp co caddc co cA cB csp co cB cA csp co caddc co cneg caddc co cA cB cA
      cB normpar.1 normpar.2 normpar.1 normpar.2 normlem9 cA cA csp co cB cB
      csp co caddc co cA cB csp co cB cA csp co caddc co cA cA csp co cB cB csp
      co cA cA normpar.1 normpar.1 hicli cB cB normpar.2 normpar.2 hicli addcli
      cA cB csp co cB cA csp co cA cB normpar.1 normpar.2 hicli cB cA normpar.2
      normpar.1 hicli addcli negsubi eqtr4i cA cB cA cB normpar.1 normpar.2
      normpar.1 normpar.2 normlem8 opreq12i cA cA csp co cB cB csp co caddc co
      cA cB csp co cB cA csp co caddc co cneg cA cA csp co cB cB csp co caddc
      co cA cB csp co cB cA csp co caddc co cA cA csp co cB cB csp co cA cA
      normpar.1 normpar.1 hicli cB cB normpar.2 normpar.2 hicli addcli cA cB
      csp co cB cA csp co caddc co cA cB csp co cB cA csp co cA cB normpar.1
      normpar.2 hicli cB cA normpar.2 normpar.1 hicli addcli negcli cA cA csp
      co cB cB csp co cA cA normpar.1 normpar.1 hicli cB cB normpar.2 normpar.2
      hicli addcli cA cB csp co cB cA csp co cA cB normpar.1 normpar.2 hicli cB
      cA normpar.2 normpar.1 hicli addcli add42i cA cA csp co cB cB csp co
      caddc co cA cA csp co cB cB csp co caddc co caddc co cA cB csp co cB cA
      csp co caddc co cA cB csp co cB cA csp co caddc co cneg caddc co caddc co
      cA cA csp co cB cB csp co caddc co cA cA csp co cB cB csp co caddc co
      caddc co cc0 caddc co cA cA csp co cB cB csp co caddc co cA cA csp co cB
      cB csp co caddc co caddc co cA cA csp co cA cA csp co caddc co cB cB csp
      co cB cB csp co caddc co caddc co cA cB csp co cB cA csp co caddc co cA
      cB csp co cB cA csp co caddc co cneg caddc co cc0 cA cA csp co cB cB csp
      co caddc co cA cA csp co cB cB csp co caddc co caddc co caddc cA cB csp
      co cB cA csp co caddc co cA cB csp co cB cA csp co cA cB normpar.1
      normpar.2 hicli cB cA normpar.2 normpar.1 hicli addcli negidi opreq2i cA
      cA csp co cB cB csp co caddc co cA cA csp co cB cB csp co caddc co caddc
      co cA cA csp co cB cB csp co caddc co cA cA csp co cB cB csp co caddc co
      cA cA csp co cB cB csp co cA cA normpar.1 normpar.1 hicli cB cB normpar.2
      normpar.2 hicli addcli cA cA csp co cB cB csp co cA cA normpar.1
      normpar.1 hicli cB cB normpar.2 normpar.2 hicli addcli addcli addid1i cA
      cA csp co cB cB csp co cA cA csp co cB cB csp co cA cA normpar.1
      normpar.1 hicli cB cB normpar.2 normpar.2 hicli cA cA normpar.1 normpar.1
      hicli cB cB normpar.2 normpar.2 hicli add4i 3eqtri 3eqtri cA cB cmv co
      cno cfv c2 cexp co cA cB cmv co cA cB cmv co csp co cA cB cva co cno cfv
      c2 cexp co cA cB cva co cA cB cva co csp co caddc cA cB cmv co cA cB
      normpar.1 normpar.2 hvsubcli normsqi cA cB cva co cA cB normpar.1
      normpar.2 hvaddcli normsqi opreq12i c2 cA cno cfv c2 cexp co cmul co cA
      cA csp co cA cA csp co caddc co c2 cB cno cfv c2 cexp co cmul co cB cB
      csp co cB cB csp co caddc co caddc c2 cA cno cfv c2 cexp co cmul co c2 cA
      cA csp co cmul co cA cA csp co cA cA csp co caddc co cA cno cfv c2 cexp
      co cA cA csp co c2 cmul cA normpar.1 normsqi opreq2i cA cA csp co cA cA
      normpar.1 normpar.1 hicli 2timesi eqtri c2 cB cno cfv c2 cexp co cmul co
      c2 cB cB csp co cmul co cB cB csp co cB cB csp co caddc co cB cno cfv c2
      cexp co cB cB csp co c2 cmul cB normpar.2 normsqi opreq2i cB cB csp co cB
      cB normpar.2 normpar.2 hicli 2timesi eqtri opreq12i 3eqtr4i $.
      $( [21-Aug-1999] $)
  $}

  $( Parallelogram law for norms.  Remark 3.4(B) of [Beran] p. 98. $)
  normpar $p |- ( ( A e. ~H /\ B e. ~H ) ->
          ( ( ( normh ` ( A -h B ) ) ^ 2 ) + ( ( normh ` ( A +h B ) ) ^ 2 ) ) =
       ( ( 2 x. ( ( normh ` A ) ^ 2 ) ) + ( 2 x. ( ( normh ` B ) ^ 2 ) ) ) ) $=
    cA chil wcel cB chil wcel cA cB cmv co cno cfv c2 cexp co cA cB cva co cno
    cfv c2 cexp co caddc co c2 cA cno cfv c2 cexp co cmul co c2 cB cno cfv c2
    cexp co cmul co caddc co wceq cA chil wcel cA c0v cif cB cmv co cno cfv c2
    cexp co cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co caddc co c2 cA
    chil wcel cA c0v cif cno cfv c2 cexp co cmul co c2 cB cno cfv c2 cexp co
    cmul co caddc co wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv
    co cno cfv c2 cexp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva
    co cno cfv c2 cexp co caddc co c2 cA chil wcel cA c0v cif cno cfv c2 cexp
    co cmul co c2 cB chil wcel cB c0v cif cno cfv c2 cexp co cmul co caddc co
    wceq cA cB c0v c0v cA cA chil wcel cA c0v cif wceq cA cB cmv co cno cfv c2
    cexp co cA cB cva co cno cfv c2 cexp co caddc co cA chil wcel cA c0v cif cB
    cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp
    co caddc co c2 cA cno cfv c2 cexp co cmul co c2 cB cno cfv c2 cexp co cmul
    co caddc co c2 cA chil wcel cA c0v cif cno cfv c2 cexp co cmul co c2 cB cno
    cfv c2 cexp co cmul co caddc co cA cA chil wcel cA c0v cif wceq cA cB cmv
    co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cmv co cno cfv c2 cexp co
    cA cB cva co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cva co cno cfv
    c2 cexp co caddc cA cA chil wcel cA c0v cif wceq cA cB cmv co cno cfv cA
    chil wcel cA c0v cif cB cmv co cno cfv c2 cexp cA cA chil wcel cA c0v cif
    wceq cA cB cmv co cA chil wcel cA c0v cif cB cmv co cno cA cA chil wcel cA
    c0v cif cB cmv opreq1 fveq2d opreq1d cA cA chil wcel cA c0v cif wceq cA cB
    cva co cno cfv cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp cA cA chil
    wcel cA c0v cif wceq cA cB cva co cA chil wcel cA c0v cif cB cva co cno cA
    cA chil wcel cA c0v cif cB cva opreq1 fveq2d opreq1d opreq12d cA cA chil
    wcel cA c0v cif wceq c2 cA cno cfv c2 cexp co cmul co c2 cA chil wcel cA
    c0v cif cno cfv c2 cexp co cmul co c2 cB cno cfv c2 cexp co cmul co caddc
    cA cA chil wcel cA c0v cif wceq cA cno cfv c2 cexp co cA chil wcel cA c0v
    cif cno cfv c2 cexp co c2 cmul cA cA chil wcel cA c0v cif wceq cA cno cfv
    cA chil wcel cA c0v cif cno cfv c2 cexp cA cA chil wcel cA c0v cif cno
    fveq2 opreq1d opreq2d opreq1d eqeq12d cB cB chil wcel cB c0v cif wceq cA
    chil wcel cA c0v cif cB cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif
    cB cva co cno cfv c2 cexp co caddc co cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cva co cno cfv c2 cexp co caddc co c2 cA chil wcel cA c0v cif
    cno cfv c2 cexp co cmul co c2 cB cno cfv c2 cexp co cmul co caddc co c2 cA
    chil wcel cA c0v cif cno cfv c2 cexp co cmul co c2 cB chil wcel cB c0v cif
    cno cfv c2 cexp co cmul co caddc co cB cB chil wcel cB c0v cif wceq cA chil
    wcel cA c0v cif cB cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif cB
    chil wcel cB c0v cif cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif cB
    cva co cno cfv c2 cexp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif
    cva co cno cfv c2 cexp co caddc cB cB chil wcel cB c0v cif wceq cA chil
    wcel cA c0v cif cB cmv co cno cfv cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif cmv co cno cfv c2 cexp cB cB chil wcel cB c0v cif wceq cA chil wcel
    cA c0v cif cB cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co
    cno cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d
    opreq1d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cva co
    cno cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno cfv c2
    cexp cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cva co cA
    chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno cB cB chil wcel cB
    c0v cif cA chil wcel cA c0v cif cva opreq2 fveq2d opreq1d opreq12d cB cB
    chil wcel cB c0v cif wceq c2 cB cno cfv c2 cexp co cmul co c2 cB chil wcel
    cB c0v cif cno cfv c2 cexp co cmul co c2 cA chil wcel cA c0v cif cno cfv c2
    cexp co cmul co caddc cB cB chil wcel cB c0v cif wceq cB cno cfv c2 cexp co
    cB chil wcel cB c0v cif cno cfv c2 cexp co c2 cmul cB cB chil wcel cB c0v
    cif wceq cB cno cfv cB chil wcel cB c0v cif cno cfv c2 cexp cB cB chil wcel
    cB c0v cif cno fveq2 opreq1d opreq2d opreq2d eqeq12d cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif cA c0v chil ax-hv0cl elimel cB c0v chil
    ax-hv0cl elimel normpari dedth2h $.
    $( [27-Apr-2007] $) $( [15-Apr-2007] $)

  ${
    normpar2.1 $e |- A e. ~H $.
    normpar2.2 $e |- B e. ~H $.
    normpar2.3 $e |- C e. ~H $.
    $( Corollary of parallelogram law for norms.  Part of Lemma 3.6 of [Beran]
       p. 100. $)
    normpar2i $p |- ( ( normh ` ( A -h B ) ) ^ 2 ) =
                   ( ( ( 2 x. ( ( normh ` ( A -h C ) ) ^ 2 ) ) +
                       ( 2 x. ( ( normh ` ( B -h C ) ) ^ 2 ) ) )
          - ( ( normh ` ( ( A +h B ) -h ( 2 .h C ) ) ) ^ 2 ) ) $=
      c2 cA cC cmv co cno cfv c2 cexp co cmul co c2 cB cC cmv co cno cfv c2
      cexp co cmul co caddc co cA cB cva co c2 cC csm co cmv co cno cfv c2 cexp
      co cmin co cA cB cmv co cno cfv c2 cexp co c2 cA cC cmv co cno cfv c2
      cexp co cmul co c2 cB cC cmv co cno cfv c2 cexp co cmul co caddc co cA cB
      cva co c2 cC csm co cmv co cno cfv c2 cexp co cA cB cmv co cno cfv c2
      cexp co c2 cA cC cmv co cno cfv c2 cexp co cmul co c2 cB cC cmv co cno
      cfv c2 cexp co cmul co caddc co c2 cA cC cmv co cno cfv c2 cexp co cmul
      co c2 cB cC cmv co cno cfv c2 cexp co cmul co c2 cA cC cmv co cno cfv c2
      cexp co 2re cA cC cmv co cno cfv cA cC cmv co cA cC normpar2.1 normpar2.3
      hvsubcli normcli resqcli remulcli c2 cB cC cmv co cno cfv c2 cexp co 2re
      cB cC cmv co cno cfv cB cC cmv co cB cC normpar2.2 normpar2.3 hvsubcli
      normcli resqcli remulcli readdcli recni cA cB cva co c2 cC csm co cmv co
      cno cfv c2 cexp co cA cB cva co c2 cC csm co cmv co cno cfv cA cB cva co
      c2 cC csm co cmv co cA cB cva co c2 cC csm co cA cB normpar2.1 normpar2.2
      hvaddcli c2 cC 2cn normpar2.3 hvmulcli hvsubcli normcli resqcli recni cA
      cB cmv co cno cfv c2 cexp co cA cB cmv co cno cfv cA cB cmv co cA cB
      normpar2.1 normpar2.2 hvsubcli normcli resqcli recni c4 cA cC cmv co cno
      cfv c2 cexp co cmul co c4 cB cC cmv co cno cfv c2 cexp co cmul co caddc
      co c2 cdiv co c4 cA cC cmv co cno cfv c2 cexp co cmul co c2 cdiv co c4 cB
      cC cmv co cno cfv c2 cexp co cmul co c2 cdiv co caddc co cA cB cva co c2
      cC csm co cmv co cno cfv c2 cexp co cA cB cmv co cno cfv c2 cexp co caddc
      co c2 cA cC cmv co cno cfv c2 cexp co cmul co c2 cB cC cmv co cno cfv c2
      cexp co cmul co caddc co c4 cA cC cmv co cno cfv c2 cexp co cmul co c4 cB
      cC cmv co cno cfv c2 cexp co cmul co c2 c4 cA cC cmv co cno cfv c2 cexp
      co c4 4re recni cA cC cmv co cno cfv c2 cexp co cA cC cmv co cno cfv cA
      cC cmv co cA cC normpar2.1 normpar2.3 hvsubcli normcli resqcli recni
      mulcli c4 cB cC cmv co cno cfv c2 cexp co c4 4re recni cB cC cmv co cno
      cfv c2 cexp co cB cC cmv co cno cfv cB cC cmv co cB cC normpar2.2
      normpar2.3 hvsubcli normcli resqcli recni mulcli 2cn 2ne0 divdiri c4 cA
      cC cmv co cno cfv c2 cexp co cmul co c4 cB cC cmv co cno cfv c2 cexp co
      cmul co caddc co c2 cdiv co c2 cA cB cva co c2 cC csm co cmv co cno cfv
      c2 cexp co cmul co c2 cA cB cmv co cno cfv c2 cexp co cmul co caddc co c2
      cdiv co c2 cA cB cva co c2 cC csm co cmv co cno cfv c2 cexp co cmul co c2
      cdiv co c2 cA cB cmv co cno cfv c2 cexp co cmul co c2 cdiv co caddc co cA
      cB cva co c2 cC csm co cmv co cno cfv c2 cexp co cA cB cmv co cno cfv c2
      cexp co caddc co c4 cA cC cmv co cno cfv c2 cexp co cmul co c4 cB cC cmv
      co cno cfv c2 cexp co cmul co caddc co c2 cA cB cva co c2 cC csm co cmv
      co cno cfv c2 cexp co cmul co c2 cA cB cmv co cno cfv c2 cexp co cmul co
      caddc co c2 cdiv c4 cA cC cmv co cno cfv c2 cexp co cmul co c4 cB cC cmv
      co cno cfv c2 cexp co cmul co caddc co c4 cB cC cmv co cno cfv c2 cexp co
      cmul co c4 cA cC cmv co cno cfv c2 cexp co cmul co caddc co cA cB cva co
      c2 cC csm co cmv co cA cB cmv co cmv co cno cfv c2 cexp co cA cB cva co
      c2 cC csm co cmv co cA cB cmv co cva co cno cfv c2 cexp co caddc co c2 cA
      cB cva co c2 cC csm co cmv co cno cfv c2 cexp co cmul co c2 cA cB cmv co
      cno cfv c2 cexp co cmul co caddc co c4 cA cC cmv co cno cfv c2 cexp co
      cmul co c4 cB cC cmv co cno cfv c2 cexp co cmul co c4 cA cC cmv co cno
      cfv c2 cexp co c4 4re recni cA cC cmv co cno cfv c2 cexp co cA cC cmv co
      cno cfv cA cC cmv co cA cC normpar2.1 normpar2.3 hvsubcli normcli resqcli
      recni mulcli c4 cB cC cmv co cno cfv c2 cexp co c4 4re recni cB cC cmv co
      cno cfv c2 cexp co cB cC cmv co cno cfv cB cC cmv co cB cC normpar2.2
      normpar2.3 hvsubcli normcli resqcli recni mulcli addcomi cA cB cva co c2
      cC csm co cmv co cA cB cmv co cmv co cno cfv c2 cexp co c4 cB cC cmv co
      cno cfv c2 cexp co cmul co cA cB cva co c2 cC csm co cmv co cA cB cmv co
      cva co cno cfv c2 cexp co c4 cA cC cmv co cno cfv c2 cexp co cmul co
      caddc cA cB cva co c2 cC csm co cmv co cA cB cmv co cmv co cno cfv c2
      cexp co c2 cB cC cmv co cno cfv cmul co c2 cexp co c2 c2 cexp co cB cC
      cmv co cno cfv c2 cexp co cmul co c4 cB cC cmv co cno cfv c2 cexp co cmul
      co cA cB cva co c2 cC csm co cmv co cA cB cmv co cmv co cno cfv c2 cB cC
      cmv co cno cfv cmul co c2 cexp cA cB cva co c2 cC csm co cmv co cA cB cmv
      co cmv co cno cfv c2 cB cC cmv co csm co cno cfv c2 cabs cfv cB cC cmv co
      cno cfv cmul co c2 cB cC cmv co cno cfv cmul co cA cB cva co c2 cC csm co
      cmv co cA cB cmv co cmv co c2 cB cC cmv co csm co cno cA cB cva co c2 cC
      csm co cmv co cA cB cmv co cmv co c2 cB csm co c2 cC csm co cmv co c2 cB
      cC cmv co csm co cA cB cva co c2 cC csm co cmv co cA cB cmv co cmv co cA
      cB cva co c2 cC csm co cmv co c1 cneg cA cB cmv co csm co cva co cA cB
      cva co c1 cneg c2 cC csm co csm co cva co c1 cneg cA cB cmv co csm co cva
      co c2 cB csm co c2 cC csm co cmv co cA cB cva co c2 cC csm co cmv co cA
      cB cmv co cA cB cva co c2 cC csm co cA cB normpar2.1 normpar2.2 hvaddcli
      c2 cC 2cn normpar2.3 hvmulcli hvsubcli cA cB normpar2.1 normpar2.2
      hvsubcli hvsubvali cA cB cva co c2 cC csm co cmv co cA cB cva co c1 cneg
      c2 cC csm co csm co cva co c1 cneg cA cB cmv co csm co cva cA cB cva co
      c2 cC csm co cA cB normpar2.1 normpar2.2 hvaddcli c2 cC 2cn normpar2.3
      hvmulcli hvsubvali opreq1i cA cB cva co c1 cneg cA cB cmv co csm co cva
      co c1 cneg c2 cC csm co csm co cva co c2 cB csm co c1 cneg c2 cC csm co
      csm co cva co cA cB cva co c1 cneg c2 cC csm co csm co cva co c1 cneg cA
      cB cmv co csm co cva co c2 cB csm co c2 cC csm co cmv co cA cB cva co c1
      cneg cA cB cmv co csm co cva co c2 cB csm co c1 cneg c2 cC csm co csm co
      cva cA cB cva co c1 cneg cA cB cmv co csm co cva co cB cA cva co cB cA
      cmv co cva co c2 cB csm co cA cB cva co cB cA cva co c1 cneg cA cB cmv co
      csm co cB cA cmv co cva cA cB normpar2.1 normpar2.2 hvcomi cA cB
      normpar2.1 normpar2.2 hvnegdii opreq12i cB cA normpar2.2 normpar2.1
      hvsubcan2i eqtri opreq1i cA cB cva co c1 cneg c2 cC csm co csm co c1 cneg
      cA cB cmv co csm co cA cB normpar2.1 normpar2.2 hvaddcli c1 cneg c2 cC
      csm co c1 ax1cn negcli c2 cC 2cn normpar2.3 hvmulcli hvmulcli c1 cneg cA
      cB cmv co c1 ax1cn negcli cA cB normpar2.1 normpar2.2 hvsubcli hvmulcli
      hvadd23i c2 cB csm co c2 cC csm co c2 cB 2cn normpar2.2 hvmulcli c2 cC
      2cn normpar2.3 hvmulcli hvsubvali 3eqtr4i 3eqtri c2 cB cC 2cn normpar2.2
      normpar2.3 hvsubdistr1i eqtr4i fveq2i c2 cB cC cmv co 2cn cB cC
      normpar2.2 normpar2.3 hvsubcli norm-iii.i c2 cabs cfv c2 cB cC cmv co cno
      cfv cmul cc0 c2 cle wbr c2 cabs cfv c2 wceq cc0 c2 0re 2re 2pos ltleii c2
      2re absidi ax-mp opreq1i 3eqtri opreq1i c2 cB cC cmv co cno cfv 2cn cB cC
      cmv co cno cfv cB cC cmv co cB cC normpar2.2 normpar2.3 hvsubcli normcli
      recni sqmuli c2 c2 cexp co c4 cB cC cmv co cno cfv c2 cexp co cmul sq2
      opreq1i 3eqtri cA cB cva co c2 cC csm co cmv co cA cB cmv co cva co cno
      cfv c2 cexp co c2 cA cC cmv co cno cfv cmul co c2 cexp co c2 c2 cexp co
      cA cC cmv co cno cfv c2 cexp co cmul co c4 cA cC cmv co cno cfv c2 cexp
      co cmul co cA cB cva co c2 cC csm co cmv co cA cB cmv co cva co cno cfv
      c2 cA cC cmv co cno cfv cmul co c2 cexp cA cB cva co c2 cC csm co cmv co
      cA cB cmv co cva co cno cfv c2 cA cC cmv co csm co cno cfv c2 cabs cfv cA
      cC cmv co cno cfv cmul co c2 cA cC cmv co cno cfv cmul co cA cB cva co c2
      cC csm co cmv co cA cB cmv co cva co c2 cA cC cmv co csm co cno cA cB cva
      co c2 cC csm co cmv co cA cB cmv co cva co c2 cA csm co c2 cC csm co cmv
      co c2 cA cC cmv co csm co cA cB cva co c2 cC csm co cmv co cA cB cmv co
      cva co cA cB cva co c1 cneg c2 cC csm co csm co cva co cA cB cmv co cva
      co cA cB cva co cA cB cmv co cva co c1 cneg c2 cC csm co csm co cva co c2
      cA csm co c2 cC csm co cmv co cA cB cva co c2 cC csm co cmv co cA cB cva
      co c1 cneg c2 cC csm co csm co cva co cA cB cmv co cva cA cB cva co c2 cC
      csm co cA cB normpar2.1 normpar2.2 hvaddcli c2 cC 2cn normpar2.3 hvmulcli
      hvsubvali opreq1i cA cB cva co c1 cneg c2 cC csm co csm co cA cB cmv co
      cA cB normpar2.1 normpar2.2 hvaddcli c1 cneg c2 cC csm co c1 ax1cn negcli
      c2 cC 2cn normpar2.3 hvmulcli hvmulcli cA cB normpar2.1 normpar2.2
      hvsubcli hvadd23i cA cB cva co cA cB cmv co cva co c1 cneg c2 cC csm co
      csm co cva co c2 cA csm co c1 cneg c2 cC csm co csm co cva co c2 cA csm
      co c2 cC csm co cmv co cA cB cva co cA cB cmv co cva co c2 cA csm co c1
      cneg c2 cC csm co csm co cva cA cB normpar2.1 normpar2.2 hvsubcan2i
      opreq1i c2 cA csm co c2 cC csm co c2 cA 2cn normpar2.1 hvmulcli c2 cC 2cn
      normpar2.3 hvmulcli hvsubvali eqtr4i 3eqtri c2 cA cC 2cn normpar2.1
      normpar2.3 hvsubdistr1i eqtr4i fveq2i c2 cA cC cmv co 2cn cA cC
      normpar2.1 normpar2.3 hvsubcli norm-iii.i c2 cabs cfv c2 cA cC cmv co cno
      cfv cmul cc0 c2 cle wbr c2 cabs cfv c2 wceq cc0 c2 0re 2re 2pos ltleii c2
      2re absidi ax-mp opreq1i 3eqtri opreq1i c2 cA cC cmv co cno cfv 2cn cA cC
      cmv co cno cfv cA cC cmv co cA cC normpar2.1 normpar2.3 hvsubcli normcli
      recni sqmuli c2 c2 cexp co c4 cA cC cmv co cno cfv c2 cexp co cmul sq2
      opreq1i 3eqtri opreq12i cA cB cva co c2 cC csm co cmv co cA cB cmv co cA
      cB cva co c2 cC csm co cA cB normpar2.1 normpar2.2 hvaddcli c2 cC 2cn
      normpar2.3 hvmulcli hvsubcli cA cB normpar2.1 normpar2.2 hvsubcli
      normpari 3eqtr2i opreq1i c2 cA cB cva co c2 cC csm co cmv co cno cfv c2
      cexp co cmul co c2 cA cB cmv co cno cfv c2 cexp co cmul co c2 c2 cA cB
      cva co c2 cC csm co cmv co cno cfv c2 cexp co 2cn cA cB cva co c2 cC csm
      co cmv co cno cfv c2 cexp co cA cB cva co c2 cC csm co cmv co cno cfv cA
      cB cva co c2 cC csm co cmv co cA cB cva co c2 cC csm co cA cB normpar2.1
      normpar2.2 hvaddcli c2 cC 2cn normpar2.3 hvmulcli hvsubcli normcli
      resqcli recni mulcli c2 cA cB cmv co cno cfv c2 cexp co 2cn cA cB cmv co
      cno cfv c2 cexp co cA cB cmv co cno cfv cA cB cmv co cA cB normpar2.1
      normpar2.2 hvsubcli normcli resqcli recni mulcli 2cn 2ne0 divdiri c2 cA
      cB cva co c2 cC csm co cmv co cno cfv c2 cexp co cmul co c2 cdiv co cA cB
      cva co c2 cC csm co cmv co cno cfv c2 cexp co c2 cA cB cmv co cno cfv c2
      cexp co cmul co c2 cdiv co cA cB cmv co cno cfv c2 cexp co caddc cA cB
      cva co c2 cC csm co cmv co cno cfv c2 cexp co c2 cA cB cva co c2 cC csm
      co cmv co cno cfv c2 cexp co cA cB cva co c2 cC csm co cmv co cno cfv cA
      cB cva co c2 cC csm co cmv co cA cB cva co c2 cC csm co cA cB normpar2.1
      normpar2.2 hvaddcli c2 cC 2cn normpar2.3 hvmulcli hvsubcli normcli
      resqcli recni 2cn 2ne0 divcan3i cA cB cmv co cno cfv c2 cexp co c2 cA cB
      cmv co cno cfv c2 cexp co cA cB cmv co cno cfv cA cB cmv co cA cB
      normpar2.1 normpar2.2 hvsubcli normcli resqcli recni 2cn 2ne0 divcan3i
      opreq12i 3eqtri c4 cA cC cmv co cno cfv c2 cexp co cmul co c2 cdiv co c2
      cA cC cmv co cno cfv c2 cexp co cmul co c4 cB cC cmv co cno cfv c2 cexp
      co cmul co c2 cdiv co c2 cB cC cmv co cno cfv c2 cexp co cmul co caddc c4
      cA cC cmv co cno cfv c2 cexp co cmul co c2 cdiv co c4 c2 cdiv co cA cC
      cmv co cno cfv c2 cexp co cmul co c2 cA cC cmv co cno cfv c2 cexp co cmul
      co c4 cA cC cmv co cno cfv c2 cexp co c2 c4 4re recni cA cC cmv co cno
      cfv c2 cexp co cA cC cmv co cno cfv cA cC cmv co cA cC normpar2.1
      normpar2.3 hvsubcli normcli resqcli recni 2cn 2ne0 div23i c4 c2 cdiv co
      c2 cA cC cmv co cno cfv c2 cexp co cmul 4d2e2 opreq1i eqtri c4 cB cC cmv
      co cno cfv c2 cexp co cmul co c2 cdiv co c4 c2 cdiv co cB cC cmv co cno
      cfv c2 cexp co cmul co c2 cB cC cmv co cno cfv c2 cexp co cmul co c4 cB
      cC cmv co cno cfv c2 cexp co c2 c4 4re recni cB cC cmv co cno cfv c2 cexp
      co cB cC cmv co cno cfv cB cC cmv co cB cC normpar2.2 normpar2.3 hvsubcli
      normcli resqcli recni 2cn 2ne0 div23i c4 c2 cdiv co c2 cB cC cmv co cno
      cfv c2 cexp co cmul 4d2e2 opreq1i eqtri opreq12i 3eqtr3i subaddrii eqcomi
      $.
      $( [5-Oct-1999] $)
  $}

  ${
    polid2.1 $e |- A e. ~H $.
    polid2.2 $e |- B e. ~H $.
    polid2.3 $e |- C e. ~H $.
    polid2.4 $e |- D e. ~H $.
    $( Generalized polarization identity.  Generalization of Exercise 4(a) of
       [ReedSimon] p. 63. $)
    polid2i $p |- ( A .ih B ) = ( ( ( ( ( A +h C ) .ih ( D +h B ) )  -
                ( ( A -h C ) .ih ( D -h B ) )  ) +
       ( _i x. ( ( ( A +h ( _i .h C ) ) .ih ( D +h ( _i .h B ) ) ) -
               ( ( A -h ( _i .h C ) ) .ih ( D -h ( _i .h B ) ) ) ) ) ) / 4 ) $=
      c4 cA cB csp co cmul co c4 cdiv co cA cB csp co cA cC cva co cD cB cva co
      csp co cA cC cmv co cD cB cmv co csp co cmin co ci cA ci cC csm co cva co
      cD ci cB csm co cva co csp co cA ci cC csm co cmv co cD ci cB csm co cmv
      co csp co cmin co cmul co caddc co c4 cdiv co cA cB csp co c4 cA cB
      polid2.1 polid2.2 hicli c4 4re recni c4 4re 4pos gt0ne0ii divcan3i c4 cA
      cB csp co cmul co cA cC cva co cD cB cva co csp co cA cC cmv co cD cB cmv
      co csp co cmin co ci cA ci cC csm co cva co cD ci cB csm co cva co csp co
      cA ci cC csm co cmv co cD ci cB csm co cmv co csp co cmin co cmul co
      caddc co c4 cdiv c2 cA cB csp co cC cD csp co caddc co cA cB csp co cC cD
      csp co cmin co caddc co cmul co c2 cA cB csp co cC cD csp co caddc co
      cmul co c2 cA cB csp co cC cD csp co cmin co cmul co caddc co c4 cA cB
      csp co cmul co cA cC cva co cD cB cva co csp co cA cC cmv co cD cB cmv co
      csp co cmin co ci cA ci cC csm co cva co cD ci cB csm co cva co csp co cA
      ci cC csm co cmv co cD ci cB csm co cmv co csp co cmin co cmul co caddc
      co c2 cA cB csp co cC cD csp co caddc co cA cB csp co cC cD csp co cmin
      co 2cn cA cB csp co cC cD csp co cA cB polid2.1 polid2.2 hicli cC cD
      polid2.3 polid2.4 hicli addcli cA cB csp co cC cD csp co cA cB polid2.1
      polid2.2 hicli cC cD polid2.3 polid2.4 hicli subcli adddii c2 cA cB csp
      co cC cD csp co caddc co cA cB csp co cC cD csp co cmin co caddc co cmul
      co c2 c2 cA cB csp co cmul co cmul co c2 c2 cmul co cA cB csp co cmul co
      c4 cA cB csp co cmul co cA cB csp co cC cD csp co caddc co cA cB csp co
      cC cD csp co cmin co caddc co c2 cA cB csp co cmul co c2 cmul cA cB csp
      co cC cD csp co caddc co cA cB csp co cC cD csp co cmin co caddc co cA cB
      csp co cA cB csp co caddc co c2 cA cB csp co cmul co cA cB csp co cc wcel
      cC cD csp co cc wcel cA cB csp co cc wcel cA cB csp co cC cD csp co caddc
      co cA cB csp co cC cD csp co cmin co caddc co cA cB csp co cA cB csp co
      caddc co wceq cA cB polid2.1 polid2.2 hicli cC cD polid2.3 polid2.4 hicli
      cA cB polid2.1 polid2.2 hicli cA cB csp co cC cD csp co cA cB csp co
      ppncan mp3an cA cB csp co cA cB polid2.1 polid2.2 hicli 2timesi eqtr4i
      opreq2i c2 c2 cA cB csp co 2cn 2cn cA cB polid2.1 polid2.2 hicli mulassi
      c2 c2 cmul co c4 cA cB csp co cmul 2t2e4 opreq1i 3eqtr2ri cA cC cva co cD
      cB cva co csp co cA cC cmv co cD cB cmv co csp co cmin co c2 cA cB csp co
      cC cD csp co caddc co cmul co ci cA ci cC csm co cva co cD ci cB csm co
      cva co csp co cA ci cC csm co cmv co cD ci cB csm co cmv co csp co cmin
      co cmul co c2 cA cB csp co cC cD csp co cmin co cmul co caddc cA cD csp
      co cC cB csp co caddc co cA cB csp co cC cD csp co caddc co caddc co cA
      cD csp co cC cB csp co caddc co cA cB csp co cC cD csp co caddc co cmin
      co cmin co cA cB csp co cC cD csp co caddc co cA cB csp co cC cD csp co
      caddc co caddc co cA cC cva co cD cB cva co csp co cA cC cmv co cD cB cmv
      co csp co cmin co c2 cA cB csp co cC cD csp co caddc co cmul co cA cD csp
      co cC cB csp co caddc co cA cB csp co cC cD csp co caddc co cA cB csp co
      cC cD csp co caddc co cA cD csp co cC cB csp co cA cD polid2.1 polid2.4
      hicli cC cB polid2.3 polid2.2 hicli addcli cA cB csp co cC cD csp co cA
      cB polid2.1 polid2.2 hicli cC cD polid2.3 polid2.4 hicli addcli cA cB csp
      co cC cD csp co cA cB polid2.1 polid2.2 hicli cC cD polid2.3 polid2.4
      hicli addcli pnncani cA cC cva co cD cB cva co csp co cA cD csp co cC cB
      csp co caddc co cA cB csp co cC cD csp co caddc co caddc co cA cC cmv co
      cD cB cmv co csp co cA cD csp co cC cB csp co caddc co cA cB csp co cC cD
      csp co caddc co cmin co cmin cA cC cD cB polid2.1 polid2.3 polid2.4
      polid2.2 normlem8 cA cC cD cB polid2.1 polid2.3 polid2.4 polid2.2
      normlem9 opreq12i cA cB csp co cC cD csp co caddc co cA cB csp co cC cD
      csp co cA cB polid2.1 polid2.2 hicli cC cD polid2.3 polid2.4 hicli addcli
      2timesi 3eqtr4i ci cA ci cC csm co cva co cD ci cB csm co cva co csp co
      cA ci cC csm co cmv co cD ci cB csm co cmv co csp co cmin co cmul co ci
      c2 ci cneg cA cB csp co cmul co ci cC cD csp co cmul co caddc co cmul co
      cmul co c2 ci ci cneg cA cB csp co cmul co ci cC cD csp co cmul co caddc
      co cmul co cmul co c2 cA cB csp co cC cD csp co cmin co cmul co cA ci cC
      csm co cva co cD ci cB csm co cva co csp co cA ci cC csm co cmv co cD ci
      cB csm co cmv co csp co cmin co c2 ci cneg cA cB csp co cmul co ci cC cD
      csp co cmul co caddc co cmul co ci cmul cA ci cC csm co cva co cD ci cB
      csm co cva co csp co cA ci cC csm co cmv co cD ci cB csm co cmv co csp co
      cmin co cA cD csp co ci cC csm co ci cB csm co csp co caddc co cA ci cB
      csm co csp co ci cC csm co cD csp co caddc co caddc co cA cD csp co ci cC
      csm co ci cB csm co csp co caddc co cA ci cB csm co csp co ci cC csm co
      cD csp co caddc co cmin co cmin co cA ci cB csm co csp co ci cC csm co cD
      csp co caddc co cA ci cB csm co csp co ci cC csm co cD csp co caddc co
      caddc co c2 ci cneg cA cB csp co cmul co ci cC cD csp co cmul co caddc co
      cmul co cA ci cC csm co cva co cD ci cB csm co cva co csp co cA cD csp co
      ci cC csm co ci cB csm co csp co caddc co cA ci cB csm co csp co ci cC
      csm co cD csp co caddc co caddc co cA ci cC csm co cmv co cD ci cB csm co
      cmv co csp co cA cD csp co ci cC csm co ci cB csm co csp co caddc co cA
      ci cB csm co csp co ci cC csm co cD csp co caddc co cmin co cmin cA ci cC
      csm co cD ci cB csm co polid2.1 ci cC axicn polid2.3 hvmulcli polid2.4 ci
      cB axicn polid2.2 hvmulcli normlem8 cA ci cC csm co cD ci cB csm co
      polid2.1 ci cC axicn polid2.3 hvmulcli polid2.4 ci cB axicn polid2.2
      hvmulcli normlem9 opreq12i cA cD csp co ci cC csm co ci cB csm co csp co
      caddc co cA ci cB csm co csp co ci cC csm co cD csp co caddc co cA ci cB
      csm co csp co ci cC csm co cD csp co caddc co cA cD csp co ci cC csm co
      ci cB csm co csp co cA cD polid2.1 polid2.4 hicli ci cC csm co ci cB csm
      co ci cC axicn polid2.3 hvmulcli ci cB axicn polid2.2 hvmulcli hicli
      addcli cA ci cB csm co csp co ci cC csm co cD csp co cA ci cB csm co
      polid2.1 ci cB axicn polid2.2 hvmulcli hicli ci cC csm co cD ci cC axicn
      polid2.3 hvmulcli polid2.4 hicli addcli cA ci cB csm co csp co ci cC csm
      co cD csp co cA ci cB csm co polid2.1 ci cB axicn polid2.2 hvmulcli hicli
      ci cC csm co cD ci cC axicn polid2.3 hvmulcli polid2.4 hicli addcli
      pnncani c2 cA ci cB csm co csp co ci cC csm co cD csp co caddc co cmul co
      cA ci cB csm co csp co ci cC csm co cD csp co caddc co cA ci cB csm co
      csp co ci cC csm co cD csp co caddc co caddc co c2 ci cneg cA cB csp co
      cmul co ci cC cD csp co cmul co caddc co cmul co cA ci cB csm co csp co
      ci cC csm co cD csp co caddc co cA ci cB csm co csp co ci cC csm co cD
      csp co cA ci cB csm co polid2.1 ci cB axicn polid2.2 hvmulcli hicli ci cC
      csm co cD ci cC axicn polid2.3 hvmulcli polid2.4 hicli addcli 2timesi cA
      ci cB csm co csp co ci cC csm co cD csp co caddc co ci cneg cA cB csp co
      cmul co ci cC cD csp co cmul co caddc co c2 cmul cA ci cB csm co csp co
      ci cneg cA cB csp co cmul co ci cC csm co cD csp co ci cC cD csp co cmul
      co caddc cA ci cB csm co csp co ci ccj cfv cA cB csp co cmul co ci cneg
      cA cB csp co cmul co ci cc wcel cA chil wcel cB chil wcel cA ci cB csm co
      csp co ci ccj cfv cA cB csp co cmul co wceq axicn polid2.1 polid2.2 ci cA
      cB his5 mp3an ci ccj cfv ci cneg cA cB csp co cmul cji opreq1i eqtri ci
      cc wcel cC chil wcel cD chil wcel ci cC csm co cD csp co ci cC cD csp co
      cmul co wceq axicn polid2.3 polid2.4 ci cC cD ax-his3 mp3an opreq12i
      opreq2i eqtr3i 3eqtri opreq2i c2 ci ci cneg cA cB csp co cmul co ci cC cD
      csp co cmul co caddc co 2cn axicn ci cneg cA cB csp co cmul co ci cC cD
      csp co cmul co ci cneg cA cB csp co ci axicn negcli cA cB polid2.1
      polid2.2 hicli mulcli ci cC cD csp co axicn cC cD polid2.3 polid2.4 hicli
      mulcli addcli mul12i ci ci cneg cA cB csp co cmul co ci cC cD csp co cmul
      co caddc co cmul co cA cB csp co cC cD csp co cmin co c2 cmul ci ci cneg
      cA cB csp co cmul co ci cC cD csp co cmul co caddc co cmul co ci ci cneg
      cA cB csp co cmul co cmul co ci ci cC cD csp co cmul co cmul co caddc co
      cA cB csp co cC cD csp co cneg caddc co cA cB csp co cC cD csp co cmin co
      ci ci cneg cA cB csp co cmul co ci cC cD csp co cmul co axicn ci cneg cA
      cB csp co ci axicn negcli cA cB polid2.1 polid2.2 hicli mulcli ci cC cD
      csp co axicn cC cD polid2.3 polid2.4 hicli mulcli adddii ci ci cneg cA cB
      csp co cmul co cmul co cA cB csp co ci ci cC cD csp co cmul co cmul co cC
      cD csp co cneg caddc ci ci cneg cmul co cA cB csp co cmul co c1 cA cB csp
      co cmul co ci ci cneg cA cB csp co cmul co cmul co cA cB csp co ci ci
      cneg cmul co c1 cA cB csp co cmul ci ci cneg cmul co ci ci cmul co cneg
      c1 cneg cneg c1 ci ci axicn axicn mulneg2i ci ci cmul co c1 cneg ixi
      negeqi c1 ax1cn negnegi 3eqtri opreq1i ci ci cneg cA cB csp co axicn ci
      axicn negcli cA cB polid2.1 polid2.2 hicli mulassi cA cB csp co cA cB
      polid2.1 polid2.2 hicli mulid2i 3eqtr3i ci ci cmul co cC cD csp co cmul
      co c1 cneg cC cD csp co cmul co ci ci cC cD csp co cmul co cmul co cC cD
      csp co cneg ci ci cmul co c1 cneg cC cD csp co cmul ixi opreq1i ci ci cC
      cD csp co axicn axicn cC cD polid2.3 polid2.4 hicli mulassi cC cD csp co
      cC cD polid2.3 polid2.4 hicli mulm1i 3eqtr3i opreq12i cA cB csp co cC cD
      csp co cA cB polid2.1 polid2.2 hicli cC cD polid2.3 polid2.4 hicli
      negsubi 3eqtri opreq2i 3eqtr2i opreq12i 3eqtr4i opreq1i eqtr3i $.
      $( [11-Jul-2005] $) $( [30-Jun-2005] $)
  $}

  ${
    polid.1 $e |- A e. ~H $.
    polid.2 $e |- B e. ~H $.
    $( Polarization identity.  Recovers inner product from norm.  Exercise 4(a)
       of [ReedSimon] p. 63.  The outermost operation is + instead of - due to
       our mathematicians' (rather than physicists') version of axiom
       ~ ax-his3 . $)
    polidi $p |- ( A .ih B ) = ( ( ( ( ( normh ` ( A +h B ) ) ^ 2 ) -
                ( ( normh ` ( A -h B ) ) ^ 2 ) ) +
       ( _i x. ( ( ( normh ` ( A +h ( _i .h B ) ) ) ^ 2 ) -
                ( ( normh ` ( A -h ( _i .h B ) ) ) ^ 2 ) ) ) ) / 4 ) $=
      cA cB csp co cA cB cva co cA cB cva co csp co cA cB cmv co cA cB cmv co
      csp co cmin co ci cA ci cB csm co cva co cA ci cB csm co cva co csp co cA
      ci cB csm co cmv co cA ci cB csm co cmv co csp co cmin co cmul co caddc
      co c4 cdiv co cA cB cva co cno cfv c2 cexp co cA cB cmv co cno cfv c2
      cexp co cmin co ci cA ci cB csm co cva co cno cfv c2 cexp co cA ci cB csm
      co cmv co cno cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co cA cB cB
      cA polid.1 polid.2 polid.2 polid.1 polid2i cA cB cva co cno cfv c2 cexp
      co cA cB cmv co cno cfv c2 cexp co cmin co ci cA ci cB csm co cva co cno
      cfv c2 cexp co cA ci cB csm co cmv co cno cfv c2 cexp co cmin co cmul co
      caddc co cA cB cva co cA cB cva co csp co cA cB cmv co cA cB cmv co csp
      co cmin co ci cA ci cB csm co cva co cA ci cB csm co cva co csp co cA ci
      cB csm co cmv co cA ci cB csm co cmv co csp co cmin co cmul co caddc co
      c4 cdiv cA cB cva co cno cfv c2 cexp co cA cB cmv co cno cfv c2 cexp co
      cmin co cA cB cva co cA cB cva co csp co cA cB cmv co cA cB cmv co csp co
      cmin co ci cA ci cB csm co cva co cno cfv c2 cexp co cA ci cB csm co cmv
      co cno cfv c2 cexp co cmin co cmul co ci cA ci cB csm co cva co cA ci cB
      csm co cva co csp co cA ci cB csm co cmv co cA ci cB csm co cmv co csp co
      cmin co cmul co caddc cA cB cva co cno cfv c2 cexp co cA cB cva co cA cB
      cva co csp co cA cB cmv co cno cfv c2 cexp co cA cB cmv co cA cB cmv co
      csp co cmin cA cB cva co cA cB polid.1 polid.2 hvaddcli normsqi cA cB cmv
      co cA cB polid.1 polid.2 hvsubcli normsqi opreq12i cA ci cB csm co cva co
      cno cfv c2 cexp co cA ci cB csm co cmv co cno cfv c2 cexp co cmin co cA
      ci cB csm co cva co cA ci cB csm co cva co csp co cA ci cB csm co cmv co
      cA ci cB csm co cmv co csp co cmin co ci cmul cA ci cB csm co cva co cno
      cfv c2 cexp co cA ci cB csm co cva co cA ci cB csm co cva co csp co cA ci
      cB csm co cmv co cno cfv c2 cexp co cA ci cB csm co cmv co cA ci cB csm
      co cmv co csp co cmin cA ci cB csm co cva co cA ci cB csm co polid.1 ci
      cB axicn polid.2 hvmulcli hvaddcli normsqi cA ci cB csm co cmv co cA ci
      cB csm co polid.1 ci cB axicn polid.2 hvmulcli hvsubcli normsqi opreq12i
      opreq2i opreq12i opreq1i eqtr4i $.
      $( [20-Jul-2005] $) $( [30-Jun-2005] $)
  $}

  $( Polarization identity.  Recovers inner product from norm.  Exercise 4(a)
     of [ReedSimon] p. 63.  The outermost operation is + instead of - due to
     our mathematicians' (rather than physicists') version of axiom
     ~ ax-his3 . $)
  polid $p |- ( ( A e. ~H /\ B e. ~H ) ->
           ( A .ih B ) = ( ( ( ( ( normh ` ( A +h B ) ) ^ 2 ) -
              ( ( normh ` ( A -h B ) ) ^ 2 ) ) +
       ( _i x. ( ( ( normh ` ( A +h ( _i .h B ) ) ) ^ 2 ) -
                ( ( normh ` ( A -h ( _i .h B ) ) ) ^ 2 ) ) ) ) / 4 ) ) $=
    cA chil wcel cB chil wcel cA cB csp co cA cB cva co cno cfv c2 cexp co cA
    cB cmv co cno cfv c2 cexp co cmin co ci cA ci cB csm co cva co cno cfv c2
    cexp co cA ci cB csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc co
    c4 cdiv co wceq cA chil wcel cA c0v cif cB csp co cA chil wcel cA c0v cif
    cB cva co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cmv co cno cfv c2
    cexp co cmin co ci cA chil wcel cA c0v cif ci cB csm co cva co cno cfv c2
    cexp co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2 cexp co cmin
    co cmul co caddc co c4 cdiv co wceq cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno
    cfv c2 cexp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno
    cfv c2 cexp co cmin co ci cA chil wcel cA c0v cif ci cB chil wcel cB c0v
    cif csm co cva co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB chil
    wcel cB c0v cif csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc co
    c4 cdiv co wceq cA cB c0v c0v cA cA chil wcel cA c0v cif wceq cA cB csp co
    cA chil wcel cA c0v cif cB csp co cA cB cva co cno cfv c2 cexp co cA cB cmv
    co cno cfv c2 cexp co cmin co ci cA ci cB csm co cva co cno cfv c2 cexp co
    cA ci cB csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc co c4 cdiv
    co cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co cA chil wcel cA c0v
    cif cB cmv co cno cfv c2 cexp co cmin co ci cA chil wcel cA c0v cif ci cB
    csm co cva co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB csm co cmv
    co cno cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co cA cA chil wcel
    cA c0v cif cB csp opreq1 cA cA chil wcel cA c0v cif wceq cA cB cva co cno
    cfv c2 cexp co cA cB cmv co cno cfv c2 cexp co cmin co ci cA ci cB csm co
    cva co cno cfv c2 cexp co cA ci cB csm co cmv co cno cfv c2 cexp co cmin co
    cmul co caddc co cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co cA
    chil wcel cA c0v cif cB cmv co cno cfv c2 cexp co cmin co ci cA chil wcel
    cA c0v cif ci cB csm co cva co cno cfv c2 cexp co cA chil wcel cA c0v cif
    ci cB csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc co c4 cdiv cA
    cA chil wcel cA c0v cif wceq cA cB cva co cno cfv c2 cexp co cA cB cmv co
    cno cfv c2 cexp co cmin co cA chil wcel cA c0v cif cB cva co cno cfv c2
    cexp co cA chil wcel cA c0v cif cB cmv co cno cfv c2 cexp co cmin co ci cA
    ci cB csm co cva co cno cfv c2 cexp co cA ci cB csm co cmv co cno cfv c2
    cexp co cmin co cmul co ci cA chil wcel cA c0v cif ci cB csm co cva co cno
    cfv c2 cexp co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2 cexp
    co cmin co cmul co caddc cA cA chil wcel cA c0v cif wceq cA cB cva co cno
    cfv c2 cexp co cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co cA cB
    cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cmv co cno cfv c2 cexp
    co cmin cA cA chil wcel cA c0v cif wceq cA cB cva co cno cfv cA chil wcel
    cA c0v cif cB cva co cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq cA cB
    cva co cA chil wcel cA c0v cif cB cva co cno cA cA chil wcel cA c0v cif cB
    cva opreq1 fveq2d opreq1d cA cA chil wcel cA c0v cif wceq cA cB cmv co cno
    cfv cA chil wcel cA c0v cif cB cmv co cno cfv c2 cexp cA cA chil wcel cA
    c0v cif wceq cA cB cmv co cA chil wcel cA c0v cif cB cmv co cno cA cA chil
    wcel cA c0v cif cB cmv opreq1 fveq2d opreq1d opreq12d cA cA chil wcel cA
    c0v cif wceq cA ci cB csm co cva co cno cfv c2 cexp co cA ci cB csm co cmv
    co cno cfv c2 cexp co cmin co cA chil wcel cA c0v cif ci cB csm co cva co
    cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2
    cexp co cmin co ci cmul cA cA chil wcel cA c0v cif wceq cA ci cB csm co cva
    co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB csm co cva co cno cfv
    c2 cexp co cA ci cB csm co cmv co cno cfv c2 cexp co cA chil wcel cA c0v
    cif ci cB csm co cmv co cno cfv c2 cexp co cmin cA cA chil wcel cA c0v cif
    wceq cA ci cB csm co cva co cno cfv cA chil wcel cA c0v cif ci cB csm co
    cva co cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq cA ci cB csm co cva
    co cA chil wcel cA c0v cif ci cB csm co cva co cno cA cA chil wcel cA c0v
    cif ci cB csm co cva opreq1 fveq2d opreq1d cA cA chil wcel cA c0v cif wceq
    cA ci cB csm co cmv co cno cfv cA chil wcel cA c0v cif ci cB csm co cmv co
    cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq cA ci cB csm co cmv co cA
    chil wcel cA c0v cif ci cB csm co cmv co cno cA cA chil wcel cA c0v cif ci
    cB csm co cmv opreq1 fveq2d opreq1d opreq12d opreq2d opreq12d opreq1d
    eqeq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB csp co
    cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cA chil wcel cA c0v
    cif cB cva co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cmv co cno cfv
    c2 cexp co cmin co ci cA chil wcel cA c0v cif ci cB csm co cva co cno cfv
    c2 cexp co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2 cexp co
    cmin co cmul co caddc co c4 cdiv co cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif cva co cno cfv c2 cexp co cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif cmv co cno cfv c2 cexp co cmin co ci cA chil wcel cA c0v cif ci cB
    chil wcel cB c0v cif csm co cva co cno cfv c2 cexp co cA chil wcel cA c0v
    cif ci cB chil wcel cB c0v cif csm co cmv co cno cfv c2 cexp co cmin co
    cmul co caddc co c4 cdiv co cB cB chil wcel cB c0v cif cA chil wcel cA c0v
    cif csp opreq2 cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB
    cva co cno cfv c2 cexp co cA chil wcel cA c0v cif cB cmv co cno cfv c2 cexp
    co cmin co ci cA chil wcel cA c0v cif ci cB csm co cva co cno cfv c2 cexp
    co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2 cexp co cmin co
    cmul co caddc co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno
    cfv c2 cexp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno
    cfv c2 cexp co cmin co ci cA chil wcel cA c0v cif ci cB chil wcel cB c0v
    cif csm co cva co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB chil
    wcel cB c0v cif csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc co
    c4 cdiv cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cva co
    cno cfv c2 cexp co cA chil wcel cA c0v cif cB cmv co cno cfv c2 cexp co
    cmin co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cno cfv c2
    cexp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cfv c2
    cexp co cmin co ci cA chil wcel cA c0v cif ci cB csm co cva co cno cfv c2
    cexp co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2 cexp co cmin
    co cmul co ci cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva
    co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif
    csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc cB cB chil wcel cB
    c0v cif wceq cA chil wcel cA c0v cif cB cva co cno cfv c2 cexp co cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif cva co cno cfv c2 cexp co cA chil
    wcel cA c0v cif cB cmv co cno cfv c2 cexp co cA chil wcel cA c0v cif cB
    chil wcel cB c0v cif cmv co cno cfv c2 cexp co cmin cB cB chil wcel cB c0v
    cif wceq cA chil wcel cA c0v cif cB cva co cno cfv cA chil wcel cA c0v cif
    cB chil wcel cB c0v cif cva co cno cfv c2 cexp cB cB chil wcel cB c0v cif
    wceq cA chil wcel cA c0v cif cB cva co cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif cva co cno cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif
    cva opreq2 fveq2d opreq1d cB cB chil wcel cB c0v cif wceq cA chil wcel cA
    c0v cif cB cmv co cno cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif
    cmv co cno cfv c2 cexp cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v
    cif cB cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cno cB
    cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d opreq1d
    opreq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif ci cB csm
    co cva co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB csm co cmv co
    cno cfv c2 cexp co cmin co cA chil wcel cA c0v cif ci cB chil wcel cB c0v
    cif csm co cva co cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB chil
    wcel cB c0v cif csm co cmv co cno cfv c2 cexp co cmin co ci cmul cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif ci cB csm co cva co cno cfv c2
    cexp co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co
    cno cfv c2 cexp co cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv c2
    cexp co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co
    cno cfv c2 cexp co cmin cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v
    cif ci cB csm co cva co cno cfv cA chil wcel cA c0v cif ci cB chil wcel cB
    c0v cif csm co cva co cno cfv c2 cexp cB cB chil wcel cB c0v cif wceq cA
    chil wcel cA c0v cif ci cB csm co cva co cA chil wcel cA c0v cif ci cB chil
    wcel cB c0v cif csm co cva co cno cB cB chil wcel cB c0v cif wceq ci cB csm
    co ci cB chil wcel cB c0v cif csm co cA chil wcel cA c0v cif cva cB cB chil
    wcel cB c0v cif ci csm opreq2 opreq2d fveq2d opreq1d cB cB chil wcel cB c0v
    cif wceq cA chil wcel cA c0v cif ci cB csm co cmv co cno cfv cA chil wcel
    cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co cno cfv c2 cexp cB cB
    chil wcel cB c0v cif wceq cA chil wcel cA c0v cif ci cB csm co cmv co cA
    chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co cno cB cB
    chil wcel cB c0v cif wceq ci cB csm co ci cB chil wcel cB c0v cif csm co cA
    chil wcel cA c0v cif cmv cB cB chil wcel cB c0v cif ci csm opreq2 opreq2d
    fveq2d opreq1d opreq12d opreq2d opreq12d opreq1d eqeq12d cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif cA c0v chil ax-hv0cl elimel cB c0v chil
    ax-hv0cl elimel polidi dedth2h $.
    $( [24-Dec-2007] $) $( [17-Nov-2007] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Relate Hilbert space to normed complex vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Hilbert space vector addition is an Abelian group operation. $)
    hilabl $p |- +h e. Abel $=
      vx vy cva chil vx vy vz c0v cva c1 cneg vx cv csm co chil ax-hilex
      ax-hfvadd vx cv vy cv vz cv ax-hvass ax-hv0cl vx cv hvaddid2 c1 cneg cc
      wcel vx cv chil wcel c1 cneg vx cv csm co chil wcel c1 ax1cn negcli c1
      cneg vx cv hvmulcl mpan vx cv chil wcel c1 cneg vx cv csm co vx cv cva co
      vx cv c1 cneg vx cv csm co cva co c0v c1 cneg vx cv csm co chil wcel vx
      cv chil wcel c1 cneg vx cv csm co vx cv cva co vx cv c1 cneg vx cv csm co
      cva co wceq c1 cneg cc wcel vx cv chil wcel c1 cneg vx cv csm co chil
      wcel c1 ax1cn negcli c1 cneg vx cv hvmulcl mpan c1 cneg vx cv csm co vx
      cv ax-hvcom mpancom vx cv hvnegid eqtrd isgrpi chil chil cxp chil cva
      ax-hfvadd fdmi vx cv vy cv ax-hvcom isabli $.
      $( [10-Aug-2008] $) $( [15-Apr-2007] $)

    $( The group identity element of Hilbert space vector addition is the zero
       vector. $)
    hilid $p |- ( Id ` +h ) = 0h $=
      c0v vx cv cva co vx cv wceq vx chil wral cva cgi cfv c0v wceq c0v vx cv
      cva co vx cv wceq vx chil vx cv hvaddid2 rgen c0v chil wcel c0v vx cv cva
      co vx cv wceq vx chil wral cva cgi cfv c0v wceq wb ax-hv0cl vy cv vx cv
      cva co vx cv wceq vx chil wral vy cv vx cv cva co vx cv wceq vx chil wral
      vy chil crab cuni vy cv wceq wb c0v vx cv cva co vx cv wceq vx chil wral
      cva cgi cfv c0v wceq wb vy c0v chil vy cv c0v wceq vy cv vx cv cva co vx
      cv wceq vx chil wral c0v vx cv cva co vx cv wceq vx chil wral vy cv vx cv
      cva co vx cv wceq vx chil wral vy chil crab cuni vy cv wceq cva cgi cfv
      c0v wceq vy cv c0v wceq vy cv vx cv cva co vx cv wceq c0v vx cv cva co vx
      cv wceq vx chil vy cv c0v wceq vy cv vx cv cva co c0v vx cv cva co vx cv
      vy cv c0v vx cv cva opreq1 eqeq1d ralbidv cva cgi cfv vy cv vx cv cva co
      vx cv wceq vx chil wral vy chil crab cuni wceq vy cv c0v wceq vy cv vx cv
      cva co vx cv wceq vx chil wral vy chil crab cuni vy cv wceq cva cgi cfv
      c0v wceq wb cva cgr wcel cva cgi cfv vy cv vx cv cva co vx cv wceq vx
      chil wral vy chil crab cuni wceq cva cabl wcel cva cgr wcel hilabl cva
      ablgrp ax-mp vx vy cva cgi cfv cva chil cva chil cva cabl wcel cva cgr
      wcel hilabl cva ablgrp ax-mp chil chil cxp chil cva ax-hfvadd fdmi grprn
      cva cgi cfv eqid grpidval ax-mp vy cv vx cv cva co vx cv wceq vx chil
      wral vy chil crab cuni cva cgi cfv wceq vy cv c0v wceq vy cv vx cv cva co
      vx cv wceq vx chil wral vy chil crab cuni vy cv wceq cva cgi cfv c0v wceq
      wb cva cgi cfv vy cv vx cv cva co vx cv wceq vx chil wral vy chil crab
      cuni wceq vy cv vx cv cva co vx cv wceq vx chil wral vy chil crab cuni
      cva cgi cfv vy cv c0v eqeq12 cva cgi cfv vy cv vx cv cva co vx cv wceq vx
      chil wral vy chil crab cuni eqcom sylanb mpan bibi12d vy cv chil wcel vy
      cv vx cv cva co vx cv wceq vx chil wral vy chil wreu vy cv vx cv cva co
      vx cv wceq vx chil wral vy cv vx cv cva co vx cv wceq vx chil wral vy
      chil crab cuni vy cv wceq wb cva cgr wcel vy cv vx cv cva co vx cv wceq
      vx chil wral vy chil wreu cva cabl wcel cva cgr wcel hilabl cva ablgrp
      ax-mp vx vy cva chil cva chil cva cabl wcel cva cgr wcel hilabl cva
      ablgrp ax-mp chil chil cxp chil cva ax-hfvadd fdmi grprn grpideu ax-mp vy
      cv vx cv cva co vx cv wceq vx chil wral vy chil reuuni1 mpan2 vtoclga
      ax-mp mpbi $.
      $( [25-Jul-2008] $) $( [16-Apr-2007] $)

    $( Hilbert space is a complex vector space.  Vector addition is ` +h ` ,
       and scalar product is ` .h ` . $)
    hilvc $p |- <. +h , .h >. e. CVec $=
      vx vy vz csm cva cva csm cop chil hilabl chil chil cxp chil cva ax-hfvadd
      fdmi ax-hfvmul vx cv ax-hvmulid vy cv vx cv vz cv ax-hvdistr1 vy cv vz cv
      vx cv ax-hvdistr2 vy cv vz cv vx cv ax-hvmulass cva csm cop eqid isvci $.
      $( [23-Apr-2007] $) $( [15-Apr-2007] $)
  $}

  ${
    $d x y U $.
    hilnorm.5 $e |- ~H = ( BaseSet ` U ) $.
    hilnorm.2 $e |- .ih = ( .i ` U ) $.
    hilnorm.9 $e |- U e. NrmCVec $.
    $( Hilbert space norm in terms of vector space norm. $)
    hilnormi $p |- normh = ( norm ` U ) $=
      vx cv chil wcel vy cv vx cv cU cnm cfv cfv wceq wa vx vy copab vx cv chil
      wcel vy cv vx cv vx cv csp co csqr cfv wceq wa vx vy copab cU cnm cfv cno
      vx cv chil wcel vy cv vx cv cU cnm cfv cfv wceq wa vx cv chil wcel vy cv
      vx cv vx cv csp co csqr cfv wceq wa vx vy vx cv chil wcel vy cv vx cv cU
      cnm cfv cfv wceq vy cv vx cv vx cv csp co csqr cfv wceq vx cv chil wcel
      vx cv cU cnm cfv cfv vx cv vx cv csp co csqr cfv vy cv cU cnv wcel vx cv
      chil wcel vx cv cU cnm cfv cfv vx cv vx cv csp co csqr cfv wceq hilnorm.9
      vx cv csp cU cU cnm cfv chil hilnorm.5 cU cnm cfv eqid hilnorm.2 ipnm
      mpan eqeq2d pm5.32i opabbii cU cnm cfv chil wfn cU cnm cfv vx cv chil
      wcel vy cv vx cv cU cnm cfv cfv wceq wa vx vy copab wceq chil cr cU cnm
      cfv wf cU cnm cfv chil wfn cU cnv wcel chil cr cU cnm cfv wf hilnorm.9 cU
      cU cnm cfv chil hilnorm.5 cU cnm cfv eqid nvf ax-mp chil cr cU cnm cfv
      ffn ax-mp vx vy chil cU cnm cfv dffn5 mpbi vx vy dfhnorm2 3eqtr4ri $.
      $( [2-Dec-2007] $) $( [11-Sep-2007] $)
  $}

  ${
    hilhh.1 $e |- ~H = ( BaseSet ` U ) $.
    hilhh.2 $e |- +h = ( +v ` U ) $.
    hilhh.3 $e |- .h = ( .s ` U ) $.
    hilhh.5 $e |- .ih = ( .i ` U ) $.
    hilhh.9 $e |- U e. NrmCVec $.
    $( Deduce the structure of Hilbert space from its components. $)
    hilhhi $p |- U = <. <. +h , .h >. , normh >. $=
      cU cnv wcel cU cva csm cop cno cop wceq hilhh.9 csm cU cva cno hilhh.2
      hilhh.3 cU hilhh.1 hilhh.5 hilhh.9 hilnormi nvop ax-mp $.
      $( [11-Apr-2008] $) $( [10-Apr-2008] $)
  $}

  ${
    $d k v w x y z U $.
    hhnv.1 $e |- U = <. <. +h , .h >. , normh >. $.
    $( Hilbert space is a normed complex vector space. $)
    hhnv $p |- U e. NrmCVec $=
      vx vy csm cU cva cno chil c0v cva chil cva cabl wcel cva cgr wcel hilabl
      cva ablgrp ax-mp chil chil cxp chil cva ax-hfvadd fdmi grprn cva cgi cfv
      c0v hilid eqcomi hilvc normf vx cv chil wcel vx cv cno cfv cc0 wceq vx cv
      c0v wceq vx cv norm-i biimpa vy cv vx cv norm-iii vx cv vy cv norm-ii
      hhnv.1 isnvi $.
      $( [25-Jul-2008] $) $( [17-Nov-2007] $)

    $( The group (addition) operation of Hilbert space. $)
    hhva $p |- +h = ( +v ` U ) $=
      cU hhnv.1 cU hhnv.1 hhnv h2hva $.
      $( [29-Nov-2007] $) $( [17-Nov-2007] $)

    $( The base set of Hilbert space.  This theorem provides an independent
       proof of ~ df-hba (see comments in that definition). $)
    hhba $p |- ~H = ( BaseSet ` U ) $=
      chil cva crn cU cba cfv cva chil cva cabl wcel cva cgr wcel hilabl cva
      ablgrp ax-mp chil chil cxp chil cva ax-hfvadd fdmi grprn cU cva cU cba
      cfv cU cba cfv eqid cU hhnv.1 hhva bafval eqtr4i $.
      $( [25-Jul-2008] $) $( [17-Nov-2007] $)

    $( The zero vector of Hilbert space. $)
    hh0v $p |- 0h = ( 0v ` U ) $=
      cU cn0v cfv cU cpv cfv cgi cfv cva cgi cfv c0v cU cU cpv cfv cU cn0v cfv
      cU cpv cfv eqid cU cn0v cfv eqid 0vfval cva cU cpv cfv cgi cU hhnv.1 hhva
      fveq2i hilid 3eqtr2ri $.
      $( [20-Dec-2007] $) $( [17-Nov-2007] $)

    $( The scalar product operation of Hilbert space. $)
    hhsm $p |- .h = ( .s ` U ) $=
      cU hhnv.1 cU hhnv.1 hhnv h2hsm $.
      $( [29-Nov-2007] $) $( [17-Nov-2007] $)

    $( The vector subtraction operation of Hilbert space. $)
    hhvs $p |- -h = ( -v ` U ) $=
      cU hhnv.1 cU hhnv.1 hhnv cU hhnv.1 hhba h2hvs $.
      $( [13-Dec-2007] $) $( [13-Dec-2007] $)

    $( The norm function of Hilbert space. $)
    hhnm $p |- normh = ( norm ` U ) $=
      cU hhnv.1 cU hhnv.1 hhnv h2hnm $.
      $( [30-Nov-2007] $) $( [17-Nov-2007] $)

    ${
      hhims.2 $e |- D = ( normh o. -h ) $.
      $( The induced metric of Hilbert space. $)
      hhims $p |- D = ( IndMet ` U ) $=
        cD cno cmv ccom cU cims cfv hhims.2 cU cnv wcel cU cims cfv cno cmv
        ccom wceq cU hhnv.1 hhnv cU cims cfv cU cmv cno cU hhnv.1 hhvs cU
        hhnv.1 hhnm cU cims cfv eqid imsval ax-mp eqtr4i $.
        $( [26-Nov-2007] $) $( [17-Nov-2007] $)
    $}

    ${
      hhims2.2 $e |- D = ( IndMet ` U ) $.
      $( Hilbert space distance metric. $)
      hhims2 $p |- D = ( normh o. -h ) $=
        cD cU cims cfv cno cmv ccom hhims2.2 cno cmv ccom cU hhnv.1 cno cmv
        ccom eqid hhims eqtr4i $.
        $( [11-Apr-2008] $) $( [10-Apr-2008] $)

      $( The induced metric of Hilbert space. $)
      hhmet $p |- D e. Met $=
        cU cnv wcel cD cme wcel cU hhnv.1 hhnv cD cU hhims2.2 imsmet ax-mp $.
        $( [10-Apr-2008] $) $( [10-Apr-2008] $)

      $( The base set for the metric for Hilbert space. $)
      hhmetba $p |- ~H = dom dom D $=
        cD cU hhnv.1 cU hhnv.1 hhnv cU hhnv.1 hhba hhims2.2 h2hmetba $.
        $( [10-Apr-2008] $) $( [10-Apr-2008] $)

      $( Value of the distance function of the metric space of Hilbert
         space. $)
      hhmetdval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( A D B ) = ( normh ` ( A -h B ) ) ) $=
        cA cB cD cU hhnv.1 cU hhnv.1 hhnv cU hhnv.1 hhba hhims2.2 h2hmetdval $.
        $( [10-Apr-2008] $) $( [10-Apr-2008] $)
    $}

    $( The inner product operation of Hilbert space. $)
    hhip $p |- .ih = ( .i ` U ) $=
      csp cU cip cfv wceq chil chil cxp chil chil cxp wceq vx cv vy cv csp co
      vx cv vy cv cU cip cfv co wceq vy chil wral vx chil wral csp chil chil
      cxp wfn cU cip cfv chil chil cxp wfn csp cU cip cfv wceq chil chil cxp
      chil chil cxp wceq vx cv vy cv csp co vx cv vy cv cU cip cfv co wceq vy
      chil wral vx chil wral wa wb chil chil cxp cc csp wf csp chil chil cxp
      wfn ax-hfi chil chil cxp cc csp ffn ax-mp vz vw vv chil chil c1 c4 cfz co
      ci vk cv cexp co vz cv ci vk cv cexp co vw cv csm co cva co cno cfv c2
      cexp co cmul co vk csu c4 cdiv co cU cip cfv c1 c4 cfz co ci vk cv cexp
      co vz cv ci vk cv cexp co vw cv csm co cva co cno cfv c2 cexp co cmul co
      vk csu c4 cdiv oprex cU cnv wcel cU cip cfv vz cv chil wcel vw cv chil
      wcel wa vv cv c1 c4 cfz co ci vk cv cexp co vz cv ci vk cv cexp co vw cv
      csm co cva co cno cfv c2 cexp co cmul co vk csu c4 cdiv co wceq wa vz vw
      vv copab2 wceq cU hhnv.1 hhnv vz vw vv cU cip cfv csm cU vk cva cno chil
      cU hhnv.1 hhba cU hhnv.1 hhva cU hhnv.1 hhsm cU hhnv.1 hhnm cU cip cfv
      eqid ipfval ax-mp fnoprab2 vx vy chil chil chil chil csp cU cip cfv
      eqfnoprv mp2an chil chil cxp eqid vx cv vy cv csp co vx cv vy cv cU cip
      cfv co wceq vx vy chil vx cv chil wcel vy cv chil wcel wa vx cv vy cv csp
      co vx cv vy cv cva co cno cfv c2 cexp co vx cv vy cv cmv co cno cfv c2
      cexp co cmin co ci vx cv ci vy cv csm co cva co cno cfv c2 cexp co vx cv
      ci vy cv csm co cmv co cno cfv c2 cexp co cmin co cmul co caddc co c4
      cdiv co vx cv vy cv cU cip cfv co vx cv vy cv polid cU cnv wcel vx cv
      chil wcel vy cv chil wcel vx cv vy cv cU cip cfv co vx cv vy cv cva co
      cno cfv c2 cexp co vx cv vy cv cmv co cno cfv c2 cexp co cmin co ci vx cv
      ci vy cv csm co cva co cno cfv c2 cexp co vx cv ci vy cv csm co cmv co
      cno cfv c2 cexp co cmin co cmul co caddc co c4 cdiv co wceq cU hhnv.1
      hhnv vx cv vy cv cU cip cfv csm cU cva cmv cno chil cU hhnv.1 hhba cU
      hhnv.1 hhva cU hhnv.1 hhsm cU hhnv.1 hhnm cU cip cfv eqid cU hhnv.1 hhvs
      ipval3 mp3an1 eqtr4d rgen2a mpbir2an $.
      $( [27-Dec-2007] $) $( [17-Nov-2007] $)

    $( The Hilbert space of the Hilbert Space Explorer is an inner product
       space. $)
    hhph $p |- U e. CPreHil $=
      cU cphl wcel cva csm cop cno cop cnv wcel vx cv vy cv cva co cno cfv c2
      cexp co vx cv c1 cneg vy cv csm co cva co cno cfv c2 cexp co caddc co c2
      vx cv cno cfv c2 cexp co vy cv cno cfv c2 cexp co caddc co cmul co wceq
      vy chil wral vx chil wral cva cvv wcel csm cvv wcel cno cvv wcel cU cphl
      wcel cva csm cop cno cop cnv wcel vx cv vy cv cva co cno cfv c2 cexp co
      vx cv c1 cneg vy cv csm co cva co cno cfv c2 cexp co caddc co c2 vx cv
      cno cfv c2 cexp co vy cv cno cfv c2 cexp co caddc co cmul co wceq vy chil
      wral vx chil wral wa wb cva cabl hilabl elisseti hvmulex chil cr cno wf
      chil cvv wcel cno cvv wcel normf ax-hilex chil cr cvv cno fex mp2an cva
      cvv wcel csm cvv wcel cno cvv wcel w3a cva csm cop cno cop cphl wcel cva
      csm cop cno cop cnv wcel vx cv vy cv cva co cno cfv c2 cexp co vx cv c1
      cneg vy cv csm co cva co cno cfv c2 cexp co caddc co c2 vx cv cno cfv c2
      cexp co vy cv cno cfv c2 cexp co caddc co cmul co wceq vy chil wral vx
      chil wral wa cU cphl wcel vx vy cvv cvv cvv csm cva cno chil cva chil cva
      cabl wcel cva cgr wcel hilabl cva ablgrp ax-mp chil chil cxp chil cva
      ax-hfvadd fdmi grprn isphg cU cva csm cop cno cop cphl hhnv.1 eleq1i
      syl5bb mp3an cva csm cop cno cop cva csm cop cno cop eqid hhnv vx cv vy
      cv cva co cno cfv c2 cexp co vx cv c1 cneg vy cv csm co cva co cno cfv c2
      cexp co caddc co c2 vx cv cno cfv c2 cexp co vy cv cno cfv c2 cexp co
      caddc co cmul co wceq vx vy chil vx cv chil wcel vy cv chil wcel wa vx cv
      vy cv cmv co cno cfv c2 cexp co vx cv vy cv cva co cno cfv c2 cexp co
      caddc co c2 vx cv cno cfv c2 cexp co cmul co c2 vy cv cno cfv c2 cexp co
      cmul co caddc co vx cv vy cv cva co cno cfv c2 cexp co vx cv c1 cneg vy
      cv csm co cva co cno cfv c2 cexp co caddc co c2 vx cv cno cfv c2 cexp co
      vy cv cno cfv c2 cexp co caddc co cmul co vx cv vy cv normpar vx cv chil
      wcel vy cv chil wcel wa vx cv vy cv cva co cno cfv c2 cexp co vx cv vy cv
      cmv co cno cfv c2 cexp co caddc co vx cv vy cv cva co cno cfv c2 cexp co
      vx cv c1 cneg vy cv csm co cva co cno cfv c2 cexp co caddc co vx cv vy cv
      cmv co cno cfv c2 cexp co vx cv vy cv cva co cno cfv c2 cexp co caddc co
      vx cv chil wcel vy cv chil wcel wa vx cv vy cv cmv co cno cfv c2 cexp co
      vx cv c1 cneg vy cv csm co cva co cno cfv c2 cexp co vx cv vy cv cva co
      cno cfv c2 cexp co caddc vx cv chil wcel vy cv chil wcel wa vx cv vy cv
      cmv co cno cfv vx cv c1 cneg vy cv csm co cva co cno cfv c2 cexp vx cv
      chil wcel vy cv chil wcel wa vx cv vy cv cmv co vx cv c1 cneg vy cv csm
      co cva co cno vx cv vy cv hvsubval fveq2d opreq1d opreq2d vx cv vy cv cva
      co cno cfv c2 cexp co cc wcel vx cv vy cv cmv co cno cfv c2 cexp co cc
      wcel vx cv vy cv cva co cno cfv c2 cexp co vx cv vy cv cmv co cno cfv c2
      cexp co caddc co vx cv vy cv cmv co cno cfv c2 cexp co vx cv vy cv cva co
      cno cfv c2 cexp co caddc co wceq vx cv chil wcel vy cv chil wcel wa vx cv
      vy cv cva co cno cfv c2 cexp co vx cv vy cv cmv co cno cfv c2 cexp co
      addcom vx cv chil wcel vy cv chil wcel wa vx cv vy cv cva co cno cfv cc
      wcel vx cv vy cv cva co cno cfv c2 cexp co cc wcel vx cv chil wcel vy cv
      chil wcel wa vx cv vy cv cva co cno cfv vx cv chil wcel vy cv chil wcel
      wa vx cv vy cv cva co chil wcel vx cv vy cv cva co cno cfv cr wcel vx cv
      vy cv hvaddcl vx cv vy cv cva co normcl syl recnd vx cv vy cv cva co cno
      cfv sqcl syl vx cv chil wcel vy cv chil wcel wa vx cv vy cv cmv co chil
      wcel vx cv vy cv cmv co cno cfv cc wcel vx cv vy cv cmv co cno cfv c2
      cexp co cc wcel vx cv vy cv hvsubcl vx cv vy cv cmv co chil wcel vx cv vy
      cv cmv co cno cfv vx cv vy cv cmv co normcl recnd vx cv vy cv cmv co cno
      cfv sqcl 3syl sylanc eqtr3d vx cv cno cfv c2 cexp co cc wcel vy cv cno
      cfv c2 cexp co cc wcel c2 vx cv cno cfv c2 cexp co vy cv cno cfv c2 cexp
      co caddc co cmul co c2 vx cv cno cfv c2 cexp co cmul co c2 vy cv cno cfv
      c2 cexp co cmul co caddc co wceq vx cv chil wcel vy cv chil wcel c2 cc
      wcel vx cv cno cfv c2 cexp co cc wcel vy cv cno cfv c2 cexp co cc wcel c2
      vx cv cno cfv c2 cexp co vy cv cno cfv c2 cexp co caddc co cmul co c2 vx
      cv cno cfv c2 cexp co cmul co c2 vy cv cno cfv c2 cexp co cmul co caddc
      co wceq 2cn c2 vx cv cno cfv c2 cexp co vy cv cno cfv c2 cexp co adddi
      mp3an1 vx cv chil wcel vx cv cno cfv cc wcel vx cv cno cfv c2 cexp co cc
      wcel vx cv chil wcel vx cv cno cfv vx cv normcl recnd vx cv cno cfv sqcl
      syl vy cv chil wcel vy cv cno cfv cc wcel vy cv cno cfv c2 cexp co cc
      wcel vy cv chil wcel vy cv cno cfv vy cv normcl recnd vy cv cno cfv sqcl
      syl syl2an 3eqtr4d rgen2a mpbir2an $.
      $( [25-Jul-2008] $) $( [24-Nov-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Bunjakovaskij-Cauchy-Schwarz inequality
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    bcs.1 $e |- A e. ~H $.
    bcs.2 $e |- B e. ~H $.
    $( Bunjakovaskij-Cauchy-Schwarz inequality.  Remark 3.4 of [Beran]
       p. 98. $)
    bcsiALT $p |- ( abs ` ( A .ih B ) )
          <_ ( ( normh ` A ) x. ( normh ` B ) ) $=
      cA cB csp co cc0 wceq cA cB csp co cabs cfv cA cno cfv cB cno cfv cmul co
      cle wbr cA cB csp co cc0 wceq cA cB csp co cabs cfv cc0 cabs cfv cA cno
      cfv cB cno cfv cmul co cle cA cB csp co cc0 cabs fveq2 cc0 cabs cfv cc0
      cA cno cfv cB cno cfv cmul co cle abs0 cc0 cA cno cfv cle wbr cc0 cB cno
      cfv cle wbr cc0 cA cno cfv cB cno cfv cmul co cle wbr cA chil wcel cc0 cA
      cno cfv cle wbr bcs.1 cA normge0 ax-mp cB chil wcel cc0 cB cno cfv cle
      wbr bcs.2 cB normge0 ax-mp cA cno cfv cB cno cfv cA bcs.1 normcli cB
      bcs.2 normcli mulge0i mp2an eqbrtri syl6eqbr cA cB csp co cc0 wceq wn c2
      cA cB csp co cabs cfv cmul co c2 cB cB csp co csqr cfv cA cA csp co csqr
      cfv cmul co cmul co cle wbr cA cB csp co cabs cfv cA cno cfv cB cno cfv
      cmul co cle wbr cA cB csp co cc0 wceq wn cA cB csp co cc0 wne c2 cA cB
      csp co cabs cfv cmul co c2 cB cB csp co csqr cfv cA cA csp co csqr cfv
      cmul co cmul co cle wbr cA cB csp co cc0 df-ne cA cB csp co cc0 wne c2 cA
      cB csp co cabs cfv cmul co cA cB csp co cA cB csp co cabs cfv cdiv co ccj
      cfv cA cB csp co cmul co cA cB csp co cA cB csp co cabs cfv cdiv co cB cA
      csp co cmul co caddc co c2 cB cB csp co csqr cfv cA cA csp co csqr cfv
      cmul co cmul co cle cA cB csp co cc0 wne cA cB csp co cA cB csp co cabs
      cfv cdiv co ccj cfv cA cB csp co cmul co cA cB csp co cA cB csp co cabs
      cfv cdiv co cA cB csp co ccj cfv cmul co caddc co c2 cA cB csp co cabs
      cfv cmul co cA cB csp co cA cB csp co cabs cfv cdiv co ccj cfv cA cB csp
      co cmul co cA cB csp co cA cB csp co cabs cfv cdiv co cB cA csp co cmul
      co caddc co cA cB csp co cA cB bcs.1 bcs.2 hicli abslem2 cA cB csp co cA
      cB csp co cabs cfv cdiv co cB cA csp co cmul co cA cB csp co cA cB csp co
      cabs cfv cdiv co cA cB csp co ccj cfv cmul co cA cB csp co cA cB csp co
      cabs cfv cdiv co ccj cfv cA cB csp co cmul co caddc cB cA csp co cA cB
      csp co ccj cfv cA cB csp co cA cB csp co cabs cfv cdiv co cmul cB cA
      bcs.2 bcs.1 his1i opreq2i opreq2i syl5req cA cB csp co cc0 wne cA cB csp
      co cA cB csp co cabs cfv cdiv co cc wcel cA cB csp co cA cB csp co cabs
      cfv cdiv co cabs cfv c1 wceq wa cA cB csp co cA cB csp co cabs cfv cdiv
      co ccj cfv cA cB csp co cmul co cA cB csp co cA cB csp co cabs cfv cdiv
      co cB cA csp co cmul co caddc co c2 cB cB csp co csqr cfv cA cA csp co
      csqr cfv cmul co cmul co cle wbr cA cB csp co cc0 wne cA cB csp co cabs
      cfv cc0 wne cA cB csp co cA cB csp co cabs cfv cdiv co cc wcel cA cB csp
      co cA cB csp co cabs cfv cdiv co cabs cfv c1 wceq wa cA cB csp co cabs
      cfv cc0 cA cB csp co cc0 cA cB csp co cA cB bcs.1 bcs.2 hicli abs00i
      necon3bii cA cB csp co cabs cfv cc0 wne cA cB csp co cA cB csp co cabs
      cfv cdiv co cc wcel cA cB csp co cA cB csp co cabs cfv cdiv co cabs cfv
      c1 wceq cA cB csp co cA cB csp co cabs cfv cA cB bcs.1 bcs.2 hicli cA cB
      csp co cabs cfv cA cB csp co cA cB bcs.1 bcs.2 hicli abscli recni divclzi
      cA cB csp co cabs cfv cc0 wne cA cB csp co cA cB csp co cabs cfv cdiv co
      cabs cfv cA cB csp co c1 cA cB csp co cabs cfv cdiv co cmul co cabs cfv
      cA cB csp co cabs cfv c1 cA cB csp co cabs cfv cdiv co cmul co c1 cA cB
      csp co cabs cfv cc0 wne cA cB csp co cA cB csp co cabs cfv cdiv co cA cB
      csp co c1 cA cB csp co cabs cfv cdiv co cmul co cabs cA cB csp co cA cB
      csp co cabs cfv cA cB bcs.1 bcs.2 hicli cA cB csp co cabs cfv cA cB csp
      co cA cB bcs.1 bcs.2 hicli abscli recni divreczi fveq2d cA cB csp co cabs
      cfv cc0 wne cA cB csp co c1 cA cB csp co cabs cfv cdiv co cmul co cabs
      cfv cA cB csp co cabs cfv c1 cA cB csp co cabs cfv cdiv co cabs cfv cmul
      co cA cB csp co cabs cfv c1 cA cB csp co cabs cfv cdiv co cmul co cA cB
      csp co cabs cfv cc0 wne cA cB csp co cc wcel c1 cA cB csp co cabs cfv
      cdiv co cc wcel wa cA cB csp co c1 cA cB csp co cabs cfv cdiv co cmul co
      cabs cfv cA cB csp co cabs cfv c1 cA cB csp co cabs cfv cdiv co cabs cfv
      cmul co wceq cA cB csp co cabs cfv cc0 wne c1 cA cB csp co cabs cfv cdiv
      co cc wcel cA cB csp co cc wcel cA cB csp co cabs cfv cA cB csp co cabs
      cfv cA cB csp co cA cB bcs.1 bcs.2 hicli abscli recni recclzi cA cB bcs.1
      bcs.2 hicli jctil cA cB csp co c1 cA cB csp co cabs cfv cdiv co absmul
      syl cA cB csp co cabs cfv cc0 wne c1 cA cB csp co cabs cfv cdiv co cabs
      cfv c1 cA cB csp co cabs cfv cdiv co cA cB csp co cabs cfv cmul c1 cA cB
      csp co cabs cfv cdiv co cr wcel cc0 c1 cA cB csp co cabs cfv cdiv co cle
      wbr c1 cA cB csp co cabs cfv cdiv co cabs cfv c1 cA cB csp co cabs cfv
      cdiv co wceq cA cB csp co cabs cfv cc0 wne c1 cA cB csp co cabs cfv cdiv
      co absid cA cB csp co cabs cfv cA cB csp co cA cB bcs.1 bcs.2 hicli
      abscli rerecclzi cc0 cr wcel c1 cA cB csp co cabs cfv cdiv co cr wcel wa
      cc0 c1 cA cB csp co cabs cfv cdiv co clt wbr cc0 c1 cA cB csp co cabs cfv
      cdiv co cle wbr cA cB csp co cabs cfv cc0 wne cc0 c1 cA cB csp co cabs
      cfv cdiv co ltle cA cB csp co cabs cfv cc0 wne c1 cA cB csp co cabs cfv
      cdiv co cr wcel cc0 cr wcel cA cB csp co cabs cfv cA cB csp co cA cB
      bcs.1 bcs.2 hicli abscli rerecclzi 0re jctil cA cB csp co cabs cfv cc0
      wne cc0 cA cB csp co cabs cfv clt wbr cc0 c1 cA cB csp co cabs cfv cdiv
      co clt wbr cA cB csp co cabs cfv cc0 wne cA cB csp co cc0 wne cc0 cA cB
      csp co cabs cfv clt wbr cA cB csp co cabs cfv cc0 cA cB csp co cc0 cA cB
      csp co cA cB bcs.1 bcs.2 hicli abs00i necon3bii cA cB csp co cA cB bcs.1
      bcs.2 hicli absgt0i bitri cA cB csp co cabs cfv cA cB csp co cA cB bcs.1
      bcs.2 hicli abscli recgt0i sylbi sylc sylanc opreq2d eqtrd cA cB csp co
      cabs cfv cA cB csp co cabs cfv cA cB csp co cA cB bcs.1 bcs.2 hicli
      abscli recni recidzi 3eqtrd jca sylbir cA cB cA cB csp co cA cB csp co
      cabs cfv cdiv co bcs.1 bcs.2 normlem7tALT syl eqbrtrd sylbir cA cB csp co
      cabs cfv cA cno cfv cB cno cfv cmul co cle wbr cA cB csp co cabs cfv cB
      cB csp co csqr cfv cA cA csp co csqr cfv cmul co cle wbr c2 cA cB csp co
      cabs cfv cmul co c2 cB cB csp co csqr cfv cA cA csp co csqr cfv cmul co
      cmul co cle wbr cA cno cfv cB cno cfv cmul co cB cB csp co csqr cfv cA cA
      csp co csqr cfv cmul co cA cB csp co cabs cfv cle cA cno cfv cB cno cfv
      cmul co cB cno cfv cA cno cfv cmul co cB cB csp co csqr cfv cA cA csp co
      csqr cfv cmul co cA cno cfv cB cno cfv cA cno cfv cA bcs.1 normcli recni
      cB cno cfv cB bcs.2 normcli recni mulcomi cB cno cfv cB cB csp co csqr
      cfv cA cno cfv cA cA csp co csqr cfv cmul cB chil wcel cB cno cfv cB cB
      csp co csqr cfv wceq bcs.2 cB normval ax-mp cA chil wcel cA cno cfv cA cA
      csp co csqr cfv wceq bcs.1 cA normval ax-mp opreq12i eqtri breq2i cc0 c2
      clt wbr cA cB csp co cabs cfv cB cB csp co csqr cfv cA cA csp co csqr cfv
      cmul co cle wbr c2 cA cB csp co cabs cfv cmul co c2 cB cB csp co csqr cfv
      cA cA csp co csqr cfv cmul co cmul co cle wbr wb 2pos cA cB csp co cabs
      cfv cB cB csp co csqr cfv cA cA csp co csqr cfv cmul co c2 cA cB csp co
      cA cB bcs.1 bcs.2 hicli abscli cB cB csp co csqr cfv cA cA csp co csqr
      cfv cc0 cB cB csp co cle wbr cB cB csp co csqr cfv cr wcel cB chil wcel
      cc0 cB cB csp co cle wbr bcs.2 cB hiidge0 ax-mp cB cB csp co cB chil wcel
      cB cB csp co cr wcel bcs.2 cB hiidrcl ax-mp sqrcli ax-mp cc0 cA cA csp co
      cle wbr cA cA csp co csqr cfv cr wcel cA chil wcel cc0 cA cA csp co cle
      wbr bcs.1 cA hiidge0 ax-mp cA cA csp co cA chil wcel cA cA csp co cr wcel
      bcs.1 cA hiidrcl ax-mp sqrcli ax-mp remulcli 2re lemul2i ax-mp bitri
      sylibr pm2.61i $.
      $( [11-Oct-1999] $)

    $( Bunjakovaskij-Cauchy-Schwarz inequality.  Remark 3.4 of [Beran]
       p. 98.  (Proved from ZFC version.) $)
    bcsiHIL $p |- ( abs ` ( A .ih B ) )
         <_ ( ( normh ` A ) x. ( normh ` B ) ) $=
      cA cB csp cva csm cop cno cop cno chil cva csm cop cno cop cva csm cop
      cno cop eqid hhba cva csm cop cno cop cva csm cop cno cop eqid hhnm cva
      csm cop cno cop cva csm cop cno cop eqid hhip cva csm cop cno cop cva csm
      cop cno cop eqid hhph bcs.1 bcs.2 siii $.
      $( [19-Mar-2008] $) $( [24-Nov-2007] $)
  $}

  $( Bunjakovaskij-Cauchy-Schwarz inequality.  Remark 3.4 of [Beran] p. 98. $)
  bcs $p |- ( ( A e. ~H /\ B e. ~H ) ->
             ( abs ` ( A .ih B ) ) <_ ( ( normh ` A ) x. ( normh ` B ) ) ) $=
    cA chil wcel cB chil wcel cA cB csp co cabs cfv cA cno cfv cB cno cfv cmul
    co cle wbr cA chil wcel cA c0v cif cB csp co cabs cfv cA chil wcel cA c0v
    cif cno cfv cB cno cfv cmul co cle wbr cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif csp co cabs cfv cA chil wcel cA c0v cif cno cfv cB chil wcel cB
    c0v cif cno cfv cmul co cle wbr cA cB c0v c0v cA cA chil wcel cA c0v cif
    wceq cA cB csp co cabs cfv cA chil wcel cA c0v cif cB csp co cabs cfv cA
    cno cfv cB cno cfv cmul co cA chil wcel cA c0v cif cno cfv cB cno cfv cmul
    co cle cA cA chil wcel cA c0v cif wceq cA cB csp co cA chil wcel cA c0v cif
    cB csp co cabs cA cA chil wcel cA c0v cif cB csp opreq1 fveq2d cA cA chil
    wcel cA c0v cif wceq cA cno cfv cA chil wcel cA c0v cif cno cfv cB cno cfv
    cmul cA cA chil wcel cA c0v cif cno fveq2 opreq1d breq12d cB cB chil wcel
    cB c0v cif wceq cA chil wcel cA c0v cif cB csp co cabs cfv cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif csp co cabs cfv cA chil wcel cA c0v cif cno
    cfv cB cno cfv cmul co cA chil wcel cA c0v cif cno cfv cB chil wcel cB c0v
    cif cno cfv cmul co cle cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v
    cif cB csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cabs
    cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif csp opreq2 fveq2d cB cB
    chil wcel cB c0v cif wceq cB cno cfv cB chil wcel cB c0v cif cno cfv cA
    chil wcel cA c0v cif cno cfv cmul cB cB chil wcel cB c0v cif cno fveq2
    opreq2d breq12d cA chil wcel cA c0v cif cB chil wcel cB c0v cif cA c0v chil
    ax-hv0cl elimel cB c0v chil ax-hv0cl elimel bcsiHIL dedth2h $.
    $( [19-Feb-2006] $) $( [16-Feb-2006] $)

  $( Corollary of the Bunjakovaskij-Cauchy-Schwarz inequality ~ bcsiHIL . $)
  bcs2 $p |- ( ( A e. ~H /\ B e. ~H /\ ( normh ` A ) <_ 1 ) ->
             ( abs ` ( A .ih B ) ) <_ ( normh ` B ) ) $=
    cA chil wcel cB chil wcel cA cno cfv c1 cle wbr w3a cA cB csp co cabs cfv
    cA cno cfv cB cno cfv cmul co cB cno cfv cA chil wcel cB chil wcel cA cB
    csp co cabs cfv cr wcel cA cno cfv c1 cle wbr cA chil wcel cB chil wcel wa
    cA cB csp co cc wcel cA cB csp co cabs cfv cr wcel cA cB hicl cA cB csp co
    abscl syl 3adant3 cA chil wcel cB chil wcel cA cno cfv cB cno cfv cmul co
    cr wcel cA cno cfv c1 cle wbr cA cno cfv cr wcel cB cno cfv cr wcel cA cno
    cfv cB cno cfv cmul co cr wcel cA chil wcel cB chil wcel cA cno cfv cB cno
    cfv remulcl cA normcl cB normcl syl2an 3adant3 cB chil wcel cA chil wcel cB
    cno cfv cr wcel cA cno cfv c1 cle wbr cB normcl 3ad2ant2 cA chil wcel cB
    chil wcel cA cB csp co cabs cfv cA cno cfv cB cno cfv cmul co cle wbr cA
    cno cfv c1 cle wbr cA cB bcs 3adant3 cA chil wcel cB chil wcel cA cno cfv
    c1 cle wbr w3a cA cno cfv cB cno cfv cmul co c1 cB cno cfv cmul co cB cno
    cfv cle cA cno cfv cr wcel cB cno cfv cr wcel cc0 cB cno cfv cle wbr cA cno
    cfv c1 cle wbr cA cno cfv cB cno cfv cmul co c1 cB cno cfv cmul co cle wbr
    cA chil wcel cB chil wcel cA cno cfv c1 cle wbr w3a cA cno cfv cr wcel c1
    cr wcel cB cno cfv cr wcel cc0 cB cno cfv cle wbr cA cno cfv c1 cle wbr wa
    cA cno cfv cB cno cfv cmul co c1 cB cno cfv cmul co cle wbr 1re cA cno cfv
    c1 cB cno cfv lemul1aOLD mp3anl2 cA chil wcel cB chil wcel cA cno cfv cr
    wcel cA cno cfv c1 cle wbr cA normcl 3ad2ant1 cB chil wcel cA chil wcel cB
    cno cfv cr wcel cA cno cfv c1 cle wbr cB normcl 3ad2ant2 cB chil wcel cA
    chil wcel cc0 cB cno cfv cle wbr cA cno cfv c1 cle wbr cB normge0 3ad2ant2
    cA chil wcel cB chil wcel cA cno cfv c1 cle wbr 3simp3 syl2anc cB chil wcel
    cA chil wcel c1 cB cno cfv cmul co cB cno cfv wceq cA cno cfv c1 cle wbr cB
    chil wcel cB cno cfv cc wcel c1 cB cno cfv cmul co cB cno cfv wceq cB chil
    wcel cB cno cfv cB normcl recnd cB cno cfv mulid2 syl 3ad2ant2 breqtrd
    letrd $.
    $( [18-Jun-2006] $) $( [24-May-2006] $)

  $( Corollary of the Bunjakovaskij-Cauchy-Schwarz inequality ~ bcsiHIL . $)
  bcs3 $p |- ( ( A e. ~H /\ B e. ~H /\ ( normh ` B ) <_ 1 ) ->
             ( abs ` ( A .ih B ) ) <_ ( normh ` A ) ) $=
    cA chil wcel cB chil wcel cB cno cfv c1 cle wbr w3a cA cB csp co cabs cfv
    cB cA csp co cabs cfv cA cno cfv cle cA chil wcel cB chil wcel cA cB csp co
    cabs cfv cB cA csp co cabs cfv wceq cB cno cfv c1 cle wbr cA cB abshicom
    3adant3 cB chil wcel cA chil wcel cB cno cfv c1 cle wbr cB cA csp co cabs
    cfv cA cno cfv cle wbr cB cA bcs2 3com12 eqbrtrd $.
    $( [23-Jun-2006] $) $( [26-May-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Cauchy sequences and limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w f F $.
    $( Member of the set of Cauchy sequences on a Hilbert space.  Definition
       for Cauchy sequence in [Beran] p. 96. $)
    hcau $p |- ( F e. Cauchy <-> ( F : NN --> ~H /\
          A. x e. RR ( 0 < x ->
          E. y e. NN A. z e. NN A. w e. NN ( ( y <_ z /\ y <_ w ) ->
             ( normh ` ( ( F ` z ) -h ( F ` w ) ) ) < x ) ) ) ) $=
      cF ccau wcel cF cvv wcel cn chil cF wf cc0 vx cv clt wbr vy cv vz cv cle
      wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv
      clt wbr wi vw cn wral vz cn wral vy cn wrex wi vx cr wral wa cF ccau
      elisset cn chil cF wf cF cvv wcel cc0 vx cv clt wbr vy cv vz cv cle wbr
      vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt
      wbr wi vw cn wral vz cn wral vy cn wrex wi vx cr wral cn chil cF wf cn
      cvv wcel cF cvv wcel nnex cn chil cvv cF fex mpan2 adantr cn chil vf cv
      wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf
      cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn
      wral vy cn wrex wi vx cr wral wa cn chil cF wf cc0 vx cv clt wbr vy cv vz
      cv cle wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno
      cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex wi vx cr wral wa vf
      cF ccau cvv vf cv cF wceq cn chil vf cv wf cn chil cF wf cc0 vx cv clt
      wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv vf
      cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex
      wi vx cr wral cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr
      wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi vw cn wral
      vz cn wral vy cn wrex wi vx cr wral cn chil vf cv cF feq1 vf cv cF wceq
      cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv vf cv
      cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral
      vy cn wrex wi cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr
      wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi vw cn wral
      vz cn wral vy cn wrex wi vx cr vf cv cF wceq vy cv vz cv cle wbr vy cv vw
      cv cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt
      wbr wi vw cn wral vz cn wral vy cn wrex vy cv vz cv cle wbr vy cv vw cv
      cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi vw
      cn wral vz cn wral vy cn wrex cc0 vx cv clt wbr vf cv cF wceq vy cv vz cv
      cle wbr vy cv vw cv cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno
      cfv vx cv clt wbr wi vw cn wral vz cn wral vy cv vz cv cle wbr vy cv vw
      cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi
      vw cn wral vz cn wral vy cn vf cv cF wceq vy cv vz cv cle wbr vy cv vw cv
      cle wbr wa vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vx cv clt wbr
      wi vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv
      cmv co cno cfv vx cv clt wbr wi vz vw cn cn vf cv cF wceq vz cv vf cv cfv
      vw cv vf cv cfv cmv co cno cfv vx cv clt wbr vz cv cF cfv vw cv cF cfv
      cmv co cno cfv vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle wbr wa
      vf cv cF wceq vz cv vf cv cfv vw cv vf cv cfv cmv co cno cfv vz cv cF cfv
      vw cv cF cfv cmv co cno cfv vx cv clt vf cv cF wceq vz cv vf cv cfv vw cv
      vf cv cfv cmv co vz cv cF cfv vw cv cF cfv cmv co cno vf cv cF wceq vz cv
      vf cv cfv vz cv cF cfv vw cv vf cv cfv vw cv cF cfv cmv vz cv vf cv cF
      fveq1 vw cv vf cv cF fveq1 opreq12d fveq2d breq1d imbi2d 2ralbidv rexbidv
      imbi2d ralbidv anbi12d vx vy vz vw vf df-hcau elab2g pm5.21nii $.
      $( [16-Aug-1999] $)

    $( A Cauchy sequences on a Hilbert space is a sequence. $)
    hcauseq $p |- ( F e. Cauchy -> F : NN --> ~H ) $=
      cF ccau wcel cn chil cF wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw
      cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi
      vw cn wral vz cn wral vy cn wrex wi vx cr wral vx vy vz vw cF hcau
      pm3.26bi $.
      $( [16-Aug-1999] $)

    $( A Cauchy sequence on a Hilbert space converges. $)
    hcaucvg $p |- ( F e. Cauchy -> A. x e. RR ( 0 < x ->
          E. y e. NN A. z e. NN A. w e. NN ( ( y <_ z /\ y <_ w ) ->
             ( normh ` ( ( F ` z ) -h ( F ` w ) ) ) < x ) ) ) $=
      cF ccau wcel cn chil cF wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw
      cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi
      vw cn wral vz cn wral vy cn wrex wi vx cr wral vx vy vz vw cF hcau
      pm3.27bi $.
      $( [16-Aug-1999] $)

    $( A sequence on a Hilbert space is a Cauchy sequence if it converges. $)
    seq1hcau $p |- ( F : NN --> ~H -> ( F e. Cauchy <->
          A. x e. RR ( 0 < x ->
          E. y e. NN A. z e. NN A. w e. NN ( ( y <_ z /\ y <_ w ) ->
             ( normh ` ( ( F ` z ) -h ( F ` w ) ) ) < x ) ) ) ) $=
      cF ccau wcel cn chil cF wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw
      cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi
      vw cn wral vz cn wral vy cn wrex wi vx cr wral vx vy vz vw cF hcau baib
      $.
      $( [16-Aug-1999] $)
  $}

  ${
    $d j k m n y x F $.
    $( Alternate representation of a Hilbert space Cauchy sequence. $)
    hcau2 $p |- ( F e. Cauchy <-> ( F : NN --> ~H /\ A. x e. RR
        ( 0 < x -> E. j e. NN A. k e. NN
        ( j <_ k -> ( normh ` ( ( F ` k ) -h ( F ` j ) ) ) < x ) ) ) ) $=
      cF ccau wcel cn chil cF wf cc0 vx cv clt wbr vm cv vj cv cle wbr vm cv vk
      cv cle wbr wa vj cv cF cfv vk cv cF cfv cmv co cno cfv vx cv clt wbr wi
      vk cn wral vj cn wral vm cn wrex wi vx cr wral wa cn chil cF wf cc0 vx cv
      clt wbr vj cv vk cv cle wbr vk cv cF cfv vj cv cF cfv cmv co cno cfv vx
      cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral wa vx vm vj vk cF hcau
      cn chil cF wf cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv vj cv cF
      cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr wral
      cc0 vx cv clt wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa vj cv cF cfv
      vk cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn wral vm cn
      wrex wi vx cr wral cn chil cF wf cc0 vx cv clt wbr vj cv vk cv cle wbr vj
      cv cF cfv vk cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn
      wrex wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv vj
      cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr
      wral cc0 vx cv clt wbr vm cv vj cv cle wbr vm cv vk cv cle wbr wa vj cv
      cF cfv vk cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn wral
      vm cn wrex wi vx cr wral cn chil cF wf cc0 vx cv clt wbr vj cv vk cv cle
      wbr vj cv cF cfv vk cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral
      vj cn wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vk cv cF cfv vj cv cF
      cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn wrex wi vx cr cn
      chil cF wf vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cmv co cno cfv
      vx cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vk cv cF cfv
      vj cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn wrex cc0 vx
      cv clt wbr cn chil cF wf vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv
      cmv co cno cfv vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr vk cv cF
      cfv vj cv cF cfv cmv co cno cfv vx cv clt wbr wi vk cn wral vj cn cn chil
      cF wf vj cv cn wcel wa vj cv vk cv cle wbr vj cv cF cfv vk cv cF cfv cmv
      co cno cfv vx cv clt wbr wi vj cv vk cv cle wbr vk cv cF cfv vj cv cF cfv
      cmv co cno cfv vx cv clt wbr wi vk cn cn chil cF wf vj cv cn wcel wa vk
      cv cn wcel wa vj cv cF cfv vk cv cF cfv cmv co cno cfv vx cv clt wbr vk
      cv cF cfv vj cv cF cfv cmv co cno cfv vx cv clt wbr vj cv vk cv cle wbr
      cn chil cF wf vj cv cn wcel wa vk cv cn wcel wa vj cv cF cfv vk cv cF cfv
      cmv co cno cfv vk cv cF cfv vj cv cF cfv cmv co cno cfv vx cv clt cn chil
      cF wf vj cv cn wcel vk cv cn wcel vj cv cF cfv vk cv cF cfv cmv co cno
      cfv vk cv cF cfv vj cv cF cfv cmv co cno cfv wceq cn chil cF wf vj cv cn
      wcel vk cv cn wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv vk cv cF cfv
      vj cv cF cfv cmv co cno cfv wceq vj cv cF cfv chil wcel vk cv cF cfv chil
      wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv vk cv cF cfv vj cv cF cfv
      cmv co cno cfv wceq cn chil cF wf vj cv cn wcel wa cn chil cF wf vk cv cn
      wcel wa vj cv cF cfv vk cv cF cfv normsub cn chil vj cv cF ffvelrn cn
      chil vk cv cF ffvelrn syl2an anandis anassrs breq1d imbi2d ralbidva
      rexbidva imbi2d ralbidv vj cv cF cfv vk cv cF cfv cmv co cno cfv vx cv
      clt wbr vj cv cF cfv vm cv cF cfv cmv co cno cfv vx cv clt wbr vk cv cF
      cfv vm cv cF cfv cmv co cno cfv vx cv clt wbr vj cv cF cfv vk cv cF cfv
      cmv co cno cfv vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cmv co
      cno cfv vy cv c2 cdiv co clt wbr wa vk cv cF cfv vm cv cF cfv cmv co cno
      cfv vy cv clt wbr vx vy vj vk vm cn cn chil cF wf vk cv vm cv wceq vj cv
      cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv vm cv cF cfv cmv co cno
      cfv vx cv clt vk cv vm cv wceq vj cv cF cfv vk cv cF cfv cmv co vj cv cF
      cfv vm cv cF cfv cmv co cno vk cv vm cv wceq vk cv cF cfv vm cv cF cfv vj
      cv cF cfv cmv vk cv vm cv cF fveq2 opreq2d fveq2d breq1d vj cv vk cv wceq
      vj cv cF cfv vm cv cF cfv cmv co cno cfv vk cv cF cfv vm cv cF cfv cmv co
      cno cfv vx cv clt vj cv vk cv wceq vj cv cF cfv vm cv cF cfv cmv co vk cv
      cF cfv vm cv cF cfv cmv co cno vj cv vk cv wceq vj cv cF cfv vk cv cF cfv
      vm cv cF cfv cmv vj cv vk cv cF fveq2 opreq1d fveq2d breq1d vx cv vy cv
      c2 cdiv co wceq vj cv cF cfv vk cv cF cfv cmv co cno cfv vx cv clt wbr vj
      cv cF cfv vk cv cF cfv cmv co cno cfv vy cv c2 cdiv co clt wbr vj cv cF
      cfv vm cv cF cfv cmv co cno cfv vx cv clt wbr vj cv cF cfv vm cv cF cfv
      cmv co cno cfv vy cv c2 cdiv co clt wbr vx cv vy cv c2 cdiv co vj cv cF
      cfv vk cv cF cfv cmv co cno cfv clt breq2 vx cv vy cv c2 cdiv co vj cv cF
      cfv vm cv cF cfv cmv co cno cfv clt breq2 anbi12d vx cv vy cv vk cv cF
      cfv vm cv cF cfv cmv co cno cfv clt breq2 cn chil cF wf vj cv cn wcel vk
      cv cn wcel vm cv cn wcel w3a vy cv cr wcel vj cv cF cfv vk cv cF cfv cmv
      co cno cfv vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cmv co cno
      cfv vy cv c2 cdiv co clt wbr wa vk cv cF cfv vm cv cF cfv cmv co cno cfv
      vy cv clt wbr wi vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF
      cfv chil wcel w3a vy cv cr wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv
      vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF cfv cmv co cno cfv vy cv
      c2 cdiv co clt wbr wa vk cv cF cfv vm cv cF cfv cmv co cno cfv vy cv clt
      wbr wi cn chil cF wf vj cv cn wcel vk cv cn wcel vm cv cn wcel w3a wa vk
      cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil wcel w3a vy
      cv cr wcel wa vj cv cF cfv vk cv cF cfv cmv co cno cfv vy cv c2 cdiv co
      clt wbr vj cv cF cfv vm cv cF cfv cmv co cno cfv vy cv c2 cdiv co clt wbr
      wa vj cv cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv vm cv cF cfv cmv
      co cno cfv caddc co vy cv clt wbr vk cv cF cfv vm cv cF cfv cmv co cno
      cfv vy cv clt wbr vj cv cF cfv vk cv cF cfv cmv co cno cfv cr wcel vj cv
      cF cfv vm cv cF cfv cmv co cno cfv cr wcel vy cv cr wcel vj cv cF cfv vk
      cv cF cfv cmv co cno cfv vy cv c2 cdiv co clt wbr vj cv cF cfv vm cv cF
      cfv cmv co cno cfv vy cv c2 cdiv co clt wbr wa vj cv cF cfv vk cv cF cfv
      cmv co cno cfv vj cv cF cfv vm cv cF cfv cmv co cno cfv caddc co vy cv
      clt wbr wi vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv
      chil wcel w3a vy cv cr wcel wa vj cv cF cfv vk cv cF cfv cmv co cno cfv
      vj cv cF cfv vm cv cF cfv cmv co cno cfv vy cv lt2halves vk cv cF cfv
      chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil wcel w3a vj cv cF cfv
      vk cv cF cfv cmv co cno cfv cr wcel vy cv cr wcel vk cv cF cfv chil wcel
      vj cv cF cfv chil wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv cr wcel
      vm cv cF cfv chil wcel vk cv cF cfv chil wcel vj cv cF cfv chil wcel wa
      vj cv cF cfv vk cv cF cfv cmv co chil wcel vj cv cF cfv vk cv cF cfv cmv
      co cno cfv cr wcel vj cv cF cfv chil wcel vk cv cF cfv chil wcel vj cv cF
      cfv vk cv cF cfv cmv co chil wcel vj cv cF cfv vk cv cF cfv hvsubcl
      ancoms vj cv cF cfv vk cv cF cfv cmv co normcl syl 3adant2 adantr vk cv
      cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil wcel w3a vj cv
      cF cfv vm cv cF cfv cmv co cno cfv cr wcel vy cv cr wcel vm cv cF cfv
      chil wcel vj cv cF cfv chil wcel vj cv cF cfv vm cv cF cfv cmv co cno cfv
      cr wcel vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil
      wcel wa vj cv cF cfv vm cv cF cfv cmv co chil wcel vj cv cF cfv vm cv cF
      cfv cmv co cno cfv cr wcel vj cv cF cfv chil wcel vm cv cF cfv chil wcel
      vj cv cF cfv vm cv cF cfv cmv co chil wcel vj cv cF cfv vm cv cF cfv
      hvsubcl ancoms vj cv cF cfv vm cv cF cfv cmv co normcl syl 3adant1 adantr
      vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil wcel w3a
      vy cv cr wcel pm3.27 syl3anc vk cv cF cfv chil wcel vm cv cF cfv chil
      wcel vj cv cF cfv chil wcel w3a vy cv cr wcel wa vk cv cF cfv vm cv cF
      cfv cmv co cno cfv vj cv cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv
      vm cv cF cfv cmv co cno cfv caddc co cle wbr vj cv cF cfv vk cv cF cfv
      cmv co cno cfv vj cv cF cfv vm cv cF cfv cmv co cno cfv caddc co vy cv
      clt wbr vk cv cF cfv vm cv cF cfv cmv co cno cfv vy cv clt wbr vk cv cF
      cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil wcel w3a vk cv cF
      cfv vm cv cF cfv cmv co cno cfv vj cv cF cfv vk cv cF cfv cmv co cno cfv
      vj cv cF cfv vm cv cF cfv cmv co cno cfv caddc co cle wbr vy cv cr wcel
      vk cv cF cfv vm cv cF cfv vj cv cF cfv norm3dif2 adantr vk cv cF cfv vm
      cv cF cfv cmv co cno cfv cr wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv
      vj cv cF cfv vm cv cF cfv cmv co cno cfv caddc co cr wcel vy cv cr wcel
      vk cv cF cfv vm cv cF cfv cmv co cno cfv vj cv cF cfv vk cv cF cfv cmv co
      cno cfv vj cv cF cfv vm cv cF cfv cmv co cno cfv caddc co cle wbr vj cv
      cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv vm cv cF cfv cmv co cno
      cfv caddc co vy cv clt wbr wa vk cv cF cfv vm cv cF cfv cmv co cno cfv vy
      cv clt wbr wi vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv
      chil wcel w3a vy cv cr wcel wa vk cv cF cfv vm cv cF cfv cmv co cno cfv
      vj cv cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv vm cv cF cfv cmv co
      cno cfv caddc co vy cv lelttr vk cv cF cfv chil wcel vm cv cF cfv chil
      wcel vj cv cF cfv chil wcel w3a vk cv cF cfv vm cv cF cfv cmv co cno cfv
      cr wcel vy cv cr wcel vk cv cF cfv chil wcel vm cv cF cfv chil wcel vk cv
      cF cfv vm cv cF cfv cmv co cno cfv cr wcel vj cv cF cfv chil wcel vk cv
      cF cfv chil wcel vm cv cF cfv chil wcel wa vk cv cF cfv vm cv cF cfv cmv
      co chil wcel vk cv cF cfv vm cv cF cfv cmv co cno cfv cr wcel vk cv cF
      cfv vm cv cF cfv hvsubcl vk cv cF cfv vm cv cF cfv cmv co normcl syl
      3adant3 adantr vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv
      chil wcel w3a vj cv cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv vm cv
      cF cfv cmv co cno cfv caddc co cr wcel vy cv cr wcel vj cv cF cfv vk cv
      cF cfv cmv co cno cfv cr wcel vj cv cF cfv vm cv cF cfv cmv co cno cfv cr
      wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv vj cv cF cfv vm cv cF cfv
      cmv co cno cfv caddc co cr wcel vk cv cF cfv chil wcel vm cv cF cfv chil
      wcel vj cv cF cfv chil wcel w3a vj cv cF cfv vk cv cF cfv cmv co cno cfv
      vj cv cF cfv vm cv cF cfv cmv co cno cfv readdcl vk cv cF cfv chil wcel
      vj cv cF cfv chil wcel vj cv cF cfv vk cv cF cfv cmv co cno cfv cr wcel
      vm cv cF cfv chil wcel vk cv cF cfv chil wcel vj cv cF cfv chil wcel wa
      vj cv cF cfv vk cv cF cfv cmv co chil wcel vj cv cF cfv vk cv cF cfv cmv
      co cno cfv cr wcel vj cv cF cfv chil wcel vk cv cF cfv chil wcel vj cv cF
      cfv vk cv cF cfv cmv co chil wcel vj cv cF cfv vk cv cF cfv hvsubcl
      ancoms vj cv cF cfv vk cv cF cfv cmv co normcl syl 3adant2 vm cv cF cfv
      chil wcel vj cv cF cfv chil wcel vj cv cF cfv vm cv cF cfv cmv co cno cfv
      cr wcel vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil
      wcel wa vj cv cF cfv vm cv cF cfv cmv co chil wcel vj cv cF cfv vm cv cF
      cfv cmv co cno cfv cr wcel vj cv cF cfv chil wcel vm cv cF cfv chil wcel
      vj cv cF cfv vm cv cF cfv cmv co chil wcel vj cv cF cfv vm cv cF cfv
      hvsubcl ancoms vj cv cF cfv vm cv cF cfv cmv co normcl syl 3adant1 sylanc
      adantr vk cv cF cfv chil wcel vm cv cF cfv chil wcel vj cv cF cfv chil
      wcel w3a vy cv cr wcel pm3.27 syl3anc mpand syld cn chil cF wf vj cv cn
      wcel vk cv cn wcel vm cv cn wcel vk cv cF cfv chil wcel vm cv cF cfv chil
      wcel vj cv cF cfv chil wcel w3a cn chil cF wf vk cv cn wcel wa cn chil cF
      wf vm cv cn wcel wa cn chil cF wf vj cv cn wcel wa vk cv cF cfv chil wcel
      vm cv cF cfv chil wcel vj cv cF cfv chil wcel w3a cn chil cF wf vk cv cn
      wcel wa vk cv cF cfv chil wcel cn chil cF wf vm cv cn wcel wa vm cv cF
      cfv chil wcel cn chil cF wf vj cv cn wcel wa vj cv cF cfv chil wcel cn
      chil vk cv cF ffvelrn cn chil vm cv cF ffvelrn cn chil vj cv cF ffvelrn
      3anim123i 3comr 3anandis sylan an1rs nnssz cau3i bitr3d pm5.32i bitr4i $.
      $( [26-Apr-2007] $) $( [17-Apr-2007] $)
  $}

  ${
    $d x y z w f F $.  $d x y z w f A $.
    hlim.1 $e |- F e. _V $.
    hlim.2 $e |- A e. _V $.
    $( Express the predicate: The limit of vector sequence ` F ` in a Hilbert
       space is ` A ` , i.e. ` F ` converges to ` A ` .  This means that for
       any real ` x ` , no matter how small, there always exists an integer
       ` y ` such that the norm of any later vector in the sequence minus
       the limit is less than ` x ` .  Definition of converge in [Beran]
       p. 96. $)
    hlimi $p |- ( F ~~>v A <-> ( ( F : NN --> ~H /\ A e. ~H ) /\
          A. x e. RR ( 0 < x ->
             E. y e. NN A. z e. NN ( y <_ z ->
                ( normh ` ( ( F ` z ) -h A ) ) < x ) ) ) ) $=
      cn chil vf cv wf vw cv chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr
      vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn
      wrex wi vx cr wral wa cn chil cF wf vw cv chil wcel wa cc0 vx cv clt wbr
      vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vz
      cn wral vy cn wrex wi vx cr wral wa cn chil cF wf cA chil wcel wa cc0 vx
      cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt
      wbr wi vz cn wral vy cn wrex wi vx cr wral wa vf vw cF cA chli hlim.1
      hlim.2 vf cv cF wceq cn chil vf cv wf vw cv chil wcel wa cn chil cF wf vw
      cv chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv vw
      cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral
      cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv
      vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral vf cv cF wceq cn
      chil vf cv wf cn chil cF wf vw cv chil wcel cn chil vf cv cF feq1 anbi1d
      vf cv cF wceq cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv cfv vw cv
      cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi cc0 vx cv clt
      wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr
      wi vz cn wral vy cn wrex wi vx cr vf cv cF wceq vy cv vz cv cle wbr vz cv
      vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex vy
      cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn
      wral vy cn wrex cc0 vx cv clt wbr vf cv cF wceq vy cv vz cv cle wbr vz cv
      vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vy cv vz cv cle wbr vz cv
      cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vy vz cn cn vf cv cF wceq vz
      cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr vz cv cF cfv vw cv cmv co
      cno cfv vx cv clt wbr vy cv vz cv cle wbr vf cv cF wceq vz cv vf cv cfv
      vw cv cmv co cno cfv vz cv cF cfv vw cv cmv co cno cfv vx cv clt vf cv cF
      wceq vz cv vf cv cfv vw cv cmv co vz cv cF cfv vw cv cmv co cno vf cv cF
      wceq vz cv vf cv cfv vz cv cF cfv vw cv cmv vz cv vf cv cF fveq1 opreq1d
      fveq2d breq1d imbi2d rexralbidv imbi2d ralbidv anbi12d vw cv cA wceq cn
      chil cF wf vw cv chil wcel wa cn chil cF wf cA chil wcel wa cc0 vx cv clt
      wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr
      wi vz cn wral vy cn wrex wi vx cr wral cc0 vx cv clt wbr vy cv vz cv cle
      wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex
      wi vx cr wral vw cv cA wceq vw cv chil wcel cA chil wcel cn chil cF wf vw
      cv cA chil eleq1 anbi2d vw cv cA wceq cc0 vx cv clt wbr vy cv vz cv cle
      wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn
      wrex wi cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno
      cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr vw cv cA wceq vy cv
      vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn
      wral vy cn wrex vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv
      clt wbr wi vz cn wral vy cn wrex cc0 vx cv clt wbr vw cv cA wceq vy cv vz
      cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vy cv vz cv
      cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vy vz cn cn vw cv
      cA wceq vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr vz cv cF cfv cA
      cmv co cno cfv vx cv clt wbr vy cv vz cv cle wbr vw cv cA wceq vz cv cF
      cfv vw cv cmv co cno cfv vz cv cF cfv cA cmv co cno cfv vx cv clt vw cv
      cA wceq vz cv cF cfv vw cv cmv co vz cv cF cfv cA cmv co cno vw cv cA vz
      cv cF cfv cmv opreq2 fveq2d breq1d imbi2d rexralbidv imbi2d ralbidv
      anbi12d vx vy vz vw vf df-hlim brab $.
      $( [16-Aug-1999] $)

    $( A sequence with a limit on a Hilbert space is a sequence. $)
    hlimseqi $p |- ( F ~~>v A -> F : NN --> ~H ) $=
      cF cA chli wbr cn chil cF wf cA chil wcel cF cA chli wbr cn chil cF wf cA
      chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co
      cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral vx vy vz cA
      cF hlim.1 hlim.2 hlimi pm3.26bi pm3.26d $.
      $( [16-Aug-1999] $)

    $( Closure of the limit of a sequence on Hilbert space. $)
    hlimveci $p |- ( F ~~>v A -> A e. ~H ) $=
      cF cA chli wbr cn chil cF wf cA chil wcel cF cA chli wbr cn chil cF wf cA
      chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co
      cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral vx vy vz cA
      cF hlim.1 hlim.2 hlimi pm3.26bi pm3.27d $.
      $( [16-Aug-1999] $)

    $( Convergence of a sequence on a Hilbert space. $)
    hlimconvi $p |- ( F ~~>v A -> A. x e. RR ( 0 < x ->
             E. y e. NN A. z e. NN ( y <_ z ->
                ( normh ` ( ( F ` z ) -h A ) ) < x ) ) ) $=
      cF cA chli wbr cn chil cF wf cA chil wcel wa cc0 vx cv clt wbr vy cv vz
      cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn wral vy
      cn wrex wi vx cr wral vx vy vz cA cF hlim.1 hlim.2 hlimi pm3.27bi $.
      $( [16-Aug-1999] $)
  $}

  ${
    $d x y z w f F $.  $d x y z w f A $.
    $( The limit of a sequence on a Hilbert space. $)
    hlim2 $p |- ( ( F : NN --> ~H /\ A e. ~H ) ->  ( F ~~>v A <->
          A. x e. RR ( 0 < x ->
             E. y e. NN A. z e. NN ( y <_ z ->
                ( normh ` ( ( F ` z ) -h A ) ) < x ) ) ) ) $=
      cn chil cF wf cA chil wcel wa cF cA chli wbr cc0 vx cv clt wbr vy cv vz
      cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn wral vy
      cn wrex wi vx cr wral cF cvv wcel cA chil wcel cF cA chli wbr cn chil cF
      wf cA chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA
      cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral wa wb
      cn chil cF wf cn chil vf cv wf vw cv chil wcel wa cc0 vx cv clt wbr vy cv
      vz cv cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn
      wral vy cn wrex wi vx cr wral wa cn chil cF wf vw cv chil wcel wa cc0 vx
      cv clt wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv
      clt wbr wi vz cn wral vy cn wrex wi vx cr wral wa cn chil cF wf cA chil
      wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno
      cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral wa vf vw cF cA
      cvv chil chli vf cv cF wceq cn chil vf cv wf vw cv chil wcel wa cn chil
      cF wf vw cv chil wcel wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf
      cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx
      cr wral cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co
      cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral vf cv cF
      wceq cn chil vf cv wf cn chil cF wf vw cv chil wcel cn chil vf cv cF feq1
      anbi1d vf cv cF wceq cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv vf cv
      cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi cc0 vx
      cv clt wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv
      clt wbr wi vz cn wral vy cn wrex wi vx cr vf cv cF wceq vy cv vz cv cle
      wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vz cn wral vy
      cn wrex vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt
      wbr wi vz cn wral vy cn wrex cc0 vx cv clt wbr vf cv cF wceq vy cv vz cv
      cle wbr vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr wi vy cv vz cv
      cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr wi vy vz cn cn vf
      cv cF wceq vz cv vf cv cfv vw cv cmv co cno cfv vx cv clt wbr vz cv cF
      cfv vw cv cmv co cno cfv vx cv clt wbr vy cv vz cv cle wbr vf cv cF wceq
      vz cv vf cv cfv vw cv cmv co cno cfv vz cv cF cfv vw cv cmv co cno cfv vx
      cv clt vf cv cF wceq vz cv vf cv cfv vw cv cmv co vz cv cF cfv vw cv cmv
      co cno vf cv cF wceq vz cv vf cv cfv vz cv cF cfv vw cv cmv vz cv vf cv
      cF fveq1 opreq1d fveq2d breq1d imbi2d rexralbidv imbi2d ralbidv anbi12d
      vw cv cA wceq cn chil cF wf vw cv chil wcel wa cn chil cF wf cA chil wcel
      wa cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno
      cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral cc0 vx cv clt
      wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi
      vz cn wral vy cn wrex wi vx cr wral vw cv cA wceq vw cv chil wcel cA chil
      wcel cn chil cF wf vw cv cA chil eleq1 anbi2d vw cv cA wceq cc0 vx cv clt
      wbr vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt wbr
      wi vz cn wral vy cn wrex wi cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv
      cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr
      vw cv cA wceq vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv
      clt wbr wi vz cn wral vy cn wrex vy cv vz cv cle wbr vz cv cF cfv cA cmv
      co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex cc0 vx cv clt wbr vw cv
      cA wceq vy cv vz cv cle wbr vz cv cF cfv vw cv cmv co cno cfv vx cv clt
      wbr wi vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr
      wi vy vz cn cn vw cv cA wceq vz cv cF cfv vw cv cmv co cno cfv vx cv clt
      wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr vy cv vz cv cle wbr vw
      cv cA wceq vz cv cF cfv vw cv cmv co cno cfv vz cv cF cfv cA cmv co cno
      cfv vx cv clt vw cv cA wceq vz cv cF cfv vw cv cmv co vz cv cF cfv cA cmv
      co cno vw cv cA vz cv cF cfv cmv opreq2 fveq2d breq1d imbi2d rexralbidv
      imbi2d ralbidv anbi12d vx vy vz vw vf df-hlim brabg cn chil cF wf cn cvv
      wcel cF cvv wcel nnex cn chil cvv cF fex mpan2 sylan bianabs $.
      $( [16-Aug-1999] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Derivation of the completeness axiom from ZF set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    hilmet.1 $e |- D = ( normh o. -h ) $.
    $( The Hilbert space norm determines a metric space. $)
    hilmet $p  |- D e. Met $=
      cD cva csm cop cno cop cva csm cop cno cop eqid cD cva csm cop cno cop
      cva csm cop cno cop eqid hilmet.1 hhims hhmet $.
      $( [24-Nov-2007] $) $( [17-Apr-2007] $)

    $( Value of the distance function of the metric space of Hilbert space. $)
    hilmetdval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( A D B ) = ( normh ` ( A -h B ) ) ) $=
      cA cB cD cva csm cop cno cop cva csm cop cno cop eqid cD cva csm cop cno
      cop cva csm cop cno cop eqid hilmet.1 hhims hhmetdval $.
      $( [19-Sep-2007] $) $( [17-Apr-2007] $)

    $( The base set for the metric for Hilbert space. $)
    hilmetba $p |- ~H = dom dom D $=
      cD cva csm cop cno cop cva csm cop cno cop eqid cD cva csm cop cno cop
      cva csm cop cno cop eqid hilmet.1 hhims hhmetba $.
      $( [21-Nov-2007] $) $( [6-Sep-2007] $)
  $}

  ${
    $d x y z U $.
    hilims.1 $e |- ~H = ( BaseSet ` U ) $.
    hilims.2 $e |- +h = ( +v ` U ) $.
    hilims.3 $e |- .h = ( .s ` U ) $.
    hilims.5 $e |- .ih = ( .i ` U ) $.
    hilims.8 $e |- D = ( IndMet ` U ) $.
    hilims.9 $e |- U e. NrmCVec $.
    $( Hilbert space distance metric. $)
    hilims $p |- D = ( normh o. -h ) $=
      cD cU cU hilims.1 hilims.2 hilims.3 hilims.5 hilims.9 hilhhi hilims.8
      hhims2 $.
      $( [11-Apr-2008] $) $( [13-Sep-2007] $)
  $}

  ${
    $d f w x y z D $.
    hillim.1 $e |- ~H = ( BaseSet ` U ) $.
    hillim.2 $e |- +h = ( +v ` U ) $.
    hillim.3 $e |- .h = ( .s ` U ) $.
    hillim.5 $e |- .ih = ( .i ` U ) $.
    hillim.8 $e |- D = ( IndMet ` U ) $.
    hillim.9 $e |- U e. NrmCVec $.
    $( MAY BE REVISED - not needed? delete? $)
    $( Hilbert space limit in terms of metric space limit. $)
    hillim $p |- ~~>v = ( ( ~~>m ` D ) |` ( ~H ^m NN ) ) $=
      cD cU cU hillim.1 hillim.2 hillim.3 hillim.5 hillim.9 hilhhi hillim.9
      hillim.1 hillim.8 h2hlm $.
      $( [11-Apr-2008] $) $( [13-Sep-2007] $)

    $( MAY BE REVISED - not needed? delete? $)
    $( Hilbert space Cauchy sequences in terms of metric space Cauchy
       sequences. $)
    hilcau $p |- Cauchy = ( ( Cau ` D ) i^i ( ~H ^m NN ) ) $=
      cD cU cU hillim.1 hillim.2 hillim.3 hillim.5 hillim.9 hilhhi hillim.9
      hillim.1 hillim.8 h2hcau $.
      $( [12-Apr-2008] $) $( [10-Sep-2007] $)
  $}

  ${
    hhlm.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhlm.2 $e |- D = ( IndMet ` U ) $.
    $( The limit sequences of Hilbert space. $)
    hhlm $p |- ~~>v = ( ( ~~>m ` D ) |` ( ~H ^m NN ) ) $=
      cD cU hhlm.1 cU hhlm.1 hhnv cU hhlm.1 hhba hhlm.2 h2hlm $.
      $( [5-Mar-2008] $) $( [19-Nov-2007] $)

    $( The Cauchy sequences of Hilbert space. $)
    hhcau $p |- Cauchy = ( ( Cau ` D ) i^i ( ~H ^m NN ) ) $=
      cD cU hhlm.1 cU hhlm.1 hhnv cU hhlm.1 hhba hhlm.2 h2hcau $.
      $( [12-Apr-2008] $) $( [19-Nov-2007] $)

    ${
      $d x F $.
      hhcmpl.c $e |- ( F e. ( Cau ` D ) -> E. x e. ~H F ( ~~>m ` D ) x ) $.
      $( Lemma used for derivation of the completeness axiom ~ ax-hcompl from
         ZFC Hilbert space theory. $)
      hhcmpl $p |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $=
        cF cD cca cfv wcel cF chil cn cm co wcel wa cF vx cv cD clm cfv wbr vx
        chil wrex cF chil cn cm co wcel wa cF ccau wcel cF vx cv chli wbr vx
        chil wrex cF cD cca cfv wcel cF vx cv cD clm cfv wbr vx chil wrex cF
        chil cn cm co wcel hhcmpl.c anim1i cF ccau wcel cF cD cca cfv chil cn
        cm co cin wcel cF cD cca cfv wcel cF chil cn cm co wcel wa ccau cD cca
        cfv chil cn cm co cin cF cD cU hhlm.1 hhlm.2 hhcau eleq2i cF cD cca cfv
        chil cn cm co elin bitri cF vx cv chli wbr vx chil wrex cF vx cv cD clm
        cfv wbr cF chil cn cm co wcel wa vx chil wrex cF vx cv cD clm cfv wbr
        vx chil wrex cF chil cn cm co wcel wa cF vx cv chli wbr cF vx cv cD clm
        cfv wbr cF chil cn cm co wcel wa vx chil cF vx cv chli wbr cF vx cv cD
        clm cfv chil cn cm co cres wbr cF vx cv cD clm cfv wbr cF chil cn cm co
        wcel wa cF vx cv chli cD clm cfv chil cn cm co cres cD cU hhlm.1 hhlm.2
        hhlm breqi cF vx cv cD clm cfv chil cn cm co vx visset brres bitri
        rexbii cF vx cv cD clm cfv wbr cF chil cn cm co wcel vx chil r19.41v
        bitri 3imtr4i $.
        $( [13-Apr-2008] $) $( [9-Apr-2008] $)
    $}
  $}

  ${
    $d x F $.
    hilcompl.1 $e |- ~H = ( BaseSet ` U ) $.
    hilcompl.2 $e |- +h = ( +v ` U ) $.
    hilcompl.3 $e |- .h = ( .s ` U ) $.
    hilcompl.5 $e |- .ih = ( .i ` U ) $.
    hilcompl.8 $e |- D = ( IndMet ` U ) $.
    hilcompl.9 $e |- U e. CHil $.
    hilcompl.c $e |- ( F e. ( Cau ` D ) -> E. x e. ~H F ( ~~>m ` D ) x ) $.
    $( Lemma used for derivation of the completeness axiom ~ ax-hcompl from
       ZFC Hilbert space theory.  The first 5 hypotheses would be satisfied
       by the definitions described in ~ ax-hilex ; the 6th would be satisfied
       by ~ eqid ; the 7th by a given fixed Hilbert space; and the last by
       theorem ~ hlcompl . $)
    hilcompl $p |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $=
      vx cD cU cF cU hilcompl.1 hilcompl.2 hilcompl.3 hilcompl.5 cU hilcompl.9
      hlnvi hilhhi hilcompl.8 hilcompl.c hhcmpl $.
      $( [22-Dec-2007] $) $( [13-Sep-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Completeness postulate for a Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d F x $.
    $( Completeness of a Hilbert space. $)
    ax-hcompl $a |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Relate Hilbert space to ZFC pre-Hilbert and Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f j k t u v w x y z D $.
    hhcms.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhcms.2 $e |- D = ( IndMet ` U ) $.
    $( The Hilbert space induced metric determines a complete metric space. $)
    hhcms $p |- D e. CMet $=
      vx cD vf chil cD cU hhcms.1 hhcms.2 hhmetba cD cU hhcms.1 hhcms.2 hhmet
      cn chil vf cv wf vf cv vx cv chli wbr vx chil wrex vf cv vx cv cD clm cfv
      wbr vx chil wrex vf cv cD cca cfv wcel cn chil vf cv wf wa cn chil vf cv
      wf vf cv vx cv chli wbr vf cv vx cv cD clm cfv wbr vx chil cn chil vf cv
      wf vx cv chil wcel wa vf cv vx cv cD clm cfv wbr cc0 vy cv clt wbr vj cv
      vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral vj
      cn wrex wi vy cr wral vf cv vx cv chli wbr vx cv chil wcel cn chil vf cv
      wf vf cv vx cv cD clm cfv wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv
      vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr
      wral wb cD cme wcel vx cv chil wcel cn chil vf cv wf vf cv vx cv cD clm
      cfv wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vx cv cD co
      vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral wb cD cU hhcms.1
      hhcms.2 hhmet vy cD vx cv vj vk vf cv c1 chil cn cD cU hhcms.1 hhcms.2
      hhmetba 1z nnuz lmbrf2 mp3an1 ancoms vf cv vx cv chli wbr cc0 vy cv clt
      wbr vj cv vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv clt wbr wi vk
      cn wral vj cn wrex wi vy cr wral cc0 vy cv clt wbr vj cv vk cv cle wbr vk
      cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex
      wi vy cr wral vy vj vk vx cv vf cv vf visset vx visset hlimconvi vf cv vx
      cv chli wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vx cv
      cD co vy cv clt wbr wi vk cn wral vj cn wrex wi cc0 vy cv clt wbr vj cv
      vk cv cle wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr wi vk cn
      wral vj cn wrex wi vy cr vf cv vx cv chli wbr vj cv vk cv cle wbr vk cv
      vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv
      cle wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr wi vk cn wral
      vj cn wrex cc0 vy cv clt wbr vf cv vx cv chli wbr vj cv vk cv cle wbr vk
      cv vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral vj cv vk cv cle wbr
      vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn vf
      cv vx cv chli wbr vj cv vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv
      clt wbr wi vj cv vk cv cle wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv
      clt wbr wi vk cn vf cv vx cv chli wbr vk cv cn wcel wa vk cv vf cv cfv vx
      cv cD co vy cv clt wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr
      vj cv vk cv cle wbr vf cv vx cv chli wbr vk cv cn wcel wa vk cv vf cv cfv
      vx cv cD co vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt vk cv vf cv
      cfv chil wcel vx cv chil wcel vk cv vf cv cfv vx cv cD co vk cv vf cv cfv
      vx cv cmv co cno cfv wceq vf cv vx cv chli wbr vk cv cn wcel wa vk cv vf
      cv cfv vx cv cD cU hhcms.1 hhcms.2 hhmetdval cn chil vf cv wf vk cv cn
      wcel vk cv vf cv cfv chil wcel vf cv vx cv chli wbr cn chil vk cv vf cv
      ffvelrn vx cv vf cv vf visset vx visset hlimseqi sylan vf cv vx cv chli
      wbr vx cv chil wcel vk cv cn wcel vx cv vf cv vf visset vx visset
      hlimveci adantr sylanc breq1d imbi2d ralbidva rexbidv imbi2d ralbidv
      mpbird syl5bir r19.22dva vf cv cD cca cfv wcel cn chil vf cv wf pm3.27 cn
      chil vf cv wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vj cv
      vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr
      wral vf cv vx cv chli wbr vx chil wrex vf cv cD cca cfv wcel cn chil vf
      cv wf wa cn chil vf cv wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf
      cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn
      wrex wi vy cr wral wa vf cv ccau wcel vf cv vx cv chli wbr vx chil wrex
      vy vj vk vf cv hcau2 vx vf cv ax-hcompl sylbir vf cv cD cca cfv wcel cn
      chil vf cv wf pm3.27 cn chil vf cv wf vf cv cD cca cfv wcel cc0 vy cv clt
      wbr vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy
      cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral cn chil vf cv wf vf cv
      cD cca cfv wcel cc0 vy cv clt wbr vj cv vk cv cle wbr vj cv vf cv cfv vk
      cv vf cv cfv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral
      cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv
      co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral cD cme
      wcel cn chil vf cv wf vf cv cD cca cfv wcel cc0 vy cv clt wbr vj cv vk cv
      cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt wbr wi vk cn wral
      vj cn wrex wi vy cr wral wb cD cU hhcms.1 hhcms.2 hhmet vy cD vj vk vf cv
      c1 chil cn cD cU hhcms.1 hhcms.2 hhmetba 1z nnuz iscauf mpan cn chil vf
      cv wf cc0 vy cv clt wbr vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv
      cfv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi cc0 vy cv clt wbr vj
      cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt
      wbr wi vk cn wral vj cn wrex wi vy cr cn chil vf cv wf vj cv vk cv cle
      wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt wbr wi vk cn wral vj
      cn wrex vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno
      cfv vy cv clt wbr wi vk cn wral vj cn wrex cc0 vy cv clt wbr cn chil vf
      cv wf vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt
      wbr wi vk cn wral vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv
      co cno cfv vy cv clt wbr wi vk cn wral vj cn cn chil vf cv wf vj cv cn
      wcel wa vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv
      clt wbr wi vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno
      cfv vy cv clt wbr wi vk cn cn chil vf cv wf vj cv cn wcel wa vk cv cn
      wcel wa vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt wbr vk cv vf cv
      cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr vj cv vk cv cle wbr vj
      cv vf cv cfv chil wcel vk cv vf cv cfv chil wcel vj cv vf cv cfv vk cv vf
      cv cfv cD co vy cv clt wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv
      vy cv clt wbr wb cn chil vf cv wf vj cv cn wcel wa vk cv cn wcel wa vj cv
      vf cv cfv chil wcel vk cv vf cv cfv chil wcel wa vj cv vf cv cfv vk cv vf
      cv cfv cD co vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt vj
      cv vf cv cfv chil wcel vk cv vf cv cfv chil wcel wa vj cv vf cv cfv vk cv
      vf cv cfv cD co vj cv vf cv cfv vk cv vf cv cfv cmv co cno cfv vk cv vf
      cv cfv vj cv vf cv cfv cmv co cno cfv vj cv vf cv cfv vk cv vf cv cfv cD
      cU hhcms.1 hhcms.2 hhmetdval vj cv vf cv cfv vk cv vf cv cfv normsub
      eqtrd breq1d cn chil vf cv wf vj cv cn wcel wa vj cv vf cv cfv chil wcel
      vk cv cn wcel cn chil vj cv vf cv ffvelrn adantr cn chil vf cv wf vk cv
      cn wcel vk cv vf cv cfv chil wcel vj cv cn wcel cn chil vk cv vf cv
      ffvelrn adantlr sylanc imbi2d ralbidva rexbidva imbi2d ralbidv bitrd
      biimpac sylanc sylc iscms2i $.
      $( [13-Apr-2008] $) $( [10-Apr-2008] $)
  $}

  ${
    hhhl.1 $e |- U = <. <. +h , .h >. , normh >. $.
    $( The Hilbert space structure is a complex Hilbert space. $)
    hhhl $p |- U e. CHil $=
      cU chl wcel cU cbn wcel cU cphl wcel cU ishl cU cbn wcel cU cnv wcel cU
      cims cfv cms wcel cU cims cfv cU cU cims cfv eqid isbn cU hhhl.1 hhnv cU
      cims cfv cU hhhl.1 cU cims cfv eqid hhcms mpbir2an cU hhhl.1 hhph
      mpbir2an $.
      $( [13-Apr-2008] $) $( [10-Apr-2008] $)
  $}

  ${
    hilcms.1 $e |- D = ( normh o. -h ) $.
    $( The Hilbert space norm determines a complete metric space. $)
    hilcms $p |- D e. CMet $=
      cD cva csm cop cno cop cva csm cop cno cop eqid cD cva csm cop cno cop
      cva csm cop cno cop eqid hilcms.1 hhims hhcms $.
      $( [24-Nov-2007] $) $( [17-Apr-2007] $)
  $}

  ${
    $d x y z $.
    $( The Hilbert space of the Hilbert Space Explorer is a complex Hilbert
       space.  (Contributed by Steve Rodriguez, 29-Apr-2007.) $)
    hilhl $p |- <. <. +h , .h >. , normh >. e. CHil $=
      cva csm cop cno cop cva csm cop cno cop eqid hhhl $.
      $( [29-Apr-2007] $) $( [29-Apr-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y h $.
    $( Define the set of subspaces of a Hilbert space.  See
       ~ sh for its membership relation.  Basically, a subspace
       is a subset of a Hilbert space that acts like a vector space.
       From Definition of [Beran] p. 95. $)
    df-sh $a |- SH = { h | ( ( h C_ ~H /\ 0h e. h ) /\
       ( A. x e. h A. y e. h ( x +h y ) e. h /\
       A. x e. CC A. y e. h ( x .h y ) e. h ) ) } $.
  $}

  ${
    $d x y h H $.  $d x y A $.  $d x y B $.
    $( The set of subspaces of a Hilbert space exists (is a set). $)
    shex $p |- SH e. _V $=
      csh vh cv chil wss c0v vh cv wcel wa vx cv vy cv cva co vh cv wcel vy vh
      cv wral vx vh cv wral vx cv vy cv csm co vh cv wcel vy vh cv wral vx cc
      wral wa wa vh cab cvv vx vy vh df-sh vh cv chil wss c0v vh cv wcel wa vx
      cv vy cv cva co vh cv wcel vy vh cv wral vx vh cv wral vx cv vy cv csm co
      vh cv wcel vy vh cv wral vx cc wral wa wa vh cab vh cv chil wss vh cab
      chil cpw vh cv chil wss vh cab cvv vh chil df-pw chil ax-hilex pwex
      eqeltrri vh cv chil wss c0v vh cv wcel wa vx cv vy cv cva co vh cv wcel
      vy vh cv wral vx vh cv wral vx cv vy cv csm co vh cv wcel vy vh cv wral
      vx cc wral wa wa vh cv chil wss vh vh cv chil wss c0v vh cv wcel vx cv vy
      cv cva co vh cv wcel vy vh cv wral vx vh cv wral vx cv vy cv csm co vh cv
      wcel vy vh cv wral vx cc wral wa simpll ss2abi ssexi eqeltri $.
      $( [23-Oct-1999] $)

    $( Subspace ` H ` of a Hilbert space.  A subspace is a subset of Hilbert
       space which contains the zero vector and is closed under vector
       addition and scalar multiplication.  Definition of [Beran] p. 95. $)
    sh $p |- ( H e. SH <-> ( ( H C_ ~H /\ 0h e. H ) /\
       ( A. x e. H A. y e. H ( x +h y ) e. H /\
       A. x e. CC A. y e. H ( x .h y ) e. H ) ) ) $=
      cH csh wcel cH cvv wcel cH chil wss c0v cH wcel wa vx cv vy cv cva co cH
      wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel vy cH wral vx cc
      wral wa wa cH csh elisset cH chil wss cH cvv wcel c0v cH wcel vx cv vy cv
      cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel vy cH
      wral vx cc wral wa cH chil ax-hilex ssex ad2antrr vh cv chil wss c0v vh
      cv wcel wa vx cv vy cv cva co vh cv wcel vy vh cv wral vx vh cv wral vx
      cv vy cv csm co vh cv wcel vy vh cv wral vx cc wral wa wa cH chil wss c0v
      cH wcel wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv
      csm co cH wcel vy cH wral vx cc wral wa wa vh cH csh cvv vh cv cH wceq vh
      cv chil wss c0v vh cv wcel wa cH chil wss c0v cH wcel wa vx cv vy cv cva
      co vh cv wcel vy vh cv wral vx vh cv wral vx cv vy cv csm co vh cv wcel
      vy vh cv wral vx cc wral wa vx cv vy cv cva co cH wcel vy cH wral vx cH
      wral vx cv vy cv csm co cH wcel vy cH wral vx cc wral wa vh cv cH wceq vh
      cv chil wss cH chil wss c0v vh cv wcel c0v cH wcel vh cv cH chil sseq1 vh
      cv cH c0v eleq2 anbi12d vh cv cH wceq vx cv vy cv cva co vh cv wcel vy vh
      cv wral vx vh cv wral vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx
      cv vy cv csm co vh cv wcel vy vh cv wral vx cc wral vx cv vy cv csm co cH
      wcel vy cH wral vx cc wral vx cv vy cv cva co vh cv wcel vy vh cv wral vx
      cv vy cv cva co cH wcel vy cH wral vx vh cv cH vx cv vy cv cva co vh cv
      wcel vx cv vy cv cva co cH wcel vy vh cv cH vh cv cH vx cv vy cv cva co
      eleq2 raleqd raleqd vh cv cH wceq vx cv vy cv csm co vh cv wcel vy vh cv
      wral vx cv vy cv csm co cH wcel vy cH wral vx cc vx cv vy cv csm co vh cv
      wcel vx cv vy cv csm co cH wcel vy vh cv cH vh cv cH vx cv vy cv csm co
      eleq2 raleqd ralbidv anbi12d anbi12d vx vy vh df-sh elab2g pm5.21nii $.
      $( [16-Aug-1999] $)

    $( A subspace is a subset of Hilbert space. $)
    shss $p |- ( H e. SH -> H C_ ~H ) $=
      cH csh wcel cH chil wss c0v cH wcel cH csh wcel cH chil wss c0v cH wcel
      wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH
      wcel vy cH wral vx cc wral wa vx vy cH sh pm3.26bi pm3.26d $.
      $( [9-Oct-1999] $)

    $( A member of a subspace of a Hilbert space is a vector. $)
    shel $p |- ( ( H e. SH /\ A e. H ) -> A e. ~H ) $=
      cH csh wcel cA cH wcel cA chil wcel cH csh wcel cH chil cA cH shss sseld
      imp $.
      $( [16-Dec-2004] $) $( [14-Dec-2004] $)

    ${
      shssi.1 $e |- H e. SH $.
      $( A closed subspace of a Hilbert space is a subset of Hilbert space. $)
      shssii $p |- H C_ ~H $=
        cH csh wcel cH chil wss shssi.1 cH shss ax-mp $.
        $( [6-Oct-1999] $)

      $( A member of a subspace of a Hilbert space is a vector. $)
      sheli $p |- ( A e. H -> A e. ~H ) $=
        cH chil cA cH shssi.1 shssii sseli $.
        $( [6-Oct-1999] $)

      ${
        sheli.1 $e |- A e. H $.
        $( A member of a subspace of a Hilbert space is a vector. $)
        shelii $p |- A e. ~H $=
          cH chil cA cH shssi.1 shssii sheli.1 sselii $.
          $( [6-Oct-1999] $)
      $}
    $}

    $( The zero vector belongs to any subspace of a Hilbert space. $)
    sh0 $p |- ( H e. SH -> 0h e. H ) $=
      cH csh wcel cH chil wss c0v cH wcel cH csh wcel cH chil wss c0v cH wcel
      wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH
      wcel vy cH wral vx cc wral wa vx vy cH sh pm3.26bi pm3.27d $.
      $( [11-Oct-1999] $)

    $( Closure of vector addition in a subspace of a Hilbert space. $)
    shaddcl $p |- ( ( H e. SH /\ A e. H /\ B e. H ) -> ( A +h B ) e. H ) $=
      cH csh wcel cA cH wcel cB cH wcel cA cB cva co cH wcel cA cH wcel cB cH
      wcel wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral cA cB cva co cH
      wcel cH csh wcel vx cv vy cv cva co cH wcel cA cB cva co cH wcel cA vy cv
      cva co cH wcel vx vy cA cB cH cH vx cv cA wceq vx cv vy cv cva co cA vy
      cv cva co cH vx cv cA vy cv cva opreq1 eleq1d vy cv cB wceq cA vy cv cva
      co cA cB cva co cH vy cv cB cA cva opreq2 eleq1d rcla42v cH csh wcel vx
      cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel
      vy cH wral vx cc wral cH csh wcel cH chil wss c0v cH wcel wa vx cv vy cv
      cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel vy cH
      wral vx cc wral wa vx vy cH sh pm3.27bi pm3.26d syl5com 3impib $.
      $( [21-May-2007] $) $( [13-Sep-1999] $)

    $( Closure of vector addition in a subspace of a Hilbert space. $)
    shaddclOLD $p |- ( H e. SH ->
                   ( ( A e. H /\ B e. H ) -> ( A +h B ) e. H ) ) $=
      cA cH wcel cB cH wcel wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral
      cA cB cva co cH wcel cH csh wcel vx cv vy cv cva co cH wcel cA cB cva co
      cH wcel cA vy cv cva co cH wcel vx vy cA cB cH cH vx cv cA wceq vx cv vy
      cv cva co cA vy cv cva co cH vx cv cA vy cv cva opreq1 eleq1d vy cv cB
      wceq cA vy cv cva co cA cB cva co cH vy cv cB cA cva opreq2 eleq1d
      rcla42v cH csh wcel vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx
      cv vy cv csm co cH wcel vy cH wral vx cc wral cH csh wcel cH chil wss c0v
      cH wcel wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv
      csm co cH wcel vy cH wral vx cc wral wa vx vy cH sh pm3.27bi pm3.26d
      syl5com $.
      $( [13-Sep-1999] $)

    $( Closure of vector scalar multiplication in a subspace of a Hilbert
       space. $)
    shmulcl $p |- ( ( H e. SH /\ A e. CC /\ B e. H ) -> ( A .h B ) e. H ) $=
      cH csh wcel cA cc wcel cB cH wcel cA cB csm co cH wcel cA cc wcel cB cH
      wcel wa vx cv vy cv csm co cH wcel vy cH wral vx cc wral cA cB csm co cH
      wcel cH csh wcel vx cv vy cv csm co cH wcel cA cB csm co cH wcel cA vy cv
      csm co cH wcel vx vy cA cB cc cH vx cv cA wceq vx cv vy cv csm co cA vy
      cv csm co cH vx cv cA vy cv csm opreq1 eleq1d vy cv cB wceq cA vy cv csm
      co cA cB csm co cH vy cv cB cA csm opreq2 eleq1d rcla42v cH csh wcel vx
      cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel
      vy cH wral vx cc wral cH csh wcel cH chil wss c0v cH wcel wa vx cv vy cv
      cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel vy cH
      wral vx cc wral wa vx vy cH sh pm3.27bi pm3.27d syl5com 3impib $.
      $( [21-Feb-2007] $) $( [13-Sep-1999] $)

    $( Closure of vector scalar multiplication in a subspace of a Hilbert
       space. $)
    shmulclOLD $p |- ( H e. SH ->
                   ( ( A e. CC /\ B e. H ) -> ( A .h B ) e. H ) ) $=
      cA cc wcel cB cH wcel wa vx cv vy cv csm co cH wcel vy cH wral vx cc wral
      cA cB csm co cH wcel cH csh wcel vx cv vy cv csm co cH wcel cA cB csm co
      cH wcel cA vy cv csm co cH wcel vx vy cA cB cc cH vx cv cA wceq vx cv vy
      cv csm co cA vy cv csm co cH vx cv cA vy cv csm opreq1 eleq1d vy cv cB
      wceq cA vy cv csm co cA cB csm co cH vy cv cB cA csm opreq2 eleq1d
      rcla42v cH csh wcel vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx
      cv vy cv csm co cH wcel vy cH wral vx cc wral cH csh wcel cH chil wss c0v
      cH wcel wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv
      csm co cH wcel vy cH wral vx cc wral wa vx vy cH sh pm3.27bi pm3.27d
      syl5com $.
      $( [13-Sep-1999] $)

    $( Closure of vector subtraction in a subspace of a Hilbert space. $)
    shsubcl $p |- ( ( H e. SH /\ A e. H /\ B e. H ) -> ( A -h B ) e. H ) $=
      cH csh wcel cA cH wcel cB cH wcel w3a cA cB cmv co cA c1 cneg cB csm co
      cva co cH cH csh wcel cA cH wcel cB cH wcel w3a cA chil wcel cB chil wcel
      wa cA cB cmv co cA c1 cneg cB csm co cva co wceq cH csh wcel cA cH wcel
      cB cH wcel cA chil wcel cB chil wcel wa cH csh wcel cA cH wcel cA chil
      wcel cB cH wcel cB chil wcel cH csh wcel cH chil cA cH shss sseld cH csh
      wcel cH chil cB cH shss sseld anim12d 3impib cA cB hvsubval syl cH csh
      wcel cA cH wcel c1 cneg cB csm co cH wcel cA c1 cneg cB csm co cva co cH
      wcel cB cH wcel cA c1 cneg cB csm co cH shaddcl cH csh wcel cB cH wcel c1
      cneg cB csm co cH wcel cA cH wcel cH csh wcel c1 cneg cc wcel cB cH wcel
      c1 cneg cB csm co cH wcel c1 ax1cn negcli c1 cneg cB cH shmulcl mp3an2
      3adant2 syld3an3 eqeltrd $.
      $( [17-Apr-2008] $) $( [18-Oct-1999] $)

    $( Closure of vector subtraction in a subspace of a Hilbert space. $)
    shsubclOLD $p |- ( H e. SH ->
                   ( ( A e. H /\ B e. H ) -> ( A -h B ) e. H ) ) $=
      cH csh wcel cA cH wcel cB cH wcel wa cA cB cmv co cH wcel cH csh wcel cA
      cH wcel cB cH wcel wa wa cA cB cmv co cA c1 cneg cB csm co cva co cH cH
      csh wcel cA cH wcel cB cH wcel wa wa cA chil wcel cB chil wcel wa cA cB
      cmv co cA c1 cneg cB csm co cva co wceq cH csh wcel cA cH wcel cB cH wcel
      wa cA chil wcel cB chil wcel wa cH csh wcel cA cH wcel cA chil wcel cB cH
      wcel cB chil wcel cH csh wcel cH chil cA cH shss sseld cH csh wcel cH
      chil cB cH shss sseld anim12d imp cA cB hvsubval syl cH csh wcel cA cH
      wcel cB cH wcel wa cA c1 cneg cB csm co cva co cH wcel cH csh wcel cA cH
      wcel c1 cneg cB csm co cH wcel cA c1 cneg cB csm co cva co cH wcel cB cH
      wcel cA c1 cneg cB csm co cH shaddclOLD cH csh wcel c1 cneg cc wcel cB cH
      wcel c1 cneg cB csm co cH wcel c1 ax1cn negcli c1 cneg cB cH shmulclOLD
      mpani sylan2d imp eqeltrd ex $.
      $( [18-Oct-1999] $)

    $(
    @( Reversal of subtraction remains a member of a subspace of a Hilbert
       space. @)
    shsubrclt @p  |- ( H e. SH -> ( ( A e. ~H /\ B e. ~H ) ->
                    ( ( A -h B ) e. H <-> ( B -h A ) e. H ) ) ) @=
?@.
    $)

    $( Subspace ` H ` of a Hilbert space. $)
    sh2 $p |- ( H C_ ~H -> ( H e. SH <-> ( 0h e. H /\
       ( A. x e. H A. y e. H ( x +h y ) e. H /\
       A. x e. CC A. y e. H ( x .h y ) e. H ) ) ) ) $=
      cH chil wss cH chil wss c0v cH wcel wa vx cv vy cv cva co cH wcel vy cH
      wral vx cH wral vx cv vy cv csm co cH wcel vy cH wral vx cc wral wa wa
      c0v cH wcel vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv
      csm co cH wcel vy cH wral vx cc wral wa wa cH csh wcel cH chil wss c0v cH
      wcel wa vx cv vy cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm
      co cH wcel vy cH wral vx cc wral wa wa cH chil wss c0v cH wcel vx cv vy
      cv cva co cH wcel vy cH wral vx cH wral vx cv vy cv csm co cH wcel vy cH
      wral vx cc wral wa wa cH chil wss c0v cH wcel vx cv vy cv cva co cH wcel
      vy cH wral vx cH wral vx cv vy cv csm co cH wcel vy cH wral vx cc wral wa
      anass baib vx vy cH sh syl5bb $.
      $( [16-Aug-1999] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Closed subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x f h $.
    $( Define the set of closed subspaces of a Hilbert space.  A closed
       subspace is one in which the limit of every convergent sequence
       in the subspace belongs to the subspace.  For its
       membership relation, see ~ closedsub .  From Definition of [Beran]
       p. 107.  Alternate definitions are given by ~ chcmhi and ~ dfch2 . $)
    df-ch $a |- CH = { h | ( h e. SH /\ A. f A. x ( ( f : NN --> h /\
        f ~~>v x ) -> x e. h ) ) } $.
  $}

  ${
    $d x f h H $.
    $( Closed subspace ` H ` of a Hilbert space.  Definition of [Beran]
       p. 107. $)
    closedsub $p |- ( H e. CH <-> ( H e. SH /\ A. f A. x ( ( f : NN --> H /\
        f ~~>v x ) -> x e. H ) ) ) $=
      cH cch wcel cH cvv wcel cH csh wcel cn cH vf cv wf vf cv vx cv chli wbr
      wa vx cv cH wcel wi vx wal vf wal wa cH cch elisset cH csh wcel cH cvv
      wcel cn cH vf cv wf vf cv vx cv chli wbr wa vx cv cH wcel wi vx wal vf
      wal cH csh elisset adantr vh cv csh wcel cn vh cv vf cv wf vf cv vx cv
      chli wbr wa vx cv vh cv wcel wi vx wal vf wal wa cH csh wcel cn cH vf cv
      wf vf cv vx cv chli wbr wa vx cv cH wcel wi vx wal vf wal wa vh cH cch
      cvv vh cv cH wceq vh cv csh wcel cH csh wcel cn vh cv vf cv wf vf cv vx
      cv chli wbr wa vx cv vh cv wcel wi vx wal vf wal cn cH vf cv wf vf cv vx
      cv chli wbr wa vx cv cH wcel wi vx wal vf wal vh cv cH csh eleq1 vh cv cH
      wceq cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi cn cH
      vf cv wf vf cv vx cv chli wbr wa vx cv cH wcel wi vf vx vh cv cH wceq cn
      vh cv vf cv wf vf cv vx cv chli wbr wa cn cH vf cv wf vf cv vx cv chli
      wbr wa vx cv vh cv wcel vx cv cH wcel vh cv cH wceq cn vh cv vf cv wf cn
      cH vf cv wf vf cv vx cv chli wbr vh cv cH cn vf cv feq3 anbi1d vh cv cH
      vx cv eleq2 imbi12d 2albidv anbi12d vx vf vh df-ch elab2g pm5.21nii $.
      $( [17-Aug-1999] $)
  $}

  ${
    $d x f h $.
    $( Closed subspaces are subspaces in a Hilbert space. $)
    chsssh $p |- CH C_ SH $=
      cch vh cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv
      wcel wi vx wal vf wal wa vh cab csh vx vf vh df-ch cn vh cv vf cv wf vf
      cv vx cv chli wbr wa vx cv vh cv wcel wi vx wal vf wal vh csh ssab2
      eqsstri $.
      $( [29-May-1999] $)
  $}

  $( The set of closed subspaces of a Hilbert space exists (is a set). $)
  chex $p |- CH e. _V $=
    cch csh shex chsssh ssexi $.
    $( [23-Oct-1999] $)

  $( A closed subspace is a subspace. $)
  chsh $p |- ( H e. CH -> H e. SH ) $=
    cch csh cH chsssh sseli $.
    $( [19-Oct-1999] $)

  ${
    chshi.1 $e |- H e. CH $.
    $( A closed subspace is a subspace. $)
    chshii $p |- H e. SH $=
      cH cch wcel cH csh wcel chshi.1 cH chsh ax-mp $.
      $( [19-Oct-1999] $)
  $}

  ${
    $d x y H $.
    $( The zero vector belongs to any closed subspace of a Hilbert space. $)
    ch0 $p |- ( H e. CH -> 0h e. H ) $=
      cH cch wcel cH csh wcel c0v cH wcel cH chsh cH sh0 syl $.
      $( [24-Aug-1999] $)

    $( A closed subspace of a Hilbert space is a subset of Hilbert space. $)
    chss $p |- ( H e. CH -> H C_ ~H ) $=
      cH cch wcel cH csh wcel cH chil wss cH chsh cH shss syl $.
      $( [24-Aug-1999] $)

  $}

  $( A member of a closed subspace of a Hilbert space is a vector. $)
  chel $p |- ( ( H e. CH /\ A e. H ) -> A e. ~H ) $=
    cH cch wcel cA cH wcel cA chil wcel cH cch wcel cH chil cA cH chss sseld
    imp $.
    $( [17-Dec-2004] $) $( [15-Dec-2004] $)

  ${
    chssi.1 $e |- H e. CH $.
    $( A closed subspace of a Hilbert space is a subset of Hilbert space. $)
    chssii $p |- H C_ ~H $=
      cH cH chssi.1 chshii shssii $.
      $( [6-Oct-1999] $)

    $( A member of a closed subspace of a Hilbert space is a vector. $)
    cheli $p |- ( A e. H -> A e. ~H ) $=
      cH chil cA cH chssi.1 chssii sseli $.
      $( [6-Oct-1999] $)

    ${
      cheli.1 $e |- A e. H $.
      $( A member of a closed subspace of a Hilbert space is a vector. $)
      chelii $p |- A e. ~H $=
        cH chil cA cH chssi.1 chssii cheli.1 sselii $.
        $( [6-Oct-1999] $)
    $}
  $}

  ${
    $d x f F $.  $d x f H $.  $d x A $.
    chlim.1 $e |- A e. _V $.
    $( The limit property of a closed subspace of a Hilbert space. $)
    chlimi $p |- ( ( H e. CH /\ F : NN --> H /\ F ~~>v A ) -> A e. H ) $=
      cH cch wcel cn cH cF wf cF cA chli wbr cA cH wcel cH cch wcel cn cH vf cv
      wf vf cv vx cv chli wbr wa vx cv cH wcel wi vx wal vf wal cn cH cF wf cF
      cA chli wbr wa cA cH wcel wi cH cch wcel cH csh wcel cn cH vf cv wf vf cv
      vx cv chli wbr wa vx cv cH wcel wi vx wal vf wal vx vf cH closedsub
      pm3.27bi cn cH vf cv wf vf cv vx cv chli wbr wa vx cv cH wcel wi vx wal
      vf wal cn cH cF wf cF cA chli wbr wa cA cH wcel cn cH cF wf cF cA chli
      wbr wa cF cvv wcel cn cH vf cv wf vf cv vx cv chli wbr wa vx cv cH wcel
      wi vx wal vf wal cn cH cF wf cF cA chli wbr wa cA cH wcel wi wi cn cH cF
      wf cF cvv wcel cF cA chli wbr cn cH cF wf cn cvv wcel cF cvv wcel nnex cn
      cH cvv cF fex mpan2 adantr cF cvv wcel cn cH vf cv wf vf cv vx cv chli
      wbr wa vx cv cH wcel wi vx wal vf wal cn cH cF wf cF vx cv chli wbr wa vx
      cv cH wcel wi vx wal cn cH cF wf cF cA chli wbr wa cA cH wcel wi cn cH vf
      cv wf vf cv vx cv chli wbr wa vx cv cH wcel wi vx wal cn cH cF wf cF vx
      cv chli wbr wa vx cv cH wcel wi vx wal vf cF cvv vf cv cF wceq cn cH vf
      cv wf vf cv vx cv chli wbr wa vx cv cH wcel wi cn cH cF wf cF vx cv chli
      wbr wa vx cv cH wcel wi vx vf cv cF wceq cn cH vf cv wf vf cv vx cv chli
      wbr wa cn cH cF wf cF vx cv chli wbr wa vx cv cH wcel vf cv cF wceq cn cH
      vf cv wf cn cH cF wf vf cv vx cv chli wbr cF vx cv chli wbr cn cH vf cv
      cF feq1 vf cv cF vx cv chli breq1 anbi12d imbi1d albidv cla4gv cn cH cF
      wf cF vx cv chli wbr wa vx cv cH wcel wi cn cH cF wf cF cA chli wbr wa cA
      cH wcel wi vx cA chlim.1 vx cv cA wceq cn cH cF wf cF vx cv chli wbr wa
      cn cH cF wf cF cA chli wbr wa vx cv cH wcel cA cH wcel vx cv cA wceq cF
      vx cv chli wbr cF cA chli wbr cn cH cF wf vx cv cA cF chli breq2 anbi2d
      vx cv cA cH eleq1 imbi12d cla4v syl6 syl pm2.43b syl 3impib $.
      $( [14-Apr-2008] $) $( [14-Sep-1999] $)
  $}

  ${
    $d x y z $.
    $( The zero sequence in Hilbert space converges to the zero vector. $)
    hlim0 $p |- ( NN X. { 0h } ) ~~>v 0h $=
      cn c0v csn cxp c0v chli wbr cn chil cn c0v csn cxp wf c0v chil wcel wa
      cc0 vx cv clt wbr vy cv vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co
      cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr wral vx vy vz c0v
      cn c0v csn cxp cn c0v csn nnex c0v snex xpex c0v chil ax-hv0cl elisseti
      hlimi cn chil cn c0v csn cxp wf c0v chil wcel cn c0v csn cn c0v csn cxp
      wf c0v csn chil wss cn chil cn c0v csn cxp wf cn c0v c0v chil ax-hv0cl
      elisseti fconst c0v chil wcel c0v csn chil wss ax-hv0cl c0v chil snssi
      ax-mp cn c0v csn chil cn c0v csn cxp fss mp2an ax-hv0cl pm3.2i cc0 vx cv
      clt wbr vy cv vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv
      vx cv clt wbr wi vz cn wral vy cn wrex wi vx cr cc0 vx cv clt wbr vy cv
      vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv vx cv clt wbr
      wi vz cn wral vy cn wrex wi vx cv cr wcel cc0 vx cv clt wbr c1 cn wcel c1
      vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv vx cv clt wbr
      wi vz cn wral wa vy cv vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co
      cno cfv vx cv clt wbr wi vz cn wral vy cn wrex cc0 vx cv clt wbr c1 vz cv
      cle wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv vx cv clt wbr wi vz
      cn wral c1 cn wcel cc0 vx cv clt wbr c1 vz cv cle wbr vz cv cn c0v csn
      cxp cfv c0v cmv co cno cfv vx cv clt wbr wi vz cn vz cv cn wcel c1 vz cv
      cle wbr cc0 vx cv clt wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv vx
      cv clt wbr vz cv cn wcel cc0 vx cv clt wbr vz cv cn c0v csn cxp cfv c0v
      cmv co cno cfv vx cv clt wbr wi c1 vz cv cle wbr vz cv cn wcel vz cv cn
      c0v csn cxp cfv c0v cmv co cno cfv vx cv clt wbr cc0 vx cv clt wbr vz cv
      cn wcel vz cv cn c0v csn cxp cfv c0v cmv co cno cfv cc0 vx cv clt vz cv
      cn wcel vz cv cn c0v csn cxp cfv c0v cmv co cno cfv c0v cno cfv cc0 vz cv
      cn wcel vz cv cn c0v csn cxp cfv c0v cmv co c0v cno vz cv cn wcel vz cv
      cn c0v csn cxp cfv c0v cmv co c0v c0v cmv co c0v vz cv cn wcel vz cv cn
      c0v csn cxp cfv c0v c0v cmv cn c0v vz cv c0v chil ax-hv0cl elisseti
      fvconst2 opreq1d c0v chil wcel c0v c0v cmv co c0v wceq ax-hv0cl c0v
      hvsubid ax-mp syl6eq fveq2d norm0 syl6eq breq1d biimprd a1d com3r
      r19.21aiv 1nn jctil vy cv vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv
      co cno cfv vx cv clt wbr wi vz cn wral c1 vz cv cle wbr vz cv cn c0v csn
      cxp cfv c0v cmv co cno cfv vx cv clt wbr wi vz cn wral vy c1 cn vy cv c1
      wceq vy cv vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv vx
      cv clt wbr wi c1 vz cv cle wbr vz cv cn c0v csn cxp cfv c0v cmv co cno
      cfv vx cv clt wbr wi vz cn vy cv c1 wceq vy cv vz cv cle wbr c1 vz cv cle
      wbr vz cv cn c0v csn cxp cfv c0v cmv co cno cfv vx cv clt wbr vy cv c1 vz
      cv cle breq1 imbi1d ralbidv rcla4ev syl a1i rgen mpbir2an $.
      $( [17-Aug-1999] $)
  $}

  ${
    $d x y z w v A $.  $d x y z w v F $.
    hlimcau.1 $e |- A e. _V $.
    hlimcau.2 $e |- F e. _V $.
    ${
      hlimcaui.4 $e |- F ~~>v A $.
      $( If a sequence in Hilbert space subset converges to a limit, it is a
         Cauchy sequence. $)
      hlimcauii $p |- F e. Cauchy $=
        cF ccau wcel cn chil cF wf cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv
        vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr
        wi vw cn wral vz cn wral vy cn wrex wi vx cr wral vx vy vz vw cF hcau
        cF cA chli wbr cn chil cF wf hlimcaui.4 cA cF hlimcau.2 hlimcau.1
        hlimseqi ax-mp cc0 vx cv clt wbr vy cv vz cv cle wbr vy cv vw cv cle
        wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi vw cn
        wral vz cn wral vy cn wrex wi vx cr vx cv cr wcel cc0 vx cv clt wbr vy
        cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv
        co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex vx cv cr
        wcel cc0 vx cv clt wbr wa vy cv vz cv cle wbr vz cv cF cfv cA cmv co
        cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral vy cn wrex vy cv vz cv
        cle wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv
        vx cv clt wbr wi vw cn wral vz cn wral vy cn wrex vx cv c2 cdiv co cr
        wcel cc0 vx cv c2 cdiv co clt wbr vy cv vz cv cle wbr vz cv cF cfv cA
        cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral vy cn wrex vx cv
        cr wcel cc0 vx cv clt wbr wa cc0 vv cv clt wbr vy cv vz cv cle wbr vz
        cv cF cfv cA cmv co cno cfv vv cv clt wbr wi vz cn wral vy cn wrex wi
        cc0 vx cv c2 cdiv co clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co
        cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral vy cn wrex wi vv vx cv
        c2 cdiv co cr vv cv vx cv c2 cdiv co wceq cc0 vv cv clt wbr cc0 vx cv
        c2 cdiv co clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv
        vv cv clt wbr wi vz cn wral vy cn wrex vy cv vz cv cle wbr vz cv cF cfv
        cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral vy cn wrex vv
        cv vx cv c2 cdiv co cc0 clt breq2 vv cv vx cv c2 cdiv co wceq vy cv vz
        cv cle wbr vz cv cF cfv cA cmv co cno cfv vv cv clt wbr wi vy cv vz cv
        cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vy
        vz cn cn vv cv vx cv c2 cdiv co wceq vz cv cF cfv cA cmv co cno cfv vv
        cv clt wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr vy
        cv vz cv cle wbr vv cv vx cv c2 cdiv co vz cv cF cfv cA cmv co cno cfv
        clt breq2 imbi2d rexralbidv imbi12d cn chil cF wf cA chil wcel cc0 vv
        cv clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vv cv clt
        wbr wi vz cn wral vy cn wrex wi vv cr wral cF cA chli wbr cn chil cF wf
        hlimcaui.4 cA cF hlimcau.2 hlimcau.1 hlimseqi ax-mp cF cA chli wbr cA
        chil wcel hlimcaui.4 cA cF hlimcau.2 hlimcau.1 hlimveci ax-mp cn chil
        cF wf cA chil wcel wa cF cA chli wbr cc0 vv cv clt wbr vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv vv cv clt wbr wi vz cn wral vy cn
        wrex wi vv cr wral hlimcaui.4 vv vy vz cA cF hlim2 mpbii mp2an vtoclri
        vx cv cr wcel vx cv c2 cdiv co cr wcel cc0 vx cv clt wbr vx cv rehalfcl
        adantr vx cv cr wcel cc0 vx cv clt wbr cc0 vx cv c2 cdiv co clt wbr vx
        cv cr wcel cc0 vx cv clt wbr cc0 vx cv c2 cdiv co clt wbr wi cc0 vx cv
        cr wcel vx cv cc0 cif clt wbr cc0 vx cv cr wcel vx cv cc0 cif c2 cdiv
        co clt wbr wi vx cv cc0 vx cv vx cv cr wcel vx cv cc0 cif wceq cc0 vx
        cv clt wbr cc0 vx cv cr wcel vx cv cc0 cif clt wbr cc0 vx cv c2 cdiv co
        clt wbr cc0 vx cv cr wcel vx cv cc0 cif c2 cdiv co clt wbr vx cv vx cv
        cr wcel vx cv cc0 cif cc0 clt breq2 vx cv vx cv cr wcel vx cv cc0 cif
        wceq vx cv c2 cdiv co vx cv cr wcel vx cv cc0 cif c2 cdiv co cc0 clt vx
        cv vx cv cr wcel vx cv cc0 cif c2 cdiv opreq1 breq2d imbi12d vx cv cr
        wcel vx cv cc0 cif c2 vx cv cc0 cr 0re elimel 2re 2pos divgt0i2i dedth
        imp sylc vx cv cr wcel vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno
        cfv vx cv c2 cdiv co clt wbr wi vz cn wral vy cn wrex vy cv vz cv cle
        wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx
        cv clt wbr wi vw cn wral vz cn wral vy cn wrex wi cc0 vx cv clt wbr vx
        cv cr wcel vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2
        cdiv co clt wbr wi vz cn wral vy cv vz cv cle wbr vy cv vw cv cle wbr
        wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi vw cn wral
        vz cn wral vy cn vx cv cr wcel vy cv vz cv cle wbr vz cv cF cfv cA cmv
        co cno cfv vx cv c2 cdiv co clt wbr wi vy cv vw cv cle wbr vw cv cF cfv
        cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi wa vw cn wral vz cn wral
        vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv
        cmv co cno cfv vx cv clt wbr wi vw cn wral vz cn wral vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz cn
        wral vx cv cr wcel vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv
        vx cv c2 cdiv co clt wbr wi vy cv vw cv cle wbr vw cv cF cfv cA cmv co
        cno cfv vx cv c2 cdiv co clt wbr wi wa vw cn wral vy cv vz cv cle wbr
        vy cv vw cv cle wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv
        clt wbr wi vw cn wral vz cn vx cv cr wcel vz cv cn wcel wa vy cv vz cv
        cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vy
        cv vw cv cle wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt
        wbr wi wa vy cv vz cv cle wbr vy cv vw cv cle wbr wa vz cv cF cfv vw cv
        cF cfv cmv co cno cfv vx cv clt wbr wi vw cn vy cv vz cv cle wbr vz cv
        cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vy cv vw cv cle
        wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi wa vy cv
        vz cv cle wbr vy cv vw cv cle wbr wa vz cv cF cfv cA cmv co cno cfv vx
        cv c2 cdiv co clt wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co
        clt wbr wa vx cv cr wcel vz cv cn wcel wa vw cv cn wcel wa vz cv cF cfv
        vw cv cF cfv cmv co cno cfv vx cv clt wbr vy cv vz cv cle wbr vz cv cF
        cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr vy cv vw cv cle wbr vw
        cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr prth vx cv cr wcel
        vz cv cn wcel wa cA chil wcel vw cv cF cfv chil wcel wa vz cv cF cfv cA
        cmv co cno cfv vx cv c2 cdiv co clt wbr vw cv cF cfv cA cmv co cno cfv
        vx cv c2 cdiv co clt wbr wa vz cv cF cfv vw cv cF cfv cmv co cno cfv vx
        cv clt wbr wi vw cv cn wcel vx cv cr wcel vz cv cn wcel wa cA chil wcel
        vw cv cF cfv chil wcel wa wa vz cv cF cfv cA cmv co cno cfv vx cv c2
        cdiv co clt wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr
        wa vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr cA vw cv cF
        cfv cmv co cno cfv vx cv c2 cdiv co clt wbr wa vz cv cF cfv vw cv cF
        cfv cmv co cno cfv vx cv clt wbr cA chil wcel vw cv cF cfv chil wcel wa
        vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr cA vw cv cF cfv
        cmv co cno cfv vx cv c2 cdiv co clt wbr wa vz cv cF cfv cA cmv co cno
        cfv vx cv c2 cdiv co clt wbr vw cv cF cfv cA cmv co cno cfv vx cv c2
        cdiv co clt wbr wa wb vx cv cr wcel vz cv cn wcel wa cA chil wcel vw cv
        cF cfv chil wcel wa cA vw cv cF cfv cmv co cno cfv vx cv c2 cdiv co clt
        wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr vz cv cF
        cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr cA chil wcel vw cv cF
        cfv chil wcel wa cA vw cv cF cfv cmv co cno cfv vw cv cF cfv cA cmv co
        cno cfv vx cv c2 cdiv co clt cA vw cv cF cfv normsub breq1d anbi2d
        adantl vx cv cr wcel vz cv cn wcel wa cA chil wcel vw cv cF cfv chil
        wcel wa wa vz cv cF cfv chil wcel vw cv cF cfv chil wcel wa cA chil
        wcel vx cv cr wcel wa wa vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv
        co clt wbr cA vw cv cF cfv cmv co cno cfv vx cv c2 cdiv co clt wbr wa
        vz cv cF cfv vw cv cF cfv cmv co cno cfv vx cv clt wbr wi cA chil wcel
        vw cv cF cfv chil wcel wa vx cv cr wcel vz cv cn wcel wa vz cv cF cfv
        chil wcel vw cv cF cfv chil wcel wa cA chil wcel vx cv cr wcel wa wa cA
        chil wcel vx cv cr wcel vw cv cF cfv chil wcel vz cv cn wcel vz cv cF
        cfv chil wcel vw cv cF cfv chil wcel wa cA chil wcel vx cv cr wcel wa
        wa vw cv cF cfv chil wcel vz cv cn wcel wa cA chil wcel vx cv cr wcel
        wa vz cv cF cfv chil wcel vw cv cF cfv chil wcel wa cA chil wcel vx cv
        cr wcel wa wa vw cv cF cfv chil wcel vz cv cn wcel wa vz cv cF cfv chil
        wcel vw cv cF cfv chil wcel wa cA chil wcel vx cv cr wcel wa vz cv cn
        wcel vw cv cF cfv chil wcel vz cv cF cfv chil wcel vw cv cF cfv chil
        wcel wa vz cv cn wcel vz cv cF cfv chil wcel vw cv cF cfv chil wcel cn
        chil vz cv cF cF cA chli wbr cn chil cF wf hlimcaui.4 cA cF hlimcau.2
        hlimcau.1 hlimseqi ax-mp ffvelrni anim1i ancoms anim1i ancoms an4s
        ancoms vz cv cF cfv vw cv cF cfv cA vx cv norm3lemt syl sylbird vw cv
        cn wcel vw cv cF cfv chil wcel cA chil wcel cn chil vw cv cF cF cA chli
        wbr cn chil cF wf hlimcaui.4 cA cF hlimcau.2 hlimcau.1 hlimseqi ax-mp
        ffvelrni cF cA chli wbr cA chil wcel hlimcaui.4 cA cF hlimcau.2
        hlimcau.1 hlimveci ax-mp jctil sylan2 syl9r r19.20dva r19.20dva vy cv
        vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr
        wi vy cv vw cv cle wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co
        clt wbr wi wa vw cn wral vz cn wral vy cv vz cv cle wbr vz cv cF cfv cA
        cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral vy cv vw cv cle
        wbr vw cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vw cn
        wral wa vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2
        cdiv co clt wbr wi vz cn wral vy cv vz cv cle wbr vz cv cF cfv cA cmv
        co cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral wa vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz cn
        wral vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv
        co clt wbr wi vy cv vw cv cle wbr vw cv cF cfv cA cmv co cno cfv vx cv
        c2 cdiv co clt wbr wi vz vw cn raaanv vy cv vw cv cle wbr vw cv cF cfv
        cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vw cn wral vy cv vz cv
        cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz
        cn wral vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv c2
        cdiv co clt wbr wi vz cn wral vy cv vw cv cle wbr vw cv cF cfv cA cmv
        co cno cfv vx cv c2 cdiv co clt wbr wi vy cv vz cv cle wbr vz cv cF cfv
        cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vw vz cn vw cv vz cv wceq
        vy cv vw cv cle wbr vy cv vz cv cle wbr vw cv cF cfv cA cmv co cno cfv
        vx cv c2 cdiv co clt wbr vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv
        co clt wbr vw cv vz cv vy cv cle breq2 vw cv vz cv wceq vw cv cF cfv cA
        cmv co cno cfv vz cv cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt vw
        cv vz cv wceq vw cv cF cfv cA cmv co vz cv cF cfv cA cmv co cno vw cv
        vz cv wceq vw cv cF cfv vz cv cF cfv cA cmv vw cv vz cv cF fveq2
        opreq1d fveq2d breq1d imbi12d cbvralv anbi2i vy cv vz cv cle wbr vz cv
        cF cfv cA cmv co cno cfv vx cv c2 cdiv co clt wbr wi vz cn wral anidm
        3bitri syl5ibr r19.22sdv adantr mpd ex rgen mpbir2an $.
        $( [17-Aug-1999] $)
    $}

    $( If a sequence in Hilbert space subset converges to a limit, it is a
       Cauchy sequence. $)
    hlimcaui $p |- ( F ~~>v A -> F e. Cauchy ) $=
      cF cA chli wbr cF ccau wcel cF cA chli wbr cF cn c0v csn cxp cif ccau
      wcel cF cn c0v csn cxp cF cF cA chli wbr cF cn c0v csn cxp cif ccau eleq1
      cF cA chli wbr cA c0v cif cF cA chli wbr cF cn c0v csn cxp cif cF cA chli
      wbr cA c0v hlimcau.1 c0v chil ax-hv0cl elisseti ifex cF cA chli wbr cF cn
      c0v csn cxp hlimcau.2 cn c0v csn nnex c0v snex xpex ifex cF cA chli wbr
      cF cA chli wbr cF cn c0v csn cxp cif cA chli wbr cF cA chli wbr cF cn c0v
      csn cxp cif cF cA chli wbr cA c0v cif chli wbr cn c0v csn cxp c0v chli
      wbr cF cA cn c0v csn cxp c0v cF cA chli wbr cF cn c0v csn cxp cif c0v
      chli wbr cF cF cA chli wbr cF cn c0v csn cxp cif cA chli breq1 cA cF cA
      chli wbr cA c0v cif cF cA chli wbr cF cn c0v csn cxp cif chli breq2 cn
      c0v csn cxp cF cA chli wbr cF cn c0v csn cxp cif c0v chli breq1 c0v cF cA
      chli wbr cA c0v cif cF cA chli wbr cF cn c0v csn cxp cif chli breq2 hlim0
      elimhyp2v hlimcauii dedth $.
      $( [17-Aug-1999] $)
  $}

  ${
    $d x y z w v A $.  $d x y z w v B $.  $d x y z w v F $.
    hlimuni.1 $e |- A e. _V $.
    hlimuni.2 $e |- B e. _V $.
    hlimuni.3 $e |- F e. _V $.
    ${
      hlimunii.3 $e |- ( F ~~>v A /\ F ~~>v B ) $.
      $( A Hilbert space sequence converges to at most one limit. $)
      hlimuniii $p |- A = B $=
        cA cB cmv co c0v wceq cA cB wceq cc0 cA cB cmv co cno cfv clt wbr wn cA
        cB cmv co c0v wceq cc0 cA cB cmv co cno cfv clt wbr vy cv vz cv cle wbr
        vw cv vz cv cle wbr wa vz cn wrex vw cn wral vy cn wral vy cv vz cv cle
        wbr vw cv vz cv cle wbr wa vz cn wrex vy vw cn vz vy cv vw cv nn2ge
        rgen2a cc0 cA cB cmv co cno cfv clt wbr cc0 cA cB cmv co cno cfv c2
        cdiv co clt wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv cA
        cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral vy cn wrex vw cv vz
        cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv
        co clt wbr wi vz cn wral vw cn wrex wa vy cv vz cv cle wbr vw cv vz cv
        cle wbr wa vz cn wrex vw cn wral vy cn wral wn cA cB cmv co cno cfv c2
        cA cB cmv co cA cB cF cA chli wbr cA chil wcel cF cA chli wbr cF cB
        chli wbr hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1 hlimveci ax-mp cF
        cB chli wbr cB chil wcel cF cA chli wbr cF cB chli wbr hlimunii.3
        pm3.27i cB cF hlimuni.3 hlimuni.2 hlimveci ax-mp hvsubcli normcli 2re
        2pos divgt0i2i cc0 cA cB cmv co cno cfv c2 cdiv co clt wbr vy cv vz cv
        cle wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co
        clt wbr wi vz cn wral vy cn wrex vw cv vz cv cle wbr vz cv cF cfv cB
        cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral vw
        cn wrex cA cB cmv co cno cfv c2 cdiv co cr wcel cc0 vx cv clt wbr vy cv
        vz cv cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn
        wral vy cn wrex wi vx cr wral cc0 cA cB cmv co cno cfv c2 cdiv co clt
        wbr vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno
        cfv c2 cdiv co clt wbr wi vz cn wral vy cn wrex wi cA cB cmv co cno cfv
        c2 cA cB cmv co cA cB cF cA chli wbr cA chil wcel cF cA chli wbr cF cB
        chli wbr hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1 hlimveci ax-mp cF
        cB chli wbr cB chil wcel cF cA chli wbr cF cB chli wbr hlimunii.3
        pm3.27i cB cF hlimuni.3 hlimuni.2 hlimveci ax-mp hvsubcli normcli 2re
        2ne0 redivcli cF cA chli wbr cc0 vx cv clt wbr vy cv vz cv cle wbr vz
        cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex wi
        vx cr wral cF cA chli wbr cF cB chli wbr hlimunii.3 pm3.26i vx vy vz cA
        cF hlimuni.3 hlimuni.1 hlimconvi ax-mp cc0 vx cv clt wbr vy cv vz cv
        cle wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vz cn wral vy
        cn wrex wi cc0 cA cB cmv co cno cfv c2 cdiv co clt wbr vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt
        wbr wi vz cn wral vy cn wrex wi vx cA cB cmv co cno cfv c2 cdiv co cr
        vx cv cA cB cmv co cno cfv c2 cdiv co wceq cc0 vx cv clt wbr cc0 cA cB
        cmv co cno cfv c2 cdiv co clt wbr vy cv vz cv cle wbr vz cv cF cfv cA
        cmv co cno cfv vx cv clt wbr wi vz cn wral vy cn wrex vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt
        wbr wi vz cn wral vy cn wrex vx cv cA cB cmv co cno cfv c2 cdiv co cc0
        clt breq2 vx cv cA cB cmv co cno cfv c2 cdiv co wceq vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv vx cv clt wbr wi vy cv vz cv cle wbr
        vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr
        wi vy vz cn cn vx cv cA cB cmv co cno cfv c2 cdiv co wceq vz cv cF cfv
        cA cmv co cno cfv vx cv clt wbr vz cv cF cfv cA cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr vy cv vz cv cle wbr vx cv cA cB cmv
        co cno cfv c2 cdiv co vz cv cF cfv cA cmv co cno cfv clt breq2 imbi2d
        rexralbidv imbi12d rcla4v mp2 cA cB cmv co cno cfv c2 cdiv co cr wcel
        cc0 vx cv clt wbr vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv vx
        cv clt wbr wi vz cn wral vw cn wrex wi vx cr wral cc0 cA cB cmv co cno
        cfv c2 cdiv co clt wbr vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno
        cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral vw cn wrex wi
        cA cB cmv co cno cfv c2 cA cB cmv co cA cB cF cA chli wbr cA chil wcel
        cF cA chli wbr cF cB chli wbr hlimunii.3 pm3.26i cA cF hlimuni.3
        hlimuni.1 hlimveci ax-mp cF cB chli wbr cB chil wcel cF cA chli wbr cF
        cB chli wbr hlimunii.3 pm3.27i cB cF hlimuni.3 hlimuni.2 hlimveci ax-mp
        hvsubcli normcli 2re 2ne0 redivcli cF cB chli wbr cc0 vx cv clt wbr vw
        cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv vx cv clt wbr wi vz cn
        wral vw cn wrex wi vx cr wral cF cA chli wbr cF cB chli wbr hlimunii.3
        pm3.27i vx vw vz cB cF hlimuni.3 hlimuni.2 hlimconvi ax-mp cc0 vx cv
        clt wbr vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv vx cv clt
        wbr wi vz cn wral vw cn wrex wi cc0 cA cB cmv co cno cfv c2 cdiv co clt
        wbr vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno
        cfv c2 cdiv co clt wbr wi vz cn wral vw cn wrex wi vx cA cB cmv co cno
        cfv c2 cdiv co cr vx cv cA cB cmv co cno cfv c2 cdiv co wceq cc0 vx cv
        clt wbr cc0 cA cB cmv co cno cfv c2 cdiv co clt wbr vw cv vz cv cle wbr
        vz cv cF cfv cB cmv co cno cfv vx cv clt wbr wi vz cn wral vw cn wrex
        vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv
        c2 cdiv co clt wbr wi vz cn wral vw cn wrex vx cv cA cB cmv co cno cfv
        c2 cdiv co cc0 clt breq2 vx cv cA cB cmv co cno cfv c2 cdiv co wceq vw
        cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv vx cv clt wbr wi vw cv
        vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2
        cdiv co clt wbr wi vw vz cn cn vx cv cA cB cmv co cno cfv c2 cdiv co
        wceq vz cv cF cfv cB cmv co cno cfv vx cv clt wbr vz cv cF cfv cB cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vw cv vz cv cle wbr
        vx cv cA cB cmv co cno cfv c2 cdiv co vz cv cF cfv cB cmv co cno cfv
        clt breq2 imbi2d rexralbidv imbi12d rcla4v mp2 jca vy cv vz cv cle wbr
        vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr
        wi vz cn wral vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral wa vw cn wrex vy cn
        wrex vy cv vz cv cle wbr vw cv vz cv cle wbr wa wn vz cn wral vw cn
        wrex vy cn wrex vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv cA
        cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral vy cn wrex vw cv vz
        cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv
        co clt wbr wi vz cn wral vw cn wrex wa vy cv vz cv cle wbr vw cv vz cv
        cle wbr wa vz cn wrex vw cn wral vy cn wral wn vy cv vz cv cle wbr vz
        cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi
        vz cn wral vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv
        co cno cfv c2 cdiv co clt wbr wi vz cn wral wa vw cn wrex vy cv vz cv
        cle wbr vw cv vz cv cle wbr wa wn vz cn wral vw cn wrex vy cn vy cv vz
        cv cle wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv
        co clt wbr wi vz cn wral vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno
        cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral wa vy cv vz
        cv cle wbr vw cv vz cv cle wbr wa wn vz cn wral vw cn vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt
        wbr wi vz cn wral vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA
        cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral wa vy cv vz cv cle
        wbr vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt
        wbr wi vw cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co
        cno cfv c2 cdiv co clt wbr wi wa vz cn wral vy cv vz cv cle wbr vw cv
        vz cv cle wbr wa wn vz cn wral vy cv vz cv cle wbr vz cv cF cfv cA cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi vw cv vz cv cle
        wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt
        wbr wi vz cn r19.26 vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv
        cA cB cmv co cno cfv c2 cdiv co clt wbr wi vw cv vz cv cle wbr vz cv cF
        cfv cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi wa vy
        cv vz cv cle wbr vw cv vz cv cle wbr wa wn vz cn vz cv cn wcel vy cv vz
        cv cle wbr vw cv vz cv cle wbr wa vz cv cF cfv cA cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr wa wi vy cv vz cv cle wbr vw cv vz cv
        cle wbr wa wn vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr wi vw cv vz cv cle wbr vz cv cF cfv
        cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi wa vy cv
        vz cv cle wbr vw cv vz cv cle wbr wa vz cv cF cfv cA cmv co cno cfv cA
        cB cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv co cno cfv cA
        cB cmv co cno cfv c2 cdiv co clt wbr wa wi vz cv cF cfv cA cmv co cno
        cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv co cno
        cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wa wn vy cv vz cv cle wbr
        vw cv vz cv cle wbr wa wn vz cv cn wcel vy cv vz cv cle wbr vw cv vz cv
        cle wbr wa vz cv cF cfv cA cmv co cno cfv cA cB cmv co cno cfv c2 cdiv
        co clt wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv
        co clt wbr wa con3 vz cv cn wcel vz cv cF cfv cA cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr wa cA cB cmv co cno cfv cA cB cmv co
        cno cfv clt wbr cA cB cmv co cno cfv cA cB cmv co cA cB cF cA chli wbr
        cA chil wcel cF cA chli wbr cF cB chli wbr hlimunii.3 pm3.26i cA cF
        hlimuni.3 hlimuni.1 hlimveci ax-mp cF cB chli wbr cB chil wcel cF cA
        chli wbr cF cB chli wbr hlimunii.3 pm3.27i cB cF hlimuni.3 hlimuni.2
        hlimveci ax-mp hvsubcli normcli ltnri vz cv cn wcel vz cv cF cfv cA cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wa cA vz cv cF cfv
        cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB
        cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wa cA cB cmv co
        cno cfv cA cB cmv co cno cfv clt wbr vz cv cn wcel vz cv cF cfv cA cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr cA vz cv cF cfv cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz cv cn wcel vz cv
        cF cfv cA cmv co cno cfv cA vz cv cF cfv cmv co cno cfv cA cB cmv co
        cno cfv c2 cdiv co clt vz cv cn wcel vz cv cF cfv chil wcel vz cv cF
        cfv cA cmv co cno cfv cA vz cv cF cfv cmv co cno cfv wceq cn chil vz cv
        cF cF cA chli wbr cn chil cF wf cF cA chli wbr cF cB chli wbr
        hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1 hlimseqi ax-mp ffvelrni vz
        cv cF cfv chil wcel cA chil wcel vz cv cF cfv cA cmv co cno cfv cA vz
        cv cF cfv cmv co cno cfv wceq cF cA chli wbr cA chil wcel cF cA chli
        wbr cF cB chli wbr hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1
        hlimveci ax-mp vz cv cF cfv cA normsub mpan2 syl breq1d anbi1d vz cv cn
        wcel vz cv cF cfv chil wcel cA vz cv cF cfv cmv co cno cfv cA cB cmv co
        cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co
        cno cfv c2 cdiv co clt wbr wa cA cB cmv co cno cfv cA cB cmv co cno cfv
        clt wbr wi cn chil vz cv cF cF cA chli wbr cn chil cF wf cF cA chli wbr
        cF cB chli wbr hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1 hlimseqi
        ax-mp ffvelrni vz cv cF cfv chil wcel cA cB cmv co cno cfv cr wcel cA
        vz cv cF cfv cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz
        cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wa
        cA cB cmv co cno cfv cA cB cmv co cno cfv clt wbr wi cA cB cmv co cA cB
        cF cA chli wbr cA chil wcel cF cA chli wbr cF cB chli wbr hlimunii.3
        pm3.26i cA cF hlimuni.3 hlimuni.1 hlimveci ax-mp cF cB chli wbr cB chil
        wcel cF cA chli wbr cF cB chli wbr hlimunii.3 pm3.27i cB cF hlimuni.3
        hlimuni.2 hlimveci ax-mp hvsubcli normcli cA chil wcel cB chil wcel vz
        cv cF cfv chil wcel cA cB cmv co cno cfv cr wcel wa cA vz cv cF cfv cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr vz cv cF cfv cB cmv
        co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wa cA cB cmv co cno
        cfv cA cB cmv co cno cfv clt wbr wi cF cA chli wbr cA chil wcel cF cA
        chli wbr cF cB chli wbr hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1
        hlimveci ax-mp cF cB chli wbr cB chil wcel cF cA chli wbr cF cB chli
        wbr hlimunii.3 pm3.27i cB cF hlimuni.3 hlimuni.2 hlimveci ax-mp cA cB
        vz cv cF cfv cA cB cmv co cno cfv norm3lemt mpanl12 mpan2 syl sylbid
        mtoi syl5com vy cv vz cv cle wbr vz cv cF cfv cA cmv co cno cfv cA cB
        cmv co cno cfv c2 cdiv co clt wbr vw cv vz cv cle wbr vz cv cF cfv cB
        cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr prth syl5
        r19.20i sylbir r19.22si r19.22si vy cv vz cv cle wbr vz cv cF cfv cA
        cmv co cno cfv cA cB cmv co cno cfv c2 cdiv co clt wbr wi vz cn wral vw
        cv vz cv cle wbr vz cv cF cfv cB cmv co cno cfv cA cB cmv co cno cfv c2
        cdiv co clt wbr wi vz cn wral vy vw cn cn reeanv vy cv vz cv cle wbr vw
        cv vz cv cle wbr wa wn vz cn wral vw cn wrex vy cn wrex vy cv vz cv cle
        wbr vw cv vz cv cle wbr wa vz cn wrex vw cn wral wn vy cn wrex vy cv vz
        cv cle wbr vw cv vz cv cle wbr wa vz cn wrex vw cn wral vy cn wral wn
        vy cv vz cv cle wbr vw cv vz cv cle wbr wa wn vz cn wral vw cn wrex vy
        cv vz cv cle wbr vw cv vz cv cle wbr wa vz cn wrex vw cn wral wn vy cn
        vy cv vz cv cle wbr vw cv vz cv cle wbr wa wn vz cn wral vw cn wrex vy
        cv vz cv cle wbr vw cv vz cv cle wbr wa vz cn wrex wn vw cn wrex vy cv
        vz cv cle wbr vw cv vz cv cle wbr wa vz cn wrex vw cn wral wn vy cv vz
        cv cle wbr vw cv vz cv cle wbr wa wn vz cn wral vy cv vz cv cle wbr vw
        cv vz cv cle wbr wa vz cn wrex wn vw cn vy cv vz cv cle wbr vw cv vz cv
        cle wbr wa vz cn ralnex rexbii vy cv vz cv cle wbr vw cv vz cv cle wbr
        wa vz cn wrex vw cn rexnal bitri rexbii vy cv vz cv cle wbr vw cv vz cv
        cle wbr wa vz cn wrex vw cn wral vy cn rexnal bitri 3imtr3i 3syl mt2
        cc0 cA cB cmv co cno cfv clt wbr cA cB cmv co c0v cA cB cmv co chil
        wcel cA cB cmv co c0v wne cc0 cA cB cmv co cno cfv clt wbr wb cA cB cF
        cA chli wbr cA chil wcel cF cA chli wbr cF cB chli wbr hlimunii.3
        pm3.26i cA cF hlimuni.3 hlimuni.1 hlimveci ax-mp cF cB chli wbr cB chil
        wcel cF cA chli wbr cF cB chli wbr hlimunii.3 pm3.27i cB cF hlimuni.3
        hlimuni.2 hlimveci ax-mp hvsubcli cA cB cmv co normgt0 ax-mp necon1bbii
        mpbi cA cB cF cA chli wbr cA chil wcel cF cA chli wbr cF cB chli wbr
        hlimunii.3 pm3.26i cA cF hlimuni.3 hlimuni.1 hlimveci ax-mp cF cB chli
        wbr cB chil wcel cF cA chli wbr cF cB chli wbr hlimunii.3 pm3.27i cB cF
        hlimuni.3 hlimuni.2 hlimveci ax-mp hvsubeq0i mpbi $.
        $( [19-Aug-1999] $)
    $}

    $( A Hilbert space sequence converges to at most one limit. $)
    hlimunii $p |- ( ( F ~~>v A /\ F ~~>v B ) -> A = B ) $=
      cF cA chli wbr cF cB chli wbr wa cA cB wceq cF cA chli wbr cF cB chli wbr
      wa cA c0v cif cB wceq cF cA chli wbr cF cB chli wbr wa cA c0v cif cF cA
      chli wbr cF cB chli wbr wa cB c0v cif wceq cA cB c0v c0v cA cF cA chli
      wbr cF cB chli wbr wa cA c0v cif cB eqeq1 cB cF cA chli wbr cF cB chli
      wbr wa cB c0v cif cF cA chli wbr cF cB chli wbr wa cA c0v cif eqeq2 cF cA
      chli wbr cF cB chli wbr wa cA c0v cif cF cA chli wbr cF cB chli wbr wa cB
      c0v cif cF cA chli wbr cF cB chli wbr wa cF cn c0v csn cxp cif cF cA chli
      wbr cF cB chli wbr wa cA c0v hlimuni.1 c0v chil ax-hv0cl elisseti ifex cF
      cA chli wbr cF cB chli wbr wa cB c0v hlimuni.2 c0v chil ax-hv0cl elisseti
      ifex cF cA chli wbr cF cB chli wbr wa cF cn c0v csn cxp hlimuni.3 cn c0v
      csn nnex c0v snex xpex ifex cF cA chli wbr cF cB chli wbr wa cF cF cA
      chli wbr cF cB chli wbr wa cA c0v cif chli wbr cF cB chli wbr wa cF cF cA
      chli wbr cF cB chli wbr wa cA c0v cif chli wbr cF cF cA chli wbr cF cB
      chli wbr wa cB c0v cif chli wbr wa cF cA chli wbr cF cB chli wbr wa cF cn
      c0v csn cxp cif cF cA chli wbr cF cB chli wbr wa cA c0v cif chli wbr cF
      cA chli wbr cF cB chli wbr wa cF cn c0v csn cxp cif cF cA chli wbr cF cB
      chli wbr wa cB c0v cif chli wbr wa cA cB cF c0v c0v cn c0v csn cxp cn c0v
      csn cxp c0v chli wbr cn c0v csn cxp c0v chli wbr wa cn c0v csn cxp cF cA
      chli wbr cF cB chli wbr wa cA c0v cif chli wbr cn c0v csn cxp c0v chli
      wbr wa cn c0v csn cxp cF cA chli wbr cF cB chli wbr wa cA c0v cif chli
      wbr cn c0v csn cxp cF cA chli wbr cF cB chli wbr wa cB c0v cif chli wbr
      wa cA cF cA chli wbr cF cB chli wbr wa cA c0v cif wceq cF cA chli wbr cF
      cF cA chli wbr cF cB chli wbr wa cA c0v cif chli wbr cF cB chli wbr cA cF
      cA chli wbr cF cB chli wbr wa cA c0v cif cF chli breq2 anbi1d cB cF cA
      chli wbr cF cB chli wbr wa cB c0v cif wceq cF cB chli wbr cF cF cA chli
      wbr cF cB chli wbr wa cB c0v cif chli wbr cF cF cA chli wbr cF cB chli
      wbr wa cA c0v cif chli wbr cB cF cA chli wbr cF cB chli wbr wa cB c0v cif
      cF chli breq2 anbi2d cF cF cA chli wbr cF cB chli wbr wa cF cn c0v csn
      cxp cif wceq cF cF cA chli wbr cF cB chli wbr wa cA c0v cif chli wbr cF
      cA chli wbr cF cB chli wbr wa cF cn c0v csn cxp cif cF cA chli wbr cF cB
      chli wbr wa cA c0v cif chli wbr cF cF cA chli wbr cF cB chli wbr wa cB
      c0v cif chli wbr cF cA chli wbr cF cB chli wbr wa cF cn c0v csn cxp cif
      cF cA chli wbr cF cB chli wbr wa cB c0v cif chli wbr cF cF cA chli wbr cF
      cB chli wbr wa cF cn c0v csn cxp cif cF cA chli wbr cF cB chli wbr wa cA
      c0v cif chli breq1 cF cF cA chli wbr cF cB chli wbr wa cF cn c0v csn cxp
      cif cF cA chli wbr cF cB chli wbr wa cB c0v cif chli breq1 anbi12d c0v cF
      cA chli wbr cF cB chli wbr wa cA c0v cif wceq cn c0v csn cxp c0v chli wbr
      cn c0v csn cxp cF cA chli wbr cF cB chli wbr wa cA c0v cif chli wbr cn
      c0v csn cxp c0v chli wbr c0v cF cA chli wbr cF cB chli wbr wa cA c0v cif
      cn c0v csn cxp chli breq2 anbi1d c0v cF cA chli wbr cF cB chli wbr wa cB
      c0v cif wceq cn c0v csn cxp c0v chli wbr cn c0v csn cxp cF cA chli wbr cF
      cB chli wbr wa cB c0v cif chli wbr cn c0v csn cxp cF cA chli wbr cF cB
      chli wbr wa cA c0v cif chli wbr c0v cF cA chli wbr cF cB chli wbr wa cB
      c0v cif cn c0v csn cxp chli breq2 anbi2d cn c0v csn cxp cF cA chli wbr cF
      cB chli wbr wa cF cn c0v csn cxp cif wceq cn c0v csn cxp cF cA chli wbr
      cF cB chli wbr wa cA c0v cif chli wbr cF cA chli wbr cF cB chli wbr wa cF
      cn c0v csn cxp cif cF cA chli wbr cF cB chli wbr wa cA c0v cif chli wbr
      cn c0v csn cxp cF cA chli wbr cF cB chli wbr wa cB c0v cif chli wbr cF cA
      chli wbr cF cB chli wbr wa cF cn c0v csn cxp cif cF cA chli wbr cF cB
      chli wbr wa cB c0v cif chli wbr cn c0v csn cxp cF cA chli wbr cF cB chli
      wbr wa cF cn c0v csn cxp cif cF cA chli wbr cF cB chli wbr wa cA c0v cif
      chli breq1 cn c0v csn cxp cF cA chli wbr cF cB chli wbr wa cF cn c0v csn
      cxp cif cF cA chli wbr cF cB chli wbr wa cB c0v cif chli breq1 anbi12d cn
      c0v csn cxp c0v chli wbr cn c0v csn cxp c0v chli wbr hlim0 hlim0 pm3.2i
      elimhyp3v hlimuniii dedth2v $.
      $( [19-Aug-1999] $)
  $}

  ${
    $d x y F $.  $d x y H $.
    hlimreu.1 $e |- F e. _V $.
    $( The limit of a Hilbert space sequence is unique. $)
    hlimreui $p |- ( E. x e. H F ~~>v x <-> E! x e. H F ~~>v x ) $=
      cF vx cv chli wbr vx cH wrex cF vx cv chli wbr vx cH wreu cF vx cv chli
      wbr vx cH wrex cF vx cv chli wbr vx cH wrex cF vx cv chli wbr cF vy cv
      chli wbr wa vx cv vy cv wceq wi vy cH wral vx cH wral wa cF vx cv chli
      wbr vx cH wreu cF vx cv chli wbr vx cH wrex cF vx cv chli wbr cF vy cv
      chli wbr wa vx cv vy cv wceq wi vy cH wral vx cH wral cF vx cv chli wbr
      cF vy cv chli wbr wa vx cv vy cv wceq wi vx vy cH cF vx cv chli wbr cF vy
      cv chli wbr wa vx cv vy cv wceq wi vx cv cH wcel vy cv cH wcel wa vx cv
      vy cv cF vx visset vy visset hlimreu.1 hlimunii a1i rgen2a jctr cF vx cv
      chli wbr cF vy cv chli wbr vx vy cH vx cv vy cv cF chli breq2 reu4 sylibr
      cF vx cv chli wbr vx cH reurex impbii $.
      $( [19-Aug-1999] $)
  $}

  ${
    $d x y F $.  $d x y H $.
    hlimeu.1 $e |- F e. _V $.
    $( The limit of a Hilbert space sequence is unique. $)
    hlimeui $p |- ( E. x F ~~>v x <-> E! x F ~~>v x ) $=
      cF vx cv chli wbr vx wex cF vx cv chli wbr vx weu cF vx cv chli wbr vx
      wex cF vx cv chli wbr vx wex cF vx cv chli wbr cF vy cv chli wbr wa vx cv
      vy cv wceq wi vy wal vx wal wa cF vx cv chli wbr vx weu cF vx cv chli wbr
      vx wex cF vx cv chli wbr cF vy cv chli wbr wa vx cv vy cv wceq wi vy wal
      vx wal cF vx cv chli wbr cF vy cv chli wbr wa vx cv vy cv wceq wi vx vy
      vx cv vy cv cF vx visset vy visset hlimeu.1 hlimunii gen2 jctr cF vx cv
      chli wbr cF vy cv chli wbr vx vy vx cv vy cv cF chli breq2 eu4 sylibr cF
      vx cv chli wbr vx euex impbii $.
      $( [19-Aug-1999] $)
  $}

  ${
    $d x f h $.  $d h C $.
    cmh.1 $e |- C = { h | ( h e. SH /\ A. f e. Cauchy (
      f : NN --> h -> E. x e. h f ~~>v x ) ) } $.
    $( The hypothesis defines the set of complete subspaces of Hilbert
       space.  A complete subspace is one in which every Cauchy sequence of
       vectors in the subspace converges to a member of the subspace
       (Definition of complete subspace in [Beran] p. 96).  Any closed
       subspace of a Hilbert space is complete.  Part of Remark 3.12 of
       [Beran] p. 107. $)
    chsscmi $p |- CH C_ C $=
      vh cch cC vh cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv
      vh cv wcel wi vx wal vf wal wa vh cv csh wcel cn vh cv vf cv wf vf cv vx
      cv chli wbr vx vh cv wrex wi vf ccau wral wa vh cv cch wcel vh cv cC wcel
      cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi vx wal vf
      wal cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi vf ccau wral
      vh cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel
      wi vx wal vf wal vf cv ccau wcel cn vh cv vf cv wf vf cv vx cv chli wbr
      vx vh cv wrex wi wi vf wal cn vh cv vf cv wf vf cv vx cv chli wbr vx vh
      cv wrex wi vf ccau wral cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv
      vh cv wcel wi vx wal vf cv ccau wcel cn vh cv vf cv wf vf cv vx cv chli
      wbr vx vh cv wrex wi wi vf cn vh cv vf cv wf vf cv vx cv chli wbr wa vx
      cv vh cv wcel wi vx wal cn vh cv vf cv wf vf cv ccau wcel vf cv vx cv
      chli wbr vx vh cv wrex cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh
      cv wcel wi vx wal cn vh cv vf cv wf vf cv ccau wcel vf cv vx cv chli wbr
      vx vh cv wrex wi cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv
      wcel wi vx wal cn vh cv vf cv wf wa vf cv vx cv chli wbr vx chil wrex vf
      cv vx cv chli wbr vx vh cv wrex vf cv ccau wcel cn vh cv vf cv wf vf cv
      vx cv chli wbr wa vx cv vh cv wcel wi vx wal cn vh cv vf cv wf wa vx cv
      chil wcel vf cv vx cv chli wbr wa vx wex vx cv vh cv wcel vf cv vx cv
      chli wbr wa vx wex vf cv vx cv chli wbr vx chil wrex vf cv vx cv chli wbr
      vx vh cv wrex cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel
      wi vx wal cn vh cv vf cv wf wa vx cv chil wcel vf cv vx cv chli wbr wa vx
      cv vh cv wcel vf cv vx cv chli wbr wa wi vx wal vx cv chil wcel vf cv vx
      cv chli wbr wa vx wex vx cv vh cv wcel vf cv vx cv chli wbr wa vx wex wi
      cn vh cv vf cv wf cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv
      wcel wi vx wal vx cv chil wcel vf cv vx cv chli wbr wa vx cv vh cv wcel
      vf cv vx cv chli wbr wa wi vx wal cn vh cv vf cv wf cn vh cv vf cv wf vf
      cv vx cv chli wbr wa vx cv vh cv wcel wi vx cv chil wcel vf cv vx cv chli
      wbr wa vx cv vh cv wcel vf cv vx cv chli wbr wa wi vx cn vh cv vf cv wf
      vf cv vx cv chli wbr wa vx cv vh cv wcel wi cn vh cv vf cv wf vx cv chil
      wcel vf cv vx cv chli wbr wa vx cv vh cv wcel vf cv vx cv chli wbr wa wi
      cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi cn vh cv vf
      cv wf vf cv vx cv chli wbr vx cv vh cv wcel wi wi cn vh cv vf cv wf vx cv
      chil wcel vf cv vx cv chli wbr wa vx cv vh cv wcel vf cv vx cv chli wbr
      wa wi wi cn vh cv vf cv wf vf cv vx cv chli wbr vx cv vh cv wcel impexp
      vf cv vx cv chli wbr vx cv vh cv wcel wi vx cv chil wcel vf cv vx cv chli
      wbr wa vx cv vh cv wcel vf cv vx cv chli wbr wa wi cn vh cv vf cv wf vf
      cv vx cv chli wbr vx cv vh cv wcel wi vf cv vx cv chli wbr vx cv vh cv
      wcel vf cv vx cv chli wbr wa vx cv chil wcel vf cv vx cv chli wbr vx cv
      vh cv wcel ancr adantld imim2i sylbi com12 19.20dv impcom vx cv chil wcel
      vf cv vx cv chli wbr wa vx cv vh cv wcel vf cv vx cv chli wbr wa vx 19.22
      syl vf cv vx cv chli wbr vx chil df-rex vf cv vx cv chli wbr vx vh cv
      df-rex 3imtr4g vx vf cv ax-hcompl syl5 ex com23 19.20i cn vh cv vf cv wf
      vf cv vx cv chli wbr vx vh cv wrex wi vf ccau df-ral sylibr anim2i vx vf
      vh cv closedsub vh cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx
      vh cv wrex wi vf ccau wral wa vh cC cmh.1 abeq2i 3imtr4i ssriv $.
      $( [24-Dec-2001] $)

    $( The hypothesis defines the set of complete subspaces of Hilbert
       space (see ~ chsscmi ).  A Hilbert subspace is closed iff it is
       complete.  Remark 3.12(C) of [Beran] p. 107. $)
    chcmhi $p |- CH = C $=
      cch cC vx cC vf vh cmh.1 chsscmi vh cC cch vh cv csh wcel cn vh cv vf cv
      wf vf cv vx cv chli wbr vx vh cv wrex wi vf ccau wral wa vh cv csh wcel
      cn vh cv vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi vx wal vf
      wal wa vh cv cC wcel vh cv cch wcel cn vh cv vf cv wf vf cv vx cv chli
      wbr vx vh cv wrex wi vf ccau wral cn vh cv vf cv wf vf cv vx cv chli wbr
      wa vx cv vh cv wcel wi vx wal vf wal vh cv csh wcel cn vh cv vf cv wf vf
      cv vx cv chli wbr vx vh cv wrex wi vf ccau wral vf cv ccau wcel cn vh cv
      vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi wi vf wal cn vh cv vf cv
      wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi vx wal vf wal cn vh cv vf
      cv wf vf cv vx cv chli wbr vx vh cv wrex wi vf ccau df-ral vf cv ccau
      wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi wi cn vh cv
      vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi vx wal vf vf cv ccau
      wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi wi cn vh cv
      vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi vx vf cv ccau wcel
      cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi vx vf cv ccau
      wcel vx ax-17 cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex vx cn
      vh cv vf cv wf vx ax-17 vf cv vx cv chli wbr vx vh cv hbre1 hbim hbim cn
      vh cv vf cv wf vf cv ccau wcel vf cv vx cv chli wbr vx vh cv wrex wi wi
      cn vh cv vf cv wf vf cv vx cv chli wbr vx cv vh cv wcel wi wi vf cv ccau
      wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi wi cn vh cv
      vf cv wf vf cv vx cv chli wbr wa vx cv vh cv wcel wi vf cv ccau wcel vf
      cv vx cv chli wbr vx vh cv wrex wi vf cv vx cv chli wbr vx cv vh cv wcel
      wi cn vh cv vf cv wf vf cv ccau wcel vf cv vx cv chli wbr vx vh cv wrex
      wi vf cv vx cv chli wbr vf cv vx cv chli wbr vx vh cv wrex vx cv vh cv
      wcel vf cv vx cv chli wbr vf cv ccau wcel vf cv vx cv chli wbr vx vh cv
      wrex vx cv vf cv vx visset vf visset hlimcaui imim1i vf cv vx cv chli wbr
      vx vh cv wrex vf cv vx cv chli wbr vx cv vh cv wcel vf cv vx cv chli wbr
      vf cv vx cv chli wbr vx weu vf cv vx cv chli wbr vx vh cv wrex vf cv vx
      cv chli wbr vx cv vh cv wcel wi wi vf cv vx cv chli wbr vf cv vx cv chli
      wbr vx wex vf cv vx cv chli wbr vx weu vf cv vx cv chli wbr vx 19.8a vx
      vf cv vf visset hlimeui sylib vf cv vx cv chli wbr vx weu vf cv vx cv
      chli wbr vx cv vh cv wcel wa vx wex vf cv vx cv chli wbr vx cv vh cv wcel
      wi vf cv vx cv chli wbr vx vh cv wrex vf cv vx cv chli wbr vx weu vf cv
      vx cv chli wbr vx cv vh cv wcel wa vx wex vf cv vx cv chli wbr vx cv vh
      cv wcel wi vf cv vx cv chli wbr vx cv vh cv wcel vx eupick ex vf cv vx cv
      chli wbr vx vh cv wrex vx cv vh cv wcel vf cv vx cv chli wbr wa vx wex vf
      cv vx cv chli wbr vx cv vh cv wcel wa vx wex vf cv vx cv chli wbr vx vh
      cv df-rex vx cv vh cv wcel vf cv vx cv chli wbr vx exancom bitri syl5ib
      syl pm2.43a sylcom imim2i vf cv ccau wcel cn vh cv vf cv wf vf cv vx cv
      chli wbr vx vh cv wrex bi2.04 cn vh cv vf cv wf vf cv vx cv chli wbr vx
      cv vh cv wcel impexp 3imtr4i 19.21ai 19.20i sylbi anim2i vh cv csh wcel
      cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi vf ccau wral wa
      vh cC cmh.1 abeq2i vx vf vh cv closedsub 3imtr4i ssriv eqssi $.
      $( [24-Dec-2001] $)
  $}

  ${
    $d x f h H $.  $d x f h g $.
    $( A Hilbert subspace is closed iff it is complete.  Remark 3.12(C) of
      [Beran] p. 107. $)
    ch2 $p |- ( H e. CH <-> ( H e. SH /\ A. f e. Cauchy (
      f : NN --> H -> E. x e. H f ~~>v x ) ) ) $=
      cH cch wcel cH cvv wcel cH csh wcel cn cH vf cv wf vf cv vx cv chli wbr
      vx cH wrex wi vf ccau wral wa cH cch elisset cH csh wcel cH cvv wcel cn
      cH vf cv wf vf cv vx cv chli wbr vx cH wrex wi vf ccau wral cH csh
      elisset adantr vh cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx
      vh cv wrex wi vf ccau wral wa cH csh wcel cn cH vf cv wf vf cv vx cv chli
      wbr vx cH wrex wi vf ccau wral wa vh cH cch cvv vh cv cH wceq vh cv csh
      wcel cH csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi
      vf ccau wral cn cH vf cv wf vf cv vx cv chli wbr vx cH wrex wi vf ccau
      wral vh cv cH csh eleq1 vh cv cH wceq cn vh cv vf cv wf vf cv vx cv chli
      wbr vx vh cv wrex wi cn cH vf cv wf vf cv vx cv chli wbr vx cH wrex wi vf
      ccau vh cv cH wceq cn vh cv vf cv wf cn cH vf cv wf vf cv vx cv chli wbr
      vx vh cv wrex vf cv vx cv chli wbr vx cH wrex vh cv cH cn vf cv feq3 vf
      cv vx cv chli wbr vx vh cv cH rexeq1 imbi12d ralbidv anbi12d vx vh cv csh
      wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv wrex wi vf ccau wral
      wa vh cab vf vg vh cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx
      vh cv wrex wi vf ccau wral wa vg cv csh wcel cn vg cv vf cv wf vf cv vx
      cv chli wbr vx vg cv wrex wi vf ccau wral wa vh vg vh cv vg cv wceq vh cv
      csh wcel vg cv csh wcel cn vh cv vf cv wf vf cv vx cv chli wbr vx vh cv
      wrex wi vf ccau wral cn vg cv vf cv wf vf cv vx cv chli wbr vx vg cv wrex
      wi vf ccau wral vh cv vg cv csh eleq1 vh cv vg cv wceq cn vh cv vf cv wf
      vf cv vx cv chli wbr vx vh cv wrex wi cn vg cv vf cv wf vf cv vx cv chli
      wbr vx vg cv wrex wi vf ccau vh cv vg cv wceq cn vh cv vf cv wf cn vg cv
      vf cv wf vf cv vx cv chli wbr vx vh cv wrex vf cv vx cv chli wbr vx vg cv
      wrex vh cv vg cv cn vf cv feq3 vf cv vx cv chli wbr vx vh cv vg cv rexeq1
      imbi12d ralbidv anbi12d cbvabv chcmhi elab2g pm5.21nii $.
      $( [24-Dec-2001] $)
  $}

  ${
    $d x f H $.  $d x f F $.
    $( Completeness of a closed subspace of Hilbert space. $)
    chcompl $p |- ( ( H e. CH /\ F e. Cauchy /\ F : NN --> H ) ->
                      E. x e. H F ~~>v x ) $=
      cH cch wcel cF ccau wcel cn cH cF wf cF vx cv chli wbr vx cH wrex cH cch
      wcel cn cH vf cv wf vf cv vx cv chli wbr vx cH wrex wi vf ccau wral cF
      ccau wcel cn cH cF wf cF vx cv chli wbr vx cH wrex wi wi cH cch wcel cH
      csh wcel cn cH vf cv wf vf cv vx cv chli wbr vx cH wrex wi vf ccau wral
      vx vf cH ch2 pm3.27bi cn cH vf cv wf vf cv vx cv chli wbr vx cH wrex wi
      cn cH cF wf cF vx cv chli wbr vx cH wrex wi vf cF ccau vf cv cF wceq cn
      cH vf cv wf cn cH cF wf vf cv vx cv chli wbr vx cH wrex cF vx cv chli wbr
      vx cH wrex cn cH vf cv cF feq1 vf cv cF wceq vf cv vx cv chli wbr cF vx
      cv chli wbr vx cH vf cv cF vx cv chli breq1 rexbidv imbi12d rcla4cv syl
      3imp $.
      $( [13-Apr-2008] $) $( [4-Oct-1999] $)
  $}

  ${
    $d x y f $.
    $( The unit Hilbert lattice element (which is all of Hilbert space) belongs
       to the Hilbert lattice.  Part of Proposition 1 of [Kalmbach] p. 65. $)
    helch $p |- ~H e. CH $=
      chil cch wcel chil csh wcel cn chil vf cv wf vf cv vx cv chli wbr wa vx
      cv chil wcel wi vx wal vf wal vx vf chil closedsub chil csh wcel chil
      chil wss c0v chil wcel wa vx cv vy cv cva co chil wcel vy chil wral vx
      chil wral vx cv vy cv csm co chil wcel vy chil wral vx cc wral wa vx vy
      chil sh chil chil wss c0v chil wcel chil ssid ax-hv0cl pm3.2i vx cv vy cv
      cva co chil wcel vy chil wral vx chil wral vx cv vy cv csm co chil wcel
      vy chil wral vx cc wral vx cv vy cv cva co chil wcel vx vy chil vx cv vy
      cv hvaddcl rgen2a vx cv vy cv csm co chil wcel vx vy cc chil vx cv vy cv
      hvmulcl rgen2 pm3.2i mpbir2an cn chil vf cv wf vf cv vx cv chli wbr wa vx
      cv chil wcel wi vf vx vf cv vx cv chli wbr vx cv chil wcel cn chil vf cv
      wf vx cv vf cv vf visset vx visset hlimveci adantl gen2 mpbir2an $.
      $( [6-Sep-1999] $)
  $}

  $( Hilbert space is a subspace of Hilbert space. $)
  helsh $p |- ~H e. SH $=
    chil helch chshii $.
    $( [3-Jun-2004] $) $( [2-Jun-2004] $)

  $( Subspaces are subsets of Hilbert space. $)
  shsspwh $p |- SH C_ ~P ~H $=
    csh csh cuni cpw chil cpw csh pwuni chil csh cuni wceq chil cpw csh cuni
    cpw wceq chil csh wcel vx cv chil wss vx csh wral chil csh cuni wceq helsh
    vx cv chil wss vx csh vx cv shss rgen vx chil csh ssunieq mp2an chil csh
    cuni pweq ax-mp sseqtr4i $.
    $( [26-Nov-2004] $) $( [24-Nov-2004] $)

  $( Closed subspaces are subsets of Hilbert space. $)
  chsspwh $p |- CH C_ ~P ~H $=
    cch csh chil cpw chsssh shsspwh sstri $.
    $( [26-Nov-2004] $) $( [24-Nov-2004] $)

  ${
    $d x y f $.
    $( The zero subspace belongs to the set of closed subspaces of Hilbert
       space. $)
    hsn0elch $p |- { 0h } e. CH $=
      c0v csn cch wcel c0v csn csh wcel cn c0v csn vf cv wf vf cv vx cv chli
      wbr wa vx cv c0v csn wcel wi vx wal vf wal vx vf c0v csn closedsub c0v
      csn csh wcel c0v csn chil wss c0v c0v csn wcel wa vx cv vy cv cva co c0v
      csn wcel vy c0v csn wral vx c0v csn wral vx cv vy cv csm co c0v csn wcel
      vy c0v csn wral vx cc wral wa vx vy c0v csn sh c0v csn chil wss c0v c0v
      csn wcel c0v chil wcel c0v csn chil wss ax-hv0cl c0v chil snssi ax-mp c0v
      c0v chil ax-hv0cl elisseti snid pm3.2i vx cv vy cv cva co c0v csn wcel vy
      c0v csn wral vx c0v csn wral vx cv vy cv csm co c0v csn wcel vy c0v csn
      wral vx cc wral vx cv vy cv cva co c0v csn wcel vx vy c0v csn vx cv c0v
      wceq vy cv c0v wceq vx cv vy cv cva co c0v csn wcel vx cv c0v csn wcel vy
      cv c0v csn wcel vx cv c0v wceq vy cv c0v wceq wa vx cv vy cv cva co c0v
      wceq vx cv vy cv cva co c0v csn wcel vx cv c0v wceq vy cv c0v wceq wa vx
      cv vy cv cva co c0v c0v cva co c0v vx cv c0v vy cv c0v cva opreq12 c0v
      ax-hv0cl hvaddid2i syl6eq vx cv vy cv cva co c0v vx cv vy cv cva oprex
      elsnc sylibr vx c0v elsn vy c0v elsn syl2anb rgen2a vx cv vy cv csm co
      c0v csn wcel vx vy cc c0v csn vx cv cc wcel vy cv c0v wceq vx cv vy cv
      csm co c0v csn wcel vy cv c0v csn wcel vx cv cc wcel vy cv c0v wceq wa vx
      cv vy cv csm co c0v wceq vx cv vy cv csm co c0v csn wcel vy cv c0v wceq
      vx cv cc wcel vx cv vy cv csm co vx cv c0v csm co c0v vy cv c0v vx cv csm
      opreq2 vx cv hvmul0 sylan9eqr vx cv vy cv csm co c0v vx cv vy cv csm
      oprex elsnc sylibr vy c0v elsn sylan2b rgen2 pm3.2i mpbir2an cn c0v csn
      vf cv wf vf cv vx cv chli wbr wa vx cv c0v csn wcel wi vf vx cn c0v csn
      vf cv wf vf cv vx cv chli wbr wa c0v c0v csn wcel vx cv c0v csn wcel c0v
      c0v chil ax-hv0cl elisseti snid vf cv c0v chli wbr vf cv vx cv chli wbr
      c0v c0v csn wcel vx cv c0v csn wcel wb cn c0v csn vf cv wf vf cv c0v chli
      wbr vf cv vx cv chli wbr wa c0v vx cv c0v csn c0v vx cv vf cv c0v chil
      ax-hv0cl elisseti vx visset vf visset hlimunii eleq1d cn c0v csn vf cv wf
      vf cv cn c0v csn cxp wceq vf cv c0v chli wbr cn c0v vf cv c0v chil
      ax-hv0cl elisseti fconst2 vf cv cn c0v csn cxp wceq vf cv c0v chli wbr cn
      c0v csn cxp c0v chli wbr hlim0 vf cv cn c0v csn cxp c0v chli breq1 mpbiri
      sylbi sylan mpbii gen2 mpbir2an $.
      $( [14-Oct-1999] $)
  $}

  $( From any nonzero Hilbert space vector, construct a vector whose norm is
     1. $)
  norm1 $p |- ( ( A e. ~H /\ A =/= 0h ) ->
               ( normh ` ( ( 1 / ( normh ` A ) ) .h A ) ) = 1 ) $=
    cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co cno cfv c1 cA
    cno cfv cdiv co cabs cfv cA cno cfv cmul co c1 cA cno cfv cdiv co cA cno
    cfv cmul co c1 c1 cA cno cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv
    cdiv co cA csm co cno cfv c1 cA cno cfv cdiv co cabs cfv cA cno cfv cmul co
    wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA norm-iii cA chil
    wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0
    wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv
    rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil
    wcel cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc recnd cA chil
    wcel cA c0v wne pm3.26 sylanc cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv
    co cabs cfv c1 cA cno cfv cdiv co cA cno cfv cmul c1 cA cno cfv cdiv co cr
    wcel cc0 c1 cA cno cfv cdiv co cle wbr c1 cA cno cfv cdiv co cabs cfv c1 cA
    cno cfv cdiv co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co absid
    cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil
    wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA
    c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA
    normne0 biimpar sylanc cA cno cfv cr wcel cc0 cA cno cfv clt wbr cc0 c1 cA
    cno cfv cdiv co cle wbr cA chil wcel cA c0v wne wa c1 cr wcel cc0 c1 cle
    wbr cA cno cfv cr wcel cc0 cA cno cfv clt wbr wa cc0 c1 cA cno cfv cdiv co
    cle wbr 1re cc0 c1 0re 1re lt01 ltleii c1 cA cno cfv divge0 mpanl12 cA chil
    wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA c0v wne
    cc0 cA cno cfv clt wbr cA normgt0 biimpa sylanc sylanc opreq1d cA chil wcel
    cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cmul co cA cno cfv c1 cA cno
    cfv cdiv co cmul co c1 c1 cA cno cfv cdiv co cc wcel cA cno cfv cc wcel c1
    cA cno cfv cdiv co cA cno cfv cmul co cA cno cfv c1 cA cno cfv cdiv co cmul
    co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv mulcom
    cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cr wcel cA cno
    cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno
    cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA
    chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc recnd cA
    chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno cfv cA normcl
    recnd adantr sylanc cA cno cfv cc wcel cA cno cfv cc0 wne cA cno cfv c1 cA
    cno cfv cdiv co cmul co c1 wceq cA chil wcel cA c0v wne wa cA cno cfv recid
    cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno cfv cA
    normcl recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
    biimpar sylanc eqtrd 3eqtrd $.
    $( [8-Feb-2006] $) $( [7-Feb-2006] $)

  ${
    $d x z H $.  $d y z H $.
    norm1ex.1 $e |- H e. SH $.
    $( A normalized vector exists in a subspace iff the subspace has a non-zero
       vector. $)
    norm1exi $p |- ( E. x e. H x =/= 0h <-> E. y e. H ( normh ` y ) = 1 ) $=
      vx cv c0v wne vx cH wrex vz cv c0v wne vz cH wrex vy cv cno cfv c1 wceq
      vy cH wrex vx cv c0v wne vz cv c0v wne vx vz cH vx cv vz cv c0v neeq1
      cbvrexv vz cv c0v wne vz cH wrex vy cv cno cfv c1 wceq vy cH wrex vz cv
      c0v wne vy cv cno cfv c1 wceq vy cH wrex vz cH c1 vz cv cno cfv cdiv co
      vz cv csm co cH wcel c1 vz cv cno cfv cdiv co vz cv csm co cno cfv c1
      wceq vy cv cno cfv c1 wceq vy cH wrex vz cv cH wcel vz cv c0v wne wa vy
      cv cno cfv c1 wceq c1 vz cv cno cfv cdiv co vz cv csm co cno cfv c1 wceq
      vy c1 vz cv cno cfv cdiv co vz cv csm co cH vy cv c1 vz cv cno cfv cdiv
      co vz cv csm co wceq vy cv cno cfv c1 vz cv cno cfv cdiv co vz cv csm co
      cno cfv c1 vy cv c1 vz cv cno cfv cdiv co vz cv csm co cno fveq2 eqeq1d
      rcla4ev c1 vz cv cno cfv cdiv co cc wcel vz cv cH wcel c1 vz cv cno cfv
      cdiv co vz cv csm co cH wcel vz cv cH wcel vz cv c0v wne wa cH csh wcel
      c1 vz cv cno cfv cdiv co cc wcel vz cv cH wcel wa c1 vz cv cno cfv cdiv
      co vz cv csm co cH wcel wi norm1ex.1 c1 vz cv cno cfv cdiv co vz cv cH
      shmulclOLD ax-mp vz cv cH wcel vz cv c0v wne wa c1 vz cv cno cfv cdiv co
      vz cv cno cfv cr wcel vz cv cno cfv cc0 wne c1 vz cv cno cfv cdiv co cr
      wcel vz cv cH wcel vz cv c0v wne wa vz cv cno cfv rereccl vz cv cH wcel
      vz cv cno cfv cr wcel vz cv c0v wne vz cv cH wcel vz cv chil wcel vz cv
      cno cfv cr wcel vz cv cH norm1ex.1 sheli vz cv normcl syl adantr vz cv cH
      wcel vz cv cno cfv cc0 wne vz cv c0v wne vz cv cH wcel vz cv chil wcel vz
      cv cno cfv cc0 wne vz cv c0v wne wb vz cv cH norm1ex.1 sheli vz cv
      normne0 syl biimpar sylanc recnd vz cv cH wcel vz cv c0v wne pm3.26
      sylanc vz cv chil wcel vz cv c0v wne c1 vz cv cno cfv cdiv co vz cv csm
      co cno cfv c1 wceq vz cv cH wcel vz cv norm1 vz cv cH norm1ex.1 sheli
      sylan sylanc r19.23aiva vy cv cno cfv c1 wceq vy cH wrex vy cv c0v wne vy
      cH wrex vz cv c0v wne vz cH wrex vy cv cno cfv c1 wceq vy cv c0v wne vy
      cH vy cv cH wcel vy cv cno cfv cc0 wceq wn vy cv c0v wne vy cv cno cfv c1
      wceq vy cv cH wcel vy cv cno cfv cc0 wceq vy cv c0v vy cv cH wcel vy cv
      chil wcel vy cv cno cfv cc0 wceq vy cv c0v wceq wb vy cv cH norm1ex.1
      sheli vy cv norm-i syl necon3bbid vy cv cno cfv c1 wceq vy cv cno cfv cc0
      wceq c1 cc0 wceq c1 cc0 wne c1 cc0 wceq wn ax1ne0 c1 cc0 df-ne mpbi vy cv
      cno cfv c1 cc0 eqeq1 mtbiri syl5bi r19.22i vy cv c0v wne vz cv c0v wne vy
      vz cH vy cv vz cv c0v neeq1 cbvrexv sylib impbii bitri $.
      $( [9-Apr-2006] $) $( [9-Apr-2006] $)
  $}

  ${
    $d x z $.  $d y z $.
    $( A normalized vector can exist only iff the Hilbert space has a non-zero
       vector. $)
    norm1hex $p |- ( E. x e. ~H x =/= 0h <-> E. y e. ~H ( normh ` y ) = 1 ) $=
      vx vy chil helsh norm1exi $.
      $( [2-Feb-2006] $) $( [21-Jan-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Orthocomplements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.
    $( Define orthogonal complement of a subset (usually a subspace) of
       Hilbert space.  The orthogonal complement is the set of all vectors
       orthogonal to all vectors in the subset.  See ~ ocval and ~ chocvali
       for its value.  Textbooks usually denote this unary operation with the
       symbol ` _|_ ` as a small superscript, although Mittelstaedt uses
       the symbol as a prefix operation.  Here we define a function (prefix
       operation) ` _|_ ` rather than introducing a new syntactical form.
       This lets us take advantage of the theorems about functions that we
       already have proved under set theory.  Definition of [Mittelstaedt]
       p. 9. $)
    df-oc $a |- _|_ = { <. x , y >. | ( x C_ ~H /\ y =
                         { z e. ~H | A. w e. x ( z .ih w ) = 0 } ) } $.
  $}

  $( Define the zero for closed subspaces of Hilbert space.  See ~ h0elch
     for closure law. $)
  df-ch0 $a |- 0H = { 0h } $.

  $( Membership in zero for closed subspaces of Hilbert space. $)
  elch0 $p |- ( A e. 0H <-> A = 0h ) $=
    cA c0h wcel cA c0v csn wcel cA c0v wceq c0h c0v csn cA df-ch0 eleq2i cA c0v
    c0v chil ax-hv0cl elisseti elsnc2 bitri $.
    $( [6-Apr-2001] $)

  $( The zero subspace is a closed subspace.  Part of Proposition 1 of
     [Kalmbach] p. 65. $)
  h0elch $p |- 0H e. CH $=
    c0h c0v csn cch df-ch0 hsn0elch eqeltri $.
    $( [30-May-1999] $)

  $( The zero subspace is a subspace of Hilbert space. $)
  h0elsh $p |- 0H e. SH $=
    c0h h0elch chshii $.
    $( [3-Jun-2004] $) $( [2-Jun-2004] $)

  ${
    hhss.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    $( The vector addition operation on a subspace. $)
    hhssva $p |- ( +h |` ( H X. H ) ) = ( +v ` W ) $=
      cW cpv cfv cW c1st cfv c1st cfv cva cH cH cxp cres csm cc cH cxp cres cop
      c1st cfv cva cH cH cxp cres cW cW cpv cfv cW cpv cfv eqid vafval cW c1st
      cfv cva cH cH cxp cres csm cc cH cxp cres cop c1st cW c1st cfv cva cH cH
      cxp cres csm cc cH cxp cres cop cno cH cres cop c1st cfv cva cH cH cxp
      cres csm cc cH cxp cres cop cW cva cH cH cxp cres csm cc cH cxp cres cop
      cno cH cres cop c1st hhss.1 fveq2i cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cva cH cH cxp cres csm cc cH cxp cres opex op1st eqtri
      fveq2i cva cH cH cxp cres csm cc cH cxp cres cva cabl wcel cva cH cH cxp
      cres cvv wcel hilabl cva cH cH cxp cabl resexg ax-mp op1st 3eqtrri $.
      $( [22-Apr-2008] $) $( [8-Apr-2008] $)

    $( The scalar multiplication operation on a subspace. $)
    hhsssm $p |- ( .h |` ( CC X. H ) ) = ( .s ` W ) $=
      cW cns cfv cW c1st cfv c2nd cfv cva cH cH cxp cres csm cc cH cxp cres cop
      c2nd cfv csm cc cH cxp cres cW cns cfv cW cW cns cfv eqid smfval cW c1st
      cfv cva cH cH cxp cres csm cc cH cxp cres cop c2nd cW c1st cfv cva cH cH
      cxp cres csm cc cH cxp cres cop cno cH cres cop c1st cfv cva cH cH cxp
      cres csm cc cH cxp cres cop cW cva cH cH cxp cres csm cc cH cxp cres cop
      cno cH cres cop c1st hhss.1 fveq2i cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cva cH cH cxp cres csm cc cH cxp cres opex op1st eqtri
      fveq2i cva cH cH cxp cres csm cc cH cxp cres cva cabl wcel cva cH cH cxp
      cres cvv wcel hilabl cva cH cH cxp cabl resexg ax-mp csm cvv wcel csm cc
      cH cxp cres cvv wcel hvmulex csm cc cH cxp cvv resexg ax-mp op2nd 3eqtrri
      $.
      $( [29-Apr-2008] $) $( [8-Apr-2008] $)

    $( The norm operation on a subspace. $)
    hhssnm $p |- ( normh |` H ) = ( norm ` W ) $=
      cW cnm cfv cW c2nd cfv cva cH cH cxp cres csm cc cH cxp cres cop cno cH
      cres cop c2nd cfv cno cH cres cW cW cnm cfv cW cnm cfv eqid nmfval cW cva
      cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop c2nd hhss.1 fveq2i
      cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cva cH cH cxp cres
      csm cc cH cxp cres opex cno cvv wcel cno cH cres cvv wcel chil cr cno wf
      chil cvv wcel cno cvv wcel normf ax-hilex chil cr cvv cno fex mp2an cno
      cH cvv resexg ax-mp op2nd 3eqtrri $.
      $( [30-Apr-2008] $) $( [8-Apr-2008] $)
  $}

  ${
    $d x y H $.
    hhssabl.1 $e |- H e. SH $.
    $( Abelian group property of subspace addition. $)
    hhssabli $p |- ( +h |` ( H X. H ) ) e. Abel $=
      vx vy cva cH cH cxp cres cH cva cgr wcel cva cH cH cxp cres cgr wcel cva
      cH cH cxp cres cva wss cva cH cH cxp cres cva csubg cfv wcel cva cgr wcel
      cva cH cH cxp cres cgr wcel cva cH cH cxp cres cva wss w3a vx vy c0v cva
      cva cH cH cxp cres csm c2nd c1 cneg csn cvv cxp cres ccnv ccom chil cH
      cva cabl wcel cva cgr wcel hilabl cva ablgrp ax-mp cva csm cop cno cop
      cva chil cva csm cop cno cop cva csm cop cno cop eqid hhba cva csm cop
      cno cop cva csm cop cno cop eqid hhva bafval cva csm cop cno cop cva c0v
      cva csm cop cno cop cva csm cop cno cop eqid hhva cva csm cop cno cop cva
      csm cop cno cop eqid hh0v 0vfval cva csm cop cno cop cnv wcel csm c2nd c1
      cneg csn cvv cxp cres ccnv ccom cva cgn cfv wceq cva csm cop cno cop cva
      csm cop cno cop eqid hhnv csm cva csm cop cno cop cva csm c2nd c1 cneg
      csn cvv cxp cres ccnv ccom cva csm cop cno cop cva csm cop cno cop eqid
      hhva cva csm cop cno cop cva csm cop cno cop eqid hhsm csm c2nd c1 cneg
      csn cvv cxp cres ccnv ccom eqid invfval ax-mp cH hhssabl.1 shssii cva cH
      cH cxp cres eqid cH csh wcel vx cv cH wcel vy cv cH wcel vx cv vy cv cva
      co cH wcel hhssabl.1 vx cv vy cv cH shaddcl mp3an1 cH csh wcel c0v cH
      wcel hhssabl.1 cH sh0 ax-mp vx cv cH wcel vx cv csm c2nd c1 cneg csn cvv
      cxp cres ccnv ccom cfv c1 cneg vx cv csm co cH csm cc chil cxp wfn c1
      cneg cc wcel vx cv cH wcel vx cv csm c2nd c1 cneg csn cvv cxp cres ccnv
      ccom cfv c1 cneg vx cv csm co wceq cc chil cxp chil csm wf csm cc chil
      cxp wfn ax-hfvmul cc chil cxp chil csm ffn ax-mp c1 ax1cn negcli cc chil
      c1 cneg vx cv cH csm csm c2nd c1 cneg csn cvv cxp cres ccnv ccom csm c2nd
      c1 cneg csn cvv cxp cres ccnv ccom eqid curry1val mp3an12 cH csh wcel c1
      cneg cc wcel vx cv cH wcel c1 cneg vx cv csm co cH wcel hhssabl.1 c1
      ax1cn negcli c1 cneg vx cv cH shmulcl mp3an12 eqeltrd issubgi cva cva cH
      cH cxp cres issubg mpbi 3simp2i cH cH cxp cva cdm wss cva cH cH cxp cres
      cdm cH cH cxp wceq cH cH cxp chil chil cxp cva cdm cH chil wss cH chil
      wss cH cH cxp chil chil cxp wss cH hhssabl.1 shssii cH hhssabl.1 shssii
      cH chil cH chil ssxp mp2an chil chil cxp chil cva ax-hfvadd fdmi sseqtr4i
      cH cH cxp cva ssdmres mpbi vx cv cH wcel vy cv cH wcel wa vx cv vy cv cva
      co vy cv vx cv cva co vx cv vy cv cva cH cH cxp cres co vy cv vx cv cva
      cH cH cxp cres co vx cv chil wcel vy cv chil wcel vx cv vy cv cva co vy
      cv vx cv cva co wceq vx cv cH wcel vy cv cH wcel vx cv vy cv ax-hvcom vx
      cv cH hhssabl.1 sheli vy cv cH hhssabl.1 sheli syl2an vx cv vy cv cH cH
      cva oprvres vy cv cH wcel vx cv cH wcel vy cv vx cv cva cH cH cxp cres co
      vy cv vx cv cva co wceq vy cv vx cv cH cH cva oprvres ancoms 3eqtr4d
      isabli $.
      $( [8-May-2008] $) $( [9-Apr-2008] $)
  $}

  $( Abelian group property of subspace addition. $)
  hhssabl $p |- ( H e. SH -> ( +h |` ( H X. H ) ) e. Abel ) $=
    cH csh wcel cva cH cH cxp cres cabl wcel cva cH csh wcel cH chil cif cH csh
    wcel cH chil cif cxp cres cabl wcel cH chil cH cH csh wcel cH chil cif wceq
    cva cH cH cxp cres cva cH csh wcel cH chil cif cH csh wcel cH chil cif cxp
    cres cabl cH cH csh wcel cH chil cif wceq cH cH cxp cH csh wcel cH chil cif
    cH csh wcel cH chil cif cxp wceq cva cH cH cxp cres cva cH csh wcel cH chil
    cif cH csh wcel cH chil cif cxp cres wceq cH cH csh wcel cH chil cif wceq
    cH cH cxp cH csh wcel cH chil cif cH cxp cH csh wcel cH chil cif cH csh
    wcel cH chil cif cxp cH cH csh wcel cH chil cif cH xpeq1 cH cH csh wcel cH
    chil cif cH csh wcel cH chil cif xpeq2 eqtrd cH cH cxp cH csh wcel cH chil
    cif cH csh wcel cH chil cif cxp cva reseq2 syl eleq1d cH csh wcel cH chil
    cif cH chil csh helsh elimel hhssabli dedth $.
    $( [24-Jun-2008] $) $( [9-Apr-2008] $)

  ${
    $d x y z H $.
    hhssnvt.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    ${
      hhssnv.2 $e |- H e. SH $.
      $( Normed complex vector space property of a subspace. $)
      hhssnv $p |- W e. NrmCVec $=
        vx vy csm cc cH cxp cres cW cva cH cH cxp cres cno cH cres cH c0v cva
        cH cH cxp cres cH cva cH cH cxp cres cabl wcel cva cH cH cxp cres cgr
        wcel cH hhssnv.2 hhssabli cva cH cH cxp cres ablgrp ax-mp cH cH cxp cva
        cdm wss cva cH cH cxp cres cdm cH cH cxp wceq cH cH cxp chil chil cxp
        cva cdm cH chil wss cH chil wss cH cH cxp chil chil cxp wss cH hhssnv.2
        shssii cH hhssnv.2 shssii cH chil cH chil ssxp mp2an chil chil cxp chil
        cva ax-hfvadd fdmi sseqtr4i cH cH cxp cva ssdmres mpbi grprn c0v cva cH
        cH cxp cres cgi cfv wceq c0v c0v cva cH cH cxp cres co c0v wceq c0v c0v
        cva cH cH cxp cres co c0v c0v cva co c0v c0v cH wcel c0v cH wcel c0v
        c0v cva cH cH cxp cres co c0v c0v cva co wceq cH csh wcel c0v cH wcel
        hhssnv.2 cH sh0 ax-mp cH csh wcel c0v cH wcel hhssnv.2 cH sh0 ax-mp c0v
        c0v cH cH cva oprvres mp2an c0v ax-hv0cl hvaddid2i eqtri cva cH cH cxp
        cres cgr wcel c0v cH wcel c0v cva cH cH cxp cres cgi cfv wceq c0v c0v
        cva cH cH cxp cres co c0v wceq wb cva cH cH cxp cres cabl wcel cva cH
        cH cxp cres cgr wcel cH hhssnv.2 hhssabli cva cH cH cxp cres ablgrp
        ax-mp cH csh wcel c0v cH wcel hhssnv.2 cH sh0 ax-mp c0v cva cH cH cxp
        cres cgi cfv cva cH cH cxp cres cH cva cH cH cxp cres cH cva cH cH cxp
        cres cabl wcel cva cH cH cxp cres cgr wcel cH hhssnv.2 hhssabli cva cH
        cH cxp cres ablgrp ax-mp cH cH cxp cva cdm wss cva cH cH cxp cres cdm
        cH cH cxp wceq cH cH cxp chil chil cxp cva cdm cH chil wss cH chil wss
        cH cH cxp chil chil cxp wss cH hhssnv.2 shssii cH hhssnv.2 shssii cH
        chil cH chil ssxp mp2an chil chil cxp chil cva ax-hfvadd fdmi sseqtr4i
        cH cH cxp cva ssdmres mpbi grprn cva cH cH cxp cres cgi cfv eqid grpid
        mp2an mpbir vx vy vz csm cc cH cxp cres cva cH cH cxp cres cva cH cH
        cxp cres csm cc cH cxp cres cop cH cH hhssnv.2 hhssabli cH cH cxp cva
        cdm wss cva cH cH cxp cres cdm cH cH cxp wceq cH cH cxp chil chil cxp
        cva cdm cH chil wss cH chil wss cH cH cxp chil chil cxp wss cH hhssnv.2
        shssii cH hhssnv.2 shssii cH chil cH chil ssxp mp2an chil chil cxp chil
        cva ax-hfvadd fdmi sseqtr4i cH cH cxp cva ssdmres mpbi cc cH cxp cH csm
        cc cH cxp cres wf csm cc cH cxp cres cc cH cxp wfn csm cc cH cxp cres
        crn cH wss cc cH cxp cH csm cc cH cxp cres df-f csm cc chil cxp wfn cc
        cH cxp cc chil cxp wss csm cc cH cxp cres cc cH cxp wfn cc chil cxp
        chil csm wf csm cc chil cxp wfn ax-hfvmul cc chil cxp chil csm ffn
        ax-mp cc cc wss cH chil wss cc cH cxp cc chil cxp wss cc ssid cH
        hhssnv.2 shssii cc cc cH chil ssxp mp2an cc chil cxp cc cH cxp csm
        fnssres mp2an vz csm cc cH cxp cres crn cH vz cv csm cc cH cxp cres crn
        wcel vx cv vy cv csm cc cH cxp cres co vz cv wceq vy cH wrex vx cc wrex
        vz cv cH wcel csm cc cH cxp cres cc cH cxp wfn vz cv csm cc cH cxp cres
        crn wcel vx cv vy cv csm cc cH cxp cres co vz cv wceq vy cH wrex vx cc
        wrex wb csm cc chil cxp wfn cc cH cxp cc chil cxp wss csm cc cH cxp
        cres cc cH cxp wfn cc chil cxp chil csm wf csm cc chil cxp wfn
        ax-hfvmul cc chil cxp chil csm ffn ax-mp cc cc wss cH chil wss cc cH
        cxp cc chil cxp wss cc ssid cH hhssnv.2 shssii cc cc cH chil ssxp mp2an
        cc chil cxp cc cH cxp csm fnssres mp2an vx vy cc cH vz cv csm cc cH cxp
        cres oprvelrn ax-mp vx cv vy cv csm cc cH cxp cres co vz cv wceq vz cv
        cH wcel vx vy cc cH vx cv vy cv csm cc cH cxp cres co vz cv wceq vx cv
        vy cv csm cc cH cxp cres co cH wcel vz cv cH wcel vx cv cc wcel vy cv
        cH wcel wa vx cv vy cv csm cc cH cxp cres co vz cv cH eleq1 vx cv cc
        wcel vy cv cH wcel wa vx cv vy cv csm cc cH cxp cres co vx cv vy cv csm
        co cH vx cv vy cv cc cH csm oprvres cH csh wcel vx cv cc wcel vy cv cH
        wcel vx cv vy cv csm co cH wcel hhssnv.2 vx cv vy cv cH shmulcl mp3an1
        eqeltrd syl5cbi r19.23aivv sylbi ssriv mpbir2an vx cv cH wcel c1 vx cv
        csm cc cH cxp cres co c1 vx cv csm co vx cv c1 cc wcel vx cv cH wcel c1
        vx cv csm cc cH cxp cres co c1 vx cv csm co wceq ax1cn c1 vx cv cc cH
        csm oprvres mpan vx cv cH wcel vx cv chil wcel c1 vx cv csm co vx cv
        wceq vx cv cH hhssnv.2 sheli vx cv ax-hvmulid syl eqtrd vy cv cc wcel
        vx cv cH wcel vz cv cH wcel w3a vy cv vx cv vz cv cva co csm co vy cv
        vx cv csm co vy cv vz cv csm co cva co vy cv vx cv vz cv cva cH cH cxp
        cres co csm cc cH cxp cres co vy cv vx cv csm cc cH cxp cres co vy cv
        vz cv csm cc cH cxp cres co cva cH cH cxp cres co vy cv cc wcel vx cv
        chil wcel vz cv chil wcel vy cv vx cv vz cv cva co csm co vy cv vx cv
        csm co vy cv vz cv csm co cva co wceq vy cv cc wcel vx cv cH wcel vz cv
        cH wcel vy cv vx cv vz cv ax-hvdistr1 vy cv cc wcel id vx cv cH
        hhssnv.2 sheli vz cv cH hhssnv.2 sheli syl3an vy cv cc wcel vx cv cH
        wcel vz cv cH wcel w3a vy cv vx cv vz cv cva cH cH cxp cres co csm cc
        cH cxp cres co vy cv vx cv vz cv cva co csm cc cH cxp cres co vy cv vx
        cv vz cv cva co csm co vy cv cc wcel vx cv cH wcel vz cv cH wcel w3a vx
        cv vz cv cva cH cH cxp cres co vx cv vz cv cva co vy cv csm cc cH cxp
        cres vx cv cH wcel vz cv cH wcel vx cv vz cv cva cH cH cxp cres co vx
        cv vz cv cva co wceq vy cv cc wcel vx cv vz cv cH cH cva oprvres
        3adant1 opreq2d vy cv cc wcel vx cv cH wcel vz cv cH wcel vy cv vx cv
        vz cv cva co csm cc cH cxp cres co vy cv vx cv vz cv cva co csm co wceq
        vy cv cc wcel vx cv vz cv cva co cH wcel vy cv vx cv vz cv cva co csm
        cc cH cxp cres co vy cv vx cv vz cv cva co csm co wceq vx cv cH wcel vz
        cv cH wcel wa vy cv vx cv vz cv cva co cc cH csm oprvres cH csh wcel vx
        cv cH wcel vz cv cH wcel vx cv vz cv cva co cH wcel hhssnv.2 vx cv vz
        cv cH shaddcl mp3an1 sylan2 3impb eqtrd vy cv cc wcel vx cv cH wcel vz
        cv cH wcel w3a vy cv vx cv csm cc cH cxp cres co vy cv vz cv csm cc cH
        cxp cres co cva cH cH cxp cres co vy cv vx cv csm co vy cv vz cv csm co
        cva cH cH cxp cres co vy cv vx cv csm co vy cv vz cv csm co cva co vy
        cv cc wcel vx cv cH wcel vz cv cH wcel w3a vy cv vx cv csm cc cH cxp
        cres co vy cv vx cv csm co vy cv vz cv csm cc cH cxp cres co vy cv vz
        cv csm co cva cH cH cxp cres vy cv cc wcel vx cv cH wcel vy cv vx cv
        csm cc cH cxp cres co vy cv vx cv csm co wceq vz cv cH wcel vy cv vx cv
        cc cH csm oprvres 3adant3 vy cv cc wcel vz cv cH wcel vy cv vz cv csm
        cc cH cxp cres co vy cv vz cv csm co wceq vx cv cH wcel vy cv vz cv cc
        cH csm oprvres 3adant2 opreq12d vy cv vx cv csm co cH wcel vy cv vz cv
        csm co cH wcel vy cv vx cv csm co vy cv vz cv csm co cva cH cH cxp cres
        co vy cv vx cv csm co vy cv vz cv csm co cva co wceq vy cv cc wcel vx
        cv cH wcel vz cv cH wcel w3a vy cv vx cv csm co vy cv vz cv csm co cH
        cH cva oprvres vy cv cc wcel vx cv cH wcel vy cv vx cv csm co cH wcel
        vz cv cH wcel cH csh wcel vy cv cc wcel vx cv cH wcel vy cv vx cv csm
        co cH wcel hhssnv.2 vy cv vx cv cH shmulcl mp3an1 3adant3 vy cv cc wcel
        vz cv cH wcel vy cv vz cv csm co cH wcel vx cv cH wcel cH csh wcel vy
        cv cc wcel vz cv cH wcel vy cv vz cv csm co cH wcel hhssnv.2 vy cv vz
        cv cH shmulcl mp3an1 3adant2 sylanc eqtrd 3eqtr4d vy cv cc wcel vz cv
        cc wcel vx cv cH wcel w3a vy cv vz cv caddc co vx cv csm co vy cv vx cv
        csm co vz cv vx cv csm co cva co vy cv vz cv caddc co vx cv csm cc cH
        cxp cres co vy cv vx cv csm cc cH cxp cres co vz cv vx cv csm cc cH cxp
        cres co cva cH cH cxp cres co vy cv cc wcel vz cv cc wcel vx cv chil
        wcel vy cv vz cv caddc co vx cv csm co vy cv vx cv csm co vz cv vx cv
        csm co cva co wceq vx cv cH wcel vy cv vz cv vx cv ax-hvdistr2 vx cv cH
        hhssnv.2 sheli syl3an3 vy cv cc wcel vz cv cc wcel vx cv cH wcel vy cv
        vz cv caddc co vx cv csm cc cH cxp cres co vy cv vz cv caddc co vx cv
        csm co wceq vy cv vz cv caddc co cc wcel vx cv cH wcel vy cv vz cv
        caddc co vx cv csm cc cH cxp cres co vy cv vz cv caddc co vx cv csm co
        wceq vy cv cc wcel vz cv cc wcel wa vy cv vz cv caddc co vx cv cc cH
        csm oprvres vy cv vz cv addcl sylan 3impa vy cv cc wcel vz cv cc wcel
        vx cv cH wcel w3a vy cv vx cv csm cc cH cxp cres co vz cv vx cv csm cc
        cH cxp cres co cva cH cH cxp cres co vy cv vx cv csm co vz cv vx cv csm
        co cva cH cH cxp cres co vy cv vx cv csm co vz cv vx cv csm co cva co
        vy cv cc wcel vz cv cc wcel vx cv cH wcel w3a vy cv vx cv csm cc cH cxp
        cres co vy cv vx cv csm co vz cv vx cv csm cc cH cxp cres co vz cv vx
        cv csm co cva cH cH cxp cres vy cv cc wcel vx cv cH wcel vy cv vx cv
        csm cc cH cxp cres co vy cv vx cv csm co wceq vz cv cc wcel vy cv vx cv
        cc cH csm oprvres 3adant2 vz cv cc wcel vx cv cH wcel vz cv vx cv csm
        cc cH cxp cres co vz cv vx cv csm co wceq vy cv cc wcel vz cv vx cv cc
        cH csm oprvres 3adant1 opreq12d vy cv vx cv csm co cH wcel vz cv vx cv
        csm co cH wcel vy cv vx cv csm co vz cv vx cv csm co cva cH cH cxp cres
        co vy cv vx cv csm co vz cv vx cv csm co cva co wceq vy cv cc wcel vz
        cv cc wcel vx cv cH wcel w3a vy cv vx cv csm co vz cv vx cv csm co cH
        cH cva oprvres vy cv cc wcel vx cv cH wcel vy cv vx cv csm co cH wcel
        vz cv cc wcel cH csh wcel vy cv cc wcel vx cv cH wcel vy cv vx cv csm
        co cH wcel hhssnv.2 vy cv vx cv cH shmulcl mp3an1 3adant2 vz cv cc wcel
        vx cv cH wcel vz cv vx cv csm co cH wcel vy cv cc wcel cH csh wcel vz
        cv cc wcel vx cv cH wcel vz cv vx cv csm co cH wcel hhssnv.2 vz cv vx
        cv cH shmulcl mp3an1 3adant1 sylanc eqtrd 3eqtr4d vy cv cc wcel vz cv
        cc wcel vx cv cH wcel w3a vy cv vz cv cmul co vx cv csm co vy cv vz cv
        vx cv csm co csm co vy cv vz cv cmul co vx cv csm cc cH cxp cres co vy
        cv vz cv vx cv csm cc cH cxp cres co csm cc cH cxp cres co vy cv cc
        wcel vz cv cc wcel vx cv chil wcel vy cv vz cv cmul co vx cv csm co vy
        cv vz cv vx cv csm co csm co wceq vx cv cH wcel vy cv vz cv vx cv
        ax-hvmulass vx cv cH hhssnv.2 sheli syl3an3 vy cv cc wcel vz cv cc wcel
        vx cv cH wcel vy cv vz cv cmul co vx cv csm cc cH cxp cres co vy cv vz
        cv cmul co vx cv csm co wceq vy cv vz cv cmul co cc wcel vx cv cH wcel
        vy cv vz cv cmul co vx cv csm cc cH cxp cres co vy cv vz cv cmul co vx
        cv csm co wceq vy cv cc wcel vz cv cc wcel wa vy cv vz cv cmul co vx cv
        cc cH csm oprvres vy cv vz cv mulcl sylan 3impa vy cv cc wcel vz cv cc
        wcel vx cv cH wcel w3a vy cv vz cv vx cv csm cc cH cxp cres co csm cc
        cH cxp cres co vy cv vz cv vx cv csm co csm cc cH cxp cres co vy cv vz
        cv vx cv csm co csm co vy cv cc wcel vz cv cc wcel vx cv cH wcel w3a vz
        cv vx cv csm cc cH cxp cres co vz cv vx cv csm co vy cv csm cc cH cxp
        cres vz cv cc wcel vx cv cH wcel vz cv vx cv csm cc cH cxp cres co vz
        cv vx cv csm co wceq vy cv cc wcel vz cv vx cv cc cH csm oprvres
        3adant1 opreq2d vy cv cc wcel vz cv cc wcel vx cv cH wcel vy cv vz cv
        vx cv csm co csm cc cH cxp cres co vy cv vz cv vx cv csm co csm co wceq
        vy cv cc wcel vz cv vx cv csm co cH wcel vy cv vz cv vx cv csm co csm
        cc cH cxp cres co vy cv vz cv vx cv csm co csm co wceq vz cv cc wcel vx
        cv cH wcel wa vy cv vz cv vx cv csm co cc cH csm oprvres cH csh wcel vz
        cv cc wcel vx cv cH wcel vz cv vx cv csm co cH wcel hhssnv.2 vz cv vx
        cv cH shmulcl mp3an1 sylan2 3impb eqtrd 3eqtr4d cva cH cH cxp cres csm
        cc cH cxp cres cop eqid isvci chil cr cno wf cH chil wss cH cr cno cH
        cres wf normf cH hhssnv.2 shssii chil cr cH cno fssres mp2an vx cv cH
        wcel vx cv cno cH cres cfv cc0 wceq vx cv c0v wceq vx cv cH wcel vx cv
        cno cH cres cfv cc0 wceq vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv cH
        wcel vx cv cno cH cres cfv vx cv cno cfv cc0 vx cv cH cno fvres eqeq1d
        vx cv cH wcel vx cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq wb
        vx cv cH hhssnv.2 sheli vx cv norm-i syl bitrd biimpa vy cv cc wcel vx
        cv cH wcel wa vy cv vx cv csm co cno cfv vy cv cabs cfv vx cv cno cfv
        cmul co vy cv vx cv csm cc cH cxp cres co cno cH cres cfv vy cv cabs
        cfv vx cv cno cH cres cfv cmul co vy cv cc wcel vx cv chil wcel vy cv
        vx cv csm co cno cfv vy cv cabs cfv vx cv cno cfv cmul co wceq vx cv cH
        wcel vy cv vx cv norm-iii vx cv cH hhssnv.2 sheli sylan2 vy cv cc wcel
        vx cv cH wcel wa vy cv vx cv csm cc cH cxp cres co cno cH cres cfv vy
        cv vx cv csm co cno cH cres cfv vy cv vx cv csm co cno cfv vy cv cc
        wcel vx cv cH wcel wa vy cv vx cv csm cc cH cxp cres co vy cv vx cv csm
        co cno cH cres vy cv vx cv cc cH csm oprvres fveq2d vy cv cc wcel vx cv
        cH wcel wa vy cv vx cv csm co cH wcel vy cv vx cv csm co cno cH cres
        cfv vy cv vx cv csm co cno cfv wceq cH csh wcel vy cv cc wcel vx cv cH
        wcel vy cv vx cv csm co cH wcel hhssnv.2 vy cv vx cv cH shmulcl mp3an1
        vy cv vx cv csm co cH cno fvres syl eqtrd vy cv cc wcel vx cv cH wcel
        wa vx cv cno cH cres cfv vx cv cno cfv vy cv cabs cfv cmul vx cv cH
        wcel vx cv cno cH cres cfv vx cv cno cfv wceq vy cv cc wcel vx cv cH
        cno fvres adantl opreq2d 3eqtr4d vx cv cH wcel vy cv cH wcel wa vx cv
        vy cv cva co cno cfv vx cv cno cfv vy cv cno cfv caddc co vx cv vy cv
        cva cH cH cxp cres co cno cH cres cfv vx cv cno cH cres cfv vy cv cno
        cH cres cfv caddc co cle vx cv chil wcel vy cv chil wcel vx cv vy cv
        cva co cno cfv vx cv cno cfv vy cv cno cfv caddc co cle wbr vx cv cH
        wcel vy cv cH wcel vx cv vy cv norm-ii vx cv cH hhssnv.2 sheli vy cv cH
        hhssnv.2 sheli syl2an vx cv cH wcel vy cv cH wcel wa vx cv vy cv cva cH
        cH cxp cres co cno cH cres cfv vx cv vy cv cva co cno cH cres cfv vx cv
        vy cv cva co cno cfv vx cv cH wcel vy cv cH wcel wa vx cv vy cv cva cH
        cH cxp cres co vx cv vy cv cva co cno cH cres vx cv vy cv cH cH cva
        oprvres fveq2d vx cv cH wcel vy cv cH wcel wa vx cv vy cv cva co cH
        wcel vx cv vy cv cva co cno cH cres cfv vx cv vy cv cva co cno cfv wceq
        cH csh wcel vx cv cH wcel vy cv cH wcel vx cv vy cv cva co cH wcel
        hhssnv.2 vx cv vy cv cH shaddcl mp3an1 vx cv vy cv cva co cH cno fvres
        syl eqtrd vx cv cH wcel vy cv cH wcel vx cv cno cH cres cfv vx cv cno
        cfv vy cv cno cH cres cfv vy cv cno cfv caddc vx cv cH cno fvres vy cv
        cH cno fvres opreqan12d 3brtr4d hhssnvt.1 isnvi $.
        $( [8-May-2008] $) $( [26-Mar-2008] $)
    $}

    $( Normed complex vector space property of a subspace. $)
    hhssnvt $p |- ( H e. SH -> W e. NrmCVec ) $=
      cH csh wcel cW cnv wcel cva cH csh wcel cH c0h cif cH csh wcel cH c0h cif
      cxp cres csm cc cH csh wcel cH c0h cif cxp cres cop cno cH csh wcel cH
      c0h cif cres cop cnv wcel cH c0h cH cH csh wcel cH c0h cif wceq cW cva cH
      csh wcel cH c0h cif cH csh wcel cH c0h cif cxp cres csm cc cH csh wcel cH
      c0h cif cxp cres cop cno cH csh wcel cH c0h cif cres cop cnv cH cH csh
      wcel cH c0h cif wceq cva cH cH cxp cres csm cc cH cxp cres cop cno cH
      cres cop cva cH csh wcel cH c0h cif cH csh wcel cH c0h cif cxp cres csm
      cc cH csh wcel cH c0h cif cxp cres cop cno cH csh wcel cH c0h cif cres
      cop cW cH cH csh wcel cH c0h cif wceq cva cH cH cxp cres csm cc cH cxp
      cres cop cva cH csh wcel cH c0h cif cH csh wcel cH c0h cif cxp cres csm
      cc cH csh wcel cH c0h cif cxp cres cop cno cH cres cno cH csh wcel cH c0h
      cif cres cH cH csh wcel cH c0h cif wceq cva cH cH cxp cres cva cH csh
      wcel cH c0h cif cH csh wcel cH c0h cif cxp cres csm cc cH cxp cres csm cc
      cH csh wcel cH c0h cif cxp cres cH cH csh wcel cH c0h cif wceq cH cH cxp
      cH csh wcel cH c0h cif cH csh wcel cH c0h cif cxp wceq cva cH cH cxp cres
      cva cH csh wcel cH c0h cif cH csh wcel cH c0h cif cxp cres wceq cH cH csh
      wcel cH c0h cif wceq cH cH cxp cH csh wcel cH c0h cif cH cxp cH csh wcel
      cH c0h cif cH csh wcel cH c0h cif cxp cH cH csh wcel cH c0h cif cH xpeq1
      cH cH csh wcel cH c0h cif cH csh wcel cH c0h cif xpeq2 eqtrd cH cH cxp cH
      csh wcel cH c0h cif cH csh wcel cH c0h cif cxp cva reseq2 syl cH cH csh
      wcel cH c0h cif wceq cc cH cxp cc cH csh wcel cH c0h cif cxp wceq csm cc
      cH cxp cres csm cc cH csh wcel cH c0h cif cxp cres wceq cH cH csh wcel cH
      c0h cif cc xpeq2 cc cH cxp cc cH csh wcel cH c0h cif cxp csm reseq2 syl
      opeq12d cH cH csh wcel cH c0h cif cno reseq2 opeq12d hhssnvt.1 syl5eq
      eleq1d cH csh wcel cH c0h cif cva cH csh wcel cH c0h cif cH csh wcel cH
      c0h cif cxp cres csm cc cH csh wcel cH c0h cif cxp cres cop cno cH csh
      wcel cH c0h cif cres cop cva cH csh wcel cH c0h cif cH csh wcel cH c0h
      cif cxp cres csm cc cH csh wcel cH c0h cif cxp cres cop cno cH csh wcel
      cH c0h cif cres cop eqid cH c0h csh h0elsh elimel hhssnv dedth $.
      $( [8-May-2008] $) $( [9-Apr-2008] $)
  $}

  ${
    $d x y z H $.
    hhsst.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhsst.2 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    $( A member of ` SH ` is a subspace. $)
    hhsst $p |- ( H e. SH -> W e. ( SubSp ` U ) ) $=
      cH csh wcel cW cnv wcel cva cH cH cxp cres cva wss csm cc cH cxp cres csm
      wss cno cH cres cno wss w3a wa cW cU css cfv wcel cH csh wcel cW cnv wcel
      cva cH cH cxp cres cva wss csm cc cH cxp cres csm wss cno cH cres cno wss
      w3a cH cW hhsst.2 hhssnvt cva cH cH cxp cres cva wss csm cc cH cxp cres
      csm wss cno cH cres cno wss cva cH cH cxp resss csm cc cH cxp resss cno
      cH resss 3pm3.2i jctir cU cnv wcel cW cU css cfv wcel cW cnv wcel cva cH
      cH cxp cres cva wss csm cc cH cxp cres csm wss cno cH cres cno wss w3a wa
      wb cU hhsst.1 hhnv csm cc cH cxp cres csm cU cva cH cH cxp cres cva cU
      css cfv cno cH cres cno cW cU hhsst.1 hhva cH cW hhsst.2 hhssva cU
      hhsst.1 hhsm cH cW hhsst.2 hhsssm cU hhsst.1 hhnm cH cW hhsst.2 hhssnm cU
      css cfv eqid isssp ax-mp sylibr $.
      $( [9-May-2008] $) $( [6-Apr-2008] $)

    ${
      hhssp3.3 $e |- W e. ( SubSp ` U ) $.
      hhssp3.4 $e |- H C_ ~H $.
      $( Lemma for ~ hhsssh . $)
      hhshsslem1 $p |- H = ( BaseSet ` W ) $=
        cW cba cfv cH cW cba cfv cW cpv cfv crn cH cW cW cpv cfv cW cba cfv cW
        cba cfv eqid cW cpv cfv eqid bafval cW cpv cfv crn cW cpv cfv cdm cdm
        cH cH cxp cdm cH cW cpv cfv cgr wcel cW cpv cfv crn cW cpv cfv cdm cdm
        wceq cW cnv wcel cW cpv cfv cgr wcel cU cnv wcel cW cU css cfv wcel cW
        cnv wcel cU hhsst.1 hhnv hhssp3.3 cU cU css cfv cW cU css cfv eqid
        sspnv mp2an cW cW cpv cfv cW cpv cfv eqid nvgrp ax-mp cW cpv cfv
        grprndm ax-mp cW cpv cfv cdm cH cH cxp cW cpv cfv cdm cva cH cH cxp
        cres cdm cH cH cxp cW cpv cfv cva cH cH cxp cres cW cpv cfv cva cH cH
        cxp cres csm cc cH cxp cres cop cno cH cres cop cpv cfv cva cH cH cxp
        cres cW cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop cpv
        hhsst.2 fveq2i cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres
        cop cpv cfv cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop
        c1st cfv c1st cfv cva cH cH cxp cres cva cH cH cxp cres csm cc cH cxp
        cres cop cno cH cres cop cva cH cH cxp cres csm cc cH cxp cres cop cno
        cH cres cop cpv cfv cva cH cH cxp cres csm cc cH cxp cres cop cno cH
        cres cop cpv cfv eqid vafval cva cH cH cxp cres csm cc cH cxp cres cop
        cno cH cres cop c1st cfv c1st cfv cva cH cH cxp cres csm cc cH cxp cres
        cop c1st cfv cva cH cH cxp cres cva cH cH cxp cres csm cc cH cxp cres
        cop cno cH cres cop c1st cfv cva cH cH cxp cres csm cc cH cxp cres cop
        c1st cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cva cH cH
        cxp cres csm cc cH cxp cres opex op1st fveq2i cva cH cH cxp cres csm cc
        cH cxp cres cva cabl wcel cva cH cH cxp cres cvv wcel hilabl cva cH cH
        cxp cabl resexg ax-mp op1st eqtri eqtri eqtri dmeqi cH cH cxp cva cdm
        wss cva cH cH cxp cres cdm cH cH cxp wceq cH cH cxp chil chil cxp cva
        cdm cH chil wss cH chil wss cH cH cxp chil chil cxp wss hhssp3.4
        hhssp3.4 cH chil cH chil ssxp mp2an chil chil cxp chil cva ax-hfvadd
        fdmi sseqtr4i cH cH cxp cva ssdmres mpbi eqtri dmeqi cH dmxpid 3eqtri
        eqtri eqcomi $.
        $( [11-May-2008] $) $( [10-Apr-2008] $)

      $( Lemma for ~ hhsssh . $)
      hhshsslem2 $p |- H e. SH $=
        cH csh wcel cH chil wss c0v cH wcel wa vx cv vy cv cva co cH wcel vy cH
        wral vx cH wral vx cv vy cv csm co cH wcel vy cH wral vx cc wral wa vx
        vy cH sh cH chil wss c0v cH wcel hhssp3.4 cW cn0v cfv c0v cH cU cnv
        wcel cW cU css cfv wcel cW cn0v cfv c0v wceq cU hhsst.1 hhnv hhssp3.3
        cW cn0v cfv cU cU css cfv cW c0v cU hhsst.1 hh0v cW cn0v cfv eqid cU
        css cfv eqid sspz mp2an cW cn0v cfv cW cba cfv cH cW cnv wcel cW cn0v
        cfv cW cba cfv wcel cU cnv wcel cW cU css cfv wcel cW cnv wcel cU
        hhsst.1 hhnv hhssp3.3 cU cU css cfv cW cU css cfv eqid sspnv mp2an cW
        cW cba cfv cW cn0v cfv cW cba cfv eqid cW cn0v cfv eqid nvzcl ax-mp cH
        cW cba cfv cU cH cW hhsst.1 hhsst.2 hhssp3.3 hhssp3.4 hhshsslem1 eqcomi
        eleqtri eqeltrri pm3.2i vx cv vy cv cva co cH wcel vy cH wral vx cH
        wral vx cv vy cv csm co cH wcel vy cH wral vx cc wral vx cv vy cv cva
        co cH wcel vx vy cH vx cv cH wcel vy cv cH wcel wa vx cv vy cv cW cpv
        cfv co vx cv vy cv cva co cH cU cnv wcel cW cU css cfv wcel vx cv cH
        wcel vy cv cH wcel wa vx cv vy cv cW cpv cfv co vx cv vy cv cva co wceq
        cU hhsst.1 hhnv hhssp3.3 vx cv vy cv cU cW cpv cfv cva cU css cfv cW cH
        cU cH cW hhsst.1 hhsst.2 hhssp3.3 hhssp3.4 hhshsslem1 cU hhsst.1 hhva
        cW cpv cfv eqid cU css cfv eqid sspgval mpanl12 cW cnv wcel vx cv cH
        wcel vy cv cH wcel vx cv vy cv cW cpv cfv co cH wcel cU cnv wcel cW cU
        css cfv wcel cW cnv wcel cU hhsst.1 hhnv hhssp3.3 cU cU css cfv cW cU
        css cfv eqid sspnv mp2an vx cv vy cv cW cW cpv cfv cH cU cH cW hhsst.1
        hhsst.2 hhssp3.3 hhssp3.4 hhshsslem1 cW cpv cfv eqid nvgcl mp3an1
        eqeltrrd rgen2a vx cv vy cv csm co cH wcel vx vy cc cH vx cv cc wcel vy
        cv cH wcel wa vx cv vy cv cW cns cfv co vx cv vy cv csm co cH cU cnv
        wcel cW cU css cfv wcel vx cv cc wcel vy cv cH wcel wa vx cv vy cv cW
        cns cfv co vx cv vy cv csm co wceq cU hhsst.1 hhnv hhssp3.3 vx cv vy cv
        cW cns cfv csm cU cU css cfv cW cH cU cH cW hhsst.1 hhsst.2 hhssp3.3
        hhssp3.4 hhshsslem1 cU hhsst.1 hhsm cW cns cfv eqid cU css cfv eqid
        sspsval mpanl12 cW cnv wcel vx cv cc wcel vy cv cH wcel vx cv vy cv cW
        cns cfv co cH wcel cU cnv wcel cW cU css cfv wcel cW cnv wcel cU
        hhsst.1 hhnv hhssp3.3 cU cU css cfv cW cU css cfv eqid sspnv mp2an vx
        cv vy cv cW cns cfv cW cH cU cH cW hhsst.1 hhsst.2 hhssp3.3 hhssp3.4
        hhshsslem1 cW cns cfv eqid nvscl mp3an1 eqeltrrd rgen2 pm3.2i mpbir2an
        $.
        $( [11-May-2008] $) $( [6-Apr-2008] $)
    $}

    $( The predicate " ` H ` is a subspace of Hilbert space." $)
    hhsssh $p |- ( H e. SH <-> ( W e. ( SubSp ` U ) /\ H C_ ~H ) ) $=
      cH csh wcel cW cU css cfv wcel cH chil wss wa cH csh wcel cW cU css cfv
      wcel cH chil wss cU cH cW hhsst.1 hhsst.2 hhsst cH shss jca cW cU css cfv
      wcel cH chil wss wa cH csh wcel cW cU css cfv wcel cH chil wss wa cH chil
      cif csh wcel cH chil cH cW cU css cfv wcel cH chil wss wa cH chil cif csh
      eleq1 cU cW cU css cfv wcel cH chil wss wa cH chil cif cva cW cU css cfv
      wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil
      cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp
      cres cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop
      hhsst.1 cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv
      wcel cH chil wss wa cH chil cif cxp cres csm cc cW cU css cfv wcel cH
      chil wss wa cH chil cif cxp cres cop cno cW cU css cfv wcel cH chil wss
      wa cH chil cif cres cop eqid cva cW cU css cfv wcel cH chil wss wa cH
      chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres csm cc cW
      cU css cfv wcel cH chil wss wa cH chil cif cxp cres cop cno cW cU css cfv
      wcel cH chil wss wa cH chil cif cres cop cU css cfv wcel cW cU css cfv
      wcel cH chil wss wa cH chil cif chil wss cW cU css cfv wcel cH chil wss
      wa cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel
      cH chil wss wa cH chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss
      wa cH chil cif cxp cres cop cno cW cU css cfv wcel cH chil wss wa cH chil
      cif cres cop cU css cfv wcel cW cU css cfv wcel cH chil wss wa cH chil
      cif chil wss wa cva chil chil cxp cres csm cc chil cxp cres cop cno chil
      cres cop cU css cfv wcel chil chil wss wa cH chil cH cW cU css cfv wcel
      cH chil wss wa cH chil cif wceq cW cU css cfv wcel cva cW cU css cfv wcel
      cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres
      cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop cU css cfv
      wcel cH chil wss cW cU css cfv wcel cH chil wss wa cH chil cif chil wss
      cH cW cU css cfv wcel cH chil wss wa cH chil cif wceq cW cva cW cU css
      cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH
      chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cres cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop
      cU css cfv cH cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva cH
      cH cxp cres csm cc cH cxp cres cop cno cH cres cop cva cW cU css cfv wcel
      cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres
      cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop cW cH cW
      cU css cfv wcel cH chil wss wa cH chil cif wceq cva cH cH cxp cres csm cc
      cH cxp cres cop cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU
      css cfv wcel cH chil wss wa cH chil cif cxp cres csm cc cW cU css cfv
      wcel cH chil wss wa cH chil cif cxp cres cop cno cH cres cno cW cU css
      cfv wcel cH chil wss wa cH chil cif cres cH cW cU css cfv wcel cH chil
      wss wa cH chil cif wceq cva cH cH cxp cres cva cW cU css cfv wcel cH chil
      wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres
      csm cc cH cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cres cH cW cU css cfv wcel cH chil wss wa cH chil cif wceq cH cH cxp
      cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil
      wss wa cH chil cif cxp wceq cva cH cH cxp cres cva cW cU css cfv wcel cH
      chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp
      cres wceq cH cW cU css cfv wcel cH chil wss wa cH chil cif wceq cH cH cxp
      cW cU css cfv wcel cH chil wss wa cH chil cif cH cxp cW cU css cfv wcel
      cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cH cW cU css cfv wcel cH chil wss wa cH chil cif cH xpeq1 cH cW cU
      css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa
      cH chil cif xpeq2 eqtrd cH cH cxp cW cU css cfv wcel cH chil wss wa cH
      chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cva reseq2 syl
      cH cW cU css cfv wcel cH chil wss wa cH chil cif wceq cc cH cxp cc cW cU
      css cfv wcel cH chil wss wa cH chil cif cxp wceq csm cc cH cxp cres csm
      cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres wceq cH cW cU
      css cfv wcel cH chil wss wa cH chil cif cc xpeq2 cc cH cxp cc cW cU css
      cfv wcel cH chil wss wa cH chil cif cxp csm reseq2 syl opeq12d cH cW cU
      css cfv wcel cH chil wss wa cH chil cif cno reseq2 opeq12d hhsst.2 syl5eq
      eleq1d cH cW cU css cfv wcel cH chil wss wa cH chil cif chil sseq1
      anbi12d chil cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva chil
      chil cxp cres csm cc chil cxp cres cop cno chil cres cop cU css cfv wcel
      cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH
      chil wss wa cH chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa
      cH chil cif cxp cres cop cno cW cU css cfv wcel cH chil wss wa cH chil
      cif cres cop cU css cfv wcel chil chil wss cW cU css cfv wcel cH chil wss
      wa cH chil cif chil wss chil cW cU css cfv wcel cH chil wss wa cH chil
      cif wceq cva chil chil cxp cres csm cc chil cxp cres cop cno chil cres
      cop cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel
      cH chil wss wa cH chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss
      wa cH chil cif cxp cres cop cno cW cU css cfv wcel cH chil wss wa cH chil
      cif cres cop cU css cfv chil cW cU css cfv wcel cH chil wss wa cH chil
      cif wceq cva chil chil cxp cres csm cc chil cxp cres cop cva cW cU css
      cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH
      chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cres cop cno chil cres cno cW cU css cfv wcel cH chil wss wa cH chil
      cif cres chil cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva chil
      chil cxp cres cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css
      cfv wcel cH chil wss wa cH chil cif cxp cres csm cc chil cxp cres csm cc
      cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres chil cW cU css cfv
      wcel cH chil wss wa cH chil cif wceq chil chil cxp cW cU css cfv wcel cH
      chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp
      wceq cva chil chil cxp cres cva cW cU css cfv wcel cH chil wss wa cH chil
      cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres wceq chil cW
      cU css cfv wcel cH chil wss wa cH chil cif wceq chil chil cxp cW cU css
      cfv wcel cH chil wss wa cH chil cif chil cxp cW cU css cfv wcel cH chil
      wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp chil
      cW cU css cfv wcel cH chil wss wa cH chil cif chil xpeq1 chil cW cU css
      cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH
      chil cif xpeq2 eqtrd chil chil cxp cW cU css cfv wcel cH chil wss wa cH
      chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cva reseq2 syl
      chil cW cU css cfv wcel cH chil wss wa cH chil cif wceq cc chil cxp cc cW
      cU css cfv wcel cH chil wss wa cH chil cif cxp wceq csm cc chil cxp cres
      csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres wceq chil
      cW cU css cfv wcel cH chil wss wa cH chil cif cc xpeq2 cc chil cxp cc cW
      cU css cfv wcel cH chil wss wa cH chil cif cxp csm reseq2 syl opeq12d
      chil cW cU css cfv wcel cH chil wss wa cH chil cif cno reseq2 opeq12d
      eleq1d chil cW cU css cfv wcel cH chil wss wa cH chil cif chil sseq1
      anbi12d cva chil chil cxp cres csm cc chil cxp cres cop cno chil cres cop
      cU css cfv wcel chil chil wss cva chil chil cxp cres csm cc chil cxp cres
      cop cno chil cres cop cU cU css cfv cva chil chil cxp cres csm cc chil
      cxp cres cop cno chil cres cop cva csm cop cno cop cU cva chil chil cxp
      cres csm cc chil cxp cres cop cva csm cop cno chil cres cno cva chil chil
      cxp cres cva csm cc chil cxp cres csm cva chil chil cxp wfn cva chil chil
      cxp cres cva wceq chil chil cxp chil cva wf cva chil chil cxp wfn
      ax-hfvadd chil chil cxp chil cva ffn ax-mp chil chil cxp cva fnresdm
      ax-mp csm cc chil cxp wfn csm cc chil cxp cres csm wceq cc chil cxp chil
      csm wf csm cc chil cxp wfn ax-hfvmul cc chil cxp chil csm ffn ax-mp cc
      chil cxp csm fnresdm ax-mp opeq12i cno chil wfn cno chil cres cno wceq
      chil cr cno wf cno chil wfn normf chil cr cno ffn ax-mp chil cno fnresdm
      ax-mp opeq12i hhsst.1 eqtr4i cU cnv wcel cU cU css cfv wcel cU hhsst.1
      hhnv cU cU css cfv cU css cfv eqid sspid ax-mp eqeltri chil ssid pm3.2i
      elimhyp pm3.26i cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU
      css cfv wcel cH chil wss wa cH chil cif cxp cres csm cc cW cU css cfv
      wcel cH chil wss wa cH chil cif cxp cres cop cno cW cU css cfv wcel cH
      chil wss wa cH chil cif cres cop cU css cfv wcel cW cU css cfv wcel cH
      chil wss wa cH chil cif chil wss cW cU css cfv wcel cH chil wss wa cva cW
      cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss
      wa cH chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil
      cif cxp cres cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres
      cop cU css cfv wcel cW cU css cfv wcel cH chil wss wa cH chil cif chil
      wss wa cva chil chil cxp cres csm cc chil cxp cres cop cno chil cres cop
      cU css cfv wcel chil chil wss wa cH chil cH cW cU css cfv wcel cH chil
      wss wa cH chil cif wceq cW cU css cfv wcel cva cW cU css cfv wcel cH chil
      wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres
      csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres cop cno cW
      cU css cfv wcel cH chil wss wa cH chil cif cres cop cU css cfv wcel cH
      chil wss cW cU css cfv wcel cH chil wss wa cH chil cif chil wss cH cW cU
      css cfv wcel cH chil wss wa cH chil cif wceq cW cva cW cU css cfv wcel cH
      chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp
      cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres cop
      cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop cU css cfv cH
      cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva cH cH cxp cres csm
      cc cH cxp cres cop cno cH cres cop cva cW cU css cfv wcel cH chil wss wa
      cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres csm cc
      cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres cop cno cW cU css
      cfv wcel cH chil wss wa cH chil cif cres cop cW cH cW cU css cfv wcel cH
      chil wss wa cH chil cif wceq cva cH cH cxp cres csm cc cH cxp cres cop
      cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH
      chil wss wa cH chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa
      cH chil cif cxp cres cop cno cH cres cno cW cU css cfv wcel cH chil wss
      wa cH chil cif cres cH cW cU css cfv wcel cH chil wss wa cH chil cif wceq
      cva cH cH cxp cres cva cW cU css cfv wcel cH chil wss wa cH chil cif cW
      cU css cfv wcel cH chil wss wa cH chil cif cxp cres csm cc cH cxp cres
      csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres cH cW cU
      css cfv wcel cH chil wss wa cH chil cif wceq cH cH cxp cW cU css cfv wcel
      cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp wceq cva cH cH cxp cres cva cW cU css cfv wcel cH chil wss wa cH chil
      cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres wceq cH cW cU
      css cfv wcel cH chil wss wa cH chil cif wceq cH cH cxp cW cU css cfv wcel
      cH chil wss wa cH chil cif cH cxp cW cU css cfv wcel cH chil wss wa cH
      chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp cH cW cU css
      cfv wcel cH chil wss wa cH chil cif cH xpeq1 cH cW cU css cfv wcel cH
      chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif
      xpeq2 eqtrd cH cH cxp cW cU css cfv wcel cH chil wss wa cH chil cif cW cU
      css cfv wcel cH chil wss wa cH chil cif cxp cva reseq2 syl cH cW cU css
      cfv wcel cH chil wss wa cH chil cif wceq cc cH cxp cc cW cU css cfv wcel
      cH chil wss wa cH chil cif cxp wceq csm cc cH cxp cres csm cc cW cU css
      cfv wcel cH chil wss wa cH chil cif cxp cres wceq cH cW cU css cfv wcel
      cH chil wss wa cH chil cif cc xpeq2 cc cH cxp cc cW cU css cfv wcel cH
      chil wss wa cH chil cif cxp csm reseq2 syl opeq12d cH cW cU css cfv wcel
      cH chil wss wa cH chil cif cno reseq2 opeq12d hhsst.2 syl5eq eleq1d cH cW
      cU css cfv wcel cH chil wss wa cH chil cif chil sseq1 anbi12d chil cW cU
      css cfv wcel cH chil wss wa cH chil cif wceq cva chil chil cxp cres csm
      cc chil cxp cres cop cno chil cres cop cU css cfv wcel cva cW cU css cfv
      wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil
      cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp
      cres cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop cU
      css cfv wcel chil chil wss cW cU css cfv wcel cH chil wss wa cH chil cif
      chil wss chil cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva chil
      chil cxp cres csm cc chil cxp cres cop cno chil cres cop cva cW cU css
      cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH
      chil cif cxp cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif
      cxp cres cop cno cW cU css cfv wcel cH chil wss wa cH chil cif cres cop
      cU css cfv chil cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva
      chil chil cxp cres csm cc chil cxp cres cop cva cW cU css cfv wcel cH
      chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp
      cres csm cc cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres cop
      cno chil cres cno cW cU css cfv wcel cH chil wss wa cH chil cif cres chil
      cW cU css cfv wcel cH chil wss wa cH chil cif wceq cva chil chil cxp cres
      cva cW cU css cfv wcel cH chil wss wa cH chil cif cW cU css cfv wcel cH
      chil wss wa cH chil cif cxp cres csm cc chil cxp cres csm cc cW cU css
      cfv wcel cH chil wss wa cH chil cif cxp cres chil cW cU css cfv wcel cH
      chil wss wa cH chil cif wceq chil chil cxp cW cU css cfv wcel cH chil wss
      wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp wceq cva
      chil chil cxp cres cva cW cU css cfv wcel cH chil wss wa cH chil cif cW
      cU css cfv wcel cH chil wss wa cH chil cif cxp cres wceq chil cW cU css
      cfv wcel cH chil wss wa cH chil cif wceq chil chil cxp cW cU css cfv wcel
      cH chil wss wa cH chil cif chil cxp cW cU css cfv wcel cH chil wss wa cH
      chil cif cW cU css cfv wcel cH chil wss wa cH chil cif cxp chil cW cU css
      cfv wcel cH chil wss wa cH chil cif chil xpeq1 chil cW cU css cfv wcel cH
      chil wss wa cH chil cif cW cU css cfv wcel cH chil wss wa cH chil cif
      xpeq2 eqtrd chil chil cxp cW cU css cfv wcel cH chil wss wa cH chil cif
      cW cU css cfv wcel cH chil wss wa cH chil cif cxp cva reseq2 syl chil cW
      cU css cfv wcel cH chil wss wa cH chil cif wceq cc chil cxp cc cW cU css
      cfv wcel cH chil wss wa cH chil cif cxp wceq csm cc chil cxp cres csm cc
      cW cU css cfv wcel cH chil wss wa cH chil cif cxp cres wceq chil cW cU
      css cfv wcel cH chil wss wa cH chil cif cc xpeq2 cc chil cxp cc cW cU css
      cfv wcel cH chil wss wa cH chil cif cxp csm reseq2 syl opeq12d chil cW cU
      css cfv wcel cH chil wss wa cH chil cif cno reseq2 opeq12d eleq1d chil cW
      cU css cfv wcel cH chil wss wa cH chil cif chil sseq1 anbi12d cva chil
      chil cxp cres csm cc chil cxp cres cop cno chil cres cop cU css cfv wcel
      chil chil wss cva chil chil cxp cres csm cc chil cxp cres cop cno chil
      cres cop cU cU css cfv cva chil chil cxp cres csm cc chil cxp cres cop
      cno chil cres cop cva csm cop cno cop cU cva chil chil cxp cres csm cc
      chil cxp cres cop cva csm cop cno chil cres cno cva chil chil cxp cres
      cva csm cc chil cxp cres csm cva chil chil cxp wfn cva chil chil cxp cres
      cva wceq chil chil cxp chil cva wf cva chil chil cxp wfn ax-hfvadd chil
      chil cxp chil cva ffn ax-mp chil chil cxp cva fnresdm ax-mp csm cc chil
      cxp wfn csm cc chil cxp cres csm wceq cc chil cxp chil csm wf csm cc chil
      cxp wfn ax-hfvmul cc chil cxp chil csm ffn ax-mp cc chil cxp csm fnresdm
      ax-mp opeq12i cno chil wfn cno chil cres cno wceq chil cr cno wf cno chil
      wfn normf chil cr cno ffn ax-mp chil cno fnresdm ax-mp opeq12i hhsst.1
      eqtr4i cU cnv wcel cU cU css cfv wcel cU hhsst.1 hhnv cU cU css cfv cU
      css cfv eqid sspid ax-mp eqeltri chil ssid pm3.2i elimhyp pm3.27i
      hhshsslem2 dedth impbii $.
      $( [11-May-2008] $) $( [25-Mar-2008] $)
  $}

  ${
    $d x y H $.
    hhsssh2.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    $( The predicate " ` H ` is a subspace of Hilbert space." $)
    hhsssh2 $p |- ( H e. SH <-> ( W e. NrmCVec /\ H C_ ~H ) ) $=
      cH csh wcel cW cva csm cop cno cop css cfv wcel cH chil wss wa cW cnv
      wcel cH chil wss wa cva csm cop cno cop cH cW cva csm cop cno cop eqid
      hhsssh2.1 hhsssh cW cva csm cop cno cop css cfv wcel cW cnv wcel cH chil
      wss cW cva csm cop cno cop css cfv wcel cW cnv wcel cva cH cH cxp cres
      cva wss csm cc cH cxp cres csm wss cno cH cres cno wss w3a cva csm cop
      cno cop cnv wcel cW cva csm cop cno cop css cfv wcel cW cnv wcel cva cH
      cH cxp cres cva wss csm cc cH cxp cres csm wss cno cH cres cno wss w3a wa
      wb cva csm cop cno cop cva csm cop cno cop eqid hhnv csm cc cH cxp cres
      csm cva csm cop cno cop cva cH cH cxp cres cva cva csm cop cno cop css
      cfv cno cH cres cno cW cva csm cop cno cop cva csm cop cno cop eqid hhva
      cW cpv cfv cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop cpv
      cfv cva cH cH cxp cres cW cva cH cH cxp cres csm cc cH cxp cres cop cno
      cH cres cop cpv hhsssh2.1 fveq2i cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cop cpv cfv cva cH cH cxp cres csm cc cH cxp cres cop cno
      cH cres cop c1st cfv c1st cfv cva cH cH cxp cres cva cH cH cxp cres csm
      cc cH cxp cres cop cno cH cres cop cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cop cpv cfv cva cH cH cxp cres csm cc cH cxp cres cop cno
      cH cres cop cpv cfv eqid vafval cva cH cH cxp cres csm cc cH cxp cres cop
      cno cH cres cop c1st cfv c1st cfv cva cH cH cxp cres csm cc cH cxp cres
      cop c1st cfv cva cH cH cxp cres cva cH cH cxp cres csm cc cH cxp cres cop
      cno cH cres cop c1st cfv cva cH cH cxp cres csm cc cH cxp cres cop c1st
      cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cva cH cH cxp cres
      csm cc cH cxp cres opex op1st fveq2i cva cH cH cxp cres csm cc cH cxp
      cres cva cabl wcel cva cH cH cxp cres cvv wcel hilabl cva cH cH cxp cabl
      resexg ax-mp op1st eqtri eqtri eqtr2i cva csm cop cno cop cva csm cop cno
      cop eqid hhsm cW cns cfv cva cH cH cxp cres csm cc cH cxp cres cop cno cH
      cres cop cns cfv csm cc cH cxp cres cW cva cH cH cxp cres csm cc cH cxp
      cres cop cno cH cres cop cns hhsssh2.1 fveq2i cva cH cH cxp cres csm cc
      cH cxp cres cop cno cH cres cop cns cfv cva cH cH cxp cres csm cc cH cxp
      cres cop cno cH cres cop c1st cfv c2nd cfv csm cc cH cxp cres cva cH cH
      cxp cres csm cc cH cxp cres cop cno cH cres cop cns cfv cva cH cH cxp
      cres csm cc cH cxp cres cop cno cH cres cop cva cH cH cxp cres csm cc cH
      cxp cres cop cno cH cres cop cns cfv eqid smfval cva cH cH cxp cres csm
      cc cH cxp cres cop cno cH cres cop c1st cfv c2nd cfv cva cH cH cxp cres
      csm cc cH cxp cres cop c2nd cfv csm cc cH cxp cres cva cH cH cxp cres csm
      cc cH cxp cres cop cno cH cres cop c1st cfv cva cH cH cxp cres csm cc cH
      cxp cres cop c2nd cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres
      cva cH cH cxp cres csm cc cH cxp cres opex op1st fveq2i cva cH cH cxp
      cres csm cc cH cxp cres cva cabl wcel cva cH cH cxp cres cvv wcel hilabl
      cva cH cH cxp cabl resexg ax-mp csm cvv wcel csm cc cH cxp cres cvv wcel
      hvmulex csm cc cH cxp cvv resexg ax-mp op2nd eqtri eqtri eqtr2i cva csm
      cop cno cop cva csm cop cno cop eqid hhnm cW cnm cfv cva cH cH cxp cres
      csm cc cH cxp cres cop cno cH cres cop cnm cfv cno cH cres cW cva cH cH
      cxp cres csm cc cH cxp cres cop cno cH cres cop cnm hhsssh2.1 fveq2i cva
      cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop cnm cfv cva cH cH
      cxp cres csm cc cH cxp cres cop cno cH cres cop c2nd cfv cno cH cres cva
      cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop cva cH cH cxp cres
      csm cc cH cxp cres cop cno cH cres cop cnm cfv cva cH cH cxp cres csm cc
      cH cxp cres cop cno cH cres cop cnm cfv eqid nmfval cva cH cH cxp cres
      csm cc cH cxp cres cop cno cH cres cva cH cH cxp cres csm cc cH cxp cres
      opex cno cvv wcel cno cH cres cvv wcel chil cr cno wf chil cvv wcel cno
      cvv wcel normf ax-hilex chil cr cvv cno fex mp2an cno cH cvv resexg ax-mp
      op2nd eqtri eqtr2i cva csm cop cno cop css cfv eqid isssp ax-mp cva cH cH
      cxp cres cva wss csm cc cH cxp cres csm wss cno cH cres cno wss cva cH cH
      cxp resss csm cc cH cxp resss cno cH resss 3pm3.2i mpbiran2 anbi1i bitri
      $.
      $( [27-Jun-2008] $) $( [8-Apr-2008] $)

    ${
      hhssba.2 $e |- H e. SH $.
      $( The base set of a subspace. $)
      hhssba $p |- H = ( BaseSet ` W ) $=
        cva csm cop cno cop cH cW cva csm cop cno cop eqid hhsssh2.1 cH csh
        wcel cW cva csm cop cno cop css cfv wcel hhssba.2 cva csm cop cno cop
        cH cW cva csm cop cno cop eqid hhsssh2.1 hhsst ax-mp cH hhssba.2 shssii
        hhshsslem1 $.
        $( [17-May-2008] $) $( [10-Apr-2008] $)

      $( The vector subtraction operation on a subspace. $)
      hhssvs $p |- ( -h |` ( H X. H ) ) = ( -v ` W ) $=
        cW cnsb cfv cmv cH cH cxp cres cva csm cop cno cop cnv wcel cW cva csm
        cop cno cop css cfv wcel cW cnsb cfv cmv cH cH cxp cres wceq cva csm
        cop cno cop cva csm cop cno cop eqid hhnv cH csh wcel cW cva csm cop
        cno cop css cfv wcel hhssba.2 cva csm cop cno cop cH cW cva csm cop cno
        cop eqid hhsssh2.1 hhsst ax-mp cva csm cop cno cop cva csm cop cno cop
        css cfv cW cnsb cfv cmv cW cH cH cW hhsssh2.1 hhssba.2 hhssba cva csm
        cop cno cop cva csm cop cno cop eqid hhvs cW cnsb cfv eqid cva csm cop
        cno cop css cfv eqid sspm mp2an eqcomi $.
        $( [18-May-2008] $) $( [10-Apr-2008] $)

      $( Mapping of the vector subtraction operation on a subspace. $)
      hhssvsf $p |- ( -h |` ( H X. H ) ) : ( H X. H ) --> H $=
        cW cnv wcel cH cH cxp cH cmv cH cH cxp cres wf cH cW hhsssh2.1 hhssba.2
        hhssnv cW cmv cH cH cxp cres cH cH cW hhsssh2.1 hhssba.2 hhssba cH cW
        hhsssh2.1 hhssba.2 hhssvs nvmf ax-mp $.
        $( [31-May-2008] $) $( [10-Apr-2008] $)

      $( Inner product space property of a subspace. $)
      hhssph $p |- W e. CPreHil $=
        cva csm cop cno cop cphl wcel cW cva csm cop cno cop css cfv wcel cW
        cphl wcel cva csm cop cno cop cva csm cop cno cop eqid hhph cH csh wcel
        cW cva csm cop cno cop css cfv wcel hhssba.2 cva csm cop cno cop cH cW
        cva csm cop cno cop eqid hhsssh2.1 hhsst ax-mp cva csm cop cno cop cva
        csm cop cno cop css cfv cW cva csm cop cno cop css cfv eqid sspph mp2an
        $.
        $( [5-Jun-2008] $) $( [10-Apr-2008] $)
    $}

    ${
      hhssims.2 $e |- H e. SH $.
      hhssims.3 $e |- D = ( ( normh o. -h ) |` ( H X. H ) ) $.
      $( Induced metric of a subspace. $)
      hhssims $p |- D = ( IndMet ` W ) $=
        cno cmv ccom cH cH cxp cres cno cH cres cmv cH cH cxp cres ccom cD cW
        cims cfv cno cmv ccom cH cH cxp cres cno cmv cH cH cxp cres ccom cno cH
        cres cmv cH cH cxp cres ccom cno cmv cH cH cxp resco cmv cH cH cxp cres
        crn cH wss cno cH cres cmv cH cH cxp cres ccom cno cmv cH cH cxp cres
        ccom wceq cH cH cxp cH cmv cH cH cxp cres wf cmv cH cH cxp cres crn cH
        wss cH cW hhsssh2.1 hhssims.2 hhssvsf cH cH cxp cH cmv cH cH cxp cres
        frn ax-mp cno cmv cH cH cxp cres cH cores ax-mp eqtr4i hhssims.3 cW cnv
        wcel cW cims cfv cno cH cres cmv cH cH cxp cres ccom wceq cH cW
        hhsssh2.1 hhssims.2 hhssnv cW cims cfv cW cmv cH cH cxp cres cno cH
        cres cH cW hhsssh2.1 hhssims.2 hhssvs cH cW hhsssh2.1 hhssnm cW cims
        cfv eqid imsval ax-mp 3eqtr4i $.
        $( [27-Jun-2008] $) $( [10-Apr-2008] $)
    $}
  $}

  ${
    hhssims2.1 $e |- W =
   <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. , ( normh |` H ) >. $.
    hhssims2.3 $e |- D = ( IndMet ` W ) $.
    ${
      hhssims2.2 $e |- H e. SH $.
      $( Induced metric of a subspace. $)
      hhssims2 $p |- D = ( ( normh o. -h ) |` ( H X. H ) ) $=
        cD cW cims cfv cno cmv ccom cH cH cxp cres hhssims2.3 cno cmv ccom cH
        cH cxp cres cH cW hhssims2.1 hhssims2.2 cno cmv ccom cH cH cxp cres
        eqid hhssims eqtr4i $.
        $( [29-Jun-2008] $) $( [10-Apr-2008] $)

      $( Induced metric of a subspace. $)
      hhssmet $p |- D e. Met $=
        cW cnv wcel cD cme wcel cH cW hhssims2.1 hhssims2.2 hhssnv cD cW
        hhssims2.3 imsmet ax-mp $.
        $( [26-May-2008] $) $( [10-Apr-2008] $)

      $( The base set for the metric of a subspace. $)
      hhssmetba $p |- H = dom dom D $=
        cD cW cH cH cW hhssims2.1 hhssims2.2 hhssba hhssims2.3 cH cW hhssims2.1
        hhssims2.2 hhssnv imsbai $.
        $( [27-May-2008] $) $( [10-Apr-2008] $)

      $( Value of the distance function of the metric space of a subspace. $)
      hhssmetdval $p |- ( ( A e. H /\ B e. H )
         -> ( A D B ) = ( normh ` ( A -h B ) ) ) $=
        cA cH wcel cB cH wcel wa cA cB cD co cA cB cmv cH cH cxp cres co cno cH
        cres cfv cA cB cmv co cno cH cres cfv cA cB cmv co cno cfv cW cnv wcel
        cA cH wcel cB cH wcel cA cB cD co cA cB cmv cH cH cxp cres co cno cH
        cres cfv wceq cH cW hhssims2.1 hhssims2.2 hhssnv cA cB cD cW cmv cH cH
        cxp cres cno cH cres cH cH cW hhssims2.1 hhssims2.2 hhssba cH cW
        hhssims2.1 hhssims2.2 hhssvs cH cW hhssims2.1 hhssnm hhssims2.3 imsdval
        mp3an1 cA cH wcel cB cH wcel wa cA cB cmv cH cH cxp cres co cA cB cmv
        co cno cH cres cA cB cH cH cmv oprvres fveq2d cA cH wcel cB cH wcel wa
        cA cB cmv co cH wcel cA cB cmv co cno cH cres cfv cA cB cmv co cno cfv
        wceq cH csh wcel cA cH wcel cB cH wcel cA cB cmv co cH wcel hhssims2.2
        cA cB cH shsubcl mp3an1 cA cB cmv co cH cno fvres syl 3eqtrd $.
        $( [27-May-2008] $) $( [10-Apr-2008] $)
    $}

    ${
      $d f j k x y D $.  $d f j k x y H $.
      hhsscms.3 $e |- H e. CH $.
      $( The induced metric of a closed subspace is complete. $)
      hhsscms $p |- D e. CMet $=
        vx cD vf cH cD cH cW hhssims2.1 hhssims2.3 cH hhsscms.3 chshii
        hhssmetba cD cH cW hhssims2.1 hhssims2.3 cH hhsscms.3 chshii hhssmet cn
        cH vf cv wf vf cv vx cv chli wbr vx cH wrex vf cv vx cv cD clm cfv wbr
        vx cH wrex vf cv cD cca cfv wcel cn cH vf cv wf wa cn cH vf cv wf vf cv
        vx cv chli wbr vf cv vx cv cD clm cfv wbr vx cH cn cH vf cv wf vx cv cH
        wcel wa vf cv vx cv cD clm cfv wbr cc0 vy cv clt wbr vj cv vk cv cle
        wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr wi vk cn wral vj
        cn wrex wi vy cr wral vf cv vx cv chli wbr cn cH vf cv wf vx cv cH wcel
        wa vf cv vx cv cD clm cfv wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk
        cv vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi vy
        cr wral cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vx cv cmv
        co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral vx cv
        cH wcel cn cH vf cv wf vf cv vx cv cD clm cfv wbr cc0 vy cv clt wbr vj
        cv vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv clt wbr wi vk cn
        wral vj cn wrex wi vy cr wral wb cD cme wcel vx cv cH wcel cn cH vf cv
        wf vf cv vx cv cD clm cfv wbr cc0 vy cv clt wbr vj cv vk cv cle wbr vk
        cv vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi vy
        cr wral wb cD cH cW hhssims2.1 hhssims2.3 cH hhsscms.3 chshii hhssmet
        vy cD vx cv vj vk vf cv c1 cH cn cD cH cW hhssims2.1 hhssims2.3 cH
        hhsscms.3 chshii hhssmetba 1z nnuz lmbrf2 mp3an1 ancoms cn cH vf cv wf
        vx cv cH wcel wa cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv
        vx cv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi cc0 vy cv clt wbr
        vj cv vk cv cle wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr
        wi vk cn wral vj cn wrex wi vy cr cn cH vf cv wf vx cv cH wcel wa vj cv
        vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv clt wbr wi vk cn wral
        vj cn wrex vj cv vk cv cle wbr vk cv vf cv cfv vx cv cmv co cno cfv vy
        cv clt wbr wi vk cn wral vj cn wrex cc0 vy cv clt wbr cn cH vf cv wf vx
        cv cH wcel wa vj cv vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv clt
        wbr wi vk cn wral vj cv vk cv cle wbr vk cv vf cv cfv vx cv cmv co cno
        cfv vy cv clt wbr wi vk cn wral vj cn cn cH vf cv wf vx cv cH wcel wa
        vj cv vk cv cle wbr vk cv vf cv cfv vx cv cD co vy cv clt wbr wi vj cv
        vk cv cle wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt wbr wi vk
        cn cn cH vf cv wf vx cv cH wcel wa vk cv cn wcel wa vk cv vf cv cfv vx
        cv cD co vy cv clt wbr vk cv vf cv cfv vx cv cmv co cno cfv vy cv clt
        wbr vj cv vk cv cle wbr cn cH vf cv wf vx cv cH wcel wa vk cv cn wcel
        wa vk cv vf cv cfv vx cv cD co vk cv vf cv cfv vx cv cmv co cno cfv vy
        cv clt vk cv vf cv cfv cH wcel vx cv cH wcel vk cv vf cv cfv vx cv cD
        co vk cv vf cv cfv vx cv cmv co cno cfv wceq cn cH vf cv wf vx cv cH
        wcel wa vk cv cn wcel wa vk cv vf cv cfv vx cv cD cH cW hhssims2.1
        hhssims2.3 cH hhsscms.3 chshii hhssmetdval cn cH vf cv wf vk cv cn wcel
        vk cv vf cv cfv cH wcel vx cv cH wcel cn cH vk cv vf cv ffvelrn adantlr
        cn cH vf cv wf vx cv cH wcel vk cv cn wcel simplr sylanc breq1d imbi2d
        ralbidva rexbidv imbi2d ralbidv bitrd vy vj vk vx cv vf cv vf visset vx
        visset hlimconvi syl5bir r19.22dva vf cv cD cca cfv wcel cn cH vf cv wf
        pm3.27 cn cH vf cv wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv
        cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn
        wrex wi vy cr wral vf cv vx cv chli wbr vx cH wrex vf cv cD cca cfv
        wcel cn cH vf cv wf wa vf cv ccau wcel cn cH vf cv wf vf cv vx cv chli
        wbr vx cH wrex cn cH vf cv wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk
        cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral
        vj cn wrex wi vy cr wral wa cH cch wcel vf cv ccau wcel cn cH vf cv wf
        vf cv vx cv chli wbr vx cH wrex hhsscms.3 vx vf cv cH chcompl mp3an1 cn
        chil vf cv wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vj
        cv vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex wi
        vy cr wral vf cv ccau wcel cn cH vf cv wf vf cv ccau wcel cn chil vf cv
        wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv
        cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral
        wa vy vj vk vf cv hcau2 biimpri cn cH vf cv wf cH chil wss cn chil vf
        cv wf cH hhsscms.3 chssii cn cH chil vf cv fss mpan2 sylan cn cH vf cv
        wf cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv
        cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr wral
        pm3.26 sylanc vf cv cD cca cfv wcel cn cH vf cv wf pm3.27 cn cH vf cv
        wf vf cv cD cca cfv wcel cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv vf
        cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj cn
        wrex wi vy cr wral cn cH vf cv wf vf cv cD cca cfv wcel cc0 vy cv clt
        wbr vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt
        wbr wi vk cn wral vj cn wrex wi vy cr wral cc0 vy cv clt wbr vj cv vk
        cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr
        wi vk cn wral vj cn wrex wi vy cr wral cD cme wcel cn cH vf cv wf vf cv
        cD cca cfv wcel cc0 vy cv clt wbr vj cv vk cv cle wbr vj cv vf cv cfv
        vk cv vf cv cfv cD co vy cv clt wbr wi vk cn wral vj cn wrex wi vy cr
        wral wb cD cH cW hhssims2.1 hhssims2.3 cH hhsscms.3 chshii hhssmet vy
        cD vj vk vf cv c1 cH cn cD cH cW hhssims2.1 hhssims2.3 cH hhsscms.3
        chshii hhssmetba 1z nnuz iscauf mpan cn cH vf cv wf cc0 vy cv clt wbr
        vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt wbr
        wi vk cn wral vj cn wrex wi cc0 vy cv clt wbr vj cv vk cv cle wbr vk cv
        vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr wi vk cn wral vj
        cn wrex wi vy cr cn cH vf cv wf vj cv vk cv cle wbr vj cv vf cv cfv vk
        cv vf cv cfv cD co vy cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv
        cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr wi
        vk cn wral vj cn wrex cc0 vy cv clt wbr cn cH vf cv wf vj cv vk cv cle
        wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt wbr wi vk cn wral
        vj cv vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy
        cv clt wbr wi vk cn wral vj cn cn cH vf cv wf vj cv cn wcel wa vj cv vk
        cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cD co vy cv clt wbr wi vj cv
        vk cv cle wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt
        wbr wi vk cn cn cH vf cv wf vj cv cn wcel wa vk cv cn wcel wa vj cv vf
        cv cfv vk cv vf cv cfv cD co vy cv clt wbr vk cv vf cv cfv vj cv vf cv
        cfv cmv co cno cfv vy cv clt wbr vj cv vk cv cle wbr vj cv vf cv cfv cH
        wcel vk cv vf cv cfv cH wcel vj cv vf cv cfv vk cv vf cv cfv cD co vy
        cv clt wbr vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt wbr
        wb cn cH vf cv wf vj cv cn wcel wa vk cv cn wcel wa vj cv vf cv cfv cH
        wcel vk cv vf cv cfv cH wcel wa vj cv vf cv cfv vk cv vf cv cfv cD co
        vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv vy cv clt vj cv vf cv
        cfv cH wcel vk cv vf cv cfv cH wcel wa vj cv vf cv cfv vk cv vf cv cfv
        cD co vj cv vf cv cfv vk cv vf cv cfv cmv co cno cfv vk cv vf cv cfv vj
        cv vf cv cfv cmv co cno cfv vj cv vf cv cfv vk cv vf cv cfv cD cH cW
        hhssims2.1 hhssims2.3 cH hhsscms.3 chshii hhssmetdval vj cv vf cv cfv
        chil wcel vk cv vf cv cfv chil wcel vj cv vf cv cfv vk cv vf cv cfv cmv
        co cno cfv vk cv vf cv cfv vj cv vf cv cfv cmv co cno cfv wceq vj cv vf
        cv cfv cH wcel vk cv vf cv cfv cH wcel vj cv vf cv cfv vk cv vf cv cfv
        normsub vj cv vf cv cfv cH hhsscms.3 cheli vk cv vf cv cfv cH hhsscms.3
        cheli syl2an eqtrd breq1d cn cH vf cv wf vj cv cn wcel wa vj cv vf cv
        cfv cH wcel vk cv cn wcel cn cH vj cv vf cv ffvelrn adantr cn cH vf cv
        wf vk cv cn wcel vk cv vf cv cfv cH wcel vj cv cn wcel cn cH vk cv vf
        cv ffvelrn adantlr sylanc imbi2d ralbidva rexbidva imbi2d ralbidv bitrd
        biimpac sylanc sylc iscms2i $.
        $( [28-May-2008] $) $( [10-Apr-2008] $)
    $}
  $}

  ${
    hhssbn.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    hhssbn.2 $e |- H e. CH $.
    $( Banach space property of a closed subspace. $)
    hhssbn $p |- W e. CBan $=
      cW cbn wcel cW cnv wcel cW cims cfv cms wcel cW cims cfv cW cW cims cfv
      eqid isbn cH cW hhssbn.1 cH hhssbn.2 chshii hhssnv cW cims cfv cH cW
      hhssbn.1 cW cims cfv eqid hhssbn.2 hhsscms mpbir2an $.
      $( [3-Jun-2008] $) $( [10-Apr-2008] $)

    $( Hilbert space property of a closed subspace. $)
    hhsshl $p |- W e. CHil $=
      cW chl wcel cW cbn wcel cW cphl wcel cW ishl cH cW hhssbn.1 hhssbn.2
      hhssbn cH cW hhssbn.1 cH hhssbn.2 chshii hhssph mpbir2an $.
      $( [30-Jun-2008] $) $( [10-Apr-2008] $)
  $}

  ${
    $d x y z w H $.  $d x y z w A $.  $d x y B $.
    $( Value of orthogonal complement of a subset of Hilbert space. $)
    ocval $p |- ( H C_ ~H -> ( _|_ ` H ) =
        { x e. ~H | A. y e. H ( x .ih y ) = 0 } ) $=
      cH chil wss cH chil cpw wcel cH cort cfv vx cv vy cv csp co cc0 wceq vy
      cH wral vx chil crab wceq cH chil ax-hilex elpw2 vz vw cH vx cv vy cv csp
      co cc0 wceq vy vz cv wral vx chil crab vx cv vy cv csp co cc0 wceq vy cH
      wral vx chil crab chil cpw cort vz cv cH wceq vx cv vy cv csp co cc0 wceq
      vy vz cv wral vx cv vy cv csp co cc0 wceq vy cH wral vx chil vx cv vy cv
      csp co cc0 wceq vy vz cv cH raleq1 rabbisdv cort vz cv chil wss vw cv vx
      cv vy cv csp co cc0 wceq vy vz cv wral vx chil crab wceq wa vz vw copab
      vz cv chil cpw wcel vw cv vx cv vy cv csp co cc0 wceq vy vz cv wral vx
      chil crab wceq wa vz vw copab vz vw vx vy df-oc vz cv chil cpw wcel vw cv
      vx cv vy cv csp co cc0 wceq vy vz cv wral vx chil crab wceq wa vz cv chil
      wss vw cv vx cv vy cv csp co cc0 wceq vy vz cv wral vx chil crab wceq wa
      vz vw vz cv chil cpw wcel vz cv chil wss vw cv vx cv vy cv csp co cc0
      wceq vy vz cv wral vx chil crab wceq vz cv chil ax-hilex elpw2 anbi1i
      opabbii eqtr4i vx cv vy cv csp co cc0 wceq vy cH wral vx chil ax-hilex
      rabex fvopab4 sylbir $.
      $( [7-Aug-2000] $)

    $( Membership in orthogonal complement of H subset. $)
    ocel $p |- ( H C_ ~H -> ( A e. ( _|_ ` H ) <-> ( A e. ~H /\
                  A. x e. H ( A .ih x ) = 0 ) ) ) $=
      cH chil wss cA cH cort cfv wcel cA vy cv vx cv csp co cc0 wceq vx cH wral
      vy chil crab wcel cA chil wcel cA vx cv csp co cc0 wceq vx cH wral wa cH
      chil wss cH cort cfv vy cv vx cv csp co cc0 wceq vx cH wral vy chil crab
      cA vy vx cH ocval eleq2d vy cv vx cv csp co cc0 wceq vx cH wral cA vx cv
      csp co cc0 wceq vx cH wral vy cA chil vy cv cA wceq vy cv vx cv csp co
      cc0 wceq cA vx cv csp co cc0 wceq vx cH vy cv cA wceq vy cv vx cv csp co
      cA vx cv csp co cc0 vy cv cA vx cv csp opreq1 eqeq1d ralbidv elrab syl6bb
      $.
      $( [7-Aug-2000] $)

    $( Membership in orthogonal complement of H subspace. $)
    shocel $p |- ( H e. SH -> ( A e. ( _|_ ` H ) <-> ( A e. ~H /\
                  A. x e. H ( A .ih x ) = 0 ) ) ) $=
      cH csh wcel cH chil wss cA cH cort cfv wcel cA chil wcel cA vx cv csp co
      cc0 wceq vx cH wral wa wb cH shss vx cA cH ocel syl $.
      $( [9-Oct-1999] $)

    $( The orthogonal complement of a subspace is a subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    ocsh $p |- ( A C_ ~H -> ( _|_ ` A ) e. SH ) $=
      cA chil wss cA cort cfv chil wss c0v cA cort cfv wcel wa vx cv vy cv cva
      co cA cort cfv wcel vy cA cort cfv wral vx cA cort cfv wral vx cv vy cv
      csm co cA cort cfv wcel vy cA cort cfv wral vx cc wral wa wa cA cort cfv
      csh wcel cA chil wss cA cort cfv chil wss c0v cA cort cfv wcel wa vx cv
      vy cv cva co cA cort cfv wcel vy cA cort cfv wral vx cA cort cfv wral vx
      cv vy cv csm co cA cort cfv wcel vy cA cort cfv wral vx cc wral wa cA
      chil wss cA cort cfv chil wss c0v cA cort cfv wcel cA chil wss cA cort
      cfv chil wss vx cv vy cv csp co cc0 wceq vy cA wral vx chil crab chil wss
      vx cv vy cv csp co cc0 wceq vy cA wral vx chil ssrab2 cA chil wss cA cort
      cfv vx cv vy cv csp co cc0 wceq vy cA wral vx chil crab chil vx vy cA
      ocval sseq1d mpbiri cA chil wss c0v cA cort cfv wcel c0v chil wcel c0v vy
      cv csp co cc0 wceq vy cA wral wa cA chil wss c0v vy cv csp co cc0 wceq vy
      cA wral c0v chil wcel cA chil wss c0v vy cv csp co cc0 wceq vy cA cA chil
      wss vy cv cA wcel vy cv chil wcel c0v vy cv csp co cc0 wceq cA chil vy cv
      ssel vy cv hi01 syl6 r19.21aiv ax-hv0cl jctil vy c0v cA ocel mpbird jca
      cA chil wss vx cv vy cv cva co cA cort cfv wcel vy cA cort cfv wral vx cA
      cort cfv wral vx cv vy cv csm co cA cort cfv wcel vy cA cort cfv wral vx
      cc wral cA chil wss vx cv vy cv cva co cA cort cfv wcel vy cA cort cfv
      wral vx cA cort cfv cA chil wss vx cv cA cort cfv wcel vx cv vy cv cva co
      cA cort cfv wcel vy cA cort cfv cA chil wss vx cv cA cort cfv wcel vy cv
      cA cort cfv wcel vx cv vy cv cva co cA cort cfv wcel cA chil wss vx cv
      chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv vz cv csp
      co cc0 wceq wa vz cA wral wa vx cv vy cv cva co chil wcel vx cv vy cv cva
      co vz cv csp co cc0 wceq vz cA wral wa vx cv cA cort cfv wcel vy cv cA
      cort cfv wcel wa vx cv vy cv cva co cA cort cfv wcel cA chil wss vx cv
      chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv vz cv csp
      co cc0 wceq wa vz cA wral wa vx cv chil wcel vy cv chil wcel wa vx cv vy
      cv cva co vz cv csp co cc0 wceq vz cA wral wa vx cv vy cv cva co chil
      wcel vx cv vy cv cva co vz cv csp co cc0 wceq vz cA wral wa cA chil wss
      vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv vz
      cv csp co cc0 wceq wa vz cA wral vx cv vy cv cva co vz cv csp co cc0 wceq
      vz cA wral cA chil wss vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp
      co cc0 wceq vy cv vz cv csp co cc0 wceq wa vz cA wral vx cv vy cv cva co
      vz cv csp co cc0 wceq vz cA wral wi cA chil wss vx cv chil wcel vy cv
      chil wcel wa wa vx cv vz cv csp co cc0 wceq vy cv vz cv csp co cc0 wceq
      wa vx cv vy cv cva co vz cv csp co cc0 wceq vz cA cA chil wss vz cv cA
      wcel vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv
      vz cv csp co cc0 wceq wa vx cv vy cv cva co vz cv csp co cc0 wceq wi vz
      cv chil wcel vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0
      wceq vy cv vz cv csp co cc0 wceq wa vx cv vy cv cva co vz cv csp co cc0
      wceq wi cA chil wss vz cv cA wcel wa vx cv chil wcel vy cv chil wcel wa
      vz cv chil wcel vx cv vz cv csp co cc0 wceq vy cv vz cv csp co cc0 wceq
      wa vx cv vy cv cva co vz cv csp co cc0 wceq wi vx cv chil wcel vy cv chil
      wcel wa vz cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv vz cv csp co
      cc0 wceq wa vx cv vy cv cva co vz cv csp co cc0 wceq vx cv chil wcel vy
      cv chil wcel wa vz cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv vz
      cv csp co cc0 wceq wa vx cv vy cv cva co vz cv csp co vx cv vz cv csp co
      vy cv vz cv csp co caddc co cc0 vx cv chil wcel vy cv chil wcel vz cv
      chil wcel vx cv vy cv cva co vz cv csp co vx cv vz cv csp co vy cv vz cv
      csp co caddc co wceq vx cv vy cv vz cv ax-his2 3expa vx cv vz cv csp co
      cc0 wceq vy cv vz cv csp co cc0 wceq wa vx cv vz cv csp co vy cv vz cv
      csp co caddc co cc0 cc0 caddc co cc0 vx cv vz cv csp co cc0 vy cv vz cv
      csp co cc0 caddc opreq12 cc0 0cn addid1i syl6eq sylan9eq ex ancoms cA
      chil vz cv ssel2 sylan an1rs r19.20dva ex imdistand vx cv chil wcel vy cv
      chil wcel wa vx cv vy cv cva co chil wcel vx cv vy cv cva co vz cv csp co
      cc0 wceq vz cA wral vx cv vy cv hvaddcl anim1i syl6 cA chil wss vx cv cA
      cort cfv wcel vy cv cA cort cfv wcel wa vx cv chil wcel vx cv vz cv csp
      co cc0 wceq vz cA wral wa vy cv chil wcel vy cv vz cv csp co cc0 wceq vz
      cA wral wa wa vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0
      wceq vy cv vz cv csp co cc0 wceq wa vz cA wral wa cA chil wss vx cv cA
      cort cfv wcel vx cv chil wcel vx cv vz cv csp co cc0 wceq vz cA wral wa
      vy cv cA cort cfv wcel vy cv chil wcel vy cv vz cv csp co cc0 wceq vz cA
      wral wa vz vx cv cA ocel vz vy cv cA ocel anbi12d vx cv chil wcel vx cv
      vz cv csp co cc0 wceq vz cA wral wa vy cv chil wcel vy cv vz cv csp co
      cc0 wceq vz cA wral wa wa vx cv chil wcel vy cv chil wcel wa vx cv vz cv
      csp co cc0 wceq vz cA wral vy cv vz cv csp co cc0 wceq vz cA wral wa wa
      vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0 wceq vy cv vz
      cv csp co cc0 wceq wa vz cA wral wa vx cv chil wcel vx cv vz cv csp co
      cc0 wceq vz cA wral vy cv chil wcel vy cv vz cv csp co cc0 wceq vz cA
      wral an4 vx cv vz cv csp co cc0 wceq vy cv vz cv csp co cc0 wceq wa vz cA
      wral vx cv vz cv csp co cc0 wceq vz cA wral vy cv vz cv csp co cc0 wceq
      vz cA wral wa vx cv chil wcel vy cv chil wcel wa vx cv vz cv csp co cc0
      wceq vy cv vz cv csp co cc0 wceq vz cA r19.26 anbi2i bitr4i syl6bb vz vx
      cv vy cv cva co cA ocel 3imtr4d exp3a r19.21adv r19.21aiv cA chil wss vx
      cv vy cv csm co cA cort cfv wcel vy cA cort cfv wral vx cc cA chil wss vx
      cv cc wcel vx cv vy cv csm co cA cort cfv wcel vy cA cort cfv cA chil wss
      vx cv cc wcel vy cv cA cort cfv wcel vx cv vy cv csm co cA cort cfv wcel
      cA chil wss vx cv cc wcel vy cv chil wcel wa vy cv vz cv csp co cc0 wceq
      vz cA wral wa vx cv vy cv csm co chil wcel vx cv vy cv csm co vz cv csp
      co cc0 wceq vz cA wral wa vx cv cc wcel vy cv cA cort cfv wcel wa vx cv
      vy cv csm co cA cort cfv wcel cA chil wss vx cv cc wcel vy cv chil wcel
      wa vy cv vz cv csp co cc0 wceq vz cA wral wa vx cv cc wcel vy cv chil
      wcel wa vx cv vy cv csm co vz cv csp co cc0 wceq vz cA wral wa vx cv vy
      cv csm co chil wcel vx cv vy cv csm co vz cv csp co cc0 wceq vz cA wral
      wa cA chil wss vx cv cc wcel vy cv chil wcel wa vy cv vz cv csp co cc0
      wceq vz cA wral vx cv vy cv csm co vz cv csp co cc0 wceq vz cA wral cA
      chil wss vx cv cc wcel vy cv chil wcel wa vy cv vz cv csp co cc0 wceq vz
      cA wral vx cv vy cv csm co vz cv csp co cc0 wceq vz cA wral wi cA chil
      wss vx cv cc wcel vy cv chil wcel wa wa vy cv vz cv csp co cc0 wceq vx cv
      vy cv csm co vz cv csp co cc0 wceq vz cA cA chil wss vz cv cA wcel vx cv
      cc wcel vy cv chil wcel wa vy cv vz cv csp co cc0 wceq vx cv vy cv csm co
      vz cv csp co cc0 wceq wi vz cv chil wcel vx cv cc wcel vy cv chil wcel wa
      vy cv vz cv csp co cc0 wceq vx cv vy cv csm co vz cv csp co cc0 wceq wi
      cA chil wss vz cv cA wcel wa vz cv chil wcel vx cv cc wcel vy cv chil
      wcel wa wa vy cv vz cv csp co cc0 wceq vx cv vy cv vz cv csp co cmul co
      cc0 wceq vx cv vy cv csm co vz cv csp co cc0 wceq vx cv cc wcel vy cv vz
      cv csp co cc0 wceq vx cv vy cv vz cv csp co cmul co cc0 wceq wi vz cv
      chil wcel vy cv chil wcel vy cv vz cv csp co cc0 wceq vx cv vy cv vz cv
      csp co cmul co cc0 wceq vx cv cc0 cmul co cc0 wceq vx cv cc wcel vy cv vz
      cv csp co cc0 wceq vx cv vy cv vz cv csp co cmul co vx cv cc0 cmul co cc0
      vy cv vz cv csp co cc0 vx cv cmul opreq2 eqeq1d vx cv mul01 syl5cbir
      ad2antrl vx cv cc wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv csm
      co vz cv csp co cc0 wceq vx cv vy cv vz cv csp co cmul co cc0 wceq wb vx
      cv cc wcel vy cv chil wcel vz cv chil wcel vx cv vy cv csm co vz cv csp
      co cc0 wceq vx cv vy cv vz cv csp co cmul co cc0 wceq wb vx cv cc wcel vy
      cv chil wcel vz cv chil wcel w3a vx cv vy cv csm co vz cv csp co vx cv vy
      cv vz cv csp co cmul co cc0 vx cv vy cv vz cv ax-his3 eqeq1d 3expa ancoms
      sylibrd cA chil vz cv ssel2 sylan an1rs r19.20dva ex imdistand vx cv cc
      wcel vy cv chil wcel wa vx cv vy cv csm co chil wcel vx cv vy cv csm co
      vz cv csp co cc0 wceq vz cA wral vx cv vy cv hvmulcl anim1i syl6 cA chil
      wss vx cv cc wcel vy cv cA cort cfv wcel wa vx cv cc wcel vy cv chil wcel
      vy cv vz cv csp co cc0 wceq vz cA wral wa wa vx cv cc wcel vy cv chil
      wcel wa vy cv vz cv csp co cc0 wceq vz cA wral wa cA chil wss vy cv cA
      cort cfv wcel vy cv chil wcel vy cv vz cv csp co cc0 wceq vz cA wral wa
      vx cv cc wcel vz vy cv cA ocel anbi2d vx cv cc wcel vy cv chil wcel vy cv
      vz cv csp co cc0 wceq vz cA wral anass syl6bbr vz vx cv vy cv csm co cA
      ocel 3imtr4d exp3a r19.21adv r19.21aiv jca jca vx vy cA cort cfv sh
      sylibr $.
      $( [7-Aug-2000] $)

    $( The orthogonal complement of a subspace is a subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    shocsh $p |- ( A e. SH -> ( _|_ ` A ) e. SH ) $=
      cA csh wcel cA chil wss cA cort cfv csh wcel cA shss cA ocsh syl $.
      $( [10-Oct-1999] $)

    $( An orthogonal complement is a subset of Hilbert space. $)
    ocss $p |- ( A C_ ~H -> ( _|_ ` A ) C_ ~H ) $=
      cA chil wss cA cort cfv csh wcel cA cort cfv chil wss cA ocsh cA cort cfv
      shss syl $.
      $( [9-Aug-2000] $)

    $( An orthogonal complement is a subset of Hilbert space. $)
    shocss $p |- ( A e. SH -> ( _|_ ` A ) C_ ~H ) $=
      cA csh wcel cA chil wss cA cort cfv chil wss cA shss cA ocss syl $.
      $( [11-Oct-1999] $)

    $( Contraposition law for orthogonal complement. $)
    occon $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
                 ( A C_ B -> ( _|_ ` B ) C_ ( _|_ ` A ) ) ) $=
      cA chil wss cB chil wss wa cA cB wss cB cort cfv cA cort cfv wss cA chil
      wss cB chil wss wa cA cB wss wa vx cv vy cv csp co cc0 wceq vy cB wral vx
      chil crab vx cv vy cv csp co cc0 wceq vy cA wral vx chil crab cB cort cfv
      cA cort cfv cA cB wss vx cv vy cv csp co cc0 wceq vy cB wral vx chil crab
      vx cv vy cv csp co cc0 wceq vy cA wral vx chil crab wss cA chil wss cB
      chil wss wa cA cB wss vx cv vy cv csp co cc0 wceq vy cB wral vx cv vy cv
      csp co cc0 wceq vy cA wral wi vx chil wral vx cv vy cv csp co cc0 wceq vy
      cB wral vx chil crab vx cv vy cv csp co cc0 wceq vy cA wral vx chil crab
      wss cA cB wss vx cv vy cv csp co cc0 wceq vy cB wral vx cv vy cv csp co
      cc0 wceq vy cA wral wi vx chil cA cB wss vx cv vy cv csp co cc0 wceq vy
      cB wral vx cv vy cv csp co cc0 wceq vy cA wral wi vx cv chil wcel cA cB
      wss vy cv cB wcel vx cv vy cv csp co cc0 wceq wi vy wal vy cv cA wcel vx
      cv vy cv csp co cc0 wceq wi vy wal vx cv vy cv csp co cc0 wceq vy cB wral
      vx cv vy cv csp co cc0 wceq vy cA wral cA cB wss vy cv cB wcel vx cv vy
      cv csp co cc0 wceq wi vy cv cA wcel vx cv vy cv csp co cc0 wceq wi vy cA
      cB wss vy cv cA wcel vy cv cB wcel vx cv vy cv csp co cc0 wceq cA cB vy
      cv ssel imim1d 19.20dv vx cv vy cv csp co cc0 wceq vy cB df-ral vx cv vy
      cv csp co cc0 wceq vy cA df-ral 3imtr4g a1d r19.21aiv vx cv vy cv csp co
      cc0 wceq vy cB wral vx cv vy cv csp co cc0 wceq vy cA wral vx chil ss2rab
      sylibr adantl cB chil wss cB cort cfv vx cv vy cv csp co cc0 wceq vy cB
      wral vx chil crab wceq cA chil wss cA cB wss vx vy cB ocval ad2antlr cA
      chil wss cA cort cfv vx cv vy cv csp co cc0 wceq vy cA wral vx chil crab
      wceq cB chil wss cA cB wss vx vy cA ocval ad2antrr 3sstr4d ex $.
      $( [8-Aug-2000] $)

    $( Double contraposition for orthogonal complement. $)
    occon2 $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
              ( A C_ B -> ( _|_ ` ( _|_ ` A ) ) C_ ( _|_ ` ( _|_ ` B ) ) ) ) $=
      cA chil wss cB chil wss wa cA cB wss cB cort cfv cA cort cfv wss cA cort
      cfv cort cfv cB cort cfv cort cfv wss cA cB occon cA chil wss cB chil wss
      wa cB cort cfv chil wss cA cort cfv chil wss wa cB cort cfv cA cort cfv
      wss cA cort cfv cort cfv cB cort cfv cort cfv wss wi cB chil wss cA chil
      wss cB cort cfv chil wss cA cort cfv chil wss wa cB chil wss cB cort cfv
      chil wss cA chil wss cA cort cfv chil wss cB ocss cA ocss anim12i ancoms
      cB cort cfv cA cort cfv occon syl syld $.
      $( [22-Jul-2001] $)

    ${
      occon2.1 $e |- A C_ ~H $.
      occon2.2 $e |- B C_ ~H $.
      $( Double contraposition for orthogonal complement. $)
      occon2i $p |- ( A C_ B ->
                   ( _|_ ` ( _|_ ` A ) ) C_ ( _|_ ` ( _|_ ` B ) ) ) $=
        cA chil wss cB chil wss cA cB wss cA cort cfv cort cfv cB cort cfv cort
        cfv wss wi occon2.1 occon2.2 cA cB occon2 mp2an $.
        $( [9-Aug-2000] $)
    $}

    $( The zero vector belongs to an orthogonal complement of a Hilbert
       subspace. $)
    oc0 $p |- ( H e. SH -> 0h e. ( _|_ ` H ) ) $=
      cH csh wcel cH cort cfv csh wcel c0v cH cort cfv wcel cH shocsh cH cort
      cfv sh0 syl $.
      $( [11-Oct-1999] $)

    $( Members of a subset and its complement are orthogonal. $)
    ocorth $p |- ( H C_ ~H -> ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
                 ( A .ih B ) = 0 ) ) $=
      cH chil wss cA cH wcel cB cH cort cfv wcel wa cA cB csp co cc0 wceq cH
      chil wss cA cH wcel cB cH cort cfv wcel cA cB csp co cc0 wceq cH chil wss
      cA cH wcel wa cH chil wss cB cH cort cfv wcel wa wa cB vx cv csp co cc0
      wceq vx cH wral cA cB csp co cc0 wceq cH chil wss cB cH cort cfv wcel wa
      cB vx cv csp co cc0 wceq vx cH wral cH chil wss cA cH wcel wa cH chil wss
      cB cH cort cfv wcel cB chil wcel cB vx cv csp co cc0 wceq vx cH wral vx
      cB cH ocel pm3.27bda adantl cH chil wss cA cH wcel wa cH chil wss cB cH
      cort cfv wcel wa wa cB vx cv csp co cc0 wceq vx cH wral cB cA csp co cc0
      wceq cA cB csp co cc0 wceq cA cH wcel cB vx cv csp co cc0 wceq vx cH wral
      cB cA csp co cc0 wceq wi cH chil wss cH chil wss cB cH cort cfv wcel wa
      cB vx cv csp co cc0 wceq cB cA csp co cc0 wceq vx cA cH vx cv cA wceq cB
      vx cv csp co cB cA csp co cc0 vx cv cA cB csp opreq2 eqeq1d rcla4v
      ad2antlr cA chil wcel cB chil wcel cA cB csp co cc0 wceq cB cA csp co cc0
      wceq wb cH chil wss cA cH wcel wa cH chil wss cB cH cort cfv wcel wa cA
      cB orthcom cH chil cA ssel2 cH chil wss cB cH cort cfv wcel cB chil wcel
      cH chil wss cH cort cfv chil cB cH ocss sseld imp syl2an sylibrd mpd
      anandis ex $.
      $( [9-Aug-2000] $)

    $( Members of a subspace and its complement are orthogonal. $)
    shocorth $p |- ( H e. SH -> ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
                 ( A .ih B ) = 0 ) ) $=
      cH csh wcel cH chil wss cA cH wcel cB cH cort cfv wcel wa cA cB csp co
      cc0 wceq wi cH shss cA cB cH ocorth syl $.
      $( [10-Oct-1999] $)

    $( Inclusion in complement of complement.  Part of Proposition 1 of
       [Kalmbach] p. 65. $)
    ococss $p |- ( A C_ ~H -> A C_ ( _|_ ` ( _|_ ` A ) ) ) $=
      cA chil wss vy cA cA cort cfv cort cfv cA chil wss vy cv cA wcel vy cv
      chil wcel vy cv vx cv csp co cc0 wceq vx cA cort cfv wral wa vy cv cA
      cort cfv cort cfv wcel cA chil wss vy cv cA wcel vy cv chil wcel vy cv vx
      cv csp co cc0 wceq vx cA cort cfv wral cA chil vy cv ssel cA chil wss vy
      cv cA wcel vy cv vx cv csp co cc0 wceq vx cA cort cfv cA chil wss vy cv
      cA wcel vx cv cA cort cfv wcel vy cv vx cv csp co cc0 wceq vy cv vx cv cA
      ocorth exp3a r19.21adv jcad cA chil wss cA cort cfv chil wss vy cv cA
      cort cfv cort cfv wcel vy cv chil wcel vy cv vx cv csp co cc0 wceq vx cA
      cort cfv wral wa wb cA ocss vx vy cv cA cort cfv ocel syl sylibrd ssrdv
      $.
      $( [9-Aug-2000] $)

    $( Inclusion in complement of complement.  Part of Proposition 1 of
       [Kalmbach] p. 65. $)
    shococss $p |- ( A e. SH -> A C_ ( _|_ ` ( _|_ ` A ) ) ) $=
      cA csh wcel cA chil wss cA cA cort cfv cort cfv wss cA shss cA ococss syl
      $.
      $( [10-Oct-1999] $)

    $( Members of orthogonal subspaces are orthogonal. $)
    shorth $p |- ( H e. SH -> ( G C_ ( _|_ ` H ) ->
        ( ( A e. G /\ B e. H ) -> ( A .ih B ) = 0 ) ) ) $=
      cH csh wcel cG cH cort cfv wss cA cG wcel cB cH wcel wa cA cB csp co cc0
      wceq cH csh wcel cB cH wcel cA cH cort cfv wcel wa cA cB csp co cc0 wceq
      cG cH cort cfv wss cA cG wcel cB cH wcel wa wa cH csh wcel cB cH wcel cA
      cH cort cfv wcel wa wa cB cA csp co cc0 wceq cA cB csp co cc0 wceq cH csh
      wcel cB cH wcel cA cH cort cfv wcel wa cB cA csp co cc0 wceq cB cA cH
      shocorth imp cH csh wcel cB cH wcel cA cH cort cfv wcel wa wa cB chil
      wcel cA chil wcel wa cB cA csp co cc0 wceq cA cB csp co cc0 wceq wb cH
      csh wcel cB cH wcel cA cH cort cfv wcel wa cB chil wcel cA chil wcel wa
      cH csh wcel cB cH wcel cB chil wcel cA cH cort cfv wcel cA chil wcel cH
      csh wcel cH chil cB cH shss sseld cH csh wcel cH cort cfv chil cA cH
      shocss sseld anim12d imp cB cA orthcom syl mpbid cG cH cort cfv wss cA cG
      wcel cB cH wcel wa wa cA cH cort cfv wcel cB cH wcel wa cB cH wcel cA cH
      cort cfv wcel wa cG cH cort cfv wss cA cG wcel cB cH wcel wa cA cH cort
      cfv wcel cB cH wcel wa cG cH cort cfv wss cA cG wcel cA cH cort cfv wcel
      cB cH wcel cG cH cort cfv cA ssel anim1d imp cA cH cort cfv wcel cB cH
      wcel ancom sylib sylan2 exp32 $.
      $( [17-Oct-1999] $)

    $( Intersection of a Hilbert subspace and its complement.  Part of
       Proposition 1 of [Kalmbach] p. 65. $)
    ocin $p |- ( A e. SH -> ( A i^i ( _|_ ` A ) ) = 0H ) $=
      cA csh wcel vx cA cA cort cfv cin c0h cA csh wcel vx cv cA wcel vx cv cA
      cort cfv wcel wa vx cv c0v wceq vx cv cA cA cort cfv cin wcel vx cv c0h
      wcel cA csh wcel vx cv cA wcel vx cv cA cort cfv wcel wa vx cv c0v wceq
      cA csh wcel vx cv cA wcel vx cv cA cort cfv wcel vx cv c0v wceq cA csh
      wcel vx cv cA cort cfv wcel vx cv cA wcel vx cv c0v wceq cA csh wcel vx
      cv cA cort cfv wcel vx cv chil wcel vx cv vy cv csp co cc0 wceq vy cA
      wral wa vx cv cA wcel vx cv c0v wceq wi vy vx cv cA shocel vx cv vy cv
      csp co cc0 wceq vy cA wral vx cv cA wcel vx cv vx cv csp co cc0 wceq vx
      cv chil wcel vx cv c0v wceq vx cv vy cv csp co cc0 wceq vx cv vx cv csp
      co cc0 wceq vy vx cv cA vy cv vx cv wceq vx cv vy cv csp co vx cv vx cv
      csp co cc0 vy cv vx cv vx cv csp opreq2 eqeq1d rcla4cv vx cv chil wcel vx
      cv vx cv csp co cc0 wceq vx cv c0v wceq vx cv his6 biimpd sylan9r syl6bi
      com23 imp3a vx cv c0v wceq vx cv cA wcel vx cv cA cort cfv wcel wa c0v cA
      wcel c0v cA cort cfv wcel wa cA csh wcel vx cv c0v wceq vx cv cA wcel c0v
      cA wcel vx cv cA cort cfv wcel c0v cA cort cfv wcel vx cv c0v cA eleq1 vx
      cv c0v cA cort cfv eleq1 anbi12d cA csh wcel c0v cA wcel c0v cA cort cfv
      wcel cA sh0 cA oc0 jca syl5cbir impbid vx cv cA cA cort cfv elin vx cv
      elch0 3bitr4g eqrdv $.
      $( [11-Oct-1999] $)
  $}

  $( A nonzero vector in the complement of a subspace does not belong to the
     subspace. $)
  ocnel $p |- ( ( H e. SH /\ A e. ( _|_ ` H ) /\ A =/= 0h ) -> -. A e. H ) $=
    cH csh wcel cA cH cort cfv wcel cA c0v wne cA cH wcel wn cH csh wcel cA cH
    cort cfv wcel wa cA cH wcel cA c0v cH csh wcel cA cH cort cfv wcel wa cA cH
    wcel cA c0h wcel cA c0v wceq cH csh wcel cA cH cort cfv wcel cA cH wcel cA
    c0h wcel wi cH csh wcel cA cH wcel cA cH cort cfv wcel cA c0h wcel cH csh
    wcel cA cH wcel cA cH cort cfv wcel cA c0h wcel cH csh wcel cA cH cH cort
    cfv cin wcel cA c0h wcel cA cH wcel cA cH cort cfv wcel wa cH csh wcel cA
    cH cH cort cfv cin wcel cA c0h wcel cH csh wcel cH cH cort cfv cin c0h cA
    cH ocin eleq2d biimpd cA cH cH cort cfv elin syl5ibr exp3a com23 imp cA
    elch0 syl6ib necon3ad 3impia $.
    $( [11-May-2006] $) $( [10-Apr-2006] $)

  ${
    $d x y A $.
    chocval.1 $e |- A e. CH $.
    $( Value of the orthogonal complement of a Hilbert lattice element.  The
       orthogonal complement of ` A ` is the set of vectors that are
       orthogonal to all vectors in ` A ` . $)
    chocvali $p |- ( _|_ ` A ) = { x e. ~H | A. y e. A ( x .ih y ) = 0 } $=
      cA chil wss cA cort cfv vx cv vy cv csp co cc0 wceq vy cA wral vx chil
      crab wceq cA chocval.1 chssii vx vy cA ocval ax-mp $.
      $( [11-Aug-2004] $) $( [8-Aug-2004] $)
  $}

  ${
    chocuni.1 $e |- H e. CH $.
    $( Lemma for uniqueness part of Projection Theorem.  Theorem 3.7(i) of
       [Beran] p. 102 (uniqueness part). $)
    chocunii $p |- ( ( ( A e. H /\ B e. ( _|_ ` H ) ) /\
                    ( C e. H /\ D e. ( _|_ ` H ) ) ) ->
            ( ( R = ( A +h B ) /\ R = ( C +h D ) ) -> ( A = C /\ B = D ) ) ) $=
      cA cH wcel cB cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa wa cA
      cB cva co cA cD cva co cmv co cC cD cva co cA cD cva co cmv co wceq cA cC
      wceq cB cD wceq wa cR cA cB cva co wceq cR cC cD cva co wceq wa cA cH
      wcel cB cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa wa cA cB
      cva co cA cD cva co cmv co cC cD cva co cA cD cva co cmv co wceq cB cD
      cmv co cC cA cmv co wceq cA cC wceq cB cD wceq wa cA chil wcel cB chil
      wcel wa cC chil wcel cD chil wcel wa cA cB cva co cA cD cva co cmv co cC
      cD cva co cA cD cva co cmv co wceq cB cD cmv co cC cA cmv co wceq wb cA
      cH wcel cB cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa cA chil
      wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB cva co cA cD
      cva co cmv co cB cD cmv co cC cD cva co cA cD cva co cmv co cC cA cmv co
      cA chil wcel cB chil wcel wa cD chil wcel cA cB cva co cA cD cva co cmv
      co cB cD cmv co wceq cC chil wcel cA chil wcel cB chil wcel wa cD chil
      wcel wa cA cB cva co cA cD cva co cmv co cA cA cmv co cB cD cmv co cva co
      c0v cB cD cmv co cva co cB cD cmv co cA chil wcel cB chil wcel wa cD chil
      wcel cA chil wcel cD chil wcel wa cA cB cva co cA cD cva co cmv co cA cA
      cmv co cB cD cmv co cva co wceq cA chil wcel cB chil wcel wa cA chil wcel
      cD chil wcel cA chil wcel cB chil wcel pm3.26 anim1i cA cB cA cD hvsub4
      syldan cA chil wcel cB chil wcel wa cD chil wcel wa cA cA cmv co c0v cB
      cD cmv co cva cA chil wcel cA cA cmv co c0v wceq cB chil wcel cD chil
      wcel cA hvsubid ad2antrr opreq1d cB chil wcel cD chil wcel c0v cB cD cmv
      co cva co cB cD cmv co wceq cA chil wcel cB chil wcel cD chil wcel wa cB
      cD cmv co chil wcel c0v cB cD cmv co cva co cB cD cmv co wceq cB cD
      hvsubcl cB cD cmv co hvaddid2 syl adantll 3eqtrd adantrl cA chil wcel cC
      chil wcel cD chil wcel wa cC cD cva co cA cD cva co cmv co cC cA cmv co
      wceq cB chil wcel cA chil wcel cC chil wcel cD chil wcel wa wa cC cD cva
      co cA cD cva co cmv co cC cA cmv co cD cD cmv co cva co cC cA cmv co c0v
      cva co cC cA cmv co cC chil wcel cD chil wcel wa cA chil wcel cD chil
      wcel wa cC cD cva co cA cD cva co cmv co cC cA cmv co cD cD cmv co cva co
      wceq cA chil wcel cC chil wcel cD chil wcel wa wa cC cD cA cD hvsub4 cA
      chil wcel cC chil wcel cD chil wcel wa pm3.27 cC chil wcel cD chil wcel
      wa cD chil wcel cA chil wcel cC chil wcel cD chil wcel pm3.27 anim2i
      sylanc cA chil wcel cC chil wcel cD chil wcel wa wa cD cD cmv co c0v cC
      cA cmv co cva cD chil wcel cD cD cmv co c0v wceq cA chil wcel cC chil
      wcel cD hvsubid ad2antll opreq2d cA chil wcel cC chil wcel cC cA cmv co
      c0v cva co cC cA cmv co wceq cD chil wcel cC chil wcel cA chil wcel cC cA
      cmv co c0v cva co cC cA cmv co wceq cC chil wcel cA chil wcel wa cC cA
      cmv co chil wcel cC cA cmv co c0v cva co cC cA cmv co wceq cC cA hvsubcl
      cC cA cmv co ax-hvaddid syl ancoms adantrr 3eqtrd adantlr eqeq12d cA cH
      wcel cA chil wcel cB cH cort cfv wcel cB chil wcel cA cH chocuni.1 cheli
      cB cH cort cfv cH csh wcel cH cort cfv csh wcel cH chocuni.1 chshii cH
      shocsh ax-mp sheli anim12i cC cH wcel cC chil wcel cD cH cort cfv wcel cD
      chil wcel cC cH chocuni.1 cheli cD cH cort cfv cH csh wcel cH cort cfv
      csh wcel cH chocuni.1 chshii cH shocsh ax-mp sheli anim12i syl2an cA cH
      wcel cB cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa wa cB cD
      cmv co cC cA cmv co wceq cA cC wceq cB cD wceq cA cH wcel cB cH cort cfv
      wcel wa cC cH wcel cD cH cort cfv wcel wa wa cB cD cmv co cC cA cmv co
      wceq cC cA cmv co cH wcel cC cA cmv co cH cort cfv wcel wa cA cC wceq cA
      cH wcel cB cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa wa cB cD
      cmv co cC cA cmv co wceq cC cA cmv co cH wcel cC cA cmv co cH cort cfv
      wcel cA cH wcel cC cH wcel cB cD cmv co cC cA cmv co wceq cC cA cmv co cH
      wcel wi cB cH cort cfv wcel cD cH cort cfv wcel cA cH wcel cC cH wcel wa
      cC cA cmv co cH wcel cB cD cmv co cC cA cmv co wceq cC cH wcel cA cH wcel
      cC cA cmv co cH wcel cH csh wcel cC cH wcel cA cH wcel wa cC cA cmv co cH
      wcel wi cH chocuni.1 chshii cC cA cH shsubclOLD ax-mp ancoms a1d ad2ant2r
      cB cH cort cfv wcel cD cH cort cfv wcel cB cD cmv co cC cA cmv co wceq cC
      cA cmv co cH cort cfv wcel wi cA cH wcel cC cH wcel cB cD cmv co cC cA
      cmv co wceq cB cD cmv co cH cort cfv wcel cC cA cmv co cH cort cfv wcel
      cB cH cort cfv wcel cD cH cort cfv wcel wa cB cD cmv co cC cA cmv co cH
      cort cfv eleq1 cH cort cfv csh wcel cB cH cort cfv wcel cD cH cort cfv
      wcel wa cB cD cmv co cH cort cfv wcel wi cH csh wcel cH cort cfv csh wcel
      cH chocuni.1 chshii cH shocsh ax-mp cB cD cH cort cfv shsubclOLD ax-mp
      syl5cbi ad2ant2l jcad cA cH wcel cB cH cort cfv wcel wa cC cH wcel cD cH
      cort cfv wcel wa wa cC cA cmv co c0v wceq cA cC wceq cC cA cmv co cH wcel
      cC cA cmv co cH cort cfv wcel wa cA cH wcel cB cH cort cfv wcel wa cC cH
      wcel cD cH cort cfv wcel wa wa cC cA cmv co c0v wceq cC cA wceq cA cC
      wceq cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa cC cA cmv
      co c0v wceq cC cA wceq wb cA cH wcel cB cH cort cfv wcel wa cC cH wcel cD
      cH cort cfv wcel wa cA chil wcel cC chil wcel cC cA cmv co c0v wceq cC cA
      wceq wb cB chil wcel cD chil wcel cC chil wcel cA chil wcel cC cA cmv co
      c0v wceq cC cA wceq wb cC cA hvsubeq0 ancoms ad2ant2r cA cH wcel cA chil
      wcel cB cH cort cfv wcel cB chil wcel cA cH chocuni.1 cheli cB cH cort
      cfv cH csh wcel cH cort cfv csh wcel cH chocuni.1 chshii cH shocsh ax-mp
      sheli anim12i cC cH wcel cC chil wcel cD cH cort cfv wcel cD chil wcel cC
      cH chocuni.1 cheli cD cH cort cfv cH csh wcel cH cort cfv csh wcel cH
      chocuni.1 chshii cH shocsh ax-mp sheli anim12i syl2an cC cA eqcom syl6bb
      cC cA cmv co cH cH cort cfv cin wcel cC cA cmv co c0h wcel cC cA cmv co
      cH wcel cC cA cmv co cH cort cfv wcel wa cC cA cmv co c0v wceq cH cH cort
      cfv cin c0h cC cA cmv co cH csh wcel cH cH cort cfv cin c0h wceq cH
      chocuni.1 chshii cH ocin ax-mp eleq2i cC cA cmv co cH cH cort cfv elin cC
      cA cmv co elch0 3bitr3i syl5bb sylibd cA cH wcel cB cH cort cfv wcel wa
      cC cH wcel cD cH cort cfv wcel wa wa cB cD cmv co cC cA cmv co wceq cB cD
      cmv co cH wcel cB cD cmv co cH cort cfv wcel wa cB cD wceq cA cH wcel cB
      cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa wa cB cD cmv co cC
      cA cmv co wceq cB cD cmv co cH wcel cB cD cmv co cH cort cfv wcel cA cH
      wcel cC cH wcel cB cD cmv co cC cA cmv co wceq cB cD cmv co cH wcel wi cB
      cH cort cfv wcel cD cH cort cfv wcel cA cH wcel cC cH wcel wa cC cA cmv
      co cH wcel cB cD cmv co cC cA cmv co wceq cB cD cmv co cH wcel wi cC cH
      wcel cA cH wcel cC cA cmv co cH wcel cH csh wcel cC cH wcel cA cH wcel wa
      cC cA cmv co cH wcel wi cH chocuni.1 chshii cC cA cH shsubclOLD ax-mp
      ancoms cC cA cmv co cH cB cD cmv co eleq1a syl ad2ant2r cB cH cort cfv
      wcel cD cH cort cfv wcel cB cD cmv co cC cA cmv co wceq cB cD cmv co cH
      cort cfv wcel wi cA cH wcel cC cH wcel cB cH cort cfv wcel cD cH cort cfv
      wcel wa cB cD cmv co cH cort cfv wcel cB cD cmv co cC cA cmv co wceq cH
      cort cfv csh wcel cB cH cort cfv wcel cD cH cort cfv wcel wa cB cD cmv co
      cH cort cfv wcel wi cH csh wcel cH cort cfv csh wcel cH chocuni.1 chshii
      cH shocsh ax-mp cB cD cH cort cfv shsubclOLD ax-mp a1d ad2ant2l jcad cA
      cH wcel cB cH cort cfv wcel wa cC cH wcel cD cH cort cfv wcel wa wa cB cD
      cmv co c0v wceq cB cD wceq cB cD cmv co cH wcel cB cD cmv co cH cort cfv
      wcel wa cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa cB cD
      cmv co c0v wceq cB cD wceq wb cA cH wcel cB cH cort cfv wcel wa cC cH
      wcel cD cH cort cfv wcel wa cB chil wcel cD chil wcel cB cD cmv co c0v
      wceq cB cD wceq wb cA chil wcel cC chil wcel cB cD hvsubeq0 ad2ant2l cA
      cH wcel cA chil wcel cB cH cort cfv wcel cB chil wcel cA cH chocuni.1
      cheli cB cH cort cfv cH csh wcel cH cort cfv csh wcel cH chocuni.1 chshii
      cH shocsh ax-mp sheli anim12i cC cH wcel cC chil wcel cD cH cort cfv wcel
      cD chil wcel cC cH chocuni.1 cheli cD cH cort cfv cH csh wcel cH cort cfv
      csh wcel cH chocuni.1 chshii cH shocsh ax-mp sheli anim12i syl2an cB cD
      cmv co cH cH cort cfv cin wcel cB cD cmv co c0h wcel cB cD cmv co cH wcel
      cB cD cmv co cH cort cfv wcel wa cB cD cmv co c0v wceq cH cH cort cfv cin
      c0h cB cD cmv co cH csh wcel cH cH cort cfv cin c0h wceq cH chocuni.1
      chshii cH ocin ax-mp eleq2i cB cD cmv co cH cH cort cfv elin cB cD cmv co
      elch0 3bitr3i syl5bb sylibd jcad sylbid cR cA cB cva co wceq cR cC cD cva
      co wceq wa cA cB cva co cC cD cva co cA cD cva co cmv cR cA cB cva co cC
      cD cva co eqtr2 opreq1d syl5 $.
      $( [23-Oct-1999] $)
  $}

  ${
    occllem1.1 $e |- A e. ~H $.
    occllem1.2 $e |- B e. ~H $.
    occllem1.3 $e |- S e. ~H $.
    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem1 $p |-  ( abs ` ( ( B .ih S ) - ( A .ih S ) ) ) <_
                    ( ( normh ` ( B -h A ) ) x. ( normh ` S ) ) $=
      cB cS csp co cA cS csp co cmin co cabs cfv cB cA cmv co cS csp co cabs
      cfv cB cA cmv co cno cfv cS cno cfv cmul co cle cB cS csp co cA cS csp co
      cmin co cB cA cmv co cS csp co cabs cB cS csp co c1 cneg cA cS csp co
      cmul co caddc co cB c1 cneg cA csm co cva co cS csp co cB cS csp co cA cS
      csp co cmin co cB cA cmv co cS csp co cB c1 cneg cA csm co cva co cS csp
      co cB cS csp co c1 cneg cA csm co cS csp co caddc co cB cS csp co c1 cneg
      cA cS csp co cmul co caddc co cB chil wcel c1 cneg cA csm co chil wcel cS
      chil wcel cB c1 cneg cA csm co cva co cS csp co cB cS csp co c1 cneg cA
      csm co cS csp co caddc co wceq occllem1.2 c1 cneg cA c1 ax1cn negcli
      occllem1.1 hvmulcli occllem1.3 cB c1 cneg cA csm co cS ax-his2 mp3an c1
      cneg cA csm co cS csp co c1 cneg cA cS csp co cmul co cB cS csp co caddc
      c1 cneg cc wcel cA chil wcel cS chil wcel c1 cneg cA csm co cS csp co c1
      cneg cA cS csp co cmul co wceq c1 ax1cn negcli occllem1.1 occllem1.3 c1
      cneg cA cS ax-his3 mp3an opreq2i eqtr2i cB cS csp co c1 cneg cA cS csp co
      cmul co caddc co cB cS csp co cA cS csp co cneg caddc co cB cS csp co cA
      cS csp co cmin co c1 cneg cA cS csp co cmul co cA cS csp co cneg cB cS
      csp co caddc cA cS csp co cA cS occllem1.1 occllem1.3 hicli mulm1i
      opreq2i cB cS csp co cA cS csp co cB cS occllem1.2 occllem1.3 hicli cA cS
      occllem1.1 occllem1.3 hicli negsubi eqtr2i cB cA cmv co cB c1 cneg cA csm
      co cva co cS csp cB cA occllem1.2 occllem1.1 hvsubvali opreq1i 3eqtr4i
      fveq2i cB cA cmv co cS cB cA occllem1.2 occllem1.1 hvsubcli occllem1.3
      bcsiHIL eqbrtri $.
      $( [12-Oct-1999] $)
  $}

  ${
    occllem2.1 $e |- S e. ~H $.
    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem2 $p |-  ( ( A e. ~H /\ B e. ~H ) ->
                  ( abs ` ( ( B .ih S ) - ( A .ih S ) ) ) <_
                  ( ( normh ` ( B -h A ) ) x. ( normh ` S ) ) ) $=
      cA chil wcel cB chil wcel cB cS csp co cA cS csp co cmin co cabs cfv cB
      cA cmv co cno cfv cS cno cfv cmul co cle wbr cB cS csp co cA chil wcel cA
      c0v cif cS csp co cmin co cabs cfv cB cA chil wcel cA c0v cif cmv co cno
      cfv cS cno cfv cmul co cle wbr cB chil wcel cB c0v cif cS csp co cA chil
      wcel cA c0v cif cS csp co cmin co cabs cfv cB chil wcel cB c0v cif cA
      chil wcel cA c0v cif cmv co cno cfv cS cno cfv cmul co cle wbr cA cB c0v
      c0v cA cA chil wcel cA c0v cif wceq cB cS csp co cA cS csp co cmin co
      cabs cfv cB cS csp co cA chil wcel cA c0v cif cS csp co cmin co cabs cfv
      cB cA cmv co cno cfv cS cno cfv cmul co cB cA chil wcel cA c0v cif cmv co
      cno cfv cS cno cfv cmul co cle cA cA chil wcel cA c0v cif wceq cB cS csp
      co cA cS csp co cmin co cB cS csp co cA chil wcel cA c0v cif cS csp co
      cmin co cabs cA cA chil wcel cA c0v cif wceq cA cS csp co cA chil wcel cA
      c0v cif cS csp co cB cS csp co cmin cA cA chil wcel cA c0v cif cS csp
      opreq1 opreq2d fveq2d cA cA chil wcel cA c0v cif wceq cB cA cmv co cno
      cfv cB cA chil wcel cA c0v cif cmv co cno cfv cS cno cfv cmul cA cA chil
      wcel cA c0v cif wceq cB cA cmv co cB cA chil wcel cA c0v cif cmv co cno
      cA cA chil wcel cA c0v cif cB cmv opreq2 fveq2d opreq1d breq12d cB cB
      chil wcel cB c0v cif wceq cB cS csp co cA chil wcel cA c0v cif cS csp co
      cmin co cabs cfv cB chil wcel cB c0v cif cS csp co cA chil wcel cA c0v
      cif cS csp co cmin co cabs cfv cB cA chil wcel cA c0v cif cmv co cno cfv
      cS cno cfv cmul co cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv co
      cno cfv cS cno cfv cmul co cle cB cB chil wcel cB c0v cif wceq cB cS csp
      co cA chil wcel cA c0v cif cS csp co cmin co cB chil wcel cB c0v cif cS
      csp co cA chil wcel cA c0v cif cS csp co cmin co cabs cB cB chil wcel cB
      c0v cif wceq cB cS csp co cB chil wcel cB c0v cif cS csp co cA chil wcel
      cA c0v cif cS csp co cmin cB cB chil wcel cB c0v cif cS csp opreq1
      opreq1d fveq2d cB cB chil wcel cB c0v cif wceq cB cA chil wcel cA c0v cif
      cmv co cno cfv cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv co cno
      cfv cS cno cfv cmul cB cB chil wcel cB c0v cif wceq cB cA chil wcel cA
      c0v cif cmv co cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv co cno
      cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq1 fveq2d
      opreq1d breq12d cA chil wcel cA c0v cif cB chil wcel cB c0v cif cS cA c0v
      chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel occllem2.1 occllem1
      dedth2h $.
      $( [13-Oct-1999] $)
  $}

  ${
    $d x y z F $.  $d x y z S $.  $d z G $.  $d x y D $.
    occllem3.1 $e |- G =
                    { <. x , y >. | ( x e. NN /\ y = ( ( F ` x ) .ih S ) ) } $.
    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem3 $p |- ( D e. NN -> ( G ` D ) = ( ( F ` D ) .ih S ) ) $=
      vx vy cD vx cv cF cfv cS csp co cD cF cfv cS csp co cn cG vx cv cD wceq
      vx cv cF cfv cD cF cfv cS csp vx cv cD cF fveq2 opreq1d occllem3.1 cD cF
      cfv cS csp oprex fvopab4 $.
      $( [13-Oct-1999] $)

    ${
      occllem4.2 $e |- S e. ~H $.
      $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
         3.12 of [Beran] p. 107. $)
      occllem4 $p |- ( F : NN --> ~H -> G : NN --> CC ) $=
        cn chil cF wf vx cv cF cfv cS csp co cc wcel vx cn wral cn cc cG wf cn
        chil cF wf vx cv cF cfv cS csp co cc wcel vx cn cn chil cF wf vx cv cn
        wcel wa vx cv cF cfv chil wcel cS chil wcel wa vx cv cF cfv cS csp co
        cc wcel cn chil cF wf vx cv cn wcel wa vx cv cF cfv chil wcel cS chil
        wcel cn chil vx cv cF ffvelrn occllem4.2 jctir vx cv cF cfv cS hicl syl
        r19.21aiva vx vy cn cc vx cv cF cfv cS csp co cG occllem3.1 fopab2
        sylib $.
        $( [12-Oct-1999] $)
    $}

    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem5 $p |- ( A. z e. NN ( ( F ` z ) .ih S ) = 0 -> G ~~> 0 ) $=
      vz cv cF cfv cS csp co cc0 wceq vz cn wral cG cn cc0 csn cxp cc0 cli vz
      cv cF cfv cS csp co cc0 wceq vz cn wral vx cv cn wcel vy cv vx cv cF cfv
      cS csp co wceq wa vx vy copab vx cv cn wcel vy cv cc0 wceq wa vx vy copab
      cG cn cc0 csn cxp vz cv cF cfv cS csp co cc0 wceq vz cn wral vx cv cn
      wcel vy cv vx cv cF cfv cS csp co wceq wa vx cv cn wcel vy cv cc0 wceq wa
      vx vy vz cv cF cfv cS csp co cc0 wceq vz cn wral vx cv cn wcel vy cv vx
      cv cF cfv cS csp co wceq vy cv cc0 wceq vx cv cn wcel vz cv cF cfv cS csp
      co cc0 wceq vz cn wral vx cv cF cfv cS csp co cc0 wceq vy cv vx cv cF cfv
      cS csp co wceq vy cv cc0 wceq wb vz cv cF cfv cS csp co cc0 wceq vx cv cF
      cfv cS csp co cc0 wceq vz vx cv cn vz cv vx cv wceq vz cv cF cfv cS csp
      co vx cv cF cfv cS csp co cc0 vz cv vx cv wceq vz cv cF cfv vx cv cF cfv
      cS csp vz cv vx cv cF fveq2 opreq1d eqeq1d rcla4v vx cv cF cfv cS csp co
      cc0 vy cv eqeq2 syl6com pm5.32d opabbidv occllem3.1 vx vy cn cc0
      fconstopab 3eqtr4g cn cc0 csn cxp c1 cuz cfv cc0 csn cxp cc0 cli cn c1
      cuz cfv cc0 csn nnuz xpeq1i c1 1z climuz0i eqbrtri syl6eqbr $.
      $( [6-Jul-2006] $) $( [12-Oct-1999] $)
  $}

  ${
    $d z w v u A $.  $d x y z w v u F $.  $d w u v G $.  $d x y z w v u S $.
    occllem6.1 $e |- G =
                    { <. x , y >. | ( x e. NN /\ y = ( ( F ` x ) .ih S ) ) } $.
    occllem6.2 $e |- A e. ~H $.
    occllem6.3 $e |- S e. ~H $.
    occllem6.4 $e |- F e. _V $.
    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem6 $p |-  ( S =/= 0h -> ( F ~~>v A -> G ~~> ( A .ih S ) ) ) $=
      cS c0v wne cF cA chli wbr cA cS csp co cc wcel vv cv cG cfv cc wcel vv cn
      wral wa cc0 vu cv clt wbr vw cv vv cv cle wbr vv cv cG cfv cA cS csp co
      cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn wrex wi vu cr wral wa
      cG cA cS csp co cli wbr cS c0v wne cn chil cF wf cA chil wcel wa cc0 vz
      cv clt wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv clt
      wbr wi vv cn wral vw cn wrex wi vz cr wral wa cA cS csp co cc wcel vv cv
      cG cfv cc wcel vv cn wral wa cc0 vu cv clt wbr vw cv vv cv cle wbr vv cv
      cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn
      wrex wi vu cr wral wa cF cA chli wbr cS c0v wne cn chil cF wf cA chil
      wcel wa cc0 vz cv clt wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno
      cfv vz cv clt wbr wi vv cn wral vw cn wrex wi vz cr wral wa cA cS csp co
      cc wcel vv cv cG cfv cc wcel vv cn wral wa cc0 vu cv clt wbr vw cv vv cv
      cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn
      wral vw cn wrex wi vu cr wral cS c0v wne cn chil cF wf cA chil wcel wa cA
      cS csp co cc wcel vv cv cG cfv cc wcel vv cn wral wa cc0 vz cv clt wbr vw
      cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv clt wbr wi vv cn
      wral vw cn wrex wi vz cr wral cn chil cF wf cA chil wcel wa cA cS csp co
      cc wcel vv cv cG cfv cc wcel vv cn wral wa wi cS c0v wne cn chil cF wf cA
      cS csp co cc wcel vv cv cG cfv cc wcel vv cn wral wa cA chil wcel cn chil
      cF wf vv cv cG cfv cc wcel vv cn wral cA cS csp co cc wcel cn chil cF wf
      vv cv cG cfv cc wcel vv cn cn cc cG wf vv cv cn wcel vv cv cG cfv cc wcel
      cn chil cF wf cn cc vv cv cG ffvelrn vx vy cS cF cG occllem6.1 occllem6.3
      occllem4 sylan r19.21aiva cA cS occllem6.2 occllem6.3 hicli jctil adantr
      a1i adantrd cS c0v wne cn chil cF wf cA chil wcel wa cc0 vz cv clt wbr vw
      cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv clt wbr wi vv cn
      wral vw cn wrex wi vz cr wral cc0 vu cv clt wbr vw cv vv cv cle wbr vv cv
      cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn
      wrex wi vu cr wral cS c0v wne cn chil cF wf cA chil wcel wa wa cc0 vz cv
      clt wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv clt wbr
      wi vv cn wral vw cn wrex wi vz cr wral cc0 vu cv clt wbr vw cv vv cv cle
      wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn
      wral vw cn wrex wi vu cr cS c0v wne cn chil cF wf cA chil wcel wa wa vu
      cv cS cno cfv cdiv co cr wcel cc0 vu cv cS cno cfv cdiv co clt wbr wa vw
      cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv co
      clt wbr wi vv cn wral vw cn wrex wi vu cv cr wcel cc0 vu cv clt wbr vw cv
      vv cv cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi
      vv cn wral vw cn wrex wi wi cc0 vz cv clt wbr vw cv vv cv cle wbr vv cv
      cF cfv cA cmv co cno cfv vz cv clt wbr wi vv cn wral vw cn wrex wi vz cr
      wral cS c0v wne cn chil cF wf vu cv cS cno cfv cdiv co cr wcel cc0 vu cv
      cS cno cfv cdiv co clt wbr wa vw cv vv cv cle wbr vv cv cF cfv cA cmv co
      cno cfv vu cv cS cno cfv cdiv co clt wbr wi vv cn wral vw cn wrex wi vu
      cv cr wcel cc0 vu cv clt wbr vw cv vv cv cle wbr vv cv cG cfv cA cS csp
      co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn wrex wi wi wi cA
      chil wcel cc0 cS cno cfv clt wbr cn chil cF wf vu cv cS cno cfv cdiv co
      cr wcel cc0 vu cv cS cno cfv cdiv co clt wbr wa vw cv vv cv cle wbr vv cv
      cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv co clt wbr wi vv cn wral
      vw cn wrex wi vu cv cr wcel cc0 vu cv clt wbr vw cv vv cv cle wbr vv cv
      cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn
      wrex wi wi wi cS c0v wne cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cS
      cno cfv cdiv co cr wcel cc0 vu cv cS cno cfv cdiv co clt wbr wa vw cv vv
      cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv co clt
      wbr wi vv cn wral vw cn wrex wi vu cv cr wcel cc0 vu cv clt wbr vw cv vv
      cv cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv
      cn wral vw cn wrex cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cS cno
      cfv cdiv co cr wcel cc0 vu cv cS cno cfv cdiv co clt wbr wa vw cv vv cv
      cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv co clt wbr
      wi vv cn wral vw cn wrex wi vu cv cr wcel cc0 vu cv clt wbr wa vw cv vv
      cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv co clt
      wbr wi vv cn wral vw cn wrex wi vu cv cr wcel cc0 vu cv clt wbr wa vw cv
      vv cv cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi
      vv cn wral vw cn wrex wi cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cr
      wcel cc0 vu cv clt wbr wa vu cv cS cno cfv cdiv co cr wcel cc0 vu cv cS
      cno cfv cdiv co clt wbr wa vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno
      cfv vu cv cS cno cfv cdiv co clt wbr wi vv cn wral vw cn wrex cc0 cS cno
      cfv clt wbr vu cv cr wcel cc0 vu cv clt wbr wa vu cv cS cno cfv cdiv co
      cr wcel cc0 vu cv cS cno cfv cdiv co clt wbr wa wi cn chil cF wf vu cv cr
      wcel cc0 vu cv clt wbr wa cc0 cS cno cfv clt wbr vu cv cS cno cfv cdiv co
      cr wcel cc0 vu cv cS cno cfv cdiv co clt wbr wa vu cv cr wcel cc0 vu cv
      clt wbr wa cc0 cS cno cfv clt wbr wa vu cv cS cno cfv cdiv co cr wcel cc0
      vu cv cS cno cfv cdiv co clt wbr vu cv cr wcel cc0 cS cno cfv clt wbr vu
      cv cS cno cfv cdiv co cr wcel cc0 vu cv clt wbr vu cv cr wcel cS cno cfv
      cc0 wne vu cv cS cno cfv cdiv co cr wcel cc0 cS cno cfv clt wbr vu cv cr
      wcel cS cno cfv cr wcel cS cno cfv cc0 wne vu cv cS cno cfv cdiv co cr
      wcel cS occllem6.3 normcli vu cv cS cno cfv redivcl mp3an2 cS cno cfv cS
      occllem6.3 normcli gt0ne0i sylan2 adantlr vu cv cr wcel cc0 vu cv clt wbr
      wa cS cno cfv cr wcel cc0 cS cno cfv clt wbr cc0 vu cv cS cno cfv cdiv co
      clt wbr cS occllem6.3 normcli vu cv cS cno cfv divgt0 mpanr1 jca expcom
      adantr imim1d cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cr wcel cc0
      vu cv clt wbr wa vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv
      cS cno cfv cdiv co clt wbr wi vv cn wral vw cn wrex vw cv vv cv cle wbr
      vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw
      cn wrex cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cr wcel cc0 vu cv
      clt wbr wa vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS
      cno cfv cdiv co clt wbr wi vv cn wral vw cn wrex vw cv vv cv cle wbr vv
      cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn
      wrex wi cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cr wcel cc0 vu cv
      clt wbr wa wa vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS
      cno cfv cdiv co clt wbr wi vv cn wral vw cv vv cv cle wbr vv cv cG cfv cA
      cS csp co cmin co cabs cfv vu cv clt wbr wi vv cn wral vw cn cc0 cS cno
      cfv clt wbr cn chil cF wf wa vu cv cr wcel cc0 vu cv clt wbr wa wa vw cv
      vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv co clt
      wbr wi vw cv vv cv cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu
      cv clt wbr wi vv cn cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cr wcel
      cc0 vu cv clt wbr wa wa vv cv cn wcel wa vv cv cF cfv cA cmv co cno cfv
      vu cv cS cno cfv cdiv co clt wbr vv cv cG cfv cA cS csp co cmin co cabs
      cfv vu cv clt wbr vw cv vv cv cle wbr cc0 cS cno cfv clt wbr cn chil cF
      wf wa vu cv cr wcel cc0 vu cv clt wbr wa wa vv cv cn wcel wa vv cv cF cfv
      cA cmv co cno cfv vu cv cS cno cfv cdiv co clt wbr vv cv cF cfv cA cmv co
      cno cfv cS cno cfv cmul co vu cv clt wbr vv cv cG cfv cA cS csp co cmin
      co cabs cfv vu cv clt wbr vv cv cF cfv cA cmv co cno cfv cr wcel vu cv cr
      wcel wa cc0 cS cno cfv clt wbr vv cv cF cfv cA cmv co cno cfv cS cno cfv
      cmul co vu cv clt wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv
      cdiv co clt wbr wb cc0 cS cno cfv clt wbr cn chil cF wf wa vu cv cr wcel
      cc0 vu cv clt wbr wa wa vv cv cn wcel wa vv cv cF cfv cA cmv co cno cfv
      cr wcel cS cno cfv cr wcel vu cv cr wcel cc0 cS cno cfv clt wbr vv cv cF
      cfv cA cmv co cno cfv cS cno cfv cmul co vu cv clt wbr vv cv cF cfv cA
      cmv co cno cfv vu cv cS cno cfv cdiv co clt wbr wb cS occllem6.3 normcli
      vv cv cF cfv cA cmv co cno cfv cS cno cfv vu cv ltmuldivOLD mp3anl2 cc0
      cS cno cfv clt wbr cn chil cF wf wa vu cv cr wcel cc0 vu cv clt wbr wa wa
      vv cv cn wcel wa vv cv cF cfv cA cmv co cno cfv cr wcel vu cv cr wcel cc0
      cS cno cfv clt wbr cn chil cF wf wa vv cv cn wcel vv cv cF cfv cA cmv co
      cno cfv cr wcel vu cv cr wcel cc0 vu cv clt wbr wa cn chil cF wf vv cv cn
      wcel vv cv cF cfv cA cmv co cno cfv cr wcel cc0 cS cno cfv clt wbr cn
      chil cF wf vv cv cn wcel wa vv cv cF cfv chil wcel cA chil wcel wa vv cv
      cF cfv cA cmv co chil wcel vv cv cF cfv cA cmv co cno cfv cr wcel cn chil
      cF wf vv cv cn wcel wa vv cv cF cfv chil wcel cA chil wcel cn chil vv cv
      cF ffvelrn occllem6.2 jctir vv cv cF cfv cA hvsubcl vv cv cF cfv cA cmv
      co normcl 3syl adantll adantlr vu cv cr wcel cc0 vu cv clt wbr wa vu cv
      cr wcel cc0 cS cno cfv clt wbr cn chil cF wf wa vv cv cn wcel vu cv cr
      wcel cc0 vu cv clt wbr pm3.26 ad2antlr jca cc0 cS cno cfv clt wbr cn chil
      cF wf wa cc0 cS cno cfv clt wbr vu cv cr wcel cc0 vu cv clt wbr wa vv cv
      cn wcel cc0 cS cno cfv clt wbr cn chil cF wf pm3.26 ad2antrr sylanc cc0
      cS cno cfv clt wbr cn chil cF wf wa vv cv cn wcel vu cv cr wcel cc0 vu cv
      clt wbr wa vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co vu cv clt
      wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr wi cc0 cS
      cno cfv clt wbr cn chil cF wf wa vv cv cn wcel wa vu cv cr wcel vv cv cF
      cfv cA cmv co cno cfv cS cno cfv cmul co vu cv clt wbr vv cv cG cfv cA cS
      csp co cmin co cabs cfv vu cv clt wbr wi cc0 vu cv clt wbr cc0 cS cno cfv
      clt wbr cn chil cF wf wa vv cv cn wcel wa vu cv cr wcel wa vv cv cG cfv
      cA cS csp co cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv
      cmul co cle wbr vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co vu cv
      clt wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr cc0 cS
      cno cfv clt wbr cn chil cF wf wa vv cv cn wcel wa vv cv cG cfv cA cS csp
      co cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co cle
      wbr vu cv cr wcel cn chil cF wf vv cv cn wcel vv cv cG cfv cA cS csp co
      cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co cle
      wbr cc0 cS cno cfv clt wbr cn chil cF wf vv cv cn wcel wa vv cv cG cfv cA
      cS csp co cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul
      co cle wbr vv cv cF cfv cS csp co cA cS csp co cmin co cabs cfv vv cv cF
      cfv cA cmv co cno cfv cS cno cfv cmul co cle wbr cn chil cF wf vv cv cn
      wcel wa cA chil wcel vv cv cF cfv chil wcel wa vv cv cF cfv cS csp co cA
      cS csp co cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul
      co cle wbr cn chil cF wf vv cv cn wcel wa vv cv cF cfv chil wcel cA chil
      wcel cn chil vv cv cF ffvelrn occllem6.2 jctil cA vv cv cF cfv cS
      occllem6.3 occllem2 syl vv cv cn wcel vv cv cG cfv cA cS csp co cmin co
      cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co cle wbr vv cv
      cF cfv cS csp co cA cS csp co cmin co cabs cfv vv cv cF cfv cA cmv co cno
      cfv cS cno cfv cmul co cle wbr wb cn chil cF wf vv cv cn wcel vv cv cG
      cfv cA cS csp co cmin co cabs cfv vv cv cF cfv cS csp co cA cS csp co
      cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co cle vv
      cv cn wcel vv cv cG cfv cA cS csp co cmin co vv cv cF cfv cS csp co cA cS
      csp co cmin co cabs vv cv cn wcel vv cv cG cfv vv cv cF cfv cS csp co cA
      cS csp co cmin vx vy vv cv cS cF cG occllem6.1 occllem3 opreq1d fveq2d
      breq1d adantl mpbird adantll adantr vv cv cG cfv cA cS csp co cmin co
      cabs cfv cr wcel vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co cr
      wcel wa vu cv cr wcel vv cv cG cfv cA cS csp co cmin co cabs cfv vv cv cF
      cfv cA cmv co cno cfv cS cno cfv cmul co cle wbr vv cv cF cfv cA cmv co
      cno cfv cS cno cfv cmul co vu cv clt wbr wa vv cv cG cfv cA cS csp co
      cmin co cabs cfv vu cv clt wbr wi cc0 cS cno cfv clt wbr cn chil cF wf wa
      vv cv cn wcel wa vv cv cG cfv cA cS csp co cmin co cabs cfv cr wcel vv cv
      cF cfv cA cmv co cno cfv cS cno cfv cmul co cr wcel vu cv cr wcel vv cv
      cG cfv cA cS csp co cmin co cabs cfv vv cv cF cfv cA cmv co cno cfv cS
      cno cfv cmul co cle wbr vv cv cF cfv cA cmv co cno cfv cS cno cfv cmul co
      vu cv clt wbr wa vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv clt wbr
      wi vv cv cG cfv cA cS csp co cmin co cabs cfv vv cv cF cfv cA cmv co cno
      cfv cS cno cfv cmul co vu cv lelttr 3expa cn chil cF wf vv cv cn wcel vv
      cv cG cfv cA cS csp co cmin co cabs cfv cr wcel vv cv cF cfv cA cmv co
      cno cfv cS cno cfv cmul co cr wcel wa cc0 cS cno cfv clt wbr cn chil cF
      wf vv cv cn wcel wa vv cv cG cfv cA cS csp co cmin co cabs cfv cr wcel vv
      cv cF cfv cA cmv co cno cfv cS cno cfv cmul co cr wcel cn chil cF wf vv
      cv cn wcel wa vv cv cG cfv cc wcel cA cS csp co cc wcel wa vv cv cG cfv
      cA cS csp co cmin co cc wcel vv cv cG cfv cA cS csp co cmin co cabs cfv
      cr wcel cn chil cF wf vv cv cn wcel wa vv cv cG cfv cc wcel cA cS csp co
      cc wcel cn cc cG wf vv cv cn wcel vv cv cG cfv cc wcel cn chil cF wf cn
      cc vv cv cG ffvelrn vx vy cS cF cG occllem6.1 occllem6.3 occllem4 sylan
      cA cS occllem6.2 occllem6.3 hicli jctir vv cv cG cfv cA cS csp co subcl
      vv cv cG cfv cA cS csp co cmin co abscl 3syl cn chil cF wf vv cv cn wcel
      wa vv cv cF cfv cA cmv co cno cfv cr wcel cS cno cfv cr wcel wa vv cv cF
      cfv cA cmv co cno cfv cS cno cfv cmul co cr wcel cn chil cF wf vv cv cn
      wcel wa vv cv cF cfv cA cmv co cno cfv cr wcel cS cno cfv cr wcel cn chil
      cF wf vv cv cn wcel wa vv cv cF cfv chil wcel cA chil wcel wa vv cv cF
      cfv cA cmv co chil wcel vv cv cF cfv cA cmv co cno cfv cr wcel cn chil cF
      wf vv cv cn wcel wa vv cv cF cfv chil wcel cA chil wcel cn chil vv cv cF
      ffvelrn occllem6.2 jctir vv cv cF cfv cA hvsubcl vv cv cF cfv cA cmv co
      normcl 3syl cS occllem6.3 normcli jctir vv cv cF cfv cA cmv co cno cfv cS
      cno cfv remulcl syl jca adantll sylan mpand adantrr an1rs sylbird imim2d
      r19.20dva r19.22sdv ex a2d syld exp4a cS chil wcel cS c0v wne cc0 cS cno
      cfv clt wbr wb occllem6.3 cS normgt0 ax-mp sylanb adantrr cc0 vz cv clt
      wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv clt wbr wi
      vv cn wral vw cn wrex wi vz cr wral vu cv cS cno cfv cdiv co cr wcel cc0
      vu cv cS cno cfv cdiv co clt wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv
      co cno cfv vu cv cS cno cfv cdiv co clt wbr wi vv cn wral vw cn wrex cc0
      vz cv clt wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv
      clt wbr wi vv cn wral vw cn wrex wi cc0 vu cv cS cno cfv cdiv co clt wbr
      vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv
      co clt wbr wi vv cn wral vw cn wrex wi vz vu cv cS cno cfv cdiv co cr vz
      cv vu cv cS cno cfv cdiv co wceq cc0 vz cv clt wbr cc0 vu cv cS cno cfv
      cdiv co clt wbr vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv
      clt wbr wi vv cn wral vw cn wrex vw cv vv cv cle wbr vv cv cF cfv cA cmv
      co cno cfv vu cv cS cno cfv cdiv co clt wbr wi vv cn wral vw cn wrex vz
      cv vu cv cS cno cfv cdiv co cc0 clt breq2 vz cv vu cv cS cno cfv cdiv co
      wceq vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vz cv clt wbr wi
      vw cv vv cv cle wbr vv cv cF cfv cA cmv co cno cfv vu cv cS cno cfv cdiv
      co clt wbr wi vw vv cn cn vz cv vu cv cS cno cfv cdiv co wceq vv cv cF
      cfv cA cmv co cno cfv vz cv clt wbr vv cv cF cfv cA cmv co cno cfv vu cv
      cS cno cfv cdiv co clt wbr vw cv vv cv cle wbr vz cv vu cv cS cno cfv
      cdiv co vv cv cF cfv cA cmv co cno cfv clt breq2 imbi2d rexralbidv
      imbi12d rcla4cv imp3a syl5 r19.21adv expimpd jcad vz vw vv cA cF
      occllem6.4 cA chil occllem6.2 elisseti hlimi syl5ib cA cS csp co cc wcel
      vv cv cG cfv cc wcel vv cn wral wa cG cA cS csp co cli wbr cc0 vu cv clt
      wbr vw cv vv cv cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv
      clt wbr wi vv cn wral vw cn wrex wi vu cr wral cA cS csp co cc wcel vv cv
      cG cfv cc wcel vv cn cn cin wral cG cA cS csp co cli wbr cc0 vu cv clt
      wbr vw cv vv cv cle wbr vv cv cG cfv cA cS csp co cmin co cabs cfv vu cv
      clt wbr wi vv cn wral vw cn wrex wi vu cr wral wb vv cv cG cfv cc wcel vv
      cn wral vu cA cS csp co vw vv cG c1 c1 cn cn 1z cn c1 cuz cfv nnuz
      eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz vx vy cn vx cv cF cfv
      cS csp co cG nnex occllem6.1 fopabex2 clm4i cn cn cin cn wss vv cv cG cfv
      cc wcel vv cn wral vv cv cG cfv cc wcel vv cn cn cin wral wi cn cn inss2
      vv cv cG cfv cc wcel vv cn cn cin cn ssralv ax-mp sylan2 biimpar syl6 $.
      $( [17-Nov-2007] $) $( [12-Oct-1999] $)
  $}

  ${
    $d x y z F $.  $d x y z S $.
    occllem7.1 $e |- A e. ~H $.
    occllem7.2 $e |- S e. ~H $.
    occllem7.3 $e |- F e. _V $.
    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem7 $p |- ( ( F ~~>v A /\
               A. x e. NN ( ( F ` x ) .ih S ) = 0 ) -> ( A .ih S ) = 0 ) $=
      cF cA chli wbr vx cv cF cfv cS csp co cc0 wceq vx cn wral wa cA cS csp co
      cc0 wceq wi cS c0v cS c0v wceq cA cS csp co cc0 wceq cF cA chli wbr vx cv
      cF cfv cS csp co cc0 wceq vx cn wral wa cS c0v wceq cA cS csp co cA c0v
      csp co cc0 cS c0v cA csp opreq2 cA chil wcel cA c0v csp co cc0 wceq
      occllem7.1 cA hi02 ax-mp syl6eq a1d cS c0v wne cF cA chli wbr vx cv cF
      cfv cS csp co cc0 wceq vx cn wral wa vy cv cn wcel vz cv vy cv cF cfv cS
      csp co wceq wa vy vz copab cA cS csp co cli wbr vy cv cn wcel vz cv vy cv
      cF cfv cS csp co wceq wa vy vz copab cc0 cli wbr wa cA cS csp co cc0 wceq
      cS c0v wne cF cA chli wbr vy cv cn wcel vz cv vy cv cF cfv cS csp co wceq
      wa vy vz copab cA cS csp co cli wbr vx cv cF cfv cS csp co cc0 wceq vx cn
      wral vy cv cn wcel vz cv vy cv cF cfv cS csp co wceq wa vy vz copab cc0
      cli wbr vy vz cA cS cF vy cv cn wcel vz cv vy cv cF cfv cS csp co wceq wa
      vy vz copab vy cv cn wcel vz cv vy cv cF cfv cS csp co wceq wa vy vz
      copab eqid occllem7.1 occllem7.2 occllem7.3 occllem6 vx cv cF cfv cS csp
      co cc0 wceq vx cn wral vy cv cn wcel vz cv vy cv cF cfv cS csp co wceq wa
      vy vz copab cc0 cli wbr wi cS c0v wne vy vz vx cS cF vy cv cn wcel vz cv
      vy cv cF cfv cS csp co wceq wa vy vz copab vy cv cn wcel vz cv vy cv cF
      cfv cS csp co wceq wa vy vz copab eqid occllem5 a1i anim12d cA cS csp co
      cc0 vy cv cn wcel vz cv vy cv cF cfv cS csp co wceq wa vy vz copab cA cS
      csp oprex cc0 cr 0re elisseti climuni syl6 pm2.61ine $.
      $( [6-Jul-2006] $) $( [12-Oct-1999] $)
  $}

  ${
    $d x y z F $.  $d x y z S $.
    occllem8.1 $e |- F e. _V $.
    $( Lemma for closure of complement of Hilbert subspace.  Part of Remark
       3.12 of [Beran] p. 107. $)
    occllem8 $p |- ( ( A e. ~H /\ S e. ~H ) -> ( ( F ~~>v A /\
             A. x e. NN ( ( F ` x ) .ih S ) = 0 ) -> ( A .ih S ) = 0 ) ) $=
      cA chil wcel cS chil wcel cF cA chli wbr vx cv cF cfv cS csp co cc0 wceq
      vx cn wral wa cA cS csp co cc0 wceq wi cF cA chil wcel cA c0v cif chli
      wbr vx cv cF cfv cS csp co cc0 wceq vx cn wral wa cA chil wcel cA c0v cif
      cS csp co cc0 wceq wi cF cA chil wcel cA c0v cif chli wbr vx cv cF cfv cS
      chil wcel cS c0v cif csp co cc0 wceq vx cn wral wa cA chil wcel cA c0v
      cif cS chil wcel cS c0v cif csp co cc0 wceq wi cA cS c0v c0v cA cA chil
      wcel cA c0v cif wceq cF cA chli wbr vx cv cF cfv cS csp co cc0 wceq vx cn
      wral wa cF cA chil wcel cA c0v cif chli wbr vx cv cF cfv cS csp co cc0
      wceq vx cn wral wa cA cS csp co cc0 wceq cA chil wcel cA c0v cif cS csp
      co cc0 wceq cA cA chil wcel cA c0v cif wceq cF cA chli wbr cF cA chil
      wcel cA c0v cif chli wbr vx cv cF cfv cS csp co cc0 wceq vx cn wral cA cA
      chil wcel cA c0v cif cF chli breq2 anbi1d cA cA chil wcel cA c0v cif wceq
      cA cS csp co cA chil wcel cA c0v cif cS csp co cc0 cA cA chil wcel cA c0v
      cif cS csp opreq1 eqeq1d imbi12d cS cS chil wcel cS c0v cif wceq cF cA
      chil wcel cA c0v cif chli wbr vx cv cF cfv cS csp co cc0 wceq vx cn wral
      wa cF cA chil wcel cA c0v cif chli wbr vx cv cF cfv cS chil wcel cS c0v
      cif csp co cc0 wceq vx cn wral wa cA chil wcel cA c0v cif cS csp co cc0
      wceq cA chil wcel cA c0v cif cS chil wcel cS c0v cif csp co cc0 wceq cS
      cS chil wcel cS c0v cif wceq vx cv cF cfv cS csp co cc0 wceq vx cn wral
      vx cv cF cfv cS chil wcel cS c0v cif csp co cc0 wceq vx cn wral cF cA
      chil wcel cA c0v cif chli wbr cS cS chil wcel cS c0v cif wceq vx cv cF
      cfv cS csp co cc0 wceq vx cv cF cfv cS chil wcel cS c0v cif csp co cc0
      wceq vx cn cS cS chil wcel cS c0v cif wceq vx cv cF cfv cS csp co vx cv
      cF cfv cS chil wcel cS c0v cif csp co cc0 cS cS chil wcel cS c0v cif vx
      cv cF cfv csp opreq2 eqeq1d ralbidv anbi2d cS cS chil wcel cS c0v cif
      wceq cA chil wcel cA c0v cif cS csp co cA chil wcel cA c0v cif cS chil
      wcel cS c0v cif csp co cc0 cS cS chil wcel cS c0v cif cA chil wcel cA c0v
      cif csp opreq2 eqeq1d imbi12d vx cA chil wcel cA c0v cif cS chil wcel cS
      c0v cif cF cA c0v chil ax-hv0cl elimel cS c0v chil ax-hv0cl elimel
      occllem8.1 occllem7 dedth2h $.
      $( [13-Oct-1999] $)
  $}

  ${
    $d x y z f A $.
    occl.1 $e |- A C_ ~H $.
    $( Closure of complement of Hilbert subset.  Part of Remark 3.12 of
       [Beran] p. 107. $)
    occli $p |- ( _|_ ` A ) e. CH $=
      cA cort cfv cch wcel cA cort cfv csh wcel cn cA cort cfv vf cv wf vf cv
      vx cv chli wbr wa vx cv cA cort cfv wcel wi vx wal vf wal vx vf cA cort
      cfv closedsub cA chil wss cA cort cfv csh wcel occl.1 cA ocsh ax-mp cn cA
      cort cfv vf cv wf vf cv vx cv chli wbr wa vx cv cA cort cfv wcel wi vf vx
      cn cA cort cfv vf cv wf vf cv vx cv chli wbr wa vx cv chil wcel vx cv vy
      cv csp co cc0 wceq vy cA wral wa vx cv cA cort cfv wcel cn cA cort cfv vf
      cv wf vf cv vx cv chli wbr wa vx cv chil wcel vx cv vy cv csp co cc0 wceq
      vy cA wral vf cv vx cv chli wbr vx cv chil wcel cn cA cort cfv vf cv wf
      vx cv vf cv vf visset vx visset hlimveci adantl vf cv vx cv chli wbr cn
      cA cort cfv vf cv wf vx cv vy cv csp co cc0 wceq vy cA wral vf cv vx cv
      chli wbr vz cv vf cv cfv vy cv csp co cc0 wceq vz cn wral vy cA wral vx
      cv vy cv csp co cc0 wceq vy cA wral cn cA cort cfv vf cv wf vf cv vx cv
      chli wbr vz cv vf cv cfv vy cv csp co cc0 wceq vz cn wral vx cv vy cv csp
      co cc0 wceq vy cA vf cv vx cv chli wbr vy cv cA wcel vz cv vf cv cfv vy
      cv csp co cc0 wceq vz cn wral vx cv vy cv csp co cc0 wceq wi vx cv chil
      wcel vf cv vx cv chli wbr vy cv cA wcel vz cv vf cv cfv vy cv csp co cc0
      wceq vz cn wral vx cv vy cv csp co cc0 wceq wi wi vx cv vf cv vf visset
      vx visset hlimveci vx cv chil wcel vy cv cA wcel vf cv vx cv chli wbr vz
      cv vf cv cfv vy cv csp co cc0 wceq vz cn wral vx cv vy cv csp co cc0 wceq
      wi vx cv chil wcel vy cv chil wcel vf cv vx cv chli wbr vz cv vf cv cfv
      vy cv csp co cc0 wceq vz cn wral vx cv vy cv csp co cc0 wceq wi wi vy cv
      cA wcel vx cv chil wcel vy cv chil wcel vf cv vx cv chli wbr vz cv vf cv
      cfv vy cv csp co cc0 wceq vz cn wral vx cv vy cv csp co cc0 wceq vz vx cv
      vy cv vf cv vf visset occllem8 exp4b cA chil vy cv occl.1 sseli syl5
      com23 mpcom imp r19.20dva cn cA cort cfv vf cv wf vz cv vf cv cfv vy cv
      csp co cc0 wceq vy cA wral vz cn wral vz cv vf cv cfv vy cv csp co cc0
      wceq vz cn wral vy cA wral cn cA cort cfv vf cv wf vz cv vf cv cfv vy cv
      csp co cc0 wceq vy cA wral vz cn cn cA cort cfv vf cv wf vz cv cn wcel wa
      vz cv vf cv cfv cA cort cfv wcel vz cv vf cv cfv vy cv csp co cc0 wceq vy
      cA wral cn cA cort cfv vz cv vf cv ffvelrn vz cv vf cv cfv cA cort cfv
      wcel vz cv vf cv cfv chil wcel vz cv vf cv cfv vy cv csp co cc0 wceq vy
      cA wral cA chil wss vz cv vf cv cfv cA cort cfv wcel vz cv vf cv cfv chil
      wcel vz cv vf cv cfv vy cv csp co cc0 wceq vy cA wral wa wb occl.1 vy vz
      cv vf cv cfv cA ocel ax-mp pm3.27bi syl r19.21aiva vz cv vf cv cfv vy cv
      csp co cc0 wceq vy vz cA cn ralcom sylibr syl5 impcom jca cA chil wss vx
      cv cA cort cfv wcel vx cv chil wcel vx cv vy cv csp co cc0 wceq vy cA
      wral wa wb occl.1 vy vx cv cA ocel ax-mp sylibr gen2 mpbir2an $.
      $( [7-Aug-2000] $)
  $}

  $( Closure of complement of Hilbert subset.  Part of Remark 3.12 of
     [Beran] p. 107. $)
  occl $p |- ( A C_ ~H -> ( _|_ ` A ) e. CH ) $=
    cA chil wss cA cort cfv cch wcel cA chil wss cA chil cif cort cfv cch wcel
    cA chil cA cA chil wss cA chil cif wceq cA cort cfv cA chil wss cA chil cif
    cort cfv cch cA cA chil wss cA chil cif cort fveq2 eleq1d cA chil wss cA
    chil cif cA chil wss cA chil wss cA chil cif chil wss chil chil wss cA chil
    cA cA chil wss cA chil cif chil sseq1 chil cA chil wss cA chil cif chil
    sseq1 chil ssid elimhyp occli dedth $.
    $( [8-Aug-2000] $)

  $( Closure of complement of Hilbert subspace.  Part of Remark 3.12 of
     [Beran] p. 107. $)
  shoccl $p |- ( A e. SH -> ( _|_ ` A ) e. CH ) $=
    cA csh wcel cA chil wss cA cort cfv cch wcel cA shss cA occl syl $.
    $( [13-Oct-1999] $)

  $( Closure of complement of Hilbert subspace.  Part of Remark 3.12 of
     [Beran] p. 107. $)
  choccl $p |- ( A e. CH -> ( _|_ ` A ) e. CH ) $=
    cA cch wcel cA csh wcel cA cort cfv cch wcel cA chsh cA shoccl syl $.
    $( [22-Jul-2001] $)

  ${
    choccl.1 $e |- A e. CH $.
    $( Closure of ` CH ` orthocomplement. $)
    choccli $p |- ( _|_ ` A ) e. CH $=
      cA cA choccl.1 chssii occli $.
      $( [29-Jul-1999] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projection theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d z w R $.  $d z w D $.
    projlem1.1 $e |- R e. RR $.
    projlem1.2 $e |- D e. RR $.
    $( Part of Lemma 3.6 of [Beran] p. 100: "Choose e > 0.  Let n_0 be a
       natural number satisfying the inequality n_0 > 4(2i_0 + 1) ` x. `
       e ` ^ ` -1."  Used by ~ projlem2 . $)
    projlem1 $p |- ( 0 < D -> E. z e. NN
               ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / z ) < ( D ^ 2 ) ) $=
      cc0 cD clt wbr cD cc0 wne cc0 cD c2 cexp co clt wbr c4 c2 cR cmul co c1
      caddc co cmul co vz cv cdiv co cD c2 cexp co clt wbr vz cn wrex cD
      projlem1.2 gt0ne0i cD projlem1.2 sqgt0i cc0 cD c2 cexp co clt wbr c4 c2
      cR cmul co c1 caddc co cmul co vz cv cdiv co cD c2 cexp co clt wbr vz cn
      wrex c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp co cdiv co vz cv clt
      wbr vz cn wrex cc0 cD c2 cexp co clt wbr cD c2 cexp co cc0 wne c4 c2 cR
      cmul co c1 caddc co cmul co cD c2 cexp co cdiv co cr wcel c4 c2 cR cmul
      co c1 caddc co cmul co cD c2 cexp co cdiv co vz cv clt wbr vz cn wrex cD
      c2 cexp co cD projlem1.2 resqcli gt0ne0i c4 c2 cR cmul co c1 caddc co
      cmul co cD c2 cexp co c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1
      c2 cR 2re projlem1.1 remulcli 1re readdcli remulcli cD projlem1.2 resqcli
      redivclzi c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp co cdiv co vz
      arch 3syl cc0 cD c2 cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co
      vz cv cdiv co cD c2 cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co
      cD c2 cexp co cdiv co vz cv clt wbr vz cn cc0 cD c2 cexp co clt wbr vz cv
      cn wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cD c2 cexp co
      clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp co cdiv co vz cv
      clt wbr wb vz cv cn wcel vz cv cr wcel vz cv cn wcel cc0 cD c2 cexp co
      clt wbr wa c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cD c2 cexp
      co clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp co cdiv co vz
      cv clt wbr wb wi vz cv nnre vz cv cr wcel cc0 vz cv clt wbr cc0 cD c2
      cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cD c2
      cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp co cdiv
      co vz cv clt wbr wb vz cv cn wcel vz cv cr wcel cc0 vz cv clt wbr cc0 cD
      c2 cexp co clt wbr wa c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co
      cD c2 cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp co
      cdiv co vz cv clt wbr wb wi cc0 vz cv cr wcel vz cv cc0 cif clt wbr cc0
      cD c2 cexp co clt wbr wa c4 c2 cR cmul co c1 caddc co cmul co vz cv cr
      wcel vz cv cc0 cif cdiv co cD c2 cexp co clt wbr c4 c2 cR cmul co c1
      caddc co cmul co cD c2 cexp co cdiv co vz cv cr wcel vz cv cc0 cif clt
      wbr wb wi vz cv cc0 vz cv vz cv cr wcel vz cv cc0 cif wceq cc0 vz cv clt
      wbr cc0 cD c2 cexp co clt wbr wa cc0 vz cv cr wcel vz cv cc0 cif clt wbr
      cc0 cD c2 cexp co clt wbr wa c4 c2 cR cmul co c1 caddc co cmul co vz cv
      cdiv co cD c2 cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2
      cexp co cdiv co vz cv clt wbr wb c4 c2 cR cmul co c1 caddc co cmul co vz
      cv cr wcel vz cv cc0 cif cdiv co cD c2 cexp co clt wbr c4 c2 cR cmul co
      c1 caddc co cmul co cD c2 cexp co cdiv co vz cv cr wcel vz cv cc0 cif clt
      wbr wb vz cv vz cv cr wcel vz cv cc0 cif wceq cc0 vz cv clt wbr cc0 vz cv
      cr wcel vz cv cc0 cif clt wbr cc0 cD c2 cexp co clt wbr vz cv vz cv cr
      wcel vz cv cc0 cif cc0 clt breq2 anbi1d vz cv vz cv cr wcel vz cv cc0 cif
      wceq c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cD c2 cexp co clt
      wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cr wcel vz cv cc0 cif cdiv
      co cD c2 cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp
      co cdiv co vz cv clt wbr c4 c2 cR cmul co c1 caddc co cmul co cD c2 cexp
      co cdiv co vz cv cr wcel vz cv cc0 cif clt wbr vz cv vz cv cr wcel vz cv
      cc0 cif wceq c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co c4 c2 cR
      cmul co c1 caddc co cmul co vz cv cr wcel vz cv cc0 cif cdiv co cD c2
      cexp co clt vz cv vz cv cr wcel vz cv cc0 cif c4 c2 cR cmul co c1 caddc
      co cmul co cdiv opreq2 breq1d vz cv vz cv cr wcel vz cv cc0 cif c4 c2 cR
      cmul co c1 caddc co cmul co cD c2 cexp co cdiv co clt breq2 bibi12d
      imbi12d c4 c2 cR cmul co c1 caddc co cmul co vz cv cr wcel vz cv cc0 cif
      cD c2 cexp co c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re
      projlem1.1 remulcli 1re readdcli remulcli vz cv cc0 cr 0re elimel cD
      projlem1.2 resqcli ltdiv23i dedth vz cv nngt0 sylani syl anabsi8 rexbidva
      mpbird 3syl $.
      $( [26-Sep-1999] $)

    ${
      projlem2.3 $e |- 0 <_ R $.
      $( Part of Lemma 3.6 of [Beran] p. 100.  We need the square root for
         the norm limit.  Used by ~ projlem28 . $)
      projlem2 $p |- ( 0 < D -> E. z e. NN
                ( sqr ` ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / z ) ) < D ) $=
        cc0 cD clt wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr
        cfv cD clt wbr vz cn wrex c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co cD c2 cexp co clt wbr vz cn wrex vz cD cR projlem1.1 projlem1.2
        projlem1 cc0 cD clt wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co csqr cfv cD clt wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co cD c2 cexp co clt wbr vz cn cc0 cD clt wbr vz cv cn wcel wa c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv c2 cexp co cD c2
        cexp co clt wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cD
        c2 cexp co clt wbr vz cv cn wcel cc0 cD clt wbr c4 c2 cR cmul co c1
        caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr c4 c2 cR cmul co c1
        caddc co cmul co vz cv cdiv co csqr cfv c2 cexp co cD c2 cexp co clt
        wbr wb c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cr
        wcel cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv
        cle wbr wa cD cr wcel cc0 cD cle wbr wa c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co csqr cfv cD clt wbr c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co csqr cfv c2 cexp co cD c2 cexp co clt wbr wb vz
        cv cn wcel cc0 cD clt wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co csqr cfv cD lt2sq vz cv cn wcel c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co csqr cfv cr wcel cc0 c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co csqr cfv cle wbr c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co cr wcel cc0 c4 c2 cR cmul co c1 caddc co cmul co
        vz cv cdiv co cle wbr c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co csqr cfv cr wcel vz cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co
        vz cv cdiv co sqrcl c4 c2 cR cmul co c1 caddc co cmul co cr wcel vz cv
        cr wcel wa vz cv cc0 wne c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co cr wcel vz cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co cr
        wcel vz cv cr wcel vz cv cc0 wne c4 c2 cR cmul co c1 caddc co cmul co
        vz cv cdiv co cr wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv
        redivcl 3expa vz cv cn wcel vz cv cr wcel c4 c2 cR cmul co c1 caddc co
        cmul co cr wcel vz cv nnre c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul
        co c1 c2 cR 2re projlem1.1 remulcli 1re readdcli remulcli jctil vz cv
        nnne0 sylanc vz cv cr wcel cc0 vz cv clt wbr cc0 c4 c2 cR cmul co c1
        caddc co cmul co vz cv cdiv co cle wbr vz cv cn wcel c4 c2 cR cmul co
        c1 caddc co cmul co cr wcel cc0 c4 c2 cR cmul co c1 caddc co cmul co
        cle wbr vz cv cr wcel cc0 vz cv clt wbr wa cc0 c4 c2 cR cmul co c1
        caddc co cmul co vz cv cdiv co cle wbr c4 c2 cR cmul co c1 caddc co 4re
        c2 cR cmul co c1 c2 cR 2re projlem1.1 remulcli 1re readdcli remulcli
        cc0 c4 c2 cR cmul co c1 caddc co cmul co 0re c4 c2 cR cmul co c1 caddc
        co 4re c2 cR cmul co c1 c2 cR 2re projlem1.1 remulcli 1re readdcli
        remulcli c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re
        projlem1.1 remulcli 1re readdcli 4pos cc0 c2 cR cmul co cle wbr cc0 c1
        clt wbr cc0 c2 cR cmul co c1 caddc co clt wbr cc0 c2 cle wbr cc0 cR cle
        wbr cc0 c2 cR cmul co cle wbr cc0 c2 0re 2re 2pos ltleii projlem2.3 c2
        cR 2re projlem1.1 mulge0i mp2an lt01 c2 cR cmul co c1 c2 cR 2re
        projlem1.1 remulcli 1re addgegt0i mp2an mulgt0ii ltleii c4 c2 cR cmul
        co c1 caddc co cmul co vz cv divge0 mpanl12 vz cv nnre vz cv nngt0
        sylanc sylanc c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr
        wcel cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr cc0
        c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cle wbr vz
        cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co sqrge0 c4
        c2 cR cmul co c1 caddc co cmul co cr wcel vz cv cr wcel wa vz cv cc0
        wne c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel vz cv cn
        wcel c4 c2 cR cmul co c1 caddc co cmul co cr wcel vz cv cr wcel vz cv
        cc0 wne c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel c4
        c2 cR cmul co c1 caddc co cmul co vz cv redivcl 3expa vz cv cn wcel vz
        cv cr wcel c4 c2 cR cmul co c1 caddc co cmul co cr wcel vz cv nnre c4
        c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem1.1
        remulcli 1re readdcli remulcli jctil vz cv nnne0 sylanc vz cv cr wcel
        cc0 vz cv clt wbr cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co cle wbr vz cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co cr wcel
        cc0 c4 c2 cR cmul co c1 caddc co cmul co cle wbr vz cv cr wcel cc0 vz
        cv clt wbr wa cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co
        cle wbr c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re
        projlem1.1 remulcli 1re readdcli remulcli cc0 c4 c2 cR cmul co c1 caddc
        co cmul co 0re c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR
        2re projlem1.1 remulcli 1re readdcli remulcli c4 c2 cR cmul co c1 caddc
        co 4re c2 cR cmul co c1 c2 cR 2re projlem1.1 remulcli 1re readdcli 4pos
        cc0 c2 cR cmul co cle wbr cc0 c1 clt wbr cc0 c2 cR cmul co c1 caddc co
        clt wbr cc0 c2 cle wbr cc0 cR cle wbr cc0 c2 cR cmul co cle wbr cc0 c2
        0re 2re 2pos ltleii projlem2.3 c2 cR 2re projlem1.1 mulge0i mp2an lt01
        c2 cR cmul co c1 c2 cR 2re projlem1.1 remulcli 1re addgegt0i mp2an
        mulgt0ii ltleii c4 c2 cR cmul co c1 caddc co cmul co vz cv divge0
        mpanl12 vz cv nnre vz cv nngt0 sylanc sylanc jca cc0 cD clt wbr cc0 cD
        cle wbr cD cr wcel cc0 cD 0re projlem1.2 ltlei projlem1.2 jctil syl2an
        ancoms vz cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co
        csqr cfv c2 cexp co cD c2 cexp co clt wbr c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co cD c2 cexp co clt wbr wb cc0 cD clt wbr vz cv cn
        wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv c2
        cexp co c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cD c2 cexp
        co clt c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel cc0
        c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv c2 cexp co c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co wceq vz cv cn wcel c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co sqsqr c4 c2 cR cmul co c1
        caddc co cmul co cr wcel vz cv cr wcel wa vz cv cc0 wne c4 c2 cR cmul
        co c1 caddc co cmul co vz cv cdiv co cr wcel vz cv cn wcel c4 c2 cR
        cmul co c1 caddc co cmul co cr wcel vz cv cr wcel vz cv cc0 wne c4 c2
        cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel c4 c2 cR cmul co
        c1 caddc co cmul co vz cv redivcl 3expa vz cv cn wcel vz cv cr wcel c4
        c2 cR cmul co c1 caddc co cmul co cr wcel vz cv nnre c4 c2 cR cmul co
        c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem1.1 remulcli 1re
        readdcli remulcli jctil vz cv nnne0 sylanc vz cv cr wcel cc0 vz cv clt
        wbr cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr vz
        cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co cr wcel cc0 c4 c2 cR
        cmul co c1 caddc co cmul co cle wbr vz cv cr wcel cc0 vz cv clt wbr wa
        cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr c4 c2 cR
        cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem1.1 remulcli
        1re readdcli remulcli cc0 c4 c2 cR cmul co c1 caddc co cmul co 0re c4
        c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem1.1
        remulcli 1re readdcli remulcli c4 c2 cR cmul co c1 caddc co 4re c2 cR
        cmul co c1 c2 cR 2re projlem1.1 remulcli 1re readdcli 4pos cc0 c2 cR
        cmul co cle wbr cc0 c1 clt wbr cc0 c2 cR cmul co c1 caddc co clt wbr
        cc0 c2 cle wbr cc0 cR cle wbr cc0 c2 cR cmul co cle wbr cc0 c2 0re 2re
        2pos ltleii projlem2.3 c2 cR 2re projlem1.1 mulge0i mp2an lt01 c2 cR
        cmul co c1 c2 cR 2re projlem1.1 remulcli 1re addgegt0i mp2an mulgt0ii
        ltleii c4 c2 cR cmul co c1 caddc co cmul co vz cv divge0 mpanl12 vz cv
        nnre vz cv nngt0 sylanc sylanc breq1d adantl bitrd rexbidva mpbird $.
        $( [27-Sep-1999] $)
    $}
  $}

  ${
    projlem3.1 $e |- R e. RR $.
    projlem3.2 $e |- D e. NN $.
    projlem3.3 $e |- G e. NN $.
    $( Part of Lemma 3.6 of [Beran] p. 100, bottom inequality.  Used by
       ~ projlem6 . $)
    projlem3 $p |- ( ( ( 2 x. ( ( R + ( 1 / D ) ) ^ 2 ) ) +
                    ( 2 x. ( ( R + ( 1 / G ) ) ^ 2 ) ) ) -
                           ( 4 x. ( R ^ 2 ) ) ) <_
             ( ( ( 4 x. R ) + 2 ) x. ( ( 1 / D ) + ( 1 / G ) ) ) $=
      c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc
      co c2 cexp co cmul co caddc co c4 cR c2 cexp co cmul co cmin co c2 c2 cR
      c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2
      cexp co c1 cG cdiv co c2 cexp co caddc co caddc co cmul co c4 cR cmul co
      c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co cle c2 cR c1 cD
      cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp
      co cmul co caddc co c4 cR c2 cexp co cmul co cmin co c2 cR c2 cexp co cR
      c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2
      cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2
      cexp co caddc co caddc co caddc co cmul co c2 cR c2 cexp co cR c2 cexp co
      caddc co cmul co cmin co c2 cR c2 cexp co cR c2 cexp co caddc co c2 cR c1
      cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG
      cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co caddc co caddc co caddc
      co cR c2 cexp co cR c2 cexp co caddc co cmin co cmul co c2 c2 cR c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2 cexp co
      c1 cG cdiv co c2 cexp co caddc co caddc co cmul co c2 cR c1 cD cdiv co
      caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul
      co caddc co c2 cR c2 cexp co cR c2 cexp co caddc co c2 cR c1 cD cdiv co
      cmul co cmul co c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG cdiv co
      cmul co cmul co c1 cG cdiv co c2 cexp co caddc co caddc co caddc co cmul
      co c4 cR c2 cexp co cmul co c2 cR c2 cexp co cR c2 cexp co caddc co cmul
      co cmin c2 cR c1 cD cdiv co caddc co c2 cexp co cR c1 cG cdiv co caddc co
      c2 cexp co caddc co cmul co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul
      co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co caddc co c2 cR c2 cexp
      co cR c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv
      co c2 cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co
      c2 cexp co caddc co caddc co caddc co cmul co c2 cR c1 cD cdiv co caddc
      co c2 cexp co cR c1 cG cdiv co caddc co c2 cexp co 2cn cR c1 cD cdiv co
      caddc co c2 cexp co cR c1 cD cdiv co caddc co cR c1 cD cdiv co projlem3.1
      cD cD projlem3.2 nnrei cD projlem3.2 nnne0i rereccli readdcli resqcli
      recni cR c1 cG cdiv co caddc co c2 cexp co cR c1 cG cdiv co caddc co cR
      c1 cG cdiv co projlem3.1 cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli readdcli resqcli recni adddii cR c1 cD cdiv co caddc co c2 cexp
      co cR c1 cG cdiv co caddc co c2 cexp co caddc co cR c2 cexp co cR c2 cexp
      co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co
      caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co
      caddc co caddc co caddc co c2 cmul cR c1 cD cdiv co caddc co c2 cexp co
      cR c1 cG cdiv co caddc co c2 cexp co caddc co cR c2 cexp co c2 cR c1 cD
      cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co caddc co cR c2
      cexp co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co
      caddc co caddc co caddc co cR c2 cexp co cR c2 cexp co caddc co c2 cR c1
      cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG
      cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co caddc co caddc co caddc
      co cR c1 cD cdiv co caddc co c2 cexp co cR c2 cexp co c2 cR c1 cD cdiv co
      cmul co cmul co c1 cD cdiv co c2 cexp co caddc co caddc co cR c1 cG cdiv
      co caddc co c2 cexp co cR c2 cexp co c2 cR c1 cG cdiv co cmul co cmul co
      c1 cG cdiv co c2 cexp co caddc co caddc co caddc cR c1 cD cdiv co caddc
      co c2 cexp co cR c2 cexp co c2 cR c1 cD cdiv co cmul co cmul co caddc co
      c1 cD cdiv co c2 cexp co caddc co cR c2 cexp co c2 cR c1 cD cdiv co cmul
      co cmul co c1 cD cdiv co c2 cexp co caddc co caddc co cR c1 cD cdiv co cR
      projlem3.1 recni c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2
      nnne0i rereccli recni binom2i cR c2 cexp co c2 cR c1 cD cdiv co cmul co
      cmul co c1 cD cdiv co c2 cexp co cR cR projlem3.1 recni sqcli c2 cR c1 cD
      cdiv co cmul co 2cn cR c1 cD cdiv co cR projlem3.1 recni c1 cD cdiv co cD
      cD projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni mulcli mulcli c1
      cD cdiv co c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli recni sqcli addassi eqtri cR c1 cG cdiv co caddc co c2 cexp co
      cR c2 cexp co c2 cR c1 cG cdiv co cmul co cmul co caddc co c1 cG cdiv co
      c2 cexp co caddc co cR c2 cexp co c2 cR c1 cG cdiv co cmul co cmul co c1
      cG cdiv co c2 cexp co caddc co caddc co cR c1 cG cdiv co cR projlem3.1
      recni c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli
      recni binom2i cR c2 cexp co c2 cR c1 cG cdiv co cmul co cmul co c1 cG
      cdiv co c2 cexp co cR cR projlem3.1 recni sqcli c2 cR c1 cG cdiv co cmul
      co 2cn cR c1 cG cdiv co cR projlem3.1 recni c1 cG cdiv co cG cG
      projlem3.3 nnrei cG projlem3.3 nnne0i rereccli recni mulcli mulcli c1 cG
      cdiv co c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli recni sqcli addassi eqtri opreq12i cR c2 cexp co c2 cR c1 cD
      cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co cR c2 cexp co
      c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co caddc co cR
      cR projlem3.1 recni sqcli c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv
      co c2 cexp co c2 cR c1 cD cdiv co cmul co 2cn cR c1 cD cdiv co cR
      projlem3.1 recni c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2
      nnne0i rereccli recni mulcli mulcli c1 cD cdiv co c1 cD cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni sqcli addcli cR cR
      projlem3.1 recni sqcli c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co
      c2 cexp co c2 cR c1 cG cdiv co cmul co 2cn cR c1 cG cdiv co cR projlem3.1
      recni c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli
      recni mulcli mulcli c1 cG cdiv co c1 cG cdiv co cG cG projlem3.3 nnrei cG
      projlem3.3 nnne0i rereccli recni sqcli addcli add4i eqtri opreq2i eqtr3i
      c2 c2 cmul co cR c2 cexp co cmul co c2 c2 cR c2 cexp co cmul co cmul co
      c4 cR c2 cexp co cmul co c2 cR c2 cexp co cR c2 cexp co caddc co cmul co
      c2 c2 cR c2 cexp co 2cn 2cn cR cR projlem3.1 recni sqcli mulassi c2 c2
      cmul co c4 cR c2 cexp co cmul 2t2e4 opreq1i c2 cR c2 cexp co cmul co cR
      c2 cexp co cR c2 cexp co caddc co c2 cmul cR c2 cexp co cR cR projlem3.1
      recni sqcli 2timesi opreq2i 3eqtr3i opreq12i c2 cR c2 cexp co cR c2 cexp
      co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co
      caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co
      caddc co caddc co caddc co cR c2 cexp co cR c2 cexp co caddc co 2cn cR c2
      cexp co cR c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD
      cdiv co c2 cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG
      cdiv co c2 cexp co caddc co caddc co cR c2 cexp co cR c2 cexp co cR cR
      projlem3.1 recni sqcli cR cR projlem3.1 recni sqcli addcli c2 cR c1 cD
      cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG
      cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co caddc co c2 cR c1 cD
      cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co c2 cR c1 cD cdiv co cmul
      co 2cn cR c1 cD cdiv co cR projlem3.1 recni c1 cD cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni mulcli mulcli c1 cD
      cdiv co c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli recni sqcli addcli c2 cR c1 cG cdiv co cmul co cmul co c1 cG
      cdiv co c2 cexp co c2 cR c1 cG cdiv co cmul co 2cn cR c1 cG cdiv co cR
      projlem3.1 recni c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3
      nnne0i rereccli recni mulcli mulcli c1 cG cdiv co c1 cG cdiv co cG cG
      projlem3.3 nnrei cG projlem3.3 nnne0i rereccli recni sqcli addcli addcli
      addcli cR c2 cexp co cR c2 cexp co cR cR projlem3.1 recni sqcli cR cR
      projlem3.1 recni sqcli addcli subdii cR c2 cexp co cR c2 cexp co caddc co
      c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co c2
      cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co caddc co caddc
      co caddc co cR c2 cexp co cR c2 cexp co caddc co cmin co c2 cR c1 cD cdiv
      co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2 cexp co c1 cG
      cdiv co c2 cexp co caddc co caddc co c2 cmul cR c2 cexp co cR c2 cexp co
      caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co
      caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co
      caddc co caddc co caddc co cR c2 cexp co cR c2 cexp co caddc co cmin co
      cR c2 cexp co cR c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co cmul co
      c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1
      cG cdiv co c2 cexp co caddc co caddc co cR c2 cexp co cR c2 cexp co caddc
      co cmin co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2
      cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2
      cexp co caddc co caddc co c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul
      co cmul co c1 cD cdiv co c2 cexp co c1 cG cdiv co c2 cexp co caddc co
      caddc co cR c2 cexp co cR c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co
      cmul co c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG cdiv co cmul co
      cmul co c1 cG cdiv co c2 cexp co caddc co caddc co cR c2 cexp co cR c2
      cexp co caddc co cR c2 cexp co cR c2 cexp co cR cR projlem3.1 recni sqcli
      cR cR projlem3.1 recni sqcli addcli c2 cR c1 cD cdiv co cmul co cmul co
      c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1
      cG cdiv co c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1 cD
      cdiv co c2 cexp co c2 cR c1 cD cdiv co cmul co 2cn cR c1 cD cdiv co cR
      projlem3.1 recni c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2
      nnne0i rereccli recni mulcli mulcli c1 cD cdiv co c1 cD cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni sqcli addcli c2 cR
      c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co c2 cR c1 cG cdiv
      co cmul co 2cn cR c1 cG cdiv co cR projlem3.1 recni c1 cG cdiv co cG cG
      projlem3.3 nnrei cG projlem3.3 nnne0i rereccli recni mulcli mulcli c1 cG
      cdiv co c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli recni sqcli addcli addcli cR c2 cexp co cR c2 cexp co cR cR
      projlem3.1 recni sqcli cR cR projlem3.1 recni sqcli addcli addsubassi cR
      c2 cexp co cR c2 cexp co caddc co c2 cR c1 cD cdiv co cmul co cmul co c1
      cD cdiv co c2 cexp co caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG
      cdiv co c2 cexp co caddc co caddc co cR c2 cexp co cR c2 cexp co cR cR
      projlem3.1 recni sqcli cR cR projlem3.1 recni sqcli addcli c2 cR c1 cD
      cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co caddc co c2 cR c1 cG
      cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co caddc co c2 cR c1 cD
      cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co c2 cR c1 cD cdiv co cmul
      co 2cn cR c1 cD cdiv co cR projlem3.1 recni c1 cD cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni mulcli mulcli c1 cD
      cdiv co c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli recni sqcli addcli c2 cR c1 cG cdiv co cmul co cmul co c1 cG
      cdiv co c2 cexp co c2 cR c1 cG cdiv co cmul co 2cn cR c1 cG cdiv co cR
      projlem3.1 recni c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3
      nnne0i rereccli recni mulcli mulcli c1 cG cdiv co c1 cG cdiv co cG cG
      projlem3.3 nnrei cG projlem3.3 nnne0i rereccli recni sqcli addcli addcli
      pncan3i c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co
      caddc co c2 cR c1 cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co
      caddc co caddc co c2 cR c1 cD cdiv co cmul co cmul co c2 cR c1 cG cdiv co
      cmul co cmul co caddc co c1 cD cdiv co c2 cexp co c1 cG cdiv co c2 cexp
      co caddc co caddc co c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co
      cmul co c1 cD cdiv co c2 cexp co c1 cG cdiv co c2 cexp co caddc co caddc
      co c2 cR c1 cD cdiv co cmul co cmul co c1 cD cdiv co c2 cexp co c2 cR c1
      cG cdiv co cmul co cmul co c1 cG cdiv co c2 cexp co c2 cR c1 cD cdiv co
      cmul co 2cn cR c1 cD cdiv co cR projlem3.1 recni c1 cD cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni mulcli mulcli c1 cD
      cdiv co c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli recni sqcli c2 cR c1 cG cdiv co cmul co 2cn cR c1 cG cdiv co cR
      projlem3.1 recni c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3
      nnne0i rereccli recni mulcli mulcli c1 cG cdiv co c1 cG cdiv co cG cG
      projlem3.3 nnrei cG projlem3.3 nnne0i rereccli recni sqcli add4i c2 cR c1
      cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c2 cR c1 cD cdiv co
      cmul co cmul co c2 cR c1 cG cdiv co cmul co cmul co caddc co c1 cD cdiv
      co c2 cexp co c1 cG cdiv co c2 cexp co caddc co caddc c2 cR c1 cD cdiv co
      c1 cG cdiv co caddc co cmul co cmul co c2 cR c1 cD cdiv co cmul co cR c1
      cG cdiv co cmul co caddc co cmul co c2 cR c1 cD cdiv co cmul co cmul co
      c2 cR c1 cG cdiv co cmul co cmul co caddc co cR c1 cD cdiv co c1 cG cdiv
      co caddc co cmul co cR c1 cD cdiv co cmul co cR c1 cG cdiv co cmul co
      caddc co c2 cmul cR c1 cD cdiv co c1 cG cdiv co cR projlem3.1 recni c1 cD
      cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i rereccli recni c1 cG
      cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli recni adddii
      opreq2i c2 cR c1 cD cdiv co cmul co cR c1 cG cdiv co cmul co 2cn cR c1 cD
      cdiv co cR projlem3.1 recni c1 cD cdiv co cD cD projlem3.2 nnrei cD
      projlem3.2 nnne0i rereccli recni mulcli cR c1 cG cdiv co cR projlem3.1
      recni c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli
      recni mulcli adddii eqtri opreq1i eqtr4i 3eqtri opreq2i 3eqtr2i c2 c2 cR
      c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2
      cexp co c1 cG cdiv co c2 cexp co caddc co caddc co cmul co c2 c2 cR c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv
      co caddc co caddc co cmul co c4 cR cmul co c2 caddc co c1 cD cdiv co c1
      cG cdiv co caddc co cmul co cle c2 cR c1 cD cdiv co c1 cG cdiv co caddc
      co cmul co cmul co c1 cD cdiv co c2 cexp co c1 cG cdiv co c2 cexp co
      caddc co caddc co c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul
      co c1 cD cdiv co c1 cG cdiv co caddc co caddc co cle wbr c2 c2 cR c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2 cexp co
      c1 cG cdiv co c2 cexp co caddc co caddc co cmul co c2 c2 cR c1 cD cdiv co
      c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv co caddc
      co caddc co cmul co cle wbr c1 cD cdiv co c2 cexp co c1 cG cdiv co c2
      cexp co caddc co c1 cD cdiv co c1 cG cdiv co caddc co cle wbr c2 cR c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2 cexp co
      c1 cG cdiv co c2 cexp co caddc co caddc co c2 cR c1 cD cdiv co c1 cG cdiv
      co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv co caddc co caddc co
      cle wbr c1 cD cdiv co c2 cexp co c1 cD cdiv co cle wbr c1 cG cdiv co c2
      cexp co c1 cG cdiv co cle wbr c1 cD cdiv co c2 cexp co c1 cG cdiv co c2
      cexp co caddc co c1 cD cdiv co c1 cG cdiv co caddc co cle wbr c1 cD cdiv
      co c2 cexp co c1 cD c2 cexp co cdiv co c1 cD cdiv co cle cD cD projlem3.2
      nncni cD projlem3.2 nnne0i sqrecii cD cD c2 cexp co cle wbr c1 cD c2 cexp
      co cdiv co c1 cD cdiv co cle wbr cD projlem3.2 nnlesqi cc0 cD clt wbr cc0
      cD c2 cexp co clt wbr cD cD c2 cexp co cle wbr c1 cD c2 cexp co cdiv co
      c1 cD cdiv co cle wbr wb cD projlem3.2 nngt0i cD cc0 wne cc0 cD c2 cexp
      co clt wbr cD projlem3.2 nnne0i cD cD projlem3.2 nnrei sqgt0i ax-mp cD cD
      c2 cexp co cD projlem3.2 nnrei cD cD projlem3.2 nnrei resqcli lereci
      mp2an mpbi eqbrtri c1 cG cdiv co c2 cexp co c1 cG c2 cexp co cdiv co c1
      cG cdiv co cle cG cG projlem3.3 nncni cG projlem3.3 nnne0i sqrecii cG cG
      c2 cexp co cle wbr c1 cG c2 cexp co cdiv co c1 cG cdiv co cle wbr cG
      projlem3.3 nnlesqi cc0 cG clt wbr cc0 cG c2 cexp co clt wbr cG cG c2 cexp
      co cle wbr c1 cG c2 cexp co cdiv co c1 cG cdiv co cle wbr wb cG
      projlem3.3 nngt0i cG cc0 wne cc0 cG c2 cexp co clt wbr cG projlem3.3
      nnne0i cG cG projlem3.3 nnrei sqgt0i ax-mp cG cG c2 cexp co cG projlem3.3
      nnrei cG cG projlem3.3 nnrei resqcli lereci mp2an mpbi eqbrtri c1 cD cdiv
      co c2 cexp co c1 cG cdiv co c2 cexp co c1 cD cdiv co c1 cG cdiv co c1 cD
      cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i rereccli resqcli c1
      cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli resqcli
      cD cD projlem3.2 nnrei cD projlem3.2 nnne0i rereccli cG cG projlem3.3
      nnrei cG projlem3.3 nnne0i rereccli le2addi mp2an c1 cD cdiv co c2 cexp
      co c1 cG cdiv co c2 cexp co caddc co c1 cD cdiv co c1 cG cdiv co caddc co
      c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co
      c2 cexp co c1 cG cdiv co c2 cexp co c1 cD cdiv co cD cD projlem3.2 nnrei
      cD projlem3.2 nnne0i rereccli resqcli c1 cG cdiv co cG cG projlem3.3
      nnrei cG projlem3.3 nnne0i rereccli resqcli readdcli c1 cD cdiv co c1 cG
      cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i rereccli cG cG
      projlem3.3 nnrei cG projlem3.3 nnne0i rereccli readdcli c2 cR c1 cD cdiv
      co c1 cG cdiv co caddc co cmul co 2re cR c1 cD cdiv co c1 cG cdiv co
      caddc co projlem3.1 c1 cD cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei cD
      projlem3.2 nnne0i rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli readdcli remulcli remulcli leadd2i mpbi cc0 c2 clt wbr c2 cR c1
      cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2 cexp
      co c1 cG cdiv co c2 cexp co caddc co caddc co c2 cR c1 cD cdiv co c1 cG
      cdiv co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv co caddc co
      caddc co cle wbr c2 c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co
      cmul co c1 cD cdiv co c2 cexp co c1 cG cdiv co c2 cexp co caddc co caddc
      co cmul co c2 c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co
      c1 cD cdiv co c1 cG cdiv co caddc co caddc co cmul co cle wbr wb 2pos c2
      cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c2
      cexp co c1 cG cdiv co c2 cexp co caddc co caddc co c2 cR c1 cD cdiv co c1
      cG cdiv co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv co caddc co
      caddc co c2 c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c1
      cD cdiv co c2 cexp co c1 cG cdiv co c2 cexp co caddc co c2 cR c1 cD cdiv
      co c1 cG cdiv co caddc co cmul co 2re cR c1 cD cdiv co c1 cG cdiv co
      caddc co projlem3.1 c1 cD cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei cD
      projlem3.2 nnne0i rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli readdcli remulcli remulcli c1 cD cdiv co c2 cexp co c1 cG cdiv
      co c2 cexp co c1 cD cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli resqcli c1 cG cdiv co cG cG projlem3.3 nnrei cG projlem3.3
      nnne0i rereccli resqcli readdcli readdcli c2 cR c1 cD cdiv co c1 cG cdiv
      co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv co caddc co c2 cR c1
      cD cdiv co c1 cG cdiv co caddc co cmul co 2re cR c1 cD cdiv co c1 cG cdiv
      co caddc co projlem3.1 c1 cD cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei
      cD projlem3.2 nnne0i rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli readdcli remulcli remulcli c1 cD cdiv co c1 cG cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli cG cG projlem3.3 nnrei cG
      projlem3.3 nnne0i rereccli readdcli readdcli 2re lemul2i ax-mp mpbi c2 c2
      cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co cmul co c2 c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co caddc co c4 cR cmul co c1 cD cdiv
      co c1 cG cdiv co caddc co cmul co c2 c1 cD cdiv co c1 cG cdiv co caddc co
      cmul co caddc co c2 c2 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co
      cmul co c1 cD cdiv co c1 cG cdiv co caddc co caddc co cmul co c4 cR cmul
      co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co c2 c2 cR c1
      cD cdiv co c1 cG cdiv co caddc co cmul co cmul co cmul co c4 cR cmul co
      c1 cD cdiv co c1 cG cdiv co caddc co cmul co c2 c1 cD cdiv co c1 cG cdiv
      co caddc co cmul co caddc c4 cR cmul co c1 cD cdiv co c1 cG cdiv co caddc
      co cmul co c4 cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c2
      c2 cmul co cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co c2 c2
      cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co cmul co cmul co c4 cR c1
      cD cdiv co c1 cG cdiv co caddc co c4 4re recni cR projlem3.1 recni c1 cD
      cdiv co c1 cG cdiv co caddc co c1 cD cdiv co c1 cG cdiv co cD cD
      projlem3.2 nnrei cD projlem3.2 nnne0i rereccli cG cG projlem3.3 nnrei cG
      projlem3.3 nnne0i rereccli readdcli recni mulassi c2 c2 cmul co c4 cR c1
      cD cdiv co c1 cG cdiv co caddc co cmul co cmul 2t2e4 opreq1i c2 c2 cR c1
      cD cdiv co c1 cG cdiv co caddc co cmul co 2cn 2cn cR c1 cD cdiv co c1 cG
      cdiv co caddc co cR projlem3.1 recni c1 cD cdiv co c1 cG cdiv co caddc co
      c1 cD cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli readdcli
      recni mulcli mulassi 3eqtr2ri opreq1i c2 c2 cR c1 cD cdiv co c1 cG cdiv
      co caddc co cmul co cmul co c1 cD cdiv co c1 cG cdiv co caddc co 2cn c2
      cR c1 cD cdiv co c1 cG cdiv co caddc co cmul co 2cn cR c1 cD cdiv co c1
      cG cdiv co caddc co cR projlem3.1 recni c1 cD cdiv co c1 cG cdiv co caddc
      co c1 cD cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei cD projlem3.2
      nnne0i rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli
      readdcli recni mulcli mulcli c1 cD cdiv co c1 cG cdiv co caddc co c1 cD
      cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei cD projlem3.2 nnne0i
      rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i rereccli readdcli
      recni adddii c4 cR cmul co c2 c1 cD cdiv co c1 cG cdiv co caddc co c4 cR
      cmul co c4 cR 4re projlem3.1 remulcli recni 2cn c1 cD cdiv co c1 cG cdiv
      co caddc co c1 cD cdiv co c1 cG cdiv co cD cD projlem3.2 nnrei cD
      projlem3.2 nnne0i rereccli cG cG projlem3.3 nnrei cG projlem3.3 nnne0i
      rereccli readdcli recni adddiri 3eqtr4i breqtri eqbrtri $.
      $( [16-Sep-1999] $)
  $}

  ${
    projlem4.1 $e |- R e. RR $.
    projlem4.2 $e |- 0 <_ R $.
    projlem4.3 $e |- D e. NN $.
    projlem4.4 $e |- G e. NN $.
    projlem4.5 $e |- B e. NN $.
    $( Part of Lemma 3.6 of [Beran] p. 101, top.  Used by ~ projlem6 . $)
    projlem4 $p |- ( ( B <_ D /\ B <_ G ) ->
             ( ( ( 4 x. R ) + 2 ) x. ( ( 1 / D ) + ( 1 / G ) ) )
           <_ ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / B ) ) $=
      cB cD cle wbr cB cG cle wbr wa c1 cD cdiv co c1 cG cdiv co caddc co c1 cB
      cdiv co c1 cB cdiv co caddc co cle wbr c4 cR cmul co c2 caddc co c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co c4 c2 cR cmul co c1 caddc co cmul
      co cB cdiv co cle wbr c1 cD cdiv co c1 cB cdiv co cle wbr c1 cG cdiv co
      c1 cB cdiv co cle wbr c1 cD cdiv co c1 cG cdiv co caddc co c1 cB cdiv co
      c1 cB cdiv co caddc co cle wbr cB cD cle wbr cB cG cle wbr c1 cD cdiv co
      c1 cG cdiv co c1 cB cdiv co c1 cB cdiv co cD cD projlem4.3 nnrei cD
      projlem4.3 nnne0i rereccli cG cG projlem4.4 nnrei cG projlem4.4 nnne0i
      rereccli cB cB projlem4.5 nnrei cB projlem4.5 nnne0i rereccli cB cB
      projlem4.5 nnrei cB projlem4.5 nnne0i rereccli le2addi cc0 cB clt wbr cc0
      cD clt wbr cB cD cle wbr c1 cD cdiv co c1 cB cdiv co cle wbr wb cB
      projlem4.5 nngt0i cD projlem4.3 nngt0i cB cD cB projlem4.5 nnrei cD
      projlem4.3 nnrei lereci mp2an cc0 cB clt wbr cc0 cG clt wbr cB cG cle wbr
      c1 cG cdiv co c1 cB cdiv co cle wbr wb cB projlem4.5 nngt0i cG projlem4.4
      nngt0i cB cG cB projlem4.5 nnrei cG projlem4.4 nnrei lereci mp2an syl2anb
      c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co c4
      c2 cR cmul co c1 caddc co cmul co cB cdiv co cle wbr c4 cR cmul co c2
      caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co c4 cR cmul co c2
      caddc co c1 cB cdiv co c1 cB cdiv co caddc co cmul co cle wbr c1 cD cdiv
      co c1 cG cdiv co caddc co c1 cB cdiv co c1 cB cdiv co caddc co cle wbr c4
      c2 cR cmul co c1 caddc co cmul co cB cdiv co c4 cR cmul co c2 caddc co c1
      cB cdiv co c1 cB cdiv co caddc co cmul co c4 cR cmul co c2 caddc co c1 cD
      cdiv co c1 cG cdiv co caddc co cmul co cle c4 c2 cR cmul co c1 caddc co
      cmul co cB cdiv co c4 cR cmul co c2 caddc co c2 c1 cmul co cmul co cB
      cdiv co c4 cR cmul co c2 caddc co c2 c1 cmul co cB cdiv co cmul co c4 cR
      cmul co c2 caddc co c1 cB cdiv co c1 cB cdiv co caddc co cmul co c4 c2 cR
      cmul co c1 caddc co cmul co c4 cR cmul co c2 caddc co c2 c1 cmul co cmul
      co cB cdiv c4 cR cmul co c2 caddc co c2 c1 cmul co cmul co c2 c2 cR cmul
      co c1 caddc co cmul co c2 cmul co c2 c2 cmul co c2 cR cmul co c1 caddc co
      cmul co c4 c2 cR cmul co c1 caddc co cmul co c4 cR cmul co c2 caddc co c2
      c2 cR cmul co c1 caddc co cmul co c2 c1 cmul co c2 cmul c2 c2 cR cmul co
      c1 caddc co cmul co c2 c2 cR cmul co cmul co c2 c1 cmul co caddc co c4 cR
      cmul co c2 caddc co c2 c2 cR cmul co c1 2cn c2 cR cmul co c2 cR 2re
      projlem4.1 remulcli recni ax1cn adddii c2 c2 cR cmul co cmul co c4 cR
      cmul co c2 c1 cmul co c2 caddc c2 c2 cmul co cR cmul co c2 c2 cR cmul co
      cmul co c4 cR cmul co c2 c2 cR 2cn 2cn cR projlem4.1 recni mulassi c2 c2
      cmul co c4 cR cmul 2t2e4 opreq1i eqtr3i c2 2cn mulid1i opreq12i eqtr2i c2
      2cn mulid1i opreq12i c2 c2 c2 cR cmul co c1 caddc co 2cn 2cn c2 cR cmul
      co c1 caddc co c2 cR cmul co c1 c2 cR 2re projlem4.1 remulcli 1re
      readdcli recni mul23i c2 c2 cmul co c4 c2 cR cmul co c1 caddc co cmul
      2t2e4 opreq1i 3eqtr2ri opreq1i c4 cR cmul co c2 caddc co c2 c1 cmul co cB
      c4 cR cmul co c2 caddc co c4 cR cmul co c2 c4 cR 4re projlem4.1 remulcli
      2re readdcli recni c2 c1 2cn ax1cn mulcli cB projlem4.5 nncni cB
      projlem4.5 nnne0i divassi c2 c1 cmul co cB cdiv co c1 cB cdiv co c1 cB
      cdiv co caddc co c4 cR cmul co c2 caddc co cmul c2 c1 cmul co cB cdiv co
      c2 c1 cB cdiv co cmul co c1 cB cdiv co c1 cB cdiv co caddc co c2 c1 cB
      2cn ax1cn cB projlem4.5 nncni cB projlem4.5 nnne0i divassi c1 cB cdiv co
      c1 cB cdiv co cB cB projlem4.5 nnrei cB projlem4.5 nnne0i rereccli recni
      2timesi eqtri opreq2i 3eqtri breq2i cc0 c4 cR cmul co c2 caddc co clt wbr
      c1 cD cdiv co c1 cG cdiv co caddc co c1 cB cdiv co c1 cB cdiv co caddc co
      cle wbr c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co
      cmul co c4 cR cmul co c2 caddc co c1 cB cdiv co c1 cB cdiv co caddc co
      cmul co cle wbr wb cc0 c4 cR cmul co cle wbr cc0 c2 clt wbr cc0 c4 cR
      cmul co c2 caddc co clt wbr cc0 c4 cle wbr cc0 cR cle wbr cc0 c4 cR cmul
      co cle wbr cc0 c4 0re 4re 4pos ltleii projlem4.2 c4 cR 4re projlem4.1
      mulge0i mp2an 2pos c4 cR cmul co c2 c4 cR 4re projlem4.1 remulcli 2re
      addgegt0i mp2an c1 cD cdiv co c1 cG cdiv co caddc co c1 cB cdiv co c1 cB
      cdiv co caddc co c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co cD
      cD projlem4.3 nnrei cD projlem4.3 nnne0i rereccli cG cG projlem4.4 nnrei
      cG projlem4.4 nnne0i rereccli readdcli c1 cB cdiv co c1 cB cdiv co cB cB
      projlem4.5 nnrei cB projlem4.5 nnne0i rereccli cB cB projlem4.5 nnrei cB
      projlem4.5 nnne0i rereccli readdcli c4 cR cmul co c2 c4 cR 4re projlem4.1
      remulcli 2re readdcli lemul2i ax-mp bitr4i sylibr $.
      $( [25-Sep-1999] $)
  $}

  ${
    projlem5.1 $e |- A e. ~H $.
    projlem5.2 $e |- B e. ~H $.
    projlem5.3 $e |- C e. ~H $.
    projlem5.4 $e |- R e. RR $.
    projlem5.5 $e |- 0 <_ R $.
    projlem5.6 $e |- ( 4 x. ( R ^ 2 ) ) <_
                     ( ( normh ` ( ( B +h C ) -h ( 2 .h A ) ) ) ^ 2 ) $.
    projlem5.7 $e |- D e. NN $.
    projlem5.8 $e |- G e. NN $.
    projlem5.9 $e |- N e. NN $.
    ${
      projlem5.10 $e |- ( normh ` ( B -h A ) ) < ( R + ( 1 / D ) ) $.
      projlem5.11 $e |- ( normh ` ( C -h A ) ) < ( R + ( 1 / G ) ) $.
      $( Part of Lemma 3.6 of [Beran] p. 100, bottom.  Used by ~ projlem6 . $)
      projlem5 $p |- ( ( normh ` ( B -h C ) ) ^ 2 ) <
                   ( ( ( 2 x. ( ( R + ( 1 / D ) ) ^ 2 ) ) +
                       ( 2 x. ( ( R + ( 1 / G ) ) ^ 2 ) ) ) -
                     ( 4 x. ( R ^ 2 ) ) ) $=
        cB cC cmv co cno cfv c2 cexp co c2 cB cA cmv co cno cfv c2 cexp co cmul
        co c2 cC cA cmv co cno cfv c2 cexp co cmul co caddc co cB cC cva co c2
        cA csm co cmv co cno cfv c2 cexp co cmin co c2 cR c1 cD cdiv co caddc
        co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co
        caddc co c4 cR c2 cexp co cmul co cmin co clt cB cC cA projlem5.2
        projlem5.3 projlem5.1 normpar2i c2 cB cA cmv co cno cfv c2 cexp co cmul
        co c2 cC cA cmv co cno cfv c2 cexp co cmul co caddc co cB cC cva co c2
        cA csm co cmv co cno cfv c2 cexp co cneg caddc co c2 cR c1 cD cdiv co
        caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co caddc co c4 cR c2 cexp co cmul co cneg caddc co c2 cB cA cmv co
        cno cfv c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co
        caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cmin co c2
        cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc
        co c2 cexp co cmul co caddc co c4 cR c2 cexp co cmul co cmin co clt c2
        cB cA cmv co cno cfv c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp
        co cmul co caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co
        cneg caddc co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1
        cG cdiv co caddc co c2 cexp co cmul co caddc co cB cC cva co c2 cA csm
        co cmv co cno cfv c2 cexp co cneg caddc co clt wbr c2 cR c1 cD cdiv co
        caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co
        cneg caddc co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1
        cG cdiv co caddc co c2 cexp co cmul co caddc co c4 cR c2 cexp co cmul
        co cneg caddc co cle wbr c2 cB cA cmv co cno cfv c2 cexp co cmul co c2
        cC cA cmv co cno cfv c2 cexp co cmul co caddc co cB cC cva co c2 cA csm
        co cmv co cno cfv c2 cexp co cneg caddc co c2 cR c1 cD cdiv co caddc co
        c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co
        caddc co c4 cR c2 cexp co cmul co cneg caddc co clt wbr c2 cB cA cmv co
        cno cfv c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co
        caddc co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG
        cdiv co caddc co c2 cexp co cmul co caddc co clt wbr c2 cB cA cmv co
        cno cfv c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co
        caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cneg caddc
        co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co
        caddc co c2 cexp co cmul co caddc co cB cC cva co c2 cA csm co cmv co
        cno cfv c2 cexp co cneg caddc co clt wbr c2 cB cA cmv co cno cfv c2
        cexp co cmul co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co clt wbr
        c2 cC cA cmv co cno cfv c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co
        c2 cexp co cmul co clt wbr c2 cB cA cmv co cno cfv c2 cexp co cmul co
        c2 cC cA cmv co cno cfv c2 cexp co cmul co caddc co c2 cR c1 cD cdiv co
        caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co caddc co clt wbr cB cA cmv co cno cfv c2 cexp co cR c1 cD cdiv
        co caddc co c2 cexp co clt wbr c2 cB cA cmv co cno cfv c2 cexp co cmul
        co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co clt wbr cB cA cmv co
        cno cfv cR c1 cD cdiv co caddc co clt wbr cB cA cmv co cno cfv c2 cexp
        co cR c1 cD cdiv co caddc co c2 cexp co clt wbr projlem5.10 cc0 cB cA
        cmv co cno cfv cle wbr cc0 cR c1 cD cdiv co caddc co cle wbr cB cA cmv
        co cno cfv cR c1 cD cdiv co caddc co clt wbr cB cA cmv co cno cfv c2
        cexp co cR c1 cD cdiv co caddc co c2 cexp co clt wbr wb cB cA cmv co
        chil wcel cc0 cB cA cmv co cno cfv cle wbr cB cA projlem5.2 projlem5.1
        hvsubcli cB cA cmv co normge0 ax-mp cc0 cR cle wbr cc0 c1 cD cdiv co
        cle wbr cc0 cR c1 cD cdiv co caddc co cle wbr projlem5.5 cc0 c1 cD cdiv
        co 0re cD cD projlem5.7 nnrei cD projlem5.7 nnne0i rereccli cD cn wcel
        cc0 c1 cD cdiv co clt wbr projlem5.7 cD nnrecgt0 ax-mp ltleii cR c1 cD
        cdiv co projlem5.4 cD cD projlem5.7 nnrei cD projlem5.7 nnne0i rereccli
        addge0i mp2an cB cA cmv co cno cfv cR c1 cD cdiv co caddc co cB cA cmv
        co cB cA projlem5.2 projlem5.1 hvsubcli normcli cR c1 cD cdiv co
        projlem5.4 cD cD projlem5.7 nnrei cD projlem5.7 nnne0i rereccli
        readdcli lt2sqi mp2an mpbi cc0 c2 clt wbr cB cA cmv co cno cfv c2 cexp
        co cR c1 cD cdiv co caddc co c2 cexp co clt wbr c2 cB cA cmv co cno cfv
        c2 cexp co cmul co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co clt
        wbr wb 2pos cB cA cmv co cno cfv c2 cexp co cR c1 cD cdiv co caddc co
        c2 cexp co c2 cB cA cmv co cno cfv cB cA cmv co cB cA projlem5.2
        projlem5.1 hvsubcli normcli resqcli cR c1 cD cdiv co caddc co cR c1 cD
        cdiv co projlem5.4 cD cD projlem5.7 nnrei cD projlem5.7 nnne0i rereccli
        readdcli resqcli 2re ltmul2i ax-mp mpbi cC cA cmv co cno cfv c2 cexp co
        cR c1 cG cdiv co caddc co c2 cexp co clt wbr c2 cC cA cmv co cno cfv c2
        cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co clt wbr
        cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr cC cA cmv co cno
        cfv c2 cexp co cR c1 cG cdiv co caddc co c2 cexp co clt wbr projlem5.11
        cc0 cC cA cmv co cno cfv cle wbr cc0 cR c1 cG cdiv co caddc co cle wbr
        cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr cC cA cmv co cno
        cfv c2 cexp co cR c1 cG cdiv co caddc co c2 cexp co clt wbr wb cC cA
        cmv co chil wcel cc0 cC cA cmv co cno cfv cle wbr cC cA projlem5.3
        projlem5.1 hvsubcli cC cA cmv co normge0 ax-mp cc0 cR cle wbr cc0 c1 cG
        cdiv co cle wbr cc0 cR c1 cG cdiv co caddc co cle wbr projlem5.5 cc0 c1
        cG cdiv co 0re cG cG projlem5.8 nnrei cG projlem5.8 nnne0i rereccli cG
        cn wcel cc0 c1 cG cdiv co clt wbr projlem5.8 cG nnrecgt0 ax-mp ltleii
        cR c1 cG cdiv co projlem5.4 cG cG projlem5.8 nnrei cG projlem5.8 nnne0i
        rereccli addge0i mp2an cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
        cC cA cmv co cC cA projlem5.3 projlem5.1 hvsubcli normcli cR c1 cG cdiv
        co projlem5.4 cG cG projlem5.8 nnrei cG projlem5.8 nnne0i rereccli
        readdcli lt2sqi mp2an mpbi cc0 c2 clt wbr cC cA cmv co cno cfv c2 cexp
        co cR c1 cG cdiv co caddc co c2 cexp co clt wbr c2 cC cA cmv co cno cfv
        c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co clt
        wbr wb 2pos cC cA cmv co cno cfv c2 cexp co cR c1 cG cdiv co caddc co
        c2 cexp co c2 cC cA cmv co cno cfv cC cA cmv co cC cA projlem5.3
        projlem5.1 hvsubcli normcli resqcli cR c1 cG cdiv co caddc co cR c1 cG
        cdiv co projlem5.4 cG cG projlem5.8 nnrei cG projlem5.8 nnne0i rereccli
        readdcli resqcli 2re ltmul2i ax-mp mpbi c2 cB cA cmv co cno cfv c2 cexp
        co cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co c2 cR c1 cD cdiv
        co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co c2 cB cA cmv co cno cfv c2 cexp co 2re cB cA cmv co cno cfv cB
        cA cmv co cB cA projlem5.2 projlem5.1 hvsubcli normcli resqcli remulcli
        c2 cC cA cmv co cno cfv c2 cexp co 2re cC cA cmv co cno cfv cC cA cmv
        co cC cA projlem5.3 projlem5.1 hvsubcli normcli resqcli remulcli c2 cR
        c1 cD cdiv co caddc co c2 cexp co 2re cR c1 cD cdiv co caddc co cR c1
        cD cdiv co projlem5.4 cD cD projlem5.7 nnrei cD projlem5.7 nnne0i
        rereccli readdcli resqcli remulcli c2 cR c1 cG cdiv co caddc co c2 cexp
        co 2re cR c1 cG cdiv co caddc co cR c1 cG cdiv co projlem5.4 cG cG
        projlem5.8 nnrei cG projlem5.8 nnne0i rereccli readdcli resqcli
        remulcli lt2addi mp2an c2 cB cA cmv co cno cfv c2 cexp co cmul co c2 cC
        cA cmv co cno cfv c2 cexp co cmul co caddc co c2 cR c1 cD cdiv co caddc
        co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co
        caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cneg c2 cB
        cA cmv co cno cfv c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp co
        cmul co c2 cB cA cmv co cno cfv c2 cexp co 2re cB cA cmv co cno cfv cB
        cA cmv co cB cA projlem5.2 projlem5.1 hvsubcli normcli resqcli remulcli
        c2 cC cA cmv co cno cfv c2 cexp co 2re cC cA cmv co cno cfv cC cA cmv
        co cC cA projlem5.3 projlem5.1 hvsubcli normcli resqcli remulcli
        readdcli c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG
        cdiv co caddc co c2 cexp co cmul co c2 cR c1 cD cdiv co caddc co c2
        cexp co 2re cR c1 cD cdiv co caddc co cR c1 cD cdiv co projlem5.4 cD cD
        projlem5.7 nnrei cD projlem5.7 nnne0i rereccli readdcli resqcli
        remulcli c2 cR c1 cG cdiv co caddc co c2 cexp co 2re cR c1 cG cdiv co
        caddc co cR c1 cG cdiv co projlem5.4 cG cG projlem5.8 nnrei cG
        projlem5.8 nnne0i rereccli readdcli resqcli remulcli readdcli cB cC cva
        co c2 cA csm co cmv co cno cfv c2 cexp co cB cC cva co c2 cA csm co cmv
        co cno cfv cB cC cva co c2 cA csm co cmv co cB cC cva co c2 cA csm co
        cB cC projlem5.2 projlem5.3 hvaddcli c2 cA 2cn projlem5.1 hvmulcli
        hvsubcli normcli resqcli renegcli ltadd1i mpbi cB cC cva co c2 cA csm
        co cmv co cno cfv c2 cexp co cneg c4 cR c2 cexp co cmul co cneg cle wbr
        c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co
        caddc co c2 cexp co cmul co caddc co cB cC cva co c2 cA csm co cmv co
        cno cfv c2 cexp co cneg caddc co c2 cR c1 cD cdiv co caddc co c2 cexp
        co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co caddc co c4
        cR c2 cexp co cmul co cneg caddc co cle wbr c4 cR c2 cexp co cmul co cB
        cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cle wbr cB cC cva co
        c2 cA csm co cmv co cno cfv c2 cexp co cneg c4 cR c2 cexp co cmul co
        cneg cle wbr projlem5.6 c4 cR c2 cexp co cmul co cB cC cva co c2 cA csm
        co cmv co cno cfv c2 cexp co c4 cR c2 cexp co 4re cR projlem5.4 resqcli
        remulcli cB cC cva co c2 cA csm co cmv co cno cfv cB cC cva co c2 cA
        csm co cmv co cB cC cva co c2 cA csm co cB cC projlem5.2 projlem5.3
        hvaddcli c2 cA 2cn projlem5.1 hvmulcli hvsubcli normcli resqcli lenegi
        mpbi cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cneg c4 cR c2
        cexp co cmul co cneg c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2
        cR c1 cG cdiv co caddc co c2 cexp co cmul co caddc co cB cC cva co c2
        cA csm co cmv co cno cfv c2 cexp co cB cC cva co c2 cA csm co cmv co
        cno cfv cB cC cva co c2 cA csm co cmv co cB cC cva co c2 cA csm co cB
        cC projlem5.2 projlem5.3 hvaddcli c2 cA 2cn projlem5.1 hvmulcli
        hvsubcli normcli resqcli renegcli c4 cR c2 cexp co cmul co c4 cR c2
        cexp co 4re cR projlem5.4 resqcli remulcli renegcli c2 cR c1 cD cdiv co
        caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co c2 cR c1 cD cdiv co caddc co c2 cexp co 2re cR c1 cD cdiv co
        caddc co cR c1 cD cdiv co projlem5.4 cD cD projlem5.7 nnrei cD
        projlem5.7 nnne0i rereccli readdcli resqcli remulcli c2 cR c1 cG cdiv
        co caddc co c2 cexp co 2re cR c1 cG cdiv co caddc co cR c1 cG cdiv co
        projlem5.4 cG cG projlem5.8 nnrei cG projlem5.8 nnne0i rereccli
        readdcli resqcli remulcli readdcli leadd2i mpbi c2 cB cA cmv co cno cfv
        c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co caddc co
        cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cneg caddc co c2 cR
        c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co
        c2 cexp co cmul co caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2
        cexp co cneg caddc co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co
        c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co caddc co c4 cR c2 cexp
        co cmul co cneg caddc co c2 cB cA cmv co cno cfv c2 cexp co cmul co c2
        cC cA cmv co cno cfv c2 cexp co cmul co caddc co cB cC cva co c2 cA csm
        co cmv co cno cfv c2 cexp co cneg c2 cB cA cmv co cno cfv c2 cexp co
        cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co c2 cB cA cmv co cno
        cfv c2 cexp co 2re cB cA cmv co cno cfv cB cA cmv co cB cA projlem5.2
        projlem5.1 hvsubcli normcli resqcli remulcli c2 cC cA cmv co cno cfv c2
        cexp co 2re cC cA cmv co cno cfv cC cA cmv co cC cA projlem5.3
        projlem5.1 hvsubcli normcli resqcli remulcli readdcli cB cC cva co c2
        cA csm co cmv co cno cfv c2 cexp co cB cC cva co c2 cA csm co cmv co
        cno cfv cB cC cva co c2 cA csm co cmv co cB cC cva co c2 cA csm co cB
        cC projlem5.2 projlem5.3 hvaddcli c2 cA 2cn projlem5.1 hvmulcli
        hvsubcli normcli resqcli renegcli readdcli c2 cR c1 cD cdiv co caddc co
        c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co
        caddc co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cneg c2 cR
        c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co
        c2 cexp co cmul co c2 cR c1 cD cdiv co caddc co c2 cexp co 2re cR c1 cD
        cdiv co caddc co cR c1 cD cdiv co projlem5.4 cD cD projlem5.7 nnrei cD
        projlem5.7 nnne0i rereccli readdcli resqcli remulcli c2 cR c1 cG cdiv
        co caddc co c2 cexp co 2re cR c1 cG cdiv co caddc co cR c1 cG cdiv co
        projlem5.4 cG cG projlem5.8 nnrei cG projlem5.8 nnne0i rereccli
        readdcli resqcli remulcli readdcli cB cC cva co c2 cA csm co cmv co cno
        cfv c2 cexp co cB cC cva co c2 cA csm co cmv co cno cfv cB cC cva co c2
        cA csm co cmv co cB cC cva co c2 cA csm co cB cC projlem5.2 projlem5.3
        hvaddcli c2 cA 2cn projlem5.1 hvmulcli hvsubcli normcli resqcli
        renegcli readdcli c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR
        c1 cG cdiv co caddc co c2 cexp co cmul co caddc co c4 cR c2 cexp co
        cmul co cneg c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1
        cG cdiv co caddc co c2 cexp co cmul co c2 cR c1 cD cdiv co caddc co c2
        cexp co 2re cR c1 cD cdiv co caddc co cR c1 cD cdiv co projlem5.4 cD cD
        projlem5.7 nnrei cD projlem5.7 nnne0i rereccli readdcli resqcli
        remulcli c2 cR c1 cG cdiv co caddc co c2 cexp co 2re cR c1 cG cdiv co
        caddc co cR c1 cG cdiv co projlem5.4 cG cG projlem5.8 nnrei cG
        projlem5.8 nnne0i rereccli readdcli resqcli remulcli readdcli c4 cR c2
        cexp co cmul co c4 cR c2 cexp co 4re cR projlem5.4 resqcli remulcli
        renegcli readdcli ltletri mp2an c2 cB cA cmv co cno cfv c2 cexp co cmul
        co c2 cC cA cmv co cno cfv c2 cexp co cmul co caddc co cB cC cva co c2
        cA csm co cmv co cno cfv c2 cexp co c2 cB cA cmv co cno cfv c2 cexp co
        cmul co c2 cC cA cmv co cno cfv c2 cexp co cmul co caddc co c2 cB cA
        cmv co cno cfv c2 cexp co cmul co c2 cC cA cmv co cno cfv c2 cexp co
        cmul co c2 cB cA cmv co cno cfv c2 cexp co 2re cB cA cmv co cno cfv cB
        cA cmv co cB cA projlem5.2 projlem5.1 hvsubcli normcli resqcli remulcli
        c2 cC cA cmv co cno cfv c2 cexp co 2re cC cA cmv co cno cfv cC cA cmv
        co cC cA projlem5.3 projlem5.1 hvsubcli normcli resqcli remulcli
        readdcli recni cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cB
        cC cva co c2 cA csm co cmv co cno cfv cB cC cva co c2 cA csm co cmv co
        cB cC cva co c2 cA csm co cB cC projlem5.2 projlem5.3 hvaddcli c2 cA
        2cn projlem5.1 hvmulcli hvsubcli normcli resqcli recni negsubi c2 cR c1
        cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2
        cexp co cmul co caddc co c4 cR c2 cexp co cmul co c2 cR c1 cD cdiv co
        caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co caddc co c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR
        c1 cG cdiv co caddc co c2 cexp co cmul co c2 cR c1 cD cdiv co caddc co
        c2 cexp co 2re cR c1 cD cdiv co caddc co cR c1 cD cdiv co projlem5.4 cD
        cD projlem5.7 nnrei cD projlem5.7 nnne0i rereccli readdcli resqcli
        remulcli c2 cR c1 cG cdiv co caddc co c2 cexp co 2re cR c1 cG cdiv co
        caddc co cR c1 cG cdiv co projlem5.4 cG cG projlem5.8 nnrei cG
        projlem5.8 nnne0i rereccli readdcli resqcli remulcli readdcli recni c4
        cR c2 cexp co cmul co c4 cR c2 cexp co 4re cR projlem5.4 resqcli
        remulcli recni negsubi 3brtr3i eqbrtri $.
        $( [14-Sep-1999] $)

      $( Part of Lemma 3.6 of [Beran] p. 101.  Used by ~ projlem7 . $)
      projlem6 $p |- ( ( N <_ D /\ N <_ G ) ->
           ( normh ` ( B -h C ) ) <
         ( sqr ` ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / N ) ) ) $=
        cN cD cle wbr cN cG cle wbr wa cB cC cmv co cno cfv c2 cexp co c4 c2 cR
        cmul co c1 caddc co cmul co cN cdiv co csqr cfv c2 cexp co clt wbr cB
        cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr
        cfv clt wbr cN cD cle wbr cN cG cle wbr wa cB cC cmv co cno cfv c2 cexp
        co c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co c4 c2 cR cmul co c1
        caddc co cmul co cN cdiv co csqr cfv c2 cexp co clt cN cD cle wbr cN cG
        cle wbr wa c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc
        co cmul co c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co cle wbr cB
        cC cmv co cno cfv c2 cexp co c4 c2 cR cmul co c1 caddc co cmul co cN
        cdiv co clt wbr cN cD cR cG projlem5.4 projlem5.5 projlem5.7 projlem5.8
        projlem5.9 projlem4 cB cC cmv co cno cfv c2 cexp co c4 cR cmul co c2
        caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co clt wbr c4 cR
        cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co c4 c2
        cR cmul co c1 caddc co cmul co cN cdiv co cle wbr cB cC cmv co cno cfv
        c2 cexp co c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co clt wbr cB
        cC cmv co cno cfv c2 cexp co c2 cR c1 cD cdiv co caddc co c2 cexp co
        cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co caddc co c4 cR
        c2 cexp co cmul co cmin co clt wbr c2 cR c1 cD cdiv co caddc co c2 cexp
        co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co cmul co caddc co c4
        cR c2 cexp co cmul co cmin co c4 cR cmul co c2 caddc co c1 cD cdiv co
        c1 cG cdiv co caddc co cmul co cle wbr cB cC cmv co cno cfv c2 cexp co
        c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co
        clt wbr cA cB cC cD cR cG cD projlem5.1 projlem5.2 projlem5.3
        projlem5.4 projlem5.5 projlem5.6 projlem5.7 projlem5.8 projlem5.7
        projlem5.10 projlem5.11 projlem5 cD cR cG projlem5.4 projlem5.7
        projlem5.8 projlem3 cB cC cmv co cno cfv c2 cexp co c2 cR c1 cD cdiv co
        caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2 cexp co
        cmul co caddc co c4 cR c2 cexp co cmul co cmin co c4 cR cmul co c2
        caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul co cB cC cmv co cno
        cfv cB cC cmv co cB cC projlem5.2 projlem5.3 hvsubcli normcli resqcli
        c2 cR c1 cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co
        caddc co c2 cexp co cmul co caddc co c4 cR c2 cexp co cmul co c2 cR c1
        cD cdiv co caddc co c2 cexp co cmul co c2 cR c1 cG cdiv co caddc co c2
        cexp co cmul co c2 cR c1 cD cdiv co caddc co c2 cexp co 2re cR c1 cD
        cdiv co caddc co cR c1 cD cdiv co projlem5.4 cD cD projlem5.7 nnrei cD
        projlem5.7 nnne0i rereccli readdcli resqcli remulcli c2 cR c1 cG cdiv
        co caddc co c2 cexp co 2re cR c1 cG cdiv co caddc co cR c1 cG cdiv co
        projlem5.4 cG cG projlem5.8 nnrei cG projlem5.8 nnne0i rereccli
        readdcli resqcli remulcli readdcli c4 cR c2 cexp co 4re cR projlem5.4
        resqcli remulcli resubcli c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG
        cdiv co caddc co c4 cR cmul co c2 c4 cR 4re projlem5.4 remulcli 2re
        readdcli c1 cD cdiv co c1 cG cdiv co cD cD projlem5.7 nnrei cD
        projlem5.7 nnne0i rereccli cG cG projlem5.8 nnrei cG projlem5.8 nnne0i
        rereccli readdcli remulcli ltletri mp2an cB cC cmv co cno cfv c2 cexp
        co c4 cR cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co cmul
        co c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co cB cC cmv co cno cfv
        cB cC cmv co cB cC projlem5.2 projlem5.3 hvsubcli normcli resqcli c4 cR
        cmul co c2 caddc co c1 cD cdiv co c1 cG cdiv co caddc co c4 cR cmul co
        c2 c4 cR 4re projlem5.4 remulcli 2re readdcli c1 cD cdiv co c1 cG cdiv
        co cD cD projlem5.7 nnrei cD projlem5.7 nnne0i rereccli cG cG
        projlem5.8 nnrei cG projlem5.8 nnne0i rereccli readdcli remulcli c4 c2
        cR cmul co c1 caddc co cmul co cN c4 c2 cR cmul co c1 caddc co 4re c2
        cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re readdcli remulcli cN
        projlem5.9 nnrei cN projlem5.9 nnne0i redivcli ltletri mpan syl cc0 c4
        c2 cR cmul co c1 caddc co cmul co cN cdiv co cle wbr c4 c2 cR cmul co
        c1 caddc co cmul co cN cdiv co csqr cfv c2 cexp co c4 c2 cR cmul co c1
        caddc co cmul co cN cdiv co wceq cc0 c4 c2 cR cmul co c1 caddc co cmul
        co cN cdiv co 0re c4 c2 cR cmul co c1 caddc co cmul co cN c4 c2 cR cmul
        co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re
        readdcli remulcli cN projlem5.9 nnrei cN projlem5.9 nnne0i redivcli c4
        c2 cR cmul co c1 caddc co cmul co cN c4 c2 cR cmul co c1 caddc co 4re
        c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re readdcli remulcli cN
        projlem5.9 nnrei c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2
        cR 2re projlem5.4 remulcli 1re readdcli 4pos cc0 c2 cR cmul co cle wbr
        cc0 c1 clt wbr cc0 c2 cR cmul co c1 caddc co clt wbr cc0 c2 cle wbr cc0
        cR cle wbr cc0 c2 cR cmul co cle wbr cc0 c2 0re 2re 2pos ltleii
        projlem5.5 c2 cR 2re projlem5.4 mulge0i mp2an lt01 c2 cR cmul co c1 c2
        cR 2re projlem5.4 remulcli 1re addgegt0i mp2an mulgt0ii cN projlem5.9
        nngt0i divgt0ii ltleii c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co
        c4 c2 cR cmul co c1 caddc co cmul co cN c4 c2 cR cmul co c1 caddc co
        4re c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re readdcli
        remulcli cN projlem5.9 nnrei cN projlem5.9 nnne0i redivcli sqsqri ax-mp
        syl6breqr cc0 cB cC cmv co cno cfv cle wbr cc0 c4 c2 cR cmul co c1
        caddc co cmul co cN cdiv co csqr cfv cle wbr cB cC cmv co cno cfv c4 c2
        cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr cB cC cmv co
        cno cfv c2 cexp co c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr
        cfv c2 cexp co clt wbr wb cB cC cmv co chil wcel cc0 cB cC cmv co cno
        cfv cle wbr cB cC projlem5.2 projlem5.3 hvsubcli cB cC cmv co normge0
        ax-mp cc0 c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co cle wbr cc0
        c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv cle wbr cc0 c4
        c2 cR cmul co c1 caddc co cmul co cN cdiv co 0re c4 c2 cR cmul co c1
        caddc co cmul co cN c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1
        c2 cR 2re projlem5.4 remulcli 1re readdcli remulcli cN projlem5.9 nnrei
        cN projlem5.9 nnne0i redivcli c4 c2 cR cmul co c1 caddc co cmul co cN
        c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem5.4
        remulcli 1re readdcli remulcli cN projlem5.9 nnrei c4 c2 cR cmul co c1
        caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re
        readdcli 4pos cc0 c2 cR cmul co cle wbr cc0 c1 clt wbr cc0 c2 cR cmul
        co c1 caddc co clt wbr cc0 c2 cle wbr cc0 cR cle wbr cc0 c2 cR cmul co
        cle wbr cc0 c2 0re 2re 2pos ltleii projlem5.5 c2 cR 2re projlem5.4
        mulge0i mp2an lt01 c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re
        addgegt0i mp2an mulgt0ii cN projlem5.9 nngt0i divgt0ii ltleii c4 c2 cR
        cmul co c1 caddc co cmul co cN cdiv co c4 c2 cR cmul co c1 caddc co
        cmul co cN c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re
        projlem5.4 remulcli 1re readdcli remulcli cN projlem5.9 nnrei cN
        projlem5.9 nnne0i redivcli sqrge0i ax-mp cB cC cmv co cno cfv c4 c2 cR
        cmul co c1 caddc co cmul co cN cdiv co csqr cfv cB cC cmv co cB cC
        projlem5.2 projlem5.3 hvsubcli normcli c4 c2 cR cmul co c1 caddc co
        cmul co cN cdiv co c4 c2 cR cmul co c1 caddc co cmul co cN c4 c2 cR
        cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli
        1re readdcli remulcli cN projlem5.9 nnrei cN projlem5.9 nnne0i redivcli
        c4 c2 cR cmul co c1 caddc co cmul co cN c4 c2 cR cmul co c1 caddc co
        4re c2 cR cmul co c1 c2 cR 2re projlem5.4 remulcli 1re readdcli
        remulcli cN projlem5.9 nnrei c4 c2 cR cmul co c1 caddc co 4re c2 cR
        cmul co c1 c2 cR 2re projlem5.4 remulcli 1re readdcli 4pos cc0 c2 cR
        cmul co cle wbr cc0 c1 clt wbr cc0 c2 cR cmul co c1 caddc co clt wbr
        cc0 c2 cle wbr cc0 cR cle wbr cc0 c2 cR cmul co cle wbr cc0 c2 0re 2re
        2pos ltleii projlem5.5 c2 cR 2re projlem5.4 mulge0i mp2an lt01 c2 cR
        cmul co c1 c2 cR 2re projlem5.4 remulcli 1re addgegt0i mp2an mulgt0ii
        cN projlem5.9 nngt0i divgt0ii sqrlem24 lt2sqi mp2an sylibr $.
        $( [5-Oct-1999] $)
    $}
    $( Part of Lemma 3.6 of [Beran] p. 101.  Applies weak deduction theorem to
       ~ projlem6 .  Used by ~ projlem19 . $)
    projlem7 $p |- ( ( ( normh ` ( B -h A ) ) < ( R + ( 1 / D ) ) /\
                     ( normh ` ( C -h A ) ) < ( R + ( 1 / G ) ) ) ->
                     ( ( N <_ D /\ N <_ G ) ->
             ( normh ` ( B -h C ) ) <
           ( sqr ` ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / N ) ) ) ) $=
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cN cD cle wbr cN cG cle wbr wa
      cB cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr
      cfv clt wbr wi cN cD cle wbr cN cG cle wbr wa cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cB cA cif cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co
      cmul co cN cdiv co csqr cfv clt wbr wi cN cD cle wbr cN cG cle wbr wa cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul
      co cN cdiv co csqr cfv clt wbr wi cN cD cle wbr cN cG cle wbr wa cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cC cA cif cmv co cno cfv c4 c2 cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cR cc0 cif cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt
      wbr wi cB cC cR cA cA cc0 cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB
      cA cif wceq cB cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN
      cdiv co csqr cfv clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co
      csqr cfv clt wbr cN cD cle wbr cN cG cle wbr wa cB cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif wceq cB cC cmv co cno cfv cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cB cA cif cC cmv co cno cfv c4 c2 cR cmul co c1
      caddc co cmul co cN cdiv co csqr cfv clt cB cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cif wceq cB cC cmv co cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif cC cmv co cno cB cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cC cmv opreq1 fveq2d breq1d imbi2d cC cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN
      cdiv co csqr cfv clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cmv co cno cfv c4
      c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr cN cD cle
      wbr cN cG cle wbr wa cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cC cmv co cno
      cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cC cA cif cmv co cno cfv c4 c2 cR cmul co c1 caddc
      co cmul co cN cdiv co csqr cfv clt cC cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cC cA cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cC cmv co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cC cA cif cmv co cno cC cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cC cA cif cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cmv opreq2 fveq2d breq1d imbi2d cR cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cmv co cno
      cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif cmv co cno cfv c4 c2 cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cR cc0 cif cmul co c1 caddc co cmul co cN cdiv co csqr cfv
      clt wbr cN cD cle wbr cN cG cle wbr wa cR cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cR cc0 cif wceq c4 c2 cR cmul co c1 caddc co cmul co cN cdiv
      co csqr cfv c4 c2 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif cmul
      co c1 caddc co cmul co cN cdiv co csqr cfv cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif
      cmv co cno cfv clt cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif
      wceq c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co c4 c2 cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cR cc0 cif cmul co c1 caddc co cmul co cN
      cdiv co csqr cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif wceq c4
      c2 cR cmul co c1 caddc co cmul co c4 c2 cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cR cc0 cif cmul co c1 caddc co cmul co cN cdiv cR cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cR cc0 cif wceq c2 cR cmul co c1 caddc co c2
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif cmul co c1 caddc co
      c4 cmul cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif wceq c2 cR
      cmul co c2 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif cmul co c1
      caddc cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c2 cmul opreq2
      opreq1d opreq2d opreq1d fveq2d breq2d imbi2d cA cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cD cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif cG cN
      projlem5.1 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA chil projlem5.2
      projlem5.1 keepel cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA chil
      projlem5.3 projlem5.1 keepel cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR
      cc0 cr projlem5.4 0re keepel cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cc0
      cR cle wbr cc0 cc0 cle wbr cc0 cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif cle wbr cR cc0 cR cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif cc0 cle breq2 cc0 cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif cc0 cle breq2 projlem5.5 cc0 0re leidi keephyp cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa c4 cR c2 cexp co cmul co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cC cva co c2 cA csm co cmv co cno cfv c2
      cexp co cle wbr c4 cR c2 cexp co cmul co cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif
      cva co c2 cA csm co cmv co cno cfv c2 cexp co cle wbr c4 cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cR cc0 cif c2 cexp co cmul co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cva co c2 cA csm co cmv co cno cfv c2 cexp co cle wbr cB cC cR cA
      cA cc0 c4 cc0 c2 cexp co cmul co cA cA cva co c2 cA csm co cmv co cno cfv
      c2 cexp co cle wbr c4 cc0 c2 cexp co cmul co cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cB cA cif cA cva co c2 cA csm co cmv co cno cfv c2 cexp co
      cle wbr c4 cc0 c2 cexp co cmul co cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cva co c2
      cA csm co cmv co cno cfv c2 cexp co cle wbr c4 cR c2 cexp co cmul co cB
      cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cle wbr cB cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cB cA cif wceq cB cC cva co c2 cA csm co cmv
      co cno cfv c2 cexp co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cC cva co c2 cA csm co cmv co cno cfv c2 cexp co c4 cR c2 cexp co cmul co
      cle cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif wceq cB cC cva
      co c2 cA csm co cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cC cva co c2 cA csm co cmv co cno cfv c2 cexp cB cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cB cA cif wceq cB cC cva co c2 cA csm co
      cmv co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cC cva co c2 cA
      csm co cmv co cno cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      wceq cB cC cva co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cC
      cva co c2 cA csm co cmv cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cC cva opreq1 opreq1d fveq2d opreq1d breq2d cC cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cC cva co c2 cA csm co cmv co cno cfv c2 cexp co cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cC cA cif cva co c2 cA csm co cmv co cno cfv c2 cexp co c4 cR
      c2 cexp co cmul co cle cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cC cva co c2 cA
      csm co cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cva co c2 cA csm co
      cmv co cno cfv c2 cexp cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cC cva co c2 cA
      csm co cmv co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cC cA cif cva co c2 cA csm co cmv co
      cno cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif wceq cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cB cA cif cC cva co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cva co c2 cA csm co cmv cC cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cC cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cva opreq2
      opreq1d fveq2d opreq1d breq2d cR cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif wceq c4 cR c2 cexp co cmul co c4 cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cR cc0 cif c2 cexp co cmul co cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif
      cva co c2 cA csm co cmv co cno cfv c2 cexp co cle cR cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif wceq cR c2 cexp co cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif c2 cexp co c4 cmul cR cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif c2 cexp opreq1 opreq2d breq1d cA cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cB cA cif wceq cA cA cva co c2 cA csm co
      cmv co cno cfv c2 cexp co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cA cva co c2 cA csm co cmv co cno cfv c2 cexp co c4 cc0 c2 cexp co
      cmul co cle cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif wceq cA
      cA cva co c2 cA csm co cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif cA cva co c2 cA csm co cmv co cno cfv c2 cexp cA cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cB cA cif wceq cA cA cva co c2 cA csm
      co cmv co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cva co
      c2 cA csm co cmv co cno cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif wceq cA cA cva co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cA cva co c2 cA csm co cmv cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB
      cA cif cA cva opreq1 opreq1d fveq2d opreq1d breq2d cA cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cC cA cif wceq cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif cA cva co c2 cA csm co cmv co cno cfv c2 cexp co cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cC cA cif cva co c2 cA csm co cmv co cno cfv c2 cexp co c4 cc0
      c2 cexp co cmul co cle cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cva co c2 cA
      csm co cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cva co c2 cA csm co
      cmv co cno cfv c2 cexp cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cva co c2 cA
      csm co cmv co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cC cA cif cva co c2 cA csm co cmv co
      cno cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif wceq cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cB cA cif cA cva co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cva co c2 cA csm co cmv cA cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cC cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cva opreq2
      opreq1d fveq2d opreq1d breq2d cc0 cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif wceq c4 cc0 c2 cexp co cmul co c4 cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif c2 cexp co cmul co cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cva co c2 cA csm co cmv co cno cfv c2 cexp co cle cc0 cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cR cc0 cif wceq cc0 c2 cexp co cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cR cc0 cif c2 cexp co c4 cmul cc0 cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cR cc0 cif c2 cexp opreq1 opreq2d breq1d
      projlem5.6 c4 cc0 c2 cexp co cmul co cc0 cA cA cva co c2 cA csm co cmv co
      cno cfv c2 cexp co cle c4 cc0 c2 cexp co cmul co c4 cc0 cmul co cc0 cc0
      c2 cexp co cc0 c4 cmul sq0 opreq2i c4 c4 4re recni mul01i eqtri cA cA cva
      co c2 cA csm co cmv co cno cfv cA cA cva co c2 cA csm co cmv co cA cA cva
      co c2 cA csm co cA cA projlem5.1 projlem5.1 hvaddcli c2 cA 2cn projlem5.1
      hvmulcli hvsubcli normcli sqge0i eqbrtri keephyp3v projlem5.7 projlem5.8
      projlem5.9 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co
      cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co
      caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA
      cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cG
      cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cC cA cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc
      co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co
      cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cG cdiv co
      caddc co clt wbr wa cB cC cR cA cA cc0 cA cA cmv co cno cfv cc0 c1 cD
      cdiv co caddc co clt wbr cA cA cmv co cno cfv cc0 c1 cG cdiv co caddc co
      clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co
      cno cfv cc0 c1 cD cdiv co caddc co clt wbr cA cA cmv co cno cfv cc0 c1 cG
      cdiv co caddc co clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB
      cA cif cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt wbr cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno cfv cc0 c1 cG cdiv co
      caddc co clt wbr wa cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif wceq cB cA cmv co
      cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt cB cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif wceq cB cA cmv co cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif cA cmv co cno cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB
      cA cif cA cmv opreq1 fveq2d breq1d anbi1d cC cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif wceq cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif wceq cC cA cmv co
      cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt cC cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cC cA cif wceq cC cA cmv co cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cC cA cif cA cmv co cno cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cA cmv opreq1 fveq2d breq1d anbi2d cR cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cR cc0 cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB
      cA cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc co clt wbr cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif
      c1 cG cdiv co caddc co clt wbr cR cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif wceq cR c1 cD cdiv co caddc co cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cR cc0 cif c1 cD cdiv co caddc co cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cA cmv co cno cfv clt cR cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc opreq1 breq2d cR cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif wceq cR c1 cG cdiv co
      caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cG cdiv co
      caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno
      cfv clt cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cG cdiv
      co caddc opreq1 breq2d anbi12d cA cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif wceq cA cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt wbr
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cc0
      c1 cD cdiv co caddc co clt wbr cA cA cmv co cno cfv cc0 c1 cG cdiv co
      caddc co clt wbr cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      wceq cA cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt cA cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cB cA cif wceq cA cA cmv co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cA cmv co cno cA cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cB cA cif cA cmv opreq1 fveq2d breq1d anbi1d cA cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cC cA cif wceq cA cA cmv co cno cfv cc0 c1
      cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cA cmv co cno cfv cc0 c1 cG cdiv co caddc co clt wbr cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cc0 c1 cD cdiv co
      caddc co clt wbr cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif
      wceq cA cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif cA cmv co cno cfv cc0 c1 cG cdiv co caddc co clt cA cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cC cA cif wceq cA cA cmv co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif cA cmv co cno cA cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif cA cmv opreq1 fveq2d breq1d anbi2d cc0 cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cR cc0 cif wceq cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cB cA cif cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt
      wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc
      co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co
      cno cfv cc0 c1 cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cC cA cif cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cR cc0 cif c1 cG cdiv co caddc co clt wbr cc0 cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif wceq cc0 c1 cD cdiv co caddc co cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc co cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv clt cc0 cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc
      opreq1 breq2d cc0 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif wceq
      cc0 c1 cG cdiv co caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0
      cif c1 cG cdiv co caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif cA cmv co cno cfv clt cc0 cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR
      cc0 cif c1 cG cdiv co caddc opreq1 breq2d anbi12d cA cA cmv co cno cfv
      cc0 c1 cD cdiv co caddc co clt wbr cA cA cmv co cno cfv cc0 c1 cG cdiv co
      caddc co clt wbr cc0 c1 cD cdiv co cA cA cmv co cno cfv cc0 c1 cD cdiv co
      caddc co clt cD cD projlem5.7 nnrei cD projlem5.7 nngt0i recgt0ii cA cA
      cmv co cno cfv c0v cno cfv cc0 cA cA cmv co c0v cno cA chil wcel cA cA
      cmv co c0v wceq projlem5.1 cA hvsubid ax-mp fveq2i norm0 eqtri c1 cD cdiv
      co cD cD projlem5.7 nncni cD projlem5.7 nnne0i reccli addid2i 3brtr4i cc0
      c1 cG cdiv co cA cA cmv co cno cfv cc0 c1 cG cdiv co caddc co clt cG cG
      projlem5.8 nnrei cG projlem5.8 nngt0i recgt0ii cA cA cmv co cno cfv c0v
      cno cfv cc0 cA cA cmv co c0v cno cA chil wcel cA cA cmv co c0v wceq
      projlem5.1 cA hvsubid ax-mp fveq2i norm0 eqtri c1 cG cdiv co cG cG
      projlem5.8 nncni cG projlem5.8 nnne0i reccli addid2i 3brtr4i pm3.2i
      elimhyp3v pm3.26i cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA
      cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD
      cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif
      c1 cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co
      cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co
      caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA
      cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cG
      cdiv co caddc co clt wbr wa cB cC cR cA cA cc0 cA cA cmv co cno cfv cc0
      c1 cD cdiv co caddc co clt wbr cA cA cmv co cno cfv cc0 c1 cG cdiv co
      caddc co clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt wbr cA cA cmv co cno cfv
      cc0 c1 cG cdiv co caddc co clt wbr wa cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt wbr cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno cfv cc0 c1
      cG cdiv co caddc co clt wbr wa cB cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cB cA cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr cB cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif
      wceq cB cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt cB cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cB cA cif wceq cB cA cmv co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif cA cmv co cno cB cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cB cA cif cA cmv opreq1 fveq2d breq1d anbi1d cC cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cC cA cif wceq cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC
      cA cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif
      wceq cC cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt cC cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cC cA cif wceq cC cA cmv co cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif cA cmv co cno cC cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif cA cmv opreq1 fveq2d breq1d anbi2d cR cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cR cc0 cif wceq cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cB cA cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt
      wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc
      co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cC cA cif cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cR cc0 cif c1 cG cdiv co caddc co clt wbr cR cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cR cc0 cif wceq cR c1 cD cdiv co caddc co cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc co cB cA
      cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR
      c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cfv clt cR cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cD cdiv co caddc
      opreq1 breq2d cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif wceq
      cR c1 cG cdiv co caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0
      cif c1 cG cdiv co caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA
      cif cA cmv co cno cfv clt cR cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR
      cc0 cif c1 cG cdiv co caddc opreq1 breq2d anbi12d cA cB cA cmv co cno cfv
      cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cB cA cif wceq cA cA cmv co cno cfv cc0 c1 cD cdiv co
      caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
      cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA
      cmv co cno cfv cc0 c1 cD cdiv co caddc co clt wbr cA cA cmv co cno cfv
      cc0 c1 cG cdiv co caddc co clt wbr cA cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif wceq cA cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD
      cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co
      clt wbr wa cB cA cif cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt cA
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif wceq cA cA cmv co cB
      cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
      cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno cA cB cA cmv
      co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1
      cG cdiv co caddc co clt wbr wa cB cA cif cA cmv opreq1 fveq2d breq1d
      anbi1d cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif wceq cA cA
      cmv co cno cfv cc0 c1 cG cdiv co caddc co clt wbr cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif cA cmv co cno cfv cc0 c1 cG cdiv co caddc
      co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co
      cno cfv cc0 c1 cD cdiv co caddc co clt wbr cA cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif wceq cA cA cmv co cno cfv cB cA cmv co cno cfv cR
      c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
      caddc co clt wbr wa cC cA cif cA cmv co cno cfv cc0 c1 cG cdiv co caddc
      co clt cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA
      cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif wceq cA cA
      cmv co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno
      cA cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv opreq1
      fveq2d breq1d anbi2d cc0 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0
      cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv
      co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA cif cA cmv co cno
      cfv cc0 c1 cD cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1 cD cdiv
      co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
      wbr wa cB cA cif cA cmv co cno cfv cB cA cmv co cno cfv cR c1 cD cdiv co
      caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
      wa cR cc0 cif c1 cD cdiv co caddc co clt wbr cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cC cA cif cA cmv co cno cfv cc0 c1 cG cdiv co caddc co clt
      wbr cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co
      cno cfv cR c1 cG cdiv co caddc co clt wbr wa cC cA cif cA cmv co cno cfv
      cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno
      cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif c1 cG cdiv co caddc
      co clt wbr cc0 cB cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
      cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0 cif wceq
      cc0 c1 cD cdiv co caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR cc0
      cif c1 cD cdiv co caddc co cB cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB cA
      cif cA cmv co cno cfv clt cc0 cB cA cmv co cno cfv cR c1 cD cdiv co caddc
      co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cR
      cc0 cif c1 cD cdiv co caddc opreq1 breq2d cc0 cB cA cmv co cno cfv cR c1
      cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
      co clt wbr wa cR cc0 cif wceq cc0 c1 cG cdiv co caddc co cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cR cc0 cif c1 cG cdiv co caddc co cB cA cmv co cno
      cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv
      co caddc co clt wbr wa cC cA cif cA cmv co cno cfv clt cc0 cB cA cmv co
      cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG
      cdiv co caddc co clt wbr wa cR cc0 cif c1 cG cdiv co caddc opreq1 breq2d
      anbi12d cA cA cmv co cno cfv cc0 c1 cD cdiv co caddc co clt wbr cA cA cmv
      co cno cfv cc0 c1 cG cdiv co caddc co clt wbr cc0 c1 cD cdiv co cA cA cmv
      co cno cfv cc0 c1 cD cdiv co caddc co clt cD cD projlem5.7 nnrei cD
      projlem5.7 nngt0i recgt0ii cA cA cmv co cno cfv c0v cno cfv cc0 cA cA cmv
      co c0v cno cA chil wcel cA cA cmv co c0v wceq projlem5.1 cA hvsubid ax-mp
      fveq2i norm0 eqtri c1 cD cdiv co cD cD projlem5.7 nncni cD projlem5.7
      nnne0i reccli addid2i 3brtr4i cc0 c1 cG cdiv co cA cA cmv co cno cfv cc0
      c1 cG cdiv co caddc co clt cG cG projlem5.8 nnrei cG projlem5.8 nngt0i
      recgt0ii cA cA cmv co cno cfv c0v cno cfv cc0 cA cA cmv co c0v cno cA
      chil wcel cA cA cmv co c0v wceq projlem5.1 cA hvsubid ax-mp fveq2i norm0
      eqtri c1 cG cdiv co cG cG projlem5.8 nncni cG projlem5.8 nnne0i reccli
      addid2i 3brtr4i pm3.2i elimhyp3v pm3.27i projlem6 dedth3v $.
      $( [5-Oct-1999] $)
  $}

  ${
    $d u v x y z w f A $.  $d u v x y z w f H $.  $d w z x y S $.  $d x B $.
    projlem8.1 $e |- A e. ~H $.
    projlem8.2 $e |- H e. CH $.
    projlem8.3 $e |- S =
                     { u e. RR | E. v e. H u = -u ( normh ` ( v -h A ) ) } $.
    $( Part of Lemma 3.6 of [Beran] p. 100.  The set ` S ` is a non-empty
       set of reals with an upper bound.  Part of Lemma 3.6 of [Beran]
       p. 100.  Used by ~ projlem9 ~ projlem12 ~ projlem13 ~ projlem15 .
       Note we use 'supremum'; its negative is the infimum. $)
    projlem8 $p |- ( S C_ RR /\ S =/= (/) /\ E. z e. RR A. w e. S w <_ z ) $=
      cS cr wss cS c0 wne vw cv vz cv cle wbr vw cS wral vz cr wrex cS vu cv vv
      cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab cr projlem8.3 vu cv
      vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr ssrab2 eqsstri c0v cA
      cmv co cno cfv cneg cS wcel cS c0 wne c0v cA cmv co cno cfv cneg vu cv vv
      cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab cS c0v cA cmv co cno
      cfv cneg vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab
      wcel c0v cA cmv co cno cfv cneg cr wcel c0v cA cmv co cno cfv cneg vv cv
      cA cmv co cno cfv cneg wceq vv cH wrex vu cv vv cv cA cmv co cno cfv cneg
      wceq vv cH wrex c0v cA cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg
      wceq vv cH wrex vu c0v cA cmv co cno cfv cneg cr vu cv c0v cA cmv co cno
      cfv cneg wceq vu cv vv cv cA cmv co cno cfv cneg wceq c0v cA cmv co cno
      cfv cneg vv cv cA cmv co cno cfv cneg wceq vv cH vu cv c0v cA cmv co cno
      cfv cneg vv cv cA cmv co cno cfv cneg eqeq1 rexbidv elrab c0v cA cmv co
      cno cfv c0v cA cmv co c0v cA ax-hv0cl projlem8.1 hvsubcli normcli
      renegcli c0v cH wcel c0v cA cmv co cno cfv cneg c0v cA cmv co cno cfv
      cneg wceq c0v cA cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg wceq vv
      cH wrex cH cch wcel c0v cH wcel projlem8.2 cH ch0 ax-mp c0v cA cmv co cno
      cfv cneg eqid c0v cA cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg
      wceq c0v cA cmv co cno cfv cneg c0v cA cmv co cno cfv cneg wceq vv c0v cH
      vv cv c0v wceq vv cv cA cmv co cno cfv cneg c0v cA cmv co cno cfv cneg
      c0v cA cmv co cno cfv cneg vv cv c0v wceq vv cv cA cmv co cno cfv c0v cA
      cmv co cno cfv vv cv c0v wceq vv cv cA cmv co c0v cA cmv co cno vv cv c0v
      cA cmv opreq1 fveq2d negeqd eqeq2d rcla4ev mp2an mpbir2an projlem8.3
      eleqtrri cS c0v cA cmv co cno cfv cneg ne0i ax-mp cc0 cr wcel vw cv cc0
      cle wbr vw cS wral vw cv vz cv cle wbr vw cS wral vz cr wrex 0re vw cv
      cc0 cle wbr vw cS vw cv cS wcel vw cv cr wcel vw cv vv cv cA cmv co cno
      cfv cneg wceq vv cH wrex wa vw cv cc0 cle wbr vu cv vv cv cA cmv co cno
      cfv cneg wceq vv cH wrex vw cv vv cv cA cmv co cno cfv cneg wceq vv cH
      wrex vu vw cv cr cS vu cv vw cv wceq vu cv vv cv cA cmv co cno cfv cneg
      wceq vw cv vv cv cA cmv co cno cfv cneg wceq vv cH vu cv vw cv vv cv cA
      cmv co cno cfv cneg eqeq1 rexbidv projlem8.3 elrab2 vw cv vv cv cA cmv co
      cno cfv cneg wceq vv cH wrex vw cv cc0 cle wbr vw cv cr wcel vw cv vv cv
      cA cmv co cno cfv cneg wceq vw cv cc0 cle wbr vv cH vw cv vv cv cA cmv co
      cno cfv cneg wceq vw cv cc0 cle wbr vv cv cA cmv co cno cfv cneg cc0 cle
      wbr vv cv cH wcel vw cv vv cv cA cmv co cno cfv cneg cc0 cle breq1 vv cv
      cH wcel vv cv chil wcel cA chil wcel wa vv cv cA cmv co chil wcel vv cv
      cA cmv co cno cfv cneg cc0 cle wbr vv cv cH wcel vv cv chil wcel cA chil
      wcel vv cv cH projlem8.2 cheli projlem8.1 jctir vv cv cA hvsubcl vv cv cA
      cmv co chil wcel cc0 vv cv cA cmv co cno cfv cle wbr vv cv cA cmv co cno
      cfv cneg cc0 cle wbr vv cv cA cmv co normge0 vv cv cA cmv co chil wcel vv
      cv cA cmv co cno cfv cr wcel cc0 vv cv cA cmv co cno cfv cle wbr vv cv cA
      cmv co cno cfv cneg cc0 cle wbr wb vv cv cA cmv co normcl vv cv cA cmv co
      cno cfv le0neg2 syl mpbid 3syl syl5cbir r19.23aiv adantl sylbi rgen vw cv
      vz cv cle wbr vw cS wral vw cv cc0 cle wbr vw cS wral vz cc0 cr vz cv cc0
      wceq vw cv vz cv cle wbr vw cv cc0 cle wbr vw cS vz cv cc0 vw cv cle
      breq2 ralbidv rcla4ev mp2an 3pm3.2i $.
      $( [4-Oct-1999] $)

    $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
       Real closure of the infimum of norms.  Used by ~ projlem11
       ~ projlem12 ~ projlem13 ~ projlem15 . $)
    projlem9 $p |- sup ( S , RR , < ) e. RR $=
      vz vw vx cr cS clt ltso vz vw vx cS vz vw vv vu cA cS cH projlem8.1
      projlem8.2 projlem8.3 projlem8 sup3ii supcli $.
      $( [26-Aug-1999] $)

    $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
       A member of the infimum set.  Used by ~ projlem12 . $)
    projlem10 $p |- ( B e. H -> -u ( normh ` ( B -h A ) ) e. S ) $=
      vx cv cA cmv co cno cfv cneg cS wcel cB cA cmv co cno cfv cneg cS wcel vx
      cB cH vx cv cB wceq vx cv cA cmv co cno cfv cneg cB cA cmv co cno cfv
      cneg cS vx cv cB wceq vx cv cA cmv co cno cfv cB cA cmv co cno cfv vx cv
      cB wceq vx cv cA cmv co cB cA cmv co cno vx cv cB cA cmv opreq1 fveq2d
      negeqd eleq1d vx cv cH wcel vx cv cA cmv co cno cfv cneg cr wcel vx cv cA
      cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg wceq vv cH wrex wa vx cv
      cA cmv co cno cfv cneg cS wcel vx cv cH wcel vx cv cA cmv co cno cfv cneg
      cr wcel vx cv cA cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg wceq vv
      cH wrex vx cv cH wcel vx cv cA cmv co chil wcel vx cv cA cmv co cno cfv
      cr wcel vx cv cA cmv co cno cfv cneg cr wcel vx cv cH wcel vx cv chil
      wcel vx cv cA cmv co chil wcel vx cv cH projlem8.2 cheli vx cv chil wcel
      cA chil wcel vx cv cA cmv co chil wcel projlem8.1 vx cv cA hvsubcl mpan2
      syl vx cv cA cmv co normcl vx cv cA cmv co cno cfv renegcl 3syl vx cv cH
      wcel vx cv cA cmv co cno cfv cneg vx cv cA cmv co cno cfv cneg wceq vx cv
      cA cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg wceq vv cH wrex vx cv
      cA cmv co cno cfv cneg eqid vx cv cA cmv co cno cfv cneg vv cv cA cmv co
      cno cfv cneg wceq vx cv cA cmv co cno cfv cneg vx cv cA cmv co cno cfv
      cneg wceq vv vx cv cH vv cv vx cv wceq vv cv cA cmv co cno cfv cneg vx cv
      cA cmv co cno cfv cneg vx cv cA cmv co cno cfv cneg vv cv vx cv wceq vv
      cv cA cmv co cno cfv vx cv cA cmv co cno cfv vv cv vx cv wceq vv cv cA
      cmv co vx cv cA cmv co cno vv cv vx cv cA cmv opreq1 fveq2d negeqd eqeq2d
      rcla4ev mpan2 jca vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vx
      cv cA cmv co cno cfv cneg vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu
      vx cv cA cmv co cno cfv cneg cr cS vu cv vx cv cA cmv co cno cfv cneg
      wceq vu cv vv cv cA cmv co cno cfv cneg wceq vx cv cA cmv co cno cfv cneg
      vv cv cA cmv co cno cfv cneg wceq vv cH vu cv vx cv cA cmv co cno cfv
      cneg vv cv cA cmv co cno cfv cneg eqeq1 rexbidv projlem8.3 elrab2 sylibr
      vtoclga $.
      $( [4-Oct-1999] $)
  $}

  ${
    $d u v x y z w f A $.  $d u v x y z w f H $.  $d w z x y S $.  $d x B $.
    $d z w f R $.
    projlem11.1 $e |- A e. ~H $.
    projlem11.2 $e |- H e. CH $.
    projlem11.3 $e |- S =
                      { u e. RR | E. v e. H u = -u ( normh ` ( v -h A ) ) } $.
    projlem11.4 $e |- R = -u sup ( S , RR , < ) $.
    $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
       ` R ` is the infimum of the set of norms.  Show it is real.  Used
       by ~ projlem12 ~ projlem13 ~ projlem14 ~ projlem15 ~ projlem18
       ~ projlem19 ~ projlem26 ~ projlem28 ~ projlem31 . $)
    projlem11 $p |- R e. RR $=
      cR cS cr clt csup cneg cr projlem11.4 cS cr clt csup vv vu cA cS cH
      projlem11.1 projlem11.2 projlem11.3 projlem9 renegcli eqeltri $.
      $( [25-Aug-1999] $)

    $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
       The infimum is less than any norm in the set of norms.  Used by
       ~ projlem14 ~ projlem18 ~ projlem31 . $)
    projlem12 $p |- ( B e. H -> R <_ ( normh ` ( B -h A ) ) ) $=
      cB cH wcel cR cB cA cmv co cno cfv cle wbr cB cA cmv co cno cfv cneg cR
      cneg cle wbr cB cH wcel cB cA cmv co cno cfv cneg cS cr clt csup cR cneg
      cle cB cH wcel cB cA cmv co cno cfv cneg cS wcel cB cA cmv co cno cfv
      cneg cS cr clt csup cle wbr vv vu cA cB cS cH projlem11.1 projlem11.2
      projlem11.3 projlem10 vx vy cS cB cA cmv co cno cfv cneg vx vy vv vu cA
      cS cH projlem11.1 projlem11.2 projlem11.3 projlem8 suprubii syl cR cS cr
      clt csup cneg wceq cS cr clt csup cR cneg wceq projlem11.4 cR cS cr clt
      csup cR vv vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4
      projlem11 recni cS cr clt csup vv vu cA cS cH projlem11.1 projlem11.2
      projlem11.3 projlem9 recni negcon2i mpbi syl6breq cB cH wcel cR cr wcel
      cB cA cmv co cno cfv cr wcel wa cR cB cA cmv co cno cfv cle wbr cB cA cmv
      co cno cfv cneg cR cneg cle wbr wb cB cH wcel cB cA cmv co cno cfv cr
      wcel cR cr wcel cB cH wcel cB chil wcel cB cA cmv co chil wcel cB cA cmv
      co cno cfv cr wcel cB cH projlem11.2 cheli cB chil wcel cA chil wcel cB
      cA cmv co chil wcel projlem11.1 cB cA hvsubcl mpan2 cB cA cmv co normcl
      3syl vv vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4
      projlem11 jctil cR cB cA cmv co cno cfv leneg syl mpbird $.
      $( [12-Sep-1999] $)

    $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
       The infimum of the set of norms is nonnegative.  Used by
       ~ projlem18 ~ projlem19 ~ projlem28 . $)
    projlem13 $p |- 0 <_ R $=
      cc0 cR cle wbr cR cneg cc0 cneg cle wbr cS cr clt csup cR cneg cc0 cneg
      cle cS cr clt csup cR cneg wceq cR cS cr clt csup cneg wceq projlem11.4
      cS cr clt csup cR cS cr clt csup vv vu cA cS cH projlem11.1 projlem11.2
      projlem11.3 projlem9 recni cR vv vu cA cR cS cH projlem11.1 projlem11.2
      projlem11.3 projlem11.4 projlem11 recni negcon2i mpbir cS cr clt csup cc0
      cneg cle wbr cc0 cneg cS cr clt csup clt wbr wn cc0 cneg cr wcel cc0 cneg
      vz cv clt wbr wn vz cS wral cc0 cneg cS cr clt csup clt wbr wn cc0 0re
      renegcli cc0 cneg vz cv clt wbr wn vz cS vz cv cS wcel vz cv cr wcel vz
      cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex wa cc0 cneg vz cv clt wbr
      wn vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vz cv vv cv cA cmv
      co cno cfv cneg wceq vv cH wrex vu vz cv cr cS vu cv vz cv wceq vu cv vv
      cv cA cmv co cno cfv cneg wceq vz cv vv cv cA cmv co cno cfv cneg wceq vv
      cH vu cv vz cv vv cv cA cmv co cno cfv cneg eqeq1 rexbidv projlem11.3
      elrab2 vz cv cr wcel vz cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex
      cc0 cneg vz cv clt wbr wn vz cv cr wcel vz cv vv cv cA cmv co cno cfv
      cneg wceq cc0 cneg vz cv clt wbr wn vv cH vz cv cr wcel vv cv cH wcel vz
      cv vv cv cA cmv co cno cfv cneg wceq cc0 cneg vz cv clt wbr wn vz cv cr
      wcel vz cv cc0 cneg cle wbr cc0 cneg vz cv clt wbr wn vv cv cH wcel vz cv
      vv cv cA cmv co cno cfv cneg wceq wa vz cv cr wcel cc0 cneg cr wcel vz cv
      cc0 cneg cle wbr cc0 cneg vz cv clt wbr wn wb cc0 0re renegcli vz cv cc0
      cneg lenlt mpan2 vz cv vv cv cA cmv co cno cfv cneg wceq vv cv cH wcel vz
      cv cc0 cneg cle wbr vz cv vv cv cA cmv co cno cfv cneg wceq vz cv cc0
      cneg cle wbr vv cv cA cmv co cno cfv cneg cc0 cneg cle wbr vv cv cH wcel
      vz cv vv cv cA cmv co cno cfv cneg cc0 cneg cle breq1 vv cv cH wcel cc0
      vv cv cA cmv co cno cfv cle wbr vv cv cA cmv co cno cfv cneg cc0 cneg cle
      wbr vv cv cH wcel vv cv chil wcel cA chil wcel wa vv cv cA cmv co chil
      wcel cc0 vv cv cA cmv co cno cfv cle wbr vv cv cH wcel vv cv chil wcel cA
      chil wcel vv cv cH projlem11.2 cheli projlem11.1 jctir vv cv cA hvsubcl
      vv cv cA cmv co normge0 3syl vv cv cH wcel cc0 cr wcel vv cv cA cmv co
      cno cfv cr wcel wa cc0 vv cv cA cmv co cno cfv cle wbr vv cv cA cmv co
      cno cfv cneg cc0 cneg cle wbr wb vv cv cH wcel vv cv cA cmv co cno cfv cr
      wcel cc0 cr wcel vv cv cH wcel vv cv chil wcel cA chil wcel wa vv cv cA
      cmv co chil wcel vv cv cA cmv co cno cfv cr wcel vv cv cH wcel vv cv chil
      wcel cA chil wcel vv cv cH projlem11.2 cheli projlem11.1 jctir vv cv cA
      hvsubcl vv cv cA cmv co normcl 3syl 0re jctil cc0 vv cv cA cmv co cno cfv
      leneg syl mpbid syl5bir impcom syl5bi exp3a r19.23adv imp sylbi rgen vx
      vy vz cr cS cc0 cneg clt ltso vx vy vz cS vx vy vv vu cA cS cH
      projlem11.1 projlem11.2 projlem11.3 projlem8 sup3ii supnubi mp2an cS cr
      clt csup cc0 cneg vv vu cA cS cH projlem11.1 projlem11.2 projlem11.3
      projlem9 cc0 0re renegcli lenlti mpbir eqbrtrri cc0 cR 0re vv vu cA cR cS
      cH projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem11 lenegi mpbir
      $.
      $( [12-Sep-1999] $)

    ${
      projlem14.5 $e |- C e. NN $.
      projlem14.6 $e |- B e. H $.
      $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
         Used by ~ projlem16 . $)
      projlem14 $p |- ( R - ( 1 / C ) ) < ( normh ` ( B -h A ) ) $=
        cR c1 cC cdiv co cmin co cR clt wbr cR cB cA cmv co cno cfv cle wbr cR
        c1 cC cdiv co cmin co cB cA cmv co cno cfv clt wbr cR c1 cC cdiv co
        cmin co cR clt wbr cR cR c1 cC cdiv co caddc co clt wbr cc0 c1 cC cdiv
        co clt wbr cR cR c1 cC cdiv co caddc co clt wbr cC cn wcel cc0 c1 cC
        cdiv co clt wbr projlem14.5 cC nnrecgt0 ax-mp c1 cC cdiv co cR cC cC
        projlem14.5 nnrei cC projlem14.5 nnne0i rereccli vv vu cA cR cS cH
        projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem11 ltaddposi
        mpbi cR c1 cC cdiv co cR vv vu cA cR cS cH projlem11.1 projlem11.2
        projlem11.3 projlem11.4 projlem11 cC cC projlem14.5 nnrei cC
        projlem14.5 nnne0i rereccli vv vu cA cR cS cH projlem11.1 projlem11.2
        projlem11.3 projlem11.4 projlem11 ltsubaddi mpbir cB cH wcel cR cB cA
        cmv co cno cfv cle wbr projlem14.6 vv vu cA cB cR cS cH projlem11.1
        projlem11.2 projlem11.3 projlem11.4 projlem12 ax-mp cR c1 cC cdiv co
        cmin co cR cB cA cmv co cno cfv cR c1 cC cdiv co vv vu cA cR cS cH
        projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem11 cC cC
        projlem14.5 nnrei cC projlem14.5 nnne0i rereccli resubcli vv vu cA cR
        cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem11 cB cA
        cmv co cB cA cB cH projlem11.2 projlem14.6 chelii projlem11.1 hvsubcli
        normcli ltletri mp2an $.
        $( [25-Aug-1999] $)

    $}

    ${
      $d w v u z C $.
      projlem15.5 $e |- C e. NN $.
      $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
         Used by ~ projlem16 . $)
      projlem15 $p |- E. z e. H ( normh ` ( z -h A ) ) < ( R + ( 1 / C ) ) $=
        cR c1 cC cdiv co caddc co cneg vw cv clt wbr vw cS wrex vz cv cA cmv co
        cno cfv cR c1 cC cdiv co caddc co clt wbr vz cH wrex cR c1 cC cdiv co
        caddc co cneg cr wcel cR c1 cC cdiv co caddc co cneg cS cr clt csup clt
        wbr cR c1 cC cdiv co caddc co cneg vw cv clt wbr vw cS wrex cR c1 cC
        cdiv co caddc co cR c1 cC cdiv co vv vu cA cR cS cH projlem11.1
        projlem11.2 projlem11.3 projlem11.4 projlem11 cC cC projlem15.5 nnrei
        cC projlem15.5 nnne0i rereccli readdcli renegcli cS cr clt csup cneg cR
        c1 cC cdiv co caddc co clt wbr cR c1 cC cdiv co caddc co cneg cS cr clt
        csup clt wbr cR cS cr clt csup cneg cR c1 cC cdiv co caddc co clt
        projlem11.4 cc0 c1 cC cdiv co clt wbr cR cR c1 cC cdiv co caddc co clt
        wbr cC cn wcel cc0 c1 cC cdiv co clt wbr projlem15.5 cC nnrecgt0 ax-mp
        c1 cC cdiv co cR cC cC projlem15.5 nnrei cC projlem15.5 nnne0i rereccli
        vv vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4
        projlem11 ltaddposi mpbi eqbrtrri cS cr clt csup cR c1 cC cdiv co caddc
        co vv vu cA cS cH projlem11.1 projlem11.2 projlem11.3 projlem9 cR c1 cC
        cdiv co vv vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3
        projlem11.4 projlem11 cC cC projlem15.5 nnrei cC projlem15.5 nnne0i
        rereccli readdcli ltnegcon1i mpbi vx vy vw cr cS cR c1 cC cdiv co caddc
        co cneg clt ltso vx vy vw cS vx vy vv vu cA cS cH projlem11.1
        projlem11.2 projlem11.3 projlem8 sup3ii suplubi mp2an cR c1 cC cdiv co
        caddc co cneg vw cv clt wbr vz cv cA cmv co cno cfv cR c1 cC cdiv co
        caddc co clt wbr vz cH wrex vw cS cR c1 cC cdiv co caddc co cneg vw cv
        clt wbr vw cv vz cv cA cmv co cno cfv cneg wceq vz cH wrex vz cv cA cmv
        co cno cfv cR c1 cC cdiv co caddc co clt wbr vz cH wrex vw cv cS wcel
        cR c1 cC cdiv co caddc co cneg vw cv clt wbr vw cv vz cv cA cmv co cno
        cfv cneg wceq vz cv cA cmv co cno cfv cR c1 cC cdiv co caddc co clt wbr
        vz cH cR c1 cC cdiv co caddc co cneg vw cv clt wbr vz cv cH wcel vw cv
        vz cv cA cmv co cno cfv cneg wceq vz cv cA cmv co cno cfv cR c1 cC cdiv
        co caddc co clt wbr wi vw cv vz cv cA cmv co cno cfv cneg wceq vz cv cH
        wcel cR c1 cC cdiv co caddc co cneg vw cv clt wbr vz cv cA cmv co cno
        cfv cR c1 cC cdiv co caddc co clt wbr vw cv vz cv cA cmv co cno cfv
        cneg wceq cR c1 cC cdiv co caddc co cneg vw cv clt wbr cR c1 cC cdiv co
        caddc co cneg vz cv cA cmv co cno cfv cneg clt wbr vz cv cH wcel vz cv
        cA cmv co cno cfv cR c1 cC cdiv co caddc co clt wbr vw cv vz cv cA cmv
        co cno cfv cneg wceq cR c1 cC cdiv co caddc co cneg vw cv clt wbr cR c1
        cC cdiv co caddc co cneg vz cv cA cmv co cno cfv cneg clt wbr vw cv vz
        cv cA cmv co cno cfv cneg cR c1 cC cdiv co caddc co cneg clt breq2
        biimpd vz cv cH wcel vz cv cA cmv co cno cfv cR c1 cC cdiv co caddc co
        clt wbr cR c1 cC cdiv co caddc co cneg vz cv cA cmv co cno cfv cneg clt
        wbr vz cv cH wcel vz cv cA cmv co chil wcel vz cv cA cmv co cno cfv cr
        wcel vz cv cA cmv co cno cfv cR c1 cC cdiv co caddc co clt wbr cR c1 cC
        cdiv co caddc co cneg vz cv cA cmv co cno cfv cneg clt wbr wb vz cv cH
        wcel vz cv chil wcel cA chil wcel wa vz cv cA cmv co chil wcel vz cv cH
        wcel vz cv chil wcel cA chil wcel vz cv cH projlem11.2 cheli
        projlem11.1 jctir vz cv cA hvsubcl syl vz cv cA cmv co normcl vz cv cA
        cmv co cno cfv cr wcel cR c1 cC cdiv co caddc co cr wcel vz cv cA cmv
        co cno cfv cR c1 cC cdiv co caddc co clt wbr cR c1 cC cdiv co caddc co
        cneg vz cv cA cmv co cno cfv cneg clt wbr wb cR c1 cC cdiv co vv vu cA
        cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem11 cC
        cC projlem15.5 nnrei cC projlem15.5 nnne0i rereccli readdcli vz cv cA
        cmv co cno cfv cR c1 cC cdiv co caddc co ltneg mpan2 3syl biimprd syl9
        com13 imp r19.22dva vw cv cS wcel vw cv cr wcel vw cv vz cv cA cmv co
        cno cfv cneg wceq vz cH wrex vu cv vv cv cA cmv co cno cfv cneg wceq vv
        cH wrex vw cv vz cv cA cmv co cno cfv cneg wceq vz cH wrex vu vw cv cr
        cS vu cv vw cv wceq vu cv vz cv cA cmv co cno cfv cneg wceq vz cH wrex
        vw cv vz cv cA cmv co cno cfv cneg wceq vz cH wrex vu cv vv cv cA cmv
        co cno cfv cneg wceq vv cH wrex vu cv vw cv wceq vu cv vz cv cA cmv co
        cno cfv cneg wceq vw cv vz cv cA cmv co cno cfv cneg wceq vz cH vu cv
        vw cv vz cv cA cmv co cno cfv cneg eqeq1 rexbidv vu cv vv cv cA cmv co
        cno cfv cneg wceq vu cv vz cv cA cmv co cno cfv cneg wceq vv vz cH vv
        cv vz cv wceq vv cv cA cmv co cno cfv cneg vz cv cA cmv co cno cfv cneg
        vu cv vv cv vz cv wceq vv cv cA cmv co cno cfv vz cv cA cmv co cno cfv
        vv cv vz cv wceq vv cv cA cmv co vz cv cA cmv co cno vv cv vz cv cA cmv
        opreq1 fveq2d negeqd eqeq2d cbvrexv syl5bb projlem11.3 elrab2 pm3.27bi
        syl5com r19.23aiv ax-mp $.
        $( [27-Aug-1999] $)

      $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
         Existence of a vector sequence member, used to show (via Axiom
         of Choice) the vector sequence existence.  Used by ~ projlem17 . $)
      projlem16 $p |- E. z e. H ( ( R - ( 1 / C ) ) < ( normh ` ( z -h A ) )
                    /\ ( normh ` ( z -h A ) ) < ( R + ( 1 / C ) ) ) $=
        vz cv cA cmv co cno cfv cR c1 cC cdiv co caddc co clt wbr vz cH wrex cR
        c1 cC cdiv co cmin co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co
        cno cfv cR c1 cC cdiv co caddc co clt wbr wa vz cH wrex vz vv vu cA cC
        cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem15.5
        projlem15 vz cv cA cmv co cno cfv cR c1 cC cdiv co caddc co clt wbr cR
        c1 cC cdiv co cmin co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co
        cno cfv cR c1 cC cdiv co caddc co clt wbr wa vz cH vz cv cH wcel vz cv
        cA cmv co cno cfv cR c1 cC cdiv co caddc co clt wbr cR c1 cC cdiv co
        cmin co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co cno cfv cR c1
        cC cdiv co caddc co clt wbr wa vz cv cH wcel cR c1 cC cdiv co cmin co
        vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co cno cfv cR c1 cC cdiv
        co caddc co clt wbr vz cv cH wcel cR c1 cC cdiv co cmin co vz cv cA cmv
        co cno cfv clt wbr cR c1 cC cdiv co cmin co vz cv cH wcel vz cv c0v cif
        cA cmv co cno cfv clt wbr vz cv c0v vz cv vz cv cH wcel vz cv c0v cif
        wceq vz cv cA cmv co cno cfv vz cv cH wcel vz cv c0v cif cA cmv co cno
        cfv cR c1 cC cdiv co cmin co clt vz cv vz cv cH wcel vz cv c0v cif wceq
        vz cv cA cmv co vz cv cH wcel vz cv c0v cif cA cmv co cno vz cv vz cv
        cH wcel vz cv c0v cif cA cmv opreq1 fveq2d breq2d vv vu cA vz cv cH
        wcel vz cv c0v cif cC cR cS cH projlem11.1 projlem11.2 projlem11.3
        projlem11.4 projlem15.5 vz cv c0v cH cH cch wcel c0v cH wcel
        projlem11.2 cH ch0 ax-mp elimel projlem14 dedth anim1i ex r19.22i ax-mp
        $.
        $( [29-Aug-1999] $)

    $}

    $( Part of Lemma 3.6 of [Beran] p. 100 (lemma for projection theorem).
       This uses the Axiom of Choice to show the existence of a vector sequence
       satisfying the assumption of Lemma 3.6 of [Beran]  p. 100:  "Let {y_n }
       be a sequence of W such that i_0 - 1/n < ||x_0 - y_n || < i_0 + 1/n."
       Here, ` H ` corresponds to "W"; ` f : NN --> H ` to "{y_n }"; ` w ` to
       "n"; ` R ` to "i_0 "; and ` ( norm `` ( A -h ( f `` w ) ) ) ` to
       "||x_0 - y_n ||".  Used by ~ projlem . $)
    projlem17 $p |- E. f ( f : NN --> H  /\ A. w e. NN
                   ( ( R - ( 1 / w ) ) < ( normh ` ( ( f ` w ) -h A ) )
              /\ ( normh ` ( ( f ` w ) -h A ) ) < ( R + ( 1 / w ) ) ) ) $=
      cR c1 vw cv cdiv co cmin co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv
      co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa vz cH wrex cn cH vf cv
      wf cR c1 vw cv cdiv co cmin co vw cv vf cv cfv cA cmv co cno cfv clt wbr
      vw cv vf cv cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa
      vw cn wral wa vf wex vw cn cR c1 vw cv cdiv co cmin co vz cv cA cmv co
      cno cfv clt wbr vz cv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt
      wbr wa cR c1 vw cv cdiv co cmin co vw cv vf cv cfv cA cmv co cno cfv clt
      wbr vw cv vf cv cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt
      wbr wa vw vz cn cH vf nnex cH cch projlem11.2 elisseti vz cv vw cv vf cv
      cfv wceq cR c1 vw cv cdiv co cmin co vz cv cA cmv co cno cfv clt wbr cR
      c1 vw cv cdiv co cmin co vw cv vf cv cfv cA cmv co cno cfv clt wbr vz cv
      cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr vw cv vf cv cfv cA
      cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr vz cv vw cv vf cv cfv
      wceq vz cv cA cmv co cno cfv vw cv vf cv cfv cA cmv co cno cfv cR c1 vw
      cv cdiv co cmin co clt vz cv vw cv vf cv cfv wceq vz cv cA cmv co vw cv
      vf cv cfv cA cmv co cno vz cv vw cv vf cv cfv cA cmv opreq1 fveq2d breq2d
      vz cv vw cv vf cv cfv wceq vz cv cA cmv co cno cfv vw cv vf cv cfv cA cmv
      co cno cfv cR c1 vw cv cdiv co caddc co clt vz cv vw cv vf cv cfv wceq vz
      cv cA cmv co vw cv vf cv cfv cA cmv co cno vz cv vw cv vf cv cfv cA cmv
      opreq1 fveq2d breq1d anbi12d ac6 vw cv cn wcel cR c1 vw cv cdiv co cmin
      co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co cno cfv cR c1 vw cv
      cdiv co caddc co clt wbr wa vz cH wrex cR c1 vw cv cn wcel vw cv c1 cif
      cdiv co cmin co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co cno cfv
      cR c1 vw cv cn wcel vw cv c1 cif cdiv co caddc co clt wbr wa vz cH wrex
      vw cv c1 vw cv vw cv cn wcel vw cv c1 cif wceq cR c1 vw cv cdiv co cmin
      co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co cno cfv cR c1 vw cv
      cdiv co caddc co clt wbr wa cR c1 vw cv cn wcel vw cv c1 cif cdiv co cmin
      co vz cv cA cmv co cno cfv clt wbr vz cv cA cmv co cno cfv cR c1 vw cv cn
      wcel vw cv c1 cif cdiv co caddc co clt wbr wa vz cH vw cv vw cv cn wcel
      vw cv c1 cif wceq cR c1 vw cv cdiv co cmin co vz cv cA cmv co cno cfv clt
      wbr cR c1 vw cv cn wcel vw cv c1 cif cdiv co cmin co vz cv cA cmv co cno
      cfv clt wbr vz cv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr
      vz cv cA cmv co cno cfv cR c1 vw cv cn wcel vw cv c1 cif cdiv co caddc co
      clt wbr vw cv vw cv cn wcel vw cv c1 cif wceq cR c1 vw cv cdiv co cmin co
      cR c1 vw cv cn wcel vw cv c1 cif cdiv co cmin co vz cv cA cmv co cno cfv
      clt vw cv vw cv cn wcel vw cv c1 cif wceq c1 vw cv cdiv co c1 vw cv cn
      wcel vw cv c1 cif cdiv co cR cmin vw cv vw cv cn wcel vw cv c1 cif c1
      cdiv opreq2 opreq2d breq1d vw cv vw cv cn wcel vw cv c1 cif wceq cR c1 vw
      cv cdiv co caddc co cR c1 vw cv cn wcel vw cv c1 cif cdiv co caddc co vz
      cv cA cmv co cno cfv clt vw cv vw cv cn wcel vw cv c1 cif wceq c1 vw cv
      cdiv co c1 vw cv cn wcel vw cv c1 cif cdiv co cR caddc vw cv vw cv cn
      wcel vw cv c1 cif c1 cdiv opreq2 opreq2d breq2d anbi12d rexbidv vz vv vu
      cA vw cv cn wcel vw cv c1 cif cR cS cH projlem11.1 projlem11.2
      projlem11.3 projlem11.4 vw cv c1 cn 1nn elimel projlem16 dedth mprg $.
      $( [7-Sep-1999] $)

    ${
      projlem18.5 $e |- B e. H $.
      projlem18.6 $e |- C e. H $.
      $( Part of Lemma 3.6 of [Beran] p. 101, top.  Used by ~ projlem19 . $)
      projlem18 $p |- ( 4 x. ( R ^ 2 ) ) <_
                   ( ( normh ` ( ( B +h C ) -h ( 2 .h A ) ) ) ^ 2 ) $=
        c4 cR c2 cexp co cmul co c2 cR cmul co c2 cexp co cB cC cva co c2 cA
        csm co cmv co cno cfv c2 cexp co cle c2 cR cmul co c2 cexp co c2 c2
        cexp co cR c2 cexp co cmul co c4 cR c2 cexp co cmul co c2 cR 2cn cR vv
        vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4
        projlem11 recni sqmuli c2 c2 cexp co c4 cR c2 cexp co cmul sq2 opreq1i
        eqtr2i c2 cR cmul co cB cC cva co c2 cA csm co cmv co cno cfv cle wbr
        c2 cR cmul co c2 cexp co cB cC cva co c2 cA csm co cmv co cno cfv c2
        cexp co cle wbr c2 cR cmul co c2 c1 c2 cdiv co cB cC cva co csm co cA
        cmv co cno cfv cmul co cB cC cva co c2 cA csm co cmv co cno cfv cle cR
        c1 c2 cdiv co cB cC cva co csm co cA cmv co cno cfv cle wbr c2 cR cmul
        co c2 c1 c2 cdiv co cB cC cva co csm co cA cmv co cno cfv cmul co cle
        wbr c1 c2 cdiv co cB cC cva co csm co cH wcel cR c1 c2 cdiv co cB cC
        cva co csm co cA cmv co cno cfv cle wbr c1 c2 cdiv co cc wcel cB cC cva
        co cH wcel c1 c2 cdiv co cB cC cva co csm co cH wcel c2 2cn 2ne0 reccli
        cB cH wcel cC cH wcel cB cC cva co cH wcel projlem18.5 projlem18.6 cH
        csh wcel cB cH wcel cC cH wcel wa cB cC cva co cH wcel wi cH
        projlem11.2 chshii cB cC cH shaddclOLD ax-mp mp2an cH csh wcel c1 c2
        cdiv co cc wcel cB cC cva co cH wcel wa c1 c2 cdiv co cB cC cva co csm
        co cH wcel wi cH projlem11.2 chshii c1 c2 cdiv co cB cC cva co cH
        shmulclOLD ax-mp mp2an vv vu cA c1 c2 cdiv co cB cC cva co csm co cR cS
        cH projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem12 ax-mp cc0
        c2 clt wbr cR c1 c2 cdiv co cB cC cva co csm co cA cmv co cno cfv cle
        wbr c2 cR cmul co c2 c1 c2 cdiv co cB cC cva co csm co cA cmv co cno
        cfv cmul co cle wbr wb 2pos cR c1 c2 cdiv co cB cC cva co csm co cA cmv
        co cno cfv c2 vv vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3
        projlem11.4 projlem11 c1 c2 cdiv co cB cC cva co csm co cA cmv co c1 c2
        cdiv co cB cC cva co csm co cA c1 c2 cdiv co cB cC cva co c2 2cn 2ne0
        reccli cB cC cB cH projlem11.2 projlem18.5 chelii cC cH projlem11.2
        projlem18.6 chelii hvaddcli hvmulcli projlem11.1 hvsubcli normcli 2re
        lemul2i ax-mp mpbi c2 c1 c2 cdiv co cB cC cva co csm co cA cmv co csm
        co cno cfv c2 cabs cfv c1 c2 cdiv co cB cC cva co csm co cA cmv co cno
        cfv cmul co cB cC cva co c2 cA csm co cmv co cno cfv c2 c1 c2 cdiv co
        cB cC cva co csm co cA cmv co cno cfv cmul co c2 c1 c2 cdiv co cB cC
        cva co csm co cA cmv co 2cn c1 c2 cdiv co cB cC cva co csm co cA c1 c2
        cdiv co cB cC cva co c2 2cn 2ne0 reccli cB cC cB cH projlem11.2
        projlem18.5 chelii cC cH projlem11.2 projlem18.6 chelii hvaddcli
        hvmulcli projlem11.1 hvsubcli norm-iii.i c2 c1 c2 cdiv co cB cC cva co
        csm co cA cmv co csm co cB cC cva co c2 cA csm co cmv co cno c2 c1 c2
        cdiv co cB cC cva co csm co cA cmv co csm co c2 c1 c2 cdiv co cB cC cva
        co csm co csm co c2 cA csm co cmv co cB cC cva co c2 cA csm co cmv co
        c2 c1 c2 cdiv co cB cC cva co csm co cA 2cn c1 c2 cdiv co cB cC cva co
        c2 2cn 2ne0 reccli cB cC cB cH projlem11.2 projlem18.5 chelii cC cH
        projlem11.2 projlem18.6 chelii hvaddcli hvmulcli projlem11.1
        hvsubdistr1i c2 c1 c2 cdiv co cB cC cva co csm co csm co cB cC cva co
        c2 cA csm co cmv c2 c1 c2 cdiv co cmul co cB cC cva co csm co c1 cB cC
        cva co csm co c2 c1 c2 cdiv co cB cC cva co csm co csm co cB cC cva co
        c2 c1 c2 cdiv co cmul co c1 cB cC cva co csm c2 2cn 2ne0 recidi opreq1i
        c2 c1 c2 cdiv co cB cC cva co 2cn c2 2cn 2ne0 reccli cB cC cB cH
        projlem11.2 projlem18.5 chelii cC cH projlem11.2 projlem18.6 chelii
        hvaddcli hvmulassi cB cC cva co chil wcel c1 cB cC cva co csm co cB cC
        cva co wceq cB cC cB cH projlem11.2 projlem18.5 chelii cC cH
        projlem11.2 projlem18.6 chelii hvaddcli cB cC cva co ax-hvmulid ax-mp
        3eqtr3i opreq1i eqtri fveq2i c2 cabs cfv c2 c1 c2 cdiv co cB cC cva co
        csm co cA cmv co cno cfv cmul cc0 c2 cle wbr c2 cabs cfv c2 wceq cc0 c2
        0re 2re 2pos ltleii c2 2re absidi ax-mp opreq1i 3eqtr3ri breqtri cc0 c2
        cR cmul co cle wbr cc0 cB cC cva co c2 cA csm co cmv co cno cfv cle wbr
        c2 cR cmul co cB cC cva co c2 cA csm co cmv co cno cfv cle wbr c2 cR
        cmul co c2 cexp co cB cC cva co c2 cA csm co cmv co cno cfv c2 cexp co
        cle wbr wb cc0 c2 cle wbr cc0 cR cle wbr cc0 c2 cR cmul co cle wbr cc0
        c2 0re 2re 2pos ltleii vv vu cA cR cS cH projlem11.1 projlem11.2
        projlem11.3 projlem11.4 projlem13 c2 cR 2re vv vu cA cR cS cH
        projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem11 mulge0i mp2an
        cB cC cva co c2 cA csm co cmv co chil wcel cc0 cB cC cva co c2 cA csm
        co cmv co cno cfv cle wbr cB cC cva co c2 cA csm co cB cC cB cH
        projlem11.2 projlem18.5 chelii cC cH projlem11.2 projlem18.6 chelii
        hvaddcli c2 cA 2cn projlem11.1 hvmulcli hvsubcli cB cC cva co c2 cA csm
        co cmv co normge0 ax-mp c2 cR cmul co cB cC cva co c2 cA csm co cmv co
        cno cfv c2 cR 2re vv vu cA cR cS cH projlem11.1 projlem11.2 projlem11.3
        projlem11.4 projlem11 remulcli cB cC cva co c2 cA csm co cmv co cB cC
        cva co c2 cA csm co cB cC cB cH projlem11.2 projlem18.5 chelii cC cH
        projlem11.2 projlem18.6 chelii hvaddcli c2 cA 2cn projlem11.1 hvmulcli
        hvsubcli normcli le2sqi mp2an mpbi eqbrtri $.
        $( [12-Sep-1999] $)
    $}

    ${
      projlem19.5 $e |- B e. H $.
      projlem19.6 $e |- C e. H $.
      projlem19.7 $e |- D e. NN $.
      projlem19.8 $e |- G e. NN $.
      projlem19.9 $e |- N e. NN $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  Used by ~ projlem20 . $)
      projlem19 $p |- ( ( ( normh ` ( B -h A ) ) < ( R + ( 1 / D ) ) /\
                       ( normh ` ( C -h A ) ) < ( R + ( 1 / G ) ) ) ->
                       ( ( N <_ D /\ N <_ G ) ->
               ( normh ` ( B -h C ) ) <
             ( sqr ` ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / N ) ) ) ) $=
        cA cB cC cD cR cG cN projlem11.1 cB cH projlem11.2 projlem19.5 chelii
        cC cH projlem11.2 projlem19.6 chelii vv vu cA cR cS cH projlem11.1
        projlem11.2 projlem11.3 projlem11.4 projlem11 vv vu cA cR cS cH
        projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem13 vv vu cA cB
        cC cR cS cH projlem11.1 projlem11.2 projlem11.3 projlem11.4 projlem19.5
        projlem19.6 projlem18 projlem19.7 projlem19.8 projlem19.9 projlem7 $.
        $( [28-Sep-1999] $)
    $}

    ${
      projlem20.5 $e |- N e. NN $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  Used by ~ projlem27 . $)
      projlem20 $p |- ( ( ( B e. H /\ C e. H ) /\ ( D e. NN /\ G e. NN ) ) ->
                      ( ( ( normh ` ( B -h A ) ) < ( R + ( 1 / D ) ) /\
                       ( normh ` ( C -h A ) ) < ( R + ( 1 / G ) ) ) ->
                       ( ( N <_ D /\ N <_ G ) ->
               ( normh ` ( B -h C ) ) <
             ( sqr ` ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / N ) ) ) ) ) $=
        cB cH wcel cC cH wcel cD cn wcel cG cn wcel cB cA cmv co cno cfv cR c1
        cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc
        co clt wbr wa cN cD cle wbr cN cG cle wbr wa cB cC cmv co cno cfv c4 c2
        cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr wi wi cB cC
        cD cG c0v c0v cB cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD cdiv co
        caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
        wa cN cD cle wbr cN cG cle wbr wa cB cH wcel cB c0v cif cC cmv co cno
        cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr wi
        wi cB cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD cdiv co caddc co
        clt wbr cC cH wcel cC c0v cif cA cmv co cno cfv cR c1 cG cdiv co caddc
        co clt wbr wa cN cD cle wbr cN cG cle wbr wa cB cH wcel cB c0v cif cC
        cH wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co
        cN cdiv co csqr cfv clt wbr wi wi cB cH wcel cB c0v cif cA cmv co cno
        cfv cR c1 cD cn wcel cD c1 cif cdiv co caddc co clt wbr cC cH wcel cC
        c0v cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cN cD cn
        wcel cD c1 cif cle wbr cN cG cle wbr wa cB cH wcel cB c0v cif cC cH
        wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN
        cdiv co csqr cfv clt wbr wi wi cB cH wcel cB c0v cif cA cmv co cno cfv
        cR c1 cD cn wcel cD c1 cif cdiv co caddc co clt wbr cC cH wcel cC c0v
        cif cA cmv co cno cfv cR c1 cG cn wcel cG c1 cif cdiv co caddc co clt
        wbr wa cN cD cn wcel cD c1 cif cle wbr cN cG cn wcel cG c1 cif cle wbr
        wa cB cH wcel cB c0v cif cC cH wcel cC c0v cif cmv co cno cfv c4 c2 cR
        cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr wi wi c1 c1 cB
        cB cH wcel cB c0v cif wceq cB cA cmv co cno cfv cR c1 cD cdiv co caddc
        co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cB
        cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
        cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cN cD cle wbr
        cN cG cle wbr wa cB cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul
        co cN cdiv co csqr cfv clt wbr wi cN cD cle wbr cN cG cle wbr wa cB cH
        wcel cB c0v cif cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co
        cN cdiv co csqr cfv clt wbr wi cB cB cH wcel cB c0v cif wceq cB cA cmv
        co cno cfv cR c1 cD cdiv co caddc co clt wbr cB cH wcel cB c0v cif cA
        cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv
        cR c1 cG cdiv co caddc co clt wbr cB cB cH wcel cB c0v cif wceq cB cA
        cmv co cno cfv cB cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD cdiv co
        caddc co clt cB cB cH wcel cB c0v cif wceq cB cA cmv co cB cH wcel cB
        c0v cif cA cmv co cno cB cB cH wcel cB c0v cif cA cmv opreq1 fveq2d
        breq1d anbi1d cB cB cH wcel cB c0v cif wceq cB cC cmv co cno cfv c4 c2
        cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt wbr cB cH wcel
        cB c0v cif cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN
        cdiv co csqr cfv clt wbr cN cD cle wbr cN cG cle wbr wa cB cB cH wcel
        cB c0v cif wceq cB cC cmv co cno cfv cB cH wcel cB c0v cif cC cmv co
        cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv clt cB
        cB cH wcel cB c0v cif wceq cB cC cmv co cB cH wcel cB c0v cif cC cmv co
        cno cB cB cH wcel cB c0v cif cC cmv opreq1 fveq2d breq1d imbi2d imbi12d
        cC cC cH wcel cC c0v cif wceq cB cH wcel cB c0v cif cA cmv co cno cfv
        cR c1 cD cdiv co caddc co clt wbr cC cA cmv co cno cfv cR c1 cG cdiv co
        caddc co clt wbr wa cB cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD
        cdiv co caddc co clt wbr cC cH wcel cC c0v cif cA cmv co cno cfv cR c1
        cG cdiv co caddc co clt wbr wa cN cD cle wbr cN cG cle wbr wa cB cH
        wcel cB c0v cif cC cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co
        cN cdiv co csqr cfv clt wbr wi cN cD cle wbr cN cG cle wbr wa cB cH
        wcel cB c0v cif cC cH wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co
        c1 caddc co cmul co cN cdiv co csqr cfv clt wbr wi cC cC cH wcel cC c0v
        cif wceq cC cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr cC cH
        wcel cC c0v cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr cB
        cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr
        cC cC cH wcel cC c0v cif wceq cC cA cmv co cno cfv cC cH wcel cC c0v
        cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt cC cC cH wcel cC
        c0v cif wceq cC cA cmv co cC cH wcel cC c0v cif cA cmv co cno cC cC cH
        wcel cC c0v cif cA cmv opreq1 fveq2d breq1d anbi2d cC cC cH wcel cC c0v
        cif wceq cB cH wcel cB c0v cif cC cmv co cno cfv c4 c2 cR cmul co c1
        caddc co cmul co cN cdiv co csqr cfv clt wbr cB cH wcel cB c0v cif cC
        cH wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co
        cN cdiv co csqr cfv clt wbr cN cD cle wbr cN cG cle wbr wa cC cC cH
        wcel cC c0v cif wceq cB cH wcel cB c0v cif cC cmv co cno cfv cB cH wcel
        cB c0v cif cC cH wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co c1
        caddc co cmul co cN cdiv co csqr cfv clt cC cC cH wcel cC c0v cif wceq
        cB cH wcel cB c0v cif cC cmv co cB cH wcel cB c0v cif cC cH wcel cC c0v
        cif cmv co cno cC cC cH wcel cC c0v cif cB cH wcel cB c0v cif cmv
        opreq2 fveq2d breq1d imbi2d imbi12d cD cD cn wcel cD c1 cif wceq cB cH
        wcel cB c0v cif cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cC
        cH wcel cC c0v cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr
        wa cB cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD cn wcel cD c1 cif
        cdiv co caddc co clt wbr cC cH wcel cC c0v cif cA cmv co cno cfv cR c1
        cG cdiv co caddc co clt wbr wa cN cD cle wbr cN cG cle wbr wa cB cH
        wcel cB c0v cif cC cH wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co
        c1 caddc co cmul co cN cdiv co csqr cfv clt wbr wi cN cD cn wcel cD c1
        cif cle wbr cN cG cle wbr wa cB cH wcel cB c0v cif cC cH wcel cC c0v
        cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr
        cfv clt wbr wi cD cD cn wcel cD c1 cif wceq cB cH wcel cB c0v cif cA
        cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cB cH wcel cB c0v cif
        cA cmv co cno cfv cR c1 cD cn wcel cD c1 cif cdiv co caddc co clt wbr
        cC cH wcel cC c0v cif cA cmv co cno cfv cR c1 cG cdiv co caddc co clt
        wbr cD cD cn wcel cD c1 cif wceq cR c1 cD cdiv co caddc co cR c1 cD cn
        wcel cD c1 cif cdiv co caddc co cB cH wcel cB c0v cif cA cmv co cno cfv
        clt cD cD cn wcel cD c1 cif wceq c1 cD cdiv co c1 cD cn wcel cD c1 cif
        cdiv co cR caddc cD cD cn wcel cD c1 cif c1 cdiv opreq2 opreq2d breq2d
        anbi1d cD cD cn wcel cD c1 cif wceq cN cD cle wbr cN cG cle wbr wa cN
        cD cn wcel cD c1 cif cle wbr cN cG cle wbr wa cB cH wcel cB c0v cif cC
        cH wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co
        cN cdiv co csqr cfv clt wbr cD cD cn wcel cD c1 cif wceq cN cD cle wbr
        cN cD cn wcel cD c1 cif cle wbr cN cG cle wbr cD cD cn wcel cD c1 cif
        cN cle breq2 anbi1d imbi1d imbi12d cG cG cn wcel cG c1 cif wceq cB cH
        wcel cB c0v cif cA cmv co cno cfv cR c1 cD cn wcel cD c1 cif cdiv co
        caddc co clt wbr cC cH wcel cC c0v cif cA cmv co cno cfv cR c1 cG cdiv
        co caddc co clt wbr wa cB cH wcel cB c0v cif cA cmv co cno cfv cR c1 cD
        cn wcel cD c1 cif cdiv co caddc co clt wbr cC cH wcel cC c0v cif cA cmv
        co cno cfv cR c1 cG cn wcel cG c1 cif cdiv co caddc co clt wbr wa cN cD
        cn wcel cD c1 cif cle wbr cN cG cle wbr wa cB cH wcel cB c0v cif cC cH
        wcel cC c0v cif cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN
        cdiv co csqr cfv clt wbr wi cN cD cn wcel cD c1 cif cle wbr cN cG cn
        wcel cG c1 cif cle wbr wa cB cH wcel cB c0v cif cC cH wcel cC c0v cif
        cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv
        clt wbr wi cG cG cn wcel cG c1 cif wceq cC cH wcel cC c0v cif cA cmv co
        cno cfv cR c1 cG cdiv co caddc co clt wbr cC cH wcel cC c0v cif cA cmv
        co cno cfv cR c1 cG cn wcel cG c1 cif cdiv co caddc co clt wbr cB cH
        wcel cB c0v cif cA cmv co cno cfv cR c1 cD cn wcel cD c1 cif cdiv co
        caddc co clt wbr cG cG cn wcel cG c1 cif wceq cR c1 cG cdiv co caddc co
        cR c1 cG cn wcel cG c1 cif cdiv co caddc co cC cH wcel cC c0v cif cA
        cmv co cno cfv clt cG cG cn wcel cG c1 cif wceq c1 cG cdiv co c1 cG cn
        wcel cG c1 cif cdiv co cR caddc cG cG cn wcel cG c1 cif c1 cdiv opreq2
        opreq2d breq2d anbi2d cG cG cn wcel cG c1 cif wceq cN cD cn wcel cD c1
        cif cle wbr cN cG cle wbr wa cN cD cn wcel cD c1 cif cle wbr cN cG cn
        wcel cG c1 cif cle wbr wa cB cH wcel cB c0v cif cC cH wcel cC c0v cif
        cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co cN cdiv co csqr cfv
        clt wbr cG cG cn wcel cG c1 cif wceq cN cG cle wbr cN cG cn wcel cG c1
        cif cle wbr cN cD cn wcel cD c1 cif cle wbr cG cG cn wcel cG c1 cif cN
        cle breq2 anbi2d imbi1d imbi12d vv vu cA cB cH wcel cB c0v cif cC cH
        wcel cC c0v cif cD cn wcel cD c1 cif cR cS cG cn wcel cG c1 cif cH cN
        projlem11.1 projlem11.2 projlem11.3 projlem11.4 cB c0v cH cH cch wcel
        c0v cH wcel projlem11.2 cH ch0 ax-mp elimel cC c0v cH cH cch wcel c0v
        cH wcel projlem11.2 cH ch0 ax-mp elimel cD c1 cn 1nn elimel cG c1 cn
        1nn elimel projlem20.5 projlem19 dedth4h $.
        $( [28-Sep-1999] $)
    $}
  $}

  ${
    $d w A $.  $d w D $.  $d w F $.  $d w R $.
    projlem21.1 $e |- ( ph <-> ( F : NN --> H /\ A. w e. NN
                     ( ( R - ( 1 / w ) ) < ( normh ` ( ( F ` w ) -h A ) )
               /\ ( normh ` ( ( F ` w ) -h A ) ) < ( R + ( 1 / w ) ) ) ) ) $.
    $( Part of Lemma 3.6 of [Beran] p. 100.  The hypothesis lets us work with
       our postulated vector sequence (whose existence was shown by
       ~ projlem17 ).  Here we just show the sequence value belongs to the
       closed subspace ` H ` .  Used by ~ projlem27 ~ projlem28 . $)
    projlem21 $p |- ( ph -> ( D e. NN -> ( F ` D ) e. H ) ) $=
      wph cD cn wcel cD cF cfv cH wcel cn cH cF wf cD cn wcel cD cF cfv cH wcel
      wph cn cH cD cF ffvelrn wph cn cH cF wf cR c1 vw cv cdiv co cmin co vw cv
      cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw
      cv cdiv co caddc co clt wbr wa vw cn wral projlem21.1 pm3.26bi sylan ex
      $.
      $( [28-Sep-1999] $)

    $( Part of Lemma 3.6 of [Beran] p. 100.  Here we show a member of
       the vector sequence is bounded.  Used by ~ projlem27 . $)
    projlem22 $p |- ( ph -> ( D e. NN ->
          ( normh ` ( ( F ` D ) -h A ) ) < ( R + ( 1 / D ) ) ) ) $=
      cD cn wcel vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co
      clt wbr vw cn wral cD cF cfv cA cmv co cno cfv cR c1 cD cdiv co caddc co
      clt wbr wph vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co
      clt wbr cD cF cfv cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr vw
      cD cn vw cv cD wceq vw cv cF cfv cA cmv co cno cfv cD cF cfv cA cmv co
      cno cfv cR c1 vw cv cdiv co caddc co cR c1 cD cdiv co caddc co clt vw cv
      cD wceq vw cv cF cfv cA cmv co cD cF cfv cA cmv co cno vw cv cD wceq vw
      cv cF cfv cD cF cfv cA cmv vw cv cD cF fveq2 opreq1d fveq2d vw cv cD wceq
      c1 vw cv cdiv co c1 cD cdiv co cR caddc vw cv cD c1 cdiv opreq2 opreq2d
      breq12d rcla4v wph cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno
      cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co
      clt wbr wa vw cn wral vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co
      caddc co clt wbr vw cn wral wph cn cH cF wf cR c1 vw cv cdiv co cmin co
      vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR
      c1 vw cv cdiv co caddc co clt wbr wa vw cn wral projlem21.1 pm3.27bi cR
      c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF
      cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa vw cv cF
      cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr vw cn cR c1 vw
      cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA
      cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr pm3.27 r19.20si syl
      syl5com $.
      $( [28-Sep-1999] $)
  $}

  ${
    $d x y D $.  $d u v w x y A $.  $d u v w x y z F $.  $d u v z w G $.
    projlem23.1 $e |- G = { <. x , y >. | ( x e. NN /\ y =
                    ( normh ` ( ( F ` x ) -h A ) ) ) } $.
    ${
      $( Part of Lemma 3.6 of [Beran] p. 101.  The hypothesis lets us work
         with the sequence ` G ` which corresponds to Beran's "{||yn-x0||}".
         Used by ~ projlem25 ~ projlem26 . $)
      projlem23 $p |- ( D e. NN ->
                   ( G ` D ) = ( normh ` ( ( F ` D ) -h A ) ) ) $=
        vx vy cD vx cv cF cfv cA cmv co cno cfv cD cF cfv cA cmv co cno cfv cn
        cG vx cv cD wceq vx cv cF cfv cA cmv co cD cF cfv cA cmv co cno vx cv
        cD wceq vx cv cF cfv cD cF cfv cA cmv vx cv cD cF fveq2 opreq1d fveq2d
        projlem23.1 cD cF cfv cA cmv co cno fvex fvopab4 $.
        $( [19-Oct-1999] $)
    $}

    ${
      projlem24.2 $e |- A e. ~H $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  Here we show our vector
         sequence implies the real numbers sequence ` G ` corresponding
         to Beran's "{||yn-x0||}".  Used by ~ projlem25 ~ projlem26 . $)
      projlem24 $p |- ( F : NN --> ~H -> G : NN --> CC ) $=
        cn chil cF wf vx cv cF cfv cA cmv co cno cfv cc wcel vx cn wral cn cc
        cG wf cn chil cF wf vx cv cF cfv cA cmv co cno cfv cc wcel vx cn cn
        chil cF wf vx cv cn wcel wa vx cv cF cfv cA cmv co chil wcel vx cv cF
        cfv cA cmv co cno cfv cr wcel vx cv cF cfv cA cmv co cno cfv cc wcel cn
        chil cF wf vx cv cn wcel wa vx cv cF cfv chil wcel cA chil wcel wa vx
        cv cF cfv cA cmv co chil wcel cn chil cF wf vx cv cn wcel wa vx cv cF
        cfv chil wcel cA chil wcel cn chil vx cv cF ffvelrn projlem24.2 jctir
        vx cv cF cfv cA hvsubcl syl vx cv cF cfv cA cmv co normcl vx cv cF cfv
        cA cmv co cno cfv recn 3syl r19.21aiva vx vy cn cc vx cv cF cfv cA cmv
        co cno cfv cG projlem23.1 fopab2 sylib $.
        $( [6-Oct-1999] $)
    $}

    ${
      projlem25.2 $e |- A e. ~H $.
      projlem25.3 $e |- F e. _V $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  "The sequence {||yn-x0||} of
         real numbers converges to the number ||y0-x0||" (here, "y0"
         is ` A ` and "x0" is ` z ` ).  Used by ~ projlem31 . $)
      projlem25 $p |- ( F ~~>v z -> G ~~> ( normh ` ( z -h A ) ) ) $=
        cF vz cv chli wbr cG vz cv cA cmv co cno cfv cli wbr cc0 vw cv clt wbr
        vv cv vu cv cle wbr vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs
        cfv vw cv clt wbr wi vu cn wral vv cn wrex wi vw cr wral cF vz cv chli
        wbr cc0 vw cv clt wbr vv cv vu cv cle wbr vu cv cF cfv vz cv cmv co cno
        cfv vw cv clt wbr wi vu cn wral vv cn wrex wi vw cr wral cc0 vw cv clt
        wbr vv cv vu cv cle wbr vu cv cG cfv vz cv cA cmv co cno cfv cmin co
        cabs cfv vw cv clt wbr wi vu cn wral vv cn wrex wi vw cr wral vw vv vu
        vz cv cF projlem25.3 vz visset hlimconvi cF vz cv chli wbr cc0 vw cv
        clt wbr vv cv vu cv cle wbr vu cv cF cfv vz cv cmv co cno cfv vw cv clt
        wbr wi vu cn wral vv cn wrex wi cc0 vw cv clt wbr vv cv vu cv cle wbr
        vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr wi
        vu cn wral vv cn wrex wi vw cr cF vz cv chli wbr vw cv cr wcel wa vv cv
        vu cv cle wbr vu cv cF cfv vz cv cmv co cno cfv vw cv clt wbr wi vu cn
        wral vv cn wrex vv cv vu cv cle wbr vu cv cG cfv vz cv cA cmv co cno
        cfv cmin co cabs cfv vw cv clt wbr wi vu cn wral vv cn wrex cc0 vw cv
        clt wbr cF vz cv chli wbr vw cv cr wcel wa vv cv vu cv cle wbr vu cv cF
        cfv vz cv cmv co cno cfv vw cv clt wbr wi vu cn wral vv cv vu cv cle
        wbr vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr
        wi vu cn wral vv cn cF vz cv chli wbr vw cv cr wcel wa vv cv vu cv cle
        wbr vu cv cF cfv vz cv cmv co cno cfv vw cv clt wbr wi vv cv vu cv cle
        wbr vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr
        wi vu cn cF vz cv chli wbr vw cv cr wcel wa vu cv cn wcel wa vu cv cF
        cfv vz cv cmv co cno cfv vw cv clt wbr vu cv cG cfv vz cv cA cmv co cno
        cfv cmin co cabs cfv vw cv clt wbr vv cv vu cv cle wbr cF vz cv chli
        wbr vw cv cr wcel wa vu cv cn wcel wa vu cv cF cfv vz cv cmv co cno cfv
        vw cv clt wbr vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw
        cv clt wbr cF vz cv chli wbr vw cv cr wcel wa vu cv cn wcel wa vu cv cF
        cfv vz cv cmv co cno cfv vw cv clt wbr wa vu cv cG cfv vz cv cA cmv co
        cno cfv cmin co cabs cfv vw cv clt wbr vu cv cF cfv cA cmv co cno cfv
        vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr cF vz cv chli
        wbr vw cv cr wcel wa vu cv cn wcel wa vu cv cF cfv vz cv cmv co cno cfv
        vw cv clt wbr vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv
        cmin co cabs cfv vw cv clt wbr cF vz cv chli wbr vw cv cr wcel wa vu cv
        cn wcel wa vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin
        co cabs cfv vu cv cF cfv vz cv cmv co cno cfv cle wbr vu cv cF cfv vz
        cv cmv co cno cfv vw cv clt wbr vu cv cF cfv cA cmv co cno cfv vz cv cA
        cmv co cno cfv cmin co cabs cfv vw cv clt wbr cF vz cv chli wbr vw cv
        cr wcel wa vu cv cn wcel wa cF vz cv chli wbr vu cv cn wcel vw cv cr
        wcel vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin co
        cabs cfv vu cv cF cfv vz cv cmv co cno cfv cle wbr vu cv cF cfv vz cv
        cmv co cno cfv vw cv clt wbr wa vu cv cF cfv cA cmv co cno cfv vz cv cA
        cmv co cno cfv cmin co cabs cfv vw cv clt wbr wi vu cv cF cfv cA cmv co
        cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv cr wcel vu cv cF cfv
        vz cv cmv co cno cfv cr wcel wa vw cv cr wcel vu cv cF cfv cA cmv co
        cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv vu cv cF cfv vz cv cmv
        co cno cfv cle wbr vu cv cF cfv vz cv cmv co cno cfv vw cv clt wbr wa
        vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv
        vw cv clt wbr wi cF vz cv chli wbr vu cv cn wcel wa vu cv cF cfv cA cmv
        co cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv cr wcel vu cv cF
        cfv vz cv cmv co cno cfv cr wcel vw cv cr wcel vu cv cF cfv cA cmv co
        cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv vu cv cF cfv vz cv cmv
        co cno cfv cle wbr vu cv cF cfv vz cv cmv co cno cfv vw cv clt wbr wa
        vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv
        vw cv clt wbr wi vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv
        cmin co cabs cfv vu cv cF cfv vz cv cmv co cno cfv vw cv lelttr 3expa
        cF vz cv chli wbr vu cv cn wcel wa vu cv cF cfv cA cmv co cno cfv vz cv
        cA cmv co cno cfv cmin co cabs cfv cr wcel vu cv cF cfv vz cv cmv co
        cno cfv cr wcel cF vz cv chli wbr vu cv cn wcel wa vu cv cF cfv cA cmv
        co cno cfv vz cv cA cmv co cno cfv cmin co cc wcel vu cv cF cfv cA cmv
        co cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv cr wcel cF vz cv
        chli wbr vu cv cn wcel wa vu cv cF cfv cA cmv co cno cfv vz cv cA cmv
        co cno cfv cmin co vu cv cF cfv cA cmv co cno cfv cr wcel vz cv cA cmv
        co cno cfv cr wcel vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno
        cfv cmin co cr wcel cF vz cv chli wbr vu cv cn wcel wa vu cv cF cfv cA
        cmv co cno cfv vz cv cA cmv co cno cfv resubcl cF vz cv chli wbr vu cv
        cn wcel wa vu cv cF cfv chil wcel vu cv cF cfv cA cmv co chil wcel vu
        cv cF cfv cA cmv co cno cfv cr wcel cn chil cF wf vu cv cn wcel vu cv
        cF cfv chil wcel cF vz cv chli wbr cn chil vu cv cF ffvelrn vz cv cF
        projlem25.3 vz visset hlimseqi sylan vu cv cF cfv chil wcel cA chil
        wcel vu cv cF cfv cA cmv co chil wcel projlem25.2 vu cv cF cfv cA
        hvsubcl mpan2 vu cv cF cfv cA cmv co normcl 3syl cF vz cv chli wbr vu
        cv cn wcel wa vz cv chil wcel vz cv cA cmv co chil wcel vz cv cA cmv co
        cno cfv cr wcel cF vz cv chli wbr vz cv chil wcel vu cv cn wcel vz cv
        cF projlem25.3 vz visset hlimveci adantr vz cv chil wcel cA chil wcel
        vz cv cA cmv co chil wcel projlem25.2 vz cv cA hvsubcl mpan2 vz cv cA
        cmv co normcl 3syl sylanc recnd vu cv cF cfv cA cmv co cno cfv vz cv cA
        cmv co cno cfv cmin co abscl syl cF vz cv chli wbr vu cv cn wcel wa vu
        cv cF cfv vz cv cmv co chil wcel vu cv cF cfv vz cv cmv co cno cfv cr
        wcel vu cv cF cfv chil wcel vz cv chil wcel vu cv cF cfv vz cv cmv co
        chil wcel cF vz cv chli wbr vu cv cn wcel wa vu cv cF cfv vz cv hvsubcl
        cn chil cF wf vu cv cn wcel vu cv cF cfv chil wcel cF vz cv chli wbr cn
        chil vu cv cF ffvelrn vz cv cF projlem25.3 vz visset hlimseqi sylan cF
        vz cv chli wbr vz cv chil wcel vu cv cn wcel vz cv cF projlem25.3 vz
        visset hlimveci adantr sylanc vu cv cF cfv vz cv cmv co normcl syl jca
        sylan an1rs cF vz cv chli wbr vu cv cn wcel vu cv cF cfv cA cmv co cno
        cfv vz cv cA cmv co cno cfv cmin co cabs cfv vu cv cF cfv vz cv cmv co
        cno cfv cle wbr vw cv cr wcel vu cv cF cfv chil wcel vz cv chil wcel vu
        cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv vu
        cv cF cfv vz cv cmv co cno cfv cle wbr cF vz cv chli wbr vu cv cn wcel
        wa vu cv cF cfv vz cv cA projlem25.2 norm3adifi cn chil cF wf vu cv cn
        wcel vu cv cF cfv chil wcel cF vz cv chli wbr cn chil vu cv cF ffvelrn
        vz cv cF projlem25.3 vz visset hlimseqi sylan cF vz cv chli wbr vz cv
        chil wcel vu cv cn wcel vz cv cF projlem25.3 vz visset hlimveci adantr
        sylanc adantlr sylani anabsi5 vu cv cn wcel vu cv cG cfv vz cv cA cmv
        co cno cfv cmin co cabs cfv vw cv clt wbr vu cv cF cfv cA cmv co cno
        cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr wb cF vz cv
        chli wbr vw cv cr wcel wa vu cv cF cfv vz cv cmv co cno cfv vw cv clt
        wbr vu cv cn wcel vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs cfv
        vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin co cabs cfv
        vw cv clt vu cv cn wcel vu cv cG cfv vz cv cA cmv co cno cfv cmin co vu
        cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno cfv cmin co cabs vu cv
        cn wcel vu cv cG cfv vu cv cF cfv cA cmv co cno cfv vz cv cA cmv co cno
        cfv cmin vx vy cA vu cv cF cG projlem23.1 projlem23 opreq1d fveq2d
        breq1d ad2antlr mpbird ex imim2d r19.20dva r19.22sdv imim2d r19.20dva
        mpd vz cv cA cmv co cno cfv cc wcel vu cv cG cfv cc wcel vu cn wral cG
        vz cv cA cmv co cno cfv cli wbr cc0 vw cv clt wbr vv cv vu cv cle wbr
        vu cv cG cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr wi
        vu cn wral vv cn wrex wi vw cr wral wb cF vz cv chli wbr vz cv cA cmv
        co cno cfv cc wcel vu cv cG cfv cc wcel vu cn cn cin wral cG vz cv cA
        cmv co cno cfv cli wbr cc0 vw cv clt wbr vv cv vu cv cle wbr vu cv cG
        cfv vz cv cA cmv co cno cfv cmin co cabs cfv vw cv clt wbr wi vu cn
        wral vv cn wrex wi vw cr wral wb vu cv cG cfv cc wcel vu cn wral vw vz
        cv cA cmv co cno cfv vv vu cG c1 c1 cn cn 1z cn c1 cuz cfv nnuz
        eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz vx vy cn vx cv cF
        cfv cA cmv co cno cfv cG nnex projlem23.1 fopabex2 clm4i cn cn cin cn
        wss vu cv cG cfv cc wcel vu cn wral vu cv cG cfv cc wcel vu cn cn cin
        wral wi cn cn inss2 vu cv cG cfv cc wcel vu cn cn cin cn ssralv ax-mp
        sylan2 cF vz cv chli wbr vz cv cA cmv co cno cfv cF vz cv chli wbr vz
        cv chil wcel cA chil wcel wa vz cv cA cmv co chil wcel vz cv cA cmv co
        cno cfv cr wcel cF vz cv chli wbr vz cv chil wcel cA chil wcel vz cv cF
        projlem25.3 vz visset hlimveci projlem25.2 jctir vz cv cA hvsubcl vz cv
        cA cmv co normcl 3syl recnd cF vz cv chli wbr vu cv cG cfv cc wcel vu
        cn cn cc cG wf vu cv cn wcel vu cv cG cfv cc wcel cF vz cv chli wbr cn
        cc vu cv cG ffvelrn cF vz cv chli wbr cn chil cF wf cn cc cG wf vz cv
        cF projlem25.3 vz visset hlimseqi vx vy cA cF cG projlem23.1
        projlem25.2 projlem24 syl sylan r19.21aiva sylanc mpbird $.
        $( [6-Jul-2006] $) $( [19-Oct-1999] $)
    $}
  $}

  ${
    $d w u v x y A $.  $d w x y F $.  $d w f g z R $.  $d f g z G $.
    $d f g x z ph $.  $d u v H $.  $d y g $.
    projlem26.1 $e |- A e. ~H $.
    projlem26.2 $e |- H e. CH $.
    projlem26.3 $e |- S =
                      { u e. RR | E. v e. H u = -u ( normh ` ( v -h A ) ) } $.
    projlem26.4 $e |- R = -u sup ( S , RR , < ) $.
    projlem26.5 $e |- ( ph <-> ( F : NN --> H /\ A. w e. NN
                     ( ( R - ( 1 / w ) ) < ( normh ` ( ( F ` w ) -h A ) )
               /\ ( normh ` ( ( F ` w ) -h A ) ) < ( R + ( 1 / w ) ) ) ) ) $.
    projlem26.6 $e |- G = { <. x , y >. | ( x e. NN /\ y =
                    ( normh ` ( ( F ` x ) -h A ) ) ) } $.
    $( Part of Lemma 3.6 of [Beran] p. 101.  The real sequence ` G ` (Beran's
       "{||yn-x0||}") converges to the infimum of norms.  Used by
       ~ projlem31 . $)
    projlem26 $p |- ( ph -> G ~~> R ) $=
      wph cG cR cli wbr cc0 vz cv clt wbr vf cv vg cv cle wbr vg cv cG cfv cR
      cmin co cabs cfv vz cv clt wbr wi vg cn wral vf cn wrex wi vz cr wral wph
      cc0 vz cv clt wbr vf cv vg cv cle wbr vg cv cG cfv cR cmin co cabs cfv vz
      cv clt wbr wi vg cn wral vf cn wrex wi vz cr wph vz cv cr wcel cc0 vz cv
      clt wbr vf cv vg cv cle wbr vg cv cG cfv cR cmin co cabs cfv vz cv clt
      wbr wi vg cn wral vf cn wrex wph vz cv cr wcel cc0 vz cv clt wbr wa wa c1
      vf cv cdiv co vz cv clt wbr vf cn wrex vf cv vg cv cle wbr vg cv cG cfv
      cR cmin co cabs cfv vz cv clt wbr wi vg cn wral vf cn wrex vz cv cr wcel
      cc0 vz cv clt wbr wa c1 vf cv cdiv co vz cv clt wbr vf cn wrex wph vz cv
      cr wcel cc0 vz cv clt wbr wa c1 vz cv cdiv co vf cv clt wbr vf cn wrex c1
      vf cv cdiv co vz cv clt wbr vf cn wrex vz cv cr wcel cc0 vz cv clt wbr wa
      c1 vz cv cdiv co cr wcel c1 vz cv cdiv co vf cv clt wbr vf cn wrex vz cv
      cr wcel cc0 vz cv clt wbr vz cv cc0 wne c1 vz cv cdiv co cr wcel vz cv
      gt0ne0 vz cv rereccl syldan c1 vz cv cdiv co vf arch syl vz cv cr wcel
      cc0 vz cv clt wbr wa c1 vz cv cdiv co vf cv clt wbr c1 vf cv cdiv co vz
      cv clt wbr vf cn vz cv cr wcel cc0 vz cv clt wbr wa vf cv cr wcel cc0 vf
      cv clt wbr wa c1 vz cv cdiv co vf cv clt wbr c1 vf cv cdiv co vz cv clt
      wbr wb vf cv cn wcel vz cv vf cv ltrec1 vf cv cn wcel vf cv cr wcel cc0
      vf cv clt wbr vf cv nnre vf cv nngt0 jca sylan2 rexbidva mpbid adantl wph
      vz cv cr wcel cc0 vz cv clt wbr wa wa c1 vf cv cdiv co vz cv clt wbr vf
      cv vg cv cle wbr vg cv cG cfv cR cmin co cabs cfv vz cv clt wbr wi vg cn
      wral vf cn wph vz cv cr wcel cc0 vz cv clt wbr wa wa vf cv cn wcel wa c1
      vf cv cdiv co vz cv clt wbr vf cv vg cv cle wbr vg cv cG cfv cR cmin co
      cabs cfv vz cv clt wbr wi vg cn wph vz cv cr wcel cc0 vz cv clt wbr wa wa
      vf cv cn wcel wa vg cv cn wcel c1 vf cv cdiv co vz cv clt wbr vf cv vg cv
      cle wbr vg cv cG cfv cR cmin co cabs cfv vz cv clt wbr wi wph vz cv cr
      wcel cc0 vz cv clt wbr wa wa vf cv cn wcel wa vg cv cn wcel c1 vf cv cdiv
      co vz cv clt wbr vf cv vg cv cle wbr vg cv cG cfv cR cmin co cabs cfv vz
      cv clt wbr wph vz cv cr wcel cc0 vz cv clt wbr wa wa vf cv cn wcel wa vg
      cv cn wcel wa c1 vf cv cdiv co vz cv clt wbr vf cv vg cv cle wbr wa vg cv
      cF cfv cA cmv co cno cfv cR cmin co cabs cfv vz cv clt wbr vg cv cG cfv
      cR cmin co cabs cfv vz cv clt wbr wph vz cv cr wcel cc0 vz cv clt wbr wa
      wa vf cv cn wcel wa vg cv cn wcel wa c1 vf cv cdiv co vz cv clt wbr vf cv
      vg cv cle wbr wa c1 vg cv cdiv co vz cv clt wbr vg cv cF cfv cA cmv co
      cno cfv cR cmin co cabs cfv vz cv clt wbr wph vz cv cr wcel cc0 vz cv clt
      wbr wa wa vf cv cn wcel vg cv cn wcel c1 vf cv cdiv co vz cv clt wbr vf
      cv vg cv cle wbr wa c1 vg cv cdiv co vz cv clt wbr wi vz cv cr wcel vf cv
      cn wcel vg cv cn wcel c1 vf cv cdiv co vz cv clt wbr vf cv vg cv cle wbr
      wa c1 vg cv cdiv co vz cv clt wbr wi wi wi wph cc0 vz cv clt wbr vg cv cn
      wcel vf cv cn wcel vz cv cr wcel c1 vf cv cdiv co vz cv clt wbr vf cv vg
      cv cle wbr wa c1 vg cv cdiv co vz cv clt wbr wi vg cv cn wcel vf cv cn
      wcel vz cv cr wcel c1 vf cv cdiv co vz cv clt wbr vf cv vg cv cle wbr wa
      c1 vg cv cdiv co vz cv clt wbr wi vg cv cn wcel vf cv cn wcel vz cv cr
      wcel w3a c1 vf cv cdiv co vz cv clt wbr vf cv vg cv cle wbr c1 vg cv cdiv
      co vz cv clt wbr vg cv cn wcel vf cv cn wcel vz cv cr wcel w3a vf cv vg
      cv cle wbr c1 vf cv cdiv co vz cv clt wbr c1 vg cv cdiv co vz cv clt wbr
      vg cv cn wcel vf cv cn wcel vz cv cr wcel w3a vf cv vg cv cle wbr c1 vg
      cv cdiv co c1 vf cv cdiv co cle wbr c1 vf cv cdiv co vz cv clt wbr c1 vg
      cv cdiv co vz cv clt wbr wi vg cv cn wcel vf cv cn wcel vf cv vg cv cle
      wbr c1 vg cv cdiv co c1 vf cv cdiv co cle wbr wb vz cv cr wcel vf cv cn
      wcel vg cv cn wcel vf cv vg cv cle wbr c1 vg cv cdiv co c1 vf cv cdiv co
      cle wbr wb vf cv cr wcel cc0 vf cv clt wbr wa vg cv cr wcel cc0 vg cv clt
      wbr wa vf cv vg cv cle wbr c1 vg cv cdiv co c1 vf cv cdiv co cle wbr wb
      vf cv cn wcel vg cv cn wcel vf cv vg cv lerec vf cv cn wcel vf cv cr wcel
      cc0 vf cv clt wbr vf cv nnre vf cv nngt0 jca vg cv cn wcel vg cv cr wcel
      cc0 vg cv clt wbr vg cv nnre vg cv nngt0 jca syl2an ancoms 3adant3 c1 vg
      cv cdiv co cr wcel vf cv cn wcel vz cv cr wcel c1 vg cv cdiv co c1 vf cv
      cdiv co cle wbr c1 vf cv cdiv co vz cv clt wbr c1 vg cv cdiv co vz cv clt
      wbr wi wi vg cv cn wcel c1 vg cv cdiv co cr wcel c1 vf cv cdiv co cr wcel
      vz cv cr wcel c1 vg cv cdiv co c1 vf cv cdiv co cle wbr c1 vf cv cdiv co
      vz cv clt wbr c1 vg cv cdiv co vz cv clt wbr wi wi vf cv cn wcel c1 vg cv
      cdiv co cr wcel c1 vf cv cdiv co cr wcel vz cv cr wcel w3a c1 vg cv cdiv
      co c1 vf cv cdiv co cle wbr c1 vf cv cdiv co vz cv clt wbr c1 vg cv cdiv
      co vz cv clt wbr c1 vg cv cdiv co c1 vf cv cdiv co vz cv lelttr exp3a vf
      cv cr wcel vf cv cc0 wne c1 vf cv cdiv co cr wcel vf cv cn wcel vf cv
      rereccl vf cv nnre vf cv nnne0 sylanc syl3an2 vg cv cr wcel vg cv cc0 wne
      c1 vg cv cdiv co cr wcel vg cv cn wcel vg cv rereccl vg cv nnre vg cv
      nnne0 sylanc syl3an1 sylbid com23 imp3a 3exp com13 ad2antrl imp31 wph vz
      cv cr wcel cc0 vz cv clt wbr wa wa vg cv cn wcel c1 vg cv cdiv co vz cv
      clt wbr vg cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv vz cv clt wbr
      wi vf cv cn wcel wph vg cv cn wcel vz cv cr wcel cc0 vz cv clt wbr wa c1
      vg cv cdiv co vz cv clt wbr vg cv cF cfv cA cmv co cno cfv cR cmin co
      cabs cfv vz cv clt wbr wi vg cv cF cfv cA cmv co cno cfv cR cmin co cabs
      cfv cr wcel c1 vg cv cdiv co cr wcel wa vz cv cr wcel wa vg cv cF cfv cA
      cmv co cno cfv cR cmin co cabs cfv c1 vg cv cdiv co clt wbr c1 vg cv cdiv
      co vz cv clt wbr vg cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv vz cv
      clt wbr wi wph vg cv cn wcel wa vz cv cr wcel cc0 vz cv clt wbr wa wa vg
      cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv cr wcel c1 vg cv cdiv co
      cr wcel wa vz cv cr wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co
      cabs cfv c1 vg cv cdiv co clt wbr c1 vg cv cdiv co vz cv clt wbr vg cv cF
      cfv cA cmv co cno cfv cR cmin co cabs cfv vz cv clt wbr vg cv cF cfv cA
      cmv co cno cfv cR cmin co cabs cfv cr wcel c1 vg cv cdiv co cr wcel vz cv
      cr wcel vg cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv c1 vg cv cdiv
      co clt wbr c1 vg cv cdiv co vz cv clt wbr wa vg cv cF cfv cA cmv co cno
      cfv cR cmin co cabs cfv vz cv clt wbr wi vg cv cF cfv cA cmv co cno cfv
      cR cmin co cabs cfv c1 vg cv cdiv co vz cv axlttrn 3expa exp3a wph vg cv
      cn wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv cr wcel c1
      vg cv cdiv co cr wcel wa vz cv cr wcel cc0 vz cv clt wbr wa vz cv cr wcel
      wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv
      cr wcel c1 vg cv cdiv co cr wcel wph vg cv cn wcel wa vg cv cF cfv cA cmv
      co cno cfv cR cmin co cc wcel vg cv cF cfv cA cmv co cno cfv cR cmin co
      cabs cfv cr wcel wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cR
      cmin co wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cr wcel cR cr
      wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co cr wcel wph vg cv cn
      wcel wa vg cv cF cfv cA cmv co cno cfv cr wcel cR cr wcel wph vg cv cn
      wcel wa vg cv cF cfv chil wcel cA chil wcel wa vg cv cF cfv cA cmv co
      chil wcel vg cv cF cfv cA cmv co cno cfv cr wcel wph vg cv cn wcel wa vg
      cv cF cfv chil wcel cA chil wcel wph vg cv cn wcel wa vg cv cF cfv cH
      wcel vg cv cF cfv chil wcel cn cH cF wf vg cv cn wcel vg cv cF cfv cH
      wcel wph cn cH vg cv cF ffvelrn wph cn cH cF wf cR c1 vw cv cdiv co cmin
      co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv
      cR c1 vw cv cdiv co caddc co clt wbr wa vw cn wral projlem26.5 pm3.26bi
      sylan vg cv cF cfv cH projlem26.2 cheli syl projlem26.1 jctir vg cv cF
      cfv cA hvsubcl vg cv cF cfv cA cmv co normcl 3syl vv vu cA cR cS cH
      projlem26.1 projlem26.2 projlem26.3 projlem26.4 projlem11 jctir vg cv cF
      cfv cA cmv co cno cfv cR resubcl syl recnd vg cv cF cfv cA cmv co cno cfv
      cR cmin co abscl syl vg cv cn wcel c1 vg cv cdiv co cr wcel wph vg cv cr
      wcel vg cv cc0 wne c1 vg cv cdiv co cr wcel vg cv cn wcel vg cv rereccl
      vg cv nnre vg cv nnne0 sylanc adantl jca vz cv cr wcel cc0 vz cv clt wbr
      pm3.26 anim12i wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cR
      cmin co cabs cfv c1 vg cv cdiv co clt wbr vz cv cr wcel cc0 vz cv clt wbr
      wa wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co cabs
      cfv c1 vg cv cdiv co clt wbr c1 vg cv cdiv co cneg vg cv cF cfv cA cmv co
      cno cfv cR cmin co clt wbr vg cv cF cfv cA cmv co cno cfv cR cmin co c1
      vg cv cdiv co clt wbr wa wph vg cv cn wcel wa c1 vg cv cdiv co cneg vg cv
      cF cfv cA cmv co cno cfv cR cmin co clt wbr vg cv cF cfv cA cmv co cno
      cfv cR cmin co c1 vg cv cdiv co clt wbr wph vg cv cn wcel wa c1 vg cv
      cdiv co cneg vg cv cF cfv cA cmv co cno cfv cR cmin co clt wbr vg cv cF
      cfv cA cmv co cno cfv cR cmin co cneg c1 vg cv cdiv co clt wbr wph vg cv
      cn wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co cneg cR vg cv cF cfv
      cA cmv co cno cfv cmin co c1 vg cv cdiv co clt wph vg cv cn wcel wa vg cv
      cF cfv cA cmv co cno cfv cc wcel cR cc wcel wa vg cv cF cfv cA cmv co cno
      cfv cR cmin co cneg cR vg cv cF cfv cA cmv co cno cfv cmin co wceq wph vg
      cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cc wcel cR cc wcel wph vg cv
      cn wcel wa vg cv cF cfv cA cmv co cno cfv wph vg cv cn wcel wa vg cv cF
      cfv chil wcel cA chil wcel wa vg cv cF cfv cA cmv co chil wcel vg cv cF
      cfv cA cmv co cno cfv cr wcel wph vg cv cn wcel wa vg cv cF cfv chil wcel
      cA chil wcel wph vg cv cn wcel wa vg cv cF cfv cH wcel vg cv cF cfv chil
      wcel cn cH cF wf vg cv cn wcel vg cv cF cfv cH wcel wph cn cH vg cv cF
      ffvelrn wph cn cH cF wf cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv
      co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co
      caddc co clt wbr wa vw cn wral projlem26.5 pm3.26bi sylan vg cv cF cfv cH
      projlem26.2 cheli syl projlem26.1 jctir vg cv cF cfv cA hvsubcl vg cv cF
      cfv cA cmv co normcl 3syl recnd cR vv vu cA cR cS cH projlem26.1
      projlem26.2 projlem26.3 projlem26.4 projlem11 recni jctir vg cv cF cfv cA
      cmv co cno cfv cR negsubdi2 syl wph vg cv cn wcel wa cR vg cv cF cfv cA
      cmv co cno cfv cmin co c1 vg cv cdiv co clt wbr cR c1 vg cv cdiv co cmin
      co vg cv cF cfv cA cmv co cno cfv clt wbr wph vg cv cn wcel wa cR c1 vg
      cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv cF cfv cA
      cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wph vg cv cn wcel cR
      c1 vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv cF
      cfv cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wa vg cv cn
      wcel cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr
      vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa vw
      cn wral cR c1 vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt
      wbr vg cv cF cfv cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr
      wa wph cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr
      vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa cR
      c1 vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv cF
      cfv cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wa vw vg cv cn
      vw cv vg cv wceq cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno
      cfv clt wbr cR c1 vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv
      clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt
      wbr vg cv cF cfv cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr
      vw cv vg cv wceq cR c1 vw cv cdiv co cmin co cR c1 vg cv cdiv co cmin co
      vw cv cF cfv cA cmv co cno cfv vg cv cF cfv cA cmv co cno cfv clt vw cv
      vg cv wceq c1 vw cv cdiv co c1 vg cv cdiv co cR cmin vw cv vg cv c1 cdiv
      opreq2 opreq2d vw cv vg cv wceq vw cv cF cfv cA cmv co vg cv cF cfv cA
      cmv co cno vw cv vg cv wceq vw cv cF cfv vg cv cF cfv cA cmv vw cv vg cv
      cF fveq2 opreq1d fveq2d breq12d vw cv vg cv wceq vw cv cF cfv cA cmv co
      cno cfv vg cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co cR c1
      vg cv cdiv co caddc co clt vw cv vg cv wceq vw cv cF cfv cA cmv co vg cv
      cF cfv cA cmv co cno vw cv vg cv wceq vw cv cF cfv vg cv cF cfv cA cmv vw
      cv vg cv cF fveq2 opreq1d fveq2d vw cv vg cv wceq c1 vw cv cdiv co c1 vg
      cv cdiv co cR caddc vw cv vg cv c1 cdiv opreq2 opreq2d breq12d anbi12d
      rcla4v wph cn cH cF wf cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co
      cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc
      co clt wbr wa vw cn wral projlem26.5 pm3.27bi syl5com imp pm3.26d vg cv
      cF cfv cA cmv co cno cfv cr wcel c1 vg cv cdiv co cr wcel cR vg cv cF cfv
      cA cmv co cno cfv cmin co c1 vg cv cdiv co clt wbr cR c1 vg cv cdiv co
      cmin co vg cv cF cfv cA cmv co cno cfv clt wbr wb wph vg cv cn wcel wa cR
      cr wcel vg cv cF cfv cA cmv co cno cfv cr wcel c1 vg cv cdiv co cr wcel
      cR vg cv cF cfv cA cmv co cno cfv cmin co c1 vg cv cdiv co clt wbr cR c1
      vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr wb vv vu cA
      cR cS cH projlem26.1 projlem26.2 projlem26.3 projlem26.4 projlem11 cR vg
      cv cF cfv cA cmv co cno cfv c1 vg cv cdiv co ltsub23 mp3an1 wph vg cv cn
      wcel wa vg cv cF cfv chil wcel cA chil wcel wa vg cv cF cfv cA cmv co
      chil wcel vg cv cF cfv cA cmv co cno cfv cr wcel wph vg cv cn wcel wa vg
      cv cF cfv chil wcel cA chil wcel wph vg cv cn wcel wa vg cv cF cfv cH
      wcel vg cv cF cfv chil wcel cn cH cF wf vg cv cn wcel vg cv cF cfv cH
      wcel wph cn cH vg cv cF ffvelrn wph cn cH cF wf cR c1 vw cv cdiv co cmin
      co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv
      cR c1 vw cv cdiv co caddc co clt wbr wa vw cn wral projlem26.5 pm3.26bi
      sylan vg cv cF cfv cH projlem26.2 cheli syl projlem26.1 jctir vg cv cF
      cfv cA hvsubcl vg cv cF cfv cA cmv co normcl 3syl vg cv cn wcel c1 vg cv
      cdiv co cr wcel wph vg cv cr wcel vg cv cc0 wne c1 vg cv cdiv co cr wcel
      vg cv cn wcel vg cv rereccl vg cv nnre vg cv nnne0 sylanc adantl sylanc
      mpbird eqbrtrd c1 vg cv cdiv co cr wcel vg cv cF cfv cA cmv co cno cfv cR
      cmin co cr wcel c1 vg cv cdiv co cneg vg cv cF cfv cA cmv co cno cfv cR
      cmin co clt wbr vg cv cF cfv cA cmv co cno cfv cR cmin co cneg c1 vg cv
      cdiv co clt wbr wb wph vg cv cn wcel wa c1 vg cv cdiv co vg cv cF cfv cA
      cmv co cno cfv cR cmin co ltnegcon1 vg cv cn wcel c1 vg cv cdiv co cr
      wcel wph vg cv cr wcel vg cv cc0 wne c1 vg cv cdiv co cr wcel vg cv cn
      wcel vg cv rereccl vg cv nnre vg cv nnne0 sylanc adantl wph vg cv cn wcel
      wa vg cv cF cfv cA cmv co cno cfv cr wcel cR cr wcel wa vg cv cF cfv cA
      cmv co cno cfv cR cmin co cr wcel wph vg cv cn wcel wa vg cv cF cfv cA
      cmv co cno cfv cr wcel cR cr wcel wph vg cv cn wcel wa vg cv cF cfv chil
      wcel cA chil wcel wa vg cv cF cfv cA cmv co chil wcel vg cv cF cfv cA cmv
      co cno cfv cr wcel wph vg cv cn wcel wa vg cv cF cfv chil wcel cA chil
      wcel wph vg cv cn wcel wa vg cv cF cfv cH wcel vg cv cF cfv chil wcel cn
      cH cF wf vg cv cn wcel vg cv cF cfv cH wcel wph cn cH vg cv cF ffvelrn
      wph cn cH cF wf cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno
      cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co
      clt wbr wa vw cn wral projlem26.5 pm3.26bi sylan vg cv cF cfv cH
      projlem26.2 cheli syl projlem26.1 jctir vg cv cF cfv cA hvsubcl vg cv cF
      cfv cA cmv co normcl 3syl vv vu cA cR cS cH projlem26.1 projlem26.2
      projlem26.3 projlem26.4 projlem11 jctir vg cv cF cfv cA cmv co cno cfv cR
      resubcl syl sylanc mpbird wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno
      cfv cR cmin co c1 vg cv cdiv co clt wbr vg cv cF cfv cA cmv co cno cfv cR
      c1 vg cv cdiv co caddc co clt wbr wph vg cv cn wcel wa cR c1 vg cv cdiv
      co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv cF cfv cA cmv co
      cno cfv cR c1 vg cv cdiv co caddc co clt wbr wph vg cv cn wcel cR c1 vg
      cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv cF cfv cA
      cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wa vg cv cn wcel cR
      c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF
      cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa vw cn wral
      cR c1 vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv
      cF cfv cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wa wph cR
      c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF
      cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa cR c1 vg cv
      cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vg cv cF cfv cA
      cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wa vw vg cv cn vw cv
      vg cv wceq cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt
      wbr cR c1 vg cv cdiv co cmin co vg cv cF cfv cA cmv co cno cfv clt wbr vw
      cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr vg cv cF
      cfv cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr vw cv vg cv
      wceq cR c1 vw cv cdiv co cmin co cR c1 vg cv cdiv co cmin co vw cv cF cfv
      cA cmv co cno cfv vg cv cF cfv cA cmv co cno cfv clt vw cv vg cv wceq c1
      vw cv cdiv co c1 vg cv cdiv co cR cmin vw cv vg cv c1 cdiv opreq2 opreq2d
      vw cv vg cv wceq vw cv cF cfv cA cmv co vg cv cF cfv cA cmv co cno vw cv
      vg cv wceq vw cv cF cfv vg cv cF cfv cA cmv vw cv vg cv cF fveq2 opreq1d
      fveq2d breq12d vw cv vg cv wceq vw cv cF cfv cA cmv co cno cfv vg cv cF
      cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co cR c1 vg cv cdiv co
      caddc co clt vw cv vg cv wceq vw cv cF cfv cA cmv co vg cv cF cfv cA cmv
      co cno vw cv vg cv wceq vw cv cF cfv vg cv cF cfv cA cmv vw cv vg cv cF
      fveq2 opreq1d fveq2d vw cv vg cv wceq c1 vw cv cdiv co c1 vg cv cdiv co
      cR caddc vw cv vg cv c1 cdiv opreq2 opreq2d breq12d anbi12d rcla4v wph cn
      cH cF wf cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt
      wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr
      wa vw cn wral projlem26.5 pm3.27bi syl5com imp pm3.27d vg cv cF cfv cA
      cmv co cno cfv cr wcel c1 vg cv cdiv co cr wcel vg cv cF cfv cA cmv co
      cno cfv cR cmin co c1 vg cv cdiv co clt wbr vg cv cF cfv cA cmv co cno
      cfv cR c1 vg cv cdiv co caddc co clt wbr wb wph vg cv cn wcel wa vg cv cF
      cfv cA cmv co cno cfv cr wcel cR cr wcel c1 vg cv cdiv co cr wcel vg cv
      cF cfv cA cmv co cno cfv cR cmin co c1 vg cv cdiv co clt wbr vg cv cF cfv
      cA cmv co cno cfv cR c1 vg cv cdiv co caddc co clt wbr wb vv vu cA cR cS
      cH projlem26.1 projlem26.2 projlem26.3 projlem26.4 projlem11 vg cv cF cfv
      cA cmv co cno cfv cR c1 vg cv cdiv co ltsubadd2 mp3an2 wph vg cv cn wcel
      wa vg cv cF cfv chil wcel cA chil wcel wa vg cv cF cfv cA cmv co chil
      wcel vg cv cF cfv cA cmv co cno cfv cr wcel wph vg cv cn wcel wa vg cv cF
      cfv chil wcel cA chil wcel wph vg cv cn wcel wa vg cv cF cfv cH wcel vg
      cv cF cfv chil wcel cn cH cF wf vg cv cn wcel vg cv cF cfv cH wcel wph cn
      cH vg cv cF ffvelrn wph cn cH cF wf cR c1 vw cv cdiv co cmin co vw cv cF
      cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv
      cdiv co caddc co clt wbr wa vw cn wral projlem26.5 pm3.26bi sylan vg cv
      cF cfv cH projlem26.2 cheli syl projlem26.1 jctir vg cv cF cfv cA hvsubcl
      vg cv cF cfv cA cmv co normcl 3syl vg cv cn wcel c1 vg cv cdiv co cr wcel
      wph vg cv cr wcel vg cv cc0 wne c1 vg cv cdiv co cr wcel vg cv cn wcel vg
      cv rereccl vg cv nnre vg cv nnne0 sylanc adantl sylanc mpbird jca vg cv
      cF cfv cA cmv co cno cfv cR cmin co cr wcel c1 vg cv cdiv co cr wcel vg
      cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv c1 vg cv cdiv co clt wbr
      c1 vg cv cdiv co cneg vg cv cF cfv cA cmv co cno cfv cR cmin co clt wbr
      vg cv cF cfv cA cmv co cno cfv cR cmin co c1 vg cv cdiv co clt wbr wa wb
      wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co c1 vg cv
      cdiv co abslt wph vg cv cn wcel wa vg cv cF cfv cA cmv co cno cfv cr wcel
      cR cr wcel wa vg cv cF cfv cA cmv co cno cfv cR cmin co cr wcel wph vg cv
      cn wcel wa vg cv cF cfv cA cmv co cno cfv cr wcel cR cr wcel wph vg cv cn
      wcel wa vg cv cF cfv chil wcel cA chil wcel wa vg cv cF cfv cA cmv co
      chil wcel vg cv cF cfv cA cmv co cno cfv cr wcel wph vg cv cn wcel wa vg
      cv cF cfv chil wcel cA chil wcel wph vg cv cn wcel wa vg cv cF cfv cH
      wcel vg cv cF cfv chil wcel cn cH cF wf vg cv cn wcel vg cv cF cfv cH
      wcel wph cn cH vg cv cF ffvelrn wph cn cH cF wf cR c1 vw cv cdiv co cmin
      co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno cfv
      cR c1 vw cv cdiv co caddc co clt wbr wa vw cn wral projlem26.5 pm3.26bi
      sylan vg cv cF cfv cH projlem26.2 cheli syl projlem26.1 jctir vg cv cF
      cfv cA hvsubcl vg cv cF cfv cA cmv co normcl 3syl vv vu cA cR cS cH
      projlem26.1 projlem26.2 projlem26.3 projlem26.4 projlem11 jctir vg cv cF
      cfv cA cmv co cno cfv cR resubcl syl vg cv cn wcel c1 vg cv cdiv co cr
      wcel wph vg cv cr wcel vg cv cc0 wne c1 vg cv cdiv co cr wcel vg cv cn
      wcel vg cv rereccl vg cv nnre vg cv nnne0 sylanc adantl sylanc mpbird
      adantr sylc an1rs adantlr syld vg cv cn wcel vg cv cG cfv cR cmin co cabs
      cfv vz cv clt wbr vg cv cF cfv cA cmv co cno cfv cR cmin co cabs cfv vz
      cv clt wbr wb wph vz cv cr wcel cc0 vz cv clt wbr wa wa vf cv cn wcel wa
      vg cv cn wcel vg cv cG cfv cR cmin co cabs cfv vg cv cF cfv cA cmv co cno
      cfv cR cmin co cabs cfv vz cv clt vg cv cn wcel vg cv cG cfv cR cmin co
      vg cv cF cfv cA cmv co cno cfv cR cmin co cabs vg cv cn wcel vg cv cG cfv
      vg cv cF cfv cA cmv co cno cfv cR cmin vx vy cA vg cv cF cG projlem26.6
      projlem23 opreq1d fveq2d breq1d adantl sylibrd exp4b com23 r19.21adv
      r19.22dva mpd exp32 r19.21aiv wph vg cv cG cfv cc wcel vg cn wral cG cR
      cli wbr cc0 vz cv clt wbr vf cv vg cv cle wbr vg cv cG cfv cR cmin co
      cabs cfv vz cv clt wbr wi vg cn wral vf cn wrex wi vz cr wral wb wph vg
      cv cG cfv cc wcel vg cn cn cc cG wf vg cv cn wcel vg cv cG cfv cc wcel
      wph cn cc vg cv cG ffvelrn wph cn cH cF wf cn chil cF wf cn cc cG wf wph
      cn cH cF wf cR c1 vw cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv
      clt wbr vw cv cF cfv cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt
      wbr wa vw cn wral projlem26.5 pm3.26bi cn cH cF wf cH chil wss cn chil cF
      wf cH projlem26.2 chssii cn cH chil cF fss mpan2 vx vy cA cF cG
      projlem26.6 projlem26.1 projlem24 3syl sylan r19.21aiva cR cc wcel vg cv
      cG cfv cc wcel vg cn wral cG cR cli wbr cc0 vz cv clt wbr vf cv vg cv cle
      wbr vg cv cG cfv cR cmin co cabs cfv vz cv clt wbr wi vg cn wral vf cn
      wrex wi vz cr wral wb cR vv vu cA cR cS cH projlem26.1 projlem26.2
      projlem26.3 projlem26.4 projlem11 recni cR cc wcel vg cv cG cfv cc wcel
      vg cn cn cin wral cG cR cli wbr cc0 vz cv clt wbr vf cv vg cv cle wbr vg
      cv cG cfv cR cmin co cabs cfv vz cv clt wbr wi vg cn wral vf cn wrex wi
      vz cr wral wb vg cv cG cfv cc wcel vg cn wral vz cR vf vg cG c1 c1 cn cn
      1z cn c1 cuz cfv nnuz eqimss2i nnssz 1z cn c1 cuz cfv nnuz eqimss2i nnssz
      vx vy cn vx cv cF cfv cA cmv co cno cfv cG nnex projlem26.6 fopabex2
      clm4i cn cn cin cn wss vg cv cG cfv cc wcel vg cn wral vg cv cG cfv cc
      wcel vg cn cn cin wral wi cn cn inss2 vg cv cG cfv cc wcel vg cn cn cin
      cn ssralv ax-mp sylan2 mpan syl mpbird $.
      $( [6-Jul-2006] $) $( [3-Oct-1999] $)
  $}

  ${
    $d u v x y z w A $.  $d u v g x z H $.  $d x y z w D $.  $d w G $.
    $d g x y w z F $.  $d x y z w R $.  $d g x y z ph $.
    projlem27.1 $e |- A e. ~H $.
    projlem27.2 $e |- H e. CH $.
    projlem27.3 $e |- S =
                      { u e. RR | E. v e. H u = -u ( normh ` ( v -h A ) ) } $.
    projlem27.4 $e |- R = -u sup ( S , RR , < ) $.
    projlem27.5 $e |- ( ph <-> ( F : NN --> H /\ A. w e. NN
                     ( ( R - ( 1 / w ) ) < ( normh ` ( ( F ` w ) -h A ) )
               /\ ( normh ` ( ( F ` w ) -h A ) ) < ( R + ( 1 / w ) ) ) ) ) $.
    ${
      projlem27.6 $e |- N e. NN $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  Boundedness to show ` F `
         is a Cauchy sequence.  Used by ~ projlem28 . $)
      projlem27 $p |- ( ( ph /\ ( D e. NN /\ G e. NN ) ) ->
                ( ( N <_ D /\ N <_ G ) ->
             ( normh ` ( ( F ` D ) -h ( F ` G ) ) ) <
           ( sqr ` ( ( 4 x. ( ( 2 x. R ) + 1 ) ) / N ) ) ) ) $=
        cD cF cfv cH wcel cG cF cfv cH wcel wa cD cn wcel cG cn wcel wa wa cD
        cF cfv cA cmv co cno cfv cR c1 cD cdiv co caddc co clt wbr cG cF cfv cA
        cmv co cno cfv cR c1 cG cdiv co caddc co clt wbr wa cN cD cle wbr cN cG
        cle wbr wa cD cF cfv cG cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc
        co cmul co cN cdiv co csqr cfv clt wbr wi wph cD cn wcel cG cn wcel wa
        wa vv vu cA cD cF cfv cG cF cfv cD cR cS cG cH cN projlem27.1
        projlem27.2 projlem27.3 projlem27.4 projlem27.6 projlem20 wph cD cn
        wcel cG cn wcel wa cD cF cfv cH wcel cG cF cfv cH wcel wa wph cD cn
        wcel cD cF cfv cH wcel cG cn wcel cG cF cfv cH wcel wph vw cA cD cR cF
        cH projlem27.5 projlem21 wph vw cA cG cR cF cH projlem27.5 projlem21
        anim12d impac wph cD cn wcel cG cn wcel wa cD cF cfv cA cmv co cno cfv
        cR c1 cD cdiv co caddc co clt wbr cG cF cfv cA cmv co cno cfv cR c1 cG
        cdiv co caddc co clt wbr wa wph cD cn wcel cD cF cfv cA cmv co cno cfv
        cR c1 cD cdiv co caddc co clt wbr cG cn wcel cG cF cfv cA cmv co cno
        cfv cR c1 cG cdiv co caddc co clt wbr wph vw cA cD cR cF cH projlem27.5
        projlem22 wph vw cA cG cR cF cH projlem27.5 projlem22 anim12d imp sylc
        $.
        $( [28-Sep-1999] $)
    $}

    ${
      projlem28.6 $e |- D e. RR $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  Boundedness to show ` F `
         is a Cauchy sequence.  Used by ~ projlem29 . $)
      projlem28 $p |- ( ph -> ( 0 < D -> E. z e. NN
                  A. x e. NN A. y e. NN ( ( z <_ x /\ z <_ y ) ->
               ( normh ` ( ( F ` x ) -h ( F ` y ) ) ) < D ) ) ) $=
        wph c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt
        wbr vz cn wrex vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv
        vy cv cF cfv cmv co cno cfv cD clt wbr wi vy cn wral vx cn wral vz cn
        wrex cc0 cD clt wbr wph c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co csqr cfv cD clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv
        cF cfv vy cv cF cfv cmv co cno cfv cD clt wbr wi vy cn wral vx cn wral
        vz cn wph vz cv cn wcel wa c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co csqr cfv cD clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa
        vx cv cF cfv vy cv cF cfv cmv co cno cfv cD clt wbr wi vy cn wral vx cn
        wral wph vz cv cn wcel wa c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co csqr cfv cD clt wbr wa vx cv cn wcel vy cv cn wcel wa vz cv vx
        cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co cno
        cfv cD clt wbr wi wi vy wal vx wal vz cv vx cv cle wbr vz cv vy cv cle
        wbr wa vx cv cF cfv vy cv cF cfv cmv co cno cfv cD clt wbr wi vy cn
        wral vx cn wral wph vz cv cn wcel wa c4 c2 cR cmul co c1 caddc co cmul
        co vz cv cdiv co csqr cfv cD clt wbr wa vx cv cn wcel vy cv cn wcel wa
        vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv
        cmv co cno cfv cD clt wbr wi wi vx vy wph vz cv cn wcel wa c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr wa vx cv
        cn wcel vy cv cn wcel wa vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx
        cv cF cfv vy cv cF cfv cmv co cno cfv cD clt wbr wi wph vz cv cn wcel
        wa c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt
        wbr wa vx cv cn wcel vy cv cn wcel wa wa vz cv vx cv cle wbr vz cv vy
        cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co
        c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr vx cv cF cfv vy cv
        cF cfv cmv co cno cfv cD clt wbr wph vz cv cn wcel wa vx cv cn wcel vy
        cv cn wcel wa vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv
        vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co csqr cfv clt wbr wi c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co csqr cfv cD clt wbr wph vz cv cn wcel vx cv cn wcel vy cv cn
        wcel wa vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv
        cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co csqr cfv clt wbr wi vz cv cn wcel wph vx cv cn wcel vy cv cn wcel wa
        vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv
        cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr
        cfv clt wbr wi wi vz cv cn wcel wph vx cv cn wcel vy cv cn wcel wa vz
        cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv
        co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv
        clt wbr wi vz cv cn wcel wph vx cv cn wcel vy cv cn wcel wa wa vz cv vx
        cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co cno
        cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr
        wi wi wph vx cv cn wcel vy cv cn wcel wa wa vz cv cn wcel vz cv c1 cif
        vx cv cle wbr vz cv cn wcel vz cv c1 cif vy cv cle wbr wa vx cv cF cfv
        vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cn wcel vz cv c1 cif cdiv co csqr cfv clt wbr wi wi vz cv c1 vz cv vz
        cv cn wcel vz cv c1 cif wceq vz cv vx cv cle wbr vz cv vy cv cle wbr wa
        vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc co
        cmul co vz cv cdiv co csqr cfv clt wbr wi vz cv cn wcel vz cv c1 cif vx
        cv cle wbr vz cv cn wcel vz cv c1 cif vy cv cle wbr wa vx cv cF cfv vy
        cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv cn
        wcel vz cv c1 cif cdiv co csqr cfv clt wbr wi wph vx cv cn wcel vy cv
        cn wcel wa wa vz cv vz cv cn wcel vz cv c1 cif wceq vz cv vx cv cle wbr
        vz cv vy cv cle wbr wa vz cv cn wcel vz cv c1 cif vx cv cle wbr vz cv
        cn wcel vz cv c1 cif vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co
        cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv clt
        wbr vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc
        co cmul co vz cv cn wcel vz cv c1 cif cdiv co csqr cfv clt wbr vz cv vz
        cv cn wcel vz cv c1 cif wceq vz cv vx cv cle wbr vz cv cn wcel vz cv c1
        cif vx cv cle wbr vz cv vy cv cle wbr vz cv cn wcel vz cv c1 cif vy cv
        cle wbr vz cv vz cv cn wcel vz cv c1 cif vx cv cle breq1 vz cv vz cv cn
        wcel vz cv c1 cif vy cv cle breq1 anbi12d vz cv vz cv cn wcel vz cv c1
        cif wceq c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv c4
        c2 cR cmul co c1 caddc co cmul co vz cv cn wcel vz cv c1 cif cdiv co
        csqr cfv vx cv cF cfv vy cv cF cfv cmv co cno cfv clt vz cv vz cv cn
        wcel vz cv c1 cif wceq c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co c4 c2 cR cmul co c1 caddc co cmul co vz cv cn wcel vz cv c1 cif cdiv
        co csqr vz cv vz cv cn wcel vz cv c1 cif c4 c2 cR cmul co c1 caddc co
        cmul co cdiv opreq2 fveq2d breq2d imbi12d imbi2d wph vw vv vu cA vx cv
        cR cS cF vy cv cH vz cv cn wcel vz cv c1 cif projlem27.1 projlem27.2
        projlem27.3 projlem27.4 projlem27.5 vz cv c1 cn 1nn elimel projlem27
        dedth exp3a com12 imp31 adantlr wph vz cv cn wcel c4 c2 cR cmul co c1
        caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr vx cv cn wcel vy cv
        cn wcel wa vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1
        caddc co cmul co vz cv cdiv co csqr cfv clt wbr vx cv cF cfv vy cv cF
        cfv cmv co cno cfv cD clt wbr wi vx cv cn wcel vy cv cn wcel wa vz cv
        cn wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD
        clt wbr wph vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co
        c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr vx cv cF cfv vy cv
        cF cfv cmv co cno cfv cD clt wbr wi c4 c2 cR cmul co c1 caddc co cmul
        co vz cv cdiv co csqr cfv cD clt wbr wph vx cv cn wcel vy cv cn wcel wa
        vz cv cn wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co
        c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr vx cv cF cfv vy cv
        cF cfv cmv co cno cfv cD clt wbr wi c4 c2 cR cmul co c1 caddc co cmul
        co vz cv cdiv co csqr cfv cD clt wbr wph vx cv cn wcel vy cv cn wcel wa
        vz cv cn wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul co
        c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr vx cv cF cfv vy cv
        cF cfv cmv co cno cfv cD clt wbr wi wi wph vx cv cn wcel vy cv cn wcel
        wa wa vz cv cn wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr vx cv cF
        cfv vy cv cF cfv cmv co cno cfv cD clt wbr wph vx cv cn wcel vy cv cn
        wcel wa wa vz cv cn wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2
        cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr vx cv cF
        cfv vy cv cF cfv cmv co cno cfv cD clt wbr vx cv cF cfv vy cv cF cfv
        cmv co cno cfv cr wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv
        co csqr cfv cr wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr wa vx cv
        cF cfv vy cv cF cfv cmv co cno cfv cD clt wbr wi wph vx cv cn wcel vy
        cv cn wcel wa wa vz cv cn wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv
        cr wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cr
        wcel cD cr wcel vx cv cF cfv vy cv cF cfv cmv co cno cfv c4 c2 cR cmul
        co c1 caddc co cmul co vz cv cdiv co csqr cfv clt wbr c4 c2 cR cmul co
        c1 caddc co cmul co vz cv cdiv co csqr cfv cD clt wbr wa vx cv cF cfv
        vy cv cF cfv cmv co cno cfv cD clt wbr wi projlem28.6 vx cv cF cfv vy
        cv cF cfv cmv co cno cfv c4 c2 cR cmul co c1 caddc co cmul co vz cv
        cdiv co csqr cfv cD axlttrn mp3an3 wph vx cv cn wcel vy cv cn wcel wa
        wa vx cv cF cfv vy cv cF cfv cmv co chil wcel vx cv cF cfv vy cv cF cfv
        cmv co cno cfv cr wcel wph vx cv cn wcel vy cv cn wcel vx cv cF cfv vy
        cv cF cfv cmv co chil wcel vx cv cF cfv chil wcel vy cv cF cfv chil
        wcel vx cv cF cfv vy cv cF cfv cmv co chil wcel wph vx cv cn wcel wa
        wph vy cv cn wcel wa vx cv cF cfv vy cv cF cfv hvsubcl wph vx cv cn
        wcel wa vx cv cF cfv cH wcel vx cv cF cfv chil wcel wph vx cv cn wcel
        vx cv cF cfv cH wcel wph vw cA vx cv cR cF cH projlem27.5 projlem21 imp
        vx cv cF cfv cH projlem27.2 cheli syl wph vy cv cn wcel wa vy cv cF cfv
        cH wcel vy cv cF cfv chil wcel wph vy cv cn wcel vy cv cF cfv cH wcel
        wph vw cA vy cv cR cF cH projlem27.5 projlem21 imp vy cv cF cfv cH
        projlem27.2 cheli syl syl2an anandis vx cv cF cfv vy cv cF cfv cmv co
        normcl syl c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel
        cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr c4 c2 cR
        cmul co c1 caddc co cmul co vz cv cdiv co csqr cfv cr wcel vz cv cn
        wcel c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co sqrcl c4 c2 cR
        cmul co c1 caddc co cmul co cr wcel vz cv cr wcel wa vz cv cc0 wne c4
        c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel vz cv cn wcel
        c4 c2 cR cmul co c1 caddc co cmul co cr wcel vz cv cr wcel vz cv cc0
        wne c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cr wcel c4 c2 cR
        cmul co c1 caddc co cmul co vz cv redivcl 3expa vz cv cn wcel vz cv cr
        wcel c4 c2 cR cmul co c1 caddc co cmul co cr wcel vz cv nnre c4 c2 cR
        cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re vv vu cA cR cS cH
        projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem11 remulcli 1re
        readdcli remulcli jctil vz cv nnne0 sylanc vz cv cr wcel cc0 vz cv clt
        wbr cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr vz
        cv cn wcel c4 c2 cR cmul co c1 caddc co cmul co cr wcel cc0 c4 c2 cR
        cmul co c1 caddc co cmul co cle wbr vz cv cr wcel cc0 vz cv clt wbr wa
        cc0 c4 c2 cR cmul co c1 caddc co cmul co vz cv cdiv co cle wbr c4 c2 cR
        cmul co c1 caddc co 4re c2 cR cmul co c1 c2 cR 2re vv vu cA cR cS cH
        projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem11 remulcli 1re
        readdcli remulcli cc0 c4 cle wbr cc0 c2 cR cmul co c1 caddc co cle wbr
        cc0 c4 c2 cR cmul co c1 caddc co cmul co cle wbr cc0 c4 0re 4re 4pos
        ltleii cc0 c2 cR cmul co cle wbr cc0 c1 cle wbr cc0 c2 cR cmul co c1
        caddc co cle wbr cc0 c2 cle wbr cc0 cR cle wbr cc0 c2 cR cmul co cle
        wbr cc0 c2 0re 2re 2pos ltleii vv vu cA cR cS cH projlem27.1
        projlem27.2 projlem27.3 projlem27.4 projlem13 c2 cR 2re vv vu cA cR cS
        cH projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem11 mulge0i
        mp2an cc0 c1 0re 1re lt01 ltleii c2 cR cmul co c1 c2 cR 2re vv vu cA cR
        cS cH projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem11
        remulcli 1re addge0i mp2an c4 c2 cR cmul co c1 caddc co 4re c2 cR cmul
        co c1 c2 cR 2re vv vu cA cR cS cH projlem27.1 projlem27.2 projlem27.3
        projlem27.4 projlem11 remulcli 1re readdcli mulge0i mp2an c4 c2 cR cmul
        co c1 caddc co cmul co vz cv divge0 mpanl12 vz cv nnre vz cv nngt0
        sylanc sylanc syl2an exp4b com4r exp3a com4t com14 imp41 syld ex
        19.21aivv vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv
        cF cfv cmv co cno cfv cD clt wbr wi vx vy cn cn r2al sylibr ex
        r19.22dva vz cD cR vv vu cA cR cS cH projlem27.1 projlem27.2
        projlem27.3 projlem27.4 projlem11 projlem28.6 vv vu cA cR cS cH
        projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem13 projlem2 syl5
        $.
        $( [29-Sep-1999] $)
    $}

    ${
      $( Part of Lemma 3.6 of [Beran] p. 101: 'Hence, {yn} is a Cauchy
         sequence.'  Used by ~ projlem30 . $)
      projlem29 $p |- ( ph -> F e. Cauchy ) $=
        wph cn chil cF wf cc0 vg cv clt wbr vz cv vx cv cle wbr vz cv vy cv cle
        wbr wa vx cv cF cfv vy cv cF cfv cmv co cno cfv vg cv clt wbr wi vy cn
        wral vx cn wral vz cn wrex wi vg cr wral wa cF ccau wcel wph cn chil cF
        wf cc0 vg cv clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv
        cF cfv vy cv cF cfv cmv co cno cfv vg cv clt wbr wi vy cn wral vx cn
        wral vz cn wrex wi vg cr wral wph cn cH cF wf cH chil wss wa cn chil cF
        wf wph cn cH cF wf cH chil wss wph cn cH cF wf cR c1 vw cv cdiv co cmin
        co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv cA cmv co cno
        cfv cR c1 vw cv cdiv co caddc co clt wbr wa vw cn wral projlem27.5
        pm3.26bi cH projlem27.2 chssii jctir cn cH chil cF fss syl wph cc0 vg
        cv clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy
        cv cF cfv cmv co cno cfv vg cv clt wbr wi vy cn wral vx cn wral vz cn
        wrex wi vg cr vg cv cr wcel wph cc0 vg cv clt wbr vz cv vx cv cle wbr
        vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co cno cfv vg cv
        clt wbr wi vy cn wral vx cn wral vz cn wrex wi vg cv cr wcel wph cc0 vg
        cv clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy
        cv cF cfv cmv co cno cfv vg cv clt wbr wi vy cn wral vx cn wral vz cn
        wrex wi wi wph cc0 vg cv cr wcel vg cv c1 cif clt wbr vz cv vx cv cle
        wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co cno cfv vg
        cv cr wcel vg cv c1 cif clt wbr wi vy cn wral vx cn wral vz cn wrex wi
        wi vg cv c1 vg cv vg cv cr wcel vg cv c1 cif wceq cc0 vg cv clt wbr vz
        cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv
        co cno cfv vg cv clt wbr wi vy cn wral vx cn wral vz cn wrex wi cc0 vg
        cv cr wcel vg cv c1 cif clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr
        wa vx cv cF cfv vy cv cF cfv cmv co cno cfv vg cv cr wcel vg cv c1 cif
        clt wbr wi vy cn wral vx cn wral vz cn wrex wi wph vg cv vg cv cr wcel
        vg cv c1 cif wceq cc0 vg cv clt wbr cc0 vg cv cr wcel vg cv c1 cif clt
        wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF
        cfv cmv co cno cfv vg cv clt wbr wi vy cn wral vx cn wral vz cn wrex vz
        cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv
        co cno cfv vg cv cr wcel vg cv c1 cif clt wbr wi vy cn wral vx cn wral
        vz cn wrex vg cv vg cv cr wcel vg cv c1 cif cc0 clt breq2 vg cv vg cv
        cr wcel vg cv c1 cif wceq vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx
        cv cF cfv vy cv cF cfv cmv co cno cfv vg cv clt wbr wi vy cn wral vx cn
        wral vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF
        cfv cmv co cno cfv vg cv cr wcel vg cv c1 cif clt wbr wi vy cn wral vx
        cn wral vz cn vg cv vg cv cr wcel vg cv c1 cif wceq vz cv vx cv cle wbr
        vz cv vy cv cle wbr wa vx cv cF cfv vy cv cF cfv cmv co cno cfv vg cv
        clt wbr wi vz cv vx cv cle wbr vz cv vy cv cle wbr wa vx cv cF cfv vy
        cv cF cfv cmv co cno cfv vg cv cr wcel vg cv c1 cif clt wbr wi vx vy cn
        cn vg cv vg cv cr wcel vg cv c1 cif wceq vx cv cF cfv vy cv cF cfv cmv
        co cno cfv vg cv clt wbr vx cv cF cfv vy cv cF cfv cmv co cno cfv vg cv
        cr wcel vg cv c1 cif clt wbr vz cv vx cv cle wbr vz cv vy cv cle wbr wa
        vg cv vg cv cr wcel vg cv c1 cif vx cv cF cfv vy cv cF cfv cmv co cno
        cfv clt breq2 imbi2d 2ralbidv rexbidv imbi12d imbi2d wph vx vy vz vw vv
        vu cA vg cv cr wcel vg cv c1 cif cR cS cF cH projlem27.1 projlem27.2
        projlem27.3 projlem27.4 projlem27.5 vg cv c1 cr 1re elimel projlem28
        dedth com12 r19.21aiv jca vg vz vx vy cF hcau sylibr $.
        $( [29-Sep-1999] $)

      $( Part of Lemma 3.6 of [Beran] p. 101: 'By completeness of W, there
         exists y0 e. W such that yn->y0.'  Used by ~ projlem31 . $)
      projlem30 $p |- ( ph -> E. z e. H F ~~>v z ) $=
        cF ccau wcel cn cH cF wf cF vz cv chli wbr vz cH wrex wph cH cch wcel
        cF ccau wcel cn cH cF wf cF vz cv chli wbr vz cH wrex projlem27.2 vz cF
        cH chcompl mp3an1 wph vw vv vu cA cR cS cF cH projlem27.1 projlem27.2
        projlem27.3 projlem27.4 projlem27.5 projlem29 wph cn cH cF wf cR c1 vw
        cv cdiv co cmin co vw cv cF cfv cA cmv co cno cfv clt wbr vw cv cF cfv
        cA cmv co cno cfv cR c1 vw cv cdiv co caddc co clt wbr wa vw cn wral
        projlem27.5 pm3.26bi sylanc $.
        $( [29-Sep-1999] $)
    $}

    ${
      projlem31.6 $e |- F e. _V $.
      $( Part of Lemma 3.6 of [Beran] p. 101.  The postulated vector sequence
         ` F ` implies our conclusion.  By showing such a sequence exists
         (which was done with the Axiom of Choice in ~ projlem17 ),
         we can show the final conclusion, ~ projlem . $)
      projlem31 $p |- ( ph -> E. x e. H A. y e. H ( normh ` ( x -h A ) )
                          <_ ( normh ` ( y -h A ) ) ) $=
        wph cF vx cv chli wbr vx cH wrex vx cv cA cmv co cno cfv vy cv cA cmv
        co cno cfv cle wbr vy cH wral vx cH wrex wph vx vw vv vu cA cR cS cF cH
        projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem27.5 projlem30
        wph cF vx cv chli wbr vx cv cA cmv co cno cfv vy cv cA cmv co cno cfv
        cle wbr vy cH wral vx cH wph cF vx cv chli wbr vx cv cA cmv co cno cfv
        vy cv cA cmv co cno cfv cle wbr vy cH wral wph cF vx cv chli wbr wa vx
        cv cA cmv co cno cfv vy cv cA cmv co cno cfv cle wbr vy cH wph cF vx cv
        chli wbr wa cR vy cv cA cmv co cno cfv cle wbr vx cv cA cmv co cno cfv
        vy cv cA cmv co cno cfv cle wbr vy cv cH wcel wph cF vx cv chli wbr wa
        cR vx cv cA cmv co cno cfv vy cv cA cmv co cno cfv cle vz cv cn wcel vy
        cv vz cv cF cfv cA cmv co cno cfv wceq wa vz vy copab cR cli wbr vz cv
        cn wcel vy cv vz cv cF cfv cA cmv co cno cfv wceq wa vz vy copab vx cv
        cA cmv co cno cfv cli wbr cR vx cv cA cmv co cno cfv wceq wph cF vx cv
        chli wbr cR vx cv cA cmv co cno cfv vz cv cn wcel vy cv vz cv cF cfv cA
        cmv co cno cfv wceq wa vz vy copab cR cr vv vu cA cR cS cH projlem27.1
        projlem27.2 projlem27.3 projlem27.4 projlem11 elisseti vx cv cA cmv co
        cno fvex climuni wph vz vy vw vv vu cA cR cS cF vz cv cn wcel vy cv vz
        cv cF cfv cA cmv co cno cfv wceq wa vz vy copab cH projlem27.1
        projlem27.2 projlem27.3 projlem27.4 projlem27.5 vz cv cn wcel vy cv vz
        cv cF cfv cA cmv co cno cfv wceq wa vz vy copab eqid projlem26 vz vy vx
        cA cF vz cv cn wcel vy cv vz cv cF cfv cA cmv co cno cfv wceq wa vz vy
        copab vz cv cn wcel vy cv vz cv cF cfv cA cmv co cno cfv wceq wa vz vy
        copab eqid projlem27.1 projlem31.6 projlem25 syl2an breq1d vv vu cA vy
        cv cR cS cH projlem27.1 projlem27.2 projlem27.3 projlem27.4 projlem12
        syl5bi r19.21aiv ex r19.22sdv mpd $.
        $( [6-Jul-2006] $) $( [4-Oct-1999] $)
    $}
  $}

  ${
    $d x y f u v w H $.  $d x y f u v w A $.
    projlem.1 $e |- A e. ~H $.
    projlem.2 $e |- H e. CH $.
    $( Lemma 3.6 of [Beran] p. 101:  "Let ` H ` be a complete subspace of a
       (pre-)Hilbert space ` ~H ` and let ` A e. ~H ` .  Then there exists
       a vector ` x e. H ` such that
       ` ( norm `` ( x -h A ) ) <_ ( norm `` ( y -h A ) ) ` for every
       ` y e. H ` ."  This is a lemma for the projection theorem. $)
    projlem $p |- E. x e. H A. y e. H ( normh ` ( x -h A ) )
                   <_ ( normh ` ( y -h A ) ) $=
      cn cH vf cv wf vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr
      crab cr clt csup cneg c1 vw cv cdiv co cmin co vw cv vf cv cfv cA cmv co
      cno cfv clt wbr vw cv vf cv cfv cA cmv co cno cfv vu cv vv cv cA cmv co
      cno cfv cneg wceq vv cH wrex vu cr crab cr clt csup cneg c1 vw cv cdiv co
      caddc co clt wbr wa vw cn wral wa vf wex vx cv cA cmv co cno cfv vy cv cA
      cmv co cno cfv cle wbr vy cH wral vx cH wrex vw vv vu cA vu cv vv cv cA
      cmv co cno cfv cneg wceq vv cH wrex vu cr crab cr clt csup cneg vu cv vv
      cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab vf cH projlem.1
      projlem.2 vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab
      eqid vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab cr clt
      csup cneg eqid projlem17 cn cH vf cv wf vu cv vv cv cA cmv co cno cfv
      cneg wceq vv cH wrex vu cr crab cr clt csup cneg c1 vw cv cdiv co cmin co
      vw cv vf cv cfv cA cmv co cno cfv clt wbr vw cv vf cv cfv cA cmv co cno
      cfv vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab cr clt
      csup cneg c1 vw cv cdiv co caddc co clt wbr wa vw cn wral wa vx cv cA cmv
      co cno cfv vy cv cA cmv co cno cfv cle wbr vy cH wral vx cH wrex vf cn cH
      vf cv wf vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab cr
      clt csup cneg c1 vw cv cdiv co cmin co vw cv vf cv cfv cA cmv co cno cfv
      clt wbr vw cv vf cv cfv cA cmv co cno cfv vu cv vv cv cA cmv co cno cfv
      cneg wceq vv cH wrex vu cr crab cr clt csup cneg c1 vw cv cdiv co caddc
      co clt wbr wa vw cn wral wa vx vy vw vv vu cA vu cv vv cv cA cmv co cno
      cfv cneg wceq vv cH wrex vu cr crab cr clt csup cneg vu cv vv cv cA cmv
      co cno cfv cneg wceq vv cH wrex vu cr crab vf cv cH projlem.1 projlem.2
      vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab eqid vu cv
      vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu cr crab cr clt csup cneg
      eqid cn cH vf cv wf vu cv vv cv cA cmv co cno cfv cneg wceq vv cH wrex vu
      cr crab cr clt csup cneg c1 vw cv cdiv co cmin co vw cv vf cv cfv cA cmv
      co cno cfv clt wbr vw cv vf cv cfv cA cmv co cno cfv vu cv vv cv cA cmv
      co cno cfv cneg wceq vv cH wrex vu cr crab cr clt csup cneg c1 vw cv cdiv
      co caddc co clt wbr wa vw cn wral wa biid vf visset projlem31 19.23aiv
      ax-mp $.
      $( [4-Oct-1999] $)

    $( Lemma 3.6 of [Beran] p. 101:  "Let ` H ` be a complete subspace of a
       (pre-)Hilbert space ` ~H ` and let ` A e. ~H ` .  Then there exists
       a vector ` x e. H ` such that
       ` ( norm `` ( x -h A ) ) <_ ( norm `` ( y -h A ) ) ` for every
       ` y e. H ` ."  This is a lemma for the projection theorem. $)
    projlemHIL $p |- E. x e. H A. y e. H ( normh ` ( x -h A ) )
                   <_ ( normh ` ( y -h A ) ) $=
      cA vx cv cmv co cno cfv cA vy cv cmv co cno cfv cle wbr vy cH wral vx cH
      wrex vx cv cA cmv co cno cfv vy cv cA cmv co cno cfv cle wbr vy cH wral
      vx cH wrex vx vy cA cva csm cop cno cop cmv cno cva cH cH cxp cres csm cc
      cH cxp cres cop cno cH cres cop chil cH cva csm cop cno cop cva csm cop
      cno cop eqid hhba cva csm cop cno cop cva csm cop cno cop eqid hhvs cva
      csm cop cno cop cva csm cop cno cop eqid hhnm cH cva cH cH cxp cres csm
      cc cH cxp cres cop cno cH cres cop cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cop eqid cH projlem.2 chshii hhssba cva csm cop cno cop
      cva csm cop cno cop eqid hhph cva cH cH cxp cres csm cc cH cxp cres cop
      cno cH cres cop cva csm cop cno cop css cfv cbn cin wcel cva cH cH cxp
      cres csm cc cH cxp cres cop cno cH cres cop cva csm cop cno cop css cfv
      wcel cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop cbn wcel
      cva cH cH cxp cres csm cc cH cxp cres cop cno cH cres cop cva csm cop cno
      cop css cfv cbn elin cH csh wcel cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cop cva csm cop cno cop css cfv wcel cH projlem.2 chshii
      cva csm cop cno cop cH cva cH cH cxp cres csm cc cH cxp cres cop cno cH
      cres cop cva csm cop cno cop eqid cva cH cH cxp cres csm cc cH cxp cres
      cop cno cH cres cop eqid hhsst ax-mp cH cva cH cH cxp cres csm cc cH cxp
      cres cop cno cH cres cop cva cH cH cxp cres csm cc cH cxp cres cop cno cH
      cres cop eqid projlem.2 hhssbn mpbir2an projlem.1 minvecex2 cA vx cv cmv
      co cno cfv cA vy cv cmv co cno cfv cle wbr vy cH wral vx cv cA cmv co cno
      cfv vy cv cA cmv co cno cfv cle wbr vy cH wral vx cH vx cv cH wcel cA vx
      cv cmv co cno cfv cA vy cv cmv co cno cfv cle wbr vx cv cA cmv co cno cfv
      vy cv cA cmv co cno cfv cle wbr vy cH vx cv cH wcel vy cv cH wcel cA vx
      cv cmv co cno cfv vx cv cA cmv co cno cfv cA vy cv cmv co cno cfv vy cv
      cA cmv co cno cfv cle vx cv cH wcel vx cv chil wcel cA vx cv cmv co cno
      cfv vx cv cA cmv co cno cfv wceq vx cv cH projlem.2 cheli cA chil wcel vx
      cv chil wcel cA vx cv cmv co cno cfv vx cv cA cmv co cno cfv wceq
      projlem.1 cA vx cv normsub mpan syl vy cv cH wcel vy cv chil wcel cA vy
      cv cmv co cno cfv vy cv cA cmv co cno cfv wceq vy cv cH projlem.2 cheli
      cA chil wcel vy cv chil wcel cA vy cv cmv co cno cfv vy cv cA cmv co cno
      cfv wceq projlem.1 cA vy cv normsub mpan syl breqan12d ralbidva rexbiia
      mpbi $.
      $( [8-Jul-2008] $) $( [24-Mar-2008] $)
  $}

  ${
    pjthlem1.1 $e |- A e. ~H $.
    pjthlem1.2 $e |- B e. ~H $.
    pjthlem1.3 $e |- D e. ~H $.
    pjthlem1.4 $e |- S e. CC $.
    pjthlem1.5 $e |- C = ( A -h B ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem1 $p |- ( ( normh ` ( B -h A ) ) <_
                ( normh ` ( ( B +h ( S .h D ) ) -h A ) ) <->
      ( ( normh ` C ) ^ 2 ) <_ ( ( normh ` ( C -h ( S .h D ) ) ) ^ 2 ) ) $=
      cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno cfv cle wbr cC
      cno cfv cC cS cD csm co cmv co cno cfv cle wbr cC cno cfv c2 cexp co cC
      cS cD csm co cmv co cno cfv c2 cexp co cle wbr cB cA cmv co cno cfv cC
      cno cfv cB cS cD csm co cva co cA cmv co cno cfv cC cS cD csm co cmv co
      cno cfv cle cB cA cmv co cno cfv cA cB cmv co cno cfv cC cno cfv cB cA
      pjthlem1.2 pjthlem1.1 normsubi cC cA cB cmv co cno pjthlem1.5 fveq2i
      eqtr4i cB cS cD csm co cva co cA cmv co cno cfv cA cB cS cD csm co cva co
      cmv co cno cfv cC cS cD csm co cmv co cno cfv cB cS cD csm co cva co cA
      cB cS cD csm co pjthlem1.2 cS cD pjthlem1.4 pjthlem1.3 hvmulcli hvaddcli
      pjthlem1.1 normsubi cA cB cS cD csm co cva co cmv co cC cS cD csm co cmv
      co cno cC cS cD csm co cmv co cA cB cmv co cS cD csm co cmv co cA cB cS
      cD csm co cva co cmv co cC cA cB cmv co cS cD csm co cmv pjthlem1.5
      opreq1i cA cB cS cD csm co pjthlem1.1 pjthlem1.2 cS cD pjthlem1.4
      pjthlem1.3 hvmulcli hvsubassi eqtr2i fveq2i eqtri breq12i cc0 cC cno cfv
      cle wbr cc0 cC cS cD csm co cmv co cno cfv cle wbr cC cno cfv cC cS cD
      csm co cmv co cno cfv cle wbr cC cno cfv c2 cexp co cC cS cD csm co cmv
      co cno cfv c2 cexp co cle wbr wb cC chil wcel cc0 cC cno cfv cle wbr cC
      cA cB cmv co chil pjthlem1.5 cA cB pjthlem1.1 pjthlem1.2 hvsubcli eqeltri
      cC normge0 ax-mp cC cS cD csm co cmv co chil wcel cc0 cC cS cD csm co cmv
      co cno cfv cle wbr cC cS cD csm co cC cA cB cmv co chil pjthlem1.5 cA cB
      pjthlem1.1 pjthlem1.2 hvsubcli eqeltri cS cD pjthlem1.4 pjthlem1.3
      hvmulcli hvsubcli cC cS cD csm co cmv co normge0 ax-mp cC cno cfv cC cS
      cD csm co cmv co cno cfv cC cC cA cB cmv co chil pjthlem1.5 cA cB
      pjthlem1.1 pjthlem1.2 hvsubcli eqeltri normcli cC cS cD csm co cmv co cC
      cS cD csm co cC cA cB cmv co chil pjthlem1.5 cA cB pjthlem1.1 pjthlem1.2
      hvsubcli eqeltri cS cD pjthlem1.4 pjthlem1.3 hvmulcli hvsubcli normcli
      le2sqi mp2an bitri $.
      $( [7-Oct-1999] $)
  $}

  ${
    pjthlem2.1 $e |- D e. ~H $.
    pjthlem2.2 $e |- R = ( 1 / ( D .ih D ) ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem2 $p |- ( D =/= 0h -> R e. RR ) $=
      cD c0v wne c1 cD cD csp co cdiv co cr cR cD c0v wne cc0 cD cD csp co clt
      wbr cD cD csp co cc0 wne c1 cD cD csp co cdiv co cr wcel cD chil wcel cD
      c0v wne cc0 cD cD csp co clt wbr pjthlem2.1 cD ax-his4 mpan cD cD csp co
      cD chil wcel cD cD csp co cr wcel pjthlem2.1 cD hiidrcl ax-mp gt0ne0i cD
      cD csp co cD chil wcel cD cD csp co cr wcel pjthlem2.1 cD hiidrcl ax-mp
      rerecclzi 3syl pjthlem2.2 syl5eqel $.
      $( [5-Jul-2007] $) $( [8-Oct-1999] $)

    $( Lemma for ~ pjthi . $)
    pjthlem3 $p |- ( D =/= 0h -> 0 < R ) $=
      cD c0v wne cc0 c1 cD cD csp co cdiv co cR clt cD c0v wne cc0 cD cD csp co
      clt wbr cc0 c1 cD cD csp co cdiv co clt wbr cD chil wcel cD c0v wne cc0
      cD cD csp co clt wbr pjthlem2.1 cD ax-his4 mpan cD cD csp co cD chil wcel
      cD cD csp co cr wcel pjthlem2.1 cD hiidrcl ax-mp recgt0i syl pjthlem2.2
      syl6breqr $.
      $( [5-Jul-2007] $) $( [8-Oct-1999] $)

    ${
      pjthlem4.3 $e |- C e. ~H $.
      pjthlem4.4 $e |- S = ( R x. ( C .ih D ) ) $.
      $( Lemma for ~ pjthi . $)
      pjthlem4 $p |- ( D =/= 0h -> S e. CC ) $=
        cD c0v wne cR cC cD csp co cmul co cc cS cD c0v wne cR cc wcel cC cD
        csp co cc wcel wa cR cC cD csp co cmul co cc wcel cD c0v wne cR cc wcel
        cC cD csp co cc wcel cD c0v wne cR cD cR pjthlem2.1 pjthlem2.2 pjthlem2
        recnd cC cD pjthlem4.3 pjthlem2.1 hicli jctir cR cC cD csp co mulcl syl
        pjthlem4.4 syl5eqel $.
        $( [5-Jul-2007] $) $( [8-Oct-1999] $)
    $}
  $}

  ${
    pjthlem5.1 $e |- D e. ~H $.
    pjthlem5.2 $e |- C e. ~H $.
    pjthlem5.3 $e |- S e. CC $.
    $( Lemma for ~ pjthi . $)
    pjthlem5 $p |- ( ( normh ` ( C -h ( S .h D ) ) ) ^ 2 ) =
       ( ( ( ( normh ` C ) ^ 2 ) - ( * ` ( S x. ( D .ih C ) ) ) ) +
      ( ( ( S x. ( * ` S ) ) x. ( D .ih D ) ) - ( S x. ( D .ih C ) ) ) ) $=
      cC cS cD csm co cmv co cno cfv c2 cexp co cC cS cD csm co cmv co cC cS cD
      csm co cmv co csp co cC cC csp co cS ccj cfv cneg cC cD csp co cmul co
      caddc co cS cneg cD cC csp co cmul co cS cS ccj cfv cmul co cD cD csp co
      cmul co caddc co caddc co cC cno cfv c2 cexp co cS cD cC csp co cmul co
      ccj cfv cmin co cS cS ccj cfv cmul co cD cD csp co cmul co cS cD cC csp
      co cmul co cmin co caddc co cC cS cD csm co cmv co cC cS cD csm co
      pjthlem5.2 cS cD pjthlem5.3 pjthlem5.1 hvmulcli hvsubcli normsqi cS cC cD
      pjthlem5.3 pjthlem5.2 pjthlem5.1 normlem0 cC cC csp co cS ccj cfv cneg cC
      cD csp co cmul co caddc co cC cno cfv c2 cexp co cS cD cC csp co cmul co
      ccj cfv cmin co cS cneg cD cC csp co cmul co cS cS ccj cfv cmul co cD cD
      csp co cmul co caddc co cS cS ccj cfv cmul co cD cD csp co cmul co cS cD
      cC csp co cmul co cmin co caddc cC cno cfv c2 cexp co cS cD cC csp co
      cmul co ccj cfv cneg caddc co cC cC csp co cS ccj cfv cneg cC cD csp co
      cmul co caddc co cC cno cfv c2 cexp co cS cD cC csp co cmul co ccj cfv
      cmin co cC cno cfv c2 cexp co cC cC csp co cS cD cC csp co cmul co ccj
      cfv cneg cS ccj cfv cneg cC cD csp co cmul co caddc cC pjthlem5.2 normsqi
      cS cD cC csp co cmul co ccj cfv cneg cS ccj cfv cC cD csp co cmul co cneg
      cS ccj cfv cneg cC cD csp co cmul co cS cD cC csp co cmul co ccj cfv cS
      ccj cfv cC cD csp co cmul co cS cD cC csp co cmul co ccj cfv cS ccj cfv
      cD cC csp co ccj cfv cmul co cS ccj cfv cC cD csp co cmul co cS cD cC csp
      co pjthlem5.3 cD cC pjthlem5.1 pjthlem5.2 hicli cjmuli cC cD csp co cD cC
      csp co ccj cfv cS ccj cfv cmul cC cD pjthlem5.2 pjthlem5.1 his1i opreq2i
      eqtr4i negeqi cS ccj cfv cC cD csp co cS pjthlem5.3 cjcli cC cD
      pjthlem5.2 pjthlem5.1 hicli mulneg1i eqtr4i opreq12i cC cno cfv c2 cexp
      co cS cD cC csp co cmul co ccj cfv cC cno cfv c2 cexp co cC cno cfv cC
      pjthlem5.2 normcli resqcli recni cS cD cC csp co cmul co cS cD cC csp co
      pjthlem5.3 cD cC pjthlem5.1 pjthlem5.2 hicli mulcli cjcli negsubi eqtr3i
      cS cneg cD cC csp co cmul co cS cS ccj cfv cmul co cD cD csp co cmul co
      caddc co cS cD cC csp co cmul co cneg cS cS ccj cfv cmul co cD cD csp co
      cmul co caddc co cS cS ccj cfv cmul co cD cD csp co cmul co cS cD cC csp
      co cmul co cneg caddc co cS cS ccj cfv cmul co cD cD csp co cmul co cS cD
      cC csp co cmul co cmin co cS cneg cD cC csp co cmul co cS cD cC csp co
      cmul co cneg cS cS ccj cfv cmul co cD cD csp co cmul co caddc cS cD cC
      csp co pjthlem5.3 cD cC pjthlem5.1 pjthlem5.2 hicli mulneg1i opreq1i cS
      cD cC csp co cmul co cneg cS cS ccj cfv cmul co cD cD csp co cmul co cS
      cD cC csp co cmul co cS cD cC csp co pjthlem5.3 cD cC pjthlem5.1
      pjthlem5.2 hicli mulcli negcli cS cS ccj cfv cmul co cD cD csp co cS cS
      ccj cfv cmul co cS pjthlem5.3 cjmulrcli recni cD cD pjthlem5.1 pjthlem5.1
      hicli mulcli addcomi cS cS ccj cfv cmul co cD cD csp co cmul co cS cD cC
      csp co cmul co cS cS ccj cfv cmul co cD cD csp co cS cS ccj cfv cmul co
      cS pjthlem5.3 cjmulrcli recni cD cD pjthlem5.1 pjthlem5.1 hicli mulcli cS
      cD cC csp co pjthlem5.3 cD cC pjthlem5.1 pjthlem5.2 hicli mulcli negsubi
      3eqtri opreq12i 3eqtri $.
      $( [8-Oct-1999] $)
  $}

  ${
    pjthlem6.1 $e |- D e. ~H $.
    pjthlem6.2 $e |- R = ( 1 / ( D .ih D ) ) $.
    pjthlem6.3 $e |- C e. ~H $.
    pjthlem6.4 $e |- S = ( R x. ( C .ih D ) ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem6 $p |- ( D =/= 0h -> ( S x. ( D .ih C ) ) =
                 ( R x. ( ( abs ` ( C .ih D ) ) ^ 2 ) ) ) $=
      cD c0v wne cR cC cD csp co cmul co cD cC csp co cmul co cR cC cD csp co
      cD cC csp co cmul co cmul co cS cD cC csp co cmul co cR cC cD csp co cabs
      cfv c2 cexp co cmul co cD c0v wne cR cc wcel cR cC cD csp co cmul co cD
      cC csp co cmul co cR cC cD csp co cD cC csp co cmul co cmul co wceq cD
      c0v wne cR cD cR pjthlem6.1 pjthlem6.2 pjthlem2 recnd cR cc wcel cC cD
      csp co cc wcel cD cC csp co cc wcel cR cC cD csp co cmul co cD cC csp co
      cmul co cR cC cD csp co cD cC csp co cmul co cmul co wceq cC cD
      pjthlem6.3 pjthlem6.1 hicli cD cC pjthlem6.1 pjthlem6.3 hicli cR cC cD
      csp co cD cC csp co mulass mp3an23 syl cS cR cC cD csp co cmul co cD cC
      csp co cmul pjthlem6.4 opreq1i cC cD csp co cabs cfv c2 cexp co cC cD csp
      co cD cC csp co cmul co cR cmul cC cD csp co cabs cfv c2 cexp co cC cD
      csp co cC cD csp co ccj cfv cmul co cC cD csp co cD cC csp co cmul co cC
      cD csp co cC cD pjthlem6.3 pjthlem6.1 hicli absvalsqi cD cC csp co cC cD
      csp co ccj cfv cC cD csp co cmul cD cC pjthlem6.1 pjthlem6.3 his1i
      opreq2i eqtr4i opreq2i 3eqtr4g $.
      $( [5-Jul-2007] $) $( [8-Oct-1999] $)

    $( Lemma for ~ pjthi . $)
    pjthlem7 $p |- ( D =/= 0h -> ( ( S x. ( * ` S ) ) x. ( D .ih D ) ) =
                 ( R x. ( ( abs ` ( C .ih D ) ) ^ 2 ) ) ) $=
      cD c0v wne cS cS ccj cfv cmul co cD cD csp co cmul co cR cC cD csp co cC
      cD csp co ccj cfv cmul co cmul co cR cC cD csp co cabs cfv c2 cexp co
      cmul co cD c0v wne cS cS ccj cfv cmul co cD cD csp co cmul co cR cR cmul
      co cD cD csp co cmul co cC cD csp co cC cD csp co ccj cfv cmul co cmul co
      cR cC cD csp co cC cD csp co ccj cfv cmul co cmul co cD c0v wne cR cr
      wcel cS cS ccj cfv cmul co cD cD csp co cmul co cR cR cmul co cD cD csp
      co cmul co cC cD csp co cC cD csp co ccj cfv cmul co cmul co wceq cD cR
      pjthlem6.1 pjthlem6.2 pjthlem2 cR cr wcel cS cS ccj cfv cmul co cD cD csp
      co cmul co cR cR cmul co cC cD csp co cC cD csp co ccj cfv cmul co cmul
      co cD cD csp co cmul co cR cR cmul co cD cD csp co cmul co cC cD csp co
      cC cD csp co ccj cfv cmul co cmul co cR cr wcel cS cS ccj cfv cmul co cR
      cR cmul co cC cD csp co cC cD csp co ccj cfv cmul co cmul co cD cD csp co
      cmul cR cr wcel cS cS ccj cfv cmul co cR cC cD csp co cmul co cR cC cD
      csp co ccj cfv cmul co cmul co cR cR cmul co cC cD csp co cC cD csp co
      ccj cfv cmul co cmul co cR cr wcel cS cR cC cD csp co cmul co cS ccj cfv
      cR cC cD csp co ccj cfv cmul co cmul cS cR cC cD csp co cmul co wceq cR
      cr wcel pjthlem6.4 a1i cR cr wcel cR cC cD csp co cmul co ccj cfv cR cC
      cD csp co ccj cfv cmul co cS ccj cfv cR cr wcel cR cC cD csp co cmul co
      ccj cfv cR ccj cfv cC cD csp co ccj cfv cmul co cR cC cD csp co ccj cfv
      cmul co cR cr wcel cR cc wcel cR cC cD csp co cmul co ccj cfv cR ccj cfv
      cC cD csp co ccj cfv cmul co wceq cR recn cR cc wcel cC cD csp co cc wcel
      cR cC cD csp co cmul co ccj cfv cR ccj cfv cC cD csp co ccj cfv cmul co
      wceq cC cD pjthlem6.3 pjthlem6.1 hicli cR cC cD csp co cjmul mpan2 syl cR
      cr wcel cR ccj cfv cR cC cD csp co ccj cfv cmul cR cjre opreq1d eqtrd cS
      cR cC cD csp co cmul co ccj pjthlem6.4 fveq2i syl5eq opreq12d cR cc wcel
      cC cD csp co cc wcel wa cR cc wcel cC cD csp co ccj cfv cc wcel wa cR cC
      cD csp co cmul co cR cC cD csp co ccj cfv cmul co cmul co cR cR cmul co
      cC cD csp co cC cD csp co ccj cfv cmul co cmul co wceq cR cr wcel cR cC
      cD csp co cR cC cD csp co ccj cfv mul4 cR cr wcel cR cc wcel cC cD csp co
      cc wcel cR recn cC cD pjthlem6.3 pjthlem6.1 hicli jctir cR cr wcel cR cc
      wcel cC cD csp co ccj cfv cc wcel cR recn cC cD csp co cC cD pjthlem6.3
      pjthlem6.1 hicli cjcli jctir sylanc eqtrd opreq1d cR cr wcel cR cR cmul
      co cc wcel cR cR cmul co cC cD csp co cC cD csp co ccj cfv cmul co cmul
      co cD cD csp co cmul co cR cR cmul co cD cD csp co cmul co cC cD csp co
      cC cD csp co ccj cfv cmul co cmul co wceq cR cc wcel cR cc wcel cR cR
      cmul co cc wcel cR cr wcel cR cR mulcl cR recn cR recn sylanc cR cR cmul
      co cc wcel cC cD csp co cC cD csp co ccj cfv cmul co cc wcel cD cD csp co
      cc wcel cR cR cmul co cC cD csp co cC cD csp co ccj cfv cmul co cmul co
      cD cD csp co cmul co cR cR cmul co cD cD csp co cmul co cC cD csp co cC
      cD csp co ccj cfv cmul co cmul co wceq cC cD csp co cC cD csp co ccj cfv
      cC cD pjthlem6.3 pjthlem6.1 hicli cC cD csp co cC cD pjthlem6.3
      pjthlem6.1 hicli cjcli mulcli cD cD pjthlem6.1 pjthlem6.1 hicli cR cR
      cmul co cC cD csp co cC cD csp co ccj cfv cmul co cD cD csp co mul23
      mp3an23 syl eqtrd syl cD c0v wne cR cR cmul co cD cD csp co cmul co cR cC
      cD csp co cC cD csp co ccj cfv cmul co cmul cD c0v wne cR cR cmul co cD
      cD csp co cmul co cR cD cD csp co cmul co cR cmul co c1 cR cmul co cR cD
      c0v wne cR cr wcel cR cR cmul co cD cD csp co cmul co cR cD cD csp co
      cmul co cR cmul co wceq cD cR pjthlem6.1 pjthlem6.2 pjthlem2 cR cc wcel
      cR cc wcel cR cR cmul co cD cD csp co cmul co cR cD cD csp co cmul co cR
      cmul co wceq cR cr wcel cR cc wcel cR cc wcel cD cD csp co cc wcel cR cR
      cmul co cD cD csp co cmul co cR cD cD csp co cmul co cR cmul co wceq cD
      cD pjthlem6.1 pjthlem6.1 hicli cR cR cD cD csp co mul23 mp3an3 cR recn cR
      recn sylanc syl cD c0v wne cR cD cD csp co cmul co c1 cR cmul cD c0v wne
      c1 cD cD csp co cdiv co cD cD csp co cmul co c1 cR cD cD csp co cmul co
      cD c0v wne c1 cD cD csp co cdiv co cD cD csp co cmul co cD cD csp co c1
      cD cD csp co cdiv co cmul co c1 cD c0v wne cD cD csp co cc0 wne c1 cD cD
      csp co cdiv co cc wcel c1 cD cD csp co cdiv co cD cD csp co cmul co cD cD
      csp co c1 cD cD csp co cdiv co cmul co wceq cD c0v wne cc0 cD cD csp co
      clt wbr cD cD csp co cc0 wne cD chil wcel cD c0v wne cc0 cD cD csp co clt
      wbr pjthlem6.1 cD ax-his4 mpan cD cD csp co cD chil wcel cD cD csp co cr
      wcel pjthlem6.1 cD hiidrcl ax-mp gt0ne0i syl cD cD csp co cD cD
      pjthlem6.1 pjthlem6.1 hicli recclzi c1 cD cD csp co cdiv co cc wcel cD cD
      csp co cc wcel c1 cD cD csp co cdiv co cD cD csp co cmul co cD cD csp co
      c1 cD cD csp co cdiv co cmul co wceq cD cD pjthlem6.1 pjthlem6.1 hicli c1
      cD cD csp co cdiv co cD cD csp co mulcom mpan2 3syl cD c0v wne cc0 cD cD
      csp co clt wbr cD cD csp co cc0 wne cD cD csp co c1 cD cD csp co cdiv co
      cmul co c1 wceq cD chil wcel cD c0v wne cc0 cD cD csp co clt wbr
      pjthlem6.1 cD ax-his4 mpan cD cD csp co cD chil wcel cD cD csp co cr wcel
      pjthlem6.1 cD hiidrcl ax-mp gt0ne0i cD cD csp co cD cD pjthlem6.1
      pjthlem6.1 hicli recidzi 3syl eqtrd cR c1 cD cD csp co cdiv co cD cD csp
      co cmul pjthlem6.2 opreq1i syl5eq opreq1d cD c0v wne cR cr wcel cR cc
      wcel c1 cR cmul co cR wceq cD cR pjthlem6.1 pjthlem6.2 pjthlem2 cR recn
      cR mulid2 3syl 3eqtrd opreq1d eqtrd cC cD csp co cabs cfv c2 cexp co cC
      cD csp co cC cD csp co ccj cfv cmul co cR cmul cC cD csp co cC cD
      pjthlem6.3 pjthlem6.1 hicli absvalsqi opreq2i syl6eqr $.
      $( [5-Jul-2007] $) $( [8-Oct-1999] $)

    $( Lemma for ~ pjthi . $)
    pjthlem8 $p |- ( D =/= 0h -> ( ( normh ` ( C -h ( S .h D ) ) ) ^ 2 ) =
    ( ( ( normh ` C ) ^ 2 ) - ( R x. ( ( abs ` ( C .ih D ) ) ^ 2 ) ) ) ) $=
      cD c0v wne cC cS cD csm co cmv co cno cfv c2 cexp co cC cno cfv c2 cexp
      co cS cD cC csp co cmul co ccj cfv cmin co cS cS ccj cfv cmul co cD cD
      csp co cmul co cS cD cC csp co cmul co cmin co caddc co cC cno cfv c2
      cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co cc0 caddc co
      cC cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co
      cD c0v wne cS cc wcel cC cS cD csm co cmv co cno cfv c2 cexp co cC cno
      cfv c2 cexp co cS cD cC csp co cmul co ccj cfv cmin co cS cS ccj cfv cmul
      co cD cD csp co cmul co cS cD cC csp co cmul co cmin co caddc co wceq cC
      cD cR cS pjthlem6.1 pjthlem6.2 pjthlem6.3 pjthlem6.4 pjthlem4 cS cc wcel
      cC cS cD csm co cmv co cno cfv c2 cexp co cC cno cfv c2 cexp co cS cD cC
      csp co cmul co ccj cfv cmin co cS cS ccj cfv cmul co cD cD csp co cmul co
      cS cD cC csp co cmul co cmin co caddc co wceq cC cS cc wcel cS cc0 cif cD
      csm co cmv co cno cfv c2 cexp co cC cno cfv c2 cexp co cS cc wcel cS cc0
      cif cD cC csp co cmul co ccj cfv cmin co cS cc wcel cS cc0 cif cS cc wcel
      cS cc0 cif ccj cfv cmul co cD cD csp co cmul co cS cc wcel cS cc0 cif cD
      cC csp co cmul co cmin co caddc co wceq cS cc0 cS cS cc wcel cS cc0 cif
      wceq cC cS cD csm co cmv co cno cfv c2 cexp co cC cS cc wcel cS cc0 cif
      cD csm co cmv co cno cfv c2 cexp co cC cno cfv c2 cexp co cS cD cC csp co
      cmul co ccj cfv cmin co cS cS ccj cfv cmul co cD cD csp co cmul co cS cD
      cC csp co cmul co cmin co caddc co cC cno cfv c2 cexp co cS cc wcel cS
      cc0 cif cD cC csp co cmul co ccj cfv cmin co cS cc wcel cS cc0 cif cS cc
      wcel cS cc0 cif ccj cfv cmul co cD cD csp co cmul co cS cc wcel cS cc0
      cif cD cC csp co cmul co cmin co caddc co cS cS cc wcel cS cc0 cif wceq
      cC cS cD csm co cmv co cno cfv cC cS cc wcel cS cc0 cif cD csm co cmv co
      cno cfv c2 cexp cS cS cc wcel cS cc0 cif wceq cC cS cD csm co cmv co cC
      cS cc wcel cS cc0 cif cD csm co cmv co cno cS cS cc wcel cS cc0 cif wceq
      cS cD csm co cS cc wcel cS cc0 cif cD csm co cC cmv cS cS cc wcel cS cc0
      cif cD csm opreq1 opreq2d fveq2d opreq1d cS cS cc wcel cS cc0 cif wceq cC
      cno cfv c2 cexp co cS cD cC csp co cmul co ccj cfv cmin co cC cno cfv c2
      cexp co cS cc wcel cS cc0 cif cD cC csp co cmul co ccj cfv cmin co cS cS
      ccj cfv cmul co cD cD csp co cmul co cS cD cC csp co cmul co cmin co cS
      cc wcel cS cc0 cif cS cc wcel cS cc0 cif ccj cfv cmul co cD cD csp co
      cmul co cS cc wcel cS cc0 cif cD cC csp co cmul co cmin co caddc cS cS cc
      wcel cS cc0 cif wceq cS cD cC csp co cmul co ccj cfv cS cc wcel cS cc0
      cif cD cC csp co cmul co ccj cfv cC cno cfv c2 cexp co cmin cS cS cc wcel
      cS cc0 cif wceq cS cD cC csp co cmul co cS cc wcel cS cc0 cif cD cC csp
      co cmul co ccj cS cS cc wcel cS cc0 cif cD cC csp co cmul opreq1 fveq2d
      opreq2d cS cS cc wcel cS cc0 cif wceq cS cS ccj cfv cmul co cD cD csp co
      cmul co cS cc wcel cS cc0 cif cS cc wcel cS cc0 cif ccj cfv cmul co cD cD
      csp co cmul co cS cD cC csp co cmul co cS cc wcel cS cc0 cif cD cC csp co
      cmul co cmin cS cS cc wcel cS cc0 cif wceq cS cS ccj cfv cmul co cS cc
      wcel cS cc0 cif cS cc wcel cS cc0 cif ccj cfv cmul co cD cD csp co cmul
      cS cS cc wcel cS cc0 cif wceq cS cS cc wcel cS cc0 cif cS ccj cfv cS cc
      wcel cS cc0 cif ccj cfv cmul cS cS cc wcel cS cc0 cif wceq id cS cS cc
      wcel cS cc0 cif ccj fveq2 opreq12d opreq1d cS cS cc wcel cS cc0 cif cD cC
      csp co cmul opreq1 opreq12d opreq12d eqeq12d cC cD cS cc wcel cS cc0 cif
      pjthlem6.1 pjthlem6.3 cS cc0 cc 0cn elimel pjthlem5 dedth syl cD c0v wne
      cC cno cfv c2 cexp co cS cD cC csp co cmul co ccj cfv cmin co cC cno cfv
      c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co cS cS ccj
      cfv cmul co cD cD csp co cmul co cS cD cC csp co cmul co cmin co cc0
      caddc cD c0v wne cS cD cC csp co cmul co ccj cfv cR cC cD csp co cabs cfv
      c2 cexp co cmul co cC cno cfv c2 cexp co cmin cD c0v wne cS cD cC csp co
      cmul co ccj cfv cR cC cD csp co cabs cfv c2 cexp co cmul co ccj cfv cR cC
      cD csp co cabs cfv c2 cexp co cmul co cD c0v wne cS cD cC csp co cmul co
      cR cC cD csp co cabs cfv c2 cexp co cmul co ccj cC cD cR cS pjthlem6.1
      pjthlem6.2 pjthlem6.3 pjthlem6.4 pjthlem6 fveq2d cD c0v wne cR cr wcel cR
      cC cD csp co cabs cfv c2 cexp co cmul co cr wcel cR cC cD csp co cabs cfv
      c2 cexp co cmul co ccj cfv cR cC cD csp co cabs cfv c2 cexp co cmul co
      wceq cD cR pjthlem6.1 pjthlem6.2 pjthlem2 cR cr wcel cC cD csp co cabs
      cfv c2 cexp co cr wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cr
      wcel cC cD csp co cabs cfv cC cD csp co cC cD pjthlem6.3 pjthlem6.1 hicli
      abscli resqcli cR cC cD csp co cabs cfv c2 cexp co remulcl mpan2 cR cC cD
      csp co cabs cfv c2 cexp co cmul co cjre 3syl eqtrd opreq2d cD c0v wne cS
      cS ccj cfv cmul co cD cD csp co cmul co cS cD cC csp co cmul co cmin co
      cR cC cD csp co cabs cfv c2 cexp co cmul co cR cC cD csp co cabs cfv c2
      cexp co cmul co cmin co cc0 cD c0v wne cS cS ccj cfv cmul co cD cD csp co
      cmul co cR cC cD csp co cabs cfv c2 cexp co cmul co cS cD cC csp co cmul
      co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin cC cD cR cS
      pjthlem6.1 pjthlem6.2 pjthlem6.3 pjthlem6.4 pjthlem7 cC cD cR cS
      pjthlem6.1 pjthlem6.2 pjthlem6.3 pjthlem6.4 pjthlem6 opreq12d cD c0v wne
      cR cC cD csp co cabs cfv c2 cexp co cmul co cc wcel cR cC cD csp co cabs
      cfv c2 cexp co cmul co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin
      co cc0 wceq cD c0v wne cR cC cD csp co cabs cfv c2 cexp co cmul co cD c0v
      wne cR cr wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cr wcel cD cR
      pjthlem6.1 pjthlem6.2 pjthlem2 cR cr wcel cC cD csp co cabs cfv c2 cexp
      co cr wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cr wcel cC cD csp
      co cabs cfv cC cD csp co cC cD pjthlem6.3 pjthlem6.1 hicli abscli resqcli
      cR cC cD csp co cabs cfv c2 cexp co remulcl mpan2 syl recnd cR cC cD csp
      co cabs cfv c2 cexp co cmul co subid syl eqtrd opreq12d cD c0v wne cR cC
      cD csp co cabs cfv c2 cexp co cmul co cc wcel cC cno cfv c2 cexp co cR cC
      cD csp co cabs cfv c2 cexp co cmul co cmin co cc wcel cC cno cfv c2 cexp
      co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co cc0 caddc co cC
      cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co
      wceq cD c0v wne cR cC cD csp co cabs cfv c2 cexp co cmul co cD c0v wne cR
      cr wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cr wcel cD cR
      pjthlem6.1 pjthlem6.2 pjthlem2 cR cr wcel cC cD csp co cabs cfv c2 cexp
      co cr wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cr wcel cC cD csp
      co cabs cfv cC cD csp co cC cD pjthlem6.3 pjthlem6.1 hicli abscli resqcli
      cR cC cD csp co cabs cfv c2 cexp co remulcl mpan2 syl recnd cC cno cfv c2
      cexp co cc wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cc wcel cC
      cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co cc
      wcel cC cno cfv c2 cexp co cC cno cfv cC pjthlem6.3 normcli resqcli recni
      cC cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co subcl
      mpan cC cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co
      cmin co addid1 3syl 3eqtrd $.
      $( [5-Jul-2007] $) $( [8-Oct-1999] $)
  $}

  ${
    pjthlem9.1 $e |- A e. ~H $.
    pjthlem9.2 $e |- B e. ~H $.
    pjthlem9.3 $e |- D e. ~H $.
    pjthlem9.4 $e |- R = ( 1 / ( D .ih D ) ) $.
    pjthlem9.5 $e |- S = ( R x. ( C .ih D ) ) $.
    pjthlem9.6 $e |- C = ( A -h B ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem9 $p |- ( D =/= 0h -> ( ( normh ` ( B -h A ) ) <_
                ( normh ` ( ( B +h ( S .h D ) ) -h A ) ) <->
     ( ( normh ` C ) ^ 2 ) <_ ( ( normh ` ( C -h ( S .h D ) ) ) ^ 2 ) ) ) $=
      cD c0v wne cS cc wcel cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv
      co cno cfv cle wbr cC cno cfv c2 cexp co cC cS cD csm co cmv co cno cfv
      c2 cexp co cle wbr wb cC cD cR cS pjthlem9.3 pjthlem9.4 cC cA cB cmv co
      chil pjthlem9.6 cA cB pjthlem9.1 pjthlem9.2 hvsubcli eqeltri pjthlem9.5
      pjthlem4 cS cc wcel cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co
      cno cfv cle wbr cC cno cfv c2 cexp co cC cS cD csm co cmv co cno cfv c2
      cexp co cle wbr wb cB cA cmv co cno cfv cB cS cc wcel cS cc0 cif cD csm
      co cva co cA cmv co cno cfv cle wbr cC cno cfv c2 cexp co cC cS cc wcel
      cS cc0 cif cD csm co cmv co cno cfv c2 cexp co cle wbr wb cS cc0 cS cS cc
      wcel cS cc0 cif wceq cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv
      co cno cfv cle wbr cB cA cmv co cno cfv cB cS cc wcel cS cc0 cif cD csm
      co cva co cA cmv co cno cfv cle wbr cC cno cfv c2 cexp co cC cS cD csm co
      cmv co cno cfv c2 cexp co cle wbr cC cno cfv c2 cexp co cC cS cc wcel cS
      cc0 cif cD csm co cmv co cno cfv c2 cexp co cle wbr cS cS cc wcel cS cc0
      cif wceq cB cS cD csm co cva co cA cmv co cno cfv cB cS cc wcel cS cc0
      cif cD csm co cva co cA cmv co cno cfv cB cA cmv co cno cfv cle cS cS cc
      wcel cS cc0 cif wceq cB cS cD csm co cva co cA cmv co cB cS cc wcel cS
      cc0 cif cD csm co cva co cA cmv co cno cS cS cc wcel cS cc0 cif wceq cB
      cS cD csm co cva co cB cS cc wcel cS cc0 cif cD csm co cva co cA cmv cS
      cS cc wcel cS cc0 cif wceq cS cD csm co cS cc wcel cS cc0 cif cD csm co
      cB cva cS cS cc wcel cS cc0 cif cD csm opreq1 opreq2d opreq1d fveq2d
      breq2d cS cS cc wcel cS cc0 cif wceq cC cS cD csm co cmv co cno cfv c2
      cexp co cC cS cc wcel cS cc0 cif cD csm co cmv co cno cfv c2 cexp co cC
      cno cfv c2 cexp co cle cS cS cc wcel cS cc0 cif wceq cC cS cD csm co cmv
      co cno cfv cC cS cc wcel cS cc0 cif cD csm co cmv co cno cfv c2 cexp cS
      cS cc wcel cS cc0 cif wceq cC cS cD csm co cmv co cC cS cc wcel cS cc0
      cif cD csm co cmv co cno cS cS cc wcel cS cc0 cif wceq cS cD csm co cS cc
      wcel cS cc0 cif cD csm co cC cmv cS cS cc wcel cS cc0 cif cD csm opreq1
      opreq2d fveq2d opreq1d breq2d bibi12d cA cB cC cD cS cc wcel cS cc0 cif
      pjthlem9.1 pjthlem9.2 pjthlem9.3 cS cc0 cc 0cn elimel pjthlem9.6 pjthlem1
      dedth syl $.
      $( [5-Jul-2007] $) $( [8-Oct-1999] $)

    $( Lemma for ~ pjthi . $)
    pjthlem10 $p |- ( ( D =/= 0h /\ ( normh ` ( B -h A ) ) <_
           ( normh ` ( ( B +h ( S .h D ) ) -h A ) ) ) ->
                   ( R x. ( ( abs ` ( C .ih D ) ) ^ 2 ) ) = 0 ) $=
      cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno cfv
      cle wbr wa cc0 cR cC cD csp co cabs cfv c2 cexp co cmul co cle wbr cC cno
      cfv c2 cexp co cC cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co
      cmul co cmin co cle wbr wa cR cC cD csp co cabs cfv c2 cexp co cmul co
      cc0 wceq cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co
      cno cfv cle wbr wa cc0 cR cC cD csp co cabs cfv c2 cexp co cmul co cle
      wbr cC cno cfv c2 cexp co cC cno cfv c2 cexp co cR cC cD csp co cabs cfv
      c2 cexp co cmul co cmin co cle wbr cD c0v wne cc0 cR cC cD csp co cabs
      cfv c2 cexp co cmul co cle wbr cB cA cmv co cno cfv cB cS cD csm co cva
      co cA cmv co cno cfv cle wbr cR cr wcel cC cD csp co cabs cfv c2 cexp co
      cr wcel wa cc0 cR cle wbr cc0 cC cD csp co cabs cfv c2 cexp co cle wbr wa
      cc0 cR cC cD csp co cabs cfv c2 cexp co cmul co cle wbr cD c0v wne cR cC
      cD csp co cabs cfv c2 cexp co mulge0OLD cD c0v wne cR cr wcel cC cD csp
      co cabs cfv c2 cexp co cr wcel cD cR pjthlem9.3 pjthlem9.4 pjthlem2 cC cD
      csp co cabs cfv cC cD csp co cC cD cC cA cB cmv co chil pjthlem9.6 cA cB
      pjthlem9.1 pjthlem9.2 hvsubcli eqeltri pjthlem9.3 hicli abscli resqcli
      jctir cD c0v wne cc0 cR cle wbr cc0 cC cD csp co cabs cfv c2 cexp co cle
      wbr cc0 cr wcel cR cr wcel wa cc0 cR clt wbr cc0 cR cle wbr cD c0v wne
      cc0 cR ltle cD c0v wne cR cr wcel cc0 cr wcel cD cR pjthlem9.3 pjthlem9.4
      pjthlem2 0re jctil cD cR pjthlem9.3 pjthlem9.4 pjthlem3 sylc cC cD csp co
      cabs cfv cC cD csp co cC cD cC cA cB cmv co chil pjthlem9.6 cA cB
      pjthlem9.1 pjthlem9.2 hvsubcli eqeltri pjthlem9.3 hicli abscli sqge0i
      jctir sylanc adantr cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva
      co cA cmv co cno cfv cle wbr wa cC cno cfv c2 cexp co cC cS cD csm co cmv
      co cno cfv c2 cexp co cC cno cfv c2 cexp co cR cC cD csp co cabs cfv c2
      cexp co cmul co cmin co cle cD c0v wne cB cA cmv co cno cfv cB cS cD csm
      co cva co cA cmv co cno cfv cle wbr cC cno cfv c2 cexp co cC cS cD csm co
      cmv co cno cfv c2 cexp co cle wbr cA cB cC cD cR cS pjthlem9.1 pjthlem9.2
      pjthlem9.3 pjthlem9.4 pjthlem9.5 pjthlem9.6 pjthlem9 biimpa cD c0v wne cC
      cS cD csm co cmv co cno cfv c2 cexp co cC cno cfv c2 cexp co cR cC cD csp
      co cabs cfv c2 cexp co cmul co cmin co wceq cB cA cmv co cno cfv cB cS cD
      csm co cva co cA cmv co cno cfv cle wbr cC cD cR cS pjthlem9.3 pjthlem9.4
      cC cA cB cmv co chil pjthlem9.6 cA cB pjthlem9.1 pjthlem9.2 hvsubcli
      eqeltri pjthlem9.5 pjthlem8 adantr breqtrd jca cD c0v wne cc0 cR cC cD
      csp co cabs cfv c2 cexp co cmul co cle wbr cC cno cfv c2 cexp co cC cno
      cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co cmul co cmin co cle
      wbr wa cR cC cD csp co cabs cfv c2 cexp co cmul co cc0 wceq wb cB cA cmv
      co cno cfv cB cS cD csm co cva co cA cmv co cno cfv cle wbr cD c0v wne cR
      cC cD csp co cabs cfv c2 cexp co cmul co cr wcel cC cno cfv c2 cexp co cr
      wcel wa cc0 cR cC cD csp co cabs cfv c2 cexp co cmul co cle wbr cC cno
      cfv c2 cexp co cC cno cfv c2 cexp co cR cC cD csp co cabs cfv c2 cexp co
      cmul co cmin co cle wbr wa cR cC cD csp co cabs cfv c2 cexp co cmul co
      cc0 wceq wb cD c0v wne cR cC cD csp co cabs cfv c2 cexp co cmul co cr
      wcel cC cno cfv c2 cexp co cr wcel cD c0v wne cR cr wcel cC cD csp co
      cabs cfv c2 cexp co cr wcel wa cR cC cD csp co cabs cfv c2 cexp co cmul
      co cr wcel cD c0v wne cR cr wcel cC cD csp co cabs cfv c2 cexp co cr wcel
      cD cR pjthlem9.3 pjthlem9.4 pjthlem2 cC cD csp co cabs cfv cC cD csp co
      cC cD cC cA cB cmv co chil pjthlem9.6 cA cB pjthlem9.1 pjthlem9.2
      hvsubcli eqeltri pjthlem9.3 hicli abscli resqcli jctir cR cC cD csp co
      cabs cfv c2 cexp co remulcl syl cC cno cfv cC cC cA cB cmv co chil
      pjthlem9.6 cA cB pjthlem9.1 pjthlem9.2 hvsubcli eqeltri normcli resqcli
      jctir cR cC cD csp co cabs cfv c2 cexp co cmul co cC cno cfv c2 cexp co
      lesub0 syl adantr mpbid $.
      $( [5-Jul-2007] $) $( [9-Oct-1999] $)

    $( Lemma for ~ pjthi . $)
    pjthlem11 $p |- ( ( D =/= 0h /\ ( normh ` ( B -h A ) ) <_
           ( normh ` ( ( B +h ( S .h D ) ) -h A ) ) ) -> ( C .ih D ) = 0 ) $=
      cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno cfv
      cle wbr wa cC cD csp co cabs cfv cc0 wceq cC cD csp co cc0 wceq cD c0v
      wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno cfv cle wbr
      wa cC cD csp co cabs cfv c2 cexp co cc0 wceq cC cD csp co cabs cfv cc0
      wceq cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno
      cfv cle wbr wa cR cc0 wceq wn cC cD csp co cabs cfv c2 cexp co cc0 wceq
      cD c0v wne cR cc0 wceq wn cB cA cmv co cno cfv cB cS cD csm co cva co cA
      cmv co cno cfv cle wbr cD c0v wne cc0 cR clt wbr cR cc0 wceq wn cD cR
      pjthlem9.3 pjthlem9.4 pjthlem3 cD c0v wne cR cc0 wceq wn cR cc0 clt wbr
      cc0 cR clt wbr wo cc0 cR clt wbr cD c0v wne cR cr wcel cc0 cr wcel wa cR
      cc0 wceq wn cR cc0 clt wbr cc0 cR clt wbr wo wb cD c0v wne cR cr wcel cc0
      cr wcel cD cR pjthlem9.3 pjthlem9.4 pjthlem2 0re jctir cR cr wcel cc0 cr
      wcel wa cR cc0 wne cR cc0 clt wbr cc0 cR clt wbr wo cR cc0 wceq wn cR cc0
      lttri2 cR cc0 df-ne syl5bbr syl cc0 cR clt wbr cR cc0 clt wbr olc syl5bir
      mpd adantr cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv
      co cno cfv cle wbr wa cR cc0 wceq cC cD csp co cabs cfv c2 cexp co cc0
      wceq cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno
      cfv cle wbr wa cR cC cD csp co cabs cfv c2 cexp co cmul co cc0 wceq cR
      cc0 wceq cC cD csp co cabs cfv c2 cexp co cc0 wceq wo cA cB cC cD cR cS
      pjthlem9.1 pjthlem9.2 pjthlem9.3 pjthlem9.4 pjthlem9.5 pjthlem9.6
      pjthlem10 cD c0v wne cR cC cD csp co cabs cfv c2 cexp co cmul co cc0 wceq
      cR cc0 wceq cC cD csp co cabs cfv c2 cexp co cc0 wceq wo wb cB cA cmv co
      cno cfv cB cS cD csm co cva co cA cmv co cno cfv cle wbr cD c0v wne cR cc
      wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cc0 wceq cR cc0 wceq cC
      cD csp co cabs cfv c2 cexp co cc0 wceq wo wb cD c0v wne cR cD cR
      pjthlem9.3 pjthlem9.4 pjthlem2 recnd cR cc wcel cC cD csp co cabs cfv c2
      cexp co cc wcel cR cC cD csp co cabs cfv c2 cexp co cmul co cc0 wceq cR
      cc0 wceq cC cD csp co cabs cfv c2 cexp co cc0 wceq wo wb cC cD csp co
      cabs cfv c2 cexp co cC cD csp co cabs cfv cC cD csp co cC cD cC cA cB cmv
      co chil pjthlem9.6 cA cB pjthlem9.1 pjthlem9.2 hvsubcli eqeltri
      pjthlem9.3 hicli abscli resqcli recni cR cC cD csp co cabs cfv c2 cexp co
      mul0or mpan2 syl adantr mpbid ord mpd cC cD csp co cabs cfv cC cD csp co
      cabs cfv cC cD csp co cC cD cC cA cB cmv co chil pjthlem9.6 cA cB
      pjthlem9.1 pjthlem9.2 hvsubcli eqeltri pjthlem9.3 hicli abscli recni
      sqeq0i sylib cC cD csp co cC cD cC cA cB cmv co chil pjthlem9.6 cA cB
      pjthlem9.1 pjthlem9.2 hvsubcli eqeltri pjthlem9.3 hicli abs00i sylib $.
      $( [5-Jul-2007] $) $( [9-Oct-1999] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y D $.  $d y S $.  $d y H $.
    pjthlem12.1 $e |- A e. ~H $.
    pjthlem12.2 $e |- H e. CH $.
    pjthlem12.3 $e |- B e. H $.
    pjthlem12.4 $e |- D e. H $.
    pjthlem12.5 $e |- R = ( 1 / ( D .ih D ) ) $.
    pjthlem12.6 $e |- S = ( R x. ( C .ih D ) ) $.
    pjthlem12.7 $e |- C = ( A -h B ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem12 $p |- ( A. y e. H
             ( normh ` ( B -h A ) ) <_ ( normh ` ( y -h A ) ) -> ( D =/= 0h ->
              ( C .ih D ) = 0 ) ) $=
      cB cA cmv co cno cfv vy cv cA cmv co cno cfv cle wbr vy cH wral cD c0v
      wne cD c0v wne cB cA cmv co cno cfv cB cS cD csm co cva co cA cmv co cno
      cfv cle wbr wa cC cD csp co cc0 wceq cB cA cmv co cno cfv vy cv cA cmv co
      cno cfv cle wbr vy cH wral cD c0v wne cB cA cmv co cno cfv cB cS cD csm
      co cva co cA cmv co cno cfv cle wbr cB cA cmv co cno cfv vy cv cA cmv co
      cno cfv cle wbr vy cH wral cB cS cD csm co cva co cH wcel cB cA cmv co
      cno cfv cB cS cD csm co cva co cA cmv co cno cfv cle wbr cD c0v wne cB cA
      cmv co cno cfv vy cv cA cmv co cno cfv cle wbr cB cA cmv co cno cfv cB cS
      cD csm co cva co cA cmv co cno cfv cle wbr vy cB cS cD csm co cva co cH
      vy cv cB cS cD csm co cva co wceq vy cv cA cmv co cno cfv cB cS cD csm co
      cva co cA cmv co cno cfv cB cA cmv co cno cfv cle vy cv cB cS cD csm co
      cva co wceq vy cv cA cmv co cB cS cD csm co cva co cA cmv co cno vy cv cB
      cS cD csm co cva co cA cmv opreq1 fveq2d breq2d rcla4cv cD c0v wne cB cH
      wcel cS cD csm co cH wcel wa cB cS cD csm co cva co cH wcel cD c0v wne cS
      cD csm co cH wcel cB cH wcel cD c0v wne cS cc wcel cD cH wcel wa cS cD
      csm co cH wcel cD c0v wne cS cc wcel cD cH wcel cC cD cR cS cD cH
      pjthlem12.2 pjthlem12.4 chelii pjthlem12.5 cC cA cB cmv co chil
      pjthlem12.7 cA cB pjthlem12.1 cB cH pjthlem12.2 pjthlem12.3 chelii
      hvsubcli eqeltri pjthlem12.6 pjthlem4 pjthlem12.4 jctir cH csh wcel cS cc
      wcel cD cH wcel wa cS cD csm co cH wcel wi cH pjthlem12.2 chshii cS cD cH
      shmulclOLD ax-mp syl pjthlem12.3 jctil cH csh wcel cB cH wcel cS cD csm
      co cH wcel wa cB cS cD csm co cva co cH wcel wi cH pjthlem12.2 chshii cB
      cS cD csm co cH shaddclOLD ax-mp syl syl5 ancld cA cB cC cD cR cS
      pjthlem12.1 cB cH pjthlem12.2 pjthlem12.3 chelii cD cH pjthlem12.2
      pjthlem12.4 chelii pjthlem12.5 pjthlem12.6 pjthlem12.7 pjthlem11 syl6 $.
      $( [5-Jul-2007] $) $( [9-Oct-1999] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y D $.  $d y C $.  $d y H $.
    pjthlem13.1 $e |- A e. ~H $.
    pjthlem13.2 $e |- H e. CH $.
    pjthlem13.3 $e |- B e. H $.
    pjthlem13.4 $e |- D e. H $.
    pjthlem13.5 $e |- C = ( A -h B ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem13 $p |- ( A. y e. H
     ( normh ` ( B -h A ) ) <_ ( normh ` ( y -h A ) ) -> ( C .ih D ) = 0 ) $=
      cB cA cmv co cno cfv vy cv cA cmv co cno cfv cle wbr vy cH wral cC cD csp
      co cc0 wceq cC c0v csp co cc0 wceq cD c0v cD c0v wceq cC cD csp co cC c0v
      csp co cc0 cD c0v cC csp opreq2 eqeq1d cB cA cmv co cno cfv vy cv cA cmv
      co cno cfv cle wbr vy cH wral cD c0v wne cC cD csp co cc0 wceq vy cA cB
      cC cD c1 cD cD csp co cdiv co c1 cD cD csp co cdiv co cC cD csp co cmul
      co cH pjthlem13.1 pjthlem13.2 pjthlem13.3 pjthlem13.4 c1 cD cD csp co
      cdiv co eqid c1 cD cD csp co cdiv co cC cD csp co cmul co eqid
      pjthlem13.5 pjthlem12 imp cC c0v csp co cc0 wceq cB cA cmv co cno cfv vy
      cv cA cmv co cno cfv cle wbr vy cH wral cC c0v csp co c0v cC csp co ccj
      cfv cc0 ccj cfv cc0 cC c0v cC cA cB cmv co chil pjthlem13.5 cA cB
      pjthlem13.1 cB cH pjthlem13.2 pjthlem13.3 chelii hvsubcli eqeltri
      ax-hv0cl his1i c0v cC csp co cc0 ccj cC chil wcel c0v cC csp co cc0 wceq
      cC cA cB cmv co chil pjthlem13.5 cA cB pjthlem13.1 cB cH pjthlem13.2
      pjthlem13.3 chelii hvsubcli eqeltri cC hi01 ax-mp fveq2i cj0 3eqtri a1i
      pm2.61ne $.
      $( [9-Oct-1999] $)
  $}

  ${
    $d z x y A $.  $d z x y B $.  $d z x y C $.  $d z x y H $.
    pjthlem14.1 $e |- A e. ~H $.
    pjthlem14.2 $e |- H e. CH $.
    pjthlem14.3 $e |- B e. H $.
    pjthlem14.4 $e |- C = ( A -h B ) $.
    $( Lemma for ~ pjthi . $)
    pjthlem14 $p |- ( A. z e. H
                    ( normh ` ( B -h A ) ) <_ ( normh ` ( z -h A ) ) ->
                    E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      cB cA cmv co cno cfv vz cv cA cmv co cno cfv cle wbr vz cH wral cC cH
      cort cfv wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wrex
      cB cA cmv co cno cfv vz cv cA cmv co cno cfv cle wbr vz cH wral cC vx cv
      csp co cc0 wceq vx cH wral cC cH cort cfv wcel cB cA cmv co cno cfv vz cv
      cA cmv co cno cfv cle wbr vz cH wral cC vx cv csp co cc0 wceq vx cH vx cv
      cH wcel cB cA cmv co cno cfv vz cv cA cmv co cno cfv cle wbr vz cH wral
      cC vx cv csp co cc0 wceq vx cv cH wcel cB cA cmv co cno cfv vz cv cA cmv
      co cno cfv cle wbr vz cH wral cC vx cv csp co cc0 wceq wi cB cA cmv co
      cno cfv vz cv cA cmv co cno cfv cle wbr vz cH wral cC vx cv cH wcel vx cv
      c0v cif csp co cc0 wceq wi vx cv c0v vx cv vx cv cH wcel vx cv c0v cif
      wceq cC vx cv csp co cc0 wceq cC vx cv cH wcel vx cv c0v cif csp co cc0
      wceq cB cA cmv co cno cfv vz cv cA cmv co cno cfv cle wbr vz cH wral vx
      cv vx cv cH wcel vx cv c0v cif wceq cC vx cv csp co cC vx cv cH wcel vx
      cv c0v cif csp co cc0 vx cv vx cv cH wcel vx cv c0v cif cC csp opreq2
      eqeq1d imbi2d vz cA cB cC vx cv cH wcel vx cv c0v cif cH pjthlem14.1
      pjthlem14.2 pjthlem14.3 vx cv c0v cH cH cch wcel c0v cH wcel pjthlem14.2
      cH ch0 ax-mp elimel pjthlem14.4 pjthlem13 dedth com12 r19.21aiv cC cH
      cort cfv wcel cC chil wcel cC vx cv csp co cc0 wceq vx cH wral cH csh
      wcel cC cH cort cfv wcel cC chil wcel cC vx cv csp co cc0 wceq vx cH wral
      wa wb cH pjthlem14.2 chshii vx cC cH shocel ax-mp cC cA cB cmv co chil
      pjthlem14.4 cA cB pjthlem14.1 cB cH pjthlem14.2 pjthlem14.3 chelii
      hvsubcli eqeltri mpbiran sylibr cB cH wcel cC cH cort cfv wcel cA cB cC
      cva co wceq cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wrex
      pjthlem14.3 cB cA cB cmv co cva co cB cA c1 cneg cB csm co cva co cva co
      cB cC cva co cA cA cB cmv co cA c1 cneg cB csm co cva co cB cva cA cB
      pjthlem14.1 cB cH pjthlem14.2 pjthlem14.3 chelii hvsubvali opreq2i cC cA
      cB cmv co cB cva pjthlem14.4 opreq2i cA cB c1 cneg cB csm co cva co cva
      co cA c0v cva co cB cA c1 cneg cB csm co cva co cva co cA cB c1 cneg cB
      csm co cva co c0v cA cva cB cB cH pjthlem14.2 pjthlem14.3 chelii hvnegidi
      opreq2i cA cB c1 cneg cB csm co pjthlem14.1 cB cH pjthlem14.2 pjthlem14.3
      chelii c1 cneg cB c1 ax1cn negcli cB cH pjthlem14.2 pjthlem14.3 chelii
      hvmulcli hvadd12i cA chil wcel cA c0v cva co cA wceq pjthlem14.1 cA
      ax-hvaddid ax-mp 3eqtr3ri 3eqtr4ri vx vy cH cH cort cfv cB cC cA cva
      rcla4eopr mp3an13 syl $.
      $( [10-Oct-1999] $)
  $}

  ${
    $d z w x y A $.  $d z w x y H $.
    pjth.1 $e |- A e. ~H $.
    pjth.2 $e |- H e. CH $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       into a member ` x ` of a closed subspace ` H ` and a member ` y` of the
       complement of the subspace.  Theorem 3.7(i) of [Beran] p. 102 (existence
       part). $)
    pjthi $p |- E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) $=
      vz cv cA cmv co cno cfv vw cv cA cmv co cno cfv cle wbr vw cH wral vz cH
      wrex cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wrex vz vw cA
      cH pjth.1 pjth.2 projlem vz cv cA cmv co cno cfv vw cv cA cmv co cno cfv
      cle wbr vw cH wral cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH
      wrex vz cH vz cv cH wcel vz cv cA cmv co cno cfv vw cv cA cmv co cno cfv
      cle wbr vw cH wral cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH
      wrex wi vz cv cH wcel vz cv c0v cif cA cmv co cno cfv vw cv cA cmv co cno
      cfv cle wbr vw cH wral cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx
      cH wrex wi vz cv c0v vz cv vz cv cH wcel vz cv c0v cif wceq vz cv cA cmv
      co cno cfv vw cv cA cmv co cno cfv cle wbr vw cH wral vz cv cH wcel vz cv
      c0v cif cA cmv co cno cfv vw cv cA cmv co cno cfv cle wbr vw cH wral cA
      vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wrex vz cv vz cv cH
      wcel vz cv c0v cif wceq vz cv cA cmv co cno cfv vw cv cA cmv co cno cfv
      cle wbr vz cv cH wcel vz cv c0v cif cA cmv co cno cfv vw cv cA cmv co cno
      cfv cle wbr vw cH vz cv vz cv cH wcel vz cv c0v cif wceq vz cv cA cmv co
      cno cfv vz cv cH wcel vz cv c0v cif cA cmv co cno cfv vw cv cA cmv co cno
      cfv cle vz cv vz cv cH wcel vz cv c0v cif wceq vz cv cA cmv co vz cv cH
      wcel vz cv c0v cif cA cmv co cno vz cv vz cv cH wcel vz cv c0v cif cA cmv
      opreq1 fveq2d breq1d ralbidv imbi1d vx vy vw cA vz cv cH wcel vz cv c0v
      cif cA vz cv cH wcel vz cv c0v cif cmv co cH pjth.1 pjth.2 vz cv c0v cH
      cH cch wcel c0v cH wcel pjth.2 cH ch0 ax-mp elimel cA vz cv cH wcel vz cv
      c0v cif cmv co eqid pjthlem14 dedth r19.23aiv ax-mp $.
      $( [10-Oct-1999] $)
  $}

  ${
    $d x y A $.  $d x y H $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       into a member ` x ` of a closed subspace ` H ` and a member ` y` of the
       complement of the subspace.  Theorem 3.7(i) of [Beran] p. 102 (existence
       part). $)
    pjth $p |- ( ( H e. CH /\ A e. ~H ) ->
                E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      cH cch wcel cA chil wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex
      vx cH wrex cA vx cv vy cv cva co wceq vy cH cch wcel cH chil cif cort cfv
      wrex vx cH cch wcel cH chil cif wrex cA chil wcel cA c0v cif vx cv vy cv
      cva co wceq vy cH cch wcel cH chil cif cort cfv wrex vx cH cch wcel cH
      chil cif wrex cH cA chil c0v cA vx cv vy cv cva co wceq vy cH cort cfv
      wrex cA vx cv vy cv cva co wceq vy cH cch wcel cH chil cif cort cfv wrex
      vx cH cH cch wcel cH chil cif cH cH cch wcel cH chil cif wceq cA vx cv vy
      cv cva co wceq vy cH cort cfv cH cch wcel cH chil cif cort cfv cH cH cch
      wcel cH chil cif cort fveq2 rexeq1d rexeqd cA cA chil wcel cA c0v cif
      wceq cA vx cv vy cv cva co wceq cA chil wcel cA c0v cif vx cv vy cv cva
      co wceq vx vy cH cch wcel cH chil cif cH cch wcel cH chil cif cort cfv cA
      cA chil wcel cA c0v cif vx cv vy cv cva co eqeq1 2rexbidv vx vy cA chil
      wcel cA c0v cif cH cch wcel cH chil cif cA c0v chil ax-hv0cl elimel cH
      chil cch helch elimel pjthi dedth2h $.
      $( [11-Oct-1999] $)
  $}


  ${
    $d x y z w A $.  $d x y z w H $.
    pjtheu.1 $e |- H e. CH $.
    $( Uniqueness of ` x ` for the projection theorem.  See ~ pjtheu2i for the
       uniqueness of ` y ` . $)
    pjtheui $p |- ( A e. ~H
        -> E! x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      cA chil wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wrex cA
      vx cv vy cv cva co wceq vy cH cort cfv wrex cA vz cv vy cv cva co wceq vy
      cH cort cfv wrex wa vx cv vz cv wceq wi vz cH wral vx cH wral wa cA vx cv
      vy cv cva co wceq vy cH cort cfv wrex vx cH wreu cA chil wcel cA vx cv vy
      cv cva co wceq vy cH cort cfv wrex vx cH wrex cA vx cv vy cv cva co wceq
      vy cH cort cfv wrex cA vz cv vy cv cva co wceq vy cH cort cfv wrex wa vx
      cv vz cv wceq wi vz cH wral vx cH wral cH cch wcel cA chil wcel cA vx cv
      vy cv cva co wceq vy cH cort cfv wrex vx cH wrex pjtheu.1 vx vy cA cH
      pjth mpan cA chil wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex cA
      vz cv vy cv cva co wceq vy cH cort cfv wrex wa vx cv vz cv wceq wi vz cH
      wral vx cH cA chil wcel vx cv cH wcel cA vx cv vy cv cva co wceq vy cH
      cort cfv wrex cA vz cv vy cv cva co wceq vy cH cort cfv wrex wa vx cv vz
      cv wceq wi vz cH cA chil wcel vx cv cH wcel vz cv cH wcel cA vx cv vy cv
      cva co wceq vy cH cort cfv wrex cA vz cv vy cv cva co wceq vy cH cort cfv
      wrex wa vx cv vz cv wceq wi cA chil wcel vx cv cH wcel vz cv cH wcel wa
      wa vy cv cH cort cfv wcel vw cv cH cort cfv wcel wa cA vx cv vy cv cva co
      wceq cA vz cv vw cv cva co wceq wa wa vw wex vy wex vx cv vz cv wceq cA
      vx cv vy cv cva co wceq vy cH cort cfv wrex cA vz cv vy cv cva co wceq vy
      cH cort cfv wrex wa cA chil wcel vx cv cH wcel vz cv cH wcel wa wa vy cv
      cH cort cfv wcel vw cv cH cort cfv wcel wa cA vx cv vy cv cva co wceq cA
      vz cv vw cv cva co wceq wa wa vx cv vz cv wceq vy vw vx cv cH wcel vz cv
      cH wcel wa vy cv cH cort cfv wcel vw cv cH cort cfv wcel wa cA vx cv vy
      cv cva co wceq cA vz cv vw cv cva co wceq wa wa vx cv vz cv wceq wi cA
      chil wcel vx cv cH wcel vz cv cH wcel wa vy cv cH cort cfv wcel vw cv cH
      cort cfv wcel wa cA vx cv vy cv cva co wceq cA vz cv vw cv cva co wceq wa
      vx cv vz cv wceq vx cv cH wcel vz cv cH wcel wa vy cv cH cort cfv wcel vw
      cv cH cort cfv wcel wa wa cA vx cv vy cv cva co wceq cA vz cv vw cv cva
      co wceq wa vx cv vz cv wceq vy cv vw cv wceq wa vx cv vz cv wceq vx cv cH
      wcel vy cv cH cort cfv wcel vz cv cH wcel vw cv cH cort cfv wcel cA vx cv
      vy cv cva co wceq cA vz cv vw cv cva co wceq wa vx cv vz cv wceq vy cv vw
      cv wceq wa wi vx cv vy cv vz cv vw cv cA cH pjtheu.1 chocunii an4s vx cv
      vz cv wceq vy cv vw cv wceq pm3.26 syl6 expimpd adantl 19.23advv cA vx cv
      vy cv cva co wceq vy cH cort cfv wrex cA vz cv vy cv cva co wceq vy cH
      cort cfv wrex wa cA vx cv vy cv cva co wceq vy cH cort cfv wrex cA vz cv
      vw cv cva co wceq vw cH cort cfv wrex wa cA vx cv vy cv cva co wceq cA vz
      cv vw cv cva co wceq wa vw cH cort cfv wrex vy cH cort cfv wrex vy cv cH
      cort cfv wcel vw cv cH cort cfv wcel wa cA vx cv vy cv cva co wceq cA vz
      cv vw cv cva co wceq wa wa vw wex vy wex cA vz cv vy cv cva co wceq vy cH
      cort cfv wrex cA vz cv vw cv cva co wceq vw cH cort cfv wrex cA vx cv vy
      cv cva co wceq vy cH cort cfv wrex cA vz cv vy cv cva co wceq cA vz cv vw
      cv cva co wceq vy vw cH cort cfv vy cv vw cv wceq vz cv vy cv cva co vz
      cv vw cv cva co cA vy cv vw cv vz cv cva opreq2 eqeq2d cbvrexv anbi2i cA
      vx cv vy cv cva co wceq cA vz cv vw cv cva co wceq vy vw cH cort cfv cH
      cort cfv reeanv cA vx cv vy cv cva co wceq cA vz cv vw cv cva co wceq wa
      vy vw cH cort cfv cH cort cfv r2ex 3bitr2i syl5ib exp32 r19.21adv
      r19.21aiv jca cA vx cv vy cv cva co wceq vy cH cort cfv wrex cA vz cv vy
      cv cva co wceq vy cH cort cfv wrex vx vz cH vx cv vz cv wceq cA vx cv vy
      cv cva co wceq cA vz cv vy cv cva co wceq vy cH cort cfv vx cv vz cv wceq
      vx cv vy cv cva co vz cv vy cv cva co cA vx cv vz cv vy cv cva opreq1
      eqeq2d rexbidv reu4 sylibr $.
      $( [23-Oct-1999] $)
  $}

  ${
    $d x y A $.  $d x y H $.
    $( Uniqueness of ` x ` for the projection theorem. $)
    pjtheu $p |- ( ( H e. CH /\ A e. ~H ) ->
                  E! x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      cH cch wcel cA chil wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex
      vx cH wreu cH cch wcel cA chil wcel cA vx cv vy cv cva co wceq vy cH cort
      cfv wrex vx cH wreu wi cA chil wcel cA vx cv vy cv cva co wceq vy cH cch
      wcel cH chil cif cort cfv wrex vx cH cch wcel cH chil cif wreu wi cH chil
      cH cH cch wcel cH chil cif wceq cA vx cv vy cv cva co wceq vy cH cort cfv
      wrex vx cH wreu cA vx cv vy cv cva co wceq vy cH cch wcel cH chil cif
      cort cfv wrex vx cH cch wcel cH chil cif wreu cA chil wcel cH cH cch wcel
      cH chil cif wceq vx cv cH wcel cA vx cv vy cv cva co wceq vy cH cort cfv
      wrex wa vx weu vx cv cH cch wcel cH chil cif wcel cA vx cv vy cv cva co
      wceq vy cH cch wcel cH chil cif cort cfv wrex wa vx weu cA vx cv vy cv
      cva co wceq vy cH cort cfv wrex vx cH wreu cA vx cv vy cv cva co wceq vy
      cH cch wcel cH chil cif cort cfv wrex vx cH cch wcel cH chil cif wreu cH
      cH cch wcel cH chil cif wceq vx cv cH wcel cA vx cv vy cv cva co wceq vy
      cH cort cfv wrex wa vx cv cH cch wcel cH chil cif wcel cA vx cv vy cv cva
      co wceq vy cH cch wcel cH chil cif cort cfv wrex wa vx cH cH cch wcel cH
      chil cif wceq vx cv cH wcel vx cv cH cch wcel cH chil cif wcel cA vx cv
      vy cv cva co wceq vy cH cort cfv wrex cA vx cv vy cv cva co wceq vy cH
      cch wcel cH chil cif cort cfv wrex cH cH cch wcel cH chil cif vx cv eleq2
      cH cH cch wcel cH chil cif wceq cA vx cv vy cv cva co wceq vy cH cort cfv
      cH cch wcel cH chil cif cort cfv cH cH cch wcel cH chil cif cort fveq2
      rexeq1d anbi12d eubidv cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx
      cH df-reu cA vx cv vy cv cva co wceq vy cH cch wcel cH chil cif cort cfv
      wrex vx cH cch wcel cH chil cif df-reu 3bitr4g imbi2d vx vy cA cH cch
      wcel cH chil cif cH chil cch helch elimel pjtheui dedth imp $.
      $( [23-Oct-1999] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d h f x y z w $.
    $( Define the projection function on a Hilbert space, as a mapping from
       the Hilbert lattice to a function on Hilbert space.  Every closed
       subspace is associated with a unique projection function.  Remark in
       [Kalmbach] p. 66, adopted as a definition.  ` ( proj `` H ) `` A ` is
       the projection of vector ` A ` onto closed subspace ` H ` .  Note that
       the range of ` proj ` is the set of all projection operators, so
       ` T e. ran proj ` means that ` T ` is a projection operator. $)
    df-pj $a |- proj = { <. h , f >. | ( h e. CH /\
           f = { <. x , y >. | ( x e. ~H /\
           y = U. { z e. h | E. w e. ( _|_ ` h ) x = ( z +h w ) } ) } ) } $.
  $}

  ${
    $d f h w x y z H $.  $d w x y z A $.  $d x y B $.
    $( The value of the projection map. $)
    pjmval $p |- ( H e. CH -> ( proj ` H ) = { <. x , y >. | ( x e. ~H /\
           y = U. { z e. H | E. w e. ( _|_ ` H ) x = ( z +h w ) } ) } ) $=
      vh vf cH vx cv chil wcel vy cv vx cv vz cv vw cv cva co wceq vw vh cv
      cort cfv wrex vz vh cv crab cuni wceq wa vx vy copab vx cv chil wcel vy
      cv vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH crab cuni wceq
      wa vx vy copab cch cpj vh cv cH wceq vx cv chil wcel vy cv vx cv vz cv vw
      cv cva co wceq vw vh cv cort cfv wrex vz vh cv crab cuni wceq wa vx cv
      chil wcel vy cv vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH
      crab cuni wceq wa vx vy vh cv cH wceq vy cv vx cv vz cv vw cv cva co wceq
      vw vh cv cort cfv wrex vz vh cv crab cuni wceq vy cv vx cv vz cv vw cv
      cva co wceq vw cH cort cfv wrex vz cH crab cuni wceq vx cv chil wcel vh
      cv cH wceq vx cv vz cv vw cv cva co wceq vw vh cv cort cfv wrex vz vh cv
      crab cuni vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH crab
      cuni vy cv vh cv cH wceq vx cv vz cv vw cv cva co wceq vw vh cv cort cfv
      wrex vz vh cv crab vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz
      cH crab vh cv cH wceq vz cv vh cv wcel vx cv vz cv vw cv cva co wceq vw
      vh cv cort cfv wrex wa vz cab vz cv cH wcel vx cv vz cv vw cv cva co wceq
      vw cH cort cfv wrex wa vz cab vx cv vz cv vw cv cva co wceq vw vh cv cort
      cfv wrex vz vh cv crab vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex
      vz cH crab vh cv cH wceq vz cv vh cv wcel vx cv vz cv vw cv cva co wceq
      vw vh cv cort cfv wrex wa vz cv cH wcel vx cv vz cv vw cv cva co wceq vw
      cH cort cfv wrex wa vz vh cv cH wceq vz cv vh cv wcel vz cv cH wcel vx cv
      vz cv vw cv cva co wceq vw vh cv cort cfv wrex vx cv vz cv vw cv cva co
      wceq vw cH cort cfv wrex vh cv cH vz cv eleq2 vh cv cH wceq vx cv vz cv
      vw cv cva co wceq vw vh cv cort cfv cH cort cfv vh cv cH cort fveq2
      rexeq1d anbi12d abbidv vx cv vz cv vw cv cva co wceq vw vh cv cort cfv
      wrex vz vh cv df-rab vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz
      cH df-rab 3eqtr4g unieqd eqeq2d anbi2d opabbidv vx vy vz vw vf vh df-pj
      vx vy chil vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH crab
      cuni ax-hilex opabex2 fvopab4 $.
      $( [23-Oct-1999] $)

    $( Value of a projection. $)
    pjval $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( proj ` H ) ` A ) =
             U. { x e. H | E. y e. ( _|_ ` H ) A = ( x +h y ) } ) $=
      cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cA vz cv chil wcel vw cv vz
      cv vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab cuni wceq wa vz
      vw copab cfv cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab
      cuni cH cch wcel cA cH cpj cfv cfv cA vz cv chil wcel vw cv vz cv vx cv
      vy cv cva co wceq vy cH cort cfv wrex vx cH crab cuni wceq wa vz vw copab
      cfv wceq cA chil wcel cH cch wcel cA cH cpj cfv vz cv chil wcel vw cv vz
      cv vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab cuni wceq wa vz
      vw copab vz vw vx vy cH pjmval fveq1d adantr cA chil wcel cH cch wcel cA
      vz cv chil wcel vw cv vz cv vx cv vy cv cva co wceq vy cH cort cfv wrex
      vx cH crab cuni wceq wa vz vw copab cfv cA vx cv vy cv cva co wceq vy cH
      cort cfv wrex vx cH crab cuni wceq cA chil wcel cA vx cv vy cv cva co
      wceq vy cH cort cfv wrex vx cH crab cuni cvv wcel cA vz cv chil wcel vw
      cv vz cv vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab cuni wceq
      wa vz vw copab cfv cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH
      crab cuni wceq cH cch wcel vz vw cA vz cv vx cv vy cv cva co wceq vy cH
      cort cfv wrex vx cH crab cuni cA vx cv vy cv cva co wceq vy cH cort cfv
      wrex vx cH crab cuni chil cvv vz cv chil wcel vw cv vz cv vx cv vy cv cva
      co wceq vy cH cort cfv wrex vx cH crab cuni wceq wa vz vw copab vz cv cA
      wceq vz cv vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab cA vx
      cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab vz cv cA wceq vz cv
      vx cv vy cv cva co wceq vy cH cort cfv wrex cA vx cv vy cv cva co wceq vy
      cH cort cfv wrex vx cH vz cv cA wceq vz cv vx cv vy cv cva co wceq cA vx
      cv vy cv cva co wceq vy cH cort cfv vz cv cA vx cv vy cv cva co eqeq1
      rexbidv rabbisdv unieqd vz cv chil wcel vw cv vz cv vx cv vy cv cva co
      wceq vy cH cort cfv wrex vx cH crab cuni wceq wa vz vw copab eqid
      fvopab4g cH cch wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH
      crab cvv wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab
      cuni cvv wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH cch
      rabexg cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab cvv
      uniexg syl sylan2 ancoms eqtrd $.
      $( [23-Oct-1999] $)

    $( Closure of a projection in its subspace.  If we consider this together
       with ~ axpjpj to be axioms, the need for the ~ ax-hcompl can often be
       avoided for the kinds of theorems we are interested in here.  An
       interesting project is to see how far we can go by using them in place
       of it.  In particular, we can prove the orthomodular law ~ pjomli .) $)
    axpjcl $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( proj ` H ) ` A ) e. H ) $=
      cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cA vx cv vy cv cva co wceq
      vy cH cort cfv wrex vx cH crab cuni cH vx vy cA cH pjval cH cch wcel cA
      chil wcel wa cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wreu cA
      vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab cuni cH wcel vx vy
      cA cH pjtheu cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH reucl
      syl eqeltrd $.
      $( [23-Oct-1999] $)

$(
    @( Closure of projection, as an axiom.  Can be used to replace ~ axpjcl
       for studies of the Hilbert space completeness axiom. @)
    ax-pjcl @a |- ( ( H e. CH /\ A e. ~H ) -> ( ( proj ` H ) ` A ) e. H ) @.
$)

    $( Equality with a projection. $)
    pjeq2 $p |- ( ( H e. CH /\ A e. ~H /\ B e. H ) ->
       ( ( ( proj ` H ) ` A ) = B <-> E. x e. ( _|_ ` H ) A = ( B +h x ) ) ) $=
      cB cH wcel cH cch wcel cA chil wcel cA cH cpj cfv cfv cB wceq cA cB vx cv
      cva co wceq vx cH cort cfv wrex wb cB cH wcel cH cch wcel cA chil wcel cA
      cH cpj cfv cfv cB wceq cA cB vx cv cva co wceq vx cH cort cfv wrex wb cB
      cH wcel cH cch wcel cA chil wcel wa wa cA cH cpj cfv cfv cB wceq cA vy cv
      vx cv cva co wceq vx cH cort cfv wrex vy cH crab cuni cB wceq cA cB vx cv
      cva co wceq vx cH cort cfv wrex cH cch wcel cA chil wcel wa cA cH cpj cfv
      cfv cB wceq cA vy cv vx cv cva co wceq vx cH cort cfv wrex vy cH crab
      cuni cB wceq wb cB cH wcel cH cch wcel cA chil wcel wa cA cH cpj cfv cfv
      cA vy cv vx cv cva co wceq vx cH cort cfv wrex vy cH crab cuni cB vy vx
      cA cH pjval eqeq1d adantl cB cH wcel cA vy cv vx cv cva co wceq vx cH
      cort cfv wrex vy cH wreu cA cB vx cv cva co wceq vx cH cort cfv wrex cA
      vy cv vx cv cva co wceq vx cH cort cfv wrex vy cH crab cuni cB wceq wb cH
      cch wcel cA chil wcel wa cA vy cv vx cv cva co wceq vx cH cort cfv wrex
      cA cB vx cv cva co wceq vx cH cort cfv wrex vy cH cB vy cv cB wceq cA vy
      cv vx cv cva co wceq cA cB vx cv cva co wceq vx cH cort cfv vy cv cB wceq
      vy cv vx cv cva co cB vx cv cva co cA vy cv cB vx cv cva opreq1 eqeq2d
      rexbidv reuuni2 vy vx cA cH pjtheu sylan2 bitr4d 3impb 3coml $.
      $( [21-Feb-2007] $) $( [20-Jan-2007] $)

    $( Equality with a projection. $)
    pjeq $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( ( proj ` H ) ` A ) = B <->
                ( B e. H /\ E. x e. ( _|_ ` H ) A = ( B +h x ) ) ) ) $=
      cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cB wceq cB cH wcel cA cH
      cpj cfv cfv cB wceq wa cB cH wcel cA cB vx cv cva co wceq vx cH cort cfv
      wrex wa cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cB wceq cB cH wcel
      cA cH cpj cfv cfv cB wceq cA cH cpj cfv cfv cH wcel cB cH wcel cH cch
      wcel cA chil wcel wa cA cH cpj cfv cfv cB cH eleq1 cA cH axpjcl syl5cbi
      pm4.71rd cH cch wcel cA chil wcel wa cB cH wcel cA cH cpj cfv cfv cB wceq
      cA cB vx cv cva co wceq vx cH cort cfv wrex cH cch wcel cA chil wcel cB
      cH wcel cA cH cpj cfv cfv cB wceq cA cB vx cv cva co wceq vx cH cort cfv
      wrex wb vx cA cB cH pjeq2 3expa pm5.32da bitrd $.
      $( [15-Aug-2007] $) $( [20-Jan-2007] $)
  $}

  $( Closure of a projection in Hilbert space. $)
  pjhcl $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( proj ` H ) ` A ) e. ~H ) $=
    cH cch wcel cA chil wcel wa cH chil cA cH cpj cfv cfv cH cch wcel cH chil
    wss cA chil wcel cH chss adantr cA cH axpjcl sseldd $.
    $( [30-Oct-1999] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Orthomodular law
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    omlsilem.1 $e |- G e. SH $.
    omlsilem.2 $e |- H e. SH $.
    omlsilem.3 $e |- G C_ H $.
    omlsilem.4 $e |- ( H i^i ( _|_ ` G ) ) = 0H $.
    omlsilem.5 $e |- A e. H $.
    omlsilem.6 $e |- B e. G $.
    omlsilem.7 $e |- C e. ( _|_ ` G ) $.
    $( Lemma for orthomodular law in the Hilbert lattice. $)
    omlsilem $p |- ( A = ( B +h C ) -> A e. G ) $=
      cA cB cC cva co wceq cA cG wcel cB cC cva co cG wcel cA cB cC cva co wceq
      cB cC cva co cB cG cA cB cC cva co wceq cB cC cva co cB c0v cva co cB cA
      cB cC cva co wceq cC c0v cB cva cA cB cC cva co wceq cC cH wcel cC c0v
      wceq cA cB cC cva co wceq cA cB cmv co cC wceq cC cH wcel cA cB cmv co cC
      wceq cB cC cva co cA wceq cA cB cC cva co wceq cA cB cC cA cH omlsilem.2
      omlsilem.5 shelii cB cG omlsilem.1 omlsilem.6 shelii cG cort cfv chil cC
      cG csh wcel cG cort cfv chil wss omlsilem.1 cG shocss ax-mp omlsilem.7
      sselii hvsubaddi cB cC cva co cA eqcom bitri cA cB cmv co cC wceq cA cB
      cmv co cH wcel cC cH wcel cA cH wcel cB cH wcel cA cB cmv co cH wcel
      omlsilem.5 cG cH cB omlsilem.3 omlsilem.6 sselii cH csh wcel cA cH wcel
      cB cH wcel wa cA cB cmv co cH wcel wi omlsilem.2 cA cB cH shsubclOLD
      ax-mp mp2an cA cB cmv co cC cH eleq1 mpbii sylbir cC cH wcel cC cG cort
      cfv wcel cC c0v wceq omlsilem.7 cC cH wcel cC cG cort cfv wcel wa cC c0v
      wceq cC cH cG cort cfv cin wcel cC c0h wcel cC cH wcel cC cG cort cfv
      wcel wa cC c0v wceq cH cG cort cfv cin c0h cC omlsilem.4 eleq2i cC cH cG
      cort cfv elin cC elch0 3bitr3i biimpi mpan2 syl opreq2d cB chil wcel cB
      c0v cva co cB wceq cB cG omlsilem.1 omlsilem.6 shelii cB ax-hvaddid ax-mp
      syl6eq omlsilem.6 syl6eqel cA cB cC cva co cG eleq1 mpbird $.
      $( [14-Oct-1999] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    omlsi.1 $e |- A e. CH $.
    omlsi.2 $e |- B e. SH $.
    omlsi.3 $e |- A C_ B $.
    omlsi.4 $e |- ( B i^i ( _|_ ` A ) ) = 0H $.
    $( Subspace inference form of orthomodular law in the Hilbert lattice. $)
    omlsii $p |- A = B $=
      cA cB omlsi.3 vx cB cA vx cv cB wcel vx cv vy cv vz cv cva co wceq vz cA
      cort cfv wrex vy cA wrex vx cv cA wcel vx cv cB wcel vx cv chil wcel vx
      cv vy cv vz cv cva co wceq vz cA cort cfv wrex vy cA wrex vx cv cB
      omlsi.2 sheli cA cch wcel vx cv chil wcel vx cv vy cv vz cv cva co wceq
      vz cA cort cfv wrex vy cA wrex omlsi.1 vy vz vx cv cA pjth mpan syl vx cv
      cB wcel vx cv vy cv vz cv cva co wceq vz cA cort cfv wrex vx cv cA wcel
      vy cA vx cv cB wcel vy cv cA wcel wa vx cv vy cv vz cv cva co wceq vx cv
      cA wcel vz cA cort cfv vx cv cB wcel vy cv cA wcel vz cv cA cort cfv wcel
      vx cv vy cv vz cv cva co wceq vx cv cA wcel wi vx cv cB wcel vy cv cA
      wcel vz cv cA cort cfv wcel vx cv vy cv vz cv cva co wceq vx cv cA wcel
      wi vx cv cB wcel vx cv c0v cif vy cv vz cv cva co wceq vx cv cB wcel vx
      cv c0v cif cA wcel wi vx cv vy cv vz cv c0v c0v c0v vx cv cB wcel vx cv
      c0v cif vy cv cA wcel vy cv c0v cif vz cv cva co wceq vx cv cB wcel vx cv
      c0v cif cA wcel wi vx cv cB wcel vx cv c0v cif vy cv cA wcel vy cv c0v
      cif vz cv cA cort cfv wcel vz cv c0v cif cva co wceq vx cv cB wcel vx cv
      c0v cif cA wcel wi vx cv vx cv cB wcel vx cv c0v cif wceq vx cv vy cv vz
      cv cva co wceq vx cv cB wcel vx cv c0v cif vy cv vz cv cva co wceq vx cv
      cA wcel vx cv cB wcel vx cv c0v cif cA wcel vx cv vx cv cB wcel vx cv c0v
      cif vy cv vz cv cva co eqeq1 vx cv vx cv cB wcel vx cv c0v cif cA eleq1
      imbi12d vy cv vy cv cA wcel vy cv c0v cif wceq vx cv cB wcel vx cv c0v
      cif vy cv vz cv cva co wceq vx cv cB wcel vx cv c0v cif vy cv cA wcel vy
      cv c0v cif vz cv cva co wceq vx cv cB wcel vx cv c0v cif cA wcel vy cv vy
      cv cA wcel vy cv c0v cif wceq vy cv vz cv cva co vy cv cA wcel vy cv c0v
      cif vz cv cva co vx cv cB wcel vx cv c0v cif vy cv vy cv cA wcel vy cv
      c0v cif vz cv cva opreq1 eqeq2d imbi1d vz cv vz cv cA cort cfv wcel vz cv
      c0v cif wceq vx cv cB wcel vx cv c0v cif vy cv cA wcel vy cv c0v cif vz
      cv cva co wceq vx cv cB wcel vx cv c0v cif vy cv cA wcel vy cv c0v cif vz
      cv cA cort cfv wcel vz cv c0v cif cva co wceq vx cv cB wcel vx cv c0v cif
      cA wcel vz cv vz cv cA cort cfv wcel vz cv c0v cif wceq vy cv cA wcel vy
      cv c0v cif vz cv cva co vy cv cA wcel vy cv c0v cif vz cv cA cort cfv
      wcel vz cv c0v cif cva co vx cv cB wcel vx cv c0v cif vz cv vz cv cA cort
      cfv wcel vz cv c0v cif vy cv cA wcel vy cv c0v cif cva opreq2 eqeq2d
      imbi1d vx cv cB wcel vx cv c0v cif vy cv cA wcel vy cv c0v cif vz cv cA
      cort cfv wcel vz cv c0v cif cA cB cA omlsi.1 chshii omlsi.2 omlsi.3
      omlsi.4 vx cv c0v cB cB csh wcel c0v cB wcel omlsi.2 cB sh0 ax-mp elimel
      vy cv c0v cA cA cch wcel c0v cA wcel omlsi.1 cA ch0 ax-mp elimel vz cv
      c0v cA cort cfv cA cort cfv csh wcel c0v cA cort cfv wcel cA csh wcel cA
      cort cfv csh wcel cA omlsi.1 chshii cA shocsh ax-mp cA cort cfv sh0 ax-mp
      elimel omlsilem dedth3h 3expia r19.23adv r19.23adva mpd ssriv eqssi $.
      $( [14-Oct-1999] $)
  $}

  ${
    omls.1 $e |- A e. CH $.
    omls.2 $e |- B e. SH $.
    $( Subspace form of orthomodular law in the Hilbert lattice.  Compare
       the orthomodular law in Theorem 2(ii) of [Kalmbach] p. 22. $)
    omlsi $p |- ( ( A C_ B /\ ( B i^i ( _|_ ` A ) ) = 0H ) -> A = B ) $=
      cA cB wss cB cA cort cfv cin c0h wceq wa cA cB wceq cA cB wss cB cA cort
      cfv cin c0h wceq wa cA c0h cif cB wceq cA cB wss cB cA cort cfv cin c0h
      wceq wa cA c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif
      wceq cA cB c0h c0h cA cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif
      cB eqeq1 cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif cA cB wss
      cB cA cort cfv cin c0h wceq wa cA c0h cif eqeq2 cA cB wss cB cA cort cfv
      cin c0h wceq wa cA c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cB
      c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cch omls.1 h0elch
      keepel cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h csh omls.2 h0elsh
      keepel cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cA cB wss cB
      cA cort cfv cin c0h wceq wa cB c0h cif wss cA cB wss cB cA cort cfv cin
      c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h
      cif cort cfv cin c0h wceq cA cB wss cB cA cort cfv cin c0h wceq wa cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB wss cB cA cB wss cB cA
      cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq wa cA cB wss cB
      cA cort cfv cin c0h wceq wa cA c0h cif cA cB wss cB cA cort cfv cin c0h
      wceq wa cB c0h cif wss cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h
      cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h
      wceq wa c0h c0h wss c0h c0h cort cfv cin c0h wceq wa cA cB c0h c0h cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif c0h wss c0h cA cB wss cB cA
      cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq wa cA cA cB wss
      cB cA cort cfv cin c0h wceq wa cA c0h cif wceq cA cB wss cA cB wss cB cA
      cort cfv cin c0h wceq wa cA c0h cif cB wss cB cA cort cfv cin c0h wceq cB
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq
      cA cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB sseq1 cA cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq cB cA cort cfv cin cB
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h cA
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq cA cort cfv cA
      cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cB cA cA cB wss
      cB cA cort cfv cin c0h wceq wa cA c0h cif cort fveq2 ineq2d eqeq1d
      anbi12d cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif wceq cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB wss cA cB wss cB cA cort
      cfv cin c0h wceq wa cA c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa
      cB c0h cif wss cB cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif
      cort cfv cin c0h wceq cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq
      cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif cA cB wss cB cA
      cort cfv cin c0h wceq wa cA c0h cif sseq2 cB cA cB wss cB cA cort cfv cin
      c0h wceq wa cB c0h cif wceq cB cA cB wss cB cA cort cfv cin c0h wceq wa
      cA c0h cif cort cfv cin cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h
      cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h
      cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif cA cB wss cB cA
      cort cfv cin c0h wceq wa cA c0h cif cort cfv ineq1 eqeq1d anbi12d c0h cA
      cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq c0h c0h wss cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif c0h wss c0h c0h cort cfv
      cin c0h wceq c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort
      cfv cin c0h wceq c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif
      c0h sseq1 c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq
      c0h c0h cort cfv cin c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h
      cif cort cfv cin c0h c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h
      cif wceq c0h cort cfv cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif
      cort cfv c0h c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort
      fveq2 ineq2d eqeq1d anbi12d c0h cA cB wss cB cA cort cfv cin c0h wceq wa
      cB c0h cif wceq cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif c0h
      wss cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cA cB wss cB cA
      cort cfv cin c0h wceq wa cB c0h cif wss c0h cA cB wss cB cA cort cfv cin
      c0h wceq wa cA c0h cif cort cfv cin c0h wceq cA cB wss cB cA cort cfv cin
      c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h
      cif cort cfv cin c0h wceq c0h cA cB wss cB cA cort cfv cin c0h wceq wa cB
      c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif sseq2 c0h cA
      cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif wceq c0h cA cB wss cB cA
      cort cfv cin c0h wceq wa cA c0h cif cort cfv cin cA cB wss cB cA cort cfv
      cin c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA
      c0h cif cort cfv cin c0h c0h cA cB wss cB cA cort cfv cin c0h wceq wa cB
      c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv
      ineq1 eqeq1d anbi12d c0h c0h wss c0h c0h cort cfv cin c0h wceq c0h ssid
      c0h csh wcel c0h c0h cort cfv cin c0h wceq h0elsh c0h ocin ax-mp pm3.2i
      elimhyp2v pm3.26i cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cA
      cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif wss cA cB wss cB cA cort
      cfv cin c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa
      cA c0h cif cort cfv cin c0h wceq cA cB wss cB cA cort cfv cin c0h wceq wa
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB wss cB cA cB wss
      cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq wa cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif cA cB wss cB cA cort cfv
      cin c0h wceq wa cB c0h cif wss cA cB wss cB cA cort cfv cin c0h wceq wa
      cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv
      cin c0h wceq wa c0h c0h wss c0h c0h cort cfv cin c0h wceq wa cA cB c0h
      c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif c0h wss c0h cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq wa cA
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq cA cB wss cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB wss cB cA cort cfv cin
      c0h wceq cB cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv
      cin c0h wceq cA cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB
      sseq1 cA cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq cB cA
      cort cfv cin cB cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort
      cfv cin c0h cA cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq
      cA cort cfv cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv
      cB cA cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort fveq2
      ineq2d eqeq1d anbi12d cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h
      cif wceq cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cB wss cA cB
      wss cB cA cort cfv cin c0h wceq wa cA c0h cif cA cB wss cB cA cort cfv
      cin c0h wceq wa cB c0h cif wss cB cA cB wss cB cA cort cfv cin c0h wceq
      wa cA c0h cif cort cfv cin c0h wceq cA cB wss cB cA cort cfv cin c0h wceq
      wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort
      cfv cin c0h wceq cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif sseq2 cB cA cB wss cB
      cA cort cfv cin c0h wceq wa cB c0h cif wceq cB cA cB wss cB cA cort cfv
      cin c0h wceq wa cA c0h cif cort cfv cin cA cB wss cB cA cort cfv cin c0h
      wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif
      cort cfv cin c0h cB cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif
      cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv ineq1 eqeq1d
      anbi12d c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif wceq c0h
      c0h wss cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif c0h wss c0h
      c0h cort cfv cin c0h wceq c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA
      c0h cif cort cfv cin c0h wceq c0h cA cB wss cB cA cort cfv cin c0h wceq
      wa cA c0h cif c0h sseq1 c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA
      c0h cif wceq c0h c0h cort cfv cin c0h cA cB wss cB cA cort cfv cin c0h
      wceq wa cA c0h cif cort cfv cin c0h c0h cA cB wss cB cA cort cfv cin c0h
      wceq wa cA c0h cif wceq c0h cort cfv cA cB wss cB cA cort cfv cin c0h
      wceq wa cA c0h cif cort cfv c0h c0h cA cB wss cB cA cort cfv cin c0h wceq
      wa cA c0h cif cort fveq2 ineq2d eqeq1d anbi12d c0h cA cB wss cB cA cort
      cfv cin c0h wceq wa cB c0h cif wceq cA cB wss cB cA cort cfv cin c0h wceq
      wa cA c0h cif c0h wss cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif
      cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif wss c0h cA cB wss cB
      cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin c0h wceq cA cB wss cB
      cA cort cfv cin c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h
      wceq wa cA c0h cif cort cfv cin c0h wceq c0h cA cB wss cB cA cort cfv cin
      c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h
      cif sseq2 c0h cA cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif wceq
      c0h cA cB wss cB cA cort cfv cin c0h wceq wa cA c0h cif cort cfv cin cA
      cB wss cB cA cort cfv cin c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv
      cin c0h wceq wa cA c0h cif cort cfv cin c0h c0h cA cB wss cB cA cort cfv
      cin c0h wceq wa cB c0h cif cA cB wss cB cA cort cfv cin c0h wceq wa cA
      c0h cif cort cfv ineq1 eqeq1d anbi12d c0h c0h wss c0h c0h cort cfv cin
      c0h wceq c0h ssid c0h csh wcel c0h c0h cort cfv cin c0h wceq h0elsh c0h
      ocin ax-mp pm3.2i elimhyp2v pm3.27i omlsii dedth2v $.
      $( [14-Oct-1999] $)
  $}

  ${
    $d x y z A $.
    ococ.1 $e |- A e. CH $.
    $( Complement of complement of a closed subspace of Hilbert space.
       Theorem 3.7(ii) of [Beran] p. 102. $)
    ococi $p |- ( _|_ ` ( _|_ ` A ) ) = A $=
      cA cA cort cfv cort cfv cA cA cort cfv cort cfv ococ.1 cA cort cfv csh
      wcel cA cort cfv cort cfv csh wcel cA csh wcel cA cort cfv csh wcel cA
      ococ.1 chshii cA shocsh ax-mp cA cort cfv shocsh ax-mp cA csh wcel cA cA
      cort cfv cort cfv wss cA ococ.1 chshii cA shococss ax-mp cA cort cfv cort
      cfv cA cort cfv cin cA cort cfv cA cort cfv cort cfv cin c0h cA cort cfv
      cort cfv cA cort cfv incom cA cort cfv csh wcel cA cort cfv cA cort cfv
      cort cfv cin c0h wceq cA csh wcel cA cort cfv csh wcel cA ococ.1 chshii
      cA shocsh ax-mp cA cort cfv ocin ax-mp eqtri omlsii eqcomi $.
      $( [11-Oct-1999] $)
  $}

  ${
    $d x y z A $.
    $( Complement of complement of a closed subspace of Hilbert space.
       Theorem 3.7(ii) of [Beran] p. 102. $)
    ococ $p |- ( A e. CH -> ( _|_ ` ( _|_ ` A ) ) = A ) $=
      cA cch wcel cA cort cfv cort cfv cA wceq cA cch wcel cA chil cif cort cfv
      cort cfv cA cch wcel cA chil cif wceq cA chil cA cA cch wcel cA chil cif
      wceq cA cort cfv cort cfv cA cch wcel cA chil cif cort cfv cort cfv cA cA
      cch wcel cA chil cif cA cA cch wcel cA chil cif wceq cA cort cfv cA cch
      wcel cA chil cif cort cfv cort cA cA cch wcel cA chil cif cort fveq2
      fveq2d cA cA cch wcel cA chil cif wceq id eqeq12d cA cch wcel cA chil cif
      cA chil cch helch elimel ococi dedth $.
      $( [11-Oct-1999] $)
  $}

  $( Alternate definition of the Hilbert lattice. $)
  dfch2 $p |- CH = { x | ( x C_ ~H /\ ( _|_ ` ( _|_ ` x ) ) = x ) } $=
    vx cv chil wss vx cv cort cfv cort cfv vx cv wceq wa vx cch vx cv cch wcel
    vx cv chil wss vx cv cort cfv cort cfv vx cv wceq wa vx cv cch wcel vx cv
    chil wss vx cv cort cfv cort cfv vx cv wceq vx cv chss vx cv ococ jca vx cv
    cort cfv cort cfv vx cv wceq vx cv chil wss vx cv cch wcel vx cv cort cfv
    cort cfv vx cv wceq vx cv cort cfv cort cfv cch wcel vx cv cch wcel vx cv
    chil wss vx cv cort cfv cort cfv vx cv cch eleq1 vx cv chil wss vx cv cort
    cfv cch wcel vx cv cort cfv chil wss vx cv cort cfv cort cfv cch wcel vx cv
    occl vx cv cort cfv chss vx cv cort cfv occl 3syl syl5bi impcom impbii
    abbi2i $.
    $( [8-Aug-2000] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y H $.
    pjtheu2.1 $e |- H e. CH $.
    $( Uniqueness of ` y ` for the projection theorem. $)
    pjtheu2i $p |- ( A e. ~H
        -> E! y e. ( _|_ ` H ) E. x e. H A = ( x +h y ) ) $=
      cA chil wcel cA vy cv vx cv cva co wceq vx cH cort cfv cort cfv wrex vy
      cH cort cfv wreu cA vx cv vy cv cva co wceq vx cH wrex vy cH cort cfv
      wreu vy vx cA cH cort cfv cH pjtheu2.1 choccli pjtheui cA vy cv vx cv cva
      co wceq vx cH cort cfv cort cfv wrex cA vx cv vy cv cva co wceq vx cH
      wrex vy cH cort cfv vy cv cH cort cfv wcel cA vy cv vx cv cva co wceq vx
      cH wrex cA vx cv vy cv cva co wceq vx cH wrex cA vy cv vx cv cva co wceq
      vx cH cort cfv cort cfv wrex vy cv cH cort cfv wcel cA vy cv vx cv cva co
      wceq cA vx cv vy cv cva co wceq vx cH vy cv cH cort cfv wcel vx cv cH
      wcel wa vy cv vx cv cva co vx cv vy cv cva co cA vy cv chil wcel vx cv
      chil wcel vy cv vx cv cva co vx cv vy cv cva co wceq vy cv cH cort cfv
      wcel vx cv cH wcel vy cv vx cv ax-hvcom vy cv cH cort cfv cH pjtheu2.1
      choccli cheli vx cv cH pjtheu2.1 cheli syl2an eqeq2d rexbidva cH cort cfv
      cort cfv cH wceq cA vy cv vx cv cva co wceq vx cH cort cfv cort cfv wrex
      cA vy cv vx cv cva co wceq vx cH wrex wb cH pjtheu2.1 ococi cA vy cv vx
      cv cva co wceq vx cH cort cfv cort cfv cH rexeq1 ax-mp syl5bb reubiia
      sylib $.
      $( [13-Apr-2008] $) $( [6-Nov-1999] $)
  $}

  ${
    pjcl.1 $e |- H e. CH $.
    $( Closure of a projection in its subspace. $)
    pjcli $p |- ( A e. ~H -> ( ( proj ` H ) ` A ) e. H ) $=
      cH cch wcel cA chil wcel cA cH cpj cfv cfv cH wcel pjcl.1 cA cH axpjcl
      mpan $.
      $( [7-Oct-2000] $)

    $( Closure of a projection in Hilbert space. $)
    pjhcli $p |- ( A e. ~H -> ( ( proj ` H ) ` A ) e. ~H ) $=
      cH cch wcel cA chil wcel cA cH cpj cfv cfv chil wcel pjcl.1 cA cH pjhcl
      mpan $.
      $( [7-Oct-2000] $)
  $}

  ${
    $d x y A $.  $d x y H $.
    pjcli.1 $e |- H e. CH $.
    pjcli.2 $e |- A e. ~H $.
    $( Closure of a projection in its subspace. $)
    pjclii $p |- ( ( proj ` H ) ` A ) e. H $=
      cA chil wcel cA cH cpj cfv cfv cH wcel pjcli.2 cA cH pjcli.1 pjcli ax-mp
      $.
      $( [30-Oct-1999] $)

    $( Closure of a projection in Hilbert space. $)
    pjhclii $p |- ( ( proj ` H ) ` A ) e. ~H $=
      cA chil wcel cA cH cpj cfv cfv chil wcel pjcli.2 cA cH pjcli.1 pjhcli
      ax-mp $.
      $( [30-Oct-1999] $)

    $( Decomposition of a vector into projections. $)
    pjpj0i $p |- A = ( ( ( proj ` H ) ` A ) +h
                ( ( proj ` ( _|_ ` H ) ) ` A ) ) $=
      vx cv cH wcel vy cv cH cort cfv wcel wa cA vx cv cA cH cort cfv cpj cfv
      cfv cva co wceq cA cA cH cpj cfv cfv vy cv cva co wceq wa wa vy wex vx
      wex cA cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co wceq vx cv cH
      wcel vy cv cH cort cfv wcel wa cA vx cv cA cH cort cfv cpj cfv cfv cva co
      wceq cA cA cH cpj cfv cfv vy cv cva co wceq wa wa vy wex vx wex cA vx cv
      cA cH cort cfv cpj cfv cfv cva co wceq vx cH wrex cA cA cH cpj cfv cfv vy
      cv cva co wceq vy cH cort cfv wrex vx cv cH wcel vy cv cH cort cfv wcel
      wa cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq cA cA cH cpj cfv cfv
      vy cv cva co wceq wa wa vy wex vx wex cA vx cv cA cH cort cfv cpj cfv cfv
      cva co wceq cA cA cH cpj cfv cfv vy cv cva co wceq wa vy cH cort cfv wrex
      vx cH wrex cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq vx cH wrex cA
      cA cH cpj cfv cfv vy cv cva co wceq vy cH cort cfv wrex wa cA vx cv cA cH
      cort cfv cpj cfv cfv cva co wceq cA cA cH cpj cfv cfv vy cv cva co wceq
      wa vx vy cH cH cort cfv r2ex cA vx cv cA cH cort cfv cpj cfv cfv cva co
      wceq cA cA cH cpj cfv cfv vy cv cva co wceq vx vy cH cH cort cfv reeanv
      bitr3i cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq vx cH wrex cA cA
      cH cort cfv cpj cfv cfv vx cv cva co wceq vx cH cort cfv cort cfv wrex cA
      cA cH cort cfv cpj cfv cfv vx cv cva co wceq vx cH cort cfv cort cfv wrex
      cA vy cv vx cv cva co wceq vx cH cort cfv cort cfv wrex vy cH cort cfv
      crab cuni cA cH cort cfv cpj cfv cfv wceq cA cH cort cfv cpj cfv cfv cA
      vy cv vx cv cva co wceq vx cH cort cfv cort cfv wrex vy cH cort cfv crab
      cuni cH cort cfv cch wcel cA chil wcel cA cH cort cfv cpj cfv cfv cA vy
      cv vx cv cva co wceq vx cH cort cfv cort cfv wrex vy cH cort cfv crab
      cuni wceq cH pjcli.1 choccli pjcli.2 vy vx cA cH cort cfv pjval mp2an
      eqcomi cA cH cort cfv cpj cfv cfv cH cort cfv wcel cA vy cv vx cv cva co
      wceq vx cH cort cfv cort cfv wrex vy cH cort cfv wreu cA cA cH cort cfv
      cpj cfv cfv vx cv cva co wceq vx cH cort cfv cort cfv wrex cA vy cv vx cv
      cva co wceq vx cH cort cfv cort cfv wrex vy cH cort cfv crab cuni cA cH
      cort cfv cpj cfv cfv wceq wb cA cH cort cfv cH pjcli.1 choccli pjcli.2
      pjclii cA chil wcel cA vy cv vx cv cva co wceq vx cH cort cfv cort cfv
      wrex vy cH cort cfv wreu pjcli.2 vy vx cA cH cort cfv cH pjcli.1 choccli
      pjtheui ax-mp cA vy cv vx cv cva co wceq vx cH cort cfv cort cfv wrex cA
      cA cH cort cfv cpj cfv cfv vx cv cva co wceq vx cH cort cfv cort cfv wrex
      vy cH cort cfv cA cH cort cfv cpj cfv cfv vy cv cA cH cort cfv cpj cfv
      cfv wceq cA vy cv vx cv cva co wceq cA cA cH cort cfv cpj cfv cfv vx cv
      cva co wceq vx cH cort cfv cort cfv vy cv cA cH cort cfv cpj cfv cfv wceq
      vy cv vx cv cva co cA cH cort cfv cpj cfv cfv vx cv cva co cA vy cv cA cH
      cort cfv cpj cfv cfv vx cv cva opreq1 eqeq2d rexbidv reuuni2 mp2an mpbir
      cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq vx cH wrex cA vx cv cA cH
      cort cfv cpj cfv cfv cva co wceq vx cH cort cfv cort cfv wrex cA cA cH
      cort cfv cpj cfv cfv vx cv cva co wceq vx cH cort cfv cort cfv wrex cH
      cort cfv cort cfv cH wceq cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq
      vx cH cort cfv cort cfv wrex cA vx cv cA cH cort cfv cpj cfv cfv cva co
      wceq vx cH wrex wb cH pjcli.1 ococi cA vx cv cA cH cort cfv cpj cfv cfv
      cva co wceq vx cH cort cfv cort cfv cH rexeq1 ax-mp cA vx cv cA cH cort
      cfv cpj cfv cfv cva co wceq cA cA cH cort cfv cpj cfv cfv vx cv cva co
      wceq vx cH cort cfv cort cfv vx cv cH cort cfv cort cfv wcel vx cv chil
      wcel cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq cA cA cH cort cfv
      cpj cfv cfv vx cv cva co wceq wb vx cv cH cort cfv cort cfv cH cort cfv
      cH pjcli.1 choccli choccli cheli vx cv chil wcel vx cv cA cH cort cfv cpj
      cfv cfv cva co cA cH cort cfv cpj cfv cfv vx cv cva co cA vx cv chil wcel
      cA cH cort cfv cpj cfv cfv chil wcel vx cv cA cH cort cfv cpj cfv cfv cva
      co cA cH cort cfv cpj cfv cfv vx cv cva co wceq cA cH cort cfv cH pjcli.1
      choccli pjcli.2 pjhclii vx cv cA cH cort cfv cpj cfv cfv ax-hvcom mpan2
      eqeq2d syl rexbiia bitr3i mpbir cA cA cH cpj cfv cfv vy cv cva co wceq vy
      cH cort cfv wrex cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH
      crab cuni cA cH cpj cfv cfv wceq cA cH cpj cfv cfv cA vx cv vy cv cva co
      wceq vy cH cort cfv wrex vx cH crab cuni cH cch wcel cA chil wcel cA cH
      cpj cfv cfv cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH crab
      cuni wceq pjcli.1 pjcli.2 vx vy cA cH pjval mp2an eqcomi cA cH cpj cfv
      cfv cH wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex vx cH wreu cA
      cA cH cpj cfv cfv vy cv cva co wceq vy cH cort cfv wrex cA vx cv vy cv
      cva co wceq vy cH cort cfv wrex vx cH crab cuni cA cH cpj cfv cfv wceq wb
      cA cH pjcli.1 pjcli.2 pjclii cA chil wcel cA vx cv vy cv cva co wceq vy
      cH cort cfv wrex vx cH wreu pjcli.2 vx vy cA cH pjcli.1 pjtheui ax-mp cA
      vx cv vy cv cva co wceq vy cH cort cfv wrex cA cA cH cpj cfv cfv vy cv
      cva co wceq vy cH cort cfv wrex vx cH cA cH cpj cfv cfv vx cv cA cH cpj
      cfv cfv wceq cA vx cv vy cv cva co wceq cA cA cH cpj cfv cfv vy cv cva co
      wceq vy cH cort cfv vx cv cA cH cpj cfv cfv wceq vx cv vy cv cva co cA cH
      cpj cfv cfv vy cv cva co cA vx cv cA cH cpj cfv cfv vy cv cva opreq1
      eqeq2d rexbidv reuuni2 mp2an mpbir mpbir2an vx cv cH wcel vy cv cH cort
      cfv wcel wa cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq cA cA cH cpj
      cfv cfv vy cv cva co wceq wa wa cA cA cH cpj cfv cfv cA cH cort cfv cpj
      cfv cfv cva co wceq vx vy vx cv cH wcel vy cv cH cort cfv wcel wa cA vx
      cv cA cH cort cfv cpj cfv cfv cva co wceq cA cA cH cpj cfv cfv vy cv cva
      co wceq wa wa vx cv cA cH cpj cfv cfv wceq cA cA cH cpj cfv cfv cA cH
      cort cfv cpj cfv cfv cva co wceq vx cv cH wcel vy cv cH cort cfv wcel wa
      cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq cA cA cH cpj cfv cfv vy
      cv cva co wceq wa wa vx cv cA cH cpj cfv cfv wceq cA cH cort cfv cpj cfv
      cfv vy cv wceq vx cv cH wcel vy cv cH cort cfv wcel wa cA vx cv cA cH
      cort cfv cpj cfv cfv cva co wceq cA cA cH cpj cfv cfv vy cv cva co wceq
      wa vx cv cA cH cpj cfv cfv wceq cA cH cort cfv cpj cfv cfv vy cv wceq wa
      vx cv cH wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel wa cA cH cpj
      cfv cfv cH wcel vy cv cH cort cfv wcel wa cA vx cv cA cH cort cfv cpj cfv
      cfv cva co wceq cA cA cH cpj cfv cfv vy cv cva co wceq wa vx cv cA cH cpj
      cfv cfv wceq cA cH cort cfv cpj cfv cfv vy cv wceq wa wi vx cv cH wcel vy
      cv cH cort cfv wcel vx cv cA cH cort cfv cpj cfv cfv cA cH cpj cfv cfv vy
      cv cA cH pjcli.1 chocunii vx cv cH wcel cA cH cort cfv cpj cfv cfv cH
      cort cfv wcel cA cH cort cfv cH pjcli.1 choccli pjcli.2 pjclii jctr vy cv
      cH cort cfv wcel cA cH cpj cfv cfv cH wcel cA cH pjcli.1 pjcli.2 pjclii
      jctl syl2an imp pm3.26d cA vx cv cA cH cort cfv cpj cfv cfv cva co wceq
      vx cv cA cH cpj cfv cfv wceq cA cA cH cpj cfv cfv cA cH cort cfv cpj cfv
      cfv cva co wceq wi vx cv cH wcel vy cv cH cort cfv wcel wa cA cA cH cpj
      cfv cfv vy cv cva co wceq vx cv cA cH cpj cfv cfv wceq cA vx cv cA cH
      cort cfv cpj cfv cfv cva co wceq cA cA cH cpj cfv cfv cA cH cort cfv cpj
      cfv cfv cva co wceq vx cv cA cH cpj cfv cfv wceq vx cv cA cH cort cfv cpj
      cfv cfv cva co cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cA vx
      cv cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva opreq1 eqeq2d biimpcd
      ad2antrl mpd 19.23aivv ax-mp $.
      $( [26-Oct-1999] $)
  $}

  $( Decomposition of a vector into projections.  See comment in ~ axpjcl . $)
  axpjpj $p |- ( ( H e. CH /\ A e. ~H ) ->
            A = ( ( ( proj ` H ) ` A ) +h ( ( proj ` ( _|_ ` H ) ) ` A ) ) ) $=
    cH cch wcel cA chil wcel cA cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv
    cva co wceq cA cA cH cch wcel cH chil cif cpj cfv cfv cA cH cch wcel cH
    chil cif cort cfv cpj cfv cfv cva co wceq cA chil wcel cA c0v cif cA chil
    wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif
    cH cch wcel cH chil cif cort cfv cpj cfv cfv cva co wceq cH cA chil c0v cH
    cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv
    cva co cA cH cch wcel cH chil cif cpj cfv cfv cA cH cch wcel cH chil cif
    cort cfv cpj cfv cfv cva co cA cH cH cch wcel cH chil cif wceq cA cH cpj
    cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv cA cH cort cfv cpj cfv cfv
    cA cH cch wcel cH chil cif cort cfv cpj cfv cfv cva cH cH cch wcel cH chil
    cif wceq cA cH cpj cfv cH cch wcel cH chil cif cpj cfv cH cH cch wcel cH
    chil cif cpj fveq2 fveq1d cH cH cch wcel cH chil cif wceq cA cH cort cfv
    cpj cfv cH cch wcel cH chil cif cort cfv cpj cfv cH cH cch wcel cH chil cif
    wceq cH cort cfv cH cch wcel cH chil cif cort cfv cpj cH cH cch wcel cH
    chil cif cort fveq2 fveq2d fveq1d opreq12d eqeq2d cA cA chil wcel cA c0v
    cif wceq cA cA chil wcel cA c0v cif cA cH cch wcel cH chil cif cpj cfv cfv
    cA cH cch wcel cH chil cif cort cfv cpj cfv cfv cva co cA chil wcel cA c0v
    cif cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif cH cch wcel
    cH chil cif cort cfv cpj cfv cfv cva co cA cA chil wcel cA c0v cif wceq id
    cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cA
    chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA cH cch wcel cH
    chil cif cort cfv cpj cfv cfv cA chil wcel cA c0v cif cH cch wcel cH chil
    cif cort cfv cpj cfv cfv cva cA cA chil wcel cA c0v cif cH cch wcel cH chil
    cif cpj cfv fveq2 cA cA chil wcel cA c0v cif cH cch wcel cH chil cif cort
    cfv cpj cfv fveq2 opreq12d eqeq12d cA chil wcel cA c0v cif cH cch wcel cH
    chil cif cH chil cch helch elimel cA c0v chil ax-hv0cl elimel pjpj0i
    dedth2h $.
    $( [26-Oct-1999] $)

$(
  @( Decomposition of a vector into projections, as an axiom.  Can be used to
     replace ~ axpjpj in studies of the Hilbert space completeness axiom. @)
  ax-pjpj @a |- ( ( H e. CH /\ A e. ~H ) ->
            A = ( ( ( proj ` H ) ` A ) +h ( ( proj ` ( _|_ ` H ) ) ` A ) ) ) @.
$)

  ${
    $d x y A $.  $d x y H $.
    pjpj.1 $e |- H e. CH $.
    pjpj.2 $e |- A e. ~H $.
    $( Decomposition of a vector into projections. $)
    pjpji $p |- A = ( ( ( proj ` H ) ` A ) +h
               ( ( proj ` ( _|_ ` H ) ) ` A ) ) $=
      cA cH pjpj.1 pjpj.2 pjpj0i $.
      $( [6-Nov-1999] $)
  $}

  ${
    $d x y A $.  $d x y H $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       into a member ` x ` of a closed subspace ` H ` and a member ` y` of the
       complement of the subspace.  Theorem 3.7(i) of [Beran] p. 102 (existence
       part). $)
    pjpjth $p |- ( ( H e. CH /\ A e. ~H ) ->
                E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      cA cH cpj cfv cfv cH wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel cA
      cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co wceq cA vx cv vy cv
      cva co wceq vy cH cort cfv wrex vx cH wrex cH cch wcel cA chil wcel wa vx
      vy cH cH cort cfv cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cA cva
      rcla4eopr cA cH axpjcl cH cort cfv cch wcel cA chil wcel cA cH cort cfv
      cpj cfv cfv cH cort cfv wcel cH cch wcel cA cH cort cfv axpjcl cH choccl
      sylan cA cH axpjpj syl3anc $.
      $( [6-Nov-1999] $)
  $}

  ${
    $d x y A $.  $d x y H $.
    pjpjth.1 $e |- A e. ~H $.
    pjpjth.2 $e |- H e. CH $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       into a member ` x ` of a closed subspace ` H ` and a member ` y` of the
       complement of the subspace.  Theorem 3.7(i) of [Beran] p. 102 (existence
       part). $)
    pjpjthi $p |- E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) $=
      cH cch wcel cA chil wcel cA vx cv vy cv cva co wceq vy cH cort cfv wrex
      vx cH wrex pjpjth.2 pjpjth.1 vx vy cA cH pjpjth mp2an $.
      $( [6-Nov-1999] $)
  $}

  $( Orthocomplement projection in terms of projection. $)
  pjop $p |- ( ( H e. CH /\ A e. ~H ) ->
           ( ( proj ` ( _|_ ` H ) ) ` A ) = ( A -h ( ( proj ` H ) ` A ) ) ) $=
    cH cch wcel cA chil wcel wa cA cA cH cpj cfv cfv cmv co cA cH cort cfv cpj
    cfv cfv cH cch wcel cA chil wcel wa cA cA cH cpj cfv cfv cmv co cA cH cort
    cfv cpj cfv cfv wceq cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cA
    wceq cH cch wcel cA chil wcel wa cA cA cH cpj cfv cfv cA cH cort cfv cpj
    cfv cfv cva co cA cH axpjpj eqcomd cA chil wcel cA cH cpj cfv cfv chil wcel
    cA cH cort cfv cpj cfv cfv chil wcel cA cA cH cpj cfv cfv cmv co cA cH cort
    cfv cpj cfv cfv wceq cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cA
    wceq wb cH cch wcel cA chil wcel wa cA cA cH cpj cfv cfv cA cH cort cfv cpj
    cfv cfv hvsubadd cH cch wcel cA chil wcel pm3.27 cA cH pjhcl cH cort cfv
    cch wcel cA chil wcel cA cH cort cfv cpj cfv cfv chil wcel cH cch wcel cA
    cH cort cfv pjhcl cH choccl sylan syl3anc mpbird eqcomd $.
    $( [5-Nov-1999] $)

  $( Projection in terms of orthocomplement projection. $)
  pjpo $p |- ( ( H e. CH /\ A e. ~H ) ->
           ( ( proj ` H ) ` A ) = ( A -h ( ( proj ` ( _|_ ` H ) ) ` A ) ) ) $=
    cH cch wcel cA chil wcel wa cA cA cH cort cfv cpj cfv cfv cmv co cA cH cpj
    cfv cfv cH cch wcel cA chil wcel wa cA cA cH cort cfv cpj cfv cfv cmv co cA
    cH cpj cfv cfv wceq cA cH cort cfv cpj cfv cfv cA cH cpj cfv cfv cva co cA
    wceq cH cch wcel cA chil wcel wa cA cH cort cfv cpj cfv cfv cA cH cpj cfv
    cfv cva co cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cA cA cH
    cort cfv cpj cfv cfv chil wcel cA cH cpj cfv cfv chil wcel cA cH cort cfv
    cpj cfv cfv cA cH cpj cfv cfv cva co cA cH cpj cfv cfv cA cH cort cfv cpj
    cfv cfv cva co wceq cH cch wcel cA chil wcel wa cA cH cort cfv cpj cfv cfv
    cA cH cpj cfv cfv ax-hvcom cH cort cfv cch wcel cA chil wcel cA cH cort cfv
    cpj cfv cfv chil wcel cH cch wcel cA cH cort cfv pjhcl cH choccl sylan cA
    cH pjhcl sylanc cA cH axpjpj eqtr4d cA chil wcel cA cH cort cfv cpj cfv cfv
    chil wcel cA cH cpj cfv cfv chil wcel cA cA cH cort cfv cpj cfv cfv cmv co
    cA cH cpj cfv cfv wceq cA cH cort cfv cpj cfv cfv cA cH cpj cfv cfv cva co
    cA wceq wb cH cch wcel cA chil wcel wa cA cA cH cort cfv cpj cfv cfv cA cH
    cpj cfv cfv hvsubadd cH cch wcel cA chil wcel pm3.27 cH cort cfv cch wcel
    cA chil wcel cA cH cort cfv cpj cfv cfv chil wcel cH cch wcel cA cH cort
    cfv pjhcl cH choccl sylan cA cH pjhcl syl3anc mpbird eqcomd $.
    $( [5-Nov-1999] $)

  ${
    pjop.1 $e |- H e. CH $.
    pjop.2 $e |- A e. ~H $.
    $( Orthocomplement projection in terms of projection. $)
    pjopi $p |- ( ( proj ` ( _|_ ` H ) ) ` A ) =
               ( A -h ( ( proj ` H ) ` A ) ) $=
      cH cch wcel cA chil wcel cA cH cort cfv cpj cfv cfv cA cA cH cpj cfv cfv
      cmv co wceq pjop.1 pjop.2 cA cH pjop mp2an $.
      $( [31-Oct-1999] $)

    $( Projection in terms of orthocomplement projection. $)
    pjpoi $p |- ( ( proj ` H ) ` A ) =
               ( A -h ( ( proj ` ( _|_ ` H ) ) ` A ) ) $=
      cH cch wcel cA chil wcel cA cH cpj cfv cfv cA cA cH cort cfv cpj cfv cfv
      cmv co wceq pjop.1 pjop.2 cA cH pjpo mp2an $.
      $( [31-Oct-1999] $)

    $( Projection of a vector in the orthocomplement of the projection
       subspace. $)
    pjoc1i $p |- ( A e. H <-> ( ( proj ` ( _|_ ` H ) ) ` A ) = 0h ) $=
      cA cH wcel cA cH cort cfv cpj cfv cfv c0v wceq cA cH wcel cA cH cort cfv
      cpj cfv cfv c0h wcel cA cH cort cfv cpj cfv cfv c0v wceq cA cH wcel cA cH
      cort cfv cpj cfv cfv cH cH cort cfv cin c0h cA cH wcel cA cH cort cfv cpj
      cfv cfv cH wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel wa cA cH cort
      cfv cpj cfv cfv cH cH cort cfv cin wcel cA cH wcel cA cH cort cfv cpj cfv
      cfv cH wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel cA cH wcel cA cA
      cH cpj cfv cfv cmv co cH cA cH cort cfv cpj cfv cfv cA cH wcel cA cH cpj
      cfv cfv cH wcel cA cA cH cpj cfv cfv cmv co cH wcel cA cH pjop.1 pjop.2
      pjclii cH csh wcel cA cH wcel cA cH cpj cfv cfv cH wcel wa cA cA cH cpj
      cfv cfv cmv co cH wcel wi cH pjop.1 chshii cA cA cH cpj cfv cfv cH
      shsubclOLD ax-mp mpan2 cA cH pjop.1 pjop.2 pjopi syl5eqel cA cH cort cfv
      cH pjop.1 choccli pjop.2 pjclii jctir cA cH cort cfv cpj cfv cfv cH cH
      cort cfv elin sylibr cH csh wcel cH cH cort cfv cin c0h wceq cH pjop.1
      chshii cH ocin ax-mp syl6eleq cA cH cort cfv cpj cfv cfv elch0 sylib cA
      cH cort cfv cpj cfv cfv c0v wceq cA cA cH cpj cfv cfv cH cA cH cort cfv
      cpj cfv cfv c0v wceq cA cA cH cpj cfv cfv c0v cva co cA cH cpj cfv cfv cA
      cH cort cfv cpj cfv cfv c0v wceq cA cH cpj cfv cfv cA cH cort cfv cpj cfv
      cfv cva co cA cH cpj cfv cfv c0v cva co cA cA cH cort cfv cpj cfv cfv c0v
      cA cH cpj cfv cfv cva opreq2 cA cH pjop.1 pjop.2 pjpji syl5eq cA cH cpj
      cfv cfv chil wcel cA cH cpj cfv cfv c0v cva co cA cH cpj cfv cfv wceq cA
      cH pjop.1 pjop.2 pjhclii cA cH cpj cfv cfv ax-hvaddid ax-mp syl6eq cA cH
      pjop.1 pjop.2 pjclii syl6eqel impbii $.
      $( [27-Oct-1999] $)

    $( Projection of a vector in the projection subspace.  Lemma 4.4(ii) of
       [Beran] p. 111. $)
    pjchi $p |- ( A e. H <-> ( ( proj ` H ) ` A ) = A ) $=
      cA cH wcel cA cH cpj cfv cfv cA wceq cA cH wcel cA cH cpj cfv cfv c0v cva
      co cA cA cH cpj cfv cfv cA cH wcel cA cH cpj cfv cfv cA cH cort cfv cpj
      cfv cfv cva co cA cH cpj cfv cfv c0v cva co cA cA cH wcel cA cH cort cfv
      cpj cfv cfv c0v cA cH cpj cfv cfv cva cA cH wcel cA cH cort cfv cpj cfv
      cfv c0v wceq cA cH pjop.1 pjop.2 pjoc1i biimpi opreq2d cA cH pjop.1
      pjop.2 pjpji syl5req cA cH cpj cfv cfv chil wcel cA cH cpj cfv cfv c0v
      cva co cA cH cpj cfv cfv wceq cA cH pjop.1 pjop.2 pjhclii cA cH cpj cfv
      cfv ax-hvaddid ax-mp syl5eqr cA cH cpj cfv cfv cA wceq cA cH cpj cfv cfv
      cH wcel cA cH wcel cA cH pjop.1 pjop.2 pjclii cA cH cpj cfv cfv cA cH
      eleq1 mpbii impbii $.
      $( [27-Oct-1999] $)
  $}

  $( The part of a vector that belongs to the orthocomplemented space. $)
  pjoccl $p |- ( ( H e. CH /\ A e. ~H ) ->
          ( A -h ( ( proj ` H ) ` A ) ) e. ( _|_ ` H ) ) $=
    cH cch wcel cA chil wcel wa cA cH cort cfv cpj cfv cfv cA cA cH cpj cfv cfv
    cmv co cH cort cfv cA cH pjop cH cort cfv cch wcel cA chil wcel cA cH cort
    cfv cpj cfv cfv cH cort cfv wcel cH cch wcel cA cH cort cfv axpjcl cH
    choccl sylan eqeltrrd $.
    $( [11-May-2006] $) $( [11-Apr-2006] $)

  $( Projection of a vector in the orthocomplement of the projection
     subspace. $)
  pjoc1 $p |- ( ( H e. CH /\ A e. ~H ) ->
               ( A e. H <-> ( ( proj ` ( _|_ ` H ) ) ` A ) = 0h ) ) $=
    cH cch wcel cA chil wcel cA cH wcel cA cH cort cfv cpj cfv cfv c0v wceq wb
    cA cH cch wcel cH chil cif wcel cA cH cch wcel cH chil cif cort cfv cpj cfv
    cfv c0v wceq wb cA chil wcel cA c0v cif cH cch wcel cH chil cif wcel cA
    chil wcel cA c0v cif cH cch wcel cH chil cif cort cfv cpj cfv cfv c0v wceq
    wb cH cA chil c0v cH cH cch wcel cH chil cif wceq cA cH wcel cA cH cch wcel
    cH chil cif wcel cA cH cort cfv cpj cfv cfv c0v wceq cA cH cch wcel cH chil
    cif cort cfv cpj cfv cfv c0v wceq cH cH cch wcel cH chil cif cA eleq2 cH cH
    cch wcel cH chil cif wceq cA cH cort cfv cpj cfv cfv cA cH cch wcel cH chil
    cif cort cfv cpj cfv cfv c0v cH cH cch wcel cH chil cif wceq cA cH cort cfv
    cpj cfv cH cch wcel cH chil cif cort cfv cpj cfv cH cH cch wcel cH chil cif
    wceq cH cort cfv cH cch wcel cH chil cif cort cfv cpj cH cH cch wcel cH
    chil cif cort fveq2 fveq2d fveq1d eqeq1d bibi12d cA cA chil wcel cA c0v cif
    wceq cA cH cch wcel cH chil cif wcel cA chil wcel cA c0v cif cH cch wcel cH
    chil cif wcel cA cH cch wcel cH chil cif cort cfv cpj cfv cfv c0v wceq cA
    chil wcel cA c0v cif cH cch wcel cH chil cif cort cfv cpj cfv cfv c0v wceq
    cA cA chil wcel cA c0v cif cH cch wcel cH chil cif eleq1 cA cA chil wcel cA
    c0v cif wceq cA cH cch wcel cH chil cif cort cfv cpj cfv cfv cA chil wcel
    cA c0v cif cH cch wcel cH chil cif cort cfv cpj cfv cfv c0v cA cA chil wcel
    cA c0v cif cH cch wcel cH chil cif cort cfv cpj cfv fveq2 eqeq1d bibi12d cA
    chil wcel cA c0v cif cH cch wcel cH chil cif cH chil cch helch elimel cA
    c0v chil ax-hv0cl elimel pjoc1i dedth2h $.
    $( [6-Nov-1999] $)

  ${
    $d x A $.  $d x B $.
    pjoml.1 $e |- A e. CH $.
    pjoml.2 $e |- B e. SH $.
    $( Subspace form of orthomodular law in the Hilbert lattice.  Compare the
       orthomodular law in Theorem 2(ii) of [Kalmbach] p. 22.  Derived using
       projections; compare ~ omlsi . $)
    pjomli $p |- ( ( A C_ B /\ ( B i^i ( _|_ ` A ) ) = 0H ) -> A = B ) $=
      cA cB pjoml.1 pjoml.2 omlsi $.
      $( [6-Nov-1999] $)
  $}

  $( Subspace form of orthomodular law in the Hilbert lattice.  Compare the
     orthomodular law in Theorem 2(ii) of [Kalmbach] p. 22.  Derived using
     projections; compare ~ omlsi . $)
  pjoml $p |- ( ( ( A e. CH /\ B e. SH ) /\
               ( A C_ B /\ ( B i^i ( _|_ ` A ) ) = 0H ) ) -> A = B ) $=
    cA cch wcel cB csh wcel wa cA cB wss cB cA cort cfv cin c0h wceq wa cA cB
    wceq cA cch wcel cB csh wcel cA cB wss cB cA cort cfv cin c0h wceq wa cA cB
    wceq wi cA cch wcel cA c0h cif cB wss cB cA cch wcel cA c0h cif cort cfv
    cin c0h wceq wa cA cch wcel cA c0h cif cB wceq wi cA cch wcel cA c0h cif cB
    csh wcel cB c0h cif wss cB csh wcel cB c0h cif cA cch wcel cA c0h cif cort
    cfv cin c0h wceq wa cA cch wcel cA c0h cif cB csh wcel cB c0h cif wceq wi
    cA cB c0h c0h cA cA cch wcel cA c0h cif wceq cA cB wss cB cA cort cfv cin
    c0h wceq wa cA cch wcel cA c0h cif cB wss cB cA cch wcel cA c0h cif cort
    cfv cin c0h wceq wa cA cB wceq cA cch wcel cA c0h cif cB wceq cA cA cch
    wcel cA c0h cif wceq cA cB wss cA cch wcel cA c0h cif cB wss cB cA cort cfv
    cin c0h wceq cB cA cch wcel cA c0h cif cort cfv cin c0h wceq cA cA cch wcel
    cA c0h cif cB sseq1 cA cA cch wcel cA c0h cif wceq cB cA cort cfv cin cB cA
    cch wcel cA c0h cif cort cfv cin c0h cA cA cch wcel cA c0h cif wceq cA cort
    cfv cA cch wcel cA c0h cif cort cfv cB cA cA cch wcel cA c0h cif cort fveq2
    ineq2d eqeq1d anbi12d cA cA cch wcel cA c0h cif cB eqeq1 imbi12d cB cB csh
    wcel cB c0h cif wceq cA cch wcel cA c0h cif cB wss cB cA cch wcel cA c0h
    cif cort cfv cin c0h wceq wa cA cch wcel cA c0h cif cB csh wcel cB c0h cif
    wss cB csh wcel cB c0h cif cA cch wcel cA c0h cif cort cfv cin c0h wceq wa
    cA cch wcel cA c0h cif cB wceq cA cch wcel cA c0h cif cB csh wcel cB c0h
    cif wceq cB cB csh wcel cB c0h cif wceq cA cch wcel cA c0h cif cB wss cA
    cch wcel cA c0h cif cB csh wcel cB c0h cif wss cB cA cch wcel cA c0h cif
    cort cfv cin c0h wceq cB csh wcel cB c0h cif cA cch wcel cA c0h cif cort
    cfv cin c0h wceq cB cB csh wcel cB c0h cif cA cch wcel cA c0h cif sseq2 cB
    cB csh wcel cB c0h cif wceq cB cA cch wcel cA c0h cif cort cfv cin cB csh
    wcel cB c0h cif cA cch wcel cA c0h cif cort cfv cin c0h cB cB csh wcel cB
    c0h cif cA cch wcel cA c0h cif cort cfv ineq1 eqeq1d anbi12d cB cB csh wcel
    cB c0h cif cA cch wcel cA c0h cif eqeq2 imbi12d cA cch wcel cA c0h cif cB
    csh wcel cB c0h cif cA c0h cch h0elch elimel cB c0h csh h0elsh elimel
    pjomli dedth2h imp $.
    $( [14-Jun-2006] $) $( [14-Jun-2006] $)

  ${
    pjococ.1 $e |- H e. CH $.
    $( Proof of orthocomplement theorem using projections.  Compare ~ococ . $)
    pjococi $p |- ( _|_ ` ( _|_ ` H ) ) = H $=
      cH pjococ.1 ococi $.
      $( [5-Nov-1999] $)
  $}

  ${
    pjoc2.1 $e |- H e. CH $.
    pjoc2.2 $e |- A e. ~H $.
    $( Projection of a vector in the orthocomplement of the projection
       subspace.  Lemma 4.4(iii) of [Beran] p. 111. $)
    pjoc2i $p |- ( A e. ( _|_ ` H ) <-> ( ( proj ` H ) ` A ) = 0h ) $=
      cA cH cort cfv wcel cA cH cort cfv cort cfv cpj cfv cfv c0v wceq cA cH
      cpj cfv cfv c0v wceq cA cH cort cfv cH pjoc2.1 choccli pjoc2.2 pjoc1i cA
      cH cort cfv cort cfv cpj cfv cfv cA cH cpj cfv cfv c0v cA cH cort cfv
      cort cfv cpj cfv cH cpj cfv cH cort cfv cort cfv cH cpj cH pjoc2.1
      pjococi fveq2i fveq1i eqeq1i bitri $.
      $( [27-Oct-1999] $)
  $}

  $( Projection of a vector in the orthocomplement of the projection
     subspace.  Lemma 4.4(iii) of [Beran] p. 111. $)
  pjoc2 $p |- ( ( H e. CH /\ A e. ~H ) ->
               ( A e. ( _|_ ` H ) <-> ( ( proj ` H ) ` A ) = 0h ) ) $=
    cH cch wcel cA chil wcel cA cH cort cfv wcel cA cH cpj cfv cfv c0v wceq wb
    cA cH cch wcel cH c0h cif cort cfv wcel cA cH cch wcel cH c0h cif cpj cfv
    cfv c0v wceq wb cA chil wcel cA c0v cif cH cch wcel cH c0h cif cort cfv
    wcel cA chil wcel cA c0v cif cH cch wcel cH c0h cif cpj cfv cfv c0v wceq wb
    cH cA c0h c0v cH cH cch wcel cH c0h cif wceq cA cH cort cfv wcel cA cH cch
    wcel cH c0h cif cort cfv wcel cA cH cpj cfv cfv c0v wceq cA cH cch wcel cH
    c0h cif cpj cfv cfv c0v wceq cH cH cch wcel cH c0h cif wceq cH cort cfv cH
    cch wcel cH c0h cif cort cfv cA cH cH cch wcel cH c0h cif cort fveq2 eleq2d
    cH cH cch wcel cH c0h cif wceq cA cH cpj cfv cfv cA cH cch wcel cH c0h cif
    cpj cfv cfv c0v cH cH cch wcel cH c0h cif wceq cA cH cpj cfv cH cch wcel cH
    c0h cif cpj cfv cH cH cch wcel cH c0h cif cpj fveq2 fveq1d eqeq1d bibi12d
    cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH c0h cif cort cfv wcel cA
    chil wcel cA c0v cif cH cch wcel cH c0h cif cort cfv wcel cA cH cch wcel cH
    c0h cif cpj cfv cfv c0v wceq cA chil wcel cA c0v cif cH cch wcel cH c0h cif
    cpj cfv cfv c0v wceq cA cA chil wcel cA c0v cif cH cch wcel cH c0h cif cort
    cfv eleq1 cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH c0h cif cpj cfv
    cfv cA chil wcel cA c0v cif cH cch wcel cH c0h cif cpj cfv cfv c0v cA cA
    chil wcel cA c0v cif cH cch wcel cH c0h cif cpj cfv fveq2 eqeq1d bibi12d cA
    chil wcel cA c0v cif cH cch wcel cH c0h cif cH c0h cch h0elch elimel cA c0v
    chil ax-hv0cl elimel pjoc2i dedth2h $.
    $( [13-May-2006] $) $( [24-Apr-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Subspace sum, span, lattice join, lattice supremum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u $.
    $( Define subspace sum in ` SH ` .  See ~ shsumval , ~ shsumval2i , and
       ~ shsumval3i for its value. $)
    df-shsum $a |- +H = { <. <. x , y >. , z >. | ( ( x e. SH /\ y e. SH ) /\
                 z = { w e. ~H | E. v e. x E. u e. y w = ( v +h u ) } ) } $.

    $( Define the linear span of a subset of Hilbert space.  Definition
       of span in [Schechter] p. 276.  See ~ spanval for its value. $)
    df-span $a |- span = { <. x , y >. | ( x C_ ~H /\
                   y = |^| { z e. SH | x C_ z } ) } $.

    $( Define Hilbert lattice join.  See ~ chjval for its value and
       ~ chjcl for its closure law.  Note that we define it over all Hilbert
       space subsets to allow proving more general theorems.  Even for general
       subsets the join belongs to ` CH ` ; see ~ sshjcl .  For an alternate
       definition see ~ dfchj2 . $)
    df-chj $a |- vH = { <. <. x , y >. , z >. | ( ( x C_ ~H /\ y C_ ~H ) /\
               z = ( _|_ ` ( _|_ ` ( x u. y ) ) ) ) } $.

    $( Define the supremum of a set of Hilbert lattice elements.  See
       ~ chsupval2 for its value and ~ dfchsup2 for an alternate definition.
       We actually define the supremum for an arbitrary collection of Hilbert
       space subsets, not just elements of the Hilbert lattice ` CH ` , to
       allow more general theorems.  Even for general subsets the supremum
       still a Hilbert lattice element; see ~ hsupcl . $)
    df-chsup $a |- \/H = { <. x , y >. | ( x C_ ~P ~H /\
                   y = ( _|_ ` ( _|_ ` U. x ) ) ) } $.

  $}

  ${
    $d x y z w f g v u A $.  $d x y z w f g v u B $.  $d x y z C $.
    $d x y D $.
    $( Value of subspace sum of two Hilbert space subspaces.  Definition of
       subspace sum in [Kalmbach] p. 65. $)
    shsumval $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) =
        { x e. ~H | E. y e. A E. z e. B x = ( y +h z ) } ) $=
      vw vv vu cA cB csh csh vx cv vy cv vz cv cva co wceq vz vv cv wrex vy vw
      cv wrex vx chil crab vx cv vy cv vz cv cva co wceq vz cB wrex vy cA wrex
      vx chil crab cph vx cv vy cv vz cv cva co wceq vz vv cv wrex vy cA wrex
      vx chil crab vx cv vy cv vz cv cva co wceq vz cB wrex vy cA wrex vx chil
      ax-hilex rabex vw cv cA wceq vx cv vy cv vz cv cva co wceq vz vv cv wrex
      vy vw cv wrex vx cv vy cv vz cv cva co wceq vz vv cv wrex vy cA wrex vx
      chil vx cv vy cv vz cv cva co wceq vz vv cv wrex vy vw cv cA rexeq1
      rabbisdv vv cv cB wceq vx cv vy cv vz cv cva co wceq vz vv cv wrex vy cA
      wrex vx cv vy cv vz cv cva co wceq vz cB wrex vy cA wrex vx chil vv cv cB
      wceq vx cv vy cv vz cv cva co wceq vz vv cv wrex vx cv vy cv vz cv cva co
      wceq vz cB wrex vy cA vx cv vy cv vz cv cva co wceq vz vv cv cB rexeq1
      rexbidv rabbisdv vw vv vu vx vy vz df-shsum oprabval2 $.
      $( [16-Oct-1999] $)

    $( Membership in the subspace sum of two Hilbert subspaces. $)
    shsel $p |- ( ( A e. SH /\ B e. SH ) -> ( C e. ( A +H B ) <->
                 E. x e. A E. y e. B C = ( x +h y ) ) ) $=
      cA csh wcel cB csh wcel wa cC cA cB cph co wcel cC chil wcel cC vx cv vy
      cv cva co wceq vy cB wrex vx cA wrex wa cC vx cv vy cv cva co wceq vy cB
      wrex vx cA wrex cA csh wcel cB csh wcel wa cC cA cB cph co wcel cC vz cv
      vx cv vy cv cva co wceq vy cB wrex vx cA wrex vz chil crab wcel cC chil
      wcel cC vx cv vy cv cva co wceq vy cB wrex vx cA wrex wa cA csh wcel cB
      csh wcel wa cA cB cph co vz cv vx cv vy cv cva co wceq vy cB wrex vx cA
      wrex vz chil crab cC vz vx vy cA cB shsumval eleq2d vz cv vx cv vy cv cva
      co wceq vy cB wrex vx cA wrex cC vx cv vy cv cva co wceq vy cB wrex vx cA
      wrex vz cC chil vz cv cC wceq vz cv vx cv vy cv cva co wceq cC vx cv vy
      cv cva co wceq vx vy cA cB vz cv cC vx cv vy cv cva co eqeq1 2rexbidv
      elrab syl6bb cA csh wcel cB csh wcel wa cC vx cv vy cv cva co wceq vy cB
      wrex vx cA wrex cC chil wcel cA csh wcel cB csh wcel wa cC vx cv vy cv
      cva co wceq cC chil wcel vx vy cA cB cA csh wcel cB csh wcel wa vx cv cA
      wcel vy cv cB wcel wa vx cv chil wcel vy cv chil wcel wa cC vx cv vy cv
      cva co wceq cC chil wcel wi cA csh wcel vx cv cA wcel vx cv chil wcel cB
      csh wcel vy cv cB wcel vy cv chil wcel cA csh wcel cA chil vx cv cA shss
      sseld cB csh wcel cB chil vy cv cB shss sseld im2anan9 vx cv chil wcel vy
      cv chil wcel wa vx cv vy cv cva co chil wcel cC vx cv vy cv cva co wceq
      cC chil wcel wi vx cv vy cv hvaddcl vx cv vy cv cva co chil cC eleq1a syl
      syl6 r19.23advv pm4.71rd bitr4d $.
      $( [16-Dec-2004] $) $( [14-Dec-2004] $)

    $( Membership in the subspace sum of two Hilbert subspaces, using vector
       subtraction. $)
    shsel3 $p |- ( ( A e. SH /\ B e. SH ) -> ( C e. ( A +H B ) <->
                 E. x e. A E. y e. B C = ( x -h y ) ) ) $=
      cA csh wcel cB csh wcel wa cC cA cB cph co wcel cC vx cv vz cv cva co
      wceq vz cB wrex vx cA wrex cC vx cv vy cv cmv co wceq vy cB wrex vx cA
      wrex vx vz cA cB cC shsel cA csh wcel cB csh wcel wa cC vx cv vz cv cva
      co wceq vz cB wrex cC vx cv vy cv cmv co wceq vy cB wrex vx cA cA csh
      wcel cB csh wcel wa vx cv cA wcel wa cC vx cv vz cv cva co wceq vz cB
      wrex cC vx cv vy cv cmv co wceq vy cB wrex cA csh wcel cB csh wcel wa vx
      cv cA wcel wa cC vx cv vz cv cva co wceq cC vx cv vy cv cmv co wceq vy cB
      wrex vz cB cA csh wcel cB csh wcel wa vx cv cA wcel wa vz cv cB wcel wa
      cC vx cv vz cv cva co wceq cC vx cv vy cv cmv co wceq vy cB wrex cA csh
      wcel cB csh wcel wa vx cv cA wcel wa vz cv cB wcel wa cC vx cv vz cv cva
      co wceq cC vx cv c1 cneg vz cv csm co cmv co wceq cC vx cv vy cv cmv co
      wceq vy cB wrex cC vx cv vz cv cva co wceq cA csh wcel cB csh wcel wa vx
      cv cA wcel wa vz cv cB wcel wa cC vx cv vz cv cva co vx cv c1 cneg vz cv
      csm co cmv co cC vx cv vz cv cva co wceq id cA csh wcel cB csh wcel wa vx
      cv cA wcel vz cv cB wcel vx cv vz cv cva co vx cv c1 cneg vz cv csm co
      cmv co wceq cA csh wcel vx cv cA wcel cB csh wcel vz cv cB wcel vx cv vz
      cv cva co vx cv c1 cneg vz cv csm co cmv co wceq vx cv chil wcel vz cv
      chil wcel vx cv vz cv cva co vx cv c1 cneg vz cv csm co cmv co wceq cA
      csh wcel vx cv cA wcel wa cB csh wcel vz cv cB wcel wa vx cv vz cv
      hvaddsubval vx cv cA shel vz cv cB shel syl2an an4s anassrs sylan9eqr c1
      cneg vz cv csm co cB wcel cC vx cv c1 cneg vz cv csm co cmv co wceq cC vx
      cv vy cv cmv co wceq vy cB wrex cA csh wcel cB csh wcel wa vx cv cA wcel
      wa vz cv cB wcel wa cC vx cv vy cv cmv co wceq cC vx cv c1 cneg vz cv csm
      co cmv co wceq vy c1 cneg vz cv csm co cB vy cv c1 cneg vz cv csm co wceq
      vx cv vy cv cmv co vx cv c1 cneg vz cv csm co cmv co cC vy cv c1 cneg vz
      cv csm co vx cv cmv opreq2 eqeq2d rcla4ev cA csh wcel cB csh wcel wa vz
      cv cB wcel c1 cneg vz cv csm co cB wcel vx cv cA wcel cB csh wcel vz cv
      cB wcel c1 cneg vz cv csm co cB wcel cA csh wcel cB csh wcel c1 cneg cc
      wcel vz cv cB wcel c1 cneg vz cv csm co cB wcel c1 ax1cn negcli c1 cneg
      vz cv cB shmulcl mp3an2 adantll adantlr sylan syldan ex r19.23adva cA csh
      wcel cB csh wcel wa vx cv cA wcel wa cC vx cv vy cv cmv co wceq cC vx cv
      vz cv cva co wceq vz cB wrex vy cB cA csh wcel cB csh wcel wa vx cv cA
      wcel wa vy cv cB wcel wa cC vx cv vy cv cmv co wceq cC vx cv vz cv cva co
      wceq vz cB wrex cA csh wcel cB csh wcel wa vx cv cA wcel wa vy cv cB wcel
      wa cC vx cv vy cv cmv co wceq cC vx cv c1 cneg vy cv csm co cva co wceq
      cC vx cv vz cv cva co wceq vz cB wrex cC vx cv vy cv cmv co wceq cA csh
      wcel cB csh wcel wa vx cv cA wcel wa vy cv cB wcel wa cC vx cv vy cv cmv
      co vx cv c1 cneg vy cv csm co cva co cC vx cv vy cv cmv co wceq id cA csh
      wcel cB csh wcel wa vx cv cA wcel vy cv cB wcel vx cv vy cv cmv co vx cv
      c1 cneg vy cv csm co cva co wceq cA csh wcel vx cv cA wcel cB csh wcel vy
      cv cB wcel vx cv vy cv cmv co vx cv c1 cneg vy cv csm co cva co wceq vx
      cv chil wcel vy cv chil wcel vx cv vy cv cmv co vx cv c1 cneg vy cv csm
      co cva co wceq cA csh wcel vx cv cA wcel wa cB csh wcel vy cv cB wcel wa
      vx cv vy cv hvsubval vx cv cA shel vy cv cB shel syl2an an4s anassrs
      sylan9eqr c1 cneg vy cv csm co cB wcel cC vx cv c1 cneg vy cv csm co cva
      co wceq cC vx cv vz cv cva co wceq vz cB wrex cA csh wcel cB csh wcel wa
      vx cv cA wcel wa vy cv cB wcel wa cC vx cv vz cv cva co wceq cC vx cv c1
      cneg vy cv csm co cva co wceq vz c1 cneg vy cv csm co cB vz cv c1 cneg vy
      cv csm co wceq vx cv vz cv cva co vx cv c1 cneg vy cv csm co cva co cC vz
      cv c1 cneg vy cv csm co vx cv cva opreq2 eqeq2d rcla4ev cA csh wcel cB
      csh wcel wa vy cv cB wcel c1 cneg vy cv csm co cB wcel vx cv cA wcel cB
      csh wcel vy cv cB wcel c1 cneg vy cv csm co cB wcel cA csh wcel cB csh
      wcel c1 cneg cc wcel vy cv cB wcel c1 cneg vy cv csm co cB wcel c1 ax1cn
      negcli c1 cneg vy cv cB shmulcl mp3an2 adantll adantlr sylan syldan ex
      r19.23adva impbid rexbidva bitrd $.
      $( [23-Feb-2007] $) $( [20-Jan-2007] $)

    ${
      shscl.1 $e |- A e. SH $.
      shscl.2 $e |- B e. SH $.
      $( Membership in subspace sum. $)
      shseli $p |- ( C e. ( A +H B )
                 <-> E. x e. A E. y e. B C = ( x +h y ) ) $=
        cA csh wcel cB csh wcel cC cA cB cph co wcel cC vx cv vy cv cva co wceq
        vy cB wrex vx cA wrex wb shscl.1 shscl.2 vx vy cA cB cC shsel mp2an $.
        $( [4-May-2000] $)

      $( Closure of subspace sum. $)
      shscli $p |- ( A +H B ) e. SH $=
        cA cB cph co csh wcel cA cB cph co chil wss c0v cA cB cph co wcel wa vx
        cv vy cv cva co cA cB cph co wcel vy cA cB cph co wral vx cA cB cph co
        wral vx cv vy cv csm co cA cB cph co wcel vy cA cB cph co wral vx cc
        wral wa vx vy cA cB cph co sh cA cB cph co chil wss c0v cA cB cph co
        wcel cA cB cph co vz cv vx cv vy cv cva co wceq vy cB wrex vx cA wrex
        vz chil crab chil cA csh wcel cB csh wcel cA cB cph co vz cv vx cv vy
        cv cva co wceq vy cB wrex vx cA wrex vz chil crab wceq shscl.1 shscl.2
        vz vx vy cA cB shsumval mp2an vz cv vx cv vy cv cva co wceq vy cB wrex
        vx cA wrex vz chil ssrab2 eqsstri c0v cA cB cph co wcel c0v vx cv vy cv
        cva co wceq vy cB wrex vx cA wrex c0v cA wcel c0v cB wcel c0v c0v c0v
        cva co wceq c0v vx cv vy cv cva co wceq vy cB wrex vx cA wrex cA csh
        wcel c0v cA wcel shscl.1 cA sh0 ax-mp cB csh wcel c0v cB wcel shscl.2
        cB sh0 ax-mp c0v c0v cva co c0v c0v ax-hv0cl hvaddid2i eqcomi vx vy cA
        cB c0v c0v c0v cva rcla4eopr mp3an vx vy cA cB c0v shscl.1 shscl.2
        shseli mpbir pm3.2i vx cv vy cv cva co cA cB cph co wcel vy cA cB cph
        co wral vx cA cB cph co wral vx cv vy cv csm co cA cB cph co wcel vy cA
        cB cph co wral vx cc wral vx cv vy cv cva co cA cB cph co wcel vx vy cA
        cB cph co vx cv vz cv vw cv cva co wceq vw cB wrex vz cA wrex vy cv vv
        cv vu cv cva co wceq vu cB wrex vv cA wrex wa vx cv vy cv cva co vf cv
        vg cv cva co wceq vg cB wrex vf cA wrex vx cv cA cB cph co wcel vy cv
        cA cB cph co wcel wa vx cv vy cv cva co cA cB cph co wcel vx cv vz cv
        vw cv cva co wceq vw cB wrex vz cA wrex vy cv vv cv vu cv cva co wceq
        vu cB wrex vv cA wrex vx cv vy cv cva co vf cv vg cv cva co wceq vg cB
        wrex vf cA wrex vx cv vz cv vw cv cva co wceq vy cv vv cv vu cv cva co
        wceq vu cB wrex vv cA wrex vx cv vy cv cva co vf cv vg cv cva co wceq
        vg cB wrex vf cA wrex wi vz vw cA cB vy cv vv cv vu cv cva co wceq vu
        cB wrex vv cA wrex vz cv cA wcel vw cv cB wcel wa vx cv vz cv vw cv cva
        co wceq vx cv vy cv cva co vf cv vg cv cva co wceq vg cB wrex vf cA
        wrex vy cv vv cv vu cv cva co wceq vz cv cA wcel vw cv cB wcel wa vx cv
        vz cv vw cv cva co wceq vx cv vy cv cva co vf cv vg cv cva co wceq vg
        cB wrex vf cA wrex wi wi vv vu cA cB vv cv cA wcel vu cv cB wcel wa vy
        cv vv cv vu cv cva co wceq vz cv cA wcel vw cv cB wcel wa vx cv vz cv
        vw cv cva co wceq vx cv vy cv cva co vf cv vg cv cva co wceq vg cB wrex
        vf cA wrex vz cv cA wcel vw cv cB wcel wa vx cv vz cv vw cv cva co wceq
        wa vv cv cA wcel vu cv cB wcel wa vy cv vv cv vu cv cva co wceq wa vx
        cv vy cv cva co vf cv vg cv cva co wceq vg cB wrex vf cA wrex vz cv vv
        cv cva co cA wcel vw cv vu cv cva co cB wcel vx cv vy cv cva co vz cv
        vv cv cva co vw cv vu cv cva co cva co wceq vx cv vy cv cva co vf cv vg
        cv cva co wceq vg cB wrex vf cA wrex vz cv cA wcel vw cv cB wcel wa vx
        cv vz cv vw cv cva co wceq wa vv cv cA wcel vu cv cB wcel wa vy cv vv
        cv vu cv cva co wceq wa wa vf vg cA cB vz cv vv cv cva co vw cv vu cv
        cva co vx cv vy cv cva co cva rcla4eopr vz cv cA wcel vw cv cB wcel wa
        vv cv cA wcel vu cv cB wcel wa vz cv vv cv cva co cA wcel vx cv vz cv
        vw cv cva co wceq vy cv vv cv vu cv cva co wceq vz cv cA wcel vv cv cA
        wcel vz cv vv cv cva co cA wcel vw cv cB wcel vu cv cB wcel cA csh wcel
        vz cv cA wcel vv cv cA wcel wa vz cv vv cv cva co cA wcel wi shscl.1 vz
        cv vv cv cA shaddclOLD ax-mp ad2ant2r ad2ant2r vz cv cA wcel vw cv cB
        wcel wa vv cv cA wcel vu cv cB wcel wa vw cv vu cv cva co cB wcel vx cv
        vz cv vw cv cva co wceq vy cv vv cv vu cv cva co wceq vw cv cB wcel vu
        cv cB wcel vw cv vu cv cva co cB wcel vz cv cA wcel vv cv cA wcel cB
        csh wcel vw cv cB wcel vu cv cB wcel wa vw cv vu cv cva co cB wcel wi
        shscl.2 vw cv vu cv cB shaddclOLD ax-mp ad2ant2l ad2ant2r vz cv cA wcel
        vw cv cB wcel wa vx cv vz cv vw cv cva co wceq wa vv cv cA wcel vu cv
        cB wcel wa vy cv vv cv vu cv cva co wceq wa wa vx cv vy cv cva co vz cv
        vw cv cva co vv cv vu cv cva co cva co vz cv vv cv cva co vw cv vu cv
        cva co cva co vx cv vz cv vw cv cva co wceq vy cv vv cv vu cv cva co
        wceq vx cv vy cv cva co vz cv vw cv cva co vv cv vu cv cva co cva co
        wceq vz cv cA wcel vw cv cB wcel wa vv cv cA wcel vu cv cB wcel wa vx
        cv vz cv vw cv cva co vy cv vv cv vu cv cva co cva opreq12 ad2ant2l vz
        cv cA wcel vw cv cB wcel wa vv cv cA wcel vu cv cB wcel wa vz cv vv cv
        cva co vw cv vu cv cva co cva co vz cv vw cv cva co vv cv vu cv cva co
        cva co wceq vx cv vz cv vw cv cva co wceq vy cv vv cv vu cv cva co wceq
        vz cv cA wcel vv cv cA wcel vw cv cB wcel vu cv cB wcel vz cv vv cv cva
        co vw cv vu cv cva co cva co vz cv vw cv cva co vv cv vu cv cva co cva
        co wceq vz cv chil wcel vv cv chil wcel wa vw cv chil wcel vu cv chil
        wcel wa vz cv vv cv cva co vw cv vu cv cva co cva co vz cv vw cv cva co
        vv cv vu cv cva co cva co wceq vz cv cA wcel vv cv cA wcel wa vw cv cB
        wcel vu cv cB wcel wa vz cv vv cv vw cv vu cv hvadd4 vz cv cA wcel vz
        cv chil wcel vv cv cA wcel vv cv chil wcel vz cv cA shscl.1 sheli vv cv
        cA shscl.1 sheli anim12i vw cv cB wcel vw cv chil wcel vu cv cB wcel vu
        cv chil wcel vw cv cB shscl.2 sheli vu cv cB shscl.2 sheli anim12i
        syl2an an4s ad2ant2r eqtr4d syl3anc ancoms exp43 r19.23aivv com3l
        r19.23aivv imp vx cv cA cB cph co wcel vx cv vz cv vw cv cva co wceq vw
        cB wrex vz cA wrex vy cv cA cB cph co wcel vy cv vv cv vu cv cva co
        wceq vu cB wrex vv cA wrex vz vw cA cB vx cv shscl.1 shscl.2 shseli vv
        vu cA cB vy cv shscl.1 shscl.2 shseli anbi12i vf vg cA cB vx cv vy cv
        cva co shscl.1 shscl.2 shseli 3imtr4i rgen2a vx cv vy cv csm co cA cB
        cph co wcel vx vy cc cA cB cph co vx cv cc wcel vy cv vv cv vu cv cva
        co wceq vu cB wrex vv cA wrex wa vx cv vy cv csm co vf cv vg cv cva co
        wceq vg cB wrex vf cA wrex vx cv cc wcel vy cv cA cB cph co wcel wa vx
        cv vy cv csm co cA cB cph co wcel vy cv vv cv vu cv cva co wceq vu cB
        wrex vv cA wrex vx cv cc wcel vx cv vy cv csm co vf cv vg cv cva co
        wceq vg cB wrex vf cA wrex vy cv vv cv vu cv cva co wceq vx cv cc wcel
        vx cv vy cv csm co vf cv vg cv cva co wceq vg cB wrex vf cA wrex wi vv
        vu cA cB vv cv cA wcel vu cv cB wcel vy cv vv cv vu cv cva co wceq vx
        cv cc wcel vx cv vy cv csm co vf cv vg cv cva co wceq vg cB wrex vf cA
        wrex wi wi vv cv cA wcel vu cv cB wcel vy cv vv cv vu cv cva co wceq vx
        cv cc wcel vx cv vy cv csm co vf cv vg cv cva co wceq vg cB wrex vf cA
        wrex vx cv cc wcel vv cv cA wcel vu cv cB wcel vy cv vv cv vu cv cva co
        wceq wa wa vx cv vy cv csm co vf cv vg cv cva co wceq vg cB wrex vf cA
        wrex vx cv vv cv csm co cA wcel vx cv vu cv csm co cB wcel vx cv vy cv
        csm co vx cv vv cv csm co vx cv vu cv csm co cva co wceq vx cv vy cv
        csm co vf cv vg cv cva co wceq vg cB wrex vf cA wrex vx cv cc wcel vv
        cv cA wcel vu cv cB wcel vy cv vv cv vu cv cva co wceq wa wa wa vf vg
        cA cB vx cv vv cv csm co vx cv vu cv csm co vx cv vy cv csm co cva
        rcla4eopr vx cv cc wcel vv cv cA wcel vx cv vv cv csm co cA wcel vu cv
        cB wcel vy cv vv cv vu cv cva co wceq wa cA csh wcel vx cv cc wcel vv
        cv cA wcel vx cv vv cv csm co cA wcel shscl.1 vx cv vv cv cA shmulcl
        mp3an1 adantrr vx cv cc wcel vu cv cB wcel vy cv vv cv vu cv cva co
        wceq wa vx cv vu cv csm co cB wcel vv cv cA wcel vx cv cc wcel vu cv cB
        wcel vx cv vu cv csm co cB wcel vy cv vv cv vu cv cva co wceq cB csh
        wcel vx cv cc wcel vu cv cB wcel vx cv vu cv csm co cB wcel shscl.2 vx
        cv vu cv cB shmulcl mp3an1 adantrr adantrl vx cv cc wcel vv cv cA wcel
        vu cv cB wcel vy cv vv cv vu cv cva co wceq wa wa wa vx cv vy cv csm co
        vx cv vv cv vu cv cva co csm co vx cv vv cv csm co vx cv vu cv csm co
        cva co vu cv cB wcel vy cv vv cv vu cv cva co wceq wa vx cv vy cv csm
        co vx cv vv cv vu cv cva co csm co wceq vx cv cc wcel vv cv cA wcel vy
        cv vv cv vu cv cva co wceq vx cv vy cv csm co vx cv vv cv vu cv cva co
        csm co wceq vu cv cB wcel vy cv vv cv vu cv cva co vx cv csm opreq2
        adantl ad2antll vx cv cc wcel vv cv cA wcel vu cv cB wcel vx cv vv cv
        vu cv cva co csm co vx cv vv cv csm co vx cv vu cv csm co cva co wceq
        vy cv vv cv vu cv cva co wceq vx cv cc wcel vv cv cA wcel vu cv cB wcel
        vx cv vv cv vu cv cva co csm co vx cv vv cv csm co vx cv vu cv csm co
        cva co wceq vx cv cc wcel vv cv chil wcel vu cv chil wcel vx cv vv cv
        vu cv cva co csm co vx cv vv cv csm co vx cv vu cv csm co cva co wceq
        vx cv cc wcel vv cv cA wcel vu cv cB wcel vx cv vv cv vu cv ax-hvdistr1
        vx cv cc wcel id vv cv cA shscl.1 sheli vu cv cB shscl.2 sheli syl3an
        3expb adantrrr eqtrd syl3anc ancoms exp42 imp r19.23aivv impcom vy cv
        cA cB cph co wcel vy cv vv cv vu cv cva co wceq vu cB wrex vv cA wrex
        vx cv cc wcel vv vu cA cB vy cv shscl.1 shscl.2 shseli anbi2i vf vg cA
        cB vx cv vy cv csm co shscl.1 shscl.2 shseli 3imtr4i rgen2 pm3.2i
        mpbir2an $.
        $( [15-Oct-1999] $)
    $}

    $( Closure of subspace sum. $)
    shscl $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) e. SH ) $=
      cA csh wcel cB csh wcel cA cB cph co csh wcel cA csh wcel cA chil cif cB
      cph co csh wcel cA csh wcel cA chil cif cB csh wcel cB chil cif cph co
      csh wcel cA cB chil chil cA cA csh wcel cA chil cif wceq cA cB cph co cA
      csh wcel cA chil cif cB cph co csh cA cA csh wcel cA chil cif cB cph
      opreq1 eleq1d cB cB csh wcel cB chil cif wceq cA csh wcel cA chil cif cB
      cph co cA csh wcel cA chil cif cB csh wcel cB chil cif cph co csh cB cB
      csh wcel cB chil cif cA csh wcel cA chil cif cph opreq2 eleq1d cA csh
      wcel cA chil cif cB csh wcel cB chil cif cA chil csh helsh elimel cB chil
      csh helsh elimel shscli dedth2h $.
      $( [3-Jan-2005] $) $( [15-Dec-2004] $)

    $( Commutative law for subspace sum. $)
    shscom $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) = ( B +H A ) ) $=
      cA csh wcel cB csh wcel wa vx cA cB cph co cB cA cph co cA csh wcel cB
      csh wcel wa vx cv vy cv vz cv cva co wceq vz cB wrex vy cA wrex vx cv vz
      cv vy cv cva co wceq vy cA wrex vz cB wrex vx cv cA cB cph co wcel vx cv
      cB cA cph co wcel cA csh wcel cB csh wcel wa vx cv vy cv vz cv cva co
      wceq vz cB wrex vy cA wrex vx cv vz cv vy cv cva co wceq vz cB wrex vy cA
      wrex vx cv vz cv vy cv cva co wceq vy cA wrex vz cB wrex cA csh wcel cB
      csh wcel wa vx cv vy cv vz cv cva co wceq vx cv vz cv vy cv cva co wceq
      vy vz cA cB cA csh wcel cB csh wcel wa vy cv cA wcel vz cv cB wcel wa wa
      vy cv vz cv cva co vz cv vy cv cva co vx cv cA csh wcel cB csh wcel wa vy
      cv cA wcel vz cv cB wcel wa wa vy cv chil wcel vz cv chil wcel wa vy cv
      vz cv cva co vz cv vy cv cva co wceq cA csh wcel vy cv cA wcel cB csh
      wcel vz cv cB wcel vy cv chil wcel vz cv chil wcel wa cA csh wcel vy cv
      cA wcel wa vy cv chil wcel cB csh wcel vz cv cB wcel wa vz cv chil wcel
      vy cv cA shel vz cv cB shel anim12i an4s vy cv vz cv ax-hvcom syl eqeq2d
      2rexbidva vx cv vz cv vy cv cva co wceq vy vz cA cB rexcom syl6bb vy vz
      cA cB vx cv shsel cB csh wcel cA csh wcel vx cv cB cA cph co wcel vx cv
      vz cv vy cv cva co wceq vy cA wrex vz cB wrex wb vz vy cB cA vx cv shsel
      ancoms 3bitr4d eqrdv $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)

    $( Vector sum belongs to subspace sum. $)
    shsva $p |- ( ( A e. SH /\ B e. SH ) -> ( ( C e. A /\ D e. B ) ->
                 ( C +h D ) e. ( A +H B ) ) ) $=
      cA csh wcel cB csh wcel wa cC cD cva co cA cB cph co wcel cC cD cva co vx
      cv vy cv cva co wceq vy cB wrex vx cA wrex cC cA wcel cD cB wcel wa vx vy
      cA cB cC cD cva co shsel cC cA wcel cD cB wcel cC cD cva co cC cD cva co
      wceq cC cD cva co vx cv vy cv cva co wceq vy cB wrex vx cA wrex cC cD cva
      co eqid vx vy cA cB cC cD cC cD cva co cva rcla4eopr mp3an3 syl5bir $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)

    $( A subspace sum contains a member of one of its subspaces. $)
    shsel1 $p |- ( ( A e. SH /\ B e. SH ) ->
                  ( C e. A -> C e. ( A +H B ) ) ) $=
      cA csh wcel cB csh wcel wa cC cA wcel cC cA cB cph co wcel cA csh wcel cB
      csh wcel wa cC cA wcel wa cC c0v cva co cC cA cB cph co cA csh wcel cC cA
      wcel cC c0v cva co cC wceq cB csh wcel cA csh wcel cC cA wcel wa cC chil
      wcel cC c0v cva co cC wceq cC cA shel cC ax-hvaddid syl adantlr cA csh
      wcel cB csh wcel wa cC cA wcel cC c0v cva co cA cB cph co wcel cA csh
      wcel cB csh wcel wa cC cA wcel c0v cB wcel cC c0v cva co cA cB cph co
      wcel cB csh wcel c0v cB wcel cA csh wcel cB sh0 adantl cA cB cC c0v shsva
      mpan2d imp eqeltrrd ex $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)

    $( A subspace sum contains a member of one of its subspaces. $)
    shsel2 $p |- ( ( A e. SH /\ B e. SH ) ->
                 ( C e. B -> C e. ( A +H B ) ) ) $=
      cA csh wcel cB csh wcel wa cC cB wcel cC cB cA cph co wcel cC cA cB cph
      co wcel cB csh wcel cA csh wcel cC cB wcel cC cB cA cph co wcel wi cB cA
      cC shsel1 ancoms cA csh wcel cB csh wcel wa cA cB cph co cB cA cph co cC
      cA cB shscom eleq2d sylibrd $.
      $( [17-Dec-2004] $) $( [15-Dec-2004] $)

    $( Vector subtraction belongs to subspace sum. $)
    shsvs $p |- ( ( A e. SH /\ B e. SH ) ->
                ( ( C e. A /\ D e. B ) -> ( C -h D ) e. ( A +H B ) ) ) $=
      cA csh wcel cB csh wcel wa cC cA cB cph co wcel cD cA cB cph co wcel cC
      cD cmv co cA cB cph co wcel cC cA wcel cD cB wcel cA csh wcel cB csh wcel
      wa cA cB cph co csh wcel cC cA cB cph co wcel cD cA cB cph co wcel wa cC
      cD cmv co cA cB cph co wcel wi cA cB shscl cC cD cA cB cph co shsubclOLD
      syl cA cB cC shsel1 cA cB cD shsel2 syl2and $.
      $( [3-Jan-2005] $) $( [15-Dec-2004] $)

    $( Subspace sum is an upper bound of its arguments. $)
    shsub1 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( A +H B ) ) $=
      cA csh wcel cB csh wcel wa vx cA cA cB cph co cA cB vx cv shsel1 ssrdv $.
      $( [16-Dec-2004] $) $( [14-Dec-2004] $)

    $( Subspace sum is an upper bound of its arguments. $)
    shsub2 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( B +H A ) ) $=
      cA csh wcel cB csh wcel wa cA cA cB cph co cB cA cph co cA cB shsub1 cA
      cB shscom sseqtrd $.
      $( [21-Dec-2004] $) $( [17-Dec-2004] $)

    $( The orthocomplement of the zero subspace is the unit subspace. $)
    choc0 $p |- ( _|_ ` 0H ) = ~H $=
      vx c0h cort cfv chil vx cv chil wcel vx cv vy cv csp co cc0 wceq vy c0h
      wral wa vx cv chil wcel vx cv chil wcel vx cv vy cv csp co cc0 wceq vy
      c0h wral wi wa vx cv c0h cort cfv wcel vx cv chil wcel vx cv chil wcel vx
      cv vy cv csp co cc0 wceq vy c0h wral abai c0h csh wcel vx cv c0h cort cfv
      wcel vx cv chil wcel vx cv vy cv csp co cc0 wceq vy c0h wral wa wb h0elsh
      vy vx cv c0h shocel ax-mp vx cv chil wcel vx cv vy cv csp co cc0 wceq vy
      c0h wral wi vx cv chil wcel vx cv chil wcel vx cv c0v csp co cc0 wceq vx
      cv vy cv csp co cc0 wceq vy c0h wral vx cv hi02 vx cv vy cv csp co cc0
      wceq vy c0h wral vy cv c0h wcel vx cv vy cv csp co cc0 wceq wi vy wal vy
      cv c0v wceq vx cv vy cv csp co cc0 wceq wi vy wal vx cv c0v csp co cc0
      wceq vx cv vy cv csp co cc0 wceq vy c0h df-ral vy cv c0h wcel vx cv vy cv
      csp co cc0 wceq wi vy cv c0v wceq vx cv vy cv csp co cc0 wceq wi vy vy cv
      c0h wcel vy cv c0v wceq vx cv vy cv csp co cc0 wceq vy cv elch0 imbi1i
      albii vx cv vy cv csp co cc0 wceq vx cv c0v csp co cc0 wceq vy c0v c0v
      chil ax-hv0cl elisseti vy cv c0v wceq vx cv vy cv csp co vx cv c0v csp co
      cc0 vy cv c0v vx cv csp opreq2 eqeq1d ceqsalv 3bitri sylibr biantru
      3bitr4i eqriv $.
      $( [15-Oct-1999] $)

    $( The orthocomplement of the unit subspace is the zero subspace.  Does
       not require Axiom of Choice. $)
    choc1 $p |- ( _|_ ` ~H ) = 0H $=
      chil cort cfv c0h vx chil cort cfv c0h vx cv chil cort cfv wcel vx cv c0v
      wceq vx cv c0h wcel vx cv chil cort cfv wcel vx cv vy cv csp co cc0 wceq
      vy chil wral vx cv c0v wceq vx cv chil cort cfv wcel vx cv chil wcel vx
      cv vy cv csp co cc0 wceq vy chil wral chil csh wcel vx cv chil cort cfv
      wcel vx cv chil wcel vx cv vy cv csp co cc0 wceq vy chil wral wa wb helsh
      vy vx cv chil shocel ax-mp pm3.27bi vx cv chil cort cfv wcel vx cv chil
      wcel vx cv vy cv csp co cc0 wceq vy chil wral vx cv c0v wceq wb chil cort
      cfv chil vx cv chil csh wcel chil cort cfv chil wss helsh chil shocss
      ax-mp sseli vy vx cv hial0 syl mpbid vx cv elch0 sylibr ssriv c0h c0h
      cort cfv cort cfv chil cort cfv c0h csh wcel c0h c0h cort cfv cort cfv
      wss h0elsh c0h shococss ax-mp c0h cort cfv chil cort choc0 fveq2i sseqtri
      eqssi $.
      $( [24-Oct-1999] $)

    ${
      $d x y $.
      $( Orthogonal complement of the empty set. $)
      chocnul $p |- ( _|_ ` (/) ) = ~H $=
        vx c0 cort cfv chil vx cv c0 cort cfv wcel vx cv chil wcel vx cv vy cv
        csp co cc0 wceq vy c0 wral c0 chil wss vx cv c0 cort cfv wcel vx cv
        chil wcel vx cv vy cv csp co cc0 wceq vy c0 wral wa wb chil 0ss vy vx
        cv c0 ocel ax-mp vx cv vy cv csp co cc0 wceq vy ral0 mpbiran2 eqriv $.
        $( [31-Oct-2000] $)
    $}

    ${
      shintcl.1 $e |- ( A C_ SH /\ A =/= (/) ) $.
      $( Closure of intersection of a non-empty subset of ` SH ` . $)
      shintcli $p |- |^| A e. SH $=
        cA cint csh wcel cA cint chil wss c0v cA cint wcel wa vx cv vy cv cva
        co cA cint wcel vy cA cint wral vx cA cint wral vx cv vy cv csm co cA
        cint wcel vy cA cint wral vx cc wral wa vx vy cA cint sh cA cint chil
        wss c0v cA cint wcel cA c0 wne cA cint chil wss cA csh wss cA c0 wne
        shintcl.1 pm3.27i cA c0 wne vz cv cA wcel vz wex cA cint chil wss vz cA
        n0 vz cv cA wcel cA cint chil wss vz vz cv cA wcel cA cint vz cv chil
        vz cv cA intss1 vz cv cA wcel vz cv csh wcel vz cv chil wss cA csh vz
        cv cA csh wss cA c0 wne shintcl.1 pm3.26i sseli vz cv shss syl sstrd
        19.23aiv sylbi ax-mp c0v cA cint wcel c0v vz cv wcel vz cA vz c0v cA
        c0v chil ax-hv0cl elisseti elint2 vz cv cA wcel vz cv csh wcel c0v vz
        cv wcel cA csh vz cv cA csh wss cA c0 wne shintcl.1 pm3.26i sseli vz cv
        sh0 syl mprgbir pm3.2i vx cv vy cv cva co cA cint wcel vy cA cint wral
        vx cA cint wral vx cv vy cv csm co cA cint wcel vy cA cint wral vx cc
        wral vx cv vy cv cva co cA cint wcel vx vy cA cint vx cv cA cint wcel
        vy cv cA cint wcel wa vx cv vy cv cva co vz cv wcel vz cA wral vx cv vy
        cv cva co cA cint wcel vx cv cA cint wcel vy cv cA cint wcel wa vx cv
        vy cv cva co vz cv wcel vz cA vz cv cA wcel vx cv cA cint wcel vy cv cA
        cint wcel wa vx cv vy cv cva co vz cv wcel vz cv cA wcel vx cv vz cv
        wcel vy cv vz cv wcel vx cv vy cv cva co vz cv wcel vx cv cA cint wcel
        vy cv cA cint wcel vz cv cA wcel vx cv vz cv wcel vy cv vz cv wcel vx
        cv vy cv cva co vz cv wcel vz cv csh wcel vx cv vz cv wcel vy cv vz cv
        wcel vx cv vy cv cva co vz cv wcel vz cv cA wcel vx cv vy cv vz cv
        shaddcl cA csh vz cv cA csh wss cA c0 wne shintcl.1 pm3.26i sseli
        syl3an1 3expib vx cv cA cint wcel vz cv cA wcel vx cv vz cv wcel vx cv
        cA vz cv elinti com12 vy cv cA cint wcel vz cv cA wcel vy cv vz cv wcel
        vy cv cA vz cv elinti com12 syl2and com12 r19.21aiv vz vx cv vy cv cva
        co cA vx cv vy cv cva oprex elint2 sylibr rgen2a vx cv vy cv csm co cA
        cint wcel vx vy cc cA cint vx cv cc wcel vy cv cA cint wcel wa vx cv vy
        cv csm co vz cv wcel vz cA wral vx cv vy cv csm co cA cint wcel vx cv
        cc wcel vy cv cA cint wcel wa vx cv vy cv csm co vz cv wcel vz cA vz cv
        cA wcel vx cv cc wcel vy cv cA cint wcel wa vx cv vy cv csm co vz cv
        wcel vz cv cA wcel vx cv cc wcel vy cv vz cv wcel vx cv vy cv csm co vz
        cv wcel vy cv cA cint wcel vz cv cA wcel vx cv cc wcel vy cv vz cv wcel
        vx cv vy cv csm co vz cv wcel vz cv csh wcel vx cv cc wcel vy cv vz cv
        wcel vx cv vy cv csm co vz cv wcel vz cv cA wcel vx cv vy cv vz cv
        shmulcl cA csh vz cv cA csh wss cA c0 wne shintcl.1 pm3.26i sseli
        syl3an1 3expib vy cv cA cint wcel vz cv cA wcel vy cv vz cv wcel vy cv
        cA vz cv elinti com12 sylan2d com12 r19.21aiv vz vx cv vy cv csm co cA
        vx cv vy cv csm oprex elint2 sylibr rgen2 pm3.2i mpbir2an $.
        $( [19-Jan-2007] $) $( [14-Oct-1999] $)
    $}

    $( The intersection of a non-empty set of subspaces is a subspace. $)
    shintcl $p |- ( ( A C_ SH /\ A =/= (/) ) -> |^| A e. SH ) $=
      cA csh wss cA c0 wne wa cA cint csh wcel cA csh wss cA c0 wne wa cA csh
      cif cint csh wcel cA csh cA cA csh wss cA c0 wne wa cA csh cif wceq cA
      cint cA csh wss cA c0 wne wa cA csh cif cint csh cA cA csh wss cA c0 wne
      wa cA csh cif inteq eleq1d cA csh wss cA c0 wne wa cA csh cif cA csh wss
      cA c0 wne wa cA csh wss cA c0 wne wa cA csh cif csh wss cA csh wss cA c0
      wne wa cA csh cif c0 wne wa csh csh wss csh c0 wne wa cA csh cA cA csh
      wss cA c0 wne wa cA csh cif wceq cA csh wss cA csh wss cA c0 wne wa cA
      csh cif csh wss cA c0 wne cA csh wss cA c0 wne wa cA csh cif c0 wne cA cA
      csh wss cA c0 wne wa cA csh cif csh sseq1 cA cA csh wss cA c0 wne wa cA
      csh cif c0 neeq1 anbi12d csh cA csh wss cA c0 wne wa cA csh cif wceq csh
      csh wss cA csh wss cA c0 wne wa cA csh cif csh wss csh c0 wne cA csh wss
      cA c0 wne wa cA csh cif c0 wne csh cA csh wss cA c0 wne wa cA csh cif csh
      sseq1 csh cA csh wss cA c0 wne wa cA csh cif c0 neeq1 anbi12d csh csh wss
      csh c0 wne csh ssid c0h csh wcel csh c0 wne h0elsh csh c0h ne0i ax-mp
      pm3.2i elimhyp shintcli dedth $.
      $( [20-May-2007] $) $( [2-Jun-2004] $)

    ${
      chintcl.1 $e |- ( A C_ CH /\ A =/= (/) ) $.
      $( The intersection of a non-empty set of closed subspaces is a
         closed subspace. $)
      chintcli $p |- |^| A e. CH $=
        cA cint cch wcel cA cint csh wcel cn cA cint vf cv wf vf cv vx cv chli
        wbr wa vx cv cA cint wcel wi vx wal vf wal vx vf cA cint closedsub cA
        cA csh wss cA c0 wne cA cch csh cA cch wss cA c0 wne chintcl.1 pm3.26i
        chsssh sstri cA cch wss cA c0 wne chintcl.1 pm3.27i pm3.2i shintcli cn
        cA cint vf cv wf vf cv vx cv chli wbr wa vx cv cA cint wcel wi vf vx vf
        cv vx cv chli wbr cn cA cint vf cv wf vx cv cA cint wcel vf cv vx cv
        chli wbr cn vy cv vf cv wf vy cA wral vx cv vy cv wcel vy cA wral cn cA
        cint vf cv wf vx cv cA cint wcel vf cv vx cv chli wbr cn vy cv vf cv wf
        vx cv vy cv wcel vy cA vf cv vx cv chli wbr vy cv cA wcel cn vy cv vf
        cv wf vx cv vy cv wcel wi vf cv vx cv chli wbr vy cv cch wcel cn vy cv
        vf cv wf vx cv vy cv wcel wi vy cv cA wcel vy cv cch wcel cn vy cv vf
        cv wf vf cv vx cv chli wbr vx cv vy cv wcel vy cv cch wcel cn vy cv vf
        cv wf vf cv vx cv chli wbr vx cv vy cv wcel vx cv vf cv vy cv vx visset
        chlimi 3exp com3r cA cch vy cv cA cch wss cA c0 wne chintcl.1 pm3.26i
        sseli syl5 imp r19.20dva vy cn cA vf cv cA cch wss cA c0 wne chintcl.1
        pm3.27i fint vy vx cv cA vx visset elint2 3imtr4g impcom gen2 mpbir2an
        $.
        $( [23-Jan-2007] $) $( [14-Oct-1999] $)
    $}

    $( The intersection (infimum) of a non-empty subset of ` CH ` belongs
       to ` CH ` .  Part of Theorem 3.13 of [Beran] p. 108.  Also part of
       Definition 3.4-1 in [MegillPavicic] p. 2345 (PDF p. 8). $)
    chintcl $p |- ( ( A C_ CH /\ A =/= (/) ) -> |^| A e. CH ) $=
      cA cch wss cA c0 wne wa cA cint cch wcel cA cch wss cA c0 wne wa cA cch
      cif cint cch wcel cA cch cA cA cch wss cA c0 wne wa cA cch cif wceq cA
      cint cA cch wss cA c0 wne wa cA cch cif cint cch cA cA cch wss cA c0 wne
      wa cA cch cif inteq eleq1d cA cch wss cA c0 wne wa cA cch cif cA cch wss
      cA c0 wne wa cA cch wss cA c0 wne wa cA cch cif cch wss cA cch wss cA c0
      wne wa cA cch cif c0 wne wa cch cch wss cch c0 wne wa cA cch cA cA cch
      wss cA c0 wne wa cA cch cif wceq cA cch wss cA cch wss cA c0 wne wa cA
      cch cif cch wss cA c0 wne cA cch wss cA c0 wne wa cA cch cif c0 wne cA cA
      cch wss cA c0 wne wa cA cch cif cch sseq1 cA cA cch wss cA c0 wne wa cA
      cch cif c0 neeq1 anbi12d cch cA cch wss cA c0 wne wa cA cch cif wceq cch
      cch wss cA cch wss cA c0 wne wa cA cch cif cch wss cch c0 wne cA cch wss
      cA c0 wne wa cA cch cif c0 wne cch cA cch wss cA c0 wne wa cA cch cif cch
      sseq1 cch cA cch wss cA c0 wne wa cA cch cif c0 neeq1 anbi12d cch cch wss
      cch c0 wne cch ssid c0h cch wcel cch c0 wne h0elch cch c0h ne0i ax-mp
      pm3.2i elimhyp chintcli dedth $.
      $( [26-Feb-2007] $) $( [14-Oct-1999] $)

    $( The double complement is the smallest closed subspace containing
       a subset of Hilbert space.  Remark 3.12(B) of [Beran] p. 107. $)
    ococin $p |- ( A C_ ~H ->
                  ( _|_ ` ( _|_ ` A ) ) = |^| { x e. CH | A C_ x } ) $=
      cA chil wss cA cort cfv cort cfv cA vx cv wss vx cch crab cint cA chil
      wss cA cort cfv cort cfv cA vx cv wss vx cch crab cint cort cfv cort cfv
      cA vx cv wss vx cch crab cint cA vx cv wss vx cch crab cint cort cfv chil
      wss cA cort cfv chil wss wa cA vx cv wss vx cch crab cint cort cfv cA
      cort cfv wss cA cort cfv cort cfv cA vx cv wss vx cch crab cint cort cfv
      cort cfv wss cA chil wss cA vx cv wss vx cch crab cint cort cfv cA cort
      cfv occon cA chil wss cA vx cv wss vx cch crab cint cort cfv chil wss cA
      cort cfv chil wss cA chil wss chil cA vx cv wss vx cch crab wcel cA vx cv
      wss vx cch crab cint chil wss cA vx cv wss vx cch crab cint cort cfv chil
      wss cA chil wss chil cch wcel cA chil wss wa chil cA vx cv wss vx cch
      crab wcel cA chil wss chil cch wcel helch jctl cA vx cv wss cA chil wss
      vx chil cch vx cv chil cA sseq2 elrab sylibr chil cA vx cv wss vx cch
      crab intss1 cA vx cv wss vx cch crab cint ocss 3syl cA ocss jca cA chil
      wss cA cA vx cv wss vx cch crab cint wss cA vx cv wss vx cch crab cint
      cort cfv cA cort cfv wss vx cA cch ssintub cA chil wss cA vx cv wss vx
      cch crab cint chil wss cA cA vx cv wss vx cch crab cint wss cA vx cv wss
      vx cch crab cint cort cfv cA cort cfv wss wi cA chil wss chil cA vx cv
      wss vx cch crab wcel cA vx cv wss vx cch crab cint chil wss cA chil wss
      chil cch wcel cA chil wss wa chil cA vx cv wss vx cch crab wcel cA chil
      wss chil cch wcel helch jctl cA vx cv wss cA chil wss vx chil cch vx cv
      chil cA sseq2 elrab sylibr chil cA vx cv wss vx cch crab intss1 syl cA cA
      vx cv wss vx cch crab cint occon mpdan mpi sylc cA chil wss cA vx cv wss
      vx cch crab cch wss cA vx cv wss vx cch crab c0 wne wa cA vx cv wss vx
      cch crab cint cch wcel cA vx cv wss vx cch crab cint cort cfv cort cfv cA
      vx cv wss vx cch crab cint wceq cA chil wss cA vx cv wss vx cch crab c0
      wne cA vx cv wss vx cch crab cch wss cA chil wss cA vx cv wss vx cch wrex
      cA vx cv wss vx cch crab c0 wne chil cch wcel cA chil wss cA vx cv wss vx
      cch wrex helch cA vx cv wss cA chil wss vx chil cch vx cv chil cA sseq2
      rcla4ev mpan cA vx cv wss vx cch rabn0 sylibr cA vx cv wss vx cch ssrab2
      jctil cA vx cv wss vx cch crab chintcl cA vx cv wss vx cch crab cint ococ
      3syl sseqtrd cA chil wss cA cort cfv cort cfv cA vx cv wss vx cch crab
      wcel cA vx cv wss vx cch crab cint cA cort cfv cort cfv wss cA chil wss
      cA cort cfv cort cfv cch wcel cA cA cort cfv cort cfv wss wa cA cort cfv
      cort cfv cA vx cv wss vx cch crab wcel cA chil wss cA cort cfv cort cfv
      cch wcel cA cA cort cfv cort cfv wss cA chil wss cA cort cfv chil wss cA
      cort cfv cort cfv cch wcel cA ocss cA cort cfv occl syl cA ococss jca cA
      vx cv wss cA cA cort cfv cort cfv wss vx cA cort cfv cort cfv cch vx cv
      cA cort cfv cort cfv cA sseq2 elrab sylibr cA cort cfv cort cfv cA vx cv
      wss vx cch crab intss1 syl eqssd $.
      $( [8-Aug-2000] $)

    $( Alternate definition of supremum of a subset of the Hilbert lattice.
       Definition in Proposition 1 of [Kalmbach] p. 65.  We actually define it
       on any collection of Hilbert space subsets, not just the Hilbert lattice
       ` CH ` , to allow more general theorems. $)
    dfchsup2 $p |- \/H = { <. x , y >. | ( x C_ ~P ~H /\
                   y = |^| { z e. CH | U. x C_ z } ) } $=
      chsup vx cv chil cpw wss vy cv vx cv cuni cort cfv cort cfv wceq wa vx vy
      copab vx cv chil cpw wss vy cv vx cv cuni vz cv wss vz cch crab cint wceq
      wa vx vy copab vx vy df-chsup vx cv chil cpw wss vy cv vx cv cuni cort
      cfv cort cfv wceq wa vx cv chil cpw wss vy cv vx cv cuni vz cv wss vz cch
      crab cint wceq wa vx vy vx cv chil cpw wss vy cv vx cv cuni cort cfv cort
      cfv wceq vy cv vx cv cuni vz cv wss vz cch crab cint wceq vx cv chil cpw
      wss vx cv cuni cort cfv cort cfv vx cv cuni vz cv wss vz cch crab cint vy
      cv vx cv chil cpw wss vx cv cuni chil wss vx cv cuni cort cfv cort cfv vx
      cv cuni vz cv wss vz cch crab cint wceq vx cv chil cpw wss vx cv cuni
      chil cpw cuni chil vx cv chil cpw uniss chil unipw syl6ss vz vx cv cuni
      ococin syl eqeq2d pm5.32i opabbii eqtri $.
      $( [9-Dec-2003] $) $( [9-Dec-2003] $)

    $( Value of the linear span of a subset of Hilbert space.  The span is the
       intersection of all subspaces constraining the subset.  Definition
       of span in [Schechter] p. 276. $)
    spanval $p |- ( A C_ ~H -> ( span ` A ) = |^| { x e. SH | A C_ x } ) $=
      cA chil wss cA chil cpw wcel cA cspn cfv cA vx cv wss vx csh crab cint
      wceq cA chil ax-hilex elpw2 cA chil cpw wcel cA vx cv wss vx csh crab
      cint cvv wcel cA cspn cfv cA vx cv wss vx csh crab cint wceq cA chil cpw
      wcel cA vx cv wss vx csh wrex cA vx cv wss vx csh crab cint cvv wcel cA
      chil cpw wcel cA chil wss cA vx cv wss vx csh wrex cA chil ax-hilex elpw2
      chil csh wcel cA chil wss cA vx cv wss vx csh wrex helsh cA vx cv wss cA
      chil wss vx chil csh vx cv chil cA sseq2 rcla4ev mpan sylbi cA vx cv wss
      vx csh intexrab sylib vy vz cA vy cv vx cv wss vx csh crab cint cA vx cv
      wss vx csh crab cint chil cpw cvv cspn vy cv cA wceq vy cv vx cv wss vx
      csh crab cA vx cv wss vx csh crab vy cv cA wceq vy cv vx cv wss cA vx cv
      wss vx csh vy cv cA vx cv sseq1 rabbisdv inteqd cspn vy cv chil wss vz cv
      vy cv vx cv wss vx csh crab cint wceq wa vy vz copab vy cv chil cpw wcel
      vz cv vy cv vx cv wss vx csh crab cint wceq wa vy vz copab vy vz vx
      df-span vy cv chil cpw wcel vz cv vy cv vx cv wss vx csh crab cint wceq
      wa vy cv chil wss vz cv vy cv vx cv wss vx csh crab cint wceq wa vy vz vy
      cv chil cpw wcel vy cv chil wss vz cv vy cv vx cv wss vx csh crab cint
      wceq vy cv chil ax-hilex elpw2 anbi1i opabbii eqtr4i fvopab4g mpdan
      sylbir $.
      $( [3-Jun-2004] $) $( [2-Jun-2004] $)

    $( Value of supremum of set of subsets of Hilbert space.  Definition of
       supremum in Proposition 1 of [Kalmbach] p. 65. $)
    hsupval2 $p |- ( A C_ ~P ~H ->
                    ( \/H ` A ) = |^| { x e. CH | U. A C_ x } ) $=
      cA chil cpw cpw wcel cA cuni vx cv wss vx cch crab cint cvv wcel cA chsup
      cfv cA cuni vx cv wss vx cch crab cint wceq cA chil cpw wss vy vz cA vy
      cv cuni vx cv wss vx cch crab cint cA cuni vx cv wss vx cch crab cint
      chil cpw cpw cvv chsup vy cv cA wceq vy cv cuni vx cv wss vx cch crab cA
      cuni vx cv wss vx cch crab vy cv cA wceq vy cv cuni vx cv wss cA cuni vx
      cv wss vx cch vy cv cA wceq vy cv cuni cA cuni vx cv vy cv cA unieq
      sseq1d rabbisdv inteqd chsup vy cv chil cpw wss vz cv vy cv cuni vx cv
      wss vx cch crab cint wceq wa vy vz copab vy cv chil cpw cpw wcel vz cv vy
      cv cuni vx cv wss vx cch crab cint wceq wa vy vz copab vy vz vx dfchsup2
      vy cv chil cpw cpw wcel vz cv vy cv cuni vx cv wss vx cch crab cint wceq
      wa vy cv chil cpw wss vz cv vy cv cuni vx cv wss vx cch crab cint wceq wa
      vy vz vy cv chil cpw cpw wcel vy cv chil cpw wss vz cv vy cv cuni vx cv
      wss vx cch crab cint wceq vy cv chil cpw chil ax-hilex pwex elpw2 anbi1i
      opabbii eqtr4i fvopab4g cA chil cpw cpw wcel cA chil cpw wss cA chil cpw
      chil ax-hilex pwex elpw2 biimpri cA chil cpw wss cA cuni vx cv wss vx cch
      crab c0 wne cA cuni vx cv wss vx cch crab cint cvv wcel cA chil cpw wss
      chil cA cuni vx cv wss vx cch crab wcel cA cuni vx cv wss vx cch crab c0
      wne cA chil cpw wss chil cch wcel cA cuni chil wss wa chil cA cuni vx cv
      wss vx cch crab wcel cA chil cpw wss cA cuni chil wss chil cch wcel cA
      chil cpw wss cA cuni chil cpw cuni chil cA chil cpw uniss chil unipw
      syl6ss helch jctil cA cuni vx cv wss cA cuni chil wss vx chil cch vx cv
      chil cA cuni sseq2 elrab sylibr cA cuni vx cv wss vx cch crab chil ne0i
      syl cA cuni vx cv wss vx cch crab intex sylib sylanc $.
      $( [13-Aug-2002] $)

    $( Value of supremum of set of subsets of Hilbert space.  For an alternate
       version of the value, see ~ hsupval2 . $)
    hsupval $p |- ( A C_ ~P ~H -> ( \/H ` A ) = ( _|_ ` ( _|_ ` U. A ) ) ) $=
      cA chil cpw wss cA chsup cfv cA cuni vx cv wss vx cch crab cint cA cuni
      cort cfv cort cfv vx cA hsupval2 cA chil cpw wss cA cuni chil wss cA cuni
      cort cfv cort cfv cA cuni vx cv wss vx cch crab cint wceq cA chil cpw wss
      cA cuni chil cpw cuni chil cA chil cpw uniss chil unipw syl6ss vx cA cuni
      ococin syl eqtr4d $.
      $( [9-Dec-2003] $) $( [9-Dec-2003] $)

    $( The value of the supremum of a set of closed subspaces of Hilbert space.
       Definition of supremum in Proposition 1 of [Kalmbach] p. 65. $)
    chsupval2 $p |- ( A C_ CH ->
                    ( \/H ` A ) = |^| { x e. CH | U. A C_ x } ) $=
      cA cch wss cA chil cpw wss cA chsup cfv cA cuni vx cv wss vx cch crab
      cint wceq cA cch wss cch chil cpw wss cA chil cpw wss chsspwh cA cch chil
      cpw sstr2 mpi vx cA hsupval2 syl $.
      $( [13-Aug-2002] $)

    $( The value of the supremum of a set of closed subspaces of Hilbert space.
       For an alternate version of the value, see ~ chsupval2 . $)
    chsupval $p |- ( A C_ CH -> ( \/H ` A ) = ( _|_ ` ( _|_ ` U. A ) ) ) $=
      cA cch wss cA chil cpw wss cA chsup cfv cA cuni cort cfv cort cfv wceq cA
      cch wss cch chil cpw wss cA chil cpw wss chsspwh cA cch chil cpw sstr2
      mpi cA hsupval syl $.
      $( [13-Aug-2002] $)

    $( The span of a subset of Hilbert space is a subspace. $)
    spancl $p |- ( A C_ ~H -> ( span ` A ) e. SH ) $=
      cA chil wss cA cspn cfv cA vx cv wss vx csh crab cint csh vx cA spanval
      cA chil wss cA vx cv wss vx csh crab csh wss cA vx cv wss vx csh crab c0
      wne wa cA vx cv wss vx csh crab cint csh wcel cA chil wss cA vx cv wss vx
      csh crab c0 wne cA vx cv wss vx csh crab csh wss cA chil wss cA vx cv wss
      vx csh wrex cA vx cv wss vx csh crab c0 wne chil csh wcel cA chil wss cA
      vx cv wss vx csh wrex helsh cA vx cv wss cA chil wss vx chil csh vx cv
      chil cA sseq2 rcla4ev mpan cA vx cv wss vx csh rabn0 sylibr cA vx cv wss
      vx csh ssrab2 jctil cA vx cv wss vx csh crab shintcl syl eqeltrd $.
      $( [9-Jun-2004] $) $( [2-Jun-2004] $)

    $( A member of a span is a vector. $)
    elspancl $p |- ( ( A C_ ~H /\ B e. ( span ` A ) ) -> B e. ~H ) $=
      cA cspn cfv csh wcel cB cA cspn cfv wcel cB chil wcel cA chil wss cB cA
      cspn cfv shel cA spancl sylan $.
      $( [21-Dec-2004] $) $( [17-Dec-2004] $)

    $( Closure of the subspace supremum of set of subsets of Hilbert space. $)
    shsupcl $p |- ( A C_ ~P ~H -> ( span ` U. A ) e. SH ) $=
      cA chil cpw wss cA cuni chil wss cA cuni cspn cfv csh wcel cA chil cpw
      wss cA cuni chil cpw cuni chil cA chil cpw uniss chil unipw syl6ss cA
      cuni spancl syl $.
      $( [29-Nov-2004] $) $( [26-Nov-2004] $)

    $( Closure of supremum of set of subsets of Hilbert space.  Note that the
       supremum belongs to ` CH ` even if the subsets do not. $)
    hsupcl $p |- ( A C_ ~P ~H -> ( \/H ` A ) e. CH ) $=
      cA chil cpw wss cA chsup cfv cA cuni vx cv wss vx cch crab cint cch vx cA
      hsupval2 cA chil cpw wss cA cuni vx cv wss vx cch crab cch wss cA cuni vx
      cv wss vx cch crab c0 wne wa cA cuni vx cv wss vx cch crab cint cch wcel
      cA chil cpw wss cA cuni vx cv wss vx cch crab c0 wne cA cuni vx cv wss vx
      cch crab cch wss cA chil cpw wss cA cuni vx cv wss vx cch crab cint cvv
      wcel cA cuni vx cv wss vx cch crab c0 wne cA chil cpw wss cA cuni vx cv
      wss vx cch crab cint cA chsup cfv cvv vx cA hsupval2 cA chsup fvex
      syl6eqelr cA cuni vx cv wss vx cch crab intex sylibr cA cuni vx cv wss vx
      cch ssrab2 jctil cA cuni vx cv wss vx cch crab chintcl syl eqeltrd $.
      $( [10-Nov-1999] $)

    $( Closure of supremum of subset of ` CH ` .  Definition of supremum in
       Proposition 1 of [Kalmbach] p. 65.  Shows that ` CH ` is a complete
       lattice.  Also part of Definition 3.4-1 in [MegillPavicic] p. 2345
       (PDF p. 8). $)
    chsupcl $p |- ( A C_ CH -> ( \/H ` A ) e. CH ) $=
      cA cch wss cA chil cpw wss cA chsup cfv cch wcel cA cch wss cch chil cpw
      wss cA chil cpw wss chsspwh cA cch chil cpw sstr2 mpi cA hsupcl syl $.
      $( [10-Nov-1999] $)

    $( Subset relation for supremum of Hilbert space subsets. $)
    hsupss $p |- ( ( A C_ ~P ~H /\ B C_ ~P ~H ) ->
                  ( A C_ B -> ( \/H ` A ) C_ ( \/H ` B ) ) ) $=
      cA chil cpw wss cB chil cpw wss wa cA chsup cfv cB chsup cfv wss cA cuni
      vx cv wss vx cch crab cint cB cuni vx cv wss vx cch crab cint wss cA cB
      wss cA chil cpw wss cB chil cpw wss wa cA chsup cfv cA cuni vx cv wss vx
      cch crab cint cB chsup cfv cB cuni vx cv wss vx cch crab cint cA chil cpw
      wss cA chsup cfv cA cuni vx cv wss vx cch crab cint wceq cB chil cpw wss
      vx cA hsupval2 adantr cB chil cpw wss cB chsup cfv cB cuni vx cv wss vx
      cch crab cint wceq cA chil cpw wss vx cB hsupval2 adantl sseq12d cA cB
      wss cB cuni vx cv wss vx cch crab cA cuni vx cv wss vx cch crab wss cA
      cuni vx cv wss vx cch crab cint cB cuni vx cv wss vx cch crab cint wss cA
      cB wss cB cuni vx cv wss cA cuni vx cv wss wi vx cch wral cB cuni vx cv
      wss vx cch crab cA cuni vx cv wss vx cch crab wss cA cB wss cB cuni vx cv
      wss cA cuni vx cv wss wi vx cch cA cB wss cB cuni vx cv wss cA cuni vx cv
      wss wi vx cv cch wcel cA cB wss cA cuni cB cuni wss cB cuni vx cv wss cA
      cuni vx cv wss wi cA cB uniss cA cuni cB cuni vx cv sstr2 syl a1d
      r19.21aiv cB cuni vx cv wss cA cuni vx cv wss vx cch ss2rab sylibr cB
      cuni vx cv wss vx cch crab cA cuni vx cv wss vx cch crab intss syl
      syl5bir $.
      $( [26-Nov-2004] $) $( [24-Nov-2004] $)

    $( Subset relation for supremum of subset of ` CH ` . $)
    chsupss $p |- ( ( A C_ CH /\ B C_ CH ) ->
                  ( A C_ B -> ( \/H ` A ) C_ ( \/H ` B ) ) ) $=
      cA chil cpw wss cB chil cpw wss cA cB wss cA chsup cfv cB chsup cfv wss
      wi cA cch wss cB cch wss cA cB hsupss cA cch wss cch chil cpw wss cA chil
      cpw wss chsspwh cA cch chil cpw sstr2 mpi cB cch wss cch chil cpw wss cB
      chil cpw wss chsspwh cB cch chil cpw sstr2 mpi syl2an $.
      $( [13-Aug-2002] $)

    $( A subspace is the supremum of all smaller subspaces. $)
    chsupid $p |- ( A e. CH -> ( \/H ` { x e. CH | x C_ A } ) = A ) $=
      cA cch wcel vx cv cA wss vx cch crab cuni vy cv wss vy cch crab cint cA
      vx cv cA wss vx cch crab chsup cfv cA cch wcel vx cv cA wss vx cch crab
      cuni vy cv wss vy cch crab cint cA vy cv wss vy cch crab cint cA cA cch
      wcel vx cv cA wss vx cch crab cuni vy cv wss vy cch crab cA vy cv wss vy
      cch crab cA cch wcel vx cv cA wss vx cch crab cuni vy cv wss cA vy cv wss
      vy cch cA cch wcel vx cv cA wss vx cch crab cuni cA vy cv vx cA cch
      unimax sseq1d rabbisdv inteqd vy cA cch intmin eqtrd vx cv cA wss vx cch
      crab cch wss vx cv cA wss vx cch crab chsup cfv vx cv cA wss vx cch crab
      cuni vy cv wss vy cch crab cint wceq vx cv cA wss vx cch ssrab2 vy vx cv
      cA wss vx cch crab chsupval2 ax-mp syl5eq $.
      $( [13-Aug-2002] $)

    $( Value of supremum of subset of ` CH ` on a singleton. $)
    chsupsn $p |- ( A e. CH -> ( \/H ` { A } ) = A ) $=
      cA cch wcel cA csn chsup cfv cA csn cuni vx cv wss vx cch crab cint cA cA
      cch wcel cA csn cch wss cA csn chsup cfv cA csn cuni vx cv wss vx cch
      crab cint wceq cA cch snssi vx cA csn chsupval2 syl cA cch wcel cA csn
      cuni vx cv wss vx cch crab cint cA cA cch wcel cA cA csn cuni vx cv wss
      vx cch crab wcel cA csn cuni vx cv wss vx cch crab cint cA wss cA cch
      wcel cA cch wcel cA csn cuni cA wss wa cA cA csn cuni vx cv wss vx cch
      crab wcel cA cch wcel cA csn cuni cA wss cA cch wcel cA csn cuni cA wceq
      cA csn cuni cA wss cA cch unisng cA csn cuni cA eqimss syl ancli cA csn
      cuni vx cv wss cA csn cuni cA wss vx cA cch vx cv cA cA csn cuni sseq2
      elrab sylibr cA cA csn cuni vx cv wss vx cch crab intss1 syl cA cch wcel
      cA csn cuni cA csn cuni vx cv wss vx cch crab cint wss cA cA csn cuni vx
      cv wss vx cch crab cint wss vx cA csn cuni cch ssintub cA cch wcel cA csn
      cuni cA cA csn cuni vx cv wss vx cch crab cint cA cch unisng sseq1d mpbii
      eqssd eqtrd $.
      $( [13-Aug-2002] $)

    $( The union of a set of Hilbert space subsets is smaller than its
       supremum. $)
    hsupunss $p |- ( A C_ ~P ~H -> U. A C_ ( \/H ` A ) ) $=
      cA chil cpw wss cA cuni cA chsup cfv wss cA cuni cA cuni vx cv wss vx cch
      crab cint wss vx cA cuni cch ssintub cA chil cpw wss cA chsup cfv cA cuni
      vx cv wss vx cch crab cint cA cuni vx cA hsupval2 sseq2d mpbiri $.
      $( [26-Nov-2004] $) $( [24-Nov-2004] $)

    $( A subset of Hilbert space is included in its span. $)
    spanss2 $p |- ( A C_ ~H -> A C_ ( span ` A ) ) $=
      cA chil wss cA cA cspn cfv wss cA cA vx cv wss vx csh crab cint wss vx cA
      csh ssintub cA chil wss cA cspn cfv cA vx cv wss vx csh crab cint cA vx
      cA spanval sseq2d mpbiri $.
      $( [13-Jun-2004] $) $( [2-Jun-2004] $)

    $( The union of a set of subspaces is smaller than its supremum. $)
    shsupunss $p |- ( A C_ SH -> U. A C_ ( span ` U. A ) ) $=
      cA csh wss cA cuni chil wss cA cuni cA cuni cspn cfv wss cA csh wss cA
      cuni chil cpw cuni chil cA csh wss cA chil cpw wss cA cuni chil cpw cuni
      wss cA csh wss csh chil cpw wss cA chil cpw wss shsspwh cA csh chil cpw
      sstr mpan2 cA chil cpw uniss syl chil unipw syl6ss cA cuni spanss2 syl $.
      $( [29-Nov-2004] $) $( [26-Nov-2004] $)

    $( The union of a set of closed subspaces is smaller than its supremum. $)
    chsupunss $p |- ( A C_ CH -> U. A C_ ( \/H ` A ) ) $=
      cA cch wss cA chil cpw wss cA cuni cA chsup cfv wss cA cch wss cch chil
      cpw wss cA chil cpw wss chsspwh cA cch chil cpw sstr mpan2 cA hsupunss
      syl $.
      $( [14-Aug-2002] $)

    $( A subspace of Hilbert space is its own span. $)
    spanid $p |- ( A e. SH -> ( span ` A ) = A ) $=
      cA csh wcel cA cspn cfv cA vx cv wss vx csh crab cint cA cA csh wcel cA
      chil wss cA cspn cfv cA vx cv wss vx csh crab cint wceq cA shss vx cA
      spanval syl vx cA csh intmin eqtrd $.
      $( [13-Jun-2004] $) $( [2-Jun-2004] $)

    $( Ordering relationship for the spans of subsets of Hilbert space. $)
    spanss $p |- ( ( B C_ ~H /\ A C_ B ) -> ( span ` A ) C_ ( span ` B ) ) $=
      cB chil wss cA cB wss wa cA vx cv wss vx csh crab cint cB vx cv wss vx
      csh crab cint cA cspn cfv cB cspn cfv cA cB wss cA vx cv wss vx csh crab
      cint cB vx cv wss vx csh crab cint wss cB chil wss cA cB wss cB vx cv wss
      vx csh crab cA vx cv wss vx csh crab wss cA vx cv wss vx csh crab cint cB
      vx cv wss vx csh crab cint wss cA cB wss cB vx cv wss cA vx cv wss wi vx
      csh wral cB vx cv wss vx csh crab cA vx cv wss vx csh crab wss cA cB wss
      cB vx cv wss cA vx cv wss wi vx csh cA cB wss cB vx cv wss cA vx cv wss
      wi vx cv csh wcel cA cB vx cv sstr2 a1d r19.21aiv cB vx cv wss cA vx cv
      wss vx csh ss2rab sylibr cB vx cv wss vx csh crab cA vx cv wss vx csh
      crab intss syl adantl cB chil wss cA cB wss wa cA chil wss cA cspn cfv cA
      vx cv wss vx csh crab cint wceq cA cB wss cB chil wss cA chil wss cA cB
      chil sstr ancoms vx cA spanval syl cB chil wss cB cspn cfv cB vx cv wss
      vx csh crab cint wceq cA cB wss vx cB spanval adantr 3sstr4d $.
      $( [13-Jun-2004] $) $( [2-Jun-2004] $)

    $( The span of a subset of Hilbert space is less than or equal to its
       closure (double orthogonal complement). $)
    spanssoc $p |- ( A C_ ~H -> ( span ` A ) C_ ( _|_ ` ( _|_ ` A ) ) ) $=
      cA chil wss cA cspn cfv cA cort cfv cort cfv cspn cfv cA cort cfv cort
      cfv cA cort cfv cort cfv chil wss cA cA cort cfv cort cfv wss cA cspn cfv
      cA cort cfv cort cfv cspn cfv wss cA chil wss cA cA cort cfv cort cfv
      spanss cA chil wss cA cort cfv chil wss cA cort cfv cort cfv chil wss cA
      ocss cA cort cfv ocss syl cA ococss sylanc cA chil wss cA cort cfv chil
      wss cA cort cfv cort cfv csh wcel cA cort cfv cort cfv cspn cfv cA cort
      cfv cort cfv wceq cA ocss cA cort cfv ocsh cA cort cfv cort cfv spanid
      3syl sseqtrd $.
      $( [13-Jun-2004] $) $( [3-Jun-2004] $)

    $( Value of join for subsets of Hilbert space. $)
    sshjval $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) =
        ( _|_ ` ( _|_ ` ( A u. B ) ) ) ) $=
      cA chil cpw wcel cB chil cpw wcel cA cB chj co cA cB cun cort cfv cort
      cfv wceq cA chil wss cB chil wss vx vy vz cA cB chil cpw chil cpw vx cv
      vy cv cun cort cfv cort cfv cA cB cun cort cfv cort cfv chj cA vy cv cun
      cort cfv cort cfv cA cB cun cort cfv cort fvex vx cv cA wceq vx cv vy cv
      cun cort cfv cA vy cv cun cort cfv cort vx cv cA wceq vx cv vy cv cun cA
      vy cv cun cort vx cv cA vy cv uneq1 fveq2d fveq2d vy cv cB wceq cA vy cv
      cun cort cfv cA cB cun cort cfv cort vy cv cB wceq cA vy cv cun cA cB cun
      cort vy cv cB cA uneq2 fveq2d fveq2d chj vx cv chil wss vy cv chil wss wa
      vz cv vx cv vy cv cun cort cfv cort cfv wceq wa vx vy vz copab2 vx cv
      chil cpw wcel vy cv chil cpw wcel wa vz cv vx cv vy cv cun cort cfv cort
      cfv wceq wa vx vy vz copab2 vx vy vz df-chj vx cv chil cpw wcel vy cv
      chil cpw wcel wa vz cv vx cv vy cv cun cort cfv cort cfv wceq wa vx cv
      chil wss vy cv chil wss wa vz cv vx cv vy cv cun cort cfv cort cfv wceq
      wa vx vy vz vx cv chil cpw wcel vy cv chil cpw wcel wa vx cv chil wss vy
      cv chil wss wa vz cv vx cv vy cv cun cort cfv cort cfv wceq vx cv chil
      cpw wcel vx cv chil wss vy cv chil cpw wcel vy cv chil wss vx cv chil
      ax-hilex elpw2 vy cv chil ax-hilex elpw2 anbi12i anbi1i oprabbii eqtr4i
      oprabval2 cA chil ax-hilex elpw2 cB chil ax-hilex elpw2 syl2anbr $.
      $( [1-Nov-2000] $)

    $( Value of join in ` SH ` . $)
    shjval $p |- ( ( A e. SH /\ B e. SH ) -> ( A vH B ) =
        ( _|_ ` ( _|_ ` ( A u. B ) ) ) ) $=
      cA chil wss cB chil wss cA cB chj co cA cB cun cort cfv cort cfv wceq cA
      csh wcel cB csh wcel cA cB sshjval cA shss cB shss syl2an $.
      $( [9-Aug-2000] $)

    $( Value of join in ` CH ` . $)
    chjval $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH B ) =
        ( _|_ ` ( _|_ ` ( A u. B ) ) ) ) $=
      cA csh wcel cB csh wcel cA cB chj co cA cB cun cort cfv cort cfv wceq cA
      cch wcel cB cch wcel cA cB shjval cA chsh cB chsh syl2an $.
      $( [9-Aug-2000] $)

    ${
      chjval.1 $e |- A e. CH $.
      chjval.2 $e |- B e. CH $.
      $( Value of join in ` CH ` . $)
      chjvali $p |- ( A vH B ) = ( _|_ ` ( _|_ ` ( A u. B ) ) ) $=
        cA cch wcel cB cch wcel cA cB chj co cA cB cun cort cfv cort cfv wceq
        chjval.1 chjval.2 cA cB chjval mp2an $.
        $( [9-Aug-2000] $)
    $}


    $( Alternate definition of join in the set of closed subspaces of
       Hilbert space ` CH ` . $)
    dfchj2 $p |- vH = { <. <. x , y >. , z >. | ( ( x C_ ~H /\ y C_ ~H ) /\
               z = |^| { w e. CH | ( x u. y ) C_ w } ) } $=
      chj vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cun cort cfv cort
      cfv wceq wa vx vy vz copab2 vx cv chil wss vy cv chil wss wa vz cv vx cv
      vy cv cun vw cv wss vw cch crab cint wceq wa vx vy vz copab2 vx vy vz
      df-chj vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cun cort cfv
      cort cfv wceq wa vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cun
      vw cv wss vw cch crab cint wceq wa vx vy vz vx cv chil wss vy cv chil wss
      wa vz cv vx cv vy cv cun cort cfv cort cfv wceq vz cv vx cv vy cv cun vw
      cv wss vw cch crab cint wceq vx cv chil wss vy cv chil wss wa vx cv vy cv
      cun cort cfv cort cfv vx cv vy cv cun vw cv wss vw cch crab cint vz cv vx
      cv chil wss vy cv chil wss wa vx cv vy cv cun chil wss vx cv vy cv cun
      cort cfv cort cfv vx cv vy cv cun vw cv wss vw cch crab cint wceq vx cv
      vy cv chil unss vw vx cv vy cv cun ococin sylbi eqeq2d pm5.32i oprabbii
      eqtri $.
      $( [1-Nov-2000] $)

    $( Alternate definition of join in the set of closed subspaces of Hilbert
       space ` CH ` :  the join is the supremum of its two arguments.  Based
       on the definition of join in [Beran] p. 3.  For later convenience we
       prove a general version that works for any subset of Hilbert space,
       not just the elements of the lattice ` CH ` . $)
    dfchj3 $p |- vH = { <. <. x , y >. , z >. | ( ( x C_ ~H /\ y C_ ~H ) /\
               z = ( \/H ` { x , y } ) ) } $=
      chj vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cun cort cfv cort
      cfv wceq wa vx vy vz copab2 vx cv chil wss vy cv chil wss wa vz cv vx cv
      vy cv cpr chsup cfv wceq wa vx vy vz copab2 vx vy vz df-chj vx cv chil
      wss vy cv chil wss wa vz cv vx cv vy cv cun cort cfv cort cfv wceq wa vx
      cv chil wss vy cv chil wss wa vz cv vx cv vy cv cpr chsup cfv wceq wa vx
      vy vz vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cun cort cfv
      cort cfv wceq vz cv vx cv vy cv cpr chsup cfv wceq vx cv chil wss vy cv
      chil wss wa vx cv vy cv cun cort cfv cort cfv vx cv vy cv cpr chsup cfv
      vz cv vx cv chil wss vy cv chil wss wa vx cv vy cv cpr chsup cfv vx cv vy
      cv cpr cuni cort cfv cort cfv vx cv vy cv cun cort cfv cort cfv vx cv
      chil wss vy cv chil wss wa vx cv vy cv cpr chil cpw wss vx cv vy cv cpr
      chsup cfv vx cv vy cv cpr cuni cort cfv cort cfv wceq vx cv vy cv chil vx
      visset vy visset prsspw vx cv vy cv cpr hsupval sylbir vx cv vy cv cpr
      cuni cort cfv vx cv vy cv cun cort cfv cort vx cv vy cv cpr cuni vx cv vy
      cv cun cort vx cv vy cv vx visset vy visset unipr fveq2i fveq2i syl6req
      eqeq2d pm5.32i oprabbii eqtri $.
      $( [3-Mar-2004] $) $( [2-Mar-2004] $)

    $( Value of join for subsets of Hilbert space in terms of supremum:  the
       join is the supremum of its two arguments.  Based on the definition of
       join in [Beran] p. 3. $)
    sshjval3 $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) =
                 ( \/H ` { A , B } ) ) $=
      cA chil cpw wcel cB chil cpw wcel cA cB chj co cA cB cpr chsup cfv wceq
      cA chil wss cB chil wss vx vy vz cA cB chil cpw chil cpw vx cv vy cv cpr
      chsup cfv cA cB cpr chsup cfv chj cA vy cv cpr chsup cfv cA cB cpr chsup
      fvex vx cv cA wceq vx cv vy cv cpr cA vy cv cpr chsup vx cv cA vy cv
      preq1 fveq2d vy cv cB wceq cA vy cv cpr cA cB cpr chsup vy cv cB cA preq2
      fveq2d chj vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cpr chsup
      cfv wceq wa vx vy vz copab2 vx cv chil cpw wcel vy cv chil cpw wcel wa vz
      cv vx cv vy cv cpr chsup cfv wceq wa vx vy vz copab2 vx vy vz dfchj3 vx
      cv chil cpw wcel vy cv chil cpw wcel wa vz cv vx cv vy cv cpr chsup cfv
      wceq wa vx cv chil wss vy cv chil wss wa vz cv vx cv vy cv cpr chsup cfv
      wceq wa vx vy vz vx cv chil cpw wcel vy cv chil cpw wcel wa vx cv chil
      wss vy cv chil wss wa vz cv vx cv vy cv cpr chsup cfv wceq vx cv chil cpw
      wcel vx cv chil wss vy cv chil cpw wcel vy cv chil wss vx cv chil
      ax-hilex elpw2 vy cv chil ax-hilex elpw2 anbi12i anbi1i oprabbii eqtr4i
      oprabval2 cA chil ax-hilex elpw2 cB chil ax-hilex elpw2 syl2anbr $.
      $( [14-Jun-2004] $) $( [2-Mar-2004] $)

    $( Closure of join for subsets of Hilbert space. $)
    sshjcl $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) e. CH ) $=
      cA chil wss cB chil wss wa cA cB chj co cA cB cun cort cfv cort cfv cch
      cA cB sshjval cA chil wss cB chil wss wa cA cB cun chil wss cA cB cun
      cort cfv cort cfv cch wcel cA cB chil unss cA cB cun chil wss cA cB cun
      cort cfv chil wss cA cB cun cort cfv cort cfv cch wcel cA cB cun ocss cA
      cB cun cort cfv occl syl sylbi eqeltrd $.
      $( [1-Nov-2000] $)

    $( Closure of join in ` SH ` . $)
    shjcl $p |- ( ( A e. SH /\ B e. SH ) -> ( A vH B ) e. CH ) $=
      cA chil wss cB chil wss cA cB chj co cch wcel cA csh wcel cB csh wcel cA
      cB sshjcl cA shss cB shss syl2an $.
      $( [2-Nov-1999] $)

    $( Closure of join in ` CH ` . $)
    chjcl $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH B ) e. CH ) $=
      cA csh wcel cB csh wcel cA cB chj co cch wcel cA cch wcel cB cch wcel cA
      cB shjcl cA chsh cB chsh syl2an $.
      $( [2-Nov-1999] $)

    $( Commutative law for Hilbert lattice join of subspaces. $)
    shjcom $p |- ( ( A e. SH /\ B e. SH ) -> ( A vH B ) = ( B vH A ) ) $=
      cA csh wcel cB csh wcel wa cA cB chj co cA cB cun cort cfv cort cfv cB cA
      chj co cA cB shjval cA csh wcel cB csh wcel wa cB cA chj co cB cA cun
      cort cfv cort cfv cA cB cun cort cfv cort cfv cB csh wcel cA csh wcel cB
      cA chj co cB cA cun cort cfv cort cfv wceq cB cA shjval ancoms cB cA cun
      cort cfv cA cB cun cort cfv cort cB cA cun cA cB cun cort cB cA uncom
      fveq2i fveq2i syl6eq eqtr4d $.
      $( [22-Jun-2004] $) $( [22-Jun-2004] $)

    ${
      $d x y D $.
      shincl.1 $e |- A e. SH $.
      shincl.2 $e |- B e. SH $.
      $( Closure of intersection of two subspaces. $)
      shincli $p |- ( A i^i B ) e. SH $=
        cA cB cpr cint cA cB cin csh cA cB cA csh shincl.1 elisseti cB csh
        shincl.2 elisseti intpr cA cB cpr cA cB cpr csh wss cA cB cpr c0 wne cA
        csh wcel cB csh wcel wa cA cB cpr csh wss cA csh wcel cB csh wcel
        shincl.1 shincl.2 pm3.2i cA cB csh cA csh shincl.1 elisseti cB csh
        shincl.2 elisseti prss mpbi cA cB cA csh shincl.1 elisseti prnz pm3.2i
        shintcli eqeltrri $.
        $( [19-Oct-1999] $)

      $( Commutative law for subspace sum. $)
      shscomi $p |- ( A +H B ) = ( B +H A ) $=
        cA csh wcel cB csh wcel cA cB cph co cB cA cph co wceq shincl.1
        shincl.2 cA cB shscom mp2an $.
        $( [17-Oct-1999] $)

      $( Vector sum belongs to subspace sum. $)
      shsvai $p |- ( ( C e. A /\ D e. B ) -> ( C +h D ) e. ( A +H B ) ) $=
        cA csh wcel cB csh wcel cC cA wcel cD cB wcel wa cC cD cva co cA cB cph
        co wcel wi shincl.1 shincl.2 cA cB cC cD shsva mp2an $.
        $( [17-Oct-1999] $)

      $( A subspace sum contains a member of one of its subspaces. $)
      shsel1i $p |- ( C e. A -> C e. ( A +H B ) ) $=
        cA csh wcel cB csh wcel cC cA wcel cC cA cB cph co wcel wi shincl.1
        shincl.2 cA cB cC shsel1 mp2an $.
        $( [19-Oct-1999] $)

      $( A subspace sum contains a member of one of its subspaces. $)
      shsel2i $p |- ( C e. B -> C e. ( A +H B ) ) $=
        cA csh wcel cB csh wcel cC cB wcel cC cA cB cph co wcel wi shincl.1
        shincl.2 cA cB cC shsel2 mp2an $.
        $( [19-Oct-1999] $)

      $( Vector subtraction belongs to subspace sum. $)
      shsvsi $p |- ( ( C e. A /\ D e. B ) -> ( C -h D ) e. ( A +H B ) ) $=
        cC cA cB cph co wcel cD cA cB cph co wcel cC cD cmv co cA cB cph co
        wcel cC cA wcel cD cB wcel cA cB cph co csh wcel cC cA cB cph co wcel
        cD cA cB cph co wcel wa cC cD cmv co cA cB cph co wcel wi cA cB
        shincl.1 shincl.2 shscli cC cD cA cB cph co shsubclOLD ax-mp cA cB cC
        shincl.1 shincl.2 shsel1i cA cB cD shincl.1 shincl.2 shsel2i syl2an $.
        $( [19-Oct-1999] $)

      $( Union is smaller than subspace sum. $)
      shunssi $p |- ( A u. B ) C_ ( A +H B ) $=
        vx cA cB cun cA cB cph co vx cv cA wcel vx cv cB wcel wo vx cv vy cv vz
        cv cva co wceq vz cB wrex vy cA wrex vx cv cA cB cun wcel vx cv cA cB
        cph co wcel vx cv cA wcel vx cv vy cv vz cv cva co wceq vz cB wrex vy
        cA wrex vx cv cB wcel vx cv cA wcel vx cv vx cv c0v cva co wceq vx cv
        vy cv vz cv cva co wceq vz cB wrex vy cA wrex vx cv cA wcel vx cv chil
        wcel vx cv vx cv c0v cva co wceq vx cv cA shincl.1 sheli vx cv chil
        wcel vx cv c0v cva co vx cv vx cv ax-hvaddid eqcomd syl vx cv cA wcel
        c0v cB wcel vx cv vx cv c0v cva co wceq vx cv vy cv vz cv cva co wceq
        vz cB wrex vy cA wrex cB csh wcel c0v cB wcel shincl.2 cB sh0 ax-mp vy
        vz cA cB vx cv c0v vx cv cva rcla4eopr mp3an2 mpdan vx cv cB wcel vx cv
        c0v vx cv cva co wceq vx cv vy cv vz cv cva co wceq vz cB wrex vy cA
        wrex vx cv cB wcel vx cv chil wcel vx cv c0v vx cv cva co wceq vx cv cB
        shincl.2 sheli vx cv chil wcel c0v vx cv cva co vx cv vx cv hvaddid2
        eqcomd syl c0v cA wcel vx cv cB wcel vx cv c0v vx cv cva co wceq vx cv
        vy cv vz cv cva co wceq vz cB wrex vy cA wrex cA csh wcel c0v cA wcel
        shincl.1 cA sh0 ax-mp vy vz cA cB c0v vx cv vx cv cva rcla4eopr mp3an1
        mpdan jaoi vx cv cA cB elun vy vz cA cB vx cv shincl.1 shincl.2 shseli
        3imtr4i ssriv $.
        $( [18-Oct-1999] $)

      $( Subspace sum is smaller than Hilbert lattice join.  Remark in
         [Kalmbach] p. 65. $)
      shsleji $p |- ( A +H B ) C_ ( A vH B ) $=
        vx cA cB cph co cA cB chj co vx cv vy cv vz cv cva co wceq vz cB wrex
        vy cA wrex vx cv cA cB cun cort cfv cort cfv wcel vx cv cA cB cph co
        wcel vx cv cA cB chj co wcel vx cv vy cv vz cv cva co wceq vx cv cA cB
        cun cort cfv cort cfv wcel vy vz cA cB vx cv vy cv vz cv cva co wceq vx
        cv cA cB cun cort cfv cort cfv wcel vy cv vz cv cva co cA cB cun cort
        cfv cort cfv wcel vy cv cA wcel vz cv cB wcel wa vx cv vy cv vz cv cva
        co cA cB cun cort cfv cort cfv eleq1 vy cv cA cB cun cort cfv cort cfv
        wcel vz cv cA cB cun cort cfv cort cfv wcel vy cv vz cv cva co cA cB
        cun cort cfv cort cfv wcel vy cv cA wcel vz cv cB wcel cA cB cun cort
        cfv cort cfv csh wcel vy cv cA cB cun cort cfv cort cfv wcel vz cv cA
        cB cun cort cfv cort cfv wcel wa vy cv vz cv cva co cA cB cun cort cfv
        cort cfv wcel wi cA cB cun cort cfv chil wss cA cB cun cort cfv cort
        cfv csh wcel cA cB cun chil wss cA cB cun cort cfv chil wss cA cB chil
        cA shincl.1 shssii cB shincl.2 shssii unssi cA cB cun ocss ax-mp cA cB
        cun cort cfv ocsh ax-mp vy cv vz cv cA cB cun cort cfv cort cfv
        shaddclOLD ax-mp vy cv cA wcel vy cv cA cB cun wcel vy cv cA cB cun
        cort cfv cort cfv wcel vy cv cA cB elun1 cA cB cun cA cB cun cort cfv
        cort cfv vy cv cA cB cun chil wss cA cB cun cA cB cun cort cfv cort cfv
        wss cA cB chil cA shincl.1 shssii cB shincl.2 shssii unssi cA cB cun
        ococss ax-mp sseli syl vz cv cB wcel vz cv cA cB cun wcel vz cv cA cB
        cun cort cfv cort cfv wcel vz cv cB cA elun2 cA cB cun cA cB cun cort
        cfv cort cfv vz cv cA cB cun chil wss cA cB cun cA cB cun cort cfv cort
        cfv wss cA cB chil cA shincl.1 shssii cB shincl.2 shssii unssi cA cB
        cun ococss ax-mp sseli syl syl2an syl5cbir r19.23aivv vy vz cA cB vx cv
        shincl.1 shincl.2 shseli cA cB chj co cA cB cun cort cfv cort cfv vx cv
        cA csh wcel cB csh wcel cA cB chj co cA cB cun cort cfv cort cfv wceq
        shincl.1 shincl.2 cA cB shjval mp2an eleq2i 3imtr4i ssriv $.
        $( [19-Oct-1999] $)

      $( Union is smaller than Hilbert lattice join. $)
      shunssji $p |- ( A u. B ) C_ ( A vH B ) $=
        cA cB cun cA cB cph co cA cB chj co cA cB shincl.1 shincl.2 shunssi cA
        cB shincl.1 shincl.2 shsleji sstri $.
        $( [13-Jun-2004] $) $( [11-Jun-2004] $)

      $( Commutative law for join in ` SH ` . $)
      shjcomi $p |- ( A vH B ) = ( B vH A ) $=
        cA csh wcel cB csh wcel cA cB chj co cB cA chj co wceq shincl.1
        shincl.2 cA cB shjcom mp2an $.
        $( [19-Oct-1999] $)

      $( Subspace sum is an upper bound of its arguments. $)
      shsub1i $p |- A C_ ( A +H B ) $=
        vx cA cA cB cph co cA cB vx cv shincl.1 shincl.2 shsel1i ssriv $.
        $( [19-Oct-1999] $)

      $( Subspace sum is an upper bound of its arguments. $)
      shsub2i $p |- A C_ ( B +H A ) $=
        vx cA cB cA cph co cB cA vx cv shincl.2 shincl.1 shsel2i ssriv $.
        $( [21-Dec-2004] $) $( [17-Dec-2004] $)

      $( Hilbert lattice join is an upper bound of two subspaces. $)
      shub1i $p |- A C_ ( A vH B ) $=
        cA cA cB cph co cA cB chj co cA cB shincl.1 shincl.2 shsub1i cA cB
        shincl.1 shincl.2 shsleji sstri $.
        $( [19-Oct-1999] $)

      $( Closure of ` CH ` join. $)
      shjcli $p |- ( A vH B ) e. CH $=
        cA csh wcel cB csh wcel cA cB chj co cch wcel shincl.1 shincl.2 cA cB
        shjcl mp2an $.
        $( [19-Oct-1999] $)

      $( ` SH ` closure of join. $)
      shjshcli $p |- ( A vH B ) e. SH $=
        cA cB chj co cA cB shincl.1 shincl.2 shjcli chshii $.
        $( [5-May-2000] $)

      ${
        $d x y C $.
        shlub.1 $e |- C e. CH $.
        $( Hilbert lattice join is the least upper bound (among Hilbert
           lattice elements) of two subspaces. $)
        shlubi $p |- ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) $=
          cA cC wss cB cC wss wa cA cB chj co cC wss cA cB cun cC wss cA cB cun
          cort cfv cort cfv cC cort cfv cort cfv wss cA cC wss cB cC wss wa cA
          cB chj co cC wss cA cB cun cC cA cB chil cA shincl.1 shssii cB
          shincl.2 shssii unssi cC shlub.1 chssii occon2i cA cB cC unss cA cB
          chj co cA cB cun cort cfv cort cfv cC cC cort cfv cort cfv cA csh
          wcel cB csh wcel cA cB chj co cA cB cun cort cfv cort cfv wceq
          shincl.1 shincl.2 cA cB shjval mp2an cC cort cfv cort cfv cC cC
          shlub.1 pjococi eqcomi sseq12i 3imtr4i cA cB chj co cC wss cA cC wss
          cB cC wss cA cA cB chj co wss cA cB chj co cC wss cA cC wss cA cB
          shincl.1 shincl.2 shub1i cA cA cB chj co cC sstr mpan cB cA cB chj co
          wss cA cB chj co cC wss cB cC wss cB cA cB cun cA cB chj co cB cA
          ssun2 cA cB shincl.1 shincl.2 shunssji sstri cB cA cB chj co cC sstr
          mpan jca impbii $.
          $( [14-Jun-2004] $) $( [11-Jun-2004] $)
      $}

      ${
        shless.1 $e |- C e. SH $.
        $( Subset implies subset of subspace sum. $)
        shlessi $p |- ( A C_ B -> ( A +H C ) C_ ( B +H C ) ) $=
          cA cB wss vx cA cC cph co cB cC cph co cA cB wss vx cv vy cv vz cv
          cva co wceq vz cC wrex vy cA wrex vx cv vy cv vz cv cva co wceq vz cC
          wrex vy cB wrex vx cv cA cC cph co wcel vx cv cB cC cph co wcel cA cB
          wss vx cv vy cv vz cv cva co wceq vz cC wrex vx cv vy cv vz cv cva co
          wceq vz cC wrex vy cA cB cA cB wss vy cv cA wcel vy cv cB wcel vx cv
          vy cv vz cv cva co wceq vz cC wrex cA cB vy cv ssel anim1d r19.22dv2
          vy vz cA cC vx cv shincl.1 shless.1 shseli vy vz cB cC vx cv shincl.2
          shless.1 shseli 3imtr4g ssrdv $.
          $( [18-Nov-2000] $)

        $( Add disjunct to both sides of Hilbert subspace ordering. $)
        shlej1i $p |- ( A C_ B -> ( A vH C ) C_ ( B vH C ) ) $=
          cA cB wss cA cB cC chj co wss cC cB cC chj co wss wa cA cC chj co cB
          cC chj co wss cA cB wss cA cB cC chj co wss cC cB cC chj co wss cA cB
          wss cB cB cC chj co wss cA cB cC chj co wss cB cC shincl.2 shless.1
          shub1i cA cB cB cC chj co sstr2 mpi cC cC cB chj co cB cC chj co cC
          cB shless.1 shincl.2 shub1i cC cB shless.1 shincl.2 shjcomi sseqtri
          jctir cA cC cB cC chj co shincl.1 shless.1 cB cC shincl.2 shless.1
          shjcli shlubi sylib $.
          $( [19-Oct-1999] $)

        $( Add disjunct to both sides of Hilbert subspace ordering. $)
        shlej2i $p |- ( A C_ B -> ( C vH A ) C_ ( C vH B ) ) $=
          cA cB wss cA cC chj co cB cC chj co cC cA chj co cC cB chj co cA cB
          cC shincl.1 shincl.2 shless.1 shlej1i cC cA shless.1 shincl.1 shjcomi
          cC cB shless.1 shincl.2 shjcomi 3sstr4g $.
          $( [19-Oct-1999] $)
      $}
    $}
  $}

  $( Subspace sum is smaller than subspace join.  Remark in [Kalmbach]
     p. 65. $)
  shslej $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) C_ ( A vH B ) ) $=
    cA csh wcel cB csh wcel cA cB cph co cA cB chj co wss cA csh wcel cA chil
    cif cB cph co cA csh wcel cA chil cif cB chj co wss cA csh wcel cA chil cif
    cB csh wcel cB chil cif cph co cA csh wcel cA chil cif cB csh wcel cB chil
    cif chj co wss cA cB chil chil cA cA csh wcel cA chil cif wceq cA cB cph co
    cA csh wcel cA chil cif cB cph co cA cB chj co cA csh wcel cA chil cif cB
    chj co cA cA csh wcel cA chil cif cB cph opreq1 cA cA csh wcel cA chil cif
    cB chj opreq1 sseq12d cB cB csh wcel cB chil cif wceq cA csh wcel cA chil
    cif cB cph co cA csh wcel cA chil cif cB csh wcel cB chil cif cph co cA csh
    wcel cA chil cif cB chj co cA csh wcel cA chil cif cB csh wcel cB chil cif
    chj co cB cB csh wcel cB chil cif cA csh wcel cA chil cif cph opreq2 cB cB
    csh wcel cB chil cif cA csh wcel cA chil cif chj opreq2 sseq12d cA csh wcel
    cA chil cif cB csh wcel cB chil cif cA chil csh helsh elimel cB chil csh
    helsh elimel shsleji dedth2h $.
    $( [26-Aug-2004] $) $( [12-Jul-2004] $)

  $( Closure of intersection of two subspaces. $)
  shincl $p |- ( ( A e. SH /\ B e. SH ) -> ( A i^i B ) e. SH ) $=
    cA csh wcel cB csh wcel cA cB cin csh wcel cA csh wcel cA chil cif cB cin
    csh wcel cA csh wcel cA chil cif cB csh wcel cB chil cif cin csh wcel cA cB
    chil chil cA cA csh wcel cA chil cif wceq cA cB cin cA csh wcel cA chil cif
    cB cin csh cA cA csh wcel cA chil cif cB ineq1 eleq1d cB cB csh wcel cB
    chil cif wceq cA csh wcel cA chil cif cB cin cA csh wcel cA chil cif cB csh
    wcel cB chil cif cin csh cB cB csh wcel cB chil cif cA csh wcel cA chil cif
    ineq2 eleq1d cA csh wcel cA chil cif cB csh wcel cB chil cif cA chil csh
    helsh elimel cB chil csh helsh elimel shincli dedth2h $.
    $( [24-Jun-2004] $) $( [24-Jun-2004] $)

  $( Hilbert lattice join is an upper bound of two subspaces. $)
  shub1 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( A vH B ) ) $=
    cA csh wcel cB csh wcel wa cA cA cB cph co cA cB chj co cA cB shsub1 cA cB
    shslej sstrd $.
    $( [22-Jun-2004] $) $( [22-Jun-2004] $)

  $( A subspace is a subset of its Hilbert lattice join with another. $)
  shub2 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( B vH A ) ) $=
    cA csh wcel cB csh wcel wa cA cA cB chj co cB cA chj co cA cB shub1 cA cB
    shjcom sseqtrd $.
    $( [23-Jun-2004] $) $( [22-Jun-2004] $)

  $( Hilbert lattice join is the least upper bound (among Hilbert lattice
     elements) of two subspaces. $)
  shlub $p |- ( ( A e. SH /\ B e. SH /\ C e. CH ) ->
               ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) ) $=
    cA csh wcel cB csh wcel cC cch wcel cA cC wss cB cC wss wa cA cB chj co cC
    wss wb cA csh wcel cA chil cif cC wss cB cC wss wa cA csh wcel cA chil cif
    cB chj co cC wss wb cA cB cC chil chil chil cA csh wcel cA chil cif cC wss
    cB csh wcel cB chil cif cC wss wa cA csh wcel cA chil cif cB csh wcel cB
    chil cif chj co cC wss wb cA csh wcel cA chil cif cC cch wcel cC chil cif
    wss cB csh wcel cB chil cif cC cch wcel cC chil cif wss wa cA csh wcel cA
    chil cif cB csh wcel cB chil cif chj co cC cch wcel cC chil cif wss wb cA
    cA csh wcel cA chil cif wceq cA cC wss cB cC wss wa cA csh wcel cA chil cif
    cC wss cB cC wss wa cA cB chj co cC wss cA csh wcel cA chil cif cB chj co
    cC wss cA cA csh wcel cA chil cif wceq cA cC wss cA csh wcel cA chil cif cC
    wss cB cC wss cA cA csh wcel cA chil cif cC sseq1 anbi1d cA cA csh wcel cA
    chil cif wceq cA cB chj co cA csh wcel cA chil cif cB chj co cC cA cA csh
    wcel cA chil cif cB chj opreq1 sseq1d bibi12d cB cB csh wcel cB chil cif
    wceq cA csh wcel cA chil cif cC wss cB cC wss wa cA csh wcel cA chil cif cC
    wss cB csh wcel cB chil cif cC wss wa cA csh wcel cA chil cif cB chj co cC
    wss cA csh wcel cA chil cif cB csh wcel cB chil cif chj co cC wss cB cB csh
    wcel cB chil cif wceq cB cC wss cB csh wcel cB chil cif cC wss cA csh wcel
    cA chil cif cC wss cB cB csh wcel cB chil cif cC sseq1 anbi2d cB cB csh
    wcel cB chil cif wceq cA csh wcel cA chil cif cB chj co cA csh wcel cA chil
    cif cB csh wcel cB chil cif chj co cC cB cB csh wcel cB chil cif cA csh
    wcel cA chil cif chj opreq2 sseq1d bibi12d cC cC cch wcel cC chil cif wceq
    cA csh wcel cA chil cif cC wss cB csh wcel cB chil cif cC wss wa cA csh
    wcel cA chil cif cC cch wcel cC chil cif wss cB csh wcel cB chil cif cC cch
    wcel cC chil cif wss wa cA csh wcel cA chil cif cB csh wcel cB chil cif chj
    co cC wss cA csh wcel cA chil cif cB csh wcel cB chil cif chj co cC cch
    wcel cC chil cif wss cC cC cch wcel cC chil cif wceq cA csh wcel cA chil
    cif cC wss cA csh wcel cA chil cif cC cch wcel cC chil cif wss cB csh wcel
    cB chil cif cC wss cB csh wcel cB chil cif cC cch wcel cC chil cif wss cC
    cC cch wcel cC chil cif cA csh wcel cA chil cif sseq2 cC cC cch wcel cC
    chil cif cB csh wcel cB chil cif sseq2 anbi12d cC cC cch wcel cC chil cif
    cA csh wcel cA chil cif cB csh wcel cB chil cif chj co sseq2 bibi12d cA csh
    wcel cA chil cif cB csh wcel cB chil cif cC cch wcel cC chil cif cA chil
    csh helsh elimel cB chil csh helsh elimel cC chil cch helch elimel shlubi
    dedth3h $.
    $( [15-Jun-2004] $) $( [15-Jun-2004] $)

  $( Add disjunct to both sides of Hilbert subspace ordering. $)
  shlej1 $p |- ( ( ( A e. SH /\ B e. SH /\ C e. SH ) /\
               A C_ B ) -> ( A vH C ) C_ ( B vH C ) ) $=
    cA csh wcel cB csh wcel cC csh wcel w3a cA cB wss cA cC chj co cB cC chj co
    wss cA csh wcel cB csh wcel cC csh wcel w3a cA cB wss cA cB cC chj co wss
    cC cB cC chj co wss wa cA cC chj co cB cC chj co wss cB csh wcel cC csh
    wcel cA cB wss cA cB cC chj co wss cC cB cC chj co wss wa wi cA csh wcel cB
    csh wcel cC csh wcel wa cA cB wss cA cB cC chj co wss cC cB cC chj co wss
    cA cB wss cB cB cC chj co wss cA cB cC chj co wss cB csh wcel cC csh wcel
    wa cA cB cB cC chj co sstr2 cB cC shub1 syl5com cC csh wcel cB csh wcel cC
    cB cC chj co wss cC cB shub2 ancoms jctird 3adant1 cA csh wcel cC csh wcel
    cB cC chj co cch wcel cA cB cC chj co wss cC cB cC chj co wss wa cA cC chj
    co cB cC chj co wss wb cA csh wcel cB csh wcel cC csh wcel w3a cA cC cB cC
    chj co shlub cA csh wcel cB csh wcel cC csh wcel 3simp1 cA csh wcel cB csh
    wcel cC csh wcel 3simp3 cB csh wcel cC csh wcel cB cC chj co cch wcel cA
    csh wcel cB cC shjcl 3adant1 syl3anc sylibd imp $.
    $( [27-Dec-2006] $) $( [22-Jun-2004] $)

  $( Add disjunct to both sides of Hilbert subspace ordering. $)
  shlej2 $p |- ( ( ( A e. SH /\ B e. SH /\ C e. SH ) /\
               A C_ B ) -> ( C vH A ) C_ ( C vH B ) ) $=
    cA csh wcel cB csh wcel cC csh wcel w3a cA cB wss wa cA cC chj co cB cC chj
    co cC cA chj co cC cB chj co cA cB cC shlej1 cA csh wcel cB csh wcel cC csh
    wcel w3a cA cC chj co cC cA chj co wceq cA cB wss cA csh wcel cC csh wcel
    cA cC chj co cC cA chj co wceq cB csh wcel cA cC shjcom 3adant2 adantr cA
    csh wcel cB csh wcel cC csh wcel w3a cB cC chj co cC cB chj co wceq cA cB
    wss cB csh wcel cC csh wcel cB cC chj co cC cB chj co wceq cA csh wcel cB
    cC shjcom 3adant1 adantr 3sstr3d $.
    $( [3-Jan-2007] $) $( [22-Jun-2004] $)

  ${
    $d x y z A $.
    shsidm.1 $e |- A e. SH $.
    $( Idempotent law for Hilbert subspace sum. $)
    shsidmi $p |- ( A +H A ) = A $=
      cA cA cph co cA vx cA cA cph co cA vx cv cA cA cph co wcel vx cv vy cv vz
      cv cva co wceq vz cA wrex vy cA wrex vx cv cA wcel vy vz cA cA vx cv
      shsidm.1 shsidm.1 shseli vx cv vy cv vz cv cva co wceq vx cv cA wcel vy
      vz cA cA vx cv vy cv vz cv cva co wceq vx cv cA wcel vy cv vz cv cva co
      cA wcel vy cv cA wcel vz cv cA wcel wa vx cv vy cv vz cv cva co cA eleq1
      cA csh wcel vy cv cA wcel vz cv cA wcel wa vy cv vz cv cva co cA wcel wi
      shsidm.1 vy cv vz cv cA shaddclOLD ax-mp syl5cbir r19.23aivv sylbi ssriv
      cA cA shsidm.1 shsidm.1 shsub1i eqssi $.
      $( [14-Jun-2004] $) $( [6-Jun-2004] $)
  $}

  ${
    shslub.1 $e |- A e. SH $.
    shslub.2 $e |- B e. SH $.
    shslub.3 $e |- C e. SH $.
    $( Least upper bound law for Hilbert subspace sum. $)
    shslubi $p |- ( ( A C_ C /\ B C_ C ) <-> ( A +H B ) C_ C ) $=
      cA cC wss cB cC wss wa cA cB cph co cC wss cA cC wss cB cC wss cA cB cph
      co cB cC cph co cC cA cC wss cA cB cph co cC cB cph co cB cC cph co cA cC
      cB shslub.1 shslub.3 shslub.2 shlessi cC cB shslub.3 shslub.2 shscomi
      syl6ss cB cC wss cB cC cph co cC cC cph co cC cB cC cC shslub.2 shslub.3
      shslub.3 shlessi cC shslub.3 shsidmi syl6ss sylan9ss cA cB cph co cC wss
      cA cC wss cB cC wss cA cA cB cph co wss cA cB cph co cC wss cA cC wss cA
      cB shslub.1 shslub.2 shsub1i cA cA cB cph co cC sstr mpan cB cA cB cph co
      wss cA cB cph co cC wss cB cC wss cB cA shslub.2 shslub.1 shsub2i cB cA
      cB cph co cC sstr mpan jca impbii $.
      $( [15-Jun-2004] $) $( [15-Jun-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    shlesb1.1 $e |- A e. SH $.
    shlesb1.2 $e |- B e. SH $.
    $( Hilbert lattice ordering in terms of subspace sum. $)
    shlesb1i $p |- ( A C_ B <-> ( A +H B ) = B ) $=
      cA cB wss cB cB wss cA cB wss wa cB cA cph co cB wss cA cB cph co cB wceq
      cB cB wss cA cB wss cB ssid biantrur cB cA cB shlesb1.2 shlesb1.1
      shlesb1.2 shslubi cA cB cph co cB wceq cA cB cph co cB wss cB cA cph co
      cB wss cA cB cph co cB wceq cA cB cph co cB wss cB cA cB cph co wss cA cB
      cph co cB eqss cB cA shlesb1.2 shlesb1.1 shsub2i mpbiran2 cA cB cph co cB
      cA cph co cB cA cB shlesb1.1 shlesb1.2 shscomi sseq1i bitr2i 3bitri $.
      $( [29-Nov-2004] $) $( [23-Nov-2004] $)

    $( An alternate way to express subspace sum. $)
    shsumval2i $p |- ( A +H B ) = |^| { x e. SH | ( A u. B ) C_ x } $=
      cA cB cph co cA cB cun vx cv wss vx csh crab cint cA cA cB cun vx cv wss
      vx csh crab cint wss cB cA cB cun vx cv wss vx csh crab cint wss wa cA cB
      cph co cA cB cun vx cv wss vx csh crab cint wss cA cA cB cun vx cv wss vx
      csh crab cint wss cB cA cB cun vx cv wss vx csh crab cint wss cA cA cB
      cun cA cB cun vx cv wss vx csh crab cint cA cB ssun1 vx cA cB cun csh
      ssintub sstri cB cA cB cun cA cB cun vx cv wss vx csh crab cint cB cA
      ssun2 vx cA cB cun csh ssintub sstri pm3.2i cA cB cA cB cun vx cv wss vx
      csh crab cint shlesb1.1 shlesb1.2 cA cB cun vx cv wss vx csh crab csh wss
      cA cB cun vx cv wss vx csh crab c0 wne cA cB cun vx cv wss vx csh crab
      cint csh wcel cA cB cun vx cv wss vx csh ssrab2 cA cB cun vx cv wss vx
      csh crab c0 wne cA cB cun vx cv wss vx csh wrex cA cB cph co csh wcel cA
      cB cun cA cB cph co wss cA cB cun vx cv wss vx csh wrex cA cB shlesb1.1
      shlesb1.2 shscli cA cB shlesb1.1 shlesb1.2 shunssi cA cB cun vx cv wss cA
      cB cun cA cB cph co wss vx cA cB cph co csh vx cv cA cB cph co cA cB cun
      sseq2 rcla4ev mp2an cA cB cun vx cv wss vx csh rabn0 mpbir cA cB cun vx
      cv wss vx csh crab shintcl mp2an shslubi mpbi cA cB cph co cA cB cun vx
      cv wss vx csh crab wcel cA cB cun vx cv wss vx csh crab cint cA cB cph co
      wss cA cB cph co cA cB cun vx cv wss vx csh crab wcel cA cB cph co csh
      wcel cA cB cun cA cB cph co wss cA cB cun vx cv wss cA cB cun cA cB cph
      co wss vx cA cB cph co csh vx cv cA cB cph co cA cB cun sseq2 elrab cA cB
      shlesb1.1 shlesb1.2 shscli cA cB shlesb1.1 shlesb1.2 shunssi mpbir2an cA
      cB cph co cA cB cun vx cv wss vx csh crab intss1 ax-mp eqssi $.
      $( [2-Dec-2004] $) $( [25-Nov-2004] $)

    $( An alternate way to express subspace sum. $)
    shsumval3i $p |- ( A +H B ) = ( span ` ( A u. B ) ) $=
      cA cB cph co cA cB cun vx cv wss vx csh crab cint cA cB cun cspn cfv vx
      cA cB shlesb1.1 shlesb1.2 shsumval2i cA cB cun chil wss cA cB cun cspn
      cfv cA cB cun vx cv wss vx csh crab cint wceq cA cB chil cA shlesb1.1
      shssii cB shlesb1.2 shssii unssi vx cA cB cun spanval ax-mp eqtr4i $.
      $( [2-Dec-2004] $) $( [25-Nov-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    shmod.1 $e |- A e. SH $.
    shmod.2 $e |- B e. SH $.
    shmod.3 $e |- C e. SH $.
    $( The modular law holds for subspace sum.  Similar to part of Theorem 16.9
       of [MaedaMaeda] p. 70. $)
    shmodsi $p |- ( A C_ C -> ( ( A +H B ) i^i C ) C_ ( A +H ( B i^i C ) ) ) $=
      cA cC wss vz cA cB cph co cC cin cA cB cC cin cph co cA cC wss vz cv cA
      cB cph co wcel vz cv cC wcel wa vz cv cA cB cC cin cph co wcel vz cv cA
      cB cph co cC cin wcel cA cC wss vz cv cA cB cph co wcel vz cv cC wcel vz
      cv cA cB cC cin cph co wcel vz cv cC wcel vz cv cA cB cph co wcel cA cC
      wss vz cv cA cB cC cin cph co wcel vz cv cC wcel vz cv vx cv vy cv cva co
      wceq vy cB wrex vx cA wrex cA cC wss vz cv cA cB cC cin cph co wcel wi vz
      cv cA cB cph co wcel vz cv cC wcel vz cv vx cv vy cv cva co wceq cA cC
      wss vz cv cA cB cC cin cph co wcel wi vx vy cA cB vz cv cC wcel vx cv cA
      wcel vy cv cB wcel wa vz cv vx cv vy cv cva co wceq cA cC wss vz cv cA cB
      cC cin cph co wcel wi vz cv cC wcel vx cv cA wcel vy cv cB wcel wa wa vz
      cv vx cv vy cv cva co wceq wa cA cC wss vy cv cB cC cin wcel vz cv cA cB
      cC cin cph co wcel vz cv cC wcel vx cv cA wcel vy cv cB wcel wa wa vz cv
      vx cv vy cv cva co wceq cA cC wss vy cv cB cC cin wcel wi vz cv cC wcel
      vx cv cA wcel vy cv cB wcel wa wa vz cv vx cv vy cv cva co wceq vz cv vx
      cv cmv co vy cv wceq cA cC wss vy cv cB cC cin wcel wi vz cv cC wcel vx
      cv cA wcel vy cv cB wcel vz cv vx cv cmv co vy cv wceq vz cv vx cv vy cv
      cva co wceq wb vz cv cC wcel vx cv cA wcel vy cv cB wcel w3a vz cv vx cv
      cmv co vy cv wceq vx cv vy cv cva co vz cv wceq vz cv vx cv vy cv cva co
      wceq vz cv chil wcel vx cv chil wcel vy cv chil wcel vz cv vx cv cmv co
      vy cv wceq vx cv vy cv cva co vz cv wceq wb vz cv cC wcel vx cv cA wcel
      vy cv cB wcel vz cv vx cv vy cv hvsubadd vz cv cC shmod.3 sheli vx cv cA
      shmod.1 sheli vy cv cB shmod.2 sheli syl3an vx cv vy cv cva co vz cv
      eqcom syl6bb 3expb vz cv cC wcel vx cv cA wcel vy cv cB wcel vz cv vx cv
      cmv co vy cv wceq cA cC wss vy cv cB cC cin wcel wi wi vy cv cB wcel vz
      cv cC wcel vx cv cA wcel wa vz cv vx cv cmv co vy cv wceq cA cC wss vy cv
      cB cC cin wcel wi wi cA cC wss vz cv vx cv cmv co vy cv wceq vy cv cB
      wcel vz cv cC wcel vx cv cA wcel wa wa vy cv cB cC cin wcel cA cC wss vz
      cv vx cv cmv co vy cv wceq vy cv cB wcel vz cv cC wcel vx cv cA wcel wa
      wa vy cv cB cC cin wcel wi cA cC wss vz cv vx cv cmv co vy cv wceq wa vy
      cv cB wcel vz cv cC wcel vx cv cA wcel wa wa vy cv cB wcel vy cv cC wcel
      wa vy cv cB cC cin wcel cA cC wss vz cv vx cv cmv co vy cv wceq wa vz cv
      cC wcel vx cv cA wcel wa vy cv cC wcel vy cv cB wcel cA cC wss vz cv cC
      wcel vx cv cA wcel wa vz cv vx cv cmv co cC wcel vz cv vx cv cmv co vy cv
      wceq vy cv cC wcel cA cC wss vz cv vx cv cmv co cA cC cph co wcel vz cv
      vx cv cmv co cC wcel vz cv cC wcel vx cv cA wcel wa cA cC wss cA cC cph
      co cC vz cv vx cv cmv co cA cC wss cA cC cph co cC wceq cA cC shmod.1
      shmod.3 shlesb1i biimpi eleq2d vz cv cC wcel vx cv cA wcel wa vz cv vx cv
      cmv co cC cA cph co cA cC cph co cC cA vz cv vx cv shmod.3 shmod.1 shsvsi
      cC cA shmod.3 shmod.1 shscomi syl6eleq syl5bi vz cv vx cv cmv co vy cv
      wceq vz cv vx cv cmv co cC wcel vy cv cC wcel vz cv vx cv cmv co vy cv cC
      eleq1 biimpd sylan9 anim2d vy cv cB cC elin syl6ibr ex com13 ancoms
      anasss sylbird imp vz cv cC wcel vx cv cA wcel vy cv cB wcel wa wa vz cv
      vx cv vy cv cva co wceq vy cv cB cC cin wcel vz cv cA cB cC cin cph co
      wcel wi vx cv cA wcel vz cv vx cv vy cv cva co wceq vy cv cB cC cin wcel
      vz cv cA cB cC cin cph co wcel wi wi vz cv cC wcel vy cv cB wcel vz cv vx
      cv vy cv cva co wceq vx cv cA wcel vy cv cB cC cin wcel vz cv cA cB cC
      cin cph co wcel wi vz cv vx cv vy cv cva co wceq vx cv cA wcel vy cv cB
      cC cin wcel vz cv cA cB cC cin cph co wcel vz cv vx cv vy cv cva co wceq
      vz cv cA cB cC cin cph co wcel vx cv vy cv cva co cA cB cC cin cph co
      wcel vx cv cA wcel vy cv cB cC cin wcel wa vz cv vx cv vy cv cva co cA cB
      cC cin cph co eleq1 cA cB cC cin vx cv vy cv shmod.1 cB cC shmod.2
      shmod.3 shincli shsvai syl5bir exp3a com12 ad2antrl imp syld exp31
      r19.23advv vx vy cA cB vz cv shmod.1 shmod.2 shseli syl5ib com13 imp3a vz
      cv cA cB cph co cC elin syl5ib ssrdv $.
      $( [2-Dec-2004] $) $( [23-Nov-2004] $)

    $( The modular law is implied by the closure of subspace sum.  Part of
       proof of Theorem 16.9 of [MaedaMaeda] p. 70. $)
    shmodi $p |- ( ( ( A +H B ) = ( A vH B ) /\ A C_ C ) ->
                ( ( A vH B ) i^i C ) C_ ( A vH ( B i^i C ) ) ) $=
      cA cB cph co cA cB chj co wceq cA cC wss wa cA cB chj co cC cin cA cB cC
      cin cph co wss cA cB chj co cC cin cA cB cC cin chj co wss cA cB cph co
      cA cB chj co wceq cA cC wss cA cB chj co cC cin cA cB cC cin cph co wss
      cA cB cph co cA cB chj co wceq cA cB cph co cC cin cA cB cC cin cph co
      wss cA cB chj co cC cin cA cB cC cin cph co wss cA cC wss cA cB cph co cA
      cB chj co wceq cA cB cph co cC cin cA cB chj co cC cin cA cB cC cin cph
      co cA cB cph co cA cB chj co cC ineq1 sseq1d cA cB cC shmod.1 shmod.2
      shmod.3 shmodsi syl5bi imp cA cB chj co cC cin cA cB cC cin cph co wss cA
      cB cC cin cph co cA cB cC cin chj co wss cA cB chj co cC cin cA cB cC cin
      chj co wss cA cB cC cin shmod.1 cB cC shmod.2 shmod.3 shincli shsleji cA
      cB chj co cC cin cA cB cC cin cph co cA cB cC cin chj co sstr mpan2 syl
      $.
      $( [4-Dec-2004] $) $( [23-Nov-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Hilbert lattice operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The zero subspace is the smallest subspace. $)
  sh0le $p |- ( A e. SH -> 0H C_ A ) $=
    cA csh wcel c0v csn cA c0h cA csh wcel c0v cA wcel c0v csn cA wss cA sh0
    c0v cA snssi syl df-ch0 syl5ss $.
    $( [4-Jun-2004] $) $( [3-Jun-2004] $)

  $( The zero subspace is the smallest member of ` CH ` . $)
  ch0le $p |- ( A e. CH -> 0H C_ A ) $=
    cA cch wcel cA csh wcel c0h cA wss cA chsh cA sh0le syl $.
    $( [14-Aug-2002] $)

  $( No subspace is smaller than the zero subspace. $)
  shle0 $p |- ( A e. SH -> ( A C_ 0H <-> A = 0H ) ) $=
    cA csh wcel cA c0h wss cA c0h wss c0h cA wss wa cA c0h wceq cA csh wcel c0h
    cA wss cA c0h wss cA sh0le biantrud cA c0h eqss syl6bbr $.
    $( [26-Nov-2004] $) $( [24-Nov-2004] $)

  $( No Hilbert lattice element is smaller than zero. $)
  chle0 $p |- ( A e. CH -> ( A C_ 0H <-> A = 0H ) ) $=
    cA cch wcel cA csh wcel cA c0h wss cA c0h wceq wb cA chsh cA shle0 syl $.
    $( [14-Aug-2002] $)

  $( A Hilbert lattice element that is not a subset of another is nonzero. $)
  chnlen0 $p |- ( B e. CH -> ( -. A C_ B -> -. A = 0H ) ) $=
    cB cch wcel cA c0h wceq cA cB wss cA c0h wceq cA cB wss c0h cB wss cB cch
    wcel cA c0h cB sseq1 cB ch0le syl5cbir con3d $.
    $( [2-Jul-2004] $) $( [30-Jun-2004] $)

  $( The zero subspace is a proper subset of non-zero Hilbert lattice
     elements. $)
  ch0pss $p |- ( A e. CH -> ( 0H C. A <-> A =/= 0H ) ) $=
    cA cch wcel cA c0h wne c0h cA wss c0h cA wne wa c0h cA wpss cA cch wcel c0h
    cA wne c0h cA wss c0h cA wne wa cA c0h wne cA cch wcel c0h cA wss c0h cA
    wne cA ch0le biantrurd c0h cA necom syl5bbr c0h cA df-pss syl6rbbr $.
    $( [18-Jun-2006] $) $( [9-Jun-2004] $)

  $( The intersection of orthogonal subspaces is the zero subspace. $)
  orthin $p |- ( ( A e. SH /\ B e. SH ) ->
               ( A C_ ( _|_ ` B ) -> ( A i^i B ) = 0H ) ) $=
    cA csh wcel cB csh wcel wa cA cB cort cfv wss cA cB cin c0h wss c0h cA cB
    cin wss wa cA cB cin c0h wceq cA csh wcel cB csh wcel wa cA cB cort cfv wss
    cA cB cin c0h wss c0h cA cB cin wss cB csh wcel cA cB cort cfv wss cA cB
    cin c0h wss wi cA csh wcel cB csh wcel cA cB cin cB cB cort cfv cin wss cA
    cB cin c0h wss cA cB cort cfv wss cB csh wcel cB cB cort cfv cin c0h cA cB
    cin cB ocin sseq2d cA cB cort cfv wss cA cB cin cB cort cfv cB cin cB cB
    cort cfv cin cA cB cort cfv cB ssrin cB cort cfv cB incom syl6ss syl5bi
    adantl cA csh wcel cB csh wcel wa cA cB cin csh wcel c0h cA cB cin wss cA
    cB shincl cA cB cin sh0le syl jctird cA cB cin c0h eqss syl6ibr $.
    $( [24-Jun-2004] $) $( [24-Jun-2004] $)

  ${
    $d x y A $.
    shne0.1 $e |- A e. SH $.
    $( A non-zero subspace has a non-zero vector. $)
    shne0i $p |- ( A =/= 0H <-> E. x e. A x =/= 0h ) $=
      cA c0h wne cA c0h wceq wn vx cv c0h wcel wn vx cA wrex vx cv c0v wne vx
      cA wrex cA c0h df-ne vx cv c0h wcel wn vx cA wrex vx cv cA wcel vx cv c0h
      wcel wn wa vx wex cA c0h wss wn cA c0h wceq wn vx cv c0h wcel wn vx cA
      df-rex vx cA c0h nss cA c0h wss cA c0h wceq cA csh wcel cA c0h wss cA c0h
      wceq wb shne0.1 cA shle0 ax-mp notbii 3bitr2ri vx cv c0h wcel wn vx cv
      c0v wne vx cA vx cv c0h wcel vx cv c0v vx cv elch0 necon3bbii rexbii
      3bitri $.
      $( [18-Mar-2006] $) $( [25-Feb-2006] $)

    $( Hilbert subspace sum with the zero subspace. $)
    shs0i $p |- ( A +H 0H ) = A $=
      cA c0h cph co cA c0h cun cspn cfv cA cspn cfv cA cA c0h shne0.1 h0elsh
      shsumval3i cA c0h cun cA cspn c0h cA wss cA c0h cun cA wceq cA csh wcel
      c0h cA wss shne0.1 cA sh0le ax-mp c0h cA ssequn2 mpbi fveq2i cA csh wcel
      cA cspn cfv cA wceq shne0.1 cA spanid ax-mp 3eqtri $.
      $( [17-Jan-2005] $) $( [14-Jan-2005] $)

    ${
      shs00.2 $e |- B e. SH $.
      $( Two subspaces are zero iff their join is zero. $)
      shs00i $p |- ( ( A = 0H /\ B = 0H ) <-> ( A +H B ) = 0H ) $=
        cA c0h wceq cB c0h wceq wa cA cB cph co c0h wceq cA c0h wceq cB c0h
        wceq wa cA cB cph co c0h c0h cph co c0h cA c0h cB c0h cph opreq12 c0h
        h0elsh shs0i syl6eq cA cB cph co c0h wceq cA c0h wceq cB c0h wceq cA cB
        cph co c0h wceq cA c0h wss cA c0h wceq cA cB cph co c0h wceq cA cA cB
        cph co wss cA c0h wss cA cB shne0.1 shs00.2 shsub1i cA cB cph co c0h cA
        sseq2 mpbii cA csh wcel cA c0h wss cA c0h wceq wb shne0.1 cA shle0
        ax-mp sylib cA cB cph co c0h wceq cB c0h wss cB c0h wceq cA cB cph co
        c0h wceq cB cA cB cph co wss cB c0h wss cB cA shs00.2 shne0.1 shsub2i
        cA cB cph co c0h cB sseq2 mpbii cB csh wcel cB c0h wss cB c0h wceq wb
        shs00.2 cB shle0 ax-mp sylib jca impbii $.
        $( [11-Aug-2004] $) $( [7-Aug-2004] $)
    $}
  $}

  ${
    $d x y A $.
    ch0le.1 $e |- A e. CH $.
    $( The closed subspace zero is the smallest member of ` CH ` . $)
    ch0lei $p |- 0H C_ A $=
      cA cch wcel c0h cA wss ch0le.1 cA ch0le ax-mp $.
      $( [15-Oct-1999] $)

    $( No Hilbert closed subspace is smaller than zero. $)
    chle0i $p |- ( A C_ 0H <-> A = 0H ) $=
      cA cch wcel cA c0h wss cA c0h wceq wb ch0le.1 cA chle0 ax-mp $.
      $( [7-Apr-2001] $)

    $( A non-zero closed subspace has a non-zero vector. $)
    chne0i $p |- ( A =/= 0H <-> E. x e. A x =/= 0h ) $=
      vx cA cA ch0le.1 chshii shne0i $.
      $( [19-Mar-2006] $) $( [25-Feb-2006] $)

    $( Intersection of a closed subspace and its orthocomplement.  Part of
       Proposition 1 of [Kalmbach] p. 65. $)
    chocini $p |- ( A i^i ( _|_ ` A ) ) = 0H $=
      cA csh wcel cA cA cort cfv cin c0h wceq cA ch0le.1 chshii cA ocin ax-mp
      $.
      $( [6-Aug-2004] $) $( [11-Oct-1999] $)

    $( Join with lattice zero in ` CH ` . $)
    chj0i $p |- ( A vH 0H ) = A $=
      cA c0h chj co cA c0h cun cort cfv cort cfv cA cort cfv cort cfv cA cA c0h
      ch0le.1 h0elch chjvali cA c0h cun cort cfv cA cort cfv cort cA c0h cun cA
      cort c0h cA wss cA c0h cun cA wceq cA ch0le.1 ch0lei c0h cA ssequn2 mpbi
      fveq2i fveq2i cA ch0le.1 pjococi 3eqtri $.
      $( [15-Oct-1999] $)

    $( Meet with lattice one in ` CH ` . $)
    chm1i $p |- ( A i^i ~H ) = A $=
      cA chil cin cA cA chil inss1 cA cA chil cA ssid cA ch0le.1 chssii ssini
      eqssi $.
      $( [24-Oct-1999] $)

    ${
      $d x y B $.  $d x y C $.
      chjcl.2 $e |- B e. CH $.
      $( Closure of ` CH ` join. $)
      chjcli $p |- ( A vH B ) e. CH $=
        cA cB cA ch0le.1 chshii cB chjcl.2 chshii shjcli $.
        $( [29-Jul-1999] $)

      $( Subspace sum is smaller than subspace join.  Remark in [Kalmbach]
         p. 65. $)
      chsleji $p |- ( A +H B ) C_ ( A vH B ) $=
        cA cB cA ch0le.1 chshii cB chjcl.2 chshii shsleji $.
        $( [17-Oct-1999] $)

      $( Membership in subspace sum. $)
      chseli $p |- ( C e. ( A +H B )
           <-> E. x e. A E. y e. B C = ( x +h y ) ) $=
        vx vy cA cB cC cA ch0le.1 chshii cB chjcl.2 chshii shseli $.
        $( [19-Oct-1999] $)

      $( Closure of Hilbert lattice intersection. $)
      chincli $p |- ( A i^i B ) e. CH $=
        cA cB cpr cint cA cB cin cch cA cB cA cch ch0le.1 elisseti cB cch
        chjcl.2 elisseti intpr cA cB cpr cA cB cpr cch wss cA cB cpr c0 wne cA
        cch wcel cB cch wcel wa cA cB cpr cch wss cA cch wcel cB cch wcel
        ch0le.1 chjcl.2 pm3.2i cA cB cch cA cch ch0le.1 elisseti cB cch chjcl.2
        elisseti prss mpbi cA cB cA cch ch0le.1 elisseti prnz pm3.2i chintcli
        eqeltrri $.
        $( [15-Oct-1999] $)

      $( Hilbert lattice contraposition law. $)
      chsscon3i $p |- ( A C_ B <-> ( _|_ ` B ) C_ ( _|_ ` A ) ) $=
        cA cB wss cB cort cfv cA cort cfv wss cA chil wss cB chil wss cA cB wss
        cB cort cfv cA cort cfv wss wi cA ch0le.1 chssii cB chjcl.2 chssii cA
        cB occon mp2an cB cort cfv cA cort cfv wss cA cort cfv cort cfv cB cort
        cfv cort cfv cA cB cB cort cfv chil wss cA cort cfv chil wss cB cort
        cfv cA cort cfv wss cA cort cfv cort cfv cB cort cfv cort cfv wss wi cB
        cort cfv cB chjcl.2 choccli chssii cA cort cfv cA ch0le.1 choccli
        chssii cB cort cfv cA cort cfv occon mp2an cA ch0le.1 pjococi cB
        chjcl.2 pjococi 3sstr3g impbii $.
        $( [15-Oct-1999] $)

      $( Hilbert lattice contraposition law. $)
      chsscon1i $p |- ( ( _|_ ` A ) C_ B <-> ( _|_ ` B ) C_ A ) $=
        cA cort cfv cB wss cB cort cfv cA cort cfv cort cfv wss cB cort cfv cA
        wss cA cort cfv cB cA ch0le.1 choccli chjcl.2 chsscon3i cA cort cfv
        cort cfv cA cB cort cfv cA ch0le.1 pjococi sseq2i bitri $.
        $( [15-Oct-1999] $)

      $( Hilbert lattice contraposition law. $)
      chsscon2i $p |- ( A C_ ( _|_ ` B ) <-> B C_ ( _|_ ` A ) ) $=
        cA cB cort cfv wss cB cort cfv cort cfv cA cort cfv wss cB cA cort cfv
        wss cA cB cort cfv ch0le.1 cB chjcl.2 choccli chsscon3i cB cort cfv
        cort cfv cB cA cort cfv cB chjcl.2 pjococi sseq1i bitri $.
        $( [15-Oct-1999] $)

      $( Hilbert lattice contraposition law. $)
      chcon2i $p |- ( A = ( _|_ ` B ) <-> B = ( _|_ ` A ) ) $=
        cA cB cort cfv wss cB cort cfv cA wss wa cB cA cort cfv wss cA cort cfv
        cB wss wa cA cB cort cfv wceq cB cA cort cfv wceq cA cB cort cfv wss cB
        cA cort cfv wss cB cort cfv cA wss cA cort cfv cB wss cA cB ch0le.1
        chjcl.2 chsscon2i cB cA chjcl.2 ch0le.1 chsscon1i anbi12i cA cB cort
        cfv eqss cB cA cort cfv eqss 3bitr4i $.
        $( [24-Jun-2004] $) $( [24-Jun-2004] $)

      $( Hilbert lattice contraposition law. $)
      chcon1i $p |- ( ( _|_ ` A ) = B <-> ( _|_ ` B ) = A ) $=
        cB cA cort cfv wceq cA cB cort cfv wceq cA cort cfv cB wceq cB cort cfv
        cA wceq cB cA chjcl.2 ch0le.1 chcon2i cA cort cfv cB eqcom cB cort cfv
        cA eqcom 3bitr4i $.
        $( [3-Oct-2006] $) $( [15-Jun-2006] $)

      $( Hilbert lattice contraposition law. $)
      chcon3i $p |- ( A = B <-> ( _|_ ` B ) = ( _|_ ` A ) ) $=
        cA cB wss cB cA wss wa cB cort cfv cA cort cfv wss cA cort cfv cB cort
        cfv wss wa cA cB wceq cB cort cfv cA cort cfv wceq cA cB wss cB cort
        cfv cA cort cfv wss cB cA wss cA cort cfv cB cort cfv wss cA cB ch0le.1
        chjcl.2 chsscon3i cB cA chjcl.2 ch0le.1 chsscon3i anbi12i cA cB eqss cB
        cort cfv cA cort cfv eqss 3bitr4i $.
        $( [25-Jun-2004] $) $( [24-Jun-2004] $)

      $( Union is smaller than ` CH ` join. $)
      chunssji $p |- ( A u. B ) C_ ( A vH B ) $=
        cA cB cA ch0le.1 chshii cB chjcl.2 chshii shunssji $.
        $( [15-Oct-1999] $)

      $( Commutative law for join in ` CH ` . $)
      chjcomi $p |- ( A vH B ) = ( B vH A ) $=
        cA cB cA ch0le.1 chshii cB chjcl.2 chshii shjcomi $.
        $( [14-Oct-1999] $)

      $( ` CH ` join is an upper bound of two elements. $)
      chub1i $p |- A C_ ( A vH B ) $=
        cA cB cA ch0le.1 chshii cB chjcl.2 chshii shub1i $.
        $( [15-Oct-1999] $)

      $( ` CH ` join is an upper bound of two elements. $)
      chub2i $p |- A C_ ( B vH A ) $=
        cA cA cB chj co cB cA chj co cA cB ch0le.1 chjcl.2 chub1i cA cB ch0le.1
        chjcl.2 chjcomi sseqtri $.
        $( [5-Nov-2000] $)

      ${
        $d x y C $.
        chlub.1 $e |- C e. CH $.
        $( Hilbert lattice join is the least upper bound of two elements. $)
        chlubi $p |- ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) $=
          cA cB cC cA ch0le.1 chshii cB chjcl.2 chshii chlub.1 shlubi $.
          $( [16-Jun-2004] $) $( [11-Jun-2004] $)

        $( Hilbert lattice join is the least upper bound of two elements
           (one direction of ~ chlubi ). $)
        chlubii $p |- ( ( A C_ C /\ B C_ C ) -> ( A vH B ) C_ C ) $=
          cA cC wss cB cC wss wa cA cB chj co cC wss cA cB cC ch0le.1 chjcl.2
          chlub.1 chlubi biimpi $.
          $( [15-Oct-1999] $)

        $( Add join to both sides of a Hilbert lattice ordering. $)
        chlej1i $p |- ( A C_ B -> ( A vH C ) C_ ( B vH C ) ) $=
          cA cB cC cA ch0le.1 chshii cB chjcl.2 chshii cC chlub.1 chshii
          shlej1i $.
          $( [19-Oct-1999] $)

        $( Add join to both sides of a Hilbert lattice ordering. $)
        chlej2i $p |- ( A C_ B -> ( C vH A ) C_ ( C vH B ) ) $=
          cA cB cC cA ch0le.1 chshii cB chjcl.2 chshii cC chlub.1 chshii
          shlej2i $.
          $( [19-Oct-1999] $)

        ${
          chlej12.4 $e |- D e. CH $.
          $( Add join to both sides of a Hilbert lattice ordering. $)
          chlej12i $p |- ( ( A C_ B /\ C C_ D ) ->
                       ( A vH C ) C_ ( B vH D ) ) $=
            cA cB wss cC cD wss cA cC chj co cB cC chj co cB cD chj co cA cB cC
            ch0le.1 chjcl.2 chlub.1 chlej1i cC cD cB chlub.1 chlej12.4 chjcl.2
            chlej2i sylan9ss $.
            $( [19-Oct-1999] $)
        $}
      $}

      $( Hilbert lattice ordering in terms of join. $)
      chlejb1i $p |- ( A C_ B <-> ( A vH B ) = B ) $=
        cA cB wss cA cB chj co cB wceq cA cB wss cA cB chj co cB wss cB cA cB
        chj co wss wa cA cB chj co cB wceq cA cB wss cA cB chj co cB wss cB cA
        cB chj co wss cA cB wss cB cB wss cA cB chj co cB wss cB ssid cA cB cB
        ch0le.1 chjcl.2 chjcl.2 chlubii mpan2 cB cA chjcl.2 ch0le.1 chub2i
        jctir cA cB chj co cB eqss sylibr cA cA cB chj co wss cA cB chj co cB
        wceq cA cB wss wi cA cB ch0le.1 chjcl.2 chub1i cA cA cB chj co wss cA
        cB chj co cB wss cA cB wss cA cB chj co cB wceq cA cA cB chj co cB
        sstr2 cA cB chj co cB eqimss syl5 ax-mp impbii $.
        $( [15-Oct-1999] $)

      $( DeMorgan's law for meet in a Hilbert lattice. $)
      chdmm1i $p |- ( _|_ ` ( A i^i B ) ) = ( ( _|_ ` A ) vH ( _|_ ` B ) ) $=
        cA cB cin cort cfv cA cort cfv cB cort cfv chj co cA cort cfv cB cort
        cfv chj co cort cfv cA cB cin wss cA cB cin cort cfv cA cort cfv cB
        cort cfv chj co wss cA cort cfv cB cort cfv chj co cort cfv cA cB cA
        cort cfv cA cort cfv cB cort cfv chj co wss cA cort cfv cB cort cfv chj
        co cort cfv cA wss cA cort cfv cB cort cfv cA ch0le.1 choccli cB
        chjcl.2 choccli chub1i cA cA cort cfv cB cort cfv chj co ch0le.1 cA
        cort cfv cB cort cfv cA ch0le.1 choccli cB chjcl.2 choccli chjcli
        chsscon1i mpbi cB cort cfv cA cort cfv cB cort cfv chj co wss cA cort
        cfv cB cort cfv chj co cort cfv cB wss cB cort cfv cA cort cfv cB
        chjcl.2 choccli cA ch0le.1 choccli chub2i cB cA cort cfv cB cort cfv
        chj co chjcl.2 cA cort cfv cB cort cfv cA ch0le.1 choccli cB chjcl.2
        choccli chjcli chsscon1i mpbi ssini cA cort cfv cB cort cfv chj co cA
        cB cin cA cort cfv cB cort cfv cA ch0le.1 choccli cB chjcl.2 choccli
        chjcli cA cB ch0le.1 chjcl.2 chincli chsscon1i mpbi cA cort cfv cA cB
        cin cort cfv wss cB cort cfv cA cB cin cort cfv wss cA cort cfv cB cort
        cfv chj co cA cB cin cort cfv wss cA cB cin cA wss cA cort cfv cA cB
        cin cort cfv wss cA cB inss1 cA cB cin cA cA cB ch0le.1 chjcl.2 chincli
        ch0le.1 chsscon3i mpbi cA cB cin cB wss cB cort cfv cA cB cin cort cfv
        wss cA cB inss2 cA cB cin cB cA cB ch0le.1 chjcl.2 chincli chjcl.2
        chsscon3i mpbi cA cort cfv cB cort cfv cA cB cin cort cfv cA ch0le.1
        choccli cB chjcl.2 choccli cA cB cin cA cB ch0le.1 chjcl.2 chincli
        choccli chlubii mp2an eqssi $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for meet in a Hilbert lattice. $)
      chdmm2i $p |- ( _|_ ` ( ( _|_ ` A ) i^i B ) ) = ( A vH ( _|_ ` B ) ) $=
        cA cort cfv cB cin cort cfv cA cort cfv cort cfv cB cort cfv chj co cA
        cB cort cfv chj co cA cort cfv cB cA ch0le.1 choccli chjcl.2 chdmm1i cA
        cort cfv cort cfv cA cB cort cfv chj cA ch0le.1 pjococi opreq1i eqtri
        $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for meet in a Hilbert lattice. $)
      chdmm3i $p |- ( _|_ ` ( A i^i ( _|_ ` B ) ) ) = ( ( _|_ ` A ) vH B ) $=
        cA cB cort cfv cin cort cfv cA cort cfv cB cort cfv cort cfv chj co cA
        cort cfv cB chj co cA cB cort cfv ch0le.1 cB chjcl.2 choccli chdmm1i cB
        cort cfv cort cfv cB cA cort cfv chj cB chjcl.2 pjococi opreq2i eqtri
        $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for meet in a Hilbert lattice. $)
      chdmm4i $p |- ( _|_ ` ( ( _|_ ` A ) i^i ( _|_ ` B ) ) ) = ( A vH B ) $=
        cA cort cfv cB cort cfv cin cort cfv cA cB cort cfv cort cfv chj co cA
        cB chj co cA cB cort cfv ch0le.1 cB chjcl.2 choccli chdmm2i cB cort cfv
        cort cfv cB cA chj cB chjcl.2 pjococi opreq2i eqtri $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for join in a Hilbert lattice. $)
      chdmj1i $p |- ( _|_ ` ( A vH B ) ) = ( ( _|_ ` A ) i^i ( _|_ ` B ) ) $=
        cA cort cfv cB cort cfv cin cort cfv cort cfv cA cB chj co cort cfv cA
        cort cfv cB cort cfv cin cA cort cfv cB cort cfv cin cort cfv cA cB chj
        co cort cA cB ch0le.1 chjcl.2 chdmm4i fveq2i cA cort cfv cB cort cfv
        cin cA cort cfv cB cort cfv cA ch0le.1 choccli cB chjcl.2 choccli
        chincli pjococi eqtr3i $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for join in a Hilbert lattice. $)
      chdmj2i $p |- ( _|_ ` ( ( _|_ ` A ) vH B ) ) = ( A i^i ( _|_ ` B ) ) $=
        cA cort cfv cB chj co cort cfv cA cort cfv cort cfv cB cort cfv cin cA
        cB cort cfv cin cA cort cfv cB cA ch0le.1 choccli chjcl.2 chdmj1i cA
        cort cfv cort cfv cA cB cort cfv cA ch0le.1 pjococi ineq1i eqtri $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for join in a Hilbert lattice. $)
      chdmj3i $p |- ( _|_ ` ( A vH ( _|_ ` B ) ) ) = ( ( _|_ ` A ) i^i B ) $=
        cA cB cort cfv chj co cort cfv cA cort cfv cB cort cfv cort cfv cin cA
        cort cfv cB cin cA cB cort cfv ch0le.1 cB chjcl.2 choccli chdmj1i cB
        cort cfv cort cfv cB cA cort cfv cB chjcl.2 pjococi ineq2i eqtri $.
        $( [23-Jun-2004] $) $( [21-Jun-2004] $)

      $( DeMorgan's law for join in a Hilbert lattice. $)
      chdmj4i $p |- ( _|_ ` ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) = ( A i^i B ) $=
        cA cort cfv cB cort cfv chj co cort cfv cA cB cort cfv cort cfv cin cA
        cB cin cA cB cort cfv ch0le.1 cB chjcl.2 choccli chdmj2i cB cort cfv
        cort cfv cB cA cB chjcl.2 pjococi ineq2i eqtri $.
        $( [21-Jun-2004] $) $( [21-Jun-2004] $)

      $( Equivalent expressions for "not less than" in the Hilbert lattice. $)
      chnlei $p |- ( -. B C_ A <->  A C. ( A vH B ) ) $=
        cA cA cB chj co wceq wn cA cA cB chj co wss cA cA cB chj co wceq wn wa
        cB cA wss wn cA cA cB chj co wpss cA cA cB chj co wss cA cA cB chj co
        wceq wn cA cB ch0le.1 chjcl.2 chub1i biantrur cB cA wss cA cA cB chj co
        wceq cB cA wss cB cA chj co cA wceq cA cB cA chj co wceq cA cA cB chj
        co wceq cB cA chjcl.2 ch0le.1 chlejb1i cB cA chj co cA eqcom cB cA chj
        co cA cB chj co cA cB cA chjcl.2 ch0le.1 chjcomi eqeq2i 3bitri notbii
        cA cA cB chj co dfpss2 3bitr4i $.
        $( [16-Jun-2004] $) $( [5-Jun-2004] $)

      ${
        chjass.3 $e |- C e. CH $.
        $( Associative law for Hilbert lattice join.  From definition of
           lattice in [Kalmbach] p. 14. $)
        chjassi $p |- ( ( A vH B ) vH C ) = ( A vH ( B vH C ) ) $=
          cA cB chj co cort cfv cC cort cfv cin cort cfv cA cort cfv cB cC chj
          co cort cfv cin cort cfv cA cB chj co cC chj co cA cB cC chj co chj
          co cA cB chj co cort cfv cC cort cfv cin cA cort cfv cB cC chj co
          cort cfv cin cort cA cort cfv cB cort cfv cin cC cort cfv cin cA cort
          cfv cB cort cfv cC cort cfv cin cin cA cB chj co cort cfv cC cort cfv
          cin cA cort cfv cB cC chj co cort cfv cin cA cort cfv cB cort cfv cC
          cort cfv inass cA cB chj co cort cfv cA cort cfv cB cort cfv cin cC
          cort cfv cA cB ch0le.1 chjcl.2 chdmj1i ineq1i cB cC chj co cort cfv
          cB cort cfv cC cort cfv cin cA cort cfv cB cC chjcl.2 chjass.3
          chdmj1i ineq2i 3eqtr4i fveq2i cA cB chj co cC cA cB ch0le.1 chjcl.2
          chjcli chjass.3 chdmm4i cA cB cC chj co ch0le.1 cB cC chjcl.2
          chjass.3 chjcli chdmm4i 3eqtr3i $.
          $( [17-Jun-2004] $) $( [10-Jun-2004] $)
      $}

      $( Two Hilbert lattice elements are zero iff their join is zero. $)
      chj00i $p |- ( ( A = 0H /\ B = 0H ) <-> ( A vH B ) = 0H ) $=
        cA c0h wceq cB c0h wceq wa cA cB chj co c0h wceq cA c0h wceq cB c0h
        wceq wa cA cB chj co c0h c0h chj co c0h cA c0h cB c0h chj opreq12 c0h
        h0elch chj0i syl6eq cA cB chj co c0h wceq cA c0h wceq cB c0h wceq cA cB
        chj co c0h wceq cA c0h wss cA c0h wceq cA cB chj co c0h wceq cA cA cB
        chj co wss cA c0h wss cA cB ch0le.1 chjcl.2 chub1i cA cB chj co c0h cA
        sseq2 mpbii cA ch0le.1 chle0i sylib cA cB chj co c0h wceq cB c0h wss cB
        c0h wceq cA cB chj co c0h wceq cB cA cB chj co wss cB c0h wss cB cA
        chjcl.2 ch0le.1 chub2i cA cB chj co c0h cB sseq2 mpbii cB chjcl.2
        chle0i sylib jca impbii $.
        $( [11-Aug-2004] $) $( [7-Aug-2004] $)
    $}

    $( The join of a closed subspace and its orthocomplement. $)
    chjoi $p |- ( A vH ( _|_ ` A ) ) = ~H $=
      cA cort cfv cA cin cort cfv c0h cort cfv cA cA cort cfv chj co chil cA
      cort cfv cA cin c0h cort cA cort cfv cA cin cA cA cort cfv cin c0h cA
      cort cfv cA incom cA ch0le.1 chocini eqtri fveq2i cA cA ch0le.1 ch0le.1
      chdmm2i choc0 3eqtr3i $.
      $( [24-Oct-1999] $)

    $( Join with Hilbert lattice unit. $)
    chj1i $p |- ( A vH ~H ) = ~H $=
      cA chil chj co chil cA chil chj co cA chil ch0le.1 helch chjcli chssii
      chil cA helch ch0le.1 chub2i eqssi $.
      $( [11-Aug-2004] $) $( [6-Aug-2004] $)

    $( Meet with Hilbert lattice zero. $)
    chm0i $p |- ( A i^i 0H ) = 0H $=
      cA c0h cin c0h cA c0h inss2 c0h cA c0h cA ch0le.1 ch0lei c0h ssid ssini
      eqssi $.
      $( [11-Aug-2004] $) $( [6-Aug-2004] $)

  $}

  $( Meet with Hilbert lattice zero. $)
  chm0 $p |- ( A e. CH -> ( A i^i 0H ) = 0H ) $=
    cA cch wcel cA c0h cin c0h wceq cA cch wcel cA c0h cif c0h cin c0h wceq cA
    c0h cA cA cch wcel cA c0h cif wceq cA c0h cin cA cch wcel cA c0h cif c0h
    cin c0h cA cA cch wcel cA c0h cif c0h ineq1 eqeq1d cA cch wcel cA c0h cif
    cA c0h cch h0elch elimel chm0i dedth $.
    $( [14-Jun-2006] $) $( [14-Jun-2006] $)

  ${
    shjshs.1 $e |- A e. SH $.
    shjshs.2 $e |- B e. SH $.
    $( Hilbert lattice join equals the double orthocomplement of subspace
       sum. $)
    shjshsi $p |- ( A vH B ) = ( _|_ ` ( _|_ ` ( A +H B ) ) ) $=
      cA cB chj co cA cB cph co cort cfv cort cfv cA cB chj co cA cB cun cort
      cfv cort cfv cA cB cph co cort cfv cort cfv cA csh wcel cB csh wcel cA cB
      chj co cA cB cun cort cfv cort cfv wceq shjshs.1 shjshs.2 cA cB shjval
      mp2an cA cB cun cA cB cph co wss cA cB cun cort cfv cort cfv cA cB cph co
      cort cfv cort cfv wss cA cB shjshs.1 shjshs.2 shunssi cA cB cun cA cB cph
      co cA cB chil cA shjshs.1 shssii cB shjshs.2 shssii unssi cA cB cph co cA
      cB shjshs.1 shjshs.2 shscli shssii occon2i ax-mp eqsstri cA cB chj co
      cort cfv cA cB cph co cort cfv wss cA cB cph co cort cfv cort cfv cA cB
      chj co wss cA cB cph co cA cB chj co wss cA cB chj co cort cfv cA cB cph
      co cort cfv wss cA cB shjshs.1 shjshs.2 shsleji cA cB cph co chil wss cA
      cB chj co chil wss cA cB cph co cA cB chj co wss cA cB chj co cort cfv cA
      cB cph co cort cfv wss wi cA cB cph co cA cB shjshs.1 shjshs.2 shscli
      shssii cA cB chj co cA cB shjshs.1 shjshs.2 shjcli chssii cA cB cph co cA
      cB chj co occon mp2an ax-mp cA cB chj co cA cB cph co cort cfv cA cB
      shjshs.1 shjshs.2 shjcli cA cB cph co cA cB cph co cA cB shjshs.1
      shjshs.2 shscli shssii occli chsscon1i mpbi eqssi $.
      $( [1-Dec-2004] $) $( [27-Nov-2004] $)

    $( A closed subspace sum equals Hilbert lattice join.  Part of Lemma
       31.1.5 of [MaedaMaeda] p. 136. $)
    shjshseli $p |- ( ( A +H B ) e. CH <-> ( A +H B ) = ( A vH B ) ) $=
      cA cB cph co cch wcel cA cB cph co cA cB chj co wceq cA cB cph co cch
      wcel cA cB cph co cort cfv cort cfv cA cB cph co cA cB chj co cA cB cph
      co ococ cA cB shjshs.1 shjshs.2 shjshsi syl5req cA cB cph co cA cB chj co
      wceq cA cB cph co cch wcel cA cB chj co cch wcel cA cB shjshs.1 shjshs.2
      shjcli cA cB cph co cA cB chj co cch eleq1 mpbiri impbii $.
      $( [3-Jan-2005] $) $( [30-Nov-2004] $)
  $}

  ${
    $d x A $.
    $( A non-zero closed subspace has a nonzero vector. $)
    chne0 $p |- ( A e. CH -> ( A =/= 0H <-> E. x e. A x =/= 0h ) ) $=
      cA cch wcel cA c0h wne vx cv c0v wne vx cA wrex wb cA cch wcel cA c0h cif
      c0h wne vx cv c0v wne vx cA cch wcel cA c0h cif wrex wb cA c0h cA cA cch
      wcel cA c0h cif wceq cA c0h wne cA cch wcel cA c0h cif c0h wne vx cv c0v
      wne vx cA wrex vx cv c0v wne vx cA cch wcel cA c0h cif wrex cA cA cch
      wcel cA c0h cif c0h neeq1 vx cv c0v wne vx cA cA cch wcel cA c0h cif
      rexeq1 bibi12d vx cA cch wcel cA c0h cif cA c0h cch h0elch elimel chne0i
      dedth $.
      $( [19-Jun-2006] $) $( [25-Feb-2006] $)
  $}

  $( Intersection of a closed subspace and its orthocomplement.  Part of
     Proposition 1 of [Kalmbach] p. 65. $)
  chocin $p |- ( A e. CH -> ( A i^i ( _|_ ` A ) ) = 0H ) $=
    cA cch wcel cA cA cort cfv cin c0h wceq cA cch wcel cA c0h cif cA cch wcel
    cA c0h cif cort cfv cin c0h wceq cA c0h cA cA cch wcel cA c0h cif wceq cA
    cA cort cfv cin cA cch wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cin
    c0h cA cA cch wcel cA c0h cif wceq cA cA cch wcel cA c0h cif cA cort cfv cA
    cch wcel cA c0h cif cort cfv cA cA cch wcel cA c0h cif wceq id cA cA cch
    wcel cA c0h cif cort fveq2 ineq12d eqeq1d cA cch wcel cA c0h cif cA c0h cch
    h0elch elimel chocini dedth $.
    $( [14-Jun-2006] $) $( [13-Jun-2006] $)

  $( A closed subspace less than its orthocomplement is zero. $)
  chssoc $p |- ( A e. CH -> ( A C_ ( _|_ ` A ) <-> A = 0H ) ) $=
    cA cch wcel cA cA cort cfv wss cA c0h wceq cA cch wcel cA cA cA cort cfv
    cin wss cA c0h wceq cA cA cort cfv wss cA cch wcel cA cA cA cort cfv cin
    wss cA c0h wss cA c0h wceq cA cch wcel cA cA cort cfv cin c0h cA cA chocin
    sseq2d cA chle0 bitrd cA cA cort cfv wss cA cA cin cA cA cort cfv cin cA cA
    cA cort cfv cA sslin cA inidm syl5ssr syl5bi cA cch wcel cA c0h wceq cA cA
    cort cfv wss cA cch wcel cA c0h wceq wa cA c0h cA cort cfv cA cch wcel cA
    c0h wceq pm3.27 cA cch wcel c0h cA cort cfv wss cA c0h wceq cA cch wcel cA
    cort cfv cch wcel c0h cA cort cfv wss cA choccl cA cort cfv ch0le syl
    adantr eqsstrd ex impbid $.
    $( [27-Jun-2006] $) $( [14-Jun-2006] $)

  $( Join with Hilbert lattice zero. $)
  chj0 $p |- ( A e. CH -> ( A vH 0H ) = A ) $=
    cA cch wcel cA c0h chj co cA wceq cA cch wcel cA c0h cif c0h chj co cA cch
    wcel cA c0h cif wceq cA c0h cA cA cch wcel cA c0h cif wceq cA c0h chj co cA
    cch wcel cA c0h cif c0h chj co cA cA cch wcel cA c0h cif cA cA cch wcel cA
    c0h cif c0h chj opreq1 cA cA cch wcel cA c0h cif wceq id eqeq12d cA cch
    wcel cA c0h cif cA c0h cch h0elch elimel chj0i dedth $.
    $( [25-Jun-2004] $) $( [22-Jun-2004] $)

  $( Subspace sum is smaller than subspace join.  Remark in [Kalmbach]
     p. 65. $)
  chslej $p |- ( ( A e. CH /\ B e. CH ) -> ( A +H B ) C_ ( A vH B ) ) $=
    cA csh wcel cB csh wcel cA cB cph co cA cB chj co wss cA cch wcel cB cch
    wcel cA cB shslej cA chsh cB chsh syl2an $.
    $( [2-Sep-2004] $) $( [12-Jul-2004] $)

  $( Closure of Hilbert lattice intersection. $)
  chincl $p |- ( ( A e. CH /\ B e. CH ) -> ( A i^i B ) e. CH ) $=
    cA cch wcel cB cch wcel cA cB cin cch wcel cA cch wcel cA chil cif cB cin
    cch wcel cA cch wcel cA chil cif cB cch wcel cB chil cif cin cch wcel cA cB
    chil chil cA cA cch wcel cA chil cif wceq cA cB cin cA cch wcel cA chil cif
    cB cin cch cA cA cch wcel cA chil cif cB ineq1 eleq1d cB cB cch wcel cB
    chil cif wceq cA cch wcel cA chil cif cB cin cA cch wcel cA chil cif cB cch
    wcel cB chil cif cin cch cB cB cch wcel cB chil cif cA cch wcel cA chil cif
    ineq2 eleq1d cA cch wcel cA chil cif cB cch wcel cB chil cif cA chil cch
    helch elimel cB chil cch helch elimel chincli dedth2h $.
    $( [20-Jun-2004] $) $( [15-Jun-2004] $)

  $( Hilbert lattice contraposition law. $)
  chsscon3 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C_ B <-> ( _|_ ` B ) C_ ( _|_ ` A ) ) ) $=
    cA cch wcel cB cch wcel cA cB wss cB cort cfv cA cort cfv wss wb cA cch
    wcel cA chil cif cB wss cB cort cfv cA cch wcel cA chil cif cort cfv wss wb
    cA cch wcel cA chil cif cB cch wcel cB chil cif wss cB cch wcel cB chil cif
    cort cfv cA cch wcel cA chil cif cort cfv wss wb cA cB chil chil cA cA cch
    wcel cA chil cif wceq cA cB wss cA cch wcel cA chil cif cB wss cB cort cfv
    cA cort cfv wss cB cort cfv cA cch wcel cA chil cif cort cfv wss cA cA cch
    wcel cA chil cif cB sseq1 cA cA cch wcel cA chil cif wceq cA cort cfv cA
    cch wcel cA chil cif cort cfv cB cort cfv cA cA cch wcel cA chil cif cort
    fveq2 sseq2d bibi12d cB cB cch wcel cB chil cif wceq cA cch wcel cA chil
    cif cB wss cA cch wcel cA chil cif cB cch wcel cB chil cif wss cB cort cfv
    cA cch wcel cA chil cif cort cfv wss cB cch wcel cB chil cif cort cfv cA
    cch wcel cA chil cif cort cfv wss cB cB cch wcel cB chil cif cA cch wcel cA
    chil cif sseq2 cB cB cch wcel cB chil cif wceq cB cort cfv cB cch wcel cB
    chil cif cort cfv cA cch wcel cA chil cif cort cfv cB cB cch wcel cB chil
    cif cort fveq2 sseq1d bibi12d cA cch wcel cA chil cif cB cch wcel cB chil
    cif cA chil cch helch elimel cB chil cch helch elimel chsscon3i dedth2h $.
    $( [20-Jun-2004] $) $( [12-Jun-2004] $)

  $( Hilbert lattice contraposition law. $)
  chsscon1 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( ( _|_  ` A ) C_ B <-> ( _|_ ` B ) C_ A ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB wss cB cort cfv cA cort cfv cort
    cfv wss cB cort cfv cA wss cA cort cfv cch wcel cB cch wcel cA cort cfv cB
    wss cB cort cfv cA cort cfv cort cfv wss wb cA cch wcel cA cort cfv cB
    chsscon3 cA choccl sylan cA cch wcel cB cch wcel wa cA cort cfv cort cfv cA
    cB cort cfv cA cch wcel cA cort cfv cort cfv cA wceq cB cch wcel cA ococ
    adantr sseq2d bitrd $.
    $( [25-Jun-2004] $) $( [21-Jun-2004] $)

  $( Hilbert lattice contraposition law. $)
  chsscon2 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C_ ( _|_ ` B ) <-> B C_ ( _|_ ` A ) ) ) $=
    cA cch wcel cB cch wcel wa cA cB cort cfv wss cB cort cfv cort cfv cA cort
    cfv wss cB cA cort cfv wss cA cch wcel cB cort cfv cch wcel cA cB cort cfv
    wss cB cort cfv cort cfv cA cort cfv wss wb cB cch wcel cA cB cort cfv
    chsscon3 cB choccl sylan2 cA cch wcel cB cch wcel wa cB cort cfv cort cfv
    cB cA cort cfv cB cch wcel cB cort cfv cort cfv cB wceq cA cch wcel cB ococ
    adantl sseq1d bitrd $.
    $( [26-Jun-2004] $) $( [21-Jun-2004] $)

  $( Hilbert lattice contraposition law for strict ordering. $)
  chpsscon3 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C. B <-> ( _|_ ` B ) C. ( _|_ ` A ) ) ) $=
    cA cch wcel cB cch wcel wa cA cB wss cB cA wss wn wa cB cort cfv cA cort
    cfv wss cA cort cfv cB cort cfv wss wn wa cA cB wpss cB cort cfv cA cort
    cfv wpss cA cch wcel cB cch wcel wa cA cB wss cB cort cfv cA cort cfv wss
    cB cA wss wn cA cort cfv cB cort cfv wss wn cA cB chsscon3 cA cch wcel cB
    cch wcel wa cB cA wss cA cort cfv cB cort cfv wss cB cch wcel cA cch wcel
    cB cA wss cA cort cfv cB cort cfv wss wb cB cA chsscon3 ancoms notbid
    anbi12d cA cB dfpss3 cB cort cfv cA cort cfv dfpss3 3bitr4g $.
    $( [20-Jun-2004] $) $( [12-Jun-2004] $)

  $( Hilbert lattice contraposition law for strict ordering. $)
  chpsscon1 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( ( _|_  ` A ) C. B <-> ( _|_ ` B ) C. A ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB wpss cB cort cfv cA cort cfv cort
    cfv wpss cB cort cfv cA wpss cA cort cfv cch wcel cB cch wcel cA cort cfv
    cB wpss cB cort cfv cA cort cfv cort cfv wpss wb cA cch wcel cA cort cfv cB
    chpsscon3 cA choccl sylan cA cch wcel cB cch wcel wa cA cort cfv cort cfv
    cA cB cort cfv cA cch wcel cA cort cfv cort cfv cA wceq cB cch wcel cA ococ
    adantr psseq2d bitrd $.
    $( [26-Jun-2004] $) $( [12-Jun-2004] $)

  $( Hilbert lattice contraposition law for strict ordering. $)
  chpsscon2 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C. ( _|_ ` B ) <-> B C. ( _|_  ` A ) ) ) $=
    cA cch wcel cB cch wcel wa cA cB cort cfv wpss cB cort cfv cort cfv cA cort
    cfv wpss cB cA cort cfv wpss cA cch wcel cB cort cfv cch wcel cA cB cort
    cfv wpss cB cort cfv cort cfv cA cort cfv wpss wb cB cch wcel cA cB cort
    cfv chpsscon3 cB choccl sylan2 cA cch wcel cB cch wcel wa cB cort cfv cort
    cfv cB cA cort cfv cB cch wcel cB cort cfv cort cfv cB wceq cA cch wcel cB
    ococ adantl psseq1d bitrd $.
    $( [26-Jun-2004] $) $( [12-Jun-2004] $)

  $( Commutative law for Hilbert lattice join. $)
  chjcom $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH B ) = ( B vH A ) ) $=
    cA csh wcel cB csh wcel cA cB chj co cB cA chj co wceq cA cch wcel cB cch
    wcel cA cB shjcom cA chsh cB chsh syl2an $.
    $( [26-Jun-2004] $) $( [12-Jun-2004] $)

  $( Hilbert lattice join is greater than or equal to its first argument. $)
  chub1 $p |- ( ( A e. CH /\ B e. CH ) -> A C_ ( A vH B ) ) $=
    cA csh wcel cB csh wcel cA cA cB chj co wss cA cch wcel cB cch wcel cA cB
    shub1 cA chsh cB chsh syl2an $.
    $( [26-Jun-2004] $) $( [12-Jun-2004] $)

  $( Hilbert lattice join is greater than or equal to its second argument. $)
  chub2 $p |- ( ( A e. CH /\ B e. CH ) -> A C_ ( B vH A ) ) $=
    cA cch wcel cB cch wcel wa cA cA cB chj co cB cA chj co cA cB chub1 cA cB
    chjcom sseqtrd $.
    $( [26-Jun-2004] $) $( [12-Jun-2004] $)

  $( Hilbert lattice join is the least upper bound of two elements. $)
  chlub $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
               ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) ) $=
    cA csh wcel cB cch wcel cC cch wcel cA cC wss cB cC wss wa cA cB chj co cC
    wss wb cA cch wcel cA csh wcel cB csh wcel cC cch wcel cA cC wss cB cC wss
    wa cA cB chj co cC wss wb cB cch wcel cA cB cC shlub cB chsh syl3an2 cA
    chsh syl3an1 $.
    $( [26-Jun-2004] $) $( [12-Jun-2004] $)

  $( Add join to both sides of Hilbert lattice ordering. $)
  chlej1 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
                A C_ B ) -> ( A vH C ) C_ ( B vH C ) ) $=
    cA csh wcel cB csh wcel cC csh wcel cA cB wss cA cC chj co cB cC chj co wss
    cA cch wcel cB cch wcel cC cch wcel cA cB cC shlej1 cA chsh cB chsh cC chsh
    syl3anl $.
    $( [17-Jun-2007] $) $( [22-Jun-2004] $)

  $( Add join to both sides of Hilbert lattice ordering. $)
  chlej2 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
                A C_ B ) -> ( C vH A ) C_ ( C vH B ) ) $=
    cA csh wcel cB csh wcel cC csh wcel cA cB wss cC cA chj co cC cB chj co wss
    cA cch wcel cB cch wcel cC cch wcel cA cB cC shlej2 cA chsh cB chsh cC chsh
    syl3anl $.
    $( [4-Jan-2007] $) $( [22-Jun-2004] $)

  $( Hilbert lattice ordering in terms of join. $)
  chlejb1 $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_ B <-> ( A vH B ) = B ) ) $=
    cA cch wcel cB cch wcel cA cB wss cA cB chj co cB wceq wb cA cch wcel cA
    c0h cif cB wss cA cch wcel cA c0h cif cB chj co cB wceq wb cA cch wcel cA
    c0h cif cB cch wcel cB c0h cif wss cA cch wcel cA c0h cif cB cch wcel cB
    c0h cif chj co cB cch wcel cB c0h cif wceq wb cA cB c0h c0h cA cA cch wcel
    cA c0h cif wceq cA cB wss cA cch wcel cA c0h cif cB wss cA cB chj co cB
    wceq cA cch wcel cA c0h cif cB chj co cB wceq cA cA cch wcel cA c0h cif cB
    sseq1 cA cA cch wcel cA c0h cif wceq cA cB chj co cA cch wcel cA c0h cif cB
    chj co cB cA cA cch wcel cA c0h cif cB chj opreq1 eqeq1d bibi12d cB cB cch
    wcel cB c0h cif wceq cA cch wcel cA c0h cif cB wss cA cch wcel cA c0h cif
    cB cch wcel cB c0h cif wss cA cch wcel cA c0h cif cB chj co cB wceq cA cch
    wcel cA c0h cif cB cch wcel cB c0h cif chj co cB cch wcel cB c0h cif wceq
    cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif sseq2 cB cB cch wcel cB
    c0h cif wceq cA cch wcel cA c0h cif cB chj co cA cch wcel cA c0h cif cB cch
    wcel cB c0h cif chj co cB cB cch wcel cB c0h cif cB cB cch wcel cB c0h cif
    cA cch wcel cA c0h cif chj opreq2 cB cB cch wcel cB c0h cif wceq id eqeq12d
    bibi12d cA cch wcel cA c0h cif cB cch wcel cB c0h cif cA c0h cch h0elch
    elimel cB c0h cch h0elch elimel chlejb1i dedth2h $.
    $( [2-Jul-2004] $) $( [30-Jun-2004] $)

  $( Hilbert lattice ordering in terms of join. $)
  chlejb2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_ B <-> ( B vH A ) = B ) ) $=
    cA cch wcel cB cch wcel wa cA cB wss cA cB chj co cB wceq cB cA chj co cB
    wceq cA cB chlejb1 cA cch wcel cB cch wcel wa cA cB chj co cB cA chj co cB
    cA cB chjcom eqeq1d bitrd $.
    $( [2-Jul-2004] $) $( [2-Jul-2004] $)

  $( Equivalent expressions for "not less than" in the Hilbert lattice. $)
  chnle $p |- ( ( A e. CH /\ B e. CH ) ->
               ( -. B C_ A <-> A C. ( A vH B ) ) ) $=
    cA cch wcel cB cch wcel cB cA wss wn cA cA cB chj co wpss wb cB cA cch wcel
    cA c0h cif wss wn cA cch wcel cA c0h cif cA cch wcel cA c0h cif cB chj co
    wpss wb cB cch wcel cB c0h cif cA cch wcel cA c0h cif wss wn cA cch wcel cA
    c0h cif cA cch wcel cA c0h cif cB cch wcel cB c0h cif chj co wpss wb cA cB
    c0h c0h cA cA cch wcel cA c0h cif wceq cB cA wss wn cB cA cch wcel cA c0h
    cif wss wn cA cA cB chj co wpss cA cch wcel cA c0h cif cA cch wcel cA c0h
    cif cB chj co wpss cA cA cch wcel cA c0h cif wceq cB cA wss cB cA cch wcel
    cA c0h cif wss cA cA cch wcel cA c0h cif cB sseq2 notbid cA cA cch wcel cA
    c0h cif wceq cA cA cch wcel cA c0h cif cA cB chj co cA cch wcel cA c0h cif
    cB chj co cA cA cch wcel cA c0h cif wceq id cA cA cch wcel cA c0h cif cB
    chj opreq1 psseq12d bibi12d cB cB cch wcel cB c0h cif wceq cB cA cch wcel
    cA c0h cif wss wn cB cch wcel cB c0h cif cA cch wcel cA c0h cif wss wn cA
    cch wcel cA c0h cif cA cch wcel cA c0h cif cB chj co wpss cA cch wcel cA
    c0h cif cA cch wcel cA c0h cif cB cch wcel cB c0h cif chj co wpss cB cB cch
    wcel cB c0h cif wceq cB cA cch wcel cA c0h cif wss cB cch wcel cB c0h cif
    cA cch wcel cA c0h cif wss cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif
    sseq1 notbid cB cB cch wcel cB c0h cif wceq cA cch wcel cA c0h cif cB chj
    co cA cch wcel cA c0h cif cB cch wcel cB c0h cif chj co cA cch wcel cA c0h
    cif cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif chj opreq2 psseq2d
    bibi12d cA cch wcel cA c0h cif cB cch wcel cB c0h cif cA c0h cch h0elch
    elimel cB c0h cch h0elch elimel chnlei dedth2h $.
    $( [27-Jun-2004] $) $( [9-Jun-2004] $)

  $( The join of a closed subspace and its orthocomplement is all of Hilbert
     space. $)
  chjo $p |- ( A e. CH -> ( A vH ( _|_ ` A ) ) = ~H ) $=
    cA cch wcel cA cA cort cfv chj co chil wceq cA cch wcel cA chil cif cA cch
    wcel cA chil cif cort cfv chj co chil wceq cA chil cA cA cch wcel cA chil
    cif wceq cA cA cort cfv chj co cA cch wcel cA chil cif cA cch wcel cA chil
    cif cort cfv chj co chil cA cA cch wcel cA chil cif wceq cA cA cch wcel cA
    chil cif cA cort cfv cA cch wcel cA chil cif cort cfv chj cA cA cch wcel cA
    chil cif wceq id cA cA cch wcel cA chil cif cort fveq2 opreq12d eqeq1d cA
    cch wcel cA chil cif cA chil cch helch elimel chjoi dedth $.
    $( [26-Nov-2005] $) $( [31-Oct-2005] $)

  $( Hilbert lattice absorption law.  From definition of lattice in
     [Kalmbach] p. 14. $)
  chabs1 $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH ( A i^i B ) ) = A ) $=
    cA cch wcel cB cch wcel wa cA cA cB cin chj co cA cA cch wcel cB cch wcel
    wa cA cA wss cA cB cin cA wss wa cA cA cB cin chj co cA wss cA cA wss cA cB
    cin cA wss cA ssid cA cB inss1 pm3.2i cA cch wcel cA cB cin cch wcel cA cch
    wcel cA cA wss cA cB cin cA wss wa cA cA cB cin chj co cA wss wb cA cch
    wcel cB cch wcel wa cA cA cB cin cA chlub cA cch wcel cB cch wcel pm3.26 cA
    cB chincl cA cch wcel cB cch wcel pm3.26 syl3anc mpbii cA cch wcel cB cch
    wcel cA cB cin cch wcel cA cA cA cB cin chj co wss cA cB chincl cA cA cB
    cin chub1 syldan eqssd $.
    $( [27-Jun-2004] $) $( [15-Jun-2004] $)

  $( Hilbert lattice absorption law.  From definition of lattice in
     [Kalmbach] p. 14. $)
  chabs2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A i^i ( A vH B ) ) = A ) $=
    cA cch wcel cB cch wcel wa cA cA cB chj co cin cA wss cA cA cA cB chj co
    cin wss wa cA cA cB chj co cin cA wceq cA cch wcel cB cch wcel wa cA cA cA
    cB chj co cin wss cA cA cB chj co cin cA wss cA cch wcel cB cch wcel wa cA
    cA wss cA cA cB chj co wss wa cA cA cA cB chj co cin wss cA cch wcel cB cch
    wcel wa cA cA cB chj co wss cA cA wss cA cB chub1 cA ssid jctil cA cA cA cB
    chj co ssin sylib cA cA cB chj co inss1 jctil cA cA cB chj co cin cA eqss
    sylibr $.
    $( [27-Jun-2004] $) $( [16-Jun-2004] $)

  ${
    chabs.1 $e |- A e. CH $.
    chabs.2 $e |- B e. CH $.
    $( Hilbert lattice absorption law.  From definition of lattice in
     [Kalmbach] p. 14. $)
    chabs1i $p |- ( A vH ( A i^i B ) ) = A $=
      cA cch wcel cB cch wcel cA cA cB cin chj co cA wceq chabs.1 chabs.2 cA cB
      chabs1 mp2an $.
      $( [27-Jun-2004] $) $( [10-Jun-2004] $)

    $( Hilbert lattice absorption law.  From definition of lattice in
     [Kalmbach] p. 14. $)
    chabs2i $p |- ( A i^i ( A vH B ) ) = A $=
      cA cch wcel cB cch wcel cA cA cB chj co cin cA wceq chabs.1 chabs.2 cA cB
      chabs2 mp2an $.
      $( [27-Jun-2004] $) $( [16-Jun-2004] $)
  $}

  $( Idempotent law for Hilbert lattice join. $)
  chjidm $p |- ( A e. CH -> ( A vH A ) = A ) $=
    cA cch wcel cA cA cA cin chj co cA cA cA chj co cA cch wcel cA cA cA cin
    chj co cA wceq cA cA chabs1 anidms cA cA cin cA cA chj cA inidm opreq2i
    syl5eqr $.
    $( [27-Jun-2004] $) $( [26-Jun-2004] $)

  ${
    chjidm.1 $e |- A e. CH $.
    $( Idempotent law for Hilbert lattice join. $)
    chjidmi $p |- ( A vH A ) = A $=
      cA cch wcel cA cA chj co cA wceq chjidm.1 cA chjidm ax-mp $.
      $( [27-Jun-2004] $) $( [15-Jun-2004] $)
  $}

  ${
    chj12.1 $e |- A e. CH $.
    chj12.2 $e |- B e. CH $.
    chj12.3 $e |- C e. CH $.
    $( A rearrangement of Hilbert lattice join. $)
    chj12i $p |- ( A vH ( B vH C ) ) = ( B vH ( A vH C ) ) $=
      cA cB chj co cC chj co cB cA chj co cC chj co cA cB cC chj co chj co cB
      cA cC chj co chj co cA cB chj co cB cA chj co cC chj cA cB chj12.1
      chj12.2 chjcomi opreq1i cA cB cC chj12.1 chj12.2 chj12.3 chjassi cB cA cC
      chj12.2 chj12.1 chj12.3 chjassi 3eqtr3i $.
      $( [11-May-2006] $) $( [29-Apr-2006] $)

    ${
      chj4.4 $e |- D e. CH $.
      $( Rearrangement of the join of 4 Hilbert lattice elements. $)
      chj4i $p |- ( ( A vH B ) vH ( C vH D ) ) =
                 ( ( A vH C ) vH ( B vH D ) ) $=
        cA cB cC cD chj co chj co chj co cA cC cB cD chj co chj co chj co cA cB
        chj co cC cD chj co chj co cA cC chj co cB cD chj co chj co cB cC cD
        chj co chj co cC cB cD chj co chj co cA chj cB cC cD chj12.2 chj12.3
        chj4.4 chj12i opreq2i cA cB cC cD chj co chj12.1 chj12.2 cC cD chj12.3
        chj4.4 chjcli chjassi cA cC cB cD chj co chj12.1 chj12.3 cB cD chj12.2
        chj4.4 chjcli chjassi 3eqtr4i $.
        $( [14-May-2006] $) $( [29-Apr-2006] $)
    $}

    $( Hilbert lattice join distributes over itself. $)
    chjjdiri $p |- ( ( A vH B ) vH C ) = ( ( A vH C ) vH ( B vH C ) ) $=
      cA cB chj co cC cC chj co chj co cA cB chj co cC chj co cA cC chj co cB
      cC chj co chj co cC cC chj co cC cA cB chj co chj cC chj12.3 chjidmi
      opreq2i cA cB cC cC chj12.1 chj12.2 chj12.3 chj12.3 chj4i eqtr3i $.
      $( [14-May-2006] $) $( [29-Apr-2006] $)
  $}

  $( DeMorgan's law for meet in a Hilbert lattice. $)
  chdmm1 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A i^i B ) ) = ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) $=
    cA cch wcel cB cch wcel cA cB cin cort cfv cA cort cfv cB cort cfv chj co
    wceq cA cch wcel cA chil cif cB cin cort cfv cA cch wcel cA chil cif cort
    cfv cB cort cfv chj co wceq cA cch wcel cA chil cif cB cch wcel cB chil cif
    cin cort cfv cA cch wcel cA chil cif cort cfv cB cch wcel cB chil cif cort
    cfv chj co wceq cA cB chil chil cA cA cch wcel cA chil cif wceq cA cB cin
    cort cfv cA cch wcel cA chil cif cB cin cort cfv cA cort cfv cB cort cfv
    chj co cA cch wcel cA chil cif cort cfv cB cort cfv chj co cA cA cch wcel
    cA chil cif wceq cA cB cin cA cch wcel cA chil cif cB cin cort cA cA cch
    wcel cA chil cif cB ineq1 fveq2d cA cA cch wcel cA chil cif wceq cA cort
    cfv cA cch wcel cA chil cif cort cfv cB cort cfv chj cA cA cch wcel cA chil
    cif cort fveq2 opreq1d eqeq12d cB cB cch wcel cB chil cif wceq cA cch wcel
    cA chil cif cB cin cort cfv cA cch wcel cA chil cif cB cch wcel cB chil cif
    cin cort cfv cA cch wcel cA chil cif cort cfv cB cort cfv chj co cA cch
    wcel cA chil cif cort cfv cB cch wcel cB chil cif cort cfv chj co cB cB cch
    wcel cB chil cif wceq cA cch wcel cA chil cif cB cin cA cch wcel cA chil
    cif cB cch wcel cB chil cif cin cort cB cB cch wcel cB chil cif cA cch wcel
    cA chil cif ineq2 fveq2d cB cB cch wcel cB chil cif wceq cB cort cfv cB cch
    wcel cB chil cif cort cfv cA cch wcel cA chil cif cort cfv chj cB cB cch
    wcel cB chil cif cort fveq2 opreq2d eqeq12d cA cch wcel cA chil cif cB cch
    wcel cB chil cif cA chil cch helch elimel cB chil cch helch elimel chdmm1i
    dedth2h $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for meet in a Hilbert lattice. $)
  chdmm2 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) i^i B ) ) = ( A vH ( _|_ ` B ) ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB cin cort cfv cA cort cfv cort cfv
    cB cort cfv chj co cA cB cort cfv chj co cA cort cfv cch wcel cB cch wcel
    cA cort cfv cB cin cort cfv cA cort cfv cort cfv cB cort cfv chj co wceq cA
    cch wcel cA cort cfv cB chdmm1 cA choccl sylan cA cch wcel cB cch wcel wa
    cA cort cfv cort cfv cA cB cort cfv chj cA cch wcel cA cort cfv cort cfv cA
    wceq cB cch wcel cA ococ adantr opreq1d eqtrd $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for meet in a Hilbert lattice. $)
  chdmm3 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A i^i ( _|_ ` B ) ) ) = ( ( _|_ ` A ) vH B ) ) $=
    cA cch wcel cB cch wcel wa cA cB cort cfv cin cort cfv cA cort cfv cB cort
    cfv cort cfv chj co cA cort cfv cB chj co cA cch wcel cB cort cfv cch wcel
    cA cB cort cfv cin cort cfv cA cort cfv cB cort cfv cort cfv chj co wceq cB
    cch wcel cA cB cort cfv chdmm1 cB choccl sylan2 cA cch wcel cB cch wcel wa
    cB cort cfv cort cfv cB cA cort cfv chj cB cch wcel cB cort cfv cort cfv cB
    wceq cA cch wcel cB ococ adantl opreq2d eqtrd $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for meet in a Hilbert lattice. $)
  chdmm4 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) i^i ( _|_ ` B ) ) ) = ( A vH B ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv cin cort cfv cA cB cort
    cfv cort cfv chj co cA cB chj co cA cch wcel cB cort cfv cch wcel cA cort
    cfv cB cort cfv cin cort cfv cA cB cort cfv cort cfv chj co wceq cB cch
    wcel cA cB cort cfv chdmm2 cB choccl sylan2 cA cch wcel cB cch wcel wa cB
    cort cfv cort cfv cB cA chj cB cch wcel cB cort cfv cort cfv cB wceq cA cch
    wcel cB ococ adantl opreq2d eqtrd $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for join in a Hilbert lattice. $)
  chdmj1 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A vH B ) ) = ( ( _|_ ` A ) i^i ( _|_ ` B ) ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv cin cort cfv cort cfv cA
    cB chj co cort cfv cA cort cfv cB cort cfv cin cA cch wcel cB cch wcel wa
    cA cort cfv cB cort cfv cin cort cfv cA cB chj co cort cA cB chdmm4 fveq2d
    cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv cin cch wcel cA cort cfv
    cB cort cfv cin cort cfv cort cfv cA cort cfv cB cort cfv cin wceq cA cort
    cfv cch wcel cB cort cfv cch wcel cA cort cfv cB cort cfv cin cch wcel cA
    cch wcel cB cch wcel cA cort cfv cB cort cfv chincl cA choccl cB choccl
    syl2an cA cort cfv cB cort cfv cin ococ syl eqtr3d $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for join in a Hilbert lattice. $)
  chdmj2 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) vH B ) ) = ( A i^i ( _|_ ` B ) ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB chj co cort cfv cA cort cfv cort
    cfv cB cort cfv cin cA cB cort cfv cin cA cort cfv cch wcel cB cch wcel cA
    cort cfv cB chj co cort cfv cA cort cfv cort cfv cB cort cfv cin wceq cA
    cch wcel cA cort cfv cB chdmj1 cA choccl sylan cA cch wcel cA cort cfv cort
    cfv cB cort cfv cin cA cB cort cfv cin wceq cB cch wcel cA cch wcel cA cort
    cfv cort cfv cA cB cort cfv cA ococ ineq1d adantr eqtrd $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for join in a Hilbert lattice. $)
  chdmj3 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A vH ( _|_ ` B ) ) ) = ( ( _|_ ` A ) i^i B ) ) $=
    cA cch wcel cB cch wcel wa cA cB cort cfv chj co cort cfv cA cort cfv cB
    cort cfv cort cfv cin cA cort cfv cB cin cA cch wcel cB cort cfv cch wcel
    cA cB cort cfv chj co cort cfv cA cort cfv cB cort cfv cort cfv cin wceq cB
    cch wcel cA cB cort cfv chdmj1 cB choccl sylan2 cA cch wcel cB cch wcel wa
    cB cort cfv cort cfv cB cA cort cfv cB cch wcel cB cort cfv cort cfv cB
    wceq cA cch wcel cB ococ adantl ineq2d eqtrd $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( DeMorgan's law for join in a Hilbert lattice. $)
  chdmj4 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) = ( A i^i B ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv chj co cort cfv cA cB
    cort cfv cort cfv cin cA cB cin cA cch wcel cB cort cfv cch wcel cA cort
    cfv cB cort cfv chj co cort cfv cA cB cort cfv cort cfv cin wceq cB cch
    wcel cA cB cort cfv chdmj2 cB choccl sylan2 cA cch wcel cB cch wcel wa cB
    cort cfv cort cfv cB cA cB cch wcel cB cort cfv cort cfv cB wceq cA cch
    wcel cB ococ adantl ineq2d eqtrd $.
    $( [3-Jul-2004] $) $( [21-Jun-2004] $)

  $( Associative law for Hilbert lattice join.  From definition of lattice in
     [Kalmbach] p. 14. $)
  chjass $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
                ( ( A vH B ) vH C ) = ( A vH ( B vH C ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel cA cB chj co cC chj co cA cB cC chj co
    chj co wceq cA cch wcel cA chil cif cB chj co cC chj co cA cch wcel cA chil
    cif cB cC chj co chj co wceq cA cB cC chil chil chil cA cch wcel cA chil
    cif cB cch wcel cB chil cif chj co cC chj co cA cch wcel cA chil cif cB cch
    wcel cB chil cif cC chj co chj co wceq cA cch wcel cA chil cif cB cch wcel
    cB chil cif chj co cC cch wcel cC chil cif chj co cA cch wcel cA chil cif
    cB cch wcel cB chil cif cC cch wcel cC chil cif chj co chj co wceq cA cA
    cch wcel cA chil cif wceq cA cB chj co cC chj co cA cch wcel cA chil cif cB
    chj co cC chj co cA cB cC chj co chj co cA cch wcel cA chil cif cB cC chj
    co chj co cA cA cch wcel cA chil cif wceq cA cB chj co cA cch wcel cA chil
    cif cB chj co cC chj cA cA cch wcel cA chil cif cB chj opreq1 opreq1d cA cA
    cch wcel cA chil cif cB cC chj co chj opreq1 eqeq12d cB cB cch wcel cB chil
    cif wceq cA cch wcel cA chil cif cB chj co cC chj co cA cch wcel cA chil
    cif cB cch wcel cB chil cif chj co cC chj co cA cch wcel cA chil cif cB cC
    chj co chj co cA cch wcel cA chil cif cB cch wcel cB chil cif cC chj co chj
    co cB cB cch wcel cB chil cif wceq cA cch wcel cA chil cif cB chj co cA cch
    wcel cA chil cif cB cch wcel cB chil cif chj co cC chj cB cB cch wcel cB
    chil cif cA cch wcel cA chil cif chj opreq2 opreq1d cB cB cch wcel cB chil
    cif wceq cB cC chj co cB cch wcel cB chil cif cC chj co cA cch wcel cA chil
    cif chj cB cB cch wcel cB chil cif cC chj opreq1 opreq2d eqeq12d cC cC cch
    wcel cC chil cif wceq cA cch wcel cA chil cif cB cch wcel cB chil cif chj
    co cC chj co cA cch wcel cA chil cif cB cch wcel cB chil cif chj co cC cch
    wcel cC chil cif chj co cA cch wcel cA chil cif cB cch wcel cB chil cif cC
    chj co chj co cA cch wcel cA chil cif cB cch wcel cB chil cif cC cch wcel
    cC chil cif chj co chj co cC cC cch wcel cC chil cif cA cch wcel cA chil
    cif cB cch wcel cB chil cif chj co chj opreq2 cC cC cch wcel cC chil cif
    wceq cB cch wcel cB chil cif cC chj co cB cch wcel cB chil cif cC cch wcel
    cC chil cif chj co cA cch wcel cA chil cif chj cC cC cch wcel cC chil cif
    cB cch wcel cB chil cif chj opreq2 opreq2d eqeq12d cA cch wcel cA chil cif
    cB cch wcel cB chil cif cC cch wcel cC chil cif cA chil cch helch elimel cB
    chil cch helch elimel cC chil cch helch elimel chjassi dedth3h $.
    $( [28-Jun-2004] $) $( [10-Jun-2004] $)

  $( A rearrangement of Hilbert lattice join. $)
  chj12 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
              ( A vH ( B vH C ) ) = ( B vH ( A vH C ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB chj co cC chj co cB cA chj co
    cC chj co cA cB cC chj co chj co cB cA cC chj co chj co cA cch wcel cB cch
    wcel cC cch wcel w3a cA cB chj co cB cA chj co cC chj cA cch wcel cB cch
    wcel cA cB chj co cB cA chj co wceq cC cch wcel cA cB chjcom 3adant3
    opreq1d cA cB cC chjass cB cch wcel cA cch wcel cC cch wcel cB cA chj co cC
    chj co cB cA cC chj co chj co wceq cB cA cC chjass 3com12 3eqtr3d $.
    $( [27-Jun-2006] $) $( [15-Jun-2006] $)

  $( Rearrangement of the join of 4 Hilbert lattice elements. $)
  chj4 $p |- ( ( ( A e. CH /\ B e. CH ) /\ ( C e. CH /\ D e. CH ) ) ->
              ( ( A vH B ) vH ( C vH D ) ) = ( ( A vH C ) vH ( B vH D ) ) ) $=
    cA cch wcel cB cch wcel wa cC cch wcel cD cch wcel wa wa cA cB cC cD chj co
    chj co chj co cA cC cB cD chj co chj co chj co cA cB chj co cC cD chj co
    chj co cA cC chj co cB cD chj co chj co cA cch wcel cB cch wcel wa cC cch
    wcel cD cch wcel wa wa cB cC cD chj co chj co cC cB cD chj co chj co cA chj
    cB cch wcel cC cch wcel cD cch wcel wa cB cC cD chj co chj co cC cB cD chj
    co chj co wceq cA cch wcel cB cch wcel cC cch wcel cD cch wcel cB cC cD chj
    co chj co cC cB cD chj co chj co wceq cB cC cD chj12 3expb adantll opreq2d
    cA cch wcel cB cch wcel wa cC cD chj co cch wcel cA cB chj co cC cD chj co
    chj co cA cB cC cD chj co chj co chj co wceq cC cch wcel cD cch wcel wa cA
    cch wcel cB cch wcel cC cD chj co cch wcel cA cB chj co cC cD chj co chj co
    cA cB cC cD chj co chj co chj co wceq cA cB cC cD chj co chjass 3expa cC cD
    chjcl sylan2 cA cch wcel cC cch wcel cB cch wcel cD cch wcel cA cC chj co
    cB cD chj co chj co cA cC cB cD chj co chj co chj co wceq cA cch wcel cC
    cch wcel wa cB cD chj co cch wcel cA cC chj co cB cD chj co chj co cA cC cB
    cD chj co chj co chj co wceq cB cch wcel cD cch wcel wa cA cch wcel cC cch
    wcel cB cD chj co cch wcel cA cC chj co cB cD chj co chj co cA cC cB cD chj
    co chj co chj co wceq cA cC cB cD chj co chjass 3expa cB cD chjcl sylan2
    an4s 3eqtr4d $.
    $( [27-Jun-2006] $) $( [15-Jun-2006] $)

  ${
    ledi.1 $e |- A e. CH $.
    ledi.2 $e |- B e. CH $.
    ledi.3 $e |- C e. CH $.
    $( An ortholattice is distributive in one ordering direction. $)
    ledii $p |- ( ( A i^i B ) vH ( A i^i C ) ) C_ ( A i^i ( B vH C ) ) $=
      cA cB cin cA cC cin chj co cA cB cC chj co cA cB cin cA wss cA cC cin cA
      wss cA cB cin cA cC cin chj co cA wss cA cB inss1 cA cC inss1 cA cB cin
      cA cC cin cA cA cB ledi.1 ledi.2 chincli cA cC ledi.1 ledi.3 chincli
      ledi.1 chlubii mp2an cA cB cin cB wss cA cC cin cC wss cA cB cin cA cC
      cin chj co cB cC chj co wss cA cB inss2 cA cC inss2 cA cB cin cB cA cC
      cin cC cA cB ledi.1 ledi.2 chincli ledi.2 cA cC ledi.1 ledi.3 chincli
      ledi.3 chlej12i mp2an ssini $.
      $( [11-Aug-2004] $) $( [6-Aug-2004] $)

    $( An ortholattice is distributive in one ordering direction. $)
    lediri $p |- ( ( A i^i C ) vH ( B i^i C ) ) C_ ( ( A vH B ) i^i C ) $=
      cC cA cin cC cB cin chj co cC cA cB chj co cin cA cC cin cB cC cin chj co
      cA cB chj co cC cin cC cA cB ledi.3 ledi.1 ledi.2 ledii cA cC cin cC cA
      cin cB cC cin cC cB cin chj cA cC incom cB cC incom opreq12i cA cB chj co
      cC incom 3sstr4i $.
      $( [14-May-2006] $) $( [27-Apr-2006] $)

    $( An ortholattice is distributive in one ordering direction (join
       version). $)
    lejdii $p |- ( A vH ( B i^i C ) ) C_ ( ( A vH B ) i^i ( A vH C ) ) $=
      cA cB cC cin chj co cA cB chj co cA cC chj co cin wss cA cA cB chj co cA
      cC chj co cin wss cB cC cin cA cB chj co cA cC chj co cin wss cA cA cB
      chj co cA cC chj co cin wss cB cC cin cA cB chj co cA cC chj co cin wss
      wa cA cB cC cin chj co cA cB chj co cA cC chj co cin wss cA cB cC cin cA
      cB chj co cA cC chj co cin ledi.1 cB cC ledi.2 ledi.3 chincli cA cB chj
      co cA cC chj co cA cB ledi.1 ledi.2 chjcli cA cC ledi.1 ledi.3 chjcli
      chincli chlubi bicomi cA cA cB chj co cA cC chj co cA cB ledi.1 ledi.2
      chub1i cA cC ledi.1 ledi.3 chub1i ssini cB cC cin cA cB chj co cA cC chj
      co cB cC cin cB cA cB chj co cB cC inss1 cB cA ledi.2 ledi.1 chub2i sstri
      cB cC cin cC cA cC chj co cB cC inss2 cC cA ledi.3 ledi.1 chub2i sstri
      ssini mpbir2an $.
      $( [16-May-2006] $) $( [27-Apr-2006] $)

    $( An ortholattice is distributive in one ordering direction (join
       version). $)
    lejdiri $p |- ( ( A i^i B ) vH C ) C_ ( ( A vH C ) i^i ( B vH C ) ) $=
      cC cA cB cin chj co cC cA chj co cC cB chj co cin cA cB cin cC chj co cA
      cC chj co cB cC chj co cin cC cA cB ledi.3 ledi.1 ledi.2 lejdii cA cB cin
      cC cA cB ledi.1 ledi.2 chincli ledi.3 chjcomi cA cC chj co cC cA chj co
      cB cC chj co cC cB chj co cA cC ledi.1 ledi.3 chjcomi cB cC ledi.2 ledi.3
      chjcomi ineq12i 3sstr4i $.
      $( [20-May-2006] $) $( [27-Apr-2006] $)
  $}

  $( An ortholattice is distributive in one ordering direction. $)
  ledi $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
              ( ( A i^i B ) vH ( A i^i C ) ) C_ ( A i^i ( B vH C ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel cA cB cin cA cC cin chj co cA cB cC chj
    co cin wss cA cch wcel cA c0h cif cB cin cA cch wcel cA c0h cif cC cin chj
    co cA cch wcel cA c0h cif cB cC chj co cin wss cA cB cC c0h c0h c0h cA cch
    wcel cA c0h cif cB cch wcel cB c0h cif cin cA cch wcel cA c0h cif cC cin
    chj co cA cch wcel cA c0h cif cB cch wcel cB c0h cif cC chj co cin wss cA
    cch wcel cA c0h cif cB cch wcel cB c0h cif cin cA cch wcel cA c0h cif cC
    cch wcel cC c0h cif cin chj co cA cch wcel cA c0h cif cB cch wcel cB c0h
    cif cC cch wcel cC c0h cif chj co cin wss cA cA cch wcel cA c0h cif wceq cA
    cB cin cA cC cin chj co cA cch wcel cA c0h cif cB cin cA cch wcel cA c0h
    cif cC cin chj co cA cB cC chj co cin cA cch wcel cA c0h cif cB cC chj co
    cin cA cA cch wcel cA c0h cif wceq cA cB cin cA cch wcel cA c0h cif cB cin
    cA cC cin cA cch wcel cA c0h cif cC cin chj cA cA cch wcel cA c0h cif cB
    ineq1 cA cA cch wcel cA c0h cif cC ineq1 opreq12d cA cA cch wcel cA c0h cif
    cB cC chj co ineq1 sseq12d cB cB cch wcel cB c0h cif wceq cA cch wcel cA
    c0h cif cB cin cA cch wcel cA c0h cif cC cin chj co cA cch wcel cA c0h cif
    cB cch wcel cB c0h cif cin cA cch wcel cA c0h cif cC cin chj co cA cch wcel
    cA c0h cif cB cC chj co cin cA cch wcel cA c0h cif cB cch wcel cB c0h cif
    cC chj co cin cB cB cch wcel cB c0h cif wceq cA cch wcel cA c0h cif cB cin
    cA cch wcel cA c0h cif cB cch wcel cB c0h cif cin cA cch wcel cA c0h cif cC
    cin chj cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif ineq2 opreq1d cB
    cB cch wcel cB c0h cif wceq cB cC chj co cB cch wcel cB c0h cif cC chj co
    cA cch wcel cA c0h cif cB cB cch wcel cB c0h cif cC chj opreq1 ineq2d
    sseq12d cC cC cch wcel cC c0h cif wceq cA cch wcel cA c0h cif cB cch wcel
    cB c0h cif cin cA cch wcel cA c0h cif cC cin chj co cA cch wcel cA c0h cif
    cB cch wcel cB c0h cif cin cA cch wcel cA c0h cif cC cch wcel cC c0h cif
    cin chj co cA cch wcel cA c0h cif cB cch wcel cB c0h cif cC chj co cin cA
    cch wcel cA c0h cif cB cch wcel cB c0h cif cC cch wcel cC c0h cif chj co
    cin cC cC cch wcel cC c0h cif wceq cA cch wcel cA c0h cif cC cin cA cch
    wcel cA c0h cif cC cch wcel cC c0h cif cin cA cch wcel cA c0h cif cB cch
    wcel cB c0h cif cin chj cC cC cch wcel cC c0h cif cA cch wcel cA c0h cif
    ineq2 opreq2d cC cC cch wcel cC c0h cif wceq cB cch wcel cB c0h cif cC chj
    co cB cch wcel cB c0h cif cC cch wcel cC c0h cif chj co cA cch wcel cA c0h
    cif cC cC cch wcel cC c0h cif cB cch wcel cB c0h cif chj opreq2 ineq2d
    sseq12d cA cch wcel cA c0h cif cB cch wcel cB c0h cif cC cch wcel cC c0h
    cif cA c0h cch h0elch elimel cB c0h cch h0elch elimel cC c0h cch h0elch
    elimel ledii dedth3h $.
    $( [15-Jun-2006] $) $( [14-Jun-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Span (cont.) and one-dimensional subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The span of the singleton of the zero vector is the zero subspace. $)
  spansn0 $p |- ( span ` { 0h } ) = 0H $=
    c0h cspn cfv c0v csn cspn cfv c0h c0h c0v csn cspn df-ch0 fveq2i c0h csh
    wcel c0h cspn cfv c0h wceq h0elsh c0h spanid ax-mp eqtr3i $.
    $( [17-Jan-2005] $) $( [14-Jan-2005] $)

  $( The span of the empty set is the zero subspace.  Remark 11.6.e of
     [Schechter] p. 276. $)
  span0 $p |- ( span ` (/) ) = 0H $=
    c0 cspn cfv c0h c0 cspn cfv c0h cspn cfv c0h c0h chil wss c0 c0h wss c0
    cspn cfv c0h cspn cfv wss c0h h0elsh shssii c0h 0ss c0 c0h spanss mp2an c0h
    csh wcel c0h cspn cfv c0h wceq h0elsh c0h spanid ax-mp sseqtri c0 cspn cfv
    csh wcel c0h c0 cspn cfv wss c0 chil wss c0 cspn cfv csh wcel chil 0ss c0
    spancl ax-mp c0 cspn cfv sh0le ax-mp eqssi $.
    $( [17-Aug-2004] $) $( [3-Jun-2004] $)

  ${
    $d x A $.  $d x B $.
    elspan.1 $e |- B e. _V $.
    $( Membership in the span of a subset of Hilbert space. $)
    elspani $p |- ( A C_ ~H ->
                ( B e. ( span ` A ) <-> A. x e. SH ( A C_ x -> B e. x ) ) ) $=
      cA chil wss cB cA cspn cfv wcel cB cA vx cv wss vx csh crab cint wcel cA
      vx cv wss cB vx cv wcel wi vx csh wral cA chil wss cA cspn cfv cA vx cv
      wss vx csh crab cint cB vx cA spanval eleq2d cA vx cv wss vx cB csh
      elspan.1 elintrab syl6bb $.
      $( [3-Jun-2004] $) $( [2-Jun-2004] $)

  $}

  ${
    spanun.1 $e |- A C_ ~H $.
    spanun.2 $e |- B C_ ~H $.
    $d x y z w A $.  $d x y z w B $.
    $( The span of a union is the subspace sum of spans. $)
    spanuni $p |- ( span ` ( A u. B ) ) = ( ( span ` A ) +H ( span ` B ) ) $=
      cA cB cun cspn cfv cA cspn cfv cB cspn cfv cph co cA cB cun cspn cfv cA
      cspn cfv cB cspn cfv cph co cspn cfv cA cspn cfv cB cspn cfv cph co cA
      cspn cfv cB cspn cfv cph co chil wss cA cB cun cA cspn cfv cB cspn cfv
      cph co wss cA cB cun cspn cfv cA cspn cfv cB cspn cfv cph co cspn cfv wss
      cA cspn cfv cB cspn cfv cph co cA cspn cfv cB cspn cfv cA chil wss cA
      cspn cfv csh wcel spanun.1 cA spancl ax-mp cB chil wss cB cspn cfv csh
      wcel spanun.2 cB spancl ax-mp shscli shssii cA cB cun cA cspn cfv cB cspn
      cfv cun cA cspn cfv cB cspn cfv cph co cA cA cspn cfv wss cB cB cspn cfv
      wss cA cB cun cA cspn cfv cB cspn cfv cun wss cA chil wss cA cA cspn cfv
      wss spanun.1 cA spanss2 ax-mp cB chil wss cB cB cspn cfv wss spanun.2 cB
      spanss2 ax-mp cA cA cspn cfv cB cB cspn cfv unss12 mp2an cA cspn cfv cB
      cspn cfv cA chil wss cA cspn cfv csh wcel spanun.1 cA spancl ax-mp cB
      chil wss cB cspn cfv csh wcel spanun.2 cB spancl ax-mp shunssi sstri cA
      cB cun cA cspn cfv cB cspn cfv cph co spanss mp2an cA cspn cfv cB cspn
      cfv cph co csh wcel cA cspn cfv cB cspn cfv cph co cspn cfv cA cspn cfv
      cB cspn cfv cph co wceq cA cspn cfv cB cspn cfv cA chil wss cA cspn cfv
      csh wcel spanun.1 cA spancl ax-mp cB chil wss cB cspn cfv csh wcel
      spanun.2 cB spancl ax-mp shscli cA cspn cfv cB cspn cfv cph co spanid
      ax-mp sseqtri vx cA cspn cfv cB cspn cfv cph co cA cB cun cspn cfv vx cv
      cA cspn cfv cB cspn cfv cph co wcel vz cv cA cspn cfv wcel vw cv cB cspn
      cfv wcel wa vx cv vz cv vw cv cva co wceq wa vw wex vz wex vx cv cA cB
      cun cspn cfv wcel vx cv cA cspn cfv cB cspn cfv cph co wcel vx cv vz cv
      vw cv cva co wceq vw cB cspn cfv wrex vz cA cspn cfv wrex vz cv cA cspn
      cfv wcel vw cv cB cspn cfv wcel wa vx cv vz cv vw cv cva co wceq wa vw
      wex vz wex vz vw cA cspn cfv cB cspn cfv vx cv cA chil wss cA cspn cfv
      csh wcel spanun.1 cA spancl ax-mp cB chil wss cB cspn cfv csh wcel
      spanun.2 cB spancl ax-mp shseli vx cv vz cv vw cv cva co wceq vz vw cA
      cspn cfv cB cspn cfv r2ex bitri vz cv cA cspn cfv wcel vw cv cB cspn cfv
      wcel wa vx cv vz cv vw cv cva co wceq wa vx cv cA cB cun cspn cfv wcel vz
      vw vz cv cA cspn cfv wcel vw cv cB cspn cfv wcel wa vx cv vz cv vw cv cva
      co wceq wa cA vy cv wss vz cv vy cv wcel wi cB vy cv wss vw cv vy cv wcel
      wi wa vx cv vz cv vw cv cva co wceq wa vy csh wral vx cv cA cB cun cspn
      cfv wcel cA vy cv wss vz cv vy cv wcel wi cB vy cv wss vw cv vy cv wcel
      wi wa vy csh wral vx cv vz cv vw cv cva co wceq cA vy cv wss vz cv vy cv
      wcel wi cB vy cv wss vw cv vy cv wcel wi wa vx cv vz cv vw cv cva co wceq
      wa vy csh wral vz cv cA cspn cfv wcel vw cv cB cspn cfv wcel wa cA vy cv
      wss vz cv vy cv wcel wi cB vy cv wss vw cv vy cv wcel wi wa vx cv vz cv
      vw cv cva co wceq vy csh r19.27av vz cv cA cspn cfv wcel vw cv cB cspn
      cfv wcel wa cA vy cv wss vz cv vy cv wcel wi vy csh wral cB vy cv wss vw
      cv vy cv wcel wi vy csh wral wa cA vy cv wss vz cv vy cv wcel wi cB vy cv
      wss vw cv vy cv wcel wi wa vy csh wral vz cv cA cspn cfv wcel cA vy cv
      wss vz cv vy cv wcel wi vy csh wral vw cv cB cspn cfv wcel cB vy cv wss
      vw cv vy cv wcel wi vy csh wral cA chil wss vz cv cA cspn cfv wcel cA vy
      cv wss vz cv vy cv wcel wi vy csh wral wb spanun.1 vy cA vz cv vz visset
      elspani ax-mp cB chil wss vw cv cB cspn cfv wcel cB vy cv wss vw cv vy cv
      wcel wi vy csh wral wb spanun.2 vy cB vw cv vw visset elspani ax-mp
      anbi12i cA vy cv wss vz cv vy cv wcel wi cB vy cv wss vw cv vy cv wcel wi
      vy csh r19.26 bitr4i sylanb cA vy cv wss vz cv vy cv wcel wi cB vy cv wss
      vw cv vy cv wcel wi wa vx cv vz cv vw cv cva co wceq wa vy csh wral cA cB
      cun vy cv wss vx cv vy cv wcel wi vy csh wral vx cv cA cB cun cspn cfv
      wcel cA vy cv wss vz cv vy cv wcel wi cB vy cv wss vw cv vy cv wcel wi wa
      vx cv vz cv vw cv cva co wceq wa cA cB cun vy cv wss vx cv vy cv wcel wi
      vy csh vy cv csh wcel cA vy cv wss vz cv vy cv wcel wi cB vy cv wss vw cv
      vy cv wcel wi vx cv vz cv vw cv cva co wceq cA cB cun vy cv wss vx cv vy
      cv wcel wi vy cv csh wcel cA vy cv wss vz cv vy cv wcel wi cB vy cv wss
      vw cv vy cv wcel wi vx cv vz cv vw cv cva co wceq cA cB cun vy cv wss vx
      cv vy cv wcel wi vy cv csh wcel cA vy cv wss vz cv vy cv wcel wi cB vy cv
      wss vw cv vy cv wcel wi wa wa cA cB cun vy cv wss vz cv vw cv cva co vy
      cv wcel vx cv vz cv vw cv cva co wceq vx cv vy cv wcel cA vy cv wss vz cv
      vy cv wcel wi cB vy cv wss vw cv vy cv wcel wi wa cA cB cun vy cv wss vz
      cv vy cv wcel vw cv vy cv wcel wa vy cv csh wcel vz cv vw cv cva co vy cv
      wcel cA vy cv wss vz cv vy cv wcel wi cB vy cv wss vw cv vy cv wcel wi wa
      cA vy cv wss cB vy cv wss wa vz cv vy cv wcel vw cv vy cv wcel wa cA cB
      cun vy cv wss cA vy cv wss vz cv vy cv wcel cB vy cv wss vw cv vy cv wcel
      prth cA cB vy cv unss syl5ibr vz cv vw cv vy cv shaddclOLD sylan9r vx cv
      vz cv vw cv cva co wceq vx cv vy cv wcel vz cv vw cv cva co vy cv wcel vx
      cv vz cv vw cv cva co vy cv eleq1 biimprd sylan9 exp42 imp4c r19.20i cA
      cB cun chil wss vx cv cA cB cun cspn cfv wcel cA cB cun vy cv wss vx cv
      vy cv wcel wi vy csh wral wb cA cB chil spanun.1 spanun.2 unssi vy cA cB
      cun vx cv vx visset elspani ax-mp sylibr syl 19.23aivv sylbi ssriv eqssi
      $.
      $( [28-Jun-2004] $) $( [2-Jun-2004] $)
  $}

  $( The span of a union is the subspace sum of spans. $)
  spanun $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
                ( span ` ( A u. B ) ) = ( ( span ` A ) +H ( span ` B ) ) ) $=
    cA chil wss cB chil wss cA cB cun cspn cfv cA cspn cfv cB cspn cfv cph co
    wceq cA chil wss cA chil cif cB cun cspn cfv cA chil wss cA chil cif cspn
    cfv cB cspn cfv cph co wceq cA chil wss cA chil cif cB chil wss cB chil cif
    cun cspn cfv cA chil wss cA chil cif cspn cfv cB chil wss cB chil cif cspn
    cfv cph co wceq cA cB chil chil cA cA chil wss cA chil cif wceq cA cB cun
    cspn cfv cA chil wss cA chil cif cB cun cspn cfv cA cspn cfv cB cspn cfv
    cph co cA chil wss cA chil cif cspn cfv cB cspn cfv cph co cA cA chil wss
    cA chil cif wceq cA cB cun cA chil wss cA chil cif cB cun cspn cA cA chil
    wss cA chil cif cB uneq1 fveq2d cA cA chil wss cA chil cif wceq cA cspn cfv
    cA chil wss cA chil cif cspn cfv cB cspn cfv cph cA cA chil wss cA chil cif
    cspn fveq2 opreq1d eqeq12d cB cB chil wss cB chil cif wceq cA chil wss cA
    chil cif cB cun cspn cfv cA chil wss cA chil cif cB chil wss cB chil cif
    cun cspn cfv cA chil wss cA chil cif cspn cfv cB cspn cfv cph co cA chil
    wss cA chil cif cspn cfv cB chil wss cB chil cif cspn cfv cph co cB cB chil
    wss cB chil cif wceq cA chil wss cA chil cif cB cun cA chil wss cA chil cif
    cB chil wss cB chil cif cun cspn cB cB chil wss cB chil cif cA chil wss cA
    chil cif uneq2 fveq2d cB cB chil wss cB chil cif wceq cB cspn cfv cB chil
    wss cB chil cif cspn cfv cA chil wss cA chil cif cspn cfv cph cB cB chil
    wss cB chil cif cspn fveq2 opreq2d eqeq12d cA chil wss cA chil cif cB chil
    wss cB chil cif cA chil wss cA chil wss cA chil cif chil wss chil chil wss
    cA chil cA cA chil wss cA chil cif chil sseq1 chil cA chil wss cA chil cif
    chil sseq1 chil ssid elimhyp cB chil wss cB chil wss cB chil cif chil wss
    chil chil wss cB chil cB cB chil wss cB chil cif chil sseq1 chil cB chil
    wss cB chil cif chil sseq1 chil ssid elimhyp spanuni dedth2h $.
    $( [18-Jun-2006] $) $( [9-Jun-2006] $)

  ${
    sshjococ.1 $e |- A C_ ~H $.
    sshjococ.2 $e |- B C_ ~H $.
    $( The join of two Hilbert space subsets (not necessarily closed subspaces)
       equals the join of their closures (double orthocomplements). $)
    sshhococi $p |- ( A vH B ) =
                 ( ( _|_ ` ( _|_ ` A ) ) vH ( _|_ ` ( _|_ ` B ) ) ) $=
      cA cB chj co cA cort cfv cort cfv cB cort cfv cort cfv chj co cA cB cun
      cort cfv cort cfv cA cort cfv cort cfv cB cort cfv cort cfv cun cort cfv
      cort cfv cA cB chj co cA cort cfv cort cfv cB cort cfv cort cfv chj co cA
      cB cun cA cort cfv cort cfv cB cort cfv cort cfv cun wss cA cB cun cort
      cfv cort cfv cA cort cfv cort cfv cB cort cfv cort cfv cun cort cfv cort
      cfv wss cA cA cort cfv cort cfv wss cB cB cort cfv cort cfv wss cA cB cun
      cA cort cfv cort cfv cB cort cfv cort cfv cun wss cA chil wss cA cA cort
      cfv cort cfv wss sshjococ.1 cA ococss ax-mp cB chil wss cB cB cort cfv
      cort cfv wss sshjococ.2 cB ococss ax-mp cA cA cort cfv cort cfv cB cB
      cort cfv cort cfv unss12 mp2an cA cB cun cA cort cfv cort cfv cB cort cfv
      cort cfv cun cA cB chil sshjococ.1 sshjococ.2 unssi cA cort cfv cort cfv
      cB cort cfv cort cfv chil cA cort cfv cort cfv cA cort cfv cA sshjococ.1
      occli choccli chssii cB cort cfv cort cfv cB cort cfv cB sshjococ.2 occli
      choccli chssii unssi occon2i ax-mp cA chil wss cB chil wss cA cB chj co
      cA cB cun cort cfv cort cfv wceq sshjococ.1 sshjococ.2 cA cB sshjval
      mp2an cA cort cfv cort cfv cB cort cfv cort cfv cA cort cfv cA sshjococ.1
      occli choccli cB cort cfv cB sshjococ.2 occli choccli chjvali 3sstr4i cA
      cort cfv cort cfv cB cort cfv cort cfv chj co cA cB chj co cort cfv cort
      cfv cA cB chj co cA cort cfv cort cfv cA cB chj co cort cfv cort cfv wss
      cB cort cfv cort cfv cA cB chj co cort cfv cort cfv wss cA cort cfv cort
      cfv cB cort cfv cort cfv chj co cA cB chj co cort cfv cort cfv wss cA cA
      cB chj co wss cA cort cfv cort cfv cA cB chj co cort cfv cort cfv wss cA
      cA cB cun cort cfv cort cfv cA cB chj co cA cA cB cun cA cB cun cort cfv
      cort cfv cA cB ssun1 cA cB cun chil wss cA cB cun cA cB cun cort cfv cort
      cfv wss cA cB chil sshjococ.1 sshjococ.2 unssi cA cB cun ococss ax-mp
      sstri cA chil wss cB chil wss cA cB chj co cA cB cun cort cfv cort cfv
      wceq sshjococ.1 sshjococ.2 cA cB sshjval mp2an sseqtr4i cA cA cB chj co
      sshjococ.1 cA cB chj co cA chil wss cB chil wss cA cB chj co cch wcel
      sshjococ.1 sshjococ.2 cA cB sshjcl mp2an chssii occon2i ax-mp cB cA cB
      chj co wss cB cort cfv cort cfv cA cB chj co cort cfv cort cfv wss cB cA
      cB cun cort cfv cort cfv cA cB chj co cB cA cB cun cA cB cun cort cfv
      cort cfv cB cA ssun2 cA cB cun chil wss cA cB cun cA cB cun cort cfv cort
      cfv wss cA cB chil sshjococ.1 sshjococ.2 unssi cA cB cun ococss ax-mp
      sstri cA chil wss cB chil wss cA cB chj co cA cB cun cort cfv cort cfv
      wceq sshjococ.1 sshjococ.2 cA cB sshjval mp2an sseqtr4i cB cA cB chj co
      sshjococ.2 cA cB chj co cA chil wss cB chil wss cA cB chj co cch wcel
      sshjococ.1 sshjococ.2 cA cB sshjcl mp2an chssii occon2i ax-mp cA cort cfv
      cort cfv cB cort cfv cort cfv cA cB chj co cort cfv cort cfv cA cort cfv
      cA sshjococ.1 occli choccli cB cort cfv cB sshjococ.2 occli choccli cA cB
      chj co cort cfv cA cB chj co cA chil wss cB chil wss cA cB chj co cch
      wcel sshjococ.1 sshjococ.2 cA cB sshjcl mp2an choccli choccli chlubii
      mp2an cA cB chj co cA chil wss cB chil wss cA cB chj co cch wcel
      sshjococ.1 sshjococ.2 cA cB sshjcl mp2an ococi sseqtri eqssi $.
      $( [2-Sep-2004] $) $( [1-Jun-2004] $)
  $}

  $( Hilbert space has a nonzero vector iff it is not trivial. $)
  hne0 $p |- ( ~H =/= 0H <-> E. x e. ~H x =/= 0h ) $=
    vx chil helch chne0i $.
    $( [19-Mar-2006] $) $( [24-Feb-2006] $)

  $( The supremum of the empty set. $)
  chsup0 $p |- ( \/H ` (/) ) = 0H $=
    c0 chsup cfv c0h wss c0 chsup cfv c0h wceq c0 chsup cfv c0h csn chsup cfv
    c0h c0 c0h csn wss c0 chsup cfv c0h csn chsup cfv wss c0h csn 0ss c0 cch
    wss c0h csn cch wss c0 c0h csn wss c0 chsup cfv c0h csn chsup cfv wss wi
    cch 0ss c0h cch wcel c0h csn cch wss h0elch c0h cch snssi ax-mp c0 c0h csn
    chsupss mp2an ax-mp c0h cch wcel c0h csn chsup cfv c0h wceq h0elch c0h
    chsupsn ax-mp sseqtri c0 chsup cfv c0 cch wss c0 chsup cfv cch wcel cch 0ss
    c0 chsupcl ax-mp chle0i mpbi $.
    $( [13-Aug-2002] $)

  ${
    $d x A $.  $d x B $.
    h1deot.1 $e |- B e. ~H $.
    $( Membership in orthocomplement of 1-dimensional subspace. $)
    h1deoi $p |- ( A e. ( _|_ ` { B } ) <->
                 ( A e. ~H /\ ( A .ih B ) = 0 ) ) $=
      cA cB csn cort cfv wcel cA chil wcel cA vx cv csp co cc0 wceq vx cB csn
      wral wa cA chil wcel cA cB csp co cc0 wceq wa cB csn chil wss cA cB csn
      cort cfv wcel cA chil wcel cA vx cv csp co cc0 wceq vx cB csn wral wa wb
      cB chil wcel cB csn chil wss h1deot.1 cB chil snssi ax-mp vx cA cB csn
      ocel ax-mp cA vx cv csp co cc0 wceq vx cB csn wral cA cB csp co cc0 wceq
      cA chil wcel cA vx cv csp co cc0 wceq vx cB csn wral vx cv cB csn wcel cA
      vx cv csp co cc0 wceq wi vx wal vx cv cB wceq cA vx cv csp co cc0 wceq wi
      vx wal cA cB csp co cc0 wceq cA vx cv csp co cc0 wceq vx cB csn df-ral vx
      cv cB csn wcel cA vx cv csp co cc0 wceq wi vx cv cB wceq cA vx cv csp co
      cc0 wceq wi vx vx cv cB csn wcel vx cv cB wceq cA vx cv csp co cc0 wceq
      vx cB elsn imbi1i albii cA vx cv csp co cc0 wceq cA cB csp co cc0 wceq vx
      cB cB chil h1deot.1 elisseti vx cv cB wceq cA vx cv csp co cA cB csp co
      cc0 vx cv cB cA csp opreq2 eqeq1d ceqsalv 3bitri anbi2i bitri $.
      $( [7-Jul-2001] $)

    $( Membership in 1-dimensional subspace. $)
    h1dei $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
    ( A e. ~H /\ A. x e. ~H ( ( B .ih x ) = 0 -> ( A .ih x ) = 0 ) ) ) $=
      cA cB csn cort cfv cort cfv wcel cA chil wcel cA vx cv csp co cc0 wceq vx
      cB csn cort cfv wral wa cA chil wcel cB vx cv csp co cc0 wceq cA vx cv
      csp co cc0 wceq wi vx chil wral wa cB csn cort cfv chil wss cA cB csn
      cort cfv cort cfv wcel cA chil wcel cA vx cv csp co cc0 wceq vx cB csn
      cort cfv wral wa wb cB csn cort cfv cB csn cB chil wcel cB csn chil wss
      h1deot.1 cB chil snssi ax-mp occli chssii vx cA cB csn cort cfv ocel
      ax-mp cA vx cv csp co cc0 wceq vx cB csn cort cfv wral cB vx cv csp co
      cc0 wceq cA vx cv csp co cc0 wceq wi vx chil wral cA chil wcel cA vx cv
      csp co cc0 wceq cB vx cv csp co cc0 wceq cA vx cv csp co cc0 wceq wi vx
      cB csn cort cfv chil vx cv cB csn cort cfv wcel cA vx cv csp co cc0 wceq
      wi vx cv chil wcel cB vx cv csp co cc0 wceq wa cA vx cv csp co cc0 wceq
      wi vx cv chil wcel cB vx cv csp co cc0 wceq cA vx cv csp co cc0 wceq wi
      wi vx cv cB csn cort cfv wcel vx cv chil wcel cB vx cv csp co cc0 wceq wa
      cA vx cv csp co cc0 wceq vx cv cB csn cort cfv wcel vx cv chil wcel vx cv
      cB csp co cc0 wceq wa vx cv chil wcel cB vx cv csp co cc0 wceq wa vx cv
      cB h1deot.1 h1deoi vx cv chil wcel vx cv cB csp co cc0 wceq cB vx cv csp
      co cc0 wceq vx cv chil wcel cB chil wcel vx cv cB csp co cc0 wceq cB vx
      cv csp co cc0 wceq wb h1deot.1 vx cv cB orthcom mpan2 pm5.32i bitri
      imbi1i vx cv chil wcel cB vx cv csp co cc0 wceq cA vx cv csp co cc0 wceq
      impexp bitri ralbii2 anbi2i bitri $.
      $( [7-Jul-2001] $)
  $}

  $( A generating vector belongs to the 1-dimensional subspace it
     generates. $)
  h1did $p |- ( A e. ~H -> A e. ( _|_ ` ( _|_ ` { A } ) ) ) $=
    cA chil wcel cA cA csn cort cfv cort cfv wcel cA csn cA csn cort cfv cort
    cfv wss cA chil wcel cA csn chil wss cA csn cA csn cort cfv cort cfv wss cA
    chil snssi cA csn ococss syl cA cA csn cort cfv cort cfv chil snssg mpbird
    $.
    $( [22-Jul-2001] $)

  $( A non-zero vector generates a (non-zero) 1-dimensional subspace. $)
  h1dn0 $p |- ( ( A e. ~H /\ A =/= 0h ) ->
              ( _|_ ` ( _|_ ` { A } ) ) =/= 0H ) $=
    cA chil wcel cA c0v wne cA csn cort cfv cort cfv c0h wne cA chil wcel cA
    csn cort cfv cort cfv c0h cA c0v cA chil wcel cA csn cort cfv cort cfv c0h
    wceq cA c0h wcel cA c0v wceq cA csn cort cfv cort cfv c0h wceq cA cA csn
    cort cfv cort cfv wcel cA c0h wcel cA chil wcel cA csn cort cfv cort cfv
    c0h cA eleq2 cA h1did syl5cbi cA elch0 syl6ib necon3d imp $.
    $( [19-Jun-2006] $) $( [22-Jul-2001] $)

  ${
    $d x A $.  $d x B $.
    h1de2.1 $e |- A e. ~H $.
    h1de2.2 $e |- B e. ~H $.
    $( Membership in 1-dimensional subspace.  All members are collinear with
       the generating vector. $)
    h1de2i $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) ->
                ( ( B .ih B ) .h A ) = ( ( A .ih B ) .h B ) ) $=
      cA cB csn cort cfv cort cfv wcel cA cB csp co cB cA csp co cmul co cA cA
      csp co cB cB csp co cmul co wceq cB cB csp co cA csm co cA cB csp co cB
      csm co wceq cA cB csn cort cfv cort cfv wcel cA cA csp co cB cB csp co
      cmul co cA cB csp co cB cA csp co cmul co cA cB csn cort cfv cort cfv
      wcel cA cA csp co cB cB csp co cmul co cA cB csp co cB cA csp co cmul co
      cmin co cc0 wceq cA cA csp co cB cB csp co cmul co cA cB csp co cB cA csp
      co cmul co wceq cA cB csn cort cfv cort cfv wcel cB cB csp co cA csm co
      cA cB csp co cB csm co cmv co cA csp co cc0 cA cA csp co cB cB csp co
      cmul co cA cB csp co cB cA csp co cmul co cmin co cA cB csn cort cfv cort
      cfv wcel cB cB csp co cA csm co cA cB csp co cB csm co cmv co cB csp co
      cc0 wceq cB cB csp co cA csm co cA cB csp co cB csm co cmv co cA csp co
      cc0 wceq cB cB csp co cA csm co cA cB csp co cB csm co cmv co cB csp co
      cB cB csp co cA csm co cB csp co cA cB csp co cB csm co cB csp co cmin co
      cc0 cB cB csp co cA csm co chil wcel cA cB csp co cB csm co chil wcel cB
      chil wcel cB cB csp co cA csm co cA cB csp co cB csm co cmv co cB csp co
      cB cB csp co cA csm co cB csp co cA cB csp co cB csm co cB csp co cmin co
      wceq cB cB csp co cA cB cB h1de2.2 h1de2.2 hicli h1de2.1 hvmulcli cA cB
      csp co cB cA cB h1de2.1 h1de2.2 hicli h1de2.2 hvmulcli h1de2.2 cB cB csp
      co cA csm co cA cB csp co cB csm co cB his2sub mp3an cB cB csp co cA csm
      co cB csp co cA cB csp co cB csm co cB csp co cmin co cc0 wceq cB cB csp
      co cA csm co cB csp co cA cB csp co cB csm co cB csp co wceq cB cB csp co
      cA cB csp co cmul co cA cB csp co cB cB csp co cmul co cB cB csp co cA
      csm co cB csp co cA cB csp co cB csm co cB csp co cB cB csp co cA cB csp
      co cB cB h1de2.2 h1de2.2 hicli cA cB h1de2.1 h1de2.2 hicli mulcomi cB cB
      csp co cc wcel cA chil wcel cB chil wcel cB cB csp co cA csm co cB csp co
      cB cB csp co cA cB csp co cmul co wceq cB cB h1de2.2 h1de2.2 hicli
      h1de2.1 h1de2.2 cB cB csp co cA cB ax-his3 mp3an cA cB csp co cc wcel cB
      chil wcel cB chil wcel cA cB csp co cB csm co cB csp co cA cB csp co cB
      cB csp co cmul co wceq cA cB h1de2.1 h1de2.2 hicli h1de2.2 h1de2.2 cA cB
      csp co cB cB ax-his3 mp3an 3eqtr4i cB cB csp co cA csm co cB csp co cA cB
      csp co cB csm co cB csp co cB cB csp co cA csm co cB cB cB csp co cA cB
      cB h1de2.2 h1de2.2 hicli h1de2.1 hvmulcli h1de2.2 hicli cA cB csp co cB
      csm co cB cA cB csp co cB cA cB h1de2.1 h1de2.2 hicli h1de2.2 hvmulcli
      h1de2.2 hicli subeq0i mpbir eqtri cA cB csn cort cfv cort cfv wcel cB cB
      cB csp co cA csm co cA cB csp co cB csm co cmv co csp co cc0 wceq cA cB
      cB csp co cA csm co cA cB csp co cB csm co cmv co csp co cc0 wceq cB cB
      csp co cA csm co cA cB csp co cB csm co cmv co cB csp co cc0 wceq cB cB
      csp co cA csm co cA cB csp co cB csm co cmv co cA csp co cc0 wceq cA cB
      csn cort cfv cort cfv wcel cB vx cv csp co cc0 wceq cA vx cv csp co cc0
      wceq wi vx chil wral cB cB cB csp co cA csm co cA cB csp co cB csm co cmv
      co csp co cc0 wceq cA cB cB csp co cA csm co cA cB csp co cB csm co cmv
      co csp co cc0 wceq wi cA cB csn cort cfv cort cfv wcel cA chil wcel cB vx
      cv csp co cc0 wceq cA vx cv csp co cc0 wceq wi vx chil wral vx cA cB
      h1de2.2 h1dei h1de2.1 mpbiran cB cB csp co cA csm co cA cB csp co cB csm
      co cmv co chil wcel cB vx cv csp co cc0 wceq cA vx cv csp co cc0 wceq wi
      vx chil wral cB cB cB csp co cA csm co cA cB csp co cB csm co cmv co csp
      co cc0 wceq cA cB cB csp co cA csm co cA cB csp co cB csm co cmv co csp
      co cc0 wceq wi wi cB cB csp co cA csm co cA cB csp co cB csm co cB cB csp
      co cA cB cB h1de2.2 h1de2.2 hicli h1de2.1 hvmulcli cA cB csp co cB cA cB
      h1de2.1 h1de2.2 hicli h1de2.2 hvmulcli hvsubcli cB vx cv csp co cc0 wceq
      cA vx cv csp co cc0 wceq wi cB cB cB csp co cA csm co cA cB csp co cB csm
      co cmv co csp co cc0 wceq cA cB cB csp co cA csm co cA cB csp co cB csm
      co cmv co csp co cc0 wceq wi vx cB cB csp co cA csm co cA cB csp co cB
      csm co cmv co chil vx cv cB cB csp co cA csm co cA cB csp co cB csm co
      cmv co wceq cB vx cv csp co cc0 wceq cB cB cB csp co cA csm co cA cB csp
      co cB csm co cmv co csp co cc0 wceq cA vx cv csp co cc0 wceq cA cB cB csp
      co cA csm co cA cB csp co cB csm co cmv co csp co cc0 wceq vx cv cB cB
      csp co cA csm co cA cB csp co cB csm co cmv co wceq cB vx cv csp co cB cB
      cB csp co cA csm co cA cB csp co cB csm co cmv co csp co cc0 vx cv cB cB
      csp co cA csm co cA cB csp co cB csm co cmv co cB csp opreq2 eqeq1d vx cv
      cB cB csp co cA csm co cA cB csp co cB csm co cmv co wceq cA vx cv csp co
      cA cB cB csp co cA csm co cA cB csp co cB csm co cmv co csp co cc0 vx cv
      cB cB csp co cA csm co cA cB csp co cB csm co cmv co cA csp opreq2 eqeq1d
      imbi12d rcla4v ax-mp sylbi cB cB csp co cA csm co cA cB csp co cB csm co
      cmv co chil wcel cB chil wcel cB cB csp co cA csm co cA cB csp co cB csm
      co cmv co cB csp co cc0 wceq cB cB cB csp co cA csm co cA cB csp co cB
      csm co cmv co csp co cc0 wceq wb cB cB csp co cA csm co cA cB csp co cB
      csm co cB cB csp co cA cB cB h1de2.2 h1de2.2 hicli h1de2.1 hvmulcli cA cB
      csp co cB cA cB h1de2.1 h1de2.2 hicli h1de2.2 hvmulcli hvsubcli h1de2.2
      cB cB csp co cA csm co cA cB csp co cB csm co cmv co cB orthcom mp2an cB
      cB csp co cA csm co cA cB csp co cB csm co cmv co chil wcel cA chil wcel
      cB cB csp co cA csm co cA cB csp co cB csm co cmv co cA csp co cc0 wceq
      cA cB cB csp co cA csm co cA cB csp co cB csm co cmv co csp co cc0 wceq
      wb cB cB csp co cA csm co cA cB csp co cB csm co cB cB csp co cA cB cB
      h1de2.2 h1de2.2 hicli h1de2.1 hvmulcli cA cB csp co cB cA cB h1de2.1
      h1de2.2 hicli h1de2.2 hvmulcli hvsubcli h1de2.1 cB cB csp co cA csm co cA
      cB csp co cB csm co cmv co cA orthcom mp2an 3imtr4g mpi cB cB csp co cA
      csm co cA cB csp co cB csm co cmv co cA csp co cB cB csp co cA csm co cA
      csp co cA cB csp co cB csm co cA csp co cmin co cA cA csp co cB cB csp co
      cmul co cA cB csp co cB cA csp co cmul co cmin co cB cB csp co cA csm co
      chil wcel cA cB csp co cB csm co chil wcel cA chil wcel cB cB csp co cA
      csm co cA cB csp co cB csm co cmv co cA csp co cB cB csp co cA csm co cA
      csp co cA cB csp co cB csm co cA csp co cmin co wceq cB cB csp co cA cB
      cB h1de2.2 h1de2.2 hicli h1de2.1 hvmulcli cA cB csp co cB cA cB h1de2.1
      h1de2.2 hicli h1de2.2 hvmulcli h1de2.1 cB cB csp co cA csm co cA cB csp
      co cB csm co cA his2sub mp3an cB cB csp co cA csm co cA csp co cA cA csp
      co cB cB csp co cmul co cA cB csp co cB csm co cA csp co cA cB csp co cB
      cA csp co cmul co cmin cB cB csp co cA csm co cA csp co cB cB csp co cA
      cA csp co cmul co cA cA csp co cB cB csp co cmul co cB cB csp co cc wcel
      cA chil wcel cA chil wcel cB cB csp co cA csm co cA csp co cB cB csp co
      cA cA csp co cmul co wceq cB cB h1de2.2 h1de2.2 hicli h1de2.1 h1de2.1 cB
      cB csp co cA cA ax-his3 mp3an cB cB csp co cA cA csp co cB cB h1de2.2
      h1de2.2 hicli cA cA h1de2.1 h1de2.1 hicli mulcomi eqtri cA cB csp co cc
      wcel cB chil wcel cA chil wcel cA cB csp co cB csm co cA csp co cA cB csp
      co cB cA csp co cmul co wceq cA cB h1de2.1 h1de2.2 hicli h1de2.2 h1de2.1
      cA cB csp co cB cA ax-his3 mp3an opreq12i eqtr2i syl5eq cA cA csp co cB
      cB csp co cmul co cA cB csp co cB cA csp co cmul co cA cA csp co cB cB
      csp co cA cA h1de2.1 h1de2.1 hicli cB cB h1de2.2 h1de2.2 hicli mulcli cA
      cB csp co cB cA csp co cA cB h1de2.1 h1de2.2 hicli cB cA h1de2.2 h1de2.1
      hicli mulcli subeq0i sylib eqcomd cA cB h1de2.1 h1de2.2 bcseqi sylib $.
      $( [17-Jul-2001] $)

    $( Membership in 1-dimensional subspace.  All members are collinear with
       the generating vector. $)
    h1de2bi $p |- ( B =/= 0h -> ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
                A = ( ( ( A .ih B ) / ( B .ih B ) ) .h B ) ) ) $=
      cB c0v wne cB cB csp co cc0 wne cA cB csn cort cfv cort cfv wcel cA cA cB
      csp co cB cB csp co cdiv co cB csm co wceq wb cB cB csp co cc0 cB c0v cB
      chil wcel cB cB csp co cc0 wceq cB c0v wceq wb h1de2.2 cB his6 ax-mp
      necon3bii cB cB csp co cc0 wne cA cB csn cort cfv cort cfv wcel cA cA cB
      csp co cB cB csp co cdiv co cB csm co wceq cB cB csp co cc0 wne cA cB csn
      cort cfv cort cfv wcel cA cA cB csp co cB cB csp co cdiv co cB csm co
      wceq cB cB csp co cc0 wne cA cB csn cort cfv cort cfv wcel wa c1 cB cB
      csp co cdiv co cB cB csp co cA csm co csm co c1 cB cB csp co cdiv co cA
      cB csp co cB csm co csm co cA cA cB csp co cB cB csp co cdiv co cB csm co
      cB cB csp co cc0 wne cA cB csn cort cfv cort cfv wcel wa cB cB csp co cA
      csm co cA cB csp co cB csm co c1 cB cB csp co cdiv co csm cA cB csn cort
      cfv cort cfv wcel cB cB csp co cA csm co cA cB csp co cB csm co wceq cB
      cB csp co cc0 wne cA cB h1de2.1 h1de2.2 h1de2i adantl opreq2d cB cB csp
      co cc0 wne c1 cB cB csp co cdiv co cB cB csp co cA csm co csm co cA wceq
      cA cB csn cort cfv cort cfv wcel cB cB csp co cc0 wne c1 cB cB csp co
      cdiv co cB cB csp co cA csm co csm co c1 cA csm co cA cB cB csp co cc0
      wne c1 cB cB csp co cdiv co cB cB csp co cmul co cA csm co c1 cB cB csp
      co cdiv co cB cB csp co cA csm co csm co c1 cA csm co cB cB csp co cc0
      wne c1 cB cB csp co cdiv co cc wcel c1 cB cB csp co cdiv co cB cB csp co
      cmul co cA csm co c1 cB cB csp co cdiv co cB cB csp co cA csm co csm co
      wceq cB cB csp co cB cB h1de2.2 h1de2.2 hicli recclzi c1 cB cB csp co
      cdiv co cc wcel cB cB csp co cc wcel cA chil wcel c1 cB cB csp co cdiv co
      cB cB csp co cmul co cA csm co c1 cB cB csp co cdiv co cB cB csp co cA
      csm co csm co wceq cB cB h1de2.2 h1de2.2 hicli h1de2.1 c1 cB cB csp co
      cdiv co cB cB csp co cA ax-hvmulass mp3an23 syl cB cB csp co cc0 wne c1
      cB cB csp co cdiv co cB cB csp co cmul co c1 cA csm c1 cB cB csp co ax1cn
      cB cB h1de2.2 h1de2.2 hicli divcan1zi opreq1d eqtr3d cA chil wcel c1 cA
      csm co cA wceq h1de2.1 cA ax-hvmulid ax-mp syl6eq adantr cB cB csp co cc0
      wne c1 cB cB csp co cdiv co cA cB csp co cB csm co csm co cA cB csp co cB
      cB csp co cdiv co cB csm co wceq cA cB csn cort cfv cort cfv wcel cB cB
      csp co cc0 wne c1 cB cB csp co cdiv co cA cB csp co cmul co cB csm co c1
      cB cB csp co cdiv co cA cB csp co cB csm co csm co cA cB csp co cB cB csp
      co cdiv co cB csm co cB cB csp co cc0 wne c1 cB cB csp co cdiv co cc wcel
      c1 cB cB csp co cdiv co cA cB csp co cmul co cB csm co c1 cB cB csp co
      cdiv co cA cB csp co cB csm co csm co wceq cB cB csp co cB cB h1de2.2
      h1de2.2 hicli recclzi c1 cB cB csp co cdiv co cc wcel cA cB csp co cc
      wcel cB chil wcel c1 cB cB csp co cdiv co cA cB csp co cmul co cB csm co
      c1 cB cB csp co cdiv co cA cB csp co cB csm co csm co wceq cA cB h1de2.1
      h1de2.2 hicli h1de2.2 c1 cB cB csp co cdiv co cA cB csp co cB ax-hvmulass
      mp3an23 syl cB cB csp co cc0 wne c1 cB cB csp co cdiv co cA cB csp co
      cmul co cA cB csp co cB cB csp co cdiv co cB csm cB cB csp co cc0 wne c1
      cB cB csp co cdiv co cA cB csp co cmul co cA cB csp co c1 cB cB csp co
      cdiv co cmul co cA cB csp co cB cB csp co cdiv co cB cB csp co cc0 wne c1
      cB cB csp co cdiv co cc wcel c1 cB cB csp co cdiv co cA cB csp co cmul co
      cA cB csp co c1 cB cB csp co cdiv co cmul co wceq cB cB csp co cB cB
      h1de2.2 h1de2.2 hicli recclzi c1 cB cB csp co cdiv co cc wcel cA cB csp
      co cc wcel c1 cB cB csp co cdiv co cA cB csp co cmul co cA cB csp co c1
      cB cB csp co cdiv co cmul co wceq cA cB h1de2.1 h1de2.2 hicli c1 cB cB
      csp co cdiv co cA cB csp co mulcom mpan2 syl cA cB csp co cB cB csp co cA
      cB h1de2.1 h1de2.2 hicli cB cB h1de2.2 h1de2.2 hicli divreczi eqtr4d
      opreq1d eqtr3d adantr 3eqtr3d ex cA cA cB csp co cB cB csp co cdiv co cB
      csm co wceq cA cB csn cort cfv cort cfv wcel cA cB csp co cB cB csp co
      cdiv co cB csm co cB csn cort cfv cort cfv wcel cB cB csp co cc0 wne cA
      cA cB csp co cB cB csp co cdiv co cB csm co cB csn cort cfv cort cfv
      eleq1 cB cB csp co cc0 wne cA cB csp co cB cB csp co cdiv co cc wcel cA
      cB csp co cB cB csp co cdiv co cB csm co cB csn cort cfv cort cfv wcel cA
      cB csp co cB cB csp co cA cB h1de2.1 h1de2.2 hicli cB cB h1de2.2 h1de2.2
      hicli divclzi cA cB csp co cB cB csp co cdiv co cc wcel cB cB csn cort
      cfv cort cfv wcel cA cB csp co cB cB csp co cdiv co cB csm co cB csn cort
      cfv cort cfv wcel cB chil wcel cB cB csn cort cfv cort cfv wcel h1de2.2
      cB h1did ax-mp cB csn cort cfv cort cfv csh wcel cA cB csp co cB cB csp
      co cdiv co cc wcel cB cB csn cort cfv cort cfv wcel wa cA cB csp co cB cB
      csp co cdiv co cB csm co cB csn cort cfv cort cfv wcel wi cB csn cort cfv
      cort cfv cB csn cort cfv cB csn cB chil wcel cB csn chil wss h1de2.2 cB
      chil snssi ax-mp occli choccli chshii cA cB csp co cB cB csp co cdiv co
      cB cB csn cort cfv cort cfv shmulclOLD ax-mp mpan2 syl syl5cbir impbid
      sylbir $.
      $( [19-Jul-2001] $)

    $( Lemma for ~ h1de2ci . $)
    h1de2ctlem $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
                 E. x e. CC A = ( x .h B ) ) $=
      cA cB csn cort cfv cort cfv wcel cA vx cv cB csm co wceq vx cc wrex cA cB
      csn cort cfv cort cfv wcel cA vx cv cB csm co wceq vx cc wrex wi cB c0v
      cB c0v wceq cA cB csn cort cfv cort cfv wcel cA cc0 cB csm co wceq cA vx
      cv cB csm co wceq vx cc wrex cB c0v wceq cA cB csn cort cfv cort cfv wcel
      cA c0v csn cort cfv cort cfv wcel cA cc0 cB csm co wceq cB c0v wceq cB
      csn cort cfv cort cfv c0v csn cort cfv cort cfv cA cB c0v wceq cB csn
      cort cfv c0v csn cort cfv cort cB c0v wceq cB csn c0v csn cort cB c0v
      sneq fveq2d fveq2d eleq2d cA c0v csn wcel cA c0v wceq cA c0v csn cort cfv
      cort cfv wcel cA cc0 cB csm co wceq cA c0v cA chil h1de2.1 elisseti elsnc
      c0v csn cort cfv cort cfv c0v csn cA c0v csn hsn0elch ococi eleq2i cc0 cB
      csm co c0v cA cB chil wcel cc0 cB csm co c0v wceq h1de2.2 cB ax-hvmul0
      ax-mp eqeq2i 3bitr4ri syl6rbbr cc0 cc wcel cA cc0 cB csm co wceq cA vx cv
      cB csm co wceq vx cc wrex 0cn cA vx cv cB csm co wceq cA cc0 cB csm co
      wceq vx cc0 cc vx cv cc0 wceq vx cv cB csm co cc0 cB csm co cA vx cv cc0
      cB csm opreq1 eqeq2d rcla4ev mpan syl6bir cB c0v wne cA cB csn cort cfv
      cort cfv wcel cA cA cB csp co cB cB csp co cdiv co cB csm co wceq cA vx
      cv cB csm co wceq vx cc wrex cA cB h1de2.1 h1de2.2 h1de2bi cB c0v wne cA
      cA cB csp co cB cB csp co cdiv co cB csm co wceq cA vx cv cB csm co wceq
      vx cc wrex cA cB csp co cB cB csp co cdiv co cc wcel cA cA cB csp co cB
      cB csp co cdiv co cB csm co wceq cA vx cv cB csm co wceq vx cc wrex cB
      c0v wne cA vx cv cB csm co wceq cA cA cB csp co cB cB csp co cdiv co cB
      csm co wceq vx cA cB csp co cB cB csp co cdiv co cc vx cv cA cB csp co cB
      cB csp co cdiv co wceq vx cv cB csm co cA cB csp co cB cB csp co cdiv co
      cB csm co cA vx cv cA cB csp co cB cB csp co cdiv co cB csm opreq1 eqeq2d
      rcla4ev cB c0v wne cB cB csp co cc0 wne cA cB csp co cB cB csp co cdiv co
      cc wcel cB cB csp co cc0 cB c0v cB chil wcel cB cB csp co cc0 wceq cB c0v
      wceq wb h1de2.2 cB his6 ax-mp necon3bii cA cB csp co cB cB csp co cA cB
      h1de2.1 h1de2.2 hicli cB cB h1de2.2 h1de2.2 hicli divclzi sylbir sylan ex
      sylbid pm2.61ine cA vx cv cB csm co wceq cA cB csn cort cfv cort cfv wcel
      vx cc cA vx cv cB csm co wceq cA cB csn cort cfv cort cfv wcel vx cv cB
      csm co cB csn cort cfv cort cfv wcel vx cv cc wcel cA vx cv cB csm co cB
      csn cort cfv cort cfv eleq1 vx cv cc wcel cB cB csn cort cfv cort cfv
      wcel vx cv cB csm co cB csn cort cfv cort cfv wcel cB chil wcel cB cB csn
      cort cfv cort cfv wcel h1de2.2 cB h1did ax-mp cB csn cort cfv cort cfv
      csh wcel vx cv cc wcel cB cB csn cort cfv cort cfv wcel wa vx cv cB csm
      co cB csn cort cfv cort cfv wcel wi cB csn cort cfv cort cfv cB csn cort
      cfv cB csn cB chil wcel cB csn chil wss h1de2.2 cB chil snssi ax-mp occli
      choccli chshii vx cv cB cB csn cort cfv cort cfv shmulclOLD ax-mp mpan2
      syl5cbir r19.23aiv impbii $.
      $( [10-Aug-2008] $) $( [19-Jul-2001] $)
  $}

  ${
    $d x A $.  $d x B $.
    h1de2ct.1 $e |- B e. ~H $.
    $( Membership in 1-dimensional subspace.  All members are collinear with
       the generating vector. $)
    h1de2ci $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
                 E. x e. CC A = ( x .h B ) ) $=
      cA cB csn cort cfv cort cfv wcel cA chil wcel cA vx cv cB csm co wceq vx
      cc wrex cA cB csn cort cfv cort cfv cB csn cort cfv cB csn cB chil wcel
      cB csn chil wss h1de2ct.1 cB chil snssi ax-mp occli choccli cheli cA vx
      cv cB csm co wceq cA chil wcel vx cc cA vx cv cB csm co wceq cA chil wcel
      vx cv cB csm co chil wcel vx cv cc wcel cA vx cv cB csm co chil eleq1 vx
      cv cc wcel cB chil wcel vx cv cB csm co chil wcel h1de2ct.1 vx cv cB
      hvmulcl mpan2 syl5cbir r19.23aiv cA chil wcel cA cB csn cort cfv cort cfv
      wcel cA vx cv cB csm co wceq vx cc wrex wb cA chil wcel cA c0v cif cB csn
      cort cfv cort cfv wcel cA chil wcel cA c0v cif vx cv cB csm co wceq vx cc
      wrex wb cA c0v cA cA chil wcel cA c0v cif wceq cA cB csn cort cfv cort
      cfv wcel cA chil wcel cA c0v cif cB csn cort cfv cort cfv wcel cA vx cv
      cB csm co wceq vx cc wrex cA chil wcel cA c0v cif vx cv cB csm co wceq vx
      cc wrex cA cA chil wcel cA c0v cif cB csn cort cfv cort cfv eleq1 cA cA
      chil wcel cA c0v cif wceq cA vx cv cB csm co wceq cA chil wcel cA c0v cif
      vx cv cB csm co wceq vx cc cA cA chil wcel cA c0v cif vx cv cB csm co
      eqeq1 rexbidv bibi12d vx cA chil wcel cA c0v cif cB cA c0v chil ax-hv0cl
      elimel h1de2ct.1 h1de2ctlem dedth pm5.21nii $.
      $( [21-Jul-2001] $)
  $}

  ${
    $d x y z A $.  $d x B $.
    spansn.1 $e |- A e. ~H $.
    $( The span of a singleton in Hilbert space equals its closure. $)
    spansni $p |- ( span ` { A } ) = ( _|_ ` ( _|_ ` { A } ) ) $=
      cA csn cspn cfv cA csn cort cfv cort cfv cA csn chil wss cA csn cspn cfv
      cA csn cort cfv cort cfv wss cA chil wcel cA csn chil wss spansn.1 cA
      chil snssi ax-mp cA csn spanssoc ax-mp vx cA csn cort cfv cort cfv cA csn
      cspn cfv vx cv cA csn cort cfv cort cfv wcel cA csn vy cv wss vx cv vy cv
      wcel wi vy csh wral vx cv cA csn cspn cfv wcel vx cv cA csn cort cfv cort
      cfv wcel cA csn vy cv wss vx cv vy cv wcel wi vy csh vx cv cA csn cort
      cfv cort cfv wcel vy cv csh wcel wa cA vy cv wcel vx cv vy cv wcel cA csn
      vy cv wss vx cv cA csn cort cfv cort cfv wcel vy cv csh wcel cA vy cv
      wcel vx cv vy cv wcel wi vx cv cA csn cort cfv cort cfv wcel vx cv vz cv
      cA csm co wceq vz cc wrex vy cv csh wcel cA vy cv wcel vx cv vy cv wcel
      wi wi vz vx cv cA spansn.1 h1de2ci vx cv vz cv cA csm co wceq vy cv csh
      wcel cA vy cv wcel vx cv vy cv wcel wi wi vz cc vx cv vz cv cA csm co
      wceq vy cv csh wcel vz cv cc wcel cA vy cv wcel vx cv vy cv wcel wi vx cv
      vz cv cA csm co wceq vy cv csh wcel vz cv cc wcel cA vy cv wcel vx cv vy
      cv wcel vy cv csh wcel vz cv cc wcel cA vy cv wcel wa vz cv cA csm co vy
      cv wcel vx cv vz cv cA csm co wceq vx cv vy cv wcel vz cv cA vy cv
      shmulclOLD vz cv cA csm co vy cv wcel vx cv vz cv cA csm co wceq vx cv vy
      cv wcel vz cv cA csm co vy cv vx cv eleq1a com12 syl9r exp4a com3r
      r19.23aiv sylbi imp cA vy cv cA chil spansn.1 elisseti snss syl5ibr
      r19.21aiva cA csn chil wss vx cv cA csn cspn cfv wcel cA csn vy cv wss vx
      cv vy cv wcel wi vy csh wral wb cA chil wcel cA csn chil wss spansn.1 cA
      chil snssi ax-mp vy cA csn vx cv vx visset elspani ax-mp sylibr ssriv
      eqssi $.
      $( [28-Jun-2004] $) $( [3-Jun-2004] $)

    $( Membership in the span of a singleton. $)
    elspansni $p |- ( B e. ( span ` { A } ) <-> E. x e. CC B = ( x .h A ) ) $=
      cB cA csn cspn cfv wcel cB cA csn cort cfv cort cfv wcel cB vx cv cA csm
      co wceq vx cc wrex cA csn cspn cfv cA csn cort cfv cort cfv cB cA
      spansn.1 spansni eleq2i vx cB cA spansn.1 h1de2ci bitri $.
      $( [28-Jun-2004] $) $( [3-Jun-2004] $)
  $}

  $( The span of a singleton in Hilbert space equals its closure. $)
  spansn $p |- ( A e. ~H -> ( span ` { A } ) = ( _|_ ` ( _|_ ` { A } ) ) ) $=
    cA chil wcel cA csn cspn cfv cA csn cort cfv cort cfv wceq cA chil wcel cA
    c0v cif csn cspn cfv cA chil wcel cA c0v cif csn cort cfv cort cfv wceq cA
    c0v cA cA chil wcel cA c0v cif wceq cA csn cspn cfv cA chil wcel cA c0v cif
    csn cspn cfv cA csn cort cfv cort cfv cA chil wcel cA c0v cif csn cort cfv
    cort cfv cA cA chil wcel cA c0v cif wceq cA csn cA chil wcel cA c0v cif csn
    cspn cA cA chil wcel cA c0v cif sneq fveq2d cA cA chil wcel cA c0v cif wceq
    cA csn cort cfv cA chil wcel cA c0v cif csn cort cfv cort cA cA chil wcel
    cA c0v cif wceq cA csn cA chil wcel cA c0v cif csn cort cA cA chil wcel cA
    c0v cif sneq fveq2d fveq2d eqeq12d cA chil wcel cA c0v cif cA c0v chil
    ax-hv0cl elimel spansni dedth $.
    $( [28-Jun-2004] $) $( [4-Jun-2004] $)

  $( The span of a Hilbert space singleton belongs to the Hilbert lattice. $)
  spansnch $p |- ( A e. ~H -> ( span ` { A } ) e. CH ) $=
    cA chil wcel cA csn cspn cfv cA csn cort cfv cort cfv cch cA spansn cA chil
    wcel cA csn chil wss cA csn cort cfv cch wcel cA csn cort cfv cort cfv cch
    wcel cA chil snssi cA csn occl cA csn cort cfv choccl 3syl eqeltrd $.
    $( [28-Jun-2004] $) $( [9-Jun-2004] $)

  $( The span of a Hilbert space singleton is a subspace. $)
  spansnsh $p |- ( A e. ~H -> ( span ` { A } ) e. SH ) $=
    cA chil wcel cA csn cspn cfv cch wcel cA csn cspn cfv csh wcel cA spansnch
    cA csn cspn cfv chsh syl $.
    $( [21-Dec-2004] $) $( [17-Dec-2004] $)

  ${
    spansnch.1 $e |- A e. ~H $.
    $( The span of a singleton in Hilbert space is a closed subspace. $)
    spansnchi $p |- ( span ` { A } ) e. CH $=
      cA chil wcel cA csn cspn cfv cch wcel spansnch.1 cA spansnch ax-mp $.
      $( [29-Jun-2004] $) $( [3-Jun-2004] $)
  $}

  $( A vector belongs to the span of its singleton. $)
  spansnid $p |- ( A e. ~H -> A e. ( span ` { A } ) ) $=
    cA chil wcel cA cA csn cort cfv cort cfv cA csn cspn cfv cA h1did cA spansn
    eleqtrrd $.
    $( [29-Jun-2004] $) $( [3-Jun-2004] $)

  $( A scalar product with a vector belongs to the span of its singleton. $)
  spansnmul $p |- ( ( A e. ~H /\ B e. CC ) ->
                  ( B .h A ) e. ( span ` { A } ) ) $=
    cB cc wcel cA chil wcel cB cA csm co cA csn cspn cfv wcel cB cc wcel cA csn
    cspn cfv csh wcel cA cA csn cspn cfv wcel wa cB cA csm co cA csn cspn cfv
    wcel cA chil wcel cA csn cspn cfv csh wcel cB cc wcel cA cA csn cspn cfv
    wcel cB cA csm co cA csn cspn cfv wcel cA csn cspn cfv csh wcel cB cc wcel
    cA cA csn cspn cfv wcel wa cB cA csm co cA csn cspn cfv wcel cB cA cA csn
    cspn cfv shmulclOLD imp an1s cA chil wcel cA csn cspn cfv csh wcel cA cA
    csn cspn cfv wcel cA spansnsh cA spansnid jca sylan2 ancoms $.
    $( [29-Jun-2004] $) $( [3-Jun-2004] $)

  $( A member of a span of a singleton is a vector. $)
  elspansncl $p |- ( ( A e. ~H /\ B e. ( span ` { A } ) ) -> B e. ~H ) $=
    cA csn chil wss cB cA csn cspn cfv wcel cB chil wcel cA chil wcel cA csn cB
    elspancl cA chil snssi sylan $.
    $( [22-Dec-2004] $) $( [17-Dec-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Membership in the span of a singleton. $)
    elspansn $p |- ( A e. ~H ->
                   ( B e. ( span ` { A } ) <-> E. x e. CC B = ( x .h A ) ) ) $=
      cA chil wcel cB cA csn cspn cfv wcel cB vx cv cA csm co wceq vx cc wrex
      wb cB cA chil wcel cA c0v cif csn cspn cfv wcel cB vx cv cA chil wcel cA
      c0v cif csm co wceq vx cc wrex wb cA c0v cA cA chil wcel cA c0v cif wceq
      cB cA csn cspn cfv wcel cB cA chil wcel cA c0v cif csn cspn cfv wcel cB
      vx cv cA csm co wceq vx cc wrex cB vx cv cA chil wcel cA c0v cif csm co
      wceq vx cc wrex cA cA chil wcel cA c0v cif wceq cA csn cspn cfv cA chil
      wcel cA c0v cif csn cspn cfv cB cA cA chil wcel cA c0v cif wceq cA csn cA
      chil wcel cA c0v cif csn cspn cA cA chil wcel cA c0v cif sneq fveq2d
      eleq2d cA cA chil wcel cA c0v cif wceq cB vx cv cA csm co wceq cB vx cv
      cA chil wcel cA c0v cif csm co wceq vx cc cA cA chil wcel cA c0v cif wceq
      vx cv cA csm co vx cv cA chil wcel cA c0v cif csm co cB cA cA chil wcel
      cA c0v cif vx cv csm opreq2 eqeq2d rexbidv bibi12d vx cA chil wcel cA c0v
      cif cB cA c0v chil ax-hv0cl elimel elspansni dedth $.
      $( [29-Jun-2004] $) $( [5-Jun-2004] $)
  $}

  $( Membership in the span of a singleton.  All members are collinear with
     the generating vector. $)
  elspansn2 $p |- ( ( A e. ~H /\ B e. ~H /\ B =/= 0h ) ->
  ( A e. ( span ` { B } ) <-> A = ( ( ( A .ih B ) / ( B .ih B ) ) .h B ) ) ) $=
    cA chil wcel cB chil wcel cB c0v wne w3a cA cB csn cspn cfv wcel cA cB csn
    cort cfv cort cfv wcel cA cA cB csp co cB cB csp co cdiv co cB csm co wceq
    cB chil wcel cA chil wcel cA cB csn cspn cfv wcel cA cB csn cort cfv cort
    cfv wcel wb cB c0v wne cB chil wcel cB csn cspn cfv cB csn cort cfv cort
    cfv cA cB spansn eleq2d 3ad2ant2 cA chil wcel cB chil wcel cB c0v wne cA cB
    csn cort cfv cort cfv wcel cA cA cB csp co cB cB csp co cdiv co cB csm co
    wceq wb cA chil wcel cB chil wcel cB c0v wne cA cB csn cort cfv cort cfv
    wcel cA cA cB csp co cB cB csp co cdiv co cB csm co wceq wb wi cB c0v wne
    cA chil wcel cA c0v cif cB csn cort cfv cort cfv wcel cA chil wcel cA c0v
    cif cA chil wcel cA c0v cif cB csp co cB cB csp co cdiv co cB csm co wceq
    wb wi cB chil wcel cB c0v cif c0v wne cA chil wcel cA c0v cif cB chil wcel
    cB c0v cif csn cort cfv cort cfv wcel cA chil wcel cA c0v cif cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif csp co cB chil wcel cB c0v cif cB chil
    wcel cB c0v cif csp co cdiv co cB chil wcel cB c0v cif csm co wceq wb wi cA
    cB c0v c0v cA cA chil wcel cA c0v cif wceq cA cB csn cort cfv cort cfv wcel
    cA cA cB csp co cB cB csp co cdiv co cB csm co wceq wb cA chil wcel cA c0v
    cif cB csn cort cfv cort cfv wcel cA chil wcel cA c0v cif cA chil wcel cA
    c0v cif cB csp co cB cB csp co cdiv co cB csm co wceq wb cB c0v wne cA cA
    chil wcel cA c0v cif wceq cA cB csn cort cfv cort cfv wcel cA chil wcel cA
    c0v cif cB csn cort cfv cort cfv wcel cA cA cB csp co cB cB csp co cdiv co
    cB csm co wceq cA chil wcel cA c0v cif cA chil wcel cA c0v cif cB csp co cB
    cB csp co cdiv co cB csm co wceq cA cA chil wcel cA c0v cif cB csn cort cfv
    cort cfv eleq1 cA cA chil wcel cA c0v cif wceq cA cA chil wcel cA c0v cif
    cA cB csp co cB cB csp co cdiv co cB csm co cA chil wcel cA c0v cif cB csp
    co cB cB csp co cdiv co cB csm co cA cA chil wcel cA c0v cif wceq id cA cA
    chil wcel cA c0v cif wceq cA cB csp co cB cB csp co cdiv co cA chil wcel cA
    c0v cif cB csp co cB cB csp co cdiv co cB csm cA cA chil wcel cA c0v cif
    wceq cA cB csp co cA chil wcel cA c0v cif cB csp co cB cB csp co cdiv cA cA
    chil wcel cA c0v cif cB csp opreq1 opreq1d opreq1d eqeq12d bibi12d imbi2d
    cB cB chil wcel cB c0v cif wceq cB c0v wne cB chil wcel cB c0v cif c0v wne
    cA chil wcel cA c0v cif cB csn cort cfv cort cfv wcel cA chil wcel cA c0v
    cif cA chil wcel cA c0v cif cB csp co cB cB csp co cdiv co cB csm co wceq
    wb cA chil wcel cA c0v cif cB chil wcel cB c0v cif csn cort cfv cort cfv
    wcel cA chil wcel cA c0v cif cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif csp co cB chil wcel cB c0v cif cB chil wcel cB c0v cif csp co cdiv co
    cB chil wcel cB c0v cif csm co wceq wb cB cB chil wcel cB c0v cif c0v neeq1
    cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB csn cort cfv
    cort cfv wcel cA chil wcel cA c0v cif cB chil wcel cB c0v cif csn cort cfv
    cort cfv wcel cA chil wcel cA c0v cif cA chil wcel cA c0v cif cB csp co cB
    cB csp co cdiv co cB csm co wceq cA chil wcel cA c0v cif cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif csp co cB chil wcel cB c0v cif cB chil wcel
    cB c0v cif csp co cdiv co cB chil wcel cB c0v cif csm co wceq cB cB chil
    wcel cB c0v cif wceq cB csn cort cfv cort cfv cB chil wcel cB c0v cif csn
    cort cfv cort cfv cA chil wcel cA c0v cif cB cB chil wcel cB c0v cif wceq
    cB csn cort cfv cB chil wcel cB c0v cif csn cort cfv cort cB cB chil wcel
    cB c0v cif wceq cB csn cB chil wcel cB c0v cif csn cort cB cB chil wcel cB
    c0v cif sneq fveq2d fveq2d eleq2d cB cB chil wcel cB c0v cif wceq cA chil
    wcel cA c0v cif cB csp co cB cB csp co cdiv co cB csm co cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif csp co cB chil wcel cB c0v cif cB chil wcel
    cB c0v cif csp co cdiv co cB chil wcel cB c0v cif csm co cA chil wcel cA
    c0v cif cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB csp co
    cB cB csp co cdiv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co
    cB chil wcel cB c0v cif cB chil wcel cB c0v cif csp co cdiv co cB cB chil
    wcel cB c0v cif csm cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif
    cB csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cB cB csp
    co cB chil wcel cB c0v cif cB chil wcel cB c0v cif csp co cdiv cB cB chil
    wcel cB c0v cif cA chil wcel cA c0v cif csp opreq2 cB cB chil wcel cB c0v
    cif wceq cB cB csp co cB chil wcel cB c0v cif cB csp co cB chil wcel cB c0v
    cif cB chil wcel cB c0v cif csp co cB cB chil wcel cB c0v cif cB csp opreq1
    cB cB chil wcel cB c0v cif cB chil wcel cB c0v cif csp opreq2 eqtrd
    opreq12d cB cB chil wcel cB c0v cif wceq id opreq12d eqeq2d bibi12d imbi12d
    cA chil wcel cA c0v cif cB chil wcel cB c0v cif cA c0v chil ax-hv0cl elimel
    cB c0v chil ax-hv0cl elimel h1de2bi dedth2h 3impia bitrd $.
    $( [29-Jun-2004] $) $( [5-Jun-2004] $)

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( The singletons of collinear vectors have the same span. $)
    spansncol $p |- ( ( A e. ~H /\ B e. CC /\ B =/= 0 ) ->
                    ( span ` { ( B .h A ) } ) = ( span ` { A } ) ) $=
      cA chil wcel cB cc wcel cB cc0 wne w3a vx cB cA csm co csn cspn cfv cA
      csn cspn cfv cA chil wcel cB cc wcel cB cc0 wne w3a vx cv vy cv cB cA csm
      co csm co wceq vy cc wrex vx cv vz cv cA csm co wceq vz cc wrex vx cv cB
      cA csm co csn cspn cfv wcel vx cv cA csn cspn cfv wcel cA chil wcel cB cc
      wcel cB cc0 wne w3a vx cv vy cv cB cA csm co csm co wceq vy cc wrex vx cv
      vz cv cA csm co wceq vz cc wrex cA chil wcel cB cc wcel vx cv vy cv cB cA
      csm co csm co wceq vy cc wrex vx cv vz cv cA csm co wceq vz cc wrex wi cB
      cc0 wne cA chil wcel cB cc wcel wa vx cv vy cv cB cA csm co csm co wceq
      vx cv vz cv cA csm co wceq vz cc wrex vy cc cA chil wcel cB cc wcel wa vy
      cv cc wcel wa vx cv vy cv cB cA csm co csm co wceq vy cv cB cmul co cc
      wcel vx cv vy cv cB cmul co cA csm co wceq wa vx cv vz cv cA csm co wceq
      vz cc wrex cA chil wcel cB cc wcel wa vy cv cc wcel wa vx cv vy cv cB cA
      csm co csm co wceq vx cv vy cv cB cmul co cA csm co wceq vy cv cB cmul co
      cc wcel cA chil wcel cB cc wcel wa vy cv cc wcel wa vx cv vy cv cB cmul
      co cA csm co wceq vx cv vy cv cB cA csm co csm co wceq cA chil wcel cB cc
      wcel wa vy cv cc wcel wa vy cv cB cmul co cA csm co vy cv cB cA csm co
      csm co vx cv cA chil wcel cB cc wcel vy cv cc wcel vy cv cB cmul co cA
      csm co vy cv cB cA csm co csm co wceq vy cv cc wcel cB cc wcel cA chil
      wcel vy cv cB cmul co cA csm co vy cv cB cA csm co csm co wceq vy cv cB
      cA ax-hvmulass 3com13 3expa eqeq2d biimprd cB cc wcel vy cv cc wcel vy cv
      cB cmul co cc wcel cA chil wcel vy cv cc wcel cB cc wcel vy cv cB cmul co
      cc wcel vy cv cB mulcl ancoms adantll jctild vx cv vz cv cA csm co wceq
      vx cv vy cv cB cmul co cA csm co wceq vz vy cv cB cmul co cc vz cv vy cv
      cB cmul co wceq vz cv cA csm co vy cv cB cmul co cA csm co vx cv vz cv vy
      cv cB cmul co cA csm opreq1 eqeq2d rcla4ev syl6 r19.23adva 3adant3 cA
      chil wcel cB cc wcel cB cc0 wne w3a vx cv vz cv cA csm co wceq vx cv vy
      cv cB cA csm co csm co wceq vy cc wrex vz cc cA chil wcel cB cc wcel cB
      cc0 wne vz cv cc wcel vx cv vz cv cA csm co wceq vx cv vy cv cB cA csm co
      csm co wceq vy cc wrex wi wi vz cv cc wcel cA chil wcel cB cc wcel cB cc0
      wne vx cv vz cv cA csm co wceq vx cv vy cv cB cA csm co csm co wceq vy cc
      wrex wi vz cv cc wcel cA chil wcel cB cc wcel cB cc0 wne vx cv vz cv cA
      csm co wceq vx cv vy cv cB cA csm co csm co wceq vy cc wrex wi vz cv cc
      wcel cA chil wcel wa cB cc wcel cB cc0 wne wa wa vx cv vz cv cA csm co
      wceq vz cv cB cdiv co cc wcel vx cv vz cv cB cdiv co cB cA csm co csm co
      wceq wa vx cv vy cv cB cA csm co csm co wceq vy cc wrex vz cv cc wcel cA
      chil wcel wa cB cc wcel cB cc0 wne wa wa vx cv vz cv cA csm co wceq vx cv
      vz cv cB cdiv co cB cA csm co csm co wceq vz cv cB cdiv co cc wcel vz cv
      cc wcel cA chil wcel wa cB cc wcel cB cc0 wne wa wa vx cv vz cv cB cdiv
      co cB cA csm co csm co wceq vx cv vz cv cA csm co wceq vz cv cc wcel cA
      chil wcel wa cB cc wcel cB cc0 wne wa wa vz cv cB cdiv co cB cA csm co
      csm co vz cv cA csm co vx cv vz cv cc wcel cA chil wcel wa cB cc wcel cB
      cc0 wne wa wa vz cv cB cdiv co cB cmul co cA csm co vz cv cB cdiv co cB
      cA csm co csm co vz cv cA csm co vz cv cB cdiv co cc wcel cB cc wcel cA
      chil wcel vz cv cB cdiv co cB cmul co cA csm co vz cv cB cdiv co cB cA
      csm co csm co wceq vz cv cc wcel cA chil wcel wa cB cc wcel cB cc0 wne wa
      wa vz cv cB cdiv co cB cA ax-hvmulass vz cv cc wcel cB cc wcel cB cc0 wne
      wa vz cv cB cdiv co cc wcel cA chil wcel vz cv cc wcel cB cc wcel cB cc0
      wne vz cv cB cdiv co cc wcel vz cv cB divcl 3expb adantlr vz cv cc wcel
      cA chil wcel wa cB cc wcel cB cc0 wne simprl vz cv cc wcel cA chil wcel
      cB cc wcel cB cc0 wne wa simplr syl3anc vz cv cc wcel cA chil wcel wa cB
      cc wcel cB cc0 wne wa wa vz cv cB cdiv co cB cmul co vz cv cA csm vz cv
      cc wcel cB cc wcel cB cc0 wne wa vz cv cB cdiv co cB cmul co vz cv wceq
      cA chil wcel vz cv cc wcel cB cc wcel cB cc0 wne vz cv cB cdiv co cB cmul
      co vz cv wceq vz cv cc wcel cB cc wcel cB cc0 wne vz cv cB cdiv co cB
      cmul co vz cv wceq vz cv cB divcan1 3exp imp32 adantlr opreq1d eqtr3d
      eqeq2d biimprd vz cv cc wcel cB cc wcel cB cc0 wne wa vz cv cB cdiv co cc
      wcel cA chil wcel vz cv cc wcel cB cc wcel cB cc0 wne vz cv cB cdiv co cc
      wcel vz cv cB divcl 3expb adantlr jctild vx cv vy cv cB cA csm co csm co
      wceq vx cv vz cv cB cdiv co cB cA csm co csm co wceq vy vz cv cB cdiv co
      cc vy cv vz cv cB cdiv co wceq vy cv cB cA csm co csm co vz cv cB cdiv co
      cB cA csm co csm co vx cv vy cv vz cv cB cdiv co cB cA csm co csm opreq1
      eqeq2d rcla4ev syl6 exp43 com4l 3imp r19.23adv impbid cA chil wcel cB cc
      wcel vx cv cB cA csm co csn cspn cfv wcel vx cv vy cv cB cA csm co csm co
      wceq vy cc wrex wb cB cc0 wne cA chil wcel cB cc wcel wa cB cA csm co
      chil wcel vx cv cB cA csm co csn cspn cfv wcel vx cv vy cv cB cA csm co
      csm co wceq vy cc wrex wb cB cc wcel cA chil wcel cB cA csm co chil wcel
      cB cA hvmulcl ancoms vy cB cA csm co vx cv elspansn syl 3adant3 cA chil
      wcel cB cc wcel vx cv cA csn cspn cfv wcel vx cv vz cv cA csm co wceq vz
      cc wrex wb cB cc0 wne vz cA vx cv elspansn 3ad2ant1 3bitr4d eqrdv $.
      $( [4-Jul-2004] $) $( [6-Jun-2004] $)
  $}

  $( Membership relation implied by equality of spans. $)
  spansneleqi $p |- ( A e. ~H ->
        ( ( span ` { A } ) = ( span ` { B } ) -> A e. ( span ` { B } ) ) ) $=
    cA csn cspn cfv cB csn cspn cfv wceq cA cA csn cspn cfv wcel cA cB csn cspn
    cfv wcel cA chil wcel cA csn cspn cfv cB csn cspn cfv cA eleq2 cA spansnid
    syl5cbi $.
    $( [9-Sep-2004] $) $( [6-Jun-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Membership relation that implies equality of spans. $)
    spansneleq $p |- ( ( B e. ~H /\ A =/= 0h ) ->
         ( A e. ( span ` { B } ) -> ( span ` { A } ) = ( span ` { B } ) ) ) $=
      cB chil wcel cA c0v wne wa cA cB csn cspn cfv wcel cA vx cv cB csm co
      wceq vx cc wrex cA csn cspn cfv cB csn cspn cfv wceq cB chil wcel cA cB
      csn cspn cfv wcel cA vx cv cB csm co wceq vx cc wrex wb cA c0v wne vx cB
      cA elspansn adantr cB chil wcel cA c0v wne wa cA vx cv cB csm co wceq cA
      csn cspn cfv cB csn cspn cfv wceq vx cc cB chil wcel cA c0v wne wa vx cv
      cc wcel cA vx cv cB csm co wceq cA csn cspn cfv cB csn cspn cfv wceq cB
      chil wcel cA c0v wne wa vx cv cc wcel cA vx cv cB csm co wceq wa wa cA
      csn cspn cfv vx cv cB csm co csn cspn cfv cB csn cspn cfv cA vx cv cB csm
      co wceq cA csn cspn cfv vx cv cB csm co csn cspn cfv wceq cB chil wcel cA
      c0v wne wa vx cv cc wcel cA vx cv cB csm co wceq cA csn vx cv cB csm co
      csn cspn cA vx cv cB csm co sneq fveq2d ad2antll cB chil wcel cA c0v wne
      vx cv cc wcel cA vx cv cB csm co wceq vx cv cB csm co csn cspn cfv cB csn
      cspn cfv wceq cB chil wcel vx cv cc wcel cA c0v wne cA vx cv cB csm co
      wceq vx cv cB csm co csn cspn cfv cB csn cspn cfv wceq wi cB chil wcel vx
      cv cc wcel cA c0v wne cA vx cv cB csm co wceq vx cv cB csm co csn cspn
      cfv cB csn cspn cfv wceq cB chil wcel vx cv cc wcel wa cA c0v wne cA vx
      cv cB csm co wceq wa vx cv cc0 wne vx cv cB csm co csn cspn cfv cB csn
      cspn cfv wceq cB chil wcel cA c0v wne cA vx cv cB csm co wceq wa vx cv
      cc0 wne wi vx cv cc wcel cB chil wcel cA c0v wne cA vx cv cB csm co wceq
      vx cv cc0 wne cB chil wcel cA vx cv cB csm co wceq cA c0v wne vx cv cc0
      wne cB chil wcel cA vx cv cB csm co wceq cA c0v wne vx cv cc0 wne wi cB
      chil wcel cA vx cv cB csm co wceq wa vx cv cc0 cA c0v cB chil wcel vx cv
      cc0 wceq vx cv cB csm co c0v wceq cA vx cv cB csm co wceq cA c0v wceq cB
      chil wcel vx cv cc0 wceq vx cv cB csm co c0v wceq vx cv cc0 wceq cB chil
      wcel vx cv cB csm co cc0 cB csm co c0v vx cv cc0 cB csm opreq1 cB
      ax-hvmul0 sylan9eqr ex cA vx cv cB csm co wceq cA c0v wceq vx cv cB csm
      co c0v wceq cA vx cv cB csm co c0v eqeq1 biimprd sylan9 necon3d ex com23
      imp3a adantr cB chil wcel vx cv cc wcel vx cv cc0 wne vx cv cB csm co csn
      cspn cfv cB csn cspn cfv wceq cB vx cv spansncol 3expia syld exp4b com23
      imp43 eqtrd exp32 r19.23adv sylbid $.
      $( [24-Jun-2006] $) $( [6-Jun-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The span of the singleton of an element of a subspace is included in the
       subspace. $)
    spansnss $p |- ( ( A e. SH /\ B e. A ) -> ( span ` { B } ) C_ A ) $=
      cA csh wcel cB cA wcel wa vx cB csn cspn cfv cA cA csh wcel cB cA wcel wa
      vx cv cB csn cspn cfv wcel vx cv vy cv cB csm co wceq vy cc wrex vx cv cA
      wcel cA csh wcel cB cA wcel wa cB chil wcel vx cv cB csn cspn cfv wcel vx
      cv vy cv cB csm co wceq vy cc wrex wb cB cA shel vy cB vx cv elspansn syl
      cA csh wcel cB cA wcel wa vx cv vy cv cB csm co wceq vx cv cA wcel vy cc
      cA csh wcel cB cA wcel vy cv cc wcel vx cv vy cv cB csm co wceq vx cv cA
      wcel wi wi cA csh wcel vy cv cc wcel cB cA wcel vx cv vy cv cB csm co
      wceq vx cv cA wcel wi cA csh wcel vy cv cc wcel cB cA wcel vx cv vy cv cB
      csm co wceq vx cv cA wcel wi cA csh wcel vx cv vy cv cB csm co wceq vy cv
      cc wcel cB cA wcel wa vx cv cA wcel cA csh wcel vy cv cc wcel cB cA wcel
      wa vy cv cB csm co cA wcel vx cv vy cv cB csm co wceq vx cv cA wcel vy cv
      cB cA shmulclOLD vx cv vy cv cB csm co wceq vx cv cA wcel vy cv cB csm co
      cA wcel vx cv vy cv cB csm co cA eleq1 biimprd syl9 com23 exp3a com23 imp
      r19.23adv sylbid ssrdv $.
      $( [4-Jul-2004] $) $( [5-Jun-2004] $)
  $}

  $( A member of the span of the singleton of a vector is a member of a
     subspace containing the vector. $)
  elspansn3 $p |- ( ( A e. SH /\ B e. A /\ C e. ( span ` { B } ) ) ->
                   C e. A ) $=
    cA csh wcel cB cA wcel cC cB csn cspn cfv wcel cC cA wcel cA csh wcel cB cA
    wcel wa cB csn cspn cfv cA cC cA cB spansnss sseld 3impia $.
    $( [19-Jun-2006] $) $( [16-Dec-2004] $)

  $( A span membership condition implying two vectors belong to the same
     subspace. $)
  elspansn4 $p |- ( ( ( A e. SH /\ B e. ~H ) /\
         ( C e. ( span ` { B } ) /\ C =/= 0h ) ) -> ( B e. A <-> C e. A ) ) $=
    cA csh wcel cB chil wcel wa cC cB csn cspn cfv wcel cC c0v wne wa wa cB cA
    wcel cC cA wcel cA csh wcel cC cB csn cspn cfv wcel cB cA wcel cC cA wcel
    wi cB chil wcel cC c0v wne cA csh wcel cC cB csn cspn cfv wcel cB cA wcel
    cC cA wcel wi cA csh wcel cB cA wcel cC cB csn cspn cfv wcel cC cA wcel cA
    csh wcel cB cA wcel cC cB csn cspn cfv wcel cC cA wcel cA cB cC elspansn3
    3exp com23 imp ad2ant2r cA csh wcel cB chil wcel cC cB csn cspn cfv wcel cC
    c0v wne cC cA wcel cB cA wcel wi cA csh wcel cC cB csn cspn cfv wcel cB
    chil wcel cC c0v wne cC cA wcel cB cA wcel wi wi cA csh wcel cC cB csn cspn
    cfv wcel cB chil wcel cC c0v wne cC cA wcel cB cA wcel wi cA csh wcel cC cA
    wcel cB chil wcel cC c0v wne wa cC cB csn cspn cfv wcel cB cA wcel cA csh
    wcel cC cA wcel cB chil wcel cC c0v wne wa cC cB csn cspn cfv wcel cB cA
    wcel cA csh wcel cC cA wcel wa cB cC csn cspn cfv wcel cB cA wcel cB chil
    wcel cC c0v wne wa cC cB csn cspn cfv wcel wa cA csh wcel cC cA wcel cB cC
    csn cspn cfv wcel cB cA wcel cA cC cB elspansn3 3expia cB chil wcel cC c0v
    wne wa cC cB csn cspn cfv wcel wa cB cB csn cspn cfv cC csn cspn cfv cB
    chil wcel cB cB csn cspn cfv wcel cC c0v wne cC cB csn cspn cfv wcel cB
    spansnid ad2antrr cB chil wcel cC c0v wne wa cC cB csn cspn cfv wcel cC csn
    cspn cfv cB csn cspn cfv wceq cC cB spansneleq imp eleqtrrd syl5 exp4b
    com24 exp4a com23 imp43 impbid $.
    $( [27-Dec-2007] $) $( [17-Dec-2004] $)

  $( A vector belonging to both a subspace and the span of the singleton of a
     vector not in it must be zero. $)
  elspansn5 $p |- ( A e. SH -> ( ( ( B e. ~H /\ -. B e. A ) /\
         ( C e. ( span ` { B } ) /\ C e. A ) ) -> C = 0h ) ) $=
    cA csh wcel cB chil wcel cB cA wcel wn cC cB csn cspn cfv wcel cC cA wcel
    wa cC c0v wceq cA csh wcel cB chil wcel cC cB csn cspn cfv wcel cC cA wcel
    wa cB cA wcel wn cC c0v wceq cA csh wcel cB chil wcel cC cB csn cspn cfv
    wcel cC cA wcel wa cB cA wcel wn cC c0v wceq wi cA csh wcel cB chil wcel wa
    cC cB csn cspn cfv wcel cC cA wcel wa wa cB cA wcel cC c0v cA csh wcel cB
    chil wcel wa cC cB csn cspn cfv wcel cC cA wcel cC c0v wne cB cA wcel wi cA
    csh wcel cB chil wcel wa cC cB csn cspn cfv wcel cC c0v wne cC cA wcel cB
    cA wcel cA csh wcel cB chil wcel wa cC cB csn cspn cfv wcel cC c0v wne cC
    cA wcel cB cA wcel wi cA csh wcel cB chil wcel wa cC cB csn cspn cfv wcel
    cC c0v wne wa wa cB cA wcel cC cA wcel cA cB cC elspansn4 biimprd exp32
    com34 imp32 necon1bd exp31 com34 imp4c $.
    $( [22-Dec-2004] $) $( [17-Dec-2004] $)

  $( The span of the singleton of an element of a subspace is included in the
     subspace. $)
  spansnss2 $p |- ( ( A e. SH /\ B e. ~H ) ->
                   ( B e. A <-> ( span ` { B } ) C_ A ) ) $=
    cA csh wcel cB chil wcel wa cB cA wcel cB csn cspn cfv cA wss cA csh wcel
    cB cA wcel cB csn cspn cfv cA wss wi cB chil wcel cA csh wcel cB cA wcel cB
    csn cspn cfv cA wss cA cB spansnss ex adantr cB chil wcel cB csn cspn cfv
    cA wss cB cA wcel wi cA csh wcel cB csn cspn cfv cA wss cB cB csn cspn cfv
    wcel cB cA wcel cB chil wcel cB csn cspn cfv cA cB ssel cB spansnid syl5com
    adantl impbid $.
    $( [5-Jan-2005] $) $( [16-Dec-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Cancellation-type law that "extracts" a vector ` A ` from its inner
       product with a proportional vector ` B ` . $)
    normcan $p |- ( ( B e. ~H /\ B =/= 0h /\ A e. ( span ` { B } ) ) ->
            ( ( ( A .ih B ) / ( ( normh ` B ) ^ 2 ) ) .h B ) = A ) $=
      cB chil wcel cB c0v wne cA cB csn cspn cfv wcel cA cB csp co cB cno cfv
      c2 cexp co cdiv co cB csm co cA wceq cB chil wcel cB c0v wne wa cA cB csn
      cspn cfv wcel cA vx cv cB csm co wceq vx cc wrex cA cB csp co cB cno cfv
      c2 cexp co cdiv co cB csm co cA wceq cB chil wcel cA cB csn cspn cfv wcel
      cA vx cv cB csm co wceq vx cc wrex wb cB c0v wne vx cB cA elspansn adantr
      cB chil wcel cB c0v wne wa cA vx cv cB csm co wceq cA cB csp co cB cno
      cfv c2 cexp co cdiv co cB csm co cA wceq vx cc cB chil wcel cB c0v wne wa
      vx cv cc wcel cA vx cv cB csm co wceq cA cB csp co cB cno cfv c2 cexp co
      cdiv co cB csm co cA wceq cB chil wcel cB c0v wne wa vx cv cc wcel wa cA
      vx cv cB csm co wceq wa cA cB csp co cB cno cfv c2 cexp co cdiv co cB csm
      co vx cv cB csm co cA cB chil wcel cB c0v wne wa vx cv cc wcel wa cA vx
      cv cB csm co wceq wa cA cB csp co cB cno cfv c2 cexp co cdiv co vx cv cB
      csm cB chil wcel cB c0v wne wa vx cv cc wcel wa cA vx cv cB csm co wceq
      wa cA cB csp co cB cno cfv c2 cexp co cdiv co vx cv cB cB csp co cmul co
      cB cB csp co cdiv co vx cv cB chil wcel vx cv cc wcel cA vx cv cB csm co
      wceq cA cB csp co cB cno cfv c2 cexp co cdiv co vx cv cB cB csp co cmul
      co cB cB csp co cdiv co wceq cB c0v wne cB chil wcel vx cv cc wcel wa cA
      vx cv cB csm co wceq wa cA cB csp co vx cv cB cB csp co cmul co cB cno
      cfv c2 cexp co cB cB csp co cdiv cA vx cv cB csm co wceq cB chil wcel vx
      cv cc wcel wa cA cB csp co vx cv cB csm co cB csp co vx cv cB cB csp co
      cmul co cA vx cv cB csm co cB csp opreq1 vx cv cc wcel cB chil wcel cB
      chil wcel vx cv cB csm co cB csp co vx cv cB cB csp co cmul co wceq cB
      chil wcel vx cv cc wcel wa vx cv cB cB ax-his3 cB chil wcel vx cv cc wcel
      pm3.27 cB chil wcel vx cv cc wcel pm3.26 cB chil wcel vx cv cc wcel
      pm3.26 syl3anc sylan9eqr cB chil wcel cB cno cfv c2 cexp co cB cB csp co
      wceq vx cv cc wcel cA vx cv cB csm co wceq cB normsq ad2antrr opreq12d
      adantllr cB chil wcel cB c0v wne wa vx cv cc wcel wa vx cv cB cB csp co
      cmul co cB cB csp co cdiv co vx cv wceq cA vx cv cB csm co wceq vx cv cc
      wcel cB cB csp co cc wcel cB cB csp co cc0 wne vx cv cB cB csp co cmul co
      cB cB csp co cdiv co vx cv wceq cB chil wcel cB c0v wne wa vx cv cc wcel
      wa vx cv cB cB csp co divcan4 cB chil wcel cB c0v wne wa vx cv cc wcel
      pm3.27 cB chil wcel cB cB csp co cc wcel cB c0v wne vx cv cc wcel cB chil
      wcel cB cB csp co cc wcel cB cB hicl anidms ad2antrr cB chil wcel cB c0v
      wne wa cB cB csp co cc0 wne vx cv cc wcel cB chil wcel cB cB csp co cc0
      wne cB c0v wne cB chil wcel cB cB csp co cc0 cB c0v cB his6 necon3bid
      biimpar adantr syl3anc adantr eqtrd opreq1d cB chil wcel cB c0v wne wa vx
      cv cc wcel wa cA vx cv cB csm co wceq pm3.27 eqtr4d exp31 r19.23adv
      sylbid 3impia $.
      $( [28-May-2006] $) $( [18-Mar-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A projection on the span of a singleton. $)
    pjspansn $p |- ( ( A e. ~H /\ B e. ~H /\ A =/= 0h ) -> ( ( proj ` ( span `
        { A } ) ) ` B ) = ( ( ( B .ih A ) / ( ( normh ` A ) ^ 2 ) ) .h A ) ) $=
      cA chil wcel cB chil wcel cA c0v wne w3a cB cA csn cspn cfv cpj cfv cfv
      cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn
      cspn cfv crab cuni cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm co
      cA chil wcel cB chil wcel cB cA csn cspn cfv cpj cfv cfv cB vx cv vy cv
      cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn cfv crab cuni
      wceq cA c0v wne cA csn cspn cfv cch wcel cB chil wcel cB cA csn cspn cfv
      cpj cfv cfv cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex
      vx cA csn cspn cfv crab cuni wceq cA chil wcel vx vy cB cA csn cspn cfv
      pjval cA spansnch sylan 3adant3 cA chil wcel cB chil wcel cA c0v wne w3a
      cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn
      cspn cfv crab cuni csn cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm
      co csn wss cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx
      cA csn cspn cfv crab cuni cB cA csp co cA cno cfv c2 cexp co cdiv co cA
      csm co wceq cA chil wcel cB chil wcel cA c0v wne w3a cB vx cv vy cv cva
      co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn cfv crab vx cv cB
      cA csp co cA cno cfv c2 cexp co cdiv co cA csm co wceq vx cA csn cspn cfv
      crab cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA
      csn cspn cfv crab cuni csn cB cA csp co cA cno cfv c2 cexp co cdiv co cA
      csm co csn cA chil wcel cB chil wcel cA c0v wne w3a cB vx cv vy cv cva co
      wceq vy cA csn cspn cfv cort cfv wrex vx cv cB cA csp co cA cno cfv c2
      cexp co cdiv co cA csm co wceq vx cA csn cspn cfv cA chil wcel cA c0v wne
      vx cv cA csn cspn cfv wcel cB vx cv vy cv cva co wceq vy cA csn cspn cfv
      cort cfv wrex vx cv cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm co
      wceq wi cB chil wcel cA chil wcel cA c0v wne wa vx cv cA csn cspn cfv
      wcel wa cB vx cv vy cv cva co wceq vx cv cB cA csp co cA cno cfv c2 cexp
      co cdiv co cA csm co wceq vy cA csn cspn cfv cort cfv cA chil wcel cA c0v
      wne wa vx cv cA csn cspn cfv wcel wa vy cv cA csn cspn cfv cort cfv wcel
      cB vx cv vy cv cva co wceq vx cv cB cA csp co cA cno cfv c2 cexp co cdiv
      co cA csm co wceq cA chil wcel cA c0v wne wa vx cv cA csn cspn cfv wcel
      wa vy cv cA csn cspn cfv cort cfv wcel cB vx cv vy cv cva co wceq wa wa
      cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm co vx cv cA csp co cA
      cno cfv c2 cexp co cdiv co cA csm co vx cv cA chil wcel cA c0v wne wa vx
      cv cA csn cspn cfv wcel wa vy cv cA csn cspn cfv cort cfv wcel cB vx cv
      vy cv cva co wceq wa wa cB cA csp co cA cno cfv c2 cexp co cdiv co vx cv
      cA csp co cA cno cfv c2 cexp co cdiv co cA csm cA chil wcel cA c0v wne wa
      vx cv cA csn cspn cfv wcel wa vy cv cA csn cspn cfv cort cfv wcel cB vx
      cv vy cv cva co wceq wa wa cB cA csp co vx cv cA csp co cA cno cfv c2
      cexp co cdiv cA chil wcel vx cv cA csn cspn cfv wcel vy cv cA csn cspn
      cfv cort cfv wcel cB vx cv vy cv cva co wceq wa cB cA csp co vx cv cA csp
      co wceq cA c0v wne cA chil wcel vx cv cA csn cspn cfv wcel wa vy cv cA
      csn cspn cfv cort cfv wcel cB vx cv vy cv cva co wceq wa wa cB cA csp co
      vx cv vy cv cva co cA csp co vx cv cA csp co cB vx cv vy cv cva co wceq
      cB cA csp co vx cv vy cv cva co cA csp co wceq cA chil wcel vx cv cA csn
      cspn cfv wcel wa vy cv cA csn cspn cfv cort cfv wcel cB vx cv vy cv cva
      co cA csp opreq1 ad2antll cA chil wcel vx cv cA csn cspn cfv wcel wa vy
      cv cA csn cspn cfv cort cfv wcel vx cv vy cv cva co cA csp co vx cv cA
      csp co wceq cB vx cv vy cv cva co wceq cA chil wcel vx cv chil wcel wa vy
      cv cA csn cspn cfv cort cfv wcel vx cv vy cv cva co cA csp co vx cv cA
      csp co wceq cA chil wcel vx cv cA csn cspn cfv wcel wa cA chil wcel vx cv
      chil wcel wa vy cv cA csn cspn cfv cort cfv wcel wa vx cv vy cv cva co cA
      csp co vx cv cA csp co vy cv cA csp co caddc co vx cv cA csp co cc0 caddc
      co vx cv cA csp co cA chil wcel vx cv chil wcel wa vy cv cA csn cspn cfv
      cort cfv wcel vy cv chil wcel vx cv vy cv cva co cA csp co vx cv cA csp
      co vy cv cA csp co caddc co wceq cA chil wcel vy cv cA csn cspn cfv cort
      cfv wcel vy cv chil wcel vx cv chil wcel cA csn cspn cfv cort cfv cch
      wcel vy cv cA csn cspn cfv cort cfv wcel vy cv chil wcel cA chil wcel vy
      cv cA csn cspn cfv cort cfv chel cA chil wcel cA csn cspn cfv cch wcel cA
      csn cspn cfv cort cfv cch wcel cA spansnch cA csn cspn cfv choccl syl
      sylan adantlr cA chil wcel vx cv chil wcel vy cv chil wcel vx cv vy cv
      cva co cA csp co vx cv cA csp co vy cv cA csp co caddc co wceq vx cv chil
      wcel vy cv chil wcel cA chil wcel vx cv vy cv cva co cA csp co vx cv cA
      csp co vy cv cA csp co caddc co wceq vx cv vy cv cA ax-his2 3comr 3expa
      syldan cA chil wcel vx cv chil wcel wa vy cv cA csn cspn cfv cort cfv
      wcel wa vy cv cA csp co cc0 vx cv cA csp co caddc cA chil wcel vy cv cA
      csn cspn cfv cort cfv wcel vy cv cA csp co cc0 wceq vx cv chil wcel cA
      chil wcel vy cv cA csn cspn cfv cort cfv wcel wa cA vy cv csp co cc0 wceq
      vy cv cA csp co cc0 wceq cA csn cspn cfv csh wcel cA cA csn cspn cfv wcel
      vy cv cA csn cspn cfv cort cfv wcel cA vy cv csp co cc0 wceq cA chil wcel
      vy cv cA csn cspn cfv cort cfv wcel wa cA csn cspn cfv csh wcel cA cA csn
      cspn cfv wcel vy cv cA csn cspn cfv cort cfv wcel cA vy cv csp co cc0
      wceq cA vy cv cA csn cspn cfv shocorth 3impib cA chil wcel cA csn cspn
      cfv csh wcel vy cv cA csn cspn cfv cort cfv wcel cA spansnsh adantr cA
      chil wcel cA cA csn cspn cfv wcel vy cv cA csn cspn cfv cort cfv wcel cA
      spansnid adantr cA chil wcel vy cv cA csn cspn cfv cort cfv wcel pm3.27
      syl3anc cA chil wcel vy cv cA csn cspn cfv cort cfv wcel vy cv chil wcel
      cA vy cv csp co cc0 wceq vy cv cA csp co cc0 wceq wb cA csn cspn cfv cort
      cfv cch wcel vy cv cA csn cspn cfv cort cfv wcel vy cv chil wcel cA chil
      wcel vy cv cA csn cspn cfv cort cfv chel cA chil wcel cA csn cspn cfv cch
      wcel cA csn cspn cfv cort cfv cch wcel cA spansnch cA csn cspn cfv choccl
      syl sylan cA vy cv orthcom syldan mpbid adantlr opreq2d cA chil wcel vx
      cv chil wcel wa vx cv cA csp co cc0 caddc co vx cv cA csp co wceq vy cv
      cA csn cspn cfv cort cfv wcel cA chil wcel vx cv chil wcel wa vx cv cA
      csp co cc wcel vx cv cA csp co cc0 caddc co vx cv cA csp co wceq vx cv
      chil wcel cA chil wcel vx cv cA csp co cc wcel vx cv cA hicl ancoms vx cv
      cA csp co addid1 syl adantr 3eqtrd cA chil wcel vx cv cA csn cspn cfv
      wcel wa cA chil wcel vx cv chil wcel cA chil wcel vx cv cA csn cspn cfv
      wcel pm3.26 cA vx cv elspansncl jca sylan adantrr eqtrd adantllr opreq1d
      opreq1d cA chil wcel cA c0v wne wa vx cv cA csn cspn cfv wcel wa vx cv cA
      csp co cA cno cfv c2 cexp co cdiv co cA csm co vx cv wceq vy cv cA csn
      cspn cfv cort cfv wcel cB vx cv vy cv cva co wceq wa cA chil wcel cA c0v
      wne vx cv cA csn cspn cfv wcel vx cv cA csp co cA cno cfv c2 cexp co cdiv
      co cA csm co vx cv wceq vx cv cA normcan 3expa adantr eqtr2d exp32
      r19.23adv 3adantl2 ss2rabdv cA chil wcel cB chil wcel cA c0v wne w3a cB
      vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn
      cfv wreu cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx
      cA csn cspn cfv crab cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort
      cfv wrex vx cA csn cspn cfv crab cuni csn wceq cA chil wcel cB chil wcel
      cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn
      cspn cfv wreu cA c0v wne cA csn cspn cfv cch wcel cB chil wcel cB vx cv
      vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn cfv
      wreu cA chil wcel vx vy cB cA csn cspn cfv pjtheu cA spansnch sylan
      3adant3 cB vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA
      csn cspn cfv reuunisn syl cA chil wcel cB chil wcel cA c0v wne w3a cB cA
      csp co cA cno cfv c2 cexp co cdiv co cA csm co cA csn cspn cfv wcel vx cv
      cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm co wceq vx cA csn cspn
      cfv crab cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm co csn wceq cA
      chil wcel cB cA csp co cA cno cfv c2 cexp co cdiv co cc wcel cB cA csp co
      cA cno cfv c2 cexp co cdiv co cA csm co cA csn cspn cfv wcel cA chil wcel
      cB chil wcel cA c0v wne w3a cA cB cA csp co cA cno cfv c2 cexp co cdiv co
      spansnmul cA chil wcel cB chil wcel cA c0v wne 3simp1 cB cA csp co cc
      wcel cA cno cfv c2 cexp co cc wcel cA cno cfv c2 cexp co cc0 wne cB cA
      csp co cA cno cfv c2 cexp co cdiv co cc wcel cA chil wcel cB chil wcel cA
      c0v wne w3a cB cA csp co cA cno cfv c2 cexp co divcl cA chil wcel cB chil
      wcel cB cA csp co cc wcel cA c0v wne cB chil wcel cA chil wcel cB cA csp
      co cc wcel cB cA hicl ancoms 3adant3 cA chil wcel cB chil wcel cA cno cfv
      c2 cexp co cc wcel cA c0v wne cA chil wcel cA cno cfv cc wcel cA cno cfv
      c2 cexp co cc wcel cA chil wcel cA cno cfv cA normcl recnd cA cno cfv
      sqcl syl 3ad2ant1 cA chil wcel cA c0v wne cA cno cfv c2 cexp co cc0 wne
      cB chil wcel cA chil wcel cA c0v wne cA cno cfv c2 cexp co cc0 wne cA
      chil wcel cA cno cfv c2 cexp co cc0 wne cA cno cfv cc0 wne cA c0v wne cA
      chil wcel cA cno cfv cc wcel cA cno cfv c2 cexp co cc0 wne cA cno cfv cc0
      wne wb cA chil wcel cA cno cfv cA normcl recnd cA cno cfv sqne0 syl cA
      normne0 bitr2d biimpa 3adant2 syl3anc sylanc vx cA csn cspn cfv cB cA csp
      co cA cno cfv c2 cexp co cdiv co cA csm co rabsn syl 3sstr3d cB vx cv vy
      cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn cfv crab
      cuni cB cA csp co cA cno cfv c2 cexp co cdiv co cA csm co cB vx cv vy cv
      cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn cfv crab cB
      vx cv vy cv cva co wceq vy cA csn cspn cfv cort cfv wrex vx cA csn cspn
      cfv cA csn cspn fvex rabex uniex snsssn syl eqtrd $.
      $( [12-Jul-2006] $) $( [28-May-2006] $)
  $}

  ${
    spansnpj.1 $e |- A C_ ~H $.
    spansnpj.2 $e |- B e. ~H $.
    $( A subset of Hilbert space is orthogonal to the span of the singleton of
       a projection onto its orthocomplement. $)
    spansnpji $p |- A C_
                 ( _|_ ` ( span ` { ( ( proj ` ( _|_ ` A ) ) ` B ) } ) ) $=
      cA cA cort cfv cort cfv cB cA cort cfv cpj cfv cfv csn cspn cfv cort cfv
      cA chil wss cA cA cort cfv cort cfv wss spansnpj.1 cA ococss ax-mp cB cA
      cort cfv cpj cfv cfv csn cspn cfv cA cort cfv wss cA cort cfv cort cfv cB
      cA cort cfv cpj cfv cfv csn cspn cfv cort cfv wss cB cA cort cfv cpj cfv
      cfv csn cspn cfv cA cort cfv cspn cfv cA cort cfv cA cort cfv chil wss cB
      cA cort cfv cpj cfv cfv csn cA cort cfv wss cB cA cort cfv cpj cfv cfv
      csn cspn cfv cA cort cfv cspn cfv wss cA cort cfv cA spansnpj.1 occli
      chssii cB cA cort cfv cpj cfv cfv cA cort cfv wcel cB cA cort cfv cpj cfv
      cfv csn cA cort cfv wss cB cA cort cfv cA spansnpj.1 occli spansnpj.2
      pjclii cB cA cort cfv cpj cfv cfv cA cort cfv snssi ax-mp cB cA cort cfv
      cpj cfv cfv csn cA cort cfv spanss mp2an cA cort cfv csh wcel cA cort cfv
      cspn cfv cA cort cfv wceq cA cort cfv cA spansnpj.1 occli chshii cA cort
      cfv spanid ax-mp sseqtri cB cA cort cfv cpj cfv cfv csn cspn cfv cA cort
      cfv cB cA cort cfv cpj cfv cfv cB cA cort cfv cA spansnpj.1 occli
      spansnpj.2 pjhclii spansnchi cA spansnpj.1 occli chsscon3i mpbi sstri $.
      $( [4-Jul-2004] $) $( [4-Jun-2004] $)
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    spanunsn.1 $e |- A e. CH $.
    spanunsn.2 $e |- B e. ~H $.
    $( The span of the union of a closed subspace with a singleton equals
       the span of its union with an orthogonal singleton. $)
    spanunsni $p |- ( span ` ( A u. { B } ) ) =
             ( span ` ( A u. { ( ( proj ` ( _|_ ` A ) ) ` B ) } ) ) $=
      cA cB csn cspn cfv cph co cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph
      co cA cB csn cun cspn cfv cA cB cA cort cfv cpj cfv cfv csn cun cspn cfv
      vx cA cB csn cspn cfv cph co cA cB cA cort cfv cpj cfv cfv csn cspn cfv
      cph co vx cv cA cB csn cspn cfv cph co wcel vx cv cA cB cA cort cfv cpj
      cfv cfv csn cspn cfv cph co wcel vx cv cA cB csn cspn cfv cph co wcel vx
      cv vy cv vz cv cva co wceq vz cB csn cspn cfv wrex vy cA wrex vx cv cA cB
      cA cort cfv cpj cfv cfv csn cspn cfv cph co wcel vy vz cA cB csn cspn cfv
      vx cv cA spanunsn.1 chshii cB csn chil wss cB csn cspn cfv csh wcel cB
      chil wcel cB csn chil wss spanunsn.2 cB chil snssi ax-mp cB csn spancl
      ax-mp shseli vx cv vy cv vz cv cva co wceq vz cB csn cspn cfv wrex vx cv
      cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph co wcel vy cA vy cv cA
      wcel vx cv vy cv vz cv cva co wceq vx cv cA cB cA cort cfv cpj cfv cfv
      csn cspn cfv cph co wcel vz cB csn cspn cfv vy cv cA wcel vz cv vw cv cB
      csm co wceq vw cc wrex vx cv vy cv vz cv cva co wceq vx cv cA cB cA cort
      cfv cpj cfv cfv csn cspn cfv cph co wcel wi vz cv cB csn cspn cfv wcel vy
      cv cA wcel vz cv vw cv cB csm co wceq vx cv vy cv vz cv cva co wceq vx cv
      cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph co wcel wi vw cc vy cv cA
      wcel vw cv cc wcel vz cv vw cv cB csm co wceq vx cv vy cv vz cv cva co
      wceq vx cv cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph co wcel vy cv
      vw cv cB csm co cva co cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph co
      wcel vx cv vy cv vw cv cB csm co cva co wceq vx cv cA cB cA cort cfv cpj
      cfv cfv csn cspn cfv cph co wcel vy cv cA wcel vw cv cc wcel wa vz cv vw
      cv cB csm co wceq vx cv vy cv vz cv cva co wceq wa vx cv vy cv vw cv cB
      csm co cva co wceq vx cv cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph
      co wcel vy cv vw cv cB csm co cva co cA cB cA cort cfv cpj cfv cfv csn
      cspn cfv cph co wcel vx cv vy cv vw cv cB csm co cva co cA cB cA cort cfv
      cpj cfv cfv csn cspn cfv cph co eleq1 biimparc vy cv cA wcel vw cv cc
      wcel wa vy cv vw cv cB csm co cva co vv cv vu cv cva co wceq vu cB cA
      cort cfv cpj cfv cfv csn cspn cfv wrex vv cA wrex vy cv vw cv cB csm co
      cva co cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph co wcel vy cv vw cv
      cB cA cpj cfv cfv csm co cva co cA wcel vw cv cB cA cort cfv cpj cfv cfv
      csm co cB cA cort cfv cpj cfv cfv csn cspn cfv wcel vy cv vw cv cB csm co
      cva co vy cv vw cv cB cA cpj cfv cfv csm co cva co vw cv cB cA cort cfv
      cpj cfv cfv csm co cva co wceq vy cv vw cv cB csm co cva co vv cv vu cv
      cva co wceq vu cB cA cort cfv cpj cfv cfv csn cspn cfv wrex vv cA wrex vy
      cv cA wcel vw cv cc wcel wa vv vu cA cB cA cort cfv cpj cfv cfv csn cspn
      cfv vy cv vw cv cB cA cpj cfv cfv csm co cva co vw cv cB cA cort cfv cpj
      cfv cfv csm co vy cv vw cv cB csm co cva co cva rcla4eopr cA csh wcel vy
      cv cA wcel vw cv cc wcel wa vy cv vw cv cB cA cpj cfv cfv csm co cva co
      cA wcel wi cA spanunsn.1 chshii cA csh wcel vy cv cA wcel vw cv cB cA cpj
      cfv cfv csm co cA wcel vy cv vw cv cB cA cpj cfv cfv csm co cva co cA
      wcel vw cv cc wcel vy cv vw cv cB cA cpj cfv cfv csm co cA shaddclOLD vw
      cv cc wcel cB cA cpj cfv cfv cA wcel vw cv cB cA cpj cfv cfv csm co cA
      wcel cB cA spanunsn.1 spanunsn.2 pjclii cA csh wcel vw cv cc wcel cB cA
      cpj cfv cfv cA wcel wa vw cv cB cA cpj cfv cfv csm co cA wcel wi cA
      spanunsn.1 chshii vw cv cB cA cpj cfv cfv cA shmulclOLD ax-mp mpan2
      sylan2i ax-mp vw cv cc wcel vw cv cB cA cort cfv cpj cfv cfv csm co cB cA
      cort cfv cpj cfv cfv csn cspn cfv wcel vy cv cA wcel cB cA cort cfv cpj
      cfv cfv chil wcel vw cv cc wcel vw cv cB cA cort cfv cpj cfv cfv csm co
      cB cA cort cfv cpj cfv cfv csn cspn cfv wcel cB cA cort cfv cA spanunsn.1
      choccli spanunsn.2 pjhclii cB cA cort cfv cpj cfv cfv vw cv spansnmul
      mpan adantl vy cv cA wcel vw cv cc wcel wa vy cv vw cv cB csm co cva co
      vy cv vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv csm
      co cva co cva co vy cv vw cv cB cA cpj cfv cfv csm co cva co vw cv cB cA
      cort cfv cpj cfv cfv csm co cva co vy cv cA wcel vw cv cc wcel wa vw cv
      cB csm co vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv
      csm co cva co vy cv cva vw cv cc wcel vw cv cB csm co vw cv cB cA cpj cfv
      cfv csm co vw cv cB cA cort cfv cpj cfv cfv csm co cva co wceq vy cv cA
      wcel vw cv cc wcel vw cv cB cA cpj cfv cfv cB cA cort cfv cpj cfv cfv cva
      co csm co vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv
      csm co cva co vw cv cB csm co vw cv cc wcel cB cA cpj cfv cfv chil wcel
      cB cA cort cfv cpj cfv cfv chil wcel vw cv cB cA cpj cfv cfv cB cA cort
      cfv cpj cfv cfv cva co csm co vw cv cB cA cpj cfv cfv csm co vw cv cB cA
      cort cfv cpj cfv cfv csm co cva co wceq cB cA spanunsn.1 spanunsn.2
      pjhclii cB cA cort cfv cA spanunsn.1 choccli spanunsn.2 pjhclii vw cv cB
      cA cpj cfv cfv cB cA cort cfv cpj cfv cfv ax-hvdistr1 mp3an23 cB cB cA
      cpj cfv cfv cB cA cort cfv cpj cfv cfv cva co vw cv csm cB cA spanunsn.1
      spanunsn.2 pjpji opreq2i syl5eq adantl opreq2d vy cv chil wcel vw cv cB
      cA cpj cfv cfv csm co chil wcel vw cv cB cA cort cfv cpj cfv cfv csm co
      chil wcel wa vy cv vw cv cB cA cpj cfv cfv csm co cva co vw cv cB cA cort
      cfv cpj cfv cfv csm co cva co vy cv vw cv cB cA cpj cfv cfv csm co vw cv
      cB cA cort cfv cpj cfv cfv csm co cva co cva co wceq vy cv cA wcel vw cv
      cc wcel vy cv chil wcel vw cv cB cA cpj cfv cfv csm co chil wcel vw cv cB
      cA cort cfv cpj cfv cfv csm co chil wcel vy cv vw cv cB cA cpj cfv cfv
      csm co cva co vw cv cB cA cort cfv cpj cfv cfv csm co cva co vy cv vw cv
      cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv csm co cva co
      cva co wceq vy cv vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj
      cfv cfv csm co ax-hvass 3expb vy cv cA spanunsn.1 cheli vw cv cc wcel vw
      cv cB cA cpj cfv cfv csm co chil wcel vw cv cB cA cort cfv cpj cfv cfv
      csm co chil wcel vw cv cc wcel cB cA cpj cfv cfv chil wcel vw cv cB cA
      cpj cfv cfv csm co chil wcel cB cA spanunsn.1 spanunsn.2 pjhclii vw cv cB
      cA cpj cfv cfv hvmulcl mpan2 vw cv cc wcel cB cA cort cfv cpj cfv cfv
      chil wcel vw cv cB cA cort cfv cpj cfv cfv csm co chil wcel cB cA cort
      cfv cA spanunsn.1 choccli spanunsn.2 pjhclii vw cv cB cA cort cfv cpj cfv
      cfv hvmulcl mpan2 jca syl2an eqtr4d syl3anc vv vu cA cB cA cort cfv cpj
      cfv cfv csn cspn cfv vy cv vw cv cB csm co cva co cA spanunsn.1 chshii cB
      cA cort cfv cpj cfv cfv csn chil wss cB cA cort cfv cpj cfv cfv csn cspn
      cfv csh wcel cB cA cort cfv cpj cfv cfv chil wcel cB cA cort cfv cpj cfv
      cfv csn chil wss cB cA cort cfv cA spanunsn.1 choccli spanunsn.2 pjhclii
      cB cA cort cfv cpj cfv cfv chil snssi ax-mp cB cA cort cfv cpj cfv cfv
      csn spancl ax-mp shseli sylibr vz cv vw cv cB csm co wceq vx cv vy cv vz
      cv cva co wceq vx cv vy cv vw cv cB csm co cva co wceq vz cv vw cv cB csm
      co wceq vy cv vz cv cva co vy cv vw cv cB csm co cva co vx cv vz cv vw cv
      cB csm co vy cv cva opreq2 eqeq2d biimpa syl2an exp43 r19.23adv vw cB vz
      cv spanunsn.2 elspansni syl5ib r19.23adv r19.23aiv sylbi vx cv cA cB cA
      cort cfv cpj cfv cfv csn cspn cfv cph co wcel vx cv vy cv vz cv cva co
      wceq vz cB cA cort cfv cpj cfv cfv csn cspn cfv wrex vy cA wrex vx cv cA
      cB csn cspn cfv cph co wcel vy vz cA cB cA cort cfv cpj cfv cfv csn cspn
      cfv vx cv cA spanunsn.1 chshii cB cA cort cfv cpj cfv cfv csn chil wss cB
      cA cort cfv cpj cfv cfv csn cspn cfv csh wcel cB cA cort cfv cpj cfv cfv
      chil wcel cB cA cort cfv cpj cfv cfv csn chil wss cB cA cort cfv cA
      spanunsn.1 choccli spanunsn.2 pjhclii cB cA cort cfv cpj cfv cfv chil
      snssi ax-mp cB cA cort cfv cpj cfv cfv csn spancl ax-mp shseli vx cv vy
      cv vz cv cva co wceq vz cB cA cort cfv cpj cfv cfv csn cspn cfv wrex vx
      cv cA cB csn cspn cfv cph co wcel vy cA vy cv cA wcel vx cv vy cv vz cv
      cva co wceq vx cv cA cB csn cspn cfv cph co wcel vz cB cA cort cfv cpj
      cfv cfv csn cspn cfv vy cv cA wcel vz cv vw cv cB cA cort cfv cpj cfv cfv
      csm co wceq vw cc wrex vx cv vy cv vz cv cva co wceq vx cv cA cB csn cspn
      cfv cph co wcel wi vz cv cB cA cort cfv cpj cfv cfv csn cspn cfv wcel vy
      cv cA wcel vz cv vw cv cB cA cort cfv cpj cfv cfv csm co wceq vx cv vy cv
      vz cv cva co wceq vx cv cA cB csn cspn cfv cph co wcel wi vw cc vy cv cA
      wcel vw cv cc wcel vz cv vw cv cB cA cort cfv cpj cfv cfv csm co wceq vx
      cv vy cv vz cv cva co wceq vx cv cA cB csn cspn cfv cph co wcel vy cv vw
      cv cB cA cort cfv cpj cfv cfv csm co cva co cA cB csn cspn cfv cph co
      wcel vx cv vy cv vw cv cB cA cort cfv cpj cfv cfv csm co cva co wceq vx
      cv cA cB csn cspn cfv cph co wcel vy cv cA wcel vw cv cc wcel wa vz cv vw
      cv cB cA cort cfv cpj cfv cfv csm co wceq vx cv vy cv vz cv cva co wceq
      wa vx cv vy cv vw cv cB cA cort cfv cpj cfv cfv csm co cva co wceq vx cv
      cA cB csn cspn cfv cph co wcel vy cv vw cv cB cA cort cfv cpj cfv cfv csm
      co cva co cA cB csn cspn cfv cph co wcel vx cv vy cv vw cv cB cA cort cfv
      cpj cfv cfv csm co cva co cA cB csn cspn cfv cph co eleq1 biimparc vy cv
      cA wcel vw cv cc wcel wa vy cv vw cv cB cA cort cfv cpj cfv cfv csm co
      cva co vv cv vu cv cva co wceq vu cB csn cspn cfv wrex vv cA wrex vy cv
      vw cv cB cA cort cfv cpj cfv cfv csm co cva co cA cB csn cspn cfv cph co
      wcel vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co cA wcel vw cv cB
      csm co cB csn cspn cfv wcel vy cv vw cv cB cA cort cfv cpj cfv cfv csm co
      cva co vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co vw cv cB csm co
      cva co wceq vy cv vw cv cB cA cort cfv cpj cfv cfv csm co cva co vv cv vu
      cv cva co wceq vu cB csn cspn cfv wrex vv cA wrex vy cv cA wcel vw cv cc
      wcel wa vv vu cA cB csn cspn cfv vw cv cneg cB cA cpj cfv cfv csm co vy
      cv cva co vw cv cB csm co vy cv vw cv cB cA cort cfv cpj cfv cfv csm co
      cva co cva rcla4eopr vw cv cc wcel vy cv cA wcel vw cv cneg cB cA cpj cfv
      cfv csm co vy cv cva co cA wcel cA csh wcel vw cv cc wcel vy cv cA wcel
      wa vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co cA wcel wi cA
      spanunsn.1 chshii cA csh wcel vw cv cneg cB cA cpj cfv cfv csm co cA wcel
      vy cv cA wcel vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co cA wcel vw
      cv cc wcel vw cv cneg cB cA cpj cfv cfv csm co vy cv cA shaddclOLD vw cv
      cc wcel vw cv cneg cc wcel vw cv cneg cB cA cpj cfv cfv csm co cA wcel vw
      cv negcl vw cv cneg cc wcel cB cA cpj cfv cfv cA wcel vw cv cneg cB cA
      cpj cfv cfv csm co cA wcel cB cA spanunsn.1 spanunsn.2 pjclii cA csh wcel
      vw cv cneg cc wcel cB cA cpj cfv cfv cA wcel wa vw cv cneg cB cA cpj cfv
      cfv csm co cA wcel wi cA spanunsn.1 chshii vw cv cneg cB cA cpj cfv cfv
      cA shmulclOLD ax-mp mpan2 syl sylani ax-mp ancoms vw cv cc wcel vw cv cB
      csm co cB csn cspn cfv wcel vy cv cA wcel cB chil wcel vw cv cc wcel vw
      cv cB csm co cB csn cspn cfv wcel spanunsn.2 cB vw cv spansnmul mpan
      adantl vy cv cA wcel vw cv cc wcel wa vy cv vw cv cB cA cort cfv cpj cfv
      cfv csm co cva co vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co vw cv
      cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv csm co cva co
      cva co vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co vw cv cB csm co
      cva co vy cv cA wcel vw cv cc wcel wa c0v vy cv vw cv cB cA cort cfv cpj
      cfv cfv csm co cva co cva co vw cv cneg cB cA cpj cfv cfv csm co vw cv cB
      cA cpj cfv cfv csm co cva co vy cv vw cv cB cA cort cfv cpj cfv cfv csm
      co cva co cva co vy cv vw cv cB cA cort cfv cpj cfv cfv csm co cva co vw
      cv cneg cB cA cpj cfv cfv csm co vy cv cva co vw cv cB cA cpj cfv cfv csm
      co vw cv cB cA cort cfv cpj cfv cfv csm co cva co cva co vy cv cA wcel vw
      cv cc wcel wa c0v vw cv cneg cB cA cpj cfv cfv csm co vw cv cB cA cpj cfv
      cfv csm co cva co vy cv vw cv cB cA cort cfv cpj cfv cfv csm co cva co
      cva vw cv cc wcel c0v vw cv cneg cB cA cpj cfv cfv csm co vw cv cB cA cpj
      cfv cfv csm co cva co wceq vy cv cA wcel vw cv cc wcel vw cv cB cA cpj
      cfv cfv csm co c1 cneg vw cv cB cA cpj cfv cfv csm co csm co cva co vw cv
      cB cA cpj cfv cfv csm co vw cv cneg cB cA cpj cfv cfv csm co cva co c0v
      vw cv cneg cB cA cpj cfv cfv csm co vw cv cB cA cpj cfv cfv csm co cva co
      vw cv cc wcel c1 cneg vw cv cB cA cpj cfv cfv csm co csm co vw cv cneg cB
      cA cpj cfv cfv csm co vw cv cB cA cpj cfv cfv csm co cva vw cv cc wcel cB
      cA cpj cfv cfv chil wcel c1 cneg vw cv cB cA cpj cfv cfv csm co csm co vw
      cv cneg cB cA cpj cfv cfv csm co wceq cB cA spanunsn.1 spanunsn.2 pjhclii
      vw cv cB cA cpj cfv cfv hvm1neg mpan2 opreq2d vw cv cc wcel vw cv cB cA
      cpj cfv cfv csm co chil wcel vw cv cB cA cpj cfv cfv csm co c1 cneg vw cv
      cB cA cpj cfv cfv csm co csm co cva co c0v wceq vw cv cc wcel cB cA cpj
      cfv cfv chil wcel vw cv cB cA cpj cfv cfv csm co chil wcel cB cA
      spanunsn.1 spanunsn.2 pjhclii vw cv cB cA cpj cfv cfv hvmulcl mpan2 vw cv
      cB cA cpj cfv cfv csm co hvnegid syl vw cv cB cA cpj cfv cfv csm co chil
      wcel vw cv cneg cB cA cpj cfv cfv csm co chil wcel vw cv cB cA cpj cfv
      cfv csm co vw cv cneg cB cA cpj cfv cfv csm co cva co vw cv cneg cB cA
      cpj cfv cfv csm co vw cv cB cA cpj cfv cfv csm co cva co wceq vw cv cc
      wcel vw cv cB cA cpj cfv cfv csm co vw cv cneg cB cA cpj cfv cfv csm co
      ax-hvcom vw cv cc wcel cB cA cpj cfv cfv chil wcel vw cv cB cA cpj cfv
      cfv csm co chil wcel cB cA spanunsn.1 spanunsn.2 pjhclii vw cv cB cA cpj
      cfv cfv hvmulcl mpan2 vw cv cc wcel vw cv cneg cc wcel vw cv cneg cB cA
      cpj cfv cfv csm co chil wcel vw cv negcl vw cv cneg cc wcel cB cA cpj cfv
      cfv chil wcel vw cv cneg cB cA cpj cfv cfv csm co chil wcel cB cA
      spanunsn.1 spanunsn.2 pjhclii vw cv cneg cB cA cpj cfv cfv hvmulcl mpan2
      syl sylanc 3eqtr3d adantl opreq1d vy cv cA wcel vw cv cc wcel wa vy cv vw
      cv cB cA cort cfv cpj cfv cfv csm co cva co chil wcel c0v vy cv vw cv cB
      cA cort cfv cpj cfv cfv csm co cva co cva co vy cv vw cv cB cA cort cfv
      cpj cfv cfv csm co cva co wceq vy cv chil wcel vw cv cB cA cort cfv cpj
      cfv cfv csm co chil wcel vy cv vw cv cB cA cort cfv cpj cfv cfv csm co
      cva co chil wcel vy cv cA wcel vw cv cc wcel vy cv vw cv cB cA cort cfv
      cpj cfv cfv csm co hvaddcl vy cv cA spanunsn.1 cheli vw cv cc wcel cB cA
      cort cfv cpj cfv cfv chil wcel vw cv cB cA cort cfv cpj cfv cfv csm co
      chil wcel cB cA cort cfv cA spanunsn.1 choccli spanunsn.2 pjhclii vw cv
      cB cA cort cfv cpj cfv cfv hvmulcl mpan2 syl2an vy cv vw cv cB cA cort
      cfv cpj cfv cfv csm co cva co hvaddid2 syl vw cv cneg cB cA cpj cfv cfv
      csm co chil wcel vw cv cB cA cpj cfv cfv csm co chil wcel wa vy cv chil
      wcel vw cv cB cA cort cfv cpj cfv cfv csm co chil wcel wa vw cv cneg cB
      cA cpj cfv cfv csm co vw cv cB cA cpj cfv cfv csm co cva co vy cv vw cv
      cB cA cort cfv cpj cfv cfv csm co cva co cva co vw cv cneg cB cA cpj cfv
      cfv csm co vy cv cva co vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort
      cfv cpj cfv cfv csm co cva co cva co wceq vy cv cA wcel vw cv cc wcel wa
      vw cv cneg cB cA cpj cfv cfv csm co vw cv cB cA cpj cfv cfv csm co vy cv
      vw cv cB cA cort cfv cpj cfv cfv csm co hvadd4 vw cv cc wcel vw cv cneg
      cB cA cpj cfv cfv csm co chil wcel vw cv cB cA cpj cfv cfv csm co chil
      wcel wa vy cv cA wcel vw cv cc wcel vw cv cneg cB cA cpj cfv cfv csm co
      chil wcel vw cv cB cA cpj cfv cfv csm co chil wcel vw cv cc wcel vw cv
      cneg cc wcel vw cv cneg cB cA cpj cfv cfv csm co chil wcel vw cv negcl vw
      cv cneg cc wcel cB cA cpj cfv cfv chil wcel vw cv cneg cB cA cpj cfv cfv
      csm co chil wcel cB cA spanunsn.1 spanunsn.2 pjhclii vw cv cneg cB cA cpj
      cfv cfv hvmulcl mpan2 syl vw cv cc wcel cB cA cpj cfv cfv chil wcel vw cv
      cB cA cpj cfv cfv csm co chil wcel cB cA spanunsn.1 spanunsn.2 pjhclii vw
      cv cB cA cpj cfv cfv hvmulcl mpan2 jca adantl vy cv cA wcel vy cv chil
      wcel vw cv cc wcel vw cv cB cA cort cfv cpj cfv cfv csm co chil wcel vy
      cv cA spanunsn.1 cheli vw cv cc wcel cB cA cort cfv cpj cfv cfv chil wcel
      vw cv cB cA cort cfv cpj cfv cfv csm co chil wcel cB cA cort cfv cA
      spanunsn.1 choccli spanunsn.2 pjhclii vw cv cB cA cort cfv cpj cfv cfv
      hvmulcl mpan2 anim12i sylanc 3eqtr3d vy cv cA wcel vw cv cc wcel wa vw cv
      cB csm co vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv
      csm co cva co vw cv cneg cB cA cpj cfv cfv csm co vy cv cva co cva vw cv
      cc wcel vw cv cB csm co vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort
      cfv cpj cfv cfv csm co cva co wceq vy cv cA wcel vw cv cc wcel vw cv cB
      cA cpj cfv cfv cB cA cort cfv cpj cfv cfv cva co csm co vw cv cB cA cpj
      cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv csm co cva co vw cv cB
      csm co vw cv cc wcel cB cA cpj cfv cfv chil wcel cB cA cort cfv cpj cfv
      cfv chil wcel vw cv cB cA cpj cfv cfv cB cA cort cfv cpj cfv cfv cva co
      csm co vw cv cB cA cpj cfv cfv csm co vw cv cB cA cort cfv cpj cfv cfv
      csm co cva co wceq cB cA spanunsn.1 spanunsn.2 pjhclii cB cA cort cfv cA
      spanunsn.1 choccli spanunsn.2 pjhclii vw cv cB cA cpj cfv cfv cB cA cort
      cfv cpj cfv cfv ax-hvdistr1 mp3an23 cB cB cA cpj cfv cfv cB cA cort cfv
      cpj cfv cfv cva co vw cv csm cB cA spanunsn.1 spanunsn.2 pjpji opreq2i
      syl5eq adantl opreq2d eqtr4d syl3anc vv vu cA cB csn cspn cfv vy cv vw cv
      cB cA cort cfv cpj cfv cfv csm co cva co cA spanunsn.1 chshii cB csn chil
      wss cB csn cspn cfv csh wcel cB chil wcel cB csn chil wss spanunsn.2 cB
      chil snssi ax-mp cB csn spancl ax-mp shseli sylibr vz cv vw cv cB cA cort
      cfv cpj cfv cfv csm co wceq vx cv vy cv vz cv cva co wceq vx cv vy cv vw
      cv cB cA cort cfv cpj cfv cfv csm co cva co wceq vz cv vw cv cB cA cort
      cfv cpj cfv cfv csm co wceq vy cv vz cv cva co vy cv vw cv cB cA cort cfv
      cpj cfv cfv csm co cva co vx cv vz cv vw cv cB cA cort cfv cpj cfv cfv
      csm co vy cv cva opreq2 eqeq2d biimpa syl2an exp43 r19.23adv vw cB cA
      cort cfv cpj cfv cfv vz cv cB cA cort cfv cA spanunsn.1 choccli
      spanunsn.2 pjhclii elspansni syl5ib r19.23adv r19.23aiv sylbi impbii
      eqriv cA cB csn cun cspn cfv cA cspn cfv cB csn cspn cfv cph co cA cB csn
      cspn cfv cph co cA cB csn cA spanunsn.1 chssii cB chil wcel cB csn chil
      wss spanunsn.2 cB chil snssi ax-mp spanuni cA cspn cfv cA cB csn cspn cfv
      cph cA csh wcel cA cspn cfv cA wceq cA spanunsn.1 chshii cA spanid ax-mp
      opreq1i eqtri cA cB cA cort cfv cpj cfv cfv csn cun cspn cfv cA cspn cfv
      cB cA cort cfv cpj cfv cfv csn cspn cfv cph co cA cB cA cort cfv cpj cfv
      cfv csn cspn cfv cph co cA cB cA cort cfv cpj cfv cfv csn cA spanunsn.1
      chssii cB cA cort cfv cpj cfv cfv chil wcel cB cA cort cfv cpj cfv cfv
      csn chil wss cB cA cort cfv cA spanunsn.1 choccli spanunsn.2 pjhclii cB
      cA cort cfv cpj cfv cfv chil snssi ax-mp spanuni cA cspn cfv cA cB cA
      cort cfv cpj cfv cfv csn cspn cfv cph cA csh wcel cA cspn cfv cA wceq cA
      spanunsn.1 chshii cA spanid ax-mp opreq1i eqtri 3eqtr4i $.
      $( [6-Jul-2004] $) $( [3-Jun-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The span of a pair of vectors. $)
    spanpr $p |- ( ( A e. ~H /\ B e. ~H ) ->
                 ( span ` { ( A +h B ) } ) C_ ( span ` { A , B } ) ) $=
      cA chil wcel cB chil wcel wa cA cB cva co csn cspn cfv cA csn cspn cfv cB
      csn cspn cfv cph co cA cB cpr cspn cfv cA chil wcel cB chil wcel wa vx cA
      cB cva co csn cspn cfv cA csn cspn cfv cB csn cspn cfv cph co cA chil
      wcel cB chil wcel wa vx cv cA cB cva co csn cspn cfv wcel vx cv cA csn
      cspn cfv cB csn cspn cfv cph co wcel cA csn cspn cfv cB csn cspn cfv cph
      co csh wcel cA cB cva co cA csn cspn cfv cB csn cspn cfv cph co wcel vx
      cv cA cB cva co csn cspn cfv wcel vx cv cA csn cspn cfv cB csn cspn cfv
      cph co wcel cA chil wcel cB chil wcel wa vx cv cA cB cva co csn cspn cfv
      wcel wa cA csn cspn cfv cB csn cspn cfv cph co cA cB cva co vx cv
      elspansn3 cA chil wcel cB chil wcel wa cA csn cspn cfv cB csn cspn cfv
      cph co csh wcel vx cv cA cB cva co csn cspn cfv wcel cA csn cspn cfv csh
      wcel cB csn cspn cfv csh wcel cA csn cspn cfv cB csn cspn cfv cph co csh
      wcel cA chil wcel cB chil wcel cA csn cspn cfv cB csn cspn cfv shscl cA
      spansnsh cB spansnsh syl2an adantr cA chil wcel cB chil wcel wa cA cB cva
      co cA csn cspn cfv cB csn cspn cfv cph co wcel vx cv cA cB cva co csn
      cspn cfv wcel cA csn cspn cfv csh wcel cB csn cspn cfv csh wcel wa cA cA
      csn cspn cfv wcel cB cB csn cspn cfv wcel wa cA cB cva co cA csn cspn cfv
      cB csn cspn cfv cph co wcel cA chil wcel cB chil wcel wa cA csn cspn cfv
      cB csn cspn cfv cA cB shsva cA chil wcel cA csn cspn cfv csh wcel cB chil
      wcel cB csn cspn cfv csh wcel cA spansnsh cB spansnsh anim12i cA chil
      wcel cA cA csn cspn cfv wcel cB chil wcel cB cB csn cspn cfv wcel cA
      spansnid cB spansnid anim12i sylc adantr cA chil wcel cB chil wcel wa vx
      cv cA cB cva co csn cspn cfv wcel pm3.27 syl3anc ex ssrdv cA chil wcel cB
      chil wcel wa cA csn cB csn cun cspn cfv cA csn cspn cfv cB csn cspn cfv
      cph co cA cB cpr cspn cfv cA csn chil wss cB csn chil wss cA csn cB csn
      cun cspn cfv cA csn cspn cfv cB csn cspn cfv cph co wceq cA chil wcel cB
      chil wcel cA csn cB csn spanun cA chil snssi cB chil snssi syl2an cA cB
      cpr cA csn cB csn cun cspn cA cB df-pr fveq2i syl5req sseqtrd $.
      $( [19-Jun-2006] $) $( [9-Jun-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    h1datom.1 $e |- A e. CH $.
    h1datom.2 $e |- B e. ~H $.
    $( A 1-dimensional subspace is an atom. $)
    h1datomi $p |- ( A C_ ( _|_ ` ( _|_ ` { B } ) ) ->
                  ( A = ( _|_ ` ( _|_ ` { B } ) ) \/ A = 0H ) ) $=
      cA cB csn cort cfv cort cfv wss cA cB csn cort cfv cort cfv wne cA c0h
      wceq wi cA cB csn cort cfv cort cfv wceq cA c0h wceq wo cA cB csn cort
      cfv cort cfv wss cA c0h cA cB csn cort cfv cort cfv cA cB csn cort cfv
      cort cfv wss cA c0h wne cA cB csn cort cfv cort cfv wss cB csn cort cfv
      cort cfv cA wss wa cA cB csn cort cfv cort cfv wceq cA cB csn cort cfv
      cort cfv wss cA c0h wne cB csn cort cfv cort cfv cA wss cA cB csn cort
      cfv cort cfv wss cA c0h wne cB cA wcel cB csn cort cfv cort cfv cA wss cA
      cB csn cort cfv cort cfv wss vx cv c0v wne vx cA wrex cB cA wcel cA c0h
      wne cA cB csn cort cfv cort cfv wss vx cv c0v wne cB cA wcel vx cA cA cB
      csn cort cfv cort cfv wss vx cv cA wcel vx cv cB csn cort cfv cort cfv
      wcel vx cv c0v wne cB cA wcel wi cA cB csn cort cfv cort cfv vx cv ssel
      vx cv cA wcel vx cv vy cv cB csm co wceq vy cc wrex vx cv c0v wne cB cA
      wcel wi vx cv cB csn cort cfv cort cfv wcel vx cv cA wcel vx cv vy cv cB
      csm co wceq vx cv c0v wne cB cA wcel wi vy cc vx cv cA wcel vy cv cc wcel
      vx cv vy cv cB csm co wceq vx cv c0v wne cB cA wcel wi vy cv cc wcel vx
      cv vy cv cB csm co wceq wa vx cv c0v wne vx cv cA wcel cB cA wcel vy cv
      cc wcel vx cv vy cv cB csm co wceq wa vx cv c0v wne vy cv cc0 wne vx cv
      cA wcel cB cA wcel wi vx cv vy cv cB csm co wceq vx cv c0v wne vy cv cc0
      wne wi vy cv cc wcel vx cv vy cv cB csm co wceq vy cv cc0 vx cv c0v vx cv
      vy cv cB csm co wceq vx cv c0v wceq vy cv cB csm co c0v wceq vy cv cc0
      wceq vx cv vy cv cB csm co c0v eqeq1 vy cv cc0 wceq vy cv cB csm co cc0
      cB csm co c0v vy cv cc0 cB csm opreq1 cB chil wcel cc0 cB csm co c0v wceq
      h1datom.2 cB ax-hvmul0 ax-mp syl6eq syl5bir necon3d adantl vy cv cc wcel
      vx cv vy cv cB csm co wceq vy cv cc0 wne vx cv cA wcel cB cA wcel wi wi
      vy cv cc wcel vy cv cc0 wne vx cv vy cv cB csm co wceq vx cv cA wcel cB
      cA wcel wi vy cv cc wcel vy cv cc0 wne vx cv vy cv cB csm co wceq vx cv
      cA wcel cB cA wcel wi vy cv cc wcel vy cv cc0 wne wa vx cv vy cv cB csm
      co wceq wa vx cv cA wcel c1 vy cv cdiv co vx cv csm co cA wcel cB cA wcel
      vy cv cc wcel vy cv cc0 wne wa vx cv cA wcel c1 vy cv cdiv co vx cv csm
      co cA wcel wi vx cv vy cv cB csm co wceq vy cv cc wcel vy cv cc0 wne wa
      c1 vy cv cdiv co cc wcel vx cv cA wcel c1 vy cv cdiv co vx cv csm co cA
      wcel wi vy cv reccl c1 vy cv cdiv co cc wcel vx cv cA wcel c1 vy cv cdiv
      co vx cv csm co cA wcel cA csh wcel c1 vy cv cdiv co cc wcel vx cv cA
      wcel c1 vy cv cdiv co vx cv csm co cA wcel cA h1datom.1 chshii c1 vy cv
      cdiv co vx cv cA shmulcl mp3an1 ex syl adantr vy cv cc wcel vy cv cc0 wne
      wa vx cv vy cv cB csm co wceq wa c1 vy cv cdiv co vx cv csm co cB cA vx
      cv vy cv cB csm co wceq vy cv cc wcel vy cv cc0 wne wa c1 vy cv cdiv co
      vx cv csm co c1 vy cv cdiv co vy cv cB csm co csm co cB vx cv vy cv cB
      csm co c1 vy cv cdiv co csm opreq2 vy cv cc wcel vy cv cc0 wne wa c1 vy
      cv cdiv co vy cv cB csm co csm co c1 cB csm co cB vy cv cc wcel vy cv cc0
      wne wa c1 vy cv cdiv co vy cv cmul co cB csm co c1 vy cv cdiv co vy cv cB
      csm co csm co c1 cB csm co c1 vy cv cdiv co cc wcel vy cv cc wcel c1 vy
      cv cdiv co vy cv cmul co cB csm co c1 vy cv cdiv co vy cv cB csm co csm
      co wceq vy cv cc wcel vy cv cc0 wne wa c1 vy cv cdiv co cc wcel vy cv cc
      wcel cB chil wcel c1 vy cv cdiv co vy cv cmul co cB csm co c1 vy cv cdiv
      co vy cv cB csm co csm co wceq h1datom.2 c1 vy cv cdiv co vy cv cB
      ax-hvmulass mp3an3 vy cv reccl vy cv cc wcel vy cv cc0 wne pm3.26 sylanc
      vy cv cc wcel vy cv cc0 wne wa c1 vy cv cdiv co vy cv cmul co c1 cB csm
      vy cv recid2 opreq1d eqtr3d cB chil wcel c1 cB csm co cB wceq h1datom.2
      cB ax-hvmulid ax-mp syl6eq sylan9eqr eleq1d sylibd exp31 com23 imp syld
      com3r exp3a r19.23adv vy vx cv cB h1datom.2 h1de2ci syl5ib sylcom
      r19.23adv vx cA h1datom.1 chne0i syl5ib cB cA wcel cB csn cort cfv cort
      cfv cA cort cfv cort cfv cA cB cA wcel cB csn cA wss cB csn cort cfv cort
      cfv cA cort cfv cort cfv wss cB cA snssi cB csn cA cB chil wcel cB csn
      chil wss h1datom.2 cB chil snssi ax-mp cA h1datom.1 chssii occon2i syl cA
      h1datom.1 ococi syl6ss syl6 anc2li cA cB csn cort cfv cort cfv eqss
      syl6ibr necon1d cA c0h wceq cA cB csn cort cfv cort cfv neor sylibr $.
      $( [20-Jul-2001] $)
  $}

  $( A 1-dimensional subspace is an atom. $)
  h1datom $p |- ( ( A e. CH /\ B e. ~H ) ->
                ( A C_ ( _|_ ` ( _|_ ` { B } ) ) ->
                ( A = ( _|_ ` ( _|_ ` { B } ) ) \/ A = 0H ) ) ) $=
    cA cch wcel cB chil wcel cA cB csn cort cfv cort cfv wss cA cB csn cort cfv
    cort cfv wceq cA c0h wceq wo wi cA cch wcel cA c0h cif cB csn cort cfv cort
    cfv wss cA cch wcel cA c0h cif cB csn cort cfv cort cfv wceq cA cch wcel cA
    c0h cif c0h wceq wo wi cA cch wcel cA c0h cif cB chil wcel cB c0v cif csn
    cort cfv cort cfv wss cA cch wcel cA c0h cif cB chil wcel cB c0v cif csn
    cort cfv cort cfv wceq cA cch wcel cA c0h cif c0h wceq wo wi cA cB c0h c0v
    cA cA cch wcel cA c0h cif wceq cA cB csn cort cfv cort cfv wss cA cch wcel
    cA c0h cif cB csn cort cfv cort cfv wss cA cB csn cort cfv cort cfv wceq cA
    c0h wceq wo cA cch wcel cA c0h cif cB csn cort cfv cort cfv wceq cA cch
    wcel cA c0h cif c0h wceq wo cA cA cch wcel cA c0h cif cB csn cort cfv cort
    cfv sseq1 cA cA cch wcel cA c0h cif wceq cA cB csn cort cfv cort cfv wceq
    cA cch wcel cA c0h cif cB csn cort cfv cort cfv wceq cA c0h wceq cA cch
    wcel cA c0h cif c0h wceq cA cA cch wcel cA c0h cif cB csn cort cfv cort cfv
    eqeq1 cA cA cch wcel cA c0h cif c0h eqeq1 orbi12d imbi12d cB cB chil wcel
    cB c0v cif wceq cA cch wcel cA c0h cif cB csn cort cfv cort cfv wss cA cch
    wcel cA c0h cif cB chil wcel cB c0v cif csn cort cfv cort cfv wss cA cch
    wcel cA c0h cif cB csn cort cfv cort cfv wceq cA cch wcel cA c0h cif c0h
    wceq wo cA cch wcel cA c0h cif cB chil wcel cB c0v cif csn cort cfv cort
    cfv wceq cA cch wcel cA c0h cif c0h wceq wo cB cB chil wcel cB c0v cif wceq
    cB csn cort cfv cort cfv cB chil wcel cB c0v cif csn cort cfv cort cfv cA
    cch wcel cA c0h cif cB cB chil wcel cB c0v cif wceq cB csn cort cfv cB chil
    wcel cB c0v cif csn cort cfv cort cB cB chil wcel cB c0v cif wceq cB csn cB
    chil wcel cB c0v cif csn cort cB cB chil wcel cB c0v cif sneq fveq2d fveq2d
    sseq2d cB cB chil wcel cB c0v cif wceq cA cch wcel cA c0h cif cB csn cort
    cfv cort cfv wceq cA cch wcel cA c0h cif cB chil wcel cB c0v cif csn cort
    cfv cort cfv wceq cA cch wcel cA c0h cif c0h wceq cB cB chil wcel cB c0v
    cif wceq cB csn cort cfv cort cfv cB chil wcel cB c0v cif csn cort cfv cort
    cfv cA cch wcel cA c0h cif cB cB chil wcel cB c0v cif wceq cB csn cort cfv
    cB chil wcel cB c0v cif csn cort cfv cort cB cB chil wcel cB c0v cif wceq
    cB csn cB chil wcel cB c0v cif csn cort cB cB chil wcel cB c0v cif sneq
    fveq2d fveq2d eqeq2d orbi1d imbi12d cA cch wcel cA c0h cif cB chil wcel cB
    c0v cif cA c0h cch h0elch elimel cB c0v chil ax-hv0cl elimel h1datomi
    dedth2h $.
    $( [22-Jul-2001] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Operator sum, difference, and scalar multiplication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g h x y $.
    $( Define the sum of two Hilbert space operators.  Definition of [Beran]
       p. 111.

      _Note on operators_.  Unlike some authors, we use the term "operator" to
      mean any function from ` ~H ` to ` ~H ` .  This is the definition of
      operator in [Hughes] p. 14, the definition of operator in
      [AkhiezerGlazman] p. 30, and the definition of operator in [Goldberg]
      p. 10.  For Reed and Simon, an operator is linear (definition of
      operator in [ReedSimon] p. 2).  For Halmos, an operator is bounded and
      linear (definition of operator in [Halmos] p. 35).  For Kalmbach and
      Beran, an operator is continuous and linear (definition of operator in
      [Kalmbach] p. 353; definition of operator in [Beran] p. 99).  Note that
      "bounded and linear" and "continuous and linear" are equivalent by
      ~ lncnbd . $)
    df-hosum $a |- +op = { <. <. f , g >. , h >. | ( ( f : ~H --> ~H /\
          g : ~H --> ~H ) /\
          h = { <. x , y >. | ( x e. ~H /\
           y = ( ( f ` x ) +h ( g ` x ) ) ) } ) } $.

    $( Define the scalar product with a Hilbert space operator.  Definition of
       [Beran] p. 111. $)
    df-homul $a |- .op = { <. <. f , g >. , h >. | ( ( f e. CC /\
          g : ~H --> ~H ) /\
          h = { <. x , y >. | ( x e. ~H /\
           y = ( f .h ( g ` x ) ) ) } ) } $.

$(
    @( Define the difference of two Hilbert space operators.  Definition of
       [Beran] p. 111. @)
    df-hodif @a |- -op = { <. <. f , g >. , h >. | ( ( f : ~H --> ~H /\
          g : ~H --> ~H ) /\ h = ( f +op ( -u 1 .op g ) ) ) } @.
$)

    $( Define the difference of two Hilbert space operators.  Definition of
       [Beran] p. 111. $)
    df-hodif $a |- -op = { <. <. f , g >. , h >. | ( ( f : ~H --> ~H /\
          g : ~H --> ~H ) /\
          h = { <. x , y >. | ( x e. ~H /\
           y = ( ( f ` x ) -h ( g ` x ) ) ) } ) } $.

    $( Define the sum of two Hilbert space functionals.  Definition of [Beran]
       p. 111.  Note that unlike some authors, we define a functional as any
       function from ` ~H ` to ` CC ` , not just linear (or bounded linear)
       ones. $)
    df-hfsum $a |- +fn = { <. <. f , g >. , h >. | ( ( f : ~H --> CC /\
          g : ~H --> CC ) /\
          h = { <. x , y >. | ( x e. ~H /\
           y = ( ( f ` x ) + ( g ` x ) ) ) } ) } $.

    $( Define the scalar product with a Hilbert space functional.  Definition
       of [Beran] p. 111. $)
    df-hfmul $a |- .fn = { <. <. f , g >. , h >. | ( ( f e. CC /\
          g : ~H --> CC ) /\
          h = { <. x , y >. | ( x e. ~H /\
           y = ( f x. ( g ` x ) ) ) } ) } $.
  $}

  ${
    $d f g h x y A $.  $d x y f g h S $.  $d x y f g h T $.
    $( Value of the sum of two Hilbert space operators. $)
    hosmval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( S +op T ) =
        { <. x , y >. | ( x e. ~H /\ y = ( ( S ` x ) +h ( T ` x ) ) ) } ) $=
      cS chil chil cm co wcel cT chil chil cm co wcel cS cT chos co vx cv chil
      wcel vy cv vx cv cS cfv vx cv cT cfv cva co wceq wa vx vy copab wceq chil
      chil cS wf chil chil cT wf vf vg vh cS cT chil chil cm co chil chil cm co
      vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv cva co wceq wa vx
      vy copab vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co wceq wa
      vx vy copab chos vx cv chil wcel vy cv vx cv cS cfv vx cv vg cv cfv cva
      co wceq wa vx vy copab vx vy chil vx cv cS cfv vx cv cT cfv cva co
      ax-hilex opabex2 vf cv cS wceq vx cv chil wcel vy cv vx cv vf cv cfv vx
      cv vg cv cfv cva co wceq wa vx cv chil wcel vy cv vx cv cS cfv vx cv vg
      cv cfv cva co wceq wa vx vy vf cv cS wceq vy cv vx cv vf cv cfv vx cv vg
      cv cfv cva co wceq vy cv vx cv cS cfv vx cv vg cv cfv cva co wceq vx cv
      chil wcel vf cv cS wceq vx cv vf cv cfv vx cv vg cv cfv cva co vx cv cS
      cfv vx cv vg cv cfv cva co vy cv vf cv cS wceq vx cv vf cv cfv vx cv cS
      cfv vx cv vg cv cfv cva vx cv vf cv cS fveq1 opreq1d eqeq2d anbi2d
      opabbidv vg cv cT wceq vx cv chil wcel vy cv vx cv cS cfv vx cv vg cv cfv
      cva co wceq wa vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co
      wceq wa vx vy vg cv cT wceq vy cv vx cv cS cfv vx cv vg cv cfv cva co
      wceq vy cv vx cv cS cfv vx cv cT cfv cva co wceq vx cv chil wcel vg cv cT
      wceq vx cv cS cfv vx cv vg cv cfv cva co vx cv cS cfv vx cv cT cfv cva co
      vy cv vg cv cT wceq vx cv vg cv cfv vx cv cT cfv vx cv cS cfv cva vx cv
      vg cv cT fveq1 opreq2d eqeq2d anbi2d opabbidv chos chil chil vf cv wf
      chil chil vg cv wf wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv
      vg cv cfv cva co wceq wa vx vy copab wceq wa vf vg vh copab2 vf cv chil
      chil cm co wcel vg cv chil chil cm co wcel wa vh cv vx cv chil wcel vy cv
      vx cv vf cv cfv vx cv vg cv cfv cva co wceq wa vx vy copab wceq wa vf vg
      vh copab2 vx vy vf vg vh df-hosum vf cv chil chil cm co wcel vg cv chil
      chil cm co wcel wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg
      cv cfv cva co wceq wa vx vy copab wceq wa chil chil vf cv wf chil chil vg
      cv wf wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv cva
      co wceq wa vx vy copab wceq wa vf vg vh vf cv chil chil cm co wcel vg cv
      chil chil cm co wcel wa chil chil vf cv wf chil chil vg cv wf wa vh cv vx
      cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv cva co wceq wa vx vy
      copab wceq vf cv chil chil cm co wcel chil chil vf cv wf vg cv chil chil
      cm co wcel chil chil vg cv wf chil chil vf cv ax-hilex ax-hilex elmap
      chil chil vg cv ax-hilex ax-hilex elmap anbi12i anbi1i oprabbii eqtr4i
      oprabval2 chil chil cS ax-hilex ax-hilex elmap chil chil cT ax-hilex
      ax-hilex elmap syl2anbr $.
      $( [9-Nov-2000] $)

    $( Value of the scalar product with a Hilbert space operator. $)
    hommval $p |- ( ( A e. CC /\ T : ~H --> ~H ) -> ( A .op T ) =
        { <. x , y >. | ( x e. ~H /\ y = ( A .h ( T ` x ) ) ) } ) $=
      cA cc wcel cT chil chil cm co wcel cA cT chot co vx cv chil wcel vy cv cA
      vx cv cT cfv csm co wceq wa vx vy copab wceq chil chil cT wf vf vg vh cA
      cT cc chil chil cm co vx cv chil wcel vy cv vf cv vx cv vg cv cfv csm co
      wceq wa vx vy copab vx cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa
      vx vy copab chot vx cv chil wcel vy cv cA vx cv vg cv cfv csm co wceq wa
      vx vy copab vx vy chil cA vx cv cT cfv csm co ax-hilex opabex2 vf cv cA
      wceq vx cv chil wcel vy cv vf cv vx cv vg cv cfv csm co wceq wa vx cv
      chil wcel vy cv cA vx cv vg cv cfv csm co wceq wa vx vy vf cv cA wceq vy
      cv vf cv vx cv vg cv cfv csm co wceq vy cv cA vx cv vg cv cfv csm co wceq
      vx cv chil wcel vf cv cA wceq vf cv vx cv vg cv cfv csm co cA vx cv vg cv
      cfv csm co vy cv vf cv cA vx cv vg cv cfv csm opreq1 eqeq2d anbi2d
      opabbidv vg cv cT wceq vx cv chil wcel vy cv cA vx cv vg cv cfv csm co
      wceq wa vx cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy vg cv
      cT wceq vy cv cA vx cv vg cv cfv csm co wceq vy cv cA vx cv cT cfv csm co
      wceq vx cv chil wcel vg cv cT wceq cA vx cv vg cv cfv csm co cA vx cv cT
      cfv csm co vy cv vg cv cT wceq vx cv vg cv cfv vx cv cT cfv cA csm vx cv
      vg cv cT fveq1 opreq2d eqeq2d anbi2d opabbidv chot vf cv cc wcel chil
      chil vg cv wf wa vh cv vx cv chil wcel vy cv vf cv vx cv vg cv cfv csm co
      wceq wa vx vy copab wceq wa vf vg vh copab2 vf cv cc wcel vg cv chil chil
      cm co wcel wa vh cv vx cv chil wcel vy cv vf cv vx cv vg cv cfv csm co
      wceq wa vx vy copab wceq wa vf vg vh copab2 vx vy vf vg vh df-homul vf cv
      cc wcel vg cv chil chil cm co wcel wa vh cv vx cv chil wcel vy cv vf cv
      vx cv vg cv cfv csm co wceq wa vx vy copab wceq wa vf cv cc wcel chil
      chil vg cv wf wa vh cv vx cv chil wcel vy cv vf cv vx cv vg cv cfv csm co
      wceq wa vx vy copab wceq wa vf vg vh vf cv cc wcel vg cv chil chil cm co
      wcel wa vf cv cc wcel chil chil vg cv wf wa vh cv vx cv chil wcel vy cv
      vf cv vx cv vg cv cfv csm co wceq wa vx vy copab wceq vg cv chil chil cm
      co wcel chil chil vg cv wf vf cv cc wcel chil chil vg cv ax-hilex
      ax-hilex elmap anbi2i anbi1i oprabbii eqtr4i oprabval2 chil chil cT
      ax-hilex ax-hilex elmap sylan2br $.
      $( [19-Mar-2006] $) $( [20-Feb-2006] $)

    $( Value of the difference of two Hilbert space operators. $)
    hodmval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( S -op T ) =
        { <. x , y >. | ( x e. ~H /\ y = ( ( S ` x ) -h ( T ` x ) ) ) } ) $=
      cS chil chil cm co wcel cT chil chil cm co wcel cS cT chod co vx cv chil
      wcel vy cv vx cv cS cfv vx cv cT cfv cmv co wceq wa vx vy copab wceq chil
      chil cS wf chil chil cT wf vf vg vh cS cT chil chil cm co chil chil cm co
      vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv cmv co wceq wa vx
      vy copab vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cmv co wceq wa
      vx vy copab chod vx cv chil wcel vy cv vx cv cS cfv vx cv vg cv cfv cmv
      co wceq wa vx vy copab vx vy chil vx cv cS cfv vx cv cT cfv cmv co
      ax-hilex opabex2 vf cv cS wceq vx cv chil wcel vy cv vx cv vf cv cfv vx
      cv vg cv cfv cmv co wceq wa vx cv chil wcel vy cv vx cv cS cfv vx cv vg
      cv cfv cmv co wceq wa vx vy vf cv cS wceq vy cv vx cv vf cv cfv vx cv vg
      cv cfv cmv co wceq vy cv vx cv cS cfv vx cv vg cv cfv cmv co wceq vx cv
      chil wcel vf cv cS wceq vx cv vf cv cfv vx cv vg cv cfv cmv co vx cv cS
      cfv vx cv vg cv cfv cmv co vy cv vf cv cS wceq vx cv vf cv cfv vx cv cS
      cfv vx cv vg cv cfv cmv vx cv vf cv cS fveq1 opreq1d eqeq2d anbi2d
      opabbidv vg cv cT wceq vx cv chil wcel vy cv vx cv cS cfv vx cv vg cv cfv
      cmv co wceq wa vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cmv co
      wceq wa vx vy vg cv cT wceq vy cv vx cv cS cfv vx cv vg cv cfv cmv co
      wceq vy cv vx cv cS cfv vx cv cT cfv cmv co wceq vx cv chil wcel vg cv cT
      wceq vx cv cS cfv vx cv vg cv cfv cmv co vx cv cS cfv vx cv cT cfv cmv co
      vy cv vg cv cT wceq vx cv vg cv cfv vx cv cT cfv vx cv cS cfv cmv vx cv
      vg cv cT fveq1 opreq2d eqeq2d anbi2d opabbidv chod chil chil vf cv wf
      chil chil vg cv wf wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv
      vg cv cfv cmv co wceq wa vx vy copab wceq wa vf vg vh copab2 vf cv chil
      chil cm co wcel vg cv chil chil cm co wcel wa vh cv vx cv chil wcel vy cv
      vx cv vf cv cfv vx cv vg cv cfv cmv co wceq wa vx vy copab wceq wa vf vg
      vh copab2 vx vy vf vg vh df-hodif vf cv chil chil cm co wcel vg cv chil
      chil cm co wcel wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg
      cv cfv cmv co wceq wa vx vy copab wceq wa chil chil vf cv wf chil chil vg
      cv wf wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv cmv
      co wceq wa vx vy copab wceq wa vf vg vh vf cv chil chil cm co wcel vg cv
      chil chil cm co wcel wa chil chil vf cv wf chil chil vg cv wf wa vh cv vx
      cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv cmv co wceq wa vx vy
      copab wceq vf cv chil chil cm co wcel chil chil vf cv wf vg cv chil chil
      cm co wcel chil chil vg cv wf chil chil vf cv ax-hilex ax-hilex elmap
      chil chil vg cv ax-hilex ax-hilex elmap anbi12i anbi1i oprabbii eqtr4i
      oprabval2 chil chil cS ax-hilex ax-hilex elmap chil chil cT ax-hilex
      ax-hilex elmap syl2anbr $.
      $( [9-Nov-2000] $)

    $( Value of the sum of two Hilbert space functionals. $)
    hfsmval $p |- ( ( S : ~H --> CC /\ T : ~H --> CC ) -> ( S +fn T ) =
        { <. x , y >. | ( x e. ~H /\ y = ( ( S ` x ) + ( T ` x ) ) ) } ) $=
      cS cc chil cm co wcel cT cc chil cm co wcel cS cT chfs co vx cv chil wcel
      vy cv vx cv cS cfv vx cv cT cfv caddc co wceq wa vx vy copab wceq chil cc
      cS wf chil cc cT wf vf vg vh cS cT cc chil cm co cc chil cm co vx cv chil
      wcel vy cv vx cv vf cv cfv vx cv vg cv cfv caddc co wceq wa vx vy copab
      vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv caddc co wceq wa vx vy
      copab chfs vx cv chil wcel vy cv vx cv cS cfv vx cv vg cv cfv caddc co
      wceq wa vx vy copab vx vy chil vx cv cS cfv vx cv cT cfv caddc co
      ax-hilex opabex2 vf cv cS wceq vx cv chil wcel vy cv vx cv vf cv cfv vx
      cv vg cv cfv caddc co wceq wa vx cv chil wcel vy cv vx cv cS cfv vx cv vg
      cv cfv caddc co wceq wa vx vy vf cv cS wceq vy cv vx cv vf cv cfv vx cv
      vg cv cfv caddc co wceq vy cv vx cv cS cfv vx cv vg cv cfv caddc co wceq
      vx cv chil wcel vf cv cS wceq vx cv vf cv cfv vx cv vg cv cfv caddc co vx
      cv cS cfv vx cv vg cv cfv caddc co vy cv vf cv cS wceq vx cv vf cv cfv vx
      cv cS cfv vx cv vg cv cfv caddc vx cv vf cv cS fveq1 opreq1d eqeq2d
      anbi2d opabbidv vg cv cT wceq vx cv chil wcel vy cv vx cv cS cfv vx cv vg
      cv cfv caddc co wceq wa vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv
      caddc co wceq wa vx vy vg cv cT wceq vy cv vx cv cS cfv vx cv vg cv cfv
      caddc co wceq vy cv vx cv cS cfv vx cv cT cfv caddc co wceq vx cv chil
      wcel vg cv cT wceq vx cv cS cfv vx cv vg cv cfv caddc co vx cv cS cfv vx
      cv cT cfv caddc co vy cv vg cv cT wceq vx cv vg cv cfv vx cv cT cfv vx cv
      cS cfv caddc vx cv vg cv cT fveq1 opreq2d eqeq2d anbi2d opabbidv chfs
      chil cc vf cv wf chil cc vg cv wf wa vh cv vx cv chil wcel vy cv vx cv vf
      cv cfv vx cv vg cv cfv caddc co wceq wa vx vy copab wceq wa vf vg vh
      copab2 vf cv cc chil cm co wcel vg cv cc chil cm co wcel wa vh cv vx cv
      chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv caddc co wceq wa vx vy
      copab wceq wa vf vg vh copab2 vx vy vf vg vh df-hfsum vf cv cc chil cm co
      wcel vg cv cc chil cm co wcel wa vh cv vx cv chil wcel vy cv vx cv vf cv
      cfv vx cv vg cv cfv caddc co wceq wa vx vy copab wceq wa chil cc vf cv wf
      chil cc vg cv wf wa vh cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg
      cv cfv caddc co wceq wa vx vy copab wceq wa vf vg vh vf cv cc chil cm co
      wcel vg cv cc chil cm co wcel wa chil cc vf cv wf chil cc vg cv wf wa vh
      cv vx cv chil wcel vy cv vx cv vf cv cfv vx cv vg cv cfv caddc co wceq wa
      vx vy copab wceq vf cv cc chil cm co wcel chil cc vf cv wf vg cv cc chil
      cm co wcel chil cc vg cv wf cc chil vf cv axcnex ax-hilex elmap cc chil
      vg cv axcnex ax-hilex elmap anbi12i anbi1i oprabbii eqtr4i oprabval2 cc
      chil cS axcnex ax-hilex elmap cc chil cT axcnex ax-hilex elmap syl2anbr
      $.
      $( [27-Jun-2006] $) $( [23-May-2006] $)

    $( Value of the scalar product with a Hilbert space functional. $)
    hfmmval $p |- ( ( A e. CC /\ T : ~H --> CC ) -> ( A .fn T ) =
        { <. x , y >. | ( x e. ~H /\ y = ( A x. ( T ` x ) ) ) } ) $=
      cA cc wcel cT cc chil cm co wcel cA cT chft co vx cv chil wcel vy cv cA
      vx cv cT cfv cmul co wceq wa vx vy copab wceq chil cc cT wf vf vg vh cA
      cT cc cc chil cm co vx cv chil wcel vy cv vf cv vx cv vg cv cfv cmul co
      wceq wa vx vy copab vx cv chil wcel vy cv cA vx cv cT cfv cmul co wceq wa
      vx vy copab chft vx cv chil wcel vy cv cA vx cv vg cv cfv cmul co wceq wa
      vx vy copab vx vy chil cA vx cv cT cfv cmul co ax-hilex opabex2 vf cv cA
      wceq vx cv chil wcel vy cv vf cv vx cv vg cv cfv cmul co wceq wa vx cv
      chil wcel vy cv cA vx cv vg cv cfv cmul co wceq wa vx vy vf cv cA wceq vy
      cv vf cv vx cv vg cv cfv cmul co wceq vy cv cA vx cv vg cv cfv cmul co
      wceq vx cv chil wcel vf cv cA wceq vf cv vx cv vg cv cfv cmul co cA vx cv
      vg cv cfv cmul co vy cv vf cv cA vx cv vg cv cfv cmul opreq1 eqeq2d
      anbi2d opabbidv vg cv cT wceq vx cv chil wcel vy cv cA vx cv vg cv cfv
      cmul co wceq wa vx cv chil wcel vy cv cA vx cv cT cfv cmul co wceq wa vx
      vy vg cv cT wceq vy cv cA vx cv vg cv cfv cmul co wceq vy cv cA vx cv cT
      cfv cmul co wceq vx cv chil wcel vg cv cT wceq cA vx cv vg cv cfv cmul co
      cA vx cv cT cfv cmul co vy cv vg cv cT wceq vx cv vg cv cfv vx cv cT cfv
      cA cmul vx cv vg cv cT fveq1 opreq2d eqeq2d anbi2d opabbidv chft vf cv cc
      wcel chil cc vg cv wf wa vh cv vx cv chil wcel vy cv vf cv vx cv vg cv
      cfv cmul co wceq wa vx vy copab wceq wa vf vg vh copab2 vf cv cc wcel vg
      cv cc chil cm co wcel wa vh cv vx cv chil wcel vy cv vf cv vx cv vg cv
      cfv cmul co wceq wa vx vy copab wceq wa vf vg vh copab2 vx vy vf vg vh
      df-hfmul vf cv cc wcel vg cv cc chil cm co wcel wa vh cv vx cv chil wcel
      vy cv vf cv vx cv vg cv cfv cmul co wceq wa vx vy copab wceq wa vf cv cc
      wcel chil cc vg cv wf wa vh cv vx cv chil wcel vy cv vf cv vx cv vg cv
      cfv cmul co wceq wa vx vy copab wceq wa vf vg vh vf cv cc wcel vg cv cc
      chil cm co wcel wa vf cv cc wcel chil cc vg cv wf wa vh cv vx cv chil
      wcel vy cv vf cv vx cv vg cv cfv cmul co wceq wa vx vy copab wceq vg cv
      cc chil cm co wcel chil cc vg cv wf vf cv cc wcel cc chil vg cv axcnex
      ax-hilex elmap anbi2i anbi1i oprabbii eqtr4i oprabval2 cc chil cT axcnex
      ax-hilex elmap sylan2br $.
      $( [1-Jun-2006] $) $( [23-May-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y S $.  $d x y T $.
    $( Value of the sum of two Hilbert space operators. $)
    hosval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ A e. ~H ) ->
        ( ( S +op T ) ` A ) = ( ( S ` A ) +h ( T ` A ) ) ) $=
      chil chil cS wf chil chil cT wf cA chil wcel cA cS cT chos co cfv cA cS
      cfv cA cT cfv cva co wceq chil chil cS wf chil chil cT wf wa cA chil wcel
      cA cS cT chos co cfv cA vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv
      cva co wceq wa vx vy copab cfv cA cS cfv cA cT cfv cva co chil chil cS wf
      chil chil cT wf wa cA cS cT chos co vx cv chil wcel vy cv vx cv cS cfv vx
      cv cT cfv cva co wceq wa vx vy copab vx vy cS cT hosmval fveq1d vx vy cA
      vx cv cS cfv vx cv cT cfv cva co cA cS cfv cA cT cfv cva co chil vx cv
      chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co wceq wa vx vy copab vx
      cv cA wceq vx cv cS cfv cA cS cfv vx cv cT cfv cA cT cfv cva vx cv cA cS
      fveq2 vx cv cA cT fveq2 opreq12d vx cv chil wcel vy cv vx cv cS cfv vx cv
      cT cfv cva co wceq wa vx vy copab eqid cA cS cfv cA cT cfv cva oprex
      fvopab4 sylan9eq 3impa $.
      $( [13-Aug-2006] $) $( [10-Nov-2000] $)

    $( Value of the sum of two Hilbert space operators. $)
    hosvalOLD $p |- ( ( ( S : ~H --> ~H /\ T : ~H --> ~H ) /\ A e. ~H ) ->
        ( ( S +op T ) ` A ) = ( ( S ` A ) +h ( T ` A ) ) ) $=
      chil chil cS wf chil chil cT wf wa cA chil wcel cA cS cT chos co cfv cA
      vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co wceq wa vx vy
      copab cfv cA cS cfv cA cT cfv cva co chil chil cS wf chil chil cT wf wa
      cA cS cT chos co vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co
      wceq wa vx vy copab vx vy cS cT hosmval fveq1d vx vy cA vx cv cS cfv vx
      cv cT cfv cva co cA cS cfv cA cT cfv cva co chil vx cv chil wcel vy cv vx
      cv cS cfv vx cv cT cfv cva co wceq wa vx vy copab vx cv cA wceq vx cv cS
      cfv cA cS cfv vx cv cT cfv cA cT cfv cva vx cv cA cS fveq2 vx cv cA cT
      fveq2 opreq12d vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co
      wceq wa vx vy copab eqid cA cS cfv cA cT cfv cva oprex fvopab4 sylan9eq
      $.
      $( [10-Nov-2000] $)

    $( Value of the scalar product with a Hilbert space operator. $)
    homval $p |- ( ( A e. CC /\ T : ~H --> ~H /\ B e. ~H ) ->
        ( ( A .op T ) ` B ) = ( A .h ( T ` B ) ) ) $=
      cA cc wcel chil chil cT wf cB chil wcel cB cA cT chot co cfv cA cB cT cfv
      csm co wceq cA cc wcel chil chil cT wf wa cB chil wcel cB cA cT chot co
      cfv cB vx cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab
      cfv cA cB cT cfv csm co cA cc wcel chil chil cT wf wa cB cA cT chot co vx
      cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab vx vy cA cT
      hommval fveq1d vx vy cB cA vx cv cT cfv csm co cA cB cT cfv csm co chil
      vx cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab vx cv cB
      wceq vx cv cT cfv cB cT cfv cA csm vx cv cB cT fveq2 opreq2d vx cv chil
      wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab eqid cA cB cT cfv
      csm oprex fvopab4 sylan9eq 3impa $.
      $( [20-Mar-2006] $) $( [20-Feb-2006] $)

    $( Value of the difference of two Hilbert space operators. $)
    hodval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ A e. ~H ) ->
        ( ( S -op T ) ` A ) = ( ( S ` A ) -h ( T ` A ) ) ) $=
      chil chil cS wf chil chil cT wf cA chil wcel cA cS cT chod co cfv cA cS
      cfv cA cT cfv cmv co wceq chil chil cS wf chil chil cT wf wa cA chil wcel
      cA cS cT chod co cfv cA vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv
      cmv co wceq wa vx vy copab cfv cA cS cfv cA cT cfv cmv co chil chil cS wf
      chil chil cT wf wa cA cS cT chod co vx cv chil wcel vy cv vx cv cS cfv vx
      cv cT cfv cmv co wceq wa vx vy copab vx vy cS cT hodmval fveq1d vx vy cA
      vx cv cS cfv vx cv cT cfv cmv co cA cS cfv cA cT cfv cmv co chil vx cv
      chil wcel vy cv vx cv cS cfv vx cv cT cfv cmv co wceq wa vx vy copab vx
      cv cA wceq vx cv cS cfv cA cS cfv vx cv cT cfv cA cT cfv cmv vx cv cA cS
      fveq2 vx cv cA cT fveq2 opreq12d vx cv chil wcel vy cv vx cv cS cfv vx cv
      cT cfv cmv co wceq wa vx vy copab eqid cA cS cfv cA cT cfv cmv oprex
      fvopab4 sylan9eq 3impa $.
      $( [28-Jun-2006] $) $( [10-Nov-2000] $)

    $( Value of the difference of two Hilbert space operators. $)
    hodvalOLD $p |- ( ( ( S : ~H --> ~H /\ T : ~H --> ~H ) /\ A e. ~H ) ->
        ( ( S -op T ) ` A ) = ( ( S ` A ) -h ( T ` A ) ) ) $=
      chil chil cS wf chil chil cT wf wa cA chil wcel cA cS cT chod co cfv cA
      vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cmv co wceq wa vx vy
      copab cfv cA cS cfv cA cT cfv cmv co chil chil cS wf chil chil cT wf wa
      cA cS cT chod co vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cmv co
      wceq wa vx vy copab vx vy cS cT hodmval fveq1d vx vy cA vx cv cS cfv vx
      cv cT cfv cmv co cA cS cfv cA cT cfv cmv co chil vx cv chil wcel vy cv vx
      cv cS cfv vx cv cT cfv cmv co wceq wa vx vy copab vx cv cA wceq vx cv cS
      cfv cA cS cfv vx cv cT cfv cA cT cfv cmv vx cv cA cS fveq2 vx cv cA cT
      fveq2 opreq12d vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cmv co
      wceq wa vx vy copab eqid cA cS cfv cA cT cfv cmv oprex fvopab4 sylan9eq
      $.
      $( [10-Nov-2000] $)

    $( Value of the sum of two Hilbert space functionals. $)
    hfsval $p |- ( ( ( S : ~H --> CC /\ T : ~H --> CC ) /\ A e. ~H ) ->
        ( ( S +fn T ) ` A ) = ( ( S ` A ) + ( T ` A ) ) ) $=
      chil cc cS wf chil cc cT wf wa cA chil wcel cA cS cT chfs co cfv cA vx cv
      chil wcel vy cv vx cv cS cfv vx cv cT cfv caddc co wceq wa vx vy copab
      cfv cA cS cfv cA cT cfv caddc co chil cc cS wf chil cc cT wf wa cA cS cT
      chfs co vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv caddc co wceq wa
      vx vy copab vx vy cS cT hfsmval fveq1d vx vy cA vx cv cS cfv vx cv cT cfv
      caddc co cA cS cfv cA cT cfv caddc co chil vx cv chil wcel vy cv vx cv cS
      cfv vx cv cT cfv caddc co wceq wa vx vy copab vx cv cA wceq vx cv cS cfv
      cA cS cfv vx cv cT cfv cA cT cfv caddc vx cv cA cS fveq2 vx cv cA cT
      fveq2 opreq12d vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv caddc co
      wceq wa vx vy copab eqid cA cS cfv cA cT cfv caddc oprex fvopab4 sylan9eq
      $.
      $( [11-Oct-2006] $) $( [23-May-2006] $)

    $( Value of the scalar product with a Hilbert space functional. $)
    hfmval $p |- ( ( A e. CC /\ T : ~H --> CC /\ B e. ~H ) ->
        ( ( A .fn T ) ` B ) = ( A x. ( T ` B ) ) ) $=
      cA cc wcel chil cc cT wf cB chil wcel cB cA cT chft co cfv cA cB cT cfv
      cmul co wceq cA cc wcel chil cc cT wf wa cB chil wcel cB cA cT chft co
      cfv cB vx cv chil wcel vy cv cA vx cv cT cfv cmul co wceq wa vx vy copab
      cfv cA cB cT cfv cmul co cA cc wcel chil cc cT wf wa cB cA cT chft co vx
      cv chil wcel vy cv cA vx cv cT cfv cmul co wceq wa vx vy copab vx vy cA
      cT hfmmval fveq1d vx vy cB cA vx cv cT cfv cmul co cA cB cT cfv cmul co
      chil vx cv chil wcel vy cv cA vx cv cT cfv cmul co wceq wa vx vy copab vx
      cv cB wceq vx cv cT cfv cB cT cfv cA cmul vx cv cB cT fveq2 opreq2d vx cv
      chil wcel vy cv cA vx cv cT cfv cmul co wceq wa vx vy copab eqid cA cB cT
      cfv cmul oprex fvopab4 sylan9eq 3impa $.
      $( [29-Jun-2006] $) $( [23-May-2006] $)
  $}

  $( Closure of the sum of two Hilbert space operators. $)
  hoscl $p |- ( ( ( S : ~H --> ~H /\ T : ~H --> ~H ) /\ A e. ~H ) ->
      ( ( S +op T ) ` A ) e. ~H ) $=
    chil chil cS wf chil chil cT wf wa cA chil wcel wa cA cS cT chos co cfv cA
    cS cfv cA cT cfv cva co chil cA cS cT hosvalOLD chil chil cS wf chil chil
    cT wf wa cA chil wcel wa cA cS cfv chil wcel cA cT cfv chil wcel wa cA cS
    cfv cA cT cfv cva co chil wcel chil chil cS wf chil chil cT wf cA chil wcel
    cA cS cfv chil wcel cA cT cfv chil wcel wa chil chil cS wf cA chil wcel wa
    cA cS cfv chil wcel chil chil cT wf cA chil wcel wa cA cT cfv chil wcel
    chil chil cA cS ffvelrn chil chil cA cT ffvelrn anim12i anandirs cA cS cfv
    cA cT cfv hvaddcl syl eqeltrd $.
    $( [12-Nov-2000] $)

  $( Closure of the scalar product of a Hilbert space operator. $)
  homcl $p |- ( ( A e. CC /\ T : ~H --> ~H /\ B e. ~H ) ->
      ( ( A .op T ) ` B ) e. ~H ) $=
    cA cc wcel chil chil cT wf cB chil wcel w3a cB cA cT chot co cfv cA cB cT
    cfv csm co chil cA cB cT homval cA cc wcel chil chil cT wf cB chil wcel w3a
    cA cc wcel cB cT cfv chil wcel wa cA cB cT cfv csm co chil wcel cA cc wcel
    chil chil cT wf cB chil wcel cA cc wcel cB cT cfv chil wcel wa chil chil cT
    wf cB chil wcel wa cB cT cfv chil wcel cA cc wcel chil chil cB cT ffvelrn
    anim2i 3impb cA cB cT cfv hvmulcl syl eqeltrd $.
    $( [12-Oct-2006] $) $( [20-Feb-2006] $)

  $( Closure of the difference of two Hilbert space operators. $)
  hodcl $p |- ( ( ( S : ~H --> ~H /\ T : ~H --> ~H ) /\ A e. ~H ) ->
      ( ( S -op T ) ` A ) e. ~H ) $=
    chil chil cS wf chil chil cT wf wa cA chil wcel wa cA cS cT chod co cfv cA
    cS cfv cA cT cfv cmv co chil cA cS cT hodvalOLD chil chil cS wf chil chil
    cT wf wa cA chil wcel wa cA cS cfv chil wcel cA cT cfv chil wcel wa cA cS
    cfv cA cT cfv cmv co chil wcel chil chil cS wf chil chil cT wf cA chil wcel
    cA cS cfv chil wcel cA cT cfv chil wcel wa chil chil cS wf cA chil wcel wa
    cA cS cfv chil wcel chil chil cT wf cA chil wcel wa cA cT cfv chil wcel
    chil chil cA cS ffvelrn chil chil cA cT ffvelrn anim12i anandirs cA cS cfv
    cA cT cfv hvsubcl syl eqeltrd $.
    $( [15-Nov-2002] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Commutes relation for Hilbert lattice elements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Define the commutes relation (on the Hilbert lattice).  Definition of
       commutes in [Kalmbach] p. 20, who uses the notation xCy for "x commutes
       with y."  See ~ cmbri for membership relation. $)
    df-cm $a |- C_H = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
                x = ( ( x i^i y ) vH ( x i^i ( _|_ ` y ) ) ) ) } $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Binary relation expressing ` A ` commutes with ` B ` .  Definition of
       commutes in [Kalmbach] p. 20. $)
    cmbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_H B <->
               A = ( ( A i^i B ) vH ( A i^i ( _|_ ` B ) ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB ccm wbr cA cA cB cin cA cB cort cfv cin
      chj co wceq vx cv cch wcel vy cv cch wcel wa vx cv vx cv vy cv cin vx cv
      vy cv cort cfv cin chj co wceq wa cA cch wcel vy cv cch wcel wa cA cA vy
      cv cin cA vy cv cort cfv cin chj co wceq wa cA cch wcel cB cch wcel wa cA
      cA cB cin cA cB cort cfv cin chj co wceq wa vx vy cA cB cch cch ccm vx cv
      cA wceq vx cv cch wcel vy cv cch wcel wa cA cch wcel vy cv cch wcel wa vx
      cv vx cv vy cv cin vx cv vy cv cort cfv cin chj co wceq cA cA vy cv cin
      cA vy cv cort cfv cin chj co wceq vx cv cA wceq vx cv cch wcel cA cch
      wcel vy cv cch wcel vx cv cA cch eleq1 anbi1d vx cv cA wceq vx cv cA vx
      cv vy cv cin vx cv vy cv cort cfv cin chj co cA vy cv cin cA vy cv cort
      cfv cin chj co vx cv cA wceq id vx cv cA wceq vx cv vy cv cin cA vy cv
      cin vx cv vy cv cort cfv cin cA vy cv cort cfv cin chj vx cv cA vy cv
      ineq1 vx cv cA vy cv cort cfv ineq1 opreq12d eqeq12d anbi12d vy cv cB
      wceq cA cch wcel vy cv cch wcel wa cA cch wcel cB cch wcel wa cA cA vy cv
      cin cA vy cv cort cfv cin chj co wceq cA cA cB cin cA cB cort cfv cin chj
      co wceq vy cv cB wceq vy cv cch wcel cB cch wcel cA cch wcel vy cv cB cch
      eleq1 anbi2d vy cv cB wceq cA vy cv cin cA vy cv cort cfv cin chj co cA
      cB cin cA cB cort cfv cin chj co cA vy cv cB wceq cA vy cv cin cA cB cin
      cA vy cv cort cfv cin cA cB cort cfv cin chj vy cv cB cA ineq2 vy cv cB
      wceq vy cv cort cfv cB cort cfv cA vy cv cB cort fveq2 ineq2d opreq12d
      eqeq2d anbi12d vx vy df-cm brabg bianabs $.
      $( [12-Aug-2004] $) $( [14-Jun-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    pjoml2.1 $e |- A e. CH $.
    pjoml2.2 $e |- B e. CH $.
    $( Variation of orthomodular law.  Definition in [Kalmbach] p. 22. $)
    pjoml2i $p |- ( A C_ B -> ( A vH ( ( _|_ ` A ) i^i B ) ) = B ) $=
      cA cB wss cA cA cort cfv cB cin chj co cB wss cA cA cort cfv cB cin chj
      co cB wceq cA cB wss cA cort cfv cB cin cB wss cA cA cort cfv cB cin chj
      co cB wss cA cort cfv cB inss2 cA cA cort cfv cB cin cB pjoml2.1 cA cort
      cfv cB cA pjoml2.1 choccli pjoml2.2 chincli pjoml2.2 chlubii mpan2 cA cA
      cort cfv cB cin chj co cB wss cB cA cA cort cfv cB cin chj co cort cfv
      cin c0h wceq cA cA cort cfv cB cin chj co cB wceq cB cA cA cort cfv cB
      cin chj co cort cfv cin cB cA cort cfv cA cort cfv cB cin cort cfv cin
      cin cA cort cfv cB cin cA cort cfv cB cin cort cfv cin c0h cA cA cort cfv
      cB cin chj co cort cfv cA cort cfv cA cort cfv cB cin cort cfv cin cB cA
      cA cort cfv cB cin pjoml2.1 cA cort cfv cB cA pjoml2.1 choccli pjoml2.2
      chincli chdmj1i ineq2i cB cA cort cfv cin cA cort cfv cB cin cort cfv cin
      cB cA cort cfv cA cort cfv cB cin cort cfv cin cin cA cort cfv cB cin cA
      cort cfv cB cin cort cfv cin cB cA cort cfv cA cort cfv cB cin cort cfv
      inass cB cA cort cfv cin cA cort cfv cB cin cA cort cfv cB cin cort cfv
      cB cA cort cfv incom ineq1i eqtr3i cA cort cfv cB cin cA cort cfv cB cA
      pjoml2.1 choccli pjoml2.2 chincli chocini 3eqtri cA cA cort cfv cB cin
      chj co cB cA cA cort cfv cB cin pjoml2.1 cA cort cfv cB cA pjoml2.1
      choccli pjoml2.2 chincli chjcli cB pjoml2.2 chshii pjomli mpan2 syl $.
      $( [31-Oct-2000] $)

    $( Variation of orthomodular law. $)
    pjoml3i $p |- ( B C_ A -> ( A i^i ( ( _|_ ` A ) vH B ) ) = B ) $=
      cA cort cfv cB cort cfv wss cA cort cfv cA cort cfv cort cfv cB cort cfv
      cin chj co cB cort cfv wceq cB cA wss cA cA cort cfv cB chj co cin cB
      wceq cA cort cfv cB cort cfv cA pjoml2.1 choccli cB pjoml2.2 choccli
      pjoml2i cB cA pjoml2.2 pjoml2.1 chsscon3i cA cort cfv cA cort cfv cort
      cfv cB cort cfv cin chj co cort cfv cB wceq cB cA cort cfv cA cort cfv
      cort cfv cB cort cfv cin chj co cort cfv wceq cA cA cort cfv cB chj co
      cin cB wceq cA cort cfv cA cort cfv cort cfv cB cort cfv cin chj co cB
      cort cfv wceq cA cort cfv cA cort cfv cort cfv cB cort cfv cin chj co
      cort cfv cB eqcom cA cort cfv cA cort cfv cort cfv cB cort cfv cin chj co
      cort cfv cA cA cort cfv cB chj co cin cB cA cort cfv cA cort cfv cort cfv
      cB cort cfv cin chj co cort cfv cA cA cort cfv cort cfv cB cort cfv cin
      cort cfv cin cA cA cort cfv cB chj co cin cA cA cort cfv cort cfv cB cort
      cfv cin pjoml2.1 cA cort cfv cort cfv cB cort cfv cA cort cfv cA pjoml2.1
      choccli choccli cB pjoml2.2 choccli chincli chdmj2i cA cort cfv cort cfv
      cB cort cfv cin cort cfv cA cort cfv cB chj co cA cA cort cfv cB cA
      pjoml2.1 choccli pjoml2.2 chdmm4i ineq2i eqtri eqeq1i cB cA cort cfv cA
      cort cfv cort cfv cB cort cfv cin chj co pjoml2.2 cA cort cfv cA cort cfv
      cort cfv cB cort cfv cin cA pjoml2.1 choccli cA cort cfv cort cfv cB cort
      cfv cA cort cfv cA pjoml2.1 choccli choccli cB pjoml2.2 choccli chincli
      chjcli chcon2i 3bitr3i 3imtr4i $.
      $( [9-Sep-2004] $) $( [24-Jun-2004] $)

    $( Variation of orthomodular law. $)
    pjoml4i $p |- ( A vH ( B i^i ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) ) =
                 ( A vH B ) $=
      cA cB cA cort cfv cB cort cfv chj co cin chj co cA cB chj co cB cA cort
      cfv cB cort cfv chj co cin cB wss cA cB cA cort cfv cB cort cfv chj co
      cin chj co cA cB chj co wss cB cA cort cfv cB cort cfv chj co inss1 cB cA
      cort cfv cB cort cfv chj co cin cB cA cB cA cort cfv cB cort cfv chj co
      pjoml2.2 cA cort cfv cB cort cfv cA pjoml2.1 choccli cB pjoml2.2 choccli
      chjcli chincli pjoml2.2 pjoml2.1 chlej2i ax-mp cA cA cB cA cort cfv cB
      cort cfv chj co cin chj co wss cB cA cB cA cort cfv cB cort cfv chj co
      cin chj co wss cA cB chj co cA cB cA cort cfv cB cort cfv chj co cin chj
      co wss cA cB cA cort cfv cB cort cfv chj co cin pjoml2.1 cB cA cort cfv
      cB cort cfv chj co pjoml2.2 cA cort cfv cB cort cfv cA pjoml2.1 choccli
      cB pjoml2.2 choccli chjcli chincli chub1i cB cA cB cin cB cA cort cfv cB
      cort cfv chj co cin chj co cA cB cA cort cfv cB cort cfv chj co cin chj
      co cA cB cin cA cB cin cort cfv cB cin chj co cA cB cin cB cA cort cfv cB
      cort cfv chj co cin chj co cB cA cB cin cort cfv cB cin cB cA cort cfv cB
      cort cfv chj co cin cA cB cin chj cA cB cin cort cfv cB cin cA cort cfv
      cB cort cfv chj co cB cin cB cA cort cfv cB cort cfv chj co cin cA cB cin
      cort cfv cA cort cfv cB cort cfv chj co cB cA cB pjoml2.1 pjoml2.2
      chdmm1i ineq1i cA cort cfv cB cort cfv chj co cB incom eqtri opreq2i cA
      cB cin cB wss cA cB cin cA cB cin cort cfv cB cin chj co cB wceq cA cB
      inss2 cA cB cin cB cA cB pjoml2.1 pjoml2.2 chincli pjoml2.2 pjoml2i ax-mp
      eqtr3i cA cB cin cA wss cA cB cin cB cA cort cfv cB cort cfv chj co cin
      chj co cA cB cA cort cfv cB cort cfv chj co cin chj co wss cA cB inss1 cA
      cB cin cA cB cA cort cfv cB cort cfv chj co cin cA cB pjoml2.1 pjoml2.2
      chincli pjoml2.1 cB cA cort cfv cB cort cfv chj co pjoml2.2 cA cort cfv
      cB cort cfv cA pjoml2.1 choccli cB pjoml2.2 choccli chjcli chincli
      chlej1i ax-mp eqsstr3i cA cB cA cB cA cort cfv cB cort cfv chj co cin chj
      co pjoml2.1 pjoml2.2 cA cB cA cort cfv cB cort cfv chj co cin pjoml2.1 cB
      cA cort cfv cB cort cfv chj co pjoml2.2 cA cort cfv cB cort cfv cA
      pjoml2.1 choccli cB pjoml2.2 choccli chjcli chincli chjcli chlubii mp2an
      eqssi $.
      $( [6-Dec-2000] $)

    $( The orthomodular law.  Remark in [Kalmbach] p. 22. $)
    pjoml5i $p |- ( A vH ( ( _|_ ` A ) i^i ( A vH B ) ) ) = ( A vH B ) $=
      cA cA cB chj co wss cA cA cort cfv cA cB chj co cin chj co cA cB chj co
      wceq cA cB pjoml2.1 pjoml2.2 chub1i cA cA cB chj co pjoml2.1 cA cB
      pjoml2.1 pjoml2.2 chjcli pjoml2i ax-mp $.
      $( [12-Jun-2006] $) $( [12-Jun-2006] $)

    $( An equivalent of the orthomodular law.  Theorem 29.13(e) of [MaedaMaeda]
       p. 132. $)
    pjoml6i $p |- ( A C_ B ->
                  E. x e. CH ( A C_ ( _|_ ` x ) /\ ( A vH x ) = B ) ) $=
      cA cB wss cA cA cort cfv cB cin cort cfv wss cA cA cort cfv cB cin chj co
      cB wceq wa cA vx cv cort cfv wss cA vx cv chj co cB wceq wa vx cch wrex
      cA cB wss cA cA cort cfv cB cin chj co cB wceq cA cA cort cfv cB cin cort
      cfv wss cA cB pjoml2.1 pjoml2.2 pjoml2i cA cA cB cort cfv chj co cA cort
      cfv cB cin cort cfv cA cB cort cfv pjoml2.1 cB pjoml2.2 choccli chub1i cA
      cB pjoml2.1 pjoml2.2 chdmm2i sseqtr4i jctil cA cort cfv cB cin cch wcel
      cA cA cort cfv cB cin cort cfv wss cA cA cort cfv cB cin chj co cB wceq
      wa cA vx cv cort cfv wss cA vx cv chj co cB wceq wa vx cch wrex cA cort
      cfv cB cA pjoml2.1 choccli pjoml2.2 chincli cA vx cv cort cfv wss cA vx
      cv chj co cB wceq wa cA cA cort cfv cB cin cort cfv wss cA cA cort cfv cB
      cin chj co cB wceq wa vx cA cort cfv cB cin cch vx cv cA cort cfv cB cin
      wceq cA vx cv cort cfv wss cA cA cort cfv cB cin cort cfv wss cA vx cv
      chj co cB wceq cA cA cort cfv cB cin chj co cB wceq vx cv cA cort cfv cB
      cin wceq vx cv cort cfv cA cort cfv cB cin cort cfv cA vx cv cA cort cfv
      cB cin cort fveq2 sseq2d vx cv cA cort cfv cB cin wceq cA vx cv chj co cA
      cA cort cfv cB cin chj co cB vx cv cA cort cfv cB cin cA chj opreq2
      eqeq1d anbi12d rcla4ev mpan syl $.
      $( [9-Sep-2004] $) $( [30-May-2004] $)

    $( Binary relation expressing the commutes relation.  Definition of
       commutes in [Kalmbach] p. 20. $)
    cmbri $p |- ( A C_H B <-> A = ( ( A i^i B ) vH ( A i^i ( _|_ ` B ) ) ) ) $=
      cA cch wcel cB cch wcel cA cB ccm wbr cA cA cB cin cA cB cort cfv cin chj
      co wceq wb pjoml2.1 pjoml2.2 cA cB cmbr mp2an $.
      $( [12-Aug-2004] $) $( [6-Aug-2004] $)

    $( Commutation is symmetric.  Theorem 3.4 of [Beran] p. 45. $)
    cmcmlem $p |- ( A C_H B -> B C_H A ) $=
      cA cA cB cin cA cB cort cfv cin chj co wceq cB cB cA cin cB cA cort cfv
      cin chj co wceq cA cB ccm wbr cB cA ccm wbr cA cA cB cin cA cB cort cfv
      cin chj co wceq cA cB cin cA cB cin cort cfv cB cin chj co cA cB cin cA
      cort cfv cB cin chj co cB cB cA cin cB cA cort cfv cin chj co cA cA cB
      cin cA cB cort cfv cin chj co wceq cA cB cin cort cfv cB cin cA cort cfv
      cB cin cA cB cin chj cA cA cB cin cA cB cort cfv cin chj co wceq cA cort
      cfv cB cort cfv chj co cA cort cfv cB chj co cin cB cin cA cort cfv cB
      cin cA cB cin cort cfv cB cin cA cA cB cin cA cB cort cfv cin chj co wceq
      cA cort cfv cB cort cfv chj co cA cort cfv cB chj co cin cA cort cfv cB
      cA cA cB cin cA cB cort cfv cin chj co wceq cA cort cfv cA cort cfv cB
      cort cfv chj co cort cfv cA cort cfv cB chj co cort cfv chj co cort cfv
      cA cort cfv cB cort cfv chj co cA cort cfv cB chj co cin cA cA cB cin cA
      cB cort cfv cin chj co wceq cA cA cort cfv cB cort cfv chj co cort cfv cA
      cort cfv cB chj co cort cfv chj co cort cA cA cort cfv cB cort cfv chj co
      cort cfv cA cort cfv cB chj co cort cfv chj co wceq cA cA cB cin cA cB
      cort cfv cin chj co wceq cA cort cfv cB cort cfv chj co cort cfv cA cort
      cfv cB chj co cort cfv chj co cA cB cin cA cB cort cfv cin chj co cA cA
      cort cfv cB cort cfv chj co cort cfv cA cB cin cA cort cfv cB chj co cort
      cfv cA cB cort cfv cin chj cA cB pjoml2.1 pjoml2.2 chdmj4i cA cB pjoml2.1
      pjoml2.2 chdmj2i opreq12i eqeq2i biimpri fveq2d cA cort cfv cB cort cfv
      chj co cA cort cfv cB chj co cA cort cfv cB cort cfv cA pjoml2.1 choccli
      cB pjoml2.2 choccli chjcli cA cort cfv cB cA pjoml2.1 choccli pjoml2.2
      chjcli chdmj4i syl6req ineq1d cA cort cfv cB cort cfv chj co cA cort cfv
      cB chj co cB cin cin cA cort cfv cB cort cfv chj co cB cin cA cort cfv cB
      cort cfv chj co cA cort cfv cB chj co cin cB cin cA cB cin cort cfv cB
      cin cA cort cfv cB chj co cB cin cB cA cort cfv cB cort cfv chj co cB cA
      cort cfv cB chj co wss cA cort cfv cB chj co cB cin cB wceq cB cA cort
      cfv pjoml2.2 cA pjoml2.1 choccli chub2i cB cA cort cfv cB chj co sseqin2
      mpbi ineq2i cA cort cfv cB cort cfv chj co cA cort cfv cB chj co cB inass
      cA cB cin cort cfv cA cort cfv cB cort cfv chj co cB cA cB pjoml2.1
      pjoml2.2 chdmm1i ineq1i 3eqtr4ri syl5eq opreq2d cA cB cin cB wss cA cB
      cin cA cB cin cort cfv cB cin chj co cB wceq cA cB inss2 cA cB cin cB cA
      cB pjoml2.1 pjoml2.2 chincli pjoml2.2 pjoml2i ax-mp cA cB cin cB cA cin
      cA cort cfv cB cin cB cA cort cfv cin chj cA cB incom cA cort cfv cB
      incom opreq12i 3eqtr3g cA cB pjoml2.1 pjoml2.2 cmbri cB cA pjoml2.2
      pjoml2.1 cmbri 3imtr4i $.
      $( [12-Aug-2004] $) $( [3-Nov-2000] $)

    $( Commutation is symmetric.  Theorem 2(v) of [Kalmbach] p. 22. $)
    cmcmi $p |- ( A C_H B <-> B C_H A ) $=
      cA cB ccm wbr cB cA ccm wbr cA cB pjoml2.1 pjoml2.2 cmcmlem cB cA
      pjoml2.2 pjoml2.1 cmcmlem impbii $.
      $( [12-Aug-2004] $) $( [4-Nov-2000] $)

    $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39. $)
    cmcm2i $p |- ( A C_H B <-> A C_H ( _|_ ` B ) ) $=
      cA cA cB cin cA cB cort cfv cin chj co wceq cA cA cB cort cfv cin cA cB
      cort cfv cort cfv cin chj co wceq cA cB ccm wbr cA cB cort cfv ccm wbr cA
      cB cin cA cB cort cfv cin chj co cA cB cort cfv cin cA cB cort cfv cort
      cfv cin chj co cA cA cB cin cA cB cort cfv cin chj co cA cB cort cfv cin
      cA cB cin chj co cA cB cort cfv cin cA cB cort cfv cort cfv cin chj co cA
      cB cin cA cB cort cfv cin cA cB pjoml2.1 pjoml2.2 chincli cA cB cort cfv
      pjoml2.1 cB pjoml2.2 choccli chincli chjcomi cA cB cort cfv cort cfv cin
      cA cB cin cA cB cort cfv cin chj cB cort cfv cort cfv cB cA cB pjoml2.2
      pjococi ineq2i opreq2i eqtr4i eqeq2i cA cB pjoml2.1 pjoml2.2 cmbri cA cB
      cort cfv pjoml2.1 cB pjoml2.2 choccli cmbri 3bitr4i $.
      $( [12-Aug-2004] $) $( [4-Nov-2000] $)

    $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23. $)
    cmcm3i $p |- ( A C_H B <-> ( _|_ ` A ) C_H B ) $=
      cB cA ccm wbr cB cA cort cfv ccm wbr cA cB ccm wbr cA cort cfv cB ccm wbr
      cB cA pjoml2.2 pjoml2.1 cmcm2i cA cB pjoml2.1 pjoml2.2 cmcmi cA cort cfv
      cB cA pjoml2.1 choccli pjoml2.2 cmcmi 3bitr4i $.
      $( [12-Aug-2004] $) $( [4-Nov-2000] $)

    $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23. $)
    cmcm4i $p |- ( A C_H B <-> ( _|_ ` A ) C_H ( _|_ ` B ) ) $=
      cA cB ccm wbr cA cB cort cfv ccm wbr cA cort cfv cB cort cfv ccm wbr cA
      cB pjoml2.1 pjoml2.2 cmcm2i cA cB cort cfv pjoml2.1 cB pjoml2.2 choccli
      cmcm3i bitri $.
      $( [12-Aug-2004] $) $( [7-Aug-2004] $)

    $( Alternate definition of the commutes relation.  Remark in [Kalmbach]
       p. 23. $)
    cmbr2i $p |- ( A C_H B <-> A = ( ( A vH B ) i^i ( A vH ( _|_ ` B ) ) ) ) $=
      cA cB ccm wbr cA cort cfv cB cort cfv ccm wbr cA cort cfv cA cort cfv cB
      cort cfv cin cA cort cfv cB cort cfv cort cfv cin chj co wceq cA cA cB
      chj co cA cB cort cfv chj co cin wceq cA cB pjoml2.1 pjoml2.2 cmcm4i cA
      cort cfv cB cort cfv cA pjoml2.1 choccli cB pjoml2.2 choccli cmbri cA cA
      cB chj co cA cB cort cfv chj co cin wceq cA cB chj co cA cB cort cfv chj
      co cin cA wceq cA cort cfv cA cB chj co cA cB cort cfv chj co cin cort
      cfv wceq cA cort cfv cA cort cfv cB cort cfv cin cA cort cfv cB cort cfv
      cort cfv cin chj co wceq cA cA cB chj co cA cB cort cfv chj co cin eqcom
      cA cB chj co cA cB cort cfv chj co cin cA cA cB chj co cA cB cort cfv chj
      co cA cB pjoml2.1 pjoml2.2 chjcli cA cB cort cfv pjoml2.1 cB pjoml2.2
      choccli chjcli chincli pjoml2.1 chcon3i cA cB chj co cA cB cort cfv chj
      co cin cort cfv cA cort cfv cB cort cfv cin cA cort cfv cB cort cfv cort
      cfv cin chj co cA cort cfv cA cB chj co cA cB cort cfv chj co cin cort
      cfv cA cB chj co cort cfv cA cB cort cfv chj co cort cfv chj co cA cort
      cfv cB cort cfv cin cA cort cfv cB cort cfv cort cfv cin chj co cA cB chj
      co cA cB cort cfv chj co cA cB pjoml2.1 pjoml2.2 chjcli cA cB cort cfv
      pjoml2.1 cB pjoml2.2 choccli chjcli chdmm1i cA cB chj co cort cfv cA cort
      cfv cB cort cfv cin cA cB cort cfv chj co cort cfv cA cort cfv cB cort
      cfv cort cfv cin chj cA cB pjoml2.1 pjoml2.2 chdmj1i cA cB cort cfv
      pjoml2.1 cB pjoml2.2 choccli chdmj1i opreq12i eqtri eqeq2i 3bitrri 3bitri
      $.
      $( [12-Aug-2004] $) $( [7-Aug-2004] $)

    ${
      cmcmi.1 $e |- A C_H B $.
      $( Commutation is symmetric.  Theorem 2(v) of [Kalmbach] p. 22. $)
      cmcmii $p |- B C_H A $=
        cA cB ccm wbr cB cA ccm wbr cmcmi.1 cA cB pjoml2.1 pjoml2.2 cmcmi mpbi
        $.
        $( [12-Aug-2004] $) $( [7-Aug-2004] $)

      $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39. $)
      cmcm2ii $p |- A C_H ( _|_ ` B ) $=
        cA cB ccm wbr cA cB cort cfv ccm wbr cmcmi.1 cA cB pjoml2.1 pjoml2.2
        cmcm2i mpbi $.
        $( [12-Aug-2004] $) $( [7-Aug-2004] $)

      $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23. $)
      cmcm3ii $p |- ( _|_ ` A ) C_H B $=
        cA cB ccm wbr cA cort cfv cB ccm wbr cmcmi.1 cA cB pjoml2.1 pjoml2.2
        cmcm3i mpbi $.
        $( [13-Sep-2004] $) $( [7-Aug-2004] $)
    $}

    $( Alternate definition for the commutes relation.  Lemma 3 of [Kalmbach]
       p. 23. $)
    cmbr3i $p |- ( A C_H B
             <-> ( A i^i ( ( _|_ ` A ) vH B ) ) = ( A i^i B ) ) $=
      cA cB ccm wbr cA cA cort cfv cB chj co cin cA cB cin wceq cA cB ccm wbr
      cB cB cA chj co cB cA cort cfv chj co cin wceq cA cA cort cfv cB chj co
      cin cA cB cin wceq cA cB ccm wbr cB cA ccm wbr cB cB cA chj co cB cA cort
      cfv chj co cin wceq cA cB pjoml2.1 pjoml2.2 cmcmi cB cA pjoml2.2 pjoml2.1
      cmbr2i bitri cB cB cA chj co cB cA cort cfv chj co cin wceq cA cB cin cA
      cB cA chj co cB cA cort cfv chj co cin cin cA cA cort cfv cB chj co cin
      cB cB cA chj co cB cA cort cfv chj co cin cA ineq2 cA cB cA chj co cin cB
      cA cort cfv chj co cin cA cB cA chj co cB cA cort cfv chj co cin cin cA
      cA cort cfv cB chj co cin cA cB cA chj co cB cA cort cfv chj co inass cA
      cB cA chj co cin cA cB cA cort cfv chj co cA cort cfv cB chj co cA cB cA
      chj co cin cA cA cB chj co cin cA cB cA chj co cA cB chj co cA cB cA
      pjoml2.2 pjoml2.1 chjcomi ineq2i cA cB pjoml2.1 pjoml2.2 chabs2i eqtri cB
      cA cort cfv pjoml2.2 cA pjoml2.1 choccli chjcomi ineq12i eqtr3i syl6req
      sylbi cA cA cort cfv cB chj co cin cA cB cin wceq cA cA cB cin cA cB cort
      cfv cin chj co wceq cA cB ccm wbr cA cA cort cfv cB chj co cin cA cB cin
      wceq cA cB cort cfv cin cort cfv cA cin cA cB cort cfv cin chj co cA cB
      cin cA cB cort cfv cin chj co cA cA cA cort cfv cB chj co cin cA cB cin
      wceq cA cB cort cfv cin cort cfv cA cin cA cB cin wceq cA cB cort cfv cin
      cort cfv cA cin cA cB cort cfv cin chj co cA cB cin cA cB cort cfv cin
      chj co wceq cA cA cort cfv cB chj co cin cA cB cort cfv cin cort cfv cA
      cin cA cB cin cA cA cB cort cfv cin cort cfv cin cA cA cort cfv cB chj co
      cin cA cB cort cfv cin cort cfv cA cin cA cB cort cfv cin cort cfv cA
      cort cfv cB chj co cA cA cB pjoml2.1 pjoml2.2 chdmm3i ineq2i cA cA cB
      cort cfv cin cort cfv incom eqtr3i eqeq1i cA cB cort cfv cin cort cfv cA
      cin cA cB cin cA cB cort cfv cin chj opreq1 sylbi cA cB cort cfv cin cA
      cB cort cfv cin cort cfv cA cin chj co cA cA cB cort cfv cin cort cfv cA
      cin cA cB cort cfv cin chj co cA cB cort cfv cin cA wss cA cB cort cfv
      cin cA cB cort cfv cin cort cfv cA cin chj co cA wceq cA cB cort cfv
      inss1 cA cB cort cfv cin cA cA cB cort cfv pjoml2.1 cB pjoml2.2 choccli
      chincli pjoml2.1 pjoml2i ax-mp cA cB cort cfv cin cA cB cort cfv cin cort
      cfv cA cin cA cB cort cfv pjoml2.1 cB pjoml2.2 choccli chincli cA cB cort
      cfv cin cort cfv cA cA cB cort cfv cin cA cB cort cfv pjoml2.1 cB
      pjoml2.2 choccli chincli choccli pjoml2.1 chincli chjcomi eqtr3i syl5eq
      cA cB pjoml2.1 pjoml2.2 cmbri sylibr impbii $.
      $( [12-Aug-2004] $) $( [6-Dec-2000] $)

    $( Alternate definition for the commutes relation. $)
    cmbr4i $p |- ( A C_H B <-> ( A i^i ( ( _|_ ` A ) vH B ) ) C_ B ) $=
      cA cB ccm wbr cA cA cort cfv cB chj co cin cA cB cin wceq cA cA cort cfv
      cB chj co cin cB wss cA cB pjoml2.1 pjoml2.2 cmbr3i cA cA cort cfv cB chj
      co cin cA cB cin wceq cA cA cort cfv cB chj co cin cB wss cA cA cort cfv
      cB chj co cin cA cB cin wceq cA cA cort cfv cB chj co cin cB wss cA cB
      cin cB wss cA cB inss2 cA cA cort cfv cB chj co cin cA cB cin cB sseq1
      mpbiri cA cA cort cfv cB chj co cin cB wss cA cA cort cfv cB chj co cin
      cA cB cin wss cA cB cin cA cA cort cfv cB chj co cin wss wa cA cA cort
      cfv cB chj co cin cA cB cin wceq cA cA cort cfv cB chj co cin cB wss cA
      cA cort cfv cB chj co cin cA cB cin wss cA cB cin cA cA cort cfv cB chj
      co cin wss cA cA cort cfv cB chj co cin cB wss cA cA cort cfv cB chj co
      cin cA wss cA cA cort cfv cB chj co cin cB wss wa cA cA cort cfv cB chj
      co cin cA cB cin wss cA cA cort cfv cB chj co cin cB wss cA cA cort cfv
      cB chj co cin cA wss cA cA cort cfv cB chj co inss1 jctl cA cA cort cfv
      cB chj co cin cA cB ssin sylib cB cA cort cfv cB chj co wss cA cB cin cA
      cA cort cfv cB chj co cin wss cB cA cort cfv pjoml2.2 cA pjoml2.1 choccli
      chub2i cB cA cort cfv cB chj co cA sslin ax-mp jctir cA cA cort cfv cB
      chj co cin cA cB cin eqss sylibr impbii bitri $.
      $( [12-Aug-2004] $) $( [6-Dec-2000] $)

    $( Comparable Hilbert lattice elements commute.  Theorem 2.3(iii) of
       [Beran] p. 40. $)
    lecmi $p |- ( A C_ B -> A C_H B ) $=
      cA cB wss cA cA cort cfv cB chj co cin cB wss cA cB ccm wbr cA cA cort
      cfv cB chj co cB ssinss1 cA cB pjoml2.1 pjoml2.2 cmbr4i sylibr $.
      $( [22-Jan-2005] $) $( [16-Jan-2005] $)

    ${
      lecmi.1 $e |- A C_ B $.
      $( Comparable Hilbert lattice elements commute.  Theorem 2.3(iii) of
         [Beran] p. 40. $)
      lecmii $p |- A C_H B $=
        cA cB wss cA cB ccm wbr lecmi.1 cA cB pjoml2.1 pjoml2.2 lecmi ax-mp $.
        $( [12-Aug-2004] $) $( [7-Aug-2004] $)
    $}

    $( A Hilbert lattice element commutes with its join. $)
    cmj1i $p |- A C_H ( A vH B ) $=
      cA cA cB chj co pjoml2.1 cA cB pjoml2.1 pjoml2.2 chjcli cA cB pjoml2.1
      pjoml2.2 chub1i lecmii $.
      $( [12-Aug-2004] $) $( [7-Aug-2004] $)

    $( A Hilbert lattice element commutes with its join. $)
    cmj2i $p |- B C_H ( A vH B ) $=
      cB cA cB chj co pjoml2.2 cA cB pjoml2.1 pjoml2.2 chjcli cB cA pjoml2.2
      pjoml2.1 chub2i lecmii $.
      $( [12-Aug-2004] $) $( [7-Aug-2004] $)

    $( A Hilbert lattice element commutes with its meet. $)
    cmm1i $p |- A C_H ( A i^i B ) $=
      cA cB cin cA cA cB pjoml2.1 pjoml2.2 chincli pjoml2.1 cA cB cin cA cA cB
      pjoml2.1 pjoml2.2 chincli pjoml2.1 cA cB inss1 lecmii cmcmii $.
      $( [13-Sep-2004] $) $( [7-Aug-2004] $)

    $( A Hilbert lattice element commutes with its meet. $)
    cmm2i $p |- B C_H ( A i^i B ) $=
      cB cB cA cin cA cB cin ccm cB cA pjoml2.2 pjoml2.1 cmm1i cB cA incom
      breqtri $.
      $( [13-Sep-2004] $) $( [7-Aug-2004] $)
  $}

  $( Alternate definition for the commutes relation.  Lemma 3 of [Kalmbach]
     p. 23. $)
  cmbr3 $p |- ( ( A e. CH /\ B e. CH ) ->
              ( A C_H B <-> ( A i^i ( ( _|_ ` A ) vH B ) ) = ( A i^i B ) ) ) $=
    cA cch wcel cB cch wcel cA cB ccm wbr cA cA cort cfv cB chj co cin cA cB
    cin wceq wb cA cch wcel cA c0h cif cB ccm wbr cA cch wcel cA c0h cif cA cch
    wcel cA c0h cif cort cfv cB chj co cin cA cch wcel cA c0h cif cB cin wceq
    wb cA cch wcel cA c0h cif cB cch wcel cB c0h cif ccm wbr cA cch wcel cA c0h
    cif cA cch wcel cA c0h cif cort cfv cB cch wcel cB c0h cif chj co cin cA
    cch wcel cA c0h cif cB cch wcel cB c0h cif cin wceq wb cA cB c0h c0h cA cA
    cch wcel cA c0h cif wceq cA cB ccm wbr cA cch wcel cA c0h cif cB ccm wbr cA
    cA cort cfv cB chj co cin cA cB cin wceq cA cch wcel cA c0h cif cA cch wcel
    cA c0h cif cort cfv cB chj co cin cA cch wcel cA c0h cif cB cin wceq cA cA
    cch wcel cA c0h cif cB ccm breq1 cA cA cch wcel cA c0h cif wceq cA cA cort
    cfv cB chj co cin cA cch wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB
    chj co cin cA cB cin cA cch wcel cA c0h cif cB cin cA cA cch wcel cA c0h
    cif wceq cA cA cch wcel cA c0h cif cA cort cfv cB chj co cA cch wcel cA c0h
    cif cort cfv cB chj co cA cA cch wcel cA c0h cif wceq id cA cA cch wcel cA
    c0h cif wceq cA cort cfv cA cch wcel cA c0h cif cort cfv cB chj cA cA cch
    wcel cA c0h cif cort fveq2 opreq1d ineq12d cA cA cch wcel cA c0h cif cB
    ineq1 eqeq12d bibi12d cB cB cch wcel cB c0h cif wceq cA cch wcel cA c0h cif
    cB ccm wbr cA cch wcel cA c0h cif cB cch wcel cB c0h cif ccm wbr cA cch
    wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB chj co cin cA cch wcel
    cA c0h cif cB cin wceq cA cch wcel cA c0h cif cA cch wcel cA c0h cif cort
    cfv cB cch wcel cB c0h cif chj co cin cA cch wcel cA c0h cif cB cch wcel cB
    c0h cif cin wceq cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif ccm breq2
    cB cB cch wcel cB c0h cif wceq cA cch wcel cA c0h cif cA cch wcel cA c0h
    cif cort cfv cB chj co cin cA cch wcel cA c0h cif cA cch wcel cA c0h cif
    cort cfv cB cch wcel cB c0h cif chj co cin cA cch wcel cA c0h cif cB cin cA
    cch wcel cA c0h cif cB cch wcel cB c0h cif cin cB cB cch wcel cB c0h cif
    wceq cA cch wcel cA c0h cif cort cfv cB chj co cA cch wcel cA c0h cif cort
    cfv cB cch wcel cB c0h cif chj co cA cch wcel cA c0h cif cB cB cch wcel cB
    c0h cif cA cch wcel cA c0h cif cort cfv chj opreq2 ineq2d cB cB cch wcel cB
    c0h cif cA cch wcel cA c0h cif ineq2 eqeq12d bibi12d cA cch wcel cA c0h cif
    cB cch wcel cB c0h cif cA c0h cch h0elch elimel cB c0h cch h0elch elimel
    cmbr3i dedth2h $.
    $( [15-Jun-2006] $) $( [14-Jun-2006] $)

  $( The zero Hilbert lattice element commutes with every element. $)
  cm0 $p |- ( A e. CH -> 0H C_H A ) $=
    cA cch wcel c0h cA ccm wbr c0h c0h cort cfv cA chj co cin c0h cA cin wceq
    cA cch wcel c0h cort cfv cA chj co c0h cin cA c0h cin c0h c0h cort cfv cA
    chj co cin c0h cA cin cA cch wcel c0h cort cfv cA chj co c0h cin c0h cA c0h
    cin cA cch wcel c0h cort cfv cA chj co cch wcel c0h cort cfv cA chj co c0h
    cin c0h wceq c0h cort cfv cch wcel cA cch wcel c0h cort cfv cA chj co cch
    wcel c0h h0elch choccli c0h cort cfv cA chjcl mpan c0h cort cfv cA chj co
    chm0 syl cA chm0 eqtr4d c0h c0h cort cfv cA chj co incom c0h cA incom
    3eqtr4g c0h cch wcel cA cch wcel c0h cA ccm wbr c0h c0h cort cfv cA chj co
    cin c0h cA cin wceq wb h0elch c0h cA cmbr3 mpan mpbird $.
    $( [18-Jun-2006] $) $( [16-Jun-2006] $)

  ${
    cmid.1 $e |- A e. CH $.
    $( The commutes relation is reflexive. $)
    cmidi $p |- A C_H A $=
      cA cA cmid.1 cmid.1 cA ssid lecmii $.
      $( [13-Sep-2004] $) $( [7-Aug-2004] $)
  $}

  $( Variation of orthomodular law.  Definition in [Kalmbach] p. 22. $)
  pjoml2 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) ->
                ( A vH ( ( _|_ ` A ) i^i B ) ) = B ) $=
    cA cch wcel cB cch wcel cA cB wss cA cA cort cfv cB cin chj co cB wceq cA
    cch wcel cB cch wcel cA cB wss cA cA cort cfv cB cin chj co cB wceq wi cA
    cch wcel cA c0h cif cB wss cA cch wcel cA c0h cif cA cch wcel cA c0h cif
    cort cfv cB cin chj co cB wceq wi cA cch wcel cA c0h cif cB cch wcel cB c0h
    cif wss cA cch wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB cch wcel
    cB c0h cif cin chj co cB cch wcel cB c0h cif wceq wi cA cB c0h c0h cA cA
    cch wcel cA c0h cif wceq cA cB wss cA cch wcel cA c0h cif cB wss cA cA cort
    cfv cB cin chj co cB wceq cA cch wcel cA c0h cif cA cch wcel cA c0h cif
    cort cfv cB cin chj co cB wceq cA cA cch wcel cA c0h cif cB sseq1 cA cA cch
    wcel cA c0h cif wceq cA cA cort cfv cB cin chj co cA cch wcel cA c0h cif cA
    cch wcel cA c0h cif cort cfv cB cin chj co cB cA cA cch wcel cA c0h cif
    wceq cA cA cch wcel cA c0h cif cA cort cfv cB cin cA cch wcel cA c0h cif
    cort cfv cB cin chj cA cA cch wcel cA c0h cif wceq id cA cA cch wcel cA c0h
    cif wceq cA cort cfv cA cch wcel cA c0h cif cort cfv cB cA cA cch wcel cA
    c0h cif cort fveq2 ineq1d opreq12d eqeq1d imbi12d cB cB cch wcel cB c0h cif
    wceq cA cch wcel cA c0h cif cB wss cA cch wcel cA c0h cif cB cch wcel cB
    c0h cif wss cA cch wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB cin
    chj co cB wceq cA cch wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB
    cch wcel cB c0h cif cin chj co cB cch wcel cB c0h cif wceq cB cB cch wcel
    cB c0h cif cA cch wcel cA c0h cif sseq2 cB cB cch wcel cB c0h cif wceq cA
    cch wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB cin chj co cA cch
    wcel cA c0h cif cA cch wcel cA c0h cif cort cfv cB cch wcel cB c0h cif cin
    chj co cB cB cch wcel cB c0h cif cB cB cch wcel cB c0h cif wceq cA cch wcel
    cA c0h cif cort cfv cB cin cA cch wcel cA c0h cif cort cfv cB cch wcel cB
    c0h cif cin cA cch wcel cA c0h cif chj cB cB cch wcel cB c0h cif cA cch
    wcel cA c0h cif cort cfv ineq2 opreq2d cB cB cch wcel cB c0h cif wceq id
    eqeq12d imbi12d cA cch wcel cA c0h cif cB cch wcel cB c0h cif cA c0h cch
    h0elch elimel cB c0h cch h0elch elimel pjoml2i dedth2h 3impia $.
    $( [27-Jun-2006] $) $( [13-Jun-2006] $)

  $( Variation of orthomodular law. $)
  pjoml3 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( B C_ A -> ( A i^i ( ( _|_ ` A ) vH B ) ) = B ) ) $=
    cA cch wcel cB cch wcel cB cA wss cA cA cort cfv cB chj co cin cB wceq wi
    cB cA cch wcel cA chil cif wss cA cch wcel cA chil cif cA cch wcel cA chil
    cif cort cfv cB chj co cin cB wceq wi cB cch wcel cB chil cif cA cch wcel
    cA chil cif wss cA cch wcel cA chil cif cA cch wcel cA chil cif cort cfv cB
    cch wcel cB chil cif chj co cin cB cch wcel cB chil cif wceq wi cA cB chil
    chil cA cA cch wcel cA chil cif wceq cB cA wss cB cA cch wcel cA chil cif
    wss cA cA cort cfv cB chj co cin cB wceq cA cch wcel cA chil cif cA cch
    wcel cA chil cif cort cfv cB chj co cin cB wceq cA cA cch wcel cA chil cif
    cB sseq2 cA cA cch wcel cA chil cif wceq cA cA cort cfv cB chj co cin cA
    cch wcel cA chil cif cA cch wcel cA chil cif cort cfv cB chj co cin cB cA
    cA cch wcel cA chil cif wceq cA cA cch wcel cA chil cif cA cort cfv cB chj
    co cA cch wcel cA chil cif cort cfv cB chj co cA cA cch wcel cA chil cif
    wceq id cA cA cch wcel cA chil cif wceq cA cort cfv cA cch wcel cA chil cif
    cort cfv cB chj cA cA cch wcel cA chil cif cort fveq2 opreq1d ineq12d
    eqeq1d imbi12d cB cB cch wcel cB chil cif wceq cB cA cch wcel cA chil cif
    wss cB cch wcel cB chil cif cA cch wcel cA chil cif wss cA cch wcel cA chil
    cif cA cch wcel cA chil cif cort cfv cB chj co cin cB wceq cA cch wcel cA
    chil cif cA cch wcel cA chil cif cort cfv cB cch wcel cB chil cif chj co
    cin cB cch wcel cB chil cif wceq cB cB cch wcel cB chil cif cA cch wcel cA
    chil cif sseq1 cB cB cch wcel cB chil cif wceq cA cch wcel cA chil cif cA
    cch wcel cA chil cif cort cfv cB chj co cin cA cch wcel cA chil cif cA cch
    wcel cA chil cif cort cfv cB cch wcel cB chil cif chj co cin cB cB cch wcel
    cB chil cif cB cB cch wcel cB chil cif wceq cA cch wcel cA chil cif cort
    cfv cB chj co cA cch wcel cA chil cif cort cfv cB cch wcel cB chil cif chj
    co cA cch wcel cA chil cif cB cB cch wcel cB chil cif cA cch wcel cA chil
    cif cort cfv chj opreq2 ineq2d cB cB cch wcel cB chil cif wceq id eqeq12d
    imbi12d cA cch wcel cA chil cif cB cch wcel cB chil cif cA chil cch helch
    elimel cB chil cch helch elimel pjoml3i dedth2h $.
    $( [13-Sep-2004] $) $( [24-Jun-2004] $)

  $( The orthomodular law.  Remark in [Kalmbach] p. 22. $)
  pjoml5 $p |- ( ( A e. CH /\ B e. CH ) ->
             ( A vH ( ( _|_ ` A ) i^i ( A vH B ) ) ) = ( A vH B ) ) $=
    cA cch wcel cA cB chj co cch wcel cA cA cB chj co wss cA cA cort cfv cA cB
    chj co cin chj co cA cB chj co wceq cA cch wcel cB cch wcel wa cA cA cB chj
    co pjoml2 cA cch wcel cB cch wcel pm3.26 cA cB chjcl cA cB chub1 syl3anc $.
    $( [30-Jun-2006] $) $( [12-Jun-2006] $)

  $( Commutation is symmetric.  Theorem 2(v) of [Kalmbach] p. 22. $)
  cmcm $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_H B <-> B C_H A ) ) $=
    cA cch wcel cB cch wcel cA cB ccm wbr cB cA ccm wbr wb cA cch wcel cA c0h
    cif cB ccm wbr cB cA cch wcel cA c0h cif ccm wbr wb cA cch wcel cA c0h cif
    cB cch wcel cB c0h cif ccm wbr cB cch wcel cB c0h cif cA cch wcel cA c0h
    cif ccm wbr wb cA cB c0h c0h cA cA cch wcel cA c0h cif wceq cA cB ccm wbr
    cA cch wcel cA c0h cif cB ccm wbr cB cA ccm wbr cB cA cch wcel cA c0h cif
    ccm wbr cA cA cch wcel cA c0h cif cB ccm breq1 cA cA cch wcel cA c0h cif cB
    ccm breq2 bibi12d cB cB cch wcel cB c0h cif wceq cA cch wcel cA c0h cif cB
    ccm wbr cA cch wcel cA c0h cif cB cch wcel cB c0h cif ccm wbr cB cA cch
    wcel cA c0h cif ccm wbr cB cch wcel cB c0h cif cA cch wcel cA c0h cif ccm
    wbr cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif ccm breq2 cB cB cch
    wcel cB c0h cif cA cch wcel cA c0h cif ccm breq1 bibi12d cA cch wcel cA c0h
    cif cB cch wcel cB c0h cif cA c0h cch h0elch elimel cB c0h cch h0elch
    elimel cmcmi dedth2h $.
    $( [14-Jun-2006] $) $( [13-Jun-2006] $)

  $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23. $)
  cmcm3 $p |- ( ( A e. CH /\ B e. CH ) ->
               ( A C_H B <-> ( _|_ ` A ) C_H B ) ) $=
    cA cch wcel cB cch wcel cA cB ccm wbr cA cort cfv cB ccm wbr wb cA cch wcel
    cA c0h cif cB ccm wbr cA cch wcel cA c0h cif cort cfv cB ccm wbr wb cA cch
    wcel cA c0h cif cB cch wcel cB c0h cif ccm wbr cA cch wcel cA c0h cif cort
    cfv cB cch wcel cB c0h cif ccm wbr wb cA cB c0h c0h cA cA cch wcel cA c0h
    cif wceq cA cB ccm wbr cA cch wcel cA c0h cif cB ccm wbr cA cort cfv cB ccm
    wbr cA cch wcel cA c0h cif cort cfv cB ccm wbr cA cA cch wcel cA c0h cif cB
    ccm breq1 cA cA cch wcel cA c0h cif wceq cA cort cfv cA cch wcel cA c0h cif
    cort cfv cB ccm cA cA cch wcel cA c0h cif cort fveq2 breq1d bibi12d cB cB
    cch wcel cB c0h cif wceq cA cch wcel cA c0h cif cB ccm wbr cA cch wcel cA
    c0h cif cB cch wcel cB c0h cif ccm wbr cA cch wcel cA c0h cif cort cfv cB
    ccm wbr cA cch wcel cA c0h cif cort cfv cB cch wcel cB c0h cif ccm wbr cB
    cB cch wcel cB c0h cif cA cch wcel cA c0h cif ccm breq2 cB cB cch wcel cB
    c0h cif cA cch wcel cA c0h cif cort cfv ccm breq2 bibi12d cA cch wcel cA
    c0h cif cB cch wcel cB c0h cif cA c0h cch h0elch elimel cB c0h cch h0elch
    elimel cmcm3i dedth2h $.
    $( [14-Jun-2006] $) $( [13-Jun-2006] $)

  $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39. $)
  cmcm2 $p |- ( ( A e. CH /\ B e. CH ) ->
               ( A C_H B <-> A C_H ( _|_ ` B ) ) ) $=
    cA cch wcel cB cch wcel wa cB cA ccm wbr cB cort cfv cA ccm wbr cA cB ccm
    wbr cA cB cort cfv ccm wbr cB cch wcel cA cch wcel cB cA ccm wbr cB cort
    cfv cA ccm wbr wb cB cA cmcm3 ancoms cA cB cmcm cA cch wcel cB cort cfv cch
    wcel cA cB cort cfv ccm wbr cB cort cfv cA ccm wbr wb cB cch wcel cA cB
    cort cfv cmcm cB choccl sylan2 3bitr4d $.
    $( [14-Jun-2006] $) $( [14-Jun-2006] $)

  $( Comparable Hilbert lattice elements commute.  Theorem 2.3(iii) of
     [Beran] p. 40. $)
  lecm $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) -> A C_H B ) $=
    cA cch wcel cB cch wcel cA cB wss cA cB ccm wbr cA cch wcel cB cch wcel cA
    cB wss cA cB ccm wbr wi cA cch wcel cA c0h cif cB wss cA cch wcel cA c0h
    cif cB ccm wbr wi cA cch wcel cA c0h cif cB cch wcel cB c0h cif wss cA cch
    wcel cA c0h cif cB cch wcel cB c0h cif ccm wbr wi cA cB c0h c0h cA cA cch
    wcel cA c0h cif wceq cA cB wss cA cch wcel cA c0h cif cB wss cA cB ccm wbr
    cA cch wcel cA c0h cif cB ccm wbr cA cA cch wcel cA c0h cif cB sseq1 cA cA
    cch wcel cA c0h cif cB ccm breq1 imbi12d cB cB cch wcel cB c0h cif wceq cA
    cch wcel cA c0h cif cB wss cA cch wcel cA c0h cif cB cch wcel cB c0h cif
    wss cA cch wcel cA c0h cif cB ccm wbr cA cch wcel cA c0h cif cB cch wcel cB
    c0h cif ccm wbr cB cB cch wcel cB c0h cif cA cch wcel cA c0h cif sseq2 cB
    cB cch wcel cB c0h cif cA cch wcel cA c0h cif ccm breq2 imbi12d cA cch wcel
    cA c0h cif cB cch wcel cB c0h cif cA c0h cch h0elch elimel cB c0h cch
    h0elch elimel lecmi dedth2h 3impia $.
    $( [20-Jun-2006] $) $( [13-Jun-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Foulis-Holland theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
     lattice elements commute, the triple is distributive.  First of two
     parts.  Theorem 5 of [Kalmbach] p. 25. $)
  fh1 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A C_H B /\ A C_H C ) )
             -> ( A i^i ( B vH C ) ) = ( ( A i^i B ) vH ( A i^i C ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa
    cA cB cin cA cC cin chj co cA cB cC chj co cin cA cB cin cA cC cin chj co
    cch wcel cA cB cC chj co cin csh wcel wa cA cB cin cA cC cin chj co cA cB
    cC chj co cin wss cA cB cC chj co cin cA cB cin cA cC cin chj co cort cfv
    cin c0h wceq wa cA cB cin cA cC cin chj co cA cB cC chj co cin wceq cA cch
    wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa cA cB
    cin cA cC cin chj co cA cB cC chj co cin pjoml cA cch wcel cB cch wcel cC
    cch wcel w3a cA cB cin cA cC cin chj co cch wcel cA cB cC chj co cin csh
    wcel wa cA cB ccm wbr cA cC ccm wbr wa cA cch wcel cB cch wcel cC cch wcel
    cA cB cin cA cC cin chj co cch wcel cA cB cC chj co cin csh wcel wa cA cch
    wcel cB cch wcel cC cch wcel wa wa cA cB cin cA cC cin chj co cch wcel cA
    cB cC chj co cin csh wcel cA cch wcel cB cch wcel cC cch wcel cA cB cin cA
    cC cin chj co cch wcel cA cB cin cch wcel cA cC cin cch wcel cA cB cin cA
    cC cin chj co cch wcel cA cch wcel cB cch wcel wa cA cch wcel cC cch wcel
    wa cA cB cin cA cC cin chjcl cA cB chincl cA cC chincl syl2an anandis cA
    cch wcel cB cch wcel cC cch wcel wa wa cA cB cC chj co cin cch wcel cA cB
    cC chj co cin csh wcel cA cch wcel cB cC chj co cch wcel cA cB cC chj co
    cin cch wcel cB cch wcel cC cch wcel wa cA cB cC chj co chincl cB cC chjcl
    sylan2 cA cB cC chj co cin chsh syl jca 3impb adantr cA cch wcel cB cch
    wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa cA cB cin cA cC cin
    chj co cA cB cC chj co cin wss cA cB cC chj co cin cA cB cin cA cC cin chj
    co cort cfv cin c0h wceq cA cch wcel cB cch wcel cC cch wcel w3a cA cB cin
    cA cC cin chj co cA cB cC chj co cin wss cA cB ccm wbr cA cC ccm wbr wa cA
    cB cC ledi adantr cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA
    cC ccm wbr wa wa cA cB cC chj co cin cA cB cin cA cC cin chj co cort cfv
    cin cB cC chj co cA cin cA cort cfv cB cort cfv chj co cA cort cfv cC cort
    cfv chj co cin cin cA cB cC chj co cB cort cfv cC cort cfv cin cin cin c0h
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB cC chj co cin cA cB cin cA cC
    cin chj co cort cfv cin cB cC chj co cA cin cA cort cfv cB cort cfv chj co
    cA cort cfv cC cort cfv chj co cin cin wceq cA cB ccm wbr cA cC ccm wbr wa
    cA cch wcel cB cch wcel cC cch wcel cA cB cC chj co cin cA cB cin cA cC cin
    chj co cort cfv cin cB cC chj co cA cin cA cort cfv cB cort cfv chj co cA
    cort cfv cC cort cfv chj co cin cin wceq cA cch wcel cB cch wcel wa cA cch
    wcel cC cch wcel wa wa cA cB cC chj co cin cB cC chj co cA cin cA cB cin cA
    cC cin chj co cort cfv cA cort cfv cB cort cfv chj co cA cort cfv cC cort
    cfv chj co cin cA cB cC chj co cin cB cC chj co cA cin wceq cA cch wcel cB
    cch wcel wa cA cch wcel cC cch wcel wa wa cA cB cC chj co incom a1i cA cch
    wcel cB cch wcel wa cA cch wcel cC cch wcel wa wa cA cB cin cA cC cin chj
    co cort cfv cA cB cin cort cfv cA cC cin cort cfv cin cA cort cfv cB cort
    cfv chj co cA cort cfv cC cort cfv chj co cin cA cB cin cch wcel cA cC cin
    cch wcel cA cB cin cA cC cin chj co cort cfv cA cB cin cort cfv cA cC cin
    cort cfv cin wceq cA cch wcel cB cch wcel wa cA cch wcel cC cch wcel wa cA
    cB cin cA cC cin chdmj1 cA cB chincl cA cC chincl syl2an cA cch wcel cB cch
    wcel wa cA cch wcel cC cch wcel wa cA cB cin cort cfv cA cort cfv cB cort
    cfv chj co cA cC cin cort cfv cA cort cfv cC cort cfv chj co cA cB chdmm1
    cA cC chdmm1 ineqan12d eqtrd ineq12d 3impdi adantr cA cch wcel cB cch wcel
    cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa cB cC chj co cA cin cA
    cort cfv cB cort cfv chj co cA cort cfv cC cort cfv chj co cin cin cB cC
    chj co cA cB cort cfv cC cort cfv cin cin cin cA cB cC chj co cB cort cfv
    cC cort cfv cin cin cin cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm
    wbr cA cC ccm wbr wa wa cB cC chj co cA cA cort cfv cB cort cfv chj co cA
    cort cfv cC cort cfv chj co cin cin cin cB cC chj co cA cB cort cfv cC cort
    cfv cin cin cin cB cC chj co cA cin cA cort cfv cB cort cfv chj co cA cort
    cfv cC cort cfv chj co cin cin cA cch wcel cB cch wcel cC cch wcel w3a cA
    cB ccm wbr cA cC ccm wbr wa wa cA cA cort cfv cB cort cfv chj co cA cort
    cfv cC cort cfv chj co cin cin cA cB cort cfv cC cort cfv cin cin cB cC chj
    co cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa
    wa cA cA cort cfv cB cort cfv chj co cin cA cA cort cfv cC cort cfv chj co
    cin cin cA cB cort cfv cin cA cC cort cfv cin cin cA cA cort cfv cB cort
    cfv chj co cA cort cfv cC cort cfv chj co cin cin cA cB cort cfv cC cort
    cfv cin cin cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm
    wbr wa wa cA cA cort cfv cB cort cfv chj co cin cA cB cort cfv cin cA cA
    cort cfv cC cort cfv chj co cin cA cC cort cfv cin cA cch wcel cB cch wcel
    cC cch wcel w3a cA cB ccm wbr cA cA cort cfv cB cort cfv chj co cin cA cB
    cort cfv cin wceq cA cC ccm wbr cA cch wcel cB cch wcel cA cB ccm wbr cA cA
    cort cfv cB cort cfv chj co cin cA cB cort cfv cin wceq cC cch wcel cA cch
    wcel cB cch wcel wa cA cB ccm wbr cA cA cort cfv cB cort cfv chj co cin cA
    cB cort cfv cin wceq cA cch wcel cB cch wcel wa cA cB ccm wbr cA cB cort
    cfv ccm wbr cA cA cort cfv cB cort cfv chj co cin cA cB cort cfv cin wceq
    cA cB cmcm2 cA cch wcel cB cort cfv cch wcel cA cB cort cfv ccm wbr cA cA
    cort cfv cB cort cfv chj co cin cA cB cort cfv cin wceq wb cB cch wcel cA
    cB cort cfv cmbr3 cB choccl sylan2 bitrd biimpa 3adantl3 adantrr cA cch
    wcel cB cch wcel cC cch wcel w3a cA cC ccm wbr cA cA cort cfv cC cort cfv
    chj co cin cA cC cort cfv cin wceq cA cB ccm wbr cA cch wcel cC cch wcel cA
    cC ccm wbr cA cA cort cfv cC cort cfv chj co cin cA cC cort cfv cin wceq cB
    cch wcel cA cch wcel cC cch wcel wa cA cC ccm wbr cA cA cort cfv cC cort
    cfv chj co cin cA cC cort cfv cin wceq cA cch wcel cC cch wcel wa cA cC ccm
    wbr cA cC cort cfv ccm wbr cA cA cort cfv cC cort cfv chj co cin cA cC cort
    cfv cin wceq cA cC cmcm2 cA cch wcel cC cort cfv cch wcel cA cC cort cfv
    ccm wbr cA cA cort cfv cC cort cfv chj co cin cA cC cort cfv cin wceq wb cC
    cch wcel cA cC cort cfv cmbr3 cC choccl sylan2 bitrd biimpa 3adantl2
    adantrl ineq12d cA cA cort cfv cB cort cfv chj co cA cort cfv cC cort cfv
    chj co inindi cA cB cort cfv cC cort cfv inindi 3eqtr4g ineq2d cB cC chj co
    cA cA cort cfv cB cort cfv chj co cA cort cfv cC cort cfv chj co cin inass
    syl5eq cB cC chj co cA cB cort cfv cC cort cfv cin in12 syl6eq cA cch wcel
    cB cch wcel cC cch wcel w3a cA cB cC chj co cB cort cfv cC cort cfv cin cin
    cin c0h wceq cA cB ccm wbr cA cC ccm wbr wa cA cch wcel cB cch wcel cC cch
    wcel cA cB cC chj co cB cort cfv cC cort cfv cin cin cin c0h wceq cB cch
    wcel cC cch wcel wa cA cch wcel cA cB cC chj co cB cort cfv cC cort cfv cin
    cin cin cA c0h cin c0h cB cch wcel cC cch wcel wa cB cC chj co cB cort cfv
    cC cort cfv cin cin c0h cA cB cch wcel cC cch wcel wa cB cC chj co cB cC
    chj co cort cfv cin cB cC chj co cB cort cfv cC cort cfv cin cin c0h cB cch
    wcel cC cch wcel wa cB cC chj co cort cfv cB cort cfv cC cort cfv cin cB cC
    chj co cB cC chdmj1 ineq2d cB cch wcel cC cch wcel wa cB cC chj co cch wcel
    cB cC chj co cB cC chj co cort cfv cin c0h wceq cB cC chjcl cB cC chj co
    chocin syl eqtr3d ineq2d cA chm0 sylan9eqr 3impb adantr 3eqtrd jca sylanc
    eqcomd $.
    $( [14-Jun-2006] $) $( [14-Jun-2006] $)

  $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
     lattice elements commute, the triple is distributive.  Second of two
     parts.  Theorem 5 of [Kalmbach] p. 25. $)
  fh2 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( B C_H A /\ B C_H C ) )
             -> ( A i^i ( B vH C ) ) = ( ( A i^i B ) vH ( A i^i C ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa
    cA cB cin cA cC cin chj co cA cB cC chj co cin cA cB cin cA cC cin chj co
    cch wcel cA cB cC chj co cin csh wcel wa cA cB cin cA cC cin chj co cA cB
    cC chj co cin wss cA cB cC chj co cin cA cB cin cA cC cin chj co cort cfv
    cin c0h wceq wa cA cB cin cA cC cin chj co cA cB cC chj co cin wceq cA cch
    wcel cB cch wcel cC cch wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cA cB
    cin cA cC cin chj co cA cB cC chj co cin pjoml cA cch wcel cB cch wcel cC
    cch wcel w3a cA cB cin cA cC cin chj co cch wcel cA cB cC chj co cin csh
    wcel wa cB cA ccm wbr cB cC ccm wbr wa cA cch wcel cB cch wcel cC cch wcel
    cA cB cin cA cC cin chj co cch wcel cA cB cC chj co cin csh wcel wa cA cch
    wcel cB cch wcel cC cch wcel wa wa cA cB cin cA cC cin chj co cch wcel cA
    cB cC chj co cin csh wcel cA cch wcel cB cch wcel cC cch wcel cA cB cin cA
    cC cin chj co cch wcel cA cB cin cch wcel cA cC cin cch wcel cA cB cin cA
    cC cin chj co cch wcel cA cch wcel cB cch wcel wa cA cch wcel cC cch wcel
    wa cA cB cin cA cC cin chjcl cA cB chincl cA cC chincl syl2an anandis cA
    cch wcel cB cch wcel cC cch wcel wa wa cA cB cC chj co cin cch wcel cA cB
    cC chj co cin csh wcel cA cch wcel cB cC chj co cch wcel cA cB cC chj co
    cin cch wcel cB cch wcel cC cch wcel wa cA cB cC chj co chincl cB cC chjcl
    sylan2 cA cB cC chj co cin chsh syl jca 3impb adantr cA cch wcel cB cch
    wcel cC cch wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cA cB cin cA cC cin
    chj co cA cB cC chj co cin wss cA cB cC chj co cin cA cB cin cA cC cin chj
    co cort cfv cin c0h wceq cA cch wcel cB cch wcel cC cch wcel w3a cA cB cin
    cA cC cin chj co cA cB cC chj co cin wss cB cA ccm wbr cB cC ccm wbr wa cA
    cB cC ledi adantr cA cch wcel cB cch wcel cC cch wcel w3a cB cA ccm wbr cB
    cC ccm wbr wa wa cA cB cC chj co cin cA cB cin cA cC cin chj co cort cfv
    cin cB cort cfv cB cC chj co cin cA cA cC cin cort cfv cin cin cB cort cfv
    cC cin cA cA cC cin cort cfv cin cin c0h cA cch wcel cB cch wcel cC cch
    wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cA cB cC chj co cin cA cB cin cA
    cC cin chj co cort cfv cin cB cort cfv cA cin cB cC chj co cA cC cin cort
    cfv cin cin cB cort cfv cB cC chj co cin cA cA cC cin cort cfv cin cin cA
    cch wcel cB cch wcel cC cch wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cA
    cB cC chj co cin cA cB cin cA cC cin chj co cort cfv cin cA cB cC chj co
    cin cA cort cfv cB cort cfv chj co cA cC cin cort cfv cin cin cB cort cfv
    cA cin cB cC chj co cA cC cin cort cfv cin cin cA cch wcel cB cch wcel cC
    cch wcel w3a cA cB cC chj co cin cA cB cin cA cC cin chj co cort cfv cin cA
    cB cC chj co cin cA cort cfv cB cort cfv chj co cA cC cin cort cfv cin cin
    wceq cB cA ccm wbr cB cC ccm wbr wa cA cch wcel cB cch wcel cC cch wcel w3a
    cA cB cin cA cC cin chj co cort cfv cA cort cfv cB cort cfv chj co cA cC
    cin cort cfv cin cA cB cC chj co cin cA cch wcel cB cch wcel cC cch wcel cA
    cB cin cA cC cin chj co cort cfv cA cort cfv cB cort cfv chj co cA cC cin
    cort cfv cin wceq cA cch wcel cB cch wcel wa cA cch wcel cC cch wcel wa wa
    cA cB cin cA cC cin chj co cort cfv cA cB cin cort cfv cA cC cin cort cfv
    cin cA cort cfv cB cort cfv chj co cA cC cin cort cfv cin cA cB cin cch
    wcel cA cC cin cch wcel cA cB cin cA cC cin chj co cort cfv cA cB cin cort
    cfv cA cC cin cort cfv cin wceq cA cch wcel cB cch wcel wa cA cch wcel cC
    cch wcel wa cA cB cin cA cC cin chdmj1 cA cB chincl cA cC chincl syl2an cA
    cch wcel cB cch wcel wa cA cch wcel cC cch wcel wa wa cA cB cin cort cfv cA
    cort cfv cB cort cfv chj co cA cC cin cort cfv cA cch wcel cB cch wcel wa
    cA cB cin cort cfv cA cort cfv cB cort cfv chj co wceq cA cch wcel cC cch
    wcel wa cA cB chdmm1 adantr ineq1d eqtrd 3impdi ineq2d adantr cA cch wcel
    cB cch wcel cC cch wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cA cA cort
    cfv cB cort cfv chj co cin cB cC chj co cA cC cin cort cfv cin cin cB cort
    cfv cA cin cB cC chj co cA cC cin cort cfv cin cin cA cB cC chj co cin cA
    cort cfv cB cort cfv chj co cA cC cin cort cfv cin cin cA cch wcel cB cch
    wcel cC cch wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cA cA cort cfv cB
    cort cfv chj co cin cB cort cfv cA cin cB cC chj co cA cC cin cort cfv cin
    cA cch wcel cB cch wcel cC cch wcel w3a cB cA ccm wbr cA cA cort cfv cB
    cort cfv chj co cin cB cort cfv cA cin wceq cB cC ccm wbr cA cch wcel cB
    cch wcel cB cA ccm wbr cA cA cort cfv cB cort cfv chj co cin cB cort cfv cA
    cin wceq cC cch wcel cA cch wcel cB cch wcel wa cB cA ccm wbr wa cA cA cort
    cfv cB cort cfv chj co cin cA cB cort cfv cin cB cort cfv cA cin cA cch
    wcel cB cch wcel wa cB cA ccm wbr cA cA cort cfv cB cort cfv chj co cin cA
    cB cort cfv cin wceq cA cch wcel cB cch wcel wa cA cB ccm wbr cA cB cort
    cfv ccm wbr cB cA ccm wbr cA cA cort cfv cB cort cfv chj co cin cA cB cort
    cfv cin wceq cA cB cmcm2 cA cB cmcm cA cch wcel cB cort cfv cch wcel cA cB
    cort cfv ccm wbr cA cA cort cfv cB cort cfv chj co cin cA cB cort cfv cin
    wceq wb cB cch wcel cA cB cort cfv cmbr3 cB choccl sylan2 3bitr3d biimpa cA
    cB cort cfv incom syl6eq 3adantl3 adantrr ineq1d cA cB cC chj co cA cort
    cfv cB cort cfv chj co cA cC cin cort cfv in4 syl5eq eqtrd cB cort cfv cA
    cB cC chj co cA cC cin cort cfv in4 syl6eq cA cch wcel cB cch wcel cC cch
    wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cB cort cfv cB cC chj co cin cB
    cort cfv cC cin cA cA cC cin cort cfv cin cA cch wcel cB cch wcel cC cch
    wcel w3a cB cA ccm wbr cB cC ccm wbr wa wa cB cort cfv cB cort cfv cort cfv
    cC chj co cin cB cort cfv cB cC chj co cin cB cort cfv cC cin cA cch wcel
    cB cch wcel cC cch wcel w3a cB cort cfv cB cort cfv cort cfv cC chj co cin
    cB cort cfv cB cC chj co cin wceq cB cA ccm wbr cB cC ccm wbr wa cB cch
    wcel cA cch wcel cB cort cfv cB cort cfv cort cfv cC chj co cin cB cort cfv
    cB cC chj co cin wceq cC cch wcel cB cch wcel cB cort cfv cort cfv cC chj
    co cB cC chj co cB cort cfv cB cch wcel cB cort cfv cort cfv cB cC chj cB
    ococ opreq1d ineq2d 3ad2ant2 adantr cA cch wcel cB cch wcel cC cch wcel w3a
    cB cC ccm wbr cB cort cfv cB cort cfv cort cfv cC chj co cin cB cort cfv cC
    cin wceq cB cA ccm wbr cB cch wcel cC cch wcel cB cC ccm wbr cB cort cfv cB
    cort cfv cort cfv cC chj co cin cB cort cfv cC cin wceq cA cch wcel cB cch
    wcel cC cch wcel wa cB cC ccm wbr cB cort cfv cB cort cfv cort cfv cC chj
    co cin cB cort cfv cC cin wceq cB cch wcel cC cch wcel wa cB cC ccm wbr cB
    cort cfv cC ccm wbr cB cort cfv cB cort cfv cort cfv cC chj co cin cB cort
    cfv cC cin wceq cB cC cmcm3 cB cort cfv cch wcel cC cch wcel cB cort cfv cC
    ccm wbr cB cort cfv cB cort cfv cort cfv cC chj co cin cB cort cfv cC cin
    wceq wb cB cch wcel cB cort cfv cC cmbr3 cB choccl sylan bitrd biimpa
    3adantl1 adantrl eqtr3d ineq1d cA cch wcel cB cch wcel cC cch wcel w3a cB
    cort cfv cC cin cA cA cC cin cort cfv cin cin c0h wceq cB cA ccm wbr cB cC
    ccm wbr wa cA cch wcel cB cch wcel cC cch wcel w3a cB cort cfv cC cin cA cA
    cC cin cort cfv cin cin cB cort cfv c0h cin c0h cA cch wcel cC cch wcel cB
    cort cfv cC cin cA cA cC cin cort cfv cin cin cB cort cfv c0h cin wceq cB
    cch wcel cA cch wcel cC cch wcel wa cB cort cfv cC cA cA cC cin cort cfv
    cin cin cin cB cort cfv c0h cin cB cort cfv cC cin cA cA cC cin cort cfv
    cin cin cA cch wcel cC cch wcel wa cC cA cA cC cin cort cfv cin cin c0h cB
    cort cfv cA cch wcel cC cch wcel wa cA cC cin cA cC cin cort cfv cin c0h cC
    cA cA cC cin cort cfv cin cin cA cch wcel cC cch wcel wa cA cC cin cch wcel
    cA cC cin cA cC cin cort cfv cin c0h wceq cA cC chincl cA cC cin chocin syl
    cC cA cA cC cin cort cfv cin cin cA cC cA cC cin cort cfv cin cin cA cC cin
    cA cC cin cort cfv cin cC cA cA cC cin cort cfv in12 cA cC cA cC cin cort
    cfv inass eqtr4i syl5eq ineq2d cB cort cfv cC cA cA cC cin cort cfv cin
    inass syl5eq 3adant2 cB cch wcel cA cch wcel cB cort cfv c0h cin c0h wceq
    cC cch wcel cB cch wcel cB cort cfv cch wcel cB cort cfv c0h cin c0h wceq
    cB choccl cB cort cfv chm0 syl 3ad2ant2 eqtrd adantr 3eqtrd jca sylanc
    eqcomd $.
    $( [15-Jun-2006] $) $( [14-Jun-2006] $)

  $( A lattice element that commutes with two others also commutes with their
     join.  Theorem 4.2 of [Beran] p. 49. $)
  cm2j $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A C_H B /\ A C_H C ) )
             -> A C_H ( B vH C ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa cA
    cB cC chj co ccm wbr cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr
    cA cC ccm wbr wa cB cC chj co cB cC chj co cA cin cB cC chj co cA cort cfv
    cin chj co wceq cA cB cC chj co ccm wbr cA cch wcel cB cch wcel cC cch wcel
    w3a cA cB ccm wbr cA cC ccm wbr wa cB cC chj co cB cC chj co cA cin cB cC
    chj co cA cort cfv cin chj co wceq cA cch wcel cB cch wcel cC cch wcel w3a
    cA cB ccm wbr cA cC ccm wbr wa wa cB cC chj co cA cB cin cA cort cfv cB cin
    chj co cA cC cin cA cort cfv cC cin chj co chj co cA cB cin cA cC cin chj
    co cA cort cfv cB cin cA cort cfv cC cin chj co chj co cB cC chj co cA cin
    cB cC chj co cA cort cfv cin chj co cA cch wcel cB cch wcel cC cch wcel w3a
    cA cB ccm wbr cA cC ccm wbr wa wa cB cA cB cin cA cort cfv cB cin chj co cC
    cA cC cin cA cort cfv cC cin chj co chj cA cch wcel cB cch wcel cC cch wcel
    w3a cA cB ccm wbr cB cA cB cin cA cort cfv cB cin chj co wceq cA cC ccm wbr
    cA cch wcel cB cch wcel cA cB ccm wbr cB cA cB cin cA cort cfv cB cin chj
    co wceq cC cch wcel cA cch wcel cB cch wcel wa cA cB ccm wbr wa cB cB cA
    cin cB cA cort cfv cin chj co cA cB cin cA cort cfv cB cin chj co cA cch
    wcel cB cch wcel wa cA cB ccm wbr cB cB cA cin cB cA cort cfv cin chj co
    wceq cA cch wcel cB cch wcel wa cA cB ccm wbr cB cA ccm wbr cB cB cA cin cB
    cA cort cfv cin chj co wceq cA cB cmcm cB cch wcel cA cch wcel cB cA ccm
    wbr cB cB cA cin cB cA cort cfv cin chj co wceq wb cB cA cmbr ancoms bitrd
    biimpa cB cA cin cA cB cin cB cA cort cfv cin cA cort cfv cB cin chj cB cA
    incom cB cA cort cfv incom opreq12i syl6eq 3adantl3 adantrr cA cch wcel cB
    cch wcel cC cch wcel w3a cA cC ccm wbr cC cA cC cin cA cort cfv cC cin chj
    co wceq cA cB ccm wbr cA cch wcel cC cch wcel cA cC ccm wbr cC cA cC cin cA
    cort cfv cC cin chj co wceq cB cch wcel cA cch wcel cC cch wcel wa cA cC
    ccm wbr wa cC cC cA cin cC cA cort cfv cin chj co cA cC cin cA cort cfv cC
    cin chj co cA cch wcel cC cch wcel wa cA cC ccm wbr cC cC cA cin cC cA cort
    cfv cin chj co wceq cA cch wcel cC cch wcel wa cA cC ccm wbr cC cA ccm wbr
    cC cC cA cin cC cA cort cfv cin chj co wceq cA cC cmcm cC cch wcel cA cch
    wcel cC cA ccm wbr cC cC cA cin cC cA cort cfv cin chj co wceq wb cC cA
    cmbr ancoms bitrd biimpa cC cA cin cA cC cin cC cA cort cfv cin cA cort cfv
    cC cin chj cC cA incom cC cA cort cfv incom opreq12i syl6eq 3adantl2
    adantrl opreq12d cA cch wcel cB cch wcel cC cch wcel w3a cA cB cin cA cort
    cfv cB cin chj co cA cC cin cA cort cfv cC cin chj co chj co cA cB cin cA
    cC cin chj co cA cort cfv cB cin cA cort cfv cC cin chj co chj co wceq cA
    cB ccm wbr cA cC ccm wbr wa cA cch wcel cB cch wcel cC cch wcel cA cB cin
    cA cort cfv cB cin chj co cA cC cin cA cort cfv cC cin chj co chj co cA cB
    cin cA cC cin chj co cA cort cfv cB cin cA cort cfv cC cin chj co chj co
    wceq cA cB cin cch wcel cA cort cfv cB cin cch wcel wa cA cC cin cch wcel
    cA cort cfv cC cin cch wcel wa cA cB cin cA cort cfv cB cin chj co cA cC
    cin cA cort cfv cC cin chj co chj co cA cB cin cA cC cin chj co cA cort cfv
    cB cin cA cort cfv cC cin chj co chj co wceq cA cch wcel cB cch wcel wa cA
    cch wcel cC cch wcel wa cA cB cin cA cort cfv cB cin cA cC cin cA cort cfv
    cC cin chj4 cA cch wcel cB cch wcel wa cA cB cin cch wcel cA cort cfv cB
    cin cch wcel cA cB chincl cA cort cfv cch wcel cB cch wcel cA cort cfv cB
    cin cch wcel cA cch wcel cA cort cfv cB chincl cA choccl sylan jca cA cch
    wcel cC cch wcel wa cA cC cin cch wcel cA cort cfv cC cin cch wcel cA cC
    chincl cA cort cfv cch wcel cC cch wcel cA cort cfv cC cin cch wcel cA cch
    wcel cA cort cfv cC chincl cA choccl sylan jca syl2an 3impdi adantr cA cch
    wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa cA cB
    cin cA cC cin chj co cB cC chj co cA cin cA cort cfv cB cin cA cort cfv cC
    cin chj co cB cC chj co cA cort cfv cin chj cA cch wcel cB cch wcel cC cch
    wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa cA cB cC chj co cin cA cB cin cA
    cC cin chj co cB cC chj co cA cin cA cB cC fh1 cA cB cC chj co incom
    syl5reqr cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm
    wbr wa wa cA cort cfv cB cC chj co cin cA cort cfv cB cin cA cort cfv cC
    cin chj co cB cC chj co cA cort cfv cin cA cort cfv cch wcel cB cch wcel cC
    cch wcel w3a cA cort cfv cB ccm wbr cA cort cfv cC ccm wbr wa cA cort cfv
    cB cC chj co cin cA cort cfv cB cin cA cort cfv cC cin chj co wceq cA cch
    wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa wa cA cort
    cfv cB cC fh1 cA cch wcel cB cch wcel cC cch wcel w3a cA cort cfv cch wcel
    cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa cA cch wcel cA
    cort cfv cch wcel cB cch wcel cB cch wcel cC cch wcel cC cch wcel cA choccl
    cB cch wcel id cC cch wcel id 3anim123i adantr cA cch wcel cB cch wcel cC
    cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa cA cort cfv cB ccm wbr cA cort
    cfv cC ccm wbr wa cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA
    cort cfv cB ccm wbr cA cC ccm wbr cA cort cfv cC ccm wbr cA cch wcel cB cch
    wcel cA cB ccm wbr cA cort cfv cB ccm wbr wb cC cch wcel cA cB cmcm3
    3adant3 cA cch wcel cC cch wcel cA cC ccm wbr cA cort cfv cC ccm wbr wb cB
    cch wcel cA cC cmcm3 3adant2 anbi12d biimpa sylanc cA cort cfv cB cC chj co
    incom syl5reqr opreq12d 3eqtrd ex cA cch wcel cB cch wcel cC cch wcel cA cB
    cC chj co ccm wbr cB cC chj co cB cC chj co cA cin cB cC chj co cA cort cfv
    cin chj co wceq wb cA cch wcel cB cC chj co cch wcel cA cB cC chj co ccm
    wbr cB cC chj co cB cC chj co cA cin cB cC chj co cA cort cfv cin chj co
    wceq wb cB cch wcel cC cch wcel wa cA cch wcel cB cC chj co cch wcel wa cA
    cB cC chj co ccm wbr cB cC chj co cA ccm wbr cB cC chj co cB cC chj co cA
    cin cB cC chj co cA cort cfv cin chj co wceq cA cB cC chj co cmcm cB cC chj
    co cch wcel cA cch wcel cB cC chj co cA ccm wbr cB cC chj co cB cC chj co
    cA cin cB cC chj co cA cort cfv cin chj co wceq wb cB cC chj co cA cmbr
    ancoms bitrd cB cC chjcl sylan2 3impb sylibrd imp $.
    $( [11-Oct-2006] $) $( [15-Jun-2006] $)

  ${
    fh1.1 $e |- A e. CH $.
    fh1.2 $e |- B e. CH $.
    fh1.3 $e |- C e. CH $.
    fh1.4 $e |- A C_H B $.
    fh1.5 $e |- A C_H C $.
    $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
       lattice elements commute, the triple is distributive.  First of two
       parts.  Theorem 5 of [Kalmbach] p. 25. $)
    fh1i $p |- ( A i^i ( B vH C ) ) = ( ( A i^i B ) vH ( A i^i C ) ) $=
      cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa cA
      cB cC chj co cin cA cB cin cA cC cin chj co wceq cA cch wcel cB cch wcel
      cC cch wcel fh1.1 fh1.2 fh1.3 3pm3.2i cA cB ccm wbr cA cC ccm wbr fh1.4
      fh1.5 pm3.2i cA cB cC fh1 mp2an $.
      $( [13-Aug-2004] $) $( [7-Aug-2004] $)

    $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
       lattice elements commute, the triple is distributive.  Second of two
       parts.  Theorem 5 of [Kalmbach] p. 25. $)
    fh2i $p |- ( B i^i ( A vH C ) ) = ( ( B i^i A ) vH ( B i^i C ) ) $=
      cB cch wcel cA cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa cB
      cA cC chj co cin cB cA cin cB cC cin chj co wceq cB cch wcel cA cch wcel
      cC cch wcel fh1.2 fh1.1 fh1.3 3pm3.2i cA cB ccm wbr cA cC ccm wbr fh1.4
      fh1.5 pm3.2i cB cA cC fh2 mp2an $.
      $( [16-Sep-2004] $) $( [7-Aug-2004] $)

    $( Variation of the Foulis-Holland Theorem. $)
    fh3i $p |- ( A vH ( B i^i C ) ) = ( ( A vH B ) i^i ( A vH C ) ) $=
      cA cB cC cin chj co cA cB chj co cA cC chj co cin wceq cA cB chj co cA cC
      chj co cin cort cfv cA cB cC cin chj co cort cfv wceq cA cB chj co cort
      cfv cA cC chj co cort cfv chj co cA cort cfv cB cC cin cort cfv cin cA cB
      chj co cA cC chj co cin cort cfv cA cB cC cin chj co cort cfv cA cort cfv
      cB cort cfv cC cort cfv chj co cin cA cort cfv cB cort cfv cin cA cort
      cfv cC cort cfv cin chj co cA cort cfv cB cC cin cort cfv cin cA cB chj
      co cort cfv cA cC chj co cort cfv chj co cA cort cfv cB cort cfv cC cort
      cfv cA fh1.1 choccli cB fh1.2 choccli cC fh1.3 choccli cA cort cfv cB cA
      fh1.1 choccli fh1.2 cA cB fh1.1 fh1.2 fh1.4 cmcm3ii cmcm2ii cA cort cfv
      cC cA fh1.1 choccli fh1.3 cA cC fh1.1 fh1.3 fh1.5 cmcm3ii cmcm2ii fh1i cB
      cC cin cort cfv cB cort cfv cC cort cfv chj co cA cort cfv cB cC fh1.2
      fh1.3 chdmm1i ineq2i cA cB chj co cort cfv cA cort cfv cB cort cfv cin cA
      cC chj co cort cfv cA cort cfv cC cort cfv cin chj cA cB fh1.1 fh1.2
      chdmj1i cA cC fh1.1 fh1.3 chdmj1i opreq12i 3eqtr4ri cA cB chj co cA cC
      chj co cA cB fh1.1 fh1.2 chjcli cA cC fh1.1 fh1.3 chjcli chdmm1i cA cB cC
      cin fh1.1 cB cC fh1.2 fh1.3 chincli chdmj1i 3eqtr4i cA cB cC cin chj co
      cA cB chj co cA cC chj co cin cA cB cC cin fh1.1 cB cC fh1.2 fh1.3
      chincli chjcli cA cB chj co cA cC chj co cA cB fh1.1 fh1.2 chjcli cA cC
      fh1.1 fh1.3 chjcli chincli chcon3i mpbir $.
      $( [22-Jan-2005] $) $( [16-Jan-2005] $)

    $( Variation of the Foulis-Holland Theorem. $)
    fh4i $p |- ( B vH ( A i^i C ) ) = ( ( B vH A ) i^i ( B vH C ) ) $=
      cB cA cC cin chj co cB cA chj co cB cC chj co cin wceq cB cA chj co cB cC
      chj co cin cort cfv cB cA cC cin chj co cort cfv wceq cB cA chj co cort
      cfv cB cC chj co cort cfv chj co cB cort cfv cA cC cin cort cfv cin cB cA
      chj co cB cC chj co cin cort cfv cB cA cC cin chj co cort cfv cB cort cfv
      cA cort cfv cC cort cfv chj co cin cB cort cfv cA cort cfv cin cB cort
      cfv cC cort cfv cin chj co cB cort cfv cA cC cin cort cfv cin cB cA chj
      co cort cfv cB cC chj co cort cfv chj co cA cort cfv cB cort cfv cC cort
      cfv cA fh1.1 choccli cB fh1.2 choccli cC fh1.3 choccli cA cort cfv cB cA
      fh1.1 choccli fh1.2 cA cB fh1.1 fh1.2 fh1.4 cmcm3ii cmcm2ii cA cort cfv
      cC cA fh1.1 choccli fh1.3 cA cC fh1.1 fh1.3 fh1.5 cmcm3ii cmcm2ii fh2i cA
      cC cin cort cfv cA cort cfv cC cort cfv chj co cB cort cfv cA cC fh1.1
      fh1.3 chdmm1i ineq2i cB cA chj co cort cfv cB cort cfv cA cort cfv cin cB
      cC chj co cort cfv cB cort cfv cC cort cfv cin chj cB cA fh1.2 fh1.1
      chdmj1i cB cC fh1.2 fh1.3 chdmj1i opreq12i 3eqtr4ri cB cA chj co cB cC
      chj co cB cA fh1.2 fh1.1 chjcli cB cC fh1.2 fh1.3 chjcli chdmm1i cB cA cC
      cin fh1.2 cA cC fh1.1 fh1.3 chincli chdmj1i 3eqtr4i cB cA cC cin chj co
      cB cA chj co cB cC chj co cin cB cA cC cin fh1.2 cA cC fh1.1 fh1.3
      chincli chjcli cB cA chj co cB cC chj co cB cA fh1.2 fh1.1 chjcli cB cC
      fh1.2 fh1.3 chjcli chincli chcon3i mpbir $.
      $( [22-Jan-2005] $) $( [16-Jan-2005] $)

    $( A lattice element that commutes with two others also commutes with their
       join.  Theorem 4.2 of [Beran] p. 49. $)
    cm2ji $p |- A C_H ( B vH C ) $=
      cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccm wbr cA cC ccm wbr wa cA
      cB cC chj co ccm wbr cA cch wcel cB cch wcel cC cch wcel fh1.1 fh1.2
      fh1.3 3pm3.2i cA cB ccm wbr cA cC ccm wbr fh1.4 fh1.5 pm3.2i cA cB cC
      cm2j mp2an $.
      $( [11-May-2009] $) $( [11-May-2009] $)

    $( A lattice element that commutes with two others also commutes with their
       meet.  Theorem 4.2 of [Beran] p. 49. $)
    cm2mi $p |- A C_H ( B i^i C ) $=
      cA cB cC cin ccm wbr cA cB cC cin cort cfv ccm wbr cA cB cort cfv cC cort
      cfv chj co cB cC cin cort cfv ccm cA cB cort cfv cC cort cfv fh1.1 cB
      fh1.2 choccli cC fh1.3 choccli cA cB fh1.1 fh1.2 fh1.4 cmcm2ii cA cC
      fh1.1 fh1.3 fh1.5 cmcm2ii cm2ji cB cC fh1.2 fh1.3 chdmm1i breqtrri cA cB
      cC cin fh1.1 cB cC fh1.2 fh1.3 chincli cmcm2i mpbir $.
      $( [11-May-2009] $) $( [11-May-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Quantum Logic Explorer axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    qlax1.1 $e |- A e. CH $.
    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-1" in the Quantum Logic Explorer.) $)
    qlax1i $p |- A = ( _|_ ` ( _|_ ` A ) ) $=
      cA cort cfv cort cfv cA cA qlax1.1 ococi eqcomi $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)
  $}

  ${
    qlax.1 $e |- A e. CH $.
    qlax.2 $e |- B e. CH $.
    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-2" in the Quantum Logic Explorer.) $)
    qlax2i $p |- ( A vH B ) = ( B vH A ) $=
      cA cB qlax.1 qlax.2 chjcomi $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)

    ${
      qlax.3 $e |- C e. CH $.
      $( One of the equations showing ` CH ` is an ortholattice.  (This
         corresponds to axiom "ax-3" in the Quantum Logic Explorer.) $)
      qlax3i $p |- ( ( A vH B ) vH C ) = ( A vH ( B vH C ) ) $=
        cA cB cC qlax.1 qlax.2 qlax.3 chjassi $.
        $( [15-Aug-2004] $) $( [4-Aug-2004] $)
    $}

    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-4" in the Quantum Logic Explorer.) $)
    qlax4i $p |- ( A vH ( B vH ( _|_ ` B ) ) ) = ( B vH ( _|_ ` B ) ) $=
      cA chil chj co chil cA cB cB cort cfv chj co chj co cB cB cort cfv chj co
      cA qlax.1 chj1i cB cB cort cfv chj co chil cA chj cB qlax.2 chjoi opreq2i
      cB qlax.2 chjoi 3eqtr4i $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)

    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-5" in the Quantum Logic Explorer.) $)
    qlax5i $p |- ( A vH ( _|_ ` ( ( _|_ ` A ) vH B ) ) ) = A $=
      cA cA cort cfv cB chj co cort cfv chj co cA cA cB cort cfv cin chj co cA
      cA cort cfv cB chj co cort cfv cA cB cort cfv cin cA chj cA cB qlax.1
      qlax.2 chdmj2i opreq2i cA cB cort cfv qlax.1 cB qlax.2 choccli chabs1i
      eqtri $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)
  $}

  ${
    qlaxr1.1 $e |- A e. CH $.
    qlaxr1.2 $e |- B e. CH $.
    qlaxr1.3 $e |- A = B $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r1" in the Quantum Logic Explorer.) $)
    qlaxr1i $p |- B = A $=
      cA cB qlaxr1.3 eqcomi $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)
  $}

  ${
    qlaxr2.1 $e |- A e. CH $.
    qlaxr2.2 $e |- B e. CH $.
    qlaxr2.3 $e |- C e. CH $.
    qlaxr2.4 $e |- A = B $.
    qlaxr2.5 $e |- B = C $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r2" in the Quantum Logic Explorer.) $)
    qlaxr2i $p |- A = C $=
      cA cB cC qlaxr2.4 qlaxr2.5 eqtri $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)
  $}

  ${
    qlaxr4.1 $e |- A e. CH $.
    qlaxr4.2 $e |- B e. CH $.
    qlaxr4.3 $e |- A = B $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r4" in the Quantum Logic Explorer.) $)
    qlaxr4i $p |- ( _|_ ` A ) = ( _|_ ` B ) $=
      cA cB cort qlaxr4.3 fveq2i $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)
  $}

  ${
    qlaxr5.1 $e |- A e. CH $.
    qlaxr5.2 $e |- B e. CH $.
    qlaxr5.3 $e |- C e. CH $.
    qlaxr5.4 $e |- A = B $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r5" in the Quantum Logic Explorer.) $)
    qlaxr5i $p |- ( A vH C ) = ( B vH C ) $=
      cA cB cC chj qlaxr5.4 opreq1i $.
      $( [15-Aug-2004] $) $( [4-Aug-2004] $)
  $}

  ${
    qlaxr3.1 $e |- A e. CH $.
    qlaxr3.2 $e |- B e. CH $.
    qlaxr3.3 $e |- C e. CH $.
    qlaxr3.4 $e |- ( C vH ( _|_ ` C ) ) =
        ( ( _|_ ` ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) vH ( _|_ ` ( A vH B ) ) ) $.
    $( A variation of the orthomodular law, showing ` CH ` is an orthomodular
       lattice.  (This corresponds to axiom "ax-r3" in the Quantum Logic
       Explorer.) $)
    qlaxr3i $p |- A = B $=
      cA cA cB chj co cB cA cA cB chj co qlaxr3.1 cA cB chj co cA cB qlaxr3.1
      qlaxr3.2 chjcli chshii cA cB qlaxr3.1 qlaxr3.2 chub1i cA cB chj co cA
      cort cfv cin c0h wceq cA cB chj co cB cort cfv cin c0h wceq cA cB chj co
      cA cort cfv cin c0h wceq cA cB chj co cB cort cfv cin c0h wceq wa cA cB
      chj co cA cort cfv cin cA cB chj co cB cort cfv cin chj co c0h wceq cA cB
      chj co cA cort cfv cB cort cfv chj co cin cA cort cfv cB cort cfv chj co
      cA cB chj co cin cA cB chj co cA cort cfv cin cA cB chj co cB cort cfv
      cin chj co c0h cA cB chj co cA cort cfv cB cort cfv chj co incom cA cB
      chj co cA cort cfv cB cort cfv cA cB qlaxr3.1 qlaxr3.2 chjcli cA qlaxr3.1
      choccli cB qlaxr3.2 choccli cA cB chj co cA cA cB qlaxr3.1 qlaxr3.2
      chjcli qlaxr3.1 cA cA cB chj co qlaxr3.1 cA cB qlaxr3.1 qlaxr3.2 chjcli
      cA cB qlaxr3.1 qlaxr3.2 cmj1i cmcmii cmcm2ii cA cB chj co cB cA cB
      qlaxr3.1 qlaxr3.2 chjcli qlaxr3.2 cB cA cB chj co qlaxr3.2 cA cB qlaxr3.1
      qlaxr3.2 chjcli cA cB qlaxr3.1 qlaxr3.2 cmj2i cmcmii cmcm2ii fh1i cA cort
      cfv cB cort cfv chj co cA cB chj co cin c0h wceq c0h cort cfv cA cort cfv
      cB cort cfv chj co cA cB chj co cin cort cfv wceq chil cA cort cfv cB
      cort cfv chj co cort cfv cA cB chj co cort cfv chj co c0h cort cfv cA
      cort cfv cB cort cfv chj co cA cB chj co cin cort cfv cC cC cort cfv chj
      co chil cA cort cfv cB cort cfv chj co cort cfv cA cB chj co cort cfv chj
      co cC qlaxr3.3 chjoi qlaxr3.4 eqtr3i choc0 cA cort cfv cB cort cfv chj co
      cA cB chj co cA cort cfv cB cort cfv cA qlaxr3.1 choccli cB qlaxr3.2
      choccli chjcli cA cB qlaxr3.1 qlaxr3.2 chjcli chdmm1i 3eqtr4i cA cort cfv
      cB cort cfv chj co cA cB chj co cin c0h cA cort cfv cB cort cfv chj co cA
      cB chj co cA cort cfv cB cort cfv cA qlaxr3.1 choccli cB qlaxr3.2 choccli
      chjcli cA cB qlaxr3.1 qlaxr3.2 chjcli chincli h0elch chcon3i mpbir
      3eqtr3i cA cB chj co cA cort cfv cin cA cB chj co cB cort cfv cin cA cB
      chj co cA cort cfv cA cB qlaxr3.1 qlaxr3.2 chjcli cA qlaxr3.1 choccli
      chincli cA cB chj co cB cort cfv cA cB qlaxr3.1 qlaxr3.2 chjcli cB
      qlaxr3.2 choccli chincli chj00i mpbir pm3.26i omlsii cB cA cB chj co
      qlaxr3.2 cA cB chj co cA cB qlaxr3.1 qlaxr3.2 chjcli chshii cB cA
      qlaxr3.2 qlaxr3.1 chub2i cA cB chj co cA cort cfv cin c0h wceq cA cB chj
      co cB cort cfv cin c0h wceq cA cB chj co cA cort cfv cin c0h wceq cA cB
      chj co cB cort cfv cin c0h wceq wa cA cB chj co cA cort cfv cin cA cB chj
      co cB cort cfv cin chj co c0h wceq cA cB chj co cA cort cfv cB cort cfv
      chj co cin cA cort cfv cB cort cfv chj co cA cB chj co cin cA cB chj co
      cA cort cfv cin cA cB chj co cB cort cfv cin chj co c0h cA cB chj co cA
      cort cfv cB cort cfv chj co incom cA cB chj co cA cort cfv cB cort cfv cA
      cB qlaxr3.1 qlaxr3.2 chjcli cA qlaxr3.1 choccli cB qlaxr3.2 choccli cA cB
      chj co cA cA cB qlaxr3.1 qlaxr3.2 chjcli qlaxr3.1 cA cA cB chj co
      qlaxr3.1 cA cB qlaxr3.1 qlaxr3.2 chjcli cA cB qlaxr3.1 qlaxr3.2 cmj1i
      cmcmii cmcm2ii cA cB chj co cB cA cB qlaxr3.1 qlaxr3.2 chjcli qlaxr3.2 cB
      cA cB chj co qlaxr3.2 cA cB qlaxr3.1 qlaxr3.2 chjcli cA cB qlaxr3.1
      qlaxr3.2 cmj2i cmcmii cmcm2ii fh1i cA cort cfv cB cort cfv chj co cA cB
      chj co cin c0h wceq c0h cort cfv cA cort cfv cB cort cfv chj co cA cB chj
      co cin cort cfv wceq chil cA cort cfv cB cort cfv chj co cort cfv cA cB
      chj co cort cfv chj co c0h cort cfv cA cort cfv cB cort cfv chj co cA cB
      chj co cin cort cfv cC cC cort cfv chj co chil cA cort cfv cB cort cfv
      chj co cort cfv cA cB chj co cort cfv chj co cC qlaxr3.3 chjoi qlaxr3.4
      eqtr3i choc0 cA cort cfv cB cort cfv chj co cA cB chj co cA cort cfv cB
      cort cfv cA qlaxr3.1 choccli cB qlaxr3.2 choccli chjcli cA cB qlaxr3.1
      qlaxr3.2 chjcli chdmm1i 3eqtr4i cA cort cfv cB cort cfv chj co cA cB chj
      co cin c0h cA cort cfv cB cort cfv chj co cA cB chj co cA cort cfv cB
      cort cfv cA qlaxr3.1 choccli cB qlaxr3.2 choccli chjcli cA cB qlaxr3.1
      qlaxr3.2 chjcli chincli h0elch chcon3i mpbir 3eqtr3i cA cB chj co cA cort
      cfv cin cA cB chj co cB cort cfv cin cA cB chj co cA cort cfv cA cB
      qlaxr3.1 qlaxr3.2 chjcli cA qlaxr3.1 choccli chincli cA cB chj co cB cort
      cfv cA cB qlaxr3.1 qlaxr3.2 chjcli cB qlaxr3.2 choccli chincli chj00i
      mpbir pm3.27i omlsii eqtr4i $.
      $( [15-Aug-2004] $) $( [7-Aug-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Orthogonal subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    osumlem1.1 $e |- A e. CH $.
    osumlem1.2 $e |- B e. CH $.
    osumlem1.3 $e |- B C_ ( _|_ ` A ) $.
    osumlem1.4 $e |- ( ph <-> ( ( ( C e. A /\ D e. B ) /\ R = ( C +h D ) )
                 /\ ( ( x e. A /\ y e. ( _|_ ` A ) ) /\ z = ( x +h y ) ) ) ) $.
    $( Lemma for ~ osumi . $)
    osumlem1 $p |- ( ph -> ( ( ( C e. ~H /\ D e. ~H ) /\
          R e. ~H ) /\ ( ( x e. ~H /\ y e. ~H ) /\ z e. ~H ) ) ) $=
      wph cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv
      cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cC chil wcel cD
      chil wcel wa cR chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv
      chil wcel wa wa osumlem1.4 cC cA wcel cD cB wcel wa cR cC cD cva co wceq
      wa cC chil wcel cD chil wcel wa cR chil wcel wa vx cv cA wcel vy cv cA
      cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa vx cv chil wcel vy cv
      chil wcel wa vz cv chil wcel wa cC chil wcel cD chil wcel wa cR cC cD cva
      co wceq cC chil wcel cD chil wcel wa cR chil wcel wa cC cA wcel cD cB
      wcel wa cC chil wcel cD chil wcel wa cR cC cD cva co wceq cR chil wcel cR
      cC cD cva co wceq cR chil wcel cC cD cva co chil wcel cC chil wcel cD
      chil wcel wa cR cC cD cva co chil eleq1 cC cD hvaddcl syl5cbir imdistani
      cC cA wcel cC chil wcel cD cB wcel cD chil wcel cC cA osumlem1.1 cheli cD
      cB osumlem1.2 cheli anim12i sylan vx cv chil wcel vy cv chil wcel wa vz
      cv vx cv vy cv cva co wceq vx cv chil wcel vy cv chil wcel wa vz cv chil
      wcel wa vx cv cA wcel vy cv cA cort cfv wcel wa vx cv chil wcel vy cv
      chil wcel wa vz cv vx cv vy cv cva co wceq vz cv chil wcel vz cv vx cv vy
      cv cva co wceq vz cv chil wcel vx cv vy cv cva co chil wcel vx cv chil
      wcel vy cv chil wcel wa vz cv vx cv vy cv cva co chil eleq1 vx cv vy cv
      hvaddcl syl5cbir imdistani vx cv cA wcel vx cv chil wcel vy cv cA cort
      cfv wcel vy cv chil wcel vx cv cA osumlem1.1 cheli vy cv cA cort cfv cA
      osumlem1.1 choccli cheli anim12i sylan anim12i sylbi $.
      $( [19-Oct-1999] $)

    $( Lemma for ~ osumi . $)
    osumlem2 $p |- ( ph -> ( ( ( normh ` ( C -h x ) ) ^ 2 ) +
                   ( ( normh ` ( D -h y ) ) ^ 2 ) ) =
                   ( ( normh ` ( R -h z ) ) ^ 2 ) ) $=
      wph cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv
      cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cC vx cv cmv co
      cno cfv c2 cexp co cD vy cv cmv co cno cfv c2 cexp co caddc co cR vz cv
      cmv co cno cfv c2 cexp co wceq osumlem1.4 cC cA wcel cD cB wcel wa cR cC
      cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa cR vz cv cmv co cno cfv c2 cexp co cC vx cv cmv co
      cD vy cv cmv co cva co cno cfv c2 cexp co cC vx cv cmv co cno cfv c2 cexp
      co cD vy cv cmv co cno cfv c2 cexp co caddc co cC cA wcel cD cB wcel wa
      cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx
      cv vy cv cva co wceq wa wa cR vz cv cmv co cno cfv cC vx cv cmv co cD vy
      cv cmv co cva co cno cfv c2 cexp cC cA wcel cD cB wcel wa cR cC cD cva co
      wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
      wceq wa wa cR vz cv cmv co cC vx cv cmv co cD vy cv cmv co cva co cno cC
      cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cR vz cv cmv co cC cD cva
      co vx cv vy cv cva co cmv co cC vx cv cmv co cD vy cv cmv co cva co cC cA
      wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa cR cC cD cva co vz cv vx cv
      vy cv cva co cmv cC cA wcel cD cB wcel wa cR cC cD cva co wceq pm3.27 vx
      cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq pm3.27
      opreqan12d cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel
      vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cC chil
      wcel cD chil wcel wa cR chil wcel wa vx cv chil wcel vy cv chil wcel wa
      vz cv chil wcel wa wa cC cD cva co vx cv vy cv cva co cmv co cC vx cv cmv
      co cD vy cv cmv co cva co wceq cC cA wcel cD cB wcel wa cR cC cD cva co
      wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
      wceq wa wa vx vy vz cA cB cC cD cR osumlem1.1 osumlem1.2 osumlem1.3 cC cA
      wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa biid osumlem1 cC chil
      wcel cD chil wcel wa vx cv chil wcel vy cv chil wcel wa cC cD cva co vx
      cv vy cv cva co cmv co cC vx cv cmv co cD vy cv cmv co cva co wceq cR
      chil wcel vz cv chil wcel cC cD vx cv vy cv hvsub4 ad2ant2r syl eqtrd
      fveq2d opreq1d cC vx cv cmv co chil wcel cD vy cv cmv co chil wcel wa cC
      vx cv cmv co cD vy cv cmv co csp co cc0 wceq cC vx cv cmv co cD vy cv cmv
      co cva co cno cfv c2 cexp co cC vx cv cmv co cno cfv c2 cexp co cD vy cv
      cmv co cno cfv c2 cexp co caddc co wceq cC cA wcel cD cB wcel wa cR cC cD
      cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv
      cva co wceq wa wa cC vx cv cmv co cD vy cv cmv co normpyth cC cA wcel cD
      cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel
      wa vz cv vx cv vy cv cva co wceq wa wa cC chil wcel cD chil wcel wa cR
      chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa cC
      vx cv cmv co chil wcel cD vy cv cmv co chil wcel wa cC cA wcel cD cB wcel
      wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv
      vx cv vy cv cva co wceq wa wa vx vy vz cA cB cC cD cR osumlem1.1
      osumlem1.2 osumlem1.3 cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx
      cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa
      biid osumlem1 cC chil wcel cD chil wcel wa vx cv chil wcel vy cv chil
      wcel wa cC vx cv cmv co chil wcel cD vy cv cmv co chil wcel wa cR chil
      wcel vz cv chil wcel cC chil wcel vx cv chil wcel cD chil wcel vy cv chil
      wcel cC vx cv cmv co chil wcel cD vy cv cmv co chil wcel wa cC chil wcel
      vx cv chil wcel wa cC vx cv cmv co chil wcel cD chil wcel vy cv chil wcel
      wa cD vy cv cmv co chil wcel cC vx cv hvsubcl cD vy cv hvsubcl anim12i
      an4s ad2ant2r syl cC cA wcel cD cB wcel wa vx cv cA wcel vy cv cA cort
      cfv wcel wa cC vx cv cmv co cD vy cv cmv co csp co cc0 wceq cR cC cD cva
      co wceq vz cv vx cv vy cv cva co wceq cC cA wcel vx cv cA wcel cD cB wcel
      vy cv cA cort cfv wcel cC vx cv cmv co cD vy cv cmv co csp co cc0 wceq cC
      vx cv cmv co cA wcel cD vy cv cmv co cA cort cfv wcel cC vx cv cmv co cD
      vy cv cmv co csp co cc0 wceq cC cA wcel vx cv cA wcel wa cD cB wcel vy cv
      cA cort cfv wcel wa cA csh wcel cC vx cv cmv co cA wcel cD vy cv cmv co
      cA cort cfv wcel wa cC vx cv cmv co cD vy cv cmv co csp co cc0 wceq wi cA
      osumlem1.1 chshii cC vx cv cmv co cD vy cv cmv co cA shocorth ax-mp cA
      csh wcel cC cA wcel vx cv cA wcel wa cC vx cv cmv co cA wcel wi cA
      osumlem1.1 chshii cC vx cv cA shsubclOLD ax-mp cD cA cort cfv wcel vy cv
      cA cort cfv wcel cD vy cv cmv co cA cort cfv wcel cD cB wcel cA cort cfv
      csh wcel cD cA cort cfv wcel vy cv cA cort cfv wcel wa cD vy cv cmv co cA
      cort cfv wcel wi cA cort cfv cA osumlem1.1 choccli chshii cD vy cv cA
      cort cfv shsubclOLD ax-mp cB cA cort cfv cD osumlem1.3 sseli sylan syl2an
      an4s ad2ant2r sylc eqtr2d sylbi $.
      $( [19-Oct-1999] $)

    $( Lemma for ~ osumi . $)
    osumlem3 $p |- ( ph ->
                   ( normh ` ( D -h y ) ) <_ ( normh ` ( R -h z ) ) ) $=
      wph cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv
      cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cD vy cv cmv co
      cno cfv cR vz cv cmv co cno cfv cle wbr osumlem1.4 cC cA wcel cD cB wcel
      wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv
      vx cv vy cv cva co wceq wa wa cD vy cv cmv co cno cfv cR vz cv cmv co cno
      cfv cle wbr cD vy cv cmv co cno cfv c2 cexp co cR vz cv cmv co cno cfv c2
      cexp co cle wbr cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA
      wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cc0 cD
      vy cv cmv co cno cfv c2 cexp co caddc co cC vx cv cmv co cno cfv c2 cexp
      co cD vy cv cmv co cno cfv c2 cexp co caddc co cD vy cv cmv co cno cfv c2
      cexp co cR vz cv cmv co cno cfv c2 cexp co cle cC cA wcel cD cB wcel wa
      cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx
      cv vy cv cva co wceq wa wa cc0 cC vx cv cmv co cno cfv c2 cexp co cle wbr
      cc0 cD vy cv cmv co cno cfv c2 cexp co caddc co cC vx cv cmv co cno cfv
      c2 cexp co cD vy cv cmv co cno cfv c2 cexp co caddc co cle wbr cC cA wcel
      cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv
      wcel wa vz cv vx cv vy cv cva co wceq wa wa cC chil wcel cD chil wcel wa
      cR chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa
      cC vx cv cmv co cno cfv cr wcel cc0 cC vx cv cmv co cno cfv c2 cexp co
      cle wbr cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy
      cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vx vy vz cA cB
      cC cD cR osumlem1.1 osumlem1.2 osumlem1.3 cC cA wcel cD cB wcel wa cR cC
      cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa biid osumlem1 cC chil wcel cD chil wcel wa cR chil
      wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa cC vx cv
      cmv co chil wcel cC vx cv cmv co cno cfv cr wcel cC chil wcel cD chil
      wcel wa vx cv chil wcel vy cv chil wcel wa cC vx cv cmv co chil wcel cR
      chil wcel vz cv chil wcel cC chil wcel vx cv chil wcel cC vx cv cmv co
      chil wcel cD chil wcel vy cv chil wcel cC vx cv hvsubcl ad2ant2r ad2ant2r
      cC vx cv cmv co normcl syl cC vx cv cmv co cno cfv sqge0 3syl cC cA wcel
      cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv
      wcel wa vz cv vx cv vy cv cva co wceq wa wa cC chil wcel cD chil wcel wa
      cR chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa
      cc0 cr wcel cC vx cv cmv co cno cfv c2 cexp co cr wcel cD vy cv cmv co
      cno cfv c2 cexp co cr wcel w3a cc0 cC vx cv cmv co cno cfv c2 cexp co cle
      wbr cc0 cD vy cv cmv co cno cfv c2 cexp co caddc co cC vx cv cmv co cno
      cfv c2 cexp co cD vy cv cmv co cno cfv c2 cexp co caddc co cle wbr wb cC
      cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vx vy vz cA cB cC cD cR
      osumlem1.1 osumlem1.2 osumlem1.3 cC cA wcel cD cB wcel wa cR cC cD cva co
      wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
      wceq wa wa biid osumlem1 cC chil wcel cD chil wcel wa cR chil wcel wa vx
      cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa cc0 cr wcel cC vx
      cv cmv co cno cfv c2 cexp co cr wcel cD vy cv cmv co cno cfv c2 cexp co
      cr wcel cc0 cr wcel cC chil wcel cD chil wcel wa cR chil wcel wa vx cv
      chil wcel vy cv chil wcel wa vz cv chil wcel wa wa 0re a1i cC chil wcel
      cD chil wcel wa cR chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv
      chil wcel wa wa cC vx cv cmv co chil wcel cC vx cv cmv co cno cfv cr wcel
      cC vx cv cmv co cno cfv c2 cexp co cr wcel cC chil wcel cD chil wcel wa
      vx cv chil wcel vy cv chil wcel wa cC vx cv cmv co chil wcel cR chil wcel
      vz cv chil wcel cC chil wcel vx cv chil wcel cC vx cv cmv co chil wcel cD
      chil wcel vy cv chil wcel cC vx cv hvsubcl ad2ant2r ad2ant2r cC vx cv cmv
      co normcl cC vx cv cmv co cno cfv resqcl 3syl cC chil wcel cD chil wcel
      wa cR chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa
      wa cD vy cv cmv co chil wcel cD vy cv cmv co cno cfv cr wcel cD vy cv cmv
      co cno cfv c2 cexp co cr wcel cC chil wcel cD chil wcel wa vx cv chil
      wcel vy cv chil wcel wa cD vy cv cmv co chil wcel cR chil wcel vz cv chil
      wcel cD chil wcel vy cv chil wcel cD vy cv cmv co chil wcel cC chil wcel
      vx cv chil wcel cD vy cv hvsubcl ad2ant2l ad2ant2r cD vy cv cmv co normcl
      cD vy cv cmv co cno cfv resqcl 3syl 3jca cc0 cC vx cv cmv co cno cfv c2
      cexp co cD vy cv cmv co cno cfv c2 cexp co leadd1 3syl mpbid cC cA wcel
      cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv
      wcel wa vz cv vx cv vy cv cva co wceq wa wa cC chil wcel cD chil wcel wa
      cR chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa
      cD vy cv cmv co cno cfv c2 cexp co cc wcel cc0 cD vy cv cmv co cno cfv c2
      cexp co caddc co cD vy cv cmv co cno cfv c2 cexp co wceq cC cA wcel cD cB
      wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa
      vz cv vx cv vy cv cva co wceq wa wa vx vy vz cA cB cC cD cR osumlem1.1
      osumlem1.2 osumlem1.3 cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx
      cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa
      biid osumlem1 cC chil wcel cD chil wcel wa cR chil wcel wa vx cv chil
      wcel vy cv chil wcel wa vz cv chil wcel wa wa cD vy cv cmv co cno cfv c2
      cexp co cC chil wcel cD chil wcel wa cR chil wcel wa vx cv chil wcel vy
      cv chil wcel wa vz cv chil wcel wa wa cD vy cv cmv co chil wcel cD vy cv
      cmv co cno cfv cr wcel cD vy cv cmv co cno cfv c2 cexp co cr wcel cC chil
      wcel cD chil wcel wa vx cv chil wcel vy cv chil wcel wa cD vy cv cmv co
      chil wcel cR chil wcel vz cv chil wcel cD chil wcel vy cv chil wcel cD vy
      cv cmv co chil wcel cC chil wcel vx cv chil wcel cD vy cv hvsubcl
      ad2ant2l ad2ant2r cD vy cv cmv co normcl cD vy cv cmv co cno cfv resqcl
      3syl recnd cD vy cv cmv co cno cfv c2 cexp co addid2 3syl cC cA wcel cD
      cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel
      wa vz cv vx cv vy cv cva co wceq wa wa vx vy vz cA cB cC cD cR osumlem1.1
      osumlem1.2 osumlem1.3 cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx
      cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa
      biid osumlem2 3brtr3d cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx
      cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa
      cC chil wcel cD chil wcel wa cR chil wcel wa vx cv chil wcel vy cv chil
      wcel wa vz cv chil wcel wa wa cD vy cv cmv co chil wcel cR vz cv cmv co
      chil wcel wa cD vy cv cmv co cno cfv cR vz cv cmv co cno cfv cle wbr cD
      vy cv cmv co cno cfv c2 cexp co cR vz cv cmv co cno cfv c2 cexp co cle
      wbr wb cC cA wcel cD cB wcel wa cR cC cD cva co wceq wa vx cv cA wcel vy
      cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vx vy vz cA cB
      cC cD cR osumlem1.1 osumlem1.2 osumlem1.3 cC cA wcel cD cB wcel wa cR cC
      cD cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa biid osumlem1 cC chil wcel cD chil wcel wa cR chil
      wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa cD vy cv
      cmv co chil wcel cR vz cv cmv co chil wcel cC chil wcel cD chil wcel wa
      vx cv chil wcel vy cv chil wcel wa cD vy cv cmv co chil wcel cR chil wcel
      vz cv chil wcel cD chil wcel vy cv chil wcel cD vy cv cmv co chil wcel cC
      chil wcel vx cv chil wcel cD vy cv hvsubcl ad2ant2l ad2ant2r cR chil wcel
      vz cv chil wcel cR vz cv cmv co chil wcel cC chil wcel cD chil wcel wa vx
      cv chil wcel vy cv chil wcel wa cR vz cv hvsubcl ad2ant2l jca cD vy cv
      cmv co cno cfv cr wcel cc0 cD vy cv cmv co cno cfv cle wbr wa cR vz cv
      cmv co cno cfv cr wcel cc0 cR vz cv cmv co cno cfv cle wbr wa cD vy cv
      cmv co cno cfv cR vz cv cmv co cno cfv cle wbr cD vy cv cmv co cno cfv c2
      cexp co cR vz cv cmv co cno cfv c2 cexp co cle wbr wb cD vy cv cmv co
      chil wcel cR vz cv cmv co chil wcel cD vy cv cmv co cno cfv cR vz cv cmv
      co cno cfv le2sq cD vy cv cmv co chil wcel cD vy cv cmv co cno cfv cr
      wcel cc0 cD vy cv cmv co cno cfv cle wbr cD vy cv cmv co normcl cD vy cv
      cmv co normge0 jca cR vz cv cmv co chil wcel cR vz cv cmv co cno cfv cr
      wcel cc0 cR vz cv cmv co cno cfv cle wbr cR vz cv cmv co normcl cR vz cv
      cmv co normge0 jca syl2an 3syl mpbird sylbi $.
      $( [19-Oct-1999] $)
  $}

  ${
    $d u v w A $.  $d u v w B $.  $d u v w F $.  $d u v w G $.  $d u v w H $.
    $d u v w x $.  $d u v w y $.  $d u v w z $.
    osumlem4.1 $e |- A e. CH $.
    osumlem4.2 $e |- B e. CH $.
    osumlem4.3 $e |- B C_ ( _|_ ` A ) $.
    osumlem4.4 $e |- G e. _V $.
    osumlem4.5 $e |- H e. _V $.
    $( Lemma for ~ osumi . $)
    osumlem4 $p |- ( ( ( ( F : NN --> A /\ G : NN --> B ) /\
                   A. w e. NN ( H ` w ) = ( ( F ` w ) +h ( G ` w ) ) )
                  /\ ( ( x e. A /\ y e. ( _|_ ` A ) ) /\ z = ( x +h y ) ) ) ->
                  ( H ~~>v z -> G ~~>v y ) ) $=
      cn cA cF wf cn cB cG wf wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co
      wceq vw cn wral wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa cH vz cv chli wbr cn chil cG wf vy cv chil wcel wa
      cc0 vu cv clt wbr vv cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv
      vu cv clt wbr wi vw cn wral vv cn wrex wi vu cr wral wa cG vy cv chli wbr
      cn cA cF wf cn cB cG wf wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co
      wceq vw cn wral wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa cH vz cv chli wbr cc0 vu cv clt wbr vv cv vw cv cle
      wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi vw cn wral vv cn
      wrex wi vu cr wral cn chil cG wf vy cv chil wcel wa cn cA cF wf cn cB cG
      wf wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co wceq vw cn wral wa vx
      cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa
      cc0 vu cv clt wbr vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co cno cfv
      vu cv clt wbr wi vw cn wral vv cn wrex wi vu cr wral cc0 vu cv clt wbr vv
      cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi vw cn
      wral vv cn wrex wi vu cr wral cH vz cv chli wbr cn cA cF wf cn cB cG wf
      wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co wceq vw cn wral wa vx cv
      cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cc0
      vu cv clt wbr vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu cv
      clt wbr wi vw cn wral vv cn wrex wi cc0 vu cv clt wbr vv cv vw cv cle wbr
      vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi vw cn wral vv cn wrex
      wi vu cr cn cA cF wf cn cB cG wf wa vw cv cH cfv vw cv cF cfv vw cv cG
      cfv cva co wceq vw cn wral wa vx cv cA wcel vy cv cA cort cfv wcel wa vz
      cv vx cv vy cv cva co wceq wa wa vu cv cr wcel wa vv cv vw cv cle wbr vw
      cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wi vw cn wral vv cn wrex vv
      cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi vw cn
      wral vv cn wrex cc0 vu cv clt wbr cn cA cF wf cn cB cG wf wa vw cv cH cfv
      vw cv cF cfv vw cv cG cfv cva co wceq vw cn wral wa vx cv cA wcel vy cv
      cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vu cv cr wcel wa
      vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wi vw
      cn wral vv cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt
      wbr wi vw cn wral vv cn cn cA cF wf cn cB cG wf wa vw cv cH cfv vw cv cF
      cfv vw cv cG cfv cva co wceq vw cn wral wa vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vu cv cr wcel wa vv cv vw
      cv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wi vv cv vw cv
      cle wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi wi vw cn wral
      vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wi vw
      cn wral vv cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt
      wbr wi vw cn wral wi cn cA cF wf cn cB cG wf wa vw cv cH cfv vw cv cF cfv
      vw cv cG cfv cva co wceq vw cn wral vx cv cA wcel vy cv cA cort cfv wcel
      wa vz cv vx cv vy cv cva co wceq wa vu cv cr wcel vv cv vw cv cle wbr vw
      cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wi vv cv vw cv cle wbr vw cv
      cG cfv vy cv cmv co cno cfv vu cv clt wbr wi wi vw cn wral cn cA cF wf cn
      cB cG wf wa vu cv cr wcel vx cv cA wcel vy cv cA cort cfv wcel wa vz cv
      vx cv vy cv cva co wceq wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co
      wceq vw cn wral vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu
      cv clt wbr wi vv cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv vu cv
      clt wbr wi wi vw cn wral cn cA cF wf cn cB cG wf wa vu cv cr wcel vx cv
      cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa vw cv
      cH cfv vw cv cF cfv vw cv cG cfv cva co wceq vw cn wral vv cv vw cv cle
      wbr vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wi vv cv vw cv cle
      wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi wi vw cn wral wi
      cn cA cF wf cn cB cG wf wa vu cv cr wcel wa vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vw cv cH cfv vw cv cF cfv
      vw cv cG cfv cva co wceq vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co
      cno cfv vu cv clt wbr wi vv cv vw cv cle wbr vw cv cG cfv vy cv cmv co
      cno cfv vu cv clt wbr wi wi vw cn cn cA cF wf cn cB cG wf wa vu cv cr
      wcel wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
      wceq wa wa vw cv cn wcel wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co
      wceq vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr vw cv cG cfv vy cv
      cmv co cno cfv vu cv clt wbr wi vv cv vw cv cle wbr vw cv cH cfv vz cv
      cmv co cno cfv vu cv clt wbr wi vv cv vw cv cle wbr vw cv cG cfv vy cv
      cmv co cno cfv vu cv clt wbr wi wi cn cA cF wf cn cB cG wf wa vu cv cr
      wcel vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
      wceq wa vw cv cn wcel vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co wceq
      vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr vw cv cG cfv vy cv cmv co
      cno cfv vu cv clt wbr wi wi vw cv cn wcel cn cA cF wf cn cB cG wf wa vu
      cv cr wcel vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva
      co wceq wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co wceq vw cv cH
      cfv vz cv cmv co cno cfv vu cv clt wbr vw cv cG cfv vy cv cmv co cno cfv
      vu cv clt wbr wi wi vw cv cn wcel cn cA cF wf cn cB cG wf wa vw cv cF cfv
      cA wcel vw cv cG cfv cB wcel wa vu cv cr wcel vx cv cA wcel vy cv cA cort
      cfv wcel wa vz cv vx cv vy cv cva co wceq wa vw cv cH cfv vw cv cF cfv vw
      cv cG cfv cva co wceq vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr vw
      cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi wi wi wi vw cv cn wcel cn
      cA cF wf vw cv cF cfv cA wcel cn cB cG wf vw cv cG cfv cB wcel cn cA cF
      wf vw cv cn wcel vw cv cF cfv cA wcel cn cA vw cv cF ffvelrn expcom cn cB
      cG wf vw cv cn wcel vw cv cG cfv cB wcel cn cB vw cv cG ffvelrn expcom
      anim12d vw cv cF cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv
      cF cfv vw cv cG cfv cva co wceq vx cv cA wcel vy cv cA cort cfv wcel wa
      vz cv vx cv vy cv cva co wceq wa vu cv cr wcel vw cv cH cfv vz cv cmv co
      cno cfv vu cv clt wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi
      vw cv cF cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv cF cfv vw
      cv cG cfv cva co wceq vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv
      vy cv cva co wceq wa vu cv cr wcel vw cv cH cfv vz cv cmv co cno cfv vu
      cv clt wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi vw cv cF
      cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv cF cfv vw cv cG
      cfv cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa vu cv cr wcel wa vw cv cG cfv vy cv cmv co cno cfv
      vw cv cH cfv vz cv cmv co cno cfv cle wbr vw cv cH cfv vz cv cmv co cno
      cfv vu cv clt wbr vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr vw cv
      cF cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv cF cfv vw cv cG
      cfv cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa vw cv cG cfv vy cv cmv co cno cfv vw cv cH cfv vz cv
      cmv co cno cfv cle wbr vu cv cr wcel vw cv cF cfv cA wcel vw cv cG cfv cB
      wcel wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co wceq wa vx cv cA
      wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa vx vy
      vz cA cB vw cv cF cfv vw cv cG cfv vw cv cH cfv osumlem4.1 osumlem4.2
      osumlem4.3 vw cv cF cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw
      cv cF cfv vw cv cG cfv cva co wceq wa vx cv cA wcel vy cv cA cort cfv
      wcel wa vz cv vx cv vy cv cva co wceq wa wa biid osumlem3 adantr vw cv cF
      cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv cF cfv vw cv cG
      cfv cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa vu cv cr wcel vw cv cG cfv vy cv cmv co cno cfv vw
      cv cH cfv vz cv cmv co cno cfv cle wbr vw cv cH cfv vz cv cmv co cno cfv
      vu cv clt wbr wa vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi vw cv
      cF cfv cA wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv cF cfv vw cv cG
      cfv cva co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa wa vw cv cF cfv chil wcel vw cv cG cfv chil wcel wa vw
      cv cH cfv chil wcel wa vx cv chil wcel vy cv chil wcel wa vz cv chil wcel
      wa wa vu cv cr wcel vw cv cG cfv vy cv cmv co cno cfv vw cv cH cfv vz cv
      cmv co cno cfv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wa
      vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi wi vw cv cF cfv cA
      wcel vw cv cG cfv cB wcel wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva
      co wceq wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva
      co wceq wa wa vx vy vz cA cB vw cv cF cfv vw cv cG cfv vw cv cH cfv
      osumlem4.1 osumlem4.2 osumlem4.3 vw cv cF cfv cA wcel vw cv cG cfv cB
      wcel wa vw cv cH cfv vw cv cF cfv vw cv cG cfv cva co wceq wa vx cv cA
      wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa biid
      osumlem1 vw cv cG cfv vy cv cmv co cno cfv cr wcel vw cv cH cfv vz cv cmv
      co cno cfv cr wcel vu cv cr wcel vw cv cG cfv vy cv cmv co cno cfv vw cv
      cH cfv vz cv cmv co cno cfv cle wbr vw cv cH cfv vz cv cmv co cno cfv vu
      cv clt wbr wa vw cv cG cfv vy cv cmv co cno cfv vu cv clt wbr wi wi vw cv
      cF cfv chil wcel vw cv cG cfv chil wcel wa vw cv cH cfv chil wcel wa vx
      cv chil wcel vy cv chil wcel wa vz cv chil wcel wa wa vw cv cG cfv vy cv
      cmv co cno cfv cr wcel vw cv cH cfv vz cv cmv co cno cfv cr wcel vu cv cr
      wcel vw cv cG cfv vy cv cmv co cno cfv vw cv cH cfv vz cv cmv co cno cfv
      cle wbr vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr wa vw cv cG cfv
      vy cv cmv co cno cfv vu cv clt wbr wi vw cv cG cfv vy cv cmv co cno cfv
      vw cv cH cfv vz cv cmv co cno cfv vu cv lelttr 3exp vw cv cF cfv chil
      wcel vw cv cG cfv chil wcel wa vx cv chil wcel vy cv chil wcel wa vw cv
      cG cfv vy cv cmv co cno cfv cr wcel vw cv cH cfv chil wcel vz cv chil
      wcel vw cv cG cfv chil wcel vy cv chil wcel vw cv cG cfv vy cv cmv co cno
      cfv cr wcel vw cv cF cfv chil wcel vx cv chil wcel vw cv cG cfv chil wcel
      vy cv chil wcel wa vw cv cG cfv vy cv cmv co chil wcel vw cv cG cfv vy cv
      cmv co cno cfv cr wcel vw cv cG cfv vy cv hvsubcl vw cv cG cfv vy cv cmv
      co normcl syl ad2ant2l ad2ant2r vw cv cH cfv chil wcel vz cv chil wcel vw
      cv cH cfv vz cv cmv co cno cfv cr wcel vw cv cF cfv chil wcel vw cv cG
      cfv chil wcel wa vx cv chil wcel vy cv chil wcel wa vw cv cH cfv chil
      wcel vz cv chil wcel wa vw cv cH cfv vz cv cmv co chil wcel vw cv cH cfv
      vz cv cmv co cno cfv cr wcel vw cv cH cfv vz cv hvsubcl vw cv cH cfv vz
      cv cmv co normcl syl ad2ant2l sylc syl imp mpand exp41 com24 syl6 com4l
      imp41 vw cv cH cfv vz cv cmv co cno cfv vu cv clt wbr vw cv cG cfv vy cv
      cmv co cno cfv vu cv clt wbr vv cv vw cv cle wbr imim2 syl6 r19.20dva
      exp31 com24 imp41 vv cv vw cv cle wbr vw cv cH cfv vz cv cmv co cno cfv
      vu cv clt wbr wi vv cv vw cv cle wbr vw cv cG cfv vy cv cmv co cno cfv vu
      cv clt wbr wi vw cn r19.20 syl r19.22sdv imim2d r19.20dva vu vv vw vz cv
      cH osumlem4.5 vz visset hlimconvi syl5 cn cA cF wf cn cB cG wf wa vw cv
      cH cfv vw cv cF cfv vw cv cG cfv cva co wceq vw cn wral wa cn chil cG wf
      vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa
      vy cv chil wcel cn cB cG wf cn chil cG wf cn cA cF wf vw cv cH cfv vw cv
      cF cfv vw cv cG cfv cva co wceq vw cn wral cn cB cG wf cB chil wss cn
      chil cG wf cB osumlem4.2 chssii cn cB chil cG fss mpan2 ad2antlr vy cv cA
      cort cfv wcel vy cv chil wcel vx cv cA wcel vz cv vx cv vy cv cva co wceq
      cA cort cfv chil vy cv cA csh wcel cA cort cfv chil wss cA osumlem4.1
      chshii cA shocss ax-mp sseli ad2antlr anim12i jctild vu vv vw vy cv cG
      osumlem4.4 vy visset hlimi syl6ibr $.
      $( [18-Oct-1999] $)
  $}

  ${
    $d x y w f g A $.  $d x y w f g B $.  $d x y w f g H $.
    osumlem5.1 $e |- A e. CH $.
    osumlem5.2 $e |- B e. CH $.
    $( Lemma for ~ osumi . $)
    osumlem5 $p |- ( H : NN --> ( A +H B ) -> E. f E. g ( ( f : NN --> A /\
     g : NN --> B ) /\ A. w e. NN ( H ` w ) = ( ( f ` w ) +h ( g ` w ) ) ) ) $=
      cn cA cB cph co cH wf vw cv cH cfv vx cv vy cv cva co wceq vy cB wrex vx
      cA wrex vw cn wral cn cA vf cv wf vw cv cH cfv vw cv vf cv cfv vy cv cva
      co wceq vy cB wrex vw cn wral wa vf wex cn cA vf cv wf cn cB vg cv wf wa
      vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vg
      wex vf wex cn cA cB cph co cH wf vw cv cH cfv vx cv vy cv cva co wceq vy
      cB wrex vx cA wrex vw cn cn cA cB cph co cH wf vw cv cn wcel vw cv cH cfv
      cA cB cph co wcel vw cv cH cfv vx cv vy cv cva co wceq vy cB wrex vx cA
      wrex cn cA cB cph co cH wf vw cv cn wcel vw cv cH cfv cA cB cph co wcel
      cn cA cB cph co vw cv cH ffvelrn ex vx vy cA cB vw cv cH cfv cA
      osumlem5.1 chshii cB osumlem5.2 chshii shseli syl6ib r19.21aiv vw cv cH
      cfv vx cv vy cv cva co wceq vy cB wrex vw cv cH cfv vw cv vf cv cfv vy cv
      cva co wceq vy cB wrex vw vx cn cA vf nnex cA cch osumlem5.1 elisseti vx
      cv vw cv vf cv cfv wceq vw cv cH cfv vx cv vy cv cva co wceq vw cv cH cfv
      vw cv vf cv cfv vy cv cva co wceq vy cB vx cv vw cv vf cv cfv wceq vx cv
      vy cv cva co vw cv vf cv cfv vy cv cva co vw cv cH cfv vx cv vw cv vf cv
      cfv vy cv cva opreq1 eqeq2d rexbidv ac6 cn cA vf cv wf vw cv cH cfv vw cv
      vf cv cfv vy cv cva co wceq vy cB wrex vw cn wral wa cn cA vf cv wf cn cB
      vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw
      cn wral wa vg wex vf cn cA vf cv wf vw cv cH cfv vw cv vf cv cfv vy cv
      cva co wceq vy cB wrex vw cn wral wa cn cA vf cv wf cn cB vg cv wf vw cv
      cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vg wex
      wa cn cA vf cv wf cn cB vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg
      cv cfv cva co wceq vw cn wral wa vg wex vw cv cH cfv vw cv vf cv cfv vy
      cv cva co wceq vy cB wrex vw cn wral cn cB vg cv wf vw cv cH cfv vw cv vf
      cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vg wex cn cA vf cv wf vw
      cv cH cfv vw cv vf cv cfv vy cv cva co wceq vw cv cH cfv vw cv vf cv cfv
      vw cv vg cv cfv cva co wceq vw vy cn cB vg nnex cB cch osumlem5.2
      elisseti vy cv vw cv vg cv cfv wceq vw cv vf cv cfv vy cv cva co vw cv vf
      cv cfv vw cv vg cv cfv cva co vw cv cH cfv vy cv vw cv vg cv cfv vw cv vf
      cv cfv cva opreq2 eqeq2d ac6 anim2i cn cA vf cv wf cn cB vg cv wf wa vw
      cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vg
      wex cn cA vf cv wf cn cB vg cv wf vw cv cH cfv vw cv vf cv cfv vw cv vg
      cv cfv cva co wceq vw cn wral wa wa vg wex cn cA vf cv wf cn cB vg cv wf
      vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vg
      wex wa cn cA vf cv wf cn cB vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw
      cv vg cv cfv cva co wceq vw cn wral wa cn cA vf cv wf cn cB vg cv wf vw
      cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa wa vg
      cn cA vf cv wf cn cB vg cv wf vw cv cH cfv vw cv vf cv cfv vw cv vg cv
      cfv cva co wceq vw cn wral anass exbii cn cA vf cv wf cn cB vg cv wf vw
      cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vg
      19.42v bitri sylibr 19.22i 3syl $.
      $( [18-Oct-1999] $)
  $}

  ${
    $d w f g A $.  $d w f g B $.  $d w f g H $.
    $d w f g x $.  $d w f g y $.  $d w f g z $.
    osumlem6.1 $e |- A e. CH $.
    osumlem6.2 $e |- B e. CH $.
    osumlem6.3 $e |- B C_ ( _|_ ` A ) $.
    osumlem6.4 $e |- H e. _V $.
    $( Lemma for ~ osumi . $)
    osumlem6 $p |- ( ( ( H : NN --> ( A +H B ) /\ H ~~>v z )
                  /\ ( ( x e. A /\ y e. ( _|_ ` A ) ) /\ z = ( x +h y ) ) ) ->
                  y e. B ) $=
      cn cA cB cph co cH wf cH vz cv chli wbr vx cv cA wcel vy cv cA cort cfv
      wcel wa vz cv vx cv vy cv cva co wceq wa vy cv cB wcel cn cA cB cph co cH
      wf cn cA vf cv wf cn cB vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg
      cv cfv cva co wceq vw cn wral wa vg wex vf wex cH vz cv chli wbr vx cv cA
      wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa vy cv cB
      wcel wi wi vw cA cB vf vg cH osumlem6.1 osumlem6.2 osumlem5 cn cA vf cv
      wf cn cB vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co
      wceq vw cn wral wa cH vz cv chli wbr vx cv cA wcel vy cv cA cort cfv wcel
      wa vz cv vx cv vy cv cva co wceq wa vy cv cB wcel wi wi vf vg cn cA vf cv
      wf cn cB vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co
      wceq vw cn wral wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy
      cv cva co wceq wa cH vz cv chli wbr vy cv cB wcel cn cA vf cv wf cn cB vg
      cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn
      wral wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
      wceq wa cH vz cv chli wbr vy cv cB wcel cn cB vg cv wf vg cv vy cv chli
      wbr vy cv cB wcel cn cA vf cv wf cn cB vg cv wf wa vw cv cH cfv vw cv vf
      cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa vx cv cA wcel vy cv cA
      cort cfv wcel wa vz cv vx cv vy cv cva co wceq wa wa cH vz cv chli wbr wa
      cB cch wcel cn cB vg cv wf vg cv vy cv chli wbr vy cv cB wcel osumlem6.2
      vy cv vg cv cB vy visset chlimi mp3an1 cn cA vf cv wf cn cB vg cv wf wa
      vw cv cH cfv vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral wa cn
      cB vg cv wf vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva
      co wceq wa cH vz cv chli wbr cn cA vf cv wf cn cB vg cv wf vw cv cH cfv
      vw cv vf cv cfv vw cv vg cv cfv cva co wceq vw cn wral simplr ad2antrr cn
      cA vf cv wf cn cB vg cv wf wa vw cv cH cfv vw cv vf cv cfv vw cv vg cv
      cfv cva co wceq vw cn wral wa vx cv cA wcel vy cv cA cort cfv wcel wa vz
      cv vx cv vy cv cva co wceq wa wa cH vz cv chli wbr vg cv vy cv chli wbr
      vx vy vz vw cA cB vf cv vg cv cH osumlem6.1 osumlem6.2 osumlem6.3 vg
      visset osumlem6.4 osumlem4 imp sylanc exp31 com23 19.23aivv syl imp31 $.
      $( [19-Oct-1999] $)
  $}

  ${
    $d x y z h A $.  $d x y z h B $.
    osumlem7.1 $e |- A e. CH $.
    osumlem7.2 $e |- B e. CH $.
    ${
      osumlem7.3 $e |- B C_ ( _|_ ` A ) $.
      $( Lemma for ~ osumi . $)
      osumlem7 $p |- ( A +H B ) e. CH $=
        cA cB cph co cch wcel cA cB cph co csh wcel cn cA cB cph co vh cv wf vh
        cv vz cv chli wbr wa vz cv cA cB cph co wcel wi vz wal vh wal vz vh cA
        cB cph co closedsub cA cB cA osumlem7.1 chshii cB osumlem7.2 chshii
        shscli cn cA cB cph co vh cv wf vh cv vz cv chli wbr wa vz cv cA cB cph
        co wcel wi vh vz cn cA cB cph co vh cv wf vh cv vz cv chli wbr wa vz cv
        vx cv vy cv cva co wceq vy cA cort cfv wrex vx cA wrex vz cv cA cB cph
        co wcel vh cv vz cv chli wbr vz cv vx cv vy cv cva co wceq vy cA cort
        cfv wrex vx cA wrex cn cA cB cph co vh cv wf vh cv vz cv chli wbr vz cv
        chil wcel vz cv vx cv vy cv cva co wceq vy cA cort cfv wrex vx cA wrex
        vz cv vh cv vh visset vz visset hlimveci cA cch wcel vz cv chil wcel vz
        cv vx cv vy cv cva co wceq vy cA cort cfv wrex vx cA wrex osumlem7.1 vx
        vy vz cv cA pjpjth mpan syl adantl cn cA cB cph co vh cv wf vh cv vz cv
        chli wbr wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv
        cva co wceq wa vy wex vx wex vz cv cA cB cph co wcel vz cv vx cv vy cv
        cva co wceq vy cA cort cfv wrex vx cA wrex cn cA cB cph co vh cv wf vh
        cv vz cv chli wbr wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx
        cv vy cv cva co wceq wa vz cv cA cB cph co wcel vx vy cn cA cB cph co
        vh cv wf vh cv vz cv chli wbr wa vx cv cA wcel vy cv cA cort cfv wcel
        wa vz cv vx cv vy cv cva co wceq wa vz cv cA cB cph co wcel cn cA cB
        cph co vh cv wf vh cv vz cv chli wbr wa vx cv cA wcel vy cv cA cort cfv
        wcel wa vz cv vx cv vy cv cva co wceq wa wa vz cv cA cB cph co wcel vx
        cv vy cv cva co cA cB cph co wcel vx cv cA wcel vy cv cB wcel vx cv vy
        cv cva co cA cB cph co wcel cn cA cB cph co vh cv wf vh cv vz cv chli
        wbr wa vx cv cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co
        wceq wa wa cA cB vx cv vy cv cA osumlem7.1 chshii cB osumlem7.2 chshii
        shsvai vx cv cA wcel vy cv cA cort cfv wcel wa vx cv cA wcel cn cA cB
        cph co vh cv wf vh cv vz cv chli wbr wa vz cv vx cv vy cv cva co wceq
        vx cv cA wcel vy cv cA cort cfv wcel pm3.26 ad2antrl vx vy vz cA cB vh
        cv osumlem7.1 osumlem7.2 osumlem7.3 vh visset osumlem6 sylanc vz cv vx
        cv vy cv cva co wceq vz cv cA cB cph co wcel vx cv vy cv cva co cA cB
        cph co wcel wb cn cA cB cph co vh cv wf vh cv vz cv chli wbr wa vx cv
        cA wcel vy cv cA cort cfv wcel wa vz cv vx cv vy cv cva co cA cB cph co
        eleq1 ad2antll mpbird ex 19.23advv vz cv vx cv vy cv cva co wceq vx vy
        cA cA cort cfv r2ex syl5ib mpd gen2 mpbir2an $.
        $( [19-Oct-1999] $)
    $}

    $( Lemma for ~ osumi . $)
    osumlem8 $p |- ( B C_ ( _|_ ` A ) -> ( A +H B ) e. CH ) $=
      cB cA cort cfv wss cA cB cph co cch wcel cB cA cort cfv wss cA c0h cif cB
      cph co cch wcel cB cA cort cfv wss cA c0h cif cB cA cort cfv wss cB c0h
      cif cph co cch wcel cA cB c0h c0h cA cB cA cort cfv wss cA c0h cif wceq
      cA cB cph co cB cA cort cfv wss cA c0h cif cB cph co cch cA cB cA cort
      cfv wss cA c0h cif cB cph opreq1 eleq1d cB cB cA cort cfv wss cB c0h cif
      wceq cB cA cort cfv wss cA c0h cif cB cph co cB cA cort cfv wss cA c0h
      cif cB cA cort cfv wss cB c0h cif cph co cch cB cB cA cort cfv wss cB c0h
      cif cB cA cort cfv wss cA c0h cif cph opreq2 eleq1d cB cA cort cfv wss cA
      c0h cif cB cA cort cfv wss cB c0h cif cB cA cort cfv wss cA c0h cch
      osumlem7.1 h0elch keepel cB cA cort cfv wss cB c0h cch osumlem7.2 h0elch
      keepel cB cA cort cfv wss cB cB cA cort cfv wss cA c0h cif cort cfv wss
      cB cA cort cfv wss cB c0h cif cB cA cort cfv wss cA c0h cif cort cfv wss
      c0h c0h cort cfv wss cA cB c0h c0h c0h cB cA cort cfv wss cA c0h cif cort
      cfv wss cA cB cA cort cfv wss cA c0h cif wceq cA cort cfv cB cA cort cfv
      wss cA c0h cif cort cfv cB cA cB cA cort cfv wss cA c0h cif cort fveq2
      sseq2d cB cB cA cort cfv wss cB c0h cif cB cA cort cfv wss cA c0h cif
      cort cfv sseq1 c0h cB cA cort cfv wss cA c0h cif wceq c0h cort cfv cB cA
      cort cfv wss cA c0h cif cort cfv c0h c0h cB cA cort cfv wss cA c0h cif
      cort fveq2 sseq2d c0h cB cA cort cfv wss cB c0h cif cB cA cort cfv wss cA
      c0h cif cort cfv sseq1 c0h chil c0h cort cfv c0h h0elch chssii choc0
      sseqtr4i elimhyp2v osumlem7 dedth2v $.
      $( [19-Oct-1999] $)

    $( If two closed subspaces of a Hilbert space are orthogonal, their
       subspace sum equals their subspace join.  Lemma 3 of [Kalmbach] p. 67.
       Note that the Axiom of Choice is used for this proof (in ~ osumlem5
       and via ~ pjpjth in ~ osumlem7 ). $)
    osumi $p |- ( A C_ ( _|_ ` B ) -> ( A +H B ) = ( A vH B ) ) $=
      cA cB cort cfv wss cA cB cph co cA cB chj co wss cA cB chj co cA cB cph
      co wss wa cA cB cph co cA cB chj co wceq cA cB cort cfv wss cA cB chj co
      cA cB cph co wss cA cB cph co cA cB chj co wss cA cB cort cfv wss cA cB
      cph co cch wcel cA cB chj co cA cB cph co wss cA cB cort cfv wss cB cA
      cph co cch cA cB cph co cB cA osumlem7.2 osumlem7.1 osumlem8 cA cB cA
      osumlem7.1 chshii cB osumlem7.2 chshii shscomi syl5eqel cA cB cph co cch
      wcel cA cB cun cort cfv cort cfv cA cB cph co cort cfv cort cfv wss cA cB
      chj co cA cB cph co wss cA cB cun cA cB cph co wss cA cB cun cort cfv
      cort cfv cA cB cph co cort cfv cort cfv wss cA cB cA osumlem7.1 chshii cB
      osumlem7.2 chshii shunssi cA cB cun cA cB cph co cA cB chil cA osumlem7.1
      chssii cB osumlem7.2 chssii unssi cA cB cph co cA cB cA osumlem7.1 chshii
      cB osumlem7.2 chshii shscli shssii occon2i ax-mp cA cB cph co cch wcel cA
      cB cun cort cfv cort cfv cA cB chj co cA cB cph co cort cfv cort cfv cA
      cB cph co cA cB cun cort cfv cort cfv cA cB chj co wceq cA cB cph co cch
      wcel cA cB chj co cA cB cun cort cfv cort cfv cA cB osumlem7.1 osumlem7.2
      chjvali eqcomi a1i cA cB cph co ococ sseq12d mpbii syl cA cB osumlem7.1
      osumlem7.2 chsleji jctil cA cB cph co cA cB chj co eqss sylibr $.
      $( [24-Nov-2004] $) $( [28-Oct-1999] $)

    $( Corollary of ~ osumi . $)
    osumcori $p |- ( ( A i^i B ) +H ( A i^i ( _|_ ` B ) ) ) =
                  ( ( A i^i B ) vH ( A i^i ( _|_ ` B ) ) ) $=
      cA cB cin cA cB cort cfv cin cort cfv wss cA cB cin cA cB cort cfv cin
      cph co cA cB cin cA cB cort cfv cin chj co wceq cA cB cin cA cort cfv cB
      chj co cA cB cort cfv cin cort cfv cA cB cin cB cA cort cfv cB chj co cA
      cB inss2 cB cA cort cfv osumlem7.2 cA osumlem7.1 choccli chub2i sstri cA
      cB osumlem7.1 osumlem7.2 chdmm3i sseqtr4i cA cB cin cA cB cort cfv cin cA
      cB osumlem7.1 osumlem7.2 chincli cA cB cort cfv osumlem7.1 cB osumlem7.2
      choccli chincli osumi ax-mp $.
      $( [13-Jan-2005] $) $( [5-Nov-2000] $)
  $}

  $( If two closed subspaces of a Hilbert space are orthogonal, their subspace
     sum equals their subspace join.  Lemma 3 of [Kalmbach] p. 67. $)
  osum $p |- ( ( A e. CH /\ B e. CH /\ A C_ ( _|_ ` B ) ) ->
             ( A +H B ) = ( A vH B ) ) $=
    cA cch wcel cB cch wcel cA cB cort cfv wss cA cB cph co cA cB chj co wceq
    cA cch wcel cB cch wcel cA cB cort cfv wss cA cB cph co cA cB chj co wceq
    wi cA cch wcel cA chil cif cB cort cfv wss cA cch wcel cA chil cif cB cph
    co cA cch wcel cA chil cif cB chj co wceq wi cA cch wcel cA chil cif cB cch
    wcel cB chil cif cort cfv wss cA cch wcel cA chil cif cB cch wcel cB chil
    cif cph co cA cch wcel cA chil cif cB cch wcel cB chil cif chj co wceq wi
    cA cB chil chil cA cA cch wcel cA chil cif wceq cA cB cort cfv wss cA cch
    wcel cA chil cif cB cort cfv wss cA cB cph co cA cB chj co wceq cA cch wcel
    cA chil cif cB cph co cA cch wcel cA chil cif cB chj co wceq cA cA cch wcel
    cA chil cif cB cort cfv sseq1 cA cA cch wcel cA chil cif wceq cA cB cph co
    cA cch wcel cA chil cif cB cph co cA cB chj co cA cch wcel cA chil cif cB
    chj co cA cA cch wcel cA chil cif cB cph opreq1 cA cA cch wcel cA chil cif
    cB chj opreq1 eqeq12d imbi12d cB cB cch wcel cB chil cif wceq cA cch wcel
    cA chil cif cB cort cfv wss cA cch wcel cA chil cif cB cch wcel cB chil cif
    cort cfv wss cA cch wcel cA chil cif cB cph co cA cch wcel cA chil cif cB
    chj co wceq cA cch wcel cA chil cif cB cch wcel cB chil cif cph co cA cch
    wcel cA chil cif cB cch wcel cB chil cif chj co wceq cB cB cch wcel cB chil
    cif wceq cB cort cfv cB cch wcel cB chil cif cort cfv cA cch wcel cA chil
    cif cB cB cch wcel cB chil cif cort fveq2 sseq2d cB cB cch wcel cB chil cif
    wceq cA cch wcel cA chil cif cB cph co cA cch wcel cA chil cif cB cch wcel
    cB chil cif cph co cA cch wcel cA chil cif cB chj co cA cch wcel cA chil
    cif cB cch wcel cB chil cif chj co cB cB cch wcel cB chil cif cA cch wcel
    cA chil cif cph opreq2 cB cB cch wcel cB chil cif cA cch wcel cA chil cif
    chj opreq2 eqeq12d imbi12d cA cch wcel cA chil cif cB cch wcel cB chil cif
    cA chil cch helch elimel cB chil cch helch elimel osumi dedth2h 3impia $.
    $( [12-Jan-2006] $) $( [31-Oct-2005] $)

  $( The subspace sum of a closed subspace and its complement is all of
     Hilbert space. $)
  chso $p |- ( A e. CH -> ( A +H ( _|_ ` A ) ) = ~H ) $=
    cA cch wcel cA cA cort cfv cph co cA cA cort cfv chj co chil cA cch wcel cA
    cort cfv cch wcel cA cA cort cfv cort cfv wss cA cA cort cfv cph co cA cA
    cort cfv chj co wceq cA choccl cA cch wcel cA csh wcel cA cA cort cfv cort
    cfv wss cA chsh cA shococss syl cA cA cort cfv osum mpd3an23 cA chjo eqtrd
    $.
    $( [17-Jan-2006] $) $( [31-Oct-2005] $)

  ${
    osumcor2.1 $e |- A e. CH $.
    osumcor2.2 $e |- B e. CH $.
    $( Corollary of ~ osumi , showing it holds under the weaker hypothesis
       that ` A ` and ` B ` commute. $)
    osumcor2i $p |- ( A C_H B ->
                   ( A +H B ) = ( A vH B ) ) $=
      cA cB ccm wbr cA cB cph co cA cB chj co wss cA cB chj co cA cB cph co wss
      wa cA cB cph co cA cB chj co wceq cA cB ccm wbr cA cB chj co cA cB cph co
      wss cA cB cph co cA cB chj co wss cA cB ccm wbr cA cA cort cfv cB cort
      cfv chj co cin cB cort cfv wss cA cB chj co cA cB cph co wss cA cB ccm
      wbr cA cB cort cfv ccm wbr cA cA cort cfv cB cort cfv chj co cin cB cort
      cfv wss cA cB osumcor2.1 osumcor2.2 cmcm2i cA cB cort cfv osumcor2.1 cB
      osumcor2.2 choccli cmbr4i bitri cA cA cort cfv cB cort cfv chj co cin cB
      cort cfv wss cA cA cort cfv cB cort cfv chj co cin cB cph co cA cA cort
      cfv cB cort cfv chj co cin cB chj co wceq cA cB chj co cA cB cph co wss
      cA cA cort cfv cB cort cfv chj co cin cB cA cA cort cfv cB cort cfv chj
      co osumcor2.1 cA cort cfv cB cort cfv cA osumcor2.1 choccli cB osumcor2.2
      choccli chjcli chincli osumcor2.2 osumi cA cA cort cfv cB cort cfv chj co
      cin cB cph co cA cA cort cfv cB cort cfv chj co cin cB chj co wceq cA cA
      cort cfv cB cort cfv chj co cin cB cph co cA cB chj co wceq cA cB chj co
      cA cB cph co wss cA cA cort cfv cB cort cfv chj co cin cB chj co cA cB
      chj co cA cA cort cfv cB cort cfv chj co cin cB cph co cA cA cort cfv cB
      cort cfv chj co cin cB chj co cB cA cB cort cfv cA cort cfv chj co cin
      chj co cB cA chj co cA cB chj co cA cA cort cfv cB cort cfv chj co cin cB
      chj co cA cB cort cfv cA cort cfv chj co cin cB chj co cB cA cB cort cfv
      cA cort cfv chj co cin chj co cA cA cort cfv cB cort cfv chj co cin cA cB
      cort cfv cA cort cfv chj co cin cB chj cA cort cfv cB cort cfv chj co cB
      cort cfv cA cort cfv chj co cA cA cort cfv cB cort cfv cA osumcor2.1
      choccli cB osumcor2.2 choccli chjcomi ineq2i opreq1i cA cB cort cfv cA
      cort cfv chj co cin cB cA cB cort cfv cA cort cfv chj co osumcor2.1 cB
      cort cfv cA cort cfv cB osumcor2.2 choccli cA osumcor2.1 choccli chjcli
      chincli osumcor2.2 chjcomi eqtri cB cA osumcor2.2 osumcor2.1 pjoml4i cB
      cA osumcor2.2 osumcor2.1 chjcomi 3eqtri eqeq2i cA cA cort cfv cB cort cfv
      chj co cin cB cph co cA cB chj co wceq cA cA cort cfv cB cort cfv chj co
      cin cB cph co cA cB cph co wss cA cB chj co cA cB cph co wss cA cA cort
      cfv cB cort cfv chj co cin cA wss cA cA cort cfv cB cort cfv chj co cin
      cB cph co cA cB cph co wss cA cA cort cfv cB cort cfv chj co inss1 cA cA
      cort cfv cB cort cfv chj co cin cA cB cA cA cort cfv cB cort cfv chj co
      cin cA cA cort cfv cB cort cfv chj co osumcor2.1 cA cort cfv cB cort cfv
      cA osumcor2.1 choccli cB osumcor2.2 choccli chjcli chincli chshii cA
      osumcor2.1 chshii cB osumcor2.2 chshii shlessi ax-mp cA cA cort cfv cB
      cort cfv chj co cin cB cph co cA cB chj co cA cB cph co sseq1 mpbii sylbi
      syl sylbi cA cB osumcor2.1 osumcor2.2 chsleji jctil cA cB cph co cA cB
      chj co eqss sylibr $.
      $( [13-Jan-2005] $) $( [6-Dec-2000] $)
  $}

  ${
    spansnj.1 $e |- A e. CH $.
    spansnj.2 $e |- B e. ~H $.
    $( The subspace sum of a closed subspace and a one-dimensional subspace
       equals their join.  (Proof suggested by Eric Schechter 1-Jun-2004.) $)
    spansnji $p |- ( A +H ( span ` { B } ) ) = ( A vH ( span ` { B } ) ) $=
      cA cB csn cspn cfv chj co cA cB csn cspn cfv cph co cort cfv cort cfv cA
      cB csn cspn cfv cph co cA cB csn cspn cfv cA spansnj.1 chshii cB csn cspn
      cfv cB spansnj.2 spansnchi chshii shjshsi cA cB csn cspn cfv cph co cA cB
      csn cspn cfv cph co cA cB cA cort cfv cpj cfv cfv csn cspn cfv chj co cch
      cA cB cA cort cfv cpj cfv cfv csn cspn cfv chj co cA cB csn cun cspn cfv
      cA cspn cfv cB csn cspn cfv cph co cA cB csn cspn cfv cph co cA cB cA
      cort cfv cpj cfv cfv csn cun cspn cfv cA cspn cfv cB cA cort cfv cpj cfv
      cfv csn cspn cfv cph co cA cB csn cun cspn cfv cA cB cA cort cfv cpj cfv
      cfv csn cspn cfv chj co cA cB cA cort cfv cpj cfv cfv csn cA spansnj.1
      chssii cB cA cort cfv cpj cfv cfv chil wcel cB cA cort cfv cpj cfv cfv
      csn chil wss cB cA cort cfv cA spansnj.1 choccli spansnj.2 pjhclii cB cA
      cort cfv cpj cfv cfv chil snssi ax-mp spanuni cA cB spansnj.1 spansnj.2
      spanunsni cA cspn cfv cB cA cort cfv cpj cfv cfv csn cspn cfv cph co cA
      cB cA cort cfv cpj cfv cfv csn cspn cfv cph co cA cB cA cort cfv cpj cfv
      cfv csn cspn cfv chj co cA cspn cfv cA cB cA cort cfv cpj cfv cfv csn
      cspn cfv cph cA csh wcel cA cspn cfv cA wceq cA spansnj.1 chshii cA
      spanid ax-mp opreq1i cA cB cA cort cfv cpj cfv cfv csn cspn cfv cort cfv
      wss cA cB cA cort cfv cpj cfv cfv csn cspn cfv cph co cA cB cA cort cfv
      cpj cfv cfv csn cspn cfv chj co wceq cA cB cA spansnj.1 chssii spansnj.2
      spansnpji cA cB cA cort cfv cpj cfv cfv csn cspn cfv spansnj.1 cB cA cort
      cfv cpj cfv cfv cB cA cort cfv cA spansnj.1 choccli spansnj.2 pjhclii
      spansnchi osumi ax-mp eqtr2i 3eqtr4ri cA cB csn cA spansnj.1 chssii cB
      chil wcel cB csn chil wss spansnj.2 cB chil snssi ax-mp spanuni cA cspn
      cfv cA cB csn cspn cfv cph cA csh wcel cA cspn cfv cA wceq cA spansnj.1
      chshii cA spanid ax-mp opreq1i 3eqtrri cA cB cA cort cfv cpj cfv cfv csn
      cspn cfv spansnj.1 cB cA cort cfv cpj cfv cfv cB cA cort cfv cA spansnj.1
      choccli spansnj.2 pjhclii spansnchi chjcli eqeltri ococi eqtr2i $.
      $( [24-Nov-2004] $) $( [1-Jun-2004] $)
  $}

  $( The subspace sum of a closed subspace and a one-dimensional subspace
     equals their join. $)
  spansnj $p |- ( ( A e. CH /\ B e. ~H ) ->
              ( A +H ( span ` { B } ) ) = ( A vH ( span ` { B } ) ) ) $=
    cA cch wcel cB chil wcel cA cB csn cspn cfv cph co cA cB csn cspn cfv chj
    co wceq cA cch wcel cA chil cif cB csn cspn cfv cph co cA cch wcel cA chil
    cif cB csn cspn cfv chj co wceq cA cch wcel cA chil cif cB chil wcel cB c0v
    cif csn cspn cfv cph co cA cch wcel cA chil cif cB chil wcel cB c0v cif csn
    cspn cfv chj co wceq cA cB chil c0v cA cA cch wcel cA chil cif wceq cA cB
    csn cspn cfv cph co cA cch wcel cA chil cif cB csn cspn cfv cph co cA cB
    csn cspn cfv chj co cA cch wcel cA chil cif cB csn cspn cfv chj co cA cA
    cch wcel cA chil cif cB csn cspn cfv cph opreq1 cA cA cch wcel cA chil cif
    cB csn cspn cfv chj opreq1 eqeq12d cB cB chil wcel cB c0v cif wceq cA cch
    wcel cA chil cif cB csn cspn cfv cph co cA cch wcel cA chil cif cB chil
    wcel cB c0v cif csn cspn cfv cph co cA cch wcel cA chil cif cB csn cspn cfv
    chj co cA cch wcel cA chil cif cB chil wcel cB c0v cif csn cspn cfv chj co
    cB cB chil wcel cB c0v cif wceq cB csn cspn cfv cB chil wcel cB c0v cif csn
    cspn cfv cA cch wcel cA chil cif cph cB cB chil wcel cB c0v cif wceq cB csn
    cB chil wcel cB c0v cif csn cspn cB cB chil wcel cB c0v cif sneq fveq2d
    opreq2d cB cB chil wcel cB c0v cif wceq cB csn cspn cfv cB chil wcel cB c0v
    cif csn cspn cfv cA cch wcel cA chil cif chj cB cB chil wcel cB c0v cif
    wceq cB csn cB chil wcel cB c0v cif csn cspn cB cB chil wcel cB c0v cif
    sneq fveq2d opreq2d eqeq12d cA cch wcel cA chil cif cB chil wcel cB c0v cif
    cA chil cch helch elimel cB c0v chil ax-hv0cl elimel spansnji dedth2h $.
    $( [22-Dec-2004] $) $( [4-Jun-2004] $)

  $( The subspace sum of a closed subspace and a one-dimensional subspace
     is closed. $)
  spansnscl $p |- ( ( A e. CH /\ B e. ~H ) ->
              ( A +H ( span ` { B } ) ) e. CH ) $=
    cA cch wcel cB chil wcel wa cA cB csn cspn cfv cph co cA cB csn cspn cfv
    chj co cch cA cB spansnj cA cch wcel cB csn cspn cfv cch wcel cA cB csn
    cspn cfv chj co cch wcel cB chil wcel cA cB csn cspn cfv chjcl cB spansnch
    sylan2 eqeltrd $.
    $( [22-Dec-2004] $) $( [17-Dec-2004] $)

  $( The sum of two vectors belong to the span of one of them iff the other
     vector also belongs. $)
  sumspansn $p |- ( ( A e. ~H /\ B e. ~H ) ->
           ( ( A +h B ) e. ( span ` { A } ) <-> B e. ( span ` { A } ) ) ) $=
    cA chil wcel cB chil wcel wa cA cB cva co cA csn cspn cfv wcel cB cA csn
    cspn cfv wcel cA chil wcel cB chil wcel wa cA cB cva co cA csn cspn cfv
    wcel cA cB cva co cA cmv co cA csn cspn cfv wcel cB cA csn cspn cfv wcel cA
    chil wcel cA cB cva co cA csn cspn cfv wcel cA cB cva co cA cmv co cA csn
    cspn cfv wcel wi cB chil wcel cA chil wcel cA cB cva co cA csn cspn cfv
    wcel cA cA csn cspn cfv wcel cA cB cva co cA cmv co cA csn cspn cfv wcel cA
    spansnid cA chil wcel cA csn cspn cfv csh wcel cA cB cva co cA csn cspn cfv
    wcel cA cA csn cspn cfv wcel wa cA cB cva co cA cmv co cA csn cspn cfv wcel
    wi cA spansnsh cA cB cva co cA cA csn cspn cfv shsubclOLD syl mpan2d adantr
    cA chil wcel cB chil wcel wa cA cB cva co cA cmv co cB cA csn cspn cfv cA
    cB hvpncan2 eleq1d sylibd cA chil wcel cB cA csn cspn cfv wcel cA cB cva co
    cA csn cspn cfv wcel wi cB chil wcel cA chil wcel cA cA csn cspn cfv wcel
    cB cA csn cspn cfv wcel cA cB cva co cA csn cspn cfv wcel cA spansnid cA
    chil wcel cA csn cspn cfv csh wcel cA cA csn cspn cfv wcel cB cA csn cspn
    cfv wcel wa cA cB cva co cA csn cspn cfv wcel wi cA spansnsh cA cB cA csn
    cspn cfv shaddclOLD syl mpand adantr impbid $.
    $( [4-Feb-2006] $) $( [1-Nov-2005] $)

  ${
    $d x A $.  $d x B $.
    spansnm0.1 $e |- A e. ~H $.
    spansnm0.2 $e |- B e. ~H $.
    $( The meet of different one-dimensional subspaces is the zero subspace. $)
    spansnm0i $p |- ( -. A e. ( span ` { B } ) ->
                   ( ( span ` { A } ) i^i ( span ` { B } ) ) = 0H ) $=
      cA cB csn cspn cfv wcel wn cA csn cspn cfv cB csn cspn cfv cin c0h wss cA
      csn cspn cfv cB csn cspn cfv cin c0h wceq cA cB csn cspn cfv wcel wn vx
      cA csn cspn cfv cB csn cspn cfv cin c0h cA cB csn cspn cfv wcel wn vx cv
      cA csn cspn cfv wcel vx cv cB csn cspn cfv wcel wa vx cv c0v wceq vx cv
      cA csn cspn cfv cB csn cspn cfv cin wcel vx cv c0h wcel cA cB csn cspn
      cfv wcel wn vx cv cA csn cspn cfv wcel vx cv cB csn cspn cfv wcel wa vx
      cv c0v wceq cA chil wcel cA cB csn cspn cfv wcel wn vx cv cA csn cspn cfv
      wcel vx cv cB csn cspn cfv wcel wa vx cv c0v wceq spansnm0.1 cB csn cspn
      cfv csh wcel cA chil wcel cA cB csn cspn cfv wcel wn wa vx cv cA csn cspn
      cfv wcel vx cv cB csn cspn cfv wcel wa wa vx cv c0v wceq wi cB csn cspn
      cfv cB spansnm0.2 spansnchi chshii cB csn cspn cfv cA vx cv elspansn5
      ax-mp mpanl1 ex vx cv cA csn cspn cfv cB csn cspn cfv elin vx cv elch0
      3imtr4g ssrdv cA csn cspn cfv cB csn cspn cfv cin cA csn cspn cfv cB csn
      cspn cfv cA spansnm0.1 spansnchi cB spansnm0.2 spansnchi chincli chle0i
      sylib $.
      $( [11-Feb-2006] $) $( [1-Nov-2005] $)
  $}

  ${
    nonbool.1 $e |- A e. ~H $.
    nonbool.2 $e |- B e. ~H $.
    nonbool.3 $e |- F = ( span ` { A } ) $.
    nonbool.4 $e |- G = ( span ` { B } ) $.
    nonbool.5 $e |- H = ( span ` { ( A +h B ) } ) $.
    $( A Hilbert lattice with two or more dimensions fails the distributive law
       and therefore cannot be a Boolean algebra.  This counterexample
       demonstrates a condition where ` ( ( H i^i F ) vH ( H i^i G ) ) = 0H `
       but ` ( H i^i ( F vH G ) ) =/= 0H ` .  The antecedent specifies that the
       vectors ` A ` and ` B ` are nonzero and non-colinear.  The last three
       hypotheses assign one-dimensional subspaces to ` F ` , ` G ` , and
       ` H ` . $)
    nonbooli $p |- ( -. ( A e. G \/ B e. F ) ->
                  ( H i^i ( F vH G ) ) =/= ( ( H i^i F ) vH ( H i^i G ) ) ) $=
      cA cG wcel wn cB cF wcel wn wa cH cF cG chj co cin cH cF cin cH cG cin
      chj co wceq wn cA cG wcel cB cF wcel wo wn cH cF cG chj co cin cH cF cin
      cH cG cin chj co wne cH cF cG chj co cin c0h wceq wn cH cF cin cH cG cin
      chj co c0h wceq cH cF cG chj co cin cH cF cin cH cG cin chj co wceq wn cA
      cG wcel wn cB cF wcel wn wa cH cF cin cH cG cin chj co c0h wceq cH cF cG
      chj co cin cH cF cin cH cG cin chj co wceq wn cH cF cG chj co cin c0h
      wceq wn cH cF cin cH cG cin chj co c0h wceq cH cF cG chj co cin cH cF cin
      cH cG cin chj co wceq cH cF cG chj co cin c0h wceq cH cF cin cH cG cin
      chj co c0h cH cF cG chj co cin eqeq2 notbid biimparc cB cF wcel wn cH cF
      cG chj co cin c0h wceq wn cA cG wcel wn cH cF cG chj co cin c0h wceq cB
      cF wcel cH cF cG chj co cin c0h wceq cA cB cva co cA csn cspn cfv wcel cB
      cF wcel cH cF cG chj co cin c0h wceq cA cB cva co c0v cA csn cspn cfv cH
      cF cG chj co cin c0h wceq cA cB cva co c0h wcel cA cB cva co c0v wceq cH
      cF cG chj co cin c0h wceq cA cB cva co cH cF cG chj co cin wcel cA cB cva
      co c0h wcel cA cB cva co cH cF cG chj co cin wcel cA cB cva co cH wcel cA
      cB cva co cF cG chj co wcel cA cB cva co cH cF cG chj co elin cA cB cva
      co cA cB cva co csn cspn cfv cH cA cB cva co chil wcel cA cB cva co cA cB
      cva co csn cspn cfv wcel cA cB nonbool.1 nonbool.2 hvaddcli cA cB cva co
      spansnid ax-mp nonbool.5 eleqtrri cF cG cph co cF cG chj co cA cB cva co
      cF cG cF cA csn cspn cfv csh nonbool.3 cA csn cspn cfv cA nonbool.1
      spansnchi chshii eqeltri cG cB csn cspn cfv csh nonbool.4 cB csn cspn cfv
      cB nonbool.2 spansnchi chshii eqeltri shsleji cA cF wcel cB cG wcel cA cB
      cva co cF cG cph co wcel cA cA csn cspn cfv cF cA chil wcel cA cA csn
      cspn cfv wcel nonbool.1 cA spansnid ax-mp nonbool.3 eleqtrri cB cB csn
      cspn cfv cG cB chil wcel cB cB csn cspn cfv wcel nonbool.2 cB spansnid
      ax-mp nonbool.4 eleqtrri cF cG cA cB cF cA csn cspn cfv csh nonbool.3 cA
      csn cspn cfv cA nonbool.1 spansnchi chshii eqeltri cG cB csn cspn cfv csh
      nonbool.4 cB csn cspn cfv cB nonbool.2 spansnchi chshii eqeltri shsvai
      mp2an sselii mpbir2an cH cF cG chj co cin c0h cA cB cva co eleq2 mpbii cA
      cB cva co elch0 sylib cA csn cspn cfv cch wcel c0v cA csn cspn cfv wcel
      cA nonbool.1 spansnchi cA csn cspn cfv ch0 ax-mp syl6eqel cB cF wcel cB
      cA csn cspn cfv wcel cA cB cva co cA csn cspn cfv wcel cF cA csn cspn cfv
      cB nonbool.3 eleq2i cA chil wcel cB chil wcel cA cB cva co cA csn cspn
      cfv wcel cB cA csn cspn cfv wcel wb nonbool.1 nonbool.2 cA cB sumspansn
      mp2an bitr4i sylibr con3i adantl cA cG wcel wn cB cF wcel wn wa cH cF cin
      cH cG cin chj co c0h c0h chj co c0h cB cF wcel wn cA cG wcel wn cH cF cin
      c0h cH cG cin c0h chj cA cB cva co cA csn cspn cfv wcel wn cA cB cva co
      csn cspn cfv cA csn cspn cfv cin c0h wceq cB cF wcel wn cH cF cin c0h
      wceq cA cB cva co cA cA cB nonbool.1 nonbool.2 hvaddcli nonbool.1
      spansnm0i cB cF wcel cA cB cva co cA csn cspn cfv wcel cB cF wcel cB cA
      csn cspn cfv wcel cA cB cva co cA csn cspn cfv wcel cF cA csn cspn cfv cB
      nonbool.3 eleq2i cA chil wcel cB chil wcel cA cB cva co cA csn cspn cfv
      wcel cB cA csn cspn cfv wcel wb nonbool.1 nonbool.2 cA cB sumspansn mp2an
      bitr4i notbii cH cF cin cA cB cva co csn cspn cfv cA csn cspn cfv cin c0h
      cH cA cB cva co csn cspn cfv cF cA csn cspn cfv nonbool.5 nonbool.3
      ineq12i eqeq1i 3imtr4i cA cB cva co cB csn cspn cfv wcel wn cA cB cva co
      csn cspn cfv cB csn cspn cfv cin c0h wceq cA cG wcel wn cH cG cin c0h
      wceq cA cB cva co cB cA cB nonbool.1 nonbool.2 hvaddcli nonbool.2
      spansnm0i cA cG wcel cA cB cva co cB csn cspn cfv wcel cB cA cva co cB
      csn cspn cfv wcel cA cB csn cspn cfv wcel cA cB cva co cB csn cspn cfv
      wcel cA cG wcel cB chil wcel cA chil wcel cB cA cva co cB csn cspn cfv
      wcel cA cB csn cspn cfv wcel wb nonbool.2 nonbool.1 cB cA sumspansn mp2an
      cA cB cva co cB cA cva co cB csn cspn cfv cA cB nonbool.1 nonbool.2
      hvcomi eleq1i cG cB csn cspn cfv cA nonbool.4 eleq2i 3bitr4ri notbii cH
      cG cin cA cB cva co csn cspn cfv cB csn cspn cfv cin c0h cH cA cB cva co
      csn cspn cfv cG cB csn cspn cfv nonbool.5 nonbool.4 ineq12i eqeq1i
      3imtr4i opreqan12rd c0h h0elch chj0i syl6eq sylanc cA cG wcel cB cF wcel
      ioran cH cF cG chj co cin cH cF cin cH cG cin chj co df-ne 3imtr4i $.
      $( [12-Feb-2006] $) $( [1-Nov-2005] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    spansncv.1 $e |- A e. CH $.
    spansncv.2 $e |- B e. CH $.
    spansncv.3 $e |- C e. ~H $.
    $( Hilbert space has the covering property (using spans of singletons to
       represent atoms).  Exercise 5 of [Kalmbach] p. 153. $)
    spansncvi $p |- ( ( A C. B /\ B C_ ( A vH ( span ` { C } ) ) ) ->
                   B = ( A vH ( span ` { C } ) ) ) $=
      cA cB wpss cB cA cC csn cspn cfv chj co wss wa cB cA cC csn cspn cfv chj
      co cA cB wpss cB cA cC csn cspn cfv chj co wss pm3.27 cA cB wss cC csn
      cspn cfv cB wss cA cC csn cspn cfv chj co cB wss cA cB wpss cB cA cC csn
      cspn cfv chj co wss wa cA cC csn cspn cfv cB spansncv.1 cC spansncv.3
      spansnchi spansncv.2 chlubii cA cB wpss cA cB wss cB cA cC csn cspn cfv
      chj co wss cA cB pssss adantr cB cA cC csn cspn cfv chj co wss cA cB wpss
      cC csn cspn cfv cB wss cB cA cC csn cspn cfv chj co wss cA cB wpss cC csn
      cspn cfv cB wss cB cA cC csn cspn cfv chj co wss cA cB wpss cA cB wpss cC
      csn cspn cfv cB wss wi cB cA cC csn cspn cfv chj co wss cA cB wpss wa vx
      cv cB wcel vx cv cA wcel wn wa vx wex cC csn cspn cfv cB wss cA cB wpss
      cB cA cC csn cspn cfv chj co wss cA cB wpss wa vx cv cB wcel vx cv cA
      wcel wn wa cC csn cspn cfv cB wss vx cB cA cC csn cspn cfv chj co wss cA
      cB wpss wa vx cv cB wcel vx cv cA wcel wn cC csn cspn cfv cB wss cB cA cC
      csn cspn cfv chj co wss cA cB wpss vx cv cB wcel vx cv cA wcel wn cC csn
      cspn cfv cB wss wi cB cA cC csn cspn cfv chj co wss vx cv cB wcel wa cA
      cB wpss vx cv cB wcel wa vx cv cA wcel wn cC csn cspn cfv cB wss wi cB cA
      cC csn cspn cfv chj co wss vx cv cB wcel wa vx cv cA cC csn cspn cfv chj
      co wcel cA cB wpss vx cv cB wcel wa vx cv cA wcel wn cC csn cspn cfv cB
      wss wi wi cB cA cC csn cspn cfv chj co vx cv ssel2 vx cv cA cC csn cspn
      cfv chj co wcel vx cv vy cv vz cv cva co wceq vz cC csn cspn cfv wrex vy
      cA wrex cA cB wpss vx cv cB wcel wa vx cv cA wcel wn cC csn cspn cfv cB
      wss wi wi vx cv cA cC csn cspn cfv chj co wcel vx cv cA cC csn cspn cfv
      cph co wcel vx cv vy cv vz cv cva co wceq vz cC csn cspn cfv wrex vy cA
      wrex cA cC csn cspn cfv cph co cA cC csn cspn cfv chj co vx cv cA cC
      spansncv.1 spansncv.3 spansnji eleq2i vy vz cA cC csn cspn cfv vx cv
      spansncv.1 cC spansncv.3 spansnchi chseli bitr3i vx cv vy cv vz cv cva co
      wceq cA cB wpss vx cv cB wcel wa vx cv cA wcel wn cC csn cspn cfv cB wss
      wi wi vy vz cA cC csn cspn cfv vy cv cA wcel vz cv cC csn cspn cfv wcel
      wa vx cv vy cv vz cv cva co wceq cA cB wpss vx cv cB wcel wa vx cv cA
      wcel wn cC csn cspn cfv cB wss vy cv cA wcel vz cv cC csn cspn cfv wcel
      wa vx cv vy cv vz cv cva co wceq wa cA cB wpss vx cv cB wcel wa vx cv cA
      wcel wn wa wa vz cv cB wcel cC csn cspn cfv cB wss vy cv cA wcel vz cv cC
      csn cspn cfv wcel wa vx cv vy cv vz cv cva co wceq wa cA cB wpss vx cv cB
      wcel wa vz cv cB wcel vx cv cA wcel wn vy cv cA wcel vz cv cC csn cspn
      cfv wcel vx cv vy cv vz cv cva co wceq cA cB wpss vx cv cB wcel wa vz cv
      cB wcel vy cv cA wcel vz cv cC csn cspn cfv wcel vx cv vy cv vz cv cva co
      wceq cA cB wpss vx cv cB wcel wa vz cv cB wcel vy cv cA wcel vz cv cC csn
      cspn cfv wcel vx cv vy cv vz cv cva co wceq cA cB wpss vx cv cB wcel wa
      wa vz cv cB wcel vy cv cA wcel vz cv cC csn cspn cfv wcel wa vy cv cA
      wcel vx cv vy cv vz cv cva co wceq cA cB wpss vx cv cB wcel wa wa wa vz
      cv cB wcel vy cv cA wcel vz cv cC csn cspn cfv wcel wa vy cv vz cv cva co
      vy cv cmv co cB wcel vz cv cB wcel vy cv cA wcel vx cv vy cv vz cv cva co
      wceq cA cB wpss vx cv cB wcel wa wa wa vy cv cA wcel vz cv cC csn cspn
      cfv wcel wa vy cv vz cv cva co vy cv cmv co vz cv cB vy cv chil wcel vz
      cv chil wcel vy cv vz cv cva co vy cv cmv co vz cv wceq vy cv cA wcel vz
      cv cC csn cspn cfv wcel vy cv vz cv hvpncan2 vy cv cA spansncv.1 cheli vz
      cv cC csn cspn cfv cC spansncv.3 spansnchi cheli syl2an eleq1d vy cv cA
      wcel vx cv vy cv vz cv cva co wceq cA cB wpss vx cv cB wcel vy cv vz cv
      cva co vy cv cmv co cB wcel vx cv cB wcel vx cv vy cv vz cv cva co wceq
      cA cB wpss vy cv cA wcel vy cv vz cv cva co vy cv cmv co cB wcel vx cv cB
      wcel vx cv vy cv vz cv cva co wceq cA cB wpss vy cv cA wcel vy cv vz cv
      cva co vy cv cmv co cB wcel vy cv vz cv cva co cB wcel vy cv cB wcel vy
      cv vz cv cva co vy cv cmv co cB wcel vx cv cB wcel vx cv vy cv vz cv cva
      co wceq wa cA cB wpss vy cv cA wcel wa cB csh wcel vy cv vz cv cva co cB
      wcel vy cv cB wcel wa vy cv vz cv cva co vy cv cmv co cB wcel wi cB
      spansncv.2 chshii vy cv vz cv cva co vy cv cB shsubclOLD ax-mp vx cv vy
      cv vz cv cva co wceq vx cv cB wcel vy cv vz cv cva co cB wcel vx cv vy cv
      vz cv cva co cB eleq1 biimpac cA cB wss vy cv cA wcel vy cv cB wcel cA cB
      wpss cA cB vy cv ssel2 cA cB pssss sylan syl2an exp43 com14 imp45 syl5bi
      imp anandis exp45 imp41 adantrr vy cv cA wcel vz cv cC csn cspn cfv wcel
      wa vx cv vy cv vz cv cva co wceq wa vx cv cA wcel wn vz cv cB wcel cC csn
      cspn cfv cB wss wi cA cB wpss vx cv cB wcel wa vy cv cA wcel vz cv cC csn
      cspn cfv wcel vx cv vy cv vz cv cva co wceq vx cv cA wcel wn vz cv cB
      wcel cC csn cspn cfv cB wss wi vz cv cC csn cspn cfv wcel vy cv cA wcel
      vx cv vy cv vz cv cva co wceq vx cv cA wcel wn vz cv cB wcel cC csn cspn
      cfv cB wss wi wi wi vz cv cC csn cspn cfv wcel vy cv cA wcel vx cv vy cv
      vz cv cva co wceq vx cv cA wcel wn vz cv cB wcel cC csn cspn cfv cB wss
      wi vz cv cC csn cspn cfv wcel vz cv c0v wne vz cv cB wcel cC csn cspn cfv
      cB wss wi vy cv cA wcel vx cv vy cv vz cv cva co wceq wa vx cv cA wcel wn
      wa vz cv c0v wne vz cv cC csn cspn cfv wcel vz cv cB wcel cC csn cspn cfv
      cB wss wi vz cv c0v wne vz cv cC csn cspn cfv wcel wa vz cv csn cspn cfv
      cB wss cC csn cspn cfv cB wss vz cv cB wcel vz cv c0v wne vz cv cC csn
      cspn cfv wcel wa vz cv csn cspn cfv cC csn cspn cfv cB vz cv c0v wne vz
      cv cC csn cspn cfv wcel vz cv csn cspn cfv cC csn cspn cfv wceq cC chil
      wcel vz cv c0v wne vz cv cC csn cspn cfv wcel vz cv csn cspn cfv cC csn
      cspn cfv wceq wi spansncv.3 vz cv cC spansneleq mpan imp sseq1d cB csh
      wcel vz cv cB wcel vz cv csn cspn cfv cB wss cB spansncv.2 chshii cB vz
      cv spansnss mpan syl5bi ancoms vy cv cA wcel vx cv vy cv vz cv cva co
      wceq wa vx cv cA wcel wn vz cv c0v wne vy cv cA wcel vx cv vy cv vz cv
      cva co wceq wa vx cv cA wcel vz cv c0v vy cv cA wcel vx cv vy cv vz cv
      cva co wceq vz cv c0v wceq vx cv cA wcel wi vy cv cA wcel vz cv c0v wceq
      vx cv vy cv vz cv cva co wceq vx cv cA wcel vy cv cA wcel vz cv c0v wceq
      vx cv vy cv vz cv cva co wceq vx cv cA wcel wi vy cv cA wcel vz cv c0v
      wceq wa vx cv vy cv vz cv cva co wceq vx cv vy cv wceq vx cv cA wcel vy
      cv cA wcel vz cv c0v wceq wa vy cv vz cv cva co vy cv vx cv vz cv c0v
      wceq vy cv cA wcel vy cv vz cv cva co vy cv c0v cva co vy cv vz cv c0v vy
      cv cva opreq2 vy cv cA wcel vy cv chil wcel vy cv c0v cva co vy cv wceq
      vy cv cA spansncv.1 cheli vy cv ax-hvaddid syl sylan9eqr eqeq2d vy cv cA
      wcel vx cv vy cv wceq vx cv cA wcel wi vz cv c0v wceq vy cv cA vx cv
      eleq1a adantr sylbid ex com23 imp necon3bd imp sylan2 exp44 com12 imp41
      adantrl mpd exp43 r19.23aivv sylbi syl imp anandirs expimpd 19.23adv vx
      cA cB pssnel syl5 ex pm2.43d impcom sylanc eqssd $.
      $( [30-Jul-2008] $) $( [7-Jun-2004] $)
  $}

  $( Hilbert space has the covering property (using spans of singletons to
     represent atoms).  Exercise 5 of [Kalmbach] p. 153. $)
  spansncv $p |- ( ( A e. CH /\ B e. CH /\ C e. ~H ) ->
                  ( ( A C. B /\ B C_ ( A vH ( span ` { C } ) ) )
                 -> B = ( A vH ( span ` { C } ) ) ) ) $=
    cA cch wcel cB cch wcel cC chil wcel cA cB wpss cB cA cC csn cspn cfv chj
    co wss wa cB cA cC csn cspn cfv chj co wceq wi cA cch wcel cA chil cif cB
    wpss cB cA cch wcel cA chil cif cC csn cspn cfv chj co wss wa cB cA cch
    wcel cA chil cif cC csn cspn cfv chj co wceq wi cA cB cC chil chil c0v cA
    cch wcel cA chil cif cB cch wcel cB chil cif wpss cB cch wcel cB chil cif
    cA cch wcel cA chil cif cC csn cspn cfv chj co wss wa cB cch wcel cB chil
    cif cA cch wcel cA chil cif cC csn cspn cfv chj co wceq wi cA cch wcel cA
    chil cif cB cch wcel cB chil cif wpss cB cch wcel cB chil cif cA cch wcel
    cA chil cif cC chil wcel cC c0v cif csn cspn cfv chj co wss wa cB cch wcel
    cB chil cif cA cch wcel cA chil cif cC chil wcel cC c0v cif csn cspn cfv
    chj co wceq wi cA cA cch wcel cA chil cif wceq cA cB wpss cB cA cC csn cspn
    cfv chj co wss wa cA cch wcel cA chil cif cB wpss cB cA cch wcel cA chil
    cif cC csn cspn cfv chj co wss wa cB cA cC csn cspn cfv chj co wceq cB cA
    cch wcel cA chil cif cC csn cspn cfv chj co wceq cA cA cch wcel cA chil cif
    wceq cA cB wpss cA cch wcel cA chil cif cB wpss cB cA cC csn cspn cfv chj
    co wss cB cA cch wcel cA chil cif cC csn cspn cfv chj co wss cA cA cch wcel
    cA chil cif cB psseq1 cA cA cch wcel cA chil cif wceq cA cC csn cspn cfv
    chj co cA cch wcel cA chil cif cC csn cspn cfv chj co cB cA cA cch wcel cA
    chil cif cC csn cspn cfv chj opreq1 sseq2d anbi12d cA cA cch wcel cA chil
    cif wceq cA cC csn cspn cfv chj co cA cch wcel cA chil cif cC csn cspn cfv
    chj co cB cA cA cch wcel cA chil cif cC csn cspn cfv chj opreq1 eqeq2d
    imbi12d cB cB cch wcel cB chil cif wceq cA cch wcel cA chil cif cB wpss cB
    cA cch wcel cA chil cif cC csn cspn cfv chj co wss wa cA cch wcel cA chil
    cif cB cch wcel cB chil cif wpss cB cch wcel cB chil cif cA cch wcel cA
    chil cif cC csn cspn cfv chj co wss wa cB cA cch wcel cA chil cif cC csn
    cspn cfv chj co wceq cB cch wcel cB chil cif cA cch wcel cA chil cif cC csn
    cspn cfv chj co wceq cB cB cch wcel cB chil cif wceq cA cch wcel cA chil
    cif cB wpss cA cch wcel cA chil cif cB cch wcel cB chil cif wpss cB cA cch
    wcel cA chil cif cC csn cspn cfv chj co wss cB cch wcel cB chil cif cA cch
    wcel cA chil cif cC csn cspn cfv chj co wss cB cB cch wcel cB chil cif cA
    cch wcel cA chil cif psseq2 cB cB cch wcel cB chil cif cA cch wcel cA chil
    cif cC csn cspn cfv chj co sseq1 anbi12d cB cB cch wcel cB chil cif cA cch
    wcel cA chil cif cC csn cspn cfv chj co eqeq1 imbi12d cC cC chil wcel cC
    c0v cif wceq cA cch wcel cA chil cif cB cch wcel cB chil cif wpss cB cch
    wcel cB chil cif cA cch wcel cA chil cif cC csn cspn cfv chj co wss wa cA
    cch wcel cA chil cif cB cch wcel cB chil cif wpss cB cch wcel cB chil cif
    cA cch wcel cA chil cif cC chil wcel cC c0v cif csn cspn cfv chj co wss wa
    cB cch wcel cB chil cif cA cch wcel cA chil cif cC csn cspn cfv chj co wceq
    cB cch wcel cB chil cif cA cch wcel cA chil cif cC chil wcel cC c0v cif csn
    cspn cfv chj co wceq cC cC chil wcel cC c0v cif wceq cB cch wcel cB chil
    cif cA cch wcel cA chil cif cC csn cspn cfv chj co wss cB cch wcel cB chil
    cif cA cch wcel cA chil cif cC chil wcel cC c0v cif csn cspn cfv chj co wss
    cA cch wcel cA chil cif cB cch wcel cB chil cif wpss cC cC chil wcel cC c0v
    cif wceq cA cch wcel cA chil cif cC csn cspn cfv chj co cA cch wcel cA chil
    cif cC chil wcel cC c0v cif csn cspn cfv chj co cB cch wcel cB chil cif cC
    cC chil wcel cC c0v cif wceq cC csn cspn cfv cC chil wcel cC c0v cif csn
    cspn cfv cA cch wcel cA chil cif chj cC cC chil wcel cC c0v cif wceq cC csn
    cC chil wcel cC c0v cif csn cspn cC cC chil wcel cC c0v cif sneq fveq2d
    opreq2d sseq2d anbi2d cC cC chil wcel cC c0v cif wceq cA cch wcel cA chil
    cif cC csn cspn cfv chj co cA cch wcel cA chil cif cC chil wcel cC c0v cif
    csn cspn cfv chj co cB cch wcel cB chil cif cC cC chil wcel cC c0v cif wceq
    cC csn cspn cfv cC chil wcel cC c0v cif csn cspn cfv cA cch wcel cA chil
    cif chj cC cC chil wcel cC c0v cif wceq cC csn cC chil wcel cC c0v cif csn
    cspn cC cC chil wcel cC c0v cif sneq fveq2d opreq2d eqeq2d imbi12d cA cch
    wcel cA chil cif cB cch wcel cB chil cif cC chil wcel cC c0v cif cA chil
    cch helch elimel cB chil cch helch elimel cC c0v chil ax-hv0cl elimel
    spansncvi dedth3h $.
    $( [7-Jul-2004] $) $( [9-Jun-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Orthoarguesian laws 5OA and 3OA
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    5oalem1.1 $e |- A e. SH $.
    5oalem1.2 $e |- B e. SH $.
    5oalem1.3 $e |- C e. SH $.
    5oalem1.4 $e |- R e. SH $.
    $( Lemma for orthoarguesian law 5OA. $)
    5oalem1 $p |- ( ( ( ( x e. A /\ y e. B ) /\ v = ( x +h y ) ) /\
                  ( z e. C /\ ( x -h z ) e. R ) ) ->
                  v e. ( B +H ( A i^i ( C +H R ) ) ) ) $=
      vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC
      wcel vx cv vz cv cmv co cR wcel wa wa vv cv cB cA cC cR cph co cin cph co
      wcel vx cv vy cv cva co cB cA cC cR cph co cin cph co wcel vx cv cA cC cR
      cph co cin wcel vy cv cB wcel vx cv vy cv cva co cB cA cC cR cph co cin
      cph co wcel vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cva co wceq
      wa vz cv cC wcel vx cv vz cv cmv co cR wcel wa wa vx cv cA cC cR cph co
      cin wcel vy cv cB wcel wa vx cv vy cv cva co cA cC cR cph co cin cB cph
      co cB cA cC cR cph co cin cph co cA cC cR cph co cin cB vx cv vy cv cA cC
      cR cph co 5oalem1.1 cC cR 5oalem1.3 5oalem1.4 shscli shincli 5oalem1.2
      shsvai cA cC cR cph co cin cB cA cC cR cph co 5oalem1.1 cC cR 5oalem1.3
      5oalem1.4 shscli shincli 5oalem1.2 shscomi syl6eleq vx cv cA wcel vy cv
      cB wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vx cv vz cv cmv
      co cR wcel wa wa vx cv cA wcel vx cv cC cR cph co wcel wa vx cv cA cC cR
      cph co cin wcel vx cv cA wcel vy cv cB wcel wa vv cv vx cv vy cv cva co
      wceq wa vz cv cC wcel vx cv vz cv cmv co cR wcel wa wa vx cv cA wcel vx
      cv cC cR cph co wcel vx cv cA wcel vy cv cB wcel wa vx cv cA wcel vv cv
      vx cv vy cv cva co wceq vz cv cC wcel vx cv vz cv cmv co cR wcel wa vx cv
      cA wcel vy cv cB wcel pm3.26 ad2antrr vx cv cA wcel vy cv cB wcel wa vv
      cv vx cv vy cv cva co wceq wa vz cv cC wcel vx cv vz cv cmv co cR wcel wa
      wa vz cv vx cv vz cv cmv co cva co vx cv cC cR cph co vx cv chil wcel vz
      cv chil wcel vz cv vx cv vz cv cmv co cva co vx cv wceq vx cv cA wcel vy
      cv cB wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vx cv vz cv
      cmv co cR wcel wa vx cv chil wcel vz cv chil wcel wa vx cv vz cv vz cv
      cmv co cva co vz cv vx cv vz cv cmv co cva co vx cv vx cv chil wcel vz cv
      chil wcel vx cv vz cv vz cv cmv co cva co vz cv vx cv vz cv cmv co cva co
      wceq vx cv vz cv vz cv hvaddsub12 3anidm23 vz cv chil wcel vx cv chil
      wcel vx cv vz cv vz cv cmv co cva co vx cv c0v cva co vx cv vz cv chil
      wcel vz cv vz cv cmv co c0v vx cv cva vz cv hvsubid opreq2d vx cv
      ax-hvaddid sylan9eqr eqtr3d vx cv cA wcel vx cv chil wcel vy cv cB wcel
      vv cv vx cv vy cv cva co wceq vx cv cA 5oalem1.1 sheli ad2antrr vz cv cC
      wcel vz cv chil wcel vx cv vz cv cmv co cR wcel vz cv cC 5oalem1.3 sheli
      adantr syl2an vz cv cC wcel vx cv vz cv cmv co cR wcel wa vz cv vx cv vz
      cv cmv co cva co cC cR cph co wcel vx cv cA wcel vy cv cB wcel wa vv cv
      vx cv vy cv cva co wceq wa cC cR vz cv vx cv vz cv cmv co 5oalem1.3
      5oalem1.4 shsvai adantl eqeltrrd jca vx cv cA cC cR cph co elin sylibr vx
      cv cA wcel vy cv cB wcel wa vy cv cB wcel vv cv vx cv vy cv cva co wceq
      vz cv cC wcel vx cv vz cv cmv co cR wcel wa vx cv cA wcel vy cv cB wcel
      pm3.27 ad2antrr sylanc vv cv vx cv vy cv cva co wceq vv cv cB cA cC cR
      cph co cin cph co wcel vx cv vy cv cva co cB cA cC cR cph co cin cph co
      wcel wb vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vx cv vz cv cmv co
      cR wcel wa vv cv vx cv vy cv cva co cB cA cC cR cph co cin cph co eleq1
      ad2antlr mpbird $.
      $( [1-Apr-2000] $)
  $}

  ${
    5oalem2.1 $e |- A e. SH $.
    5oalem2.2 $e |- B e. SH $.
    5oalem2.3 $e |- C e. SH $.
    5oalem2.4 $e |- D e. SH $.
    $( Lemma for orthoarguesian law 5OA. $)
    5oalem2 $p |- ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) ) /\
                  ( x +h y ) = ( z +h w ) ) ->
                  ( x -h z ) e. ( ( A +H C ) i^i ( B +H D ) ) ) $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vx cv vy
      cv cva co vz cv vw cv cva co wceq wa vx cv vz cv cmv co cA cC cph co wcel
      vx cv vz cv cmv co cB cD cph co wcel wa vx cv vz cv cmv co cA cC cph co
      cB cD cph co cin wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv
      cD wcel wa wa vx cv vy cv cva co vz cv vw cv cva co wceq wa vx cv vz cv
      cmv co cA cC cph co wcel vx cv vz cv cmv co cB cD cph co wcel vx cv cA
      wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vx cv vz cv cmv
      co cA cC cph co wcel vx cv vy cv cva co vz cv vw cv cva co wceq vx cv cA
      wcel vz cv cC wcel vx cv vz cv cmv co cA cC cph co wcel vy cv cB wcel vw
      cv cD wcel cA cC vx cv vz cv 5oalem2.1 5oalem2.3 shsvsi ad2ant2r adantr
      vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vx cv vy
      cv cva co vz cv vw cv cva co wceq wa vx cv vz cv cmv co cB cD cph co wcel
      vw cv vy cv cmv co cB cD cph co wcel vx cv cA wcel vy cv cB wcel wa vz cv
      cC wcel vw cv cD wcel wa wa vw cv vy cv cmv co cB cD cph co wcel vx cv vy
      cv cva co vz cv vw cv cva co wceq vy cv cB wcel vw cv cD wcel vw cv vy cv
      cmv co cB cD cph co wcel vx cv cA wcel vz cv cC wcel vw cv cD wcel vy cv
      cB wcel wa vw cv vy cv cmv co cD cB cph co wcel vy cv cB wcel vw cv cD
      wcel wa vw cv vy cv cmv co cB cD cph co wcel cD cB vw cv vy cv 5oalem2.4
      5oalem2.2 shsvsi vy cv cB wcel vw cv cD wcel ancom cB cD cph co cD cB cph
      co vw cv vy cv cmv co cB cD 5oalem2.2 5oalem2.4 shscomi eleq2i 3imtr4i
      ad2ant2l adantr vx cv chil wcel vy cv chil wcel wa vz cv chil wcel vw cv
      chil wcel wa wa vx cv vy cv cva co vz cv vw cv cva co wceq vx cv vz cv
      cmv co cB cD cph co wcel vw cv vy cv cmv co cB cD cph co wcel wb vx cv cA
      wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vx cv chil wcel
      vy cv chil wcel wa vz cv chil wcel vw cv chil wcel wa wa vx cv vy cv cva
      co vz cv vw cv cva co wceq wa vx cv vz cv cmv co vw cv vy cv cmv co cB cD
      cph co vx cv chil wcel vy cv chil wcel wa vz cv chil wcel vw cv chil wcel
      wa wa vx cv vy cv cva co vz cv vw cv cva co wceq wa vx cv vy cv cva co vz
      cv vy cv cva co cmv co vz cv vw cv cva co vz cv vy cv cva co cmv co vx cv
      vz cv cmv co vw cv vy cv cmv co vx cv vy cv cva co vz cv vw cv cva co
      wceq vx cv vy cv cva co vz cv vy cv cva co cmv co vz cv vw cv cva co vz
      cv vy cv cva co cmv co wceq vx cv chil wcel vy cv chil wcel wa vz cv chil
      wcel vw cv chil wcel wa wa vx cv vy cv cva co vz cv vw cv cva co vz cv vy
      cv cva co cmv opreq1 adantl vx cv chil wcel vy cv chil wcel wa vz cv chil
      wcel vw cv chil wcel wa wa vx cv vy cv cva co vz cv vy cv cva co cmv co
      vx cv vz cv cmv co wceq vx cv vy cv cva co vz cv vw cv cva co wceq vx cv
      chil wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv cva co vz cv vy
      cv cva co cmv co vx cv vz cv cmv co wceq vw cv chil wcel vx cv chil wcel
      vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv cva co vz cv vy cv cva
      co cmv co vx cv vz cv cmv co vy cv vy cv cmv co cva co vx cv vz cv cmv co
      c0v cva co vx cv vz cv cmv co vx cv chil wcel vy cv chil wcel wa vz cv
      chil wcel vz cv chil wcel vy cv chil wcel wa vx cv vy cv cva co vz cv vy
      cv cva co cmv co vx cv vz cv cmv co vy cv vy cv cmv co cva co wceq vz cv
      chil wcel vx cv chil wcel vy cv chil wcel wa vz cv chil wcel vy cv chil
      wcel wa vx cv chil wcel vy cv chil wcel wa vy cv chil wcel vz cv chil
      wcel vx cv chil wcel vy cv chil wcel pm3.27 anim2i ancoms vx cv vy cv vz
      cv vy cv hvsub4 syldan vy cv chil wcel vx cv vz cv cmv co vy cv vy cv cmv
      co cva co vx cv vz cv cmv co c0v cva co wceq vx cv chil wcel vz cv chil
      wcel vy cv chil wcel vy cv vy cv cmv co c0v vx cv vz cv cmv co cva vy cv
      hvsubid opreq2d ad2antlr vx cv chil wcel vz cv chil wcel vx cv vz cv cmv
      co c0v cva co vx cv vz cv cmv co wceq vy cv chil wcel vx cv chil wcel vz
      cv chil wcel wa vx cv vz cv cmv co chil wcel vx cv vz cv cmv co c0v cva
      co vx cv vz cv cmv co wceq vx cv vz cv hvsubcl vx cv vz cv cmv co
      ax-hvaddid syl adantlr 3eqtrd adantrr adantr vx cv chil wcel vy cv chil
      wcel wa vz cv chil wcel vw cv chil wcel wa wa vz cv vw cv cva co vz cv vy
      cv cva co cmv co vw cv vy cv cmv co wceq vx cv vy cv cva co vz cv vw cv
      cva co wceq vy cv chil wcel vz cv chil wcel vw cv chil wcel wa vz cv vw
      cv cva co vz cv vy cv cva co cmv co vw cv vy cv cmv co wceq vx cv chil
      wcel vy cv chil wcel vz cv chil wcel vw cv chil wcel wa wa vz cv vw cv
      cva co vz cv vy cv cva co cmv co vz cv vz cv cmv co vw cv vy cv cmv co
      cva co c0v vw cv vy cv cmv co cva co vw cv vy cv cmv co vz cv chil wcel
      vw cv chil wcel wa vz cv chil wcel vy cv chil wcel wa vz cv vw cv cva co
      vz cv vy cv cva co cmv co vz cv vz cv cmv co vw cv vy cv cmv co cva co
      wceq vy cv chil wcel vz cv chil wcel vw cv chil wcel wa wa vz cv vw cv vz
      cv vy cv hvsub4 vy cv chil wcel vz cv chil wcel vw cv chil wcel wa pm3.27
      vz cv chil wcel vw cv chil wcel wa vy cv chil wcel vz cv chil wcel vy cv
      chil wcel wa vz cv chil wcel vw cv chil wcel wa vz cv chil wcel vy cv
      chil wcel vz cv chil wcel vw cv chil wcel pm3.26 anim1i ancoms sylanc vz
      cv chil wcel vz cv vz cv cmv co vw cv vy cv cmv co cva co c0v vw cv vy cv
      cmv co cva co wceq vy cv chil wcel vw cv chil wcel vz cv chil wcel vz cv
      vz cv cmv co c0v vw cv vy cv cmv co cva vz cv hvsubid opreq1d ad2antrl vy
      cv chil wcel vw cv chil wcel c0v vw cv vy cv cmv co cva co vw cv vy cv
      cmv co wceq vz cv chil wcel vw cv chil wcel vy cv chil wcel c0v vw cv vy
      cv cmv co cva co vw cv vy cv cmv co wceq vw cv chil wcel vy cv chil wcel
      wa vw cv vy cv cmv co chil wcel c0v vw cv vy cv cmv co cva co vw cv vy cv
      cmv co wceq vw cv vy cv hvsubcl vw cv vy cv cmv co hvaddid2 syl ancoms
      adantrl 3eqtrd adantll adantr 3eqtr3d eleq1d vx cv cA wcel vy cv cB wcel
      wa vx cv chil wcel vy cv chil wcel wa vz cv cC wcel vw cv cD wcel wa vz
      cv chil wcel vw cv chil wcel wa vx cv cA wcel vx cv chil wcel vy cv cB
      wcel vy cv chil wcel vx cv cA 5oalem2.1 sheli vy cv cB 5oalem2.2 sheli
      anim12i vz cv cC wcel vz cv chil wcel vw cv cD wcel vw cv chil wcel vz cv
      cC 5oalem2.3 sheli vw cv cD 5oalem2.4 sheli anim12i anim12i sylan mpbird
      jca vx cv vz cv cmv co cA cC cph co cB cD cph co elin sylibr $.
      $( [2-Apr-2000] $)
  $}

  ${
    5oalem3.1 $e |- A e. SH $.
    5oalem3.2 $e |- B e. SH $.
    5oalem3.3 $e |- C e. SH $.
    5oalem3.4 $e |- D e. SH $.
    5oalem3.5 $e |- F e. SH $.
    5oalem3.6 $e |- G e. SH $.
    $( Lemma for orthoarguesian law 5OA. $)
    5oalem3 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) )
                    /\ ( f e. F /\ g e. G ) ) /\
                  ( ( x +h y ) = ( f +h g ) /\ ( z +h w ) = ( f +h g ) ) ) ->
                  ( x -h z ) e. ( ( ( A +H F ) i^i ( B +H G ) ) +H
                    ( ( C +H F ) i^i ( D +H G ) ) ) ) $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF
      wcel vg cv cG wcel wa wa vx cv vy cv cva co vf cv vg cv cva co wceq vz cv
      vw cv cva co vf cv vg cv cva co wceq wa wa vx cv vf cv cmv co vz cv vf cv
      cmv co cmv co cA cF cph co cB cG cph co cin cC cF cph co cD cG cph co cin
      cph co wcel vx cv vz cv cmv co cA cF cph co cB cG cph co cin cC cF cph co
      cD cG cph co cin cph co wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel
      vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa wa vx cv vy cv cva co
      vf cv vg cv cva co wceq vz cv vw cv cva co vf cv vg cv cva co wceq wa wa
      vx cv vf cv cmv co cA cF cph co cB cG cph co cin wcel vz cv vf cv cmv co
      cC cF cph co cD cG cph co cin wcel wa vx cv vf cv cmv co vz cv vf cv cmv
      co cmv co cA cF cph co cB cG cph co cin cC cF cph co cD cG cph co cin cph
      co wcel vx cv cA wcel vy cv cB wcel wa vf cv cF wcel vg cv cG wcel wa wa
      vz cv cC wcel vw cv cD wcel wa vf cv cF wcel vg cv cG wcel wa wa wa vx cv
      vy cv cva co vf cv vg cv cva co wceq vz cv vw cv cva co vf cv vg cv cva
      co wceq wa vx cv vf cv cmv co cA cF cph co cB cG cph co cin wcel vz cv vf
      cv cmv co cC cF cph co cD cG cph co cin wcel wa vx cv cA wcel vy cv cB
      wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa
      wa vx cv cA wcel vy cv cB wcel wa vf cv cF wcel vg cv cG wcel wa wa vx cv
      vy cv cva co vf cv vg cv cva co wceq vz cv cC wcel vw cv cD wcel wa vf cv
      cF wcel vg cv cG wcel wa wa vz cv vw cv cva co vf cv vg cv cva co wceq vx
      cv vf cv cmv co cA cF cph co cB cG cph co cin wcel vz cv vf cv cmv co cC
      cF cph co cD cG cph co cin wcel wa vx cv cA wcel vy cv cB wcel wa vf cv
      cF wcel vg cv cG wcel wa wa vx cv vy cv cva co vf cv vg cv cva co wceq wa
      vx cv vf cv cmv co cA cF cph co cB cG cph co cin wcel vz cv cC wcel vw cv
      cD wcel wa vf cv cF wcel vg cv cG wcel wa wa vz cv vw cv cva co vf cv vg
      cv cva co wceq wa vz cv vf cv cmv co cC cF cph co cD cG cph co cin wcel
      vx vy vf vg cA cB cF cG 5oalem3.1 5oalem3.2 5oalem3.5 5oalem3.6 5oalem2
      vz vw vf vg cC cD cF cG 5oalem3.3 5oalem3.4 5oalem3.5 5oalem3.6 5oalem2
      anim12i an4s vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel
      wa vf cv cF wcel vg cv cG wcel wa anandir sylanb cA cF cph co cB cG cph
      co cin cC cF cph co cD cG cph co cin vx cv vf cv cmv co vz cv vf cv cmv
      co cA cF cph co cB cG cph co cA cF 5oalem3.1 5oalem3.5 shscli cB cG
      5oalem3.2 5oalem3.6 shscli shincli cC cF cph co cD cG cph co cC cF
      5oalem3.3 5oalem3.5 shscli cD cG 5oalem3.4 5oalem3.6 shscli shincli
      shsvsi syl vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa
      wa vf cv cF wcel vg cv cG wcel wa wa vx cv vf cv cmv co vz cv vf cv cmv
      co cmv co cA cF cph co cB cG cph co cin cC cF cph co cD cG cph co cin cph
      co wcel vx cv vz cv cmv co cA cF cph co cB cG cph co cin cC cF cph co cD
      cG cph co cin cph co wcel wb vx cv vy cv cva co vf cv vg cv cva co wceq
      vz cv vw cv cva co vf cv vg cv cva co wceq wa vx cv cA wcel vy cv cB wcel
      wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa wa vx
      cv vf cv cmv co vz cv vf cv cmv co cmv co vx cv vz cv cmv co cA cF cph co
      cB cG cph co cin cC cF cph co cD cG cph co cin cph co vx cv chil wcel vz
      cv chil wcel wa vf cv chil wcel vx cv vf cv cmv co vz cv vf cv cmv co cmv
      co vx cv vz cv cmv co wceq vx cv cA wcel vy cv cB wcel wa vz cv cC wcel
      vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vx cv chil wcel vz cv
      chil wcel wa vf cv chil wcel wa vx cv vf cv cmv co vz cv vf cv cmv co cmv
      co vx cv vz cv cmv co vf cv vf cv cmv co cmv co vx cv vz cv cmv co c0v
      cmv co vx cv vz cv cmv co vx cv chil wcel vz cv chil wcel vf cv chil wcel
      vx cv vf cv cmv co vz cv vf cv cmv co cmv co vx cv vz cv cmv co vf cv vf
      cv cmv co cmv co wceq vx cv vf cv vz cv vf cv hvsubsub4 anandirs vf cv
      chil wcel vx cv vz cv cmv co vf cv vf cv cmv co cmv co vx cv vz cv cmv co
      c0v cmv co wceq vx cv chil wcel vz cv chil wcel wa vf cv chil wcel vf cv
      vf cv cmv co c0v vx cv vz cv cmv co cmv vf cv hvsubid opreq2d adantl vx
      cv chil wcel vz cv chil wcel wa vx cv vz cv cmv co c0v cmv co vx cv vz cv
      cmv co wceq vf cv chil wcel vx cv chil wcel vz cv chil wcel wa vx cv vz
      cv cmv co chil wcel vx cv vz cv cmv co c0v cmv co vx cv vz cv cmv co wceq
      vx cv vz cv hvsubcl vx cv vz cv cmv co hvsub0 syl adantr 3eqtrd vx cv cA
      wcel vy cv cB wcel wa vx cv chil wcel vz cv cC wcel vw cv cD wcel wa vz
      cv chil wcel vx cv cA wcel vx cv chil wcel vy cv cB wcel vx cv cA
      5oalem3.1 sheli adantr vz cv cC wcel vz cv chil wcel vw cv cD wcel vz cv
      cC 5oalem3.3 sheli adantr anim12i vf cv cF wcel vf cv chil wcel vg cv cG
      wcel vf cv cF 5oalem3.5 sheli adantr syl2an eleq1d adantr mpbid $.
      $( [2-Apr-2000] $)


    $( Lemma for orthoarguesian law 5OA. $)
    5oalem4 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) )
                    /\ ( f e. F /\ g e. G ) ) /\
                  ( ( x +h y ) = ( f +h g ) /\ ( z +h w ) = ( f +h g ) ) ) ->
                  ( x -h z ) e. ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                    ( ( ( A +H F ) i^i ( B +H G ) ) +H
                      ( ( C +H F ) i^i ( D +H G ) ) ) ) ) $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF
      wcel vg cv cG wcel wa wa vx cv vy cv cva co vf cv vg cv cva co wceq vz cv
      vw cv cva co vf cv vg cv cva co wceq wa wa vx cv vz cv cmv co cA cC cph
      co cB cD cph co cin wcel vx cv vz cv cmv co cA cF cph co cB cG cph co cin
      cC cF cph co cD cG cph co cin cph co wcel wa vx cv vz cv cmv co cA cC cph
      co cB cD cph co cin cA cF cph co cB cG cph co cin cC cF cph co cD cG cph
      co cin cph co cin wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv
      cD wcel wa wa vf cv cF wcel vg cv cG wcel wa wa vx cv vy cv cva co vf cv
      vg cv cva co wceq vz cv vw cv cva co vf cv vg cv cva co wceq wa wa vx cv
      vz cv cmv co cA cC cph co cB cD cph co cin wcel vx cv vz cv cmv co cA cF
      cph co cB cG cph co cin cC cF cph co cD cG cph co cin cph co wcel vx cv
      cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vx cv vy cv
      cva co vf cv vg cv cva co wceq vz cv vw cv cva co vf cv vg cv cva co wceq
      wa vx cv vz cv cmv co cA cC cph co cB cD cph co cin wcel vf cv cF wcel vg
      cv cG wcel wa vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel
      wa wa vx cv vy cv cva co vz cv vw cv cva co wceq vx cv vz cv cmv co cA cC
      cph co cB cD cph co cin wcel vx cv vy cv cva co vf cv vg cv cva co wceq
      vz cv vw cv cva co vf cv vg cv cva co wceq wa vx vy vz vw cA cB cC cD
      5oalem3.1 5oalem3.2 5oalem3.3 5oalem3.4 5oalem2 vx cv vy cv cva co vz cv
      vw cv cva co vf cv vg cv cva co eqtr3 sylan2 adantlr vx vy vz vw cA cB cC
      cD vf vg cF cG 5oalem3.1 5oalem3.2 5oalem3.3 5oalem3.4 5oalem3.5
      5oalem3.6 5oalem3 jca vx cv vz cv cmv co cA cC cph co cB cD cph co cin cA
      cF cph co cB cG cph co cin cC cF cph co cD cG cph co cin cph co elin
      sylibr $.
      $( [2-Apr-2000] $)
  $}

  ${
    5oalem5.1 $e |- A e. SH $.
    5oalem5.2 $e |- B e. SH $.
    5oalem5.3 $e |- C e. SH $.
    5oalem5.4 $e |- D e. SH $.
    5oalem5.5 $e |- F e. SH $.
    5oalem5.6 $e |- G e. SH $.
    5oalem5.7 $e |- R e. SH $.
    5oalem5.8 $e |- S e. SH $.
    $( Lemma for orthoarguesian law 5OA. $)
    5oalem5 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) )
                    /\ ( ( f e. F /\ g e. G ) /\ ( v e. R /\ u e. S ) ) ) /\
             ( ( ( x +h y ) = ( v +h u ) /\ ( z +h w ) = ( v +h u ) ) /\
                 ( f +h g ) = ( v +h u ) ) ) ->
                  ( x -h z ) e.
                 ( ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                     ( ( ( A +H R ) i^i ( B +H S ) ) +H
                       ( ( C +H R ) i^i ( D +H S ) ) ) )
                i^i ( ( ( ( A +H F ) i^i ( B +H G ) ) i^i
                        ( ( ( A +H R ) i^i ( B +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) )
                   +H ( ( ( C +H F ) i^i ( D +H G ) ) i^i
                        ( ( ( C +H R ) i^i ( D +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) ) ) ) ) $=
      vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF
      wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa wa vx cv vy cv
      cva co vv cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq
      wa vf cv vg cv cva co vv cv vu cv cva co wceq wa wa vx cv vz cv cmv co cA
      cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD
      cS cph co cin cph co cin wcel vx cv vz cv cmv co cA cF cph co cB cG cph
      co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cph co wcel wa vx cv vz cv cmv co cA cC
      cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel
      vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS
      wcel wa wa wa vx cv vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva
      co vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv cva co wceq
      wa wa vx cv vz cv cmv co cA cC cph co cB cD cph co cin cA cR cph co cB cS
      cph co cin cC cR cph co cD cS cph co cin cph co cin wcel vx cv vz cv cmv
      co cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co
      cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co wcel vx
      cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vv cv cR
      wcel vu cv cS wcel wa wa vx cv vy cv cva co vv cv vu cv cva co wceq vz cv
      vw cv cva co vv cv vu cv cva co wceq wa vx cv vz cv cmv co cA cC cph co
      cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co
      cin cph co cin wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD
      wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa
      wa wa vx cv vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva co vv cv
      vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv cva co wceq wa vx vy
      vz vw cA cB cC cD vv vu cR cS 5oalem5.1 5oalem5.2 5oalem5.3 5oalem5.4
      5oalem5.7 5oalem5.8 5oalem4 vf cv cF wcel vg cv cG wcel wa vv cv cR wcel
      vu cv cS wcel wa wa vv cv cR wcel vu cv cS wcel wa vx cv cA wcel vy cv cB
      wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa
      vv cv cR wcel vu cv cS wcel wa pm3.27 anim2i vx cv vy cv cva co vv cv vu
      cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv
      cva co vv cv vu cv cva co wceq pm3.26 syl2an vx cv cA wcel vy cv cB wcel
      wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv
      cR wcel vu cv cS wcel wa wa wa vx cv vy cv cva co vv cv vu cv cva co wceq
      vz cv vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu
      cv cva co wceq wa wa vx cv vf cv cmv co vz cv vf cv cmv co cmv co vx cv
      vz cv cmv co cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin
      cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC
      cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph
      co vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv
      cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa wa vx cv vf cv
      cmv co vz cv vf cv cmv co cmv co vx cv vz cv cmv co wceq vx cv vy cv cva
      co vv cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq wa
      vf cv vg cv cva co vv cv vu cv cva co wceq wa vx cv cA wcel vy cv cB wcel
      wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vx cv
      vf cv cmv co vz cv vf cv cmv co cmv co vx cv vz cv cmv co wceq vv cv cR
      wcel vu cv cS wcel wa vx cv chil wcel vz cv chil wcel wa vf cv chil wcel
      vx cv vf cv cmv co vz cv vf cv cmv co cmv co vx cv vz cv cmv co wceq vx
      cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF
      wcel vg cv cG wcel wa vx cv chil wcel vz cv chil wcel wa vf cv chil wcel
      wa vx cv vf cv cmv co vz cv vf cv cmv co cmv co vx cv vz cv cmv co vf cv
      vf cv cmv co cmv co vx cv vz cv cmv co c0v cmv co vx cv vz cv cmv co vx
      cv chil wcel vz cv chil wcel vf cv chil wcel vx cv vf cv cmv co vz cv vf
      cv cmv co cmv co vx cv vz cv cmv co vf cv vf cv cmv co cmv co wceq vx cv
      vf cv vz cv vf cv hvsubsub4 anandirs vf cv chil wcel vx cv vz cv cmv co
      vf cv vf cv cmv co cmv co vx cv vz cv cmv co c0v cmv co wceq vx cv chil
      wcel vz cv chil wcel wa vf cv chil wcel vf cv vf cv cmv co c0v vx cv vz
      cv cmv co cmv vf cv hvsubid opreq2d adantl vx cv chil wcel vz cv chil
      wcel wa vx cv vz cv cmv co c0v cmv co vx cv vz cv cmv co wceq vf cv chil
      wcel vx cv chil wcel vz cv chil wcel wa vx cv vz cv cmv co chil wcel vx
      cv vz cv cmv co c0v cmv co vx cv vz cv cmv co wceq vx cv vz cv hvsubcl vx
      cv vz cv cmv co hvsub0 syl adantr 3eqtrd vx cv cA wcel vy cv cB wcel wa
      vx cv chil wcel vz cv cC wcel vw cv cD wcel wa vz cv chil wcel vx cv cA
      wcel vx cv chil wcel vy cv cB wcel vx cv cA 5oalem5.1 sheli adantr vz cv
      cC wcel vz cv chil wcel vw cv cD wcel vz cv cC 5oalem5.3 sheli adantr
      anim12i vf cv cF wcel vf cv chil wcel vg cv cG wcel vf cv cF 5oalem5.5
      sheli adantr syl2an adantrr adantr vx cv cA wcel vy cv cB wcel wa vz cv
      cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel
      vu cv cS wcel wa wa wa vx cv vy cv cva co vv cv vu cv cva co wceq vz cv
      vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv
      cva co wceq wa wa vx cv cA wcel vy cv cB wcel wa vf cv cF wcel vg cv cG
      wcel wa wa vz cv cC wcel vw cv cD wcel wa vf cv cF wcel vg cv cG wcel wa
      wa wa vv cv cR wcel vu cv cS wcel wa wa vx cv vy cv cva co vv cv vu cv
      cva co wceq vf cv vg cv cva co vv cv vu cv cva co wceq wa vz cv vw cv cva
      co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu cv cva co wceq wa
      wa wa vx cv vf cv cmv co cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin wcel vz cv vf cv cmv
      co cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin wcel wa vx cv vf cv cmv co vz cv vf cv cmv
      co cmv co cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co
      wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf
      cv cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa wa vx cv cA
      wcel vy cv cB wcel wa vf cv cF wcel vg cv cG wcel wa wa vz cv cC wcel vw
      cv cD wcel wa vf cv cF wcel vg cv cG wcel wa wa wa vv cv cR wcel vu cv cS
      wcel wa wa vx cv vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva co
      vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv cva co wceq wa
      vx cv vy cv cva co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu cv
      cva co wceq wa vz cv vw cv cva co vv cv vu cv cva co wceq vf cv vg cv cva
      co vv cv vu cv cva co wceq wa wa vx cv cA wcel vy cv cB wcel wa vz cv cC
      wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel vu
      cv cS wcel wa wa wa vx cv cA wcel vy cv cB wcel wa vf cv cF wcel vg cv cG
      wcel wa wa vz cv cC wcel vw cv cD wcel wa vf cv cF wcel vg cv cG wcel wa
      wa wa vv cv cR wcel vu cv cS wcel wa vx cv cA wcel vy cv cB wcel wa vz cv
      cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel
      vu cv cS wcel wa wa wa vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv
      cD wcel wa wa vf cv cF wcel vg cv cG wcel wa wa vx cv cA wcel vy cv cB
      wcel wa vf cv cF wcel vg cv cG wcel wa wa vz cv cC wcel vw cv cD wcel wa
      vf cv cF wcel vg cv cG wcel wa wa wa vf cv cF wcel vg cv cG wcel wa vv cv
      cR wcel vu cv cS wcel wa wa vf cv cF wcel vg cv cG wcel wa vx cv cA wcel
      vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG
      wcel wa vv cv cR wcel vu cv cS wcel wa pm3.26 anim2i vx cv cA wcel vy cv
      cB wcel wa vz cv cC wcel vw cv cD wcel wa vf cv cF wcel vg cv cG wcel wa
      anandir sylib vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel
      wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa
      simprr jca vx cv vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva co
      vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv cva co wceq wa
      vx cv vy cv cva co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu cv
      cva co wceq wa vz cv vw cv cva co vv cv vu cv cva co wceq vf cv vg cv cva
      co vv cv vu cv cva co wceq wa vx cv vy cv cva co vv cv vu cv cva co wceq
      vz cv vw cv cva co vv cv vu cv cva co wceq wa vx cv vy cv cva co vv cv vu
      cv cva co wceq vf cv vg cv cva co vv cv vu cv cva co wceq vx cv vy cv cva
      co vv cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq
      pm3.26 anim1i vx cv vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva
      co vv cv vu cv cva co wceq wa vz cv vw cv cva co vv cv vu cv cva co wceq
      vf cv vg cv cva co vv cv vu cv cva co wceq vx cv vy cv cva co vv cv vu cv
      cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq pm3.27 anim1i jca
      anim12i vx cv cA wcel vy cv cB wcel wa vf cv cF wcel vg cv cG wcel wa wa
      vv cv cR wcel vu cv cS wcel wa wa vz cv cC wcel vw cv cD wcel wa vf cv cF
      wcel vg cv cG wcel wa wa vv cv cR wcel vu cv cS wcel wa wa wa vx cv vy cv
      cva co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu cv cva co wceq
      wa vz cv vw cv cva co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu
      cv cva co wceq wa wa vx cv vf cv cmv co cA cF cph co cB cG cph co cin cA
      cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin wcel
      vz cv vf cv cmv co cC cF cph co cD cG cph co cin cC cR cph co cD cS cph
      co cin cF cR cph co cG cS cph co cin cph co cin wcel wa vx cv cA wcel vy
      cv cB wcel wa vf cv cF wcel vg cv cG wcel wa wa vz cv cC wcel vw cv cD
      wcel wa vf cv cF wcel vg cv cG wcel wa wa wa vv cv cR wcel vu cv cS wcel
      wa wa vx cv cA wcel vy cv cB wcel wa vf cv cF wcel vg cv cG wcel wa wa vv
      cv cR wcel vu cv cS wcel wa wa vx cv vy cv cva co vv cv vu cv cva co wceq
      vf cv vg cv cva co vv cv vu cv cva co wceq wa vz cv cC wcel vw cv cD wcel
      wa vf cv cF wcel vg cv cG wcel wa wa vv cv cR wcel vu cv cS wcel wa wa vz
      cv vw cv cva co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu cv
      cva co wceq wa vx cv vf cv cmv co cA cF cph co cB cG cph co cin cA cR cph
      co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin wcel vz cv
      vf cv cmv co cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin
      cF cR cph co cG cS cph co cin cph co cin wcel wa vx cv cA wcel vy cv cB
      wcel wa vf cv cF wcel vg cv cG wcel wa wa vv cv cR wcel vu cv cS wcel wa
      wa vx cv vy cv cva co vv cv vu cv cva co wceq vf cv vg cv cva co vv cv vu
      cv cva co wceq wa wa vx cv vf cv cmv co cA cF cph co cB cG cph co cin cA
      cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin wcel
      vz cv cC wcel vw cv cD wcel wa vf cv cF wcel vg cv cG wcel wa wa vv cv cR
      wcel vu cv cS wcel wa wa vz cv vw cv cva co vv cv vu cv cva co wceq vf cv
      vg cv cva co vv cv vu cv cva co wceq wa wa vz cv vf cv cmv co cC cF cph
      co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph
      co cin cph co cin wcel vx vy vf vg cA cB cF cG vv vu cR cS 5oalem5.1
      5oalem5.2 5oalem5.5 5oalem5.6 5oalem5.7 5oalem5.8 5oalem4 vz vw vf vg cC
      cD cF cG vv vu cR cS 5oalem5.3 5oalem5.4 5oalem5.5 5oalem5.6 5oalem5.7
      5oalem5.8 5oalem4 anim12i an4s vx cv cA wcel vy cv cB wcel wa vf cv cF
      wcel vg cv cG wcel wa wa vz cv cC wcel vw cv cD wcel wa vf cv cF wcel vg
      cv cG wcel wa wa vv cv cR wcel vu cv cS wcel wa anandir sylanb cA cF cph
      co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph
      co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin vx cv vf cv cmv co vz cv vf
      cv cmv co cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF
      cR cph co cG cS cph co cin cph co cA cF cph co cB cG cph co cA cF
      5oalem5.1 5oalem5.5 shscli cB cG 5oalem5.2 5oalem5.6 shscli shincli cA cR
      cph co cB cS cph co cin cF cR cph co cG cS cph co cin cA cR cph co cB cS
      cph co cA cR 5oalem5.1 5oalem5.7 shscli cB cS 5oalem5.2 5oalem5.8 shscli
      shincli cF cR cph co cG cS cph co cF cR 5oalem5.5 5oalem5.7 shscli cG cS
      5oalem5.6 5oalem5.8 shscli shincli shscli shincli cC cF cph co cD cG cph
      co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co
      cC cF cph co cD cG cph co cC cF 5oalem5.3 5oalem5.5 shscli cD cG
      5oalem5.4 5oalem5.6 shscli shincli cC cR cph co cD cS cph co cin cF cR
      cph co cG cS cph co cin cC cR cph co cD cS cph co cC cR 5oalem5.3
      5oalem5.7 shscli cD cS 5oalem5.4 5oalem5.8 shscli shincli cF cR cph co cG
      cS cph co cF cR 5oalem5.5 5oalem5.7 shscli cG cS 5oalem5.6 5oalem5.8
      shscli shincli shscli shincli shsvsi 3syl eqeltrrd jca vx cv vz cv cmv co
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co elin sylibr $.
      $( [2-May-2000] $)

    $( Lemma for orthoarguesian law 5OA. $)
    5oalem6 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ h = ( x +h y ) ) /\
                        ( ( z e. C /\ w e. D ) /\ h = ( z +h w ) ) ) /\
                      ( ( ( f e. F /\ g e. G ) /\ h = ( f +h g ) ) /\
                        ( ( v e. R /\ u e. S ) /\ h = ( v +h u ) ) ) ) ->
           h e. ( B +H ( A i^i ( C +H
                 ( ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                     ( ( ( A +H R ) i^i ( B +H S ) ) +H
                       ( ( C +H R ) i^i ( D +H S ) ) ) )
                i^i ( ( ( ( A +H F ) i^i ( B +H G ) ) i^i
                        ( ( ( A +H R ) i^i ( B +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) )
                   +H ( ( ( C +H F ) i^i ( D +H G ) ) i^i
                        ( ( ( C +H R ) i^i ( D +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) ) ) ) ) ) ) ) $=
      vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC
      wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vf cv cF wcel
      vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS
      wcel wa vh cv vv cv vu cv cva co wceq wa wa wa vx cv vz cv cmv co cA cC
      cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin wcel vh cv cB cA cC cA cC cph co cB cD cph co cin
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA
      cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG
      cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin cph co cin
      cph co wcel vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq
      wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vf
      cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR
      wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa wa vx cv cA
      wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg
      cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa wa vx cv vy cv cva co vv
      cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq wa vf cv
      vg cv cva co vv cv vu cv cva co wceq wa wa vx cv vz cv cmv co cA cC cph
      co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph
      co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co
      cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cph co cin wcel vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD
      wcel wa wa vh cv vx cv vy cv cva co wceq vh cv vz cv vw cv cva co wceq wa
      wa vf cv cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa vh cv
      vf cv vg cv cva co wceq vh cv vv cv vu cv cva co wceq wa wa vx cv cA wcel
      vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG
      wcel wa vv cv cR wcel vu cv cS wcel wa wa wa vx cv vy cv cva co vv cv vu
      cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv
      cva co vv cv vu cv cva co wceq wa wa vx cv cA wcel vy cv cB wcel wa vh cv
      vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw
      cv cva co wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva
      co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq
      wa wa vx cv cA wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf
      cv cF wcel vg cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa vh cv vx cv
      vy cv cva co wceq vh cv vz cv vw cv cva co wceq wa vh cv vf cv vg cv cva
      co wceq vh cv vv cv vu cv cva co wceq wa vx cv cA wcel vy cv cB wcel wa
      vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg cv cG wcel wa vv cv cR
      wcel vu cv cS wcel wa wa wa vx cv vy cv cva co vv cv vu cv cva co wceq vz
      cv vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv
      cva co wceq wa wa vh cv vx cv vy cv cva co wceq vh cv vz cv vw cv cva co
      wceq wa vh cv vf cv vg cv cva co wceq vh cv vv cv vu cv cva co wceq wa wa
      vx cv vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv
      cva co wceq wa vf cv vg cv cva co vv cv vu cv cva co wceq wa vx cv cA
      wcel vy cv cB wcel wa vz cv cC wcel vw cv cD wcel wa wa vf cv cF wcel vg
      cv cG wcel wa vv cv cR wcel vu cv cS wcel wa wa wa vh cv vx cv vy cv cva
      co wceq vh cv vz cv vw cv cva co wceq wa vh cv vf cv vg cv cva co wceq vh
      cv vv cv vu cv cva co wceq vx cv vy cv cva co vv cv vu cv cva co wceq vz
      cv vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv cva co vv cv vu cv
      cva co wceq wa vh cv vv cv vu cv cva co wceq vh cv vx cv vy cv cva co
      wceq vh cv vz cv vw cv cva co wceq wa vh cv vf cv vg cv cva co wceq vx cv
      vy cv cva co vv cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva
      co wceq wa vf cv vg cv cva co vv cv vu cv cva co wceq wa vh cv vv cv vu
      cv cva co wceq vh cv vx cv vy cv cva co wceq vh cv vz cv vw cv cva co
      wceq wa vh cv vf cv vg cv cva co wceq vx cv vy cv cva co vv cv vu cv cva
      co wceq vz cv vw cv cva co vv cv vu cv cva co wceq wa vf cv vg cv cva co
      vv cv vu cv cva co wceq wa vh cv vv cv vu cv cva co wceq vh cv vx cv vy
      cv cva co wceq vh cv vz cv vw cv cva co wceq wa vx cv vy cv cva co vv cv
      vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq wa vh cv vf
      cv vg cv cva co wceq vf cv vg cv cva co vv cv vu cv cva co wceq vh cv vv
      cv vu cv cva co wceq vh cv vx cv vy cv cva co wceq vx cv vy cv cva co vv
      cv vu cv cva co wceq vh cv vz cv vw cv cva co wceq vz cv vw cv cva co vv
      cv vu cv cva co wceq vh cv vx cv vy cv cva co wceq vh cv vv cv vu cv cva
      co wceq vx cv vy cv cva co vv cv vu cv cva co wceq vh cv vx cv vy cv cva
      co vv cv vu cv cva co eqeq1 biimpcd vh cv vz cv vw cv cva co wceq vh cv
      vv cv vu cv cva co wceq vz cv vw cv cva co vv cv vu cv cva co wceq vh cv
      vz cv vw cv cva co vv cv vu cv cva co eqeq1 biimpcd anim12d vh cv vf cv
      vg cv cva co wceq vh cv vv cv vu cv cva co wceq vf cv vg cv cva co vv cv
      vu cv cva co wceq vh cv vf cv vg cv cva co vv cv vu cv cva co eqeq1
      biimpcd anim12d exp3a com3l imp32 anim2i an4s vx cv cA wcel vy cv cB wcel
      wa vh cv vx cv vy cv cva co wceq vz cv cC wcel vw cv cD wcel wa vh cv vz
      cv vw cv cva co wceq an4 vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv
      cva co wceq vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq
      an4 syl2anb vx vy vz vw vv vu cA cB cC cD cR cS vf vg cF cG 5oalem5.1
      5oalem5.2 5oalem5.3 5oalem5.4 5oalem5.5 5oalem5.6 5oalem5.7 5oalem5.8
      5oalem5 syl vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq
      wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vx
      cv vz cv cmv co cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co
      cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co
      cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cph co cin wcel vh cv cB cA cC cA cC cph
      co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph
      co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co
      cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cph co cin cph co cin cph co wcel wi vf cv cF wcel vg cv cG wcel wa
      vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv
      cv vu cv cva co wceq wa wa vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy
      cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vx cv vz cv cmv co cA cC
      cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin wcel vh cv cB cA cC cA cC cph co cB cD cph co cin
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA
      cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG
      cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin cph co cin
      cph co wcel wi vh cv vz cv vw cv cva co wceq vx cv cA wcel vy cv cB wcel
      wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vx cv vz cv cmv co cA
      cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD
      cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin wcel vh cv cB cA cC cA cC cph co cB cD cph co cin
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA
      cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG
      cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin cph co cin
      cph co wcel wi vw cv cD wcel vx cv cA wcel vy cv cB wcel wa vh cv vx cv
      vy cv cva co wceq wa vz cv cC wcel vx cv vz cv cmv co cA cC cph co cB cD
      cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin
      cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co
      cin wcel vh cv cB cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS
      cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG
      cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cin cph co cin cph co wcel
      wi vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv
      cC wcel vx cv vz cv cmv co cA cC cph co cB cD cph co cin cA cR cph co cB
      cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG
      cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cin wcel vh cv cB cA cC cA
      cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD
      cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin cph co cin cph co wcel vx vy vz vh cA cB cC cA cC
      cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin 5oalem5.1 5oalem5.2 5oalem5.3 cA cC cph co cB cD
      cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin
      cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cA cC cph co cB cD cph co cA cC 5oalem5.1
      5oalem5.3 shscli cB cD 5oalem5.2 5oalem5.4 shscli shincli cA cR cph co cB
      cS cph co cin cC cR cph co cD cS cph co cin cA cR cph co cB cS cph co cA
      cR 5oalem5.1 5oalem5.7 shscli cB cS 5oalem5.2 5oalem5.8 shscli shincli cC
      cR cph co cD cS cph co cC cR 5oalem5.3 5oalem5.7 shscli cD cS 5oalem5.4
      5oalem5.8 shscli shincli shscli shincli cA cF cph co cB cG cph co cin cA
      cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
      cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cA cF cph co cB cG cph co
      cA cF 5oalem5.1 5oalem5.5 shscli cB cG 5oalem5.2 5oalem5.6 shscli shincli
      cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cA cR cph co
      cB cS cph co cA cR 5oalem5.1 5oalem5.7 shscli cB cS 5oalem5.2 5oalem5.8
      shscli shincli cF cR cph co cG cS cph co cF cR 5oalem5.5 5oalem5.7 shscli
      cG cS 5oalem5.6 5oalem5.8 shscli shincli shscli shincli cC cF cph co cD
      cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cC cF cph co cD cG cph co cC cF 5oalem5.3 5oalem5.5 shscli cD cG
      5oalem5.4 5oalem5.6 shscli shincli cC cR cph co cD cS cph co cin cF cR
      cph co cG cS cph co cin cC cR cph co cD cS cph co cC cR 5oalem5.3
      5oalem5.7 shscli cD cS 5oalem5.4 5oalem5.8 shscli shincli cF cR cph co cG
      cS cph co cF cR 5oalem5.5 5oalem5.7 shscli cG cS 5oalem5.6 5oalem5.8
      shscli shincli shscli shincli shscli shincli 5oalem1 exp32 imp adantrr
      adantrr adantr mpd $.
      $( [4-May-2000] $)

    ${
      $d A h f g u v w x y z $.  $d B h f g u v w x y z $.
      $d C h f g u v w x y z $.  $d D h f g u v w x y z $.
      $d F h f g u v w x y z $.  $d G h f g u v w x y z $.
      $d R h f g u v w x y z $.  $d S h f g u v w x y z $.
      $( Lemma for orthoarguesian law 5OA. $)
      5oalem7 $p |- ( ( ( A +H B ) i^i ( C +H D ) ) i^i
              ( ( F +H G ) i^i ( R +H S ) ) ) C_ ( B +H ( A i^i ( C +H
                 ( ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                     ( ( ( A +H R ) i^i ( B +H S ) ) +H
                       ( ( C +H R ) i^i ( D +H S ) ) ) )
                i^i ( ( ( ( A +H F ) i^i ( B +H G ) ) i^i
                        ( ( ( A +H R ) i^i ( B +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) )
                   +H ( ( ( C +H F ) i^i ( D +H G ) ) i^i
                        ( ( ( C +H R ) i^i ( D +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) ) ) ) ) ) ) $=
        vh cA cB cph co cC cD cph co cin cF cG cph co cR cS cph co cin cin cB
        cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR
        cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR
        cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
        cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG
        cS cph co cin cph co cin cph co cin cph co cin cph co vh cv cA cB cph
        co cC cD cph co cin cF cG cph co cR cS cph co cin cin wcel vx cv cA
        wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vw
        cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vf cv cF wcel vg cv
        cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel
        wa vh cv vv cv vu cv cva co wceq wa wa wa vu wex vv wex vg wex vf wex
        vw wex vz wex vy wex vx wex vh cv cB cA cC cA cC cph co cB cD cph co
        cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co
        cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR
        cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR
        cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co
        cin cph co cin cph co wcel vx cv cA wcel vy cv cB wcel wa vh cv vx cv
        vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv
        cva co wceq wa wa vw wex vz wex vf cv cF wcel vg cv cG wcel wa vh cv vf
        cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu
        cv cva co wceq wa wa vu wex vv wex wa vg wex vf wex vy wex vx wex vx cv
        cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel
        vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vw wex vz wex vy
        wex vx wex vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq
        wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa
        vu wex vv wex vg wex vf wex wa vx cv cA wcel vy cv cB wcel wa vh cv vx
        cv vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw
        cv cva co wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv
        cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co
        wceq wa wa wa vu wex vv wex vg wex vf wex vw wex vz wex vy wex vx wex
        vh cv cA cB cph co cC cD cph co cin cF cG cph co cR cS cph co cin cin
        wcel vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz
        cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vw wex
        vz wex vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa
        vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa vu
        wex vv wex vx vy vf vg ee4anv vx cv cA wcel vy cv cB wcel wa vh cv vx
        cv vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw
        cv cva co wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv
        cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co
        wceq wa wa wa vu wex vv wex vg wex vf wex vw wex vz wex vx cv cA wcel
        vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv
        cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vw wex vz wex vf cv cF
        wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu
        cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa vu wex vv wex wa vg
        wex vf wex vx vy vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva
        co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq
        wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa
        vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa wa
        vu wex vv wex vg wex vf wex vw wex vz wex vx cv cA wcel vy cv cB wcel
        wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh
        cv vz cv vw cv cva co wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv
        vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv
        vu cv cva co wceq wa wa wa vu wex vv wex vw wex vz wex vg wex vf wex vx
        cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC
        wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vw wex vz wex
        vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv
        cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa vu wex vv
        wex wa vg wex vf wex vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv
        cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co
        wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq
        wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa
        wa vu wex vv wex vz vw vf vg exrot4 vx cv cA wcel vy cv cB wcel wa vh
        cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz
        cv vw cv cva co wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv
        vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv
        cva co wceq wa wa wa vu wex vv wex vw wex vz wex vx cv cA wcel vy cv cB
        wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa
        vh cv vz cv vw cv cva co wceq wa wa vw wex vz wex vf cv cF wcel vg cv
        cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel
        wa vh cv vv cv vu cv cva co wceq wa wa vu wex vv wex wa vf vg vx cv cA
        wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vw
        cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vf cv cF wcel vg cv
        cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel
        wa vh cv vv cv vu cv cva co wceq wa wa vz vw vv vu ee4anv 2exbii bitri
        2exbii vh cv cA cB cph co cC cD cph co cin cF cG cph co cR cS cph co
        cin cin wcel vh cv cA cB cph co cC cD cph co cin wcel vh cv cF cG cph
        co cR cS cph co cin wcel wa vx cv cA wcel vy cv cB wcel wa vh cv vx cv
        vy cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv
        cva co wceq wa wa vw wex vz wex vy wex vx wex vf cv cF wcel vg cv cG
        wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel wa
        vh cv vv cv vu cv cva co wceq wa wa vu wex vv wex vg wex vf wex wa vh
        cv cA cB cph co cC cD cph co cin cF cG cph co cR cS cph co cin elin vx
        cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC
        wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vw wex vz wex
        vy wex vx wex vh cv cA cB cph co cC cD cph co cin wcel vf cv cF wcel vg
        cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS
        wcel wa vh cv vv cv vu cv cva co wceq wa wa vu wex vv wex vg wex vf wex
        vh cv cF cG cph co cR cS cph co cin wcel vh cv cA cB cph co wcel vh cv
        cC cD cph co wcel wa vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv
        cva co wceq wa vy wex vx wex vz cv cC wcel vw cv cD wcel wa vh cv vz cv
        vw cv cva co wceq wa vw wex vz wex wa vh cv cA cB cph co cC cD cph co
        cin wcel vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq
        wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa
        vw wex vz wex vy wex vx wex vh cv cA cB cph co wcel vx cv cA wcel vy cv
        cB wcel wa vh cv vx cv vy cv cva co wceq wa vy wex vx wex vh cv cC cD
        cph co wcel vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co
        wceq wa vw wex vz wex vh cv cA cB cph co wcel vh cv vx cv vy cv cva co
        wceq vy cB wrex vx cA wrex vx cv cA wcel vy cv cB wcel wa vh cv vx cv
        vy cv cva co wceq wa vy wex vx wex vx vy cA cB vh cv 5oalem5.1
        5oalem5.2 shseli vh cv vx cv vy cv cva co wceq vx vy cA cB r2ex bitri
        vh cv cC cD cph co wcel vh cv vz cv vw cv cva co wceq vw cD wrex vz cC
        wrex vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa vw
        wex vz wex vz vw cC cD vh cv 5oalem5.3 5oalem5.4 shseli vh cv vz cv vw
        cv cva co wceq vz vw cC cD r2ex bitri anbi12i vh cv cA cB cph co cC cD
        cph co elin vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co
        wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa
        vx vy vz vw ee4anv 3bitr4ri vh cv cF cG cph co wcel vh cv cR cS cph co
        wcel wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa
        vg wex vf wex vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co
        wceq wa vu wex vv wex wa vh cv cF cG cph co cR cS cph co cin wcel vf cv
        cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel
        vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa wa vu wex vv wex vg
        wex vf wex vh cv cF cG cph co wcel vf cv cF wcel vg cv cG wcel wa vh cv
        vf cv vg cv cva co wceq wa vg wex vf wex vh cv cR cS cph co wcel vv cv
        cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa vu wex vv wex
        vh cv cF cG cph co wcel vh cv vf cv vg cv cva co wceq vg cG wrex vf cF
        wrex vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vg
        wex vf wex vf vg cF cG vh cv 5oalem5.5 5oalem5.6 shseli vh cv vf cv vg
        cv cva co wceq vf vg cF cG r2ex bitri vh cv cR cS cph co wcel vh cv vv
        cv vu cv cva co wceq vu cS wrex vv cR wrex vv cv cR wcel vu cv cS wcel
        wa vh cv vv cv vu cv cva co wceq wa vu wex vv wex vv vu cR cS vh cv
        5oalem5.7 5oalem5.8 shseli vh cv vv cv vu cv cva co wceq vv vu cR cS
        r2ex bitri anbi12i vh cv cF cG cph co cR cS cph co elin vf cv cF wcel
        vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv
        cS wcel wa vh cv vv cv vu cv cva co wceq wa vf vg vv vu ee4anv 3bitr4ri
        anbi12i bitr4i 3bitr4ri vx cv cA wcel vy cv cB wcel wa vh cv vx cv vy
        cv cva co wceq wa vz cv cC wcel vw cv cD wcel wa vh cv vz cv vw cv cva
        co wceq wa wa vf cv cF wcel vg cv cG wcel wa vh cv vf cv vg cv cva co
        wceq wa vv cv cR wcel vu cv cS wcel wa vh cv vv cv vu cv cva co wceq wa
        wa wa vu wex vv wex vg wex vf wex vw wex vz wex vh cv cB cA cC cA cC
        cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD
        cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
        cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD
        cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
        cin cph co cin cph co cin cph co cin cph co wcel vx vy vx cv cA wcel vy
        cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cD
        wcel wa vh cv vz cv vw cv cva co wceq wa wa vf cv cF wcel vg cv cG wcel
        wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv cS wcel wa vh
        cv vv cv vu cv cva co wceq wa wa wa vu wex vv wex vg wex vf wex vh cv
        cB cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC
        cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA
        cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC
        cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co
        cG cS cph co cin cph co cin cph co cin cph co cin cph co wcel vz vw vx
        cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC
        wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vf cv cF wcel
        vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv
        cS wcel wa vh cv vv cv vu cv cva co wceq wa wa wa vu wex vv wex vh cv
        cB cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC
        cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA
        cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC
        cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co
        cG cS cph co cin cph co cin cph co cin cph co cin cph co wcel vf vg vx
        cv cA wcel vy cv cB wcel wa vh cv vx cv vy cv cva co wceq wa vz cv cC
        wcel vw cv cD wcel wa vh cv vz cv vw cv cva co wceq wa wa vf cv cF wcel
        vg cv cG wcel wa vh cv vf cv vg cv cva co wceq wa vv cv cR wcel vu cv
        cS wcel wa vh cv vv cv vu cv cva co wceq wa wa wa vh cv cB cA cC cA cC
        cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD
        cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
        cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD
        cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
        cin cph co cin cph co cin cph co cin cph co wcel vv vu vx vy vz vw vv
        vu cA cB cC cD cR cS vf vg vh cF cG 5oalem5.1 5oalem5.2 5oalem5.3
        5oalem5.4 5oalem5.5 5oalem5.6 5oalem5.7 5oalem5.8 5oalem6 19.23aivv
        19.23aivv 19.23aivv 19.23aivv sylbi ssriv $.
        $( [4-May-2000] $)
    $}
  $}

  ${
    5oa.1 $e |- A e. CH $.
    5oa.2 $e |- B e. CH $.
    5oa.3 $e |- C e. CH $.
    5oa.4 $e |- D e. CH $.
    5oa.5 $e |- F e. CH $.
    5oa.6 $e |- G e. CH $.
    5oa.7 $e |- R e. CH $.
    5oa.8 $e |- S e. CH $.
    5oa.9 $e |- A C_ ( _|_ ` B ) $.
    5oa.10 $e |- C C_ ( _|_ ` D ) $.
    5oa.11 $e |- F C_ ( _|_ ` G ) $.
    5oa.12 $e |- R C_ ( _|_ ` S ) $.
    $( Orthoarguesian law 5OA.  This 8-variable inference is called 5OA
       because it can be converted to a 5-variable equation (see
       Quantum Logic Explorer). $)
    5oai $p |- ( ( ( A vH B ) i^i ( C vH D ) ) i^i
            ( ( F vH G ) i^i ( R vH S ) ) ) C_ ( B vH ( A i^i ( C vH
               ( ( ( ( A vH C ) i^i ( B vH D ) ) i^i
                   ( ( ( A vH R ) i^i ( B vH S ) ) vH
                     ( ( C vH R ) i^i ( D vH S ) ) ) )
              i^i ( ( ( ( A vH F ) i^i ( B vH G ) ) i^i
                      ( ( ( A vH R ) i^i ( B vH S ) ) vH
                        ( ( F vH R ) i^i ( G vH S ) ) ) )
                 vH ( ( ( C vH F ) i^i ( D vH G ) ) i^i
                      ( ( ( C vH R ) i^i ( D vH S ) ) vH
                        ( ( F vH R ) i^i ( G vH S ) ) ) ) ) ) ) ) ) $=
      cA cB chj co cC cD chj co cin cF cG chj co cR cS chj co cin cin cB cA cC
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin cph co cin cph co cB cA cC cA cC chj co cB cD chj
      co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co
      cin cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj
      co cG cS chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co
      cD cS chj co cin cF cR chj co cG cS chj co cin chj co cin chj co cin chj
      co cin chj co cA cB chj co cC cD chj co cin cF cG chj co cR cS chj co cin
      cin cA cB cph co cC cD cph co cin cF cG cph co cR cS cph co cin cin cB cA
      cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph
      co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co
      cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD
      cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin cph co cin cph co cA cB cph co cC cD cph co cin cA
      cB chj co cC cD chj co cin cF cG cph co cR cS cph co cin cF cG chj co cR
      cS chj co cin cA cB cph co cA cB chj co cC cD cph co cC cD chj co cA cB
      cort cfv wss cA cB cph co cA cB chj co wceq 5oa.9 cA cB 5oa.1 5oa.2 osumi
      ax-mp cC cD cort cfv wss cC cD cph co cC cD chj co wceq 5oa.10 cC cD
      5oa.3 5oa.4 osumi ax-mp ineq12i cF cG cph co cF cG chj co cR cS cph co cR
      cS chj co cF cG cort cfv wss cF cG cph co cF cG chj co wceq 5oa.11 cF cG
      5oa.5 5oa.6 osumi ax-mp cR cS cort cfv wss cR cS cph co cR cS chj co wceq
      5oa.12 cR cS 5oa.7 5oa.8 osumi ax-mp ineq12i ineq12i cA cB cC cD cR cS cF
      cG cA 5oa.1 chshii cB 5oa.2 chshii cC 5oa.3 chshii cD 5oa.4 chshii cF
      5oa.5 chshii cG 5oa.6 chshii cR 5oa.7 chshii cS 5oa.8 chshii 5oalem7
      eqsstr3i cB cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co
      cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co
      cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cph co cin cph co cin cph co cB cA cC cA
      cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD
      cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin cph co cin chj co cB cA cC cA cC chj co cB cD chj
      co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co
      cin cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj
      co cG cS chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co
      cD cS chj co cin cF cR chj co cG cS chj co cin chj co cin chj co cin chj
      co cin chj co cB cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS
      cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG
      cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cin cph co cin cB 5oa.2
      chshii cA cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin
      cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA
      cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
      cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin cph co cin cph co cA 5oa.1 chshii cC cA cC cph co
      cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co
      cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co
      cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cph co cin cC 5oa.3 chshii cA cC cph co cB cD cph co cin cA cR cph co
      cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB
      cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cA cC cph co cB cD cph co
      cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cA
      cC cph co cB cD cph co cA cC cA 5oa.1 chshii cC 5oa.3 chshii shscli cB cD
      cB 5oa.2 chshii cD 5oa.4 chshii shscli shincli cA cR cph co cB cS cph co
      cin cC cR cph co cD cS cph co cin cA cR cph co cB cS cph co cA cR cA
      5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii
      shscli shincli cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7
      chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli shscli
      shincli cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR
      cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cA cF
      cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS
      cph co cin cph co cA cF cph co cB cG cph co cA cF cA 5oa.1 chshii cF
      5oa.5 chshii shscli cB cG cB 5oa.2 chshii cG 5oa.6 chshii shscli shincli
      cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cA cR cph co
      cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2
      chshii cS 5oa.8 chshii shscli shincli cF cR cph co cG cS cph co cF cR cF
      5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii
      shscli shincli shscli shincli cC cF cph co cD cG cph co cin cC cR cph co
      cD cS cph co cin cF cR cph co cG cS cph co cin cph co cC cF cph co cD cG
      cph co cC cF cC 5oa.3 chshii cF 5oa.5 chshii shscli cD cG cD 5oa.4 chshii
      cG 5oa.6 chshii shscli shincli cC cR cph co cD cS cph co cin cF cR cph co
      cG cS cph co cin cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7
      chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli cF cR
      cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG
      5oa.6 chshii cS 5oa.8 chshii shscli shincli shscli shincli shscli shincli
      shscli shincli shsleji cA cC cA cC cph co cB cD cph co cin cA cR cph co
      cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB
      cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cin cph co cin cA cC cA cC
      chj co cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS
      chj co cin chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cin chj co cin wss cB cA cC cA cC cph co cB cD cph co
      cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co
      cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co
      cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin cph
      co cin chj co cB cA cC cA cC chj co cB cD chj co cin cA cR chj co cB cS
      chj co cin cC cR chj co cD cS chj co cin chj co cin cA cF chj co cB cG
      chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin chj co cin chj co cin chj co wss cC
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin cph co cC cA cC chj co cB cD chj co cin cA cR chj
      co cB cS chj co cin cC cR chj co cD cS chj co cin chj co cin cA cF chj co
      cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co
      cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co
      cin cF cR chj co cG cS chj co cin chj co cin chj co cin chj co wss cA cC
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cin cph co cin cA cC cA cC chj co cB cD chj co cin cA
      cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co cin cA cF
      chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS
      chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin chj co cin chj co cin
      wss cC cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR
      cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR
      cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
      cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin cph co cin cph co cC cA cC cph co cB cD cph co cin
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA
      cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG
      cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin chj co cC
      cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co
      cD cS chj co cin chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB
      cS chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cin chj co cC cA cC cph co cB cD cph co cin cA cR cph
      co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co
      cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cph co cin cC 5oa.3 chshii
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co
      cin cC cR cph co cD cS cph co cin cph co cA cC cph co cB cD cph co cA cC
      cA 5oa.1 chshii cC 5oa.3 chshii shscli cB cD cB 5oa.2 chshii cD 5oa.4
      chshii shscli shincli cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7
      chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli shincli cC cR
      cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii shscli cD cS cD
      5oa.4 chshii cS 5oa.8 chshii shscli shincli shscli shincli cA cF cph co
      cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cA cF cph co cB cG cph co
      cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA
      cF cph co cB cG cph co cA cF cA 5oa.1 chshii cF 5oa.5 chshii shscli cB cG
      cB 5oa.2 chshii cG 5oa.6 chshii shscli shincli cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cA cR cph co cB cS cph co cA cR cA
      5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii
      shscli shincli cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7
      chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli shscli
      shincli cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR
      cph co cG cS cph co cin cph co cC cF cph co cD cG cph co cC cF cC 5oa.3
      chshii cF 5oa.5 chshii shscli cD cG cD 5oa.4 chshii cG 5oa.6 chshii
      shscli shincli cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
      cin cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii
      shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli cF cR cph co
      cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6
      chshii cS 5oa.8 chshii shscli shincli shscli shincli shscli shincli
      shsleji cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR
      cph co cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR
      cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
      cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin cph co cin cA cC chj co cB cD chj co cin cA cR chj
      co cB cS chj co cin cC cR chj co cD cS chj co cin chj co cin cA cF chj co
      cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co
      cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co
      cin cF cR chj co cG cS chj co cin chj co cin chj co cin wss cC cA cC cph
      co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph
      co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co
      cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cph co cin chj co cC cA cC chj co cB cD chj co cin cA cR chj co cB cS
      chj co cin cC cR chj co cD cS chj co cin chj co cin cA cF chj co cB cG
      chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin chj co cin chj co wss cA cC cph co
      cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co
      cin cph co cin cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co
      cin cC cR chj co cD cS chj co cin chj co cin wss cA cF cph co cB cG cph
      co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cph co cA cF chj co cB cG chj co cin cA cR
      chj co cB cS chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF
      chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS
      chj co cin chj co cin chj co wss cA cC cph co cB cD cph co cin cA cR cph
      co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co
      cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cph co cin cA cC chj co cB
      cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin
      chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR
      chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co cin chj co
      cin wss cA cC cph co cB cD cph co cin cA cC chj co cB cD chj co cin wss
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cA cR
      chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co wss cA cC
      cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cph co cin cA cC chj co cB cD chj co cin cA cR chj co cB cS
      chj co cin cC cR chj co cD cS chj co cin chj co cin wss cA cC cph co cA
      cC chj co wss cB cD cph co cB cD chj co wss cA cC cph co cB cD cph co cin
      cA cC chj co cB cD chj co cin wss cA cC 5oa.1 5oa.3 chsleji cB cD 5oa.2
      5oa.4 chsleji cA cC cph co cA cC chj co cB cD cph co cB cD chj co ss2in
      mp2an cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin chj co cA cR
      chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co cA cR cph co
      cB cS cph co cin cC cR cph co cD cS cph co cin cA cR cph co cB cS cph co
      cA cR cA 5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS
      5oa.8 chshii shscli shincli cC cR cph co cD cS cph co cC cR cC 5oa.3
      chshii cR 5oa.7 chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii
      shscli shincli shsleji cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin chj co cA cR cph co cB cS cph co cin cC cR chj co cD cS chj co
      cin chj co cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin
      chj co cC cR cph co cD cS cph co cin cC cR chj co cD cS chj co cin wss cA
      cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin chj co cA cR cph
      co cB cS cph co cin cC cR chj co cD cS chj co cin chj co wss cC cR cph co
      cC cR chj co wss cD cS cph co cD cS chj co wss cC cR cph co cD cS cph co
      cin cC cR chj co cD cS chj co cin wss cC cR 5oa.3 5oa.7 chsleji cD cS
      5oa.4 5oa.8 chsleji cC cR cph co cC cR chj co cD cS cph co cD cS chj co
      ss2in mp2an cC cR cph co cD cS cph co cin cC cR chj co cD cS chj co cin
      cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cC cR cC 5oa.3
      chshii cR 5oa.7 chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii
      shscli shincli cC cR chj co cD cS chj co cC cR cC 5oa.3 chshii cR 5oa.7
      chshii shjshcli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shjshcli shincli cA
      cR cph co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shscli cB cS
      cB 5oa.2 chshii cS 5oa.8 chshii shscli shincli shlej2i ax-mp cA cR cph co
      cB cS cph co cin cA cR chj co cB cS chj co cin wss cA cR cph co cB cS cph
      co cin cC cR chj co cD cS chj co cin chj co cA cR chj co cB cS chj co cin
      cC cR chj co cD cS chj co cin chj co wss cA cR cph co cA cR chj co wss cB
      cS cph co cB cS chj co wss cA cR cph co cB cS cph co cin cA cR chj co cB
      cS chj co cin wss cA cR 5oa.1 5oa.7 chsleji cB cS 5oa.2 5oa.8 chsleji cA
      cR cph co cA cR chj co cB cS cph co cB cS chj co ss2in mp2an cA cR cph co
      cB cS cph co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co
      cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7 chshii
      shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli shincli cA cR chj co
      cB cS chj co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shjshcli cB cS cB
      5oa.2 chshii cS 5oa.8 chshii shjshcli shincli cC cR chj co cD cS chj co
      cC cR cC 5oa.3 chshii cR 5oa.7 chshii shjshcli cD cS cD 5oa.4 chshii cS
      5oa.8 chshii shjshcli shincli shlej1i ax-mp sstri sstri cA cC cph co cB
      cD cph co cin cA cC chj co cB cD chj co cin cA cR cph co cB cS cph co cin
      cC cR cph co cD cS cph co cin cph co cA cR chj co cB cS chj co cin cC cR
      chj co cD cS chj co cin chj co ss2in mp2an cA cF cph co cB cG cph co cin
      cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC
      cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG
      cS cph co cin cph co cin cph co cA cF cph co cB cG cph co cin cA cR cph
      co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co
      cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin chj co cA cF chj co cB cG chj co cin cA cR chj co cB cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co
      cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co
      cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph
      co cG cS cph co cin cph co cA cF cph co cB cG cph co cA cF cA 5oa.1
      chshii cF 5oa.5 chshii shscli cB cG cB 5oa.2 chshii cG 5oa.6 chshii
      shscli shincli cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7 chshii
      shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli shincli cF cR cph co
      cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6
      chshii cS 5oa.8 chshii shscli shincli shscli shincli cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cC cF cph co cD cG cph co cC cF cC 5oa.3 chshii cF 5oa.5 chshii
      shscli cD cG cD 5oa.4 chshii cG 5oa.6 chshii shscli shincli cC cR cph co
      cD cS cph co cin cF cR cph co cG cS cph co cin cC cR cph co cD cS cph co
      cC cR cC 5oa.3 chshii cR 5oa.7 chshii shscli cD cS cD 5oa.4 chshii cS
      5oa.8 chshii shscli shincli cF cR cph co cG cS cph co cF cR cF 5oa.5
      chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii
      shscli shincli shscli shincli shsleji cA cF cph co cB cG cph co cin cA cR
      cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
      cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin chj co cA cF cph co cB cG cph co cin cA cR cph co
      cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF chj co cD
      cG chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co
      cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG chj co
      cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co
      cin chj co cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cC cF chj co cD cG chj co cin cC cR
      chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co cin wss cA
      cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG
      cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin chj co cA cF cph co
      cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co
      cin cF cR chj co cG cS chj co cin chj co cin chj co wss cC cF cph co cD
      cG cph co cin cC cF chj co cD cG chj co cin wss cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cC cR chj co cD cS chj co cin cF
      cR chj co cG cS chj co cin chj co wss cC cF cph co cD cG cph co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF
      chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS
      chj co cin chj co cin wss cC cF cph co cC cF chj co wss cD cG cph co cD
      cG chj co wss cC cF cph co cD cG cph co cin cC cF chj co cD cG chj co cin
      wss cC cF 5oa.3 5oa.5 chsleji cD cG 5oa.4 5oa.6 chsleji cC cF cph co cC
      cF chj co cD cG cph co cD cG chj co ss2in mp2an cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin chj co cC cR chj co cD cS chj co cin cF cR chj
      co cG cS chj co cin chj co cC cR cph co cD cS cph co cin cF cR cph co cG
      cS cph co cin cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7
      chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli cF cR
      cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG
      5oa.6 chshii cS 5oa.8 chshii shscli shincli shsleji cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin chj co cC cR cph co cD cS cph co
      cin cF cR chj co cG cS chj co cin chj co cC cR chj co cD cS chj co cin cF
      cR chj co cG cS chj co cin chj co cF cR cph co cG cS cph co cin cF cR chj
      co cG cS chj co cin wss cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin chj co cC cR cph co cD cS cph co cin cF cR chj co cG cS chj co
      cin chj co wss cF cR cph co cF cR chj co wss cG cS cph co cG cS chj co
      wss cF cR cph co cG cS cph co cin cF cR chj co cG cS chj co cin wss cF cR
      5oa.5 5oa.7 chsleji cG cS 5oa.6 5oa.8 chsleji cF cR cph co cF cR chj co
      cG cS cph co cG cS chj co ss2in mp2an cF cR cph co cG cS cph co cin cF cR
      chj co cG cS chj co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6 chshii
      cS 5oa.8 chshii shscli shincli cF cR chj co cG cS chj co cF cR cF 5oa.5
      chshii cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii cS 5oa.8 chshii
      shjshcli shincli cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7
      chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli
      shlej2i ax-mp cC cR cph co cD cS cph co cin cC cR chj co cD cS chj co cin
      wss cC cR cph co cD cS cph co cin cF cR chj co cG cS chj co cin chj co cC
      cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co wss cC cR
      cph co cC cR chj co wss cD cS cph co cD cS chj co wss cC cR cph co cD cS
      cph co cin cC cR chj co cD cS chj co cin wss cC cR 5oa.3 5oa.7 chsleji cD
      cS 5oa.4 5oa.8 chsleji cC cR cph co cC cR chj co cD cS cph co cD cS chj
      co ss2in mp2an cC cR cph co cD cS cph co cin cC cR chj co cD cS chj co
      cin cF cR chj co cG cS chj co cin cC cR cph co cD cS cph co cC cR cC
      5oa.3 chshii cR 5oa.7 chshii shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii
      shscli shincli cC cR chj co cD cS chj co cC cR cC 5oa.3 chshii cR 5oa.7
      chshii shjshcli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shjshcli shincli cF
      cR chj co cG cS chj co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shjshcli cG
      cS cG 5oa.6 chshii cS 5oa.8 chshii shjshcli shincli shlej1i ax-mp sstri
      sstri cC cF cph co cD cG cph co cin cC cF chj co cD cG chj co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cC cR chj co
      cD cS chj co cin cF cR chj co cG cS chj co cin chj co ss2in mp2an cC cF
      cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin cA cF cph co cB cG
      cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cC cF cph co cD cG cph co cC cF cC
      5oa.3 chshii cF 5oa.5 chshii shscli cD cG cD 5oa.4 chshii cG 5oa.6 chshii
      shscli shincli cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
      cin cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii
      shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli cF cR cph co
      cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6
      chshii cS 5oa.8 chshii shscli shincli shscli shincli cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cC cF chj co cD cG chj co cin cC cF chj co cD cG chj co cC cF
      5oa.3 5oa.5 chjcli cD cG 5oa.4 5oa.6 chjcli chincli chshii cC cR chj co
      cD cS chj co cin cF cR chj co cG cS chj co cin cC cR chj co cD cS chj co
      cC cR cC 5oa.3 chshii cR 5oa.7 chshii shjshcli cD cS cD 5oa.4 chshii cS
      5oa.8 chshii shjshcli shincli cF cR chj co cG cS chj co cF cR cF 5oa.5
      chshii cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii cS 5oa.8 chshii
      shjshcli shincli shjshcli shincli cA cF cph co cB cG cph co cin cA cR cph
      co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA cF cph co cB
      cG cph co cA cF cA 5oa.1 chshii cF 5oa.5 chshii shscli cB cG cB 5oa.2
      chshii cG 5oa.6 chshii shscli shincli cA cR cph co cB cS cph co cin cF cR
      cph co cG cS cph co cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii
      cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli
      shincli cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii
      shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli shscli
      shincli shlej2i ax-mp cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cA cF chj co cB cG
      chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin wss cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cC cF chj co cD cG chj co
      cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co
      cin chj co cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR
      chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co cin chj co
      wss cA cF cph co cB cG cph co cin cA cF chj co cB cG chj co cin wss cA cR
      cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA cR chj co
      cB cS chj co cin cF cR chj co cG cS chj co cin chj co wss cA cF cph co cB
      cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin wss cA cF cph co cA cF chj co wss
      cB cG cph co cB cG chj co wss cA cF cph co cB cG cph co cin cA cF chj co
      cB cG chj co cin wss cA cF 5oa.1 5oa.5 chsleji cB cG 5oa.2 5oa.6 chsleji
      cA cF cph co cA cF chj co cB cG cph co cB cG chj co ss2in mp2an cA cR cph
      co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin chj co cA cR chj co cB cS chj
      co cin cF cR chj co cG cS chj co cin chj co cA cR cph co cB cS cph co cin
      cF cR cph co cG cS cph co cin cA cR cph co cB cS cph co cA cR cA 5oa.1
      chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii
      shscli shincli cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7
      chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli
      shsleji cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin chj
      co cA cR cph co cB cS cph co cin cF cR chj co cG cS chj co cin chj co cA
      cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin chj co cF cR cph
      co cG cS cph co cin cF cR chj co cG cS chj co cin wss cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin chj co cA cR cph co cB cS cph co
      cin cF cR chj co cG cS chj co cin chj co wss cF cR cph co cF cR chj co
      wss cG cS cph co cG cS chj co wss cF cR cph co cG cS cph co cin cF cR chj
      co cG cS chj co cin wss cF cR 5oa.5 5oa.7 chsleji cG cS 5oa.6 5oa.8
      chsleji cF cR cph co cF cR chj co cG cS cph co cG cS chj co ss2in mp2an
      cF cR cph co cG cS cph co cin cF cR chj co cG cS chj co cin cA cR cph co
      cB cS cph co cin cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7
      chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli cF cR
      chj co cG cS chj co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shjshcli cG cS
      cG 5oa.6 chshii cS 5oa.8 chshii shjshcli shincli cA cR cph co cB cS cph
      co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS
      5oa.8 chshii shscli shincli shlej2i ax-mp cA cR cph co cB cS cph co cin
      cA cR chj co cB cS chj co cin wss cA cR cph co cB cS cph co cin cF cR chj
      co cG cS chj co cin chj co cA cR chj co cB cS chj co cin cF cR chj co cG
      cS chj co cin chj co wss cA cR cph co cA cR chj co wss cB cS cph co cB cS
      chj co wss cA cR cph co cB cS cph co cin cA cR chj co cB cS chj co cin
      wss cA cR 5oa.1 5oa.7 chsleji cB cS 5oa.2 5oa.8 chsleji cA cR cph co cA
      cR chj co cB cS cph co cB cS chj co ss2in mp2an cA cR cph co cB cS cph co
      cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin cA cR cph
      co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB
      5oa.2 chshii cS 5oa.8 chshii shscli shincli cA cR chj co cB cS chj co cA
      cR cA 5oa.1 chshii cR 5oa.7 chshii shjshcli cB cS cB 5oa.2 chshii cS
      5oa.8 chshii shjshcli shincli cF cR chj co cG cS chj co cF cR cF 5oa.5
      chshii cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii cS 5oa.8 chshii
      shjshcli shincli shlej1i ax-mp sstri sstri cA cF cph co cB cG cph co cin
      cA cF chj co cB cG chj co cin cA cR cph co cB cS cph co cin cF cR cph co
      cG cS cph co cin cph co cA cR chj co cB cS chj co cin cF cR chj co cG cS
      chj co cin chj co ss2in mp2an cA cF cph co cB cG cph co cin cA cR cph co
      cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cA cF chj co cB
      cG chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin cA cF cph co cB cG cph co cin cA cR
      cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA cF cph co
      cB cG cph co cA cF cA 5oa.1 chshii cF 5oa.5 chshii shscli cB cG cB 5oa.2
      chshii cG 5oa.6 chshii shscli shincli cA cR cph co cB cS cph co cin cF cR
      cph co cG cS cph co cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii
      cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli
      shincli cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii
      shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli shscli
      shincli cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF cR
      chj co cG cS chj co cin chj co cA cF chj co cB cG chj co cin cA cF chj co
      cB cG chj co cA cF 5oa.1 5oa.5 chjcli cB cG 5oa.2 5oa.6 chjcli chincli
      chshii cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin cA cR
      chj co cB cS chj co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shjshcli cB cS
      cB 5oa.2 chshii cS 5oa.8 chshii shjshcli shincli cF cR chj co cG cS chj
      co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii
      cS 5oa.8 chshii shjshcli shincli shjshcli shincli cC cF chj co cD cG chj
      co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co
      cC cF chj co cD cG chj co cin cC cF chj co cD cG chj co cC cF 5oa.3 5oa.5
      chjcli cD cG 5oa.4 5oa.6 chjcli chincli chshii cC cR chj co cD cS chj co
      cin cF cR chj co cG cS chj co cin cC cR chj co cD cS chj co cC cR cC
      5oa.3 chshii cR 5oa.7 chshii shjshcli cD cS cD 5oa.4 chshii cS 5oa.8
      chshii shjshcli shincli cF cR chj co cG cS chj co cF cR cF 5oa.5 chshii
      cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shjshcli
      shincli shjshcli shincli shlej1i ax-mp sstri sstri cA cC cph co cB cD cph
      co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co
      cin cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj
      co cD cS chj co cin chj co cin cA cF cph co cB cG cph co cin cA cR cph co
      cB cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD
      cG cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co
      cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG chj co
      cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co
      cin chj co ss2in mp2an cA cC cph co cB cD cph co cin cA cR cph co cB cS
      cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB cG
      cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cin cA cC chj co cB cD chj
      co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co
      cin cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj
      co cG cS chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co
      cD cS chj co cin cF cR chj co cG cS chj co cin chj co cin chj co cin cC
      cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co
      cD cS cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB
      cS cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co
      cin cC cR cph co cD cS cph co cin cph co cA cC cph co cB cD cph co cA cC
      cA 5oa.1 chshii cC 5oa.3 chshii shscli cB cD cB 5oa.2 chshii cD 5oa.4
      chshii shscli shincli cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7
      chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli shincli cC cR
      cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii shscli cD cS cD
      5oa.4 chshii cS 5oa.8 chshii shscli shincli shscli shincli cA cF cph co
      cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cA cF cph co cB cG cph co
      cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA
      cF cph co cB cG cph co cA cF cA 5oa.1 chshii cF 5oa.5 chshii shscli cB cG
      cB 5oa.2 chshii cG 5oa.6 chshii shscli shincli cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cA cR cph co cB cS cph co cA cR cA
      5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii
      shscli shincli cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7
      chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli shscli
      shincli cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR
      cph co cG cS cph co cin cph co cC cF cph co cD cG cph co cC cF cC 5oa.3
      chshii cF 5oa.5 chshii shscli cD cG cD 5oa.4 chshii cG 5oa.6 chshii
      shscli shincli cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
      cin cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii
      shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli cF cR cph co
      cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6
      chshii cS 5oa.8 chshii shscli shincli shscli shincli shscli shincli cA cC
      chj co cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS
      chj co cin chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co
      cin cC cR chj co cD cS chj co cin chj co cin cA cC chj co cB cD chj co
      cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co cA
      cC chj co cB cD chj co cA cC 5oa.1 5oa.3 chjcli cB cD 5oa.2 5oa.4 chjcli
      chincli cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co cin cA cR
      chj co cB cS chj co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shjshcli cB cS
      cB 5oa.2 chshii cS 5oa.8 chshii shjshcli shincli cC cR chj co cD cS chj
      co cC cR cC 5oa.3 chshii cR 5oa.7 chshii shjshcli cD cS cD 5oa.4 chshii
      cS 5oa.8 chshii shjshcli shincli shjcli chincli chshii cA cF chj co cB cG
      chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF
      cR chj co cG cS chj co cin chj co cin cA cF chj co cB cG chj co cin cA cR
      chj co cB cS chj co cin cF cR chj co cG cS chj co cin chj co cA cF chj co
      cB cG chj co cin cA cF chj co cB cG chj co cA cF 5oa.1 5oa.5 chjcli cB cG
      5oa.2 5oa.6 chjcli chincli chshii cA cR chj co cB cS chj co cin cF cR chj
      co cG cS chj co cin cA cR chj co cB cS chj co cA cR cA 5oa.1 chshii cR
      5oa.7 chshii shjshcli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shjshcli
      shincli cF cR chj co cG cS chj co cF cR cF 5oa.5 chshii cR 5oa.7 chshii
      shjshcli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shjshcli shincli shjshcli
      shincli cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF cR
      chj co cG cS chj co cin chj co cC cF chj co cD cG chj co cin cC cF chj co
      cD cG chj co cC cF 5oa.3 5oa.5 chjcli cD cG 5oa.4 5oa.6 chjcli chincli
      chshii cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin cC cR
      chj co cD cS chj co cC cR cC 5oa.3 chshii cR 5oa.7 chshii shjshcli cD cS
      cD 5oa.4 chshii cS 5oa.8 chshii shjshcli shincli cF cR chj co cG cS chj
      co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii
      cS 5oa.8 chshii shjshcli shincli shjshcli shincli shjshcli shincli cC
      5oa.3 chshii shlej2i ax-mp sstri cC cA cC cph co cB cD cph co cin cA cR
      cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF
      cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS
      cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin cph co cC
      cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co
      cD cS chj co cin chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB
      cS chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cin chj co cA sslin ax-mp cA cC cA cC cph co cB cD cph
      co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin cph co
      cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph
      co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co
      cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co cin cph
      co cin cA cC cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co cin
      cC cR chj co cD cS chj co cin chj co cin cA cF chj co cB cG chj co cin cA
      cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF
      chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS
      chj co cin chj co cin chj co cin chj co cin cB cA cC cA cC cph co cB cD
      cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS cph co cin
      cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG cph co cin cC cR
      cph co cD cS cph co cin cF cR cph co cG cS cph co cin cph co cin cph co
      cin cph co cA 5oa.1 chshii cC cA cC cph co cB cD cph co cin cA cR cph co
      cB cS cph co cin cC cR cph co cD cS cph co cin cph co cin cA cF cph co cB
      cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF
      cR cph co cG cS cph co cin cph co cin cph co cin cC 5oa.3 chshii cA cC
      cph co cB cD cph co cin cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cph co cin cA cF cph co cB cG cph co cin cA cR cph co cB cS
      cph co cin cF cR cph co cG cS cph co cin cph co cin cC cF cph co cD cG
      cph co cin cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co cin
      cph co cin cph co cA cC cph co cB cD cph co cin cA cR cph co cB cS cph co
      cin cC cR cph co cD cS cph co cin cph co cA cC cph co cB cD cph co cA cC
      cA 5oa.1 chshii cC 5oa.3 chshii shscli cB cD cB 5oa.2 chshii cD 5oa.4
      chshii shscli shincli cA cR cph co cB cS cph co cin cC cR cph co cD cS
      cph co cin cA cR cph co cB cS cph co cA cR cA 5oa.1 chshii cR 5oa.7
      chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii shscli shincli cC cR
      cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii shscli cD cS cD
      5oa.4 chshii cS 5oa.8 chshii shscli shincli shscli shincli cA cF cph co
      cB cG cph co cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co
      cin cph co cin cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co
      cin cF cR cph co cG cS cph co cin cph co cin cA cF cph co cB cG cph co
      cin cA cR cph co cB cS cph co cin cF cR cph co cG cS cph co cin cph co cA
      cF cph co cB cG cph co cA cF cA 5oa.1 chshii cF 5oa.5 chshii shscli cB cG
      cB 5oa.2 chshii cG 5oa.6 chshii shscli shincli cA cR cph co cB cS cph co
      cin cF cR cph co cG cS cph co cin cA cR cph co cB cS cph co cA cR cA
      5oa.1 chshii cR 5oa.7 chshii shscli cB cS cB 5oa.2 chshii cS 5oa.8 chshii
      shscli shincli cF cR cph co cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7
      chshii shscli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shscli shincli shscli
      shincli cC cF cph co cD cG cph co cin cC cR cph co cD cS cph co cin cF cR
      cph co cG cS cph co cin cph co cC cF cph co cD cG cph co cC cF cC 5oa.3
      chshii cF 5oa.5 chshii shscli cD cG cD 5oa.4 chshii cG 5oa.6 chshii
      shscli shincli cC cR cph co cD cS cph co cin cF cR cph co cG cS cph co
      cin cC cR cph co cD cS cph co cC cR cC 5oa.3 chshii cR 5oa.7 chshii
      shscli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shscli shincli cF cR cph co
      cG cS cph co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shscli cG cS cG 5oa.6
      chshii cS 5oa.8 chshii shscli shincli shscli shincli shscli shincli
      shscli shincli cA cC cA cC chj co cB cD chj co cin cA cR chj co cB cS chj
      co cin cC cR chj co cD cS chj co cin chj co cin cA cF chj co cB cG chj co
      cin cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin chj co
      cin cC cF chj co cD cG chj co cin cC cR chj co cD cS chj co cin cF cR chj
      co cG cS chj co cin chj co cin chj co cin chj co cA 5oa.1 chshii cC cA cC
      chj co cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS
      chj co cin chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD cG
      chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin chj co cin cC 5oa.3 chshii cA cC chj co cB cD chj co cin cA cR
      chj co cB cS chj co cin cC cR chj co cD cS chj co cin chj co cin cA cF
      chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF cR chj co cG cS
      chj co cin chj co cin cC cF chj co cD cG chj co cin cC cR chj co cD cS
      chj co cin cF cR chj co cG cS chj co cin chj co cin chj co cA cC chj co
      cB cD chj co cin cA cR chj co cB cS chj co cin cC cR chj co cD cS chj co
      cin chj co cin cA cC chj co cB cD chj co cin cA cR chj co cB cS chj co
      cin cC cR chj co cD cS chj co cin chj co cA cC chj co cB cD chj co cA cC
      5oa.1 5oa.3 chjcli cB cD 5oa.2 5oa.4 chjcli chincli cA cR chj co cB cS
      chj co cin cC cR chj co cD cS chj co cin cA cR chj co cB cS chj co cA cR
      cA 5oa.1 chshii cR 5oa.7 chshii shjshcli cB cS cB 5oa.2 chshii cS 5oa.8
      chshii shjshcli shincli cC cR chj co cD cS chj co cC cR cC 5oa.3 chshii
      cR 5oa.7 chshii shjshcli cD cS cD 5oa.4 chshii cS 5oa.8 chshii shjshcli
      shincli shjcli chincli chshii cA cF chj co cB cG chj co cin cA cR chj co
      cB cS chj co cin cF cR chj co cG cS chj co cin chj co cin cC cF chj co cD
      cG chj co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin
      chj co cin cA cF chj co cB cG chj co cin cA cR chj co cB cS chj co cin cF
      cR chj co cG cS chj co cin chj co cA cF chj co cB cG chj co cin cA cF chj
      co cB cG chj co cA cF 5oa.1 5oa.5 chjcli cB cG 5oa.2 5oa.6 chjcli chincli
      chshii cA cR chj co cB cS chj co cin cF cR chj co cG cS chj co cin cA cR
      chj co cB cS chj co cA cR cA 5oa.1 chshii cR 5oa.7 chshii shjshcli cB cS
      cB 5oa.2 chshii cS 5oa.8 chshii shjshcli shincli cF cR chj co cG cS chj
      co cF cR cF 5oa.5 chshii cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii
      cS 5oa.8 chshii shjshcli shincli shjshcli shincli cC cF chj co cD cG chj
      co cin cC cR chj co cD cS chj co cin cF cR chj co cG cS chj co cin chj co
      cC cF chj co cD cG chj co cin cC cF chj co cD cG chj co cC cF 5oa.3 5oa.5
      chjcli cD cG 5oa.4 5oa.6 chjcli chincli chshii cC cR chj co cD cS chj co
      cin cF cR chj co cG cS chj co cin cC cR chj co cD cS chj co cC cR cC
      5oa.3 chshii cR 5oa.7 chshii shjshcli cD cS cD 5oa.4 chshii cS 5oa.8
      chshii shjshcli shincli cF cR chj co cG cS chj co cF cR cF 5oa.5 chshii
      cR 5oa.7 chshii shjshcli cG cS cG 5oa.6 chshii cS 5oa.8 chshii shjshcli
      shincli shjshcli shincli shjshcli shincli shjshcli shincli cB 5oa.2
      chshii shlej2i ax-mp sstri sstri $.
      $( [5-May-2000] $)
  $}

  ${
    $d x y z w v B $.  $d x y z w v C $.  $d x y z w v R $.  $d x y z w v S $.
    3oalem1.1 $e |- B e. CH $.
    3oalem1.2 $e |- C e. CH $.
    3oalem1.3 $e |- R e. CH $.
    3oalem1.4 $e |- S e. CH $.
    $( Lemma for 3OA (weak) orthoarguesian law. $)
    3oalem1 $p |- ( ( ( ( x e. B /\ y e. R ) /\ v = ( x +h y ) ) /\
                  ( ( z e. C /\ w e. S ) /\ v = ( z +h w ) ) ) ->
                 ( ( ( x e. ~H /\ y e. ~H ) /\ v e. ~H ) /\
                  ( z e. ~H /\ w e. ~H ) ) ) $=
      vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vx cv
      chil wcel vy cv chil wcel wa vv cv chil wcel wa vz cv cC wcel vw cv cS
      wcel wa vv cv vz cv vw cv cva co wceq wa vz cv chil wcel vw cv chil wcel
      wa vx cv chil wcel vy cv chil wcel wa vv cv vx cv vy cv cva co wceq vx cv
      chil wcel vy cv chil wcel wa vv cv chil wcel wa vx cv cB wcel vy cv cR
      wcel wa vx cv chil wcel vy cv chil wcel wa vv cv vx cv vy cv cva co wceq
      vv cv chil wcel vv cv vx cv vy cv cva co wceq vv cv chil wcel vx cv vy cv
      cva co chil wcel vx cv chil wcel vy cv chil wcel wa vv cv vx cv vy cv cva
      co chil eleq1 vx cv vy cv hvaddcl syl5cbir imdistani vx cv cB wcel vx cv
      chil wcel vy cv cR wcel vy cv chil wcel vx cv cB 3oalem1.1 cheli vy cv cR
      3oalem1.3 cheli anim12i sylan vz cv cC wcel vw cv cS wcel wa vz cv chil
      wcel vw cv chil wcel wa vv cv vz cv vw cv cva co wceq vz cv cC wcel vz cv
      chil wcel vw cv cS wcel vw cv chil wcel vz cv cC 3oalem1.2 cheli vw cv cS
      3oalem1.4 cheli anim12i adantr anim12i $.
      $( [19-Oct-1999] $)

    $( Lemma for 3OA (weak) orthoarguesian law. $)
    3oalem2 $p |- ( ( ( ( x e. B /\ y e. R ) /\ v = ( x +h y ) ) /\
                  ( ( z e. C /\ w e. S ) /\ v = ( z +h w ) ) ) ->
            v e. ( B +H ( R i^i ( S +H ( ( B +H C ) i^i ( R +H S ) ) ) ) ) ) $=
      vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC
      wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa vv cv cB cR cS
      cB cC cph co cR cS cph co cin cph co cin cph co wcel vx cv vy cv cva co
      cB cR cS cB cC cph co cR cS cph co cin cph co cin cph co wcel vx cv cB
      wcel vy cv cR cS cB cC cph co cR cS cph co cin cph co cin wcel vx cv vy
      cv cva co cB cR cS cB cC cph co cR cS cph co cin cph co cin cph co wcel
      vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC
      wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa cB cR cS cB cC
      cph co cR cS cph co cin cph co cin vx cv vy cv cB 3oalem1.1 chshii cR cS
      cB cC cph co cR cS cph co cin cph co cR 3oalem1.3 chshii cS cB cC cph co
      cR cS cph co cin cS 3oalem1.4 chshii cB cC cph co cR cS cph co cB cC cB
      3oalem1.1 chshii cC 3oalem1.2 chshii shscli cR cS cR 3oalem1.3 chshii cS
      3oalem1.4 chshii shscli shincli shscli shincli shsvai vx cv cB wcel vy cv
      cR wcel wa vx cv cB wcel vv cv vx cv vy cv cva co wceq vz cv cC wcel vw
      cv cS wcel wa vv cv vz cv vw cv cva co wceq wa vx cv cB wcel vy cv cR
      wcel pm3.26 ad2antrr vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva
      co wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq
      wa wa vy cv cR wcel vy cv cS cB cC cph co cR cS cph co cin cph co wcel wa
      vy cv cR cS cB cC cph co cR cS cph co cin cph co cin wcel vx cv cB wcel
      vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cS
      wcel wa vv cv vz cv vw cv cva co wceq wa wa vy cv cR wcel vy cv cS cB cC
      cph co cR cS cph co cin cph co wcel vx cv cB wcel vy cv cR wcel wa vy cv
      cR wcel vv cv vx cv vy cv cva co wceq vz cv cC wcel vw cv cS wcel wa vv
      cv vz cv vw cv cva co wceq wa vx cv cB wcel vy cv cR wcel pm3.27 ad2antrr
      vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC
      wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa vw cv vy cv vw
      cv cmv co cva co vy cv cS cB cC cph co cR cS cph co cin cph co vx cv cB
      wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw
      cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa vx cv chil wcel vy cv
      chil wcel wa vv cv chil wcel wa vz cv chil wcel vw cv chil wcel wa wa vw
      cv vy cv vw cv cmv co cva co vy cv wceq vx vy vz vw vv cB cC cR cS
      3oalem1.1 3oalem1.2 3oalem1.3 3oalem1.4 3oalem1 vx cv chil wcel vy cv
      chil wcel wa vz cv chil wcel vw cv chil wcel wa vw cv vy cv vw cv cmv co
      cva co vy cv wceq vv cv chil wcel vy cv chil wcel vw cv chil wcel vw cv
      vy cv vw cv cmv co cva co vy cv wceq vx cv chil wcel vz cv chil wcel vy
      cv chil wcel vw cv chil wcel wa vy cv vw cv vw cv cmv co cva co vw cv vy
      cv vw cv cmv co cva co vy cv vy cv chil wcel vw cv chil wcel vy cv vw cv
      vw cv cmv co cva co vw cv vy cv vw cv cmv co cva co wceq vy cv vw cv vw
      cv hvaddsub12 3anidm23 vw cv chil wcel vy cv chil wcel vy cv vw cv vw cv
      cmv co cva co vy cv c0v cva co vy cv vw cv chil wcel vw cv vw cv cmv co
      c0v vy cv cva vw cv hvsubid opreq2d vy cv ax-hvaddid sylan9eqr eqtr3d
      ad2ant2l adantlr syl vw cv cS wcel vy cv vw cv cmv co cB cC cph co cR cS
      cph co cin wcel vw cv vy cv vw cv cmv co cva co cS cB cC cph co cR cS cph
      co cin cph co wcel vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva
      co wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq
      wa wa cS cB cC cph co cR cS cph co cin vw cv vy cv vw cv cmv co cS
      3oalem1.4 chshii cB cC cph co cR cS cph co cB cC cB 3oalem1.1 chshii cC
      3oalem1.2 chshii shscli cR cS cR 3oalem1.3 chshii cS 3oalem1.4 chshii
      shscli shincli shsvai vz cv cC wcel vw cv cS wcel wa vw cv cS wcel vx cv
      cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vv cv vz cv vw
      cv cva co wceq vz cv cC wcel vw cv cS wcel pm3.27 ad2antrl vx cv cB wcel
      vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cS
      wcel wa vv cv vz cv vw cv cva co wceq wa wa vy cv vw cv cmv co cB cC cph
      co wcel vy cv vw cv cmv co cR cS cph co wcel wa vy cv vw cv cmv co cB cC
      cph co cR cS cph co cin wcel vx cv cB wcel vy cv cR wcel wa vv cv vx cv
      vy cv cva co wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva
      co wceq wa wa vy cv vw cv cmv co cB cC cph co wcel vy cv vw cv cmv co cR
      cS cph co wcel vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co
      wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa
      wa vy cv vw cv cmv co vz cv vx cv cmv co cB cC cph co vx cv cB wcel vy cv
      cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cS wcel
      wa vv cv vz cv vw cv cva co wceq wa wa vx cv vy cv cva co vx cv vw cv cva
      co cmv co vz cv vw cv cva co vx cv vw cv cva co cmv co vy cv vw cv cmv co
      vz cv vx cv cmv co vv cv vx cv vy cv cva co wceq vv cv vz cv vw cv cva co
      wceq vx cv vy cv cva co vx cv vw cv cva co cmv co vz cv vw cv cva co vx
      cv vw cv cva co cmv co wceq vx cv cB wcel vy cv cR wcel wa vz cv cC wcel
      vw cv cS wcel wa vv cv vx cv vy cv cva co wceq vv cv vz cv vw cv cva co
      wceq wa vx cv vy cv cva co vz cv vw cv cva co vx cv vw cv cva co cmv vv
      cv vx cv vy cv cva co vz cv vw cv cva co eqtr2 opreq1d ad2ant2l vx cv cB
      wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw
      cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa vx cv chil wcel vy cv
      chil wcel wa vv cv chil wcel wa vz cv chil wcel vw cv chil wcel wa wa vx
      cv vy cv cva co vx cv vw cv cva co cmv co vy cv vw cv cmv co wceq vx vy
      vz vw vv cB cC cR cS 3oalem1.1 3oalem1.2 3oalem1.3 3oalem1.4 3oalem1 vx
      cv chil wcel vy cv chil wcel wa vw cv chil wcel vx cv vy cv cva co vx cv
      vw cv cva co cmv co vy cv vw cv cmv co wceq vv cv chil wcel vz cv chil
      wcel vx cv chil wcel vy cv chil wcel wa vw cv chil wcel wa vx cv vy cv
      cva co vx cv vw cv cva co cmv co vx cv vx cv cmv co vy cv vw cv cmv co
      cva co c0v vy cv vw cv cmv co cva co vy cv vw cv cmv co vx cv chil wcel
      vy cv chil wcel wa vw cv chil wcel vx cv chil wcel vw cv chil wcel wa vx
      cv vy cv cva co vx cv vw cv cva co cmv co vx cv vx cv cmv co vy cv vw cv
      cmv co cva co wceq vx cv chil wcel vy cv chil wcel wa vx cv chil wcel vw
      cv chil wcel vx cv chil wcel vy cv chil wcel pm3.26 anim1i vx cv vy cv vx
      cv vw cv hvsub4 syldan vx cv chil wcel vy cv chil wcel wa vw cv chil wcel
      wa vx cv vx cv cmv co c0v vy cv vw cv cmv co cva vx cv chil wcel vx cv vx
      cv cmv co c0v wceq vy cv chil wcel vw cv chil wcel vx cv hvsubid ad2antrr
      opreq1d vy cv chil wcel vw cv chil wcel c0v vy cv vw cv cmv co cva co vy
      cv vw cv cmv co wceq vx cv chil wcel vy cv chil wcel vw cv chil wcel wa
      vy cv vw cv cmv co chil wcel c0v vy cv vw cv cmv co cva co vy cv vw cv
      cmv co wceq vy cv vw cv hvsubcl vy cv vw cv cmv co hvaddid2 syl adantll
      3eqtrd ad2ant2rl syl vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva
      co wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq
      wa wa vx cv chil wcel vy cv chil wcel wa vv cv chil wcel wa vz cv chil
      wcel vw cv chil wcel wa wa vz cv vw cv cva co vx cv vw cv cva co cmv co
      vz cv vx cv cmv co wceq vx vy vz vw vv cB cC cR cS 3oalem1.1 3oalem1.2
      3oalem1.3 3oalem1.4 3oalem1 vx cv chil wcel vy cv chil wcel wa vz cv chil
      wcel vw cv chil wcel wa vz cv vw cv cva co vx cv vw cv cva co cmv co vz
      cv vx cv cmv co wceq vv cv chil wcel vx cv chil wcel vz cv chil wcel vw
      cv chil wcel wa vz cv vw cv cva co vx cv vw cv cva co cmv co vz cv vx cv
      cmv co wceq vy cv chil wcel vx cv chil wcel vz cv chil wcel vw cv chil
      wcel wa wa vz cv vw cv cva co vx cv vw cv cva co cmv co vz cv vx cv cmv
      co vw cv vw cv cmv co cva co vz cv vx cv cmv co c0v cva co vz cv vx cv
      cmv co vz cv chil wcel vw cv chil wcel wa vx cv chil wcel vw cv chil wcel
      wa vz cv vw cv cva co vx cv vw cv cva co cmv co vz cv vx cv cmv co vw cv
      vw cv cmv co cva co wceq vx cv chil wcel vz cv chil wcel vw cv chil wcel
      wa wa vz cv vw cv vx cv vw cv hvsub4 vx cv chil wcel vz cv chil wcel vw
      cv chil wcel wa pm3.27 vz cv chil wcel vw cv chil wcel wa vw cv chil wcel
      vx cv chil wcel vz cv chil wcel vw cv chil wcel pm3.27 anim2i sylanc vx
      cv chil wcel vz cv chil wcel vw cv chil wcel wa wa vw cv vw cv cmv co c0v
      vz cv vx cv cmv co cva vw cv chil wcel vw cv vw cv cmv co c0v wceq vx cv
      chil wcel vz cv chil wcel vw cv hvsubid ad2antll opreq2d vx cv chil wcel
      vz cv chil wcel vz cv vx cv cmv co c0v cva co vz cv vx cv cmv co wceq vw
      cv chil wcel vz cv chil wcel vx cv chil wcel vz cv vx cv cmv co c0v cva
      co vz cv vx cv cmv co wceq vz cv chil wcel vx cv chil wcel wa vz cv vx cv
      cmv co chil wcel vz cv vx cv cmv co c0v cva co vz cv vx cv cmv co wceq vz
      cv vx cv hvsubcl vz cv vx cv cmv co ax-hvaddid syl ancoms adantrr 3eqtrd
      adantlr adantlr syl 3eqtr3d vx cv cB wcel vz cv cC wcel vz cv vx cv cmv
      co cB cC cph co wcel vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva
      co wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq
      wa vz cv cC wcel vx cv cB wcel wa vz cv vx cv cmv co cC cB cph co wcel vx
      cv cB wcel vz cv cC wcel wa vz cv vx cv cmv co cB cC cph co wcel cC cB vz
      cv vx cv cC 3oalem1.2 chshii cB 3oalem1.1 chshii shsvsi vx cv cB wcel vz
      cv cC wcel ancom cB cC cph co cC cB cph co vz cv vx cv cmv co cB cC cB
      3oalem1.1 chshii cC 3oalem1.2 chshii shscomi eleq2i 3imtr4i vx cv cB wcel
      vy cv cR wcel vv cv vx cv vy cv cva co wceq simpll vz cv cC wcel vw cv cS
      wcel vv cv vz cv vw cv cva co wceq simpll syl2an eqeltrd vy cv cR wcel vw
      cv cS wcel vy cv vw cv cmv co cR cS cph co wcel vx cv cB wcel vy cv cR
      wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cS wcel wa
      vv cv vz cv vw cv cva co wceq wa cR cS vy cv vw cv cR 3oalem1.3 chshii cS
      3oalem1.4 chshii shsvsi vx cv cB wcel vy cv cR wcel vv cv vx cv vy cv cva
      co wceq simplr vz cv cC wcel vw cv cS wcel vv cv vz cv vw cv cva co wceq
      simplr syl2an jca vy cv vw cv cmv co cB cC cph co cR cS cph co elin
      sylibr sylanc eqeltrrd jca vy cv cR cS cB cC cph co cR cS cph co cin cph
      co elin sylibr sylanc vv cv vx cv vy cv cva co wceq vv cv cB cR cS cB cC
      cph co cR cS cph co cin cph co cin cph co wcel vx cv vy cv cva co cB cR
      cS cB cC cph co cR cS cph co cin cph co cin cph co wcel wb vx cv cB wcel
      vy cv cR wcel wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co
      wceq wa vv cv vx cv vy cv cva co cB cR cS cB cC cph co cR cS cph co cin
      cph co cin cph co eleq1 ad2antlr mpbird $.
      $( [19-Oct-1999] $)

    $( Lemma for 3OA (weak) orthoarguesian law. $)
    3oalem3 $p |- ( ( B +H R ) i^i ( C +H S ) ) C_
                   ( B +H ( R i^i ( S +H ( ( B +H C ) i^i ( R +H S ) ) ) ) ) $=
      vv cB cR cph co cC cS cph co cin cB cR cS cB cC cph co cR cS cph co cin
      cph co cin cph co vv cv cB cR cph co cC cS cph co cin wcel vx cv cB wcel
      vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel vw cv cS
      wcel wa vv cv vz cv vw cv cva co wceq wa wa vw wex vz wex vy wex vx wex
      vv cv cB cR cS cB cC cph co cR cS cph co cin cph co cin cph co wcel vv cv
      cB cR cph co wcel vv cv cC cS cph co wcel wa vx cv cB wcel vy cv cR wcel
      wa vv cv vx cv vy cv cva co wceq wa vy wex vx wex vz cv cC wcel vw cv cS
      wcel wa vv cv vz cv vw cv cva co wceq wa vw wex vz wex wa vv cv cB cR cph
      co cC cS cph co cin wcel vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv
      cva co wceq wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co
      wceq wa wa vw wex vz wex vy wex vx wex vv cv cB cR cph co wcel vx cv cB
      wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vy wex vx wex vv
      cv cC cS cph co wcel vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva
      co wceq wa vw wex vz wex vv cv cB cR cph co wcel vv cv vx cv vy cv cva co
      wceq vy cR wrex vx cB wrex vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy
      cv cva co wceq wa vy wex vx wex vx vy cB cR vv cv 3oalem1.1 3oalem1.3
      chseli vv cv vx cv vy cv cva co wceq vx vy cB cR r2ex bitri vv cv cC cS
      cph co wcel vv cv vz cv vw cv cva co wceq vw cS wrex vz cC wrex vz cv cC
      wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa vw wex vz wex vz
      vw cC cS vv cv 3oalem1.2 3oalem1.4 chseli vv cv vz cv vw cv cva co wceq
      vz vw cC cS r2ex bitri anbi12i vv cv cB cR cph co cC cS cph co elin vx cv
      cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa vz cv cC wcel
      vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa vx vy vz vw ee4anv
      3bitr4i vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq wa
      vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa vw wex
      vz wex vv cv cB cR cS cB cC cph co cR cS cph co cin cph co cin cph co
      wcel vx vy vx cv cB wcel vy cv cR wcel wa vv cv vx cv vy cv cva co wceq
      wa vz cv cC wcel vw cv cS wcel wa vv cv vz cv vw cv cva co wceq wa wa vv
      cv cB cR cS cB cC cph co cR cS cph co cin cph co cin cph co wcel vz vw vx
      vy vz vw vv cB cC cR cS 3oalem1.1 3oalem1.2 3oalem1.3 3oalem1.4 3oalem2
      19.23aivv 19.23aivv sylbi ssriv $.
      $( [19-Oct-1999] $)
  $}

  ${
    3oalem4.3 $e |- R = ( ( _|_ ` B ) i^i ( B vH A ) ) $.
    $( Lemma for 3OA (weak) orthoarguesian law. $)
    3oalem4 $p |- R C_ ( _|_ ` B ) $=
      cR cB cort cfv cB cA chj co cin cB cort cfv 3oalem4.3 cB cort cfv cB cA
      chj co inss1 eqsstri $.
      $( [19-Oct-1999] $)
  $}

  ${
    3oa.1 $e |- A e. CH $.
    3oa.2 $e |- B e. CH $.
    3oa.3 $e |- C e. CH $.
    3oa.4 $e |- R = ( ( _|_ ` B ) i^i ( B vH A ) ) $.
    3oa.5 $e |- S = ( ( _|_ ` C ) i^i ( C vH A ) ) $.
    $( Lemma for 3OA (weak) orthoarguesian law. $)
    3oalem5 $p |- ( ( B +H R ) i^i ( C +H S ) ) =
                  ( ( B vH R ) i^i ( C vH S ) ) $=
      cB cR cph co cB cR chj co cC cS cph co cC cS chj co cR cB cph co cR cB
      chj co cB cR cph co cB cR chj co cR cB cort cfv wss cR cB cph co cR cB
      chj co wceq cA cB cR 3oa.4 3oalem4 cR cB cR cB cort cfv cB cA chj co cin
      cch 3oa.4 cB cort cfv cB cA chj co cB 3oa.2 choccli cB cA 3oa.2 3oa.1
      chjcli chincli eqeltri 3oa.2 osumi ax-mp cB cR cB 3oa.2 chshii cR cR cB
      cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA chj co cB 3oa.2
      choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri chshii shscomi cB cR
      3oa.2 cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA chj co
      cB 3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri chjcomi 3eqtr4i
      cS cC cph co cS cC chj co cC cS cph co cC cS chj co cS cC cort cfv wss cS
      cC cph co cS cC chj co wceq cA cC cS 3oa.5 3oalem4 cS cC cS cC cort cfv
      cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co cC 3oa.3 choccli cC
      cA 3oa.3 3oa.1 chjcli chincli eqeltri 3oa.3 osumi ax-mp cC cS cC 3oa.3
      chshii cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj
      co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chshii
      shscomi cC cS 3oa.3 cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv
      cC cA chj co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri
      chjcomi 3eqtr4i ineq12i $.
      $( [19-Oct-1999] $)

    $( Lemma for 3OA (weak) orthoarguesian law. $)
    3oalem6 $p |- ( B +H ( R i^i ( S +H ( ( B +H C ) i^i ( R +H S ) ) ) ) ) C_
                  ( B vH ( R i^i ( S vH ( ( B vH C ) i^i ( R vH S ) ) ) ) ) $=
      cB cR cS cB cC cph co cR cS cph co cin cph co cin cph co cB cR cS cB cC
      cph co cR cS cph co cin cph co cin chj co cB cR cS cB cC chj co cR cS chj
      co cin chj co cin chj co cB cR cS cB cC cph co cR cS cph co cin cph co
      cin cB 3oa.2 chshii cR cS cB cC cph co cR cS cph co cin cph co cR cR cB
      cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA chj co cB 3oa.2
      choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri chshii cS cB cC cph co
      cR cS cph co cin cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv
      cC cA chj co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri
      chshii cB cC cph co cR cS cph co cB cC cB 3oa.2 chshii cC 3oa.3 chshii
      shscli cR cS cR cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB
      cA chj co cB 3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri
      chshii cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj
      co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chshii
      shscli shincli shscli shincli shsleji cR cS cB cC cph co cR cS cph co cin
      cph co cin cR cS cB cC chj co cR cS chj co cin chj co cin wss cB cR cS cB
      cC cph co cR cS cph co cin cph co cin chj co cB cR cS cB cC chj co cR cS
      chj co cin chj co cin chj co wss cS cB cC cph co cR cS cph co cin cph co
      cS cB cC chj co cR cS chj co cin chj co wss cR cS cB cC cph co cR cS cph
      co cin cph co cin cR cS cB cC chj co cR cS chj co cin chj co cin wss cS
      cB cC cph co cR cS cph co cin cph co cS cB cC cph co cR cS cph co cin chj
      co cS cB cC chj co cR cS chj co cin chj co cS cB cC cph co cR cS cph co
      cin cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co
      cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chshii cB cC
      cph co cR cS cph co cB cC cB 3oa.2 chshii cC 3oa.3 chshii shscli cR cS cR
      cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA chj co cB
      3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri chshii cS cS cC
      cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co cC 3oa.3
      choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chshii shscli shincli
      shsleji cB cC cph co cR cS cph co cin cB cC chj co cR cS chj co cin wss
      cS cB cC cph co cR cS cph co cin chj co cS cB cC chj co cR cS chj co cin
      chj co wss cB cC cph co cR cS cph co cin cB cC chj co cR cS cph co cin cB
      cC chj co cR cS chj co cin cB cC cph co cB cC chj co wss cB cC cph co cR
      cS cph co cin cB cC chj co cR cS cph co cin wss cB cC 3oa.2 3oa.3 chsleji
      cB cC cph co cB cC chj co cR cS cph co ssrin ax-mp cR cS cph co cR cS chj
      co wss cB cC chj co cR cS cph co cin cB cC chj co cR cS chj co cin wss cR
      cS cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA chj co cB
      3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri cS cC cort cfv cC
      cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co cC 3oa.3 choccli cC cA
      3oa.3 3oa.1 chjcli chincli eqeltri chsleji cR cS cph co cR cS chj co cB
      cC chj co sslin ax-mp sstri cB cC cph co cR cS cph co cin cB cC chj co cR
      cS chj co cin cS cB cC cph co cR cS cph co cB cC cB 3oa.2 chshii cC 3oa.3
      chshii shscli cR cS cR cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort
      cfv cB cA chj co cB 3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli
      eqeltri chshii cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv
      cC cA chj co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri
      chshii shscli shincli cB cC chj co cR cS chj co cin cB cC chj co cR cS
      chj co cB cC 3oa.2 3oa.3 chjcli cR cS cR cB cort cfv cB cA chj co cin cch
      3oa.4 cB cort cfv cB cA chj co cB 3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli
      chincli eqeltri cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC
      cA chj co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri
      chjcli chincli chshii cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC
      cort cfv cC cA chj co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli
      eqeltri chshii shlej2i ax-mp sstri cS cB cC cph co cR cS cph co cin cph
      co cS cB cC chj co cR cS chj co cin chj co cR sslin ax-mp cR cS cB cC cph
      co cR cS cph co cin cph co cin cR cS cB cC chj co cR cS chj co cin chj co
      cin cB cR cS cB cC cph co cR cS cph co cin cph co cR cR cB cort cfv cB cA
      chj co cin cch 3oa.4 cB cort cfv cB cA chj co cB 3oa.2 choccli cB cA
      3oa.2 3oa.1 chjcli chincli eqeltri chshii cS cB cC cph co cR cS cph co
      cin cS cS cC cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co
      cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chshii cB cC
      cph co cR cS cph co cB cC cB 3oa.2 chshii cC 3oa.3 chshii shscli cR cS cR
      cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA chj co cB
      3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri chshii cS cS cC
      cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co cC 3oa.3
      choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chshii shscli shincli
      shscli shincli cR cS cB cC chj co cR cS chj co cin chj co cin cR cS cB cC
      chj co cR cS chj co cin chj co cR cB cort cfv cB cA chj co cin cch 3oa.4
      cB cort cfv cB cA chj co cB 3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli
      chincli eqeltri cS cB cC chj co cR cS chj co cin cS cC cort cfv cC cA chj
      co cin cch 3oa.5 cC cort cfv cC cA chj co cC 3oa.3 choccli cC cA 3oa.3
      3oa.1 chjcli chincli eqeltri cB cC chj co cR cS chj co cB cC 3oa.2 3oa.3
      chjcli cR cS cR cB cort cfv cB cA chj co cin cch 3oa.4 cB cort cfv cB cA
      chj co cB 3oa.2 choccli cB cA 3oa.2 3oa.1 chjcli chincli eqeltri cS cC
      cort cfv cC cA chj co cin cch 3oa.5 cC cort cfv cC cA chj co cC 3oa.3
      choccli cC cA 3oa.3 3oa.1 chjcli chincli eqeltri chjcli chincli chjcli
      chincli chshii cB 3oa.2 chshii shlej2i ax-mp sstri $.
      $( [19-Oct-1999] $)

    $( 3OA (weak) orthoarguesian law.  Equation IV of [GodowskiGreechie]
       p. 249. $)
    3oai $p |- ( ( B vH R ) i^i ( C vH S ) ) C_
                  ( B vH ( R i^i ( S vH ( ( B vH C ) i^i ( R vH S ) ) ) ) ) $=
      cB cR chj co cC cS chj co cin cB cR cph co cC cS cph co cin cB cR cS cB
      cC chj co cR cS chj co cin chj co cin chj co cA cB cC cR cS 3oa.1 3oa.2
      3oa.3 3oa.4 3oa.5 3oalem5 cB cR cph co cC cS cph co cin cB cR cS cB cC
      cph co cR cS cph co cin cph co cin cph co cB cR cS cB cC chj co cR cS chj
      co cin chj co cin chj co cB cC cR cS 3oa.2 3oa.3 cR cB cort cfv cB cA chj
      co cin cch 3oa.4 cB cort cfv cB cA chj co cB 3oa.2 choccli cB cA 3oa.2
      3oa.1 chjcli chincli eqeltri cS cC cort cfv cC cA chj co cin cch 3oa.5 cC
      cort cfv cC cA chj co cC 3oa.3 choccli cC cA 3oa.3 3oa.1 chjcli chincli
      eqeltri 3oalem3 cA cB cC cR cS 3oa.1 3oa.2 3oa.3 3oa.4 3oa.5 3oalem6
      sstri eqsstr3i $.
      $( [19-Oct-1999] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    pjorth.1 $e |- A e. ~H $.
    pjorth.2 $e |- B e. ~H $.
    $( Projection components on orthocomplemented subspaces are orthogonal. $)
    pjorthi $p |- ( H e. CH ->
          ( ( ( proj ` H ) ` A ) .ih ( ( proj ` ( _|_ ` H ) ) ` B ) ) = 0 ) $=
      cH csh wcel cA cH cpj cfv cfv cH wcel cB cH cort cfv cpj cfv cfv cH cort
      cfv wcel wa cA cH cpj cfv cfv cB cH cort cfv cpj cfv cfv csp co cc0 wceq
      cH cch wcel cA cH cpj cfv cfv cB cH cort cfv cpj cfv cfv cH shocorth cH
      chsh cH cch wcel cA cH cpj cfv cfv cH wcel cB cH cort cfv cpj cfv cfv cH
      cort cfv wcel cH cch wcel cA chil wcel cA cH cpj cfv cfv cH wcel pjorth.1
      cA cH axpjcl mpan2 cH cch wcel cH cort cfv cch wcel cB cH cort cfv cpj
      cfv cfv cH cort cfv wcel cH choccl cH cort cfv cch wcel cB chil wcel cB
      cH cort cfv cpj cfv cfv cH cort cfv wcel pjorth.2 cB cH cort cfv axpjcl
      mpan2 syl jca sylc $.
      $( [26-Oct-1999] $)
  $}

  $( Property of identity projection.  Remark in [Beran] p. 111. $)
  pjch1 $p |- ( A e. ~H -> ( ( proj ` ~H ) ` A ) = A ) $=
    cA chil wcel cA chil cpj cfv cfv cA wceq cA chil wcel cA chil wcel cA chil
    cpj cfv cfv cA wceq wb cA chil wcel cA c0v cif chil wcel cA chil wcel cA
    c0v cif chil cpj cfv cfv cA chil wcel cA c0v cif wceq wb cA c0v cA cA chil
    wcel cA c0v cif wceq cA chil wcel cA chil wcel cA c0v cif chil wcel cA chil
    cpj cfv cfv cA wceq cA chil wcel cA c0v cif chil cpj cfv cfv cA chil wcel
    cA c0v cif wceq cA cA chil wcel cA c0v cif chil eleq1 cA cA chil wcel cA
    c0v cif wceq cA chil cpj cfv cfv cA chil wcel cA c0v cif chil cpj cfv cfv
    cA cA chil wcel cA c0v cif cA cA chil wcel cA c0v cif chil cpj cfv fveq2 cA
    cA chil wcel cA c0v cif wceq id eqeq12d bibi12d cA chil wcel cA c0v cif
    chil helch cA c0v chil ax-hv0cl elimel pjchi dedth ibi $.
    $( [28-Oct-1999] $)

  $( The orthogonal projection.  Lemma 4.4(i) of [Beran] p. 111. $)
  pjo $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( proj ` ( _|_ ` H ) ) ` A ) =
             ( ( ( proj ` ~H ) ` A ) -h ( ( proj ` H ) ` A ) ) ) $=
    cH cch wcel cA chil wcel wa cA chil cpj cfv cfv cA cH cpj cfv cfv cmv co cA
    cH cort cfv cpj cfv cfv cH cch wcel cA chil wcel wa cA chil cpj cfv cfv cA
    cH cpj cfv cfv cmv co cA cH cort cfv cpj cfv cfv wceq cA cH cpj cfv cfv cA
    cH cort cfv cpj cfv cfv cva co cA chil cpj cfv cfv wceq cH cch wcel cA chil
    wcel wa cA chil cpj cfv cfv cA cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv
    cva co cA chil wcel cA chil cpj cfv cfv cA wceq cH cch wcel cA pjch1 adantl
    cA cH axpjpj eqtr2d cA chil cpj cfv cfv chil wcel cA cH cpj cfv cfv chil
    wcel cA cH cort cfv cpj cfv cfv chil wcel cA chil cpj cfv cfv cA cH cpj cfv
    cfv cmv co cA cH cort cfv cpj cfv cfv wceq cA cH cpj cfv cfv cA cH cort cfv
    cpj cfv cfv cva co cA chil cpj cfv cfv wceq wb cH cch wcel cA chil wcel wa
    cA chil cpj cfv cfv cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv hvsubadd
    cA chil wcel cA chil cpj cfv cfv chil wcel cH cch wcel cA chil helch pjcli
    adantl cA cH pjhcl cH cort cfv cch wcel cA chil wcel cA cH cort cfv cpj cfv
    cfv chil wcel cH cch wcel cA cH cort cfv pjhcl cH choccl sylan syl3anc
    mpbird eqcomd $.
    $( [30-Oct-1999] $)

  ${
    pjidm.1 $e |- H e. CH $.
    pjidm.2 $e |- A e. ~H $.
    $( A projection is idempotent.  Property (ii) of [Beran] p. 109. $)
    pjidmi $p |- ( ( proj ` H ) ` ( ( proj ` H ) ` A ) ) =
               ( ( proj ` H ) ` A ) $=
      cA cH cpj cfv cfv cH wcel cA cH cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv
      cfv wceq cA cH pjidm.1 pjidm.2 pjclii cA cH cpj cfv cfv cH pjidm.1 cA cH
      pjidm.1 pjidm.2 pjhclii pjchi mpbi $.
      $( [28-Oct-1999] $)

    ${
      pjadj.3 $e |- B e. ~H $.
      $( A projection is self-adjoint.  Property (i) of [Beran] p. 109. $)
      pjadjii $p |- ( ( ( proj ` H ) ` A ) .ih B ) =
                  ( A .ih ( ( proj ` H ) ` B ) ) $=
        cA cH cpj cfv cfv cB cH cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co
        csp co cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cB cH cpj
        cfv cfv csp co cA cH cpj cfv cfv cB csp co cA cB cH cpj cfv cfv csp co
        cA cH cpj cfv cfv cB cH cpj cfv cfv csp co cA cH cpj cfv cfv cB cH cort
        cfv cpj cfv cfv csp co caddc co cA cH cpj cfv cfv cB cH cpj cfv cfv csp
        co cA cH cort cfv cpj cfv cfv cB cH cpj cfv cfv csp co caddc co cA cH
        cpj cfv cfv cB cH cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co csp co
        cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cB cH cpj cfv cfv
        csp co cA cH cpj cfv cfv cB cH cort cfv cpj cfv cfv csp co cA cH cort
        cfv cpj cfv cfv cB cH cpj cfv cfv csp co cA cH cpj cfv cfv cB cH cpj
        cfv cfv csp co caddc cB cH cpj cfv cfv cA cH cort cfv cpj cfv cfv csp
        co ccj cfv cc0 cA cH cort cfv cpj cfv cfv cB cH cpj cfv cfv csp co cA
        cH cpj cfv cfv cB cH cort cfv cpj cfv cfv csp co cB cH cpj cfv cfv cA
        cH cort cfv cpj cfv cfv csp co ccj cfv cc0 ccj cfv cc0 cB cH cpj cfv
        cfv cA cH cort cfv cpj cfv cfv csp co cc0 ccj cH cch wcel cB cH cpj cfv
        cfv cA cH cort cfv cpj cfv cfv csp co cc0 wceq pjidm.1 cB cA cH pjadj.3
        pjidm.2 pjorthi ax-mp fveq2i cj0 eqtri cA cH cort cfv cpj cfv cfv cB cH
        cpj cfv cfv cA cH cort cfv cH pjidm.1 choccli pjidm.2 pjhclii cB cH
        pjidm.1 pjadj.3 pjhclii his1i cH cch wcel cA cH cpj cfv cfv cB cH cort
        cfv cpj cfv cfv csp co cc0 wceq pjidm.1 cA cB cH pjidm.2 pjadj.3
        pjorthi ax-mp 3eqtr4ri opreq2i cA cH cpj cfv cfv chil wcel cB cH cpj
        cfv cfv chil wcel cB cH cort cfv cpj cfv cfv chil wcel cA cH cpj cfv
        cfv cB cH cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co csp co cA cH
        cpj cfv cfv cB cH cpj cfv cfv csp co cA cH cpj cfv cfv cB cH cort cfv
        cpj cfv cfv csp co caddc co wceq cA cH pjidm.1 pjidm.2 pjhclii cB cH
        pjidm.1 pjadj.3 pjhclii cB cH cort cfv cH pjidm.1 choccli pjadj.3
        pjhclii cA cH cpj cfv cfv cB cH cpj cfv cfv cB cH cort cfv cpj cfv cfv
        his7 mp3an cA cH cpj cfv cfv chil wcel cA cH cort cfv cpj cfv cfv chil
        wcel cB cH cpj cfv cfv chil wcel cA cH cpj cfv cfv cA cH cort cfv cpj
        cfv cfv cva co cB cH cpj cfv cfv csp co cA cH cpj cfv cfv cB cH cpj cfv
        cfv csp co cA cH cort cfv cpj cfv cfv cB cH cpj cfv cfv csp co caddc co
        wceq cA cH pjidm.1 pjidm.2 pjhclii cA cH cort cfv cH pjidm.1 choccli
        pjidm.2 pjhclii cB cH pjidm.1 pjadj.3 pjhclii cA cH cpj cfv cfv cA cH
        cort cfv cpj cfv cfv cB cH cpj cfv cfv ax-his2 mp3an 3eqtr4i cB cB cH
        cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cA cH cpj cfv cfv csp cB
        cH pjidm.1 pjadj.3 pjpji opreq2i cA cA cH cpj cfv cfv cA cH cort cfv
        cpj cfv cfv cva co cB cH cpj cfv cfv csp cA cH pjidm.1 pjidm.2 pjpji
        opreq1i 3eqtr4i $.
        $( [30-Oct-1999] $)

      $( Component of a projection. $)
      pjcompi $p |- ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
                   ( ( proj ` H ) ` ( A +h B ) ) = A ) $=
        cA cH wcel cB cH cort cfv wcel wa cA cB cva co cH cpj cfv cfv cA wceq
        cA cB cva co cH cort cfv cpj cfv cfv cB wceq cA cB cva co cH cpj cfv
        cfv cH wcel cA cB cva co cH cort cfv cpj cfv cfv cH cort cfv wcel cA cH
        wcel cB cH cort cfv wcel wa cA cB cva co cH cpj cfv cfv cA wceq cA cB
        cva co cH cort cfv cpj cfv cfv cB wceq wa cA cB cva co cH pjidm.1 cA cB
        pjidm.2 pjadj.3 hvaddcli pjclii cA cB cva co cH cort cfv cH pjidm.1
        choccli cA cB pjidm.2 pjadj.3 hvaddcli pjclii cA cB cva co cH cpj cfv
        cfv cH wcel cA cB cva co cH cort cfv cpj cfv cfv cH cort cfv wcel wa cA
        cH wcel cB cH cort cfv wcel wa wa cA cB cva co cA cB cva co cH cpj cfv
        cfv cA cB cva co cH cort cfv cpj cfv cfv cva co wceq cA cB cva co cA cB
        cva co wceq cA cB cva co cH cpj cfv cfv cA wceq cA cB cva co cH cort
        cfv cpj cfv cfv cB wceq wa cA cB cva co cH pjidm.1 cA cB pjidm.2
        pjadj.3 hvaddcli pjpji cA cB cva co eqid cA cB cva co cH cpj cfv cfv cA
        cB cva co cH cort cfv cpj cfv cfv cA cB cA cB cva co cH pjidm.1
        chocunii mp2ani mpanl12 pm3.26d $.
        $( [31-Oct-1999] $)

      $( Projection of vector sum is sum of projections. $)
      pjaddii $p |- ( ( proj ` H ) ` ( A +h B ) ) =
                  ( ( ( proj ` H ) ` A ) +h ( ( proj ` H ) ` B ) ) $=
        cA cB cva co cH cpj cfv cfv cA cH cpj cfv cfv cB cH cpj cfv cfv cva co
        cA cH cort cfv cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cva co cH
        cpj cfv cfv cA cH cpj cfv cfv cB cH cpj cfv cfv cva co cA cB cva co cA
        cH cpj cfv cfv cB cH cpj cfv cfv cva co cA cH cort cfv cpj cfv cfv cB
        cH cort cfv cpj cfv cfv cva co cva co cH cpj cfv cA cB cva co cA cH cpj
        cfv cfv cA cH cort cfv cpj cfv cfv cva co cB cH cpj cfv cfv cB cH cort
        cfv cpj cfv cfv cva co cva co cA cH cpj cfv cfv cB cH cpj cfv cfv cva
        co cA cH cort cfv cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cva co
        cA cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cB cB cH cpj cfv
        cfv cB cH cort cfv cpj cfv cfv cva co cva cA cH pjidm.1 pjidm.2 pjpji
        cB cH pjidm.1 pjadj.3 pjpji opreq12i cA cH cpj cfv cfv cA cH cort cfv
        cpj cfv cfv cB cH cpj cfv cfv cB cH cort cfv cpj cfv cfv cA cH pjidm.1
        pjidm.2 pjhclii cA cH cort cfv cH pjidm.1 choccli pjidm.2 pjhclii cB cH
        pjidm.1 pjadj.3 pjhclii cB cH cort cfv cH pjidm.1 choccli pjadj.3
        pjhclii hvadd4i eqtri fveq2i cA cH cpj cfv cfv cB cH cpj cfv cfv cva co
        cH wcel cA cH cort cfv cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cH
        cort cfv wcel cA cH cpj cfv cfv cB cH cpj cfv cfv cva co cA cH cort cfv
        cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cva co cH cpj cfv cfv cA
        cH cpj cfv cfv cB cH cpj cfv cfv cva co wceq cA cH cpj cfv cfv cH wcel
        cB cH cpj cfv cfv cH wcel cA cH cpj cfv cfv cB cH cpj cfv cfv cva co cH
        wcel cA cH pjidm.1 pjidm.2 pjclii cB cH pjidm.1 pjadj.3 pjclii cH csh
        wcel cA cH cpj cfv cfv cH wcel cB cH cpj cfv cfv cH wcel wa cA cH cpj
        cfv cfv cB cH cpj cfv cfv cva co cH wcel wi cH pjidm.1 chshii cA cH cpj
        cfv cfv cB cH cpj cfv cfv cH shaddclOLD ax-mp mp2an cA cH cort cfv cpj
        cfv cfv cH cort cfv wcel cB cH cort cfv cpj cfv cfv cH cort cfv wcel cA
        cH cort cfv cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cH cort cfv
        wcel cA cH cort cfv cH pjidm.1 choccli pjidm.2 pjclii cB cH cort cfv cH
        pjidm.1 choccli pjadj.3 pjclii cH cort cfv csh wcel cA cH cort cfv cpj
        cfv cfv cH cort cfv wcel cB cH cort cfv cpj cfv cfv cH cort cfv wcel wa
        cA cH cort cfv cpj cfv cfv cB cH cort cfv cpj cfv cfv cva co cH cort
        cfv wcel wi cH cort cfv cH pjidm.1 choccli chshii cA cH cort cfv cpj
        cfv cfv cB cH cort cfv cpj cfv cfv cH cort cfv shaddclOLD ax-mp mp2an
        cA cH cpj cfv cfv cB cH cpj cfv cfv cva co cA cH cort cfv cpj cfv cfv
        cB cH cort cfv cpj cfv cfv cva co cH pjidm.1 cA cH cpj cfv cfv cB cH
        cpj cfv cfv cA cH pjidm.1 pjidm.2 pjhclii cB cH pjidm.1 pjadj.3 pjhclii
        hvaddcli cA cH cort cfv cpj cfv cfv cB cH cort cfv cpj cfv cfv cA cH
        cort cfv cH pjidm.1 choccli pjidm.2 pjhclii cB cH cort cfv cH pjidm.1
        choccli pjadj.3 pjhclii hvaddcli pjcompi mp2an eqtri $.
        $( [31-Oct-1999] $)
    $}

    $( The inner product of a projection and its argument is the square of the
       norm of the projection.  Remark in [Halmos] p. 44. $)
    pjinormii $p |- ( ( ( proj ` H ) ` A ) .ih A ) =
                 ( ( normh ` ( ( proj ` H ) ` A ) ) ^ 2 ) $=
      cA cH cpj cfv cfv cno cfv c2 cexp co cA cH cpj cfv cfv cA cH cpj cfv cfv
      csp co cA cH cpj cfv cfv cH cpj cfv cfv cA csp co cA cH cpj cfv cfv cA
      csp co cA cH cpj cfv cfv cA cH pjidm.1 pjidm.2 pjhclii normsqi cA cH cpj
      cfv cfv cA cH pjidm.1 cA cH pjidm.1 pjidm.2 pjhclii pjidm.2 pjadjii cA cH
      cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv cfv cA csp cA cH pjidm.1 pjidm.2
      pjidmi opreq1i 3eqtr2ri $.
      $( [13-Aug-2000] $)

    ${
      pjmul.3 $e |- C e. CC $.
      $( Projection of (scalar) product is product of projection. $)
      pjmulii $p |- ( ( proj ` H ) ` ( C .h A ) ) =
                  ( C .h ( ( proj ` H ) ` A ) ) $=
        cC cA csm co cH cpj cfv cfv cC cA cH cpj cfv cfv csm co cC cA cH cort
        cfv cpj cfv cfv csm co cva co cH cpj cfv cfv cC cA cH cpj cfv cfv csm
        co cC cA csm co cC cA cH cpj cfv cfv csm co cC cA cH cort cfv cpj cfv
        cfv csm co cva co cH cpj cfv cC cA csm co cC cA cH cpj cfv cfv cA cH
        cort cfv cpj cfv cfv cva co csm co cC cA cH cpj cfv cfv csm co cC cA cH
        cort cfv cpj cfv cfv csm co cva co cA cA cH cpj cfv cfv cA cH cort cfv
        cpj cfv cfv cva co cC csm cA cH pjidm.1 pjidm.2 pjpji opreq2i cC cA cH
        cpj cfv cfv cA cH cort cfv cpj cfv cfv pjmul.3 cA cH pjidm.1 pjidm.2
        pjhclii cA cH cort cfv cH pjidm.1 choccli pjidm.2 pjhclii hvdistr1i
        eqtri fveq2i cC cA cH cpj cfv cfv csm co cH wcel cC cA cH cort cfv cpj
        cfv cfv csm co cH cort cfv wcel cC cA cH cpj cfv cfv csm co cC cA cH
        cort cfv cpj cfv cfv csm co cva co cH cpj cfv cfv cC cA cH cpj cfv cfv
        csm co wceq cC cc wcel cA cH cpj cfv cfv cH wcel cC cA cH cpj cfv cfv
        csm co cH wcel pjmul.3 cA cH pjidm.1 pjidm.2 pjclii cH csh wcel cC cc
        wcel cA cH cpj cfv cfv cH wcel wa cC cA cH cpj cfv cfv csm co cH wcel
        wi cH pjidm.1 chshii cC cA cH cpj cfv cfv cH shmulclOLD ax-mp mp2an cC
        cc wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel cC cA cH cort cfv
        cpj cfv cfv csm co cH cort cfv wcel pjmul.3 cA cH cort cfv cH pjidm.1
        choccli pjidm.2 pjclii cH cort cfv csh wcel cC cc wcel cA cH cort cfv
        cpj cfv cfv cH cort cfv wcel wa cC cA cH cort cfv cpj cfv cfv csm co cH
        cort cfv wcel wi cH cort cfv cH pjidm.1 choccli chshii cC cA cH cort
        cfv cpj cfv cfv cH cort cfv shmulclOLD ax-mp mp2an cC cA cH cpj cfv cfv
        csm co cC cA cH cort cfv cpj cfv cfv csm co cH pjidm.1 cC cA cH cpj cfv
        cfv pjmul.3 cA cH pjidm.1 pjidm.2 pjhclii hvmulcli cC cA cH cort cfv
        cpj cfv cfv pjmul.3 cA cH cort cfv cH pjidm.1 choccli pjidm.2 pjhclii
        hvmulcli pjcompi mp2an eqtri $.
        $( [31-Oct-1999] $)
    $}

    ${
      pjsub.3 $e |- B e. ~H $.
      $( Projection of vector difference is difference of projections. $)
      pjsubii $p |- ( ( proj ` H ) ` ( A -h B ) ) =
                  ( ( ( proj ` H ) ` A ) -h ( ( proj ` H ) ` B ) ) $=
        cA c1 cneg cB csm co cva co cH cpj cfv cfv cA cH cpj cfv cfv c1 cneg cB
        cH cpj cfv cfv csm co cva co cA cB cmv co cH cpj cfv cfv cA cH cpj cfv
        cfv cB cH cpj cfv cfv cmv co cA c1 cneg cB csm co cva co cH cpj cfv cfv
        cA cH cpj cfv cfv c1 cneg cB csm co cH cpj cfv cfv cva co cA cH cpj cfv
        cfv c1 cneg cB cH cpj cfv cfv csm co cva co cA c1 cneg cB csm co cH
        pjidm.1 pjidm.2 c1 cneg cB c1 ax1cn negcli pjsub.3 hvmulcli pjaddii c1
        cneg cB csm co cH cpj cfv cfv c1 cneg cB cH cpj cfv cfv csm co cA cH
        cpj cfv cfv cva cB c1 cneg cH pjidm.1 pjsub.3 c1 ax1cn negcli pjmulii
        opreq2i eqtri cA cB cmv co cA c1 cneg cB csm co cva co cH cpj cfv cA cB
        pjidm.2 pjsub.3 hvsubvali fveq2i cA cH cpj cfv cfv cB cH cpj cfv cfv cA
        cH pjidm.1 pjidm.2 pjhclii cB cH pjidm.1 pjsub.3 pjhclii hvsubvali
        3eqtr4i $.
        $( [31-Oct-1999] $)
    $}

    ${
      pjsslem.1 $e |- G e. CH $.
      $( Lemma for subset relationships of projections. $)
      pjsslem $p |- ( ( ( proj ` ( _|_ ` H ) ) ` A ) -h
                      ( ( proj ` ( _|_ ` G ) ) ` A ) ) =
                    ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) ) $=
        cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv cfv cmv co c0v cA cH
        cpj cfv cfv cA cG cpj cfv cfv cmv co cmv co c1 cneg cA cH cpj cfv cfv
        cA cG cpj cfv cfv cmv co csm co cA cG cpj cfv cfv cA cH cpj cfv cfv cmv
        co cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv cfv cmv co cA chil
        cpj cfv cfv cA cH cpj cfv cfv cmv co cA chil cpj cfv cfv cA cG cpj cfv
        cfv cmv co cmv co cA chil cpj cfv cfv cA chil cpj cfv cfv cmv co cA cH
        cpj cfv cfv cA cG cpj cfv cfv cmv co cmv co c0v cA cH cpj cfv cfv cA cG
        cpj cfv cfv cmv co cmv co cA cH cort cfv cpj cfv cfv cA chil cpj cfv
        cfv cA cH cpj cfv cfv cmv co cA cG cort cfv cpj cfv cfv cA chil cpj cfv
        cfv cA cG cpj cfv cfv cmv co cmv cH cch wcel cA chil wcel cA cH cort
        cfv cpj cfv cfv cA chil cpj cfv cfv cA cH cpj cfv cfv cmv co wceq
        pjidm.1 pjidm.2 cA cH pjo mp2an cG cch wcel cA chil wcel cA cG cort cfv
        cpj cfv cfv cA chil cpj cfv cfv cA cG cpj cfv cfv cmv co wceq pjsslem.1
        pjidm.2 cA cG pjo mp2an opreq12i cA chil cpj cfv cfv cA cH cpj cfv cfv
        cA chil cpj cfv cfv cA cG cpj cfv cfv cA chil helch pjidm.2 pjclii cA
        cH pjidm.1 pjidm.2 pjhclii cA chil helch pjidm.2 pjclii cA cG pjsslem.1
        pjidm.2 pjhclii hvsubsub4i cA chil cpj cfv cfv cA chil cpj cfv cfv cmv
        co c0v cA cH cpj cfv cfv cA cG cpj cfv cfv cmv co cmv cA chil cpj cfv
        cfv chil wcel cA chil cpj cfv cfv cA chil cpj cfv cfv cmv co c0v wceq
        cA chil helch pjidm.2 pjclii cA chil cpj cfv cfv hvsubid ax-mp opreq1i
        3eqtri cA cH cpj cfv cfv cA cG cpj cfv cfv cmv co cA cH cpj cfv cfv cA
        cG cpj cfv cfv cA cH pjidm.1 pjidm.2 pjhclii cA cG pjsslem.1 pjidm.2
        pjhclii hvsubcli hv2negi cA cH cpj cfv cfv cA cG cpj cfv cfv cA cH
        pjidm.1 pjidm.2 pjhclii cA cG pjsslem.1 pjidm.2 pjhclii hvnegdii 3eqtri
        $.
        $( [31-Oct-1999] $)

      $( Subset relationship for projections.  Theorem 4.5(i)->(ii) of [Beran]
         p. 112. $)
      pjss2i $p |- ( H C_ G -> ( ( proj ` H ) ` ( ( proj ` G ) ` A ) ) =
                 ( ( proj ` H ) ` A ) ) $=
        cH cG wss cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv cfv cmv co
        cH cort cfv wcel cA cG cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv cfv
        wceq cH cG wss cA cH cort cfv cpj cfv cfv cH cort cfv wcel cA cG cort
        cfv cpj cfv cfv cH cort cfv wcel wa cA cH cort cfv cpj cfv cfv cA cG
        cort cfv cpj cfv cfv cmv co cH cort cfv wcel cH cG wss cA cG cort cfv
        cpj cfv cfv cH cort cfv wcel cA cH cort cfv cpj cfv cfv cH cort cfv
        wcel cH cG wss cG cort cfv cH cort cfv wss cA cG cort cfv cpj cfv cfv
        cH cort cfv wcel cH cG pjidm.1 pjsslem.1 chsscon3i cG cort cfv cH cort
        cfv wss cA cG cort cfv cpj cfv cfv cG cort cfv wcel cA cG cort cfv cpj
        cfv cfv cH cort cfv wcel cA cG cort cfv cG pjsslem.1 choccli pjidm.2
        pjclii cG cort cfv cH cort cfv cA cG cort cfv cpj cfv cfv ssel mpi
        sylbi cA cH cort cfv cH pjidm.1 choccli pjidm.2 pjclii jctil cH cort
        cfv csh wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel cA cG cort cfv
        cpj cfv cfv cH cort cfv wcel wa cA cH cort cfv cpj cfv cfv cA cG cort
        cfv cpj cfv cfv cmv co cH cort cfv wcel wi cH cort cfv cH pjidm.1
        choccli chshii cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv cfv cH
        cort cfv shsubclOLD ax-mp syl cA cH cort cfv cpj cfv cfv cA cG cort cfv
        cpj cfv cfv cmv co cH cort cfv wcel cA cG cpj cfv cfv cH cpj cfv cfv cA
        cH cpj cfv cfv cH cpj cfv cfv wceq cA cG cpj cfv cfv cH cpj cfv cfv cA
        cH cpj cfv cfv wceq cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv
        cfv cmv co cH cort cfv wcel cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co
        cH cpj cfv cfv c0v wceq cA cG cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv
        cfv cH cpj cfv cfv cmv co c0v wceq cA cG cpj cfv cfv cH cpj cfv cfv cA
        cH cpj cfv cfv cH cpj cfv cfv wceq cA cH cort cfv cpj cfv cfv cA cG
        cort cfv cpj cfv cfv cmv co cH cort cfv wcel cA cG cpj cfv cfv cA cH
        cpj cfv cfv cmv co cH cort cfv wcel cA cG cpj cfv cfv cA cH cpj cfv cfv
        cmv co cH cpj cfv cfv c0v wceq cA cH cort cfv cpj cfv cfv cA cG cort
        cfv cpj cfv cfv cmv co cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cH
        cort cfv cA cG cH pjidm.1 pjidm.2 pjsslem.1 pjsslem eleq1i cA cG cpj
        cfv cfv cA cH cpj cfv cfv cmv co cH pjidm.1 cA cG cpj cfv cfv cA cH cpj
        cfv cfv cA cG pjsslem.1 pjidm.2 pjhclii cA cH pjidm.1 pjidm.2 pjhclii
        hvsubcli pjoc2i bitri cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cH cpj
        cfv cfv cA cG cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv cfv cH cpj cfv
        cfv cmv co c0v cA cG cpj cfv cfv cA cH cpj cfv cfv cH pjidm.1 cA cG
        pjsslem.1 pjidm.2 pjhclii cA cH pjidm.1 pjidm.2 pjhclii pjsubii eqeq1i
        cA cG cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv cfv cH cpj cfv cfv cA cG
        cpj cfv cfv cH pjidm.1 cA cG pjsslem.1 pjidm.2 pjhclii pjhclii cA cH
        cpj cfv cfv cH pjidm.1 cA cH pjidm.1 pjidm.2 pjhclii pjhclii hvsubeq0i
        3bitri cA cH cpj cfv cfv cH cpj cfv cfv cA cH cpj cfv cfv cA cG cpj cfv
        cfv cH cpj cfv cfv cA cH pjidm.1 pjidm.2 pjidmi eqeq2i bitr2i sylibr $.
        $( [31-Oct-1999] $)

      $( Projection meet property.  Remark in [Kalmbach] p. 66.  Also Theorem
         4.5(i)->(iv) of [Beran] p. 112. $)
      pjssmii $p |- ( H C_ G -> ( ( ( proj ` G ) ` A )
      -h ( ( proj ` H ) ` A ) ) = ( ( proj ` ( G i^i ( _|_ ` H ) ) ) ` A ) ) $=
        cH cG wss cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cG cH cort cfv cin
        cpj cfv cfv cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA cG cH cort
        cfv cin cpj cfv cfv cH cG wss cA cG cpj cfv cfv cA cH cpj cfv cfv cmv
        co cG wcel cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cH cort cfv wcel
        wa cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cG cH cort cfv cin cpj
        cfv cfv cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co wceq cH cG wss cA cG
        cpj cfv cfv cA cH cpj cfv cfv cmv co cG wcel cA cG cpj cfv cfv cA cH
        cpj cfv cfv cmv co cH cort cfv wcel cH cG wss cA cG cpj cfv cfv cG wcel
        cA cH cpj cfv cfv cG wcel wa cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co
        cG wcel cH cG wss cA cH cpj cfv cfv cG wcel cA cG cpj cfv cfv cG wcel
        cH cG wss cA cH cpj cfv cfv cH wcel cA cH cpj cfv cfv cG wcel cA cH
        pjidm.1 pjidm.2 pjclii cH cG cA cH cpj cfv cfv ssel mpi cA cG pjsslem.1
        pjidm.2 pjclii jctil cG csh wcel cA cG cpj cfv cfv cG wcel cA cH cpj
        cfv cfv cG wcel wa cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cG wcel
        wi cG pjsslem.1 chshii cA cG cpj cfv cfv cA cH cpj cfv cfv cG
        shsubclOLD ax-mp syl cH cG wss cA cH cort cfv cpj cfv cfv cA cG cort
        cfv cpj cfv cfv cmv co cH cort cfv cA cG cpj cfv cfv cA cH cpj cfv cfv
        cmv co cH cG wss cG cort cfv cH cort cfv wss cA cH cort cfv cpj cfv cfv
        cA cG cort cfv cpj cfv cfv cmv co cH cort cfv wcel cH cG pjidm.1
        pjsslem.1 chsscon3i cG cort cfv cH cort cfv wss cA cH cort cfv cpj cfv
        cfv cH cort cfv wcel cA cG cort cfv cpj cfv cfv cH cort cfv wcel wa cA
        cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv cfv cmv co cH cort cfv
        wcel cG cort cfv cH cort cfv wss cA cG cort cfv cpj cfv cfv cH cort cfv
        wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel cG cort cfv cH cort
        cfv wss cA cG cort cfv cpj cfv cfv cG cort cfv wcel cA cG cort cfv cpj
        cfv cfv cH cort cfv wcel cA cG cort cfv cG pjsslem.1 choccli pjidm.2
        pjclii cG cort cfv cH cort cfv cA cG cort cfv cpj cfv cfv ssel mpi cA
        cH cort cfv cH pjidm.1 choccli pjidm.2 pjclii jctil cH cort cfv csh
        wcel cA cH cort cfv cpj cfv cfv cH cort cfv wcel cA cG cort cfv cpj cfv
        cfv cH cort cfv wcel wa cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj
        cfv cfv cmv co cH cort cfv wcel wi cH cort cfv cH pjidm.1 choccli
        chshii cA cH cort cfv cpj cfv cfv cA cG cort cfv cpj cfv cfv cH cort
        cfv shsubclOLD ax-mp syl sylbi cA cG cH pjidm.1 pjidm.2 pjsslem.1
        pjsslem syl5eqelr jca cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cG
        wcel cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cH cort cfv wcel wa cA
        cG cpj cfv cfv cA cH cpj cfv cfv cmv co cG cH cort cfv cin wcel cA cG
        cpj cfv cfv cA cH cpj cfv cfv cmv co cG cH cort cfv cin cpj cfv cfv cA
        cG cpj cfv cfv cA cH cpj cfv cfv cmv co wceq cA cG cpj cfv cfv cA cH
        cpj cfv cfv cmv co cG cH cort cfv elin cA cG cpj cfv cfv cA cH cpj cfv
        cfv cmv co cG cH cort cfv cin cG cH cort cfv pjsslem.1 cH pjidm.1
        choccli chincli cA cG cpj cfv cfv cA cH cpj cfv cfv cA cG pjsslem.1
        pjidm.2 pjhclii cA cH pjidm.1 pjidm.2 pjhclii hvsubcli pjchi bitr3i
        sylib cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cG cH cort cfv cin cpj
        cfv cfv cA cG cpj cfv cfv cG cH cort cfv cin cpj cfv cfv cA cH cpj cfv
        cfv cG cH cort cfv cin cpj cfv cfv cmv co cA cG cpj cfv cfv cG cH cort
        cfv cin cpj cfv cfv c1 cneg cA cH cpj cfv cfv cG cH cort cfv cin cpj
        cfv cfv csm co cva co cA cG cH cort cfv cin cpj cfv cfv cA cG cpj cfv
        cfv cA cH cpj cfv cfv cG cH cort cfv cin cG cH cort cfv pjsslem.1 cH
        pjidm.1 choccli chincli cA cG pjsslem.1 pjidm.2 pjhclii cA cH pjidm.1
        pjidm.2 pjhclii pjsubii cA cG cpj cfv cfv cG cH cort cfv cin cpj cfv
        cfv cA cH cpj cfv cfv cG cH cort cfv cin cpj cfv cfv cA cG cpj cfv cfv
        cG cH cort cfv cin cG cH cort cfv pjsslem.1 cH pjidm.1 choccli chincli
        cA cG pjsslem.1 pjidm.2 pjhclii pjhclii cA cH cpj cfv cfv cG cH cort
        cfv cin cG cH cort cfv pjsslem.1 cH pjidm.1 choccli chincli cA cH
        pjidm.1 pjidm.2 pjhclii pjhclii hvsubvali cA cG cpj cfv cfv cG cH cort
        cfv cin cpj cfv cfv c1 cneg cA cH cpj cfv cfv cG cH cort cfv cin cpj
        cfv cfv csm co cva co cA cG cH cort cfv cin cpj cfv cfv c0v cva co cA
        cG cH cort cfv cin cpj cfv cfv cA cG cpj cfv cfv cG cH cort cfv cin cpj
        cfv cfv cA cG cH cort cfv cin cpj cfv cfv c1 cneg cA cH cpj cfv cfv cG
        cH cort cfv cin cpj cfv cfv csm co c0v cva cG cH cort cfv cin cG wss cA
        cG cpj cfv cfv cG cH cort cfv cin cpj cfv cfv cA cG cH cort cfv cin cpj
        cfv cfv wceq cG cH cort cfv inss1 cA cG cG cH cort cfv cin cG cH cort
        cfv pjsslem.1 cH pjidm.1 choccli chincli pjidm.2 pjsslem.1 pjss2i ax-mp
        c1 cneg cA cH cpj cfv cfv cG cH cort cfv cin cpj cfv cfv csm co c1 cneg
        c0v csm co c0v cA cH cpj cfv cfv cG cH cort cfv cin cpj cfv cfv c0v c1
        cneg csm cA cH cpj cfv cfv cG cH cort cfv cin cort cfv wcel cA cH cpj
        cfv cfv cG cH cort cfv cin cpj cfv cfv c0v wceq cH cG cH cort cfv cin
        cort cfv cA cH cpj cfv cfv cH cH cort cfv cort cfv cG cH cort cfv cin
        cort cfv cH csh wcel cH cH cort cfv cort cfv wss cH pjidm.1 chshii cH
        shococss ax-mp cG cH cort cfv cin cH cort cfv wss cH cort cfv cort cfv
        cG cH cort cfv cin cort cfv wss cG cH cort cfv inss2 cG cH cort cfv cin
        cH cort cfv cG cH cort cfv pjsslem.1 cH pjidm.1 choccli chincli cH
        pjidm.1 choccli chsscon3i mpbi sstri cA cH pjidm.1 pjidm.2 pjclii
        sselii cA cH cpj cfv cfv cG cH cort cfv cin cG cH cort cfv pjsslem.1 cH
        pjidm.1 choccli chincli cA cH pjidm.1 pjidm.2 pjhclii pjoc2i mpbi
        opreq2i c1 cneg cc wcel c1 cneg c0v csm co c0v wceq c1 ax1cn negcli c1
        cneg hvmul0 ax-mp eqtri opreq12i cA cG cH cort cfv cin cpj cfv cfv chil
        wcel cA cG cH cort cfv cin cpj cfv cfv c0v cva co cA cG cH cort cfv cin
        cpj cfv cfv wceq cA cG cH cort cfv cin cG cH cort cfv pjsslem.1 cH
        pjidm.1 choccli chincli pjidm.2 pjhclii cA cG cH cort cfv cin cpj cfv
        cfv ax-hvaddid ax-mp eqtri 3eqtri syl5reqr $.
        $( [31-Oct-1999] $)

      $( Theorem 4.5(iv)->(v) of [Beran] p. 112. $)
      pjssge0ii $p |- ( ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) )
                    = ( ( proj ` ( G i^i ( _|_ ` H ) ) ) ` A ) ->
   0 <_ ( ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) ) .ih A ) ) $=
        cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA cG cH cort cfv cin cpj
        cfv cfv wceq cA cG cH cort cfv cin cpj cfv cfv cno cfv c2 cexp co cA cG
        cpj cfv cfv cA cH cpj cfv cfv cmv co cA csp co cc0 cle cA cG cpj cfv
        cfv cA cH cpj cfv cfv cmv co cA cG cH cort cfv cin cpj cfv cfv wceq cA
        cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA csp co cA cG cH cort cfv cin
        cpj cfv cfv cA csp co cA cG cH cort cfv cin cpj cfv cfv cno cfv c2 cexp
        co cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA cG cH cort cfv cin cpj
        cfv cfv cA csp opreq1 cA cG cH cort cfv cin cG cH cort cfv pjsslem.1 cH
        pjidm.1 choccli chincli pjidm.2 pjinormii syl6eq cA cG cH cort cfv cin
        cpj cfv cfv cno cfv cA cG cH cort cfv cin cpj cfv cfv cA cG cH cort cfv
        cin cG cH cort cfv pjsslem.1 cH pjidm.1 choccli chincli pjidm.2 pjhclii
        normcli sqge0i syl5breqr $.
        $( [13-Aug-2000] $)

      $( Theorem 4.5(v)<->(vi) of [Beran] p. 112. $)
      pjdifnormii $p |- ( 0 <_
                 ( ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) ) .ih A ) <->
      ( normh ` ( ( proj ` H ) ` A ) ) <_ ( normh ` ( ( proj ` G ) ` A ) ) ) $=
        cc0 cA cG cpj cfv cfv cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2
        cexp co cmin co cle wbr cA cH cpj cfv cfv cno cfv c2 cexp co cA cG cpj
        cfv cfv cno cfv c2 cexp co cle wbr cc0 cA cG cpj cfv cfv cA cH cpj cfv
        cfv cmv co cA csp co cle wbr cA cH cpj cfv cfv cno cfv cA cG cpj cfv
        cfv cno cfv cle wbr cA cG cpj cfv cfv cno cfv c2 cexp co cA cH cpj cfv
        cfv cno cfv c2 cexp co cA cG cpj cfv cfv cno cfv cA cG cpj cfv cfv cA
        cG pjsslem.1 pjidm.2 pjhclii normcli resqcli cA cH cpj cfv cfv cno cfv
        cA cH cpj cfv cfv cA cH pjidm.1 pjidm.2 pjhclii normcli resqcli subge0i
        cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA csp co cA cG cpj cfv cfv
        cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cmin co cc0 cle
        cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA csp co cA cG cpj cfv cfv
        cA csp co cA cH cpj cfv cfv cA csp co cmin co cA cG cpj cfv cfv cno cfv
        c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cmin co cA cG cpj cfv
        cfv chil wcel cA cH cpj cfv cfv chil wcel cA chil wcel cA cG cpj cfv
        cfv cA cH cpj cfv cfv cmv co cA csp co cA cG cpj cfv cfv cA csp co cA
        cH cpj cfv cfv cA csp co cmin co wceq cA cG pjsslem.1 pjidm.2 pjhclii
        cA cH pjidm.1 pjidm.2 pjhclii pjidm.2 cA cG cpj cfv cfv cA cH cpj cfv
        cfv cA his2sub mp3an cA cG cpj cfv cfv cA csp co cA cG cpj cfv cfv cno
        cfv c2 cexp co cA cH cpj cfv cfv cA csp co cA cH cpj cfv cfv cno cfv c2
        cexp co cmin cA cG pjsslem.1 pjidm.2 pjinormii cA cH pjidm.1 pjidm.2
        pjinormii opreq12i eqtri breq2i cc0 cA cH cpj cfv cfv cno cfv cle wbr
        cc0 cA cG cpj cfv cfv cno cfv cle wbr cA cH cpj cfv cfv cno cfv cA cG
        cpj cfv cfv cno cfv cle wbr cA cH cpj cfv cfv cno cfv c2 cexp co cA cG
        cpj cfv cfv cno cfv c2 cexp co cle wbr wb cA cH cpj cfv cfv chil wcel
        cc0 cA cH cpj cfv cfv cno cfv cle wbr cA cH pjidm.1 pjidm.2 pjhclii cA
        cH cpj cfv cfv normge0 ax-mp cA cG cpj cfv cfv chil wcel cc0 cA cG cpj
        cfv cfv cno cfv cle wbr cA cG pjsslem.1 pjidm.2 pjhclii cA cG cpj cfv
        cfv normge0 ax-mp cA cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv
        cA cH cpj cfv cfv cA cH pjidm.1 pjidm.2 pjhclii normcli cA cG cpj cfv
        cfv cA cG pjsslem.1 pjidm.2 pjhclii normcli le2sqi mp2an 3bitr4i $.
        $( [13-Aug-2000] $)

      $( The projection on a subspace join is the sum of the projections. $)
      pjcji $p |- ( H C_ ( _|_ ` G ) -> ( ( proj ` ( H vH G ) ) ` A ) =
                ( ( ( proj ` H ) ` A ) +h ( ( proj ` G ) ` A ) ) ) $=
        cH cG cort cfv wss cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cA cH cG
        chj co cpj cfv cfv cH cG cort cfv wss cA cA cG cort cfv cpj cfv cfv cA
        cH cpj cfv cfv cmv co cmv co cA cA cG cort cfv cH cort cfv cin cpj cfv
        cfv cmv co cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cA cH cG chj co
        cpj cfv cfv cH cG cort cfv wss cA cG cort cfv cpj cfv cfv cA cH cpj cfv
        cfv cmv co cA cG cort cfv cH cort cfv cin cpj cfv cfv cA cmv cA cG cort
        cfv cH pjidm.1 pjidm.2 cG pjsslem.1 choccli pjssmii opreq2d cA cH cpj
        cfv cfv cA cG cpj cfv cfv cva co cA c1 cneg cA cG cort cfv cpj cfv cfv
        cA cH cpj cfv cfv cmv co csm co cva co cA cA cG cort cfv cpj cfv cfv cA
        cH cpj cfv cfv cmv co cmv co cA cH cpj cfv cfv cA cA cG cort cfv cpj
        cfv cfv cmv co cva co cA cA cH cpj cfv cfv cA cG cort cfv cpj cfv cfv
        cmv co cva co cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cA c1 cneg cA
        cG cort cfv cpj cfv cfv cA cH cpj cfv cfv cmv co csm co cva co cA cH
        cpj cfv cfv chil wcel cA chil wcel cA cG cort cfv cpj cfv cfv chil wcel
        cA cH cpj cfv cfv cA cA cG cort cfv cpj cfv cfv cmv co cva co cA cA cH
        cpj cfv cfv cA cG cort cfv cpj cfv cfv cmv co cva co wceq cA cH pjidm.1
        pjidm.2 pjhclii pjidm.2 cA cG cort cfv cG pjsslem.1 choccli pjidm.2
        pjhclii cA cH cpj cfv cfv cA cA cG cort cfv cpj cfv cfv hvaddsub12
        mp3an cA cG cpj cfv cfv cA cA cG cort cfv cpj cfv cfv cmv co cA cH cpj
        cfv cfv cva cA cG pjsslem.1 pjidm.2 pjpoi opreq2i c1 cneg cA cG cort
        cfv cpj cfv cfv cA cH cpj cfv cfv cmv co csm co cA cH cpj cfv cfv cA cG
        cort cfv cpj cfv cfv cmv co cA cva cA cG cort cfv cpj cfv cfv cA cH cpj
        cfv cfv cA cG cort cfv cG pjsslem.1 choccli pjidm.2 pjhclii cA cH
        pjidm.1 pjidm.2 pjhclii hvnegdii opreq2i 3eqtr4i cA cA cG cort cfv cpj
        cfv cfv cA cH cpj cfv cfv cmv co pjidm.2 cA cG cort cfv cpj cfv cfv cA
        cH cpj cfv cfv cA cG cort cfv cG pjsslem.1 choccli pjidm.2 pjhclii cA
        cH pjidm.1 pjidm.2 pjhclii hvsubcli hvsubvali eqtr4i cA cH cG chj co
        cpj cfv cfv cA cG cort cfv cH cort cfv cin cort cfv cpj cfv cfv cA cA
        cG cort cfv cH cort cfv cin cpj cfv cfv cmv co cA cH cG chj co cpj cfv
        cG cort cfv cH cort cfv cin cort cfv cpj cfv cH cG chj co cG cort cfv
        cH cort cfv cin cort cfv cpj cH cG chj co cG cH chj co cG cort cfv cH
        cort cfv cin cort cfv cH cG pjidm.1 pjsslem.1 chjcomi cG cH pjsslem.1
        pjidm.1 chdmm4i eqtr4i fveq2i fveq1i cA cG cort cfv cH cort cfv cin cG
        cort cfv cH cort cfv cG pjsslem.1 choccli cH pjidm.1 choccli chincli
        pjidm.2 pjopi eqtri 3eqtr4g eqcomd $.
        $( [1-Nov-1999] $)
    $}
  $}

  ${
    pjadjt.1 $e |- H e. CH $.
    $( A projection is self-adjoint.  Property (i) of [Beran] p. 109. $)
    pjadji $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( ( proj ` H ) ` A ) .ih B ) =
                  ( A .ih ( ( proj ` H ) ` B ) ) ) $=
      cA chil wcel cB chil wcel cA cH cpj cfv cfv cB csp co cA cB cH cpj cfv
      cfv csp co wceq cA chil wcel cA c0v cif cH cpj cfv cfv cB csp co cA chil
      wcel cA c0v cif cB cH cpj cfv cfv csp co wceq cA chil wcel cA c0v cif cH
      cpj cfv cfv cB chil wcel cB c0v cif csp co cA chil wcel cA c0v cif cB
      chil wcel cB c0v cif cH cpj cfv cfv csp co wceq cA cB c0v c0v cA cA chil
      wcel cA c0v cif wceq cA cH cpj cfv cfv cB csp co cA chil wcel cA c0v cif
      cH cpj cfv cfv cB csp co cA cB cH cpj cfv cfv csp co cA chil wcel cA c0v
      cif cB cH cpj cfv cfv csp co cA cA chil wcel cA c0v cif wceq cA cH cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB csp cA cA chil wcel cA
      c0v cif cH cpj cfv fveq2 opreq1d cA cA chil wcel cA c0v cif cB cH cpj cfv
      cfv csp opreq1 eqeq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA
      c0v cif cH cpj cfv cfv cB csp co cA chil wcel cA c0v cif cH cpj cfv cfv
      cB chil wcel cB c0v cif csp co cA chil wcel cA c0v cif cB cH cpj cfv cfv
      csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cH cpj cfv cfv csp
      co cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cH cpj cfv cfv csp
      opreq2 cB cB chil wcel cB c0v cif wceq cB cH cpj cfv cfv cB chil wcel cB
      c0v cif cH cpj cfv cfv cA chil wcel cA c0v cif csp cB cB chil wcel cB c0v
      cif cH cpj cfv fveq2 opreq2d eqeq12d cA chil wcel cA c0v cif cB chil wcel
      cB c0v cif cH pjadjt.1 cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl
      elimel pjadjii dedth2h $.
      $( [6-Oct-2000] $)

    $( Projection of vector sum is sum of projections. $)
    pjaddi $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( proj ` H ) ` ( A +h B ) ) =
                ( ( ( proj ` H ) ` A ) +h ( ( proj ` H ) ` B ) ) ) $=
      cA chil wcel cB chil wcel cA cB cva co cH cpj cfv cfv cA cH cpj cfv cfv
      cB cH cpj cfv cfv cva co wceq cA chil wcel cA c0v cif cB cva co cH cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB cH cpj cfv cfv cva co
      wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co cH cpj cfv
      cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB chil wcel cB c0v cif cH cpj
      cfv cfv cva co wceq cA cB c0v c0v cA cA chil wcel cA c0v cif wceq cA cB
      cva co cH cpj cfv cfv cA chil wcel cA c0v cif cB cva co cH cpj cfv cfv cA
      cH cpj cfv cfv cB cH cpj cfv cfv cva co cA chil wcel cA c0v cif cH cpj
      cfv cfv cB cH cpj cfv cfv cva co cA cA chil wcel cA c0v cif wceq cA cB
      cva co cA chil wcel cA c0v cif cB cva co cH cpj cfv cA cA chil wcel cA
      c0v cif cB cva opreq1 fveq2d cA cA chil wcel cA c0v cif wceq cA cH cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB cH cpj cfv cfv cva cA
      cA chil wcel cA c0v cif cH cpj cfv fveq2 opreq1d eqeq12d cB cB chil wcel
      cB c0v cif wceq cA chil wcel cA c0v cif cB cva co cH cpj cfv cfv cA chil
      wcel cA c0v cif cB chil wcel cB c0v cif cva co cH cpj cfv cfv cA chil
      wcel cA c0v cif cH cpj cfv cfv cB cH cpj cfv cfv cva co cA chil wcel cA
      c0v cif cH cpj cfv cfv cB chil wcel cB c0v cif cH cpj cfv cfv cva co cB
      cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cva co cA chil
      wcel cA c0v cif cB chil wcel cB c0v cif cva co cH cpj cfv cB cB chil wcel
      cB c0v cif cA chil wcel cA c0v cif cva opreq2 fveq2d cB cB chil wcel cB
      c0v cif wceq cB cH cpj cfv cfv cB chil wcel cB c0v cif cH cpj cfv cfv cA
      chil wcel cA c0v cif cH cpj cfv cfv cva cB cB chil wcel cB c0v cif cH cpj
      cfv fveq2 opreq2d eqeq12d cA chil wcel cA c0v cif cB chil wcel cB c0v cif
      cH pjadjt.1 cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel
      pjaddii dedth2h $.
      $( [14-Nov-2000] $)

    $( The inner product of a projection and its argument is the square of the
       norm of the projection.  Remark in [Halmos] p. 44. $)
    pjinormi $p |- ( A e. ~H -> ( ( ( proj ` H ) ` A ) .ih A ) =
                 ( ( normh ` ( ( proj ` H ) ` A ) ) ^ 2 ) ) $=
      cA chil wcel cA cH cpj cfv cfv cA csp co cA cH cpj cfv cfv cno cfv c2
      cexp co wceq cA chil wcel cA c0v cif cH cpj cfv cfv cA chil wcel cA c0v
      cif csp co cA chil wcel cA c0v cif cH cpj cfv cfv cno cfv c2 cexp co wceq
      cA c0v cA cA chil wcel cA c0v cif wceq cA cH cpj cfv cfv cA csp co cA
      chil wcel cA c0v cif cH cpj cfv cfv cA chil wcel cA c0v cif csp co cA cH
      cpj cfv cfv cno cfv c2 cexp co cA chil wcel cA c0v cif cH cpj cfv cfv cno
      cfv c2 cexp co cA cA chil wcel cA c0v cif wceq cA cH cpj cfv cfv cA chil
      wcel cA c0v cif cH cpj cfv cfv cA cA chil wcel cA c0v cif csp cA cA chil
      wcel cA c0v cif cH cpj cfv fveq2 cA cA chil wcel cA c0v cif wceq id
      opreq12d cA cA chil wcel cA c0v cif wceq cA cH cpj cfv cfv cno cfv cA
      chil wcel cA c0v cif cH cpj cfv cfv cno cfv c2 cexp cA cA chil wcel cA
      c0v cif wceq cA cH cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cno
      cA cA chil wcel cA c0v cif cH cpj cfv fveq2 fveq2d opreq1d eqeq12d cA
      chil wcel cA c0v cif cH pjadjt.1 cA c0v chil ax-hv0cl elimel pjinormii
      dedth $.
      $( [28-Jun-2006] $) $( [2-Jun-2006] $)

    $( Projection of vector difference is difference of projections. $)
    pjsubi $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( proj ` H ) ` ( A -h B ) ) =
                ( ( ( proj ` H ) ` A ) -h ( ( proj ` H ) ` B ) ) ) $=
      cA chil wcel cB chil wcel cA cB cmv co cH cpj cfv cfv cA cH cpj cfv cfv
      cB cH cpj cfv cfv cmv co wceq cA chil wcel cA c0v cif cB cmv co cH cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB cH cpj cfv cfv cmv co
      wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cH cpj cfv
      cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB chil wcel cB c0v cif cH cpj
      cfv cfv cmv co wceq cA cB c0v c0v cA cA chil wcel cA c0v cif wceq cA cB
      cmv co cH cpj cfv cfv cA chil wcel cA c0v cif cB cmv co cH cpj cfv cfv cA
      cH cpj cfv cfv cB cH cpj cfv cfv cmv co cA chil wcel cA c0v cif cH cpj
      cfv cfv cB cH cpj cfv cfv cmv co cA cA chil wcel cA c0v cif wceq cA cB
      cmv co cA chil wcel cA c0v cif cB cmv co cH cpj cfv cA cA chil wcel cA
      c0v cif cB cmv opreq1 fveq2d cA cA chil wcel cA c0v cif wceq cA cH cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cB cH cpj cfv cfv cmv cA
      cA chil wcel cA c0v cif cH cpj cfv fveq2 opreq1d eqeq12d cB cB chil wcel
      cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cH cpj cfv cfv cA chil
      wcel cA c0v cif cB chil wcel cB c0v cif cmv co cH cpj cfv cfv cA chil
      wcel cA c0v cif cH cpj cfv cfv cB cH cpj cfv cfv cmv co cA chil wcel cA
      c0v cif cH cpj cfv cfv cB chil wcel cB c0v cif cH cpj cfv cfv cmv co cB
      cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cmv co cA chil
      wcel cA c0v cif cB chil wcel cB c0v cif cmv co cH cpj cfv cB cB chil wcel
      cB c0v cif cA chil wcel cA c0v cif cmv opreq2 fveq2d cB cB chil wcel cB
      c0v cif wceq cB cH cpj cfv cfv cB chil wcel cB c0v cif cH cpj cfv cfv cA
      chil wcel cA c0v cif cH cpj cfv cfv cmv cB cB chil wcel cB c0v cif cH cpj
      cfv fveq2 opreq2d eqeq12d cA chil wcel cA c0v cif cB chil wcel cB c0v cif
      cH pjadjt.1 cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel
      pjsubii dedth2h $.
      $( [14-Nov-2000] $)

    $( Projection of scalar product is scalar product of projection. $)
    pjmuli $p |- ( ( A e. CC /\ B e. ~H ) -> ( ( proj ` H ) ` ( A .h B ) ) =
                ( A .h ( ( proj ` H ) ` B ) ) ) $=
      cA cc wcel cB chil wcel cA cB csm co cH cpj cfv cfv cA cB cH cpj cfv cfv
      csm co wceq cA cc wcel cA cc0 cif cB csm co cH cpj cfv cfv cA cc wcel cA
      cc0 cif cB cH cpj cfv cfv csm co wceq cA cc wcel cA cc0 cif cB chil wcel
      cB c0v cif csm co cH cpj cfv cfv cA cc wcel cA cc0 cif cB chil wcel cB
      c0v cif cH cpj cfv cfv csm co wceq cA cB cc0 c0v cA cA cc wcel cA cc0 cif
      wceq cA cB csm co cH cpj cfv cfv cA cc wcel cA cc0 cif cB csm co cH cpj
      cfv cfv cA cB cH cpj cfv cfv csm co cA cc wcel cA cc0 cif cB cH cpj cfv
      cfv csm co cA cA cc wcel cA cc0 cif wceq cA cB csm co cA cc wcel cA cc0
      cif cB csm co cH cpj cfv cA cA cc wcel cA cc0 cif cB csm opreq1 fveq2d cA
      cA cc wcel cA cc0 cif cB cH cpj cfv cfv csm opreq1 eqeq12d cB cB chil
      wcel cB c0v cif wceq cA cc wcel cA cc0 cif cB csm co cH cpj cfv cfv cA cc
      wcel cA cc0 cif cB chil wcel cB c0v cif csm co cH cpj cfv cfv cA cc wcel
      cA cc0 cif cB cH cpj cfv cfv csm co cA cc wcel cA cc0 cif cB chil wcel cB
      c0v cif cH cpj cfv cfv csm co cB cB chil wcel cB c0v cif wceq cA cc wcel
      cA cc0 cif cB csm co cA cc wcel cA cc0 cif cB chil wcel cB c0v cif csm co
      cH cpj cfv cB cB chil wcel cB c0v cif cA cc wcel cA cc0 cif csm opreq2
      fveq2d cB cB chil wcel cB c0v cif wceq cB cH cpj cfv cfv cB chil wcel cB
      c0v cif cH cpj cfv cfv cA cc wcel cA cc0 cif csm cB cB chil wcel cB c0v
      cif cH cpj cfv fveq2 opreq2d eqeq12d cB chil wcel cB c0v cif cA cc wcel
      cA cc0 cif cH pjadjt.1 cB c0v chil ax-hv0cl elimel cA cc0 cc 0cn elimel
      pjmulii dedth2h $.
      $( [26-Nov-2000] $)

    $( The inner product of a projection and its argument is nonnegative. $)
    pjige0i $p |- ( A e. ~H -> 0 <_ ( ( ( proj ` H ) ` A ) .ih A ) ) $=
      cA chil wcel cc0 cA cH cpj cfv cfv cno cfv c2 cexp co cA cH cpj cfv cfv
      cA csp co cle cA chil wcel cA cH cpj cfv cfv chil wcel cA cH cpj cfv cfv
      cno cfv cr wcel cc0 cA cH cpj cfv cfv cno cfv c2 cexp co cle wbr cA cH
      pjadjt.1 pjhcli cA cH cpj cfv cfv normcl cA cH cpj cfv cfv cno cfv sqge0
      3syl cA cH pjadjt.1 pjinormi breqtrrd $.
      $( [2-Jul-2006] $) $( [2-Jun-2006] $)
  $}

  $( The inner product of a projection and its argument is nonnegative. $)
  pjige0 $p |- ( ( H e. CH /\ A e. ~H ) ->
                0 <_ ( ( ( proj ` H ) ` A ) .ih A ) ) $=
    cH cch wcel cA chil wcel cc0 cA cH cpj cfv cfv cA csp co cle wbr cH cch
    wcel cA chil wcel cc0 cA cH cpj cfv cfv cA csp co cle wbr wi cA chil wcel
    cc0 cA cH cch wcel cH c0h cif cpj cfv cfv cA csp co cle wbr wi cH c0h cH cH
    cch wcel cH c0h cif wceq cc0 cA cH cpj cfv cfv cA csp co cle wbr cc0 cA cH
    cch wcel cH c0h cif cpj cfv cfv cA csp co cle wbr cA chil wcel cH cH cch
    wcel cH c0h cif wceq cA cH cpj cfv cfv cA csp co cA cH cch wcel cH c0h cif
    cpj cfv cfv cA csp co cc0 cle cH cH cch wcel cH c0h cif wceq cA cH cpj cfv
    cfv cA cH cch wcel cH c0h cif cpj cfv cfv cA csp cH cH cch wcel cH c0h cif
    wceq cA cH cpj cfv cH cch wcel cH c0h cif cpj cfv cH cH cch wcel cH c0h cif
    cpj fveq2 fveq1d opreq1d breq2d imbi2d cA cH cch wcel cH c0h cif cH c0h cch
    h0elch elimel pjige0i dedth imp $.
    $( [4-Jul-2006] $) $( [2-Jun-2006] $)

  $( The projection on a subspace join is the sum of the projections. $)
  pjcjt2 $p |- ( ( H e. CH /\ G e. CH /\ A e. ~H ) ->
            ( H C_ ( _|_ ` G ) -> ( ( proj ` ( H vH G ) ) ` A ) =
            ( ( ( proj ` H ) ` A ) +h ( ( proj ` G ) ` A ) ) ) ) $=
    cH cch wcel cG cch wcel cA chil wcel cH cG cort cfv wss cA cH cG chj co cpj
    cfv cfv cA cH cpj cfv cfv cA cG cpj cfv cfv cva co wceq wi cH cch wcel cH
    chil cif cG cort cfv wss cA cH cch wcel cH chil cif cG chj co cpj cfv cfv
    cA cH cch wcel cH chil cif cpj cfv cfv cA cG cpj cfv cfv cva co wceq wi cH
    cG cA chil chil c0v cH cch wcel cH chil cif cG cch wcel cG chil cif cort
    cfv wss cA cH cch wcel cH chil cif cG cch wcel cG chil cif chj co cpj cfv
    cfv cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil cif cpj
    cfv cfv cva co wceq wi cH cch wcel cH chil cif cG cch wcel cG chil cif cort
    cfv wss cA chil wcel cA c0v cif cH cch wcel cH chil cif cG cch wcel cG chil
    cif chj co cpj cfv cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj
    cfv cfv cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cva co
    wceq wi cH cH cch wcel cH chil cif wceq cH cG cort cfv wss cH cch wcel cH
    chil cif cG cort cfv wss cA cH cG chj co cpj cfv cfv cA cH cpj cfv cfv cA
    cG cpj cfv cfv cva co wceq cA cH cch wcel cH chil cif cG chj co cpj cfv cfv
    cA cH cch wcel cH chil cif cpj cfv cfv cA cG cpj cfv cfv cva co wceq cH cH
    cch wcel cH chil cif cG cort cfv sseq1 cH cH cch wcel cH chil cif wceq cA
    cH cG chj co cpj cfv cfv cA cH cch wcel cH chil cif cG chj co cpj cfv cfv
    cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cA cH cch wcel cH chil cif cpj
    cfv cfv cA cG cpj cfv cfv cva co cH cH cch wcel cH chil cif wceq cA cH cG
    chj co cpj cfv cH cch wcel cH chil cif cG chj co cpj cfv cH cH cch wcel cH
    chil cif wceq cH cG chj co cH cch wcel cH chil cif cG chj co cpj cH cH cch
    wcel cH chil cif cG chj opreq1 fveq2d fveq1d cH cH cch wcel cH chil cif
    wceq cA cH cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv cA cG cpj cfv
    cfv cva cH cH cch wcel cH chil cif wceq cA cH cpj cfv cH cch wcel cH chil
    cif cpj cfv cH cH cch wcel cH chil cif cpj fveq2 fveq1d opreq1d eqeq12d
    imbi12d cG cG cch wcel cG chil cif wceq cH cch wcel cH chil cif cG cort cfv
    wss cH cch wcel cH chil cif cG cch wcel cG chil cif cort cfv wss cA cH cch
    wcel cH chil cif cG chj co cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv
    cfv cA cG cpj cfv cfv cva co wceq cA cH cch wcel cH chil cif cG cch wcel cG
    chil cif chj co cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv cA cG
    cch wcel cG chil cif cpj cfv cfv cva co wceq cG cG cch wcel cG chil cif
    wceq cG cort cfv cG cch wcel cG chil cif cort cfv cH cch wcel cH chil cif
    cG cG cch wcel cG chil cif cort fveq2 sseq2d cG cG cch wcel cG chil cif
    wceq cA cH cch wcel cH chil cif cG chj co cpj cfv cfv cA cH cch wcel cH
    chil cif cG cch wcel cG chil cif chj co cpj cfv cfv cA cH cch wcel cH chil
    cif cpj cfv cfv cA cG cpj cfv cfv cva co cA cH cch wcel cH chil cif cpj cfv
    cfv cA cG cch wcel cG chil cif cpj cfv cfv cva co cG cG cch wcel cG chil
    cif wceq cA cH cch wcel cH chil cif cG chj co cpj cfv cH cch wcel cH chil
    cif cG cch wcel cG chil cif chj co cpj cfv cG cG cch wcel cG chil cif wceq
    cH cch wcel cH chil cif cG chj co cH cch wcel cH chil cif cG cch wcel cG
    chil cif chj co cpj cG cG cch wcel cG chil cif cH cch wcel cH chil cif chj
    opreq2 fveq2d fveq1d cG cG cch wcel cG chil cif wceq cA cG cpj cfv cfv cA
    cG cch wcel cG chil cif cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv
    cva cG cG cch wcel cG chil cif wceq cA cG cpj cfv cG cch wcel cG chil cif
    cpj cfv cG cG cch wcel cG chil cif cpj fveq2 fveq1d opreq2d eqeq12d imbi12d
    cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cG cch wcel cG
    chil cif chj co cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv cA cG
    cch wcel cG chil cif cpj cfv cfv cva co wceq cA chil wcel cA c0v cif cH cch
    wcel cH chil cif cG cch wcel cG chil cif chj co cpj cfv cfv cA chil wcel cA
    c0v cif cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif cG cch
    wcel cG chil cif cpj cfv cfv cva co wceq cH cch wcel cH chil cif cG cch
    wcel cG chil cif cort cfv wss cA cA chil wcel cA c0v cif wceq cA cH cch
    wcel cH chil cif cG cch wcel cG chil cif chj co cpj cfv cfv cA chil wcel cA
    c0v cif cH cch wcel cH chil cif cG cch wcel cG chil cif chj co cpj cfv cfv
    cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil cif cpj cfv
    cfv cva co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA
    chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cva co cA cA chil
    wcel cA c0v cif cH cch wcel cH chil cif cG cch wcel cG chil cif chj co cpj
    cfv fveq2 cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj
    cfv cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA cG
    cch wcel cG chil cif cpj cfv cfv cA chil wcel cA c0v cif cG cch wcel cG
    chil cif cpj cfv cfv cva cA cA chil wcel cA c0v cif cH cch wcel cH chil cif
    cpj cfv fveq2 cA cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv
    fveq2 opreq12d eqeq12d imbi2d cA chil wcel cA c0v cif cG cch wcel cG chil
    cif cH cch wcel cH chil cif cH chil cch helch elimel cA c0v chil ax-hv0cl
    elimel cG chil cch helch elimel pjcji dedth3h $.
    $( [1-Nov-1999] $)

  ${
    pj0.1 $e |- H e. CH $.
    $( The projection of the zero vector. $)
    pj0i $p |- ( ( proj ` H ) ` 0h ) = 0h $=
      c0v cH cort cfv wcel c0v cH cpj cfv cfv c0v wceq cH csh wcel c0v cH cort
      cfv wcel cH pj0.1 chshii cH oc0 ax-mp c0v cH pj0.1 ax-hv0cl pjoc2i mpbi
      $.
      $( [31-Oct-1999] $)
  $}

  $( Projection of a vector in the projection subspace.  Lemma 4.4(ii) of
     [Beran] p. 111. $)
  pjch $p |- ( ( H e. CH /\ A e. ~H ) ->
              ( A e. H <-> ( ( proj ` H ) ` A ) = A ) ) $=
    cH cch wcel cA chil wcel cA cH wcel cA cH cpj cfv cfv cA wceq wb cA cH cch
    wcel cH chil cif wcel cA cH cch wcel cH chil cif cpj cfv cfv cA wceq wb cA
    chil wcel cA c0v cif cH cch wcel cH chil cif wcel cA chil wcel cA c0v cif
    cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif wceq wb cH cA
    chil c0v cH cH cch wcel cH chil cif wceq cA cH wcel cA cH cch wcel cH chil
    cif wcel cA cH cpj cfv cfv cA wceq cA cH cch wcel cH chil cif cpj cfv cfv
    cA wceq cH cH cch wcel cH chil cif cA eleq2 cH cH cch wcel cH chil cif wceq
    cA cH cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv cA cH cH cch wcel
    cH chil cif wceq cA cH cpj cfv cH cch wcel cH chil cif cpj cfv cH cH cch
    wcel cH chil cif cpj fveq2 fveq1d eqeq1d bibi12d cA cA chil wcel cA c0v cif
    wceq cA cH cch wcel cH chil cif wcel cA chil wcel cA c0v cif cH cch wcel cH
    chil cif wcel cA cH cch wcel cH chil cif cpj cfv cfv cA wceq cA chil wcel
    cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif wceq
    cA cA chil wcel cA c0v cif cH cch wcel cH chil cif eleq1 cA cA chil wcel cA
    c0v cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif
    cH cch wcel cH chil cif cpj cfv cfv cA cA chil wcel cA c0v cif cA cA chil
    wcel cA c0v cif cH cch wcel cH chil cif cpj cfv fveq2 cA cA chil wcel cA
    c0v cif wceq id eqeq12d bibi12d cA chil wcel cA c0v cif cH cch wcel cH chil
    cif cH chil cch helch elimel cA c0v chil ax-hv0cl elimel pjchi dedth2h $.
    $( [30-Oct-1999] $)

  $( The projection of a vector in the projection subspace is itself. $)
  pjid $p |- ( ( H e. CH /\ A e. H ) -> ( ( proj ` H ) ` A ) = A ) $=
    cH cch wcel cA cH wcel cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cA
    wceq cH cch wcel cA cH wcel wa cH cch wcel cA chil wcel cH cch wcel cA cH
    wcel pm3.26 cA cH chel jca cH cch wcel cA chil wcel wa cA cH wcel cA cH cpj
    cfv cfv cA wceq cA cH pjch biimpa sylancom $.
    $( [9-Apr-2006] $) $( [9-Apr-2006] $)

  ${
    $d x H $.
    $( The set of vectors belonging to the subspace of a projection.  Part of
       Theorem 26.2 of [Halmos] p. 44. $)
    pjvec $p |- ( H e. CH -> H = { x e. ~H | ( ( proj ` H ) ` x ) = x } ) $=
      cH cch wcel chil cH cin cH vx cv cH cpj cfv cfv vx cv wceq vx chil crab
      cH cch wcel cH chil wss chil cH cin cH wceq cH chss cH chil sseqin2 sylib
      cH cch wcel vx cv cH cpj cfv cfv vx cv wceq vx cH chil cH cch wcel vx cv
      chil wcel vx cv cH wcel vx cv cH cpj cfv cfv vx cv wceq wb vx cv cH pjch
      ex rabbirdv eqtr3d $.
      $( [13-Oct-2006] $) $( [11-Apr-2006] $)

    $( The set of vectors belonging to the orthocomplemented subspace of a
       projection.  Second part of Theorem 27.3 of [Halmos] p. 45. $)
    pjocvec $p |- ( H e. CH -> ( _|_ ` H ) =
                   { x e. ~H | ( ( proj ` H ) ` x ) = 0h } ) $=
      cH cch wcel chil cH cort cfv cin cH cort cfv vx cv cH cpj cfv cfv c0v
      wceq vx chil crab cH cch wcel cH cort cfv chil wss chil cH cort cfv cin
      cH cort cfv wceq cH cch wcel cH cort cfv cch wcel cH cort cfv chil wss cH
      choccl cH cort cfv chss syl cH cort cfv chil sseqin2 sylib cH cch wcel vx
      cv cH cpj cfv cfv c0v wceq vx cH cort cfv chil cH cch wcel vx cv chil
      wcel vx cv cH cort cfv wcel vx cv cH cpj cfv cfv c0v wceq wb vx cv cH
      pjoc2 ex rabbirdv eqtr3d $.
      $( [14-Oct-2006] $) $( [24-Apr-2006] $)
  $}

  ${
    pjocin.1 $e |- G e. CH $.
    pjocin.2 $e |- H e. CH $.
    $( Membership of projection in orthocomplement of intersection. $)
    pjocini $p |- ( A e. ( _|_ ` ( G i^i H ) ) ->
                 ( ( proj ` G ) ` A ) e. ( _|_ ` ( G i^i H ) ) ) $=
      cA cG cH cin cort cfv wcel cA cG cpj cfv cfv cA cA cG cort cfv cpj cfv
      cfv cmv co cG cH cin cort cfv cA cG cH cin cort cfv wcel cA chil wcel cA
      cG cpj cfv cfv cA cA cG cort cfv cpj cfv cfv cmv co wceq cA cG cH cin
      cort cfv cG cH cin cG cH pjocin.1 pjocin.2 chincli choccli cheli cG cch
      wcel cA chil wcel cA cG cpj cfv cfv cA cA cG cort cfv cpj cfv cfv cmv co
      wceq pjocin.1 cA cG pjpo mpan syl cA cG cH cin cort cfv wcel cA cG cort
      cfv cpj cfv cfv cG cH cin cort cfv wcel cA cA cG cort cfv cpj cfv cfv cmv
      co cG cH cin cort cfv wcel cA cG cH cin cort cfv wcel cA chil wcel cA cG
      cort cfv cpj cfv cfv cG cort cfv wcel cA cG cort cfv cpj cfv cfv cG cH
      cin cort cfv wcel cA cG cH cin cort cfv cG cH cin cG cH pjocin.1 pjocin.2
      chincli choccli cheli cA cG cort cfv cG pjocin.1 choccli pjcli cG cort
      cfv cG cH cin cort cfv cA cG cort cfv cpj cfv cfv cG cH cin cG wss cG
      cort cfv cG cH cin cort cfv wss cG cH inss1 cG cH cin cG cG cH pjocin.1
      pjocin.2 chincli pjocin.1 chsscon3i mpbi sseli 3syl cG cH cin cort cfv
      csh wcel cA cG cH cin cort cfv wcel cA cG cort cfv cpj cfv cfv cG cH cin
      cort cfv wcel wa cA cA cG cort cfv cpj cfv cfv cmv co cG cH cin cort cfv
      wcel wi cG cH cin cort cfv cG cH cin cG cH pjocin.1 pjocin.2 chincli
      choccli chshii cA cA cG cort cfv cpj cfv cfv cG cH cin cort cfv
      shsubclOLD ax-mp mpdan eqeltrd $.
      $( [21-Apr-2001] $)

    $( Membership of projection in an intersection. $)
    pjini $p |- ( A e. ( G i^i H ) ->
                 ( ( proj ` G ) ` A ) e. ( G i^i H ) ) $=
      cA cG cH cin wcel cA cG cpj cfv cfv cG cH cin wcel cA cG cH cin wcel cA
      cG cpj cfv cfv cA cG cH cin cA cG cH cin wcel cA cG wcel cA cG cpj cfv
      cfv cA wceq cG cH cin cG cA cG cH inss1 sseli cG cch wcel cA cG wcel cA
      cG cpj cfv cfv cA wceq pjocin.1 cA cG pjid mpan syl eleq1d ibir $.
      $( [22-Apr-2001] $)
  $}

  ${
    $d x y z w G $.  $d x y z w H $.
    pjjs.1 $e |- G e. CH $.
    pjjs.2 $e |- H e. SH $.
    $( A sufficient condition for subspace join to be equal to subspace sum. $)
    pjjsi $p |- ( A. x e. ( G vH H ) ( ( proj ` ( _|_ ` G ) ) ` x ) e. H ->
               ( G vH H ) = ( G +H H ) ) $=
      vx cv cG cort cfv cpj cfv cfv cH wcel vx cG cH chj co wral cG cH chj co
      cG cH cph co wss cG cH cph co cG cH chj co wss wa cG cH chj co cG cH cph
      co wceq vx cv cG cort cfv cpj cfv cfv cH wcel vx cG cH chj co wral cG cH
      chj co cG cH cph co wss cG cH cph co cG cH chj co wss vx cv cG cort cfv
      cpj cfv cfv cH wcel vx cG cH chj co wral vw cG cH chj co cG cH cph co vw
      cv cG cH chj co wcel vx cv cG cort cfv cpj cfv cfv cH wcel vx cG cH chj
      co wral vw cv cG cH cph co wcel vw cv cG cH chj co wcel vx cv cG cort cfv
      cpj cfv cfv cH wcel vx cG cH chj co wral vw cv cG cort cfv cpj cfv cfv cH
      wcel vw cv cG cH cph co wcel vx cv cG cort cfv cpj cfv cfv cH wcel vw cv
      cG cort cfv cpj cfv cfv cH wcel vx vw cv cG cH chj co vx cv vw cv wceq vx
      cv cG cort cfv cpj cfv cfv vw cv cG cort cfv cpj cfv cfv cH vx cv vw cv
      cG cort cfv cpj cfv fveq2 eleq1d rcla4v vw cv cG cH chj co wcel vw cv cG
      cort cfv cpj cfv cfv cH wcel vw cv cG cH cph co wcel vw cv cG cH chj co
      wcel vw cv cG cort cfv cpj cfv cfv cH wcel wa vw cv vy cv vz cv cva co
      wceq vz cH wrex vy cG wrex vw cv cG cH cph co wcel vw cv cG cH chj co
      wcel vw cv cG cort cfv cpj cfv cfv cH wcel wa vw cv cG cpj cfv cfv cG
      wcel vw cv cG cort cfv cpj cfv cfv cH wcel wa vw cv vw cv cG cpj cfv cfv
      vw cv cG cort cfv cpj cfv cfv cva co wceq wa vw cv vy cv vz cv cva co
      wceq vz cH wrex vy cG wrex vw cv chil wcel vw cv cG cort cfv cpj cfv cfv
      cH wcel vw cv cG cpj cfv cfv cG wcel vw cv cG cort cfv cpj cfv cfv cH
      wcel wa vw cv vw cv cG cpj cfv cfv vw cv cG cort cfv cpj cfv cfv cva co
      wceq wa vw cv cG cH chj co wcel vw cv chil wcel vw cv cG cort cfv cpj cfv
      cfv cH wcel wa vw cv cG cpj cfv cfv cG wcel vw cv cG cort cfv cpj cfv cfv
      cH wcel wa vw cv vw cv cG cpj cfv cfv vw cv cG cort cfv cpj cfv cfv cva
      co wceq vw cv chil wcel vw cv cG cpj cfv cfv cG wcel vw cv cG cort cfv
      cpj cfv cfv cH wcel vw cv cG pjjs.1 pjcli anim1i vw cv chil wcel vw cv vw
      cv cG cpj cfv cfv vw cv cG cort cfv cpj cfv cfv cva co wceq vw cv cG cort
      cfv cpj cfv cfv cH wcel cG cch wcel vw cv chil wcel vw cv vw cv cG cpj
      cfv cfv vw cv cG cort cfv cpj cfv cfv cva co wceq pjjs.1 vw cv cG axpjpj
      mpan adantr jca vw cv cG cH chj co cG cH cG pjjs.1 chshii pjjs.2 shjcli
      cheli sylan vw cv cG cpj cfv cfv cG wcel vw cv cG cort cfv cpj cfv cfv cH
      wcel vw cv vw cv cG cpj cfv cfv vw cv cG cort cfv cpj cfv cfv cva co wceq
      vw cv vy cv vz cv cva co wceq vz cH wrex vy cG wrex vy vz cG cH vw cv cG
      cpj cfv cfv vw cv cG cort cfv cpj cfv cfv vw cv cva rcla4eopr 3expa syl
      vy vz cG cH vw cv cG pjjs.1 chshii pjjs.2 shseli sylibr ex syld com12
      ssrdv cG cH cG pjjs.1 chshii pjjs.2 shsleji jctir cG cH chj co cG cH cph
      co eqss sylibr $.
      $( [29-Aug-2004] $) $( [29-May-2004] $)
  $}

  ${
    $d x y z w H $.
    pjfn.1 $e |- H e. CH $.
    $( Functionality of a projection. $)
    pjfni $p |- ( proj ` H ) Fn ~H $=
      vx vy chil vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH crab
      cuni cH cpj cfv vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH
      crab vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH cH cch
      pjfn.1 elisseti rabex uniex cH cch wcel cH cpj cfv vx cv chil wcel vy cv
      vx cv vz cv vw cv cva co wceq vw cH cort cfv wrex vz cH crab cuni wceq wa
      vx vy copab wceq pjfn.1 vx vy vz vw cH pjmval ax-mp fnopab2 $.
      $( [30-Oct-1999] $)

    $( The range of a projection.  Part of Theorem 26.2 of [Halmos] p. 44. $)
    pjrni $p |- ran ( proj ` H ) = H $=
      vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vx vy copab crn vx cv
      chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vx wex vy cab cH cpj cfv crn
      cH vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vx vy rnopab cH cpj
      cfv vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vx vy copab cH cpj
      cfv chil wfn cH cpj cfv vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq
      wa vx vy copab wceq cH pjfn.1 pjfni vx vy chil cH cpj cfv dffn5 mpbi
      rneqi vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vx wex vy cH vy
      cv cH wcel vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vx wex vy
      cv chil wcel vy cv vy cv cH cpj cfv cfv wceq vx cv chil wcel vy cv vx cv
      cH cpj cfv cfv wceq wa vx wex vy cv cH wcel vx cv chil wcel vy cv vx cv
      cH cpj cfv cfv wceq wa vy cv chil wcel vy cv vy cv cH cpj cfv cfv wceq wa
      vx vy cv vy visset vx cv vy cv wceq vx cv chil wcel vy cv chil wcel vy cv
      vx cv cH cpj cfv cfv wceq vy cv vy cv cH cpj cfv cfv wceq vx cv vy cv
      chil eleq1 vx cv vy cv wceq vx cv cH cpj cfv cfv vy cv cH cpj cfv cfv vy
      cv vx cv vy cv cH cpj cfv fveq2 eqeq2d anbi12d cla4ev vy cv cH pjfn.1
      cheli vy cv cH wcel vy cv cH cpj cfv cfv vy cv cH cch wcel vy cv cH wcel
      vy cv cH cpj cfv cfv vy cv wceq pjfn.1 vy cv cH pjid mpan eqcomd sylanc
      vx cv chil wcel vy cv vx cv cH cpj cfv cfv wceq wa vy cv cH wcel vx vy cv
      vx cv cH cpj cfv cfv wceq vx cv chil wcel vy cv cH wcel vy cv vx cv cH
      cpj cfv cfv wceq vy cv cH wcel vx cv cH cpj cfv cfv cH wcel vx cv chil
      wcel vy cv vx cv cH cpj cfv cfv cH eleq1 vx cv cH pjfn.1 pjcli syl5bir
      impcom 19.23aiv impbii abbi2i 3eqtr4i $.
      $( [30-Oct-1999] $)

    $( A projection maps onto its subspace. $)
    pjfoi $p |- ( proj ` H ) : ~H -onto-> H $=
      chil cH cH cpj cfv wfo cH cpj cfv chil wfn cH cpj cfv crn cH wceq chil cH
      cH cpj cfv df-fo cH pjfn.1 pjfni cH pjfn.1 pjrni mpbir2an $.
      $( [17-May-2006] $) $( [24-Apr-2006] $)

    $( The mapping of a projection. $)
    pjfi $p |- ( proj ` H ) : ~H --> ~H $=
      chil chil cH cpj cfv wf cH cpj cfv chil wfn cH cpj cfv crn chil wss chil
      chil cH cpj cfv df-f cH pjfn.1 pjfni cH cpj cfv crn cH chil cH pjfn.1
      pjrni cH pjfn.1 chssii eqsstri mpbir2an $.
      $( [11-Nov-2000] $)

    $( The value of a projection in terms of components. $)
    pjvi $p |- ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
               ( ( proj ` H ) ` ( A +h B ) ) = A ) $=
      cA cH wcel cB cH cort cfv wcel wa cA cB cva co cH cpj cfv cfv cA cH cpj
      cfv cfv cB cH cpj cfv cfv cva co cA c0v cva co cA cA chil wcel cB chil
      wcel cA cB cva co cH cpj cfv cfv cA cH cpj cfv cfv cB cH cpj cfv cfv cva
      co wceq cA cH wcel cB cH cort cfv wcel cA cB cH pjfn.1 pjaddi cA cH
      pjfn.1 cheli cB cH cort cfv cH pjfn.1 choccli cheli syl2an cA cH wcel cB
      cH cort cfv wcel cA cH cpj cfv cfv cA cB cH cpj cfv cfv c0v cva cH cch
      wcel cA cH wcel cA cH cpj cfv cfv cA wceq pjfn.1 cA cH pjid mpan cB cH
      cort cfv wcel cB cH cpj cfv cfv c0v wceq cB cH cort cfv wcel cB chil wcel
      cB cH cort cfv wcel cB cH cpj cfv cfv c0v wceq wb cB cH cort cfv cH
      pjfn.1 choccli cheli cH cch wcel cB chil wcel cB cH cort cfv wcel cB cH
      cpj cfv cfv c0v wceq wb pjfn.1 cB cH pjoc2 mpan syl ibi opreqan12d cA cH
      wcel cA c0v cva co cA wceq cB cH cort cfv wcel cA cH wcel cA chil wcel cA
      c0v cva co cA wceq cA cH pjfn.1 cheli cA ax-hvaddid syl adantr 3eqtrd $.
      $( [28-Nov-2000] $)
  $}

  $( A projection maps onto its subspace. $)
  pjfo $p |- ( H e. CH -> ( proj ` H ) : ~H -onto-> H ) $=
    cH cch wcel chil cH cH cpj cfv wfo chil cH cH cch wcel cH c0h cif cpj cfv
    wfo chil cH cch wcel cH c0h cif cH cch wcel cH c0h cif cpj cfv wfo cH cH
    c0h c0h cH cH cch wcel cH c0h cif wceq cH cpj cfv cH cch wcel cH c0h cif
    cpj cfv wceq chil cH cH cpj cfv wfo chil cH cH cch wcel cH c0h cif cpj cfv
    wfo wb cH cH cch wcel cH c0h cif cpj fveq2 chil cH cH cpj cfv cH cch wcel
    cH c0h cif cpj cfv foeq1 syl cH cH cch wcel cH c0h cif chil cH cch wcel cH
    c0h cif cpj cfv foeq3 cH cch wcel cH c0h cif cH c0h cch h0elch elimel pjfoi
    dedth2v $.
    $( [17-May-2006] $) $( [24-Apr-2006] $)

  $( The range of a projection.  Part of Theorem 26.2 of [Halmos] p. 44. $)
  pjrn $p |- ( H e. CH -> ran ( proj ` H ) = H ) $=
    cH cch wcel chil cH cH cpj cfv wfo cH cpj cfv crn cH wceq cH pjfo chil cH
    cH cpj cfv forn syl $.
    $( [20-May-2006] $) $( [24-Apr-2006] $)

  $( The mapping of a projection. $)
  pjf $p |- ( H e. CH -> ( proj ` H ) : ~H --> ~H ) $=
    chil cH cH cpj cfv wf cH chil wss chil chil cH cpj cfv wf cH cch wcel chil
    cH chil cH cpj cfv fss cH cch wcel chil cH cH cpj cfv wfo chil cH cH cpj
    cfv wf cH pjfo chil cH cH cpj cfv fof syl cH chss sylanc $.
    $( [22-May-2006] $) $( [24-Apr-2006] $)

  $( Functionality of a projection. $)
  pjfn $p |- ( H e. CH -> ( proj ` H ) Fn ~H ) $=
    cH cch wcel chil chil cH cpj cfv wf cH cpj cfv chil wfn cH pjf chil chil cH
    cpj cfv ffn syl $.
    $( [1-Jul-2006] $) $( [30-May-2006] $)

  ${
    pjsumt.1 $e |- G e. CH $.
    pjsumt.2 $e |- H e. CH $.
    $( The projection on a subspace sum is the sum of the projections. $)
    pjsumi $p |- ( A e. ~H ->
            ( G C_ ( _|_ ` H ) -> ( ( proj ` ( G +H H ) ) ` A ) =
            ( ( ( proj ` G ) ` A ) +h ( ( proj ` H ) ` A ) ) ) ) $=
      cA chil wcel cG cH cort cfv wss cA cG cH cph co cpj cfv cfv cA cG cpj cfv
      cfv cA cH cpj cfv cfv cva co wceq cA chil wcel cG cH cort cfv wss wa cA
      cG cH cph co cpj cfv cfv cA cG cH chj co cpj cfv cfv cA cG cpj cfv cfv cA
      cH cpj cfv cfv cva co cG cH cort cfv wss cA cG cH cph co cpj cfv cfv cA
      cG cH chj co cpj cfv cfv wceq cA chil wcel cG cH cort cfv wss cA cG cH
      cph co cpj cfv cG cH chj co cpj cfv cG cH cort cfv wss cG cH cph co cG cH
      chj co cpj cG cH pjsumt.1 pjsumt.2 osumi fveq2d fveq1d adantl cA chil
      wcel cG cH cort cfv wss cA cG cH chj co cpj cfv cfv cA cG cpj cfv cfv cA
      cH cpj cfv cfv cva co wceq cG cch wcel cH cch wcel cA chil wcel cG cH
      cort cfv wss cA cG cH chj co cpj cfv cfv cA cG cpj cfv cfv cA cH cpj cfv
      cfv cva co wceq wi pjsumt.1 pjsumt.2 cA cH cG pjcjt2 mp3an12 imp eqtrd ex
      $.
      $( [11-Nov-2000] $)

    $( One-to-one correspondence of projection and subspace. $)
    pj11i $p |- ( ( proj ` G ) = ( proj ` H ) <-> G = H ) $=
      cG cpj cfv cH cpj cfv wceq cG cH wceq cG cpj cfv cH cpj cfv wceq cG cpj
      cfv crn cH cpj cfv crn cG cH cG cpj cfv cH cpj cfv rneq cG pjsumt.1 pjrni
      cH pjsumt.2 pjrni 3eqtr3g cG cH cpj fveq2 impbii $.
      $( [26-Nov-2000] $)

    $( Vector decomposition into sum of projections on orthogonal subspaces. $)
    pjdsi $p |- ( ( A e. ( G vH H ) /\ G C_ ( _|_ ` H ) ) ->
               A = ( ( ( proj ` G ) ` A ) +h ( ( proj ` H ) ` A ) ) ) $=
      cA cG cH chj co wcel cG cH cort cfv wss wa cA cG cH cph co cpj cfv cfv cA
      cA cG cpj cfv cfv cA cH cpj cfv cfv cva co cG cH cort cfv wss cA cG cH
      chj co wcel cA cG cH cph co cpj cfv cfv cA cG cH chj co cpj cfv cfv cA cG
      cH cort cfv wss cA cG cH cph co cpj cfv cG cH chj co cpj cfv cG cH cort
      cfv wss cG cH cph co cG cH chj co cpj cG cH pjsumt.1 pjsumt.2 osumi
      fveq2d fveq1d cG cH chj co cch wcel cA cG cH chj co wcel cA cG cH chj co
      cpj cfv cfv cA wceq cG cH pjsumt.1 pjsumt.2 chjcli cA cG cH chj co pjid
      mpan sylan9eqr cA chil wcel cG cH cort cfv wss cA cG cH cph co cpj cfv
      cfv cA cG cpj cfv cfv cA cH cpj cfv cfv cva co wceq cA cG cH chj co wcel
      cA chil wcel cG cH cort cfv wss cA cG cH cph co cpj cfv cfv cA cG cpj cfv
      cfv cA cH cpj cfv cfv cva co wceq cA cG cH pjsumt.1 pjsumt.2 pjsumi imp
      cA cG cH chj co cG cH pjsumt.1 pjsumt.2 chjcli cheli sylan eqtr3d $.
      $( [22-Jun-2006] $) $( [21-Jun-2006] $)
  $}

  ${
    pjds3.1 $e |- F e. CH $.
    pjds3.2 $e |- G e. CH $.
    pjds3.3 $e |- H e. CH $.
    $( Vector decomposition into sum of projections on orthogonal subspaces. $)
    pjds3i $p |- ( ( ( A e.  ( ( F vH G ) vH H ) /\ F C_ ( _|_ ` G ) ) /\
     ( F C_ ( _|_ ` H ) /\ G C_ ( _|_ ` H ) ) ) -> A = ( ( ( ( proj ` F ) ` A )
                +h ( ( proj ` G ) ` A ) ) +h ( ( proj ` H ) ` A ) ) ) $=
      cA cF cG chj co cH chj co wcel cF cG cort cfv wss wa cF cH cort cfv wss
      cG cH cort cfv wss wa wa cA cA cF cG chj co cpj cfv cfv cA cH cpj cfv cfv
      cva co cA cF cG cph co cpj cfv cfv cA cH cpj cfv cfv cva co cA cF cpj cfv
      cfv cA cG cpj cfv cfv cva co cA cH cpj cfv cfv cva co cA cF cG chj co cH
      chj co wcel cF cG chj co cH cort cfv wss cA cA cF cG chj co cpj cfv cfv
      cA cH cpj cfv cfv cva co wceq cA cF cG chj co cH chj co wcel cF cG cort
      cfv wss wa cF cH cort cfv wss cG cH cort cfv wss wa cA cF cG chj co cH cF
      cG pjds3.1 pjds3.2 chjcli pjds3.3 pjdsi cA cF cG chj co cH chj co wcel cF
      cG cort cfv wss pm3.26 cF cG cH cort cfv pjds3.1 pjds3.2 cH pjds3.3
      choccli chlubii syl2an cF cG cort cfv wss cA cF cG cph co cpj cfv cfv cA
      cH cpj cfv cfv cva co cA cF cG chj co cpj cfv cfv cA cH cpj cfv cfv cva
      co wceq cA cF cG chj co cH chj co wcel cF cH cort cfv wss cG cH cort cfv
      wss wa cF cG cort cfv wss cA cF cG cph co cpj cfv cfv cA cF cG chj co cpj
      cfv cfv cA cH cpj cfv cfv cva cF cG cort cfv wss cA cF cG cph co cpj cfv
      cF cG chj co cpj cfv cF cG cort cfv wss cF cG cph co cF cG chj co cpj cF
      cG pjds3.1 pjds3.2 osumi fveq2d fveq1d opreq1d ad2antlr cA cF cG chj co
      cH chj co wcel cF cG cort cfv wss wa cA cF cG cph co cpj cfv cfv cA cH
      cpj cfv cfv cva co cA cF cpj cfv cfv cA cG cpj cfv cfv cva co cA cH cpj
      cfv cfv cva co wceq cF cH cort cfv wss cG cH cort cfv wss wa cA cF cG chj
      co cH chj co wcel cF cG cort cfv wss wa cA cF cG cph co cpj cfv cfv cA cF
      cpj cfv cfv cA cG cpj cfv cfv cva co cA cH cpj cfv cfv cva cA chil wcel
      cF cG cort cfv wss cA cF cG cph co cpj cfv cfv cA cF cpj cfv cfv cA cG
      cpj cfv cfv cva co wceq cA cF cG chj co cH chj co wcel cA chil wcel cF cG
      cort cfv wss cA cF cG cph co cpj cfv cfv cA cF cpj cfv cfv cA cG cpj cfv
      cfv cva co wceq cA cF cG pjds3.1 pjds3.2 pjsumi imp cA cF cG chj co cH
      chj co cF cG chj co cH cF cG pjds3.1 pjds3.2 chjcli pjds3.3 chjcli cheli
      sylan opreq1d adantr 3eqtr2d $.
      $( [22-Jun-2006] $) $( [22-Jun-2006] $)
  $}

  $( One-to-one correspondence of projection and subspace. $)
  pj11 $p |- ( ( G e. CH /\ H e. CH ) ->
              ( ( proj ` G ) = ( proj ` H ) <-> G = H ) ) $=
    cG cch wcel cH cch wcel cG cpj cfv cH cpj cfv wceq cG cH wceq wb cG cch
    wcel cG c0h cif cpj cfv cH cpj cfv wceq cG cch wcel cG c0h cif cH wceq wb
    cG cch wcel cG c0h cif cpj cfv cH cch wcel cH c0h cif cpj cfv wceq cG cch
    wcel cG c0h cif cH cch wcel cH c0h cif wceq wb cG cH c0h c0h cG cG cch wcel
    cG c0h cif wceq cG cpj cfv cH cpj cfv wceq cG cch wcel cG c0h cif cpj cfv
    cH cpj cfv wceq cG cH wceq cG cch wcel cG c0h cif cH wceq cG cG cch wcel cG
    c0h cif wceq cG cpj cfv cG cch wcel cG c0h cif cpj cfv cH cpj cfv cG cG cch
    wcel cG c0h cif cpj fveq2 eqeq1d cG cG cch wcel cG c0h cif cH eqeq1 bibi12d
    cH cH cch wcel cH c0h cif wceq cG cch wcel cG c0h cif cpj cfv cH cpj cfv
    wceq cG cch wcel cG c0h cif cpj cfv cH cch wcel cH c0h cif cpj cfv wceq cG
    cch wcel cG c0h cif cH wceq cG cch wcel cG c0h cif cH cch wcel cH c0h cif
    wceq cH cH cch wcel cH c0h cif wceq cH cpj cfv cH cch wcel cH c0h cif cpj
    cfv cG cch wcel cG c0h cif cpj cfv cH cH cch wcel cH c0h cif cpj fveq2
    eqeq2d cH cH cch wcel cH c0h cif cG cch wcel cG c0h cif eqeq2 bibi12d cG
    cch wcel cG c0h cif cH cch wcel cH c0h cif cG c0h cch h0elch elimel cH c0h
    cch h0elch elimel pj11i dedth2h $.
    $( [23-May-2006] $) $( [24-Apr-2006] $)

  ${
    $d f h w x y z $.
    $( Functionality of the projection function. $)
    pjmfn $p |- proj Fn CH $=
      vh vf cch vx cv chil wcel vy cv vx cv vz cv vw cv cva co wceq vw vh cv
      cort cfv wrex vz vh cv crab cuni wceq wa vx vy copab cpj vx vy chil vx cv
      vz cv vw cv cva co wceq vw vh cv cort cfv wrex vz vh cv crab cuni
      ax-hilex opabex2 vx vy vz vw vf vh df-pj fnopab2 $.
      $( [26-May-2006] $) $( [24-Apr-2006] $)

    $( The projector function maps one-to-one into the set of Hilbert space
       operators. $)
    pjmf1 $p |- proj : CH -1-1-> ( ~H ^m ~H ) $=
      cch chil chil cm co cpj wf1 cch chil chil cm co cpj wf vx cv cpj cfv vy
      cv cpj cfv wceq vx cv vy cv wceq wi vy cch wral vx cch wral vx vy cch
      chil chil cm co cpj dff13 cch chil chil cm co cpj wf cpj cch wfn vx cv
      cpj cfv chil chil cm co wcel vx cch wral vx cch chil chil cm co cpj ffnfv
      pjmfn vx cv cpj cfv chil chil cm co wcel vx cch vx cv cch wcel chil chil
      vx cv cpj cfv wf vx cv cpj cfv chil chil cm co wcel vx cv pjf chil chil
      vx cv cpj cfv ax-hilex ax-hilex elmap sylibr rgen mpbir2an vx cv cpj cfv
      vy cv cpj cfv wceq vx cv vy cv wceq wi vx vy cch vx cv cch wcel vy cv cch
      wcel wa vx cv cpj cfv vy cv cpj cfv wceq vx cv vy cv wceq vx cv vy cv
      pj11 biimpd rgen2a mpbir2an $.
      $( [14-Oct-2006] $) $( [24-Apr-2006] $)
  $}

  $( The inner product of projections on orthogonal subspaces vanishes. $)
  pjoi0 $p |- ( ( ( G e. CH /\ H e. CH /\ A e. ~H )  /\ G C_ ( _|_ ` H ) ) ->
               ( ( ( proj ` G ) ` A ) .ih ( ( proj ` H ) ` A ) ) = 0 ) $=
    cG cch wcel cH cch wcel cA chil wcel w3a cG cH cort cfv wss cG cpj cfv crn
    cH cpj cfv crn cort cfv wss cA cG cpj cfv cfv cA cH cpj cfv cfv csp co cc0
    wceq cG cch wcel cH cch wcel cG cH cort cfv wss cG cpj cfv crn cH cpj cfv
    crn cort cfv wss cA chil wcel cG cch wcel cH cch wcel wa cG cpj cfv crn cH
    cpj cfv crn cort cfv wss cG cH cort cfv wss cG cch wcel cH cch wcel wa cG
    cpj cfv crn cG cH cpj cfv crn cort cfv cH cort cfv cG cch wcel cG cpj cfv
    crn cG wceq cH cch wcel cG pjrn adantr cH cch wcel cH cpj cfv crn cort cfv
    cH cort cfv wceq cG cch wcel cH cch wcel cH cpj cfv crn cH cort cH pjrn
    fveq2d adantl sseq12d biimpar 3adantl3 cH cpj cfv crn csh wcel cG cpj cfv
    crn cH cpj cfv crn cort cfv wss cA cG cpj cfv cfv cG cpj cfv crn wcel cA cH
    cpj cfv cfv cH cpj cfv crn wcel wa cA cG cpj cfv cfv cA cH cpj cfv cfv csp
    co cc0 wceq cG cch wcel cH cch wcel cA chil wcel w3a cG cpj cfv crn cH cpj
    cfv crn cort cfv wss wa cH cpj cfv crn csh wcel cG cpj cfv crn cH cpj cfv
    crn cort cfv wss cA cG cpj cfv cfv cG cpj cfv crn wcel cA cH cpj cfv cfv cH
    cpj cfv crn wcel wa cA cG cpj cfv cfv cA cH cpj cfv cfv csp co cc0 wceq cA
    cG cpj cfv cfv cA cH cpj cfv cfv cG cpj cfv crn cH cpj cfv crn shorth 3imp
    cG cch wcel cH cch wcel cA chil wcel w3a cH cpj cfv crn csh wcel cG cpj cfv
    crn cH cpj cfv crn cort cfv wss cH cch wcel cG cch wcel cH cpj cfv crn csh
    wcel cA chil wcel cH cch wcel cH cpj cfv crn cch wcel cH cpj cfv crn csh
    wcel cH cch wcel cH cpj cfv crn cH cch cH pjrn cH cch wcel id eqeltrd cH
    cpj cfv crn chsh syl 3ad2ant2 adantr cG cch wcel cH cch wcel cA chil wcel
    w3a cG cpj cfv crn cH cpj cfv crn cort cfv wss pm3.27 cG cch wcel cH cch
    wcel cA chil wcel w3a cA cG cpj cfv cfv cG cpj cfv crn wcel cA cH cpj cfv
    cfv cH cpj cfv crn wcel wa cG cpj cfv crn cH cpj cfv crn cort cfv wss cG
    cch wcel cH cch wcel cA chil wcel w3a cA cG cpj cfv cfv cG cpj cfv crn wcel
    cA cH cpj cfv cfv cH cpj cfv crn wcel cG cch wcel cA chil wcel cA cG cpj
    cfv cfv cG cpj cfv crn wcel cH cch wcel cG cpj cfv chil wfn cA chil wcel cA
    cG cpj cfv cfv cG cpj cfv crn wcel cG cch wcel chil cA cG cpj cfv fnfvelrn
    cG pjfn sylan 3adant2 cH cch wcel cA chil wcel cA cH cpj cfv cfv cH cpj cfv
    crn wcel cG cch wcel cH cpj cfv chil wfn cA chil wcel cA cH cpj cfv cfv cH
    cpj cfv crn wcel cH cch wcel chil cA cH cpj cfv fnfvelrn cH pjfn sylan
    3adant1 jca adantr syl3anc syldan $.
    $( [1-Jul-2006] $) $( [30-Jun-2006] $)

  ${
    pjoi0.1 $e |- G e. CH $.
    pjoi0.2 $e |- H e. CH $.
    pjoi0.3 $e |- A e. ~H $.
    $( The inner product of projections on orthogonal subspaces vanishes. $)
    pjoi0i $p |- ( G C_ ( _|_ ` H ) ->
                ( ( ( proj ` G ) ` A ) .ih ( ( proj ` H ) ` A ) ) = 0 ) $=
      cG cch wcel cH cch wcel cA chil wcel w3a cG cH cort cfv wss cA cG cpj cfv
      cfv cA cH cpj cfv cfv csp co cc0 wceq cG cch wcel cH cch wcel cA chil
      wcel pjoi0.1 pjoi0.2 pjoi0.3 3pm3.2i cA cG cH pjoi0 mpan $.
      $( [1-Nov-1999] $)

    $( Pythagorean theorem for projections on orthogonal subspaces. $)
    pjopythi $p |- ( G C_ ( _|_ ` H ) ->
       ( ( normh ` ( ( ( proj ` G ) ` A ) +h ( ( proj ` H ) ` A ) ) ) ^ 2 ) =
                 ( ( ( normh ` ( ( proj ` G ) ` A ) ) ^ 2 ) +
                   ( ( normh ` ( ( proj ` H ) ` A ) ) ^ 2 ) ) ) $=
      cG cH cort cfv wss cA cG cpj cfv cfv cA cH cpj cfv cfv csp co cc0 wceq cA
      cG cpj cfv cfv cA cH cpj cfv cfv cva co cno cfv c2 cexp co cA cG cpj cfv
      cfv cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co caddc co wceq
      cA cG cH pjoi0.1 pjoi0.2 pjoi0.3 pjoi0i cA cG cpj cfv cfv cA cH cpj cfv
      cfv cA cG pjoi0.1 pjoi0.3 pjhclii cA cH pjoi0.2 pjoi0.3 pjhclii normpythi
      syl $.
      $( [1-Nov-1999] $)
  $}

  $( Pythagorean theorem for projections on orthogonal subspaces. $)
  pjopyth $p |- ( ( H e. CH /\ G e. CH /\ A e. ~H ) -> ( H C_ ( _|_ ` G ) ->
       ( ( normh ` ( ( ( proj ` H ) ` A ) +h ( ( proj ` G ) ` A ) ) ) ^ 2 ) =
                 ( ( ( normh ` ( ( proj ` H ) ` A ) ) ^ 2 ) +
                   ( ( normh ` ( ( proj ` G ) ` A ) ) ^ 2 ) ) ) ) $=
    cH cch wcel cG cch wcel cA chil wcel cH cG cort cfv wss cA cH cpj cfv cfv
    cA cG cpj cfv cfv cva co cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2
    cexp co cA cG cpj cfv cfv cno cfv c2 cexp co caddc co wceq wi cH cch wcel
    cH chil cif cG cort cfv wss cA cH cch wcel cH chil cif cpj cfv cfv cA cG
    cpj cfv cfv cva co cno cfv c2 cexp co cA cH cch wcel cH chil cif cpj cfv
    cfv cno cfv c2 cexp co cA cG cpj cfv cfv cno cfv c2 cexp co caddc co wceq
    wi cH cG cA chil chil c0v cH cch wcel cH chil cif cG cch wcel cG chil cif
    cort cfv wss cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil
    cif cpj cfv cfv cva co cno cfv c2 cexp co cA cH cch wcel cH chil cif cpj
    cfv cfv cno cfv c2 cexp co cA cG cch wcel cG chil cif cpj cfv cfv cno cfv
    c2 cexp co caddc co wceq wi cH cch wcel cH chil cif cG cch wcel cG chil cif
    cort cfv wss cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA
    chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cva co cno cfv c2
    cexp co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cno cfv
    c2 cexp co cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cno
    cfv c2 cexp co caddc co wceq wi cH cH cch wcel cH chil cif wceq cH cG cort
    cfv wss cH cch wcel cH chil cif cG cort cfv wss cA cH cpj cfv cfv cA cG cpj
    cfv cfv cva co cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cA
    cG cpj cfv cfv cno cfv c2 cexp co caddc co wceq cA cH cch wcel cH chil cif
    cpj cfv cfv cA cG cpj cfv cfv cva co cno cfv c2 cexp co cA cH cch wcel cH
    chil cif cpj cfv cfv cno cfv c2 cexp co cA cG cpj cfv cfv cno cfv c2 cexp
    co caddc co wceq cH cH cch wcel cH chil cif cG cort cfv sseq1 cH cH cch
    wcel cH chil cif wceq cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cno cfv c2
    cexp co cA cH cch wcel cH chil cif cpj cfv cfv cA cG cpj cfv cfv cva co cno
    cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cA cG cpj cfv cfv cno
    cfv c2 cexp co caddc co cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2
    cexp co cA cG cpj cfv cfv cno cfv c2 cexp co caddc co cH cH cch wcel cH
    chil cif wceq cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cno cfv cA cH cch
    wcel cH chil cif cpj cfv cfv cA cG cpj cfv cfv cva co cno cfv c2 cexp cH cH
    cch wcel cH chil cif wceq cA cH cpj cfv cfv cA cG cpj cfv cfv cva co cA cH
    cch wcel cH chil cif cpj cfv cfv cA cG cpj cfv cfv cva co cno cH cH cch
    wcel cH chil cif wceq cA cH cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv
    cfv cA cG cpj cfv cfv cva cH cH cch wcel cH chil cif wceq cA cH cpj cfv cH
    cch wcel cH chil cif cpj cfv cH cH cch wcel cH chil cif cpj fveq2 fveq1d
    opreq1d fveq2d opreq1d cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv
    cno cfv c2 cexp co cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp
    co cA cG cpj cfv cfv cno cfv c2 cexp co caddc cH cH cch wcel cH chil cif
    wceq cA cH cpj cfv cfv cno cfv cA cH cch wcel cH chil cif cpj cfv cfv cno
    cfv c2 cexp cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cA cH cch
    wcel cH chil cif cpj cfv cfv cno cH cH cch wcel cH chil cif wceq cA cH cpj
    cfv cH cch wcel cH chil cif cpj cfv cH cH cch wcel cH chil cif cpj fveq2
    fveq1d fveq2d opreq1d opreq1d eqeq12d imbi12d cG cG cch wcel cG chil cif
    wceq cH cch wcel cH chil cif cG cort cfv wss cH cch wcel cH chil cif cG cch
    wcel cG chil cif cort cfv wss cA cH cch wcel cH chil cif cpj cfv cfv cA cG
    cpj cfv cfv cva co cno cfv c2 cexp co cA cH cch wcel cH chil cif cpj cfv
    cfv cno cfv c2 cexp co cA cG cpj cfv cfv cno cfv c2 cexp co caddc co wceq
    cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil cif cpj cfv
    cfv cva co cno cfv c2 cexp co cA cH cch wcel cH chil cif cpj cfv cfv cno
    cfv c2 cexp co cA cG cch wcel cG chil cif cpj cfv cfv cno cfv c2 cexp co
    caddc co wceq cG cG cch wcel cG chil cif wceq cG cort cfv cG cch wcel cG
    chil cif cort cfv cH cch wcel cH chil cif cG cG cch wcel cG chil cif cort
    fveq2 sseq2d cG cG cch wcel cG chil cif wceq cA cH cch wcel cH chil cif cpj
    cfv cfv cA cG cpj cfv cfv cva co cno cfv c2 cexp co cA cH cch wcel cH chil
    cif cpj cfv cfv cA cG cch wcel cG chil cif cpj cfv cfv cva co cno cfv c2
    cexp co cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA cG cpj
    cfv cfv cno cfv c2 cexp co caddc co cA cH cch wcel cH chil cif cpj cfv cfv
    cno cfv c2 cexp co cA cG cch wcel cG chil cif cpj cfv cfv cno cfv c2 cexp
    co caddc co cG cG cch wcel cG chil cif wceq cA cH cch wcel cH chil cif cpj
    cfv cfv cA cG cpj cfv cfv cva co cno cfv cA cH cch wcel cH chil cif cpj cfv
    cfv cA cG cch wcel cG chil cif cpj cfv cfv cva co cno cfv c2 cexp cG cG cch
    wcel cG chil cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cA cG cpj cfv
    cfv cva co cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil
    cif cpj cfv cfv cva co cno cG cG cch wcel cG chil cif wceq cA cG cpj cfv
    cfv cA cG cch wcel cG chil cif cpj cfv cfv cA cH cch wcel cH chil cif cpj
    cfv cfv cva cG cG cch wcel cG chil cif wceq cA cG cpj cfv cG cch wcel cG
    chil cif cpj cfv cG cG cch wcel cG chil cif cpj fveq2 fveq1d opreq2d fveq2d
    opreq1d cG cG cch wcel cG chil cif wceq cA cG cpj cfv cfv cno cfv c2 cexp
    co cA cG cch wcel cG chil cif cpj cfv cfv cno cfv c2 cexp co cA cH cch wcel
    cH chil cif cpj cfv cfv cno cfv c2 cexp co caddc cG cG cch wcel cG chil cif
    wceq cA cG cpj cfv cfv cno cfv cA cG cch wcel cG chil cif cpj cfv cfv cno
    cfv c2 cexp cG cG cch wcel cG chil cif wceq cA cG cpj cfv cfv cA cG cch
    wcel cG chil cif cpj cfv cfv cno cG cG cch wcel cG chil cif wceq cA cG cpj
    cfv cG cch wcel cG chil cif cpj cfv cG cG cch wcel cG chil cif cpj fveq2
    fveq1d fveq2d opreq1d opreq2d eqeq12d imbi12d cA cA chil wcel cA c0v cif
    wceq cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil cif cpj
    cfv cfv cva co cno cfv c2 cexp co cA cH cch wcel cH chil cif cpj cfv cfv
    cno cfv c2 cexp co cA cG cch wcel cG chil cif cpj cfv cfv cno cfv c2 cexp
    co caddc co wceq cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv
    cfv cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cva co cno
    cfv c2 cexp co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv
    cno cfv c2 cexp co cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv
    cfv cno cfv c2 cexp co caddc co wceq cH cch wcel cH chil cif cG cch wcel cG
    chil cif cort cfv wss cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH
    chil cif cpj cfv cfv cA cG cch wcel cG chil cif cpj cfv cfv cva co cno cfv
    c2 cexp co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA
    chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cva co cno cfv c2
    cexp co cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA cG cch
    wcel cG chil cif cpj cfv cfv cno cfv c2 cexp co caddc co cA chil wcel cA
    c0v cif cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA chil wcel
    cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cno cfv c2 cexp co caddc co
    cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cA
    cG cch wcel cG chil cif cpj cfv cfv cva co cno cfv cA chil wcel cA c0v cif
    cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v cif cG cch wcel cG
    chil cif cpj cfv cfv cva co cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq
    cA cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil cif cpj cfv
    cfv cva co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA
    chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cva co cno cA cA
    chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cA chil
    wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cA cG cch wcel cG chil
    cif cpj cfv cfv cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv
    cva cA cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv fveq2 cA cA
    chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv fveq2 opreq12d fveq2d
    opreq1d cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv
    cfv cno cfv c2 cexp co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj
    cfv cfv cno cfv c2 cexp co cA cG cch wcel cG chil cif cpj cfv cfv cno cfv
    c2 cexp co cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv cfv cno
    cfv c2 cexp co caddc cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil
    cif cpj cfv cfv cno cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj
    cfv cfv cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH
    chil cif cpj cfv cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj
    cfv cfv cno cA cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv
    fveq2 fveq2d opreq1d cA cA chil wcel cA c0v cif wceq cA cG cch wcel cG chil
    cif cpj cfv cfv cno cfv cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj
    cfv cfv cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq cA cG cch wcel cG
    chil cif cpj cfv cfv cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj
    cfv cfv cno cA cA chil wcel cA c0v cif cG cch wcel cG chil cif cpj cfv
    fveq2 fveq2d opreq1d opreq12d eqeq12d imbi2d cA chil wcel cA c0v cif cH cch
    wcel cH chil cif cG cch wcel cG chil cif cH chil cch helch elimel cG chil
    cch helch elimel cA c0v chil ax-hv0cl elimel pjopythi dedth3h $.
    $( [2-Nov-1999] $)

  ${
    pjnorm.1 $e |- H e. CH $.
    pjnorm.2 $e |- A e. ~H $.
    $( The norm of the projection is less than or equal to the norm. $)
    pjnormi $p |- ( normh ` ( ( proj ` H ) ` A ) ) <_ ( normh ` A ) $=
      cA cH cpj cfv cfv cno cfv cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv
      cva co cno cfv cA cno cfv cle cA cH cpj cfv cfv chil wcel cA cH cort cfv
      cpj cfv cfv chil wcel wa cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv csp
      co cc0 wceq cA cH cpj cfv cfv cno cfv cA cH cpj cfv cfv cA cH cort cfv
      cpj cfv cfv cva co cno cfv cle wbr cA cH cpj cfv cfv chil wcel cA cH cort
      cfv cpj cfv cfv chil wcel cA cH pjnorm.1 pjnorm.2 pjhclii cA cH cort cfv
      cH pjnorm.1 choccli pjnorm.2 pjhclii pm3.2i cH cch wcel cA cH cpj cfv cfv
      cA cH cort cfv cpj cfv cfv csp co cc0 wceq pjnorm.1 cA cA cH pjnorm.2
      pjnorm.2 pjorthi ax-mp cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv
      normpyc mp2 cA cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co cno cA
      cH pjnorm.1 pjnorm.2 pjpji fveq2i breqtrri $.
      $( [27-Oct-1999] $)

    $( Pythagorean theorem for projections. $)
    pjpythi $p |- ( ( normh ` A ) ^ 2 ) =
                 ( ( ( normh ` ( ( proj ` H ) ` A ) ) ^ 2 ) +
                   ( ( normh ` ( ( proj ` ( _|_ ` H ) ) ` A ) ) ^ 2 ) ) $=
      cA cno cfv c2 cexp co cA cH cpj cfv cfv cA cH cort cfv cpj cfv cfv cva co
      cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cA cH cort cfv
      cpj cfv cfv cno cfv c2 cexp co caddc co cA cno cfv cA cH cpj cfv cfv cA
      cH cort cfv cpj cfv cfv cva co cno cfv c2 cexp cA cA cH cpj cfv cfv cA cH
      cort cfv cpj cfv cfv cva co cno cA cH pjnorm.1 pjnorm.2 pjpji fveq2i
      opreq1i cH cH cort cfv cort cfv wss cA cH cpj cfv cfv cA cH cort cfv cpj
      cfv cfv cva co cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cA
      cH cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co wceq cH csh wcel cH
      cH cort cfv cort cfv wss cH pjnorm.1 chshii cH shococss ax-mp cA cH cH
      cort cfv pjnorm.1 cH pjnorm.1 choccli pjnorm.2 pjopythi ax-mp eqtri $.
      $( [27-Oct-1999] $)

    $( If a vector does not belong to subspace, the norm of its projection
       is less than its norm. $)
    pjneli $p |- ( -. A e. H <->
                ( normh ` ( ( proj ` H ) ` A ) ) < ( normh ` A ) ) $=
      cA cno cfv cA cH cpj cfv cfv cno cfv wne cA cH cpj cfv cfv cno cfv cA cno
      cfv cle wbr cA cno cfv cA cH cpj cfv cfv cno cfv wne wa cA cH wcel wn cA
      cH cpj cfv cfv cno cfv cA cno cfv clt wbr cA cH cpj cfv cfv cno cfv cA
      cno cfv cle wbr cA cno cfv cA cH cpj cfv cfv cno cfv wne cA cH pjnorm.1
      pjnorm.2 pjnormi biantrur cA cH wcel cA cno cfv cA cH cpj cfv cfv cno cfv
      cA cH wcel cA cH cort cfv cpj cfv cfv c0v wceq cA cno cfv c2 cexp co cA
      cH cpj cfv cfv cno cfv c2 cexp co wceq cA cno cfv cA cH cpj cfv cfv cno
      cfv wceq cA cH pjnorm.1 pjnorm.2 pjoc1i cA cH cpj cfv cfv cno cfv c2 cexp
      co cA cH cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co cA cH cpj cfv
      cfv cno cfv c2 cexp co cc0 c2 cexp co caddc co wceq cA cH cort cfv cpj
      cfv cfv cno cfv c2 cexp co cc0 c2 cexp co wceq cA cno cfv c2 cexp co cA
      cH cpj cfv cfv cno cfv c2 cexp co wceq cA cH cort cfv cpj cfv cfv c0v
      wceq cA cH cpj cfv cfv cno cfv c2 cexp co cA cH cort cfv cpj cfv cfv cno
      cfv c2 cexp co cc0 c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cA cH
      cpj cfv cfv cno cfv cA cH cpj cfv cfv cA cH pjnorm.1 pjnorm.2 pjhclii
      normcli resqcli recni cA cH cort cfv cpj cfv cfv cno cfv c2 cexp co cA cH
      cort cfv cpj cfv cfv cno cfv cA cH cort cfv cpj cfv cfv cA cH cort cfv cH
      pjnorm.1 choccli pjnorm.2 pjhclii normcli resqcli recni cc0 0cn sqcli
      addcani cA cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cA cH
      cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co cA cH cpj cfv cfv cno
      cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2 cexp co cc0 c2 cexp co caddc
      co cA cH pjnorm.1 pjnorm.2 pjpythi cA cH cpj cfv cfv cno cfv c2 cexp co
      cc0 c2 cexp co caddc co cA cH cpj cfv cfv cno cfv c2 cexp co cc0 caddc co
      cA cH cpj cfv cfv cno cfv c2 cexp co cc0 c2 cexp co cc0 cA cH cpj cfv cfv
      cno cfv c2 cexp co caddc sq0 opreq2i cA cH cpj cfv cfv cno cfv c2 cexp co
      cA cH cpj cfv cfv cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv cA cH cpj
      cfv cfv cA cH pjnorm.1 pjnorm.2 pjhclii normcli resqcli recni addid1i
      eqtr2i eqeq12i cA cH cort cfv cpj cfv cfv cno cfv c2 cexp co cc0 c2 cexp
      co wceq cA cH cort cfv cpj cfv cfv cno cfv cc0 wceq cA cH cort cfv cpj
      cfv cfv c0v wceq cc0 cA cH cort cfv cpj cfv cfv cno cfv cle wbr cc0 cc0
      cle wbr cA cH cort cfv cpj cfv cfv cno cfv c2 cexp co cc0 c2 cexp co wceq
      cA cH cort cfv cpj cfv cfv cno cfv cc0 wceq wb cA cH cort cfv cpj cfv cfv
      chil wcel cc0 cA cH cort cfv cpj cfv cfv cno cfv cle wbr cA cH cort cfv
      cH pjnorm.1 choccli pjnorm.2 pjhclii cA cH cort cfv cpj cfv cfv normge0
      ax-mp cc0 0re leidi cA cH cort cfv cpj cfv cfv cno cfv cc0 cA cH cort cfv
      cpj cfv cfv cA cH cort cfv cH pjnorm.1 choccli pjnorm.2 pjhclii normcli
      0re sq11i mp2an cA cH cort cfv cpj cfv cfv cA cH cort cfv cH pjnorm.1
      choccli pjnorm.2 pjhclii norm-i.i bitr2i 3bitr4ri cc0 cA cno cfv cle wbr
      cc0 cA cH cpj cfv cfv cno cfv cle wbr cA cno cfv c2 cexp co cA cH cpj cfv
      cfv cno cfv c2 cexp co wceq cA cno cfv cA cH cpj cfv cfv cno cfv wceq wb
      cA chil wcel cc0 cA cno cfv cle wbr pjnorm.2 cA normge0 ax-mp cA cH cpj
      cfv cfv chil wcel cc0 cA cH cpj cfv cfv cno cfv cle wbr cA cH pjnorm.1
      pjnorm.2 pjhclii cA cH cpj cfv cfv normge0 ax-mp cA cno cfv cA cH cpj cfv
      cfv cno cfv cA pjnorm.2 normcli cA cH cpj cfv cfv cA cH pjnorm.1 pjnorm.2
      pjhclii normcli sq11i mp2an 3bitri necon3bbii cA cH cpj cfv cfv cno cfv
      cA cno cfv cA cH cpj cfv cfv cA cH pjnorm.1 pjnorm.2 pjhclii normcli cA
      pjnorm.2 normcli ltleni 3bitr4i $.
      $( [27-Oct-1999] $)
  $}

  $( The norm of the projection is less than or equal to the norm. $)
  pjnorm $p |- ( ( H e. CH /\ A e. ~H ) ->
                ( normh ` ( ( proj ` H ) ` A ) ) <_ ( normh ` A ) ) $=
    cH cch wcel cA chil wcel cA cH cpj cfv cfv cno cfv cA cno cfv cle wbr cA cH
    cch wcel cH chil cif cpj cfv cfv cno cfv cA cno cfv cle wbr cA chil wcel cA
    c0v cif cH cch wcel cH chil cif cpj cfv cfv cno cfv cA chil wcel cA c0v cif
    cno cfv cle wbr cH cA chil c0v cH cH cch wcel cH chil cif wceq cA cH cpj
    cfv cfv cno cfv cA cH cch wcel cH chil cif cpj cfv cfv cno cfv cA cno cfv
    cle cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cA cH cch wcel cH
    chil cif cpj cfv cfv cno cH cH cch wcel cH chil cif wceq cA cH cpj cfv cH
    cch wcel cH chil cif cpj cfv cH cH cch wcel cH chil cif cpj fveq2 fveq1d
    fveq2d breq1d cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif
    cpj cfv cfv cno cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv
    cfv cno cfv cA cno cfv cA chil wcel cA c0v cif cno cfv cle cA cA chil wcel
    cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cA chil wcel cA c0v
    cif cH cch wcel cH chil cif cpj cfv cfv cno cA cA chil wcel cA c0v cif cH
    cch wcel cH chil cif cpj cfv fveq2 fveq2d cA cA chil wcel cA c0v cif cno
    fveq2 breq12d cA chil wcel cA c0v cif cH cch wcel cH chil cif cH chil cch
    helch elimel cA c0v chil ax-hv0cl elimel pjnormi dedth2h $.
    $( [28-Oct-1999] $)

  $( Pythagorean theorem for projectors. $)
  pjpyth $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( normh ` A ) ^ 2 ) =
               ( ( ( normh ` ( ( proj ` H ) ` A ) ) ^ 2 ) +
                 ( ( normh ` ( ( proj ` ( _|_ ` H ) ) ` A ) ) ^ 2 ) ) ) $=
    cH cch wcel cA chil wcel cA cno cfv c2 cexp co cA cH cpj cfv cfv cno cfv c2
    cexp co cA cH cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co wceq cA cno
    cfv c2 cexp co cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA
    cH cch wcel cH chil cif cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co
    wceq cA chil wcel cA c0v cif cno cfv c2 cexp co cA chil wcel cA c0v cif cH
    cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA chil wcel cA c0v cif
    cH cch wcel cH chil cif cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co
    wceq cH cA chil c0v cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cno
    cfv c2 cexp co cA cH cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co cA cH
    cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA cH cch wcel cH chil
    cif cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co cA cno cfv c2 cexp co
    cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cno cfv c2 cexp co cA cH
    cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA cH cort cfv cpj cfv
    cfv cno cfv c2 cexp co cA cH cch wcel cH chil cif cort cfv cpj cfv cfv cno
    cfv c2 cexp co caddc cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cno
    cfv cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp cH cH cch wcel
    cH chil cif wceq cA cH cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv cfv
    cno cH cH cch wcel cH chil cif wceq cA cH cpj cfv cH cch wcel cH chil cif
    cpj cfv cH cH cch wcel cH chil cif cpj fveq2 fveq1d fveq2d opreq1d cH cH
    cch wcel cH chil cif wceq cA cH cort cfv cpj cfv cfv cno cfv cA cH cch wcel
    cH chil cif cort cfv cpj cfv cfv cno cfv c2 cexp cH cH cch wcel cH chil cif
    wceq cA cH cort cfv cpj cfv cfv cA cH cch wcel cH chil cif cort cfv cpj cfv
    cfv cno cH cH cch wcel cH chil cif wceq cA cH cort cfv cpj cfv cH cch wcel
    cH chil cif cort cfv cpj cfv cH cH cch wcel cH chil cif wceq cH cort cfv cH
    cch wcel cH chil cif cort cfv cpj cH cH cch wcel cH chil cif cort fveq2
    fveq2d fveq1d fveq2d opreq1d opreq12d eqeq2d cA cA chil wcel cA c0v cif
    wceq cA cno cfv c2 cexp co cA chil wcel cA c0v cif cno cfv c2 cexp co cA cH
    cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA cH cch wcel cH chil
    cif cort cfv cpj cfv cfv cno cfv c2 cexp co caddc co cA chil wcel cA c0v
    cif cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp co cA chil wcel cA
    c0v cif cH cch wcel cH chil cif cort cfv cpj cfv cfv cno cfv c2 cexp co
    caddc co cA cA chil wcel cA c0v cif wceq cA cno cfv cA chil wcel cA c0v cif
    cno cfv c2 cexp cA cA chil wcel cA c0v cif cno fveq2 opreq1d cA cA chil
    wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv cfv cno cfv c2 cexp
    co cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cno cfv c2
    cexp co cA cH cch wcel cH chil cif cort cfv cpj cfv cfv cno cfv c2 cexp co
    cA chil wcel cA c0v cif cH cch wcel cH chil cif cort cfv cpj cfv cfv cno
    cfv c2 cexp co caddc cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil
    cif cpj cfv cfv cno cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj
    cfv cfv cno cfv c2 cexp cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH
    chil cif cpj cfv cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj
    cfv cfv cno cA cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv
    fveq2 fveq2d opreq1d cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil
    cif cort cfv cpj cfv cfv cno cfv cA chil wcel cA c0v cif cH cch wcel cH
    chil cif cort cfv cpj cfv cfv cno cfv c2 cexp cA cA chil wcel cA c0v cif
    wceq cA cH cch wcel cH chil cif cort cfv cpj cfv cfv cA chil wcel cA c0v
    cif cH cch wcel cH chil cif cort cfv cpj cfv cfv cno cA cA chil wcel cA c0v
    cif cH cch wcel cH chil cif cort cfv cpj cfv fveq2 fveq2d opreq1d opreq12d
    eqeq12d cA chil wcel cA c0v cif cH cch wcel cH chil cif cH chil cch helch
    elimel cA c0v chil ax-hv0cl elimel pjpythi dedth2h $.
    $( [25-Sep-2006] $) $( [11-Apr-2006] $)

  $( If a vector does not belong to subspace, the norm of its projection
     is less than its norm. $)
  pjnel $p |- ( ( H e. CH /\ A e. ~H ) -> ( -. A e. H <->
              ( normh ` ( ( proj ` H ) ` A ) ) < ( normh ` A ) ) ) $=
    cH cch wcel cA chil wcel cA cH wcel wn cA cH cpj cfv cfv cno cfv cA cno cfv
    clt wbr wb cA cH cch wcel cH chil cif wcel wn cA cH cch wcel cH chil cif
    cpj cfv cfv cno cfv cA cno cfv clt wbr wb cA chil wcel cA c0v cif cH cch
    wcel cH chil cif wcel wn cA chil wcel cA c0v cif cH cch wcel cH chil cif
    cpj cfv cfv cno cfv cA chil wcel cA c0v cif cno cfv clt wbr wb cH cA chil
    c0v cH cH cch wcel cH chil cif wceq cA cH wcel wn cA cH cch wcel cH chil
    cif wcel wn cA cH cpj cfv cfv cno cfv cA cno cfv clt wbr cA cH cch wcel cH
    chil cif cpj cfv cfv cno cfv cA cno cfv clt wbr cH cH cch wcel cH chil cif
    wceq cA cH wcel cA cH cch wcel cH chil cif wcel cH cH cch wcel cH chil cif
    cA eleq2 notbid cH cH cch wcel cH chil cif wceq cA cH cpj cfv cfv cno cfv
    cA cH cch wcel cH chil cif cpj cfv cfv cno cfv cA cno cfv clt cH cH cch
    wcel cH chil cif wceq cA cH cpj cfv cfv cA cH cch wcel cH chil cif cpj cfv
    cfv cno cH cH cch wcel cH chil cif wceq cA cH cpj cfv cH cch wcel cH chil
    cif cpj cfv cH cH cch wcel cH chil cif cpj fveq2 fveq1d fveq2d breq1d
    bibi12d cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif wcel wn
    cA chil wcel cA c0v cif cH cch wcel cH chil cif wcel wn cA cH cch wcel cH
    chil cif cpj cfv cfv cno cfv cA cno cfv clt wbr cA chil wcel cA c0v cif cH
    cch wcel cH chil cif cpj cfv cfv cno cfv cA chil wcel cA c0v cif cno cfv
    clt wbr cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif wcel cA
    chil wcel cA c0v cif cH cch wcel cH chil cif wcel cA cA chil wcel cA c0v
    cif cH cch wcel cH chil cif eleq1 notbid cA cA chil wcel cA c0v cif wceq cA
    cH cch wcel cH chil cif cpj cfv cfv cno cfv cA chil wcel cA c0v cif cH cch
    wcel cH chil cif cpj cfv cfv cno cfv cA cno cfv cA chil wcel cA c0v cif cno
    cfv clt cA cA chil wcel cA c0v cif wceq cA cH cch wcel cH chil cif cpj cfv
    cfv cA chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv cfv cno cA cA
    chil wcel cA c0v cif cH cch wcel cH chil cif cpj cfv fveq2 fveq2d cA cA
    chil wcel cA c0v cif cno fveq2 breq12d bibi12d cA chil wcel cA c0v cif cH
    cch wcel cH chil cif cH chil cch helch elimel cA c0v chil ax-hv0cl elimel
    pjneli dedth2h $.
    $( [2-Nov-1999] $)

  $( A vector belongs to the subspace of a projection iff the norm of its
     projection equals its norm.  This and ~ pjch yield Theorem 26.3 of
     [Halmos] p. 44. $)
  pjnorm2 $p |- ( ( H e. CH /\ A e. ~H ) -> ( A e. H <->
              ( normh ` ( ( proj ` H ) ` A ) ) = ( normh ` A ) ) ) $=
    cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cno cfv cA cno cfv wceq cA cH
    cpj cfv cfv cno cfv cA cno cfv cle wbr cA cH cpj cfv cfv cno cfv cA cno cfv
    clt wbr wn wa cA cH cpj cfv cfv cno cfv cA cno cfv clt wbr wn cA cH wcel cA
    cH cpj cfv cfv cno cfv cr wcel cA cno cfv cr wcel cA cH cpj cfv cfv cno cfv
    cA cno cfv wceq cA cH cpj cfv cfv cno cfv cA cno cfv cle wbr cA cH cpj cfv
    cfv cno cfv cA cno cfv clt wbr wn wa wb cH cch wcel cA chil wcel wa cA cH
    cpj cfv cfv cno cfv cA cno cfv eqlelt cH cch wcel cA chil wcel wa cA cH cpj
    cfv cfv chil wcel cA cH cpj cfv cfv cno cfv cr wcel cA cH pjhcl cA cH cpj
    cfv cfv normcl syl cA chil wcel cA cno cfv cr wcel cH cch wcel cA normcl
    adantl sylanc cH cch wcel cA chil wcel wa cA cH cpj cfv cfv cno cfv cA cno
    cfv cle wbr cA cH cpj cfv cfv cno cfv cA cno cfv clt wbr wn cA cH pjnorm
    biantrurd cH cch wcel cA chil wcel wa cA cH wcel cA cH cpj cfv cfv cno cfv
    cA cno cfv clt wbr cA cH pjnel con1bid 3bitr2rd $.
    $( [7-Apr-2001] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Mayet's equation E_3
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x B $.  $d x D $.  $d x G $.  $d x X $.  $d x Y $.
    mayete3.a $e |- A e. CH $.
    mayete3.b $e |- B e. CH $.
    mayete3.c $e |- C e. CH $.
    mayete3.d $e |- D e. CH $.
    mayete3.f $e |- F e. CH $.
    mayete3.g $e |- G e. CH $.
    mayete3.ac $e |- A C_ ( _|_ ` C ) $.
    mayete3.af $e |- A C_ ( _|_ ` F ) $.
    mayete3.cf $e |- C C_ ( _|_ ` F ) $.
    mayete3.ab $e |- A C_ ( _|_ ` B ) $.
    mayete3.cd $e |- C C_ ( _|_ ` D ) $.
    mayete3.fg $e |- F C_ ( _|_ ` G ) $.
    mayete3.x $e |- X = ( ( A vH C ) vH F ) $.
    mayete3.y $e |- Y = ( ( ( A vH B ) i^i ( C vH D ) ) i^i ( F vH G ) ) $.
    mayete3.z $e |- Z = ( ( B vH D ) vH G ) $.
    $( Mayet's equation E_3.  Part of Theorem 4.1 of [Mayet3] p. 1223. $)
    mayete3i $p |- ( X i^i Y ) C_ Z $=
      cX cY cin cB cD chj co cG chj co cZ cX cY cin cB cD chj co cG cph co cB
      cD chj co cG chj co cX cY cin cB cD cph co cG cph co cB cD chj co cG cph
      co vx cX cY cin cB cD cph co cG cph co vx cv cX cY cin wcel vx cv c1 c2
      cdiv co c2 vx cv csm co csm co cB cD cph co cG cph co vx cv cX cY cin
      wcel vx cv chil wcel vx cv c1 c2 cdiv co c2 vx cv csm co csm co wceq vx
      cv cX cY cin wcel vx cv cX wcel vx cv cY wcel wa vx cv chil wcel vx cv cX
      cY elin vx cv cX wcel vx cv chil wcel vx cv cY wcel vx cv cX wcel vx cv
      cA cC chj co cF chj co wcel vx cv chil wcel cX cA cC chj co cF chj co vx
      cv mayete3.x eleq2i vx cv cA cC chj co cF chj co cA cC chj co cF cA cC
      mayete3.a mayete3.c chjcli mayete3.f chjcli cheli sylbi adantr sylbi vx
      cv chil wcel c1 vx cv csm co vx cv c1 c2 cdiv co c2 vx cv csm co csm co
      vx cv ax-hvmulid vx cv chil wcel c1 c2 cdiv co c2 cmul co vx cv csm co c1
      c2 cdiv co c2 vx cv csm co csm co c1 vx cv csm co c1 c2 cdiv co cc wcel
      c2 cc wcel vx cv chil wcel c1 c2 cdiv co c2 cmul co vx cv csm co c1 c2
      cdiv co c2 vx cv csm co csm co wceq c2 2cn 2ne0 reccli 2cn c1 c2 cdiv co
      c2 vx cv ax-hvmulass mp3an12 c1 c2 cdiv co c2 cmul co c1 vx cv csm c2 cc
      wcel c2 cc0 wne c1 c2 cdiv co c2 cmul co c1 wceq 2cn 2ne0 c2 recid2 mp2an
      opreq1i syl5eqr eqtr3d syl vx cv cX cY cin wcel c2 vx cv csm co cB cD cph
      co cG cph co wcel c1 c2 cdiv co c2 vx cv csm co csm co cB cD cph co cG
      cph co wcel vx cv cX cY cin wcel c2 vx cv csm co vx cv cB cpj cfv cfv vx
      cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co cB cD cph co cG cph
      co vx cv cX cY cin wcel c2 vx cv csm co vx cv cva co vx cv cmv co vx cv
      cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva co vx
      cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co
      cva co vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv
      cfv cva co cmv co c2 vx cv csm co vx cv cB cpj cfv cfv vx cv cD cpj cfv
      cfv cva co vx cv cG cpj cfv cfv cva co vx cv cX cY cin wcel c2 vx cv csm
      co vx cv cva co vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF
      cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv
      cG cpj cfv cfv cva co cva co vx cv vx cv cA cpj cfv cfv vx cv cC cpj cfv
      cfv cva co vx cv cF cpj cfv cfv cva co cmv vx cv cX cY cin wcel c2 vx cv
      csm co vx cv cva co vx cv vx cv cva co vx cv cva co vx cv cA cpj cfv cfv
      vx cv cC cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva
      co cva co vx cv cF cpj cfv cfv vx cv cG cpj cfv cfv cva co cva co vx cv
      cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva co vx
      cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co
      cva co vx cv cX cY cin wcel vx cv chil wcel c2 vx cv csm co vx cv cva co
      vx cv vx cv cva co vx cv cva co wceq vx cv cX cY cin wcel vx cv cX wcel
      vx cv cY wcel wa vx cv chil wcel vx cv cX cY elin vx cv cX wcel vx cv
      chil wcel vx cv cY wcel vx cv cX wcel vx cv cA cC chj co cF chj co wcel
      vx cv chil wcel cX cA cC chj co cF chj co vx cv mayete3.x eleq2i vx cv cA
      cC chj co cF chj co cA cC chj co cF cA cC mayete3.a mayete3.c chjcli
      mayete3.f chjcli cheli sylbi adantr sylbi vx cv chil wcel c2 vx cv csm co
      vx cv vx cv cva co vx cv cva vx cv hv2times opreq1d syl vx cv cX cY cin
      wcel vx cv cY wcel vx cv vx cv cva co vx cv cva co vx cv cA cpj cfv cfv
      vx cv cC cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva
      co cva co vx cv cF cpj cfv cfv vx cv cG cpj cfv cfv cva co cva co wceq cX
      cY cin cY vx cv cX cY inss2 sseli vx cv cY wcel vx cv cA cB chj co cC cD
      chj co cin wcel vx cv cF cG chj co wcel wa vx cv vx cv cva co vx cv cva
      co vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cB cpj cfv cfv
      vx cv cD cpj cfv cfv cva co cva co vx cv cF cpj cfv cfv vx cv cG cpj cfv
      cfv cva co cva co wceq vx cv cY wcel vx cv cA cB chj co cC cD chj co cin
      cF cG chj co cin wcel vx cv cA cB chj co cC cD chj co cin wcel vx cv cF
      cG chj co wcel wa cY cA cB chj co cC cD chj co cin cF cG chj co cin vx cv
      mayete3.y eleq2i vx cv cA cB chj co cC cD chj co cin cF cG chj co elin
      bitri vx cv cA cB chj co cC cD chj co cin wcel vx cv cF cG chj co wcel vx
      cv vx cv cva co vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cB
      cpj cfv cfv vx cv cD cpj cfv cfv cva co cva co vx cv vx cv cF cpj cfv cfv
      vx cv cG cpj cfv cfv cva co cva vx cv cA cB chj co cC cD chj co cin wcel
      vx cv vx cv cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv
      cC cpj cfv cfv vx cv cD cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx
      cv cC cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co
      cva co vx cv cA cB chj co cC cD chj co cin wcel vx cv cA cB chj co wcel
      vx cv cC cD chj co wcel wa vx cv vx cv cva co vx cv cA cpj cfv cfv vx cv
      cB cpj cfv cfv cva co vx cv cC cpj cfv cfv vx cv cD cpj cfv cfv cva co
      cva co wceq vx cv cA cB chj co cC cD chj co elin vx cv cA cB chj co wcel
      vx cv cC cD chj co wcel vx cv vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv
      cva co vx cv vx cv cC cpj cfv cfv vx cv cD cpj cfv cfv cva co cva vx cv
      cA cB chj co wcel cA cB cort cfv wss vx cv vx cv cA cpj cfv cfv vx cv cB
      cpj cfv cfv cva co wceq mayete3.ab vx cv cA cB mayete3.a mayete3.b pjdsi
      mpan2 vx cv cC cD chj co wcel cC cD cort cfv wss vx cv vx cv cC cpj cfv
      cfv vx cv cD cpj cfv cfv cva co wceq mayete3.cd vx cv cC cD mayete3.c
      mayete3.d pjdsi mpan2 opreqan12d sylbi vx cv cA cB chj co cC cD chj co
      cin wcel vx cv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co
      vx cv cC cpj cfv cfv vx cv cD cpj cfv cfv cva co cva co vx cv cA cpj cfv
      cfv vx cv cC cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv
      cva co cva co wceq vx cv cA cB chj co cC cD chj co cin wcel vx cv cA cB
      chj co wcel vx cv chil wcel cA cB chj co cC cD chj co cin cA cB chj co vx
      cv cA cB chj co cC cD chj co inss1 sseli vx cv cA cB chj co cA cB
      mayete3.a mayete3.b chjcli cheli syl vx cv cA cpj cfv cfv chil wcel vx cv
      cB cpj cfv cfv chil wcel vx cv cC cpj cfv cfv chil wcel vx cv cD cpj cfv
      cfv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC
      cpj cfv cfv vx cv cD cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv
      cC cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co
      cva co wceq vx cv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv vx
      cv cC cpj cfv cfv vx cv cD cpj cfv cfv hvadd4 vx cv cA mayete3.a pjhcli
      vx cv cB mayete3.b pjhcli vx cv cC mayete3.c pjhcli vx cv cD mayete3.d
      pjhcli syl2anc syl eqtrd vx cv cF cG chj co wcel cF cG cort cfv wss vx cv
      vx cv cF cpj cfv cfv vx cv cG cpj cfv cfv cva co wceq mayete3.fg vx cv cF
      cG mayete3.f mayete3.g pjdsi mpan2 opreqan12d sylbi syl vx cv cX cY cin
      wcel vx cv chil wcel vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx
      cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co cva co vx cv cF cpj cfv cfv
      vx cv cG cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv cC cpj cfv
      cfv cva co vx cv cF cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj
      cfv cfv cva co vx cv cG cpj cfv cfv cva co cva co wceq vx cv cX cY cin
      wcel vx cv cX wcel vx cv cY wcel wa vx cv chil wcel vx cv cX cY elin vx
      cv cX wcel vx cv chil wcel vx cv cY wcel vx cv cX wcel vx cv cA cC chj co
      cF chj co wcel vx cv chil wcel cX cA cC chj co cF chj co vx cv mayete3.x
      eleq2i vx cv cA cC chj co cF chj co cA cC chj co cF cA cC mayete3.a
      mayete3.c chjcli mayete3.f chjcli cheli sylbi adantr sylbi vx cv cA cpj
      cfv cfv vx cv cC cpj cfv cfv cva co chil wcel vx cv cB cpj cfv cfv vx cv
      cD cpj cfv cfv cva co chil wcel vx cv cF cpj cfv cfv chil wcel vx cv cG
      cpj cfv cfv chil wcel vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx
      cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co cva co vx cv cF cpj cfv cfv
      vx cv cG cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv cC cpj cfv
      cfv cva co vx cv cF cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj
      cfv cfv cva co vx cv cG cpj cfv cfv cva co cva co wceq vx cv chil wcel vx
      cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv
      cD cpj cfv cfv cva co vx cv cF cpj cfv cfv vx cv cG cpj cfv cfv hvadd4 vx
      cv cA cpj cfv cfv chil wcel vx cv cC cpj cfv cfv chil wcel vx cv cA cpj
      cfv cfv vx cv cC cpj cfv cfv cva co chil wcel vx cv chil wcel vx cv cA
      cpj cfv cfv vx cv cC cpj cfv cfv hvaddcl vx cv cA mayete3.a pjhcli vx cv
      cC mayete3.c pjhcli sylanc vx cv cB cpj cfv cfv chil wcel vx cv cD cpj
      cfv cfv chil wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co chil
      wcel vx cv chil wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv hvaddcl vx
      cv cB mayete3.b pjhcli vx cv cD mayete3.d pjhcli sylanc vx cv cF
      mayete3.f pjhcli vx cv cG mayete3.g pjhcli syl2anc syl 3eqtrd vx cv cX cY
      cin wcel vx cv cA cC chj co cF chj co wcel vx cv vx cv cA cpj cfv cfv vx
      cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva co wceq vx cv cX cY cin
      wcel vx cv cX cA cC chj co cF chj co cX cY cin cX vx cv cX cY inss1 sseli
      mayete3.x syl6eleq vx cv cA cC chj co cF chj co wcel cA cC cort cfv wss
      vx cv vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv
      cfv cva co wceq mayete3.ac vx cv cA cC chj co cF chj co wcel cA cC cort
      cfv wss wa cA cF cort cfv wss cC cF cort cfv wss vx cv vx cv cA cpj cfv
      cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva co wceq
      mayete3.af mayete3.cf vx cv cA cC cF mayete3.a mayete3.c mayete3.f pjds3i
      mpanr12 mpan2 syl opreq12d vx cv cX cY cin wcel vx cv chil wcel c2 vx cv
      csm co vx cv cva co vx cv cmv co c2 vx cv csm co wceq vx cv cX cY cin
      wcel vx cv cX wcel vx cv cY wcel wa vx cv chil wcel vx cv cX cY elin vx
      cv cX wcel vx cv chil wcel vx cv cY wcel vx cv cX wcel vx cv cA cC chj co
      cF chj co wcel vx cv chil wcel cX cA cC chj co cF chj co vx cv mayete3.x
      eleq2i vx cv cA cC chj co cF chj co cA cC chj co cF cA cC mayete3.a
      mayete3.c chjcli mayete3.f chjcli cheli sylbi adantr sylbi c2 vx cv csm
      co chil wcel vx cv chil wcel c2 vx cv csm co vx cv cva co vx cv cmv co c2
      vx cv csm co wceq c2 cc wcel vx cv chil wcel c2 vx cv csm co chil wcel
      2cn c2 vx cv hvmulcl mpan c2 vx cv csm co vx cv hvpncan mpancom syl vx cv
      cX cY cin wcel vx cv chil wcel vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv
      cva co vx cv cF cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv
      cfv cva co vx cv cG cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv
      cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva co cmv co vx cv cB cpj cfv
      cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co wceq vx cv cX
      cY cin wcel vx cv cX wcel vx cv cY wcel wa vx cv chil wcel vx cv cX cY
      elin vx cv cX wcel vx cv chil wcel vx cv cY wcel vx cv cX wcel vx cv cA
      cC chj co cF chj co wcel vx cv chil wcel cX cA cC chj co cF chj co vx cv
      mayete3.x eleq2i vx cv cA cC chj co cF chj co cA cC chj co cF cA cC
      mayete3.a mayete3.c chjcli mayete3.f chjcli cheli sylbi adantr sylbi vx
      cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva co
      chil wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj
      cfv cfv cva co chil wcel vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co
      vx cv cF cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva
      co vx cv cG cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv cC cpj
      cfv cfv cva co vx cv cF cpj cfv cfv cva co cmv co vx cv cB cpj cfv cfv vx
      cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co wceq vx cv chil wcel
      vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv cva
      co vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv
      cva co hvpncan2 vx cv cA cpj cfv cfv vx cv cC cpj cfv cfv cva co chil
      wcel vx cv cF cpj cfv cfv chil wcel vx cv cA cpj cfv cfv vx cv cC cpj cfv
      cfv cva co vx cv cF cpj cfv cfv cva co chil wcel vx cv chil wcel vx cv cA
      cpj cfv cfv vx cv cC cpj cfv cfv cva co vx cv cF cpj cfv cfv hvaddcl vx
      cv cA cpj cfv cfv chil wcel vx cv cC cpj cfv cfv chil wcel vx cv cA cpj
      cfv cfv vx cv cC cpj cfv cfv cva co chil wcel vx cv chil wcel vx cv cA
      cpj cfv cfv vx cv cC cpj cfv cfv hvaddcl vx cv cA mayete3.a pjhcli vx cv
      cC mayete3.c pjhcli sylanc vx cv cF mayete3.f pjhcli sylanc vx cv cB cpj
      cfv cfv vx cv cD cpj cfv cfv cva co chil wcel vx cv cG cpj cfv cfv chil
      wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj cfv
      cfv cva co chil wcel vx cv chil wcel vx cv cB cpj cfv cfv vx cv cD cpj
      cfv cfv cva co vx cv cG cpj cfv cfv hvaddcl vx cv cB cpj cfv cfv chil
      wcel vx cv cD cpj cfv cfv chil wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv
      cfv cva co chil wcel vx cv chil wcel vx cv cB cpj cfv cfv vx cv cD cpj
      cfv cfv hvaddcl vx cv cB mayete3.b pjhcli vx cv cD mayete3.d pjhcli
      sylanc vx cv cG mayete3.g pjhcli sylanc sylanc syl 3eqtr3d vx cv cX cY
      cin wcel vx cv chil wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co
      vx cv cG cpj cfv cfv cva co cB cD cph co cG cph co wcel vx cv cX cY cin
      wcel vx cv cX wcel vx cv cY wcel wa vx cv chil wcel vx cv cX cY elin vx
      cv cX wcel vx cv chil wcel vx cv cY wcel vx cv cX wcel vx cv cA cC chj co
      cF chj co wcel vx cv chil wcel cX cA cC chj co cF chj co vx cv mayete3.x
      eleq2i vx cv cA cC chj co cF chj co cA cC chj co cF cA cC mayete3.a
      mayete3.c chjcli mayete3.f chjcli cheli sylbi adantr sylbi vx cv cB cpj
      cfv cfv vx cv cD cpj cfv cfv cva co cB cD cph co wcel vx cv cG cpj cfv
      cfv cG wcel vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj
      cfv cfv cva co cB cD cph co cG cph co wcel vx cv chil wcel cB cD cph co
      cG vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cG cpj cfv cfv
      cB cD cB mayete3.b chshii cD mayete3.d chshii shscli cG mayete3.g chshii
      shsvai vx cv cB cpj cfv cfv cB wcel vx cv cD cpj cfv cfv cD wcel vx cv cB
      cpj cfv cfv vx cv cD cpj cfv cfv cva co cB cD cph co wcel vx cv chil wcel
      cB cD vx cv cB cpj cfv cfv vx cv cD cpj cfv cfv cB mayete3.b chshii cD
      mayete3.d chshii shsvai vx cv cB mayete3.b pjcli vx cv cD mayete3.d pjcli
      sylanc vx cv cG mayete3.g pjcli sylanc syl eqeltrd c1 c2 cdiv co cc wcel
      c2 vx cv csm co cB cD cph co cG cph co wcel c1 c2 cdiv co c2 vx cv csm co
      csm co cB cD cph co cG cph co wcel c2 2cn 2ne0 reccli cB cD cph co cG cph
      co csh wcel c1 c2 cdiv co cc wcel c2 vx cv csm co cB cD cph co cG cph co
      wcel wa c1 c2 cdiv co c2 vx cv csm co csm co cB cD cph co cG cph co wcel
      wi cB cD cph co cG cB cD cB mayete3.b chshii cD mayete3.d chshii shscli
      cG mayete3.g chshii shscli c1 c2 cdiv co c2 vx cv csm co cB cD cph co cG
      cph co shmulclOLD ax-mp mpan syl eqeltrd ssriv cB cD cph co cB cD chj co
      wss cB cD cph co cG cph co cB cD chj co cG cph co wss cB cD mayete3.b
      mayete3.d chsleji cB cD cph co cB cD chj co cG cB cD cB mayete3.b chshii
      cD mayete3.d chshii shscli cB cD chj co cB cD mayete3.b mayete3.d chjcli
      chshii cG mayete3.g chshii shlessi ax-mp sstri cB cD chj co cG cB cD
      mayete3.b mayete3.d chjcli mayete3.g chsleji sstri mayete3.z sseqtr4i $.
      $( [10-May-2009] $) $( [22-Jun-2006] $)
  $}

  ${
    $d x D $.  $d x F $.  $d x G $.  $d x R $.  $d x S $.
    mayete3OLD.1 $e |- A e. CH $.
    mayete3OLD.2 $e |- B e. CH $.
    mayete3OLD.3 $e |- C e. CH $.
    mayete3OLD.4 $e |- D e. CH $.
    mayete3OLD.5 $e |- F e. CH $.
    mayete3OLD.6 $e |- G e. CH $.
    mayete3OLD.7 $e |- A C_ ( _|_ ` B ) $.
    mayete3OLD.8 $e |- A C_ ( _|_ ` C ) $.
    mayete3OLD.9 $e |- B C_ ( _|_ ` C ) $.
    mayete3OLD.10 $e |- A C_ ( _|_ ` D ) $.
    mayete3OLD.11 $e |- B C_ ( _|_ ` F ) $.
    mayete3OLD.12 $e |- C C_ ( _|_ ` G ) $.
    mayete3OLD.13 $e |- R = ( ( A vH B ) vH C ) $.
    mayete3OLD.14 $e |- S = ( ( ( A vH D ) i^i ( B vH F ) ) i^i ( C vH G ) ) $.
    mayete3OLD.15 $e |- T = ( ( D vH F ) vH G ) $.
    $( Mayet's equation E_3.  Part of Theorem 4.1 of [Mayet3] p. 7. $)
    mayete3OLDi $p |- ( R i^i S ) C_ T $=
      cR cS cin cD cF chj co cG chj co cT cR cS cin cD cF chj co cG cph co cD
      cF chj co cG chj co cR cS cin cD cF cph co cG cph co cD cF chj co cG cph
      co vx cR cS cin cD cF cph co cG cph co vx cv cR cS cin wcel vx cv c1 c2
      cdiv co c2 vx cv csm co csm co cD cF cph co cG cph co vx cv cR cS cin
      wcel vx cv chil wcel vx cv c1 c2 cdiv co c2 vx cv csm co csm co wceq vx
      cv cR cS cin wcel vx cv cR wcel vx cv cS wcel wa vx cv chil wcel vx cv cR
      cS elin vx cv cR wcel vx cv chil wcel vx cv cS wcel vx cv cR wcel vx cv
      cA cB chj co cC chj co wcel vx cv chil wcel cR cA cB chj co cC chj co vx
      cv mayete3OLD.13 eleq2i vx cv cA cB chj co cC chj co cA cB chj co cC cA
      cB mayete3OLD.1 mayete3OLD.2 chjcli mayete3OLD.3 chjcli cheli sylbi
      adantr sylbi vx cv chil wcel c1 vx cv csm co vx cv c1 c2 cdiv co c2 vx cv
      csm co csm co vx cv ax-hvmulid vx cv chil wcel c1 c2 cdiv co c2 cmul co
      vx cv csm co c1 c2 cdiv co c2 vx cv csm co csm co c1 vx cv csm co c1 c2
      cdiv co cc wcel c2 cc wcel vx cv chil wcel c1 c2 cdiv co c2 cmul co vx cv
      csm co c1 c2 cdiv co c2 vx cv csm co csm co wceq c2 2cn 2ne0 reccli 2cn
      c1 c2 cdiv co c2 vx cv ax-hvmulass mp3an12 c1 c2 cdiv co c2 cmul co c1 vx
      cv csm c2 cc wcel c2 cc0 wne c1 c2 cdiv co c2 cmul co c1 wceq 2cn 2ne0 c2
      recid2 mp2an opreq1i syl5eqr eqtr3d syl vx cv cR cS cin wcel c2 vx cv csm
      co cD cF cph co cG cph co wcel c1 c2 cdiv co c2 vx cv csm co csm co cD cF
      cph co cG cph co wcel vx cv cR cS cin wcel c2 vx cv csm co vx cv cD cpj
      cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co cD cF cph
      co cG cph co vx cv cR cS cin wcel c2 vx cv csm co vx cv cva co vx cv cmv
      co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv
      cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv
      cfv cva co cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv
      cC cpj cfv cfv cva co cmv co c2 vx cv csm co vx cv cD cpj cfv cfv vx cv
      cF cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co vx cv cR cS cin wcel c2
      vx cv csm co vx cv cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva
      co vx cv cC cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv
      cva co vx cv cG cpj cfv cfv cva co cva co vx cv vx cv cA cpj cfv cfv vx
      cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co cmv vx cv cR cS cin
      wcel c2 vx cv csm co vx cv cva co vx cv vx cv cva co vx cv cva co vx cv
      cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF
      cpj cfv cfv cva co cva co vx cv cC cpj cfv cfv vx cv cG cpj cfv cfv cva
      co cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj
      cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG
      cpj cfv cfv cva co cva co vx cv cR cS cin wcel vx cv chil wcel c2 vx cv
      csm co vx cv cva co vx cv vx cv cva co vx cv cva co wceq vx cv cR cS cin
      wcel vx cv cR wcel vx cv cS wcel wa vx cv chil wcel vx cv cR cS elin vx
      cv cR wcel vx cv chil wcel vx cv cS wcel vx cv cR wcel vx cv cA cB chj co
      cC chj co wcel vx cv chil wcel cR cA cB chj co cC chj co vx cv
      mayete3OLD.13 eleq2i vx cv cA cB chj co cC chj co cA cB chj co cC cA cB
      mayete3OLD.1 mayete3OLD.2 chjcli mayete3OLD.3 chjcli cheli sylbi adantr
      sylbi vx cv chil wcel c2 vx cv csm co vx cv vx cv cva co vx cv cva vx cv
      hv2times opreq1d syl vx cv cR cS cin wcel vx cv cS wcel vx cv vx cv cva
      co vx cv cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cD
      cpj cfv cfv vx cv cF cpj cfv cfv cva co cva co vx cv cC cpj cfv cfv vx cv
      cG cpj cfv cfv cva co cva co wceq cR cS cin cS vx cv cR cS inss2 sseli vx
      cv cS wcel vx cv cA cD chj co cB cF chj co cin wcel vx cv cC cG chj co
      wcel wa vx cv vx cv cva co vx cv cva co vx cv cA cpj cfv cfv vx cv cB cpj
      cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co cva co vx
      cv cC cpj cfv cfv vx cv cG cpj cfv cfv cva co cva co wceq vx cv cS wcel
      vx cv cA cD chj co cB cF chj co cin cC cG chj co cin wcel vx cv cA cD chj
      co cB cF chj co cin wcel vx cv cC cG chj co wcel wa cS cA cD chj co cB cF
      chj co cin cC cG chj co cin vx cv mayete3OLD.14 eleq2i vx cv cA cD chj co
      cB cF chj co cin cC cG chj co elin bitri vx cv cA cD chj co cB cF chj co
      cin wcel vx cv cC cG chj co wcel vx cv vx cv cva co vx cv cA cpj cfv cfv
      vx cv cB cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva
      co cva co vx cv vx cv cC cpj cfv cfv vx cv cG cpj cfv cfv cva co cva vx
      cv cA cD chj co cB cF chj co cin wcel vx cv vx cv cva co vx cv cA cpj cfv
      cfv vx cv cD cpj cfv cfv cva co vx cv cB cpj cfv cfv vx cv cF cpj cfv cfv
      cva co cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cD
      cpj cfv cfv vx cv cF cpj cfv cfv cva co cva co vx cv cA cD chj co cB cF
      chj co cin wcel vx cv cA cD chj co wcel vx cv cB cF chj co wcel wa vx cv
      vx cv cva co vx cv cA cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cB
      cpj cfv cfv vx cv cF cpj cfv cfv cva co cva co wceq vx cv cA cD chj co cB
      cF chj co elin vx cv cA cD chj co wcel vx cv cB cF chj co wcel vx cv vx
      cv cA cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv vx cv cB cpj cfv cfv
      vx cv cF cpj cfv cfv cva co cva vx cv cA cD chj co wcel cA cD cort cfv
      wss vx cv vx cv cA cpj cfv cfv vx cv cD cpj cfv cfv cva co wceq
      mayete3OLD.10 vx cv cA cD mayete3OLD.1 mayete3OLD.4 pjdsi mpan2 vx cv cB
      cF chj co wcel cB cF cort cfv wss vx cv vx cv cB cpj cfv cfv vx cv cF cpj
      cfv cfv cva co wceq mayete3OLD.11 vx cv cB cF mayete3OLD.2 mayete3OLD.5
      pjdsi mpan2 opreqan12d sylbi vx cv cA cD chj co cB cF chj co cin wcel vx
      cv chil wcel vx cv cA cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cB
      cpj cfv cfv vx cv cF cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv
      cB cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co
      cva co wceq vx cv cA cD chj co cB cF chj co cin wcel vx cv cA cD chj co
      wcel vx cv chil wcel cA cD chj co cB cF chj co cin cA cD chj co vx cv cA
      cD chj co cB cF chj co inss1 sseli vx cv cA cD chj co cA cD mayete3OLD.1
      mayete3OLD.4 chjcli cheli syl vx cv cA cpj cfv cfv chil wcel vx cv cD cpj
      cfv cfv chil wcel vx cv cB cpj cfv cfv chil wcel vx cv cF cpj cfv cfv
      chil wcel vx cv cA cpj cfv cfv vx cv cD cpj cfv cfv cva co vx cv cB cpj
      cfv cfv vx cv cF cpj cfv cfv cva co cva co vx cv cA cpj cfv cfv vx cv cB
      cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co cva
      co wceq vx cv chil wcel vx cv cA cpj cfv cfv vx cv cD cpj cfv cfv vx cv
      cB cpj cfv cfv vx cv cF cpj cfv cfv hvadd4 vx cv cA mayete3OLD.1 pjhcli
      vx cv cD mayete3OLD.4 pjhcli vx cv cB mayete3OLD.2 pjhcli vx cv cF
      mayete3OLD.5 pjhcli syl2anc syl eqtrd vx cv cC cG chj co wcel cC cG cort
      cfv wss vx cv vx cv cC cpj cfv cfv vx cv cG cpj cfv cfv cva co wceq
      mayete3OLD.12 vx cv cC cG mayete3OLD.3 mayete3OLD.6 pjdsi mpan2
      opreqan12d sylbi syl vx cv cR cS cin wcel vx cv chil wcel vx cv cA cpj
      cfv cfv vx cv cB cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv
      cfv cva co cva co vx cv cC cpj cfv cfv vx cv cG cpj cfv cfv cva co cva co
      vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva
      co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv cfv
      cva co cva co wceq vx cv cR cS cin wcel vx cv cR wcel vx cv cS wcel wa vx
      cv chil wcel vx cv cR cS elin vx cv cR wcel vx cv chil wcel vx cv cS wcel
      vx cv cR wcel vx cv cA cB chj co cC chj co wcel vx cv chil wcel cR cA cB
      chj co cC chj co vx cv mayete3OLD.13 eleq2i vx cv cA cB chj co cC chj co
      cA cB chj co cC cA cB mayete3OLD.1 mayete3OLD.2 chjcli mayete3OLD.3
      chjcli cheli sylbi adantr sylbi vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv
      cva co chil wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co chil
      wcel vx cv cC cpj cfv cfv chil wcel vx cv cG cpj cfv cfv chil wcel vx cv
      cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF
      cpj cfv cfv cva co cva co vx cv cC cpj cfv cfv vx cv cG cpj cfv cfv cva
      co cva co vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj
      cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG
      cpj cfv cfv cva co cva co wceq vx cv chil wcel vx cv cA cpj cfv cfv vx cv
      cB cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx
      cv cC cpj cfv cfv vx cv cG cpj cfv cfv hvadd4 vx cv cA cpj cfv cfv chil
      wcel vx cv cB cpj cfv cfv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv
      cfv cva co chil wcel vx cv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj
      cfv cfv hvaddcl vx cv cA mayete3OLD.1 pjhcli vx cv cB mayete3OLD.2 pjhcli
      sylanc vx cv cD cpj cfv cfv chil wcel vx cv cF cpj cfv cfv chil wcel vx
      cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co chil wcel vx cv chil wcel
      vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv hvaddcl vx cv cD mayete3OLD.4
      pjhcli vx cv cF mayete3OLD.5 pjhcli sylanc vx cv cC mayete3OLD.3 pjhcli
      vx cv cG mayete3OLD.6 pjhcli syl2anc syl 3eqtrd vx cv cR cS cin wcel vx
      cv cA cB chj co cC chj co wcel vx cv vx cv cA cpj cfv cfv vx cv cB cpj
      cfv cfv cva co vx cv cC cpj cfv cfv cva co wceq vx cv cR cS cin wcel vx
      cv cR cA cB chj co cC chj co cR cS cin cR vx cv cR cS inss1 sseli
      mayete3OLD.13 syl6eleq vx cv cA cB chj co cC chj co wcel cA cB cort cfv
      wss vx cv vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj
      cfv cfv cva co wceq mayete3OLD.7 vx cv cA cB chj co cC chj co wcel cA cB
      cort cfv wss wa cA cC cort cfv wss cB cC cort cfv wss vx cv vx cv cA cpj
      cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co wceq
      mayete3OLD.8 mayete3OLD.9 vx cv cA cB cC mayete3OLD.1 mayete3OLD.2
      mayete3OLD.3 pjds3i mpanr12 mpan2 syl opreq12d vx cv cR cS cin wcel vx cv
      chil wcel c2 vx cv csm co vx cv cva co vx cv cmv co c2 vx cv csm co wceq
      vx cv cR cS cin wcel vx cv cR wcel vx cv cS wcel wa vx cv chil wcel vx cv
      cR cS elin vx cv cR wcel vx cv chil wcel vx cv cS wcel vx cv cR wcel vx
      cv cA cB chj co cC chj co wcel vx cv chil wcel cR cA cB chj co cC chj co
      vx cv mayete3OLD.13 eleq2i vx cv cA cB chj co cC chj co cA cB chj co cC
      cA cB mayete3OLD.1 mayete3OLD.2 chjcli mayete3OLD.3 chjcli cheli sylbi
      adantr sylbi c2 vx cv csm co chil wcel vx cv chil wcel c2 vx cv csm co vx
      cv cva co vx cv cmv co c2 vx cv csm co wceq c2 cc wcel vx cv chil wcel c2
      vx cv csm co chil wcel 2cn c2 vx cv hvmulcl mpan c2 vx cv csm co vx cv
      hvpncan mpancom syl vx cv cR cS cin wcel vx cv chil wcel vx cv cA cpj cfv
      cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co vx cv cD cpj
      cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co cva co vx
      cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co
      cmv co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv
      cfv cva co wceq vx cv cR cS cin wcel vx cv cR wcel vx cv cS wcel wa vx cv
      chil wcel vx cv cR cS elin vx cv cR wcel vx cv chil wcel vx cv cS wcel vx
      cv cR wcel vx cv cA cB chj co cC chj co wcel vx cv chil wcel cR cA cB chj
      co cC chj co vx cv mayete3OLD.13 eleq2i vx cv cA cB chj co cC chj co cA
      cB chj co cC cA cB mayete3OLD.1 mayete3OLD.2 chjcli mayete3OLD.3 chjcli
      cheli sylbi adantr sylbi vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co
      vx cv cC cpj cfv cfv cva co chil wcel vx cv cD cpj cfv cfv vx cv cF cpj
      cfv cfv cva co vx cv cG cpj cfv cfv cva co chil wcel vx cv cA cpj cfv cfv
      vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co vx cv cD cpj cfv
      cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co cva co vx cv
      cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co
      cmv co vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv
      cfv cva co wceq vx cv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv
      cva co vx cv cC cpj cfv cfv cva co vx cv cD cpj cfv cfv vx cv cF cpj cfv
      cfv cva co vx cv cG cpj cfv cfv cva co hvpncan2 vx cv cA cpj cfv cfv vx
      cv cB cpj cfv cfv cva co chil wcel vx cv cC cpj cfv cfv chil wcel vx cv
      cA cpj cfv cfv vx cv cB cpj cfv cfv cva co vx cv cC cpj cfv cfv cva co
      chil wcel vx cv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva
      co vx cv cC cpj cfv cfv hvaddcl vx cv cA cpj cfv cfv chil wcel vx cv cB
      cpj cfv cfv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv cva co
      chil wcel vx cv chil wcel vx cv cA cpj cfv cfv vx cv cB cpj cfv cfv
      hvaddcl vx cv cA mayete3OLD.1 pjhcli vx cv cB mayete3OLD.2 pjhcli sylanc
      vx cv cC mayete3OLD.3 pjhcli sylanc vx cv cD cpj cfv cfv vx cv cF cpj cfv
      cfv cva co chil wcel vx cv cG cpj cfv cfv chil wcel vx cv cD cpj cfv cfv
      vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv cfv cva co chil wcel vx cv
      chil wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj
      cfv cfv hvaddcl vx cv cD cpj cfv cfv chil wcel vx cv cF cpj cfv cfv chil
      wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co chil wcel vx cv
      chil wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv hvaddcl vx cv cD
      mayete3OLD.4 pjhcli vx cv cF mayete3OLD.5 pjhcli sylanc vx cv cG
      mayete3OLD.6 pjhcli sylanc sylanc syl 3eqtr3d vx cv cR cS cin wcel vx cv
      chil wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj
      cfv cfv cva co cD cF cph co cG cph co wcel vx cv cR cS cin wcel vx cv cR
      wcel vx cv cS wcel wa vx cv chil wcel vx cv cR cS elin vx cv cR wcel vx
      cv chil wcel vx cv cS wcel vx cv cR wcel vx cv cA cB chj co cC chj co
      wcel vx cv chil wcel cR cA cB chj co cC chj co vx cv mayete3OLD.13 eleq2i
      vx cv cA cB chj co cC chj co cA cB chj co cC cA cB mayete3OLD.1
      mayete3OLD.2 chjcli mayete3OLD.3 chjcli cheli sylbi adantr sylbi vx cv cD
      cpj cfv cfv vx cv cF cpj cfv cfv cva co cD cF cph co wcel vx cv cG cpj
      cfv cfv cG wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG
      cpj cfv cfv cva co cD cF cph co cG cph co wcel vx cv chil wcel cD cF cph
      co cG vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co vx cv cG cpj cfv
      cfv cD cF cD mayete3OLD.4 chshii cF mayete3OLD.5 chshii shscli cG
      mayete3OLD.6 chshii shsvai vx cv cD cpj cfv cfv cD wcel vx cv cF cpj cfv
      cfv cF wcel vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cva co cD cF cph co
      wcel vx cv chil wcel cD cF vx cv cD cpj cfv cfv vx cv cF cpj cfv cfv cD
      mayete3OLD.4 chshii cF mayete3OLD.5 chshii shsvai vx cv cD mayete3OLD.4
      pjcli vx cv cF mayete3OLD.5 pjcli sylanc vx cv cG mayete3OLD.6 pjcli
      sylanc syl eqeltrd c1 c2 cdiv co cc wcel c2 vx cv csm co cD cF cph co cG
      cph co wcel c1 c2 cdiv co c2 vx cv csm co csm co cD cF cph co cG cph co
      wcel c2 2cn 2ne0 reccli cD cF cph co cG cph co csh wcel c1 c2 cdiv co cc
      wcel c2 vx cv csm co cD cF cph co cG cph co wcel wa c1 c2 cdiv co c2 vx
      cv csm co csm co cD cF cph co cG cph co wcel wi cD cF cph co cG cD cF cD
      mayete3OLD.4 chshii cF mayete3OLD.5 chshii shscli cG mayete3OLD.6 chshii
      shscli c1 c2 cdiv co c2 vx cv csm co cD cF cph co cG cph co shmulclOLD
      ax-mp mpan syl eqeltrd ssriv cD cF cph co cD cF chj co wss cD cF cph co
      cG cph co cD cF chj co cG cph co wss cD cF mayete3OLD.4 mayete3OLD.5
      chsleji cD cF cph co cD cF chj co cG cD cF cD mayete3OLD.4 chshii cF
      mayete3OLD.5 chshii shscli cD cF chj co cD cF mayete3OLD.4 mayete3OLD.5
      chjcli chshii cG mayete3OLD.6 chshii shlessi ax-mp sstri cD cF chj co cG
      cD cF mayete3OLD.4 mayete3OLD.5 chjcli mayete3OLD.6 chsleji sstri
      mayete3OLD.15 sseqtr4i $.
      $( [22-Jun-2006] $) $( [22-Jun-2006] $)
  $}

  ${
    mayetes3.a $e |- A e. CH $.
    mayetes3.b $e |- B e. CH $.
    mayetes3.c $e |- C e. CH $.
    mayetes3.d $e |- D e. CH $.
    mayetes3.f $e |- F e. CH $.
    mayetes3.g $e |- G e. CH $.
    mayetes3.r $e |- R e. CH $.
    mayetes3.ac $e |- A C_ ( _|_ ` C ) $.
    mayetes3.af $e |- A C_ ( _|_ ` F ) $.
    mayetes3.cf $e |- C C_ ( _|_ ` F ) $.
    mayetes3.ab $e |- A C_ ( _|_ ` B ) $.
    mayetes3.cd $e |- C C_ ( _|_ ` D ) $.
    mayetes3.fg $e |- F C_ ( _|_ ` G ) $.
    mayetes3.rx $e |- R C_ ( _|_ ` X ) $.
    mayetes3.x $e |- X = ( ( A vH C ) vH F ) $.
    mayetes3.y $e |- Y = ( ( ( A vH B ) i^i ( C vH D ) ) i^i ( F vH G ) ) $.
    mayetes3.z $e |- Z = ( ( B vH D ) vH G ) $.
    $( Mayet's equation E^*_3, derived from E_3.  Solution, for n = 3, to open
       problem in Remark (b) after Theorem 7.1 of [Mayet3] p. 1240. $)
    mayetes3i $p |- ( ( X vH R ) i^i Y ) C_ ( Z vH R ) $=
      cA cC chj co cF chj co cR chj co cA cB chj co cC cD chj co cin cF cG chj
      co cin cin cB cD chj co cG chj co cR chj co cX cR chj co cY cin cZ cR chj
      co cA cC chj co cF chj co cR chj co cA cB chj co cC cD chj co cin cF cG
      chj co cin cin cR cA cC chj co cF chj co cA cB cR chj co chj co cC cD cR
      chj co chj co cin cF cG cR chj co chj co cin cin chj co cB cD chj co cG
      chj co cR chj co cA cC chj co cF chj co cR chj co cA cB chj co cC cD chj
      co cin cF cG chj co cin cin cR cA cC chj co cF chj co chj co cR cA cB cR
      chj co chj co chj co cR cC cD cR chj co chj co chj co cin cR cF cG cR chj
      co chj co chj co cin cin cR cA cC chj co cF chj co cA cB cR chj co chj co
      cC cD cR chj co chj co cin cF cG cR chj co chj co cin cin chj co cA cC
      chj co cF chj co cR chj co cR cA cC chj co cF chj co chj co wss cA cB chj
      co cC cD chj co cin cF cG chj co cin cR cA cB cR chj co chj co chj co cR
      cC cD cR chj co chj co chj co cin cR cF cG cR chj co chj co chj co cin
      wss cA cC chj co cF chj co cR chj co cA cB chj co cC cD chj co cin cF cG
      chj co cin cin cR cA cC chj co cF chj co chj co cR cA cB cR chj co chj co
      chj co cR cC cD cR chj co chj co chj co cin cR cF cG cR chj co chj co chj
      co cin cin wss cA cC chj co cF chj co cR chj co cR cA cC chj co cF chj co
      chj co cA cC chj co cF chj co cR cA cC chj co cF cA cC mayetes3.a
      mayetes3.c chjcli mayetes3.f chjcli mayetes3.r chjcomi eqimssi cA cB chj
      co cC cD chj co cin cR cA cB cR chj co chj co chj co cR cC cD cR chj co
      chj co chj co cin wss cF cG chj co cR cF cG cR chj co chj co chj co wss
      cA cB chj co cC cD chj co cin cF cG chj co cin cR cA cB cR chj co chj co
      chj co cR cC cD cR chj co chj co chj co cin cR cF cG cR chj co chj co chj
      co cin wss cA cB chj co cR cA cB cR chj co chj co chj co wss cC cD chj co
      cR cC cD cR chj co chj co chj co wss cA cB chj co cC cD chj co cin cR cA
      cB cR chj co chj co chj co cR cC cD cR chj co chj co chj co cin wss cA cB
      chj co cA cB cR chj co chj co cR cA cB cR chj co chj co chj co cA cB chj
      co cA cB chj co cR chj co cA cB cR chj co chj co cA cB chj co cR cA cB
      mayetes3.a mayetes3.b chjcli mayetes3.r chub1i cA cB cR mayetes3.a
      mayetes3.b mayetes3.r chjassi sseqtri cA cB cR chj co chj co cR cA cB cR
      chj co mayetes3.a cB cR mayetes3.b mayetes3.r chjcli chjcli mayetes3.r
      chub2i sstri cC cD chj co cC cD cR chj co chj co cR cC cD cR chj co chj
      co chj co cC cD chj co cC cD chj co cR chj co cC cD cR chj co chj co cC
      cD chj co cR cC cD mayetes3.c mayetes3.d chjcli mayetes3.r chub1i cC cD
      cR mayetes3.c mayetes3.d mayetes3.r chjassi sseqtri cC cD cR chj co chj
      co cR cC cD cR chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli
      chjcli mayetes3.r chub2i sstri cA cB chj co cR cA cB cR chj co chj co chj
      co cC cD chj co cR cC cD cR chj co chj co chj co ss2in mp2an cF cG chj co
      cF cG cR chj co chj co cR cF cG cR chj co chj co chj co cF cG chj co cF
      cG chj co cR chj co cF cG cR chj co chj co cF cG chj co cR cF cG
      mayetes3.f mayetes3.g chjcli mayetes3.r chub1i cF cG cR mayetes3.f
      mayetes3.g mayetes3.r chjassi sseqtri cF cG cR chj co chj co cR cF cG cR
      chj co mayetes3.f cG cR mayetes3.g mayetes3.r chjcli chjcli mayetes3.r
      chub2i sstri cA cB chj co cC cD chj co cin cR cA cB cR chj co chj co chj
      co cR cC cD cR chj co chj co chj co cin cF cG chj co cR cF cG cR chj co
      chj co chj co ss2in mp2an cA cC chj co cF chj co cR chj co cR cA cC chj
      co cF chj co chj co cA cB chj co cC cD chj co cin cF cG chj co cin cR cA
      cB cR chj co chj co chj co cR cC cD cR chj co chj co chj co cin cR cF cG
      cR chj co chj co chj co cin ss2in mp2an cR cA cC chj co cF chj co cA cB
      cR chj co chj co cC cD cR chj co chj co cin cF cG cR chj co chj co cin
      cin chj co cR cA cC chj co cF chj co chj co cR cA cB cR chj co chj co cC
      cD cR chj co chj co cin cF cG cR chj co chj co cin chj co cin cR cA cC
      chj co cF chj co chj co cR cA cB cR chj co chj co chj co cR cC cD cR chj
      co chj co chj co cin cR cF cG cR chj co chj co chj co cin cin cR cA cC
      chj co cF chj co cA cB cR chj co chj co cC cD cR chj co chj co cin cF cG
      cR chj co chj co cin mayetes3.r cA cC chj co cF cA cC mayetes3.a
      mayetes3.c chjcli mayetes3.f chjcli cA cB cR chj co chj co cC cD cR chj
      co chj co cin cF cG cR chj co chj co cA cB cR chj co chj co cC cD cR chj
      co chj co cA cB cR chj co mayetes3.a cB cR mayetes3.b mayetes3.r chjcli
      chjcli cC cD cR chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli
      chjcli chincli cF cG cR chj co mayetes3.f cG cR mayetes3.g mayetes3.r
      chjcli chjcli chincli cR cX cA cC chj co cF chj co ccm cR cX ccm wbr cR
      cX cort cfv ccm wbr cR cX cort cfv mayetes3.r cX cX cA cC chj co cF chj
      co cch mayetes3.x cA cC chj co cF cA cC mayetes3.a mayetes3.c chjcli
      mayetes3.f chjcli eqeltri choccli mayetes3.rx lecmii cR cX mayetes3.r cX
      cA cC chj co cF chj co cch mayetes3.x cA cC chj co cF cA cC mayetes3.a
      mayetes3.c chjcli mayetes3.f chjcli eqeltri cmcm2i mpbir mayetes3.x
      breqtri cR cA cB cR chj co chj co cC cD cR chj co chj co cin cF cG cR chj
      co chj co mayetes3.r cA cB cR chj co chj co cC cD cR chj co chj co cA cB
      cR chj co mayetes3.a cB cR mayetes3.b mayetes3.r chjcli chjcli cC cD cR
      chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli chincli cF cG
      cR chj co mayetes3.f cG cR mayetes3.g mayetes3.r chjcli chjcli cR cA cB
      cR chj co chj co cC cD cR chj co chj co mayetes3.r cA cB cR chj co
      mayetes3.a cB cR mayetes3.b mayetes3.r chjcli chjcli cC cD cR chj co
      mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli cR cA cB cR chj co
      chj co mayetes3.r cA cB cR chj co mayetes3.a cB cR mayetes3.b mayetes3.r
      chjcli chjcli cR cB cR chj co cA cB cR chj co chj co cR cB mayetes3.r
      mayetes3.b chub2i cB cR chj co cA cB cR mayetes3.b mayetes3.r chjcli
      mayetes3.a chub2i sstri lecmii cR cC cD cR chj co chj co mayetes3.r cC cD
      cR chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli cR cD cR
      chj co cC cD cR chj co chj co cR cD mayetes3.r mayetes3.d chub2i cD cR
      chj co cC cD cR mayetes3.d mayetes3.r chjcli mayetes3.c chub2i sstri
      lecmii cm2mi cR cF cG cR chj co chj co mayetes3.r cF cG cR chj co
      mayetes3.f cG cR mayetes3.g mayetes3.r chjcli chjcli cR cG cR chj co cF
      cG cR chj co chj co cR cG mayetes3.r mayetes3.g chub2i cG cR chj co cF cG
      cR mayetes3.g mayetes3.r chjcli mayetes3.f chub2i sstri lecmii cm2mi fh3i
      cR cA cB cR chj co chj co cC cD cR chj co chj co cin cF cG cR chj co chj
      co cin chj co cR cA cB cR chj co chj co chj co cR cC cD cR chj co chj co
      chj co cin cR cF cG cR chj co chj co chj co cin cR cA cC chj co cF chj co
      chj co cR cA cB cR chj co chj co cC cD cR chj co chj co cin cF cG cR chj
      co chj co cin chj co cR cA cB cR chj co chj co cC cD cR chj co chj co cin
      chj co cR cF cG cR chj co chj co chj co cin cR cA cB cR chj co chj co chj
      co cR cC cD cR chj co chj co chj co cin cR cF cG cR chj co chj co chj co
      cin cR cA cB cR chj co chj co cC cD cR chj co chj co cin cF cG cR chj co
      chj co mayetes3.r cA cB cR chj co chj co cC cD cR chj co chj co cA cB cR
      chj co mayetes3.a cB cR mayetes3.b mayetes3.r chjcli chjcli cC cD cR chj
      co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli chincli cF cG cR
      chj co mayetes3.f cG cR mayetes3.g mayetes3.r chjcli chjcli cR cA cB cR
      chj co chj co cC cD cR chj co chj co mayetes3.r cA cB cR chj co
      mayetes3.a cB cR mayetes3.b mayetes3.r chjcli chjcli cC cD cR chj co
      mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli cR cA cB cR chj co
      chj co mayetes3.r cA cB cR chj co mayetes3.a cB cR mayetes3.b mayetes3.r
      chjcli chjcli cR cB cR chj co cA cB cR chj co chj co cR cB mayetes3.r
      mayetes3.b chub2i cB cR chj co cA cB cR mayetes3.b mayetes3.r chjcli
      mayetes3.a chub2i sstri lecmii cR cC cD cR chj co chj co mayetes3.r cC cD
      cR chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli cR cD cR
      chj co cC cD cR chj co chj co cR cD mayetes3.r mayetes3.d chub2i cD cR
      chj co cC cD cR mayetes3.d mayetes3.r chjcli mayetes3.c chub2i sstri
      lecmii cm2mi cR cF cG cR chj co chj co mayetes3.r cF cG cR chj co
      mayetes3.f cG cR mayetes3.g mayetes3.r chjcli chjcli cR cG cR chj co cF
      cG cR chj co chj co cR cG mayetes3.r mayetes3.g chub2i cG cR chj co cF cG
      cR mayetes3.g mayetes3.r chjcli mayetes3.f chub2i sstri lecmii fh3i cR cA
      cB cR chj co chj co cC cD cR chj co chj co cin chj co cR cA cB cR chj co
      chj co chj co cR cC cD cR chj co chj co chj co cin cR cF cG cR chj co chj
      co chj co cR cA cB cR chj co chj co cC cD cR chj co chj co mayetes3.r cA
      cB cR chj co mayetes3.a cB cR mayetes3.b mayetes3.r chjcli chjcli cC cD
      cR chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli chjcli cR cA cB
      cR chj co chj co mayetes3.r cA cB cR chj co mayetes3.a cB cR mayetes3.b
      mayetes3.r chjcli chjcli cR cB cR chj co cA cB cR chj co chj co cR cB
      mayetes3.r mayetes3.b chub2i cB cR chj co cA cB cR mayetes3.b mayetes3.r
      chjcli mayetes3.a chub2i sstri lecmii cR cC cD cR chj co chj co
      mayetes3.r cC cD cR chj co mayetes3.c cD cR mayetes3.d mayetes3.r chjcli
      chjcli cR cD cR chj co cC cD cR chj co chj co cR cD mayetes3.r mayetes3.d
      chub2i cD cR chj co cC cD cR mayetes3.d mayetes3.r chjcli mayetes3.c
      chub2i sstri lecmii fh3i ineq1i eqtri ineq2i eqtr2i sseqtri cR cB cD chj
      co cG chj co cR chj co wss cA cC chj co cF chj co cA cB cR chj co chj co
      cC cD cR chj co chj co cin cF cG cR chj co chj co cin cin cB cD chj co cG
      chj co cR chj co wss cR cA cC chj co cF chj co cA cB cR chj co chj co cC
      cD cR chj co chj co cin cF cG cR chj co chj co cin cin chj co cB cD chj
      co cG chj co cR chj co wss cR cB cD chj co cG chj co mayetes3.r cB cD chj
      co cG cB cD mayetes3.b mayetes3.d chjcli mayetes3.g chjcli chub2i cA cB
      cR chj co cC cD cR chj co cF cG cR chj co cA cC chj co cF chj co cA cB cR
      chj co chj co cC cD cR chj co chj co cin cF cG cR chj co chj co cin cB cD
      chj co cG chj co cR chj co mayetes3.a cB cR mayetes3.b mayetes3.r chjcli
      mayetes3.c cD cR mayetes3.d mayetes3.r chjcli mayetes3.f cG cR mayetes3.g
      mayetes3.r chjcli mayetes3.ac mayetes3.af mayetes3.cf cA cB cort cfv cR
      cort cfv cin cB cR chj co cort cfv cA cB cort cfv cR cort cfv mayetes3.ab
      cR cA cort cfv wss cA cR cort cfv wss cR cX cort cfv cA cort cfv
      mayetes3.rx cA cX wss cX cort cfv cA cort cfv wss cA cA cC chj co cX cA
      cC mayetes3.a mayetes3.c chub1i cA cC chj co cA cC chj co cF chj co cX cA
      cC chj co cF cA cC mayetes3.a mayetes3.c chjcli mayetes3.f chub1i
      mayetes3.x sseqtr4i sstri cA cX mayetes3.a cX cA cC chj co cF chj co cch
      mayetes3.x cA cC chj co cF cA cC mayetes3.a mayetes3.c chjcli mayetes3.f
      chjcli eqeltri chsscon3i mpbi sstri cR cA mayetes3.r mayetes3.a chsscon2i
      mpbi ssini cB cR mayetes3.b mayetes3.r chdmj1i sseqtr4i cC cD cort cfv cR
      cort cfv cin cD cR chj co cort cfv cC cD cort cfv cR cort cfv mayetes3.cd
      cR cC cort cfv wss cC cR cort cfv wss cR cX cort cfv cC cort cfv
      mayetes3.rx cC cX wss cX cort cfv cC cort cfv wss cC cA cC chj co cX cC
      cA mayetes3.c mayetes3.a chub2i cA cC chj co cA cC chj co cF chj co cX cA
      cC chj co cF cA cC mayetes3.a mayetes3.c chjcli mayetes3.f chub1i
      mayetes3.x sseqtr4i sstri cC cX mayetes3.c cX cA cC chj co cF chj co cch
      mayetes3.x cA cC chj co cF cA cC mayetes3.a mayetes3.c chjcli mayetes3.f
      chjcli eqeltri chsscon3i mpbi sstri cR cC mayetes3.r mayetes3.c chsscon2i
      mpbi ssini cD cR mayetes3.d mayetes3.r chdmj1i sseqtr4i cF cG cort cfv cR
      cort cfv cin cG cR chj co cort cfv cF cG cort cfv cR cort cfv mayetes3.fg
      cR cF cort cfv wss cF cR cort cfv wss cR cX cort cfv cF cort cfv
      mayetes3.rx cF cX wss cX cort cfv cF cort cfv wss cF cA cC chj co cF chj
      co cX cF cA cC chj co mayetes3.f cA cC mayetes3.a mayetes3.c chjcli
      chub2i mayetes3.x sseqtr4i cF cX mayetes3.f cX cA cC chj co cF chj co cch
      mayetes3.x cA cC chj co cF cA cC mayetes3.a mayetes3.c chjcli mayetes3.f
      chjcli eqeltri chsscon3i mpbi sstri cR cF mayetes3.r mayetes3.f chsscon2i
      mpbi ssini cG cR mayetes3.g mayetes3.r chdmj1i sseqtr4i cA cC chj co cF
      chj co eqid cA cB cR chj co chj co cC cD cR chj co chj co cin cF cG cR
      chj co chj co cin eqid cB cD chj co cG chj co cR chj co cB cD chj co cR
      chj co cG cR chj co chj co cB cR chj co cD cR chj co chj co cG cR chj co
      chj co cB cD chj co cG cR cB cD mayetes3.b mayetes3.d chjcli mayetes3.g
      mayetes3.r chjjdiri cB cD chj co cR chj co cB cR chj co cD cR chj co chj
      co cG cR chj co chj cB cD cR mayetes3.b mayetes3.d mayetes3.r chjjdiri
      opreq1i eqtri mayete3i cR cA cC chj co cF chj co cA cB cR chj co chj co
      cC cD cR chj co chj co cin cF cG cR chj co chj co cin cin cB cD chj co cG
      chj co cR chj co mayetes3.r cA cC chj co cF chj co cA cB cR chj co chj co
      cC cD cR chj co chj co cin cF cG cR chj co chj co cin cA cC chj co cF cA
      cC mayetes3.a mayetes3.c chjcli mayetes3.f chjcli cA cB cR chj co chj co
      cC cD cR chj co chj co cin cF cG cR chj co chj co cA cB cR chj co chj co
      cC cD cR chj co chj co cA cB cR chj co mayetes3.a cB cR mayetes3.b
      mayetes3.r chjcli chjcli cC cD cR chj co mayetes3.c cD cR mayetes3.d
      mayetes3.r chjcli chjcli chincli cF cG cR chj co mayetes3.f cG cR
      mayetes3.g mayetes3.r chjcli chjcli chincli chincli cB cD chj co cG chj
      co cR cB cD chj co cG cB cD mayetes3.b mayetes3.d chjcli mayetes3.g
      chjcli mayetes3.r chjcli chlubii mp2an sstri cX cR chj co cA cC chj co cF
      chj co cR chj co cY cA cB chj co cC cD chj co cin cF cG chj co cin cX cA
      cC chj co cF chj co cR chj mayetes3.x opreq1i mayetes3.y ineq12i cZ cB cD
      chj co cG chj co cR chj mayetes3.z opreq1i 3sstr4i $.
      $( [12-May-2009] $) $( [10-May-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Zero and identity operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the Hilbert space zero operator.  See ~ df0op2 for alternate
     definition. $)
  df-h0op $a |- 0hop = ( proj ` 0H ) $.

  $( Define the Hilbert space identity operator.  See ~ dfiop2 for alternate
     definition. $)
  df-iop $a |- Iop = ( proj ` ~H ) $.

  $( Value of the zero Hilbert space operator (null projector).  Remark in
     [Beran] p. 111. $)
  ho0val $p |- ( A e. ~H -> ( 0hop ` A ) = 0h ) $=
    cA chil wcel cA ch0o cfv cA chil cpj cfv cfv cA chil cpj cfv cfv cmv co c0v
    cA chil wcel cA chil cort cfv cpj cfv cfv cA chil cpj cfv cfv cA chil cpj
    cfv cfv cmv co cA ch0o cfv chil cch wcel cA chil wcel cA chil cort cfv cpj
    cfv cfv cA chil cpj cfv cfv cA chil cpj cfv cfv cmv co wceq helch cA chil
    pjo mpan cA chil cort cfv cpj cfv ch0o chil cort cfv cpj cfv c0h cpj cfv
    ch0o chil cort cfv c0h cpj choc1 fveq2i df-h0op eqtr4i fveq1i syl5eqr cA
    chil wcel cA chil cpj cfv cfv chil wcel cA chil cpj cfv cfv cA chil cpj cfv
    cfv cmv co c0v wceq cA chil helch pjhcli cA chil cpj cfv cfv hvsubid syl
    eqtrd $.
    $( [8-Aug-2006] $) $( [7-Feb-2006] $)

  $( Functionality of the zero Hilbert space operator. $)
  ho0f $p |- 0hop : ~H --> ~H $=
    chil chil ch0o wf chil chil c0h cpj cfv wf c0h h0elch pjfi ch0o c0h cpj cfv
    wceq chil chil ch0o wf chil chil c0h cpj cfv wf wb df-h0op chil chil ch0o
    c0h cpj cfv feq1 ax-mp mpbir $.
    $( [7-Aug-2006] $) $( [10-Mar-2006] $)

  $( Alternate definition of Hilbert space zero operator. $)
  df0op2 $p |- 0hop = ( ~H X. 0H ) $=
    ch0o chil c0v csn cxp chil c0h cxp chil c0v csn ch0o wf ch0o chil c0v csn
    cxp wceq chil c0v csn ch0o wf ch0o chil wfn vx cv ch0o cfv c0v wceq vx chil
    wral vx chil c0v ch0o fconstfv chil chil ch0o wf ch0o chil wfn ho0f chil
    chil ch0o ffn ax-mp vx cv ch0o cfv c0v wceq vx chil vx cv ho0val rgen
    mpbir2an chil c0v ch0o c0v chil ax-hv0cl elisseti fconst2 mpbi c0h c0v csn
    chil df-ch0 xpeq2i eqtr4i $.
    $( [7-Aug-2006] $) $( [7-Aug-2006] $)

  $( Alternate definition of Hilbert space identity operator. $)
  dfiop2 $p  |- Iop = ( _I |` ~H ) $=
    chio chil cpj cfv cid chil cres df-iop chil cpj cfv chil wfn cid chil cres
    chil wfn chil cpj cfv cid chil cres wceq chil helch pjfni chil fnresi chil
    cpj cfv chil wfn cid chil cres chil wfn wa chil cpj cfv cid chil cres wceq
    vx cv chil cpj cfv cfv vx cv cid chil cres cfv wceq vx chil wral vx cv chil
    cpj cfv cfv vx cv cid chil cres cfv wceq vx chil vx cv chil wcel vx cv chil
    cpj cfv cfv vx cv vx cv cid chil cres cfv vx cv pjch1 chil vx cv fvresi
    eqtr4d rgen vx chil chil cpj cfv cid chil cres eqfnfv2 mpbiri mp2an eqtri
    $.
    $( [7-Aug-2006] $) $( [7-Aug-2006] $)

  $( Functionality of the Hilbert space identity operator. $)
  hoif $p |- Iop : ~H -1-1-onto-> ~H $=
    chil chil chio wf1o chil chil cid chil cres wf1o chil f1oi chio cid chil
    cres wceq chil chil chio wf1o chil chil cid chil cres wf1o wb dfiop2 chil
    chil chio cid chil cres f1oeq1 ax-mp mpbir $.
    $( [9-Aug-2006] $) $( [8-Aug-2006] $)

  $( The value of the Hilbert space identity operator. $)
  hoival $p |- ( A e. ~H -> ( Iop ` A ) = A ) $=
    cA chil wcel cA chil cpj cfv cfv cA cA chio cfv cA pjch1 cA chio chil cpj
    cfv df-iop fveq1i syl5eq $.
    $( [9-Aug-2006] $) $( [8-Aug-2006] $)

  $( Composition with the Hilbert space identity operator. $)
  hoico1 $p |- ( T : ~H --> ~H -> ( T o. Iop ) = T ) $=
    chil chil cT wf cT cid chil cres ccom cT cT chio ccom chil chil cT fcoi1
    chio cid chil cres cT dfiop2 coeq2i syl5eq $.
    $( [24-Aug-2006] $) $( [24-Aug-2006] $)

  $( Composition with the Hilbert space identity operator. $)
  hoico2 $p |- ( T : ~H --> ~H -> ( Iop o. T ) = T ) $=
    chil chil cT wf cid chil cres cT ccom cT chio cT ccom chil chil cT fcoi2
    chio cid chil cres cT dfiop2 coeq1i syl5eq $.
    $( [25-Aug-2006] $) $( [24-Aug-2006] $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Operations on Hilbert space operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y S $.  $d x y T $.
    $( The sum of Hilbert space operators is an operator. $)
    hoaddcl $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( S +op T ) : ~H --> ~H ) $=
      chil chil cS wf chil chil cT wf wa chil chil cS cT chos co wf chil chil
      vx cv chil wcel vy cv vx cv cS cfv vx cv cT cfv cva co wceq wa vx vy
      copab wf chil chil cS wf chil chil cT wf wa vx cv cS cfv vx cv cT cfv cva
      co chil wcel vx chil wral chil chil vx cv chil wcel vy cv vx cv cS cfv vx
      cv cT cfv cva co wceq wa vx vy copab wf chil chil cS wf chil chil cT wf
      wa vx cv cS cfv vx cv cT cfv cva co chil wcel vx chil chil chil cS wf
      chil chil cT wf vx cv chil wcel vx cv cS cfv vx cv cT cfv cva co chil
      wcel vx cv cS cfv chil wcel vx cv cT cfv chil wcel vx cv cS cfv vx cv cT
      cfv cva co chil wcel chil chil cS wf vx cv chil wcel wa chil chil cT wf
      vx cv chil wcel wa vx cv cS cfv vx cv cT cfv hvaddcl chil chil vx cv cS
      ffvelrn chil chil vx cv cT ffvelrn syl2an anandirs r19.21aiva vx vy chil
      chil vx cv cS cfv vx cv cT cfv cva co vx cv chil wcel vy cv vx cv cS cfv
      vx cv cT cfv cva co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cS
      cfv vx cv cT cfv cva co wceq wa vx vy copab eqid fopab2 sylib chil chil
      cS wf chil chil cT wf wa chil chil cS cT chos co vx cv chil wcel vy cv vx
      cv cS cfv vx cv cT cfv cva co wceq wa vx vy copab vx vy cS cT hosmval
      feq1d mpbird $.
      $( [22-Feb-2006] $) $( [21-Feb-2006] $)

    $( The scalar product of a Hilbert space operator is an operator. $)
    homulcl $p |- ( ( A e. CC /\ T : ~H --> ~H ) ->
                   ( A .op T ) : ~H --> ~H ) $=
      cA cc wcel chil chil cT wf wa chil chil cA cT chot co wf chil chil vx cv
      chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab wf cA cc wcel
      chil chil cT wf wa cA vx cv cT cfv csm co chil wcel vx chil wral chil
      chil vx cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab wf
      cA cc wcel chil chil cT wf wa cA vx cv cT cfv csm co chil wcel vx chil cA
      cc wcel chil chil cT wf vx cv chil wcel cA vx cv cT cfv csm co chil wcel
      cA cc wcel vx cv cT cfv chil wcel cA vx cv cT cfv csm co chil wcel chil
      chil cT wf vx cv chil wcel wa cA vx cv cT cfv hvmulcl chil chil vx cv cT
      ffvelrn sylan2 anassrs r19.21aiva vx vy chil chil cA vx cv cT cfv csm co
      vx cv chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab vx cv
      chil wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab eqid fopab2
      sylib cA cc wcel chil chil cT wf wa chil chil cA cT chot co vx cv chil
      wcel vy cv cA vx cv cT cfv csm co wceq wa vx vy copab vx vy cA cT hommval
      feq1d mpbird $.
      $( [22-Mar-2006] $) $( [21-Feb-2006] $)
  $}

  ${
    $d x T $.  $d x U $.
    $( Equality of Hilbert space operators. $)
    hoeq $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                ( A. x e. ~H ( T ` x ) = ( U ` x ) <-> T = U ) ) $=
      cT chil wfn cU chil wfn vx cv cT cfv vx cv cU cfv wceq vx chil wral cT cU
      wceq wb chil chil cT wf chil chil cU wf cT chil wfn cU chil wfn wa cT cU
      wceq vx cv cT cfv vx cv cU cfv wceq vx chil wral vx chil cT cU eqfnfv2
      bicomd chil chil cT ffn chil chil cU ffn syl2an $.
      $( [13-Aug-2006] $) $( [12-Aug-2006] $)
  $}

  ${
    $d x y S $.  $d x y T $.
    hoeq.1 $e |- S : ~H --> ~H $.
    hoeq.2 $e |- T : ~H --> ~H $.
    $( Equality of Hilbert space operators. $)
    hoeqi $p |- ( A. x e. ~H ( S ` x ) = ( T ` x ) <-> S = T ) $=
      chil chil cS wf chil chil cT wf vx cv cS cfv vx cv cT cfv wceq vx chil
      wral cS cT wceq wb hoeq.1 hoeq.2 vx cS cT hoeq mp2an $.
      $( [14-Nov-2000] $)

    $( Closure of Hilbert space operator sum. $)
    hoscli $p |- ( A e. ~H -> ( ( S +op T ) ` A ) e. ~H ) $=
      chil chil cS wf chil chil cT wf cA chil wcel cA cS cT chos co cfv chil
      wcel hoeq.1 hoeq.2 cA cS cT hoscl mpanl12 $.
      $( [12-Nov-2000] $)

    $( Closure of Hilbert space operator difference. $)
    hodcli $p |- ( A e. ~H -> ( ( S -op T ) ` A ) e. ~H ) $=
      chil chil cS wf chil chil cT wf cA chil wcel cA cS cT chod co cfv chil
      wcel hoeq.1 hoeq.2 cA cS cT hodcl mpanl12 $.
      $( [12-Nov-2000] $)

    $( Composition of Hilbert space operators. $)
    hocoi $p |- ( A e. ~H -> ( ( S o. T ) ` A ) = ( S ` ( T ` A ) ) ) $=
      cA chil wcel cA cT cdm wcel cA cS cT ccom cfv cA cT cfv cS cfv wceq cT
      cdm chil cA chil chil cT hoeq.2 fdmi eleq2i cS wfun cT wfun cA cT cdm
      wcel cA cS cT ccom cfv cA cT cfv cS cfv wceq chil chil cS wf cS wfun
      hoeq.1 chil chil cS ffun ax-mp chil chil cT wf cT wfun hoeq.2 chil chil
      cT ffun ax-mp cA cS cT fvco mp3an12 sylbir $.
      $( [12-Nov-2000] $)

    $( Closure of composition of Hilbert space operators. $)
    hococli $p |- ( A e. ~H -> ( ( S o. T ) ` A ) e. ~H ) $=
      cA chil wcel cA cS cT ccom cfv cA cT cfv cS cfv chil cA cS cT hoeq.1
      hoeq.2 hocoi cA chil wcel cA cT cfv chil wcel cA cT cfv cS cfv chil wcel
      chil chil cA cT hoeq.2 ffvelrni chil chil cA cT cfv cS hoeq.1 ffvelrni
      syl eqeltrd $.
      $( [12-Nov-2000] $)

    $( Mapping of composition of Hilbert space operators. $)
    hocofi $p |- ( S o. T ) : ~H --> ~H $=
      chil chil cS wf chil chil cT wf chil chil cS cT ccom wf hoeq.1 hoeq.2
      chil chil chil cS cT fco mp2an $.
      $( [14-Nov-2000] $)

    $( Functionality of composition of Hilbert space operators. $)
    hocofni $p |- ( S o. T ) Fn ~H $=
      chil chil cS cT ccom wf cS cT ccom chil wfn cS cT hoeq.1 hoeq.2 hocofi
      chil chil cS cT ccom ffn ax-mp $.
      $( [12-Nov-2000] $)

    $( Mapping of sum of Hilbert space operators. $)
    hoaddcli $p |- ( S +op T ) : ~H --> ~H $=
      chil chil cS wf chil chil cT wf chil chil cS cT chos co wf hoeq.1 hoeq.2
      cS cT hoaddcl mp2an $.
      $( [14-Nov-2000] $)

    $( Mapping of difference of Hilbert space operators. $)
    hosubcli $p |- ( S -op T ) : ~H --> ~H $=
      vx vy chil chil vx cv cS cfv vx cv cT cfv cmv co cS cT chod co chil chil
      cS wf chil chil cT wf cS cT chod co vx cv chil wcel vy cv vx cv cS cfv vx
      cv cT cfv cmv co wceq wa vx vy copab wceq hoeq.1 hoeq.2 vx vy cS cT
      hodmval mp2an vx cv cS cfv chil wcel vx cv cT cfv chil wcel vx cv cS cfv
      vx cv cT cfv cmv co chil wcel vx cv chil wcel vx cv cS cfv vx cv cT cfv
      hvsubcl chil chil vx cv cS hoeq.1 ffvelrni chil chil vx cv cT hoeq.2
      ffvelrni sylanc fopab $.
      $( [14-Nov-2000] $)

    $( Functionality of sum of Hilbert space operators. $)
    hoaddfni $p |- ( S +op T ) Fn ~H $=
      chil chil cS cT chos co wf cS cT chos co chil wfn cS cT hoeq.1 hoeq.2
      hoaddcli chil chil cS cT chos co ffn ax-mp $.
      $( [14-Nov-2000] $)

    $( Functionality of difference of Hilbert space operators. $)
    hosubfni $p |- ( S -op T ) Fn ~H $=
      chil chil cS cT chod co wf cS cT chod co chil wfn cS cT hoeq.1 hoeq.2
      hosubcli chil chil cS cT chod co ffn ax-mp $.
      $( [30-Jun-2006] $) $( [2-Jun-2006] $)

    $( Commutativity of sum of Hilbert space operators. $)
    hoaddcomi $p |- ( S +op T ) = ( T +op S ) $=
      vx cv cS cT chos co cfv vx cv cT cS chos co cfv wceq vx chil wral cS cT
      chos co cT cS chos co wceq vx cv cS cT chos co cfv vx cv cT cS chos co
      cfv wceq vx chil vx cv chil wcel vx cv cS cfv vx cv cT cfv cva co vx cv
      cT cfv vx cv cS cfv cva co vx cv cS cT chos co cfv vx cv cT cS chos co
      cfv vx cv cS cfv chil wcel vx cv cT cfv chil wcel vx cv cS cfv vx cv cT
      cfv cva co vx cv cT cfv vx cv cS cfv cva co wceq vx cv chil wcel vx cv cS
      cfv vx cv cT cfv ax-hvcom chil chil vx cv cS hoeq.1 ffvelrni chil chil vx
      cv cT hoeq.2 ffvelrni sylanc chil chil cS wf chil chil cT wf vx cv chil
      wcel vx cv cS cT chos co cfv vx cv cS cfv vx cv cT cfv cva co wceq hoeq.1
      hoeq.2 vx cv cS cT hosvalOLD mpanl12 chil chil cT wf chil chil cS wf vx
      cv chil wcel vx cv cT cS chos co cfv vx cv cT cfv vx cv cS cfv cva co
      wceq hoeq.2 hoeq.1 vx cv cT cS hosvalOLD mpanl12 3eqtr4d rgen vx cS cT
      chos co cT cS chos co cS cT hoeq.1 hoeq.2 hoaddcli cT cS hoeq.2 hoeq.1
      hoaddcli hoeqi mpbi $.
      $( [15-Nov-2000] $)
  $}

  $( Mapping of difference of Hilbert space operators. $)
  hosubcl $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
              ( S -op T ) : ~H --> ~H ) $=
    chil chil cS wf chil chil cT wf chil chil cS cT chod co wf chil chil chil
    chil cS wf cS ch0o cif cT chod co wf chil chil chil chil cS wf cS ch0o cif
    chil chil cT wf cT ch0o cif chod co wf cS cT ch0o ch0o cS chil chil cS wf
    cS ch0o cif wceq chil chil cS cT chod co chil chil cS wf cS ch0o cif cT
    chod co cS chil chil cS wf cS ch0o cif cT chod opreq1 feq1d cT chil chil cT
    wf cT ch0o cif wceq chil chil chil chil cS wf cS ch0o cif cT chod co chil
    chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif chod co cT chil chil cT
    wf cT ch0o cif chil chil cS wf cS ch0o cif chod opreq2 feq1d chil chil cS
    wf cS ch0o cif chil chil cT wf cT ch0o cif chil chil cS ch0o ho0f elimf
    chil chil cT ch0o ho0f elimf hosubcli dedth2h $.
    $( [25-Aug-2006] $) $( [23-Aug-2006] $)

  $( Commutativity of sum of Hilbert space operators. $)
  hoaddcom $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( S +op T ) = ( T +op S ) ) $=
    chil chil cS wf chil chil cT wf cS cT chos co cT cS chos co wceq chil chil
    cS wf cS ch0o cif cT chos co cT chil chil cS wf cS ch0o cif chos co wceq
    chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif chos co chil chil
    cT wf cT ch0o cif chil chil cS wf cS ch0o cif chos co wceq cS cT ch0o ch0o
    cS chil chil cS wf cS ch0o cif wceq cS cT chos co chil chil cS wf cS ch0o
    cif cT chos co cT cS chos co cT chil chil cS wf cS ch0o cif chos co cS chil
    chil cS wf cS ch0o cif cT chos opreq1 cS chil chil cS wf cS ch0o cif cT
    chos opreq2 eqeq12d cT chil chil cT wf cT ch0o cif wceq chil chil cS wf cS
    ch0o cif cT chos co chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif
    chos co cT chil chil cS wf cS ch0o cif chos co chil chil cT wf cT ch0o cif
    chil chil cS wf cS ch0o cif chos co cT chil chil cT wf cT ch0o cif chil
    chil cS wf cS ch0o cif chos opreq2 cT chil chil cT wf cT ch0o cif chil chil
    cS wf cS ch0o cif chos opreq1 eqeq12d chil chil cS wf cS ch0o cif chil chil
    cT wf cT ch0o cif chil chil cS ch0o ho0f elimf chil chil cT ch0o ho0f elimf
    hoaddcomi dedth2h $.
    $( [26-Aug-2006] $) $( [24-Aug-2006] $)

  ${
    $d x R $.  $d x S $.  $d x T $.
    hods.1 $e |- R : ~H --> ~H $.
    hods.2 $e |- S : ~H --> ~H $.
    hods.3 $e |- T : ~H --> ~H $.
    $( Relationship between Hilbert space operator difference and sum. $)
    hodsi $p |- ( ( R -op S ) = T <-> ( S +op T ) = R ) $=
      vx cv cR cS chod co cfv vx cv cT cfv wceq vx chil wral vx cv cS cT chos
      co cfv vx cv cR cfv wceq vx chil wral cR cS chod co cT wceq cS cT chos co
      cR wceq vx cv cR cS chod co cfv vx cv cT cfv wceq vx cv cS cT chos co cfv
      vx cv cR cfv wceq vx chil vx cv chil wcel vx cv cR cfv vx cv cS cfv cmv
      co vx cv cT cfv wceq vx cv cS cfv vx cv cT cfv cva co vx cv cR cfv wceq
      vx cv cR cS chod co cfv vx cv cT cfv wceq vx cv cS cT chos co cfv vx cv
      cR cfv wceq vx cv cR cfv chil wcel vx cv cS cfv chil wcel vx cv cT cfv
      chil wcel vx cv cR cfv vx cv cS cfv cmv co vx cv cT cfv wceq vx cv cS cfv
      vx cv cT cfv cva co vx cv cR cfv wceq wb vx cv chil wcel vx cv cR cfv vx
      cv cS cfv vx cv cT cfv hvsubadd chil chil vx cv cR hods.1 ffvelrni chil
      chil vx cv cS hods.2 ffvelrni chil chil vx cv cT hods.3 ffvelrni syl3anc
      vx cv chil wcel vx cv cR cS chod co cfv vx cv cR cfv vx cv cS cfv cmv co
      vx cv cT cfv chil chil cR wf chil chil cS wf vx cv chil wcel vx cv cR cS
      chod co cfv vx cv cR cfv vx cv cS cfv cmv co wceq hods.1 hods.2 vx cv cR
      cS hodvalOLD mpanl12 eqeq1d vx cv chil wcel vx cv cS cT chos co cfv vx cv
      cS cfv vx cv cT cfv cva co vx cv cR cfv chil chil cS wf chil chil cT wf
      vx cv chil wcel vx cv cS cT chos co cfv vx cv cS cfv vx cv cT cfv cva co
      wceq hods.2 hods.3 vx cv cS cT hosvalOLD mpanl12 eqeq1d 3bitr4d ralbiia
      vx cR cS chod co cT cR cS hods.1 hods.2 hosubcli hods.3 hoeqi vx cS cT
      chos co cR cS cT hods.2 hods.3 hoaddcli hods.1 hoeqi 3bitr3i $.
      $( [17-Nov-2000] $)

    $( Associativity of sum of Hilbert space operators. $)
    hoaddassi $p |- ( ( R +op S ) +op T ) = ( R +op ( S +op T ) ) $=
      vx cv cR cS chos co cT chos co cfv vx cv cR cS cT chos co chos co cfv
      wceq vx chil wral cR cS chos co cT chos co cR cS cT chos co chos co wceq
      vx cv cR cS chos co cT chos co cfv vx cv cR cS cT chos co chos co cfv
      wceq vx chil vx cv chil wcel vx cv cR cfv vx cv cS cfv cva co vx cv cT
      cfv cva co vx cv cR cfv vx cv cS cfv vx cv cT cfv cva co cva co vx cv cR
      cS chos co cT chos co cfv vx cv cR cS cT chos co chos co cfv vx cv cR cfv
      chil wcel vx cv cS cfv chil wcel vx cv cT cfv chil wcel vx cv cR cfv vx
      cv cS cfv cva co vx cv cT cfv cva co vx cv cR cfv vx cv cS cfv vx cv cT
      cfv cva co cva co wceq vx cv chil wcel vx cv cR cfv vx cv cS cfv vx cv cT
      cfv ax-hvass chil chil vx cv cR hods.1 ffvelrni chil chil vx cv cS hods.2
      ffvelrni chil chil vx cv cT hods.3 ffvelrni syl3anc vx cv chil wcel vx cv
      cR cS chos co cT chos co cfv vx cv cR cS chos co cfv vx cv cT cfv cva co
      vx cv cR cfv vx cv cS cfv cva co vx cv cT cfv cva co chil chil cR cS chos
      co wf chil chil cT wf vx cv chil wcel vx cv cR cS chos co cT chos co cfv
      vx cv cR cS chos co cfv vx cv cT cfv cva co wceq cR cS hods.1 hods.2
      hoaddcli hods.3 vx cv cR cS chos co cT hosvalOLD mpanl12 vx cv chil wcel
      vx cv cR cS chos co cfv vx cv cR cfv vx cv cS cfv cva co vx cv cT cfv cva
      chil chil cR wf chil chil cS wf vx cv chil wcel vx cv cR cS chos co cfv
      vx cv cR cfv vx cv cS cfv cva co wceq hods.1 hods.2 vx cv cR cS hosvalOLD
      mpanl12 opreq1d eqtrd vx cv chil wcel vx cv cR cS cT chos co chos co cfv
      vx cv cR cfv vx cv cS cT chos co cfv cva co vx cv cR cfv vx cv cS cfv vx
      cv cT cfv cva co cva co chil chil cR wf chil chil cS cT chos co wf vx cv
      chil wcel vx cv cR cS cT chos co chos co cfv vx cv cR cfv vx cv cS cT
      chos co cfv cva co wceq hods.1 cS cT hods.2 hods.3 hoaddcli vx cv cR cS
      cT chos co hosvalOLD mpanl12 vx cv chil wcel vx cv cS cT chos co cfv vx
      cv cS cfv vx cv cT cfv cva co vx cv cR cfv cva chil chil cS wf chil chil
      cT wf vx cv chil wcel vx cv cS cT chos co cfv vx cv cS cfv vx cv cT cfv
      cva co wceq hods.2 hods.3 vx cv cS cT hosvalOLD mpanl12 opreq2d eqtrd
      3eqtr4d rgen vx cR cS chos co cT chos co cR cS cT chos co chos co cR cS
      chos co cT cR cS hods.1 hods.2 hoaddcli hods.3 hoaddcli cR cS cT chos co
      hods.1 cS cT hods.2 hods.3 hoaddcli hoaddcli hoeqi mpbi $.
      $( [26-Nov-2000] $)

    $( Commutative/associative law for Hilbert space operator sum that swaps
       the first two terms. $)
    hoadd12i $p |- ( R +op ( S +op T ) ) = ( S +op ( R +op T ) ) $=
      cR cS chos co cT chos co cS cR chos co cT chos co cR cS cT chos co chos
      co cS cR cT chos co chos co cR cS chos co cS cR chos co cT chos cR cS
      hods.1 hods.2 hoaddcomi opreq1i cR cS cT hods.1 hods.2 hods.3 hoaddassi
      cS cR cT hods.2 hods.1 hods.3 hoaddassi 3eqtr3i $.
      $( [21-Sep-2004] $) $( [27-Aug-2004] $)

    $( Commutative/associative law for Hilbert space operator sum that swaps
       the second and third terms. $)
    hoadd23i $p |- ( ( R +op S ) +op T ) = ( ( R +op T ) +op S ) $=
      cR cS cT chos co chos co cR cT cS chos co chos co cR cS chos co cT chos
      co cR cT chos co cS chos co cS cT chos co cT cS chos co cR chos cS cT
      hods.2 hods.3 hoaddcomi opreq2i cR cS cT hods.1 hods.2 hods.3 hoaddassi
      cR cT cS hods.1 hods.3 hods.2 hoaddassi 3eqtr4i $.
      $( [28-Jul-2006] $) $( [27-Jul-2006] $)

    $( Distributive law for Hilbert space operator sum. $)
    hocadddiri $p |- ( ( R +op S ) o. T ) = ( ( R o. T ) +op ( S o. T ) ) $=
      vx cv cR cS chos co cT ccom cfv vx cv cR cT ccom cS cT ccom chos co cfv
      wceq vx chil wral cR cS chos co cT ccom cR cT ccom cS cT ccom chos co
      wceq vx cv cR cS chos co cT ccom cfv vx cv cR cT ccom cS cT ccom chos co
      cfv wceq vx chil vx cv chil wcel vx cv cT cfv cR cS chos co cfv vx cv cR
      cT ccom cfv vx cv cS cT ccom cfv cva co vx cv cR cS chos co cT ccom cfv
      vx cv cR cT ccom cS cT ccom chos co cfv vx cv chil wcel vx cv cT cfv cR
      cS chos co cfv vx cv cT cfv cR cfv vx cv cT cfv cS cfv cva co vx cv cR cT
      ccom cfv vx cv cS cT ccom cfv cva co vx cv chil wcel vx cv cT cfv chil
      wcel vx cv cT cfv cR cS chos co cfv vx cv cT cfv cR cfv vx cv cT cfv cS
      cfv cva co wceq chil chil vx cv cT hods.3 ffvelrni chil chil cR wf chil
      chil cS wf vx cv cT cfv chil wcel vx cv cT cfv cR cS chos co cfv vx cv cT
      cfv cR cfv vx cv cT cfv cS cfv cva co wceq hods.1 hods.2 vx cv cT cfv cR
      cS hosvalOLD mpanl12 syl vx cv chil wcel vx cv cR cT ccom cfv vx cv cT
      cfv cR cfv vx cv cS cT ccom cfv vx cv cT cfv cS cfv cva vx cv cR cT
      hods.1 hods.3 hocoi vx cv cS cT hods.2 hods.3 hocoi opreq12d eqtr4d vx cv
      cR cS chos co cT cR cS hods.1 hods.2 hoaddcli hods.3 hocoi chil chil cR
      cT ccom wf chil chil cS cT ccom wf vx cv chil wcel vx cv cR cT ccom cS cT
      ccom chos co cfv vx cv cR cT ccom cfv vx cv cS cT ccom cfv cva co wceq cR
      cT hods.1 hods.3 hocofi cS cT hods.2 hods.3 hocofi vx cv cR cT ccom cS cT
      ccom hosvalOLD mpanl12 3eqtr4d rgen vx cR cS chos co cT ccom cR cT ccom
      cS cT ccom chos co cR cS chos co cT cR cS hods.1 hods.2 hoaddcli hods.3
      hocofi cR cT ccom cS cT ccom cR cT hods.1 hods.3 hocofi cS cT hods.2
      hods.3 hocofi hoaddcli hoeqi mpbi $.
      $( [26-Nov-2000] $)

    $( Distributive law for Hilbert space operator difference. $)
    hocsubdiri $p |- ( ( R -op S ) o. T ) = ( ( R o. T ) -op ( S o. T ) ) $=
      vx cv cR cS chod co cT ccom cfv vx cv cR cT ccom cS cT ccom chod co cfv
      wceq vx chil wral cR cS chod co cT ccom cR cT ccom cS cT ccom chod co
      wceq vx cv cR cS chod co cT ccom cfv vx cv cR cT ccom cS cT ccom chod co
      cfv wceq vx chil vx cv chil wcel vx cv cT cfv cR cS chod co cfv vx cv cR
      cT ccom cfv vx cv cS cT ccom cfv cmv co vx cv cR cS chod co cT ccom cfv
      vx cv cR cT ccom cS cT ccom chod co cfv vx cv chil wcel vx cv cT cfv cR
      cS chod co cfv vx cv cT cfv cR cfv vx cv cT cfv cS cfv cmv co vx cv cR cT
      ccom cfv vx cv cS cT ccom cfv cmv co vx cv chil wcel vx cv cT cfv chil
      wcel vx cv cT cfv cR cS chod co cfv vx cv cT cfv cR cfv vx cv cT cfv cS
      cfv cmv co wceq chil chil vx cv cT hods.3 ffvelrni chil chil cR wf chil
      chil cS wf vx cv cT cfv chil wcel vx cv cT cfv cR cS chod co cfv vx cv cT
      cfv cR cfv vx cv cT cfv cS cfv cmv co wceq hods.1 hods.2 vx cv cT cfv cR
      cS hodvalOLD mpanl12 syl vx cv chil wcel vx cv cR cT ccom cfv vx cv cT
      cfv cR cfv vx cv cS cT ccom cfv vx cv cT cfv cS cfv cmv vx cv cR cT
      hods.1 hods.3 hocoi vx cv cS cT hods.2 hods.3 hocoi opreq12d eqtr4d vx cv
      cR cS chod co cT cR cS hods.1 hods.2 hosubcli hods.3 hocoi chil chil cR
      cT ccom wf chil chil cS cT ccom wf vx cv chil wcel vx cv cR cT ccom cS cT
      ccom chod co cfv vx cv cR cT ccom cfv vx cv cS cT ccom cfv cmv co wceq cR
      cT hods.1 hods.3 hocofi cS cT hods.2 hods.3 hocofi vx cv cR cT ccom cS cT
      ccom hodvalOLD mpanl12 3eqtr4d rgen vx cR cS chod co cT ccom cR cT ccom
      cS cT ccom chod co cR cS chod co cT cR cS hods.1 hods.2 hosubcli hods.3
      hocofi cR cT ccom cS cT ccom cR cT hods.1 hods.3 hocofi cS cT hods.2
      hods.3 hocofi hosubcli hoeqi mpbi $.
      $( [26-Nov-2000] $)

    $( Double composition of Hilbert space operators. $)
    ho2coi $p |- ( A e. ~H -> ( ( ( R o. S ) o. T ) ` A ) =
                 ( R ` ( S ` ( T ` A ) ) ) ) $=
      cA chil wcel cA cR cS ccom cT ccom cfv cA cT cfv cR cS ccom cfv cA cT cfv
      cS cfv cR cfv cA cR cS ccom cT cR cS hods.1 hods.2 hocofi hods.3 hocoi cA
      chil wcel cA cT cfv chil wcel cA cT cfv cR cS ccom cfv cA cT cfv cS cfv
      cR cfv wceq chil chil cA cT hods.3 ffvelrni cA cT cfv cR cS hods.1 hods.2
      hocoi syl eqtrd $.
      $( [1-Dec-2000] $)
  $}

  $( Associativity of sum of Hilbert space operators. $)
  hoaddass $p |- ( ( R : ~H --> ~H /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( ( R +op S ) +op T ) = ( R +op ( S +op T ) ) ) $=
    chil chil cR wf chil chil cS wf chil chil cT wf cR cS chos co cT chos co cR
    cS cT chos co chos co wceq chil chil cR wf cR ch0o cif cS chos co cT chos
    co chil chil cR wf cR ch0o cif cS cT chos co chos co wceq cR cS cT ch0o
    ch0o ch0o chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif chos co
    cT chos co chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif cT chos
    co chos co wceq chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif
    chos co chil chil cT wf cT ch0o cif chos co chil chil cR wf cR ch0o cif
    chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif chos co chos co
    wceq cR chil chil cR wf cR ch0o cif wceq cR cS chos co cT chos co chil chil
    cR wf cR ch0o cif cS chos co cT chos co cR cS cT chos co chos co chil chil
    cR wf cR ch0o cif cS cT chos co chos co cR chil chil cR wf cR ch0o cif wceq
    cR cS chos co chil chil cR wf cR ch0o cif cS chos co cT chos cR chil chil
    cR wf cR ch0o cif cS chos opreq1 opreq1d cR chil chil cR wf cR ch0o cif cS
    cT chos co chos opreq1 eqeq12d cS chil chil cS wf cS ch0o cif wceq chil
    chil cR wf cR ch0o cif cS chos co cT chos co chil chil cR wf cR ch0o cif
    chil chil cS wf cS ch0o cif chos co cT chos co chil chil cR wf cR ch0o cif
    cS cT chos co chos co chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o
    cif cT chos co chos co cS chil chil cS wf cS ch0o cif wceq chil chil cR wf
    cR ch0o cif cS chos co chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o
    cif chos co cT chos cS chil chil cS wf cS ch0o cif chil chil cR wf cR ch0o
    cif chos opreq2 opreq1d cS chil chil cS wf cS ch0o cif wceq cS cT chos co
    chil chil cS wf cS ch0o cif cT chos co chil chil cR wf cR ch0o cif chos cS
    chil chil cS wf cS ch0o cif cT chos opreq1 opreq2d eqeq12d cT chil chil cT
    wf cT ch0o cif wceq chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif
    chos co cT chos co chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif
    chos co chil chil cT wf cT ch0o cif chos co chil chil cR wf cR ch0o cif
    chil chil cS wf cS ch0o cif cT chos co chos co chil chil cR wf cR ch0o cif
    chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif chos co chos co cT
    chil chil cT wf cT ch0o cif chil chil cR wf cR ch0o cif chil chil cS wf cS
    ch0o cif chos co chos opreq2 cT chil chil cT wf cT ch0o cif wceq chil chil
    cS wf cS ch0o cif cT chos co chil chil cS wf cS ch0o cif chil chil cT wf cT
    ch0o cif chos co chil chil cR wf cR ch0o cif chos cT chil chil cT wf cT
    ch0o cif chil chil cS wf cS ch0o cif chos opreq2 opreq2d eqeq12d chil chil
    cR wf cR ch0o cif chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif
    chil chil cR ch0o ho0f elimf chil chil cS ch0o ho0f elimf chil chil cT ch0o
    ho0f elimf hoaddassi dedth3h $.
    $( [25-Aug-2006] $) $( [24-Aug-2006] $)

  $( Commutative/associative law for Hilbert space operator sum that swaps
     the second and third terms. $)
  hoadd23 $p |- ( ( R : ~H --> ~H /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( ( R +op S ) +op T ) = ( ( R +op T ) +op S ) ) $=
    chil chil cR wf chil chil cS wf chil chil cT wf w3a cR cS cT chos co chos
    co cR cT cS chos co chos co cR cS chos co cT chos co cR cT chos co cS chos
    co chil chil cR wf chil chil cS wf chil chil cT wf w3a cS cT chos co cT cS
    chos co cR chos chil chil cS wf chil chil cT wf cS cT chos co cT cS chos co
    wceq chil chil cR wf cS cT hoaddcom 3adant1 opreq2d cR cS cT hoaddass chil
    chil cR wf chil chil cT wf chil chil cS wf cR cT chos co cS chos co cR cT
    cS chos co chos co wceq cR cT cS hoaddass 3com23 3eqtr4d $.
    $( [26-Aug-2006] $) $( [24-Aug-2006] $)

  $( Rearrangement of 4 terms in a sum of Hilbert space operators. $)
  hoadd4 $p |- ( ( ( R : ~H --> ~H /\ S : ~H --> ~H ) /\
      ( T : ~H --> ~H /\ U : ~H --> ~H ) ) -> ( ( R +op S ) +op ( T +op U ) ) =
                ( ( R +op T ) +op ( S +op U ) ) ) $=
    chil chil cR wf chil chil cS wf wa chil chil cT wf chil chil cU wf wa wa cR
    cS chos co cT chos co cU chos co cR cT chos co cS chos co cU chos co cR cS
    chos co cT cU chos co chos co cR cT chos co cS cU chos co chos co chil chil
    cR wf chil chil cS wf wa chil chil cT wf cR cS chos co cT chos co cU chos
    co cR cT chos co cS chos co cU chos co wceq chil chil cU wf chil chil cR wf
    chil chil cS wf chil chil cT wf cR cS chos co cT chos co cU chos co cR cT
    chos co cS chos co cU chos co wceq chil chil cR wf chil chil cS wf chil
    chil cT wf w3a cR cS chos co cT chos co cR cT chos co cS chos co cU chos cR
    cS cT hoadd23 opreq1d 3expa adantrr chil chil cR cS chos co wf chil chil cT
    wf chil chil cU wf wa cR cS chos co cT chos co cU chos co cR cS chos co cT
    cU chos co chos co wceq chil chil cR wf chil chil cS wf wa chil chil cR cS
    chos co wf chil chil cT wf chil chil cU wf cR cS chos co cT chos co cU chos
    co cR cS chos co cT cU chos co chos co wceq cR cS chos co cT cU hoaddass
    3expb cR cS hoaddcl sylan chil chil cR wf chil chil cT wf chil chil cS wf
    chil chil cU wf cR cT chos co cS chos co cU chos co cR cT chos co cS cU
    chos co chos co wceq chil chil cR cT chos co wf chil chil cS wf chil chil
    cU wf wa cR cT chos co cS chos co cU chos co cR cT chos co cS cU chos co
    chos co wceq chil chil cR wf chil chil cT wf wa chil chil cR cT chos co wf
    chil chil cS wf chil chil cU wf cR cT chos co cS chos co cU chos co cR cT
    chos co cS cU chos co chos co wceq cR cT chos co cS cU hoaddass 3expb cR cT
    hoaddcl sylan an4s 3eqtr3d $.
    $( [27-Aug-2006] $) $( [24-Aug-2006] $)

  $( Distributive law for Hilbert space operator difference. $)
  hocsubdir $p |- ( ( R : ~H --> ~H /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( ( R -op S ) o. T ) = ( ( R o. T ) -op ( S o. T ) ) ) $=
    chil chil cR wf chil chil cS wf chil chil cT wf cR cS chod co cT ccom cR cT
    ccom cS cT ccom chod co wceq chil chil cR wf cR ch0o cif cS chod co cT ccom
    chil chil cR wf cR ch0o cif cT ccom cS cT ccom chod co wceq cR cS cT ch0o
    ch0o ch0o chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif chod co
    cT ccom chil chil cR wf cR ch0o cif cT ccom chil chil cS wf cS ch0o cif cT
    ccom chod co wceq chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif
    chod co chil chil cT wf cT ch0o cif ccom chil chil cR wf cR ch0o cif chil
    chil cT wf cT ch0o cif ccom chil chil cS wf cS ch0o cif chil chil cT wf cT
    ch0o cif ccom chod co wceq cR chil chil cR wf cR ch0o cif wceq cR cS chod
    co cT ccom chil chil cR wf cR ch0o cif cS chod co cT ccom cR cT ccom cS cT
    ccom chod co chil chil cR wf cR ch0o cif cT ccom cS cT ccom chod co cR chil
    chil cR wf cR ch0o cif wceq cR cS chod co chil chil cR wf cR ch0o cif cS
    chod co cT cR chil chil cR wf cR ch0o cif cS chod opreq1 coeq1d cR chil
    chil cR wf cR ch0o cif wceq cR cT ccom chil chil cR wf cR ch0o cif cT ccom
    cS cT ccom chod cR chil chil cR wf cR ch0o cif cT coeq1 opreq1d eqeq12d cS
    chil chil cS wf cS ch0o cif wceq chil chil cR wf cR ch0o cif cS chod co cT
    ccom chil chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif chod co cT
    ccom chil chil cR wf cR ch0o cif cT ccom cS cT ccom chod co chil chil cR wf
    cR ch0o cif cT ccom chil chil cS wf cS ch0o cif cT ccom chod co cS chil
    chil cS wf cS ch0o cif wceq chil chil cR wf cR ch0o cif cS chod co chil
    chil cR wf cR ch0o cif chil chil cS wf cS ch0o cif chod co cT cS chil chil
    cS wf cS ch0o cif chil chil cR wf cR ch0o cif chod opreq2 coeq1d cS chil
    chil cS wf cS ch0o cif wceq cS cT ccom chil chil cS wf cS ch0o cif cT ccom
    chil chil cR wf cR ch0o cif cT ccom chod cS chil chil cS wf cS ch0o cif cT
    coeq1 opreq2d eqeq12d cT chil chil cT wf cT ch0o cif wceq chil chil cR wf
    cR ch0o cif chil chil cS wf cS ch0o cif chod co cT ccom chil chil cR wf cR
    ch0o cif chil chil cS wf cS ch0o cif chod co chil chil cT wf cT ch0o cif
    ccom chil chil cR wf cR ch0o cif cT ccom chil chil cS wf cS ch0o cif cT
    ccom chod co chil chil cR wf cR ch0o cif chil chil cT wf cT ch0o cif ccom
    chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif ccom chod co cT
    chil chil cT wf cT ch0o cif chil chil cR wf cR ch0o cif chil chil cS wf cS
    ch0o cif chod co coeq2 cT chil chil cT wf cT ch0o cif wceq chil chil cR wf
    cR ch0o cif cT ccom chil chil cR wf cR ch0o cif chil chil cT wf cT ch0o cif
    ccom chil chil cS wf cS ch0o cif cT ccom chil chil cS wf cS ch0o cif chil
    chil cT wf cT ch0o cif ccom chod cT chil chil cT wf cT ch0o cif chil chil
    cR wf cR ch0o cif coeq2 cT chil chil cT wf cT ch0o cif chil chil cS wf cS
    ch0o cif coeq2 opreq12d eqeq12d chil chil cR wf cR ch0o cif chil chil cS wf
    cS ch0o cif chil chil cT wf cT ch0o cif chil chil cR ch0o ho0f elimf chil
    chil cS ch0o ho0f elimf chil chil cT ch0o ho0f elimf hocsubdiri dedth3h $.
    $( [27-Aug-2006] $) $( [23-Aug-2006] $)

  ${
    $d x T $.
    hoaddid1.1 $e |- T : ~H --> ~H $.
    $( Sum of a Hilbert space operator with the zero operator. $)
    hoaddid1i $p |- ( T +op 0hop ) = T $=
      vx cv cT ch0o chos co cfv vx cv cT cfv wceq vx chil wral cT ch0o chos co
      cT wceq vx cv cT ch0o chos co cfv vx cv cT cfv wceq vx chil vx cv chil
      wcel vx cv cT ch0o chos co cfv vx cv cT cfv vx cv ch0o cfv cva co vx cv
      cT cfv c0v cva co vx cv cT cfv chil chil cT wf chil chil ch0o wf vx cv
      chil wcel vx cv cT ch0o chos co cfv vx cv cT cfv vx cv ch0o cfv cva co
      wceq hoaddid1.1 ho0f vx cv cT ch0o hosval mp3an12 vx cv chil wcel vx cv
      ch0o cfv c0v vx cv cT cfv cva vx cv ho0val opreq2d vx cv chil wcel vx cv
      cT cfv chil wcel vx cv cT cfv c0v cva co vx cv cT cfv wceq chil chil vx
      cv cT hoaddid1.1 ffvelrni vx cv cT cfv ax-hvaddid syl 3eqtrd rgen vx cT
      ch0o chos co cT cT ch0o hoaddid1.1 ho0f hoaddcli hoaddid1.1 hoeqi mpbi $.
      $( [13-Aug-2006] $) $( [15-Nov-2000] $)

    $( Difference of a Hilbert space operator from itself. $)
    hodidi $p |- ( T -op T ) = 0hop $=
      cT cT chod co ch0o wceq cT ch0o chos co cT wceq cT hoaddid1.1 hoaddid1i
      cT cT ch0o hoaddid1.1 hoaddid1.1 ho0f hodsi mpbir $.
      $( [30-Jul-2007] $) $( [10-Mar-2006] $)

    $( Composition of the zero operator and a Hilbert space operator. $)
    ho0coi $p |- ( 0hop o. T ) = 0hop $=
      vx cv ch0o cT ccom cfv vx cv ch0o cfv wceq vx chil wral ch0o cT ccom ch0o
      wceq vx cv ch0o cT ccom cfv vx cv ch0o cfv wceq vx chil vx cv chil wcel
      vx cv cT cfv ch0o cfv c0v vx cv ch0o cT ccom cfv vx cv ch0o cfv vx cv
      chil wcel vx cv cT cfv chil wcel vx cv cT cfv ch0o cfv c0v wceq chil chil
      vx cv cT hoaddid1.1 ffvelrni vx cv cT cfv ho0val syl vx cv ch0o cT ho0f
      hoaddid1.1 hocoi vx cv ho0val 3eqtr4d rgen vx ch0o cT ccom ch0o ch0o cT
      ho0f hoaddid1.1 hocofi ho0f hoeqi mpbi $.
      $( [9-Aug-2006] $) $( [9-Aug-2006] $)

    $( Composition of Hilbert space operator with unit identity. $)
    hoid1i $p |- ( T o. Iop ) = T $=
      cT chio ccom cT chil cpj cfv ccom cT chio chil cpj cfv cT df-iop coeq2i
      vx cv cT chil cpj cfv ccom cfv vx cv cT cfv wceq vx chil wral cT chil cpj
      cfv ccom cT wceq vx cv cT chil cpj cfv ccom cfv vx cv cT cfv wceq vx chil
      vx cv chil wcel vx cv cT chil cpj cfv ccom cfv vx cv chil cpj cfv cfv cT
      cfv vx cv cT cfv vx cv cT chil cpj cfv hoaddid1.1 chil helch pjfi hocoi
      vx cv chil wcel vx cv chil cpj cfv cfv vx cv cT vx cv pjch1 fveq2d eqtrd
      rgen vx cT chil cpj cfv ccom cT cT chil cpj cfv hoaddid1.1 chil helch
      pjfi hocofi hoaddid1.1 hoeqi mpbi eqtri $.
      $( [18-Sep-2007] $) $( [15-Nov-2000] $)

    $( Composition of Hilbert space operator with unit identity. $)
    hoid1ri $p |- ( Iop o. T ) = T $=
      chio cT ccom chil cpj cfv cT ccom cT chio chil cpj cfv cT df-iop coeq1i
      vx cv chil cpj cfv cT ccom cfv vx cv cT cfv wceq vx chil wral chil cpj
      cfv cT ccom cT wceq vx cv chil cpj cfv cT ccom cfv vx cv cT cfv wceq vx
      chil vx cv chil wcel vx cv chil cpj cfv cT ccom cfv vx cv cT cfv chil cpj
      cfv cfv vx cv cT cfv vx cv chil cpj cfv cT chil helch pjfi hoaddid1.1
      hocoi vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv chil cpj cfv
      cfv vx cv cT cfv wceq chil chil vx cv cT hoaddid1.1 ffvelrni vx cv cT cfv
      pjch1 syl eqtrd rgen vx chil cpj cfv cT ccom cT chil cpj cfv cT chil
      helch pjfi hoaddid1.1 hocofi hoaddid1.1 hoeqi mpbi eqtri $.
      $( [17-Nov-2007] $) $( [15-Nov-2000] $)
  $}

  $( Sum of a Hilbert space operator with the zero operator. $)
  hoaddid1 $p |- ( T : ~H --> ~H -> ( T +op 0hop ) = T ) $=
    chil chil cT wf cT ch0o chos co cT wceq chil chil cT wf cT ch0o cif ch0o
    chos co chil chil cT wf cT ch0o cif wceq cT ch0o cT chil chil cT wf cT ch0o
    cif wceq cT ch0o chos co chil chil cT wf cT ch0o cif ch0o chos co cT chil
    chil cT wf cT ch0o cif cT chil chil cT wf cT ch0o cif ch0o chos opreq1 cT
    chil chil cT wf cT ch0o cif wceq id eqeq12d chil chil cT wf cT ch0o cif
    chil chil cT ch0o ho0f elimf hoaddid1i dedth $.
    $( [31-Jul-2007] $) $( [25-Jul-2006] $)

  $( Difference of a Hilbert space operator from itself. $)
  hodid $p |- ( T : ~H --> ~H -> ( T -op T ) = 0hop ) $=
    chil chil cT wf cT cT chod co ch0o wceq chil chil cT wf cT ch0o cif chil
    chil cT wf cT ch0o cif chod co ch0o wceq cT ch0o cT chil chil cT wf cT ch0o
    cif wceq cT cT chod co chil chil cT wf cT ch0o cif chil chil cT wf cT ch0o
    cif chod co ch0o cT chil chil cT wf cT ch0o cif wceq cT chil chil cT wf cT
    ch0o cif cT chil chil cT wf cT ch0o cif chod cT chil chil cT wf cT ch0o cif
    wceq id cT chil chil cT wf cT ch0o cif wceq id opreq12d eqeq1d chil chil cT
    wf cT ch0o cif chil chil cT ch0o ho0f elimf hodidi dedth $.
    $( [31-Jul-2007] $) $( [23-Jul-2006] $)

  $( A Hilbert space operator is not empty. $)
  hon0 $p |- ( T : ~H --> ~H -> -. T = (/) ) $=
    chil chil cT wf cT c0 wceq chil c0 wceq c0v chil wcel chil c0 wceq wn
    ax-hv0cl chil c0v n0i ax-mp chil chil cT wf cT c0 wfn chil c0 wceq cT c0
    wceq chil chil cT wf cT chil wfn cT c0 wfn chil c0 wceq wi chil chil cT ffn
    cT chil wfn cT c0 wfn chil c0 wceq chil c0 cT fndmu ex syl cT fn0 syl5ibr
    mtoi $.
    $( [23-May-2006] $) $( [24-Mar-2006] $)

  ${
    $d x S $.  $d x T $.
    hodseq.2 $e |- S : ~H --> ~H $.
    hodseq.3 $e |- T : ~H --> ~H $.
    $( Subtraction and addition of equal Hilbert space operators. $)
    hodseqi $p |- ( S +op ( T -op S ) ) = T $=
      cT cS chod co cT cS chod co wceq cS cT cS chod co chos co cT wceq cT cS
      chod co eqid cT cS cT cS chod co hodseq.3 hodseq.2 cT cS hodseq.3
      hodseq.2 hosubcli hodsi mpbi $.
      $( [22-Oct-2004] $) $( [27-Aug-2004] $)

    $( Subtraction of Hilbert space operators expressed in terms of difference
       from zero. $)
    ho0subi $p |- ( S -op T ) = ( S +op ( 0hop -op T ) ) $=
      cS cT chod co cS ch0o cT chod co chos co wceq cT cS ch0o cT chod co chos
      co chos co cS wceq cT cS ch0o cT chod co chos co chos co cS cT ch0o cT
      chod co chos co chos co cS ch0o chos co cS cT cS ch0o cT chod co hodseq.3
      hodseq.2 ch0o cT ho0f hodseq.3 hosubcli hoadd12i cT ch0o cT chod co chos
      co ch0o cS chos cT ch0o hodseq.3 ho0f hodseqi opreq2i cS hodseq.2
      hoaddid1i 3eqtri cS cT cS ch0o cT chod co chos co hodseq.2 hodseq.3 cS
      ch0o cT chod co hodseq.2 ch0o cT ho0f hodseq.3 hosubcli hoaddcli hodsi
      mpbir $.
      $( [13-Aug-2006] $) $( [10-Mar-2006] $)

    $( Relationship between Hilbert operator addition and subtraction. $)
    honegsubi $p |- ( S +op ( -u 1 .op T ) ) = ( S -op T ) $=
      vx cv cS c1 cneg cT chot co chos co cfv vx cv cS cT chod co cfv wceq vx
      chil wral cS c1 cneg cT chot co chos co cS cT chod co wceq vx cv cS c1
      cneg cT chot co chos co cfv vx cv cS cT chod co cfv wceq vx chil vx cv
      chil wcel vx cv cS cfv vx cv cT cfv cmv co vx cv cS cfv vx cv c1 cneg cT
      chot co cfv cva co vx cv cS cT chod co cfv vx cv cS c1 cneg cT chot co
      chos co cfv vx cv chil wcel vx cv cS cfv vx cv cT cfv cmv co vx cv cS cfv
      c1 cneg vx cv cT cfv csm co cva co vx cv cS cfv vx cv c1 cneg cT chot co
      cfv cva co vx cv cS cfv chil wcel vx cv cT cfv chil wcel vx cv cS cfv vx
      cv cT cfv cmv co vx cv cS cfv c1 cneg vx cv cT cfv csm co cva co wceq vx
      cv chil wcel vx cv cS cfv vx cv cT cfv hvsubval chil chil vx cv cS
      hodseq.2 ffvelrni chil chil vx cv cT hodseq.3 ffvelrni sylanc vx cv chil
      wcel vx cv c1 cneg cT chot co cfv c1 cneg vx cv cT cfv csm co vx cv cS
      cfv cva c1 cneg cc wcel chil chil cT wf vx cv chil wcel vx cv c1 cneg cT
      chot co cfv c1 cneg vx cv cT cfv csm co wceq c1 ax1cn negcli hodseq.3 c1
      cneg vx cv cT homval mp3an12 opreq2d eqtr4d chil chil cS wf chil chil cT
      wf vx cv chil wcel vx cv cS cT chod co cfv vx cv cS cfv vx cv cT cfv cmv
      co wceq hodseq.2 hodseq.3 vx cv cS cT hodval mp3an12 chil chil cS wf chil
      chil c1 cneg cT chot co wf vx cv chil wcel vx cv cS c1 cneg cT chot co
      chos co cfv vx cv cS cfv vx cv c1 cneg cT chot co cfv cva co wceq
      hodseq.2 c1 cneg cc wcel chil chil cT wf chil chil c1 cneg cT chot co wf
      c1 ax1cn negcli hodseq.3 c1 cneg cT homulcl mp2an vx cv cS c1 cneg cT
      chot co hosval mp3an12 3eqtr4rd rgen vx cS c1 cneg cT chot co chos co cS
      cT chod co cS c1 cneg cT chot co hodseq.2 c1 cneg cc wcel chil chil cT wf
      chil chil c1 cneg cT chot co wf c1 ax1cn negcli hodseq.3 c1 cneg cT
      homulcl mp2an hoaddcli cS cT hodseq.2 hodseq.3 hosubcli hoeqi mpbi $.
      $( [27-Aug-2006] $) $( [24-Aug-2006] $)

$(
    @( Distributive law for Hilbert space operators. @)
    hosdi @p |- ( A e. CC ->
                 ( A .op ( S +op T ) ) = ( ( A .op S ) +op ( A .op T ) ) ) @=
?@.

    @( Distributive law for Hilbert space operators. @)
    hoddii @p |- ( A e. CC ->
                 ( A .op ( S -op T ) ) = ( ( A .op S ) -op ( A .op T ) ) ) @=
?@.
$)
  $}

  $( Subtraction of Hilbert space operators expressed in terms of difference
     from zero. $)
  ho0sub $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( S -op T ) = ( S +op ( 0hop -op T ) ) ) $=
    chil chil cS wf chil chil cT wf cS cT chod co cS ch0o cT chod co chos co
    wceq chil chil cS wf cS ch0o cif cT chod co chil chil cS wf cS ch0o cif
    ch0o cT chod co chos co wceq chil chil cS wf cS ch0o cif chil chil cT wf cT
    ch0o cif chod co chil chil cS wf cS ch0o cif ch0o chil chil cT wf cT ch0o
    cif chod co chos co wceq cS cT ch0o ch0o cS chil chil cS wf cS ch0o cif
    wceq cS cT chod co chil chil cS wf cS ch0o cif cT chod co cS ch0o cT chod
    co chos co chil chil cS wf cS ch0o cif ch0o cT chod co chos co cS chil chil
    cS wf cS ch0o cif cT chod opreq1 cS chil chil cS wf cS ch0o cif ch0o cT
    chod co chos opreq1 eqeq12d cT chil chil cT wf cT ch0o cif wceq chil chil
    cS wf cS ch0o cif cT chod co chil chil cS wf cS ch0o cif chil chil cT wf cT
    ch0o cif chod co chil chil cS wf cS ch0o cif ch0o cT chod co chos co chil
    chil cS wf cS ch0o cif ch0o chil chil cT wf cT ch0o cif chod co chos co cT
    chil chil cT wf cT ch0o cif chil chil cS wf cS ch0o cif chod opreq2 cT chil
    chil cT wf cT ch0o cif wceq ch0o cT chod co ch0o chil chil cT wf cT ch0o
    cif chod co chil chil cS wf cS ch0o cif chos cT chil chil cT wf cT ch0o cif
    ch0o chod opreq2 opreq2d eqeq12d chil chil cS wf cS ch0o cif chil chil cT
    wf cT ch0o cif chil chil cS ch0o ho0f elimf chil chil cT ch0o ho0f elimf
    ho0subi dedth2h $.
    $( [16-Aug-2006] $) $( [25-Jul-2006] $)

  $( The zero operator subtracted from a Hilbert space operator. $)
  hosubid1 $p |- ( T : ~H --> ~H -> ( T -op 0hop ) = T ) $=
    chil chil cT wf cT ch0o chod co cT ch0o ch0o chod co chos co cT ch0o chos
    co cT chil chil cT wf chil chil ch0o wf cT ch0o chod co cT ch0o ch0o chod
    co chos co wceq ho0f cT ch0o ho0sub mpan2 cT ch0o ch0o chod co chos co cT
    ch0o chos co wceq chil chil cT wf ch0o ch0o chod co ch0o cT chos ch0o ho0f
    hodidi opreq2i a1i cT hoaddid1 3eqtrd $.
    $( [16-Aug-2006] $) $( [25-Jul-2006] $)

  $( Relationship between Hilbert space operator addition and subtraction. $)
  honegsub $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                ( T +op ( -u 1 .op U ) ) = ( T -op U ) ) $=
    chil chil cT wf chil chil cU wf cT c1 cneg cU chot co chos co cT cU chod co
    wceq chil chil cT wf cT ch0o cif c1 cneg cU chot co chos co chil chil cT wf
    cT ch0o cif cU chod co wceq chil chil cT wf cT ch0o cif c1 cneg chil chil
    cU wf cU ch0o cif chot co chos co chil chil cT wf cT ch0o cif chil chil cU
    wf cU ch0o cif chod co wceq cT cU ch0o ch0o cT chil chil cT wf cT ch0o cif
    wceq cT c1 cneg cU chot co chos co chil chil cT wf cT ch0o cif c1 cneg cU
    chot co chos co cT cU chod co chil chil cT wf cT ch0o cif cU chod co cT
    chil chil cT wf cT ch0o cif c1 cneg cU chot co chos opreq1 cT chil chil cT
    wf cT ch0o cif cU chod opreq1 eqeq12d cU chil chil cU wf cU ch0o cif wceq
    chil chil cT wf cT ch0o cif c1 cneg cU chot co chos co chil chil cT wf cT
    ch0o cif c1 cneg chil chil cU wf cU ch0o cif chot co chos co chil chil cT
    wf cT ch0o cif cU chod co chil chil cT wf cT ch0o cif chil chil cU wf cU
    ch0o cif chod co cU chil chil cU wf cU ch0o cif wceq c1 cneg cU chot co c1
    cneg chil chil cU wf cU ch0o cif chot co chil chil cT wf cT ch0o cif chos
    cU chil chil cU wf cU ch0o cif c1 cneg chot opreq2 opreq2d cU chil chil cU
    wf cU ch0o cif chil chil cT wf cT ch0o cif chod opreq2 eqeq12d chil chil cT
    wf cT ch0o cif chil chil cU wf cU ch0o cif chil chil cT ch0o ho0f elimf
    chil chil cU ch0o ho0f elimf honegsubi dedth2h $.
    $( [2-Sep-2006] $) $( [24-Aug-2006] $)

  ${
    $d x A $.  $d x B $.  $d x T $.  $d x U $.
    $( An operator equals its scalar product with one. $)
    homulid2 $p |- ( T : ~H --> ~H -> ( 1 .op T ) = T ) $=
      chil chil cT wf vx cv c1 cT chot co cfv vx cv cT cfv wceq vx chil wral c1
      cT chot co cT wceq chil chil cT wf vx cv c1 cT chot co cfv vx cv cT cfv
      wceq vx chil chil chil cT wf vx cv chil wcel wa vx cv c1 cT chot co cfv
      c1 vx cv cT cfv csm co vx cv cT cfv c1 cc wcel chil chil cT wf vx cv chil
      wcel vx cv c1 cT chot co cfv c1 vx cv cT cfv csm co wceq ax1cn c1 vx cv
      cT homval mp3an1 chil chil cT wf vx cv chil wcel wa vx cv cT cfv chil
      wcel c1 vx cv cT cfv csm co vx cv cT cfv wceq chil chil vx cv cT ffvelrn
      vx cv cT cfv ax-hvmulid syl eqtrd r19.21aiva chil chil c1 cT chot co wf
      chil chil cT wf vx cv c1 cT chot co cfv vx cv cT cfv wceq vx chil wral c1
      cT chot co cT wceq wb c1 cc wcel chil chil cT wf chil chil c1 cT chot co
      wf ax1cn c1 cT homulcl mpan vx c1 cT chot co cT hoeq mpancom mpbid $.
      $( [16-Aug-2006] $) $( [12-Aug-2006] $)

    $( Associative law for scalar product and composition of operators. $)
    homco1 $p |- ( ( A e. CC /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( A .op T ) o. U ) = ( A .op ( T o. U ) ) ) $=
      cA cc wcel chil chil cT wf chil chil cU wf w3a vx cv cA cT chot co cU
      ccom cfv vx cv cA cT cU ccom chot co cfv wceq vx chil wral cA cT chot co
      cU ccom cA cT cU ccom chot co wceq cA cc wcel chil chil cT wf chil chil
      cU wf w3a vx cv cA cT chot co cU ccom cfv vx cv cA cT cU ccom chot co cfv
      wceq vx chil cA cc wcel chil chil cT wf chil chil cU wf w3a vx cv chil
      wcel wa vx cv cA cT chot co cU ccom cfv cA vx cv cT cU ccom cfv csm co vx
      cv cA cT cU ccom chot co cfv cA cc wcel chil chil cT wf chil chil cU wf
      w3a vx cv chil wcel wa vx cv cU cfv cA cT chot co cfv cA vx cv cU cfv cT
      cfv csm co vx cv cA cT chot co cU ccom cfv cA vx cv cT cU ccom cfv csm co
      cA cc wcel chil chil cT wf chil chil cU wf vx cv chil wcel vx cv cU cfv
      cA cT chot co cfv cA vx cv cU cfv cT cfv csm co wceq cA cc wcel chil chil
      cT wf chil chil cU wf vx cv chil wcel vx cv cU cfv cA cT chot co cfv cA
      vx cv cU cfv cT cfv csm co wceq cA cc wcel chil chil cT wf chil chil cU
      wf vx cv chil wcel wa vx cv cU cfv cA cT chot co cfv cA vx cv cU cfv cT
      cfv csm co wceq cA cc wcel chil chil cT wf vx cv cU cfv chil wcel vx cv
      cU cfv cA cT chot co cfv cA vx cv cU cfv cT cfv csm co wceq chil chil cU
      wf vx cv chil wcel wa cA vx cv cU cfv cT homval chil chil vx cv cU
      ffvelrn syl3an3 3expa exp43 3imp1 cA cc wcel chil chil cT wf chil chil cU
      wf w3a vx cv chil wcel vx cv cA cT chot co cU ccom cfv vx cv cU cfv cA cT
      chot co cfv wceq cA cc wcel chil chil cT wf chil chil cU wf vx cv chil
      wcel vx cv cA cT chot co cU ccom cfv vx cv cU cfv cA cT chot co cfv wceq
      wi cA cc wcel chil chil cT wf wa chil chil cU wf vx cv chil wcel vx cv cA
      cT chot co cU ccom cfv vx cv cU cfv cA cT chot co cfv wceq cA cT chot co
      wfun chil chil cU wf vx cv chil wcel vx cv cA cT chot co cU ccom cfv vx
      cv cU cfv cA cT chot co cfv wceq cA cc wcel chil chil cT wf wa chil chil
      vx cv cA cT chot co cU fvco3 cA cc wcel chil chil cT wf wa chil chil cA
      cT chot co wf cA cT chot co wfun cA cT homulcl chil chil cA cT chot co
      ffun syl syl3an1 3expia 3impa imp chil chil cT wf chil chil cU wf vx cv
      chil wcel cA vx cv cT cU ccom cfv csm co cA vx cv cU cfv cT cfv csm co
      wceq cA cc wcel chil chil cT wf chil chil cU wf wa vx cv chil wcel wa vx
      cv cT cU ccom cfv vx cv cU cfv cT cfv cA csm chil chil cT wf chil chil cU
      wf vx cv chil wcel vx cv cT cU ccom cfv vx cv cU cfv cT cfv wceq cT wfun
      chil chil cU wf vx cv chil wcel vx cv cT cU ccom cfv vx cv cU cfv cT cfv
      wceq chil chil cT wf chil chil vx cv cT cU fvco3 chil chil cT ffun
      syl3an1 3expa opreq2d 3adantl1 3eqtr4d cA cc wcel chil chil cT wf chil
      chil cU wf w3a vx cv chil wcel vx cv cA cT cU ccom chot co cfv cA vx cv
      cT cU ccom cfv csm co wceq cA cc wcel chil chil cT wf chil chil cU wf vx
      cv chil wcel vx cv cA cT cU ccom chot co cfv cA vx cv cT cU ccom cfv csm
      co wceq wi cA cc wcel chil chil cT wf chil chil cU wf wa vx cv chil wcel
      vx cv cA cT cU ccom chot co cfv cA vx cv cT cU ccom cfv csm co wceq cA cc
      wcel chil chil cT cU ccom wf vx cv chil wcel vx cv cA cT cU ccom chot co
      cfv cA vx cv cT cU ccom cfv csm co wceq chil chil cT wf chil chil cU wf
      wa cA vx cv cT cU ccom homval chil chil chil cT cU fco syl3an2 3expia
      3impb imp eqtr4d r19.21aiva chil chil cA cT chot co cU ccom wf chil chil
      cA cT cU ccom chot co wf vx cv cA cT chot co cU ccom cfv vx cv cA cT cU
      ccom chot co cfv wceq vx chil wral cA cT chot co cU ccom cA cT cU ccom
      chot co wceq wb cA cc wcel chil chil cT wf chil chil cU wf w3a vx cA cT
      chot co cU ccom cA cT cU ccom chot co hoeq cA cc wcel chil chil cT wf
      chil chil cU wf chil chil cA cT chot co cU ccom wf chil chil cA cT chot
      co wf chil chil cU wf chil chil cA cT chot co cU ccom wf cA cc wcel chil
      chil cT wf wa chil chil chil cA cT chot co cU fco cA cT homulcl sylan
      3impa cA cc wcel chil chil cT wf chil chil cU wf chil chil cA cT cU ccom
      chot co wf cA cc wcel chil chil cT cU ccom wf chil chil cA cT cU ccom
      chot co wf chil chil cT wf chil chil cU wf wa cA cT cU ccom homulcl chil
      chil chil cT cU fco sylan2 3impb sylanc mpbid $.
      $( [20-Aug-2006] $) $( [13-Aug-2006] $)

    $( Scalar product associative law for Hilbert space operators. $)
    homulass $p |- ( ( A e. CC /\ B e. CC /\ T : ~H --> ~H ) ->
                  ( ( A x. B ) .op T ) = ( A .op ( B .op T ) ) ) $=
      cA cc wcel cB cc wcel chil chil cT wf w3a vx cv cA cB cmul co cT chot co
      cfv vx cv cA cB cT chot co chot co cfv wceq vx chil wral cA cB cmul co cT
      chot co cA cB cT chot co chot co wceq cA cc wcel cB cc wcel chil chil cT
      wf w3a vx cv cA cB cmul co cT chot co cfv vx cv cA cB cT chot co chot co
      cfv wceq vx chil cA cc wcel cB cc wcel chil chil cT wf w3a vx cv chil
      wcel wa vx cv cA cB cmul co cT chot co cfv cA vx cv cB cT chot co cfv csm
      co vx cv cA cB cT chot co chot co cfv cA cc wcel cB cc wcel chil chil cT
      wf w3a vx cv chil wcel wa cA cB cmul co vx cv cT cfv csm co cA cB vx cv
      cT cfv csm co csm co vx cv cA cB cmul co cT chot co cfv cA vx cv cB cT
      chot co cfv csm co cA cc wcel cB cc wcel chil chil cT wf vx cv chil wcel
      cA cB cmul co vx cv cT cfv csm co cA cB vx cv cT cfv csm co csm co wceq
      cA cc wcel cB cc wcel chil chil cT wf vx cv chil wcel cA cB cmul co vx cv
      cT cfv csm co cA cB vx cv cT cfv csm co csm co wceq cA cc wcel cB cc wcel
      chil chil cT wf vx cv chil wcel wa cA cB cmul co vx cv cT cfv csm co cA
      cB vx cv cT cfv csm co csm co wceq cA cc wcel cB cc wcel vx cv cT cfv
      chil wcel cA cB cmul co vx cv cT cfv csm co cA cB vx cv cT cfv csm co csm
      co wceq chil chil cT wf vx cv chil wcel wa cA cB vx cv cT cfv ax-hvmulass
      chil chil vx cv cT ffvelrn syl3an3 3expa exp43 3imp1 cA cc wcel cB cc
      wcel chil chil cT wf w3a vx cv chil wcel vx cv cA cB cmul co cT chot co
      cfv cA cB cmul co vx cv cT cfv csm co wceq cA cc wcel cB cc wcel chil
      chil cT wf vx cv chil wcel vx cv cA cB cmul co cT chot co cfv cA cB cmul
      co vx cv cT cfv csm co wceq wi cA cc wcel cB cc wcel wa chil chil cT wf
      vx cv chil wcel vx cv cA cB cmul co cT chot co cfv cA cB cmul co vx cv cT
      cfv csm co wceq cA cB cmul co cc wcel chil chil cT wf vx cv chil wcel vx
      cv cA cB cmul co cT chot co cfv cA cB cmul co vx cv cT cfv csm co wceq cA
      cc wcel cB cc wcel wa cA cB cmul co vx cv cT homval cA cB mulcl syl3an1
      3expia 3impa imp cB cc wcel chil chil cT wf vx cv chil wcel cA vx cv cB
      cT chot co cfv csm co cA cB vx cv cT cfv csm co csm co wceq cA cc wcel cB
      cc wcel chil chil cT wf vx cv chil wcel cA vx cv cB cT chot co cfv csm co
      cA cB vx cv cT cfv csm co csm co wceq cB cc wcel chil chil cT wf vx cv
      chil wcel w3a vx cv cB cT chot co cfv cB vx cv cT cfv csm co cA csm cB vx
      cv cT homval opreq2d 3expa 3adantl1 3eqtr4d cA cc wcel cB cc wcel chil
      chil cT wf w3a vx cv chil wcel vx cv cA cB cT chot co chot co cfv cA vx
      cv cB cT chot co cfv csm co wceq cA cc wcel cB cc wcel chil chil cT wf vx
      cv chil wcel vx cv cA cB cT chot co chot co cfv cA vx cv cB cT chot co
      cfv csm co wceq wi cA cc wcel cB cc wcel chil chil cT wf wa vx cv chil
      wcel vx cv cA cB cT chot co chot co cfv cA vx cv cB cT chot co cfv csm co
      wceq cA cc wcel chil chil cB cT chot co wf vx cv chil wcel vx cv cA cB cT
      chot co chot co cfv cA vx cv cB cT chot co cfv csm co wceq cB cc wcel
      chil chil cT wf wa cA vx cv cB cT chot co homval cB cT homulcl syl3an2
      3expia 3impb imp eqtr4d r19.21aiva chil chil cA cB cmul co cT chot co wf
      chil chil cA cB cT chot co chot co wf vx cv cA cB cmul co cT chot co cfv
      vx cv cA cB cT chot co chot co cfv wceq vx chil wral cA cB cmul co cT
      chot co cA cB cT chot co chot co wceq wb cA cc wcel cB cc wcel chil chil
      cT wf w3a vx cA cB cmul co cT chot co cA cB cT chot co chot co hoeq cA cc
      wcel cB cc wcel chil chil cT wf chil chil cA cB cmul co cT chot co wf cA
      cB cmul co cc wcel chil chil cT wf chil chil cA cB cmul co cT chot co wf
      cA cc wcel cB cc wcel wa cA cB cmul co cT homulcl cA cB mulcl sylan 3impa
      cA cc wcel cB cc wcel chil chil cT wf chil chil cA cB cT chot co chot co
      wf cA cc wcel chil chil cB cT chot co wf chil chil cA cB cT chot co chot
      co wf cB cc wcel chil chil cT wf wa cA cB cT chot co homulcl cB cT
      homulcl sylan2 3impb sylanc mpbid $.
      $( [18-Aug-2006] $) $( [12-Aug-2006] $)

    $( Scalar product distributive law for Hilbert space operators. $)
    hoadddi $p |- ( ( A e. CC /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                 ( A .op ( T +op U ) ) = ( ( A .op T ) +op ( A .op U ) ) ) $=
      cA cc wcel chil chil cT wf chil chil cU wf w3a vx cv cA cT cU chos co
      chot co cfv vx cv cA cT chot co cA cU chot co chos co cfv wceq vx chil
      wral cA cT cU chos co chot co cA cT chot co cA cU chot co chos co wceq cA
      cc wcel chil chil cT wf chil chil cU wf w3a vx cv cA cT cU chos co chot
      co cfv vx cv cA cT chot co cA cU chot co chos co cfv wceq vx chil cA cc
      wcel chil chil cT wf chil chil cU wf w3a vx cv chil wcel wa vx cv cA cT
      cU chos co chot co cfv vx cv cA cT chot co cfv vx cv cA cU chot co cfv
      cva co vx cv cA cT chot co cA cU chot co chos co cfv cA cc wcel chil chil
      cT wf chil chil cU wf w3a vx cv chil wcel wa vx cv cA cT cU chos co chot
      co cfv cA vx cv cT cU chos co cfv csm co cA vx cv cT cfv vx cv cU cfv cva
      co csm co vx cv cA cT chot co cfv vx cv cA cU chot co cfv cva co cA cc
      wcel chil chil cT cU chos co wf wa vx cv chil wcel vx cv cA cT cU chos co
      chot co cfv cA vx cv cT cU chos co cfv csm co wceq cA cc wcel chil chil
      cT wf chil chil cU wf w3a cA cc wcel chil chil cT cU chos co wf vx cv
      chil wcel vx cv cA cT cU chos co chot co cfv cA vx cv cT cU chos co cfv
      csm co wceq cA vx cv cT cU chos co homval 3expa cA cc wcel chil chil cT
      wf chil chil cU wf cA cc wcel chil chil cT cU chos co wf wa chil chil cT
      wf chil chil cU wf wa chil chil cT cU chos co wf cA cc wcel cT cU hoaddcl
      anim2i 3impb sylan chil chil cT wf chil chil cU wf vx cv chil wcel cA vx
      cv cT cU chos co cfv csm co cA vx cv cT cfv vx cv cU cfv cva co csm co
      wceq cA cc wcel chil chil cT wf chil chil cU wf vx cv chil wcel cA vx cv
      cT cU chos co cfv csm co cA vx cv cT cfv vx cv cU cfv cva co csm co wceq
      chil chil cT wf chil chil cU wf vx cv chil wcel w3a vx cv cT cU chos co
      cfv vx cv cT cfv vx cv cU cfv cva co cA csm vx cv cT cU hosval opreq2d
      3expa 3adantl1 cA cc wcel chil chil cT wf chil chil cU wf w3a vx cv chil
      wcel wa cA vx cv cT cfv vx cv cU cfv cva co csm co cA vx cv cT cfv csm co
      cA vx cv cU cfv csm co cva co vx cv cA cT chot co cfv vx cv cA cU chot co
      cfv cva co cA cc wcel vx cv cT cfv chil wcel vx cv cU cfv chil wcel cA vx
      cv cT cfv vx cv cU cfv cva co csm co cA vx cv cT cfv csm co cA vx cv cU
      cfv csm co cva co wceq cA cc wcel chil chil cT wf chil chil cU wf w3a vx
      cv chil wcel wa cA vx cv cT cfv vx cv cU cfv ax-hvdistr1 cA cc wcel chil
      chil cT wf chil chil cU wf w3a cA cc wcel vx cv chil wcel cA cc wcel chil
      chil cT wf chil chil cU wf 3simp1 adantr chil chil cT wf cA cc wcel vx cv
      chil wcel vx cv cT cfv chil wcel chil chil cU wf chil chil vx cv cT
      ffvelrn 3ad2antl2 chil chil cU wf cA cc wcel vx cv chil wcel vx cv cU cfv
      chil wcel chil chil cT wf chil chil vx cv cU ffvelrn 3ad2antl3 syl3anc cA
      cc wcel chil chil cT wf chil chil cU wf w3a vx cv chil wcel wa vx cv cA
      cT chot co cfv cA vx cv cT cfv csm co vx cv cA cU chot co cfv cA vx cv cU
      cfv csm co cva cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT
      chot co cfv cA vx cv cT cfv csm co wceq chil chil cU wf cA cc wcel chil
      chil cT wf vx cv chil wcel vx cv cA cT chot co cfv cA vx cv cT cfv csm co
      wceq cA vx cv cT homval 3expa 3adantl3 cA cc wcel chil chil cU wf vx cv
      chil wcel vx cv cA cU chot co cfv cA vx cv cU cfv csm co wceq chil chil
      cT wf cA cc wcel chil chil cU wf vx cv chil wcel vx cv cA cU chot co cfv
      cA vx cv cU cfv csm co wceq cA vx cv cU homval 3expa 3adantl2 opreq12d
      eqtr4d 3eqtrd chil chil cA cT chot co wf chil chil cA cU chot co wf wa vx
      cv chil wcel vx cv cA cT chot co cA cU chot co chos co cfv vx cv cA cT
      chot co cfv vx cv cA cU chot co cfv cva co wceq cA cc wcel chil chil cT
      wf chil chil cU wf w3a chil chil cA cT chot co wf chil chil cA cU chot co
      wf vx cv chil wcel vx cv cA cT chot co cA cU chot co chos co cfv vx cv cA
      cT chot co cfv vx cv cA cU chot co cfv cva co wceq vx cv cA cT chot co cA
      cU chot co hosval 3expa cA cc wcel chil chil cT wf chil chil cU wf chil
      chil cA cT chot co wf chil chil cA cU chot co wf wa cA cc wcel chil chil
      cT wf wa chil chil cA cT chot co wf cA cc wcel chil chil cU wf wa chil
      chil cA cU chot co wf cA cT homulcl cA cU homulcl anim12i 3impdi sylan
      eqtr4d r19.21aiva chil chil cA cT cU chos co chot co wf chil chil cA cT
      chot co cA cU chot co chos co wf vx cv cA cT cU chos co chot co cfv vx cv
      cA cT chot co cA cU chot co chos co cfv wceq vx chil wral cA cT cU chos
      co chot co cA cT chot co cA cU chot co chos co wceq wb cA cc wcel chil
      chil cT wf chil chil cU wf w3a vx cA cT cU chos co chot co cA cT chot co
      cA cU chot co chos co hoeq cA cc wcel chil chil cT wf chil chil cU wf
      chil chil cA cT cU chos co chot co wf cA cc wcel chil chil cT cU chos co
      wf chil chil cA cT cU chos co chot co wf chil chil cT wf chil chil cU wf
      wa cA cT cU chos co homulcl cT cU hoaddcl sylan2 3impb cA cc wcel chil
      chil cT wf chil chil cU wf chil chil cA cT chot co cA cU chot co chos co
      wf chil chil cA cT chot co wf chil chil cA cU chot co wf chil chil cA cT
      chot co cA cU chot co chos co wf cA cc wcel chil chil cT wf wa cA cc wcel
      chil chil cU wf wa cA cT chot co cA cU chot co hoaddcl cA cT homulcl cA
      cU homulcl syl2an 3impdi sylanc mpbid $.
      $( [19-Aug-2006] $) $( [12-Aug-2006] $)

    $( Scalar product reverse distributive law for Hilbert space operators. $)
    hoadddir $p |- ( ( A e. CC /\ B e. CC /\ T : ~H --> ~H ) ->
                 ( ( A + B ) .op T ) = ( ( A .op T ) +op ( B .op T ) ) ) $=
      cA cc wcel cB cc wcel chil chil cT wf w3a vx cv cA cB caddc co cT chot co
      cfv vx cv cA cT chot co cB cT chot co chos co cfv wceq vx chil wral cA cB
      caddc co cT chot co cA cT chot co cB cT chot co chos co wceq cA cc wcel
      cB cc wcel chil chil cT wf w3a vx cv cA cB caddc co cT chot co cfv vx cv
      cA cT chot co cB cT chot co chos co cfv wceq vx chil cA cc wcel cB cc
      wcel chil chil cT wf w3a vx cv chil wcel wa vx cv cA cB caddc co cT chot
      co cfv vx cv cA cT chot co cfv vx cv cB cT chot co cfv cva co vx cv cA cT
      chot co cB cT chot co chos co cfv cA cc wcel cB cc wcel chil chil cT wf
      w3a vx cv chil wcel wa cA cB caddc co vx cv cT cfv csm co cA vx cv cT cfv
      csm co cB vx cv cT cfv csm co cva co vx cv cA cB caddc co cT chot co cfv
      vx cv cA cT chot co cfv vx cv cB cT chot co cfv cva co cA cc wcel cB cc
      wcel chil chil cT wf vx cv chil wcel cA cB caddc co vx cv cT cfv csm co
      cA vx cv cT cfv csm co cB vx cv cT cfv csm co cva co wceq cA cc wcel cB
      cc wcel chil chil cT wf vx cv chil wcel cA cB caddc co vx cv cT cfv csm
      co cA vx cv cT cfv csm co cB vx cv cT cfv csm co cva co wceq cA cc wcel
      cB cc wcel chil chil cT wf vx cv chil wcel wa cA cB caddc co vx cv cT cfv
      csm co cA vx cv cT cfv csm co cB vx cv cT cfv csm co cva co wceq cA cc
      wcel cB cc wcel vx cv cT cfv chil wcel cA cB caddc co vx cv cT cfv csm co
      cA vx cv cT cfv csm co cB vx cv cT cfv csm co cva co wceq chil chil cT wf
      vx cv chil wcel wa cA cB vx cv cT cfv ax-hvdistr2 chil chil vx cv cT
      ffvelrn syl3an3 3exp exp4a 3imp1 cA cB caddc co cc wcel chil chil cT wf
      wa vx cv chil wcel vx cv cA cB caddc co cT chot co cfv cA cB caddc co vx
      cv cT cfv csm co wceq cA cc wcel cB cc wcel chil chil cT wf w3a cA cB
      caddc co cc wcel chil chil cT wf vx cv chil wcel vx cv cA cB caddc co cT
      chot co cfv cA cB caddc co vx cv cT cfv csm co wceq cA cB caddc co vx cv
      cT homval 3expa cA cc wcel cB cc wcel chil chil cT wf cA cB caddc co cc
      wcel chil chil cT wf wa cA cc wcel cB cc wcel wa cA cB caddc co cc wcel
      chil chil cT wf cA cB addcl anim1i 3impa sylan cA cc wcel cB cc wcel chil
      chil cT wf w3a vx cv chil wcel wa vx cv cA cT chot co cfv cA vx cv cT cfv
      csm co vx cv cB cT chot co cfv cB vx cv cT cfv csm co cva cA cc wcel chil
      chil cT wf vx cv chil wcel vx cv cA cT chot co cfv cA vx cv cT cfv csm co
      wceq cB cc wcel cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT
      chot co cfv cA vx cv cT cfv csm co wceq cA vx cv cT homval 3expa 3adantl2
      cB cc wcel chil chil cT wf vx cv chil wcel vx cv cB cT chot co cfv cB vx
      cv cT cfv csm co wceq cA cc wcel cB cc wcel chil chil cT wf vx cv chil
      wcel vx cv cB cT chot co cfv cB vx cv cT cfv csm co wceq cB vx cv cT
      homval 3expa 3adantl1 opreq12d 3eqtr4d chil chil cA cT chot co wf chil
      chil cB cT chot co wf wa vx cv chil wcel vx cv cA cT chot co cB cT chot
      co chos co cfv vx cv cA cT chot co cfv vx cv cB cT chot co cfv cva co
      wceq cA cc wcel cB cc wcel chil chil cT wf w3a chil chil cA cT chot co wf
      chil chil cB cT chot co wf vx cv chil wcel vx cv cA cT chot co cB cT chot
      co chos co cfv vx cv cA cT chot co cfv vx cv cB cT chot co cfv cva co
      wceq vx cv cA cT chot co cB cT chot co hosval 3expa cA cc wcel chil chil
      cT wf cB cc wcel chil chil cA cT chot co wf chil chil cB cT chot co wf wa
      cA cc wcel chil chil cT wf wa chil chil cA cT chot co wf cB cc wcel chil
      chil cT wf wa chil chil cB cT chot co wf cA cT homulcl cB cT homulcl
      anim12i 3impdir sylan eqtr4d r19.21aiva chil chil cA cB caddc co cT chot
      co wf chil chil cA cT chot co cB cT chot co chos co wf vx cv cA cB caddc
      co cT chot co cfv vx cv cA cT chot co cB cT chot co chos co cfv wceq vx
      chil wral cA cB caddc co cT chot co cA cT chot co cB cT chot co chos co
      wceq wb cA cc wcel cB cc wcel chil chil cT wf w3a vx cA cB caddc co cT
      chot co cA cT chot co cB cT chot co chos co hoeq cA cc wcel cB cc wcel
      chil chil cT wf chil chil cA cB caddc co cT chot co wf cA cB caddc co cc
      wcel chil chil cT wf chil chil cA cB caddc co cT chot co wf cA cc wcel cB
      cc wcel wa cA cB caddc co cT homulcl cA cB addcl sylan 3impa cA cc wcel
      chil chil cT wf cB cc wcel chil chil cA cT chot co cB cT chot co chos co
      wf chil chil cA cT chot co wf chil chil cB cT chot co wf chil chil cA cT
      chot co cB cT chot co chos co wf cA cc wcel chil chil cT wf wa cB cc wcel
      chil chil cT wf wa cA cT chot co cB cT chot co hoaddcl cA cT homulcl cB
      cT homulcl syl2an 3impdir sylanc mpbid $.
      $( [2-Sep-2006] $) $( [25-Aug-2006] $)
  $}

  $( Swap first and second factors in a nested operator scalar product. $)
  homul12 $p |- ( ( A e. CC /\ B e. CC /\ T : ~H --> ~H ) ->
                ( A .op ( B .op T ) ) = ( B .op ( A .op T ) ) ) $=
    cA cc wcel cB cc wcel chil chil cT wf w3a cA cB cmul co cT chot co cB cA
    cmul co cT chot co cA cB cT chot co chot co cB cA cT chot co chot co cA cc
    wcel cB cc wcel cA cB cmul co cT chot co cB cA cmul co cT chot co wceq chil
    chil cT wf cA cc wcel cB cc wcel wa cA cB cmul co cB cA cmul co cT chot cA
    cB mulcom opreq1d 3adant3 cA cB cT homulass cB cc wcel cA cc wcel chil chil
    cT wf cB cA cmul co cT chot co cB cA cT chot co chot co wceq cB cA cT
    homulass 3com12 3eqtr3d $.
    $( [19-Aug-2006] $) $( [12-Aug-2006] $)

  $( Double negative of a Hilbert space operator. $)
  honegneg $p |- ( T : ~H --> ~H -> ( -u 1 .op ( -u 1 .op T ) ) = T ) $=
    chil chil cT wf c1 cneg c1 cneg cmul co cT chot co c1 cT chot co c1 cneg c1
    cneg cT chot co chot co cT c1 cneg c1 cneg cmul co cT chot co c1 cT chot co
    wceq chil chil cT wf c1 cneg c1 cneg cmul co c1 cT chot c1 cneg c1 cneg
    cmul co c1 c1 cmul co c1 c1 c1 ax1cn ax1cn mul2negi c1 ax1cn mulid1i eqtri
    opreq1i a1i c1 cneg cc wcel c1 cneg cc wcel chil chil cT wf c1 cneg c1 cneg
    cmul co cT chot co c1 cneg c1 cneg cT chot co chot co wceq c1 ax1cn negcli
    c1 ax1cn negcli c1 cneg c1 cneg cT homulass mp3an12 cT homulid2 3eqtr3d $.
    $( [2-Sep-2006] $) $( [24-Aug-2006] $)

  $( Relationship between operator subtraction and negative. $)
  hosubneg $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( T -op ( -u 1 .op U ) ) = ( T +op U ) ) $=
    chil chil cT wf chil chil cU wf wa cT c1 cneg c1 cneg cU chot co chot co
    chos co cT c1 cneg cU chot co chod co cT cU chos co chil chil cT wf chil
    chil c1 cneg cU chot co wf cT c1 cneg c1 cneg cU chot co chot co chos co cT
    c1 cneg cU chot co chod co wceq chil chil cU wf cT c1 cneg cU chot co
    honegsub c1 cneg cc wcel chil chil cU wf chil chil c1 cneg cU chot co wf c1
    ax1cn negcli c1 cneg cU homulcl mpan sylan2 chil chil cU wf cT c1 cneg c1
    cneg cU chot co chot co chos co cT cU chos co wceq chil chil cT wf chil
    chil cU wf c1 cneg c1 cneg cU chot co chot co cU cT chos cU honegneg
    opreq2d adantl eqtr3d $.
    $( [2-Sep-2006] $) $( [25-Aug-2006] $)

  $( Scalar product distributive law for operator difference. $)
  hosubdi $p |- ( ( A e. CC /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
               ( A .op ( T -op U ) ) = ( ( A .op T ) -op ( A .op U ) ) ) $=
    cA cc wcel chil chil cT wf chil chil cU wf w3a cA cT c1 cneg cU chot co
    chos co chot co cA cT chot co c1 cneg cA cU chot co chot co chos co cA cT
    cU chod co chot co cA cT chot co cA cU chot co chod co cA cc wcel chil chil
    cT wf chil chil cU wf w3a cA cT c1 cneg cU chot co chos co chot co cA cT
    chot co cA c1 cneg cU chot co chot co chos co cA cT chot co c1 cneg cA cU
    chot co chot co chos co cA cc wcel chil chil cT wf chil chil c1 cneg cU
    chot co wf cA cT c1 cneg cU chot co chos co chot co cA cT chot co cA c1
    cneg cU chot co chot co chos co wceq chil chil cU wf cA cT c1 cneg cU chot
    co hoadddi c1 cneg cc wcel chil chil cU wf chil chil c1 cneg cU chot co wf
    c1 ax1cn negcli c1 cneg cU homulcl mpan syl3an3 cA cc wcel chil chil cT wf
    chil chil cU wf w3a cA c1 cneg cU chot co chot co c1 cneg cA cU chot co
    chot co cA cT chot co chos cA cc wcel chil chil cU wf cA c1 cneg cU chot co
    chot co c1 cneg cA cU chot co chot co wceq chil chil cT wf cA cc wcel c1
    cneg cc wcel chil chil cU wf cA c1 cneg cU chot co chot co c1 cneg cA cU
    chot co chot co wceq c1 ax1cn negcli cA c1 cneg cU homul12 mp3an2 3adant2
    opreq2d eqtrd chil chil cT wf chil chil cU wf cA cT c1 cneg cU chot co chos
    co chot co cA cT cU chod co chot co wceq cA cc wcel chil chil cT wf chil
    chil cU wf wa cT c1 cneg cU chot co chos co cT cU chod co cA chot cT cU
    honegsub opreq2d 3adant1 cA cc wcel chil chil cT wf chil chil cU wf cA cT
    chot co c1 cneg cA cU chot co chot co chos co cA cT chot co cA cU chot co
    chod co wceq chil chil cA cT chot co wf chil chil cA cU chot co wf cA cT
    chot co c1 cneg cA cU chot co chot co chos co cA cT chot co cA cU chot co
    chod co wceq cA cc wcel chil chil cT wf wa cA cc wcel chil chil cU wf wa cA
    cT chot co cA cU chot co honegsub cA cT homulcl cA cU homulcl syl2an 3impdi
    3eqtr3d $.
    $( [19-Aug-2006] $) $( [12-Aug-2006] $)

  $( Distribution of negative over addition. $)
  honegdi $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
          ( -u 1 .op ( T +op U ) ) = ( ( -u 1 .op T ) +op ( -u 1 .op U ) ) ) $=
    c1 cneg cc wcel chil chil cT wf chil chil cU wf c1 cneg cT cU chos co chot
    co c1 cneg cT chot co c1 cneg cU chot co chos co wceq c1 ax1cn negcli c1
    cneg cT cU hoadddi mp3an1 $.
    $( [2-Sep-2006] $) $( [24-Aug-2006] $)

  $( Distribution of negative over subtraction. $)
  honegsubdi $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                    ( -u 1 .op ( T -op U ) ) = ( ( -u 1 .op T ) +op U ) ) $=
    chil chil cT wf chil chil cU wf wa c1 cneg cT c1 cneg cU chot co chos co
    chot co c1 cneg cT chot co c1 cneg c1 cneg cU chot co chot co chos co c1
    cneg cT cU chod co chot co c1 cneg cT chot co cU chos co chil chil cT wf
    chil chil c1 cneg cU chot co wf c1 cneg cT c1 cneg cU chot co chos co chot
    co c1 cneg cT chot co c1 cneg c1 cneg cU chot co chot co chos co wceq chil
    chil cU wf cT c1 cneg cU chot co honegdi c1 cneg cc wcel chil chil cU wf
    chil chil c1 cneg cU chot co wf c1 ax1cn negcli c1 cneg cU homulcl mpan
    sylan2 chil chil cT wf chil chil cU wf wa cT c1 cneg cU chot co chos co cT
    cU chod co c1 cneg chot cT cU honegsub opreq2d chil chil cT wf chil chil cU
    wf wa c1 cneg c1 cneg cU chot co chot co cU c1 cneg cT chot co chos chil
    chil cU wf c1 cneg c1 cneg cU chot co chot co cU wceq chil chil cT wf cU
    honegneg adantl opreq2d 3eqtr3d $.
    $( [2-Sep-2006] $) $( [24-Aug-2006] $)

  $( Distribution of negative over subtraction. $)
  honegsubdi2 $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                     ( -u 1 .op ( T -op U ) ) = ( U -op T ) ) $=
    chil chil cT wf chil chil cU wf wa c1 cneg cT cU chod co chot co c1 cneg cT
    chot co cU chos co cU c1 cneg cT chot co chos co cU cT chod co cT cU
    honegsubdi chil chil c1 cneg cT chot co wf chil chil cU wf c1 cneg cT chot
    co cU chos co cU c1 cneg cT chot co chos co wceq chil chil cT wf c1 cneg cT
    chot co cU hoaddcom c1 cneg cc wcel chil chil cT wf chil chil c1 cneg cT
    chot co wf c1 ax1cn negcli c1 cneg cT homulcl mpan sylan chil chil cU wf
    chil chil cT wf cU c1 cneg cT chot co chos co cU cT chod co wceq cU cT
    honegsub ancoms 3eqtrd $.
    $( [2-Sep-2006] $) $( [24-Aug-2006] $)

  $( Law for double subtraction of Hilbert space operators. $)
  hosubsub2 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( S -op ( T -op U ) ) = ( S +op ( U -op T ) ) ) $=
    chil chil cS wf chil chil cT wf chil chil cU wf w3a cS c1 cneg cT cU chod
    co chot co chos co cS cT cU chod co chod co cS cU cT chod co chos co chil
    chil cS wf chil chil cT wf chil chil cU wf cS c1 cneg cT cU chod co chot co
    chos co cS cT cU chod co chod co wceq chil chil cS wf chil chil cT cU chod
    co wf cS c1 cneg cT cU chod co chot co chos co cS cT cU chod co chod co
    wceq chil chil cT wf chil chil cU wf wa cS cT cU chod co honegsub cT cU
    hosubcl sylan2 3impb chil chil cT wf chil chil cU wf cS c1 cneg cT cU chod
    co chot co chos co cS cU cT chod co chos co wceq chil chil cS wf chil chil
    cT wf chil chil cU wf wa c1 cneg cT cU chod co chot co cU cT chod co cS
    chos cT cU honegsubdi2 opreq2d 3adant1 eqtr3d $.
    $( [3-Sep-2006] $) $( [24-Aug-2006] $)

  $( Rearrangement of 4 terms in a mixed addition and subtraction of Hilbert
     space operators. $)
  hosub4 $p |- ( ( ( R : ~H --> ~H /\ S : ~H --> ~H ) /\
      ( T : ~H --> ~H /\ U : ~H --> ~H ) ) -> ( ( R +op S ) -op ( T +op U ) ) =
                ( ( R -op T ) +op ( S -op U ) ) ) $=
    chil chil cR wf chil chil cS wf wa chil chil cT wf chil chil cU wf wa wa cR
    cS chos co c1 cneg cT cU chos co chot co chos co cR c1 cneg cT chot co chos
    co cS c1 cneg cU chot co chos co chos co cR cS chos co cT cU chos co chod
    co cR cT chod co cS cU chod co chos co chil chil cR wf chil chil cS wf wa
    chil chil cT wf chil chil cU wf wa wa cR cS chos co c1 cneg cT cU chos co
    chot co chos co cR cS chos co c1 cneg cT chot co c1 cneg cU chot co chos co
    chos co cR c1 cneg cT chot co chos co cS c1 cneg cU chot co chos co chos co
    chil chil cR wf chil chil cS wf wa chil chil cT wf chil chil cU wf wa wa c1
    cneg cT cU chos co chot co c1 cneg cT chot co c1 cneg cU chot co chos co cR
    cS chos co chos chil chil cT wf chil chil cU wf wa c1 cneg cT cU chos co
    chot co c1 cneg cT chot co c1 cneg cU chot co chos co wceq chil chil cR wf
    chil chil cS wf wa cT cU honegdi adantl opreq2d chil chil cR wf chil chil
    cS wf wa chil chil c1 cneg cT chot co wf chil chil c1 cneg cU chot co wf wa
    cR cS chos co c1 cneg cT chot co c1 cneg cU chot co chos co chos co cR c1
    cneg cT chot co chos co cS c1 cneg cU chot co chos co chos co wceq chil
    chil cT wf chil chil cU wf wa cR cS c1 cneg cT chot co c1 cneg cU chot co
    hoadd4 chil chil cT wf chil chil c1 cneg cT chot co wf chil chil cU wf chil
    chil c1 cneg cU chot co wf c1 cneg cc wcel chil chil cT wf chil chil c1
    cneg cT chot co wf c1 ax1cn negcli c1 cneg cT homulcl mpan c1 cneg cc wcel
    chil chil cU wf chil chil c1 cneg cU chot co wf c1 ax1cn negcli c1 cneg cU
    homulcl mpan anim12i sylan2 eqtrd chil chil cR cS chos co wf chil chil cT
    cU chos co wf cR cS chos co c1 cneg cT cU chos co chot co chos co cR cS
    chos co cT cU chos co chod co wceq chil chil cR wf chil chil cS wf wa chil
    chil cT wf chil chil cU wf wa cR cS chos co cT cU chos co honegsub cR cS
    hoaddcl cT cU hoaddcl syl2an chil chil cR wf chil chil cS wf wa chil chil
    cT wf chil chil cU wf wa wa cR c1 cneg cT chot co chos co cR cT chod co cS
    c1 cneg cU chot co chos co cS cU chod co chos chil chil cR wf chil chil cT
    wf cR c1 cneg cT chot co chos co cR cT chod co wceq chil chil cS wf chil
    chil cU wf cR cT honegsub ad2ant2r chil chil cS wf chil chil cU wf cS c1
    cneg cU chot co chos co cS cU chod co wceq chil chil cR wf chil chil cT wf
    cS cU honegsub ad2ant2l opreq12d 3eqtr3d $.
    $( [3-Sep-2006] $) $( [24-Aug-2006] $)

  $( Rearrangement of 4 terms in a mixed addition and subtraction of Hilbert
     space operators. $)
  hosubadd4 $p |- ( ( ( R : ~H --> ~H /\ S : ~H --> ~H ) /\
      ( T : ~H --> ~H /\ U : ~H --> ~H ) ) -> ( ( R -op S ) -op ( T -op U ) ) =
                ( ( R +op U ) -op ( S +op T ) ) ) $=
    chil chil cR wf chil chil cS wf wa chil chil cT wf chil chil cU wf wa wa cR
    cS chod co cT cU chod co chod co cR cS chod co cU cT chod co chos co cR cU
    chos co cS cT chos co chod co chil chil cR cS chod co wf chil chil cT wf
    chil chil cU wf wa cR cS chod co cT cU chod co chod co cR cS chod co cU cT
    chod co chos co wceq chil chil cR wf chil chil cS wf wa chil chil cR cS
    chod co wf chil chil cT wf chil chil cU wf cR cS chod co cT cU chod co chod
    co cR cS chod co cU cT chod co chos co wceq cR cS chod co cT cU hosubsub2
    3expb cR cS hosubcl sylan chil chil cR wf chil chil cU wf chil chil cS wf
    chil chil cT wf cR cU chos co cS cT chos co chod co cR cS chod co cU cT
    chod co chos co wceq cR cU cS cT hosub4 an42s eqtr4d $.
    $( [6-Sep-2006] $) $( [24-Aug-2006] $)

  $( Associative-type law for addition and subtraction of Hilbert space
     operators. $)
  hoaddsubass $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( S +op T ) -op U ) = ( S +op ( T -op U ) ) ) $=
    chil chil cS wf chil chil cT wf chil chil cU wf w3a cS cT chos co ch0o cU
    chod co chos co cS cT ch0o cU chod co chos co chos co cS cT chos co cU chod
    co cS cT cU chod co chos co chil chil cS wf chil chil cT wf chil chil ch0o
    cU chod co wf cS cT chos co ch0o cU chod co chos co cS cT ch0o cU chod co
    chos co chos co wceq chil chil cU wf cS cT ch0o cU chod co hoaddass chil
    chil ch0o wf chil chil cU wf chil chil ch0o cU chod co wf ho0f ch0o cU
    hosubcl mpan syl3an3 chil chil cS wf chil chil cT wf chil chil cU wf cS cT
    chos co cU chod co cS cT chos co ch0o cU chod co chos co wceq chil chil cS
    cT chos co wf chil chil cU wf cS cT chos co cU chod co cS cT chos co ch0o
    cU chod co chos co wceq chil chil cS wf chil chil cT wf wa cS cT chos co cU
    ho0sub cS cT hoaddcl sylan 3impa chil chil cS wf chil chil cT wf chil chil
    cU wf w3a cT cU chod co cT ch0o cU chod co chos co cS chos chil chil cT wf
    chil chil cU wf cT cU chod co cT ch0o cU chod co chos co wceq chil chil cS
    wf cT cU ho0sub 3adant1 opreq2d 3eqtr4d $.
    $( [25-Aug-2006] $) $( [25-Aug-2006] $)

  $( Law for operator addition and subtraction of Hilbert space operators. $)
  hoaddsub $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( S +op T ) -op U ) = ( ( S -op U ) +op T ) ) $=
    chil chil cS wf chil chil cT wf chil chil cU wf w3a cS cT chos co cU chod
    co cT cS chos co cU chod co cT cS cU chod co chos co cS cU chod co cT chos
    co chil chil cS wf chil chil cT wf cS cT chos co cU chod co cT cS chos co
    cU chod co wceq chil chil cU wf chil chil cS wf chil chil cT wf wa cS cT
    chos co cT cS chos co cU chod cS cT hoaddcom opreq1d 3adant3 chil chil cT
    wf chil chil cS wf chil chil cU wf cT cS chos co cU chod co cT cS cU chod
    co chos co wceq cT cS cU hoaddsubass 3com12 chil chil cS wf chil chil cT wf
    chil chil cU wf cT cS cU chod co chos co cS cU chod co cT chos co wceq chil
    chil cT wf chil chil cS wf chil chil cU wf cT cS cU chod co chos co cS cU
    chod co cT chos co wceq wi chil chil cT wf chil chil cS wf chil chil cU wf
    cT cS cU chod co chos co cS cU chod co cT chos co wceq chil chil cT wf chil
    chil cS cU chod co wf cT cS cU chod co chos co cS cU chod co cT chos co
    wceq chil chil cS wf chil chil cU wf wa chil chil cT wf chil chil cS cU
    chod co wf cT cS cU chod co chos co cS cU chod co cT chos co wceq cT cS cU
    chod co hoaddcom ex cS cU hosubcl syl5 exp3a com12 3imp 3eqtrd $.
    $( [9-Sep-2006] $) $( [25-Aug-2006] $)

  $( Law for double subtraction of Hilbert space operators. $)
  hosubsub $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( S -op ( T -op U ) ) = ( ( S -op T ) +op U ) ) $=
    chil chil cS wf chil chil cT wf chil chil cU wf w3a cS cT cU chod co chod
    co cS cU cT chod co chos co cS cT chod co cU chos co cS cT cU hosubsub2
    chil chil cS wf chil chil cU wf chil chil cT wf cS cU cT chod co chos co cS
    cT chod co cU chos co wceq chil chil cS wf chil chil cU wf chil chil cT wf
    w3a cS cU chos co cT chod co cS cU cT chod co chos co cS cT chod co cU chos
    co cS cU cT hoaddsubass cS cU cT hoaddsub eqtr3d 3com23 eqtrd $.
    $( [9-Sep-2006] $) $( [25-Aug-2006] $)

  $( Law for double subtraction of Hilbert space operators. $)
  hosubsub4 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( S -op T ) -op U ) = ( S -op ( T +op U ) ) ) $=
    chil chil cS wf chil chil cT wf chil chil cU wf w3a cS cT c1 cneg cU chot
    co chod co chod co cS cT chod co c1 cneg cU chot co chos co cS cT cU chos
    co chod co cS cT chod co cU chod co chil chil cS wf chil chil cT wf chil
    chil c1 cneg cU chot co wf cS cT c1 cneg cU chot co chod co chod co cS cT
    chod co c1 cneg cU chot co chos co wceq chil chil cU wf cS cT c1 cneg cU
    chot co hosubsub c1 cneg cc wcel chil chil cU wf chil chil c1 cneg cU chot
    co wf c1 ax1cn negcli c1 cneg cU homulcl mpan syl3an3 chil chil cS wf chil
    chil cT wf chil chil cU wf w3a cT c1 cneg cU chot co chod co cT cU chos co
    cS chod chil chil cT wf chil chil cU wf cT c1 cneg cU chot co chod co cT cU
    chos co wceq chil chil cS wf cT cU hosubneg 3adant1 opreq2d chil chil cS wf
    chil chil cT wf chil chil cU wf cS cT chod co c1 cneg cU chot co chos co cS
    cT chod co cU chod co wceq chil chil cS cT chod co wf chil chil cU wf cS cT
    chod co c1 cneg cU chot co chos co cS cT chod co cU chod co wceq chil chil
    cS wf chil chil cT wf wa cS cT chod co cU honegsub cS cT hosubcl sylan
    3impa 3eqtr3rd $.
    $( [10-Sep-2006] $) $( [25-Aug-2006] $)

  $( Two times a Hilbert space operator. $)
  ho2times $p |- ( T : ~H --> ~H -> ( 2 .op T ) = ( T +op T ) ) $=
    chil chil cT wf c2 cT chot co c1 cT chot co c1 cT chot co chos co c1 cT cT
    chos co chot co cT cT chos co chil chil cT wf c1 c1 caddc co cT chot co c1
    cT chot co c1 cT chot co chos co c2 cT chot co c1 cc wcel c1 cc wcel chil
    chil cT wf c1 c1 caddc co cT chot co c1 cT chot co c1 cT chot co chos co
    wceq ax1cn ax1cn c1 c1 cT hoadddir mp3an12 c2 c1 c1 caddc co cT chot df-2
    opreq1i syl5eq chil chil cT wf c1 cT cT chos co chot co c1 cT chot co c1 cT
    chot co chos co wceq c1 cc wcel chil chil cT wf chil chil cT wf c1 cT cT
    chos co chot co c1 cT chot co c1 cT chot co chos co wceq ax1cn c1 cT cT
    hoadddi mp3an1 anidms chil chil cT wf chil chil cT cT chos co wf c1 cT cT
    chos co chot co cT cT chos co wceq chil chil cT wf chil chil cT cT chos co
    wf cT cT hoaddcl anidms cT cT chos co homulid2 syl 3eqtr2d $.
    $( [10-Sep-2006] $) $( [26-Aug-2006] $)

  ${
    hoaddsubass.1 $e |- R : ~H --> ~H $.
    hoaddsubass.2 $e |- S : ~H --> ~H $.
    hoaddsubass.3 $e |- T : ~H --> ~H $.
    $( Associativity of sum and difference of Hilbert space operators. $)
    hoaddsubassi $p |- ( ( R +op S ) -op T ) = ( R +op ( S -op T ) ) $=
      chil chil cR wf chil chil cS wf chil chil cT wf cR cS chos co cT chod co
      cR cS cT chod co chos co wceq hoaddsubass.1 hoaddsubass.2 hoaddsubass.3
      cR cS cT hoaddsubass mp3an $.
      $( [18-Nov-2004] $) $( [27-Aug-2004] $)

    $( Law for sum and difference of Hilbert space operators. $)
    hoaddsubi $p |- ( ( R +op S ) -op T ) = ( ( R -op T ) +op S ) $=
      cR cS chos co cT chod co cS cR chos co cT chod co cS cR cT chod co chos
      co cR cT chod co cS chos co cR cS chos co cS cR chos co cT chod cR cS
      hoaddsubass.1 hoaddsubass.2 hoaddcomi opreq1i cS cR cT hoaddsubass.2
      hoaddsubass.1 hoaddsubass.3 hoaddsubassi cS cR cT chod co hoaddsubass.2
      cR cT hoaddsubass.1 hoaddsubass.3 hosubcli hoaddcomi 3eqtri $.
      $( [18-Nov-2004] $) $( [27-Aug-2004] $)
  $}

  ${
    hosd1.2 $e |- T : ~H --> ~H $.
    hosd1.3 $e |- U : ~H --> ~H $.
    $( Hilbert space operator sum expressed in terms of difference. $)
    hosd1i $p |- ( T +op U ) = ( T -op ( 0hop -op U ) ) $=
      cT ch0o cU chod co chod co cT cU chos co cT ch0o cU chod co chod co cT cU
      chos co wceq ch0o cU chod co cT cU chos co chos co cT wceq ch0o cU chod
      co cT cU chos co chos co cT cU chos co ch0o cU chod co chos co cT cU chos
      co ch0o chos co cU chod co cT ch0o cU chod co cT cU chos co ch0o cU ho0f
      hosd1.3 hosubcli cT cU hosd1.2 hosd1.3 hoaddcli hoaddcomi cT cU chos co
      ch0o cU cT cU hosd1.2 hosd1.3 hoaddcli ho0f hosd1.3 hoaddsubassi cT cU
      chos co ch0o chos co cU chod co cT cU chos co cU chod co cT cU chod co cU
      chos co cT cT cU chos co ch0o chos co cT cU chos co cU chod cT cU chos co
      cT cU hosd1.2 hosd1.3 hoaddcli hoaddid1i opreq1i cT cU cU hosd1.2 hosd1.3
      hosd1.3 hoaddsubi cT cU chod co cU chos co cU cT cU chod co chos co cT cT
      cU chod co cU cT cU hosd1.2 hosd1.3 hosubcli hosd1.3 hoaddcomi cU cT
      hosd1.3 hosd1.2 hodseqi eqtri 3eqtri 3eqtr2i cT ch0o cU chod co cT cU
      chos co hosd1.2 ch0o cU ho0f hosd1.3 hosubcli cT cU hosd1.2 hosd1.3
      hoaddcli hodsi mpbir eqcomi $.
      $( [3-Aug-2007] $) $( [27-Aug-2004] $)

    $( Hilbert space operator sum expressed in terms of difference. $)
    hosd2i $p |- ( T +op U ) = ( T -op ( ( U -op U ) -op U ) ) $=
      cT cU chos co cT ch0o cU chod co chod co cT cU cU chod co cU chod co chod
      co cT cU hosd1.2 hosd1.3 hosd1i cU cU chod co cU chod co ch0o cU chod co
      cT chod cU cU chod co ch0o cU chod cU hosd1.3 hodidi opreq1i opreq2i
      eqtr4i $.
      $( [18-Nov-2004] $) $( [27-Aug-2004] $)

    $( Hilbert space operator cancellation law. $)
    hopncani $p |- ( ( T +op U ) -op U ) = T $=
      cT cU chos co cU chod co cT cU cU chod co chos co cT ch0o chos co cT cT
      cU cU hosd1.2 hosd1.3 hosd1.3 hoaddsubassi cU cU chod co ch0o cT chos cU
      hosd1.3 hodidi opreq2i cT hosd1.2 hoaddid1i 3eqtri $.
      $( [25-Mar-2006] $) $( [10-Mar-2006] $)

    $( Hilbert space operator cancellation law. $)
    honpcani $p |- ( ( T -op U ) +op U ) = T $=
      cT cU chos co cU chod co cT cU chod co cU chos co cT cT cU cU hosd1.2
      hosd1.3 hosd1.3 hoaddsubi cT cU hosd1.2 hosd1.3 hopncani eqtr3i $.
      $( [28-Mar-2006] $) $( [11-Mar-2006] $)

    $( If the difference between two operators is zero, they are equal. $)
    hosubeq0i $p |- ( ( T -op U ) = 0hop <-> T = U ) $=
      cT cU chod co ch0o wceq cT cU wceq cT cU chod co ch0o wceq cT c1 cneg cU
      chot co chos co cU chos co ch0o cU chos co cT cU cT cU chod co ch0o wceq
      cT c1 cneg cU chot co chos co ch0o wceq cT c1 cneg cU chot co chos co cU
      chos co ch0o cU chos co wceq cT c1 cneg cU chot co chos co cT cU chod co
      ch0o cT cU hosd1.2 hosd1.3 honegsubi eqeq1i cT c1 cneg cU chot co chos co
      ch0o cU chos opreq1 sylbir cT c1 cneg cU chot co chos co cU chos co cT cU
      chos co c1 cneg cU chot co chos co cT cU c1 cneg cU chot co chos co chos
      co cT cT c1 cneg cU chot co cU hosd1.2 c1 cneg cc wcel chil chil cU wf
      chil chil c1 cneg cU chot co wf c1 ax1cn negcli hosd1.3 c1 cneg cU
      homulcl mp2an hosd1.3 hoadd23i cT cU c1 cneg cU chot co hosd1.2 hosd1.3
      c1 cneg cc wcel chil chil cU wf chil chil c1 cneg cU chot co wf c1 ax1cn
      negcli hosd1.3 c1 cneg cU homulcl mp2an hoaddassi cT cU c1 cneg cU chot
      co chos co chos co cT ch0o chos co cT cU c1 cneg cU chot co chos co ch0o
      cT chos cU c1 cneg cU chot co chos co cU cU chod co ch0o cU cU hosd1.3
      hosd1.3 honegsubi cU hosd1.3 hodidi eqtri opreq2i cT hosd1.2 hoaddid1i
      eqtri 3eqtri ch0o cU chos co cU ch0o chos co cU ch0o cU ho0f hosd1.3
      hoaddcomi cU hosd1.3 hoaddid1i eqtri 3eqtr3g cT cU wceq cT cU chod co cU
      cU chod co ch0o cT cU cU chod opreq1 cU hosd1.3 hodidi syl6eq impbii $.
      $( [31-Jul-2007] $) $( [27-Jul-2006] $)
  $}

  ${
    honpncan.1 $e |- R : ~H --> ~H $.
    honpncan.2 $e |- S : ~H --> ~H $.
    honpncan.3 $e |- T : ~H --> ~H $.
    $( Hilbert space operator cancellation law. $)
    honpncani $p |- ( ( R -op S ) +op ( S -op T ) ) = ( R -op T ) $=
      cR cS chod co cS chos co cT chod co cR cS chod co cS cT chod co chos co
      cR cT chod co cR cS chod co cS cT cR cS honpncan.1 honpncan.2 hosubcli
      honpncan.2 honpncan.3 hoaddsubassi cR cS chod co cS chos co cR cT chod cR
      cS honpncan.1 honpncan.2 honpcani opreq1i eqtr3i $.
      $( [30-Apr-2006] $) $( [11-Mar-2006] $)
  $}

  ${
    $d x y T $.
    ho0.1 $e |- T : ~H --> ~H $.
    $( A condition implying that a Hilbert space operator is identically zero.
       Lemma 3.2(S8) of [Beran] p. 95. $)
    ho01i $p |- ( A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = 0 <->
               T = 0hop ) $=
      cT chil c0v csn cxp wceq vx cv cT cfv vx cv chil c0v csn cxp cfv wceq vx
      chil wral cT ch0o wceq vx cv cT cfv vy cv csp co cc0 wceq vy chil wral vx
      chil wral cT chil wfn chil c0v csn cxp chil wfn cT chil c0v csn cxp wceq
      vx cv cT cfv vx cv chil c0v csn cxp cfv wceq vx chil wral wb chil chil cT
      wf cT chil wfn ho0.1 chil chil cT ffn ax-mp chil c0v csn chil c0v csn cxp
      wf chil c0v csn cxp chil wfn chil c0v c0v chil ax-hv0cl elisseti fconst
      chil c0v csn chil c0v csn cxp ffn ax-mp vx chil cT chil c0v csn cxp
      eqfnfv2 mp2an ch0o chil c0v csn cxp cT ch0o chil c0h cxp chil c0v csn cxp
      df0op2 c0h c0v csn chil df-ch0 xpeq2i eqtri eqeq2i vx cv cT cfv vy cv csp
      co cc0 wceq vy chil wral vx cv cT cfv vx cv chil c0v csn cxp cfv wceq vx
      chil vx cv chil wcel vx cv cT cfv vy cv csp co cc0 wceq vy chil wral vx
      cv cT cfv c0v wceq vx cv cT cfv vx cv chil c0v csn cxp cfv wceq vx cv
      chil wcel vx cv cT cfv chil wcel vx cv cT cfv vy cv csp co cc0 wceq vy
      chil wral vx cv cT cfv c0v wceq wb chil chil vx cv cT ho0.1 ffvelrni vy
      vx cv cT cfv hial0 syl vx cv chil wcel vx cv chil c0v csn cxp cfv c0v vx
      cv cT cfv chil c0v vx cv c0v chil ax-hv0cl elisseti fvconst2 eqeq2d
      bitr4d ralbiia 3bitr4ri $.
      $( [31-Jul-2007] $) $( [28-Jan-2006] $)

    $( A condition implying that a Hilbert space operator is identically zero.
       Lemma 3.2(S10) of [Beran] p. 95. $)
    ho02i $p |- ( A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = 0 <->
               T = 0hop ) $=
      vx cv vy cv cT cfv csp co cc0 wceq vy chil wral vx chil wral vx cv vy cv
      cT cfv csp co cc0 wceq vx chil wral vy chil wral vy cv cT cfv vx cv csp
      co cc0 wceq vx chil wral vy chil wral cT ch0o wceq vx cv vy cv cT cfv csp
      co cc0 wceq vx vy chil chil ralcom vx cv vy cv cT cfv csp co cc0 wceq vx
      chil wral vy cv cT cfv vx cv csp co cc0 wceq vx chil wral vy chil vy cv
      chil wcel vy cv cT cfv chil wcel vx cv vy cv cT cfv csp co cc0 wceq vx
      chil wral vy cv cT cfv vx cv csp co cc0 wceq vx chil wral wb chil chil vy
      cv cT ho0.1 ffvelrni vy cv cT cfv chil wcel vx cv vy cv cT cfv csp co cc0
      wceq vx chil wral vy cv cT cfv c0v wceq vy cv cT cfv vx cv csp co cc0
      wceq vx chil wral vx vy cv cT cfv hial02 vx vy cv cT cfv hial0 bitr4d syl
      ralbiia vy vx cT ho0.1 ho01i 3bitri $.
      $( [30-Apr-2008] $) $( [28-Jan-2006] $)
  $}

  ${
    $d x y z S $.  $d u v x y z T $.
    $( A condition implying that two Hilbert space operators are equal.
       Lemma 3.2(S9) of [Beran] p. 95. $)
    hoeq1 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( A. x e. ~H
          A. y e. ~H ( ( S ` x ) .ih y ) = ( ( T ` x ) .ih y ) <-> S = T ) ) $=
      chil chil cS wf chil chil cT wf wa vx cv cS cfv vy cv csp co vx cv cT cfv
      vy cv csp co wceq vy chil wral vx chil wral vx cv cS cfv vx cv cT cfv
      wceq vx chil wral cS cT wceq chil chil cS wf chil chil cT wf wa vx cv cS
      cfv vy cv csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx cv cS cfv
      vx cv cT cfv wceq vx chil chil chil cS wf chil chil cT wf vx cv chil wcel
      vx cv cS cfv vy cv csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx
      cv cS cfv vx cv cT cfv wceq wb vx cv cS cfv chil wcel vx cv cT cfv chil
      wcel vx cv cS cfv vy cv csp co vx cv cT cfv vy cv csp co wceq vy chil
      wral vx cv cS cfv vx cv cT cfv wceq wb chil chil cS wf vx cv chil wcel wa
      chil chil cT wf vx cv chil wcel wa vy vx cv cS cfv vx cv cT cfv hial2eq
      chil chil vx cv cS ffvelrn chil chil vx cv cT ffvelrn syl2an anandirs
      ralbidva cS chil wfn cT chil wfn cS cT wceq vx cv cS cfv vx cv cT cfv
      wceq vx chil wral wb chil chil cS wf chil chil cT wf vx chil cS cT
      eqfnfv2 chil chil cS ffn chil chil cT ffn syl2an bitr4d $.
      $( [21-Feb-2006] $) $( [15-Feb-2006] $)

    $( A condition implying that two Hilbert space operators are equal.
       Lemma 3.2(S11) of [Beran] p. 95. $)
    hoeq2 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( A. x e. ~H
          A. y e. ~H ( x .ih ( S ` y ) ) = ( x .ih ( T ` y ) ) <-> S = T ) ) $=
      chil chil cS wf chil chil cT wf wa vx cv vy cv cS cfv csp co vx cv vy cv
      cT cfv csp co wceq vy chil wral vx chil wral vx cv vy cv cS cfv csp co vx
      cv vy cv cT cfv csp co wceq vx chil wral vy chil wral vy cv cS cfv vx cv
      csp co vy cv cT cfv vx cv csp co wceq vx chil wral vy chil wral cS cT
      wceq vx cv vy cv cS cfv csp co vx cv vy cv cT cfv csp co wceq vy chil
      wral vx chil wral vx cv vy cv cS cfv csp co vx cv vy cv cT cfv csp co
      wceq vx chil wral vy chil wral wb chil chil cS wf chil chil cT wf wa vx
      cv vy cv cS cfv csp co vx cv vy cv cT cfv csp co wceq vx vy chil chil
      ralcom a1i chil chil cS wf chil chil cT wf wa vx cv vy cv cS cfv csp co
      vx cv vy cv cT cfv csp co wceq vx chil wral vy cv cS cfv vx cv csp co vy
      cv cT cfv vx cv csp co wceq vx chil wral vy chil chil chil cS wf chil
      chil cT wf vy cv chil wcel vx cv vy cv cS cfv csp co vx cv vy cv cT cfv
      csp co wceq vx chil wral vy cv cS cfv vx cv csp co vy cv cT cfv vx cv csp
      co wceq vx chil wral wb vy cv cS cfv chil wcel vy cv cT cfv chil wcel vx
      cv vy cv cS cfv csp co vx cv vy cv cT cfv csp co wceq vx chil wral vy cv
      cS cfv vx cv csp co vy cv cT cfv vx cv csp co wceq vx chil wral wb chil
      chil cS wf vy cv chil wcel wa chil chil cT wf vy cv chil wcel wa vy cv cS
      cfv chil wcel vy cv cT cfv chil wcel wa vx cv vy cv cS cfv csp co vx cv
      vy cv cT cfv csp co wceq vx chil wral vy cv cS cfv vy cv cT cfv wceq vy
      cv cS cfv vx cv csp co vy cv cT cfv vx cv csp co wceq vx chil wral vx vy
      cv cS cfv vy cv cT cfv hial2eq2 vx vy cv cS cfv vy cv cT cfv hial2eq
      bitr4d chil chil vy cv cS ffvelrn chil chil vy cv cT ffvelrn syl2an
      anandirs ralbidva vy vx cS cT hoeq1 3bitrd $.
      $( [26-May-2006] $) $( [15-Feb-2006] $)

    $( Every Hilbert space operator has at most one adjoint. $)
    adjmo $p |- E* u ( u : ~H --> ~H /\
           A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( u ` x ) .ih y ) ) $=
      chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co
      wceq vy chil wral vx chil wral wa vu wmo chil chil vu cv wf vx cv vy cv
      cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral
      wa chil chil vv cv wf vx cv vy cv cT cfv csp co vx cv vv cv cfv vy cv csp
      co wceq vy chil wral vx chil wral wa wa vu cv vv cv wceq wi vv wal vu wal
      chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co
      wceq vy chil wral vx chil wral wa chil chil vv cv wf vx cv vy cv cT cfv
      csp co vx cv vv cv cfv vy cv csp co wceq vy chil wral vx chil wral wa wa
      vu cv vv cv wceq wi vu vv chil chil vu cv wf chil chil vv cv wf vx cv vy
      cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil
      wral vx cv vy cv cT cfv csp co vx cv vv cv cfv vy cv csp co wceq vy chil
      wral vx chil wral vu cv vv cv wceq chil chil vu cv wf chil chil vv cv wf
      wa vx cv vu cv cfv vy cv csp co vx cv vv cv cfv vy cv csp co wceq vy chil
      wral vx chil wral vu cv vv cv wceq vx cv vy cv cT cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral vx cv vy cv cT cfv csp co
      vx cv vv cv cfv vy cv csp co wceq vy chil wral vx chil wral wa chil chil
      vu cv wf chil chil vv cv wf wa vx cv vu cv cfv vy cv csp co vx cv vv cv
      cfv vy cv csp co wceq vy chil wral vx chil wral vu cv vv cv wceq vx vy vu
      cv vv cv hoeq1 biimpa vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp
      co wceq vy chil wral vx chil wral vx cv vy cv cT cfv csp co vx cv vv cv
      cfv vy cv csp co wceq vy chil wral vx chil wral wa vx cv vy cv cT cfv csp
      co vx cv vu cv cfv vy cv csp co wceq vx cv vy cv cT cfv csp co vx cv vv
      cv cfv vy cv csp co wceq wa vy chil wral vx chil wral vx cv vu cv cfv vy
      cv csp co vx cv vv cv cfv vy cv csp co wceq vy chil wral vx chil wral vx
      cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vx cv vy cv cT
      cfv csp co vx cv vv cv cfv vy cv csp co wceq vx vy chil chil r19.26-2 vx
      cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vx cv vy cv cT
      cfv csp co vx cv vv cv cfv vy cv csp co wceq wa vy chil wral vx cv vu cv
      cfv vy cv csp co vx cv vv cv cfv vy cv csp co wceq vy chil wral vx chil
      vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vx cv vy cv
      cT cfv csp co vx cv vv cv cfv vy cv csp co wceq wa vx cv vu cv cfv vy cv
      csp co vx cv vv cv cfv vy cv csp co wceq vy chil vx cv vy cv cT cfv csp
      co vx cv vu cv cfv vy cv csp co vx cv vv cv cfv vy cv csp co eqtr2
      r19.20si r19.20si sylbir sylan2 an4s gen2 chil chil vu cv wf vx cv vy cv
      cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral
      wa chil chil vv cv wf vx cv vy cv cT cfv csp co vx cv vv cv cfv vy cv csp
      co wceq vy chil wral vx chil wral wa vu vv vu cv vv cv wceq chil chil vu
      cv wf chil chil vv cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv
      csp co wceq vy chil wral vx chil wral vx cv vy cv cT cfv csp co vx cv vv
      cv cfv vy cv csp co wceq vy chil wral vx chil wral chil chil vu cv vv cv
      feq1 vu cv vv cv wceq vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp
      co wceq vx cv vy cv cT cfv csp co vx cv vv cv cfv vy cv csp co wceq vx vy
      chil chil vu cv vv cv wceq vx cv vu cv cfv vy cv csp co vx cv vv cv cfv
      vy cv csp co vx cv vy cv cT cfv csp co vu cv vv cv wceq vx cv vu cv cfv
      vx cv vv cv cfv vy cv csp vx cv vu cv vv cv fveq1 opreq1d eqeq2d 2ralbidv
      anbi12d mo4 mpbir $.
      $( [21-Feb-2006] $) $( [18-Feb-2006] $)

    $( Symmetry property of an adjoint. $)
    adjsym $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
          ( A. x e. ~H A. y e. ~H ( x .ih ( S ` y ) ) = ( ( T ` x ) .ih y ) <->
         A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( S ` x ) .ih y ) ) ) $=
      chil chil cS wf chil chil cT wf wa vx cv vy cv cT cfv csp co vx cv cS cfv
      vy cv csp co wceq vy chil wral vx chil wral vy cv vx cv cS cfv csp co vy
      cv cT cfv vx cv csp co wceq vy chil wral vx chil wral vx cv vy cv cS cfv
      csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx chil wral chil chil
      cS wf chil chil cT wf wa vx cv vy cv cT cfv csp co vx cv cS cfv vy cv csp
      co wceq vy chil wral vy cv vx cv cS cfv csp co vy cv cT cfv vx cv csp co
      wceq vy chil wral vx chil chil chil cS wf chil chil cT wf wa vx cv chil
      wcel wa vx cv vy cv cT cfv csp co vx cv cS cfv vy cv csp co wceq vy cv vx
      cv cS cfv csp co vy cv cT cfv vx cv csp co wceq vy chil chil chil cS wf
      chil chil cT wf wa vx cv chil wcel wa vy cv chil wcel wa vx cv vy cv cT
      cfv csp co vx cv cS cfv vy cv csp co wceq vy cv cT cfv vx cv csp co vy cv
      vx cv cS cfv csp co wceq vy cv vx cv cS cfv csp co vy cv cT cfv vx cv csp
      co wceq chil chil cS wf chil chil cT wf wa vx cv chil wcel vy cv chil
      wcel vx cv vy cv cT cfv csp co vx cv cS cfv vy cv csp co wceq vy cv cT
      cfv vx cv csp co vy cv vx cv cS cfv csp co wceq wb chil chil cS wf vx cv
      chil wcel chil chil cT wf vy cv chil wcel vx cv vy cv cT cfv csp co vx cv
      cS cfv vy cv csp co wceq vy cv cT cfv vx cv csp co vy cv vx cv cS cfv csp
      co wceq wb chil chil cS wf vx cv chil wcel wa chil chil cT wf vy cv chil
      wcel wa wa vy cv cT cfv vx cv csp co vy cv vx cv cS cfv csp co wceq vx cv
      vy cv cT cfv csp co ccj cfv vx cv cS cfv vy cv csp co ccj cfv wceq vx cv
      vy cv cT cfv csp co vx cv cS cfv vy cv csp co wceq chil chil cT wf vy cv
      chil wcel wa chil chil cS wf vx cv chil wcel wa vy cv cT cfv vx cv csp co
      vy cv vx cv cS cfv csp co wceq vx cv vy cv cT cfv csp co ccj cfv vx cv cS
      cfv vy cv csp co ccj cfv wceq wb chil chil cT wf vy cv chil wcel wa chil
      chil cS wf vx cv chil wcel wa wa vy cv cT cfv vx cv csp co vx cv vy cv cT
      cfv csp co ccj cfv vy cv vx cv cS cfv csp co vx cv cS cfv vy cv csp co
      ccj cfv chil chil cT wf vy cv chil wcel wa vx cv chil wcel vy cv cT cfv
      vx cv csp co vx cv vy cv cT cfv csp co ccj cfv wceq chil chil cS wf vy cv
      cT cfv chil wcel vx cv chil wcel vy cv cT cfv vx cv csp co vx cv vy cv cT
      cfv csp co ccj cfv wceq chil chil cT wf vy cv chil wcel wa vy cv cT cfv
      vx cv ax-his1 chil chil vy cv cT ffvelrn sylan adantrl vy cv chil wcel
      chil chil cS wf vx cv chil wcel wa vy cv vx cv cS cfv csp co vx cv cS cfv
      vy cv csp co ccj cfv wceq chil chil cT wf vy cv chil wcel vx cv cS cfv
      chil wcel vy cv vx cv cS cfv csp co vx cv cS cfv vy cv csp co ccj cfv
      wceq chil chil cS wf vx cv chil wcel wa vy cv vx cv cS cfv ax-his1 chil
      chil vx cv cS ffvelrn sylan2 adantll eqeq12d ancoms vx cv vy cv cT cfv
      csp co cc wcel vx cv cS cfv vy cv csp co cc wcel vx cv vy cv cT cfv csp
      co ccj cfv vx cv cS cfv vy cv csp co ccj cfv wceq vx cv vy cv cT cfv csp
      co vx cv cS cfv vy cv csp co wceq wb chil chil cS wf vx cv chil wcel wa
      chil chil cT wf vy cv chil wcel wa wa vx cv vy cv cT cfv csp co vx cv cS
      cfv vy cv csp co cj11 vx cv chil wcel chil chil cT wf vy cv chil wcel wa
      vx cv vy cv cT cfv csp co cc wcel chil chil cS wf vx cv chil wcel vy cv
      cT cfv chil wcel vx cv vy cv cT cfv csp co cc wcel chil chil cT wf vy cv
      chil wcel wa vx cv vy cv cT cfv hicl chil chil vy cv cT ffvelrn sylan2
      adantll chil chil cS wf vx cv chil wcel wa vy cv chil wcel vx cv cS cfv
      vy cv csp co cc wcel chil chil cT wf vx cv cS cfv chil wcel vy cv chil
      wcel vx cv cS cfv vy cv csp co cc wcel chil chil cS wf vx cv chil wcel wa
      vx cv cS cfv vy cv hicl chil chil vx cv cS ffvelrn sylan adantrl sylanc
      bitr2d an4s anassrs vy cv cT cfv vx cv csp co vy cv vx cv cS cfv csp co
      eqcom syl6bb ralbidva ralbidva vx cv vy cv cS cfv csp co vx cv cT cfv vy
      cv csp co wceq vy chil wral vx chil wral vx cv vz cv cS cfv csp co vx cv
      cT cfv vz cv csp co wceq vx chil wral vz chil wral vy cv vz cv cS cfv csp
      co vy cv cT cfv vz cv csp co wceq vy chil wral vz chil wral vy cv vx cv
      cS cfv csp co vy cv cT cfv vx cv csp co wceq vy chil wral vx chil wral vx
      cv vy cv cS cfv csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx
      chil wral vx cv vy cv cS cfv csp co vx cv cT cfv vy cv csp co wceq vx
      chil wral vy chil wral vx cv vz cv cS cfv csp co vx cv cT cfv vz cv csp
      co wceq vx chil wral vz chil wral vx cv vy cv cS cfv csp co vx cv cT cfv
      vy cv csp co wceq vx vy chil chil ralcom vx cv vz cv cS cfv csp co vx cv
      cT cfv vz cv csp co wceq vx chil wral vx cv vy cv cS cfv csp co vx cv cT
      cfv vy cv csp co wceq vx chil wral vz vy chil vz cv vy cv wceq vx cv vz
      cv cS cfv csp co vx cv cT cfv vz cv csp co wceq vx cv vy cv cS cfv csp co
      vx cv cT cfv vy cv csp co wceq vx chil vz cv vy cv wceq vx cv vz cv cS
      cfv csp co vx cv vy cv cS cfv csp co vx cv cT cfv vz cv csp co vx cv cT
      cfv vy cv csp co vz cv vy cv wceq vz cv cS cfv vy cv cS cfv vx cv csp vz
      cv vy cv cS fveq2 opreq2d vz cv vy cv vx cv cT cfv csp opreq2 eqeq12d
      ralbidv cbvralv bitr4i vx cv vz cv cS cfv csp co vx cv cT cfv vz cv csp
      co wceq vx chil wral vy cv vz cv cS cfv csp co vy cv cT cfv vz cv csp co
      wceq vy chil wral vz chil vx cv vz cv cS cfv csp co vx cv cT cfv vz cv
      csp co wceq vy cv vz cv cS cfv csp co vy cv cT cfv vz cv csp co wceq vx
      vy chil vx cv vy cv wceq vx cv vz cv cS cfv csp co vy cv vz cv cS cfv csp
      co vx cv cT cfv vz cv csp co vy cv cT cfv vz cv csp co vx cv vy cv vz cv
      cS cfv csp opreq1 vx cv vy cv wceq vx cv cT cfv vy cv cT cfv vz cv csp vx
      cv vy cv cT fveq2 opreq1d eqeq12d cbvralv ralbii vy cv vz cv cS cfv csp
      co vy cv cT cfv vz cv csp co wceq vy chil wral vy cv vx cv cS cfv csp co
      vy cv cT cfv vx cv csp co wceq vy chil wral vz vx chil vz cv vx cv wceq
      vy cv vz cv cS cfv csp co vy cv cT cfv vz cv csp co wceq vy cv vx cv cS
      cfv csp co vy cv cT cfv vx cv csp co wceq vy chil vz cv vx cv wceq vy cv
      vz cv cS cfv csp co vy cv vx cv cS cfv csp co vy cv cT cfv vz cv csp co
      vy cv cT cfv vx cv csp co vz cv vx cv wceq vz cv cS cfv vx cv cS cfv vy
      cv csp vz cv vx cv cS fveq2 opreq2d vz cv vx cv vy cv cT cfv csp opreq2
      eqeq12d ralbidv cbvralv 3bitri syl6rbbr $.
      $( [25-Feb-2006] $) $( [18-Feb-2006] $)
  $}

  ${
    eigre.1 $e |- A e. ~H $.
    eigre.2 $e |- B e. CC $.
    $( A necessary and sufficient condition (that holds when ` T ` is a
       Hermitian operator) for an eigenvalue ` B ` to be real.  Generalization
       of Equation 1.30 of [Hughes] p. 49. $)
    eigrei $p |- ( ( ( T ` A ) = ( B .h A ) /\ A =/= 0h ) ->
                 ( ( A .ih ( T ` A ) ) = ( ( T ` A ) .ih A ) <-> B e. RR ) ) $=
      cA cT cfv cB cA csm co wceq cA c0v wne wa cA cA cT cfv csp co cA cT cfv
      cA csp co wceq cB ccj cfv cB wceq cB cr wcel cA cT cfv cB cA csm co wceq
      cA cA cT cfv csp co cA cT cfv cA csp co wceq cB ccj cfv cA cA csp co cmul
      co cB cA cA csp co cmul co wceq cA c0v wne cB ccj cfv cB wceq cA cT cfv
      cB cA csm co wceq cA cA cT cfv csp co cB ccj cfv cA cA csp co cmul co cA
      cT cfv cA csp co cB cA cA csp co cmul co cA cT cfv cB cA csm co wceq cA
      cA cT cfv csp co cA cB cA csm co csp co cB ccj cfv cA cA csp co cmul co
      cA cT cfv cB cA csm co cA csp opreq2 cB cc wcel cA chil wcel cA chil wcel
      cA cB cA csm co csp co cB ccj cfv cA cA csp co cmul co wceq eigre.2
      eigre.1 eigre.1 cB cA cA his5 mp3an syl6eq cA cT cfv cB cA csm co wceq cA
      cT cfv cA csp co cB cA csm co cA csp co cB cA cA csp co cmul co cA cT cfv
      cB cA csm co cA csp opreq1 cB cc wcel cA chil wcel cA chil wcel cB cA csm
      co cA csp co cB cA cA csp co cmul co wceq eigre.2 eigre.1 eigre.1 cB cA
      cA ax-his3 mp3an syl6eq eqeq12d cA c0v wne cc0 cA cA csp co clt wbr cA cA
      csp co cc0 wne cB ccj cfv cA cA csp co cmul co cB cA cA csp co cmul co
      wceq cB ccj cfv cB wceq wb cA chil wcel cA c0v wne cc0 cA cA csp co clt
      wbr eigre.1 cA ax-his4 mpan cA cA csp co cA chil wcel cA cA csp co cr
      wcel eigre.1 cA hiidrcl ax-mp gt0ne0i cA cA csp co cc wcel cA cA csp co
      cc0 wne cB ccj cfv cA cA csp co cmul co cB cA cA csp co cmul co wceq cB
      ccj cfv cB wceq wb cA cA eigre.1 eigre.1 hicli cB cc wcel cA cA csp co cc
      wcel cA cA csp co cc0 wne wa cB ccj cfv cA cA csp co cmul co cB cA cA csp
      co cmul co wceq cB ccj cfv cB wceq wb eigre.2 cB ccj cfv cc wcel cB cc
      wcel cA cA csp co cc wcel cA cA csp co cc0 wne wa cB ccj cfv cA cA csp co
      cmul co cB cA cA csp co cmul co wceq cB ccj cfv cB wceq wb cB eigre.2
      cjcli cB ccj cfv cB cA cA csp co mulcan2 mp3an1 mpan mpan 3syl sylan9bb
      cB eigre.2 cjrebi syl6bbr $.
      $( [18-May-2006] $) $( [21-Jan-2005] $)
  $}

  $( A necessary and sufficient condition (that holds when ` T ` is a Hermitian
     operator) for an eigenvalue ` B ` to be real.  Generalization of Equation
     1.30 of [Hughes] p. 49. $)
  eigre $p |- ( ( ( A e. ~H /\ B e. CC ) /\ ( ( T ` A ) = ( B .h A ) /\ A =/=
       0h ) ) -> ( ( A .ih ( T ` A ) ) = ( ( T ` A ) .ih A ) <-> B e. RR ) ) $=
    cA chil wcel cB cc wcel wa cA cT cfv cB cA csm co wceq cA c0v wne wa cA cA
    cT cfv csp co cA cT cfv cA csp co wceq cB cr wcel wb cA chil wcel cB cc
    wcel cA cT cfv cB cA csm co wceq cA c0v wne wa cA cA cT cfv csp co cA cT
    cfv cA csp co wceq cB cr wcel wb wi cA chil wcel cA c0v cif cT cfv cB cA
    chil wcel cA c0v cif csm co wceq cA chil wcel cA c0v cif c0v wne wa cA chil
    wcel cA c0v cif cA chil wcel cA c0v cif cT cfv csp co cA chil wcel cA c0v
    cif cT cfv cA chil wcel cA c0v cif csp co wceq cB cr wcel wb wi cA chil
    wcel cA c0v cif cT cfv cB cc wcel cB cc0 cif cA chil wcel cA c0v cif csm co
    wceq cA chil wcel cA c0v cif c0v wne wa cA chil wcel cA c0v cif cA chil
    wcel cA c0v cif cT cfv csp co cA chil wcel cA c0v cif cT cfv cA chil wcel
    cA c0v cif csp co wceq cB cc wcel cB cc0 cif cr wcel wb wi cA cB c0v cc0 cA
    cA chil wcel cA c0v cif wceq cA cT cfv cB cA csm co wceq cA c0v wne wa cA
    chil wcel cA c0v cif cT cfv cB cA chil wcel cA c0v cif csm co wceq cA chil
    wcel cA c0v cif c0v wne wa cA cA cT cfv csp co cA cT cfv cA csp co wceq cB
    cr wcel wb cA chil wcel cA c0v cif cA chil wcel cA c0v cif cT cfv csp co cA
    chil wcel cA c0v cif cT cfv cA chil wcel cA c0v cif csp co wceq cB cr wcel
    wb cA cA chil wcel cA c0v cif wceq cA cT cfv cB cA csm co wceq cA chil wcel
    cA c0v cif cT cfv cB cA chil wcel cA c0v cif csm co wceq cA c0v wne cA chil
    wcel cA c0v cif c0v wne cA cA chil wcel cA c0v cif wceq cA cT cfv cA chil
    wcel cA c0v cif cT cfv cB cA csm co cB cA chil wcel cA c0v cif csm co cA cA
    chil wcel cA c0v cif cT fveq2 cA cA chil wcel cA c0v cif cB csm opreq2
    eqeq12d cA cA chil wcel cA c0v cif c0v neeq1 anbi12d cA cA chil wcel cA c0v
    cif wceq cA cA cT cfv csp co cA cT cfv cA csp co wceq cA chil wcel cA c0v
    cif cA chil wcel cA c0v cif cT cfv csp co cA chil wcel cA c0v cif cT cfv cA
    chil wcel cA c0v cif csp co wceq cB cr wcel cA cA chil wcel cA c0v cif wceq
    cA cA cT cfv csp co cA chil wcel cA c0v cif cA chil wcel cA c0v cif cT cfv
    csp co cA cT cfv cA csp co cA chil wcel cA c0v cif cT cfv cA chil wcel cA
    c0v cif csp co cA cA chil wcel cA c0v cif wceq cA cA chil wcel cA c0v cif
    cA cT cfv cA chil wcel cA c0v cif cT cfv csp cA cA chil wcel cA c0v cif
    wceq id cA cA chil wcel cA c0v cif cT fveq2 opreq12d cA cA chil wcel cA c0v
    cif wceq cA cT cfv cA chil wcel cA c0v cif cT cfv cA cA chil wcel cA c0v
    cif csp cA cA chil wcel cA c0v cif cT fveq2 cA cA chil wcel cA c0v cif wceq
    id opreq12d eqeq12d bibi1d imbi12d cB cB cc wcel cB cc0 cif wceq cA chil
    wcel cA c0v cif cT cfv cB cA chil wcel cA c0v cif csm co wceq cA chil wcel
    cA c0v cif c0v wne wa cA chil wcel cA c0v cif cT cfv cB cc wcel cB cc0 cif
    cA chil wcel cA c0v cif csm co wceq cA chil wcel cA c0v cif c0v wne wa cA
    chil wcel cA c0v cif cA chil wcel cA c0v cif cT cfv csp co cA chil wcel cA
    c0v cif cT cfv cA chil wcel cA c0v cif csp co wceq cB cr wcel wb cA chil
    wcel cA c0v cif cA chil wcel cA c0v cif cT cfv csp co cA chil wcel cA c0v
    cif cT cfv cA chil wcel cA c0v cif csp co wceq cB cc wcel cB cc0 cif cr
    wcel wb cB cB cc wcel cB cc0 cif wceq cA chil wcel cA c0v cif cT cfv cB cA
    chil wcel cA c0v cif csm co wceq cA chil wcel cA c0v cif cT cfv cB cc wcel
    cB cc0 cif cA chil wcel cA c0v cif csm co wceq cA chil wcel cA c0v cif c0v
    wne cB cB cc wcel cB cc0 cif wceq cB cA chil wcel cA c0v cif csm co cB cc
    wcel cB cc0 cif cA chil wcel cA c0v cif csm co cA chil wcel cA c0v cif cT
    cfv cB cB cc wcel cB cc0 cif cA chil wcel cA c0v cif csm opreq1 eqeq2d
    anbi1d cB cB cc wcel cB cc0 cif wceq cB cr wcel cB cc wcel cB cc0 cif cr
    wcel cA chil wcel cA c0v cif cA chil wcel cA c0v cif cT cfv csp co cA chil
    wcel cA c0v cif cT cfv cA chil wcel cA c0v cif csp co wceq cB cB cc wcel cB
    cc0 cif cr eleq1 bibi2d imbi12d cA chil wcel cA c0v cif cB cc wcel cB cc0
    cif cT cA c0v chil ax-hv0cl elimel cB cc0 cc 0cn elimel eigrei dedth2h imp
    $.
    $( [26-May-2006] $) $( [19-Mar-2006] $)

  ${
    eigpos.1 $e |- A e. ~H $.
    eigpos.2 $e |- B e. CC $.
    $( A sufficient condition (first conjunct pair, that holds when ` T ` is a
       positive operator) for an eigenvalue ` B ` (second conjunct pair) to be
       nonnegative.  Remark (ii) in [Hughes] p. 137. $)
    eigposi $p |- ( ( ( ( A .ih ( T ` A ) ) e. RR /\ 0 <_ ( A .ih ( T ` A ) ) )
      /\ ( ( T ` A ) = ( B .h A ) /\ A =/= 0h ) ) -> ( B e. RR /\ 0 <_ B ) ) $=
      cA cA cT cfv csp co cr wcel cc0 cA cA cT cfv csp co cle wbr wa cA cT cfv
      cB cA csm co wceq cA c0v wne wa wa cB cr wcel cc0 cB cle wbr cA cA cT cfv
      csp co cr wcel cA cT cfv cB cA csm co wceq cA c0v wne wa cB cr wcel cc0
      cA cA cT cfv csp co cle wbr cA cT cfv cB cA csm co wceq cA c0v wne wa cA
      cA cT cfv csp co cr wcel cB cr wcel cA cT cfv cB cA csm co wceq cA c0v
      wne wa cA cA cT cfv csp co cr wcel cA cA cT cfv csp co cA cT cfv cA csp
      co wceq cB cr wcel cA cT cfv cB cA csm co wceq cA cA cT cfv csp co cr
      wcel cA cA cT cfv csp co cA cT cfv cA csp co wceq wb cA c0v wne cA cT cfv
      cB cA csm co wceq cA cB cA csm co csp co cr wcel cA cB cA csm co csp co
      cB cA csm co cA csp co wceq cA cA cT cfv csp co cr wcel cA cA cT cfv csp
      co cA cT cfv cA csp co wceq cA cB cA csm co csp co cr wcel cA cB cA csm
      co csp co cB cA csm co cA csp co wceq wb cA cT cfv cB cA csm co wceq cA
      chil wcel cB cA csm co chil wcel cA cB cA csm co csp co cr wcel cA cB cA
      csm co csp co cB cA csm co cA csp co wceq wb eigpos.1 cB cA eigpos.2
      eigpos.1 hvmulcli cA cB cA csm co hire mp2an a1i cA cT cfv cB cA csm co
      wceq cA cA cT cfv csp co cA cB cA csm co csp co cr cA cT cfv cB cA csm co
      cA csp opreq2 eleq1d cA cT cfv cB cA csm co wceq cA cA cT cfv csp co cA
      cB cA csm co csp co cA cT cfv cA csp co cB cA csm co cA csp co cA cT cfv
      cB cA csm co cA csp opreq2 cA cT cfv cB cA csm co cA csp opreq1 eqeq12d
      3bitr4d adantr cA cB cT eigpos.1 eigpos.2 eigrei bitrd biimpac adantlr cB
      cr wcel cc0 cA cA csp co clt wbr cc0 cB cA cA csp co cmul co cle wbr wa
      cc0 cB cle wbr cA cA cT cfv csp co cr wcel cc0 cA cA cT cfv csp co cle
      wbr wa cA cT cfv cB cA csm co wceq cA c0v wne wa wa cB cr wcel cA cA csp
      co cr wcel cc0 cA cA csp co clt wbr cc0 cB cA cA csp co cmul co cle wbr
      wa cc0 cB cle wbr cA chil wcel cA cA csp co cr wcel eigpos.1 cA hiidrcl
      ax-mp cB cA cA csp co prodge02 mpanl2 cA cA cT cfv csp co cr wcel cA cT
      cfv cB cA csm co wceq cA c0v wne wa cB cr wcel cc0 cA cA cT cfv csp co
      cle wbr cA cT cfv cB cA csm co wceq cA c0v wne wa cA cA cT cfv csp co cr
      wcel cB cr wcel cA cT cfv cB cA csm co wceq cA c0v wne wa cA cA cT cfv
      csp co cr wcel cA cA cT cfv csp co cA cT cfv cA csp co wceq cB cr wcel cA
      cT cfv cB cA csm co wceq cA cA cT cfv csp co cr wcel cA cA cT cfv csp co
      cA cT cfv cA csp co wceq wb cA c0v wne cA cT cfv cB cA csm co wceq cA cB
      cA csm co csp co cr wcel cA cB cA csm co csp co cB cA csm co cA csp co
      wceq cA cA cT cfv csp co cr wcel cA cA cT cfv csp co cA cT cfv cA csp co
      wceq cA cB cA csm co csp co cr wcel cA cB cA csm co csp co cB cA csm co
      cA csp co wceq wb cA cT cfv cB cA csm co wceq cA chil wcel cB cA csm co
      chil wcel cA cB cA csm co csp co cr wcel cA cB cA csm co csp co cB cA csm
      co cA csp co wceq wb eigpos.1 cB cA eigpos.2 eigpos.1 hvmulcli cA cB cA
      csm co hire mp2an a1i cA cT cfv cB cA csm co wceq cA cA cT cfv csp co cA
      cB cA csm co csp co cr cA cT cfv cB cA csm co cA csp opreq2 eleq1d cA cT
      cfv cB cA csm co wceq cA cA cT cfv csp co cA cB cA csm co csp co cA cT
      cfv cA csp co cB cA csm co cA csp co cA cT cfv cB cA csm co cA csp opreq2
      cA cT cfv cB cA csm co cA csp opreq1 eqeq12d 3bitr4d adantr cA cB cT
      eigpos.1 eigpos.2 eigrei bitrd biimpac adantlr cA cA cT cfv csp co cr
      wcel cc0 cA cA cT cfv csp co cle wbr wa cA cT cfv cB cA csm co wceq cA
      c0v wne wa wa cc0 cA cA csp co clt wbr cc0 cB cA cA csp co cmul co cle
      wbr cA c0v wne cc0 cA cA csp co clt wbr cA cA cT cfv csp co cr wcel cc0
      cA cA cT cfv csp co cle wbr wa cA cT cfv cB cA csm co wceq cA chil wcel
      cA c0v wne cc0 cA cA csp co clt wbr eigpos.1 cA ax-his4 mpan ad2antll cA
      cA cT cfv csp co cr wcel cc0 cA cA cT cfv csp co cle wbr wa cA cT cfv cB
      cA csm co wceq cA c0v wne wa wa cc0 cA cA cT cfv csp co cB cA cA csp co
      cmul co cle cA cA cT cfv csp co cr wcel cc0 cA cA cT cfv csp co cle wbr
      cA cT cfv cB cA csm co wceq cA c0v wne wa simplr cA cA cT cfv csp co cr
      wcel cc0 cA cA cT cfv csp co cle wbr wa cA cT cfv cB cA csm co wceq cA
      c0v wne wa wa cA cA cT cfv csp co cA cB cA csm co csp co cB cA cA csp co
      cmul co cA cT cfv cB cA csm co wceq cA cA cT cfv csp co cA cB cA csm co
      csp co wceq cA cA cT cfv csp co cr wcel cc0 cA cA cT cfv csp co cle wbr
      wa cA c0v wne cA cT cfv cB cA csm co cA csp opreq2 ad2antrl cA cA cT cfv
      csp co cr wcel cc0 cA cA cT cfv csp co cle wbr wa cA cT cfv cB cA csm co
      wceq cA c0v wne wa wa cB ccj cfv cA cA csp co cmul co cB cA cA csp co
      cmul co cA cB cA csm co csp co cA cA cT cfv csp co cr wcel cc0 cA cA cT
      cfv csp co cle wbr wa cA cT cfv cB cA csm co wceq cA c0v wne wa wa cB ccj
      cfv cB cA cA csp co cmul cA cA cT cfv csp co cr wcel cc0 cA cA cT cfv csp
      co cle wbr wa cA cT cfv cB cA csm co wceq cA c0v wne wa wa cB cr wcel cB
      ccj cfv cB wceq cA cA cT cfv csp co cr wcel cA cT cfv cB cA csm co wceq
      cA c0v wne wa cB cr wcel cc0 cA cA cT cfv csp co cle wbr cA cT cfv cB cA
      csm co wceq cA c0v wne wa cA cA cT cfv csp co cr wcel cB cr wcel cA cT
      cfv cB cA csm co wceq cA c0v wne wa cA cA cT cfv csp co cr wcel cA cA cT
      cfv csp co cA cT cfv cA csp co wceq cB cr wcel cA cT cfv cB cA csm co
      wceq cA cA cT cfv csp co cr wcel cA cA cT cfv csp co cA cT cfv cA csp co
      wceq wb cA c0v wne cA cT cfv cB cA csm co wceq cA cB cA csm co csp co cr
      wcel cA cB cA csm co csp co cB cA csm co cA csp co wceq cA cA cT cfv csp
      co cr wcel cA cA cT cfv csp co cA cT cfv cA csp co wceq cA cB cA csm co
      csp co cr wcel cA cB cA csm co csp co cB cA csm co cA csp co wceq wb cA
      cT cfv cB cA csm co wceq cA chil wcel cB cA csm co chil wcel cA cB cA csm
      co csp co cr wcel cA cB cA csm co csp co cB cA csm co cA csp co wceq wb
      eigpos.1 cB cA eigpos.2 eigpos.1 hvmulcli cA cB cA csm co hire mp2an a1i
      cA cT cfv cB cA csm co wceq cA cA cT cfv csp co cA cB cA csm co csp co cr
      cA cT cfv cB cA csm co cA csp opreq2 eleq1d cA cT cfv cB cA csm co wceq
      cA cA cT cfv csp co cA cB cA csm co csp co cA cT cfv cA csp co cB cA csm
      co cA csp co cA cT cfv cB cA csm co cA csp opreq2 cA cT cfv cB cA csm co
      cA csp opreq1 eqeq12d 3bitr4d adantr cA cB cT eigpos.1 eigpos.2 eigrei
      bitrd biimpac adantlr cB eigpos.2 cjrebi sylib opreq1d cB cc wcel cA chil
      wcel cA chil wcel cA cB cA csm co csp co cB ccj cfv cA cA csp co cmul co
      wceq eigpos.2 eigpos.1 eigpos.1 cB cA cA his5 mp3an syl5eq eqtrd breqtrd
      jca sylanc jca $.
      $( [13-Oct-2006] $) $( [2-Jul-2005] $)
  $}

  ${
    eigorthi.1 $e |- A e. ~H $.
    eigorthi.2 $e |- B e. ~H $.
    eigorthi.3 $e |- C e. CC $.
    eigorthi.4 $e |- D e. CC $.
    $( A necessary and sufficient condition (that holds when ` T ` is a
       Hermitian operator) for two eigenvectors ` A ` and ` B ` to be
       orthogonal.  Generalization of Equation 1.31 of [Hughes] p. 49. $)
    eigorthi $p |- ( ( ( ( T ` A ) = ( C .h A ) /\ ( T ` B ) = ( D .h B ) )
                     /\ C =/= ( * ` D ) ) ->
         ( ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) <-> ( A .ih B ) = 0 ) ) $=
      cA cT cfv cC cA csm co wceq cB cT cfv cD cB csm co wceq wa cA cB cT cfv
      csp co cA cT cfv cB csp co wceq cD ccj cfv cA cB csp co cmul co cC cA cB
      csp co cmul co wceq cC cD ccj cfv wne cA cB csp co cc0 wceq cB cT cfv cD
      cB csm co wceq cA cT cfv cC cA csm co wceq cA cB cT cfv csp co cD ccj cfv
      cA cB csp co cmul co cA cT cfv cB csp co cC cA cB csp co cmul co cB cT
      cfv cD cB csm co wceq cA cB cT cfv csp co cA cD cB csm co csp co cD ccj
      cfv cA cB csp co cmul co cB cT cfv cD cB csm co cA csp opreq2 cD cc wcel
      cA chil wcel cB chil wcel cA cD cB csm co csp co cD ccj cfv cA cB csp co
      cmul co wceq eigorthi.4 eigorthi.1 eigorthi.2 cD cA cB his5 mp3an syl6eq
      cA cT cfv cC cA csm co wceq cA cT cfv cB csp co cC cA csm co cB csp co cC
      cA cB csp co cmul co cA cT cfv cC cA csm co cB csp opreq1 cC cc wcel cA
      chil wcel cB chil wcel cC cA csm co cB csp co cC cA cB csp co cmul co
      wceq eigorthi.3 eigorthi.1 eigorthi.2 cC cA cB ax-his3 mp3an syl6eq
      eqeqan12rd cC cD ccj cfv wne cD ccj cfv cA cB csp co cmul co cC cA cB csp
      co cmul co wceq cA cB csp co cc0 wceq cD ccj cfv cA cB csp co cmul co cC
      cA cB csp co cmul co wceq cC cD ccj cfv wne cA cB csp co cc0 wceq cD ccj
      cfv cA cB csp co cmul co cC cA cB csp co cmul co wceq cA cB csp co cc0 cC
      cD ccj cfv cA cB csp co cc0 wne cD ccj cfv cA cB csp co cmul co cC cA cB
      csp co cmul co wceq cC cD ccj cfv wceq cA cB csp co cc0 wne cD ccj cfv cA
      cB csp co cmul co cC cA cB csp co cmul co wceq cD ccj cfv cC wceq cC cD
      ccj cfv wceq cA cB csp co cc wcel cA cB csp co cc0 wne cD ccj cfv cA cB
      csp co cmul co cC cA cB csp co cmul co wceq cD ccj cfv cC wceq wb cA cB
      eigorthi.1 eigorthi.2 hicli cD ccj cfv cc wcel cC cc wcel cA cB csp co cc
      wcel cA cB csp co cc0 wne wa cD ccj cfv cA cB csp co cmul co cC cA cB csp
      co cmul co wceq cD ccj cfv cC wceq wb cD eigorthi.4 cjcli eigorthi.3 cD
      ccj cfv cC cA cB csp co mulcan2 mp3an12 mpan cD ccj cfv cC eqcom syl6bb
      biimpcd necon1d com12 cA cB csp co cc0 wceq cD ccj cfv cA cB csp co cmul
      co cD ccj cfv cc0 cmul co cC cA cB csp co cmul co cA cB csp co cc0 cD ccj
      cfv cmul opreq2 cA cB csp co cc0 wceq cC cA cB csp co cmul co cC cc0 cmul
      co cD ccj cfv cc0 cmul co cA cB csp co cc0 cC cmul opreq2 cC cc0 cmul co
      cc0 cD ccj cfv cc0 cmul co cC eigorthi.3 mul01i cD ccj cfv cD eigorthi.4
      cjcli mul01i eqtr4i syl6eq eqtr4d impbid1 sylan9bb $.
      $( [13-Jan-2009] $) $( [23-Jan-2005] $)
  $}

  $( A necessary and sufficient condition (that holds when ` T ` is a
     Hermitian operator) for two eigenvectors ` A ` and ` B ` to be
     orthogonal.  Generalization of Equation 1.31 of [Hughes] p. 49. $)
  eigorth $p |- ( ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. CC /\ D e. CC ) ) /\
                 ( ( ( T ` A ) = ( C .h A ) /\ ( T ` B ) = ( D .h B ) )
                   /\ C =/= ( * ` D ) ) ) ->
         ( ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) <-> ( A .ih B ) = 0 ) ) $=
    cA chil wcel cB chil wcel wa cC cc wcel cD cc wcel wa wa cA cT cfv cC cA
    csm co wceq cB cT cfv cD cB csm co wceq wa cC cD ccj cfv wne wa cA cB cT
    cfv csp co cA cT cfv cB csp co wceq cA cB csp co cc0 wceq wb cA chil wcel
    cB chil wcel cC cc wcel cD cc wcel cA cT cfv cC cA csm co wceq cB cT cfv cD
    cB csm co wceq wa cC cD ccj cfv wne wa cA cB cT cfv csp co cA cT cfv cB csp
    co wceq cA cB csp co cc0 wceq wb wi cA cB cC cD c0v c0v cA chil wcel cA c0v
    cif cT cfv cC cA chil wcel cA c0v cif csm co wceq cB cT cfv cD cB csm co
    wceq wa cC cD ccj cfv wne wa cA chil wcel cA c0v cif cB cT cfv csp co cA
    chil wcel cA c0v cif cT cfv cB csp co wceq cA chil wcel cA c0v cif cB csp
    co cc0 wceq wb wi cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif
    csm co wceq cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v cif csm
    co wceq wa cC cD ccj cfv wne wa cA chil wcel cA c0v cif cB chil wcel cB c0v
    cif cT cfv csp co cA chil wcel cA c0v cif cT cfv cB chil wcel cB c0v cif
    csp co wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cc0 wceq
    wb wi cA chil wcel cA c0v cif cT cfv cC cc wcel cC cc0 cif cA chil wcel cA
    c0v cif csm co wceq cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v
    cif csm co wceq wa cC cc wcel cC cc0 cif cD ccj cfv wne wa cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif cT cfv csp co cA chil wcel cA c0v cif cT
    cfv cB chil wcel cB c0v cif csp co wceq cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif csp co cc0 wceq wb wi cA chil wcel cA c0v cif cT cfv cC cc
    wcel cC cc0 cif cA chil wcel cA c0v cif csm co wceq cB chil wcel cB c0v cif
    cT cfv cD cc wcel cD cc0 cif cB chil wcel cB c0v cif csm co wceq wa cC cc
    wcel cC cc0 cif cD cc wcel cD cc0 cif ccj cfv wne wa cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif cT cfv csp co cA chil wcel cA c0v cif cT cfv cB
    chil wcel cB c0v cif csp co wceq cA chil wcel cA c0v cif cB chil wcel cB
    c0v cif csp co cc0 wceq wb wi cc0 cc0 cA cA chil wcel cA c0v cif wceq cA cT
    cfv cC cA csm co wceq cB cT cfv cD cB csm co wceq wa cC cD ccj cfv wne wa
    cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif csm co wceq cB cT
    cfv cD cB csm co wceq wa cC cD ccj cfv wne wa cA cB cT cfv csp co cA cT cfv
    cB csp co wceq cA cB csp co cc0 wceq wb cA chil wcel cA c0v cif cB cT cfv
    csp co cA chil wcel cA c0v cif cT cfv cB csp co wceq cA chil wcel cA c0v
    cif cB csp co cc0 wceq wb cA cA chil wcel cA c0v cif wceq cA cT cfv cC cA
    csm co wceq cB cT cfv cD cB csm co wceq wa cA chil wcel cA c0v cif cT cfv
    cC cA chil wcel cA c0v cif csm co wceq cB cT cfv cD cB csm co wceq wa cC cD
    ccj cfv wne cA cA chil wcel cA c0v cif wceq cA cT cfv cC cA csm co wceq cA
    chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif csm co wceq cB cT
    cfv cD cB csm co wceq cA cA chil wcel cA c0v cif wceq cA cT cfv cA chil
    wcel cA c0v cif cT cfv cC cA csm co cC cA chil wcel cA c0v cif csm co cA cA
    chil wcel cA c0v cif cT fveq2 cA cA chil wcel cA c0v cif cC csm opreq2
    eqeq12d anbi1d anbi1d cA cA chil wcel cA c0v cif wceq cA cB cT cfv csp co
    cA cT cfv cB csp co wceq cA chil wcel cA c0v cif cB cT cfv csp co cA chil
    wcel cA c0v cif cT cfv cB csp co wceq cA cB csp co cc0 wceq cA chil wcel cA
    c0v cif cB csp co cc0 wceq cA cA chil wcel cA c0v cif wceq cA cB cT cfv csp
    co cA chil wcel cA c0v cif cB cT cfv csp co cA cT cfv cB csp co cA chil
    wcel cA c0v cif cT cfv cB csp co cA cA chil wcel cA c0v cif cB cT cfv csp
    opreq1 cA cA chil wcel cA c0v cif wceq cA cT cfv cA chil wcel cA c0v cif cT
    cfv cB csp cA cA chil wcel cA c0v cif cT fveq2 opreq1d eqeq12d cA cA chil
    wcel cA c0v cif wceq cA cB csp co cA chil wcel cA c0v cif cB csp co cc0 cA
    cA chil wcel cA c0v cif cB csp opreq1 eqeq1d bibi12d imbi12d cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v
    cif csm co wceq cB cT cfv cD cB csm co wceq wa cC cD ccj cfv wne wa cA chil
    wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif csm co wceq cB chil wcel
    cB c0v cif cT cfv cD cB chil wcel cB c0v cif csm co wceq wa cC cD ccj cfv
    wne wa cA chil wcel cA c0v cif cB cT cfv csp co cA chil wcel cA c0v cif cT
    cfv cB csp co wceq cA chil wcel cA c0v cif cB csp co cc0 wceq wb cA chil
    wcel cA c0v cif cB chil wcel cB c0v cif cT cfv csp co cA chil wcel cA c0v
    cif cT cfv cB chil wcel cB c0v cif csp co wceq cA chil wcel cA c0v cif cB
    chil wcel cB c0v cif csp co cc0 wceq wb cB cB chil wcel cB c0v cif wceq cA
    chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif csm co wceq cB cT
    cfv cD cB csm co wceq wa cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA
    c0v cif csm co wceq cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v
    cif csm co wceq wa cC cD ccj cfv wne cB cB chil wcel cB c0v cif wceq cB cT
    cfv cD cB csm co wceq cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v
    cif csm co wceq cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif
    csm co wceq cB cB chil wcel cB c0v cif wceq cB cT cfv cB chil wcel cB c0v
    cif cT cfv cD cB csm co cD cB chil wcel cB c0v cif csm co cB cB chil wcel
    cB c0v cif cT fveq2 cB cB chil wcel cB c0v cif cD csm opreq2 eqeq12d anbi2d
    anbi1d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cT cfv
    csp co cA chil wcel cA c0v cif cT cfv cB csp co wceq cA chil wcel cA c0v
    cif cB chil wcel cB c0v cif cT cfv csp co cA chil wcel cA c0v cif cT cfv cB
    chil wcel cB c0v cif csp co wceq cA chil wcel cA c0v cif cB csp co cc0 wceq
    cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp co cc0 wceq cB cB chil
    wcel cB c0v cif wceq cA chil wcel cA c0v cif cB cT cfv csp co cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif cT cfv csp co cA chil wcel cA c0v cif cT
    cfv cB csp co cA chil wcel cA c0v cif cT cfv cB chil wcel cB c0v cif csp co
    cB cB chil wcel cB c0v cif wceq cB cT cfv cB chil wcel cB c0v cif cT cfv cA
    chil wcel cA c0v cif csp cB cB chil wcel cB c0v cif cT fveq2 opreq2d cB cB
    chil wcel cB c0v cif cA chil wcel cA c0v cif cT cfv csp opreq2 eqeq12d cB
    cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif cB csp co cA chil wcel
    cA c0v cif cB chil wcel cB c0v cif csp co cc0 cB cB chil wcel cB c0v cif cA
    chil wcel cA c0v cif csp opreq2 eqeq1d bibi12d imbi12d cC cC cc wcel cC cc0
    cif wceq cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif csm co
    wceq cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v cif csm co wceq
    wa cC cD ccj cfv wne wa cA chil wcel cA c0v cif cT cfv cC cc wcel cC cc0
    cif cA chil wcel cA c0v cif csm co wceq cB chil wcel cB c0v cif cT cfv cD
    cB chil wcel cB c0v cif csm co wceq wa cC cc wcel cC cc0 cif cD ccj cfv wne
    wa cA chil wcel cA c0v cif cB chil wcel cB c0v cif cT cfv csp co cA chil
    wcel cA c0v cif cT cfv cB chil wcel cB c0v cif csp co wceq cA chil wcel cA
    c0v cif cB chil wcel cB c0v cif csp co cc0 wceq wb cC cC cc wcel cC cc0 cif
    wceq cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v cif csm co wceq
    cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v cif csm co wceq wa cA
    chil wcel cA c0v cif cT cfv cC cc wcel cC cc0 cif cA chil wcel cA c0v cif
    csm co wceq cB chil wcel cB c0v cif cT cfv cD cB chil wcel cB c0v cif csm
    co wceq wa cC cD ccj cfv wne cC cc wcel cC cc0 cif cD ccj cfv wne cC cC cc
    wcel cC cc0 cif wceq cA chil wcel cA c0v cif cT cfv cC cA chil wcel cA c0v
    cif csm co wceq cA chil wcel cA c0v cif cT cfv cC cc wcel cC cc0 cif cA
    chil wcel cA c0v cif csm co wceq cB chil wcel cB c0v cif cT cfv cD cB chil
    wcel cB c0v cif csm co wceq cC cC cc wcel cC cc0 cif wceq cC cA chil wcel
    cA c0v cif csm co cC cc wcel cC cc0 cif cA chil wcel cA c0v cif csm co cA
    chil wcel cA c0v cif cT cfv cC cC cc wcel cC cc0 cif cA chil wcel cA c0v
    cif csm opreq1 eqeq2d anbi1d cC cC cc wcel cC cc0 cif cD ccj cfv neeq1
    anbi12d imbi1d cD cD cc wcel cD cc0 cif wceq cA chil wcel cA c0v cif cT cfv
    cC cc wcel cC cc0 cif cA chil wcel cA c0v cif csm co wceq cB chil wcel cB
    c0v cif cT cfv cD cB chil wcel cB c0v cif csm co wceq wa cC cc wcel cC cc0
    cif cD ccj cfv wne wa cA chil wcel cA c0v cif cT cfv cC cc wcel cC cc0 cif
    cA chil wcel cA c0v cif csm co wceq cB chil wcel cB c0v cif cT cfv cD cc
    wcel cD cc0 cif cB chil wcel cB c0v cif csm co wceq wa cC cc wcel cC cc0
    cif cD cc wcel cD cc0 cif ccj cfv wne wa cA chil wcel cA c0v cif cB chil
    wcel cB c0v cif cT cfv csp co cA chil wcel cA c0v cif cT cfv cB chil wcel
    cB c0v cif csp co wceq cA chil wcel cA c0v cif cB chil wcel cB c0v cif csp
    co cc0 wceq wb cD cD cc wcel cD cc0 cif wceq cA chil wcel cA c0v cif cT cfv
    cC cc wcel cC cc0 cif cA chil wcel cA c0v cif csm co wceq cB chil wcel cB
    c0v cif cT cfv cD cB chil wcel cB c0v cif csm co wceq wa cA chil wcel cA
    c0v cif cT cfv cC cc wcel cC cc0 cif cA chil wcel cA c0v cif csm co wceq cB
    chil wcel cB c0v cif cT cfv cD cc wcel cD cc0 cif cB chil wcel cB c0v cif
    csm co wceq wa cC cc wcel cC cc0 cif cD ccj cfv wne cC cc wcel cC cc0 cif
    cD cc wcel cD cc0 cif ccj cfv wne cD cD cc wcel cD cc0 cif wceq cB chil
    wcel cB c0v cif cT cfv cD cB chil wcel cB c0v cif csm co wceq cB chil wcel
    cB c0v cif cT cfv cD cc wcel cD cc0 cif cB chil wcel cB c0v cif csm co wceq
    cA chil wcel cA c0v cif cT cfv cC cc wcel cC cc0 cif cA chil wcel cA c0v
    cif csm co wceq cD cD cc wcel cD cc0 cif wceq cD cB chil wcel cB c0v cif
    csm co cD cc wcel cD cc0 cif cB chil wcel cB c0v cif csm co cB chil wcel cB
    c0v cif cT cfv cD cD cc wcel cD cc0 cif cB chil wcel cB c0v cif csm opreq1
    eqeq2d anbi2d cD cD cc wcel cD cc0 cif wceq cD ccj cfv cD cc wcel cD cc0
    cif ccj cfv cC cc wcel cC cc0 cif cD cD cc wcel cD cc0 cif ccj fveq2 neeq2d
    anbi12d imbi1d cA chil wcel cA c0v cif cB chil wcel cB c0v cif cC cc wcel
    cC cc0 cif cD cc wcel cD cc0 cif cT cA c0v chil ax-hv0cl elimel cB c0v chil
    ax-hv0cl elimel cC cc0 cc 0cn elimel cD cc0 cc 0cn elimel eigorthi dedth4h
    imp $.
    $( [15-Jan-2009] $) $( [23-Mar-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Linear, continuous, bounded, Hermitian, unitary operators and norms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define the norm of a Hilbert space operator. $)
    df-nmop $a |- normop = { <. t , y >. | ( t : ~H --> ~H /\ y = sup (
       { x | E. z e. ~H ( ( normh ` z ) <_ 1 /\ x = ( normh ` ( t ` z ) ) ) } ,
              RR* , < ) ) } $.

    $( Define the set of continuous operators on Hilbert space.  For every
       "epsilon" ( ` y ` ) there is an "delta" ( ` z ` ) such that... $)
    df-cnop $a |- ConOp = { t | ( t :  ~H --> ~H /\ A. x e. ~H A. y e. RR (
      0 < y -> E. z e. RR ( 0 < z /\ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
      ( normh ` ( ( t ` w ) -h ( t ` x ) ) ) < y ) ) ) ) } $.

    $( Define the set of linear operators on Hilbert space.  (See ~ df-hosum
       for definition of operator.) $)
    df-lnop $a |- LinOp = { t | ( t : ~H --> ~H /\
           A. x e. CC A. y e. ~H A. z e. ~H
       ( t ` ( ( x .h y ) +h z ) ) = ( ( x .h ( t ` y ) ) +h ( t ` z ) ) ) } $.

    $( Define the set of bounded linear Hilbert space operators.  (See
       ~ df-hosum for definition of operator.) $)
    df-bdop $a |- BndLinOp = ( LinOp i^i { t | ( t : ~H --> ~H /\
                   ( normop ` t ) < +oo ) } ) $.

    $( Define the set of unitary operators on Hilbert space. $)
    df-unop $a |- UniOp = { t | ( t : ~H -onto-> ~H /\
         A. x e. ~H A. y e. ~H ( ( t ` x ) .ih ( t ` y ) ) = ( x .ih y ) ) } $.

    $( Define the set of Hermitian operators on Hilbert space.  Some books
       call these "symmetric operators" and others call them "self-adjoint
       operators," sometimes with slightly different technical meanings. $)
    df-hmop $a |- HrmOp = { t | ( t : ~H --> ~H /\ A. x e. ~H A. y e. ~H
                   ( x .ih ( t ` y ) ) = ( ( t ` x ) .ih y ) ) } $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Linear and continuous functionals and norms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define the norm of a Hilbert space functional. $)
    df-nmfn $a |- normfn = { <. t , y >. | ( t : ~H --> CC /\ y = sup (
         { x | E. z e. ~H ( ( normh ` z ) <_ 1 /\ x = ( abs ` ( t ` z ) ) ) } ,
              RR* , < ) ) } $.

    $( Define the null space of a Hilbert space functional. $)
    df-nlfn $a |- null = { <. t , y >. | ( t : ~H --> CC /\ y =
                 { x e. ~H | ( t ` x ) = 0 } ) } $.

    $( Define the set of continuous functionals on Hilbert space.  For every
       "epsilon" ( ` y ` ) there is an "delta" ( ` z ` ) such that... $)
    df-cnfn $a |- ConFn = { t | ( t :  ~H --> CC /\ A. x e. ~H A. y e. RR (
      0 < y -> E. z e. RR ( 0 < z /\ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
      ( abs ` ( ( t ` w ) - ( t ` x ) ) ) < y ) ) ) ) } $.

    $( Define the set of linear functionals on Hilbert space. $)
    df-lnfn $a |- LinFn = { t | ( t : ~H --> CC /\
           A. x e. CC A. y e. ~H A. z e. ~H
       ( t ` ( ( x .h y ) +h z ) ) = ( ( x x. ( t ` y ) ) + ( t ` z ) ) ) } $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Adjoint
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define the adjoint of a Hilbert space operator (if it exists).  The
       domain of ` adjh ` is the set of all adjoint operators.  Definition of
       adjoint in [Kalmbach2] p. 8.  Unlike Kalmbach (and most authors), we do
       not demand that the operator be linear, but instead show (in
       ~ adjbdln ) that the adjoint exists for a bounded linear operator. $)
    df-adjh $a |- adjh = { <. t , u >. | ( t : ~H --> ~H /\ u : ~H --> ~H /\
         A. x e. ~H A. y e. ~H ( ( t ` x ) .ih y ) = ( x .ih ( u ` y ) ) ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Dirac bra-ket notation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define the bra of a vector used by Dirac notation.  Based on definition
       of bra in [Prugovecki] p. 186 (p. 180 in 1971 edition).  In Dirac
       bra-ket notation, ` <. A | B >. ` is a complex number equal to the inner
       product ` ( B .ih A ) ` . But physicists like to talk about the
       individual components ` <. A | ` and ` | B >. ` , called bra and ket
       respectively.  In order for their properties to make sense formally, we
       define the ket ` | B >. ` as the vector ` B ` itself, and the bra
       ` <. A | ` as a functional from ` ~H ` to ` CC ` . We represent the
       Dirac notation ` <. A | B >. ` by ` ( ( bra `` A ) `` B ) ` ; see
       ~ bravalval . The reversal of the inner product arguments not only makes
       the bra-ket behavior consistent with physics literature (see comments
       under ~ ax-his3 ) but is also required in order for the associative law
       ~ kbass2 to work.

       Our definition of bra and the associated outer product ~ df-kb differs
       from, but is equivalent to, a common approach in the literature that
       makes use of mappings to a dual space.  Our approach eliminates the need
       to have a parallel development of this dual space and instead keeps
       everything in Hilbert space.

       _For an extensive discussion about how our notation maps to the bra-ket
       notation in physics textbooks, see
       ~ http://us.metamath.org/mpegif/mmnotes.txt , under the
       17-May-2006 entry_. $)
    df-bra $a |- bra = { <. x , t >. | ( x e. ~H /\
                    t = { <. y , z >. | ( y e. ~H /\ z = ( y .ih x ) ) } ) } $.

    $( Define a commuted bra and ket juxtaposition used by Dirac notation.
       In Dirac notation, ` | A >. ` ` <. B | ` is an operator known as the
       outer product of ` A ` and ` B ` , which we represent by
       ` ( A ketbra B ) ` .  Based on Equation 8.1 of [Prugovecki] p. 376.
       This definition, combined with definition ~ df-bra , allows any legal
       juxtaposition of bras and kets to make sense formally and also to obey
       the associative law when mapped back to Dirac notation. $)
    df-kb $a |- ketbra = { <. <. x , y >. , t >. | ( ( x e. ~H /\ y e. ~H )
        /\ t = { <. w , v >. | ( w e. ~H /\ v = ( ( w .ih y ) .h x ) ) } ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Positive operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define positive operator ordering.  Definition VI.1 of [Retherford]
       p. 49.  Note that ` ( ~H X. 0H ) <_op T ` means that ` T ` is a
       positive operator. $)
    df-leop $a |- <_op = { <. t , u >. | ( ( u -op t ) e. HrmOp /\
               A. x e. ~H 0 <_ ( ( ( u -op t ) ` x ) .ih x ) ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Eigenvectors, eigenvalues, spectrum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define the eigenvector function.  Theorem ~ eleigveccl shows that
       ` eigvec `` T ` , the set of eigenvectors of Hilbert space operator
       ` T ` , are Hilbert space vectors. $)
    df-eigvec $a |- eigvec = { <. t , y >. | ( t : ~H --> ~H /\ y =
         { x e. ~H | ( x =/= 0h /\ E. z e. CC ( t ` x ) = ( z .h x ) ) } ) } $.

    $( Define the eigenvalue function.  The range of ` eigval `` T ` is the set
       of eigenvalues of Hilbert space operator ` T ` . Theorem ~ eigvalcl
       shows that ` ( eigval `` T ) `` A ` , the eigenvalue associated with
       eigenvector ` A ` , is a complex number. $)
    df-eigval $a |- eigval = { <. t , y >. | ( t : ~H --> ~H /\ y =
                   { <. x , z >. | ( x e. ( eigvec ` t ) /\
                 z = ( ( ( t ` x ) .ih x ) / ( ( normh ` x ) ^ 2 ) ) ) } ) } $.

    $( Define the spectrum of an operator.  Definition of spectrum in [Halmos]
       p. 50. $)
    df-spec $a |- Lambda = { <. t , y >. | ( t : ~H --> ~H /\
    y = { x e. CC | -. ( t -op ( x .op ( _I |` ~H ) ) ) : ~H -1-1-> ~H } ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Theorems about operators and functionals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z T $.
    $( Value of the norm of a Hilbert space operator. $)
    nmopval $p |- ( T : ~H --> ~H -> ( normop ` T ) = sup ( { x | E. y e. ~H
         ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } , RR* , < ) ) $=
      vt vz cT vy cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cno cfv wceq wa
      vy chil wrex vx cab cxr clt csup vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup chil chil cnop cxr
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex
      vx cab clt xrltso supex ax-hilex ax-hilex vt cv cT wceq vy cv cno cfv c1
      cle wbr vx cv vy cv vt cv cfv cno cfv wceq wa vy chil wrex vx cab vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab
      wceq vy cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cno cfv wceq wa vy
      chil wrex vx cab cxr clt csup vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cno cfv wceq wa vy chil wrex vx cab cxr clt csup wceq vt cv cT wceq vy cv
      cno cfv c1 cle wbr vx cv vy cv vt cv cfv cno cfv wceq wa vy chil wrex vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx
      vt cv cT wceq vy cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cno cfv wceq
      wa vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil vt
      cv cT wceq vx cv vy cv vt cv cfv cno cfv wceq vx cv vy cv cT cfv cno cfv
      wceq vy cv cno cfv c1 cle wbr vt cv cT wceq vy cv vt cv cfv cno cfv vy cv
      cT cfv cno cfv vx cv vt cv cT wceq vy cv vt cv cfv vy cv cT cfv cno vy cv
      vt cv cT fveq1 fveq2d eqeq2d anbi2d rexbidv abbidv cxr vy cv cno cfv c1
      cle wbr vx cv vy cv vt cv cfv cno cfv wceq wa vy chil wrex vx cab vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab
      clt supeq1 syl vx vz vy vt df-nmop fvopabf4 $.
      $( [19-Feb-2006] $) $( [18-Jan-2006] $)

    $( Property defining a continuous Hilbert space operator. $)
    elcnop $p |- ( T e. ConOp <-> ( T :  ~H --> ~H /\ A. x e. ~H A. y e. RR (
      0 < y -> E. z e. RR ( 0 < z /\ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
      ( normh ` ( ( T ` w ) -h ( T ` x ) ) ) < y ) ) ) ) ) $=
      cT cco wcel cT cvv wcel chil chil cT wf cc0 vy cv clt wbr cc0 vz cv clt
      wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv
      cmv co cno cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vy cr wral
      vx chil wral wa cT cco elisset chil chil cT wf cT cvv wcel cc0 vy cv clt
      wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT
      cfv vx cv cT cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa vz cr
      wrex wi vy cr wral vx chil wral chil chil cT wf chil cvv wcel cT cvv wcel
      ax-hilex chil chil cvv cT fex mpan2 adantr chil chil vt cv wf cc0 vy cv
      clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv
      vt cv cfv vx cv vt cv cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa
      vz cr wrex wi vy cr wral vx chil wral wa chil chil cT wf cc0 vy cv clt
      wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT
      cfv vx cv cT cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa vz cr
      wrex wi vy cr wral vx chil wral wa vt cT cco cvv vt cv cT wceq chil chil
      vt cv wf chil chil cT wf cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv
      cmv co cno cfv vz cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmv co cno
      cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vy cr wral vx chil
      wral cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv
      clt wbr vw cv cT cfv vx cv cT cfv cmv co cno cfv vy cv clt wbr wi vw chil
      wral wa vz cr wrex wi vy cr wral vx chil wral chil chil vt cv cT feq1 vt
      cv cT wceq cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv
      vz cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmv co cno cfv vy cv clt
      wbr wi vw chil wral wa vz cr wrex wi cc0 vy cv clt wbr cc0 vz cv clt wbr
      vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv cmv co
      cno cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vx vy chil cr vt
      cv cT wceq cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw
      cv vt cv cfv vx cv vt cv cfv cmv co cno cfv vy cv clt wbr wi vw chil wral
      wa vz cr wrex cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr
      vw cv cT cfv vx cv cT cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa
      vz cr wrex cc0 vy cv clt wbr vt cv cT wceq cc0 vz cv clt wbr vw cv vx cv
      cmv co cno cfv vz cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmv co cno
      cfv vy cv clt wbr wi vw chil wral wa cc0 vz cv clt wbr vw cv vx cv cmv co
      cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv cmv co cno cfv vy cv clt
      wbr wi vw chil wral wa vz cr vt cv cT wceq vw cv vx cv cmv co cno cfv vz
      cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmv co cno cfv vy cv clt wbr
      wi vw chil wral vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx
      cv cT cfv cmv co cno cfv vy cv clt wbr wi vw chil wral cc0 vz cv clt wbr
      vt cv cT wceq vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv vt cv cfv vx
      cv vt cv cfv cmv co cno cfv vy cv clt wbr wi vw cv vx cv cmv co cno cfv
      vz cv clt wbr vw cv cT cfv vx cv cT cfv cmv co cno cfv vy cv clt wbr wi
      vw chil vt cv cT wceq vw cv vt cv cfv vx cv vt cv cfv cmv co cno cfv vy
      cv clt wbr vw cv cT cfv vx cv cT cfv cmv co cno cfv vy cv clt wbr vw cv
      vx cv cmv co cno cfv vz cv clt wbr vt cv cT wceq vw cv vt cv cfv vx cv vt
      cv cfv cmv co cno cfv vw cv cT cfv vx cv cT cfv cmv co cno cfv vy cv clt
      vt cv cT wceq vw cv vt cv cfv vx cv vt cv cfv cmv co vw cv cT cfv vx cv
      cT cfv cmv co cno vt cv cT wceq vw cv vt cv cfv vw cv cT cfv vx cv vt cv
      cfv vx cv cT cfv cmv vw cv vt cv cT fveq1 vx cv vt cv cT fveq1 opreq12d
      fveq2d breq1d imbi2d ralbidv anbi2d rexbidv imbi2d 2ralbidv anbi12d vx vy
      vz vw vt df-cnop elab2g pm5.21nii $.
      $( [20-Feb-2006] $) $( [28-Jan-2006] $)

    $( Property defining a linear Hilbert space operator. $)
    ellnop $p |- ( T e. LinOp <-> ( T : ~H --> ~H /\
        A. x e. CC A. y e. ~H A. z e. ~H
       ( T ` ( ( x .h y ) +h z ) ) = ( ( x .h ( T ` y ) ) +h ( T ` z ) ) ) ) $=
      cT clo wcel cT cvv wcel chil chil cT wf vx cv vy cv csm co vz cv cva co
      cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz chil wral vy
      chil wral vx cc wral wa cT clo elisset chil chil cT wf cT cvv wcel vx cv
      vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv
      cva co wceq vz chil wral vy chil wral vx cc wral chil chil cT wf chil cvv
      wcel cT cvv wcel ax-hilex chil chil cvv cT fex mpan2 adantr chil chil vt
      cv wf vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv csm
      co vz cv vt cv cfv cva co wceq vz chil wral vy chil wral vx cc wral wa
      chil chil cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv
      csm co vz cv cT cfv cva co wceq vz chil wral vy chil wral vx cc wral wa
      vt cT clo cvv vt cv cT wceq chil chil vt cv wf chil chil cT wf vx cv vy
      cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv csm co vz cv vt cv
      cfv cva co wceq vz chil wral vy chil wral vx cc wral vx cv vy cv csm co
      vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz
      chil wral vy chil wral vx cc wral chil chil vt cv cT feq1 vt cv cT wceq
      vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv csm co vz
      cv vt cv cfv cva co wceq vz chil wral vx cv vy cv csm co vz cv cva co cT
      cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz chil wral vx vy
      cc chil vt cv cT wceq vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy
      cv vt cv cfv csm co vz cv vt cv cfv cva co wceq vx cv vy cv csm co vz cv
      cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz chil
      vt cv cT wceq vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv csm
      co vz cv cva co cT cfv vx cv vy cv vt cv cfv csm co vz cv vt cv cfv cva
      co vx cv vy cv cT cfv csm co vz cv cT cfv cva co vx cv vy cv csm co vz cv
      cva co vt cv cT fveq1 vt cv cT wceq vx cv vy cv vt cv cfv csm co vx cv vy
      cv cT cfv csm co vz cv vt cv cfv vz cv cT cfv cva vt cv cT wceq vy cv vt
      cv cfv vy cv cT cfv vx cv csm vy cv vt cv cT fveq1 opreq2d vz cv vt cv cT
      fveq1 opreq12d eqeq12d ralbidv 2ralbidv anbi12d vx vy vz vt df-lnop
      elab2g pm5.21nii $.
      $( [25-Feb-2006] $) $( [18-Jan-2006] $)

    $( A linear Hilbert space operator is a Hilbert space operator. $)
    lnopf $p |- ( T e. LinOp -> T : ~H --> ~H ) $=
      cT clo wcel chil chil cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv
      vy cv cT cfv csm co vz cv cT cfv cva co wceq vz chil wral vy chil wral vx
      cc wral vx vy vz cT ellnop pm3.26bi $.
      $( [25-Feb-2006] $) $( [18-Jan-2006] $)

    $( Alternate definition of the set of bounded linear Hilbert space
       operators. $)
    dfbdop2 $p |- BndLinOp = { t e. LinOp | ( normop ` t ) < +oo } $=
      clo chil chil vt cv wf vt cv cnop cfv cpnf clt wbr wa vt cab cin chil
      chil vt cv wf vt cv cnop cfv cpnf clt wbr wa vt clo crab cbo vt cv cnop
      cfv cpnf clt wbr vt clo crab clo chil chil vt cv wf vt cv cnop cfv cpnf
      clt wbr wa vt cab cin chil chil vt cv wf vt cv cnop cfv cpnf clt wbr wa
      vt cab clo cin chil chil vt cv wf vt cv cnop cfv cpnf clt wbr wa vt clo
      crab clo chil chil vt cv wf vt cv cnop cfv cpnf clt wbr wa vt cab incom
      chil chil vt cv wf vt cv cnop cfv cpnf clt wbr wa vt clo dfrab2 eqtr4i vt
      df-bdop vt cv cnop cfv cpnf clt wbr chil chil vt cv wf vt cv cnop cfv
      cpnf clt wbr wa vt clo vt cv clo wcel chil chil vt cv wf vt cv cnop cfv
      cpnf clt wbr vt cv lnopf biantrurd rabbii 3eqtr4i $.
      $( [20-Nov-2007] $) $( [19-Nov-2007] $)

    $( Property defining a bounded linear Hilbert space operator. $)
    elbdop $p |- ( T e. BndLinOp <->
                  ( T e. LinOp /\ ( normop ` T ) < +oo ) ) $=
      vt cv cnop cfv cpnf clt wbr cT cnop cfv cpnf clt wbr vt cT clo cbo vt cv
      cT wceq vt cv cnop cfv cT cnop cfv cpnf clt vt cv cT cnop fveq2 breq1d vt
      dfbdop2 elrab2 $.
      $( [25-Feb-2006] $) $( [18-Jan-2006] $)

    $( A bounded linear Hilbert space operator is a linear operator. $)
    bdopln $p |- ( T e. BndLinOp -> T e. LinOp ) $=
      cT cbo wcel cT clo wcel cT cnop cfv cpnf clt wbr cT elbdop pm3.26bi $.
      $( [25-Feb-2006] $) $( [18-Feb-2006] $)

    $( A bounded linear Hilbert space operator is a Hilbert space operator. $)
    bdopf $p |- ( T e. BndLinOp -> T : ~H --> ~H ) $=
      cT cbo wcel cT clo wcel chil chil cT wf cT bdopln cT lnopf syl $.
      $( [25-Feb-2006] $) $( [2-Feb-2006] $)

    $( The set in the supremum of the operator norm definition ~ df-nmop is a
       set of reals. $)
    nmopsetretALT $p |- ( T : ~H --> ~H -> { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } C_ RR ) $=
      chil chil cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vx cr chil chil cT wf vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cno cfv wceq wa vx cv cr wcel vy chil chil chil cT wf vy cv
      chil wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vx
      cv cr wcel chil chil cT wf vy cv chil wcel wa vx cv vy cv cT cfv cno cfv
      wceq vx cv cr wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv
      wceq chil chil cT wf vy cv chil wcel wa vx cv cr wcel vx cv vy cv cT cfv
      cno cfv wceq vx cv cr wcel vy cv cT cfv cno cfv cr wcel chil chil cT wf
      vy cv chil wcel wa vx cv vy cv cT cfv cno cfv cr eleq1 chil chil cT wf vy
      cv chil wcel wa vy cv cT cfv chil wcel vy cv cT cfv cno cfv cr wcel chil
      chil vy cv cT ffvelrn vy cv cT cfv normcl syl syl5bir impcom adantrl
      exp31 r19.23adv abssdv $.
      $( [25-Feb-2006] $) $( [2-Feb-2006] $)

    $( The set in the supremum of the operator norm definition ~ df-nmop is a
       set of reals. $)
    nmopsetretHIL $p |- ( T : ~H --> ~H -> { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } C_ RR ) $=
      cva csm cop cno cop cnv wcel chil chil cT wf vy cv cno cfv c1 cle wbr vx
      cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cr wss cva csm cop
      cno cop cva csm cop cno cop eqid hhnv vx vy cT cno cno cva csm cop cno
      cop chil chil cva csm cop cno cop cva csm cop cno cop eqid hhba cva csm
      cop cno cop cva csm cop cno cop eqid hhnm nmosetre mpan $.
      $( [22-Mar-2008] $) $( [2-Feb-2006] $)

    $( The set in the supremum of the operator norm definition ~ df-nmop is
       nonempty. $)
    nmopsetn0 $p |- ( normh ` ( T ` 0h ) ) e.
      { x | E. y e. ~H ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } $=
      c0v cT cfv cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv
      wceq wa vy chil wrex vx cab wcel vy cv cno cfv c1 cle wbr c0v cT cfv cno
      cfv vy cv cT cfv cno cfv wceq wa vy chil wrex c0v chil wcel c0v cno cfv
      c1 cle wbr c0v cT cfv cno cfv c0v cT cfv cno cfv wceq wa vy cv cno cfv c1
      cle wbr c0v cT cfv cno cfv vy cv cT cfv cno cfv wceq wa vy chil wrex
      ax-hv0cl c0v cno cfv c1 cle wbr c0v cT cfv cno cfv c0v cT cfv cno cfv
      wceq c0v cno cfv cc0 c1 cle norm0 cc0 c1 0re 1re lt01 ltleii eqbrtri c0v
      cT cfv cno cfv eqid pm3.2i vy cv cno cfv c1 cle wbr c0v cT cfv cno cfv vy
      cv cT cfv cno cfv wceq wa c0v cno cfv c1 cle wbr c0v cT cfv cno cfv c0v
      cT cfv cno cfv wceq wa vy c0v chil vy cv c0v wceq vy cv cno cfv c1 cle
      wbr c0v cno cfv c1 cle wbr c0v cT cfv cno cfv vy cv cT cfv cno cfv wceq
      c0v cT cfv cno cfv c0v cT cfv cno cfv wceq vy cv c0v wceq vy cv cno cfv
      c0v cno cfv c1 cle vy cv c0v cno fveq2 breq1d vy cv c0v wceq vy cv cT cfv
      cno cfv c0v cT cfv cno cfv c0v cT cfv cno cfv vy cv c0v wceq vy cv cT cfv
      c0v cT cfv cno vy cv c0v cT fveq2 fveq2d eqeq2d anbi12d rcla4ev mp2an vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vy
      cv cno cfv c1 cle wbr c0v cT cfv cno cfv vy cv cT cfv cno cfv wceq wa vy
      chil wrex vx c0v cT cfv cno cfv c0v cT cfv cno fvex vx cv c0v cT cfv cno
      cfv wceq vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy
      cv cno cfv c1 cle wbr c0v cT cfv cno cfv vy cv cT cfv cno cfv wceq wa vy
      chil vx cv c0v cT cfv cno cfv wceq vx cv vy cv cT cfv cno cfv wceq c0v cT
      cfv cno cfv vy cv cT cfv cno cfv wceq vy cv cno cfv c1 cle wbr vx cv c0v
      cT cfv cno cfv vy cv cT cfv cno cfv eqeq1 anbi2d rexbidv elab mpbir $.
      $( [25-Feb-2006] $) $( [9-Feb-2006] $)

    $( The norm of a Hilbert space operator is an extended real. $)
    nmopxr $p |- ( T : ~H --> ~H -> ( normop ` T ) e. RR* ) $=
      chil chil cT wf cT cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cno cfv wceq wa vy chil wrex vx cab cxr clt csup cxr vx vy cT nmopval
      chil chil cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vx cab cxr wss vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup cxr wcel chil chil
      cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil
      wrex vx cab cr cxr vx vy cT nmopsetretHIL cr cxr wss chil chil cT wf
      ressxr a1i sstrd vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vx cab supxrcl syl eqeltrd $.
      $( [25-Feb-2006] $) $( [9-Feb-2006] $)

    $( The norm of a Hilbert space operator is either real or plus infinity. $)
    nmoprepnf $p |- ( T : ~H --> ~H ->
                   ( ( normop ` T ) e. RR <-> ( normop ` T ) =/= +oo ) ) $=
      chil chil cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vx cab cxr clt csup cr wcel vy cv cno cfv c1 cle wbr vx
      cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup cpnf wne
      cT cnop cfv cr wcel cT cnop cfv cpnf wne chil chil cT wf vy cv cno cfv c1
      cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cr wss vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx
      cab cxr clt csup cr wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno
      cfv wceq wa vy chil wrex vx cab cxr clt csup cpnf wne wb vx vy cT
      nmopsetretHIL vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa
      vy chil wrex vx cab cr wss vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cno cfv wceq wa vy chil wrex vx cab c0 wne vy cv cno cfv c1 cle wbr vx cv
      vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup cr wcel vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx
      cab cxr clt csup cpnf wne wb c0v cT cfv cno cfv vy cv cno cfv c1 cle wbr
      vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab wcel vy cv cno cfv
      c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab c0 wne
      vx vy cT nmopsetn0 vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv
      wceq wa vy chil wrex vx cab c0v cT cfv cno cfv ne0i ax-mp vy cv cno cfv
      c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab
      supxrre2 mpan2 syl chil chil cT wf cT cnop cfv vy cv cno cfv c1 cle wbr
      vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup cr vx
      vy cT nmopval eleq1d chil chil cT wf cT cnop cfv cpnf vy cv cno cfv c1
      cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt
      csup cpnf chil chil cT wf cT cnop cfv vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup cpnf vx vy cT
      nmopval eqeq1d necon3bid 3bitr4d $.
      $( [8-Dec-2007] $) $( [5-Feb-2006] $)

    $( The norm of a Hilbert space operator is not minus infinity. $)
    nmopgtmnf $p |- ( T : ~H --> ~H -> -oo < ( normop ` T ) ) $=
      chil chil cT wf cT cnop cfv cr wcel cT cnop cfv cpnf wceq wn wb cT cnop
      cfv cr wcel cT cnop cfv cpnf wceq wo cmnf cT cnop cfv clt wbr chil chil
      cT wf cT cnop cfv cr wcel cT cnop cfv cpnf wne cT cnop cfv cpnf wceq wn
      cT nmoprepnf cT cnop cfv cpnf df-ne syl6bb cT cnop cfv cr wcel cT cnop
      cfv cpnf wceq wn wb cT cnop cfv cr wcel cT cnop cfv cpnf wceq wb wn cT
      cnop cfv cr wcel cT cnop cfv cpnf wceq wo cT cnop cfv cr wcel cT cnop cfv
      cpnf wceq xor3 cT cnop cfv cr wcel cT cnop cfv cpnf wceq wb wn cT cnop
      cfv cr wcel cT cnop cfv cpnf wceq wo cT cnop cfv cr wcel cT cnop cfv cpnf
      wceq wa wn cT cnop cfv cr wcel cT cnop cfv cpnf wceq xor2 pm3.26bi sylbir
      cT cnop cfv mnfltxr 3syl $.
      $( [9-Mar-2006] $) $( [2-Feb-2006] $)

    $( The norm of a Hilbert space operator is real iff it is less than
       infinity. $)
    nmopreltpnf $p |- ( T : ~H --> ~H ->
                   ( ( normop ` T ) e. RR <-> ( normop ` T ) < +oo ) ) $=
      chil chil cT wf cT cnop cfv cr wcel cT cnop cfv cpnf wne cT cnop cfv cpnf
      clt wbr cT nmoprepnf chil chil cT wf cT cnop cfv cpnf clt wbr cT cnop cfv
      cpnf chil chil cT wf cT cnop cfv cxr wcel cT cnop cfv cpnf wceq cT cnop
      cfv cpnf clt wbr wn wb cT nmopxr cT cnop cfv nltpnft syl necon2abid
      bitr4d $.
      $( [10-Mar-2006] $) $( [14-Feb-2006] $)

    $( The norm of a bounded operator is a real number. $)
    nmopre $p |- ( T e. BndLinOp -> ( normop ` T ) e. RR ) $=
      cT cbo wcel cT cnop cfv cr wcel cmnf cT cnop cfv clt wbr cT cnop cfv cpnf
      clt wbr wa cT cbo wcel cmnf cT cnop cfv clt wbr cT cnop cfv cpnf clt wbr
      cT cbo wcel chil chil cT wf cmnf cT cnop cfv clt wbr cT bdopf cT
      nmopgtmnf syl cT cbo wcel cT clo wcel cT cnop cfv cpnf clt wbr cT elbdop
      pm3.27bi jca cT cbo wcel chil chil cT wf cT cnop cfv cxr wcel cT cnop cfv
      cr wcel cmnf cT cnop cfv clt wbr cT cnop cfv cpnf clt wbr wa wb cT bdopf
      cT nmopxr cT cnop cfv xrrebnd 3syl mpbird $.
      $( [11-Mar-2006] $) $( [29-Jan-2006] $)

    $( Property defining a bounded linear Hilbert space operator. $)
    elbdop2 $p |- ( T e. BndLinOp <->
                   ( T e. LinOp /\ ( normop ` T ) e. RR ) ) $=
      cT cbo wcel cT clo wcel cT cnop cfv cpnf clt wbr wa cT clo wcel cT cnop
      cfv cr wcel wa cT elbdop cT clo wcel cT cnop cfv cr wcel cT cnop cfv cpnf
      clt wbr cT clo wcel chil chil cT wf cT cnop cfv cr wcel cT cnop cfv cpnf
      clt wbr wb cT lnopf cT nmopreltpnf syl pm5.32i bitr4i $.
      $( [11-Mar-2006] $) $( [14-Feb-2006] $)

    $( Property defining a unitary Hilbert space operator. $)
    elunop $p |- ( T e. UniOp <-> ( T : ~H -onto-> ~H /\
        A. x e. ~H A. y e. ~H ( ( T ` x ) .ih ( T ` y ) ) = ( x .ih y ) ) ) $=
      cT cuo wcel cT cvv wcel chil chil cT wfo vx cv cT cfv vy cv cT cfv csp co
      vx cv vy cv csp co wceq vy chil wral vx chil wral wa cT cuo elisset chil
      chil cT wfo cT cvv wcel vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp
      co wceq vy chil wral vx chil wral chil chil cT wfo chil chil cT wf cT cvv
      wcel chil chil cT fof chil chil cT wf chil cvv wcel cT cvv wcel ax-hilex
      chil chil cvv cT fex mpan2 syl adantr chil chil vt cv wfo vx cv vt cv cfv
      vy cv vt cv cfv csp co vx cv vy cv csp co wceq vy chil wral vx chil wral
      wa chil chil cT wfo vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co
      wceq vy chil wral vx chil wral wa vt cT cuo cvv vt cv cT wceq chil chil
      vt cv wfo chil chil cT wfo vx cv vt cv cfv vy cv vt cv cfv csp co vx cv
      vy cv csp co wceq vy chil wral vx chil wral vx cv cT cfv vy cv cT cfv csp
      co vx cv vy cv csp co wceq vy chil wral vx chil wral chil chil vt cv cT
      foeq1 vt cv cT wceq vx cv vt cv cfv vy cv vt cv cfv csp co vx cv vy cv
      csp co wceq vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co wceq vx
      vy chil chil vt cv cT wceq vx cv vt cv cfv vy cv vt cv cfv csp co vx cv
      cT cfv vy cv cT cfv csp co vx cv vy cv csp co vt cv cT wceq vx cv vt cv
      cfv vx cv cT cfv vy cv vt cv cfv vy cv cT cfv csp vx cv vt cv cT fveq1 vy
      cv vt cv cT fveq1 opreq12d eqeq1d 2ralbidv anbi12d vx vy vt df-unop
      elab2g pm5.21nii $.
      $( [26-Feb-2006] $) $( [18-Jan-2006] $)

    $( Property defining a Hermitian Hilbert space operator. $)
    elhmop $p |- ( T e. HrmOp <-> ( T : ~H --> ~H /\ A. x e. ~H A. y e. ~H
                   ( x .ih ( T ` y ) ) = ( ( T ` x ) .ih y ) ) ) $=
      cT cho wcel cT cvv wcel chil chil cT wf vx cv vy cv cT cfv csp co vx cv
      cT cfv vy cv csp co wceq vy chil wral vx chil wral wa cT cho elisset chil
      chil cT wf cT cvv wcel vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp
      co wceq vy chil wral vx chil wral chil chil cT wf chil cvv wcel cT cvv
      wcel ax-hilex chil chil cvv cT fex mpan2 adantr chil chil vt cv wf vx cv
      vy cv vt cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx
      chil wral wa chil chil cT wf vx cv vy cv cT cfv csp co vx cv cT cfv vy cv
      csp co wceq vy chil wral vx chil wral wa vt cT cho cvv vt cv cT wceq chil
      chil vt cv wf chil chil cT wf vx cv vy cv vt cv cfv csp co vx cv vt cv
      cfv vy cv csp co wceq vy chil wral vx chil wral vx cv vy cv cT cfv csp co
      vx cv cT cfv vy cv csp co wceq vy chil wral vx chil wral chil chil vt cv
      cT feq1 vt cv cT wceq vx cv vy cv vt cv cfv csp co vx cv vt cv cfv vy cv
      csp co wceq vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp co wceq vx
      vy chil chil vt cv cT wceq vx cv vy cv vt cv cfv csp co vx cv vy cv cT
      cfv csp co vx cv vt cv cfv vy cv csp co vx cv cT cfv vy cv csp co vt cv
      cT wceq vy cv vt cv cfv vy cv cT cfv vx cv csp vy cv vt cv cT fveq1
      opreq2d vt cv cT wceq vx cv vt cv cfv vx cv cT cfv vy cv csp vx cv vt cv
      cT fveq1 opreq1d eqeq12d 2ralbidv anbi12d vx vy vt df-hmop elab2g
      pm5.21nii $.
      $( [23-May-2006] $) $( [18-Jan-2006] $)

    $( A Hermitian operator is a Hilbert space operator (mapping). $)
    hmopf $p |- ( T e. HrmOp -> T : ~H --> ~H ) $=
      cT cho wcel chil chil cT wf vx cv vy cv cT cfv csp co vx cv cT cfv vy cv
      csp co wceq vy chil wral vx chil wral vx vy cT elhmop pm3.26bi $.
      $( [26-May-2006] $) $( [19-Mar-2006] $)

    $( The class of Hermitian operators is a set. $)
    hmopex $p |- HrmOp e. _V $=
      cho chil chil cm co chil chil cm oprex vt cho chil chil cm co vt cv cho
      wcel chil chil vt cv wf vt cv chil chil cm co wcel vt cv hmopf chil chil
      vt cv ax-hilex ax-hilex elmap sylibr ssriv ssexi $.
      $( [19-Aug-2006] $) $( [17-Aug-2006] $)

    $( Value of the norm of a Hilbert space functional. $)
    nmfnval $p |- ( T : ~H --> CC -> ( normfn ` T ) = sup ( { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( abs ` ( T ` y ) ) ) } , RR* , < ) ) $=
      vt vz cT vy cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cabs cfv wceq wa
      vy chil wrex vx cab cxr clt csup vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup chil cc cnmf cxr vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx
      cab clt xrltso supex ax-hilex axcnex vt cv cT wceq vy cv cno cfv c1 cle
      wbr vx cv vy cv vt cv cfv cabs cfv wceq wa vy chil wrex vx cab vy cv cno
      cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab
      wceq vy cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cabs cfv wceq wa vy
      chil wrex vx cab cxr clt csup vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cabs cfv wceq wa vy chil wrex vx cab cxr clt csup wceq vt cv cT wceq vy
      cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cabs cfv wceq wa vy chil wrex
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex
      vx vt cv cT wceq vy cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cabs cfv
      wceq wa vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy
      chil vt cv cT wceq vx cv vy cv vt cv cfv cabs cfv wceq vx cv vy cv cT cfv
      cabs cfv wceq vy cv cno cfv c1 cle wbr vt cv cT wceq vy cv vt cv cfv cabs
      cfv vy cv cT cfv cabs cfv vx cv vt cv cT wceq vy cv vt cv cfv vy cv cT
      cfv cabs vy cv vt cv cT fveq1 fveq2d eqeq2d anbi2d rexbidv abbidv cxr vy
      cv cno cfv c1 cle wbr vx cv vy cv vt cv cfv cabs cfv wceq wa vy chil wrex
      vx cab vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy
      chil wrex vx cab clt supeq1 syl vx vz vy vt df-nmfn fvopabf4 $.
      $( [6-Mar-2006] $) $( [11-Feb-2006] $)

    $( The set in the supremum of the functional norm definition ~ df-nmfn is a
       set of reals. $)
    nmfnsetre $p |- ( T : ~H --> CC -> { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( abs ` ( T ` y ) ) ) } C_ RR ) $=
      chil cc cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq
      wa vy chil wrex vx cr chil cc cT wf vy cv cno cfv c1 cle wbr vx cv vy cv
      cT cfv cabs cfv wceq wa vx cv cr wcel vy chil chil cc cT wf vy cv chil
      wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vx cv
      cr wcel chil cc cT wf vy cv chil wcel wa vx cv vy cv cT cfv cabs cfv wceq
      vx cv cr wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq
      chil cc cT wf vy cv chil wcel wa vx cv cr wcel vx cv vy cv cT cfv cabs
      cfv wceq vx cv cr wcel vy cv cT cfv cabs cfv cr wcel chil cc cT wf vy cv
      chil wcel wa vx cv vy cv cT cfv cabs cfv cr eleq1 chil cc cT wf vy cv
      chil wcel wa vy cv cT cfv cc wcel vy cv cT cfv cabs cfv cr wcel chil cc
      vy cv cT ffvelrn vy cv cT cfv abscl syl syl5bir impcom adantrl exp31
      r19.23adv abssdv $.
      $( [11-Mar-2006] $) $( [14-Feb-2006] $)

    $( The set in the supremum of the functional norm definition ~ df-nmfn is
       nonempty. $)
    nmfnsetn0 $p |- ( abs ` ( T ` 0h ) ) e.
      { x | E. y e. ~H ( ( normh ` y ) <_ 1 /\ x = ( abs ` ( T ` y ) ) ) } $=
      c0v cT cfv cabs cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv
      wceq wa vy chil wrex vx cab wcel vy cv cno cfv c1 cle wbr c0v cT cfv cabs
      cfv vy cv cT cfv cabs cfv wceq wa vy chil wrex c0v chil wcel c0v cno cfv
      c1 cle wbr c0v cT cfv cabs cfv c0v cT cfv cabs cfv wceq wa vy cv cno cfv
      c1 cle wbr c0v cT cfv cabs cfv vy cv cT cfv cabs cfv wceq wa vy chil wrex
      ax-hv0cl c0v cno cfv c1 cle wbr c0v cT cfv cabs cfv c0v cT cfv cabs cfv
      wceq c0v cno cfv cc0 c1 cle norm0 cc0 c1 0re 1re lt01 ltleii eqbrtri c0v
      cT cfv cabs cfv eqid pm3.2i vy cv cno cfv c1 cle wbr c0v cT cfv cabs cfv
      vy cv cT cfv cabs cfv wceq wa c0v cno cfv c1 cle wbr c0v cT cfv cabs cfv
      c0v cT cfv cabs cfv wceq wa vy c0v chil vy cv c0v wceq vy cv cno cfv c1
      cle wbr c0v cno cfv c1 cle wbr c0v cT cfv cabs cfv vy cv cT cfv cabs cfv
      wceq c0v cT cfv cabs cfv c0v cT cfv cabs cfv wceq vy cv c0v wceq vy cv
      cno cfv c0v cno cfv c1 cle vy cv c0v cno fveq2 breq1d vy cv c0v wceq vy
      cv cT cfv cabs cfv c0v cT cfv cabs cfv c0v cT cfv cabs cfv vy cv c0v wceq
      vy cv cT cfv c0v cT cfv cabs vy cv c0v cT fveq2 fveq2d eqeq2d anbi12d
      rcla4ev mp2an vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq
      wa vy chil wrex vy cv cno cfv c1 cle wbr c0v cT cfv cabs cfv vy cv cT cfv
      cabs cfv wceq wa vy chil wrex vx c0v cT cfv cabs cfv c0v cT cfv cabs fvex
      vx cv c0v cT cfv cabs cfv wceq vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cabs cfv wceq wa vy cv cno cfv c1 cle wbr c0v cT cfv cabs cfv vy cv
      cT cfv cabs cfv wceq wa vy chil vx cv c0v cT cfv cabs cfv wceq vx cv vy
      cv cT cfv cabs cfv wceq c0v cT cfv cabs cfv vy cv cT cfv cabs cfv wceq vy
      cv cno cfv c1 cle wbr vx cv c0v cT cfv cabs cfv vy cv cT cfv cabs cfv
      eqeq1 anbi2d rexbidv elab mpbir $.
      $( [7-Mar-2006] $) $( [14-Feb-2006] $)

    $( The norm of any Hilbert space functional is an extended real. $)
    nmfnxr $p |- ( T : ~H --> CC -> ( normfn ` T ) e. RR* ) $=
      chil cc cT wf cT cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cxr vx vy cT nmfnval
      chil cc cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq
      wa vy chil wrex vx cab cxr wss vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cxr wcel chil cc cT
      wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil
      wrex vx cab cr cxr vx vy cT nmfnsetre cr cxr wss chil cc cT wf ressxr a1i
      sstrd vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy
      chil wrex vx cab supxrcl syl eqeltrd $.
      $( [25-Feb-2006] $) $( [9-Feb-2006] $)

    $( The norm of a Hilbert space functional is either real or plus
       infinity. $)
    nmfnrepnf $p |- ( T : ~H --> CC ->
                   ( ( normfn ` T ) e. RR <-> ( normfn ` T ) =/= +oo ) ) $=
      chil cc cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq
      wa vy chil wrex vx cab cxr clt csup cr wcel vy cv cno cfv c1 cle wbr vx
      cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cpnf
      wne cT cnmf cfv cr wcel cT cnmf cfv cpnf wne chil cc cT wf vy cv cno cfv
      c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab cr wss
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex
      vx cab cxr clt csup cr wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cpnf wne wb vx vy cT
      nmfnsetre vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy
      chil wrex vx cab cr wss vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs
      cfv wceq wa vy chil wrex vx cab c0 wne vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cr wcel vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx
      cab cxr clt csup cpnf wne wb c0v cT cfv cabs cfv vy cv cno cfv c1 cle wbr
      vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab wcel vy cv cno
      cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab c0
      wne vx vy cT nmfnsetn0 vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs
      cfv wceq wa vy chil wrex vx cab c0v cT cfv cabs cfv ne0i ax-mp vy cv cno
      cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab
      supxrre2 mpan2 syl chil cc cT wf cT cnmf cfv vy cv cno cfv c1 cle wbr vx
      cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cr vx
      vy cT nmfnval eleq1d chil cc cT wf cT cnmf cfv cpnf vy cv cno cfv c1 cle
      wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup
      cpnf chil cc cT wf cT cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cpnf vx vy cT
      nmfnval eqeq1d necon3bid 3bitr4d $.
      $( [9-Dec-2007] $) $( [8-Dec-2007] $)

    $( Value of the null space of a Hilbert space functional. $)
    nlfnval $p |- ( T : ~H --> CC ->
                   ( null ` T ) = { x e. ~H | ( T ` x ) = 0 } ) $=
      vt vy cT vx cv vt cv cfv cc0 wceq vx chil crab vx cv cT cfv cc0 wceq vx
      chil crab chil cc cnl vx cv cT cfv cc0 wceq vx chil ax-hilex rabex
      ax-hilex axcnex vt cv cT wceq vx cv vt cv cfv cc0 wceq vx cv cT cfv cc0
      wceq vx chil vt cv cT wceq vx cv vt cv cfv vx cv cT cfv cc0 vx cv vt cv
      cT fveq1 eqeq1d rabbisdv vx vy vt df-nlfn fvopabf4 $.
      $( [6-Apr-2006] $) $( [11-Feb-2006] $)

    $( Property defining a continuous functional. $)
    elcnfn $p |- ( T e. ConFn <-> ( T :  ~H --> CC /\ A. x e. ~H A. y e. RR (
      0 < y -> E. z e. RR ( 0 < z /\ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
      ( abs ` ( ( T ` w ) - ( T ` x ) ) ) < y ) ) ) ) ) $=
      cT ccnf wcel cT cvv wcel chil cc cT wf cc0 vy cv clt wbr cc0 vz cv clt
      wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv
      cmin co cabs cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vy cr
      wral vx chil wral wa cT ccnf elisset chil cc cT wf cT cvv wcel cc0 vy cv
      clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv
      cT cfv vx cv cT cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral wa vz
      cr wrex wi vy cr wral vx chil wral chil cc cT wf chil cvv wcel cT cvv
      wcel ax-hilex chil cc cvv cT fex mpan2 adantr chil cc vt cv wf cc0 vy cv
      clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv
      vt cv cfv vx cv vt cv cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral
      wa vz cr wrex wi vy cr wral vx chil wral wa chil cc cT wf cc0 vy cv clt
      wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT
      cfv vx cv cT cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral wa vz cr
      wrex wi vy cr wral vx chil wral wa vt cT ccnf cvv vt cv cT wceq chil cc
      vt cv wf chil cc cT wf cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv
      cmv co cno cfv vz cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmin co cabs
      cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vy cr wral vx chil
      wral cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv
      clt wbr vw cv cT cfv vx cv cT cfv cmin co cabs cfv vy cv clt wbr wi vw
      chil wral wa vz cr wrex wi vy cr wral vx chil wral chil cc vt cv cT feq1
      vt cv cT wceq cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno
      cfv vz cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmin co cabs cfv vy cv
      clt wbr wi vw chil wral wa vz cr wrex wi cc0 vy cv clt wbr cc0 vz cv clt
      wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv
      cmin co cabs cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vx vy
      chil cr vt cv cT wceq cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv
      clt wbr vw cv vt cv cfv vx cv vt cv cfv cmin co cabs cfv vy cv clt wbr wi
      vw chil wral wa vz cr wrex cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv
      vz cv clt wbr vw cv cT cfv vx cv cT cfv cmin co cabs cfv vy cv clt wbr wi
      vw chil wral wa vz cr wrex cc0 vy cv clt wbr vt cv cT wceq cc0 vz cv clt
      wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv vt cv cfv vx cv vt cv
      cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral wa cc0 vz cv clt wbr
      vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv cmin
      co cabs cfv vy cv clt wbr wi vw chil wral wa vz cr vt cv cT wceq vw cv vx
      cv cmv co cno cfv vz cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmin co
      cabs cfv vy cv clt wbr wi vw chil wral vw cv vx cv cmv co cno cfv vz cv
      clt wbr vw cv cT cfv vx cv cT cfv cmin co cabs cfv vy cv clt wbr wi vw
      chil wral cc0 vz cv clt wbr vt cv cT wceq vw cv vx cv cmv co cno cfv vz
      cv clt wbr vw cv vt cv cfv vx cv vt cv cfv cmin co cabs cfv vy cv clt wbr
      wi vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cT cfv vx cv cT cfv
      cmin co cabs cfv vy cv clt wbr wi vw chil vt cv cT wceq vw cv vt cv cfv
      vx cv vt cv cfv cmin co cabs cfv vy cv clt wbr vw cv cT cfv vx cv cT cfv
      cmin co cabs cfv vy cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr
      vt cv cT wceq vw cv vt cv cfv vx cv vt cv cfv cmin co cabs cfv vw cv cT
      cfv vx cv cT cfv cmin co cabs cfv vy cv clt vt cv cT wceq vw cv vt cv cfv
      vx cv vt cv cfv cmin co vw cv cT cfv vx cv cT cfv cmin co cabs vt cv cT
      wceq vw cv vt cv cfv vw cv cT cfv vx cv vt cv cfv vx cv cT cfv cmin vw cv
      vt cv cT fveq1 vx cv vt cv cT fveq1 opreq12d fveq2d breq1d imbi2d ralbidv
      anbi2d rexbidv imbi2d 2ralbidv anbi12d vx vy vz vw vt df-cnfn elab2g
      pm5.21nii $.
      $( [2-Apr-2006] $) $( [11-Feb-2006] $)

    $( Property defining a linear functional. $)
    ellnfn $p |- ( T e. LinFn <-> ( T : ~H --> CC /\
        A. x e. CC A. y e. ~H A. z e. ~H
       ( T ` ( ( x .h y ) +h z ) ) = ( ( x x. ( T ` y ) ) + ( T ` z ) ) ) ) $=
      cT clf wcel cT cvv wcel chil cc cT wf vx cv vy cv csm co vz cv cva co cT
      cfv vx cv vy cv cT cfv cmul co vz cv cT cfv caddc co wceq vz chil wral vy
      chil wral vx cc wral wa cT clf elisset chil cc cT wf cT cvv wcel vx cv vy
      cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv
      caddc co wceq vz chil wral vy chil wral vx cc wral chil cc cT wf chil cvv
      wcel cT cvv wcel ax-hilex chil cc cvv cT fex mpan2 adantr chil cc vt cv
      wf vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv cmul
      co vz cv vt cv cfv caddc co wceq vz chil wral vy chil wral vx cc wral wa
      chil cc cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv
      cmul co vz cv cT cfv caddc co wceq vz chil wral vy chil wral vx cc wral
      wa vt cT clf cvv vt cv cT wceq chil cc vt cv wf chil cc cT wf vx cv vy cv
      csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv cmul co vz cv vt cv
      cfv caddc co wceq vz chil wral vy chil wral vx cc wral vx cv vy cv csm co
      vz cv cva co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv caddc co wceq
      vz chil wral vy chil wral vx cc wral chil cc vt cv cT feq1 vt cv cT wceq
      vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv cmul co
      vz cv vt cv cfv caddc co wceq vz chil wral vx cv vy cv csm co vz cv cva
      co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv caddc co wceq vz chil
      wral vx vy cc chil vt cv cT wceq vx cv vy cv csm co vz cv cva co vt cv
      cfv vx cv vy cv vt cv cfv cmul co vz cv vt cv cfv caddc co wceq vx cv vy
      cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv
      caddc co wceq vz chil vt cv cT wceq vx cv vy cv csm co vz cv cva co vt cv
      cfv vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv vt cv cfv cmul co
      vz cv vt cv cfv caddc co vx cv vy cv cT cfv cmul co vz cv cT cfv caddc co
      vx cv vy cv csm co vz cv cva co vt cv cT fveq1 vt cv cT wceq vx cv vy cv
      vt cv cfv cmul co vx cv vy cv cT cfv cmul co vz cv vt cv cfv vz cv cT cfv
      caddc vt cv cT wceq vy cv vt cv cfv vy cv cT cfv vx cv cmul vy cv vt cv
      cT fveq1 opreq2d vz cv vt cv cT fveq1 opreq12d eqeq12d ralbidv 2ralbidv
      anbi12d vx vy vz vt df-lnfn elab2g pm5.21nii $.
      $( [8-Apr-2006] $) $( [11-Feb-2006] $)

    $( A linear Hilbert space functional is a functional. $)
    lnfnf $p |- ( T e. LinFn -> T : ~H --> CC ) $=
      cT clf wcel chil cc cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv vy
      cv cT cfv cmul co vz cv cT cfv caddc co wceq vz chil wral vy chil wral vx
      cc wral vx vy vz cT ellnfn pm3.26bi $.
      $( [26-Apr-2006] $) $( [25-Apr-2006] $)

    $( Alternate definition of the adjoint of a Hilbert space operator. $)
    dfadj2 $p |- adjh = { <. t , u >. | ( t : ~H --> ~H /\ u : ~H --> ~H /\
         A. x e. ~H A. y e. ~H ( x .ih ( t ` y ) ) = ( ( u ` x ) .ih y ) ) } $=
      cado chil chil vt cv wf chil chil vu cv wf vx cv vt cv cfv vy cv csp co
      vx cv vy cv vu cv cfv csp co wceq vy chil wral vx chil wral w3a vt vu
      copab chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co
      vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt vu
      copab vx vy vu vt df-adjh chil chil vt cv wf chil chil vu cv wf vx cv vt
      cv cfv vy cv csp co vx cv vy cv vu cv cfv csp co wceq vy chil wral vx
      chil wral w3a chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv
      csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt
      vu chil chil vt cv wf chil chil vu cv wf wa vx cv vt cv cfv vy cv csp co
      vx cv vy cv vu cv cfv csp co wceq vy chil wral vx chil wral wa chil chil
      vt cv wf chil chil vu cv wf wa vx cv vy cv vt cv cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral wa chil chil vt cv wf
      chil chil vu cv wf vx cv vt cv cfv vy cv csp co vx cv vy cv vu cv cfv csp
      co wceq vy chil wral vx chil wral w3a chil chil vt cv wf chil chil vu cv
      wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil
      wral vx chil wral w3a chil chil vt cv wf chil chil vu cv wf wa vx cv vt
      cv cfv vy cv csp co vx cv vy cv vu cv cfv csp co wceq vy chil wral vx
      chil wral vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq
      vy chil wral vx chil wral chil chil vt cv wf chil chil vu cv wf wa vx cv
      vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx
      chil wral vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv csp co wceq
      vy chil wral vx chil wral vx cv vt cv cfv vy cv csp co vx cv vy cv vu cv
      cfv csp co wceq vy chil wral vx chil wral vx vy vt cv vu cv adjsym vx cv
      vt cv cfv vy cv csp co vx cv vy cv vu cv cfv csp co wceq vx cv vy cv vu
      cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vx vy chil chil vx cv vt
      cv cfv vy cv csp co vx cv vy cv vu cv cfv csp co eqcom 2ralbii syl6rbbr
      pm5.32i chil chil vt cv wf chil chil vu cv wf vx cv vt cv cfv vy cv csp
      co vx cv vy cv vu cv cfv csp co wceq vy chil wral vx chil wral df-3an
      chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv
      vu cv cfv vy cv csp co wceq vy chil wral vx chil wral df-3an 3bitr4i
      opabbii eqtri $.
      $( [27-Feb-2006] $) $( [20-Feb-2006] $)

    $( Functionality of the adjoint function. $)
    funadj $p |- Fun adjh $=
      cado wfun chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp
      co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt vu
      copab wfun chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv
      csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt
      vu copab wfun chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv
      csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vu
      wmo vt chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co
      vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt vu
      funopab chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv
      vy cv csp co wceq vy chil wral vx chil wral wa vu wmo chil chil vt cv wf
      chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp
      co wceq vy chil wral vx chil wral w3a vu wmo vx vy vu vt cv adjmo chil
      chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral w3a chil chil vu cv wf vx
      cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral
      vx chil wral wa vu chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt
      cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral
      3simpc immoi ax-mp mpgbir cado chil chil vt cv wf chil chil vu cv wf vx
      cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral
      vx chil wral w3a vt vu copab wceq cado wfun chil chil vt cv wf chil chil
      vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq
      vy chil wral vx chil wral w3a vt vu copab wfun wb vx vy vu vt dfadj2 cado
      chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv
      vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt vu copab
      funeq ax-mp mpbir $.
      $( [27-Feb-2006] $) $( [15-Feb-2006] $)

    $( Value of the adjoint function.  By ~ adjmo and ~ euuni , the union
       should be read "the unique ` u ` such that..." for ` T ` in the domain
       of ` adjh ` . $)
    adjval $p |- ( T : ~H --> ~H -> ( adjh ` T ) = U. { u | ( u : ~H --> ~H /\
       A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( u ` x ) .ih y ) ) } ) $=
      chil chil cT wf cT cado cfv chil chil cT wf chil chil vu cv wf vx cv vy
      cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil
      wral w3a vu cab cuni chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv
      vu cv cfv vy cv csp co wceq vy chil wral vx chil wral wa vu cab cuni chil
      chil cT wf cT cvv wcel cT cado cfv chil chil cT wf chil chil vu cv wf vx
      cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx
      chil wral w3a vu cab cuni wceq chil chil cT wf chil cvv wcel cT cvv wcel
      ax-hilex chil chil cvv cT fex mpan2 cado wfun cT cvv wcel cT cado cfv
      chil chil cT wf chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral w3a vu cab cuni wceq
      funadj chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co
      vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a chil chil
      cT wf chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv
      csp co wceq vy chil wral vx chil wral w3a vt vu cT cvv cado vx vy vu vt
      dfadj2 vt cv cT wceq chil chil vt cv wf chil chil cT wf vx cv vy cv vt cv
      cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral vx
      cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx
      chil wral chil chil vu cv wf chil chil vt cv cT feq1 vt cv cT wceq vx cv
      vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vx cv vy cv cT
      cfv csp co vx cv vu cv cfv vy cv csp co wceq vx vy chil chil vt cv cT
      wceq vx cv vy cv vt cv cfv csp co vx cv vy cv cT cfv csp co vx cv vu cv
      cfv vy cv csp co vt cv cT wceq vy cv vt cv cfv vy cv cT cfv vx cv csp vy
      cv vt cv cT fveq1 opreq2d eqeq1d 2ralbidv 3anbi13d fvopab5 mpan syl chil
      chil cT wf chil chil cT wf chil chil vu cv wf vx cv vy cv cT cfv csp co
      vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vu cab
      chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co
      wceq vy chil wral vx chil wral wa vu cab chil chil cT wf chil chil cT wf
      chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co
      wceq vy chil wral vx chil wral w3a chil chil vu cv wf vx cv vy cv cT cfv
      csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral wa vu
      chil chil cT wf chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral w3a chil chil cT wf chil
      chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq
      vy chil wral vx chil wral wa chil chil cT wf chil chil vu cv wf vx cv vy
      cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil
      wral 3anass baib abbidv unieqd eqtrd $.
      $( [2-Apr-2006] $) $( [19-Feb-2006] $)

    $( Value of the adjoint function. $)
    adjval2 $p |- ( T : ~H --> ~H -> ( adjh ` T ) = U. { u | ( u : ~H --> ~H
    /\ A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( u ` y ) ) ) } ) $=
      chil chil cT wf cT cado cfv chil chil vu cv wf vx cv vy cv cT cfv csp co
      vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral wa vu cab
      cuni chil chil vu cv wf vx cv cT cfv vy cv csp co vx cv vy cv vu cv cfv
      csp co wceq vy chil wral vx chil wral wa vu cab cuni vx vy vu cT adjval
      chil chil cT wf chil chil vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral wa vu cab chil chil vu cv
      wf vx cv cT cfv vy cv csp co vx cv vy cv vu cv cfv csp co wceq vy chil
      wral vx chil wral wa vu cab chil chil cT wf chil chil vu cv wf vx cv vy
      cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil
      wral wa chil chil vu cv wf vx cv cT cfv vy cv csp co vx cv vy cv vu cv
      cfv csp co wceq vy chil wral vx chil wral wa vu chil chil cT wf chil chil
      vu cv wf vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy
      chil wral vx chil wral vx cv cT cfv vy cv csp co vx cv vy cv vu cv cfv
      csp co wceq vy chil wral vx chil wral chil chil cT wf chil chil vu cv wf
      wa vx cv vy cv cT cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil
      wral vx chil wral vx cv vy cv vu cv cfv csp co vx cv cT cfv vy cv csp co
      wceq vy chil wral vx chil wral vx cv cT cfv vy cv csp co vx cv vy cv vu
      cv cfv csp co wceq vy chil wral vx chil wral vx vy cT vu cv adjsym vx cv
      vy cv vu cv cfv csp co vx cv cT cfv vy cv csp co wceq vx cv cT cfv vy cv
      csp co vx cv vy cv vu cv cfv csp co wceq vx vy chil chil vx cv vy cv vu
      cv cfv csp co vx cv cT cfv vy cv csp co eqcom 2ralbii syl6bb pm5.32da
      abbidv unieqd eqtrd $.
      $( [7-Apr-2006] $) $( [19-Feb-2006] $)

    $( The adjoint function equals its converse. $)
    cnvadj $p |- `' adjh = adjh $=
      chil chil vu cv wf chil chil vt cv wf vx cv vy cv vu cv cfv csp co vx cv
      vt cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vu vt copab
      ccnv chil chil vt cv wf chil chil vu cv wf vy cv vx cv vt cv cfv csp co
      vy cv vu cv cfv vx cv csp co wceq vx chil wral vy chil wral w3a vt vu
      copab cado ccnv cado chil chil vu cv wf chil chil vt cv wf vx cv vy cv vu
      cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral
      w3a vu vt copab ccnv chil chil vu cv wf chil chil vt cv wf vx cv vy cv vu
      cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral
      w3a vt vu copab chil chil vt cv wf chil chil vu cv wf vy cv vx cv vt cv
      cfv csp co vy cv vu cv cfv vx cv csp co wceq vx chil wral vy chil wral
      w3a vt vu copab chil chil vu cv wf chil chil vt cv wf vx cv vy cv vu cv
      cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral
      w3a vu vt cnvopab chil chil vu cv wf chil chil vt cv wf vx cv vy cv vu cv
      cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral
      w3a chil chil vt cv wf chil chil vu cv wf vy cv vx cv vt cv cfv csp co vy
      cv vu cv cfv vx cv csp co wceq vx chil wral vy chil wral w3a vt vu chil
      chil vu cv wf chil chil vt cv wf vx cv vy cv vu cv cfv csp co vx cv vt cv
      cfv vy cv csp co wceq vy chil wral vx chil wral w3a chil chil vt cv wf
      chil chil vu cv wf vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv csp
      co wceq vy chil wral vx chil wral w3a chil chil vt cv wf chil chil vu cv
      wf vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp co wceq vx chil
      wral vy chil wral w3a chil chil vu cv wf chil chil vt cv wf vx cv vy cv
      vu cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil
      wral 3ancoma chil chil vt cv wf chil chil vu cv wf wa vx cv vy cv vu cv
      cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral wa
      chil chil vt cv wf chil chil vu cv wf wa vy cv vx cv vt cv cfv csp co vy
      cv vu cv cfv vx cv csp co wceq vx chil wral vy chil wral wa chil chil vt
      cv wf chil chil vu cv wf vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy
      cv csp co wceq vy chil wral vx chil wral w3a chil chil vt cv wf chil chil
      vu cv wf vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp co wceq
      vx chil wral vy chil wral w3a chil chil vt cv wf chil chil vu cv wf wa vx
      cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral
      vx chil wral vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp co
      wceq vx chil wral vy chil wral chil chil vt cv wf chil chil vu cv wf wa
      vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil
      wral vx chil wral vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp
      co wceq vy chil wral vx chil wral vy cv vx cv vt cv cfv csp co vy cv vu
      cv cfv vx cv csp co wceq vx chil wral vy chil wral chil chil vt cv wf
      chil chil vu cv wf wa vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv
      csp co wceq vy chil wral vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx
      cv csp co wceq vy chil wral vx chil chil chil vt cv wf chil chil vu cv wf
      wa vx cv chil wcel wa vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv
      csp co wceq vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp co
      wceq vy chil chil chil vt cv wf chil chil vu cv wf wa vx cv chil wcel wa
      vy cv chil wcel wa vx cv vy cv vu cv cfv csp co vx cv vt cv cfv vy cv csp
      co wceq vy cv vu cv cfv vx cv csp co vy cv vx cv vt cv cfv csp co wceq vy
      cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp co wceq chil chil vt
      cv wf chil chil vu cv wf wa vx cv chil wcel vy cv chil wcel vx cv vy cv
      vu cv cfv csp co vx cv vt cv cfv vy cv csp co wceq vy cv vu cv cfv vx cv
      csp co vy cv vx cv vt cv cfv csp co wceq wb chil chil vt cv wf vx cv chil
      wcel chil chil vu cv wf vy cv chil wcel vx cv vy cv vu cv cfv csp co vx
      cv vt cv cfv vy cv csp co wceq vy cv vu cv cfv vx cv csp co vy cv vx cv
      vt cv cfv csp co wceq wb chil chil vt cv wf vx cv chil wcel wa chil chil
      vu cv wf vy cv chil wcel wa wa vy cv vu cv cfv vx cv csp co vy cv vx cv
      vt cv cfv csp co wceq vx cv vy cv vu cv cfv csp co ccj cfv vx cv vt cv
      cfv vy cv csp co ccj cfv wceq vx cv vy cv vu cv cfv csp co vx cv vt cv
      cfv vy cv csp co wceq chil chil vu cv wf vy cv chil wcel wa chil chil vt
      cv wf vx cv chil wcel wa vy cv vu cv cfv vx cv csp co vy cv vx cv vt cv
      cfv csp co wceq vx cv vy cv vu cv cfv csp co ccj cfv vx cv vt cv cfv vy
      cv csp co ccj cfv wceq wb chil chil vu cv wf vy cv chil wcel wa chil chil
      vt cv wf vx cv chil wcel wa wa vy cv vu cv cfv vx cv csp co vx cv vy cv
      vu cv cfv csp co ccj cfv vy cv vx cv vt cv cfv csp co vx cv vt cv cfv vy
      cv csp co ccj cfv chil chil vu cv wf vy cv chil wcel wa vx cv chil wcel
      vy cv vu cv cfv vx cv csp co vx cv vy cv vu cv cfv csp co ccj cfv wceq
      chil chil vt cv wf vy cv vu cv cfv chil wcel vx cv chil wcel vy cv vu cv
      cfv vx cv csp co vx cv vy cv vu cv cfv csp co ccj cfv wceq chil chil vu
      cv wf vy cv chil wcel wa vy cv vu cv cfv vx cv ax-his1 chil chil vy cv vu
      cv ffvelrn sylan adantrl vy cv chil wcel chil chil vt cv wf vx cv chil
      wcel wa vy cv vx cv vt cv cfv csp co vx cv vt cv cfv vy cv csp co ccj cfv
      wceq chil chil vu cv wf vy cv chil wcel vx cv vt cv cfv chil wcel vy cv
      vx cv vt cv cfv csp co vx cv vt cv cfv vy cv csp co ccj cfv wceq chil
      chil vt cv wf vx cv chil wcel wa vy cv vx cv vt cv cfv ax-his1 chil chil
      vx cv vt cv ffvelrn sylan2 adantll eqeq12d ancoms vx cv vy cv vu cv cfv
      csp co cc wcel vx cv vt cv cfv vy cv csp co cc wcel vx cv vy cv vu cv cfv
      csp co ccj cfv vx cv vt cv cfv vy cv csp co ccj cfv wceq vx cv vy cv vu
      cv cfv csp co vx cv vt cv cfv vy cv csp co wceq wb chil chil vt cv wf vx
      cv chil wcel wa chil chil vu cv wf vy cv chil wcel wa wa vx cv vy cv vu
      cv cfv csp co vx cv vt cv cfv vy cv csp co cj11 vx cv chil wcel chil chil
      vu cv wf vy cv chil wcel wa vx cv vy cv vu cv cfv csp co cc wcel chil
      chil vt cv wf vx cv chil wcel vy cv vu cv cfv chil wcel vx cv vy cv vu cv
      cfv csp co cc wcel chil chil vu cv wf vy cv chil wcel wa vx cv vy cv vu
      cv cfv hicl chil chil vy cv vu cv ffvelrn sylan2 adantll chil chil vt cv
      wf vx cv chil wcel wa vy cv chil wcel vx cv vt cv cfv vy cv csp co cc
      wcel chil chil vu cv wf vx cv vt cv cfv chil wcel vy cv chil wcel vx cv
      vt cv cfv vy cv csp co cc wcel chil chil vt cv wf vx cv chil wcel wa vx
      cv vt cv cfv vy cv hicl chil chil vx cv vt cv ffvelrn sylan adantrl
      sylanc bitr2d an4s anassrs vy cv vu cv cfv vx cv csp co vy cv vx cv vt cv
      cfv csp co eqcom syl6bb ralbidva ralbidva vy cv vx cv vt cv cfv csp co vy
      cv vu cv cfv vx cv csp co wceq vx vy chil chil ralcom syl6bb pm5.32i chil
      chil vt cv wf chil chil vu cv wf vx cv vy cv vu cv cfv csp co vx cv vt cv
      cfv vy cv csp co wceq vy chil wral vx chil wral df-3an chil chil vt cv wf
      chil chil vu cv wf vy cv vx cv vt cv cfv csp co vy cv vu cv cfv vx cv csp
      co wceq vx chil wral vy chil wral df-3an 3bitr4i bitri opabbii eqtri cado
      chil chil vu cv wf chil chil vt cv wf vx cv vy cv vu cv cfv csp co vx cv
      vt cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vu vt copab vx
      vy vt vu dfadj2 cnveqi vy vx vu vt dfadj2 3eqtr4i $.
      $( [20-May-2006] $) $( [15-Feb-2006] $)

    $( The converse of the adjoint function is a function. $)
    funcnvadj $p |- Fun `' adjh $=
      cado ccnv wfun cado wfun funadj cado ccnv cado wceq cado ccnv wfun cado
      wfun wb cnvadj cado ccnv cado funeq ax-mp mpbir $.
      $( [23-May-2006] $) $( [25-Jan-2006] $)

    $( The adjoint function maps one-to-one onto its domain. $)
    adj1o $p |- adjh : dom adjh -1-1-onto-> dom adjh $=
      cado cdm cado cdm cado wf1o cado cado cdm wfn cado ccnv wfun cado crn
      cado cdm wceq w3a cado cado cdm wfn cado ccnv wfun cado crn cado cdm wceq
      cado wfun cado cado cdm wfn funadj cado funfn mpbi funcnvadj cado crn
      cado ccnv cdm cado cdm cado df-rn cado ccnv cado cnvadj dmeqi eqtri
      3pm3.2i cado cdm cado cdm cado dff1o2 mpbir $.
      $( [26-May-2006] $) $( [15-Feb-2006] $)

    $( The domain of the adjoint function is a subset of the maps from ` ~H `
       to ` ~H ` . $)
    dmadjss $p |- dom adjh C_ ( ~H ^m ~H ) $=
      cado cdm vt cv chil chil cm co wcel chil chil vu cv wf vx cv vy cv vt cv
      cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral wa
      wa vt vu copab cdm chil chil cm co cado vt cv chil chil cm co wcel chil
      chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co
      wceq vy chil wral vx chil wral wa wa vt vu copab cado chil chil vt cv wf
      chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp
      co wceq vy chil wral vx chil wral w3a vt vu copab vt cv chil chil cm co
      wcel chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy
      cv csp co wceq vy chil wral vx chil wral wa wa vt vu copab vx vy vu vt
      dfadj2 chil chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co
      vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vt cv
      chil chil cm co wcel chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx
      cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral wa wa vt vu chil
      chil vt cv wf chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv
      cfv vy cv csp co wceq vy chil wral vx chil wral w3a chil chil vt cv wf
      chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp
      co wceq vy chil wral vx chil wral wa wa vt cv chil chil cm co wcel chil
      chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co
      wceq vy chil wral vx chil wral wa wa chil chil vt cv wf chil chil vu cv
      wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil
      wral vx chil wral 3anass vt cv chil chil cm co wcel chil chil vt cv wf
      chil chil vu cv wf vx cv vy cv vt cv cfv csp co vx cv vu cv cfv vy cv csp
      co wceq vy chil wral vx chil wral wa chil chil vt cv ax-hilex ax-hilex
      elmap anbi1i bitr4i opabbii eqtri dmeqi chil chil vu cv wf vx cv vy cv vt
      cv cfv csp co vx cv vu cv cfv vy cv csp co wceq vy chil wral vx chil wral
      wa vt vu chil chil cm co dmopabss eqsstri $.
      $( [27-May-2006] $) $( [15-Feb-2006] $)

    $( A member of the domain of the adjoint function is a Hilbert space
       operator. $)
    dmadjop $p |- ( T e. dom adjh -> T : ~H --> ~H ) $=
      cT cado cdm wcel cT chil chil cm co wcel chil chil cT wf cado cdm chil
      chil cm co cT dmadjss sseli chil chil cT ax-hilex ax-hilex elmap sylib $.
      $( [28-May-2006] $) $( [15-Feb-2006] $)

    $( The adjoint of an operator belongs to the adjoint function's domain. $)
    dmadjrn $p |- ( T e. dom adjh -> ( adjh ` T ) e. dom adjh ) $=
      cado cdm cado cdm cT cado cado cdm cado cdm cado wf1o cado cdm cado cdm
      cado wf adj1o cado cdm cado cdm cado f1of ax-mp ffvelrni $.
      $( [30-May-2006] $) $( [15-Feb-2006] $)

    $( The set of eigenvectors of a Hilbert space operator. $)
    eigvecval $p |- ( T : ~H --> ~H -> ( eigvec ` T ) =
           { x e. ~H | ( x =/= 0h /\ E. y e. CC ( T ` x ) = ( y .h x ) ) } ) $=
      vt vz cT vx cv c0v wne vx cv vt cv cfv vy cv vx cv csm co wceq vy cc wrex
      wa vx chil crab vx cv c0v wne vx cv cT cfv vy cv vx cv csm co wceq vy cc
      wrex wa vx chil crab chil chil cei vx cv c0v wne vx cv cT cfv vy cv vx cv
      csm co wceq vy cc wrex wa vx chil ax-hilex rabex ax-hilex ax-hilex vt cv
      cT wceq vx cv c0v wne vx cv vt cv cfv vy cv vx cv csm co wceq vy cc wrex
      wa vx cv c0v wne vx cv cT cfv vy cv vx cv csm co wceq vy cc wrex wa vx
      chil vt cv cT wceq vx cv vt cv cfv vy cv vx cv csm co wceq vy cc wrex vx
      cv cT cfv vy cv vx cv csm co wceq vy cc wrex vx cv c0v wne vt cv cT wceq
      vx cv vt cv cfv vy cv vx cv csm co wceq vx cv cT cfv vy cv vx cv csm co
      wceq vy cc vt cv cT wceq vx cv vt cv cfv vx cv cT cfv vy cv vx cv csm co
      vx cv vt cv cT fveq1 eqeq1d rexbidv anbi2d rabbisdv vx vz vy vt df-eigvec
      fvopabf4 $.
      $( [10-Apr-2006] $) $( [11-Mar-2006] $)

    $( The eigenvalues of eigenvectors of a Hilbert space operator. $)
    eigvalval $p |- ( T : ~H --> ~H -> ( eigval ` T ) =
             { <. x , y >. | ( x e. ( eigvec ` T ) /\
                   y = ( ( ( T ` x ) .ih x ) / ( ( normh ` x ) ^ 2 ) ) ) } ) $=
      vt vz cT vx cv vt cv cei cfv wcel vy cv vx cv vt cv cfv vx cv csp co vx
      cv cno cfv c2 cexp co cdiv co wceq wa vx vy copab vx cv cT cei cfv wcel
      vy cv vx cv cT cfv vx cv csp co vx cv cno cfv c2 cexp co cdiv co wceq wa
      vx vy copab chil chil cel vx vy cT cei cfv vx cv cT cfv vx cv csp co vx
      cv cno cfv c2 cexp co cdiv co cT cei fvex opabex2 ax-hilex ax-hilex vt cv
      cT wceq vx cv vt cv cei cfv wcel vy cv vx cv vt cv cfv vx cv csp co vx cv
      cno cfv c2 cexp co cdiv co wceq wa vx cv cT cei cfv wcel vy cv vx cv cT
      cfv vx cv csp co vx cv cno cfv c2 cexp co cdiv co wceq wa vx vy vt cv cT
      wceq vx cv vt cv cei cfv wcel vx cv cT cei cfv wcel vy cv vx cv vt cv cfv
      vx cv csp co vx cv cno cfv c2 cexp co cdiv co wceq vy cv vx cv cT cfv vx
      cv csp co vx cv cno cfv c2 cexp co cdiv co wceq vt cv cT wceq vt cv cei
      cfv cT cei cfv vx cv vt cv cT cei fveq2 eleq2d vt cv cT wceq vx cv vt cv
      cfv vx cv csp co vx cv cno cfv c2 cexp co cdiv co vx cv cT cfv vx cv csp
      co vx cv cno cfv c2 cexp co cdiv co vy cv vt cv cT wceq vx cv vt cv cfv
      vx cv csp co vx cv cT cfv vx cv csp co vx cv cno cfv c2 cexp co cdiv vt
      cv cT wceq vx cv vt cv cfv vx cv cT cfv vx cv csp vx cv vt cv cT fveq1
      opreq1d opreq1d eqeq2d anbi12d opabbidv vx vz vy vt df-eigval fvopabf4 $.
      $( [11-Apr-2006] $) $( [11-Mar-2006] $)

    $( The value of the spectrum of an operator. $)
    specval $p |- ( T : ~H --> ~H -> ( Lambda ` T ) = { x e. CC |
                   -. ( T -op ( x .op ( _I |` ~H ) ) ) : ~H -1-1-> ~H } ) $=
      vt vy cT chil chil vt cv vx cv cid chil cres chot co chod co wf1 wn vx cc
      crab chil chil cT vx cv cid chil cres chot co chod co wf1 wn vx cc crab
      chil chil cspc chil chil cT vx cv cid chil cres chot co chod co wf1 wn vx
      cc axcnex rabex ax-hilex ax-hilex vt cv cT wceq chil chil vt cv vx cv cid
      chil cres chot co chod co wf1 wn chil chil cT vx cv cid chil cres chot co
      chod co wf1 wn vx cc vt cv cT wceq chil chil vt cv vx cv cid chil cres
      chot co chod co wf1 chil chil cT vx cv cid chil cres chot co chod co wf1
      vt cv cT wceq vt cv vx cv cid chil cres chot co chod co cT vx cv cid chil
      cres chot co chod co wceq chil chil vt cv vx cv cid chil cres chot co
      chod co wf1 chil chil cT vx cv cid chil cres chot co chod co wf1 wb vt cv
      cT vx cv cid chil cres chot co chod opreq1 chil chil vt cv vx cv cid chil
      cres chot co chod co cT vx cv cid chil cres chot co chod co f1eq1 syl
      notbid rabbisdv vx vy vt df-spec fvopabf4 $.
      $( [20-May-2006] $) $( [11-Apr-2006] $)

    $( The spectrum of an operator is a set of complex numbers. $)
    speccl $p |- ( T : ~H --> ~H -> ( Lambda ` T ) C_ CC ) $=
      chil chil cT wf cT cspc cfv chil chil cT vx cv cid chil cres chot co chod
      co wf1 wn vx cc crab cc vx cT specval chil chil cT vx cv cid chil cres
      chot co chod co wf1 wn vx cc crab cc wss chil chil cT wf chil chil cT vx
      cv cid chil cres chot co chod co wf1 wn vx cc ssrab2 a1i eqsstrd $.
      $( [20-Oct-2006] $) $( [11-Apr-2006] $)
  $}

  ${
    $d t x y z $.
    hhlno.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhlno.2 $e |- L = ( U LnOp U ) $.
    $( The linear operators of Hilbert space. $)
    hhlnoi $p |- LinOp = L $=
      chil chil vt cv wf vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv
      vt cv cfv csm co vz cv vt cv cfv cva co wceq vz chil wral vy chil wral vx
      cc wral wa vt cab chil chil vt cv wf vz cv vx cv vy cv csm co cva co vt
      cv cfv vz cv vt cv cfv vx cv vy cv vt cv cfv csm co cva co wceq vy chil
      wral vx cc wral vz chil wral wa vt cab clo cL chil chil vt cv wf vx cv vy
      cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv csm co vz cv vt cv
      cfv cva co wceq vz chil wral vy chil wral vx cc wral wa chil chil vt cv
      wf vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv vx cv vy cv
      vt cv cfv csm co cva co wceq vy chil wral vx cc wral vz chil wral wa vt
      chil chil vt cv wf vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv
      vt cv cfv csm co vz cv vt cv cfv cva co wceq vz chil wral vy chil wral vx
      cc wral vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv vx cv
      vy cv vt cv cfv csm co cva co wceq vy chil wral vx cc wral vz chil wral
      chil chil vt cv wf vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv
      vt cv cfv csm co vz cv vt cv cfv cva co wceq vz chil wral vy chil wral vx
      cc wral vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv vx cv
      vy cv vt cv cfv csm co cva co wceq vy chil wral vz chil wral vx cc wral
      vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv vx cv vy cv vt
      cv cfv csm co cva co wceq vy chil wral vx cc wral vz chil wral chil chil
      vt cv wf vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv
      csm co vz cv vt cv cfv cva co wceq vz chil wral vy chil wral vz cv vx cv
      vy cv csm co cva co vt cv cfv vz cv vt cv cfv vx cv vy cv vt cv cfv csm
      co cva co wceq vy chil wral vz chil wral vx cc chil chil vt cv wf vx cv
      cc wcel wa vx cv vy cv csm co vz cv cva co vt cv cfv vx cv vy cv vt cv
      cfv csm co vz cv vt cv cfv cva co wceq vz chil wral vy chil wral vz cv vx
      cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv vx cv vy cv vt cv cfv
      csm co cva co wceq vz chil wral vy chil wral vz cv vx cv vy cv csm co cva
      co vt cv cfv vz cv vt cv cfv vx cv vy cv vt cv cfv csm co cva co wceq vy
      chil wral vz chil wral chil chil vt cv wf vx cv cc wcel wa vx cv vy cv
      csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv csm co vz cv vt cv
      cfv cva co wceq vz chil wral vz cv vx cv vy cv csm co cva co vt cv cfv vz
      cv vt cv cfv vx cv vy cv vt cv cfv csm co cva co wceq vz chil wral vy
      chil chil chil vt cv wf vx cv cc wcel wa vy cv chil wcel wa vx cv vy cv
      csm co vz cv cva co vt cv cfv vx cv vy cv vt cv cfv csm co vz cv vt cv
      cfv cva co wceq vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv
      vx cv vy cv vt cv cfv csm co cva co wceq vz chil chil chil vt cv wf vx cv
      cc wcel wa vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv csm co vz cv
      cva co vt cv cfv vz cv vx cv vy cv csm co cva co vt cv cfv vx cv vy cv vt
      cv cfv csm co vz cv vt cv cfv cva co vz cv vt cv cfv vx cv vy cv vt cv
      cfv csm co cva co vx cv cc wcel vy cv chil wcel vz cv chil wcel vx cv vy
      cv csm co vz cv cva co vt cv cfv vz cv vx cv vy cv csm co cva co vt cv
      cfv wceq chil chil vt cv wf vx cv cc wcel vy cv chil wcel wa vz cv chil
      wcel wa vx cv vy cv csm co vz cv cva co vz cv vx cv vy cv csm co cva co
      vt cv vx cv vy cv csm co chil wcel vz cv chil wcel vx cv vy cv csm co vz
      cv cva co vz cv vx cv vy cv csm co cva co wceq vx cv cc wcel vy cv chil
      wcel wa vx cv vy cv csm co vz cv ax-hvcom vx cv vy cv hvmulcl sylan
      fveq2d adantlll vx cv vy cv vt cv cfv csm co chil wcel vz cv vt cv cfv
      chil wcel vx cv vy cv vt cv cfv csm co vz cv vt cv cfv cva co vz cv vt cv
      cfv vx cv vy cv vt cv cfv csm co cva co wceq chil chil vt cv wf vx cv cc
      wcel wa vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv vt cv cfv csm
      co vz cv vt cv cfv ax-hvcom chil chil vt cv wf vx cv cc wcel wa vy cv
      chil wcel wa vx cv vy cv vt cv cfv csm co chil wcel vz cv chil wcel vx cv
      cc wcel vy cv vt cv cfv chil wcel vx cv vy cv vt cv cfv csm co chil wcel
      chil chil vt cv wf vx cv cc wcel wa vy cv chil wcel wa vx cv vy cv vt cv
      cfv hvmulcl chil chil vt cv wf vx cv cc wcel vy cv chil wcel simplr chil
      chil vt cv wf vy cv chil wcel vy cv vt cv cfv chil wcel vx cv cc wcel
      chil chil vy cv vt cv ffvelrn adantlr sylanc adantr chil chil vt cv wf vx
      cv cc wcel wa vz cv chil wcel vz cv vt cv cfv chil wcel vy cv chil wcel
      chil chil vt cv wf vz cv chil wcel vz cv vt cv cfv chil wcel vx cv cc
      wcel chil chil vz cv vt cv ffvelrn adantlr adantlr sylanc eqeq12d
      ralbidva ralbidva vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv
      cfv vx cv vy cv vt cv cfv csm co cva co wceq vy vz chil chil ralcom
      syl6bb ralbidva vz cv vx cv vy cv csm co cva co vt cv cfv vz cv vt cv cfv
      vx cv vy cv vt cv cfv csm co cva co wceq vy chil wral vx vz cc chil
      ralcom syl6bb pm5.32i abbii vx vy vz vt df-lnop cva csm cop cno cop cnv
      wcel cva csm cop cno cop cnv wcel cL chil chil vt cv wf vz cv vx cv vy cv
      csm co cva co vt cv cfv vz cv vt cv cfv vx cv vy cv vt cv cfv csm co cva
      co wceq vy chil wral vx cc wral vz chil wral wa vt cab wceq cva csm cop
      cno cop cva csm cop cno cop eqid hhnv cva csm cop cno cop cva csm cop cno
      cop eqid hhnv vz vx vy vt csm csm cva csm cop cno cop cva cva cL cva csm
      cop cno cop chil chil cva csm cop cno cop cva csm cop cno cop eqid hhba
      cva csm cop cno cop cva csm cop cno cop eqid hhba cva csm cop cno cop cva
      csm cop cno cop eqid hhva cva csm cop cno cop cva csm cop cno cop eqid
      hhva cva csm cop cno cop cva csm cop cno cop eqid hhsm cva csm cop cno
      cop cva csm cop cno cop eqid hhsm cL cU cU clno co cva csm cop cno cop
      cva csm cop cno cop clno co hhlno.2 cU cva csm cop cno cop cU cva csm cop
      cno cop clno hhlno.1 hhlno.1 opreq12i eqtri lnoval mp2an 3eqtr4i $.
      $( [7-Feb-2008] $) $( [19-Nov-2007] $)
  $}

  ${
    $d t x y z U $.
    hhnmo.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhnmo.2 $e |- N = ( U normOp U ) $.
    $( The norm of an operator in Hilbert space. $)
    hhnmoi $p |- normop = N $=
      cnop chil chil vt cv wf vy cv vz cv cno cfv c1 cle wbr vx cv vz cv vt cv
      cfv cno cfv wceq wa vz chil wrex vx cab cxr clt csup wceq wa vt vy copab
      cN vx vy vz vt df-nmop cU cnv wcel cU cnv wcel cN chil chil vt cv wf vy
      cv vz cv cno cfv c1 cle wbr vx cv vz cv vt cv cfv cno cfv wceq wa vz chil
      wrex vx cab cxr clt csup wceq wa vt vy copab wceq cU hhnmo.1 hhnv cU
      hhnmo.1 hhnv vx vy vz vt cU cno cno cN cU chil chil cU hhnmo.1 hhba cU
      hhnmo.1 hhba cU hhnmo.1 hhnm cU hhnmo.1 hhnm hhnmo.2 nmofval mp2an eqtr4i
      $.
      $( [31-Jan-2008] $) $( [19-Nov-2007] $)
  $}

  ${
    $d t x y z U $.
    hhblo.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhblo.2 $e |- B = ( U BLnOp U ) $.
    $( A bounded linear operator in Hilbert space. $)
    hhbloi $p |- BndLinOp = B $=
      cbo vt cv cU cU cnmo co cfv cpnf clt wbr vt cU cU clno co crab cB cbo vt
      cv cnop cfv cpnf clt wbr vt clo crab vt cv cU cU cnmo co cfv cpnf clt wbr
      vt clo crab vt cv cU cU cnmo co cfv cpnf clt wbr vt cU cU clno co crab vt
      dfbdop2 vt cv cnop cfv cpnf clt wbr vt cv cU cU cnmo co cfv cpnf clt wbr
      vt clo vt cv cnop cfv cpnf clt wbr vt cv cU cU cnmo co cfv cpnf clt wbr
      wb vt cv clo wcel vt cv cnop cfv vt cv cU cU cnmo co cfv cpnf clt vt cv
      cnop cU cU cnmo co cU cU cU cnmo co hhblo.1 cU cU cnmo co eqid hhnmoi
      fveq1i breq1i a1i rabbii clo cU cU clno co wceq vt cv cU cU cnmo co cfv
      cpnf clt wbr vt clo crab vt cv cU cU cnmo co cfv cpnf clt wbr vt cU cU
      clno co crab wceq cU cU cU clno co hhblo.1 cU cU clno co eqid hhlnoi vt
      cv cU cU cnmo co cfv cpnf clt wbr vt clo cU cU clno co rabeq ax-mp 3eqtri
      cU cnv wcel cU cnv wcel cB vt cv cU cU cnmo co cfv cpnf clt wbr vt cU cU
      clno co crab wceq cU hhblo.1 hhnv cU hhblo.1 hhnv vt cB cU cU cU clno co
      cU cU cnmo co cU cU cU cnmo co eqid cU cU clno co eqid hhblo.2 bloval
      mp2an eqtr4i $.
      $( [12-Feb-2007] $) $( [19-Nov-2007] $)
  $}

  ${
    $d t x y z U $.
    hh0o.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hh0o.2 $e |- Z = ( U 0op U ) $.
    $( The zero operator in Hilbert space. $)
    hh0oi $p |- 0hop = Z $=
      ch0o cU cba cfv cU cn0v cfv csn cxp cZ ch0o chil c0h cxp cU cba cfv c0h
      cxp cU cba cfv cU cn0v cfv csn cxp df0op2 chil cU cba cfv c0h cU hh0o.1
      hhba xpeq1i c0h cU cn0v cfv csn cU cba cfv c0h c0v csn cU cn0v cfv csn
      df-ch0 c0v cU cn0v cfv cU hh0o.1 hh0v sneqi eqtri xpeq2i 3eqtri cU cnv
      wcel cU cnv wcel cZ cU cba cfv cU cn0v cfv csn cxp wceq cU hh0o.1 hhnv cU
      hh0o.1 hhnv cU cZ cU cU cba cfv cU cn0v cfv cU cba cfv eqid cU cn0v cfv
      eqid hh0o.2 0ofval mp2an eqtr4i $.
      $( [13-Feb-2008] $) $( [7-Dec-2007] $)
  $}

  $( The adjoint of an operator belongs to the adjoint function's domain.
     (Note: the converse is dependent on our definition of function value,
     since it uses ~ ndmfv .) $)
  dmadjrnb $p |- ( T e. dom adjh <-> ( adjh ` T ) e. dom adjh ) $=
    cT cado cdm wcel cT cado cfv cado cdm wcel cT dmadjrn cT cado cdm wcel cT
    cado cfv cado cdm wcel cT cado cdm wcel wn cT cado cfv cado cdm wcel c0
    cado cdm wcel c0 cado cdm wcel chil chil c0 wf chil chil c0 wf c0 cdm chil
    wceq c0 cdm chil wceq c0 chil wceq c0 chil wceq chil c0 wceq c0v chil wcel
    chil c0 wceq wn ax-hv0cl chil c0v n0i ax-mp c0 chil eqcom mtbir c0 cdm c0
    chil dm0 eqeq1i mtbir chil chil c0 fdm mto c0 dmadjop mto cT cado cdm wcel
    wn cT cado cfv c0 cado cdm cT cado ndmfv eleq1d mtbiri con4i impbii $.
    $( [3-Jun-2006] $) $( [19-Feb-2006] $)

  ${
    $d t w x y z A $.  $d t w x y z B $.  $d x y z C $.
    $d w x y z S $.  $d x y z w T $.
    $( A lower bound for an operator norm. $)
    nmoplb $p |- ( ( T : ~H --> ~H /\ A e. ~H /\ ( normh ` A ) <_ 1 ) ->
                  ( normh ` ( T ` A ) ) <_ ( normop ` T ) ) $=
      chil chil cT wf cA chil wcel cA cno cfv c1 cle wbr w3a cA cT cfv cno cfv
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex
      vx cab cxr clt csup cT cnop cfv cle vy cv cno cfv c1 cle wbr vx cv vy cv
      cT cfv cno cfv wceq wa vy chil wrex vx cab cxr wss cA cT cfv cno cfv vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx
      cab wcel cA cT cfv cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cno cfv wceq wa vy chil wrex vx cab cxr clt csup cle wbr chil chil cT wf
      cA chil wcel cA cno cfv c1 cle wbr w3a vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cno cfv wceq wa vy chil wrex vx cab cA cT cfv cno cfv supxrub
      chil chil cT wf cA chil wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cno cfv wceq wa vy chil wrex vx cab cxr wss cA cno cfv c1 cle wbr chil
      chil cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy
      chil wrex vx cab cr cxr vx vy cT nmopsetretHIL cr cxr wss chil chil cT wf
      ressxr a1i sstrd 3ad2ant1 cA chil wcel cA cno cfv c1 cle wbr cA cT cfv
      cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy
      chil wrex vx cab wcel chil chil cT wf cA chil wcel cA cno cfv c1 cle wbr
      wa vy cv cno cfv c1 cle wbr cA cT cfv cno cfv vy cv cT cfv cno cfv wceq
      wa vy chil wrex cA cT cfv cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cno cfv wceq wa vy chil wrex vx cab wcel vy cv cno cfv c1 cle wbr cA
      cT cfv cno cfv vy cv cT cfv cno cfv wceq wa cA cno cfv c1 cle wbr vy cA
      chil vy cv cA wceq vy cv cno cfv c1 cle wbr cA cT cfv cno cfv vy cv cT
      cfv cno cfv wceq wa cA cno cfv c1 cle wbr cA cT cfv cno cfv cA cT cfv cno
      cfv wceq wa cA cno cfv c1 cle wbr vy cv cA wceq vy cv cno cfv c1 cle wbr
      cA cno cfv c1 cle wbr cA cT cfv cno cfv vy cv cT cfv cno cfv wceq cA cT
      cfv cno cfv cA cT cfv cno cfv wceq vy cv cA wceq vy cv cno cfv cA cno cfv
      c1 cle vy cv cA cno fveq2 breq1d vy cv cA wceq vy cv cT cfv cno cfv cA cT
      cfv cno cfv cA cT cfv cno cfv vy cv cA wceq vy cv cT cfv cA cT cfv cno vy
      cv cA cT fveq2 fveq2d eqeq2d anbi12d cA cT cfv cno cfv cA cT cfv cno cfv
      wceq cA cno cfv c1 cle wbr cA cT cfv cno cfv eqid biantru syl6bbr rcla4ev
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex
      vy cv cno cfv c1 cle wbr cA cT cfv cno cfv vy cv cT cfv cno cfv wceq wa
      vy chil wrex vx cA cT cfv cno cfv cA cT cfv cno fvex vx cv cA cT cfv cno
      cfv wceq vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy
      cv cno cfv c1 cle wbr cA cT cfv cno cfv vy cv cT cfv cno cfv wceq wa vy
      chil vx cv cA cT cfv cno cfv wceq vx cv vy cv cT cfv cno cfv wceq cA cT
      cfv cno cfv vy cv cT cfv cno cfv wceq vy cv cno cfv c1 cle wbr vx cv cA
      cT cfv cno cfv vy cv cT cfv cno cfv eqeq1 anbi2d rexbidv elab sylibr
      3adant1 sylanc chil chil cT wf cA chil wcel cT cnop cfv vy cv cno cfv c1
      cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt
      csup wceq cA cno cfv c1 cle wbr vx vy cT nmopval 3ad2ant1 breqtrrd $.
      $( [13-Mar-2006] $) $( [7-Feb-2006] $)

    $( An upper bound for an operator norm. $)
    nmopub $p |- ( ( T : ~H --> ~H /\ A e. RR* /\ A. x e. ~H ( ( normh ` x )
             <_ 1 -> ( normh ` ( T ` x ) ) <_ A ) ) -> ( normop ` T ) <_ A ) $=
      chil chil cT wf cA cxr wcel vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv
      cA cle wbr wi vx chil wral w3a cT cnop cfv vz cv cno cfv c1 cle wbr vy cv
      vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab cxr clt csup cA cle chil
      chil cT wf cA cxr wcel cT cnop cfv vz cv cno cfv c1 cle wbr vy cv vz cv
      cT cfv cno cfv wceq wa vz chil wrex vy cab cxr clt csup wceq vx cv cno
      cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral vy vz cT
      nmopval 3ad2ant1 vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq
      wa vz chil wrex vy cab cxr wss cA cxr wcel vw cv cA cle wbr vw vz cv cno
      cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab
      wral vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil
      wrex vy cab cxr clt csup cA cle wbr chil chil cT wf cA cxr wcel vx cv cno
      cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral w3a vw vz
      cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy
      cab cA supxrleub chil chil cT wf cA cxr wcel vz cv cno cfv c1 cle wbr vy
      cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab cxr wss vx cv cno cfv
      c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral chil chil cT
      wf vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil
      wrex vy cab cr cxr vy vz cT nmopsetretHIL cr cxr wss chil chil cT wf
      ressxr a1i sstrd 3ad2ant1 chil chil cT wf cA cxr wcel vx cv cno cfv c1
      cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral 3simp2 vx cv cno
      cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral chil chil
      cT wf vw cv cA cle wbr vw vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno
      cfv wceq wa vz chil wrex vy cab wral cA cxr wcel vx cv cno cfv c1 cle wbr
      vx cv cT cfv cno cfv cA cle wbr wi vx chil wral vw cv cA cle wbr vw vz cv
      cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab
      vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral
      vz cv cno cfv c1 cle wbr vw cv vz cv cT cfv cno cfv wceq wa vz chil wrex
      vw cv cA cle wbr vw cv vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno
      cfv wceq wa vz chil wrex vy cab wcel vx cv cno cfv c1 cle wbr vx cv cT
      cfv cno cfv cA cle wbr wi vx chil wral vz cv cno cfv c1 cle wbr vw cv vz
      cv cT cfv cno cfv wceq wa vw cv cA cle wbr vz chil vx cv cno cfv c1 cle
      wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral vz cv chil wcel vz cv
      cno cfv c1 cle wbr vw cv vz cv cT cfv cno cfv wceq vw cv cA cle wbr vx cv
      cno cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral vz cv
      chil wcel vz cv cno cfv c1 cle wbr vz cv cT cfv cno cfv cA cle wbr vw cv
      vz cv cT cfv cno cfv wceq vw cv cA cle wbr wi vx cv cno cfv c1 cle wbr vx
      cv cT cfv cno cfv cA cle wbr wi vz cv cno cfv c1 cle wbr vz cv cT cfv cno
      cfv cA cle wbr wi vx vz cv chil vx cv vz cv wceq vx cv cno cfv c1 cle wbr
      vz cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr vz cv cT cfv cno
      cfv cA cle wbr vx cv vz cv wceq vx cv cno cfv vz cv cno cfv c1 cle vx cv
      vz cv cno fveq2 breq1d vx cv vz cv wceq vx cv cT cfv cno cfv vz cv cT cfv
      cno cfv cA cle vx cv vz cv wceq vx cv cT cfv vz cv cT cfv cno vx cv vz cv
      cT fveq2 fveq2d breq1d imbi12d rcla4cv vw cv vz cv cT cfv cno cfv wceq vw
      cv cA cle wbr vz cv cT cfv cno cfv cA cle wbr vw cv vz cv cT cfv cno cfv
      cA cle breq1 biimprcd syl8 imp4a r19.23adv vz cv cno cfv c1 cle wbr vy cv
      vz cv cT cfv cno cfv wceq wa vz chil wrex vz cv cno cfv c1 cle wbr vw cv
      vz cv cT cfv cno cfv wceq wa vz chil wrex vy vw cv vw visset vy cv vw cv
      wceq vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz cv
      cno cfv c1 cle wbr vw cv vz cv cT cfv cno cfv wceq wa vz chil vy cv vw cv
      wceq vy cv vz cv cT cfv cno cfv wceq vw cv vz cv cT cfv cno cfv wceq vz
      cv cno cfv c1 cle wbr vy cv vw cv vz cv cT cfv cno cfv eqeq1 anbi2d
      rexbidv elab syl5ib r19.21aiv 3ad2ant3 syl3anc eqbrtrd $.
      $( [19-Mar-2006] $) $( [7-Mar-2006] $)

    $( An upper bound for an operator norm. $)
    nmopub2tALT $p |- ( ( T : ~H --> ~H /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. ~H
  ( normh ` ( T ` x ) ) <_ ( A x. ( normh ` x ) ) ) -> ( normop ` T ) <_ A ) $=
      chil chil cT wf cA cr wcel cc0 cA cle wbr wa vx cv cT cfv cno cfv cA vx
      cv cno cfv cmul co cle wbr vx chil wral cT cnop cfv cA cle wbr chil chil
      cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv cT cfv cno cfv cA vx cv cno
      cfv cmul co cle wbr vx chil wral vx cv cno cfv c1 cle wbr vx cv cT cfv
      cno cfv cA cle wbr wi vx chil wral cT cnop cfv cA cle wbr chil chil cT wf
      cA cr wcel cc0 cA cle wbr wa wa vx cv cT cfv cno cfv cA vx cv cno cfv
      cmul co cle wbr vx chil wral vx cv cno cfv c1 cle wbr vx cv cT cfv cno
      cfv cA cle wbr wi vx chil wral chil chil cT wf cA cr wcel cc0 cA cle wbr
      wa wa vx cv cT cfv cno cfv cA vx cv cno cfv cmul co cle wbr vx cv cno cfv
      c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil chil chil cT wf cA
      cr wcel cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cno cfv c1 cle wbr
      vx cv cT cfv cno cfv cA vx cv cno cfv cmul co cle wbr vx cv cT cfv cno
      cfv cA cle wbr chil chil cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil
      wcel wa vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cA vx cv cno cfv
      cmul co cle wbr vx cv cT cfv cno cfv cA cle wbr wi chil chil cT wf cA cr
      wcel cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa
      vx cv cT cfv cno cfv cA vx cv cno cfv cmul co cle wbr cA vx cv cno cfv
      cmul co cA cle wbr vx cv cT cfv cno cfv cA cle wbr chil chil cT wf cA cr
      wcel cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa
      cA vx cv cno cfv cmul co cA c1 cmul co cA cle vx cv cno cfv cr wcel cA cr
      wcel wa cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa cA vx cv cno cfv cmul
      co cA c1 cmul co cle wbr chil chil cT wf cA cr wcel cc0 cA cle wbr wa wa
      vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cno cfv cr wcel c1
      cr wcel cA cr wcel cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa cA vx cv
      cno cfv cmul co cA c1 cmul co cle wbr 1re vx cv cno cfv c1 cA lemul2aOLD
      mp3anl2 chil chil cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil wcel
      wa vx cv cno cfv cr wcel cA cr wcel wa vx cv cno cfv c1 cle wbr cA cr
      wcel cc0 cA cle wbr wa vx cv chil wcel vx cv cno cfv cr wcel cA cr wcel
      wa chil chil cT wf cA cr wcel vx cv chil wcel vx cv cno cfv cr wcel cA cr
      wcel wa cc0 cA cle wbr vx cv chil wcel cA cr wcel vx cv cno cfv cr wcel
      cA cr wcel wa vx cv chil wcel vx cv cno cfv cr wcel cA cr wcel vx cv
      normcl anim1i ancoms adantlr adantll adantr chil chil cT wf cA cr wcel
      cc0 cA cle wbr wa wa vx cv cno cfv c1 cle wbr cc0 cA cle wbr vx cv cno
      cfv c1 cle wbr wa vx cv chil wcel cA cr wcel cc0 cA cle wbr wa vx cv cno
      cfv c1 cle wbr cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa chil chil cT wf
      cc0 cA cle wbr vx cv cno cfv c1 cle wbr cc0 cA cle wbr vx cv cno cfv c1
      cle wbr wa cA cr wcel cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa id
      adantll adantll adantlr sylanc chil chil cT wf cA cr wcel cc0 cA cle wbr
      wa wa cA c1 cmul co cA wceq vx cv chil wcel vx cv cno cfv c1 cle wbr cA
      cr wcel cA c1 cmul co cA wceq chil chil cT wf cc0 cA cle wbr cA cr wcel
      cA cc wcel cA c1 cmul co cA wceq cA recn cA ax1id syl ad2antrl ad2antrr
      breqtrd chil chil cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil wcel
      wa vx cv cT cfv cno cfv cA vx cv cno cfv cmul co cle wbr cA vx cv cno cfv
      cmul co cA cle wbr wa vx cv cT cfv cno cfv cA cle wbr wi vx cv cno cfv c1
      cle wbr vx cv cT cfv cno cfv cr wcel cA vx cv cno cfv cmul co cr wcel cA
      cr wcel vx cv cT cfv cno cfv cA vx cv cno cfv cmul co cle wbr cA vx cv
      cno cfv cmul co cA cle wbr wa vx cv cT cfv cno cfv cA cle wbr wi chil
      chil cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cT
      cfv cno cfv cA vx cv cno cfv cmul co cA letr chil chil cT wf vx cv chil
      wcel vx cv cT cfv cno cfv cr wcel cA cr wcel cc0 cA cle wbr wa chil chil
      cT wf vx cv chil wcel wa vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr
      wcel chil chil vx cv cT ffvelrn vx cv cT cfv normcl syl adantlr cA cr
      wcel cc0 cA cle wbr wa vx cv chil wcel cA vx cv cno cfv cmul co cr wcel
      chil chil cT wf cA cr wcel vx cv chil wcel cA vx cv cno cfv cmul co cr
      wcel cc0 cA cle wbr cA cr wcel vx cv cno cfv cr wcel cA vx cv cno cfv
      cmul co cr wcel vx cv chil wcel cA vx cv cno cfv remulcl vx cv normcl
      sylan2 adantlr adantll cA cr wcel cc0 cA cle wbr wa cA cr wcel chil chil
      cT wf vx cv chil wcel cA cr wcel cc0 cA cle wbr pm3.26 ad2antlr syl3anc
      adantr mpan2d ex com23 r19.20dva imp chil chil cT wf cA cr wcel cc0 cA
      cle wbr wa vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx
      chil wral cT cnop cfv cA cle wbr chil chil cT wf cA cxr wcel vx cv cno
      cfv c1 cle wbr vx cv cT cfv cno cfv cA cle wbr wi vx chil wral cT cnop
      cfv cA cle wbr cA cr wcel cc0 cA cle wbr wa vx cA cT nmopub cA cr wcel cA
      cxr wcel cc0 cA cle wbr cA rexr adantr syl3an2 3expa syldan 3impa $.
      $( [18-Oct-2006] $) $( [12-Apr-2006] $)

    $( An upper bound for an operator norm. $)
    nmopub2tHIL $p |- ( ( T : ~H --> ~H /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. ~H
  ( normh ` ( T ` x ) ) <_ ( A x. ( normh ` x ) ) ) -> ( normop ` T ) <_ A ) $=
      vx cA cT cva csm cop cno cop cno cno cnop cva csm cop cno cop chil chil
      cva csm cop cno cop cva csm cop cno cop eqid hhba cva csm cop cno cop cva
      csm cop cno cop eqid hhba cva csm cop cno cop cva csm cop cno cop eqid
      hhnm cva csm cop cno cop cva csm cop cno cop eqid hhnm cva csm cop cno
      cop cva csm cop cno cop cva csm cop cno cop cnmo co cva csm cop cno cop
      eqid cva csm cop cno cop cva csm cop cno cop cnmo co eqid hhnmoi cva csm
      cop cno cop cva csm cop cno cop eqid hhnv cva csm cop cno cop cva csm cop
      cno cop eqid hhnv nmoub2i $.
      $( [8-Jul-2008] $) $( [13-Dec-2007] $)

    $( The norm of any Hilbert space operator is nonnegative. $)
    nmopge0 $p |- ( T : ~H --> ~H -> 0 <_ ( normop ` T ) ) $=
      chil chil cT wf cc0 c0v cT cfv cno cfv cle wbr c0v cT cfv cno cfv cT cnop
      cfv cle wbr cc0 cT cnop cfv cle wbr chil chil cT wf c0v cT cfv chil wcel
      cc0 c0v cT cfv cno cfv cle wbr chil chil cT wf c0v chil wcel c0v cT cfv
      chil wcel ax-hv0cl chil chil c0v cT ffvelrn mpan2 c0v cT cfv normge0 syl
      chil chil cT wf c0v chil wcel c0v cno cfv c1 cle wbr c0v cT cfv cno cfv
      cT cnop cfv cle wbr ax-hv0cl c0v cno cfv cc0 c1 cle norm0 cc0 c1 0re 1re
      lt01 ltleii eqbrtri c0v cT nmoplb mp3an23 c0v cT cfv cno cfv cxr wcel cT
      cnop cfv cxr wcel cc0 c0v cT cfv cno cfv cle wbr c0v cT cfv cno cfv cT
      cnop cfv cle wbr wa cc0 cT cnop cfv cle wbr wi chil chil cT wf cc0 cxr
      wcel c0v cT cfv cno cfv cxr wcel cT cnop cfv cxr wcel cc0 c0v cT cfv cno
      cfv cle wbr c0v cT cfv cno cfv cT cnop cfv cle wbr wa cc0 cT cnop cfv cle
      wbr wi cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cc0 c0v cT cfv cno cfv
      cT cnop cfv xrletr mp3an1 chil chil cT wf c0v cT cfv chil wcel c0v cT cfv
      cno cfv cr wcel c0v cT cfv cno cfv cxr wcel chil chil cT wf c0v chil wcel
      c0v cT cfv chil wcel ax-hv0cl chil chil c0v cT ffvelrn mpan2 c0v cT cfv
      normcl c0v cT cfv cno cfv rexr 3syl cT nmopxr sylanc mp2and $.
      $( [14-Mar-2006] $) $( [9-Feb-2006] $)

    $( A linear Hilbert space operator that is not identically zero has a
       positive norm. $)
    nmopgt0 $p |- ( T : ~H --> ~H ->
                  ( ( normop ` T ) =/= 0 <-> 0 < ( normop ` T ) ) ) $=
      chil chil cT wf cc0 cT cnop cfv clt wbr cT cnop cfv cc0 wne cT cnop cfv
      cxr wcel cc0 cT cnop cfv cle wbr cc0 cT cnop cfv clt wbr cT cnop cfv cc0
      wne wb chil chil cT wf cc0 cxr wcel cT cnop cfv cxr wcel cc0 cT cnop cfv
      cle wbr cc0 cT cnop cfv clt wbr cT cnop cfv cc0 wne wb cc0 cr wcel cc0
      cxr wcel 0re cc0 rexr ax-mp cc0 cT cnop cfv xrleltne mp3an1 cT nmopxr cT
      nmopge0 sylanc bicomd $.
      $( [25-Mar-2006] $) $( [9-Feb-2006] $)

    $( Basic continuity property of a continuous Hilbert space operator. $)
    cnopc $p |- ( ( ( T e. ConOp /\ A e. ~H ) /\ ( B e. RR /\ 0 < B ) ) ->
               E. x e. RR ( 0 < x /\ A. y e. ~H ( ( normh ` ( y -h A ) ) < x ->
               ( normh ` ( ( T ` y ) -h ( T ` A ) ) ) < B ) ) ) $=
      cT cco wcel cA chil wcel cB cr wcel cc0 cB clt wbr cc0 vx cv clt wbr vy
      cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv
      cB clt wbr wi vy chil wral wa vx cr wrex cT cco wcel cc0 vw cv clt wbr
      cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv
      vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vy chil wral wa vx cr wrex
      wi vw cr wral vz chil wral cA chil wcel cB cr wcel cc0 cB clt wbr cc0 vx
      cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv
      cmv co cno cfv cB clt wbr wi vy chil wral wa vx cr wrex wi wi wi cT cco
      wcel chil chil cT wf cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv vz cv cmv
      co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmv co cno cfv vw cv
      clt wbr wi vy chil wral wa vx cr wrex wi vw cr wral vz chil wral vz vw vx
      vy cT elcnop pm3.27bi cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv vz cv cmv
      co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmv co cno cfv vw cv
      clt wbr wi vy chil wral wa vx cr wrex wi vw cr wral vz chil wral cA chil
      wcel cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv cA cmv co cno cfv vx cv
      clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt wbr wi vy chil
      wral wa vx cr wrex wi vw cr wral cB cr wcel cc0 cB clt wbr cc0 vx cv clt
      wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co
      cno cfv cB clt wbr wi vy chil wral wa vx cr wrex wi wi cc0 vw cv clt wbr
      cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv
      vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vy chil wral wa vx cr wrex
      wi vw cr wral cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv cA cmv co cno cfv
      vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt wbr wi vy
      chil wral wa vx cr wrex wi vw cr wral vz cA chil vz cv cA wceq cc0 vw cv
      clt wbr cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv
      cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vy chil wral wa vx cr
      wrex wi cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv cA cmv co cno cfv vx cv
      clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt wbr wi vy chil
      wral wa vx cr wrex wi vw cr vz cv cA wceq cc0 vx cv clt wbr vy cv vz cv
      cmv co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmv co cno cfv vw
      cv clt wbr wi vy chil wral wa vx cr wrex cc0 vx cv clt wbr vy cv cA cmv
      co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt
      wbr wi vy chil wral wa vx cr wrex cc0 vw cv clt wbr vz cv cA wceq cc0 vx
      cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT
      cfv cmv co cno cfv vw cv clt wbr wi vy chil wral wa cc0 vx cv clt wbr vy
      cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv
      vw cv clt wbr wi vy chil wral wa vx cr vz cv cA wceq vy cv vz cv cmv co
      cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt
      wbr wi vy chil wral vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA
      cT cfv cmv co cno cfv vw cv clt wbr wi vy chil wral cc0 vx cv clt wbr vz
      cv cA wceq vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT
      cfv cmv co cno cfv vw cv clt wbr wi vy cv cA cmv co cno cfv vx cv clt wbr
      vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt wbr wi vy chil vz cv cA
      wceq vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cA cmv co cno cfv vx
      cv clt wbr vy cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr vy cv
      cT cfv cA cT cfv cmv co cno cfv vw cv clt wbr vz cv cA wceq vy cv vz cv
      cmv co cno cfv vy cv cA cmv co cno cfv vx cv clt vz cv cA wceq vy cv vz
      cv cmv co vy cv cA cmv co cno vz cv cA vy cv cmv opreq2 fveq2d breq1d vz
      cv cA wceq vy cv cT cfv vz cv cT cfv cmv co cno cfv vy cv cT cfv cA cT
      cfv cmv co cno cfv vw cv clt vz cv cA wceq vy cv cT cfv vz cv cT cfv cmv
      co vy cv cT cfv cA cT cfv cmv co cno vz cv cA wceq vz cv cT cfv cA cT cfv
      vy cv cT cfv cmv vz cv cA cT fveq2 opreq2d fveq2d breq1d imbi12d ralbidv
      anbi2d rexbidv imbi2d ralbidv rcla4cv cc0 vw cv clt wbr cc0 vx cv clt wbr
      vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno
      cfv vw cv clt wbr wi vy chil wral wa vx cr wrex wi cc0 cB clt wbr cc0 vx
      cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv
      cmv co cno cfv cB clt wbr wi vy chil wral wa vx cr wrex wi vw cB cr vw cv
      cB wceq cc0 vw cv clt wbr cc0 cB clt wbr cc0 vx cv clt wbr vy cv cA cmv
      co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt
      wbr wi vy chil wral wa vx cr wrex cc0 vx cv clt wbr vy cv cA cmv co cno
      cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv cB clt wbr wi vy
      chil wral wa vx cr wrex vw cv cB cc0 clt breq2 vw cv cB wceq cc0 vx cv
      clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv
      co cno cfv vw cv clt wbr wi vy chil wral wa cc0 vx cv clt wbr vy cv cA
      cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv cB clt
      wbr wi vy chil wral wa vx cr vw cv cB wceq vy cv cA cmv co cno cfv vx cv
      clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw cv clt wbr wi vy chil
      wral vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co
      cno cfv cB clt wbr wi vy chil wral cc0 vx cv clt wbr vw cv cB wceq vy cv
      cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv vw
      cv clt wbr wi vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT
      cfv cmv co cno cfv cB clt wbr wi vy chil vw cv cB wceq vy cv cT cfv cA cT
      cfv cmv co cno cfv vw cv clt wbr vy cv cT cfv cA cT cfv cmv co cno cfv cB
      clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vw cv cB vy cv cT cfv cA cT
      cfv cmv co cno cfv clt breq2 imbi2d ralbidv anbi2d rexbidv imbi12d
      rcla4cv syl6 syl imp43 $.
      $( [2-Mar-2006] $) $( [2-Feb-2006] $)

    $( Basic linearity property of a linear Hilbert space operator. $)
    lnopl $p |- ( ( ( T e. LinOp /\ A e. CC ) /\ ( B e. ~H /\ C e. ~H ) ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A .h ( T ` B ) ) +h ( T ` C ) ) ) $=
      cT clo wcel cA cc wcel cB chil wcel cC chil wcel wa cA cB csm co cC cva
      co cT cfv cA cB cT cfv csm co cC cT cfv cva co wceq cA cc wcel cB chil
      wcel cC chil wcel wa wa cT clo wcel cA cB csm co cC cva co cT cfv cA cB
      cT cfv csm co cC cT cfv cva co wceq cA cc wcel cB chil wcel cC chil wcel
      cT clo wcel cA cB csm co cC cva co cT cfv cA cB cT cfv csm co cC cT cfv
      cva co wceq wi cA cc wcel cB chil wcel cC chil wcel w3a vx cv vy cv csm
      co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq
      vz chil wral vy chil wral vx cc wral cA cB csm co cC cva co cT cfv cA cB
      cT cfv csm co cC cT cfv cva co wceq cT clo wcel vx cv vy cv csm co vz cv
      cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq cA cB
      csm co cC cva co cT cfv cA cB cT cfv csm co cC cT cfv cva co wceq cA vy
      cv csm co vz cv cva co cT cfv cA vy cv cT cfv csm co vz cv cT cfv cva co
      wceq cA cB csm co vz cv cva co cT cfv cA cB cT cfv csm co vz cv cT cfv
      cva co wceq vx vy vz cA cB cC cc chil chil vx cv cA wceq vx cv vy cv csm
      co vz cv cva co cT cfv cA vy cv csm co vz cv cva co cT cfv vx cv vy cv cT
      cfv csm co vz cv cT cfv cva co cA vy cv cT cfv csm co vz cv cT cfv cva co
      vx cv cA wceq vx cv vy cv csm co vz cv cva co cA vy cv csm co vz cv cva
      co cT vx cv cA wceq vx cv vy cv csm co cA vy cv csm co vz cv cva vx cv cA
      vy cv csm opreq1 opreq1d fveq2d vx cv cA wceq vx cv vy cv cT cfv csm co
      cA vy cv cT cfv csm co vz cv cT cfv cva vx cv cA vy cv cT cfv csm opreq1
      opreq1d eqeq12d vy cv cB wceq cA vy cv csm co vz cv cva co cT cfv cA cB
      csm co vz cv cva co cT cfv cA vy cv cT cfv csm co vz cv cT cfv cva co cA
      cB cT cfv csm co vz cv cT cfv cva co vy cv cB wceq cA vy cv csm co vz cv
      cva co cA cB csm co vz cv cva co cT vy cv cB wceq cA vy cv csm co cA cB
      csm co vz cv cva vy cv cB cA csm opreq2 opreq1d fveq2d vy cv cB wceq cA
      vy cv cT cfv csm co cA cB cT cfv csm co vz cv cT cfv cva vy cv cB wceq vy
      cv cT cfv cB cT cfv cA csm vy cv cB cT fveq2 opreq2d opreq1d eqeq12d vz
      cv cC wceq cA cB csm co vz cv cva co cT cfv cA cB csm co cC cva co cT cfv
      cA cB cT cfv csm co vz cv cT cfv cva co cA cB cT cfv csm co cC cT cfv cva
      co vz cv cC wceq cA cB csm co vz cv cva co cA cB csm co cC cva co cT vz
      cv cC cA cB csm co cva opreq2 fveq2d vz cv cC wceq vz cv cT cfv cC cT cfv
      cA cB cT cfv csm co cva vz cv cC cT fveq2 opreq2d eqeq12d rcla43v cT clo
      wcel chil chil cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv
      cT cfv csm co vz cv cT cfv cva co wceq vz chil wral vy chil wral vx cc
      wral vx vy vz cT ellnop pm3.27bi syl5 3expb impcom anassrs $.
      $( [4-Mar-2006] $) $( [22-Jan-2006] $)

    $( Basic inner product property of a unitary operator. $)
    unop $p |- ( ( T e. UniOp /\ A e. ~H /\ B e. ~H ) ->
                ( ( T ` A ) .ih ( T ` B ) ) = ( A .ih B ) ) $=
      cT cuo wcel cA chil wcel cB chil wcel w3a vx cv cT cfv vy cv cT cfv csp
      co vx cv vy cv csp co wceq vy chil wral vx chil wral cA cT cfv cB cT cfv
      csp co cA cB csp co wceq cT cuo wcel cA chil wcel vx cv cT cfv vy cv cT
      cfv csp co vx cv vy cv csp co wceq vy chil wral vx chil wral cB chil wcel
      cT cuo wcel chil chil cT wfo vx cv cT cfv vy cv cT cfv csp co vx cv vy cv
      csp co wceq vy chil wral vx chil wral vx vy cT elunop pm3.27bi 3ad2ant1
      cA chil wcel cB chil wcel vx cv cT cfv vy cv cT cfv csp co vx cv vy cv
      csp co wceq vy chil wral vx chil wral cA cT cfv cB cT cfv csp co cA cB
      csp co wceq wi cT cuo wcel vx cv cT cfv vy cv cT cfv csp co vx cv vy cv
      csp co wceq cA cT cfv cB cT cfv csp co cA cB csp co wceq cA cT cfv vy cv
      cT cfv csp co cA vy cv csp co wceq vx vy cA cB chil chil vx cv cA wceq vx
      cv cT cfv vy cv cT cfv csp co cA cT cfv vy cv cT cfv csp co vx cv vy cv
      csp co cA vy cv csp co vx cv cA wceq vx cv cT cfv cA cT cfv vy cv cT cfv
      csp vx cv cA cT fveq2 opreq1d vx cv cA vy cv csp opreq1 eqeq12d vy cv cB
      wceq cA cT cfv vy cv cT cfv csp co cA cT cfv cB cT cfv csp co cA vy cv
      csp co cA cB csp co vy cv cB wceq vy cv cT cfv cB cT cfv cA cT cfv csp vy
      cv cB cT fveq2 opreq2d vy cv cB cA csp opreq2 eqeq12d rcla42v 3adant1 mpd
      $.
      $( [3-Mar-2006] $) $( [22-Jan-2006] $)

    $( A unitary operator in Hilbert space is one-to-one and onto. $)
    unopf1o $p |- ( T e. UniOp -> T : ~H -1-1-onto-> ~H ) $=
      cT cuo wcel chil chil cT wf1 chil chil cT wfo wa chil chil cT wf1o cT cuo
      wcel chil chil cT wf1 chil chil cT wfo cT cuo wcel chil chil cT wf vx cv
      cT cfv vy cv cT cfv wceq vx cv vy cv wceq wi vy chil wral vx chil wral wa
      chil chil cT wf1 cT cuo wcel chil chil cT wf vx cv cT cfv vy cv cT cfv
      wceq vx cv vy cv wceq wi vy chil wral vx chil wral cT cuo wcel chil chil
      cT wfo chil chil cT wf cT cuo wcel chil chil cT wfo vx cv cT cfv vy cv cT
      cfv csp co vx cv vy cv csp co wceq vy chil wral vx chil wral vx vy cT
      elunop pm3.26bi chil chil cT fof syl cT cuo wcel vx cv cT cfv vy cv cT
      cfv wceq vx cv vy cv wceq wi vx vy chil chil cT cuo wcel vx cv chil wcel
      vy cv chil wcel wa vx cv cT cfv vy cv cT cfv wceq vx cv vy cv wceq wi cT
      cuo wcel vx cv chil wcel vy cv chil wcel wa wa vx cv cT cfv vy cv cT cfv
      wceq vx cv vy cv wceq cT cuo wcel vx cv chil wcel vy cv chil wcel wa wa
      vx cv vy cv cmv co vx cv vy cv cmv co csp co cc0 wceq vx cv cT cfv vy cv
      cT cfv cmv co vx cv cT cfv vy cv cT cfv cmv co csp co cc0 wceq vx cv vy
      cv wceq vx cv cT cfv vy cv cT cfv wceq cT cuo wcel vx cv chil wcel vy cv
      chil wcel wa wa vx cv vy cv cmv co vx cv vy cv cmv co csp co vx cv cT cfv
      vy cv cT cfv cmv co vx cv cT cfv vy cv cT cfv cmv co csp co cc0 cT cuo
      wcel vx cv chil wcel vy cv chil wcel wa wa vx cv cT cfv vx cv cT cfv csp
      co vy cv cT cfv vy cv cT cfv csp co caddc co vx cv cT cfv vy cv cT cfv
      csp co vy cv cT cfv vx cv cT cfv csp co caddc co cmin co vx cv vx cv csp
      co vy cv vy cv csp co caddc co vx cv vy cv csp co vy cv vx cv csp co
      caddc co cmin co vx cv cT cfv vy cv cT cfv cmv co vx cv cT cfv vy cv cT
      cfv cmv co csp co vx cv vy cv cmv co vx cv vy cv cmv co csp co cT cuo
      wcel vx cv chil wcel vy cv chil wcel vx cv cT cfv vx cv cT cfv csp co vy
      cv cT cfv vy cv cT cfv csp co caddc co vx cv cT cfv vy cv cT cfv csp co
      vy cv cT cfv vx cv cT cfv csp co caddc co cmin co vx cv vx cv csp co vy
      cv vy cv csp co caddc co vx cv vy cv csp co vy cv vx cv csp co caddc co
      cmin co wceq cT cuo wcel vx cv chil wcel vy cv chil wcel w3a vx cv cT cfv
      vx cv cT cfv csp co vy cv cT cfv vy cv cT cfv csp co caddc co vx cv vx cv
      csp co vy cv vy cv csp co caddc co vx cv cT cfv vy cv cT cfv csp co vy cv
      cT cfv vx cv cT cfv csp co caddc co vx cv vy cv csp co vy cv vx cv csp co
      caddc co cmin cT cuo wcel vx cv chil wcel vy cv chil wcel w3a vx cv cT
      cfv vx cv cT cfv csp co vx cv vx cv csp co vy cv cT cfv vy cv cT cfv csp
      co vy cv vy cv csp co caddc cT cuo wcel vx cv chil wcel vx cv cT cfv vx
      cv cT cfv csp co vx cv vx cv csp co wceq vy cv chil wcel cT cuo wcel vx
      cv chil wcel vx cv cT cfv vx cv cT cfv csp co vx cv vx cv csp co wceq vx
      cv vx cv cT unop 3anidm23 3adant3 cT cuo wcel vy cv chil wcel vy cv cT
      cfv vy cv cT cfv csp co vy cv vy cv csp co wceq vx cv chil wcel cT cuo
      wcel vy cv chil wcel vy cv cT cfv vy cv cT cfv csp co vy cv vy cv csp co
      wceq vy cv vy cv cT unop 3anidm23 3adant2 opreq12d cT cuo wcel vx cv chil
      wcel vy cv chil wcel w3a vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp
      co vy cv cT cfv vx cv cT cfv csp co vy cv vx cv csp co caddc vx cv vy cv
      cT unop cT cuo wcel vy cv chil wcel vx cv chil wcel vy cv cT cfv vx cv cT
      cfv csp co vy cv vx cv csp co wceq vy cv vx cv cT unop 3com23 opreq12d
      opreq12d 3expb cT cuo wcel vx cv chil wcel vy cv chil wcel wa wa vx cv cT
      cfv chil wcel vy cv cT cfv chil wcel wa vx cv cT cfv vy cv cT cfv cmv co
      vx cv cT cfv vy cv cT cfv cmv co csp co vx cv cT cfv vx cv cT cfv csp co
      vy cv cT cfv vy cv cT cfv csp co caddc co vx cv cT cfv vy cv cT cfv csp
      co vy cv cT cfv vx cv cT cfv csp co caddc co cmin co wceq chil chil cT wf
      vx cv chil wcel vy cv chil wcel wa vx cv cT cfv chil wcel vy cv cT cfv
      chil wcel wa cT cuo wcel chil chil cT wf vx cv chil wcel vy cv chil wcel
      vx cv cT cfv chil wcel vy cv cT cfv chil wcel wa chil chil cT wf vx cv
      chil wcel wa vx cv cT cfv chil wcel chil chil cT wf vy cv chil wcel wa vy
      cv cT cfv chil wcel chil chil vx cv cT ffvelrn chil chil vy cv cT ffvelrn
      anim12i anandis cT cuo wcel chil chil cT wfo chil chil cT wf cT cuo wcel
      chil chil cT wfo vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co wceq
      vy chil wral vx chil wral vx vy cT elunop pm3.26bi chil chil cT fof syl
      sylan vx cv cT cfv vy cv cT cfv normlem9at syl vx cv chil wcel vy cv chil
      wcel wa vx cv vy cv cmv co vx cv vy cv cmv co csp co vx cv vx cv csp co
      vy cv vy cv csp co caddc co vx cv vy cv csp co vy cv vx cv csp co caddc
      co cmin co wceq cT cuo wcel vx cv vy cv normlem9at adantl 3eqtr4rd eqeq1d
      vx cv chil wcel vy cv chil wcel wa vx cv vy cv cmv co vx cv vy cv cmv co
      csp co cc0 wceq vx cv vy cv wceq wb cT cuo wcel vx cv chil wcel vy cv
      chil wcel wa vx cv vy cv cmv co vx cv vy cv cmv co csp co cc0 wceq vx cv
      vy cv cmv co c0v wceq vx cv vy cv wceq vx cv chil wcel vy cv chil wcel wa
      vx cv vy cv cmv co chil wcel vx cv vy cv cmv co vx cv vy cv cmv co csp co
      cc0 wceq vx cv vy cv cmv co c0v wceq wb vx cv vy cv hvsubcl vx cv vy cv
      cmv co his6 syl vx cv vy cv hvsubeq0 bitrd adantl cT cuo wcel vx cv chil
      wcel vy cv chil wcel wa wa vx cv cT cfv chil wcel vy cv cT cfv chil wcel
      wa vx cv cT cfv vy cv cT cfv cmv co vx cv cT cfv vy cv cT cfv cmv co csp
      co cc0 wceq vx cv cT cfv vy cv cT cfv wceq wb chil chil cT wf vx cv chil
      wcel vy cv chil wcel wa vx cv cT cfv chil wcel vy cv cT cfv chil wcel wa
      cT cuo wcel chil chil cT wf vx cv chil wcel vy cv chil wcel vx cv cT cfv
      chil wcel vy cv cT cfv chil wcel wa chil chil cT wf vx cv chil wcel wa vx
      cv cT cfv chil wcel chil chil cT wf vy cv chil wcel wa vy cv cT cfv chil
      wcel chil chil vx cv cT ffvelrn chil chil vy cv cT ffvelrn anim12i
      anandis cT cuo wcel chil chil cT wfo chil chil cT wf cT cuo wcel chil
      chil cT wfo vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co wceq vy
      chil wral vx chil wral vx vy cT elunop pm3.26bi chil chil cT fof syl
      sylan vx cv cT cfv chil wcel vy cv cT cfv chil wcel wa vx cv cT cfv vy cv
      cT cfv cmv co vx cv cT cfv vy cv cT cfv cmv co csp co cc0 wceq vx cv cT
      cfv vy cv cT cfv cmv co c0v wceq vx cv cT cfv vy cv cT cfv wceq vx cv cT
      cfv chil wcel vy cv cT cfv chil wcel wa vx cv cT cfv vy cv cT cfv cmv co
      chil wcel vx cv cT cfv vy cv cT cfv cmv co vx cv cT cfv vy cv cT cfv cmv
      co csp co cc0 wceq vx cv cT cfv vy cv cT cfv cmv co c0v wceq wb vx cv cT
      cfv vy cv cT cfv hvsubcl vx cv cT cfv vy cv cT cfv cmv co his6 syl vx cv
      cT cfv vy cv cT cfv hvsubeq0 bitrd syl 3bitr3rd biimpd ex r19.21aivv jca
      vx vy chil chil cT dff13 sylibr cT cuo wcel chil chil cT wfo vx cv cT cfv
      vy cv cT cfv csp co vx cv vy cv csp co wceq vy chil wral vx chil wral vx
      vy cT elunop pm3.26bi jca chil chil cT df-f1o sylibr $.
      $( [3-Mar-2006] $) $( [22-Jan-2006] $)

    $( A unitary operator is idempotent in the norm. $)
    unopnorm $p |- ( ( T e. UniOp /\ A e. ~H ) ->
                ( normh ` ( T ` A ) ) = ( normh ` A ) ) $=
      cT cuo wcel cA chil wcel wa cA cT cfv cno cfv c2 cexp co cA cno cfv c2
      cexp co wceq cA cT cfv cno cfv cA cno cfv wceq cT cuo wcel cA chil wcel
      wa cA cT cfv cA cT cfv csp co cA cA csp co cA cT cfv cno cfv c2 cexp co
      cA cno cfv c2 cexp co cT cuo wcel cA chil wcel cA cT cfv cA cT cfv csp co
      cA cA csp co wceq cA cA cT unop 3anidm23 cT cuo wcel cA chil wcel wa cA
      cT cfv chil wcel cA cT cfv cno cfv c2 cexp co cA cT cfv cA cT cfv csp co
      wceq chil chil cT wf cA chil wcel cA cT cfv chil wcel cT cuo wcel chil
      chil cA cT ffvelrn cT cuo wcel chil chil cT wf1o chil chil cT wf cT
      unopf1o chil chil cT f1of syl sylan cA cT cfv normsq syl cA chil wcel cA
      cno cfv c2 cexp co cA cA csp co wceq cT cuo wcel cA normsq adantl 3eqtr4d
      cA cT cfv cno cfv cr wcel cc0 cA cT cfv cno cfv cle wbr cA cno cfv cr
      wcel cc0 cA cno cfv cle wbr cA cT cfv cno cfv c2 cexp co cA cno cfv c2
      cexp co wceq cA cT cfv cno cfv cA cno cfv wceq wb cT cuo wcel cA chil
      wcel wa cA cT cfv cno cfv cA cno cfv sq11 cT cuo wcel cA chil wcel wa cA
      cT cfv chil wcel cA cT cfv cno cfv cr wcel chil chil cT wf cA chil wcel
      cA cT cfv chil wcel cT cuo wcel chil chil cA cT ffvelrn cT cuo wcel chil
      chil cT wf1o chil chil cT wf cT unopf1o chil chil cT f1of syl sylan cA cT
      cfv normcl syl cT cuo wcel cA chil wcel wa cA cT cfv chil wcel cc0 cA cT
      cfv cno cfv cle wbr chil chil cT wf cA chil wcel cA cT cfv chil wcel cT
      cuo wcel chil chil cA cT ffvelrn cT cuo wcel chil chil cT wf1o chil chil
      cT wf cT unopf1o chil chil cT f1of syl sylan cA cT cfv normge0 syl cA
      chil wcel cA cno cfv cr wcel cT cuo wcel cA normcl adantl cA chil wcel
      cc0 cA cno cfv cle wbr cT cuo wcel cA normge0 adantl syl2anc mpbid $.
      $( [22-Mar-2006] $) $( [25-Feb-2006] $)

    $( The inverse (converse) of a unitary operator in Hilbert space is
       unitary.  Theorem in [AkhiezerGlazman] p. 72. $)
    cnvunop $p |- ( T e. UniOp -> `' T e. UniOp ) $=
      cT cuo wcel chil chil cT ccnv wfo vx cv cT ccnv cfv vy cv cT ccnv cfv csp
      co vx cv vy cv csp co wceq vy chil wral vx chil wral wa cT ccnv cuo wcel
      cT cuo wcel chil chil cT ccnv wfo vx cv cT ccnv cfv vy cv cT ccnv cfv csp
      co vx cv vy cv csp co wceq vy chil wral vx chil wral cT cuo wcel chil
      chil cT wf1o chil chil cT ccnv wfo cT unopf1o chil chil cT wf1o chil chil
      cT ccnv wf1o chil chil cT ccnv wfo chil chil cT f1ocnv chil chil cT ccnv
      f1ofo syl syl cT cuo wcel vx cv cT ccnv cfv vy cv cT ccnv cfv csp co vx
      cv vy cv csp co wceq vx vy chil chil cT cuo wcel vx cv chil wcel vy cv
      chil wcel wa vx cv cT ccnv cfv vy cv cT ccnv cfv csp co vx cv vy cv csp
      co wceq cT cuo wcel vx cv chil wcel vy cv chil wcel wa wa vx cv cT ccnv
      cfv cT cfv vy cv cT ccnv cfv cT cfv csp co vx cv cT ccnv cfv vy cv cT
      ccnv cfv csp co vx cv vy cv csp co cT cuo wcel vx cv cT ccnv cfv chil
      wcel vy cv cT ccnv cfv chil wcel vx cv cT ccnv cfv cT cfv vy cv cT ccnv
      cfv cT cfv csp co vx cv cT ccnv cfv vy cv cT ccnv cfv csp co wceq cT cuo
      wcel vx cv chil wcel vy cv chil wcel wa wa vx cv cT ccnv cfv vy cv cT
      ccnv cfv cT unop cT cuo wcel vx cv chil wcel vy cv chil wcel wa pm3.26 cT
      cuo wcel vx cv chil wcel vx cv cT ccnv cfv chil wcel vy cv chil wcel chil
      chil cT ccnv wf vx cv chil wcel vx cv cT ccnv cfv chil wcel cT cuo wcel
      chil chil vx cv cT ccnv ffvelrn cT cuo wcel chil chil cT ccnv wfo chil
      chil cT ccnv wf cT cuo wcel chil chil cT wf1o chil chil cT ccnv wfo cT
      unopf1o chil chil cT wf1o chil chil cT ccnv wf1o chil chil cT ccnv wfo
      chil chil cT f1ocnv chil chil cT ccnv f1ofo syl syl chil chil cT ccnv fof
      syl sylan adantrr cT cuo wcel vy cv chil wcel vy cv cT ccnv cfv chil wcel
      vx cv chil wcel chil chil cT ccnv wf vy cv chil wcel vy cv cT ccnv cfv
      chil wcel cT cuo wcel chil chil vy cv cT ccnv ffvelrn cT cuo wcel chil
      chil cT ccnv wfo chil chil cT ccnv wf cT cuo wcel chil chil cT wf1o chil
      chil cT ccnv wfo cT unopf1o chil chil cT wf1o chil chil cT ccnv wf1o chil
      chil cT ccnv wfo chil chil cT f1ocnv chil chil cT ccnv f1ofo syl syl chil
      chil cT ccnv fof syl sylan adantrl syl3anc chil chil cT wf1o vx cv chil
      wcel vy cv chil wcel wa vx cv cT ccnv cfv cT cfv vy cv cT ccnv cfv cT cfv
      csp co vx cv vy cv csp co wceq cT cuo wcel chil chil cT wf1o vx cv chil
      wcel vy cv chil wcel wa wa vx cv cT ccnv cfv cT cfv vx cv vy cv cT ccnv
      cfv cT cfv vy cv csp chil chil cT wf1o vx cv chil wcel vx cv cT ccnv cfv
      cT cfv vx cv wceq vy cv chil wcel chil chil vx cv cT f1ocnvfv2 adantrr
      chil chil cT wf1o vy cv chil wcel vy cv cT ccnv cfv cT cfv vy cv wceq vx
      cv chil wcel chil chil vy cv cT f1ocnvfv2 adantrl opreq12d cT unopf1o
      sylan eqtr3d ex r19.21aivv jca vx vy cT ccnv elunop sylibr $.
      $( [4-Mar-2006] $) $( [22-Jan-2006] $)

    $( The inverse (converse) of a unitary operator is its adjoint.  Equation 2
       of [AkhiezerGlazman] p. 72. $)
    unopadj $p |- ( ( T e. UniOp /\ A e. ~H /\ B e. ~H ) ->
                  ( ( T ` A ) .ih B ) = ( A .ih ( `' T ` B ) ) ) $=
      cT cuo wcel cA chil wcel cB chil wcel w3a cA cT cfv cB cT ccnv cfv cT cfv
      csp co cA cT cfv cB csp co cA cB cT ccnv cfv csp co cT cuo wcel cA chil
      wcel cB chil wcel w3a cB cT ccnv cfv cT cfv cB cA cT cfv csp cT cuo wcel
      cB chil wcel cB cT ccnv cfv cT cfv cB wceq cA chil wcel chil chil cT wf1o
      cB chil wcel cB cT ccnv cfv cT cfv cB wceq cT cuo wcel chil chil cB cT
      f1ocnvfv2 cT unopf1o sylan 3adant2 opreq2d cT cuo wcel cA chil wcel cB cT
      ccnv cfv chil wcel cA cT cfv cB cT ccnv cfv cT cfv csp co cA cB cT ccnv
      cfv csp co wceq cB chil wcel cA cB cT ccnv cfv cT unop cT cuo wcel cB
      chil wcel cB cT ccnv cfv chil wcel cA chil wcel chil chil cT ccnv wf cB
      chil wcel cB cT ccnv cfv chil wcel cT cuo wcel chil chil cB cT ccnv
      ffvelrn cT cuo wcel chil chil cT wf1o chil chil cT ccnv wf1o chil chil cT
      ccnv wf cT unopf1o chil chil cT f1ocnv chil chil cT ccnv f1of 3syl sylan
      3adant2 syld3an3 eqtr3d $.
      $( [4-Mar-2006] $) $( [22-Jan-2006] $)

    $( A unitary operator is linear.  Theorem in [AkhiezerGlazman] p. 72. $)
    unoplin $p |- ( T e. UniOp -> T e. LinOp ) $=
      cT cuo wcel chil chil cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv
      vy cv cT cfv csm co vz cv cT cfv cva co wceq vz chil wral vy chil wral vx
      cc wral wa cT clo wcel cT cuo wcel chil chil cT wf vx cv vy cv csm co vz
      cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz
      chil wral vy chil wral vx cc wral cT cuo wcel chil chil cT wf1o chil chil
      cT wf cT unopf1o chil chil cT f1of syl cT cuo wcel vx cv vy cv csm co vz
      cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz
      chil wral vx vy cc chil cT cuo wcel vx cv cc wcel vy cv chil wcel wa vx
      cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT
      cfv cva co wceq vz chil wral cT cuo wcel vx cv cc wcel vy cv chil wcel wa
      wa vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv
      cT cfv cva co wceq vz chil cT cuo wcel vx cv cc wcel vy cv chil wcel wa
      wa vz cv chil wcel wa vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co
      vx cv vy cv cT cfv csm co vz cv cT cfv cva co vw cv csp co wceq vw chil
      wral vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz
      cv cT cfv cva co wceq cT cuo wcel vx cv cc wcel vy cv chil wcel wa wa vz
      cv chil wcel wa vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co vx cv
      vy cv cT cfv csm co vz cv cT cfv cva co vw cv csp co wceq vw chil cT cuo
      wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil
      wcel wa vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co vx cv vy cv
      csm co vz cv cva co vw cv cT ccnv cfv csp co vx cv vy cv vw cv cT ccnv
      cfv csp co cmul co vz cv vw cv cT ccnv cfv csp co caddc co vx cv vy cv cT
      cfv csm co vz cv cT cfv cva co vw cv csp co cT cuo wcel vx cv vy cv csm
      co vz cv cva co chil wcel vw cv chil wcel vx cv vy cv csm co vz cv cva co
      cT cfv vw cv csp co vx cv vy cv csm co vz cv cva co vw cv cT ccnv cfv csp
      co wceq cT cuo wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel
      wa vw cv chil wcel wa vx cv vy cv csm co vz cv cva co vw cv cT unopadj cT
      cuo wcel vx cv cc wcel vy cv chil wcel wa wa cT cuo wcel vz cv chil wcel
      vw cv chil wcel cT cuo wcel vx cv cc wcel vy cv chil wcel wa pm3.26
      ad2antrr cT cuo wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel
      wa vx cv vy cv csm co vz cv cva co chil wcel vw cv chil wcel vx cv cc
      wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv csm co vz cv cva co
      chil wcel cT cuo wcel vx cv vy cv csm co chil wcel vz cv chil wcel vx cv
      vy cv csm co vz cv cva co chil wcel vx cv cc wcel vy cv chil wcel wa vx
      cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl sylan adantll adantr cT
      cuo wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv
      chil wcel pm3.27 syl3anc vx cv cc wcel vy cv chil wcel vz cv chil wcel vw
      cv cT ccnv cfv chil wcel vx cv vy cv csm co vz cv cva co vw cv cT ccnv
      cfv csp co vx cv vy cv vw cv cT ccnv cfv csp co cmul co vz cv vw cv cT
      ccnv cfv csp co caddc co wceq cT cuo wcel vx cv cc wcel vy cv chil wcel
      wa wa vz cv chil wcel wa vw cv chil wcel wa vx cv vy cv vz cv vw cv cT
      ccnv cfv hiassdi cT cuo wcel vx cv cc wcel vy cv chil wcel wa wa vx cv cc
      wcel vz cv chil wcel vw cv chil wcel cT cuo wcel vx cv cc wcel vy cv chil
      wcel simprl ad2antrr cT cuo wcel vx cv cc wcel vy cv chil wcel wa wa vy
      cv chil wcel vz cv chil wcel vw cv chil wcel cT cuo wcel vx cv cc wcel vy
      cv chil wcel simprr ad2antrr cT cuo wcel vx cv cc wcel vy cv chil wcel wa
      wa vz cv chil wcel vw cv chil wcel simplr cT cuo wcel vz cv chil wcel vw
      cv chil wcel vw cv cT ccnv cfv chil wcel vx cv cc wcel vy cv chil wcel wa
      cT cuo wcel vw cv chil wcel vw cv cT ccnv cfv chil wcel vz cv chil wcel
      chil chil cT ccnv wf vw cv chil wcel vw cv cT ccnv cfv chil wcel cT cuo
      wcel chil chil vw cv cT ccnv ffvelrn cT cuo wcel cT ccnv cuo wcel chil
      chil cT ccnv wf1o chil chil cT ccnv wf cT cnvunop cT ccnv unopf1o chil
      chil cT ccnv f1of 3syl sylan adantlr adantllr syl2anc cT cuo wcel vx cv
      cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil wcel wa vx cv
      vy cv cT cfv csm co vz cv cT cfv cva co vw cv csp co vx cv vy cv cT cfv
      vw cv csp co cmul co vz cv cT cfv vw cv csp co caddc co vx cv vy cv vw cv
      cT ccnv cfv csp co cmul co vz cv vw cv cT ccnv cfv csp co caddc co vx cv
      cc wcel vy cv cT cfv chil wcel vz cv cT cfv chil wcel vw cv chil wcel vx
      cv vy cv cT cfv csm co vz cv cT cfv cva co vw cv csp co vx cv vy cv cT
      cfv vw cv csp co cmul co vz cv cT cfv vw cv csp co caddc co wceq cT cuo
      wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil
      wcel wa vx cv vy cv cT cfv vz cv cT cfv vw cv hiassdi cT cuo wcel vx cv
      cc wcel vy cv chil wcel wa wa vx cv cc wcel vz cv chil wcel vw cv chil
      wcel cT cuo wcel vx cv cc wcel vy cv chil wcel simprl ad2antrr cT cuo
      wcel vx cv cc wcel vy cv chil wcel wa wa vy cv cT cfv chil wcel vz cv
      chil wcel vw cv chil wcel cT cuo wcel vy cv chil wcel vy cv cT cfv chil
      wcel vx cv cc wcel chil chil cT wf vy cv chil wcel vy cv cT cfv chil wcel
      cT cuo wcel chil chil vy cv cT ffvelrn cT cuo wcel chil chil cT wf1o chil
      chil cT wf cT unopf1o chil chil cT f1of syl sylan adantrl ad2antrr cT cuo
      wcel vz cv chil wcel vw cv chil wcel vz cv cT cfv chil wcel vx cv cc wcel
      vy cv chil wcel wa cT cuo wcel vz cv chil wcel wa vz cv cT cfv chil wcel
      vw cv chil wcel chil chil cT wf vz cv chil wcel vz cv cT cfv chil wcel cT
      cuo wcel chil chil vz cv cT ffvelrn cT cuo wcel chil chil cT wf1o chil
      chil cT wf cT unopf1o chil chil cT f1of syl sylan adantr adantllr cT cuo
      wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil
      wcel pm3.27 syl2anc cT cuo wcel vx cv cc wcel vy cv chil wcel wa wa vz cv
      chil wcel wa vw cv chil wcel wa vx cv vy cv cT cfv vw cv csp co cmul co
      vx cv vy cv vw cv cT ccnv cfv csp co cmul co vz cv cT cfv vw cv csp co vz
      cv vw cv cT ccnv cfv csp co caddc cT cuo wcel vx cv cc wcel vy cv chil
      wcel wa wa vw cv chil wcel vx cv vy cv cT cfv vw cv csp co cmul co vx cv
      vy cv vw cv cT ccnv cfv csp co cmul co wceq vz cv chil wcel cT cuo wcel
      vy cv chil wcel vw cv chil wcel vx cv vy cv cT cfv vw cv csp co cmul co
      vx cv vy cv vw cv cT ccnv cfv csp co cmul co wceq vx cv cc wcel cT cuo
      wcel vy cv chil wcel wa vw cv chil wcel wa vy cv cT cfv vw cv csp co vy
      cv vw cv cT ccnv cfv csp co vx cv cmul cT cuo wcel vy cv chil wcel vw cv
      chil wcel vy cv cT cfv vw cv csp co vy cv vw cv cT ccnv cfv csp co wceq
      vy cv vw cv cT unopadj 3expa opreq2d adantlrl adantlr cT cuo wcel vz cv
      chil wcel vw cv chil wcel vz cv cT cfv vw cv csp co vz cv vw cv cT ccnv
      cfv csp co wceq vx cv cc wcel vy cv chil wcel wa cT cuo wcel vz cv chil
      wcel vw cv chil wcel vz cv cT cfv vw cv csp co vz cv vw cv cT ccnv cfv
      csp co wceq vz cv vw cv cT unopadj 3expa adantllr opreq12d eqtr2d 3eqtrd
      r19.21aiva chil chil cT wf vx cv cc wcel vy cv chil wcel wa vz cv chil
      wcel vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co vx cv vy cv cT
      cfv csm co vz cv cT cfv cva co vw cv csp co wceq vw chil wral vx cv vy cv
      csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co
      wceq wb cT cuo wcel vx cv vy cv csm co vz cv cva co cT cfv chil wcel vx
      cv vy cv cT cfv csm co vz cv cT cfv cva co chil wcel vx cv vy cv csm co
      vz cv cva co cT cfv vw cv csp co vx cv vy cv cT cfv csm co vz cv cT cfv
      cva co vw cv csp co wceq vw chil wral vx cv vy cv csm co vz cv cva co cT
      cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq wb chil chil cT wf
      vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw vx cv vy cv csm
      co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co
      hial2eq chil chil cT wf vx cv cc wcel vy cv chil wcel wa vz cv chil wcel
      vx cv vy cv csm co vz cv cva co cT cfv chil wcel chil chil cT wf vx cv vy
      cv csm co vz cv cva co chil wcel vx cv vy cv csm co vz cv cva co cT cfv
      chil wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa chil chil
      vx cv vy cv csm co vz cv cva co cT ffvelrn vx cv vy cv csm co chil wcel
      vz cv chil wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv cc wcel
      vy cv chil wcel wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl
      sylan sylan2 anassrs vx cv vy cv cT cfv csm co chil wcel vz cv cT cfv
      chil wcel vx cv vy cv cT cfv csm co vz cv cT cfv cva co chil wcel chil
      chil cT wf vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vx cv
      vy cv cT cfv csm co vz cv cT cfv hvaddcl chil chil cT wf vx cv cc wcel vy
      cv chil wcel wa wa vx cv vy cv cT cfv csm co chil wcel vz cv chil wcel vx
      cv cc wcel chil chil cT wf vy cv chil wcel vx cv vy cv cT cfv csm co chil
      wcel vx cv cc wcel vy cv cT cfv chil wcel vx cv vy cv cT cfv csm co chil
      wcel chil chil cT wf vy cv chil wcel wa vx cv vy cv cT cfv hvmulcl chil
      chil vy cv cT ffvelrn sylan2 an1s adantr chil chil cT wf vz cv chil wcel
      vz cv cT cfv chil wcel vx cv cc wcel vy cv chil wcel wa chil chil vz cv
      cT ffvelrn adantlr sylanc sylanc cT cuo wcel chil chil cT wf1o chil chil
      cT wf cT unopf1o chil chil cT f1of syl sylanl1 mpbid r19.21aiva ex
      r19.21aivv jca vx vy vz cT ellnop sylibr $.
      $( [4-Mar-2006] $) $( [22-Jan-2006] $)

    $( The composition of two unitary operators is unitary. $)
    counop $p |- ( ( S e. UniOp /\ T e. UniOp ) -> ( S o. T ) e. UniOp ) $=
      cS cuo wcel cT cuo wcel wa chil chil cS cT ccom wfo vx cv cS cT ccom cfv
      vy cv cS cT ccom cfv csp co vx cv vy cv csp co wceq vy chil wral vx chil
      wral wa cS cT ccom cuo wcel cS cuo wcel cT cuo wcel wa chil chil cS cT
      ccom wfo vx cv cS cT ccom cfv vy cv cS cT ccom cfv csp co vx cv vy cv csp
      co wceq vy chil wral vx chil wral cS cuo wcel cT cuo wcel wa chil chil cS
      cT ccom wf1o chil chil cS cT ccom wfo chil chil cS wf1o chil chil cT wf1o
      chil chil cS cT ccom wf1o cS cuo wcel cT cuo wcel chil chil chil cS cT
      f1oco cS unopf1o cT unopf1o syl2an chil chil cS cT ccom f1ofo syl cS cuo
      wcel cT cuo wcel wa vx cv cS cT ccom cfv vy cv cS cT ccom cfv csp co vx
      cv vy cv csp co wceq vx vy chil chil cS cuo wcel cT cuo wcel wa vx cv
      chil wcel vy cv chil wcel wa vx cv cS cT ccom cfv vy cv cS cT ccom cfv
      csp co vx cv vy cv csp co wceq cS cuo wcel cT cuo wcel wa vx cv chil wcel
      vy cv chil wcel wa wa vx cv cS cT ccom cfv vy cv cS cT ccom cfv csp co vx
      cv cT cfv cS cfv vy cv cT cfv cS cfv csp co vx cv cT cfv vy cv cT cfv csp
      co vx cv vy cv csp co cS cuo wcel cT cuo wcel wa vx cv chil wcel vy cv
      chil wcel wa wa vx cv cS cT ccom cfv vx cv cT cfv cS cfv vy cv cS cT ccom
      cfv vy cv cT cfv cS cfv csp cS wfun chil chil cT wf wa vx cv chil wcel vx
      cv cS cT ccom cfv vx cv cT cfv cS cfv wceq cS cuo wcel cT cuo wcel wa vx
      cv chil wcel vy cv chil wcel wa cS wfun chil chil cT wf vx cv chil wcel
      vx cv cS cT ccom cfv vx cv cT cfv cS cfv wceq chil chil vx cv cS cT fvco3
      3expa cS cuo wcel cS wfun cT cuo wcel chil chil cT wf cS cuo wcel chil
      chil cS wf1o cS wfun cS unopf1o chil chil cS f1ofun syl cT cuo wcel chil
      chil cT wf1o chil chil cT wf cT unopf1o chil chil cT f1of syl anim12i vx
      cv chil wcel vy cv chil wcel pm3.26 syl2an cS wfun chil chil cT wf wa vy
      cv chil wcel vy cv cS cT ccom cfv vy cv cT cfv cS cfv wceq cS cuo wcel cT
      cuo wcel wa vx cv chil wcel vy cv chil wcel wa cS wfun chil chil cT wf vy
      cv chil wcel vy cv cS cT ccom cfv vy cv cT cfv cS cfv wceq chil chil vy
      cv cS cT fvco3 3expa cS cuo wcel cS wfun cT cuo wcel chil chil cT wf cS
      cuo wcel chil chil cS wf1o cS wfun cS unopf1o chil chil cS f1ofun syl cT
      cuo wcel chil chil cT wf1o chil chil cT wf cT unopf1o chil chil cT f1of
      syl anim12i vx cv chil wcel vy cv chil wcel pm3.27 syl2an opreq12d cS cuo
      wcel cT cuo wcel vx cv chil wcel vy cv chil wcel wa vx cv cT cfv cS cfv
      vy cv cT cfv cS cfv csp co vx cv cT cfv vy cv cT cfv csp co wceq cS cuo
      wcel vx cv cT cfv chil wcel vy cv cT cfv chil wcel wa vx cv cT cfv cS cfv
      vy cv cT cfv cS cfv csp co vx cv cT cfv vy cv cT cfv csp co wceq cT cuo
      wcel vx cv chil wcel vy cv chil wcel wa wa cS cuo wcel vx cv cT cfv chil
      wcel vy cv cT cfv chil wcel vx cv cT cfv cS cfv vy cv cT cfv cS cfv csp
      co vx cv cT cfv vy cv cT cfv csp co wceq vx cv cT cfv vy cv cT cfv cS
      unop 3expb chil chil cT wf vx cv chil wcel vy cv chil wcel wa vx cv cT
      cfv chil wcel vy cv cT cfv chil wcel wa cT cuo wcel chil chil cT wf vx cv
      chil wcel vy cv chil wcel vx cv cT cfv chil wcel vy cv cT cfv chil wcel
      wa chil chil cT wf vx cv chil wcel wa vx cv cT cfv chil wcel chil chil cT
      wf vy cv chil wcel wa vy cv cT cfv chil wcel chil chil vx cv cT ffvelrn
      chil chil vy cv cT ffvelrn anim12i anandis cT cuo wcel chil chil cT wf1o
      chil chil cT wf cT unopf1o chil chil cT f1of syl sylan sylan2 anassrs cT
      cuo wcel vx cv chil wcel vy cv chil wcel wa vx cv cT cfv vy cv cT cfv csp
      co vx cv vy cv csp co wceq cS cuo wcel cT cuo wcel vx cv chil wcel vy cv
      chil wcel vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co wceq vx cv
      vy cv cT unop 3expb adantll 3eqtrd ex r19.21aivv jca vx vy cS cT ccom
      elunop sylibr $.
      $( [20-Oct-2006] $) $( [22-Jan-2006] $)

    $( Basic inner product property of a Hermitian operator. $)
    hmop $p |- ( ( T e. HrmOp /\ A e. ~H /\ B e. ~H ) ->
                ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) ) $=
      cT cho wcel cA chil wcel cB chil wcel w3a vx cv vy cv cT cfv csp co vx cv
      cT cfv vy cv csp co wceq vy chil wral vx chil wral cA cB cT cfv csp co cA
      cT cfv cB csp co wceq cT cho wcel cA chil wcel vx cv vy cv cT cfv csp co
      vx cv cT cfv vy cv csp co wceq vy chil wral vx chil wral cB chil wcel cT
      cho wcel chil chil cT wf vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp
      co wceq vy chil wral vx chil wral vx vy cT elhmop pm3.27bi 3ad2ant1 cA
      chil wcel cB chil wcel vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp
      co wceq vy chil wral vx chil wral cA cB cT cfv csp co cA cT cfv cB csp co
      wceq wi cT cho wcel vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp co
      wceq cA cB cT cfv csp co cA cT cfv cB csp co wceq cA vy cv cT cfv csp co
      cA cT cfv vy cv csp co wceq vx vy cA cB chil chil vx cv cA wceq vx cv vy
      cv cT cfv csp co cA vy cv cT cfv csp co vx cv cT cfv vy cv csp co cA cT
      cfv vy cv csp co vx cv cA vy cv cT cfv csp opreq1 vx cv cA wceq vx cv cT
      cfv cA cT cfv vy cv csp vx cv cA cT fveq2 opreq1d eqeq12d vy cv cB wceq
      cA vy cv cT cfv csp co cA cB cT cfv csp co cA cT cfv vy cv csp co cA cT
      cfv cB csp co vy cv cB wceq vy cv cT cfv cB cT cfv cA csp vy cv cB cT
      fveq2 opreq2d vy cv cB cA cT cfv csp opreq2 eqeq12d rcla42v 3adant1 mpd
      $.
      $( [27-May-2006] $) $( [19-Mar-2006] $)

    $( The inner product of the value and argument of a Hermitian operator is
       real. $)
    hmopre $p |- ( ( T e. HrmOp /\ A e. ~H ) -> ( ( T ` A ) .ih A ) e. RR ) $=
      cT cho wcel cA chil wcel wa cA cT cfv cA csp co cr wcel cA cT cfv cA csp
      co cA cA cT cfv csp co wceq cT cho wcel cA chil wcel wa cA cA cT cfv csp
      co cA cT cfv cA csp co cT cho wcel cA chil wcel cA cA cT cfv csp co cA cT
      cfv cA csp co wceq cA cA cT hmop 3anidm23 eqcomd cT cho wcel cA chil wcel
      cA cT cfv chil wcel cA cT cfv cA csp co cr wcel cA cT cfv cA csp co cA cA
      cT cfv csp co wceq wb chil chil cT wf cA chil wcel cA cT cfv chil wcel cT
      cho wcel chil chil cA cT ffvelrn cT hmopf sylan cA cT cfv cA hire
      sylancom mpbird $.
      $( [28-Jul-2006] $) $( [23-Jul-2006] $)

    $( A lower bound for a functional norm. $)
    nmfnlb $p |- ( ( T : ~H --> CC /\ A e. ~H /\ ( normh ` A ) <_ 1 ) ->
                  ( abs ` ( T ` A ) ) <_ ( normfn ` T ) ) $=
      chil cc cT wf cA chil wcel cA cno cfv c1 cle wbr w3a cA cT cfv cabs cfv
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex
      vx cab cxr clt csup cT cnmf cfv cle vy cv cno cfv c1 cle wbr vx cv vy cv
      cT cfv cabs cfv wceq wa vy chil wrex vx cab cxr wss cA cT cfv cabs cfv vy
      cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy chil wrex vx
      cab wcel cA cT cfv cabs cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cle wbr chil cc cT wf
      cA chil wcel cA cno cfv c1 cle wbr w3a vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cabs cfv wceq wa vy chil wrex vx cab cA cT cfv cabs cfv supxrub
      chil cc cT wf cA chil wcel vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv
      cabs cfv wceq wa vy chil wrex vx cab cxr wss cA cno cfv c1 cle wbr chil
      cc cT wf vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy
      chil wrex vx cab cr cxr vx vy cT nmfnsetre cr cxr wss chil cc cT wf
      ressxr a1i sstrd 3ad2ant1 cA chil wcel cA cno cfv c1 cle wbr cA cT cfv
      cabs cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv wceq wa vy
      chil wrex vx cab wcel chil cc cT wf cA chil wcel cA cno cfv c1 cle wbr wa
      vy cv cno cfv c1 cle wbr cA cT cfv cabs cfv vy cv cT cfv cabs cfv wceq wa
      vy chil wrex cA cT cfv cabs cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cabs cfv wceq wa vy chil wrex vx cab wcel vy cv cno cfv c1 cle wbr cA
      cT cfv cabs cfv vy cv cT cfv cabs cfv wceq wa cA cno cfv c1 cle wbr vy cA
      chil vy cv cA wceq vy cv cno cfv c1 cle wbr cA cT cfv cabs cfv vy cv cT
      cfv cabs cfv wceq wa cA cno cfv c1 cle wbr cA cT cfv cabs cfv cA cT cfv
      cabs cfv wceq wa cA cno cfv c1 cle wbr vy cv cA wceq vy cv cno cfv c1 cle
      wbr cA cno cfv c1 cle wbr cA cT cfv cabs cfv vy cv cT cfv cabs cfv wceq
      cA cT cfv cabs cfv cA cT cfv cabs cfv wceq vy cv cA wceq vy cv cno cfv cA
      cno cfv c1 cle vy cv cA cno fveq2 breq1d vy cv cA wceq vy cv cT cfv cabs
      cfv cA cT cfv cabs cfv cA cT cfv cabs cfv vy cv cA wceq vy cv cT cfv cA
      cT cfv cabs vy cv cA cT fveq2 fveq2d eqeq2d anbi12d cA cT cfv cabs cfv cA
      cT cfv cabs cfv wceq cA cno cfv c1 cle wbr cA cT cfv cabs cfv eqid
      biantru syl6bbr rcla4ev vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs
      cfv wceq wa vy chil wrex vy cv cno cfv c1 cle wbr cA cT cfv cabs cfv vy
      cv cT cfv cabs cfv wceq wa vy chil wrex vx cA cT cfv cabs cfv cA cT cfv
      cabs fvex vx cv cA cT cfv cabs cfv wceq vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cabs cfv wceq wa vy cv cno cfv c1 cle wbr cA cT cfv cabs cfv vy
      cv cT cfv cabs cfv wceq wa vy chil vx cv cA cT cfv cabs cfv wceq vx cv vy
      cv cT cfv cabs cfv wceq cA cT cfv cabs cfv vy cv cT cfv cabs cfv wceq vy
      cv cno cfv c1 cle wbr vx cv cA cT cfv cabs cfv vy cv cT cfv cabs cfv
      eqeq1 anbi2d rexbidv elab sylibr 3adant1 sylanc chil cc cT wf cA chil
      wcel cT cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cabs cfv
      wceq wa vy chil wrex vx cab cxr clt csup wceq cA cno cfv c1 cle wbr vx vy
      cT nmfnval 3ad2ant1 breqtrrd $.
      $( [9-Apr-2006] $) $( [14-Feb-2006] $)

    $( An upper bound for the norm of a functional. $)
    nmfnleub $p |- ( ( T : ~H --> CC /\ A e. RR* /\ A. x e. ~H ( ( normh ` x )
              <_ 1 -> ( abs ` ( T ` x ) ) <_ A ) ) -> ( normfn ` T ) <_ A ) $=
      chil cc cT wf cA cxr wcel vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv
      cA cle wbr wi vx chil wral w3a cT cnmf cfv vz cv cno cfv c1 cle wbr vy cv
      vz cv cT cfv cabs cfv wceq wa vz chil wrex vy cab cxr clt csup cA cle
      chil cc cT wf cA cxr wcel cT cnmf cfv vz cv cno cfv c1 cle wbr vy cv vz
      cv cT cfv cabs cfv wceq wa vz chil wrex vy cab cxr clt csup wceq vx cv
      cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral vy vz
      cT nmfnval 3ad2ant1 vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv
      wceq wa vz chil wrex vy cab cxr wss cA cxr wcel vw cv cA cle wbr vw vz cv
      cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv wceq wa vz chil wrex vy
      cab wral vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv wceq wa vz
      chil wrex vy cab cxr clt csup cA cle wbr chil cc cT wf cA cxr wcel vx cv
      cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral w3a
      vw vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv wceq wa vz chil
      wrex vy cab cA supxrleub chil cc cT wf cA cxr wcel vz cv cno cfv c1 cle
      wbr vy cv vz cv cT cfv cabs cfv wceq wa vz chil wrex vy cab cxr wss vx cv
      cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral chil
      cc cT wf vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv wceq wa vz
      chil wrex vy cab cr cxr vy vz cT nmfnsetre cr cxr wss chil cc cT wf
      ressxr a1i sstrd 3ad2ant1 chil cc cT wf cA cxr wcel vx cv cno cfv c1 cle
      wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral 3simp2 vx cv cno cfv
      c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral chil cc cT wf
      vw cv cA cle wbr vw vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv
      wceq wa vz chil wrex vy cab wral cA cxr wcel vx cv cno cfv c1 cle wbr vx
      cv cT cfv cabs cfv cA cle wbr wi vx chil wral vw cv cA cle wbr vw vz cv
      cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv wceq wa vz chil wrex vy
      cab vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil
      wral vz cv cno cfv c1 cle wbr vw cv vz cv cT cfv cabs cfv wceq wa vz chil
      wrex vw cv cA cle wbr vw cv vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv
      cabs cfv wceq wa vz chil wrex vy cab wcel vx cv cno cfv c1 cle wbr vx cv
      cT cfv cabs cfv cA cle wbr wi vx chil wral vz cv cno cfv c1 cle wbr vw cv
      vz cv cT cfv cabs cfv wceq wa vw cv cA cle wbr vz chil vx cv cno cfv c1
      cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral vz cv chil wcel
      vz cv cno cfv c1 cle wbr vw cv vz cv cT cfv cabs cfv wceq vw cv cA cle
      wbr vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil
      wral vz cv chil wcel vz cv cno cfv c1 cle wbr vz cv cT cfv cabs cfv cA
      cle wbr vw cv vz cv cT cfv cabs cfv wceq vw cv cA cle wbr wi vx cv cno
      cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vz cv cno cfv c1 cle
      wbr vz cv cT cfv cabs cfv cA cle wbr wi vx vz cv chil vx cv vz cv wceq vx
      cv cno cfv c1 cle wbr vz cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA
      cle wbr vz cv cT cfv cabs cfv cA cle wbr vx cv vz cv wceq vx cv cno cfv
      vz cv cno cfv c1 cle vx cv vz cv cno fveq2 breq1d vx cv vz cv wceq vx cv
      cT cfv cabs cfv vz cv cT cfv cabs cfv cA cle vx cv vz cv wceq vx cv cT
      cfv vz cv cT cfv cabs vx cv vz cv cT fveq2 fveq2d breq1d imbi12d rcla4cv
      vw cv vz cv cT cfv cabs cfv wceq vw cv cA cle wbr vz cv cT cfv cabs cfv
      cA cle wbr vw cv vz cv cT cfv cabs cfv cA cle breq1 biimprcd syl8 imp4a
      r19.23adv vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cabs cfv wceq wa vz
      chil wrex vz cv cno cfv c1 cle wbr vw cv vz cv cT cfv cabs cfv wceq wa vz
      chil wrex vy vw cv vw visset vy cv vw cv wceq vz cv cno cfv c1 cle wbr vy
      cv vz cv cT cfv cabs cfv wceq wa vz cv cno cfv c1 cle wbr vw cv vz cv cT
      cfv cabs cfv wceq wa vz chil vy cv vw cv wceq vy cv vz cv cT cfv cabs cfv
      wceq vw cv vz cv cT cfv cabs cfv wceq vz cv cno cfv c1 cle wbr vy cv vw
      cv vz cv cT cfv cabs cfv eqeq1 anbi2d rexbidv elab syl5ib r19.21aiv
      3ad2ant3 syl3anc eqbrtrd $.
      $( [28-Jun-2006] $) $( [24-May-2006] $)

    $( An upper bound for the norm of a functional. $)
    nmfnleub2 $p |- ( ( T : ~H --> CC /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. ~H
    ( abs ` ( T ` x ) ) <_ ( A x. ( normh ` x ) ) ) -> ( normfn ` T ) <_ A ) $=
      chil cc cT wf cA cr wcel cc0 cA cle wbr wa vx cv cT cfv cabs cfv cA vx cv
      cno cfv cmul co cle wbr vx chil wral cT cnmf cfv cA cle wbr chil cc cT wf
      cA cr wcel cc0 cA cle wbr wa wa vx cv cT cfv cabs cfv cA vx cv cno cfv
      cmul co cle wbr vx chil wral vx cv cno cfv c1 cle wbr vx cv cT cfv cabs
      cfv cA cle wbr wi vx chil wral cT cnmf cfv cA cle wbr chil cc cT wf cA cr
      wcel cc0 cA cle wbr wa wa vx cv cT cfv cabs cfv cA vx cv cno cfv cmul co
      cle wbr vx chil wral vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA
      cle wbr wi vx chil wral chil cc cT wf cA cr wcel cc0 cA cle wbr wa wa vx
      cv cT cfv cabs cfv cA vx cv cno cfv cmul co cle wbr vx cv cno cfv c1 cle
      wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil chil cc cT wf cA cr wcel
      cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cno cfv c1 cle wbr vx cv cT
      cfv cabs cfv cA vx cv cno cfv cmul co cle wbr vx cv cT cfv cabs cfv cA
      cle wbr chil cc cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil wcel wa
      vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA vx cv cno cfv cmul co
      cle wbr vx cv cT cfv cabs cfv cA cle wbr wi chil cc cT wf cA cr wcel cc0
      cA cle wbr wa wa vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cT
      cfv cabs cfv cA vx cv cno cfv cmul co cle wbr cA vx cv cno cfv cmul co cA
      cle wbr vx cv cT cfv cabs cfv cA cle wbr chil cc cT wf cA cr wcel cc0 cA
      cle wbr wa wa vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa cA vx cv cno
      cfv cmul co cA c1 cmul co cA cle vx cv cno cfv cr wcel cA cr wcel wa cc0
      cA cle wbr vx cv cno cfv c1 cle wbr wa cA vx cv cno cfv cmul co cA c1
      cmul co cle wbr chil cc cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil
      wcel wa vx cv cno cfv c1 cle wbr wa vx cv cno cfv cr wcel c1 cr wcel cA
      cr wcel cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa cA vx cv cno cfv cmul
      co cA c1 cmul co cle wbr 1re vx cv cno cfv c1 cA lemul2aOLD mp3anl2 chil
      cc cT wf cA cr wcel cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cno cfv
      cr wcel cA cr wcel wa vx cv cno cfv c1 cle wbr cA cr wcel cc0 cA cle wbr
      wa vx cv chil wcel vx cv cno cfv cr wcel cA cr wcel wa chil cc cT wf cA
      cr wcel vx cv chil wcel vx cv cno cfv cr wcel cA cr wcel wa cc0 cA cle
      wbr vx cv chil wcel cA cr wcel vx cv cno cfv cr wcel cA cr wcel wa vx cv
      chil wcel vx cv cno cfv cr wcel cA cr wcel vx cv normcl anim1i ancoms
      adantlr adantll adantr chil cc cT wf cA cr wcel cc0 cA cle wbr wa wa vx
      cv cno cfv c1 cle wbr cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa vx cv
      chil wcel cA cr wcel cc0 cA cle wbr wa vx cv cno cfv c1 cle wbr cc0 cA
      cle wbr vx cv cno cfv c1 cle wbr wa chil cc cT wf cc0 cA cle wbr vx cv
      cno cfv c1 cle wbr cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa cA cr wcel
      cc0 cA cle wbr vx cv cno cfv c1 cle wbr wa id adantll adantll adantlr
      sylanc chil cc cT wf cA cr wcel cc0 cA cle wbr wa wa cA c1 cmul co cA
      wceq vx cv chil wcel vx cv cno cfv c1 cle wbr cA cr wcel cA c1 cmul co cA
      wceq chil cc cT wf cc0 cA cle wbr cA cr wcel cA cc wcel cA c1 cmul co cA
      wceq cA recn cA ax1id syl ad2antrl ad2antrr breqtrd chil cc cT wf cA cr
      wcel cc0 cA cle wbr wa wa vx cv chil wcel wa vx cv cT cfv cabs cfv cA vx
      cv cno cfv cmul co cle wbr cA vx cv cno cfv cmul co cA cle wbr wa vx cv
      cT cfv cabs cfv cA cle wbr wi vx cv cno cfv c1 cle wbr vx cv cT cfv cabs
      cfv cr wcel cA vx cv cno cfv cmul co cr wcel cA cr wcel vx cv cT cfv cabs
      cfv cA vx cv cno cfv cmul co cle wbr cA vx cv cno cfv cmul co cA cle wbr
      wa vx cv cT cfv cabs cfv cA cle wbr wi chil cc cT wf cA cr wcel cc0 cA
      cle wbr wa wa vx cv chil wcel wa vx cv cT cfv cabs cfv cA vx cv cno cfv
      cmul co cA letr chil cc cT wf vx cv chil wcel vx cv cT cfv cabs cfv cr
      wcel cA cr wcel cc0 cA cle wbr wa chil cc cT wf vx cv chil wcel wa vx cv
      cT cfv cc wcel vx cv cT cfv cabs cfv cr wcel chil cc vx cv cT ffvelrn vx
      cv cT cfv abscl syl adantlr cA cr wcel cc0 cA cle wbr wa vx cv chil wcel
      cA vx cv cno cfv cmul co cr wcel chil cc cT wf cA cr wcel vx cv chil wcel
      cA vx cv cno cfv cmul co cr wcel cc0 cA cle wbr cA cr wcel vx cv cno cfv
      cr wcel cA vx cv cno cfv cmul co cr wcel vx cv chil wcel cA vx cv cno cfv
      remulcl vx cv normcl sylan2 adantlr adantll cA cr wcel cc0 cA cle wbr wa
      cA cr wcel chil cc cT wf vx cv chil wcel cA cr wcel cc0 cA cle wbr pm3.26
      ad2antlr syl3anc adantr mpan2d ex com23 r19.20dva imp chil cc cT wf cA cr
      wcel cc0 cA cle wbr wa vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA
      cle wbr wi vx chil wral cT cnmf cfv cA cle wbr chil cc cT wf cA cxr wcel
      vx cv cno cfv c1 cle wbr vx cv cT cfv cabs cfv cA cle wbr wi vx chil wral
      cT cnmf cfv cA cle wbr cA cr wcel cc0 cA cle wbr wa vx cA cT nmfnleub cA
      cr wcel cA cxr wcel cc0 cA cle wbr cA rexr adantr syl3an2 3expa syldan
      3impa $.
      $( [22-Oct-2006] $) $( [24-May-2006] $)

    $( The norm of any Hilbert space functional is nonnegative. $)
    nmfnge0 $p |- ( T : ~H --> CC -> 0 <_ ( normfn ` T ) ) $=
      chil cc cT wf cc0 c0v cT cfv cabs cfv cle wbr c0v cT cfv cabs cfv cT cnmf
      cfv cle wbr cc0 cT cnmf cfv cle wbr chil cc cT wf c0v cT cfv cc wcel cc0
      c0v cT cfv cabs cfv cle wbr chil cc cT wf c0v chil wcel c0v cT cfv cc
      wcel ax-hv0cl chil cc c0v cT ffvelrn mpan2 c0v cT cfv absge0 syl chil cc
      cT wf c0v chil wcel c0v cno cfv c1 cle wbr c0v cT cfv cabs cfv cT cnmf
      cfv cle wbr ax-hv0cl c0v cno cfv cc0 c1 cle norm0 cc0 c1 0re 1re lt01
      ltleii eqbrtri c0v cT nmfnlb mp3an23 c0v cT cfv cabs cfv cxr wcel cT cnmf
      cfv cxr wcel cc0 c0v cT cfv cabs cfv cle wbr c0v cT cfv cabs cfv cT cnmf
      cfv cle wbr wa cc0 cT cnmf cfv cle wbr wi chil cc cT wf cc0 cxr wcel c0v
      cT cfv cabs cfv cxr wcel cT cnmf cfv cxr wcel cc0 c0v cT cfv cabs cfv cle
      wbr c0v cT cfv cabs cfv cT cnmf cfv cle wbr wa cc0 cT cnmf cfv cle wbr wi
      cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cc0 c0v cT cfv cabs cfv cT
      cnmf cfv xrletr mp3an1 chil cc cT wf c0v cT cfv cc wcel c0v cT cfv cabs
      cfv cr wcel c0v cT cfv cabs cfv cxr wcel chil cc cT wf c0v chil wcel c0v
      cT cfv cc wcel ax-hv0cl chil cc c0v cT ffvelrn mpan2 c0v cT cfv abscl c0v
      cT cfv cabs cfv rexr 3syl cT nmfnxr sylanc mp2and $.
      $( [23-Oct-2006] $) $( [24-May-2006] $)

    $( Membership in the null space of a Hilbert space functional. $)
    elnlfn $p |- ( ( T : ~H --> CC /\ A e. ~H ) ->
                  ( A e. ( null ` T ) <-> ( T ` A ) = 0 ) ) $=
      chil cc cT wf cA cT cnl cfv wcel cA chil wcel cA cT cfv cc0 wceq wa cA
      chil wcel cA cT cfv cc0 wceq chil cc cT wf cA cT cnl cfv wcel cA vx cv cT
      cfv cc0 wceq vx chil crab wcel cA chil wcel cA cT cfv cc0 wceq wa chil cc
      cT wf cT cnl cfv vx cv cT cfv cc0 wceq vx chil crab cA vx cT nlfnval
      eleq2d vx cv cT cfv cc0 wceq cA cT cfv cc0 wceq vx cA chil vx cv cA wceq
      vx cv cT cfv cA cT cfv cc0 vx cv cA cT fveq2 eqeq1d elrab syl6bb cA chil
      wcel cA cT cfv cc0 wceq cA chil wcel cA cT cfv cc0 wceq wa cA chil wcel
      cA cT cfv cc0 wceq ibar bicomd sylan9bb $.
      $( [9-Apr-2006] $) $( [11-Feb-2006] $)

    $( Membership in the null space of a Hilbert space functional. $)
    elnlfn2 $p |- ( ( T : ~H --> CC /\ A e. ( null ` T ) ) ->
                   ( T ` A ) = 0 ) $=
      chil cc cT wf cA cT cnl cfv wcel wa cA cT cnl cfv wcel cA cT cfv cc0 wceq
      chil cc cT wf cA cT cnl cfv wcel pm3.27 chil cc cT wf cA cT cnl cfv wcel
      cA chil wcel cA cT cnl cfv wcel cA cT cfv cc0 wceq wb chil cc cT wf cA cT
      cnl cfv wcel cA chil wcel chil cc cT wf cT cnl cfv chil cA chil cc cT wf
      cT cnl cfv vx cv cT cfv cc0 wceq vx chil crab chil vx cT nlfnval vx cv cT
      cfv cc0 wceq vx chil crab chil wss chil cc cT wf vx cv cT cfv cc0 wceq vx
      chil ssrab2 a1i eqsstrd sseld imp cA cT elnlfn syldan mpbid $.
      $( [11-Apr-2006] $) $( [11-Feb-2006] $)

    $( Basic continuity property of a continuous functional. $)
    cnfnc $p |- ( ( ( T e. ConFn /\ A e. ~H ) /\ ( B e. RR /\ 0 < B ) ) ->
               E. x e. RR ( 0 < x /\ A. y e. ~H ( ( normh ` ( y -h A ) ) < x ->
               ( abs ` ( ( T ` y ) - ( T ` A ) ) ) < B ) ) ) $=
      cT ccnf wcel cA chil wcel cB cr wcel cc0 cB clt wbr cc0 vx cv clt wbr vy
      cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs
      cfv cB clt wbr wi vy chil wral wa vx cr wrex cT ccnf wcel cc0 vw cv clt
      wbr cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT
      cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vy chil wral wa vx cr
      wrex wi vw cr wral vz chil wral cA chil wcel cB cr wcel cc0 cB clt wbr
      cc0 vx cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA
      cT cfv cmin co cabs cfv cB clt wbr wi vy chil wral wa vx cr wrex wi wi wi
      cT ccnf wcel chil cc cT wf cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv vz
      cv cmv co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmin co cabs
      cfv vw cv clt wbr wi vy chil wral wa vx cr wrex wi vw cr wral vz chil
      wral vz vw vx vy cT elcnfn pm3.27bi cc0 vw cv clt wbr cc0 vx cv clt wbr
      vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmin
      co cabs cfv vw cv clt wbr wi vy chil wral wa vx cr wrex wi vw cr wral vz
      chil wral cA chil wcel cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv cA cmv
      co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv vw cv
      clt wbr wi vy chil wral wa vx cr wrex wi vw cr wral cB cr wcel cc0 cB clt
      wbr cc0 vx cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv
      cA cT cfv cmin co cabs cfv cB clt wbr wi vy chil wral wa vx cr wrex wi wi
      cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt
      wbr vy cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vy chil
      wral wa vx cr wrex wi vw cr wral cc0 vw cv clt wbr cc0 vx cv clt wbr vy
      cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs
      cfv vw cv clt wbr wi vy chil wral wa vx cr wrex wi vw cr wral vz cA chil
      vz cv cA wceq cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv vz cv cmv co cno
      cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt
      wbr wi vy chil wral wa vx cr wrex wi cc0 vw cv clt wbr cc0 vx cv clt wbr
      vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs
      cfv vw cv clt wbr wi vy chil wral wa vx cr wrex wi vw cr vz cv cA wceq
      cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv
      vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vy chil wral wa vx cr wrex
      cc0 vx cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA
      cT cfv cmin co cabs cfv vw cv clt wbr wi vy chil wral wa vx cr wrex cc0
      vw cv clt wbr vz cv cA wceq cc0 vx cv clt wbr vy cv vz cv cmv co cno cfv
      vx cv clt wbr vy cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi
      vy chil wral wa cc0 vx cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr
      vy cv cT cfv cA cT cfv cmin co cabs cfv vw cv clt wbr wi vy chil wral wa
      vx cr vz cv cA wceq vy cv vz cv cmv co cno cfv vx cv clt wbr vy cv cT cfv
      vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vy chil wral vy cv cA cmv
      co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv vw cv
      clt wbr wi vy chil wral cc0 vx cv clt wbr vz cv cA wceq vy cv vz cv cmv
      co cno cfv vx cv clt wbr vy cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv
      clt wbr wi vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv
      cmin co cabs cfv vw cv clt wbr wi vy chil vz cv cA wceq vy cv vz cv cmv
      co cno cfv vx cv clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT
      cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr vy cv cT cfv cA cT cfv
      cmin co cabs cfv vw cv clt wbr vz cv cA wceq vy cv vz cv cmv co cno cfv
      vy cv cA cmv co cno cfv vx cv clt vz cv cA wceq vy cv vz cv cmv co vy cv
      cA cmv co cno vz cv cA vy cv cmv opreq2 fveq2d breq1d vz cv cA wceq vy cv
      cT cfv vz cv cT cfv cmin co cabs cfv vy cv cT cfv cA cT cfv cmin co cabs
      cfv vw cv clt vz cv cA wceq vy cv cT cfv vz cv cT cfv cmin co vy cv cT
      cfv cA cT cfv cmin co cabs vz cv cA wceq vz cv cT cfv cA cT cfv vy cv cT
      cfv cmin vz cv cA cT fveq2 opreq2d fveq2d breq1d imbi12d ralbidv anbi2d
      rexbidv imbi2d ralbidv rcla4cv cc0 vw cv clt wbr cc0 vx cv clt wbr vy cv
      cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv
      vw cv clt wbr wi vy chil wral wa vx cr wrex wi cc0 cB clt wbr cc0 vx cv
      clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin
      co cabs cfv cB clt wbr wi vy chil wral wa vx cr wrex wi vw cB cr vw cv cB
      wceq cc0 vw cv clt wbr cc0 cB clt wbr cc0 vx cv clt wbr vy cv cA cmv co
      cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv vw cv clt
      wbr wi vy chil wral wa vx cr wrex cc0 vx cv clt wbr vy cv cA cmv co cno
      cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv cB clt wbr wi
      vy chil wral wa vx cr wrex vw cv cB cc0 clt breq2 vw cv cB wceq cc0 vx cv
      clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin
      co cabs cfv vw cv clt wbr wi vy chil wral wa cc0 vx cv clt wbr vy cv cA
      cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv cB
      clt wbr wi vy chil wral wa vx cr vw cv cB wceq vy cv cA cmv co cno cfv vx
      cv clt wbr vy cv cT cfv cA cT cfv cmin co cabs cfv vw cv clt wbr wi vy
      chil wral vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv
      cmin co cabs cfv cB clt wbr wi vy chil wral cc0 vx cv clt wbr vw cv cB
      wceq vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT cfv cA cT cfv cmin co
      cabs cfv vw cv clt wbr wi vy cv cA cmv co cno cfv vx cv clt wbr vy cv cT
      cfv cA cT cfv cmin co cabs cfv cB clt wbr wi vy chil vw cv cB wceq vy cv
      cT cfv cA cT cfv cmin co cabs cfv vw cv clt wbr vy cv cT cfv cA cT cfv
      cmin co cabs cfv cB clt wbr vy cv cA cmv co cno cfv vx cv clt wbr vw cv
      cB vy cv cT cfv cA cT cfv cmin co cabs cfv clt breq2 imbi2d ralbidv
      anbi2d rexbidv imbi12d rcla4cv syl6 syl imp43 $.
      $( [9-Apr-2006] $) $( [11-Feb-2006] $)

    $( Basic linearity property of a linear functional. $)
    lnfnl $p |- ( ( ( T e. LinFn /\ A e. CC ) /\ ( B e. ~H /\ C e. ~H ) ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A x. ( T ` B ) ) + ( T ` C ) ) ) $=
      cT clf wcel cA cc wcel cB chil wcel cC chil wcel wa cA cB csm co cC cva
      co cT cfv cA cB cT cfv cmul co cC cT cfv caddc co wceq cA cc wcel cB chil
      wcel cC chil wcel wa wa cT clf wcel cA cB csm co cC cva co cT cfv cA cB
      cT cfv cmul co cC cT cfv caddc co wceq cA cc wcel cB chil wcel cC chil
      wcel cT clf wcel cA cB csm co cC cva co cT cfv cA cB cT cfv cmul co cC cT
      cfv caddc co wceq wi cA cc wcel cB chil wcel cC chil wcel w3a vx cv vy cv
      csm co vz cv cva co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv caddc
      co wceq vz chil wral vy chil wral vx cc wral cA cB csm co cC cva co cT
      cfv cA cB cT cfv cmul co cC cT cfv caddc co wceq cT clf wcel vx cv vy cv
      csm co vz cv cva co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv caddc
      co wceq cA cB csm co cC cva co cT cfv cA cB cT cfv cmul co cC cT cfv
      caddc co wceq cA vy cv csm co vz cv cva co cT cfv cA vy cv cT cfv cmul co
      vz cv cT cfv caddc co wceq cA cB csm co vz cv cva co cT cfv cA cB cT cfv
      cmul co vz cv cT cfv caddc co wceq vx vy vz cA cB cC cc chil chil vx cv
      cA wceq vx cv vy cv csm co vz cv cva co cT cfv cA vy cv csm co vz cv cva
      co cT cfv vx cv vy cv cT cfv cmul co vz cv cT cfv caddc co cA vy cv cT
      cfv cmul co vz cv cT cfv caddc co vx cv cA wceq vx cv vy cv csm co vz cv
      cva co cA vy cv csm co vz cv cva co cT vx cv cA wceq vx cv vy cv csm co
      cA vy cv csm co vz cv cva vx cv cA vy cv csm opreq1 opreq1d fveq2d vx cv
      cA wceq vx cv vy cv cT cfv cmul co cA vy cv cT cfv cmul co vz cv cT cfv
      caddc vx cv cA vy cv cT cfv cmul opreq1 opreq1d eqeq12d vy cv cB wceq cA
      vy cv csm co vz cv cva co cT cfv cA cB csm co vz cv cva co cT cfv cA vy
      cv cT cfv cmul co vz cv cT cfv caddc co cA cB cT cfv cmul co vz cv cT cfv
      caddc co vy cv cB wceq cA vy cv csm co vz cv cva co cA cB csm co vz cv
      cva co cT vy cv cB wceq cA vy cv csm co cA cB csm co vz cv cva vy cv cB
      cA csm opreq2 opreq1d fveq2d vy cv cB wceq cA vy cv cT cfv cmul co cA cB
      cT cfv cmul co vz cv cT cfv caddc vy cv cB wceq vy cv cT cfv cB cT cfv cA
      cmul vy cv cB cT fveq2 opreq2d opreq1d eqeq12d vz cv cC wceq cA cB csm co
      vz cv cva co cT cfv cA cB csm co cC cva co cT cfv cA cB cT cfv cmul co vz
      cv cT cfv caddc co cA cB cT cfv cmul co cC cT cfv caddc co vz cv cC wceq
      cA cB csm co vz cv cva co cA cB csm co cC cva co cT vz cv cC cA cB csm co
      cva opreq2 fveq2d vz cv cC wceq vz cv cT cfv cC cT cfv cA cB cT cfv cmul
      co caddc vz cv cC cT fveq2 opreq2d eqeq12d rcla43v cT clf wcel chil cc cT
      wf vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv cmul co vz
      cv cT cfv caddc co wceq vz chil wral vy chil wral vx cc wral vx vy vz cT
      ellnfn pm3.27bi syl5 3expb impcom anassrs $.
      $( [9-Apr-2006] $) $( [11-Feb-2006] $)

    $( Closure of the adjoint of a Hilbert space operator. $)
    adjcl $p |- ( ( T e. dom adjh /\ A e. ~H ) ->
                 ( ( adjh ` T ) ` A ) e. ~H ) $=
      chil chil cT cado cfv wf cA chil wcel cA cT cado cfv cfv chil wcel cT
      cado cdm wcel chil chil cA cT cado cfv ffvelrn cT cado cdm wcel cT cado
      cfv cado cdm wcel chil chil cT cado cfv wf cT dmadjrn cT cado cfv dmadjop
      syl sylan $.
      $( [20-Jun-2006] $) $( [17-Jun-2006] $)

    $( Property of an adjoint Hilbert space operator. $)
    adj1 $p |- ( ( T e. dom adjh /\ A e. ~H /\ B e. ~H ) ->
               ( A .ih ( T ` B ) ) = ( ( ( adjh ` T ) ` A ) .ih B ) ) $=
      cT cado cdm wcel cA chil wcel cB chil wcel cA cB cT cfv csp co cA cT cado
      cfv cfv cB csp co wceq cA chil wcel cB chil wcel wa vx cv vy cv cT cfv
      csp co vx cv cT cado cfv cfv vy cv csp co wceq vy chil wral vx chil wral
      cA cB cT cfv csp co cA cT cado cfv cfv cB csp co wceq cT cado cdm wcel vx
      cv vy cv cT cfv csp co vx cv cT cado cfv cfv vy cv csp co wceq cA cB cT
      cfv csp co cA cT cado cfv cfv cB csp co wceq cA vy cv cT cfv csp co cA cT
      cado cfv cfv vy cv csp co wceq vx vy cA cB chil chil vx cv cA wceq vx cv
      vy cv cT cfv csp co cA vy cv cT cfv csp co vx cv cT cado cfv cfv vy cv
      csp co cA cT cado cfv cfv vy cv csp co vx cv cA vy cv cT cfv csp opreq1
      vx cv cA wceq vx cv cT cado cfv cfv cA cT cado cfv cfv vy cv csp vx cv cA
      cT cado cfv fveq2 opreq1d eqeq12d vy cv cB wceq cA vy cv cT cfv csp co cA
      cB cT cfv csp co cA cT cado cfv cfv vy cv csp co cA cT cado cfv cfv cB
      csp co vy cv cB wceq vy cv cT cfv cB cT cfv cA csp vy cv cB cT fveq2
      opreq2d vy cv cB cA cT cado cfv cfv csp opreq2 eqeq12d rcla42v cT cado
      cdm wcel chil chil cT wf chil chil cT cado cfv wf vx cv vy cv cT cfv csp
      co vx cv cT cado cfv cfv vy cv csp co wceq vy chil wral vx chil wral cT
      cado cdm wcel cT cT cado cfv cop chil chil vz cv wf chil chil vw cv wf vx
      cv vy cv vz cv cfv csp co vx cv vw cv cfv vy cv csp co wceq vy chil wral
      vx chil wral w3a vz vw copab wcel chil chil cT wf chil chil cT cado cfv
      wf vx cv vy cv cT cfv csp co vx cv cT cado cfv cfv vy cv csp co wceq vy
      chil wral vx chil wral w3a cT cado cdm wcel cT cT cado cfv cop cado chil
      chil vz cv wf chil chil vw cv wf vx cv vy cv vz cv cfv csp co vx cv vw cv
      cfv vy cv csp co wceq vy chil wral vx chil wral w3a vz vw copab cado wfun
      cT cado cdm wcel cT cT cado cfv cop cado wcel funadj cT cado funfvop mpan
      vx vy vw vz dfadj2 syl6eleq cT cado cdm wcel cT cado cfv cvv wcel cT cT
      cado cfv cop chil chil vz cv wf chil chil vw cv wf vx cv vy cv vz cv cfv
      csp co vx cv vw cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a vz
      vw copab wcel chil chil cT wf chil chil cT cado cfv wf vx cv vy cv cT cfv
      csp co vx cv cT cado cfv cfv vy cv csp co wceq vy chil wral vx chil wral
      w3a wb cT cado fvex chil chil vz cv wf chil chil vw cv wf vx cv vy cv vz
      cv cfv csp co vx cv vw cv cfv vy cv csp co wceq vy chil wral vx chil wral
      w3a chil chil cT wf chil chil vw cv wf vx cv vy cv cT cfv csp co vx cv vw
      cv cfv vy cv csp co wceq vy chil wral vx chil wral w3a chil chil cT wf
      chil chil cT cado cfv wf vx cv vy cv cT cfv csp co vx cv cT cado cfv cfv
      vy cv csp co wceq vy chil wral vx chil wral w3a vz vw cT cT cado cfv cado
      cdm cvv vz cv cT wceq chil chil vz cv wf chil chil cT wf vx cv vy cv vz
      cv cfv csp co vx cv vw cv cfv vy cv csp co wceq vy chil wral vx chil wral
      vx cv vy cv cT cfv csp co vx cv vw cv cfv vy cv csp co wceq vy chil wral
      vx chil wral chil chil vw cv wf chil chil vz cv cT feq1 vz cv cT wceq vx
      cv vy cv vz cv cfv csp co vx cv vw cv cfv vy cv csp co wceq vx cv vy cv
      cT cfv csp co vx cv vw cv cfv vy cv csp co wceq vx vy chil chil vz cv cT
      wceq vx cv vy cv vz cv cfv csp co vx cv vy cv cT cfv csp co vx cv vw cv
      cfv vy cv csp co vz cv cT wceq vy cv vz cv cfv vy cv cT cfv vx cv csp vy
      cv vz cv cT fveq1 opreq2d eqeq1d 2ralbidv 3anbi13d vw cv cT cado cfv wceq
      chil chil vw cv wf chil chil cT cado cfv wf vx cv vy cv cT cfv csp co vx
      cv vw cv cfv vy cv csp co wceq vy chil wral vx chil wral vx cv vy cv cT
      cfv csp co vx cv cT cado cfv cfv vy cv csp co wceq vy chil wral vx chil
      wral chil chil cT wf chil chil vw cv cT cado cfv feq1 vw cv cT cado cfv
      wceq vx cv vy cv cT cfv csp co vx cv vw cv cfv vy cv csp co wceq vx cv vy
      cv cT cfv csp co vx cv cT cado cfv cfv vy cv csp co wceq vx vy chil chil
      vw cv cT cado cfv wceq vx cv vw cv cfv vy cv csp co vx cv cT cado cfv cfv
      vy cv csp co vx cv vy cv cT cfv csp co vw cv cT cado cfv wceq vx cv vw cv
      cfv vx cv cT cado cfv cfv vy cv csp vx cv vw cv cT cado cfv fveq1 opreq1d
      eqeq2d 2ralbidv 3anbi23d opelopabg mpan2 mpbid 3simp3d syl5com 3impib $.
      $( [9-Apr-2006] $) $( [15-Feb-2006] $)

    $( Property of an adjoint Hilbert space operator. $)
    adj2 $p |- ( ( T e. dom adjh /\ A e. ~H /\ B e. ~H ) ->
                ( ( T ` A ) .ih B ) = ( A .ih ( ( adjh ` T ) ` B ) ) ) $=
      cT cado cdm wcel cB chil wcel cA chil wcel cA cT cfv cB csp co cA cB cT
      cado cfv cfv csp co wceq cT cado cdm wcel cB chil wcel cA chil wcel w3a
      cA cT cfv cB csp co ccj cfv cA cB cT cado cfv cfv csp co ccj cfv wceq cA
      cT cfv cB csp co cA cB cT cado cfv cfv csp co wceq cT cado cdm wcel cB
      chil wcel cA chil wcel w3a cB cA cT cfv csp co cB cT cado cfv cfv cA csp
      co cA cT cfv cB csp co ccj cfv cA cB cT cado cfv cfv csp co ccj cfv cB cA
      cT adj1 cB chil wcel cA cT cfv chil wcel cB cA cT cfv csp co cA cT cfv cB
      csp co ccj cfv wceq cT cado cdm wcel cB chil wcel cA chil wcel w3a cB cA
      cT cfv ax-his1 cT cado cdm wcel cB chil wcel cA chil wcel 3simp2 cT cado
      cdm wcel cA chil wcel cA cT cfv chil wcel cB chil wcel chil chil cT wf cA
      chil wcel cA cT cfv chil wcel cT cado cdm wcel chil chil cA cT ffvelrn cT
      dmadjop sylan 3adant2 sylanc cB cT cado cfv cfv chil wcel cA chil wcel cB
      cT cado cfv cfv cA csp co cA cB cT cado cfv cfv csp co ccj cfv wceq cT
      cado cdm wcel cB chil wcel cA chil wcel w3a cB cT cado cfv cfv cA ax-his1
      cT cado cdm wcel cB chil wcel cB cT cado cfv cfv chil wcel cA chil wcel
      cB cT adjcl 3adant3 cT cado cdm wcel cB chil wcel cA chil wcel 3simp3
      sylanc 3eqtr3d cA cT cfv cB csp co cc wcel cA cB cT cado cfv cfv csp co
      cc wcel cA cT cfv cB csp co ccj cfv cA cB cT cado cfv cfv csp co ccj cfv
      wceq cA cT cfv cB csp co cA cB cT cado cfv cfv csp co wceq wb cT cado cdm
      wcel cB chil wcel cA chil wcel w3a cA cT cfv cB csp co cA cB cT cado cfv
      cfv csp co cj11 cA cT cfv chil wcel cB chil wcel cA cT cfv cB csp co cc
      wcel cT cado cdm wcel cB chil wcel cA chil wcel w3a cA cT cfv cB hicl cT
      cado cdm wcel cA chil wcel cA cT cfv chil wcel cB chil wcel chil chil cT
      wf cA chil wcel cA cT cfv chil wcel cT cado cdm wcel chil chil cA cT
      ffvelrn cT dmadjop sylan 3adant2 cT cado cdm wcel cB chil wcel cA chil
      wcel 3simp2 sylanc cA chil wcel cB cT cado cfv cfv chil wcel cA cB cT
      cado cfv cfv csp co cc wcel cT cado cdm wcel cB chil wcel cA chil wcel
      w3a cA cB cT cado cfv cfv hicl cT cado cdm wcel cB chil wcel cA chil wcel
      3simp3 cT cado cdm wcel cB chil wcel cB cT cado cfv cfv chil wcel cA chil
      wcel cB cT adjcl 3adant3 sylanc sylanc mpbid 3com23 $.
      $( [3-Jun-2006] $) $( [15-Feb-2006] $)

    $( A property that determines the adjoint of a Hilbert space operator. $)
    adjeq $p |- ( ( T : ~H --> ~H /\ S : ~H --> ~H /\ A. x e. ~H A. y e. ~H
           ( ( T ` x ) .ih y ) = ( x .ih ( S ` y ) ) ) -> ( adjh ` T ) = S ) $=
      cS cvv wcel cT cS cop cado wcel cT cado cfv cS wceq chil chil cT wf chil
      chil cS wf vx cv cT cfv vy cv csp co vx cv vy cv cS cfv csp co wceq vy
      chil wral vx chil wral w3a cS cvv wcel cado wfun cT cS cop cado wcel cT
      cado cfv cS wceq wi funadj cT cS cvv cado funopfvg mpan2 chil chil cS wf
      chil chil cT wf cS cvv wcel vx cv cT cfv vy cv csp co vx cv vy cv cS cfv
      csp co wceq vy chil wral vx chil wral chil chil cS wf chil cvv wcel cS
      cvv wcel ax-hilex chil chil cvv cS fex mpan2 3ad2ant2 chil chil cT wf
      chil chil cS wf cT cS cop cado wcel vx cv cT cfv vy cv csp co vx cv vy cv
      cS cfv csp co wceq vy chil wral vx chil wral chil chil cT wf chil chil cS
      wf wa cT cS cop cado wcel chil chil cT wf chil chil cS wf vx cv cT cfv vy
      cv csp co vx cv vy cv cS cfv csp co wceq vy chil wral vx chil wral w3a vx
      cv cT cfv vy cv csp co vx cv vy cv cS cfv csp co wceq vy chil wral vx
      chil wral chil chil cT wf chil chil cS wf wa cT cS cop chil chil vz cv wf
      chil chil vw cv wf vx cv vz cv cfv vy cv csp co vx cv vy cv vw cv cfv csp
      co wceq vy chil wral vx chil wral w3a vz vw copab wcel chil chil cT wf
      chil chil cS wf vx cv cT cfv vy cv csp co vx cv vy cv cS cfv csp co wceq
      vy chil wral vx chil wral w3a cT cS cop cado wcel cT cvv wcel cS cvv wcel
      cT cS cop chil chil vz cv wf chil chil vw cv wf vx cv vz cv cfv vy cv csp
      co vx cv vy cv vw cv cfv csp co wceq vy chil wral vx chil wral w3a vz vw
      copab wcel chil chil cT wf chil chil cS wf vx cv cT cfv vy cv csp co vx
      cv vy cv cS cfv csp co wceq vy chil wral vx chil wral w3a wb chil chil cT
      wf chil chil cS wf chil chil vz cv wf chil chil vw cv wf vx cv vz cv cfv
      vy cv csp co vx cv vy cv vw cv cfv csp co wceq vy chil wral vx chil wral
      w3a chil chil cT wf chil chil vw cv wf vx cv cT cfv vy cv csp co vx cv vy
      cv vw cv cfv csp co wceq vy chil wral vx chil wral w3a chil chil cT wf
      chil chil cS wf vx cv cT cfv vy cv csp co vx cv vy cv cS cfv csp co wceq
      vy chil wral vx chil wral w3a vz vw cT cS cvv cvv vz cv cT wceq chil chil
      vz cv wf chil chil cT wf vx cv vz cv cfv vy cv csp co vx cv vy cv vw cv
      cfv csp co wceq vy chil wral vx chil wral vx cv cT cfv vy cv csp co vx cv
      vy cv vw cv cfv csp co wceq vy chil wral vx chil wral chil chil vw cv wf
      chil chil vz cv cT feq1 vz cv cT wceq vx cv vz cv cfv vy cv csp co vx cv
      vy cv vw cv cfv csp co wceq vx cv cT cfv vy cv csp co vx cv vy cv vw cv
      cfv csp co wceq vx vy chil chil vz cv cT wceq vx cv vz cv cfv vy cv csp
      co vx cv cT cfv vy cv csp co vx cv vy cv vw cv cfv csp co vz cv cT wceq
      vx cv vz cv cfv vx cv cT cfv vy cv csp vx cv vz cv cT fveq1 opreq1d
      eqeq1d 2ralbidv 3anbi13d vw cv cS wceq chil chil vw cv wf chil chil cS wf
      vx cv cT cfv vy cv csp co vx cv vy cv vw cv cfv csp co wceq vy chil wral
      vx chil wral vx cv cT cfv vy cv csp co vx cv vy cv cS cfv csp co wceq vy
      chil wral vx chil wral chil chil cT wf chil chil vw cv cS feq1 vw cv cS
      wceq vx cv cT cfv vy cv csp co vx cv vy cv vw cv cfv csp co wceq vx cv cT
      cfv vy cv csp co vx cv vy cv cS cfv csp co wceq vx vy chil chil vw cv cS
      wceq vx cv vy cv vw cv cfv csp co vx cv vy cv cS cfv csp co vx cv cT cfv
      vy cv csp co vw cv cS wceq vy cv vw cv cfv vy cv cS cfv vx cv csp vy cv
      vw cv cS fveq1 opreq2d eqeq2d 2ralbidv 3anbi23d opelopabg chil chil cT wf
      chil cvv wcel cT cvv wcel ax-hilex chil chil cvv cT fex mpan2 chil chil
      cS wf chil cvv wcel cS cvv wcel ax-hilex chil chil cvv cS fex mpan2
      syl2an cado chil chil vz cv wf chil chil vw cv wf vx cv vz cv cfv vy cv
      csp co vx cv vy cv vw cv cfv csp co wceq vy chil wral vx chil wral w3a vz
      vw copab cT cS cop vx vy vw vz df-adjh eleq2i syl5bb chil chil cT wf chil
      chil cS wf vx cv cT cfv vy cv csp co vx cv vy cv cS cfv csp co wceq vy
      chil wral vx chil wral w3a chil chil cT wf chil chil cS wf wa vx cv cT
      cfv vy cv csp co vx cv vy cv cS cfv csp co wceq vy chil wral vx chil wral
      chil chil cT wf chil chil cS wf vx cv cT cfv vy cv csp co vx cv vy cv cS
      cfv csp co wceq vy chil wral vx chil wral df-3an baibr bitr4d biimp3ar
      sylc $.
      $( [3-Jun-2006] $) $( [20-Feb-2006] $)

    $( Double adjoint.  Theorem 3.11(iv) of [Beran] p. 106. $)
    adjadj $p |- ( T e. dom adjh -> ( adjh ` ( adjh ` T ) ) = T ) $=
      cT cado cdm wcel vx cv cT cado cfv cado cfv cfv vy cv csp co vx cv cT cfv
      vy cv csp co wceq vy chil wral vx chil wral cT cado cfv cado cfv cT wceq
      cT cado cdm wcel vx cv cT cado cfv cado cfv cfv vy cv csp co vx cv cT cfv
      vy cv csp co wceq vx vy chil chil cT cado cdm wcel vx cv chil wcel vy cv
      chil wcel vx cv cT cado cfv cado cfv cfv vy cv csp co vx cv cT cfv vy cv
      csp co wceq cT cado cdm wcel vx cv chil wcel vy cv chil wcel w3a vx cv cT
      cfv vy cv csp co vx cv vy cv cT cado cfv cfv csp co vx cv cT cado cfv
      cado cfv cfv vy cv csp co vx cv vy cv cT adj2 cT cado cfv cado cdm wcel
      vx cv chil wcel vy cv chil wcel vx cv vy cv cT cado cfv cfv csp co vx cv
      cT cado cfv cado cfv cfv vy cv csp co wceq cT cado cdm wcel vx cv vy cv
      cT cado cfv adj1 cT dmadjrn syl3an1 eqtr2d 3expib r19.21aivv chil chil cT
      cado cfv cado cfv wf chil chil cT wf vx cv cT cado cfv cado cfv cfv vy cv
      csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx chil wral cT cado
      cfv cado cfv cT wceq wb cT cado cdm wcel vx vy cT cado cfv cado cfv cT
      hoeq1 cT cado cdm wcel cT cado cfv cado cdm wcel cT cado cfv cado cfv
      cado cdm wcel chil chil cT cado cfv cado cfv wf cT dmadjrn cT cado cfv
      dmadjrn cT cado cfv cado cfv dmadjop 3syl cT dmadjop sylanc mpbid $.
      $( [3-Jun-2006] $) $( [15-Feb-2006] $)

    $( Value of the value of the adjoint function. $)
    adjvalval $p  |- ( ( T e. dom adjh /\ A e. ~H ) -> ( ( adjh ` T ) ` A ) =
             U. { w e. ~H | A. x e. ~H ( ( T ` x ) .ih A ) = ( x .ih w ) } ) $=
      cT cado cdm wcel cA chil wcel wa vx cv cT cfv cA csp co vx cv vw cv csp
      co wceq vx chil wral vw chil crab cuni cA cT cado cfv cfv cT cado cdm
      wcel cA chil wcel wa vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp
      co wceq vx chil wral vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx
      chil wral vw chil crab cuni cA cT cado cfv cfv wceq cT cado cdm wcel cA
      chil wcel wa vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co wceq
      vx chil cT cado cdm wcel cA chil wcel vx cv chil wcel vx cv cT cfv cA csp
      co vx cv cA cT cado cfv cfv csp co wceq cT cado cdm wcel vx cv chil wcel
      cA chil wcel vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co wceq
      vx cv cA cT adj2 3com23 3expa r19.21aiva cA cT cado cfv cfv chil wcel vx
      cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral vw chil wreu vx
      cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co wceq vx chil wral vx
      cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral vw chil crab
      cuni cA cT cado cfv cfv wceq wb cT cado cdm wcel cA chil wcel wa vx cv cT
      cfv cA csp co vx cv vw cv csp co wceq vx chil wral vx cv cT cfv cA csp co
      vx cv cA cT cado cfv cfv csp co wceq vx chil wral vw chil cA cT cado cfv
      cfv vw cv cA cT cado cfv cfv wceq vx cv cT cfv cA csp co vx cv vw cv csp
      co wceq vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co wceq vx
      chil vw cv cA cT cado cfv cfv wceq vx cv vw cv csp co vx cv cA cT cado
      cfv cfv csp co vx cv cT cfv cA csp co vw cv cA cT cado cfv cfv vx cv csp
      opreq2 eqeq2d ralbidv reuuni2 cA cT adjcl cT cado cdm wcel cA chil wcel
      wa vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral vw chil
      wrex vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral vx cv cT
      cfv cA csp co vx cv vy cv csp co wceq vx chil wral wa vw cv vy cv wceq wi
      vy chil wral vw chil wral wa vx cv cT cfv cA csp co vx cv vw cv csp co
      wceq vx chil wral vw chil wreu cT cado cdm wcel cA chil wcel wa vx cv cT
      cfv cA csp co vx cv vw cv csp co wceq vx chil wral vw chil wrex vx cv cT
      cfv cA csp co vx cv vw cv csp co wceq vx chil wral vx cv cT cfv cA csp co
      vx cv vy cv csp co wceq vx chil wral wa vw cv vy cv wceq wi vy chil wral
      vw chil wral cA cT cado cfv cfv chil wcel vx cv cT cfv cA csp co vx cv cA
      cT cado cfv cfv csp co wceq vx chil wral vx cv cT cfv cA csp co vx cv vw
      cv csp co wceq vx chil wral vw chil wrex cT cado cdm wcel cA chil wcel wa
      vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral vx cv cT cfv
      cA csp co vx cv cA cT cado cfv cfv csp co wceq vx chil wral vw cA cT cado
      cfv cfv chil vw cv cA cT cado cfv cfv wceq vx cv cT cfv cA csp co vx cv
      vw cv csp co wceq vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co
      wceq vx chil vw cv cA cT cado cfv cfv wceq vx cv vw cv csp co vx cv cA cT
      cado cfv cfv csp co vx cv cT cfv cA csp co vw cv cA cT cado cfv cfv vx cv
      csp opreq2 eqeq2d ralbidv rcla4ev cA cT adjcl cT cado cdm wcel cA chil
      wcel wa vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co wceq vx
      chil cT cado cdm wcel cA chil wcel vx cv chil wcel vx cv cT cfv cA csp co
      vx cv cA cT cado cfv cfv csp co wceq cT cado cdm wcel vx cv chil wcel cA
      chil wcel vx cv cT cfv cA csp co vx cv cA cT cado cfv cfv csp co wceq vx
      cv cA cT adj2 3com23 3expa r19.21aiva sylanc vx cv cT cfv cA csp co vx cv
      vw cv csp co wceq vx chil wral vx cv cT cfv cA csp co vx cv vy cv csp co
      wceq vx chil wral wa vw cv vy cv wceq wi vw vy chil vw cv chil wcel vy cv
      chil wcel wa vx cv vw cv csp co vx cv vy cv csp co wceq vx chil wral vw
      cv vy cv wceq vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral
      vx cv cT cfv cA csp co vx cv vy cv csp co wceq vx chil wral wa vx vw cv
      vy cv hial2eq2 vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil
      wral vx cv cT cfv cA csp co vx cv vy cv csp co wceq vx chil wral wa vx cv
      cT cfv cA csp co vx cv vw cv csp co wceq vx cv cT cfv cA csp co vx cv vy
      cv csp co wceq wa vx chil wral vx cv vw cv csp co vx cv vy cv csp co wceq
      vx chil wral vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx cv cT cfv
      cA csp co vx cv vy cv csp co wceq vx chil r19.26 vx cv cT cfv cA csp co
      vx cv vw cv csp co wceq vx cv cT cfv cA csp co vx cv vy cv csp co wceq wa
      vx cv vw cv csp co vx cv vy cv csp co wceq vx chil vx cv cT cfv cA csp co
      vx cv vw cv csp co vx cv vy cv csp co eqtr2 r19.20si sylbir syl5bi rgen2a
      jctir vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx chil wral vx cv
      cT cfv cA csp co vx cv vy cv csp co wceq vx chil wral vw vy chil vw cv vy
      cv wceq vx cv cT cfv cA csp co vx cv vw cv csp co wceq vx cv cT cfv cA
      csp co vx cv vy cv csp co wceq vx chil vw cv vy cv wceq vx cv vw cv csp
      co vx cv vy cv csp co vx cv cT cfv cA csp co vw cv vy cv vx cv csp opreq2
      eqeq2d ralbidv reu4 sylibr sylanc mpbid eqcomd $.
      $( [3-Jun-2006] $) $( [22-Feb-2006] $)

    $( The adjoint of a unitary operator is its inverse (converse).  Equation 2
       of [AkhiezerGlazman] p. 72. $)
    unopadj2 $p |- ( T e. UniOp -> ( adjh ` T ) = `' T ) $=
      chil chil cT wf chil chil cT ccnv wf vx cv cT cfv vy cv csp co vx cv vy
      cv cT ccnv cfv csp co wceq vy chil wral vx chil wral cT cado cfv cT ccnv
      wceq cT cuo wcel vx vy cT ccnv cT adjeq cT cuo wcel cT clo wcel chil chil
      cT wf cT unoplin cT lnopf syl cT cuo wcel cT ccnv cuo wcel cT ccnv clo
      wcel chil chil cT ccnv wf cT cnvunop cT ccnv unoplin cT ccnv lnopf 3syl
      cT cuo wcel vx cv cT cfv vy cv csp co vx cv vy cv cT ccnv cfv csp co wceq
      vx vy chil chil cT cuo wcel vx cv chil wcel vy cv chil wcel vx cv cT cfv
      vy cv csp co vx cv vy cv cT ccnv cfv csp co wceq vx cv vy cv cT unopadj
      3expib r19.21aivv syl3anc $.
      $( [25-Sep-2006] $) $( [23-Feb-2006] $)

    $( A Hermitian operator is self-adjoint. $)
    hmopadj $p |- ( T e. HrmOp -> ( adjh ` T ) = T ) $=
      chil chil cT wf chil chil cT wf vx cv cT cfv vy cv csp co vx cv vy cv cT
      cfv csp co wceq vy chil wral vx chil wral cT cado cfv cT wceq cT cho wcel
      vx vy cT cT adjeq cT hmopf cT hmopf cT cho wcel vx cv cT cfv vy cv csp co
      vx cv vy cv cT cfv csp co wceq vx vy chil chil cT cho wcel vx cv chil
      wcel vy cv chil wcel vx cv cT cfv vy cv csp co vx cv vy cv cT cfv csp co
      wceq cT cho wcel vx cv chil wcel vy cv chil wcel w3a vx cv vy cv cT cfv
      csp co vx cv cT cfv vy cv csp co vx cv vy cv cT hmop eqcomd 3expib
      r19.21aivv syl3anc $.
      $( [4-Jun-2006] $) $( [24-Mar-2006] $)

    $( Every Hermitian operator has an adjoint. $)
    hmdmadj $p |- ( T e. HrmOp -> T e. dom adjh ) $=
      cT cho wcel cT cado cfv c0 wceq cT cado cdm wcel cT cho wcel cT cado cfv
      c0 wceq cT c0 wceq cT cho wcel chil chil cT wf cT c0 wceq wn cT hmopf cT
      hon0 syl cT cho wcel cT cado cfv cT c0 cT hmopadj eqeq1d mtbird cT cado
      ndmfv nsyl2 $.
      $( [1-Oct-2006] $) $( [24-Mar-2006] $)

    $( An operator is Hermitian iff it is self-adjoint.  Definition of
       Hermitian in [Halmos] p. 41. $)
    hmopadj2 $p |- ( T e. dom adjh -> ( T e. HrmOp <-> ( adjh ` T ) = T ) ) $=
      cT cado cdm wcel cT cho wcel cT cado cfv cT wceq cT hmopadj cT cado cdm
      wcel cT cado cfv cT wceq cT cho wcel cT cado cdm wcel cT cado cfv cT wceq
      wa chil chil cT wf vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp co
      wceq vy chil wral vx chil wral wa cT cho wcel cT cado cdm wcel cT cado
      cfv cT wceq wa chil chil cT wf vx cv vy cv cT cfv csp co vx cv cT cfv vy
      cv csp co wceq vy chil wral vx chil wral cT cado cdm wcel chil chil cT wf
      cT cado cfv cT wceq cT dmadjop adantr cT cado cdm wcel cT cado cfv cT
      wceq wa vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp co wceq vx vy
      chil chil cT cado cdm wcel cT cado cfv cT wceq wa vx cv chil wcel vy cv
      chil wcel wa vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp co wceq cT
      cado cdm wcel cT cado cfv cT wceq wa vx cv chil wcel vy cv chil wcel wa
      wa vx cv vy cv cT cfv csp co vx cv cT cado cfv cfv vy cv csp co vx cv cT
      cfv vy cv csp co cT cado cdm wcel vx cv chil wcel vy cv chil wcel wa vx
      cv vy cv cT cfv csp co vx cv cT cado cfv cfv vy cv csp co wceq cT cado
      cfv cT wceq cT cado cdm wcel vx cv chil wcel vy cv chil wcel vx cv vy cv
      cT cfv csp co vx cv cT cado cfv cfv vy cv csp co wceq vx cv vy cv cT adj1
      3expb adantlr cT cado cfv cT wceq vx cv cT cado cfv cfv vy cv csp co vx
      cv cT cfv vy cv csp co wceq cT cado cdm wcel vx cv chil wcel vy cv chil
      wcel wa cT cado cfv cT wceq vx cv cT cado cfv cfv vx cv cT cfv vy cv csp
      vx cv cT cado cfv cT fveq1 opreq1d ad2antlr eqtrd ex r19.21aivv jca vx vy
      cT elhmop sylibr ex impbid2 $.
      $( [24-Oct-2006] $) $( [9-Apr-2006] $)

    $( A Hermitian operator is linear. $)
    hmoplin $p |- ( T e. HrmOp -> T e. LinOp ) $=
      cT cho wcel chil chil cT wf vx cv vy cv csm co vz cv cva co cT cfv vx cv
      vy cv cT cfv csm co vz cv cT cfv cva co wceq vz chil wral vy chil wral vx
      cc wral wa cT clo wcel cT cho wcel chil chil cT wf vx cv vy cv csm co vz
      cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz
      chil wral vy chil wral vx cc wral cT hmopf cT cho wcel vx cv vy cv csm co
      vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vz
      chil wral vx vy cc chil cT cho wcel vx cv cc wcel vy cv chil wcel wa vx
      cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT
      cfv cva co wceq vz chil wral cT cho wcel vx cv cc wcel vy cv chil wcel wa
      wa vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv
      cT cfv cva co wceq vz chil cT cho wcel vx cv cc wcel vy cv chil wcel wa
      wa vz cv chil wcel wa vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co
      vx cv vy cv cT cfv csm co vz cv cT cfv cva co vw cv csp co wceq vw chil
      wral vx cv vy cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz
      cv cT cfv cva co wceq cT cho wcel vx cv cc wcel vy cv chil wcel wa wa vz
      cv chil wcel wa vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co vx cv
      vy cv cT cfv csm co vz cv cT cfv cva co vw cv csp co wceq vw chil cT cho
      wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil
      wcel wa vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co vx cv vy cv
      csm co vz cv cva co vw cv cT cfv csp co vx cv vy cv vw cv cT cfv csp co
      cmul co vz cv vw cv cT cfv csp co caddc co vx cv vy cv cT cfv csm co vz
      cv cT cfv cva co vw cv csp co cT cho wcel vx cv vy cv csm co vz cv cva co
      chil wcel vw cv chil wcel vx cv vy cv csm co vz cv cva co cT cfv vw cv
      csp co vx cv vy cv csm co vz cv cva co vw cv cT cfv csp co wceq cT cho
      wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil
      wcel wa cT cho wcel vx cv vy cv csm co vz cv cva co chil wcel vw cv chil
      wcel w3a vx cv vy cv csm co vz cv cva co vw cv cT cfv csp co vx cv vy cv
      csm co vz cv cva co cT cfv vw cv csp co vx cv vy cv csm co vz cv cva co
      vw cv cT hmop eqcomd cT cho wcel vx cv cc wcel vy cv chil wcel wa wa cT
      cho wcel vz cv chil wcel vw cv chil wcel cT cho wcel vx cv cc wcel vy cv
      chil wcel wa pm3.26 ad2antrr cT cho wcel vx cv cc wcel vy cv chil wcel wa
      wa vz cv chil wcel wa vx cv vy cv csm co vz cv cva co chil wcel vw cv
      chil wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv
      csm co vz cv cva co chil wcel cT cho wcel vx cv vy cv csm co chil wcel vz
      cv chil wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv cc wcel vy
      cv chil wcel wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl
      sylan adantll adantr cT cho wcel vx cv cc wcel vy cv chil wcel wa wa vz
      cv chil wcel wa vw cv chil wcel pm3.27 syl3anc vx cv cc wcel vy cv chil
      wcel vz cv chil wcel vw cv cT cfv chil wcel vx cv vy cv csm co vz cv cva
      co vw cv cT cfv csp co vx cv vy cv vw cv cT cfv csp co cmul co vz cv vw
      cv cT cfv csp co caddc co wceq cT cho wcel vx cv cc wcel vy cv chil wcel
      wa wa vz cv chil wcel wa vw cv chil wcel wa vx cv vy cv vz cv vw cv cT
      cfv hiassdi cT cho wcel vx cv cc wcel vy cv chil wcel wa wa vx cv cc wcel
      vz cv chil wcel vw cv chil wcel cT cho wcel vx cv cc wcel vy cv chil wcel
      simprl ad2antrr cT cho wcel vx cv cc wcel vy cv chil wcel wa wa vy cv
      chil wcel vz cv chil wcel vw cv chil wcel cT cho wcel vx cv cc wcel vy cv
      chil wcel simprr ad2antrr cT cho wcel vx cv cc wcel vy cv chil wcel wa wa
      vz cv chil wcel vw cv chil wcel simplr cT cho wcel vz cv chil wcel vw cv
      chil wcel vw cv cT cfv chil wcel vx cv cc wcel vy cv chil wcel wa cT cho
      wcel vw cv chil wcel vw cv cT cfv chil wcel vz cv chil wcel chil chil cT
      wf vw cv chil wcel vw cv cT cfv chil wcel cT cho wcel chil chil vw cv cT
      ffvelrn cT hmopf sylan adantlr adantllr syl2anc cT cho wcel vx cv cc wcel
      vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil wcel wa vx cv vy cv
      cT cfv csm co vz cv cT cfv cva co vw cv csp co vx cv vy cv cT cfv vw cv
      csp co cmul co vz cv cT cfv vw cv csp co caddc co vx cv vy cv vw cv cT
      cfv csp co cmul co vz cv vw cv cT cfv csp co caddc co vx cv cc wcel vy cv
      cT cfv chil wcel vz cv cT cfv chil wcel vw cv chil wcel vx cv vy cv cT
      cfv csm co vz cv cT cfv cva co vw cv csp co vx cv vy cv cT cfv vw cv csp
      co cmul co vz cv cT cfv vw cv csp co caddc co wceq cT cho wcel vx cv cc
      wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil wcel wa vx cv vy
      cv cT cfv vz cv cT cfv vw cv hiassdi cT cho wcel vx cv cc wcel vy cv chil
      wcel wa wa vx cv cc wcel vz cv chil wcel vw cv chil wcel cT cho wcel vx
      cv cc wcel vy cv chil wcel simprl ad2antrr cT cho wcel vx cv cc wcel vy
      cv chil wcel wa wa vy cv cT cfv chil wcel vz cv chil wcel vw cv chil wcel
      cT cho wcel vy cv chil wcel vy cv cT cfv chil wcel vx cv cc wcel chil
      chil cT wf vy cv chil wcel vy cv cT cfv chil wcel cT cho wcel chil chil
      vy cv cT ffvelrn cT hmopf sylan adantrl ad2antrr cT cho wcel vz cv chil
      wcel vw cv chil wcel vz cv cT cfv chil wcel vx cv cc wcel vy cv chil wcel
      wa cT cho wcel vz cv chil wcel wa vz cv cT cfv chil wcel vw cv chil wcel
      chil chil cT wf vz cv chil wcel vz cv cT cfv chil wcel cT cho wcel chil
      chil vz cv cT ffvelrn cT hmopf sylan adantr adantllr cT cho wcel vx cv cc
      wcel vy cv chil wcel wa wa vz cv chil wcel wa vw cv chil wcel pm3.27
      syl2anc cT cho wcel vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel
      wa vw cv chil wcel wa vx cv vy cv cT cfv vw cv csp co cmul co vx cv vy cv
      vw cv cT cfv csp co cmul co vz cv cT cfv vw cv csp co vz cv vw cv cT cfv
      csp co caddc cT cho wcel vx cv cc wcel vy cv chil wcel wa wa vw cv chil
      wcel vx cv vy cv cT cfv vw cv csp co cmul co vx cv vy cv vw cv cT cfv csp
      co cmul co wceq vz cv chil wcel cT cho wcel vy cv chil wcel vw cv chil
      wcel vx cv vy cv cT cfv vw cv csp co cmul co vx cv vy cv vw cv cT cfv csp
      co cmul co wceq vx cv cc wcel cT cho wcel vy cv chil wcel wa vw cv chil
      wcel wa vy cv cT cfv vw cv csp co vy cv vw cv cT cfv csp co vx cv cmul cT
      cho wcel vy cv chil wcel vw cv chil wcel vy cv cT cfv vw cv csp co vy cv
      vw cv cT cfv csp co wceq cT cho wcel vy cv chil wcel vw cv chil wcel w3a
      vy cv vw cv cT cfv csp co vy cv cT cfv vw cv csp co vy cv vw cv cT hmop
      eqcomd 3expa opreq2d adantlrl adantlr cT cho wcel vz cv chil wcel vw cv
      chil wcel vz cv cT cfv vw cv csp co vz cv vw cv cT cfv csp co wceq vx cv
      cc wcel vy cv chil wcel wa cT cho wcel vz cv chil wcel vw cv chil wcel vz
      cv cT cfv vw cv csp co vz cv vw cv cT cfv csp co wceq cT cho wcel vz cv
      chil wcel vw cv chil wcel w3a vz cv vw cv cT cfv csp co vz cv cT cfv vw
      cv csp co vz cv vw cv cT hmop eqcomd 3expa adantllr opreq12d eqtr2d
      3eqtrd r19.21aiva chil chil cT wf vx cv cc wcel vy cv chil wcel wa vz cv
      chil wcel vx cv vy cv csm co vz cv cva co cT cfv vw cv csp co vx cv vy cv
      cT cfv csm co vz cv cT cfv cva co vw cv csp co wceq vw chil wral vx cv vy
      cv csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva
      co wceq wb cT cho wcel vx cv vy cv csm co vz cv cva co cT cfv chil wcel
      vx cv vy cv cT cfv csm co vz cv cT cfv cva co chil wcel vx cv vy cv csm
      co vz cv cva co cT cfv vw cv csp co vx cv vy cv cT cfv csm co vz cv cT
      cfv cva co vw cv csp co wceq vw chil wral vx cv vy cv csm co vz cv cva co
      cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq wb chil chil cT
      wf vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vw vx cv vy cv
      csm co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co
      hial2eq chil chil cT wf vx cv cc wcel vy cv chil wcel wa vz cv chil wcel
      vx cv vy cv csm co vz cv cva co cT cfv chil wcel chil chil cT wf vx cv vy
      cv csm co vz cv cva co chil wcel vx cv vy cv csm co vz cv cva co cT cfv
      chil wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa chil chil
      vx cv vy cv csm co vz cv cva co cT ffvelrn vx cv vy cv csm co chil wcel
      vz cv chil wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv cc wcel
      vy cv chil wcel wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl
      sylan sylan2 anassrs vx cv vy cv cT cfv csm co chil wcel vz cv cT cfv
      chil wcel vx cv vy cv cT cfv csm co vz cv cT cfv cva co chil wcel chil
      chil cT wf vx cv cc wcel vy cv chil wcel wa wa vz cv chil wcel wa vx cv
      vy cv cT cfv csm co vz cv cT cfv hvaddcl chil chil cT wf vx cv cc wcel vy
      cv chil wcel wa wa vx cv vy cv cT cfv csm co chil wcel vz cv chil wcel vx
      cv cc wcel chil chil cT wf vy cv chil wcel vx cv vy cv cT cfv csm co chil
      wcel vx cv cc wcel vy cv cT cfv chil wcel vx cv vy cv cT cfv csm co chil
      wcel chil chil cT wf vy cv chil wcel wa vx cv vy cv cT cfv hvmulcl chil
      chil vy cv cT ffvelrn sylan2 an1s adantr chil chil cT wf vz cv chil wcel
      vz cv cT cfv chil wcel vx cv cc wcel vy cv chil wcel wa chil chil vz cv
      cT ffvelrn adantlr sylanc sylanc cT hmopf sylanl1 mpbid r19.21aiva ex
      r19.21aivv jca vx vy vz cT ellnop sylibr $.
      $( [28-May-2006] $) $( [24-Mar-2006] $)

    $( The bra of a vector, expressed as ` <. A | ` in Dirac notation.  See
       ~ df-bra . $)
    braval $p |- ( A e. ~H ->
            ( bra ` A ) = { <. x , y >. | ( x e. ~H /\ y = ( x .ih A ) ) } ) $=
      vz vw cA vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy copab vx
      cv chil wcel vy cv vx cv cA csp co wceq wa vx vy copab chil cbr vz cv cA
      wceq vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx cv chil wcel vy
      cv vx cv cA csp co wceq wa vx vy vz cv cA wceq vy cv vx cv vz cv csp co
      wceq vy cv vx cv cA csp co wceq vx cv chil wcel vz cv cA wceq vx cv vz cv
      csp co vx cv cA csp co vy cv vz cv cA vx cv csp opreq2 eqeq2d anbi2d
      opabbidv vz vx vy vw df-bra vx vy chil vx cv cA csp co ax-hilex opabex2
      fvopab4 $.
      $( [17-May-2006] $) $( [15-May-2006] $)

    $( A bra-ket juxtaposition, expressed as ` <. A | B >. ` in Dirac notation,
       equals the inner product of the vectors.  Based on definition of bra in
       [Prugovecki] p. 186. $)
    bravalval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( bra ` A ) ` B ) = ( B .ih A ) ) $=
      cA chil wcel cB chil wcel cB cA cbr cfv cfv cB vx cv chil wcel vy cv vx
      cv cA csp co wceq wa vx vy copab cfv cB cA csp co cA chil wcel cB cA cbr
      cfv vx cv chil wcel vy cv vx cv cA csp co wceq wa vx vy copab vx vy cA
      braval fveq1d vx vy cB vx cv cA csp co cB cA csp co chil vx cv chil wcel
      vy cv vx cv cA csp co wceq wa vx vy copab vx cv cB cA csp opreq1 vx cv
      chil wcel vy cv vx cv cA csp co wceq wa vx vy copab eqid cB cA csp oprex
      fvopab4 sylan9eq $.
      $( [17-May-2006] $) $( [15-May-2006] $)

    $( Linearity property of bra for addition. $)
    braadd $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( ( bra ` A ) `
              ( B +h C ) ) = ( ( ( bra ` A ) ` B ) + ( ( bra ` A ) ` C ) ) ) $=
      cA chil wcel cB chil wcel cC chil wcel w3a cB cC cva co cA csp co cB cA
      csp co cC cA csp co caddc co cB cC cva co cA cbr cfv cfv cB cA cbr cfv
      cfv cC cA cbr cfv cfv caddc co cB chil wcel cC chil wcel cA chil wcel cB
      cC cva co cA csp co cB cA csp co cC cA csp co caddc co wceq cB cC cA
      ax-his2 3comr cA chil wcel cB chil wcel cC chil wcel cB cC cva co cA cbr
      cfv cfv cB cC cva co cA csp co wceq cA chil wcel cB cC cva co chil wcel
      cB cC cva co cA cbr cfv cfv cB cC cva co cA csp co wceq cB chil wcel cC
      chil wcel wa cA cB cC cva co bravalval cB cC hvaddcl sylan2 3impb cA chil
      wcel cB chil wcel cC chil wcel w3a cB cA cbr cfv cfv cB cA csp co cC cA
      cbr cfv cfv cC cA csp co caddc cA chil wcel cB chil wcel cB cA cbr cfv
      cfv cB cA csp co wceq cC chil wcel cA cB bravalval 3adant3 cA chil wcel
      cC chil wcel cC cA cbr cfv cfv cC cA csp co wceq cB chil wcel cA cC
      bravalval 3adant2 opreq12d 3eqtr4d $.
      $( [1-Jun-2006] $) $( [23-May-2006] $)

    $( Linearity property of bra for multiplication. $)
    bramul $p |- ( ( A e. ~H /\ B e. CC /\ C e. ~H ) -> ( ( bra ` A ) `
              ( B .h C ) ) = ( B x. ( ( bra ` A ) ` C ) ) ) $=
      cA chil wcel cB cc wcel cC chil wcel w3a cB cC csm co cA csp co cB cC cA
      csp co cmul co cB cC csm co cA cbr cfv cfv cB cC cA cbr cfv cfv cmul co
      cB cc wcel cC chil wcel cA chil wcel cB cC csm co cA csp co cB cC cA csp
      co cmul co wceq cB cC cA ax-his3 3comr cA chil wcel cB cc wcel cC chil
      wcel cB cC csm co cA cbr cfv cfv cB cC csm co cA csp co wceq cA chil wcel
      cB cC csm co chil wcel cB cC csm co cA cbr cfv cfv cB cC csm co cA csp co
      wceq cB cc wcel cC chil wcel wa cA cB cC csm co bravalval cB cC hvmulcl
      sylan2 3impb cA chil wcel cB cc wcel cC chil wcel w3a cC cA cbr cfv cfv
      cC cA csp co cB cmul cA chil wcel cC chil wcel cC cA cbr cfv cfv cC cA
      csp co wceq cB cc wcel cA cC bravalval 3adant2 opreq2d 3eqtr4d $.
      $( [6-Jun-2006] $) $( [23-May-2006] $)

    $( The bra function is a functional. $)
    brafn $p |- ( A e. ~H -> ( bra ` A ) : ~H --> CC ) $=
      cA chil wcel chil cc cA cbr cfv wf chil cc vx cv chil wcel vy cv vx cv cA
      csp co wceq wa vx vy copab wf cA chil wcel vx cv cA csp co cc wcel vx
      chil wral chil cc vx cv chil wcel vy cv vx cv cA csp co wceq wa vx vy
      copab wf cA chil wcel vx cv cA csp co cc wcel vx chil vx cv chil wcel cA
      chil wcel vx cv cA csp co cc wcel vx cv cA hicl ancoms r19.21aiva vx vy
      chil cc vx cv cA csp co vx cv chil wcel vy cv vx cv cA csp co wceq wa vx
      vy copab vx cv chil wcel vy cv vx cv cA csp co wceq wa vx vy copab eqid
      fopab2 sylib cA chil wcel chil cc cA cbr cfv vx cv chil wcel vy cv vx cv
      cA csp co wceq wa vx vy copab vx vy cA braval feq1d mpbird $.
      $( [1-Jun-2006] $) $( [23-May-2006] $)

    $( The Dirac bra function is a linear functional. $)
    bralnfn $p |- ( A e. ~H -> ( bra ` A ) e. LinFn ) $=
      cA chil wcel chil cc cA cbr cfv wf vx cv vy cv csm co vz cv cva co cA cbr
      cfv cfv vx cv vy cv cA cbr cfv cfv cmul co vz cv cA cbr cfv cfv caddc co
      wceq vz chil wral vy chil wral vx cc wral wa cA cbr cfv clf wcel cA chil
      wcel chil cc cA cbr cfv wf vx cv vy cv csm co vz cv cva co cA cbr cfv cfv
      vx cv vy cv cA cbr cfv cfv cmul co vz cv cA cbr cfv cfv caddc co wceq vz
      chil wral vy chil wral vx cc wral cA brafn cA chil wcel vx cv vy cv csm
      co vz cv cva co cA cbr cfv cfv vx cv vy cv cA cbr cfv cfv cmul co vz cv
      cA cbr cfv cfv caddc co wceq vz chil wral vy chil wral vx cc cA chil wcel
      vx cv cc wcel wa vx cv vy cv csm co vz cv cva co cA cbr cfv cfv vx cv vy
      cv cA cbr cfv cfv cmul co vz cv cA cbr cfv cfv caddc co wceq vy vz chil
      chil cA chil wcel vx cv cc wcel wa vy cv chil wcel vz cv chil wcel wa vx
      cv vy cv csm co vz cv cva co cA cbr cfv cfv vx cv vy cv cA cbr cfv cfv
      cmul co vz cv cA cbr cfv cfv caddc co wceq cA chil wcel vx cv cc wcel wa
      vy cv chil wcel vz cv chil wcel wa wa vx cv vy cv csm co vz cv cva co cA
      cbr cfv cfv vx cv vy cv csm co cA cbr cfv cfv vz cv cA cbr cfv cfv caddc
      co vx cv vy cv cA cbr cfv cfv cmul co vz cv cA cbr cfv cfv caddc co cA
      chil wcel vx cv vy cv csm co chil wcel vz cv chil wcel vx cv vy cv csm co
      vz cv cva co cA cbr cfv cfv vx cv vy cv csm co cA cbr cfv cfv vz cv cA
      cbr cfv cfv caddc co wceq cA chil wcel vx cv cc wcel wa vy cv chil wcel
      vz cv chil wcel wa wa cA vx cv vy cv csm co vz cv braadd cA chil wcel vx
      cv cc wcel vy cv chil wcel vz cv chil wcel wa simpll vx cv cc wcel vy cv
      chil wcel vx cv vy cv csm co chil wcel cA chil wcel vz cv chil wcel vx cv
      vy cv hvmulcl ad2ant2lr cA chil wcel vx cv cc wcel wa vy cv chil wcel vz
      cv chil wcel simprr syl3anc cA chil wcel vx cv cc wcel wa vy cv chil wcel
      vz cv chil wcel wa wa vx cv vy cv csm co cA cbr cfv cfv vx cv vy cv cA
      cbr cfv cfv cmul co vz cv cA cbr cfv cfv caddc cA chil wcel vx cv cc wcel
      wa vy cv chil wcel vx cv vy cv csm co cA cbr cfv cfv vx cv vy cv cA cbr
      cfv cfv cmul co wceq vz cv chil wcel cA chil wcel vx cv cc wcel vy cv
      chil wcel vx cv vy cv csm co cA cbr cfv cfv vx cv vy cv cA cbr cfv cfv
      cmul co wceq cA vx cv vy cv bramul 3expa adantrr opreq1d eqtrd ex
      r19.21aivv r19.21aiva jca vx vy vz cA cbr cfv ellnfn sylibr $.
      $( [7-Jun-2006] $) $( [23-May-2006] $)

    $( Closure of the bra function. $)
    bracl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( bra ` A ) ` B ) e. CC ) $=
      chil cc cA cbr cfv wf cB chil wcel cB cA cbr cfv cfv cc wcel cA chil wcel
      chil cc cB cA cbr cfv ffvelrn cA brafn sylan $.
      $( [1-Jun-2006] $) $( [23-May-2006] $)

    $( The Dirac bra of the zero vector. $)
    bra0 $p |- ( bra ` 0h ) = ( ~H X. { 0 } ) $=
      vx cv chil wcel vy cv vx cv c0v csp co wceq wa vx vy copab vx cv chil
      wcel vy cv cc0 wceq wa vx vy copab c0v cbr cfv chil cc0 csn cxp vx cv
      chil wcel vy cv vx cv c0v csp co wceq wa vx cv chil wcel vy cv cc0 wceq
      wa vx vy vx cv chil wcel vy cv vx cv c0v csp co wceq vy cv cc0 wceq vx cv
      chil wcel vx cv c0v csp co cc0 vy cv vx cv hi02 eqeq2d pm5.32i opabbii
      c0v chil wcel c0v cbr cfv vx cv chil wcel vy cv vx cv c0v csp co wceq wa
      vx vy copab wceq ax-hv0cl vx vy c0v braval ax-mp vx vy chil cc0
      fconstopab 3eqtr4i $.
      $( [7-Jun-2006] $) $( [25-May-2006] $)

    $( Anti-linearity property of bra functional for multiplication. $)
    brafnmul $p |- ( ( A e. CC /\ B e. ~H ) ->
                    ( bra ` ( A .h B ) ) = ( ( * ` A ) .fn ( bra ` B ) ) ) $=
      cA cc wcel cB chil wcel wa vx cv chil wcel vy cv vx cv cA cB csm co csp
      co wceq wa vx vy copab vx cv chil wcel vy cv cA ccj cfv vx cv cB cbr cfv
      cfv cmul co wceq wa vx vy copab cA cB csm co cbr cfv cA ccj cfv cB cbr
      cfv chft co cA cc wcel cB chil wcel wa vx cv chil wcel vy cv vx cv cA cB
      csm co csp co wceq wa vx cv chil wcel vy cv cA ccj cfv vx cv cB cbr cfv
      cfv cmul co wceq wa vx vy cA cc wcel cB chil wcel wa vx cv chil wcel vy
      cv vx cv cA cB csm co csp co wceq vy cv cA ccj cfv vx cv cB cbr cfv cfv
      cmul co wceq cA cc wcel cB chil wcel wa vx cv chil wcel wa vx cv cA cB
      csm co csp co cA ccj cfv vx cv cB cbr cfv cfv cmul co vy cv cA cc wcel cB
      chil wcel wa vx cv chil wcel wa vx cv cA cB csm co csp co cA ccj cfv vx
      cv cB csp co cmul co cA ccj cfv vx cv cB cbr cfv cfv cmul co cA cc wcel
      cB chil wcel vx cv chil wcel vx cv cA cB csm co csp co cA ccj cfv vx cv
      cB csp co cmul co wceq cA cc wcel vx cv chil wcel cB chil wcel vx cv cA
      cB csm co csp co cA ccj cfv vx cv cB csp co cmul co wceq cA vx cv cB his5
      3com23 3expa cA cc wcel cB chil wcel wa vx cv chil wcel wa vx cv cB cbr
      cfv cfv vx cv cB csp co cA ccj cfv cmul cB chil wcel vx cv chil wcel vx
      cv cB cbr cfv cfv vx cv cB csp co wceq cA cc wcel cB vx cv bravalval
      adantll opreq2d eqtr4d eqeq2d pm5.32da opabbidv cA cc wcel cB chil wcel
      wa cA cB csm co chil wcel cA cB csm co cbr cfv vx cv chil wcel vy cv vx
      cv cA cB csm co csp co wceq wa vx vy copab wceq cA cB hvmulcl vx vy cA cB
      csm co braval syl cA ccj cfv cc wcel chil cc cB cbr cfv wf cA ccj cfv cB
      cbr cfv chft co vx cv chil wcel vy cv cA ccj cfv vx cv cB cbr cfv cfv
      cmul co wceq wa vx vy copab wceq cA cc wcel cB chil wcel vx vy cA ccj cfv
      cB cbr cfv hfmmval cA cjcl cB brafn syl2an 3eqtr4d $.
      $( [18-Jun-2006] $) $( [31-May-2006] $)

    $( The outer product of two vectors, expressed as ` | A >. ` ` <. B | ` in
       Dirac notation.  See ~ df-kb . $)
    kbval $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A ketbra B ) =
                { <. x , y >. | ( x e. ~H /\ y = ( ( x .ih B ) .h A ) ) } ) $=
      vz vw vt cA cB chil chil vx cv chil wcel vy cv vx cv vw cv csp co vz cv
      csm co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cB csp co cA csm
      co wceq wa vx vy copab ck vx cv chil wcel vy cv vx cv vw cv csp co cA csm
      co wceq wa vx vy copab vx vy chil vx cv cB csp co cA csm co ax-hilex
      opabex2 vz cv cA wceq vx cv chil wcel vy cv vx cv vw cv csp co vz cv csm
      co wceq wa vx cv chil wcel vy cv vx cv vw cv csp co cA csm co wceq wa vx
      vy vz cv cA wceq vy cv vx cv vw cv csp co vz cv csm co wceq vy cv vx cv
      vw cv csp co cA csm co wceq vx cv chil wcel vz cv cA wceq vx cv vw cv csp
      co vz cv csm co vx cv vw cv csp co cA csm co vy cv vz cv cA vx cv vw cv
      csp co csm opreq2 eqeq2d anbi2d opabbidv vw cv cB wceq vx cv chil wcel vy
      cv vx cv vw cv csp co cA csm co wceq wa vx cv chil wcel vy cv vx cv cB
      csp co cA csm co wceq wa vx vy vw cv cB wceq vy cv vx cv vw cv csp co cA
      csm co wceq vy cv vx cv cB csp co cA csm co wceq vx cv chil wcel vw cv cB
      wceq vx cv vw cv csp co cA csm co vx cv cB csp co cA csm co vy cv vw cv
      cB wceq vx cv vw cv csp co vx cv cB csp co cA csm vw cv cB vx cv csp
      opreq2 opreq1d eqeq2d anbi2d opabbidv vz vw vx vy vt df-kb oprabval2 $.
      $( [17-May-2006] $) $( [15-May-2006] $)

    $( The outer product of two vectors, expressed as ` | A >. ` ` <. B | ` in
       Dirac notation, is an operator. $)
    kbop $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A ketbra B ) : ~H --> ~H ) $=
      cA chil wcel cB chil wcel wa chil chil cA cB ck co wf chil chil vx cv
      chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab wf cA chil
      wcel cB chil wcel wa vx cv cB csp co cA csm co chil wcel vx chil wral
      chil chil vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy
      copab wf cA chil wcel cB chil wcel wa vx cv cB csp co cA csm co chil wcel
      vx chil vx cv chil wcel cB chil wcel cA chil wcel vx cv cB csp co cA csm
      co chil wcel vx cv cB csp co cc wcel cA chil wcel vx cv cB csp co cA csm
      co chil wcel vx cv chil wcel cB chil wcel wa vx cv cB csp co cA hvmulcl
      vx cv cB hicl sylan ancom31s r19.21aiva vx vy chil chil vx cv cB csp co
      cA csm co vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy
      copab vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab
      eqid fopab2 sylib cA chil wcel cB chil wcel wa chil chil cA cB ck co vx
      cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab vx vy cA
      cB kbval feq1d mpbird $.
      $( [20-Jun-2006] $) $( [30-May-2006] $)

    $( The value of the operator resulting from the outer product
       ` | A >. ` ` <. B | ` of two vectors.  Equation 8.1 of [Prugovecki]
       p. 376. $)
    kbvalval $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                 ( ( A ketbra B ) ` C ) = ( ( C .ih B ) .h A ) ) $=
      cA chil wcel cB chil wcel cC chil wcel cC cA cB ck co cfv cC cB csp co cA
      csm co wceq cA chil wcel cB chil wcel wa cC chil wcel cC cA cB ck co cfv
      cC vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab
      cfv cC cB csp co cA csm co cA chil wcel cB chil wcel wa cC cA cB ck co vx
      cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab vx vy cA
      cB kbval fveq1d vx vy cC vx cv cB csp co cA csm co cC cB csp co cA csm co
      chil vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab
      vx cv cC wceq vx cv cB csp co cC cB csp co cA csm vx cv cC cB csp opreq1
      opreq1d vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy
      copab eqid cC cB csp co cA csm oprex fvopab4 sylan9eq 3impa $.
      $( [17-May-2006] $) $( [15-May-2006] $)

    $( Multiplication property of outer product. $)
    kbmul $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( ( A .h B ) ketbra C ) = ( B ketbra ( ( * ` A ) .h C ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel w3a vx cv chil wcel vy cv vx cv cC
      csp co cA cB csm co csm co wceq wa vx vy copab vx cv chil wcel vy cv vx
      cv cA ccj cfv cC csm co csp co cB csm co wceq wa vx vy copab cA cB csm co
      cC ck co cB cA ccj cfv cC csm co ck co cA cc wcel cB chil wcel cC chil
      wcel w3a vx cv chil wcel vy cv vx cv cC csp co cA cB csm co csm co wceq
      wa vx cv chil wcel vy cv vx cv cA ccj cfv cC csm co csp co cB csm co wceq
      wa vx vy cA cc wcel cB chil wcel cC chil wcel w3a vx cv chil wcel vy cv
      vx cv cC csp co cA cB csm co csm co wceq vy cv vx cv cA ccj cfv cC csm co
      csp co cB csm co wceq cA cc wcel cB chil wcel cC chil wcel w3a vx cv chil
      wcel wa vx cv cC csp co cA cB csm co csm co vx cv cA ccj cfv cC csm co
      csp co cB csm co vy cv cA cc wcel cB chil wcel cC chil wcel w3a vx cv
      chil wcel wa vx cv cC csp co cA cmul co cB csm co vx cv cC csp co cA cB
      csm co csm co vx cv cA ccj cfv cC csm co csp co cB csm co vx cv cC csp co
      cc wcel cA cc wcel cB chil wcel vx cv cC csp co cA cmul co cB csm co vx
      cv cC csp co cA cB csm co csm co wceq cA cc wcel cB chil wcel cC chil
      wcel w3a vx cv chil wcel wa vx cv cC csp co cA cB ax-hvmulass cC chil
      wcel cA cc wcel vx cv chil wcel vx cv cC csp co cc wcel cB chil wcel vx
      cv chil wcel cC chil wcel vx cv cC csp co cc wcel vx cv cC hicl ancoms
      3ad2antl3 cA cc wcel cB chil wcel cC chil wcel w3a cA cc wcel vx cv chil
      wcel cA cc wcel cB chil wcel cC chil wcel 3simp1 adantr cA cc wcel cB
      chil wcel cC chil wcel w3a cB chil wcel vx cv chil wcel cA cc wcel cB
      chil wcel cC chil wcel 3simp2 adantr syl3anc cA cc wcel cB chil wcel cC
      chil wcel w3a vx cv chil wcel wa vx cv cC csp co cA cmul co vx cv cA ccj
      cfv cC csm co csp co cB csm cA cc wcel cC chil wcel vx cv chil wcel vx cv
      cC csp co cA cmul co vx cv cA ccj cfv cC csm co csp co wceq cB chil wcel
      vx cv chil wcel cC chil wcel cA cc wcel vx cv cC csp co cA cmul co vx cv
      cA ccj cfv cC csm co csp co wceq vx cv chil wcel cC chil wcel wa cA cc
      wcel wa vx cv cC csp co cA cmul co cA vx cv cC csp co cmul co vx cv cA
      ccj cfv cC csm co csp co vx cv cC csp co cc wcel cA cc wcel vx cv cC csp
      co cA cmul co cA vx cv cC csp co cmul co wceq vx cv chil wcel cC chil
      wcel wa vx cv cC csp co cA mulcom vx cv cC hicl sylan cA cc wcel vx cv
      chil wcel cC chil wcel wa vx cv cA ccj cfv cC csm co csp co cA vx cv cC
      csp co cmul co wceq cA cc wcel vx cv chil wcel cC chil wcel vx cv cA ccj
      cfv cC csm co csp co cA vx cv cC csp co cmul co wceq cA vx cv cC his52
      3expb ancoms eqtr4d ancom31s 3adantl2 opreq1d eqtr3d eqeq2d pm5.32da
      opabbidv cA cc wcel cB chil wcel cC chil wcel cA cB csm co cC ck co vx cv
      chil wcel vy cv vx cv cC csp co cA cB csm co csm co wceq wa vx vy copab
      wceq cA cB csm co chil wcel cC chil wcel cA cB csm co cC ck co vx cv chil
      wcel vy cv vx cv cC csp co cA cB csm co csm co wceq wa vx vy copab wceq
      cA cc wcel cB chil wcel wa vx vy cA cB csm co cC kbval cA cB hvmulcl
      sylan 3impa cB chil wcel cA cc wcel cC chil wcel cB cA ccj cfv cC csm co
      ck co vx cv chil wcel vy cv vx cv cA ccj cfv cC csm co csp co cB csm co
      wceq wa vx vy copab wceq cB chil wcel cA cc wcel cC chil wcel cB cA ccj
      cfv cC csm co ck co vx cv chil wcel vy cv vx cv cA ccj cfv cC csm co csp
      co cB csm co wceq wa vx vy copab wceq cB chil wcel cA ccj cfv cC csm co
      chil wcel cB cA ccj cfv cC csm co ck co vx cv chil wcel vy cv vx cv cA
      ccj cfv cC csm co csp co cB csm co wceq wa vx vy copab wceq cA cc wcel cC
      chil wcel wa vx vy cB cA ccj cfv cC csm co kbval cA ccj cfv cc wcel cC
      chil wcel cA ccj cfv cC csm co chil wcel cA cc wcel cA ccj cfv cC hvmulcl
      cA cjcl sylan sylan2 3impb 3com12 3eqtr4d $.
      $( [27-Jun-2006] $) $( [31-May-2006] $)

    $( If a vector ` A ` has norm 1, the outer product ` | A >. ` ` <. A | ` is
       the projector onto the subspace spanned by ` A ` .
       ~ http://en.wikipedia.org/wiki/Bra-ket#Linear%5Foperators . $)
    kbpj $p |- ( ( A e. ~H /\ ( normh ` A ) = 1 ) -> ( A ketbra A ) =
                ( proj ` ( span ` { A } ) ) ) $=
      cA chil wcel cA cno cfv c1 wceq wa cA cA ck co cA csn cspn cfv cpj cfv
      wceq vx cv cA cA ck co cfv vx cv cA csn cspn cfv cpj cfv cfv wceq vx chil
      wral cA chil wcel cA cno cfv c1 wceq wa vx cv cA cA ck co cfv vx cv cA
      csn cspn cfv cpj cfv cfv wceq vx chil cA chil wcel cA cno cfv c1 wceq wa
      vx cv chil wcel wa vx cv cA csp co cA cno cfv c2 cexp co cdiv co cA csm
      co vx cv cA csp co cA csm co vx cv cA csn cspn cfv cpj cfv cfv vx cv cA
      cA ck co cfv cA chil wcel cA cno cfv c1 wceq wa vx cv chil wcel wa vx cv
      cA csp co cA cno cfv c2 cexp co cdiv co vx cv cA csp co cA csm cA chil
      wcel vx cv chil wcel cA cno cfv c1 wceq vx cv cA csp co cA cno cfv c2
      cexp co cdiv co vx cv cA csp co wceq cA cno cfv c1 wceq cA chil wcel vx
      cv chil wcel wa vx cv cA csp co cA cno cfv c2 cexp co cdiv co vx cv cA
      csp co c1 cdiv co vx cv cA csp co cA cno cfv c1 wceq cA cno cfv c2 cexp
      co c1 vx cv cA csp co cdiv cA cno cfv c1 wceq cA cno cfv c2 cexp co c1 c2
      cexp co c1 cA cno cfv c1 c2 cexp opreq1 sq1 syl6eq opreq2d cA chil wcel
      vx cv chil wcel wa vx cv cA csp co cc wcel vx cv cA csp co c1 cdiv co vx
      cv cA csp co wceq vx cv chil wcel cA chil wcel vx cv cA csp co cc wcel vx
      cv cA hicl ancoms vx cv cA csp co div1 syl sylan9eqr an1rs opreq1d cA
      chil wcel vx cv chil wcel cA c0v wne vx cv cA csn cspn cfv cpj cfv cfv vx
      cv cA csp co cA cno cfv c2 cexp co cdiv co cA csm co wceq cA chil wcel cA
      cno cfv c1 wceq wa vx cv chil wcel wa cA vx cv pjspansn cA chil wcel cA
      cno cfv c1 wceq vx cv chil wcel simpll cA chil wcel cA cno cfv c1 wceq wa
      vx cv chil wcel pm3.27 cA chil wcel cA cno cfv c1 wceq wa cA c0v wne vx
      cv chil wcel cA chil wcel cA cno cfv c1 wceq cA c0v wne cA chil wcel cA
      cno cfv cc0 wne cA c0v wne cA cno cfv c1 wceq cA normne0 cA cno cfv c1
      wceq cA cno cfv cc0 wne c1 cc0 wne ax1ne0 cA cno cfv c1 cc0 neeq1 mpbiri
      syl5bi imp adantr syl3anc cA chil wcel vx cv chil wcel vx cv cA cA ck co
      cfv vx cv cA csp co cA csm co wceq cA cno cfv c1 wceq cA chil wcel vx cv
      chil wcel vx cv cA cA ck co cfv vx cv cA csp co cA csm co wceq cA cA vx
      cv kbvalval 3anidm12 adantlr 3eqtr4rd r19.21aiva cA chil wcel cA cA ck co
      cA csn cspn cfv cpj cfv wceq vx cv cA cA ck co cfv vx cv cA csn cspn cfv
      cpj cfv cfv wceq vx chil wral wb cA cno cfv c1 wceq cA cA ck co chil wfn
      cA csn cspn cfv cpj cfv chil wfn cA cA ck co cA csn cspn cfv cpj cfv wceq
      vx cv cA cA ck co cfv vx cv cA csn cspn cfv cpj cfv cfv wceq vx chil wral
      wb cA chil wcel vx chil cA cA ck co cA csn cspn cfv cpj cfv eqfnfv2 cA
      chil wcel chil chil cA cA ck co wf cA cA ck co chil wfn cA chil wcel chil
      chil cA cA ck co wf cA cA kbop anidms chil chil cA cA ck co ffn syl cA
      chil wcel cA csn cspn cfv cch wcel cA csn cspn cfv cpj cfv chil wfn cA
      spansnch cA csn cspn cfv pjfn syl sylanc adantr mpbird $.
      $( [6-Aug-2006] $) $( [30-May-2006] $)

    $( Membership in the set of eigenvectors of a Hilbert space operator. $)
    eleigvec $p |- ( T : ~H --> ~H -> ( A e. ( eigvec ` T ) <->
            ( A e. ~H /\ A =/= 0h /\ E. x e. CC ( T ` A ) = ( x .h A ) ) ) ) $=
      chil chil cT wf cA cT cei cfv wcel cA vy cv c0v wne vy cv cT cfv vx cv vy
      cv csm co wceq vx cc wrex wa vy chil crab wcel cA chil wcel cA c0v wne cA
      cT cfv vx cv cA csm co wceq vx cc wrex w3a chil chil cT wf cT cei cfv vy
      cv c0v wne vy cv cT cfv vx cv vy cv csm co wceq vx cc wrex wa vy chil
      crab cA vy vx cT eigvecval eleq2d cA vy cv c0v wne vy cv cT cfv vx cv vy
      cv csm co wceq vx cc wrex wa vy chil crab wcel cA chil wcel cA c0v wne cA
      cT cfv vx cv cA csm co wceq vx cc wrex wa wa cA chil wcel cA c0v wne cA
      cT cfv vx cv cA csm co wceq vx cc wrex w3a vy cv c0v wne vy cv cT cfv vx
      cv vy cv csm co wceq vx cc wrex wa cA c0v wne cA cT cfv vx cv cA csm co
      wceq vx cc wrex wa vy cA chil vy cv cA wceq vy cv c0v wne cA c0v wne vy
      cv cT cfv vx cv vy cv csm co wceq vx cc wrex cA cT cfv vx cv cA csm co
      wceq vx cc wrex vy cv cA c0v neeq1 vy cv cA wceq vy cv cT cfv vx cv vy cv
      csm co wceq cA cT cfv vx cv cA csm co wceq vx cc vy cv cA wceq vy cv cT
      cfv cA cT cfv vx cv vy cv csm co vx cv cA csm co vy cv cA cT fveq2 vy cv
      cA vx cv csm opreq2 eqeq12d rexbidv anbi12d elrab cA chil wcel cA c0v wne
      cA cT cfv vx cv cA csm co wceq vx cc wrex 3anass bitr4i syl6bb $.
      $( [12-Apr-2006] $) $( [11-Mar-2006] $)

    $( Membership in the set of eigenvectors of a Hilbert space operator. $)
    eleigvec2 $p |- ( T : ~H --> ~H -> ( A e. ( eigvec ` T ) <->
            ( A e. ~H /\ A =/= 0h /\ ( T ` A ) e. ( span ` { A } ) ) ) ) $=
      chil chil cT wf cA cT cei cfv wcel cA chil wcel cA c0v wne cA cT cfv vx
      cv cA csm co wceq vx cc wrex w3a cA chil wcel cA c0v wne cA cT cfv cA csn
      cspn cfv wcel w3a vx cA cT eleigvec cA chil wcel cA c0v wne wa cA cT cfv
      cA csn cspn cfv wcel wa cA chil wcel cA c0v wne wa cA cT cfv vx cv cA csm
      co wceq vx cc wrex wa cA chil wcel cA c0v wne cA cT cfv cA csn cspn cfv
      wcel w3a cA chil wcel cA c0v wne cA cT cfv vx cv cA csm co wceq vx cc
      wrex w3a cA chil wcel cA c0v wne wa cA cT cfv cA csn cspn cfv wcel cA cT
      cfv vx cv cA csm co wceq vx cc wrex cA chil wcel cA cT cfv cA csn cspn
      cfv wcel cA cT cfv vx cv cA csm co wceq vx cc wrex wb cA c0v wne vx cA cA
      cT cfv elspansn adantr pm5.32i cA chil wcel cA c0v wne cA cT cfv cA csn
      cspn cfv wcel df-3an cA chil wcel cA c0v wne cA cT cfv vx cv cA csm co
      wceq vx cc wrex df-3an 3bitr4i syl6bbr $.
      $( [15-Apr-2006] $) $( [18-Mar-2006] $)

    $( Closure of an eigenvector of a Hilbert space operator. $)
    eleigveccl $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) ) ->
                      A e. ~H ) $=
      chil chil cT wf cA cT cei cfv wcel wa cA chil wcel cA c0v wne cA cT cfv
      cA csn cspn cfv wcel chil chil cT wf cA cT cei cfv wcel cA chil wcel cA
      c0v wne cA cT cfv cA csn cspn cfv wcel w3a cA cT eleigvec2 biimpa 3simp1d
      $.
      $( [15-Apr-2006] $) $( [23-Mar-2006] $)

    $( The eigenvalue of an eigenvector of a Hilbert space operator. $)
    eigval1 $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) ) ->
  ( ( eigval ` T ) ` A ) = ( ( ( T ` A ) .ih A ) / ( ( normh ` A ) ^ 2 ) ) ) $=
      chil chil cT wf cA cT cei cfv wcel cA cT cel cfv cfv cA vx cv cT cei cfv
      wcel vy cv vx cv cT cfv vx cv csp co vx cv cno cfv c2 cexp co cdiv co
      wceq wa vx vy copab cfv cA cT cfv cA csp co cA cno cfv c2 cexp co cdiv co
      chil chil cT wf cA cT cel cfv vx cv cT cei cfv wcel vy cv vx cv cT cfv vx
      cv csp co vx cv cno cfv c2 cexp co cdiv co wceq wa vx vy copab vx vy cT
      eigvalval fveq1d vx vy cA vx cv cT cfv vx cv csp co vx cv cno cfv c2 cexp
      co cdiv co cA cT cfv cA csp co cA cno cfv c2 cexp co cdiv co cT cei cfv
      vx cv cT cei cfv wcel vy cv vx cv cT cfv vx cv csp co vx cv cno cfv c2
      cexp co cdiv co wceq wa vx vy copab vx cv cA wceq vx cv cT cfv vx cv csp
      co cA cT cfv cA csp co vx cv cno cfv c2 cexp co cA cno cfv c2 cexp co
      cdiv vx cv cA wceq vx cv cT cfv cA cT cfv vx cv cA csp vx cv cA cT fveq2
      vx cv cA wceq id opreq12d vx cv cA wceq vx cv cno cfv cA cno cfv c2 cexp
      vx cv cA cno fveq2 opreq1d opreq12d vx cv cT cei cfv wcel vy cv vx cv cT
      cfv vx cv csp co vx cv cno cfv c2 cexp co cdiv co wceq wa vx vy copab
      eqid cA cT cfv cA csp co cA cno cfv c2 cexp co cdiv oprex fvopab4
      sylan9eq $.
      $( [15-Apr-2006] $) $( [11-Mar-2006] $)

    $( An eigenvalue is a complex number. $)
    eigvalcl $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) )
     -> ( ( eigval ` T ) ` A ) e. CC ) $=
      chil chil cT wf cA cT cei cfv wcel wa cA cT cel cfv cfv cA cT cfv cA csp
      co cA cno cfv c2 cexp co cdiv co cc cA cT eigval1 cA cT cfv cA csp co cc
      wcel cA cno cfv c2 cexp co cc wcel cA cno cfv c2 cexp co cc0 wne cA cT
      cfv cA csp co cA cno cfv c2 cexp co cdiv co cc wcel chil chil cT wf cA cT
      cei cfv wcel wa cA cT cfv cA csp co cA cno cfv c2 cexp co divcl chil chil
      cT wf cA cT cei cfv wcel cA chil wcel cA cT cfv cA csp co cc wcel cA cT
      eleigveccl chil chil cT wf cA chil wcel cA cT cfv chil wcel cA cT cfv cA
      csp co cc wcel chil chil cA cT ffvelrn cA cT cfv cA hicl sylancom syldan
      chil chil cT wf cA cT cei cfv wcel wa cA chil wcel cA cno cfv cc wcel cA
      cno cfv c2 cexp co cc wcel cA cT eleigveccl cA chil wcel cA cno cfv cA
      normcl recnd cA cno cfv sqcl 3syl chil chil cT wf cA cT cei cfv wcel wa
      cA chil wcel cA c0v wne cA cT cfv vx cv cA csm co wceq vx cc wrex w3a cA
      cno cfv c2 cexp co cc0 wne chil chil cT wf cA cT cei cfv wcel cA chil
      wcel cA c0v wne cA cT cfv vx cv cA csm co wceq vx cc wrex w3a vx cA cT
      eleigvec biimpa cA chil wcel cA c0v wne cA cno cfv c2 cexp co cc0 wne cA
      cT cfv vx cv cA csm co wceq vx cc wrex cA chil wcel cA c0v wne cA cno cfv
      c2 cexp co cc0 wne cA chil wcel cA cno cfv c2 cexp co cc0 wne cA cno cfv
      cc0 wne cA c0v wne cA chil wcel cA cno cfv cc wcel cA cno cfv c2 cexp co
      cc0 wne cA cno cfv cc0 wne wb cA chil wcel cA cno cfv cA normcl recnd cA
      cno cfv sqne0 syl cA normne0 bitr2d biimpa 3adant3 syl syl3anc eqeltrd $.
      $( [15-Apr-2006] $) $( [11-Mar-2006] $)

    $( Property of an eigenvector. $)
    eigvec1 $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) ) ->
            ( ( T ` A ) = ( ( ( eigval ` T ) ` A ) .h A ) /\ A =/= 0h ) ) $=
      chil chil cT wf cA cT cei cfv wcel wa cA cT cfv cA cT cel cfv cfv cA csm
      co wceq cA c0v wne chil chil cT wf cA cT cei cfv wcel wa cA cT cel cfv
      cfv cA csm co cA cT cfv cA csp co cA cno cfv c2 cexp co cdiv co cA csm co
      cA cT cfv chil chil cT wf cA cT cei cfv wcel wa cA cT cel cfv cfv cA cT
      cfv cA csp co cA cno cfv c2 cexp co cdiv co cA csm cA cT eigval1 opreq1d
      chil chil cT wf cA cT cei cfv wcel wa cA chil wcel cA c0v wne cA cT cfv
      cA csn cspn cfv wcel w3a cA cT cfv cA csp co cA cno cfv c2 cexp co cdiv
      co cA csm co cA cT cfv wceq chil chil cT wf cA cT cei cfv wcel cA chil
      wcel cA c0v wne cA cT cfv cA csn cspn cfv wcel w3a cA cT eleigvec2 biimpa
      cA cT cfv cA normcan syl eqtr2d chil chil cT wf cA cT cei cfv wcel wa cA
      chil wcel cA c0v wne cA cT cfv cA csn cspn cfv wcel chil chil cT wf cA cT
      cei cfv wcel cA chil wcel cA c0v wne cA cT cfv cA csn cspn cfv wcel w3a
      cA cT eleigvec2 biimpa 3simp2d jca $.
      $( [24-May-2006] $) $( [12-Mar-2006] $)

    $( The eigenvalues of a Hermitian operator are real.  Equation 1.30 of
       [Hughes] p. 49. $)
    eighmre $p |- ( ( T e. HrmOp /\ A e. ( eigvec ` T ) ) ->
                    ( ( eigval ` T ) ` A ) e. RR ) $=
      cA chil wcel cA cT cel cfv cfv cc wcel wa cA cT cfv cA cT cel cfv cfv cA
      csm co wceq cA c0v wne wa wa cA cA cT cfv csp co cA cT cfv cA csp co wceq
      cA cT cel cfv cfv cr wcel cT cho wcel cA cT cei cfv wcel wa cA chil wcel
      cA cT cel cfv cfv cc wcel wa cA cT cfv cA cT cel cfv cfv cA csm co wceq
      cA c0v wne wa wa cA cA cT cfv csp co cA cT cfv cA csp co wceq cA cT cel
      cfv cfv cr wcel cA cA cT cel cfv cfv cT eigre biimpa chil chil cT wf cA
      cT cei cfv wcel cA chil wcel cA cT cel cfv cfv cc wcel wa cA cT cfv cA cT
      cel cfv cfv cA csm co wceq cA c0v wne wa wa cT cho wcel chil chil cT wf
      cA cT cei cfv wcel wa cA chil wcel cA cT cel cfv cfv cc wcel wa cA cT cfv
      cA cT cel cfv cfv cA csm co wceq cA c0v wne wa chil chil cT wf cA cT cei
      cfv wcel wa cA chil wcel cA cT cel cfv cfv cc wcel cA cT eleigveccl cA cT
      eigvalcl jca cA cT eigvec1 jca cT hmopf sylan cT cho wcel cA cT cei cfv
      wcel cA chil wcel cA chil wcel wa cA cA cT cfv csp co cA cT cfv cA csp co
      wceq chil chil cT wf cA cT cei cfv wcel cA chil wcel cA chil wcel wa cT
      cho wcel chil chil cT wf cA cT cei cfv wcel wa cA chil wcel cA chil wcel
      cA cT eleigveccl cA cT eleigveccl jca cT hmopf sylan cT cho wcel cA chil
      wcel cA chil wcel cA cA cT cfv csp co cA cT cfv cA csp co wceq cA cA cT
      hmop 3expb syldan sylanc $.
      $( [27-May-2006] $)

  $}

  ${
    $d x y T $.
    nmopneg.1 $e |- T : ~H --> ~H $.
    $( Value of the norm of the negative of a Hilbert space operator.  Unlike
       ~ nmophmi , the operator does not have to be bounded. $)
    nmopnegi $p |- ( normop ` ( -u 1 .op T ) ) = ( normop ` T ) $=
      vy cv cno cfv c1 cle wbr vx cv vy cv c1 cneg cT chot co cfv cno cfv wceq
      wa vy chil wrex vx cab cxr clt csup vy cv cno cfv c1 cle wbr vx cv vy cv
      cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup c1 cneg cT chot
      co cnop cfv cT cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv c1 cneg cT
      chot co cfv cno cfv wceq wa vy chil wrex vx cab vy cv cno cfv c1 cle wbr
      vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab wceq vy cv cno cfv
      c1 cle wbr vx cv vy cv c1 cneg cT chot co cfv cno cfv wceq wa vy chil
      wrex vx cab cxr clt csup vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno
      cfv wceq wa vy chil wrex vx cab cxr clt csup wceq vy cv cno cfv c1 cle
      wbr vx cv vy cv c1 cneg cT chot co cfv cno cfv wceq wa vy chil wrex vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx vy
      cv cno cfv c1 cle wbr vx cv vy cv c1 cneg cT chot co cfv cno cfv wceq wa
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil vy cv
      chil wcel vx cv vy cv c1 cneg cT chot co cfv cno cfv wceq vx cv vy cv cT
      cfv cno cfv wceq vy cv cno cfv c1 cle wbr vy cv chil wcel vy cv c1 cneg
      cT chot co cfv cno cfv vy cv cT cfv cno cfv vx cv vy cv chil wcel vy cv
      c1 cneg cT chot co cfv cno cfv c1 cneg vy cv cT cfv csm co cno cfv vy cv
      cT cfv cno cfv vy cv chil wcel vy cv c1 cneg cT chot co cfv c1 cneg vy cv
      cT cfv csm co cno c1 cneg cc wcel chil chil cT wf vy cv chil wcel vy cv
      c1 cneg cT chot co cfv c1 cneg vy cv cT cfv csm co wceq c1 ax1cn negcli
      nmopneg.1 c1 cneg vy cv cT homval mp3an12 fveq2d vy cv chil wcel vy cv cT
      cfv chil wcel c1 cneg vy cv cT cfv csm co cno cfv vy cv cT cfv cno cfv
      wceq chil chil vy cv cT nmopneg.1 ffvelrni vy cv cT cfv normneg syl eqtrd
      eqeq2d anbi2d rexbiia abbii cxr vy cv cno cfv c1 cle wbr vx cv vy cv c1
      cneg cT chot co cfv cno cfv wceq wa vy chil wrex vx cab vy cv cno cfv c1
      cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab clt supeq1
      ax-mp chil chil c1 cneg cT chot co wf c1 cneg cT chot co cnop cfv vy cv
      cno cfv c1 cle wbr vx cv vy cv c1 cneg cT chot co cfv cno cfv wceq wa vy
      chil wrex vx cab cxr clt csup wceq c1 cneg cc wcel chil chil cT wf chil
      chil c1 cneg cT chot co wf c1 ax1cn negcli nmopneg.1 c1 cneg cT homulcl
      mp2an vx vy c1 cneg cT chot co nmopval ax-mp chil chil cT wf cT cnop cfv
      vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex
      vx cab cxr clt csup wceq nmopneg.1 vx vy cT nmopval ax-mp 3eqtr4i $.
      $( [26-May-2006] $) $( [10-Mar-2006] $)
  $}

  $( The value of a linear Hilbert space operator at zero is zero.  Remark
     in [Beran] p. 99. $)
  lnop0 $p |- ( T e. LinOp -> ( T ` 0h ) = 0h ) $=
    cT clo wcel c0v cT cfv c0v cT cfv cmv co c0v cT cfv c0v cT cfv cva co c0v
    cT cfv cmv co c0v c0v cT cfv cT clo wcel c0v cT cfv c0v cT cfv c0v cT cfv
    cva co c0v cT cfv cmv cT clo wcel c0v cT cfv c1 c0v cT cfv csm co c0v cT
    cfv cva co c0v cT cfv c0v cT cfv cva co cT clo wcel c1 c0v csm co c0v cva
    co cT cfv c1 c0v cT cfv csm co c0v cT cfv cva co c0v cT cfv cT clo wcel c1
    cc wcel c1 c0v csm co c0v cva co cT cfv c1 c0v cT cfv csm co c0v cT cfv cva
    co wceq ax1cn cT clo wcel c1 cc wcel wa c0v chil wcel c0v chil wcel c1 c0v
    csm co c0v cva co cT cfv c1 c0v cT cfv csm co c0v cT cfv cva co wceq
    ax-hv0cl ax-hv0cl c1 c0v c0v cT lnopl mpanr12 mpan2 c1 c0v csm co c0v cva
    co c0v cT c1 c0v csm co c0v cva co c1 c0v csm co c0v c1 c0v csm co chil
    wcel c1 c0v csm co c0v cva co c1 c0v csm co wceq c1 c0v ax1cn ax-hv0cl
    hvmulcli c1 c0v csm co ax-hvaddid ax-mp c0v chil wcel c1 c0v csm co c0v
    wceq ax-hv0cl c0v ax-hvmulid ax-mp eqtri fveq2i syl5eqr cT clo wcel c1 c0v
    cT cfv csm co c0v cT cfv c0v cT cfv cva cT clo wcel c0v cT cfv chil wcel c1
    c0v cT cfv csm co c0v cT cfv wceq cT clo wcel chil chil cT wf c0v cT cfv
    chil wcel cT lnopf chil chil cT wf c0v chil wcel c0v cT cfv chil wcel
    ax-hv0cl chil chil c0v cT ffvelrn mpan2 syl c0v cT cfv ax-hvmulid syl
    opreq1d eqtrd opreq1d cT clo wcel c0v cT cfv chil wcel c0v cT cfv c0v cT
    cfv cmv co c0v wceq cT clo wcel chil chil cT wf c0v cT cfv chil wcel cT
    lnopf chil chil cT wf c0v chil wcel c0v cT cfv chil wcel ax-hv0cl chil chil
    c0v cT ffvelrn mpan2 syl c0v cT cfv hvsubid syl cT clo wcel c0v cT cfv chil
    wcel c0v cT cfv c0v cT cfv cva co c0v cT cfv cmv co c0v cT cfv wceq cT clo
    wcel chil chil cT wf c0v cT cfv chil wcel cT lnopf chil chil cT wf c0v chil
    wcel c0v cT cfv chil wcel ax-hv0cl chil chil c0v cT ffvelrn mpan2 syl c0v
    cT cfv chil wcel c0v cT cfv c0v cT cfv cva co c0v cT cfv cmv co c0v cT cfv
    wceq c0v cT cfv c0v cT cfv hvpncan anidms syl 3eqtr3rd $.
    $( [15-Aug-2006] $) $( [13-Aug-2006] $)

  $( Multiplicative property of a linear Hilbert space operator. $)
  lnopmul $p |- ( ( T e. LinOp /\ A e. CC /\ B e. ~H ) ->
       ( T ` ( A .h B ) ) = ( A .h ( T ` B ) ) ) $=
    cT clo wcel cA cc wcel cB chil wcel w3a cA cB csm co c0v cva co cT cfv cA
    cB cT cfv csm co c0v cT cfv cva co cA cB csm co cT cfv cA cB cT cfv csm co
    cT clo wcel cA cc wcel cB chil wcel cA cB csm co c0v cva co cT cfv cA cB cT
    cfv csm co c0v cT cfv cva co wceq cT clo wcel cA cc wcel wa cB chil wcel
    c0v chil wcel cA cB csm co c0v cva co cT cfv cA cB cT cfv csm co c0v cT cfv
    cva co wceq ax-hv0cl cA cB c0v cT lnopl mpanr2 3impa cT clo wcel cA cc wcel
    cB chil wcel w3a cA cB csm co c0v cva co cA cB csm co cT cA cc wcel cB chil
    wcel cA cB csm co c0v cva co cA cB csm co wceq cT clo wcel cA cc wcel cB
    chil wcel wa cA cB csm co chil wcel cA cB csm co c0v cva co cA cB csm co
    wceq cA cB hvmulcl cA cB csm co ax-hvaddid syl 3adant1 fveq2d cT clo wcel
    cA cc wcel cB chil wcel w3a cA cB cT cfv csm co c0v cT cfv cva co cA cB cT
    cfv csm co c0v cva co cA cB cT cfv csm co cT clo wcel cA cc wcel cA cB cT
    cfv csm co c0v cT cfv cva co cA cB cT cfv csm co c0v cva co wceq cB chil
    wcel cT clo wcel c0v cT cfv c0v cA cB cT cfv csm co cva cT lnop0 opreq2d
    3ad2ant1 cT clo wcel cA cc wcel cB chil wcel w3a cA cB cT cfv csm co chil
    wcel cA cB cT cfv csm co c0v cva co cA cB cT cfv csm co wceq cA cc wcel cT
    clo wcel cB chil wcel cA cB cT cfv csm co chil wcel cA cc wcel cT clo wcel
    cB chil wcel cA cB cT cfv csm co chil wcel cA cc wcel cB cT cfv chil wcel
    cA cB cT cfv csm co chil wcel cT clo wcel cB chil wcel wa cA cB cT cfv
    hvmulcl chil chil cT wf cB chil wcel cB cT cfv chil wcel cT clo wcel chil
    chil cB cT ffvelrn cT lnopf sylan sylan2 3impb 3com12 cA cB cT cfv csm co
    ax-hvaddid syl eqtrd 3eqtr3d $.
    $( [15-Aug-2006] $) $( [13-Aug-2006] $)

  ${
    lnopl.1 $e |- T e. LinOp $.
    $( Basic scalar product property of a linear Hilbert space operator. $)
    lnopli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A .h ( T ` B ) ) +h ( T ` C ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel cA cB csm co cC cva co cT cfv cA cB
      cT cfv csm co cC cT cfv cva co wceq cT clo wcel cA cc wcel cB chil wcel
      cC chil wcel wa cA cB csm co cC cva co cT cfv cA cB cT cfv csm co cC cT
      cfv cva co wceq lnopl.1 cA cB cC cT lnopl mpanl1 3impb $.
      $( [13-Mar-2006] $) $( [23-Jan-2006] $)

    $( A linear Hilbert space operator is a Hilbert space operator. $)
    lnopfi $p |- T : ~H --> ~H $=
      cT clo wcel chil chil cT wf lnopl.1 cT lnopf ax-mp $.
      $( [17-Mar-2006] $) $( [23-Jan-2006] $)

    $( The value of a linear Hilbert space operator at zero is zero.  Remark
       in [Beran] p. 99. $)
    lnop0i $p |- ( T ` 0h ) = 0h $=
      cT clo wcel c0v cT cfv c0v wceq lnopl.1 cT lnop0 ax-mp $.
      $( [17-Mar-2006] $) $( [11-May-2005] $)

    $( Additive property of a linear Hilbert space operator. $)
    lnopaddi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A +h B ) ) = ( ( T ` A ) +h ( T ` B ) ) ) $=
      cA chil wcel cB chil wcel wa c1 cA csm co cB cva co cT cfv c1 cA cT cfv
      csm co cB cT cfv cva co cA cB cva co cT cfv cA cT cfv cB cT cfv cva co c1
      cc wcel cA chil wcel cB chil wcel c1 cA csm co cB cva co cT cfv c1 cA cT
      cfv csm co cB cT cfv cva co wceq ax1cn c1 cA cB cT lnopl.1 lnopli mp3an1
      cA chil wcel c1 cA csm co cB cva co cT cfv cA cB cva co cT cfv wceq cB
      chil wcel cA chil wcel c1 cA csm co cB cva co cA cB cva co cT cA chil
      wcel c1 cA csm co cA cB cva cA ax-hvmulid opreq1d fveq2d adantr cA chil
      wcel cB chil wcel wa c1 cA cT cfv csm co cA cT cfv cB cT cfv cva cA chil
      wcel c1 cA cT cfv csm co cA cT cfv wceq cB chil wcel cA chil wcel cA cT
      cfv chil wcel c1 cA cT cfv csm co cA cT cfv wceq chil chil cA cT cT
      lnopl.1 lnopfi ffvelrni cA cT cfv ax-hvmulid syl adantr opreq1d 3eqtr3d
      $.
      $( [17-Mar-2006] $) $( [11-May-2005] $)

    $( Multiplicative property of a linear Hilbert space operator. $)
    lnopmuli $p |- ( ( A e. CC /\ B e. ~H ) ->
         ( T ` ( A .h B ) ) = ( A .h ( T ` B ) ) ) $=
      cT clo wcel cA cc wcel cB chil wcel cA cB csm co cT cfv cA cB cT cfv csm
      co wceq lnopl.1 cA cB cT lnopmul mp3an1 $.
      $( [17-Mar-2006] $) $( [11-May-2005] $)

    $( Sum/product property of a linear Hilbert space operator. $)
    lnopaddmuli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( B +h ( A .h C ) ) ) = ( ( T ` B ) +h ( A .h ( T ` C ) ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel w3a cB cA cC csm co cva co cT cfv cB
      cT cfv cA cC csm co cT cfv cva co cB cT cfv cA cC cT cfv csm co cva co cB
      chil wcel cA cc wcel cC chil wcel cB cA cC csm co cva co cT cfv cB cT cfv
      cA cC csm co cT cfv cva co wceq cB chil wcel cA cc wcel cC chil wcel cB
      cA cC csm co cva co cT cfv cB cT cfv cA cC csm co cT cfv cva co wceq cB
      chil wcel cA cC csm co chil wcel cB cA cC csm co cva co cT cfv cB cT cfv
      cA cC csm co cT cfv cva co wceq cA cc wcel cC chil wcel wa cB cA cC csm
      co cT lnopl.1 lnopaddi cA cC hvmulcl sylan2 3impb 3com12 cA cc wcel cB
      chil wcel cC chil wcel w3a cA cC csm co cT cfv cA cC cT cfv csm co cB cT
      cfv cva cA cc wcel cC chil wcel cA cC csm co cT cfv cA cC cT cfv csm co
      wceq cB chil wcel cA cC cT lnopl.1 lnopmuli 3adant2 opreq2d eqtrd $.
      $( [17-Mar-2006] $) $( [1-Jul-2005] $)

    $( Subtraction property for a linear Hilbert space operator. $)
    lnopsubi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A -h B ) ) = ( ( T ` A ) -h ( T ` B ) ) ) $=
      cA chil wcel cB chil wcel wa cA c1 cneg cB csm co cva co cT cfv cA cT cfv
      c1 cneg cB cT cfv csm co cva co cA cB cmv co cT cfv cA cT cfv cB cT cfv
      cmv co c1 cneg cc wcel cA chil wcel cB chil wcel cA c1 cneg cB csm co cva
      co cT cfv cA cT cfv c1 cneg cB cT cfv csm co cva co wceq c1 ax1cn negcli
      c1 cneg cA cB cT lnopl.1 lnopaddmuli mp3an1 cA chil wcel cB chil wcel wa
      cA cB cmv co cA c1 cneg cB csm co cva co cT cA cB hvsubval fveq2d cA cT
      cfv chil wcel cB cT cfv chil wcel cA cT cfv cB cT cfv cmv co cA cT cfv c1
      cneg cB cT cfv csm co cva co wceq cA chil wcel cB chil wcel cA cT cfv cB
      cT cfv hvsubval chil chil cA cT cT lnopl.1 lnopfi ffvelrni chil chil cB
      cT cT lnopl.1 lnopfi ffvelrni syl2an 3eqtr4d $.
      $( [17-Mar-2006] $) $( [1-Jul-2005] $)

    $( Subtraction/product property of a linear Hilbert space operator. $)
    lnopsubmuli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( B -h ( A .h C ) ) ) = ( ( T ` B ) -h ( A .h ( T ` C ) ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel w3a cB cA cC csm co cmv co cT cfv cB
      cT cfv cA cC csm co cT cfv cmv co cB cT cfv cA cC cT cfv csm co cmv co cB
      chil wcel cA cc wcel cC chil wcel cB cA cC csm co cmv co cT cfv cB cT cfv
      cA cC csm co cT cfv cmv co wceq cB chil wcel cA cc wcel cC chil wcel cB
      cA cC csm co cmv co cT cfv cB cT cfv cA cC csm co cT cfv cmv co wceq cB
      chil wcel cA cC csm co chil wcel cB cA cC csm co cmv co cT cfv cB cT cfv
      cA cC csm co cT cfv cmv co wceq cA cc wcel cC chil wcel wa cB cA cC csm
      co cT lnopl.1 lnopsubi cA cC hvmulcl sylan2 3impb 3com12 cA cc wcel cC
      chil wcel cB cT cfv cA cC csm co cT cfv cmv co cB cT cfv cA cC cT cfv csm
      co cmv co wceq cB chil wcel cA cc wcel cC chil wcel wa cA cC csm co cT
      cfv cA cC cT cfv csm co cB cT cfv cmv cA cC cT lnopl.1 lnopmuli opreq2d
      3adant2 eqtrd $.
      $( [28-May-2006] $) $( [2-Jul-2005] $)

    $( Product/subtraction property of a linear Hilbert space operator. $)
    lnopmulsubi $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( ( A .h B ) -h C ) ) = ( ( A .h ( T ` B ) ) -h ( T ` C ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel w3a cA cB csm co cC cmv co cT cfv cA
      cB csm co cT cfv cC cT cfv cmv co cA cB cT cfv csm co cC cT cfv cmv co cA
      cc wcel cB chil wcel cC chil wcel cA cB csm co cC cmv co cT cfv cA cB csm
      co cT cfv cC cT cfv cmv co wceq cA cB csm co chil wcel cC chil wcel cA cB
      csm co cC cmv co cT cfv cA cB csm co cT cfv cC cT cfv cmv co wceq cA cc
      wcel cB chil wcel wa cA cB csm co cC cT lnopl.1 lnopsubi cA cB hvmulcl
      sylan 3impa cA cc wcel cB chil wcel cC chil wcel w3a cA cB csm co cT cfv
      cA cB cT cfv csm co cC cT cfv cmv cA cc wcel cB chil wcel cA cB csm co cT
      cfv cA cB cT cfv csm co wceq cC chil wcel cA cB cT lnopl.1 lnopmuli
      3adant3 opreq1d eqtrd $.
      $( [30-May-2006] $) $( [2-Jul-2005] $)
  $}

  ${
    $d x A $.  $d x T $.  $d x U $.
    $( Move a scalar product out of a composition of operators.  The operator
       ` T ` must be linear, unlike ~ homco1 that works for any operators. $)
    homco2 $p |- ( ( A e. CC /\ T e. LinOp /\ U : ~H --> ~H ) ->
                  ( T o. ( A .op U ) ) = ( A .op ( T o. U ) ) ) $=
      cA cc wcel cT clo wcel chil chil cU wf w3a vx cv cT cA cU chot co ccom
      cfv vx cv cA cT cU ccom chot co cfv wceq vx chil wral cT cA cU chot co
      ccom cA cT cU ccom chot co wceq cA cc wcel cT clo wcel chil chil cU wf
      w3a vx cv cT cA cU chot co ccom cfv vx cv cA cT cU ccom chot co cfv wceq
      vx chil cA cc wcel cT clo wcel chil chil cU wf w3a vx cv chil wcel wa cA
      vx cv cU cfv csm co cT cfv cA vx cv cU cfv cT cfv csm co vx cv cT cA cU
      chot co ccom cfv vx cv cA cT cU ccom chot co cfv cA cc wcel cT clo wcel
      chil chil cU wf vx cv chil wcel cA vx cv cU cfv csm co cT cfv cA vx cv cU
      cfv cT cfv csm co wceq cT clo wcel cA cc wcel chil chil cU wf vx cv chil
      wcel cA vx cv cU cfv csm co cT cfv cA vx cv cU cfv cT cfv csm co wceq wi
      wi cT clo wcel cA cc wcel chil chil cU wf vx cv chil wcel cA vx cv cU cfv
      csm co cT cfv cA vx cv cU cfv cT cfv csm co wceq cT clo wcel cA cc wcel
      chil chil cU wf vx cv chil wcel wa cA vx cv cU cfv csm co cT cfv cA vx cv
      cU cfv cT cfv csm co wceq cT clo wcel cA cc wcel vx cv cU cfv chil wcel
      cA vx cv cU cfv csm co cT cfv cA vx cv cU cfv cT cfv csm co wceq chil
      chil cU wf vx cv chil wcel wa cA vx cv cU cfv cT lnopmul chil chil vx cv
      cU ffvelrn syl3an3 3exp exp4a com12 3imp1 cA cc wcel chil chil cT wf chil
      chil cU wf vx cv chil wcel vx cv cT cA cU chot co ccom cfv cA vx cv cU
      cfv csm co cT cfv wceq cT clo wcel cA cc wcel chil chil cT wf chil chil
      cU wf w3a vx cv chil wcel wa vx cv cT cA cU chot co ccom cfv vx cv cA cU
      chot co cfv cT cfv cA vx cv cU cfv csm co cT cfv cA cc wcel chil chil cT
      wf chil chil cU wf vx cv chil wcel vx cv cT cA cU chot co ccom cfv vx cv
      cA cU chot co cfv cT cfv wceq chil chil cT wf cA cc wcel chil chil cU wf
      vx cv chil wcel vx cv cT cA cU chot co ccom cfv vx cv cA cU chot co cfv
      cT cfv wceq wi wi chil chil cT wf cA cc wcel chil chil cU wf vx cv chil
      wcel vx cv cT cA cU chot co ccom cfv vx cv cA cU chot co cfv cT cfv wceq
      wi chil chil cT wf cA cc wcel chil chil cU wf wa vx cv chil wcel vx cv cT
      cA cU chot co ccom cfv vx cv cA cU chot co cfv cT cfv wceq chil chil cT
      wf chil chil cA cU chot co wf vx cv chil wcel vx cv cT cA cU chot co ccom
      cfv vx cv cA cU chot co cfv cT cfv wceq cA cc wcel chil chil cU wf wa cT
      wfun chil chil cA cU chot co wf vx cv chil wcel vx cv cT cA cU chot co
      ccom cfv vx cv cA cU chot co cfv cT cfv wceq chil chil cT wf chil chil vx
      cv cT cA cU chot co fvco3 chil chil cT ffun syl3an1 cA cU homulcl syl3an2
      3exp exp3a com12 3imp1 cA cc wcel chil chil cT wf chil chil cU wf w3a vx
      cv chil wcel wa vx cv cA cU chot co cfv cA vx cv cU cfv csm co cT cA cc
      wcel chil chil cU wf vx cv chil wcel vx cv cA cU chot co cfv cA vx cv cU
      cfv csm co wceq chil chil cT wf cA cc wcel chil chil cU wf vx cv chil
      wcel vx cv cA cU chot co cfv cA vx cv cU cfv csm co wceq cA vx cv cU
      homval 3expa 3adantl2 fveq2d eqtrd cT lnopf syl3anl2 cA cc wcel chil chil
      cT wf chil chil cU wf vx cv chil wcel vx cv cA cT cU ccom chot co cfv cA
      vx cv cU cfv cT cfv csm co wceq cT clo wcel cA cc wcel chil chil cT wf
      chil chil cU wf w3a vx cv chil wcel wa vx cv cA cT cU ccom chot co cfv cA
      vx cv cT cU ccom cfv csm co cA vx cv cU cfv cT cfv csm co cA cc wcel chil
      chil cT wf chil chil cU wf w3a vx cv chil wcel vx cv cA cT cU ccom chot
      co cfv cA vx cv cT cU ccom cfv csm co wceq cA cc wcel chil chil cT wf
      chil chil cU wf vx cv chil wcel vx cv cA cT cU ccom chot co cfv cA vx cv
      cT cU ccom cfv csm co wceq wi cA cc wcel chil chil cT wf chil chil cU wf
      wa vx cv chil wcel vx cv cA cT cU ccom chot co cfv cA vx cv cT cU ccom
      cfv csm co wceq cA cc wcel chil chil cT cU ccom wf vx cv chil wcel vx cv
      cA cT cU ccom chot co cfv cA vx cv cT cU ccom cfv csm co wceq chil chil
      cT wf chil chil cU wf wa cA vx cv cT cU ccom homval chil chil chil cT cU
      fco syl3an2 3expia 3impb imp chil chil cT wf chil chil cU wf vx cv chil
      wcel cA vx cv cT cU ccom cfv csm co cA vx cv cU cfv cT cfv csm co wceq cA
      cc wcel chil chil cT wf chil chil cU wf wa vx cv chil wcel wa vx cv cT cU
      ccom cfv vx cv cU cfv cT cfv cA csm chil chil cT wf chil chil cU wf vx cv
      chil wcel vx cv cT cU ccom cfv vx cv cU cfv cT cfv wceq cT wfun chil chil
      cU wf vx cv chil wcel vx cv cT cU ccom cfv vx cv cU cfv cT cfv wceq chil
      chil cT wf chil chil vx cv cT cU fvco3 chil chil cT ffun syl3an1 3expa
      opreq2d 3adantl1 eqtrd cT lnopf syl3anl2 3eqtr4d r19.21aiva cA cc wcel
      chil chil cT wf chil chil cU wf vx cv cT cA cU chot co ccom cfv vx cv cA
      cT cU ccom chot co cfv wceq vx chil wral cT cA cU chot co ccom cA cT cU
      ccom chot co wceq wb cT clo wcel chil chil cT cA cU chot co ccom wf chil
      chil cA cT cU ccom chot co wf vx cv cT cA cU chot co ccom cfv vx cv cA cT
      cU ccom chot co cfv wceq vx chil wral cT cA cU chot co ccom cA cT cU ccom
      chot co wceq wb cA cc wcel chil chil cT wf chil chil cU wf w3a vx cT cA
      cU chot co ccom cA cT cU ccom chot co hoeq chil chil cT wf cA cc wcel
      chil chil cU wf chil chil cT cA cU chot co ccom wf chil chil cT wf cA cc
      wcel chil chil cU wf chil chil cT cA cU chot co ccom wf chil chil cT wf
      chil chil cA cU chot co wf chil chil cT cA cU chot co ccom wf cA cc wcel
      chil chil cU wf wa chil chil chil cT cA cU chot co fco cA cU homulcl
      sylan2 3impb 3com12 cA cc wcel chil chil cT wf chil chil cU wf chil chil
      cA cT cU ccom chot co wf cA cc wcel chil chil cT cU ccom wf chil chil cA
      cT cU ccom chot co wf chil chil cT wf chil chil cU wf wa cA cT cU ccom
      homulcl chil chil chil cT cU fco sylan2 3impb sylanc cT lnopf syl3an2
      mpbid $.
      $( [21-Aug-2006] $) $( [13-Aug-2006] $)
  $}

  ${
    $d x y z w $.
    $( The identity function (restricted to Hilbert space) is a unitary
       operator. $)
    idunop $p |- ( _I |` ~H ) e. UniOp $=
      cid chil cres cuo wcel chil chil cid chil cres wfo vx cv cid chil cres
      cfv vy cv cid chil cres cfv csp co vx cv vy cv csp co wceq vy chil wral
      vx chil wral vx vy cid chil cres elunop chil chil cid chil cres wf1o chil
      chil cid chil cres wfo chil f1oi chil chil cid chil cres f1ofo ax-mp vx
      cv cid chil cres cfv vy cv cid chil cres cfv csp co vx cv vy cv csp co
      wceq vx vy chil vx cv chil wcel vy cv chil wcel vx cv cid chil cres cfv
      vx cv vy cv cid chil cres cfv vy cv csp chil vx cv fvresi chil vy cv
      fvresi opreqan12d rgen2a mpbir2an $.
      $( [2-Apr-2006] $) $( [21-Jan-2006] $)

    $( The identically zero function is a continuous Hilbert space operator. $)
    0cnop $p |- 0hop e. ConOp $=
      ch0o cco wcel chil chil ch0o wf cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv
      vx cv cmv co cno cfv vz cv clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv co
      cno cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vy cr wral vx chil
      wral vx vy vz vw ch0o elcnop ho0f cc0 vy cv clt wbr cc0 vz cv clt wbr vw
      cv vx cv cmv co cno cfv vz cv clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv
      co cno cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vx vy chil cr
      vx cv chil wcel vy cv cr wcel wa cc0 vy cv clt wbr c1 cr wcel cc0 c1 clt
      wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv ch0o cfv vx cv ch0o cfv
      cmv co cno cfv vy cv clt wbr wi vw chil wral wa wa cc0 vz cv clt wbr vw
      cv vx cv cmv co cno cfv vz cv clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv
      co cno cfv vy cv clt wbr wi vw chil wral wa vz cr wrex vx cv chil wcel vy
      cv cr wcel wa cc0 vy cv clt wbr c1 cr wcel cc0 c1 clt wbr vw cv vx cv cmv
      co cno cfv c1 clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv co cno cfv vy cv
      clt wbr wi vw chil wral wa cc0 vy cv clt wbr c1 cr wcel wi vx cv chil
      wcel vy cv cr wcel wa c1 cr wcel cc0 vy cv clt wbr 1re a1i a1i vx cv chil
      wcel cc0 vy cv clt wbr cc0 c1 clt wbr vw cv vx cv cmv co cno cfv c1 clt
      wbr vw cv ch0o cfv vx cv ch0o cfv cmv co cno cfv vy cv clt wbr wi vw chil
      wral wa wi vy cv cr wcel vx cv chil wcel cc0 vy cv clt wbr cc0 c1 clt wbr
      vw cv vx cv cmv co cno cfv c1 clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv
      co cno cfv vy cv clt wbr wi vw chil wral cc0 vy cv clt wbr cc0 c1 clt wbr
      wi vx cv chil wcel cc0 c1 clt wbr cc0 vy cv clt wbr lt01 a1i a1i vx cv
      chil wcel cc0 vy cv clt wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv
      ch0o cfv vx cv ch0o cfv cmv co cno cfv vy cv clt wbr wi vw chil vx cv
      chil wcel vw cv chil wcel wa cc0 vy cv clt wbr vw cv ch0o cfv vx cv ch0o
      cfv cmv co cno cfv vy cv clt wbr vw cv vx cv cmv co cno cfv c1 clt wbr vx
      cv chil wcel vw cv chil wcel wa vw cv ch0o cfv vx cv ch0o cfv cmv co cno
      cfv vy cv clt wbr cc0 vy cv clt wbr vx cv chil wcel vw cv chil wcel wa vw
      cv ch0o cfv vx cv ch0o cfv cmv co cno cfv cc0 vy cv clt vx cv chil wcel
      vw cv chil wcel wa vw cv ch0o cfv vx cv ch0o cfv cmv co cno cfv c0v cno
      cfv cc0 vx cv chil wcel vw cv chil wcel wa vw cv ch0o cfv vx cv ch0o cfv
      cmv co c0v cno vx cv chil wcel vw cv chil wcel wa vw cv ch0o cfv vx cv
      ch0o cfv cmv co c0v c0v cmv co c0v vw cv chil wcel vx cv chil wcel vw cv
      ch0o cfv c0v vx cv ch0o cfv c0v cmv vw cv ho0val vx cv ho0val opreqan12rd
      c0v chil wcel c0v c0v cmv co c0v wceq ax-hv0cl c0v hvsubid ax-mp syl6eq
      fveq2d norm0 syl6eq breq1d biimprd a1dd r19.21adva jcad adantr jcad cc0
      vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv ch0o cfv vx
      cv ch0o cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa cc0 c1 clt
      wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv ch0o cfv vx cv ch0o cfv
      cmv co cno cfv vy cv clt wbr wi vw chil wral wa vz c1 cr vz cv c1 wceq
      cc0 vz cv clt wbr cc0 c1 clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr
      vw cv ch0o cfv vx cv ch0o cfv cmv co cno cfv vy cv clt wbr wi vw chil
      wral vw cv vx cv cmv co cno cfv c1 clt wbr vw cv ch0o cfv vx cv ch0o cfv
      cmv co cno cfv vy cv clt wbr wi vw chil wral vz cv c1 cc0 clt breq2 vz cv
      c1 wceq vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv ch0o cfv vx cv
      ch0o cfv cmv co cno cfv vy cv clt wbr wi vw cv vx cv cmv co cno cfv c1
      clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv co cno cfv vy cv clt wbr wi vw
      chil vz cv c1 wceq vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv vx cv
      cmv co cno cfv c1 clt wbr vw cv ch0o cfv vx cv ch0o cfv cmv co cno cfv vy
      cv clt wbr vz cv c1 vw cv vx cv cmv co cno cfv clt breq2 imbi1d ralbidv
      anbi12d rcla4ev syl6 rgen2 mpbir2an $.
      $( [1-Aug-2007] $) $( [7-Feb-2006] $)

    $( The identically zero function is a continuous Hilbert space
       functional. $)
    0cnfn $p |- ( ~H X. { 0 } ) e. ConFn $=
      chil cc0 csn cxp ccnf wcel chil cc chil cc0 csn cxp wf cc0 vy cv clt wbr
      cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv chil cc0
      csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi
      vw chil wral wa vz cr wrex wi vy cr wral vx chil wral vx vy vz vw chil
      cc0 csn cxp elcnfn chil cc0 csn chil cc0 csn cxp wf cc0 csn cc wss chil
      cc chil cc0 csn cxp wf chil cc0 cc0 cc 0cn elisseti fconst cc0 cc wcel
      cc0 csn cc wss 0cn cc0 cc snssi ax-mp chil cc0 csn cc chil cc0 csn cxp
      fss mp2an cc0 vy cv clt wbr cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv
      vz cv clt wbr vw cv chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin
      co cabs cfv vy cv clt wbr wi vw chil wral wa vz cr wrex wi vx vy chil cr
      vx cv chil wcel vy cv cr wcel wa cc0 vy cv clt wbr c1 cr wcel cc0 c1 clt
      wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv chil cc0 csn cxp cfv vx
      cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral wa
      wa cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv chil
      cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr
      wi vw chil wral wa vz cr wrex vx cv chil wcel vy cv cr wcel wa cc0 vy cv
      clt wbr c1 cr wcel cc0 c1 clt wbr vw cv vx cv cmv co cno cfv c1 clt wbr
      vw cv chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy
      cv clt wbr wi vw chil wral wa cc0 vy cv clt wbr c1 cr wcel wi vx cv chil
      wcel vy cv cr wcel wa c1 cr wcel cc0 vy cv clt wbr 1re a1i a1i vx cv chil
      wcel cc0 vy cv clt wbr cc0 c1 clt wbr vw cv vx cv cmv co cno cfv c1 clt
      wbr vw cv chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs
      cfv vy cv clt wbr wi vw chil wral wa wi vy cv cr wcel vx cv chil wcel cc0
      vy cv clt wbr cc0 c1 clt wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv
      chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv
      clt wbr wi vw chil wral cc0 vy cv clt wbr cc0 c1 clt wbr wi vx cv chil
      wcel cc0 c1 clt wbr cc0 vy cv clt wbr lt01 a1i a1i vx cv chil wcel cc0 vy
      cv clt wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv chil cc0 csn cxp
      cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw chil
      vx cv chil wcel vw cv chil wcel wa cc0 vy cv clt wbr vw cv chil cc0 csn
      cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr vw cv
      vx cv cmv co cno cfv c1 clt wbr vx cv chil wcel vw cv chil wcel wa vw cv
      chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv
      clt wbr cc0 vy cv clt wbr vx cv chil wcel vw cv chil wcel wa vw cv chil
      cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv cc0 vy cv clt
      vx cv chil wcel vw cv chil wcel wa vw cv chil cc0 csn cxp cfv vx cv chil
      cc0 csn cxp cfv cmin co cabs cfv cc0 cabs cfv cc0 vx cv chil wcel vw cv
      chil wcel wa vw cv chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin
      co cc0 cabs vx cv chil wcel vw cv chil wcel wa vw cv chil cc0 csn cxp cfv
      vx cv chil cc0 csn cxp cfv cmin co cc0 cc0 cmin co cc0 vw cv chil wcel vx
      cv chil wcel vw cv chil cc0 csn cxp cfv cc0 vx cv chil cc0 csn cxp cfv
      cc0 cmin chil cc0 vw cv cc0 cc 0cn elisseti fvconst2 chil cc0 vx cv cc0
      cc 0cn elisseti fvconst2 opreqan12rd cc0 0cn subidi syl6eq fveq2d abs0
      syl6eq breq1d biimprd a1dd r19.21adva jcad adantr jcad cc0 vz cv clt wbr
      vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv chil cc0 csn cxp cfv vx cv
      chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral wa
      cc0 c1 clt wbr vw cv vx cv cmv co cno cfv c1 clt wbr vw cv chil cc0 csn
      cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw
      chil wral wa vz c1 cr vz cv c1 wceq cc0 vz cv clt wbr cc0 c1 clt wbr vw
      cv vx cv cmv co cno cfv vz cv clt wbr vw cv chil cc0 csn cxp cfv vx cv
      chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral vw cv
      vx cv cmv co cno cfv c1 clt wbr vw cv chil cc0 csn cxp cfv vx cv chil cc0
      csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw chil wral vz cv c1 cc0
      clt breq2 vz cv c1 wceq vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv
      chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv
      clt wbr wi vw cv vx cv cmv co cno cfv c1 clt wbr vw cv chil cc0 csn cxp
      cfv vx cv chil cc0 csn cxp cfv cmin co cabs cfv vy cv clt wbr wi vw chil
      vz cv c1 wceq vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv vx cv cmv co
      cno cfv c1 clt wbr vw cv chil cc0 csn cxp cfv vx cv chil cc0 csn cxp cfv
      cmin co cabs cfv vy cv clt wbr vz cv c1 vw cv vx cv cmv co cno cfv clt
      breq2 imbi1d ralbidv anbi12d rcla4ev syl6 rgen2 mpbir2an $.
      $( [11-Apr-2006] $) $( [7-Feb-2006] $)

    $( The identity function (restricted to Hilbert space) is a continuous
       operator. $)
    idcnop $p |- ( _I |` ~H ) e. ConOp $=
      cid chil cres cco wcel chil chil cid chil cres wf cc0 vy cv clt wbr cc0
      vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cid chil
      cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil
      wral wa vz cr wrex wi vy cr wral vx chil wral vx vy vz vw cid chil cres
      elcnop chil chil cid chil cres wf1o chil chil cid chil cres wf chil f1oi
      chil chil cid chil cres f1of ax-mp cc0 vy cv clt wbr cc0 vz cv clt wbr vw
      cv vx cv cmv co cno cfv vz cv clt wbr vw cv cid chil cres cfv vx cv cid
      chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa vz cr wrex
      wi vx vy chil cr vx cv chil wcel vy cv cr wcel wa cc0 vy cv clt wbr vy cv
      cr wcel cc0 vy cv clt wbr vw cv vx cv cmv co cno cfv vy cv clt wbr vw cv
      cid chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi
      vw chil wral wa wa cc0 vz cv clt wbr vw cv vx cv cmv co cno cfv vz cv clt
      wbr vw cv cid chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv
      clt wbr wi vw chil wral wa vz cr wrex vx cv chil wcel vy cv cr wcel wa
      cc0 vy cv clt wbr cc0 vy cv clt wbr vw cv vx cv cmv co cno cfv vy cv clt
      wbr vw cv cid chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv
      clt wbr wi vw chil wral wa vy cv cr wcel vx cv chil wcel cc0 vy cv clt
      wbr cc0 vy cv clt wbr vw cv vx cv cmv co cno cfv vy cv clt wbr vw cv cid
      chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw
      chil wral wa wi vy cv cr wcel vx cv chil wcel cc0 vy cv clt wbr vw cv vx
      cv cmv co cno cfv vy cv clt wbr vw cv cid chil cres cfv vx cv cid chil
      cres cfv cmv co cno cfv vy cv clt wbr wi vw chil wral vx cv chil wcel vw
      cv vx cv cmv co cno cfv vy cv clt wbr vw cv cid chil cres cfv vx cv cid
      chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil wral cc0 vy cv clt
      wbr vx cv chil wcel vw cv vx cv cmv co cno cfv vy cv clt wbr vw cv cid
      chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw
      chil vx cv chil wcel vw cv chil wcel wa vw cv cid chil cres cfv vx cv cid
      chil cres cfv cmv co cno cfv vy cv clt wbr vw cv vx cv cmv co cno cfv vy
      cv clt wbr vx cv chil wcel vw cv chil wcel wa vw cv cid chil cres cfv vx
      cv cid chil cres cfv cmv co cno cfv vw cv vx cv cmv co cno cfv vy cv clt
      vx cv chil wcel vw cv chil wcel wa vw cv cid chil cres cfv vx cv cid chil
      cres cfv cmv co vw cv vx cv cmv co cno vw cv chil wcel vx cv chil wcel vw
      cv cid chil cres cfv vw cv vx cv cid chil cres cfv vx cv cmv chil vw cv
      fvresi chil vx cv fvresi opreqan12rd fveq2d breq1d biimprd r19.21aiva a1d
      ancld adantr vx cv chil wcel vy cv cr wcel pm3.27 jctild cc0 vz cv clt
      wbr vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cid chil cres cfv vx
      cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil wral wa cc0
      vy cv clt wbr vw cv vx cv cmv co cno cfv vy cv clt wbr vw cv cid chil
      cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil
      wral wa vz vy cv cr vz cv vy cv wceq cc0 vz cv clt wbr cc0 vy cv clt wbr
      vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cid chil cres cfv vx cv
      cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil wral vw cv vx
      cv cmv co cno cfv vy cv clt wbr vw cv cid chil cres cfv vx cv cid chil
      cres cfv cmv co cno cfv vy cv clt wbr wi vw chil wral vz cv vy cv cc0 clt
      breq2 vz cv vy cv wceq vw cv vx cv cmv co cno cfv vz cv clt wbr vw cv cid
      chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy cv clt wbr wi vw
      cv vx cv cmv co cno cfv vy cv clt wbr vw cv cid chil cres cfv vx cv cid
      chil cres cfv cmv co cno cfv vy cv clt wbr wi vw chil vz cv vy cv wceq vw
      cv vx cv cmv co cno cfv vz cv clt wbr vw cv vx cv cmv co cno cfv vy cv
      clt wbr vw cv cid chil cres cfv vx cv cid chil cres cfv cmv co cno cfv vy
      cv clt wbr vz cv vy cv vw cv vx cv cmv co cno cfv clt breq2 imbi1d
      ralbidv anbi12d rcla4ev syl6 rgen2 mpbir2an $.
      $( [12-Apr-2006] $) $( [7-Feb-2006] $)

    $( The Hilbert space identity operator is a Hermitian operator. $)
    idhmop $p |- Iop e. HrmOp $=
      chio cho wcel chil chil chio wf vx cv vy cv chio cfv csp co vx cv chio
      cfv vy cv csp co wceq vy chil wral vx chil wral vx vy chio elhmop chil
      chil chio wf1o chil chil chio wf hoif chil chil chio f1of ax-mp vx cv vy
      cv chio cfv csp co vx cv chio cfv vy cv csp co wceq vx vy chil vx cv chil
      wcel vy cv chil wcel vx cv vx cv chio cfv vy cv chio cfv vy cv csp vx cv
      chil wcel vx cv chio cfv vx cv vx cv hoival eqcomd vy cv hoival
      opreqan12d rgen2a mpbir2an $.
      $( [10-Aug-2006] $) $( [22-Apr-2006] $)

    $( The identically zero function is a Hermitian operator. $)
    0hmop $p |- 0hop e. HrmOp $=
      ch0o cho wcel chil chil ch0o wf vx cv vy cv ch0o cfv csp co vx cv ch0o
      cfv vy cv csp co wceq vy chil wral vx chil wral vx vy ch0o elhmop ho0f vx
      cv vy cv ch0o cfv csp co vx cv ch0o cfv vy cv csp co wceq vx vy chil vx
      cv chil wcel vy cv chil wcel wa vx cv vy cv ch0o cfv csp co cc0 vx cv
      ch0o cfv vy cv csp co vy cv chil wcel vx cv chil wcel vx cv vy cv ch0o
      cfv csp co vx cv c0v csp co cc0 vy cv chil wcel vy cv ch0o cfv c0v vx cv
      csp vy cv ho0val opreq2d vx cv hi02 sylan9eqr vx cv chil wcel vy cv chil
      wcel vx cv ch0o cfv vy cv csp co c0v vy cv csp co cc0 vx cv chil wcel vx
      cv ch0o cfv c0v vy cv csp vx cv ho0val opreq1d vy cv hi01 sylan9eq eqtr4d
      rgen2a mpbir2an $.
      $( [12-Aug-2006] $) $( [8-Aug-2006] $)

    $( The identically zero function is a linear Hilbert space operator. $)
    0lnop $p |- 0hop e. LinOp $=
      ch0o cho wcel ch0o clo wcel 0hmop ch0o hmoplin ax-mp $.
      $( [12-Aug-2006] $) $( [7-Feb-2006] $)

    $( The identically zero function is a linear Hilbert space functional. $)
    0lnfn $p |- ( ~H X. { 0 } ) e. LinFn $=
      chil cc0 csn cxp clf wcel chil cc chil cc0 csn cxp wf vx cv vy cv csm co
      vz cv cva co chil cc0 csn cxp cfv vx cv vy cv chil cc0 csn cxp cfv cmul
      co vz cv chil cc0 csn cxp cfv caddc co wceq vz chil wral vy chil wral vx
      cc wral vx vy vz chil cc0 csn cxp ellnfn chil cc0 csn chil cc0 csn cxp wf
      cc0 csn cc wss chil cc chil cc0 csn cxp wf chil cc0 cc0 cc 0cn elisseti
      fconst cc0 cc wcel cc0 csn cc wss 0cn cc0 cc snssi ax-mp chil cc0 csn cc
      chil cc0 csn cxp fss mp2an vx cv vy cv csm co vz cv cva co chil cc0 csn
      cxp cfv vx cv vy cv chil cc0 csn cxp cfv cmul co vz cv chil cc0 csn cxp
      cfv caddc co wceq vx vy vz cc chil chil vx cv cc wcel vy cv chil wcel vz
      cv chil wcel vx cv vy cv csm co vz cv cva co chil cc0 csn cxp cfv vx cv
      vy cv chil cc0 csn cxp cfv cmul co vz cv chil cc0 csn cxp cfv caddc co
      wceq vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv csm
      co vz cv cva co chil cc0 csn cxp cfv cc0 vx cv vy cv chil cc0 csn cxp cfv
      cmul co vz cv chil cc0 csn cxp cfv caddc co vx cv cc wcel vy cv chil wcel
      wa vz cv chil wcel wa vx cv vy cv csm co vz cv cva co chil wcel vx cv vy
      cv csm co vz cv cva co chil cc0 csn cxp cfv cc0 wceq vx cv vy cv csm co
      chil wcel vz cv chil wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv
      cc wcel vy cv chil wcel wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv
      hvmulcl sylan chil cc0 vx cv vy cv csm co vz cv cva co cc0 cc 0cn
      elisseti fvconst2 syl vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa
      vx cv vy cv chil cc0 csn cxp cfv cmul co vz cv chil cc0 csn cxp cfv caddc
      co cc0 cc0 caddc co cc0 vx cv cc wcel vy cv chil wcel wa vz cv chil wcel
      vx cv vy cv chil cc0 csn cxp cfv cmul co cc0 vz cv chil cc0 csn cxp cfv
      cc0 caddc vy cv chil wcel vx cv cc wcel vx cv vy cv chil cc0 csn cxp cfv
      cmul co vx cv cc0 cmul co cc0 vy cv chil wcel vy cv chil cc0 csn cxp cfv
      cc0 vx cv cmul chil cc0 vy cv cc0 cc 0cn elisseti fvconst2 opreq2d vx cv
      mul01 sylan9eqr chil cc0 vz cv cc0 cc 0cn elisseti fvconst2 opreqan12d
      cc0 0cn addid1i syl6eq eqtr4d 3impa rgen3 mpbir2an $.
      $( [16-Apr-2006] $) $( [14-Feb-2006] $)

    $( The norm of the zero operator is zero. $)
    nmop0 $p |- ( normop ` 0hop ) = 0 $=
      ch0o cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv ch0o cfv cno cfv wceq
      wa vy chil wrex vx cab cxr clt csup cc0 csn cxr clt csup cc0 chil chil
      ch0o wf ch0o cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv ch0o cfv cno
      cfv wceq wa vy chil wrex vx cab cxr clt csup wceq ho0f vx vy ch0o nmopval
      ax-mp vy cv cno cfv c1 cle wbr vx cv vy cv ch0o cfv cno cfv wceq wa vy
      chil wrex vx cab cc0 csn wceq vy cv cno cfv c1 cle wbr vx cv vy cv ch0o
      cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup cc0 csn cxr clt csup
      wceq vy cv cno cfv c1 cle wbr vx cv vy cv ch0o cfv cno cfv wceq wa vy
      chil wrex vx cab vx cv cc0 wceq vx cab cc0 csn vy cv cno cfv c1 cle wbr
      vx cv vy cv ch0o cfv cno cfv wceq wa vy chil wrex vx cv cc0 wceq vx vy cv
      cno cfv c1 cle wbr vx cv cc0 wceq wa vy chil wrex vy cv cno cfv c1 cle
      wbr vy chil wrex vx cv cc0 wceq wa vy cv cno cfv c1 cle wbr vx cv vy cv
      ch0o cfv cno cfv wceq wa vy chil wrex vx cv cc0 wceq vy cv cno cfv c1 cle
      wbr vx cv cc0 wceq vy chil r19.41v vy cv cno cfv c1 cle wbr vx cv vy cv
      ch0o cfv cno cfv wceq wa vy cv cno cfv c1 cle wbr vx cv cc0 wceq wa vy
      chil vy cv chil wcel vx cv vy cv ch0o cfv cno cfv wceq vx cv cc0 wceq vy
      cv cno cfv c1 cle wbr vy cv chil wcel vy cv ch0o cfv cno cfv cc0 vx cv vy
      cv chil wcel vy cv ch0o cfv cno cfv c0v cno cfv cc0 vy cv chil wcel vy cv
      ch0o cfv c0v cno vy cv ho0val fveq2d norm0 syl6eq eqeq2d anbi2d rexbiia
      vy cv cno cfv c1 cle wbr vy chil wrex vx cv cc0 wceq c0v chil wcel cc0 c1
      cle wbr vy cv cno cfv c1 cle wbr vy chil wrex ax-hv0cl cc0 c1 0re 1re
      lt01 ltleii vy cv cno cfv c1 cle wbr cc0 c1 cle wbr vy c0v chil vy cv c0v
      wceq vy cv cno cfv cc0 c1 cle vy cv c0v wceq vy cv cno cfv c0v cno cfv
      cc0 vy cv c0v cno fveq2 norm0 syl6eq breq1d rcla4ev mp2an biantrur
      3bitr4i abbii vx cc0 df-sn eqtr4i cxr vy cv cno cfv c1 cle wbr vx cv vy
      cv ch0o cfv cno cfv wceq wa vy chil wrex vx cab cc0 csn clt supeq1 ax-mp
      cc0 cxr wcel cc0 csn cxr clt csup cc0 wceq cc0 cr wcel cc0 cxr wcel 0re
      cc0 rexr ax-mp cxr cc0 clt xrltso supsn ax-mp 3eqtri $.
      $( [11-Aug-2006] $) $( [8-Feb-2006] $)

    $( The norm of the identically zero functional is zero. $)
    nmfn0 $p |- ( normfn ` ( ~H X. { 0 } ) ) = 0 $=
      chil cc0 csn cxp cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv chil cc0
      csn cxp cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup cc0 csn cxr
      clt csup cc0 chil cc chil cc0 csn cxp wf chil cc0 csn cxp cnmf cfv vy cv
      cno cfv c1 cle wbr vx cv vy cv chil cc0 csn cxp cfv cabs cfv wceq wa vy
      chil wrex vx cab cxr clt csup wceq chil cc0 csn cxp clf wcel chil cc chil
      cc0 csn cxp wf 0lnfn chil cc0 csn cxp lnfnf ax-mp vx vy chil cc0 csn cxp
      nmfnval ax-mp vy cv cno cfv c1 cle wbr vx cv vy cv chil cc0 csn cxp cfv
      cabs cfv wceq wa vy chil wrex vx cab cc0 csn wceq vy cv cno cfv c1 cle
      wbr vx cv vy cv chil cc0 csn cxp cfv cabs cfv wceq wa vy chil wrex vx cab
      cxr clt csup cc0 csn cxr clt csup wceq vy cv cno cfv c1 cle wbr vx cv vy
      cv chil cc0 csn cxp cfv cabs cfv wceq wa vy chil wrex vx cab vx cv cc0
      wceq vx cab cc0 csn vy cv cno cfv c1 cle wbr vx cv vy cv chil cc0 csn cxp
      cfv cabs cfv wceq wa vy chil wrex vx cv cc0 wceq vx vy cv cno cfv c1 cle
      wbr vx cv cc0 wceq wa vy chil wrex vy cv cno cfv c1 cle wbr vy chil wrex
      vx cv cc0 wceq wa vy cv cno cfv c1 cle wbr vx cv vy cv chil cc0 csn cxp
      cfv cabs cfv wceq wa vy chil wrex vx cv cc0 wceq vy cv cno cfv c1 cle wbr
      vx cv cc0 wceq vy chil r19.41v vy cv cno cfv c1 cle wbr vx cv vy cv chil
      cc0 csn cxp cfv cabs cfv wceq wa vy cv cno cfv c1 cle wbr vx cv cc0 wceq
      wa vy chil vy cv chil wcel vx cv vy cv chil cc0 csn cxp cfv cabs cfv wceq
      vx cv cc0 wceq vy cv cno cfv c1 cle wbr vy cv chil wcel vy cv chil cc0
      csn cxp cfv cabs cfv cc0 vx cv vy cv chil wcel vy cv chil cc0 csn cxp cfv
      cabs cfv cc0 cabs cfv cc0 vy cv chil wcel vy cv chil cc0 csn cxp cfv cc0
      cabs chil cc0 vy cv cc0 cr 0re elisseti fvconst2 fveq2d abs0 syl6eq
      eqeq2d anbi2d rexbiia vy cv cno cfv c1 cle wbr vy chil wrex vx cv cc0
      wceq c0v chil wcel cc0 c1 cle wbr vy cv cno cfv c1 cle wbr vy chil wrex
      ax-hv0cl cc0 c1 0re 1re lt01 ltleii vy cv cno cfv c1 cle wbr cc0 c1 cle
      wbr vy c0v chil vy cv c0v wceq vy cv cno cfv cc0 c1 cle vy cv c0v wceq vy
      cv cno cfv c0v cno cfv cc0 vy cv c0v cno fveq2 norm0 syl6eq breq1d
      rcla4ev mp2an biantrur 3bitr4i abbii vx cc0 df-sn eqtr4i cxr vy cv cno
      cfv c1 cle wbr vx cv vy cv chil cc0 csn cxp cfv cabs cfv wceq wa vy chil
      wrex vx cab cc0 csn clt supeq1 ax-mp cc0 cxr wcel cc0 csn cxr clt csup
      cc0 wceq cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp cxr cc0 clt xrltso
      supsn ax-mp 3eqtri $.
      $( [4-May-2006] $) $( [25-Apr-2006] $)
  $}

  ${
    $d x y T $.
    hmopbdop.1 $e |- T e. HrmOp $.
    $( A Hermitian operator is a bounded linear operator (Hellinger-Toeplitz
       Theorem). $)
    hmopbdopiHIL $p |- T e. BndLinOp $=
      vx vy cbo csp cT cva csm cop cno cop clo chil cva csm cop cno cop cva csm
      cop cno cop eqid hhba cva csm cop cno cop cva csm cop cno cop eqid hhip
      cva csm cop cno cop cva csm cop cno cop cva csm cop cno cop clno co cva
      csm cop cno cop eqid cva csm cop cno cop cva csm cop cno cop clno co eqid
      hhlnoi cva csm cop cno cop cva csm cop cno cop cblo co cva csm cop cno
      cop cva csm cop cno cop eqid cva csm cop cno cop cva csm cop cno cop cblo
      co eqid hhbloi hilhl cT cho wcel cT clo wcel hmopbdop.1 cT hmoplin ax-mp
      vx cv chil wcel vy cv chil wcel wa vx cv vy cv cT cfv csp co vx cv cT cfv
      vy cv csp co cT cho wcel vx cv chil wcel vy cv chil wcel vx cv vy cv cT
      cfv csp co vx cv cT cfv vy cv csp co wceq hmopbdop.1 vx cv vy cv cT hmop
      mp3an1 eqcomd htthi $.
      $( [19-Mar-2008] $) $( [18-Jan-2008] $)
  $}

  $( A Hermitian operator is a bounded linear operator (Hellinger-Toeplitz
     Theorem). $)
  hmopbdoptHIL $p |- ( T e. HrmOp -> T e. BndLinOp ) $=
    cT cho wcel cT cbo wcel cT cho wcel cT ch0o cif cbo wcel cT ch0o cT cT cho
    wcel cT ch0o cif cbo eleq1 cT cho wcel cT ch0o cif cT ch0o cho 0hmop elimel
    hmopbdopiHIL dedth $.
    $( [2-Aug-2008] $) $( [18-Jan-2008] $)

  ${
    $d x R $.  $d x S $.  $d x T $.
    hoddi.1 $e |- R e. LinOp $.
    hoddi.2 $e |- S : ~H --> ~H $.
    hoddi.3 $e |- T : ~H --> ~H $.
    $( Distributive law for Hilbert space operator difference.  (Interestingly,
       the reverse distributive law ~ hocsubdiri does not require
       linearity.) $)
    hoddii $p |- ( R o. ( S -op T ) ) = ( ( R o. S ) -op ( R o. T ) ) $=
      vx cv cR cS cT chod co ccom cfv vx cv cR cS ccom cR cT ccom chod co cfv
      wceq vx chil wral cR cS cT chod co ccom cR cS ccom cR cT ccom chod co
      wceq vx cv cR cS cT chod co ccom cfv vx cv cR cS ccom cR cT ccom chod co
      cfv wceq vx chil vx cv chil wcel vx cv cS cT chod co cfv cR cfv vx cv cR
      cS ccom cfv vx cv cR cT ccom cfv cmv co vx cv cR cS cT chod co ccom cfv
      vx cv cR cS ccom cR cT ccom chod co cfv vx cv chil wcel vx cv cS cfv vx
      cv cT cfv cmv co cR cfv vx cv cS cfv cR cfv vx cv cT cfv cR cfv cmv co vx
      cv cS cT chod co cfv cR cfv vx cv cR cS ccom cfv vx cv cR cT ccom cfv cmv
      co vx cv cS cfv chil wcel vx cv cT cfv chil wcel vx cv cS cfv vx cv cT
      cfv cmv co cR cfv vx cv cS cfv cR cfv vx cv cT cfv cR cfv cmv co wceq vx
      cv chil wcel vx cv cS cfv vx cv cT cfv cR hoddi.1 lnopsubi chil chil vx
      cv cS hoddi.2 ffvelrni chil chil vx cv cT hoddi.3 ffvelrni sylanc vx cv
      chil wcel vx cv cS cT chod co cfv vx cv cS cfv vx cv cT cfv cmv co cR
      chil chil cS wf chil chil cT wf vx cv chil wcel vx cv cS cT chod co cfv
      vx cv cS cfv vx cv cT cfv cmv co wceq hoddi.2 hoddi.3 vx cv cS cT
      hodvalOLD mpanl12 fveq2d vx cv chil wcel vx cv cR cS ccom cfv vx cv cS
      cfv cR cfv vx cv cR cT ccom cfv vx cv cT cfv cR cfv cmv vx cv cR cS cR
      hoddi.1 lnopfi hoddi.2 hocoi vx cv cR cT cR hoddi.1 lnopfi hoddi.3 hocoi
      opreq12d 3eqtr4d vx cv cR cS cT chod co cR hoddi.1 lnopfi cS cT hoddi.2
      hoddi.3 hosubcli hocoi chil chil cR cS ccom wf chil chil cR cT ccom wf vx
      cv chil wcel vx cv cR cS ccom cR cT ccom chod co cfv vx cv cR cS ccom cfv
      vx cv cR cT ccom cfv cmv co wceq cR cS cR hoddi.1 lnopfi hoddi.2 hocofi
      cR cT cR hoddi.1 lnopfi hoddi.3 hocofi vx cv cR cS ccom cR cT ccom
      hodvalOLD mpanl12 3eqtr4d rgen vx cR cS cT chod co ccom cR cS ccom cR cT
      ccom chod co cR cS cT chod co cR hoddi.1 lnopfi cS cT hoddi.2 hoddi.3
      hosubcli hocofi cR cS ccom cR cT ccom cR cS cR hoddi.1 lnopfi hoddi.2
      hocofi cR cT cR hoddi.1 lnopfi hoddi.3 hocofi hosubcli hoeqi mpbi $.
      $( [1-May-2006] $) $( [11-Mar-2006] $)
  $}

  $( Distributive law for Hilbert space operator difference.  (Interestingly,
     the reverse distributive law ~ hocsubdiri does not require linearity.) $)
  hoddi $p |- ( ( R e. LinOp /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
              ( R o. ( S -op T ) ) = ( ( R o. S ) -op ( R o. T ) ) ) $=
    cR clo wcel chil chil cS wf chil chil cT wf cR cS cT chod co ccom cR cS
    ccom cR cT ccom chod co wceq cR clo wcel cR ch0o cif cS cT chod co ccom cR
    clo wcel cR ch0o cif cS ccom cR clo wcel cR ch0o cif cT ccom chod co wceq
    cR cS cT ch0o ch0o ch0o cR clo wcel cR ch0o cif chil chil cS wf cS ch0o cif
    cT chod co ccom cR clo wcel cR ch0o cif chil chil cS wf cS ch0o cif ccom cR
    clo wcel cR ch0o cif cT ccom chod co wceq cR clo wcel cR ch0o cif chil chil
    cS wf cS ch0o cif chil chil cT wf cT ch0o cif chod co ccom cR clo wcel cR
    ch0o cif chil chil cS wf cS ch0o cif ccom cR clo wcel cR ch0o cif chil chil
    cT wf cT ch0o cif ccom chod co wceq cR cR clo wcel cR ch0o cif wceq cR cS
    cT chod co ccom cR clo wcel cR ch0o cif cS cT chod co ccom cR cS ccom cR cT
    ccom chod co cR clo wcel cR ch0o cif cS ccom cR clo wcel cR ch0o cif cT
    ccom chod co cR cR clo wcel cR ch0o cif cS cT chod co coeq1 cR cR clo wcel
    cR ch0o cif wceq cR cS ccom cR clo wcel cR ch0o cif cS ccom cR cT ccom cR
    clo wcel cR ch0o cif cT ccom chod cR cR clo wcel cR ch0o cif cS coeq1 cR cR
    clo wcel cR ch0o cif cT coeq1 opreq12d eqeq12d cS chil chil cS wf cS ch0o
    cif wceq cR clo wcel cR ch0o cif cS cT chod co ccom cR clo wcel cR ch0o cif
    chil chil cS wf cS ch0o cif cT chod co ccom cR clo wcel cR ch0o cif cS ccom
    cR clo wcel cR ch0o cif cT ccom chod co cR clo wcel cR ch0o cif chil chil
    cS wf cS ch0o cif ccom cR clo wcel cR ch0o cif cT ccom chod co cS chil chil
    cS wf cS ch0o cif wceq cS cT chod co chil chil cS wf cS ch0o cif cT chod co
    cR clo wcel cR ch0o cif cS chil chil cS wf cS ch0o cif cT chod opreq1
    coeq2d cS chil chil cS wf cS ch0o cif wceq cR clo wcel cR ch0o cif cS ccom
    cR clo wcel cR ch0o cif chil chil cS wf cS ch0o cif ccom cR clo wcel cR
    ch0o cif cT ccom chod cS chil chil cS wf cS ch0o cif cR clo wcel cR ch0o
    cif coeq2 opreq1d eqeq12d cT chil chil cT wf cT ch0o cif wceq cR clo wcel
    cR ch0o cif chil chil cS wf cS ch0o cif cT chod co ccom cR clo wcel cR ch0o
    cif chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif chod co ccom cR
    clo wcel cR ch0o cif chil chil cS wf cS ch0o cif ccom cR clo wcel cR ch0o
    cif cT ccom chod co cR clo wcel cR ch0o cif chil chil cS wf cS ch0o cif
    ccom cR clo wcel cR ch0o cif chil chil cT wf cT ch0o cif ccom chod co cT
    chil chil cT wf cT ch0o cif wceq chil chil cS wf cS ch0o cif cT chod co
    chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif chod co cR clo wcel
    cR ch0o cif cT chil chil cT wf cT ch0o cif chil chil cS wf cS ch0o cif chod
    opreq2 coeq2d cT chil chil cT wf cT ch0o cif wceq cR clo wcel cR ch0o cif
    cT ccom cR clo wcel cR ch0o cif chil chil cT wf cT ch0o cif ccom cR clo
    wcel cR ch0o cif chil chil cS wf cS ch0o cif ccom chod cT chil chil cT wf
    cT ch0o cif cR clo wcel cR ch0o cif coeq2 opreq2d eqeq12d cR clo wcel cR
    ch0o cif chil chil cS wf cS ch0o cif chil chil cT wf cT ch0o cif cR ch0o
    clo 0lnop elimel chil chil cS ch0o ho0f elimf chil chil cT ch0o ho0f elimf
    hoddii dedth3h $.
    $( [17-Sep-2006] $) $( [23-Aug-2006] $)

  $( The norm of any operator on the trivial Hilbert space is zero.
     (This is the reason we need ` ~H =/= 0H ` in ~ nmopun .) $)
  nmop0h $p |- ( ( ~H = 0H /\ T : ~H --> ~H ) -> ( normop ` T ) = 0 ) $=
    chil c0h wceq chil chil cT wf wa cT cnop cfv ch0o cnop cfv cc0 chil c0h
    wceq chil chil cT wf wa cT ch0o cnop chil c0h wceq chil chil cT wf cT ch0o
    wceq chil c0h wceq chil chil cT wf chil c0v csn cT wf cT ch0o wceq chil c0h
    wceq chil c0v csn wceq chil chil cT wf chil c0v csn cT wf wb c0h c0v csn
    chil df-ch0 eqeq2i chil c0v csn chil cT feq3 sylbi chil c0v csn cT wf cT
    chil c0v csn cxp wceq cT ch0o wceq chil c0v cT c0v chil ax-hv0cl elisseti
    fconst2 ch0o chil c0v csn cxp cT ch0o chil c0h cxp chil c0v csn cxp df0op2
    c0h c0v csn chil df-ch0 xpeq2i eqtri eqeq2i bitr4i syl6bb biimpa fveq2d
    nmop0 syl6eq $.
    $( [28-Mar-2006] $) $( [24-Feb-2006] $)

  $( The identity function (restricted to Hilbert space) is a linear
     operator. $)
  idlnop $p |- ( _I |` ~H ) e. LinOp $=
    cid chil cres cuo wcel cid chil cres clo wcel idunop cid chil cres unoplin
    ax-mp $.
    $( [7-Apr-2006] $) $( [24-Jan-2006] $)

  $( The identically zero operator is bounded. $)
  0bdop $p |- 0hop e. BndLinOp $=
    ch0o cbo wcel ch0o clo wcel ch0o cnop cfv cpnf clt wbr ch0o elbdop 0lnop
    ch0o cnop cfv cc0 cpnf clt nmop0 cc0 cr wcel cc0 cpnf clt wbr 0re cc0 ltpnf
    ax-mp eqbrtri mpbir2an $.
    $( [3-Aug-2007] $) $( [14-Feb-2006] $)

  ${
    $d x y $.
    $( Adjoint of the zero operator. $)
    adj0 $p |- ( adjh ` 0hop ) = 0hop $=
      chil chil ch0o wf chil chil ch0o wf vx cv ch0o cfv vy cv csp co vx cv vy
      cv ch0o cfv csp co wceq vy chil wral vx chil wral ch0o cado cfv ch0o wceq
      ho0f ho0f vx cv ch0o cfv vy cv csp co vx cv vy cv ch0o cfv csp co wceq vx
      vy chil vx cv chil wcel vy cv chil wcel wa vx cv ch0o cfv vy cv csp co
      cc0 vx cv vy cv ch0o cfv csp co vx cv chil wcel vy cv chil wcel vx cv
      ch0o cfv vy cv csp co c0v vy cv csp co cc0 vx cv chil wcel vx cv ch0o cfv
      c0v vy cv csp vx cv ho0val opreq1d vy cv hi01 sylan9eq vy cv chil wcel vx
      cv chil wcel vx cv vy cv ch0o cfv csp co vx cv c0v csp co cc0 vy cv chil
      wcel vy cv ch0o cfv c0v vx cv csp vy cv ho0val opreq2d vx cv hi02
      sylan9eqr eqtr4d rgen2a vx vy ch0o ch0o adjeq mp3an $.
      $( [10-Aug-2007] $) $( [20-Feb-2006] $)
  $}

  ${
    $d x y z T $.
    nmlnop0.1 $e |- T e. LinOp $.
    $( A linear operator with a zero norm is identically zero. $)
    nmlnop0iALT $p |- ( ( normop ` T ) = 0 <-> T = 0hop ) $=
      cT cnop cfv cc0 wceq cT ch0o wceq cT cnop cfv cc0 wceq vx cv cT cfv vx cv
      ch0o cfv wceq vx chil wral cT ch0o wceq cT cnop cfv cc0 wceq vx cv cT cfv
      vx cv ch0o cfv wceq vx chil cT cnop cfv cc0 wceq vx cv chil wcel wa vx cv
      cT cfv c0v vx cv ch0o cfv cT cnop cfv cc0 wceq vx cv chil wcel wa vx cv
      cT cfv c0v wne wn vx cv cT cfv c0v wceq cT cnop cfv cc0 wceq vx cv chil
      wcel wa vx cv cT cfv c0v wne cc0 c1 vx cv cno cfv cdiv co vx cv cT cfv
      csm co cno cfv clt wbr vx cv chil wcel vx cv cT cfv c0v wne cc0 c1 vx cv
      cno cfv cdiv co vx cv cT cfv csm co cno cfv clt wbr wi cT cnop cfv cc0
      wceq vx cv chil wcel vx cv cT cfv c0v wne cc0 c1 vx cv cno cfv cdiv co vx
      cv cT cfv csm co cno cfv clt wbr vx cv chil wcel vx cv cT cfv c0v wne wa
      c1 vx cv cno cfv cdiv co vx cv cT cfv csm co c0v wne cc0 c1 vx cv cno cfv
      cdiv co vx cv cT cfv csm co cno cfv clt wbr vx cv chil wcel vx cv cT cfv
      c0v wne wa c1 vx cv cno cfv cdiv co vx cv cT cfv csm co c0v wne c1 vx cv
      cno cfv cdiv co cc0 wne vx cv cT cfv c0v wne wa vx cv chil wcel vx cv cT
      cfv c0v wne wa c1 vx cv cno cfv cdiv co cc0 wne vx cv cT cfv c0v wne vx
      cv cno cfv cc wcel vx cv cno cfv cc0 wne c1 vx cv cno cfv cdiv co cc0 wne
      vx cv chil wcel vx cv cT cfv c0v wne wa vx cv cno cfv recne0 vx cv chil
      wcel vx cv cno cfv cc wcel vx cv cT cfv c0v wne vx cv chil wcel vx cv cno
      cfv vx cv normcl recnd adantr vx cv chil wcel vx cv cT cfv c0v wne vx cv
      cno cfv cc0 wne vx cv chil wcel vx cv cno cfv cc0 vx cv cT cfv c0v vx cv
      chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv cT cfv c0v wceq vx
      cv norm-i vx cv c0v wceq vx cv cT cfv c0v cT cfv c0v vx cv c0v cT fveq2
      cT nmlnop0.1 lnop0i syl6eq syl6bi necon3d imp sylanc vx cv chil wcel vx
      cv cT cfv c0v wne pm3.27 jca vx cv chil wcel vx cv cT cfv c0v wne wa c1
      vx cv cno cfv cdiv co vx cv cT cfv csm co c0v wne c1 vx cv cno cfv cdiv
      co cc0 wceq vx cv cT cfv c0v wceq wo wn c1 vx cv cno cfv cdiv co cc0 wne
      vx cv cT cfv c0v wne wa vx cv chil wcel vx cv cT cfv c0v wne wa c1 vx cv
      cno cfv cdiv co cc0 wceq vx cv cT cfv c0v wceq wo c1 vx cv cno cfv cdiv
      co vx cv cT cfv csm co c0v c1 vx cv cno cfv cdiv co cc wcel vx cv cT cfv
      chil wcel c1 vx cv cno cfv cdiv co vx cv cT cfv csm co c0v wceq c1 vx cv
      cno cfv cdiv co cc0 wceq vx cv cT cfv c0v wceq wo wb vx cv chil wcel vx
      cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx cv cT cfv hvmul0or vx cv
      cno cfv cc wcel vx cv cno cfv cc0 wne c1 vx cv cno cfv cdiv co cc wcel vx
      cv chil wcel vx cv cT cfv c0v wne wa vx cv cno cfv reccl vx cv chil wcel
      vx cv cno cfv cc wcel vx cv cT cfv c0v wne vx cv chil wcel vx cv cno cfv
      vx cv normcl recnd adantr vx cv chil wcel vx cv cT cfv c0v wne vx cv cno
      cfv cc0 wne vx cv chil wcel vx cv cno cfv cc0 vx cv cT cfv c0v vx cv chil
      wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv cT cfv c0v wceq vx cv
      norm-i vx cv c0v wceq vx cv cT cfv c0v cT cfv c0v vx cv c0v cT fveq2 cT
      nmlnop0.1 lnop0i syl6eq syl6bi necon3d imp sylanc vx cv chil wcel vx cv
      cT cfv chil wcel vx cv cT cfv c0v wne chil chil vx cv cT cT nmlnop0.1
      lnopfi ffvelrni adantr sylanc necon3abid c1 vx cv cno cfv cdiv co cc0 vx
      cv cT cfv c0v neanior syl6bbr mpbird vx cv chil wcel vx cv cT cfv c0v wne
      wa c1 vx cv cno cfv cdiv co vx cv cT cfv csm co chil wcel c1 vx cv cno
      cfv cdiv co vx cv cT cfv csm co c0v wne cc0 c1 vx cv cno cfv cdiv co vx
      cv cT cfv csm co cno cfv clt wbr wb c1 vx cv cno cfv cdiv co cc wcel vx
      cv cT cfv chil wcel c1 vx cv cno cfv cdiv co vx cv cT cfv csm co chil
      wcel vx cv chil wcel vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx
      cv cT cfv hvmulcl vx cv cno cfv cc wcel vx cv cno cfv cc0 wne c1 vx cv
      cno cfv cdiv co cc wcel vx cv chil wcel vx cv cT cfv c0v wne wa vx cv cno
      cfv reccl vx cv chil wcel vx cv cno cfv cc wcel vx cv cT cfv c0v wne vx
      cv chil wcel vx cv cno cfv vx cv normcl recnd adantr vx cv chil wcel vx
      cv cT cfv c0v wne vx cv cno cfv cc0 wne vx cv chil wcel vx cv cno cfv cc0
      vx cv cT cfv c0v vx cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx
      cv cT cfv c0v wceq vx cv norm-i vx cv c0v wceq vx cv cT cfv c0v cT cfv
      c0v vx cv c0v cT fveq2 cT nmlnop0.1 lnop0i syl6eq syl6bi necon3d imp
      sylanc vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv c0v wne chil
      chil vx cv cT cT nmlnop0.1 lnopfi ffvelrni adantr sylanc c1 vx cv cno cfv
      cdiv co vx cv cT cfv csm co normgt0 syl mpbid ex adantl cT cnop cfv cc0
      wceq vx cv chil wcel wa vx cv cT cfv c0v wne cc0 c1 vx cv cno cfv cdiv co
      vx cv cT cfv csm co cno cfv clt wbr wn cT cnop cfv cc0 wceq vx cv chil
      wcel wa vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx cv cT cfv csm
      co cno cfv cc0 cle wbr cc0 c1 vx cv cno cfv cdiv co vx cv cT cfv csm co
      cno cfv clt wbr wn cT cnop cfv cc0 wceq vx cv chil wcel wa vx cv cT cfv
      c0v wne wa c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv vz cv cno
      cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab cxr
      clt csup cc0 cle vx cv chil wcel vx cv cT cfv c0v wne c1 vx cv cno cfv
      cdiv co vx cv cT cfv csm co cno cfv vz cv cno cfv c1 cle wbr vy cv vz cv
      cT cfv cno cfv wceq wa vz chil wrex vy cab cxr clt csup cle wbr cT cnop
      cfv cc0 wceq vx cv chil wcel vx cv cT cfv c0v wne wa c1 vx cv cno cfv
      cdiv co vx cv cT cfv csm co cno cfv vz cv cno cfv c1 cle wbr vy cv vz cv
      cT cfv cno cfv wceq wa vz chil wrex vy cab wcel c1 vx cv cno cfv cdiv co
      vx cv cT cfv csm co cno cfv vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv
      cno cfv wceq wa vz chil wrex vy cab cxr clt csup cle wbr vx cv chil wcel
      vx cv cT cfv c0v wne wa vz cv cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co
      vx cv cT cfv csm co cno cfv vz cv cT cfv cno cfv wceq wa vz chil wrex c1
      vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv vz cv cno cfv c1 cle
      wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab wcel c1 vx cv
      cno cfv cdiv co vx cv csm co chil wcel c1 vx cv cno cfv cdiv co vx cv csm
      co cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno
      cfv c1 vx cv cno cfv cdiv co vx cv csm co cT cfv cno cfv wceq wa vz cv
      cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv
      vz cv cT cfv cno cfv wceq wa vz chil wrex vx cv chil wcel vx cv cT cfv
      c0v wne wa vz cv cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv
      csm co cno cfv vz cv cT cfv cno cfv wceq wa c1 vx cv cno cfv cdiv co vx
      cv csm co cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv csm co
      cno cfv c1 vx cv cno cfv cdiv co vx cv csm co cT cfv cno cfv wceq wa vz
      c1 vx cv cno cfv cdiv co vx cv csm co chil vz cv c1 vx cv cno cfv cdiv co
      vx cv csm co wceq vz cv cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv
      csm co cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv csm co
      cno cfv vz cv cT cfv cno cfv wceq c1 vx cv cno cfv cdiv co vx cv cT cfv
      csm co cno cfv c1 vx cv cno cfv cdiv co vx cv csm co cT cfv cno cfv wceq
      vz cv c1 vx cv cno cfv cdiv co vx cv csm co wceq vz cv cno cfv c1 vx cv
      cno cfv cdiv co vx cv csm co cno cfv c1 cle vz cv c1 vx cv cno cfv cdiv
      co vx cv csm co cno fveq2 breq1d vz cv c1 vx cv cno cfv cdiv co vx cv csm
      co wceq vz cv cT cfv cno cfv c1 vx cv cno cfv cdiv co vx cv csm co cT cfv
      cno cfv c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv vz cv c1 vx
      cv cno cfv cdiv co vx cv csm co wceq vz cv cT cfv c1 vx cv cno cfv cdiv
      co vx cv csm co cT cfv cno vz cv c1 vx cv cno cfv cdiv co vx cv csm co cT
      fveq2 fveq2d eqeq2d anbi12d rcla4ev c1 vx cv cno cfv cdiv co cc wcel vx
      cv chil wcel c1 vx cv cno cfv cdiv co vx cv csm co chil wcel vx cv chil
      wcel vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx cv hvmulcl vx cv
      cno cfv cc wcel vx cv cno cfv cc0 wne c1 vx cv cno cfv cdiv co cc wcel vx
      cv chil wcel vx cv cT cfv c0v wne wa vx cv cno cfv reccl vx cv chil wcel
      vx cv cno cfv cc wcel vx cv cT cfv c0v wne vx cv chil wcel vx cv cno cfv
      vx cv normcl recnd adantr vx cv chil wcel vx cv cT cfv c0v wne vx cv cno
      cfv cc0 wne vx cv chil wcel vx cv cno cfv cc0 vx cv cT cfv c0v vx cv chil
      wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv cT cfv c0v wceq vx cv
      norm-i vx cv c0v wceq vx cv cT cfv c0v cT cfv c0v vx cv c0v cT fveq2 cT
      nmlnop0.1 lnop0i syl6eq syl6bi necon3d imp sylanc vx cv chil wcel vx cv
      cT cfv c0v wne pm3.26 sylanc vx cv chil wcel vx cv cT cfv c0v wne wa c1
      vx cv cno cfv cdiv co vx cv csm co cno cfv c1 cle wbr c1 vx cv cno cfv
      cdiv co vx cv cT cfv csm co cno cfv c1 vx cv cno cfv cdiv co vx cv csm co
      cT cfv cno cfv wceq c1 vx cv cno cfv cdiv co vx cv csm co cno cfv cr wcel
      c1 vx cv cno cfv cdiv co vx cv csm co cno cfv c1 wceq c1 vx cv cno cfv
      cdiv co vx cv csm co cno cfv c1 cle wbr vx cv chil wcel vx cv cT cfv c0v
      wne wa c1 vx cv cno cfv cdiv co vx cv csm co cno cfv c1 eqle vx cv chil
      wcel vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx cv csm co cno
      cfv c1 cr vx cv chil wcel vx cv c0v wne c1 vx cv cno cfv cdiv co vx cv
      csm co cno cfv c1 wceq vx cv cT cfv c0v wne vx cv norm1 vx cv c0v vx cv
      cT cfv c0v vx cv c0v wceq vx cv cT cfv c0v cT cfv c0v vx cv c0v cT fveq2
      cT nmlnop0.1 lnop0i syl6eq necon3i sylan2 1re syl6eqel vx cv chil wcel vx
      cv c0v wne c1 vx cv cno cfv cdiv co vx cv csm co cno cfv c1 wceq vx cv cT
      cfv c0v wne vx cv norm1 vx cv c0v vx cv cT cfv c0v vx cv c0v wceq vx cv
      cT cfv c0v cT cfv c0v vx cv c0v cT fveq2 cT nmlnop0.1 lnop0i syl6eq
      necon3i sylan2 sylanc vx cv chil wcel vx cv cT cfv c0v wne wa c1 vx cv
      cno cfv cdiv co vx cv cT cfv csm co c1 vx cv cno cfv cdiv co vx cv csm co
      cT cfv cno vx cv chil wcel vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv
      co vx cv csm co cT cfv c1 vx cv cno cfv cdiv co vx cv cT cfv csm co c1 vx
      cv cno cfv cdiv co cc wcel vx cv chil wcel c1 vx cv cno cfv cdiv co vx cv
      csm co cT cfv c1 vx cv cno cfv cdiv co vx cv cT cfv csm co wceq vx cv
      chil wcel vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx cv cT
      nmlnop0.1 lnopmuli vx cv cno cfv cc wcel vx cv cno cfv cc0 wne c1 vx cv
      cno cfv cdiv co cc wcel vx cv chil wcel vx cv cT cfv c0v wne wa vx cv cno
      cfv reccl vx cv chil wcel vx cv cno cfv cc wcel vx cv cT cfv c0v wne vx
      cv chil wcel vx cv cno cfv vx cv normcl recnd adantr vx cv chil wcel vx
      cv cT cfv c0v wne vx cv cno cfv cc0 wne vx cv chil wcel vx cv cno cfv cc0
      vx cv cT cfv c0v vx cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx
      cv cT cfv c0v wceq vx cv norm-i vx cv c0v wceq vx cv cT cfv c0v cT cfv
      c0v vx cv c0v cT fveq2 cT nmlnop0.1 lnop0i syl6eq syl6bi necon3d imp
      sylanc vx cv chil wcel vx cv cT cfv c0v wne pm3.26 sylanc eqcomd fveq2d
      jca sylanc vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz
      chil wrex vz cv cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv
      csm co cno cfv vz cv cT cfv cno cfv wceq wa vz chil wrex vy c1 vx cv cno
      cfv cdiv co vx cv cT cfv csm co cno cfv c1 vx cv cno cfv cdiv co vx cv cT
      cfv csm co cno fvex vy cv c1 vx cv cno cfv cdiv co vx cv cT cfv csm co
      cno cfv wceq vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa
      vz cv cno cfv c1 cle wbr c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno
      cfv vz cv cT cfv cno cfv wceq wa vz chil vy cv c1 vx cv cno cfv cdiv co
      vx cv cT cfv csm co cno cfv wceq vy cv vz cv cT cfv cno cfv wceq c1 vx cv
      cno cfv cdiv co vx cv cT cfv csm co cno cfv vz cv cT cfv cno cfv wceq vz
      cv cno cfv c1 cle wbr vy cv c1 vx cv cno cfv cdiv co vx cv cT cfv csm co
      cno cfv vz cv cT cfv cno cfv eqeq1 anbi2d rexbidv elab sylibr vz cv cno
      cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab cxr
      wss c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv vz cv cno cfv c1
      cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab wcel c1 vx
      cv cno cfv cdiv co vx cv cT cfv csm co cno cfv vz cv cno cfv c1 cle wbr
      vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab cxr clt csup cle
      wbr vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil
      wrex vy cab cr cxr chil chil cT wf vz cv cno cfv c1 cle wbr vy cv vz cv
      cT cfv cno cfv wceq wa vz chil wrex vy cab cr wss cT nmlnop0.1 lnopfi vy
      vz cT nmopsetretHIL ax-mp ressxr sstri vz cv cno cfv c1 cle wbr vy cv vz
      cv cT cfv cno cfv wceq wa vz chil wrex vy cab c1 vx cv cno cfv cdiv co vx
      cv cT cfv csm co cno cfv supxrub mpan syl adantll cT cnop cfv cc0 wceq vz
      cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy
      cab cxr clt csup cc0 wceq vx cv chil wcel vx cv cT cfv c0v wne cT cnop
      cfv cc0 wceq vz cv cno cfv c1 cle wbr vy cv vz cv cT cfv cno cfv wceq wa
      vz chil wrex vy cab cxr clt csup cc0 wceq cT cnop cfv vz cv cno cfv c1
      cle wbr vy cv vz cv cT cfv cno cfv wceq wa vz chil wrex vy cab cxr clt
      csup cc0 chil chil cT wf cT cnop cfv vz cv cno cfv c1 cle wbr vy cv vz cv
      cT cfv cno cfv wceq wa vz chil wrex vy cab cxr clt csup wceq cT nmlnop0.1
      lnopfi vy vz cT nmopval ax-mp eqeq1i biimpi ad2antrr breqtrd vx cv chil
      wcel vx cv cT cfv c0v wne c1 vx cv cno cfv cdiv co vx cv cT cfv csm co
      cno cfv cc0 cle wbr cc0 c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno
      cfv clt wbr wn wb cT cnop cfv cc0 wceq vx cv chil wcel vx cv cT cfv c0v
      wne wa c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv cr wcel c1 vx
      cv cno cfv cdiv co vx cv cT cfv csm co cno cfv cc0 cle wbr cc0 c1 vx cv
      cno cfv cdiv co vx cv cT cfv csm co cno cfv clt wbr wn wb vx cv chil wcel
      vx cv cT cfv c0v wne wa c1 vx cv cno cfv cdiv co vx cv cT cfv csm co chil
      wcel c1 vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv cr wcel c1 vx
      cv cno cfv cdiv co cc wcel vx cv cT cfv chil wcel c1 vx cv cno cfv cdiv
      co vx cv cT cfv csm co chil wcel vx cv chil wcel vx cv cT cfv c0v wne wa
      c1 vx cv cno cfv cdiv co vx cv cT cfv hvmulcl vx cv cno cfv cc wcel vx cv
      cno cfv cc0 wne c1 vx cv cno cfv cdiv co cc wcel vx cv chil wcel vx cv cT
      cfv c0v wne wa vx cv cno cfv reccl vx cv chil wcel vx cv cno cfv cc wcel
      vx cv cT cfv c0v wne vx cv chil wcel vx cv cno cfv vx cv normcl recnd
      adantr vx cv chil wcel vx cv cT cfv c0v wne vx cv cno cfv cc0 wne vx cv
      chil wcel vx cv cno cfv cc0 vx cv cT cfv c0v vx cv chil wcel vx cv cno
      cfv cc0 wceq vx cv c0v wceq vx cv cT cfv c0v wceq vx cv norm-i vx cv c0v
      wceq vx cv cT cfv c0v cT cfv c0v vx cv c0v cT fveq2 cT nmlnop0.1 lnop0i
      syl6eq syl6bi necon3d imp sylanc vx cv chil wcel vx cv cT cfv chil wcel
      vx cv cT cfv c0v wne chil chil vx cv cT cT nmlnop0.1 lnopfi ffvelrni
      adantr sylanc c1 vx cv cno cfv cdiv co vx cv cT cfv csm co normcl syl c1
      vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv cr wcel cc0 cr wcel c1
      vx cv cno cfv cdiv co vx cv cT cfv csm co cno cfv cc0 cle wbr cc0 c1 vx
      cv cno cfv cdiv co vx cv cT cfv csm co cno cfv clt wbr wn wb 0re c1 vx cv
      cno cfv cdiv co vx cv cT cfv csm co cno cfv cc0 lenlt mpan2 syl adantll
      mpbid ex pm2.65d vx cv cT cfv c0v nne sylib vx cv chil wcel vx cv ch0o
      cfv c0v wceq cT cnop cfv cc0 wceq vx cv ho0val adantl eqtr4d r19.21aiva
      cT chil wfn ch0o chil wfn cT ch0o wceq vx cv cT cfv vx cv ch0o cfv wceq
      vx chil wral wb chil chil cT wf cT chil wfn cT nmlnop0.1 lnopfi chil chil
      cT ffn ax-mp chil chil ch0o wf ch0o chil wfn ho0f chil chil ch0o ffn
      ax-mp vx chil cT ch0o eqfnfv2 mp2an sylibr cT ch0o wceq cT cnop cfv ch0o
      cnop cfv cc0 cT ch0o cnop fveq2 nmop0 syl6eq impbii $.
      $( [12-Aug-2006] $) $( [8-Feb-2006] $)

    $( A linear operator with a zero norm is identically zero. $)
    nmlnop0iHIL $p |- ( ( normop ` T ) = 0 <-> T = 0hop ) $=
      cT clo wcel cT cnop cfv cc0 wceq cT ch0o wceq wb nmlnop0.1 cT cva csm cop
      cno cop clo cnop cva csm cop cno cop ch0o cva csm cop cno cop cva csm cop
      cno cop cva csm cop cno cop cnmo co cva csm cop cno cop eqid cva csm cop
      cno cop cva csm cop cno cop cnmo co eqid hhnmoi cva csm cop cno cop cva
      csm cop cno cop cva csm cop cno cop c0o co cva csm cop cno cop eqid cva
      csm cop cno cop cva csm cop cno cop c0o co eqid hh0oi cva csm cop cno cop
      cva csm cop cno cop cva csm cop cno cop clno co cva csm cop cno cop eqid
      cva csm cop cno cop cva csm cop cno cop clno co eqid hhlnoi cva csm cop
      cno cop cva csm cop cno cop eqid hhnv cva csm cop cno cop cva csm cop cno
      cop eqid hhnv nmlno0i ax-mp $.
      $( [23-May-2008] $) $( [18-Jan-2008] $)

    $( A linear Hilbert space operator that is not identically zero has a
       positive norm. $)
    nmlnopgt0i $p |- ( T =/= 0hop <-> 0 < ( normop ` T ) ) $=
      cT ch0o wne cT cnop cfv cc0 wne cc0 cT cnop cfv clt wbr cT cnop cfv cc0
      cT ch0o cT nmlnop0.1 nmlnop0iHIL necon3bii chil chil cT wf cT cnop cfv
      cc0 wne cc0 cT cnop cfv clt wbr wb cT nmlnop0.1 lnopfi cT nmopgt0 ax-mp
      bitr3i $.
      $( [20-Aug-2006] $) $( [9-Feb-2006] $)
  $}

  $( A linear operator with a zero norm is identically zero. $)
  nmlnop0 $p |- ( T e. LinOp -> ( ( normop ` T ) = 0 <-> T = 0hop ) ) $=
    cT clo wcel cT cnop cfv cc0 wceq cT ch0o wceq wb cT clo wcel cT ch0o cif
    cnop cfv cc0 wceq cT clo wcel cT ch0o cif ch0o wceq wb cT ch0o cT cT clo
    wcel cT ch0o cif wceq cT cnop cfv cc0 wceq cT clo wcel cT ch0o cif cnop cfv
    cc0 wceq cT ch0o wceq cT clo wcel cT ch0o cif ch0o wceq cT cT clo wcel cT
    ch0o cif wceq cT cnop cfv cT clo wcel cT ch0o cif cnop cfv cc0 cT cT clo
    wcel cT ch0o cif cnop fveq2 eqeq1d cT cT clo wcel cT ch0o cif ch0o eqeq1
    bibi12d cT clo wcel cT ch0o cif cT ch0o clo 0lnop elimel nmlnop0iHIL dedth
    $.
    $( [21-Aug-2006] $) $( [12-Aug-2006] $)

  $( A linear operator with a nonzero norm is nonzero. $)
  nmlnopne0 $p |- ( T e. LinOp -> ( ( normop ` T ) =/= 0 <-> T =/= 0hop ) ) $=
    cT clo wcel cT cnop cfv cc0 cT ch0o cT nmlnop0 necon3bid $.
    $( [22-Aug-2006] $) $( [12-Aug-2006] $)

  ${
    $d x y z A $.  $d x y z T $.
    lnopm.1 $e |- T e. LinOp $.
    $( The scalar product of a linear operator is a linear operator. $)
    lnopmi $p |- ( A e. CC -> ( A .op T ) e. LinOp ) $=
      cA cc wcel chil chil cA cT chot co wf vx cv vy cv csm co vz cv cva co cA
      cT chot co cfv vx cv vy cv cA cT chot co cfv csm co vz cv cA cT chot co
      cfv cva co wceq vz chil wral vy chil wral vx cc wral wa cA cT chot co clo
      wcel cA cc wcel chil chil cA cT chot co wf vx cv vy cv csm co vz cv cva
      co cA cT chot co cfv vx cv vy cv cA cT chot co cfv csm co vz cv cA cT
      chot co cfv cva co wceq vz chil wral vy chil wral vx cc wral cA cc wcel
      chil chil cT wf chil chil cA cT chot co wf cT lnopm.1 lnopfi cA cT
      homulcl mpan2 cA cc wcel vx cv vy cv csm co vz cv cva co cA cT chot co
      cfv vx cv vy cv cA cT chot co cfv csm co vz cv cA cT chot co cfv cva co
      wceq vz chil wral vx vy cc chil cA cc wcel vx cv cc wcel vy cv chil wcel
      wa vx cv vy cv csm co vz cv cva co cA cT chot co cfv vx cv vy cv cA cT
      chot co cfv csm co vz cv cA cT chot co cfv cva co wceq vz chil cA cc wcel
      vx cv cc wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv csm co vz cv
      cva co cA cT chot co cfv vx cv vy cv cA cT chot co cfv csm co vz cv cA cT
      chot co cfv cva co wceq cA cc wcel vx cv cc wcel vy cv chil wcel wa vz cv
      chil wcel wa wa cA vx cv vy cv csm co vz cv cva co cT cfv csm co cA vx cv
      vy cv cT cfv csm co csm co cA vz cv cT cfv csm co cva co vx cv vy cv csm
      co vz cv cva co cA cT chot co cfv vx cv vy cv cA cT chot co cfv csm co vz
      cv cA cT chot co cfv cva co cA cc wcel vx cv cc wcel vy cv chil wcel wa
      vz cv chil wcel wa wa cA vx cv vy cv csm co vz cv cva co cT cfv csm co cA
      vx cv vy cv cT cfv csm co vz cv cT cfv cva co csm co cA vx cv vy cv cT
      cfv csm co csm co cA vz cv cT cfv csm co cva co vx cv cc wcel vy cv chil
      wcel wa vz cv chil wcel wa cA vx cv vy cv csm co vz cv cva co cT cfv csm
      co cA vx cv vy cv cT cfv csm co vz cv cT cfv cva co csm co wceq cA cc
      wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv csm
      co vz cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co cA
      csm vx cv cc wcel vy cv chil wcel vz cv chil wcel vx cv vy cv csm co vz
      cv cva co cT cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co wceq vx cv
      vy cv vz cv cT lnopm.1 lnopli 3expa opreq2d adantl cA cc wcel vx cv cc
      wcel vy cv chil wcel wa vz cv chil wcel cA vx cv vy cv cT cfv csm co vz
      cv cT cfv cva co csm co cA vx cv vy cv cT cfv csm co csm co cA vz cv cT
      cfv csm co cva co wceq cA cc wcel vx cv vy cv cT cfv csm co chil wcel vz
      cv cT cfv chil wcel cA vx cv vy cv cT cfv csm co vz cv cT cfv cva co csm
      co cA vx cv vy cv cT cfv csm co csm co cA vz cv cT cfv csm co cva co wceq
      cA cc wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel cA vx cv vy
      cv cT cfv csm co vz cv cT cfv ax-hvdistr1 cA cc wcel id vx cv cc wcel vy
      cv cT cfv chil wcel vx cv vy cv cT cfv csm co chil wcel vy cv chil wcel
      vx cv vy cv cT cfv hvmulcl chil chil vy cv cT cT lnopm.1 lnopfi ffvelrni
      sylan2 chil chil vz cv cT cT lnopm.1 lnopfi ffvelrni syl3an 3expb eqtrd
      cA cc wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv vy cv csm co
      vz cv cva co cA cT chot co cfv cA vx cv vy cv csm co vz cv cva co cT cfv
      csm co wceq vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa cA cc
      wcel chil chil cT wf vx cv vy cv csm co vz cv cva co chil wcel vx cv vy
      cv csm co vz cv cva co cA cT chot co cfv cA vx cv vy cv csm co vz cv cva
      co cT cfv csm co wceq cT lnopm.1 lnopfi cA vx cv vy cv csm co vz cv cva
      co cT homval mp3an2 vx cv vy cv csm co chil wcel vz cv chil wcel vx cv vy
      cv csm co vz cv cva co chil wcel vx cv cc wcel vy cv chil wcel wa vx cv
      vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl sylan sylan2 cA cc wcel vx
      cv cc wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv cA cT chot co
      cfv csm co vz cv cA cT chot co cfv cva co cA vx cv vy cv cT cfv csm co
      csm co cA vz cv cT cfv csm co cva co wceq cA cc wcel vx cv cc wcel vy cv
      chil wcel wa wa cA cc wcel vz cv chil wcel wa vx cv vy cv cA cT chot co
      cfv csm co cA vx cv vy cv cT cfv csm co csm co vz cv cA cT chot co cfv cA
      vz cv cT cfv csm co cva cA cc wcel vx cv cc wcel vy cv chil wcel wa wa vx
      cv vy cv cA cT chot co cfv csm co vx cv cA vy cv cT cfv csm co csm co cA
      vx cv vy cv cT cfv csm co csm co cA cc wcel vx cv cc wcel vy cv chil wcel
      wa wa vy cv cA cT chot co cfv cA vy cv cT cfv csm co vx cv csm cA cc wcel
      vy cv chil wcel vy cv cA cT chot co cfv cA vy cv cT cfv csm co wceq vx cv
      cc wcel cA cc wcel chil chil cT wf vy cv chil wcel vy cv cA cT chot co
      cfv cA vy cv cT cfv csm co wceq cT lnopm.1 lnopfi cA vy cv cT homval
      mp3an2 adantrl opreq2d cA cc wcel vx cv cc wcel vy cv chil wcel cA vx cv
      vy cv cT cfv csm co csm co vx cv cA vy cv cT cfv csm co csm co wceq cA cc
      wcel vx cv cc wcel vy cv cT cfv chil wcel cA vx cv vy cv cT cfv csm co
      csm co vx cv cA vy cv cT cfv csm co csm co wceq vy cv chil wcel cA vx cv
      vy cv cT cfv hvmulcom chil chil vy cv cT cT lnopm.1 lnopfi ffvelrni
      syl3an3 3expb eqtr4d cA cc wcel chil chil cT wf vz cv chil wcel vz cv cA
      cT chot co cfv cA vz cv cT cfv csm co wceq cT lnopm.1 lnopfi cA vz cv cT
      homval mp3an2 opreqan12d anandis 3eqtr4d exp32 r19.21adv r19.21aivv jca
      vx vy vz cA cT chot co ellnop sylibr $.
      $( [6-May-2006] $) $( [10-Mar-2006] $)
  $}

  ${
    $d x y z S $.  $d x y z T $.
    lnopco.1 $e |- S e. LinOp $.
    lnopco.2 $e |- T e. LinOp $.
    $( The sum of two linear operators is linear. $)
    lnophsi $p |- ( S +op T ) e. LinOp $=
      cS cT chos co clo wcel chil chil cS cT chos co wf vx cv vy cv csm co vz
      cv cva co cS cT chos co cfv vx cv vy cv cS cT chos co cfv csm co vz cv cS
      cT chos co cfv cva co wceq vz chil wral vy chil wral vx cc wral vx vy vz
      cS cT chos co ellnop cS cT cS lnopco.1 lnopfi cT lnopco.2 lnopfi hoaddcli
      vx cv vy cv csm co vz cv cva co cS cT chos co cfv vx cv vy cv cS cT chos
      co cfv csm co vz cv cS cT chos co cfv cva co wceq vz chil wral vx vy cc
      chil vx cv cc wcel vy cv chil wcel wa vx cv vy cv csm co vz cv cva co cS
      cT chos co cfv vx cv vy cv cS cT chos co cfv csm co vz cv cS cT chos co
      cfv cva co wceq vz chil vx cv cc wcel vy cv chil wcel wa vz cv chil wcel
      wa vx cv vy cv csm co vz cv cva co cS cfv vx cv vy cv csm co vz cv cva co
      cT cfv cva co vx cv vy cv csm co cS cfv vx cv vy cv csm co cT cfv cva co
      vz cv cS cfv vz cv cT cfv cva co cva co vx cv vy cv csm co vz cv cva co
      cS cT chos co cfv vx cv vy cv cS cT chos co cfv csm co vz cv cS cT chos
      co cfv cva co vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa vx cv
      vy cv csm co vz cv cva co cS cfv vx cv vy cv csm co vz cv cva co cT cfv
      cva co vx cv vy cv csm co cS cfv vz cv cS cfv cva co vx cv vy cv csm co
      cT cfv vz cv cT cfv cva co cva co vx cv vy cv csm co cS cfv vx cv vy cv
      csm co cT cfv cva co vz cv cS cfv vz cv cT cfv cva co cva co vx cv vy cv
      csm co chil wcel vz cv chil wcel vx cv vy cv csm co vz cv cva co cS cfv
      vx cv vy cv csm co vz cv cva co cT cfv cva co vx cv vy cv csm co cS cfv
      vz cv cS cfv cva co vx cv vy cv csm co cT cfv vz cv cT cfv cva co cva co
      wceq vx cv cc wcel vy cv chil wcel wa vx cv vy cv csm co chil wcel vz cv
      chil wcel wa vx cv vy cv csm co vz cv cva co cS cfv vx cv vy cv csm co cS
      cfv vz cv cS cfv cva co vx cv vy cv csm co vz cv cva co cT cfv vx cv vy
      cv csm co cT cfv vz cv cT cfv cva co cva vx cv vy cv csm co vz cv cS
      lnopco.1 lnopaddi vx cv vy cv csm co vz cv cT lnopco.2 lnopaddi opreq12d
      vx cv vy cv hvmulcl sylan vx cv vy cv csm co cS cfv chil wcel vz cv cS
      cfv chil wcel wa vx cv vy cv csm co cT cfv chil wcel vz cv cT cfv chil
      wcel wa vx cv vy cv csm co cS cfv vz cv cS cfv cva co vx cv vy cv csm co
      cT cfv vz cv cT cfv cva co cva co vx cv vy cv csm co cS cfv vx cv vy cv
      csm co cT cfv cva co vz cv cS cfv vz cv cT cfv cva co cva co wceq vx cv
      cc wcel vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv csm co cS cfv
      vz cv cS cfv vx cv vy cv csm co cT cfv vz cv cT cfv hvadd4 vx cv cc wcel
      vy cv chil wcel wa vx cv vy cv csm co cS cfv chil wcel vz cv chil wcel vz
      cv cS cfv chil wcel vx cv cc wcel vy cv chil wcel wa vx cv vy cv csm co
      chil wcel vx cv vy cv csm co cS cfv chil wcel vx cv vy cv hvmulcl chil
      chil vx cv vy cv csm co cS cS lnopco.1 lnopfi ffvelrni syl chil chil vz
      cv cS cS lnopco.1 lnopfi ffvelrni anim12i vx cv cc wcel vy cv chil wcel
      wa vx cv vy cv csm co cT cfv chil wcel vz cv chil wcel vz cv cT cfv chil
      wcel vx cv cc wcel vy cv chil wcel wa vx cv vy cv csm co chil wcel vx cv
      vy cv csm co cT cfv chil wcel vx cv vy cv hvmulcl chil chil vx cv vy cv
      csm co cT cT lnopco.2 lnopfi ffvelrni syl chil chil vz cv cT cT lnopco.2
      lnopfi ffvelrni anim12i sylanc eqtrd vx cv cc wcel vy cv chil wcel wa vz
      cv chil wcel wa vx cv vy cv csm co vz cv cva co chil wcel vx cv vy cv csm
      co vz cv cva co cS cT chos co cfv vx cv vy cv csm co vz cv cva co cS cfv
      vx cv vy cv csm co vz cv cva co cT cfv cva co wceq vx cv vy cv csm co
      chil wcel vz cv chil wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv
      cc wcel vy cv chil wcel wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv
      hvmulcl sylan chil chil cS wf chil chil cT wf vx cv vy cv csm co vz cv
      cva co chil wcel vx cv vy cv csm co vz cv cva co cS cT chos co cfv vx cv
      vy cv csm co vz cv cva co cS cfv vx cv vy cv csm co vz cv cva co cT cfv
      cva co wceq cS lnopco.1 lnopfi cT lnopco.2 lnopfi vx cv vy cv csm co vz
      cv cva co cS cT hosvalOLD mpanl12 syl vx cv cc wcel vy cv chil wcel wa vz
      cv chil wcel vx cv vy cv cS cT chos co cfv csm co vx cv vy cv csm co cS
      cfv vx cv vy cv csm co cT cfv cva co vz cv cS cT chos co cfv vz cv cS cfv
      vz cv cT cfv cva co cva vx cv cc wcel vy cv chil wcel wa vx cv vy cv cS
      cfv vy cv cT cfv cva co csm co vx cv vy cv cS cfv csm co vx cv vy cv cT
      cfv csm co cva co vx cv vy cv cS cT chos co cfv csm co vx cv vy cv csm co
      cS cfv vx cv vy cv csm co cT cfv cva co vx cv cc wcel vy cv cS cfv chil
      wcel vy cv cT cfv chil wcel wa vx cv vy cv cS cfv vy cv cT cfv cva co csm
      co vx cv vy cv cS cfv csm co vx cv vy cv cT cfv csm co cva co wceq vy cv
      chil wcel vx cv cc wcel vy cv cS cfv chil wcel vy cv cT cfv chil wcel vx
      cv vy cv cS cfv vy cv cT cfv cva co csm co vx cv vy cv cS cfv csm co vx
      cv vy cv cT cfv csm co cva co wceq vx cv vy cv cS cfv vy cv cT cfv
      ax-hvdistr1 3expb vy cv chil wcel vy cv cS cfv chil wcel vy cv cT cfv
      chil wcel chil chil vy cv cS cS lnopco.1 lnopfi ffvelrni chil chil vy cv
      cT cT lnopco.2 lnopfi ffvelrni jca sylan2 vy cv chil wcel vx cv vy cv cS
      cT chos co cfv csm co vx cv vy cv cS cfv vy cv cT cfv cva co csm co wceq
      vx cv cc wcel vy cv chil wcel vy cv cS cT chos co cfv vy cv cS cfv vy cv
      cT cfv cva co vx cv csm chil chil cS wf chil chil cT wf vy cv chil wcel
      vy cv cS cT chos co cfv vy cv cS cfv vy cv cT cfv cva co wceq cS lnopco.1
      lnopfi cT lnopco.2 lnopfi vy cv cS cT hosvalOLD mpanl12 opreq2d adantl vx
      cv cc wcel vy cv chil wcel wa vx cv vy cv csm co cS cfv vx cv vy cv cS
      cfv csm co vx cv vy cv csm co cT cfv vx cv vy cv cT cfv csm co cva vx cv
      vy cv cS lnopco.1 lnopmuli vx cv vy cv cT lnopco.2 lnopmuli opreq12d
      3eqtr4d chil chil cS wf chil chil cT wf vz cv chil wcel vz cv cS cT chos
      co cfv vz cv cS cfv vz cv cT cfv cva co wceq cS lnopco.1 lnopfi cT
      lnopco.2 lnopfi vz cv cS cT hosvalOLD mpanl12 opreqan12d 3eqtr4d
      r19.21aiva rgen2 mpbir2an $.
      $( [28-Mar-2006] $) $( [10-Mar-2006] $)

    $( The difference of two linear operators is linear. $)
    lnophdi $p |- ( S -op T ) e. LinOp $=
      cS c1 cneg cT chot co chos co cS cT chod co clo cS cT cS lnopco.1 lnopfi
      cT lnopco.2 lnopfi honegsubi cS c1 cneg cT chot co lnopco.1 c1 cneg cc
      wcel c1 cneg cT chot co clo wcel c1 ax1cn negcli c1 cneg cT lnopco.2
      lnopmi ax-mp lnophsi eqeltrri $.
      $( [28-Jul-2006] $) $( [27-Jul-2006] $)

    $( The composition of two linear operators is linear. $)
    lnopcoi $p |- ( S o. T ) e. LinOp $=
      cS cT ccom clo wcel chil chil cS cT ccom wf vx cv vy cv csm co vz cv cva
      co cS cT ccom cfv vx cv vy cv cS cT ccom cfv csm co vz cv cS cT ccom cfv
      cva co wceq vz chil wral vy chil wral vx cc wral vx vy vz cS cT ccom
      ellnop cS cT cS lnopco.1 lnopfi cT lnopco.2 lnopfi hocofi vx cv vy cv csm
      co vz cv cva co cS cT ccom cfv vx cv vy cv cS cT ccom cfv csm co vz cv cS
      cT ccom cfv cva co wceq vx vy vz cc chil chil vx cv cc wcel vy cv chil
      wcel vz cv chil wcel vx cv vy cv csm co vz cv cva co cS cT ccom cfv vx cv
      vy cv cS cT ccom cfv csm co vz cv cS cT ccom cfv cva co wceq vx cv cc
      wcel vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv csm co vz cv cva
      co cT cfv cS cfv vx cv vy cv cT cfv cS cfv csm co vz cv cT cfv cS cfv cva
      co vx cv vy cv csm co vz cv cva co cS cT ccom cfv vx cv vy cv cS cT ccom
      cfv csm co vz cv cS cT ccom cfv cva co vx cv cc wcel vy cv chil wcel vz
      cv chil wcel vx cv vy cv csm co vz cv cva co cT cfv cS cfv vx cv vy cv cT
      cfv cS cfv csm co vz cv cT cfv cS cfv cva co wceq vx cv cc wcel vy cv
      chil wcel vz cv chil wcel w3a vx cv vy cv csm co vz cv cva co cT cfv cS
      cfv vx cv vy cv cT cfv csm co vz cv cT cfv cva co cS cfv vx cv vy cv cT
      cfv cS cfv csm co vz cv cT cfv cS cfv cva co vx cv cc wcel vy cv chil
      wcel vz cv chil wcel w3a vx cv vy cv csm co vz cv cva co cT cfv vx cv vy
      cv cT cfv csm co vz cv cT cfv cva co cS vx cv vy cv vz cv cT lnopco.2
      lnopli fveq2d vx cv cc wcel vy cv cT cfv chil wcel vz cv cT cfv chil wcel
      vx cv vy cv cT cfv csm co vz cv cT cfv cva co cS cfv vx cv vy cv cT cfv
      cS cfv csm co vz cv cT cfv cS cfv cva co wceq vx cv cc wcel vy cv chil
      wcel vz cv chil wcel vx cv vy cv cT cfv vz cv cT cfv cS lnopco.1 lnopli
      vx cv cc wcel id chil chil vy cv cT cT lnopco.2 lnopfi ffvelrni chil chil
      vz cv cT cT lnopco.2 lnopfi ffvelrni syl3an eqtrd 3expa vx cv cc wcel vy
      cv chil wcel wa vz cv chil wcel wa vx cv vy cv csm co vz cv cva co chil
      wcel vx cv vy cv csm co vz cv cva co cS cT ccom cfv vx cv vy cv csm co vz
      cv cva co cT cfv cS cfv wceq vx cv vy cv csm co chil wcel vz cv chil wcel
      vx cv vy cv csm co vz cv cva co chil wcel vx cv cc wcel vy cv chil wcel
      wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl sylan cS wfun
      chil chil cT wf vx cv vy cv csm co vz cv cva co chil wcel vx cv vy cv csm
      co vz cv cva co cS cT ccom cfv vx cv vy cv csm co vz cv cva co cT cfv cS
      cfv wceq chil chil cS wf cS wfun cS lnopco.1 lnopfi chil chil cS ffun
      ax-mp cT lnopco.2 lnopfi chil chil vx cv vy cv csm co vz cv cva co cS cT
      fvco3 mp3an12 syl vx cv cc wcel vy cv chil wcel wa vz cv chil wcel vx cv
      vy cv cS cT ccom cfv csm co vx cv vy cv cT cfv cS cfv csm co vz cv cS cT
      ccom cfv vz cv cT cfv cS cfv cva vy cv chil wcel vx cv vy cv cS cT ccom
      cfv csm co vx cv vy cv cT cfv cS cfv csm co wceq vx cv cc wcel vy cv chil
      wcel vy cv cS cT ccom cfv vy cv cT cfv cS cfv vx cv csm vy cv cS cT cS
      lnopco.1 lnopfi cT lnopco.2 lnopfi hocoi opreq2d adantl vz cv cS cT cS
      lnopco.1 lnopfi cT lnopco.2 lnopfi hocoi opreqan12d 3eqtr4d 3impa rgen3
      mpbir2an $.
      $( [21-Mar-2006] $) $( [8-Mar-2006] $)

    $( The composition of a linear operator with one whose norm is zero. $)
    lnopco0i $p |- ( ( normop ` T ) = 0 -> ( normop ` ( S o. T ) ) = 0 ) $=
      cT ch0o wceq cS cT ccom ch0o wceq cT cnop cfv cc0 wceq cS cT ccom cnop
      cfv cc0 wceq cT ch0o wceq cS cT ccom cS ch0o ccom ch0o cT ch0o cS coeq2
      cS ch0o ccom ch0o wceq vx cv cS ch0o ccom cfv vx cv ch0o cfv wceq vx chil
      wral vx cv cS ch0o ccom cfv vx cv ch0o cfv wceq vx chil vx cv chil wcel
      vx cv ch0o cfv cS cfv c0v vx cv cS ch0o ccom cfv vx cv ch0o cfv vx cv
      chil wcel vx cv ch0o cfv cS cfv c0v cS cfv c0v vx cv chil wcel vx cv ch0o
      cfv c0v cS vx cv ho0val fveq2d cS lnopco.1 lnop0i syl6eq vx cv cS ch0o cS
      lnopco.1 lnopfi ho0f hocoi vx cv ho0val 3eqtr4d rgen cS ch0o ccom chil
      wfn ch0o chil wfn cS ch0o ccom ch0o wceq vx cv cS ch0o ccom cfv vx cv
      ch0o cfv wceq vx chil wral wb chil chil cS ch0o ccom wf cS ch0o ccom chil
      wfn cS ch0o ccom cS ch0o lnopco.1 0lnop lnopcoi lnopfi chil chil cS ch0o
      ccom ffn ax-mp chil chil ch0o wf ch0o chil wfn ho0f chil chil ch0o ffn
      ax-mp vx chil cS ch0o ccom ch0o eqfnfv2 mp2an mpbir syl6eq cT lnopco.2
      nmlnop0iHIL cS cT ccom cS cT lnopco.1 lnopco.2 lnopcoi nmlnop0iHIL
      3imtr4i $.
      $( [26-Mar-2006] $) $( [10-Mar-2006] $)
  $}

  ${
    $d x y z T $.
    lnopeq0.1 $e |- T e. LinOp $.
    ${
      lnopeq0lem1.2 $e |- A e. ~H $.
      lnopeq0lem1.3 $e |- B e. ~H $.
      $( Lemma for ~ lnopeq0i .  Apply the generalized polarization identity
        ~ polid2i to the quadratic form ` ( ( T `` x ) , x ) ` . $)
      lnopeq0lem1 $p |- ( ( T ` A ) .ih B ) =
             ( ( ( ( ( T ` ( A +h B ) ) .ih ( A +h B ) ) -
                   ( ( T ` ( A -h B ) ) .ih ( A -h B ) ) ) + ( _i x.
        ( ( ( T ` ( A +h ( _i .h B ) ) ) .ih ( A +h ( _i .h B ) ) ) -
      ( ( T ` ( A -h ( _i .h B ) ) ) .ih ( A -h ( _i .h B ) ) ) ) ) ) / 4 ) $=
        cA cT cfv cB csp co cA cT cfv cB cT cfv cva co cA cB cva co csp co cA
        cT cfv cB cT cfv cmv co cA cB cmv co csp co cmin co ci cA cT cfv ci cB
        cT cfv csm co cva co cA ci cB csm co cva co csp co cA cT cfv ci cB cT
        cfv csm co cmv co cA ci cB csm co cmv co csp co cmin co cmul co caddc
        co c4 cdiv co cA cB cva co cT cfv cA cB cva co csp co cA cB cmv co cT
        cfv cA cB cmv co csp co cmin co ci cA ci cB csm co cva co cT cfv cA ci
        cB csm co cva co csp co cA ci cB csm co cmv co cT cfv cA ci cB csm co
        cmv co csp co cmin co cmul co caddc co c4 cdiv co cA cT cfv cB cB cT
        cfv cA cA chil wcel cA cT cfv chil wcel lnopeq0lem1.2 chil chil cA cT
        cT lnopeq0.1 lnopfi ffvelrni ax-mp lnopeq0lem1.3 cB chil wcel cB cT cfv
        chil wcel lnopeq0lem1.3 chil chil cB cT cT lnopeq0.1 lnopfi ffvelrni
        ax-mp lnopeq0lem1.2 polid2i cA cB cva co cT cfv cA cB cva co csp co cA
        cB cmv co cT cfv cA cB cmv co csp co cmin co ci cA ci cB csm co cva co
        cT cfv cA ci cB csm co cva co csp co cA ci cB csm co cmv co cT cfv cA
        ci cB csm co cmv co csp co cmin co cmul co caddc co cA cT cfv cB cT cfv
        cva co cA cB cva co csp co cA cT cfv cB cT cfv cmv co cA cB cmv co csp
        co cmin co ci cA cT cfv ci cB cT cfv csm co cva co cA ci cB csm co cva
        co csp co cA cT cfv ci cB cT cfv csm co cmv co cA ci cB csm co cmv co
        csp co cmin co cmul co caddc co c4 cdiv cA cB cva co cT cfv cA cB cva
        co csp co cA cB cmv co cT cfv cA cB cmv co csp co cmin co cA cT cfv cB
        cT cfv cva co cA cB cva co csp co cA cT cfv cB cT cfv cmv co cA cB cmv
        co csp co cmin co ci cA ci cB csm co cva co cT cfv cA ci cB csm co cva
        co csp co cA ci cB csm co cmv co cT cfv cA ci cB csm co cmv co csp co
        cmin co cmul co ci cA cT cfv ci cB cT cfv csm co cva co cA ci cB csm co
        cva co csp co cA cT cfv ci cB cT cfv csm co cmv co cA ci cB csm co cmv
        co csp co cmin co cmul co caddc cA cB cva co cT cfv cA cB cva co csp co
        cA cT cfv cB cT cfv cva co cA cB cva co csp co cA cB cmv co cT cfv cA
        cB cmv co csp co cA cT cfv cB cT cfv cmv co cA cB cmv co csp co cmin cA
        cB cva co cT cfv cA cT cfv cB cT cfv cva co cA cB cva co csp cA chil
        wcel cB chil wcel cA cB cva co cT cfv cA cT cfv cB cT cfv cva co wceq
        lnopeq0lem1.2 lnopeq0lem1.3 cA cB cT lnopeq0.1 lnopaddi mp2an opreq1i
        cA cB cmv co cT cfv cA cT cfv cB cT cfv cmv co cA cB cmv co csp cA chil
        wcel cB chil wcel cA cB cmv co cT cfv cA cT cfv cB cT cfv cmv co wceq
        lnopeq0lem1.2 lnopeq0lem1.3 cA cB cT lnopeq0.1 lnopsubi mp2an opreq1i
        opreq12i cA ci cB csm co cva co cT cfv cA ci cB csm co cva co csp co cA
        ci cB csm co cmv co cT cfv cA ci cB csm co cmv co csp co cmin co cA cT
        cfv ci cB cT cfv csm co cva co cA ci cB csm co cva co csp co cA cT cfv
        ci cB cT cfv csm co cmv co cA ci cB csm co cmv co csp co cmin co ci
        cmul cA ci cB csm co cva co cT cfv cA ci cB csm co cva co csp co cA cT
        cfv ci cB cT cfv csm co cva co cA ci cB csm co cva co csp co cA ci cB
        csm co cmv co cT cfv cA ci cB csm co cmv co csp co cA cT cfv ci cB cT
        cfv csm co cmv co cA ci cB csm co cmv co csp co cmin cA ci cB csm co
        cva co cT cfv cA cT cfv ci cB cT cfv csm co cva co cA ci cB csm co cva
        co csp ci cc wcel cA chil wcel cB chil wcel cA ci cB csm co cva co cT
        cfv cA cT cfv ci cB cT cfv csm co cva co wceq axicn lnopeq0lem1.2
        lnopeq0lem1.3 ci cA cB cT lnopeq0.1 lnopaddmuli mp3an opreq1i cA ci cB
        csm co cmv co cT cfv cA cT cfv ci cB cT cfv csm co cmv co cA ci cB csm
        co cmv co csp ci cc wcel cA chil wcel cB chil wcel cA ci cB csm co cmv
        co cT cfv cA cT cfv ci cB cT cfv csm co cmv co wceq axicn lnopeq0lem1.2
        lnopeq0lem1.3 ci cA cB cT lnopeq0.1 lnopsubmuli mp3an opreq1i opreq12i
        opreq2i opreq12i opreq1i eqtr4i $.
        $( [3-Aug-2006] $) $( [26-Jul-2006] $)
    $}

    $( Lemma for ~ lnopeq0i . $)
    lnopeq0lem2 $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( T ` A ) .ih B ) =
           ( ( ( ( ( T ` ( A +h B ) ) .ih ( A +h B ) ) -
                 ( ( T ` ( A -h B ) ) .ih ( A -h B ) ) ) + ( _i x.
      ( ( ( T ` ( A +h ( _i .h B ) ) ) .ih ( A +h ( _i .h B ) ) ) -
     ( ( T ` ( A -h ( _i .h B ) ) ) .ih ( A -h ( _i .h B ) ) ) ) ) ) / 4 ) ) $=
      cA chil wcel cB chil wcel cA cT cfv cB csp co cA cB cva co cT cfv cA cB
      cva co csp co cA cB cmv co cT cfv cA cB cmv co csp co cmin co ci cA ci cB
      csm co cva co cT cfv cA ci cB csm co cva co csp co cA ci cB csm co cmv co
      cT cfv cA ci cB csm co cmv co csp co cmin co cmul co caddc co c4 cdiv co
      wceq cA chil wcel cA c0v cif cT cfv cB csp co cA chil wcel cA c0v cif cB
      cva co cT cfv cA chil wcel cA c0v cif cB cva co csp co cA chil wcel cA
      c0v cif cB cmv co cT cfv cA chil wcel cA c0v cif cB cmv co csp co cmin co
      ci cA chil wcel cA c0v cif ci cB csm co cva co cT cfv cA chil wcel cA c0v
      cif ci cB csm co cva co csp co cA chil wcel cA c0v cif ci cB csm co cmv
      co cT cfv cA chil wcel cA c0v cif ci cB csm co cmv co csp co cmin co cmul
      co caddc co c4 cdiv co wceq cA chil wcel cA c0v cif cT cfv cB chil wcel
      cB c0v cif csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co
      cT cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co csp co cA
      chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cT cfv cA chil wcel
      cA c0v cif cB chil wcel cB c0v cif cmv co csp co cmin co ci cA chil wcel
      cA c0v cif ci cB chil wcel cB c0v cif csm co cva co cT cfv cA chil wcel
      cA c0v cif ci cB chil wcel cB c0v cif csm co cva co csp co cA chil wcel
      cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co cT cfv cA chil wcel
      cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co csp co cmin co cmul
      co caddc co c4 cdiv co wceq cA cB c0v c0v cA cA chil wcel cA c0v cif wceq
      cA cT cfv cB csp co cA chil wcel cA c0v cif cT cfv cB csp co cA cB cva co
      cT cfv cA cB cva co csp co cA cB cmv co cT cfv cA cB cmv co csp co cmin
      co ci cA ci cB csm co cva co cT cfv cA ci cB csm co cva co csp co cA ci
      cB csm co cmv co cT cfv cA ci cB csm co cmv co csp co cmin co cmul co
      caddc co c4 cdiv co cA chil wcel cA c0v cif cB cva co cT cfv cA chil wcel
      cA c0v cif cB cva co csp co cA chil wcel cA c0v cif cB cmv co cT cfv cA
      chil wcel cA c0v cif cB cmv co csp co cmin co ci cA chil wcel cA c0v cif
      ci cB csm co cva co cT cfv cA chil wcel cA c0v cif ci cB csm co cva co
      csp co cA chil wcel cA c0v cif ci cB csm co cmv co cT cfv cA chil wcel cA
      c0v cif ci cB csm co cmv co csp co cmin co cmul co caddc co c4 cdiv co cA
      cA chil wcel cA c0v cif wceq cA cT cfv cA chil wcel cA c0v cif cT cfv cB
      csp cA cA chil wcel cA c0v cif cT fveq2 opreq1d cA cA chil wcel cA c0v
      cif wceq cA cB cva co cT cfv cA cB cva co csp co cA cB cmv co cT cfv cA
      cB cmv co csp co cmin co ci cA ci cB csm co cva co cT cfv cA ci cB csm co
      cva co csp co cA ci cB csm co cmv co cT cfv cA ci cB csm co cmv co csp co
      cmin co cmul co caddc co cA chil wcel cA c0v cif cB cva co cT cfv cA chil
      wcel cA c0v cif cB cva co csp co cA chil wcel cA c0v cif cB cmv co cT cfv
      cA chil wcel cA c0v cif cB cmv co csp co cmin co ci cA chil wcel cA c0v
      cif ci cB csm co cva co cT cfv cA chil wcel cA c0v cif ci cB csm co cva
      co csp co cA chil wcel cA c0v cif ci cB csm co cmv co cT cfv cA chil wcel
      cA c0v cif ci cB csm co cmv co csp co cmin co cmul co caddc co c4 cdiv cA
      cA chil wcel cA c0v cif wceq cA cB cva co cT cfv cA cB cva co csp co cA
      cB cmv co cT cfv cA cB cmv co csp co cmin co cA chil wcel cA c0v cif cB
      cva co cT cfv cA chil wcel cA c0v cif cB cva co csp co cA chil wcel cA
      c0v cif cB cmv co cT cfv cA chil wcel cA c0v cif cB cmv co csp co cmin co
      ci cA ci cB csm co cva co cT cfv cA ci cB csm co cva co csp co cA ci cB
      csm co cmv co cT cfv cA ci cB csm co cmv co csp co cmin co cmul co ci cA
      chil wcel cA c0v cif ci cB csm co cva co cT cfv cA chil wcel cA c0v cif
      ci cB csm co cva co csp co cA chil wcel cA c0v cif ci cB csm co cmv co cT
      cfv cA chil wcel cA c0v cif ci cB csm co cmv co csp co cmin co cmul co
      caddc cA cA chil wcel cA c0v cif wceq cA cB cva co cT cfv cA cB cva co
      csp co cA chil wcel cA c0v cif cB cva co cT cfv cA chil wcel cA c0v cif
      cB cva co csp co cA cB cmv co cT cfv cA cB cmv co csp co cA chil wcel cA
      c0v cif cB cmv co cT cfv cA chil wcel cA c0v cif cB cmv co csp co cmin cA
      cA chil wcel cA c0v cif wceq cA cB cva co cT cfv cA chil wcel cA c0v cif
      cB cva co cT cfv cA cB cva co cA chil wcel cA c0v cif cB cva co csp cA cA
      chil wcel cA c0v cif wceq cA cB cva co cA chil wcel cA c0v cif cB cva co
      cT cA cA chil wcel cA c0v cif cB cva opreq1 fveq2d cA cA chil wcel cA c0v
      cif cB cva opreq1 opreq12d cA cA chil wcel cA c0v cif wceq cA cB cmv co
      cT cfv cA chil wcel cA c0v cif cB cmv co cT cfv cA cB cmv co cA chil wcel
      cA c0v cif cB cmv co csp cA cA chil wcel cA c0v cif wceq cA cB cmv co cA
      chil wcel cA c0v cif cB cmv co cT cA cA chil wcel cA c0v cif cB cmv
      opreq1 fveq2d cA cA chil wcel cA c0v cif cB cmv opreq1 opreq12d opreq12d
      cA cA chil wcel cA c0v cif wceq cA ci cB csm co cva co cT cfv cA ci cB
      csm co cva co csp co cA ci cB csm co cmv co cT cfv cA ci cB csm co cmv co
      csp co cmin co cA chil wcel cA c0v cif ci cB csm co cva co cT cfv cA chil
      wcel cA c0v cif ci cB csm co cva co csp co cA chil wcel cA c0v cif ci cB
      csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB csm co cmv co csp co
      cmin co ci cmul cA cA chil wcel cA c0v cif wceq cA ci cB csm co cva co cT
      cfv cA ci cB csm co cva co csp co cA chil wcel cA c0v cif ci cB csm co
      cva co cT cfv cA chil wcel cA c0v cif ci cB csm co cva co csp co cA ci cB
      csm co cmv co cT cfv cA ci cB csm co cmv co csp co cA chil wcel cA c0v
      cif ci cB csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB csm co cmv
      co csp co cmin cA cA chil wcel cA c0v cif wceq cA ci cB csm co cva co cT
      cfv cA chil wcel cA c0v cif ci cB csm co cva co cT cfv cA ci cB csm co
      cva co cA chil wcel cA c0v cif ci cB csm co cva co csp cA cA chil wcel cA
      c0v cif wceq cA ci cB csm co cva co cA chil wcel cA c0v cif ci cB csm co
      cva co cT cA cA chil wcel cA c0v cif ci cB csm co cva opreq1 fveq2d cA cA
      chil wcel cA c0v cif ci cB csm co cva opreq1 opreq12d cA cA chil wcel cA
      c0v cif wceq cA ci cB csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB
      csm co cmv co cT cfv cA ci cB csm co cmv co cA chil wcel cA c0v cif ci cB
      csm co cmv co csp cA cA chil wcel cA c0v cif wceq cA ci cB csm co cmv co
      cA chil wcel cA c0v cif ci cB csm co cmv co cT cA cA chil wcel cA c0v cif
      ci cB csm co cmv opreq1 fveq2d cA cA chil wcel cA c0v cif ci cB csm co
      cmv opreq1 opreq12d opreq12d opreq2d opreq12d opreq1d eqeq12d cB cB chil
      wcel cB c0v cif wceq cA chil wcel cA c0v cif cT cfv cB csp co cA chil
      wcel cA c0v cif cT cfv cB chil wcel cB c0v cif csp co cA chil wcel cA c0v
      cif cB cva co cT cfv cA chil wcel cA c0v cif cB cva co csp co cA chil
      wcel cA c0v cif cB cmv co cT cfv cA chil wcel cA c0v cif cB cmv co csp co
      cmin co ci cA chil wcel cA c0v cif ci cB csm co cva co cT cfv cA chil
      wcel cA c0v cif ci cB csm co cva co csp co cA chil wcel cA c0v cif ci cB
      csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB csm co cmv co csp co
      cmin co cmul co caddc co c4 cdiv co cA chil wcel cA c0v cif cB chil wcel
      cB c0v cif cva co cT cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif
      cva co csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cT
      cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co csp co cmin co
      ci cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co cT
      cfv cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co csp
      co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co cT
      cfv cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co csp
      co cmin co cmul co caddc co c4 cdiv co cB cB chil wcel cB c0v cif cA chil
      wcel cA c0v cif cT cfv csp opreq2 cB cB chil wcel cB c0v cif wceq cA chil
      wcel cA c0v cif cB cva co cT cfv cA chil wcel cA c0v cif cB cva co csp co
      cA chil wcel cA c0v cif cB cmv co cT cfv cA chil wcel cA c0v cif cB cmv
      co csp co cmin co ci cA chil wcel cA c0v cif ci cB csm co cva co cT cfv
      cA chil wcel cA c0v cif ci cB csm co cva co csp co cA chil wcel cA c0v
      cif ci cB csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB csm co cmv
      co csp co cmin co cmul co caddc co cA chil wcel cA c0v cif cB chil wcel
      cB c0v cif cva co cT cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif
      cva co csp co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cT
      cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co csp co cmin co
      ci cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co cT
      cfv cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co csp
      co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co cT
      cfv cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co csp
      co cmin co cmul co caddc co c4 cdiv cB cB chil wcel cB c0v cif wceq cA
      chil wcel cA c0v cif cB cva co cT cfv cA chil wcel cA c0v cif cB cva co
      csp co cA chil wcel cA c0v cif cB cmv co cT cfv cA chil wcel cA c0v cif
      cB cmv co csp co cmin co cA chil wcel cA c0v cif cB chil wcel cB c0v cif
      cva co cT cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cva co csp
      co cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv co cT cfv cA chil
      wcel cA c0v cif cB chil wcel cB c0v cif cmv co csp co cmin co ci cA chil
      wcel cA c0v cif ci cB csm co cva co cT cfv cA chil wcel cA c0v cif ci cB
      csm co cva co csp co cA chil wcel cA c0v cif ci cB csm co cmv co cT cfv
      cA chil wcel cA c0v cif ci cB csm co cmv co csp co cmin co cmul co ci cA
      chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co cT cfv cA
      chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co csp co cA
      chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co cT cfv cA
      chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co csp co cmin
      co cmul co caddc cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif
      cB cva co cT cfv cA chil wcel cA c0v cif cB cva co csp co cA chil wcel cA
      c0v cif cB chil wcel cB c0v cif cva co cT cfv cA chil wcel cA c0v cif cB
      chil wcel cB c0v cif cva co csp co cA chil wcel cA c0v cif cB cmv co cT
      cfv cA chil wcel cA c0v cif cB cmv co csp co cA chil wcel cA c0v cif cB
      chil wcel cB c0v cif cmv co cT cfv cA chil wcel cA c0v cif cB chil wcel
      cB c0v cif cmv co csp co cmin cB cB chil wcel cB c0v cif wceq cA chil
      wcel cA c0v cif cB cva co cT cfv cA chil wcel cA c0v cif cB chil wcel cB
      c0v cif cva co cT cfv cA chil wcel cA c0v cif cB cva co cA chil wcel cA
      c0v cif cB chil wcel cB c0v cif cva co csp cB cB chil wcel cB c0v cif
      wceq cA chil wcel cA c0v cif cB cva co cA chil wcel cA c0v cif cB chil
      wcel cB c0v cif cva co cT cB cB chil wcel cB c0v cif cA chil wcel cA c0v
      cif cva opreq2 fveq2d cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif
      cva opreq2 opreq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v
      cif cB cmv co cT cfv cA chil wcel cA c0v cif cB chil wcel cB c0v cif cmv
      co cT cfv cA chil wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif cB
      chil wcel cB c0v cif cmv co csp cB cB chil wcel cB c0v cif wceq cA chil
      wcel cA c0v cif cB cmv co cA chil wcel cA c0v cif cB chil wcel cB c0v cif
      cmv co cT cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2
      fveq2d cB cB chil wcel cB c0v cif cA chil wcel cA c0v cif cmv opreq2
      opreq12d opreq12d cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif
      ci cB csm co cva co cT cfv cA chil wcel cA c0v cif ci cB csm co cva co
      csp co cA chil wcel cA c0v cif ci cB csm co cmv co cT cfv cA chil wcel cA
      c0v cif ci cB csm co cmv co csp co cmin co cA chil wcel cA c0v cif ci cB
      chil wcel cB c0v cif csm co cva co cT cfv cA chil wcel cA c0v cif ci cB
      chil wcel cB c0v cif csm co cva co csp co cA chil wcel cA c0v cif ci cB
      chil wcel cB c0v cif csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB
      chil wcel cB c0v cif csm co cmv co csp co cmin co ci cmul cB cB chil wcel
      cB c0v cif wceq cA chil wcel cA c0v cif ci cB csm co cva co cT cfv cA
      chil wcel cA c0v cif ci cB csm co cva co csp co cA chil wcel cA c0v cif
      ci cB chil wcel cB c0v cif csm co cva co cT cfv cA chil wcel cA c0v cif
      ci cB chil wcel cB c0v cif csm co cva co csp co cA chil wcel cA c0v cif
      ci cB csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB csm co cmv co
      csp co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co
      cT cfv cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co
      csp co cmin cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif ci cB
      csm co cva co cT cfv cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif
      csm co cva co cT cfv cA chil wcel cA c0v cif ci cB csm co cva co cA chil
      wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co csp cB cB chil
      wcel cB c0v cif wceq cA chil wcel cA c0v cif ci cB csm co cva co cA chil
      wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cva co cT cB cB chil
      wcel cB c0v cif wceq ci cB csm co ci cB chil wcel cB c0v cif csm co cA
      chil wcel cA c0v cif cva cB cB chil wcel cB c0v cif ci csm opreq2 opreq2d
      fveq2d cB cB chil wcel cB c0v cif wceq ci cB csm co ci cB chil wcel cB
      c0v cif csm co cA chil wcel cA c0v cif cva cB cB chil wcel cB c0v cif ci
      csm opreq2 opreq2d opreq12d cB cB chil wcel cB c0v cif wceq cA chil wcel
      cA c0v cif ci cB csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB chil
      wcel cB c0v cif csm co cmv co cT cfv cA chil wcel cA c0v cif ci cB csm co
      cmv co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co
      csp cB cB chil wcel cB c0v cif wceq cA chil wcel cA c0v cif ci cB csm co
      cmv co cA chil wcel cA c0v cif ci cB chil wcel cB c0v cif csm co cmv co
      cT cB cB chil wcel cB c0v cif wceq ci cB csm co ci cB chil wcel cB c0v
      cif csm co cA chil wcel cA c0v cif cmv cB cB chil wcel cB c0v cif ci csm
      opreq2 opreq2d fveq2d cB cB chil wcel cB c0v cif wceq ci cB csm co ci cB
      chil wcel cB c0v cif csm co cA chil wcel cA c0v cif cmv cB cB chil wcel
      cB c0v cif ci csm opreq2 opreq2d opreq12d opreq12d opreq2d opreq12d
      opreq1d eqeq12d cA chil wcel cA c0v cif cB chil wcel cB c0v cif cT
      lnopeq0.1 cA c0v chil ax-hv0cl elimel cB c0v chil ax-hv0cl elimel
      lnopeq0lem1 dedth2h $.
      $( [3-Aug-2006] $) $( [26-Jul-2006] $)

    $( A condition implying that a linear Hilbert space operator is
       identically zero.  Unlike ~ ho01i for arbitrary operators, when the
       operator is linear we need to consider only the values of the quadratic
       form `  ( T `` x ) .ih x ) ` . $)
    lnopeq0i $p |- ( A. x e. ~H ( ( T ` x ) .ih x ) = 0 <-> T = 0hop ) $=
      vx cv cT cfv vx cv csp co cc0 wceq vx chil wral cT ch0o wceq vx cv cT cfv
      vx cv csp co cc0 wceq vx chil wral vy cv cT cfv vz cv csp co cc0 wceq vz
      chil wral vy chil wral cT ch0o wceq vx cv cT cfv vx cv csp co cc0 wceq vx
      chil wral vy cv cT cfv vz cv csp co cc0 wceq vy vz chil chil vx cv cT cfv
      vx cv csp co cc0 wceq vx chil wral vy cv chil wcel vz cv chil wcel wa vy
      cv cT cfv vz cv csp co cc0 wceq vx cv cT cfv vx cv csp co cc0 wceq vx
      chil wral vy cv chil wcel vz cv chil wcel wa wa vy cv cT cfv vz cv csp co
      vy cv vz cv cva co cT cfv vy cv vz cv cva co csp co vy cv vz cv cmv co cT
      cfv vy cv vz cv cmv co csp co cmin co ci vy cv ci vz cv csm co cva co cT
      cfv vy cv ci vz cv csm co cva co csp co vy cv ci vz cv csm co cmv co cT
      cfv vy cv ci vz cv csm co cmv co csp co cmin co cmul co caddc co c4 cdiv
      co cc0 vy cv chil wcel vz cv chil wcel wa vy cv cT cfv vz cv csp co vy cv
      vz cv cva co cT cfv vy cv vz cv cva co csp co vy cv vz cv cmv co cT cfv
      vy cv vz cv cmv co csp co cmin co ci vy cv ci vz cv csm co cva co cT cfv
      vy cv ci vz cv csm co cva co csp co vy cv ci vz cv csm co cmv co cT cfv
      vy cv ci vz cv csm co cmv co csp co cmin co cmul co caddc co c4 cdiv co
      wceq vx cv cT cfv vx cv csp co cc0 wceq vx chil wral vy cv vz cv cT
      lnopeq0.1 lnopeq0lem2 adantl vx cv cT cfv vx cv csp co cc0 wceq vx chil
      wral vy cv chil wcel vz cv chil wcel wa wa vy cv vz cv cva co cT cfv vy
      cv vz cv cva co csp co vy cv vz cv cmv co cT cfv vy cv vz cv cmv co csp
      co cmin co ci vy cv ci vz cv csm co cva co cT cfv vy cv ci vz cv csm co
      cva co csp co vy cv ci vz cv csm co cmv co cT cfv vy cv ci vz cv csm co
      cmv co csp co cmin co cmul co caddc co c4 cdiv co cc0 c4 cdiv co cc0 vx
      cv cT cfv vx cv csp co cc0 wceq vx chil wral vy cv chil wcel vz cv chil
      wcel wa wa vy cv vz cv cva co cT cfv vy cv vz cv cva co csp co vy cv vz
      cv cmv co cT cfv vy cv vz cv cmv co csp co cmin co ci vy cv ci vz cv csm
      co cva co cT cfv vy cv ci vz cv csm co cva co csp co vy cv ci vz cv csm
      co cmv co cT cfv vy cv ci vz cv csm co cmv co csp co cmin co cmul co
      caddc co cc0 c4 cdiv vx cv cT cfv vx cv csp co cc0 wceq vx chil wral vy
      cv chil wcel vz cv chil wcel wa wa vy cv vz cv cva co cT cfv vy cv vz cv
      cva co csp co vy cv vz cv cmv co cT cfv vy cv vz cv cmv co csp co cmin co
      ci vy cv ci vz cv csm co cva co cT cfv vy cv ci vz cv csm co cva co csp
      co vy cv ci vz cv csm co cmv co cT cfv vy cv ci vz cv csm co cmv co csp
      co cmin co cmul co caddc co cc0 cc0 caddc co cc0 vx cv cT cfv vx cv csp
      co cc0 wceq vx chil wral vy cv chil wcel vz cv chil wcel wa wa vy cv vz
      cv cva co cT cfv vy cv vz cv cva co csp co vy cv vz cv cmv co cT cfv vy
      cv vz cv cmv co csp co cmin co cc0 ci vy cv ci vz cv csm co cva co cT cfv
      vy cv ci vz cv csm co cva co csp co vy cv ci vz cv csm co cmv co cT cfv
      vy cv ci vz cv csm co cmv co csp co cmin co cmul co cc0 caddc vx cv cT
      cfv vx cv csp co cc0 wceq vx chil wral vy cv chil wcel vz cv chil wcel wa
      wa vy cv vz cv cva co cT cfv vy cv vz cv cva co csp co vy cv vz cv cmv co
      cT cfv vy cv vz cv cmv co csp co cmin co cc0 cc0 cmin co cc0 vx cv cT cfv
      vx cv csp co cc0 wceq vx chil wral vy cv chil wcel vz cv chil wcel wa wa
      vy cv vz cv cva co cT cfv vy cv vz cv cva co csp co cc0 vy cv vz cv cmv
      co cT cfv vy cv vz cv cmv co csp co cc0 cmin vx cv cT cfv vx cv csp co
      cc0 wceq vx chil wral vy cv vz cv cva co chil wcel vy cv vz cv cva co cT
      cfv vy cv vz cv cva co csp co cc0 wceq vy cv chil wcel vz cv chil wcel wa
      vx cv cT cfv vx cv csp co cc0 wceq vy cv vz cv cva co cT cfv vy cv vz cv
      cva co csp co cc0 wceq vx vy cv vz cv cva co chil vx cv vy cv vz cv cva
      co wceq vx cv cT cfv vx cv csp co vy cv vz cv cva co cT cfv vy cv vz cv
      cva co csp co cc0 vx cv vy cv vz cv cva co wceq vx cv cT cfv vy cv vz cv
      cva co cT cfv vx cv vy cv vz cv cva co csp vx cv vy cv vz cv cva co cT
      fveq2 vx cv vy cv vz cv cva co wceq id opreq12d eqeq1d rcla4cva vy cv vz
      cv hvaddcl sylan2 vx cv cT cfv vx cv csp co cc0 wceq vx chil wral vy cv
      vz cv cmv co chil wcel vy cv vz cv cmv co cT cfv vy cv vz cv cmv co csp
      co cc0 wceq vy cv chil wcel vz cv chil wcel wa vx cv cT cfv vx cv csp co
      cc0 wceq vy cv vz cv cmv co cT cfv vy cv vz cv cmv co csp co cc0 wceq vx
      vy cv vz cv cmv co chil vx cv vy cv vz cv cmv co wceq vx cv cT cfv vx cv
      csp co vy cv vz cv cmv co cT cfv vy cv vz cv cmv co csp co cc0 vx cv vy
      cv vz cv cmv co wceq vx cv cT cfv vy cv vz cv cmv co cT cfv vx cv vy cv
      vz cv cmv co csp vx cv vy cv vz cv cmv co cT fveq2 vx cv vy cv vz cv cmv
      co wceq id opreq12d eqeq1d rcla4cva vy cv vz cv hvsubcl sylan2 opreq12d
      cc0 0cn subidi syl6eq vx cv cT cfv vx cv csp co cc0 wceq vx chil wral vy
      cv chil wcel vz cv chil wcel wa wa ci vy cv ci vz cv csm co cva co cT cfv
      vy cv ci vz cv csm co cva co csp co vy cv ci vz cv csm co cmv co cT cfv
      vy cv ci vz cv csm co cmv co csp co cmin co cmul co ci cc0 cmul co cc0 vx
      cv cT cfv vx cv csp co cc0 wceq vx chil wral vy cv chil wcel vz cv chil
      wcel wa wa vy cv ci vz cv csm co cva co cT cfv vy cv ci vz cv csm co cva
      co csp co vy cv ci vz cv csm co cmv co cT cfv vy cv ci vz cv csm co cmv
      co csp co cmin co cc0 ci cmul vx cv cT cfv vx cv csp co cc0 wceq vx chil
      wral vy cv chil wcel vz cv chil wcel wa wa vy cv ci vz cv csm co cva co
      cT cfv vy cv ci vz cv csm co cva co csp co vy cv ci vz cv csm co cmv co
      cT cfv vy cv ci vz cv csm co cmv co csp co cmin co cc0 cc0 cmin co cc0 vx
      cv cT cfv vx cv csp co cc0 wceq vx chil wral vy cv chil wcel vz cv chil
      wcel wa wa vy cv ci vz cv csm co cva co cT cfv vy cv ci vz cv csm co cva
      co csp co cc0 vy cv ci vz cv csm co cmv co cT cfv vy cv ci vz cv csm co
      cmv co csp co cc0 cmin vx cv cT cfv vx cv csp co cc0 wceq vx chil wral vy
      cv ci vz cv csm co cva co chil wcel vy cv ci vz cv csm co cva co cT cfv
      vy cv ci vz cv csm co cva co csp co cc0 wceq vy cv chil wcel vz cv chil
      wcel wa vx cv cT cfv vx cv csp co cc0 wceq vy cv ci vz cv csm co cva co
      cT cfv vy cv ci vz cv csm co cva co csp co cc0 wceq vx vy cv ci vz cv csm
      co cva co chil vx cv vy cv ci vz cv csm co cva co wceq vx cv cT cfv vx cv
      csp co vy cv ci vz cv csm co cva co cT cfv vy cv ci vz cv csm co cva co
      csp co cc0 vx cv vy cv ci vz cv csm co cva co wceq vx cv cT cfv vy cv ci
      vz cv csm co cva co cT cfv vx cv vy cv ci vz cv csm co cva co csp vx cv
      vy cv ci vz cv csm co cva co cT fveq2 vx cv vy cv ci vz cv csm co cva co
      wceq id opreq12d eqeq1d rcla4cva vy cv chil wcel ci vz cv csm co chil
      wcel vy cv ci vz cv csm co cva co chil wcel vz cv chil wcel vy cv ci vz
      cv csm co hvaddcl ci cc wcel vz cv chil wcel ci vz cv csm co chil wcel
      axicn ci vz cv hvmulcl mpan sylan2 sylan2 vx cv cT cfv vx cv csp co cc0
      wceq vx chil wral vy cv ci vz cv csm co cmv co chil wcel vy cv ci vz cv
      csm co cmv co cT cfv vy cv ci vz cv csm co cmv co csp co cc0 wceq vy cv
      chil wcel vz cv chil wcel wa vx cv cT cfv vx cv csp co cc0 wceq vy cv ci
      vz cv csm co cmv co cT cfv vy cv ci vz cv csm co cmv co csp co cc0 wceq
      vx vy cv ci vz cv csm co cmv co chil vx cv vy cv ci vz cv csm co cmv co
      wceq vx cv cT cfv vx cv csp co vy cv ci vz cv csm co cmv co cT cfv vy cv
      ci vz cv csm co cmv co csp co cc0 vx cv vy cv ci vz cv csm co cmv co wceq
      vx cv cT cfv vy cv ci vz cv csm co cmv co cT cfv vx cv vy cv ci vz cv csm
      co cmv co csp vx cv vy cv ci vz cv csm co cmv co cT fveq2 vx cv vy cv ci
      vz cv csm co cmv co wceq id opreq12d eqeq1d rcla4cva vy cv chil wcel ci
      vz cv csm co chil wcel vy cv ci vz cv csm co cmv co chil wcel vz cv chil
      wcel vy cv ci vz cv csm co hvsubcl ci cc wcel vz cv chil wcel ci vz cv
      csm co chil wcel axicn ci vz cv hvmulcl mpan sylan2 sylan2 opreq12d cc0
      0cn subidi syl6eq opreq2d ci axicn mul01i syl6eq opreq12d cc0 0cn addid1i
      syl6eq opreq1d c4 c4 4re recni c4 4re 4pos gt0ne0ii div0i syl6eq eqtrd ex
      r19.21aivv vy vz cT cT lnopeq0.1 lnopfi ho01i sylib cT ch0o wceq vx cv cT
      cfv vx cv csp co cc0 wceq vx chil cT ch0o wceq vx cv chil wcel wa vx cv
      cT cfv vx cv csp co c0v vx cv csp co cc0 cT ch0o wceq vx cv chil wcel wa
      vx cv cT cfv c0v vx cv csp cT ch0o wceq vx cv chil wcel vx cv cT cfv vx
      cv ch0o cfv c0v vx cv cT ch0o fveq1 vx cv ho0val sylan9eq opreq1d vx cv
      chil wcel c0v vx cv csp co cc0 wceq cT ch0o wceq vx cv hi01 adantl eqtrd
      r19.21aiva impbii $.
      $( [3-Aug-2007] $) $( [26-Jul-2006] $)
  $}

  ${
    $d x T $.  $d x U $.
    lnopeq.1 $e |- T e. LinOp $.
    lnopeq.2 $e |- U e. LinOp $.
    $( Two linear Hilbert space operators are equal iff their quadratic forms
       are equal. $)
    lnopeqi $p |- ( A. x e. ~H ( ( T ` x ) .ih x ) = ( ( U ` x ) .ih x ) <->
                  T = U ) $=
      vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co wceq vx chil wral vx
      cv cT cU chod co cfv vx cv csp co cc0 wceq vx chil wral cT cU chod co
      ch0o wceq cT cU wceq vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      wceq vx cv cT cU chod co cfv vx cv csp co cc0 wceq vx chil vx cv chil
      wcel vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co cmin co cc0 wceq
      vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co wceq vx cv cT cU chod
      co cfv vx cv csp co cc0 wceq vx cv cT cfv vx cv csp co cc wcel vx cv cU
      cfv vx cv csp co cc wcel vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co cmin co cc0 wceq vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      wceq wb vx cv chil wcel vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co subeq0 vx cv cT cfv chil wcel vx cv chil wcel vx cv cT cfv vx cv csp
      co cc wcel chil chil vx cv cT cT lnopeq.1 lnopfi ffvelrni vx cv cT cfv vx
      cv hicl mpancom vx cv cU cfv chil wcel vx cv chil wcel vx cv cU cfv vx cv
      csp co cc wcel chil chil vx cv cU cU lnopeq.2 lnopfi ffvelrni vx cv cU
      cfv vx cv hicl mpancom sylanc vx cv chil wcel vx cv cT cfv vx cv csp co
      vx cv cU cfv vx cv csp co cmin co vx cv cT cU chod co cfv vx cv csp co
      cc0 vx cv chil wcel vx cv cT cU chod co cfv vx cv csp co vx cv cT cfv vx
      cv cU cfv cmv co vx cv csp co vx cv cT cfv vx cv csp co vx cv cU cfv vx
      cv csp co cmin co vx cv chil wcel vx cv cT cU chod co cfv vx cv cT cfv vx
      cv cU cfv cmv co vx cv csp chil chil cT wf chil chil cU wf vx cv chil
      wcel vx cv cT cU chod co cfv vx cv cT cfv vx cv cU cfv cmv co wceq cT
      lnopeq.1 lnopfi cU lnopeq.2 lnopfi vx cv cT cU hodval mp3an12 opreq1d vx
      cv cT cfv chil wcel vx cv cU cfv chil wcel vx cv chil wcel vx cv cT cfv
      vx cv cU cfv cmv co vx cv csp co vx cv cT cfv vx cv csp co vx cv cU cfv
      vx cv csp co cmin co wceq vx cv chil wcel vx cv cT cfv vx cv cU cfv vx cv
      his2sub chil chil vx cv cT cT lnopeq.1 lnopfi ffvelrni chil chil vx cv cU
      cU lnopeq.2 lnopfi ffvelrni vx cv chil wcel id syl3anc eqtr2d eqeq1d
      bitr3d ralbiia vx cT cU chod co cT cU lnopeq.1 lnopeq.2 lnophdi lnopeq0i
      cT cU cT lnopeq.1 lnopfi cU lnopeq.2 lnopfi hosubeq0i 3bitri $.
      $( [3-Aug-2006] $) $( [27-Jul-2006] $)
  $}

  ${
    $d x T $.  $d x U $.
    $( Two linear Hilbert space operators are equal iff their quadratic forms
       are equal. $)
    lnopeq $p |- ( ( T e. LinOp /\ U e. LinOp ) ->
        ( A. x e. ~H ( ( T ` x ) .ih x ) = ( ( U ` x ) .ih x ) <-> T = U ) ) $=
      cT clo wcel cU clo wcel vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co wceq vx chil wral cT cU wceq wb vx cv cT clo wcel cT ch0o cif cfv vx
      cv csp co vx cv cU cfv vx cv csp co wceq vx chil wral cT clo wcel cT ch0o
      cif cU wceq wb vx cv cT clo wcel cT ch0o cif cfv vx cv csp co vx cv cU
      clo wcel cU ch0o cif cfv vx cv csp co wceq vx chil wral cT clo wcel cT
      ch0o cif cU clo wcel cU ch0o cif wceq wb cT cU ch0o ch0o cT cT clo wcel
      cT ch0o cif wceq vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co wceq
      vx chil wral vx cv cT clo wcel cT ch0o cif cfv vx cv csp co vx cv cU cfv
      vx cv csp co wceq vx chil wral cT cU wceq cT clo wcel cT ch0o cif cU wceq
      cT cT clo wcel cT ch0o cif wceq vx cv cT cfv vx cv csp co vx cv cU cfv vx
      cv csp co wceq vx cv cT clo wcel cT ch0o cif cfv vx cv csp co vx cv cU
      cfv vx cv csp co wceq vx chil cT cT clo wcel cT ch0o cif wceq vx cv cT
      cfv vx cv csp co vx cv cT clo wcel cT ch0o cif cfv vx cv csp co vx cv cU
      cfv vx cv csp co cT cT clo wcel cT ch0o cif wceq vx cv cT cfv vx cv cT
      clo wcel cT ch0o cif cfv vx cv csp vx cv cT cT clo wcel cT ch0o cif fveq1
      opreq1d eqeq1d ralbidv cT cT clo wcel cT ch0o cif cU eqeq1 bibi12d cU cU
      clo wcel cU ch0o cif wceq vx cv cT clo wcel cT ch0o cif cfv vx cv csp co
      vx cv cU cfv vx cv csp co wceq vx chil wral vx cv cT clo wcel cT ch0o cif
      cfv vx cv csp co vx cv cU clo wcel cU ch0o cif cfv vx cv csp co wceq vx
      chil wral cT clo wcel cT ch0o cif cU wceq cT clo wcel cT ch0o cif cU clo
      wcel cU ch0o cif wceq cU cU clo wcel cU ch0o cif wceq vx cv cT clo wcel
      cT ch0o cif cfv vx cv csp co vx cv cU cfv vx cv csp co wceq vx cv cT clo
      wcel cT ch0o cif cfv vx cv csp co vx cv cU clo wcel cU ch0o cif cfv vx cv
      csp co wceq vx chil cU cU clo wcel cU ch0o cif wceq vx cv cU cfv vx cv
      csp co vx cv cU clo wcel cU ch0o cif cfv vx cv csp co vx cv cT clo wcel
      cT ch0o cif cfv vx cv csp co cU cU clo wcel cU ch0o cif wceq vx cv cU cfv
      vx cv cU clo wcel cU ch0o cif cfv vx cv csp vx cv cU cU clo wcel cU ch0o
      cif fveq1 opreq1d eqeq2d ralbidv cU cU clo wcel cU ch0o cif cT clo wcel
      cT ch0o cif eqeq2 bibi12d vx cT clo wcel cT ch0o cif cU clo wcel cU ch0o
      cif cT ch0o clo 0lnop elimel cU ch0o clo 0lnop elimel lnopeqi dedth2h $.
      $( [5-Aug-2006] $) $( [27-Jul-2006] $)
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d x y T $.
    lnopunilem.1 $e |- T e. LinOp $.
    lnopunilem.2 $e |- A. x e. ~H ( normh ` ( T ` x ) ) = ( normh ` x ) $.
    lnopunilem.3 $e |- A e. ~H $.
    lnopunilem.4 $e |- B e. ~H $.
    ${
      lnopunilem1.5 $e |- C e. CC $.
      $( Lemma for ~ lnopunii . $)
      lnopunilem1 $p |- ( Re ` ( C x. ( ( T ` A ) .ih ( T ` B ) ) ) ) =
                      ( Re ` ( C x. ( A .ih B ) ) ) $=
        cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT cfv csp co
        cmul co ccj cfv caddc co c2 cdiv co cC cA cB csp co cmul co cC cA cB
        csp co cmul co ccj cfv caddc co c2 cdiv co cC cA cT cfv cB cT cfv csp
        co cmul co cre cfv cC cA cB csp co cmul co cre cfv cC cA cT cfv cB cT
        cfv csp co cmul co cC cA cT cfv cB cT cfv csp co cmul co ccj cfv caddc
        co cC cA cB csp co cmul co cC cA cB csp co cmul co ccj cfv caddc co c2
        cdiv cC cC ccj cfv cA cA csp co cmul co cmul co cB cB csp co caddc co
        cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT cfv csp co
        cmul co ccj cfv caddc co caddc co cC cC ccj cfv cA cA csp co cmul co
        cmul co cB cB csp co caddc co cC cA cB csp co cmul co cC cA cB csp co
        cmul co ccj cfv caddc co caddc co wceq cC cA cT cfv cB cT cfv csp co
        cmul co cC cA cT cfv cB cT cfv csp co cmul co ccj cfv caddc co cC cA cB
        csp co cmul co cC cA cB csp co cmul co ccj cfv caddc co wceq cC cC ccj
        cfv cA cT cfv cA cT cfv csp co cmul co cmul co cB cT cfv cB cT cfv csp
        co caddc co cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT
        cfv csp co cmul co ccj cfv caddc co caddc co cC cC ccj cfv cA cA csp co
        cmul co cmul co cB cB csp co caddc co cC cA cT cfv cB cT cfv csp co
        cmul co cC cA cT cfv cB cT cfv csp co cmul co ccj cfv caddc co caddc co
        cC cC ccj cfv cA cA csp co cmul co cmul co cB cB csp co caddc co cC cA
        cB csp co cmul co cC cA cB csp co cmul co ccj cfv caddc co caddc co cC
        cC ccj cfv cA cT cfv cA cT cfv csp co cmul co cmul co cB cT cfv cB cT
        cfv csp co caddc co cC cC ccj cfv cA cA csp co cmul co cmul co cB cB
        csp co caddc co cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB
        cT cfv csp co cmul co ccj cfv caddc co caddc cC cC ccj cfv cA cT cfv cA
        cT cfv csp co cmul co cmul co cC cC ccj cfv cA cA csp co cmul co cmul
        co cB cT cfv cB cT cfv csp co cB cB csp co caddc cC ccj cfv cA cT cfv
        cA cT cfv csp co cmul co cC ccj cfv cA cA csp co cmul co cC cmul cA cT
        cfv cA cT cfv csp co cA cA csp co cC ccj cfv cmul cA chil wcel vy cv cT
        cfv vy cv cT cfv csp co vy cv vy cv csp co wceq vy chil wral cA cT cfv
        cA cT cfv csp co cA cA csp co wceq lnopunilem.3 vy cv cT cfv cno cfv vy
        cv cno cfv wceq vy chil wral vy cv cT cfv vy cv cT cfv csp co vy cv vy
        cv csp co wceq vy chil wral vx cv cT cfv cno cfv vx cv cno cfv wceq vx
        chil wral vy cv cT cfv cno cfv vy cv cno cfv wceq vy chil wral
        lnopunilem.2 vx cv cT cfv cno cfv vx cv cno cfv wceq vy cv cT cfv cno
        cfv vy cv cno cfv wceq vx vy chil vx cv vy cv wceq vx cv cT cfv cno cfv
        vy cv cT cfv cno cfv vx cv cno cfv vy cv cno cfv vx cv vy cv wceq vx cv
        cT cfv vy cv cT cfv cno vx cv vy cv cT fveq2 fveq2d vx cv vy cv cno
        fveq2 eqeq12d cbvralv mpbi vy cv cT cfv cno cfv vy cv cno cfv wceq vy
        cv cT cfv vy cv cT cfv csp co vy cv vy cv csp co wceq vy chil vy cv
        chil wcel vy cv cT cfv cno cfv c2 cexp co vy cv cno cfv c2 cexp co wceq
        vy cv cT cfv vy cv cT cfv csp co vy cv vy cv csp co wceq vy cv cT cfv
        cno cfv vy cv cno cfv wceq vy cv chil wcel vy cv cT cfv cno cfv c2 cexp
        co vy cv cT cfv vy cv cT cfv csp co vy cv cno cfv c2 cexp co vy cv vy
        cv csp co vy cv chil wcel vy cv cT cfv chil wcel vy cv cT cfv cno cfv
        c2 cexp co vy cv cT cfv vy cv cT cfv csp co wceq chil chil vy cv cT cT
        lnopunilem.1 lnopfi ffvelrni vy cv cT cfv normsq syl vy cv normsq
        eqeq12d vy cv cT cfv cno cfv vy cv cno cfv c2 cexp opreq1 syl5bi
        r19.20i ax-mp vy cv cT cfv vy cv cT cfv csp co vy cv vy cv csp co wceq
        cA cT cfv cA cT cfv csp co cA cA csp co wceq vy cA chil vy cv cA wceq
        vy cv cT cfv vy cv cT cfv csp co cA cT cfv cA cT cfv csp co vy cv vy cv
        csp co cA cA csp co vy cv cA wceq vy cv cT cfv cA cT cfv vy cv cT cfv
        cA cT cfv csp vy cv cA cT fveq2 vy cv cA cT fveq2 opreq12d vy cv cA
        wceq vy cv cA vy cv cA csp vy cv cA wceq id vy cv cA wceq id opreq12d
        eqeq12d rcla4v mp2 opreq2i opreq2i cB chil wcel vy cv cT cfv vy cv cT
        cfv csp co vy cv vy cv csp co wceq vy chil wral cB cT cfv cB cT cfv csp
        co cB cB csp co wceq lnopunilem.4 vy cv cT cfv cno cfv vy cv cno cfv
        wceq vy chil wral vy cv cT cfv vy cv cT cfv csp co vy cv vy cv csp co
        wceq vy chil wral vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral
        vy cv cT cfv cno cfv vy cv cno cfv wceq vy chil wral lnopunilem.2 vx cv
        cT cfv cno cfv vx cv cno cfv wceq vy cv cT cfv cno cfv vy cv cno cfv
        wceq vx vy chil vx cv vy cv wceq vx cv cT cfv cno cfv vy cv cT cfv cno
        cfv vx cv cno cfv vy cv cno cfv vx cv vy cv wceq vx cv cT cfv vy cv cT
        cfv cno vx cv vy cv cT fveq2 fveq2d vx cv vy cv cno fveq2 eqeq12d
        cbvralv mpbi vy cv cT cfv cno cfv vy cv cno cfv wceq vy cv cT cfv vy cv
        cT cfv csp co vy cv vy cv csp co wceq vy chil vy cv chil wcel vy cv cT
        cfv cno cfv c2 cexp co vy cv cno cfv c2 cexp co wceq vy cv cT cfv vy cv
        cT cfv csp co vy cv vy cv csp co wceq vy cv cT cfv cno cfv vy cv cno
        cfv wceq vy cv chil wcel vy cv cT cfv cno cfv c2 cexp co vy cv cT cfv
        vy cv cT cfv csp co vy cv cno cfv c2 cexp co vy cv vy cv csp co vy cv
        chil wcel vy cv cT cfv chil wcel vy cv cT cfv cno cfv c2 cexp co vy cv
        cT cfv vy cv cT cfv csp co wceq chil chil vy cv cT cT lnopunilem.1
        lnopfi ffvelrni vy cv cT cfv normsq syl vy cv normsq eqeq12d vy cv cT
        cfv cno cfv vy cv cno cfv c2 cexp opreq1 syl5bi r19.20i ax-mp vy cv cT
        cfv vy cv cT cfv csp co vy cv vy cv csp co wceq cB cT cfv cB cT cfv csp
        co cB cB csp co wceq vy cB chil vy cv cB wceq vy cv cT cfv vy cv cT cfv
        csp co cB cT cfv cB cT cfv csp co vy cv vy cv csp co cB cB csp co vy cv
        cB wceq vy cv cT cfv cB cT cfv vy cv cT cfv cB cT cfv csp vy cv cB cT
        fveq2 vy cv cB cT fveq2 opreq12d vy cv cB wceq vy cv cB vy cv cB csp vy
        cv cB wceq id vy cv cB wceq id opreq12d eqeq12d rcla4v mp2 opreq12i
        opreq1i cC cC ccj cfv cA cT cfv cA cT cfv csp co cmul co cmul co cC cA
        cT cfv cB cT cfv csp co cmul co caddc co cC cA cT cfv cB cT cfv csp co
        cmul co ccj cfv cB cT cfv cB cT cfv csp co caddc co caddc co cC cC ccj
        cfv cA cA csp co cmul co cmul co cC cA cB csp co cmul co caddc co cC cA
        cB csp co cmul co ccj cfv cB cB csp co caddc co caddc co cC cC ccj cfv
        cA cT cfv cA cT cfv csp co cmul co cmul co cB cT cfv cB cT cfv csp co
        caddc co cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT cfv
        csp co cmul co ccj cfv caddc co caddc co cC cC ccj cfv cA cA csp co
        cmul co cmul co cB cB csp co caddc co cC cA cB csp co cmul co cC cA cB
        csp co cmul co ccj cfv caddc co caddc co cC cA csm co cB cva co cT cfv
        cC cA csm co cB cva co cT cfv csp co cC cA csm co cB cva co cC cA csm
        co cB cva co csp co cC cC ccj cfv cA cT cfv cA cT cfv csp co cmul co
        cmul co cC cA cT cfv cB cT cfv csp co cmul co caddc co cC cA cT cfv cB
        cT cfv csp co cmul co ccj cfv cB cT cfv cB cT cfv csp co caddc co caddc
        co cC cC ccj cfv cA cA csp co cmul co cmul co cC cA cB csp co cmul co
        caddc co cC cA cB csp co cmul co ccj cfv cB cB csp co caddc co caddc co
        cC cA csm co cB cva co chil wcel vy cv cT cfv vy cv cT cfv csp co vy cv
        vy cv csp co wceq vy chil wral cC cA csm co cB cva co cT cfv cC cA csm
        co cB cva co cT cfv csp co cC cA csm co cB cva co cC cA csm co cB cva
        co csp co wceq cC cA csm co cB cC cA lnopunilem1.5 lnopunilem.3
        hvmulcli lnopunilem.4 hvaddcli vy cv cT cfv cno cfv vy cv cno cfv wceq
        vy chil wral vy cv cT cfv vy cv cT cfv csp co vy cv vy cv csp co wceq
        vy chil wral vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral vy cv
        cT cfv cno cfv vy cv cno cfv wceq vy chil wral lnopunilem.2 vx cv cT
        cfv cno cfv vx cv cno cfv wceq vy cv cT cfv cno cfv vy cv cno cfv wceq
        vx vy chil vx cv vy cv wceq vx cv cT cfv cno cfv vy cv cT cfv cno cfv
        vx cv cno cfv vy cv cno cfv vx cv vy cv wceq vx cv cT cfv vy cv cT cfv
        cno vx cv vy cv cT fveq2 fveq2d vx cv vy cv cno fveq2 eqeq12d cbvralv
        mpbi vy cv cT cfv cno cfv vy cv cno cfv wceq vy cv cT cfv vy cv cT cfv
        csp co vy cv vy cv csp co wceq vy chil vy cv chil wcel vy cv cT cfv cno
        cfv c2 cexp co vy cv cno cfv c2 cexp co wceq vy cv cT cfv vy cv cT cfv
        csp co vy cv vy cv csp co wceq vy cv cT cfv cno cfv vy cv cno cfv wceq
        vy cv chil wcel vy cv cT cfv cno cfv c2 cexp co vy cv cT cfv vy cv cT
        cfv csp co vy cv cno cfv c2 cexp co vy cv vy cv csp co vy cv chil wcel
        vy cv cT cfv chil wcel vy cv cT cfv cno cfv c2 cexp co vy cv cT cfv vy
        cv cT cfv csp co wceq chil chil vy cv cT cT lnopunilem.1 lnopfi
        ffvelrni vy cv cT cfv normsq syl vy cv normsq eqeq12d vy cv cT cfv cno
        cfv vy cv cno cfv c2 cexp opreq1 syl5bi r19.20i ax-mp vy cv cT cfv vy
        cv cT cfv csp co vy cv vy cv csp co wceq cC cA csm co cB cva co cT cfv
        cC cA csm co cB cva co cT cfv csp co cC cA csm co cB cva co cC cA csm
        co cB cva co csp co wceq vy cC cA csm co cB cva co chil vy cv cC cA csm
        co cB cva co wceq vy cv cT cfv vy cv cT cfv csp co cC cA csm co cB cva
        co cT cfv cC cA csm co cB cva co cT cfv csp co vy cv vy cv csp co cC cA
        csm co cB cva co cC cA csm co cB cva co csp co vy cv cC cA csm co cB
        cva co wceq vy cv cT cfv cC cA csm co cB cva co cT cfv vy cv cT cfv cC
        cA csm co cB cva co cT cfv csp vy cv cC cA csm co cB cva co cT fveq2 vy
        cv cC cA csm co cB cva co cT fveq2 opreq12d vy cv cC cA csm co cB cva
        co wceq vy cv cC cA csm co cB cva co vy cv cC cA csm co cB cva co csp
        vy cv cC cA csm co cB cva co wceq id vy cv cC cA csm co cB cva co wceq
        id opreq12d eqeq12d rcla4v mp2 cC cA csm co cB cva co cT cfv cC cA csm
        co cB cva co cT cfv csp co cC cA cT cfv csm co cB cT cfv cva co cC cA
        cT cfv csm co cB cT cfv cva co csp co cC cA cT cfv csm co cC cA cT cfv
        csm co cB cT cfv cva co csp co cB cT cfv cC cA cT cfv csm co cB cT cfv
        cva co csp co caddc co cC cC ccj cfv cA cT cfv cA cT cfv csp co cmul co
        cmul co cC cA cT cfv cB cT cfv csp co cmul co caddc co cC cA cT cfv cB
        cT cfv csp co cmul co ccj cfv cB cT cfv cB cT cfv csp co caddc co caddc
        co cC cA csm co cB cva co cT cfv cC cA cT cfv csm co cB cT cfv cva co
        cC cA csm co cB cva co cT cfv cC cA cT cfv csm co cB cT cfv cva co csp
        cC cc wcel cA chil wcel cB chil wcel cC cA csm co cB cva co cT cfv cC
        cA cT cfv csm co cB cT cfv cva co wceq lnopunilem1.5 lnopunilem.3
        lnopunilem.4 cC cA cB cT lnopunilem.1 lnopli mp3an cC cc wcel cA chil
        wcel cB chil wcel cC cA csm co cB cva co cT cfv cC cA cT cfv csm co cB
        cT cfv cva co wceq lnopunilem1.5 lnopunilem.3 lnopunilem.4 cC cA cB cT
        lnopunilem.1 lnopli mp3an opreq12i cC cA cT cfv csm co chil wcel cB cT
        cfv chil wcel cC cA cT cfv csm co cB cT cfv cva co chil wcel cC cA cT
        cfv csm co cB cT cfv cva co cC cA cT cfv csm co cB cT cfv cva co csp co
        cC cA cT cfv csm co cC cA cT cfv csm co cB cT cfv cva co csp co cB cT
        cfv cC cA cT cfv csm co cB cT cfv cva co csp co caddc co wceq cC cA cT
        cfv lnopunilem1.5 cA chil wcel cA cT cfv chil wcel lnopunilem.3 chil
        chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp hvmulcli cB chil wcel
        cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi
        ffvelrni ax-mp cC cA cT cfv csm co cB cT cfv cC cA cT cfv lnopunilem1.5
        cA chil wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp hvmulcli cB chil wcel cB cT cfv chil
        wcel lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        hvaddcli cC cA cT cfv csm co cB cT cfv cC cA cT cfv csm co cB cT cfv
        cva co ax-his2 mp3an cC cA cT cfv csm co cC cA cT cfv csm co cB cT cfv
        cva co csp co cC cC ccj cfv cA cT cfv cA cT cfv csp co cmul co cmul co
        cC cA cT cfv cB cT cfv csp co cmul co caddc co cB cT cfv cC cA cT cfv
        csm co cB cT cfv cva co csp co cC cA cT cfv cB cT cfv csp co cmul co
        ccj cfv cB cT cfv cB cT cfv csp co caddc co caddc cC cA cT cfv csm co
        cC cA cT cfv csm co cB cT cfv cva co csp co cC cA cT cfv cC cA cT cfv
        csm co cB cT cfv cva co csp co cmul co cC cC ccj cfv cA cT cfv cA cT
        cfv csp co cmul co cA cT cfv cB cT cfv csp co caddc co cmul co cC cC
        ccj cfv cA cT cfv cA cT cfv csp co cmul co cmul co cC cA cT cfv cB cT
        cfv csp co cmul co caddc co cC cc wcel cA cT cfv chil wcel cC cA cT cfv
        csm co cB cT cfv cva co chil wcel cC cA cT cfv csm co cC cA cT cfv csm
        co cB cT cfv cva co csp co cC cA cT cfv cC cA cT cfv csm co cB cT cfv
        cva co csp co cmul co wceq lnopunilem1.5 cA chil wcel cA cT cfv chil
        wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        cC cA cT cfv csm co cB cT cfv cC cA cT cfv lnopunilem1.5 cA chil wcel
        cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi
        ffvelrni ax-mp hvmulcli cB chil wcel cB cT cfv chil wcel lnopunilem.4
        chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp hvaddcli cC cA cT
        cfv cC cA cT cfv csm co cB cT cfv cva co ax-his3 mp3an cA cT cfv cC cA
        cT cfv csm co cB cT cfv cva co csp co cC ccj cfv cA cT cfv cA cT cfv
        csp co cmul co cA cT cfv cB cT cfv csp co caddc co cC cmul cA cT cfv cC
        cA cT cfv csm co cB cT cfv cva co csp co cA cT cfv cC cA cT cfv csm co
        csp co cA cT cfv cB cT cfv csp co caddc co cC ccj cfv cA cT cfv cA cT
        cfv csp co cmul co cA cT cfv cB cT cfv csp co caddc co cA cT cfv chil
        wcel cC cA cT cfv csm co chil wcel cB cT cfv chil wcel cA cT cfv cC cA
        cT cfv csm co cB cT cfv cva co csp co cA cT cfv cC cA cT cfv csm co csp
        co cA cT cfv cB cT cfv csp co caddc co wceq cA chil wcel cA cT cfv chil
        wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        cC cA cT cfv lnopunilem1.5 cA chil wcel cA cT cfv chil wcel
        lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        hvmulcli cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT
        cT lnopunilem.1 lnopfi ffvelrni ax-mp cA cT cfv cC cA cT cfv csm co cB
        cT cfv his7 mp3an cA cT cfv cC cA cT cfv csm co csp co cC ccj cfv cA cT
        cfv cA cT cfv csp co cmul co cA cT cfv cB cT cfv csp co caddc cC cc
        wcel cA cT cfv chil wcel cA cT cfv chil wcel cA cT cfv cC cA cT cfv csm
        co csp co cC ccj cfv cA cT cfv cA cT cfv csp co cmul co wceq
        lnopunilem1.5 cA chil wcel cA cT cfv chil wcel lnopunilem.3 chil chil
        cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp cA chil wcel cA cT cfv chil
        wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        cC cA cT cfv cA cT cfv his5 mp3an opreq1i eqtri opreq2i cC cC ccj cfv
        cA cT cfv cA cT cfv csp co cmul co cA cT cfv cB cT cfv csp co
        lnopunilem1.5 cC ccj cfv cA cT cfv cA cT cfv csp co cC lnopunilem1.5
        cjcli cA cT cfv cA cT cfv cA chil wcel cA cT cfv chil wcel lnopunilem.3
        chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp cA chil wcel cA
        cT cfv chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi
        ffvelrni ax-mp hicli mulcli cA cT cfv cB cT cfv cA chil wcel cA cT cfv
        chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni
        ax-mp cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp hicli adddii 3eqtri cB cT cfv cC cA
        cT cfv csm co cB cT cfv cva co csp co cB cT cfv cC cA cT cfv csm co csp
        co cB cT cfv cB cT cfv csp co caddc co cC cA cT cfv cB cT cfv csp co
        cmul co ccj cfv cB cT cfv cB cT cfv csp co caddc co cB cT cfv chil wcel
        cC cA cT cfv csm co chil wcel cB cT cfv chil wcel cB cT cfv cC cA cT
        cfv csm co cB cT cfv cva co csp co cB cT cfv cC cA cT cfv csm co csp co
        cB cT cfv cB cT cfv csp co caddc co wceq cB chil wcel cB cT cfv chil
        wcel lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        cC cA cT cfv lnopunilem1.5 cA chil wcel cA cT cfv chil wcel
        lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        hvmulcli cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT
        cT lnopunilem.1 lnopfi ffvelrni ax-mp cB cT cfv cC cA cT cfv csm co cB
        cT cfv his7 mp3an cB cT cfv cC cA cT cfv csm co csp co cC cA cT cfv cB
        cT cfv csp co cmul co ccj cfv cB cT cfv cB cT cfv csp co caddc cC ccj
        cfv cB cT cfv cA cT cfv csp co cmul co cC ccj cfv cA cT cfv cB cT cfv
        csp co ccj cfv cmul co cB cT cfv cC cA cT cfv csm co csp co cC cA cT
        cfv cB cT cfv csp co cmul co ccj cfv cB cT cfv cA cT cfv csp co cA cT
        cfv cB cT cfv csp co ccj cfv cC ccj cfv cmul cB cT cfv cA cT cfv cB
        chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp cA chil wcel cA cT cfv chil wcel
        lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        his1i opreq2i cC cc wcel cB cT cfv chil wcel cA cT cfv chil wcel cB cT
        cfv cC cA cT cfv csm co csp co cC ccj cfv cB cT cfv cA cT cfv csp co
        cmul co wceq lnopunilem1.5 cB chil wcel cB cT cfv chil wcel
        lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp cA
        chil wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp cC cB cT cfv cA cT cfv his5 mp3an cC
        cA cT cfv cB cT cfv csp co lnopunilem1.5 cA cT cfv cB cT cfv cA chil
        wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1
        lnopfi ffvelrni ax-mp cB chil wcel cB cT cfv chil wcel lnopunilem.4
        chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp hicli cjmuli
        3eqtr4i opreq1i eqtri opreq12i 3eqtrri cC cA csm co cB cva co cC cA csm
        co cB cva co csp co cC cA csm co cC cA csm co cB cva co csp co cB cC cA
        csm co cB cva co csp co caddc co cC cC ccj cfv cA cA csp co cmul co
        cmul co cC cA cB csp co cmul co caddc co cC cA cB csp co cmul co ccj
        cfv cB cB csp co caddc co caddc co cC cA csm co chil wcel cB chil wcel
        cC cA csm co cB cva co chil wcel cC cA csm co cB cva co cC cA csm co cB
        cva co csp co cC cA csm co cC cA csm co cB cva co csp co cB cC cA csm
        co cB cva co csp co caddc co wceq cC cA lnopunilem1.5 lnopunilem.3
        hvmulcli lnopunilem.4 cC cA csm co cB cC cA lnopunilem1.5 lnopunilem.3
        hvmulcli lnopunilem.4 hvaddcli cC cA csm co cB cC cA csm co cB cva co
        ax-his2 mp3an cC cA csm co cC cA csm co cB cva co csp co cC cC ccj cfv
        cA cA csp co cmul co cmul co cC cA cB csp co cmul co caddc co cB cC cA
        csm co cB cva co csp co cC cA cB csp co cmul co ccj cfv cB cB csp co
        caddc co caddc cC cA csm co cC cA csm co cB cva co csp co cC cA cC cA
        csm co cB cva co csp co cmul co cC cC ccj cfv cA cA csp co cmul co cA
        cB csp co caddc co cmul co cC cC ccj cfv cA cA csp co cmul co cmul co
        cC cA cB csp co cmul co caddc co cC cc wcel cA chil wcel cC cA csm co
        cB cva co chil wcel cC cA csm co cC cA csm co cB cva co csp co cC cA cC
        cA csm co cB cva co csp co cmul co wceq lnopunilem1.5 lnopunilem.3 cC
        cA csm co cB cC cA lnopunilem1.5 lnopunilem.3 hvmulcli lnopunilem.4
        hvaddcli cC cA cC cA csm co cB cva co ax-his3 mp3an cA cC cA csm co cB
        cva co csp co cC ccj cfv cA cA csp co cmul co cA cB csp co caddc co cC
        cmul cA cC cA csm co cB cva co csp co cA cC cA csm co csp co cA cB csp
        co caddc co cC ccj cfv cA cA csp co cmul co cA cB csp co caddc co cA
        chil wcel cC cA csm co chil wcel cB chil wcel cA cC cA csm co cB cva co
        csp co cA cC cA csm co csp co cA cB csp co caddc co wceq lnopunilem.3
        cC cA lnopunilem1.5 lnopunilem.3 hvmulcli lnopunilem.4 cA cC cA csm co
        cB his7 mp3an cA cC cA csm co csp co cC ccj cfv cA cA csp co cmul co cA
        cB csp co caddc cC cc wcel cA chil wcel cA chil wcel cA cC cA csm co
        csp co cC ccj cfv cA cA csp co cmul co wceq lnopunilem1.5 lnopunilem.3
        lnopunilem.3 cC cA cA his5 mp3an opreq1i eqtri opreq2i cC cC ccj cfv cA
        cA csp co cmul co cA cB csp co lnopunilem1.5 cC ccj cfv cA cA csp co cC
        lnopunilem1.5 cjcli cA cA lnopunilem.3 lnopunilem.3 hicli mulcli cA cB
        lnopunilem.3 lnopunilem.4 hicli adddii 3eqtri cB cC cA csm co cB cva co
        csp co cB cC cA csm co csp co cB cB csp co caddc co cC cA cB csp co
        cmul co ccj cfv cB cB csp co caddc co cB chil wcel cC cA csm co chil
        wcel cB chil wcel cB cC cA csm co cB cva co csp co cB cC cA csm co csp
        co cB cB csp co caddc co wceq lnopunilem.4 cC cA lnopunilem1.5
        lnopunilem.3 hvmulcli lnopunilem.4 cB cC cA csm co cB his7 mp3an cB cC
        cA csm co csp co cC cA cB csp co cmul co ccj cfv cB cB csp co caddc cC
        ccj cfv cB cA csp co cmul co cC ccj cfv cA cB csp co ccj cfv cmul co cB
        cC cA csm co csp co cC cA cB csp co cmul co ccj cfv cB cA csp co cA cB
        csp co ccj cfv cC ccj cfv cmul cB cA lnopunilem.4 lnopunilem.3 his1i
        opreq2i cC cc wcel cB chil wcel cA chil wcel cB cC cA csm co csp co cC
        ccj cfv cB cA csp co cmul co wceq lnopunilem1.5 lnopunilem.4
        lnopunilem.3 cC cB cA his5 mp3an cC cA cB csp co lnopunilem1.5 cA cB
        lnopunilem.3 lnopunilem.4 hicli cjmuli 3eqtr4i opreq1i eqtri opreq12i
        eqtr2i 3eqtr4i cC cC ccj cfv cA cT cfv cA cT cfv csp co cmul co cmul co
        cB cT cfv cB cT cfv csp co cC cA cT cfv cB cT cfv csp co cmul co cC cA
        cT cfv cB cT cfv csp co cmul co ccj cfv cC cC ccj cfv cA cT cfv cA cT
        cfv csp co cmul co lnopunilem1.5 cC ccj cfv cA cT cfv cA cT cfv csp co
        cC lnopunilem1.5 cjcli cA cT cfv cA cT cfv cA chil wcel cA cT cfv chil
        wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        cA chil wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp hicli mulcli mulcli cB cT cfv cB cT
        cfv cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp cB chil wcel cB cT cfv chil wcel
        lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        hicli cC cA cT cfv cB cT cfv csp co lnopunilem1.5 cA cT cfv cB cT cfv
        cA chil wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp cB chil wcel cB cT cfv chil wcel
        lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        hicli mulcli cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT
        cfv csp co lnopunilem1.5 cA cT cfv cB cT cfv cA chil wcel cA cT cfv
        chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni
        ax-mp cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp hicli mulcli cjcli add42i cC cC ccj
        cfv cA cA csp co cmul co cmul co cB cB csp co cC cA cB csp co cmul co
        cC cA cB csp co cmul co ccj cfv cC cC ccj cfv cA cA csp co cmul co
        lnopunilem1.5 cC ccj cfv cA cA csp co cC lnopunilem1.5 cjcli cA cA
        lnopunilem.3 lnopunilem.3 hicli mulcli mulcli cB cB lnopunilem.4
        lnopunilem.4 hicli cC cA cB csp co lnopunilem1.5 cA cB lnopunilem.3
        lnopunilem.4 hicli mulcli cC cA cB csp co cmul co cC cA cB csp co
        lnopunilem1.5 cA cB lnopunilem.3 lnopunilem.4 hicli mulcli cjcli add42i
        3eqtr4i eqtr3i cC cC ccj cfv cA cA csp co cmul co cmul co cB cB csp co
        caddc co cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT cfv
        csp co cmul co ccj cfv caddc co cC cA cB csp co cmul co cC cA cB csp co
        cmul co ccj cfv caddc co cC cC ccj cfv cA cA csp co cmul co cmul co cB
        cB csp co cC cC ccj cfv cA cA csp co cmul co lnopunilem1.5 cC ccj cfv
        cA cA csp co cC lnopunilem1.5 cjcli cA cA lnopunilem.3 lnopunilem.3
        hicli mulcli mulcli cB cB lnopunilem.4 lnopunilem.4 hicli addcli cC cA
        cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT cfv csp co cmul co
        ccj cfv cC cA cT cfv cB cT cfv csp co lnopunilem1.5 cA cT cfv cB cT cfv
        cA chil wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp cB chil wcel cB cT cfv chil wcel
        lnopunilem.4 chil chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        hicli mulcli cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT
        cfv csp co lnopunilem1.5 cA cT cfv cB cT cfv cA chil wcel cA cT cfv
        chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni
        ax-mp cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp hicli mulcli cjcli addcli cC cA cB
        csp co cmul co cC cA cB csp co cmul co ccj cfv cC cA cB csp co
        lnopunilem1.5 cA cB lnopunilem.3 lnopunilem.4 hicli mulcli cC cA cB csp
        co cmul co cC cA cB csp co lnopunilem1.5 cA cB lnopunilem.3
        lnopunilem.4 hicli mulcli cjcli addcli addcani mpbi opreq1i cC cA cT
        cfv cB cT cfv csp co cmul co cc wcel cC cA cT cfv cB cT cfv csp co cmul
        co cre cfv cC cA cT cfv cB cT cfv csp co cmul co cC cA cT cfv cB cT cfv
        csp co cmul co ccj cfv caddc co c2 cdiv co wceq cC cA cT cfv cB cT cfv
        csp co lnopunilem1.5 cA cT cfv cB cT cfv cA chil wcel cA cT cfv chil
        wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1 lnopfi ffvelrni ax-mp
        cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil chil cB cT cT
        lnopunilem.1 lnopfi ffvelrni ax-mp hicli mulcli cC cA cT cfv cB cT cfv
        csp co cmul co recj ax-mp cC cA cB csp co cmul co cc wcel cC cA cB csp
        co cmul co cre cfv cC cA cB csp co cmul co cC cA cB csp co cmul co ccj
        cfv caddc co c2 cdiv co wceq cC cA cB csp co lnopunilem1.5 cA cB
        lnopunilem.3 lnopunilem.4 hicli mulcli cC cA cB csp co cmul co recj
        ax-mp 3eqtr4i $.
        $( [27-May-2006] $) $( [14-May-2005] $)
    $}

    $( Lemma for ~ lnopunii . $)
    lnopunilem2 $p |- ( ( T ` A ) .ih ( T ` B ) ) = ( A .ih B ) $=
      vy cv cA cT cfv cB cT cfv csp co cmul co cre cfv vy cv cA cB csp co cmul
      co cre cfv wceq vy cc wral cA cT cfv cB cT cfv csp co cA cB csp co wceq
      vy cv cA cT cfv cB cT cfv csp co cmul co cre cfv vy cv cA cB csp co cmul
      co cre cfv wceq vy cc vy cv cc wcel vy cv cA cT cfv cB cT cfv csp co cmul
      co cre cfv vy cv cA cB csp co cmul co cre cfv wceq vy cv cc wcel vy cv
      cc0 cif cA cT cfv cB cT cfv csp co cmul co cre cfv vy cv cc wcel vy cv
      cc0 cif cA cB csp co cmul co cre cfv wceq vy cv cc0 vy cv vy cv cc wcel
      vy cv cc0 cif wceq vy cv cA cT cfv cB cT cfv csp co cmul co cre cfv vy cv
      cc wcel vy cv cc0 cif cA cT cfv cB cT cfv csp co cmul co cre cfv vy cv cA
      cB csp co cmul co cre cfv vy cv cc wcel vy cv cc0 cif cA cB csp co cmul
      co cre cfv vy cv vy cv cc wcel vy cv cc0 cif wceq vy cv cA cT cfv cB cT
      cfv csp co cmul co vy cv cc wcel vy cv cc0 cif cA cT cfv cB cT cfv csp co
      cmul co cre vy cv vy cv cc wcel vy cv cc0 cif cA cT cfv cB cT cfv csp co
      cmul opreq1 fveq2d vy cv vy cv cc wcel vy cv cc0 cif wceq vy cv cA cB csp
      co cmul co vy cv cc wcel vy cv cc0 cif cA cB csp co cmul co cre vy cv vy
      cv cc wcel vy cv cc0 cif cA cB csp co cmul opreq1 fveq2d eqeq12d vx cA cB
      vy cv cc wcel vy cv cc0 cif cT lnopunilem.1 lnopunilem.2 lnopunilem.3
      lnopunilem.4 vy cv cc0 cc 0cn elimel lnopunilem1 dedth rgen cA cT cfv cB
      cT cfv csp co cc wcel cA cB csp co cc wcel vy cv cA cT cfv cB cT cfv csp
      co cmul co cre cfv vy cv cA cB csp co cmul co cre cfv wceq vy cc wral cA
      cT cfv cB cT cfv csp co cA cB csp co wceq wb cA cT cfv cB cT cfv cA chil
      wcel cA cT cfv chil wcel lnopunilem.3 chil chil cA cT cT lnopunilem.1
      lnopfi ffvelrni ax-mp cB chil wcel cB cT cfv chil wcel lnopunilem.4 chil
      chil cB cT cT lnopunilem.1 lnopfi ffvelrni ax-mp hicli cA cB lnopunilem.3
      lnopunilem.4 hicli vy cA cT cfv cB cT cfv csp co cA cB csp co recan mp2an
      mpbi $.
      $( [28-May-2006] $) $( [12-May-2005] $)
  $}

  ${
    $d x y T $.
    lnopuni.1 $e |- T e. LinOp $.
    lnopuni.2 $e |- T : ~H -onto-> ~H $.
    lnopuni.3 $e |- A. x e. ~H ( normh ` ( T ` x ) ) = ( normh ` x ) $.
    $( If a linear operator (whose range is ` ~H ` ) is idempotent in the norm,
       the operator is unitary.  Similar to theorem in [AkhiezerGlazman]
       p. 73. $)
    lnopunii $p |- T e. UniOp $=
      cT cuo wcel chil chil cT wfo vx cv cT cfv vy cv cT cfv csp co vx cv vy cv
      csp co wceq vy chil wral vx chil wral vx vy cT elunop lnopuni.2 vx cv cT
      cfv vy cv cT cfv csp co vx cv vy cv csp co wceq vx vy chil vx cv chil
      wcel vy cv chil wcel vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co
      wceq vx cv chil wcel vx cv c0v cif cT cfv vy cv cT cfv csp co vx cv chil
      wcel vx cv c0v cif vy cv csp co wceq vx cv chil wcel vx cv c0v cif cT cfv
      vy cv chil wcel vy cv c0v cif cT cfv csp co vx cv chil wcel vx cv c0v cif
      vy cv chil wcel vy cv c0v cif csp co wceq vx cv vy cv c0v c0v vx cv vx cv
      chil wcel vx cv c0v cif wceq vx cv cT cfv vy cv cT cfv csp co vx cv chil
      wcel vx cv c0v cif cT cfv vy cv cT cfv csp co vx cv vy cv csp co vx cv
      chil wcel vx cv c0v cif vy cv csp co vx cv vx cv chil wcel vx cv c0v cif
      wceq vx cv cT cfv vx cv chil wcel vx cv c0v cif cT cfv vy cv cT cfv csp
      vx cv vx cv chil wcel vx cv c0v cif cT fveq2 opreq1d vx cv vx cv chil
      wcel vx cv c0v cif vy cv csp opreq1 eqeq12d vy cv vy cv chil wcel vy cv
      c0v cif wceq vx cv chil wcel vx cv c0v cif cT cfv vy cv cT cfv csp co vx
      cv chil wcel vx cv c0v cif cT cfv vy cv chil wcel vy cv c0v cif cT cfv
      csp co vx cv chil wcel vx cv c0v cif vy cv csp co vx cv chil wcel vx cv
      c0v cif vy cv chil wcel vy cv c0v cif csp co vy cv vy cv chil wcel vy cv
      c0v cif wceq vy cv cT cfv vy cv chil wcel vy cv c0v cif cT cfv vx cv chil
      wcel vx cv c0v cif cT cfv csp vy cv vy cv chil wcel vy cv c0v cif cT
      fveq2 opreq2d vy cv vy cv chil wcel vy cv c0v cif vx cv chil wcel vx cv
      c0v cif csp opreq2 eqeq12d vx vx cv chil wcel vx cv c0v cif vy cv chil
      wcel vy cv c0v cif cT lnopuni.1 lnopuni.3 vx cv c0v chil ax-hv0cl elimel
      vy cv c0v chil ax-hv0cl elimel lnopunilem2 dedth2h rgen2a mpbir2an $.
      $( [28-May-2006] $) $( [23-Jan-2006] $)
  $}

  ${
    $d w x y z T $.
    $( An operator is unitary iff it is linear, onto, and idempotent in the
       norm.  Similar to theorem in [AkhiezerGlazman] p. 73, and its
       converse. $)
    elunop2 $p |- ( T e. UniOp <-> ( T e. LinOp /\ T : ~H -onto-> ~H /\
                 A. x e. ~H ( normh ` ( T ` x ) ) = ( normh ` x ) ) ) $=
      cT cuo wcel cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cuo wcel cT clo wcel chil chil cT wfo vx cv
      cT cfv cno cfv vx cv cno cfv wceq vx chil wral cT unoplin cT cuo wcel
      chil chil cT wfo vx cv cT cfv vy cv cT cfv csp co vx cv vy cv csp co wceq
      vy chil wral vx chil wral vx vy cT elunop pm3.26bi cT cuo wcel vx cv cT
      cfv cno cfv vx cv cno cfv wceq vx chil vx cv cT unopnorm r19.21aiva 3jca
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cuo wcel cT clo wcel chil chil cT wfo vx cv cT cfv cno
      cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cuo wcel cT
      cid chil cres cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv
      cno cfv wceq vx chil wral w3a cT cid chil cres cif cuo eleq1 vy cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif clo wcel
      chil chil cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv
      wceq vx chil wral w3a cT cid chil cres cif wfo vy cv cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      cid chil cres cif cfv cno cfv vy cv cno cfv wceq vy chil wral cT clo wcel
      chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif clo wcel chil chil cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      cid chil cres cif wfo vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno
      cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv
      vy cv cno cfv wceq vy chil wral w3a cid chil cres clo wcel chil chil cid
      chil cres wfo vy cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy chil
      wral w3a cT cid chil cres cT cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq cT
      clo wcel cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv
      wceq vx chil wral w3a cT cid chil cres cif clo wcel chil chil cT wfo chil
      chil cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral w3a cT cid chil cres cif wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno
      cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv
      vy cv cno cfv wceq vy chil wral cT cT clo wcel chil chil cT wfo vx cv cT
      cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif clo
      eleq1 chil chil cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif foeq1 cT cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq vy cv cT cfv cno cfv vy cv cno cfv
      wceq vy chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy
      cv cno cfv wceq vy chil wral vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy cv cT cfv cno cfv
      vy cv cno cfv wceq vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno
      cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv
      vy cv cno cfv wceq vy chil cT cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy
      cv cT cfv cno cfv vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy
      cv cno cfv cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy cv cT cfv vy cv cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif cfv cno vy cv cT cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif fveq1 fveq2d eqeq1d ralbidv vx cv cT cfv cno cfv vx cv cno cfv
      wceq vy cv cT cfv cno cfv vy cv cno cfv wceq vx vy chil vx cv vy cv wceq
      vx cv cT cfv cno cfv vy cv cT cfv cno cfv vx cv cno cfv vy cv cno cfv vx
      cv vy cv wceq vx cv cT cfv vy cv cT cfv cno vx cv vy cv cT fveq2 fveq2d
      vx cv vy cv cno fveq2 eqeq12d cbvralv syl5bb 3anbi123d cid chil cres cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq cid chil cres clo wcel cT clo wcel
      chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a
      cT cid chil cres cif clo wcel chil chil cid chil cres wfo chil chil cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wfo vy cv cid chil cres cfv cno cfv vy cv
      cno cfv wceq vy chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno
      cfv vy cv cno cfv wceq vy chil wral cid chil cres cT clo wcel chil chil
      cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid
      chil cres cif clo eleq1 chil chil cid chil cres cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif foeq1 cid chil cres cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy
      cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy cv cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      cid chil cres cif cfv cno cfv vy cv cno cfv wceq vy chil cid chil cres cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq vy cv cid chil cres cfv cno cfv vy cv
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif cfv cno cfv vy cv cno cfv cid chil
      cres cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral w3a cT cid chil cres cif wceq vy cv cid chil cres cfv vy cv
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif cfv cno vy cv cid chil cres cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif fveq1 fveq2d eqeq1d ralbidv 3anbi123d cid
      chil cres clo wcel chil chil cid chil cres wfo vy cv cid chil cres cfv
      cno cfv vy cv cno cfv wceq vy chil wral idlnop chil chil cid chil cres
      wf1o chil chil cid chil cres wfo chil f1oi chil chil cid chil cres f1ofo
      ax-mp vy cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy chil vy cv
      chil wcel vy cv cid chil cres cfv vy cv cno chil vy cv fvresi fveq2d rgen
      3pm3.2i elimhyp 3simp1i cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif clo wcel chil
      chil cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral w3a cT cid chil cres cif wfo vy cv cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif cfv cno cfv vy cv cno cfv wceq vy chil wral cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif clo wcel chil chil cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif wfo vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy cv
      cno cfv wceq vy chil wral w3a cid chil cres clo wcel chil chil cid chil
      cres wfo vy cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy chil wral
      w3a cT cid chil cres cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq cT clo wcel
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif clo wcel chil chil cT wfo chil chil cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy cv
      cno cfv wceq vy chil wral cT cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif clo
      eleq1 chil chil cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif foeq1 cT cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq vy cv cT cfv cno cfv vy cv cno cfv
      wceq vy chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy
      cv cno cfv wceq vy chil wral vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy cv cT cfv cno cfv
      vy cv cno cfv wceq vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno
      cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv
      vy cv cno cfv wceq vy chil cT cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy
      cv cT cfv cno cfv vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy
      cv cno cfv cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy cv cT cfv vy cv cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif cfv cno vy cv cT cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif fveq1 fveq2d eqeq1d ralbidv vx cv cT cfv cno cfv vx cv cno cfv
      wceq vy cv cT cfv cno cfv vy cv cno cfv wceq vx vy chil vx cv vy cv wceq
      vx cv cT cfv cno cfv vy cv cT cfv cno cfv vx cv cno cfv vy cv cno cfv vx
      cv vy cv wceq vx cv cT cfv vy cv cT cfv cno vx cv vy cv cT fveq2 fveq2d
      vx cv vy cv cno fveq2 eqeq12d cbvralv syl5bb 3anbi123d cid chil cres cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq cid chil cres clo wcel cT clo wcel
      chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a
      cT cid chil cres cif clo wcel chil chil cid chil cres wfo chil chil cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wfo vy cv cid chil cres cfv cno cfv vy cv
      cno cfv wceq vy chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno
      cfv vy cv cno cfv wceq vy chil wral cid chil cres cT clo wcel chil chil
      cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid
      chil cres cif clo eleq1 chil chil cid chil cres cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif foeq1 cid chil cres cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy
      cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy cv cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      cid chil cres cif cfv cno cfv vy cv cno cfv wceq vy chil cid chil cres cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq vy cv cid chil cres cfv cno cfv vy cv
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif cfv cno cfv vy cv cno cfv cid chil
      cres cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral w3a cT cid chil cres cif wceq vy cv cid chil cres cfv vy cv
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif cfv cno vy cv cid chil cres cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif fveq1 fveq2d eqeq1d ralbidv 3anbi123d cid
      chil cres clo wcel chil chil cid chil cres wfo vy cv cid chil cres cfv
      cno cfv vy cv cno cfv wceq vy chil wral idlnop chil chil cid chil cres
      wf1o chil chil cid chil cres wfo chil f1oi chil chil cid chil cres f1ofo
      ax-mp vy cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy chil vy cv
      chil wcel vy cv cid chil cres cfv vy cv cno chil vy cv fvresi fveq2d rgen
      3pm3.2i elimhyp 3simp2i cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif clo wcel chil
      chil cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral w3a cT cid chil cres cif wfo vy cv cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif cfv cno cfv vy cv cno cfv wceq vy chil wral cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif clo wcel chil chil cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif wfo vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy cv
      cno cfv wceq vy chil wral w3a cid chil cres clo wcel chil chil cid chil
      cres wfo vy cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy chil wral
      w3a cT cid chil cres cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq cT clo wcel
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif clo wcel chil chil cT wfo chil chil cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy cv
      cno cfv wceq vy chil wral cT cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif clo
      eleq1 chil chil cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx
      cv cno cfv wceq vx chil wral w3a cT cid chil cres cif foeq1 cT cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq vy cv cT cfv cno cfv vy cv cno cfv
      wceq vy chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy
      cv cno cfv wceq vy chil wral vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy cv cT cfv cno cfv
      vy cv cno cfv wceq vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno
      cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv
      vy cv cno cfv wceq vy chil cT cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy
      cv cT cfv cno cfv vy cv cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv
      vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno cfv vy
      cv cno cfv cT cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno
      cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy cv cT cfv vy cv cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif cfv cno vy cv cT cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif fveq1 fveq2d eqeq1d ralbidv vx cv cT cfv cno cfv vx cv cno cfv
      wceq vy cv cT cfv cno cfv vy cv cno cfv wceq vx vy chil vx cv vy cv wceq
      vx cv cT cfv cno cfv vy cv cT cfv cno cfv vx cv cno cfv vy cv cno cfv vx
      cv vy cv wceq vx cv cT cfv vy cv cT cfv cno vx cv vy cv cT fveq2 fveq2d
      vx cv vy cv cno fveq2 eqeq12d cbvralv syl5bb 3anbi123d cid chil cres cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq cid chil cres clo wcel cT clo wcel
      chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a
      cT cid chil cres cif clo wcel chil chil cid chil cres wfo chil chil cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wfo vy cv cid chil cres cfv cno cfv vy cv
      cno cfv wceq vy chil wral vy cv cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif cfv cno
      cfv vy cv cno cfv wceq vy chil wral cid chil cres cT clo wcel chil chil
      cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid
      chil cres cif clo eleq1 chil chil cid chil cres cT clo wcel chil chil cT
      wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil
      cres cif foeq1 cid chil cres cT clo wcel chil chil cT wfo vx cv cT cfv
      cno cfv vx cv cno cfv wceq vx chil wral w3a cT cid chil cres cif wceq vy
      cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy cv cT clo wcel chil
      chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil wral w3a cT
      cid chil cres cif cfv cno cfv vy cv cno cfv wceq vy chil cid chil cres cT
      clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif wceq vy cv cid chil cres cfv cno cfv vy cv
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif cfv cno cfv vy cv cno cfv cid chil
      cres cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq
      vx chil wral w3a cT cid chil cres cif wceq vy cv cid chil cres cfv vy cv
      cT clo wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx
      chil wral w3a cT cid chil cres cif cfv cno vy cv cid chil cres cT clo
      wcel chil chil cT wfo vx cv cT cfv cno cfv vx cv cno cfv wceq vx chil
      wral w3a cT cid chil cres cif fveq1 fveq2d eqeq1d ralbidv 3anbi123d cid
      chil cres clo wcel chil chil cid chil cres wfo vy cv cid chil cres cfv
      cno cfv vy cv cno cfv wceq vy chil wral idlnop chil chil cid chil cres
      wf1o chil chil cid chil cres wfo chil f1oi chil chil cid chil cres f1ofo
      ax-mp vy cv cid chil cres cfv cno cfv vy cv cno cfv wceq vy chil vy cv
      chil wcel vy cv cid chil cres cfv vy cv cno chil vy cv fvresi fveq2d rgen
      3pm3.2i elimhyp 3simp3i lnopunii dedth impbii $.
      $( [26-Oct-2006] $) $( [24-Feb-2006] $)

    $( Norm of a unitary Hilbert space operator. $)
    nmopun $p |- ( ( ~H =/= 0H /\ T e. UniOp ) -> ( normop ` T ) = 1 ) $=
      chil c0h wne cT cuo wcel wa cT cnop cfv vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup c1 cT cuo wcel
      cT cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa
      vy chil wrex vx cab cxr clt csup wceq chil c0h wne cT cuo wcel chil chil
      cT wf cT cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv
      wceq wa vy chil wrex vx cab cxr clt csup wceq cT cuo wcel cT clo wcel
      chil chil cT wf cT unoplin cT lnopf syl vx vy cT nmopval syl adantl vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab
      cxr wss c1 cxr wcel wa vz cv c1 cle wbr vz vy cv cno cfv c1 cle wbr vx cv
      vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab wral vz cv c1 clt wbr vz
      cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv
      wceq wa vy chil wrex vx cab wrex wi vz cr wral wa vy cv cno cfv c1 cle
      wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr clt csup
      c1 wceq chil c0h wne cT cuo wcel wa vz vw vy cv cno cfv c1 cle wbr vx cv
      vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab c1 supxr2 chil c0h wne
      cT cuo wcel wa vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vx cab cxr wss c1 cxr wcel cT cuo wcel vy cv cno cfv c1
      cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr wss
      chil c0h wne cT cuo wcel chil chil cT wf vy cv cno cfv c1 cle wbr vx cv
      vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cxr wss cT cuo wcel cT
      clo wcel chil chil cT wf cT unoplin cT lnopf syl chil chil cT wf vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab
      cr cxr vx vy cT nmopsetretHIL cr cxr wss chil chil cT wf ressxr a1i sstrd
      syl adantl c1 cr wcel c1 cxr wcel 1re c1 rexr ax-mp jctir chil c0h wne cT
      cuo wcel wa vz cv c1 cle wbr vz vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cno cfv wceq wa vy chil wrex vx cab wral vz cv c1 clt wbr vz cv vw cv
      clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy
      chil wrex vx cab wrex wi vz cr wral cT cuo wcel vz cv c1 cle wbr vz vy cv
      cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab
      wral chil c0h wne cT cuo wcel vz cv c1 cle wbr vz vy cv cno cfv c1 cle
      wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab cT cuo wcel vy
      cv cno cfv c1 cle wbr vz cv vy cv cT cfv cno cfv wceq wa vy chil wrex vz
      cv c1 cle wbr vz cv vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv
      wceq wa vy chil wrex vx cab wcel cT cuo wcel vy cv cno cfv c1 cle wbr vz
      cv vy cv cT cfv cno cfv wceq wa vy chil wrex vz cv c1 cle wbr cT cuo wcel
      vy cv cno cfv c1 cle wbr vz cv vy cv cT cfv cno cfv wceq wa vz cv c1 cle
      wbr vy chil cT cuo wcel vy cv chil wcel wa vy cv cno cfv c1 cle wbr vz cv
      vy cv cT cfv cno cfv wceq wa vy cv cno cfv c1 cle wbr vz cv vy cv cno cfv
      wceq wa vz cv c1 cle wbr cT cuo wcel vy cv chil wcel wa vz cv vy cv cT
      cfv cno cfv wceq vz cv vy cv cno cfv wceq vy cv cno cfv c1 cle wbr cT cuo
      wcel vy cv chil wcel wa vy cv cT cfv cno cfv vy cv cno cfv vz cv vy cv cT
      unopnorm eqeq2d anbi2d vz cv vy cv cno cfv wceq vz cv c1 cle wbr vy cv
      cno cfv c1 cle wbr vz cv vy cv cno cfv c1 cle breq1 biimparc syl6bi
      r19.23adva imp vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vy cv cno cfv c1 cle wbr vz cv vy cv cT cfv cno cfv wceq
      wa vy chil wrex vx vz cv vz visset vx cv vz cv wceq vy cv cno cfv c1 cle
      wbr vx cv vy cv cT cfv cno cfv wceq wa vy cv cno cfv c1 cle wbr vz cv vy
      cv cT cfv cno cfv wceq wa vy chil vx cv vz cv wceq vx cv vy cv cT cfv cno
      cfv wceq vz cv vy cv cT cfv cno cfv wceq vy cv cno cfv c1 cle wbr vx cv
      vz cv vy cv cT cfv cno cfv eqeq1 anbi2d rexbidv elab sylan2b r19.21aiva
      adantl chil c0h wne cT cuo wcel wa vz cv c1 clt wbr vz cv vw cv clt wbr
      vw vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil
      wrex vx cab wrex wi vz cr chil c0h wne cT cuo wcel wa vz cv cr wcel wa vz
      cv c1 clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv
      cT cfv cno cfv wceq wa vy chil wrex vx cab wrex c1 vy cv cno cfv c1 cle
      wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab wcel vz cv c1
      clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cT
      cfv cno cfv wceq wa vy chil wrex vx cab wrex chil c0h wne cT cuo wcel wa
      vz cv cr wcel wa vz cv vw cv clt wbr vz cv c1 clt wbr vw c1 vy cv cno cfv
      c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab vw cv
      c1 vz cv clt breq2 rcla4ev chil c0h wne cT cuo wcel wa c1 vy cv cno cfv
      c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vx cab wcel vz
      cv cr wcel chil c0h wne cT cuo wcel wa vy cv cno cfv c1 cle wbr c1 vy cv
      cT cfv cno cfv wceq wa vy chil wrex c1 vy cv cno cfv c1 cle wbr vx cv vy
      cv cT cfv cno cfv wceq wa vy chil wrex vx cab wcel chil c0h wne cT cuo
      wcel wa vy cv cno cfv c1 wceq vy chil wrex vy cv cno cfv c1 cle wbr c1 vy
      cv cT cfv cno cfv wceq wa vy chil wrex chil c0h wne vy cv cno cfv c1 wceq
      vy chil wrex cT cuo wcel chil c0h wne vy cv cno cfv c1 wceq vy chil wrex
      chil c0h wne vy cv c0v wne vy chil wrex vy cv cno cfv c1 wceq vy chil
      wrex vy hne0 vy vy norm1hex bitri biimpi adantr chil c0h wne cT cuo wcel
      wa vy cv cno cfv c1 wceq vy cv cno cfv c1 cle wbr c1 vy cv cT cfv cno cfv
      wceq wa vy chil cT cuo wcel vy cv chil wcel vy cv cno cfv c1 wceq vy cv
      cno cfv c1 cle wbr c1 vy cv cT cfv cno cfv wceq wa wi chil c0h wne cT cuo
      wcel vy cv chil wcel wa vy cv cno cfv c1 wceq vy cv cno cfv c1 cle wbr c1
      vy cv cT cfv cno cfv wceq vy cv cno cfv c1 wceq vy cv cno cfv c1 cle wbr
      wi cT cuo wcel vy cv chil wcel wa vy cv cno cfv c1 wceq vy cv cno cfv c1
      cle wbr c1 c1 cle wbr c1 1re leidi vy cv cno cfv c1 c1 cle breq1 mpbiri
      a1i cT cuo wcel vy cv chil wcel wa vy cv cno cfv c1 wceq c1 vy cv cT cfv
      cno cfv wceq cT cuo wcel vy cv chil wcel wa vy cv cno cfv c1 wceq wa vy
      cv cT cfv cno cfv c1 cT cuo wcel vy cv chil wcel wa vy cv cno cfv c1 wceq
      wa vy cv cT cfv cno cfv vy cv cno cfv wceq vy cv cT cfv cno cfv c1 wceq
      cT cuo wcel vy cv chil wcel wa vy cv cT cfv cno cfv vy cv cno cfv wceq vy
      cv cno cfv c1 wceq vy cv cT unopnorm adantr vy cv cno cfv c1 wceq vy cv
      cT cfv cno cfv vy cv cno cfv wceq vy cv cT cfv cno cfv c1 wceq wb cT cuo
      wcel vy cv chil wcel wa vy cv cno cfv c1 vy cv cT cfv cno cfv eqeq2
      adantl mpbid eqcomd ex jcad adantll r19.22dva mpd vy cv cno cfv c1 cle
      wbr vx cv vy cv cT cfv cno cfv wceq wa vy chil wrex vy cv cno cfv c1 cle
      wbr c1 vy cv cT cfv cno cfv wceq wa vy chil wrex vx c1 c1 cr 1re elisseti
      vx cv c1 wceq vy cv cno cfv c1 cle wbr vx cv vy cv cT cfv cno cfv wceq wa
      vy cv cno cfv c1 cle wbr c1 vy cv cT cfv cno cfv wceq wa vy chil vx cv c1
      wceq vx cv vy cv cT cfv cno cfv wceq c1 vy cv cT cfv cno cfv wceq vy cv
      cno cfv c1 cle wbr vx cv c1 vy cv cT cfv cno cfv eqeq1 anbi2d rexbidv
      elab sylibr adantr sylan ex r19.21aiva jca sylanc eqtrd $.
      $( [26-Mar-2006] $) $( [25-Feb-2006] $)
  $}

  $( A unitary operator is a bounded linear operator. $)
  unopbd $p |- ( T e. UniOp -> T e. BndLinOp ) $=
    cT cuo wcel cT clo wcel cT cnop cfv cr wcel wa cT cbo wcel cT cuo wcel cT
    clo wcel cT cnop cfv cr wcel cT unoplin chil c0h wceq cT cuo wcel cT cnop
    cfv cr wcel chil c0h wceq chil chil cT wf cT cnop cfv cr wcel cT cuo wcel
    chil c0h wceq chil chil cT wf wa cT cnop cfv cc0 cr cT nmop0h 0re syl6eqel
    cT cuo wcel chil chil cT wf1o chil chil cT wf cT unopf1o chil chil cT f1of
    syl sylan2 chil c0h wne cT cuo wcel cT cnop cfv cr wcel chil c0h wceq wn
    chil c0h wne cT cuo wcel wa cT cnop cfv c1 cr cT nmopun 1re syl6eqel chil
    c0h df-ne sylanbr pm2.61ian jca cT elbdop2 sylibr $.
    $( [1-May-2006] $) $( [10-Mar-2006] $)

  ${
    $d x A $.  $d x B $.  $d x y z T $.
    lnophmlem.1 $e |- A e. ~H $.
    lnophmlem.2 $e |- B e. ~H $.
    lnophmlem.3 $e |- T e. LinOp $.
    lnophmlem.4 $e |- A. x e. ~H ( x .ih ( T ` x ) ) e. RR $.
    $( Lemma for ~ lnophmi . $)
    lnophmlem1 $p |- ( A .ih ( T ` A ) ) e. RR $=
      cA chil wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral cA cA cT cfv
      csp co cr wcel lnophmlem.1 lnophmlem.4 vx cv vx cv cT cfv csp co cr wcel
      cA cA cT cfv csp co cr wcel vx cA chil vx cv cA wceq vx cv vx cv cT cfv
      csp co cA cA cT cfv csp co cr vx cv cA wceq vx cv cA vx cv cT cfv cA cT
      cfv csp vx cv cA wceq id vx cv cA cT fveq2 opreq12d eleq1d rcla4v mp2 $.
      $( [24-Jan-2006] $) $( [24-Jan-2006] $)

    $( Lemma for ~ lnophmi .  _Warning:  The HTML proof page is 1/2 megabyte
       in size_. $)
    lnophmlem2 $p |- ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) $=
      cA cB cva co cA cT cfv cB cT cfv cva co csp co cA cB cmv co cA cT cfv cB
      cT cfv cmv co csp co cmin co ci cA ci cB csm co cva co cA cT cfv ci cB cT
      cfv csm co cva co csp co cA ci cB csm co cmv co cA cT cfv ci cB cT cfv
      csm co cmv co csp co cmin co cmul co caddc co c4 cdiv co cB cA cT cfv csp
      co ccj cfv cA cB cT cfv csp co cA cT cfv cB csp co cB cA cT cfv csp co
      ccj cfv cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co
      cT cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT
      cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co
      cmin co cmul co caddc co c4 cdiv co ccj cfv cA cB cva co cA cB cva co cT
      cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB
      csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co
      cA ci cB csm co cva co cT cfv csp co cmin co cmul co caddc co ccj cfv c4
      ccj cfv cdiv co cA cB cva co cA cT cfv cB cT cfv cva co csp co cA cB cmv
      co cA cT cfv cB cT cfv cmv co csp co cmin co ci cA ci cB csm co cva co cA
      cT cfv ci cB cT cfv csm co cva co csp co cA ci cB csm co cmv co cA cT cfv
      ci cB cT cfv csm co cmv co csp co cmin co cmul co caddc co c4 cdiv co cB
      cA cT cfv csp co cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA
      cB cmv co cT cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co
      cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv
      csp co cmin co cmul co caddc co c4 cdiv co ccj cB cA cT cfv csp co cB cA
      cva co cB cT cfv cA cT cfv cva co csp co cB cA cmv co cB cT cfv cA cT cfv
      cmv co csp co cmin co ci cB ci cA csm co cva co cB cT cfv ci cA cT cfv
      csm co cva co csp co cB ci cA csm co cmv co cB cT cfv ci cA cT cfv csm co
      cmv co csp co cmin co cmul co caddc co c4 cdiv co cA cB cva co cA cB cva
      co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci
      cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva
      co cA ci cB csm co cva co cT cfv csp co cmin co cmul co caddc co c4 cdiv
      co cB cA cT cfv cA cB cT cfv lnophmlem.2 cA chil wcel cA cT cfv chil wcel
      lnophmlem.1 chil chil cA cT cT lnophmlem.3 lnopfi ffvelrni ax-mp
      lnophmlem.1 cB chil wcel cB cT cfv chil wcel lnophmlem.2 chil chil cB cT
      cT lnophmlem.3 lnopfi ffvelrni ax-mp polid2i cB cA cva co cB cT cfv cA cT
      cfv cva co csp co cB cA cmv co cB cT cfv cA cT cfv cmv co csp co cmin co
      ci cB ci cA csm co cva co cB cT cfv ci cA cT cfv csm co cva co csp co cB
      ci cA csm co cmv co cB cT cfv ci cA cT cfv csm co cmv co csp co cmin co
      cmul co caddc co cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA
      cB cmv co cT cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co
      cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv
      csp co cmin co cmul co caddc co c4 cdiv cB cA cva co cB cT cfv cA cT cfv
      cva co csp co cB cA cmv co cB cT cfv cA cT cfv cmv co csp co cmin co cA
      cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp
      co cmin co ci cB ci cA csm co cva co cB cT cfv ci cA cT cfv csm co cva co
      csp co cB ci cA csm co cmv co cB cT cfv ci cA cT cfv csm co cmv co csp co
      cmin co cmul co ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv
      csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin
      co cmul co caddc cB cA cva co cB cT cfv cA cT cfv cva co csp co cA cB cva
      co cA cB cva co cT cfv csp co cB cA cmv co cB cT cfv cA cT cfv cmv co csp
      co cA cB cmv co cA cB cmv co cT cfv csp co cmin cB cA cva co cA cB cva co
      cB cT cfv cA cT cfv cva co cA cB cva co cT cfv csp cB cA lnophmlem.2
      lnophmlem.1 hvcomi cB cT cfv cA cT cfv cva co cA cT cfv cB cT cfv cva co
      cA cB cva co cT cfv cB cT cfv cA cT cfv cB chil wcel cB cT cfv chil wcel
      lnophmlem.2 chil chil cB cT cT lnophmlem.3 lnopfi ffvelrni ax-mp cA chil
      wcel cA cT cfv chil wcel lnophmlem.1 chil chil cA cT cT lnophmlem.3
      lnopfi ffvelrni ax-mp hvcomi cA chil wcel cB chil wcel cA cB cva co cT
      cfv cA cT cfv cB cT cfv cva co wceq lnophmlem.1 lnophmlem.2 cA cB cT
      lnophmlem.3 lnopaddi mp2an eqtr4i opreq12i cB cA cmv co cB cT cfv cA cT
      cfv cmv co csp co cA cB cmv co cA cT cfv cB cT cfv cmv co csp co cA cB
      cmv co cA cB cmv co cT cfv csp co cB cA cB cT cfv cA cT cfv lnophmlem.2
      lnophmlem.1 cB chil wcel cB cT cfv chil wcel lnophmlem.2 chil chil cB cT
      cT lnophmlem.3 lnopfi ffvelrni ax-mp cA chil wcel cA cT cfv chil wcel
      lnophmlem.1 chil chil cA cT cT lnophmlem.3 lnopfi ffvelrni ax-mp
      hisubcomi cA cB cmv co cT cfv cA cT cfv cB cT cfv cmv co cA cB cmv co csp
      cA chil wcel cB chil wcel cA cB cmv co cT cfv cA cT cfv cB cT cfv cmv co
      wceq lnophmlem.1 lnophmlem.2 cA cB cT lnophmlem.3 lnopsubi mp2an opreq2i
      eqtr4i opreq12i cB ci cA csm co cva co cB cT cfv ci cA cT cfv csm co cva
      co csp co cB ci cA csm co cmv co cB cT cfv ci cA cT cfv csm co cmv co csp
      co cmin co cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA
      ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin co ci cmul
      cB ci cA csm co cva co cB cT cfv ci cA cT cfv csm co cva co csp co cA ci
      cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cB ci cA csm co cmv
      co cB cT cfv ci cA cT cfv csm co cmv co csp co cA ci cB csm co cva co cA
      ci cB csm co cva co cT cfv csp co cmin ci cA ci cB csm co cmv co csm co
      ci cA ci cB csm co cmv co cT cfv csm co csp co cB ci cA csm co cva co cB
      cT cfv ci cA cT cfv csm co cva co csp co cA ci cB csm co cmv co cA ci cB
      csm co cmv co cT cfv csp co ci cA ci cB csm co cmv co csm co cB ci cA csm
      co cva co ci cA ci cB csm co cmv co cT cfv csm co cB cT cfv ci cA cT cfv
      csm co cva co csp ci cA ci cB csm co cmv co csm co ci cA csm co ci ci cB
      csm co csm co cmv co ci cA csm co cB cva co cB ci cA csm co cva co ci cA
      ci cB csm co axicn lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli
      hvsubdistr1i ci cA csm co ci ci cB csm co csm co cmv co ci cA csm co c1
      cneg ci ci cB csm co csm co csm co cva co ci cA csm co cB cva co ci cA
      csm co ci ci cB csm co csm co ci cA axicn lnophmlem.1 hvmulcli ci ci cB
      csm co axicn ci cB axicn lnophmlem.2 hvmulcli hvmulcli hvsubvali c1 cneg
      ci ci cB csm co csm co csm co cB ci cA csm co cva c1 cneg ci ci cmul co
      cB csm co csm co c1 cneg ci ci cB csm co csm co csm co cB ci ci cmul co
      cB csm co ci ci cB csm co csm co c1 cneg csm ci ci cB axicn axicn
      lnophmlem.2 hvmulassi opreq2i c1 cneg ci ci cmul co cmul co cB csm co c1
      cB csm co c1 cneg ci ci cmul co cB csm co csm co cB c1 cneg ci ci cmul co
      cmul co c1 cB csm c1 cneg ci ci cmul co cmul co c1 cneg c1 cneg cmul co
      c1 c1 cmul co c1 ci ci cmul co c1 cneg c1 cneg cmul ixi opreq2i c1 c1
      ax1cn ax1cn mul2negi c1 ax1cn mulid1i 3eqtri opreq1i c1 cneg ci ci cmul
      co cB c1 ax1cn negcli ci ci axicn axicn mulcli lnophmlem.2 hvmulassi cB
      chil wcel c1 cB csm co cB wceq lnophmlem.2 cB ax-hvmulid ax-mp 3eqtr3i
      eqtr3i opreq2i eqtri ci cA csm co cB ci cA axicn lnophmlem.1 hvmulcli
      lnophmlem.2 hvcomi 3eqtri ci cA ci cB csm co cmv co csm co cT cfv cB ci
      cA csm co cva co cT cfv ci cA ci cB csm co cmv co cT cfv csm co cB cT cfv
      ci cA cT cfv csm co cva co ci cA ci cB csm co cmv co csm co cB ci cA csm
      co cva co cT ci cA ci cB csm co cmv co csm co ci cA csm co ci ci cB csm
      co csm co cmv co ci cA csm co cB cva co cB ci cA csm co cva co ci cA ci
      cB csm co axicn lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvsubdistr1i
      ci cA csm co ci ci cB csm co csm co cmv co ci cA csm co c1 cneg ci ci cB
      csm co csm co csm co cva co ci cA csm co cB cva co ci cA csm co ci ci cB
      csm co csm co ci cA axicn lnophmlem.1 hvmulcli ci ci cB csm co axicn ci
      cB axicn lnophmlem.2 hvmulcli hvmulcli hvsubvali c1 cneg ci ci cB csm co
      csm co csm co cB ci cA csm co cva c1 cneg ci ci cmul co cB csm co csm co
      c1 cneg ci ci cB csm co csm co csm co cB ci ci cmul co cB csm co ci ci cB
      csm co csm co c1 cneg csm ci ci cB axicn axicn lnophmlem.2 hvmulassi
      opreq2i c1 cneg ci ci cmul co cmul co cB csm co c1 cB csm co c1 cneg ci
      ci cmul co cB csm co csm co cB c1 cneg ci ci cmul co cmul co c1 cB csm c1
      cneg ci ci cmul co cmul co c1 cneg c1 cneg cmul co c1 c1 cmul co c1 ci ci
      cmul co c1 cneg c1 cneg cmul ixi opreq2i c1 c1 ax1cn ax1cn mul2negi c1
      ax1cn mulid1i 3eqtri opreq1i c1 cneg ci ci cmul co cB c1 ax1cn negcli ci
      ci axicn axicn mulcli lnophmlem.2 hvmulassi cB chil wcel c1 cB csm co cB
      wceq lnophmlem.2 cB ax-hvmulid ax-mp 3eqtr3i eqtr3i opreq2i eqtri ci cA
      csm co cB ci cA axicn lnophmlem.1 hvmulcli lnophmlem.2 hvcomi 3eqtri
      fveq2i ci cc wcel cA ci cB csm co cmv co chil wcel ci cA ci cB csm co cmv
      co csm co cT cfv ci cA ci cB csm co cmv co cT cfv csm co wceq axicn cA ci
      cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvsubcli ci cA ci
      cB csm co cmv co cT lnophmlem.3 lnopmuli mp2an ci cc wcel cB chil wcel cA
      chil wcel cB ci cA csm co cva co cT cfv cB cT cfv ci cA cT cfv csm co cva
      co wceq axicn lnophmlem.2 lnophmlem.1 ci cB cA cT lnophmlem.3 lnopaddmuli
      mp3an 3eqtr3i opreq12i ci cA ci cB csm co cmv co csm co ci cA ci cB csm
      co cmv co cT cfv csm co csp co ci ci ccj cfv cmul co cA ci cB csm co cmv
      co cA ci cB csm co cmv co cT cfv csp co cmul co c1 cA ci cB csm co cmv co
      cA ci cB csm co cmv co cT cfv csp co cmul co cA ci cB csm co cmv co cA ci
      cB csm co cmv co cT cfv csp co ci ci cA ci cB csm co cmv co cA ci cB csm
      co cmv co cT cfv axicn axicn cA ci cB csm co lnophmlem.1 ci cB axicn
      lnophmlem.2 hvmulcli hvsubcli cA ci cB csm co cmv co chil wcel cA ci cB
      csm co cmv co cT cfv chil wcel cA ci cB csm co lnophmlem.1 ci cB axicn
      lnophmlem.2 hvmulcli hvsubcli chil chil cA ci cB csm co cmv co cT cT
      lnophmlem.3 lnopfi ffvelrni ax-mp his35i ci ci ccj cfv cmul co c1 cA ci
      cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cmul ci ci ccj cfv
      cmul co ci ci cneg cmul co ci ci cmul co cneg c1 ci ccj cfv ci cneg ci
      cmul cji opreq2i ci ci axicn axicn mulneg2i ci ci cmul co cneg c1 cneg
      cneg c1 ci ci cmul co c1 cneg ixi negeqi c1 ax1cn negnegi eqtri 3eqtri
      opreq1i cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci
      cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co vx cA ci cB csm co
      cmv co cA cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli
      hvsubcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 recni mulid2i
      3eqtri eqtr3i cB ci cA csm co cmv co cB cT cfv ci cA cT cfv csm co cmv co
      csp co ci cA csm co cB cmv co ci cA cT cfv csm co cB cT cfv cmv co csp co
      ci cA ci cB csm co cva co csm co ci cA ci cB csm co cva co cT cfv csm co
      csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cB ci
      cA csm co cB cT cfv ci cA cT cfv csm co lnophmlem.2 ci cA axicn
      lnophmlem.1 hvmulcli cB chil wcel cB cT cfv chil wcel lnophmlem.2 chil
      chil cB cT cT lnophmlem.3 lnopfi ffvelrni ax-mp ci cA cT cfv axicn cA
      chil wcel cA cT cfv chil wcel lnophmlem.1 chil chil cA cT cT lnophmlem.3
      lnopfi ffvelrni ax-mp hvmulcli hisubcomi ci cA ci cB csm co cva co csm co
      ci cA csm co cB cmv co ci cA ci cB csm co cva co cT cfv csm co ci cA cT
      cfv csm co cB cT cfv cmv co csp ci cA csm co ci ci cB csm co csm co cva
      co ci cA csm co c1 cneg cB csm co cva co ci cA ci cB csm co cva co csm co
      ci cA csm co cB cmv co ci ci cB csm co csm co c1 cneg cB csm co ci cA csm
      co cva ci ci cmul co cB csm co ci ci cB csm co csm co c1 cneg cB csm co
      ci ci cB axicn axicn lnophmlem.2 hvmulassi ci ci cmul co c1 cneg cB csm
      ixi opreq1i eqtr3i opreq2i ci cA ci cB csm co axicn lnophmlem.1 ci cB
      axicn lnophmlem.2 hvmulcli hvdistr1i ci cA csm co cB ci cA axicn
      lnophmlem.1 hvmulcli lnophmlem.2 hvsubvali 3eqtr4i ci cA ci cB csm co cva
      co csm co cT cfv ci cA csm co cB cmv co cT cfv ci cA ci cB csm co cva co
      cT cfv csm co ci cA cT cfv csm co cB cT cfv cmv co ci cA ci cB csm co cva
      co csm co ci cA csm co cB cmv co cT ci cA csm co ci ci cB csm co csm co
      cva co ci cA csm co c1 cneg cB csm co cva co ci cA ci cB csm co cva co
      csm co ci cA csm co cB cmv co ci ci cB csm co csm co c1 cneg cB csm co ci
      cA csm co cva ci ci cmul co cB csm co ci ci cB csm co csm co c1 cneg cB
      csm co ci ci cB axicn axicn lnophmlem.2 hvmulassi ci ci cmul co c1 cneg
      cB csm ixi opreq1i eqtr3i opreq2i ci cA ci cB csm co axicn lnophmlem.1 ci
      cB axicn lnophmlem.2 hvmulcli hvdistr1i ci cA csm co cB ci cA axicn
      lnophmlem.1 hvmulcli lnophmlem.2 hvsubvali 3eqtr4i fveq2i ci cc wcel cA
      ci cB csm co cva co chil wcel ci cA ci cB csm co cva co csm co cT cfv ci
      cA ci cB csm co cva co cT cfv csm co wceq axicn cA ci cB csm co
      lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvaddcli ci cA ci cB csm co
      cva co cT lnophmlem.3 lnopmuli mp2an ci cc wcel cA chil wcel cB chil wcel
      ci cA csm co cB cmv co cT cfv ci cA cT cfv csm co cB cT cfv cmv co wceq
      axicn lnophmlem.1 lnophmlem.2 ci cA cB cT lnophmlem.3 lnopmulsubi mp3an
      3eqtr3i opreq12i ci cA ci cB csm co cva co csm co ci cA ci cB csm co cva
      co cT cfv csm co csp co ci ci ccj cfv cmul co cA ci cB csm co cva co cA
      ci cB csm co cva co cT cfv csp co cmul co c1 cA ci cB csm co cva co cA ci
      cB csm co cva co cT cfv csp co cmul co cA ci cB csm co cva co cA ci cB
      csm co cva co cT cfv csp co ci ci cA ci cB csm co cva co cA ci cB csm co
      cva co cT cfv axicn axicn cA ci cB csm co lnophmlem.1 ci cB axicn
      lnophmlem.2 hvmulcli hvaddcli cA ci cB csm co cva co chil wcel cA ci cB
      csm co cva co cT cfv chil wcel cA ci cB csm co lnophmlem.1 ci cB axicn
      lnophmlem.2 hvmulcli hvaddcli chil chil cA ci cB csm co cva co cT cT
      lnophmlem.3 lnopfi ffvelrni ax-mp his35i ci ci ccj cfv cmul co c1 cA ci
      cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmul ci ci ccj cfv
      cmul co ci ci cneg cmul co ci ci cmul co cneg c1 ci ccj cfv ci cneg ci
      cmul cji opreq2i ci ci axicn axicn mulneg2i ci ci cmul co cneg c1 cneg
      cneg c1 ci ci cmul co c1 cneg ixi negeqi c1 ax1cn negnegi eqtri 3eqtri
      opreq1i cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cA ci
      cB csm co cva co cA ci cB csm co cva co cT cfv csp co vx cA ci cB csm co
      cva co cA cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli
      hvaddcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 recni mulid2i
      3eqtri 3eqtr2i opreq12i opreq2i opreq12i opreq1i eqtri fveq2i c4 cc0 wne
      cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv
      csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv
      csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin
      co cmul co caddc co c4 cdiv co ccj cfv cA cB cva co cA cB cva co cT cfv
      csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB csm co
      cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co cA ci
      cB csm co cva co cT cfv csp co cmin co cmul co caddc co ccj cfv c4 ccj
      cfv cdiv co wceq c4 4re 4pos gt0ne0ii cA cB cva co cA cB cva co cT cfv
      csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB csm co
      cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co cA ci
      cB csm co cva co cT cfv csp co cmin co cmul co caddc co c4 cA cB cva co
      cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin
      co ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci
      cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin co cmul co cA
      cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp
      co cmin co cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv
      co cT cfv csp co vx cA cB cva co cA cT cA cB lnophmlem.1 lnophmlem.2
      hvaddcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 vx cA cB cmv co
      cA cT cA cB lnophmlem.1 lnophmlem.2 hvsubcli lnophmlem.1 lnophmlem.3
      lnophmlem.4 lnophmlem1 resubcli recni ci cA ci cB csm co cmv co cA ci cB
      csm co cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co
      cT cfv csp co cmin co axicn cA ci cB csm co cmv co cA ci cB csm co cmv co
      cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co
      cmin co cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci
      cB csm co cva co cA ci cB csm co cva co cT cfv csp co vx cA ci cB csm co
      cmv co cA cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli
      hvsubcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 vx cA ci cB csm
      co cva co cA cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2
      hvmulcli hvaddcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 resubcli
      recni mulcli addcli c4 4re recni cjdivi ax-mp cA cB cva co cA cB cva co
      cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB
      csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co
      cA ci cB csm co cva co cT cfv csp co cmin co cmul co caddc co ccj cfv cA
      cB cva co cA cT cfv cB cT cfv cva co csp co cA cB cmv co cA cT cfv cB cT
      cfv cmv co csp co cmin co ci cA ci cB csm co cva co cA cT cfv ci cB cT
      cfv csm co cva co csp co cA ci cB csm co cmv co cA cT cfv ci cB cT cfv
      csm co cmv co csp co cmin co cmul co caddc co c4 ccj cfv c4 cdiv cA cB
      cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co
      cmin co ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA
      ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin co cmul co
      cneg caddc co cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB
      cmv co cT cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co
      cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv
      csp co cmin co cmul co cmin co cA cB cva co cA cT cfv cB cT cfv cva co
      csp co cA cB cmv co cA cT cfv cB cT cfv cmv co csp co cmin co ci cA ci cB
      csm co cva co cA cT cfv ci cB cT cfv csm co cva co csp co cA ci cB csm co
      cmv co cA cT cfv ci cB cT cfv csm co cmv co csp co cmin co cmul co caddc
      co cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT
      cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT
      cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co
      cmin co cmul co caddc co ccj cfv cA cB cva co cA cB cva co cT cfv csp co
      cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB csm co cmv co
      cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm
      co cva co cT cfv csp co cmin co cmul co cA cB cva co cA cB cva co cT cfv
      csp co cA cB cmv co cA cB cmv co cT cfv csp co cmin co cA cB cva co cA cB
      cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co vx cA cB cva
      co cA cT cA cB lnophmlem.1 lnophmlem.2 hvaddcli lnophmlem.1 lnophmlem.3
      lnophmlem.4 lnophmlem1 vx cA cB cmv co cA cT cA cB lnophmlem.1
      lnophmlem.2 hvsubcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1
      resubcli recni ci cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv
      csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin
      co axicn cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA
      ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin co cA ci cB
      csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co
      cA ci cB csm co cva co cT cfv csp co vx cA ci cB csm co cmv co cA cT cA
      ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvsubcli
      lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 vx cA ci cB csm co cva co
      cB cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli
      hvaddcli lnophmlem.2 lnophmlem.3 lnophmlem.4 lnophmlem1 resubcli recni
      mulcli negsubi cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB
      cmv co cT cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co
      cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv
      csp co cmin co cmul co cneg caddc co cA cB cva co cA cB cva co cT cfv csp
      co cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB csm co cva
      co cA ci cB csm co cva co cT cfv csp co cA ci cB csm co cmv co cA ci cB
      csm co cmv co cT cfv csp co cmin co cmul co caddc co cA cB cva co cA cT
      cfv cB cT cfv cva co csp co cA cB cmv co cA cT cfv cB cT cfv cmv co csp
      co cmin co ci cA ci cB csm co cva co cA cT cfv ci cB cT cfv csm co cva co
      csp co cA ci cB csm co cmv co cA cT cfv ci cB cT cfv csm co cmv co csp co
      cmin co cmul co caddc co ci cA ci cB csm co cmv co cA ci cB csm co cmv co
      cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co
      cmin co cmul co cneg ci cA ci cB csm co cva co cA ci cB csm co cva co cT
      cfv csp co cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co
      cmin co cmul co cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA
      cB cmv co cT cfv csp co cmin co caddc ci cA ci cB csm co cmv co cA ci cB
      csm co cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co
      cT cfv csp co cmin co cneg cmul co ci cA ci cB csm co cmv co cA ci cB csm
      co cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT
      cfv csp co cmin co cmul co cneg ci cA ci cB csm co cva co cA ci cB csm co
      cva co cT cfv csp co cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv
      csp co cmin co cmul co ci cA ci cB csm co cmv co cA ci cB csm co cmv co
      cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co
      cmin co axicn cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co
      cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin co cA ci
      cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva
      co cA ci cB csm co cva co cT cfv csp co vx cA ci cB csm co cmv co cA cT
      cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvsubcli
      lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 vx cA ci cB csm co cva co
      cA cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli
      hvaddcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 resubcli recni
      mulneg2i cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA
      ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin co cneg cA
      ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cA ci cB csm co
      cmv co cA ci cB csm co cmv co cT cfv csp co cmin co ci cmul cA ci cB csm
      co cmv co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co cA
      ci cB csm co cva co cT cfv csp co cA ci cB csm co cmv co cA ci cB csm co
      cmv co cT cfv csp co vx cA ci cB csm co cmv co cA cT cA ci cB csm co
      lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvsubcli lnophmlem.1
      lnophmlem.3 lnophmlem.4 lnophmlem1 recni cA ci cB csm co cva co cA ci cB
      csm co cva co cT cfv csp co vx cA ci cB csm co cva co cA cT cA ci cB csm
      co lnophmlem.1 ci cB axicn lnophmlem.2 hvmulcli hvaddcli lnophmlem.1
      lnophmlem.3 lnophmlem.4 lnophmlem1 recni negsubdi2i opreq2i eqtr3i
      opreq2i cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co
      cT cfv csp co cmin co cA cB cva co cA cT cfv cB cT cfv cva co csp co cA
      cB cmv co cA cT cfv cB cT cfv cmv co csp co cmin co ci cA ci cB csm co
      cva co cA ci cB csm co cva co cT cfv csp co cA ci cB csm co cmv co cA ci
      cB csm co cmv co cT cfv csp co cmin co cmul co ci cA ci cB csm co cva co
      cA cT cfv ci cB cT cfv csm co cva co csp co cA ci cB csm co cmv co cA cT
      cfv ci cB cT cfv csm co cmv co csp co cmin co cmul co caddc cA cB cva co
      cA cB cva co cT cfv csp co cA cB cva co cA cT cfv cB cT cfv cva co csp co
      cA cB cmv co cA cB cmv co cT cfv csp co cA cB cmv co cA cT cfv cB cT cfv
      cmv co csp co cmin cA cB cva co cT cfv cA cT cfv cB cT cfv cva co cA cB
      cva co csp cA chil wcel cB chil wcel cA cB cva co cT cfv cA cT cfv cB cT
      cfv cva co wceq lnophmlem.1 lnophmlem.2 cA cB cT lnophmlem.3 lnopaddi
      mp2an opreq2i cA cB cmv co cT cfv cA cT cfv cB cT cfv cmv co cA cB cmv co
      csp cA chil wcel cB chil wcel cA cB cmv co cT cfv cA cT cfv cB cT cfv cmv
      co wceq lnophmlem.1 lnophmlem.2 cA cB cT lnophmlem.3 lnopsubi mp2an
      opreq2i opreq12i cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp
      co cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cmin co cA
      ci cB csm co cva co cA cT cfv ci cB cT cfv csm co cva co csp co cA ci cB
      csm co cmv co cA cT cfv ci cB cT cfv csm co cmv co csp co cmin co ci cmul
      cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cA ci cB csm
      co cva co cA cT cfv ci cB cT cfv csm co cva co csp co cA ci cB csm co cmv
      co cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cmv co cA cT cfv
      ci cB cT cfv csm co cmv co csp co cmin cA ci cB csm co cva co cT cfv cA
      cT cfv ci cB cT cfv csm co cva co cA ci cB csm co cva co csp ci cc wcel
      cA chil wcel cB chil wcel cA ci cB csm co cva co cT cfv cA cT cfv ci cB
      cT cfv csm co cva co wceq axicn lnophmlem.1 lnophmlem.2 ci cA cB cT
      lnophmlem.3 lnopaddmuli mp3an opreq2i cA ci cB csm co cmv co cT cfv cA cT
      cfv ci cB cT cfv csm co cmv co cA ci cB csm co cmv co csp ci cc wcel cA
      chil wcel cB chil wcel cA ci cB csm co cmv co cT cfv cA cT cfv ci cB cT
      cfv csm co cmv co wceq axicn lnophmlem.1 lnophmlem.2 ci cA cB cT
      lnophmlem.3 lnopsubmuli mp3an opreq2i opreq12i opreq2i opreq12i eqtr2i cA
      cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp
      co cmin co cr wcel cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv
      csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co cmin
      co cr wcel cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co cA cB cmv
      co cT cfv csp co cmin co ci cA ci cB csm co cmv co cA ci cB csm co cmv co
      cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co
      cmin co cmul co caddc co ccj cfv cA cB cva co cA cB cva co cT cfv csp co
      cA cB cmv co cA cB cmv co cT cfv csp co cmin co ci cA ci cB csm co cmv co
      cA ci cB csm co cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm
      co cva co cT cfv csp co cmin co cmul co cmin co wceq cA cB cva co cA cB
      cva co cT cfv csp co cA cB cmv co cA cB cmv co cT cfv csp co vx cA cB cva
      co cA cT cA cB lnophmlem.1 lnophmlem.2 hvaddcli lnophmlem.1 lnophmlem.3
      lnophmlem.4 lnophmlem1 vx cA cB cmv co cA cT cA cB lnophmlem.1
      lnophmlem.2 hvsubcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1
      resubcli cA ci cB csm co cmv co cA ci cB csm co cmv co cT cfv csp co cA
      ci cB csm co cva co cA ci cB csm co cva co cT cfv csp co vx cA ci cB csm
      co cmv co cA cT cA ci cB csm co lnophmlem.1 ci cB axicn lnophmlem.2
      hvmulcli hvsubcli lnophmlem.1 lnophmlem.3 lnophmlem.4 lnophmlem1 vx cA ci
      cB csm co cva co cA cT cA ci cB csm co lnophmlem.1 ci cB axicn
      lnophmlem.2 hvmulcli hvaddcli lnophmlem.1 lnophmlem.3 lnophmlem.4
      lnophmlem1 resubcli cA cB cva co cA cB cva co cT cfv csp co cA cB cmv co
      cA cB cmv co cT cfv csp co cmin co cA ci cB csm co cmv co cA ci cB csm co
      cmv co cT cfv csp co cA ci cB csm co cva co cA ci cB csm co cva co cT cfv
      csp co cmin co cjreim mp2an 3eqtr4ri c4 cr wcel c4 ccj cfv c4 wceq 4re c4
      cjre ax-mp opreq12i 3eqtrri cA cB cT cfv cB cA cT cfv lnophmlem.1 cB chil
      wcel cB cT cfv chil wcel lnophmlem.2 chil chil cB cT cT lnophmlem.3
      lnopfi ffvelrni ax-mp lnophmlem.2 cA chil wcel cA cT cfv chil wcel
      lnophmlem.1 chil chil cA cT cT lnophmlem.3 lnopfi ffvelrni ax-mp polid2i
      cA cT cfv cB cA chil wcel cA cT cfv chil wcel lnophmlem.1 chil chil cA cT
      cT lnophmlem.3 lnopfi ffvelrni ax-mp lnophmlem.2 his1i 3eqtr4i $.
      $( [24-Jan-2006] $) $( [24-Jan-2006] $)
  $}


  ${
    $d x y z T $.
    lnophm.1 $e |- T e. LinOp $.
    lnophm.2 $e |- A. x e. ~H ( x .ih ( T ` x ) ) e. RR $.
    $( A linear operator is Hermitian if ` x .ih ( T `` x ) ` takes only real
       values.  Remark in [ReedSimon] p. 195. $)
    lnophmi $p |- T e. HrmOp $=
      cT cho wcel chil chil cT wf vy cv vz cv cT cfv csp co vy cv cT cfv vz cv
      csp co wceq vz chil wral vy chil wral vy vz cT elhmop cT lnophm.1 lnopfi
      vy cv vz cv cT cfv csp co vy cv cT cfv vz cv csp co wceq vy vz chil vy cv
      chil wcel vz cv chil wcel vy cv vz cv cT cfv csp co vy cv cT cfv vz cv
      csp co wceq vy cv chil wcel vy cv c0v cif vz cv cT cfv csp co vy cv chil
      wcel vy cv c0v cif cT cfv vz cv csp co wceq vy cv chil wcel vy cv c0v cif
      vz cv chil wcel vz cv c0v cif cT cfv csp co vy cv chil wcel vy cv c0v cif
      cT cfv vz cv chil wcel vz cv c0v cif csp co wceq vy cv vz cv c0v c0v vy
      cv vy cv chil wcel vy cv c0v cif wceq vy cv vz cv cT cfv csp co vy cv
      chil wcel vy cv c0v cif vz cv cT cfv csp co vy cv cT cfv vz cv csp co vy
      cv chil wcel vy cv c0v cif cT cfv vz cv csp co vy cv vy cv chil wcel vy
      cv c0v cif vz cv cT cfv csp opreq1 vy cv vy cv chil wcel vy cv c0v cif
      wceq vy cv cT cfv vy cv chil wcel vy cv c0v cif cT cfv vz cv csp vy cv vy
      cv chil wcel vy cv c0v cif cT fveq2 opreq1d eqeq12d vz cv vz cv chil wcel
      vz cv c0v cif wceq vy cv chil wcel vy cv c0v cif vz cv cT cfv csp co vy
      cv chil wcel vy cv c0v cif vz cv chil wcel vz cv c0v cif cT cfv csp co vy
      cv chil wcel vy cv c0v cif cT cfv vz cv csp co vy cv chil wcel vy cv c0v
      cif cT cfv vz cv chil wcel vz cv c0v cif csp co vz cv vz cv chil wcel vz
      cv c0v cif wceq vz cv cT cfv vz cv chil wcel vz cv c0v cif cT cfv vy cv
      chil wcel vy cv c0v cif csp vz cv vz cv chil wcel vz cv c0v cif cT fveq2
      opreq2d vz cv vz cv chil wcel vz cv c0v cif vy cv chil wcel vy cv c0v cif
      cT cfv csp opreq2 eqeq12d vx vy cv chil wcel vy cv c0v cif vz cv chil
      wcel vz cv c0v cif cT vy cv c0v chil ax-hv0cl elimel vz cv c0v chil
      ax-hv0cl elimel lnophm.1 lnophm.2 lnophmlem2 dedth2h rgen2a mpbir2an $.
      $( [3-Jun-2006] $) $( [24-Jan-2006] $)
  $}

  ${
    $d x y A $.  $d x y T $.  $d x y U $.
    $( A linear operator is Hermitian if ` x .ih ( T `` x ) ` takes only real
       values.  Remark in [ReedSimon] p. 195. $)
    lnophm $p |- ( ( T e. LinOp /\ A. x e. ~H ( x .ih ( T ` x ) ) e. RR ) ->
                   T e. HrmOp ) $=
      cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cho wcel
      cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil
      cres cif cho wcel cT cid chil cres cT cT clo wcel vx cv vx cv cT cfv csp
      co cr wcel vx chil wral wa cT cid chil cres cif cho eleq1 vy cT clo wcel
      vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cT
      clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil
      cres cif clo wcel vy cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif cfv csp co cr wcel vy chil wral
      cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT clo wcel
      vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif
      clo wcel vy cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx
      chil wral wa cT cid chil cres cif cfv csp co cr wcel vy chil wral wa cid
      chil cres clo wcel vy cv vy cv cid chil cres cfv csp co cr wcel vy chil
      wral wa cT cid chil cres cT cT clo wcel vx cv vx cv cT cfv csp co cr wcel
      vx chil wral wa cT cid chil cres cif wceq cT clo wcel cT clo wcel vx cv
      vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif clo wcel
      vx cv vx cv cT cfv csp co cr wcel vx chil wral vy cv vy cv cT clo wcel vx
      cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv
      csp co cr wcel vy chil wral cT cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif clo eleq1 cT cT clo wcel vx cv
      vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif wceq vy
      cv vy cv cT cfv csp co cr wcel vy chil wral vy cv vy cv cT clo wcel vx cv
      vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv csp
      co cr wcel vy chil wral vx cv vx cv cT cfv csp co cr wcel vx chil wral cT
      cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil
      cres cif wceq vy cv vy cv cT cfv csp co cr wcel vy cv vy cv cT clo wcel
      vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif
      cfv csp co cr wcel vy chil cT cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif wceq vy cv vy cv cT cfv csp co
      vy cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif cfv csp co cr cT cT clo wcel vx cv vx cv cT cfv csp
      co cr wcel vx chil wral wa cT cid chil cres cif wceq vy cv cT cfv vy cv
      cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil
      cres cif cfv vy cv csp vy cv cT cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif fveq1 opreq2d eleq1d ralbidv vx
      cv vx cv cT cfv csp co cr wcel vy cv vy cv cT cfv csp co cr wcel vx vy
      chil vx cv vy cv wceq vx cv vx cv cT cfv csp co vy cv vy cv cT cfv csp co
      cr vx cv vy cv wceq vx cv vy cv vx cv cT cfv vy cv cT cfv csp vx cv vy cv
      wceq id vx cv vy cv cT fveq2 opreq12d eleq1d cbvralv syl5bb anbi12d cid
      chil cres cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif wceq cid chil cres clo wcel cT clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif clo wcel vy cv
      vy cv cid chil cres cfv csp co cr wcel vy chil wral vy cv vy cv cT clo
      wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres
      cif cfv csp co cr wcel vy chil wral cid chil cres cT clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif clo eleq1 cid
      chil cres cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif wceq vy cv vy cv cid chil cres cfv csp co cr wcel vy
      cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT
      cid chil cres cif cfv csp co cr wcel vy chil cid chil cres cT clo wcel vx
      cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif wceq
      vy cv vy cv cid chil cres cfv csp co vy cv vy cv cT clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv csp co cr
      cid chil cres cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral
      wa cT cid chil cres cif wceq vy cv cid chil cres cfv vy cv cT clo wcel vx
      cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv
      vy cv csp vy cv cid chil cres cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif fveq1 opreq2d eleq1d ralbidv
      anbi12d cid chil cres clo wcel vy cv vy cv cid chil cres cfv csp co cr
      wcel vy chil wral idlnop vy cv vy cv cid chil cres cfv csp co cr wcel vy
      chil vy cv chil wcel vy cv vy cv cid chil cres cfv csp co vy cv vy cv csp
      co cr vy cv chil wcel vy cv cid chil cres cfv vy cv vy cv csp chil vy cv
      fvresi opreq2d vy cv hiidrcl eqeltrd rgen pm3.2i elimhyp pm3.26i cT clo
      wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres
      cif clo wcel vy cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx
      chil wral wa cT cid chil cres cif cfv csp co cr wcel vy chil wral cT clo
      wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT clo wcel vx cv
      vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif clo wcel
      vy cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif cfv csp co cr wcel vy chil wral wa cid chil cres clo
      wcel vy cv vy cv cid chil cres cfv csp co cr wcel vy chil wral wa cT cid
      chil cres cT cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral
      wa cT cid chil cres cif wceq cT clo wcel cT clo wcel vx cv vx cv cT cfv
      csp co cr wcel vx chil wral wa cT cid chil cres cif clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral vy cv vy cv cT clo wcel vx cv vx cv cT
      cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv csp co cr
      wcel vy chil wral cT cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx
      chil wral wa cT cid chil cres cif clo eleq1 cT cT clo wcel vx cv vx cv cT
      cfv csp co cr wcel vx chil wral wa cT cid chil cres cif wceq vy cv vy cv
      cT cfv csp co cr wcel vy chil wral vy cv vy cv cT clo wcel vx cv vx cv cT
      cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv csp co cr
      wcel vy chil wral vx cv vx cv cT cfv csp co cr wcel vx chil wral cT cT
      clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil
      cres cif wceq vy cv vy cv cT cfv csp co cr wcel vy cv vy cv cT clo wcel
      vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif
      cfv csp co cr wcel vy chil cT cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif wceq vy cv vy cv cT cfv csp co
      vy cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif cfv csp co cr cT cT clo wcel vx cv vx cv cT cfv csp
      co cr wcel vx chil wral wa cT cid chil cres cif wceq vy cv cT cfv vy cv
      cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil
      cres cif cfv vy cv csp vy cv cT cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif fveq1 opreq2d eleq1d ralbidv vx
      cv vx cv cT cfv csp co cr wcel vy cv vy cv cT cfv csp co cr wcel vx vy
      chil vx cv vy cv wceq vx cv vx cv cT cfv csp co vy cv vy cv cT cfv csp co
      cr vx cv vy cv wceq vx cv vy cv vx cv cT cfv vy cv cT cfv csp vx cv vy cv
      wceq id vx cv vy cv cT fveq2 opreq12d eleq1d cbvralv syl5bb anbi12d cid
      chil cres cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif wceq cid chil cres clo wcel cT clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif clo wcel vy cv
      vy cv cid chil cres cfv csp co cr wcel vy chil wral vy cv vy cv cT clo
      wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres
      cif cfv csp co cr wcel vy chil wral cid chil cres cT clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif clo eleq1 cid
      chil cres cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa
      cT cid chil cres cif wceq vy cv vy cv cid chil cres cfv csp co cr wcel vy
      cv vy cv cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral wa cT
      cid chil cres cif cfv csp co cr wcel vy chil cid chil cres cT clo wcel vx
      cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif wceq
      vy cv vy cv cid chil cres cfv csp co vy cv vy cv cT clo wcel vx cv vx cv
      cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv csp co cr
      cid chil cres cT clo wcel vx cv vx cv cT cfv csp co cr wcel vx chil wral
      wa cT cid chil cres cif wceq vy cv cid chil cres cfv vy cv cT clo wcel vx
      cv vx cv cT cfv csp co cr wcel vx chil wral wa cT cid chil cres cif cfv
      vy cv csp vy cv cid chil cres cT clo wcel vx cv vx cv cT cfv csp co cr
      wcel vx chil wral wa cT cid chil cres cif fveq1 opreq2d eleq1d ralbidv
      anbi12d cid chil cres clo wcel vy cv vy cv cid chil cres cfv csp co cr
      wcel vy chil wral idlnop vy cv vy cv cid chil cres cfv csp co cr wcel vy
      chil vy cv chil wcel vy cv vy cv cid chil cres cfv csp co vy cv vy cv csp
      co cr vy cv chil wcel vy cv cid chil cres cfv vy cv vy cv csp chil vy cv
      fvresi opreq2d vy cv hiidrcl eqeltrd rgen pm3.2i elimhyp pm3.27i lnophmi
      dedth $.
      $( [31-Oct-2006] $) $( [24-Jan-2006] $)

    $( The sum of two Hermitian operators is Hermitian. $)
    hmops $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T +op U ) e. HrmOp ) $=
      cT cho wcel cU cho wcel wa chil chil cT cU chos co wf vx cv vy cv cT cU
      chos co cfv csp co vx cv cT cU chos co cfv vy cv csp co wceq vy chil wral
      vx chil wral wa cT cU chos co cho wcel cT cho wcel cU cho wcel wa chil
      chil cT cU chos co wf vx cv vy cv cT cU chos co cfv csp co vx cv cT cU
      chos co cfv vy cv csp co wceq vy chil wral vx chil wral chil chil cT wf
      chil chil cU wf chil chil cT cU chos co wf cT cho wcel cU cho wcel cT cU
      hoaddcl cT hmopf cU hmopf syl2an cT cho wcel cU cho wcel wa vx cv vy cv
      cT cU chos co cfv csp co vx cv cT cU chos co cfv vy cv csp co wceq vx vy
      chil chil cT cho wcel cU cho wcel wa vx cv chil wcel vy cv chil wcel wa
      vx cv vy cv cT cU chos co cfv csp co vx cv cT cU chos co cfv vy cv csp co
      wceq cT cho wcel cU cho wcel wa vx cv chil wcel vy cv chil wcel wa wa vx
      cv vy cv cT cfv csp co vx cv vy cv cU cfv csp co caddc co vx cv cT cfv vy
      cv csp co vx cv cU cfv vy cv csp co caddc co vx cv vy cv cT cU chos co
      cfv csp co vx cv cT cU chos co cfv vy cv csp co cT cho wcel cU cho wcel
      vx cv chil wcel vy cv chil wcel wa vx cv vy cv cT cfv csp co vx cv vy cv
      cU cfv csp co caddc co vx cv cT cfv vy cv csp co vx cv cU cfv vy cv csp
      co caddc co wceq cT cho wcel vx cv chil wcel vy cv chil wcel wa wa cU cho
      wcel vx cv chil wcel vy cv chil wcel wa wa vx cv vy cv cT cfv csp co vx
      cv cT cfv vy cv csp co vx cv vy cv cU cfv csp co vx cv cU cfv vy cv csp
      co caddc cT cho wcel vx cv chil wcel vy cv chil wcel vx cv vy cv cT cfv
      csp co vx cv cT cfv vy cv csp co wceq vx cv vy cv cT hmop 3expb cU cho
      wcel vx cv chil wcel vy cv chil wcel vx cv vy cv cU cfv csp co vx cv cU
      cfv vy cv csp co wceq vx cv vy cv cU hmop 3expb opreqan12d anandirs chil
      chil cT wf chil chil cU wf wa vx cv chil wcel vy cv chil wcel wa vx cv vy
      cv cT cU chos co cfv csp co vx cv vy cv cT cfv csp co vx cv vy cv cU cfv
      csp co caddc co wceq cT cho wcel cU cho wcel wa chil chil cT wf chil chil
      cU wf wa vx cv chil wcel vy cv chil wcel wa wa vx cv vy cv cT cU chos co
      cfv csp co vx cv vy cv cT cfv vy cv cU cfv cva co csp co vx cv vy cv cT
      cfv csp co vx cv vy cv cU cfv csp co caddc co chil chil cT wf chil chil
      cU wf wa vy cv chil wcel vx cv vy cv cT cU chos co cfv csp co vx cv vy cv
      cT cfv vy cv cU cfv cva co csp co wceq vx cv chil wcel chil chil cT wf
      chil chil cU wf wa vy cv chil wcel wa vy cv cT cU chos co cfv vy cv cT
      cfv vy cv cU cfv cva co vx cv csp vy cv cT cU hosvalOLD opreq2d adantrl
      vx cv chil wcel vy cv cT cfv chil wcel vy cv cU cfv chil wcel vx cv vy cv
      cT cfv vy cv cU cfv cva co csp co vx cv vy cv cT cfv csp co vx cv vy cv
      cU cfv csp co caddc co wceq chil chil cT wf chil chil cU wf wa vx cv chil
      wcel vy cv chil wcel wa wa vx cv vy cv cT cfv vy cv cU cfv his7 chil chil
      cT wf chil chil cU wf wa vx cv chil wcel vy cv chil wcel simprl chil chil
      cT wf vy cv chil wcel vy cv cT cfv chil wcel chil chil cU wf vx cv chil
      wcel chil chil vy cv cT ffvelrn ad2ant2rl chil chil cU wf vy cv chil wcel
      vy cv cU cfv chil wcel chil chil cT wf vx cv chil wcel chil chil vy cv cU
      ffvelrn ad2ant2l syl3anc eqtrd cT cho wcel chil chil cT wf cU cho wcel
      chil chil cU wf cT hmopf cU hmopf anim12i sylan chil chil cT wf chil chil
      cU wf wa vx cv chil wcel vy cv chil wcel wa vx cv cT cU chos co cfv vy cv
      csp co vx cv cT cfv vy cv csp co vx cv cU cfv vy cv csp co caddc co wceq
      cT cho wcel cU cho wcel wa chil chil cT wf chil chil cU wf wa vx cv chil
      wcel vy cv chil wcel wa wa vx cv cT cU chos co cfv vy cv csp co vx cv cT
      cfv vx cv cU cfv cva co vy cv csp co vx cv cT cfv vy cv csp co vx cv cU
      cfv vy cv csp co caddc co chil chil cT wf chil chil cU wf wa vx cv chil
      wcel vx cv cT cU chos co cfv vy cv csp co vx cv cT cfv vx cv cU cfv cva
      co vy cv csp co wceq vy cv chil wcel chil chil cT wf chil chil cU wf wa
      vx cv chil wcel wa vx cv cT cU chos co cfv vx cv cT cfv vx cv cU cfv cva
      co vy cv csp vx cv cT cU hosvalOLD opreq1d adantrr vx cv cT cfv chil wcel
      vx cv cU cfv chil wcel vy cv chil wcel vx cv cT cfv vx cv cU cfv cva co
      vy cv csp co vx cv cT cfv vy cv csp co vx cv cU cfv vy cv csp co caddc co
      wceq chil chil cT wf chil chil cU wf wa vx cv chil wcel vy cv chil wcel
      wa wa vx cv cT cfv vx cv cU cfv vy cv ax-his2 chil chil cT wf vx cv chil
      wcel vx cv cT cfv chil wcel chil chil cU wf vy cv chil wcel chil chil vx
      cv cT ffvelrn ad2ant2r chil chil cU wf vx cv chil wcel vx cv cU cfv chil
      wcel chil chil cT wf vy cv chil wcel chil chil vx cv cU ffvelrn ad2ant2lr
      chil chil cT wf chil chil cU wf wa vx cv chil wcel vy cv chil wcel simprr
      syl3anc eqtrd cT cho wcel chil chil cT wf cU cho wcel chil chil cU wf cT
      hmopf cU hmopf anim12i sylan 3eqtr4d ex r19.21aivv jca vx vy cT cU chos
      co elhmop sylibr $.
      $( [24-Jul-2006] $) $( [23-Jul-2006] $)

    $( The scalar product of a Hermitian operator with a real is Hermitian. $)
    hmopm $p |- ( ( A e. RR /\ T e. HrmOp ) -> ( A .op T ) e. HrmOp ) $=
      cA cr wcel cT cho wcel wa chil chil cA cT chot co wf vx cv vy cv cA cT
      chot co cfv csp co vx cv cA cT chot co cfv vy cv csp co wceq vy chil wral
      vx chil wral wa cA cT chot co cho wcel cA cr wcel cT cho wcel wa chil
      chil cA cT chot co wf vx cv vy cv cA cT chot co cfv csp co vx cv cA cT
      chot co cfv vy cv csp co wceq vy chil wral vx chil wral cA cc wcel chil
      chil cT wf chil chil cA cT chot co wf cA cr wcel cT cho wcel cA cT
      homulcl cA recn cT hmopf syl2an cA cr wcel cT cho wcel wa vx cv vy cv cA
      cT chot co cfv csp co vx cv cA cT chot co cfv vy cv csp co wceq vx vy
      chil chil cA cr wcel cT cho wcel wa vx cv chil wcel vy cv chil wcel wa vx
      cv vy cv cA cT chot co cfv csp co vx cv cA cT chot co cfv vy cv csp co
      wceq cA cr wcel cT cho wcel wa vx cv chil wcel vy cv chil wcel wa wa cA
      ccj cfv vx cv vy cv cT cfv csp co cmul co cA vx cv cT cfv vy cv csp co
      cmul co vx cv vy cv cA cT chot co cfv csp co vx cv cA cT chot co cfv vy
      cv csp co cA cr wcel cT cho wcel vx cv chil wcel vy cv chil wcel wa cA
      ccj cfv vx cv vy cv cT cfv csp co cmul co cA vx cv cT cfv vy cv csp co
      cmul co wceq cA cr wcel cT cho wcel vx cv chil wcel vy cv chil wcel wa wa
      cA ccj cfv cA vx cv vy cv cT cfv csp co vx cv cT cfv vy cv csp co cmul cA
      cjre cT cho wcel vx cv chil wcel vy cv chil wcel vx cv vy cv cT cfv csp
      co vx cv cT cfv vy cv csp co wceq vx cv vy cv cT hmop 3expb opreqan12d
      anassrs cA cc wcel chil chil cT wf wa vx cv chil wcel vy cv chil wcel wa
      vx cv vy cv cA cT chot co cfv csp co cA ccj cfv vx cv vy cv cT cfv csp co
      cmul co wceq cA cr wcel cT cho wcel wa cA cc wcel chil chil cT wf wa vx
      cv chil wcel vy cv chil wcel wa wa vx cv vy cv cA cT chot co cfv csp co
      vx cv cA vy cv cT cfv csm co csp co cA ccj cfv vx cv vy cv cT cfv csp co
      cmul co cA cc wcel chil chil cT wf wa vx cv chil wcel vy cv chil wcel wa
      wa vy cv cA cT chot co cfv cA vy cv cT cfv csm co vx cv csp cA cc wcel
      chil chil cT wf wa vy cv chil wcel vy cv cA cT chot co cfv cA vy cv cT
      cfv csm co wceq vx cv chil wcel cA cc wcel chil chil cT wf vy cv chil
      wcel vy cv cA cT chot co cfv cA vy cv cT cfv csm co wceq cA vy cv cT
      homval 3expa adantrl opreq2d cA cc wcel vx cv chil wcel vy cv cT cfv chil
      wcel vx cv cA vy cv cT cfv csm co csp co cA ccj cfv vx cv vy cv cT cfv
      csp co cmul co wceq cA cc wcel chil chil cT wf wa vx cv chil wcel vy cv
      chil wcel wa wa cA vx cv vy cv cT cfv his5 cA cc wcel chil chil cT wf vx
      cv chil wcel vy cv chil wcel wa simpll cA cc wcel chil chil cT wf wa vx
      cv chil wcel vy cv chil wcel simprl chil chil cT wf vy cv chil wcel vy cv
      cT cfv chil wcel cA cc wcel vx cv chil wcel chil chil vy cv cT ffvelrn
      ad2ant2l syl3anc eqtrd cA cr wcel cA cc wcel cT cho wcel chil chil cT wf
      cA recn cT hmopf anim12i sylan cA cc wcel chil chil cT wf wa vx cv chil
      wcel vy cv chil wcel wa vx cv cA cT chot co cfv vy cv csp co cA vx cv cT
      cfv vy cv csp co cmul co wceq cA cr wcel cT cho wcel wa cA cc wcel chil
      chil cT wf wa vx cv chil wcel vy cv chil wcel wa wa vx cv cA cT chot co
      cfv vy cv csp co cA vx cv cT cfv csm co vy cv csp co cA vx cv cT cfv vy
      cv csp co cmul co cA cc wcel chil chil cT wf wa vx cv chil wcel vy cv
      chil wcel wa wa vx cv cA cT chot co cfv cA vx cv cT cfv csm co vy cv csp
      cA cc wcel chil chil cT wf wa vx cv chil wcel vx cv cA cT chot co cfv cA
      vx cv cT cfv csm co wceq vy cv chil wcel cA cc wcel chil chil cT wf vx cv
      chil wcel vx cv cA cT chot co cfv cA vx cv cT cfv csm co wceq cA vx cv cT
      homval 3expa adantrr opreq1d cA cc wcel vx cv cT cfv chil wcel vy cv chil
      wcel cA vx cv cT cfv csm co vy cv csp co cA vx cv cT cfv vy cv csp co
      cmul co wceq cA cc wcel chil chil cT wf wa vx cv chil wcel vy cv chil
      wcel wa wa cA vx cv cT cfv vy cv ax-his3 cA cc wcel chil chil cT wf vx cv
      chil wcel vy cv chil wcel wa simpll chil chil cT wf vx cv chil wcel vx cv
      cT cfv chil wcel cA cc wcel vy cv chil wcel chil chil vx cv cT ffvelrn
      ad2ant2lr cA cc wcel chil chil cT wf wa vx cv chil wcel vy cv chil wcel
      simprr syl3anc eqtrd cA cr wcel cA cc wcel cT cho wcel chil chil cT wf cA
      recn cT hmopf anim12i sylan 3eqtr4d ex r19.21aivv jca vx vy cA cT chot co
      elhmop sylibr $.
      $( [31-Jul-2006] $) $( [23-Jul-2006] $)

    $( The difference of two Hermitian operators is Hermitian. $)
    hmopd $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T -op U ) e. HrmOp ) $=
      cT cho wcel cU cho wcel wa cT c1 cneg cU chot co chos co cT cU chod co
      cho chil chil cT wf chil chil cU wf cT c1 cneg cU chot co chos co cT cU
      chod co wceq cT cho wcel cU cho wcel cT cU honegsub cT hmopf cU hmopf
      syl2an cT cho wcel c1 cneg cU chot co cho wcel cT c1 cneg cU chot co chos
      co cho wcel cU cho wcel cT c1 cneg cU chot co hmops c1 cneg cr wcel cU
      cho wcel c1 cneg cU chot co cho wcel c1 1re renegcli c1 cneg cU hmopm
      mpan sylan2 eqeltrrd $.
      $( [5-Aug-2006] $) $( [23-Jul-2006] $)

    $( The composition of two commuting Hermitian operators is Hermitian. $)
    hmopco $p |- ( ( T e. HrmOp /\ U e. HrmOp /\ ( T o. U ) = ( U o. T ) ) ->
                   ( T o. U ) e. HrmOp ) $=
      cT cho wcel cU cho wcel cT cU ccom cU cT ccom wceq w3a chil chil cT cU
      ccom wf vx cv vy cv cT cU ccom cfv csp co vx cv cT cU ccom cfv vy cv csp
      co wceq vy chil wral vx chil wral wa cT cU ccom cho wcel cT cho wcel cU
      cho wcel cT cU ccom cU cT ccom wceq w3a chil chil cT cU ccom wf vx cv vy
      cv cT cU ccom cfv csp co vx cv cT cU ccom cfv vy cv csp co wceq vy chil
      wral vx chil wral cT cho wcel cU cho wcel chil chil cT cU ccom wf cT cU
      ccom cU cT ccom wceq chil chil cT wf chil chil cU wf chil chil cT cU ccom
      wf cT cho wcel cU cho wcel chil chil chil cT cU fco cT hmopf cU hmopf
      syl2an 3adant3 cT cho wcel cU cho wcel cT cU ccom cU cT ccom wceq w3a vx
      cv vy cv cT cU ccom cfv csp co vx cv cT cU ccom cfv vy cv csp co wceq vx
      vy chil chil cT cho wcel cU cho wcel cT cU ccom cU cT ccom wceq w3a vx cv
      chil wcel vy cv chil wcel wa vx cv vy cv cT cU ccom cfv csp co vx cv cT
      cU ccom cfv vy cv csp co wceq cT cho wcel cU cho wcel cT cU ccom cU cT
      ccom wceq w3a vx cv chil wcel vy cv chil wcel wa wa vx cv vy cv cT cU
      ccom cfv csp co vx cv cU cT ccom cfv vy cv csp co vx cv cT cU ccom cfv vy
      cv csp co cT cho wcel cU cho wcel vx cv chil wcel vy cv chil wcel wa vx
      cv vy cv cT cU ccom cfv csp co vx cv cU cT ccom cfv vy cv csp co wceq cT
      cU ccom cU cT ccom wceq cT cho wcel cU cho wcel wa vx cv chil wcel vy cv
      chil wcel wa wa vx cv vy cv cT cU ccom cfv csp co vx cv cT cfv cU cfv vy
      cv csp co vx cv cU cT ccom cfv vy cv csp co cT cho wcel cU cho wcel wa vx
      cv chil wcel vy cv chil wcel wa wa vx cv vy cv cT cU ccom cfv csp co vx
      cv vy cv cU cfv cT cfv csp co vx cv cT cfv vy cv cU cfv csp co vx cv cT
      cfv cU cfv vy cv csp co cT cho wcel cU cho wcel wa vy cv chil wcel vx cv
      vy cv cT cU ccom cfv csp co vx cv vy cv cU cfv cT cfv csp co wceq vx cv
      chil wcel cT cho wcel cU cho wcel wa vy cv chil wcel wa vy cv cT cU ccom
      cfv vy cv cU cfv cT cfv vx cv csp cT cho wcel cU cho wcel vy cv chil wcel
      vy cv cT cU ccom cfv vy cv cU cfv cT cfv wceq cT wfun chil chil cU wf vy
      cv chil wcel vy cv cT cU ccom cfv vy cv cU cfv cT cfv wceq cT cho wcel cU
      cho wcel vy cv chil wcel chil chil vy cv cT cU fvco3 cT cho wcel chil
      chil cT wf cT wfun cT hmopf chil chil cT ffun syl cU hmopf vy cv chil
      wcel id syl3an 3expa opreq2d adantrl cT cho wcel vx cv chil wcel vy cv cU
      cfv chil wcel vx cv vy cv cU cfv cT cfv csp co vx cv cT cfv vy cv cU cfv
      csp co wceq cT cho wcel cU cho wcel wa vx cv chil wcel vy cv chil wcel wa
      wa vx cv vy cv cU cfv cT hmop cT cho wcel cU cho wcel vx cv chil wcel vy
      cv chil wcel wa simpll cT cho wcel cU cho wcel wa vx cv chil wcel vy cv
      chil wcel simprl cU cho wcel vy cv chil wcel vy cv cU cfv chil wcel cT
      cho wcel vx cv chil wcel chil chil cU wf vy cv chil wcel vy cv cU cfv
      chil wcel cU cho wcel chil chil vy cv cU ffvelrn cU hmopf sylan ad2ant2l
      syl3anc cU cho wcel vx cv cT cfv chil wcel vy cv chil wcel vx cv cT cfv
      vy cv cU cfv csp co vx cv cT cfv cU cfv vy cv csp co wceq cT cho wcel cU
      cho wcel wa vx cv chil wcel vy cv chil wcel wa wa vx cv cT cfv vy cv cU
      hmop cT cho wcel cU cho wcel vx cv chil wcel vy cv chil wcel wa simplr cT
      cho wcel vx cv chil wcel vx cv cT cfv chil wcel cU cho wcel vy cv chil
      wcel chil chil cT wf vx cv chil wcel vx cv cT cfv chil wcel cT cho wcel
      chil chil vx cv cT ffvelrn cT hmopf sylan ad2ant2r cT cho wcel cU cho
      wcel wa vx cv chil wcel vy cv chil wcel simprr syl3anc 3eqtrd cT cho wcel
      cU cho wcel wa vx cv chil wcel vx cv cU cT ccom cfv vy cv csp co vx cv cT
      cfv cU cfv vy cv csp co wceq vy cv chil wcel cT cho wcel cU cho wcel wa
      vx cv chil wcel wa vx cv cU cT ccom cfv vx cv cT cfv cU cfv vy cv csp cU
      cho wcel cT cho wcel vx cv chil wcel vx cv cU cT ccom cfv vx cv cT cfv cU
      cfv wceq cU cho wcel cT cho wcel vx cv chil wcel vx cv cU cT ccom cfv vx
      cv cT cfv cU cfv wceq cU wfun chil chil cT wf vx cv chil wcel vx cv cU cT
      ccom cfv vx cv cT cfv cU cfv wceq cU cho wcel cT cho wcel vx cv chil wcel
      chil chil vx cv cU cT fvco3 cU cho wcel chil chil cU wf cU wfun cU hmopf
      chil chil cU ffun syl cT hmopf vx cv chil wcel id syl3an 3expa ancom1s
      opreq1d adantrr eqtr4d 3adantl3 cT cho wcel cU cho wcel cT cU ccom cU cT
      ccom wceq w3a vx cv cT cU ccom cfv vy cv csp co vx cv cU cT ccom cfv vy
      cv csp co wceq vx cv chil wcel vy cv chil wcel wa cT cU ccom cU cT ccom
      wceq cT cho wcel vx cv cT cU ccom cfv vy cv csp co vx cv cU cT ccom cfv
      vy cv csp co wceq cU cho wcel cT cU ccom cU cT ccom wceq vx cv cT cU ccom
      cfv vx cv cU cT ccom cfv vy cv csp vx cv cT cU ccom cU cT ccom fveq1
      opreq1d 3ad2ant3 adantr eqtr4d ex r19.21aivv jca vx vy cT cU ccom elhmop
      sylibr $.
      $( [6-Sep-2006] $) $( [22-Aug-2006] $)
  $}

  ${
    nmbdoplb.1 $e |- T e. BndLinOp $.
    $( A lower bound for the norm of a bounded linear operator. $)
    nmbdoplbi $p |- ( A e. ~H ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
      cA chil wcel cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co cle wbr c0v
      cT cfv cno cfv cT cnop cfv c0v cno cfv cmul co cle wbr cA c0v cA c0v wceq
      cA cT cfv cno cfv c0v cT cfv cno cfv cT cnop cfv cA cno cfv cmul co cT
      cnop cfv c0v cno cfv cmul co cle cA c0v wceq cA cT cfv c0v cT cfv cno cA
      c0v cT fveq2 fveq2d cA c0v wceq cA cno cfv c0v cno cfv cT cnop cfv cmul
      cA c0v cno fveq2 opreq2d breq12d cA chil wcel cA c0v wne wa cA cT cfv cno
      cfv cA cno cfv cdiv co cT cnop cfv cle wbr cA cT cfv cno cfv cT cnop cfv
      cA cno cfv cmul co cle wbr cA chil wcel cA c0v wne wa cA cT cfv cno cfv
      cA cno cfv cdiv co c1 cA cno cfv cdiv co cA csm co cT cfv cno cfv cT cnop
      cfv cle cA chil wcel cA c0v wne wa cA cT cfv cno cfv cA cno cfv cdiv co
      c1 cA cno cfv cdiv co cA cT cfv cno cfv cmul co c1 cA cno cfv cdiv co cA
      csm co cT cfv cno cfv cA cT cfv cno cfv cc wcel cA cno cfv cc wcel cA cno
      cfv cc0 wne cA cT cfv cno cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA
      cT cfv cno cfv cmul co wceq cA chil wcel cA c0v wne wa cA cT cfv cno cfv
      cA cno cfv divrec2 cA chil wcel cA c0v wne wa cA cT cfv cno cfv cA chil
      wcel cA cT cfv cno cfv cr wcel cA c0v wne cA chil wcel cA cT cfv chil
      wcel cA cT cfv cno cfv cr wcel chil chil cA cT cT cT cbo wcel cT clo wcel
      nmbdoplb.1 cT bdopln ax-mp lnopfi ffvelrni cA cT cfv normcl syl adantr
      recnd cA chil wcel cA c0v wne wa cA cno cfv cA chil wcel cA cno cfv cr
      wcel cA c0v wne cA normcl adantr recnd cA chil wcel cA cno cfv cc0 wne cA
      c0v wne cA normne0 biimpar syl3anc cA chil wcel cA c0v wne wa c1 cA cno
      cfv cdiv co cA csm co cT cfv cno cfv c1 cA cno cfv cdiv co cA cT cfv csm
      co cno cfv c1 cA cno cfv cdiv co cabs cfv cA cT cfv cno cfv cmul co c1 cA
      cno cfv cdiv co cA cT cfv cno cfv cmul co cA chil wcel cA c0v wne wa c1
      cA cno cfv cdiv co cA csm co cT cfv c1 cA cno cfv cdiv co cA cT cfv csm
      co cno c1 cA cno cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co
      cA csm co cT cfv c1 cA cno cfv cdiv co cA cT cfv csm co wceq cA chil wcel
      cA c0v wne wa c1 cA cno cfv cdiv co cA cT cT cbo wcel cT clo wcel
      nmbdoplb.1 cT bdopln ax-mp lnopmuli cA chil wcel cA c0v wne wa c1 cA cno
      cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co
      cr wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno
      cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne
      cA c0v wne cA normne0 biimpar sylanc recnd cA chil wcel cA c0v wne pm3.26
      sylanc fveq2d c1 cA cno cfv cdiv co cc wcel cA cT cfv chil wcel c1 cA cno
      cfv cdiv co cA cT cfv csm co cno cfv c1 cA cno cfv cdiv co cabs cfv cA cT
      cfv cno cfv cmul co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co
      cA cT cfv norm-iii cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA
      cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil
      wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA
      c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA
      normne0 biimpar sylanc recnd cA chil wcel cA cT cfv chil wcel cA c0v wne
      chil chil cA cT cT cT cbo wcel cT clo wcel nmbdoplb.1 cT bdopln ax-mp
      lnopfi ffvelrni adantr sylanc cA chil wcel cA c0v wne wa c1 cA cno cfv
      cdiv co cabs cfv c1 cA cno cfv cdiv co cA cT cfv cno cfv cmul c1 cA cno
      cfv cdiv co cr wcel cc0 c1 cA cno cfv cdiv co cle wbr c1 cA cno cfv cdiv
      co cabs cfv c1 cA cno cfv cdiv co wceq cA chil wcel cA c0v wne wa c1 cA
      cno cfv cdiv co absid cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv
      cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil
      wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno
      cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc c1 cA cno cfv cdiv co cr
      wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr
      cA chil wcel cA c0v wne wa cc0 cr wcel c1 cA cno cfv cdiv co cr wcel cc0
      c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr wi 0re
      cc0 c1 cA cno cfv cdiv co ltle mpan cA cno cfv cr wcel cA cno cfv cc0 wne
      c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv
      rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA
      chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA cno
      cfv cr wcel cc0 cA cno cfv clt wbr cc0 c1 cA cno cfv cdiv co clt wbr cA
      chil wcel cA c0v wne wa cA cno cfv recgt0 cA chil wcel cA cno cfv cr wcel
      cA c0v wne cA normcl adantr cA chil wcel cA c0v wne cc0 cA cno cfv clt
      wbr cA normgt0 biimpa sylanc sylc sylanc opreq1d 3eqtrrd eqtrd c1 cA cno
      cfv cdiv co cA csm co chil wcel c1 cA cno cfv cdiv co cA csm co cno cfv
      c1 cle wbr c1 cA cno cfv cdiv co cA csm co cT cfv cno cfv cT cnop cfv cle
      wbr cA chil wcel cA c0v wne wa chil chil cT wf c1 cA cno cfv cdiv co cA
      csm co chil wcel c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr c1 cA
      cno cfv cdiv co cA csm co cT cfv cno cfv cT cnop cfv cle wbr cT cT cbo
      wcel cT clo wcel nmbdoplb.1 cT bdopln ax-mp lnopfi c1 cA cno cfv cdiv co
      cA csm co cT nmoplb mp3an1 c1 cA cno cfv cdiv co cc wcel cA chil wcel c1
      cA cno cfv cdiv co cA csm co chil wcel cA chil wcel cA c0v wne wa c1 cA
      cno cfv cdiv co cA hvmulcl cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv
      co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA
      chil wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr
      wcel cA c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v
      wne cA normne0 biimpar sylanc recnd cA chil wcel cA c0v wne pm3.26 sylanc
      c1 cA cno cfv cdiv co cA csm co cno cfv cr wcel c1 cA cno cfv cdiv co cA
      csm co cno cfv c1 wceq c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr
      cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co cno cfv c1
      eqle cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co chil wcel
      c1 cA cno cfv cdiv co cA csm co cno cfv cr wcel c1 cA cno cfv cdiv co cc
      wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co chil wcel cA chil wcel
      cA c0v wne wa c1 cA cno cfv cdiv co cA hvmulcl cA chil wcel cA c0v wne wa
      c1 cA cno cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv
      cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil
      wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno
      cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc recnd cA chil wcel cA
      c0v wne pm3.26 sylanc c1 cA cno cfv cdiv co cA csm co normcl syl cA norm1
      sylanc sylanc eqbrtrd cA cT cfv cno cfv cr wcel cA cno cfv cr wcel cT
      cnop cfv cr wcel w3a cc0 cA cno cfv clt wbr cA cT cfv cno cfv cA cno cfv
      cdiv co cT cnop cfv cle wbr cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul
      co cle wbr wb cA chil wcel cA c0v wne wa cA cT cfv cno cfv cA cno cfv cT
      cnop cfv ledivmul2OLD cA chil wcel cA c0v wne wa cA cT cfv cno cfv cr
      wcel cA cno cfv cr wcel cT cnop cfv cr wcel cA chil wcel cA cT cfv cno
      cfv cr wcel cA c0v wne cA chil wcel cA cT cfv chil wcel cA cT cfv cno cfv
      cr wcel chil chil cA cT cT cT cbo wcel cT clo wcel nmbdoplb.1 cT bdopln
      ax-mp lnopfi ffvelrni cA cT cfv normcl syl adantr cA chil wcel cA cno cfv
      cr wcel cA c0v wne cA normcl adantr cT cnop cfv cr wcel cA chil wcel cA
      c0v wne wa cT cbo wcel cT cnop cfv cr wcel nmbdoplb.1 cT nmopre ax-mp a1i
      3jca cA chil wcel cA c0v wne cc0 cA cno cfv clt wbr cA normgt0 biimpa
      sylanc mpbid c0v cT cfv cno cfv cT cnop cfv c0v cno cfv cmul co cle wbr
      cA chil wcel cc0 cc0 c0v cT cfv cno cfv cT cnop cfv c0v cno cfv cmul co
      cle cc0 0re leidi c0v cT cfv cno cfv c0v cno cfv cc0 c0v cT cfv c0v cno
      cT cT cbo wcel cT clo wcel nmbdoplb.1 cT bdopln ax-mp lnop0i fveq2i norm0
      eqtri cT cnop cfv c0v cno cfv cmul co cT cnop cfv cc0 cmul co cc0 c0v cno
      cfv cc0 cT cnop cfv cmul norm0 opreq2i cT cnop cfv cT cnop cfv cT cbo
      wcel cT cnop cfv cr wcel nmbdoplb.1 cT nmopre ax-mp recni mul01i eqtri
      3brtr4i a1i pm2.61ne $.
      $( [11-Apr-2006] $) $( [14-Feb-2006] $)
  $}

  $( A lower bound for the norm of a bounded linear Hilbert space operator. $)
  nmbdoplb $p |- ( ( T e. BndLinOp /\ A e. ~H ) ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
    cT cbo wcel cA chil wcel cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co
    cle wbr cT cbo wcel cA chil wcel cA cT cfv cno cfv cT cnop cfv cA cno cfv
    cmul co cle wbr wi cA chil wcel cA cT cbo wcel cT ch0o cif cfv cno cfv cT
    cbo wcel cT ch0o cif cnop cfv cA cno cfv cmul co cle wbr wi cT ch0o cT cT
    cbo wcel cT ch0o cif wceq cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co
    cle wbr cA cT cbo wcel cT ch0o cif cfv cno cfv cT cbo wcel cT ch0o cif cnop
    cfv cA cno cfv cmul co cle wbr cA chil wcel cT cT cbo wcel cT ch0o cif wceq
    cA cT cfv cno cfv cA cT cbo wcel cT ch0o cif cfv cno cfv cT cnop cfv cA cno
    cfv cmul co cT cbo wcel cT ch0o cif cnop cfv cA cno cfv cmul co cle cT cT
    cbo wcel cT ch0o cif wceq cA cT cfv cA cT cbo wcel cT ch0o cif cfv cno cA
    cT cT cbo wcel cT ch0o cif fveq1 fveq2d cT cT cbo wcel cT ch0o cif wceq cT
    cnop cfv cT cbo wcel cT ch0o cif cnop cfv cA cno cfv cmul cT cT cbo wcel cT
    ch0o cif cnop fveq2 opreq1d breq12d imbi2d cA cT cbo wcel cT ch0o cif cT
    ch0o cbo 0bdop elimel nmbdoplbi dedth imp $.
    $( [12-Apr-2006] $) $( [18-Feb-2006] $)

  ${
    $d k x M $.  $d k x y z T $.  $d n x y z T $.
    nmcopex.1 $e |- T e. LinOp $.
    nmcopex.2 $e |- T e. ConOp $.
    $( Lemma for ~ nmcopexi (Theorem 3.5(i) of [Beran] p. 99).  A sufficient
       condition for the norm of an operator to be real, based on its
       definition and the properties of supremum.  Compared to Beran, we use a
       direct proof instead of a proof by contradiction. $)
    nmcopexlem1 $p |- ( ( n e. NN /\ A. x e. ~H ( ( normh ` x ) <_ 1 ->
                  -. n < ( normh ` ( T ` x ) ) ) ) -> ( normop ` T ) e. RR ) $=
      vn cv cn wcel vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr
      wn wi vx chil wral wa cT cnop cfv cpnf wne cT cnop cfv cr wcel vn cv cn
      wcel vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wn wi vx
      chil wral cT cnop cfv cpnf wne vn cv cn wcel vx cv cno cfv c1 cle wbr vn
      cv vx cv cT cfv cno cfv clt wbr wn wi vx chil wral cT cnop cfv cpnf vn cv
      cn wcel cT cnop cfv cpnf wceq vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv
      cno cfv clt wbr wa vx chil wrex vx cv cno cfv c1 cle wbr vn cv vx cv cT
      cfv cno cfv clt wbr wn wi vx chil wral wn vn cv cn wcel cT cnop cfv cpnf
      wceq vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wa vx
      chil wrex vn cv cn wcel cT cnop cfv cpnf wceq wa vn cv vy cv clt wbr vy
      vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex
      vz cab wrex vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr
      wa vx chil wrex vn cv cr wcel vn cv vy cv clt wbr vy vx cv cno cfv c1 cle
      wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab wrex vn cr
      wral vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv
      cno cfv wceq wa vx chil wrex vz cab wrex vn cv cn wcel cT cnop cfv cpnf
      wceq vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv
      cno cfv wceq wa vx chil wrex vz cab wrex vn cr wral vn cv cr wcel vn cv
      vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq
      wa vx chil wrex vz cab wrex vn cv vy cv clt wbr vy vx cv cno cfv c1 cle
      wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab wrex vn cr ra4
      impcom vn cv nnre cT cnop cfv cpnf wceq vn cv vy cv clt wbr vy vx cv cno
      cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab
      wrex vn cr wral vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq
      wa vx chil wrex vz cab cxr wss cT cnop cfv cpnf wceq vn cv vy cv clt wbr
      vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil
      wrex vz cab wrex vn cr wral wb vx cv cno cfv c1 cle wbr vz cv vx cv cT
      cfv cno cfv wceq wa vx chil wrex vz cab cr cxr chil chil cT wf vx cv cno
      cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab cr
      wss cT nmcopex.1 lnopfi vz vx cT nmopsetretHIL ax-mp ressxr sstri vx cv
      cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab
      cxr wss vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT
      cfv cno cfv wceq wa vx chil wrex vz cab wrex vn cr wral vx cv cno cfv c1
      cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab cxr clt
      csup cpnf wceq cT cnop cfv cpnf wceq vn vy vx cv cno cfv c1 cle wbr vz cv
      vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab supxrunb2 cT cnop cfv vx
      cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz
      cab cxr clt csup cpnf chil chil cT wf cT cnop cfv vx cv cno cfv c1 cle
      wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz cab cxr clt csup
      wceq cT nmcopex.1 lnopfi vz vx cT nmopval ax-mp eqeq1i syl6rbbr ax-mp
      biimpi syl2an vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr
      wa vx chil wrex vy cv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv
      wceq wa vx chil wrex vz cab wcel vn cv vy cv clt wbr wa vy wex vn cv vy
      cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa
      vx chil wrex vz cab wrex vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno
      cfv wceq wa vn cv vy cv clt wbr wa vy wex vx chil wrex vx cv cno cfv c1
      cle wbr vy cv vx cv cT cfv cno cfv wceq wa vn cv vy cv clt wbr wa vx chil
      wrex vy wex vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr
      wa vx chil wrex vy cv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv
      wceq wa vx chil wrex vz cab wcel vn cv vy cv clt wbr wa vy wex vx cv cno
      cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq wa vn cv vy cv clt wbr wa
      vx vy chil rexcom4 vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv
      clt wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq wa vn
      cv vy cv clt wbr wa vy wex vx chil vx cv cno cfv c1 cle wbr vy cv vx cv
      cT cfv cno cfv wceq vn cv vy cv clt wbr wa wa vy wex vx cv cno cfv c1 cle
      wbr vy cv vx cv cT cfv cno cfv wceq vn cv vy cv clt wbr wa vy wex wa vx
      cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq wa vn cv vy cv clt
      wbr wa vy wex vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr
      wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq vn cv vy cv
      clt wbr wa vy 19.42v vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv
      wceq vn cv vy cv clt wbr wa wa vx cv cno cfv c1 cle wbr vy cv vx cv cT
      cfv cno cfv wceq wa vn cv vy cv clt wbr wa vy vx cv cno cfv c1 cle wbr vy
      cv vx cv cT cfv cno cfv wceq wa vn cv vy cv clt wbr wa vx cv cno cfv c1
      cle wbr vy cv vx cv cT cfv cno cfv wceq vn cv vy cv clt wbr wa wa vx cv
      cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq vn cv vy cv clt wbr
      anass bicomi exbii vy cv vx cv cT cfv cno cfv wceq vn cv vy cv clt wbr wa
      vy wex vn cv vx cv cT cfv cno cfv clt wbr vx cv cno cfv c1 cle wbr vn cv
      vy cv clt wbr vn cv vx cv cT cfv cno cfv clt wbr vy vx cv cT cfv cno cfv
      vx cv cT cfv cno fvex vy cv vx cv cT cfv cno cfv vn cv clt breq2 ceqsexv
      anbi2i 3bitr3ri rexbii vy cv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv
      cno cfv wceq wa vx chil wrex vz cab wcel vn cv vy cv clt wbr wa vx cv cno
      cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq wa vn cv vy cv clt wbr wa
      vx chil wrex vy vy cv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv
      wceq wa vx chil wrex vz cab wcel vn cv vy cv clt wbr wa vx cv cno cfv c1
      cle wbr vy cv vx cv cT cfv cno cfv wceq wa vx chil wrex vn cv vy cv clt
      wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq wa vn cv
      vy cv clt wbr wa vx chil wrex vy cv vx cv cno cfv c1 cle wbr vz cv vx cv
      cT cfv cno cfv wceq wa vx chil wrex vz cab wcel vx cv cno cfv c1 cle wbr
      vy cv vx cv cT cfv cno cfv wceq wa vx chil wrex vn cv vy cv clt wbr vx cv
      cno cfv c1 cle wbr vz cv vx cv cT cfv cno cfv wceq wa vx chil wrex vx cv
      cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq wa vx chil wrex vz vy
      cv vy visset vz cv vy cv wceq vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv
      cno cfv wceq wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cno cfv wceq
      wa vx chil vz cv vy cv wceq vz cv vx cv cT cfv cno cfv wceq vy cv vx cv
      cT cfv cno cfv wceq vx cv cno cfv c1 cle wbr vz cv vy cv vx cv cT cfv cno
      cfv eqeq1 anbi2d rexbidv elab anbi1i vx cv cno cfv c1 cle wbr vy cv vx cv
      cT cfv cno cfv wceq wa vn cv vy cv clt wbr vx chil r19.41v bitr4i exbii
      3bitr4i vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT
      cfv cno cfv wceq wa vx chil wrex vz cab df-rex bitr4i sylibr ex vx cv cno
      cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wa vx chil wrex vx cv
      cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wn wi wn vx chil
      wrex vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wn wi vx
      chil wral wn vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr
      wa vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wn wi wn
      vx chil vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr df-an
      rexbii vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cno cfv clt wbr wn wi
      vx chil rexnal bitri syl6ib necon2ad imp chil chil cT wf cT cnop cfv cr
      wcel cT cnop cfv cpnf wne wb cT nmcopex.1 lnopfi cT nmoprepnf ax-mp
      sylibr $.
      $( [3-Apr-2006] $) $( [5-Feb-2006] $)

    $( Lemma for ~ nmcopexi .  Apply definition of continuity.  Note that we
       use 1 instead of 0.5 that Beran uses for epsilon (e = 0.5 in his
       proof). $)
    nmcopexlem2 $p |- E. y e. RR ( 0 < y /\
            A. z e. ~H ( ( normh ` z ) < y -> ( normh ` ( T ` z ) ) < 1 ) ) $=
      cc0 vy cv clt wbr vz cv c0v cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v
      cT cfv cmv co cno cfv c1 clt wbr wi vz chil wral wa vy cr wrex cc0 vy cv
      clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz
      chil wral wa vy cr wrex cT cco wcel c0v chil wcel wa c1 cr wcel cc0 c1
      clt wbr wa cc0 vy cv clt wbr vz cv c0v cmv co cno cfv vy cv clt wbr vz cv
      cT cfv c0v cT cfv cmv co cno cfv c1 clt wbr wi vz chil wral wa vy cr wrex
      cT cco wcel c0v chil wcel nmcopex.2 ax-hv0cl pm3.2i c1 cr wcel cc0 c1 clt
      wbr 1re lt01 pm3.2i vy vz c0v c1 cT cnopc mp2an cc0 vy cv clt wbr vz cv
      c0v cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v cT cfv cmv co cno cfv
      c1 clt wbr wi vz chil wral wa cc0 vy cv clt wbr vz cv cno cfv vy cv clt
      wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral wa vy cr vz cv c0v
      cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v cT cfv cmv co cno cfv c1
      clt wbr wi vz chil wral vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv
      c1 clt wbr wi vz chil wral cc0 vy cv clt wbr vz cv c0v cmv co cno cfv vy
      cv clt wbr vz cv cT cfv c0v cT cfv cmv co cno cfv c1 clt wbr wi vz cv cno
      cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil vz cv chil
      wcel vz cv c0v cmv co cno cfv vy cv clt wbr vz cv cno cfv vy cv clt wbr
      vz cv cT cfv c0v cT cfv cmv co cno cfv c1 clt wbr vz cv cT cfv cno cfv c1
      clt wbr vz cv chil wcel vz cv c0v cmv co cno cfv vz cv cno cfv vy cv clt
      vz cv chil wcel vz cv c0v cmv co vz cv cno vz cv hvsub0 fveq2d breq1d vz
      cv chil wcel vz cv cT cfv c0v cT cfv cmv co cno cfv vz cv cT cfv cno cfv
      c1 clt vz cv chil wcel vz cv cT cfv c0v cT cfv cmv co vz cv cT cfv cno vz
      cv chil wcel vz cv cT cfv c0v cmv co vz cv cT cfv vz cv cT cfv c0v cT cfv
      cmv co vz cv chil wcel vz cv cT cfv chil wcel vz cv cT cfv c0v cmv co vz
      cv cT cfv wceq chil chil vz cv cT cT nmcopex.1 lnopfi ffvelrni vz cv cT
      cfv hvsub0 syl c0v cT cfv c0v vz cv cT cfv cmv cT nmcopex.1 lnop0i
      opreq2i syl5eq fveq2d breq1d imbi12d ralbiia anbi2i rexbii mpbi $.
      $( [4-Apr-2006] $) $( [2-Feb-2006] $)

    $( Lemma for ~ nmcopexi .  Move ` 1 / n ` out of the norm, using
       linearity. $)
    nmcopexlem3 $p |- ( ( n e. NN /\ x e. ~H ) -> ( ( normh `  ( T ` x ) ) < n
             <-> ( normh ` ( T ` ( ( 1 / n ) .h x ) ) ) < 1 ) ) $=
      vn cv cn wcel vx cv chil wcel wa vx cv cT cfv cno cfv vn cv clt wbr c1 vn
      cv cdiv co vx cv cT cfv cno cfv cmul co c1 vn cv cdiv co vn cv cmul co
      clt wbr c1 vn cv cdiv co vx cv csm co cT cfv cno cfv c1 clt wbr vx cv cT
      cfv cno cfv cr wcel vn cv cr wcel c1 vn cv cdiv co cr wcel w3a cc0 c1 vn
      cv cdiv co clt wbr vx cv cT cfv cno cfv vn cv clt wbr c1 vn cv cdiv co vx
      cv cT cfv cno cfv cmul co c1 vn cv cdiv co vn cv cmul co clt wbr wb vn cv
      cn wcel vx cv chil wcel wa vx cv cT cfv cno cfv vn cv c1 vn cv cdiv co
      ltmul2OLD vn cv cn wcel vx cv chil wcel wa vx cv cT cfv cno cfv cr wcel
      vn cv cr wcel c1 vn cv cdiv co cr wcel vx cv chil wcel vx cv cT cfv cno
      cfv cr wcel vn cv cn wcel vx cv chil wcel vx cv cT cfv chil wcel vx cv cT
      cfv cno cfv cr wcel chil chil vx cv cT cT nmcopex.1 lnopfi ffvelrni vx cv
      cT cfv normcl syl adantl vn cv cn wcel vn cv cr wcel vx cv chil wcel vn
      cv nnre adantr vn cv cn wcel c1 vn cv cdiv co cr wcel vx cv chil wcel vn
      cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
      rereccl vn cv nnre vn cv nnne0 sylanc adantr 3jca vn cv cn wcel cc0 c1 vn
      cv cdiv co clt wbr vx cv chil wcel vn cv nnrecgt0 adantr sylanc vn cv cn
      wcel vx cv chil wcel wa c1 vn cv cdiv co vx cv cT cfv cno cfv cmul co c1
      vn cv cdiv co vx cv csm co cT cfv cno cfv c1 vn cv cdiv co vn cv cmul co
      c1 clt vn cv cn wcel vx cv chil wcel wa c1 vn cv cdiv co vx cv csm co cT
      cfv cno cfv c1 vn cv cdiv co vx cv cT cfv csm co cno cfv c1 vn cv cdiv co
      cabs cfv vx cv cT cfv cno cfv cmul co c1 vn cv cdiv co vx cv cT cfv cno
      cfv cmul co vn cv cn wcel vx cv chil wcel wa c1 vn cv cdiv co vx cv csm
      co cT cfv c1 vn cv cdiv co vx cv cT cfv csm co cno c1 vn cv cdiv co cc
      wcel vx cv chil wcel c1 vn cv cdiv co vx cv csm co cT cfv c1 vn cv cdiv
      co vx cv cT cfv csm co wceq vn cv cn wcel c1 vn cv cdiv co vx cv cT
      nmcopex.1 lnopmuli vn cv cn wcel c1 vn cv cdiv co vn cv cr wcel vn cv cc0
      wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv
      nnne0 sylanc recnd sylan fveq2d c1 vn cv cdiv co cc wcel vx cv cT cfv
      chil wcel c1 vn cv cdiv co vx cv cT cfv csm co cno cfv c1 vn cv cdiv co
      cabs cfv vx cv cT cfv cno cfv cmul co wceq vn cv cn wcel vx cv chil wcel
      c1 vn cv cdiv co vx cv cT cfv norm-iii vn cv cn wcel c1 vn cv cdiv co vn
      cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
      rereccl vn cv nnre vn cv nnne0 sylanc recnd chil chil vx cv cT cT
      nmcopex.1 lnopfi ffvelrni syl2an vn cv cn wcel vx cv chil wcel wa c1 vn
      cv cdiv co cabs cfv c1 vn cv cdiv co vx cv cT cfv cno cfv cmul vn cv cn
      wcel c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co wceq vx cv chil wcel c1
      vn cv cdiv co cr wcel cc0 c1 vn cv cdiv co cle wbr c1 vn cv cdiv co cabs
      cfv c1 vn cv cdiv co wceq vn cv cn wcel c1 vn cv cdiv co absid vn cv cr
      wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv rereccl
      vn cv nnre vn cv nnne0 sylanc c1 vn cv cdiv co cr wcel cc0 c1 vn cv cdiv
      co clt wbr cc0 c1 vn cv cdiv co cle wbr vn cv cn wcel cc0 cr wcel c1 vn
      cv cdiv co cr wcel cc0 c1 vn cv cdiv co clt wbr cc0 c1 vn cv cdiv co cle
      wbr wi 0re cc0 c1 vn cv cdiv co ltle mpan vn cv cr wcel vn cv cc0 wne c1
      vn cv cdiv co cr wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0
      sylanc vn cv nnrecgt0 sylc sylanc adantr opreq1d 3eqtrrd vn cv cn wcel c1
      vn cv cdiv co vn cv cmul co c1 wceq vx cv chil wcel vn cv cc wcel vn cv
      cc0 wne c1 vn cv cdiv co vn cv cmul co c1 wceq vn cv cn wcel vn cv recid2
      vn cv nncn vn cv nnne0 sylanc adantr breq12d bitrd $.
      $( [4-Apr-2006] $) $( [5-Feb-2006] $)

    ${
      nmcopexlem4.3 $e |- A = { k e. NN | ( 1 / k ) < y } $.
      nmcopexlem4.4 $e |- M = sup ( A , RR , `' < ) $.
      $( Lemma for ~ nmcopexi .  Properties of the infimum of a collection of
         integers whose reciprocals are less than a real number ` y ` (which
         will later become the "epsilon" of the epsilon/delta continuity
         definition ~ df-cnop ).  Note that ` ``' < ` in the fourth hypothesis
         signifies infimum.  (This lemma involves only real numbers and is
         independent of Hilbert space.  The first two hypotheses aren't
         used.) $)
      nmcopexlem4 $p |- ( ( y e. RR /\ 0 < y ) ->
                        ( M e. NN /\ ( 1 / M ) < y ) ) $=
        vy cv cr wcel cc0 vy cv clt wbr wa cM c1 vk cv cdiv co vy cv clt wbr vk
        cn crab wcel cM cn wcel c1 cM cdiv co vy cv clt wbr wa vy cv cr wcel
        cc0 vy cv clt wbr wa cA cr clt ccnv csup c1 vk cv cdiv co vy cv clt wbr
        vk cn crab cM vy cv cr wcel cc0 vy cv clt wbr wa cA cr clt ccnv csup cA
        c1 vk cv cdiv co vy cv clt wbr vk cn crab vy cv cr wcel cc0 vy cv clt
        wbr wa cA c0 wne cA cr clt ccnv csup cA wcel vy cv cr wcel cc0 vy cv
        clt wbr wa c1 vk cv cdiv co vy cv clt wbr vk cn crab c0 wne cA c0 wne
        vy cv cr wcel cc0 vy cv clt wbr wa c1 vk cv cdiv co vy cv clt wbr vk cn
        wrex c1 vk cv cdiv co vy cv clt wbr vk cn crab c0 wne vy cv vk nnrecl
        c1 vk cv cdiv co vy cv clt wbr vk cn rabn0 sylibr cA c1 vk cv cdiv co
        vy cv clt wbr vk cn crab c0 nmcopexlem4.3 neeq1i sylibr cA c1 cuz cfv
        wss cA c0 wne cA cr clt ccnv csup cA wcel cA cn c1 cuz cfv cA c1 vk cv
        cdiv co vy cv clt wbr vk cn crab cn nmcopexlem4.3 c1 vk cv cdiv co vy
        cv clt wbr vk cn ssrab2 eqsstri nnuz sseqtri cA c1 infmssuzcl mpan syl
        nmcopexlem4.3 syl6eleq nmcopexlem4.4 syl5eqel c1 vk cv cdiv co vy cv
        clt wbr c1 cM cdiv co vy cv clt wbr vk cM cn vk cv cM wceq c1 vk cv
        cdiv co c1 cM cdiv co vy cv clt vk cv cM c1 cdiv opreq2 breq1d elrab
        sylib $.
        $( [3-Apr-2006] $) $( [2-Feb-2006] $)

      $( Lemma for ~ nmcopexi . $)
      nmcopexlem5 $p |- ( ( ( y e. RR /\ 0 < y ) /\ ( n e. NN /\ M <_ n ) /\
                        ( x e. ~H /\ ( normh ` x ) <_ 1 ) ) ->
                        ( normh ` ( ( 1 / n ) .h x ) ) < y ) $=
        vy cv cr wcel cc0 vy cv clt wbr wa vn cv cn wcel cM vn cv cle wbr wa vx
        cv chil wcel vx cv cno cfv c1 cle wbr wa w3a c1 vn cv cdiv co vx cv csm
        co cno cfv c1 cM cdiv co vy cv vn cv cn wcel cM vn cv cle wbr wa vx cv
        chil wcel vx cv cno cfv c1 cle wbr wa c1 vn cv cdiv co vx cv csm co cno
        cfv cr wcel vy cv cr wcel cc0 vy cv clt wbr wa vn cv cn wcel vx cv chil
        wcel c1 vn cv cdiv co vx cv csm co cno cfv cr wcel cM vn cv cle wbr vx
        cv cno cfv c1 cle wbr vn cv cn wcel vx cv chil wcel wa c1 vn cv cdiv co
        vx cv csm co chil wcel c1 vn cv cdiv co vx cv csm co cno cfv cr wcel c1
        vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv csm co
        chil wcel vn cv cn wcel c1 vn cv cdiv co vx cv hvmulcl vn cv cn wcel c1
        vn cv cdiv co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn
        cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd sylan c1
        vn cv cdiv co vx cv csm co normcl syl ad2ant2r 3adant1 vy cv cr wcel
        cc0 vy cv clt wbr wa vn cv cn wcel cM vn cv cle wbr wa c1 cM cdiv co cr
        wcel vx cv chil wcel vx cv cno cfv c1 cle wbr wa vy cv cr wcel cc0 vy
        cv clt wbr wa cM cn wcel c1 cM cdiv co cr wcel vy cv cr wcel cc0 vy cv
        clt wbr wa cM cn wcel c1 cM cdiv co vy cv clt wbr vy cA cT vk cM
        nmcopex.1 nmcopex.2 nmcopexlem4.3 nmcopexlem4.4 nmcopexlem4 pm3.26d cM
        cr wcel cM cc0 wne c1 cM cdiv co cr wcel cM cn wcel cM rereccl cM nnre
        cM nnne0 sylanc syl 3ad2ant1 vy cv cr wcel cc0 vy cv clt wbr wa vn cv
        cn wcel cM vn cv cle wbr wa vy cv cr wcel vx cv chil wcel vx cv cno cfv
        c1 cle wbr wa vy cv cr wcel cc0 vy cv clt wbr pm3.26 3ad2ant1 cM cn
        wcel vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1
        cle wbr wa c1 vn cv cdiv co vx cv csm co cno cfv c1 cM cdiv co cle wbr
        vy cv cr wcel cc0 vy cv clt wbr wa cM cn wcel vn cv cn wcel cM vn cv
        cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa w3a c1 vn cv
        cdiv co vx cv csm co cno cfv c1 vn cv cdiv co c1 cM cdiv co vn cv cn
        wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa c1
        vn cv cdiv co vx cv csm co cno cfv cr wcel cM cn wcel vn cv cn wcel vx
        cv chil wcel c1 vn cv cdiv co vx cv csm co cno cfv cr wcel cM vn cv cle
        wbr vx cv cno cfv c1 cle wbr vn cv cn wcel vx cv chil wcel wa c1 vn cv
        cdiv co vx cv csm co chil wcel c1 vn cv cdiv co vx cv csm co cno cfv cr
        wcel c1 vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv
        csm co chil wcel vn cv cn wcel c1 vn cv cdiv co vx cv hvmulcl vn cv cn
        wcel c1 vn cv cdiv co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr
        wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd
        sylan c1 vn cv cdiv co vx cv csm co normcl syl ad2ant2r 3adant1 vn cv
        cn wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa
        c1 vn cv cdiv co cr wcel cM cn wcel vn cv cn wcel c1 vn cv cdiv co cr
        wcel cM vn cv cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vn cv
        cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
        rereccl vn cv nnre vn cv nnne0 sylanc ad2antrr 3adant1 cM cn wcel vn cv
        cn wcel cM vn cv cle wbr wa c1 cM cdiv co cr wcel vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa cM cr wcel cM cc0 wne c1 cM cdiv co cr wcel cM cn
        wcel cM rereccl cM nnre cM nnne0 sylanc 3ad2ant1 cM cn wcel vn cv cn
        wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa
        w3a c1 vn cv cdiv co vx cv cno cfv cmul co c1 vn cv cdiv co c1 cmul co
        c1 vn cv cdiv co vx cv csm co cno cfv c1 vn cv cdiv co cle vx cv cno
        cfv cr wcel c1 cr wcel c1 vn cv cdiv co cr wcel w3a cc0 c1 vn cv cdiv
        co cle wbr vx cv cno cfv c1 cle wbr wa c1 vn cv cdiv co vx cv cno cfv
        cmul co c1 vn cv cdiv co c1 cmul co cle wbr cM cn wcel vn cv cn wcel cM
        vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa w3a vx cv
        cno cfv c1 c1 vn cv cdiv co lemul2aOLD cM cn wcel vn cv cn wcel cM vn
        cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa w3a vx cv cno
        cfv cr wcel c1 cr wcel c1 vn cv cdiv co cr wcel cM cn wcel vx cv chil
        wcel vx cv cno cfv c1 cle wbr wa vx cv cno cfv cr wcel vn cv cn wcel cM
        vn cv cle wbr wa vx cv chil wcel vx cv cno cfv cr wcel cM cn wcel vx cv
        cno cfv c1 cle wbr vx cv normcl ad2antrl 3adant2 c1 cr wcel cM cn wcel
        vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle
        wbr wa w3a 1re a1i vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel vx
        cv cno cfv c1 cle wbr wa c1 vn cv cdiv co cr wcel cM cn wcel vn cv cn
        wcel c1 vn cv cdiv co cr wcel cM vn cv cle wbr vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr
        wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc ad2antrr
        3adant1 3jca cM cn wcel vn cv cn wcel cM vn cv cle wbr wa vx cv chil
        wcel vx cv cno cfv c1 cle wbr wa w3a cc0 c1 vn cv cdiv co cle wbr vx cv
        cno cfv c1 cle wbr cM cn wcel vn cv cn wcel cM vn cv cle wbr wa cc0 c1
        vn cv cdiv co cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vn cv
        cn wcel cc0 c1 vn cv cdiv co cle wbr cM cn wcel cM vn cv cle wbr vn cv
        cr wcel cc0 vn cv clt wbr cc0 c1 vn cv cdiv co cle wbr vn cv cn wcel c1
        cr wcel cc0 c1 cle wbr vn cv cr wcel cc0 vn cv clt wbr wa cc0 c1 vn cv
        cdiv co cle wbr 1re cc0 c1 0re 1re lt01 ltleii c1 vn cv divge0 mpanl12
        vn cv nnre vn cv nngt0 sylanc ad2antrl 3adant3 vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa cM cn wcel vx cv cno cfv c1 cle wbr vn cv cn wcel
        cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr pm3.27
        3ad2ant3 jca sylanc vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel
        vx cv cno cfv c1 cle wbr wa c1 vn cv cdiv co vx cv cno cfv cmul co c1
        vn cv cdiv co vx cv csm co cno cfv wceq cM cn wcel vn cv cn wcel vx cv
        chil wcel c1 vn cv cdiv co vx cv cno cfv cmul co c1 vn cv cdiv co vx cv
        csm co cno cfv wceq cM vn cv cle wbr vx cv cno cfv c1 cle wbr vn cv cn
        wcel vx cv chil wcel wa c1 vn cv cdiv co vx cv csm co cno cfv c1 vn cv
        cdiv co cabs cfv vx cv cno cfv cmul co c1 vn cv cdiv co vx cv cno cfv
        cmul co c1 vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv
        csm co cno cfv c1 vn cv cdiv co cabs cfv vx cv cno cfv cmul co wceq vn
        cv cn wcel c1 vn cv cdiv co vx cv norm-iii vn cv cn wcel c1 vn cv cdiv
        co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel
        vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd sylan vn cv cn wcel
        vx cv chil wcel wa c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co vx cv cno
        cfv cmul vn cv cn wcel c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co wceq
        vx cv chil wcel c1 vn cv cdiv co cr wcel cc0 c1 vn cv cdiv co cle wbr
        c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co wceq vn cv cn wcel c1 vn cv
        cdiv co absid vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn
        cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc vn cv cr wcel
        cc0 vn cv clt wbr cc0 c1 vn cv cdiv co cle wbr vn cv cn wcel c1 cr wcel
        cc0 c1 cle wbr vn cv cr wcel cc0 vn cv clt wbr wa cc0 c1 vn cv cdiv co
        cle wbr 1re cc0 c1 0re 1re lt01 ltleii c1 vn cv divge0 mpanl12 vn cv
        nnre vn cv nngt0 sylanc sylanc adantr opreq1d eqtr2d ad2ant2r 3adant1
        cM cn wcel vn cv cn wcel cM vn cv cle wbr wa c1 vn cv cdiv co c1 cmul
        co c1 vn cv cdiv co wceq vx cv chil wcel vx cv cno cfv c1 cle wbr wa vn
        cv cn wcel c1 vn cv cdiv co c1 cmul co c1 vn cv cdiv co wceq cM cn wcel
        cM vn cv cle wbr vn cv cn wcel c1 vn cv cdiv co cc wcel c1 vn cv cdiv
        co c1 cmul co c1 vn cv cdiv co wceq vn cv cn wcel c1 vn cv cdiv co vn
        cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
        rereccl vn cv nnre vn cv nnne0 sylanc recnd c1 vn cv cdiv co ax1id syl
        ad2antrl 3adant3 3brtr3d cM cn wcel vn cv cn wcel cM vn cv cle wbr wa
        c1 vn cv cdiv co c1 cM cdiv co cle wbr vx cv chil wcel vx cv cno cfv c1
        cle wbr wa cM cn wcel vn cv cn wcel cM vn cv cle wbr c1 vn cv cdiv co
        c1 cM cdiv co cle wbr cM cn wcel vn cv cn wcel wa cM vn cv cle wbr c1
        vn cv cdiv co c1 cM cdiv co cle wbr cM cr wcel cc0 cM clt wbr wa vn cv
        cr wcel cc0 vn cv clt wbr wa cM vn cv cle wbr c1 vn cv cdiv co c1 cM
        cdiv co cle wbr wb cM cn wcel vn cv cn wcel cM vn cv lerec cM cn wcel
        cM cr wcel cc0 cM clt wbr cM nnre cM nngt0 jca vn cv cn wcel vn cv cr
        wcel cc0 vn cv clt wbr vn cv nnre vn cv nngt0 jca syl2an biimpa anasss
        3adant3 letrd vy cv cr wcel cc0 vy cv clt wbr wa cM cn wcel c1 cM cdiv
        co vy cv clt wbr vy cA cT vk cM nmcopex.1 nmcopex.2 nmcopexlem4.3
        nmcopexlem4.4 nmcopexlem4 pm3.26d syl3an1 vy cv cr wcel cc0 vy cv clt
        wbr wa vn cv cn wcel cM vn cv cle wbr wa c1 cM cdiv co vy cv clt wbr vx
        cv chil wcel vx cv cno cfv c1 cle wbr wa vy cv cr wcel cc0 vy cv clt
        wbr wa cM cn wcel c1 cM cdiv co vy cv clt wbr vy cA cT vk cM nmcopex.1
        nmcopex.2 nmcopexlem4.3 nmcopexlem4.4 nmcopexlem4 pm3.27d 3ad2ant1
        lelttrd $.
        $( [4-Apr-2006] $) $( [4-Feb-2006] $)

      $( Lemma for ~ nmcopexi .  Combine lemmas to obtain the result (with
         hypotheses to be eliminated). $)
      nmcopexlem6 $p |- ( normop ` T ) e. RR $=
        cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1
        clt wbr wi vz chil wral wa vy cr wrex cT cnop cfv cr wcel vy vz cT
        nmcopex.1 nmcopex.2 nmcopexlem2 cc0 vy cv clt wbr vz cv cno cfv vy cv
        clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral wa cT cnop cfv
        cr wcel vy cr vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt
        wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral wa cM cn wcel cT
        cnop cfv cr wcel vy cv cr wcel cc0 vy cv clt wbr cM cn wcel vz cv cno
        cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral vy cv
        cr wcel cc0 vy cv clt wbr cM cn wcel vy cv cr wcel cc0 vy cv clt wbr wa
        cM cn wcel c1 cM cdiv co vy cv clt wbr vy cA cT vk cM nmcopex.1
        nmcopex.2 nmcopexlem4.3 nmcopexlem4.4 nmcopexlem4 pm3.26d ex adantrd vy
        cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv
        cno cfv c1 clt wbr wi vz chil wral wa cM cn wcel cT cnop cfv cr wcel wi
        vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT
        cfv cno cfv c1 clt wbr wi vz chil wral wa wa cM vk cv cle wbr vk cn
        wrex cT cnop cfv cr wcel cM cn wcel vy cv cr wcel cc0 vy cv clt wbr vz
        cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil
        wral wa wa cM vk cv cle wbr cT cnop cfv cr wcel vk cn vy cv cr wcel cc0
        vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt
        wbr wi vz chil wral wa wa vk cv cn wcel cM vk cv cle wbr cT cnop cfv cr
        wcel vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv
        cT cfv cno cfv c1 clt wbr wi vz chil wral wa wa vk cv cn wcel cM vk cv
        cle wbr wa wa vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv cno cfv clt
        wbr wn wi vx chil wral cT cnop cfv cr wcel vy cv cr wcel cc0 vy cv clt
        wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz
        chil wral wa wa vk cv cn wcel cM vk cv cle wbr wa wa vx cv cno cfv c1
        cle wbr vk cv vx cv cT cfv cno cfv clt wbr wn wi vx chil vy cv cr wcel
        cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1
        clt wbr wi vz chil wral wa wa vk cv cn wcel cM vk cv cle wbr wa vx cv
        chil wcel vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv cno cfv clt wbr
        wn wi wi vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz
        cv cT cfv cno cfv c1 clt wbr wi vz chil wral vk cv cn wcel cM vk cv cle
        wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv cno
        cfv clt wbr wn wi wi wi vy cv cr wcel cc0 vy cv clt wbr wa vz cv cno
        cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral wa vk
        cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr
        vk cv vx cv cT cfv cno cfv clt wbr wn vy cv cr wcel cc0 vy cv clt wbr
        wa vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz
        chil wral vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno
        cfv c1 cle wbr wa wa vk cv vx cv cT cfv cno cfv clt wbr wn wi vy cv cr
        wcel cc0 vy cv clt wbr wa vk cv cn wcel cM vk cv cle wbr wa vx cv chil
        wcel vx cv cno cfv c1 cle wbr wa wa vz cv cno cfv vy cv clt wbr vz cv
        cT cfv cno cfv c1 clt wbr wi vz chil wral vk cv vx cv cT cfv cno cfv
        clt wbr wn vy cv cr wcel cc0 vy cv clt wbr wa vk cv cn wcel cM vk cv
        cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa wa vz cv cno cfv
        vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral vk cv vx
        cv cT cfv cno cfv clt wbr wn wi vy cv cr wcel cc0 vy cv clt wbr wa vk
        cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr
        wa wa wa vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi
        vz chil wral c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr vk cv
        vx cv cT cfv cno cfv clt wbr wn vy cv cr wcel cc0 vy cv clt wbr wa vk
        cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr
        wa c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr vx vy cA cT vk
        vk cM nmcopex.1 nmcopex.2 nmcopexlem4.3 nmcopexlem4.4 nmcopexlem5 3expb
        vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle
        wbr wa wa vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr
        wi vz chil wral c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr vk
        cv vx cv cT cfv cno cfv clt wbr wn wi wi vy cv cr wcel cc0 vy cv clt
        wbr wa vk cv cn wcel vx cv chil wcel vz cv cno cfv vy cv clt wbr vz cv
        cT cfv cno cfv c1 clt wbr wi vz chil wral c1 vk cv cdiv co vx cv csm co
        cno cfv vy cv clt wbr vk cv vx cv cT cfv cno cfv clt wbr wn wi wi cM vk
        cv cle wbr vx cv cno cfv c1 cle wbr vk cv cn wcel vx cv chil wcel wa vz
        cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil
        wral c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr c1 vk cv cdiv
        co vx cv csm co cT cfv cno cfv c1 clt wbr vk cv vx cv cT cfv cno cfv
        clt wbr wn vk cv cn wcel vx cv chil wcel wa c1 vk cv cdiv co vx cv csm
        co chil wcel vz cv cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt
        wbr wi vz chil wral c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr
        c1 vk cv cdiv co vx cv csm co cT cfv cno cfv c1 clt wbr wi wi c1 vk cv
        cdiv co cc wcel vx cv chil wcel c1 vk cv cdiv co vx cv csm co chil wcel
        vk cv cn wcel c1 vk cv cdiv co vx cv hvmulcl vk cv cn wcel c1 vk cv
        cdiv co vk cv cr wcel vk cv cc0 wne c1 vk cv cdiv co cr wcel vk cv cn
        wcel vk cv rereccl vk cv nnre vk cv nnne0 sylanc recnd sylan vz cv cno
        cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi c1 vk cv cdiv co
        vx cv csm co cno cfv vy cv clt wbr c1 vk cv cdiv co vx cv csm co cT cfv
        cno cfv c1 clt wbr wi vz c1 vk cv cdiv co vx cv csm co chil vz cv c1 vk
        cv cdiv co vx cv csm co wceq vz cv cno cfv vy cv clt wbr c1 vk cv cdiv
        co vx cv csm co cno cfv vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr
        c1 vk cv cdiv co vx cv csm co cT cfv cno cfv c1 clt wbr vz cv c1 vk cv
        cdiv co vx cv csm co wceq vz cv cno cfv c1 vk cv cdiv co vx cv csm co
        cno cfv vy cv clt vz cv c1 vk cv cdiv co vx cv csm co cno fveq2 breq1d
        vz cv c1 vk cv cdiv co vx cv csm co wceq vz cv cT cfv cno cfv c1 vk cv
        cdiv co vx cv csm co cT cfv cno cfv c1 clt vz cv c1 vk cv cdiv co vx cv
        csm co wceq vz cv cT cfv c1 vk cv cdiv co vx cv csm co cT cfv cno vz cv
        c1 vk cv cdiv co vx cv csm co cT fveq2 fveq2d breq1d imbi12d rcla4v syl
        vk cv cn wcel vx cv chil wcel wa c1 vk cv cdiv co vx cv csm co cT cfv
        cno cfv c1 clt wbr vx cv cT cfv cno cfv vk cv clt wbr vk cv vx cv cT
        cfv cno cfv clt wbr wn vx cT vk nmcopex.1 nmcopex.2 nmcopexlem3 vx cv
        chil wcel vk cv cn wcel vx cv cT cfv cno cfv vk cv clt wbr vk cv vx cv
        cT cfv cno cfv clt wbr wn wi vx cv cT cfv cno cfv cr wcel vk cv cr wcel
        vx cv cT cfv cno cfv vk cv clt wbr vk cv vx cv cT cfv cno cfv clt wbr
        wn wi vx cv chil wcel vk cv cn wcel vx cv cT cfv cno cfv vk cv ltnsym
        vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel
        chil chil vx cv cT cT nmcopex.1 lnopfi ffvelrni vx cv cT cfv normcl syl
        vk cv nnre syl2an ancoms sylbird syl6d ad2ant2r adantl mpid ex com23
        imp exp4d anasss imp r19.21aiv vk cv cn wcel cM vk cv cle wbr wa vx cv
        cno cfv c1 cle wbr vk cv vx cv cT cfv cno cfv clt wbr wn wi vx chil
        wral cT cnop cfv cr wcel vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv
        vy cv clt wbr vz cv cT cfv cno cfv c1 clt wbr wi vz chil wral wa wa vk
        cv cn wcel vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv cno cfv clt wbr
        wn wi vx chil wral cT cnop cfv cr wcel cM vk cv cle wbr vx cT vk
        nmcopex.1 nmcopex.2 nmcopexlem1 adantlr adantll mpdan exp32 r19.23adv
        cM cn wcel cM cM cle wbr cM vk cv cle wbr vk cn wrex cM cn wcel cM cr
        wcel cM cM cle wbr cM nnre cM leid syl cM vk cv cle wbr cM cM cle wbr
        vk cM cn vk cv cM cM cle breq2 rcla4ev mpdan syl5 ex mpdd r19.23aiv
        ax-mp $.
        $( [4-Apr-2006] $) $( [5-Feb-2006] $)
    $}

    $( The norm of a continuous linear Hilbert space operator exists.  Theorem
       3.5(i) of [Beran] p. 99. $)
    nmcopexi $p |- ( normop ` T ) e. RR $=
      vy c1 vk cv cdiv co vy cv clt wbr vk cn crab cT vk c1 vz cv cdiv co vy cv
      clt wbr vz cn crab cr clt ccnv csup nmcopex.1 nmcopex.2 c1 vk cv cdiv co
      vy cv clt wbr vk cn crab eqid c1 vz cv cdiv co vy cv clt wbr vz cn crab
      c1 vk cv cdiv co vy cv clt wbr vk cn crab wceq c1 vz cv cdiv co vy cv clt
      wbr vz cn crab cr clt ccnv csup c1 vk cv cdiv co vy cv clt wbr vk cn crab
      cr clt ccnv csup wceq c1 vz cv cdiv co vy cv clt wbr c1 vk cv cdiv co vy
      cv clt wbr vz vk cn vz cv vk cv wceq c1 vz cv cdiv co c1 vk cv cdiv co vy
      cv clt vz cv vk cv c1 cdiv opreq2 breq1d cbvrabv cr c1 vz cv cdiv co vy
      cv clt wbr vz cn crab c1 vk cv cdiv co vy cv clt wbr vk cn crab clt ccnv
      supeq1 ax-mp nmcopexlem6 $.
      $( [4-Apr-2006] $) $( [5-Feb-2006] $)

    $( A lower bound for the norm of a continuous linear operator.  Theorem
       3.5(ii) of [Beran] p. 99. $)
    nmcoplbi $p |- ( A e. ~H ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
      cA chil wcel cA c0v wceq cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co
      cle wbr cA c0v wceq cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co cle
      wbr cA chil wcel cA c0v wceq cA cT cfv cno cfv cc0 cT cnop cfv cA cno cfv
      cmul co cle cA c0v wceq cA cT cfv cno cfv c0v cno cfv cc0 cA c0v wceq cA
      cT cfv c0v cno cA c0v wceq cA cT cfv c0v cT cfv c0v cA c0v cT fveq2 cT
      nmcopex.1 lnop0i syl6eq fveq2d norm0 syl6eq cA c0v wceq cc0 cT cnop cfv
      cA cno cfv cmul co cc0 cle cA c0v wceq cT cnop cfv cA cno cfv cmul co cT
      cnop cfv cc0 cmul co cc0 cA c0v wceq cA cno cfv cc0 cT cnop cfv cmul cA
      c0v wceq cA cno cfv c0v cno cfv cc0 cA c0v cno fveq2 norm0 syl6eq opreq2d
      cT cnop cfv cT cnop cfv cT nmcopex.1 nmcopex.2 nmcopexi recni mul01i
      syl6req cc0 0re leidi syl5breq eqbrtrd adantl cA chil wcel cA c0v wceq wn
      wa cA cT cfv cno cfv cA cno cfv cdiv co cT cnop cfv cle wbr cA cT cfv cno
      cfv cT cnop cfv cA cno cfv cmul co cle wbr cA chil wcel cA c0v wceq wn wa
      cA cT cfv cno cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA csm co cT
      cfv cno cfv cT cnop cfv cle cA chil wcel cA c0v wceq wn wa cA cT cfv cno
      cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA cT cfv cno cfv cmul co c1
      cA cno cfv cdiv co cA csm co cT cfv cno cfv cA cT cfv cno cfv cc wcel cA
      cno cfv cc wcel cA cno cfv cc0 wne cA cT cfv cno cfv cA cno cfv cdiv co
      c1 cA cno cfv cdiv co cA cT cfv cno cfv cmul co wceq cA chil wcel cA c0v
      wceq wn wa cA cT cfv cno cfv cA cno cfv divrec2 cA chil wcel cA c0v wceq
      wn wa cA cT cfv cno cfv cA chil wcel cA cT cfv cno cfv cr wcel cA c0v
      wceq wn cA chil wcel cA cT cfv chil wcel cA cT cfv cno cfv cr wcel chil
      chil cA cT cT nmcopex.1 lnopfi ffvelrni cA cT cfv normcl syl adantr recnd
      cA chil wcel cA c0v wceq wn wa cA cno cfv cA chil wcel cA cno cfv cr wcel
      cA c0v wceq wn cA normcl adantr recnd cA chil wcel cA c0v wceq wn wa cA
      cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv cc0 wceq
      wn cA c0v wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq cA norm-i
      notbid biimpar cA cno cfv cc0 df-ne sylibr syl3anc cA chil wcel cA c0v
      wceq wn wa c1 cA cno cfv cdiv co cA csm co cT cfv cno cfv c1 cA cno cfv
      cdiv co cA cT cfv csm co cno cfv c1 cA cno cfv cdiv co cabs cfv cA cT cfv
      cno cfv cmul co c1 cA cno cfv cdiv co cA cT cfv cno cfv cmul co cA chil
      wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA csm co cT cfv c1 cA cno
      cfv cdiv co cA cT cfv csm co cno c1 cA cno cfv cdiv co cc wcel cA chil
      wcel c1 cA cno cfv cdiv co cA csm co cT cfv c1 cA cno cfv cdiv co cA cT
      cfv csm co wceq cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA
      cT nmcopex.1 lnopmuli cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv
      co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA
      chil wcel cA c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA cno cfv cr
      wcel cA c0v wceq wn cA normcl adantr cA chil wcel cA c0v wceq wn wa cA
      cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv cc0 wceq
      wn cA c0v wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq cA norm-i
      notbid biimpar cA cno cfv cc0 df-ne sylibr sylanc recnd cA chil wcel cA
      c0v wceq wn pm3.26 sylanc fveq2d c1 cA cno cfv cdiv co cc wcel cA cT cfv
      chil wcel c1 cA cno cfv cdiv co cA cT cfv csm co cno cfv c1 cA cno cfv
      cdiv co cabs cfv cA cT cfv cno cfv cmul co wceq cA chil wcel cA c0v wceq
      wn wa c1 cA cno cfv cdiv co cA cT cfv norm-iii cA chil wcel cA c0v wceq
      wn wa c1 cA cno cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA
      cno cfv cdiv co cr wcel cA chil wcel cA c0v wceq wn wa cA cno cfv rereccl
      cA chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl adantr cA chil
      wcel cA c0v wceq wn wa cA cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil
      wcel cA cno cfv cc0 wceq wn cA c0v wceq wn cA chil wcel cA cno cfv cc0
      wceq cA c0v wceq cA norm-i notbid biimpar cA cno cfv cc0 df-ne sylibr
      sylanc recnd cA chil wcel cA cT cfv chil wcel cA c0v wceq wn chil chil cA
      cT cT nmcopex.1 lnopfi ffvelrni adantr sylanc cA chil wcel cA c0v wceq wn
      wa c1 cA cno cfv cdiv co cabs cfv c1 cA cno cfv cdiv co cA cT cfv cno cfv
      cmul c1 cA cno cfv cdiv co cr wcel cc0 c1 cA cno cfv cdiv co cle wbr c1
      cA cno cfv cdiv co cabs cfv c1 cA cno cfv cdiv co wceq cA chil wcel cA
      c0v wceq wn wa c1 cA cno cfv cdiv co absid cA cno cfv cr wcel cA cno cfv
      cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wceq wn wa cA
      cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl
      adantr cA chil wcel cA c0v wceq wn wa cA cno cfv cc0 wceq wn cA cno cfv
      cc0 wne cA chil wcel cA cno cfv cc0 wceq wn cA c0v wceq wn cA chil wcel
      cA cno cfv cc0 wceq cA c0v wceq cA norm-i notbid biimpar cA cno cfv cc0
      df-ne sylibr sylanc c1 cA cno cfv cdiv co cr wcel cc0 c1 cA cno cfv cdiv
      co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr cA chil wcel cA c0v wceq wn
      wa cc0 cr wcel c1 cA cno cfv cdiv co cr wcel cc0 c1 cA cno cfv cdiv co
      clt wbr cc0 c1 cA cno cfv cdiv co cle wbr wi 0re cc0 c1 cA cno cfv cdiv
      co ltle mpan cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co
      cr wcel cA chil wcel cA c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA
      cno cfv cr wcel cA c0v wceq wn cA normcl adantr cA chil wcel cA c0v wceq
      wn wa cA cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv
      cc0 wceq wn cA c0v wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq
      cA norm-i notbid biimpar cA cno cfv cc0 df-ne sylibr sylanc cA cno cfv cr
      wcel cc0 cA cno cfv clt wbr cc0 c1 cA cno cfv cdiv co clt wbr cA chil
      wcel cA c0v wceq wn wa cA cno cfv recgt0 cA chil wcel cA cno cfv cr wcel
      cA c0v wceq wn cA normcl adantr cA chil wcel cA c0v wceq wn cc0 cA cno
      cfv clt wbr cA normgt0OLD biimpa sylanc sylc sylanc opreq1d 3eqtrrd eqtrd
      c1 cA cno cfv cdiv co cA csm co chil wcel c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 cle wbr c1 cA cno cfv cdiv co cA csm co cT cfv cno cfv cT cnop
      cfv cle wbr cA chil wcel cA c0v wceq wn wa chil chil cT wf c1 cA cno cfv
      cdiv co cA csm co chil wcel c1 cA cno cfv cdiv co cA csm co cno cfv c1
      cle wbr c1 cA cno cfv cdiv co cA csm co cT cfv cno cfv cT cnop cfv cle
      wbr cT nmcopex.1 lnopfi c1 cA cno cfv cdiv co cA csm co cT nmoplb mp3an1
      c1 cA cno cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co cA csm
      co chil wcel cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA
      hvmulcl cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA cno cfv
      cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA
      c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v
      wceq wn cA normcl adantr cA chil wcel cA c0v wceq wn wa cA cno cfv cc0
      wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv cc0 wceq wn cA c0v
      wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq cA norm-i notbid
      biimpar cA cno cfv cc0 df-ne sylibr sylanc recnd cA chil wcel cA c0v wceq
      wn pm3.26 sylanc c1 cA cno cfv cdiv co cA csm co cno cfv cr wcel c1 cA
      cno cfv cdiv co cA csm co cno cfv c1 wceq c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 cle wbr cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co
      cA csm co cno cfv c1 eqle cA chil wcel cA c0v wceq wn wa c1 cA cno cfv
      cdiv co cA csm co chil wcel c1 cA cno cfv cdiv co cA csm co cno cfv cr
      wcel c1 cA cno cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co cA
      csm co chil wcel cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA
      hvmulcl cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA cno cfv
      cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA
      c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v
      wceq wn cA normcl adantr cA chil wcel cA c0v wceq wn wa cA cno cfv cc0
      wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv cc0 wceq wn cA c0v
      wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq cA norm-i notbid
      biimpar cA cno cfv cc0 df-ne sylibr sylanc recnd cA chil wcel cA c0v wceq
      wn pm3.26 sylanc c1 cA cno cfv cdiv co cA csm co normcl syl cA chil wcel
      cA c0v wne c1 cA cno cfv cdiv co cA csm co cno cfv c1 wceq cA c0v wceq wn
      cA norm1 cA c0v df-ne sylan2br sylanc sylanc eqbrtrd cA cT cfv cno cfv cr
      wcel cA cno cfv cr wcel cT cnop cfv cr wcel w3a cc0 cA cno cfv clt wbr cA
      cT cfv cno cfv cA cno cfv cdiv co cT cnop cfv cle wbr cA cT cfv cno cfv
      cT cnop cfv cA cno cfv cmul co cle wbr wb cA chil wcel cA c0v wceq wn wa
      cA cT cfv cno cfv cA cno cfv cT cnop cfv ledivmul2OLD cA chil wcel cA c0v
      wceq wn wa cA cT cfv cno cfv cr wcel cA cno cfv cr wcel cT cnop cfv cr
      wcel cA chil wcel cA cT cfv cno cfv cr wcel cA c0v wceq wn cA chil wcel
      cA cT cfv chil wcel cA cT cfv cno cfv cr wcel chil chil cA cT cT
      nmcopex.1 lnopfi ffvelrni cA cT cfv normcl syl adantr cA chil wcel cA cno
      cfv cr wcel cA c0v wceq wn cA normcl adantr cT cnop cfv cr wcel cA chil
      wcel cA c0v wceq wn wa cT nmcopex.1 nmcopex.2 nmcopexi a1i 3jca cA chil
      wcel cA c0v wceq wn cc0 cA cno cfv clt wbr cA normgt0OLD biimpa sylanc
      mpbid pm2.61dan $.
      $( [13-Apr-2006] $) $( [7-Feb-2006] $)
  $}

  $( The norm of a continuous linear Hilbert space operator exists.  Theorem
     3.5(i) of [Beran] p. 99. $)
  nmcopex $p |- ( ( T e. LinOp /\ T e. ConOp ) -> ( normop ` T ) e. RR ) $=
    cT clo wcel cT cco wcel wa cT clo cco cin wcel cT cnop cfv cr wcel cT clo
    cco elin cT clo cco cin wcel cT cnop cfv cr wcel cT clo cco cin wcel cT cid
    chil cres cif cnop cfv cr wcel cT cid chil cres cT cT clo cco cin wcel cT
    cid chil cres cif wceq cT cnop cfv cT clo cco cin wcel cT cid chil cres cif
    cnop cfv cr cT cT clo cco cin wcel cT cid chil cres cif cnop fveq2 eleq1d
    cT clo cco cin wcel cT cid chil cres cif cT clo cco cin wcel cT cid chil
    cres cif clo wcel cT clo cco cin wcel cT cid chil cres cif cco wcel cT clo
    cco cin wcel cT cid chil cres cif clo cco cin wcel cT clo cco cin wcel cT
    cid chil cres cif clo wcel cT clo cco cin wcel cT cid chil cres cif cco
    wcel wa cT cid chil cres clo cco cin cid chil cres clo cco cin wcel cid
    chil cres clo wcel cid chil cres cco wcel cid chil cres clo cco elin idlnop
    idcnop mpbir2an elimel cT clo cco cin wcel cT cid chil cres cif clo cco
    elin mpbi pm3.26i cT clo cco cin wcel cT cid chil cres cif clo wcel cT clo
    cco cin wcel cT cid chil cres cif cco wcel cT clo cco cin wcel cT cid chil
    cres cif clo cco cin wcel cT clo cco cin wcel cT cid chil cres cif clo wcel
    cT clo cco cin wcel cT cid chil cres cif cco wcel wa cT cid chil cres clo
    cco cin cid chil cres clo cco cin wcel cid chil cres clo wcel cid chil cres
    cco wcel cid chil cres clo cco elin idlnop idcnop mpbir2an elimel cT clo
    cco cin wcel cT cid chil cres cif clo cco elin mpbi pm3.27i nmcopexi dedth
    sylbir $.
    $( [12-Apr-2006] $) $( [7-Feb-2006] $)

  $( A lower bound for the norm of a continuous linear Hilbert space operator.
     Theorem 3.5(ii) of [Beran] p. 99. $)
  nmcoplb $p |- ( ( T e. LinOp /\ T e. ConOp /\ A e. ~H ) ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
    cT clo wcel cT cco wcel cA chil wcel cA cT cfv cno cfv cT cnop cfv cA cno
    cfv cmul co cle wbr cT clo cco cin wcel cA chil wcel cA cT cfv cno cfv cT
    cnop cfv cA cno cfv cmul co cle wbr cT clo wcel cT cco wcel wa cT clo cco
    cin wcel cA chil wcel cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co cle
    wbr cT clo cco cin wcel cA chil wcel cA cT cfv cno cfv cT cnop cfv cA cno
    cfv cmul co cle wbr wi cA chil wcel cA cT clo cco cin wcel cT cid chil cres
    cif cfv cno cfv cT clo cco cin wcel cT cid chil cres cif cnop cfv cA cno
    cfv cmul co cle wbr wi cT cid chil cres cT cT clo cco cin wcel cT cid chil
    cres cif wceq cA cT cfv cno cfv cT cnop cfv cA cno cfv cmul co cle wbr cA
    cT clo cco cin wcel cT cid chil cres cif cfv cno cfv cT clo cco cin wcel cT
    cid chil cres cif cnop cfv cA cno cfv cmul co cle wbr cA chil wcel cT cT
    clo cco cin wcel cT cid chil cres cif wceq cA cT cfv cno cfv cA cT clo cco
    cin wcel cT cid chil cres cif cfv cno cfv cT cnop cfv cA cno cfv cmul co cT
    clo cco cin wcel cT cid chil cres cif cnop cfv cA cno cfv cmul co cle cT cT
    clo cco cin wcel cT cid chil cres cif wceq cA cT cfv cA cT clo cco cin wcel
    cT cid chil cres cif cfv cno cA cT cT clo cco cin wcel cT cid chil cres cif
    fveq1 fveq2d cT cT clo cco cin wcel cT cid chil cres cif wceq cT cnop cfv
    cT clo cco cin wcel cT cid chil cres cif cnop cfv cA cno cfv cmul cT cT clo
    cco cin wcel cT cid chil cres cif cnop fveq2 opreq1d breq12d imbi2d cA cT
    clo cco cin wcel cT cid chil cres cif cT clo cco cin wcel cT cid chil cres
    cif clo wcel cT clo cco cin wcel cT cid chil cres cif cco wcel cT clo cco
    cin wcel cT cid chil cres cif clo cco cin wcel cT clo cco cin wcel cT cid
    chil cres cif clo wcel cT clo cco cin wcel cT cid chil cres cif cco wcel wa
    cT cid chil cres clo cco cin cid chil cres clo cco cin wcel cid chil cres
    clo wcel cid chil cres cco wcel cid chil cres clo cco elin idlnop idcnop
    mpbir2an elimel cT clo cco cin wcel cT cid chil cres cif clo cco elin mpbi
    pm3.26i cT clo cco cin wcel cT cid chil cres cif clo wcel cT clo cco cin
    wcel cT cid chil cres cif cco wcel cT clo cco cin wcel cT cid chil cres cif
    clo cco cin wcel cT clo cco cin wcel cT cid chil cres cif clo wcel cT clo
    cco cin wcel cT cid chil cres cif cco wcel wa cT cid chil cres clo cco cin
    cid chil cres clo cco cin wcel cid chil cres clo wcel cid chil cres cco
    wcel cid chil cres clo cco elin idlnop idcnop mpbir2an elimel cT clo cco
    cin wcel cT cid chil cres cif clo cco elin mpbi pm3.27i nmcoplbi dedth imp
    cT clo cco elin sylanbr 3impa $.
    $( [13-Apr-2006] $) $( [7-Feb-2006] $)

  ${
    $d x A $.  $d x T $.
    nmophm.1 $e |- T e. BndLinOp $.
    $( The norm of the scalar product of a bounded linear operator. $)
    nmophmi $p |- ( A e. CC ->
              ( normop ` ( A .op T ) ) = ( ( abs ` A ) x. ( normop ` T ) ) ) $=
      cA cc wcel cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co wceq cA
      cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cabs cfv
      cT cnop cfv cmul co cA cT chot co cnop cfv cle wbr wa cA cc wcel cA cT
      chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cabs cfv cT
      cnop cfv cmul co cA cT chot co cnop cfv cle wbr chil chil cA cT chot co
      wf cA cabs cfv cT cnop cfv cmul co cxr wcel vx cv cno cfv c1 cle wbr vx
      cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr wi
      vx chil wral cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cle
      wbr cA cc wcel vx cA cabs cfv cT cnop cfv cmul co cA cT chot co nmopub cA
      cc wcel chil chil cT wf chil chil cA cT chot co wf cT cbo wcel chil chil
      cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cc wcel cA cabs cfv
      cT cnop cfv cmul co cr wcel cA cabs cfv cT cnop cfv cmul co cxr wcel cA
      cc wcel cA cabs cfv cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA
      abscl cA cabs cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cT cnop cfv
      cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp
      cA cabs cfv cT cnop cfv remulcl mpan2 syl cA cabs cfv cT cnop cfv cmul co
      rexr syl cA cc wcel vx cv cno cfv c1 cle wbr vx cv cA cT chot co cfv cno
      cfv cA cabs cfv cT cnop cfv cmul co cle wbr wi vx chil cA cc wcel vx cv
      chil wcel wa vx cv cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA
      cabs cfv cT cnop cfv cmul co cle wbr cA cc wcel vx cv chil wcel wa vx cv
      cno cfv c1 cle wbr wa vx cv cA cT chot co cfv cno cfv cA cabs cfv vx cv
      cT cfv cno cfv cmul co cA cabs cfv cT cnop cfv cmul co cle cA cc wcel vx
      cv chil wcel wa vx cv cA cT chot co cfv cno cfv cA cabs cfv vx cv cT cfv
      cno cfv cmul co wceq vx cv cno cfv c1 cle wbr cA cc wcel vx cv chil wcel
      wa vx cv cA cT chot co cfv cno cfv cA vx cv cT cfv csm co cno cfv cA cabs
      cfv vx cv cT cfv cno cfv cmul co cA cc wcel vx cv chil wcel wa vx cv cA
      cT chot co cfv cA vx cv cT cfv csm co cno cA cc wcel chil chil cT wf vx
      cv chil wcel vx cv cA cT chot co cfv cA vx cv cT cfv csm co wceq cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA vx cv cT homval mp3an2
      fveq2d cA cc wcel vx cv cT cfv chil wcel cA vx cv cT cfv csm co cno cfv
      cA cabs cfv vx cv cT cfv cno cfv cmul co wceq vx cv chil wcel cA vx cv cT
      cfv norm-iii chil chil vx cv cT cT cbo wcel chil chil cT wf nmophm.1 cT
      bdopf ax-mp ffvelrni sylan2 eqtrd adantr vx cv cT cfv cno cfv cr wcel cT
      cnop cfv cr wcel cA cabs cfv cr wcel w3a cc0 cA cabs cfv cle wbr vx cv cT
      cfv cno cfv cT cnop cfv cle wbr wa cA cabs cfv vx cv cT cfv cno cfv cmul
      co cA cabs cfv cT cnop cfv cmul co cle wbr cA cc wcel vx cv chil wcel wa
      vx cv cno cfv c1 cle wbr wa vx cv cT cfv cno cfv cT cnop cfv cA cabs cfv
      lemul2aOLD cA cc wcel vx cv chil wcel wa vx cv cT cfv cno cfv cr wcel cT
      cnop cfv cr wcel cA cabs cfv cr wcel w3a vx cv cno cfv c1 cle wbr cA cc
      wcel vx cv chil wcel wa vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel
      cA cabs cfv cr wcel vx cv chil wcel vx cv cT cfv cno cfv cr wcel cA cc
      wcel vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel
      chil chil vx cv cT cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp
      ffvelrni vx cv cT cfv normcl syl adantl cT cnop cfv cr wcel cA cc wcel vx
      cv chil wcel wa cT cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp
      a1i cA cc wcel cA cabs cfv cr wcel vx cv chil wcel cA abscl adantr 3jca
      adantr cA cc wcel vx cv chil wcel vx cv cno cfv c1 cle wbr cc0 cA cabs
      cfv cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr wa cA cc wcel cc0 cA
      cabs cfv cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv
      cno cfv cT cnop cfv cle wbr cA absge0 chil chil cT wf vx cv chil wcel vx
      cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp vx cv cT nmoplb mp3an1
      anim12i anassrs sylanc eqbrtrd ex r19.21aiva syl3anc cA cc wcel cA cc0
      wceq cA cabs cfv cT cnop cfv cmul co cA cT chot co cnop cfv cle wbr cA cc
      wcel cA cc0 wceq wa cA cabs cfv cT cnop cfv cmul co cc0 cA cT chot co
      cnop cfv cle cA cc0 wceq cA cabs cfv cT cnop cfv cmul co cc0 wceq cA cc
      wcel cA cc0 wceq cA cabs cfv cT cnop cfv cmul co cc0 cT cnop cfv cmul co
      cc0 cA cc0 wceq cA cabs cfv cc0 cT cnop cfv cmul cA cc0 wceq cA cabs cfv
      cc0 cabs cfv cc0 cA cc0 cabs fveq2 abs0 syl6eq opreq1d cT cnop cfv cT
      cnop cfv cT cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp recni
      mul02i syl6eq adantl cA cc wcel cc0 cA cT chot co cnop cfv cle wbr cA cc0
      wceq cA cc wcel chil chil cA cT chot co wf cc0 cA cT chot co cnop cfv cle
      wbr cA cc wcel chil chil cT wf chil chil cA cT chot co wf cT cbo wcel
      chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cT chot co
      nmopge0 syl adantr eqbrtrd cA cc wcel cA cc0 wne cA cabs cfv cT cnop cfv
      cmul co cA cT chot co cnop cfv cle wbr cA cc0 wceq wn cA cc wcel cA cc0
      wne wa cA cabs cfv cT cnop cfv cmul co cA cT chot co cnop cfv cle wbr cT
      cnop cfv cA cT chot co cnop cfv cA cabs cfv cdiv co cle wbr cA cT chot co
      cnop cfv cA cabs cfv cdiv co cxr wcel vx cv cno cfv c1 cle wbr vx cv cT
      cfv cno cfv cA cT chot co cnop cfv cA cabs cfv cdiv co cle wbr wi vx chil
      wral cT cnop cfv cA cT chot co cnop cfv cA cabs cfv cdiv co cle wbr cA cc
      wcel cA cc0 wne wa chil chil cT wf cA cT chot co cnop cfv cA cabs cfv
      cdiv co cxr wcel vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cA cT chot
      co cnop cfv cA cabs cfv cdiv co cle wbr wi vx chil wral cT cnop cfv cA cT
      chot co cnop cfv cA cabs cfv cdiv co cle wbr cT cbo wcel chil chil cT wf
      nmophm.1 cT bdopf ax-mp vx cA cT chot co cnop cfv cA cabs cfv cdiv co cT
      nmopub mp3an1 cA cc wcel cA cc0 wne wa cA cT chot co cnop cfv cA cabs cfv
      cdiv co cr wcel cA cT chot co cnop cfv cA cabs cfv cdiv co cxr wcel cA cT
      chot co cnop cfv cr wcel cA cabs cfv cr wcel cA cabs cfv cc0 wne cA cT
      chot co cnop cfv cA cabs cfv cdiv co cr wcel cA cc wcel cA cc0 wne wa cA
      cT chot co cnop cfv cA cabs cfv redivcl cA cc wcel cA cT chot co cnop cfv
      cr wcel cA cc0 wne cA cT chot co cnop cfv cxr wcel cA cabs cfv cT cnop
      cfv cmul co cr wcel cmnf cA cT chot co cnop cfv clt wbr cA cT chot co
      cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cT chot co cnop cfv
      cr wcel cA cc wcel cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co
      xrre cA cc wcel chil chil cA cT chot co wf cA cT chot co cnop cfv cxr
      wcel cA cc wcel chil chil cT wf chil chil cA cT chot co wf cT cbo wcel
      chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cT chot co
      nmopxr syl cA cc wcel cA cabs cfv cr wcel cA cabs cfv cT cnop cfv cmul co
      cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cT
      cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel nmophm.1 cT
      nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2 syl cA cc wcel chil
      chil cA cT chot co wf cmnf cA cT chot co cnop cfv clt wbr cA cc wcel chil
      chil cT wf chil chil cA cT chot co wf cT cbo wcel chil chil cT wf
      nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cT chot co nmopgtmnf syl
      chil chil cA cT chot co wf cA cabs cfv cT cnop cfv cmul co cxr wcel vx cv
      cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop
      cfv cmul co cle wbr wi vx chil wral cA cT chot co cnop cfv cA cabs cfv cT
      cnop cfv cmul co cle wbr cA cc wcel vx cA cabs cfv cT cnop cfv cmul co cA
      cT chot co nmopub cA cc wcel chil chil cT wf chil chil cA cT chot co wf
      cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2
      cA cc wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA cabs cfv cT cnop
      cfv cmul co cxr wcel cA cc wcel cA cabs cfv cr wcel cA cabs cfv cT cnop
      cfv cmul co cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv cr wcel cA
      cabs cfv cT cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel
      nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2 syl cA
      cabs cfv cT cnop cfv cmul co rexr syl cA cc wcel vx cv cno cfv c1 cle wbr
      vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr
      wi vx chil cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr vx cv
      cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cc
      wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cA cT chot co
      cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co cA cabs cfv cT cnop
      cfv cmul co cle cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cno
      cfv cA cabs cfv vx cv cT cfv cno cfv cmul co wceq vx cv cno cfv c1 cle
      wbr cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cno cfv cA vx
      cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co cA cc
      wcel vx cv chil wcel wa vx cv cA cT chot co cfv cA vx cv cT cfv csm co
      cno cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT chot co cfv cA
      vx cv cT cfv csm co wceq cT cbo wcel chil chil cT wf nmophm.1 cT bdopf
      ax-mp cA vx cv cT homval mp3an2 fveq2d cA cc wcel vx cv cT cfv chil wcel
      cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      wceq vx cv chil wcel cA vx cv cT cfv norm-iii chil chil vx cv cT cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni sylan2 eqtrd adantr
      vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel w3a
      cc0 cA cabs cfv cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr wa cA
      cabs cfv vx cv cT cfv cno cfv cmul co cA cabs cfv cT cnop cfv cmul co cle
      wbr cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cT
      cfv cno cfv cT cnop cfv cA cabs cfv lemul2aOLD cA cc wcel vx cv chil wcel
      wa vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel
      w3a vx cv cno cfv c1 cle wbr cA cc wcel vx cv chil wcel wa vx cv cT cfv
      cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel vx cv chil wcel
      vx cv cT cfv cno cfv cr wcel cA cc wcel vx cv chil wcel vx cv cT cfv chil
      wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv cT cT cbo wcel chil
      chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni vx cv cT cfv normcl syl
      adantl cT cnop cfv cr wcel cA cc wcel vx cv chil wcel wa cT cbo wcel cT
      cnop cfv cr wcel nmophm.1 cT nmopre ax-mp a1i cA cc wcel cA cabs cfv cr
      wcel vx cv chil wcel cA abscl adantr 3jca adantr cA cc wcel vx cv chil
      wcel vx cv cno cfv c1 cle wbr cc0 cA cabs cfv cle wbr vx cv cT cfv cno
      cfv cT cnop cfv cle wbr wa cA cc wcel cc0 cA cabs cfv cle wbr vx cv chil
      wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cno cfv cT cnop cfv cle wbr
      cA absge0 chil chil cT wf vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv
      cT cfv cno cfv cT cnop cfv cle wbr cT cbo wcel chil chil cT wf nmophm.1
      cT bdopf ax-mp vx cv cT nmoplb mp3an1 anim12i anassrs sylanc eqbrtrd ex
      r19.21aiva syl3anc syl2anc adantr cA cc wcel cA cabs cfv cr wcel cA cc0
      wne cA abscl adantr cA cc wcel cA cabs cfv cc0 wne cA cc0 wne cA cc wcel
      cA cabs cfv cc0 cA cc0 cA abs00 necon3bid biimpar syl3anc cA cT chot co
      cnop cfv cA cabs cfv cdiv co rexr syl cA cc wcel cA cc0 wne wa vx cv cno
      cfv c1 cle wbr vx cv cT cfv cno cfv cA cT chot co cnop cfv cA cabs cfv
      cdiv co cle wbr wi vx chil cA cc wcel cA cc0 wne wa vx cv chil wcel wa vx
      cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cA cT chot co cnop cfv cA cabs
      cfv cdiv co cle wbr cA cc wcel cA cc0 wne wa vx cv chil wcel wa vx cv cno
      cfv c1 cle wbr wa cA cabs cfv vx cv cT cfv cno cfv cmul co cA cT chot co
      cnop cfv cle wbr vx cv cT cfv cno cfv cA cT chot co cnop cfv cA cabs cfv
      cdiv co cle wbr cA cc wcel vx cv chil wcel vx cv cno cfv c1 cle wbr cA
      cabs cfv vx cv cT cfv cno cfv cmul co cA cT chot co cnop cfv cle wbr cA
      cc0 wne cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv
      cA cT chot co cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co cA cT
      chot co cnop cfv cle cA cc wcel vx cv chil wcel wa vx cv cA cT chot co
      cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co wceq vx cv cno cfv
      c1 cle wbr cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cno cfv
      cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cA vx cv cT cfv csm
      co cno cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT chot co cfv
      cA vx cv cT cfv csm co wceq cT cbo wcel chil chil cT wf nmophm.1 cT bdopf
      ax-mp cA vx cv cT homval mp3an2 fveq2d cA cc wcel vx cv cT cfv chil wcel
      cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      wceq vx cv chil wcel cA vx cv cT cfv norm-iii chil chil vx cv cT cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni sylan2 eqtrd adantr
      cA cc wcel vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv cA cT chot co
      cfv cno cfv cA cT chot co cnop cfv cle wbr chil chil cA cT chot co wf vx
      cv chil wcel vx cv cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA
      cT chot co cnop cfv cle wbr cA cc wcel vx cv cA cT chot co nmoplb cA cc
      wcel chil chil cT wf chil chil cA cT chot co wf cT cbo wcel chil chil cT
      wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 syl3an1 3expa eqbrtrrd
      adantllr cA cc wcel cA cc0 wne wa vx cv chil wcel wa cA cabs cfv vx cv cT
      cfv cno cfv cmul co cA cT chot co cnop cfv cle wbr vx cv cT cfv cno cfv
      cA cT chot co cnop cfv cA cabs cfv cdiv co cle wbr wb vx cv cno cfv c1
      cle wbr cA cabs cfv cr wcel vx cv cT cfv cno cfv cr wcel cA cT chot co
      cnop cfv cr wcel w3a cc0 cA cabs cfv clt wbr cA cabs cfv vx cv cT cfv cno
      cfv cmul co cA cT chot co cnop cfv cle wbr vx cv cT cfv cno cfv cA cT
      chot co cnop cfv cA cabs cfv cdiv co cle wbr wb cA cc wcel cA cc0 wne wa
      vx cv chil wcel wa cA cabs cfv vx cv cT cfv cno cfv cA cT chot co cnop
      cfv lemuldiv2OLD cA cc wcel cA cc0 wne wa vx cv chil wcel wa cA cabs cfv
      cr wcel vx cv cT cfv cno cfv cr wcel cA cT chot co cnop cfv cr wcel cA cc
      wcel cA cabs cfv cr wcel cA cc0 wne vx cv chil wcel cA abscl ad2antrr vx
      cv chil wcel vx cv cT cfv cno cfv cr wcel cA cc wcel cA cc0 wne wa vx cv
      chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil chil
      vx cv cT cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni vx
      cv cT cfv normcl syl adantl cA cc wcel cA cT chot co cnop cfv cr wcel cA
      cc0 wne vx cv chil wcel cA cT chot co cnop cfv cxr wcel cA cabs cfv cT
      cnop cfv cmul co cr wcel cmnf cA cT chot co cnop cfv clt wbr cA cT chot
      co cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cT chot co cnop
      cfv cr wcel cA cc wcel cA cT chot co cnop cfv cA cabs cfv cT cnop cfv
      cmul co xrre cA cc wcel chil chil cA cT chot co wf cA cT chot co cnop cfv
      cxr wcel cA cc wcel chil chil cT wf chil chil cA cT chot co wf cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cT
      chot co nmopxr syl cA cc wcel cA cabs cfv cr wcel cA cabs cfv cT cnop cfv
      cmul co cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv cr wcel cA cabs
      cfv cT cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel nmophm.1
      cT nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2 syl cA cc wcel chil
      chil cA cT chot co wf cmnf cA cT chot co cnop cfv clt wbr cA cc wcel chil
      chil cT wf chil chil cA cT chot co wf cT cbo wcel chil chil cT wf
      nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cT chot co nmopgtmnf syl
      chil chil cA cT chot co wf cA cabs cfv cT cnop cfv cmul co cxr wcel vx cv
      cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop
      cfv cmul co cle wbr wi vx chil wral cA cT chot co cnop cfv cA cabs cfv cT
      cnop cfv cmul co cle wbr cA cc wcel vx cA cabs cfv cT cnop cfv cmul co cA
      cT chot co nmopub cA cc wcel chil chil cT wf chil chil cA cT chot co wf
      cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2
      cA cc wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA cabs cfv cT cnop
      cfv cmul co cxr wcel cA cc wcel cA cabs cfv cr wcel cA cabs cfv cT cnop
      cfv cmul co cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv cr wcel cA
      cabs cfv cT cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel
      nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2 syl cA
      cabs cfv cT cnop cfv cmul co rexr syl cA cc wcel vx cv cno cfv c1 cle wbr
      vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr
      wi vx chil cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr vx cv
      cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cc
      wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cA cT chot co
      cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co cA cabs cfv cT cnop
      cfv cmul co cle cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cno
      cfv cA cabs cfv vx cv cT cfv cno cfv cmul co wceq vx cv cno cfv c1 cle
      wbr cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cno cfv cA vx
      cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co cA cc
      wcel vx cv chil wcel wa vx cv cA cT chot co cfv cA vx cv cT cfv csm co
      cno cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT chot co cfv cA
      vx cv cT cfv csm co wceq cT cbo wcel chil chil cT wf nmophm.1 cT bdopf
      ax-mp cA vx cv cT homval mp3an2 fveq2d cA cc wcel vx cv cT cfv chil wcel
      cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      wceq vx cv chil wcel cA vx cv cT cfv norm-iii chil chil vx cv cT cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni sylan2 eqtrd adantr
      vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel w3a
      cc0 cA cabs cfv cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr wa cA
      cabs cfv vx cv cT cfv cno cfv cmul co cA cabs cfv cT cnop cfv cmul co cle
      wbr cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cT
      cfv cno cfv cT cnop cfv cA cabs cfv lemul2aOLD cA cc wcel vx cv chil wcel
      wa vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel
      w3a vx cv cno cfv c1 cle wbr cA cc wcel vx cv chil wcel wa vx cv cT cfv
      cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel vx cv chil wcel
      vx cv cT cfv cno cfv cr wcel cA cc wcel vx cv chil wcel vx cv cT cfv chil
      wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv cT cT cbo wcel chil
      chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni vx cv cT cfv normcl syl
      adantl cT cnop cfv cr wcel cA cc wcel vx cv chil wcel wa cT cbo wcel cT
      cnop cfv cr wcel nmophm.1 cT nmopre ax-mp a1i cA cc wcel cA cabs cfv cr
      wcel vx cv chil wcel cA abscl adantr 3jca adantr cA cc wcel vx cv chil
      wcel vx cv cno cfv c1 cle wbr cc0 cA cabs cfv cle wbr vx cv cT cfv cno
      cfv cT cnop cfv cle wbr wa cA cc wcel cc0 cA cabs cfv cle wbr vx cv chil
      wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cno cfv cT cnop cfv cle wbr
      cA absge0 chil chil cT wf vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv
      cT cfv cno cfv cT cnop cfv cle wbr cT cbo wcel chil chil cT wf nmophm.1
      cT bdopf ax-mp vx cv cT nmoplb mp3an1 anim12i anassrs sylanc eqbrtrd ex
      r19.21aiva syl3anc syl2anc ad2antrr 3jca cA cc wcel cA cc0 wne wa cc0 cA
      cabs cfv clt wbr vx cv chil wcel cA cc wcel cA cc0 wne cc0 cA cabs cfv
      clt wbr cA absgt0 biimpa adantr sylanc adantr mpbid ex r19.21aiva sylanc
      cA cabs cfv cr wcel cT cnop cfv cr wcel cA cT chot co cnop cfv cr wcel
      w3a cc0 cA cabs cfv clt wbr cA cabs cfv cT cnop cfv cmul co cA cT chot co
      cnop cfv cle wbr cT cnop cfv cA cT chot co cnop cfv cA cabs cfv cdiv co
      cle wbr wb cA cc wcel cA cc0 wne wa cA cabs cfv cT cnop cfv cA cT chot co
      cnop cfv lemuldiv2OLD cA cc wcel cA cc0 wne wa cA cabs cfv cr wcel cT
      cnop cfv cr wcel cA cT chot co cnop cfv cr wcel cA cc wcel cA cabs cfv cr
      wcel cA cc0 wne cA abscl adantr cT cnop cfv cr wcel cA cc wcel cA cc0 wne
      wa cT cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp a1i cA cc
      wcel cA cT chot co cnop cfv cr wcel cA cc0 wne cA cT chot co cnop cfv cxr
      wcel cA cabs cfv cT cnop cfv cmul co cr wcel cmnf cA cT chot co cnop cfv
      clt wbr cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA
      cT chot co cnop cfv cr wcel cA cc wcel cA cT chot co cnop cfv cA cabs cfv
      cT cnop cfv cmul co xrre cA cc wcel chil chil cA cT chot co wf cA cT chot
      co cnop cfv cxr wcel cA cc wcel chil chil cT wf chil chil cA cT chot co
      wf cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl
      mpan2 cA cT chot co nmopxr syl cA cc wcel cA cabs cfv cr wcel cA cabs cfv
      cT cnop cfv cmul co cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv cr
      wcel cA cabs cfv cT cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr
      wcel nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2 syl
      cA cc wcel chil chil cA cT chot co wf cmnf cA cT chot co cnop cfv clt wbr
      cA cc wcel chil chil cT wf chil chil cA cT chot co wf cT cbo wcel chil
      chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2 cA cT chot co
      nmopgtmnf syl chil chil cA cT chot co wf cA cabs cfv cT cnop cfv cmul co
      cxr wcel vx cv cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA cabs
      cfv cT cnop cfv cmul co cle wbr wi vx chil wral cA cT chot co cnop cfv cA
      cabs cfv cT cnop cfv cmul co cle wbr cA cc wcel vx cA cabs cfv cT cnop
      cfv cmul co cA cT chot co nmopub cA cc wcel chil chil cT wf chil chil cA
      cT chot co wf cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT
      homulcl mpan2 cA cc wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA cabs
      cfv cT cnop cfv cmul co cxr wcel cA cc wcel cA cabs cfv cr wcel cA cabs
      cfv cT cnop cfv cmul co cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv
      cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv
      cr wcel nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2
      syl cA cabs cfv cT cnop cfv cmul co rexr syl cA cc wcel vx cv cno cfv c1
      cle wbr vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co
      cle wbr wi vx chil cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr
      vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr
      cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cA cT
      chot co cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co cA cabs cfv
      cT cnop cfv cmul co cle cA cc wcel vx cv chil wcel wa vx cv cA cT chot co
      cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co wceq vx cv cno cfv
      c1 cle wbr cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cno cfv
      cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv cA vx cv cT cfv csm
      co cno cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT chot co cfv
      cA vx cv cT cfv csm co wceq cT cbo wcel chil chil cT wf nmophm.1 cT bdopf
      ax-mp cA vx cv cT homval mp3an2 fveq2d cA cc wcel vx cv cT cfv chil wcel
      cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      wceq vx cv chil wcel cA vx cv cT cfv norm-iii chil chil vx cv cT cT cbo
      wcel chil chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni sylan2 eqtrd adantr
      vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel w3a
      cc0 cA cabs cfv cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr wa cA
      cabs cfv vx cv cT cfv cno cfv cmul co cA cabs cfv cT cnop cfv cmul co cle
      wbr cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle wbr wa vx cv cT
      cfv cno cfv cT cnop cfv cA cabs cfv lemul2aOLD cA cc wcel vx cv chil wcel
      wa vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel
      w3a vx cv cno cfv c1 cle wbr cA cc wcel vx cv chil wcel wa vx cv cT cfv
      cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv cr wcel vx cv chil wcel
      vx cv cT cfv cno cfv cr wcel cA cc wcel vx cv chil wcel vx cv cT cfv chil
      wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv cT cT cbo wcel chil
      chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni vx cv cT cfv normcl syl
      adantl cT cnop cfv cr wcel cA cc wcel vx cv chil wcel wa cT cbo wcel cT
      cnop cfv cr wcel nmophm.1 cT nmopre ax-mp a1i cA cc wcel cA cabs cfv cr
      wcel vx cv chil wcel cA abscl adantr 3jca adantr cA cc wcel vx cv chil
      wcel vx cv cno cfv c1 cle wbr cc0 cA cabs cfv cle wbr vx cv cT cfv cno
      cfv cT cnop cfv cle wbr wa cA cc wcel cc0 cA cabs cfv cle wbr vx cv chil
      wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cno cfv cT cnop cfv cle wbr
      cA absge0 chil chil cT wf vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv
      cT cfv cno cfv cT cnop cfv cle wbr cT cbo wcel chil chil cT wf nmophm.1
      cT bdopf ax-mp vx cv cT nmoplb mp3an1 anim12i anassrs sylanc eqbrtrd ex
      r19.21aiva syl3anc syl2anc adantr 3jca cA cc wcel cA cc0 wne cc0 cA cabs
      cfv clt wbr cA absgt0 biimpa sylanc mpbird cA cc0 df-ne sylan2br
      pm2.61dan jca cA cT chot co cnop cfv cr wcel cA cabs cfv cT cnop cfv cmul
      co cr wcel cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co wceq cA
      cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cabs cfv
      cT cnop cfv cmul co cA cT chot co cnop cfv cle wbr wa wb cA cc wcel cA cT
      chot co cnop cfv cA cabs cfv cT cnop cfv cmul co letri3 cA cT chot co
      cnop cfv cxr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cmnf cA cT chot
      co cnop cfv clt wbr cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul
      co cle wbr cA cT chot co cnop cfv cr wcel cA cc wcel cA cT chot co cnop
      cfv cA cabs cfv cT cnop cfv cmul co xrre cA cc wcel chil chil cA cT chot
      co wf cA cT chot co cnop cfv cxr wcel cA cc wcel chil chil cT wf chil
      chil cA cT chot co wf cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp
      cA cT homulcl mpan2 cA cT chot co nmopxr syl cA cc wcel cA cabs cfv cr
      wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA abscl cA cabs cfv cr wcel
      cT cnop cfv cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cT cbo wcel
      cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop cfv
      remulcl mpan2 syl cA cc wcel chil chil cA cT chot co wf cmnf cA cT chot
      co cnop cfv clt wbr cA cc wcel chil chil cT wf chil chil cA cT chot co wf
      cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp cA cT homulcl mpan2
      cA cT chot co nmopgtmnf syl chil chil cA cT chot co wf cA cabs cfv cT
      cnop cfv cmul co cxr wcel vx cv cno cfv c1 cle wbr vx cv cA cT chot co
      cfv cno cfv cA cabs cfv cT cnop cfv cmul co cle wbr wi vx chil wral cA cT
      chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cle wbr cA cc wcel vx cA
      cabs cfv cT cnop cfv cmul co cA cT chot co nmopub cA cc wcel chil chil cT
      wf chil chil cA cT chot co wf cT cbo wcel chil chil cT wf nmophm.1 cT
      bdopf ax-mp cA cT homulcl mpan2 cA cc wcel cA cabs cfv cT cnop cfv cmul
      co cr wcel cA cabs cfv cT cnop cfv cmul co cxr wcel cA cc wcel cA cabs
      cfv cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA abscl cA cabs cfv
      cr wcel cT cnop cfv cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cT
      cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop
      cfv remulcl mpan2 syl cA cabs cfv cT cnop cfv cmul co rexr syl cA cc wcel
      vx cv cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA cabs cfv cT
      cnop cfv cmul co cle wbr wi vx chil cA cc wcel vx cv chil wcel wa vx cv
      cno cfv c1 cle wbr vx cv cA cT chot co cfv cno cfv cA cabs cfv cT cnop
      cfv cmul co cle wbr cA cc wcel vx cv chil wcel wa vx cv cno cfv c1 cle
      wbr wa vx cv cA cT chot co cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv
      cmul co cA cabs cfv cT cnop cfv cmul co cle cA cc wcel vx cv chil wcel wa
      vx cv cA cT chot co cfv cno cfv cA cabs cfv vx cv cT cfv cno cfv cmul co
      wceq vx cv cno cfv c1 cle wbr cA cc wcel vx cv chil wcel wa vx cv cA cT
      chot co cfv cno cfv cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT
      cfv cno cfv cmul co cA cc wcel vx cv chil wcel wa vx cv cA cT chot co cfv
      cA vx cv cT cfv csm co cno cA cc wcel chil chil cT wf vx cv chil wcel vx
      cv cA cT chot co cfv cA vx cv cT cfv csm co wceq cT cbo wcel chil chil cT
      wf nmophm.1 cT bdopf ax-mp cA vx cv cT homval mp3an2 fveq2d cA cc wcel vx
      cv cT cfv chil wcel cA vx cv cT cfv csm co cno cfv cA cabs cfv vx cv cT
      cfv cno cfv cmul co wceq vx cv chil wcel cA vx cv cT cfv norm-iii chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp
      ffvelrni sylan2 eqtrd adantr vx cv cT cfv cno cfv cr wcel cT cnop cfv cr
      wcel cA cabs cfv cr wcel w3a cc0 cA cabs cfv cle wbr vx cv cT cfv cno cfv
      cT cnop cfv cle wbr wa cA cabs cfv vx cv cT cfv cno cfv cmul co cA cabs
      cfv cT cnop cfv cmul co cle wbr cA cc wcel vx cv chil wcel wa vx cv cno
      cfv c1 cle wbr wa vx cv cT cfv cno cfv cT cnop cfv cA cabs cfv lemul2aOLD
      cA cc wcel vx cv chil wcel wa vx cv cT cfv cno cfv cr wcel cT cnop cfv cr
      wcel cA cabs cfv cr wcel w3a vx cv cno cfv c1 cle wbr cA cc wcel vx cv
      chil wcel wa vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cA cabs cfv
      cr wcel vx cv chil wcel vx cv cT cfv cno cfv cr wcel cA cc wcel vx cv
      chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil chil
      vx cv cT cT cbo wcel chil chil cT wf nmophm.1 cT bdopf ax-mp ffvelrni vx
      cv cT cfv normcl syl adantl cT cnop cfv cr wcel cA cc wcel vx cv chil
      wcel wa cT cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp a1i cA
      cc wcel cA cabs cfv cr wcel vx cv chil wcel cA abscl adantr 3jca adantr
      cA cc wcel vx cv chil wcel vx cv cno cfv c1 cle wbr cc0 cA cabs cfv cle
      wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr wa cA cc wcel cc0 cA cabs
      cfv cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cno
      cfv cT cnop cfv cle wbr cA absge0 chil chil cT wf vx cv chil wcel vx cv
      cno cfv c1 cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr cT cbo wcel
      chil chil cT wf nmophm.1 cT bdopf ax-mp vx cv cT nmoplb mp3an1 anim12i
      anassrs sylanc eqbrtrd ex r19.21aiva syl3anc syl2anc cA cc wcel cA cabs
      cfv cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cA abscl cA cabs cfv
      cr wcel cT cnop cfv cr wcel cA cabs cfv cT cnop cfv cmul co cr wcel cT
      cbo wcel cT cnop cfv cr wcel nmophm.1 cT nmopre ax-mp cA cabs cfv cT cnop
      cfv remulcl mpan2 syl sylanc mpbird $.
      $( [7-May-2006] $) $( [10-Mar-2006] $)

    $( The scalar product of a bounded linear operator is a bounded linear
       operator. $)
    bdophmi $p |- ( A e. CC -> ( A .op T ) e. BndLinOp ) $=
      cA cc wcel cA cT chot co clo wcel cA cT chot co cnop cfv cr wcel wa cA cT
      chot co cbo wcel cA cc wcel cA cT chot co clo wcel cA cT chot co cnop cfv
      cr wcel cA cT cT cbo wcel cT clo wcel nmophm.1 cT bdopln ax-mp lnopmi cA
      cc wcel cA cT chot co cnop cfv cA cabs cfv cT cnop cfv cmul co cr cA cT
      nmophm.1 nmophmi cA cc wcel cA cabs cfv cr wcel cA cabs cfv cT cnop cfv
      cmul co cr wcel cA abscl cA cabs cfv cr wcel cT cnop cfv cr wcel cA cabs
      cfv cT cnop cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel nmophm.1
      cT nmopre ax-mp cA cabs cfv cT cnop cfv remulcl mpan2 syl eqeltrd jca cA
      cT chot co elbdop2 sylibr $.
      $( [7-May-2006] $) $( [10-Mar-2006] $)
  $}

  ${
    $d x y z w v u T $.
    lnopcon.1 $e |- T e. LinOp $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is
       linear.  Theorem 3.5(iii) of [Beran] p. 99. $)
    lnopconi $p |- ( T e. ConOp <->
     E. x e. RR A. y e. ~H ( normh ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) $=
      cT cco wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vx cr wrex cT cnop cfv cr wcel vy cv cT cfv cno cfv cT cnop cfv
      vy cv cno cfv cmul co cle wbr vy chil wral vy cv cT cfv cno cfv vx cv vy
      cv cno cfv cmul co cle wbr vy chil wral vx cr wrex cT cco wcel vy cv cT
      cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vy cv cT cfv
      cno cfv cT cnop cfv vy cv cno cfv cmul co cle wbr vy chil wral vx cT cnop
      cfv cr vx cv cT cnop cfv wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv
      cmul co cle wbr vy cv cT cfv cno cfv cT cnop cfv vy cv cno cfv cmul co
      cle wbr vy chil vx cv cT cnop cfv wceq vx cv vy cv cno cfv cmul co cT
      cnop cfv vy cv cno cfv cmul co vy cv cT cfv cno cfv cle vx cv cT cnop cfv
      vy cv cno cfv cmul opreq1 breq2d ralbidv rcla4ev cT clo wcel cT cco wcel
      cT cnop cfv cr wcel lnopcon.1 cT nmcopex mpan cT cco wcel vy cv cT cfv
      cno cfv cT cnop cfv vy cv cno cfv cmul co cle wbr vy chil cT clo wcel cT
      cco wcel vy cv chil wcel vy cv cT cfv cno cfv cT cnop cfv vy cv cno cfv
      cmul co cle wbr lnopcon.1 vy cv cT nmcoplb mp3an1 r19.21aiva sylanc vz cv
      c0v wceq wn vz chil wrex vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral vx cr wrex cT cco wcel wi vz cv c0v wceq wn vy cv cT
      cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx cr wrex
      cT cco wcel wi vz chil vz cv chil wcel vz cv c0v wceq wn wa vy cv cT cfv
      cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cT cco wcel vx
      cr vz cv chil wcel vz cv c0v wceq wn wa vx cv cr wcel vy cv cT cfv cno
      cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cT cco wcel vz cv
      chil wcel vz cv c0v wceq wn wa vx cv cr wcel wa vy cv cT cfv cno cfv vx
      cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr cc0 vx
      cv wceq wo cT cco wcel vz cv chil wcel vz cv c0v wceq wn wa vx cv cr wcel
      wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral
      wa cc0 vx cv cle wbr cc0 vx cv clt wbr cc0 vx cv wceq wo vx cv cr wcel vz
      cv cno cfv cr wcel wa cc0 vz cv cno cfv clt wbr cc0 vx cv vz cv cno cfv
      cmul co cle wbr wa cc0 vx cv cle wbr vz cv chil wcel vz cv c0v wceq wn wa
      vx cv cr wcel wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral wa vx cv vz cv cno cfv prodge02 vz cv chil wcel vz cv c0v
      wceq wn wa vx cv cr wcel wa vx cv cr wcel vz cv cno cfv cr wcel wa vy cv
      cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx cv cr
      wcel vz cv chil wcel vz cv c0v wceq wn wa vx cv cr wcel vz cv cno cfv cr
      wcel wa vz cv chil wcel vz cv c0v wceq wn wa vz cv cno cfv cr wcel vx cv
      cr wcel vz cv chil wcel vz cv cno cfv cr wcel vz cv c0v wceq wn vz cv
      normcl adantr anim2i ancoms adantr vz cv chil wcel vz cv c0v wceq wn wa
      vx cv cr wcel wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral wa cc0 vz cv cno cfv clt wbr cc0 vx cv vz cv cno cfv cmul co
      cle wbr vz cv chil wcel vz cv c0v wceq wn wa cc0 vz cv cno cfv clt wbr vx
      cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vz cv chil wcel vz cv c0v wceq wn cc0 vz cv cno cfv clt wbr vz
      cv normgt0OLD biimpa ad2antrr vz cv chil wcel vz cv c0v wceq wn wa vx cv
      cr wcel wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral wa cc0 vz cv cT cfv cno cfv vx cv vz cv cno cfv cmul co cc0 cr
      wcel vz cv chil wcel vz cv c0v wceq wn wa vx cv cr wcel wa vy cv cT cfv
      cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa 0re a1i vz cv
      chil wcel vz cv c0v wceq wn wa vz cv cT cfv cno cfv cr wcel vx cv cr wcel
      vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vz
      cv chil wcel vz cv cT cfv cno cfv cr wcel vz cv c0v wceq wn vz cv chil
      wcel vz cv cT cfv chil wcel vz cv cT cfv cno cfv cr wcel chil chil vz cv
      cT cT lnopcon.1 lnopfi ffvelrni vz cv cT cfv normcl syl adantr ad2antrr
      vz cv chil wcel vz cv c0v wceq wn wa vx cv cr wcel wa vx cv vz cv cno cfv
      cmul co cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral vz cv chil wcel vx cv cr wcel vx cv vz cv cno cfv cmul co cr
      wcel vz cv c0v wceq wn vx cv cr wcel vz cv chil wcel vx cv vz cv cno cfv
      cmul co cr wcel vx cv cr wcel vz cv cno cfv cr wcel vx cv vz cv cno cfv
      cmul co cr wcel vz cv chil wcel vx cv vz cv cno cfv remulcl vz cv normcl
      sylan2 ancoms adantlr adantr vz cv chil wcel vz cv c0v wceq wn wa cc0 vz
      cv cT cfv cno cfv cle wbr vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv
      cno cfv cmul co cle wbr vy chil wral vz cv chil wcel cc0 vz cv cT cfv cno
      cfv cle wbr vz cv c0v wceq wn vz cv chil wcel vz cv cT cfv chil wcel cc0
      vz cv cT cfv cno cfv cle wbr chil chil vz cv cT cT lnopcon.1 lnopfi
      ffvelrni vz cv cT cfv normge0 syl adantr ad2antrr vz cv chil wcel vz cv
      c0v wceq wn wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral vz cv cT cfv cno cfv vx cv vz cv cno cfv cmul co cle wbr vx
      cv cr wcel vz cv chil wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul
      co cle wbr vy chil wral vz cv cT cfv cno cfv vx cv vz cv cno cfv cmul co
      cle wbr vz cv c0v wceq wn vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul
      co cle wbr vz cv cT cfv cno cfv vx cv vz cv cno cfv cmul co cle wbr vy vz
      cv chil vy cv vz cv wceq vy cv cT cfv cno cfv vz cv cT cfv cno cfv vx cv
      vy cv cno cfv cmul co vx cv vz cv cno cfv cmul co cle vy cv vz cv wceq vy
      cv cT cfv vz cv cT cfv cno vy cv vz cv cT fveq2 fveq2d vy cv vz cv wceq
      vy cv cno cfv vz cv cno cfv vx cv cmul vy cv vz cv cno fveq2 opreq2d
      breq12d rcla4va adantlr adantlr letrd jca sylanc vx cv cr wcel cc0 vx cv
      cle wbr cc0 vx cv clt wbr cc0 vx cv wceq wo wb vz cv chil wcel vz cv c0v
      wceq wn wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral cc0 cr wcel vx cv cr wcel cc0 vx cv cle wbr cc0 vx cv clt wbr
      cc0 vx cv wceq wo wb 0re cc0 vx cv leloe mpan ad2antlr mpbid vx cv cr
      wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral cc0 vx cv clt wbr cc0 vx cv wceq wo cT cco wcel wi vz cv chil wcel
      vz cv c0v wceq wn wa vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno
      cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr cT cco wcel cc0 vx
      cv wceq vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral wa cc0 vx cv clt wbr cT cco wcel vx cv cr wcel vy cv
      cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx
      cv clt wbr wa cc0 vw cv clt wbr cc0 vv cv clt wbr vu cv vz cv cmv co cno
      cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr
      wi vu chil wral wa vv cr wrex wi vw cr wral vz chil wral cT cco wcel vx
      cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral wa cc0 vx cv clt wbr wa cc0 vw cv clt wbr cc0 vv cv clt wbr vu
      cv vz cv cmv co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmv co
      cno cfv vw cv clt wbr wi vu chil wral wa vv cr wrex wi vz vw chil cr vx
      cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral wa cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw
      cv clt wbr cc0 vv cv clt wbr vu cv vz cv cmv co cno cfv vv cv clt wbr vu
      cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vu chil wral wa vv
      cr wrex vw cv vx cv cdiv co cr wcel cc0 vw cv vx cv cdiv co clt wbr vu cv
      vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT
      cfv cmv co cno cfv vw cv clt wbr wi vu chil wral wa cc0 vv cv clt wbr vu
      cv vz cv cmv co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmv co
      cno cfv vw cv clt wbr wi vu chil wral wa vv cr wrex vx cv cr wcel vy cv
      cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx
      cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa wa
      cc0 vv cv clt wbr vu cv vz cv cmv co cno cfv vv cv clt wbr vu cv cT cfv
      vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vu chil wral wa cc0 vw cv vx
      cv cdiv co clt wbr vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr
      vu cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vu chil wral wa
      vv vw cv vx cv cdiv co cr vv cv vw cv vx cv cdiv co wceq cc0 vv cv clt
      wbr cc0 vw cv vx cv cdiv co clt wbr vu cv vz cv cmv co cno cfv vv cv clt
      wbr vu cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vu chil
      wral vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv
      vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vu chil wral vv cv vw cv vx
      cv cdiv co cc0 clt breq2 vv cv vw cv vx cv cdiv co wceq vu cv vz cv cmv
      co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmv co cno cfv vw cv
      clt wbr wi vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv
      cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr wi vu chil vv cv vw cv
      vx cv cdiv co wceq vu cv vz cv cmv co cno cfv vv cv clt wbr vu cv vz cv
      cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT cfv cmv
      co cno cfv vw cv clt wbr vv cv vw cv vx cv cdiv co vu cv vz cv cmv co cno
      cfv clt breq2 imbi1d ralbidv anbi12d rcla4ev vx cv cr wcel cc0 vx cv clt
      wbr vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vw cv vx cv
      cdiv co cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral vx cv cr wcel cc0 vx cv clt wbr wa vw cv cr wcel cc0 vw cv
      clt wbr vw cv vx cv cdiv co cr wcel vz cv chil wcel vw cv cr wcel vx cv
      cr wcel vx cv cc0 wne vw cv vx cv cdiv co cr wcel vx cv cr wcel cc0 vx cv
      clt wbr wa vw cv cr wcel cc0 vw cv clt wbr wa wa vw cv vx cv redivcl vx
      cv cr wcel cc0 vx cv clt wbr wa vw cv cr wcel cc0 vw cv clt wbr simprl vx
      cv cr wcel cc0 vx cv clt wbr vw cv cr wcel cc0 vw cv clt wbr wa simpll vx
      cv cr wcel cc0 vx cv clt wbr wa vx cv cc0 wne vw cv cr wcel cc0 vw cv clt
      wbr wa vx cv gt0ne0 adantr syl3anc adantrll adantllr vx cv cr wcel vy cv
      cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx
      cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa wa
      cc0 vw cv vx cv cdiv co clt wbr vu cv vz cv cmv co cno cfv vw cv vx cv
      cdiv co clt wbr vu cv cT cfv vz cv cT cfv cmv co cno cfv vw cv clt wbr wi
      vu chil wral vx cv cr wcel cc0 vx cv clt wbr vz cv chil wcel vw cv cr
      wcel wa cc0 vw cv clt wbr wa cc0 vw cv vx cv cdiv co clt wbr vy cv cT cfv
      cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx cv cr wcel
      cc0 vx cv clt wbr wa vw cv cr wcel cc0 vw cv clt wbr cc0 vw cv vx cv cdiv
      co clt wbr vz cv chil wcel vw cv cr wcel cc0 vw cv clt wbr wa vx cv cr
      wcel cc0 vx cv clt wbr wa cc0 vw cv vx cv cdiv co clt wbr vw cv vx cv
      divgt0 ancoms adantrll adantllr vx cv cr wcel vy cv cT cfv cno cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv
      chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa wa vu cv vz cv cmv co cno
      cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT cfv cmv co cno cfv
      vw cv clt wbr wi vu chil vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv
      cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv chil
      wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel vu cv vz cv
      cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT cfv cmv
      co cno cfv vw cv clt wbr wi vx cv cr wcel vy cv cT cfv cno cfv vx cv vy
      cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv
      chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel wa wa vu
      cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT
      cfv cmv co cno cfv vw cv clt wbr vx cv cr wcel vy cv cT cfv cno cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv
      chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv
      vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT
      cfv cmv co cno cfv vw cv clt wbr vx cv cr wcel vy cv cT cfv cno cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv
      chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv
      vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr wa wa vu cv cT cfv vz cv
      cT cfv cmv co cno cfv vx cv vu cv vz cv cmv co cno cfv cmul co vw cv vz
      cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel wa vu
      cv cT cfv vz cv cT cfv cmv co cno cfv cr wcel vx cv cr wcel vy cv cT cfv
      cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt
      wbr wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vz cv chil
      wcel vw cv cr wcel wa vu cv chil wcel vu cv cT cfv vz cv cT cfv cmv co
      cno cfv cr wcel cc0 vw cv clt wbr vz cv chil wcel vu cv chil wcel vu cv
      cT cfv vz cv cT cfv cmv co cno cfv cr wcel vw cv cr wcel vz cv chil wcel
      vu cv chil wcel wa vu cv cT cfv vz cv cT cfv cmv co chil wcel vu cv cT
      cfv vz cv cT cfv cmv co cno cfv cr wcel vu cv chil wcel vz cv chil wcel
      vu cv cT cfv vz cv cT cfv cmv co chil wcel vu cv cT cfv chil wcel vz cv
      cT cfv chil wcel vu cv cT cfv vz cv cT cfv cmv co chil wcel vu cv chil
      wcel vz cv chil wcel vu cv cT cfv vz cv cT cfv hvsubcl chil chil vu cv cT
      cT lnopcon.1 lnopfi ffvelrni chil chil vz cv cT cT lnopcon.1 lnopfi
      ffvelrni syl2an ancoms vu cv cT cfv vz cv cT cfv cmv co normcl syl
      adantlr adantlr ad2antrl vx cv cr wcel cc0 vx cv clt wbr vz cv chil wcel
      vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv vz cv cmv
      co cno cfv vw cv vx cv cdiv co clt wbr wa vx cv vu cv vz cv cmv co cno
      cfv cmul co cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral vx cv cr wcel vz cv chil wcel vw cv cr wcel wa cc0 vw cv
      clt wbr wa vu cv chil wcel wa vx cv vu cv vz cv cmv co cno cfv cmul co cr
      wcel cc0 vx cv clt wbr vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt
      wbr vx cv cr wcel vz cv chil wcel vw cv cr wcel wa vu cv chil wcel vx cv
      vu cv vz cv cmv co cno cfv cmul co cr wcel cc0 vw cv clt wbr vx cv cr
      wcel vz cv chil wcel vu cv chil wcel vx cv vu cv vz cv cmv co cno cfv
      cmul co cr wcel vw cv cr wcel vx cv cr wcel vu cv vz cv cmv co cno cfv cr
      wcel vx cv vu cv vz cv cmv co cno cfv cmul co cr wcel vz cv chil wcel vu
      cv chil wcel wa vx cv vu cv vz cv cmv co cno cfv remulcl vz cv chil wcel
      vu cv chil wcel wa vu cv vz cv cmv co chil wcel vu cv vz cv cmv co cno
      cfv cr wcel vu cv chil wcel vz cv chil wcel vu cv vz cv cmv co chil wcel
      vu cv vz cv hvsubcl ancoms vu cv vz cv cmv co normcl syl sylan2 adantrlr
      adantrlr ad2ant2r adantllr vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt
      wbr wa vu cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co
      clt wbr wa vw cv cr wcel vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv
      cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv chil
      wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vw cv cr wcel vu cv chil wcel
      vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vz cv chil wcel vw
      cv cr wcel cc0 vw cv clt wbr simplr ad2antrr adantl vx cv cr wcel vy cv
      cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx
      cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv
      chil wcel wa vu cv cT cfv vz cv cT cfv cmv co cno cfv vx cv vu cv vz cv
      cmv co cno cfv cmul co cle wbr vu cv vz cv cmv co cno cfv vw cv vx cv
      cdiv co clt wbr vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv chil wcel vw
      cv cr wcel wa vu cv chil wcel vu cv cT cfv vz cv cT cfv cmv co cno cfv vx
      cv vu cv vz cv cmv co cno cfv cmul co cle wbr cc0 vw cv clt wbr vx cv cr
      wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral wa cc0 vx cv clt wbr wa vz cv chil wcel vu cv chil wcel vu cv cT cfv
      vz cv cT cfv cmv co cno cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle
      wbr vw cv cr wcel vx cv cr wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral wa vz cv chil wcel vu cv chil wcel wa vu cv
      cT cfv vz cv cT cfv cmv co cno cfv vx cv vu cv vz cv cmv co cno cfv cmul
      co cle wbr cc0 vx cv clt wbr vx cv cr wcel vy cv cT cfv cno cfv vx cv vy
      cv cno cfv cmul co cle wbr vy chil wral wa vz cv chil wcel vu cv chil
      wcel wa wa vu cv vz cv cmv co cT cfv cno cfv vu cv cT cfv vz cv cT cfv
      cmv co cno cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle vz cv chil
      wcel vu cv chil wcel wa vu cv vz cv cmv co cT cfv cno cfv vu cv cT cfv vz
      cv cT cfv cmv co cno cfv wceq vx cv cr wcel vy cv cT cfv cno cfv vx cv vy
      cv cno cfv cmul co cle wbr vy chil wral wa vz cv chil wcel vu cv chil
      wcel wa vu cv vz cv cmv co cT cfv vu cv cT cfv vz cv cT cfv cmv co cno vu
      cv chil wcel vz cv chil wcel vu cv vz cv cmv co cT cfv vu cv cT cfv vz cv
      cT cfv cmv co wceq vu cv vz cv cT lnopcon.1 lnopsubi ancoms fveq2d adantl
      vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vz
      cv chil wcel vu cv chil wcel wa vu cv vz cv cmv co cT cfv cno cfv vx cv
      vu cv vz cv cmv co cno cfv cmul co cle wbr vx cv cr wcel vz cv chil wcel
      vu cv chil wcel wa vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral vu cv vz cv cmv co cT cfv cno cfv vx cv vu cv vz cv cmv
      co cno cfv cmul co cle wbr vu cv vz cv cmv co chil wcel vy cv cT cfv cno
      cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vu cv vz cv cmv co
      cT cfv cno cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle wbr vz cv
      chil wcel vu cv chil wcel wa vy cv cT cfv cno cfv vx cv vy cv cno cfv
      cmul co cle wbr vu cv vz cv cmv co cT cfv cno cfv vx cv vu cv vz cv cmv
      co cno cfv cmul co cle wbr vy vu cv vz cv cmv co chil vy cv vu cv vz cv
      cmv co wceq vy cv cT cfv cno cfv vu cv vz cv cmv co cT cfv cno cfv vx cv
      vy cv cno cfv cmul co vx cv vu cv vz cv cmv co cno cfv cmul co cle vy cv
      vu cv vz cv cmv co wceq vy cv cT cfv vu cv vz cv cmv co cT cfv cno vy cv
      vu cv vz cv cmv co cT fveq2 fveq2d vy cv vu cv vz cv cmv co wceq vy cv
      cno cfv vu cv vz cv cmv co cno cfv vx cv cmul vy cv vu cv vz cv cmv co
      cno fveq2 opreq2d breq12d rcla4va vu cv chil wcel vz cv chil wcel vu cv
      vz cv cmv co chil wcel vu cv vz cv hvsubcl ancoms sylan ancoms adantll
      eqbrtrrd adantlr adantrlr adantrlr adantrr vx cv cr wcel cc0 vx cv clt
      wbr vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel
      wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr wa vx cv vu cv
      vz cv cmv co cno cfv cmul co vw cv clt wbr vy cv cT cfv cno cfv vx cv vy
      cv cno cfv cmul co cle wbr vy chil wral vx cv cr wcel cc0 vx cv clt wbr
      wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel
      wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vx cv vu cv vz
      cv cmv co cno cfv cmul co vw cv clt wbr vx cv cr wcel cc0 vx cv clt wbr
      wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel
      wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vx cv vu cv vz
      cv cmv co cno cfv cmul co vw cv clt wbr wi vx cv cr wcel cc0 vx cv clt
      wbr wa vz cv chil wcel vw cv cr wcel wa vu cv chil wcel vu cv vz cv cmv
      co cno cfv vw cv vx cv cdiv co clt wbr vx cv vu cv vz cv cmv co cno cfv
      cmul co vw cv clt wbr wi cc0 vw cv clt wbr vx cv cr wcel cc0 vx cv clt
      wbr wa vz cv chil wcel vw cv cr wcel wa vu cv chil wcel wa wa vx cv vu cv
      vz cv cmv co cno cfv cmul co vw cv clt wbr vu cv vz cv cmv co cno cfv vw
      cv vx cv cdiv co clt wbr vx cv cr wcel vu cv vz cv cmv co cno cfv cr wcel
      vw cv cr wcel w3a cc0 vx cv clt wbr vx cv vu cv vz cv cmv co cno cfv cmul
      co vw cv clt wbr vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr
      wb vx cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa vu
      cv chil wcel wa wa vx cv vu cv vz cv cmv co cno cfv vw cv ltmuldiv2OLD vx
      cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa vu cv
      chil wcel wa wa vx cv cr wcel vu cv vz cv cmv co cno cfv cr wcel vw cv cr
      wcel vx cv cr wcel cc0 vx cv clt wbr vz cv chil wcel vw cv cr wcel wa vu
      cv chil wcel wa simpll vz cv chil wcel vw cv cr wcel wa vu cv chil wcel
      wa vu cv vz cv cmv co cno cfv cr wcel vx cv cr wcel cc0 vx cv clt wbr wa
      vz cv chil wcel vu cv chil wcel vu cv vz cv cmv co cno cfv cr wcel vw cv
      cr wcel vz cv chil wcel vu cv chil wcel wa vu cv vz cv cmv co chil wcel
      vu cv vz cv cmv co cno cfv cr wcel vu cv chil wcel vz cv chil wcel vu cv
      vz cv cmv co chil wcel vu cv vz cv hvsubcl ancoms vu cv vz cv cmv co
      normcl syl adantlr adantl vz cv chil wcel vw cv cr wcel wa vw cv cr wcel
      vx cv cr wcel cc0 vx cv clt wbr wa vu cv chil wcel vz cv chil wcel vw cv
      cr wcel pm3.27 ad2antrl 3jca vx cv cr wcel cc0 vx cv clt wbr vz cv chil
      wcel vw cv cr wcel wa vu cv chil wcel wa simplr sylanc biimprd adantrlr
      ex imp32 adantllr lelttrd anassrs ex anassrs r19.21aiva jca sylanc exp32
      r19.21aivv cT cco wcel chil chil cT wf cc0 vw cv clt wbr cc0 vv cv clt
      wbr vu cv vz cv cmv co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv
      cmv co cno cfv vw cv clt wbr wi vu chil wral wa vv cr wrex wi vw cr wral
      vz chil wral vz vw vv vu cT elcnop cT lnopcon.1 lnopfi mpbiran sylibr ex
      vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cc0
      vx cv wceq cT cco wcel wi vx cv cr wcel cc0 vx cv wceq vy cv cT cfv cno
      cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cT cco wcel cc0 vx
      cv wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vy cv cT cfv cno cfv cc0 vy cv cno cfv cmul co cle wbr vy chil wral
      cT cco wcel cc0 vx cv wceq vy cv cT cfv cno cfv cc0 vy cv cno cfv cmul co
      cle wbr vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      cc0 vx cv wceq cc0 vy cv cno cfv cmul co vx cv vy cv cno cfv cmul co vy
      cv cT cfv cno cfv cle cc0 vx cv vy cv cno cfv cmul opreq1 breq2d ralbidv
      vy cv cT cfv cno cfv cc0 vy cv cno cfv cmul co cle wbr vy chil wral vy cv
      cT cfv cno cfv cc0 cle wbr vy chil wral cT cco wcel vy cv cT cfv cno cfv
      cc0 vy cv cno cfv cmul co cle wbr vy cv cT cfv cno cfv cc0 cle wbr vy
      chil vy cv chil wcel cc0 vy cv cno cfv cmul co cc0 vy cv cT cfv cno cfv
      cle vy cv chil wcel vy cv cno cfv cc wcel cc0 vy cv cno cfv cmul co cc0
      wceq vy cv chil wcel vy cv cno cfv vy cv normcl recnd vy cv cno cfv mul02
      syl breq2d ralbiia vy cv cT cfv cno cfv cc0 cle wbr vy chil wral vy cv cT
      cfv vy cv ch0o cfv wceq vy chil wral cT cco wcel vy cv cT cfv cno cfv cc0
      cle wbr vy cv cT cfv vy cv ch0o cfv wceq vy chil vy cv chil wcel vy cv cT
      cfv cno cfv cc0 cle wbr vy cv cT cfv c0v wceq vy cv cT cfv vy cv ch0o cfv
      wceq vy cv chil wcel vy cv cT cfv chil wcel vy cv cT cfv cno cfv cc0 cle
      wbr vy cv cT cfv c0v wceq wb chil chil vy cv cT cT lnopcon.1 lnopfi
      ffvelrni vy cv cT cfv chil wcel vy cv cT cfv cno cfv cc0 cle wbr vy cv cT
      cfv cno cfv cc0 cle wbr cc0 vy cv cT cfv cno cfv cle wbr wa vy cv cT cfv
      cno cfv cc0 wceq vy cv cT cfv c0v wceq vy cv cT cfv chil wcel cc0 vy cv
      cT cfv cno cfv cle wbr vy cv cT cfv cno cfv cc0 cle wbr vy cv cT cfv
      normge0 biantrud vy cv cT cfv chil wcel vy cv cT cfv cno cfv cr wcel vy
      cv cT cfv cno cfv cc0 wceq vy cv cT cfv cno cfv cc0 cle wbr cc0 vy cv cT
      cfv cno cfv cle wbr wa wb vy cv cT cfv normcl vy cv cT cfv cno cfv cr
      wcel cc0 cr wcel vy cv cT cfv cno cfv cc0 wceq vy cv cT cfv cno cfv cc0
      cle wbr cc0 vy cv cT cfv cno cfv cle wbr wa wb 0re vy cv cT cfv cno cfv
      cc0 letri3 mpan2 syl vy cv cT cfv norm-i 3bitr2d syl vy cv chil wcel vy
      cv ch0o cfv c0v vy cv cT cfv vy cv ho0val eqeq2d bitr4d ralbiia vy cv cT
      cfv vy cv ch0o cfv wceq vy chil wral cT ch0o cco cT ch0o wceq vy cv cT
      cfv vy cv ch0o cfv wceq vy chil wral cT chil wfn ch0o chil wfn cT ch0o
      wceq vy cv cT cfv vy cv ch0o cfv wceq vy chil wral wb chil chil cT wf cT
      chil wfn cT lnopcon.1 lnopfi chil chil cT ffn ax-mp chil chil ch0o wf
      ch0o chil wfn ho0f chil chil ch0o ffn ax-mp vy chil cT ch0o eqfnfv2 mp2an
      biimpri 0cnop syl6eqel sylbi sylbi syl6bir com12 adantl jaod adantll mpd
      exp31 r19.23adv r19.23aiva vz cv c0v wceq wn vz chil wrex wn vy cv c0v
      wceq vy chil wral vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral vx cr wrex cT cco wcel wi vy cv c0v wceq vy chil wral vz
      cv c0v wceq vz chil wral vz cv c0v wceq wn vz chil wrex wn vy cv c0v wceq
      vz cv c0v wceq vy vz chil vy cv vz cv c0v eqeq1 cbvralv vz cv c0v wceq vz
      chil dfral2 bitr2i vy cv c0v wceq vy chil wral vy cv cT cfv cno cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral cT cco wcel vx cr vx cv cr
      wcel vy cv c0v wceq vy chil wral vy cv cT cfv cno cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral cT cco wcel wi vx cv cr wcel vy cv c0v wceq
      vy chil wral vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral cT cco wcel vx cv cr wcel vy cv cT cfv cno cfv vx cv cc0 cmul
      co cle wbr vy chil wral cT cco wcel vy cv c0v wceq vy chil wral vy cv cT
      cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa vx cv cr
      wcel vy cv cT cfv cno cfv vx cv cc0 cmul co cle wbr vy chil wral vy cv cT
      cfv cno cfv cc0 cle wbr vy chil wral cT cco wcel vx cv cr wcel vy cv cT
      cfv cno cfv vx cv cc0 cmul co cle wbr vy cv cT cfv cno cfv cc0 cle wbr vy
      chil vx cv cr wcel vx cv cc0 cmul co cc0 vy cv cT cfv cno cfv cle vx cv
      cr wcel vx cv cc wcel vx cv cc0 cmul co cc0 wceq vx cv recn vx cv mul01
      syl breq2d ralbidv vy cv cT cfv cno cfv cc0 cle wbr vy chil wral vy cv cT
      cfv vy cv ch0o cfv wceq vy chil wral cT cco wcel vy cv cT cfv cno cfv cc0
      cle wbr vy cv cT cfv vy cv ch0o cfv wceq vy chil vy cv chil wcel vy cv cT
      cfv cno cfv cc0 cle wbr vy cv cT cfv c0v wceq vy cv cT cfv vy cv ch0o cfv
      wceq vy cv chil wcel vy cv cT cfv chil wcel vy cv cT cfv cno cfv cc0 cle
      wbr vy cv cT cfv c0v wceq wb chil chil vy cv cT cT lnopcon.1 lnopfi
      ffvelrni vy cv cT cfv chil wcel vy cv cT cfv cno cfv cc0 cle wbr vy cv cT
      cfv cno cfv cc0 cle wbr cc0 vy cv cT cfv cno cfv cle wbr wa vy cv cT cfv
      cno cfv cc0 wceq vy cv cT cfv c0v wceq vy cv cT cfv chil wcel cc0 vy cv
      cT cfv cno cfv cle wbr vy cv cT cfv cno cfv cc0 cle wbr vy cv cT cfv
      normge0 biantrud vy cv cT cfv chil wcel vy cv cT cfv cno cfv cr wcel vy
      cv cT cfv cno cfv cc0 wceq vy cv cT cfv cno cfv cc0 cle wbr cc0 vy cv cT
      cfv cno cfv cle wbr wa wb vy cv cT cfv normcl vy cv cT cfv cno cfv cr
      wcel cc0 cr wcel vy cv cT cfv cno cfv cc0 wceq vy cv cT cfv cno cfv cc0
      cle wbr cc0 vy cv cT cfv cno cfv cle wbr wa wb 0re vy cv cT cfv cno cfv
      cc0 letri3 mpan2 syl vy cv cT cfv norm-i 3bitr2d syl vy cv chil wcel vy
      cv ch0o cfv c0v vy cv cT cfv vy cv ho0val eqeq2d bitr4d ralbiia vy cv cT
      cfv vy cv ch0o cfv wceq vy chil wral cT ch0o cco cT ch0o wceq vy cv cT
      cfv vy cv ch0o cfv wceq vy chil wral cT chil wfn ch0o chil wfn cT ch0o
      wceq vy cv cT cfv vy cv ch0o cfv wceq vy chil wral wb chil chil cT wf cT
      chil wfn cT lnopcon.1 lnopfi chil chil cT ffn ax-mp chil chil ch0o wf
      ch0o chil wfn ho0f chil chil ch0o ffn ax-mp vy chil cT ch0o eqfnfv2 mp2an
      biimpri 0cnop syl6eqel sylbi syl6bi vy cv c0v wceq vy chil wral vy cv cT
      cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa vy cv c0v
      wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr wa vy chil
      wral vy cv cT cfv cno cfv vx cv cc0 cmul co cle wbr vy chil wral vy cv
      c0v wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      r19.26 vy cv c0v wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co
      cle wbr wa vy cv cT cfv cno cfv vx cv cc0 cmul co cle wbr vy chil vy cv
      c0v wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy cv
      cT cfv cno cfv vx cv cc0 cmul co cle wbr vy cv c0v wceq vx cv vy cv cno
      cfv cmul co vx cv cc0 cmul co vy cv cT cfv cno cfv cle vy cv c0v wceq vy
      cv cno cfv cc0 vx cv cmul vy cv c0v wceq vy cv cno cfv c0v cno cfv cc0 vy
      cv c0v cno fveq2 norm0 syl6eq opreq2d breq2d biimpa r19.20si sylbir syl5
      exp3a com12 r19.23adv sylbi pm2.61i impbii $.
      $( [13-Apr-2006] $) $( [7-Feb-2006] $)
  $}

  ${
    $d x y T $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is
       linear.  Theorem 3.5(iii) of [Beran] p. 99. $)
    lnopcon $p |- ( T e. LinOp -> ( T e. ConOp <->
   E. x e. RR A. y e. ~H ( normh ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) ) $=
      cT clo wcel cT cco wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral vx cr wrex wb cT clo wcel cT cid chil cres cif cco
      wcel vy cv cT clo wcel cT cid chil cres cif cfv cno cfv vx cv vy cv cno
      cfv cmul co cle wbr vy chil wral vx cr wrex wb cT cid chil cres cT cT clo
      wcel cT cid chil cres cif wceq cT cco wcel cT clo wcel cT cid chil cres
      cif cco wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vx cr wrex vy cv cT clo wcel cT cid chil cres cif cfv cno cfv
      vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx cr wrex cT cT clo
      wcel cT cid chil cres cif cco eleq1 cT cT clo wcel cT cid chil cres cif
      wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vy cv cT clo wcel cT cid chil cres cif cfv cno cfv vx cv vy cv cno
      cfv cmul co cle wbr vy chil wral vx cr cT cT clo wcel cT cid chil cres
      cif wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy cv
      cT clo wcel cT cid chil cres cif cfv cno cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil cT cT clo wcel cT cid chil cres cif wceq vy cv cT cfv cno
      cfv vy cv cT clo wcel cT cid chil cres cif cfv cno cfv vx cv vy cv cno
      cfv cmul co cle cT cT clo wcel cT cid chil cres cif wceq vy cv cT cfv vy
      cv cT clo wcel cT cid chil cres cif cfv cno vy cv cT cT clo wcel cT cid
      chil cres cif fveq1 fveq2d breq1d ralbidv rexbidv bibi12d vx vy cT clo
      wcel cT cid chil cres cif cT cid chil cres clo idlnop elimel lnopconi
      dedth $.
      $( [13-Apr-2006] $) $( [14-Feb-2006] $)

    $( A linear operator is continuous iff it is bounded. $)
    lnopcnbd $p |- ( T e. LinOp -> ( T e. ConOp <-> T e. BndLinOp ) ) $=
      cT clo wcel cT cco wcel cT cbo wcel cT clo wcel cT cco wcel cT cnop cfv
      cr wcel cT cbo wcel cT clo wcel cT cco wcel cT cnop cfv cr wcel cT
      nmcopex ex cT cbo wcel cT clo wcel cT cnop cfv cr wcel cT elbdop2 baibr
      sylibd cT clo wcel cT cco wcel vy cv cT cfv cno cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral vx cr wrex cT cbo wcel vx vy cT lnopcon cT
      cnop cfv cr wcel vy cv cT cfv cno cfv cT cnop cfv vy cv cno cfv cmul co
      cle wbr vy chil wral vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral vx cr wrex cT cbo wcel vy cv cT cfv cno cfv vx cv vy cv
      cno cfv cmul co cle wbr vy chil wral vy cv cT cfv cno cfv cT cnop cfv vy
      cv cno cfv cmul co cle wbr vy chil wral vx cT cnop cfv cr vx cv cT cnop
      cfv wceq vy cv cT cfv cno cfv vx cv vy cv cno cfv cmul co cle wbr vy cv
      cT cfv cno cfv cT cnop cfv vy cv cno cfv cmul co cle wbr vy chil vx cv cT
      cnop cfv wceq vx cv vy cv cno cfv cmul co cT cnop cfv vy cv cno cfv cmul
      co vy cv cT cfv cno cfv cle vx cv cT cnop cfv vy cv cno cfv cmul opreq1
      breq2d ralbidv rcla4ev cT nmopre cT cbo wcel vy cv cT cfv cno cfv cT cnop
      cfv vy cv cno cfv cmul co cle wbr vy chil vy cv cT nmbdoplb r19.21aiva
      sylanc syl5bir impbid $.
      $( [13-Apr-2006] $) $( [14-Feb-2006] $)
  $}

  $( A continuous linear operator is a bounded linear operator.  This theorem
     justifies our use of "bounded linear" as an interchangeable
     condition for "continuous linear" used in some textbook proofs. $)
  lncnopbd $p |- ( T e. ( LinOp i^i ConOp ) <-> T e. BndLinOp ) $=
    cT clo cco cin wcel cT clo wcel cT cco wcel wa cT cbo wcel cT clo cco elin
    cT clo wcel cT cco wcel wa cT cbo wcel cT clo wcel cT cco wcel cT cbo wcel
    cT lnopcnbd biimpa cT cbo wcel cT clo wcel cT cco wcel cT bdopln cT cbo
    wcel cT clo wcel cT cco wcel cT bdopln cT clo wcel cT cco wcel cT cbo wcel
    cT lnopcnbd biimparc mpdan jca impbii bitri $.
    $( [13-Apr-2006] $) $( [18-Feb-2006] $)

  $( A continuous linear operator is a bounded linear operator. $)
  lncnbd $p |- ( LinOp i^i ConOp ) = BndLinOp $=
    vt clo cco cin cbo vt cv lncnopbd eqriv $.
    $( [13-Apr-2006] $) $( [18-Feb-2006] $)

  $( A linear operator is continuous iff it is bounded. $)
  lnopcnre $p |- ( T e. LinOp -> ( T e. ConOp <-> ( normop ` T ) e. RR ) ) $=
    cT clo wcel cT cco wcel cT cbo wcel cT cnop cfv cr wcel cT lnopcnbd cT cbo
    wcel cT clo wcel cT cnop cfv cr wcel cT elbdop2 baib bitrd $.
    $( [3-Oct-2006] $) $( [14-Feb-2006] $)

  ${
    $d x y z T $.
    lnfnl.1 $e |- T e. LinFn $.
    $( Basic property of a linear Hilbert space functional. $)
    lnfnli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A x. ( T ` B ) ) + ( T ` C ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel cA cB csm co cC cva co cT cfv cA cB
      cT cfv cmul co cC cT cfv caddc co wceq cT clf wcel cA cc wcel cB chil
      wcel cC chil wcel wa cA cB csm co cC cva co cT cfv cA cB cT cfv cmul co
      cC cT cfv caddc co wceq lnfnl.1 cA cB cC cT lnfnl mpanl1 3impb $.
      $( [16-Apr-2006] $) $( [11-Feb-2006] $)

    $( A linear Hilbert space functional is a functional. $)
    lnfnfi $p |- T : ~H --> CC $=
      cT clf wcel chil cc cT wf lnfnl.1 cT lnfnf ax-mp $.
      $( [16-Apr-2006] $) $( [11-Feb-2006] $)

    $( The value of a linear Hilbert space functional at zero is zero.  Remark
       in [Beran] p. 99. $)
    lnfn0i $p |- ( T ` 0h ) = 0 $=
      c0v cT cfv c0v cT cfv cmin co c0v cT cfv c0v cT cfv caddc co c0v cT cfv
      cmin co cc0 c0v cT cfv c0v cT cfv c0v cT cfv c0v cT cfv caddc co c0v cT
      cfv cmin c1 c0v csm co c0v cva co cT cfv c1 c0v cT cfv cmul co c0v cT cfv
      caddc co c0v cT cfv c0v cT cfv c0v cT cfv caddc co c1 cc wcel c0v chil
      wcel c0v chil wcel c1 c0v csm co c0v cva co cT cfv c1 c0v cT cfv cmul co
      c0v cT cfv caddc co wceq ax1cn ax-hv0cl ax-hv0cl c1 c0v c0v cT lnfnl.1
      lnfnli mp3an c1 c0v csm co c0v cva co c0v cT c1 c0v csm co c0v cva co c1
      c0v csm co c0v c1 c0v csm co chil wcel c1 c0v csm co c0v cva co c1 c0v
      csm co wceq c1 c0v ax1cn ax-hv0cl hvmulcli c1 c0v csm co ax-hvaddid ax-mp
      c0v chil wcel c1 c0v csm co c0v wceq ax-hv0cl c0v ax-hvmulid ax-mp eqtri
      fveq2i c1 c0v cT cfv cmul co c0v cT cfv c0v cT cfv caddc c0v cT cfv c0v
      chil wcel c0v cT cfv cc wcel ax-hv0cl chil cc c0v cT cT lnfnl.1 lnfnfi
      ffvelrni ax-mp mulid2i opreq1i 3eqtr3i opreq1i c0v cT cfv c0v chil wcel
      c0v cT cfv cc wcel ax-hv0cl chil cc c0v cT cT lnfnl.1 lnfnfi ffvelrni
      ax-mp subidi c0v cT cfv cc wcel c0v cT cfv cc wcel c0v cT cfv c0v cT cfv
      caddc co c0v cT cfv cmin co c0v cT cfv wceq c0v chil wcel c0v cT cfv cc
      wcel ax-hv0cl chil cc c0v cT cT lnfnl.1 lnfnfi ffvelrni ax-mp c0v chil
      wcel c0v cT cfv cc wcel ax-hv0cl chil cc c0v cT cT lnfnl.1 lnfnfi
      ffvelrni ax-mp c0v cT cfv c0v cT cfv pncan mp2an 3eqtr3ri $.
      $( [17-Apr-2006] $) $( [11-Feb-2006] $)

    $( Additive property of a linear Hilbert space functional. $)
    lnfnaddi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A +h B ) ) = ( ( T ` A ) + ( T ` B ) ) ) $=
      cA chil wcel cB chil wcel wa c1 cA csm co cB cva co cT cfv c1 cA cT cfv
      cmul co cB cT cfv caddc co cA cB cva co cT cfv cA cT cfv cB cT cfv caddc
      co c1 cc wcel cA chil wcel cB chil wcel c1 cA csm co cB cva co cT cfv c1
      cA cT cfv cmul co cB cT cfv caddc co wceq ax1cn c1 cA cB cT lnfnl.1
      lnfnli mp3an1 cA chil wcel c1 cA csm co cB cva co cT cfv cA cB cva co cT
      cfv wceq cB chil wcel cA chil wcel c1 cA csm co cB cva co cA cB cva co cT
      cA chil wcel c1 cA csm co cA cB cva cA ax-hvmulid opreq1d fveq2d adantr
      cA chil wcel cB chil wcel wa c1 cA cT cfv cmul co cA cT cfv cB cT cfv
      caddc cA chil wcel c1 cA cT cfv cmul co cA cT cfv wceq cB chil wcel cA
      chil wcel cA cT cfv cc wcel c1 cA cT cfv cmul co cA cT cfv wceq chil cc
      cA cT cT lnfnl.1 lnfnfi ffvelrni cA cT cfv mulid2 syl adantr opreq1d
      3eqtr3d $.
      $( [19-Apr-2006] $) $( [11-Feb-2006] $)

    $( Multiplicative property of a linear Hilbert space functional. $)
    lnfnmuli $p |- ( ( A e. CC /\ B e. ~H ) ->
         ( T ` ( A .h B ) ) = ( A x. ( T ` B ) ) ) $=
      cA cc wcel cB chil wcel wa cA cB csm co c0v cva co cT cfv cA cB cT cfv
      cmul co c0v cT cfv caddc co cA cB csm co cT cfv cA cB cT cfv cmul co cA
      cc wcel cB chil wcel c0v chil wcel cA cB csm co c0v cva co cT cfv cA cB
      cT cfv cmul co c0v cT cfv caddc co wceq ax-hv0cl cA cB c0v cT lnfnl.1
      lnfnli mp3an3 cA cc wcel cB chil wcel wa cA cB csm co c0v cva co cA cB
      csm co cT cA cc wcel cB chil wcel wa cA cB csm co chil wcel cA cB csm co
      c0v cva co cA cB csm co wceq cA cB hvmulcl cA cB csm co ax-hvaddid syl
      fveq2d cA cc wcel cB chil wcel wa cA cB cT cfv cmul co cc0 caddc co cA cB
      cT cfv cmul co cA cB cT cfv cmul co c0v cT cfv caddc co cA cc wcel cB
      chil wcel wa cA cB cT cfv cmul co cc wcel cA cB cT cfv cmul co cc0 caddc
      co cA cB cT cfv cmul co wceq cA cc wcel cB cT cfv cc wcel cA cB cT cfv
      cmul co cc wcel cB chil wcel cA cB cT cfv mulcl chil cc cB cT cT lnfnl.1
      lnfnfi ffvelrni sylan2 cA cB cT cfv cmul co addid1 syl c0v cT cfv cc0 cA
      cB cT cfv cmul co caddc cT lnfnl.1 lnfn0i opreq2i syl5eq 3eqtr3d $.
      $( [19-Apr-2006] $) $( [11-Feb-2006] $)

    $( Sum/product property of a linear Hilbert space functional. $)
    lnfnaddmuli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( B +h ( A .h C ) ) ) = ( ( T ` B ) + ( A x. ( T ` C ) ) ) ) $=
      cA cc wcel cB chil wcel cC chil wcel w3a cB cA cC csm co cva co cT cfv cB
      cT cfv cA cC csm co cT cfv caddc co cB cT cfv cA cC cT cfv cmul co caddc
      co cB chil wcel cA cc wcel cC chil wcel cB cA cC csm co cva co cT cfv cB
      cT cfv cA cC csm co cT cfv caddc co wceq cB chil wcel cA cc wcel cC chil
      wcel cB cA cC csm co cva co cT cfv cB cT cfv cA cC csm co cT cfv caddc co
      wceq cB chil wcel cA cC csm co chil wcel cB cA cC csm co cva co cT cfv cB
      cT cfv cA cC csm co cT cfv caddc co wceq cA cc wcel cC chil wcel wa cB cA
      cC csm co cT lnfnl.1 lnfnaddi cA cC hvmulcl sylan2 3impb 3com12 cA cc
      wcel cB chil wcel cC chil wcel w3a cA cC csm co cT cfv cA cC cT cfv cmul
      co cB cT cfv caddc cA cc wcel cC chil wcel cA cC csm co cT cfv cA cC cT
      cfv cmul co wceq cB chil wcel cA cC cT lnfnl.1 lnfnmuli 3adant2 opreq2d
      eqtrd $.
      $( [20-Apr-2006] $) $( [13-Feb-2006] $)

    $( Subtraction property for a linear Hilbert space functional. $)
    lnfnsubi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A -h B ) ) = ( ( T ` A ) - ( T ` B ) ) ) $=
      cA chil wcel cB chil wcel wa cA c1 cneg cB csm co cva co cT cfv cA cT cfv
      c1 cneg cB cT cfv cmul co caddc co cA cB cmv co cT cfv cA cT cfv cB cT
      cfv cmin co c1 cneg cc wcel cA chil wcel cB chil wcel cA c1 cneg cB csm
      co cva co cT cfv cA cT cfv c1 cneg cB cT cfv cmul co caddc co wceq c1
      ax1cn negcli c1 cneg cA cB cT lnfnl.1 lnfnaddmuli mp3an1 cA chil wcel cB
      chil wcel wa cA cB cmv co cA c1 cneg cB csm co cva co cT cA cB hvsubval
      fveq2d cA cT cfv cc wcel cB cT cfv cc wcel cA cT cfv cB cT cfv cmin co cA
      cT cfv c1 cneg cB cT cfv cmul co caddc co wceq cA chil wcel cB chil wcel
      cA cT cfv cc wcel cB cT cfv cc wcel wa cA cT cfv c1 cneg cB cT cfv cmul
      co caddc co cA cT cfv cB cT cfv cneg caddc co cA cT cfv cB cT cfv cmin co
      cB cT cfv cc wcel cA cT cfv c1 cneg cB cT cfv cmul co caddc co cA cT cfv
      cB cT cfv cneg caddc co wceq cA cT cfv cc wcel cB cT cfv cc wcel c1 cneg
      cB cT cfv cmul co cB cT cfv cneg cA cT cfv caddc cB cT cfv mulm1 opreq2d
      adantl cA cT cfv cB cT cfv negsub eqtr2d chil cc cA cT cT lnfnl.1 lnfnfi
      ffvelrni chil cc cB cT cT lnfnl.1 lnfnfi ffvelrni syl2an 3eqtr4d $.
      $( [20-Apr-2006] $) $( [13-Feb-2006] $)
  $}

  $( The value of a linear Hilbert space functional at zero is zero.  Remark
     in [Beran] p. 99. $)
  lnfn0 $p |- ( T e. LinFn -> ( T ` 0h ) = 0 ) $=
    cT clf wcel c0v cT cfv cc0 wceq c0v cT clf wcel cT chil cc0 csn cxp cif cfv
    cc0 wceq cT chil cc0 csn cxp cT cT clf wcel cT chil cc0 csn cxp cif wceq
    c0v cT cfv c0v cT clf wcel cT chil cc0 csn cxp cif cfv cc0 c0v cT cT clf
    wcel cT chil cc0 csn cxp cif fveq1 eqeq1d cT clf wcel cT chil cc0 csn cxp
    cif cT chil cc0 csn cxp clf 0lnfn elimel lnfn0i dedth $.
    $( [6-Nov-2006] $) $( [25-Apr-2006] $)

  $( Multiplicative property of a linear Hilbert space functional. $)
  lnfnmul $p |- ( ( T e. LinFn /\ A e. CC /\ B e. ~H ) ->
                 ( T ` ( A .h B ) ) = ( A x. ( T ` B ) ) ) $=
    cT clf wcel cA cc wcel cB chil wcel cA cB csm co cT cfv cA cB cT cfv cmul
    co wceq cT clf wcel cA cc wcel cB chil wcel wa cA cB csm co cT cfv cA cB cT
    cfv cmul co wceq wi cA cc wcel cB chil wcel wa cA cB csm co cT clf wcel cT
    chil cc0 csn cxp cif cfv cA cB cT clf wcel cT chil cc0 csn cxp cif cfv cmul
    co wceq wi cT chil cc0 csn cxp cT cT clf wcel cT chil cc0 csn cxp cif wceq
    cA cB csm co cT cfv cA cB cT cfv cmul co wceq cA cB csm co cT clf wcel cT
    chil cc0 csn cxp cif cfv cA cB cT clf wcel cT chil cc0 csn cxp cif cfv cmul
    co wceq cA cc wcel cB chil wcel wa cT cT clf wcel cT chil cc0 csn cxp cif
    wceq cA cB csm co cT cfv cA cB csm co cT clf wcel cT chil cc0 csn cxp cif
    cfv cA cB cT cfv cmul co cA cB cT clf wcel cT chil cc0 csn cxp cif cfv cmul
    co cA cB csm co cT cT clf wcel cT chil cc0 csn cxp cif fveq1 cT cT clf wcel
    cT chil cc0 csn cxp cif wceq cB cT cfv cB cT clf wcel cT chil cc0 csn cxp
    cif cfv cA cmul cB cT cT clf wcel cT chil cc0 csn cxp cif fveq1 opreq2d
    eqeq12d imbi2d cA cB cT clf wcel cT chil cc0 csn cxp cif cT chil cc0 csn
    cxp clf 0lnfn elimel lnfnmuli dedth 3impib $.
    $( [6-Jun-2006] $) $( [30-May-2006] $)

  ${
    nmbdfnlb.1 $e |- ( T e. LinFn /\ ( normfn ` T ) e. RR ) $.
    $( A lower bound for the norm of a bounded linear functional. $)
    nmbdfnlbi $p |- ( A e. ~H ->
                ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
      cA chil wcel cA c0v wceq cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul
      co cle wbr cA c0v wceq cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co
      cle wbr cA chil wcel cA c0v wceq cA cT cfv cabs cfv cc0 cT cnmf cfv cA
      cno cfv cmul co cle cA c0v wceq cA cT cfv cabs cfv cc0 cabs cfv cc0 cA
      c0v wceq cA cT cfv cc0 cabs cA c0v wceq cA cT cfv c0v cT cfv cc0 cA c0v
      cT fveq2 cT cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1 pm3.26i lnfn0i
      syl6eq fveq2d abs0 syl6eq cA c0v wceq cc0 cT cnmf cfv cA cno cfv cmul co
      cc0 cle cA c0v wceq cT cnmf cfv cA cno cfv cmul co cT cnmf cfv cc0 cmul
      co cc0 cA c0v wceq cA cno cfv cc0 cT cnmf cfv cmul cA c0v wceq cA cno cfv
      c0v cno cfv cc0 cA c0v cno fveq2 norm0 syl6eq opreq2d cT cnmf cfv cT cnmf
      cfv cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1 pm3.27i recni mul01i
      syl6req cc0 0re leidi syl5breq eqbrtrd adantl cA chil wcel cA c0v wne cA
      cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co cle wbr cA c0v wceq wn cA
      chil wcel cA c0v wne wa cA cT cfv cabs cfv cA cno cfv cdiv co cT cnmf cfv
      cle wbr cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co cle wbr cA chil
      wcel cA c0v wne wa cA cT cfv cabs cfv cA cno cfv cdiv co c1 cA cno cfv
      cdiv co cA csm co cT cfv cabs cfv cT cnmf cfv cle cA chil wcel cA c0v wne
      wa cA cT cfv cabs cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA cT cfv
      cabs cfv cmul co c1 cA cno cfv cdiv co cA csm co cT cfv cabs cfv cA cT
      cfv cabs cfv cc wcel cA cno cfv cc wcel cA cno cfv cc0 wne cA cT cfv cabs
      cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA cT cfv cabs cfv cmul co
      wceq cA chil wcel cA c0v wne wa cA cT cfv cabs cfv cA cno cfv divrec2 cA
      chil wcel cA c0v wne wa cA cT cfv cabs cfv cA chil wcel cA cT cfv cabs
      cfv cr wcel cA c0v wne cA chil wcel cA cT cfv cc wcel cA cT cfv cabs cfv
      cr wcel chil cc cA cT cT cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1
      pm3.26i lnfnfi ffvelrni cA cT cfv abscl syl adantr recnd cA chil wcel cA
      c0v wne wa cA cno cfv cA chil wcel cA cno cfv cr wcel cA c0v wne cA
      normcl adantr recnd cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
      biimpar syl3anc cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm
      co cT cfv cabs cfv c1 cA cno cfv cdiv co cA cT cfv cmul co cabs cfv c1 cA
      cno cfv cdiv co cabs cfv cA cT cfv cabs cfv cmul co c1 cA cno cfv cdiv co
      cA cT cfv cabs cfv cmul co cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv
      co cA csm co cT cfv c1 cA cno cfv cdiv co cA cT cfv cmul co cabs c1 cA
      cno cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co cT
      cfv c1 cA cno cfv cdiv co cA cT cfv cmul co wceq cA chil wcel cA c0v wne
      wa c1 cA cno cfv cdiv co cA cT cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1
      pm3.26i lnfnmuli cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno
      cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel
      cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v
      wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA
      normne0 biimpar sylanc recnd cA chil wcel cA c0v wne pm3.26 sylanc fveq2d
      c1 cA cno cfv cdiv co cc wcel cA cT cfv cc wcel c1 cA cno cfv cdiv co cA
      cT cfv cmul co cabs cfv c1 cA cno cfv cdiv co cabs cfv cA cT cfv cabs cfv
      cmul co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cT cfv
      absmul cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cr
      wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v
      wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA
      normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
      biimpar sylanc recnd cA chil wcel cA cT cfv cc wcel cA c0v wne chil cc cA
      cT cT cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1 pm3.26i lnfnfi ffvelrni
      adantr sylanc cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cabs cfv
      c1 cA cno cfv cdiv co cA cT cfv cabs cfv cmul c1 cA cno cfv cdiv co cr
      wcel cc0 c1 cA cno cfv cdiv co cle wbr c1 cA cno cfv cdiv co cabs cfv c1
      cA cno cfv cdiv co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co
      absid cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel
      cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr
      wcel cA c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v
      wne cA normne0 biimpar sylanc c1 cA cno cfv cdiv co cr wcel cc0 c1 cA cno
      cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr cA chil wcel cA c0v
      wne wa cc0 cr wcel c1 cA cno cfv cdiv co cr wcel cc0 c1 cA cno cfv cdiv
      co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr wi 0re cc0 c1 cA cno cfv
      cdiv co ltle mpan cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv
      cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil
      wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno
      cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA cno cfv cr wcel cc0
      cA cno cfv clt wbr cc0 c1 cA cno cfv cdiv co clt wbr cA chil wcel cA c0v
      wne wa cA cno cfv recgt0 cA chil wcel cA cno cfv cr wcel cA c0v wne cA
      normcl adantr cA chil wcel cA c0v wne cc0 cA cno cfv clt wbr cA normgt0
      biimpa sylanc sylc sylanc opreq1d 3eqtrrd eqtrd c1 cA cno cfv cdiv co cA
      csm co chil wcel c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr c1 cA
      cno cfv cdiv co cA csm co cT cfv cabs cfv cT cnmf cfv cle wbr cA chil
      wcel cA c0v wne wa chil cc cT wf c1 cA cno cfv cdiv co cA csm co chil
      wcel c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr c1 cA cno cfv
      cdiv co cA csm co cT cfv cabs cfv cT cnmf cfv cle wbr cT cT clf wcel cT
      cnmf cfv cr wcel nmbdfnlb.1 pm3.26i lnfnfi c1 cA cno cfv cdiv co cA csm
      co cT nmfnlb mp3an1 c1 cA cno cfv cdiv co cc wcel cA chil wcel c1 cA cno
      cfv cdiv co cA csm co chil wcel cA chil wcel cA c0v wne wa c1 cA cno cfv
      cdiv co cA hvmulcl cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA
      cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil
      wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA
      c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA
      normne0 biimpar sylanc recnd cA chil wcel cA c0v wne pm3.26 sylanc c1 cA
      cno cfv cdiv co cA csm co cno cfv cr wcel c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 wceq c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr cA
      chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co cno cfv c1 eqle
      cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co chil wcel c1
      cA cno cfv cdiv co cA csm co cno cfv cr wcel c1 cA cno cfv cdiv co cc
      wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co chil wcel cA chil wcel
      cA c0v wne wa c1 cA cno cfv cdiv co cA hvmulcl cA chil wcel cA c0v wne wa
      c1 cA cno cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv
      cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil
      wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno
      cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc recnd cA chil wcel cA
      c0v wne pm3.26 sylanc c1 cA cno cfv cdiv co cA csm co normcl syl cA norm1
      sylanc sylanc eqbrtrd cA cT cfv cabs cfv cr wcel cA cno cfv cr wcel cT
      cnmf cfv cr wcel w3a cc0 cA cno cfv clt wbr cA cT cfv cabs cfv cA cno cfv
      cdiv co cT cnmf cfv cle wbr cA cT cfv cabs cfv cT cnmf cfv cA cno cfv
      cmul co cle wbr wb cA chil wcel cA c0v wne wa cA cT cfv cabs cfv cA cno
      cfv cT cnmf cfv ledivmul2OLD cA chil wcel cA c0v wne wa cA cT cfv cabs
      cfv cr wcel cA cno cfv cr wcel cT cnmf cfv cr wcel cA chil wcel cA cT cfv
      cabs cfv cr wcel cA c0v wne cA chil wcel cA cT cfv cc wcel cA cT cfv cabs
      cfv cr wcel chil cc cA cT cT cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1
      pm3.26i lnfnfi ffvelrni cA cT cfv abscl syl adantr cA chil wcel cA cno
      cfv cr wcel cA c0v wne cA normcl adantr cT cnmf cfv cr wcel cA chil wcel
      cA c0v wne wa cT clf wcel cT cnmf cfv cr wcel nmbdfnlb.1 pm3.27i a1i 3jca
      cA chil wcel cA c0v wne cc0 cA cno cfv clt wbr cA normgt0 biimpa sylanc
      mpbid cA c0v df-ne sylan2br pm2.61dan $.
      $( [4-May-2006] $) $( [25-Apr-2006] $)
  $}

  $( A lower bound for the norm of a bounded linear functional. $)
  nmbdfnlb $p |- ( ( T e. LinFn /\ ( normfn ` T ) e. RR /\ A e. ~H ) ->
              ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
    cT clf wcel cT cnmf cfv cr wcel cA chil wcel cA cT cfv cabs cfv cT cnmf cfv
    cA cno cfv cmul co cle wbr cT clf wcel cT cnmf cfv cr wcel wa cA chil wcel
    cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co cle wbr wi cA chil wcel
    cA cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif cfv cabs cfv
    cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif cnmf cfv cA cno
    cfv cmul co cle wbr wi cT chil cc0 csn cxp cT cT clf wcel cT cnmf cfv cr
    wcel wa cT chil cc0 csn cxp cif wceq cA cT cfv cabs cfv cT cnmf cfv cA cno
    cfv cmul co cle wbr cA cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn
    cxp cif cfv cabs cfv cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp
    cif cnmf cfv cA cno cfv cmul co cle wbr cA chil wcel cT cT clf wcel cT cnmf
    cfv cr wcel wa cT chil cc0 csn cxp cif wceq cA cT cfv cabs cfv cA cT clf
    wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif cfv cabs cfv cT cnmf
    cfv cA cno cfv cmul co cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn
    cxp cif cnmf cfv cA cno cfv cmul co cle cT cT clf wcel cT cnmf cfv cr wcel
    wa cT chil cc0 csn cxp cif wceq cA cT cfv cA cT clf wcel cT cnmf cfv cr
    wcel wa cT chil cc0 csn cxp cif cfv cabs cA cT cT clf wcel cT cnmf cfv cr
    wcel wa cT chil cc0 csn cxp cif fveq1 fveq2d cT cT clf wcel cT cnmf cfv cr
    wcel wa cT chil cc0 csn cxp cif wceq cT cnmf cfv cT clf wcel cT cnmf cfv cr
    wcel wa cT chil cc0 csn cxp cif cnmf cfv cA cno cfv cmul cT cT clf wcel cT
    cnmf cfv cr wcel wa cT chil cc0 csn cxp cif cnmf fveq2 opreq1d breq12d
    imbi2d cA cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif cT clf
    wcel cT cnmf cfv cr wcel wa cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0
    csn cxp cif clf wcel cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp
    cif cnmf cfv cr wcel wa chil cc0 csn cxp clf wcel chil cc0 csn cxp cnmf cfv
    cr wcel wa cT chil cc0 csn cxp cT cT clf wcel cT cnmf cfv cr wcel wa cT
    chil cc0 csn cxp cif wceq cT clf wcel cT clf wcel cT cnmf cfv cr wcel wa cT
    chil cc0 csn cxp cif clf wcel cT cnmf cfv cr wcel cT clf wcel cT cnmf cfv
    cr wcel wa cT chil cc0 csn cxp cif cnmf cfv cr wcel cT cT clf wcel cT cnmf
    cfv cr wcel wa cT chil cc0 csn cxp cif clf eleq1 cT cT clf wcel cT cnmf cfv
    cr wcel wa cT chil cc0 csn cxp cif wceq cT cnmf cfv cT clf wcel cT cnmf cfv
    cr wcel wa cT chil cc0 csn cxp cif cnmf cfv cr cT cT clf wcel cT cnmf cfv
    cr wcel wa cT chil cc0 csn cxp cif cnmf fveq2 eleq1d anbi12d chil cc0 csn
    cxp cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif wceq chil
    cc0 csn cxp clf wcel cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp
    cif clf wcel chil cc0 csn cxp cnmf cfv cr wcel cT clf wcel cT cnmf cfv cr
    wcel wa cT chil cc0 csn cxp cif cnmf cfv cr wcel chil cc0 csn cxp cT clf
    wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif clf eleq1 chil cc0 csn
    cxp cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp cif wceq chil
    cc0 csn cxp cnmf cfv cT clf wcel cT cnmf cfv cr wcel wa cT chil cc0 csn cxp
    cif cnmf cfv cr chil cc0 csn cxp cT clf wcel cT cnmf cfv cr wcel wa cT chil
    cc0 csn cxp cif cnmf fveq2 eleq1d anbi12d chil cc0 csn cxp clf wcel chil
    cc0 csn cxp cnmf cfv cr wcel 0lnfn chil cc0 csn cxp cnmf cfv cc0 cr nmfn0
    0re eqeltri pm3.2i elimhyp nmbdfnlbi dedth 3impia $.
    $( [4-May-2006] $) $( [25-Apr-2006] $)

  ${
    $d k x M $.  $d k x y z T $.  $d n x y z T $.
    nmcfnex.1 $e |- T e. LinFn $.
    nmcfnex.2 $e |- T e. ConFn $.
    $( Lemma for ~ nmcfnexi .  Show a condition for the norm of a functional to
       exist, based on its definition and the properties of supremum.  Compared
       to Beran, we use a direct proof instead of a proof by contradiction. $)
    nmcfnexlem1 $p |- ( ( n e. NN /\ A. x e. ~H ( ( normh ` x ) <_ 1 ->
                  -. n < ( abs ` ( T ` x ) ) ) ) -> ( normfn ` T ) e. RR ) $=
      vn cv cn wcel vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt
      wbr wn wi vx chil wral wa cT cnmf cfv cpnf wne cT cnmf cfv cr wcel vn cv
      cn wcel vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt wbr wn
      wi vx chil wral cT cnmf cfv cpnf wne vn cv cn wcel vx cv cno cfv c1 cle
      wbr vn cv vx cv cT cfv cabs cfv clt wbr wn wi vx chil wral cT cnmf cfv
      cpnf vn cv cn wcel cT cnmf cfv cpnf wceq vx cv cno cfv c1 cle wbr vn cv
      vx cv cT cfv cabs cfv clt wbr wa vx chil wrex vx cv cno cfv c1 cle wbr vn
      cv vx cv cT cfv cabs cfv clt wbr wn wi vx chil wral wn vn cv cn wcel cT
      cnmf cfv cpnf wceq vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv
      clt wbr wa vx chil wrex vn cv cn wcel cT cnmf cfv cpnf wceq wa vn cv vy
      cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq
      wa vx chil wrex vz cab wrex vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv
      cabs cfv clt wbr wa vx chil wrex vn cv cr wcel vn cv vy cv clt wbr vy vx
      cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz
      cab wrex vn cr wral vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv
      vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab wrex vn cv cn wcel cT
      cnmf cfv cpnf wceq vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv
      vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab wrex vn cr wral vn cv
      cr wcel vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT
      cfv cabs cfv wceq wa vx chil wrex vz cab wrex vn cv vy cv clt wbr vy vx
      cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz
      cab wrex vn cr ra4 impcom vn cv nnre cT cnmf cfv cpnf wceq vn cv vy cv
      clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa
      vx chil wrex vz cab wrex vn cr wral vx cv cno cfv c1 cle wbr vz cv vx cv
      cT cfv cabs cfv wceq wa vx chil wrex vz cab cxr wss cT cnmf cfv cpnf wceq
      vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs
      cfv wceq wa vx chil wrex vz cab wrex vn cr wral wb vx cv cno cfv c1 cle
      wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab cr cxr chil
      cc cT wf vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx
      chil wrex vz cab cr wss cT nmcfnex.1 lnfnfi vz vx cT nmfnsetre ax-mp
      ressxr sstri vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa
      vx chil wrex vz cab cxr wss vn cv vy cv clt wbr vy vx cv cno cfv c1 cle
      wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab wrex vn cr
      wral vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil
      wrex vz cab cxr clt csup cpnf wceq cT cnmf cfv cpnf wceq vn vy vx cv cno
      cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab
      supxrunb2 cT cnmf cfv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs
      cfv wceq wa vx chil wrex vz cab cxr clt csup cpnf chil cc cT wf cT cnmf
      cfv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil
      wrex vz cab cxr clt csup wceq cT nmcfnex.1 lnfnfi vz vx cT nmfnval ax-mp
      eqeq1i syl6rbbr ax-mp biimpi syl2an vx cv cno cfv c1 cle wbr vn cv vx cv
      cT cfv cabs cfv clt wbr wa vx chil wrex vy cv vx cv cno cfv c1 cle wbr vz
      cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab wcel vn cv vy cv clt
      wbr wa vy wex vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv
      cT cfv cabs cfv wceq wa vx chil wrex vz cab wrex vx cv cno cfv c1 cle wbr
      vy cv vx cv cT cfv cabs cfv wceq wa vn cv vy cv clt wbr wa vy wex vx chil
      wrex vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq wa vn cv
      vy cv clt wbr wa vx chil wrex vy wex vx cv cno cfv c1 cle wbr vn cv vx cv
      cT cfv cabs cfv clt wbr wa vx chil wrex vy cv vx cv cno cfv c1 cle wbr vz
      cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz cab wcel vn cv vy cv clt
      wbr wa vy wex vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq
      wa vn cv vy cv clt wbr wa vx vy chil rexcom4 vx cv cno cfv c1 cle wbr vn
      cv vx cv cT cfv cabs cfv clt wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv
      cT cfv cabs cfv wceq wa vn cv vy cv clt wbr wa vy wex vx chil vx cv cno
      cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq vn cv vy cv clt wbr wa wa
      vy wex vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq vn cv vy
      cv clt wbr wa vy wex wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs
      cfv wceq wa vn cv vy cv clt wbr wa vy wex vx cv cno cfv c1 cle wbr vn cv
      vx cv cT cfv cabs cfv clt wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv cT
      cfv cabs cfv wceq vn cv vy cv clt wbr wa vy 19.42v vx cv cno cfv c1 cle
      wbr vy cv vx cv cT cfv cabs cfv wceq vn cv vy cv clt wbr wa wa vx cv cno
      cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq wa vn cv vy cv clt wbr wa
      vy vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq wa vn cv vy
      cv clt wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq
      vn cv vy cv clt wbr wa wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv
      cabs cfv wceq vn cv vy cv clt wbr anass bicomi exbii vy cv vx cv cT cfv
      cabs cfv wceq vn cv vy cv clt wbr wa vy wex vn cv vx cv cT cfv cabs cfv
      clt wbr vx cv cno cfv c1 cle wbr vn cv vy cv clt wbr vn cv vx cv cT cfv
      cabs cfv clt wbr vy vx cv cT cfv cabs cfv vx cv cT cfv cabs fvex vy cv vx
      cv cT cfv cabs cfv vn cv clt breq2 ceqsexv anbi2i 3bitr3ri rexbii vy cv
      vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex
      vz cab wcel vn cv vy cv clt wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv
      cT cfv cabs cfv wceq wa vn cv vy cv clt wbr wa vx chil wrex vy vy cv vx
      cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz
      cab wcel vn cv vy cv clt wbr wa vx cv cno cfv c1 cle wbr vy cv vx cv cT
      cfv cabs cfv wceq wa vx chil wrex vn cv vy cv clt wbr wa vx cv cno cfv c1
      cle wbr vy cv vx cv cT cfv cabs cfv wceq wa vn cv vy cv clt wbr wa vx
      chil wrex vy cv vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv wceq
      wa vx chil wrex vz cab wcel vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv
      cabs cfv wceq wa vx chil wrex vn cv vy cv clt wbr vx cv cno cfv c1 cle
      wbr vz cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vx cv cno cfv c1 cle
      wbr vy cv vx cv cT cfv cabs cfv wceq wa vx chil wrex vz vy cv vy visset
      vz cv vy cv wceq vx cv cno cfv c1 cle wbr vz cv vx cv cT cfv cabs cfv
      wceq wa vx cv cno cfv c1 cle wbr vy cv vx cv cT cfv cabs cfv wceq wa vx
      chil vz cv vy cv wceq vz cv vx cv cT cfv cabs cfv wceq vy cv vx cv cT cfv
      cabs cfv wceq vx cv cno cfv c1 cle wbr vz cv vy cv vx cv cT cfv cabs cfv
      eqeq1 anbi2d rexbidv elab anbi1i vx cv cno cfv c1 cle wbr vy cv vx cv cT
      cfv cabs cfv wceq wa vn cv vy cv clt wbr vx chil r19.41v bitr4i exbii
      3bitr4i vn cv vy cv clt wbr vy vx cv cno cfv c1 cle wbr vz cv vx cv cT
      cfv cabs cfv wceq wa vx chil wrex vz cab df-rex bitr4i sylibr ex vx cv
      cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt wbr wa vx chil wrex vx
      cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt wbr wn wi wn vx
      chil wrex vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt wbr wn
      wi vx chil wral wn vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv
      clt wbr wa vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt wbr
      wn wi wn vx chil vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt
      wbr df-an rexbii vx cv cno cfv c1 cle wbr vn cv vx cv cT cfv cabs cfv clt
      wbr wn wi vx chil rexnal bitri syl6ib necon2ad imp chil cc cT wf cT cnmf
      cfv cr wcel cT cnmf cfv cpnf wne wb cT nmcfnex.1 lnfnfi cT nmfnrepnf
      ax-mp sylibr $.
      $( [19-Apr-2006] $) $( [14-Feb-2006] $)

    $( Lemma for ~ nmcfnexi .  Apply definition of continuity.  Note that we
       use 1 instead of 0.5 that Beran uses for epsilon (e = 0.5 in his
       proof). $)
    nmcfnexlem2 $p |- E. y e. RR ( 0 < y /\
             A. z e. ~H ( ( normh ` z ) < y -> ( abs ` ( T ` z ) ) < 1 ) ) $=
      cc0 vy cv clt wbr vz cv c0v cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v
      cT cfv cmin co cabs cfv c1 clt wbr wi vz chil wral wa vy cr wrex cc0 vy
      cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr
      wi vz chil wral wa vy cr wrex cT ccnf wcel c0v chil wcel wa c1 cr wcel
      cc0 c1 clt wbr wa cc0 vy cv clt wbr vz cv c0v cmv co cno cfv vy cv clt
      wbr vz cv cT cfv c0v cT cfv cmin co cabs cfv c1 clt wbr wi vz chil wral
      wa vy cr wrex cT ccnf wcel c0v chil wcel nmcfnex.2 ax-hv0cl pm3.2i c1 cr
      wcel cc0 c1 clt wbr 1re lt01 pm3.2i vy vz c0v c1 cT cnfnc mp2an cc0 vy cv
      clt wbr vz cv c0v cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v cT cfv
      cmin co cabs cfv c1 clt wbr wi vz chil wral wa cc0 vy cv clt wbr vz cv
      cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral wa
      vy cr vz cv c0v cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v cT cfv cmin
      co cabs cfv c1 clt wbr wi vz chil wral vz cv cno cfv vy cv clt wbr vz cv
      cT cfv cabs cfv c1 clt wbr wi vz chil wral cc0 vy cv clt wbr vz cv c0v
      cmv co cno cfv vy cv clt wbr vz cv cT cfv c0v cT cfv cmin co cabs cfv c1
      clt wbr wi vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr
      wi vz chil vz cv chil wcel vz cv c0v cmv co cno cfv vy cv clt wbr vz cv
      cno cfv vy cv clt wbr vz cv cT cfv c0v cT cfv cmin co cabs cfv c1 clt wbr
      vz cv cT cfv cabs cfv c1 clt wbr vz cv chil wcel vz cv c0v cmv co cno cfv
      vz cv cno cfv vy cv clt vz cv chil wcel vz cv c0v cmv co vz cv cno vz cv
      hvsub0 fveq2d breq1d vz cv chil wcel vz cv cT cfv c0v cT cfv cmin co cabs
      cfv vz cv cT cfv cabs cfv c1 clt vz cv chil wcel vz cv cT cfv c0v cT cfv
      cmin co vz cv cT cfv cabs vz cv chil wcel vz cv cT cfv cc0 cmin co vz cv
      cT cfv vz cv cT cfv c0v cT cfv cmin co vz cv chil wcel vz cv cT cfv cc
      wcel vz cv cT cfv cc0 cmin co vz cv cT cfv wceq chil cc vz cv cT cT
      nmcfnex.1 lnfnfi ffvelrni vz cv cT cfv subid1 syl c0v cT cfv cc0 vz cv cT
      cfv cmin cT nmcfnex.1 lnfn0i opreq2i syl5eq fveq2d breq1d imbi12d ralbiia
      anbi2i rexbii mpbi $.
      $( [20-Apr-2006] $) $( [14-Feb-2006] $)

    $( Lemma for ~ nmcfnexi .  Move ` 1 / n ` out of the norm, using
       linearity. $)
    nmcfnexlem3 $p |- ( ( n e. NN /\ x e. ~H ) -> ( ( abs ` ( T ` x ) ) < n
             <-> ( abs ` ( T ` ( ( 1 / n ) .h x ) ) ) < 1 ) ) $=
      vn cv cn wcel vx cv chil wcel wa vx cv cT cfv cabs cfv vn cv clt wbr c1
      vn cv cdiv co vx cv cT cfv cabs cfv cmul co c1 vn cv cdiv co vn cv cmul
      co clt wbr c1 vn cv cdiv co vx cv csm co cT cfv cabs cfv c1 clt wbr vx cv
      cT cfv cabs cfv cr wcel vn cv cr wcel c1 vn cv cdiv co cr wcel w3a cc0 c1
      vn cv cdiv co clt wbr vx cv cT cfv cabs cfv vn cv clt wbr c1 vn cv cdiv
      co vx cv cT cfv cabs cfv cmul co c1 vn cv cdiv co vn cv cmul co clt wbr
      wb vn cv cn wcel vx cv chil wcel wa vx cv cT cfv cabs cfv vn cv c1 vn cv
      cdiv co ltmul2OLD vn cv cn wcel vx cv chil wcel wa vx cv cT cfv cabs cfv
      cr wcel vn cv cr wcel c1 vn cv cdiv co cr wcel vx cv chil wcel vx cv cT
      cfv cabs cfv cr wcel vn cv cn wcel vx cv chil wcel vx cv cT cfv cc wcel
      vx cv cT cfv cabs cfv cr wcel chil cc vx cv cT cT nmcfnex.1 lnfnfi
      ffvelrni vx cv cT cfv abscl syl adantl vn cv cn wcel vn cv cr wcel vx cv
      chil wcel vn cv nnre adantr vn cv cn wcel c1 vn cv cdiv co cr wcel vx cv
      chil wcel vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn
      wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc adantr 3jca vn cv cn
      wcel cc0 c1 vn cv cdiv co clt wbr vx cv chil wcel vn cv nnrecgt0 adantr
      sylanc vn cv cn wcel vx cv chil wcel wa c1 vn cv cdiv co vx cv cT cfv
      cabs cfv cmul co c1 vn cv cdiv co vx cv csm co cT cfv cabs cfv c1 vn cv
      cdiv co vn cv cmul co c1 clt vn cv cn wcel vx cv chil wcel wa c1 vn cv
      cdiv co vx cv csm co cT cfv cabs cfv c1 vn cv cdiv co vx cv cT cfv cmul
      co cabs cfv c1 vn cv cdiv co cabs cfv vx cv cT cfv cabs cfv cmul co c1 vn
      cv cdiv co vx cv cT cfv cabs cfv cmul co vn cv cn wcel vx cv chil wcel wa
      c1 vn cv cdiv co vx cv csm co cT cfv c1 vn cv cdiv co vx cv cT cfv cmul
      co cabs c1 vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv
      csm co cT cfv c1 vn cv cdiv co vx cv cT cfv cmul co wceq vn cv cn wcel c1
      vn cv cdiv co vx cv cT nmcfnex.1 lnfnmuli vn cv cn wcel c1 vn cv cdiv co
      vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
      rereccl vn cv nnre vn cv nnne0 sylanc recnd sylan fveq2d c1 vn cv cdiv co
      cc wcel vx cv cT cfv cc wcel c1 vn cv cdiv co vx cv cT cfv cmul co cabs
      cfv c1 vn cv cdiv co cabs cfv vx cv cT cfv cabs cfv cmul co wceq vn cv cn
      wcel vx cv chil wcel c1 vn cv cdiv co vx cv cT cfv absmul vn cv cn wcel
      c1 vn cv cdiv co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn
      cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd chil cc vx
      cv cT cT nmcfnex.1 lnfnfi ffvelrni syl2an vn cv cn wcel vx cv chil wcel
      wa c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co vx cv cT cfv cabs cfv cmul
      vn cv cn wcel c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co wceq vx cv chil
      wcel c1 vn cv cdiv co cr wcel cc0 c1 vn cv cdiv co cle wbr c1 vn cv cdiv
      co cabs cfv c1 vn cv cdiv co wceq vn cv cn wcel c1 vn cv cdiv co absid vn
      cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
      rereccl vn cv nnre vn cv nnne0 sylanc c1 vn cv cdiv co cr wcel cc0 c1 vn
      cv cdiv co clt wbr cc0 c1 vn cv cdiv co cle wbr vn cv cn wcel cc0 cr wcel
      c1 vn cv cdiv co cr wcel cc0 c1 vn cv cdiv co clt wbr cc0 c1 vn cv cdiv
      co cle wbr wi 0re cc0 c1 vn cv cdiv co ltle mpan vn cv cr wcel vn cv cc0
      wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv
      nnne0 sylanc vn cv nnrecgt0 sylc sylanc adantr opreq1d 3eqtrrd vn cv cn
      wcel c1 vn cv cdiv co vn cv cmul co c1 wceq vx cv chil wcel vn cv cc wcel
      vn cv cc0 wne c1 vn cv cdiv co vn cv cmul co c1 wceq vn cv cn wcel vn cv
      recid2 vn cv nncn vn cv nnne0 sylanc adantr breq12d bitrd $.
      $( [21-Apr-2006] $) $( [14-Feb-2006] $)

    ${
      nmcfnexlem4.3 $e |- A = { k e. NN | ( 1 / k ) < y } $.
      nmcfnexlem4.4 $e |- M = sup ( A , RR , `' < ) $.
      $( Lemma for ~ nmcfnexi .  Properties of the infimum of the collection of
         integers whose reciprocals are less than the delta of the continuity
         definition. $)
      nmcfnexlem4 $p |- ( ( y e. RR /\ 0 < y ) ->
                        ( M e. NN /\ ( 1 / M ) < y ) ) $=
        vy cv cr wcel cc0 vy cv clt wbr wa cM c1 vk cv cdiv co vy cv clt wbr vk
        cn crab wcel cM cn wcel c1 cM cdiv co vy cv clt wbr wa vy cv cr wcel
        cc0 vy cv clt wbr wa cA cr clt ccnv csup c1 vk cv cdiv co vy cv clt wbr
        vk cn crab cM vy cv cr wcel cc0 vy cv clt wbr wa cA cr clt ccnv csup cA
        c1 vk cv cdiv co vy cv clt wbr vk cn crab vy cv cr wcel cc0 vy cv clt
        wbr wa cA c0 wne cA cr clt ccnv csup cA wcel vy cv cr wcel cc0 vy cv
        clt wbr wa c1 vk cv cdiv co vy cv clt wbr vk cn crab c0 wne cA c0 wne
        vy cv cr wcel cc0 vy cv clt wbr wa c1 vk cv cdiv co vy cv clt wbr vk cn
        wrex c1 vk cv cdiv co vy cv clt wbr vk cn crab c0 wne vy cv vk nnrecl
        c1 vk cv cdiv co vy cv clt wbr vk cn rabn0 sylibr cA c1 vk cv cdiv co
        vy cv clt wbr vk cn crab c0 nmcfnexlem4.3 neeq1i sylibr cA c1 cuz cfv
        wss cA c0 wne cA cr clt ccnv csup cA wcel cA cn c1 cuz cfv cA c1 vk cv
        cdiv co vy cv clt wbr vk cn crab cn nmcfnexlem4.3 c1 vk cv cdiv co vy
        cv clt wbr vk cn ssrab2 eqsstri nnuz sseqtri cA c1 infmssuzcl mpan syl
        nmcfnexlem4.3 syl6eleq nmcfnexlem4.4 syl5eqel c1 vk cv cdiv co vy cv
        clt wbr c1 cM cdiv co vy cv clt wbr vk cM cn vk cv cM wceq c1 vk cv
        cdiv co c1 cM cdiv co vy cv clt vk cv cM c1 cdiv opreq2 breq1d elrab
        sylib $.
        $( [20-Apr-2006] $) $( [14-Feb-2006] $)

      $( Lemma for ~ nmcfnexi . $)
      nmcfnexlem5 $p |- ( ( ( y e. RR /\ 0 < y ) /\ ( n e. NN /\ M <_ n ) /\
                        ( x e. ~H /\ ( normh ` x ) <_ 1 ) ) ->
                        ( normh ` ( ( 1 / n ) .h x ) ) < y ) $=
        vy cv cr wcel cc0 vy cv clt wbr wa vn cv cn wcel cM vn cv cle wbr wa vx
        cv chil wcel vx cv cno cfv c1 cle wbr wa w3a c1 vn cv cdiv co vx cv csm
        co cno cfv c1 cM cdiv co vy cv vn cv cn wcel cM vn cv cle wbr wa vx cv
        chil wcel vx cv cno cfv c1 cle wbr wa c1 vn cv cdiv co vx cv csm co cno
        cfv cr wcel vy cv cr wcel cc0 vy cv clt wbr wa vn cv cn wcel vx cv chil
        wcel c1 vn cv cdiv co vx cv csm co cno cfv cr wcel cM vn cv cle wbr vx
        cv cno cfv c1 cle wbr vn cv cn wcel vx cv chil wcel wa c1 vn cv cdiv co
        vx cv csm co chil wcel c1 vn cv cdiv co vx cv csm co cno cfv cr wcel c1
        vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv csm co
        chil wcel vn cv cn wcel c1 vn cv cdiv co vx cv hvmulcl vn cv cn wcel c1
        vn cv cdiv co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn
        cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd sylan c1
        vn cv cdiv co vx cv csm co normcl syl ad2ant2r 3adant1 vy cv cr wcel
        cc0 vy cv clt wbr wa vn cv cn wcel cM vn cv cle wbr wa c1 cM cdiv co cr
        wcel vx cv chil wcel vx cv cno cfv c1 cle wbr wa vy cv cr wcel cc0 vy
        cv clt wbr wa cM cn wcel c1 cM cdiv co cr wcel vy cv cr wcel cc0 vy cv
        clt wbr wa cM cn wcel c1 cM cdiv co vy cv clt wbr vy cA cT vk cM
        nmcfnex.1 nmcfnex.2 nmcfnexlem4.3 nmcfnexlem4.4 nmcfnexlem4 pm3.26d cM
        cr wcel cM cc0 wne c1 cM cdiv co cr wcel cM cn wcel cM rereccl cM nnre
        cM nnne0 sylanc syl 3ad2ant1 vy cv cr wcel cc0 vy cv clt wbr wa vn cv
        cn wcel cM vn cv cle wbr wa vy cv cr wcel vx cv chil wcel vx cv cno cfv
        c1 cle wbr wa vy cv cr wcel cc0 vy cv clt wbr pm3.26 3ad2ant1 cM cn
        wcel vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1
        cle wbr wa c1 vn cv cdiv co vx cv csm co cno cfv c1 cM cdiv co cle wbr
        vy cv cr wcel cc0 vy cv clt wbr wa cM cn wcel vn cv cn wcel cM vn cv
        cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa w3a c1 vn cv
        cdiv co vx cv csm co cno cfv c1 vn cv cdiv co c1 cM cdiv co vn cv cn
        wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa c1
        vn cv cdiv co vx cv csm co cno cfv cr wcel cM cn wcel vn cv cn wcel vx
        cv chil wcel c1 vn cv cdiv co vx cv csm co cno cfv cr wcel cM vn cv cle
        wbr vx cv cno cfv c1 cle wbr vn cv cn wcel vx cv chil wcel wa c1 vn cv
        cdiv co vx cv csm co chil wcel c1 vn cv cdiv co vx cv csm co cno cfv cr
        wcel c1 vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv
        csm co chil wcel vn cv cn wcel c1 vn cv cdiv co vx cv hvmulcl vn cv cn
        wcel c1 vn cv cdiv co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr
        wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd
        sylan c1 vn cv cdiv co vx cv csm co normcl syl ad2ant2r 3adant1 vn cv
        cn wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa
        c1 vn cv cdiv co cr wcel cM cn wcel vn cv cn wcel c1 vn cv cdiv co cr
        wcel cM vn cv cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vn cv
        cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
        rereccl vn cv nnre vn cv nnne0 sylanc ad2antrr 3adant1 cM cn wcel vn cv
        cn wcel cM vn cv cle wbr wa c1 cM cdiv co cr wcel vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa cM cr wcel cM cc0 wne c1 cM cdiv co cr wcel cM cn
        wcel cM rereccl cM nnre cM nnne0 sylanc 3ad2ant1 cM cn wcel vn cv cn
        wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa
        w3a c1 vn cv cdiv co vx cv cno cfv cmul co c1 vn cv cdiv co c1 cmul co
        c1 vn cv cdiv co vx cv csm co cno cfv c1 vn cv cdiv co cle vx cv cno
        cfv cr wcel c1 cr wcel c1 vn cv cdiv co cr wcel w3a cc0 c1 vn cv cdiv
        co cle wbr vx cv cno cfv c1 cle wbr wa c1 vn cv cdiv co vx cv cno cfv
        cmul co c1 vn cv cdiv co c1 cmul co cle wbr cM cn wcel vn cv cn wcel cM
        vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa w3a vx cv
        cno cfv c1 c1 vn cv cdiv co lemul2aOLD cM cn wcel vn cv cn wcel cM vn
        cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa w3a vx cv cno
        cfv cr wcel c1 cr wcel c1 vn cv cdiv co cr wcel cM cn wcel vx cv chil
        wcel vx cv cno cfv c1 cle wbr wa vx cv cno cfv cr wcel vn cv cn wcel cM
        vn cv cle wbr wa vx cv chil wcel vx cv cno cfv cr wcel cM cn wcel vx cv
        cno cfv c1 cle wbr vx cv normcl ad2antrl 3adant2 c1 cr wcel cM cn wcel
        vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle
        wbr wa w3a 1re a1i vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel vx
        cv cno cfv c1 cle wbr wa c1 vn cv cdiv co cr wcel cM cn wcel vn cv cn
        wcel c1 vn cv cdiv co cr wcel cM vn cv cle wbr vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr
        wcel vn cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc ad2antrr
        3adant1 3jca cM cn wcel vn cv cn wcel cM vn cv cle wbr wa vx cv chil
        wcel vx cv cno cfv c1 cle wbr wa w3a cc0 c1 vn cv cdiv co cle wbr vx cv
        cno cfv c1 cle wbr cM cn wcel vn cv cn wcel cM vn cv cle wbr wa cc0 c1
        vn cv cdiv co cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vn cv
        cn wcel cc0 c1 vn cv cdiv co cle wbr cM cn wcel cM vn cv cle wbr vn cv
        cr wcel cc0 vn cv clt wbr cc0 c1 vn cv cdiv co cle wbr vn cv cn wcel c1
        cr wcel cc0 c1 cle wbr vn cv cr wcel cc0 vn cv clt wbr wa cc0 c1 vn cv
        cdiv co cle wbr 1re cc0 c1 0re 1re lt01 ltleii c1 vn cv divge0 mpanl12
        vn cv nnre vn cv nngt0 sylanc ad2antrl 3adant3 vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa cM cn wcel vx cv cno cfv c1 cle wbr vn cv cn wcel
        cM vn cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr pm3.27
        3ad2ant3 jca sylanc vn cv cn wcel cM vn cv cle wbr wa vx cv chil wcel
        vx cv cno cfv c1 cle wbr wa c1 vn cv cdiv co vx cv cno cfv cmul co c1
        vn cv cdiv co vx cv csm co cno cfv wceq cM cn wcel vn cv cn wcel vx cv
        chil wcel c1 vn cv cdiv co vx cv cno cfv cmul co c1 vn cv cdiv co vx cv
        csm co cno cfv wceq cM vn cv cle wbr vx cv cno cfv c1 cle wbr vn cv cn
        wcel vx cv chil wcel wa c1 vn cv cdiv co vx cv csm co cno cfv c1 vn cv
        cdiv co cabs cfv vx cv cno cfv cmul co c1 vn cv cdiv co vx cv cno cfv
        cmul co c1 vn cv cdiv co cc wcel vx cv chil wcel c1 vn cv cdiv co vx cv
        csm co cno cfv c1 vn cv cdiv co cabs cfv vx cv cno cfv cmul co wceq vn
        cv cn wcel c1 vn cv cdiv co vx cv norm-iii vn cv cn wcel c1 vn cv cdiv
        co vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel
        vn cv rereccl vn cv nnre vn cv nnne0 sylanc recnd sylan vn cv cn wcel
        vx cv chil wcel wa c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co vx cv cno
        cfv cmul vn cv cn wcel c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co wceq
        vx cv chil wcel c1 vn cv cdiv co cr wcel cc0 c1 vn cv cdiv co cle wbr
        c1 vn cv cdiv co cabs cfv c1 vn cv cdiv co wceq vn cv cn wcel c1 vn cv
        cdiv co absid vn cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn
        cv cn wcel vn cv rereccl vn cv nnre vn cv nnne0 sylanc vn cv cr wcel
        cc0 vn cv clt wbr cc0 c1 vn cv cdiv co cle wbr vn cv cn wcel c1 cr wcel
        cc0 c1 cle wbr vn cv cr wcel cc0 vn cv clt wbr wa cc0 c1 vn cv cdiv co
        cle wbr 1re cc0 c1 0re 1re lt01 ltleii c1 vn cv divge0 mpanl12 vn cv
        nnre vn cv nngt0 sylanc sylanc adantr opreq1d eqtr2d ad2ant2r 3adant1
        cM cn wcel vn cv cn wcel cM vn cv cle wbr wa c1 vn cv cdiv co c1 cmul
        co c1 vn cv cdiv co wceq vx cv chil wcel vx cv cno cfv c1 cle wbr wa vn
        cv cn wcel c1 vn cv cdiv co c1 cmul co c1 vn cv cdiv co wceq cM cn wcel
        cM vn cv cle wbr vn cv cn wcel c1 vn cv cdiv co cc wcel c1 vn cv cdiv
        co c1 cmul co c1 vn cv cdiv co wceq vn cv cn wcel c1 vn cv cdiv co vn
        cv cr wcel vn cv cc0 wne c1 vn cv cdiv co cr wcel vn cv cn wcel vn cv
        rereccl vn cv nnre vn cv nnne0 sylanc recnd c1 vn cv cdiv co ax1id syl
        ad2antrl 3adant3 3brtr3d cM cn wcel vn cv cn wcel cM vn cv cle wbr wa
        c1 vn cv cdiv co c1 cM cdiv co cle wbr vx cv chil wcel vx cv cno cfv c1
        cle wbr wa cM cn wcel vn cv cn wcel cM vn cv cle wbr c1 vn cv cdiv co
        c1 cM cdiv co cle wbr cM cn wcel vn cv cn wcel wa cM vn cv cle wbr c1
        vn cv cdiv co c1 cM cdiv co cle wbr cM cr wcel cc0 cM clt wbr wa vn cv
        cr wcel cc0 vn cv clt wbr wa cM vn cv cle wbr c1 vn cv cdiv co c1 cM
        cdiv co cle wbr wb cM cn wcel vn cv cn wcel cM vn cv lerec cM cn wcel
        cM cr wcel cc0 cM clt wbr cM nnre cM nngt0 jca vn cv cn wcel vn cv cr
        wcel cc0 vn cv clt wbr vn cv nnre vn cv nngt0 jca syl2an biimpa anasss
        3adant3 letrd vy cv cr wcel cc0 vy cv clt wbr wa cM cn wcel c1 cM cdiv
        co vy cv clt wbr vy cA cT vk cM nmcfnex.1 nmcfnex.2 nmcfnexlem4.3
        nmcfnexlem4.4 nmcfnexlem4 pm3.26d syl3an1 vy cv cr wcel cc0 vy cv clt
        wbr wa vn cv cn wcel cM vn cv cle wbr wa c1 cM cdiv co vy cv clt wbr vx
        cv chil wcel vx cv cno cfv c1 cle wbr wa vy cv cr wcel cc0 vy cv clt
        wbr wa cM cn wcel c1 cM cdiv co vy cv clt wbr vy cA cT vk cM nmcfnex.1
        nmcfnex.2 nmcfnexlem4.3 nmcfnexlem4.4 nmcfnexlem4 pm3.27d 3ad2ant1
        lelttrd $.
        $( [20-Apr-2006] $) $( [14-Feb-2006] $)

      $( Lemma for ~ nmcfnexi .  Combine lemmas to obtain the result (with
         hypotheses to be eliminated). $)
      nmcfnexlem6 $p |- ( normfn ` T ) e. RR $=
        cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1
        clt wbr wi vz chil wral wa vy cr wrex cT cnmf cfv cr wcel vy vz cT
        nmcfnex.1 nmcfnex.2 nmcfnexlem2 cc0 vy cv clt wbr vz cv cno cfv vy cv
        clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral wa cT cnmf cfv
        cr wcel vy cr vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt
        wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral wa cM cn wcel cT
        cnmf cfv cr wcel vy cv cr wcel cc0 vy cv clt wbr cM cn wcel vz cv cno
        cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral vy
        cv cr wcel cc0 vy cv clt wbr cM cn wcel vy cv cr wcel cc0 vy cv clt wbr
        wa cM cn wcel c1 cM cdiv co vy cv clt wbr vy cA cT vk cM nmcfnex.1
        nmcfnex.2 nmcfnexlem4.3 nmcfnexlem4.4 nmcfnexlem4 pm3.26d ex adantrd vy
        cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv
        cabs cfv c1 clt wbr wi vz chil wral wa cM cn wcel cT cnmf cfv cr wcel
        wi vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT
        cfv cabs cfv c1 clt wbr wi vz chil wral wa wa cM vk cv cle wbr vk cn
        wrex cT cnmf cfv cr wcel cM cn wcel vy cv cr wcel cc0 vy cv clt wbr vz
        cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil
        wral wa wa cM vk cv cle wbr cT cnmf cfv cr wcel vk cn vy cv cr wcel cc0
        vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt
        wbr wi vz chil wral wa wa vk cv cn wcel cM vk cv cle wbr cT cnmf cfv cr
        wcel vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv
        cT cfv cabs cfv c1 clt wbr wi vz chil wral wa wa vk cv cn wcel cM vk cv
        cle wbr wa wa vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv cabs cfv clt
        wbr wn wi vx chil wral cT cnmf cfv cr wcel vy cv cr wcel cc0 vy cv clt
        wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz
        chil wral wa wa vk cv cn wcel cM vk cv cle wbr wa wa vx cv cno cfv c1
        cle wbr vk cv vx cv cT cfv cabs cfv clt wbr wn wi vx chil vy cv cr wcel
        cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1
        clt wbr wi vz chil wral wa wa vk cv cn wcel cM vk cv cle wbr wa vx cv
        chil wcel vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv cabs cfv clt wbr
        wn wi wi vy cv cr wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz
        cv cT cfv cabs cfv c1 clt wbr wi vz chil wral vk cv cn wcel cM vk cv
        cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr vk cv vx cv cT cfv
        cabs cfv clt wbr wn wi wi wi vy cv cr wcel cc0 vy cv clt wbr wa vz cv
        cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral
        wa vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv c1
        cle wbr vk cv vx cv cT cfv cabs cfv clt wbr wn vy cv cr wcel cc0 vy cv
        clt wbr wa vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr
        wi vz chil wral vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv
        cno cfv c1 cle wbr wa wa vk cv vx cv cT cfv cabs cfv clt wbr wn wi vy
        cv cr wcel cc0 vy cv clt wbr wa vk cv cn wcel cM vk cv cle wbr wa vx cv
        chil wcel vx cv cno cfv c1 cle wbr wa wa vz cv cno cfv vy cv clt wbr vz
        cv cT cfv cabs cfv c1 clt wbr wi vz chil wral vk cv vx cv cT cfv cabs
        cfv clt wbr wn vy cv cr wcel cc0 vy cv clt wbr wa vk cv cn wcel cM vk
        cv cle wbr wa vx cv chil wcel vx cv cno cfv c1 cle wbr wa wa vz cv cno
        cfv vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral vk
        cv vx cv cT cfv cabs cfv clt wbr wn wi vy cv cr wcel cc0 vy cv clt wbr
        wa vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv c1
        cle wbr wa wa wa vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1
        clt wbr wi vz chil wral c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt
        wbr vk cv vx cv cT cfv cabs cfv clt wbr wn vy cv cr wcel cc0 vy cv clt
        wbr wa vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx cv cno cfv
        c1 cle wbr wa c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr vx vy
        cA cT vk vk cM nmcfnex.1 nmcfnex.2 nmcfnexlem4.3 nmcfnexlem4.4
        nmcfnexlem5 3expb vk cv cn wcel cM vk cv cle wbr wa vx cv chil wcel vx
        cv cno cfv c1 cle wbr wa wa vz cv cno cfv vy cv clt wbr vz cv cT cfv
        cabs cfv c1 clt wbr wi vz chil wral c1 vk cv cdiv co vx cv csm co cno
        cfv vy cv clt wbr vk cv vx cv cT cfv cabs cfv clt wbr wn wi wi vy cv cr
        wcel cc0 vy cv clt wbr wa vk cv cn wcel vx cv chil wcel vz cv cno cfv
        vy cv clt wbr vz cv cT cfv cabs cfv c1 clt wbr wi vz chil wral c1 vk cv
        cdiv co vx cv csm co cno cfv vy cv clt wbr vk cv vx cv cT cfv cabs cfv
        clt wbr wn wi wi cM vk cv cle wbr vx cv cno cfv c1 cle wbr vk cv cn
        wcel vx cv chil wcel wa vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs
        cfv c1 clt wbr wi vz chil wral c1 vk cv cdiv co vx cv csm co cno cfv vy
        cv clt wbr c1 vk cv cdiv co vx cv csm co cT cfv cabs cfv c1 clt wbr vk
        cv vx cv cT cfv cabs cfv clt wbr wn vk cv cn wcel vx cv chil wcel wa c1
        vk cv cdiv co vx cv csm co chil wcel vz cv cno cfv vy cv clt wbr vz cv
        cT cfv cabs cfv c1 clt wbr wi vz chil wral c1 vk cv cdiv co vx cv csm
        co cno cfv vy cv clt wbr c1 vk cv cdiv co vx cv csm co cT cfv cabs cfv
        c1 clt wbr wi wi c1 vk cv cdiv co cc wcel vx cv chil wcel c1 vk cv cdiv
        co vx cv csm co chil wcel vk cv cn wcel c1 vk cv cdiv co vx cv hvmulcl
        vk cv cn wcel c1 vk cv cdiv co vk cv cr wcel vk cv cc0 wne c1 vk cv
        cdiv co cr wcel vk cv cn wcel vk cv rereccl vk cv nnre vk cv nnne0
        sylanc recnd sylan vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs cfv c1
        clt wbr wi c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr c1 vk cv
        cdiv co vx cv csm co cT cfv cabs cfv c1 clt wbr wi vz c1 vk cv cdiv co
        vx cv csm co chil vz cv c1 vk cv cdiv co vx cv csm co wceq vz cv cno
        cfv vy cv clt wbr c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt wbr
        vz cv cT cfv cabs cfv c1 clt wbr c1 vk cv cdiv co vx cv csm co cT cfv
        cabs cfv c1 clt wbr vz cv c1 vk cv cdiv co vx cv csm co wceq vz cv cno
        cfv c1 vk cv cdiv co vx cv csm co cno cfv vy cv clt vz cv c1 vk cv cdiv
        co vx cv csm co cno fveq2 breq1d vz cv c1 vk cv cdiv co vx cv csm co
        wceq vz cv cT cfv cabs cfv c1 vk cv cdiv co vx cv csm co cT cfv cabs
        cfv c1 clt vz cv c1 vk cv cdiv co vx cv csm co wceq vz cv cT cfv c1 vk
        cv cdiv co vx cv csm co cT cfv cabs vz cv c1 vk cv cdiv co vx cv csm co
        cT fveq2 fveq2d breq1d imbi12d rcla4v syl vk cv cn wcel vx cv chil wcel
        wa c1 vk cv cdiv co vx cv csm co cT cfv cabs cfv c1 clt wbr vx cv cT
        cfv cabs cfv vk cv clt wbr vk cv vx cv cT cfv cabs cfv clt wbr wn vx cT
        vk nmcfnex.1 nmcfnex.2 nmcfnexlem3 vx cv chil wcel vk cv cn wcel vx cv
        cT cfv cabs cfv vk cv clt wbr vk cv vx cv cT cfv cabs cfv clt wbr wn wi
        vx cv cT cfv cabs cfv cr wcel vk cv cr wcel vx cv cT cfv cabs cfv vk cv
        clt wbr vk cv vx cv cT cfv cabs cfv clt wbr wn wi vx cv chil wcel vk cv
        cn wcel vx cv cT cfv cabs cfv vk cv ltnsym vx cv chil wcel vx cv cT cfv
        cc wcel vx cv cT cfv cabs cfv cr wcel chil cc vx cv cT cT nmcfnex.1
        lnfnfi ffvelrni vx cv cT cfv abscl syl vk cv nnre syl2an ancoms sylbird
        syl6d ad2ant2r adantl mpid ex com23 imp exp4d anasss imp r19.21aiv vk
        cv cn wcel cM vk cv cle wbr wa vx cv cno cfv c1 cle wbr vk cv vx cv cT
        cfv cabs cfv clt wbr wn wi vx chil wral cT cnmf cfv cr wcel vy cv cr
        wcel cc0 vy cv clt wbr vz cv cno cfv vy cv clt wbr vz cv cT cfv cabs
        cfv c1 clt wbr wi vz chil wral wa wa vk cv cn wcel vx cv cno cfv c1 cle
        wbr vk cv vx cv cT cfv cabs cfv clt wbr wn wi vx chil wral cT cnmf cfv
        cr wcel cM vk cv cle wbr vx cT vk nmcfnex.1 nmcfnex.2 nmcfnexlem1
        adantlr adantll mpdan exp32 r19.23adv cM cn wcel cM cM cle wbr cM vk cv
        cle wbr vk cn wrex cM cn wcel cM cr wcel cM cM cle wbr cM nnre cM leid
        syl cM vk cv cle wbr cM cM cle wbr vk cM cn vk cv cM cM cle breq2
        rcla4ev mpdan syl5 ex mpdd r19.23aiv ax-mp $.
        $( [21-Apr-2006] $) $( [14-Feb-2006] $)
    $}

    $( The norm of a continuous linear Hilbert space functional exists.
       Theorem 3.5(i) of [Beran] p. 99. $)
    nmcfnexi $p |- ( normfn ` T ) e. RR $=
      vy c1 vk cv cdiv co vy cv clt wbr vk cn crab cT vk c1 vz cv cdiv co vy cv
      clt wbr vz cn crab cr clt ccnv csup nmcfnex.1 nmcfnex.2 c1 vk cv cdiv co
      vy cv clt wbr vk cn crab eqid c1 vz cv cdiv co vy cv clt wbr vz cn crab
      c1 vk cv cdiv co vy cv clt wbr vk cn crab wceq c1 vz cv cdiv co vy cv clt
      wbr vz cn crab cr clt ccnv csup c1 vk cv cdiv co vy cv clt wbr vk cn crab
      cr clt ccnv csup wceq c1 vz cv cdiv co vy cv clt wbr c1 vk cv cdiv co vy
      cv clt wbr vz vk cn vz cv vk cv wceq c1 vz cv cdiv co c1 vk cv cdiv co vy
      cv clt vz cv vk cv c1 cdiv opreq2 breq1d cbvrabv cr c1 vz cv cdiv co vy
      cv clt wbr vz cn crab c1 vk cv cdiv co vy cv clt wbr vk cn crab clt ccnv
      supeq1 ax-mp nmcfnexlem6 $.
      $( [21-Apr-2006] $) $( [14-Feb-2006] $)

    $( A lower bound for the norm of a continuous linear functional.  Theorem
       3.5(ii) of [Beran] p. 99. $)
    nmcfnlbi $p |- ( A e. ~H ->
                ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
      cA chil wcel cA c0v wceq cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul
      co cle wbr cA c0v wceq cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co
      cle wbr cA chil wcel cA c0v wceq cA cT cfv cabs cfv cc0 cT cnmf cfv cA
      cno cfv cmul co cle cA c0v wceq cA cT cfv cabs cfv cc0 cabs cfv cc0 cA
      c0v wceq cA cT cfv cc0 cabs cA c0v wceq cA cT cfv c0v cT cfv cc0 cA c0v
      cT fveq2 cT nmcfnex.1 lnfn0i syl6eq fveq2d abs0 syl6eq cA c0v wceq cc0 cT
      cnmf cfv cA cno cfv cmul co cc0 cle cA c0v wceq cT cnmf cfv cA cno cfv
      cmul co cT cnmf cfv cc0 cmul co cc0 cA c0v wceq cA cno cfv cc0 cT cnmf
      cfv cmul cA c0v wceq cA cno cfv c0v cno cfv cc0 cA c0v cno fveq2 norm0
      syl6eq opreq2d cT cnmf cfv cT cnmf cfv cT nmcfnex.1 nmcfnex.2 nmcfnexi
      recni mul01i syl6req cc0 0re leidi syl5breq eqbrtrd adantl cA chil wcel
      cA c0v wceq wn wa cA cT cfv cabs cfv cA cno cfv cdiv co cT cnmf cfv cle
      wbr cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co cle wbr cA chil
      wcel cA c0v wceq wn wa cA cT cfv cabs cfv cA cno cfv cdiv co c1 cA cno
      cfv cdiv co cA csm co cT cfv cabs cfv cT cnmf cfv cle cA chil wcel cA c0v
      wceq wn wa cA cT cfv cabs cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA
      cT cfv cabs cfv cmul co c1 cA cno cfv cdiv co cA csm co cT cfv cabs cfv
      cA cT cfv cabs cfv cc wcel cA cno cfv cc wcel cA cno cfv cc0 wne cA cT
      cfv cabs cfv cA cno cfv cdiv co c1 cA cno cfv cdiv co cA cT cfv cabs cfv
      cmul co wceq cA chil wcel cA c0v wceq wn wa cA cT cfv cabs cfv cA cno cfv
      divrec2 cA chil wcel cA c0v wceq wn wa cA cT cfv cabs cfv cA chil wcel cA
      cT cfv cabs cfv cr wcel cA c0v wceq wn cA chil wcel cA cT cfv cc wcel cA
      cT cfv cabs cfv cr wcel chil cc cA cT cT nmcfnex.1 lnfnfi ffvelrni cA cT
      cfv abscl syl adantr recnd cA chil wcel cA c0v wceq wn wa cA cno cfv cA
      chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl adantr recnd cA
      chil wcel cA c0v wceq wn wa cA cno cfv cc0 wceq wn cA cno cfv cc0 wne cA
      chil wcel cA cno cfv cc0 wceq wn cA c0v wceq wn cA chil wcel cA cno cfv
      cc0 wceq cA c0v wceq cA norm-i notbid biimpar cA cno cfv cc0 df-ne sylibr
      syl3anc cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA csm co cT
      cfv cabs cfv c1 cA cno cfv cdiv co cA cT cfv cmul co cabs cfv c1 cA cno
      cfv cdiv co cabs cfv cA cT cfv cabs cfv cmul co c1 cA cno cfv cdiv co cA
      cT cfv cabs cfv cmul co cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv
      co cA csm co cT cfv c1 cA cno cfv cdiv co cA cT cfv cmul co cabs c1 cA
      cno cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co cT
      cfv c1 cA cno cfv cdiv co cA cT cfv cmul co wceq cA chil wcel cA c0v wceq
      wn wa c1 cA cno cfv cdiv co cA cT nmcfnex.1 lnfnmuli cA chil wcel cA c0v
      wceq wn wa c1 cA cno cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1
      cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wceq wn wa cA cno cfv
      rereccl cA chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl adantr
      cA chil wcel cA c0v wceq wn wa cA cno cfv cc0 wceq wn cA cno cfv cc0 wne
      cA chil wcel cA cno cfv cc0 wceq wn cA c0v wceq wn cA chil wcel cA cno
      cfv cc0 wceq cA c0v wceq cA norm-i notbid biimpar cA cno cfv cc0 df-ne
      sylibr sylanc recnd cA chil wcel cA c0v wceq wn pm3.26 sylanc fveq2d c1
      cA cno cfv cdiv co cc wcel cA cT cfv cc wcel c1 cA cno cfv cdiv co cA cT
      cfv cmul co cabs cfv c1 cA cno cfv cdiv co cabs cfv cA cT cfv cabs cfv
      cmul co wceq cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA cT
      cfv absmul cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cA cno
      cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel
      cA c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA
      c0v wceq wn cA normcl adantr cA chil wcel cA c0v wceq wn wa cA cno cfv
      cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv cc0 wceq wn cA c0v
      wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq cA norm-i notbid
      biimpar cA cno cfv cc0 df-ne sylibr sylanc recnd cA chil wcel cA cT cfv
      cc wcel cA c0v wceq wn chil cc cA cT cT nmcfnex.1 lnfnfi ffvelrni adantr
      sylanc cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co cabs cfv c1
      cA cno cfv cdiv co cA cT cfv cabs cfv cmul c1 cA cno cfv cdiv co cr wcel
      cc0 c1 cA cno cfv cdiv co cle wbr c1 cA cno cfv cdiv co cabs cfv c1 cA
      cno cfv cdiv co wceq cA chil wcel cA c0v wceq wn wa c1 cA cno cfv cdiv co
      absid cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr wcel
      cA chil wcel cA c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA cno cfv
      cr wcel cA c0v wceq wn cA normcl adantr cA chil wcel cA c0v wceq wn wa cA
      cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv cc0 wceq
      wn cA c0v wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq cA norm-i
      notbid biimpar cA cno cfv cc0 df-ne sylibr sylanc c1 cA cno cfv cdiv co
      cr wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle
      wbr cA chil wcel cA c0v wceq wn wa cc0 cr wcel c1 cA cno cfv cdiv co cr
      wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr
      wi 0re cc0 c1 cA cno cfv cdiv co ltle mpan cA cno cfv cr wcel cA cno cfv
      cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wceq wn wa cA
      cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl
      adantr cA chil wcel cA c0v wceq wn wa cA cno cfv cc0 wceq wn cA cno cfv
      cc0 wne cA chil wcel cA cno cfv cc0 wceq wn cA c0v wceq wn cA chil wcel
      cA cno cfv cc0 wceq cA c0v wceq cA norm-i notbid biimpar cA cno cfv cc0
      df-ne sylibr sylanc cA cno cfv cr wcel cc0 cA cno cfv clt wbr cc0 c1 cA
      cno cfv cdiv co clt wbr cA chil wcel cA c0v wceq wn wa cA cno cfv recgt0
      cA chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl adantr cA chil
      wcel cA c0v wceq wn cc0 cA cno cfv clt wbr cA normgt0OLD biimpa sylanc
      sylc sylanc opreq1d 3eqtrrd eqtrd c1 cA cno cfv cdiv co cA csm co chil
      wcel c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr c1 cA cno cfv
      cdiv co cA csm co cT cfv cabs cfv cT cnmf cfv cle wbr cA chil wcel cA c0v
      wceq wn wa chil cc cT wf c1 cA cno cfv cdiv co cA csm co chil wcel c1 cA
      cno cfv cdiv co cA csm co cno cfv c1 cle wbr c1 cA cno cfv cdiv co cA csm
      co cT cfv cabs cfv cT cnmf cfv cle wbr cT nmcfnex.1 lnfnfi c1 cA cno cfv
      cdiv co cA csm co cT nmfnlb mp3an1 c1 cA cno cfv cdiv co cc wcel cA chil
      wcel c1 cA cno cfv cdiv co cA csm co chil wcel cA chil wcel cA c0v wceq
      wn wa c1 cA cno cfv cdiv co cA hvmulcl cA chil wcel cA c0v wceq wn wa c1
      cA cno cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv
      cdiv co cr wcel cA chil wcel cA c0v wceq wn wa cA cno cfv rereccl cA chil
      wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl adantr cA chil wcel cA
      c0v wceq wn wa cA cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA
      cno cfv cc0 wceq wn cA c0v wceq wn cA chil wcel cA cno cfv cc0 wceq cA
      c0v wceq cA norm-i notbid biimpar cA cno cfv cc0 df-ne sylibr sylanc
      recnd cA chil wcel cA c0v wceq wn pm3.26 sylanc c1 cA cno cfv cdiv co cA
      csm co cno cfv cr wcel c1 cA cno cfv cdiv co cA csm co cno cfv c1 wceq c1
      cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr cA chil wcel cA c0v wceq
      wn wa c1 cA cno cfv cdiv co cA csm co cno cfv c1 eqle cA chil wcel cA c0v
      wceq wn wa c1 cA cno cfv cdiv co cA csm co chil wcel c1 cA cno cfv cdiv
      co cA csm co cno cfv cr wcel c1 cA cno cfv cdiv co cc wcel cA chil wcel
      c1 cA cno cfv cdiv co cA csm co chil wcel cA chil wcel cA c0v wceq wn wa
      c1 cA cno cfv cdiv co cA hvmulcl cA chil wcel cA c0v wceq wn wa c1 cA cno
      cfv cdiv co cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co
      cr wcel cA chil wcel cA c0v wceq wn wa cA cno cfv rereccl cA chil wcel cA
      cno cfv cr wcel cA c0v wceq wn cA normcl adantr cA chil wcel cA c0v wceq
      wn wa cA cno cfv cc0 wceq wn cA cno cfv cc0 wne cA chil wcel cA cno cfv
      cc0 wceq wn cA c0v wceq wn cA chil wcel cA cno cfv cc0 wceq cA c0v wceq
      cA norm-i notbid biimpar cA cno cfv cc0 df-ne sylibr sylanc recnd cA chil
      wcel cA c0v wceq wn pm3.26 sylanc c1 cA cno cfv cdiv co cA csm co normcl
      syl cA chil wcel cA c0v wne c1 cA cno cfv cdiv co cA csm co cno cfv c1
      wceq cA c0v wceq wn cA norm1 cA c0v df-ne sylan2br sylanc sylanc eqbrtrd
      cA cT cfv cabs cfv cr wcel cA cno cfv cr wcel cT cnmf cfv cr wcel w3a cc0
      cA cno cfv clt wbr cA cT cfv cabs cfv cA cno cfv cdiv co cT cnmf cfv cle
      wbr cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co cle wbr wb cA chil
      wcel cA c0v wceq wn wa cA cT cfv cabs cfv cA cno cfv cT cnmf cfv
      ledivmul2OLD cA chil wcel cA c0v wceq wn wa cA cT cfv cabs cfv cr wcel cA
      cno cfv cr wcel cT cnmf cfv cr wcel cA chil wcel cA cT cfv cabs cfv cr
      wcel cA c0v wceq wn cA chil wcel cA cT cfv cc wcel cA cT cfv cabs cfv cr
      wcel chil cc cA cT cT nmcfnex.1 lnfnfi ffvelrni cA cT cfv abscl syl
      adantr cA chil wcel cA cno cfv cr wcel cA c0v wceq wn cA normcl adantr cT
      cnmf cfv cr wcel cA chil wcel cA c0v wceq wn wa cT nmcfnex.1 nmcfnex.2
      nmcfnexi a1i 3jca cA chil wcel cA c0v wceq wn cc0 cA cno cfv clt wbr cA
      normgt0OLD biimpa sylanc mpbid pm2.61dan $.
      $( [22-Apr-2006] $) $( [14-Feb-2006] $)
  $}

  $( The norm of a continuous linear Hilbert space functional exists.  Theorem
     3.5(i) of [Beran] p. 99. $)
  nmcfnex $p |- ( ( T e. LinFn /\ T e. ConFn ) -> ( normfn ` T ) e. RR ) $=
    cT clf wcel cT ccnf wcel wa cT clf ccnf cin wcel cT cnmf cfv cr wcel cT clf
    ccnf elin cT clf ccnf cin wcel cT cnmf cfv cr wcel cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif cnmf cfv cr wcel cT chil cc0 csn cxp cT cT clf ccnf
    cin wcel cT chil cc0 csn cxp cif wceq cT cnmf cfv cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif cnmf cfv cr cT cT clf ccnf cin wcel cT chil cc0 csn
    cxp cif cnmf fveq2 eleq1d cT clf ccnf cin wcel cT chil cc0 csn cxp cif cT
    clf ccnf cin wcel cT chil cc0 csn cxp cif clf wcel cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif ccnf wcel cT clf ccnf cin wcel cT chil cc0 csn cxp cif
    clf ccnf cin wcel cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf wcel cT
    clf ccnf cin wcel cT chil cc0 csn cxp cif ccnf wcel wa cT chil cc0 csn cxp
    clf ccnf cin chil cc0 csn cxp clf ccnf cin wcel chil cc0 csn cxp clf wcel
    chil cc0 csn cxp ccnf wcel chil cc0 csn cxp clf ccnf elin 0lnfn 0cnfn
    mpbir2an elimel cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf ccnf elin
    mpbi pm3.26i cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf wcel cT clf
    ccnf cin wcel cT chil cc0 csn cxp cif ccnf wcel cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif clf ccnf cin wcel cT clf ccnf cin wcel cT chil cc0 csn
    cxp cif clf wcel cT clf ccnf cin wcel cT chil cc0 csn cxp cif ccnf wcel wa
    cT chil cc0 csn cxp clf ccnf cin chil cc0 csn cxp clf ccnf cin wcel chil
    cc0 csn cxp clf wcel chil cc0 csn cxp ccnf wcel chil cc0 csn cxp clf ccnf
    elin 0lnfn 0cnfn mpbir2an elimel cT clf ccnf cin wcel cT chil cc0 csn cxp
    cif clf ccnf elin mpbi pm3.27i nmcfnexi dedth sylbir $.
    $( [24-Apr-2006] $) $( [14-Feb-2006] $)

  $( A lower bound of the norm of a continuous linear Hilbert space functional.
     Theorem 3.5(ii) of [Beran] p. 99. $)
  nmcfnlb $p |- ( ( T e. LinFn /\ T e. ConFn /\ A e. ~H ) ->
                ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
    cT clf wcel cT ccnf wcel cA chil wcel cA cT cfv cabs cfv cT cnmf cfv cA cno
    cfv cmul co cle wbr cT clf ccnf cin wcel cA chil wcel cA cT cfv cabs cfv cT
    cnmf cfv cA cno cfv cmul co cle wbr cT clf wcel cT ccnf wcel wa cT clf ccnf
    cin wcel cA chil wcel cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul co cle
    wbr cT clf ccnf cin wcel cA chil wcel cA cT cfv cabs cfv cT cnmf cfv cA cno
    cfv cmul co cle wbr wi cA chil wcel cA cT clf ccnf cin wcel cT chil cc0 csn
    cxp cif cfv cabs cfv cT clf ccnf cin wcel cT chil cc0 csn cxp cif cnmf cfv
    cA cno cfv cmul co cle wbr wi cT chil cc0 csn cxp cT cT clf ccnf cin wcel
    cT chil cc0 csn cxp cif wceq cA cT cfv cabs cfv cT cnmf cfv cA cno cfv cmul
    co cle wbr cA cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv cabs cfv cT
    clf ccnf cin wcel cT chil cc0 csn cxp cif cnmf cfv cA cno cfv cmul co cle
    wbr cA chil wcel cT cT clf ccnf cin wcel cT chil cc0 csn cxp cif wceq cA cT
    cfv cabs cfv cA cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv cabs cfv
    cT cnmf cfv cA cno cfv cmul co cT clf ccnf cin wcel cT chil cc0 csn cxp cif
    cnmf cfv cA cno cfv cmul co cle cT cT clf ccnf cin wcel cT chil cc0 csn cxp
    cif wceq cA cT cfv cA cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv cabs
    cA cT cT clf ccnf cin wcel cT chil cc0 csn cxp cif fveq1 fveq2d cT cT clf
    ccnf cin wcel cT chil cc0 csn cxp cif wceq cT cnmf cfv cT clf ccnf cin wcel
    cT chil cc0 csn cxp cif cnmf cfv cA cno cfv cmul cT cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif cnmf fveq2 opreq1d breq12d imbi2d cA cT clf ccnf cin
    wcel cT chil cc0 csn cxp cif cT clf ccnf cin wcel cT chil cc0 csn cxp cif
    clf wcel cT clf ccnf cin wcel cT chil cc0 csn cxp cif ccnf wcel cT clf ccnf
    cin wcel cT chil cc0 csn cxp cif clf ccnf cin wcel cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif clf wcel cT clf ccnf cin wcel cT chil cc0 csn cxp cif
    ccnf wcel wa cT chil cc0 csn cxp clf ccnf cin chil cc0 csn cxp clf ccnf cin
    wcel chil cc0 csn cxp clf wcel chil cc0 csn cxp ccnf wcel chil cc0 csn cxp
    clf ccnf elin 0lnfn 0cnfn mpbir2an elimel cT clf ccnf cin wcel cT chil cc0
    csn cxp cif clf ccnf elin mpbi pm3.26i cT clf ccnf cin wcel cT chil cc0 csn
    cxp cif clf wcel cT clf ccnf cin wcel cT chil cc0 csn cxp cif ccnf wcel cT
    clf ccnf cin wcel cT chil cc0 csn cxp cif clf ccnf cin wcel cT clf ccnf cin
    wcel cT chil cc0 csn cxp cif clf wcel cT clf ccnf cin wcel cT chil cc0 csn
    cxp cif ccnf wcel wa cT chil cc0 csn cxp clf ccnf cin chil cc0 csn cxp clf
    ccnf cin wcel chil cc0 csn cxp clf wcel chil cc0 csn cxp ccnf wcel chil cc0
    csn cxp clf ccnf elin 0lnfn 0cnfn mpbir2an elimel cT clf ccnf cin wcel cT
    chil cc0 csn cxp cif clf ccnf elin mpbi pm3.27i nmcfnlbi dedth imp cT clf
    ccnf elin sylanbr 3impa $.
    $( [25-Apr-2006] $) $( [14-Feb-2006] $)

  ${
    $d x y z w v u T $.
    lnfncon.1 $e |- T e. LinFn $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is
       linear.  Theorem 3.5(iii) of [Beran] p. 99. $)
    lnfnconi $p |- ( T e. ConFn <->
       E. x e. RR A. y e. ~H ( abs ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) $=
      cT ccnf wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vx cr wrex cT cnmf cfv cr wcel vy cv cT cfv cabs cfv cT cnmf
      cfv vy cv cno cfv cmul co cle wbr vy chil wral vy cv cT cfv cabs cfv vx
      cv vy cv cno cfv cmul co cle wbr vy chil wral vx cr wrex cT ccnf wcel vy
      cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vy cv
      cT cfv cabs cfv cT cnmf cfv vy cv cno cfv cmul co cle wbr vy chil wral vx
      cT cnmf cfv cr vx cv cT cnmf cfv wceq vy cv cT cfv cabs cfv vx cv vy cv
      cno cfv cmul co cle wbr vy cv cT cfv cabs cfv cT cnmf cfv vy cv cno cfv
      cmul co cle wbr vy chil vx cv cT cnmf cfv wceq vx cv vy cv cno cfv cmul
      co cT cnmf cfv vy cv cno cfv cmul co vy cv cT cfv cabs cfv cle vx cv cT
      cnmf cfv vy cv cno cfv cmul opreq1 breq2d ralbidv rcla4ev cT clf wcel cT
      ccnf wcel cT cnmf cfv cr wcel lnfncon.1 cT nmcfnex mpan cT ccnf wcel vy
      cv cT cfv cabs cfv cT cnmf cfv vy cv cno cfv cmul co cle wbr vy chil cT
      clf wcel cT ccnf wcel vy cv chil wcel vy cv cT cfv cabs cfv cT cnmf cfv
      vy cv cno cfv cmul co cle wbr lnfncon.1 vy cv cT nmcfnlb mp3an1
      r19.21aiva sylanc vz cv c0v wne vz chil wrex vy cv cT cfv cabs cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral vx cr wrex cT ccnf wcel wi vz
      cv c0v wne vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vx cr wrex cT ccnf wcel wi vz chil vz cv chil wcel vz cv c0v
      wne wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral cT ccnf wcel vx cr vz cv chil wcel vz cv c0v wne wa vx cv cr wcel vy
      cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cT
      ccnf wcel vz cv chil wcel vz cv c0v wne wa vx cv cr wcel wa vy cv cT cfv
      cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv
      clt wbr cc0 vx cv wceq wo cT ccnf wcel vz cv chil wcel vz cv c0v wne wa
      vx cv cr wcel wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral wa cc0 vx cv cle wbr cc0 vx cv clt wbr cc0 vx cv wceq wo
      vx cv cr wcel vz cv cno cfv cr wcel wa cc0 vz cv cno cfv clt wbr cc0 vx
      cv vz cv cno cfv cmul co cle wbr wa cc0 vx cv cle wbr vz cv chil wcel vz
      cv c0v wne wa vx cv cr wcel wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral wa vx cv vz cv cno cfv prodge02 vz cv chil
      wcel vz cv c0v wne wa vx cv cr wcel wa vx cv cr wcel vz cv cno cfv cr
      wcel wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vx cv cr wcel vz cv chil wcel vz cv c0v wne wa vx cv cr wcel vz cv
      cno cfv cr wcel wa vz cv chil wcel vz cv c0v wne wa vz cv cno cfv cr wcel
      vx cv cr wcel vz cv chil wcel vz cv cno cfv cr wcel vz cv c0v wne vz cv
      normcl adantr anim2i ancoms adantr vz cv chil wcel vz cv c0v wne wa vx cv
      cr wcel wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral wa cc0 vz cv cno cfv clt wbr cc0 vx cv vz cv cno cfv cmul co
      cle wbr vz cv chil wcel vz cv c0v wne wa cc0 vz cv cno cfv clt wbr vx cv
      cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vz cv chil wcel vz cv c0v wne cc0 vz cv cno cfv clt wbr vz cv
      normgt0 biimpa ad2antrr vz cv chil wcel vx cv cr wcel vy cv cT cfv cabs
      cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cc0 vx cv vz cv cno
      cfv cmul co cle wbr vz cv c0v wne vz cv chil wcel vx cv cr wcel wa vy cv
      cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0
      vz cv cT cfv cabs cfv vx cv vz cv cno cfv cmul co cc0 cr wcel vz cv chil
      wcel vx cv cr wcel wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral wa 0re a1i vz cv chil wcel vz cv cT cfv cabs cfv cr
      wcel vx cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral vz cv chil wcel vz cv cT cfv cc wcel vz cv cT cfv cabs
      cfv cr wcel chil cc vz cv cT cT lnfncon.1 lnfnfi ffvelrni vz cv cT cfv
      abscl syl ad2antrr vz cv chil wcel vx cv cr wcel wa vx cv vz cv cno cfv
      cmul co cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral vx cv cr wcel vz cv chil wcel vx cv vz cv cno cfv cmul co cr
      wcel vx cv cr wcel vz cv cno cfv cr wcel vx cv vz cv cno cfv cmul co cr
      wcel vz cv chil wcel vx cv vz cv cno cfv remulcl vz cv normcl sylan2
      ancoms adantr vz cv chil wcel cc0 vz cv cT cfv cabs cfv cle wbr vx cv cr
      wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vz cv chil wcel vz cv cT cfv cc wcel cc0 vz cv cT cfv cabs cfv cle
      wbr chil cc vz cv cT cT lnfncon.1 lnfnfi ffvelrni vz cv cT cfv absge0 syl
      ad2antrr vz cv chil wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul
      co cle wbr vy chil wral vz cv cT cfv cabs cfv vx cv vz cv cno cfv cmul co
      cle wbr vx cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co
      cle wbr vz cv cT cfv cabs cfv vx cv vz cv cno cfv cmul co cle wbr vy vz
      cv chil vy cv vz cv wceq vy cv cT cfv cabs cfv vz cv cT cfv cabs cfv vx
      cv vy cv cno cfv cmul co vx cv vz cv cno cfv cmul co cle vy cv vz cv wceq
      vy cv cT cfv vz cv cT cfv cabs vy cv vz cv cT fveq2 fveq2d vy cv vz cv
      wceq vy cv cno cfv vz cv cno cfv vx cv cmul vy cv vz cv cno fveq2 opreq2d
      breq12d rcla4va adantlr letrd adantllr jca sylanc vx cv cr wcel cc0 vx cv
      cle wbr cc0 vx cv clt wbr cc0 vx cv wceq wo wb vz cv chil wcel vz cv c0v
      wne wa vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral cc0 cr wcel vx cv cr wcel cc0 vx cv cle wbr cc0 vx cv clt wbr cc0 vx
      cv wceq wo wb 0re cc0 vx cv leloe mpan ad2antlr mpbid vx cv cr wcel vy cv
      cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cc0 vx
      cv clt wbr cc0 vx cv wceq wo cT ccnf wcel wi vz cv chil wcel vz cv c0v
      wne wa vx cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral wa cc0 vx cv clt wbr cT ccnf wcel cc0 vx cv wceq vx
      cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral wa cc0 vx cv clt wbr cT ccnf wcel vx cv cr wcel vy cv cT cfv
      cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv
      clt wbr wa cc0 vw cv clt wbr cc0 vv cv clt wbr vu cv vz cv cmv co cno cfv
      vv cv clt wbr vu cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi
      vu chil wral wa vv cr wrex wi vw cr wral vz chil wral cT ccnf wcel vx cv
      cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral wa cc0 vx cv clt wbr wa cc0 vw cv clt wbr cc0 vv cv clt wbr vu cv vz
      cv cmv co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmin co cabs
      cfv vw cv clt wbr wi vu chil wral wa vv cr wrex wi vz vw chil cr vx cv cr
      wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral wa cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv
      clt wbr cc0 vv cv clt wbr vu cv vz cv cmv co cno cfv vv cv clt wbr vu cv
      cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vu chil wral wa vv
      cr wrex vw cv vx cv cdiv co cr wcel cc0 vw cv vx cv cdiv co clt wbr vu cv
      vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT
      cfv cmin co cabs cfv vw cv clt wbr wi vu chil wral wa cc0 vv cv clt wbr
      vu cv vz cv cmv co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmin
      co cabs cfv vw cv clt wbr wi vu chil wral wa vv cr wrex vx cv cr wcel vy
      cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa
      cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr
      wa wa cc0 vv cv clt wbr vu cv vz cv cmv co cno cfv vv cv clt wbr vu cv cT
      cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vu chil wral wa cc0 vw
      cv vx cv cdiv co clt wbr vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co
      clt wbr vu cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vu
      chil wral wa vv vw cv vx cv cdiv co cr vv cv vw cv vx cv cdiv co wceq cc0
      vv cv clt wbr cc0 vw cv vx cv cdiv co clt wbr vu cv vz cv cmv co cno cfv
      vv cv clt wbr vu cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi
      vu chil wral vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv
      cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vu chil wral vv cv
      vw cv vx cv cdiv co cc0 clt breq2 vv cv vw cv vx cv cdiv co wceq vu cv vz
      cv cmv co cno cfv vv cv clt wbr vu cv cT cfv vz cv cT cfv cmin co cabs
      cfv vw cv clt wbr wi vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt
      wbr vu cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vu chil
      vv cv vw cv vx cv cdiv co wceq vu cv vz cv cmv co cno cfv vv cv clt wbr
      vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv
      cT cfv cmin co cabs cfv vw cv clt wbr vv cv vw cv vx cv cdiv co vu cv vz
      cv cmv co cno cfv clt breq2 imbi1d ralbidv anbi12d rcla4ev vx cv cr wcel
      cc0 vx cv clt wbr vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa
      vw cv vx cv cdiv co cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral vx cv cr wcel cc0 vx cv clt wbr wa vw cv cr
      wcel cc0 vw cv clt wbr vw cv vx cv cdiv co cr wcel vz cv chil wcel vw cv
      cr wcel vx cv cr wcel vx cv cc0 wne vw cv vx cv cdiv co cr wcel vx cv cr
      wcel cc0 vx cv clt wbr wa vw cv cr wcel cc0 vw cv clt wbr wa wa vw cv vx
      cv redivcl vx cv cr wcel cc0 vx cv clt wbr wa vw cv cr wcel cc0 vw cv clt
      wbr simprl vx cv cr wcel cc0 vx cv clt wbr vw cv cr wcel cc0 vw cv clt
      wbr wa simpll vx cv cr wcel cc0 vx cv clt wbr wa vx cv cc0 wne vw cv cr
      wcel cc0 vw cv clt wbr wa vx cv gt0ne0 adantr syl3anc adantrll adantllr
      vx cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral wa cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0
      vw cv clt wbr wa wa cc0 vw cv vx cv cdiv co clt wbr vu cv vz cv cmv co
      cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv cT cfv cmin co
      cabs cfv vw cv clt wbr wi vu chil wral vx cv cr wcel cc0 vx cv clt wbr vz
      cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa cc0 vw cv vx cv cdiv
      co clt wbr vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vx cv cr wcel cc0 vx cv clt wbr wa vw cv cr wcel cc0 vw cv clt
      wbr cc0 vw cv vx cv cdiv co clt wbr vz cv chil wcel vw cv cr wcel cc0 vw
      cv clt wbr wa vx cv cr wcel cc0 vx cv clt wbr wa cc0 vw cv vx cv cdiv co
      clt wbr vw cv vx cv divgt0 ancoms adantrll adantllr vx cv cr wcel vy cv
      cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0
      vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa wa
      vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT cfv vz cv
      cT cfv cmin co cabs cfv vw cv clt wbr wi vu chil vx cv cr wcel vy cv cT
      cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx
      cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv
      chil wcel vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu cv cT
      cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vx cv cr wcel vy cv cT
      cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx
      cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv
      chil wcel wa wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu
      cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr vx cv cr wcel vy cv
      cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0
      vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu
      cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vu
      cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr vx cv cr wcel vy cv
      cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0
      vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu
      cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr wa
      wa vu cv cT cfv vz cv cT cfv cmin co cabs cfv vx cv vu cv vz cv cmv co
      cno cfv cmul co vw cv vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr
      wa vu cv chil wcel wa vu cv cT cfv vz cv cT cfv cmin co cabs cfv cr wcel
      vx cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr
      vy chil wral wa cc0 vx cv clt wbr wa vu cv vz cv cmv co cno cfv vw cv vx
      cv cdiv co clt wbr vz cv chil wcel vw cv cr wcel wa vu cv chil wcel vu cv
      cT cfv vz cv cT cfv cmin co cabs cfv cr wcel cc0 vw cv clt wbr vz cv chil
      wcel vu cv chil wcel vu cv cT cfv vz cv cT cfv cmin co cabs cfv cr wcel
      vw cv cr wcel vz cv chil wcel vu cv chil wcel wa vu cv cT cfv vz cv cT
      cfv cmin co cc wcel vu cv cT cfv vz cv cT cfv cmin co cabs cfv cr wcel vu
      cv chil wcel vz cv chil wcel vu cv cT cfv vz cv cT cfv cmin co cc wcel vu
      cv cT cfv cc wcel vz cv cT cfv cc wcel vu cv cT cfv vz cv cT cfv cmin co
      cc wcel vu cv chil wcel vz cv chil wcel vu cv cT cfv vz cv cT cfv subcl
      chil cc vu cv cT cT lnfncon.1 lnfnfi ffvelrni chil cc vz cv cT cT
      lnfncon.1 lnfnfi ffvelrni syl2an ancoms vu cv cT cfv vz cv cT cfv cmin co
      abscl syl adantlr adantlr ad2antrl vx cv cr wcel cc0 vx cv clt wbr vz cv
      chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv
      vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr wa vx cv vu cv vz cv cmv
      co cno cfv cmul co cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul
      co cle wbr vy chil wral vx cv cr wcel vz cv chil wcel vw cv cr wcel wa
      cc0 vw cv clt wbr wa vu cv chil wcel wa vx cv vu cv vz cv cmv co cno cfv
      cmul co cr wcel cc0 vx cv clt wbr vu cv vz cv cmv co cno cfv vw cv vx cv
      cdiv co clt wbr vx cv cr wcel vz cv chil wcel vw cv cr wcel wa vu cv chil
      wcel vx cv vu cv vz cv cmv co cno cfv cmul co cr wcel cc0 vw cv clt wbr
      vx cv cr wcel vz cv chil wcel vu cv chil wcel vx cv vu cv vz cv cmv co
      cno cfv cmul co cr wcel vw cv cr wcel vx cv cr wcel vu cv vz cv cmv co
      cno cfv cr wcel vx cv vu cv vz cv cmv co cno cfv cmul co cr wcel vz cv
      chil wcel vu cv chil wcel wa vx cv vu cv vz cv cmv co cno cfv remulcl vz
      cv chil wcel vu cv chil wcel wa vu cv vz cv cmv co chil wcel vu cv vz cv
      cmv co cno cfv cr wcel vu cv chil wcel vz cv chil wcel vu cv vz cv cmv co
      chil wcel vu cv vz cv hvsubcl ancoms vu cv vz cv cmv co normcl syl sylan2
      adantrlr adantrlr ad2ant2r adantllr vz cv chil wcel vw cv cr wcel wa cc0
      vw cv clt wbr wa vu cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv vx
      cv cdiv co clt wbr wa vw cv cr wcel vx cv cr wcel vy cv cT cfv cabs cfv
      vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa
      vz cv chil wcel vw cv cr wcel wa cc0 vw cv clt wbr wa vw cv cr wcel vu cv
      chil wcel vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vz cv
      chil wcel vw cv cr wcel cc0 vw cv clt wbr simplr ad2antrr adantl vx cv cr
      wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral wa cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa cc0 vw cv
      clt wbr wa vu cv chil wcel wa vu cv cT cfv vz cv cT cfv cmin co cabs cfv
      vx cv vu cv vz cv cmv co cno cfv cmul co cle wbr vu cv vz cv cmv co cno
      cfv vw cv vx cv cdiv co clt wbr vx cv cr wcel vy cv cT cfv cabs cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv
      chil wcel vw cv cr wcel wa vu cv chil wcel vu cv cT cfv vz cv cT cfv cmin
      co cabs cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle wbr cc0 vw cv
      clt wbr vx cv cr wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral wa cc0 vx cv clt wbr wa vz cv chil wcel vu cv chil
      wcel vu cv cT cfv vz cv cT cfv cmin co cabs cfv vx cv vu cv vz cv cmv co
      cno cfv cmul co cle wbr vw cv cr wcel vx cv cr wcel vy cv cT cfv cabs cfv
      vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa vz cv chil wcel vu cv
      chil wcel wa vu cv cT cfv vz cv cT cfv cmin co cabs cfv vx cv vu cv vz cv
      cmv co cno cfv cmul co cle wbr cc0 vx cv clt wbr vx cv cr wcel vy cv cT
      cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa vz cv
      chil wcel vu cv chil wcel wa wa vu cv vz cv cmv co cT cfv cabs cfv vu cv
      cT cfv vz cv cT cfv cmin co cabs cfv vx cv vu cv vz cv cmv co cno cfv
      cmul co cle vz cv chil wcel vu cv chil wcel wa vu cv vz cv cmv co cT cfv
      cabs cfv vu cv cT cfv vz cv cT cfv cmin co cabs cfv wceq vx cv cr wcel vy
      cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa vz
      cv chil wcel vu cv chil wcel wa vu cv vz cv cmv co cT cfv vu cv cT cfv vz
      cv cT cfv cmin co cabs vu cv chil wcel vz cv chil wcel vu cv vz cv cmv co
      cT cfv vu cv cT cfv vz cv cT cfv cmin co wceq vu cv vz cv cT lnfncon.1
      lnfnsubi ancoms fveq2d adantl vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral vz cv chil wcel vu cv chil wcel wa vu cv vz
      cv cmv co cT cfv cabs cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle
      wbr vx cv cr wcel vz cv chil wcel vu cv chil wcel wa vy cv cT cfv cabs
      cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vu cv vz cv cmv co
      cT cfv cabs cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle wbr vu cv vz
      cv cmv co chil wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle
      wbr vy chil wral vu cv vz cv cmv co cT cfv cabs cfv vx cv vu cv vz cv cmv
      co cno cfv cmul co cle wbr vz cv chil wcel vu cv chil wcel wa vy cv cT
      cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vu cv vz cv cmv co cT
      cfv cabs cfv vx cv vu cv vz cv cmv co cno cfv cmul co cle wbr vy vu cv vz
      cv cmv co chil vy cv vu cv vz cv cmv co wceq vy cv cT cfv cabs cfv vu cv
      vz cv cmv co cT cfv cabs cfv vx cv vy cv cno cfv cmul co vx cv vu cv vz
      cv cmv co cno cfv cmul co cle vy cv vu cv vz cv cmv co wceq vy cv cT cfv
      vu cv vz cv cmv co cT cfv cabs vy cv vu cv vz cv cmv co cT fveq2 fveq2d
      vy cv vu cv vz cv cmv co wceq vy cv cno cfv vu cv vz cv cmv co cno cfv vx
      cv cmul vy cv vu cv vz cv cmv co cno fveq2 opreq2d breq12d rcla4va vu cv
      chil wcel vz cv chil wcel vu cv vz cv cmv co chil wcel vu cv vz cv
      hvsubcl ancoms sylan ancoms adantll eqbrtrrd adantlr adantrlr adantrlr
      adantrr vx cv cr wcel cc0 vx cv clt wbr vz cv chil wcel vw cv cr wcel wa
      cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv
      vx cv cdiv co clt wbr wa vx cv vu cv vz cv cmv co cno cfv cmul co vw cv
      clt wbr vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vx cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa
      cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv
      vx cv cdiv co clt wbr vx cv vu cv vz cv cmv co cno cfv cmul co vw cv clt
      wbr vx cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa
      cc0 vw cv clt wbr wa vu cv chil wcel wa vu cv vz cv cmv co cno cfv vw cv
      vx cv cdiv co clt wbr vx cv vu cv vz cv cmv co cno cfv cmul co vw cv clt
      wbr wi vx cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel
      wa vu cv chil wcel vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr
      vx cv vu cv vz cv cmv co cno cfv cmul co vw cv clt wbr wi cc0 vw cv clt
      wbr vx cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vw cv cr wcel wa
      vu cv chil wcel wa wa vx cv vu cv vz cv cmv co cno cfv cmul co vw cv clt
      wbr vu cv vz cv cmv co cno cfv vw cv vx cv cdiv co clt wbr vx cv cr wcel
      vu cv vz cv cmv co cno cfv cr wcel vw cv cr wcel w3a cc0 vx cv clt wbr vx
      cv vu cv vz cv cmv co cno cfv cmul co vw cv clt wbr vu cv vz cv cmv co
      cno cfv vw cv vx cv cdiv co clt wbr wb vx cv cr wcel cc0 vx cv clt wbr wa
      vz cv chil wcel vw cv cr wcel wa vu cv chil wcel wa wa vx cv vu cv vz cv
      cmv co cno cfv vw cv ltmuldiv2OLD vx cv cr wcel cc0 vx cv clt wbr wa vz
      cv chil wcel vw cv cr wcel wa vu cv chil wcel wa wa vx cv cr wcel vu cv
      vz cv cmv co cno cfv cr wcel vw cv cr wcel vx cv cr wcel cc0 vx cv clt
      wbr vz cv chil wcel vw cv cr wcel wa vu cv chil wcel wa simpll vz cv chil
      wcel vw cv cr wcel wa vu cv chil wcel wa vu cv vz cv cmv co cno cfv cr
      wcel vx cv cr wcel cc0 vx cv clt wbr wa vz cv chil wcel vu cv chil wcel
      vu cv vz cv cmv co cno cfv cr wcel vw cv cr wcel vz cv chil wcel vu cv
      chil wcel wa vu cv vz cv cmv co chil wcel vu cv vz cv cmv co cno cfv cr
      wcel vu cv chil wcel vz cv chil wcel vu cv vz cv cmv co chil wcel vu cv
      vz cv hvsubcl ancoms vu cv vz cv cmv co normcl syl adantlr adantl vz cv
      chil wcel vw cv cr wcel wa vw cv cr wcel vx cv cr wcel cc0 vx cv clt wbr
      wa vu cv chil wcel vz cv chil wcel vw cv cr wcel pm3.27 ad2antrl 3jca vx
      cv cr wcel cc0 vx cv clt wbr vz cv chil wcel vw cv cr wcel wa vu cv chil
      wcel wa simplr sylanc biimprd adantrlr ex imp32 adantllr lelttrd anassrs
      ex anassrs r19.21aiva jca sylanc exp32 r19.21aivv cT ccnf wcel chil cc cT
      wf cc0 vw cv clt wbr cc0 vv cv clt wbr vu cv vz cv cmv co cno cfv vv cv
      clt wbr vu cv cT cfv vz cv cT cfv cmin co cabs cfv vw cv clt wbr wi vu
      chil wral wa vv cr wrex wi vw cr wral vz chil wral vz vw vv vu cT elcnfn
      cT lnfncon.1 lnfnfi mpbiran sylibr ex vy cv cT cfv cabs cfv vx cv vy cv
      cno cfv cmul co cle wbr vy chil wral cc0 vx cv wceq cT ccnf wcel wi vx cv
      cr wcel cc0 vx cv wceq vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co
      cle wbr vy chil wral cT ccnf wcel cc0 vx cv wceq vy cv cT cfv cabs cfv vx
      cv vy cv cno cfv cmul co cle wbr vy chil wral vy cv cT cfv cabs cfv cc0
      vy cv cno cfv cmul co cle wbr vy chil wral cT ccnf wcel cc0 vx cv wceq vy
      cv cT cfv cabs cfv cc0 vy cv cno cfv cmul co cle wbr vy cv cT cfv cabs
      cfv vx cv vy cv cno cfv cmul co cle wbr vy chil cc0 vx cv wceq cc0 vy cv
      cno cfv cmul co vx cv vy cv cno cfv cmul co vy cv cT cfv cabs cfv cle cc0
      vx cv vy cv cno cfv cmul opreq1 breq2d ralbidv vy cv cT cfv cabs cfv cc0
      vy cv cno cfv cmul co cle wbr vy chil wral vy cv cT cfv cabs cfv cc0 cle
      wbr vy chil wral cT ccnf wcel vy cv cT cfv cabs cfv cc0 vy cv cno cfv
      cmul co cle wbr vy cv cT cfv cabs cfv cc0 cle wbr vy chil vy cv chil wcel
      cc0 vy cv cno cfv cmul co cc0 vy cv cT cfv cabs cfv cle vy cv chil wcel
      vy cv cno cfv cc wcel cc0 vy cv cno cfv cmul co cc0 wceq vy cv chil wcel
      vy cv cno cfv vy cv normcl recnd vy cv cno cfv mul02 syl breq2d ralbiia
      vy cv cT cfv cabs cfv cc0 cle wbr vy chil wral vy cv cT cfv vy cv chil
      cc0 csn cxp cfv wceq vy chil wral cT ccnf wcel vy cv cT cfv cabs cfv cc0
      cle wbr vy cv cT cfv vy cv chil cc0 csn cxp cfv wceq vy chil vy cv chil
      wcel vy cv cT cfv cabs cfv cc0 cle wbr vy cv cT cfv cc0 wceq vy cv cT cfv
      vy cv chil cc0 csn cxp cfv wceq vy cv chil wcel vy cv cT cfv cc wcel vy
      cv cT cfv cabs cfv cc0 cle wbr vy cv cT cfv cc0 wceq wb chil cc vy cv cT
      cT lnfncon.1 lnfnfi ffvelrni vy cv cT cfv cc wcel vy cv cT cfv cabs cfv
      cc0 cle wbr vy cv cT cfv cabs cfv cc0 cle wbr cc0 vy cv cT cfv cabs cfv
      cle wbr wa vy cv cT cfv cabs cfv cc0 wceq vy cv cT cfv cc0 wceq vy cv cT
      cfv cc wcel cc0 vy cv cT cfv cabs cfv cle wbr vy cv cT cfv cabs cfv cc0
      cle wbr vy cv cT cfv absge0 biantrud vy cv cT cfv cc wcel vy cv cT cfv
      cabs cfv cr wcel vy cv cT cfv cabs cfv cc0 wceq vy cv cT cfv cabs cfv cc0
      cle wbr cc0 vy cv cT cfv cabs cfv cle wbr wa wb vy cv cT cfv abscl vy cv
      cT cfv cabs cfv cr wcel cc0 cr wcel vy cv cT cfv cabs cfv cc0 wceq vy cv
      cT cfv cabs cfv cc0 cle wbr cc0 vy cv cT cfv cabs cfv cle wbr wa wb 0re
      vy cv cT cfv cabs cfv cc0 letri3 mpan2 syl vy cv cT cfv abs00 3bitr2d syl
      vy cv chil wcel vy cv chil cc0 csn cxp cfv cc0 vy cv cT cfv chil cc0 vy
      cv cc0 cc 0cn elisseti fvconst2 eqeq2d bitr4d ralbiia vy cv cT cfv vy cv
      chil cc0 csn cxp cfv wceq vy chil wral cT chil cc0 csn cxp ccnf cT chil
      cc0 csn cxp wceq vy cv cT cfv vy cv chil cc0 csn cxp cfv wceq vy chil
      wral cT chil wfn chil cc0 csn cxp chil wfn cT chil cc0 csn cxp wceq vy cv
      cT cfv vy cv chil cc0 csn cxp cfv wceq vy chil wral wb chil cc cT wf cT
      chil wfn cT lnfncon.1 lnfnfi chil cc cT ffn ax-mp chil cc chil cc0 csn
      cxp wf chil cc0 csn cxp chil wfn chil cc0 csn cxp 0lnfn lnfnfi chil cc
      chil cc0 csn cxp ffn ax-mp vy chil cT chil cc0 csn cxp eqfnfv2 mp2an
      biimpri 0cnfn syl6eqel sylbi sylbi syl6bir com12 adantl jaod adantll mpd
      exp31 r19.23adv r19.23aiva vz cv c0v wne vz chil wrex wn vy cv c0v wceq
      vy chil wral vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral vx cr wrex cT ccnf wcel wi vy cv c0v wceq vy chil wral vy cv
      c0v wceq wn vy chil wrex wn vz cv c0v wne vz chil wrex wn vy cv c0v wceq
      vy chil dfral2 vy cv c0v wceq wn vy chil wrex vz cv c0v wne vz chil wrex
      vy cv c0v wceq wn vz cv c0v wne vy vz chil vy cv vz cv wceq vy cv c0v
      wceq vz cv c0v vy cv vz cv c0v eqeq1 necon3bbid cbvrexv notbii bitr2i vy
      cv c0v wceq vy chil wral vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul
      co cle wbr vy chil wral cT ccnf wcel vx cr vx cv cr wcel vy cv c0v wceq
      vy chil wral vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy
      chil wral cT ccnf wcel wi vx cv cr wcel vy cv c0v wceq vy chil wral vy cv
      cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral cT ccnf
      wcel vx cv cr wcel vy cv cT cfv cabs cfv vx cv cc0 cmul co cle wbr vy
      chil wral cT ccnf wcel vy cv c0v wceq vy chil wral vy cv cT cfv cabs cfv
      vx cv vy cv cno cfv cmul co cle wbr vy chil wral wa vx cv cr wcel vy cv
      cT cfv cabs cfv vx cv cc0 cmul co cle wbr vy chil wral vy cv cT cfv cabs
      cfv cc0 cle wbr vy chil wral cT ccnf wcel vx cv cr wcel vy cv cT cfv cabs
      cfv vx cv cc0 cmul co cle wbr vy cv cT cfv cabs cfv cc0 cle wbr vy chil
      vx cv cr wcel vx cv cc0 cmul co cc0 vy cv cT cfv cabs cfv cle vx cv cr
      wcel vx cv cc wcel vx cv cc0 cmul co cc0 wceq vx cv recn vx cv mul01 syl
      breq2d ralbidv vy cv cT cfv cabs cfv cc0 cle wbr vy chil wral vy cv cT
      cfv vy cv chil cc0 csn cxp cfv wceq vy chil wral cT ccnf wcel vy cv cT
      cfv cabs cfv cc0 cle wbr vy cv cT cfv vy cv chil cc0 csn cxp cfv wceq vy
      chil vy cv chil wcel vy cv cT cfv cabs cfv cc0 cle wbr vy cv cT cfv cc0
      wceq vy cv cT cfv vy cv chil cc0 csn cxp cfv wceq vy cv chil wcel vy cv
      cT cfv cc wcel vy cv cT cfv cabs cfv cc0 cle wbr vy cv cT cfv cc0 wceq wb
      chil cc vy cv cT cT lnfncon.1 lnfnfi ffvelrni vy cv cT cfv cc wcel vy cv
      cT cfv cabs cfv cc0 cle wbr vy cv cT cfv cabs cfv cc0 cle wbr cc0 vy cv
      cT cfv cabs cfv cle wbr wa vy cv cT cfv cabs cfv cc0 wceq vy cv cT cfv
      cc0 wceq vy cv cT cfv cc wcel cc0 vy cv cT cfv cabs cfv cle wbr vy cv cT
      cfv cabs cfv cc0 cle wbr vy cv cT cfv absge0 biantrud vy cv cT cfv cc
      wcel vy cv cT cfv cabs cfv cr wcel vy cv cT cfv cabs cfv cc0 wceq vy cv
      cT cfv cabs cfv cc0 cle wbr cc0 vy cv cT cfv cabs cfv cle wbr wa wb vy cv
      cT cfv abscl vy cv cT cfv cabs cfv cr wcel cc0 cr wcel vy cv cT cfv cabs
      cfv cc0 wceq vy cv cT cfv cabs cfv cc0 cle wbr cc0 vy cv cT cfv cabs cfv
      cle wbr wa wb 0re vy cv cT cfv cabs cfv cc0 letri3 mpan2 syl vy cv cT cfv
      abs00 3bitr2d syl vy cv chil wcel vy cv chil cc0 csn cxp cfv cc0 vy cv cT
      cfv chil cc0 vy cv cc0 cc 0cn elisseti fvconst2 eqeq2d bitr4d ralbiia vy
      cv cT cfv vy cv chil cc0 csn cxp cfv wceq vy chil wral cT chil cc0 csn
      cxp ccnf cT chil cc0 csn cxp wceq vy cv cT cfv vy cv chil cc0 csn cxp cfv
      wceq vy chil wral cT chil wfn chil cc0 csn cxp chil wfn cT chil cc0 csn
      cxp wceq vy cv cT cfv vy cv chil cc0 csn cxp cfv wceq vy chil wral wb
      chil cc cT wf cT chil wfn cT lnfncon.1 lnfnfi chil cc cT ffn ax-mp chil
      cc chil cc0 csn cxp wf chil cc0 csn cxp chil wfn chil cc0 csn cxp 0lnfn
      lnfnfi chil cc chil cc0 csn cxp ffn ax-mp vy chil cT chil cc0 csn cxp
      eqfnfv2 mp2an biimpri 0cnfn syl6eqel sylbi syl6bi vy cv c0v wceq vy chil
      wral vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral wa vy cv c0v wceq vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co
      cle wbr wa vy chil wral vy cv cT cfv cabs cfv vx cv cc0 cmul co cle wbr
      vy chil wral vy cv c0v wceq vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil r19.26 vy cv c0v wceq vy cv cT cfv cabs cfv vx cv
      vy cv cno cfv cmul co cle wbr wa vy cv cT cfv cabs cfv vx cv cc0 cmul co
      cle wbr vy chil vy cv c0v wceq vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy cv cT cfv cabs cfv vx cv cc0 cmul co cle wbr vy cv c0v
      wceq vx cv vy cv cno cfv cmul co vx cv cc0 cmul co vy cv cT cfv cabs cfv
      cle vy cv c0v wceq vy cv cno cfv cc0 vx cv cmul vy cv c0v wceq vy cv cno
      cfv c0v cno cfv cc0 vy cv c0v cno fveq2 norm0 syl6eq opreq2d breq2d
      biimpa r19.20si sylbir syl5 exp3a com12 r19.23adv sylbi pm2.61i impbii $.
      $( [25-Apr-2006] $) $( [14-Feb-2006] $)
  $}

  ${
    $d x y T $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is
       linear.  Theorem 3.5(iii) of [Beran] p. 99. $)
    lnfncon $p |- ( T e. LinFn -> ( T e. ConFn <->
     E. x e. RR A. y e. ~H ( abs ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) ) $=
      cT clf wcel cT ccnf wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul
      co cle wbr vy chil wral vx cr wrex wb cT clf wcel cT chil cc0 csn cxp cif
      ccnf wcel vy cv cT clf wcel cT chil cc0 csn cxp cif cfv cabs cfv vx cv vy
      cv cno cfv cmul co cle wbr vy chil wral vx cr wrex wb cT chil cc0 csn cxp
      cT cT clf wcel cT chil cc0 csn cxp cif wceq cT ccnf wcel cT clf wcel cT
      chil cc0 csn cxp cif ccnf wcel vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral vx cr wrex vy cv cT clf wcel cT chil cc0 csn
      cxp cif cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx
      cr wrex cT cT clf wcel cT chil cc0 csn cxp cif ccnf eleq1 cT cT clf wcel
      cT chil cc0 csn cxp cif wceq vy cv cT cfv cabs cfv vx cv vy cv cno cfv
      cmul co cle wbr vy chil wral vy cv cT clf wcel cT chil cc0 csn cxp cif
      cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx cr cT cT
      clf wcel cT chil cc0 csn cxp cif wceq vy cv cT cfv cabs cfv vx cv vy cv
      cno cfv cmul co cle wbr vy cv cT clf wcel cT chil cc0 csn cxp cif cfv
      cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil cT cT clf wcel cT
      chil cc0 csn cxp cif wceq vy cv cT cfv cabs cfv vy cv cT clf wcel cT chil
      cc0 csn cxp cif cfv cabs cfv vx cv vy cv cno cfv cmul co cle cT cT clf
      wcel cT chil cc0 csn cxp cif wceq vy cv cT cfv vy cv cT clf wcel cT chil
      cc0 csn cxp cif cfv cabs vy cv cT cT clf wcel cT chil cc0 csn cxp cif
      fveq1 fveq2d breq1d ralbidv rexbidv bibi12d vx vy cT clf wcel cT chil cc0
      csn cxp cif cT chil cc0 csn cxp clf 0lnfn elimel lnfnconi dedth $.
      $( [27-Apr-2006] $) $( [16-Feb-2006] $)

    $( A linear functional is continuous iff it is bounded. $)
    lnfncnbd $p |- ( T e. LinFn ->
                    ( T e. ConFn <-> ( normfn ` T ) e. RR ) ) $=
      cT clf wcel cT ccnf wcel cT cnmf cfv cr wcel cT clf wcel cT ccnf wcel cT
      cnmf cfv cr wcel cT nmcfnex ex cT clf wcel cT cnmf cfv cr wcel vy cv cT
      cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil wral vx cr wrex
      cT ccnf wcel cT clf wcel cT cnmf cfv cr wcel vy cv cT cfv cabs cfv vx cv
      vy cv cno cfv cmul co cle wbr vy chil wral vx cr wrex cT cnmf cfv cr wcel
      vy cv cT cfv cabs cfv cT cnmf cfv vy cv cno cfv cmul co cle wbr vy chil
      wral vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle wbr vy chil
      wral vx cr wrex cT clf wcel cT cnmf cfv cr wcel wa vy cv cT cfv cabs cfv
      vx cv vy cv cno cfv cmul co cle wbr vy chil wral vy cv cT cfv cabs cfv cT
      cnmf cfv vy cv cno cfv cmul co cle wbr vy chil wral vx cT cnmf cfv cr vx
      cv cT cnmf cfv wceq vy cv cT cfv cabs cfv vx cv vy cv cno cfv cmul co cle
      wbr vy cv cT cfv cabs cfv cT cnmf cfv vy cv cno cfv cmul co cle wbr vy
      chil vx cv cT cnmf cfv wceq vx cv vy cv cno cfv cmul co cT cnmf cfv vy cv
      cno cfv cmul co vy cv cT cfv cabs cfv cle vx cv cT cnmf cfv vy cv cno cfv
      cmul opreq1 breq2d ralbidv rcla4ev cT clf wcel cT cnmf cfv cr wcel pm3.27
      cT clf wcel cT cnmf cfv cr wcel wa vy cv cT cfv cabs cfv cT cnmf cfv vy
      cv cno cfv cmul co cle wbr vy chil cT clf wcel cT cnmf cfv cr wcel vy cv
      chil wcel vy cv cT cfv cabs cfv cT cnmf cfv vy cv cno cfv cmul co cle wbr
      vy cv cT nmbdfnlb 3expa r19.21aiva sylanc ex vx vy cT lnfncon sylibrd
      impbid $.
      $( [4-May-2006] $) $( [25-Apr-2006] $)
  $}

  ${
    $d x y T $.
    nlelsh.1 $e |- T e. LinFn $.
    $( The null space of a linear functional is a subspace. $)
    nlelshi $p |- ( null ` T ) e. SH $=
      cT cnl cfv csh wcel c0v cT cnl cfv wcel vx cv vy cv cva co cT cnl cfv
      wcel vy cT cnl cfv wral vx cT cnl cfv wral vx cv vy cv csm co cT cnl cfv
      wcel vy cT cnl cfv wral vx cc wral wa cT cnl cfv chil wss cT cnl cfv csh
      wcel c0v cT cnl cfv wcel vx cv vy cv cva co cT cnl cfv wcel vy cT cnl cfv
      wral vx cT cnl cfv wral vx cv vy cv csm co cT cnl cfv wcel vy cT cnl cfv
      wral vx cc wral wa wa wb cT cnl cfv vx cv cT cfv cc0 wceq vx chil crab
      chil chil cc cT wf cT cnl cfv vx cv cT cfv cc0 wceq vx chil crab wceq cT
      nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx cv cT cfv cc0 wceq vx chil ssrab2
      eqsstri vx vy cT cnl cfv sh2 ax-mp c0v cT cnl cfv wcel c0v cT cfv cc0
      wceq cT nlelsh.1 lnfn0i chil cc cT wf c0v chil wcel c0v cT cnl cfv wcel
      c0v cT cfv cc0 wceq wb cT nlelsh.1 lnfnfi ax-hv0cl c0v cT elnlfn mp2an
      mpbir vx cv vy cv cva co cT cnl cfv wcel vy cT cnl cfv wral vx cT cnl cfv
      wral vx cv vy cv csm co cT cnl cfv wcel vy cT cnl cfv wral vx cc wral vx
      cv vy cv cva co cT cnl cfv wcel vx vy cT cnl cfv cT cnl cfv vx cv cT cnl
      cfv wcel vy cv cT cnl cfv wcel wa vx cv vy cv cva co cT cnl cfv wcel vx
      cv vy cv cva co cT cfv cc0 wceq vx cv cT cnl cfv wcel vy cv cT cnl cfv
      wcel wa vx cv vy cv cva co cT cfv vx cv cT cfv vy cv cT cfv caddc co cc0
      vx cv chil wcel vy cv chil wcel vx cv vy cv cva co cT cfv vx cv cT cfv vy
      cv cT cfv caddc co wceq vx cv cT cnl cfv wcel vy cv cT cnl cfv wcel vx cv
      vy cv cT nlelsh.1 lnfnaddi cT cnl cfv chil vx cv cT cnl cfv vx cv cT cfv
      cc0 wceq vx chil crab chil chil cc cT wf cT cnl cfv vx cv cT cfv cc0 wceq
      vx chil crab wceq cT nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx cv cT cfv cc0
      wceq vx chil ssrab2 eqsstri sseli cT cnl cfv chil vy cv cT cnl cfv vx cv
      cT cfv cc0 wceq vx chil crab chil chil cc cT wf cT cnl cfv vx cv cT cfv
      cc0 wceq vx chil crab wceq cT nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx cv
      cT cfv cc0 wceq vx chil ssrab2 eqsstri sseli syl2an vx cv cT cnl cfv wcel
      vy cv cT cnl cfv wcel wa vx cv cT cfv vy cv cT cfv caddc co cc0 cc0 caddc
      co cc0 vx cv cT cnl cfv wcel vy cv cT cnl cfv wcel vx cv cT cfv cc0 vy cv
      cT cfv cc0 caddc chil cc cT wf vx cv cT cnl cfv wcel vx cv cT cfv cc0
      wceq cT nlelsh.1 lnfnfi vx cv cT elnlfn2 mpan chil cc cT wf vy cv cT cnl
      cfv wcel vy cv cT cfv cc0 wceq cT nlelsh.1 lnfnfi vy cv cT elnlfn2 mpan
      opreqan12d cc0 0cn addid1i syl6eq eqtrd vx cv cT cnl cfv wcel vy cv cT
      cnl cfv wcel wa vx cv vy cv cva co chil wcel vx cv vy cv cva co cT cnl
      cfv wcel vx cv vy cv cva co cT cfv cc0 wceq wb vx cv chil wcel vy cv chil
      wcel vx cv vy cv cva co chil wcel vx cv cT cnl cfv wcel vy cv cT cnl cfv
      wcel vx cv vy cv hvaddcl cT cnl cfv chil vx cv cT cnl cfv vx cv cT cfv
      cc0 wceq vx chil crab chil chil cc cT wf cT cnl cfv vx cv cT cfv cc0 wceq
      vx chil crab wceq cT nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx cv cT cfv cc0
      wceq vx chil ssrab2 eqsstri sseli cT cnl cfv chil vy cv cT cnl cfv vx cv
      cT cfv cc0 wceq vx chil crab chil chil cc cT wf cT cnl cfv vx cv cT cfv
      cc0 wceq vx chil crab wceq cT nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx cv
      cT cfv cc0 wceq vx chil ssrab2 eqsstri sseli syl2an chil cc cT wf vx cv
      vy cv cva co chil wcel vx cv vy cv cva co cT cnl cfv wcel vx cv vy cv cva
      co cT cfv cc0 wceq wb cT nlelsh.1 lnfnfi vx cv vy cv cva co cT elnlfn
      mpan syl mpbird rgen2 vx cv vy cv csm co cT cnl cfv wcel vx vy cc cT cnl
      cfv vx cv cc wcel vy cv cT cnl cfv wcel wa vx cv vy cv csm co cT cnl cfv
      wcel vx cv vy cv csm co cT cfv cc0 wceq vx cv cc wcel vy cv cT cnl cfv
      wcel wa vx cv vy cv csm co cT cfv vx cv vy cv cT cfv cmul co vx cv cc0
      cmul co cc0 vx cv cc wcel vy cv chil wcel vx cv vy cv csm co cT cfv vx cv
      vy cv cT cfv cmul co wceq vy cv cT cnl cfv wcel vx cv vy cv cT nlelsh.1
      lnfnmuli cT cnl cfv chil vy cv cT cnl cfv vx cv cT cfv cc0 wceq vx chil
      crab chil chil cc cT wf cT cnl cfv vx cv cT cfv cc0 wceq vx chil crab
      wceq cT nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx cv cT cfv cc0 wceq vx chil
      ssrab2 eqsstri sseli sylan2 vy cv cT cnl cfv wcel vx cv vy cv cT cfv cmul
      co vx cv cc0 cmul co wceq vx cv cc wcel vy cv cT cnl cfv wcel vy cv cT
      cfv cc0 vx cv cmul chil cc cT wf vy cv cT cnl cfv wcel vy cv cT cfv cc0
      wceq cT nlelsh.1 lnfnfi vy cv cT elnlfn2 mpan opreq2d adantl vx cv cc
      wcel vx cv cc0 cmul co cc0 wceq vy cv cT cnl cfv wcel vx cv mul01 adantr
      3eqtrd vx cv cc wcel vy cv cT cnl cfv wcel wa vx cv vy cv csm co chil
      wcel vx cv vy cv csm co cT cnl cfv wcel vx cv vy cv csm co cT cfv cc0
      wceq wb vx cv cc wcel vy cv chil wcel vx cv vy cv csm co chil wcel vy cv
      cT cnl cfv wcel vx cv vy cv hvmulcl cT cnl cfv chil vy cv cT cnl cfv vx
      cv cT cfv cc0 wceq vx chil crab chil chil cc cT wf cT cnl cfv vx cv cT
      cfv cc0 wceq vx chil crab wceq cT nlelsh.1 lnfnfi vx cT nlfnval ax-mp vx
      cv cT cfv cc0 wceq vx chil ssrab2 eqsstri sseli sylan2 chil cc cT wf vx
      cv vy cv csm co chil wcel vx cv vy cv csm co cT cnl cfv wcel vx cv vy cv
      csm co cT cfv cc0 wceq wb cT nlelsh.1 lnfnfi vx cv vy cv csm co cT elnlfn
      mpan syl mpbird rgen2 pm3.2i mpbir2an $.
      $( [23-Apr-2006] $) $( [11-Feb-2006] $)
  $}

  ${
    $d g h m n u v w x y T $.
    nlelch.1 $e |- T e. LinFn $.
    nlelch.2 $e |- T e. ConFn $.
    $( The null space of a continuous linear functional is a closed subspace.
       Remark 3.8 of [Beran] p. 103. $)
    nlelchi $p |- ( null ` T ) e. CH $=
      cT cnl cfv cch wcel cT cnl cfv csh wcel cn cT cnl cfv vg cv wf vg cv vh
      cv chli wbr wa vh cv cT cnl cfv wcel wi vh wal vg wal vh vg cT cnl cfv
      closedsub cT nlelch.1 nlelshi cn cT cnl cfv vg cv wf vg cv vh cv chli wbr
      wa vh cv cT cnl cfv wcel wi vg vh cn cT cnl cfv vg cv wf vg cv vh cv chli
      wbr wa vh cv cT cnl cfv wcel vh cv cT cfv cc0 wceq cn cT cnl cfv vg cv wf
      vg cv vh cv chli wbr wa vh cv cT cfv cabs cfv cc0 wceq vh cv cT cfv cc0
      wceq vh cv cT cfv cabs cfv cr wcel cc0 vh cv cT cfv cabs cfv cle wbr cc0
      vy cv clt wbr vh cv cT cfv cabs cfv vy cv clt wbr wi vy cr wral vh cv cT
      cfv cabs cfv cc0 wceq cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vy
      vh cv cT cfv cabs cfv squeeze0 vg cv vh cv chli wbr vh cv cT cfv cabs cfv
      cr wcel cn cT cnl cfv vg cv wf vg cv vh cv chli wbr vh cv cT cfv cc wcel
      vh cv cT cfv cabs cfv cr wcel vg cv vh cv chli wbr vh cv chil wcel vh cv
      cT cfv cc wcel vh cv vg cv vg visset vh visset hlimveci chil cc vh cv cT
      cT nlelch.1 lnfnfi ffvelrni syl vh cv cT cfv abscl syl adantl vg cv vh cv
      chli wbr cc0 vh cv cT cfv cabs cfv cle wbr cn cT cnl cfv vg cv wf vg cv
      vh cv chli wbr vh cv cT cfv cc wcel cc0 vh cv cT cfv cabs cfv cle wbr vg
      cv vh cv chli wbr vh cv chil wcel vh cv cT cfv cc wcel vh cv vg cv vg
      visset vh visset hlimveci chil cc vh cv cT cT nlelch.1 lnfnfi ffvelrni
      syl vh cv cT cfv absge0 syl adantl cn cT cnl cfv vg cv wf vg cv vh cv
      chli wbr wa cc0 vy cv clt wbr vh cv cT cfv cabs cfv vy cv clt wbr wi vy
      cr cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vy cv cr wcel wa cc0 vy
      cv clt wbr vh cv cT cfv cabs cfv vy cv clt wbr cn cT cnl cfv vg cv wf vg
      cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr vh cv cT cfv cabs
      cfv vy cv clt wbr cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vy cv cr
      wcel cc0 vy cv clt wbr wa wa cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv
      vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi
      vv chil wral wa vx cr wrex vh cv cT cfv cabs cfv vy cv clt wbr vg cv vh
      cv chli wbr vy cv cr wcel cc0 vy cv clt wbr wa cc0 vx cv clt wbr vv cv vh
      cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs
      cfv vy cv clt wbr wi vv chil wral wa vx cr wrex cn cT cnl cfv vg cv wf vh
      cv chil wcel vy cv cr wcel cc0 vy cv clt wbr wa cc0 vx cv clt wbr vv cv
      vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs
      cfv vy cv clt wbr wi vv chil wral wa vx cr wrex vg cv vh cv chli wbr cT
      ccnf wcel vh cv chil wcel vy cv cr wcel cc0 vy cv clt wbr wa cc0 vx cv
      clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT
      cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa vx cr wrex nlelch.2
      vx vv vh cv vy cv cT cnfnc mpanl1 vh cv vg cv vg visset vh visset
      hlimveci sylan adantll cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vy
      cv cr wcel cc0 vy cv clt wbr wa wa cc0 vx cv clt wbr vv cv vh cv cmv co
      cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv
      clt wbr wi vv chil wral wa vh cv cT cfv cabs cfv vy cv clt wbr vx cr cn
      cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt
      wbr wa wa vx cv cr wcel cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx
      cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv
      chil wral wa vh cv cT cfv cabs cfv vy cv clt wbr cn cT cnl cfv vg cv wf
      vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv cr
      wcel cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT
      cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa wa wa
      vm cv vn cv cle wbr vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi
      vn cn wral vm cn wrex vh cv cT cfv cabs cfv vy cv clt wbr cn cT cnl cfv
      vg cv wf vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx
      cv cr wcel cc0 vx cv clt wbr vm cv vn cv cle wbr vn cv vg cv cfv vh cv
      cmv co cno cfv vx cv clt wbr wi vn cn wral vm cn wrex vv cv vh cv cmv co
      cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv
      clt wbr wi vv chil wral vg cv vh cv chli wbr vy cv cr wcel cc0 vy cv clt
      wbr wa vx cv cr wcel cc0 vx cv clt wbr wa vm cv vn cv cle wbr vn cv vg cv
      cfv vh cv cmv co cno cfv vx cv clt wbr wi vn cn wral vm cn wrex cn cT cnl
      cfv vg cv wf vg cv vh cv chli wbr vx cv cr wcel cc0 vx cv clt wbr wa vm
      cv vn cv cle wbr vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi vn
      cn wral vm cn wrex vy cv cr wcel cc0 vy cv clt wbr wa vg cv vh cv chli
      wbr vx cv cr wcel cc0 vx cv clt wbr vm cv vn cv cle wbr vn cv vg cv cfv
      vh cv cmv co cno cfv vx cv clt wbr wi vn cn wral vm cn wrex vg cv vh cv
      chli wbr cc0 vx cv clt wbr vm cv vn cv cle wbr vn cv vg cv cfv vh cv cmv
      co cno cfv vx cv clt wbr wi vn cn wral vm cn wrex wi vx cr wral vx cv cr
      wcel cc0 vx cv clt wbr vm cv vn cv cle wbr vn cv vg cv cfv vh cv cmv co
      cno cfv vx cv clt wbr wi vn cn wral vm cn wrex wi wi vx vm vn vh cv vg cv
      vg visset vh visset hlimconvi cc0 vx cv clt wbr vm cv vn cv cle wbr vn cv
      vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi vn cn wral vm cn wrex wi
      vx cr ra4 syl imp32 adantlr adantlll adantrrr cn cT cnl cfv vg cv wf vg
      cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv cr wcel
      cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv
      vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa wa wa vm
      cv vn cv cle wbr vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi vn
      cn wral vh cv cT cfv cabs cfv vy cv clt wbr vm cn cn cT cnl cfv vg cv wf
      vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv cr
      wcel cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT
      cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa wa wa
      vm cv cn wcel vm cv vm cv cle wbr wa vm cv vn cv cle wbr vn cv vg cv cfv
      vh cv cmv co cno cfv vx cv clt wbr wi vn cn wral vh cv cT cfv cabs cfv vy
      cv clt wbr wi vm cv cn wcel cn cT cnl cfv vg cv wf vg cv vh cv chli wbr
      wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv cr wcel cc0 vx cv clt wbr
      vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin
      co cabs cfv vy cv clt wbr wi vv chil wral wa wa wa vm cv vn cv cle wbr vn
      cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi vn cn wral vm cv cn
      wcel vm cv vm cv cle wbr wa vh cv cT cfv cabs cfv vy cv clt wbr cn cT cnl
      cfv vg cv wf vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa
      wa vx cv cr wcel cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt
      wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil
      wral wa wa wa vm cv vn cv cle wbr vn cv vg cv cfv vh cv cmv co cno cfv vx
      cv clt wbr wi vn cn wral vm cv cn wcel vm cv vm cv cle wbr wa vh cv cT
      cfv cabs cfv vy cv clt wbr wi cn cT cnl cfv vg cv wf vg cv vh cv chli wbr
      wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv cr wcel cc0 vx cv clt wbr
      vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin
      co cabs cfv vy cv clt wbr wi vv chil wral wa wa wa vm cv vn cv cle wbr vn
      cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi vn cn wral wa vm cv cn
      wcel vm cv vm cv cle wbr vh cv cT cfv cabs cfv vy cv clt wbr vm cv cn
      wcel vm cv vn cv cle wbr vh cv cT cfv cabs cfv vy cv clt wbr wi vn cn
      wral vm cv vm cv cle wbr vh cv cT cfv cabs cfv vy cv clt wbr wi cn cT cnl
      cfv vg cv wf vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa
      wa vx cv cr wcel cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt
      wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil
      wral wa wa wa vm cv vn cv cle wbr vn cv vg cv cfv vh cv cmv co cno cfv vx
      cv clt wbr wi vn cn wral wa vm cv vn cv cle wbr vh cv cT cfv cabs cfv vy
      cv clt wbr wi vm cv vm cv cle wbr vh cv cT cfv cabs cfv vy cv clt wbr wi
      vn vm cv cn vn cv vm cv wceq vm cv vn cv cle wbr vm cv vm cv cle wbr vh
      cv cT cfv cabs cfv vy cv clt wbr vn cv vm cv vm cv cle breq2 imbi1d
      rcla4v cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vy cv cr wcel cc0
      vy cv clt wbr wa wa vx cv cr wcel cc0 vx cv clt wbr vv cv vh cv cmv co
      cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv
      clt wbr wi vv chil wral wa wa wa vm cv vn cv cle wbr vn cv vg cv cfv vh
      cv cmv co cno cfv vx cv clt wbr wi vn cn wral vm cv vn cv cle wbr vh cv
      cT cfv cabs cfv vy cv clt wbr wi vn cn wral cn cT cnl cfv vg cv wf vg cv
      vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv cr wcel cc0
      vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv
      cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa wa wa vm cv vn
      cv cle wbr vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr wi vm cv vn
      cv cle wbr vh cv cT cfv cabs cfv vy cv clt wbr wi vn cn cn cT cnl cfv vg
      cv wf vg cv vh cv chli wbr wa vy cv cr wcel cc0 vy cv clt wbr wa wa vx cv
      cr wcel cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv
      cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa wa
      wa vn cv cn wcel wa vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr vh
      cv cT cfv cabs cfv vy cv clt wbr vm cv vn cv cle wbr cn cT cnl cfv vg cv
      wf vg cv vh cv chli wbr wa vx cv cr wcel cc0 vx cv clt wbr vv cv vh cv
      cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv
      vy cv clt wbr wi vv chil wral wa wa vn cv cn wcel vn cv vg cv cfv vh cv
      cmv co cno cfv vx cv clt wbr vh cv cT cfv cabs cfv vy cv clt wbr wi vy cv
      cr wcel cc0 vy cv clt wbr wa cn cT cnl cfv vg cv wf vg cv vh cv chli wbr
      wa cc0 vx cv clt wbr vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT
      cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa vn cv
      cn wcel vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr vh cv cT cfv
      cabs cfv vy cv clt wbr wi vx cv cr wcel cn cT cnl cfv vg cv wf vg cv vh
      cv chli wbr wa vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh
      cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral vn cv cn wcel vn
      cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr vh cv cT cfv cabs cfv vy
      cv clt wbr wi cc0 vx cv clt wbr cn cT cnl cfv vg cv wf vg cv vh cv chli
      wbr wa vn cv cn wcel vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT
      cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral vn cv vg
      cv cfv vh cv cmv co cno cfv vx cv clt wbr vh cv cT cfv cabs cfv vy cv clt
      wbr wi cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vn cv cn wcel wa vv
      cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co
      cabs cfv vy cv clt wbr wi vv chil wral wa vn cv vg cv cfv vh cv cmv co
      cno cfv vx cv clt wbr vh cv cT cfv cabs cfv vy cv clt wbr cn cT cnl cfv
      vg cv wf vg cv vh cv chli wbr wa vn cv cn wcel wa vv cv vh cv cmv co cno
      cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt
      wbr wi vv chil wral wa vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt wbr
      wa vh cv cT cfv cabs cfv vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs
      cfv vy cv clt cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vn cv cn
      wcel wa vh cv cT cfv cabs cfv vn cv vg cv cfv cT cfv vh cv cT cfv cmin co
      cabs cfv wceq vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv
      cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral vn cv vg cv cfv vh
      cv cmv co cno cfv vx cv clt wbr cn cT cnl cfv vg cv wf vg cv vh cv chli
      wbr wa vn cv cn wcel wa vh cv cT cfv cneg cabs cfv vh cv cT cfv cabs cfv
      vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs cfv vg cv vh cv chli wbr
      vh cv cT cfv cneg cabs cfv vh cv cT cfv cabs cfv wceq cn cT cnl cfv vg cv
      wf vn cv cn wcel vg cv vh cv chli wbr vh cv cT cfv cc wcel vh cv cT cfv
      cneg cabs cfv vh cv cT cfv cabs cfv wceq vg cv vh cv chli wbr vh cv chil
      wcel vh cv cT cfv cc wcel vh cv vg cv vg visset vh visset hlimveci chil
      cc vh cv cT cT nlelch.1 lnfnfi ffvelrni syl vh cv cT cfv absneg syl
      ad2antlr cn cT cnl cfv vg cv wf vn cv cn wcel vh cv cT cfv cneg cabs cfv
      vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs cfv wceq vg cv vh cv
      chli wbr cn cT cnl cfv vg cv wf vn cv cn wcel wa vh cv cT cfv cneg vn cv
      vg cv cfv cT cfv vh cv cT cfv cmin co cabs cn cT cnl cfv vg cv wf vn cv
      cn wcel wa vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cc0 vh cv cT cfv
      cmin co vh cv cT cfv cneg cn cT cnl cfv vg cv wf vn cv cn wcel wa vn cv
      vg cv cfv cT cfv cc0 vh cv cT cfv cmin cn cT cnl cfv vg cv wf vn cv cn
      wcel wa vn cv vg cv cfv cT cnl cfv wcel vn cv vg cv cfv cT cfv cc0 wceq
      cn cT cnl cfv vn cv vg cv ffvelrn chil cc cT wf vn cv vg cv cfv cT cnl
      cfv wcel vn cv vg cv cfv cT cfv cc0 wceq cT nlelch.1 lnfnfi vn cv vg cv
      cfv cT elnlfn2 mpan syl opreq1d vh cv cT cfv df-neg syl6reqr fveq2d
      adantlr eqtr3d ad2antrr cn cT cnl cfv vg cv wf vg cv vh cv chli wbr wa vn
      cv cn wcel wa vv cv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv
      cT cfv cmin co cabs cfv vy cv clt wbr wi vv chil wral wa vn cv vg cv cfv
      vh cv cmv co cno cfv vx cv clt wbr vn cv vg cv cfv cT cfv vh cv cT cfv
      cmin co cabs cfv vy cv clt wbr cn cT cnl cfv vg cv wf vn cv cn wcel vv cv
      vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs
      cfv vy cv clt wbr wi vv chil wral vn cv vg cv cfv vh cv cmv co cno cfv vx
      cv clt wbr vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt
      wbr wi vg cv vh cv chli wbr vn cv vg cv cfv chil wcel vv cv vh cv cmv co
      cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv
      clt wbr wi vv chil wral vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt
      wbr vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi
      cn cT cnl cfv vg cv wf vn cv cn wcel wa vv cv vh cv cmv co cno cfv vx cv
      clt wbr vv cv cT cfv vh cv cT cfv cmin co cabs cfv vy cv clt wbr wi vn cv
      vg cv cfv vh cv cmv co cno cfv vx cv clt wbr vn cv vg cv cfv cT cfv vh cv
      cT cfv cmin co cabs cfv vy cv clt wbr wi vv vn cv vg cv cfv chil vv cv vn
      cv vg cv cfv wceq vv cv vh cv cmv co cno cfv vx cv clt wbr vn cv vg cv
      cfv vh cv cmv co cno cfv vx cv clt wbr vv cv cT cfv vh cv cT cfv cmin co
      cabs cfv vy cv clt wbr vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs
      cfv vy cv clt wbr vv cv vn cv vg cv cfv wceq vv cv vh cv cmv co cno cfv
      vn cv vg cv cfv vh cv cmv co cno cfv vx cv clt vv cv vn cv vg cv cfv wceq
      vv cv vh cv cmv co vn cv vg cv cfv vh cv cmv co cno vv cv vn cv vg cv cfv
      vh cv cmv opreq1 fveq2d breq1d vv cv vn cv vg cv cfv wceq vv cv cT cfv vh
      cv cT cfv cmin co cabs cfv vn cv vg cv cfv cT cfv vh cv cT cfv cmin co
      cabs cfv vy cv clt vv cv vn cv vg cv cfv wceq vv cv cT cfv vh cv cT cfv
      cmin co vn cv vg cv cfv cT cfv vh cv cT cfv cmin co cabs vv cv vn cv vg
      cv cfv wceq vv cv cT cfv vn cv vg cv cfv cT cfv vh cv cT cfv cmin vv cv
      vn cv vg cv cfv cT fveq2 opreq1d fveq2d breq1d imbi12d rcla4va cn cT cnl
      cfv vg cv wf vn cv cn wcel wa vn cv vg cv cfv cT cnl cfv wcel vn cv vg cv
      cfv chil wcel cn cT cnl cfv vn cv vg cv ffvelrn vn cv vg cv cfv cT cnl
      cfv cT nlelch.1 nlelshi sheli syl sylan adantllr imp eqbrtrd ex an1rs
      adantlrl adantlrl adantllr imim2d r19.20dva imp syl5com imp3a ex com23 vm
      cv cn wcel vm cv vm cv cle wbr vm cv cn wcel vm cv cr wcel vm cv vm cv
      cle wbr vm cv nnre vm cv leid syl ancli syl5 r19.23adv mpd exp32
      r19.23adv mpd anassrs ex r19.21aiva syl3anc vg cv vh cv chli wbr vh cv cT
      cfv cabs cfv cc0 wceq vh cv cT cfv cc0 wceq wb cn cT cnl cfv vg cv wf vg
      cv vh cv chli wbr vh cv cT cfv cc wcel vh cv cT cfv cabs cfv cc0 wceq vh
      cv cT cfv cc0 wceq wb vg cv vh cv chli wbr vh cv chil wcel vh cv cT cfv
      cc wcel vh cv vg cv vg visset vh visset hlimveci chil cc vh cv cT cT
      nlelch.1 lnfnfi ffvelrni syl vh cv cT cfv abs00 syl adantl mpbid vg cv vh
      cv chli wbr vh cv cT cnl cfv wcel vh cv cT cfv cc0 wceq wb cn cT cnl cfv
      vg cv wf vg cv vh cv chli wbr vh cv chil wcel vh cv cT cnl cfv wcel vh cv
      cT cfv cc0 wceq wb vh cv vg cv vg visset vh visset hlimveci chil cc cT wf
      vh cv chil wcel vh cv cT cnl cfv wcel vh cv cT cfv cc0 wceq wb cT
      nlelch.1 lnfnfi vh cv cT elnlfn mpan syl adantl mpbird gen2 mpbir2an $.
      $( [25-Apr-2006] $) $( [11-Feb-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Riesz lemma
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

   ${
    $d g h m n u v w x y T $.
    nlelch.1 $e |- T e. LinFn $.
    nlelch.2 $e |- T e. ConFn $.
    $( A continuous linear functional can be expressed as an inner product.
       Existence part of Theorem 3.9 of [Beran] p. 104. $)
    riesz3i $p |- E. w e. ~H A. v e. ~H ( T ` v ) = ( v .ih w ) $=
      vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw chil wrex cT cnl cfv
      cort cfv c0h cT cnl cfv cort cfv c0h wceq vv cv cT cfv vv cv c0v csp co
      wceq vv chil wral vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw
      chil wrex cT cnl cfv cort cfv c0h wceq vv cv cT cfv vv cv c0v csp co wceq
      vv chil cT cnl cfv cort cfv c0h wceq vv cv chil wcel wa vv cv cT cfv cc0
      vv cv c0v csp co cT cnl cfv cort cfv c0h wceq vv cv chil wcel wa vv cv cT
      cnl cfv wcel vv cv cT cfv cc0 wceq cT cnl cfv cort cfv c0h wceq vv cv cT
      cnl cfv wcel vv cv chil wcel cT cnl cfv cort cfv c0h wceq cT cnl cfv chil
      vv cv cT cnl cfv cort cfv c0h wceq cT cnl cfv cort cfv cort cfv c0h cort
      cfv cT cnl cfv chil cT cnl cfv cort cfv c0h cort fveq2 cT cnl cfv cT
      nlelch.1 nlelch.2 nlelchi ococi choc0 3eqtr3g eleq2d biimpar chil cc cT
      wf vv cv cT cnl cfv wcel vv cv cT cfv cc0 wceq cT nlelch.1 lnfnfi vv cv
      cT elnlfn2 mpan syl vv cv chil wcel vv cv c0v csp co cc0 wceq cT cnl cfv
      cort cfv c0h wceq vv cv hi02 adantl eqtr4d r19.21aiva c0v chil wcel vv cv
      cT cfv vv cv c0v csp co wceq vv chil wral vv cv cT cfv vv cv vw cv csp co
      wceq vv chil wral vw chil wrex ax-hv0cl vv cv cT cfv vv cv vw cv csp co
      wceq vv chil wral vv cv cT cfv vv cv c0v csp co wceq vv chil wral vw c0v
      chil vw cv c0v wceq vv cv cT cfv vv cv vw cv csp co wceq vv cv cT cfv vv
      cv c0v csp co wceq vv chil vw cv c0v wceq vv cv vw cv csp co vv cv c0v
      csp co vv cv cT cfv vw cv c0v vv cv csp opreq2 eqeq2d ralbidv rcla4ev
      mpan syl cT cnl cfv cort cfv c0h wne vu cv c0v wne vu cT cnl cfv cort cfv
      wrex vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw chil wrex vu cT
      cnl cfv cort cfv cT cnl cfv cT nlelch.1 nlelch.2 nlelchi choccli chne0i
      vu cv c0v wne vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw chil
      wrex vu cT cnl cfv cort cfv vu cv cT cnl cfv cort cfv wcel vu cv chil
      wcel vu cv c0v wne vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw
      chil wrex wi vu cv cT cnl cfv cort cfv cT cnl cfv cT nlelch.1 nlelch.2
      nlelchi choccli cheli vu cv cT cnl cfv cort cfv wcel vu cv chil wcel wa
      vu cv c0v wne vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw chil
      wrex vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv vu cv csm co chil
      wcel vv cv cT cfv vv cv vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv
      vu cv csm co csp co wceq vv chil wral vv cv cT cfv vv cv vw cv csp co
      wceq vv chil wral vw chil wrex vu cv cT cnl cfv cort cfv wcel vu cv chil
      wcel wa vu cv c0v wne wa vv cv cT cfv vv cv vw cv csp co wceq vv chil
      wral vv cv cT cfv vv cv vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv
      vu cv csm co csp co wceq vv chil wral vw vu cv cT cfv vu cv vu cv csp co
      cdiv co ccj cfv vu cv csm co chil vw cv vu cv cT cfv vu cv vu cv csp co
      cdiv co ccj cfv vu cv csm co wceq vv cv cT cfv vv cv vw cv csp co wceq vv
      cv cT cfv vv cv vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv vu cv csm
      co csp co wceq vv chil vw cv vu cv cT cfv vu cv vu cv csp co cdiv co ccj
      cfv vu cv csm co wceq vv cv vw cv csp co vv cv vu cv cT cfv vu cv vu cv
      csp co cdiv co ccj cfv vu cv csm co csp co vv cv cT cfv vw cv vu cv cT
      cfv vu cv vu cv csp co cdiv co ccj cfv vu cv csm co vv cv csp opreq2
      eqeq2d ralbidv rcla4ev vu cv chil wcel vu cv c0v wne vu cv cT cfv vu cv
      vu cv csp co cdiv co ccj cfv vu cv csm co chil wcel vu cv cT cnl cfv cort
      cfv wcel vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv cc wcel vu cv
      chil wcel vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv vu cv csm co
      chil wcel vu cv chil wcel vu cv c0v wne wa vu cv cT cfv vu cv vu cv csp
      co cdiv co ccj cfv vu cv hvmulcl vu cv chil wcel vu cv c0v wne wa vu cv
      cT cfv vu cv vu cv csp co cdiv co cc wcel vu cv cT cfv vu cv vu cv csp co
      cdiv co ccj cfv cc wcel vu cv cT cfv cc wcel vu cv vu cv csp co cc wcel
      vu cv vu cv csp co cc0 wne vu cv cT cfv vu cv vu cv csp co cdiv co cc
      wcel vu cv chil wcel vu cv c0v wne wa vu cv cT cfv vu cv vu cv csp co
      divcl vu cv chil wcel vu cv cT cfv cc wcel vu cv c0v wne chil cc vu cv cT
      cT nlelch.1 lnfnfi ffvelrni adantr vu cv chil wcel vu cv vu cv csp co cc
      wcel vu cv c0v wne vu cv chil wcel vu cv vu cv csp co cc wcel vu cv vu cv
      hicl anidms adantr vu cv chil wcel vu cv vu cv csp co cc0 wne vu cv c0v
      wne vu cv chil wcel vu cv vu cv csp co cc0 vu cv c0v vu cv his6 necon3bid
      biimpar syl3anc vu cv cT cfv vu cv vu cv csp co cdiv co cjcl syl vu cv
      chil wcel vu cv c0v wne pm3.26 sylanc adantll vu cv cT cnl cfv cort cfv
      wcel vu cv chil wcel wa vu cv c0v wne wa vv cv cT cfv vv cv vu cv cT cfv
      vu cv vu cv csp co cdiv co ccj cfv vu cv csm co csp co wceq vv chil vu cv
      cT cnl cfv cort cfv wcel vu cv chil wcel wa vu cv c0v wne wa vv cv chil
      wcel wa vu cv cT cfv vv cv vu cv csp co cmul co vu cv vu cv csp co cdiv
      co vv cv cT cfv vv cv vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv vu
      cv csm co csp co vu cv cT cnl cfv cort cfv wcel vu cv chil wcel wa vu cv
      c0v wne wa vv cv chil wcel wa vu cv cT cfv vv cv vu cv csp co cmul co vu
      cv vu cv csp co cdiv co vv cv cT cfv wceq vu cv cT cfv vv cv vu cv csp co
      cmul co vv cv cT cfv vu cv vu cv csp co cmul co wceq vu cv cT cnl cfv
      cort cfv wcel vu cv chil wcel wa vv cv chil wcel vu cv cT cfv vv cv vu cv
      csp co cmul co vv cv cT cfv vu cv vu cv csp co cmul co wceq vu cv c0v wne
      vu cv cT cnl cfv cort cfv wcel vu cv chil wcel wa vv cv chil wcel wa vu
      cv cT cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp co cmul
      co cmin co cc0 wceq vu cv cT cfv vv cv vu cv csp co cmul co vv cv cT cfv
      vu cv vu cv csp co cmul co wceq vu cv cT cnl cfv cort cfv wcel vu cv chil
      wcel wa vv cv chil wcel wa vu cv cT cfv vv cv vu cv csp co cmul co vv cv
      cT cfv vu cv vu cv csp co cmul co cmin co vu cv cT cfv vv cv csm co vv cv
      cT cfv vu cv csm co cmv co vu cv csp co cc0 vu cv chil wcel vv cv chil
      wcel vu cv cT cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp
      co cmul co cmin co vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co
      cmv co vu cv csp co wceq vu cv cT cnl cfv cort cfv wcel vu cv chil wcel
      vv cv chil wcel wa vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co
      cmv co vu cv csp co vu cv cT cfv vv cv csm co vu cv csp co vv cv cT cfv
      vu cv csm co vu cv csp co cmin co vu cv cT cfv vv cv vu cv csp co cmul co
      vv cv cT cfv vu cv vu cv csp co cmul co cmin co vu cv cT cfv vv cv csm co
      chil wcel vv cv cT cfv vu cv csm co chil wcel vu cv chil wcel vu cv cT
      cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co vu cv csp co vu cv cT
      cfv vv cv csm co vu cv csp co vv cv cT cfv vu cv csm co vu cv csp co cmin
      co wceq vu cv chil wcel vv cv chil wcel wa vu cv cT cfv vv cv csm co vv
      cv cT cfv vu cv csm co vu cv his2sub vu cv cT cfv cc wcel vv cv chil wcel
      vu cv cT cfv vv cv csm co chil wcel vu cv chil wcel vu cv cT cfv vv cv
      hvmulcl chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni sylan vv cv chil
      wcel vu cv chil wcel vv cv cT cfv vu cv csm co chil wcel vv cv cT cfv cc
      wcel vu cv chil wcel vv cv cT cfv vu cv csm co chil wcel vv cv chil wcel
      vv cv cT cfv vu cv hvmulcl chil cc vv cv cT cT nlelch.1 lnfnfi ffvelrni
      sylan ancoms vu cv chil wcel vv cv chil wcel pm3.26 syl3anc vu cv chil
      wcel vv cv chil wcel wa vu cv cT cfv vv cv csm co vu cv csp co vu cv cT
      cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv csm co vu cv csp co vv
      cv cT cfv vu cv vu cv csp co cmul co cmin vu cv cT cfv cc wcel vv cv chil
      wcel vu cv chil wcel vu cv cT cfv vv cv csm co vu cv csp co vu cv cT cfv
      vv cv vu cv csp co cmul co wceq vu cv chil wcel vv cv chil wcel wa vu cv
      cT cfv vv cv vu cv ax-his3 vu cv chil wcel vu cv cT cfv cc wcel vv cv
      chil wcel chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni adantr vu cv chil
      wcel vv cv chil wcel pm3.27 vu cv chil wcel vv cv chil wcel pm3.26
      syl3anc vv cv cT cfv cc wcel vu cv chil wcel vu cv chil wcel vv cv cT cfv
      vu cv csm co vu cv csp co vv cv cT cfv vu cv vu cv csp co cmul co wceq vu
      cv chil wcel vv cv chil wcel wa vv cv cT cfv vu cv vu cv ax-his3 vv cv
      chil wcel vv cv cT cfv cc wcel vu cv chil wcel chil cc vv cv cT cT
      nlelch.1 lnfnfi ffvelrni adantl vu cv chil wcel vv cv chil wcel pm3.26 vu
      cv chil wcel vv cv chil wcel pm3.26 syl3anc opreq12d eqtr2d adantll vu cv
      cT cnl cfv cort cfv wcel vu cv chil wcel vv cv chil wcel vu cv cT cfv vv
      cv csm co vv cv cT cfv vu cv csm co cmv co vu cv csp co cc0 wceq vu cv
      chil wcel vv cv chil wcel wa vu cv cT cnl cfv cort cfv wcel vu cv cT cfv
      vv cv csm co vv cv cT cfv vu cv csm co cmv co vu cv csp co cc0 wceq vu cv
      cT cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co cT cnl cfv wcel vu
      cv cT cnl cfv cort cfv wcel vu cv cT cfv vv cv csm co vv cv cT cfv vu cv
      csm co cmv co vu cv csp co cc0 wceq vu cv chil wcel vv cv chil wcel wa cT
      cnl cfv chil wss vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co cmv
      co cT cnl cfv wcel vu cv cT cnl cfv cort cfv wcel wa vu cv cT cfv vv cv
      csm co vv cv cT cfv vu cv csm co cmv co vu cv csp co cc0 wceq wi cT cnl
      cfv cT nlelch.1 nlelch.2 nlelchi chssii vu cv cT cfv vv cv csm co vv cv
      cT cfv vu cv csm co cmv co vu cv cT cnl cfv ocorth ax-mp vu cv chil wcel
      vv cv chil wcel wa vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co
      cmv co cT cnl cfv wcel vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm
      co cmv co cT cfv cc0 wceq vu cv chil wcel vv cv chil wcel wa vu cv cT cfv
      vv cv csm co vv cv cT cfv vu cv csm co cmv co cT cfv vu cv cT cfv vv cv
      csm co cT cfv vv cv cT cfv vu cv csm co cT cfv cmin co vu cv cT cfv vv cv
      cT cfv cmul co vu cv cT cfv vv cv cT cfv cmul co cmin co cc0 vu cv cT cfv
      vv cv csm co chil wcel vv cv cT cfv vu cv csm co chil wcel vu cv cT cfv
      vv cv csm co vv cv cT cfv vu cv csm co cmv co cT cfv vu cv cT cfv vv cv
      csm co cT cfv vv cv cT cfv vu cv csm co cT cfv cmin co wceq vu cv chil
      wcel vv cv chil wcel wa vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm
      co cT nlelch.1 lnfnsubi vu cv cT cfv cc wcel vv cv chil wcel vu cv cT cfv
      vv cv csm co chil wcel vu cv chil wcel vu cv cT cfv vv cv hvmulcl chil cc
      vu cv cT cT nlelch.1 lnfnfi ffvelrni sylan vv cv chil wcel vu cv chil
      wcel vv cv cT cfv vu cv csm co chil wcel vv cv cT cfv cc wcel vu cv chil
      wcel vv cv cT cfv vu cv csm co chil wcel vv cv chil wcel vv cv cT cfv vu
      cv hvmulcl chil cc vv cv cT cT nlelch.1 lnfnfi ffvelrni sylan ancoms
      sylanc vu cv chil wcel vv cv chil wcel wa vu cv cT cfv vv cv csm co cT
      cfv vu cv cT cfv vv cv cT cfv cmul co vv cv cT cfv vu cv csm co cT cfv vu
      cv cT cfv vv cv cT cfv cmul co cmin vu cv cT cfv cc wcel vv cv chil wcel
      vu cv cT cfv vv cv csm co cT cfv vu cv cT cfv vv cv cT cfv cmul co wceq
      vu cv chil wcel vu cv cT cfv vv cv cT nlelch.1 lnfnmuli chil cc vu cv cT
      cT nlelch.1 lnfnfi ffvelrni sylan vv cv chil wcel vu cv chil wcel vv cv
      cT cfv vu cv csm co cT cfv vu cv cT cfv vv cv cT cfv cmul co wceq vv cv
      cT cfv cc wcel vu cv chil wcel vv cv cT cfv vu cv csm co cT cfv vu cv cT
      cfv vv cv cT cfv cmul co wceq vv cv chil wcel vv cv cT cfv cc wcel vu cv
      chil wcel wa vv cv cT cfv vu cv csm co cT cfv vv cv cT cfv vu cv cT cfv
      cmul co vu cv cT cfv vv cv cT cfv cmul co vv cv cT cfv vu cv cT nlelch.1
      lnfnmuli vv cv cT cfv cc wcel vu cv cT cfv cc wcel vv cv cT cfv vu cv cT
      cfv cmul co vu cv cT cfv vv cv cT cfv cmul co wceq vu cv chil wcel vv cv
      cT cfv vu cv cT cfv mulcom chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni
      sylan2 eqtrd chil cc vv cv cT cT nlelch.1 lnfnfi ffvelrni sylan ancoms
      opreq12d vu cv chil wcel vv cv chil wcel wa vu cv cT cfv vv cv cT cfv
      cmul co cc wcel vu cv cT cfv vv cv cT cfv cmul co vu cv cT cfv vv cv cT
      cfv cmul co cmin co cc0 wceq vu cv cT cfv cc wcel vv cv cT cfv cc wcel vu
      cv cT cfv vv cv cT cfv cmul co cc wcel vu cv chil wcel vv cv chil wcel vu
      cv cT cfv vv cv cT cfv mulcl chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni
      chil cc vv cv cT cT nlelch.1 lnfnfi ffvelrni syl2an vu cv cT cfv vv cv cT
      cfv cmul co subid syl 3eqtrd vu cv chil wcel vv cv chil wcel wa vu cv cT
      cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co chil wcel vu cv cT cfv
      vv cv csm co vv cv cT cfv vu cv csm co cmv co cT cnl cfv wcel vu cv cT
      cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co cT cfv cc0 wceq wb vu
      cv cT cfv vv cv csm co chil wcel vv cv cT cfv vu cv csm co chil wcel vu
      cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co chil wcel vu cv
      chil wcel vv cv chil wcel wa vu cv cT cfv vv cv csm co vv cv cT cfv vu cv
      csm co hvsubcl vu cv cT cfv cc wcel vv cv chil wcel vu cv cT cfv vv cv
      csm co chil wcel vu cv chil wcel vu cv cT cfv vv cv hvmulcl chil cc vu cv
      cT cT nlelch.1 lnfnfi ffvelrni sylan vv cv chil wcel vu cv chil wcel vv
      cv cT cfv vu cv csm co chil wcel vv cv cT cfv cc wcel vu cv chil wcel vv
      cv cT cfv vu cv csm co chil wcel vv cv chil wcel vv cv cT cfv vu cv
      hvmulcl chil cc vv cv cT cT nlelch.1 lnfnfi ffvelrni sylan ancoms sylanc
      chil cc cT wf vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co
      chil wcel vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co cT
      cnl cfv wcel vu cv cT cfv vv cv csm co vv cv cT cfv vu cv csm co cmv co
      cT cfv cc0 wceq wb cT nlelch.1 lnfnfi vu cv cT cfv vv cv csm co vv cv cT
      cfv vu cv csm co cmv co cT elnlfn mpan syl mpbird sylan ancoms anassrs
      eqtrd vu cv chil wcel vv cv chil wcel vu cv cT cfv vv cv vu cv csp co
      cmul co vv cv cT cfv vu cv vu cv csp co cmul co cmin co cc0 wceq vu cv cT
      cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp co cmul co
      wceq wb vu cv cT cnl cfv cort cfv wcel vu cv cT cfv vv cv vu cv csp co
      cmul co cc wcel vv cv cT cfv vu cv vu cv csp co cmul co cc wcel vu cv cT
      cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp co cmul co
      cmin co cc0 wceq vu cv cT cfv vv cv vu cv csp co cmul co vv cv cT cfv vu
      cv vu cv csp co cmul co wceq wb vu cv chil wcel vv cv chil wcel wa vu cv
      cT cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp co cmul co
      subeq0 vu cv cT cfv cc wcel vv cv vu cv csp co cc wcel vu cv cT cfv vv cv
      vu cv csp co cmul co cc wcel vu cv chil wcel vv cv chil wcel wa vu cv cT
      cfv vv cv vu cv csp co mulcl vu cv chil wcel vu cv cT cfv cc wcel vv cv
      chil wcel chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni adantr vv cv chil
      wcel vu cv chil wcel vv cv vu cv csp co cc wcel vv cv vu cv hicl ancoms
      sylanc vv cv chil wcel vu cv chil wcel vv cv cT cfv vu cv vu cv csp co
      cmul co cc wcel vv cv cT cfv cc wcel vu cv vu cv csp co cc wcel vv cv cT
      cfv vu cv vu cv csp co cmul co cc wcel vv cv chil wcel vu cv chil wcel vv
      cv cT cfv vu cv vu cv csp co mulcl chil cc vv cv cT cT nlelch.1 lnfnfi
      ffvelrni vu cv chil wcel vu cv vu cv csp co cc wcel vu cv vu cv hicl
      anidms syl2an ancoms sylanc adantll mpbid adantlr vu cv chil wcel vu cv
      c0v wne vv cv chil wcel vu cv cT cfv vv cv vu cv csp co cmul co vu cv vu
      cv csp co cdiv co vv cv cT cfv wceq vu cv cT cfv vv cv vu cv csp co cmul
      co vv cv cT cfv vu cv vu cv csp co cmul co wceq wb vu cv cT cnl cfv cort
      cfv wcel vu cv cT cfv vv cv vu cv csp co cmul co cc wcel vv cv cT cfv cc
      wcel vu cv vu cv csp co cc wcel vu cv vu cv csp co cc0 wne wa vu cv cT
      cfv vv cv vu cv csp co cmul co vu cv vu cv csp co cdiv co vv cv cT cfv
      wceq vu cv cT cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp
      co cmul co wceq wb vu cv chil wcel vu cv c0v wne wa vv cv chil wcel wa vu
      cv cT cfv vv cv vu cv csp co cmul co vv cv cT cfv vu cv vu cv csp co
      divmul3 vu cv chil wcel vv cv chil wcel vu cv cT cfv vv cv vu cv csp co
      cmul co cc wcel vu cv c0v wne vu cv cT cfv cc wcel vv cv vu cv csp co cc
      wcel vu cv cT cfv vv cv vu cv csp co cmul co cc wcel vu cv chil wcel vv
      cv chil wcel wa vu cv cT cfv vv cv vu cv csp co mulcl vu cv chil wcel vu
      cv cT cfv cc wcel vv cv chil wcel chil cc vu cv cT cT nlelch.1 lnfnfi
      ffvelrni adantr vv cv chil wcel vu cv chil wcel vv cv vu cv csp co cc
      wcel vv cv vu cv hicl ancoms sylanc adantlr vv cv chil wcel vv cv cT cfv
      cc wcel vu cv chil wcel vu cv c0v wne wa chil cc vv cv cT cT nlelch.1
      lnfnfi ffvelrni adantl vu cv chil wcel vu cv c0v wne wa vu cv vu cv csp
      co cc wcel vu cv vu cv csp co cc0 wne wa vv cv chil wcel vu cv chil wcel
      vu cv c0v wne wa vu cv vu cv csp co cc wcel vu cv vu cv csp co cc0 wne vu
      cv chil wcel vu cv vu cv csp co cc wcel vu cv c0v wne vu cv chil wcel vu
      cv vu cv csp co cc wcel vu cv vu cv hicl anidms adantr vu cv chil wcel vu
      cv vu cv csp co cc0 wne vu cv c0v wne vu cv chil wcel vu cv vu cv csp co
      cc0 vu cv c0v vu cv his6 necon3bid biimpar jca adantr syl3anc adantlll
      mpbird vu cv chil wcel vu cv c0v wne vv cv chil wcel vu cv cT cfv vv cv
      vu cv csp co cmul co vu cv vu cv csp co cdiv co vv cv vu cv cT cfv vu cv
      vu cv csp co cdiv co ccj cfv vu cv csm co csp co wceq vu cv cT cnl cfv
      cort cfv wcel vu cv chil wcel vu cv c0v wne wa vv cv chil wcel wa vu cv
      cT cfv vv cv vu cv csp co cmul co vu cv vu cv csp co cdiv co vu cv cT cfv
      vu cv vu cv csp co cdiv co vv cv vu cv csp co cmul co vv cv vu cv cT cfv
      vu cv vu cv csp co cdiv co ccj cfv vu cv csm co csp co vu cv cT cfv cc
      wcel vv cv vu cv csp co cc wcel vu cv vu cv csp co cc wcel vu cv vu cv
      csp co cc0 wne wa vu cv cT cfv vv cv vu cv csp co cmul co vu cv vu cv csp
      co cdiv co vu cv cT cfv vu cv vu cv csp co cdiv co vv cv vu cv csp co
      cmul co wceq vu cv chil wcel vu cv c0v wne wa vv cv chil wcel wa vu cv cT
      cfv vv cv vu cv csp co vu cv vu cv csp co div23 vu cv chil wcel vu cv c0v
      wne wa vu cv cT cfv cc wcel vv cv chil wcel vu cv chil wcel vu cv cT cfv
      cc wcel vu cv c0v wne chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni adantr
      adantr vu cv chil wcel vv cv chil wcel vv cv vu cv csp co cc wcel vu cv
      c0v wne vv cv chil wcel vu cv chil wcel vv cv vu cv csp co cc wcel vv cv
      vu cv hicl ancoms adantlr vu cv chil wcel vu cv c0v wne wa vu cv vu cv
      csp co cc wcel vu cv vu cv csp co cc0 wne wa vv cv chil wcel vu cv chil
      wcel vu cv c0v wne wa vu cv vu cv csp co cc wcel vu cv vu cv csp co cc0
      wne vu cv chil wcel vu cv vu cv csp co cc wcel vu cv c0v wne vu cv chil
      wcel vu cv vu cv csp co cc wcel vu cv vu cv hicl anidms adantr vu cv chil
      wcel vu cv vu cv csp co cc0 wne vu cv c0v wne vu cv chil wcel vu cv vu cv
      csp co cc0 vu cv c0v vu cv his6 necon3bid biimpar jca adantr syl3anc vu
      cv cT cfv vu cv vu cv csp co cdiv co cc wcel vv cv chil wcel vu cv chil
      wcel vv cv vu cv cT cfv vu cv vu cv csp co cdiv co ccj cfv vu cv csm co
      csp co vu cv cT cfv vu cv vu cv csp co cdiv co vv cv vu cv csp co cmul co
      wceq vu cv chil wcel vu cv c0v wne wa vv cv chil wcel wa vu cv cT cfv vu
      cv vu cv csp co cdiv co vv cv vu cv his52 vu cv chil wcel vu cv c0v wne
      wa vu cv cT cfv vu cv vu cv csp co cdiv co cc wcel vv cv chil wcel vu cv
      cT cfv cc wcel vu cv vu cv csp co cc wcel vu cv vu cv csp co cc0 wne vu
      cv cT cfv vu cv vu cv csp co cdiv co cc wcel vu cv chil wcel vu cv c0v
      wne wa vu cv cT cfv vu cv vu cv csp co divcl vu cv chil wcel vu cv cT cfv
      cc wcel vu cv c0v wne chil cc vu cv cT cT nlelch.1 lnfnfi ffvelrni adantr
      vu cv chil wcel vu cv vu cv csp co cc wcel vu cv c0v wne vu cv chil wcel
      vu cv vu cv csp co cc wcel vu cv vu cv hicl anidms adantr vu cv chil wcel
      vu cv vu cv csp co cc0 wne vu cv c0v wne vu cv chil wcel vu cv vu cv csp
      co cc0 vu cv c0v vu cv his6 necon3bid biimpar syl3anc adantr vu cv chil
      wcel vu cv c0v wne wa vv cv chil wcel pm3.27 vu cv chil wcel vu cv c0v
      wne vv cv chil wcel simpll syl3anc eqtr4d adantlll eqtr3d r19.21aiva
      sylanc ex mpdan r19.23aiv sylbi pm2.61ine $.
      $( [26-Apr-2006] $) $( [13-Feb-2006] $)

    $( A continuous linear functional can be expressed as an inner product.
       Uniqueness part of Theorem 3.9 of [Beran] p. 104. $)
    riesz4i $p |- E! w e. ~H A. v e. ~H ( T ` v ) = ( v .ih w ) $=
      vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw chil wreu vv cv cT
      cfv vv cv vw cv csp co wceq vv chil wral vw chil wrex vv cv cT cfv vv cv
      vw cv csp co wceq vv chil wral vv cv cT cfv vv cv vu cv csp co wceq vv
      chil wral wa vw cv vu cv wceq wi vu chil wral vw chil wral vv cv cT cfv
      vv cv vw cv csp co wceq vv chil wral vv cv cT cfv vv cv vu cv csp co wceq
      vv chil wral vw vu chil vw cv vu cv wceq vv cv cT cfv vv cv vw cv csp co
      wceq vv cv cT cfv vv cv vu cv csp co wceq vv chil vw cv vu cv wceq vv cv
      vw cv csp co vv cv vu cv csp co vv cv cT cfv vw cv vu cv vv cv csp opreq2
      eqeq2d ralbidv reu4 vw vv cT nlelch.1 nlelch.2 riesz3i vv cv cT cfv vv cv
      vw cv csp co wceq vv chil wral vv cv cT cfv vv cv vu cv csp co wceq vv
      chil wral wa vw cv vu cv wceq wi vw vu chil vw cv chil wcel vu cv chil
      wcel wa vv cv vw cv csp co vv cv vu cv csp co cmin co cc0 wceq vv chil
      wral vw cv vu cv wceq vv cv cT cfv vv cv vw cv csp co wceq vv chil wral
      vv cv cT cfv vv cv vu cv csp co wceq vv chil wral wa vw cv chil wcel vu
      cv chil wcel wa vv cv vw cv csp co vv cv vu cv csp co cmin co cc0 wceq vv
      chil wral vw cv vu cv cmv co vw cv csp co vw cv vu cv cmv co vu cv csp co
      cmin co cc0 wceq vw cv vu cv wceq vw cv chil wcel vu cv chil wcel wa vw
      cv vu cv cmv co chil wcel vv cv vw cv csp co vv cv vu cv csp co cmin co
      cc0 wceq vv chil wral vw cv vu cv cmv co vw cv csp co vw cv vu cv cmv co
      vu cv csp co cmin co cc0 wceq wi vw cv vu cv hvsubcl vv cv vw cv csp co
      vv cv vu cv csp co cmin co cc0 wceq vw cv vu cv cmv co vw cv csp co vw cv
      vu cv cmv co vu cv csp co cmin co cc0 wceq vv vw cv vu cv cmv co chil vv
      cv vw cv vu cv cmv co wceq vv cv vw cv csp co vv cv vu cv csp co cmin co
      vw cv vu cv cmv co vw cv csp co vw cv vu cv cmv co vu cv csp co cmin co
      cc0 vv cv vw cv vu cv cmv co wceq vv cv vw cv csp co vw cv vu cv cmv co
      vw cv csp co vv cv vu cv csp co vw cv vu cv cmv co vu cv csp co cmin vv
      cv vw cv vu cv cmv co vw cv csp opreq1 vv cv vw cv vu cv cmv co vu cv csp
      opreq1 opreq12d eqeq1d rcla4v syl vw cv chil wcel vu cv chil wcel wa vw
      cv vu cv cmv co cno cfv c2 cexp co cc0 wceq vw cv vu cv cmv co c0v wceq
      vw cv vu cv cmv co vw cv csp co vw cv vu cv cmv co vu cv csp co cmin co
      cc0 wceq vw cv vu cv wceq vw cv chil wcel vu cv chil wcel wa vw cv vu cv
      cmv co chil wcel vw cv vu cv cmv co cno cfv c2 cexp co cc0 wceq vw cv vu
      cv cmv co c0v wceq wb vw cv vu cv hvsubcl vw cv vu cv cmv co chil wcel vw
      cv vu cv cmv co cno cfv c2 cexp co cc0 wceq vw cv vu cv cmv co cno cfv
      cc0 wceq vw cv vu cv cmv co c0v wceq vw cv vu cv cmv co chil wcel vw cv
      vu cv cmv co cno cfv cc wcel vw cv vu cv cmv co cno cfv c2 cexp co cc0
      wceq vw cv vu cv cmv co cno cfv cc0 wceq wb vw cv vu cv cmv co chil wcel
      vw cv vu cv cmv co cno cfv vw cv vu cv cmv co normcl recnd vw cv vu cv
      cmv co cno cfv sqeq0 syl vw cv vu cv cmv co norm-i bitrd syl vw cv chil
      wcel vu cv chil wcel wa vw cv vu cv cmv co cno cfv c2 cexp co vw cv vu cv
      cmv co vw cv csp co vw cv vu cv cmv co vu cv csp co cmin co cc0 vw cv
      chil wcel vu cv chil wcel wa vw cv vu cv cmv co cno cfv c2 cexp co vw cv
      vu cv cmv co vw cv vu cv cmv co csp co vw cv vu cv cmv co vw cv csp co vw
      cv vu cv cmv co vu cv csp co cmin co vw cv chil wcel vu cv chil wcel wa
      vw cv vu cv cmv co chil wcel vw cv vu cv cmv co cno cfv c2 cexp co vw cv
      vu cv cmv co vw cv vu cv cmv co csp co wceq vw cv vu cv hvsubcl vw cv vu
      cv cmv co normsq syl vw cv vu cv cmv co chil wcel vw cv chil wcel vu cv
      chil wcel vw cv vu cv cmv co vw cv vu cv cmv co csp co vw cv vu cv cmv co
      vw cv csp co vw cv vu cv cmv co vu cv csp co cmin co wceq vw cv chil wcel
      vu cv chil wcel wa vw cv vu cv cmv co vw cv vu cv his2sub2 vw cv vu cv
      hvsubcl vw cv chil wcel vu cv chil wcel pm3.26 vw cv chil wcel vu cv chil
      wcel pm3.27 syl3anc eqtrd eqeq1d vw cv vu cv hvsubeq0 3bitr3d sylibd vv
      cv cT cfv vv cv vw cv csp co wceq vv chil wral vv cv cT cfv vv cv vu cv
      csp co wceq vv chil wral wa vv cv cT cfv vv cv vw cv csp co wceq vv cv cT
      cfv vv cv vu cv csp co wceq wa vv chil wral vv cv vw cv csp co vv cv vu
      cv csp co cmin co cc0 wceq vv chil wral vv cv cT cfv vv cv vw cv csp co
      wceq vv cv cT cfv vv cv vu cv csp co wceq vv chil r19.26 vv cv cT cfv vv
      cv vw cv csp co wceq vv cv cT cfv vv cv vu cv csp co wceq wa vv cv vw cv
      csp co vv cv vu cv csp co cmin co cc0 wceq vv chil vv cv chil wcel vv cv
      cT cfv vv cv vw cv csp co wceq vv cv cT cfv vv cv vu cv csp co wceq wa wa
      vv cv cT cfv vv cv cT cfv cmin co vv cv vw cv csp co vv cv vu cv csp co
      cmin co cc0 vv cv cT cfv vv cv vw cv csp co wceq vv cv cT cfv vv cv vu cv
      csp co wceq wa vv cv cT cfv vv cv cT cfv cmin co vv cv vw cv csp co vv cv
      vu cv csp co cmin co wceq vv cv chil wcel vv cv cT cfv vv cv vw cv csp co
      vv cv cT cfv vv cv vu cv csp co cmin opreq12 adantl vv cv chil wcel vv cv
      cT cfv vv cv cT cfv cmin co cc0 wceq vv cv cT cfv vv cv vw cv csp co wceq
      vv cv cT cfv vv cv vu cv csp co wceq wa vv cv chil wcel vv cv cT cfv cc
      wcel vv cv cT cfv vv cv cT cfv cmin co cc0 wceq chil cc vv cv cT cT
      nlelch.1 lnfnfi ffvelrni vv cv cT cfv subid syl adantr eqtr3d r19.20ia
      sylbir syl5 rgen2a mpbir2an $.
      $( [27-Apr-2006] $) $( [13-Feb-2006] $)
  $}

  ${
    $d w v T $.
    $( A continuous linear functional can be expressed as an inner product.
       Uniqueness part of Theorem 3.9 of [Beran] p. 104.  See ~ riesz2 for the
       bounded linear functional version. $)
    riesz4 $p |- ( T e. ( LinFn i^i ConFn ) ->
                   E! w e. ~H A. v e. ~H ( T ` v ) = ( v .ih w ) ) $=
      cT clf ccnf cin wcel vv cv cT cfv vv cv vw cv csp co wceq vv chil wral vw
      chil wreu vv cv cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv vv cv vw
      cv csp co wceq vv chil wral vw chil wreu cT chil cc0 csn cxp cT cT clf
      ccnf cin wcel cT chil cc0 csn cxp cif wceq vv cv cT cfv vv cv vw cv csp
      co wceq vv chil wral vv cv cT clf ccnf cin wcel cT chil cc0 csn cxp cif
      cfv vv cv vw cv csp co wceq vv chil wral vw chil cT cT clf ccnf cin wcel
      cT chil cc0 csn cxp cif wceq vv cv cT cfv vv cv vw cv csp co wceq vv cv
      cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv vv cv vw cv csp co wceq
      vv chil cT cT clf ccnf cin wcel cT chil cc0 csn cxp cif wceq vv cv cT cfv
      vv cv cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv vv cv vw cv csp co
      vv cv cT cT clf ccnf cin wcel cT chil cc0 csn cxp cif fveq1 eqeq1d
      ralbidv reubidv vw vv cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf
      ccnf cin clf cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf ccnf inss1
      cT chil cc0 csn cxp clf ccnf cin chil cc0 csn cxp clf ccnf cin wcel chil
      cc0 csn cxp clf wcel chil cc0 csn cxp ccnf wcel chil cc0 csn cxp clf ccnf
      elin 0lnfn 0cnfn mpbir2an elimel sselii clf ccnf cin ccnf cT clf ccnf cin
      wcel cT chil cc0 csn cxp cif clf ccnf inss2 cT chil cc0 csn cxp clf ccnf
      cin chil cc0 csn cxp clf ccnf cin wcel chil cc0 csn cxp clf wcel chil cc0
      csn cxp ccnf wcel chil cc0 csn cxp clf ccnf elin 0lnfn 0cnfn mpbir2an
      elimel sselii riesz4i dedth $.
      $( [27-Apr-2006] $) $( [16-Feb-2006] $)
  $}

  ${
    $d x y z T $.
    $( Part 1 of the Riesz representation theorem for bounded linear
       functionals.  A linear functional is bounded iff its value can be
       expressed as an inner product.  Part of Theorem 17.3 of [Halmos] p. 31.
       For part 2, see ~ riesz2 .  For the continuous linear functional
       version, see ~ riesz3i and ~ riesz4 . $)
    riesz1 $p |- ( T e. LinFn -> ( ( normfn ` T ) e. RR <->
                  E. y e. ~H A. x e. ~H ( T ` x ) = ( x .ih y ) ) ) $=
      cT clf wcel cT ccnf wcel cT cnmf cfv cr wcel vx cv cT cfv vx cv vy cv csp
      co wceq vx chil wral vy chil wrex cT lnfncnbd cT clf wcel cT ccnf wcel vx
      cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil wrex cT clf wcel
      cT ccnf wcel vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil
      wrex cT clf wcel cT ccnf wcel wa cT clf ccnf cin wcel vx cv cT cfv vx cv
      vy cv csp co wceq vx chil wral vy chil wrex cT clf ccnf elin cT clf ccnf
      cin wcel vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil wrex
      vx cv cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv vx cv vy cv csp co
      wceq vx chil wral vy chil wrex cT chil cc0 csn cxp cT cT clf ccnf cin
      wcel cT chil cc0 csn cxp cif wceq vx cv cT cfv vx cv vy cv csp co wceq vx
      cv cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv vx cv vy cv csp co
      wceq vy vx chil chil cT cT clf ccnf cin wcel cT chil cc0 csn cxp cif wceq
      vx cv cT cfv vx cv cT clf ccnf cin wcel cT chil cc0 csn cxp cif cfv vx cv
      vy cv csp co vx cv cT cT clf ccnf cin wcel cT chil cc0 csn cxp cif fveq1
      eqeq1d rexralbidv vy vx cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf
      ccnf cin clf cT clf ccnf cin wcel cT chil cc0 csn cxp cif clf ccnf inss1
      cT chil cc0 csn cxp clf ccnf cin chil cc0 csn cxp clf ccnf cin wcel chil
      cc0 csn cxp clf wcel chil cc0 csn cxp ccnf wcel chil cc0 csn cxp clf ccnf
      elin 0lnfn 0cnfn mpbir2an elimel sselii clf ccnf cin ccnf cT clf ccnf cin
      wcel cT chil cc0 csn cxp cif clf ccnf inss2 cT chil cc0 csn cxp clf ccnf
      cin chil cc0 csn cxp clf ccnf cin wcel chil cc0 csn cxp clf wcel chil cc0
      csn cxp ccnf wcel chil cc0 csn cxp clf ccnf elin 0lnfn 0cnfn mpbir2an
      elimel sselii riesz3i dedth sylbir ex cT clf wcel vx cv cT cfv vx cv vy
      cv csp co wceq vx chil wral vy chil wrex vx cv cT cfv cabs cfv vz cv vx
      cv cno cfv cmul co cle wbr vx chil wral vz cr wrex cT ccnf wcel cT clf
      wcel vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vx cv cT cfv cabs
      cfv vz cv vx cv cno cfv cmul co cle wbr vx chil wral vz cr wrex vy chil
      cT clf wcel vy cv chil wcel wa vx cv cT cfv vx cv vy cv csp co wceq vx
      chil wral vy cv cno cfv cr wcel vx cv cT cfv cabs cfv vy cv cno cfv vx cv
      cno cfv cmul co cle wbr vx chil wral wa vx cv cT cfv cabs cfv vz cv vx cv
      cno cfv cmul co cle wbr vx chil wral vz cr wrex cT clf wcel vy cv chil
      wcel wa vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vx cv cT cfv
      cabs cfv vy cv cno cfv vx cv cno cfv cmul co cle wbr vx chil wral vy cv
      cno cfv cr wcel cT clf wcel vy cv chil wcel wa vx cv cT cfv vx cv vy cv
      csp co wceq vx cv cT cfv cabs cfv vy cv cno cfv vx cv cno cfv cmul co cle
      wbr vx chil cT clf wcel vx cv chil wcel vy cv chil wcel vx cv cT cfv vx
      cv vy cv csp co wceq vx cv cT cfv cabs cfv vy cv cno cfv vx cv cno cfv
      cmul co cle wbr wi cT clf wcel vx cv chil wcel wa vy cv chil wcel wa vx
      cv cT cfv vx cv vy cv csp co wceq vx cv cT cfv cabs cfv vy cv cno cfv vx
      cv cno cfv cmul co cle wbr cT clf wcel vx cv chil wcel wa vy cv chil wcel
      wa vx cv cT cfv vx cv vy cv csp co wceq wa vx cv cT cfv cabs cfv vx cv vy
      cv csp co cabs cfv vy cv cno cfv vx cv cno cfv cmul co cle vx cv cT cfv
      vx cv vy cv csp co wceq vx cv cT cfv cabs cfv vx cv vy cv csp co cabs cfv
      wceq cT clf wcel vx cv chil wcel wa vy cv chil wcel wa vx cv cT cfv vx cv
      vy cv csp co cabs fveq2 adantl cT clf wcel vx cv chil wcel wa vy cv chil
      wcel wa vx cv vy cv csp co cabs cfv vy cv cno cfv vx cv cno cfv cmul co
      cle wbr vx cv cT cfv vx cv vy cv csp co wceq vx cv chil wcel vy cv chil
      wcel vx cv vy cv csp co cabs cfv vy cv cno cfv vx cv cno cfv cmul co cle
      wbr cT clf wcel vx cv chil wcel vy cv chil wcel wa vx cv vy cv csp co
      cabs cfv vx cv cno cfv vy cv cno cfv cmul co vy cv cno cfv vx cv cno cfv
      cmul co cle vx cv vy cv bcs vx cv cno cfv cr wcel vy cv cno cfv cr wcel
      vx cv cno cfv vy cv cno cfv cmul co vy cv cno cfv vx cv cno cfv cmul co
      wceq vx cv chil wcel vy cv chil wcel vx cv cno cfv cc wcel vy cv cno cfv
      cc wcel vx cv cno cfv vy cv cno cfv cmul co vy cv cno cfv vx cv cno cfv
      cmul co wceq vx cv cno cfv cr wcel vy cv cno cfv cr wcel vx cv cno cfv vy
      cv cno cfv mulcom vx cv cno cfv recn vy cv cno cfv recn syl2an vx cv
      normcl vy cv normcl syl2an breqtrd adantll adantr eqbrtrd ex an1rs
      r19.20dva vy cv chil wcel vy cv cno cfv cr wcel cT clf wcel vy cv normcl
      adantl jctild vx cv cT cfv cabs cfv vz cv vx cv cno cfv cmul co cle wbr
      vx chil wral vx cv cT cfv cabs cfv vy cv cno cfv vx cv cno cfv cmul co
      cle wbr vx chil wral vz vy cv cno cfv cr vz cv vy cv cno cfv wceq vx cv
      cT cfv cabs cfv vz cv vx cv cno cfv cmul co cle wbr vx cv cT cfv cabs cfv
      vy cv cno cfv vx cv cno cfv cmul co cle wbr vx chil vz cv vy cv cno cfv
      wceq vz cv vx cv cno cfv cmul co vy cv cno cfv vx cv cno cfv cmul co vx
      cv cT cfv cabs cfv cle vz cv vy cv cno cfv vx cv cno cfv cmul opreq1
      breq2d ralbidv rcla4ev syl6 r19.23adva vz vx cT lnfncon sylibrd impbid
      bitr3d $.
      $( [5-May-2006] $) $( [25-Apr-2006] $)

    $( Part 2 of the Riesz representation theorem for bounded linear
       functionals.  The value of a bounded linear functional corresponds to a
       unique inner product.  Part of Theorem 17.3 of [Halmos] p. 31.  For
       part 1, see ~ riesz1 . $)
    riesz2 $p |- ( ( T e. LinFn /\ ( normfn ` T ) e. RR ) ->
                   E! y e. ~H A. x e. ~H ( T ` x ) = ( x .ih y ) ) $=
      cT clf wcel cT cnmf cfv cr wcel wa cT clf ccnf cin wcel vx cv cT cfv vx
      cv vy cv csp co wceq vx chil wral vy chil wreu cT clf ccnf cin wcel cT
      clf wcel cT ccnf wcel wa cT clf wcel cT cnmf cfv cr wcel wa cT clf ccnf
      elin cT clf wcel cT ccnf wcel cT cnmf cfv cr wcel cT lnfncnbd pm5.32i
      bitri vy vx cT riesz4 sylbir $.
      $( [5-May-2006] $) $( [25-Apr-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Adjoints (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g h u v w y z A $.  $d u B $.  $d f C $.  $d f t w x z F $.
    $d f v w x z G $.  $d f g h t u v w x y z T $.
    cnlnadjlem.1 $e |- T e. LinOp $.
    cnlnadjlem.2 $e |- T e. ConOp $.
    cnlnadjlem.3 $e |- G =
                    { <. g , h >. | ( g e. ~H /\ h = ( ( T ` g ) .ih y ) ) } $.
    $( Lemma for ~ cnlnadji (Theorem 3.10 of [Beran] p. 104: every continuous
       linear operator has an adjoint).  The value of the auxiliary functional
       ` G ` . $)
    cnlnadjlem1 $p |- ( A e. ~H -> ( G ` A ) = ( ( T ` A ) .ih y ) ) $=
      vg vh cA vg cv cT cfv vy cv csp co cA cT cfv vy cv csp co chil cG vg cv
      cA wceq vg cv cT cfv cA cT cfv vy cv csp vg cv cA cT fveq2 opreq1d
      cnlnadjlem.3 cA cT cfv vy cv csp oprex fvopab4 $.
      $( [26-Apr-2006] $) $( [16-Feb-2006] $)

    $( Lemma for ~ cnlnadji .  ` G ` is a continuous linear functional. $)
    cnlnadjlem2 $p |- ( y e. ~H -> ( G e. LinFn /\ G e. ConFn ) ) $=
      vy cv chil wcel cG clf wcel cG ccnf wcel vy cv chil wcel chil cc cG wf vx
      cv vw cv csm co vz cv cva co cG cfv vx cv vw cv cG cfv cmul co vz cv cG
      cfv caddc co wceq vz chil wral vw chil wral vx cc wral wa cG clf wcel vy
      cv chil wcel chil cc cG wf vx cv vw cv csm co vz cv cva co cG cfv vx cv
      vw cv cG cfv cmul co vz cv cG cfv caddc co wceq vz chil wral vw chil wral
      vx cc wral vy cv chil wcel vg cv cT cfv vy cv csp co cc wcel vg chil wral
      chil cc cG wf vy cv chil wcel vg cv cT cfv vy cv csp co cc wcel vg chil
      vg cv chil wcel vy cv chil wcel vg cv cT cfv vy cv csp co cc wcel vg cv
      cT cfv chil wcel vy cv chil wcel vg cv cT cfv vy cv csp co cc wcel vg cv
      chil wcel vg cv cT cfv vy cv hicl chil chil vg cv cT cT cnlnadjlem.1
      lnopfi ffvelrni sylan ancoms r19.21aiva vg vh chil cc vg cv cT cfv vy cv
      csp co cG cnlnadjlem.3 fopab2 sylib vy cv chil wcel vx cv vw cv csm co vz
      cv cva co cG cfv vx cv vw cv cG cfv cmul co vz cv cG cfv caddc co wceq vz
      chil wral vx vw cc chil vy cv chil wcel vx cv cc wcel vw cv chil wcel wa
      vx cv vw cv csm co vz cv cva co cG cfv vx cv vw cv cG cfv cmul co vz cv
      cG cfv caddc co wceq vz chil wral vy cv chil wcel vx cv cc wcel vw cv
      chil wcel wa wa vx cv vw cv csm co vz cv cva co cG cfv vx cv vw cv cG cfv
      cmul co vz cv cG cfv caddc co wceq vz chil vy cv chil wcel vx cv cc wcel
      vw cv chil wcel wa wa vz cv chil wcel wa vx cv vw cv csm co vz cv cva co
      cT cfv vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co vz cv cT cfv
      vy cv csp co caddc co vx cv vw cv csm co vz cv cva co cG cfv vx cv vw cv
      cG cfv cmul co vz cv cG cfv caddc co vy cv chil wcel vx cv vw cv csm co
      chil wcel vz cv chil wcel vx cv vw cv csm co vz cv cva co cT cfv vy cv
      csp co vx cv vw cv csm co cT cfv vy cv csp co vz cv cT cfv vy cv csp co
      caddc co wceq vx cv cc wcel vw cv chil wcel wa vy cv chil wcel vx cv vw
      cv csm co chil wcel vz cv chil wcel vx cv vw cv csm co vz cv cva co cT
      cfv vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co vz cv cT cfv vy
      cv csp co caddc co wceq vx cv vw cv csm co chil wcel vz cv chil wcel vy
      cv chil wcel vx cv vw cv csm co vz cv cva co cT cfv vy cv csp co vx cv vw
      cv csm co cT cfv vy cv csp co vz cv cT cfv vy cv csp co caddc co wceq vx
      cv vw cv csm co chil wcel vz cv chil wcel vy cv chil wcel w3a vx cv vw cv
      csm co vz cv cva co cT cfv vy cv csp co vx cv vw cv csm co cT cfv vz cv
      cT cfv cva co vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co vz cv
      cT cfv vy cv csp co caddc co vx cv vw cv csm co chil wcel vz cv chil wcel
      vy cv chil wcel w3a vx cv vw cv csm co vz cv cva co cT cfv vx cv vw cv
      csm co cT cfv vz cv cT cfv cva co vy cv csp vx cv vw cv csm co chil wcel
      vz cv chil wcel vx cv vw cv csm co vz cv cva co cT cfv vx cv vw cv csm co
      cT cfv vz cv cT cfv cva co wceq vy cv chil wcel vx cv vw cv csm co vz cv
      cT cnlnadjlem.1 lnopaddi 3adant3 opreq1d vx cv vw cv csm co cT cfv chil
      wcel vz cv cT cfv chil wcel vy cv chil wcel vx cv vw cv csm co cT cfv vz
      cv cT cfv cva co vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co vz
      cv cT cfv vy cv csp co caddc co wceq vx cv vw cv csm co chil wcel vz cv
      chil wcel vy cv chil wcel vx cv vw cv csm co cT cfv vz cv cT cfv vy cv
      ax-his2 chil chil vx cv vw cv csm co cT cT cnlnadjlem.1 lnopfi ffvelrni
      chil chil vz cv cT cT cnlnadjlem.1 lnopfi ffvelrni vy cv chil wcel id
      syl3an eqtrd 3comr 3expa vx cv vw cv hvmulcl sylanl2 vx cv cc wcel vw cv
      chil wcel wa vz cv chil wcel vx cv vw cv csm co vz cv cva co cG cfv vx cv
      vw cv csm co vz cv cva co cT cfv vy cv csp co wceq vy cv chil wcel vx cv
      cc wcel vw cv chil wcel wa vz cv chil wcel wa vx cv vw cv csm co vz cv
      cva co chil wcel vx cv vw cv csm co vz cv cva co cG cfv vx cv vw cv csm
      co vz cv cva co cT cfv vy cv csp co wceq vx cv vw cv csm co chil wcel vz
      cv chil wcel vx cv vw cv csm co vz cv cva co chil wcel vx cv cc wcel vw
      cv chil wcel wa vx cv vw cv csm co vz cv hvaddcl vx cv vw cv hvmulcl
      sylan vy vx cv vw cv csm co vz cv cva co cT vg vh cG cnlnadjlem.1
      cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem1 syl adantll vy cv chil wcel vx cv
      cc wcel vw cv chil wcel wa wa vz cv chil wcel vx cv vw cv cG cfv cmul co
      vx cv vw cv csm co cT cfv vy cv csp co vz cv cG cfv vz cv cT cfv vy cv
      csp co caddc vy cv chil wcel vx cv cc wcel vw cv chil wcel wa wa vx cv vw
      cv cT cfv csm co vy cv csp co vx cv vw cv cT cfv vy cv csp co cmul co vx
      cv vw cv csm co cT cfv vy cv csp co vx cv vw cv cG cfv cmul co vy cv chil
      wcel vx cv cc wcel vw cv chil wcel vx cv vw cv cT cfv csm co vy cv csp co
      vx cv vw cv cT cfv vy cv csp co cmul co wceq vx cv cc wcel vw cv chil
      wcel vy cv chil wcel vx cv vw cv cT cfv csm co vy cv csp co vx cv vw cv
      cT cfv vy cv csp co cmul co wceq vx cv cc wcel vw cv cT cfv chil wcel vy
      cv chil wcel vx cv vw cv cT cfv csm co vy cv csp co vx cv vw cv cT cfv vy
      cv csp co cmul co wceq vw cv chil wcel vx cv vw cv cT cfv vy cv ax-his3
      chil chil vw cv cT cT cnlnadjlem.1 lnopfi ffvelrni syl3an2 3comr 3expb vx
      cv cc wcel vw cv chil wcel wa vx cv vw cv csm co cT cfv vy cv csp co vx
      cv vw cv cT cfv csm co vy cv csp co wceq vy cv chil wcel vx cv cc wcel vw
      cv chil wcel wa vx cv vw cv csm co cT cfv vx cv vw cv cT cfv csm co vy cv
      csp vx cv vw cv cT cnlnadjlem.1 lnopmuli opreq1d adantl vw cv chil wcel
      vx cv vw cv cG cfv cmul co vx cv vw cv cT cfv vy cv csp co cmul co wceq
      vy cv chil wcel vx cv cc wcel vw cv chil wcel vw cv cG cfv vw cv cT cfv
      vy cv csp co vx cv cmul vy vw cv cT vg vh cG cnlnadjlem.1 cnlnadjlem.2
      cnlnadjlem.3 cnlnadjlem1 opreq2d ad2antll 3eqtr4rd vy vz cv cT vg vh cG
      cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem1 opreqan12d 3eqtr4d
      r19.21aiva ex r19.21aivv jca vx vw vz cG ellnfn sylibr vy cv chil wcel cG
      ccnf wcel vz cv cG cfv cabs cfv vx cv vz cv cno cfv cmul co cle wbr vz
      chil wral vx cr wrex cT cnop cfv vy cv cno cfv cmul co cr wcel vz cv cG
      cfv cabs cfv cT cnop cfv vy cv cno cfv cmul co vz cv cno cfv cmul co cle
      wbr vz chil wral vz cv cG cfv cabs cfv vx cv vz cv cno cfv cmul co cle
      wbr vz chil wral vx cr wrex vy cv chil wcel vz cv cG cfv cabs cfv vx cv
      vz cv cno cfv cmul co cle wbr vz chil wral vz cv cG cfv cabs cfv cT cnop
      cfv vy cv cno cfv cmul co vz cv cno cfv cmul co cle wbr vz chil wral vx
      cT cnop cfv vy cv cno cfv cmul co cr vx cv cT cnop cfv vy cv cno cfv cmul
      co wceq vz cv cG cfv cabs cfv vx cv vz cv cno cfv cmul co cle wbr vz cv
      cG cfv cabs cfv cT cnop cfv vy cv cno cfv cmul co vz cv cno cfv cmul co
      cle wbr vz chil vx cv cT cnop cfv vy cv cno cfv cmul co wceq vx cv vz cv
      cno cfv cmul co cT cnop cfv vy cv cno cfv cmul co vz cv cno cfv cmul co
      vz cv cG cfv cabs cfv cle vx cv cT cnop cfv vy cv cno cfv cmul co vz cv
      cno cfv cmul opreq1 breq2d ralbidv rcla4ev vy cv chil wcel vy cv cno cfv
      cr wcel cT cnop cfv vy cv cno cfv cmul co cr wcel vy cv normcl cT cnop
      cfv cr wcel vy cv cno cfv cr wcel cT cnop cfv vy cv cno cfv cmul co cr
      wcel cT cnlnadjlem.1 cnlnadjlem.2 nmcopexi cT cnop cfv vy cv cno cfv
      remulcl mpan syl vy cv chil wcel vz cv cG cfv cabs cfv cT cnop cfv vy cv
      cno cfv cmul co vz cv cno cfv cmul co cle wbr vz chil vz cv chil wcel vy
      cv chil wcel vz cv cG cfv cabs cfv cT cnop cfv vy cv cno cfv cmul co vz
      cv cno cfv cmul co cle wbr vz cv chil wcel vy cv chil wcel wa vz cv cG
      cfv cabs cfv cT cnop cfv vz cv cno cfv cmul co vy cv cno cfv cmul co cT
      cnop cfv vy cv cno cfv cmul co vz cv cno cfv cmul co cle vz cv chil wcel
      vy cv chil wcel wa vz cv cG cfv cabs cfv vz cv cT cfv cno cfv vy cv cno
      cfv cmul co cT cnop cfv vz cv cno cfv cmul co vy cv cno cfv cmul co vz cv
      chil wcel vy cv chil wcel wa vz cv cG cfv cc wcel vz cv cG cfv cabs cfv
      cr wcel vz cv chil wcel vy cv chil wcel wa vz cv cG cfv vz cv cT cfv vy
      cv csp co cc vz cv chil wcel vz cv cG cfv vz cv cT cfv vy cv csp co wceq
      vy cv chil wcel vy vz cv cT vg vh cG cnlnadjlem.1 cnlnadjlem.2
      cnlnadjlem.3 cnlnadjlem1 adantr vz cv cT cfv chil wcel vy cv chil wcel vz
      cv cT cfv vy cv csp co cc wcel vz cv chil wcel vz cv cT cfv vy cv hicl
      chil chil vz cv cT cT cnlnadjlem.1 lnopfi ffvelrni sylan eqeltrd vz cv cG
      cfv abscl syl vz cv cT cfv cno cfv cr wcel vy cv cno cfv cr wcel vz cv cT
      cfv cno cfv vy cv cno cfv cmul co cr wcel vz cv chil wcel vy cv chil wcel
      vz cv cT cfv cno cfv vy cv cno cfv remulcl vz cv chil wcel vz cv cT cfv
      chil wcel vz cv cT cfv cno cfv cr wcel chil chil vz cv cT cT cnlnadjlem.1
      lnopfi ffvelrni vz cv cT cfv normcl syl vy cv normcl syl2an cT cnop cfv
      vz cv cno cfv cmul co cr wcel vy cv cno cfv cr wcel cT cnop cfv vz cv cno
      cfv cmul co vy cv cno cfv cmul co cr wcel vz cv chil wcel vy cv chil wcel
      cT cnop cfv vz cv cno cfv cmul co vy cv cno cfv remulcl vz cv chil wcel
      vz cv cno cfv cr wcel cT cnop cfv vz cv cno cfv cmul co cr wcel vz cv
      normcl cT cnop cfv cr wcel vz cv cno cfv cr wcel cT cnop cfv vz cv cno
      cfv cmul co cr wcel cT cnlnadjlem.1 cnlnadjlem.2 nmcopexi cT cnop cfv vz
      cv cno cfv remulcl mpan syl vy cv normcl syl2an vz cv chil wcel vy cv
      chil wcel wa vz cv cG cfv cabs cfv vz cv cT cfv vy cv csp co cabs cfv vz
      cv cT cfv cno cfv vy cv cno cfv cmul co cle vz cv chil wcel vy cv chil
      wcel wa vz cv cG cfv vz cv cT cfv vy cv csp co cabs vz cv chil wcel vz cv
      cG cfv vz cv cT cfv vy cv csp co wceq vy cv chil wcel vy vz cv cT vg vh
      cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem1 adantr fveq2d vz cv
      cT cfv chil wcel vy cv chil wcel vz cv cT cfv vy cv csp co cabs cfv vz cv
      cT cfv cno cfv vy cv cno cfv cmul co cle wbr vz cv chil wcel vz cv cT cfv
      vy cv bcs chil chil vz cv cT cT cnlnadjlem.1 lnopfi ffvelrni sylan
      eqbrtrd vz cv cT cfv cno cfv cr wcel cT cnop cfv vz cv cno cfv cmul co cr
      wcel vy cv cno cfv cr wcel w3a cc0 vy cv cno cfv cle wbr vz cv cT cfv cno
      cfv cT cnop cfv vz cv cno cfv cmul co cle wbr wa vz cv cT cfv cno cfv vy
      cv cno cfv cmul co cT cnop cfv vz cv cno cfv cmul co vy cv cno cfv cmul
      co cle wbr vz cv chil wcel vy cv chil wcel wa vz cv cT cfv cno cfv cT
      cnop cfv vz cv cno cfv cmul co vy cv cno cfv lemul1aOLD vz cv chil wcel
      vy cv chil wcel wa vz cv cT cfv cno cfv cr wcel cT cnop cfv vz cv cno cfv
      cmul co cr wcel vy cv cno cfv cr wcel vz cv chil wcel vz cv cT cfv cno
      cfv cr wcel vy cv chil wcel vz cv chil wcel vz cv cT cfv chil wcel vz cv
      cT cfv cno cfv cr wcel chil chil vz cv cT cT cnlnadjlem.1 lnopfi ffvelrni
      vz cv cT cfv normcl syl adantr vz cv chil wcel cT cnop cfv vz cv cno cfv
      cmul co cr wcel vy cv chil wcel vz cv chil wcel vz cv cno cfv cr wcel cT
      cnop cfv vz cv cno cfv cmul co cr wcel vz cv normcl cT cnop cfv cr wcel
      vz cv cno cfv cr wcel cT cnop cfv vz cv cno cfv cmul co cr wcel cT
      cnlnadjlem.1 cnlnadjlem.2 nmcopexi cT cnop cfv vz cv cno cfv remulcl mpan
      syl adantr vy cv chil wcel vy cv cno cfv cr wcel vz cv chil wcel vy cv
      normcl adantl 3jca vz cv chil wcel vy cv chil wcel wa cc0 vy cv cno cfv
      cle wbr vz cv cT cfv cno cfv cT cnop cfv vz cv cno cfv cmul co cle wbr vy
      cv chil wcel cc0 vy cv cno cfv cle wbr vz cv chil wcel vy cv normge0
      adantl vz cv chil wcel vz cv cT cfv cno cfv cT cnop cfv vz cv cno cfv
      cmul co cle wbr vy cv chil wcel vz cv cT cnlnadjlem.1 cnlnadjlem.2
      nmcoplbi adantr jca sylanc letrd vz cv cno cfv cc wcel vy cv cno cfv cc
      wcel cT cnop cfv vz cv cno cfv cmul co vy cv cno cfv cmul co cT cnop cfv
      vy cv cno cfv cmul co vz cv cno cfv cmul co wceq vz cv chil wcel vy cv
      chil wcel cT cnop cfv cc wcel vz cv cno cfv cc wcel vy cv cno cfv cc wcel
      cT cnop cfv vz cv cno cfv cmul co vy cv cno cfv cmul co cT cnop cfv vy cv
      cno cfv cmul co vz cv cno cfv cmul co wceq cT cnop cfv cT cnlnadjlem.1
      cnlnadjlem.2 nmcopexi recni cT cnop cfv vz cv cno cfv vy cv cno cfv mul23
      mp3an1 vz cv chil wcel vz cv cno cfv vz cv normcl recnd vy cv chil wcel
      vy cv cno cfv vy cv normcl recnd syl2an breqtrd ancoms r19.21aiva sylanc
      vy cv chil wcel cG clf wcel cG ccnf wcel vz cv cG cfv cabs cfv vx cv vz
      cv cno cfv cmul co cle wbr vz chil wral vx cr wrex wb vy cv chil wcel
      chil cc cG wf vx cv vw cv csm co vz cv cva co cG cfv vx cv vw cv cG cfv
      cmul co vz cv cG cfv caddc co wceq vz chil wral vw chil wral vx cc wral
      wa cG clf wcel vy cv chil wcel chil cc cG wf vx cv vw cv csm co vz cv cva
      co cG cfv vx cv vw cv cG cfv cmul co vz cv cG cfv caddc co wceq vz chil
      wral vw chil wral vx cc wral vy cv chil wcel vg cv cT cfv vy cv csp co cc
      wcel vg chil wral chil cc cG wf vy cv chil wcel vg cv cT cfv vy cv csp co
      cc wcel vg chil vg cv chil wcel vy cv chil wcel vg cv cT cfv vy cv csp co
      cc wcel vg cv cT cfv chil wcel vy cv chil wcel vg cv cT cfv vy cv csp co
      cc wcel vg cv chil wcel vg cv cT cfv vy cv hicl chil chil vg cv cT cT
      cnlnadjlem.1 lnopfi ffvelrni sylan ancoms r19.21aiva vg vh chil cc vg cv
      cT cfv vy cv csp co cG cnlnadjlem.3 fopab2 sylib vy cv chil wcel vx cv vw
      cv csm co vz cv cva co cG cfv vx cv vw cv cG cfv cmul co vz cv cG cfv
      caddc co wceq vz chil wral vx vw cc chil vy cv chil wcel vx cv cc wcel vw
      cv chil wcel wa vx cv vw cv csm co vz cv cva co cG cfv vx cv vw cv cG cfv
      cmul co vz cv cG cfv caddc co wceq vz chil wral vy cv chil wcel vx cv cc
      wcel vw cv chil wcel wa wa vx cv vw cv csm co vz cv cva co cG cfv vx cv
      vw cv cG cfv cmul co vz cv cG cfv caddc co wceq vz chil vy cv chil wcel
      vx cv cc wcel vw cv chil wcel wa wa vz cv chil wcel wa vx cv vw cv csm co
      vz cv cva co cT cfv vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co
      vz cv cT cfv vy cv csp co caddc co vx cv vw cv csm co vz cv cva co cG cfv
      vx cv vw cv cG cfv cmul co vz cv cG cfv caddc co vy cv chil wcel vx cv vw
      cv csm co chil wcel vz cv chil wcel vx cv vw cv csm co vz cv cva co cT
      cfv vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co vz cv cT cfv vy
      cv csp co caddc co wceq vx cv cc wcel vw cv chil wcel wa vy cv chil wcel
      vx cv vw cv csm co chil wcel vz cv chil wcel vx cv vw cv csm co vz cv cva
      co cT cfv vy cv csp co vx cv vw cv csm co cT cfv vy cv csp co vz cv cT
      cfv vy cv csp co caddc co wceq vx cv vw cv csm co chil wcel vz cv chil
      wcel vy cv chil wcel vx cv vw cv csm co vz cv cva co cT cfv vy cv csp co
      vx cv vw cv csm co cT cfv vy cv csp co vz cv cT cfv vy cv csp co caddc co
      wceq vx cv vw cv csm co chil wcel vz cv chil wcel vy cv chil wcel w3a vx
      cv vw cv csm co vz cv cva co cT cfv vy cv csp co vx cv vw cv csm co cT
      cfv vz cv cT cfv cva co vy cv csp co vx cv vw cv csm co cT cfv vy cv csp
      co vz cv cT cfv vy cv csp co caddc co vx cv vw cv csm co chil wcel vz cv
      chil wcel vy cv chil wcel w3a vx cv vw cv csm co vz cv cva co cT cfv vx
      cv vw cv csm co cT cfv vz cv cT cfv cva co vy cv csp vx cv vw cv csm co
      chil wcel vz cv chil wcel vx cv vw cv csm co vz cv cva co cT cfv vx cv vw
      cv csm co cT cfv vz cv cT cfv cva co wceq vy cv chil wcel vx cv vw cv csm
      co vz cv cT cnlnadjlem.1 lnopaddi 3adant3 opreq1d vx cv vw cv csm co cT
      cfv chil wcel vz cv cT cfv chil wcel vy cv chil wcel vx cv vw cv csm co
      cT cfv vz cv cT cfv cva co vy cv csp co vx cv vw cv csm co cT cfv vy cv
      csp co vz cv cT cfv vy cv csp co caddc co wceq vx cv vw cv csm co chil
      wcel vz cv chil wcel vy cv chil wcel vx cv vw cv csm co cT cfv vz cv cT
      cfv vy cv ax-his2 chil chil vx cv vw cv csm co cT cT cnlnadjlem.1 lnopfi
      ffvelrni chil chil vz cv cT cT cnlnadjlem.1 lnopfi ffvelrni vy cv chil
      wcel id syl3an eqtrd 3comr 3expa vx cv vw cv hvmulcl sylanl2 vx cv cc
      wcel vw cv chil wcel wa vz cv chil wcel vx cv vw cv csm co vz cv cva co
      cG cfv vx cv vw cv csm co vz cv cva co cT cfv vy cv csp co wceq vy cv
      chil wcel vx cv cc wcel vw cv chil wcel wa vz cv chil wcel wa vx cv vw cv
      csm co vz cv cva co chil wcel vx cv vw cv csm co vz cv cva co cG cfv vx
      cv vw cv csm co vz cv cva co cT cfv vy cv csp co wceq vx cv vw cv csm co
      chil wcel vz cv chil wcel vx cv vw cv csm co vz cv cva co chil wcel vx cv
      cc wcel vw cv chil wcel wa vx cv vw cv csm co vz cv hvaddcl vx cv vw cv
      hvmulcl sylan vy vx cv vw cv csm co vz cv cva co cT vg vh cG cnlnadjlem.1
      cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem1 syl adantll vy cv chil wcel vx cv
      cc wcel vw cv chil wcel wa wa vz cv chil wcel vx cv vw cv cG cfv cmul co
      vx cv vw cv csm co cT cfv vy cv csp co vz cv cG cfv vz cv cT cfv vy cv
      csp co caddc vy cv chil wcel vx cv cc wcel vw cv chil wcel wa wa vx cv vw
      cv cT cfv csm co vy cv csp co vx cv vw cv cT cfv vy cv csp co cmul co vx
      cv vw cv csm co cT cfv vy cv csp co vx cv vw cv cG cfv cmul co vy cv chil
      wcel vx cv cc wcel vw cv chil wcel vx cv vw cv cT cfv csm co vy cv csp co
      vx cv vw cv cT cfv vy cv csp co cmul co wceq vx cv cc wcel vw cv chil
      wcel vy cv chil wcel vx cv vw cv cT cfv csm co vy cv csp co vx cv vw cv
      cT cfv vy cv csp co cmul co wceq vx cv cc wcel vw cv cT cfv chil wcel vy
      cv chil wcel vx cv vw cv cT cfv csm co vy cv csp co vx cv vw cv cT cfv vy
      cv csp co cmul co wceq vw cv chil wcel vx cv vw cv cT cfv vy cv ax-his3
      chil chil vw cv cT cT cnlnadjlem.1 lnopfi ffvelrni syl3an2 3comr 3expb vx
      cv cc wcel vw cv chil wcel wa vx cv vw cv csm co cT cfv vy cv csp co vx
      cv vw cv cT cfv csm co vy cv csp co wceq vy cv chil wcel vx cv cc wcel vw
      cv chil wcel wa vx cv vw cv csm co cT cfv vx cv vw cv cT cfv csm co vy cv
      csp vx cv vw cv cT cnlnadjlem.1 lnopmuli opreq1d adantl vw cv chil wcel
      vx cv vw cv cG cfv cmul co vx cv vw cv cT cfv vy cv csp co cmul co wceq
      vy cv chil wcel vx cv cc wcel vw cv chil wcel vw cv cG cfv vw cv cT cfv
      vy cv csp co vx cv cmul vy vw cv cT vg vh cG cnlnadjlem.1 cnlnadjlem.2
      cnlnadjlem.3 cnlnadjlem1 opreq2d ad2antll 3eqtr4rd vy vz cv cT vg vh cG
      cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem1 opreqan12d 3eqtr4d
      r19.21aiva ex r19.21aivv jca vx vw vz cG ellnfn sylibr vx vz cG lnfncon
      syl mpbird jca $.
      $( [27-Apr-2006] $) $( [16-Feb-2006] $)

    ${
      cnlnadjlem.4 $e |- B = U. { w e. ~H | A. v e. ~H ( ( T ` v ) .ih y )
                         = ( v .ih w ) } $.
      cnlnadjlem.5 $e |- F = { <. y , u >. | ( y e. ~H /\ u = B ) } $.
      $( Lemma for ~ cnlnadji .  By ~ riesz4 , ` B ` is the unique vector
         such that ` ( T `` v ) .ih y ) = ( v .ih w ) ` for all ` v ` . $)
      cnlnadjlem3 $p |- ( y e. ~H -> B e. ~H ) $=
        vy cv chil wcel vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv
        chil wral vw chil crab cuni chil cB vy cv chil wcel vv cv cT cfv vy cv
        csp co vv cv vw cv csp co wceq vv chil wral vw chil wreu vv cv cT cfv
        vy cv csp co vv cv vw cv csp co wceq vv chil wral vw chil crab cuni
        chil wcel vy cv chil wcel vv cv cG cfv vv cv vw cv csp co wceq vv chil
        wral vw chil wreu vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv
        chil wral vw chil wreu vy cv chil wcel cG clf ccnf cin wcel vv cv cG
        cfv vv cv vw cv csp co wceq vv chil wral vw chil wreu vy cv chil wcel
        cG clf wcel cG ccnf wcel wa cG clf ccnf cin wcel vy cT vg vh cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem2 cG clf ccnf elin
        sylibr vw vv cG riesz4 syl vv cv cG cfv vv cv vw cv csp co wceq vv chil
        wral vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw
        chil vv cv cG cfv vv cv vw cv csp co wceq vv cv cT cfv vy cv csp co vv
        cv vw cv csp co wceq vv chil vv cv chil wcel vv cv cG cfv vv cv cT cfv
        vy cv csp co vv cv vw cv csp co vy vv cv cT vg vh cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem1 eqeq1d ralbiia reubii sylib vv cv
        cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw chil reucl
        syl cnlnadjlem.4 syl5eqel $.
        $( [28-Apr-2006] $) $( [17-Feb-2006] $)

      $( Lemma for ~ cnlnadji .  The values of auxiliary function ` F ` are
         vectors. $)
      cnlnadjlem4 $p |- ( A e. ~H -> ( F ` A ) e. ~H ) $=
        cA chil wcel cA cF cfv vv cv cT cfv cA csp co vv cv vw cv csp co wceq
        vv chil wral vw chil crab cuni chil vy vu cA cB vv cv cT cfv cA csp co
        vv cv vw cv csp co wceq vv chil wral vw chil crab cuni chil cF vy cv cA
        wceq vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw
        chil crab cuni vv cv cT cfv cA csp co vv cv vw cv csp co wceq vv chil
        wral vw chil crab cuni cB vy cv cA wceq vv cv cT cfv vy cv csp co vv cv
        vw cv csp co wceq vv chil wral vw chil crab vv cv cT cfv cA csp co vv
        cv vw cv csp co wceq vv chil wral vw chil crab vy cv cA wceq vv cv cT
        cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vv cv cT cfv cA
        csp co vv cv vw cv csp co wceq vv chil wral vw chil vy cv cA wceq vv cv
        cT cfv vy cv csp co vv cv vw cv csp co wceq vv cv cT cfv cA csp co vv
        cv vw cv csp co wceq vv chil vy cv cA wceq vv cv cT cfv vy cv csp co vv
        cv cT cfv cA csp co vv cv vw cv csp co vy cv cA vv cv cT cfv csp opreq2
        eqeq1d ralbidv rabbisdv unieqd cnlnadjlem.4 syl5eq cnlnadjlem.5 vv cv
        cT cfv cA csp co vv cv vw cv csp co wceq vv chil wral vw chil crab vv
        cv cT cfv cA csp co vv cv vw cv csp co wceq vv chil wral vw chil
        ax-hilex rabex uniex fvopab4 cA chil wcel vv cv cT cfv cA csp co vv cv
        vw cv csp co wceq vv chil wral vw chil wreu vv cv cT cfv cA csp co vv
        cv vw cv csp co wceq vv chil wral vw chil crab cuni chil wcel vv cv cT
        cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw chil wreu vv
        cv cT cfv cA csp co vv cv vw cv csp co wceq vv chil wral vw chil wreu
        vy cA chil vy cv cA wceq vv cv cT cfv vy cv csp co vv cv vw cv csp co
        wceq vv chil wral vv cv cT cfv cA csp co vv cv vw cv csp co wceq vv
        chil wral vw chil vy cv cA wceq vv cv cT cfv vy cv csp co vv cv vw cv
        csp co wceq vv cv cT cfv cA csp co vv cv vw cv csp co wceq vv chil vy
        cv cA wceq vv cv cT cfv vy cv csp co vv cv cT cfv cA csp co vv cv vw cv
        csp co vy cv cA vv cv cT cfv csp opreq2 eqeq1d ralbidv reubidv vy cv
        chil wcel vv cv cG cfv vv cv vw cv csp co wceq vv chil wral vw chil
        wreu vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw
        chil wreu vy cv chil wcel cG clf ccnf cin wcel vv cv cG cfv vv cv vw cv
        csp co wceq vv chil wral vw chil wreu vy cv chil wcel cG clf wcel cG
        ccnf wcel wa cG clf ccnf cin wcel vy cT vg vh cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem2 cG clf ccnf elin sylibr vw vv cG
        riesz4 syl vv cv cG cfv vv cv vw cv csp co wceq vv chil wral vv cv cT
        cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw chil vv cv cG
        cfv vv cv vw cv csp co wceq vv cv cT cfv vy cv csp co vv cv vw cv csp
        co wceq vv chil vv cv chil wcel vv cv cG cfv vv cv cT cfv vy cv csp co
        vv cv vw cv csp co vy vv cv cT vg vh cG cnlnadjlem.1 cnlnadjlem.2
        cnlnadjlem.3 cnlnadjlem1 eqeq1d ralbiia reubii sylib vtoclga vv cv cT
        cfv cA csp co vv cv vw cv csp co wceq vv chil wral vw chil reucl syl
        eqeltrd $.
        $( [27-Apr-2006] $) $( [17-Feb-2006] $)

      $( Lemma for ~ cnlnadji .  ` F ` is an adjoint of ` T ` (later, we will
         show it is unique). $)
      cnlnadjlem5 $p |- ( ( A e. ~H /\ C e. ~H ) -> ( ( T ` C ) .ih A ) =
                        ( C .ih ( F ` A ) ) ) $=
        cC chil wcel cA chil wcel cC cT cfv cA csp co cC cA cF cfv csp co wceq
        cA chil wcel vf cv cT cfv cA csp co vf cv cA cF cfv csp co wceq wi cA
        chil wcel cC cT cfv cA csp co cC cA cF cfv csp co wceq wi vf cC chil vf
        cv cC wceq vf cv cT cfv cA csp co vf cv cA cF cfv csp co wceq cC cT cfv
        cA csp co cC cA cF cfv csp co wceq cA chil wcel vf cv cC wceq vf cv cT
        cfv cA csp co cC cT cfv cA csp co vf cv cA cF cfv csp co cC cA cF cfv
        csp co vf cv cC wceq vf cv cT cfv cC cT cfv cA csp vf cv cC cT fveq2
        opreq1d vf cv cC cA cF cfv csp opreq1 eqeq12d imbi2d cA chil wcel vf cv
        chil wcel vf cv cT cfv cA csp co vf cv cA cF cfv csp co wceq cA chil
        wcel vf cv cT cfv cA csp co vf cv cA cF cfv csp co wceq vf chil wral vf
        cv chil wcel vf cv cT cfv cA csp co vf cv cA cF cfv csp co wceq wi vf
        cv cT cfv vy cv csp co vf cv vy cv cF cfv csp co wceq vf chil wral vf
        cv cT cfv cA csp co vf cv cA cF cfv csp co wceq vf chil wral vy vz cA
        chil vz cv cA wcel vy ax-17 vf cv cT cfv cA csp co vf cv cA cF cfv csp
        co wceq vy vf chil vf cv chil wcel vy ax-17 vy vz vz vf cv cT cfv cA
        csp co vf cv cA cF cfv csp co vz cv vf cv cT cfv cA csp co wcel vy
        ax-17 vy vz vf cv cA cF cfv csp vz cv vf cv wcel vy ax-17 vz cv csp
        wcel vy ax-17 vy vz cA cF vy vz cF vy cv chil wcel vu cv cB wceq wa vy
        vu copab cnlnadjlem.5 vy cv chil wcel vu cv cB wceq wa vy vu vz hbopab1
        hbxfr vz cv cA wcel vy ax-17 hbfv hbopr hbeq hbral vy cv cA wceq vf cv
        cT cfv vy cv csp co vf cv vy cv cF cfv csp co wceq vf cv cT cfv cA csp
        co vf cv cA cF cfv csp co wceq vf chil vy cv cA wceq vf cv cT cfv vy cv
        csp co vf cv cT cfv cA csp co vf cv vy cv cF cfv csp co vf cv cA cF cfv
        csp co vy cv cA vf cv cT cfv csp opreq2 vy cv cA wceq vy cv cF cfv cA
        cF cfv vf cv csp vy cv cA cF fveq2 opreq2d eqeq12d ralbidv vy cv chil
        wcel vf cv cT cfv vy cv csp co vf cv vy cv cF cfv csp co wceq vf chil
        wral vf cv cT cfv vy cv csp co vf cv vw cv csp co wceq vf chil wral vw
        chil crab cuni vy cv cF cfv wceq vy cv chil wcel vy cv cF cfv cB vf cv
        cT cfv vy cv csp co vf cv vw cv csp co wceq vf chil wral vw chil crab
        cuni vy cv chil wcel vy cv vy cv chil wcel vu cv cB wceq wa vy vu copab
        cfv cB vy cv cF cfv vy cv chil wcel cB cvv wcel vy cv vy cv chil wcel
        vu cv cB wceq wa vy vu copab cfv cB wceq cB vv cv cT cfv vy cv csp co
        vv cv vw cv csp co wceq vv chil wral vw chil crab cuni cvv cnlnadjlem.4
        vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw chil
        crab vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw
        chil ax-hilex rabex uniex eqeltri vy vu chil cB cvv fvopab2 mpan2 vy cv
        cF vy cv chil wcel vu cv cB wceq wa vy vu copab cnlnadjlem.5 fveq1i
        syl5eq cB vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil
        wral vw chil crab cuni vf cv cT cfv vy cv csp co vf cv vw cv csp co
        wceq vf chil wral vw chil crab cuni cnlnadjlem.4 vv cv cT cfv vy cv csp
        co vv cv vw cv csp co wceq vv chil wral vw chil crab vf cv cT cfv vy cv
        csp co vf cv vw cv csp co wceq vf chil wral vw chil crab vv cv cT cfv
        vy cv csp co vv cv vw cv csp co wceq vv chil wral vf cv cT cfv vy cv
        csp co vf cv vw cv csp co wceq vf chil wral vw chil vv cv cT cfv vy cv
        csp co vv cv vw cv csp co wceq vv chil wral vf cv cT cfv vy cv csp co
        vf cv vw cv csp co wceq vf chil wral wb vw cv chil wcel vv cv cT cfv vy
        cv csp co vv cv vw cv csp co wceq vf cv cT cfv vy cv csp co vf cv vw cv
        csp co wceq vv vf chil vv cv vf cv wceq vv cv cT cfv vy cv csp co vf cv
        cT cfv vy cv csp co vv cv vw cv csp co vf cv vw cv csp co vv cv vf cv
        wceq vv cv cT cfv vf cv cT cfv vy cv csp vv cv vf cv cT fveq2 opreq1d
        vv cv vf cv vw cv csp opreq1 eqeq12d cbvralv a1i rabbii unieqi eqtri
        syl6req vy cv cF cfv chil wcel vf cv cT cfv vy cv csp co vf cv vw cv
        csp co wceq vf chil wral vw chil wreu vf cv cT cfv vy cv csp co vf cv
        vy cv cF cfv csp co wceq vf chil wral vf cv cT cfv vy cv csp co vf cv
        vw cv csp co wceq vf chil wral vw chil crab cuni vy cv cF cfv wceq wb
        vy cv chil wcel vf cv cT cfv vy cv csp co vf cv vw cv csp co wceq vf
        chil wral vf cv cT cfv vy cv csp co vf cv vy cv cF cfv csp co wceq vf
        chil wral vw chil vy cv cF cfv vw cv vy cv cF cfv wceq vf cv cT cfv vy
        cv csp co vf cv vw cv csp co wceq vf cv cT cfv vy cv csp co vf cv vy cv
        cF cfv csp co wceq vf chil vw cv vy cv cF cfv wceq vf cv vw cv csp co
        vf cv vy cv cF cfv csp co vf cv cT cfv vy cv csp co vw cv vy cv cF cfv
        vf cv csp opreq2 eqeq2d ralbidv reuuni2 vy cv chil wcel vy cv cF cfv cB
        chil vy cv chil wcel vy cv vy cv chil wcel vu cv cB wceq wa vy vu copab
        cfv cB vy cv cF cfv vy cv chil wcel cB cvv wcel vy cv vy cv chil wcel
        vu cv cB wceq wa vy vu copab cfv cB wceq cB vv cv cT cfv vy cv csp co
        vv cv vw cv csp co wceq vv chil wral vw chil crab cuni cvv cnlnadjlem.4
        vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw chil
        crab vv cv cT cfv vy cv csp co vv cv vw cv csp co wceq vv chil wral vw
        chil ax-hilex rabex uniex eqeltri vy vu chil cB cvv fvopab2 mpan2 vy cv
        cF vy cv chil wcel vu cv cB wceq wa vy vu copab cnlnadjlem.5 fveq1i
        syl5eq vy vw vv vu cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2
        cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem3 eqeltrd vy cv chil
        wcel vf cv cG cfv vf cv vw cv csp co wceq vf chil wral vw chil wreu vf
        cv cT cfv vy cv csp co vf cv vw cv csp co wceq vf chil wral vw chil
        wreu vy cv chil wcel cG clf ccnf cin wcel vf cv cG cfv vf cv vw cv csp
        co wceq vf chil wral vw chil wreu vy cv chil wcel cG clf wcel cG ccnf
        wcel wa cG clf ccnf cin wcel vy cT vg vh cG cnlnadjlem.1 cnlnadjlem.2
        cnlnadjlem.3 cnlnadjlem2 cG clf ccnf elin sylibr vw vf cG riesz4 syl vf
        cv cG cfv vf cv vw cv csp co wceq vf chil wral vf cv cT cfv vy cv csp
        co vf cv vw cv csp co wceq vf chil wral vw chil vf cv cG cfv vf cv vw
        cv csp co wceq vf cv cT cfv vy cv csp co vf cv vw cv csp co wceq vf
        chil vf cv chil wcel vf cv cG cfv vf cv cT cfv vy cv csp co vf cv vw cv
        csp co vy vf cv cT vg vh cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3
        cnlnadjlem1 eqeq1d ralbiia reubii sylib sylanc mpbird vtoclgaf vf cv cT
        cfv cA csp co vf cv cA cF cfv csp co wceq vf chil ra4 syl com12 vtoclga
        impcom $.
        $( [28-Apr-2006] $) $( [18-Feb-2006] $)

      $( Lemma for ~ cnlnadji .  ` F ` is linear. $)
      cnlnadjlem6 $p |- F e. LinOp $=
        cF clo wcel chil chil cF wf vx cv vf cv csm co vz cv cva co cF cfv vx
        cv vf cv cF cfv csm co vz cv cF cfv cva co wceq vz chil wral vf chil
        wral vx cc wral vx vf vz cF ellnop vy vu chil chil cB cF cnlnadjlem.5
        vy vw vv vu cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3
        cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem3 fopab vx cv vf cv csm co vz cv
        cva co cF cfv vx cv vf cv cF cfv csm co vz cv cF cfv cva co wceq vz
        chil wral vx vf cc chil vx cv cc wcel vf cv chil wcel wa vx cv vf cv
        csm co vz cv cva co cF cfv vx cv vf cv cF cfv csm co vz cv cF cfv cva
        co wceq vz chil vx cv cc wcel vf cv chil wcel wa vz cv chil wcel wa vt
        cv vx cv vf cv csm co vz cv cva co cF cfv csp co vt cv vx cv vf cv cF
        cfv csm co vz cv cF cfv cva co csp co wceq vt chil wral vx cv vf cv csm
        co vz cv cva co cF cfv vx cv vf cv cF cfv csm co vz cv cF cfv cva co
        wceq vx cv cc wcel vf cv chil wcel wa vz cv chil wcel wa vt cv vx cv vf
        cv csm co vz cv cva co cF cfv csp co vt cv vx cv vf cv cF cfv csm co vz
        cv cF cfv cva co csp co wceq vt chil vx cv cc wcel vf cv chil wcel wa
        vz cv chil wcel wa vt cv chil wcel wa vt cv cT cfv vx cv vf cv csm co
        vz cv cva co csp co vt cv cT cfv vx cv vf cv csm co csp co vt cv cT cfv
        vz cv csp co caddc co vt cv vx cv vf cv csm co vz cv cva co cF cfv csp
        co vt cv vx cv vf cv cF cfv csm co vz cv cF cfv cva co csp co vt cv cT
        cfv chil wcel vx cv vf cv csm co chil wcel vz cv chil wcel vt cv cT cfv
        vx cv vf cv csm co vz cv cva co csp co vt cv cT cfv vx cv vf cv csm co
        csp co vt cv cT cfv vz cv csp co caddc co wceq vx cv cc wcel vf cv chil
        wcel wa vz cv chil wcel wa vt cv chil wcel wa vt cv cT cfv vx cv vf cv
        csm co vz cv his7 vt cv chil wcel vt cv cT cfv chil wcel vx cv cc wcel
        vf cv chil wcel wa vz cv chil wcel wa chil chil vt cv cT cT
        cnlnadjlem.1 lnopfi ffvelrni adantl vx cv cc wcel vf cv chil wcel wa vx
        cv vf cv csm co chil wcel vz cv chil wcel vt cv chil wcel vx cv vf cv
        hvmulcl ad2antrr vx cv cc wcel vf cv chil wcel wa vz cv chil wcel vt cv
        chil wcel simplr syl3anc vx cv vf cv csm co vz cv cva co chil wcel vt
        cv chil wcel vt cv cT cfv vx cv vf cv csm co vz cv cva co csp co vt cv
        vx cv vf cv csm co vz cv cva co cF cfv csp co wceq vx cv cc wcel vf cv
        chil wcel wa vz cv chil wcel wa vy vw vv vu vx cv vf cv csm co vz cv
        cva co cB vt cv cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3
        cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem5 vx cv vf cv csm co chil wcel vz
        cv chil wcel vx cv vf cv csm co vz cv cva co chil wcel vx cv cc wcel vf
        cv chil wcel wa vx cv vf cv csm co vz cv hvaddcl vx cv vf cv hvmulcl
        sylan sylan vx cv cc wcel vf cv chil wcel wa vz cv chil wcel wa vt cv
        chil wcel wa vt cv cT cfv vx cv vf cv csm co csp co vt cv cT cfv vz cv
        csp co caddc co vt cv vx cv vf cv cF cfv csm co csp co vt cv vz cv cF
        cfv csp co caddc co vt cv vx cv vf cv cF cfv csm co vz cv cF cfv cva co
        csp co vx cv cc wcel vf cv chil wcel wa vz cv chil wcel wa vt cv chil
        wcel wa vt cv cT cfv vx cv vf cv csm co csp co vt cv vx cv vf cv cF cfv
        csm co csp co vt cv cT cfv vz cv csp co vt cv vz cv cF cfv csp co caddc
        vx cv cc wcel vf cv chil wcel wa vt cv chil wcel vt cv cT cfv vx cv vf
        cv csm co csp co vt cv vx cv vf cv cF cfv csm co csp co wceq vz cv chil
        wcel vx cv cc wcel vf cv chil wcel wa vt cv chil wcel wa vx cv ccj cfv
        vt cv cT cfv vf cv csp co cmul co vx cv ccj cfv vt cv vf cv cF cfv csp
        co cmul co vt cv cT cfv vx cv vf cv csm co csp co vt cv vx cv vf cv cF
        cfv csm co csp co vx cv cc wcel vf cv chil wcel wa vt cv chil wcel wa
        vt cv cT cfv vf cv csp co vt cv vf cv cF cfv csp co vx cv ccj cfv cmul
        vf cv chil wcel vt cv chil wcel vt cv cT cfv vf cv csp co vt cv vf cv
        cF cfv csp co wceq vx cv cc wcel vy vw vv vu vf cv cB vt cv cT vg vh cF
        cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem5 adantll opreq2d vx cv cc wcel vt cv cT cfv chil wcel vf cv
        chil wcel vt cv cT cfv vx cv vf cv csm co csp co vx cv ccj cfv vt cv cT
        cfv vf cv csp co cmul co wceq vx cv cc wcel vf cv chil wcel wa vt cv
        chil wcel wa vx cv vt cv cT cfv vf cv his5 vx cv cc wcel vf cv chil
        wcel vt cv chil wcel simpll vt cv chil wcel vt cv cT cfv chil wcel vx
        cv cc wcel vf cv chil wcel wa chil chil vt cv cT cT cnlnadjlem.1 lnopfi
        ffvelrni adantl vx cv cc wcel vf cv chil wcel vt cv chil wcel simplr
        syl3anc vx cv cc wcel vt cv chil wcel vf cv cF cfv chil wcel vt cv vx
        cv vf cv cF cfv csm co csp co vx cv ccj cfv vt cv vf cv cF cfv csp co
        cmul co wceq vx cv cc wcel vf cv chil wcel wa vt cv chil wcel wa vx cv
        vt cv vf cv cF cfv his5 vx cv cc wcel vf cv chil wcel vt cv chil wcel
        simpll vx cv cc wcel vf cv chil wcel wa vt cv chil wcel pm3.27 vf cv
        chil wcel vf cv cF cfv chil wcel vx cv cc wcel vt cv chil wcel vy vw vv
        vu vf cv cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3
        cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 ad2antlr syl3anc 3eqtr4d adantlr
        vz cv chil wcel vt cv chil wcel vt cv cT cfv vz cv csp co vt cv vz cv
        cF cfv csp co wceq vx cv cc wcel vf cv chil wcel wa vy vw vv vu vz cv
        cB vt cv cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3
        cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem5 adantll opreq12d vt cv chil wcel
        vx cv vf cv cF cfv csm co chil wcel vz cv cF cfv chil wcel vt cv vx cv
        vf cv cF cfv csm co vz cv cF cfv cva co csp co vt cv vx cv vf cv cF cfv
        csm co csp co vt cv vz cv cF cfv csp co caddc co wceq vx cv cc wcel vf
        cv chil wcel wa vz cv chil wcel wa vt cv chil wcel wa vt cv vx cv vf cv
        cF cfv csm co vz cv cF cfv his7 vx cv cc wcel vf cv chil wcel wa vz cv
        chil wcel wa vt cv chil wcel pm3.27 vx cv cc wcel vf cv chil wcel wa vx
        cv vf cv cF cfv csm co chil wcel vz cv chil wcel vt cv chil wcel vx cv
        cc wcel vf cv cF cfv chil wcel vx cv vf cv cF cfv csm co chil wcel vf
        cv chil wcel vx cv vf cv cF cfv hvmulcl vy vw vv vu vf cv cB cT vg vh
        cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 sylan2 ad2antrr vz cv chil wcel vz cv cF cfv chil wcel vx
        cv cc wcel vf cv chil wcel wa vt cv chil wcel vy vw vv vu vz cv cB cT
        vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem4 ad2antlr syl3anc eqtr4d 3eqtr3d r19.21aiva vx
        cv vf cv csm co vz cv cva co cF cfv chil wcel vx cv vf cv cF cfv csm co
        vz cv cF cfv cva co chil wcel vt cv vx cv vf cv csm co vz cv cva co cF
        cfv csp co vt cv vx cv vf cv cF cfv csm co vz cv cF cfv cva co csp co
        wceq vt chil wral vx cv vf cv csm co vz cv cva co cF cfv vx cv vf cv cF
        cfv csm co vz cv cF cfv cva co wceq wb vx cv cc wcel vf cv chil wcel wa
        vz cv chil wcel wa vt vx cv vf cv csm co vz cv cva co cF cfv vx cv vf
        cv cF cfv csm co vz cv cF cfv cva co hial2eq2 vx cv cc wcel vf cv chil
        wcel wa vz cv chil wcel wa vx cv vf cv csm co vz cv cva co chil wcel vx
        cv vf cv csm co vz cv cva co cF cfv chil wcel vx cv vf cv csm co chil
        wcel vz cv chil wcel vx cv vf cv csm co vz cv cva co chil wcel vx cv cc
        wcel vf cv chil wcel wa vx cv vf cv csm co vz cv hvaddcl vx cv vf cv
        hvmulcl sylan vy vw vv vu vx cv vf cv csm co vz cv cva co cB cT vg vh
        cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 syl vx cv vf cv cF cfv csm co chil wcel vz cv cF cfv chil
        wcel vx cv vf cv cF cfv csm co vz cv cF cfv cva co chil wcel vx cv cc
        wcel vf cv chil wcel wa vz cv chil wcel vx cv vf cv cF cfv csm co vz cv
        cF cfv hvaddcl vx cv cc wcel vf cv cF cfv chil wcel vx cv vf cv cF cfv
        csm co chil wcel vf cv chil wcel vx cv vf cv cF cfv hvmulcl vy vw vv vu
        vf cv cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3
        cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 sylan2 vy vw vv vu vz cv cB cT vg
        vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem4 syl2an sylanc mpbid r19.21aiva rgen2 mpbir2an
        $.
        $( [28-Apr-2006] $) $( [17-Feb-2006] $)

      $( Lemma for ~ cnlnadji .  Helper lemma to show that ` F ` is
         continuous. $)
      cnlnadjlem7 $p |- ( A e. ~H -> ( normh ` ( F ` A ) ) <_
                        ( ( normop ` T ) x. ( normh ` A ) ) ) $=
        cA chil wcel cA cF cfv cno cfv cT cnop cfv cA cno cfv cmul co cle wbr
        cc0 cT cnop cfv cA cno cfv cmul co cle wbr cA cF cfv cno cfv cc0 cA cF
        cfv cno cfv cc0 cT cnop cfv cA cno cfv cmul co cle breq1 cA chil wcel
        cA cF cfv cno cfv cc0 wne wa cA cF cfv cno cfv cT cnop cfv cA cno cfv
        cmul co cle wbr cA cF cfv cno cfv cA cF cfv cno cfv cmul co cT cnop cfv
        cA cno cfv cmul co cA cF cfv cno cfv cmul co cle wbr cA chil wcel cA cF
        cfv cno cfv cA cF cfv cno cfv cmul co cT cnop cfv cA cno cfv cmul co cA
        cF cfv cno cfv cmul co cle wbr cA cF cfv cno cfv cc0 wne cA chil wcel
        cA cF cfv cT cfv cA csp co cabs cfv cT cnop cfv cA cF cfv cno cfv cmul
        co cA cno cfv cmul co cA cF cfv cno cfv cA cF cfv cno cfv cmul co cT
        cnop cfv cA cno cfv cmul co cA cF cfv cno cfv cmul co cle cA chil wcel
        cA cF cfv cT cfv cA csp co cabs cfv cA cF cfv cT cfv cno cfv cA cno cfv
        cmul co cT cnop cfv cA cF cfv cno cfv cmul co cA cno cfv cmul co cA
        chil wcel cA cF cfv cT cfv cA csp co cc wcel cA cF cfv cT cfv cA csp co
        cabs cfv cr wcel cA cF cfv cT cfv chil wcel cA chil wcel cA cF cfv cT
        cfv cA csp co cc wcel cA chil wcel cA cF cfv chil wcel cA cF cfv cT cfv
        chil wcel vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2
        cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 chil chil cA cF cfv
        cT cT cnlnadjlem.1 lnopfi ffvelrni syl cA cF cfv cT cfv cA hicl mpancom
        cA cF cfv cT cfv cA csp co abscl syl cA cF cfv cT cfv cno cfv cr wcel
        cA cno cfv cr wcel cA cF cfv cT cfv cno cfv cA cno cfv cmul co cr wcel
        cA chil wcel cA cF cfv cT cfv cno cfv cA cno cfv remulcl cA chil wcel
        cA cF cfv cT cfv chil wcel cA cF cfv cT cfv cno cfv cr wcel cA chil
        wcel cA cF cfv chil wcel cA cF cfv cT cfv chil wcel vy vw vv vu cA cB
        cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem4 chil chil cA cF cfv cT cT cnlnadjlem.1 lnopfi
        ffvelrni syl cA cF cfv cT cfv normcl syl cA normcl sylanc cT cnop cfv
        cA cF cfv cno cfv cmul co cr wcel cA cno cfv cr wcel cT cnop cfv cA cF
        cfv cno cfv cmul co cA cno cfv cmul co cr wcel cA chil wcel cT cnop cfv
        cA cF cfv cno cfv cmul co cA cno cfv remulcl cA chil wcel cA cF cfv cno
        cfv cr wcel cT cnop cfv cA cF cfv cno cfv cmul co cr wcel cA chil wcel
        cA cF cfv chil wcel cA cF cfv cno cfv cr wcel vy vw vv vu cA cB cT vg
        vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem4 cA cF cfv normcl syl cT cnop cfv cr wcel cA cF
        cfv cno cfv cr wcel cT cnop cfv cA cF cfv cno cfv cmul co cr wcel cT
        cnlnadjlem.1 cnlnadjlem.2 nmcopexi cT cnop cfv cA cF cfv cno cfv
        remulcl mpan syl cA normcl sylanc cA cF cfv cT cfv chil wcel cA chil
        wcel cA cF cfv cT cfv cA csp co cabs cfv cA cF cfv cT cfv cno cfv cA
        cno cfv cmul co cle wbr cA chil wcel cA cF cfv chil wcel cA cF cfv cT
        cfv chil wcel vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 chil
        chil cA cF cfv cT cT cnlnadjlem.1 lnopfi ffvelrni syl cA cF cfv cT cfv
        cA bcs mpancom cA cF cfv cT cfv cno cfv cr wcel cT cnop cfv cA cF cfv
        cno cfv cmul co cr wcel cA cno cfv cr wcel w3a cc0 cA cno cfv cle wbr
        cA cF cfv cT cfv cno cfv cT cnop cfv cA cF cfv cno cfv cmul co cle wbr
        wa cA cF cfv cT cfv cno cfv cA cno cfv cmul co cT cnop cfv cA cF cfv
        cno cfv cmul co cA cno cfv cmul co cle wbr cA chil wcel cA cF cfv cT
        cfv cno cfv cT cnop cfv cA cF cfv cno cfv cmul co cA cno cfv lemul1aOLD
        cA chil wcel cA cF cfv cT cfv cno cfv cr wcel cT cnop cfv cA cF cfv cno
        cfv cmul co cr wcel cA cno cfv cr wcel cA chil wcel cA cF cfv cT cfv
        chil wcel cA cF cfv cT cfv cno cfv cr wcel cA chil wcel cA cF cfv chil
        wcel cA cF cfv cT cfv chil wcel vy vw vv vu cA cB cT vg vh cF cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 chil chil cA cF cfv cT cT cnlnadjlem.1 lnopfi ffvelrni syl
        cA cF cfv cT cfv normcl syl cA chil wcel cA cF cfv cno cfv cr wcel cT
        cnop cfv cA cF cfv cno cfv cmul co cr wcel cA chil wcel cA cF cfv chil
        wcel cA cF cfv cno cfv cr wcel vy vw vv vu cA cB cT vg vh cF cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 cA cF cfv normcl syl cT cnop cfv cr wcel cA cF cfv cno cfv
        cr wcel cT cnop cfv cA cF cfv cno cfv cmul co cr wcel cT cnlnadjlem.1
        cnlnadjlem.2 nmcopexi cT cnop cfv cA cF cfv cno cfv remulcl mpan syl cA
        normcl 3jca cA chil wcel cc0 cA cno cfv cle wbr cA cF cfv cT cfv cno
        cfv cT cnop cfv cA cF cfv cno cfv cmul co cle wbr cA normge0 cA chil
        wcel cA cF cfv chil wcel cA cF cfv cT cfv cno cfv cT cnop cfv cA cF cfv
        cno cfv cmul co cle wbr vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 cA cF
        cfv cT cnlnadjlem.1 cnlnadjlem.2 nmcoplbi syl jca sylanc letrd cA chil
        wcel cA cF cfv cno cfv c2 cexp co cA cF cfv cA cF cfv csp co cA cF cfv
        cno cfv cA cF cfv cno cfv cmul co cA cF cfv cT cfv cA csp co cabs cfv
        cA chil wcel cA cF cfv chil wcel cA cF cfv cno cfv c2 cexp co cA cF cfv
        cA cF cfv csp co wceq vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 cA cF
        cfv normsq syl cA chil wcel cA cF cfv cno cfv cc wcel cA cF cfv cno cfv
        c2 cexp co cA cF cfv cno cfv cA cF cfv cno cfv cmul co wceq cA chil
        wcel cA cF cfv cno cfv cA chil wcel cA cF cfv chil wcel cA cF cfv cno
        cfv cr wcel vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2
        cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 cA cF cfv normcl syl
        recnd cA cF cfv cno cfv sqval syl cA chil wcel cA cF cfv cT cfv cA csp
        co cabs cfv cA cF cfv cA cF cfv csp co cabs cfv cA cF cfv cA cF cfv csp
        co cA chil wcel cA cF cfv cT cfv cA csp co cA cF cfv cA cF cfv csp co
        cabs cA chil wcel cA cF cfv chil wcel cA cF cfv cT cfv cA csp co cA cF
        cfv cA cF cfv csp co wceq vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 vy vw
        vv vu cA cB cA cF cfv cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2
        cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem5 mpdan fveq2d cA cF
        cfv cA cF cfv csp co cr wcel cc0 cA cF cfv cA cF cfv csp co cle wbr cA
        cF cfv cA cF cfv csp co cabs cfv cA cF cfv cA cF cfv csp co wceq cA
        chil wcel cA cF cfv cA cF cfv csp co absid cA chil wcel cA cF cfv chil
        wcel cA cF cfv cA cF cfv csp co cr wcel vy vw vv vu cA cB cT vg vh cF
        cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 cA cF cfv hiidrcl syl cA chil wcel cA cF cfv chil wcel cc0
        cA cF cfv cA cF cfv csp co cle wbr vy vw vv vu cA cB cT vg vh cF cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 cA cF cfv hiidge0 syl sylanc eqtr2d 3eqtr3rd cA cF cfv cno
        cfv cc wcel cA cno cfv cc wcel cT cnop cfv cA cF cfv cno cfv cmul co cA
        cno cfv cmul co cT cnop cfv cA cno cfv cmul co cA cF cfv cno cfv cmul
        co wceq cA chil wcel cT cnop cfv cc wcel cA cF cfv cno cfv cc wcel cA
        cno cfv cc wcel cT cnop cfv cA cF cfv cno cfv cmul co cA cno cfv cmul
        co cT cnop cfv cA cno cfv cmul co cA cF cfv cno cfv cmul co wceq cT
        cnop cfv cT cnlnadjlem.1 cnlnadjlem.2 nmcopexi recni cT cnop cfv cA cF
        cfv cno cfv cA cno cfv mul23 mp3an1 cA chil wcel cA cF cfv cno cfv cA
        chil wcel cA cF cfv chil wcel cA cF cfv cno cfv cr wcel vy vw vv vu cA
        cB cT vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem4 cA cF cfv normcl syl recnd cA chil wcel cA cno
        cfv cA normcl recnd sylanc 3brtr3d adantr cA cF cfv cno cfv cr wcel cT
        cnop cfv cA cno cfv cmul co cr wcel cA cF cfv cno cfv cr wcel w3a cc0
        cA cF cfv cno cfv clt wbr cA cF cfv cno cfv cT cnop cfv cA cno cfv cmul
        co cle wbr cA cF cfv cno cfv cA cF cfv cno cfv cmul co cT cnop cfv cA
        cno cfv cmul co cA cF cfv cno cfv cmul co cle wbr wb cA chil wcel cA cF
        cfv cno cfv cc0 wne wa cA cF cfv cno cfv cT cnop cfv cA cno cfv cmul co
        cA cF cfv cno cfv lemul1OLD cA chil wcel cA cF cfv cno cfv cr wcel cT
        cnop cfv cA cno cfv cmul co cr wcel cA cF cfv cno cfv cr wcel w3a cA cF
        cfv cno cfv cc0 wne cA chil wcel cA cF cfv cno cfv cr wcel cT cnop cfv
        cA cno cfv cmul co cr wcel cA cF cfv cno cfv cr wcel cA chil wcel cA cF
        cfv chil wcel cA cF cfv cno cfv cr wcel vy vw vv vu cA cB cT vg vh cF
        cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem4 cA cF cfv normcl syl cA chil wcel cA cno cfv cr wcel cT
        cnop cfv cA cno cfv cmul co cr wcel cA normcl cT cnop cfv cr wcel cA
        cno cfv cr wcel cT cnop cfv cA cno cfv cmul co cr wcel cT cnlnadjlem.1
        cnlnadjlem.2 nmcopexi cT cnop cfv cA cno cfv remulcl mpan syl cA chil
        wcel cA cF cfv chil wcel cA cF cfv cno cfv cr wcel vy vw vv vu cA cB cT
        vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem4 cA cF cfv normcl syl 3jca adantr cA cF cfv
        chil wcel cA cF cfv cno cfv cc0 wne cc0 cA cF cfv cno cfv clt wbr cA
        chil wcel cA cF cfv chil wcel cc0 cA cF cfv cno cfv clt wbr cA cF cfv
        cno cfv cc0 wne cA cF cfv cno cfv cr wcel cc0 cA cF cfv cno cfv cle wbr
        cc0 cA cF cfv cno cfv clt wbr cA cF cfv cno cfv cc0 wne wb cA cF cfv
        chil wcel cc0 cr wcel cA cF cfv cno cfv cr wcel cc0 cA cF cfv cno cfv
        cle wbr cc0 cA cF cfv cno cfv clt wbr cA cF cfv cno cfv cc0 wne wb 0re
        cc0 cA cF cfv cno cfv leltne mp3an1 cA cF cfv normcl cA cF cfv normge0
        sylanc biimpar vy vw vv vu cA cB cT vg vh cF cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem4 sylan
        sylanc mpbird cT cnop cfv cr wcel cA cno cfv cr wcel wa cc0 cT cnop cfv
        cle wbr cc0 cA cno cfv cle wbr wa cc0 cT cnop cfv cA cno cfv cmul co
        cle wbr cA chil wcel cT cnop cfv cA cno cfv mulge0OLD cA chil wcel cA
        cno cfv cr wcel cT cnop cfv cr wcel cA normcl cT cnlnadjlem.1
        cnlnadjlem.2 nmcopexi jctil cA chil wcel cc0 cA cno cfv cle wbr cc0 cT
        cnop cfv cle wbr cA normge0 chil chil cT wf cc0 cT cnop cfv cle wbr cT
        cnlnadjlem.1 lnopfi cT nmopge0 ax-mp jctil sylanc pm2.61ne $.
        $( [28-Apr-2006] $) $( [18-Feb-2006] $)

      $( Lemma for ~ cnlnadji .  ` F ` is continuous. $)
      cnlnadjlem8 $p |- F e. ConOp $=
        cF cco wcel vz cv cF cfv cno cfv vx cv vz cv cno cfv cmul co cle wbr vz
        chil wral vx cr wrex cT cnop cfv cr wcel vz cv cF cfv cno cfv cT cnop
        cfv vz cv cno cfv cmul co cle wbr vz chil wral vz cv cF cfv cno cfv vx
        cv vz cv cno cfv cmul co cle wbr vz chil wral vx cr wrex cT
        cnlnadjlem.1 cnlnadjlem.2 nmcopexi vz cv cF cfv cno cfv cT cnop cfv vz
        cv cno cfv cmul co cle wbr vz chil vy vw vv vu vz cv cB cT vg vh cF cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem7 rgen vz cv cF cfv cno cfv vx cv vz cv cno cfv cmul co cle
        wbr vz chil wral vz cv cF cfv cno cfv cT cnop cfv vz cv cno cfv cmul co
        cle wbr vz chil wral vx cT cnop cfv cr vx cv cT cnop cfv wceq vz cv cF
        cfv cno cfv vx cv vz cv cno cfv cmul co cle wbr vz cv cF cfv cno cfv cT
        cnop cfv vz cv cno cfv cmul co cle wbr vz chil vx cv cT cnop cfv wceq
        vx cv vz cv cno cfv cmul co cT cnop cfv vz cv cno cfv cmul co vz cv cF
        cfv cno cfv cle vx cv cT cnop cfv vz cv cno cfv cmul opreq1 breq2d
        ralbidv rcla4ev mp2an vx vz cF vy vw vv vu cB cT vg vh cF cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem6 lnopconi mpbir $.
        $( [29-Apr-2006] $) $( [17-Feb-2006] $)

      $( Lemma for ~ cnlnadji .  ` F ` provides an example showing the
         existence of a continuous linear adjoint. $)
      cnlnadjlem9 $p |- E. t e. ( LinOp i^i ConOp )
             A. x e. ~H A. z e. ~H ( ( T ` x ) .ih z ) = ( x .ih ( t ` z ) ) $=
        cF clo cco cin wcel vx cv cT cfv vz cv csp co vx cv vz cv cF cfv csp co
        wceq vz chil wral vx chil wral vx cv cT cfv vz cv csp co vx cv vz cv vt
        cv cfv csp co wceq vz chil wral vx chil wral vt clo cco cin wrex cF clo
        cco cin wcel cF clo wcel cF cco wcel cF clo cco elin vy vw vv vu cB cT
        vg vh cF cG cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4
        cnlnadjlem.5 cnlnadjlem6 vy vw vv vu cB cT vg vh cF cG cnlnadjlem.1
        cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5 cnlnadjlem8
        mpbir2an vx cv cT cfv vz cv csp co vx cv vz cv cF cfv csp co wceq vx vz
        chil vz cv chil wcel vx cv chil wcel vx cv cT cfv vz cv csp co vx cv vz
        cv cF cfv csp co wceq vy vw vv vu vz cv cB vx cv cT vg vh cF cG
        cnlnadjlem.1 cnlnadjlem.2 cnlnadjlem.3 cnlnadjlem.4 cnlnadjlem.5
        cnlnadjlem5 ancoms rgen2a vx cv cT cfv vz cv csp co vx cv vz cv vt cv
        cfv csp co wceq vz chil wral vx chil wral vx cv cT cfv vz cv csp co vx
        cv vz cv cF cfv csp co wceq vz chil wral vx chil wral vt cF clo cco cin
        vt cv cF wceq vx cv cT cfv vz cv csp co vx cv vz cv vt cv cfv csp co
        wceq vx cv cT cfv vz cv csp co vx cv vz cv cF cfv csp co wceq vx vz
        chil chil vt cv cF wceq vx cv vz cv vt cv cfv csp co vx cv vz cv cF cfv
        csp co vx cv cT cfv vz cv csp co vt cv cF wceq vz cv vt cv cfv vz cv cF
        cfv vx cv csp vz cv vt cv cF fveq1 opreq2d eqeq2d 2ralbidv rcla4ev
        mp2an $.
        $( [29-Apr-2006] $) $( [18-Feb-2006] $)
    $}
  $}

  ${
    $d f g h t u v w x y z T $.
    cnlnadj.1 $e |- T e. LinOp $.
    cnlnadj.2 $e |- T e. ConOp $.
    $( Every continuous linear operator has an adjoint.  Theorem 3.10 of
       [Beran] p. 104. $)
    cnlnadji $p |- E. t e. ( LinOp i^i ConOp )
             A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) $=
      vx vz vy vw vv vu vt vv cv cT cfv vz cv csp co vv cv vf cv csp co wceq vv
      chil wral vf chil crab cuni cT vg vh vz cv chil wcel vu cv vv cv cT cfv
      vz cv csp co vv cv vf cv csp co wceq vv chil wral vf chil crab cuni wceq
      wa vz vu copab vg cv chil wcel vh cv vg cv cT cfv vz cv csp co wceq wa vg
      vh copab cnlnadj.1 cnlnadj.2 vg cv chil wcel vh cv vg cv cT cfv vz cv csp
      co wceq wa vg vh copab eqid vv cv cT cfv vz cv csp co vv cv vf cv csp co
      wceq vv chil wral vf chil crab vv cv cT cfv vz cv csp co vv cv vw cv csp
      co wceq vv chil wral vw chil crab vv cv cT cfv vz cv csp co vv cv vf cv
      csp co wceq vv chil wral vv cv cT cfv vz cv csp co vv cv vw cv csp co
      wceq vv chil wral vf vw chil vf cv vw cv wceq vv cv cT cfv vz cv csp co
      vv cv vf cv csp co wceq vv cv cT cfv vz cv csp co vv cv vw cv csp co wceq
      vv chil vf cv vw cv wceq vv cv vf cv csp co vv cv vw cv csp co vv cv cT
      cfv vz cv csp co vf cv vw cv vv cv csp opreq2 eqeq2d ralbidv cbvrabv
      unieqi vz cv chil wcel vu cv vv cv cT cfv vz cv csp co vv cv vf cv csp co
      wceq vv chil wral vf chil crab cuni wceq wa vz vu copab eqid cnlnadjlem9
      $.
      $( [29-Apr-2006] $) $( [18-Feb-2006] $)

    $( Every continuous linear operator has a unique adjoint.  Theorem 3.10 of
       [Beran] p. 104. $)
    cnlnadjeui $p |- E! t e. ( LinOp i^i ConOp )
             A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) $=
      vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral
      vx chil wral vt clo cco cin wreu vx cv cT cfv vy cv csp co vx cv vy cv vt
      cv cfv csp co wceq vy chil wral vx chil wral vt clo cco cin wrex vt cv
      clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co
      wceq vy chil wral vx chil wral wa vt wmo vx cv cT cfv vy cv csp co vx cv
      vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt clo cco cin reu5
      vx vy vt cT cnlnadj.1 cnlnadj.2 cnlnadji chil chil vt cv wf vx cv vy cv
      cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral
      wa vt wmo vt cv clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv vt
      cv cfv csp co wceq vy chil wral vx chil wral wa vt wmo vx vy vt cT adjmo
      vt cv clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv
      csp co wceq vy chil wral vx chil wral wa chil chil vt cv wf vx cv vy cv
      cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral
      wa vt chil chil vt cv wf vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv
      csp co wceq vy chil wral vx chil wral chil chil vt cv wf vx cv vy cv cT
      cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil wral wa
      vt cv clo cco cin wcel chil chil vt cv wf vx cv cT cfv vy cv csp co vx cv
      vy cv vt cv cfv csp co wceq vy chil wral vx chil wral wa chil chil vt cv
      wf vx cv vy cv cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil
      wral vx chil wral chil chil vt cv wf vx cv cT cfv vy cv csp co vx cv vy
      cv vt cv cfv csp co wceq vy chil wral vx chil wral pm3.26 chil chil vt cv
      wf vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil
      wral vx chil wral vx cv vy cv cT cfv csp co vx cv vt cv cfv vy cv csp co
      wceq vy chil wral vx chil wral chil chil vt cv wf vx cv vy cv vt cv cfv
      csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx chil wral vx cv vy
      cv cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil
      wral vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil
      wral vx chil wral chil chil vt cv wf chil chil cT wf vx cv vy cv vt cv
      cfv csp co vx cv cT cfv vy cv csp co wceq vy chil wral vx chil wral vx cv
      vy cv cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx
      chil wral wb cT cnlnadj.1 lnopfi vx vy vt cv cT adjsym mpan2 vx cv cT cfv
      vy cv csp co vx cv vy cv vt cv cfv csp co wceq vx cv vy cv vt cv cfv csp
      co vx cv cT cfv vy cv csp co wceq vx vy chil chil vx cv cT cfv vy cv csp
      co vx cv vy cv vt cv cfv csp co eqcom 2ralbii syl5bb biimpa jca vt cv clo
      cco cin wcel vt cv clo wcel chil chil vt cv wf clo cco cin clo vt cv clo
      cco inss1 sseli vt cv lnopf syl sylan immoi ax-mp mpbir2an $.
      $( [29-Apr-2006] $) $( [18-Feb-2006] $)
  $}

  ${
    $d t x y T $.
    $( Every continuous linear operator has a unique adjoint.  Theorem 3.10 of
       [Beran] p. 104. $)
    cnlnadjeu $p |- ( T e. ( LinOp i^i ConOp ) -> E! t e. ( LinOp i^i ConOp )
           A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) ) $=
      cT clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp
      co wceq vy chil wral vx chil wral vt clo cco cin wreu vx cv cT clo cco
      cin wcel cT ch0o cif cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq
      vy chil wral vx chil wral vt clo cco cin wreu cT ch0o cT cT clo cco cin
      wcel cT ch0o cif wceq vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp
      co wceq vy chil wral vx chil wral vx cv cT clo cco cin wcel cT ch0o cif
      cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil
      wral vt clo cco cin cT cT clo cco cin wcel cT ch0o cif wceq vx cv cT cfv
      vy cv csp co vx cv vy cv vt cv cfv csp co wceq vx cv cT clo cco cin wcel
      cT ch0o cif cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vx vy chil
      chil cT cT clo cco cin wcel cT ch0o cif wceq vx cv cT cfv vy cv csp co vx
      cv cT clo cco cin wcel cT ch0o cif cfv vy cv csp co vx cv vy cv vt cv cfv
      csp co cT cT clo cco cin wcel cT ch0o cif wceq vx cv cT cfv vx cv cT clo
      cco cin wcel cT ch0o cif cfv vy cv csp vx cv cT cT clo cco cin wcel cT
      ch0o cif fveq1 opreq1d eqeq1d 2ralbidv reubidv vx vy vt cT clo cco cin
      wcel cT ch0o cif clo cco cin clo cT clo cco cin wcel cT ch0o cif clo cco
      inss1 cT ch0o clo cco cin ch0o clo cco cin wcel ch0o clo wcel ch0o cco
      wcel ch0o clo cco elin 0lnop 0cnop mpbir2an elimel sselii clo cco cin cco
      cT clo cco cin wcel cT ch0o cif clo cco inss2 cT ch0o clo cco cin ch0o
      clo cco cin wcel ch0o clo wcel ch0o cco wcel ch0o clo cco elin 0lnop
      0cnop mpbir2an elimel sselii cnlnadjeui dedth $.
      $( [29-Apr-2006] $) $( [19-Feb-2006] $)

    $( Every continuous linear operator has an adjoint.  Theorem 3.10 of
       [Beran] p. 104. $)
    cnlnadj $p |- ( T e. ( LinOp i^i ConOp ) -> E. t e. ( LinOp i^i ConOp )
           A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) ) $=
      cT clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp
      co wceq vy chil wral vx chil wral vt clo cco cin wreu vx cv cT cfv vy cv
      csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt clo
      cco cin wrex vx vy vt cT cnlnadjeu vx cv cT cfv vy cv csp co vx cv vy cv
      vt cv cfv csp co wceq vy chil wral vx chil wral vt clo cco cin reurex syl
      $.
      $( [29-Apr-2006] $) $( [18-Feb-2006] $)
  $}

  ${
    $d t u v x y z $.
    $( Every continuous linear Hilbert space operator has an adjoint. $)
    cnlnssadj $p |- ( LinOp i^i ConOp ) C_ dom adjh $=
      vy clo cco cin cado cdm vy cv clo cco cin wcel vy cv vt cv cop cado wcel
      vt wex vy cv cado cdm wcel vy cv clo cco cin wcel vt cv clo cco cin wcel
      vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vz chil
      wral vx chil wral wa vt wex vy cv vt cv cop cado wcel vt wex vy cv clo
      cco cin wcel vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co
      wceq vz chil wral vx chil wral vt clo cco cin wrex vt cv clo cco cin wcel
      vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vz chil
      wral vx chil wral wa vt wex vx vz vt vy cv cnlnadj vx cv vy cv cfv vz cv
      csp co vx cv vz cv vt cv cfv csp co wceq vz chil wral vx chil wral vt clo
      cco cin df-rex sylib vy cv clo cco cin wcel vt cv clo cco cin wcel vx cv
      vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vz chil wral vx
      chil wral wa vy cv vt cv cop cado wcel vt vy cv clo cco cin wcel vt cv
      clo cco cin wcel vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp
      co wceq vz chil wral vx chil wral wa chil chil vy cv wf chil chil vt cv
      wf vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv csp co wceq vz chil
      wral vx chil wral w3a vy cv vt cv cop cado wcel vy cv clo cco cin wcel vt
      cv clo cco cin wcel vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv
      csp co wceq vz chil wral vx chil wral wa chil chil vy cv wf chil chil vt
      cv wf vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv csp co wceq vz
      chil wral vx chil wral vy cv clo cco cin wcel chil chil vy cv wf vt cv
      clo cco cin wcel vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp
      co wceq vz chil wral vx chil wral wa vy cv clo cco cin wcel vy cv clo
      wcel chil chil vy cv wf clo cco cin clo vy cv clo cco inss1 sseli vy cv
      lnopf syl a1d vy cv clo cco cin wcel vt cv clo cco cin wcel chil chil vt
      cv wf vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vz
      chil wral vx chil wral vt cv clo cco cin wcel chil chil vt cv wf wi vy cv
      clo cco cin wcel vt cv clo cco cin wcel vt cv clo wcel chil chil vt cv wf
      clo cco cin clo vt cv clo cco inss1 sseli vt cv lnopf syl a1i adantrd vy
      cv clo cco cin wcel vt cv clo cco cin wcel vx cv vy cv cfv vz cv csp co
      vx cv vz cv vt cv cfv csp co wceq vz chil wral vx chil wral vx cv vz cv
      vy cv cfv csp co vx cv vt cv cfv vz cv csp co wceq vz chil wral vx chil
      wral vy cv clo cco cin wcel vt cv clo cco cin wcel wa vx cv vz cv vt cv
      cfv csp co vx cv vy cv cfv vz cv csp co wceq vz chil wral vx chil wral vx
      cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv csp co wceq vz chil wral
      vx chil wral vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co
      wceq vz chil wral vx chil wral vt cv clo cco cin wcel vy cv clo cco cin
      wcel vx cv vz cv vt cv cfv csp co vx cv vy cv cfv vz cv csp co wceq vz
      chil wral vx chil wral vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv
      csp co wceq vz chil wral vx chil wral wb chil chil vt cv wf chil chil vy
      cv wf vx cv vz cv vt cv cfv csp co vx cv vy cv cfv vz cv csp co wceq vz
      chil wral vx chil wral vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv
      csp co wceq vz chil wral vx chil wral wb vt cv clo cco cin wcel vy cv clo
      cco cin wcel vx vz vt cv vy cv adjsym vt cv clo cco cin wcel vt cv clo
      wcel chil chil vt cv wf clo cco cin clo vt cv clo cco inss1 sseli vt cv
      lnopf syl vy cv clo cco cin wcel vy cv clo wcel chil chil vy cv wf clo
      cco cin clo vy cv clo cco inss1 sseli vy cv lnopf syl syl2an ancoms vx cv
      vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vz chil wral vx
      cv vz cv vt cv cfv csp co vx cv vy cv cfv vz cv csp co wceq vz chil wral
      vx chil vx cv vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vx
      cv vz cv vt cv cfv csp co vx cv vy cv cfv vz cv csp co wceq vz chil vx cv
      vy cv cfv vz cv csp co vx cv vz cv vt cv cfv csp co wceq vx cv vz cv vt
      cv cfv csp co vx cv vy cv cfv vz cv csp co wceq vx cv vy cv cfv vz cv csp
      co vx cv vz cv vt cv cfv csp co eqcom biimpi r19.20si r19.20si syl5bi
      expimpd 3jcad vy cv vt cv cop cado wcel vy cv vt cv cop chil chil vu cv
      wf chil chil vv cv wf vx cv vz cv vu cv cfv csp co vx cv vv cv cfv vz cv
      csp co wceq vz chil wral vx chil wral w3a vu vv copab wcel chil chil vy
      cv wf chil chil vt cv wf vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz
      cv csp co wceq vz chil wral vx chil wral w3a cado chil chil vu cv wf chil
      chil vv cv wf vx cv vz cv vu cv cfv csp co vx cv vv cv cfv vz cv csp co
      wceq vz chil wral vx chil wral w3a vu vv copab vy cv vt cv cop vx vz vv
      vu dfadj2 eleq2i chil chil vu cv wf chil chil vv cv wf vx cv vz cv vu cv
      cfv csp co vx cv vv cv cfv vz cv csp co wceq vz chil wral vx chil wral
      w3a chil chil vy cv wf chil chil vv cv wf vx cv vz cv vy cv cfv csp co vx
      cv vv cv cfv vz cv csp co wceq vz chil wral vx chil wral w3a chil chil vy
      cv wf chil chil vt cv wf vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz
      cv csp co wceq vz chil wral vx chil wral w3a vu vv vy cv vt cv vy visset
      vt visset vu cv vy cv wceq chil chil vu cv wf chil chil vy cv wf vx cv vz
      cv vu cv cfv csp co vx cv vv cv cfv vz cv csp co wceq vz chil wral vx
      chil wral vx cv vz cv vy cv cfv csp co vx cv vv cv cfv vz cv csp co wceq
      vz chil wral vx chil wral chil chil vv cv wf chil chil vu cv vy cv feq1
      vu cv vy cv wceq vx cv vz cv vu cv cfv csp co vx cv vv cv cfv vz cv csp
      co wceq vx cv vz cv vy cv cfv csp co vx cv vv cv cfv vz cv csp co wceq vx
      vz chil chil vu cv vy cv wceq vx cv vz cv vu cv cfv csp co vx cv vz cv vy
      cv cfv csp co vx cv vv cv cfv vz cv csp co vu cv vy cv wceq vz cv vu cv
      cfv vz cv vy cv cfv vx cv csp vz cv vu cv vy cv fveq1 opreq2d eqeq1d
      2ralbidv 3anbi13d vv cv vt cv wceq chil chil vv cv wf chil chil vt cv wf
      vx cv vz cv vy cv cfv csp co vx cv vv cv cfv vz cv csp co wceq vz chil
      wral vx chil wral vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv csp
      co wceq vz chil wral vx chil wral chil chil vy cv wf chil chil vv cv vt
      cv feq1 vv cv vt cv wceq vx cv vz cv vy cv cfv csp co vx cv vv cv cfv vz
      cv csp co wceq vx cv vz cv vy cv cfv csp co vx cv vt cv cfv vz cv csp co
      wceq vx vz chil chil vv cv vt cv wceq vx cv vv cv cfv vz cv csp co vx cv
      vt cv cfv vz cv csp co vx cv vz cv vy cv cfv csp co vv cv vt cv wceq vx
      cv vv cv cfv vx cv vt cv cfv vz cv csp vx cv vv cv vt cv fveq1 opreq1d
      eqeq2d 2ralbidv 3anbi23d opelopab bitr2i syl6ib 19.22dv mpd vt vy cv cado
      vy visset eldm2 sylibr ssriv $.
      $( [24-May-2006] $) $( [18-Feb-2006] $)
  $}


  $( Every bounded linear Hilbert space operator has an adjoint. $)
  bdopssadj $p |- BndLinOp C_ dom adjh $=
    cbo clo cco cin cado cdm lncnbd cnlnssadj eqsstr3i $.
    $( [4-Jun-2006] $) $( [19-Feb-2006] $)

  $( Every bounded linear Hilbert space operator has an adjoint. $)
  bdopadj $p |- ( T e. BndLinOp -> T e. dom adjh ) $=
    cbo cado cdm cT bdopssadj sseli $.
    $( [10-Jun-2006] $) $( [22-Feb-2006] $)

  ${
    $d t w x y z T $.
    $( The adjoint of a bounded linear operator is a bounded linear
       operator. $)
    adjbdln $p |- ( T e. BndLinOp -> ( adjh ` T ) e. BndLinOp ) $=
      cT cbo wcel cT cado cfv vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv
      csp co wceq vy chil wral vx chil wral vt cbo crab cuni cbo cT cbo wcel vx
      cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx
      chil wral vt chil chil cm co crab cuni chil chil vt cv wf vx cv cT cfv vy
      cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral wa
      vt cab cuni vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq
      vy chil wral vx chil wral vt cbo crab cuni cT cado cfv vx cv cT cfv vy cv
      csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt
      chil chil cm co crab cuni chil chil vt cv wf vx cv cT cfv vy cv csp co vx
      cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral wa vt cab cuni
      wceq cT cbo wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co
      wceq vy chil wral vx chil wral vt chil chil cm co crab chil chil vt cv wf
      vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral
      vx chil wral wa vt cab vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv
      csp co wceq vy chil wral vx chil wral vt chil chil cm co crab vt cv chil
      chil cm co wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co
      wceq vy chil wral vx chil wral wa vt cab chil chil vt cv wf vx cv cT cfv
      vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral
      wa vt cab vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy
      chil wral vx chil wral vt chil chil cm co df-rab vt cv chil chil cm co
      wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil
      wral vx chil wral wa chil chil vt cv wf vx cv cT cfv vy cv csp co vx cv
      vy cv vt cv cfv csp co wceq vy chil wral vx chil wral wa vt vt cv chil
      chil cm co wcel chil chil vt cv wf vx cv cT cfv vy cv csp co vx cv vy cv
      vt cv cfv csp co wceq vy chil wral vx chil wral chil chil vt cv ax-hilex
      ax-hilex elmap anbi1i abbii eqtri unieqi a1i vx cv cT cfv vy cv csp co vx
      cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt cbo wrex vt
      cv chil chil cm co wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv
      csp co wceq vy chil wral vx chil wral wa vt wmo vx cv cT cfv vy cv csp co
      vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt cbo crab
      cuni vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil
      wral vx chil wral vt chil chil cm co crab cuni wceq cT cbo wcel cbo chil
      chil cm co wss vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co
      wceq vy chil wral vx chil wral vt cbo wrex vt cv chil chil cm co wcel vx
      cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx
      chil wral wa vt wmo vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp
      co wceq vy chil wral vx chil wral vt cbo crab cuni vx cv cT cfv vy cv csp
      co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt chil
      chil cm co crab cuni wceq vt cbo chil chil cm co vt cv cbo wcel chil chil
      vt cv wf vt cv chil chil cm co wcel vt cv bdopf chil chil vt cv ax-hilex
      ax-hilex elmap sylibr ssriv vx cv cT cfv vy cv csp co vx cv vy cv vt cv
      cfv csp co wceq vy chil wral vx chil wral vt cbo chil chil cm co mouniss
      mp3an1 cT clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv
      cfv csp co wceq vy chil wral vx chil wral vt clo cco cin wrex cT cbo wcel
      vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral
      vx chil wral vt cbo wrex vx vy vt cT cnlnadj cT lncnopbd clo cco cin cbo
      wceq vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil
      wral vx chil wral vt clo cco cin wrex vx cv cT cfv vy cv csp co vx cv vy
      cv vt cv cfv csp co wceq vy chil wral vx chil wral vt cbo wrex wb lncnbd
      vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral
      vx chil wral vt clo cco cin cbo rexeq1 ax-mp 3imtr3i cT cbo wcel vt cv
      chil chil cm co wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp
      co wceq vy chil wral vx chil wral wa vt wmo chil chil vt cv wf vx cv vy
      cv cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil wral vx chil
      wral wa vt wmo vx vy vt cT adjmo cT cbo wcel vt cv chil chil cm co wcel
      vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral
      vx chil wral wa chil chil vt cv wf vx cv vy cv cT cfv csp co vx cv vt cv
      cfv vy cv csp co wceq vy chil wral vx chil wral wa vt cT cbo wcel vt
      ax-17 cT cbo wcel chil chil vt cv wf vx cv vy cv cT cfv csp co vx cv vt
      cv cfv vy cv csp co wceq vy chil wral vx chil wral wa chil chil vt cv wf
      vx cv vy cv vt cv cfv csp co vx cv cT cfv vy cv csp co wceq vy chil wral
      vx chil wral wa vt cv chil chil cm co wcel vx cv cT cfv vy cv csp co vx
      cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral wa cT cbo wcel
      chil chil vt cv wf vx cv vy cv cT cfv csp co vx cv vt cv cfv vy cv csp co
      wceq vy chil wral vx chil wral vx cv vy cv vt cv cfv csp co vx cv cT cfv
      vy cv csp co wceq vy chil wral vx chil wral chil chil cT wf chil chil vt
      cv wf vx cv vy cv cT cfv csp co vx cv vt cv cfv vy cv csp co wceq vy chil
      wral vx chil wral vx cv vy cv vt cv cfv csp co vx cv cT cfv vy cv csp co
      wceq vy chil wral vx chil wral wb cT cbo wcel vx vy cT vt cv adjsym cT
      bdopf sylan pm5.32da vt cv chil chil cm co wcel chil chil vt cv wf vx cv
      cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx
      chil wral vx cv vy cv vt cv cfv csp co vx cv cT cfv vy cv csp co wceq vy
      chil wral vx chil wral chil chil vt cv ax-hilex ax-hilex elmap vx cv cT
      cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vx cv vy cv vt cv cfv
      csp co vx cv cT cfv vy cv csp co wceq vx vy chil chil vx cv cT cfv vy cv
      csp co vx cv vy cv vt cv cfv csp co eqcom 2ralbii anbi12i syl6rbbr mobid
      mpbiri sylanc cT cbo wcel chil chil cT wf cT cado cfv chil chil vt cv wf
      vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral
      vx chil wral wa vt cab cuni wceq cT bdopf vx vy vt cT adjval2 syl
      3eqtr4rd cT cbo wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp
      co wceq vy chil wral vx chil wral vt cbo wreu vx cv cT cfv vy cv csp co
      vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt cbo crab
      cuni cbo wcel cT clo cco cin wcel vx cv cT cfv vy cv csp co vx cv vy cv
      vt cv cfv csp co wceq vy chil wral vx chil wral vt clo cco cin wreu cT
      cbo wcel vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy
      chil wral vx chil wral vt cbo wreu vx vy vt cT cnlnadjeu cT lncnopbd clo
      cco cin cbo wceq vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co
      wceq vy chil wral vx chil wral vt clo cco cin wreu vx cv cT cfv vy cv csp
      co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx chil wral vt cbo
      wreu wb lncnbd vx cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co
      wceq vy chil wral vx chil wral vt clo cco cin cbo reueq1 ax-mp 3imtr3i vx
      cv cT cfv vy cv csp co vx cv vy cv vt cv cfv csp co wceq vy chil wral vx
      chil wral vt cbo reucl syl eqeltrd $.
      $( [29-Apr-2006] $) $( [19-Feb-2006] $)

    $( An operator is bounded and linear iff its adjoint is. $)
    adjbdlnb $p |- ( T e. BndLinOp <-> ( adjh ` T ) e. BndLinOp ) $=
      cT cbo wcel cT cado cfv cbo wcel cT adjbdln cT cado cdm wcel cT cado cfv
      cbo wcel cT cbo wcel cT cado cfv cbo wcel cT cado cfv cado cdm wcel cT
      cado cdm wcel cT cado cfv bdopadj cT dmadjrnb sylibr cT cado cdm wcel cT
      cado cfv cbo wcel wa cT cT cado cfv cado cfv cbo cT cado cdm wcel cT cado
      cfv cbo wcel wa cT cado cado ccom cfv cT cid cado cdm cres cfv cT cado
      cfv cado cfv cT cT cado cado ccom cfv cT cid cado cdm cres cfv wceq cT
      cado cdm wcel cT cado cfv cbo wcel wa cT cado cado ccom cid cado cdm cres
      cado ccnv cado ccom cado cado ccom cid cado cdm cres cado ccnv cado cado
      cnvadj coeq1i cado cdm cado cdm cado wf1o cado ccnv cado ccom cid cado
      cdm cres wceq adj1o cado cdm cado cdm cado f1ococnv1 ax-mp eqtr3i fveq1i
      a1i cT cado cdm wcel cT cado cado ccom cfv cT cado cfv cado cfv wceq cT
      cado cfv cbo wcel cado wfun cado wfun cT cado cdm wcel cT cado cado ccom
      cfv cT cado cfv cado cfv wceq funadj funadj cT cado cado fvco mp3an12
      adantr cT cado cdm wcel cT cid cado cdm cres cfv cT wceq cT cado cfv cbo
      wcel cado cdm cT fvresi adantr 3eqtr3rd cT cado cfv cbo wcel cT cado cfv
      cado cfv cbo wcel cT cado cdm wcel cT cado cfv adjbdln adantl eqeltrd
      mpancom impbii $.
      $( [7-Jun-2006] $) $( [19-Feb-2006] $)

    $( The mapping of adjoints of bounded linear operators is
       one-to-one onto. $)
    adjbd1o $p |- ( adjh |` BndLinOp ) : BndLinOp -1-1-onto-> BndLinOp $=
      cbo cado cbo cima cado cbo cres wf1o cbo cbo cado cbo cres wf1o cado cdm
      cado cdm cado wf1 cbo cado cdm wss cbo cado cbo cima cado cbo cres wf1o
      cado cdm cado cdm cado wf1o cado cdm cado cdm cado wf1 adj1o cado cdm
      cado cdm cado f1of1 ax-mp bdopssadj cado cdm cado cdm cbo cado f1ores
      mp2an cado cbo cima cbo wceq cbo cado cbo cima cado cbo cres wf1o cbo cbo
      cado cbo cres wf1o wb vy cado cbo cima cbo vy cv cado cbo cima wcel vx cv
      vy cv cado wbr vx cbo wrex vx cv cado cfv vy cv wceq vx cbo wrex vy cv
      cbo wcel vx vy cv cado cbo vy visset elima vx cv cado cfv vy cv wceq vx
      cv vy cv cado wbr vx cbo vx cv cbo wcel vx cv cado cdm wcel vx cv cado
      cfv vy cv wceq vx cv vy cv cado wbr wb vx cv bdopadj cado cado cdm wfn vx
      cv cado cdm wcel vx cv cado cfv vy cv wceq vx cv vy cv cado wbr wb cado
      cdm cado cdm cado wf1o cado cado cdm wfn adj1o cado cdm cado cdm cado
      f1ofn ax-mp cado cdm vx cv vy cv cado vy visset fnbrfvb mpan syl rexbiia
      vx cv cado cfv vy cv wceq vx cbo wrex vy cv cbo wcel vx cv cado cfv vy cv
      wceq vy cv cbo wcel vx cbo vx cv cado cfv vy cv wceq vx cv cbo wcel vy cv
      cbo wcel vx cv cado cfv vy cv wceq vx cv cado cfv cbo wcel vy cv cbo wcel
      vx cv cbo wcel vx cv cado cfv vy cv cbo eleq1 vx cv adjbdlnb syl5bb
      biimpcd r19.23aiv vy cv cado cfv cbo wcel vy cv cado cfv cado cfv vy cv
      wceq vx cv cado cfv vy cv wceq vx cbo wrex vy cv cbo wcel vx cv cado cfv
      vy cv wceq vy cv cado cfv cado cfv vy cv wceq vx vy cv cado cfv cbo vx cv
      vy cv cado cfv wceq vx cv cado cfv vy cv cado cfv cado cfv vy cv vx cv vy
      cv cado cfv cado fveq2 eqeq1d rcla4ev vy cv adjbdln vy cv cbo wcel vy cv
      cado cdm wcel vy cv cado cfv cado cfv vy cv wceq vy cv bdopadj vy cv
      adjadj syl sylanc impbii 3bitr2i eqriv cado cbo cima cbo cbo cado cbo
      cres f1oeq3 ax-mp mpbi $.
      $( [20-Oct-2006] $) $( [19-Feb-2006] $)

    $( The adjoint of an operator is linear.  Proposition 1 of
       [AkhiezerGlazman] p. 80. $)
    adjlnop $p |- ( T e. dom adjh -> ( adjh ` T ) e. LinOp ) $=
      cT cado cdm wcel chil chil cT cado cfv wf vx cv vy cv csm co vz cv cva co
      cT cado cfv cfv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv
      cva co wceq vz chil wral vy chil wral vx cc wral wa cT cado cfv clo wcel
      cT cado cdm wcel chil chil cT cado cfv wf vx cv vy cv csm co vz cv cva co
      cT cado cfv cfv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv
      cva co wceq vz chil wral vy chil wral vx cc wral cT cado cdm wcel cT cado
      cfv cado cdm wcel chil chil cT cado cfv wf cT dmadjrn cT cado cfv dmadjop
      syl cT cado cdm wcel vx cv vy cv csm co vz cv cva co cT cado cfv cfv vx
      cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co wceq vz chil
      wral vx vy cc chil cT cado cdm wcel vx cv cc wcel vy cv chil wcel wa vx
      cv vy cv csm co vz cv cva co cT cado cfv cfv vx cv vy cv cT cado cfv cfv
      csm co vz cv cT cado cfv cfv cva co wceq vz chil cT cado cdm wcel vx cv
      cc wcel vy cv chil wcel wa vz cv chil wcel vx cv vy cv csm co vz cv cva
      co cT cado cfv cfv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv
      cfv cva co wceq cT cado cdm wcel vx cv cc wcel vy cv chil wcel wa vz cv
      chil wcel wa wa vw cv vx cv vy cv csm co vz cv cva co cT cado cfv cfv csp
      co vw cv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co
      csp co wceq vw chil wral vx cv vy cv csm co vz cv cva co cT cado cfv cfv
      vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co wceq cT
      cado cdm wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa wa vw
      cv vx cv vy cv csm co vz cv cva co cT cado cfv cfv csp co vw cv vx cv vy
      cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co csp co wceq vw
      chil cT cado cdm wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa
      vw cv chil wcel vw cv vx cv vy cv csm co vz cv cva co cT cado cfv cfv csp
      co vw cv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co
      csp co wceq cT cado cdm wcel vw cv chil wcel vx cv cc wcel vy cv chil
      wcel wa vz cv chil wcel wa vw cv vx cv vy cv csm co vz cv cva co cT cado
      cfv cfv csp co vw cv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv
      cfv cva co csp co wceq cT cado cdm wcel vw cv chil wcel vx cv cc wcel vy
      cv chil wcel wa vz cv chil wcel wa w3a vw cv cT cfv vx cv vy cv csm co vz
      cv cva co csp co vw cv cT cfv vx cv vy cv csm co csp co vw cv cT cfv vz
      cv csp co caddc co vw cv vx cv vy cv csm co vz cv cva co cT cado cfv cfv
      csp co vw cv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva
      co csp co vw cv cT cfv chil wcel vx cv vy cv csm co chil wcel vz cv chil
      wcel vw cv cT cfv vx cv vy cv csm co vz cv cva co csp co vw cv cT cfv vx
      cv vy cv csm co csp co vw cv cT cfv vz cv csp co caddc co wceq cT cado
      cdm wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel
      wa w3a vw cv cT cfv vx cv vy cv csm co vz cv his7 cT cado cdm wcel vw cv
      chil wcel vw cv cT cfv chil wcel vx cv cc wcel vy cv chil wcel wa vz cv
      chil wcel wa chil chil cT wf vw cv chil wcel vw cv cT cfv chil wcel cT
      cado cdm wcel chil chil vw cv cT ffvelrn cT dmadjop sylan 3adant3 vx cv
      cc wcel vy cv chil wcel wa vz cv chil wcel wa cT cado cdm wcel vx cv vy
      cv csm co chil wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa vx
      cv vy cv csm co chil wcel vz cv chil wcel vx cv vy cv hvmulcl adantr
      3ad2ant3 vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa cT cado cdm
      wcel vz cv chil wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa vz
      cv chil wcel pm3.27 3ad2ant3 syl3anc cT cado cdm wcel vw cv chil wcel vx
      cv vy cv csm co vz cv cva co chil wcel vw cv cT cfv vx cv vy cv csm co vz
      cv cva co csp co vw cv vx cv vy cv csm co vz cv cva co cT cado cfv cfv
      csp co wceq vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa vw cv vx
      cv vy cv csm co vz cv cva co cT adj2 vx cv vy cv csm co chil wcel vz cv
      chil wcel vx cv vy cv csm co vz cv cva co chil wcel vx cv cc wcel vy cv
      chil wcel wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl sylan
      syl3an3 cT cado cdm wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa
      vz cv chil wcel wa w3a vw cv cT cfv vx cv vy cv csm co csp co vw cv cT
      cfv vz cv csp co caddc co vw cv vx cv vy cv cT cado cfv cfv csm co csp co
      vw cv vz cv cT cado cfv cfv csp co caddc co vw cv vx cv vy cv cT cado cfv
      cfv csm co vz cv cT cado cfv cfv cva co csp co cT cado cdm wcel vw cv
      chil wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa w3a vw cv
      cT cfv vx cv vy cv csm co csp co vw cv vx cv vy cv cT cado cfv cfv csm co
      csp co vw cv cT cfv vz cv csp co vw cv vz cv cT cado cfv cfv csp co caddc
      cT cado cdm wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa vw cv
      cT cfv vx cv vy cv csm co csp co vw cv vx cv vy cv cT cado cfv cfv csm co
      csp co wceq vz cv chil wcel cT cado cdm wcel vw cv chil wcel vx cv cc
      wcel vy cv chil wcel wa w3a vx cv ccj cfv vw cv cT cfv vy cv csp co cmul
      co vx cv ccj cfv vw cv vy cv cT cado cfv cfv csp co cmul co vw cv cT cfv
      vx cv vy cv csm co csp co vw cv vx cv vy cv cT cado cfv cfv csm co csp co
      cT cado cdm wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa w3a vw
      cv cT cfv vy cv csp co vw cv vy cv cT cado cfv cfv csp co vx cv ccj cfv
      cmul cT cado cdm wcel vw cv chil wcel vy cv chil wcel vw cv cT cfv vy cv
      csp co vw cv vy cv cT cado cfv cfv csp co wceq vx cv cc wcel vw cv vy cv
      cT adj2 3adant3l opreq2d vx cv cc wcel vw cv cT cfv chil wcel vy cv chil
      wcel vw cv cT cfv vx cv vy cv csm co csp co vx cv ccj cfv vw cv cT cfv vy
      cv csp co cmul co wceq cT cado cdm wcel vw cv chil wcel vx cv cc wcel vy
      cv chil wcel wa w3a vx cv vw cv cT cfv vy cv his5 vx cv cc wcel vy cv
      chil wcel wa cT cado cdm wcel vx cv cc wcel vw cv chil wcel vx cv cc wcel
      vy cv chil wcel pm3.26 3ad2ant3 cT cado cdm wcel vw cv chil wcel vw cv cT
      cfv chil wcel vx cv cc wcel vy cv chil wcel wa chil chil cT wf vw cv chil
      wcel vw cv cT cfv chil wcel cT cado cdm wcel chil chil vw cv cT ffvelrn
      cT dmadjop sylan 3adant3 vx cv cc wcel vy cv chil wcel wa cT cado cdm
      wcel vy cv chil wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel pm3.27
      3ad2ant3 syl3anc vx cv cc wcel vw cv chil wcel vy cv cT cado cfv cfv chil
      wcel vw cv vx cv vy cv cT cado cfv cfv csm co csp co vx cv ccj cfv vw cv
      vy cv cT cado cfv cfv csp co cmul co wceq cT cado cdm wcel vw cv chil
      wcel vx cv cc wcel vy cv chil wcel wa w3a vx cv vw cv vy cv cT cado cfv
      cfv his5 vx cv cc wcel vy cv chil wcel wa cT cado cdm wcel vx cv cc wcel
      vw cv chil wcel vx cv cc wcel vy cv chil wcel pm3.26 3ad2ant3 cT cado cdm
      wcel vw cv chil wcel vx cv cc wcel vy cv chil wcel wa 3simp2 cT cado cdm
      wcel vx cv cc wcel vy cv chil wcel wa vy cv cT cado cfv cfv chil wcel vw
      cv chil wcel cT cado cdm wcel vy cv chil wcel vy cv cT cado cfv cfv chil
      wcel vx cv cc wcel vy cv cT adjcl adantrl 3adant2 syl3anc 3eqtr4d
      3adant3r cT cado cdm wcel vw cv chil wcel vz cv chil wcel vw cv cT cfv vz
      cv csp co vw cv vz cv cT cado cfv cfv csp co wceq vx cv cc wcel vy cv
      chil wcel wa vw cv vz cv cT adj2 3adant3l opreq12d vw cv chil wcel vx cv
      vy cv cT cado cfv cfv csm co chil wcel vz cv cT cado cfv cfv chil wcel vw
      cv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co csp co
      vw cv vx cv vy cv cT cado cfv cfv csm co csp co vw cv vz cv cT cado cfv
      cfv csp co caddc co wceq cT cado cdm wcel vw cv chil wcel vx cv cc wcel
      vy cv chil wcel wa vz cv chil wcel wa w3a vw cv vx cv vy cv cT cado cfv
      cfv csm co vz cv cT cado cfv cfv his7 cT cado cdm wcel vw cv chil wcel vx
      cv cc wcel vy cv chil wcel wa vz cv chil wcel wa 3simp2 cT cado cdm wcel
      vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv cT cado
      cfv cfv csm co chil wcel vw cv chil wcel cT cado cdm wcel vx cv cc wcel
      vy cv chil wcel wa vx cv vy cv cT cado cfv cfv csm co chil wcel vz cv
      chil wcel vx cv cc wcel cT cado cdm wcel vy cv chil wcel vx cv vy cv cT
      cado cfv cfv csm co chil wcel vx cv cc wcel vy cv cT cado cfv cfv chil
      wcel vx cv vy cv cT cado cfv cfv csm co chil wcel cT cado cdm wcel vy cv
      chil wcel wa vx cv vy cv cT cado cfv cfv hvmulcl vy cv cT adjcl sylan2
      an1s adantrr 3adant2 cT cado cdm wcel vx cv cc wcel vy cv chil wcel wa vz
      cv chil wcel wa vz cv cT cado cfv cfv chil wcel vw cv chil wcel cT cado
      cdm wcel vz cv chil wcel vz cv cT cado cfv cfv chil wcel vx cv cc wcel vy
      cv chil wcel wa vz cv cT adjcl adantrl 3adant2 syl3anc eqtr4d 3eqtr3d
      3com23 3expa r19.21aiva vx cv vy cv csm co vz cv cva co cT cado cfv cfv
      chil wcel vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co
      chil wcel vw cv vx cv vy cv csm co vz cv cva co cT cado cfv cfv csp co vw
      cv vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co csp co
      wceq vw chil wral vx cv vy cv csm co vz cv cva co cT cado cfv cfv vx cv
      vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co wceq wb cT cado
      cdm wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa wa vw vx cv
      vy cv csm co vz cv cva co cT cado cfv cfv vx cv vy cv cT cado cfv cfv csm
      co vz cv cT cado cfv cfv cva co hial2eq2 cT cado cdm wcel vx cv vy cv csm
      co vz cv cva co chil wcel vx cv vy cv csm co vz cv cva co cT cado cfv cfv
      chil wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel wa vx cv vy cv
      csm co vz cv cva co cT adjcl vx cv vy cv csm co chil wcel vz cv chil wcel
      vx cv vy cv csm co vz cv cva co chil wcel vx cv cc wcel vy cv chil wcel
      wa vx cv vy cv csm co vz cv hvaddcl vx cv vy cv hvmulcl sylan sylan2 cT
      cado cdm wcel vx cv cc wcel vy cv chil wcel wa vz cv chil wcel vx cv vy
      cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co chil wcel vx cv vy
      cv cT cado cfv cfv csm co chil wcel vz cv cT cado cfv cfv chil wcel vx cv
      vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv cva co chil wcel cT
      cado cdm wcel vx cv cc wcel vy cv chil wcel wa wa cT cado cdm wcel vz cv
      chil wcel wa vx cv vy cv cT cado cfv cfv csm co vz cv cT cado cfv cfv
      hvaddcl vx cv cc wcel cT cado cdm wcel vy cv chil wcel vx cv vy cv cT
      cado cfv cfv csm co chil wcel vx cv cc wcel vy cv cT cado cfv cfv chil
      wcel vx cv vy cv cT cado cfv cfv csm co chil wcel cT cado cdm wcel vy cv
      chil wcel wa vx cv vy cv cT cado cfv cfv hvmulcl vy cv cT adjcl sylan2
      an1s vz cv cT adjcl syl2an anandis sylanc mpbid exp32 r19.21adv
      r19.21aivv jca vx vy vz cT cado cfv ellnop sylibr $.
      $( [28-Jun-2006] $) $( [17-Jun-2006] $)

    $( Every operator with an adjoint is linear. $)
    adjsslnop $p |- dom adjh C_ LinOp $=
      vt cado cdm clo vt cv cado cdm wcel vt cv cado cfv cado cfv vt cv clo vt
      cv adjadj vt cv cado cdm wcel vt cv cado cfv cado cdm wcel vt cv cado cfv
      cado cfv clo wcel vt cv dmadjrn vt cv cado cfv adjlnop syl eqeltrrd ssriv
      $.
      $( [11-Nov-2006] $) $( [17-Jun-2006] $)
  $}

  ${
    $d f g h u v w z A $.  $d f g h t u v w x y z T $.
    nmopadjle.1 $e |- T e. BndLinOp $.
    $( Property of the norm of an adjoint.  Part of proof of Theorem 3.10 of
       [Beran] p. 104. $)
    nmopadjlei $p |- ( A e. ~H -> ( normh ` ( ( adjh ` T ) ` A ) ) <_
                        ( ( normop ` T ) x. ( normh ` A ) ) ) $=
      cA chil wcel cA cT cado cfv cfv cno cfv cA vz cv chil wcel vu cv vv cv cT
      cfv vz cv csp co vv cv vf cv csp co wceq vv chil wral vf chil crab cuni
      wceq wa vz vu copab cfv cno cfv cT cnop cfv cA cno cfv cmul co cle cA
      chil wcel cA cT cado cfv cfv cA vz cv chil wcel vu cv vv cv cT cfv vz cv
      csp co vv cv vf cv csp co wceq vv chil wral vf chil crab cuni wceq wa vz
      vu copab cfv cno cA chil wcel cA cT cado cfv cfv vv cv cT cfv cA csp co
      vv cv vf cv csp co wceq vv chil wral vf chil crab cuni cA vz cv chil wcel
      vu cv vv cv cT cfv vz cv csp co vv cv vf cv csp co wceq vv chil wral vf
      chil crab cuni wceq wa vz vu copab cfv cT cado cdm wcel cA chil wcel cA
      cT cado cfv cfv vv cv cT cfv cA csp co vv cv vf cv csp co wceq vv chil
      wral vf chil crab cuni wceq cbo cado cdm cT bdopssadj nmopadjle.1 sselii
      vv vf cA cT adjvalval mpan vz vu cA vv cv cT cfv vz cv csp co vv cv vf cv
      csp co wceq vv chil wral vf chil crab cuni vv cv cT cfv cA csp co vv cv
      vf cv csp co wceq vv chil wral vf chil crab cuni chil vz cv chil wcel vu
      cv vv cv cT cfv vz cv csp co vv cv vf cv csp co wceq vv chil wral vf chil
      crab cuni wceq wa vz vu copab vz cv cA wceq vv cv cT cfv vz cv csp co vv
      cv vf cv csp co wceq vv chil wral vf chil crab vv cv cT cfv cA csp co vv
      cv vf cv csp co wceq vv chil wral vf chil crab vz cv cA wceq vv cv cT cfv
      vz cv csp co vv cv vf cv csp co wceq vv chil wral vv cv cT cfv cA csp co
      vv cv vf cv csp co wceq vv chil wral vf chil vz cv cA wceq vv cv cT cfv
      vz cv csp co vv cv vf cv csp co wceq vv cv cT cfv cA csp co vv cv vf cv
      csp co wceq vv chil vz cv cA wceq vv cv cT cfv vz cv csp co vv cv cT cfv
      cA csp co vv cv vf cv csp co vz cv cA vv cv cT cfv csp opreq2 eqeq1d
      ralbidv rabbisdv unieqd vz cv chil wcel vu cv vv cv cT cfv vz cv csp co
      vv cv vf cv csp co wceq vv chil wral vf chil crab cuni wceq wa vz vu
      copab eqid vv cv cT cfv cA csp co vv cv vf cv csp co wceq vv chil wral vf
      chil crab vv cv cT cfv cA csp co vv cv vf cv csp co wceq vv chil wral vf
      chil ax-hilex rabex uniex fvopab4 eqtr4d fveq2d vz vw vv vu cA vv cv cT
      cfv vz cv csp co vv cv vf cv csp co wceq vv chil wral vf chil crab cuni
      cT vg vh vz cv chil wcel vu cv vv cv cT cfv vz cv csp co vv cv vf cv csp
      co wceq vv chil wral vf chil crab cuni wceq wa vz vu copab vg cv chil
      wcel vh cv vg cv cT cfv vz cv csp co wceq wa vg vh copab clo cco cin clo
      cT clo cco inss1 cT cbo clo cco cin nmopadjle.1 lncnbd eleqtrri sselii
      clo cco cin cco cT clo cco inss2 cT cbo clo cco cin nmopadjle.1 lncnbd
      eleqtrri sselii vg cv chil wcel vh cv vg cv cT cfv vz cv csp co wceq wa
      vg vh copab eqid vv cv cT cfv vz cv csp co vv cv vf cv csp co wceq vv
      chil wral vf chil crab vv cv cT cfv vz cv csp co vv cv vw cv csp co wceq
      vv chil wral vw chil crab vv cv cT cfv vz cv csp co vv cv vf cv csp co
      wceq vv chil wral vv cv cT cfv vz cv csp co vv cv vw cv csp co wceq vv
      chil wral vf vw chil vf cv vw cv wceq vv cv cT cfv vz cv csp co vv cv vf
      cv csp co wceq vv cv cT cfv vz cv csp co vv cv vw cv csp co wceq vv chil
      vf cv vw cv wceq vv cv vf cv csp co vv cv vw cv csp co vv cv cT cfv vz cv
      csp co vf cv vw cv vv cv csp opreq2 eqeq2d ralbidv cbvrabv unieqi vz cv
      chil wcel vu cv vv cv cT cfv vz cv csp co vv cv vf cv csp co wceq vv chil
      wral vf chil crab cuni wceq wa vz vu copab eqid cnlnadjlem7 eqbrtrd $.
      $( [6-Jun-2006] $) $( [22-Feb-2006] $)

    $( Lemma for ~ nmopadji . $)
    nmopadjlem $p |- ( normop ` ( adjh ` T ) ) <_ ( normop ` T ) $=
      chil chil cT cado cfv wf cT cnop cfv cxr wcel vy cv cno cfv c1 cle wbr vy
      cv cT cado cfv cfv cno cfv cT cnop cfv cle wbr wi vy chil wral cT cado
      cfv cnop cfv cT cnop cfv cle wbr cT cado cfv cbo wcel chil chil cT cado
      cfv wf cT cbo wcel cT cado cfv cbo wcel nmopadjle.1 cT adjbdln ax-mp cT
      cado cfv bdopf ax-mp chil chil cT wf cT cnop cfv cxr wcel cT cbo wcel
      chil chil cT wf nmopadjle.1 cT bdopf ax-mp cT nmopxr ax-mp vy cv cno cfv
      c1 cle wbr vy cv cT cado cfv cfv cno cfv cT cnop cfv cle wbr wi vy chil
      vy cv chil wcel vy cv cno cfv c1 cle wbr vy cv cT cado cfv cfv cno cfv cT
      cnop cfv cle wbr vy cv chil wcel vy cv cno cfv c1 cle wbr wa vy cv cT
      cado cfv cfv cno cfv cT cnop cfv c1 cmul co cT cnop cfv cle vy cv chil
      wcel vy cv cno cfv c1 cle wbr wa vy cv cT cado cfv cfv cno cfv cT cnop
      cfv vy cv cno cfv cmul co cT cnop cfv c1 cmul co vy cv chil wcel vy cv cT
      cado cfv cfv cno cfv cr wcel vy cv cno cfv c1 cle wbr vy cv chil wcel vy
      cv cT cado cfv cfv chil wcel vy cv cT cado cfv cfv cno cfv cr wcel chil
      chil vy cv cT cado cfv cT cado cfv cbo wcel chil chil cT cado cfv wf cT
      cbo wcel cT cado cfv cbo wcel nmopadjle.1 cT adjbdln ax-mp cT cado cfv
      bdopf ax-mp ffvelrni vy cv cT cado cfv cfv normcl syl adantr vy cv chil
      wcel cT cnop cfv vy cv cno cfv cmul co cr wcel vy cv cno cfv c1 cle wbr
      vy cv chil wcel vy cv cno cfv cr wcel cT cnop cfv vy cv cno cfv cmul co
      cr wcel vy cv normcl cT cnop cfv cr wcel vy cv cno cfv cr wcel cT cnop
      cfv vy cv cno cfv cmul co cr wcel cT cbo wcel cT cnop cfv cr wcel
      nmopadjle.1 cT nmopre ax-mp cT cnop cfv vy cv cno cfv remulcl mpan syl
      adantr cT cnop cfv c1 cmul co cr wcel vy cv chil wcel vy cv cno cfv c1
      cle wbr wa cT cnop cfv c1 cT cbo wcel cT cnop cfv cr wcel nmopadjle.1 cT
      nmopre ax-mp 1re remulcli a1i vy cv chil wcel vy cv cT cado cfv cfv cno
      cfv cT cnop cfv vy cv cno cfv cmul co cle wbr vy cv cno cfv c1 cle wbr vy
      cv cT nmopadjle.1 nmopadjlei adantr vy cv cno cfv cr wcel c1 cr wcel cT
      cnop cfv cr wcel w3a cc0 cT cnop cfv cle wbr vy cv cno cfv c1 cle wbr wa
      cT cnop cfv vy cv cno cfv cmul co cT cnop cfv c1 cmul co cle wbr vy cv
      chil wcel vy cv cno cfv c1 cle wbr wa vy cv cno cfv c1 cT cnop cfv
      lemul2aOLD vy cv chil wcel vy cv cno cfv c1 cle wbr wa vy cv cno cfv cr
      wcel c1 cr wcel cT cnop cfv cr wcel vy cv chil wcel vy cv cno cfv cr wcel
      vy cv cno cfv c1 cle wbr vy cv normcl adantr c1 cr wcel vy cv chil wcel
      vy cv cno cfv c1 cle wbr wa 1re a1i cT cnop cfv cr wcel vy cv chil wcel
      vy cv cno cfv c1 cle wbr wa cT cbo wcel cT cnop cfv cr wcel nmopadjle.1
      cT nmopre ax-mp a1i 3jca vy cv chil wcel vy cv cno cfv c1 cle wbr wa vy
      cv cno cfv c1 cle wbr cc0 cT cnop cfv cle wbr vy cv chil wcel vy cv cno
      cfv c1 cle wbr pm3.27 chil chil cT wf cc0 cT cnop cfv cle wbr cT cbo wcel
      chil chil cT wf nmopadjle.1 cT bdopf ax-mp cT nmopge0 ax-mp jctil sylanc
      letrd cT cnop cfv cT cnop cfv cT cbo wcel cT cnop cfv cr wcel nmopadjle.1
      cT nmopre ax-mp recni mulid1i syl6breq ex rgen vy cT cnop cfv cT cado cfv
      nmopub mp3an $.
      $( [22-Feb-2006] $) $( [22-Feb-2006] $)

    $( Property of the norm of an adjoint.  Theorem 3.11(v) of [Beran]
       p. 106. $)
    nmopadji $p |- ( normop ` ( adjh ` T ) ) = ( normop ` T ) $=
      cT cado cfv cnop cfv cT cnop cfv wceq cT cado cfv cnop cfv cT cnop cfv
      cle wbr cT cnop cfv cT cado cfv cnop cfv cle wbr cT cado cfv cnop cfv cT
      cnop cfv cT cado cfv cbo wcel cT cado cfv cnop cfv cr wcel cT cbo wcel cT
      cado cfv cbo wcel nmopadjle.1 cT adjbdln ax-mp cT cado cfv nmopre ax-mp
      cT cbo wcel cT cnop cfv cr wcel nmopadjle.1 cT nmopre ax-mp letri3i cT
      nmopadjle.1 nmopadjlem cT cado cfv cado cfv cnop cfv cT cnop cfv cT cado
      cfv cnop cfv cle cT cado cfv cado cfv cT cnop cT cado cdm wcel cT cado
      cfv cado cfv cT wceq cT cbo wcel cT cado cdm wcel nmopadjle.1 cT bdopadj
      ax-mp cT adjadj ax-mp fveq2i cT cado cfv cT cbo wcel cT cado cfv cbo wcel
      nmopadjle.1 cT adjbdln ax-mp nmopadjlem eqbrtrri mpbir2an $.
      $( [11-Jun-2006] $) $( [22-Feb-2006] $)
  $}

  $( An operator is zero iff its adjoint is zero.  Theorem 3.11(i) of [Beran]
     p. 106. $)
  adjeq0 $p |- ( T = 0hop <-> ( adjh ` T ) = 0hop ) $=
    cT ch0o wceq cT cado cfv ch0o wceq cT ch0o wceq cT cado cfv ch0o cado cfv
    ch0o cT ch0o cado fveq2 adj0 syl6eq cT cado cfv ch0o wceq cT cado cfv cado
    cfv ch0o cado cfv cT ch0o cT cado cfv ch0o cado fveq2 cT cado cfv ch0o wceq
    cT cado cdm wcel cT cado cfv cado cfv cT wceq cT cado cfv ch0o wceq cT cado
    cfv cado cdm wcel cT cado cdm wcel cT cado cfv ch0o wceq cT cado cfv cado
    cdm wcel ch0o cado cdm wcel cbo cado cdm ch0o bdopssadj 0bdop sselii cT
    cado cfv ch0o cado cdm eleq1 mpbiri cT dmadjrnb sylibr cT adjadj syl ch0o
    cado cfv ch0o wceq cT cado cfv ch0o wceq adj0 a1i 3eqtr3d impbii $.
    $( [30-Jun-2008] $) $( [20-Feb-2006] $)

  ${
    $d x y A $.  $d x y T $.
    $( The adjoint of the scalar product of an operator.  Theorem 3.11(ii) of
       [Beran] p. 106. $)
    adjmul $p |- ( ( A e. CC /\ T e. dom adjh ) ->
                 ( adjh ` ( A .op T ) ) = ( ( * ` A ) .op ( adjh ` T ) ) ) $=
      chil chil cA cT chot co wf chil chil cA ccj cfv cT cado cfv chot co wf vx
      cv cA cT chot co cfv vy cv csp co vx cv vy cv cA ccj cfv cT cado cfv chot
      co cfv csp co wceq vy chil wral vx chil wral cA cT chot co cado cfv cA
      ccj cfv cT cado cfv chot co wceq cA cc wcel cT cado cdm wcel wa vx vy cA
      ccj cfv cT cado cfv chot co cA cT chot co adjeq cA cc wcel chil chil cT
      wf chil chil cA cT chot co wf cT cado cdm wcel cA cT homulcl cT dmadjop
      sylan2 cA ccj cfv cc wcel chil chil cT cado cfv wf chil chil cA ccj cfv
      cT cado cfv chot co wf cA cc wcel cT cado cdm wcel cA ccj cfv cT cado cfv
      homulcl cA cjcl cT cado cdm wcel cT cado cfv cado cdm wcel chil chil cT
      cado cfv wf cT dmadjrn cT cado cfv dmadjop syl syl2an cA cc wcel cT cado
      cdm wcel wa vx cv cA cT chot co cfv vy cv csp co vx cv vy cv cA ccj cfv
      cT cado cfv chot co cfv csp co wceq vx vy chil chil cA cc wcel cT cado
      cdm wcel wa vx cv chil wcel vy cv chil wcel wa vx cv cA cT chot co cfv vy
      cv csp co vx cv vy cv cA ccj cfv cT cado cfv chot co cfv csp co wceq cA
      cc wcel cT cado cdm wcel wa vx cv chil wcel vy cv chil wcel wa wa cA vx
      cv cT cfv csm co vy cv csp co vx cv cA ccj cfv vy cv cT cado cfv cfv csm
      co csp co vx cv cA cT chot co cfv vy cv csp co vx cv vy cv cA ccj cfv cT
      cado cfv chot co cfv csp co cA cc wcel cT cado cdm wcel wa vx cv chil
      wcel vy cv chil wcel wa wa cA vx cv cT cfv vy cv csp co cmul co cA vx cv
      vy cv cT cado cfv cfv csp co cmul co cA vx cv cT cfv csm co vy cv csp co
      vx cv cA ccj cfv vy cv cT cado cfv cfv csm co csp co cA cc wcel cT cado
      cdm wcel wa vx cv chil wcel vy cv chil wcel wa wa vx cv cT cfv vy cv csp
      co vx cv vy cv cT cado cfv cfv csp co cA cmul cT cado cdm wcel vx cv chil
      wcel vy cv chil wcel wa vx cv cT cfv vy cv csp co vx cv vy cv cT cado cfv
      cfv csp co wceq cA cc wcel cT cado cdm wcel vx cv chil wcel vy cv chil
      wcel vx cv cT cfv vy cv csp co vx cv vy cv cT cado cfv cfv csp co wceq vx
      cv vy cv cT adj2 3expb adantll opreq2d cA cc wcel cT cado cdm wcel vx cv
      chil wcel vy cv chil wcel cA vx cv cT cfv csm co vy cv csp co cA vx cv cT
      cfv vy cv csp co cmul co wceq cA cc wcel cT cado cdm wcel vx cv chil wcel
      vy cv chil wcel cA vx cv cT cfv csm co vy cv csp co cA vx cv cT cfv vy cv
      csp co cmul co wceq wi cA cc wcel cT cado cdm wcel vx cv chil wcel wa vy
      cv chil wcel cA vx cv cT cfv csm co vy cv csp co cA vx cv cT cfv vy cv
      csp co cmul co wceq cA cc wcel vx cv cT cfv chil wcel vy cv chil wcel cA
      vx cv cT cfv csm co vy cv csp co cA vx cv cT cfv vy cv csp co cmul co
      wceq cT cado cdm wcel vx cv chil wcel wa cA vx cv cT cfv vy cv ax-his3
      chil chil cT wf vx cv chil wcel vx cv cT cfv chil wcel cT cado cdm wcel
      chil chil vx cv cT ffvelrn cT dmadjop sylan syl3an2 3exp exp3a imp43 cA
      cc wcel vx cv chil wcel vy cv cT cado cfv cfv chil wcel vx cv cA ccj cfv
      vy cv cT cado cfv cfv csm co csp co cA vx cv vy cv cT cado cfv cfv csp co
      cmul co wceq cA cc wcel cT cado cdm wcel wa vx cv chil wcel vy cv chil
      wcel wa wa cA vx cv vy cv cT cado cfv cfv his52 cA cc wcel cT cado cdm
      wcel vx cv chil wcel vy cv chil wcel wa simpll cA cc wcel cT cado cdm
      wcel wa vx cv chil wcel vy cv chil wcel simprl cT cado cdm wcel vy cv
      chil wcel vy cv cT cado cfv cfv chil wcel cA cc wcel vx cv chil wcel vy
      cv cT adjcl ad2ant2l syl3anc 3eqtr4d cA cc wcel cT cado cdm wcel wa vx cv
      chil wcel vy cv chil wcel wa wa vx cv cA cT chot co cfv cA vx cv cT cfv
      csm co vy cv csp cA cc wcel cT cado cdm wcel wa vx cv chil wcel vx cv cA
      cT chot co cfv cA vx cv cT cfv csm co wceq vy cv chil wcel cA cc wcel cT
      cado cdm wcel vx cv chil wcel vx cv cA cT chot co cfv cA vx cv cT cfv csm
      co wceq cA cc wcel chil chil cT wf vx cv chil wcel vx cv cA cT chot co
      cfv cA vx cv cT cfv csm co wceq cT cado cdm wcel cA vx cv cT homval cT
      dmadjop syl3an2 3expa adantrr opreq1d cA cc wcel cT cado cdm wcel wa vx
      cv chil wcel vy cv chil wcel wa wa vy cv cA ccj cfv cT cado cfv chot co
      cfv cA ccj cfv vy cv cT cado cfv cfv csm co vx cv csp cA cc wcel cT cado
      cdm wcel wa vy cv chil wcel vy cv cA ccj cfv cT cado cfv chot co cfv cA
      ccj cfv vy cv cT cado cfv cfv csm co wceq vx cv chil wcel cA cc wcel cT
      cado cdm wcel vy cv chil wcel vy cv cA ccj cfv cT cado cfv chot co cfv cA
      ccj cfv vy cv cT cado cfv cfv csm co wceq cA ccj cfv cc wcel chil chil cT
      cado cfv wf vy cv chil wcel vy cv cA ccj cfv cT cado cfv chot co cfv cA
      ccj cfv vy cv cT cado cfv cfv csm co wceq cA cc wcel cT cado cdm wcel vy
      cv chil wcel cA ccj cfv vy cv cT cado cfv homval cA cjcl cT cado cdm wcel
      cT cado cfv cado cdm wcel chil chil cT cado cfv wf cT dmadjrn cT cado cfv
      dmadjop syl vy cv chil wcel id syl3an 3expa adantrl opreq2d 3eqtr4d ex
      r19.21aivv syl3anc $.
      $( [5-Nov-2006] $) $( [21-Feb-2006] $)
  $}

  ${
    $d x y S $.  $d x y T $.
    $( The adjoint of the sum of two operators.  Theorem 3.11(iii) of [Beran]
       p. 106. $)
    adjadd $p |- ( ( S e. dom adjh /\ T e. dom adjh ) ->
                ( adjh ` ( S +op T ) ) = ( ( adjh ` S ) +op ( adjh ` T ) ) ) $=
      chil chil cS cT chos co wf chil chil cS cado cfv cT cado cfv chos co wf
      vx cv cS cT chos co cfv vy cv csp co vx cv vy cv cS cado cfv cT cado cfv
      chos co cfv csp co wceq vy chil wral vx chil wral cS cT chos co cado cfv
      cS cado cfv cT cado cfv chos co wceq cS cado cdm wcel cT cado cdm wcel wa
      vx vy cS cado cfv cT cado cfv chos co cS cT chos co adjeq chil chil cS wf
      chil chil cT wf chil chil cS cT chos co wf cS cado cdm wcel cT cado cdm
      wcel cS cT hoaddcl cS dmadjop cT dmadjop syl2an chil chil cS cado cfv wf
      chil chil cT cado cfv wf chil chil cS cado cfv cT cado cfv chos co wf cS
      cado cdm wcel cT cado cdm wcel cS cado cfv cT cado cfv hoaddcl cS cado
      cdm wcel cS cado cfv cado cdm wcel chil chil cS cado cfv wf cS dmadjrn cS
      cado cfv dmadjop syl cT cado cdm wcel cT cado cfv cado cdm wcel chil chil
      cT cado cfv wf cT dmadjrn cT cado cfv dmadjop syl syl2an cS cado cdm wcel
      cT cado cdm wcel wa vx cv cS cT chos co cfv vy cv csp co vx cv vy cv cS
      cado cfv cT cado cfv chos co cfv csp co wceq vx vy chil chil cS cado cdm
      wcel cT cado cdm wcel wa vx cv chil wcel vy cv chil wcel wa vx cv cS cT
      chos co cfv vy cv csp co vx cv vy cv cS cado cfv cT cado cfv chos co cfv
      csp co wceq cS cado cdm wcel cT cado cdm wcel wa vx cv chil wcel vy cv
      chil wcel wa wa vx cv cS cT chos co cfv vy cv csp co vx cv vy cv cS cado
      cfv cfv vy cv cT cado cfv cfv cva co csp co vx cv vy cv cS cado cfv cT
      cado cfv chos co cfv csp co cS cado cdm wcel cT cado cdm wcel wa vx cv
      chil wcel vy cv chil wcel wa wa vx cv cS cfv vx cv cT cfv cva co vy cv
      csp co vx cv vy cv cS cado cfv cfv csp co vx cv vy cv cT cado cfv cfv csp
      co caddc co vx cv cS cT chos co cfv vy cv csp co vx cv vy cv cS cado cfv
      cfv vy cv cT cado cfv cfv cva co csp co cS cado cdm wcel cT cado cdm wcel
      wa vx cv chil wcel vy cv chil wcel wa wa vx cv cS cfv vx cv cT cfv cva co
      vy cv csp co vx cv cS cfv vy cv csp co vx cv cT cfv vy cv csp co caddc co
      vx cv vy cv cS cado cfv cfv csp co vx cv vy cv cT cado cfv cfv csp co
      caddc co vx cv cS cfv chil wcel vx cv cT cfv chil wcel vy cv chil wcel vx
      cv cS cfv vx cv cT cfv cva co vy cv csp co vx cv cS cfv vy cv csp co vx
      cv cT cfv vy cv csp co caddc co wceq cS cado cdm wcel cT cado cdm wcel wa
      vx cv chil wcel vy cv chil wcel wa wa vx cv cS cfv vx cv cT cfv vy cv
      ax-his2 cS cado cdm wcel vx cv chil wcel vx cv cS cfv chil wcel cT cado
      cdm wcel vy cv chil wcel chil chil cS wf vx cv chil wcel vx cv cS cfv
      chil wcel cS cado cdm wcel chil chil vx cv cS ffvelrn cS dmadjop sylan
      ad2ant2r cT cado cdm wcel vx cv chil wcel vx cv cT cfv chil wcel cS cado
      cdm wcel vy cv chil wcel chil chil cT wf vx cv chil wcel vx cv cT cfv
      chil wcel cT cado cdm wcel chil chil vx cv cT ffvelrn cT dmadjop sylan
      ad2ant2lr cS cado cdm wcel cT cado cdm wcel wa vx cv chil wcel vy cv chil
      wcel simprr syl3anc cS cado cdm wcel cT cado cdm wcel wa vx cv chil wcel
      vy cv chil wcel wa wa vx cv cS cfv vy cv csp co vx cv vy cv cS cado cfv
      cfv csp co vx cv cT cfv vy cv csp co vx cv vy cv cT cado cfv cfv csp co
      caddc cS cado cdm wcel vx cv chil wcel vy cv chil wcel wa vx cv cS cfv vy
      cv csp co vx cv vy cv cS cado cfv cfv csp co wceq cT cado cdm wcel cS
      cado cdm wcel vx cv chil wcel vy cv chil wcel vx cv cS cfv vy cv csp co
      vx cv vy cv cS cado cfv cfv csp co wceq vx cv vy cv cS adj2 3expb adantlr
      cT cado cdm wcel vx cv chil wcel vy cv chil wcel wa vx cv cT cfv vy cv
      csp co vx cv vy cv cT cado cfv cfv csp co wceq cS cado cdm wcel cT cado
      cdm wcel vx cv chil wcel vy cv chil wcel vx cv cT cfv vy cv csp co vx cv
      vy cv cT cado cfv cfv csp co wceq vx cv vy cv cT adj2 3expb adantll
      opreq12d eqtrd cS cado cdm wcel cT cado cdm wcel wa vx cv chil wcel vy cv
      chil wcel wa wa vx cv cS cT chos co cfv vx cv cS cfv vx cv cT cfv cva co
      vy cv csp cS cado cdm wcel cT cado cdm wcel wa vx cv chil wcel vx cv cS
      cT chos co cfv vx cv cS cfv vx cv cT cfv cva co wceq vy cv chil wcel chil
      chil cS wf chil chil cT wf wa vx cv chil wcel vx cv cS cT chos co cfv vx
      cv cS cfv vx cv cT cfv cva co wceq cS cado cdm wcel cT cado cdm wcel wa
      vx cv cS cT hosvalOLD cS cado cdm wcel chil chil cS wf cT cado cdm wcel
      chil chil cT wf cS dmadjop cT dmadjop anim12i sylan adantrr opreq1d vx cv
      chil wcel vy cv cS cado cfv cfv chil wcel vy cv cT cado cfv cfv chil wcel
      vx cv vy cv cS cado cfv cfv vy cv cT cado cfv cfv cva co csp co vx cv vy
      cv cS cado cfv cfv csp co vx cv vy cv cT cado cfv cfv csp co caddc co
      wceq cS cado cdm wcel cT cado cdm wcel wa vx cv chil wcel vy cv chil wcel
      wa wa vx cv vy cv cS cado cfv cfv vy cv cT cado cfv cfv his7 cS cado cdm
      wcel cT cado cdm wcel wa vx cv chil wcel vy cv chil wcel simprl cS cado
      cdm wcel vy cv chil wcel vy cv cS cado cfv cfv chil wcel cT cado cdm wcel
      vx cv chil wcel vy cv cS adjcl ad2ant2rl cT cado cdm wcel vy cv chil wcel
      vy cv cT cado cfv cfv chil wcel cS cado cdm wcel vx cv chil wcel vy cv cT
      adjcl ad2ant2l syl3anc 3eqtr4d cS cado cdm wcel cT cado cdm wcel wa vx cv
      chil wcel vy cv chil wcel wa wa vy cv cS cado cfv cT cado cfv chos co cfv
      vy cv cS cado cfv cfv vy cv cT cado cfv cfv cva co vx cv csp cS cado cdm
      wcel cT cado cdm wcel wa vy cv chil wcel vy cv cS cado cfv cT cado cfv
      chos co cfv vy cv cS cado cfv cfv vy cv cT cado cfv cfv cva co wceq vx cv
      chil wcel chil chil cS cado cfv wf chil chil cT cado cfv wf wa vy cv chil
      wcel vy cv cS cado cfv cT cado cfv chos co cfv vy cv cS cado cfv cfv vy
      cv cT cado cfv cfv cva co wceq cS cado cdm wcel cT cado cdm wcel wa vy cv
      cS cado cfv cT cado cfv hosvalOLD cS cado cdm wcel chil chil cS cado cfv
      wf cT cado cdm wcel chil chil cT cado cfv wf cS cado cdm wcel cS cado cfv
      cado cdm wcel chil chil cS cado cfv wf cS dmadjrn cS cado cfv dmadjop syl
      cT cado cdm wcel cT cado cfv cado cdm wcel chil chil cT cado cfv wf cT
      dmadjrn cT cado cfv dmadjop syl anim12i sylan adantrl opreq2d eqtr4d ex
      r19.21aivv syl3anc $.
      $( [15-Feb-2006] $) $( [22-Feb-2006] $)
  $}

  ${
    $d x y z S $.  $d x y z T $.
    nmoptri.1 $e |- S e. BndLinOp $.
    nmoptri.2 $e |- T e. BndLinOp $.
    $( Triangle inequality for the norms of bounded linear operators. $)
    nmoptrii $p |- ( normop ` ( S +op T ) ) <_
                  ( ( normop ` S ) + ( normop ` T ) ) $=
      chil chil cS cT chos co wf cS cnop cfv cT cnop cfv caddc co cxr wcel vx
      cv cno cfv c1 cle wbr vx cv cS cT chos co cfv cno cfv cS cnop cfv cT cnop
      cfv caddc co cle wbr wi vx chil wral cS cT chos co cnop cfv cS cnop cfv
      cT cnop cfv caddc co cle wbr cS cT cS cbo wcel chil chil cS wf nmoptri.1
      cS bdopf ax-mp cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp
      hoaddcli cS cnop cfv cT cnop cfv caddc co cr wcel cS cnop cfv cT cnop cfv
      caddc co cxr wcel cS cnop cfv cT cnop cfv cS cbo wcel cS cnop cfv cr wcel
      nmoptri.1 cS nmopre ax-mp cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT
      nmopre ax-mp readdcli cS cnop cfv cT cnop cfv caddc co rexr ax-mp vx cv
      cno cfv c1 cle wbr vx cv cS cT chos co cfv cno cfv cS cnop cfv cT cnop
      cfv caddc co cle wbr wi vx chil vx cv chil wcel vx cv cno cfv c1 cle wbr
      vx cv cS cT chos co cfv cno cfv cS cnop cfv cT cnop cfv caddc co cle wbr
      vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cS cT chos co cfv cno
      cfv vx cv cS cfv cno cfv vx cv cT cfv cno cfv caddc co cS cnop cfv cT
      cnop cfv caddc co vx cv chil wcel vx cv cS cT chos co cfv cno cfv cr wcel
      vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv cS cT chos co cfv chil
      wcel vx cv cS cT chos co cfv cno cfv cr wcel vx cv cS cT cS cbo wcel chil
      chil cS wf nmoptri.1 cS bdopf ax-mp cT cbo wcel chil chil cT wf nmoptri.2
      cT bdopf ax-mp hoscli vx cv cS cT chos co cfv normcl syl adantr vx cv
      chil wcel vx cv cS cfv cno cfv vx cv cT cfv cno cfv caddc co cr wcel vx
      cv cno cfv c1 cle wbr vx cv cS cfv cno cfv cr wcel vx cv cT cfv cno cfv
      cr wcel vx cv cS cfv cno cfv vx cv cT cfv cno cfv caddc co cr wcel vx cv
      chil wcel vx cv cS cfv cno cfv vx cv cT cfv cno cfv readdcl vx cv chil
      wcel vx cv cS cfv chil wcel vx cv cS cfv cno cfv cr wcel chil chil vx cv
      cS cS cbo wcel chil chil cS wf nmoptri.1 cS bdopf ax-mp ffvelrni vx cv cS
      cfv normcl syl vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno
      cfv cr wcel chil chil vx cv cT cT cbo wcel chil chil cT wf nmoptri.2 cT
      bdopf ax-mp ffvelrni vx cv cT cfv normcl syl sylanc adantr cS cnop cfv cT
      cnop cfv caddc co cr wcel vx cv chil wcel vx cv cno cfv c1 cle wbr wa cS
      cnop cfv cT cnop cfv cS cbo wcel cS cnop cfv cr wcel nmoptri.1 cS nmopre
      ax-mp cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp readdcli
      a1i vx cv chil wcel vx cv cS cT chos co cfv cno cfv vx cv cS cfv cno cfv
      vx cv cT cfv cno cfv caddc co cle wbr vx cv cno cfv c1 cle wbr vx cv chil
      wcel vx cv cS cT chos co cfv cno cfv vx cv cS cfv vx cv cT cfv cva co cno
      cfv vx cv cS cfv cno cfv vx cv cT cfv cno cfv caddc co cle vx cv chil
      wcel vx cv cS cT chos co cfv vx cv cS cfv vx cv cT cfv cva co cno chil
      chil cS wf chil chil cT wf vx cv chil wcel vx cv cS cT chos co cfv vx cv
      cS cfv vx cv cT cfv cva co wceq cS cbo wcel chil chil cS wf nmoptri.1 cS
      bdopf ax-mp cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp vx cv cS
      cT hosvalOLD mpanl12 fveq2d vx cv cS cfv chil wcel vx cv cT cfv chil wcel
      vx cv cS cfv vx cv cT cfv cva co cno cfv vx cv cS cfv cno cfv vx cv cT
      cfv cno cfv caddc co cle wbr vx cv chil wcel vx cv cS cfv vx cv cT cfv
      norm-ii chil chil vx cv cS cS cbo wcel chil chil cS wf nmoptri.1 cS bdopf
      ax-mp ffvelrni chil chil vx cv cT cT cbo wcel chil chil cT wf nmoptri.2
      cT bdopf ax-mp ffvelrni sylanc eqbrtrd adantr vx cv chil wcel vx cv cno
      cfv c1 cle wbr wa vx cv cS cfv cno cfv cS cnop cfv cle wbr vx cv cT cfv
      cno cfv cT cnop cfv cle wbr vx cv cS cfv cno cfv vx cv cT cfv cno cfv
      caddc co cS cnop cfv cT cnop cfv caddc co cle wbr chil chil cS wf vx cv
      chil wcel vx cv cno cfv c1 cle wbr vx cv cS cfv cno cfv cS cnop cfv cle
      wbr cS cbo wcel chil chil cS wf nmoptri.1 cS bdopf ax-mp vx cv cS nmoplb
      mp3an1 chil chil cT wf vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv cT
      cfv cno cfv cT cnop cfv cle wbr cT cbo wcel chil chil cT wf nmoptri.2 cT
      bdopf ax-mp vx cv cT nmoplb mp3an1 vx cv chil wcel vx cv cS cfv cno cfv
      cS cnop cfv cle wbr vx cv cT cfv cno cfv cT cnop cfv cle wbr wa vx cv cS
      cfv cno cfv vx cv cT cfv cno cfv caddc co cS cnop cfv cT cnop cfv caddc
      co cle wbr wi vx cv cno cfv c1 cle wbr vx cv cS cfv cno cfv cr wcel vx cv
      cT cfv cno cfv cr wcel vx cv cS cfv cno cfv cS cnop cfv cle wbr vx cv cT
      cfv cno cfv cT cnop cfv cle wbr wa vx cv cS cfv cno cfv vx cv cT cfv cno
      cfv caddc co cS cnop cfv cT cnop cfv caddc co cle wbr wi vx cv chil wcel
      vx cv cS cfv cno cfv cr wcel vx cv cT cfv cno cfv cr wcel wa cS cnop cfv
      cr wcel cT cnop cfv cr wcel vx cv cS cfv cno cfv cS cnop cfv cle wbr vx
      cv cT cfv cno cfv cT cnop cfv cle wbr wa vx cv cS cfv cno cfv vx cv cT
      cfv cno cfv caddc co cS cnop cfv cT cnop cfv caddc co cle wbr wi cS cbo
      wcel cS cnop cfv cr wcel nmoptri.1 cS nmopre ax-mp cT cbo wcel cT cnop
      cfv cr wcel nmoptri.2 cT nmopre ax-mp vx cv cS cfv cno cfv vx cv cT cfv
      cno cfv cS cnop cfv cT cnop cfv le2add mpanr12 vx cv chil wcel vx cv cS
      cfv chil wcel vx cv cS cfv cno cfv cr wcel chil chil vx cv cS cS cbo wcel
      chil chil cS wf nmoptri.1 cS bdopf ax-mp ffvelrni vx cv cS cfv normcl syl
      vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp
      ffvelrni vx cv cT cfv normcl syl sylanc adantr mp2and letrd ex rgen vx cS
      cnop cfv cT cnop cfv caddc co cS cT chos co nmopub mp3an $.
      $( [24-Mar-2006] $) $( [10-Mar-2006] $)

    $( Upper bound for the norm of the composition of two bounded linear
       operators. $)
    nmopcoi $p |- ( normop ` ( S o. T ) ) <_
                   ( ( normop ` S ) x. ( normop ` T ) ) $=
      chil chil cS cT ccom wf cS cnop cfv cT cnop cfv cmul co cxr wcel vx cv
      cno cfv c1 cle wbr vx cv cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv
      cmul co cle wbr wi vx chil wral cS cT ccom cnop cfv cS cnop cfv cT cnop
      cfv cmul co cle wbr cS cT ccom cS cT cS cbo wcel cS clo wcel nmoptri.1 cS
      bdopln ax-mp cT cbo wcel cT clo wcel nmoptri.2 cT bdopln ax-mp lnopcoi
      lnopfi cS cnop cfv cT cnop cfv cmul co cr wcel cS cnop cfv cT cnop cfv
      cmul co cxr wcel cS cnop cfv cT cnop cfv cS cbo wcel cS cnop cfv cr wcel
      nmoptri.1 cS nmopre ax-mp cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT
      nmopre ax-mp remulcli cS cnop cfv cT cnop cfv cmul co rexr ax-mp vx cv
      cno cfv c1 cle wbr vx cv cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv
      cmul co cle wbr wi vx chil vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv
      cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv cmul co cle wbr cT cnop
      cfv cc0 wceq vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cS cT ccom
      cfv cno cfv cS cnop cfv cT cnop cfv cmul co cle wbr cT cnop cfv cc0 wceq
      vx cv chil wcel vx cv cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv cmul
      co cle wbr vx cv cno cfv c1 cle wbr cT cnop cfv cc0 wceq vx cv chil wcel
      wa cc0 cc0 vx cv cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv cmul co
      cle cc0 cc0 cle wbr cT cnop cfv cc0 wceq vx cv chil wcel wa cc0 0re leidi
      a1i cS cT ccom ch0o wceq vx cv chil wcel vx cv cS cT ccom cfv cno cfv cc0
      wceq cT cnop cfv cc0 wceq cS cT ccom ch0o wceq vx cv chil wcel vx cv cS
      cT ccom cfv cno cfv vx cv ch0o cfv cno cfv cc0 cS cT ccom ch0o wceq vx cv
      cS cT ccom cfv vx cv ch0o cfv cno vx cv cS cT ccom ch0o fveq1 fveq2d vx
      cv chil wcel vx cv ch0o cfv cno cfv c0v cno cfv cc0 vx cv chil wcel vx cv
      ch0o cfv c0v cno vx cv ho0val fveq2d norm0 syl6eq sylan9eq cT cnop cfv
      cc0 wceq cS cT ccom cnop cfv cc0 wceq cS cT ccom ch0o wceq cS cT cS cbo
      wcel cS clo wcel nmoptri.1 cS bdopln ax-mp cT cbo wcel cT clo wcel
      nmoptri.2 cT bdopln ax-mp lnopco0i cS cT ccom cS cT cS cbo wcel cS clo
      wcel nmoptri.1 cS bdopln ax-mp cT cbo wcel cT clo wcel nmoptri.2 cT
      bdopln ax-mp lnopcoi nmlnop0iHIL sylib sylan cT cnop cfv cc0 wceq cS cnop
      cfv cT cnop cfv cmul co cc0 wceq vx cv chil wcel cT cnop cfv cc0 wceq cS
      cnop cfv cT cnop cfv cmul co cS cnop cfv cc0 cmul co cc0 cT cnop cfv cc0
      cS cnop cfv cmul opreq2 cS cnop cfv cS cnop cfv cS cbo wcel cS cnop cfv
      cr wcel nmoptri.1 cS nmopre ax-mp recni mul01i syl6eq adantr 3brtr4d
      adantrr cT cnop cfv cc0 wne vx cv chil wcel vx cv cno cfv c1 cle wbr wa
      vx cv cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv cmul co cle wbr cT
      cnop cfv cc0 wceq wn cT cnop cfv cc0 wne vx cv chil wcel vx cv cno cfv c1
      cle wbr wa wa vx cv cS cT ccom cfv cno cfv cT cnop cfv cdiv co cS cnop
      cfv cle wbr vx cv cS cT ccom cfv cno cfv cS cnop cfv cT cnop cfv cmul co
      cle wbr cT cnop cfv cc0 wne vx cv chil wcel vx cv cno cfv c1 cle wbr wa
      wa vx cv cS cT ccom cfv cno cfv cT cnop cfv cdiv co c1 cT cnop cfv cdiv
      co vx cv cT cfv csm co cS cfv cno cfv cS cnop cfv cle cT cnop cfv cc0 wne
      vx cv chil wcel vx cv cS cT ccom cfv cno cfv cT cnop cfv cdiv co c1 cT
      cnop cfv cdiv co vx cv cT cfv csm co cS cfv cno cfv wceq vx cv cno cfv c1
      cle wbr cT cnop cfv cc0 wne vx cv chil wcel wa c1 cT cnop cfv cdiv co vx
      cv cS cT ccom cfv csm co cno cfv c1 cT cnop cfv cdiv co cabs cfv vx cv cS
      cT ccom cfv cno cfv cmul co c1 cT cnop cfv cdiv co vx cv cT cfv csm co cS
      cfv cno cfv vx cv cS cT ccom cfv cno cfv cT cnop cfv cdiv co c1 cT cnop
      cfv cdiv co cc wcel vx cv cS cT ccom cfv chil wcel c1 cT cnop cfv cdiv co
      vx cv cS cT ccom cfv csm co cno cfv c1 cT cnop cfv cdiv co cabs cfv vx cv
      cS cT ccom cfv cno cfv cmul co wceq cT cnop cfv cc0 wne vx cv chil wcel
      c1 cT cnop cfv cdiv co vx cv cS cT ccom cfv norm-iii cT cnop cfv cT cnop
      cfv cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp recni
      recclzi chil chil vx cv cS cT ccom cS cT ccom cS cT cS cbo wcel cS clo
      wcel nmoptri.1 cS bdopln ax-mp cT cbo wcel cT clo wcel nmoptri.2 cT
      bdopln ax-mp lnopcoi lnopfi ffvelrni syl2an cT cnop cfv cc0 wne vx cv
      chil wcel wa c1 cT cnop cfv cdiv co vx cv cT cfv csm co cS cfv c1 cT cnop
      cfv cdiv co vx cv cS cT ccom cfv csm co cno cT cnop cfv cc0 wne vx cv
      chil wcel wa c1 cT cnop cfv cdiv co vx cv cT cfv csm co cS cfv c1 cT cnop
      cfv cdiv co vx cv cT cfv cS cfv csm co c1 cT cnop cfv cdiv co vx cv cS cT
      ccom cfv csm co c1 cT cnop cfv cdiv co cc wcel vx cv cT cfv chil wcel c1
      cT cnop cfv cdiv co vx cv cT cfv csm co cS cfv c1 cT cnop cfv cdiv co vx
      cv cT cfv cS cfv csm co wceq cT cnop cfv cc0 wne vx cv chil wcel c1 cT
      cnop cfv cdiv co vx cv cT cfv cS cS cbo wcel cS clo wcel nmoptri.1 cS
      bdopln ax-mp lnopmuli cT cnop cfv cT cnop cfv cT cbo wcel cT cnop cfv cr
      wcel nmoptri.2 cT nmopre ax-mp recni recclzi chil chil vx cv cT cT cbo
      wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp ffvelrni syl2an vx cv chil
      wcel c1 cT cnop cfv cdiv co vx cv cS cT ccom cfv csm co c1 cT cnop cfv
      cdiv co vx cv cT cfv cS cfv csm co wceq cT cnop cfv cc0 wne vx cv chil
      wcel vx cv cS cT ccom cfv vx cv cT cfv cS cfv c1 cT cnop cfv cdiv co csm
      vx cv cS cT cS cbo wcel chil chil cS wf nmoptri.1 cS bdopf ax-mp cT cbo
      wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp hocoi opreq2d adantl eqtr4d
      fveq2d cT cnop cfv cc0 wne vx cv chil wcel wa vx cv cS cT ccom cfv cno
      cfv cT cnop cfv cdiv co c1 cT cnop cfv cdiv co vx cv cS cT ccom cfv cno
      cfv cmul co c1 cT cnop cfv cdiv co cabs cfv vx cv cS cT ccom cfv cno cfv
      cmul co vx cv chil wcel cT cnop cfv cc0 wne vx cv cS cT ccom cfv cno cfv
      cT cnop cfv cdiv co c1 cT cnop cfv cdiv co vx cv cS cT ccom cfv cno cfv
      cmul co wceq vx cv cS cT ccom cfv cno cfv cc wcel cT cnop cfv cc0 wne vx
      cv cS cT ccom cfv cno cfv cT cnop cfv cdiv co c1 cT cnop cfv cdiv co vx
      cv cS cT ccom cfv cno cfv cmul co wceq vx cv chil wcel vx cv cS cT ccom
      cfv cno cfv cc wcel cT cnop cfv cc wcel cT cnop cfv cc0 wne vx cv cS cT
      ccom cfv cno cfv cT cnop cfv cdiv co c1 cT cnop cfv cdiv co vx cv cS cT
      ccom cfv cno cfv cmul co wceq cT cnop cfv cT cbo wcel cT cnop cfv cr wcel
      nmoptri.2 cT nmopre ax-mp recni vx cv cS cT ccom cfv cno cfv cT cnop cfv
      divrec2 mp3an2 vx cv chil wcel vx cv cS cT ccom cfv cno cfv vx cv chil
      wcel vx cv cS cT ccom cfv chil wcel vx cv cS cT ccom cfv cno cfv cr wcel
      chil chil vx cv cS cT ccom cS cT ccom cS cT cS cbo wcel cS clo wcel
      nmoptri.1 cS bdopln ax-mp cT cbo wcel cT clo wcel nmoptri.2 cT bdopln
      ax-mp lnopcoi lnopfi ffvelrni vx cv cS cT ccom cfv normcl syl recnd sylan
      ancoms cT cnop cfv cc0 wne vx cv chil wcel wa c1 cT cnop cfv cdiv co cabs
      cfv c1 cT cnop cfv cdiv co vx cv cS cT ccom cfv cno cfv cmul cT cnop cfv
      cc0 wne c1 cT cnop cfv cdiv co cabs cfv c1 cT cnop cfv cdiv co wceq vx cv
      chil wcel c1 cT cnop cfv cdiv co cr wcel cc0 c1 cT cnop cfv cdiv co cle
      wbr c1 cT cnop cfv cdiv co cabs cfv c1 cT cnop cfv cdiv co wceq cT cnop
      cfv cc0 wne c1 cT cnop cfv cdiv co absid cT cnop cfv cT cbo wcel cT cnop
      cfv cr wcel nmoptri.2 cT nmopre ax-mp rerecclzi c1 cT cnop cfv cdiv co cr
      wcel cc0 c1 cT cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle
      wbr cT cnop cfv cc0 wne cc0 cr wcel c1 cT cnop cfv cdiv co cr wcel cc0 c1
      cT cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle wbr wi 0re cc0
      c1 cT cnop cfv cdiv co ltle mpan cT cnop cfv cT cbo wcel cT cnop cfv cr
      wcel nmoptri.2 cT nmopre ax-mp rerecclzi cT cnop cfv cc0 wne cc0 cT cnop
      cfv clt wbr cc0 c1 cT cnop cfv cdiv co clt wbr chil chil cT wf cT cnop
      cfv cc0 wne cc0 cT cnop cfv clt wbr wb cT cbo wcel chil chil cT wf
      nmoptri.2 cT bdopf ax-mp cT nmopgt0 ax-mp cT cnop cfv cT cbo wcel cT cnop
      cfv cr wcel nmoptri.2 cT nmopre ax-mp recgt0i sylbi sylc sylanc adantr
      opreq1d eqtr4d 3eqtr4rd adantrr c1 cT cnop cfv cdiv co vx cv cT cfv csm
      co chil wcel c1 cT cnop cfv cdiv co vx cv cT cfv csm co cno cfv c1 cle
      wbr c1 cT cnop cfv cdiv co vx cv cT cfv csm co cS cfv cno cfv cS cnop cfv
      cle wbr cT cnop cfv cc0 wne vx cv chil wcel vx cv cno cfv c1 cle wbr wa
      wa chil chil cS wf c1 cT cnop cfv cdiv co vx cv cT cfv csm co chil wcel
      c1 cT cnop cfv cdiv co vx cv cT cfv csm co cno cfv c1 cle wbr c1 cT cnop
      cfv cdiv co vx cv cT cfv csm co cS cfv cno cfv cS cnop cfv cle wbr cS cbo
      wcel chil chil cS wf nmoptri.1 cS bdopf ax-mp c1 cT cnop cfv cdiv co vx
      cv cT cfv csm co cS nmoplb mp3an1 cT cnop cfv cc0 wne vx cv chil wcel c1
      cT cnop cfv cdiv co vx cv cT cfv csm co chil wcel vx cv cno cfv c1 cle
      wbr c1 cT cnop cfv cdiv co cc wcel vx cv cT cfv chil wcel c1 cT cnop cfv
      cdiv co vx cv cT cfv csm co chil wcel cT cnop cfv cc0 wne vx cv chil wcel
      c1 cT cnop cfv cdiv co vx cv cT cfv hvmulcl cT cnop cfv cT cnop cfv cT
      cbo wcel cT cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp recni recclzi chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp
      ffvelrni syl2an adantrr cT cnop cfv cc0 wne vx cv chil wcel vx cv cno cfv
      c1 cle wbr wa wa c1 cT cnop cfv cdiv co vx cv cT cfv csm co cno cfv vx cv
      cT cfv cno cfv cT cnop cfv cdiv co c1 cle cT cnop cfv cc0 wne vx cv chil
      wcel c1 cT cnop cfv cdiv co vx cv cT cfv csm co cno cfv vx cv cT cfv cno
      cfv cT cnop cfv cdiv co wceq vx cv cno cfv c1 cle wbr cT cnop cfv cc0 wne
      vx cv chil wcel wa c1 cT cnop cfv cdiv co cabs cfv vx cv cT cfv cno cfv
      cmul co c1 cT cnop cfv cdiv co vx cv cT cfv cno cfv cmul co c1 cT cnop
      cfv cdiv co vx cv cT cfv csm co cno cfv vx cv cT cfv cno cfv cT cnop cfv
      cdiv co cT cnop cfv cc0 wne vx cv chil wcel wa c1 cT cnop cfv cdiv co
      cabs cfv c1 cT cnop cfv cdiv co vx cv cT cfv cno cfv cmul cT cnop cfv cc0
      wne c1 cT cnop cfv cdiv co cabs cfv c1 cT cnop cfv cdiv co wceq vx cv
      chil wcel c1 cT cnop cfv cdiv co cr wcel cc0 c1 cT cnop cfv cdiv co cle
      wbr c1 cT cnop cfv cdiv co cabs cfv c1 cT cnop cfv cdiv co wceq cT cnop
      cfv cc0 wne c1 cT cnop cfv cdiv co absid cT cnop cfv cT cbo wcel cT cnop
      cfv cr wcel nmoptri.2 cT nmopre ax-mp rerecclzi c1 cT cnop cfv cdiv co cr
      wcel cc0 c1 cT cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle
      wbr cT cnop cfv cc0 wne cc0 cr wcel c1 cT cnop cfv cdiv co cr wcel cc0 c1
      cT cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle wbr wi 0re cc0
      c1 cT cnop cfv cdiv co ltle mpan cT cnop cfv cT cbo wcel cT cnop cfv cr
      wcel nmoptri.2 cT nmopre ax-mp rerecclzi cT cnop cfv cc0 wne cc0 cT cnop
      cfv clt wbr cc0 c1 cT cnop cfv cdiv co clt wbr chil chil cT wf cT cnop
      cfv cc0 wne cc0 cT cnop cfv clt wbr wb cT cbo wcel chil chil cT wf
      nmoptri.2 cT bdopf ax-mp cT nmopgt0 ax-mp cT cnop cfv cT cbo wcel cT cnop
      cfv cr wcel nmoptri.2 cT nmopre ax-mp recgt0i sylbi sylc sylanc adantr
      opreq1d c1 cT cnop cfv cdiv co cc wcel vx cv cT cfv chil wcel c1 cT cnop
      cfv cdiv co vx cv cT cfv csm co cno cfv c1 cT cnop cfv cdiv co cabs cfv
      vx cv cT cfv cno cfv cmul co wceq cT cnop cfv cc0 wne vx cv chil wcel c1
      cT cnop cfv cdiv co vx cv cT cfv norm-iii cT cnop cfv cT cnop cfv cT cbo
      wcel cT cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp recni recclzi chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp
      ffvelrni syl2an vx cv chil wcel cT cnop cfv cc0 wne vx cv cT cfv cno cfv
      cT cnop cfv cdiv co c1 cT cnop cfv cdiv co vx cv cT cfv cno cfv cmul co
      wceq vx cv cT cfv cno cfv cc wcel cT cnop cfv cc0 wne vx cv cT cfv cno
      cfv cT cnop cfv cdiv co c1 cT cnop cfv cdiv co vx cv cT cfv cno cfv cmul
      co wceq vx cv chil wcel vx cv cT cfv cno cfv cc wcel cT cnop cfv cc wcel
      cT cnop cfv cc0 wne vx cv cT cfv cno cfv cT cnop cfv cdiv co c1 cT cnop
      cfv cdiv co vx cv cT cfv cno cfv cmul co wceq cT cnop cfv cT cbo wcel cT
      cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp recni vx cv cT cfv cno cfv cT
      cnop cfv divrec2 mp3an2 vx cv chil wcel vx cv cT cfv cno cfv vx cv chil
      wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv
      cT cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp ffvelrni vx cv cT
      cfv normcl syl recnd sylan ancoms 3eqtr4d adantrr cT cnop cfv cc0 wne vx
      cv chil wcel vx cv cno cfv c1 cle wbr wa wa vx cv cT cfv cno cfv cT cnop
      cfv cdiv co c1 cle wbr vx cv cT cfv cno cfv c1 cT cnop cfv cmul co cle
      wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cno cfv c1
      cT cnop cfv cmul co cle wbr cT cnop cfv cc0 wne vx cv chil wcel vx cv cno
      cfv c1 cle wbr wa vx cv cT cfv cno cfv cT cnop cfv c1 cT cnop cfv cmul co
      cle chil chil cT wf vx cv chil wcel vx cv cno cfv c1 cle wbr vx cv cT cfv
      cno cfv cT cnop cfv cle wbr cT cbo wcel chil chil cT wf nmoptri.2 cT
      bdopf ax-mp vx cv cT nmoplb mp3an1 cT cnop cfv cT cnop cfv cT cbo wcel cT
      cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp recni mulid2i syl6breqr adantl
      cT cnop cfv cc0 wne vx cv chil wcel vx cv cT cfv cno cfv cT cnop cfv cdiv
      co c1 cle wbr vx cv cT cfv cno cfv c1 cT cnop cfv cmul co cle wbr wb vx
      cv cno cfv c1 cle wbr vx cv chil wcel cT cnop cfv cc0 wne vx cv cT cfv
      cno cfv cT cnop cfv cdiv co c1 cle wbr vx cv cT cfv cno cfv c1 cT cnop
      cfv cmul co cle wbr wb vx cv cT cfv cno cfv cr wcel cc0 cT cnop cfv clt
      wbr vx cv cT cfv cno cfv cT cnop cfv cdiv co c1 cle wbr vx cv cT cfv cno
      cfv c1 cT cnop cfv cmul co cle wbr wb vx cv chil wcel cT cnop cfv cc0 wne
      vx cv cT cfv cno cfv cr wcel c1 cr wcel cc0 cT cnop cfv clt wbr vx cv cT
      cfv cno cfv cT cnop cfv cdiv co c1 cle wbr vx cv cT cfv cno cfv c1 cT
      cnop cfv cmul co cle wbr wb 1re vx cv cT cfv cno cfv cr wcel cT cnop cfv
      cr wcel c1 cr wcel cc0 cT cnop cfv clt wbr vx cv cT cfv cno cfv cT cnop
      cfv cdiv co c1 cle wbr vx cv cT cfv cno cfv c1 cT cnop cfv cmul co cle
      wbr wb cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp vx cv cT
      cfv cno cfv cT cnop cfv c1 ledivmul2OLD mp3anl2 mpanl2 vx cv chil wcel vx
      cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv cT cT
      cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp ffvelrni vx cv cT cfv
      normcl syl cT cnop cfv cc0 wne cc0 cT cnop cfv clt wbr chil chil cT wf cT
      cnop cfv cc0 wne cc0 cT cnop cfv clt wbr wb cT cbo wcel chil chil cT wf
      nmoptri.2 cT bdopf ax-mp cT nmopgt0 ax-mp biimpi syl2an ancoms adantrr
      mpbird eqbrtrd sylanc eqbrtrd vx cv cS cT ccom cfv cno cfv cr wcel cT
      cnop cfv cr wcel cS cnop cfv cr wcel w3a cc0 cT cnop cfv clt wbr vx cv cS
      cT ccom cfv cno cfv cT cnop cfv cdiv co cS cnop cfv cle wbr vx cv cS cT
      ccom cfv cno cfv cS cnop cfv cT cnop cfv cmul co cle wbr wb cT cnop cfv
      cc0 wne vx cv chil wcel vx cv cno cfv c1 cle wbr wa wa vx cv cS cT ccom
      cfv cno cfv cT cnop cfv cS cnop cfv ledivmul2OLD vx cv chil wcel vx cv cS
      cT ccom cfv cno cfv cr wcel cT cnop cfv cr wcel cS cnop cfv cr wcel w3a
      cT cnop cfv cc0 wne vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv cS cT
      ccom cfv cno cfv cr wcel cT cnop cfv cr wcel cS cnop cfv cr wcel vx cv
      chil wcel vx cv cS cT ccom cfv chil wcel vx cv cS cT ccom cfv cno cfv cr
      wcel chil chil vx cv cS cT ccom cS cT ccom cS cT cS cbo wcel cS clo wcel
      nmoptri.1 cS bdopln ax-mp cT cbo wcel cT clo wcel nmoptri.2 cT bdopln
      ax-mp lnopcoi lnopfi ffvelrni vx cv cS cT ccom cfv normcl syl cT cnop cfv
      cr wcel vx cv chil wcel cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT
      nmopre ax-mp a1i cS cnop cfv cr wcel vx cv chil wcel cS cbo wcel cS cnop
      cfv cr wcel nmoptri.1 cS nmopre ax-mp a1i 3jca ad2antrl cT cnop cfv cc0
      wne cc0 cT cnop cfv clt wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa
      cT cnop cfv cc0 wne cc0 cT cnop cfv clt wbr chil chil cT wf cT cnop cfv
      cc0 wne cc0 cT cnop cfv clt wbr wb cT cbo wcel chil chil cT wf nmoptri.2
      cT bdopf ax-mp cT nmopgt0 ax-mp biimpi adantr sylanc mpbid cT cnop cfv
      cc0 df-ne sylanbr pm2.61ian ex rgen vx cS cnop cfv cT cnop cfv cmul co cS
      cT ccom nmopub mp3an $.
      $( [8-May-2006] $) $( [10-Mar-2006] $)

    $( The sum of two bounded linear operators is a bounded linear operator. $)
    bdophsi $p |- ( S +op T ) e. BndLinOp $=
      cS cT chos co cbo wcel cS cT chos co clo wcel cS cT chos co cnop cfv cr
      wcel cS cT chos co elbdop2 cS cT cS cbo wcel cS clo wcel nmoptri.1 cS
      bdopln ax-mp cT cbo wcel cT clo wcel nmoptri.2 cT bdopln ax-mp lnophsi cS
      cT chos co cnop cfv cxr wcel cS cnop cfv cT cnop cfv caddc co cr wcel wa
      cmnf cS cT chos co cnop cfv clt wbr cS cT chos co cnop cfv cS cnop cfv cT
      cnop cfv caddc co cle wbr wa cS cT chos co cnop cfv cr wcel cS cT chos co
      cnop cfv cxr wcel cS cnop cfv cT cnop cfv caddc co cr wcel chil chil cS
      cT chos co wf cS cT chos co cnop cfv cxr wcel cS cT cS cbo wcel chil chil
      cS wf nmoptri.1 cS bdopf ax-mp cT cbo wcel chil chil cT wf nmoptri.2 cT
      bdopf ax-mp hoaddcli cS cT chos co nmopxr ax-mp cS cnop cfv cT cnop cfv
      cS cbo wcel cS cnop cfv cr wcel nmoptri.1 cS nmopre ax-mp cT cbo wcel cT
      cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp readdcli pm3.2i cmnf cS cT
      chos co cnop cfv clt wbr cS cT chos co cnop cfv cS cnop cfv cT cnop cfv
      caddc co cle wbr chil chil cS cT chos co wf cmnf cS cT chos co cnop cfv
      clt wbr cS cT cS cbo wcel chil chil cS wf nmoptri.1 cS bdopf ax-mp cT cbo
      wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp hoaddcli cS cT chos co
      nmopgtmnf ax-mp cS cT nmoptri.1 nmoptri.2 nmoptrii pm3.2i cS cT chos co
      cnop cfv cS cnop cfv cT cnop cfv caddc co xrre mp2an mpbir2an $.
      $( [10-May-2006] $) $( [9-Mar-2006] $)

    $( The difference between two bounded linear operators is bounded. $)
    bdophdi $p |- ( S -op T ) e. BndLinOp $=
      cS c1 cneg cT chot co chos co cS cT chod co cbo cS cT cS cbo wcel chil
      chil cS wf nmoptri.1 cS bdopf ax-mp cT cbo wcel chil chil cT wf nmoptri.2
      cT bdopf ax-mp honegsubi cS c1 cneg cT chot co nmoptri.1 c1 cneg cc wcel
      c1 cneg cT chot co cbo wcel c1 ax1cn negcli c1 cneg cT nmoptri.2 bdophmi
      ax-mp bdophsi eqeltrri $.
      $( [10-May-2006] $) $( [10-Mar-2006] $)

    $( The composition of two bounded linear operators is bounded. $)
    bdopcoi $p |- ( S o. T ) e. BndLinOp $=
      cS cT ccom cbo wcel cS cT ccom clo wcel cS cT ccom cnop cfv cr wcel cS cT
      ccom elbdop2 cS cT cS cbo wcel cS clo wcel nmoptri.1 cS bdopln ax-mp cT
      cbo wcel cT clo wcel nmoptri.2 cT bdopln ax-mp lnopcoi cS cT ccom cnop
      cfv cxr wcel cS cnop cfv cT cnop cfv cmul co cr wcel wa cmnf cS cT ccom
      cnop cfv clt wbr cS cT ccom cnop cfv cS cnop cfv cT cnop cfv cmul co cle
      wbr wa cS cT ccom cnop cfv cr wcel cS cT ccom cnop cfv cxr wcel cS cnop
      cfv cT cnop cfv cmul co cr wcel chil chil cS cT ccom wf cS cT ccom cnop
      cfv cxr wcel cS cT cS cS cbo wcel cS clo wcel nmoptri.1 cS bdopln ax-mp
      lnopfi cT cT cbo wcel cT clo wcel nmoptri.2 cT bdopln ax-mp lnopfi hocofi
      cS cT ccom nmopxr ax-mp cS cnop cfv cT cnop cfv cS cbo wcel cS cnop cfv
      cr wcel nmoptri.1 cS nmopre ax-mp cT cbo wcel cT cnop cfv cr wcel
      nmoptri.2 cT nmopre ax-mp remulcli pm3.2i cmnf cS cT ccom cnop cfv clt
      wbr cS cT ccom cnop cfv cS cnop cfv cT cnop cfv cmul co cle wbr chil chil
      cS cT ccom wf cmnf cS cT ccom cnop cfv clt wbr cS cT cS cS cbo wcel cS
      clo wcel nmoptri.1 cS bdopln ax-mp lnopfi cT cT cbo wcel cT clo wcel
      nmoptri.2 cT bdopln ax-mp lnopfi hocofi cS cT ccom nmopgtmnf ax-mp cS cT
      nmoptri.1 nmoptri.2 nmopcoi pm3.2i cS cT ccom cnop cfv cS cnop cfv cT
      cnop cfv cmul co xrre mp2an mpbir2an $.
      $( [10-May-2006] $) $( [9-Mar-2006] $)

    $( Triangle-type inequality for the norms of bounded linear operators. $)
    nmoptri2i $p |- ( ( normop ` S ) - ( normop ` T ) ) <_
                  ( normop ` ( S +op T ) ) $=
      cS cnop cfv cT cnop cfv cmin co cS cT chos co cnop cfv cle wbr cS cnop
      cfv cS cT chos co cnop cfv cT cnop cfv caddc co cle wbr cS cT chos co c1
      cneg cT chot co chos co cnop cfv cS cT chos co cnop cfv c1 cneg cT chot
      co cnop cfv caddc co cS cnop cfv cS cT chos co cnop cfv cT cnop cfv caddc
      co cle cS cT chos co c1 cneg cT chot co cS cT nmoptri.1 nmoptri.2 bdophsi
      c1 cneg cc wcel c1 cneg cT chot co cbo wcel c1 ax1cn negcli c1 cneg cT
      nmoptri.2 bdophmi ax-mp nmoptrii cS cT chos co c1 cneg cT chot co chos co
      cS cnop cS cT chos co c1 cneg cT chot co chos co cS cT chos co cT chod co
      cS cS cT chos co cT cS cT cS cbo wcel chil chil cS wf nmoptri.1 cS bdopf
      ax-mp cT cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp hoaddcli cT
      cbo wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp honegsubi cS cT cS cbo
      wcel chil chil cS wf nmoptri.1 cS bdopf ax-mp cT cbo wcel chil chil cT wf
      nmoptri.2 cT bdopf ax-mp hopncani eqtri fveq2i c1 cneg cT chot co cnop
      cfv cT cnop cfv cS cT chos co cnop cfv caddc cT cT cbo wcel chil chil cT
      wf nmoptri.2 cT bdopf ax-mp nmopnegi opreq2i 3brtr3i cS cnop cfv cT cnop
      cfv cS cT chos co cnop cfv cS cbo wcel cS cnop cfv cr wcel nmoptri.1 cS
      nmopre ax-mp cT cbo wcel cT cnop cfv cr wcel nmoptri.2 cT nmopre ax-mp cS
      cT chos co cbo wcel cS cT chos co cnop cfv cr wcel cS cT nmoptri.1
      nmoptri.2 bdophsi cS cT chos co nmopre ax-mp lesubaddi mpbir $.
      $( [26-Nov-2006] $) $( [10-Mar-2006] $)

    $( The adjoint of a composition of bounded linear operators.  Theorem
       3.11(viii) of [Beran] p. 106. $)
    adjcoi $p |- ( adjh ` ( S o. T ) ) = ( ( adjh ` T ) o. ( adjh ` S ) ) $=
      vx cv vy cv cS cT ccom cado cfv cfv csp co vx cv vy cv cT cado cfv cS
      cado cfv ccom cfv csp co wceq vy chil wral vx chil wral cS cT ccom cado
      cfv cT cado cfv cS cado cfv ccom wceq vx cv vy cv cS cT ccom cado cfv cfv
      csp co vx cv vy cv cT cado cfv cS cado cfv ccom cfv csp co wceq vx vy
      chil vx cv chil wcel vy cv chil wcel wa vx cv vy cv cT cado cfv cS cado
      cfv ccom cfv csp co vx cv vy cv cS cado cfv cfv cT cado cfv cfv csp co vx
      cv cS cT ccom cfv vy cv csp co vx cv vy cv cS cT ccom cado cfv cfv csp co
      vy cv chil wcel vx cv vy cv cT cado cfv cS cado cfv ccom cfv csp co vx cv
      vy cv cS cado cfv cfv cT cado cfv cfv csp co wceq vx cv chil wcel vy cv
      chil wcel vy cv cT cado cfv cS cado cfv ccom cfv vy cv cS cado cfv cfv cT
      cado cfv cfv vx cv csp vy cv cT cado cfv cS cado cfv cT cado cfv cbo wcel
      chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmoptri.2 cT
      adjbdln ax-mp cT cado cfv bdopf ax-mp cS cado cfv cbo wcel chil chil cS
      cado cfv wf cS cbo wcel cS cado cfv cbo wcel nmoptri.1 cS adjbdln ax-mp
      cS cado cfv bdopf ax-mp hocoi opreq2d adantl vx cv chil wcel vy cv chil
      wcel wa vx cv cS cT ccom cfv vy cv csp co vx cv cT cfv cS cfv vy cv csp
      co vx cv cT cfv vy cv cS cado cfv cfv csp co vx cv vy cv cS cado cfv cfv
      cT cado cfv cfv csp co vx cv chil wcel vx cv cS cT ccom cfv vy cv csp co
      vx cv cT cfv cS cfv vy cv csp co wceq vy cv chil wcel vx cv chil wcel vx
      cv cS cT ccom cfv vx cv cT cfv cS cfv vy cv csp vx cv cS cT cS cbo wcel
      chil chil cS wf nmoptri.1 cS bdopf ax-mp cT cbo wcel chil chil cT wf
      nmoptri.2 cT bdopf ax-mp hocoi opreq1d adantr vx cv cT cfv chil wcel vy
      cv chil wcel vx cv cT cfv cS cfv vy cv csp co vx cv cT cfv vy cv cS cado
      cfv cfv csp co wceq vx cv chil wcel cS cado cdm wcel vx cv cT cfv chil
      wcel vy cv chil wcel vx cv cT cfv cS cfv vy cv csp co vx cv cT cfv vy cv
      cS cado cfv cfv csp co wceq cS cbo wcel cS cado cdm wcel nmoptri.1 cS
      bdopadj ax-mp vx cv cT cfv vy cv cS adj2 mp3an1 chil chil vx cv cT cT cbo
      wcel chil chil cT wf nmoptri.2 cT bdopf ax-mp ffvelrni sylan vx cv chil
      wcel vy cv cS cado cfv cfv chil wcel vx cv cT cfv vy cv cS cado cfv cfv
      csp co vx cv vy cv cS cado cfv cfv cT cado cfv cfv csp co wceq vy cv chil
      wcel cT cado cdm wcel vx cv chil wcel vy cv cS cado cfv cfv chil wcel vx
      cv cT cfv vy cv cS cado cfv cfv csp co vx cv vy cv cS cado cfv cfv cT
      cado cfv cfv csp co wceq cT cbo wcel cT cado cdm wcel nmoptri.2 cT
      bdopadj ax-mp vx cv vy cv cS cado cfv cfv cT adj2 mp3an1 chil chil vy cv
      cS cado cfv cS cado cfv cbo wcel chil chil cS cado cfv wf cS cbo wcel cS
      cado cfv cbo wcel nmoptri.1 cS adjbdln ax-mp cS cado cfv bdopf ax-mp
      ffvelrni sylan2 3eqtrd cS cT ccom cado cdm wcel vx cv chil wcel vy cv
      chil wcel vx cv cS cT ccom cfv vy cv csp co vx cv vy cv cS cT ccom cado
      cfv cfv csp co wceq cS cT ccom cbo wcel cS cT ccom cado cdm wcel cS cT
      nmoptri.1 nmoptri.2 bdopcoi cS cT ccom bdopadj ax-mp vx cv vy cv cS cT
      ccom adj2 mp3an1 3eqtr2rd rgen2a chil chil cS cT ccom cado cfv wf chil
      chil cT cado cfv cS cado cfv ccom wf vx cv vy cv cS cT ccom cado cfv cfv
      csp co vx cv vy cv cT cado cfv cS cado cfv ccom cfv csp co wceq vy chil
      wral vx chil wral cS cT ccom cado cfv cT cado cfv cS cado cfv ccom wceq
      wb cS cT ccom cado cfv cbo wcel chil chil cS cT ccom cado cfv wf cS cT
      ccom cbo wcel cS cT ccom cado cfv cbo wcel cS cT nmoptri.1 nmoptri.2
      bdopcoi cS cT ccom adjbdln ax-mp cS cT ccom cado cfv bdopf ax-mp cT cado
      cfv cS cado cfv cT cado cfv cbo wcel chil chil cT cado cfv wf cT cbo wcel
      cT cado cfv cbo wcel nmoptri.2 cT adjbdln ax-mp cT cado cfv bdopf ax-mp
      cS cado cfv cbo wcel chil chil cS cado cfv wf cS cbo wcel cS cado cfv cbo
      wcel nmoptri.1 cS adjbdln ax-mp cS cado cfv bdopf ax-mp hocofi vx vy cS
      cT ccom cado cfv cT cado cfv cS cado cfv ccom hoeq2 mp2an mpbi $.
      $( [30-Jun-2006] $) $( [10-Mar-2006] $)
  $}

  ${
    $d x y S $.  $d x y T $.
    nmopcoadj.1 $e |- T e. BndLinOp $.
    $( The norm of an operator composed with its adjoint.  Part of Theorem
       3.11(vi) of [Beran] p. 106. $)
    nmopcoadji $p |- ( normop ` ( ( adjh ` T ) o. T ) )
                    = ( ( normop ` T ) ^ 2 ) $=
      cT cado cfv cT ccom cnop cfv cT cnop cfv c2 cexp co wceq cT cado cfv cT
      ccom cnop cfv cT cnop cfv c2 cexp co cle wbr cT cnop cfv c2 cexp co cT
      cado cfv cT ccom cnop cfv cle wbr cT cado cfv cT ccom cnop cfv cT cnop
      cfv c2 cexp co cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv
      cr wcel cT cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp cT
      cnop cfv cT cbo wcel cT cnop cfv cr wcel nmopcoadj.1 cT nmopre ax-mp
      resqcli letri3i chil chil cT cado cfv cT ccom wf cT cnop cfv c2 cexp co
      cxr wcel vx cv cno cfv c1 cle wbr vx cv cT cado cfv cT ccom cfv cno cfv
      cT cnop cfv c2 cexp co cle wbr wi vx chil wral cT cado cfv cT ccom cnop
      cfv cT cnop cfv c2 cexp co cle wbr cT cado cfv cT cT cado cfv cbo wcel
      chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil chil cT wf
      nmopcoadj.1 cT bdopf ax-mp hocofi cT cnop cfv c2 cexp co cr wcel cT cnop
      cfv c2 cexp co cxr wcel cT cnop cfv cT cbo wcel cT cnop cfv cr wcel
      nmopcoadj.1 cT nmopre ax-mp resqcli cT cnop cfv c2 cexp co rexr ax-mp vx
      cv cno cfv c1 cle wbr vx cv cT cado cfv cT ccom cfv cno cfv cT cnop cfv
      c2 cexp co cle wbr wi vx chil vx cv chil wcel vx cv cno cfv c1 cle wbr vx
      cv cT cado cfv cT ccom cfv cno cfv cT cnop cfv c2 cexp co cle wbr vx cv
      chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cado cfv cT ccom cfv cno
      cfv cT cado cfv cnop cfv cT cnop cfv cmul co cT cnop cfv c2 cexp co cle
      vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cado cfv cT ccom cfv
      cno cfv vx cv cT cfv cT cado cfv cfv cno cfv cT cado cfv cnop cfv cT cnop
      cfv cmul co cle vx cv chil wcel vx cv cT cado cfv cT ccom cfv cno cfv vx
      cv cT cfv cT cado cfv cfv cno cfv wceq vx cv cno cfv c1 cle wbr vx cv
      chil wcel vx cv cT cado cfv cT ccom cfv vx cv cT cfv cT cado cfv cfv cno
      vx cv cT cado cfv cT cT cado cfv cbo wcel chil chil cT cado cfv wf cT cbo
      wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf
      ax-mp cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp hocoi fveq2d
      adantr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cT cado
      cfv cfv cno cfv cT cado cfv cnop cfv vx cv cT cfv cno cfv cmul co cT cado
      cfv cnop cfv cT cnop cfv cmul co vx cv chil wcel vx cv cT cfv cT cado cfv
      cfv cno cfv cr wcel vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv cT cfv
      cT cado cfv cfv chil wcel vx cv cT cfv cT cado cfv cfv cno cfv cr wcel vx
      cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cT cado cfv cfv chil
      wcel chil chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf
      ax-mp ffvelrni chil chil vx cv cT cfv cT cado cfv cT cado cfv cbo wcel
      chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni syl vx cv cT cfv cT cado
      cfv cfv normcl syl adantr vx cv chil wcel cT cado cfv cnop cfv vx cv cT
      cfv cno cfv cmul co cr wcel vx cv cno cfv c1 cle wbr vx cv chil wcel vx
      cv cT cfv cno cfv cr wcel cT cado cfv cnop cfv vx cv cT cfv cno cfv cmul
      co cr wcel vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr
      wcel chil chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf
      ax-mp ffvelrni vx cv cT cfv normcl syl cT cado cfv cnop cfv cr wcel vx cv
      cT cfv cno cfv cr wcel cT cado cfv cnop cfv vx cv cT cfv cno cfv cmul co
      cr wcel cT cado cfv cbo wcel cT cado cfv cnop cfv cr wcel cT cbo wcel cT
      cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv nmopre ax-mp
      cT cado cfv cnop cfv vx cv cT cfv cno cfv remulcl mpan syl adantr cT cado
      cfv cnop cfv cT cnop cfv cmul co cr wcel vx cv chil wcel vx cv cno cfv c1
      cle wbr wa cT cado cfv cnop cfv cT cnop cfv cT cado cfv cbo wcel cT cado
      cfv cnop cfv cr wcel cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi cT cado cfv nmopre ax-mp cT cbo wcel cT cnop cfv cr wcel
      nmopcoadj.1 cT nmopre ax-mp remulcli a1i vx cv chil wcel vx cv cT cfv cT
      cado cfv cfv cno cfv cT cado cfv cnop cfv vx cv cT cfv cno cfv cmul co
      cle wbr vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv cT cfv chil wcel
      vx cv cT cfv cT cado cfv cfv cno cfv cT cado cfv cnop cfv vx cv cT cfv
      cno cfv cmul co cle wbr chil chil vx cv cT cT cbo wcel chil chil cT wf
      nmopcoadj.1 cT bdopf ax-mp ffvelrni vx cv cT cfv cT cado cfv cT cbo wcel
      cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi nmbdoplbi syl adantr vx
      cv cT cfv cno cfv cr wcel vx cv cT cfv cno cfv cT cnop cfv cle wbr cT
      cado cfv cnop cfv vx cv cT cfv cno cfv cmul co cT cado cfv cnop cfv cT
      cnop cfv cmul co cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx
      cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel vx cv cT cfv cno cfv cT
      cnop cfv cle wbr cT cado cfv cnop cfv vx cv cT cfv cno cfv cmul co cT
      cado cfv cnop cfv cT cnop cfv cmul co cle wbr cT cbo wcel cT cnop cfv cr
      wcel nmopcoadj.1 cT nmopre ax-mp vx cv cT cfv cno cfv cr wcel cT cnop cfv
      cr wcel cT cado cfv cnop cfv cr wcel vx cv cT cfv cno cfv cT cnop cfv cle
      wbr cT cado cfv cnop cfv vx cv cT cfv cno cfv cmul co cT cado cfv cnop
      cfv cT cnop cfv cmul co cle wbr cT cado cfv cbo wcel cT cado cfv cnop cfv
      cr wcel cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT
      cado cfv nmopre ax-mp vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel cT
      cado cfv cnop cfv cr wcel w3a cc0 cT cado cfv cnop cfv cle wbr vx cv cT
      cfv cno cfv cT cnop cfv cle wbr cT cado cfv cnop cfv vx cv cT cfv cno cfv
      cmul co cT cado cfv cnop cfv cT cnop cfv cmul co cle wbr chil chil cT
      cado cfv wf cc0 cT cado cfv cnop cfv cle wbr cT cado cfv cbo wcel chil
      chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cado cfv nmopge0 ax-mp vx cv cT
      cfv cno cfv cT cnop cfv cT cado cfv cnop cfv lemul2aOLD mpanr1 mp3anl3
      mpanl2 vx cv chil wcel vx cv cT cfv cno cfv cr wcel vx cv cno cfv c1 cle
      wbr vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel
      chil chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp
      ffvelrni vx cv cT cfv normcl syl adantr vx cv chil wcel vx cv cno cfv c1
      cle wbr wa vx cv cT cfv cno cfv cT cnop cfv vx cv cno cfv cmul co cT cnop
      cfv vx cv chil wcel vx cv cT cfv cno cfv cr wcel vx cv cno cfv c1 cle wbr
      vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp
      ffvelrni vx cv cT cfv normcl syl adantr vx cv chil wcel cT cnop cfv vx cv
      cno cfv cmul co cr wcel vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv
      cno cfv cr wcel cT cnop cfv vx cv cno cfv cmul co cr wcel vx cv normcl cT
      cnop cfv cr wcel vx cv cno cfv cr wcel cT cnop cfv vx cv cno cfv cmul co
      cr wcel cT cbo wcel cT cnop cfv cr wcel nmopcoadj.1 cT nmopre ax-mp cT
      cnop cfv vx cv cno cfv remulcl mpan syl adantr cT cnop cfv cr wcel vx cv
      chil wcel vx cv cno cfv c1 cle wbr wa cT cbo wcel cT cnop cfv cr wcel
      nmopcoadj.1 cT nmopre ax-mp a1i vx cv chil wcel vx cv cT cfv cno cfv cT
      cnop cfv vx cv cno cfv cmul co cle wbr vx cv cno cfv c1 cle wbr vx cv cT
      nmopcoadj.1 nmbdoplbi adantr vx cv chil wcel vx cv cno cfv c1 cle wbr wa
      cT cnop cfv vx cv cno cfv cmul co cT cnop cfv c1 cmul co cT cnop cfv cle
      vx cv cno cfv cr wcel vx cv cno cfv c1 cle wbr cT cnop cfv vx cv cno cfv
      cmul co cT cnop cfv c1 cmul co cle wbr vx cv chil wcel vx cv cno cfv cr
      wcel c1 cr wcel vx cv cno cfv c1 cle wbr cT cnop cfv vx cv cno cfv cmul
      co cT cnop cfv c1 cmul co cle wbr 1re vx cv cno cfv cr wcel c1 cr wcel cT
      cnop cfv cr wcel vx cv cno cfv c1 cle wbr cT cnop cfv vx cv cno cfv cmul
      co cT cnop cfv c1 cmul co cle wbr cT cbo wcel cT cnop cfv cr wcel
      nmopcoadj.1 cT nmopre ax-mp vx cv cno cfv cr wcel c1 cr wcel cT cnop cfv
      cr wcel w3a cc0 cT cnop cfv cle wbr vx cv cno cfv c1 cle wbr cT cnop cfv
      vx cv cno cfv cmul co cT cnop cfv c1 cmul co cle wbr chil chil cT wf cc0
      cT cnop cfv cle wbr cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf
      ax-mp cT nmopge0 ax-mp vx cv cno cfv c1 cT cnop cfv lemul2aOLD mpanr1
      mp3anl3 mpanl2 vx cv normcl sylan cT cnop cfv cT cnop cfv cT cbo wcel cT
      cnop cfv cr wcel nmopcoadj.1 cT nmopre ax-mp recni mulid1i syl6breq letrd
      sylanc letrd eqbrtrd cT cado cfv cnop cfv cT cnop cfv cmul co cT cnop cfv
      cT cnop cfv cmul co cT cnop cfv c2 cexp co cT cado cfv cnop cfv cT cnop
      cfv cT cnop cfv cmul cT nmopcoadj.1 nmopadji opreq1i cT cnop cfv cT cnop
      cfv cT cbo wcel cT cnop cfv cr wcel nmopcoadj.1 cT nmopre ax-mp recni
      sqvali eqtr4i syl6breq ex rgen vx cT cnop cfv c2 cexp co cT cado cfv cT
      ccom nmopub mp3an cT cnop cfv c2 cexp co cT cado cfv cT ccom cnop cfv
      csqr cfv c2 cexp co cT cado cfv cT ccom cnop cfv cle cT cnop cfv cT cado
      cfv cT ccom cnop cfv csqr cfv cle wbr cT cnop cfv c2 cexp co cT cado cfv
      cT ccom cnop cfv csqr cfv c2 cexp co cle wbr chil chil cT wf cT cado cfv
      cT ccom cnop cfv csqr cfv cxr wcel vx cv cno cfv c1 cle wbr vx cv cT cfv
      cno cfv cT cado cfv cT ccom cnop cfv csqr cfv cle wbr wi vx chil wral cT
      cnop cfv cT cado cfv cT ccom cnop cfv csqr cfv cle wbr cT cbo wcel chil
      chil cT wf nmopcoadj.1 cT bdopf ax-mp cT cado cfv cT ccom cnop cfv csqr
      cfv cr wcel cT cado cfv cT ccom cnop cfv csqr cfv cxr wcel cc0 cT cado
      cfv cT ccom cnop cfv cle wbr cT cado cfv cT ccom cnop cfv csqr cfv cr
      wcel chil chil cT cado cfv cT ccom wf cc0 cT cado cfv cT ccom cnop cfv
      cle wbr cT cado cfv cT cT cado cfv cbo wcel chil chil cT cado cfv wf cT
      cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv
      bdopf ax-mp cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp hocofi
      cT cado cfv cT ccom nmopge0 ax-mp cT cado cfv cT ccom cnop cfv cT cado
      cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT cado cfv cT
      cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi nmopcoadj.1
      bdopcoi cT cado cfv cT ccom nmopre ax-mp sqrcli ax-mp cT cado cfv cT ccom
      cnop cfv csqr cfv rexr ax-mp vx cv cno cfv c1 cle wbr vx cv cT cfv cno
      cfv cT cado cfv cT ccom cnop cfv csqr cfv cle wbr wi vx chil vx cv chil
      wcel vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cT cado cfv cT ccom
      cnop cfv csqr cfv cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx
      cv cT cfv cno cfv cT cado cfv cT ccom cnop cfv csqr cfv cle wbr vx cv cT
      cfv cno cfv c2 cexp co cT cado cfv cT ccom cnop cfv csqr cfv c2 cexp co
      cle wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cT cado
      cfv cfv vx cv csp co cabs cfv cT cado cfv cT ccom cnop cfv vx cv cT cfv
      cno cfv c2 cexp co cT cado cfv cT ccom cnop cfv csqr cfv c2 cexp co cle
      vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cT cado cfv cfv
      vx cv csp co cabs cfv vx cv cT cfv cT cado cfv cfv cno cfv vx cv cno cfv
      cmul co cT cado cfv cT ccom cnop cfv vx cv chil wcel vx cv cT cfv cT cado
      cfv cfv vx cv csp co cabs cfv cr wcel vx cv cno cfv c1 cle wbr vx cv chil
      wcel vx cv cT cfv cT cado cfv cfv vx cv csp co cc wcel vx cv cT cfv cT
      cado cfv cfv vx cv csp co cabs cfv cr wcel vx cv cT cfv cT cado cfv cfv
      chil wcel vx cv chil wcel vx cv cT cfv cT cado cfv cfv vx cv csp co cc
      wcel vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cT cado cfv cfv
      chil wcel chil chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT
      bdopf ax-mp ffvelrni chil chil vx cv cT cfv cT cado cfv cT cado cfv cbo
      wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni syl vx cv
      cT cfv cT cado cfv cfv vx cv hicl mpancom vx cv cT cfv cT cado cfv cfv vx
      cv csp co abscl syl adantr vx cv chil wcel vx cv cT cfv cT cado cfv cfv
      cno cfv vx cv cno cfv cmul co cr wcel vx cv cno cfv c1 cle wbr vx cv cT
      cfv cT cado cfv cfv cno cfv cr wcel vx cv cno cfv cr wcel vx cv cT cfv cT
      cado cfv cfv cno cfv vx cv cno cfv cmul co cr wcel vx cv chil wcel vx cv
      cT cfv cT cado cfv cfv cno cfv vx cv cno cfv remulcl vx cv chil wcel vx
      cv cT cfv cT cado cfv cfv chil wcel vx cv cT cfv cT cado cfv cfv cno cfv
      cr wcel vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cT cado cfv
      cfv chil wcel chil chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1
      cT bdopf ax-mp ffvelrni chil chil vx cv cT cfv cT cado cfv cT cado cfv
      cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni syl vx cv
      cT cfv cT cado cfv cfv normcl syl vx cv normcl sylanc adantr cT cado cfv
      cT ccom cnop cfv cr wcel vx cv chil wcel vx cv cno cfv c1 cle wbr wa cT
      cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT cado
      cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp a1i vx cv chil wcel
      vx cv cT cfv cT cado cfv cfv vx cv csp co cabs cfv vx cv cT cfv cT cado
      cfv cfv cno cfv vx cv cno cfv cmul co cle wbr vx cv cno cfv c1 cle wbr vx
      cv cT cfv cT cado cfv cfv chil wcel vx cv chil wcel vx cv cT cfv cT cado
      cfv cfv vx cv csp co cabs cfv vx cv cT cfv cT cado cfv cfv cno cfv vx cv
      cno cfv cmul co cle wbr vx cv chil wcel vx cv cT cfv chil wcel vx cv cT
      cfv cT cado cfv cfv chil wcel chil chil vx cv cT cT cbo wcel chil chil cT
      wf nmopcoadj.1 cT bdopf ax-mp ffvelrni chil chil vx cv cT cfv cT cado cfv
      cT cado cfv cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo
      wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni syl vx
      cv cT cfv cT cado cfv cfv vx cv bcs mpancom adantr vx cv chil wcel vx cv
      cno cfv c1 cle wbr wa vx cv cT cfv cT cado cfv cfv cno cfv vx cv cno cfv
      cmul co vx cv cT cado cfv cT ccom cfv cno cfv cT cado cfv cT ccom cnop
      cfv vx cv chil wcel vx cv cT cfv cT cado cfv cfv cno cfv vx cv cno cfv
      cmul co cr wcel vx cv cno cfv c1 cle wbr vx cv cT cfv cT cado cfv cfv cno
      cfv cr wcel vx cv cno cfv cr wcel vx cv cT cfv cT cado cfv cfv cno cfv vx
      cv cno cfv cmul co cr wcel vx cv chil wcel vx cv cT cfv cT cado cfv cfv
      cno cfv vx cv cno cfv remulcl vx cv chil wcel vx cv cT cfv cT cado cfv
      cfv chil wcel vx cv cT cfv cT cado cfv cfv cno cfv cr wcel vx cv chil
      wcel vx cv cT cfv chil wcel vx cv cT cfv cT cado cfv cfv chil wcel chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp
      ffvelrni chil chil vx cv cT cfv cT cado cfv cT cado cfv cbo wcel chil
      chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni syl vx cv cT cfv cT cado
      cfv cfv normcl syl vx cv normcl sylanc adantr vx cv chil wcel vx cv cT
      cado cfv cT ccom cfv cno cfv cr wcel vx cv cno cfv c1 cle wbr vx cv chil
      wcel vx cv cT cado cfv cT ccom cfv chil wcel vx cv cT cado cfv cT ccom
      cfv cno cfv cr wcel vx cv cT cado cfv cT cT cado cfv cbo wcel chil chil
      cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb
      mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil chil cT wf nmopcoadj.1 cT
      bdopf ax-mp hococli vx cv cT cado cfv cT ccom cfv normcl syl adantr cT
      cado cfv cT ccom cnop cfv cr wcel vx cv chil wcel vx cv cno cfv c1 cle
      wbr wa cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel
      cT cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb
      mpbi nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp a1i vx cv chil
      wcel vx cv cno cfv c1 cle wbr wa vx cv cT cfv cT cado cfv cfv cno cfv vx
      cv cno cfv cmul co vx cv cT cfv cT cado cfv cfv cno cfv c1 cmul co vx cv
      cT cado cfv cT ccom cfv cno cfv cle vx cv cno cfv cr wcel vx cv cT cfv cT
      cado cfv cfv cno cfv cr wcel wa cc0 vx cv cT cfv cT cado cfv cfv cno cfv
      cle wbr vx cv cno cfv c1 cle wbr wa vx cv cT cfv cT cado cfv cfv cno cfv
      vx cv cno cfv cmul co vx cv cT cfv cT cado cfv cfv cno cfv c1 cmul co cle
      wbr vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cno cfv cr wcel c1
      cr wcel vx cv cT cfv cT cado cfv cfv cno cfv cr wcel cc0 vx cv cT cfv cT
      cado cfv cfv cno cfv cle wbr vx cv cno cfv c1 cle wbr wa vx cv cT cfv cT
      cado cfv cfv cno cfv vx cv cno cfv cmul co vx cv cT cfv cT cado cfv cfv
      cno cfv c1 cmul co cle wbr 1re vx cv cno cfv c1 vx cv cT cfv cT cado cfv
      cfv cno cfv lemul2aOLD mp3anl2 vx cv chil wcel vx cv cno cfv cr wcel vx
      cv cT cfv cT cado cfv cfv cno cfv cr wcel wa vx cv cno cfv c1 cle wbr vx
      cv chil wcel vx cv cno cfv cr wcel vx cv cT cfv cT cado cfv cfv cno cfv
      cr wcel vx cv normcl vx cv chil wcel vx cv cT cfv cT cado cfv cfv chil
      wcel vx cv cT cfv cT cado cfv cfv cno cfv cr wcel vx cv chil wcel vx cv
      cT cfv chil wcel vx cv cT cfv cT cado cfv cfv chil wcel chil chil vx cv
      cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp ffvelrni chil
      chil vx cv cT cfv cT cado cfv cT cado cfv cbo wcel chil chil cT cado cfv
      wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado
      cfv bdopf ax-mp ffvelrni syl vx cv cT cfv cT cado cfv cfv normcl syl jca
      adantr vx cv chil wcel cc0 vx cv cT cfv cT cado cfv cfv cno cfv cle wbr
      vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv cT cfv cT cado cfv cfv
      chil wcel cc0 vx cv cT cfv cT cado cfv cfv cno cfv cle wbr vx cv chil
      wcel vx cv cT cfv chil wcel vx cv cT cfv cT cado cfv cfv chil wcel chil
      chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp
      ffvelrni chil chil vx cv cT cfv cT cado cfv cT cado cfv cbo wcel chil
      chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni syl vx cv cT cfv cT cado
      cfv cfv normge0 syl anim1i sylanc vx cv chil wcel vx cv cT cfv cT cado
      cfv cfv cno cfv c1 cmul co vx cv cT cado cfv cT ccom cfv cno cfv wceq vx
      cv cno cfv c1 cle wbr vx cv chil wcel vx cv cT cfv cT cado cfv cfv cno
      cfv c1 cmul co vx cv cT cfv cT cado cfv cfv cno cfv vx cv cT cado cfv cT
      ccom cfv cno cfv vx cv chil wcel vx cv cT cfv cT cado cfv cfv cno cfv cc
      wcel vx cv cT cfv cT cado cfv cfv cno cfv c1 cmul co vx cv cT cfv cT cado
      cfv cfv cno cfv wceq vx cv chil wcel vx cv cT cfv cT cado cfv cfv cno cfv
      vx cv chil wcel vx cv cT cfv cT cado cfv cfv chil wcel vx cv cT cfv cT
      cado cfv cfv cno cfv cr wcel vx cv chil wcel vx cv cT cfv chil wcel vx cv
      cT cfv cT cado cfv cfv chil wcel chil chil vx cv cT cT cbo wcel chil chil
      cT wf nmopcoadj.1 cT bdopf ax-mp ffvelrni chil chil vx cv cT cfv cT cado
      cfv cT cado cfv cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv
      cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp ffvelrni
      syl vx cv cT cfv cT cado cfv cfv normcl syl recnd vx cv cT cfv cT cado
      cfv cfv cno cfv ax1id syl vx cv chil wcel vx cv cT cado cfv cT ccom cfv
      vx cv cT cfv cT cado cfv cfv cno vx cv cT cado cfv cT cT cado cfv cbo
      wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil
      chil cT wf nmopcoadj.1 cT bdopf ax-mp hocoi fveq2d eqtr4d adantr breqtrd
      vx cv chil wcel vx cv cno cfv c1 cle wbr wa vx cv cT cado cfv cT ccom cfv
      cno cfv cT cado cfv cT ccom cnop cfv vx cv cno cfv cmul co cT cado cfv cT
      ccom cnop cfv vx cv chil wcel vx cv cT cado cfv cT ccom cfv cno cfv cr
      wcel vx cv cno cfv c1 cle wbr vx cv chil wcel vx cv cT cado cfv cT ccom
      cfv chil wcel vx cv cT cado cfv cT ccom cfv cno cfv cr wcel vx cv cT cado
      cfv cT cT cado cfv cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado
      cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo
      wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp hococli vx cv cT cado cfv
      cT ccom cfv normcl syl adantr vx cv chil wcel cT cado cfv cT ccom cnop
      cfv vx cv cno cfv cmul co cr wcel vx cv cno cfv c1 cle wbr vx cv chil
      wcel vx cv cno cfv cr wcel cT cado cfv cT ccom cnop cfv vx cv cno cfv
      cmul co cr wcel vx cv normcl cT cado cfv cT ccom cnop cfv cr wcel vx cv
      cno cfv cr wcel cT cado cfv cT ccom cnop cfv vx cv cno cfv cmul co cr
      wcel cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT
      cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp cT cado cfv cT ccom
      cnop cfv vx cv cno cfv remulcl mpan syl adantr cT cado cfv cT ccom cnop
      cfv cr wcel vx cv chil wcel vx cv cno cfv c1 cle wbr wa cT cado cfv cT
      ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT cado cfv cT cT cbo
      wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi nmopcoadj.1
      bdopcoi cT cado cfv cT ccom nmopre ax-mp a1i vx cv chil wcel vx cv cT
      cado cfv cT ccom cfv cno cfv cT cado cfv cT ccom cnop cfv vx cv cno cfv
      cmul co cle wbr vx cv cno cfv c1 cle wbr vx cv cT cado cfv cT ccom cT
      cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      nmopcoadj.1 bdopcoi nmbdoplbi adantr vx cv chil wcel vx cv cno cfv c1 cle
      wbr wa cT cado cfv cT ccom cnop cfv vx cv cno cfv cmul co cT cado cfv cT
      ccom cnop cfv c1 cmul co cT cado cfv cT ccom cnop cfv cle vx cv cno cfv
      cr wcel vx cv cno cfv c1 cle wbr cT cado cfv cT ccom cnop cfv vx cv cno
      cfv cmul co cT cado cfv cT ccom cnop cfv c1 cmul co cle wbr vx cv chil
      wcel vx cv cno cfv cr wcel cc0 cT cado cfv cT ccom cnop cfv cle wbr vx cv
      cno cfv c1 cle wbr cT cado cfv cT ccom cnop cfv vx cv cno cfv cmul co cT
      cado cfv cT ccom cnop cfv c1 cmul co cle wbr chil chil cT cado cfv cT
      ccom wf cc0 cT cado cfv cT ccom cnop cfv cle wbr cT cado cfv cT cT cado
      cfv cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil
      chil cT wf nmopcoadj.1 cT bdopf ax-mp hocofi cT cado cfv cT ccom nmopge0
      ax-mp vx cv cno cfv cr wcel c1 cr wcel cc0 cT cado cfv cT ccom cnop cfv
      cle wbr vx cv cno cfv c1 cle wbr wa cT cado cfv cT ccom cnop cfv vx cv
      cno cfv cmul co cT cado cfv cT ccom cnop cfv c1 cmul co cle wbr 1re vx cv
      cno cfv cr wcel c1 cr wcel cT cado cfv cT ccom cnop cfv cr wcel cc0 cT
      cado cfv cT ccom cnop cfv cle wbr vx cv cno cfv c1 cle wbr wa cT cado cfv
      cT ccom cnop cfv vx cv cno cfv cmul co cT cado cfv cT ccom cnop cfv c1
      cmul co cle wbr cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv
      cr wcel cT cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT
      adjbdlnb mpbi nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp vx cv
      cno cfv c1 cT cado cfv cT ccom cnop cfv lemul2aOLD mp3anl3 mpanl2 mpanr1
      vx cv normcl sylan cT cado cfv cT ccom cnop cfv cT cado cfv cT ccom cnop
      cfv cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT
      cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp recni mulid1i
      syl6breq letrd letrd letrd vx cv chil wcel vx cv cT cfv cno cfv c2 cexp
      co vx cv cT cfv cT cado cfv cfv vx cv csp co cabs cfv wceq vx cv cno cfv
      c1 cle wbr vx cv chil wcel vx cv cT cfv cno cfv c2 cexp co cabs cfv vx cv
      cT cfv cno cfv c2 cexp co vx cv cT cfv cT cado cfv cfv vx cv csp co cabs
      cfv vx cv chil wcel vx cv cT cfv cno cfv cr wcel vx cv cT cfv cno cfv c2
      cexp co cabs cfv vx cv cT cfv cno cfv c2 cexp co wceq vx cv chil wcel vx
      cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv cT cT
      cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp ffvelrni vx cv cT cfv
      normcl syl vx cv cT cfv cno cfv c2 cexp co cr wcel cc0 vx cv cT cfv cno
      cfv c2 cexp co cle wbr vx cv cT cfv cno cfv c2 cexp co cabs cfv vx cv cT
      cfv cno cfv c2 cexp co wceq vx cv cT cfv cno cfv cr wcel vx cv cT cfv cno
      cfv c2 cexp co absid vx cv cT cfv cno cfv resqcl vx cv cT cfv cno cfv
      sqge0 sylanc syl vx cv chil wcel vx cv cT cfv cno cfv c2 cexp co vx cv cT
      cfv cT cado cfv cfv vx cv csp co cabs vx cv chil wcel vx cv cT cfv cno
      cfv c2 cexp co vx cv cT cfv vx cv cT cfv csp co vx cv cT cfv cT cado cfv
      cfv vx cv csp co vx cv chil wcel vx cv cT cfv chil wcel vx cv cT cfv cno
      cfv c2 cexp co vx cv cT cfv vx cv cT cfv csp co wceq chil chil vx cv cT
      cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp ffvelrni vx cv cT
      cfv normsq syl vx cv chil wcel vx cv cT cfv cT cado cfv cfv vx cv csp co
      vx cv cT cfv vx cv cT cado cfv cado cfv cfv csp co vx cv cT cfv vx cv cT
      cfv csp co vx cv cT cfv chil wcel vx cv chil wcel vx cv cT cfv cT cado
      cfv cfv vx cv csp co vx cv cT cfv vx cv cT cado cfv cado cfv cfv csp co
      wceq chil chil vx cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf
      ax-mp ffvelrni cT cado cfv cado cdm wcel vx cv cT cfv chil wcel vx cv
      chil wcel vx cv cT cfv cT cado cfv cfv vx cv csp co vx cv cT cfv vx cv cT
      cado cfv cado cfv cfv csp co wceq cT cado cfv cbo wcel cT cado cfv cado
      cdm wcel cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT
      cado cfv bdopadj ax-mp vx cv cT cfv vx cv cT cado cfv adj2 mp3an1 mpancom
      vx cv cT cado cfv cado cfv cfv vx cv cT cfv vx cv cT cfv csp vx cv cT
      cado cfv cado cfv cT cT cado cdm wcel cT cado cfv cado cfv cT wceq cT cbo
      wcel cT cado cdm wcel nmopcoadj.1 cT bdopadj ax-mp cT adjadj ax-mp fveq1i
      opreq2i syl6req eqtrd fveq2d eqtr3d adantr cT cado cfv cT ccom cnop cfv
      csqr cfv c2 cexp co cT cado cfv cT ccom cnop cfv wceq vx cv chil wcel vx
      cv cno cfv c1 cle wbr wa cc0 cT cado cfv cT ccom cnop cfv cle wbr cT cado
      cfv cT ccom cnop cfv csqr cfv c2 cexp co cT cado cfv cT ccom cnop cfv
      wceq chil chil cT cado cfv cT ccom wf cc0 cT cado cfv cT ccom cnop cfv
      cle wbr cT cado cfv cT cT cado cfv cbo wcel chil chil cT cado cfv wf cT
      cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv
      bdopf ax-mp cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp hocofi
      cT cado cfv cT ccom nmopge0 ax-mp cT cado cfv cT ccom cnop cfv cT cado
      cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT cado cfv cT
      cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi nmopcoadj.1
      bdopcoi cT cado cfv cT ccom nmopre ax-mp sqsqri ax-mp a1i 3brtr4d vx cv
      chil wcel vx cv cT cfv cno cfv cT cado cfv cT ccom cnop cfv csqr cfv cle
      wbr vx cv cT cfv cno cfv c2 cexp co cT cado cfv cT ccom cnop cfv csqr cfv
      c2 cexp co cle wbr wb vx cv cno cfv c1 cle wbr vx cv cT cfv cno cfv cr
      wcel cc0 vx cv cT cfv cno cfv cle wbr vx cv cT cfv cno cfv cT cado cfv cT
      ccom cnop cfv csqr cfv cle wbr vx cv cT cfv cno cfv c2 cexp co cT cado
      cfv cT ccom cnop cfv csqr cfv c2 cexp co cle wbr wb vx cv chil wcel vx cv
      cT cfv cno cfv cr wcel cc0 vx cv cT cfv cno cfv cle wbr wa cT cado cfv cT
      ccom cnop cfv csqr cfv cr wcel cc0 cT cado cfv cT ccom cnop cfv csqr cfv
      cle wbr vx cv cT cfv cno cfv cT cado cfv cT ccom cnop cfv csqr cfv cle
      wbr vx cv cT cfv cno cfv c2 cexp co cT cado cfv cT ccom cnop cfv csqr cfv
      c2 cexp co cle wbr wb cc0 cT cado cfv cT ccom cnop cfv cle wbr cT cado
      cfv cT ccom cnop cfv csqr cfv cr wcel chil chil cT cado cfv cT ccom wf
      cc0 cT cado cfv cT ccom cnop cfv cle wbr cT cado cfv cT cT cado cfv cbo
      wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil
      chil cT wf nmopcoadj.1 cT bdopf ax-mp hocofi cT cado cfv cT ccom nmopge0
      ax-mp cT cado cfv cT ccom cnop cfv cT cado cfv cT ccom cbo wcel cT cado
      cfv cT ccom cnop cfv cr wcel cT cado cfv cT cT cbo wcel cT cado cfv cbo
      wcel nmopcoadj.1 cT adjbdlnb mpbi nmopcoadj.1 bdopcoi cT cado cfv cT ccom
      nmopre ax-mp sqrcli ax-mp cc0 cT cado cfv cT ccom cnop cfv cle wbr cc0 cT
      cado cfv cT ccom cnop cfv csqr cfv cle wbr chil chil cT cado cfv cT ccom
      wf cc0 cT cado cfv cT ccom cnop cfv cle wbr cT cado cfv cT cT cado cfv
      cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil
      chil cT wf nmopcoadj.1 cT bdopf ax-mp hocofi cT cado cfv cT ccom nmopge0
      ax-mp cT cado cfv cT ccom cnop cfv cT cado cfv cT ccom cbo wcel cT cado
      cfv cT ccom cnop cfv cr wcel cT cado cfv cT cT cbo wcel cT cado cfv cbo
      wcel nmopcoadj.1 cT adjbdlnb mpbi nmopcoadj.1 bdopcoi cT cado cfv cT ccom
      nmopre ax-mp sqrge0i ax-mp vx cv cT cfv cno cfv cT cado cfv cT ccom cnop
      cfv csqr cfv le2sq mpanr12 vx cv chil wcel vx cv cT cfv chil wcel vx cv
      cT cfv cno cfv cr wcel chil chil vx cv cT cT cbo wcel chil chil cT wf
      nmopcoadj.1 cT bdopf ax-mp ffvelrni vx cv cT cfv normcl syl vx cv chil
      wcel vx cv cT cfv chil wcel cc0 vx cv cT cfv cno cfv cle wbr chil chil vx
      cv cT cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp ffvelrni vx
      cv cT cfv normge0 syl sylanc adantr mpbird ex rgen vx cT cado cfv cT ccom
      cnop cfv csqr cfv cT nmopub mp3an cc0 cT cnop cfv cle wbr cc0 cT cado cfv
      cT ccom cnop cfv csqr cfv cle wbr cT cnop cfv cT cado cfv cT ccom cnop
      cfv csqr cfv cle wbr cT cnop cfv c2 cexp co cT cado cfv cT ccom cnop cfv
      csqr cfv c2 cexp co cle wbr wb chil chil cT wf cc0 cT cnop cfv cle wbr cT
      cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf ax-mp cT nmopge0 ax-mp cc0
      cT cado cfv cT ccom cnop cfv cle wbr cc0 cT cado cfv cT ccom cnop cfv
      csqr cfv cle wbr chil chil cT cado cfv cT ccom wf cc0 cT cado cfv cT ccom
      cnop cfv cle wbr cT cado cfv cT cT cado cfv cbo wcel chil chil cT cado
      cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi cT
      cado cfv bdopf ax-mp cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf
      ax-mp hocofi cT cado cfv cT ccom nmopge0 ax-mp cT cado cfv cT ccom cnop
      cfv cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT
      cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp sqrge0i ax-mp cT
      cnop cfv cT cado cfv cT ccom cnop cfv csqr cfv cT cbo wcel cT cnop cfv cr
      wcel nmopcoadj.1 cT nmopre ax-mp cc0 cT cado cfv cT ccom cnop cfv cle wbr
      cT cado cfv cT ccom cnop cfv csqr cfv cr wcel chil chil cT cado cfv cT
      ccom wf cc0 cT cado cfv cT ccom cnop cfv cle wbr cT cado cfv cT cT cado
      cfv cbo wcel chil chil cT cado cfv wf cT cbo wcel cT cado cfv cbo wcel
      nmopcoadj.1 cT adjbdlnb mpbi cT cado cfv bdopf ax-mp cT cbo wcel chil
      chil cT wf nmopcoadj.1 cT bdopf ax-mp hocofi cT cado cfv cT ccom nmopge0
      ax-mp cT cado cfv cT ccom cnop cfv cT cado cfv cT ccom cbo wcel cT cado
      cfv cT ccom cnop cfv cr wcel cT cado cfv cT cT cbo wcel cT cado cfv cbo
      wcel nmopcoadj.1 cT adjbdlnb mpbi nmopcoadj.1 bdopcoi cT cado cfv cT ccom
      nmopre ax-mp sqrcli ax-mp le2sqi mp2an mpbi cc0 cT cado cfv cT ccom cnop
      cfv cle wbr cT cado cfv cT ccom cnop cfv csqr cfv c2 cexp co cT cado cfv
      cT ccom cnop cfv wceq chil chil cT cado cfv cT ccom wf cc0 cT cado cfv cT
      ccom cnop cfv cle wbr cT cado cfv cT cT cado cfv cbo wcel chil chil cT
      cado cfv wf cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      cT cado cfv bdopf ax-mp cT cbo wcel chil chil cT wf nmopcoadj.1 cT bdopf
      ax-mp hocofi cT cado cfv cT ccom nmopge0 ax-mp cT cado cfv cT ccom cnop
      cfv cT cado cfv cT ccom cbo wcel cT cado cfv cT ccom cnop cfv cr wcel cT
      cado cfv cT cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdlnb mpbi
      nmopcoadj.1 bdopcoi cT cado cfv cT ccom nmopre ax-mp sqsqri ax-mp breqtri
      mpbir2an $.
      $( [13-Jun-2006] $) $( [8-Mar-2006] $)

    $( The norm of an operator composed with its adjoint.  Part of Theorem
       3.11(vi) of [Beran] p. 106. $)
    nmopcoadj2i $p |- ( normop ` ( T o. ( adjh ` T ) ) )
                    = ( ( normop ` T ) ^ 2 ) $=
      cT cado cfv cado cfv cT cado cfv ccom cnop cfv cT cado cfv cnop cfv c2
      cexp co cT cT cado cfv ccom cnop cfv cT cnop cfv c2 cexp co cT cado cfv
      cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdln ax-mp nmopcoadji
      cT cado cfv cado cfv cT cado cfv ccom cT cT cado cfv ccom cnop cT cado
      cfv cado cfv cT cT cado cfv cT cado cdm wcel cT cado cfv cado cfv cT wceq
      cT cbo wcel cT cado cdm wcel nmopcoadj.1 cT bdopadj ax-mp cT adjadj ax-mp
      coeq1i fveq2i cT cado cfv cnop cfv cT cnop cfv c2 cexp cT nmopcoadj.1
      nmopadji opreq1i 3eqtr3i $.
      $( [14-Jun-2006] $) $( [10-Mar-2006] $)

    $( An operator composed with its adjoint is zero iff the operator is zero.
       Theorem 3.11(vii) of [Beran] p. 106. $)
    nmopcoadj0i $p |- ( ( T o. ( adjh ` T ) ) = 0hop <-> T = 0hop ) $=
      cT cT cado cfv ccom cnop cfv cc0 wceq cT cnop cfv cc0 wceq cT cT cado cfv
      ccom ch0o wceq cT ch0o wceq cT cT cado cfv ccom cnop cfv cc0 wceq cT cnop
      cfv c2 cexp co cc0 wceq cT cnop cfv cc0 wceq cT cT cado cfv ccom cnop cfv
      cT cnop cfv c2 cexp co cc0 cT nmopcoadj.1 nmopcoadj2i eqeq1i cT cnop cfv
      cT cnop cfv cT cbo wcel cT cnop cfv cr wcel nmopcoadj.1 cT nmopre ax-mp
      recni sqeq0i bitri cT cT cado cfv ccom cT cT cado cfv cT cbo wcel cT clo
      wcel nmopcoadj.1 cT bdopln ax-mp cT cado cfv cbo wcel cT cado cfv clo
      wcel cT cbo wcel cT cado cfv cbo wcel nmopcoadj.1 cT adjbdln ax-mp cT
      cado cfv bdopln ax-mp lnopcoi nmlnop0iHIL cT cT cbo wcel cT clo wcel
      nmopcoadj.1 cT bdopln ax-mp nmlnop0iHIL 3bitr3i $.
      $( [2-Jul-2008] $) $( [10-Mar-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Quantum computation error bound theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    unierr.1 $e |- F e. UniOp $.
    unierr.2 $e |- G e. UniOp $.
    unierr.3 $e |- S e. UniOp $.
    unierr.4 $e |- T e. UniOp $.
    $( If we approximate a chain of unitary transformations (quantum computer
       gates) ` F ` , ` G ` by other unitary transformations ` S ` , ` T ` ,
       the error increases at most additively.  Equation 4.73 of
       [NielsenChuang] p. 195. $)
    unierri $p |- ( normop ` (  ( F o. G ) -op ( S o. T ) ) ) <_
                 ( ( normop ` ( F -op S ) ) + ( normop ` ( G -op T ) ) ) $=
      cF cG ccom cS cT ccom chod co cnop cfv cF cS chod co cnop cfv cG cT chod
      co cnop cfv caddc co cle wbr chil c0h chil c0h wceq cF cG ccom cS cT ccom
      chod co cnop cfv cc0 cF cS chod co cnop cfv cG cT chod co cnop cfv caddc
      co cle chil c0h wceq chil chil cF cG ccom cS cT ccom chod co wf cF cG
      ccom cS cT ccom chod co cnop cfv cc0 wceq cF cG ccom cS cT ccom cF cG cF
      cbo wcel chil chil cF wf cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp
      cF bdopf ax-mp cG cbo wcel chil chil cG wf cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp cG bdopf ax-mp hocofi cS cT cS cbo wcel chil
      chil cS wf cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cS bdopf
      ax-mp cT cbo wcel chil chil cT wf cT cuo wcel cT cbo wcel unierr.4 cT
      unopbd ax-mp cT bdopf ax-mp hocofi hosubcli cF cG ccom cS cT ccom chod co
      nmop0h mpan2 chil c0h wceq cc0 cc0 caddc co cF cS chod co cnop cfv cG cT
      chod co cnop cfv caddc co cc0 cle chil c0h wceq cF cS chod co cnop cfv
      cc0 cG cT chod co cnop cfv cc0 caddc chil c0h wceq chil chil cF cS chod
      co wf cF cS chod co cnop cfv cc0 wceq cF cS cF cbo wcel chil chil cF wf
      cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp cF bdopf ax-mp cS cbo
      wcel chil chil cS wf cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cS
      bdopf ax-mp hosubcli cF cS chod co nmop0h mpan2 chil c0h wceq chil chil
      cG cT chod co wf cG cT chod co cnop cfv cc0 wceq cG cT cG cbo wcel chil
      chil cG wf cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp cG bdopf
      ax-mp cT cbo wcel chil chil cT wf cT cuo wcel cT cbo wcel unierr.4 cT
      unopbd ax-mp cT bdopf ax-mp hosubcli cG cT chod co nmop0h mpan2 opreq12d
      cc0 cc0 cc0 cc0 caddc co cle cc0 0re leidi cc0 0cn addid1i breqtrri
      syl5breqr eqbrtrd chil c0h wne cF cS chod co cnop cfv cG cnop cfv cmul co
      cS cnop cfv cG cT chod co cnop cfv cmul co caddc co cF cS chod co cnop
      cfv cG cT chod co cnop cfv caddc co cF cG ccom cS cT ccom chod co cnop
      cfv cle chil c0h wne cF cS chod co cnop cfv cG cnop cfv cmul co cF cS
      chod co cnop cfv cS cnop cfv cG cT chod co cnop cfv cmul co cG cT chod co
      cnop cfv caddc chil c0h wne cF cS chod co cnop cfv cG cnop cfv cmul co cF
      cS chod co cnop cfv c1 cmul co cF cS chod co cnop cfv chil c0h wne cG
      cnop cfv c1 cF cS chod co cnop cfv cmul chil c0h wne cG cuo wcel cG cnop
      cfv c1 wceq unierr.2 cG nmopun mpan2 opreq2d cF cS chod co cnop cfv cF cS
      chod co cnop cfv cF cS chod co cbo wcel cF cS chod co cnop cfv cr wcel cF
      cS cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp cS cuo wcel cS cbo
      wcel unierr.3 cS unopbd ax-mp bdophdi cF cS chod co nmopre ax-mp recni
      mulid1i syl6eq chil c0h wne cS cnop cfv cG cT chod co cnop cfv cmul co c1
      cG cT chod co cnop cfv cmul co cG cT chod co cnop cfv chil c0h wne cS
      cnop cfv c1 cG cT chod co cnop cfv cmul chil c0h wne cS cuo wcel cS cnop
      cfv c1 wceq unierr.3 cS nmopun mpan2 opreq1d cG cT chod co cnop cfv cG cT
      chod co cnop cfv cG cT chod co cbo wcel cG cT chod co cnop cfv cr wcel cG
      cT cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp cT cuo wcel cT cbo
      wcel unierr.4 cT unopbd ax-mp bdophdi cG cT chod co nmopre ax-mp recni
      mulid2i syl6eq opreq12d cF cG ccom cS cG ccom chod co cS cG ccom cS cT
      ccom chod co chos co cnop cfv cF cG ccom cS cT ccom chod co cnop cfv cF
      cS chod co cnop cfv cG cnop cfv cmul co cS cnop cfv cG cT chod co cnop
      cfv cmul co caddc co cle cF cG ccom cS cG ccom chod co cS cG ccom cS cT
      ccom chod co chos co cF cG ccom cS cT ccom chod co cnop cF cG ccom cS cG
      ccom cS cT ccom cF cG cF cbo wcel chil chil cF wf cF cuo wcel cF cbo wcel
      unierr.1 cF unopbd ax-mp cF bdopf ax-mp cG cbo wcel chil chil cG wf cG
      cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp cG bdopf ax-mp hocofi cS cG
      cS cbo wcel chil chil cS wf cS cuo wcel cS cbo wcel unierr.3 cS unopbd
      ax-mp cS bdopf ax-mp cG cbo wcel chil chil cG wf cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp cG bdopf ax-mp hocofi cS cT cS cbo wcel chil
      chil cS wf cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cS bdopf
      ax-mp cT cbo wcel chil chil cT wf cT cuo wcel cT cbo wcel unierr.4 cT
      unopbd ax-mp cT bdopf ax-mp hocofi honpncani fveq2i cF cG ccom cS cG ccom
      chod co cS cG ccom cS cT ccom chod co chos co cnop cfv cF cG ccom cS cG
      ccom chod co cnop cfv cS cG ccom cS cT ccom chod co cnop cfv caddc co cle
      wbr cF cG ccom cS cG ccom chod co cnop cfv cS cG ccom cS cT ccom chod co
      cnop cfv caddc co cF cS chod co cnop cfv cG cnop cfv cmul co cS cnop cfv
      cG cT chod co cnop cfv cmul co caddc co cle wbr cF cG ccom cS cG ccom
      chod co cS cG ccom cS cT ccom chod co chos co cnop cfv cF cS chod co cnop
      cfv cG cnop cfv cmul co cS cnop cfv cG cT chod co cnop cfv cmul co caddc
      co cle wbr cF cG ccom cS cG ccom chod co cS cG ccom cS cT ccom chod co cF
      cG ccom cS cG ccom cF cG cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp
      cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp bdopcoi cS cG cS cuo
      wcel cS cbo wcel unierr.3 cS unopbd ax-mp cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp bdopcoi bdophdi cS cG ccom cS cT ccom cS cG cS
      cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp bdopcoi cS cT cS cuo wcel cS cbo wcel unierr.3
      cS unopbd ax-mp cT cuo wcel cT cbo wcel unierr.4 cT unopbd ax-mp bdopcoi
      bdophdi nmoptrii cF cG ccom cS cG ccom chod co cnop cfv cF cS chod co
      cnop cfv cG cnop cfv cmul co cle wbr cS cG ccom cS cT ccom chod co cnop
      cfv cS cnop cfv cG cT chod co cnop cfv cmul co cle wbr cF cG ccom cS cG
      ccom chod co cnop cfv cS cG ccom cS cT ccom chod co cnop cfv caddc co cF
      cS chod co cnop cfv cG cnop cfv cmul co cS cnop cfv cG cT chod co cnop
      cfv cmul co caddc co cle wbr cF cS chod co cG ccom cnop cfv cF cG ccom cS
      cG ccom chod co cnop cfv cF cS chod co cnop cfv cG cnop cfv cmul co cle
      cF cS chod co cG ccom cF cG ccom cS cG ccom chod co cnop cF cS cG cF cbo
      wcel chil chil cF wf cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp cF
      bdopf ax-mp cS cbo wcel chil chil cS wf cS cuo wcel cS cbo wcel unierr.3
      cS unopbd ax-mp cS bdopf ax-mp cG cbo wcel chil chil cG wf cG cuo wcel cG
      cbo wcel unierr.2 cG unopbd ax-mp cG bdopf ax-mp hocsubdiri fveq2i cF cS
      chod co cG cF cS cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp cS cuo
      wcel cS cbo wcel unierr.3 cS unopbd ax-mp bdophdi cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp nmopcoi eqbrtrri cS cG cT chod co ccom cnop cfv
      cS cG ccom cS cT ccom chod co cnop cfv cS cnop cfv cG cT chod co cnop cfv
      cmul co cle cS cG cT chod co ccom cS cG ccom cS cT ccom chod co cnop cS
      cG cT cS cbo wcel cS clo wcel cS cuo wcel cS cbo wcel unierr.3 cS unopbd
      ax-mp cS bdopln ax-mp cG cbo wcel chil chil cG wf cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp cG bdopf ax-mp cT cbo wcel chil chil cT wf cT
      cuo wcel cT cbo wcel unierr.4 cT unopbd ax-mp cT bdopf ax-mp hoddii
      fveq2i cS cG cT chod co cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp
      cG cT cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp cT cuo wcel cT cbo
      wcel unierr.4 cT unopbd ax-mp bdophdi nmopcoi eqbrtrri cF cG ccom cS cG
      ccom chod co cnop cfv cS cG ccom cS cT ccom chod co cnop cfv cF cS chod
      co cnop cfv cG cnop cfv cmul co cS cnop cfv cG cT chod co cnop cfv cmul
      co cF cG ccom cS cG ccom chod co cbo wcel cF cG ccom cS cG ccom chod co
      cnop cfv cr wcel cF cG ccom cS cG ccom cF cG cF cuo wcel cF cbo wcel
      unierr.1 cF unopbd ax-mp cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp
      bdopcoi cS cG cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cG cuo
      wcel cG cbo wcel unierr.2 cG unopbd ax-mp bdopcoi bdophdi cF cG ccom cS
      cG ccom chod co nmopre ax-mp cS cG ccom cS cT ccom chod co cbo wcel cS cG
      ccom cS cT ccom chod co cnop cfv cr wcel cS cG ccom cS cT ccom cS cG cS
      cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp bdopcoi cS cT cS cuo wcel cS cbo wcel unierr.3
      cS unopbd ax-mp cT cuo wcel cT cbo wcel unierr.4 cT unopbd ax-mp bdopcoi
      bdophdi cS cG ccom cS cT ccom chod co nmopre ax-mp cF cS chod co cnop cfv
      cG cnop cfv cF cS chod co cbo wcel cF cS chod co cnop cfv cr wcel cF cS
      cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp cS cuo wcel cS cbo wcel
      unierr.3 cS unopbd ax-mp bdophdi cF cS chod co nmopre ax-mp cG cbo wcel
      cG cnop cfv cr wcel cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp cG
      nmopre ax-mp remulcli cS cnop cfv cG cT chod co cnop cfv cS cbo wcel cS
      cnop cfv cr wcel cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cS
      nmopre ax-mp cG cT chod co cbo wcel cG cT chod co cnop cfv cr wcel cG cT
      cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp cT cuo wcel cT cbo wcel
      unierr.4 cT unopbd ax-mp bdophdi cG cT chod co nmopre ax-mp remulcli
      le2addi mp2an cF cG ccom cS cG ccom chod co cS cG ccom cS cT ccom chod co
      chos co cnop cfv cF cG ccom cS cG ccom chod co cnop cfv cS cG ccom cS cT
      ccom chod co cnop cfv caddc co cF cS chod co cnop cfv cG cnop cfv cmul co
      cS cnop cfv cG cT chod co cnop cfv cmul co caddc co cF cG ccom cS cG ccom
      chod co cS cG ccom cS cT ccom chod co chos co cbo wcel cF cG ccom cS cG
      ccom chod co cS cG ccom cS cT ccom chod co chos co cnop cfv cr wcel cF cG
      ccom cS cG ccom chod co cS cG ccom cS cT ccom chod co cF cG ccom cS cG
      ccom cF cG cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp cG cuo wcel
      cG cbo wcel unierr.2 cG unopbd ax-mp bdopcoi cS cG cS cuo wcel cS cbo
      wcel unierr.3 cS unopbd ax-mp cG cuo wcel cG cbo wcel unierr.2 cG unopbd
      ax-mp bdopcoi bdophdi cS cG ccom cS cT ccom cS cG cS cuo wcel cS cbo wcel
      unierr.3 cS unopbd ax-mp cG cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp
      bdopcoi cS cT cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cT cuo
      wcel cT cbo wcel unierr.4 cT unopbd ax-mp bdopcoi bdophdi bdophsi cF cG
      ccom cS cG ccom chod co cS cG ccom cS cT ccom chod co chos co nmopre
      ax-mp cF cG ccom cS cG ccom chod co cnop cfv cS cG ccom cS cT ccom chod
      co cnop cfv cF cG ccom cS cG ccom chod co cbo wcel cF cG ccom cS cG ccom
      chod co cnop cfv cr wcel cF cG ccom cS cG ccom cF cG cF cuo wcel cF cbo
      wcel unierr.1 cF unopbd ax-mp cG cuo wcel cG cbo wcel unierr.2 cG unopbd
      ax-mp bdopcoi cS cG cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cG
      cuo wcel cG cbo wcel unierr.2 cG unopbd ax-mp bdopcoi bdophdi cF cG ccom
      cS cG ccom chod co nmopre ax-mp cS cG ccom cS cT ccom chod co cbo wcel cS
      cG ccom cS cT ccom chod co cnop cfv cr wcel cS cG ccom cS cT ccom cS cG
      cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp bdopcoi cS cT cS cuo wcel cS cbo wcel unierr.3
      cS unopbd ax-mp cT cuo wcel cT cbo wcel unierr.4 cT unopbd ax-mp bdopcoi
      bdophdi cS cG ccom cS cT ccom chod co nmopre ax-mp readdcli cF cS chod co
      cnop cfv cG cnop cfv cmul co cS cnop cfv cG cT chod co cnop cfv cmul co
      cF cS chod co cnop cfv cG cnop cfv cF cS chod co cbo wcel cF cS chod co
      cnop cfv cr wcel cF cS cF cuo wcel cF cbo wcel unierr.1 cF unopbd ax-mp
      cS cuo wcel cS cbo wcel unierr.3 cS unopbd ax-mp bdophdi cF cS chod co
      nmopre ax-mp cG cbo wcel cG cnop cfv cr wcel cG cuo wcel cG cbo wcel
      unierr.2 cG unopbd ax-mp cG nmopre ax-mp remulcli cS cnop cfv cG cT chod
      co cnop cfv cS cbo wcel cS cnop cfv cr wcel cS cuo wcel cS cbo wcel
      unierr.3 cS unopbd ax-mp cS nmopre ax-mp cG cT chod co cbo wcel cG cT
      chod co cnop cfv cr wcel cG cT cG cuo wcel cG cbo wcel unierr.2 cG unopbd
      ax-mp cT cuo wcel cT cbo wcel unierr.4 cT unopbd ax-mp bdophdi cG cT chod
      co nmopre ax-mp remulcli readdcli letri mp2an eqbrtrri syl5breq pm2.61ine
      $.
      $( [2-Jun-2006] $) $( [10-Mar-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Dirac bra-ket notation (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x S $.
    $d t u x y T $.  $d t u x U $.  $d t x y z $.
    $( The norm of the bra function. $)
    branmfn $p |- ( A e. ~H -> ( normfn ` ( bra ` A ) ) = ( normh ` A ) ) $=
      cA chil wcel cA cbr cfv cnmf cfv cA cno cfv wceq c0v cbr cfv cnmf cfv c0v
      cno cfv wceq cA c0v cA c0v wceq cA cbr cfv cnmf cfv c0v cbr cfv cnmf cfv
      cA cno cfv c0v cno cfv cA c0v wceq cA cbr cfv c0v cbr cfv cnmf cA c0v cbr
      fveq2 fveq2d cA c0v cno fveq2 eqeq12d cA chil wcel cA c0v wne wa cA cbr
      cfv cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy chil wrex vx cab cxr clt csup cA cno cfv cA chil wcel cA cbr
      cfv cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy chil wrex vx cab cxr clt csup wceq cA c0v wne cA chil wcel
      chil cc cA cbr cfv wf cA cbr cfv cnmf cfv vy cv cno cfv c1 cle wbr vx cv
      vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup
      wceq cA brafn vx vy cA cbr cfv nmfnval syl adantr vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cxr
      wss cA cno cfv cxr wcel wa vz cv cA cno cfv cle wbr vz vy cv cno cfv c1
      cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab
      wral vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex
      wi vz cr wral wa vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs
      cfv wceq wa vy chil wrex vx cab cxr clt csup cA cno cfv wceq cA chil wcel
      cA c0v wne wa vz vw vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv
      cabs cfv wceq wa vy chil wrex vx cab cA cno cfv supxr2 cA chil wcel vy cv
      cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil
      wrex vx cab cxr wss cA cno cfv cxr wcel wa cA c0v wne cA chil wcel vy cv
      cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil
      wrex vx cab cxr wss cA cno cfv cxr wcel cA chil wcel vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cr
      cxr cA chil wcel chil cc cA cbr cfv wf vy cv cno cfv c1 cle wbr vx cv vy
      cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cr wss cA brafn vx
      vy cA cbr cfv nmfnsetre syl cr cxr wss cA chil wcel ressxr a1i sstrd cA
      chil wcel cA cno cfv cr wcel cA cno cfv cxr wcel cA normcl cA cno cfv
      rexr syl jca adantr cA chil wcel cA c0v wne wa vz cv cA cno cfv cle wbr
      vz vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa
      vy chil wrex vx cab wral vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw
      vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex vx cab wrex wi vz cr wral cA chil wcel vz cv cA cno cfv cle wbr
      vz vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa
      vy chil wrex vx cab wral cA c0v wne cA chil wcel vz cv cA cno cfv cle wbr
      vz vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa
      vy chil wrex vx cab cA chil wcel vy cv cno cfv c1 cle wbr vz cv vy cv cA
      cbr cfv cfv cabs cfv wceq wa vy chil wrex vz cv cA cno cfv cle wbr vz cv
      vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex vx cab wcel cA chil wcel vy cv cno cfv c1 cle wbr vz cv vy cv
      cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vz cv cA cno cfv cle wbr cA
      chil wcel vy cv cno cfv c1 cle wbr vz cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vz cv cA cno cfv cle wbr vy chil cA chil wcel vy cv chil wcel vy
      cv cno cfv c1 cle wbr vz cv vy cv cA cbr cfv cfv cabs cfv wceq vz cv cA
      cno cfv cle wbr cA chil wcel vy cv chil wcel vy cv cno cfv c1 cle wbr vz
      cv vy cv cA cbr cfv cfv cabs cfv wceq vz cv cA cno cfv cle wbr cA chil
      wcel vy cv chil wcel wa vy cv cno cfv c1 cle wbr wa vz cv vy cv cA cbr
      cfv cfv cabs cfv wceq wa vz cv vy cv cA csp co cabs cfv cA cno cfv cle vz
      cv vy cv cA cbr cfv cfv cabs cfv wceq cA chil wcel vy cv chil wcel wa vy
      cv cno cfv c1 cle wbr wa vz cv vy cv cA cbr cfv cfv cabs cfv vy cv cA csp
      co cabs cfv vz cv vy cv cA cbr cfv cfv cabs cfv wceq id cA chil wcel vy
      cv chil wcel wa vy cv cA cbr cfv cfv cabs cfv vy cv cA csp co cabs cfv
      wceq vy cv cno cfv c1 cle wbr cA chil wcel vy cv chil wcel wa vy cv cA
      cbr cfv cfv vy cv cA csp co cabs cA vy cv bravalval fveq2d adantr
      sylan9eqr cA chil wcel vy cv chil wcel wa vy cv cno cfv c1 cle wbr wa vy
      cv cA csp co cabs cfv cA cno cfv cle wbr vz cv vy cv cA cbr cfv cfv cabs
      cfv wceq vy cv chil wcel cA chil wcel vy cv cno cfv c1 cle wbr vy cv cA
      csp co cabs cfv cA cno cfv cle wbr vy cv chil wcel cA chil wcel vy cv cno
      cfv c1 cle wbr vy cv cA csp co cabs cfv cA cno cfv cle wbr vy cv cA bcs2
      3expa ancom1s adantr eqbrtrd exp41 imp4a r19.23adv imp vy cv cno cfv c1
      cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vy cv
      cno cfv c1 cle wbr vz cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil
      wrex vx vz cv vz visset vx cv vz cv wceq vy cv cno cfv c1 cle wbr vx cv
      vy cv cA cbr cfv cfv cabs cfv wceq wa vy cv cno cfv c1 cle wbr vz cv vy
      cv cA cbr cfv cfv cabs cfv wceq wa vy chil vx cv vz cv wceq vx cv vy cv
      cA cbr cfv cfv cabs cfv wceq vz cv vy cv cA cbr cfv cfv cabs cfv wceq vy
      cv cno cfv c1 cle wbr vx cv vz cv vy cv cA cbr cfv cfv cabs cfv eqeq1
      anbi2d rexbidv elab sylan2b r19.21aiva adantr cA chil wcel cA c0v wne wa
      vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr
      vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex wi
      vz cr cA chil wcel cA c0v wne wa vz cv cr wcel wa vz cv cA cno cfv clt
      wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr
      cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex cA chil wcel cA c0v wne
      wa vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex
      vz cv cr wcel cA cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv
      cfv cabs cfv wceq wa vy chil wrex vx cab wcel vz cv cA cno cfv clt wbr vz
      cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv
      cabs cfv wceq wa vy chil wrex vx cab wrex cA chil wcel cA c0v wne wa vz
      cv vw cv clt wbr vz cv cA cno cfv clt wbr vw cA cno cfv vy cv cno cfv c1
      cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab
      vw cv cA cno cfv vz cv clt breq2 rcla4ev cA chil wcel cA c0v wne wa vy cv
      cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex cA cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv
      cabs cfv wceq wa vy chil wrex vx cab wcel cA chil wcel cA c0v wne wa vy
      cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA csp co cabs cfv
      wceq wa vy chil wrex c1 cA cno cfv cdiv co cA csm co chil wcel c1 cA cno
      cfv cdiv co cA csm co cno cfv c1 cle wbr cA cno cfv c1 cA cno cfv cdiv co
      cA csm co cA csp co cabs cfv wceq wa vy cv cno cfv c1 cle wbr cA cno cfv
      vy cv cA csp co cabs cfv wceq wa vy chil wrex cA chil wcel cA c0v wne wa
      vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA csp co cabs cfv wceq wa c1
      cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr cA cno cfv c1 cA cno cfv
      cdiv co cA csm co cA csp co cabs cfv wceq wa vy c1 cA cno cfv cdiv co cA
      csm co chil vy cv c1 cA cno cfv cdiv co cA csm co wceq vy cv cno cfv c1
      cle wbr c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr cA cno cfv vy
      cv cA csp co cabs cfv wceq cA cno cfv c1 cA cno cfv cdiv co cA csm co cA
      csp co cabs cfv wceq vy cv c1 cA cno cfv cdiv co cA csm co wceq vy cv cno
      cfv c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle vy cv c1 cA cno cfv
      cdiv co cA csm co cno fveq2 breq1d vy cv c1 cA cno cfv cdiv co cA csm co
      wceq vy cv cA csp co cabs cfv c1 cA cno cfv cdiv co cA csm co cA csp co
      cabs cfv cA cno cfv vy cv c1 cA cno cfv cdiv co cA csm co wceq vy cv cA
      csp co c1 cA cno cfv cdiv co cA csm co cA csp co cabs vy cv c1 cA cno cfv
      cdiv co cA csm co cA csp opreq1 fveq2d eqeq2d anbi12d rcla4ev c1 cA cno
      cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co chil
      wcel cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA hvmulcl cA cno
      cfv cc wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil wcel
      cA c0v wne wa cA cno cfv reccl cA chil wcel cA cno cfv cc wcel cA c0v wne
      cA chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA cno cfv
      cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA c0v wne
      pm3.26 sylanc cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 cle wbr cA cno cfv c1 cA cno cfv cdiv co cA csm co cA csp co
      cabs cfv wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 c1 cle cA norm1 c1 1re leidi syl6eqbr cA chil wcel cA c0v wne
      wa c1 cA cno cfv cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA
      csp co cmul co c1 cA cno cfv cdiv co cA csm co cA csp co cabs cfv cA cno
      cfv c1 cA cno cfv cdiv co cc wcel cA chil wcel cA chil wcel c1 cA cno cfv
      cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA csp co cmul co
      wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cA ax-his3 cA
      cno cfv cc wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil
      wcel cA c0v wne wa cA cno cfv reccl cA chil wcel cA cno cfv cc wcel cA
      c0v wne cA chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA
      cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA c0v
      wne pm3.26 cA chil wcel cA c0v wne pm3.26 syl3anc c1 cA cno cfv cdiv co
      cA csm co cA csp co cr wcel cc0 c1 cA cno cfv cdiv co cA csm co cA csp co
      cle wbr c1 cA cno cfv cdiv co cA csm co cA csp co cabs cfv c1 cA cno cfv
      cdiv co cA csm co cA csp co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv
      cdiv co cA csm co cA csp co absid cA chil wcel cA c0v wne wa c1 cA cno
      cfv cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA csp co cmul
      co cr c1 cA cno cfv cdiv co cc wcel cA chil wcel cA chil wcel c1 cA cno
      cfv cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA csp co cmul
      co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cA ax-his3 cA
      cno cfv cc wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil
      wcel cA c0v wne wa cA cno cfv reccl cA chil wcel cA cno cfv cc wcel cA
      c0v wne cA chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA
      cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA c0v
      wne pm3.26 cA chil wcel cA c0v wne pm3.26 syl3anc c1 cA cno cfv cdiv co
      cr wcel cA cA csp co cr wcel c1 cA cno cfv cdiv co cA cA csp co cmul co
      cr wcel cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cA csp co
      remulcl cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr
      wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno
      cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne
      cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA cA csp co cr wcel cA
      c0v wne cA hiidrcl adantr sylanc eqeltrd cA chil wcel cA c0v wne wa cc0
      c1 cA cno cfv cdiv co cA cA csp co cmul co c1 cA cno cfv cdiv co cA csm
      co cA csp co cle c1 cA cno cfv cdiv co cr wcel cc0 c1 cA cno cfv cdiv co
      cle wbr cA cA csp co cr wcel cc0 cA cA csp co cle wbr cc0 c1 cA cno cfv
      cdiv co cA cA csp co cmul co cle wbr cA chil wcel cA c0v wne wa c1 cA cno
      cfv cdiv co cA cA csp co mulge0 cA cno cfv cr wcel cA cno cfv cc0 wne c1
      cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl
      cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel
      cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc c1 cA cno cfv
      cdiv co cr wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv
      co cle wbr cA chil wcel cA c0v wne wa cc0 cr wcel c1 cA cno cfv cdiv co
      cr wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle
      wbr wi 0re cc0 c1 cA cno cfv cdiv co ltle mpan cA cno cfv cr wcel cA cno
      cfv cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA
      cno cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl
      adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar
      sylanc cA cno cfv cr wcel cc0 cA cno cfv clt wbr cc0 c1 cA cno cfv cdiv
      co clt wbr cA chil wcel cA c0v wne wa cA cno cfv recgt0 cA chil wcel cA
      cno cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA c0v wne cc0
      cA cno cfv clt wbr cA normgt0 biimpa sylanc sylc cA chil wcel cA cA csp
      co cr wcel cA c0v wne cA hiidrcl adantr cA chil wcel cc0 cA cA csp co cle
      wbr cA c0v wne cA hiidge0 adantr syl2anc c1 cA cno cfv cdiv co cc wcel cA
      chil wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co cA csp co c1 cA
      cno cfv cdiv co cA cA csp co cmul co wceq cA chil wcel cA c0v wne wa c1
      cA cno cfv cdiv co cA cA ax-his3 cA cno cfv cc wcel cA cno cfv cc0 wne c1
      cA cno cfv cdiv co cc wcel cA chil wcel cA c0v wne wa cA cno cfv reccl cA
      chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno cfv cA normcl
      recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
      biimpar sylanc cA chil wcel cA c0v wne pm3.26 cA chil wcel cA c0v wne
      pm3.26 syl3anc breqtrrd sylanc cA chil wcel cA c0v wne wa cA cno cfv cA
      cno cfv c1 cA cno cfv cdiv co cA cno cfv cmul co cmul co c1 cA cno cfv
      cdiv co cA cno cfv cA cno cfv cmul co cmul co c1 cA cno cfv cdiv co cA cA
      csp co cmul co cA chil wcel cA c0v wne wa cA cno cfv c1 cA cno cfv cdiv
      co cA cno cfv cmul co cmul co cA cno cfv c1 cmul co cA cno cfv cA chil
      wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cmul co c1 cA cno cfv
      cmul cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cmul co
      cA cno cfv c1 cA cno cfv cdiv co cmul co c1 c1 cA cno cfv cdiv co cc wcel
      cA cno cfv cc wcel c1 cA cno cfv cdiv co cA cno cfv cmul co cA cno cfv c1
      cA cno cfv cdiv co cmul co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv
      cdiv co cA cno cfv mulcom cA cno cfv cc wcel cA cno cfv cc0 wne c1 cA cno
      cfv cdiv co cc wcel cA chil wcel cA c0v wne wa cA cno cfv reccl cA chil
      wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno cfv cA normcl
      recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
      biimpar sylanc cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA
      cno cfv cA normcl recnd adantr sylanc cA cno cfv cc wcel cA cno cfv cc0
      wne cA cno cfv c1 cA cno cfv cdiv co cmul co c1 wceq cA chil wcel cA c0v
      wne wa cA cno cfv recid cA chil wcel cA cno cfv cc wcel cA c0v wne cA
      chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA cno cfv cc0
      wne cA c0v wne cA normne0 biimpar sylanc eqtrd opreq2d cA chil wcel cA
      cno cfv c1 cmul co cA cno cfv wceq cA c0v wne cA chil wcel cA cno cfv cc
      wcel cA cno cfv c1 cmul co cA cno cfv wceq cA chil wcel cA cno cfv cA
      normcl recnd cA cno cfv ax1id syl adantr eqtr2d cA cno cfv cc wcel c1 cA
      cno cfv cdiv co cc wcel cA cno cfv cc wcel cA cno cfv c1 cA cno cfv cdiv
      co cA cno cfv cmul co cmul co c1 cA cno cfv cdiv co cA cno cfv cA cno cfv
      cmul co cmul co wceq cA chil wcel cA c0v wne wa cA cno cfv c1 cA cno cfv
      cdiv co cA cno cfv mul12 cA chil wcel cA cno cfv cc wcel cA c0v wne cA
      chil wcel cA cno cfv cA normcl recnd adantr cA cno cfv cc wcel cA cno cfv
      cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil wcel cA c0v wne wa cA cno
      cfv reccl cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno
      cfv cA normcl recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA
      normne0 biimpar sylanc cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil
      wcel cA cno cfv cA normcl recnd adantr syl3anc cA chil wcel cA c0v wne wa
      cA cno cfv cA cno cfv cmul co cA cA csp co c1 cA cno cfv cdiv co cmul cA
      chil wcel cA cno cfv cA cno cfv cmul co cA cA csp co wceq cA c0v wne cA
      chil wcel cA cno cfv c2 cexp co cA cno cfv cA cno cfv cmul co cA cA csp
      co cA chil wcel cA cno cfv cc wcel cA cno cfv c2 cexp co cA cno cfv cA
      cno cfv cmul co wceq cA chil wcel cA cno cfv cA normcl recnd cA cno cfv
      sqval syl cA normsq eqtr3d adantr opreq2d 3eqtrd 3eqtr4rd jca sylanc cA
      chil wcel vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs
      cfv wceq wa vy chil wrex vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA csp
      co cabs cfv wceq wa vy chil wrex wb cA c0v wne cA chil wcel vy cv cno cfv
      c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq wa vy cv cno cfv
      c1 cle wbr cA cno cfv vy cv cA csp co cabs cfv wceq wa vy chil cA chil
      wcel vy cv chil wcel wa cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq cA
      cno cfv vy cv cA csp co cabs cfv wceq vy cv cno cfv c1 cle wbr cA chil
      wcel vy cv chil wcel wa vy cv cA cbr cfv cfv cabs cfv vy cv cA csp co
      cabs cfv cA cno cfv cA chil wcel vy cv chil wcel wa vy cv cA cbr cfv cfv
      vy cv cA csp co cabs cA vy cv bravalval fveq2d eqeq2d anbi2d rexbidva
      adantr mpbird vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs
      cfv wceq wa vy chil wrex vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr
      cfv cfv cabs cfv wceq wa vy chil wrex vx cA cno cfv cA cno fvex vx cv cA
      cno cfv wceq vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy chil vx cv cA cno cfv wceq vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq vy cv cno cfv c1 cle
      wbr vx cv cA cno cfv vy cv cA cbr cfv cfv cabs cfv eqeq1 anbi2d rexbidv
      elab sylibr sylan adantlr ex r19.21aiva jca sylanc eqtrd c0v cbr cfv cnmf
      cfv c0v cno cfv wceq cA chil wcel chil cc0 csn cxp cnmf cfv cc0 c0v cbr
      cfv cnmf cfv c0v cno cfv nmfn0 c0v cbr cfv chil cc0 csn cxp cnmf bra0
      fveq2i norm0 3eqtr4i a1i pm2.61ne $.
      $( [27-Jul-2009] $) $( [24-May-2006] $)

    $( The norm of the bra function. $)
    branmfnOLD $p |- ( A e. ~H -> ( normfn ` ( bra ` A ) ) = ( normh ` A ) ) $=
      cA chil wcel cA cbr cfv cnmf cfv cA cno cfv wceq c0v cbr cfv cnmf cfv c0v
      cno cfv wceq cA c0v cA c0v wceq cA cbr cfv cnmf cfv c0v cbr cfv cnmf cfv
      cA cno cfv c0v cno cfv cA c0v wceq cA cbr cfv c0v cbr cfv cnmf cA c0v cbr
      fveq2 fveq2d cA c0v cno fveq2 eqeq12d cA chil wcel cA c0v wne wa cA cbr
      cfv cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy chil wrex vx cab cxr clt csup cA cno cfv cA chil wcel cA cbr
      cfv cnmf cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy chil wrex vx cab cxr clt csup wceq cA c0v wne cA chil wcel
      chil cc cA cbr cfv wf cA cbr cfv cnmf cfv vy cv cno cfv c1 cle wbr vx cv
      vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cxr clt csup
      wceq cA brafn vx vy cA cbr cfv nmfnval syl adantr vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cxr
      wss cA cno cfv cxr wcel wa vz cv cA cno cfv cle wbr vz vy cv cno cfv c1
      cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab
      wral vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex
      wi vz cr wral wa vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs
      cfv wceq wa vy chil wrex vx cab cxr clt csup cA cno cfv wceq cA chil wcel
      cA c0v wne wa vz vw vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv
      cabs cfv wceq wa vy chil wrex vx cab cA cno cfv supxr2 cA chil wcel vy cv
      cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil
      wrex vx cab cxr wss cA cno cfv cxr wcel wa cA c0v wne cA chil wcel vy cv
      cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil
      wrex vx cab cxr wss cA cno cfv cxr wcel cA chil wcel vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cr
      cxr cA chil wcel chil cc cA cbr cfv wf vy cv cno cfv c1 cle wbr vx cv vy
      cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab cr wss cA brafn vx
      vy cA cbr cfv nmfnsetre syl cr cxr wss cA chil wcel ressxr a1i sstrd cA
      chil wcel cA cno cfv cr wcel cA cno cfv cxr wcel cA normcl cA cno cfv
      rexr syl jca adantr cA chil wcel cA c0v wne wa vz cv cA cno cfv cle wbr
      vz vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa
      vy chil wrex vx cab wral vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw
      vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex vx cab wrex wi vz cr wral cA chil wcel vz cv cA cno cfv cle wbr
      vz vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa
      vy chil wrex vx cab wral cA c0v wne cA chil wcel vz cv cA cno cfv cle wbr
      vz vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa
      vy chil wrex vx cab cA chil wcel vy cv cno cfv c1 cle wbr vz cv vy cv cA
      cbr cfv cfv cabs cfv wceq wa vy chil wrex vz cv cA cno cfv cle wbr vz cv
      vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex vx cab wcel cA chil wcel vy cv cno cfv c1 cle wbr vz cv vy cv
      cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vz cv cA cno cfv cle wbr cA
      chil wcel vy cv cno cfv c1 cle wbr vz cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vz cv cA cno cfv cle wbr vy chil cA chil wcel vy cv chil wcel vy
      cv cno cfv c1 cle wbr vz cv vy cv cA cbr cfv cfv cabs cfv wceq vz cv cA
      cno cfv cle wbr cA chil wcel vy cv chil wcel vy cv cno cfv c1 cle wbr vz
      cv vy cv cA cbr cfv cfv cabs cfv wceq vz cv cA cno cfv cle wbr cA chil
      wcel vy cv chil wcel wa vy cv cno cfv c1 cle wbr wa vz cv vy cv cA cbr
      cfv cfv cabs cfv wceq wa vz cv vy cv cA csp co cabs cfv cA cno cfv cle vz
      cv vy cv cA cbr cfv cfv cabs cfv wceq cA chil wcel vy cv chil wcel wa vy
      cv cno cfv c1 cle wbr wa vz cv vy cv cA cbr cfv cfv cabs cfv vy cv cA csp
      co cabs cfv vz cv vy cv cA cbr cfv cfv cabs cfv wceq id cA chil wcel vy
      cv chil wcel wa vy cv cA cbr cfv cfv cabs cfv vy cv cA csp co cabs cfv
      wceq vy cv cno cfv c1 cle wbr cA chil wcel vy cv chil wcel wa vy cv cA
      cbr cfv cfv vy cv cA csp co cabs cA vy cv bravalval fveq2d adantr
      sylan9eqr cA chil wcel vy cv chil wcel wa vy cv cno cfv c1 cle wbr wa vy
      cv cA csp co cabs cfv cA cno cfv cle wbr vz cv vy cv cA cbr cfv cfv cabs
      cfv wceq vy cv chil wcel cA chil wcel vy cv cno cfv c1 cle wbr vy cv cA
      csp co cabs cfv cA cno cfv cle wbr vy cv chil wcel cA chil wcel vy cv cno
      cfv c1 cle wbr vy cv cA csp co cabs cfv cA cno cfv cle wbr vy cv cA bcs2
      3expa ancom1s adantr eqbrtrd exp41 imp4a r19.23adv imp vy cv cno cfv c1
      cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vy cv
      cno cfv c1 cle wbr vz cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil
      wrex vx vz cv vz visset vx cv vz cv wceq vy cv cno cfv c1 cle wbr vx cv
      vy cv cA cbr cfv cfv cabs cfv wceq wa vy cv cno cfv c1 cle wbr vz cv vy
      cv cA cbr cfv cfv cabs cfv wceq wa vy chil vx cv vz cv wceq vx cv vy cv
      cA cbr cfv cfv cabs cfv wceq vz cv vy cv cA cbr cfv cfv cabs cfv wceq vy
      cv cno cfv c1 cle wbr vx cv vz cv vy cv cA cbr cfv cfv cabs cfv eqeq1
      anbi2d rexbidv elab sylan2b r19.21aiva adantr cA chil wcel cA c0v wne wa
      vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr
      vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex wi
      vz cr cA chil wcel cA c0v wne wa vz cv cr wcel wa vz cv cA cno cfv clt
      wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr
      cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex cA chil wcel cA c0v wne
      wa vz cv cA cno cfv clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle
      wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab wrex
      vz cv cr wcel cA cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv
      cfv cabs cfv wceq wa vy chil wrex vx cab wcel vz cv cA cno cfv clt wbr vz
      cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv
      cabs cfv wceq wa vy chil wrex vx cab wrex cA chil wcel cA c0v wne wa vz
      cv vw cv clt wbr vz cv cA cno cfv clt wbr vw cA cno cfv vy cv cno cfv c1
      cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv wceq wa vy chil wrex vx cab
      vw cv cA cno cfv vz cv clt breq2 rcla4ev cA chil wcel cA c0v wne wa vy cv
      cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex cA cno cfv vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv
      cabs cfv wceq wa vy chil wrex vx cab wcel cA chil wcel cA c0v wne wa vy
      cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq wa vy
      chil wrex vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA csp co cabs cfv
      wceq wa vy chil wrex c1 cA cno cfv cdiv co cA csm co chil wcel c1 cA cno
      cfv cdiv co cA csm co cno cfv c1 cle wbr cA cno cfv c1 cA cno cfv cdiv co
      cA csm co cA csp co cabs cfv wceq wa vy cv cno cfv c1 cle wbr cA cno cfv
      vy cv cA csp co cabs cfv wceq wa vy chil wrex cA chil wcel cA c0v wne wa
      vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA csp co cabs cfv wceq wa c1
      cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr cA cno cfv c1 cA cno cfv
      cdiv co cA csm co cA csp co cabs cfv wceq wa vy c1 cA cno cfv cdiv co cA
      csm co chil vy cv c1 cA cno cfv cdiv co cA csm co wceq vy cv cno cfv c1
      cle wbr c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle wbr cA cno cfv vy
      cv cA csp co cabs cfv wceq cA cno cfv c1 cA cno cfv cdiv co cA csm co cA
      csp co cabs cfv wceq vy cv c1 cA cno cfv cdiv co cA csm co wceq vy cv cno
      cfv c1 cA cno cfv cdiv co cA csm co cno cfv c1 cle vy cv c1 cA cno cfv
      cdiv co cA csm co cno fveq2 breq1d vy cv c1 cA cno cfv cdiv co cA csm co
      wceq vy cv cA csp co cabs cfv c1 cA cno cfv cdiv co cA csm co cA csp co
      cabs cfv cA cno cfv vy cv c1 cA cno cfv cdiv co cA csm co wceq vy cv cA
      csp co c1 cA cno cfv cdiv co cA csm co cA csp co cabs vy cv c1 cA cno cfv
      cdiv co cA csm co cA csp opreq1 fveq2d eqeq2d anbi12d rcla4ev c1 cA cno
      cfv cdiv co cc wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co chil
      wcel cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA hvmulcl cA cno
      cfv cc wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil wcel
      cA c0v wne wa cA cno cfv reccl cA chil wcel cA cno cfv cc wcel cA c0v wne
      cA chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA cno cfv
      cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA c0v wne
      pm3.26 sylanc cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 cle wbr cA cno cfv c1 cA cno cfv cdiv co cA csm co cA csp co
      cabs cfv wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA csm co
      cno cfv c1 c1 cle cA norm1 c1 1re leidi syl6eqbr cA chil wcel cA c0v wne
      wa c1 cA cno cfv cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA
      csp co cmul co c1 cA cno cfv cdiv co cA csm co cA csp co cabs cfv cA cno
      cfv c1 cA cno cfv cdiv co cc wcel cA chil wcel cA chil wcel c1 cA cno cfv
      cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA csp co cmul co
      wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cA ax-his3 cA
      cno cfv cc wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil
      wcel cA c0v wne wa cA cno cfv reccl cA chil wcel cA cno cfv cc wcel cA
      c0v wne cA chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA
      cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA c0v
      wne pm3.26 cA chil wcel cA c0v wne pm3.26 syl3anc c1 cA cno cfv cdiv co
      cA csm co cA csp co cr wcel cc0 c1 cA cno cfv cdiv co cA csm co cA csp co
      cle wbr c1 cA cno cfv cdiv co cA csm co cA csp co cabs cfv c1 cA cno cfv
      cdiv co cA csm co cA csp co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv
      cdiv co cA csm co cA csp co absid cA chil wcel cA c0v wne wa c1 cA cno
      cfv cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA csp co cmul
      co cr c1 cA cno cfv cdiv co cc wcel cA chil wcel cA chil wcel c1 cA cno
      cfv cdiv co cA csm co cA csp co c1 cA cno cfv cdiv co cA cA csp co cmul
      co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cA ax-his3 cA
      cno cfv cc wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil
      wcel cA c0v wne wa cA cno cfv reccl cA chil wcel cA cno cfv cc wcel cA
      c0v wne cA chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA
      cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA c0v
      wne pm3.26 cA chil wcel cA c0v wne pm3.26 syl3anc c1 cA cno cfv cdiv co
      cr wcel cA cA csp co cr wcel c1 cA cno cfv cdiv co cA cA csp co cmul co
      cr wcel cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cA csp co
      remulcl cA cno cfv cr wcel cA cno cfv cc0 wne c1 cA cno cfv cdiv co cr
      wcel cA chil wcel cA c0v wne wa cA cno cfv rereccl cA chil wcel cA cno
      cfv cr wcel cA c0v wne cA normcl adantr cA chil wcel cA cno cfv cc0 wne
      cA c0v wne cA normne0 biimpar sylanc cA chil wcel cA cA csp co cr wcel cA
      c0v wne cA hiidrcl adantr sylanc eqeltrd cA chil wcel cA c0v wne wa cc0
      c1 cA cno cfv cdiv co cA cA csp co cmul co c1 cA cno cfv cdiv co cA csm
      co cA csp co cle c1 cA cno cfv cdiv co cr wcel cA cA csp co cr wcel cc0
      c1 cA cno cfv cdiv co cle wbr cc0 cA cA csp co cle wbr cc0 c1 cA cno cfv
      cdiv co cA cA csp co cmul co cle wbr cA chil wcel cA c0v wne wa c1 cA cno
      cfv cdiv co cA cA csp co mulge0OLD cA cno cfv cr wcel cA cno cfv cc0 wne
      c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno cfv
      rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr cA
      chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA chil
      wcel cA cA csp co cr wcel cA c0v wne cA hiidrcl adantr c1 cA cno cfv cdiv
      co cr wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co
      cle wbr cA chil wcel cA c0v wne wa cc0 cr wcel c1 cA cno cfv cdiv co cr
      wcel cc0 c1 cA cno cfv cdiv co clt wbr cc0 c1 cA cno cfv cdiv co cle wbr
      wi 0re cc0 c1 cA cno cfv cdiv co ltle mpan cA cno cfv cr wcel cA cno cfv
      cc0 wne c1 cA cno cfv cdiv co cr wcel cA chil wcel cA c0v wne wa cA cno
      cfv rereccl cA chil wcel cA cno cfv cr wcel cA c0v wne cA normcl adantr
      cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0 biimpar sylanc cA
      cno cfv cr wcel cc0 cA cno cfv clt wbr cc0 c1 cA cno cfv cdiv co clt wbr
      cA chil wcel cA c0v wne wa cA cno cfv recgt0 cA chil wcel cA cno cfv cr
      wcel cA c0v wne cA normcl adantr cA chil wcel cA c0v wne cc0 cA cno cfv
      clt wbr cA normgt0 biimpa sylanc sylc cA chil wcel cc0 cA cA csp co cle
      wbr cA c0v wne cA hiidge0 adantr syl2anc c1 cA cno cfv cdiv co cc wcel cA
      chil wcel cA chil wcel c1 cA cno cfv cdiv co cA csm co cA csp co c1 cA
      cno cfv cdiv co cA cA csp co cmul co wceq cA chil wcel cA c0v wne wa c1
      cA cno cfv cdiv co cA cA ax-his3 cA cno cfv cc wcel cA cno cfv cc0 wne c1
      cA cno cfv cdiv co cc wcel cA chil wcel cA c0v wne wa cA cno cfv reccl cA
      chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno cfv cA normcl
      recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
      biimpar sylanc cA chil wcel cA c0v wne pm3.26 cA chil wcel cA c0v wne
      pm3.26 syl3anc breqtrrd sylanc cA chil wcel cA c0v wne wa cA cno cfv cA
      cno cfv c1 cA cno cfv cdiv co cA cno cfv cmul co cmul co c1 cA cno cfv
      cdiv co cA cno cfv cA cno cfv cmul co cmul co c1 cA cno cfv cdiv co cA cA
      csp co cmul co cA chil wcel cA c0v wne wa cA cno cfv c1 cA cno cfv cdiv
      co cA cno cfv cmul co cmul co cA cno cfv c1 cmul co cA cno cfv cA chil
      wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cmul co c1 cA cno cfv
      cmul cA chil wcel cA c0v wne wa c1 cA cno cfv cdiv co cA cno cfv cmul co
      cA cno cfv c1 cA cno cfv cdiv co cmul co c1 c1 cA cno cfv cdiv co cc wcel
      cA cno cfv cc wcel c1 cA cno cfv cdiv co cA cno cfv cmul co cA cno cfv c1
      cA cno cfv cdiv co cmul co wceq cA chil wcel cA c0v wne wa c1 cA cno cfv
      cdiv co cA cno cfv mulcom cA cno cfv cc wcel cA cno cfv cc0 wne c1 cA cno
      cfv cdiv co cc wcel cA chil wcel cA c0v wne wa cA cno cfv reccl cA chil
      wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno cfv cA normcl
      recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA normne0
      biimpar sylanc cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA
      cno cfv cA normcl recnd adantr sylanc cA cno cfv cc wcel cA cno cfv cc0
      wne cA cno cfv c1 cA cno cfv cdiv co cmul co c1 wceq cA chil wcel cA c0v
      wne wa cA cno cfv recid cA chil wcel cA cno cfv cc wcel cA c0v wne cA
      chil wcel cA cno cfv cA normcl recnd adantr cA chil wcel cA cno cfv cc0
      wne cA c0v wne cA normne0 biimpar sylanc eqtrd opreq2d cA chil wcel cA
      cno cfv c1 cmul co cA cno cfv wceq cA c0v wne cA chil wcel cA cno cfv cc
      wcel cA cno cfv c1 cmul co cA cno cfv wceq cA chil wcel cA cno cfv cA
      normcl recnd cA cno cfv ax1id syl adantr eqtr2d cA cno cfv cc wcel c1 cA
      cno cfv cdiv co cc wcel cA cno cfv cc wcel cA cno cfv c1 cA cno cfv cdiv
      co cA cno cfv cmul co cmul co c1 cA cno cfv cdiv co cA cno cfv cA cno cfv
      cmul co cmul co wceq cA chil wcel cA c0v wne wa cA cno cfv c1 cA cno cfv
      cdiv co cA cno cfv mul12 cA chil wcel cA cno cfv cc wcel cA c0v wne cA
      chil wcel cA cno cfv cA normcl recnd adantr cA cno cfv cc wcel cA cno cfv
      cc0 wne c1 cA cno cfv cdiv co cc wcel cA chil wcel cA c0v wne wa cA cno
      cfv reccl cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil wcel cA cno
      cfv cA normcl recnd adantr cA chil wcel cA cno cfv cc0 wne cA c0v wne cA
      normne0 biimpar sylanc cA chil wcel cA cno cfv cc wcel cA c0v wne cA chil
      wcel cA cno cfv cA normcl recnd adantr syl3anc cA chil wcel cA c0v wne wa
      cA cno cfv cA cno cfv cmul co cA cA csp co c1 cA cno cfv cdiv co cmul cA
      chil wcel cA cno cfv cA cno cfv cmul co cA cA csp co wceq cA c0v wne cA
      chil wcel cA cno cfv c2 cexp co cA cno cfv cA cno cfv cmul co cA cA csp
      co cA chil wcel cA cno cfv cc wcel cA cno cfv c2 cexp co cA cno cfv cA
      cno cfv cmul co wceq cA chil wcel cA cno cfv cA normcl recnd cA cno cfv
      sqval syl cA normsq eqtr3d adantr opreq2d 3eqtrd 3eqtr4rd jca sylanc cA
      chil wcel vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs
      cfv wceq wa vy chil wrex vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA csp
      co cabs cfv wceq wa vy chil wrex wb cA c0v wne cA chil wcel vy cv cno cfv
      c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq wa vy cv cno cfv
      c1 cle wbr cA cno cfv vy cv cA csp co cabs cfv wceq wa vy chil cA chil
      wcel vy cv chil wcel wa cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq cA
      cno cfv vy cv cA csp co cabs cfv wceq vy cv cno cfv c1 cle wbr cA chil
      wcel vy cv chil wcel wa vy cv cA cbr cfv cfv cabs cfv vy cv cA csp co
      cabs cfv cA cno cfv cA chil wcel vy cv chil wcel wa vy cv cA cbr cfv cfv
      vy cv cA csp co cabs cA vy cv bravalval fveq2d eqeq2d anbi2d rexbidva
      adantr mpbird vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs
      cfv wceq wa vy chil wrex vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr
      cfv cfv cabs cfv wceq wa vy chil wrex vx cA cno cfv cA cno fvex vx cv cA
      cno cfv wceq vy cv cno cfv c1 cle wbr vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy cv cno cfv c1 cle wbr cA cno cfv vy cv cA cbr cfv cfv cabs cfv
      wceq wa vy chil vx cv cA cno cfv wceq vx cv vy cv cA cbr cfv cfv cabs cfv
      wceq cA cno cfv vy cv cA cbr cfv cfv cabs cfv wceq vy cv cno cfv c1 cle
      wbr vx cv cA cno cfv vy cv cA cbr cfv cfv cabs cfv eqeq1 anbi2d rexbidv
      elab sylibr sylan adantlr ex r19.21aiva jca sylanc eqtrd c0v cbr cfv cnmf
      cfv c0v cno cfv wceq cA chil wcel chil cc0 csn cxp cnmf cfv cc0 c0v cbr
      cfv cnmf cfv c0v cno cfv nmfn0 c0v cbr cfv chil cc0 csn cxp cnmf bra0
      fveq2i norm0 3eqtr4i a1i pm2.61ne $.
      $( [30-Jun-2006] $) $( [24-May-2006] $)

    $( The bra of a vector is a bounded functional. $)
    brabn $p |- ( A e. ~H -> ( normfn ` ( bra ` A ) ) e. RR ) $=
      cA chil wcel cA cbr cfv cnmf cfv cA cno cfv cr cA branmfn cA normcl
      eqeltrd $.
      $( [4-Jul-2006] $) $( [26-May-2006] $)

    $( The set of bras equals the set of continuous linear functionals. $)
    rnbra $p |- ran bra = ( LinFn i^i ConFn ) $=
      vt cbr crn clf ccnf cin vt cv vx cv chil wcel vy cv vx cv vz cv csp co
      wceq wa vx vy copab wceq vz chil wrex vt cv clf wcel vt cv ccnf wcel wa
      vt cv cbr crn wcel vt cv clf ccnf cin wcel vt cv vx cv chil wcel vy cv vx
      cv vz cv csp co wceq wa vx vy copab wceq vz chil wrex vt cv clf wcel vt
      cv cnmf cfv cr wcel wa vt cv clf wcel vt cv ccnf wcel wa vt cv vx cv chil
      wcel vy cv vx cv vz cv csp co wceq wa vx vy copab wceq vz chil wrex vt cv
      clf wcel vt cv cnmf cfv cr wcel wa vt cv vx cv chil wcel vy cv vx cv vz
      cv csp co wceq wa vx vy copab wceq vt cv clf wcel vt cv cnmf cfv cr wcel
      wa vz chil vz cv chil wcel vt cv vx cv chil wcel vy cv vx cv vz cv csp co
      wceq wa vx vy copab wceq vt cv vz cv cbr cfv wceq vt cv clf wcel vt cv
      cnmf cfv cr wcel wa vz cv chil wcel vz cv cbr cfv vx cv chil wcel vy cv
      vx cv vz cv csp co wceq wa vx vy copab vt cv vx vy vz cv braval eqeq2d vz
      cv chil wcel vt cv vz cv cbr cfv wceq vt cv clf wcel vt cv cnmf cfv cr
      wcel wa vz cv chil wcel vt cv vz cv cbr cfv wceq wa vt cv clf wcel vt cv
      cnmf cfv cr wcel vz cv chil wcel vt cv vz cv cbr cfv wceq wa vt cv vz cv
      cbr cfv clf vz cv chil wcel vt cv vz cv cbr cfv wceq pm3.27 vz cv chil
      wcel vz cv cbr cfv clf wcel vt cv vz cv cbr cfv wceq vz cv bralnfn adantr
      eqeltrd vz cv chil wcel vt cv vz cv cbr cfv wceq wa vt cv cnmf cfv vz cv
      cbr cfv cnmf cfv cr vt cv vz cv cbr cfv wceq vt cv cnmf cfv vz cv cbr cfv
      cnmf cfv wceq vz cv chil wcel vt cv vz cv cbr cfv cnmf fveq2 adantl vz cv
      chil wcel vz cv cbr cfv cnmf cfv cr wcel vt cv vz cv cbr cfv wceq vz cv
      brabn adantr eqeltrd jca ex sylbird r19.23aiv vt cv clf wcel vt cv cnmf
      cfv cr wcel wa vx cv vt cv cfv vx cv vz cv csp co wceq vx chil wral vz
      chil wrex vt cv vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy
      copab wceq vz chil wrex vt cv clf wcel vt cv cnmf cfv cr wcel vx cv vt cv
      cfv vx cv vz cv csp co wceq vx chil wral vz chil wrex vx vz vt cv riesz1
      biimpa vt cv clf wcel vt cv cnmf cfv cr wcel wa vx cv vt cv cfv vx cv vz
      cv csp co wceq vx chil wral vt cv vx cv chil wcel vy cv vx cv vz cv csp
      co wceq wa vx vy copab wceq vz chil vt cv clf wcel vt cv cnmf cfv cr wcel
      wa vz cv chil wcel wa vx cv chil wcel vy cv vx cv vt cv cfv wceq wa vx vy
      copab vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy copab wceq
      vt cv vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy copab wceq
      vx cv vt cv cfv vx cv vz cv csp co wceq vx chil wral vt cv clf wcel vt cv
      cnmf cfv cr wcel wa vz cv chil wcel wa vx cv chil wcel vy cv vx cv vt cv
      cfv wceq wa vx vy copab vx cv chil wcel vy cv vx cv vz cv csp co wceq wa
      vx vy copab wceq vt cv vx cv chil wcel vy cv vx cv vz cv csp co wceq wa
      vx vy copab wceq vt cv clf wcel vt cv cnmf cfv cr wcel wa vz cv chil wcel
      wa vx cv chil wcel vy cv vx cv vt cv cfv wceq wa vx vy copab vx cv chil
      wcel vy cv vx cv vz cv csp co wceq wa vx vy copab wceq vt cv vx cv chil
      wcel vy cv vx cv vt cv cfv wceq wa vx vy copab vx cv chil wcel vy cv vx
      cv vz cv csp co wceq wa vx vy copab vt cv clf wcel vt cv cnmf cfv cr wcel
      wa vz cv chil wcel wa chil cc vt cv wf vt cv vx cv chil wcel vy cv vx cv
      vt cv cfv wceq wa vx vy copab wceq vt cv clf wcel chil cc vt cv wf vt cv
      cnmf cfv cr wcel vz cv chil wcel vt cv lnfnf ad2antrr chil cc vt cv wf vt
      cv vx cv chil wcel vy cv vx cv vt cv cfv wceq wa vx vy copab wceq vx cv
      vt cv cfv cc wcel vx chil wral vx vy chil cc vt cv fopabfv pm3.26bi syl
      vx cv chil wcel vy cv vx cv vt cv cfv wceq wa vx vy copab vx cv chil wcel
      vy cv vx cv vz cv csp co wceq wa vx vy copab wceq id sylan9eq ex vx cv vt
      cv cfv vx cv vz cv csp co wceq vx chil wral vx cv chil wcel vy cv vx cv
      vt cv cfv wceq wa vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy
      vx cv vt cv cfv vx cv vz cv csp co wceq vx chil hbra1 vx cv vt cv cfv vx
      cv vz cv csp co wceq vx chil wral vy ax-17 vx cv vt cv cfv vx cv vz cv
      csp co wceq vx chil wral vx cv chil wcel vy cv vx cv vt cv cfv wceq vy cv
      vx cv vz cv csp co wceq vx cv vt cv cfv vx cv vz cv csp co wceq vx chil
      wral vx cv chil wcel vx cv vt cv cfv vx cv vz cv csp co wceq vy cv vx cv
      vt cv cfv wceq vy cv vx cv vz cv csp co wceq wb vx cv vt cv cfv vx cv vz
      cv csp co wceq vx chil ra4 vx cv vt cv cfv vx cv vz cv csp co vy cv eqeq2
      syl6 pm5.32d opabbid syl5 r19.22dva mpd impbii vt cv clf wcel vt cv ccnf
      wcel vt cv cnmf cfv cr wcel vt cv lnfncnbd pm5.32i bitr4i vz vt chil vx
      cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy copab vt cv cbr vx vy
      chil vx cv vz cv csp co ax-hilex opabex2 vz vx vy vt df-bra elrnopab vt
      cv clf ccnf elin 3bitr4i eqriv $.
      $( [5-Jul-2006] $) $( [26-May-2006] $)

    $( The bra function maps vectors one-to-one onto the set of continuous
       linear functionals. $)
    bra11 $p |- bra : ~H -1-1-onto-> ( LinFn i^i ConFn ) $=
      chil clf ccnf cin cbr wf1o cbr chil wfn cbr ccnv wfun cbr crn clf ccnf
      cin wceq w3a cbr chil wfn cbr ccnv wfun cbr crn clf ccnf cin wceq vz vt
      chil vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy copab cbr vx
      vy chil vx cv vz cv csp co ax-hilex opabex2 vz vx vy vt df-bra fnopab2
      cbr ccnv wfun vz cv vt cv cbr wbr vz wmo vt cbr crn vz vt cbr funcnv vz
      cv cbr cfv vt cv wceq vz chil wrex vz cv chil wcel vz cv vt cv cbr wbr wa
      vy cv chil wcel vy cv vt cv cbr wbr wa wa vz cv vy cv wceq wi vy wal vz
      wal vt cv cbr crn wcel vz cv vt cv cbr wbr vz wmo vz cv chil wcel vz cv
      vt cv cbr wbr wa vy cv chil wcel vy cv vt cv cbr wbr wa wa vz cv vy cv
      wceq wi vy wal vz wal vz cv cbr cfv vt cv wceq vz chil wrex vz cv chil
      wcel vz cv vt cv cbr wbr wa vy cv chil wcel vy cv vt cv cbr wbr wa wa vz
      cv vy cv wceq wi vz vy vz cv chil wcel vy cv chil wcel vz cv vt cv cbr
      wbr vy cv vt cv cbr wbr vz cv vy cv wceq vz cv chil wcel vy cv chil wcel
      wa vz cv vt cv cbr wbr vy cv vt cv cbr wbr wa vz cv vy cv wceq vz cv chil
      wcel vy cv chil wcel wa vz cv vt cv cbr wbr vy cv vt cv cbr wbr wa vz cv
      cbr cfv vt cv wceq vy cv cbr cfv vt cv wceq wa vz cv vy cv wceq vz cv
      chil wcel vz cv cbr cfv vt cv wceq vz cv vt cv cbr wbr vy cv chil wcel vy
      cv cbr cfv vt cv wceq vy cv vt cv cbr wbr cbr chil wfn vz cv chil wcel vz
      cv cbr cfv vt cv wceq vz cv vt cv cbr wbr wb vz vt chil vx cv chil wcel
      vy cv vx cv vz cv csp co wceq wa vx vy copab cbr vx vy chil vx cv vz cv
      csp co ax-hilex opabex2 vz vx vy vt df-bra fnopab2 chil vz cv vt cv cbr
      vt visset fnbrfvb mpan cbr chil wfn vy cv chil wcel vy cv cbr cfv vt cv
      wceq vy cv vt cv cbr wbr wb vz vt chil vx cv chil wcel vy cv vx cv vz cv
      csp co wceq wa vx vy copab cbr vx vy chil vx cv vz cv csp co ax-hilex
      opabex2 vz vx vy vt df-bra fnopab2 chil vy cv vt cv cbr vt visset fnbrfvb
      mpan bi2anan9 vz cv chil wcel vy cv chil wcel wa vz cv cbr cfv vy cv cbr
      cfv wceq vz cv vy cv wceq vz cv cbr cfv vt cv wceq vy cv cbr cfv vt cv
      wceq wa vz cv chil wcel vy cv chil wcel wa vz cv cbr cfv vy cv cbr cfv
      wceq vx cv vz cv csp co vx cv vy cv csp co wceq vx chil wral vz cv vy cv
      wceq vz cv chil wcel vy cv chil wcel wa vz cv cbr cfv vy cv cbr cfv wceq
      vx cv vz cv csp co vx cv vy cv csp co wceq vx chil vz cv chil wcel vy cv
      chil wcel wa vx cv chil wcel vz cv cbr cfv vy cv cbr cfv wceq vx cv vz cv
      csp co vx cv vy cv csp co wceq vz cv chil wcel vy cv chil wcel wa vx cv
      chil wcel vz cv cbr cfv vy cv cbr cfv wceq vx cv vz cv csp co vx cv vy cv
      csp co wceq vz cv chil wcel vy cv chil wcel wa vx cv chil wcel wa vz cv
      cbr cfv vy cv cbr cfv wceq wa vx cv vz cv cbr cfv cfv vx cv vy cv cbr cfv
      cfv vx cv vz cv csp co vx cv vy cv csp co vz cv cbr cfv vy cv cbr cfv
      wceq vx cv vz cv cbr cfv cfv vx cv vy cv cbr cfv cfv wceq vz cv chil wcel
      vy cv chil wcel wa vx cv chil wcel wa vx cv vz cv cbr cfv vy cv cbr cfv
      fveq1 adantl vz cv chil wcel vy cv chil wcel wa vx cv chil wcel wa vx cv
      vz cv cbr cfv cfv vx cv vz cv csp co wceq vz cv cbr cfv vy cv cbr cfv
      wceq vz cv chil wcel vx cv chil wcel vx cv vz cv cbr cfv cfv vx cv vz cv
      csp co wceq vy cv chil wcel vz cv vx cv bravalval adantlr adantr vz cv
      chil wcel vy cv chil wcel wa vx cv chil wcel wa vx cv vy cv cbr cfv cfv
      vx cv vy cv csp co wceq vz cv cbr cfv vy cv cbr cfv wceq vy cv chil wcel
      vx cv chil wcel vx cv vy cv cbr cfv cfv vx cv vy cv csp co wceq vz cv
      chil wcel vy cv vx cv bravalval adantll adantr 3eqtr3d exp31 com23
      r19.21adv vx vz cv vy cv hial2eq2 sylibd vz cv cbr cfv vy cv cbr cfv vt
      cv eqtr3 syl5 sylbird imp an4s gen2 a1i cbr chil wfn vt cv cbr crn wcel
      vz cv cbr cfv vt cv wceq vz chil wrex wb vz vt chil vx cv chil wcel vy cv
      vx cv vz cv csp co wceq wa vx vy copab cbr vx vy chil vx cv vz cv csp co
      ax-hilex opabex2 vz vx vy vt df-bra fnopab2 vz chil vt cv cbr fvelrnb
      ax-mp vz cv vt cv cbr wbr vz wmo vz cv chil wcel vz cv vt cv cbr wbr wa
      vz wmo vz cv chil wcel vz cv vt cv cbr wbr wa vy cv chil wcel vy cv vt cv
      cbr wbr wa wa vz cv vy cv wceq wi vy wal vz wal vz cv vt cv cbr wbr vz cv
      chil wcel vz cv vt cv cbr wbr wa vz vz cv vt cv cbr wbr vz cv chil wcel
      vz cv vt cv cbr wbr vz cv cbr cdm chil vz cv vt cv cbr vz visset breldm
      vz vt chil vx cv chil wcel vy cv vx cv vz cv csp co wceq wa vx vy copab
      cbr vx vy chil vx cv vz cv csp co ax-hilex opabex2 vz vx vy vt df-bra
      dmopab2 syl6eleq pm4.71ri mobii vz cv chil wcel vz cv vt cv cbr wbr wa vy
      cv chil wcel vy cv vt cv cbr wbr wa vz vy vz cv vy cv wceq vz cv chil
      wcel vy cv chil wcel vz cv vt cv cbr wbr vy cv vt cv cbr wbr vz cv vy cv
      chil eleq1 vz cv vy cv vt cv cbr breq1 anbi12d mo4 bitri 3imtr4i mprgbir
      rnbra 3pm3.2i chil clf ccnf cin cbr dff1o2 mpbir $.
      $( [7-Jul-2006] $) $( [26-May-2006] $)

    $( A bra is a continuous linear functional. $)
    bracnln $p |- ( A e. ~H -> ( bra ` A ) e. ( LinFn i^i ConFn ) ) $=
      chil clf ccnf cin cA cbr chil clf ccnf cin cbr wf1o chil clf ccnf cin cbr
      wf bra11 chil clf ccnf cin cbr f1of ax-mp ffvelrni $.
      $( [8-Jul-2006] $) $( [30-May-2006] $)

    $( Value of the converse of the bra function.  Based on the Riesz Lemma
       ~ riesz4 , this very important theorem not only justifies the Dirac
       bra-ket notation, but allows us to extract a unique vector from any
       continuous linear functional from which the functional can be recovered;
       i.e. a single vector can "store" _all_ of the information contained in
       any entire continuous linear functional (mapping from ` ~H ` to
       ` CC ` ). $)
    cnvbraval $p |- ( T e. ( LinFn i^i ConFn ) ->
      ( `' bra ` T ) = U. { y e. ~H | A. x e. ~H ( T ` x ) = ( x .ih y ) } ) $=
      cT clf ccnf cin wcel vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy
      chil crab cuni cT cbr ccnv cfv cT clf ccnf cin wcel vx cv cT cfv vx cv cT
      cbr ccnv cfv csp co wceq vx chil wral vx cv cT cfv vx cv vy cv csp co
      wceq vx chil wral vy chil crab cuni cT cbr ccnv cfv wceq cT clf ccnf cin
      wcel vx cv cT cfv vx cv cT cbr ccnv cfv csp co wceq vx chil cT clf ccnf
      cin wcel vx cv chil wcel wa vy cv cbr cfv cT wceq vy chil wrex vx cv cT
      cfv vx cv cT cbr ccnv cfv csp co wceq cT clf ccnf cin wcel vy cv cbr cfv
      cT wceq vy chil wrex vx cv chil wcel cT clf ccnf cin wcel cT cbr crn wcel
      vy cv cbr cfv cT wceq vy chil wrex cT cbr crn wcel cT clf ccnf cin wcel
      cbr crn clf ccnf cin cT rnbra eleq2i biimpri cbr chil wfn cT cbr crn wcel
      vy cv cbr cfv cT wceq vy chil wrex wb chil clf ccnf cin cbr wf cbr chil
      wfn chil clf ccnf cin cbr wf1o chil clf ccnf cin cbr wf bra11 chil clf
      ccnf cin cbr f1of ax-mp chil clf ccnf cin cbr ffn ax-mp vy chil cT cbr
      fvelrnb ax-mp sylib adantr cT clf ccnf cin wcel vx cv chil wcel wa vy cv
      cbr cfv cT wceq vx cv cT cfv vx cv cT cbr ccnv cfv csp co wceq vy chil cT
      clf ccnf cin wcel vx cv chil wcel wa vy cv chil wcel vy cv cbr cfv cT
      wceq vx cv cT cfv vx cv cT cbr ccnv cfv csp co wceq cT clf ccnf cin wcel
      vx cv chil wcel wa vy cv chil wcel wa vy cv cbr cfv cT wceq wa vx cv cT
      cbr ccnv cfv csp co vx cv vy cv csp co vx cv vy cv cbr cfv cfv vx cv cT
      cfv vy cv chil wcel vy cv cbr cfv cT wceq vx cv cT cbr ccnv cfv csp co vx
      cv vy cv csp co wceq cT clf ccnf cin wcel vx cv chil wcel wa vy cv chil
      wcel vy cv cbr cfv cT wceq wa cT cbr ccnv cfv vy cv vx cv csp vy cv chil
      wcel vy cv cbr cfv cT wceq cT cbr ccnv cfv vy cv wceq chil clf ccnf cin
      cbr wf1o vy cv chil wcel vy cv cbr cfv cT wceq cT cbr ccnv cfv vy cv wceq
      wi bra11 chil clf ccnf cin vy cv cT cbr f1ocnvfv mpan imp opreq2d adantll
      cT clf ccnf cin wcel vx cv chil wcel wa vy cv chil wcel wa vx cv vy cv
      cbr cfv cfv vx cv vy cv csp co wceq vy cv cbr cfv cT wceq vx cv chil wcel
      vy cv chil wcel vx cv vy cv cbr cfv cfv vx cv vy cv csp co wceq cT clf
      ccnf cin wcel vy cv chil wcel vx cv chil wcel vx cv vy cv cbr cfv cfv vx
      cv vy cv csp co wceq vy cv vx cv bravalval ancoms adantll adantr vy cv
      cbr cfv cT wceq vx cv vy cv cbr cfv cfv vx cv cT cfv wceq cT clf ccnf cin
      wcel vx cv chil wcel wa vy cv chil wcel wa vx cv vy cv cbr cfv cT fveq1
      adantl 3eqtr2rd exp31 r19.23adv mpd r19.21aiva cT cbr ccnv cfv chil wcel
      vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil wreu vx cv cT
      cfv vx cv cT cbr ccnv cfv csp co wceq vx chil wral vx cv cT cfv vx cv vy
      cv csp co wceq vx chil wral vy chil crab cuni cT cbr ccnv cfv wceq wb cT
      clf ccnf cin wcel vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vx cv
      cT cfv vx cv cT cbr ccnv cfv csp co wceq vx chil wral vy chil cT cbr ccnv
      cfv vy cv cT cbr ccnv cfv wceq vx cv cT cfv vx cv vy cv csp co wceq vx cv
      cT cfv vx cv cT cbr ccnv cfv csp co wceq vx chil vy cv cT cbr ccnv cfv
      wceq vx cv vy cv csp co vx cv cT cbr ccnv cfv csp co vx cv cT cfv vy cv
      cT cbr ccnv cfv vx cv csp opreq2 eqeq2d ralbidv reuuni2 chil clf ccnf cin
      cbr wf1o cT clf ccnf cin wcel cT cbr ccnv cfv chil wcel bra11 chil clf
      ccnf cin cT cbr f1ocnvdm mpan vy vx cT riesz4 sylanc mpbid eqcomd $.
      $( [9-Jul-2006] $) $( [26-May-2006] $)

    $( Closure of the converse of the bra function. $)
    cnvbracl $p |- ( T e. ( LinFn i^i ConFn ) -> ( `' bra ` T ) e. ~H ) $=
      chil clf ccnf cin cbr wf1o cT clf ccnf cin wcel cT cbr ccnv cfv chil wcel
      bra11 chil clf ccnf cin cT cbr f1ocnvdm mpan $.
      $( [10-Jul-2006] $) $( [26-May-2006] $)

    $( The converse bra of the bra of a vector is the vector itself. $)
    cnvbrabra $p |- ( A e. ~H -> ( `' bra ` ( bra ` A ) ) = A ) $=
      chil clf ccnf cin cbr wf1o cA chil wcel cA cbr cfv cbr ccnv cfv cA wceq
      bra11 chil clf ccnf cin cA cbr f1ocnvfv1 mpan $.
      $( [11-Jul-2006] $) $( [30-May-2006] $)

    $( The bra of the converse bra of a continuous linear functional. $)
    bracnvbra $p |- ( T e. ( LinFn i^i ConFn ) ->
                     ( bra ` ( `' bra ` T ) ) = T ) $=
      chil clf ccnf cin cbr wf1o cT clf ccnf cin wcel cT cbr ccnv cfv cbr cfv
      cT wceq bra11 chil clf ccnf cin cT cbr f1ocnvfv2 mpan $.
      $( [10-Jul-2006] $) $( [31-May-2006] $)

    $( The vector that a continuous linear functional is the bra of. $)
    bracnlnval $p |- ( T e. ( LinFn i^i ConFn ) ->
         T = ( bra ` U. { y e. ~H | A. x e. ~H ( T ` x ) = ( x .ih y ) } ) ) $=
      cT clf ccnf cin wcel vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy
      chil crab cuni cbr cfv cT cT clf ccnf cin wcel vx cv cT cfv vx cv vy cv
      csp co wceq vx chil wral vy chil crab cuni cbr cfv cT wceq cT cbr ccnv
      cfv vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil crab cuni
      wceq vx vy cT cnvbraval vx cv cT cfv vx cv vy cv csp co wceq vx chil wral
      vy chil crab cuni chil wcel cT clf ccnf cin wcel vx cv cT cfv vx cv vy cv
      csp co wceq vx chil wral vy chil crab cuni cbr cfv cT wceq cT cbr ccnv
      cfv vx cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil crab cuni
      wceq wb cT clf ccnf cin wcel cT cbr ccnv cfv vx cv cT cfv vx cv vy cv csp
      co wceq vx chil wral vy chil crab cuni chil vx vy cT cnvbraval cT
      cnvbracl eqeltrrd chil clf ccnf cin cbr wf1o vx cv cT cfv vx cv vy cv csp
      co wceq vx chil wral vy chil crab cuni chil wcel cT clf ccnf cin wcel vx
      cv cT cfv vx cv vy cv csp co wceq vx chil wral vy chil crab cuni cbr cfv
      cT wceq cT cbr ccnv cfv vx cv cT cfv vx cv vy cv csp co wceq vx chil wral
      vy chil crab cuni wceq wb bra11 chil clf ccnf cin vx cv cT cfv vx cv vy
      cv csp co wceq vx chil wral vy chil crab cuni cT cbr f1ocnvfvb mp3an1
      mpancom mpbird eqcomd $.
      $( [4-Jul-2008] $) $( [26-May-2006] $)

    $( Multiplication property of the converse bra function. $)
    cnvbramul $p |- ( ( A e. CC /\ T e. ( LinFn i^i ConFn ) ) ->
       ( `' bra ` ( A .fn T ) ) = ( ( * ` A ) .h ( `' bra ` T ) ) ) $=
      cA cc wcel cT clf ccnf cin wcel wa cA ccj cfv cT cbr ccnv cfv csm co cbr
      cfv cbr ccnv cfv cA cT chft co cbr ccnv cfv cA ccj cfv cT cbr ccnv cfv
      csm co cA cc wcel cT clf ccnf cin wcel wa cA ccj cfv cT cbr ccnv cfv csm
      co cbr cfv cA cT chft co cbr ccnv cA cc wcel cT clf ccnf cin wcel wa cA
      ccj cfv cT cbr ccnv cfv csm co cbr cfv cA cT cbr ccnv cfv cbr cfv chft co
      cA cT chft co cA cc wcel cT cbr ccnv cfv chil wcel cA ccj cfv cT cbr ccnv
      cfv csm co cbr cfv cA cT cbr ccnv cfv cbr cfv chft co wceq cT clf ccnf
      cin wcel cA cc wcel cT cbr ccnv cfv chil wcel wa cA ccj cfv cT cbr ccnv
      cfv csm co cbr cfv cA ccj cfv ccj cfv cT cbr ccnv cfv cbr cfv chft co cA
      cT cbr ccnv cfv cbr cfv chft co cA ccj cfv cc wcel cT cbr ccnv cfv chil
      wcel cA ccj cfv cT cbr ccnv cfv csm co cbr cfv cA ccj cfv ccj cfv cT cbr
      ccnv cfv cbr cfv chft co wceq cA cc wcel cA ccj cfv cT cbr ccnv cfv
      brafnmul cA cjcl sylan cA cc wcel cT cbr ccnv cfv chil wcel wa cA ccj cfv
      ccj cfv cA cT cbr ccnv cfv cbr cfv chft cA cc wcel cA ccj cfv ccj cfv cA
      wceq cT cbr ccnv cfv chil wcel cA cjcj adantr opreq1d eqtrd cT cnvbracl
      sylan2 cT clf ccnf cin wcel cA cT cbr ccnv cfv cbr cfv chft co cA cT chft
      co wceq cA cc wcel cT clf ccnf cin wcel cT cbr ccnv cfv cbr cfv cT cA
      chft cT bracnvbra opreq2d adantl eqtrd fveq2d cA cc wcel cT clf ccnf cin
      wcel wa cA ccj cfv cT cbr ccnv cfv csm co chil wcel cA ccj cfv cT cbr
      ccnv cfv csm co cbr cfv cbr ccnv cfv cA ccj cfv cT cbr ccnv cfv csm co
      wceq cA ccj cfv cc wcel cT cbr ccnv cfv chil wcel cA ccj cfv cT cbr ccnv
      cfv csm co chil wcel cA cc wcel cT clf ccnf cin wcel cA ccj cfv cT cbr
      ccnv cfv hvmulcl cA cjcl cT cnvbracl syl2an cA ccj cfv cT cbr ccnv cfv
      csm co cnvbrabra syl eqtr3d $.
      $( [13-Jul-2006] $) $( [31-May-2006] $)

    $( Dirac bra-ket associative law ` ( | A >. ` ` <. B | ) | C >. = `
       ` | A >. ( <. B | C >. ) ` i.e. the juxtaposition of an outer product
       with a ket equals a bra juxtaposed with an inner product.  Since
       ` <. B | C >. ` is a complex number, it is the first argument in the
       inner product ` .h ` that it is mapped to, although in Dirac notation
       it is placed after the ket. $)
    kbass1 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                 ( ( A ketbra B ) ` C ) = ( ( ( bra ` B ) ` C ) .h A ) ) $=
      cA chil wcel cB chil wcel cC chil wcel w3a cC cA cB ck co cfv cC cB csp
      co cA csm co cC cB cbr cfv cfv cA csm co cA cB cC kbvalval cA chil wcel
      cB chil wcel cC chil wcel w3a cC cB cbr cfv cfv cC cB csp co cA csm cB
      chil wcel cC chil wcel cC cB cbr cfv cfv cC cB csp co wceq cA chil wcel
      cB cC bravalval 3adant1 opreq1d eqtr4d $.
      $( [18-May-2006] $) $( [15-May-2006] $)

    $( Dirac bra-ket associative law ` ( <. A | B >. ) <. C | = `
       ` <. A | ( | B >. ` ` <. C | ) ` i.e. the juxtaposition of an inner
       product with a bra equals a ket juxtaposed with an outer product. $)
    kbass2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( ( bra ` A ) ` B ) .fn ( bra ` C ) ) =
                  ( ( bra ` A ) o. ( B ketbra C ) ) ) $=
      cA chil wcel cB chil wcel cC chil wcel w3a cB cA cbr cfv cfv cC cbr cfv
      chft co vx cv chil wcel vy cv cB cA cbr cfv cfv vx cv cC cbr cfv cfv cmul
      co wceq wa vx vy copab vx cv chil wcel vy cv vx vx cv cC csp co cB csm co
      vx cv cA csp co csb wceq wa vx vy copab cA cbr cfv cB cC ck co ccom cA
      chil wcel cB chil wcel cC chil wcel cB cA cbr cfv cfv cC cbr cfv chft co
      vx cv chil wcel vy cv cB cA cbr cfv cfv vx cv cC cbr cfv cfv cmul co wceq
      wa vx vy copab wceq cB cA cbr cfv cfv cc wcel chil cc cC cbr cfv wf cB cA
      cbr cfv cfv cC cbr cfv chft co vx cv chil wcel vy cv cB cA cbr cfv cfv vx
      cv cC cbr cfv cfv cmul co wceq wa vx vy copab wceq cA chil wcel cB chil
      wcel wa cC chil wcel vx vy cB cA cbr cfv cfv cC cbr cfv hfmmval cA cB
      bracl cC brafn syl2an 3impa cA chil wcel cB chil wcel cC chil wcel w3a vx
      cv chil wcel vy cv cB cA cbr cfv cfv vx cv cC cbr cfv cfv cmul co wceq wa
      vx cv chil wcel vy cv vx vx cv cC csp co cB csm co vx cv cA csp co csb
      wceq wa vx vy cA chil wcel cB chil wcel cC chil wcel w3a vx cv chil wcel
      vy cv cB cA cbr cfv cfv vx cv cC cbr cfv cfv cmul co wceq vy cv vx vx cv
      cC csp co cB csm co vx cv cA csp co csb wceq cA chil wcel cB chil wcel cC
      chil wcel w3a vx cv chil wcel wa cB cA cbr cfv cfv vx cv cC cbr cfv cfv
      cmul co vx vx cv cC csp co cB csm co vx cv cA csp co csb vy cv cA chil
      wcel cB chil wcel cC chil wcel w3a vx cv chil wcel wa cB cA csp co vx cv
      cC csp co cmul co vx cv cC csp co cB csm co cA csp co cB cA cbr cfv cfv
      vx cv cC cbr cfv cfv cmul co vx vx cv cC csp co cB csm co vx cv cA csp co
      csb cA chil wcel cB chil wcel cC chil wcel w3a vx cv chil wcel wa cB cA
      csp co vx cv cC csp co cmul co vx cv cC csp co cB cA csp co cmul co vx cv
      cC csp co cB csm co cA csp co cB cA csp co cc wcel vx cv cC csp co cc
      wcel cB cA csp co vx cv cC csp co cmul co vx cv cC csp co cB cA csp co
      cmul co wceq cA chil wcel cB chil wcel cC chil wcel w3a vx cv chil wcel
      wa cB cA csp co vx cv cC csp co mulcom cA chil wcel cB chil wcel cC chil
      wcel w3a cB cA csp co cc wcel vx cv chil wcel cA chil wcel cB chil wcel
      cB cA csp co cc wcel cC chil wcel cB chil wcel cA chil wcel cB cA csp co
      cc wcel cB cA hicl ancoms 3adant3 adantr cC chil wcel cA chil wcel vx cv
      chil wcel vx cv cC csp co cc wcel cB chil wcel vx cv chil wcel cC chil
      wcel vx cv cC csp co cc wcel vx cv cC hicl ancoms 3ad2antl3 sylanc vx cv
      cC csp co cc wcel cB chil wcel cA chil wcel vx cv cC csp co cB csm co cA
      csp co vx cv cC csp co cB cA csp co cmul co wceq cA chil wcel cB chil
      wcel cC chil wcel w3a vx cv chil wcel wa vx cv cC csp co cB cA ax-his3 cC
      chil wcel cA chil wcel vx cv chil wcel vx cv cC csp co cc wcel cB chil
      wcel vx cv chil wcel cC chil wcel vx cv cC csp co cc wcel vx cv cC hicl
      ancoms 3ad2antl3 cA chil wcel cB chil wcel cC chil wcel w3a cB chil wcel
      vx cv chil wcel cA chil wcel cB chil wcel cC chil wcel 3simp2 adantr cA
      chil wcel cB chil wcel cC chil wcel w3a cA chil wcel vx cv chil wcel cA
      chil wcel cB chil wcel cC chil wcel 3simp1 adantr syl3anc eqtr4d cA chil
      wcel cB chil wcel cC chil wcel w3a vx cv chil wcel wa cB cA cbr cfv cfv
      cB cA csp co vx cv cC cbr cfv cfv vx cv cC csp co cmul cA chil wcel cB
      chil wcel cC chil wcel w3a cB cA cbr cfv cfv cB cA csp co wceq vx cv chil
      wcel cA chil wcel cB chil wcel cB cA cbr cfv cfv cB cA csp co wceq cC
      chil wcel cA cB bravalval 3adant3 adantr cC chil wcel cA chil wcel vx cv
      chil wcel vx cv cC cbr cfv cfv vx cv cC csp co wceq cB chil wcel cC vx cv
      bravalval 3ad2antl3 opreq12d vx vx cv cC csp co cB csm co vx cv cA csp co
      csb vx cv cC csp co cB csm co cA csp co wceq cA chil wcel cB chil wcel cC
      chil wcel w3a vx cv chil wcel wa vx vx cv cC csp co cB csm co vx cv cA
      csp co csb vx vx cv cC csp co cB csm co vx cv csb cA csp co vx cv cC csp
      co cB csm co cA csp co vx cv cC csp co cB csm co cvv wcel vx vx cv cC csp
      co cB csm co vx cv cA csp co csb vx vx cv cC csp co cB csm co vx cv csb
      cA csp co wceq vx cv cC csp co cB csm oprex vx vx cv cC csp co cB csm co
      vx cv cA cvv csp csbopr1g ax-mp vx vx cv cC csp co cB csm co vx cv csb vx
      cv cC csp co cB csm co cA csp vx cv cC csp co cB csm co cvv wcel vx vx cv
      cC csp co cB csm co vx cv csb vx cv cC csp co cB csm co wceq vx cv cC csp
      co cB csm oprex vx vx cv cC csp co cB csm co cvv csbvarg ax-mp opreq1i
      eqtri a1i 3eqtr4d eqeq2d pm5.32da opabbidv cA chil wcel cB chil wcel cC
      chil wcel w3a cA cbr cfv cB cC ck co ccom vx cv chil wcel vy cv vx cv cA
      csp co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cC csp co cB csm
      co wceq wa vx vy copab ccom vx cv chil wcel vy cv vx vx cv cC csp co cB
      csm co vx cv cA csp co csb wceq wa vx vy copab cA chil wcel cB chil wcel
      cC chil wcel cA cbr cfv cB cC ck co ccom vx cv chil wcel vy cv vx cv cA
      csp co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cC csp co cB csm
      co wceq wa vx vy copab ccom wceq cA chil wcel cB chil wcel cC chil wcel
      wa cA cbr cfv cB cC ck co ccom vx cv chil wcel vy cv vx cv cA csp co wceq
      wa vx vy copab cB cC ck co ccom vx cv chil wcel vy cv vx cv cA csp co
      wceq wa vx vy copab vx cv chil wcel vy cv vx cv cC csp co cB csm co wceq
      wa vx vy copab ccom cA chil wcel cA cbr cfv vx cv chil wcel vy cv vx cv
      cA csp co wceq wa vx vy copab cB cC ck co vx vy cA braval coeq1d cB chil
      wcel cC chil wcel wa cB cC ck co vx cv chil wcel vy cv vx cv cC csp co cB
      csm co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cA csp co wceq wa
      vx vy copab vx vy cB cC kbval coeq2d sylan9eq 3impb cB chil wcel cC chil
      wcel vx cv chil wcel vy cv vx cv cA csp co wceq wa vx vy copab vx cv chil
      wcel vy cv vx cv cC csp co cB csm co wceq wa vx vy copab ccom vx cv chil
      wcel vy cv vx vx cv cC csp co cB csm co vx cv cA csp co csb wceq wa vx vy
      copab wceq cA chil wcel cB chil wcel cC chil wcel wa vx cv chil wcel vy
      cv vx cv cC csp co cB csm co wceq wa vx vy copab crn chil wss vx cv chil
      wcel vy cv vx cv cA csp co wceq wa vx vy copab vx cv chil wcel vy cv vx
      cv cC csp co cB csm co wceq wa vx vy copab ccom vx cv chil wcel vy cv vx
      vx cv cC csp co cB csm co vx cv cA csp co csb wceq wa vx vy copab wceq cB
      chil wcel cC chil wcel wa vx cv cC csp co cB csm co chil wcel vx chil
      wral vx cv chil wcel vy cv vx cv cC csp co cB csm co wceq wa vx vy copab
      crn chil wss cB chil wcel cC chil wcel wa vx cv cC csp co cB csm co chil
      wcel vx chil vx cv chil wcel cC chil wcel cB chil wcel vx cv cC csp co cB
      csm co chil wcel vx cv cC csp co cc wcel cB chil wcel vx cv cC csp co cB
      csm co chil wcel vx cv chil wcel cC chil wcel wa vx cv cC csp co cB
      hvmulcl vx cv cC hicl sylan ancom31s r19.21aiva vx vy chil chil vx cv cC
      csp co cB csm co vx cv chil wcel vy cv vx cv cC csp co cB csm co wceq wa
      vx vy copab vx cv chil wcel vy cv vx cv cC csp co cB csm co wceq wa vx vy
      copab eqid vx cv cC csp co cB csm oprex rnssopab sylib vx vy chil chil vx
      cv cA csp co vx cv cC csp co cB csm co vx cv chil wcel vy cv vx cv cA csp
      co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cC csp co cB csm co
      wceq wa vx vy copab vx cv cA csp oprex vx cv cC csp co cB csm oprex vx cv
      chil wcel vy cv vx cv cA csp co wceq wa vx vy copab eqid vx cv chil wcel
      vy cv vx cv cC csp co cB csm co wceq wa vx vy copab eqid fopabcos syl
      3adant1 eqtr2d 3eqtrd $.
      $( [5-Jun-2006] $) $( [23-May-2006] $)

    $( Dirac bra-ket associative law ` <. A | B >. ` ` <. C | D >. = `
       ` ( <. A | B >. ` ` <. C | ) | D >. ` . $)
    kbass3 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( ( bra ` A ) ` B ) x. ( ( bra ` C ) ` D ) ) =
         ( ( ( ( bra ` A ) ` B ) .fn ( bra ` C ) ) ` D ) ) $=
      cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cD cB cA cbr
      cfv cfv cC cbr cfv chft co cfv cB cA cbr cfv cfv cD cC cbr cfv cfv cmul
      co cB cA cbr cfv cfv cc wcel chil cc cC cbr cfv wf cD chil wcel cD cB cA
      cbr cfv cfv cC cbr cfv chft co cfv cB cA cbr cfv cfv cD cC cbr cfv cfv
      cmul co wceq cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa
      cB cA cbr cfv cfv cD cC cbr cfv hfmval cA chil wcel cB chil wcel wa cB cA
      cbr cfv cfv cc wcel cC chil wcel cD chil wcel wa cA cB bracl adantr cC
      chil wcel chil cc cC cbr cfv wf cA chil wcel cB chil wcel wa cD chil wcel
      cC brafn ad2antrl cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel
      simprr syl3anc eqcomd $.
      $( [22-Oct-2006] $) $( [30-May-2006] $)

    $( Dirac bra-ket associative law ` <. A | B >. ` ` <. C | D >. = `
       ` <. A | ( | B >. ` ` <. C | D >. ) ` . $)
    kbass4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( ( bra ` A ) ` B ) x. ( ( bra ` C ) ` D ) ) =
            ( ( bra ` A ) ` ( ( ( bra ` C ) ` D ) .h B ) ) ) $=
      cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cB cA cbr
      cfv cfv cD cC cbr cfv cfv cmul co cD cC cbr cfv cfv cB cA cbr cfv cfv
      cmul co cD cC cbr cfv cfv cB csm co cA cbr cfv cfv cB cA cbr cfv cfv cc
      wcel cD cC cbr cfv cfv cc wcel cB cA cbr cfv cfv cD cC cbr cfv cfv cmul
      co cD cC cbr cfv cfv cB cA cbr cfv cfv cmul co wceq cA chil wcel cB chil
      wcel wa cC chil wcel cD chil wcel wa cB cA cbr cfv cfv cD cC cbr cfv cfv
      mulcom cA cB bracl cC cD bracl syl2an cA cbr cfv clf wcel cD cC cbr cfv
      cfv cc wcel cB chil wcel cD cC cbr cfv cfv cB csm co cA cbr cfv cfv cD cC
      cbr cfv cfv cB cA cbr cfv cfv cmul co wceq cA chil wcel cB chil wcel wa
      cC chil wcel cD chil wcel wa wa cD cC cbr cfv cfv cB cA cbr cfv lnfnmul
      cA chil wcel cA cbr cfv clf wcel cB chil wcel cC chil wcel cD chil wcel
      wa cA bralnfn ad2antrr cC chil wcel cD chil wcel wa cD cC cbr cfv cfv cc
      wcel cA chil wcel cB chil wcel wa cC cD bracl adantl cA chil wcel cB chil
      wcel cC chil wcel cD chil wcel wa simplr syl3anc eqtr4d $.
      $( [22-Oct-2006] $) $( [30-May-2006] $)

    $( Dirac bra-ket associative law ` ( | A >. ` ` <. B | ) ( | C >. `
       ` <. D | ) = ( ( | A >. ` ` <. B | ) | C >. ) <. D | ` . $)
    kbass5 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( A ketbra B ) o. ( C ketbra D ) ) =
                  ( ( ( A ketbra B ) ` C ) ketbra D ) ) $=
      cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa vx cv chil
      wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab vx cv chil wcel
      vy cv vx cv cD csp co cC csm co wceq wa vx vy copab ccom vx cv chil wcel
      vy cv vx cv cD csp co cC cB csp co cA csm co csm co wceq wa vx vy copab
      cA cB ck co cC cD ck co ccom cC cA cB ck co cfv cD ck co cA chil wcel cB
      chil wcel wa cC chil wcel cD chil wcel wa wa vx cv chil wcel vy cv vx cv
      cB csp co cA csm co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cD
      csp co cC csm co wceq wa vx vy copab ccom vx cv chil wcel vy cv vx vx cv
      cD csp co cC csm co vx cv cB csp co cA csm co csb wceq wa vx vy copab vx
      cv chil wcel vy cv vx cv cD csp co cC cB csp co cA csm co csm co wceq wa
      vx vy copab cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa
      vx cv chil wcel vy cv vx cv cD csp co cC csm co wceq wa vx vy copab crn
      chil wss vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy
      copab vx cv chil wcel vy cv vx cv cD csp co cC csm co wceq wa vx vy copab
      ccom vx cv chil wcel vy cv vx vx cv cD csp co cC csm co vx cv cB csp co
      cA csm co csb wceq wa vx vy copab wceq cC chil wcel cD chil wcel wa vx cv
      chil wcel vy cv vx cv cD csp co cC csm co wceq wa vx vy copab crn chil
      wss cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa vx cv chil
      wcel vy cv vx cv cD csp co cC csm co wceq wa vx vy copab crn cC cD ck co
      crn chil cC chil wcel cD chil wcel wa cC cD ck co vx cv chil wcel vy cv
      vx cv cD csp co cC csm co wceq wa vx vy copab vx vy cC cD kbval rneqd cC
      chil wcel cD chil wcel wa chil chil cC cD ck co wf cC cD ck co crn chil
      wss cC cD kbop chil chil cC cD ck co frn syl eqsstr3d adantl vx vy chil
      chil vx cv cB csp co cA csm co vx cv cD csp co cC csm co vx cv chil wcel
      vy cv vx cv cB csp co cA csm co wceq wa vx vy copab vx cv chil wcel vy cv
      vx cv cD csp co cC csm co wceq wa vx vy copab vx cv cB csp co cA csm
      oprex vx cv cD csp co cC csm oprex vx cv chil wcel vy cv vx cv cB csp co
      cA csm co wceq wa vx vy copab eqid vx cv chil wcel vy cv vx cv cD csp co
      cC csm co wceq wa vx vy copab eqid fopabcos syl cA chil wcel cB chil wcel
      wa cC chil wcel cD chil wcel wa wa vx cv chil wcel vy cv vx vx cv cD csp
      co cC csm co vx cv cB csp co cA csm co csb wceq wa vx cv chil wcel vy cv
      vx cv cD csp co cC cB csp co cA csm co csm co wceq wa vx vy cA chil wcel
      cB chil wcel wa cC chil wcel cD chil wcel wa wa vx cv chil wcel vy cv vx
      vx cv cD csp co cC csm co vx cv cB csp co cA csm co csb wceq vy cv vx cv
      cD csp co cC cB csp co cA csm co csm co wceq cA chil wcel cB chil wcel wa
      cC chil wcel cD chil wcel wa wa vx cv chil wcel wa vx vx cv cD csp co cC
      csm co vx cv cB csp co cA csm co csb vx cv cD csp co cC cB csp co cA csm
      co csm co vy cv cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa
      wa vx cv chil wcel wa vx cv cD csp co cC csm co cB csp co cA csm co vx cv
      cD csp co cC cB csp co cA csm co csm co vx vx cv cD csp co cC csm co vx
      cv cB csp co cA csm co csb cA chil wcel cB chil wcel wa cC chil wcel cD
      chil wcel wa wa vx cv chil wcel wa vx cv cD csp co cC csm co cB csp co cA
      csm co vx cv cD csp co cC cB csp co cmul co cA csm co vx cv cD csp co cC
      cB csp co cA csm co csm co cA chil wcel cB chil wcel wa cC chil wcel cD
      chil wcel wa wa vx cv chil wcel wa vx cv cD csp co cC csm co cB csp co vx
      cv cD csp co cC cB csp co cmul co cA csm cB chil wcel cC chil wcel cD
      chil wcel wa vx cv chil wcel vx cv cD csp co cC csm co cB csp co vx cv cD
      csp co cC cB csp co cmul co wceq cA chil wcel vx cv cD csp co cc wcel cC
      chil wcel cB chil wcel vx cv cD csp co cC csm co cB csp co vx cv cD csp
      co cC cB csp co cmul co wceq cB chil wcel cC chil wcel cD chil wcel wa wa
      vx cv chil wcel wa vx cv cD csp co cC cB ax-his3 cC chil wcel cD chil
      wcel wa vx cv chil wcel vx cv cD csp co cc wcel cB chil wcel cD chil wcel
      vx cv chil wcel vx cv cD csp co cc wcel cC chil wcel vx cv chil wcel cD
      chil wcel vx cv cD csp co cc wcel vx cv cD hicl ancoms adantll adantll cC
      chil wcel cD chil wcel wa cC chil wcel cB chil wcel vx cv chil wcel cC
      chil wcel cD chil wcel pm3.26 ad2antlr cB chil wcel cC chil wcel cD chil
      wcel wa vx cv chil wcel simpll syl3anc adantlll opreq1d vx cv cD csp co
      cc wcel cC cB csp co cc wcel cA chil wcel vx cv cD csp co cC cB csp co
      cmul co cA csm co vx cv cD csp co cC cB csp co cA csm co csm co wceq cA
      chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa vx cv chil wcel
      wa vx cv cD csp co cC cB csp co cA ax-hvmulass cC chil wcel cD chil wcel
      wa vx cv chil wcel vx cv cD csp co cc wcel cA chil wcel cB chil wcel wa
      cD chil wcel vx cv chil wcel vx cv cD csp co cc wcel cC chil wcel vx cv
      chil wcel cD chil wcel vx cv cD csp co cc wcel vx cv cD hicl ancoms
      adantll adantll cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa
      wa cC cB csp co cc wcel vx cv chil wcel cB chil wcel cC chil wcel cC cB
      csp co cc wcel cA chil wcel cD chil wcel cC chil wcel cB chil wcel cC cB
      csp co cc wcel cC cB hicl ancoms ad2ant2lr adantr cA chil wcel cB chil
      wcel wa cA chil wcel cC chil wcel cD chil wcel wa vx cv chil wcel cA chil
      wcel cB chil wcel pm3.26 ad2antrr syl3anc eqtrd vx vx cv cD csp co cC csm
      co vx cv cB csp co cA csm co csb vx vx cv cD csp co cC csm co vx cv cB
      csp co csb cA csm co vx cv cD csp co cC csm co cB csp co cA csm co vx cv
      cD csp co cC csm co cvv wcel vx vx cv cD csp co cC csm co vx cv cB csp co
      cA csm co csb vx vx cv cD csp co cC csm co vx cv cB csp co csb cA csm co
      wceq vx cv cD csp co cC csm oprex vx vx cv cD csp co cC csm co vx cv cB
      csp co cA cvv csm csbopr1g ax-mp vx vx cv cD csp co cC csm co vx cv cB
      csp co csb vx cv cD csp co cC csm co cB csp co cA csm vx vx cv cD csp co
      cC csm co vx cv cB csp co csb vx vx cv cD csp co cC csm co vx cv csb cB
      csp co vx cv cD csp co cC csm co cB csp co vx cv cD csp co cC csm co cvv
      wcel vx vx cv cD csp co cC csm co vx cv cB csp co csb vx vx cv cD csp co
      cC csm co vx cv csb cB csp co wceq vx cv cD csp co cC csm oprex vx vx cv
      cD csp co cC csm co vx cv cB cvv csp csbopr1g ax-mp vx vx cv cD csp co cC
      csm co vx cv csb vx cv cD csp co cC csm co cB csp vx cv cD csp co cC csm
      co cvv wcel vx vx cv cD csp co cC csm co vx cv csb vx cv cD csp co cC csm
      co wceq vx cv cD csp co cC csm oprex vx vx cv cD csp co cC csm co cvv
      csbvarg ax-mp opreq1i eqtri opreq1i eqtri syl5eq eqeq2d pm5.32da opabbidv
      eqtrd cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB
      ck co cC cD ck co ccom vx cv chil wcel vy cv vx cv cB csp co cA csm co
      wceq wa vx vy copab cC cD ck co ccom vx cv chil wcel vy cv vx cv cB csp
      co cA csm co wceq wa vx vy copab vx cv chil wcel vy cv vx cv cD csp co cC
      csm co wceq wa vx vy copab ccom cA chil wcel cB chil wcel wa cC chil wcel
      cD chil wcel wa wa cA cB ck co vx cv chil wcel vy cv vx cv cB csp co cA
      csm co wceq wa vx vy copab cC cD ck co cA chil wcel cB chil wcel wa cA cB
      ck co vx cv chil wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab
      wceq cC chil wcel cD chil wcel wa vx vy cA cB kbval adantr coeq1d cA chil
      wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cC cD ck co vx cv
      chil wcel vy cv vx cv cD csp co cC csm co wceq wa vx vy copab vx cv chil
      wcel vy cv vx cv cB csp co cA csm co wceq wa vx vy copab cC chil wcel cD
      chil wcel wa cC cD ck co vx cv chil wcel vy cv vx cv cD csp co cC csm co
      wceq wa vx vy copab wceq cA chil wcel cB chil wcel wa vx vy cC cD kbval
      adantl coeq2d eqtrd cA chil wcel cB chil wcel wa cC chil wcel cD chil
      wcel cC cA cB ck co cfv cD ck co vx cv chil wcel vy cv vx cv cD csp co cC
      cB csp co cA csm co csm co wceq wa vx vy copab wceq cA chil wcel cB chil
      wcel wa cC chil wcel wa cD chil wcel wa cC cA cB ck co cfv cD ck co cC cB
      csp co cA csm co cD ck co vx cv chil wcel vy cv vx cv cD csp co cC cB csp
      co cA csm co csm co wceq wa vx vy copab cA chil wcel cB chil wcel wa cC
      chil wcel wa cD chil wcel wa cC cA cB ck co cfv cC cB csp co cA csm co cD
      ck cA chil wcel cB chil wcel wa cC chil wcel wa cC cA cB ck co cfv cC cB
      csp co cA csm co wceq cD chil wcel cA chil wcel cB chil wcel cC chil wcel
      cC cA cB ck co cfv cC cB csp co cA csm co wceq cA cB cC kbvalval 3expa
      adantr opreq1d cC cB csp co cA csm co chil wcel cD chil wcel cC cB csp co
      cA csm co cD ck co vx cv chil wcel vy cv vx cv cD csp co cC cB csp co cA
      csm co csm co wceq wa vx vy copab wceq cA chil wcel cB chil wcel wa cC
      chil wcel wa vx vy cC cB csp co cA csm co cD kbval cC chil wcel cB chil
      wcel cA chil wcel cC cB csp co cA csm co chil wcel cC cB csp co cc wcel
      cA chil wcel cC cB csp co cA csm co chil wcel cC chil wcel cB chil wcel
      wa cC cB csp co cA hvmulcl cC cB hicl sylan ancom31s sylan eqtrd anasss
      3eqtr4d $.
      $( [30-Jun-2006] $) $( [30-May-2006] $)

    $( Dirac bra-ket associative law ` ( | A >. ` ` <. B | ) ( | C >. `
       ` <. D | ) = | A >. ` ` ( <. B | ( | C >. ` ` <. D | ) ) ` . $)
    kbass6 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( A ketbra B ) o. ( C ketbra D ) ) =
               ( A ketbra ( `' bra ` ( ( bra ` B ) o. ( C ketbra D ) ) ) ) ) $=
      cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cA cB ck co
      cC cD ck co ccom cC cA cB ck co cfv cD ck co cC cB csp co cA csm co cD ck
      co cA cB cbr cfv cC cD ck co ccom cbr ccnv cfv ck co cA cB cC cD kbass5
      cA chil wcel cB chil wcel wa cC chil wcel cD chil wcel wa wa cC cA cB ck
      co cfv cC cB csp co cA csm co cD ck cA chil wcel cB chil wcel wa cC chil
      wcel cC cA cB ck co cfv cC cB csp co cA csm co wceq cD chil wcel cA chil
      wcel cB chil wcel cC chil wcel cC cA cB ck co cfv cC cB csp co cA csm co
      wceq cA cB cC kbvalval 3expa adantrr opreq1d cA chil wcel cB chil wcel wa
      cC chil wcel cD chil wcel wa wa cC cB csp co cA csm co cD ck co cA cC cB
      csp co ccj cfv cD csm co ck co cA cB cbr cfv cC cD ck co ccom cbr ccnv
      cfv ck co cA chil wcel cB chil wcel cC chil wcel cD chil wcel cC cB csp
      co cA csm co cD ck co cA cC cB csp co ccj cfv cD csm co ck co wceq cC
      chil wcel cB chil wcel cA chil wcel cD chil wcel cC cB csp co cA csm co
      cD ck co cA cC cB csp co ccj cfv cD csm co ck co wceq wi cC chil wcel cB
      chil wcel cA chil wcel cD chil wcel cC cB csp co cA csm co cD ck co cA cC
      cB csp co ccj cfv cD csm co ck co wceq wi wi cC chil wcel cB chil wcel wa
      cA chil wcel cD chil wcel cC cB csp co cA csm co cD ck co cA cC cB csp co
      ccj cfv cD csm co ck co wceq cC cB csp co cc wcel cA chil wcel cD chil
      wcel cC cB csp co cA csm co cD ck co cA cC cB csp co ccj cfv cD csm co ck
      co wceq cC chil wcel cB chil wcel wa cC cB csp co cA cD kbmul cC cB hicl
      syl3an1 3exp ex com13 imp43 cA chil wcel cB chil wcel wa cC chil wcel cD
      chil wcel wa wa cB cbr cfv cC cD ck co ccom cbr ccnv cfv cC cB csp co ccj
      cfv cD csm co cA ck cB chil wcel cC chil wcel cD chil wcel wa cB cbr cfv
      cC cD ck co ccom cbr ccnv cfv cC cB csp co ccj cfv cD csm co wceq cA chil
      wcel cB chil wcel cC chil wcel cD chil wcel wa wa cC cB csp co ccj cfv cD
      csm co cC cB cbr cfv cfv cD cbr cfv chft co cbr ccnv cfv cB cbr cfv cC cD
      ck co ccom cbr ccnv cfv cB chil wcel cC chil wcel cD chil wcel cC cB csp
      co ccj cfv cD csm co cC cB cbr cfv cfv cD cbr cfv chft co cbr ccnv cfv
      wceq cB chil wcel cC chil wcel wa cD chil wcel wa cC cB cbr cfv cfv cD
      cbr cfv chft co cbr ccnv cfv cC cB cbr cfv cfv ccj cfv cD cbr cfv cbr
      ccnv cfv csm co cC cB csp co ccj cfv cD csm co cC cB cbr cfv cfv cc wcel
      cD cbr cfv clf ccnf cin wcel cC cB cbr cfv cfv cD cbr cfv chft co cbr
      ccnv cfv cC cB cbr cfv cfv ccj cfv cD cbr cfv cbr ccnv cfv csm co wceq cB
      chil wcel cC chil wcel wa cD chil wcel cC cB cbr cfv cfv cD cbr cfv
      cnvbramul cB cC bracl cD bracnln syl2an cB chil wcel cC chil wcel wa cD
      chil wcel cC cB cbr cfv cfv ccj cfv cC cB csp co ccj cfv cD cbr cfv cbr
      ccnv cfv cD csm cB chil wcel cC chil wcel wa cC cB cbr cfv cfv cC cB csp
      co ccj cB cC bravalval fveq2d cD cnvbrabra opreqan12d eqtr2d anasss cB
      chil wcel cC chil wcel cD chil wcel wa wa cC cB cbr cfv cfv cD cbr cfv
      chft co cB cbr cfv cC cD ck co ccom cbr ccnv cB chil wcel cC chil wcel cD
      chil wcel cC cB cbr cfv cfv cD cbr cfv chft co cB cbr cfv cC cD ck co
      ccom wceq cB cC cD kbass2 3expb fveq2d eqtr2d adantll opreq2d eqtr4d
      3eqtrd $.
      $( [22-Oct-2006] $) $( [30-May-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Positive operators (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x S $.
    $d t u x y T $.  $d t u x U $.  $d t x y z $.
    $( Ordering relation for positive operators.  Definition of positive
       operator ordering in [Kreyszig] p. 470. $)
    leopg $p |- ( ( T e. A /\ U e. B ) -> ( T <_op U <-> ( ( U -op T ) e.
                HrmOp /\ A. x e. ~H 0 <_ ( ( ( U -op T ) ` x ) .ih x ) ) ) ) $=
      vu cv vt cv chod co cho wcel cc0 vx cv vu cv vt cv chod co cfv vx cv csp
      co cle wbr vx chil wral wa vu cv cT chod co cho wcel cc0 vx cv vu cv cT
      chod co cfv vx cv csp co cle wbr vx chil wral wa cU cT chod co cho wcel
      cc0 vx cv cU cT chod co cfv vx cv csp co cle wbr vx chil wral wa vt vu cT
      cU cA cB cleo vt cv cT wceq vu cv vt cv chod co cho wcel vu cv cT chod co
      cho wcel cc0 vx cv vu cv vt cv chod co cfv vx cv csp co cle wbr vx chil
      wral cc0 vx cv vu cv cT chod co cfv vx cv csp co cle wbr vx chil wral vt
      cv cT wceq vu cv vt cv chod co vu cv cT chod co cho vt cv cT vu cv chod
      opreq2 eleq1d vt cv cT wceq cc0 vx cv vu cv vt cv chod co cfv vx cv csp
      co cle wbr cc0 vx cv vu cv cT chod co cfv vx cv csp co cle wbr vx chil vt
      cv cT wceq vx cv vu cv vt cv chod co cfv vx cv csp co vx cv vu cv cT chod
      co cfv vx cv csp co cc0 cle vt cv cT wceq vx cv vu cv vt cv chod co cfv
      vx cv vu cv cT chod co cfv vx cv csp vt cv cT wceq vx cv vu cv vt cv chod
      co vu cv cT chod co vt cv cT vu cv chod opreq2 fveq1d opreq1d breq2d
      ralbidv anbi12d vu cv cU wceq vu cv cT chod co cho wcel cU cT chod co cho
      wcel cc0 vx cv vu cv cT chod co cfv vx cv csp co cle wbr vx chil wral cc0
      vx cv cU cT chod co cfv vx cv csp co cle wbr vx chil wral vu cv cU wceq
      vu cv cT chod co cU cT chod co cho vu cv cU cT chod opreq1 eleq1d vu cv
      cU wceq cc0 vx cv vu cv cT chod co cfv vx cv csp co cle wbr cc0 vx cv cU
      cT chod co cfv vx cv csp co cle wbr vx chil vu cv cU wceq vx cv vu cv cT
      chod co cfv vx cv csp co vx cv cU cT chod co cfv vx cv csp co cc0 cle vu
      cv cU wceq vx cv vu cv cT chod co cfv vx cv cU cT chod co cfv vx cv csp
      vu cv cU wceq vx cv vu cv cT chod co cU cT chod co vu cv cU cT chod
      opreq1 fveq1d opreq1d breq2d ralbidv anbi12d vx vu vt df-leop brabg $.
      $( [23-Jul-2006] $) $( [23-Jul-2006] $)

    $( Ordering relation for operators.  Definition of positive operator
       ordering in [Kreyszig] p. 470. $)
    leop $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T <_op U <->
                A. x e. ~H 0 <_ ( ( ( U -op T ) ` x ) .ih x ) ) ) $=
      cT cho wcel cU cho wcel wa cT cU cleo wbr cU cT chod co cho wcel cc0 vx
      cv cU cT chod co cfv vx cv csp co cle wbr vx chil wral wa cc0 vx cv cU cT
      chod co cfv vx cv csp co cle wbr vx chil wral vx cho cho cT cU leopg cT
      cho wcel cU cho wcel wa cU cT chod co cho wcel cc0 vx cv cU cT chod co
      cfv vx cv csp co cle wbr vx chil wral cU cho wcel cT cho wcel cU cT chod
      co cho wcel cU cT hmopd ancoms biantrurd bitr4d $.
      $( [6-Aug-2006] $) $( [23-Jul-2006] $)

    $( Ordering relation for operators.  Definition of operator ordering in
       [Young] p. 141. $)
    leop2 $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T <_op U <->
                A. x e. ~H ( ( T ` x ) .ih x ) <_ ( ( U ` x ) .ih x ) ) ) $=
      cT cho wcel cU cho wcel wa cT cU cleo wbr cc0 vx cv cU cT chod co cfv vx
      cv csp co cle wbr vx chil wral vx cv cT cfv vx cv csp co vx cv cU cfv vx
      cv csp co cle wbr vx chil wral vx cT cU leop cT cho wcel cU cho wcel wa
      cc0 vx cv cU cT chod co cfv vx cv csp co cle wbr vx cv cT cfv vx cv csp
      co vx cv cU cfv vx cv csp co cle wbr vx chil cT cho wcel cU cho wcel wa
      vx cv chil wcel wa cc0 vx cv cU cT chod co cfv vx cv csp co cle wbr cc0
      vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co cmin co cle wbr vx cv
      cT cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr cT cho wcel cU cho
      wcel wa vx cv chil wcel wa vx cv cU cT chod co cfv vx cv csp co vx cv cU
      cfv vx cv csp co vx cv cT cfv vx cv csp co cmin co cc0 cle chil chil cT
      wf chil chil cU wf wa vx cv chil wcel vx cv cU cT chod co cfv vx cv csp
      co vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co cmin co wceq cT
      cho wcel cU cho wcel wa chil chil cT wf chil chil cU wf wa vx cv chil
      wcel wa vx cv cU cT chod co cfv vx cv csp co vx cv cU cfv vx cv cT cfv
      cmv co vx cv csp co vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co
      cmin co chil chil cT wf chil chil cU wf wa vx cv chil wcel wa vx cv cU cT
      chod co cfv vx cv cU cfv vx cv cT cfv cmv co vx cv csp chil chil cT wf
      chil chil cU wf vx cv chil wcel vx cv cU cT chod co cfv vx cv cU cfv vx
      cv cT cfv cmv co wceq chil chil cU wf chil chil cT wf vx cv chil wcel vx
      cv cU cT chod co cfv vx cv cU cfv vx cv cT cfv cmv co wceq vx cv cU cT
      hodval 3com12 3expa opreq1d vx cv cU cfv chil wcel vx cv cT cfv chil wcel
      vx cv chil wcel vx cv cU cfv vx cv cT cfv cmv co vx cv csp co vx cv cU
      cfv vx cv csp co vx cv cT cfv vx cv csp co cmin co wceq chil chil cT wf
      chil chil cU wf wa vx cv chil wcel wa vx cv cU cfv vx cv cT cfv vx cv
      his2sub chil chil cU wf vx cv chil wcel vx cv cU cfv chil wcel chil chil
      cT wf chil chil vx cv cU ffvelrn adantll chil chil cT wf vx cv chil wcel
      vx cv cT cfv chil wcel chil chil cU wf chil chil vx cv cT ffvelrn adantlr
      chil chil cT wf chil chil cU wf wa vx cv chil wcel pm3.27 syl3anc eqtrd
      cT cho wcel chil chil cT wf cU cho wcel chil chil cU wf cT hmopf cU hmopf
      anim12i sylan breq2d vx cv cU cfv vx cv csp co cr wcel vx cv cT cfv vx cv
      csp co cr wcel cc0 vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co
      cmin co cle wbr vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co cle
      wbr wb cT cho wcel cU cho wcel wa vx cv chil wcel wa vx cv cU cfv vx cv
      csp co vx cv cT cfv vx cv csp co subge0 cU cho wcel vx cv chil wcel vx cv
      cU cfv vx cv csp co cr wcel cT cho wcel vx cv cU hmopre adantll cT cho
      wcel vx cv chil wcel vx cv cT cfv vx cv csp co cr wcel cU cho wcel vx cv
      cT hmopre adantlr sylanc bitrd ralbidva bitrd $.
      $( [9-Aug-2006] $) $( [23-Jul-2006] $)

    $( Operator ordering in terms of a positive operator.  Definition of
       operator ordering in [Retherford] p. 49. $)
    leop3 $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T <_op U <->
                0hop <_op ( U -op T ) ) ) $=
      cT cho wcel cU cho wcel wa cT cU cleo wbr cc0 vx cv cU cT chod co cfv vx
      cv csp co cle wbr vx chil wral ch0o cU cT chod co cleo wbr vx cT cU leop
      cT cho wcel cU cho wcel wa ch0o cU cT chod co cleo wbr vx cv ch0o cfv vx
      cv csp co vx cv cU cT chod co cfv vx cv csp co cle wbr vx chil wral cc0
      vx cv cU cT chod co cfv vx cv csp co cle wbr vx chil wral ch0o cho wcel
      cU cT chod co cho wcel ch0o cU cT chod co cleo wbr vx cv ch0o cfv vx cv
      csp co vx cv cU cT chod co cfv vx cv csp co cle wbr vx chil wral wb cT
      cho wcel cU cho wcel wa vx ch0o cU cT chod co leop2 ch0o cho wcel cT cho
      wcel cU cho wcel wa 0hmop a1i cU cho wcel cT cho wcel cU cT chod co cho
      wcel cU cT hmopd ancoms sylanc vx cv ch0o cfv vx cv csp co vx cv cU cT
      chod co cfv vx cv csp co cle wbr cc0 vx cv cU cT chod co cfv vx cv csp co
      cle wbr vx chil vx cv chil wcel vx cv ch0o cfv vx cv csp co cc0 vx cv cU
      cT chod co cfv vx cv csp co cle vx cv chil wcel vx cv ch0o cfv vx cv csp
      co c0v vx cv csp co cc0 vx cv chil wcel vx cv ch0o cfv c0v vx cv csp vx
      cv ho0val opreq1d vx cv hi01 eqtrd breq1d ralbiia syl6rbb bitrd $.
      $( [22-Aug-2006] $) $( [23-Jul-2006] $)

    $( Binary relation defining a positive operator.  Definition VI.1 of
       [Retherford] p. 49. $)
    leoppos $p |- ( T e. HrmOp -> ( 0hop <_op T <->
                A. x e. ~H 0 <_ ( ( T ` x ) .ih x ) ) ) $=
      cT cho wcel ch0o cT cleo wbr cc0 vx cv cT ch0o chod co cfv vx cv csp co
      cle wbr vx chil wral cc0 vx cv cT cfv vx cv csp co cle wbr vx chil wral
      ch0o cho wcel cT cho wcel ch0o cT cleo wbr cc0 vx cv cT ch0o chod co cfv
      vx cv csp co cle wbr vx chil wral wb 0hmop vx ch0o cT leop mpan cT cho
      wcel cc0 vx cv cT ch0o chod co cfv vx cv csp co cle wbr cc0 vx cv cT cfv
      vx cv csp co cle wbr vx chil cT cho wcel vx cv cT ch0o chod co cfv vx cv
      csp co vx cv cT cfv vx cv csp co cc0 cle cT cho wcel vx cv cT ch0o chod
      co cfv vx cv cT cfv vx cv csp cT cho wcel vx cv cT ch0o chod co cT cT cho
      wcel chil chil cT wf cT ch0o chod co cT wceq cT hmopf cT hosubid1 syl
      fveq1d opreq1d breq2d ralbidv bitrd $.
      $( [24-Aug-2006] $) $( [25-Jul-2006] $)

    $( The ordering relation for operators is reflexive. $)
    leoprf2 $p |- ( T : ~H --> ~H -> T <_op T ) $=
      chil chil cT wf cT cT cleo wbr cT cT chod co cho wcel cc0 vx cv cT cT
      chod co cfv vx cv csp co cle wbr vx chil wral wa chil chil cT wf cT cT
      chod co cho wcel cc0 vx cv cT cT chod co cfv vx cv csp co cle wbr vx chil
      wral chil chil cT wf cT cT chod co ch0o cho cT hodid 0hmop syl6eqel chil
      chil cT wf cc0 vx cv cT cT chod co cfv vx cv csp co cle wbr vx chil chil
      chil cT wf vx cv chil wcel wa cc0 vx cv cT cT chod co cfv vx cv csp co
      cc0 cle chil chil cT wf vx cv chil wcel wa vx cv cT cT chod co cfv vx cv
      csp co c0v vx cv csp co cc0 chil chil cT wf vx cv chil wcel wa vx cv cT
      cT chod co cfv c0v vx cv csp chil chil cT wf vx cv chil wcel wa vx cv cT
      cT chod co cfv vx cv ch0o cfv c0v chil chil cT wf vx cv chil wcel wa vx
      cv cT cT chod co ch0o chil chil cT wf cT cT chod co ch0o wceq vx cv chil
      wcel cT hodid adantr fveq1d vx cv chil wcel vx cv ch0o cfv c0v wceq chil
      chil cT wf vx cv ho0val adantl eqtrd opreq1d vx cv chil wcel c0v vx cv
      csp co cc0 wceq chil chil cT wf vx cv hi01 adantl eqtr2d cc0 0re leidi
      syl5breq r19.21aiva jca cT cvv wcel cT cvv wcel cT cT cleo wbr cT cT chod
      co cho wcel cc0 vx cv cT cT chod co cfv vx cv csp co cle wbr vx chil wral
      wa wb chil chil cT wf vx cvv cvv cT cT leopg chil chil cT wf chil cvv
      wcel cT cvv wcel ax-hilex chil chil cvv cT fex mpan2 chil chil cT wf chil
      cvv wcel cT cvv wcel ax-hilex chil chil cvv cT fex mpan2 sylanc mpbird $.
      $( [23-Dec-2006] $) $( [24-Jul-2006] $)

    $( The ordering relation for operators is reflexive. $)
    leoprf $p |- ( T e. HrmOp -> T <_op T ) $=
      cT cho wcel cT cT cleo wbr cc0 vx cv cT cT chod co cfv vx cv csp co cle
      wbr vx chil wral cT cho wcel cc0 vx cv cT cT chod co cfv vx cv csp co cle
      wbr vx chil cT cho wcel vx cv chil wcel wa cc0 vx cv cT cT chod co cfv vx
      cv csp co cc0 cle cT cho wcel vx cv chil wcel wa vx cv cT cT chod co cfv
      vx cv csp co c0v vx cv csp co cc0 cT cho wcel vx cv chil wcel wa vx cv cT
      cT chod co cfv c0v vx cv csp cT cho wcel vx cv chil wcel wa vx cv cT cT
      chod co cfv vx cv ch0o cfv c0v cT cho wcel vx cv chil wcel wa vx cv cT cT
      chod co ch0o cT cho wcel cT cT chod co ch0o wceq vx cv chil wcel cT cho
      wcel chil chil cT wf cT cT chod co ch0o wceq cT hmopf cT hodid syl adantr
      fveq1d vx cv chil wcel vx cv ch0o cfv c0v wceq cT cho wcel vx cv ho0val
      adantl eqtrd opreq1d vx cv chil wcel c0v vx cv csp co cc0 wceq cT cho
      wcel vx cv hi01 adantl eqtr2d cc0 0re leidi syl5breq r19.21aiva cT cho
      wcel cT cT cleo wbr cc0 vx cv cT cT chod co cfv vx cv csp co cle wbr vx
      chil wral wb vx cT cT leop anidms mpbird $.
      $( [7-Aug-2006] $) $( [23-Jul-2006] $)

    $( The square of a Hermitian operator is positive. $)
    leopsq $p |- ( T e. HrmOp -> 0hop <_op ( T o. T ) ) $=
      cT cho wcel ch0o cT cT ccom cleo wbr cc0 vx cv cT cT ccom cfv vx cv csp
      co cle wbr vx chil wral cT cho wcel cc0 vx cv cT cT ccom cfv vx cv csp co
      cle wbr vx chil cT cho wcel vx cv chil wcel wa cc0 vx cv cT cfv vx cv cT
      cfv csp co vx cv cT cT ccom cfv vx cv csp co cle cT cho wcel vx cv chil
      wcel wa vx cv cT cfv chil wcel cc0 vx cv cT cfv vx cv cT cfv csp co cle
      wbr chil chil cT wf vx cv chil wcel vx cv cT cfv chil wcel cT cho wcel
      chil chil vx cv cT ffvelrn cT hmopf sylan vx cv cT cfv hiidge0 syl cT cho
      wcel vx cv chil wcel wa vx cv cT cfv vx cv cT cfv csp co vx cv cT cfv cT
      cfv vx cv csp co vx cv cT cT ccom cfv vx cv csp co cT cho wcel vx cv cT
      cfv chil wcel vx cv chil wcel vx cv cT cfv vx cv cT cfv csp co vx cv cT
      cfv cT cfv vx cv csp co wceq cT cho wcel vx cv chil wcel wa vx cv cT cfv
      vx cv cT hmop cT cho wcel vx cv chil wcel pm3.26 chil chil cT wf vx cv
      chil wcel vx cv cT cfv chil wcel cT cho wcel chil chil vx cv cT ffvelrn
      cT hmopf sylan cT cho wcel vx cv chil wcel pm3.27 syl3anc cT cho wcel vx
      cv chil wcel wa vx cv cT cT ccom cfv vx cv cT cfv cT cfv vx cv csp cT
      wfun chil chil cT wf vx cv chil wcel vx cv cT cT ccom cfv vx cv cT cfv cT
      cfv wceq cT cho wcel vx cv chil wcel wa chil chil vx cv cT cT fvco3 cT
      cho wcel cT wfun vx cv chil wcel cT cho wcel chil chil cT wf cT wfun cT
      hmopf chil chil cT ffun syl adantr cT cho wcel chil chil cT wf vx cv chil
      wcel cT hmopf adantr cT cho wcel vx cv chil wcel pm3.27 syl3anc opreq1d
      eqtr4d breqtrd r19.21aiva cT cho wcel cT cT ccom cho wcel ch0o cT cT ccom
      cleo wbr cc0 vx cv cT cT ccom cfv vx cv csp co cle wbr vx chil wral wb cT
      cho wcel cT cT ccom cho wcel cT cho wcel cT cho wcel cT cT ccom cT cT
      ccom wceq cT cT ccom cho wcel cT cT ccom eqid cT cT hmopco mp3an3 anidms
      vx cT cT ccom leoppos syl mpbird $.
      $( [7-Sep-2006] $) $( [23-Aug-2006] $)

    $( The zero operator is a positive operator.  (The literature calls it
       "positive," even though in some sense it is really "nonnegative.")
       Part of Example 12.2(i) in [Young] p. 142. $)
    0leop $p |- 0hop <_op 0hop $=
      ch0o cho wcel ch0o ch0o cleo wbr 0hmop ch0o leoprf ax-mp $.
      $( [24-Aug-2006] $) $( [23-Jul-2006] $)

    $( The identity operator is a positive operator.  Part of Example 12.2(i)
       in [Young] p. 142. $)
    idleop $p |- 0hop <_op Iop $=
      ch0o chio cleo wbr vx cv ch0o cfv vx cv csp co vx cv chio cfv vx cv csp
      co cle wbr vx chil ch0o cho wcel chio cho wcel ch0o chio cleo wbr vx cv
      ch0o cfv vx cv csp co vx cv chio cfv vx cv csp co cle wbr vx chil wral wb
      0hmop idhmop vx ch0o chio leop2 mp2an vx cv chil wcel cc0 vx cv vx cv csp
      co vx cv ch0o cfv vx cv csp co vx cv chio cfv vx cv csp co cle vx cv
      hiidge0 vx cv chil wcel vx cv ch0o cfv vx cv csp co c0v vx cv csp co cc0
      vx cv chil wcel vx cv ch0o cfv c0v vx cv csp vx cv ho0val opreq1d vx cv
      hi01 eqtrd vx cv chil wcel vx cv chio cfv vx cv vx cv csp vx cv hoival
      opreq1d 3brtr4d mprgbir $.
      $( [10-Sep-2006] $) $( [23-Jul-2006] $)

    $( The sum of two positive operators is positive.  Exercise 1(i) of
       [Retherford] p. 49. $)
    leopadd $p |- ( ( ( T e. HrmOp /\ U e. HrmOp ) /\ ( 0hop <_op T
               /\ 0hop <_op U ) ) -> 0hop <_op ( T +op U ) ) $=
      cT cho wcel cU cho wcel wa ch0o cT cleo wbr ch0o cU cleo wbr wa ch0o cT
      cU chos co cleo wbr cT cho wcel cU cho wcel wa cc0 vx cv cT cfv vx cv csp
      co cle wbr vx chil wral cc0 vx cv cU cfv vx cv csp co cle wbr vx chil
      wral wa cc0 vx cv cT cU chos co cfv vx cv csp co cle wbr vx chil wral
      ch0o cT cleo wbr ch0o cU cleo wbr wa ch0o cT cU chos co cleo wbr cT cho
      wcel cU cho wcel wa cc0 vx cv cT cfv vx cv csp co cle wbr cc0 vx cv cU
      cfv vx cv csp co cle wbr wa vx chil wral cc0 vx cv cT cU chos co cfv vx
      cv csp co cle wbr vx chil wral cc0 vx cv cT cfv vx cv csp co cle wbr vx
      chil wral cc0 vx cv cU cfv vx cv csp co cle wbr vx chil wral wa cT cho
      wcel cU cho wcel wa cc0 vx cv cT cfv vx cv csp co cle wbr cc0 vx cv cU
      cfv vx cv csp co cle wbr wa cc0 vx cv cT cU chos co cfv vx cv csp co cle
      wbr vx chil cT cho wcel cU cho wcel wa vx cv chil wcel wa cc0 vx cv cT
      cfv vx cv csp co cle wbr cc0 vx cv cU cfv vx cv csp co cle wbr wa cc0 vx
      cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co caddc co cle wbr cc0 vx
      cv cT cU chos co cfv vx cv csp co cle wbr cT cho wcel cU cho wcel vx cv
      chil wcel cc0 vx cv cT cfv vx cv csp co cle wbr cc0 vx cv cU cfv vx cv
      csp co cle wbr wa cc0 vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      caddc co cle wbr wi vx cv cT cfv vx cv csp co cr wcel vx cv cU cfv vx cv
      csp co cr wcel cc0 vx cv cT cfv vx cv csp co cle wbr cc0 vx cv cU cfv vx
      cv csp co cle wbr wa cc0 vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co caddc co cle wbr wi cT cho wcel vx cv chil wcel wa cU cho wcel vx cv
      chil wcel wa vx cv cT cfv vx cv csp co cr wcel vx cv cU cfv vx cv csp co
      cr wcel wa cc0 vx cv cT cfv vx cv csp co cle wbr cc0 vx cv cU cfv vx cv
      csp co cle wbr wa cc0 vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      caddc co cle wbr vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      addge0 ex vx cv cT hmopre vx cv cU hmopre syl2an anandirs cT cho wcel cU
      cho wcel wa vx cv chil wcel wa vx cv cT cU chos co cfv vx cv csp co vx cv
      cT cfv vx cv csp co vx cv cU cfv vx cv csp co caddc co cc0 cle chil chil
      cT wf chil chil cU wf wa vx cv chil wcel vx cv cT cU chos co cfv vx cv
      csp co vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co caddc co wceq
      cT cho wcel cU cho wcel wa chil chil cT wf chil chil cU wf wa vx cv chil
      wcel wa vx cv cT cU chos co cfv vx cv csp co vx cv cT cfv vx cv cU cfv
      cva co vx cv csp co vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      caddc co chil chil cT wf chil chil cU wf wa vx cv chil wcel wa vx cv cT
      cU chos co cfv vx cv cT cfv vx cv cU cfv cva co vx cv csp vx cv cT cU
      hosvalOLD opreq1d vx cv cT cfv chil wcel vx cv cU cfv chil wcel vx cv
      chil wcel vx cv cT cfv vx cv cU cfv cva co vx cv csp co vx cv cT cfv vx
      cv csp co vx cv cU cfv vx cv csp co caddc co wceq chil chil cT wf chil
      chil cU wf wa vx cv chil wcel wa vx cv cT cfv vx cv cU cfv vx cv ax-his2
      chil chil cT wf vx cv chil wcel vx cv cT cfv chil wcel chil chil cU wf
      chil chil vx cv cT ffvelrn adantlr chil chil cU wf vx cv chil wcel vx cv
      cU cfv chil wcel chil chil cT wf chil chil vx cv cU ffvelrn adantll chil
      chil cT wf chil chil cU wf wa vx cv chil wcel pm3.27 syl3anc eqtrd cT cho
      wcel chil chil cT wf cU cho wcel chil chil cU wf cT hmopf cU hmopf
      anim12i sylan breq2d sylibrd r19.20dva cc0 vx cv cT cfv vx cv csp co cle
      wbr cc0 vx cv cU cfv vx cv csp co cle wbr vx chil r19.26 syl5ibr cT cho
      wcel ch0o cT cleo wbr cc0 vx cv cT cfv vx cv csp co cle wbr vx chil wral
      cU cho wcel ch0o cU cleo wbr cc0 vx cv cU cfv vx cv csp co cle wbr vx
      chil wral vx cT leoppos vx cU leoppos bi2anan9 cT cho wcel cU cho wcel wa
      cT cU chos co cho wcel ch0o cT cU chos co cleo wbr cc0 vx cv cT cU chos
      co cfv vx cv csp co cle wbr vx chil wral wb cT cU hmops vx cT cU chos co
      leoppos syl 3imtr4d imp $.
      $( [17-Sep-2006] $) $( [25-Jul-2006] $)

    $( The scalar product of a nonnegative real and a positive operator is
       a positive operator.  Exercise 1(ii) of [Retherford] p. 49. $)
    leopmuli $p |- ( ( ( A e. RR /\ T e. HrmOp ) /\ ( 0 <_ A /\
                0hop <_op T ) ) -> 0hop <_op ( A .op T ) ) $=
      cA cr wcel cT cho wcel wa cc0 cA cle wbr ch0o cT cleo wbr wa ch0o cA cT
      chot co cleo wbr cA cr wcel cT cho wcel wa cc0 cA cle wbr cc0 vx cv cT
      cfv vx cv csp co cle wbr vx chil wral wa cc0 vx cv cA cT chot co cfv vx
      cv csp co cle wbr vx chil wral cc0 cA cle wbr ch0o cT cleo wbr wa ch0o cA
      cT chot co cleo wbr cA cr wcel cT cho wcel wa cc0 cA cle wbr cc0 vx cv cT
      cfv vx cv csp co cle wbr vx chil wral cc0 vx cv cA cT chot co cfv vx cv
      csp co cle wbr vx chil wral cA cr wcel cT cho wcel wa cc0 cA cle wbr wa
      cc0 vx cv cT cfv vx cv csp co cle wbr cc0 vx cv cA cT chot co cfv vx cv
      csp co cle wbr vx chil cA cr wcel cT cho wcel wa cc0 cA cle wbr wa vx cv
      chil wcel wa cc0 vx cv cT cfv vx cv csp co cle wbr cc0 cA vx cv cT cfv vx
      cv csp co cmul co cle wbr cc0 vx cv cA cT chot co cfv vx cv csp co cle
      wbr cA cr wcel cT cho wcel wa vx cv chil wcel cc0 cA cle wbr cc0 vx cv cT
      cfv vx cv csp co cle wbr cc0 cA vx cv cT cfv vx cv csp co cmul co cle wbr
      wi cA cr wcel cT cho wcel wa vx cv chil wcel wa cc0 cA cle wbr cc0 vx cv
      cT cfv vx cv csp co cle wbr cc0 cA vx cv cT cfv vx cv csp co cmul co cle
      wbr wi cA cr wcel cT cho wcel wa vx cv chil wcel wa cc0 cA cle wbr cc0 vx
      cv cT cfv vx cv csp co cle wbr cc0 cA vx cv cT cfv vx cv csp co cmul co
      cle wbr cA cr wcel vx cv cT cfv vx cv csp co cr wcel wa cc0 cA cle wbr
      cc0 vx cv cT cfv vx cv csp co cle wbr wa cc0 cA vx cv cT cfv vx cv csp co
      cmul co cle wbr cA cr wcel cT cho wcel wa vx cv chil wcel wa cA vx cv cT
      cfv vx cv csp co mulge0OLD cA cr wcel cT cho wcel wa vx cv chil wcel wa
      cA cr wcel vx cv cT cfv vx cv csp co cr wcel cA cr wcel cT cho wcel vx cv
      chil wcel simpll cT cho wcel vx cv chil wcel vx cv cT cfv vx cv csp co cr
      wcel cA cr wcel vx cv cT hmopre adantll jca sylan exp32 imp an1rs cA cr
      wcel cT cho wcel wa vx cv chil wcel cc0 vx cv cA cT chot co cfv vx cv csp
      co cle wbr cc0 cA vx cv cT cfv vx cv csp co cmul co cle wbr wb cc0 cA cle
      wbr cA cr wcel cT cho wcel wa vx cv chil wcel wa vx cv cA cT chot co cfv
      vx cv csp co cA vx cv cT cfv vx cv csp co cmul co cc0 cle cA cc wcel chil
      chil cT wf wa vx cv chil wcel vx cv cA cT chot co cfv vx cv csp co cA vx
      cv cT cfv vx cv csp co cmul co wceq cA cr wcel cT cho wcel wa cA cc wcel
      chil chil cT wf wa vx cv chil wcel wa vx cv cA cT chot co cfv vx cv csp
      co cA vx cv cT cfv csm co vx cv csp co cA vx cv cT cfv vx cv csp co cmul
      co cA cc wcel chil chil cT wf wa vx cv chil wcel wa vx cv cA cT chot co
      cfv cA vx cv cT cfv csm co vx cv csp cA cc wcel chil chil cT wf vx cv
      chil wcel vx cv cA cT chot co cfv cA vx cv cT cfv csm co wceq cA vx cv cT
      homval 3expa opreq1d cA cc wcel vx cv cT cfv chil wcel vx cv chil wcel cA
      vx cv cT cfv csm co vx cv csp co cA vx cv cT cfv vx cv csp co cmul co
      wceq cA cc wcel chil chil cT wf wa vx cv chil wcel wa cA vx cv cT cfv vx
      cv ax-his3 cA cc wcel chil chil cT wf vx cv chil wcel simpll chil chil cT
      wf vx cv chil wcel vx cv cT cfv chil wcel cA cc wcel chil chil vx cv cT
      ffvelrn adantll cA cc wcel chil chil cT wf wa vx cv chil wcel pm3.27
      syl3anc eqtrd cA cr wcel cA cc wcel cT cho wcel chil chil cT wf cA recn
      cT hmopf anim12i sylan breq2d adantlr sylibrd r19.20dva expimpd cA cr
      wcel cT cho wcel wa ch0o cT cleo wbr cc0 vx cv cT cfv vx cv csp co cle
      wbr vx chil wral cc0 cA cle wbr cT cho wcel ch0o cT cleo wbr cc0 vx cv cT
      cfv vx cv csp co cle wbr vx chil wral wb cA cr wcel vx cT leoppos adantl
      anbi2d cA cr wcel cT cho wcel wa cA cT chot co cho wcel ch0o cA cT chot
      co cleo wbr cc0 vx cv cA cT chot co cfv vx cv csp co cle wbr vx chil wral
      wb cA cT hmopm vx cA cT chot co leoppos syl 3imtr4d imp $.
      $( [10-Sep-2006] $) $( [25-Jul-2006] $)

    $( The scalar product of a positive real and a positive operator is
       a positive operator.  Exercise 1(ii) of [Retherford] p. 49. $)
    leopmul $p |- ( ( A e. RR /\ T e. HrmOp /\ 0 < A ) ->
                ( 0hop <_op T <-> 0hop <_op ( A .op T ) ) ) $=
      cA cr wcel cT cho wcel cc0 cA clt wbr w3a ch0o cT cleo wbr ch0o cA cT
      chot co cleo wbr cA cr wcel cT cho wcel wa cc0 cA cle wbr ch0o cT cleo
      wbr wa ch0o cA cT chot co cleo wbr cA cr wcel cT cho wcel cc0 cA clt wbr
      w3a ch0o cT cleo wbr wa cA cT leopmuli cA cr wcel cT cho wcel cc0 cA clt
      wbr w3a cA cr wcel cT cho wcel wa ch0o cT cleo wbr cA cr wcel cT cho wcel
      cc0 cA clt wbr 3simpa adantr cA cr wcel cT cho wcel cc0 cA clt wbr w3a
      cc0 cA cle wbr ch0o cT cleo wbr cA cr wcel cc0 cA clt wbr cc0 cA cle wbr
      cT cho wcel cc0 cr wcel cA cr wcel cc0 cA clt wbr cc0 cA cle wbr 0re cc0
      cr wcel cA cr wcel cc0 cA clt wbr cc0 cA cle wbr cc0 cA ltle 3impia
      mp3an1 3adant2 anim1i sylanc cA cr wcel cT cho wcel cc0 cA clt wbr w3a
      ch0o cA cT chot co cleo wbr wa ch0o c1 cA cdiv co cA cT chot co chot co
      cT cleo c1 cA cdiv co cr wcel cA cT chot co cho wcel wa cc0 c1 cA cdiv co
      cle wbr wa ch0o cA cT chot co cleo wbr ch0o c1 cA cdiv co cA cT chot co
      chot co cleo wbr cA cr wcel cT cho wcel cc0 cA clt wbr w3a c1 cA cdiv co
      cr wcel cA cT chot co cho wcel wa cc0 c1 cA cdiv co cle wbr ch0o cA cT
      chot co cleo wbr ch0o c1 cA cdiv co cA cT chot co chot co cleo wbr c1 cA
      cdiv co cA cT chot co leopmuli anassrs cA cr wcel cT cho wcel cc0 cA clt
      wbr w3a c1 cA cdiv co cr wcel cA cT chot co cho wcel wa cc0 c1 cA cdiv co
      cle wbr cA cr wcel cT cho wcel cc0 cA clt wbr w3a c1 cA cdiv co cr wcel
      cA cT chot co cho wcel cA cr wcel cc0 cA clt wbr c1 cA cdiv co cr wcel cT
      cho wcel cA cr wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv co cr wcel cA
      gt0ne0 cA rereccl syldan 3adant2 cA cr wcel cT cho wcel cA cT chot co cho
      wcel cc0 cA clt wbr cA cT hmopm 3adant3 jca cA cr wcel cc0 cA clt wbr cc0
      c1 cA cdiv co cle wbr cT cho wcel cA cr wcel cc0 cA clt wbr wa cc0 c1 cA
      cdiv co clt wbr cc0 c1 cA cdiv co cle wbr cA recgt0 cc0 cr wcel c1 cA
      cdiv co cr wcel cc0 c1 cA cdiv co clt wbr cc0 c1 cA cdiv co cle wbr wi cA
      cr wcel cc0 cA clt wbr wa cc0 c1 cA cdiv co ltle cc0 cr wcel cA cr wcel
      cc0 cA clt wbr wa 0re a1i cA cr wcel cc0 cA clt wbr cA cc0 wne c1 cA cdiv
      co cr wcel cA gt0ne0 cA rereccl syldan sylanc mpd 3adant2 jca sylan cA cr
      wcel cT cho wcel cc0 cA clt wbr w3a c1 cA cdiv co cA cT chot co chot co
      cT wceq ch0o cA cT chot co cleo wbr cA cr wcel cT cho wcel cc0 cA clt wbr
      w3a c1 cA cdiv co cA cmul co cT chot co c1 cT chot co c1 cA cdiv co cA cT
      chot co chot co cT cA cr wcel cc0 cA clt wbr c1 cA cdiv co cA cmul co cT
      chot co c1 cT chot co wceq cT cho wcel cA cr wcel cc0 cA clt wbr wa c1 cA
      cdiv co cA cmul co c1 cT chot cA cc wcel cA cc0 wne c1 cA cdiv co cA cmul
      co c1 wceq cA cr wcel cc0 cA clt wbr wa cA recid2 cA cr wcel cA cc wcel
      cc0 cA clt wbr cA recn adantr cA gt0ne0 sylanc opreq1d 3adant2 c1 cA cdiv
      co cc wcel cA cc wcel chil chil cT wf c1 cA cdiv co cA cmul co cT chot co
      c1 cA cdiv co cA cT chot co chot co wceq cA cr wcel cT cho wcel cc0 cA
      clt wbr w3a c1 cA cdiv co cA cT homulass cA cr wcel cc0 cA clt wbr c1 cA
      cdiv co cc wcel cT cho wcel cA cc wcel cA cc0 wne c1 cA cdiv co cc wcel
      cA cr wcel cc0 cA clt wbr wa cA reccl cA cr wcel cA cc wcel cc0 cA clt
      wbr cA recn adantr cA gt0ne0 sylanc 3adant2 cA cr wcel cT cho wcel cA cc
      wcel cc0 cA clt wbr cA recn 3ad2ant1 cT cho wcel cA cr wcel chil chil cT
      wf cc0 cA clt wbr cT hmopf 3ad2ant2 syl3anc cT cho wcel cA cr wcel c1 cT
      chot co cT wceq cc0 cA clt wbr cT cho wcel chil chil cT wf c1 cT chot co
      cT wceq cT hmopf cT homulid2 syl 3ad2ant2 3eqtr3d adantr breqtrd impbida
      $.
      $( [21-Sep-2006] $) $( [23-Aug-2006] $)

    $( Scalar product applied to operator ordering. $)
    leopmul2i $p |- ( ( ( A e. RR /\ T e. HrmOp /\ U e. HrmOp ) /\ ( 0 <_ A /\
                T <_op U ) ) -> ( A .op T ) <_op ( A .op U ) ) $=
      cA cr wcel cT cho wcel cU cho wcel w3a cc0 cA cle wbr cT cU cleo wbr cA
      cT chot co cA cU chot co cleo wbr cA cr wcel cT cho wcel cU cho wcel w3a
      cc0 cA cle wbr cT cU cleo wbr cA cT chot co cA cU chot co cleo wbr wi cA
      cr wcel cT cho wcel cU cho wcel w3a cc0 cA cle wbr wa ch0o cU cT chod co
      cleo wbr ch0o cA cU cT chod co chot co cleo wbr cT cU cleo wbr cA cT chot
      co cA cU chot co cleo wbr cA cr wcel cT cho wcel cU cho wcel w3a cc0 cA
      cle wbr ch0o cU cT chod co cleo wbr ch0o cA cU cT chod co chot co cleo
      wbr wi cA cr wcel cU cT chod co cho wcel cc0 cA cle wbr ch0o cU cT chod
      co cleo wbr ch0o cA cU cT chod co chot co cleo wbr wi wi cA cr wcel cT
      cho wcel cU cho wcel w3a cA cr wcel cU cT chod co cho wcel wa cc0 cA cle
      wbr ch0o cU cT chod co cleo wbr ch0o cA cU cT chod co chot co cleo wbr cA
      cU cT chod co leopmuli exp32 cA cr wcel cT cho wcel cU cho wcel 3simp1 cT
      cho wcel cU cho wcel cU cT chod co cho wcel cA cr wcel cU cho wcel cT cho
      wcel cU cT chod co cho wcel cU cT hmopd ancoms 3adant1 sylanc imp cA cr
      wcel cT cho wcel cU cho wcel w3a cT cU cleo wbr ch0o cU cT chod co cleo
      wbr wb cc0 cA cle wbr cT cho wcel cU cho wcel cT cU cleo wbr ch0o cU cT
      chod co cleo wbr wb cA cr wcel cT cU leop3 3adant1 adantr cA cr wcel cT
      cho wcel cU cho wcel w3a cA cT chot co cA cU chot co cleo wbr ch0o cA cU
      cT chod co chot co cleo wbr wb cc0 cA cle wbr cA cr wcel cT cho wcel cU
      cho wcel w3a cA cT chot co cA cU chot co cleo wbr ch0o cA cU chot co cA
      cT chot co chod co cleo wbr ch0o cA cU cT chod co chot co cleo wbr cA cr
      wcel cT cho wcel cU cho wcel cA cT chot co cA cU chot co cleo wbr ch0o cA
      cU chot co cA cT chot co chod co cleo wbr wb cA cT chot co cho wcel cA cU
      chot co cho wcel cA cT chot co cA cU chot co cleo wbr ch0o cA cU chot co
      cA cT chot co chod co cleo wbr wb cA cr wcel cT cho wcel wa cA cr wcel cU
      cho wcel wa cA cT chot co cA cU chot co leop3 cA cT hmopm cA cU hmopm
      syl2an 3impdi cA cr wcel cT cho wcel cU cho wcel w3a cA cU cT chod co
      chot co cA cU chot co cA cT chot co chod co ch0o cleo cA cr wcel cU cho
      wcel cT cho wcel cA cU cT chod co chot co cA cU chot co cA cT chot co
      chod co wceq cA cc wcel chil chil cU wf chil chil cT wf cA cU cT chod co
      chot co cA cU chot co cA cT chot co chod co wceq cA cr wcel cU cho wcel
      cT cho wcel cA cU cT hosubdi cA recn cU hmopf cT hmopf syl3an 3com23
      breq2d bitr4d adantr 3imtr4d ex imp32 $.
      $( [22-Sep-2006] $) $( [12-Aug-2006] $)

    $( The positive operator ordering relation satisfies trichotomy.
       Exercise 1(iii) of [Retherford] p. 49. $)
    leoptri $p |- ( ( T e. HrmOp /\ U e. HrmOp ) ->
           ( ( T <_op U /\ U <_op T ) <-> T = U ) ) $=
      cT cho wcel cU cho wcel wa cT cU cleo wbr cU cT cleo wbr wa vx cv cT cfv
      vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx chil wral vx cv cU cfv
      vx cv csp co vx cv cT cfv vx cv csp co cle wbr vx chil wral wa vx cv cT
      cfv vx cv csp co vx cv cU cfv vx cv csp co wceq vx chil wral cT cU wceq
      cT cho wcel cU cho wcel wa cT cU cleo wbr vx cv cT cfv vx cv csp co vx cv
      cU cfv vx cv csp co cle wbr vx chil wral cU cT cleo wbr vx cv cU cfv vx
      cv csp co vx cv cT cfv vx cv csp co cle wbr vx chil wral vx cT cU leop2
      cU cho wcel cT cho wcel cU cT cleo wbr vx cv cU cfv vx cv csp co vx cv cT
      cfv vx cv csp co cle wbr vx chil wral wb vx cU cT leop2 ancoms anbi12d cT
      cho wcel cU cho wcel wa vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co wceq vx chil wral vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      cle wbr vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co cle wbr wa vx
      chil wral vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx
      chil wral vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co cle wbr vx
      chil wral wa cT cho wcel cU cho wcel wa vx cv cT cfv vx cv csp co vx cv
      cU cfv vx cv csp co wceq vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co cle wbr vx cv cU cfv vx cv csp co vx cv cT cfv vx cv csp co cle wbr wa
      vx chil vx cv cT cfv vx cv csp co cr wcel vx cv cU cfv vx cv csp co cr
      wcel vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co wceq vx cv cT
      cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx cv cU cfv vx cv csp
      co vx cv cT cfv vx cv csp co cle wbr wa wb cT cho wcel cU cho wcel wa vx
      cv chil wcel wa vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      letri3 cT cho wcel vx cv chil wcel vx cv cT cfv vx cv csp co cr wcel cU
      cho wcel vx cv cT hmopre adantlr cU cho wcel vx cv chil wcel vx cv cU cfv
      vx cv csp co cr wcel cT cho wcel vx cv cU hmopre adantll sylanc ralbidva
      vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx cv cU cfv
      vx cv csp co vx cv cT cfv vx cv csp co cle wbr vx chil r19.26 syl6rbb cT
      clo wcel cU clo wcel vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      wceq vx chil wral cT cU wceq wb cT cho wcel cU cho wcel vx cT cU lnopeq
      cT hmoplin cU hmoplin syl2an 3bitrd $.
      $( [23-Apr-2008] $) $( [25-Jul-2006] $)

    $( The positive operator ordering relation is transitive.  Exercise 1(iv)
       of [Retherford] p. 49. $)
    leoptr $p |- ( ( ( S e. HrmOp /\ T e. HrmOp /\ U e. HrmOp ) /\
           ( S <_op T /\ T <_op U ) ) -> S <_op U ) $=
      cS cho wcel cT cho wcel cU cho wcel w3a cS cT cleo wbr cT cU cleo wbr wa
      cS cU cleo wbr cS cho wcel cT cho wcel cU cho wcel w3a vx cv cS cfv vx cv
      csp co vx cv cT cfv vx cv csp co cle wbr vx chil wral vx cv cT cfv vx cv
      csp co vx cv cU cfv vx cv csp co cle wbr vx chil wral wa vx cv cS cfv vx
      cv csp co vx cv cU cfv vx cv csp co cle wbr vx chil wral cS cT cleo wbr
      cT cU cleo wbr wa cS cU cleo wbr cS cho wcel cT cho wcel cU cho wcel w3a
      vx cv cS cfv vx cv csp co vx cv cT cfv vx cv csp co cle wbr vx cv cT cfv
      vx cv csp co vx cv cU cfv vx cv csp co cle wbr wa vx chil wral vx cv cS
      cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx chil wral vx cv cS
      cfv vx cv csp co vx cv cT cfv vx cv csp co cle wbr vx chil wral vx cv cT
      cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx chil wral wa cS cho
      wcel cT cho wcel cU cho wcel w3a vx cv cS cfv vx cv csp co vx cv cT cfv
      vx cv csp co cle wbr vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co
      cle wbr wa vx cv cS cfv vx cv csp co vx cv cU cfv vx cv csp co cle wbr vx
      chil cS cho wcel cT cho wcel cU cho wcel vx cv chil wcel vx cv cS cfv vx
      cv csp co vx cv cT cfv vx cv csp co cle wbr vx cv cT cfv vx cv csp co vx
      cv cU cfv vx cv csp co cle wbr wa vx cv cS cfv vx cv csp co vx cv cU cfv
      vx cv csp co cle wbr wi vx cv cS cfv vx cv csp co cr wcel vx cv cT cfv vx
      cv csp co cr wcel vx cv cU cfv vx cv csp co cr wcel vx cv cS cfv vx cv
      csp co vx cv cT cfv vx cv csp co cle wbr vx cv cT cfv vx cv csp co vx cv
      cU cfv vx cv csp co cle wbr wa vx cv cS cfv vx cv csp co vx cv cU cfv vx
      cv csp co cle wbr wi cS cho wcel vx cv chil wcel wa cT cho wcel vx cv
      chil wcel wa cU cho wcel vx cv chil wcel wa vx cv cS cfv vx cv csp co vx
      cv cT cfv vx cv csp co vx cv cU cfv vx cv csp co letr vx cv cS hmopre vx
      cv cT hmopre vx cv cU hmopre syl3an 3anandirs r19.20dva vx cv cS cfv vx
      cv csp co vx cv cT cfv vx cv csp co cle wbr vx cv cT cfv vx cv csp co vx
      cv cU cfv vx cv csp co cle wbr vx chil r19.26 syl5ibr cS cho wcel cT cho
      wcel cU cho wcel w3a cS cT cleo wbr vx cv cS cfv vx cv csp co vx cv cT
      cfv vx cv csp co cle wbr vx chil wral cT cU cleo wbr vx cv cT cfv vx cv
      csp co vx cv cU cfv vx cv csp co cle wbr vx chil wral cS cho wcel cT cho
      wcel cS cT cleo wbr vx cv cS cfv vx cv csp co vx cv cT cfv vx cv csp co
      cle wbr vx chil wral wb cU cho wcel vx cS cT leop2 3adant3 cT cho wcel cU
      cho wcel cT cU cleo wbr vx cv cT cfv vx cv csp co vx cv cU cfv vx cv csp
      co cle wbr vx chil wral wb cS cho wcel vx cT cU leop2 3adant1 anbi12d cS
      cho wcel cU cho wcel cS cU cleo wbr vx cv cS cfv vx cv csp co vx cv cU
      cfv vx cv csp co cle wbr vx chil wral wb cT cho wcel vx cS cU leop2
      3adant2 3imtr4d imp $.
      $( [5-Jul-2008] $) $( [25-Jul-2006] $)

    $( A bounded Hermitian operator is less than or equal to its norm times the
       identity operator. $)
    leopnmid $p |- ( ( T e. HrmOp /\ ( normop ` T ) e. RR ) ->
                    T <_op ( ( normop ` T ) .op Iop ) ) $=
      cT cho wcel cT cnop cfv cr wcel wa cT cT cnop cfv chio chot co cleo wbr
      vx cv cT cfv vx cv csp co vx cv cT cnop cfv chio chot co cfv vx cv csp co
      cle wbr vx chil wral cT cho wcel cT cnop cfv cr wcel wa vx cv cT cfv vx
      cv csp co vx cv cT cnop cfv chio chot co cfv vx cv csp co cle wbr vx chil
      cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa vx cv cT cfv vx cv
      csp co vx cv cT cfv vx cv csp co cabs cfv vx cv cT cnop cfv chio chot co
      cfv vx cv csp co cT cho wcel vx cv chil wcel vx cv cT cfv vx cv csp co cr
      wcel cT cnop cfv cr wcel vx cv cT hmopre adantlr cT cho wcel vx cv chil
      wcel vx cv cT cfv vx cv csp co cabs cfv cr wcel cT cnop cfv cr wcel cT
      cho wcel vx cv chil wcel wa vx cv cT cfv vx cv csp co cc wcel vx cv cT
      cfv vx cv csp co cabs cfv cr wcel cT cho wcel vx cv chil wcel wa vx cv cT
      cfv vx cv csp co vx cv cT hmopre recnd vx cv cT cfv vx cv csp co abscl
      syl adantlr cT cnop cfv cr wcel vx cv chil wcel vx cv cT cnop cfv chio
      chot co cfv vx cv csp co cr wcel cT cho wcel cT cnop cfv chio chot co cho
      wcel vx cv chil wcel vx cv cT cnop cfv chio chot co cfv vx cv csp co cr
      wcel cT cnop cfv cr wcel vx cv cT cnop cfv chio chot co hmopre cT cnop
      cfv cr wcel chio cho wcel cT cnop cfv chio chot co cho wcel idhmop cT
      cnop cfv chio hmopm mpan2 sylan adantll cT cho wcel vx cv chil wcel vx cv
      cT cfv vx cv csp co vx cv cT cfv vx cv csp co cabs cfv cle wbr cT cnop
      cfv cr wcel cT cho wcel vx cv chil wcel wa vx cv cT cfv vx cv csp co cr
      wcel vx cv cT cfv vx cv csp co vx cv cT cfv vx cv csp co cabs cfv cle wbr
      vx cv cT hmopre vx cv cT cfv vx cv csp co leabs syl adantlr cT cho wcel
      cT cnop cfv cr wcel wa vx cv chil wcel wa vx cv cT cfv vx cv csp co cabs
      cfv vx cv cT cfv cno cfv vx cv cno cfv cmul co vx cv cT cnop cfv chio
      chot co cfv vx cv csp co cT cho wcel vx cv chil wcel vx cv cT cfv vx cv
      csp co cabs cfv cr wcel cT cnop cfv cr wcel cT cho wcel vx cv chil wcel
      wa vx cv cT cfv vx cv csp co cc wcel vx cv cT cfv vx cv csp co cabs cfv
      cr wcel cT cho wcel vx cv chil wcel wa vx cv cT cfv vx cv csp co vx cv cT
      hmopre recnd vx cv cT cfv vx cv csp co abscl syl adantlr vx cv cT cfv cno
      cfv cr wcel vx cv cno cfv cr wcel vx cv cT cfv cno cfv vx cv cno cfv cmul
      co cr wcel cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa vx cv cT
      cfv cno cfv vx cv cno cfv remulcl cT cho wcel vx cv chil wcel vx cv cT
      cfv cno cfv cr wcel cT cnop cfv cr wcel chil chil cT wf vx cv chil wcel
      vx cv cT cfv cno cfv cr wcel cT cho wcel chil chil cT wf vx cv chil wcel
      wa vx cv cT cfv chil wcel vx cv cT cfv cno cfv cr wcel chil chil vx cv cT
      ffvelrn vx cv cT cfv normcl syl cT hmopf sylan adantlr vx cv chil wcel vx
      cv cno cfv cr wcel cT cho wcel cT cnop cfv cr wcel wa vx cv normcl adantl
      sylanc cT cnop cfv cr wcel vx cv chil wcel vx cv cT cnop cfv chio chot co
      cfv vx cv csp co cr wcel cT cho wcel cT cnop cfv chio chot co cho wcel vx
      cv chil wcel vx cv cT cnop cfv chio chot co cfv vx cv csp co cr wcel cT
      cnop cfv cr wcel vx cv cT cnop cfv chio chot co hmopre cT cnop cfv cr
      wcel chio cho wcel cT cnop cfv chio chot co cho wcel idhmop cT cnop cfv
      chio hmopm mpan2 sylan adantll cT cho wcel vx cv chil wcel vx cv cT cfv
      vx cv csp co cabs cfv vx cv cT cfv cno cfv vx cv cno cfv cmul co cle wbr
      cT cnop cfv cr wcel cT cho wcel vx cv chil wcel vx cv cT cfv chil wcel vx
      cv cT cfv vx cv csp co cabs cfv vx cv cT cfv cno cfv vx cv cno cfv cmul
      co cle wbr chil chil cT wf vx cv chil wcel vx cv cT cfv chil wcel cT cho
      wcel chil chil vx cv cT ffvelrn cT hmopf sylan vx cv cT cfv vx cv bcs
      sylancom adantlr cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa vx
      cv cT cfv cno cfv vx cv cno cfv cmul co cT cnop cfv vx cv cno cfv cmul co
      vx cv cno cfv cmul co vx cv cT cnop cfv chio chot co cfv vx cv csp co cle
      vx cv cT cfv cno cfv cr wcel cT cnop cfv vx cv cno cfv cmul co cr wcel vx
      cv cno cfv cr wcel w3a cc0 vx cv cno cfv cle wbr vx cv cT cfv cno cfv cT
      cnop cfv vx cv cno cfv cmul co cle wbr wa vx cv cT cfv cno cfv vx cv cno
      cfv cmul co cT cnop cfv vx cv cno cfv cmul co vx cv cno cfv cmul co cle
      wbr cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa vx cv cT cfv
      cno cfv cT cnop cfv vx cv cno cfv cmul co vx cv cno cfv lemul1aOLD cT cho
      wcel cT cnop cfv cr wcel wa vx cv chil wcel wa vx cv cT cfv cno cfv cr
      wcel cT cnop cfv vx cv cno cfv cmul co cr wcel vx cv cno cfv cr wcel cT
      cho wcel vx cv chil wcel vx cv cT cfv cno cfv cr wcel cT cnop cfv cr wcel
      chil chil cT wf vx cv chil wcel vx cv cT cfv cno cfv cr wcel cT cho wcel
      chil chil cT wf vx cv chil wcel wa vx cv cT cfv chil wcel vx cv cT cfv
      cno cfv cr wcel chil chil vx cv cT ffvelrn vx cv cT cfv normcl syl cT
      hmopf sylan adantlr cT cnop cfv cr wcel vx cv cno cfv cr wcel cT cnop cfv
      vx cv cno cfv cmul co cr wcel cT cho wcel cT cnop cfv cr wcel wa vx cv
      chil wcel cT cnop cfv vx cv cno cfv remulcl cT cho wcel cT cnop cfv cr
      wcel pm3.27 vx cv normcl syl2an vx cv chil wcel vx cv cno cfv cr wcel cT
      cho wcel cT cnop cfv cr wcel wa vx cv normcl adantl 3jca cT cho wcel cT
      cnop cfv cr wcel wa vx cv chil wcel wa cc0 vx cv cno cfv cle wbr vx cv cT
      cfv cno cfv cT cnop cfv vx cv cno cfv cmul co cle wbr vx cv chil wcel cc0
      vx cv cno cfv cle wbr cT cho wcel cT cnop cfv cr wcel wa vx cv normge0
      adantl cT cbo wcel vx cv chil wcel vx cv cT cfv cno cfv cT cnop cfv vx cv
      cno cfv cmul co cle wbr cT cho wcel cT cnop cfv cr wcel wa vx cv cT
      nmbdoplb cT clo wcel cT cnop cfv cr wcel cT cbo wcel cT cho wcel cT cbo
      wcel cT clo wcel cT cnop cfv cr wcel wa cT elbdop2 biimpri cT hmoplin
      sylan sylan jca sylanc cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel
      wa cT cnop cfv vx cv cno cfv cmul co vx cv cno cfv cmul co cT cnop cfv vx
      cv csm co vx cv csp co vx cv cT cnop cfv chio chot co cfv vx cv csp co cT
      cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa cT cnop cfv vx cv cno
      cfv vx cv cno cfv cmul co cmul co cT cnop cfv vx cv vx cv csp co cmul co
      cT cnop cfv vx cv cno cfv cmul co vx cv cno cfv cmul co cT cnop cfv vx cv
      csm co vx cv csp co vx cv chil wcel cT cnop cfv vx cv cno cfv vx cv cno
      cfv cmul co cmul co cT cnop cfv vx cv vx cv csp co cmul co wceq cT cho
      wcel cT cnop cfv cr wcel wa vx cv chil wcel vx cv cno cfv vx cv cno cfv
      cmul co vx cv vx cv csp co cT cnop cfv cmul vx cv chil wcel vx cv cno cfv
      c2 cexp co vx cv cno cfv vx cv cno cfv cmul co vx cv vx cv csp co vx cv
      chil wcel vx cv cno cfv cc wcel vx cv cno cfv c2 cexp co vx cv cno cfv vx
      cv cno cfv cmul co wceq vx cv chil wcel vx cv cno cfv vx cv normcl recnd
      vx cv cno cfv sqval syl vx cv normsq eqtr3d opreq2d adantl cT cnop cfv cc
      wcel vx cv cno cfv cc wcel vx cv cno cfv cc wcel cT cnop cfv vx cv cno
      cfv cmul co vx cv cno cfv cmul co cT cnop cfv vx cv cno cfv vx cv cno cfv
      cmul co cmul co wceq cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel
      wa cT cnop cfv vx cv cno cfv vx cv cno cfv mulass cT cnop cfv cr wcel cT
      cnop cfv cc wcel cT cho wcel vx cv chil wcel cT cnop cfv recn ad2antlr cT
      cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa vx cv cno cfv vx cv
      chil wcel vx cv cno cfv cr wcel cT cho wcel cT cnop cfv cr wcel wa vx cv
      normcl adantl recnd cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa
      vx cv cno cfv vx cv chil wcel vx cv cno cfv cr wcel cT cho wcel cT cnop
      cfv cr wcel wa vx cv normcl adantl recnd syl3anc cT cnop cfv cc wcel vx
      cv chil wcel vx cv chil wcel cT cnop cfv vx cv csm co vx cv csp co cT
      cnop cfv vx cv vx cv csp co cmul co wceq cT cho wcel cT cnop cfv cr wcel
      wa vx cv chil wcel wa cT cnop cfv vx cv vx cv ax-his3 cT cnop cfv cr wcel
      cT cnop cfv cc wcel cT cho wcel vx cv chil wcel cT cnop cfv recn ad2antlr
      cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel pm3.27 cT cho wcel cT
      cnop cfv cr wcel wa vx cv chil wcel pm3.27 syl3anc 3eqtr4d cT cho wcel cT
      cnop cfv cr wcel wa vx cv chil wcel wa vx cv cT cnop cfv chio chot co cfv
      cT cnop cfv vx cv csm co vx cv csp cT cho wcel cT cnop cfv cr wcel wa vx
      cv chil wcel wa vx cv cT cnop cfv chio chot co cfv cT cnop cfv vx cv chio
      cfv csm co cT cnop cfv vx cv csm co cT cnop cfv cc wcel chil chil chio wf
      vx cv chil wcel vx cv cT cnop cfv chio chot co cfv cT cnop cfv vx cv chio
      cfv csm co wceq cT cho wcel cT cnop cfv cr wcel wa vx cv chil wcel wa cT
      cnop cfv vx cv chio homval cT cnop cfv cr wcel cT cnop cfv cc wcel cT cho
      wcel vx cv chil wcel cT cnop cfv recn ad2antlr chil chil chio wf cT cho
      wcel cT cnop cfv cr wcel wa vx cv chil wcel wa chil chil chio wf1o chil
      chil chio wf hoif chil chil chio f1of ax-mp a1i cT cho wcel cT cnop cfv
      cr wcel wa vx cv chil wcel pm3.27 syl3anc vx cv chil wcel cT cnop cfv vx
      cv chio cfv csm co cT cnop cfv vx cv csm co wceq cT cho wcel cT cnop cfv
      cr wcel wa vx cv chil wcel vx cv chio cfv vx cv cT cnop cfv csm vx cv
      hoival opreq2d adantl eqtrd opreq1d eqtr4d breqtrd letrd letrd r19.21aiva
      cT cho wcel cT cnop cfv chio chot co cho wcel cT cT cnop cfv chio chot co
      cleo wbr vx cv cT cfv vx cv csp co vx cv cT cnop cfv chio chot co cfv vx
      cv csp co cle wbr vx chil wral wb cT cnop cfv cr wcel vx cT cT cnop cfv
      chio chot co leop2 cT cnop cfv cr wcel chio cho wcel cT cnop cfv chio
      chot co cho wcel idhmop cT cnop cfv chio hmopm mpan2 sylan2 mpbird $.
      $( [12-Aug-2006] $) $( [11-Aug-2006] $)

    $( A nonzero, bounded Hermitian operator divided by its norm is less than
       or equal to the identity operator. $)
    nmopleid $p |- ( ( T e. HrmOp /\ ( normop ` T ) e. RR /\ T =/= 0hop ) ->
                    ( ( 1 / ( normop ` T ) ) .op T ) <_op Iop ) $=
      cT cho wcel cT cnop cfv cr wcel cT ch0o wne c1 cT cnop cfv cdiv co cT
      chot co chio cleo wbr cT cho wcel cT cnop cfv cr wcel wa cT ch0o wne cT
      cnop cfv cc0 wne c1 cT cnop cfv cdiv co cT chot co chio cleo wbr cT cho
      wcel cT ch0o wne cT cnop cfv cc0 wne cT cnop cfv cr wcel cT clo wcel cT
      ch0o wne cT cnop cfv cc0 wne cT cho wcel cT clo wcel cT cnop cfv cc0 wne
      cT ch0o wne cT nmlnopne0 biimpar cT hmoplin sylan adantlr cT cho wcel cT
      cnop cfv cr wcel wa cT cnop cfv cc0 wne wa c1 cT cnop cfv cdiv co cT chot
      co c1 cT cnop cfv cdiv co cT cnop cfv chio chot co chot co chio cleo c1
      cT cnop cfv cdiv co cr wcel cT cho wcel cT cnop cfv chio chot co cho wcel
      w3a cc0 c1 cT cnop cfv cdiv co cle wbr cT cT cnop cfv chio chot co cleo
      wbr wa c1 cT cnop cfv cdiv co cT chot co c1 cT cnop cfv cdiv co cT cnop
      cfv chio chot co chot co cleo wbr cT cho wcel cT cnop cfv cr wcel wa cT
      cnop cfv cc0 wne wa c1 cT cnop cfv cdiv co cT cT cnop cfv chio chot co
      leopmul2i cT cho wcel cT cnop cfv cr wcel wa cT cnop cfv cc0 wne wa c1 cT
      cnop cfv cdiv co cr wcel cT cho wcel cT cnop cfv chio chot co cho wcel cT
      cnop cfv cr wcel cT cnop cfv cc0 wne c1 cT cnop cfv cdiv co cr wcel cT
      cho wcel cT cnop cfv rereccl adantll cT cho wcel cT cnop cfv cr wcel cT
      cnop cfv cc0 wne simpll cT cnop cfv cr wcel cT cnop cfv chio chot co cho
      wcel cT cho wcel cT cnop cfv cc0 wne cT cnop cfv cr wcel chio cho wcel cT
      cnop cfv chio chot co cho wcel idhmop cT cnop cfv chio hmopm mpan2
      ad2antlr 3jca cT cho wcel cT cnop cfv cr wcel wa cT cnop cfv cc0 wne wa
      cc0 c1 cT cnop cfv cdiv co cle wbr cT cT cnop cfv chio chot co cleo wbr
      cT cho wcel cT cnop cfv cr wcel wa cT cnop cfv cc0 wne wa cc0 c1 cT cnop
      cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle wbr cT cnop cfv cr
      wcel cc0 cT cnop cfv clt wbr cc0 c1 cT cnop cfv cdiv co clt wbr cT cho
      wcel cT cnop cfv cr wcel wa cT cnop cfv cc0 wne wa cT cnop cfv recgt0 cT
      cho wcel cT cnop cfv cr wcel cT cnop cfv cc0 wne simplr cT cho wcel cT
      cnop cfv cc0 wne cc0 cT cnop cfv clt wbr cT cnop cfv cr wcel chil chil cT
      wf cT cnop cfv cc0 wne cc0 cT cnop cfv clt wbr cT cho wcel chil chil cT
      wf cT cnop cfv cc0 wne cc0 cT cnop cfv clt wbr cT nmopgt0 biimpa cT hmopf
      sylan adantlr sylanc cT cnop cfv cr wcel cT cnop cfv cc0 wne cc0 c1 cT
      cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle wbr wi cT cho
      wcel cT cnop cfv cr wcel cT cnop cfv cc0 wne wa c1 cT cnop cfv cdiv co cr
      wcel cc0 c1 cT cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle
      wbr wi cT cnop cfv rereccl cc0 cr wcel c1 cT cnop cfv cdiv co cr wcel cc0
      c1 cT cnop cfv cdiv co clt wbr cc0 c1 cT cnop cfv cdiv co cle wbr wi 0re
      cc0 c1 cT cnop cfv cdiv co ltle mpan syl adantll mpd cT cho wcel cT cnop
      cfv cr wcel wa cT cT cnop cfv chio chot co cleo wbr cT cnop cfv cc0 wne
      cT leopnmid adantr jca sylanc cT cnop cfv cr wcel cT cnop cfv cc0 wne c1
      cT cnop cfv cdiv co cT cnop cfv chio chot co chot co chio wceq cT cho
      wcel cT cnop cfv cc wcel cT cnop cfv cc0 wne c1 cT cnop cfv cdiv co cT
      cnop cfv chio chot co chot co chio wceq cT cnop cfv cr wcel cT cnop cfv
      cc wcel cT cnop cfv cc0 wne wa c1 cT cnop cfv cdiv co cT cnop cfv chio
      chot co chot co c1 chio chot co chio cT cnop cfv cc wcel cT cnop cfv cc0
      wne wa c1 cT cnop cfv cdiv co cT cnop cfv cmul co chio chot co c1 cT cnop
      cfv cdiv co cT cnop cfv chio chot co chot co c1 chio chot co c1 cT cnop
      cfv cdiv co cc wcel cT cnop cfv cc wcel c1 cT cnop cfv cdiv co cT cnop
      cfv cmul co chio chot co c1 cT cnop cfv cdiv co cT cnop cfv chio chot co
      chot co wceq cT cnop cfv cc wcel cT cnop cfv cc0 wne wa c1 cT cnop cfv
      cdiv co cc wcel cT cnop cfv cc wcel chil chil chio wf c1 cT cnop cfv cdiv
      co cT cnop cfv cmul co chio chot co c1 cT cnop cfv cdiv co cT cnop cfv
      chio chot co chot co wceq chil chil chio wf1o chil chil chio wf hoif chil
      chil chio f1of ax-mp c1 cT cnop cfv cdiv co cT cnop cfv chio homulass
      mp3an3 cT cnop cfv reccl cT cnop cfv cc wcel cT cnop cfv cc0 wne pm3.26
      sylanc cT cnop cfv cc wcel cT cnop cfv cc0 wne wa c1 cT cnop cfv cdiv co
      cT cnop cfv cmul co c1 chio chot cT cnop cfv recid2 opreq1d eqtr3d chil
      chil chio wf c1 chio chot co chio wceq chil chil chio wf1o chil chil chio
      wf hoif chil chil chio f1of ax-mp chio homulid2 ax-mp syl6eq cT cnop cfv
      recn sylan adantll breqtrd syldan 3impa $.
      $( [22-Sep-2006] $) $( [12-Aug-2006] $)
  $}

  ${
    $d u v T $.
    opsqrlem1.1 $e |- T e. HrmOp $.
    opsqrlem1.2 $e |- ( normop ` T ) e. RR $.
    opsqrlem1.3 $e |- 0hop <_op T $.
    opsqrlem1.4 $e |- R = ( ( 1 / ( normop ` T ) ) .op T ) $.
    opsqrlem1.5 $e |- ( T =/= 0hop -> E. u e. HrmOp ( 0hop <_op u /\
                      ( u o. u ) = R ) ) $.
  $}

  ${
    $d v w G $.  $d v H $.  $d v w S $.  $d v w x y z T $.
    $d j k F $.  $d j k N $.
    opsqrlem2.1 $e |- T e. HrmOp $.
    opsqrlem2.2 $e |- S = { <. <. x , y >. , z >. | ( ( x e. HrmOp /\
    y e. HrmOp ) /\ z = ( x +op ( ( 1 / 2 ) .op ( T -op ( x o. x ) ) ) ) ) } $.
    opsqrlem2.3 $e |- F = ( S seq1 ( NN X. { 0hop } ) ) $.

    ${
      opsqrlem6.4 $e |- T <_op Iop $.
    $}
  $}

  ${
    opsqrlem8.1 $e |- T e. HrmOp $.
    opsqrlem8.2 $e |- 0hop <_op T $.
    opsqrlem8.3 $e |- T <_op Iop $.
  $}

  ${
    $d u T $.
  $}

  ${
    $d u v T $.
    opsqr.1 $e |- T e. HrmOp $.
    opsqr.2 $e |- ( normop ` T ) e. RR $.
    opsqr.3 $e |- 0hop <_op T $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors as operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z H $.
    pjhmop.1 $e |- H e. CH $.
    $( A projector is a Hermitian operator. $)
    pjhmopi $p |- ( proj ` H ) e. HrmOp $=
      cH cpj cfv cho wcel chil chil cH cpj cfv wf vx cv vy cv cH cpj cfv cfv
      csp co vx cv cH cpj cfv cfv vy cv csp co wceq vy chil wral vx chil wral
      vx vy cH cpj cfv elhmop cH pjhmop.1 pjfi vx cv vy cv cH cpj cfv cfv csp
      co vx cv cH cpj cfv cfv vy cv csp co wceq vx vy chil vx cv chil wcel vy
      cv chil wcel wa vx cv cH cpj cfv cfv vy cv csp co vx cv vy cv cH cpj cfv
      cfv csp co vx cv vy cv cH pjhmop.1 pjadji eqcomd rgen2a mpbir2an $.
      $( [28-May-2006] $) $( [24-Mar-2006] $)

    $( A projector is a linear operator. $)
    pjlnopi $p |- ( proj ` H ) e. LinOp $=
      cH cpj cfv cho wcel cH cpj cfv clo wcel cH pjhmop.1 pjhmopi cH cpj cfv
      hmoplin ax-mp $.
      $( [27-Jun-2006] $) $( [24-Mar-2006] $)

    $( The operator norm of a projector on a non-zero closed subspace is
       one.  Part of Theorem 26.1 of [Halmos] p. 43. $)
    pjnmopi $p |- ( H =/= 0H -> ( normop ` ( proj ` H ) ) = 1 ) $=
      cH c0h wne vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv
      wceq wa vy chil wrex vx cab cxr clt csup c1 cH cpj cfv cnop cfv cH c0h
      wne vz cv c1 clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx
      cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab wrex wi vz cr
      wral vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa
      vy chil wrex vx cab cxr clt csup c1 wceq cH c0h wne vz cv c1 clt wbr vz
      cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv
      cno cfv wceq wa vy chil wrex vx cab wrex wi vz cr cH c0h wne vz cv c1 clt
      wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj
      cfv cfv cno cfv wceq wa vy chil wrex vx cab wrex wi vz cv cr wcel cH c0h
      wne vz cv c1 clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx
      cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab wrex c1 vy cv
      cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil
      wrex vx cab wcel vz cv c1 clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1
      cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab
      wrex cH c0h wne vz cv vw cv clt wbr vz cv c1 clt wbr vw c1 vy cv cno cfv
      c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab
      vw cv c1 vz cv clt breq2 rcla4ev vy cv cno cfv c1 wceq vy cH wrex vy cv
      cno cfv c1 cle wbr c1 vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex
      cH c0h wne c1 vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv
      wceq wa vy chil wrex vx cab wcel vy cv cno cfv c1 wceq vy cv cno cfv c1
      cle wbr c1 vy cv cH cpj cfv cfv cno cfv wceq wa vy cH chil vy cv cH wcel
      vy cv cno cfv c1 wceq wa vy cv chil wcel vy cv cno cfv c1 cle wbr c1 vy
      cv cH cpj cfv cfv cno cfv wceq wa vy cv cH wcel vy cv chil wcel vy cv cno
      cfv c1 wceq vy cv cH pjhmop.1 cheli adantr vy cv cH wcel vy cv cno cfv c1
      wceq wa vy cv cno cfv c1 cle wbr c1 vy cv cH cpj cfv cfv cno cfv wceq vy
      cv cno cfv cr wcel vy cv cno cfv c1 wceq vy cv cno cfv c1 cle wbr vy cv
      cH wcel vy cv cno cfv c1 eqle vy cv cH wcel vy cv chil wcel vy cv cno cfv
      cr wcel vy cv cH pjhmop.1 cheli vy cv normcl syl sylan vy cv cH wcel vy
      cv cno cfv c1 wceq wa vy cv cH cpj cfv cfv cno cfv vy cv cno cfv c1 vy cv
      cH wcel vy cv cH cpj cfv cfv cno cfv vy cv cno cfv wceq vy cv cno cfv c1
      wceq vy cv cH wcel vy cv cH cpj cfv cfv vy cv cno cH cch wcel vy cv cH
      wcel vy cv cH cpj cfv cfv vy cv wceq pjhmop.1 vy cv cH pjid mpan fveq2d
      adantr vy cv cH wcel vy cv cno cfv c1 wceq pm3.27 eqtr2d jca jca r19.22i2
      cH c0h wne vy cv c0v wne vy cH wrex vy cv cno cfv c1 wceq vy cH wrex vy
      cH pjhmop.1 chne0i vy vy cH cH pjhmop.1 chshii norm1exi bitri vy cv cno
      cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vy
      cv cno cfv c1 cle wbr c1 vy cv cH cpj cfv cfv cno cfv wceq wa vy chil
      wrex vx c1 c1 cr 1re elisseti vx cv c1 wceq vy cv cno cfv c1 cle wbr vx
      cv vy cv cH cpj cfv cfv cno cfv wceq wa vy cv cno cfv c1 cle wbr c1 vy cv
      cH cpj cfv cfv cno cfv wceq wa vy chil vx cv c1 wceq vx cv vy cv cH cpj
      cfv cfv cno cfv wceq c1 vy cv cH cpj cfv cfv cno cfv wceq vy cv cno cfv
      c1 cle wbr vx cv c1 vy cv cH cpj cfv cfv cno cfv eqeq1 anbi2d rexbidv
      elab 3imtr4i sylan ex a1d r19.21aiv vz cv c1 cle wbr vz vy cv cno cfv c1
      cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab
      wral vz cv c1 clt wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx
      cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab wrex wi vz cr
      wral vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa
      vy chil wrex vx cab cxr clt csup c1 wceq vz cv c1 cle wbr vz vy cv cno
      cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx
      cab vz cv vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv
      wceq wa vy chil wrex vx cab wcel vy cv cno cfv c1 cle wbr vz cv vy cv cH
      cpj cfv cfv cno cfv wceq wa vy chil wrex vz cv c1 cle wbr vy cv cno cfv
      c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vy cv
      cno cfv c1 cle wbr vz cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil
      wrex vx vz cv vz visset vx cv vz cv wceq vy cv cno cfv c1 cle wbr vx cv
      vy cv cH cpj cfv cfv cno cfv wceq wa vy cv cno cfv c1 cle wbr vz cv vy cv
      cH cpj cfv cfv cno cfv wceq wa vy chil vx cv vz cv wceq vx cv vy cv cH
      cpj cfv cfv cno cfv wceq vz cv vy cv cH cpj cfv cfv cno cfv wceq vy cv
      cno cfv c1 cle wbr vx cv vz cv vy cv cH cpj cfv cfv cno cfv eqeq1 anbi2d
      rexbidv elab vy cv cno cfv c1 cle wbr vz cv vy cv cH cpj cfv cfv cno cfv
      wceq wa vz cv c1 cle wbr vy chil vy cv chil wcel vy cv cno cfv c1 cle wbr
      vz cv vy cv cH cpj cfv cfv cno cfv wceq vz cv c1 cle wbr vy cv chil wcel
      vy cv cno cfv c1 cle wbr vz cv vy cv cH cpj cfv cfv cno cfv wceq vz cv c1
      cle wbr vy cv cH cpj cfv cfv cno cfv c1 cle wbr vz cv vy cv cH cpj cfv
      cfv cno cfv wceq vz cv c1 cle wbr vy cv chil wcel vy cv cno cfv c1 cle
      wbr wa vz cv vy cv cH cpj cfv cfv cno cfv wceq vz cv c1 cle wbr vy cv cH
      cpj cfv cfv cno cfv c1 cle wbr vz cv vy cv cH cpj cfv cfv cno cfv c1 cle
      breq1 biimparc vy cv chil wcel vy cv cno cfv c1 cle wbr vy cv cH cpj cfv
      cfv cno cfv c1 cle wbr vy cv chil wcel vy cv cH cpj cfv cfv cno cfv vy cv
      cno cfv cle wbr vy cv cno cfv c1 cle wbr vy cv cH cpj cfv cfv cno cfv c1
      cle wbr cH cch wcel vy cv chil wcel vy cv cH cpj cfv cfv cno cfv vy cv
      cno cfv cle wbr pjhmop.1 vy cv cH pjnorm mpan vy cv cH cpj cfv cfv cno
      cfv cr wcel vy cv cno cfv cr wcel vy cv cH cpj cfv cfv cno cfv vy cv cno
      cfv cle wbr vy cv cno cfv c1 cle wbr wa vy cv cH cpj cfv cfv cno cfv c1
      cle wbr wi vy cv chil wcel vy cv cH cpj cfv cfv cno cfv cr wcel vy cv cno
      cfv cr wcel c1 cr wcel vy cv cH cpj cfv cfv cno cfv vy cv cno cfv cle wbr
      vy cv cno cfv c1 cle wbr wa vy cv cH cpj cfv cfv cno cfv c1 cle wbr wi
      1re vy cv cH cpj cfv cfv cno cfv vy cv cno cfv c1 letr mp3an3 vy cv chil
      wcel vy cv cH cpj cfv cfv chil wcel vy cv cH cpj cfv cfv cno cfv cr wcel
      vy cv cH pjhmop.1 pjhcli vy cv cH cpj cfv cfv normcl syl vy cv normcl
      sylanc mpand imp sylan exp31 imp3a r19.23aiv sylbi rgen vy cv cno cfv c1
      cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab
      cxr wss c1 cxr wcel vz cv c1 cle wbr vz vy cv cno cfv c1 cle wbr vx cv vy
      cv cH cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab wral vz cv c1 clt
      wbr vz cv vw cv clt wbr vw vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj
      cfv cfv cno cfv wceq wa vy chil wrex vx cab wrex wi vz cr wral wa vy cv
      cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa vy chil
      wrex vx cab cxr clt csup c1 wceq vy cv cno cfv c1 cle wbr vx cv vy cv cH
      cpj cfv cfv cno cfv wceq wa vy chil wrex vx cab cr cxr chil chil cH cpj
      cfv wf vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq
      wa vy chil wrex vx cab cr wss cH pjhmop.1 pjfi vx vy cH cpj cfv
      nmopsetretHIL ax-mp ressxr sstri c1 cr wcel c1 cxr wcel 1re c1 rexr ax-mp
      vz vw vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno cfv wceq wa
      vy chil wrex vx cab c1 supxr2 mpanl12 mpan syl chil chil cH cpj cfv wf cH
      cpj cfv cnop cfv vy cv cno cfv c1 cle wbr vx cv vy cv cH cpj cfv cfv cno
      cfv wceq wa vy chil wrex vx cab cxr clt csup wceq cH pjhmop.1 pjfi vx vy
      cH cpj cfv nmopval ax-mp syl5eq $.
      $( [30-Jun-2006] $) $( [9-Apr-2006] $)

    $( A projector is a bounded linear operator. $)
    pjbdlni $p |- ( proj ` H ) e. BndLinOp $=
      cH cpj cfv cbo wcel cH cpj cfv clo wcel cH cpj cfv cnop cfv cr wcel cH
      cpj cfv elbdop2 cH pjhmop.1 pjlnopi cH cch wcel cH cpj cfv cnop cfv cr
      wcel pjhmop.1 cH cch wcel cH cpj cfv cnop cfv cr wcel c0h cpj cfv cnop
      cfv cr wcel cH c0h cH c0h wceq cH cpj cfv cnop cfv c0h cpj cfv cnop cfv
      cr cH c0h wceq cH cpj cfv c0h cpj cfv cnop cH c0h cpj fveq2 fveq2d eleq1d
      cH c0h wne cH cpj cfv cnop cfv cr wcel cH cch wcel cH c0h wne cH cpj cfv
      cnop cfv c1 cr cH pjhmop.1 pjnmopi 1re syl6eqel adantl c0h cpj cfv cnop
      cfv cr wcel cH cch wcel c0h cpj cfv cnop cfv cc0 cr ch0o cnop cfv c0h cpj
      cfv cnop cfv cc0 ch0o c0h cpj cfv cnop df-h0op fveq2i nmop0 eqtr3i 0re
      eqeltri a1i pm2.61ne ax-mp mpbir2an $.
      $( [7-Jul-2006] $) $( [3-Jun-2006] $)
  $}

  $( A projection is a Hermitian operator. $)
  pjhmop $p |- ( H e. CH -> ( proj ` H ) e. HrmOp ) $=
    cH cch wcel cH cpj cfv cho wcel cH cch wcel cH c0h cif cpj cfv cho wcel cH
    c0h cH cH cch wcel cH c0h cif wceq cH cpj cfv cH cch wcel cH c0h cif cpj
    cfv cho cH cH cch wcel cH c0h cif cpj fveq2 eleq1d cH cch wcel cH c0h cif
    cH c0h cch h0elch elimel pjhmopi dedth $.
    $( [8-Jun-2006] $) $( [24-Apr-2006] $)

  ${
    $d f m y z H $.  $d m x z y T $.  $d f m n x y z $.
    hmopidmch.1 $e |- H = { x e. ~H | ( T ` x ) = x } $.
    hmopidmch.2 $e |- ( T e. HrmOp /\ ( T o. T ) = T ) $.
    $( Lemma for ~ hmopidmchi . $)
    hmopidmchlem $p |- ( A e. ~H -> ( normh ` ( T ` A ) ) <_ ( normh ` A ) ) $=
      cA chil wcel cc0 cA cT cfv cno cfv cle wbr cA cT cfv cno cfv cA cno cfv
      cle wbr cA chil wcel cA cT cfv chil wcel cc0 cA cT cfv cno cfv cle wbr
      chil chil cA cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq
      hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cA cT cfv normge0
      syl cA chil wcel cc0 cA cT cfv cno cfv cle wbr cc0 cA cT cfv cno cfv clt
      wbr cc0 cA cT cfv cno cfv wceq wo cA cT cfv cno cfv cA cno cfv cle wbr cA
      chil wcel cA cT cfv chil wcel cA cT cfv cno cfv cr wcel cc0 cA cT cfv cno
      cfv cle wbr cc0 cA cT cfv cno cfv clt wbr cc0 cA cT cfv cno cfv wceq wo
      wb chil chil cA cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT
      wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cA cT cfv
      normcl cc0 cr wcel cA cT cfv cno cfv cr wcel cc0 cA cT cfv cno cfv cle
      wbr cc0 cA cT cfv cno cfv clt wbr cc0 cA cT cfv cno cfv wceq wo wb 0re
      cc0 cA cT cfv cno cfv leloe mpan 3syl cA chil wcel cc0 cA cT cfv cno cfv
      clt wbr cc0 cA cT cfv cno cfv wceq wo cA cT cfv cno cfv cA cno cfv cle
      wbr cA chil wcel cc0 cA cT cfv cno cfv clt wbr cA cT cfv cno cfv cA cno
      cfv cle wbr cc0 cA cT cfv cno cfv wceq cA chil wcel cc0 cA cT cfv cno cfv
      clt wbr wa cA cT cfv cno cfv cA cno cfv cle wbr cA cT cfv cno cfv cA cT
      cfv cno cfv cmul co cA cT cfv cno cfv cA cno cfv cmul co cle wbr cA chil
      wcel cA cT cfv cno cfv cA cT cfv cno cfv cmul co cA cT cfv cno cfv cA cno
      cfv cmul co cle wbr cc0 cA cT cfv cno cfv clt wbr cA chil wcel cA cT cfv
      cno cfv cA cT cfv cno cfv cmul co cA cT cfv cA csp co cabs cfv cA cT cfv
      cno cfv cA cno cfv cmul co cle cA chil wcel cA cT cfv cno cfv c2 cexp co
      cA cT cfv cA cT cfv csp co cA cT cfv cno cfv cA cT cfv cno cfv cmul co cA
      cT cfv cA csp co cabs cfv cA chil wcel cA cT cfv chil wcel cA cT cfv cno
      cfv c2 cexp co cA cT cfv cA cT cfv csp co wceq chil chil cA cT cT cT cho
      wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT
      hmoplin ax-mp lnopfi ffvelrni cA cT cfv normsq syl cA chil wcel cA cT cfv
      cno cfv cc wcel cA cT cfv cno cfv c2 cexp co cA cT cfv cno cfv cA cT cfv
      cno cfv cmul co wceq cA chil wcel cA cT cfv cno cfv cA chil wcel cA cT
      cfv chil wcel cA cT cfv cno cfv cr wcel chil chil cA cT cT cT cho wcel cT
      clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin
      ax-mp lnopfi ffvelrni cA cT cfv normcl syl recnd cA cT cfv cno cfv sqval
      syl cA chil wcel cA cT cfv cA csp co cabs cfv cA cT cfv cA cT cfv csp co
      cabs cfv cA cT cfv cA cT cfv csp co cA chil wcel cA cT cfv cA csp co cA
      cT cfv cA cT cfv csp co cabs cA chil wcel cA cT cfv cA cT cfv csp co cA
      cT cfv cT cfv cA csp co cA cT cfv cA csp co cA cT cfv chil wcel cA chil
      wcel cA cT cfv cA cT cfv csp co cA cT cfv cT cfv cA csp co wceq chil chil
      cA cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq
      hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cT cho wcel cA cT
      cfv chil wcel cA chil wcel cA cT cfv cA cT cfv csp co cA cT cfv cT cfv cA
      csp co wceq cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cA cT cfv
      cA cT hmop mp3an1 mpancom cA chil wcel cA cT cfv cT cfv cA cT cfv cA csp
      cA chil wcel cA cT cT ccom cfv cA cT cfv cT cfv cA cT cfv cA cT cT cT cT
      cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i
      cT hmoplin ax-mp lnopfi cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom
      cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi hocoi cA cT cT ccom
      cT cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.27i fveq1i syl5reqr
      opreq1d eqtr2d fveq2d cA cT cfv cA cT cfv csp co cr wcel cc0 cA cT cfv cA
      cT cfv csp co cle wbr cA cT cfv cA cT cfv csp co cabs cfv cA cT cfv cA cT
      cfv csp co wceq cA chil wcel cA cT cfv cA cT cfv csp co absid cA chil
      wcel cA cT cfv chil wcel cA cT cfv cA cT cfv csp co cr wcel chil chil cA
      cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cA cT cfv hiidrcl syl cA chil
      wcel cA cT cfv chil wcel cc0 cA cT cfv cA cT cfv csp co cle wbr chil chil
      cA cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq
      hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cA cT cfv hiidge0
      syl sylanc eqtr2d 3eqtr3d cA cT cfv chil wcel cA chil wcel cA cT cfv cA
      csp co cabs cfv cA cT cfv cno cfv cA cno cfv cmul co cle wbr chil chil cA
      cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cA cT cfv cA bcs mpancom eqbrtrd
      adantr cA cT cfv cno cfv cr wcel cA cno cfv cr wcel cA cT cfv cno cfv cr
      wcel w3a cc0 cA cT cfv cno cfv clt wbr cA cT cfv cno cfv cA cno cfv cle
      wbr cA cT cfv cno cfv cA cT cfv cno cfv cmul co cA cT cfv cno cfv cA cno
      cfv cmul co cle wbr wb cA chil wcel cA cT cfv cno cfv cA cno cfv cA cT
      cfv cno cfv lemul2OLD cA chil wcel cA cT cfv cno cfv cr wcel cA cno cfv
      cr wcel cA cT cfv cno cfv cr wcel cA chil wcel cA cT cfv chil wcel cA cT
      cfv cno cfv cr wcel chil chil cA cT cT cT cho wcel cT clo wcel cT cho
      wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi
      ffvelrni cA cT cfv normcl syl cA normcl cA chil wcel cA cT cfv chil wcel
      cA cT cfv cno cfv cr wcel chil chil cA cT cT cT cho wcel cT clo wcel cT
      cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi
      ffvelrni cA cT cfv normcl syl 3jca sylan mpbird cA chil wcel cc0 cA cT
      cfv cno cfv wceq wa cc0 cA cT cfv cno cfv cA cno cfv cle cA chil wcel cc0
      cA cT cfv cno cfv wceq pm3.27 cA chil wcel cc0 cA cno cfv cle wbr cc0 cA
      cT cfv cno cfv wceq cA normge0 adantr eqbrtrrd jaodan ex sylbid mpd $.
      $( [11-Jun-2006] $) $( [12-Apr-2006] $)

    $( An idempotent Hermitian operator generates a closed subspace.  Part of
       proof of Theorem of [AkhiezerGlazman] p. 64. $)
    hmopidmchi $p |- H e. CH $=
      cH cch wcel cH csh wcel cn cH vf cv wf vf cv vy cv chli wbr wa vy cv cH
      wcel wi vy wal vf wal vy vf cH closedsub cH csh wcel c0v cH wcel vy cv vz
      cv cva co cH wcel vz cH wral vy cH wral vy cv vz cv csm co cH wcel vz cH
      wral vy cc wral wa cH chil wss cH csh wcel c0v cH wcel vy cv vz cv cva co
      cH wcel vz cH wral vy cH wral vy cv vz cv csm co cH wcel vz cH wral vy cc
      wral wa wa wb cH vx cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx
      cv cT cfv vx cv wceq vx chil ssrab2 eqsstri vy vz cH sh2 ax-mp c0v vx cv
      cT cfv vx cv wceq vx chil crab cH c0v vx cv cT cfv vx cv wceq vx chil
      crab wcel c0v chil wcel c0v cT cfv c0v wceq vx cv cT cfv vx cv wceq c0v
      cT cfv c0v wceq vx c0v chil vx cv c0v wceq vx cv cT cfv c0v cT cfv vx cv
      c0v vx cv c0v cT fveq2 vx cv c0v wceq id eqeq12d elrab ax-hv0cl cT cT cho
      wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT
      hmoplin ax-mp lnop0i mpbir2an hmopidmch.1 eleqtrri vy cv vz cv cva co cH
      wcel vz cH wral vy cH wral vy cv vz cv csm co cH wcel vz cH wral vy cc
      wral vy cv vz cv cva co cH wcel vy vz cH vy cv cH wcel vz cv cH wcel wa
      vy cv vz cv cva co vx cv cT cfv vx cv wceq vx chil crab cH vy cv cH wcel
      vz cv cH wcel wa vy cv vz cv cva co chil wcel vy cv vz cv cva co cT cfv
      vy cv vz cv cva co wceq wa vy cv vz cv cva co vx cv cT cfv vx cv wceq vx
      chil crab wcel vy cv chil wcel vy cv cT cfv vy cv wceq wa vz cv chil wcel
      vz cv cT cfv vz cv wceq wa vy cv vz cv cva co chil wcel vy cv vz cv cva
      co cT cfv vy cv vz cv cva co wceq wa vy cv cH wcel vz cv cH wcel vy cv
      chil wcel vy cv cT cfv vy cv wceq wa vz cv chil wcel vz cv cT cfv vz cv
      wceq wa wa vy cv vz cv cva co chil wcel vy cv vz cv cva co cT cfv vy cv
      vz cv cva co wceq vy cv chil wcel vz cv chil wcel vy cv vz cv cva co chil
      wcel vy cv cT cfv vy cv wceq vz cv cT cfv vz cv wceq vy cv vz cv hvaddcl
      ad2ant2r vy cv chil wcel vz cv chil wcel vy cv cT cfv vy cv wceq vz cv cT
      cfv vz cv wceq vy cv vz cv cva co cT cfv vy cv vz cv cva co wceq vy cv
      chil wcel vz cv chil wcel wa vy cv cT cfv vy cv wceq vz cv cT cfv vz cv
      wceq wa vy cv vz cv cva co cT cfv vy cv cT cfv vz cv cT cfv cva co vy cv
      vz cv cva co vy cv vz cv cT cT cho wcel cT clo wcel cT cho wcel cT cT
      ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopaddi vy cv cT cfv
      vy cv vz cv cT cfv vz cv cva opreq12 sylan9eq an4s jca vx cv cT cfv vx cv
      wceq vy cv cT cfv vy cv wceq vx vy cv chil cH vx cv vy cv wceq vx cv cT
      cfv vy cv cT cfv vx cv vy cv vx cv vy cv cT fveq2 vx cv vy cv wceq id
      eqeq12d hmopidmch.1 elrab2 vx cv cT cfv vx cv wceq vz cv cT cfv vz cv
      wceq vx vz cv chil cH vx cv vz cv wceq vx cv cT cfv vz cv cT cfv vx cv vz
      cv vx cv vz cv cT fveq2 vx cv vz cv wceq id eqeq12d hmopidmch.1 elrab2
      syl2anb vx cv cT cfv vx cv wceq vy cv vz cv cva co cT cfv vy cv vz cv cva
      co wceq vx vy cv vz cv cva co chil vx cv vy cv vz cv cva co wceq vx cv cT
      cfv vy cv vz cv cva co cT cfv vx cv vy cv vz cv cva co vx cv vy cv vz cv
      cva co cT fveq2 vx cv vy cv vz cv cva co wceq id eqeq12d elrab sylibr
      hmopidmch.1 syl6eleqr rgen2a vy cv vz cv csm co cH wcel vy vz cc cH vy cv
      cc wcel vz cv cH wcel wa vy cv vz cv csm co vx cv cT cfv vx cv wceq vx
      chil crab cH vy cv cc wcel vz cv cH wcel wa vy cv vz cv csm co chil wcel
      vy cv vz cv csm co cT cfv vy cv vz cv csm co wceq wa vy cv vz cv csm co
      vx cv cT cfv vx cv wceq vx chil crab wcel vy cv cc wcel vz cv chil wcel
      vz cv cT cfv vz cv wceq wa vy cv vz cv csm co chil wcel vy cv vz cv csm
      co cT cfv vy cv vz cv csm co wceq wa vz cv cH wcel vy cv cc wcel vz cv
      chil wcel vz cv cT cfv vz cv wceq vy cv vz cv csm co chil wcel vy cv vz
      cv csm co cT cfv vy cv vz cv csm co wceq wa vy cv cc wcel vz cv chil wcel
      wa vz cv cT cfv vz cv wceq wa vy cv vz cv csm co chil wcel vy cv vz cv
      csm co cT cfv vy cv vz cv csm co wceq vy cv cc wcel vz cv chil wcel wa vy
      cv vz cv csm co chil wcel vz cv cT cfv vz cv wceq vy cv vz cv hvmulcl
      adantr vy cv cc wcel vz cv chil wcel wa vz cv cT cfv vz cv wceq vy cv vz
      cv csm co cT cfv vy cv vz cv cT cfv csm co vy cv vz cv csm co vy cv vz cv
      cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopmuli vz cv cT cfv vz cv vy cv csm opreq2
      sylan9eq jca anasss vx cv cT cfv vx cv wceq vz cv cT cfv vz cv wceq vx vz
      cv chil cH vx cv vz cv wceq vx cv cT cfv vz cv cT cfv vx cv vz cv vx cv
      vz cv cT fveq2 vx cv vz cv wceq id eqeq12d hmopidmch.1 elrab2 sylan2b vx
      cv cT cfv vx cv wceq vy cv vz cv csm co cT cfv vy cv vz cv csm co wceq vx
      vy cv vz cv csm co chil vx cv vy cv vz cv csm co wceq vx cv cT cfv vy cv
      vz cv csm co cT cfv vx cv vy cv vz cv csm co vx cv vy cv vz cv csm co cT
      fveq2 vx cv vy cv vz cv csm co wceq id eqeq12d elrab sylibr hmopidmch.1
      syl6eleqr rgen2 pm3.2i mpbir2an cn cH vf cv wf vf cv vy cv chli wbr wa vy
      cv cH wcel wi vf vy cn cH vf cv wf vf cv vy cv chli wbr wa vy cv chil
      wcel vy cv cT cfv vy cv wceq wa vy cv cH wcel cn cH vf cv wf vf cv vy cv
      chli wbr wa vy cv chil wcel vy cv cT cfv vy cv wceq vf cv vy cv chli wbr
      vy cv chil wcel cn cH vf cv wf vy cv vf cv vf visset vy visset hlimveci
      adantl cn cH vf cv wf vf cv vy cv chli wbr wa vy cv cT cfv vy cv cmv co
      c0v wceq vy cv cT cfv vy cv wceq cn cH vf cv wf vf cv vy cv chli wbr wa
      vy cv cT cfv vy cv cmv co cno cfv cc0 wceq vy cv cT cfv vy cv cmv co c0v
      wceq cn cH vf cv wf vf cv vy cv chli wbr wa vy cv cT cfv vy cv cmv co cno
      cfv c2 cdiv co cc0 wceq vy cv cT cfv vy cv cmv co cno cfv cc0 wceq vy cv
      cT cfv vy cv cmv co cno cfv c2 cdiv co cr wcel cc0 vy cv cT cfv vy cv cmv
      co cno cfv c2 cdiv co cle wbr cc0 vz cv clt wbr vy cv cT cfv vy cv cmv co
      cno cfv c2 cdiv co vz cv clt wbr wi vz cr wral vy cv cT cfv vy cv cmv co
      cno cfv c2 cdiv co cc0 wceq cn cH vf cv wf vf cv vy cv chli wbr wa vz vy
      cv cT cfv vy cv cmv co cno cfv c2 cdiv co squeeze0 vf cv vy cv chli wbr
      vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co cr wcel cn cH vf cv wf vf cv
      vy cv chli wbr vy cv cT cfv vy cv cmv co cno cfv cr wcel vy cv cT cfv vy
      cv cmv co cno cfv c2 cdiv co cr wcel vf cv vy cv chli wbr vy cv cT cfv vy
      cv cmv co chil wcel vy cv cT cfv vy cv cmv co cno cfv cr wcel vy cv cT
      cfv chil wcel vy cv chil wcel vy cv cT cfv vy cv cmv co chil wcel vf cv
      vy cv chli wbr vy cv cT cfv vy cv hvsubcl vf cv vy cv chli wbr vy cv chil
      wcel vy cv cT cfv chil wcel vy cv vf cv vf visset vy visset hlimveci chil
      chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq
      hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni syl vy cv vf cv vf
      visset vy visset hlimveci sylanc vy cv cT cfv vy cv cmv co normcl syl vy
      cv cT cfv vy cv cmv co cno cfv rehalfcl syl adantl vf cv vy cv chli wbr
      cc0 vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co cle wbr cn cH vf cv wf
      vf cv vy cv chli wbr cc0 vy cv cT cfv vy cv cmv co cno cfv cle wbr cc0 vy
      cv cT cfv vy cv cmv co cno cfv c2 cdiv co cle wbr vf cv vy cv chli wbr vy
      cv cT cfv vy cv cmv co chil wcel cc0 vy cv cT cfv vy cv cmv co cno cfv
      cle wbr vy cv cT cfv chil wcel vy cv chil wcel vy cv cT cfv vy cv cmv co
      chil wcel vf cv vy cv chli wbr vy cv cT cfv vy cv hvsubcl vf cv vy cv
      chli wbr vy cv chil wcel vy cv cT cfv chil wcel vy cv vf cv vf visset vy
      visset hlimveci chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel
      cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni
      syl vy cv vf cv vf visset vy visset hlimveci sylanc vy cv cT cfv vy cv
      cmv co normge0 syl vf cv vy cv chli wbr vy cv cT cfv vy cv cmv co cno cfv
      cr wcel cc0 vy cv cT cfv vy cv cmv co cno cfv cle wbr cc0 vy cv cT cfv vy
      cv cmv co cno cfv c2 cdiv co cle wbr wb vf cv vy cv chli wbr vy cv cT cfv
      vy cv cmv co chil wcel vy cv cT cfv vy cv cmv co cno cfv cr wcel vy cv cT
      cfv chil wcel vy cv chil wcel vy cv cT cfv vy cv cmv co chil wcel vf cv
      vy cv chli wbr vy cv cT cfv vy cv hvsubcl vf cv vy cv chli wbr vy cv chil
      wcel vy cv cT cfv chil wcel vy cv vf cv vf visset vy visset hlimveci chil
      chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq
      hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni syl vy cv vf cv vf
      visset vy visset hlimveci sylanc vy cv cT cfv vy cv cmv co normcl syl vy
      cv cT cfv vy cv cmv co cno cfv halfnneg2 syl mpbid adantl cn cH vf cv wf
      vf cv vy cv chli wbr wa cc0 vz cv clt wbr vm cv vn cv cle wbr vn cv vf cv
      cfv vy cv cmv co cno cfv vz cv clt wbr wi vn cn wral vm cn wrex wi vz cr
      wral cc0 vz cv clt wbr vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co vz cv
      clt wbr wi vz cr wral vf cv vy cv chli wbr cc0 vz cv clt wbr vm cv vn cv
      cle wbr vn cv vf cv cfv vy cv cmv co cno cfv vz cv clt wbr wi vn cn wral
      vm cn wrex wi vz cr wral cn cH vf cv wf vz vm vn vy cv vf cv vf visset vy
      visset hlimconvi adantl cn cH vf cv wf vf cv vy cv chli wbr wa cc0 vz cv
      clt wbr vm cv vn cv cle wbr vn cv vf cv cfv vy cv cmv co cno cfv vz cv
      clt wbr wi vn cn wral vm cn wrex wi cc0 vz cv clt wbr vy cv cT cfv vy cv
      cmv co cno cfv c2 cdiv co vz cv clt wbr wi vz cr cn cH vf cv wf vf cv vy
      cv chli wbr wa vz cv cr wcel wa vm cv vn cv cle wbr vn cv vf cv cfv vy cv
      cmv co cno cfv vz cv clt wbr wi vn cn wral vm cn wrex vy cv cT cfv vy cv
      cmv co cno cfv c2 cdiv co vz cv clt wbr cc0 vz cv clt wbr cn cH vf cv wf
      vf cv vy cv chli wbr wa vz cv cr wcel wa vm cv vn cv cle wbr vn cv vf cv
      cfv vy cv cmv co cno cfv vz cv clt wbr wi vn cn wral vy cv cT cfv vy cv
      cmv co cno cfv c2 cdiv co vz cv clt wbr vm cn cn cH vf cv wf vf cv vy cv
      chli wbr wa vz cv cr wcel wa vm cv cn wcel wa vm cv vn cv cle wbr vn cv
      vf cv cfv vy cv cmv co cno cfv vz cv clt wbr wi vn cn wral vm cv vf cv
      cfv vy cv cmv co cno cfv vz cv clt wbr vy cv cT cfv vy cv cmv co cno cfv
      c2 cdiv co vz cv clt wbr vm cv cn wcel vm cv vn cv cle wbr vn cv vf cv
      cfv vy cv cmv co cno cfv vz cv clt wbr wi vn cn wral vm cv vf cv cfv vy
      cv cmv co cno cfv vz cv clt wbr wi cn cH vf cv wf vf cv vy cv chli wbr wa
      vz cv cr wcel wa vm cv cn wcel vm cv vn cv cle wbr vn cv vf cv cfv vy cv
      cmv co cno cfv vz cv clt wbr wi vn cn wral vm cv vm cv cle wbr vm cv vf
      cv cfv vy cv cmv co cno cfv vz cv clt wbr vm cv cn wcel vm cv cr wcel vm
      cv vm cv cle wbr vm cv nnre vm cv leid syl vm cv vn cv cle wbr vn cv vf
      cv cfv vy cv cmv co cno cfv vz cv clt wbr wi vm cv vm cv cle wbr vm cv vf
      cv cfv vy cv cmv co cno cfv vz cv clt wbr wi vn vm cv cn vn cv vm cv wceq
      vm cv vn cv cle wbr vm cv vm cv cle wbr vn cv vf cv cfv vy cv cmv co cno
      cfv vz cv clt wbr vm cv vf cv cfv vy cv cmv co cno cfv vz cv clt wbr vn
      cv vm cv vm cv cle breq2 vn cv vm cv wceq vn cv vf cv cfv vy cv cmv co
      cno cfv vm cv vf cv cfv vy cv cmv co cno cfv vz cv clt vn cv vm cv wceq
      vn cv vf cv cfv vy cv cmv co vm cv vf cv cfv vy cv cmv co cno vn cv vm cv
      wceq vn cv vf cv cfv vm cv vf cv cfv vy cv cmv vn cv vm cv vf cv fveq2
      opreq1d fveq2d breq1d imbi12d rcla4v mpid adantl cn cH vf cv wf vf cv vy
      cv chli wbr wa vm cv cn wcel vz cv cr wcel vm cv vf cv cfv vy cv cmv co
      cno cfv vz cv clt wbr vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co vz cv
      clt wbr wi vm cv vf cv cfv cH wcel vy cv chil wcel wa vz cv cr wcel vm cv
      vf cv cfv vy cv cmv co cno cfv vz cv clt wbr vy cv cT cfv vy cv cmv co
      cno cfv c2 cdiv co vz cv clt wbr wi cn cH vf cv wf vf cv vy cv chli wbr
      wa vm cv cn wcel wa vm cv vf cv cfv cH wcel vy cv chil wcel wa vz cv cr
      wcel wa vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co vm cv vf cv cfv vy
      cv cmv co cno cfv cle wbr vm cv vf cv cfv vy cv cmv co cno cfv vz cv clt
      wbr vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co vz cv clt wbr vm cv vf
      cv cfv cH wcel vy cv chil wcel wa vy cv cT cfv vy cv cmv co cno cfv c2
      cdiv co vm cv vf cv cfv vy cv cmv co cno cfv cle wbr vz cv cr wcel vm cv
      vf cv cfv cH wcel vy cv chil wcel wa vy cv cT cfv vy cv cmv co cno cfv c2
      cdiv co vm cv vf cv cfv vy cv cmv co cno cfv cle wbr vy cv cT cfv vy cv
      cmv co cno cfv c2 vm cv vf cv cfv vy cv cmv co cno cfv cmul co cle wbr vm
      cv vf cv cfv cH wcel vy cv chil wcel wa vy cv cT cfv vy cv cmv co cno cfv
      vm cv vf cv cfv vy cv cmv co cno cfv vm cv vf cv cfv vy cv cmv co cno cfv
      caddc co c2 vm cv vf cv cfv vy cv cmv co cno cfv cmul co cle vm cv vf cv
      cfv cH wcel vy cv chil wcel wa vy cv cT cfv vy cv cmv co cno cfv vy cv cT
      cfv vm cv vf cv cfv cmv co cno cfv vm cv vf cv cfv vy cv cmv co cno cfv
      caddc co vm cv vf cv cfv vy cv cmv co cno cfv vm cv vf cv cfv vy cv cmv
      co cno cfv caddc co vy cv chil wcel vy cv cT cfv vy cv cmv co cno cfv cr
      wcel vm cv vf cv cfv cH wcel vy cv chil wcel vy cv cT cfv vy cv cmv co
      chil wcel vy cv cT cfv vy cv cmv co cno cfv cr wcel vy cv cT cfv chil
      wcel vy cv chil wcel vy cv cT cfv vy cv cmv co chil wcel chil chil vy cv
      cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopfi ffvelrni vy cv cT cfv vy cv hvsubcl
      mpancom vy cv cT cfv vy cv cmv co normcl syl adantl vy cv cT cfv vm cv vf
      cv cfv cmv co cno cfv cr wcel vm cv vf cv cfv vy cv cmv co cno cfv cr
      wcel vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm cv vf cv cfv vy cv
      cmv co cno cfv caddc co cr wcel vm cv vf cv cfv cH wcel vy cv chil wcel
      wa vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm cv vf cv cfv vy cv cmv
      co cno cfv readdcl vm cv vf cv cfv cH wcel vy cv chil wcel wa vy cv cT
      cfv vm cv vf cv cfv cmv co chil wcel vy cv cT cfv vm cv vf cv cfv cmv co
      cno cfv cr wcel vy cv chil wcel vm cv vf cv cfv cH wcel vy cv cT cfv vm
      cv vf cv cfv cmv co chil wcel vy cv cT cfv chil wcel vm cv vf cv cfv chil
      wcel vy cv cT cfv vm cv vf cv cfv cmv co chil wcel vy cv chil wcel vm cv
      vf cv cfv cH wcel vy cv cT cfv vm cv vf cv cfv hvsubcl chil chil vy cv cT
      cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopfi ffvelrni cH chil vm cv vf cv cfv cH vx cv
      cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq
      vx chil ssrab2 eqsstri sseli syl2an ancoms vy cv cT cfv vm cv vf cv cfv
      cmv co normcl syl vm cv vf cv cfv cH wcel vy cv chil wcel wa vm cv vf cv
      cfv vy cv cmv co chil wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel
      vm cv vf cv cfv chil wcel vy cv chil wcel vm cv vf cv cfv vy cv cmv co
      chil wcel vm cv vf cv cfv cH wcel vm cv vf cv cfv vy cv hvsubcl cH chil
      vm cv vf cv cfv cH vx cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1
      vx cv cT cfv vx cv wceq vx chil ssrab2 eqsstri sseli sylan vm cv vf cv
      cfv vy cv cmv co normcl syl sylanc vm cv vf cv cfv vy cv cmv co cno cfv
      cr wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel vm cv vf cv cfv vy
      cv cmv co cno cfv vm cv vf cv cfv vy cv cmv co cno cfv caddc co cr wcel
      vm cv vf cv cfv cH wcel vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co
      cno cfv vm cv vf cv cfv vy cv cmv co cno cfv readdcl vm cv vf cv cfv cH
      wcel vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co chil wcel vm cv vf
      cv cfv vy cv cmv co cno cfv cr wcel vm cv vf cv cfv chil wcel vy cv chil
      wcel vm cv vf cv cfv vy cv cmv co chil wcel vm cv vf cv cfv cH wcel vm cv
      vf cv cfv vy cv hvsubcl cH chil vm cv vf cv cfv cH vx cv cT cfv vx cv
      wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2
      eqsstri sseli sylan vm cv vf cv cfv vy cv cmv co normcl syl vm cv vf cv
      cfv cH wcel vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co chil wcel vm
      cv vf cv cfv vy cv cmv co cno cfv cr wcel vm cv vf cv cfv chil wcel vy cv
      chil wcel vm cv vf cv cfv vy cv cmv co chil wcel vm cv vf cv cfv cH wcel
      vm cv vf cv cfv vy cv hvsubcl cH chil vm cv vf cv cfv cH vx cv cT cfv vx
      cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil
      ssrab2 eqsstri sseli sylan vm cv vf cv cfv vy cv cmv co normcl syl sylanc
      vy cv cT cfv chil wcel vy cv chil wcel vm cv vf cv cfv chil wcel vy cv cT
      cfv vy cv cmv co cno cfv vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm
      cv vf cv cfv vy cv cmv co cno cfv caddc co cle wbr vm cv vf cv cfv cH
      wcel vy cv chil wcel wa vy cv cT cfv vy cv vm cv vf cv cfv norm3dif vy cv
      chil wcel vy cv cT cfv chil wcel vm cv vf cv cfv cH wcel chil chil vy cv
      cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopfi ffvelrni adantl vm cv vf cv cfv cH wcel
      vy cv chil wcel pm3.27 vm cv vf cv cfv cH wcel vm cv vf cv cfv chil wcel
      vy cv chil wcel cH chil vm cv vf cv cfv cH vx cv cT cfv vx cv wceq vx
      chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2 eqsstri
      sseli adantr syl3anc vm cv vf cv cfv cH wcel vy cv chil wcel wa vy cv cT
      cfv vm cv vf cv cfv cmv co cno cfv vm cv vf cv cfv vy cv cmv co cno cfv
      cle wbr vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm cv vf cv cfv vy cv
      cmv co cno cfv caddc co vm cv vf cv cfv vy cv cmv co cno cfv vm cv vf cv
      cfv vy cv cmv co cno cfv caddc co cle wbr vm cv vf cv cfv cH wcel vy cv
      chil wcel wa vy cv vm cv vf cv cfv cmv co cT cfv cno cfv vy cv vm cv vf
      cv cfv cmv co cno cfv vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm cv
      vf cv cfv vy cv cmv co cno cfv cle vm cv vf cv cfv cH wcel vy cv chil
      wcel wa vy cv vm cv vf cv cfv cmv co chil wcel vy cv vm cv vf cv cfv cmv
      co cT cfv cno cfv vy cv vm cv vf cv cfv cmv co cno cfv cle wbr vm cv vf
      cv cfv chil wcel vy cv chil wcel vy cv vm cv vf cv cfv cmv co chil wcel
      vm cv vf cv cfv cH wcel vy cv chil wcel vm cv vf cv cfv chil wcel vy cv
      vm cv vf cv cfv cmv co chil wcel vy cv vm cv vf cv cfv hvsubcl ancoms cH
      chil vm cv vf cv cfv cH vx cv cT cfv vx cv wceq vx chil crab chil
      hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2 eqsstri sseli sylan vx
      vy cv vm cv vf cv cfv cmv co cT cH hmopidmch.1 hmopidmch.2 hmopidmchlem
      syl vm cv vf cv cfv cH wcel vy cv chil wcel wa vy cv cT cfv vm cv vf cv
      cfv cmv co vy cv vm cv vf cv cfv cmv co cT cfv cno vm cv vf cv cfv cH
      wcel vy cv chil wcel wa vy cv vm cv vf cv cfv cmv co cT cfv vy cv cT cfv
      vm cv vf cv cfv cT cfv cmv co vy cv cT cfv vm cv vf cv cfv cmv co vm cv
      vf cv cfv chil wcel vy cv chil wcel vy cv vm cv vf cv cfv cmv co cT cfv
      vy cv cT cfv vm cv vf cv cfv cT cfv cmv co wceq vm cv vf cv cfv cH wcel
      vy cv chil wcel vm cv vf cv cfv chil wcel vy cv vm cv vf cv cfv cmv co cT
      cfv vy cv cT cfv vm cv vf cv cfv cT cfv cmv co wceq vy cv vm cv vf cv cfv
      cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i cT hmoplin ax-mp lnopsubi ancoms cH chil vm cv vf cv cfv cH vx cv
      cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq
      vx chil ssrab2 eqsstri sseli sylan vm cv vf cv cfv cH wcel vy cv chil
      wcel wa vm cv vf cv cfv cT cfv vm cv vf cv cfv vy cv cT cfv cmv vm cv vf
      cv cfv cH wcel vm cv vf cv cfv cT cfv vm cv vf cv cfv wceq vy cv chil
      wcel vm cv vf cv cfv cH wcel vm cv vf cv cfv chil wcel vm cv vf cv cfv cT
      cfv vm cv vf cv cfv wceq vx cv cT cfv vx cv wceq vm cv vf cv cfv cT cfv
      vm cv vf cv cfv wceq vx vm cv vf cv cfv chil cH vx cv vm cv vf cv cfv
      wceq vx cv cT cfv vm cv vf cv cfv cT cfv vx cv vm cv vf cv cfv vx cv vm
      cv vf cv cfv cT fveq2 vx cv vm cv vf cv cfv wceq id eqeq12d hmopidmch.1
      elrab2 pm3.27bi adantr opreq2d eqtr2d fveq2d vm cv vf cv cfv chil wcel vy
      cv chil wcel vm cv vf cv cfv vy cv cmv co cno cfv vy cv vm cv vf cv cfv
      cmv co cno cfv wceq vm cv vf cv cfv cH wcel vm cv vf cv cfv vy cv normsub
      cH chil vm cv vf cv cfv cH vx cv cT cfv vx cv wceq vx chil crab chil
      hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2 eqsstri sseli sylan
      3brtr4d vy cv cT cfv vm cv vf cv cfv cmv co cno cfv cr wcel vm cv vf cv
      cfv vy cv cmv co cno cfv cr wcel vm cv vf cv cfv vy cv cmv co cno cfv cr
      wcel vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm cv vf cv cfv vy cv
      cmv co cno cfv cle wbr vy cv cT cfv vm cv vf cv cfv cmv co cno cfv vm cv
      vf cv cfv vy cv cmv co cno cfv caddc co vm cv vf cv cfv vy cv cmv co cno
      cfv vm cv vf cv cfv vy cv cmv co cno cfv caddc co cle wbr wb vm cv vf cv
      cfv cH wcel vy cv chil wcel wa vy cv cT cfv vm cv vf cv cfv cmv co cno
      cfv vm cv vf cv cfv vy cv cmv co cno cfv vm cv vf cv cfv vy cv cmv co cno
      cfv leadd1 vm cv vf cv cfv cH wcel vy cv chil wcel wa vy cv cT cfv vm cv
      vf cv cfv cmv co chil wcel vy cv cT cfv vm cv vf cv cfv cmv co cno cfv cr
      wcel vy cv chil wcel vm cv vf cv cfv cH wcel vy cv cT cfv vm cv vf cv cfv
      cmv co chil wcel vy cv cT cfv chil wcel vm cv vf cv cfv chil wcel vy cv
      cT cfv vm cv vf cv cfv cmv co chil wcel vy cv chil wcel vm cv vf cv cfv
      cH wcel vy cv cT cfv vm cv vf cv cfv hvsubcl chil chil vy cv cT cT cT cho
      wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT
      hmoplin ax-mp lnopfi ffvelrni cH chil vm cv vf cv cfv cH vx cv cT cfv vx
      cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil
      ssrab2 eqsstri sseli syl2an ancoms vy cv cT cfv vm cv vf cv cfv cmv co
      normcl syl vm cv vf cv cfv cH wcel vy cv chil wcel wa vm cv vf cv cfv vy
      cv cmv co chil wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel vm cv vf
      cv cfv chil wcel vy cv chil wcel vm cv vf cv cfv vy cv cmv co chil wcel
      vm cv vf cv cfv cH wcel vm cv vf cv cfv vy cv hvsubcl cH chil vm cv vf cv
      cfv cH vx cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv
      vx cv wceq vx chil ssrab2 eqsstri sseli sylan vm cv vf cv cfv vy cv cmv
      co normcl syl vm cv vf cv cfv cH wcel vy cv chil wcel wa vm cv vf cv cfv
      vy cv cmv co chil wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel vm cv
      vf cv cfv chil wcel vy cv chil wcel vm cv vf cv cfv vy cv cmv co chil
      wcel vm cv vf cv cfv cH wcel vm cv vf cv cfv vy cv hvsubcl cH chil vm cv
      vf cv cfv cH vx cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv
      cT cfv vx cv wceq vx chil ssrab2 eqsstri sseli sylan vm cv vf cv cfv vy
      cv cmv co normcl syl syl3anc mpbid letrd vm cv vf cv cfv cH wcel vy cv
      chil wcel wa vm cv vf cv cfv vy cv cmv co cno cfv cc wcel c2 vm cv vf cv
      cfv vy cv cmv co cno cfv cmul co vm cv vf cv cfv vy cv cmv co cno cfv vm
      cv vf cv cfv vy cv cmv co cno cfv caddc co wceq vm cv vf cv cfv cH wcel
      vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co cno cfv vm cv vf cv cfv
      cH wcel vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co chil wcel vm cv
      vf cv cfv vy cv cmv co cno cfv cr wcel vm cv vf cv cfv chil wcel vy cv
      chil wcel vm cv vf cv cfv vy cv cmv co chil wcel vm cv vf cv cfv cH wcel
      vm cv vf cv cfv vy cv hvsubcl cH chil vm cv vf cv cfv cH vx cv cT cfv vx
      cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil
      ssrab2 eqsstri sseli sylan vm cv vf cv cfv vy cv cmv co normcl syl recnd
      vm cv vf cv cfv vy cv cmv co cno cfv 2times syl breqtrrd vy cv cT cfv vy
      cv cmv co cno cfv cr wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel vy
      cv cT cfv vy cv cmv co cno cfv c2 cdiv co vm cv vf cv cfv vy cv cmv co
      cno cfv cle wbr vy cv cT cfv vy cv cmv co cno cfv c2 vm cv vf cv cfv vy
      cv cmv co cno cfv cmul co cle wbr wb vm cv vf cv cfv cH wcel vy cv chil
      wcel wa vy cv cT cfv vy cv cmv co cno cfv cr wcel c2 cr wcel vm cv vf cv
      cfv vy cv cmv co cno cfv cr wcel vy cv cT cfv vy cv cmv co cno cfv c2
      cdiv co vm cv vf cv cfv vy cv cmv co cno cfv cle wbr vy cv cT cfv vy cv
      cmv co cno cfv c2 vm cv vf cv cfv vy cv cmv co cno cfv cmul co cle wbr wb
      2re vy cv cT cfv vy cv cmv co cno cfv cr wcel c2 cr wcel vm cv vf cv cfv
      vy cv cmv co cno cfv cr wcel w3a cc0 c2 clt wbr vy cv cT cfv vy cv cmv co
      cno cfv c2 cdiv co vm cv vf cv cfv vy cv cmv co cno cfv cle wbr vy cv cT
      cfv vy cv cmv co cno cfv c2 vm cv vf cv cfv vy cv cmv co cno cfv cmul co
      cle wbr wb 2pos vy cv cT cfv vy cv cmv co cno cfv c2 vm cv vf cv cfv vy
      cv cmv co cno cfv ledivmulOLD mpan2 mp3an2 vy cv chil wcel vy cv cT cfv
      vy cv cmv co cno cfv cr wcel vm cv vf cv cfv cH wcel vy cv chil wcel vy
      cv cT cfv vy cv cmv co chil wcel vy cv cT cfv vy cv cmv co cno cfv cr
      wcel vy cv cT cfv chil wcel vy cv chil wcel vy cv cT cfv vy cv cmv co
      chil wcel chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT
      ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni vy cv
      cT cfv vy cv hvsubcl mpancom vy cv cT cfv vy cv cmv co normcl syl adantl
      vm cv vf cv cfv cH wcel vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co
      chil wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel vm cv vf cv cfv
      chil wcel vy cv chil wcel vm cv vf cv cfv vy cv cmv co chil wcel vm cv vf
      cv cfv cH wcel vm cv vf cv cfv vy cv hvsubcl cH chil vm cv vf cv cfv cH
      vx cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv
      wceq vx chil ssrab2 eqsstri sseli sylan vm cv vf cv cfv vy cv cmv co
      normcl syl sylanc mpbird adantr vy cv cT cfv vy cv cmv co cno cfv c2 cdiv
      co cr wcel vm cv vf cv cfv vy cv cmv co cno cfv cr wcel vz cv cr wcel vy
      cv cT cfv vy cv cmv co cno cfv c2 cdiv co vm cv vf cv cfv vy cv cmv co
      cno cfv cle wbr vm cv vf cv cfv vy cv cmv co cno cfv vz cv clt wbr wa vy
      cv cT cfv vy cv cmv co cno cfv c2 cdiv co vz cv clt wbr wi vm cv vf cv
      cfv cH wcel vy cv chil wcel wa vz cv cr wcel wa vy cv cT cfv vy cv cmv co
      cno cfv c2 cdiv co vm cv vf cv cfv vy cv cmv co cno cfv vz cv lelttr vy
      cv chil wcel vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co cr wcel vm cv
      vf cv cfv cH wcel vz cv cr wcel vy cv chil wcel vy cv cT cfv vy cv cmv co
      cno cfv cr wcel vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co cr wcel vy
      cv chil wcel vy cv cT cfv vy cv cmv co chil wcel vy cv cT cfv vy cv cmv
      co cno cfv cr wcel vy cv cT cfv chil wcel vy cv chil wcel vy cv cT cfv vy
      cv cmv co chil wcel chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho
      wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi
      ffvelrni vy cv cT cfv vy cv hvsubcl mpancom vy cv cT cfv vy cv cmv co
      normcl syl vy cv cT cfv vy cv cmv co cno cfv rehalfcl syl ad2antlr vm cv
      vf cv cfv cH wcel vy cv chil wcel wa vm cv vf cv cfv vy cv cmv co cno cfv
      cr wcel vz cv cr wcel vm cv vf cv cfv cH wcel vy cv chil wcel wa vm cv vf
      cv cfv vy cv cmv co chil wcel vm cv vf cv cfv vy cv cmv co cno cfv cr
      wcel vm cv vf cv cfv chil wcel vy cv chil wcel vm cv vf cv cfv vy cv cmv
      co chil wcel vm cv vf cv cfv cH wcel vm cv vf cv cfv vy cv hvsubcl cH
      chil vm cv vf cv cfv cH vx cv cT cfv vx cv wceq vx chil crab chil
      hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2 eqsstri sseli sylan vm
      cv vf cv cfv vy cv cmv co normcl syl adantr vm cv vf cv cfv cH wcel vy cv
      chil wcel wa vz cv cr wcel pm3.27 syl3anc mpand cn cH vf cv wf vm cv cn
      wcel vf cv vy cv chli wbr vm cv vf cv cfv cH wcel vy cv chil wcel wa cn
      cH vf cv wf vm cv cn wcel wa vm cv vf cv cfv cH wcel vf cv vy cv chli wbr
      vy cv chil wcel cn cH vm cv vf cv ffvelrn vy cv vf cv vf visset vy visset
      hlimveci anim12i an1rs sylan an1rs syld r19.23adva imim2d r19.20dva mpd
      syl3anc vf cv vy cv chli wbr vy cv cT cfv vy cv cmv co cno cfv c2 cdiv co
      cc0 wceq vy cv cT cfv vy cv cmv co cno cfv cc0 wceq wb cn cH vf cv wf vf
      cv vy cv chli wbr vy cv cT cfv vy cv cmv co cno cfv cc wcel vy cv cT cfv
      vy cv cmv co cno cfv c2 cdiv co cc0 wceq vy cv cT cfv vy cv cmv co cno
      cfv cc0 wceq wb vf cv vy cv chli wbr vy cv cT cfv vy cv cmv co cno cfv vf
      cv vy cv chli wbr vy cv cT cfv vy cv cmv co chil wcel vy cv cT cfv vy cv
      cmv co cno cfv cr wcel vy cv cT cfv chil wcel vy cv chil wcel vy cv cT
      cfv vy cv cmv co chil wcel vf cv vy cv chli wbr vy cv cT cfv vy cv
      hvsubcl vf cv vy cv chli wbr vy cv chil wcel vy cv cT cfv chil wcel vy cv
      vf cv vf visset vy visset hlimveci chil chil vy cv cT cT cT cho wcel cT
      clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin
      ax-mp lnopfi ffvelrni syl vy cv vf cv vf visset vy visset hlimveci sylanc
      vy cv cT cfv vy cv cmv co normcl syl recnd vy cv cT cfv vy cv cmv co cno
      cfv half0 syl adantl mpbid vf cv vy cv chli wbr vy cv cT cfv vy cv cmv co
      cno cfv cc0 wceq vy cv cT cfv vy cv cmv co c0v wceq wb cn cH vf cv wf vf
      cv vy cv chli wbr vy cv cT cfv vy cv cmv co chil wcel vy cv cT cfv vy cv
      cmv co cno cfv cc0 wceq vy cv cT cfv vy cv cmv co c0v wceq wb vy cv cT
      cfv chil wcel vy cv chil wcel vy cv cT cfv vy cv cmv co chil wcel vf cv
      vy cv chli wbr vy cv cT cfv vy cv hvsubcl vf cv vy cv chli wbr vy cv chil
      wcel vy cv cT cfv chil wcel vy cv vf cv vf visset vy visset hlimveci chil
      chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq
      hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni syl vy cv vf cv vf
      visset vy visset hlimveci sylanc vy cv cT cfv vy cv cmv co norm-i syl
      adantl mpbid vf cv vy cv chli wbr vy cv cT cfv vy cv cmv co c0v wceq vy
      cv cT cfv vy cv wceq wb cn cH vf cv wf vy cv cT cfv chil wcel vy cv chil
      wcel vy cv cT cfv vy cv cmv co c0v wceq vy cv cT cfv vy cv wceq wb vf cv
      vy cv chli wbr vy cv cT cfv vy cv hvsubeq0 vf cv vy cv chli wbr vy cv
      chil wcel vy cv cT cfv chil wcel vy cv vf cv vf visset vy visset hlimveci
      chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT
      wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni syl vy cv vf cv
      vf visset vy visset hlimveci sylanc adantl mpbid jca vx cv cT cfv vx cv
      wceq vy cv cT cfv vy cv wceq vx vy cv chil cH vx cv vy cv wceq vx cv cT
      cfv vy cv cT cfv vx cv vy cv vx cv vy cv cT fveq2 vx cv vy cv wceq id
      eqeq12d hmopidmch.1 elrab2 sylibr gen2 mpbir2an $.
      $( [12-Jun-2006] $) $( [21-Apr-2006] $)

    $( An idempotent Hermitian operator is a projection operator.  Theorem 26.4
       of [Halmos] p. 44.  (Halmos seems to omit the proof that ` H ` is a
       closed subspace, which is not trivial as ~ hmopidmchi shows.) $)
    hmopidmpji $p |- T = ( proj ` H ) $=
      cT cH cpj cfv wceq vy cv cT cfv vy cv cH cpj cfv cfv wceq vy chil wral vy
      cv cT cfv vy cv cH cpj cfv cfv wceq vy chil vy cv chil wcel vy cv cT cfv
      vy cv vy cv cT cfv cmv co cva co cH cpj cfv cfv vy cv cT cfv vy cv cH cpj
      cfv cfv vy cv cT cfv cH wcel vy cv vy cv cT cfv cmv co cH cort cfv wcel
      vy cv cT cfv vy cv vy cv cT cfv cmv co cva co cH cpj cfv cfv vy cv cT cfv
      wceq vy cv chil wcel vy cv cT cfv vy cv vy cv cT cfv cmv co cH vx cT cH
      hmopidmch.1 hmopidmch.2 hmopidmchi pjvi vy cv chil wcel vy cv cT cfv chil
      wcel vy cv cT cfv cT cfv vy cv cT cfv wceq wa vy cv cT cfv cH wcel vy cv
      chil wcel vy cv cT cfv chil wcel vy cv cT cfv cT cfv vy cv cT cfv wceq
      chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom cT
      wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni vy cv chil wcel
      vy cv cT cT ccom cfv vy cv cT cfv cT cfv vy cv cT cfv vy cv cT cT cT cT
      cho wcel cT clo wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i
      cT hmoplin ax-mp lnopfi cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom
      cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi hocoi vy cv cT cT
      ccom cT cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.27i fveq1i
      syl5reqr jca vx cv cT cfv vx cv wceq vy cv cT cfv cT cfv vy cv cT cfv
      wceq vx vy cv cT cfv chil cH vx cv vy cv cT cfv wceq vx cv cT cfv vy cv
      cT cfv cT cfv vx cv vy cv cT cfv vx cv vy cv cT cfv cT fveq2 vx cv vy cv
      cT cfv wceq id eqeq12d hmopidmch.1 elrab2 sylibr vy cv chil wcel vy cv vy
      cv cT cfv cmv co chil wcel vy cv vy cv cT cfv cmv co vz cv csp co cc0
      wceq vz cH wral wa vy cv vy cv cT cfv cmv co cH cort cfv wcel vy cv chil
      wcel vy cv vy cv cT cfv cmv co chil wcel vy cv vy cv cT cfv cmv co vz cv
      csp co cc0 wceq vz cH wral vy cv chil wcel vy cv cT cfv chil wcel vy cv
      vy cv cT cfv cmv co chil wcel chil chil vy cv cT cT cT cho wcel cT clo
      wcel cT cho wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp
      lnopfi ffvelrni vy cv vy cv cT cfv hvsubcl mpdan vy cv chil wcel vy cv vy
      cv cT cfv cmv co vz cv csp co cc0 wceq vz cH vy cv chil wcel vz cv cH
      wcel wa vy cv vy cv cT cfv cmv co vz cv csp co vy cv vz cv csp co vy cv
      cT cfv vz cv csp co cmin co vy cv vz cv csp co vy cv vz cv csp co cmin co
      cc0 vy cv chil wcel vy cv cT cfv chil wcel vz cv chil wcel vy cv vy cv cT
      cfv cmv co vz cv csp co vy cv vz cv csp co vy cv cT cfv vz cv csp co cmin
      co wceq vy cv chil wcel vz cv cH wcel wa vy cv vy cv cT cfv vz cv his2sub
      vy cv chil wcel vz cv cH wcel pm3.26 vy cv chil wcel vy cv cT cfv chil
      wcel vz cv cH wcel chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho
      wcel cT cT ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi
      ffvelrni adantr vz cv cH wcel vz cv chil wcel vy cv chil wcel cH chil vz
      cv cH vx cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv
      vx cv wceq vx chil ssrab2 eqsstri sseli adantl syl3anc vy cv chil wcel vz
      cv cH wcel wa vy cv cT cfv vz cv csp co vy cv vz cv csp co vy cv vz cv
      csp co cmin vy cv chil wcel vz cv cH wcel wa vy cv vz cv cT cfv csp co vy
      cv cT cfv vz cv csp co vy cv vz cv csp co vy cv chil wcel vz cv chil wcel
      vy cv vz cv cT cfv csp co vy cv cT cfv vz cv csp co wceq vz cv cH wcel cT
      cho wcel vy cv chil wcel vz cv chil wcel vy cv vz cv cT cfv csp co vy cv
      cT cfv vz cv csp co wceq cT cho wcel cT cT ccom cT wceq hmopidmch.2
      pm3.26i vy cv vz cv cT hmop mp3an1 cH chil vz cv cH vx cv cT cfv vx cv
      wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2
      eqsstri sseli sylan2 vz cv cH wcel vy cv vz cv cT cfv csp co vy cv vz cv
      csp co wceq vy cv chil wcel vz cv cH wcel vz cv cT cfv vz cv vy cv csp vz
      cv cH wcel vz cv chil wcel vz cv cT cfv vz cv wceq vx cv cT cfv vx cv
      wceq vz cv cT cfv vz cv wceq vx vz cv chil cH vx cv vz cv wceq vx cv cT
      cfv vz cv cT cfv vx cv vz cv vx cv vz cv cT fveq2 vx cv vz cv wceq id
      eqeq12d hmopidmch.1 elrab2 pm3.27bi opreq2d adantl eqtr3d opreq2d vy cv
      chil wcel vz cv cH wcel wa vy cv vz cv csp co cc wcel vy cv vz cv csp co
      vy cv vz cv csp co cmin co cc0 wceq vy cv chil wcel vz cv chil wcel vy cv
      vz cv csp co cc wcel vz cv cH wcel vy cv vz cv hicl cH chil vz cv cH vx
      cv cT cfv vx cv wceq vx chil crab chil hmopidmch.1 vx cv cT cfv vx cv
      wceq vx chil ssrab2 eqsstri sseli sylan2 vy cv vz cv csp co subid syl
      3eqtrd r19.21aiva jca cH chil wss vy cv vy cv cT cfv cmv co cH cort cfv
      wcel vy cv vy cv cT cfv cmv co chil wcel vy cv vy cv cT cfv cmv co vz cv
      csp co cc0 wceq vz cH wral wa wb cH vx cv cT cfv vx cv wceq vx chil crab
      chil hmopidmch.1 vx cv cT cfv vx cv wceq vx chil ssrab2 eqsstri vz vy cv
      vy cv cT cfv cmv co cH ocel ax-mp sylibr sylanc vy cv chil wcel vy cv cT
      cfv vy cv vy cv cT cfv cmv co cva co vy cv cH cpj cfv vy cv cT cfv chil
      wcel vy cv chil wcel vy cv cT cfv vy cv vy cv cT cfv cmv co cva co vy cv
      wceq chil chil vy cv cT cT cT cho wcel cT clo wcel cT cho wcel cT cT ccom
      cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi ffvelrni vy cv cT cfv
      vy cv hvpncan3 mpancom fveq2d eqtr3d rgen cT chil wfn cH cpj cfv chil wfn
      cT cH cpj cfv wceq vy cv cT cfv vy cv cH cpj cfv cfv wceq vy chil wral wb
      chil chil cT wf cT chil wfn cT cT cho wcel cT clo wcel cT cho wcel cT cT
      ccom cT wceq hmopidmch.2 pm3.26i cT hmoplin ax-mp lnopfi chil chil cT ffn
      ax-mp cH vx cT cH hmopidmch.1 hmopidmch.2 hmopidmchi pjfni vy chil cT cH
      cpj cfv eqfnfv2 mp2an mpbir $.
      $( [14-Jun-2006] $) $( [22-Apr-2006] $)
  $}

  ${
    $d x T $.
    $( An idempotent Hermitian operator generates a closed subspace.  Part of
       proof of Theorem of [AkhiezerGlazman] p. 64. $)
    hmopidmch $p |- ( ( T e. HrmOp /\ ( T o. T ) = T ) ->
                    { x e. ~H | ( T ` x ) = x } e. CH ) $=
      cT cho wcel cT cT ccom cT wceq wa vx cv cT cfv vx cv wceq vx chil crab
      cch wcel vx cv cT cho wcel cT cT ccom cT wceq wa cT chio cif cfv vx cv
      wceq vx chil crab cch wcel cT chio cT cT cho wcel cT cT ccom cT wceq wa
      cT chio cif wceq vx cv cT cfv vx cv wceq vx chil crab vx cv cT cho wcel
      cT cT ccom cT wceq wa cT chio cif cfv vx cv wceq vx chil crab cch cT cT
      cho wcel cT cT ccom cT wceq wa cT chio cif wceq vx cv cT cfv vx cv wceq
      vx cv cT cho wcel cT cT ccom cT wceq wa cT chio cif cfv vx cv wceq vx
      chil cT cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq vx cv cT cfv
      vx cv cT cho wcel cT cT ccom cT wceq wa cT chio cif cfv vx cv vx cv cT cT
      cho wcel cT cT ccom cT wceq wa cT chio cif fveq1 eqeq1d rabbisdv eleq1d
      vx cT cho wcel cT cT ccom cT wceq wa cT chio cif vx cv cT cho wcel cT cT
      ccom cT wceq wa cT chio cif cfv vx cv wceq vx chil crab vx cv cT cho wcel
      cT cT ccom cT wceq wa cT chio cif cfv vx cv wceq vx chil crab eqid cT cho
      wcel cT cT ccom cT wceq wa cT cho wcel cT cT ccom cT wceq wa cT chio cif
      cho wcel cT cho wcel cT cT ccom cT wceq wa cT chio cif cT cho wcel cT cT
      ccom cT wceq wa cT chio cif ccom cT cho wcel cT cT ccom cT wceq wa cT
      chio cif wceq wa chio cho wcel chio chio ccom chio wceq wa cT chio cT cT
      cho wcel cT cT ccom cT wceq wa cT chio cif wceq cT cho wcel cT cho wcel
      cT cT ccom cT wceq wa cT chio cif cho wcel cT cT ccom cT wceq cT cho wcel
      cT cT ccom cT wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT
      chio cif ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq cT cT
      cho wcel cT cT ccom cT wceq wa cT chio cif cho eleq1 cT cT cho wcel cT cT
      ccom cT wceq wa cT chio cif wceq cT cT ccom cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio cif ccom cT
      cT cho wcel cT cT ccom cT wceq wa cT chio cif cT cT cho wcel cT cT ccom
      cT wceq wa cT chio cif wceq cT cT ccom cT cho wcel cT cT ccom cT wceq wa
      cT chio cif cT ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif cT cho
      wcel cT cT ccom cT wceq wa cT chio cif ccom cT cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cT coeq1 cT cT cho wcel cT cT ccom cT wceq wa cT chio
      cif cT cho wcel cT cT ccom cT wceq wa cT chio cif coeq2 eqtrd cT cT cho
      wcel cT cT ccom cT wceq wa cT chio cif wceq id eqeq12d anbi12d chio cT
      cho wcel cT cT ccom cT wceq wa cT chio cif wceq chio cho wcel cT cho wcel
      cT cT ccom cT wceq wa cT chio cif cho wcel chio chio ccom chio wceq cT
      cho wcel cT cT ccom cT wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq
      wa cT chio cif ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq
      chio cT cho wcel cT cT ccom cT wceq wa cT chio cif cho eleq1 chio cT cho
      wcel cT cT ccom cT wceq wa cT chio cif wceq chio chio ccom cT cho wcel cT
      cT ccom cT wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio
      cif ccom chio cT cho wcel cT cT ccom cT wceq wa cT chio cif chio cT cho
      wcel cT cT ccom cT wceq wa cT chio cif wceq chio chio ccom cT cho wcel cT
      cT ccom cT wceq wa cT chio cif chio ccom cT cho wcel cT cT ccom cT wceq
      wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio cif ccom chio cT
      cho wcel cT cT ccom cT wceq wa cT chio cif chio coeq1 chio cT cho wcel cT
      cT ccom cT wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio
      cif coeq2 eqtrd chio cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq
      id eqeq12d anbi12d chio cho wcel chio chio ccom chio wceq idhmop chio
      chil chil chio wf1o chil chil chio wf hoif chil chil chio f1of ax-mp
      hoid1i pm3.2i elimhyp hmopidmchi dedth $.
      $( [15-Jun-2006] $) $( [24-Apr-2006] $)

    $( An idempotent Hermitian operator is a projection operator.  Theorem 26.4
       of [Halmos] p. 44. $)
    hmopidmpj $p |- ( ( T e. HrmOp /\ ( T o. T ) = T ) ->
                    T = ( proj ` { x e. ~H | ( T ` x ) = x } ) ) $=
      cT cho wcel cT cT ccom cT wceq wa cT vx cv cT cfv vx cv wceq vx chil crab
      cpj cfv wceq cT cho wcel cT cT ccom cT wceq wa cT chio cif vx cv cT cho
      wcel cT cT ccom cT wceq wa cT chio cif cfv vx cv wceq vx chil crab cpj
      cfv wceq cT chio cT cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq cT
      cT cho wcel cT cT ccom cT wceq wa cT chio cif vx cv cT cfv vx cv wceq vx
      chil crab cpj cfv vx cv cT cho wcel cT cT ccom cT wceq wa cT chio cif cfv
      vx cv wceq vx chil crab cpj cfv cT cT cho wcel cT cT ccom cT wceq wa cT
      chio cif wceq id cT cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq vx
      cv cT cfv vx cv wceq vx chil crab vx cv cT cho wcel cT cT ccom cT wceq wa
      cT chio cif cfv vx cv wceq vx chil crab cpj cT cT cho wcel cT cT ccom cT
      wceq wa cT chio cif wceq vx cv cT cfv vx cv wceq vx cv cT cho wcel cT cT
      ccom cT wceq wa cT chio cif cfv vx cv wceq vx chil cT cT cho wcel cT cT
      ccom cT wceq wa cT chio cif wceq vx cv cT cfv vx cv cT cho wcel cT cT
      ccom cT wceq wa cT chio cif cfv vx cv vx cv cT cT cho wcel cT cT ccom cT
      wceq wa cT chio cif fveq1 eqeq1d rabbisdv fveq2d eqeq12d vx cT cho wcel
      cT cT ccom cT wceq wa cT chio cif vx cv cT cho wcel cT cT ccom cT wceq wa
      cT chio cif cfv vx cv wceq vx chil crab vx cv cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cfv vx cv wceq vx chil crab eqid cT cho wcel cT cT
      ccom cT wceq wa cT cho wcel cT cT ccom cT wceq wa cT chio cif cho wcel cT
      cho wcel cT cT ccom cT wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq
      wa cT chio cif ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq wa
      chio cho wcel chio chio ccom chio wceq wa cT chio cT cT cho wcel cT cT
      ccom cT wceq wa cT chio cif wceq cT cho wcel cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cho wcel cT cT ccom cT wceq cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio cif ccom cT
      cho wcel cT cT ccom cT wceq wa cT chio cif wceq cT cT cho wcel cT cT ccom
      cT wceq wa cT chio cif cho eleq1 cT cT cho wcel cT cT ccom cT wceq wa cT
      chio cif wceq cT cT ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif cT
      cho wcel cT cT ccom cT wceq wa cT chio cif ccom cT cT cho wcel cT cT ccom
      cT wceq wa cT chio cif cT cT cho wcel cT cT ccom cT wceq wa cT chio cif
      wceq cT cT ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif cT ccom cT
      cho wcel cT cT ccom cT wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq
      wa cT chio cif ccom cT cT cho wcel cT cT ccom cT wceq wa cT chio cif cT
      coeq1 cT cT cho wcel cT cT ccom cT wceq wa cT chio cif cT cho wcel cT cT
      ccom cT wceq wa cT chio cif coeq2 eqtrd cT cT cho wcel cT cT ccom cT wceq
      wa cT chio cif wceq id eqeq12d anbi12d chio cT cho wcel cT cT ccom cT
      wceq wa cT chio cif wceq chio cho wcel cT cho wcel cT cT ccom cT wceq wa
      cT chio cif cho wcel chio chio ccom chio wceq cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio cif ccom cT
      cho wcel cT cT ccom cT wceq wa cT chio cif wceq chio cT cho wcel cT cT
      ccom cT wceq wa cT chio cif cho eleq1 chio cT cho wcel cT cT ccom cT wceq
      wa cT chio cif wceq chio chio ccom cT cho wcel cT cT ccom cT wceq wa cT
      chio cif cT cho wcel cT cT ccom cT wceq wa cT chio cif ccom chio cT cho
      wcel cT cT ccom cT wceq wa cT chio cif chio cT cho wcel cT cT ccom cT
      wceq wa cT chio cif wceq chio chio ccom cT cho wcel cT cT ccom cT wceq wa
      cT chio cif chio ccom cT cho wcel cT cT ccom cT wceq wa cT chio cif cT
      cho wcel cT cT ccom cT wceq wa cT chio cif ccom chio cT cho wcel cT cT
      ccom cT wceq wa cT chio cif chio coeq1 chio cT cho wcel cT cT ccom cT
      wceq wa cT chio cif cT cho wcel cT cT ccom cT wceq wa cT chio cif coeq2
      eqtrd chio cT cho wcel cT cT ccom cT wceq wa cT chio cif wceq id eqeq12d
      anbi12d chio cho wcel chio chio ccom chio wceq idhmop chio chil chil chio
      wf1o chil chil chio wf hoif chil chil chio f1of ax-mp hoid1i pm3.2i
      elimhyp hmopidmpji dedth $.
      $( [16-Jun-2006] $) $( [22-Apr-2006] $)
  $}

  ${
    $d x H $.  $d x S $.  $d x T $.
    pjsdi.1 $e |- H e. CH $.
    pjsdi.2 $e |- S : ~H --> ~H $.
    pjsdi.3 $e |- T : ~H --> ~H $.
    $( Distributive law for Hilbert space operator sum. $)
    pjsdii $p |- ( ( proj ` H ) o. ( S +op T ) ) =
                ( ( ( proj ` H ) o. S ) +op ( ( proj ` H ) o. T ) ) $=
      vx cv cH cpj cfv cS cT chos co ccom cfv vx cv cH cpj cfv cS ccom cH cpj
      cfv cT ccom chos co cfv wceq vx chil wral cH cpj cfv cS cT chos co ccom
      cH cpj cfv cS ccom cH cpj cfv cT ccom chos co wceq vx cv cH cpj cfv cS cT
      chos co ccom cfv vx cv cH cpj cfv cS ccom cH cpj cfv cT ccom chos co cfv
      wceq vx chil vx cv chil wcel vx cv cS cT chos co cfv cH cpj cfv cfv vx cv
      cH cpj cfv cS ccom cfv vx cv cH cpj cfv cT ccom cfv cva co vx cv cH cpj
      cfv cS cT chos co ccom cfv vx cv cH cpj cfv cS ccom cH cpj cfv cT ccom
      chos co cfv vx cv chil wcel vx cv cS cfv vx cv cT cfv cva co cH cpj cfv
      cfv vx cv cS cfv cH cpj cfv cfv vx cv cT cfv cH cpj cfv cfv cva co vx cv
      cS cT chos co cfv cH cpj cfv cfv vx cv cH cpj cfv cS ccom cfv vx cv cH
      cpj cfv cT ccom cfv cva co vx cv cS cfv chil wcel vx cv cT cfv chil wcel
      vx cv cS cfv vx cv cT cfv cva co cH cpj cfv cfv vx cv cS cfv cH cpj cfv
      cfv vx cv cT cfv cH cpj cfv cfv cva co wceq vx cv chil wcel vx cv cS cfv
      vx cv cT cfv cH pjsdi.1 pjaddi chil chil vx cv cS pjsdi.2 ffvelrni chil
      chil vx cv cT pjsdi.3 ffvelrni sylanc vx cv chil wcel vx cv cS cT chos co
      cfv vx cv cS cfv vx cv cT cfv cva co cH cpj cfv chil chil cS wf chil chil
      cT wf vx cv chil wcel vx cv cS cT chos co cfv vx cv cS cfv vx cv cT cfv
      cva co wceq pjsdi.2 pjsdi.3 vx cv cS cT hosvalOLD mpanl12 fveq2d vx cv
      chil wcel vx cv cH cpj cfv cS ccom cfv vx cv cS cfv cH cpj cfv cfv vx cv
      cH cpj cfv cT ccom cfv vx cv cT cfv cH cpj cfv cfv cva vx cv cH cpj cfv
      cS cH pjsdi.1 pjfi pjsdi.2 hocoi vx cv cH cpj cfv cT cH pjsdi.1 pjfi
      pjsdi.3 hocoi opreq12d 3eqtr4d vx cv cH cpj cfv cS cT chos co cH pjsdi.1
      pjfi cS cT pjsdi.2 pjsdi.3 hoaddcli hocoi chil chil cH cpj cfv cS ccom wf
      chil chil cH cpj cfv cT ccom wf vx cv chil wcel vx cv cH cpj cfv cS ccom
      cH cpj cfv cT ccom chos co cfv vx cv cH cpj cfv cS ccom cfv vx cv cH cpj
      cfv cT ccom cfv cva co wceq cH cpj cfv cS cH pjsdi.1 pjfi pjsdi.2 hocofi
      cH cpj cfv cT cH pjsdi.1 pjfi pjsdi.3 hocofi vx cv cH cpj cfv cS ccom cH
      cpj cfv cT ccom hosvalOLD mpanl12 3eqtr4d rgen vx cH cpj cfv cS cT chos
      co ccom cH cpj cfv cS ccom cH cpj cfv cT ccom chos co cH cpj cfv cS cT
      chos co cH pjsdi.1 pjfi cS cT pjsdi.2 pjsdi.3 hoaddcli hocofi cH cpj cfv
      cS ccom cH cpj cfv cT ccom cH cpj cfv cS cH pjsdi.1 pjfi pjsdi.2 hocofi
      cH cpj cfv cT cH pjsdi.1 pjfi pjsdi.3 hocofi hoaddcli hoeqi mpbi $.
      $( [12-Nov-2000] $)

    $( Distributive law for Hilbert space operator difference. $)
    pjddii $p |- ( ( proj ` H ) o. ( S -op T ) ) =
                ( ( ( proj ` H ) o. S ) -op ( ( proj ` H ) o. T ) ) $=
      vx cv cH cpj cfv cS cT chod co ccom cfv vx cv cH cpj cfv cS ccom cH cpj
      cfv cT ccom chod co cfv wceq vx chil wral cH cpj cfv cS cT chod co ccom
      cH cpj cfv cS ccom cH cpj cfv cT ccom chod co wceq vx cv cH cpj cfv cS cT
      chod co ccom cfv vx cv cH cpj cfv cS ccom cH cpj cfv cT ccom chod co cfv
      wceq vx chil vx cv chil wcel vx cv cS cT chod co cfv cH cpj cfv cfv vx cv
      cH cpj cfv cS ccom cfv vx cv cH cpj cfv cT ccom cfv cmv co vx cv cH cpj
      cfv cS cT chod co ccom cfv vx cv cH cpj cfv cS ccom cH cpj cfv cT ccom
      chod co cfv vx cv chil wcel vx cv cS cfv vx cv cT cfv cmv co cH cpj cfv
      cfv vx cv cS cfv cH cpj cfv cfv vx cv cT cfv cH cpj cfv cfv cmv co vx cv
      cS cT chod co cfv cH cpj cfv cfv vx cv cH cpj cfv cS ccom cfv vx cv cH
      cpj cfv cT ccom cfv cmv co vx cv cS cfv chil wcel vx cv cT cfv chil wcel
      vx cv cS cfv vx cv cT cfv cmv co cH cpj cfv cfv vx cv cS cfv cH cpj cfv
      cfv vx cv cT cfv cH cpj cfv cfv cmv co wceq vx cv chil wcel vx cv cS cfv
      vx cv cT cfv cH pjsdi.1 pjsubi chil chil vx cv cS pjsdi.2 ffvelrni chil
      chil vx cv cT pjsdi.3 ffvelrni sylanc vx cv chil wcel vx cv cS cT chod co
      cfv vx cv cS cfv vx cv cT cfv cmv co cH cpj cfv chil chil cS wf chil chil
      cT wf vx cv chil wcel vx cv cS cT chod co cfv vx cv cS cfv vx cv cT cfv
      cmv co wceq pjsdi.2 pjsdi.3 vx cv cS cT hodvalOLD mpanl12 fveq2d vx cv
      chil wcel vx cv cH cpj cfv cS ccom cfv vx cv cS cfv cH cpj cfv cfv vx cv
      cH cpj cfv cT ccom cfv vx cv cT cfv cH cpj cfv cfv cmv vx cv cH cpj cfv
      cS cH pjsdi.1 pjfi pjsdi.2 hocoi vx cv cH cpj cfv cT cH pjsdi.1 pjfi
      pjsdi.3 hocoi opreq12d 3eqtr4d vx cv cH cpj cfv cS cT chod co cH pjsdi.1
      pjfi cS cT pjsdi.2 pjsdi.3 hosubcli hocoi chil chil cH cpj cfv cS ccom wf
      chil chil cH cpj cfv cT ccom wf vx cv chil wcel vx cv cH cpj cfv cS ccom
      cH cpj cfv cT ccom chod co cfv vx cv cH cpj cfv cS ccom cfv vx cv cH cpj
      cfv cT ccom cfv cmv co wceq cH cpj cfv cS cH pjsdi.1 pjfi pjsdi.2 hocofi
      cH cpj cfv cT cH pjsdi.1 pjfi pjsdi.3 hocofi vx cv cH cpj cfv cS ccom cH
      cpj cfv cT ccom hodvalOLD mpanl12 3eqtr4d rgen vx cH cpj cfv cS cT chod
      co ccom cH cpj cfv cS ccom cH cpj cfv cT ccom chod co cH cpj cfv cS cT
      chod co cH pjsdi.1 pjfi cS cT pjsdi.2 pjsdi.3 hosubcli hocofi cH cpj cfv
      cS ccom cH cpj cfv cT ccom cH cpj cfv cS cH pjsdi.1 pjfi pjsdi.2 hocofi
      cH cpj cfv cT cH pjsdi.1 pjfi pjsdi.3 hocofi hosubcli hoeqi mpbi $.
      $( [24-Nov-2000] $)
  $}

  ${
    pjsdi2.1 $e |- H e. CH $.
    pjsdi2.2 $e |- R : ~H --> ~H $.
    pjsdi2.3 $e |- S : ~H --> ~H $.
    pjsdi2.4 $e |- T : ~H --> ~H $.
    $( Chained distributive law for Hilbert space operator difference. $)
    pjsdi2i $p |- ( ( R o. ( S +op T ) ) =
                ( ( R o. S ) +op ( R o. T ) ) ->
           ( ( ( proj ` H ) o. R ) o. ( S +op T ) ) =
     ( ( ( ( proj ` H ) o. R ) o. S ) +op ( ( ( proj ` H ) o. R ) o. T ) ) ) $=
      cR cS cT chos co ccom cR cS ccom cR cT ccom chos co wceq cH cpj cfv cR cS
      cT chos co ccom ccom cH cpj cfv cR cS ccom ccom cH cpj cfv cR cT ccom
      ccom chos co cH cpj cfv cR ccom cS cT chos co ccom cH cpj cfv cR ccom cS
      ccom cH cpj cfv cR ccom cT ccom chos co cR cS cT chos co ccom cR cS ccom
      cR cT ccom chos co wceq cH cpj cfv cR cS cT chos co ccom ccom cH cpj cfv
      cR cS ccom cR cT ccom chos co ccom cH cpj cfv cR cS ccom ccom cH cpj cfv
      cR cT ccom ccom chos co cR cS cT chos co ccom cR cS ccom cR cT ccom chos
      co cH cpj cfv coeq2 cR cS ccom cR cT ccom cH pjsdi2.1 cR cS pjsdi2.2
      pjsdi2.3 hocofi cR cT pjsdi2.2 pjsdi2.4 hocofi pjsdii syl6eq cH cpj cfv
      cR cS cT chos co coass cH cpj cfv cR ccom cS ccom cH cpj cfv cR cS ccom
      ccom cH cpj cfv cR ccom cT ccom cH cpj cfv cR cT ccom ccom chos cH cpj
      cfv cR cS coass cH cpj cfv cR cT coass opreq12i 3eqtr4g $.
      $( [30-Nov-2000] $)
  $}

  ${
    $d x y H $.  $d x y G $.
    pjco.1 $e |- G e. CH $.
    pjco.2 $e |- H e. CH $.
    $( Composition of projections. $)
    pjcoi $p |- ( A e. ~H -> ( ( ( proj ` G ) o. ( proj ` H ) ) ` A ) =
               ( ( proj ` G ) ` ( ( proj ` H ) ` A ) ) ) $=
      cA cG cpj cfv cH cpj cfv cG pjco.1 pjfi cH pjco.2 pjfi hocoi $.
      $( [16-Aug-2000] $)

    $( Closure of composition of projections. $)
    pjcocli $p |- ( A e. ~H ->
                 ( ( ( proj ` G ) o. ( proj ` H ) ) ` A ) e. G ) $=
      cA chil wcel cA cG cpj cfv cH cpj cfv ccom cfv cA cH cpj cfv cfv cG cpj
      cfv cfv cG cA cG cH pjco.1 pjco.2 pjcoi cA chil wcel cA cH cpj cfv cfv
      chil wcel cA cH cpj cfv cfv cG cpj cfv cfv cG wcel cA cH pjco.2 pjhcli cA
      cH cpj cfv cfv cG pjco.1 pjcli syl eqeltrd $.
      $( [29-Nov-2000] $)

    $( Closure of composition of projections. $)
    pjcohcli $p |- ( A e. ~H ->
                 ( ( ( proj ` G ) o. ( proj ` H ) ) ` A ) e. ~H ) $=
      cA cG cpj cfv cH cpj cfv cG pjco.1 pjfi cH pjco.2 pjfi hococli $.
      $( [7-Oct-2000] $)

    $( Adjoint of composition of projections.  Special case of Theorem
       3.11(viii) of [Beran] p. 106. $)
    pjadjcoi $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( ( ( proj ` G ) o. ( proj ` H ) ) ` A ) .ih B ) =
                  ( A .ih ( ( ( proj ` H ) o. ( proj ` G ) ) ` B ) ) ) $=
      cA chil wcel cB chil wcel wa cA cH cpj cfv cfv cG cpj cfv cfv cB csp co
      cA cB cG cpj cfv cfv cH cpj cfv cfv csp co cA cG cpj cfv cH cpj cfv ccom
      cfv cB csp co cA cB cH cpj cfv cG cpj cfv ccom cfv csp co cA chil wcel cB
      chil wcel wa cA cH cpj cfv cfv cG cpj cfv cfv cB csp co cA cH cpj cfv cfv
      cB cG cpj cfv cfv csp co cA cB cG cpj cfv cfv cH cpj cfv cfv csp co cA cH
      cpj cfv cfv chil wcel cB chil wcel cA cH cpj cfv cfv cG cpj cfv cfv cB
      csp co cA cH cpj cfv cfv cB cG cpj cfv cfv csp co wceq cA chil wcel cA cH
      cpj cfv cfv cB cG pjco.1 pjadji cA cH pjco.2 pjhcli sylan cA chil wcel cB
      cG cpj cfv cfv chil wcel cA cH cpj cfv cfv cB cG cpj cfv cfv csp co cA cB
      cG cpj cfv cfv cH cpj cfv cfv csp co wceq cB chil wcel cA cB cG cpj cfv
      cfv cH pjco.2 pjadji cB cG pjco.1 pjhcli sylan2 eqtrd cA chil wcel cA cG
      cpj cfv cH cpj cfv ccom cfv cB csp co cA cH cpj cfv cfv cG cpj cfv cfv cB
      csp co wceq cB chil wcel cA chil wcel cA cG cpj cfv cH cpj cfv ccom cfv
      cA cH cpj cfv cfv cG cpj cfv cfv cB csp cA cG cH pjco.1 pjco.2 pjcoi
      opreq1d adantr cB chil wcel cA cB cH cpj cfv cG cpj cfv ccom cfv csp co
      cA cB cG cpj cfv cfv cH cpj cfv cfv csp co wceq cA chil wcel cB chil wcel
      cB cH cpj cfv cG cpj cfv ccom cfv cB cG cpj cfv cfv cH cpj cfv cfv cA csp
      cB cH cG pjco.2 pjco.1 pjcoi opreq2d adantl 3eqtr4d $.
      $( [6-Oct-2000] $)

    $( Functionality of composition of projections. $)
    pjcofni $p |- ( ( proj ` G ) o. ( proj ` H ) ) Fn ~H $=
      cG cpj cfv cH cpj cfv cG pjco.1 pjfi cH pjco.2 pjfi hocofni $.
      $( [1-Oct-2000] $)

    $( Subset relationship for projections.  Theorem 4.5(i)<->(iii) of [Beran]
       p. 112. $)
    pjss1coi $p |- ( G C_ H <->
                 ( ( proj ` H ) o. ( proj ` G ) ) = ( proj ` G ) ) $=
      cG cH wss cH cpj cfv cG cpj cfv ccom cG cpj cfv wceq cG cH wss vx cv cH
      cpj cfv cG cpj cfv ccom cfv vx cv cG cpj cfv cfv wceq vx chil wral cH cpj
      cfv cG cpj cfv ccom cG cpj cfv wceq cG cH wss vx cv cH cpj cfv cG cpj cfv
      ccom cfv vx cv cG cpj cfv cfv wceq vx chil cG cH wss vx cv chil wcel wa
      vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG cpj cfv cfv cH cpj cfv cfv
      vx cv cG cpj cfv cfv vx cv chil wcel vx cv cH cpj cfv cG cpj cfv ccom cfv
      vx cv cG cpj cfv cfv cH cpj cfv cfv wceq cG cH wss vx cv cH cG pjco.2
      pjco.1 pjcoi adantl cG cH wss vx cv chil wcel wa vx cv cG cpj cfv cfv cH
      wcel vx cv cG cpj cfv cfv cH cpj cfv cfv vx cv cG cpj cfv cfv wceq cG cH
      wss vx cv cG cpj cfv cfv cG wcel vx cv cG cpj cfv cfv cH wcel vx cv chil
      wcel cG cH vx cv cG cpj cfv cfv ssel2 vx cv cG pjco.1 pjcli sylan2 cH cch
      wcel vx cv cG cpj cfv cfv cH wcel vx cv cG cpj cfv cfv cH cpj cfv cfv vx
      cv cG cpj cfv cfv wceq pjco.2 vx cv cG cpj cfv cfv cH pjid mpan syl eqtrd
      r19.21aiva vx cH cpj cfv cG cpj cfv ccom cG cpj cfv cH cpj cfv cG cpj cfv
      cH pjco.2 pjfi cG pjco.1 pjfi hocofi cG pjco.1 pjfi hoeqi sylib cH cpj
      cfv cG cpj cfv ccom cG cpj cfv wceq cG cpj cfv crn cH cpj cfv crn cG cH
      cH cpj cfv cG cpj cfv ccom cG cpj cfv wceq cH cpj cfv cG cpj cfv ccom crn
      cG cpj cfv crn wceq cG cpj cfv crn cH cpj cfv crn wss cH cpj cfv cG cpj
      cfv ccom cG cpj cfv rneq cH cpj cfv cG cpj cfv ccom crn cG cpj cfv crn
      wceq cH cpj cfv cG cpj cfv ccom crn cH cpj cfv crn wss cG cpj cfv crn cH
      cpj cfv crn wss cH cpj cfv cG cpj cfv rncoss cH cpj cfv cG cpj cfv ccom
      crn cG cpj cfv crn cH cpj cfv crn sseq1 mpbii syl cG pjco.1 pjrni cH
      pjco.2 pjrni 3sstr3g impbii $.
      $( [1-Oct-2000] $)

    $( Subset relationship for projections.  Theorem 4.5(i)<->(ii) of [Beran]
       p. 112. $)
    pjss2coi $p |- ( G C_ H <->
                 ( ( proj ` G ) o. ( proj ` H ) ) = ( proj ` G ) ) $=
      cG cH wss cG cpj cfv cH cpj cfv ccom cG cpj cfv wceq cG cH wss vx cv cG
      cpj cfv cH cpj cfv ccom cfv vx cv cG cpj cfv cfv wceq vx chil wral cG cpj
      cfv cH cpj cfv ccom cG cpj cfv wceq cG cH wss vx cv cG cpj cfv cH cpj cfv
      ccom cfv vx cv cG cpj cfv cfv wceq vx chil cG cH wss vx cv chil wcel wa
      vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv cH cpj cfv cfv cG cpj cfv cfv
      vx cv cG cpj cfv cfv vx cv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv
      vx cv cH cpj cfv cfv cG cpj cfv cfv wceq cG cH wss vx cv cG cH pjco.1
      pjco.2 pjcoi adantl vx cv chil wcel cG cH wss vx cv cH cpj cfv cfv cG cpj
      cfv cfv vx cv cG cpj cfv cfv wceq vx cv chil wcel cG cH wss vx cv cH cpj
      cfv cfv cG cpj cfv cfv vx cv cG cpj cfv cfv wceq wi cG cH wss vx cv chil
      wcel vx cv c0v cif cH cpj cfv cfv cG cpj cfv cfv vx cv chil wcel vx cv
      c0v cif cG cpj cfv cfv wceq wi vx cv c0v vx cv vx cv chil wcel vx cv c0v
      cif wceq vx cv cH cpj cfv cfv cG cpj cfv cfv vx cv cG cpj cfv cfv wceq vx
      cv chil wcel vx cv c0v cif cH cpj cfv cfv cG cpj cfv cfv vx cv chil wcel
      vx cv c0v cif cG cpj cfv cfv wceq cG cH wss vx cv vx cv chil wcel vx cv
      c0v cif wceq vx cv cH cpj cfv cfv cG cpj cfv cfv vx cv chil wcel vx cv
      c0v cif cH cpj cfv cfv cG cpj cfv cfv vx cv cG cpj cfv cfv vx cv chil
      wcel vx cv c0v cif cG cpj cfv cfv vx cv vx cv chil wcel vx cv c0v cif
      wceq vx cv cH cpj cfv cfv vx cv chil wcel vx cv c0v cif cH cpj cfv cfv cG
      cpj cfv vx cv vx cv chil wcel vx cv c0v cif cH cpj cfv fveq2 fveq2d vx cv
      vx cv chil wcel vx cv c0v cif cG cpj cfv fveq2 eqeq12d imbi2d vx cv chil
      wcel vx cv c0v cif cH cG pjco.1 vx cv c0v chil ax-hv0cl elimel pjco.2
      pjss2i dedth impcom eqtrd r19.21aiva vx cG cpj cfv cH cpj cfv ccom cG cpj
      cfv cG cpj cfv cH cpj cfv cG pjco.1 pjfi cH pjco.2 pjfi hocofi cG pjco.1
      pjfi hoeqi sylib cG cpj cfv cH cpj cfv ccom cG cpj cfv wceq cH cpj cfv cG
      cpj cfv ccom cG cpj cfv wceq cG cH wss cG cpj cfv cH cpj cfv ccom cG cpj
      cfv wceq vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG cpj cfv cfv wceq
      vx chil wral cH cpj cfv cG cpj cfv ccom cG cpj cfv wceq cG cpj cfv cH cpj
      cfv ccom cG cpj cfv wceq vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG
      cpj cfv cfv wceq vx chil vx cv chil wcel cG cpj cfv cH cpj cfv ccom cG
      cpj cfv wceq vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG cpj cfv cfv
      wceq vx cv chil wcel cG cpj cfv cH cpj cfv ccom cG cpj cfv wceq vx cv cH
      cpj cfv cG cpj cfv ccom cfv vy cv csp co vx cv cG cpj cfv cfv vy cv csp
      co wceq vy chil wral vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG cpj
      cfv cfv wceq vx cv chil wcel cG cpj cfv cH cpj cfv ccom cG cpj cfv wceq
      vx cv cH cpj cfv cG cpj cfv ccom cfv vy cv csp co vx cv cG cpj cfv cfv vy
      cv csp co wceq vy chil vx cv chil wcel cG cpj cfv cH cpj cfv ccom cG cpj
      cfv wceq vy cv chil wcel vx cv cH cpj cfv cG cpj cfv ccom cfv vy cv csp
      co vx cv cG cpj cfv cfv vy cv csp co wceq vx cv chil wcel cG cpj cfv cH
      cpj cfv ccom cG cpj cfv wceq wa vy cv chil wcel wa vx cv vy cv cG cpj cfv
      cH cpj cfv ccom cfv csp co vx cv vy cv cG cpj cfv cfv csp co vx cv cH cpj
      cfv cG cpj cfv ccom cfv vy cv csp co vx cv cG cpj cfv cfv vy cv csp co cG
      cpj cfv cH cpj cfv ccom cG cpj cfv wceq vx cv vy cv cG cpj cfv cH cpj cfv
      ccom cfv csp co vx cv vy cv cG cpj cfv cfv csp co wceq vx cv chil wcel vy
      cv chil wcel cG cpj cfv cH cpj cfv ccom cG cpj cfv wceq vy cv cG cpj cfv
      cH cpj cfv ccom cfv vy cv cG cpj cfv cfv vx cv csp vy cv cG cpj cfv cH
      cpj cfv ccom cG cpj cfv fveq1 opreq2d ad2antlr vx cv chil wcel vy cv chil
      wcel vx cv cH cpj cfv cG cpj cfv ccom cfv vy cv csp co vx cv vy cv cG cpj
      cfv cH cpj cfv ccom cfv csp co wceq cG cpj cfv cH cpj cfv ccom cG cpj cfv
      wceq vx cv vy cv cH cG pjco.2 pjco.1 pjadjcoi adantlr vx cv chil wcel vy
      cv chil wcel vx cv cG cpj cfv cfv vy cv csp co vx cv vy cv cG cpj cfv cfv
      csp co wceq cG cpj cfv cH cpj cfv ccom cG cpj cfv wceq vx cv vy cv cG
      pjco.1 pjadji adantlr 3eqtr4d exp31 r19.21adv vx cv cH cpj cfv cG cpj cfv
      ccom cfv chil wcel vx cv cG cpj cfv cfv chil wcel vx cv cH cpj cfv cG cpj
      cfv ccom cfv vy cv csp co vx cv cG cpj cfv cfv vy cv csp co wceq vy chil
      wral vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG cpj cfv cfv wceq wb vx
      cv chil wcel vy vx cv cH cpj cfv cG cpj cfv ccom cfv vx cv cG cpj cfv cfv
      hial2eq vx cv cH cG pjco.2 pjco.1 pjcohcli vx cv cG pjco.1 pjhcli sylanc
      sylibd com12 r19.21aiv vx cH cpj cfv cG cpj cfv ccom cG cpj cfv cH cpj
      cfv cG cpj cfv cH pjco.2 pjfi cG pjco.1 pjfi hocofi cG pjco.1 pjfi hoeqi
      sylib cG cH pjco.1 pjco.2 pjss1coi sylibr impbii $.
      $( [7-Oct-2000] $)

    $( Projection meet property.  Remark in [Kalmbach] p. 66.  Also Theorem
       4.5(i)->(iv) of [Beran] p. 112. $)
    pjssmi $p |- ( A e. ~H -> ( H C_ G ->
               ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) )
                = ( ( proj ` ( G i^i ( _|_ ` H ) ) ) ` A ) ) ) $=
      cA chil wcel cH cG wss cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA cG
      cH cort cfv cin cpj cfv cfv wceq wi cH cG wss cA chil wcel cA c0v cif cG
      cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv co cA chil wcel cA
      c0v cif cG cH cort cfv cin cpj cfv cfv wceq wi cA c0v cA cA chil wcel cA
      c0v cif wceq cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA cG cH cort cfv
      cin cpj cfv cfv wceq cA chil wcel cA c0v cif cG cpj cfv cfv cA chil wcel
      cA c0v cif cH cpj cfv cfv cmv co cA chil wcel cA c0v cif cG cH cort cfv
      cin cpj cfv cfv wceq cH cG wss cA cA chil wcel cA c0v cif wceq cA cG cpj
      cfv cfv cA cH cpj cfv cfv cmv co cA chil wcel cA c0v cif cG cpj cfv cfv
      cA chil wcel cA c0v cif cH cpj cfv cfv cmv co cA cG cH cort cfv cin cpj
      cfv cfv cA chil wcel cA c0v cif cG cH cort cfv cin cpj cfv cfv cA cA chil
      wcel cA c0v cif wceq cA cG cpj cfv cfv cA chil wcel cA c0v cif cG cpj cfv
      cfv cA cH cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv cA cA
      chil wcel cA c0v cif cG cpj cfv fveq2 cA cA chil wcel cA c0v cif cH cpj
      cfv fveq2 opreq12d cA cA chil wcel cA c0v cif cG cH cort cfv cin cpj cfv
      fveq2 eqeq12d imbi2d cA chil wcel cA c0v cif cG cH pjco.2 cA c0v chil
      ax-hv0cl elimel pjco.1 pjssmii dedth $.
      $( [26-Sep-2001] $)

    $( Theorem 4.5(iv)->(v) of [Beran] p. 112. $)
    pjssge0i $p |- ( A e. ~H ->
                 ( ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) )
                  = ( ( proj ` ( G i^i ( _|_ ` H ) ) ) ` A ) ->
       0 <_ ( ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) ) .ih A ) ) ) $=
      cA chil wcel cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA cG cH cort cfv
      cin cpj cfv cfv wceq cc0 cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA
      csp co cle wbr wi cA chil wcel cA c0v cif cG cpj cfv cfv cA chil wcel cA
      c0v cif cH cpj cfv cfv cmv co cA chil wcel cA c0v cif cG cH cort cfv cin
      cpj cfv cfv wceq cc0 cA chil wcel cA c0v cif cG cpj cfv cfv cA chil wcel
      cA c0v cif cH cpj cfv cfv cmv co cA chil wcel cA c0v cif csp co cle wbr
      wi cA c0v cA cA chil wcel cA c0v cif wceq cA cG cpj cfv cfv cA cH cpj cfv
      cfv cmv co cA cG cH cort cfv cin cpj cfv cfv wceq cA chil wcel cA c0v cif
      cG cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv co cA chil wcel
      cA c0v cif cG cH cort cfv cin cpj cfv cfv wceq cc0 cA cG cpj cfv cfv cA
      cH cpj cfv cfv cmv co cA csp co cle wbr cc0 cA chil wcel cA c0v cif cG
      cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv co cA chil wcel cA
      c0v cif csp co cle wbr cA cA chil wcel cA c0v cif wceq cA cG cpj cfv cfv
      cA cH cpj cfv cfv cmv co cA chil wcel cA c0v cif cG cpj cfv cfv cA chil
      wcel cA c0v cif cH cpj cfv cfv cmv co cA cG cH cort cfv cin cpj cfv cfv
      cA chil wcel cA c0v cif cG cH cort cfv cin cpj cfv cfv cA cA chil wcel cA
      c0v cif wceq cA cG cpj cfv cfv cA chil wcel cA c0v cif cG cpj cfv cfv cA
      cH cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv cA cA chil wcel
      cA c0v cif cG cpj cfv fveq2 cA cA chil wcel cA c0v cif cH cpj cfv fveq2
      opreq12d cA cA chil wcel cA c0v cif cG cH cort cfv cin cpj cfv fveq2
      eqeq12d cA cA chil wcel cA c0v cif wceq cA cG cpj cfv cfv cA cH cpj cfv
      cfv cmv co cA csp co cA chil wcel cA c0v cif cG cpj cfv cfv cA chil wcel
      cA c0v cif cH cpj cfv cfv cmv co cA chil wcel cA c0v cif csp co cc0 cle
      cA cA chil wcel cA c0v cif wceq cA cG cpj cfv cfv cA cH cpj cfv cfv cmv
      co cA chil wcel cA c0v cif cG cpj cfv cfv cA chil wcel cA c0v cif cH cpj
      cfv cfv cmv co cA cA chil wcel cA c0v cif csp cA cA chil wcel cA c0v cif
      wceq cA cG cpj cfv cfv cA chil wcel cA c0v cif cG cpj cfv cfv cA cH cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv cA cA chil wcel cA c0v
      cif cG cpj cfv fveq2 cA cA chil wcel cA c0v cif cH cpj cfv fveq2 opreq12d
      cA cA chil wcel cA c0v cif wceq id opreq12d breq2d imbi12d cA chil wcel
      cA c0v cif cG cH pjco.2 cA c0v chil ax-hv0cl elimel pjco.1 pjssge0ii
      dedth $.
      $( [26-Sep-2001] $)

    $( Theorem 4.5(v)<->(vi) of [Beran] p. 112. $)
    pjdifnormi $p |- ( A e. ~H -> ( 0 <_
                ( ( ( ( proj ` G ) ` A ) -h ( ( proj ` H ) ` A ) ) .ih A ) <->
    ( normh ` ( ( proj ` H ) ` A ) ) <_ ( normh ` ( ( proj ` G ) ` A ) ) ) ) $=
      cA chil wcel cc0 cA cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA csp co cle
      wbr cA cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv cle wbr wb cc0 cA
      chil wcel cA c0v cif cG cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv
      cfv cmv co cA chil wcel cA c0v cif csp co cle wbr cA chil wcel cA c0v cif
      cH cpj cfv cfv cno cfv cA chil wcel cA c0v cif cG cpj cfv cfv cno cfv cle
      wbr wb cA c0v cA cA chil wcel cA c0v cif wceq cc0 cA cG cpj cfv cfv cA cH
      cpj cfv cfv cmv co cA csp co cle wbr cc0 cA chil wcel cA c0v cif cG cpj
      cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv co cA chil wcel cA c0v
      cif csp co cle wbr cA cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv
      cle wbr cA chil wcel cA c0v cif cH cpj cfv cfv cno cfv cA chil wcel cA
      c0v cif cG cpj cfv cfv cno cfv cle wbr cA cA chil wcel cA c0v cif wceq cA
      cG cpj cfv cfv cA cH cpj cfv cfv cmv co cA csp co cA chil wcel cA c0v cif
      cG cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cmv co cA chil wcel
      cA c0v cif csp co cc0 cle cA cA chil wcel cA c0v cif wceq cA cG cpj cfv
      cfv cA cH cpj cfv cfv cmv co cA chil wcel cA c0v cif cG cpj cfv cfv cA
      chil wcel cA c0v cif cH cpj cfv cfv cmv co cA cA chil wcel cA c0v cif csp
      cA cA chil wcel cA c0v cif wceq cA cG cpj cfv cfv cA chil wcel cA c0v cif
      cG cpj cfv cfv cA cH cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv
      cmv cA cA chil wcel cA c0v cif cG cpj cfv fveq2 cA cA chil wcel cA c0v
      cif cH cpj cfv fveq2 opreq12d cA cA chil wcel cA c0v cif wceq id opreq12d
      breq2d cA cA chil wcel cA c0v cif wceq cA cH cpj cfv cfv cno cfv cA chil
      wcel cA c0v cif cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv cA chil
      wcel cA c0v cif cG cpj cfv cfv cno cfv cle cA cA chil wcel cA c0v cif
      wceq cA cH cpj cfv cfv cA chil wcel cA c0v cif cH cpj cfv cfv cno cA cA
      chil wcel cA c0v cif cH cpj cfv fveq2 fveq2d cA cA chil wcel cA c0v cif
      wceq cA cG cpj cfv cfv cA chil wcel cA c0v cif cG cpj cfv cfv cno cA cA
      chil wcel cA c0v cif cG cpj cfv fveq2 fveq2d breq12d bibi12d cA chil wcel
      cA c0v cif cG cH pjco.2 cA c0v chil ax-hv0cl elimel pjco.1 pjdifnormii
      dedth $.
      $( [26-Sep-2001] $)

    $( Theorem 4.5(i)<->(vi) of [Beran] p. 112. $)
    pjnormssi $p |- ( G C_ H <-> A. x e. ~H ( normh ` ( ( proj ` G ) ` x ) ) <_
                   ( normh ` ( ( proj ` H ) ` x ) ) ) $=
      cG cH wss vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle
      wbr vx chil wral cG cH wss vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv
      cfv cno cfv cle wbr vx chil vx cv chil wcel cG cH wss vx cv cG cpj cfv
      cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx cv chil wcel cG cH
      wss cc0 vx cv cH cpj cfv cfv vx cv cG cpj cfv cfv cmv co vx cv csp co cle
      wbr vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx
      cv chil wcel cG cH wss vx cv cH cpj cfv cfv vx cv cG cpj cfv cfv cmv co
      vx cv cH cG cort cfv cin cpj cfv cfv wceq cc0 vx cv cH cpj cfv cfv vx cv
      cG cpj cfv cfv cmv co vx cv csp co cle wbr vx cv cH cG pjco.2 pjco.1
      pjssmi vx cv cH cG pjco.2 pjco.1 pjssge0i syld vx cv cH cG pjco.2 pjco.1
      pjdifnormi sylibd com12 r19.21aiv vx cv cG cpj cfv cfv cno cfv vx cv cH
      cpj cfv cfv cno cfv cle wbr vx chil wral cH cort cfv cG cort cfv wss cG
      cH wss vx cv chil wcel vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv
      cno cfv cle wbr wi vx wal vx cv cH cort cfv wcel vx cv cG cort cfv wcel
      wi vx wal vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle
      wbr vx chil wral cH cort cfv cG cort cfv wss vx cv chil wcel vx cv cG cpj
      cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr wi vx cv cH cort cfv
      wcel vx cv cG cort cfv wcel wi vx vx cv chil wcel vx cv cG cpj cfv cfv
      cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr wi vx cv cH cort cfv wcel vx
      cv cG cort cfv wcel vx cv chil wcel vx cv cG cpj cfv cfv cno cfv vx cv cH
      cpj cfv cfv cno cfv cle wbr wi vx cv chil wcel vx cv cH cort cfv wcel vx
      cv cG cort cfv wcel wi vx cv cH cort cfv wcel vx cv chil wcel vx cv cG
      cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx cv cH cort
      cfv wcel vx cv cG cort cfv wcel wi vx cv chil wcel vx cv cG cpj cfv cfv
      cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx cv cH cort cfv wcel vx cv
      cG cort cfv wcel wi vx cv chil wcel vx cv cG cpj cfv cfv cno cfv vx cv cH
      cpj cfv cfv cno cfv cle wbr wa vx cv cH cpj cfv cfv cno cfv cc0 wceq vx
      cv cG cpj cfv cfv cno cfv cc0 wceq vx cv cH cort cfv wcel vx cv cG cort
      cfv wcel vx cv chil wcel vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv
      cfv cno cfv cle wbr vx cv cH cpj cfv cfv cno cfv cc0 wceq vx cv cG cpj
      cfv cfv cno cfv cc0 wceq wi vx cv chil wcel vx cv cG cpj cfv cfv cno cfv
      vx cv cH cpj cfv cfv cno cfv cle wbr vx cv cH cpj cfv cfv cno cfv cc0
      wceq vx cv cG cpj cfv cfv cno cfv cc0 wceq vx cv chil wcel vx cv cG cpj
      cfv cfv cno cfv cc0 cle wbr vx cv cG cpj cfv cfv cno cfv cc0 wceq vx cv
      cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx cv cH cpj
      cfv cfv cno cfv cc0 wceq wa vx cv chil wcel vx cv cG cpj cfv cfv cno cfv
      cc0 cle wbr vx cv cG cpj cfv cfv cno cfv cc0 wceq vx cv chil wcel vx cv
      cG cpj cfv cfv cno cfv cc0 cle wbr cc0 vx cv cG cpj cfv cfv cno cfv cle
      wbr vx cv cG cpj cfv cfv cno cfv cc0 wceq vx cv chil wcel vx cv chil wcel
      vx cv cG cpj cfv cfv cno cfv cr wcel cc0 cr wcel wa vx cv cG cpj cfv cfv
      cno cfv cc0 cle wbr cc0 vx cv cG cpj cfv cfv cno cfv cle wbr wa vx cv cG
      cpj cfv cfv cno cfv cc0 wceq wi vx cv chil wcel vx cv cG cpj cfv cfv cno
      cfv cr wcel cc0 cr wcel vx cv chil wcel vx cv cG cpj cfv cfv chil wcel vx
      cv cG cpj cfv cfv cno cfv cr wcel vx cv cG pjco.1 pjhcli vx cv cG cpj cfv
      cfv normcl syl 0re jctir vx cv cG cpj cfv cfv cno cfv cr wcel cc0 cr wcel
      wa vx cv cG cpj cfv cfv cno cfv cc0 wceq vx cv cG cpj cfv cfv cno cfv cc0
      cle wbr cc0 vx cv cG cpj cfv cfv cno cfv cle wbr wa vx cv cG cpj cfv cfv
      cno cfv cc0 letri3 biimprd syl vx cv chil wcel vx cv cG cpj cfv cfv chil
      wcel cc0 vx cv cG cpj cfv cfv cno cfv cle wbr vx cv cG pjco.1 pjhcli vx
      cv cG cpj cfv cfv normge0 syl sylan2i anabsi6 vx cv cH cpj cfv cfv cno
      cfv cc0 wceq vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv
      cle wbr vx cv cG cpj cfv cfv cno cfv cc0 cle wbr vx cv cH cpj cfv cfv cno
      cfv cc0 vx cv cG cpj cfv cfv cno cfv cle breq2 biimpac sylan2 exp32 imp
      vx cv chil wcel vx cv cH cpj cfv cfv cno cfv cc0 wceq vx cv cH cort cfv
      wcel wb vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr
      vx cv chil wcel vx cv cH cpj cfv cfv cno cfv cc0 wceq vx cv cH cpj cfv
      cfv c0v wceq vx cv cH cort cfv wcel vx cv chil wcel vx cv cH cpj cfv cfv
      chil wcel vx cv cH cpj cfv cfv cno cfv cc0 wceq vx cv cH cpj cfv cfv c0v
      wceq wb vx cv cH pjco.2 pjhcli vx cv cH cpj cfv cfv norm-i syl cH cch
      wcel vx cv chil wcel vx cv cH cort cfv wcel vx cv cH cpj cfv cfv c0v wceq
      wb pjco.2 vx cv cH pjoc2 mpan bitr4d adantr vx cv chil wcel vx cv cG cpj
      cfv cfv cno cfv cc0 wceq vx cv cG cort cfv wcel wb vx cv cG cpj cfv cfv
      cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx cv chil wcel vx cv cG cpj
      cfv cfv cno cfv cc0 wceq vx cv cG cpj cfv cfv c0v wceq vx cv cG cort cfv
      wcel vx cv chil wcel vx cv cG cpj cfv cfv chil wcel vx cv cG cpj cfv cfv
      cno cfv cc0 wceq vx cv cG cpj cfv cfv c0v wceq wb vx cv cG pjco.1 pjhcli
      vx cv cG cpj cfv cfv norm-i syl cG cch wcel vx cv chil wcel vx cv cG cort
      cfv wcel vx cv cG cpj cfv cfv c0v wceq wb pjco.1 vx cv cG pjoc2 mpan
      bitr4d adantr 3imtr3d ex a2i vx cv cH cort cfv cH pjco.2 choccli cheli
      syl5 pm2.43d 19.20i vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno
      cfv cle wbr vx chil df-ral vx cH cort cfv cG cort cfv dfss2 3imtr4i cG cH
      pjco.1 pjco.2 chsscon3i sylibr impbii $.
      $( [26-Sep-2001] $)

    $( Composition of projections of orthogonal subspaces.  Part (i)->(iia) of
       Theorem 27.4 of [Halmos] p. 45. $)
    pjorthcoi $p |- ( G C_ ( _|_ ` H ) ->
                 ( ( proj ` G ) o. ( proj ` H ) ) = 0hop ) $=
      cG cH cort cfv wss vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv ch0o cfv
      wceq vx chil wral cG cpj cfv cH cpj cfv ccom ch0o wceq cG cH cort cfv wss
      vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv ch0o cfv wceq vx chil cG cH
      cort cfv wss vx cv chil wcel wa vx cv cH cpj cfv cfv cG cpj cfv cfv c0v
      vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv ch0o cfv vx cv chil wcel cG cH
      cort cfv wss vx cv cH cpj cfv cfv cG cpj cfv cfv c0v wceq vx cv chil wcel
      cG cH cort cfv wss vx cv cH cpj cfv cfv cG cort cfv wcel vx cv cH cpj cfv
      cfv cG cpj cfv cfv c0v wceq cG cH cort cfv wss vx cv cH cpj cfv cfv cH
      wcel vx cv cH cpj cfv cfv cG cort cfv wcel vx cv chil wcel cG cH cort cfv
      wss cH cG cort cfv wss vx cv cH cpj cfv cfv cH wcel vx cv cH cpj cfv cfv
      cG cort cfv wcel wi cG cH pjco.1 pjco.2 chsscon2i cH cG cort cfv vx cv cH
      cpj cfv cfv ssel sylbi vx cv cH pjco.2 pjcli syl5com vx cv chil wcel vx
      cv cH cpj cfv cfv chil wcel vx cv cH cpj cfv cfv cG cort cfv wcel vx cv
      cH cpj cfv cfv cG cpj cfv cfv c0v wceq wb vx cv cH pjco.2 pjhcli cG cch
      wcel vx cv cH cpj cfv cfv chil wcel vx cv cH cpj cfv cfv cG cort cfv wcel
      vx cv cH cpj cfv cfv cG cpj cfv cfv c0v wceq wb pjco.1 vx cv cH cpj cfv
      cfv cG pjoc2 mpan syl sylibd impcom vx cv chil wcel vx cv cG cpj cfv cH
      cpj cfv ccom cfv vx cv cH cpj cfv cfv cG cpj cfv cfv wceq cG cH cort cfv
      wss vx cv cG cH pjco.1 pjco.2 pjcoi adantl vx cv chil wcel vx cv ch0o cfv
      c0v wceq cG cH cort cfv wss vx cv ho0val adantl 3eqtr4d r19.21aiva vx cG
      cpj cfv cH cpj cfv ccom ch0o cG cpj cfv cH cpj cfv cG pjco.1 pjfi cH
      pjco.2 pjfi hocofi ho0f hoeqi sylib $.
      $( [24-Dec-2007] $) $( [6-Nov-2000] $)

    $( The projection of orthogonal subspaces is the sum of the projections. $)
    pjscji $p |- ( G C_ ( _|_ ` H ) -> ( proj ` ( G vH H ) ) =
              ( ( proj ` G ) +op ( proj ` H ) ) ) $=
      cG cH cort cfv wss vx cv cG cH chj co cpj cfv cfv vx cv cG cpj cfv cH cpj
      cfv chos co cfv wceq vx chil wral cG cH chj co cpj cfv cG cpj cfv cH cpj
      cfv chos co wceq cG cH cort cfv wss vx cv cG cH chj co cpj cfv cfv vx cv
      cG cpj cfv cH cpj cfv chos co cfv wceq vx chil cG cH cort cfv wss vx cv
      chil wcel wa vx cv cG cH chj co cpj cfv cfv vx cv cG cpj cfv cfv vx cv cH
      cpj cfv cfv cva co vx cv cG cpj cfv cH cpj cfv chos co cfv vx cv chil
      wcel cG cH cort cfv wss vx cv cG cH chj co cpj cfv cfv vx cv cG cpj cfv
      cfv vx cv cH cpj cfv cfv cva co wceq cG cch wcel cH cch wcel vx cv chil
      wcel cG cH cort cfv wss vx cv cG cH chj co cpj cfv cfv vx cv cG cpj cfv
      cfv vx cv cH cpj cfv cfv cva co wceq wi pjco.1 pjco.2 vx cv cH cG pjcjt2
      mp3an12 impcom vx cv chil wcel vx cv cG cpj cfv cH cpj cfv chos co cfv vx
      cv cG cpj cfv cfv vx cv cH cpj cfv cfv cva co wceq cG cH cort cfv wss
      chil chil cG cpj cfv wf chil chil cH cpj cfv wf vx cv chil wcel vx cv cG
      cpj cfv cH cpj cfv chos co cfv vx cv cG cpj cfv cfv vx cv cH cpj cfv cfv
      cva co wceq cG pjco.1 pjfi cH pjco.2 pjfi vx cv cG cpj cfv cH cpj cfv
      hosvalOLD mpanl12 adantl eqtr4d r19.21aiva vx cG cH chj co cpj cfv cG cpj
      cfv cH cpj cfv chos co cG cH chj co cG cH pjco.1 pjco.2 chjcli pjfi cG
      cpj cfv cH cpj cfv cG pjco.1 pjfi cH pjco.2 pjfi hoaddcli hoeqi sylib $.
      $( [11-Nov-2000] $)

    $( The projection on a subspace sum is the sum of the projections. $)
    pjssumi $p |- ( G C_ ( _|_ ` H ) -> ( proj ` ( G +H H ) ) =
              ( ( proj ` G ) +op ( proj ` H ) ) ) $=
      cG cH cort cfv wss cG cH cph co cpj cfv cG cH chj co cpj cfv cG cpj cfv
      cH cpj cfv chos co cG cH cort cfv wss cG cH cph co cG cH chj co cpj cG cH
      pjco.1 pjco.2 osumi fveq2d cG cH pjco.1 pjco.2 pjscji eqtrd $.
      $( [11-Nov-2000] $)

    $( Projector ordering can be expressed by the subset relationship between
       their projection subspaces.  (i)<->(iii) of Theorem 29.2 of [Halmos]
       p. 48. $)
    pjssposi $p |- ( A. x e. ~H
       0 <_ ( ( ( ( proj ` H ) -op ( proj ` G ) ) ` x ) .ih x ) <-> G C_ H ) $=
      cc0 vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv csp co cle wbr vx chil
      wral vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx
      chil wral cG cH wss cc0 vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv csp
      co cle wbr vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle
      wbr vx chil vx cv chil wcel cc0 vx cv cH cpj cfv cfv cno cfv c2 cexp co
      vx cv cG cpj cfv cfv cno cfv c2 cexp co cmin co cle wbr vx cv cG cpj cfv
      cfv cno cfv c2 cexp co vx cv cH cpj cfv cfv cno cfv c2 cexp co cle wbr
      cc0 vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv csp co cle wbr vx cv cG
      cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx cv cH cpj cfv
      cfv cno cfv c2 cexp co cr wcel vx cv cG cpj cfv cfv cno cfv c2 cexp co cr
      wcel cc0 vx cv cH cpj cfv cfv cno cfv c2 cexp co vx cv cG cpj cfv cfv cno
      cfv c2 cexp co cmin co cle wbr vx cv cG cpj cfv cfv cno cfv c2 cexp co vx
      cv cH cpj cfv cfv cno cfv c2 cexp co cle wbr wb vx cv chil wcel vx cv cH
      cpj cfv cfv cno cfv c2 cexp co vx cv cG cpj cfv cfv cno cfv c2 cexp co
      subge0 vx cv chil wcel vx cv cH cpj cfv cfv chil wcel vx cv cH cpj cfv
      cfv cno cfv cr wcel vx cv cH cpj cfv cfv cno cfv c2 cexp co cr wcel vx cv
      cH pjco.2 pjhcli vx cv cH cpj cfv cfv normcl vx cv cH cpj cfv cfv cno cfv
      resqcl 3syl vx cv chil wcel vx cv cG cpj cfv cfv chil wcel vx cv cG cpj
      cfv cfv cno cfv cr wcel vx cv cG cpj cfv cfv cno cfv c2 cexp co cr wcel
      vx cv cG pjco.1 pjhcli vx cv cG cpj cfv cfv normcl vx cv cG cpj cfv cfv
      cno cfv resqcl 3syl sylanc vx cv chil wcel vx cv cH cpj cfv cG cpj cfv
      chod co cfv vx cv csp co vx cv cH cpj cfv cfv cno cfv c2 cexp co vx cv cG
      cpj cfv cfv cno cfv c2 cexp co cmin co cc0 cle vx cv chil wcel vx cv cH
      cpj cfv cG cpj cfv chod co cfv vx cv csp co vx cv cH cpj cfv cfv vx cv cG
      cpj cfv cfv cmv co vx cv csp co vx cv cH cpj cfv cfv vx cv csp co vx cv
      cG cpj cfv cfv vx cv csp co cmin co vx cv cH cpj cfv cfv cno cfv c2 cexp
      co vx cv cG cpj cfv cfv cno cfv c2 cexp co cmin co vx cv chil wcel vx cv
      cH cpj cfv cG cpj cfv chod co cfv vx cv cH cpj cfv cfv vx cv cG cpj cfv
      cfv cmv co vx cv csp chil chil cH cpj cfv wf chil chil cG cpj cfv wf vx
      cv chil wcel vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv cH cpj cfv cfv
      vx cv cG cpj cfv cfv cmv co wceq cH pjco.2 pjfi cG pjco.1 pjfi vx cv cH
      cpj cfv cG cpj cfv hodval mp3an12 opreq1d vx cv cH cpj cfv cfv chil wcel
      vx cv cG cpj cfv cfv chil wcel vx cv chil wcel vx cv cH cpj cfv cfv vx cv
      cG cpj cfv cfv cmv co vx cv csp co vx cv cH cpj cfv cfv vx cv csp co vx
      cv cG cpj cfv cfv vx cv csp co cmin co wceq vx cv chil wcel vx cv cH cpj
      cfv cfv vx cv cG cpj cfv cfv vx cv his2sub vx cv cH pjco.2 pjhcli vx cv
      cG pjco.1 pjhcli vx cv chil wcel id syl3anc vx cv chil wcel vx cv cH cpj
      cfv cfv vx cv csp co vx cv cH cpj cfv cfv cno cfv c2 cexp co vx cv cG cpj
      cfv cfv vx cv csp co vx cv cG cpj cfv cfv cno cfv c2 cexp co cmin vx cv
      cH pjco.2 pjinormi vx cv cG pjco.1 pjinormi opreq12d 3eqtrd breq2d vx cv
      cG cpj cfv cfv cno cfv cr wcel cc0 vx cv cG cpj cfv cfv cno cfv cle wbr
      vx cv cH cpj cfv cfv cno cfv cr wcel cc0 vx cv cH cpj cfv cfv cno cfv cle
      wbr vx cv cG cpj cfv cfv cno cfv vx cv cH cpj cfv cfv cno cfv cle wbr vx
      cv cG cpj cfv cfv cno cfv c2 cexp co vx cv cH cpj cfv cfv cno cfv c2 cexp
      co cle wbr wb vx cv chil wcel vx cv cG cpj cfv cfv cno cfv vx cv cH cpj
      cfv cfv cno cfv le2sq vx cv chil wcel vx cv cG cpj cfv cfv chil wcel vx
      cv cG cpj cfv cfv cno cfv cr wcel vx cv cG pjco.1 pjhcli vx cv cG cpj cfv
      cfv normcl syl vx cv chil wcel vx cv cG cpj cfv cfv chil wcel cc0 vx cv
      cG cpj cfv cfv cno cfv cle wbr vx cv cG pjco.1 pjhcli vx cv cG cpj cfv
      cfv normge0 syl vx cv chil wcel vx cv cH cpj cfv cfv chil wcel vx cv cH
      cpj cfv cfv cno cfv cr wcel vx cv cH pjco.2 pjhcli vx cv cH cpj cfv cfv
      normcl syl vx cv chil wcel vx cv cH cpj cfv cfv chil wcel cc0 vx cv cH
      cpj cfv cfv cno cfv cle wbr vx cv cH pjco.2 pjhcli vx cv cH cpj cfv cfv
      normge0 syl syl2anc 3bitr4d ralbiia vx cG cH pjco.1 pjco.2 pjnormssi
      bitr4i $.
      $( [9-Jul-2006] $) $( [2-Jun-2006] $)

    $( The definition of projector ordering in [Halmos] p. 42 is equivalent to
       the definition of projector ordering in [Beran] p. 110.  (We will
       usually express projector ordering with the even simpler equivalent
       ` G C_ H ` ; see ~ pjssposi ). $)
    pjordi $p |- ( A. x e. ~H
        0 <_ ( ( ( ( proj ` H ) -op ( proj ` G ) ) ` x ) .ih x ) <->
        ( ( proj ` G ) " ~H ) C_ ( ( proj ` H ) " ~H ) ) $=
      cc0 vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv csp co cle wbr vx chil
      wral cG cH wss cG cpj cfv chil cima cH cpj cfv chil cima wss vx cG cH
      pjco.1 pjco.2 pjssposi cG cpj cfv chil cima cG cH cpj cfv chil cima cH
      chil cG cG cpj cfv wfo cG cpj cfv chil cima cG wceq cG pjco.1 pjfoi chil
      cG cG cpj cfv foima ax-mp chil cH cH cpj cfv wfo cH cpj cfv chil cima cH
      wceq cH pjco.2 pjfoi chil cH cH cpj cfv foima ax-mp sseq12i bitr4i $.
      $( [20-Oct-2006] $) $( [2-Jun-2006] $)

    $( The projection subspace of the difference between two projectors.
       Part 2 of Theorem 29.3 of [Halmos] p. 48 (shortened with
       ~ pjssposi ). $)
    pjssdif2i $p |- ( G C_ H <->
      ( ( proj ` H ) -op ( proj ` G ) ) = ( proj ` ( H i^i ( _|_ ` G ) ) ) ) $=
      cG cH wss cH cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv wceq
      cG cH wss vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv cH cG cort cfv
      cin cpj cfv cfv wceq vx chil wral cH cpj cfv cG cpj cfv chod co cH cG
      cort cfv cin cpj cfv wceq cG cH wss vx cv cH cpj cfv cG cpj cfv chod co
      cfv vx cv cH cG cort cfv cin cpj cfv cfv wceq vx chil cG cH wss vx cv
      chil wcel wa vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv cH cpj cfv cfv
      vx cv cG cpj cfv cfv cmv co vx cv cH cG cort cfv cin cpj cfv cfv vx cv
      chil wcel vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv cH cpj cfv cfv vx
      cv cG cpj cfv cfv cmv co wceq cG cH wss chil chil cH cpj cfv wf chil chil
      cG cpj cfv wf vx cv chil wcel vx cv cH cpj cfv cG cpj cfv chod co cfv vx
      cv cH cpj cfv cfv vx cv cG cpj cfv cfv cmv co wceq cH pjco.2 pjfi cG
      pjco.1 pjfi vx cv cH cpj cfv cG cpj cfv hodval mp3an12 adantl vx cv chil
      wcel cG cH wss vx cv cH cpj cfv cfv vx cv cG cpj cfv cfv cmv co vx cv cH
      cG cort cfv cin cpj cfv cfv wceq vx cv cH cG pjco.2 pjco.1 pjssmi impcom
      eqtrd r19.21aiva cH cpj cfv cG cpj cfv chod co chil wfn cH cG cort cfv
      cin cpj cfv chil wfn cH cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj
      cfv wceq vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv cH cG cort cfv cin
      cpj cfv cfv wceq vx chil wral wb cH cpj cfv cG cpj cfv cH pjco.2 pjfi cG
      pjco.1 pjfi hosubfni cH cG cort cfv cin cH cG cort cfv pjco.2 cG pjco.1
      choccli chincli pjfni vx chil cH cpj cfv cG cpj cfv chod co cH cG cort
      cfv cin cpj cfv eqfnfv2 mp2an sylibr cH cpj cfv cG cpj cfv chod co cH cG
      cort cfv cin cpj cfv wceq cc0 vx cv cH cpj cfv cG cpj cfv chod co cfv vx
      cv csp co cle wbr vx chil wral cG cH wss cH cpj cfv cG cpj cfv chod co cH
      cG cort cfv cin cpj cfv wceq cc0 vx cv cH cpj cfv cG cpj cfv chod co cfv
      vx cv csp co cle wbr vx chil cH cpj cfv cG cpj cfv chod co cH cG cort cfv
      cin cpj cfv wceq vx cv chil wcel wa cc0 vx cv cH cG cort cfv cin cpj cfv
      cfv vx cv csp co vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv csp co cle
      vx cv chil wcel cc0 vx cv cH cG cort cfv cin cpj cfv cfv vx cv csp co cle
      wbr cH cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv wceq vx cv
      cH cG cort cfv cin cH cG cort cfv pjco.2 cG pjco.1 choccli chincli
      pjige0i adantl cH cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv
      wceq vx cv cH cpj cfv cG cpj cfv chod co cfv vx cv csp co vx cv cH cG
      cort cfv cin cpj cfv cfv vx cv csp co wceq vx cv chil wcel cH cpj cfv cG
      cpj cfv chod co cH cG cort cfv cin cpj cfv wceq vx cv cH cpj cfv cG cpj
      cfv chod co cfv vx cv cH cG cort cfv cin cpj cfv cfv vx cv csp vx cv cH
      cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv fveq1 opreq1d
      adantr breqtrrd r19.21aiva vx cG cH pjco.1 pjco.2 pjssposi sylib impbii
      $.
      $( [10-Jul-2006] $) $( [2-Jun-2006] $)

    $( A necessary and sufficient condition for the difference between two
       projectors to be a projector.  Part 1 of Theorem 29.3 of [Halmos]
       p. 48 (shortened with ~ pjssposi ). $)
    pjssdif1i $p |- ( G C_ H <->
                  ( ( proj ` H ) -op ( proj ` G ) ) e. ran proj ) $=
      cG cH wss cH cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv wceq
      cH cpj cfv cG cpj cfv chod co cpj crn wcel cG cH pjco.1 pjco.2 pjssdif2i
      cH cpj cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv wceq cH cpj cfv
      cG cpj cfv chod co cpj crn wcel cH cpj cfv cG cpj cfv chod co cH cG cort
      cfv cin cpj cfv wceq cH cpj cfv cG cpj cfv chod co cpj crn wcel cH cG
      cort cfv cin cpj cfv cpj crn wcel cpj cch wfn cH cG cort cfv cin cch wcel
      cH cG cort cfv cin cpj cfv cpj crn wcel pjmfn cH cG cort cfv pjco.2 cG
      pjco.1 choccli chincli cch cH cG cort cfv cin cpj fnfvelrn mp2an cH cpj
      cfv cG cpj cfv chod co cH cG cort cfv cin cpj cfv cpj crn eleq1 mpbiri cH
      cpj cfv cG cpj cfv chod co cpj crn wcel cc0 vy cv cH cpj cfv cG cpj cfv
      chod co cfv vy cv csp co cle wbr vy chil wral cH cpj cfv cG cpj cfv chod
      co cH cG cort cfv cin cpj cfv wceq cH cpj cfv cG cpj cfv chod co cpj crn
      wcel vx cv cpj cfv cH cpj cfv cG cpj cfv chod co wceq vx cch wrex cc0 vy
      cv cH cpj cfv cG cpj cfv chod co cfv vy cv csp co cle wbr vy chil wral
      cpj cch wfn cH cpj cfv cG cpj cfv chod co cpj crn wcel vx cv cpj cfv cH
      cpj cfv cG cpj cfv chod co wceq vx cch wrex wb pjmfn vx cch cH cpj cfv cG
      cpj cfv chod co cpj fvelrnb ax-mp vx cv cpj cfv cH cpj cfv cG cpj cfv
      chod co wceq cc0 vy cv cH cpj cfv cG cpj cfv chod co cfv vy cv csp co cle
      wbr vy chil wral vx cch vx cv cch wcel vx cv cpj cfv cH cpj cfv cG cpj
      cfv chod co wceq wa cc0 vy cv cH cpj cfv cG cpj cfv chod co cfv vy cv csp
      co cle wbr vy chil vx cv cch wcel vx cv cpj cfv cH cpj cfv cG cpj cfv
      chod co wceq wa vy cv chil wcel wa cc0 vy cv vx cv cpj cfv cfv vy cv csp
      co cle wbr cc0 vy cv cH cpj cfv cG cpj cfv chod co cfv vy cv csp co cle
      wbr vx cv cch wcel vy cv chil wcel cc0 vy cv vx cv cpj cfv cfv vy cv csp
      co cle wbr vx cv cpj cfv cH cpj cfv cG cpj cfv chod co wceq vy cv vx cv
      pjige0 adantlr vx cv cpj cfv cH cpj cfv cG cpj cfv chod co wceq cc0 vy cv
      vx cv cpj cfv cfv vy cv csp co cle wbr cc0 vy cv cH cpj cfv cG cpj cfv
      chod co cfv vy cv csp co cle wbr wb vx cv cch wcel vy cv chil wcel vx cv
      cpj cfv cH cpj cfv cG cpj cfv chod co wceq vy cv vx cv cpj cfv cfv vy cv
      csp co vy cv cH cpj cfv cG cpj cfv chod co cfv vy cv csp co cc0 cle vx cv
      cpj cfv cH cpj cfv cG cpj cfv chod co wceq vy cv vx cv cpj cfv cfv vy cv
      cH cpj cfv cG cpj cfv chod co cfv vy cv csp vy cv vx cv cpj cfv cH cpj
      cfv cG cpj cfv chod co fveq1 opreq1d breq2d ad2antlr mpbid r19.21aiva
      r19.23aiva sylbi cc0 vy cv cH cpj cfv cG cpj cfv chod co cfv vy cv csp co
      cle wbr vy chil wral cG cH wss cH cpj cfv cG cpj cfv chod co cH cG cort
      cfv cin cpj cfv wceq vy cG cH pjco.1 pjco.2 pjssposi cG cH pjco.1 pjco.2
      pjssdif2i bitri sylib impbii bitri $.
      $( [30-Nov-2006] $) $( [2-Jun-2006] $)
  $}

  ${
    $d u v w A $.  $d u v w B $.
    pjima.1 $e |- A e. SH $.
    pjima.2 $e |- B e. CH $.
    $( The image of a projection.  Lemma 5 in Daniel Lehmann, "A presentation
       of Quantum Logic based on an _and then_ connective"
       ~ http://www.arxiv.org/pdf/quant-ph/0701113 p. 20. $)
    pjimai $p |- ( ( proj ` B ) " A ) = ( ( A +H ( _|_ ` B ) ) i^i B ) $=
      vu cB cpj cfv cA cima cA cB cort cfv cph co cB cin vu cv cB cpj cfv cA
      cima wcel vu cv cB wcel wa vu cv cA cB cort cfv cph co wcel vu cv cB wcel
      wa vu cv cB cpj cfv cA cima wcel vu cv cA cB cort cfv cph co cB cin wcel
      vu cv cB wcel vu cv cB cpj cfv cA cima wcel vu cv cA cB cort cfv cph co
      wcel vu cv cB wcel vv cv cB cpj cfv cfv vu cv wceq vv cA wrex vu cv vv cv
      vw cv cmv co wceq vw cB cort cfv wrex vv cA wrex vu cv cB cpj cfv cA cima
      wcel vu cv cA cB cort cfv cph co wcel vu cv cB wcel vv cv cB cpj cfv cfv
      vu cv wceq vu cv vv cv vw cv cmv co wceq vw cB cort cfv wrex vv cA vu cv
      cB wcel vv cv cA wcel wa vv cv cB cpj cfv cfv vu cv wceq vv cv vu cv vw
      cv cva co wceq vw cB cort cfv wrex vu cv vv cv vw cv cmv co wceq vw cB
      cort cfv wrex vv cv cA wcel vu cv cB wcel vv cv cB cpj cfv cfv vu cv wceq
      vv cv vu cv vw cv cva co wceq vw cB cort cfv wrex wb vv cv chil wcel vu
      cv cB wcel vv cv cB cpj cfv cfv vu cv wceq vv cv vu cv vw cv cva co wceq
      vw cB cort cfv wrex wb vv cv cA wcel cB cch wcel vv cv chil wcel vu cv cB
      wcel vv cv cB cpj cfv cfv vu cv wceq vv cv vu cv vw cv cva co wceq vw cB
      cort cfv wrex wb pjima.2 vw vv cv vu cv cB pjeq2 mp3an1 vv cv cA pjima.1
      sheli sylan ancoms vu cv cB wcel vv cv cA wcel wa vu cv vv cv vw cv cmv
      co wceq vv cv vu cv vw cv cva co wceq vw cB cort cfv vu cv cB wcel vv cv
      cA wcel vw cv cB cort cfv wcel vu cv vv cv vw cv cmv co wceq vv cv vu cv
      vw cv cva co wceq wb vu cv cB wcel vv cv cA wcel vw cv cB cort cfv wcel
      w3a vv cv vw cv cmv co vu cv wceq vu cv vw cv cva co vv cv wceq vu cv vv
      cv vw cv cmv co wceq vv cv vu cv vw cv cva co wceq vu cv chil wcel vv cv
      chil wcel vw cv chil wcel vv cv vw cv cmv co vu cv wceq vu cv vw cv cva
      co vv cv wceq wb vu cv cB wcel vv cv cA wcel vw cv cB cort cfv wcel vu cv
      chil wcel vv cv chil wcel vw cv chil wcel w3a vv cv vw cv cmv co vu cv
      wceq vw cv vu cv cva co vv cv wceq vu cv vw cv cva co vv cv wceq vv cv
      chil wcel vw cv chil wcel vu cv chil wcel vv cv vw cv cmv co vu cv wceq
      vw cv vu cv cva co vv cv wceq wb vv cv vw cv vu cv hvsubadd 3comr vu cv
      chil wcel vv cv chil wcel vw cv chil wcel w3a vu cv vw cv cva co vw cv vu
      cv cva co vv cv vu cv chil wcel vw cv chil wcel vu cv vw cv cva co vw cv
      vu cv cva co wceq vv cv chil wcel vu cv vw cv ax-hvcom 3adant2 eqeq1d
      bitr4d vu cv cB pjima.2 cheli vv cv cA pjima.1 sheli vw cv cB cort cfv cB
      pjima.2 choccli cheli syl3an vu cv vv cv vw cv cmv co eqcom vv cv vu cv
      vw cv cva co eqcom 3bitr4g 3expa rexbidva bitr4d rexbidva cB cpj cfv chil
      wfn cA chil wss vu cv cB cpj cfv cA cima wcel vv cv cB cpj cfv cfv vu cv
      wceq vv cA wrex wb cB pjima.2 pjfni cA pjima.1 shssii vv chil cA vu cv cB
      cpj cfv fvelimab mp2an cA csh wcel cB cort cfv csh wcel vu cv cA cB cort
      cfv cph co wcel vu cv vv cv vw cv cmv co wceq vw cB cort cfv wrex vv cA
      wrex wb pjima.1 cB cort cfv cB pjima.2 choccli chshii vv vw cA cB cort
      cfv vu cv shsel3 mp2an 3bitr4g pm5.32ri vu cv cB cpj cfv cA cima wcel vu
      cv cB wcel cB cpj cfv cA cima cB vu cv cB cpj cfv cA cima cB cpj cfv crn
      cB cB cpj cfv cA imassrn cB pjima.2 pjrni sseqtri sseli pm4.71i vu cv cA
      cB cort cfv cph co cB elin 3bitr4i eqriv $.
      $( [23-Feb-2007] $) $( [20-Jan-2007] $)
  $}

  ${
    $d x H $.
    pjidmco.1 $e |- H e. CH $.
    $( A projection is idempotent.  Property (ii) of [Beran] p. 109. $)
    pjidmcoi $p |- ( ( proj ` H ) o. ( proj ` H ) ) = ( proj ` H ) $=
      cH cH wss cH cpj cfv cH cpj cfv ccom cH cpj cfv wceq cH ssid cH cH
      pjidmco.1 pjidmco.1 pjss2coi mpbi $.
      $( [1-Oct-2000] $)

    $( Composition of projections of a subspace and its orthocomplement. $)
    pjoccoi $p |- ( ( proj ` H ) o. ( proj ` ( _|_ ` H ) ) ) = 0hop $=
      cH cH cort cfv cort cfv wss cH cpj cfv cH cort cfv cpj cfv ccom ch0o wceq
      cH chil wss cH cH cort cfv cort cfv wss cH pjidmco.1 chssii cH ococss
      ax-mp cH cH cort cfv pjidmco.1 cH pjidmco.1 choccli pjorthcoi ax-mp $.
      $( [5-Jul-2008] $) $( [14-Nov-2000] $)

    $( Subspace sum of projection and projection of orthocomplement. $)
    pjtoi $p |- ( ( proj ` H ) +op ( proj ` ( _|_ ` H ) ) ) = ( proj ` ~H ) $=
      vx cv cH cpj cfv cH cort cfv cpj cfv chos co cfv vx cv chil cpj cfv cfv
      wceq vx chil wral cH cpj cfv cH cort cfv cpj cfv chos co chil cpj cfv
      wceq vx cv cH cpj cfv cH cort cfv cpj cfv chos co cfv vx cv chil cpj cfv
      cfv wceq vx chil vx cv chil wcel vx cv vx cv cH cpj cfv cfv vx cv cH cort
      cfv cpj cfv cfv cva co vx cv chil cpj cfv cfv vx cv cH cpj cfv cH cort
      cfv cpj cfv chos co cfv cH cch wcel vx cv chil wcel vx cv vx cv cH cpj
      cfv cfv vx cv cH cort cfv cpj cfv cfv cva co wceq pjidmco.1 vx cv cH
      axpjpj mpan vx cv pjch1 chil chil cH cpj cfv wf chil chil cH cort cfv cpj
      cfv wf vx cv chil wcel vx cv cH cpj cfv cH cort cfv cpj cfv chos co cfv
      vx cv cH cpj cfv cfv vx cv cH cort cfv cpj cfv cfv cva co wceq cH
      pjidmco.1 pjfi cH cort cfv cH pjidmco.1 choccli pjfi vx cv cH cpj cfv cH
      cort cfv cpj cfv hosvalOLD mpanl12 3eqtr4rd rgen vx cH cpj cfv cH cort
      cfv cpj cfv chos co chil cpj cfv cH cpj cfv cH cort cfv cpj cfv cH
      pjidmco.1 pjfi cH cort cfv cH pjidmco.1 choccli pjfi hoaddcli chil helch
      pjfi hoeqi mpbi $.
      $( [16-Nov-2000] $)

    $( Projection of orthocomplement.  First part of Theorem 27.3 of [Halmos]
       p. 45. $)
    pjoci $p |- ( ( proj ` ~H ) -op ( proj ` H ) ) = ( proj ` ( _|_ ` H ) ) $=
      chil cpj cfv cH cpj cfv chod co cH cort cfv cpj cfv wceq cH cpj cfv cH
      cort cfv cpj cfv chos co chil cpj cfv wceq cH pjidmco.1 pjtoi chil cpj
      cfv cH cpj cfv cH cort cfv cpj cfv chil helch pjfi cH pjidmco.1 pjfi cH
      cort cfv cH pjidmco.1 choccli pjfi hodsi mpbir $.
      $( [26-Nov-2000] $)
  $}

  $( A projection operator is idempotent.  Property (ii) of [Beran] p. 109. $)
  pjidmco $p |- ( H e. CH ->
                 ( ( proj ` H ) o. ( proj ` H ) ) = ( proj ` H ) ) $=
    cH cch wcel cH cpj cfv cH cpj cfv ccom cH cpj cfv wceq cH cch wcel cH c0h
    cif cpj cfv cH cch wcel cH c0h cif cpj cfv ccom cH cch wcel cH c0h cif cpj
    cfv wceq cH c0h cH cH cch wcel cH c0h cif wceq cH cpj cfv cH cpj cfv ccom
    cH cch wcel cH c0h cif cpj cfv cH cch wcel cH c0h cif cpj cfv ccom cH cpj
    cfv cH cch wcel cH c0h cif cpj cfv cH cH cch wcel cH c0h cif wceq cH cpj
    cfv cH cch wcel cH c0h cif cpj cfv wceq cH cpj cfv cH cpj cfv ccom cH cch
    wcel cH c0h cif cpj cfv cH cch wcel cH c0h cif cpj cfv ccom wceq cH cH cch
    wcel cH c0h cif cpj fveq2 cH cpj cfv cH cch wcel cH c0h cif cpj cfv wceq cH
    cpj cfv cH cpj cfv ccom cH cch wcel cH c0h cif cpj cfv cH cpj cfv ccom cH
    cch wcel cH c0h cif cpj cfv cH cch wcel cH c0h cif cpj cfv ccom cH cpj cfv
    cH cch wcel cH c0h cif cpj cfv cH cpj cfv coeq1 cH cpj cfv cH cch wcel cH
    c0h cif cpj cfv cH cch wcel cH c0h cif cpj cfv coeq2 eqtrd syl cH cH cch
    wcel cH c0h cif cpj fveq2 eqeq12d cH cch wcel cH c0h cif cH c0h cch h0elch
    elimel pjidmcoi dedth $.
    $( [24-May-2006] $) $( [24-Apr-2006] $)

  ${
    $d h t u x T $.
    $( Two ways to express the set of all projection operators. $)
    pjhmopidm $p |- ran proj = ( HrmOp i^i { t | ( t o. t ) = t } ) $=
      cho vt cv vt cv ccom vt cv wceq vt cab cin cpj crn vu cho vt cv vt cv
      ccom vt cv wceq vt cab cpj crn vu cv cho wcel vu cv vu cv ccom vu cv wceq
      wa vh cv cpj cfv vu cv wceq vh cch wrex vu cv cho wcel vu cv vt cv vt cv
      ccom vt cv wceq vt cab wcel wa vu cv cpj crn wcel vu cv cho wcel vu cv vu
      cv ccom vu cv wceq wa vh cv cpj cfv vu cv wceq vh cch wrex vx cv vu cv
      cfv vx cv wceq vx chil crab cch wcel vx cv vu cv cfv vx cv wceq vx chil
      crab cpj cfv vu cv wceq vh cv cpj cfv vu cv wceq vh cch wrex vu cv cho
      wcel vu cv vu cv ccom vu cv wceq wa vh cv cpj cfv vu cv wceq vx cv vu cv
      cfv vx cv wceq vx chil crab cpj cfv vu cv wceq vh vx cv vu cv cfv vx cv
      wceq vx chil crab cch vh cv vx cv vu cv cfv vx cv wceq vx chil crab wceq
      vh cv cpj cfv vx cv vu cv cfv vx cv wceq vx chil crab cpj cfv vu cv vh cv
      vx cv vu cv cfv vx cv wceq vx chil crab cpj fveq2 eqeq1d rcla4ev vx vu cv
      hmopidmch vu cv cho wcel vu cv vu cv ccom vu cv wceq wa vu cv vx cv vu cv
      cfv vx cv wceq vx chil crab cpj cfv vx vu cv hmopidmpj eqcomd sylanc vh
      cv cpj cfv vu cv wceq vu cv cho wcel vu cv vu cv ccom vu cv wceq wa vh
      cch vh cv cch wcel vh cv cpj cfv vu cv wceq wa vu cv cho wcel vu cv vu cv
      ccom vu cv wceq vh cv cch wcel vh cv cpj cfv vu cv wceq wa vh cv cpj cfv
      vu cv cho vh cv cch wcel vh cv cpj cfv vu cv wceq pm3.27 vh cv cch wcel
      vh cv cpj cfv cho wcel vh cv cpj cfv vu cv wceq vh cv pjhmop adantr
      eqeltrrd vh cv cch wcel vh cv cpj cfv vu cv wceq wa vh cv cpj cfv vh cv
      cpj cfv ccom vh cv cpj cfv vu cv vu cv ccom vu cv vh cv cch wcel vh cv
      cpj cfv vh cv cpj cfv ccom vh cv cpj cfv wceq vh cv cpj cfv vu cv wceq vh
      cv pjidmco adantr vh cv cpj cfv vu cv wceq vh cv cpj cfv vh cv cpj cfv
      ccom vu cv vu cv ccom wceq vh cv cch wcel vh cv cpj cfv vu cv wceq vh cv
      cpj cfv vh cv cpj cfv ccom vu cv vh cv cpj cfv ccom vu cv vu cv ccom vh
      cv cpj cfv vu cv vh cv cpj cfv coeq1 vh cv cpj cfv vu cv vu cv coeq2
      eqtrd adantl vh cv cch wcel vh cv cpj cfv vu cv wceq pm3.27 3eqtr3d jca
      r19.23aiva impbii vu cv vt cv vt cv ccom vt cv wceq vt cab wcel vu cv vu
      cv ccom vu cv wceq vu cv cho wcel vt cv vt cv ccom vt cv wceq vu cv vu cv
      ccom vu cv wceq vt vu cv vu visset vt cv vu cv wceq vt cv vt cv ccom vu
      cv vu cv ccom vt cv vu cv vt cv vu cv wceq vt cv vt cv ccom vu cv vt cv
      ccom vu cv vu cv ccom vt cv vu cv vt cv coeq1 vt cv vu cv vu cv coeq2
      eqtrd vt cv vu cv wceq id eqeq12d elab anbi2i cpj cch wfn vu cv cpj crn
      wcel vh cv cpj cfv vu cv wceq vh cch wrex wb pjmfn vh cch vu cv cpj
      fvelrnb ax-mp 3bitr4i ineqri eqcomi $.
      $( [16-Jun-2006] $) $( [24-Apr-2006] $)

    $( Definition of projection operator in [Hughes] p. 47, except that we do
       not need linearity to be explicit by virtue of ~ hmoplin . $)
    dfpjop $p |-  ( T e. ran proj <-> ( T e. HrmOp  /\ ( T o. T ) = T ) ) $=
      cT cpj crn wcel cT cho vt cv vt cv ccom vt cv wceq vt cab cin wcel cT cho
      wcel cT vt cv vt cv ccom vt cv wceq vt cab wcel wa cT cho wcel cT cT ccom
      cT wceq wa cpj crn cho vt cv vt cv ccom vt cv wceq vt cab cin cT vt
      pjhmopidm eleq2i cT cho vt cv vt cv ccom vt cv wceq vt cab elin cT cho
      wcel cT vt cv vt cv ccom vt cv wceq vt cab wcel cT cT ccom cT wceq vt cv
      vt cv ccom vt cv wceq cT cT ccom cT wceq vt cT cho vt cv cT wceq vt cv vt
      cv ccom cT cT ccom vt cv cT vt cv cT wceq vt cv vt cv ccom cT vt cv ccom
      cT cT ccom vt cv cT vt cv coeq1 vt cv cT cT coeq2 eqtrd vt cv cT wceq id
      eqeq12d elabg pm5.32i 3bitri $.
      $( [16-Jun-2006] $) $( [24-Apr-2006] $)
  $}

  $( A projection operator is idempotent.  Part of Theorem 26.1 of [Halmos]
     p. 43. $)
  elpjidm $p |- ( T e. ran proj -> ( T o. T ) = T ) $=
    cT cpj crn wcel cT cho wcel cT cT ccom cT wceq cT dfpjop pm3.27bi $.
    $( [2-Dec-2006] $) $( [24-Apr-2006] $)

  $( A projection operator is Hermitian.  Part of Theorem 26.1 of [Halmos]
     p. 43. $)
  elpjhmop $p |- ( T e. ran proj -> T e. HrmOp ) $=
    cT cpj crn wcel cT cho wcel cT cT ccom cT wceq cT dfpjop pm3.26bi $.
    $( [9-Jul-2006] $) $( [24-Apr-2006] $)

  $( A projector is a positive operator. $)
  0leopj $p |- ( T e. ran proj -> 0hop <_op T ) $=
    cT cpj crn wcel ch0o cT cT ccom cT cleo cT cpj crn wcel cT cho wcel ch0o cT
    cT ccom cleo wbr cT elpjhmop cT leopsq syl cT elpjidm breqtrd $.
    $( [27-Sep-2008] $) $( [27-Sep-2008] $)

  $( A projector is self-adjoint.  Property (i) of [Beran] p. 109. $)
  pjadj2 $p |- ( T e. ran proj -> ( adjh ` T ) = T ) $=
    cT cpj crn wcel cT cho wcel cT cado cfv cT wceq cT elpjhmop cT hmopadj syl
    $.
    $( [10-Jul-2006] $) $( [3-Jun-2006] $)

  $( A projector is self-adjoint.  Property (i) of [Beran] p. 109. $)
  pjadj3 $p |- ( H e. CH -> ( adjh ` ( proj ` H ) ) = ( proj ` H ) ) $=
    cH cch wcel cH cpj cfv cpj crn wcel cH cpj cfv cado cfv cH cpj cfv wceq cpj
    cch wfn cH cch wcel cH cpj cfv cpj crn wcel pjmfn cch cH cpj fnfvelrn mpan
    cH cpj cfv pjadj2 syl $.
    $( [11-Jul-2006] $) $( [20-Feb-2006] $)

  ${
    $d x T $.
    $( Reconstruction of the subspace of a projection operator.  Part of
       Theorem 26.2 of [Halmos] p. 44. $)
    elpjch $p |- ( T e. ran proj -> ( { x e. ~H | ( T ` x ) = x } e. CH /\
                T = ( proj ` { x e. ~H | ( T ` x ) = x } ) ) ) $=
      cT cpj crn wcel cT cho wcel cT cT ccom cT wceq wa vx cv cT cfv vx cv wceq
      vx chil crab cch wcel cT vx cv cT cfv vx cv wceq vx chil crab cpj cfv
      wceq wa cT dfpjop cT cho wcel cT cT ccom cT wceq wa vx cv cT cfv vx cv
      wceq vx chil crab cch wcel cT vx cv cT cfv vx cv wceq vx chil crab cpj
      cfv wceq vx cT hmopidmch vx cT hmopidmpj jca sylbi $.
      $( [17-Jun-2006] $) $( [24-Apr-2006] $)

    $( Reconstruction of the subspace of a projection operator. $)
    elpjrn $p |- ( T e. ran proj -> ran T = { x e. ~H | ( T ` x ) = x } ) $=
      cT cpj crn wcel cT crn vx cv cT cfv vx cv wceq vx chil crab cpj cfv crn
      vx cv cT cfv vx cv wceq vx chil crab cT cpj crn wcel cT vx cv cT cfv vx
      cv wceq vx chil crab cpj cfv cT cpj crn wcel vx cv cT cfv vx cv wceq vx
      chil crab cch wcel cT vx cv cT cfv vx cv wceq vx chil crab cpj cfv wceq
      vx cT elpjch pm3.27d rneqd cT cpj crn wcel vx cv cT cfv vx cv wceq vx
      chil crab cch wcel vx cv cT cfv vx cv wceq vx chil crab cpj cfv crn vx cv
      cT cfv vx cv wceq vx chil crab wceq cT cpj crn wcel vx cv cT cfv vx cv
      wceq vx chil crab cch wcel cT vx cv cT cfv vx cv wceq vx chil crab cpj
      cfv wceq vx cT elpjch pm3.26d vx cv cT cfv vx cv wceq vx chil crab pjrn
      syl eqtrd $.
      $( [17-Jul-2006] $) $( [24-Apr-2006] $)

    $( Reconstruction of the subspace of a projection operator. $)
    elpjrnch $p |- ( T e. ran proj -> ( ran T e. CH /\
                T = ( proj ` ran T ) ) ) $=
      cT cpj crn wcel cT crn cch wcel cT cT crn cpj cfv wceq wa vx cv cT cfv vx
      cv wceq vx chil crab cch wcel cT vx cv cT cfv vx cv wceq vx chil crab cpj
      cfv wceq wa vx cT elpjch cT cpj crn wcel cT crn vx cv cT cfv vx cv wceq
      vx chil crab wceq cT crn cch wcel cT cT crn cpj cfv wceq wa vx cv cT cfv
      vx cv wceq vx chil crab cch wcel cT vx cv cT cfv vx cv wceq vx chil crab
      cpj cfv wceq wa wb vx cT elpjrn cT crn vx cv cT cfv vx cv wceq vx chil
      crab wceq cT crn cch wcel vx cv cT cfv vx cv wceq vx chil crab cch wcel
      cT cT crn cpj cfv wceq cT vx cv cT cfv vx cv wceq vx chil crab cpj cfv
      wceq cT crn vx cv cT cfv vx cv wceq vx chil crab cch eleq1 cT crn vx cv
      cT cfv vx cv wceq vx chil crab wceq cT crn cpj cfv vx cv cT cfv vx cv
      wceq vx chil crab cpj cfv cT cT crn vx cv cT cfv vx cv wceq vx chil crab
      cpj fveq2 eqeq2d anbi12d syl mpbird $.
      $( [5-Nov-2006] $) $( [24-Apr-2006] $)
  $}

  ${
    $d x H $.  $d x S $.  $d x T $.
    pjinvar.1 $e |- S : ~H --> ~H $.
    pjinvar.2 $e |- H e. CH $.
    pjinvar.3 $e |- T = ( proj ` H ) $.
    $( A closed subspace ` H ` with projection ` T ` is invariant under an
       operator ` S ` iff ` S T = T S T ` .  Theorem 27.1 of [Halmos] p. 45. $)
    pjinvari $p |- ( ( S o. T ) : ~H --> H <->
                  ( S o. T ) = ( T o. ( S o. T ) ) ) $=
      chil cH cS cT ccom wf cS cT ccom cT cS cT ccom ccom wceq chil cH cS cT
      ccom wf vx cv cS cT ccom cfv vx cv cT cS cT ccom ccom cfv wceq vx chil
      wral cS cT ccom cT cS cT ccom ccom wceq chil cH cS cT ccom wf vx cv cS cT
      ccom cfv vx cv cT cS cT ccom ccom cfv wceq vx chil chil cH cS cT ccom wf
      vx cv chil wcel wa vx cv cS cT ccom cfv vx cv cS cT ccom cfv cT cfv vx cv
      cT cS cT ccom ccom cfv chil cH cS cT ccom wf vx cv chil wcel wa vx cv cS
      cT ccom cfv cH cpj cfv cfv vx cv cS cT ccom cfv vx cv cS cT ccom cfv cT
      cfv chil cH cS cT ccom wf vx cv chil wcel wa vx cv cS cT ccom cfv cH wcel
      vx cv cS cT ccom cfv cH cpj cfv cfv vx cv cS cT ccom cfv wceq chil cH vx
      cv cS cT ccom ffvelrn cH cch wcel vx cv cS cT ccom cfv cH wcel vx cv cS
      cT ccom cfv cH cpj cfv cfv vx cv cS cT ccom cfv wceq pjinvar.2 vx cv cS
      cT ccom cfv cH pjid mpan syl vx cv cS cT ccom cfv cT cH cpj cfv pjinvar.3
      fveq1i syl5req vx cv chil wcel vx cv cT cS cT ccom ccom cfv vx cv cS cT
      ccom cfv cT cfv wceq chil cH cS cT ccom wf vx cv cT cS cT ccom chil cH cT
      wf cH chil wss chil chil cT wf chil cH cT wf chil cH cH cpj cfv wf chil
      cH cH cpj cfv wfo chil cH cH cpj cfv wf cH pjinvar.2 pjfoi chil cH cH cpj
      cfv fof ax-mp cT cH cpj cfv wceq chil cH cT wf chil cH cH cpj cfv wf wb
      pjinvar.3 chil cH cT cH cpj cfv feq1 ax-mp mpbir cH pjinvar.2 chssii chil
      cH chil cT fss mp2an cS cT pjinvar.1 chil cH cT wf cH chil wss chil chil
      cT wf chil cH cT wf chil cH cH cpj cfv wf chil cH cH cpj cfv wfo chil cH
      cH cpj cfv wf cH pjinvar.2 pjfoi chil cH cH cpj cfv fof ax-mp cT cH cpj
      cfv wceq chil cH cT wf chil cH cH cpj cfv wf wb pjinvar.3 chil cH cT cH
      cpj cfv feq1 ax-mp mpbir cH pjinvar.2 chssii chil cH chil cT fss mp2an
      hocofi hocoi adantl eqtr4d r19.21aiva cS cT ccom chil wfn cT cS cT ccom
      ccom chil wfn cS cT ccom cT cS cT ccom ccom wceq vx cv cS cT ccom cfv vx
      cv cT cS cT ccom ccom cfv wceq vx chil wral wb cS cT pjinvar.1 chil cH cT
      wf cH chil wss chil chil cT wf chil cH cT wf chil cH cH cpj cfv wf chil
      cH cH cpj cfv wfo chil cH cH cpj cfv wf cH pjinvar.2 pjfoi chil cH cH cpj
      cfv fof ax-mp cT cH cpj cfv wceq chil cH cT wf chil cH cH cpj cfv wf wb
      pjinvar.3 chil cH cT cH cpj cfv feq1 ax-mp mpbir cH pjinvar.2 chssii chil
      cH chil cT fss mp2an hocofni cT cS cT ccom chil cH cT wf cH chil wss chil
      chil cT wf chil cH cT wf chil cH cH cpj cfv wf chil cH cH cpj cfv wfo
      chil cH cH cpj cfv wf cH pjinvar.2 pjfoi chil cH cH cpj cfv fof ax-mp cT
      cH cpj cfv wceq chil cH cT wf chil cH cH cpj cfv wf wb pjinvar.3 chil cH
      cT cH cpj cfv feq1 ax-mp mpbir cH pjinvar.2 chssii chil cH chil cT fss
      mp2an cS cT pjinvar.1 chil cH cT wf cH chil wss chil chil cT wf chil cH
      cT wf chil cH cH cpj cfv wf chil cH cH cpj cfv wfo chil cH cH cpj cfv wf
      cH pjinvar.2 pjfoi chil cH cH cpj cfv fof ax-mp cT cH cpj cfv wceq chil
      cH cT wf chil cH cH cpj cfv wf wb pjinvar.3 chil cH cT cH cpj cfv feq1
      ax-mp mpbir cH pjinvar.2 chssii chil cH chil cT fss mp2an hocofi hocofni
      vx chil cS cT ccom cT cS cT ccom ccom eqfnfv2 mp2an sylibr cS cT ccom cT
      cS cT ccom ccom wceq chil cH cS cT ccom wf chil cH cT cS cT ccom ccom wf
      chil cH cT wf chil chil cS cT ccom wf chil cH cT cS cT ccom ccom wf chil
      cH cT wf chil cH cH cpj cfv wf chil cH cH cpj cfv wfo chil cH cH cpj cfv
      wf cH pjinvar.2 pjfoi chil cH cH cpj cfv fof ax-mp cT cH cpj cfv wceq
      chil cH cT wf chil cH cH cpj cfv wf wb pjinvar.3 chil cH cT cH cpj cfv
      feq1 ax-mp mpbir cS cT pjinvar.1 chil cH cT wf cH chil wss chil chil cT
      wf chil cH cT wf chil cH cH cpj cfv wf chil cH cH cpj cfv wfo chil cH cH
      cpj cfv wf cH pjinvar.2 pjfoi chil cH cH cpj cfv fof ax-mp cT cH cpj cfv
      wceq chil cH cT wf chil cH cH cpj cfv wf wb pjinvar.3 chil cH cT cH cpj
      cfv feq1 ax-mp mpbir cH pjinvar.2 chssii chil cH chil cT fss mp2an hocofi
      chil chil cH cT cS cT ccom fco mp2an chil cH cS cT ccom cT cS cT ccom
      ccom feq1 mpbiri impbii $.
      $( [9-Aug-2006] $) $( [24-Apr-2006] $)
  $}

  ${
    pjin1.1 $e |- G e. CH $.
    pjin1.2 $e |- H e. CH $.
    $( Lemma for Theorem 1.22 of Mittelstaedt, p. 20. $)
    pjin1i $p |- ( proj ` ( G i^i H ) ) =
                ( ( proj ` G ) o. ( proj ` ( G i^i H ) ) ) $=
      cG cpj cfv cG cH cin cpj cfv ccom cG cH cin cpj cfv cG cH cin cG wss cG
      cpj cfv cG cH cin cpj cfv ccom cG cH cin cpj cfv wceq cG cH inss1 cG cH
      cin cG cG cH pjin1.1 pjin1.2 chincli pjin1.1 pjss1coi mpbi eqcomi $.
      $( [22-Apr-2001] $)

    $( Lemma for Theorem 1.22 of Mittelstaedt, p. 20. $)
    pjin2i $p |- ( ( ( proj ` G ) = ( ( proj ` G ) o. ( proj ` H ) ) /\
                    ( proj ` H ) = ( ( proj ` H ) o. ( proj ` G ) ) ) <->
                ( proj ` G ) = ( proj ` H ) ) $=
      cG cpj cfv cG cpj cfv cH cpj cfv ccom wceq cH cpj cfv cH cpj cfv cG cpj
      cfv ccom wceq wa cG cpj cfv cH cpj cfv wceq cG cpj cfv cG cpj cfv cH cpj
      cfv ccom wceq cH cpj cfv cH cpj cfv cG cpj cfv ccom wceq wa cG cH wceq cG
      cpj cfv cH cpj cfv wceq cG cH wceq cG cH wss cH cG wss wa cG cpj cfv cG
      cpj cfv cH cpj cfv ccom wceq cH cpj cfv cH cpj cfv cG cpj cfv ccom wceq
      wa cG cH eqss cG cH wss cG cpj cfv cG cpj cfv cH cpj cfv ccom wceq cH cG
      wss cH cpj cfv cH cpj cfv cG cpj cfv ccom wceq cG cH wss cG cpj cfv cH
      cpj cfv ccom cG cpj cfv wceq cG cpj cfv cG cpj cfv cH cpj cfv ccom wceq
      cG cH pjin1.1 pjin1.2 pjss2coi cG cpj cfv cH cpj cfv ccom cG cpj cfv
      eqcom bitri cH cG wss cH cpj cfv cG cpj cfv ccom cH cpj cfv wceq cH cpj
      cfv cH cpj cfv cG cpj cfv ccom wceq cH cG pjin1.2 pjin1.1 pjss2coi cH cpj
      cfv cG cpj cfv ccom cH cpj cfv eqcom bitri anbi12i bitr2i cG cH cpj fveq2
      sylbi cG cpj cfv cH cpj cfv wceq cG cpj cfv cG cpj cfv cH cpj cfv ccom
      wceq cH cpj cfv cH cpj cfv cG cpj cfv ccom wceq cG cpj cfv cH cpj cfv
      wceq cG cpj cfv cG cpj cfv ccom cG cpj cfv cH cpj cfv ccom cG cpj cfv cG
      cpj cfv cH cpj cfv cG cpj cfv coeq2 cG pjin1.1 pjidmcoi syl5eqr cG cpj
      cfv cH cpj cfv wceq cH cpj cfv cG cpj cfv ccom cH cpj cfv cH cpj cfv ccom
      cH cpj cfv cG cpj cfv cH cpj cfv cH cpj cfv coeq2 cH pjin1.2 pjidmcoi
      syl6req jca impbii $.
      $( [22-Apr-2001] $)
  $}

  ${
    pjin3.1 $e |- F e. CH $.
    pjin3.2 $e |- G e. CH $.
    pjin3.3 $e |- H e. CH $.
    $( Lemma for Theorem 1.22 of Mittelstaedt, p. 20. $)
    pjin3i $p |- ( ( ( proj ` F ) = ( ( proj ` F ) o. ( proj ` G ) ) /\
                    ( proj ` F ) = ( ( proj ` F ) o. ( proj ` H ) ) ) <->
                ( proj ` F ) = ( ( proj ` F ) o. ( proj ` ( G i^i H ) ) ) ) $=
      cF cG wss cF cH wss wa cF cG cH cin wss cF cpj cfv cF cpj cfv cG cpj cfv
      ccom wceq cF cpj cfv cF cpj cfv cH cpj cfv ccom wceq wa cF cpj cfv cF cpj
      cfv cG cH cin cpj cfv ccom wceq cF cG cH ssin cF cG wss cF cpj cfv cF cpj
      cfv cG cpj cfv ccom wceq cF cH wss cF cpj cfv cF cpj cfv cH cpj cfv ccom
      wceq cF cG wss cF cpj cfv cG cpj cfv ccom cF cpj cfv wceq cF cpj cfv cF
      cpj cfv cG cpj cfv ccom wceq cF cG pjin3.1 pjin3.2 pjss2coi cF cpj cfv cG
      cpj cfv ccom cF cpj cfv eqcom bitri cF cH wss cF cpj cfv cH cpj cfv ccom
      cF cpj cfv wceq cF cpj cfv cF cpj cfv cH cpj cfv ccom wceq cF cH pjin3.1
      pjin3.3 pjss2coi cF cpj cfv cH cpj cfv ccom cF cpj cfv eqcom bitri
      anbi12i cF cG cH cin wss cF cpj cfv cG cH cin cpj cfv ccom cF cpj cfv
      wceq cF cpj cfv cF cpj cfv cG cH cin cpj cfv ccom wceq cF cG cH cin
      pjin3.1 cG cH pjin3.2 pjin3.3 chincli pjss2coi cF cpj cfv cG cH cin cpj
      cfv ccom cF cpj cfv eqcom bitri 3bitr3i $.
      $( [22-Apr-2001] $)
  $}

  ${
    $d x y G $.  $d x y H $.
    pjclem1.1 $e |- G e. CH $.
    pjclem1.2 $e |- H e. CH $.
    $( Lemma for projection commutation theorem. $)
    pjclem1 $p |- ( G C_H H ->
       ( ( proj ` G ) o. ( proj ` H ) ) = ( proj ` ( G i^i H ) ) ) $=
      cG cH ccm wbr cG cpj cfv cH cpj cfv cG cpj cfv ccom ccom cG cpj cfv cH
      cpj cfv cG cort cfv cpj cfv ccom ccom chos co cG cH cin cpj cfv ch0o chos
      co cG cpj cfv cH cpj cfv ccom cG cH cin cpj cfv cG cH ccm wbr cG cpj cfv
      cH cpj cfv cG cpj cfv ccom ccom cG cH cin cpj cfv cG cpj cfv cH cpj cfv
      cG cort cfv cpj cfv ccom ccom ch0o chos cG cH ccm wbr cG cpj cfv cG cH
      cin cG cH cort cfv cin chj co cpj cfv wceq cG cpj cfv cH cpj cfv cG cpj
      cfv ccom ccom cG cH cin cpj cfv wceq cG cH ccm wbr cG cG cH cin cG cH
      cort cfv cin chj co wceq cG cpj cfv cG cH cin cG cH cort cfv cin chj co
      cpj cfv wceq cG cH pjclem1.1 pjclem1.2 cmbri cG cG cH cin cG cH cort cfv
      cin chj co cpj fveq2 sylbi cG cpj cfv cG cH cin cG cH cort cfv cin chj co
      cpj cfv wceq cG cpj cfv cG cH cin cpj cfv cG cH cort cfv cin cpj cfv chos
      co wceq cG cpj cfv cH cpj cfv cG cpj cfv ccom ccom cG cH cin cpj cfv wceq
      cG cH cin cG cH cort cfv cin chj co cpj cfv cG cH cin cpj cfv cG cH cort
      cfv cin cpj cfv chos co cG cpj cfv cG cH cin cG cH cort cfv cin cort cfv
      wss cG cH cin cG cH cort cfv cin chj co cpj cfv cG cH cin cpj cfv cG cH
      cort cfv cin cpj cfv chos co wceq cG cH cin cH cG cH cort cfv cin cort
      cfv cG cH inss2 cH cG cort cfv cH chj co cG cH cort cfv cin cort cfv cH
      cG cort cfv pjclem1.2 cG pjclem1.1 choccli chub2i cG cH pjclem1.1
      pjclem1.2 chdmm3i sseqtr4i sstri cG cH cin cG cH cort cfv cin cG cH
      pjclem1.1 pjclem1.2 chincli cG cH cort cfv pjclem1.1 cH pjclem1.2 choccli
      chincli pjscji ax-mp eqeq2i cG cpj cfv cG cH cin cpj cfv cG cH cort cfv
      cin cpj cfv chos co wceq cH cpj cfv cG cpj cfv ccom cH cpj cfv cG cH cin
      cpj cfv cG cH cort cfv cin cpj cfv chos co ccom wceq cG cpj cfv cH cpj
      cfv cG cpj cfv ccom ccom cG cH cin cpj cfv wceq cG cpj cfv cG cH cin cpj
      cfv cG cH cort cfv cin cpj cfv chos co cH cpj cfv coeq2 cH cpj cfv cG cpj
      cfv ccom cH cpj cfv cG cH cin cpj cfv cG cH cort cfv cin cpj cfv chos co
      ccom wceq cH cpj cfv cG cpj cfv ccom cG cH cin cpj cfv wceq cG cpj cfv cH
      cpj cfv cG cpj cfv ccom ccom cG cH cin cpj cfv wceq cH cpj cfv cG cH cin
      cpj cfv cG cH cort cfv cin cpj cfv chos co ccom cG cH cin cpj cfv cH cpj
      cfv cG cpj cfv ccom cH cpj cfv cG cH cin cpj cfv cG cH cort cfv cin cpj
      cfv chos co ccom cH cpj cfv cG cH cin cpj cfv ccom cH cpj cfv cG cH cort
      cfv cin cpj cfv ccom chos co cG cH cin cpj cfv ch0o chos co cG cH cin cpj
      cfv cG cH cin cpj cfv cG cH cort cfv cin cpj cfv cH pjclem1.2 cG cH cin
      cG cH pjclem1.1 pjclem1.2 chincli pjfi cG cH cort cfv cin cG cH cort cfv
      pjclem1.1 cH pjclem1.2 choccli chincli pjfi pjsdii cH cpj cfv cG cH cin
      cpj cfv ccom cG cH cin cpj cfv cH cpj cfv cG cH cort cfv cin cpj cfv ccom
      ch0o chos cG cH cin cH wss cH cpj cfv cG cH cin cpj cfv ccom cG cH cin
      cpj cfv wceq cG cH inss2 cG cH cin cH cG cH pjclem1.1 pjclem1.2 chincli
      pjclem1.2 pjss1coi mpbi cH cG cH cort cfv cin cort cfv wss cH cpj cfv cG
      cH cort cfv cin cpj cfv ccom ch0o wceq cH cG cort cfv cH chj co cG cH
      cort cfv cin cort cfv cH cG cort cfv pjclem1.2 cG pjclem1.1 choccli
      chub2i cG cH pjclem1.1 pjclem1.2 chdmm3i sseqtr4i cH cG cH cort cfv cin
      pjclem1.2 cG cH cort cfv pjclem1.1 cH pjclem1.2 choccli chincli pjorthcoi
      ax-mp opreq12i cG cH cin cpj cfv cG cH cin cG cH pjclem1.1 pjclem1.2
      chincli pjfi hoaddid1i 3eqtri eqeq2i cH cpj cfv cG cpj cfv ccom cG cH cin
      cpj cfv wceq cG cpj cfv cH cpj cfv cG cpj cfv ccom ccom cG cpj cfv cG cH
      cin cpj cfv ccom cG cH cin cpj cfv cH cpj cfv cG cpj cfv ccom cG cH cin
      cpj cfv cG cpj cfv coeq2 cG cH cin cG wss cG cpj cfv cG cH cin cpj cfv
      ccom cG cH cin cpj cfv wceq cG cH inss1 cG cH cin cG cG cH pjclem1.1
      pjclem1.2 chincli pjclem1.1 pjss1coi mpbi syl6eq sylbi syl sylbi syl cG
      cH ccm wbr cG cort cfv cG cort cfv cH cin cG cort cfv cH cort cfv cin chj
      co wceq cG cpj cfv cH cpj cfv cG cort cfv cpj cfv ccom ccom ch0o wceq cG
      cH ccm wbr cG cort cfv cH ccm wbr cG cort cfv cG cort cfv cH cin cG cort
      cfv cH cort cfv cin chj co wceq cG cH pjclem1.1 pjclem1.2 cmcm3i cG cort
      cfv cH cG pjclem1.1 choccli pjclem1.2 cmbri bitri cG cort cfv cG cort cfv
      cH cin cG cort cfv cH cort cfv cin chj co wceq cG cort cfv cpj cfv cG
      cort cfv cH cin cG cort cfv cH cort cfv cin chj co cpj cfv wceq cG cpj
      cfv cH cpj cfv cG cort cfv cpj cfv ccom ccom ch0o wceq cG cort cfv cG
      cort cfv cH cin cG cort cfv cH cort cfv cin chj co cpj fveq2 cG cort cfv
      cpj cfv cG cort cfv cH cin cG cort cfv cH cort cfv cin chj co cpj cfv
      wceq cG cort cfv cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort
      cfv cin cpj cfv chos co wceq cG cpj cfv cH cpj cfv cG cort cfv cpj cfv
      ccom ccom ch0o wceq cG cort cfv cH cin cG cort cfv cH cort cfv cin chj co
      cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin cpj cfv
      chos co cG cort cfv cpj cfv cG cort cfv cH cin cG cort cfv cH cort cfv
      cin cort cfv wss cG cort cfv cH cin cG cort cfv cH cort cfv cin chj co
      cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin cpj cfv
      chos co wceq cG cort cfv cH cin cH cG cort cfv cH cort cfv cin cort cfv
      cG cort cfv cH inss2 cH cG cH chj co cG cort cfv cH cort cfv cin cort cfv
      cH cG pjclem1.2 pjclem1.1 chub2i cG cH pjclem1.1 pjclem1.2 chdmm4i
      sseqtr4i sstri cG cort cfv cH cin cG cort cfv cH cort cfv cin cG cort cfv
      cH cG pjclem1.1 choccli pjclem1.2 chincli cG cort cfv cH cort cfv cG
      pjclem1.1 choccli cH pjclem1.2 choccli chincli pjscji ax-mp eqeq2i cG
      cort cfv cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin
      cpj cfv chos co wceq cH cpj cfv cG cort cfv cpj cfv ccom cH cpj cfv cG
      cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin cpj cfv chos co ccom
      wceq cG cpj cfv cH cpj cfv cG cort cfv cpj cfv ccom ccom ch0o wceq cG
      cort cfv cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin
      cpj cfv chos co cH cpj cfv coeq2 cH cpj cfv cG cort cfv cpj cfv ccom cH
      cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin cpj cfv
      chos co ccom wceq cH cpj cfv cG cort cfv cpj cfv ccom cG cort cfv cH cin
      cpj cfv wceq cG cpj cfv cH cpj cfv cG cort cfv cpj cfv ccom ccom ch0o
      wceq cH cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort cfv cin
      cpj cfv chos co ccom cG cort cfv cH cin cpj cfv cH cpj cfv cG cort cfv
      cpj cfv ccom cH cpj cfv cG cort cfv cH cin cpj cfv cG cort cfv cH cort
      cfv cin cpj cfv chos co ccom cH cpj cfv cG cort cfv cH cin cpj cfv ccom
      cH cpj cfv cG cort cfv cH cort cfv cin cpj cfv ccom chos co cG cort cfv
      cH cin cpj cfv ch0o chos co cG cort cfv cH cin cpj cfv cG cort cfv cH cin
      cpj cfv cG cort cfv cH cort cfv cin cpj cfv cH pjclem1.2 cG cort cfv cH
      cin cG cort cfv cH cG pjclem1.1 choccli pjclem1.2 chincli pjfi cG cort
      cfv cH cort cfv cin cG cort cfv cH cort cfv cG pjclem1.1 choccli cH
      pjclem1.2 choccli chincli pjfi pjsdii cH cpj cfv cG cort cfv cH cin cpj
      cfv ccom cG cort cfv cH cin cpj cfv cH cpj cfv cG cort cfv cH cort cfv
      cin cpj cfv ccom ch0o chos cG cort cfv cH cin cH wss cH cpj cfv cG cort
      cfv cH cin cpj cfv ccom cG cort cfv cH cin cpj cfv wceq cG cort cfv cH
      inss2 cG cort cfv cH cin cH cG cort cfv cH cG pjclem1.1 choccli pjclem1.2
      chincli pjclem1.2 pjss1coi mpbi cH cG cort cfv cH cort cfv cin cort cfv
      wss cH cpj cfv cG cort cfv cH cort cfv cin cpj cfv ccom ch0o wceq cH cG
      cH chj co cG cort cfv cH cort cfv cin cort cfv cH cG pjclem1.2 pjclem1.1
      chub2i cG cH pjclem1.1 pjclem1.2 chdmm4i sseqtr4i cH cG cort cfv cH cort
      cfv cin pjclem1.2 cG cort cfv cH cort cfv cG pjclem1.1 choccli cH
      pjclem1.2 choccli chincli pjorthcoi ax-mp opreq12i cG cort cfv cH cin cpj
      cfv cG cort cfv cH cin cG cort cfv cH cG pjclem1.1 choccli pjclem1.2
      chincli pjfi hoaddid1i 3eqtri eqeq2i cH cpj cfv cG cort cfv cpj cfv ccom
      cG cort cfv cH cin cpj cfv wceq cG cpj cfv cH cpj cfv cG cort cfv cpj cfv
      ccom ccom cG cpj cfv cG cort cfv cH cin cpj cfv ccom ch0o cH cpj cfv cG
      cort cfv cpj cfv ccom cG cort cfv cH cin cpj cfv cG cpj cfv coeq2 cG cG
      cort cfv cH cin cort cfv wss cG cpj cfv cG cort cfv cH cin cpj cfv ccom
      ch0o wceq cG cG cH cort cfv chj co cG cort cfv cH cin cort cfv cG cH cort
      cfv pjclem1.1 cH pjclem1.2 choccli chub1i cG cH pjclem1.1 pjclem1.2
      chdmm2i sseqtr4i cG cG cort cfv cH cin pjclem1.1 cG cort cfv cH cG
      pjclem1.1 choccli pjclem1.2 chincli pjorthcoi ax-mp syl6eq sylbi syl
      sylbi syl sylbi opreq12d cG cpj cfv cH cpj cfv ccom cG cpj cfv cH cpj cfv
      cG cpj cfv ccom cH cpj cfv cG cort cfv cpj cfv ccom chos co ccom cG cpj
      cfv cH cpj cfv cG cpj cfv ccom ccom cG cpj cfv cH cpj cfv cG cort cfv cpj
      cfv ccom ccom chos co cH cpj cfv cH cpj cfv cG cpj cfv ccom cH cpj cfv cG
      cort cfv cpj cfv ccom chos co cG cpj cfv cH cpj cfv cG cpj cfv cG cort
      cfv cpj cfv chos co ccom cH cpj cfv chil cpj cfv ccom cH cpj cfv cG cpj
      cfv ccom cH cpj cfv cG cort cfv cpj cfv ccom chos co cH cpj cfv cG cpj
      cfv cG cort cfv cpj cfv chos co chil cpj cfv cH cpj cfv cG pjclem1.1
      pjtoi coeq2i cG cpj cfv cG cort cfv cpj cfv cH pjclem1.2 cG pjclem1.1
      pjfi cG cort cfv cG pjclem1.1 choccli pjfi pjsdii cH cpj cfv chio ccom cH
      cpj cfv chil cpj cfv ccom cH cpj cfv chio chil cpj cfv cH cpj cfv df-iop
      coeq2i cH cpj cfv cH pjclem1.2 pjfi hoid1i eqtr3i 3eqtr3ri coeq2i cH cpj
      cfv cG cpj cfv ccom cH cpj cfv cG cort cfv cpj cfv ccom cG pjclem1.1 cH
      cpj cfv cG cpj cfv cH pjclem1.2 pjfi cG pjclem1.1 pjfi hocofi cH cpj cfv
      cG cort cfv cpj cfv cH pjclem1.2 pjfi cG cort cfv cG pjclem1.1 choccli
      pjfi hocofi pjsdii eqtr2i cG cH cin cpj cfv cG cH cin cG cH pjclem1.1
      pjclem1.2 chincli pjfi hoaddid1i 3eqtr3g $.
      $( [24-Oct-2004] $) $( [16-Nov-2000] $)

    $( Lemma for projection commutation theorem. $)
    pjclem2 $p |- ( G C_H H ->
       ( ( proj ` G ) o. ( proj ` H ) ) = ( ( proj ` H ) o. ( proj ` G ) ) ) $=
      cG cH ccm wbr cG cH cin cpj cfv cH cG cin cpj cfv cG cpj cfv cH cpj cfv
      ccom cH cpj cfv cG cpj cfv ccom cG cH cin cH cG cin cpj cG cH incom
      fveq2i cG cH pjclem1.1 pjclem1.2 pjclem1 cG cH ccm wbr cH cG ccm wbr cH
      cpj cfv cG cpj cfv ccom cH cG cin cpj cfv wceq cG cH pjclem1.1 pjclem1.2
      cmcmi cH cG pjclem1.2 pjclem1.1 pjclem1 sylbi 3eqtr4a $.
      $( [24-Oct-2004] $) $( [17-Nov-2000] $)

    $( Lemma for projection commutation theorem. $)
    pjclem3 $p |- ( ( ( proj ` G ) o. ( proj ` H ) ) =
                    ( ( proj ` H ) o. ( proj ` G ) ) ->
                     ( ( proj ` G ) o. ( proj ` ( _|_ ` H ) ) ) =
                     ( ( proj ` ( _|_ ` H ) ) o. ( proj ` G ) ) ) $=
      cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq cG cpj cfv
      chil cpj cfv cH cpj cfv chod co ccom chil cpj cfv cH cpj cfv chod co cG
      cpj cfv ccom cG cpj cfv cH cort cfv cpj cfv ccom cH cort cfv cpj cfv cG
      cpj cfv ccom cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq
      cG cpj cfv chil cpj cfv ccom cG cpj cfv cH cpj cfv ccom chod co chil cpj
      cfv cG cpj cfv ccom cH cpj cfv cG cpj cfv ccom chod co cG cpj cfv chil
      cpj cfv cH cpj cfv chod co ccom chil cpj cfv cH cpj cfv chod co cG cpj
      cfv ccom cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq chil
      cpj cfv cG cpj cfv ccom cG cpj cfv cH cpj cfv ccom chod co chil cpj cfv
      cG cpj cfv ccom cH cpj cfv cG cpj cfv ccom chod co cG cpj cfv chil cpj
      cfv ccom cG cpj cfv cH cpj cfv ccom chod co cG cpj cfv cH cpj cfv ccom cH
      cpj cfv cG cpj cfv ccom chil cpj cfv cG cpj cfv ccom chod opreq2 cG cpj
      cfv chil cpj cfv ccom chil cpj cfv cG cpj cfv ccom cG cpj cfv cH cpj cfv
      ccom chod cG cpj cfv chil cpj cfv ccom cG cpj cfv chio cG cpj cfv ccom
      chil cpj cfv cG cpj cfv ccom cG cpj cfv chio ccom cG cpj cfv chil cpj cfv
      ccom cG cpj cfv chio chil cpj cfv cG cpj cfv df-iop coeq2i cG cpj cfv cG
      pjclem1.1 pjfi hoid1i eqtr3i cG cpj cfv cG pjclem1.1 pjfi hoid1ri chio
      chil cpj cfv cG cpj cfv df-iop coeq1i 3eqtr2i opreq1i syl5eq chil cpj cfv
      cH cpj cfv cG pjclem1.1 chil helch pjfi cH pjclem1.2 pjfi pjddii chil cpj
      cfv cH cpj cfv cG cpj cfv chil helch pjfi cH pjclem1.2 pjfi cG pjclem1.1
      pjfi hocsubdiri 3eqtr4g chil cpj cfv cH cpj cfv chod co cH cort cfv cpj
      cfv cG cpj cfv cH pjclem1.2 pjoci coeq2i chil cpj cfv cH cpj cfv chod co
      cH cort cfv cpj cfv cG cpj cfv cH pjclem1.2 pjoci coeq1i 3eqtr3g $.
      $( [26-Nov-2000] $)

    $( Lemma for projection commutation theorem. $)
    pjclem4a $p |- ( A e. ( G i^i H ) ->
               ( ( ( proj ` G ) o. ( proj ` H ) ) ` A ) = A ) $=
      cA cG cH cin wcel cA cG wcel cA cH wcel wa cA cG cpj cfv cH cpj cfv ccom
      cfv cA wceq cA cG cH elin cA cG wcel cA cH wcel wa cA cG cpj cfv cH cpj
      cfv ccom cfv cA cH cpj cfv cfv cG cpj cfv cfv cA cA cG wcel cA cH wcel wa
      cA chil wcel cA cG cpj cfv cH cpj cfv ccom cfv cA cH cpj cfv cfv cG cpj
      cfv cfv wceq cA cH wcel cA chil wcel cA cG wcel cA cH pjclem1.2 cheli
      adantl cA cG cH pjclem1.1 pjclem1.2 pjcoi syl cA cH wcel cA cG wcel cA cH
      cpj cfv cfv cG cpj cfv cfv cA wceq cA cH wcel cA cH cpj cfv cfv cA wceq
      cA cG wcel cA cH cpj cfv cfv cG cpj cfv cfv cA wceq wi cH cch wcel cA cH
      wcel cA cH cpj cfv cfv cA wceq pjclem1.2 cA cH pjid mpan cA cH cpj cfv
      cfv cA wceq cA cG wcel cA cH cpj cfv cfv cG cpj cfv cfv cA cH cpj cfv cfv
      wceq cA cH cpj cfv cfv cG cpj cfv cfv cA wceq cA cH cpj cfv cfv cA wceq
      cA cG wcel cA cH cpj cfv cfv cG wcel cA cH cpj cfv cfv cG cpj cfv cfv cA
      cH cpj cfv cfv wceq cA cH cpj cfv cfv cA cG eleq1 cG cch wcel cA cH cpj
      cfv cfv cG wcel cA cH cpj cfv cfv cG cpj cfv cfv cA cH cpj cfv cfv wceq
      pjclem1.1 cA cH cpj cfv cfv cG pjid mpan syl6bir cA cH cpj cfv cfv cA cA
      cH cpj cfv cfv cG cpj cfv cfv eqeq2 sylibd syl impcom eqtrd sylbi $.
      $( [2-Dec-2000] $)

    $( Lemma for projection commutation theorem. $)
    pjclem4 $p |- ( ( ( proj ` G ) o. ( proj ` H ) ) =
                    ( ( proj ` H ) o. ( proj ` G ) ) ->
                     ( ( proj ` G ) o. ( proj ` H ) ) =
                     ( proj ` ( G i^i H ) ) ) $=
      cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv cG cpj
      cfv cH cpj cfv ccom cfv vx cv cG cH cin cpj cfv cfv wceq vx chil wral cG
      cpj cfv cH cpj cfv ccom cG cH cin cpj cfv wceq cG cpj cfv cH cpj cfv ccom
      cH cpj cfv cG cpj cfv ccom wceq vx cv cG cpj cfv cH cpj cfv ccom cfv vx
      cv cG cH cin cpj cfv cfv wceq vx chil cG cpj cfv cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom wceq vx cv chil wcel wa vx cv cG cpj cfv cH cpj cfv
      ccom cfv vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co cva co cG cH
      cin cpj cfv cfv vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv cG cH cin cpj
      cfv cfv vx cv cG cpj cfv cH cpj cfv ccom cfv cG cH cin wcel vx cv vx cv
      cG cpj cfv cH cpj cfv ccom cfv cmv co cG cH cin cort cfv wcel vx cv cG
      cpj cfv cH cpj cfv ccom cfv vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv
      cmv co cva co cG cH cin cpj cfv cfv vx cv cG cpj cfv cH cpj cfv ccom cfv
      wceq cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv
      chil wcel wa vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv vx cv cG cpj cfv
      cH cpj cfv ccom cfv cmv co cG cH cin cG cH pjclem1.1 pjclem1.2 chincli
      pjvi cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv
      chil wcel wa vx cv cG cpj cfv cH cpj cfv ccom cfv cG wcel vx cv cG cpj
      cfv cH cpj cfv ccom cfv cH wcel wa vx cv cG cpj cfv cH cpj cfv ccom cfv
      cG cH cin wcel cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq
      vx cv chil wcel wa vx cv cG cpj cfv cH cpj cfv ccom cfv cG wcel vx cv cG
      cpj cfv cH cpj cfv ccom cfv cH wcel vx cv chil wcel vx cv cG cpj cfv cH
      cpj cfv ccom cfv cG wcel cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom wceq vx cv cG cH pjclem1.1 pjclem1.2 pjcocli adantl cG cpj cfv cH
      cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv chil wcel vx cv cG cpj
      cfv cH cpj cfv ccom cfv cH wcel cG cpj cfv cH cpj cfv ccom cH cpj cfv cG
      cpj cfv ccom wceq vx cv cG cpj cfv cH cpj cfv ccom cfv cH wcel vx cv cH
      cpj cfv cG cpj cfv ccom cfv cH wcel vx cv chil wcel cG cpj cfv cH cpj cfv
      ccom cH cpj cfv cG cpj cfv ccom wceq vx cv cG cpj cfv cH cpj cfv ccom cfv
      vx cv cH cpj cfv cG cpj cfv ccom cfv cH vx cv cG cpj cfv cH cpj cfv ccom
      cH cpj cfv cG cpj cfv ccom fveq1 eleq1d vx cv cH cG pjclem1.2 pjclem1.1
      pjcocli syl5bir imp jca vx cv cG cpj cfv cH cpj cfv ccom cfv cG cH elin
      sylibr cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv
      chil wcel wa vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co chil wcel
      vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co vy cv csp co cc0 wceq
      vy cG cH cin wral wa vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co cG
      cH cin cort cfv wcel cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom wceq vx cv chil wcel wa vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv
      cmv co chil wcel vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co vy cv
      csp co cc0 wceq vy cG cH cin wral vx cv chil wcel vx cv vx cv cG cpj cfv
      cH cpj cfv ccom cfv cmv co chil wcel cG cpj cfv cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom wceq vx cv chil wcel vx cv cG cpj cfv cH cpj cfv ccom
      cfv chil wcel vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co chil wcel
      vx cv cG cH pjclem1.1 pjclem1.2 pjcohcli vx cv vx cv cG cpj cfv cH cpj
      cfv ccom cfv hvsubcl mpdan adantl cG cpj cfv cH cpj cfv ccom cH cpj cfv
      cG cpj cfv ccom wceq vx cv chil wcel wa vx cv vx cv cG cpj cfv cH cpj cfv
      ccom cfv cmv co vy cv csp co cc0 wceq vy cG cH cin cG cpj cfv cH cpj cfv
      ccom cH cpj cfv cG cpj cfv ccom wceq vx cv chil wcel vy cv cG cH cin wcel
      vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co vy cv csp co cc0 wceq
      wi cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv chil
      wcel vy cv cG cH cin wcel vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv
      co vy cv csp co cc0 wceq cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom wceq vx cv chil wcel vy cv cG cH cin wcel wa wa vx cv vx cv cG cpj
      cfv cH cpj cfv ccom cfv cmv co vy cv csp co vx cv vy cv csp co vx cv cG
      cpj cfv cH cpj cfv ccom cfv vy cv csp co cmin co vx cv cG cpj cfv cH cpj
      cfv ccom cfv vy cv csp co vx cv cG cpj cfv cH cpj cfv ccom cfv vy cv csp
      co cmin co cc0 cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq
      vx cv chil wcel vy cv cG cH cin wcel wa wa vx cv chil wcel vx cv cG cpj
      cfv cH cpj cfv ccom cfv chil wcel vy cv chil wcel w3a vx cv vx cv cG cpj
      cfv cH cpj cfv ccom cfv cmv co vy cv csp co vx cv vy cv csp co vx cv cG
      cpj cfv cH cpj cfv ccom cfv vy cv csp co cmin co wceq vx cv chil wcel vy
      cv cG cH cin wcel wa vx cv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv
      chil wcel vy cv chil wcel w3a cG cpj cfv cH cpj cfv ccom cH cpj cfv cG
      cpj cfv ccom wceq vx cv chil wcel vy cv cG cH cin wcel wa vx cv chil wcel
      vx cv cG cpj cfv cH cpj cfv ccom cfv chil wcel vy cv chil wcel vx cv chil
      wcel vy cv cG cH cin wcel pm3.26 vx cv chil wcel vx cv cG cpj cfv cH cpj
      cfv ccom cfv chil wcel vy cv cG cH cin wcel vx cv cG cH pjclem1.1
      pjclem1.2 pjcohcli adantr vy cv cG cH cin wcel vy cv chil wcel vx cv chil
      wcel vy cv cG cH cin cG cH pjclem1.1 pjclem1.2 chincli cheli adantl 3jca
      adantl vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv vy cv his2sub syl cG
      cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv chil wcel
      vy cv cG cH cin wcel wa wa vx cv cG cpj cfv cH cpj cfv ccom cfv vy cv csp
      co vx cv vy cv csp co vx cv cG cpj cfv cH cpj cfv ccom cfv vy cv csp co
      cmin cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv
      chil wcel vy cv cG cH cin wcel wa vx cv cG cpj cfv cH cpj cfv ccom cfv vy
      cv csp co vx cv cH cpj cfv cG cpj cfv ccom cfv vy cv csp co vx cv vy cv
      csp co cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv
      cG cpj cfv cH cpj cfv ccom cfv vx cv cH cpj cfv cG cpj cfv ccom cfv vy cv
      csp vx cv cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom fveq1
      opreq1d vx cv chil wcel vy cv cG cH cin wcel wa vx cv cH cpj cfv cG cpj
      cfv ccom cfv vy cv csp co vx cv vy cv cG cpj cfv cH cpj cfv ccom cfv csp
      co vx cv vy cv csp co vx cv chil wcel vy cv chil wcel vx cv cH cpj cfv cG
      cpj cfv ccom cfv vy cv csp co vx cv vy cv cG cpj cfv cH cpj cfv ccom cfv
      csp co wceq vy cv cG cH cin wcel vx cv vy cv cH cG pjclem1.2 pjclem1.1
      pjadjcoi vy cv cG cH cin cG cH pjclem1.1 pjclem1.2 chincli cheli sylan2
      vy cv cG cH cin wcel vx cv vy cv cG cpj cfv cH cpj cfv ccom cfv csp co vx
      cv vy cv csp co wceq vx cv chil wcel vy cv cG cH cin wcel vy cv cG cpj
      cfv cH cpj cfv ccom cfv vy cv vx cv csp vy cv cG cH pjclem1.1 pjclem1.2
      pjclem4a opreq2d adantl eqtrd sylan9eq opreq1d cG cpj cfv cH cpj cfv ccom
      cH cpj cfv cG cpj cfv ccom wceq vx cv chil wcel vy cv cG cH cin wcel wa
      wa vx cv cG cpj cfv cH cpj cfv ccom cfv chil wcel vy cv chil wcel wa vx
      cv cG cpj cfv cH cpj cfv ccom cfv vy cv csp co cc wcel vx cv cG cpj cfv
      cH cpj cfv ccom cfv vy cv csp co vx cv cG cpj cfv cH cpj cfv ccom cfv vy
      cv csp co cmin co cc0 wceq vx cv chil wcel vy cv cG cH cin wcel wa vx cv
      cG cpj cfv cH cpj cfv ccom cfv chil wcel vy cv chil wcel wa cG cpj cfv cH
      cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq vx cv chil wcel vx cv cG cpj
      cfv cH cpj cfv ccom cfv chil wcel vy cv cG cH cin wcel vy cv chil wcel vx
      cv cG cH pjclem1.1 pjclem1.2 pjcohcli vy cv cG cH cin cG cH pjclem1.1
      pjclem1.2 chincli cheli anim12i adantl vx cv cG cpj cfv cH cpj cfv ccom
      cfv vy cv hicl vx cv cG cpj cfv cH cpj cfv ccom cfv vy cv csp co subid
      3syl 3eqtr2d exp32 imp r19.21aiv jca cG cH cin csh wcel vx cv vx cv cG
      cpj cfv cH cpj cfv ccom cfv cmv co cG cH cin cort cfv wcel vx cv vx cv cG
      cpj cfv cH cpj cfv ccom cfv cmv co chil wcel vx cv vx cv cG cpj cfv cH
      cpj cfv ccom cfv cmv co vy cv csp co cc0 wceq vy cG cH cin wral wa wb cG
      cH cin cG cH pjclem1.1 pjclem1.2 chincli chshii vy vx cv vx cv cG cpj cfv
      cH cpj cfv ccom cfv cmv co cG cH cin shocel ax-mp sylibr sylanc vx cv
      chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv vx cv cG cpj cfv cH
      cpj cfv ccom cfv cmv co cva co cG cH cin cpj cfv cfv vx cv cG cH cin cpj
      cfv cfv wceq cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq
      vx cv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv vx cv cG cpj
      cfv cH cpj cfv ccom cfv cmv co cva co vx cv cG cH cin cpj cfv vx cv chil
      wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv vx cv cG cpj cfv cH cpj
      cfv ccom cfv cmv co cva co vx cv vx cv cG cpj cfv cH cpj cfv ccom cfv vx
      cv cG cpj cfv cH cpj cfv ccom cfv cmv co cva co vx cv c0v cva co vx cv vx
      cv cG cpj cfv cH cpj cfv ccom cfv chil wcel vx cv chil wcel vx cv cG cpj
      cfv cH cpj cfv ccom cfv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx
      cv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co cva co vx cv vx cv cG cpj
      cfv cH cpj cfv ccom cfv vx cv cG cpj cfv cH cpj cfv ccom cfv cmv co cva
      co wceq vx cv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv vx cv
      cG cpj cfv cH cpj cfv ccom cfv hvaddsub12 vx cv cG cH pjclem1.1 pjclem1.2
      pjcohcli vx cv chil wcel id vx cv cG cH pjclem1.1 pjclem1.2 pjcohcli
      syl3anc vx cv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx cv cG cpj
      cfv cH cpj cfv ccom cfv cmv co c0v vx cv cva vx cv chil wcel vx cv cG cpj
      cfv cH cpj cfv ccom cfv chil wcel vx cv cG cpj cfv cH cpj cfv ccom cfv vx
      cv cG cpj cfv cH cpj cfv ccom cfv cmv co c0v wceq vx cv cG cH pjclem1.1
      pjclem1.2 pjcohcli vx cv cG cpj cfv cH cpj cfv ccom cfv hvsubid syl
      opreq2d vx cv ax-hvaddid 3eqtrd fveq2d adantl eqtr3d r19.21aiva vx cG cpj
      cfv cH cpj cfv ccom cG cH cin cpj cfv cG cpj cfv cH cpj cfv cG pjclem1.1
      pjfi cH pjclem1.2 pjfi hocofi cG cH cin cG cH pjclem1.1 pjclem1.2 chincli
      pjfi hoeqi sylib $.
      $( [26-Nov-2000] $)

    $( Two subspaces commute iff their projections commute.  Lemma 4 of
       [Kalmbach] p. 67. $)
    pjci $p |- ( G C_H H <->
       ( ( proj ` G ) o. ( proj ` H ) ) = ( ( proj ` H ) o. ( proj ` G ) ) ) $=
      cG cH ccm wbr cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq
      cG cH pjclem1.1 pjclem1.2 pjclem2 cG cpj cfv cH cpj cfv ccom cH cpj cfv
      cG cpj cfv ccom wceq cG cG cH cin cG cH cort cfv cin chj co wceq cG cH
      ccm wbr cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq cG cpj
      cfv cG cH cin cG cH cort cfv cin chj co cpj cfv wceq cG cG cH cin cG cH
      cort cfv cin chj co wceq cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom wceq cG cpj cfv cH cpj cfv ccom cG cpj cfv cH cort cfv cpj cfv ccom
      chos co cG cH cin cpj cfv cG cH cort cfv cin cpj cfv chos co cG cpj cfv
      cG cH cin cG cH cort cfv cin chj co cpj cfv cG cpj cfv cH cpj cfv ccom cH
      cpj cfv cG cpj cfv ccom wceq cG cpj cfv cH cpj cfv ccom cG cH cin cpj cfv
      cG cpj cfv cH cort cfv cpj cfv ccom cG cH cort cfv cin cpj cfv chos cG cH
      pjclem1.1 pjclem1.2 pjclem4 cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj
      cfv ccom wceq cG cpj cfv cH cort cfv cpj cfv ccom cH cort cfv cpj cfv cG
      cpj cfv ccom wceq cG cpj cfv cH cort cfv cpj cfv ccom cG cH cort cfv cin
      cpj cfv wceq cG cH pjclem1.1 pjclem1.2 pjclem3 cG cH cort cfv pjclem1.1
      cH pjclem1.2 choccli pjclem4 syl opreq12d cG cpj cfv cH cpj cfv cH cort
      cfv cpj cfv chos co ccom cG cpj cfv chil cpj cfv ccom cG cpj cfv cH cpj
      cfv ccom cG cpj cfv cH cort cfv cpj cfv ccom chos co cG cpj cfv cH cpj
      cfv cH cort cfv cpj cfv chos co chil cpj cfv cG cpj cfv cH pjclem1.2
      pjtoi coeq2i cH cpj cfv cH cort cfv cpj cfv cG pjclem1.1 cH pjclem1.2
      pjfi cH cort cfv cH pjclem1.2 choccli pjfi pjsdii cG cpj cfv chio ccom cG
      cpj cfv chil cpj cfv ccom cG cpj cfv chio chil cpj cfv cG cpj cfv df-iop
      coeq2i cG cpj cfv cG pjclem1.1 pjfi hoid1i eqtr3i 3eqtr3ri cG cH cin cG
      cH cort cfv cin cort cfv wss cG cH cin cG cH cort cfv cin chj co cpj cfv
      cG cH cin cpj cfv cG cH cort cfv cin cpj cfv chos co wceq cG cH cin cG
      cort cfv cH chj co cG cH cort cfv cin cort cfv cG cH cin cH cG cort cfv
      cH chj co cG cH inss2 cH cG cort cfv pjclem1.2 cG pjclem1.1 choccli
      chub2i sstri cG cH pjclem1.1 pjclem1.2 chdmm3i sseqtr4i cG cH cin cG cH
      cort cfv cin cG cH pjclem1.1 pjclem1.2 chincli cG cH cort cfv pjclem1.1
      cH pjclem1.2 choccli chincli pjscji ax-mp 3eqtr4g cG cG cH cin cG cH cort
      cfv cin chj co pjclem1.1 cG cH cin cG cH cort cfv cin cG cH pjclem1.1
      pjclem1.2 chincli cG cH cort cfv pjclem1.1 cH pjclem1.2 choccli chincli
      chjcli pj11i sylib cG cH pjclem1.1 pjclem1.2 cmbri sylibr impbii $.
      $( [24-Oct-2004] $) $( [26-Nov-2000] $)

    $( A necessary and sufficient condition for the product of two projectors
       to be a projector is that the projectors commute.  Part 1 of Theorem 1
       of [AkhiezerGlazman] p. 65. $)
    pjcmmul1i $p |- ( ( ( proj ` G ) o. ( proj ` H ) ) =
                   ( ( proj ` H ) o. ( proj ` G ) ) <->
                   ( ( proj ` G ) o. ( proj ` H ) ) e. ran proj ) $=
      cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq cG cpj cfv cH
      cpj cfv ccom cpj crn wcel cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj
      cfv ccom wceq cG cpj cfv cH cpj cfv ccom cG cH cin cpj cfv cpj crn cG cH
      pjclem1.1 pjclem1.2 pjclem4 cpj cch wfn cG cH cin cch wcel cG cH cin cpj
      cfv cpj crn wcel pjmfn cG cH pjclem1.1 pjclem1.2 chincli cch cG cH cin
      cpj fnfvelrn mp2an syl6eqel cG cpj cfv cH cpj cfv ccom cpj crn wcel cG
      cpj cfv cH cpj cfv ccom cado cfv cG cpj cfv cH cpj cfv ccom cH cpj cfv cG
      cpj cfv ccom cG cpj cfv cH cpj cfv ccom pjadj2 cG cpj cfv cH cpj cfv ccom
      cado cfv cH cpj cfv cado cfv cG cpj cfv cado cfv ccom cH cpj cfv cG cpj
      cfv cado cfv ccom cH cpj cfv cG cpj cfv ccom cG cpj cfv cH cpj cfv cG
      pjclem1.1 pjbdlni cH pjclem1.2 pjbdlni adjcoi cH cpj cfv cado cfv cH cpj
      cfv cG cpj cfv cado cfv cH cch wcel cH cpj cfv cado cfv cH cpj cfv wceq
      pjclem1.2 cH pjadj3 ax-mp coeq1i cG cpj cfv cado cfv cG cpj cfv cH cpj
      cfv cG cch wcel cG cpj cfv cado cfv cG cpj cfv wceq pjclem1.1 cG pjadj3
      ax-mp coeq2i 3eqtri syl5reqr impbii $.
      $( [11-Jul-2006] $) $( [3-Jun-2006] $)

    $( The projection subspace of the difference between two projectors.
       Part 2 of Theorem 1 of [AkhiezerGlazman] p. 65. $)
    pjcmmul2i $p |- ( ( ( proj ` G ) o. ( proj ` H ) ) =
                   ( ( proj ` H ) o. ( proj ` G ) ) <->
                 ( ( proj ` G ) o. ( proj ` H ) ) = ( proj ` ( G i^i H ) ) ) $=
      cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq cG cpj cfv cH
      cpj cfv ccom cG cH cin cpj cfv wceq cG cH pjclem1.1 pjclem1.2 pjclem4 cG
      cpj cfv cH cpj cfv ccom cG cH cin cpj cfv wceq cG cpj cfv cH cpj cfv ccom
      cpj crn wcel cG cpj cfv cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom wceq
      cG cpj cfv cH cpj cfv ccom cG cH cin cpj cfv wceq cG cpj cfv cH cpj cfv
      ccom cpj crn wcel cG cH cin cpj cfv cpj crn wcel cpj cch wfn cG cH cin
      cch wcel cG cH cin cpj cfv cpj crn wcel pjmfn cG cH pjclem1.1 pjclem1.2
      chincli cch cG cH cin cpj fnfvelrn mp2an cG cpj cfv cH cpj cfv ccom cG cH
      cin cpj cfv cpj crn eleq1 mpbiri cG cH pjclem1.1 pjclem1.2 pjcmmul1i
      sylibr impbii $.
      $( [3-Nov-2006] $) $( [3-Jun-2006] $)
  $}

  ${
    pjcohocl.1 $e |- H e. CH $.
    pjcohocl.2 $e |- T : ~H --> ~H $.
    $( Closure of composition of projection and Hilbert space operator. $)
    pjcohocli $p |- ( A e. ~H ->
         ( ( ( proj ` H ) o. T ) ` A ) e. H ) $=
      cA chil wcel cA cH cpj cfv cT ccom cfv cA cT cfv cH cpj cfv cfv cH cA cH
      cpj cfv cT cH pjcohocl.1 pjfi pjcohocl.2 hocoi cA chil wcel cA cT cfv
      chil wcel cA cT cfv cH cpj cfv cfv cH wcel chil chil cA cT pjcohocl.2
      ffvelrni cA cT cfv cH pjcohocl.1 pjcli syl eqeltrd $.
      $( [3-Dec-2000] $)
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.
    pjadj2co.1 $e |- F e. CH $.
    pjadj2co.2 $e |- G e. CH $.
    pjadj2co.3 $e |- H e. CH $.
    $( Adjoint of double composition of projections.  Generalization of
       special case of Theorem 3.11(viii) of [Beran] p. 106. $)
    pjadj2coi $p |- ( ( A e. ~H /\ B e. ~H ) ->
      ( ( ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) ` A ) .ih B ) =
    ( A .ih ( ( ( ( proj ` H ) o. ( proj ` G ) ) o. ( proj ` F ) ) ` B ) ) ) $=
      cA chil wcel cB chil wcel wa cA cH cpj cfv cfv cF cpj cfv cG cpj cfv ccom
      cfv cB csp co cA cB cG cpj cfv cF cpj cfv ccom cfv cH cpj cfv cfv csp co
      cA cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cB csp co cA cB cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom cfv csp co cA chil wcel cB chil wcel
      wa cA cH cpj cfv cfv cF cpj cfv cG cpj cfv ccom cfv cB csp co cA cH cpj
      cfv cfv cB cG cpj cfv cF cpj cfv ccom cfv csp co cA cB cG cpj cfv cF cpj
      cfv ccom cfv cH cpj cfv cfv csp co cA cH cpj cfv cfv chil wcel cB chil
      wcel cA cH cpj cfv cfv cF cpj cfv cG cpj cfv ccom cfv cB csp co cA cH cpj
      cfv cfv cB cG cpj cfv cF cpj cfv ccom cfv csp co wceq cA chil wcel cA cH
      cpj cfv cfv cB cF cG pjadj2co.1 pjadj2co.2 pjadjcoi cA cH pjadj2co.3
      pjhcli sylan cA chil wcel cB cG cpj cfv cF cpj cfv ccom cfv chil wcel cA
      cH cpj cfv cfv cB cG cpj cfv cF cpj cfv ccom cfv csp co cA cB cG cpj cfv
      cF cpj cfv ccom cfv cH cpj cfv cfv csp co wceq cB chil wcel cA cB cG cpj
      cfv cF cpj cfv ccom cfv cH pjadj2co.3 pjadji cB cG cF pjadj2co.2
      pjadj2co.1 pjcohcli sylan2 eqtrd cA chil wcel cA cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv cB csp co cA cH cpj cfv cfv cF cpj cfv cG cpj
      cfv ccom cfv cB csp co wceq cB chil wcel cA chil wcel cA cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv cA cH cpj cfv cfv cF cpj cfv cG cpj cfv
      ccom cfv cB csp cA cF cpj cfv cG cpj cfv ccom cH cpj cfv cF cpj cfv cG
      cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH pjadj2co.3 pjfi
      hocoi opreq1d adantr cB chil wcel cA cB cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom cfv csp co cA cB cG cpj cfv cF cpj cfv ccom cfv cH cpj cfv cfv
      csp co wceq cA chil wcel cB chil wcel cB cH cpj cfv cG cpj cfv ccom cF
      cpj cfv ccom cfv cB cG cpj cfv cF cpj cfv ccom cfv cH cpj cfv cfv cA csp
      cB chil wcel cB cH cpj cfv cG cpj cfv cF cpj cfv ccom ccom cfv cB cG cpj
      cfv cF cpj cfv ccom cfv cH cpj cfv cfv cB cH cpj cfv cG cpj cfv ccom cF
      cpj cfv ccom cfv cB cH cpj cfv cG cpj cfv cF cpj cfv ccom cH pjadj2co.3
      pjfi cG cpj cfv cF cpj cfv cG pjadj2co.2 pjfi cF pjadj2co.1 pjfi hocofi
      hocoi cB cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom cH cpj cfv cG cpj cfv
      cF cpj cfv ccom ccom cH cpj cfv cG cpj cfv cF cpj cfv coass fveq1i syl5eq
      opreq2d adantl 3eqtr4d $.
      $( [1-Dec-2000] $)

    $( Closure of double composition of projections. $)
    pj2cocli $p |- ( A e. ~H ->
         ( ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) ` A ) e. F ) $=
      cA chil wcel cA cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cA cH cpj
      cfv cfv cG cpj cfv cfv cF cpj cfv cfv cF cA cF cpj cfv cG cpj cfv cH cpj
      cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi cH pjadj2co.3 pjfi ho2coi cA
      chil wcel cA cH cpj cfv cfv chil wcel cA cH cpj cfv cfv cG cpj cfv cfv
      chil wcel cA cH cpj cfv cfv cG cpj cfv cfv cF cpj cfv cfv cF wcel cA cH
      pjadj2co.3 pjhcli cA cH cpj cfv cfv cG pjadj2co.2 pjhcli cA cH cpj cfv
      cfv cG cpj cfv cfv cF pjadj2co.1 pjcli 3syl eqeltrd $.
      $( [2-Dec-2000] $)

    $( Lemma for projection triplet theorem. $)
    pj3lem1 $p |- ( A e. ( ( F i^i G ) i^i H ) ->
         ( ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) ` A ) = A ) $=
      cA cF cG cH cin cin wcel cA cF cpj cfv cG cpj cfv cH cpj cfv ccom ccom
      cfv cA wceq cA cF cG cin cH cin wcel cA cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv cA wceq cA cF cG cH cin cin wcel cA cF wcel cA cG cH cin
      wcel wa cA cF cpj cfv cG cpj cfv cH cpj cfv ccom ccom cfv cA wceq cA cF
      cG cH cin elin cA cF wcel cA cG cH cin wcel wa cA cF cpj cfv cG cpj cfv
      cH cpj cfv ccom ccom cfv cA cG cpj cfv cH cpj cfv ccom cfv cF cpj cfv cfv
      cA cA cF wcel cA cG cH cin wcel wa cA chil wcel cA cF cpj cfv cG cpj cfv
      cH cpj cfv ccom ccom cfv cA cG cpj cfv cH cpj cfv ccom cfv cF cpj cfv cfv
      wceq cA cF wcel cA chil wcel cA cG cH cin wcel cA cF pjadj2co.1 cheli
      adantr cA cF cpj cfv cG cpj cfv cH cpj cfv ccom cF pjadj2co.1 pjfi cG cpj
      cfv cH cpj cfv cG pjadj2co.2 pjfi cH pjadj2co.3 pjfi hocofi hocoi syl cA
      cG cH cin wcel cA cF wcel cA cG cpj cfv cH cpj cfv ccom cfv cF cpj cfv
      cfv cA wceq cA cG cH cin wcel cA cG cpj cfv cH cpj cfv ccom cfv cA wceq
      cA cF wcel cA cG cpj cfv cH cpj cfv ccom cfv cF cpj cfv cfv cA wceq wi cA
      cG cH pjadj2co.2 pjadj2co.3 pjclem4a cA cG cpj cfv cH cpj cfv ccom cfv cA
      wceq cA cF wcel cA cG cpj cfv cH cpj cfv ccom cfv cF cpj cfv cfv cA cG
      cpj cfv cH cpj cfv ccom cfv wceq cA cG cpj cfv cH cpj cfv ccom cfv cF cpj
      cfv cfv cA wceq cA cG cpj cfv cH cpj cfv ccom cfv cA wceq cA cF wcel cA
      cG cpj cfv cH cpj cfv ccom cfv cF wcel cA cG cpj cfv cH cpj cfv ccom cfv
      cF cpj cfv cfv cA cG cpj cfv cH cpj cfv ccom cfv wceq cA cG cpj cfv cH
      cpj cfv ccom cfv cA cF eleq1 cF cch wcel cA cG cpj cfv cH cpj cfv ccom
      cfv cF wcel cA cG cpj cfv cH cpj cfv ccom cfv cF cpj cfv cfv cA cG cpj
      cfv cH cpj cfv ccom cfv wceq pjadj2co.1 cA cG cpj cfv cH cpj cfv ccom cfv
      cF pjid mpan syl6bir cA cG cpj cfv cH cpj cfv ccom cfv cA cA cG cpj cfv
      cH cpj cfv ccom cfv cF cpj cfv cfv eqeq2 sylibd syl impcom eqtrd sylbi cF
      cG cin cH cin cF cG cH cin cin cA cF cG cH inass eleq2i cA cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv cA cF cpj cfv cG cpj cfv cH cpj cfv ccom
      ccom cfv cA cA cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cF cpj cfv cG
      cpj cfv cH cpj cfv ccom ccom cF cpj cfv cG cpj cfv cH cpj cfv coass
      fveq1i eqeq1i 3imtr4i $.
      $( [2-Dec-2000] $)

    $( Stronger projection triplet theorem. $)
    pj3si $p |- ( ( ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
                  ( ( ( proj ` H ) o. ( proj ` G ) ) o. ( proj ` F ) ) /\
         ran ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) C_ G ) ->
       ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
       ( proj ` ( ( F i^i G ) i^i H ) ) ) $=
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF
      cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss
      wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv cF cG cin
      cH cin cpj cfv cfv wceq vx chil wral cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cF cG cin cH cin cpj cfv wceq cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv vx cv cF cG cin cH cin cpj cfv cfv wceq vx chil
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF
      cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss
      wa vx cv chil wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co cva
      co cF cG cin cH cin cpj cfv cfv vx cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv vx cv cF cG cin cH cin cpj cfv cfv vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv cF cG cin cH cin wcel vx cv vx cv cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cfv cmv co cF cG cin cH cin cort cfv wcel
      vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co cva co cF cG cin cH cin
      cpj cfv cfv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv wceq cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx
      cv chil wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx
      cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co cF cG cin
      cH cin cF cG cin cH cF cG pjadj2co.1 pjadj2co.2 chincli pjadj2co.3
      chincli pjvi cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj
      cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      crn cG wss wa vx cv chil wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv cF cG cin wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv cH wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      cF cG cin cH cin wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom crn cG wss wa vx cv chil wcel wa vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv cF cG cin wcel vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv cH wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      crn cG wss vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv cF cG cin wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom crn cG wss vx cv chil wcel wa vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv cF wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv cG wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv cF cG cin wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss
      vx cv chil wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      cF wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cG wcel vx
      cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cF wcel
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss vx cv cF cG cH
      pjadj2co.1 pjadj2co.2 pjadj2co.3 pj2cocli adantl cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom crn cG wss vx cv chil wcel vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv cG wcel cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom crn cG wss vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn wcel vx cv cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv cG wcel vx cv chil wcel cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom crn cG vx cv cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cfv ssel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom chil wfn
      vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn wcel cF cpj cfv cG cpj cfv
      ccom cH cpj cfv cF cpj cfv cG cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2
      pjfi hocofi cH pjadj2co.3 pjfi hocofni chil vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom fnfvelrn mpan syl5 imp jca vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv cF cG elin sylibr adantll cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq
      vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cH
      wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom
      wceq vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      cH wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom cF cpj cfv ccom wceq vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv cH wcel vx cv cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom cfv cH
      wcel vx cv chil wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom wceq vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv vx cv cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom cfv
      cH vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom cF cpj cfv ccom fveq1 eleq1d vx cv cH cG cF pjadj2co.3 pjadj2co.2
      pjadj2co.1 pj2cocli syl5bir imp adantlr jca vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv cF cG cin cH elin sylibr cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv chil wcel wa
      vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co chil
      wcel vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co vy
      cv csp co cc0 wceq vy cF cG cin cH cin wral wa vx cv vx cv cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv cmv co cF cG cin cH cin cort cfv wcel cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx
      cv chil wcel wa vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv cmv co chil wcel vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv cmv co vy cv csp co cc0 wceq vy cF cG cin cH cin wral vx cv chil
      wcel vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co
      chil wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj
      cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      crn cG wss wa vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv chil wcel vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv cmv co chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv cF cpj
      cfv cG cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH pjadj2co.3
      pjfi hococli vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      hvsubcl mpdan adantl cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom crn cG wss wa vx cv chil wcel wa vx cv vx cv cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv cmv co vy cv csp co cc0 wceq vy cF cG
      cin cH cin cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj
      cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      crn cG wss wa vx cv chil wcel vy cv cF cG cin cH cin wcel vx cv vx cv cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co vy cv csp co cc0 wceq
      wi cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom
      cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG
      wss wa vx cv chil wcel vy cv cF cG cin cH cin wcel vx cv vx cv cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cfv cmv co vy cv csp co cc0 wceq cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv
      chil wcel vy cv cF cG cin cH cin wcel wa wa vx cv vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv cmv co vy cv csp co vx cv vy cv csp co vx cv
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co cmin co vx cv
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co cmin co cc0 cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv
      chil wcel vy cv cF cG cin cH cin wcel wa wa vx cv chil wcel vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv chil wcel vy cv chil wcel w3a vx
      cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co vy cv csp
      co vx cv vy cv csp co vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv vy cv csp co cmin co wceq vx cv chil wcel vy cv cF cG cin cH cin wcel
      wa vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      chil wcel vy cv chil wcel w3a cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom crn cG wss wa vx cv chil wcel vy cv cF cG cin cH cin
      wcel wa vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv chil wcel vy cv chil wcel vx cv chil wcel vy cv cF cG cin cH cin wcel
      pm3.26 vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv chil wcel vy cv cF cG cin cH cin wcel vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv cF cpj cfv cG cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2
      pjfi hocofi cH pjadj2co.3 pjfi hococli adantr vy cv cF cG cin cH cin wcel
      vy cv chil wcel vx cv chil wcel vy cv cF cG cin cH cin cF cG cin cH cF cG
      pjadj2co.1 pjadj2co.2 chincli pjadj2co.3 chincli cheli adantl 3jca adantl
      vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv his2sub
      syl cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom
      cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG
      wss wa vx cv chil wcel vy cv cF cG cin cH cin wcel wa wa vx cv cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co vx cv vy cv csp co vx cv
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co cmin cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv
      chil wcel vy cv cF cG cin cH cin wcel wa vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv vy cv csp co vx cv cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom cfv vy cv csp co vx cv vy cv csp co cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv vx cv cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom cfv vy cv csp cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv
      cG cpj cfv ccom cF cpj cfv ccom wceq vx cv cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cfv vx cv cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom cfv
      wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom fveq1 adantr opreq1d vx cv chil wcel vy cv cF cG cin cH cin wcel wa
      vx cv cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom cfv vy cv csp co vx cv
      vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv csp co vx cv vy cv
      csp co vx cv chil wcel vy cv chil wcel vx cv cH cpj cfv cG cpj cfv ccom
      cF cpj cfv ccom cfv vy cv csp co vx cv vy cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv csp co wceq vy cv cF cG cin cH cin wcel vx cv vy cv
      cH cG cF pjadj2co.3 pjadj2co.2 pjadj2co.1 pjadj2coi vy cv cF cG cin cH
      cin cF cG cin cH cF cG pjadj2co.1 pjadj2co.2 chincli pjadj2co.3 chincli
      cheli sylan2 vy cv cF cG cin cH cin wcel vx cv vy cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv csp co vx cv vy cv csp co wceq vx cv chil
      wcel vy cv cF cG cin cH cin wcel vy cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv vy cv vx cv csp vy cv cF cG cH pjadj2co.1 pjadj2co.2
      pjadj2co.3 pj3lem1 opreq2d adantl eqtrd sylan9eq opreq1d cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom
      wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv chil
      wcel vy cv cF cG cin cH cin wcel wa wa vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv chil wcel vy cv chil wcel wa vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv vy cv csp co cc wcel vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv vy cv csp co vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv vy cv csp co cmin co cc0 wceq vx cv chil wcel vy
      cv cF cG cin cH cin wcel wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv chil wcel vy cv chil wcel wa cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom crn cG wss wa vx cv chil wcel vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv chil wcel vy cv cF cG cin cH cin
      wcel vy cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv cF cpj
      cfv cG cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH pjadj2co.3
      pjfi hococli vy cv cF cG cin cH cin cF cG cin cH cF cG pjadj2co.1
      pjadj2co.2 chincli pjadj2co.3 chincli cheli anim12i adantl vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv hicl vx cv cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co subid 3syl 3eqtr2d exp32
      imp r19.21aiv jca cF cG cin cH cin csh wcel vx cv vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv cmv co cF cG cin cH cin cort cfv wcel vx cv
      vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co chil wcel vx
      cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co vy cv csp
      co cc0 wceq vy cF cG cin cH cin wral wa wb cF cG cin cH cin cF cG cin cH
      cF cG pjadj2co.1 pjadj2co.2 chincli pjadj2co.3 chincli chshii vy vx cv vx
      cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co cF cG cin cH cin
      shocel ax-mp sylibr sylanc vx cv chil wcel vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv cmv co cva co cF cG cin cH cin cpj cfv cfv vx cv cF cG cin
      cH cin cpj cfv cfv wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom crn cG wss wa vx cv chil wcel vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv cmv co cva co vx cv cF cG cin cH cin cpj cfv vx cv chil wcel
      vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv co cva co vx cv vx cv cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv cmv co cva co vx cv c0v cva co vx cv vx cv cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cfv chil wcel vx cv chil wcel vx cv cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv chil wcel vx cv cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv vx cv vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv cmv co cva co vx cv vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      cmv co cva co wceq vx cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cfv vx cv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv hvaddsub12 vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv cF cpj cfv cG
      cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH pjadj2co.3 pjfi
      hococli vx cv chil wcel id vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv cF
      cpj cfv cG cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH
      pjadj2co.3 pjfi hococli syl3anc vx cv chil wcel vx cv cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cfv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv cmv co c0v vx cv cva vx cv chil wcel vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cfv vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv cmv
      co c0v wceq vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv cF cpj cfv cG cpj
      cfv cF pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH pjadj2co.3 pjfi
      hococli vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv hvsubid syl
      opreq2d vx cv ax-hvaddid 3eqtrd fveq2d adantl eqtr3d r19.21aiva vx cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cF cG cin cH cin cpj cfv cF cpj cfv
      cG cpj cfv ccom cH cpj cfv cF cpj cfv cG cpj cfv cF pjadj2co.1 pjfi cG
      pjadj2co.2 pjfi hocofi cH pjadj2co.3 pjfi hocofi cF cG cin cH cin cF cG
      cin cH cF cG pjadj2co.1 pjadj2co.2 chincli pjadj2co.3 chincli pjfi hoeqi
      sylib $.
      $( [2-Dec-2000] $)

    $( Projection triplet theorem. $)
    pj3i $p |- ( ( ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
                  ( ( ( proj ` H ) o. ( proj ` G ) ) o. ( proj ` F ) ) /\
                  ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
                  ( ( ( proj ` G ) o. ( proj ` F ) ) o. ( proj ` H ) ) ) ->
       ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
       ( proj ` ( ( F i^i G ) i^i H ) ) ) $=
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF
      cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cF cG cin cH cin cpj cfv wceq
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH
      cpj cfv ccom wceq cF cG cH pjadj2co.1 pjadj2co.2 pjadj2co.3 pj3si cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv
      ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom crn cG wss cG cpj
      cfv cF cpj cfv cH cpj cfv ccom ccom crn cG wss cG cpj cfv cF cpj cfv cH
      cpj cfv ccom ccom crn cG cpj cfv crn cG cG cpj cfv cF cpj cfv cH cpj cfv
      ccom rncoss cG pjadj2co.2 pjrni sseqtri cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom crn cG cpj cfv cF cpj cfv cH cpj cfv ccom
      ccom crn cG cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj
      cfv ccom cH cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cG cpj cfv cF cpj cfv cH cpj cfv ccom ccom cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv cH cpj cfv ccom
      ccom wceq cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj
      cfv cH cpj cfv ccom ccom wceq cG cpj cfv cF cpj cfv cH cpj cfv coass cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj
      cfv ccom cG cpj cfv cF cpj cfv cH cpj cfv ccom ccom eqeq1 mpbiri rneqd
      sseq1d mpbiri sylan2 $.
      $( [2-Dec-2000] $)

    $( Projection triplet corollary. $)
    pj3cor1i $p |- ( ( ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
                  ( ( ( proj ` H ) o. ( proj ` G ) ) o. ( proj ` F ) ) /\
                  ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
                  ( ( ( proj ` G ) o. ( proj ` F ) ) o. ( proj ` H ) ) ) ->
       ( ( ( proj ` F ) o. ( proj ` G ) ) o. ( proj ` H ) ) =
       ( ( ( proj ` H ) o. ( proj ` F ) ) o. ( proj ` G ) ) ) $=
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF
      cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv
      cF cpj cfv ccom cH cpj cfv ccom wceq wa vx cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv
      wceq vx chil wral cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv
      cF cpj cfv ccom cG cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom
      wceq wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv cH cpj
      cfv cF cpj cfv ccom cG cpj cfv ccom cfv wceq vx chil vx cv chil wcel cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF
      cpj cfv ccom cH cpj cfv ccom wceq wa vx cv cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cfv vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv
      wceq vx cv chil wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj
      cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq wa vx cv cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co vx cv cH cpj cfv
      cF cpj cfv ccom cG cpj cfv ccom cfv vy cv csp co wceq vy chil wral vx cv
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv cH cpj cfv cF cpj
      cfv ccom cG cpj cfv ccom cfv wceq vx cv chil wcel cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj
      cfv ccom wceq wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy
      cv csp co vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv vy cv csp
      co wceq vy chil vx cv chil wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq
      wa vy cv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv
      vy cv csp co vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv vy cv
      csp co wceq vx cv chil wcel cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH
      cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq wa wa vy
      cv chil wcel wa vx cv vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom
      cfv csp co vx cv vy cv cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom cfv csp
      co vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp co vx
      cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv vy cv csp co cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj
      cfv ccom cH cpj cfv ccom wceq wa vx cv vy cv cF cpj cfv cG cpj cfv ccom
      cH cpj cfv ccom cfv csp co vx cv vy cv cG cpj cfv cF cpj cfv ccom cH cpj
      cfv ccom cfv csp co wceq vx cv chil wcel vy cv chil wcel cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom
      wceq vx cv vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv csp co vx
      cv vy cv cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom cfv csp co wceq cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF
      cpj cfv ccom cH cpj cfv ccom wceq vy cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv vy cv cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom cfv vx cv
      csp vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj
      cfv ccom cH cpj cfv ccom fveq1 opreq2d adantl ad2antlr vx cv chil wcel cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj
      cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF
      cpj cfv ccom cH cpj cfv ccom wceq wa wa vy cv chil wcel wa vx cv cF cG
      cin cH cin cpj cfv cfv vy cv csp co vx cv vy cv cF cG cin cH cin cpj cfv
      cfv csp co vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy cv csp
      co vx cv vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv csp co vx
      cv chil wcel vy cv chil wcel vx cv cF cG cin cH cin cpj cfv cfv vy cv csp
      co vx cv vy cv cF cG cin cH cin cpj cfv cfv csp co wceq cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq
      cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH
      cpj cfv ccom wceq wa vx cv vy cv cF cG cin cH cin cF cG cin cH cF cG
      pjadj2co.1 pjadj2co.2 chincli pjadj2co.3 chincli pjadji adantlr cF cpj
      cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv
      ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj
      cfv ccom cH cpj cfv ccom wceq wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cfv vy cv csp co vx cv cF cG cin cH cin cpj cfv cfv vy cv csp co
      wceq vx cv chil wcel vy cv chil wcel cF cpj cfv cG cpj cfv ccom cH cpj
      cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom
      wceq wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vx cv cF cG
      cin cH cin cpj cfv cfv vy cv csp cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj
      cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq
      wa vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cF cG cin cH cin cpj
      cfv cF cG cH pjadj2co.1 pjadj2co.2 pjadj2co.3 pj3i fveq1d opreq1d
      ad2antlr cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv
      ccom cF cpj cfv ccom wceq cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG
      cpj cfv cF cpj cfv ccom cH cpj cfv ccom wceq wa vx cv vy cv cF cpj cfv cG
      cpj cfv ccom cH cpj cfv ccom cfv csp co vx cv vy cv cF cG cin cH cin cpj
      cfv cfv csp co wceq vx cv chil wcel vy cv chil wcel cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj
      cfv ccom wceq wa vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cfv vy
      cv cF cG cin cH cin cpj cfv cfv vx cv csp cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF cpj cfv
      cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj cfv
      ccom wceq wa vy cv cF cpj cfv cG cpj cfv ccom cH cpj cfv ccom cF cG cin
      cH cin cpj cfv cF cG cH pjadj2co.1 pjadj2co.2 pjadj2co.3 pj3i fveq1d
      opreq2d ad2antlr 3eqtr4d vx cv chil wcel vy cv chil wcel vx cv cH cpj cfv
      cF cpj cfv ccom cG cpj cfv ccom cfv vy cv csp co vx cv vy cv cG cpj cfv
      cF cpj cfv ccom cH cpj cfv ccom cfv csp co wceq cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cH cpj cfv cG cpj cfv ccom cF cpj cfv ccom wceq cF
      cpj cfv cG cpj cfv ccom cH cpj cfv ccom cG cpj cfv cF cpj cfv ccom cH cpj
      cfv ccom wceq wa vx cv vy cv cH cF cG pjadj2co.3 pjadj2co.1 pjadj2co.2
      pjadj2coi adantlr 3eqtr4d exp31 r19.21adv vx cv cF cpj cfv cG cpj cfv
      ccom cH cpj cfv ccom cfv chil wcel vx cv cH cpj cfv cF cpj cfv ccom cG
      cpj cfv ccom cfv chil wcel vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv vy cv csp co vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom
      cfv vy cv csp co wceq vy chil wral vx cv cF cpj cfv cG cpj cfv ccom cH
      cpj cfv ccom cfv vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv
      wceq wb vx cv chil wcel vy vx cv cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cfv vx cv cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cfv hial2eq vx
      cv cF cpj cfv cG cpj cfv ccom cH cpj cfv cF cpj cfv cG cpj cfv cF
      pjadj2co.1 pjfi cG pjadj2co.2 pjfi hocofi cH pjadj2co.3 pjfi hococli vx
      cv cH cpj cfv cF cpj cfv ccom cG cpj cfv cH cpj cfv cF cpj cfv cH
      pjadj2co.3 pjfi cF pjadj2co.1 pjfi hocofi cG pjadj2co.2 pjfi hococli
      sylanc sylibd com12 r19.21aiv vx cF cpj cfv cG cpj cfv ccom cH cpj cfv
      ccom cH cpj cfv cF cpj cfv ccom cG cpj cfv ccom cF cpj cfv cG cpj cfv
      ccom cH cpj cfv cF cpj cfv cG cpj cfv cF pjadj2co.1 pjfi cG pjadj2co.2
      pjfi hocofi cH pjadj2co.3 pjfi hocofi cH cpj cfv cF cpj cfv ccom cG cpj
      cfv cH cpj cfv cF cpj cfv cH pjadj2co.3 pjfi cF pjadj2co.1 pjfi hocofi cG
      pjadj2co.2 pjfi hocofi hoeqi sylib $.
      $( [2-Dec-2000] $)
  $}

  ${
    pjs14.1 $e |- G e. CH $.
    pjs14.2 $e |- H e. CH $.
    $( Theorem S-14 of Watanabe, p. 486. $)
    pjs14i $p |- ( A e. ~H ->
                ( normh ` ( ( ( proj ` H ) o. ( proj ` G ) ) ` A ) )
                <_ ( normh ` ( ( proj ` G ) ` A ) ) ) $=
      cA chil wcel cA cH cpj cfv cG cpj cfv ccom cfv cno cfv cA cG cpj cfv cfv
      cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv cle cA chil wcel cA cH
      cpj cfv cG cpj cfv ccom cfv cA cG cpj cfv cfv cH cpj cfv cfv cno cA cH cG
      pjs14.2 pjs14.1 pjcoi fveq2d cA chil wcel cA cG cpj cfv cfv chil wcel cA
      cG cpj cfv cfv cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv cle wbr
      cA cG pjs14.1 pjhcli cH cch wcel cA cG cpj cfv cfv chil wcel cA cG cpj
      cfv cfv cH cpj cfv cfv cno cfv cA cG cpj cfv cfv cno cfv cle wbr pjs14.2
      cA cG cpj cfv cfv cH pjnorm mpan syl eqbrtrd $.
      $( [26-Sep-2001] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      States on a Hilbert lattice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f x y $.
    $( Define the set of states on a Hilbert lattice.  Definition of [Kalmbach]
       p. 266. $)
    df-st $a |- States = { f | ( ( f : CH --> RR /\ A. x e. CH
        ( 0 <_ ( f ` x ) /\ ( f ` x ) <_ 1 ) ) /\ ( ( f ` ~H ) = 1 /\
          A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
            ( f ` ( x vH y ) ) = ( ( f ` x ) + ( f ` y ) ) ) ) ) } $.
  $}

  ${
    $d f x y $.
    $( Define the set of complex Hilbert-space-valued states on a Hilbert
       lattice.  Definition of CH-states in [Mayet3] p. 9. $)
    df-hst $a |- CHStates = { f | ( f : CH --> ~H /\
          ( normh ` ( f ` ~H ) ) = 1 /\
          A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
          ( ( ( f ` x ) .ih ( f ` y ) ) = 0 /\
            ( f ` ( x vH y ) ) = ( ( f ` x ) +h ( f ` y ) ) ) ) ) } $.
  $}

  ${
    $d x y z w f h H $.  $d x y z w A $.  $d x y f S $.  $d y B $.
    $( Property of a state. $)
    stel $p |- ( S e. States <-> ( ( S : CH --> RR /\ A. x e. CH
        ( 0 <_ ( S ` x ) /\ ( S ` x ) <_ 1 ) ) /\ ( ( S ` ~H ) = 1 /\
          A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
            ( S ` ( x vH y ) ) = ( ( S ` x ) + ( S ` y ) ) ) ) ) ) $=
      cS cst wcel cS cvv wcel cch cr cS wf cc0 vx cv cS cfv cle wbr vx cv cS
      cfv c1 cle wbr wa vx cch wral wa chil cS cfv c1 wceq vx cv vy cv cort cfv
      wss vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi
      vy cch wral vx cch wral wa wa cS cst elisset cch cr cS wf cS cvv wcel cc0
      vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral chil cS cfv
      c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co cS cfv vx cv cS cfv
      vy cv cS cfv caddc co wceq wi vy cch wral vx cch wral wa cch cr cS wf cch
      cvv wcel cS cvv wcel chex cch cr cvv cS fex mpan2 ad2antrr cch cr vf cv
      wf cc0 vx cv vf cv cfv cle wbr vx cv vf cv cfv c1 cle wbr wa vx cch wral
      wa chil vf cv cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co vf
      cv cfv vx cv vf cv cfv vy cv vf cv cfv caddc co wceq wi vy cch wral vx
      cch wral wa wa cch cr cS wf cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle
      wbr wa vx cch wral wa chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv
      vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vy cch
      wral vx cch wral wa wa vf cS cst cvv vf cv cS wceq cch cr vf cv wf cc0 vx
      cv vf cv cfv cle wbr vx cv vf cv cfv c1 cle wbr wa vx cch wral wa cch cr
      cS wf cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral wa
      chil vf cv cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co vf cv
      cfv vx cv vf cv cfv vy cv vf cv cfv caddc co wceq wi vy cch wral vx cch
      wral wa chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co
      cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vy cch wral vx cch wral
      wa vf cv cS wceq cch cr vf cv wf cch cr cS wf cc0 vx cv vf cv cfv cle wbr
      vx cv vf cv cfv c1 cle wbr wa vx cch wral cc0 vx cv cS cfv cle wbr vx cv
      cS cfv c1 cle wbr wa vx cch wral cch cr vf cv cS feq1 vf cv cS wceq cc0
      vx cv vf cv cfv cle wbr vx cv vf cv cfv c1 cle wbr wa cc0 vx cv cS cfv
      cle wbr vx cv cS cfv c1 cle wbr wa vx cch vf cv cS wceq cc0 vx cv vf cv
      cfv cle wbr cc0 vx cv cS cfv cle wbr vx cv vf cv cfv c1 cle wbr vx cv cS
      cfv c1 cle wbr vf cv cS wceq vx cv vf cv cfv vx cv cS cfv cc0 cle vx cv
      vf cv cS fveq1 breq2d vf cv cS wceq vx cv vf cv cfv vx cv cS cfv c1 cle
      vx cv vf cv cS fveq1 breq1d anbi12d ralbidv anbi12d vf cv cS wceq chil vf
      cv cfv c1 wceq chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv
      chj co vf cv cfv vx cv vf cv cfv vy cv vf cv cfv caddc co wceq wi vy cch
      wral vx cch wral vx cv vy cv cort cfv wss vx cv vy cv chj co cS cfv vx cv
      cS cfv vy cv cS cfv caddc co wceq wi vy cch wral vx cch wral vf cv cS
      wceq chil vf cv cfv chil cS cfv c1 chil vf cv cS fveq1 eqeq1d vf cv cS
      wceq vx cv vy cv cort cfv wss vx cv vy cv chj co vf cv cfv vx cv vf cv
      cfv vy cv vf cv cfv caddc co wceq wi vx cv vy cv cort cfv wss vx cv vy cv
      chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vx vy cch cch vf
      cv cS wceq vx cv vy cv chj co vf cv cfv vx cv vf cv cfv vy cv vf cv cfv
      caddc co wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc
      co wceq vx cv vy cv cort cfv wss vf cv cS wceq vx cv vy cv chj co vf cv
      cfv vx cv vy cv chj co cS cfv vx cv vf cv cfv vy cv vf cv cfv caddc co vx
      cv cS cfv vy cv cS cfv caddc co vx cv vy cv chj co vf cv cS fveq1 vf cv
      cS wceq vx cv vf cv cfv vx cv cS cfv vy cv vf cv cfv vy cv cS cfv caddc
      vx cv vf cv cS fveq1 vy cv vf cv cS fveq1 opreq12d eqeq12d imbi2d
      2ralbidv anbi12d anbi12d vx vy vf df-st elab2g pm5.21nii $.
      $( [23-Oct-1999] $)

    $( Property of a complex Hilbert-space-valued state.  Definition of
       CH-states in [Mayet3] p. 9. $)
    hstel $p |- ( S e. CHStates <-> ( S : CH --> ~H /\
          ( normh ` ( S ` ~H ) ) = 1 /\
          A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
          ( ( ( S ` x ) .ih ( S ` y ) ) = 0 /\
            ( S ` ( x vH y ) ) = ( ( S ` x ) +h ( S ` y ) ) ) ) ) ) $=
      cS chst wcel cS cvv wcel cch chil cS wf chil cS cfv cno cfv c1 wceq vx cv
      vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv
      chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx
      cch wral w3a cS chst elisset cch chil cS wf chil cS cfv cno cfv c1 wceq
      cS cvv wcel vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0
      wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa
      wi vy cch wral vx cch wral cch chil cS wf cch cvv wcel cS cvv wcel chex
      cch chil cvv cS fex mpan2 3ad2ant1 cch chil vf cv wf chil vf cv cfv cno
      cfv c1 wceq vx cv vy cv cort cfv wss vx cv vf cv cfv vy cv vf cv cfv csp
      co cc0 wceq vx cv vy cv chj co vf cv cfv vx cv vf cv cfv vy cv vf cv cfv
      cva co wceq wa wi vy cch wral vx cch wral w3a cch chil cS wf chil cS cfv
      cno cfv c1 wceq vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co
      cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq
      wa wi vy cch wral vx cch wral w3a vf cS chst cvv vf cv cS wceq cch chil
      vf cv wf cch chil cS wf chil vf cv cfv cno cfv c1 wceq chil cS cfv cno
      cfv c1 wceq vx cv vy cv cort cfv wss vx cv vf cv cfv vy cv vf cv cfv csp
      co cc0 wceq vx cv vy cv chj co vf cv cfv vx cv vf cv cfv vy cv vf cv cfv
      cva co wceq wa wi vy cch wral vx cch wral vx cv vy cv cort cfv wss vx cv
      cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS
      cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx cch wral cch chil vf cv
      cS feq1 vf cv cS wceq chil vf cv cfv cno cfv chil cS cfv cno cfv c1 vf cv
      cS wceq chil vf cv cfv chil cS cfv cno chil vf cv cS fveq1 fveq2d eqeq1d
      vf cv cS wceq vx cv vy cv cort cfv wss vx cv vf cv cfv vy cv vf cv cfv
      csp co cc0 wceq vx cv vy cv chj co vf cv cfv vx cv vf cv cfv vy cv vf cv
      cfv cva co wceq wa wi vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv
      csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva
      co wceq wa wi vx vy cch cch vf cv cS wceq vx cv vf cv cfv vy cv vf cv cfv
      csp co cc0 wceq vx cv vy cv chj co vf cv cfv vx cv vf cv cfv vy cv vf cv
      cfv cva co wceq wa vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv
      chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa vx cv vy cv cort
      cfv wss vf cv cS wceq vx cv vf cv cfv vy cv vf cv cfv csp co cc0 wceq vx
      cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co vf cv cfv vx cv
      vf cv cfv vy cv vf cv cfv cva co wceq vx cv vy cv chj co cS cfv vx cv cS
      cfv vy cv cS cfv cva co wceq vf cv cS wceq vx cv vf cv cfv vy cv vf cv
      cfv csp co vx cv cS cfv vy cv cS cfv csp co cc0 vf cv cS wceq vx cv vf cv
      cfv vx cv cS cfv vy cv vf cv cfv vy cv cS cfv csp vx cv vf cv cS fveq1 vy
      cv vf cv cS fveq1 opreq12d eqeq1d vf cv cS wceq vx cv vy cv chj co vf cv
      cfv vx cv vy cv chj co cS cfv vx cv vf cv cfv vy cv vf cv cfv cva co vx
      cv cS cfv vy cv cS cfv cva co vx cv vy cv chj co vf cv cS fveq1 vf cv cS
      wceq vx cv vf cv cfv vx cv cS cfv vy cv vf cv cfv vy cv cS cfv cva vx cv
      vf cv cS fveq1 vy cv vf cv cS fveq1 opreq12d eqeq12d anbi12d imbi2d
      2ralbidv 3anbi123d vx vy vf df-hst elab2g pm5.21nii $.
      $( [30-Jun-2006] $) $( [25-Jun-2006] $)

    $( Real closure of the value of a state. $)
    stcl $p |- ( S e. States -> ( A e. CH -> ( S ` A ) e. RR ) ) $=
      cS cst wcel cA cch wcel cA cS cfv cr wcel cch cr cS wf cA cch wcel cA cS
      cfv cr wcel cS cst wcel cch cr cA cS ffvelrn cS cst wcel cch cr cS wf cc0
      vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral cS cst wcel
      cch cr cS wf cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch
      wral wa chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co
      cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vy cch wral vx cch wral
      wa vx vy cS stel pm3.26bi pm3.26d sylan ex $.
      $( [24-Oct-1999] $)

    $( Closure of the value of a Hilbert-space-valued state. $)
    hstcl $p |- ( ( S e. CHStates /\ A e. CH ) -> ( S ` A ) e. ~H ) $=
      cch chil cS wf cA cch wcel cA cS cfv chil wcel cS chst wcel cch chil cA
      cS ffvelrn cS chst wcel cch chil cS wf chil cS cfv cno cfv c1 wceq vx cv
      vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv
      chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx
      cch wral w3a cch chil cS wf vx vy cS hstel cch chil cS wf chil cS cfv cno
      cfv c1 wceq vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0
      wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa
      wi vy cch wral vx cch wral 3simp1 sylbi sylan $.
      $( [11-Jul-2006] $) $( [25-Jun-2006] $)

    $( Unit value of a Hilbert-space-valued state. $)
    hst1a $p |- ( S e. CHStates -> ( normh ` ( S ` ~H ) ) = 1 ) $=
      cS chst wcel cch chil cS wf chil cS cfv cno cfv c1 wceq vx cv vy cv cort
      cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS
      cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx cch wral
      w3a chil cS cfv cno cfv c1 wceq vx vy cS hstel cch chil cS wf chil cS cfv
      cno cfv c1 wceq vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co
      cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq
      wa wi vy cch wral vx cch wral 3simp2 sylbi $.
      $( [13-Jul-2006] $) $( [25-Jun-2006] $)

    $( Properties of a Hilbert-space-valued state. $)
    hstel2 $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH
       /\ A C_ ( _|_ ` B ) ) ) -> ( ( ( S ` A ) .ih ( S ` B ) ) = 0 /\
                    ( S ` ( A vH B ) ) = ( ( S ` A ) +h ( S ` B ) ) ) ) $=
      cS chst wcel cA cch wcel wa cB cch wcel cA cB cort cfv wss wa wa vx cv vy
      cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj
      co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx cch
      wral cA cS cfv cB cS cfv csp co cc0 wceq cA cB chj co cS cfv cA cS cfv cB
      cS cfv cva co wceq wa cS chst wcel vx cv vy cv cort cfv wss vx cv cS cfv
      vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv
      cS cfv cva co wceq wa wi vy cch wral vx cch wral cA cch wcel cB cch wcel
      cA cB cort cfv wss wa cS chst wcel cch chil cS wf chil cS cfv cno cfv c1
      wceq vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq
      vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy
      cch wral vx cch wral w3a vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS
      cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv
      cva co wceq wa wi vy cch wral vx cch wral vx vy cS hstel cch chil cS wf
      chil cS cfv cno cfv c1 wceq vx cv vy cv cort cfv wss vx cv cS cfv vy cv
      cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS
      cfv cva co wceq wa wi vy cch wral vx cch wral 3simp3 sylbi ad2antrr cA
      cch wcel cB cch wcel cA cB cort cfv wss wa vx cv vy cv cort cfv wss vx cv
      cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS
      cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx cch wral cA cS cfv cB
      cS cfv csp co cc0 wceq cA cB chj co cS cfv cA cS cfv cB cS cfv cva co
      wceq wa wi cS chst wcel cA cch wcel cB cch wcel cA cB cort cfv wss vx cv
      vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv
      chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx
      cch wral cA cS cfv cB cS cfv csp co cc0 wceq cA cB chj co cS cfv cA cS
      cfv cB cS cfv cva co wceq wa wi cA cch wcel cB cch wcel wa cA cB cort cfv
      wss vx cv vy cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx
      cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch
      wral vx cch wral cA cS cfv cB cS cfv csp co cc0 wceq cA cB chj co cS cfv
      cA cS cfv cB cS cfv cva co wceq wa wi cA cch wcel cB cch wcel wa vx cv vy
      cv cort cfv wss vx cv cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj
      co cS cfv vx cv cS cfv vy cv cS cfv cva co wceq wa wi vy cch wral vx cch
      wral cA cB cort cfv wss cA cS cfv cB cS cfv csp co cc0 wceq cA cB chj co
      cS cfv cA cS cfv cB cS cfv cva co wceq wa vx cv vy cv cort cfv wss vx cv
      cS cfv vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS
      cfv vy cv cS cfv cva co wceq wa wi cA cB cort cfv wss cA cS cfv cB cS cfv
      csp co cc0 wceq cA cB chj co cS cfv cA cS cfv cB cS cfv cva co wceq wa wi
      cA vy cv cort cfv wss cA cS cfv vy cv cS cfv csp co cc0 wceq cA vy cv chj
      co cS cfv cA cS cfv vy cv cS cfv cva co wceq wa wi vx vy cA cB cch cch vx
      cv cA wceq vx cv vy cv cort cfv wss cA vy cv cort cfv wss vx cv cS cfv vy
      cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS
      cfv cva co wceq wa cA cS cfv vy cv cS cfv csp co cc0 wceq cA vy cv chj co
      cS cfv cA cS cfv vy cv cS cfv cva co wceq wa vx cv cA vy cv cort cfv
      sseq1 vx cv cA wceq vx cv cS cfv vy cv cS cfv csp co cc0 wceq cA cS cfv
      vy cv cS cfv csp co cc0 wceq vx cv vy cv chj co cS cfv vx cv cS cfv vy cv
      cS cfv cva co wceq cA vy cv chj co cS cfv cA cS cfv vy cv cS cfv cva co
      wceq vx cv cA wceq vx cv cS cfv vy cv cS cfv csp co cA cS cfv vy cv cS
      cfv csp co cc0 vx cv cA wceq vx cv cS cfv cA cS cfv vy cv cS cfv csp vx
      cv cA cS fveq2 opreq1d eqeq1d vx cv cA wceq vx cv vy cv chj co cS cfv cA
      vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv cva co cA cS cfv vy cv cS
      cfv cva co vx cv cA wceq vx cv vy cv chj co cA vy cv chj co cS vx cv cA
      vy cv chj opreq1 fveq2d vx cv cA wceq vx cv cS cfv cA cS cfv vy cv cS cfv
      cva vx cv cA cS fveq2 opreq1d eqeq12d anbi12d imbi12d vy cv cB wceq cA vy
      cv cort cfv wss cA cB cort cfv wss cA cS cfv vy cv cS cfv csp co cc0 wceq
      cA vy cv chj co cS cfv cA cS cfv vy cv cS cfv cva co wceq wa cA cS cfv cB
      cS cfv csp co cc0 wceq cA cB chj co cS cfv cA cS cfv cB cS cfv cva co
      wceq wa vy cv cB wceq vy cv cort cfv cB cort cfv cA vy cv cB cort fveq2
      sseq2d vy cv cB wceq cA cS cfv vy cv cS cfv csp co cc0 wceq cA cS cfv cB
      cS cfv csp co cc0 wceq cA vy cv chj co cS cfv cA cS cfv vy cv cS cfv cva
      co wceq cA cB chj co cS cfv cA cS cfv cB cS cfv cva co wceq vy cv cB wceq
      cA cS cfv vy cv cS cfv csp co cA cS cfv cB cS cfv csp co cc0 vy cv cB
      wceq vy cv cS cfv cB cS cfv cA cS cfv csp vy cv cB cS fveq2 opreq2d
      eqeq1d vy cv cB wceq cA vy cv chj co cS cfv cA cB chj co cS cfv cA cS cfv
      vy cv cS cfv cva co cA cS cfv cB cS cfv cva co vy cv cB wceq cA vy cv chj
      co cA cB chj co cS vy cv cB cA chj opreq2 fveq2d vy cv cB wceq vy cv cS
      cfv cB cS cfv cA cS cfv cva vy cv cB cS fveq2 opreq2d eqeq12d anbi12d
      imbi12d rcla42v com23 imp anasss adantll mpd $.
      $( [13-Jul-2006] $) $( [25-Jun-2006] $)

    $( Orthogonality property of a Hilbert-space-valued state.  This is a
       key feature distinguishing it from a real-valued state. $)
    hstorth $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH
       /\ A C_ ( _|_ ` B ) ) ) -> ( ( S ` A ) .ih ( S ` B ) ) = 0 ) $=
      cS chst wcel cA cch wcel wa cB cch wcel cA cB cort cfv wss wa wa cA cS
      cfv cB cS cfv csp co cc0 wceq cA cB chj co cS cfv cA cS cfv cB cS cfv cva
      co wceq cA cB cS hstel2 pm3.26d $.
      $( [13-Jul-2006] $) $( [25-Jun-2006] $)

    $( Orthogonal sum property of a Hilbert-space-valued state. $)
    hstosum $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH
                         /\ A C_ ( _|_ ` B ) ) ) ->
                    ( S ` ( A vH B ) ) = ( ( S ` A ) +h ( S ` B ) ) ) $=
      cS chst wcel cA cch wcel wa cB cch wcel cA cB cort cfv wss wa wa cA cS
      cfv cB cS cfv csp co cc0 wceq cA cB chj co cS cfv cA cS cfv cB cS cfv cva
      co wceq cA cB cS hstel2 pm3.27d $.
      $( [14-Jul-2006] $) $( [25-Jun-2006] $)

    $( Sum of a Hilbert-space-valued state of a lattice element and its
       orthocomplement. $)
    hstoc $p |- ( ( S e. CHStates /\ A e. CH ) ->
                  ( ( S ` A ) +h ( S ` ( _|_ ` A ) ) ) = ( S ` ~H ) ) $=
      cS chst wcel cA cch wcel wa cA cA cort cfv chj co cS cfv cA cS cfv cA
      cort cfv cS cfv cva co chil cS cfv cS chst wcel cA cch wcel wa cA cort
      cfv cch wcel cA cA cort cfv cort cfv wss wa cA cA cort cfv chj co cS cfv
      cA cS cfv cA cort cfv cS cfv cva co wceq cS chst wcel cA cch wcel wa cA
      cort cfv cch wcel cA cA cort cfv cort cfv wss cA cch wcel cA cort cfv cch
      wcel cS chst wcel cA choccl adantl cA cch wcel cA cA cort cfv cort cfv
      wss cS chst wcel cA cch wcel cA csh wcel cA cA cort cfv cort cfv wss cA
      chsh cA shococss syl adantl jca cA cA cort cfv cS hstosum mpdan cA cch
      wcel cA cA cort cfv chj co cS cfv chil cS cfv wceq cS chst wcel cA cch
      wcel cA cA cort cfv chj co chil cS cA chjo fveq2d adantl eqtr3d $.
      $( [14-Jul-2006] $) $( [25-Jun-2006] $)

    $( Sum of norms of a Hilbert-space-valued state. $)
    hstnmoc $p |- ( ( S e. CHStates /\ A e. CH ) -> ( ( ( normh `
         ( S ` A ) ) ^ 2 ) + ( ( normh ` ( S ` ( _|_ ` A ) ) ) ^ 2 ) ) = 1 ) $=
      cS chst wcel cA cch wcel wa cA cS cfv cA cort cfv cS cfv cva co cno cfv
      c2 cexp co chil cS cfv cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cA
      cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cS chst wcel cA cch wcel
      wa cA cS cfv cA cort cfv cS cfv cva co cno cfv chil cS cfv cno cfv c2
      cexp cS chst wcel cA cch wcel wa cA cS cfv cA cort cfv cS cfv cva co chil
      cS cfv cno cA cS hstoc fveq2d opreq1d cA cS cfv chil wcel cA cort cfv cS
      cfv chil wcel wa cA cS cfv cA cort cfv cS cfv csp co cc0 wceq cA cS cfv
      cA cort cfv cS cfv cva co cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co
      cA cort cfv cS cfv cno cfv c2 cexp co caddc co wceq cS chst wcel cA cch
      wcel wa cA cS cfv cA cort cfv cS cfv normpyth cS chst wcel cA cch wcel wa
      cA cS cfv chil wcel cA cort cfv cS cfv chil wcel cA cS hstcl cS chst wcel
      cA cort cfv cch wcel cA cort cfv cS cfv chil wcel cA cch wcel cA cort cfv
      cS hstcl cA choccl sylan2 jca cS chst wcel cA cch wcel wa cA cort cfv cch
      wcel cA cA cort cfv cort cfv wss wa cA cS cfv cA cort cfv cS cfv csp co
      cc0 wceq cS chst wcel cA cch wcel wa cA cort cfv cch wcel cA cA cort cfv
      cort cfv wss cA cch wcel cA cort cfv cch wcel cS chst wcel cA choccl
      adantl cA cch wcel cA cA cort cfv cort cfv wss cS chst wcel cA cch wcel
      cA csh wcel cA cA cort cfv cort cfv wss cA chsh cA shococss syl adantl
      jca cA cA cort cfv cS hstorth mpdan sylc cS chst wcel chil cS cfv cno cfv
      c2 cexp co c1 wceq cA cch wcel cS chst wcel chil cS cfv cno cfv c2 cexp
      co c1 c2 cexp co c1 cS chst wcel chil cS cfv cno cfv c1 c2 cexp cS hst1a
      opreq1d sq1 syl6eq adantr 3eqtr3d $.
      $( [16-Jul-2006] $) $( [25-Jun-2006] $)

    $( The value of a state is nonnegative. $)
    stge0 $p |- ( S e. States -> ( A e. CH -> 0 <_ ( S ` A ) ) ) $=
      cA cch wcel cc0 vx cv cS cfv cle wbr vx cch wral cc0 cA cS cfv cle wbr cS
      cst wcel cc0 vx cv cS cfv cle wbr cc0 cA cS cfv cle wbr vx cA cch vx cv
      cA wceq vx cv cS cfv cA cS cfv cc0 cle vx cv cA cS fveq2 breq2d rcla4v cS
      cst wcel cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral
      cc0 vx cv cS cfv cle wbr vx cch wral cS cst wcel cch cr cS wf cc0 vx cv
      cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral cS cst wcel cch cr
      cS wf cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral wa
      chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co cS cfv vx
      cv cS cfv vy cv cS cfv caddc co wceq wi vy cch wral vx cch wral wa vx vy
      cS stel pm3.26bi pm3.27d cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr
      wa cc0 vx cv cS cfv cle wbr vx cch cc0 vx cv cS cfv cle wbr vx cv cS cfv
      c1 cle wbr pm3.26 r19.20si syl syl5com $.
      $( [24-Oct-1999] $)

    $( The value of a state is less than or equal to one. $)
    stle1 $p |- ( S e. States -> ( A e. CH -> ( S ` A ) <_ 1 ) ) $=
      cA cch wcel vx cv cS cfv c1 cle wbr vx cch wral cA cS cfv c1 cle wbr cS
      cst wcel vx cv cS cfv c1 cle wbr cA cS cfv c1 cle wbr vx cA cch vx cv cA
      wceq vx cv cS cfv cA cS cfv c1 cle vx cv cA cS fveq2 breq1d rcla4v cS cst
      wcel cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral vx
      cv cS cfv c1 cle wbr vx cch wral cS cst wcel cch cr cS wf cc0 vx cv cS
      cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral cS cst wcel cch cr cS
      wf cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr wa vx cch wral wa
      chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj co cS cfv vx
      cv cS cfv vy cv cS cfv caddc co wceq wi vy cch wral vx cch wral wa vx vy
      cS stel pm3.26bi pm3.27d cc0 vx cv cS cfv cle wbr vx cv cS cfv c1 cle wbr
      wa vx cv cS cfv c1 cle wbr vx cch cc0 vx cv cS cfv cle wbr vx cv cS cfv
      c1 cle wbr pm3.27 r19.20si syl syl5com $.
      $( [24-Oct-1999] $)

    $( The norm of the value of a Hilbert-space-valued state is less than or
       equal to one. $)
    hstle1 $p |- ( ( S e. CHStates /\ A e. CH ) ->
                   ( normh ` ( S ` A ) ) <_ 1 ) $=
      cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1 cle wbr cA cS cfv cno
      cfv c2 cexp co c1 c2 cexp co cle wbr cS chst wcel cA cch wcel wa cA cS
      cfv cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cA cort cfv cS cfv
      cno cfv c2 cexp co caddc co c1 c2 cexp co cle cS chst wcel cA cch wcel wa
      cc0 cA cort cfv cS cfv cno cfv c2 cexp co cle wbr cA cS cfv cno cfv c2
      cexp co cA cS cfv cno cfv c2 cexp co cA cort cfv cS cfv cno cfv c2 cexp
      co caddc co cle wbr cS chst wcel cA cch wcel wa cA cort cfv cS cfv cno
      cfv cr wcel cc0 cA cort cfv cS cfv cno cfv c2 cexp co cle wbr cS chst
      wcel cA cch wcel wa cA cort cfv cS cfv chil wcel cA cort cfv cS cfv cno
      cfv cr wcel cS chst wcel cA cort cfv cch wcel cA cort cfv cS cfv chil
      wcel cA cch wcel cA cort cfv cS hstcl cA choccl sylan2 cA cort cfv cS cfv
      normcl syl cA cort cfv cS cfv cno cfv sqge0 syl cA cS cfv cno cfv c2 cexp
      co cr wcel cA cort cfv cS cfv cno cfv c2 cexp co cr wcel cc0 cA cort cfv
      cS cfv cno cfv c2 cexp co cle wbr cA cS cfv cno cfv c2 cexp co cA cS cfv
      cno cfv c2 cexp co cA cort cfv cS cfv cno cfv c2 cexp co caddc co cle wbr
      wb cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co cA cort cfv
      cS cfv cno cfv c2 cexp co addge01 cS chst wcel cA cch wcel wa cA cS cfv
      cno cfv cr wcel cA cS cfv cno cfv c2 cexp co cr wcel cS chst wcel cA cch
      wcel wa cA cS cfv chil wcel cA cS cfv cno cfv cr wcel cA cS hstcl cA cS
      cfv normcl syl cA cS cfv cno cfv resqcl syl cS chst wcel cA cch wcel wa
      cA cort cfv cS cfv cno cfv cr wcel cA cort cfv cS cfv cno cfv c2 cexp co
      cr wcel cS chst wcel cA cch wcel wa cA cort cfv cS cfv chil wcel cA cort
      cfv cS cfv cno cfv cr wcel cS chst wcel cA cort cfv cch wcel cA cort cfv
      cS cfv chil wcel cA cch wcel cA cort cfv cS hstcl cA choccl sylan2 cA
      cort cfv cS cfv normcl syl cA cort cfv cS cfv cno cfv resqcl syl sylanc
      mpbid cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co cA cort
      cfv cS cfv cno cfv c2 cexp co caddc co c1 c1 c2 cexp co cA cS hstnmoc sq1
      syl6eqr breqtrd cA cS cfv cno cfv cr wcel cc0 cA cS cfv cno cfv cle wbr
      cA cS cfv cno cfv c1 cle wbr cA cS cfv cno cfv c2 cexp co c1 c2 cexp co
      cle wbr wb cS chst wcel cA cch wcel wa cA cS cfv cno cfv cr wcel cc0 cA
      cS cfv cno cfv cle wbr wa c1 cr wcel cc0 c1 cle wbr cA cS cfv cno cfv c1
      cle wbr cA cS cfv cno cfv c2 cexp co c1 c2 cexp co cle wbr wb 1re cc0 c1
      0re 1re lt01 ltleii cA cS cfv cno cfv c1 le2sq mpanr12 cS chst wcel cA
      cch wcel wa cA cS cfv chil wcel cA cS cfv cno cfv cr wcel cA cS hstcl cA
      cS cfv normcl syl cS chst wcel cA cch wcel wa cA cS cfv chil wcel cc0 cA
      cS cfv cno cfv cle wbr cA cS hstcl cA cS cfv normge0 syl sylanc mpbird $.
      $( [16-Jul-2006] $) $( [25-Jun-2006] $)

    $( The norm of a Hilbert-space-valued state equals one iff the state value
       equals the state value of the lattice unit. $)
    hst1h $p |- ( ( S e. CHStates /\ A e. CH ) ->
                  ( ( normh ` ( S ` A ) ) = 1 <-> ( S ` A ) = ( S ` ~H ) ) ) $=
      cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1 wceq cA cS cfv chil cS
      cfv wceq cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1 wceq wa cA cS
      cfv cA cort cfv cS cfv cva co cA cS cfv c0v cva co chil cS cfv cA cS cfv
      cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1 wceq wa cA cort cfv cS
      cfv c0v cA cS cfv cva cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1
      wceq cA cort cfv cS cfv c0v wceq cS chst wcel cA cch wcel wa cA cS cfv
      cno cfv c1 wceq cA cort cfv cS cfv cno cfv c2 cexp co cc0 wceq cA cort
      cfv cS cfv c0v wceq cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1 wceq
      cA cort cfv cS cfv cno cfv c2 cexp co cc0 wceq cS chst wcel cA cch wcel
      wa cA cS cfv cno cfv c1 wceq wa cA cort cfv cS cfv cno cfv c2 cexp co c1
      c1 cmin co cc0 cS chst wcel cA cch wcel wa cA cS cfv cno cfv c1 wceq wa
      c1 cA cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cmin co cA cort cfv
      cS cfv cno cfv c2 cexp co c1 c1 cmin co cS chst wcel cA cch wcel wa c1 cA
      cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cmin co cA cort cfv cS cfv
      cno cfv c2 cexp co wceq cA cS cfv cno cfv c1 wceq cS chst wcel cA cch
      wcel wa cA cort cfv cS cfv cno cfv c2 cexp co cc wcel c1 cA cort cfv cS
      cfv cno cfv c2 cexp co caddc co c1 cmin co cA cort cfv cS cfv cno cfv c2
      cexp co wceq cS chst wcel cA cch wcel wa cA cort cfv cS cfv cno cfv c2
      cexp co cS chst wcel cA cch wcel wa cA cort cfv cS cfv cno cfv cr wcel cA
      cort cfv cS cfv cno cfv c2 cexp co cr wcel cS chst wcel cA cch wcel wa cA
      cort cfv cS cfv chil wcel cA cort cfv cS cfv cno cfv cr wcel cS chst wcel
      cA cort cfv cch wcel cA cort cfv cS cfv chil wcel cA cch wcel cA cort cfv
      cS hstcl cA choccl sylan2 cA cort cfv cS cfv normcl syl cA cort cfv cS
      cfv cno cfv resqcl syl recnd c1 cc wcel cA cort cfv cS cfv cno cfv c2
      cexp co cc wcel c1 cA cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cmin
      co cA cort cfv cS cfv cno cfv c2 cexp co wceq ax1cn c1 cA cort cfv cS cfv
      cno cfv c2 cexp co pncan2 mpan syl adantr cS chst wcel cA cch wcel wa cA
      cS cfv cno cfv c1 wceq wa c1 cA cort cfv cS cfv cno cfv c2 cexp co caddc
      co c1 c1 cmin cA cS cfv cno cfv c1 wceq cS chst wcel cA cch wcel wa c1 cA
      cort cfv cS cfv cno cfv c2 cexp co caddc co cA cS cfv cno cfv c2 cexp co
      cA cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cA cS cfv cno cfv c1
      wceq c1 cA cS cfv cno cfv c2 cexp co cA cort cfv cS cfv cno cfv c2 cexp
      co caddc cA cS cfv cno cfv c1 wceq cA cS cfv cno cfv c2 cexp co c1 c2
      cexp co c1 cA cS cfv cno cfv c1 c2 cexp opreq1 sq1 syl6req opreq1d cA cS
      hstnmoc sylan9eqr opreq1d eqtr3d c1 ax1cn subidi syl6eq ex cS chst wcel
      cA cch wcel wa cA cort cfv cS cfv cno cfv c2 cexp co cc0 wceq cA cort cfv
      cS cfv cno cfv cc0 wceq cA cort cfv cS cfv c0v wceq cS chst wcel cA cch
      wcel wa cA cort cfv cS cfv cno cfv cc wcel cA cort cfv cS cfv cno cfv c2
      cexp co cc0 wceq cA cort cfv cS cfv cno cfv cc0 wceq wb cS chst wcel cA
      cch wcel wa cA cort cfv cS cfv cno cfv cS chst wcel cA cch wcel wa cA
      cort cfv cS cfv chil wcel cA cort cfv cS cfv cno cfv cr wcel cS chst wcel
      cA cort cfv cch wcel cA cort cfv cS cfv chil wcel cA cch wcel cA cort cfv
      cS hstcl cA choccl sylan2 cA cort cfv cS cfv normcl syl recnd cA cort cfv
      cS cfv cno cfv sqeq0 syl cS chst wcel cA cch wcel wa cA cort cfv cS cfv
      chil wcel cA cort cfv cS cfv cno cfv cc0 wceq cA cort cfv cS cfv c0v wceq
      wb cS chst wcel cA cort cfv cch wcel cA cort cfv cS cfv chil wcel cA cch
      wcel cA cort cfv cS hstcl cA choccl sylan2 cA cort cfv cS cfv norm-i syl
      bitrd sylibd imp opreq2d cS chst wcel cA cch wcel wa cA cS cfv cA cort
      cfv cS cfv cva co chil cS cfv wceq cA cS cfv cno cfv c1 wceq cA cS hstoc
      adantr cS chst wcel cA cch wcel wa cA cS cfv c0v cva co cA cS cfv wceq cA
      cS cfv cno cfv c1 wceq cS chst wcel cA cch wcel wa cA cS cfv chil wcel cA
      cS cfv c0v cva co cA cS cfv wceq cA cS hstcl cA cS cfv ax-hvaddid syl
      adantr 3eqtr3rd cA cS cfv chil cS cfv wceq cS chst wcel cA cch wcel wa cA
      cS cfv cno cfv chil cS cfv cno cfv c1 cA cS cfv chil cS cfv cno fveq2 cS
      chst wcel chil cS cfv cno cfv c1 wceq cA cch wcel cS hst1a adantr
      sylan9eqr impbida $.
      $( [9-Mar-2007] $) $( [25-Jun-2006] $)

    $( The norm of a Hilbert-space-valued state equals zero iff the state value
       equals zero. $)
    hst0h $p |- ( ( S e. CHStates /\ A e. CH ) ->
                  ( ( normh ` ( S ` A ) ) = 0 <-> ( S ` A ) = 0h ) ) $=
      cS chst wcel cA cch wcel wa cA cS cfv chil wcel cA cS cfv cno cfv cc0
      wceq cA cS cfv c0v wceq wb cA cS hstcl cA cS cfv norm-i syl $.
      $( [6-Sep-2006] $) $( [30-Jun-2006] $)

    $( Pythagorean property of a Hilbert-space-valued state for orthogonal
       vectors ` A ` and ` B ` . $)
    hstpyth $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH /\
               A C_ ( _|_ ` B ) ) ) -> ( ( normh ` ( S ` ( A vH B ) ) ) ^ 2 ) =
         ( ( ( normh ` ( S ` A ) ) ^ 2 ) + ( ( normh ` ( S ` B ) ) ^ 2 ) ) ) $=
      cS chst wcel cA cch wcel wa cB cch wcel cA cB cort cfv wss wa wa cA cB
      chj co cS cfv cno cfv c2 cexp co cA cS cfv cB cS cfv cva co cno cfv c2
      cexp co cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv c2 cexp co caddc
      co cS chst wcel cA cch wcel wa cB cch wcel cA cB cort cfv wss wa wa cA cB
      chj co cS cfv cno cfv cA cS cfv cB cS cfv cva co cno cfv c2 cexp cS chst
      wcel cA cch wcel wa cB cch wcel cA cB cort cfv wss wa wa cA cB chj co cS
      cfv cA cS cfv cB cS cfv cva co cno cA cB cS hstosum fveq2d opreq1d cA cS
      cfv chil wcel cB cS cfv chil wcel cA cS cfv cB cS cfv csp co cc0 wceq cA
      cS cfv cB cS cfv cva co cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co
      cB cS cfv cno cfv c2 cexp co caddc co wceq cS chst wcel cA cch wcel wa cB
      cch wcel cA cB cort cfv wss wa wa cA cS cfv chil wcel cB cS cfv chil wcel
      cA cS cfv cB cS cfv csp co cc0 wceq cA cS cfv cB cS cfv cva co cno cfv c2
      cexp co cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv c2 cexp co caddc
      co wceq cA cS cfv cB cS cfv normpyth 3impia cS chst wcel cA cch wcel wa
      cA cS cfv chil wcel cB cch wcel cA cB cort cfv wss wa cA cS hstcl adantr
      cS chst wcel cB cch wcel cB cS cfv chil wcel cA cch wcel cA cB cort cfv
      wss cB cS hstcl ad2ant2r cA cB cS hstorth syl3anc eqtrd $.
      $( [20-Jul-2006] $) $( [26-Jun-2006] $)

    $( Ordering property of a Hilbert-space-valued state. $)
    hstle $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH /\ A C_ B ) )
                   -> ( normh ` ( S ` A ) ) <_ ( normh ` ( S ` B ) ) ) $=
      cS chst wcel cA cch wcel wa cB cch wcel cA cB wss wa wa cA cS cfv cno cfv
      cB cS cfv cno cfv cle wbr cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv
      c2 cexp co cle wbr cS chst wcel cA cch wcel wa cB cch wcel cA cB wss wa
      wa cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv c2 cexp co cle wbr cA
      cS cfv cno cfv c2 cexp co c1 caddc co cB cS cfv cno cfv c2 cexp co c1
      caddc co cle wbr cS chst wcel cA cch wcel wa cB cch wcel cA cB wss wa wa
      cA cS cfv cno cfv c2 cexp co c1 caddc co cB cS cfv cno cfv c2 cexp co cA
      cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2 cexp co caddc co
      caddc co cB cS cfv cno cfv c2 cexp co c1 caddc co cle cS chst wcel cA cch
      wcel wa cB cch wcel cA cS cfv cno cfv c2 cexp co c1 caddc co cB cS cfv
      cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno
      cfv c2 cexp co caddc co caddc co wceq cA cB wss cS chst wcel cA cch wcel
      wa cB cch wcel wa cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv c2 cexp
      co cB cort cfv cS cfv cno cfv c2 cexp co caddc co caddc co cA cS cfv cno
      cfv c2 cexp co c1 caddc co cB cS cfv cno cfv c2 cexp co cA cS cfv cno cfv
      c2 cexp co cB cort cfv cS cfv cno cfv c2 cexp co caddc co caddc co cS
      chst wcel cA cch wcel wa cB cch wcel wa cB cS cfv cno cfv c2 cexp co cB
      cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cA cS cfv cno cfv c2 cexp
      co caddc cS chst wcel cB cch wcel cB cS cfv cno cfv c2 cexp co cB cort
      cfv cS cfv cno cfv c2 cexp co caddc co c1 wceq cA cch wcel cB cS hstnmoc
      adantlr opreq2d cA cS cfv cno cfv c2 cexp co cc wcel cB cS cfv cno cfv c2
      cexp co cc wcel cB cort cfv cS cfv cno cfv c2 cexp co cc wcel cA cS cfv
      cno cfv c2 cexp co cB cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno
      cfv c2 cexp co caddc co caddc co cB cS cfv cno cfv c2 cexp co cA cS cfv
      cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2 cexp co caddc co caddc
      co wceq cS chst wcel cA cch wcel wa cB cch wcel wa cA cS cfv cno cfv c2
      cexp co cB cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2 cexp
      co add12 cS chst wcel cA cch wcel wa cB cch wcel wa cA cS cfv cno cfv c2
      cexp co cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co cr wcel
      cB cch wcel cS chst wcel cA cch wcel wa cA cS cfv cno cfv cr wcel cA cS
      cfv cno cfv c2 cexp co cr wcel cS chst wcel cA cch wcel wa cA cS cfv chil
      wcel cA cS cfv cno cfv cr wcel cA cS hstcl cA cS cfv normcl syl cA cS cfv
      cno cfv resqcl syl adantr recnd cS chst wcel cA cch wcel wa cB cch wcel
      wa cB cS cfv cno cfv c2 cexp co cS chst wcel cB cch wcel cB cS cfv cno
      cfv c2 cexp co cr wcel cA cch wcel cS chst wcel cB cch wcel wa cB cS cfv
      cno cfv cr wcel cB cS cfv cno cfv c2 cexp co cr wcel cS chst wcel cB cch
      wcel wa cB cS cfv chil wcel cB cS cfv cno cfv cr wcel cB cS hstcl cB cS
      cfv normcl syl cB cS cfv cno cfv resqcl syl adantlr recnd cS chst wcel cA
      cch wcel wa cB cch wcel wa cB cort cfv cS cfv cno cfv c2 cexp co cS chst
      wcel cB cch wcel cB cort cfv cS cfv cno cfv c2 cexp co cr wcel cA cch
      wcel cS chst wcel cB cch wcel wa cB cort cfv cS cfv cno cfv cr wcel cB
      cort cfv cS cfv cno cfv c2 cexp co cr wcel cS chst wcel cB cch wcel wa cB
      cort cfv cS cfv chil wcel cB cort cfv cS cfv cno cfv cr wcel cS chst wcel
      cB cort cfv cch wcel cB cort cfv cS cfv chil wcel cB cch wcel cB cort cfv
      cS hstcl cB choccl sylan2 cB cort cfv cS cfv normcl syl cB cort cfv cS
      cfv cno cfv resqcl syl adantlr recnd syl3anc eqtr3d adantrr cS chst wcel
      cA cch wcel wa cB cch wcel cA cB wss wa wa cA cS cfv cno cfv c2 cexp co
      cB cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cle wbr cB cS cfv cno
      cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2
      cexp co caddc co caddc co cB cS cfv cno cfv c2 cexp co c1 caddc co cle
      wbr cS chst wcel cA cch wcel wa cB cch wcel cA cB wss wa wa cA cB cort
      cfv chj co cS cfv cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cB cort
      cfv cS cfv cno cfv c2 cexp co caddc co c1 cle cS chst wcel cA cch wcel wa
      cB cort cfv cch wcel cA cB cort cfv cort cfv wss wa cA cB cort cfv chj co
      cS cfv cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv
      cno cfv c2 cexp co caddc co wceq cB cch wcel cA cB wss wa cA cB cort cfv
      cS hstpyth cB cch wcel cA cB wss wa cB cort cfv cch wcel cA cB cort cfv
      cort cfv wss cB cch wcel cB cort cfv cch wcel cA cB wss cB choccl adantr
      cB cch wcel cA cB cort cfv cort cfv wss cA cB wss cB cch wcel cB cort cfv
      cort cfv cB cA cB ococ sseq2d biimpar jca sylan2 cS chst wcel cA cch wcel
      wa cB cch wcel cA cB cort cfv chj co cS cfv cno cfv c2 cexp co c1 cle wbr
      cA cB wss cS chst wcel cA cch wcel wa cB cch wcel wa cA cB cort cfv chj
      co cS cfv cno cfv c2 cexp co c1 c2 cexp co c1 cle cA cB cort cfv chj co
      cS cfv cno cfv cr wcel cc0 cA cB cort cfv chj co cS cfv cno cfv cle wbr
      wa cA cB cort cfv chj co cS cfv cno cfv c1 cle wbr cA cB cort cfv chj co
      cS cfv cno cfv c2 cexp co c1 c2 cexp co cle wbr cS chst wcel cA cch wcel
      wa cB cch wcel wa cA cB cort cfv chj co cS cfv cno cfv cr wcel cc0 cA cB
      cort cfv chj co cS cfv cno cfv cle wbr wa c1 cr wcel cA cB cort cfv chj
      co cS cfv cno cfv c1 cle wbr cA cB cort cfv chj co cS cfv cno cfv c2 cexp
      co c1 c2 cexp co cle wbr 1re cA cB cort cfv chj co cS cfv cno cfv c1
      le2sq2 mpanr1 cS chst wcel cA cch wcel wa cB cch wcel wa cA cB cort cfv
      chj co cS cfv cno cfv cr wcel cc0 cA cB cort cfv chj co cS cfv cno cfv
      cle wbr cS chst wcel cA cch wcel wa cB cch wcel wa cA cB cort cfv chj co
      cS cfv chil wcel cA cB cort cfv chj co cS cfv cno cfv cr wcel cS chst
      wcel cA cch wcel cB cch wcel cA cB cort cfv chj co cS cfv chil wcel cS
      chst wcel cA cB cort cfv chj co cch wcel cA cB cort cfv chj co cS cfv
      chil wcel cA cch wcel cB cch wcel wa cA cB cort cfv chj co cS hstcl cA
      cch wcel cB cort cfv cch wcel cA cB cort cfv chj co cch wcel cB cch wcel
      cA cB cort cfv chjcl cB choccl sylan2 sylan2 anassrs cA cB cort cfv chj
      co cS cfv normcl syl cS chst wcel cA cch wcel wa cB cch wcel wa cA cB
      cort cfv chj co cS cfv chil wcel cc0 cA cB cort cfv chj co cS cfv cno cfv
      cle wbr cS chst wcel cA cch wcel cB cch wcel cA cB cort cfv chj co cS cfv
      chil wcel cS chst wcel cA cB cort cfv chj co cch wcel cA cB cort cfv chj
      co cS cfv chil wcel cA cch wcel cB cch wcel wa cA cB cort cfv chj co cS
      hstcl cA cch wcel cB cort cfv cch wcel cA cB cort cfv chj co cch wcel cB
      cch wcel cA cB cort cfv chjcl cB choccl sylan2 sylan2 anassrs cA cB cort
      cfv chj co cS cfv normge0 syl jca cS chst wcel cA cch wcel cB cch wcel cA
      cB cort cfv chj co cS cfv cno cfv c1 cle wbr cS chst wcel cA cB cort cfv
      chj co cch wcel cA cB cort cfv chj co cS cfv cno cfv c1 cle wbr cA cch
      wcel cB cch wcel wa cA cB cort cfv chj co cS hstle1 cA cch wcel cB cort
      cfv cch wcel cA cB cort cfv chj co cch wcel cB cch wcel cA cB cort cfv
      chjcl cB choccl sylan2 sylan2 anassrs sylanc sq1 syl6breq adantrr
      eqbrtrrd cS chst wcel cA cch wcel wa cB cch wcel cA cS cfv cno cfv c2
      cexp co cB cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cle wbr cB cS
      cfv cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv
      cno cfv c2 cexp co caddc co caddc co cB cS cfv cno cfv c2 cexp co c1
      caddc co cle wbr wb cA cB wss cA cS cfv cno cfv c2 cexp co cB cort cfv cS
      cfv cno cfv c2 cexp co caddc co cr wcel cB cS cfv cno cfv c2 cexp co cr
      wcel cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2 cexp co
      caddc co c1 cle wbr cB cS cfv cno cfv c2 cexp co cA cS cfv cno cfv c2
      cexp co cB cort cfv cS cfv cno cfv c2 cexp co caddc co caddc co cB cS cfv
      cno cfv c2 cexp co c1 caddc co cle wbr wb cS chst wcel cA cch wcel wa cB
      cch wcel wa cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2
      cexp co caddc co cr wcel c1 cr wcel cB cS cfv cno cfv c2 cexp co cr wcel
      cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2 cexp co caddc
      co c1 cle wbr cB cS cfv cno cfv c2 cexp co cA cS cfv cno cfv c2 cexp co
      cB cort cfv cS cfv cno cfv c2 cexp co caddc co caddc co cB cS cfv cno cfv
      c2 cexp co c1 caddc co cle wbr wb 1re cA cS cfv cno cfv c2 cexp co cB
      cort cfv cS cfv cno cfv c2 cexp co caddc co c1 cB cS cfv cno cfv c2 cexp
      co leadd2 mp3an2 cA cS cfv cno cfv c2 cexp co cr wcel cB cort cfv cS cfv
      cno cfv c2 cexp co cr wcel cA cS cfv cno cfv c2 cexp co cB cort cfv cS
      cfv cno cfv c2 cexp co caddc co cr wcel cS chst wcel cA cch wcel wa cB
      cch wcel wa cA cS cfv cno cfv c2 cexp co cB cort cfv cS cfv cno cfv c2
      cexp co readdcl cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co
      cr wcel cB cch wcel cS chst wcel cA cch wcel wa cA cS cfv cno cfv cr wcel
      cA cS cfv cno cfv c2 cexp co cr wcel cS chst wcel cA cch wcel wa cA cS
      cfv chil wcel cA cS cfv cno cfv cr wcel cA cS hstcl cA cS cfv normcl syl
      cA cS cfv cno cfv resqcl syl adantr cS chst wcel cB cch wcel cB cort cfv
      cS cfv cno cfv c2 cexp co cr wcel cA cch wcel cS chst wcel cB cch wcel wa
      cB cort cfv cS cfv cno cfv cr wcel cB cort cfv cS cfv cno cfv c2 cexp co
      cr wcel cS chst wcel cB cch wcel wa cB cort cfv cS cfv chil wcel cB cort
      cfv cS cfv cno cfv cr wcel cS chst wcel cB cort cfv cch wcel cB cort cfv
      cS cfv chil wcel cB cch wcel cB cort cfv cS hstcl cB choccl sylan2 cB
      cort cfv cS cfv normcl syl cB cort cfv cS cfv cno cfv resqcl syl adantlr
      sylanc cS chst wcel cB cch wcel cB cS cfv cno cfv c2 cexp co cr wcel cA
      cch wcel cS chst wcel cB cch wcel wa cB cS cfv cno cfv cr wcel cB cS cfv
      cno cfv c2 cexp co cr wcel cS chst wcel cB cch wcel wa cB cS cfv chil
      wcel cB cS cfv cno cfv cr wcel cB cS hstcl cB cS cfv normcl syl cB cS cfv
      cno cfv resqcl syl adantlr sylanc adantrr mpbid eqbrtrd cS chst wcel cA
      cch wcel wa cB cch wcel cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv c2
      cexp co cle wbr cA cS cfv cno cfv c2 cexp co c1 caddc co cB cS cfv cno
      cfv c2 cexp co c1 caddc co cle wbr wb cA cB wss cA cS cfv cno cfv c2 cexp
      co cr wcel cB cS cfv cno cfv c2 cexp co cr wcel cA cS cfv cno cfv c2 cexp
      co cB cS cfv cno cfv c2 cexp co cle wbr cA cS cfv cno cfv c2 cexp co c1
      caddc co cB cS cfv cno cfv c2 cexp co c1 caddc co cle wbr wb cS chst wcel
      cA cch wcel wa cB cch wcel wa cA cS cfv cno cfv c2 cexp co cr wcel cB cS
      cfv cno cfv c2 cexp co cr wcel c1 cr wcel cA cS cfv cno cfv c2 cexp co cB
      cS cfv cno cfv c2 cexp co cle wbr cA cS cfv cno cfv c2 cexp co c1 caddc
      co cB cS cfv cno cfv c2 cexp co c1 caddc co cle wbr wb 1re cA cS cfv cno
      cfv c2 cexp co cB cS cfv cno cfv c2 cexp co c1 leadd1 mp3an3 cS chst wcel
      cA cch wcel wa cA cS cfv cno cfv c2 cexp co cr wcel cB cch wcel cS chst
      wcel cA cch wcel wa cA cS cfv cno cfv cr wcel cA cS cfv cno cfv c2 cexp
      co cr wcel cS chst wcel cA cch wcel wa cA cS cfv chil wcel cA cS cfv cno
      cfv cr wcel cA cS hstcl cA cS cfv normcl syl cA cS cfv cno cfv resqcl syl
      adantr cS chst wcel cB cch wcel cB cS cfv cno cfv c2 cexp co cr wcel cA
      cch wcel cS chst wcel cB cch wcel wa cB cS cfv cno cfv cr wcel cB cS cfv
      cno cfv c2 cexp co cr wcel cS chst wcel cB cch wcel wa cB cS cfv chil
      wcel cB cS cfv cno cfv cr wcel cB cS hstcl cB cS cfv normcl syl cB cS cfv
      cno cfv resqcl syl adantlr sylanc adantrr mpbird cS chst wcel cA cch wcel
      wa cB cch wcel cA cS cfv cno cfv cB cS cfv cno cfv cle wbr cA cS cfv cno
      cfv c2 cexp co cB cS cfv cno cfv c2 cexp co cle wbr wb cA cB wss cA cS
      cfv cno cfv cr wcel cc0 cA cS cfv cno cfv cle wbr wa cB cS cfv cno cfv cr
      wcel cc0 cB cS cfv cno cfv cle wbr wa cA cS cfv cno cfv cB cS cfv cno cfv
      cle wbr cA cS cfv cno cfv c2 cexp co cB cS cfv cno cfv c2 cexp co cle wbr
      wb cS chst wcel cA cch wcel wa cB cch wcel wa cA cS cfv cno cfv cB cS cfv
      cno cfv le2sq cS chst wcel cA cch wcel wa cA cS cfv cno cfv cr wcel cc0
      cA cS cfv cno cfv cle wbr wa cB cch wcel cS chst wcel cA cch wcel wa cA
      cS cfv cno cfv cr wcel cc0 cA cS cfv cno cfv cle wbr cS chst wcel cA cch
      wcel wa cA cS cfv chil wcel cA cS cfv cno cfv cr wcel cA cS hstcl cA cS
      cfv normcl syl cS chst wcel cA cch wcel wa cA cS cfv chil wcel cc0 cA cS
      cfv cno cfv cle wbr cA cS hstcl cA cS cfv normge0 syl jca adantr cS chst
      wcel cB cch wcel cB cS cfv cno cfv cr wcel cc0 cB cS cfv cno cfv cle wbr
      wa cA cch wcel cS chst wcel cB cch wcel wa cB cS cfv cno cfv cr wcel cc0
      cB cS cfv cno cfv cle wbr cS chst wcel cB cch wcel wa cB cS cfv chil wcel
      cB cS cfv cno cfv cr wcel cB cS hstcl cB cS cfv normcl syl cS chst wcel
      cB cch wcel wa cB cS cfv chil wcel cc0 cB cS cfv cno cfv cle wbr cB cS
      hstcl cB cS cfv normge0 syl jca adantlr sylanc adantrr mpbird $.
      $( [20-Jul-2006] $) $( [26-Jun-2006] $)

    $( Ordering property of a Hilbert-space-valued state. $)
    hstles $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH /\ A C_ B ) )
             -> ( ( normh ` ( S ` A ) ) = 1 -> ( normh ` ( S ` B ) ) = 1 ) ) $=
      cS chst wcel cA cch wcel wa cB cch wcel cA cB wss wa wa cA cS cfv cno cfv
      c1 wceq cB cS cfv cno cfv c1 cle wbr c1 cB cS cfv cno cfv cle wbr wa cB
      cS cfv cno cfv c1 wceq cS chst wcel cA cch wcel wa cB cch wcel cA cB wss
      wa wa cA cS cfv cno cfv c1 wceq c1 cB cS cfv cno cfv cle wbr cB cS cfv
      cno cfv c1 cle wbr cS chst wcel cA cch wcel wa cB cch wcel cA cB wss wa
      wa cA cS cfv cno cfv c1 wceq c1 cB cS cfv cno cfv cle wbr cS chst wcel cA
      cch wcel wa cB cch wcel cA cB wss wa wa cA cS cfv cno cfv c1 wceq wa cA
      cS cfv cno cfv c1 cB cS cfv cno cfv cle cS chst wcel cA cch wcel wa cB
      cch wcel cA cB wss wa wa cA cS cfv cno cfv c1 wceq pm3.27 cS chst wcel cA
      cch wcel wa cB cch wcel cA cB wss wa wa cA cS cfv cno cfv cB cS cfv cno
      cfv cle wbr cA cS cfv cno cfv c1 wceq cA cB cS hstle adantr eqbrtrrd ex
      cS chst wcel cB cch wcel cB cS cfv cno cfv c1 cle wbr cA cch wcel cA cB
      wss cB cS hstle1 ad2ant2r jctild cS chst wcel cB cch wcel cB cS cfv cno
      cfv c1 wceq cB cS cfv cno cfv c1 cle wbr c1 cB cS cfv cno cfv cle wbr wa
      wb cA cch wcel cA cB wss cS chst wcel cB cch wcel wa cB cS cfv chil wcel
      cB cS cfv cno cfv cr wcel cB cS cfv cno cfv c1 wceq cB cS cfv cno cfv c1
      cle wbr c1 cB cS cfv cno cfv cle wbr wa wb cB cS hstcl cB cS cfv normcl
      cB cS cfv cno cfv cr wcel c1 cr wcel cB cS cfv cno cfv c1 wceq cB cS cfv
      cno cfv c1 cle wbr c1 cB cS cfv cno cfv cle wbr wa wb 1re cB cS cfv cno
      cfv c1 letri3 mpan2 3syl ad2ant2r sylibrd $.
      $( [22-Jul-2006] $) $( [30-Jun-2006] $)

    $( A Hilbert-space-valued state orthogonal to the state of the lattice unit
       is zero. $)
    hstoh $p |- ( ( S e. CHStates /\ A e. CH /\ ( ( S ` A ) .ih ( S ` ~H ) ) =
                  0 ) -> ( S ` A ) = 0h ) $=
      cS chst wcel cA cch wcel cA cS cfv chil cS cfv csp co cc0 wceq w3a cA cS
      cfv cno cfv cc0 wceq cA cS cfv c0v wceq cS chst wcel cA cch wcel cA cS
      cfv chil cS cfv csp co cc0 wceq w3a cA cS cfv cno cfv c2 cexp co cc0 wceq
      cA cS cfv cno cfv cc0 wceq cS chst wcel cA cch wcel cA cS cfv chil cS cfv
      csp co cc0 wceq cA cS cfv cno cfv c2 cexp co cc0 wceq cS chst wcel cA cch
      wcel wa cA cS cfv chil cS cfv csp co cc0 wceq cA cS cfv cno cfv c2 cexp
      co cA cS cfv chil cS cfv csp co cc0 cS chst wcel cA cch wcel wa cA cS cfv
      cno cfv c2 cexp co cA cS cfv cA cS cfv cA cort cfv cS cfv cva co csp co
      cA cS cfv chil cS cfv csp co cS chst wcel cA cch wcel wa cA cS cfv cA cS
      cfv cA cort cfv cS cfv cva co csp co cA cS cfv cA cS cfv csp co cA cS cfv
      cA cort cfv cS cfv csp co caddc co cA cS cfv cno cfv c2 cexp co cc0 caddc
      co cA cS cfv cno cfv c2 cexp co cA cS cfv chil wcel cA cS cfv chil wcel
      cA cort cfv cS cfv chil wcel cA cS cfv cA cS cfv cA cort cfv cS cfv cva
      co csp co cA cS cfv cA cS cfv csp co cA cS cfv cA cort cfv cS cfv csp co
      caddc co wceq cS chst wcel cA cch wcel wa cA cS cfv cA cS cfv cA cort cfv
      cS cfv his7 cA cS hstcl cA cS hstcl cS chst wcel cA cort cfv cch wcel cA
      cort cfv cS cfv chil wcel cA cch wcel cA cort cfv cS hstcl cA choccl
      sylan2 syl3anc cS chst wcel cA cch wcel wa cA cS cfv cA cS cfv csp co cA
      cS cfv cno cfv c2 cexp co cA cS cfv cA cort cfv cS cfv csp co cc0 caddc
      cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co cA cS cfv cA cS
      cfv csp co cS chst wcel cA cch wcel wa cA cS cfv chil wcel cA cS cfv cno
      cfv c2 cexp co cA cS cfv cA cS cfv csp co wceq cA cS hstcl cA cS cfv
      normsq syl eqcomd cS chst wcel cA cch wcel wa cA cort cfv cch wcel cA cA
      cort cfv cort cfv wss wa cA cS cfv cA cort cfv cS cfv csp co cc0 wceq cA
      cch wcel cA cort cfv cch wcel cA cA cort cfv cort cfv wss wa cS chst wcel
      cA cch wcel cA cort cfv cch wcel cA cA cort cfv cort cfv wss cA choccl cA
      cch wcel cA cort cfv cort cfv cA wceq cA cA cort cfv cort cfv wss cA ococ
      cA cA cort cfv cort cfv eqimss2 syl jca adantl cA cA cort cfv cS hstorth
      mpdan opreq12d cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co
      cc wcel cA cS cfv cno cfv c2 cexp co cc0 caddc co cA cS cfv cno cfv c2
      cexp co wceq cS chst wcel cA cch wcel wa cA cS cfv cno cfv c2 cexp co cS
      chst wcel cA cch wcel wa cA cS cfv cno cfv cr wcel cA cS cfv cno cfv c2
      cexp co cr wcel cS chst wcel cA cch wcel wa cA cS cfv chil wcel cA cS cfv
      cno cfv cr wcel cA cS hstcl cA cS cfv normcl syl cA cS cfv cno cfv resqcl
      syl recnd cA cS cfv cno cfv c2 cexp co addid1 syl 3eqtrrd cS chst wcel cA
      cch wcel wa cA cS cfv cA cort cfv cS cfv cva co chil cS cfv cA cS cfv csp
      cA cS hstoc opreq2d eqtrd cA cS cfv chil cS cfv csp co cc0 wceq id
      sylan9eq 3impa cS chst wcel cA cch wcel cA cS cfv cno cfv c2 cexp co cc0
      wceq cA cS cfv cno cfv cc0 wceq wb cA cS cfv chil cS cfv csp co cc0 wceq
      cS chst wcel cA cch wcel wa cA cS cfv cno cfv cc wcel cA cS cfv cno cfv
      c2 cexp co cc0 wceq cA cS cfv cno cfv cc0 wceq wb cS chst wcel cA cch
      wcel wa cA cS cfv cno cfv cS chst wcel cA cch wcel wa cA cS cfv chil wcel
      cA cS cfv cno cfv cr wcel cA cS hstcl cA cS cfv normcl syl recnd cA cS
      cfv cno cfv sqeq0 syl 3adant3 mpbid cS chst wcel cA cch wcel cA cS cfv
      cno cfv cc0 wceq cA cS cfv c0v wceq wb cA cS cfv chil cS cfv csp co cc0
      wceq cA cS hst0h 3adant3 mpbid $.
      $( [22-Jul-2006] $) $( [25-Jun-2006] $)

    $( A Hilbert-space-valued state is zero at the zero subspace. $)
    hst0 $p |- ( S e. CHStates -> ( S ` 0H ) = 0h ) $=
      cS chst wcel c0h cS cfv chil cS cfv csp co cc0 wceq c0h cS cfv c0v wceq
      cS chst wcel c0h cch wcel c0h cS cfv chil cS cfv csp co cc0 wceq h0elch
      cS chst wcel c0h cch wcel wa chil cch wcel c0h chil cort cfv wss c0h cS
      cfv chil cS cfv csp co cc0 wceq helch chil cort cfv chil chil ssid occli
      ch0lei c0h chil cS hstorth mpanr12 mpan2 cS chst wcel c0h cch wcel c0h cS
      cfv chil cS cfv csp co cc0 wceq c0h cS cfv c0v wceq h0elch c0h cS hstoh
      mp3an2 mpdan $.
      $( [1-Dec-2006] $) $( [30-Jun-2006] $)

    $( The value of a state at the full Hilbert space. $)
    sthil $p |- ( S e. States -> ( S ` ~H ) = 1 ) $=
      cS cst wcel chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy cv chj
      co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vy cch wral vx cch
      wral cS cst wcel cch cr cS wf cc0 vx cv cS cfv cle wbr vx cv cS cfv c1
      cle wbr wa vx cch wral wa chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx
      cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vy cch
      wral vx cch wral wa vx vy cS stel pm3.27bi pm3.26d $.
      $( [23-Oct-1999] $)

    $( The value of a state on a join. $)
    stj $p |- ( S e. States ->
         ( ( ( A e. CH /\ B e. CH ) /\ A C_ ( _|_ ` B ) ) ->
         ( S ` ( A vH B ) ) = ( ( S ` A ) + ( S ` B ) ) ) ) $=
      cS cst wcel cA cch wcel cB cch wcel wa cA cB cort cfv wss cA cB chj co cS
      cfv cA cS cfv cB cS cfv caddc co wceq cA cch wcel cB cch wcel wa vx cv vy
      cv cort cfv wss vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc
      co wceq wi vy cch wral vx cch wral cA cB cort cfv wss cA cB chj co cS cfv
      cA cS cfv cB cS cfv caddc co wceq wi cS cst wcel vx cv vy cv cort cfv wss
      vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi cA
      cB cort cfv wss cA cB chj co cS cfv cA cS cfv cB cS cfv caddc co wceq wi
      cA vy cv cort cfv wss cA vy cv chj co cS cfv cA cS cfv vy cv cS cfv caddc
      co wceq wi vx vy cA cB cch cch vx cv cA wceq vx cv vy cv cort cfv wss cA
      vy cv cort cfv wss vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv
      caddc co wceq cA vy cv chj co cS cfv cA cS cfv vy cv cS cfv caddc co wceq
      vx cv cA vy cv cort cfv sseq1 vx cv cA wceq vx cv vy cv chj co cS cfv cA
      vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co cA cS cfv vy cv cS
      cfv caddc co vx cv cA wceq vx cv vy cv chj co cA vy cv chj co cS vx cv cA
      vy cv chj opreq1 fveq2d vx cv cA wceq vx cv cS cfv cA cS cfv vy cv cS cfv
      caddc vx cv cA cS fveq2 opreq1d eqeq12d imbi12d vy cv cB wceq cA vy cv
      cort cfv wss cA cB cort cfv wss cA vy cv chj co cS cfv cA cS cfv vy cv cS
      cfv caddc co wceq cA cB chj co cS cfv cA cS cfv cB cS cfv caddc co wceq
      vy cv cB wceq vy cv cort cfv cB cort cfv cA vy cv cB cort fveq2 sseq2d vy
      cv cB wceq cA vy cv chj co cS cfv cA cB chj co cS cfv cA cS cfv vy cv cS
      cfv caddc co cA cS cfv cB cS cfv caddc co vy cv cB wceq cA vy cv chj co
      cA cB chj co cS vy cv cB cA chj opreq2 fveq2d vy cv cB wceq vy cv cS cfv
      cB cS cfv cA cS cfv caddc vy cv cB cS fveq2 opreq2d eqeq12d imbi12d
      rcla42v cS cst wcel chil cS cfv c1 wceq vx cv vy cv cort cfv wss vx cv vy
      cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi vy cch wral
      vx cch wral cS cst wcel cch cr cS wf cc0 vx cv cS cfv cle wbr vx cv cS
      cfv c1 cle wbr wa vx cch wral wa chil cS cfv c1 wceq vx cv vy cv cort cfv
      wss vx cv vy cv chj co cS cfv vx cv cS cfv vy cv cS cfv caddc co wceq wi
      vy cch wral vx cch wral wa vx vy cS stel pm3.27bi pm3.27d syl5com imp3a
      $.
      $( [23-Oct-1999] $)
  $}

  ${
    sto1.1 $e |- A e. CH $.
    $( The state of a subspace plus the state of its orthocomplement. $)
    sto1i $p |- ( S e. States -> ( ( S ` A ) + ( S ` ( _|_ ` A ) ) ) = 1 ) $=
      cS cst wcel cA cA cort cfv chj co cS cfv cA cS cfv cA cort cfv cS cfv
      caddc co c1 cS cst wcel cA cch wcel cA cort cfv cch wcel wa cA cA cort
      cfv cort cfv wss cA cA cort cfv chj co cS cfv cA cS cfv cA cort cfv cS
      cfv caddc co wceq cA cch wcel cA cort cfv cch wcel sto1.1 cA sto1.1
      choccli pm3.2i cA csh wcel cA cA cort cfv cort cfv wss cA sto1.1 chshii
      cA shococss ax-mp cA cA cort cfv cS stj mp2ani cS cst wcel chil cS cfv c1
      cA cA cort cfv chj co cS cfv cS sthil cA cA cort cfv chj co chil cS cA
      sto1.1 chjoi fveq2i syl5eq eqtr3d $.
      $( [24-Oct-1999] $)

    $( The state of the orthocomplement. $)
    sto2i $p |- ( S e. States ->
               ( S ` ( _|_ ` A ) ) = ( 1 - ( S ` A ) ) ) $=
      cS cst wcel c1 cA cS cfv cmin co cA cort cfv cS cfv cS cst wcel c1 cA cS
      cfv cmin co cA cort cfv cS cfv wceq cA cS cfv cA cort cfv cS cfv caddc co
      c1 wceq cA cS sto1.1 sto1i cA cS cfv cc wcel cA cort cfv cS cfv cc wcel
      c1 cA cS cfv cmin co cA cort cfv cS cfv wceq cA cS cfv cA cort cfv cS cfv
      caddc co c1 wceq wb cS cst wcel c1 cc wcel cA cS cfv cc wcel cA cort cfv
      cS cfv cc wcel c1 cA cS cfv cmin co cA cort cfv cS cfv wceq cA cS cfv cA
      cort cfv cS cfv caddc co c1 wceq wb ax1cn c1 cA cS cfv cA cort cfv cS cfv
      subadd mp3an1 cS cst wcel cA cS cfv cS cst wcel cA cch wcel cA cS cfv cr
      wcel sto1.1 cA cS stcl mpi recnd cS cst wcel cA cort cfv cS cfv cS cst
      wcel cA cort cfv cch wcel cA cort cfv cS cfv cr wcel cA sto1.1 choccli cA
      cort cfv cS stcl mpi recnd sylanc mpbird eqcomd $.
      $( [24-Oct-1999] $)

    $( If a state is greater than or equal to 1, it is 1. $)
    stge1i $p |- ( S e. States ->
                ( 1 <_ ( S ` A ) <-> ( S ` A ) = 1 ) ) $=
      cS cst wcel c1 cA cS cfv cle wbr cA cS cfv c1 wceq cS cst wcel c1 cA cS
      cfv cle wbr cA cS cfv c1 cle wbr c1 cA cS cfv cle wbr wa cA cS cfv c1
      wceq cS cst wcel c1 cA cS cfv cle wbr cA cS cfv c1 cle wbr c1 cA cS cfv
      cle wbr wa cS cst wcel cA cS cfv c1 cle wbr c1 cA cS cfv cle wbr cS cst
      wcel cA cch wcel cA cS cfv c1 cle wbr sto1.1 cA cS stle1 mpi anim1i ex cS
      cst wcel cA cS cfv cr wcel c1 cr wcel wa cA cS cfv c1 wceq cA cS cfv c1
      cle wbr c1 cA cS cfv cle wbr wa wb cS cst wcel cA cS cfv cr wcel c1 cr
      wcel cS cst wcel cA cch wcel cA cS cfv cr wcel sto1.1 cA cS stcl mpi 1re
      jctir cA cS cfv c1 letri3 syl sylibrd cA cS cfv c1 wceq c1 cA cS cfv cle
      wbr c1 c1 cle wbr c1 1re leidi cA cS cfv c1 c1 cle breq2 mpbiri impbid1
      $.
      $( [11-Nov-1999] $)

    $( If a state is less than or equal to 0, it is 0. $)
    stle0i $p |- ( S e. States ->
                ( ( S ` A ) <_ 0 <-> ( S ` A ) = 0 ) ) $=
      cS cst wcel cA cS cfv cc0 cle wbr cA cS cfv cc0 wceq cS cst wcel cA cS
      cfv cc0 cle wbr cA cS cfv cc0 cle wbr cc0 cA cS cfv cle wbr wa cA cS cfv
      cc0 wceq cA cS cfv cc0 cle wbr cS cst wcel cA cS cfv cc0 cle wbr cc0 cA
      cS cfv cle wbr wa cS cst wcel cc0 cA cS cfv cle wbr cA cS cfv cc0 cle wbr
      cS cst wcel cA cch wcel cc0 cA cS cfv cle wbr sto1.1 cA cS stge0 mpi
      anim2i expcom cS cst wcel cA cS cfv cr wcel cc0 cr wcel wa cA cS cfv cc0
      wceq cA cS cfv cc0 cle wbr cc0 cA cS cfv cle wbr wa wb cS cst wcel cA cS
      cfv cr wcel cc0 cr wcel cS cst wcel cA cch wcel cA cS cfv cr wcel sto1.1
      cA cS stcl mpi 0re jctir cA cS cfv cc0 letri3 syl sylibrd cA cS cfv cc0
      wceq cA cS cfv cc0 cle wbr cc0 cc0 cle wbr cc0 0re leidi cA cS cfv cc0
      cc0 cle breq1 mpbiri impbid1 $.
      $( [11-Nov-1999] $)
  $}

  ${
    stle.1 $e |- A e. CH $.
    stle.2 $e |- B e. CH $.
    $( Ordering law for states. $)
    stlei $p |- ( S e. States -> ( A C_ B -> ( S ` A ) <_ ( S ` B ) ) ) $=
      cS cst wcel cA cB wss cA cS cfv cB cS cfv cle wbr cS cst wcel cA cB wss
      wa cA cS cfv cB cS cfv cle wbr cA cS cfv cB cort cfv cS cfv caddc co cB
      cS cfv cB cort cfv cS cfv caddc co cle wbr cS cst wcel cA cB wss wa cA cB
      cort cfv chj co cS cfv cA cS cfv cB cort cfv cS cfv caddc co cB cS cfv cB
      cort cfv cS cfv caddc co cle cS cst wcel cA cB wss cA cB cort cfv chj co
      cS cfv cA cS cfv cB cort cfv cS cfv caddc co wceq cS cst wcel cA cch wcel
      cB cort cfv cch wcel wa cA cB cort cfv cort cfv wss wa cA cB cort cfv chj
      co cS cfv cA cS cfv cB cort cfv cS cfv caddc co wceq cA cB wss cA cB cort
      cfv cS stj cA cB wss cA cB cort cfv cort cfv wss cA cch wcel cB cort cfv
      cch wcel wa cA cB wss cB cB cort cfv cort cfv wss cA cB cort cfv cort cfv
      wss cB csh wcel cB cB cort cfv cort cfv wss cB stle.2 chshii cB shococss
      ax-mp cA cB cB cort cfv cort cfv sstr2 mpi cA cch wcel cB cort cfv cch
      wcel stle.1 cB stle.2 choccli pm3.2i jctil syl5 imp cS cst wcel cA cB
      cort cfv chj co cS cfv cB cS cfv cB cort cfv cS cfv caddc co cle wbr cA
      cB wss cS cst wcel cA cB cort cfv chj co cS cfv c1 cB cS cfv cB cort cfv
      cS cfv caddc co cle cS cst wcel cA cB cort cfv chj co cch wcel cA cB cort
      cfv chj co cS cfv c1 cle wbr cA cB cort cfv stle.1 cB stle.2 choccli
      chjcli cA cB cort cfv chj co cS stle1 mpi cB cS stle.2 sto1i breqtrrd
      adantr eqbrtrrd cS cst wcel cA cB wss wa cA cS cfv cr wcel cB cS cfv cr
      wcel cB cort cfv cS cfv cr wcel w3a cA cS cfv cB cS cfv cle wbr cA cS cfv
      cB cort cfv cS cfv caddc co cB cS cfv cB cort cfv cS cfv caddc co cle wbr
      wb cS cst wcel cA cS cfv cr wcel cB cS cfv cr wcel cB cort cfv cS cfv cr
      wcel w3a cA cB wss cS cst wcel cA cS cfv cr wcel cB cS cfv cr wcel cB
      cort cfv cS cfv cr wcel cS cst wcel cA cch wcel cA cS cfv cr wcel stle.1
      cA cS stcl mpi cS cst wcel cB cch wcel cB cS cfv cr wcel stle.2 cB cS
      stcl mpi cS cst wcel cB cort cfv cch wcel cB cort cfv cS cfv cr wcel cB
      stle.2 choccli cB cort cfv cS stcl mpi 3jca adantr cA cS cfv cB cS cfv cB
      cort cfv cS cfv leadd1 syl mpbird ex $.
      $( [24-Oct-1999] $)

    $( Ordering law for states. $)
    stlesi $p |- ( S e. States ->
                ( A C_ B -> ( ( S ` A ) = 1 -> ( S ` B ) = 1 ) ) ) $=
      cS cst wcel cA cB wss cA cS cfv c1 wceq cB cS cfv c1 wceq cS cst wcel cA
      cB wss cA cS cfv c1 wceq wa wa cB cS cfv c1 wceq cB cS cfv c1 cle wbr c1
      cB cS cfv cle wbr wa cS cst wcel cA cB wss cA cS cfv c1 wceq wa wa cB cS
      cfv c1 cle wbr c1 cB cS cfv cle wbr cS cst wcel cB cS cfv c1 cle wbr cA
      cB wss cA cS cfv c1 wceq wa cS cst wcel cB cch wcel cB cS cfv c1 cle wbr
      stle.2 cB cS stle1 mpi adantr cS cst wcel cA cB wss cA cS cfv c1 wceq wa
      wa cA cS cfv cB cS cfv cle wbr c1 cB cS cfv cle wbr cS cst wcel cA cB wss
      cA cS cfv cB cS cfv cle wbr cA cS cfv c1 wceq cS cst wcel cA cB wss cA cS
      cfv cB cS cfv cle wbr cA cB cS stle.1 stle.2 stlei imp adantrr cA cS cfv
      c1 wceq cA cS cfv cB cS cfv cle wbr c1 cB cS cfv cle wbr wb cS cst wcel
      cA cB wss cA cS cfv c1 cB cS cfv cle breq1 ad2antll mpbid jca cS cst wcel
      cA cB wss cA cS cfv c1 wceq wa wa cB cS cfv cr wcel c1 cr wcel wa cB cS
      cfv c1 wceq cB cS cfv c1 cle wbr c1 cB cS cfv cle wbr wa wb cS cst wcel
      cB cS cfv cr wcel c1 cr wcel wa cA cB wss cA cS cfv c1 wceq wa cS cst
      wcel cB cS cfv cr wcel c1 cr wcel cS cst wcel cB cch wcel cB cS cfv cr
      wcel stle.2 cB cS stcl mpi 1re jctir adantr cB cS cfv c1 letri3 syl
      mpbird exp32 $.
      $( [24-Oct-1999] $)

    $( Join of components of Sasaki arrow ->1. $)
    stji1i $p |- ( S e. States -> ( S ` ( ( _|_ ` A ) vH ( A i^i B ) ) ) =
         ( ( S ` ( _|_ ` A ) ) + ( S ` ( A i^i B ) ) ) ) $=
      cS cst wcel cA cort cfv cch wcel cA cB cin cch wcel wa cA cort cfv cA cB
      cin cort cfv wss cA cort cfv cA cB cin chj co cS cfv cA cort cfv cS cfv
      cA cB cin cS cfv caddc co wceq cA cort cfv cch wcel cA cB cin cch wcel cA
      stle.1 choccli cA cB stle.1 stle.2 chincli pm3.2i cA cB cin cA wss cA
      cort cfv cA cB cin cort cfv wss cA cB inss1 cA cB cin cA cA cB stle.1
      stle.2 chincli stle.1 chsscon3i mpbi cA cort cfv cA cB cin cS stj mp2ani
      $.
      $( [24-Oct-1999] $)

    $( State of component of unit meet. $)
    stm1i $p |- ( S e. States ->
               ( ( S ` ( A i^i B ) ) = 1 -> ( S ` A ) = 1 ) ) $=
      cS cst wcel cA cB cin cS cfv c1 wceq c1 cA cS cfv cle wbr cA cS cfv c1
      wceq cA cB cin cS cfv c1 wceq cA cB cin cS cfv cA cS cfv cle wbr c1 cA cS
      cfv cle wbr cS cst wcel cA cB cin cS cfv c1 cA cS cfv cle breq1 cS cst
      wcel cA cB cin cA wss cA cB cin cS cfv cA cS cfv cle wbr cA cB inss1 cA
      cB cin cA cS cA cB stle.1 stle.2 chincli stle.1 stlei mpi syl5cbi cA cS
      stle.1 stge1i sylibd $.
      $( [11-Nov-1999] $)

    $( State of component of unit meet. $)
    stm1ri $p |- ( S e. States ->
               ( ( S ` ( A i^i B ) ) = 1 -> ( S ` B ) = 1 ) ) $=
      cS cst wcel cB cA cin cS cfv c1 wceq cB cS cfv c1 wceq cA cB cin cS cfv
      c1 wceq cB cA cS stle.2 stle.1 stm1i cA cB cin cS cfv cB cA cin cS cfv c1
      cA cB cin cB cA cin cS cA cB incom fveq2i eqeq1i syl5ib $.
      $( [11-Nov-1999] $)

    $( Sum of states whose meet is 1. $)
    stm1addi $p |- ( S e. States -> ( ( S ` ( A i^i B ) ) = 1 ->
                  ( ( S ` A ) + ( S ` B ) ) = 2 ) ) $=
      cS cst wcel cA cB cin cS cfv c1 wceq cA cS cfv c1 wceq cB cS cfv c1 wceq
      wa cA cS cfv cB cS cfv caddc co c2 wceq cS cst wcel cA cB cin cS cfv c1
      wceq cA cS cfv c1 wceq cB cS cfv c1 wceq cA cB cS stle.1 stle.2 stm1i cA
      cB cS stle.1 stle.2 stm1ri jcad cA cS cfv c1 wceq cB cS cfv c1 wceq wa cA
      cS cfv cB cS cfv caddc co c1 c1 caddc co c2 cA cS cfv c1 cB cS cfv c1
      caddc opreq12 df-2 syl6eqr syl6 $.
      $( [11-Nov-1999] $)

    $( If the sum of 2 states is 2, then each state is 1. $)

    staddi $p |- ( S e. States -> ( ( ( S ` A ) + ( S ` B ) ) = 2 ->
                ( S ` A ) = 1 ) ) $=
      cS cst wcel cA cS cfv cB cS cfv caddc co c2 wceq cA cS cfv cB cS cfv
      caddc co c2 clt wbr wn cA cS cfv c1 clt wbr wn cA cS cfv c1 wceq cS cst
      wcel cA cS cfv cB cS cfv caddc co c2 clt wbr cA cS cfv cB cS cfv caddc co
      c2 cS cst wcel cA cS cfv cB cS cfv caddc co c2 clt wbr cA cS cfv cB cS
      cfv caddc co c2 wne cA cS cfv cB cS cfv caddc co cr wcel cA cS cfv cB cS
      cfv caddc co c2 clt wbr cA cS cfv cB cS cfv caddc co c2 wne cS cst wcel
      cA cS cfv cB cS cfv caddc co cr wcel cA cS cfv cB cS cfv caddc co c2 clt
      wbr wa c2 cA cS cfv cB cS cfv caddc co cA cS cfv cB cS cfv caddc co cr
      wcel c2 cr wcel cA cS cfv cB cS cfv caddc co c2 clt wbr c2 cA cS cfv cB
      cS cfv caddc co wne 2re cA cS cfv cB cS cfv caddc co c2 ltne mp3an2
      necomd cA cS cfv cr wcel cB cS cfv cr wcel cA cS cfv cB cS cfv caddc co
      cr wcel cS cst wcel cA cS cfv cB cS cfv readdcl cS cst wcel cA cch wcel
      cA cS cfv cr wcel stle.1 cA cS stcl mpi cS cst wcel cB cch wcel cB cS cfv
      cr wcel stle.2 cB cS stcl mpi sylanc sylan ex necon2bd cS cst wcel cA cS
      cfv c1 clt wbr cA cS cfv cB cS cfv caddc co c2 clt wbr cS cst wcel cA cS
      cfv c1 clt wbr cA cS cfv cB cS cfv caddc co c2 clt wbr cS cst wcel cA cS
      cfv c1 clt wbr wa cA cS cfv cB cS cfv caddc co c1 c1 caddc co c2 clt cS
      cst wcel cA cS cfv c1 clt wbr wa cA cS cfv cB cS cfv caddc co cA cS cfv
      c1 caddc co cle wbr cA cS cfv c1 caddc co c1 c1 caddc co clt wbr cA cS
      cfv cB cS cfv caddc co c1 c1 caddc co clt wbr cS cst wcel cA cS cfv cB cS
      cfv caddc co cA cS cfv c1 caddc co cle wbr cA cS cfv c1 clt wbr cS cst
      wcel cB cS cfv c1 cle wbr cA cS cfv cB cS cfv caddc co cA cS cfv c1 caddc
      co cle wbr cS cst wcel cB cch wcel cB cS cfv c1 cle wbr stle.2 cB cS
      stle1 mpi cB cS cfv cr wcel c1 cr wcel cA cS cfv cr wcel cB cS cfv c1 cle
      wbr cA cS cfv cB cS cfv caddc co cA cS cfv c1 caddc co cle wbr wb cS cst
      wcel cB cS cfv c1 cA cS cfv leadd2 cS cst wcel cB cch wcel cB cS cfv cr
      wcel stle.2 cB cS stcl mpi c1 cr wcel cS cst wcel 1re a1i cS cst wcel cA
      cch wcel cA cS cfv cr wcel stle.1 cA cS stcl mpi syl3anc mpbid adantr cS
      cst wcel cA cS cfv c1 clt wbr cA cS cfv c1 caddc co c1 c1 caddc co clt
      wbr cA cS cfv cr wcel c1 cr wcel c1 cr wcel cA cS cfv c1 clt wbr cA cS
      cfv c1 caddc co c1 c1 caddc co clt wbr wi cS cst wcel cA cS cfv cr wcel
      c1 cr wcel c1 cr wcel w3a cA cS cfv c1 clt wbr cA cS cfv c1 caddc co c1
      c1 caddc co clt wbr cA cS cfv c1 c1 ltadd1 biimpd cS cst wcel cA cch wcel
      cA cS cfv cr wcel stle.1 cA cS stcl mpi c1 cr wcel cS cst wcel 1re a1i c1
      cr wcel cS cst wcel 1re a1i syl3anc imp cS cst wcel cA cS cfv cB cS cfv
      caddc co cA cS cfv c1 caddc co cle wbr cA cS cfv c1 caddc co c1 c1 caddc
      co clt wbr wa cA cS cfv cB cS cfv caddc co c1 c1 caddc co clt wbr wi cA
      cS cfv c1 clt wbr cA cS cfv cB cS cfv caddc co cr wcel cA cS cfv c1 caddc
      co cr wcel c1 c1 caddc co cr wcel cA cS cfv cB cS cfv caddc co cA cS cfv
      c1 caddc co cle wbr cA cS cfv c1 caddc co c1 c1 caddc co clt wbr wa cA cS
      cfv cB cS cfv caddc co c1 c1 caddc co clt wbr wi cS cst wcel cA cS cfv cB
      cS cfv caddc co cA cS cfv c1 caddc co c1 c1 caddc co lelttr cA cS cfv cr
      wcel cB cS cfv cr wcel cA cS cfv cB cS cfv caddc co cr wcel cS cst wcel
      cA cS cfv cB cS cfv readdcl cS cst wcel cA cch wcel cA cS cfv cr wcel
      stle.1 cA cS stcl mpi cS cst wcel cB cch wcel cB cS cfv cr wcel stle.2 cB
      cS stcl mpi sylanc cS cst wcel cA cS cfv cr wcel c1 cr wcel wa cA cS cfv
      c1 caddc co cr wcel cS cst wcel cA cS cfv cr wcel c1 cr wcel cS cst wcel
      cA cch wcel cA cS cfv cr wcel stle.1 cA cS stcl mpi 1re jctir cA cS cfv
      c1 readdcl syl c1 c1 caddc co cr wcel cS cst wcel c1 c1 1re 1re readdcli
      a1i syl3anc adantr mp2and df-2 syl6breqr ex con3d cS cst wcel cA cS cfv
      c1 clt wbr cA cS cfv c1 wceq cS cst wcel cA cS cfv c1 cle wbr cA cS cfv
      c1 clt wbr cA cS cfv c1 wceq wo cS cst wcel cA cch wcel cA cS cfv c1 cle
      wbr stle.1 cA cS stle1 mpi cS cst wcel cA cS cfv cr wcel c1 cr wcel wa cA
      cS cfv c1 cle wbr cA cS cfv c1 clt wbr cA cS cfv c1 wceq wo wb cS cst
      wcel cA cS cfv cr wcel c1 cr wcel cS cst wcel cA cch wcel cA cS cfv cr
      wcel stle.1 cA cS stcl mpi 1re jctir cA cS cfv c1 leloe syl mpbid ord
      3syld $.
      $( [12-Nov-1999] $)

    ${
      stm1add3.3 $e |- C e. CH $.
      $( Sum of states whose meet is 1. $)
      stm1add3i $p |- ( S e. States -> ( ( S ` ( ( A i^i B ) i^i C ) ) = 1 ->
                  ( ( ( S ` A ) + ( S ` B ) ) + ( S ` C ) ) = 3 ) ) $=
        cS cst wcel cA cB cin cC cin cS cfv c1 wceq cA cS cfv cB cS cfv caddc
        co c2 wceq cC cS cfv c1 wceq wa cA cS cfv cB cS cfv caddc co cC cS cfv
        caddc co c3 wceq cS cst wcel cA cB cin cC cin cS cfv c1 wceq cA cS cfv
        cB cS cfv caddc co c2 wceq cC cS cfv c1 wceq cS cst wcel cA cB cin cC
        cin cS cfv c1 wceq cA cB cin cS cfv c1 wceq cA cS cfv cB cS cfv caddc
        co c2 wceq cA cB cin cC cS cA cB stle.1 stle.2 chincli stm1add3.3 stm1i
        cA cB cS stle.1 stle.2 stm1addi syld cA cB cin cC cS cA cB stle.1
        stle.2 chincli stm1add3.3 stm1ri jcad cA cS cfv cB cS cfv caddc co c2
        wceq cC cS cfv c1 wceq wa cA cS cfv cB cS cfv caddc co cC cS cfv caddc
        co c2 c1 caddc co c3 cA cS cfv cB cS cfv caddc co c2 cC cS cfv c1 caddc
        opreq12 df-3 syl6eqr syl6 $.
        $( [11-Nov-1999] $)

      $( MAY BE REVISED: using new ltne , an extra eqcom was needed.  Any way
         to avoid this? $)
      $( If the sum of 3 states is 3, then each state is 1. $)
      stadd3i $p |- ( S e. States ->
  ( ( ( ( S ` A ) + ( S ` B ) ) + ( S ` C ) ) = 3 -> ( S ` A ) = 1 ) ) $=
        cS cst wcel cA cS cfv cB cS cfv caddc co cC cS cfv caddc co c3 wceq cA
        cS cfv cB cS cfv cC cS cfv caddc co caddc co c3 wceq cA cS cfv c1 wceq
        cS cst wcel cA cS cfv cB cS cfv caddc co cC cS cfv caddc co cA cS cfv
        cB cS cfv cC cS cfv caddc co caddc co c3 cA cS cfv cc wcel cB cS cfv cc
        wcel cC cS cfv cc wcel cA cS cfv cB cS cfv caddc co cC cS cfv caddc co
        cA cS cfv cB cS cfv cC cS cfv caddc co caddc co wceq cS cst wcel cA cS
        cfv cB cS cfv cC cS cfv addass cS cst wcel cA cS cfv cS cst wcel cA cch
        wcel cA cS cfv cr wcel stle.1 cA cS stcl mpi recnd cS cst wcel cB cS
        cfv cS cst wcel cB cch wcel cB cS cfv cr wcel stle.2 cB cS stcl mpi
        recnd cS cst wcel cC cS cfv cS cst wcel cC cch wcel cC cS cfv cr wcel
        stm1add3.3 cC cS stcl mpi recnd syl3anc eqeq1d cS cst wcel cA cS cfv cB
        cS cfv cC cS cfv caddc co caddc co c3 wceq cA cS cfv cB cS cfv cC cS
        cfv caddc co caddc co c3 clt wbr wn cA cS cfv c1 clt wbr wn cA cS cfv
        c1 wceq cS cst wcel c3 cA cS cfv cB cS cfv cC cS cfv caddc co caddc co
        wceq cA cS cfv cB cS cfv cC cS cfv caddc co caddc co c3 clt wbr wn cA
        cS cfv cB cS cfv cC cS cfv caddc co caddc co c3 wceq cS cst wcel cA cS
        cfv cB cS cfv cC cS cfv caddc co caddc co c3 clt wbr c3 cA cS cfv cB cS
        cfv cC cS cfv caddc co caddc co cS cst wcel c3 cr wcel cA cS cfv cB cS
        cfv cC cS cfv caddc co caddc co c3 clt wbr c3 cA cS cfv cB cS cfv cC cS
        cfv caddc co caddc co wne wi 3re cS cst wcel cA cS cfv cB cS cfv cC cS
        cfv caddc co caddc co cr wcel c3 cr wcel cA cS cfv cB cS cfv cC cS cfv
        caddc co caddc co c3 clt wbr c3 cA cS cfv cB cS cfv cC cS cfv caddc co
        caddc co wne wi wi cA cS cfv cr wcel cB cS cfv cC cS cfv caddc co cr
        wcel cA cS cfv cB cS cfv cC cS cfv caddc co caddc co cr wcel cS cst
        wcel cA cS cfv cB cS cfv cC cS cfv caddc co readdcl cS cst wcel cA cch
        wcel cA cS cfv cr wcel stle.1 cA cS stcl mpi cB cS cfv cr wcel cC cS
        cfv cr wcel cB cS cfv cC cS cfv caddc co cr wcel cS cst wcel cB cS cfv
        cC cS cfv readdcl cS cst wcel cB cch wcel cB cS cfv cr wcel stle.2 cB
        cS stcl mpi cS cst wcel cC cch wcel cC cS cfv cr wcel stm1add3.3 cC cS
        stcl mpi sylanc sylanc cA cS cfv cB cS cfv cC cS cfv caddc co caddc co
        cr wcel c3 cr wcel cA cS cfv cB cS cfv cC cS cfv caddc co caddc co c3
        clt wbr c3 cA cS cfv cB cS cfv cC cS cfv caddc co caddc co wne cA cS
        cfv cB cS cfv cC cS cfv caddc co caddc co c3 ltne 3exp syl mpi necon2bd
        cA cS cfv cB cS cfv cC cS cfv caddc co caddc co c3 eqcom syl5ib cS cst
        wcel cA cS cfv c1 clt wbr cA cS cfv cB cS cfv cC cS cfv caddc co caddc
        co c3 clt wbr cS cst wcel cA cS cfv c1 clt wbr cA cS cfv cB cS cfv cC
        cS cfv caddc co caddc co c3 clt wbr cS cst wcel cA cS cfv c1 clt wbr wa
        cA cS cfv cB cS cfv cC cS cfv caddc co caddc co c1 c1 c1 caddc co caddc
        co c3 clt cS cst wcel cA cS cfv c1 clt wbr wa cA cS cfv cB cS cfv cC cS
        cfv caddc co caddc co cA cS cfv c1 c1 caddc co caddc co cle wbr cA cS
        cfv c1 c1 caddc co caddc co c1 c1 c1 caddc co caddc co clt wbr cA cS
        cfv cB cS cfv cC cS cfv caddc co caddc co c1 c1 c1 caddc co caddc co
        clt wbr cS cst wcel cA cS cfv cB cS cfv cC cS cfv caddc co caddc co cA
        cS cfv c1 c1 caddc co caddc co cle wbr cA cS cfv c1 clt wbr cS cst wcel
        cB cS cfv cC cS cfv caddc co c1 c1 caddc co cle wbr cA cS cfv cB cS cfv
        cC cS cfv caddc co caddc co cA cS cfv c1 c1 caddc co caddc co cle wbr
        cS cst wcel cB cS cfv cC cS cfv caddc co cB cS cfv c1 caddc co c1 c1
        caddc co cB cS cfv cr wcel cC cS cfv cr wcel cB cS cfv cC cS cfv caddc
        co cr wcel cS cst wcel cB cS cfv cC cS cfv readdcl cS cst wcel cB cch
        wcel cB cS cfv cr wcel stle.2 cB cS stcl mpi cS cst wcel cC cch wcel cC
        cS cfv cr wcel stm1add3.3 cC cS stcl mpi sylanc cS cst wcel cB cS cfv
        cr wcel c1 cr wcel wa cB cS cfv c1 caddc co cr wcel cS cst wcel cB cS
        cfv cr wcel c1 cr wcel cS cst wcel cB cch wcel cB cS cfv cr wcel stle.2
        cB cS stcl mpi 1re jctir cB cS cfv c1 readdcl syl c1 c1 caddc co cr
        wcel cS cst wcel c1 c1 1re 1re readdcli a1i cS cst wcel cC cS cfv c1
        cle wbr cB cS cfv cC cS cfv caddc co cB cS cfv c1 caddc co cle wbr cS
        cst wcel cC cch wcel cC cS cfv c1 cle wbr stm1add3.3 cC cS stle1 mpi cC
        cS cfv cr wcel c1 cr wcel cB cS cfv cr wcel cC cS cfv c1 cle wbr cB cS
        cfv cC cS cfv caddc co cB cS cfv c1 caddc co cle wbr wb cS cst wcel cC
        cS cfv c1 cB cS cfv leadd2 cS cst wcel cC cch wcel cC cS cfv cr wcel
        stm1add3.3 cC cS stcl mpi c1 cr wcel cS cst wcel 1re a1i cS cst wcel cB
        cch wcel cB cS cfv cr wcel stle.2 cB cS stcl mpi syl3anc mpbid cS cst
        wcel cB cS cfv c1 cle wbr cB cS cfv c1 caddc co c1 c1 caddc co cle wbr
        cS cst wcel cB cch wcel cB cS cfv c1 cle wbr stle.2 cB cS stle1 mpi cB
        cS cfv cr wcel c1 cr wcel c1 cr wcel cB cS cfv c1 cle wbr cB cS cfv c1
        caddc co c1 c1 caddc co cle wbr wb cS cst wcel cB cS cfv c1 c1 leadd1
        cS cst wcel cB cch wcel cB cS cfv cr wcel stle.2 cB cS stcl mpi c1 cr
        wcel cS cst wcel 1re a1i c1 cr wcel cS cst wcel 1re a1i syl3anc mpbid
        letrd cB cS cfv cC cS cfv caddc co cr wcel c1 c1 caddc co cr wcel cA cS
        cfv cr wcel cB cS cfv cC cS cfv caddc co c1 c1 caddc co cle wbr cA cS
        cfv cB cS cfv cC cS cfv caddc co caddc co cA cS cfv c1 c1 caddc co
        caddc co cle wbr wb cS cst wcel cB cS cfv cC cS cfv caddc co c1 c1
        caddc co cA cS cfv leadd2 cB cS cfv cr wcel cC cS cfv cr wcel cB cS cfv
        cC cS cfv caddc co cr wcel cS cst wcel cB cS cfv cC cS cfv readdcl cS
        cst wcel cB cch wcel cB cS cfv cr wcel stle.2 cB cS stcl mpi cS cst
        wcel cC cch wcel cC cS cfv cr wcel stm1add3.3 cC cS stcl mpi sylanc c1
        c1 caddc co cr wcel cS cst wcel c1 c1 1re 1re readdcli a1i cS cst wcel
        cA cch wcel cA cS cfv cr wcel stle.1 cA cS stcl mpi syl3anc mpbid
        adantr cS cst wcel cA cS cfv c1 clt wbr cA cS cfv c1 c1 caddc co caddc
        co c1 c1 c1 caddc co caddc co clt wbr cA cS cfv cr wcel c1 cr wcel c1
        c1 caddc co cr wcel cA cS cfv c1 clt wbr cA cS cfv c1 c1 caddc co caddc
        co c1 c1 c1 caddc co caddc co clt wbr wi cS cst wcel cA cS cfv cr wcel
        c1 cr wcel c1 c1 caddc co cr wcel w3a cA cS cfv c1 clt wbr cA cS cfv c1
        c1 caddc co caddc co c1 c1 c1 caddc co caddc co clt wbr cA cS cfv c1 c1
        c1 caddc co ltadd1 biimpd cS cst wcel cA cch wcel cA cS cfv cr wcel
        stle.1 cA cS stcl mpi c1 cr wcel cS cst wcel 1re a1i c1 c1 caddc co cr
        wcel cS cst wcel c1 c1 1re 1re readdcli a1i syl3anc imp cS cst wcel cA
        cS cfv cB cS cfv cC cS cfv caddc co caddc co cA cS cfv c1 c1 caddc co
        caddc co cle wbr cA cS cfv c1 c1 caddc co caddc co c1 c1 c1 caddc co
        caddc co clt wbr wa cA cS cfv cB cS cfv cC cS cfv caddc co caddc co c1
        c1 c1 caddc co caddc co clt wbr wi cA cS cfv c1 clt wbr cA cS cfv cB cS
        cfv cC cS cfv caddc co caddc co cr wcel cA cS cfv c1 c1 caddc co caddc
        co cr wcel c1 c1 c1 caddc co caddc co cr wcel cA cS cfv cB cS cfv cC cS
        cfv caddc co caddc co cA cS cfv c1 c1 caddc co caddc co cle wbr cA cS
        cfv c1 c1 caddc co caddc co c1 c1 c1 caddc co caddc co clt wbr wa cA cS
        cfv cB cS cfv cC cS cfv caddc co caddc co c1 c1 c1 caddc co caddc co
        clt wbr wi cS cst wcel cA cS cfv cB cS cfv cC cS cfv caddc co caddc co
        cA cS cfv c1 c1 caddc co caddc co c1 c1 c1 caddc co caddc co lelttr cA
        cS cfv cr wcel cB cS cfv cC cS cfv caddc co cr wcel cA cS cfv cB cS cfv
        cC cS cfv caddc co caddc co cr wcel cS cst wcel cA cS cfv cB cS cfv cC
        cS cfv caddc co readdcl cS cst wcel cA cch wcel cA cS cfv cr wcel
        stle.1 cA cS stcl mpi cB cS cfv cr wcel cC cS cfv cr wcel cB cS cfv cC
        cS cfv caddc co cr wcel cS cst wcel cB cS cfv cC cS cfv readdcl cS cst
        wcel cB cch wcel cB cS cfv cr wcel stle.2 cB cS stcl mpi cS cst wcel cC
        cch wcel cC cS cfv cr wcel stm1add3.3 cC cS stcl mpi sylanc sylanc cS
        cst wcel cA cS cfv cr wcel c1 c1 caddc co cr wcel wa cA cS cfv c1 c1
        caddc co caddc co cr wcel cS cst wcel cA cS cfv cr wcel c1 c1 caddc co
        cr wcel cS cst wcel cA cch wcel cA cS cfv cr wcel stle.1 cA cS stcl mpi
        c1 c1 1re 1re readdcli jctir cA cS cfv c1 c1 caddc co readdcl syl c1 c1
        c1 caddc co caddc co cr wcel cS cst wcel c1 c1 c1 caddc co 1re c1 c1
        1re 1re readdcli readdcli a1i syl3anc adantr mp2and c3 c2 c1 caddc co
        c1 c1 caddc co c1 caddc co c1 c1 c1 caddc co caddc co df-3 c2 c1 c1
        caddc co c1 caddc df-2 opreq1i c1 c1 c1 ax1cn ax1cn ax1cn addassi
        3eqtrri syl6breq ex con3d cS cst wcel cA cS cfv c1 clt wbr cA cS cfv c1
        wceq cS cst wcel cA cS cfv c1 cle wbr cA cS cfv c1 clt wbr cA cS cfv c1
        wceq wo cS cst wcel cA cch wcel cA cS cfv c1 cle wbr stle.1 cA cS stle1
        mpi cS cst wcel cA cS cfv cr wcel c1 cr wcel wa cA cS cfv c1 cle wbr cA
        cS cfv c1 clt wbr cA cS cfv c1 wceq wo wb cS cst wcel cA cS cfv cr wcel
        c1 cr wcel cS cst wcel cA cch wcel cA cS cfv cr wcel stle.1 cA cS stcl
        mpi 1re jctir cA cS cfv c1 leloe syl mpbid ord 3syld sylbid $.
        $( [13-Nov-1999] $)
    $}
  $}

  $( The state of the zero subspace. $)
  st0 $p |- ( S e. States -> ( S ` 0H ) = 0 ) $=
    cS cst wcel chil cort cfv cS cfv c1 c1 cmin co c0h cS cfv cc0 cS cst wcel
    chil cort cfv cS cfv c1 chil cS cfv cmin co c1 c1 cmin co chil cS helch
    sto2i cS cst wcel chil cS cfv c1 c1 cmin cS sthil opreq2d eqtrd chil cort
    cfv c0h cS choc1 fveq2i c1 ax1cn subidi 3eqtr3g $.
    $( [24-Oct-1999] $)

  ${
    $d u x A $.  $d u x B $.
    strlem1.1 $e |- A e. CH $.
    strlem1.2 $e |- B e. CH $.
    $( Lemma for strong state theorem:  if closed subspace ` A ` is not
       contained in ` B ` , there is a unit vector ` u ` in their
       difference. $)
    strlem1 $p |- ( -. A C_ B -> E. u e. ( A \ B ) ( normh ` u ) = 1 ) $=
      cA cB wss wn vx cv cA cB cdif wcel vx wex vu cv cno cfv c1 wceq vu cA cB
      cdif wrex cA cB wss wn cA cB cdif c0 wceq wn vx cv cA cB cdif wcel vx wex
      cA cB wss cA cB cdif c0 wceq cA cB ssdif0 notbii vx cA cB cdif neq0 bitri
      vx cv cA cB cdif wcel vu cv cno cfv c1 wceq vu cA cB cdif wrex vx c1 vx
      cv cno cfv cdiv co vx cv csm co cA cB cdif wcel c1 vx cv cno cfv cdiv co
      vx cv csm co cno cfv c1 wceq vu cv cno cfv c1 wceq vu cA cB cdif wrex vx
      cv cA cB cdif wcel vu cv cno cfv c1 wceq c1 vx cv cno cfv cdiv co vx cv
      csm co cno cfv c1 wceq vu c1 vx cv cno cfv cdiv co vx cv csm co cA cB
      cdif vu cv c1 vx cv cno cfv cdiv co vx cv csm co wceq vu cv cno cfv c1 vx
      cv cno cfv cdiv co vx cv csm co cno cfv c1 vu cv c1 vx cv cno cfv cdiv co
      vx cv csm co cno fveq2 eqeq1d rcla4ev vx cv cA cB cdif wcel c1 vx cv cno
      cfv cdiv co vx cv csm co cA cB cdif wcel vx cv cA cB cdif wcel vx cv cA
      wcel vx cv cB wcel wn wa c1 vx cv cno cfv cdiv co vx cv csm co cA wcel c1
      vx cv cno cfv cdiv co vx cv csm co cB wcel wn wa vx cv cA cB cdif wcel c1
      vx cv cno cfv cdiv co vx cv csm co cA cB cdif wcel vx cv cA cB cdif wcel
      vx cv cA wcel c1 vx cv cno cfv cdiv co vx cv csm co cA wcel vx cv cB wcel
      wn c1 vx cv cno cfv cdiv co vx cv csm co cB wcel wn vx cv cA cB cdif wcel
      c1 vx cv cno cfv cdiv co cc wcel vx cv cA wcel c1 vx cv cno cfv cdiv co
      vx cv csm co cA wcel wi vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co vx
      cv cno cfv cr wcel vx cv cno cfv cc0 wne c1 vx cv cno cfv cdiv co cr wcel
      vx cv cA cB cdif wcel vx cv cno cfv rereccl vx cv cA cB cdif wcel vx cv
      cA wcel vx cv chil wcel vx cv cno cfv cr wcel vx cv cA cB eldifi vx cv cA
      strlem1.1 cheli vx cv normcl 3syl vx cv cA cB cdif wcel vx cv cno cfv cc0
      wceq wn vx cv cno cfv cc0 wne vx cv cA cB cdif wcel vx cv cno cfv cc0
      wceq vx cv c0v wceq vx cv c0v wceq vx cv cA cB cdif wcel vx cv c0v wceq
      vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v cA cB cdif wcel c0v cB wcel
      cB cch wcel c0v cB wcel strlem1.2 cB ch0 ax-mp c0v cA cB eldifn mt2 vx cv
      c0v cA cB cdif eleq1 mtbiri con2i vx cv cA cB cdif wcel vx cv cA wcel vx
      cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq wb vx cv cA cB eldifi
      vx cv cA strlem1.1 cheli vx cv norm-i 3syl mtbird vx cv cno cfv cc0 df-ne
      sylibr sylanc recnd c1 vx cv cno cfv cdiv co cc wcel vx cv cA wcel c1 vx
      cv cno cfv cdiv co vx cv csm co cA wcel cA csh wcel c1 vx cv cno cfv cdiv
      co cc wcel vx cv cA wcel wa c1 vx cv cno cfv cdiv co vx cv csm co cA wcel
      wi cA strlem1.1 chshii c1 vx cv cno cfv cdiv co vx cv cA shmulclOLD ax-mp
      ex syl vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co vx cv csm co cB
      wcel vx cv cB wcel vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co vx cv
      csm co cB wcel vx cv cno cfv c1 vx cv cno cfv cdiv co vx cv csm co csm co
      cB wcel vx cv cB wcel vx cv cA cB cdif wcel vx cv cno cfv cc wcel c1 vx
      cv cno cfv cdiv co vx cv csm co cB wcel vx cv cno cfv c1 vx cv cno cfv
      cdiv co vx cv csm co csm co cB wcel wi vx cv cA cB cdif wcel vx cv cno
      cfv vx cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cr
      wcel vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv normcl 3syl recnd
      vx cv cno cfv cc wcel c1 vx cv cno cfv cdiv co vx cv csm co cB wcel vx cv
      cno cfv c1 vx cv cno cfv cdiv co vx cv csm co csm co cB wcel cB csh wcel
      vx cv cno cfv cc wcel c1 vx cv cno cfv cdiv co vx cv csm co cB wcel wa vx
      cv cno cfv c1 vx cv cno cfv cdiv co vx cv csm co csm co cB wcel wi cB
      strlem1.2 chshii vx cv cno cfv c1 vx cv cno cfv cdiv co vx cv csm co cB
      shmulclOLD ax-mp ex syl vx cv cA cB cdif wcel vx cv cno cfv c1 vx cv cno
      cfv cdiv co vx cv csm co csm co vx cv cB vx cv cA cB cdif wcel vx cv cno
      cfv c1 vx cv cno cfv cdiv co cmul co vx cv csm co c1 vx cv csm co vx cv
      cno cfv c1 vx cv cno cfv cdiv co vx cv csm co csm co vx cv vx cv cA cB
      cdif wcel vx cv cno cfv c1 vx cv cno cfv cdiv co cmul co c1 vx cv csm vx
      cv cno cfv cc wcel vx cv cno cfv cc0 wne vx cv cno cfv c1 vx cv cno cfv
      cdiv co cmul co c1 wceq vx cv cA cB cdif wcel vx cv cno cfv recid vx cv
      cA cB cdif wcel vx cv cno cfv vx cv cA cB cdif wcel vx cv cA wcel vx cv
      chil wcel vx cv cno cfv cr wcel vx cv cA cB eldifi vx cv cA strlem1.1
      cheli vx cv normcl 3syl recnd vx cv cA cB cdif wcel vx cv cno cfv cc0
      wceq wn vx cv cno cfv cc0 wne vx cv cA cB cdif wcel vx cv cno cfv cc0
      wceq vx cv c0v wceq vx cv c0v wceq vx cv cA cB cdif wcel vx cv c0v wceq
      vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v cA cB cdif wcel c0v cB wcel
      cB cch wcel c0v cB wcel strlem1.2 cB ch0 ax-mp c0v cA cB eldifn mt2 vx cv
      c0v cA cB cdif eleq1 mtbiri con2i vx cv cA cB cdif wcel vx cv cA wcel vx
      cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq wb vx cv cA cB eldifi
      vx cv cA strlem1.1 cheli vx cv norm-i 3syl mtbird vx cv cno cfv cc0 df-ne
      sylibr sylanc opreq1d vx cv cno cfv cc wcel c1 vx cv cno cfv cdiv co cc
      wcel vx cv chil wcel vx cv cno cfv c1 vx cv cno cfv cdiv co cmul co vx cv
      csm co vx cv cno cfv c1 vx cv cno cfv cdiv co vx cv csm co csm co wceq vx
      cv cA cB cdif wcel vx cv cno cfv c1 vx cv cno cfv cdiv co vx cv
      ax-hvmulass vx cv cA cB cdif wcel vx cv cno cfv vx cv cA cB cdif wcel vx
      cv cA wcel vx cv chil wcel vx cv cno cfv cr wcel vx cv cA cB eldifi vx cv
      cA strlem1.1 cheli vx cv normcl 3syl recnd vx cv cA cB cdif wcel c1 vx cv
      cno cfv cdiv co vx cv cno cfv cr wcel vx cv cno cfv cc0 wne c1 vx cv cno
      cfv cdiv co cr wcel vx cv cA cB cdif wcel vx cv cno cfv rereccl vx cv cA
      cB cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cr wcel vx cv cA
      cB eldifi vx cv cA strlem1.1 cheli vx cv normcl 3syl vx cv cA cB cdif
      wcel vx cv cno cfv cc0 wceq wn vx cv cno cfv cc0 wne vx cv cA cB cdif
      wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv c0v wceq vx cv cA cB
      cdif wcel vx cv c0v wceq vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v cA
      cB cdif wcel c0v cB wcel cB cch wcel c0v cB wcel strlem1.2 cB ch0 ax-mp
      c0v cA cB eldifn mt2 vx cv c0v cA cB cdif eleq1 mtbiri con2i vx cv cA cB
      cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v
      wceq wb vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv norm-i 3syl
      mtbird vx cv cno cfv cc0 df-ne sylibr sylanc recnd vx cv cA cB cdif wcel
      vx cv cA wcel vx cv chil wcel vx cv cA cB eldifi vx cv cA strlem1.1 cheli
      syl syl3anc vx cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel c1 vx cv
      csm co vx cv wceq vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv
      ax-hvmulid 3syl 3eqtr3d eleq1d sylibd con3d anim12d vx cv cA cB eldif c1
      vx cv cno cfv cdiv co vx cv csm co cA cB eldif 3imtr4g pm2.43i vx cv cA
      cB cdif wcel c1 vx cv cno cfv cdiv co vx cv csm co cno cfv c1 vx cv cno
      cfv cdiv co cabs cfv vx cv cno cfv cmul co c1 vx cv cno cfv cdiv co vx cv
      cno cfv cmul co c1 c1 vx cv cno cfv cdiv co cc wcel vx cv chil wcel c1 vx
      cv cno cfv cdiv co vx cv csm co cno cfv c1 vx cv cno cfv cdiv co cabs cfv
      vx cv cno cfv cmul co wceq vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co
      vx cv norm-iii vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co vx cv cno
      cfv cr wcel vx cv cno cfv cc0 wne c1 vx cv cno cfv cdiv co cr wcel vx cv
      cA cB cdif wcel vx cv cno cfv rereccl vx cv cA cB cdif wcel vx cv cA wcel
      vx cv chil wcel vx cv cno cfv cr wcel vx cv cA cB eldifi vx cv cA
      strlem1.1 cheli vx cv normcl 3syl vx cv cA cB cdif wcel vx cv cno cfv cc0
      wceq wn vx cv cno cfv cc0 wne vx cv cA cB cdif wcel vx cv cno cfv cc0
      wceq vx cv c0v wceq vx cv c0v wceq vx cv cA cB cdif wcel vx cv c0v wceq
      vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v cA cB cdif wcel c0v cB wcel
      cB cch wcel c0v cB wcel strlem1.2 cB ch0 ax-mp c0v cA cB eldifn mt2 vx cv
      c0v cA cB cdif eleq1 mtbiri con2i vx cv cA cB cdif wcel vx cv cA wcel vx
      cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v wceq wb vx cv cA cB eldifi
      vx cv cA strlem1.1 cheli vx cv norm-i 3syl mtbird vx cv cno cfv cc0 df-ne
      sylibr sylanc recnd vx cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel
      vx cv cA cB eldifi vx cv cA strlem1.1 cheli syl sylanc vx cv cA cB cdif
      wcel c1 vx cv cno cfv cdiv co cabs cfv c1 vx cv cno cfv cdiv co vx cv cno
      cfv cmul c1 vx cv cno cfv cdiv co cr wcel cc0 c1 vx cv cno cfv cdiv co
      cle wbr c1 vx cv cno cfv cdiv co cabs cfv c1 vx cv cno cfv cdiv co wceq
      vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co absid vx cv cno cfv cr
      wcel vx cv cno cfv cc0 wne c1 vx cv cno cfv cdiv co cr wcel vx cv cA cB
      cdif wcel vx cv cno cfv rereccl vx cv cA cB cdif wcel vx cv cA wcel vx cv
      chil wcel vx cv cno cfv cr wcel vx cv cA cB eldifi vx cv cA strlem1.1
      cheli vx cv normcl 3syl vx cv cA cB cdif wcel vx cv cno cfv cc0 wceq wn
      vx cv cno cfv cc0 wne vx cv cA cB cdif wcel vx cv cno cfv cc0 wceq vx cv
      c0v wceq vx cv c0v wceq vx cv cA cB cdif wcel vx cv c0v wceq vx cv cA cB
      cdif wcel c0v cA cB cdif wcel c0v cA cB cdif wcel c0v cB wcel cB cch wcel
      c0v cB wcel strlem1.2 cB ch0 ax-mp c0v cA cB eldifn mt2 vx cv c0v cA cB
      cdif eleq1 mtbiri con2i vx cv cA cB cdif wcel vx cv cA wcel vx cv chil
      wcel vx cv cno cfv cc0 wceq vx cv c0v wceq wb vx cv cA cB eldifi vx cv cA
      strlem1.1 cheli vx cv norm-i 3syl mtbird vx cv cno cfv cc0 df-ne sylibr
      sylanc vx cv cno cfv cr wcel cc0 vx cv cno cfv clt wbr cc0 c1 vx cv cno
      cfv cdiv co cle wbr vx cv cA cB cdif wcel c1 cr wcel cc0 c1 cle wbr vx cv
      cno cfv cr wcel cc0 vx cv cno cfv clt wbr wa cc0 c1 vx cv cno cfv cdiv co
      cle wbr 1re cc0 c1 0re 1re lt01 ltleii c1 vx cv cno cfv divge0 mpanl12 vx
      cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cr wcel vx
      cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv normcl 3syl vx cv cA cB
      cdif wcel vx cv c0v wne cc0 vx cv cno cfv clt wbr vx cv cA cB cdif wcel
      vx cv c0v vx cv c0v wceq vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v cA
      cB cdif wcel c0v cB wcel cB cch wcel c0v cB wcel strlem1.2 cB ch0 ax-mp
      c0v cA cB eldifn mt2 vx cv c0v cA cB cdif eleq1 mtbiri necon2ai vx cv cA
      cB cdif wcel vx cv chil wcel vx cv c0v wne cc0 vx cv cno cfv clt wbr wb
      vx cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel vx cv cA cB eldifi vx
      cv cA strlem1.1 cheli syl vx cv normgt0 syl mpbid sylanc sylanc opreq1d
      vx cv cA cB cdif wcel c1 vx cv cno cfv cdiv co vx cv cno cfv cmul co vx
      cv cno cfv c1 vx cv cno cfv cdiv co cmul co c1 c1 vx cv cno cfv cdiv co
      cc wcel vx cv cno cfv cc wcel c1 vx cv cno cfv cdiv co vx cv cno cfv cmul
      co vx cv cno cfv c1 vx cv cno cfv cdiv co cmul co wceq vx cv cA cB cdif
      wcel c1 vx cv cno cfv cdiv co vx cv cno cfv mulcom vx cv cA cB cdif wcel
      c1 vx cv cno cfv cdiv co vx cv cno cfv cr wcel vx cv cno cfv cc0 wne c1
      vx cv cno cfv cdiv co cr wcel vx cv cA cB cdif wcel vx cv cno cfv rereccl
      vx cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cr wcel
      vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv normcl 3syl vx cv cA cB
      cdif wcel vx cv cno cfv cc0 wceq wn vx cv cno cfv cc0 wne vx cv cA cB
      cdif wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv c0v wceq vx cv cA
      cB cdif wcel vx cv c0v wceq vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v
      cA cB cdif wcel c0v cB wcel cB cch wcel c0v cB wcel strlem1.2 cB ch0
      ax-mp c0v cA cB eldifn mt2 vx cv c0v cA cB cdif eleq1 mtbiri con2i vx cv
      cA cB cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cc0 wceq vx
      cv c0v wceq wb vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv norm-i
      3syl mtbird vx cv cno cfv cc0 df-ne sylibr sylanc recnd vx cv cA cB cdif
      wcel vx cv cno cfv vx cv cA cB cdif wcel vx cv cA wcel vx cv chil wcel vx
      cv cno cfv cr wcel vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv
      normcl 3syl recnd sylanc vx cv cno cfv cc wcel vx cv cno cfv cc0 wne vx
      cv cno cfv c1 vx cv cno cfv cdiv co cmul co c1 wceq vx cv cA cB cdif wcel
      vx cv cno cfv recid vx cv cA cB cdif wcel vx cv cno cfv vx cv cA cB cdif
      wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cr wcel vx cv cA cB
      eldifi vx cv cA strlem1.1 cheli vx cv normcl 3syl recnd vx cv cA cB cdif
      wcel vx cv cno cfv cc0 wceq wn vx cv cno cfv cc0 wne vx cv cA cB cdif
      wcel vx cv cno cfv cc0 wceq vx cv c0v wceq vx cv c0v wceq vx cv cA cB
      cdif wcel vx cv c0v wceq vx cv cA cB cdif wcel c0v cA cB cdif wcel c0v cA
      cB cdif wcel c0v cB wcel cB cch wcel c0v cB wcel strlem1.2 cB ch0 ax-mp
      c0v cA cB eldifn mt2 vx cv c0v cA cB cdif eleq1 mtbiri con2i vx cv cA cB
      cdif wcel vx cv cA wcel vx cv chil wcel vx cv cno cfv cc0 wceq vx cv c0v
      wceq wb vx cv cA cB eldifi vx cv cA strlem1.1 cheli vx cv norm-i 3syl
      mtbird vx cv cno cfv cc0 df-ne sylibr sylanc eqtrd 3eqtrd sylanc 19.23aiv
      sylbi $.
      $( [25-Oct-1999] $)
  $}

  ${
    $d x y C $.  $d x y u $.
    strlem2.1 $e |- S = { <. x , y >. | ( x e. CH /\
                    y = ( ( normh ` ( ( proj ` x ) ` u ) ) ^ 2 ) ) } $.
    $( Lemma for strong state theorem. $)
    strlem2 $p |- ( C e. CH ->
                  ( S ` C ) = ( ( normh ` ( ( proj ` C ) ` u ) ) ^ 2 ) ) $=
      vx vy cC vu cv vx cv cpj cfv cfv cno cfv c2 cexp co vu cv cC cpj cfv cfv
      cno cfv c2 cexp co cch cS vx cv cC wceq vu cv vx cv cpj cfv cfv cno cfv
      vu cv cC cpj cfv cfv cno cfv c2 cexp vx cv cC wceq vu cv vx cv cpj cfv
      cfv vu cv cC cpj cfv cfv cno vx cv cC wceq vu cv vx cv cpj cfv cC cpj cfv
      vx cv cC cpj fveq2 fveq1d fveq2d opreq1d strlem2.1 vu cv cC cpj cfv cfv
      cno cfv c2 cexp oprex fvopab4 $.
      $( [28-Oct-1999] $)
  $}

  ${
    $d x z w u $.  $d z w S $.  $d x y u $.  $d y z w $.
    strlem3a.1 $e |- S = { <. x , y >. | ( x e. CH /\
                    y = ( ( normh ` ( ( proj ` x ) ` u ) ) ^ 2 ) ) } $.
    $( Lemma for strong state theorem:  the function ` S ` , that maps a closed
       subspace to the square of the norm of its projection onto a unit vector,
       is a state. $)
    strlem3a $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) -> S e. States ) $=
      vu cv chil wcel vu cv cno cfv c1 wceq wa cch cr cS wf cc0 vz cv cS cfv
      cle wbr vz cv cS cfv c1 cle wbr wa vz cch wral wa chil cS cfv c1 wceq vz
      cv vw cv cort cfv wss vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv
      caddc co wceq wi vw cch wral vz cch wral wa wa cS cst wcel vu cv chil
      wcel vu cv cno cfv c1 wceq wa cch cr cS wf cc0 vz cv cS cfv cle wbr vz cv
      cS cfv c1 cle wbr wa vz cch wral wa chil cS cfv c1 wceq vz cv vw cv cort
      cfv wss vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv caddc co wceq
      wi vw cch wral vz cch wral wa vu cv chil wcel vu cv cno cfv c1 wceq wa
      cch cr cS wf cc0 vz cv cS cfv cle wbr vz cv cS cfv c1 cle wbr wa vz cch
      wral vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv vx cv cpj cfv cfv cno
      cfv c2 cexp co cr wcel vx cch wral cch cr cS wf vu cv chil wcel vu cv cno
      cfv c1 wceq wa vu cv vx cv cpj cfv cfv cno cfv c2 cexp co cr wcel vx cch
      vx cv cch wcel vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv vx cv cpj
      cfv cfv cno cfv c2 cexp co cr wcel vx cv cch wcel vu cv chil wcel vu cv
      cno cfv c1 wceq wa wa vu cv vx cv cpj cfv cfv chil wcel vu cv vx cv cpj
      cfv cfv cno cfv cr wcel vu cv vx cv cpj cfv cfv cno cfv c2 cexp co cr
      wcel vx cv cch wcel vu cv chil wcel vu cv vx cv cpj cfv cfv chil wcel vu
      cv cno cfv c1 wceq vu cv vx cv pjhcl adantrr vu cv vx cv cpj cfv cfv
      normcl vu cv vx cv cpj cfv cfv cno cfv resqcl 3syl expcom r19.21aiv vx vy
      cch cr vu cv vx cv cpj cfv cfv cno cfv c2 cexp co cS strlem3a.1 fopab2
      sylib vu cv chil wcel vu cv cno cfv c1 wceq wa cc0 vz cv cS cfv cle wbr
      vz cv cS cfv c1 cle wbr wa vz cch vz cv cch wcel vu cv chil wcel vu cv
      cno cfv c1 wceq wa cc0 vz cv cS cfv cle wbr vz cv cS cfv c1 cle wbr wa vz
      cv cch wcel vu cv chil wcel vu cv cno cfv c1 wceq wa wa cc0 vz cv cS cfv
      cle wbr vz cv cS cfv c1 cle wbr vz cv cch wcel vu cv chil wcel vu cv cno
      cfv c1 wceq wa wa cc0 vu cv vz cv cpj cfv cfv cno cfv c2 cexp co vz cv cS
      cfv cle vz cv cch wcel vu cv chil wcel vu cv cno cfv c1 wceq wa wa vu cv
      vz cv cpj cfv cfv chil wcel vu cv vz cv cpj cfv cfv cno cfv cr wcel cc0
      vu cv vz cv cpj cfv cfv cno cfv c2 cexp co cle wbr vz cv cch wcel vu cv
      chil wcel vu cv vz cv cpj cfv cfv chil wcel vu cv cno cfv c1 wceq vu cv
      vz cv pjhcl adantrr vu cv vz cv cpj cfv cfv normcl vu cv vz cv cpj cfv
      cfv cno cfv sqge0 3syl vz cv cch wcel vz cv cS cfv vu cv vz cv cpj cfv
      cfv cno cfv c2 cexp co wceq vu cv chil wcel vu cv cno cfv c1 wceq wa vx
      vy vu vz cv cS strlem3a.1 strlem2 adantr breqtrrd vz cv cch wcel vu cv
      chil wcel vu cv cno cfv c1 wceq wa wa vz cv cS cfv vu cv vz cv cpj cfv
      cfv cno cfv c2 cexp co c1 cle vz cv cch wcel vz cv cS cfv vu cv vz cv cpj
      cfv cfv cno cfv c2 cexp co wceq vu cv chil wcel vu cv cno cfv c1 wceq wa
      vx vy vu vz cv cS strlem3a.1 strlem2 adantr vz cv cch wcel vu cv chil
      wcel vu cv cno cfv c1 wceq wa wa vu cv vz cv cpj cfv cfv cno cfv c2 cexp
      co c1 c2 cexp co c1 cle vz cv cch wcel vu cv chil wcel vu cv cno cfv c1
      wceq wa wa vu cv vz cv cpj cfv cfv cno cfv c1 cle wbr vu cv vz cv cpj cfv
      cfv cno cfv c2 cexp co c1 c2 cexp co cle wbr vz cv cch wcel vu cv chil
      wcel vu cv cno cfv c1 wceq wa wa vu cv vz cv cpj cfv cfv cno cfv vu cv
      cno cfv c1 cle vz cv cch wcel vu cv chil wcel vu cv vz cv cpj cfv cfv cno
      cfv vu cv cno cfv cle wbr vu cv cno cfv c1 wceq vu cv vz cv pjnorm
      adantrr vz cv cch wcel vu cv chil wcel vu cv cno cfv c1 wceq simprr
      breqtrd vu cv vz cv cpj cfv cfv cno cfv cr wcel cc0 vu cv vz cv cpj cfv
      cfv cno cfv cle wbr vu cv vz cv cpj cfv cfv cno cfv c1 cle wbr vu cv vz
      cv cpj cfv cfv cno cfv c2 cexp co c1 c2 cexp co cle wbr wb vz cv cch wcel
      vu cv chil wcel vu cv cno cfv c1 wceq wa wa vu cv vz cv cpj cfv cfv cno
      cfv cr wcel cc0 vu cv vz cv cpj cfv cfv cno cfv cle wbr wa c1 cr wcel cc0
      c1 cle wbr vu cv vz cv cpj cfv cfv cno cfv c1 cle wbr vu cv vz cv cpj cfv
      cfv cno cfv c2 cexp co c1 c2 cexp co cle wbr wb 1re cc0 c1 0re 1re lt01
      ltleii vu cv vz cv cpj cfv cfv cno cfv c1 le2sq mpanr12 vz cv cch wcel vu
      cv chil wcel vu cv cno cfv c1 wceq wa wa vu cv vz cv cpj cfv cfv chil
      wcel vu cv vz cv cpj cfv cfv cno cfv cr wcel vz cv cch wcel vu cv chil
      wcel vu cv vz cv cpj cfv cfv chil wcel vu cv cno cfv c1 wceq vu cv vz cv
      pjhcl adantrr vu cv vz cv cpj cfv cfv normcl syl vz cv cch wcel vu cv
      chil wcel vu cv cno cfv c1 wceq wa wa vu cv vz cv cpj cfv cfv chil wcel
      cc0 vu cv vz cv cpj cfv cfv cno cfv cle wbr vz cv cch wcel vu cv chil
      wcel vu cv vz cv cpj cfv cfv chil wcel vu cv cno cfv c1 wceq vu cv vz cv
      pjhcl adantrr vu cv vz cv cpj cfv cfv normge0 syl sylanc mpbid sq1
      syl6breq eqbrtrd jca expcom r19.21aiv jca vu cv chil wcel vu cv cno cfv
      c1 wceq wa chil cS cfv c1 wceq vz cv vw cv cort cfv wss vz cv vw cv chj
      co cS cfv vz cv cS cfv vw cv cS cfv caddc co wceq wi vw cch wral vz cch
      wral vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv chil cpj cfv cfv cno
      cfv c2 cexp co c1 chil cS cfv vu cv chil wcel vu cv cno cfv c1 wceq vu cv
      chil cpj cfv cfv cno cfv c2 cexp co vu cv cno cfv c2 cexp co c1 vu cv
      chil wcel vu cv chil cpj cfv cfv cno cfv vu cv cno cfv c2 cexp vu cv chil
      wcel vu cv chil cpj cfv cfv vu cv cno vu cv pjch1 fveq2d opreq1d vu cv
      cno cfv c1 wceq vu cv cno cfv c2 cexp co c1 c2 cexp co c1 vu cv cno cfv
      c1 c2 cexp opreq1 sq1 syl6eq sylan9eq chil cch wcel chil cS cfv vu cv
      chil cpj cfv cfv cno cfv c2 cexp co wceq helch vx vy vu chil cS
      strlem3a.1 strlem2 ax-mp syl5eq vu cv chil wcel vu cv cno cfv c1 wceq wa
      vz cv vw cv cort cfv wss vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS
      cfv caddc co wceq wi vw cch wral vz cch vu cv chil wcel vu cv cno cfv c1
      wceq wa vz cv cch wcel vz cv vw cv cort cfv wss vz cv vw cv chj co cS cfv
      vz cv cS cfv vw cv cS cfv caddc co wceq wi vw cch vu cv chil wcel vz cv
      cch wcel vw cv cch wcel vz cv vw cv cort cfv wss vz cv vw cv chj co cS
      cfv vz cv cS cfv vw cv cS cfv caddc co wceq wi wi wi vu cv cno cfv c1
      wceq vz cv cch wcel vw cv cch wcel vu cv chil wcel vz cv vw cv cort cfv
      wss vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv caddc co wceq wi
      vz cv cch wcel vw cv cch wcel vu cv chil wcel vz cv vw cv cort cfv wss vz
      cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv caddc co wceq vz cv cch
      wcel vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort cfv wss wa vu cv
      vz cv vw cv chj co cpj cfv cfv cno cfv c2 cexp co vu cv vz cv cpj cfv cfv
      cno cfv c2 cexp co vu cv vw cv cpj cfv cfv cno cfv c2 cexp co caddc co vz
      cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv caddc co vz cv cch wcel
      vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort cfv wss wa vu cv vz
      cv vw cv chj co cpj cfv cfv cno cfv c2 cexp co vu cv vz cv cpj cfv cfv vu
      cv vw cv cpj cfv cfv cva co cno cfv c2 cexp co vu cv vz cv cpj cfv cfv
      cno cfv c2 cexp co vu cv vw cv cpj cfv cfv cno cfv c2 cexp co caddc co vz
      cv cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort cfv wss
      wa vu cv vz cv vw cv chj co cpj cfv cfv cno cfv vu cv vz cv cpj cfv cfv
      vu cv vw cv cpj cfv cfv cva co cno cfv c2 cexp vz cv cch wcel vw cv cch
      wcel vu cv chil wcel w3a vz cv vw cv cort cfv wss wa vu cv vz cv vw cv
      chj co cpj cfv cfv vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv cva co
      cno vz cv cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort
      cfv wss vu cv vz cv vw cv chj co cpj cfv cfv vu cv vz cv cpj cfv cfv vu
      cv vw cv cpj cfv cfv cva co wceq vu cv vw cv vz cv pjcjt2 imp fveq2d
      opreq1d vz cv cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv vw cv
      cort cfv wss vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv cva co cno
      cfv c2 cexp co vu cv vz cv cpj cfv cfv cno cfv c2 cexp co vu cv vw cv cpj
      cfv cfv cno cfv c2 cexp co caddc co wceq vu cv vw cv vz cv pjopyth imp
      eqtrd vz cv cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort
      cfv wss wa vz cv vw cv chj co cch wcel vz cv vw cv chj co cS cfv vu cv vz
      cv vw cv chj co cpj cfv cfv cno cfv c2 cexp co wceq vz cv cch wcel vw cv
      cch wcel vu cv chil wcel w3a vz cv vw cv chj co cch wcel vz cv vw cv cort
      cfv wss vz cv cch wcel vw cv cch wcel vz cv vw cv chj co cch wcel vu cv
      chil wcel vz cv vw cv chjcl 3adant3 adantr vx vy vu vz cv vw cv chj co cS
      strlem3a.1 strlem2 syl vz cv cch wcel vw cv cch wcel vu cv chil wcel w3a
      vz cv vw cv cort cfv wss wa vz cv cch wcel vw cv cch wcel wa vz cv cS cfv
      vw cv cS cfv caddc co vu cv vz cv cpj cfv cfv cno cfv c2 cexp co vu cv vw
      cv cpj cfv cfv cno cfv c2 cexp co caddc co wceq vz cv cch wcel vw cv cch
      wcel vu cv chil wcel w3a vz cv cch wcel vw cv cch wcel wa vz cv vw cv
      cort cfv wss vz cv cch wcel vw cv cch wcel vu cv chil wcel 3simpa adantr
      vz cv cch wcel vw cv cch wcel vz cv cS cfv vu cv vz cv cpj cfv cfv cno
      cfv c2 cexp co vw cv cS cfv vu cv vw cv cpj cfv cfv cno cfv c2 cexp co
      caddc vx vy vu vz cv cS strlem3a.1 strlem2 vx vy vu vw cv cS strlem3a.1
      strlem2 opreqan12d syl 3eqtr4d 3exp1 com3r adantr r19.21adv r19.21aiv jca
      jca vz vw cS stel sylibr $.
      $( [28-Oct-1999] $)
  $}

  ${
    $d x z w ph $.  $d z w S $.  $d x y u $.  $d y z w $.
    $d x y A $.  $d x y B $.
    strlem3.1 $e |- S = { <. x , y >. | ( x e. CH /\
                    y = ( ( normh ` ( ( proj ` x ) ` u ) ) ^ 2 ) ) } $.
    strlem3.2 $e |- ( ph <-> ( u e. ( A \ B ) /\ ( normh ` u ) = 1 ) ) $.
    strlem3.3 $e |- A e. CH $.
    strlem3.4 $e |- B e. CH $.
    $( Lemma for strong state theorem:  the function ` S ` , that maps a closed
       subspace to the square of the norm of its projection onto a unit vector,
       is a state.  This lemma restates the hypotheses in a more convenient
       form to work with. $)
    strlem3 $p |- ( ph -> S e. States ) $=
      wph vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa cS cst wcel strlem3.2
      vu cv chil wcel vu cv cno cfv c1 wceq cS cst wcel vu cv cA cB cdif wcel
      vx vy vu cS strlem3.1 strlem3a vu cv cA cB cdif wcel vu cv cA wcel vu cv
      chil wcel vu cv cA cB eldifi vu cv cA strlem3.3 cheli syl sylan sylbi $.
      $( [28-Oct-1999] $)

    $( Lemma for strong state theorem. $)
    strlem4 $p |- ( ph -> ( S ` A ) = 1 ) $=
      wph vu cv cA cpj cfv cfv cno cfv c2 cexp co c1 cA cS cfv wph vu cv cA cpj
      cfv cfv cno cfv c2 cexp co c1 c2 cexp co c1 wph vu cv cA cpj cfv cfv cno
      cfv c1 c2 cexp wph vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa vu cv
      cA cpj cfv cfv cno cfv c1 wceq strlem3.2 vu cv cA wcel vu cv cno cfv c1
      wceq vu cv cA cpj cfv cfv cno cfv c1 wceq vu cv cA cB cdif wcel vu cv cno
      cfv c1 wceq vu cv cA wcel vu cv cA cpj cfv cfv cno cfv c1 wceq vu cv cno
      cfv c1 wceq vu cv cA cpj cfv cfv cno cfv vu cv cno cfv wceq vu cv cA cpj
      cfv cfv cno cfv c1 wceq vu cv cA wcel vu cv cno cfv c1 vu cv cA cpj cfv
      cfv cno cfv eqeq2 vu cv cA wcel vu cv cA cpj cfv cfv vu cv cno cA cch
      wcel vu cv cA wcel vu cv cA cpj cfv cfv vu cv wceq strlem3.3 vu cv cA
      pjid mpan fveq2d syl5bi impcom vu cv cA cB eldifi sylan sylbi opreq1d sq1
      syl6eq cA cch wcel cA cS cfv vu cv cA cpj cfv cfv cno cfv c2 cexp co wceq
      strlem3.3 vx vy vu cA cS strlem3.1 strlem2 ax-mp syl5eq $.
      $( [2-Nov-1999] $)

    $( Lemma for strong state theorem. $)
    strlem5 $p |- ( ph -> ( S ` B ) < 1 ) $=
      wph vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa cB cS cfv c1 clt wbr
      strlem3.2 vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa cB cS cfv c1 c2
      cexp co c1 clt vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa vu cv cB
      cpj cfv cfv cno cfv c2 cexp co c1 c2 cexp co cB cS cfv clt vu cv cA cB
      cdif wcel vu cv cno cfv c1 wceq wa vu cv cB cpj cfv cfv cno cfv c1 clt
      wbr vu cv cB cpj cfv cfv cno cfv c2 cexp co c1 c2 cexp co clt wbr vu cv
      cno cfv c1 wceq vu cv cA cB cdif wcel vu cv cB cpj cfv cfv cno cfv c1 clt
      wbr vu cv cno cfv c1 wceq vu cv cB cpj cfv cfv cno cfv vu cv cno cfv clt
      wbr vu cv cB cpj cfv cfv cno cfv c1 clt wbr vu cv cA cB cdif wcel vu cv
      cno cfv c1 vu cv cB cpj cfv cfv cno cfv clt breq2 vu cv cA cB cdif wcel
      vu cv cA wcel vu cv cB wcel wn wa vu cv cB cpj cfv cfv cno cfv vu cv cno
      cfv clt wbr vu cv cA cB eldif vu cv chil wcel vu cv cB wcel wn vu cv cB
      cpj cfv cfv cno cfv vu cv cno cfv clt wbr vu cv cA wcel vu cv chil wcel
      vu cv cB wcel wn vu cv cB cpj cfv cfv cno cfv vu cv cno cfv clt wbr cB
      cch wcel vu cv chil wcel vu cv cB wcel wn vu cv cB cpj cfv cfv cno cfv vu
      cv cno cfv clt wbr wb strlem3.4 vu cv cB pjnel mpan biimpa vu cv cA
      strlem3.3 cheli sylan sylbi syl5bi impcom vu cv cA cB cdif wcel vu cv cB
      cpj cfv cfv cno cfv c1 clt wbr vu cv cB cpj cfv cfv cno cfv c2 cexp co c1
      c2 cexp co clt wbr wb vu cv cno cfv c1 wceq vu cv cA cB cdif wcel vu cv
      cA wcel vu cv chil wcel vu cv cB cpj cfv cfv cno cfv c1 clt wbr vu cv cB
      cpj cfv cfv cno cfv c2 cexp co c1 c2 cexp co clt wbr wb vu cv cA cB
      eldifi vu cv cA strlem3.3 cheli vu cv cB cpj cfv cfv cno cfv cr wcel cc0
      vu cv cB cpj cfv cfv cno cfv cle wbr vu cv cB cpj cfv cfv cno cfv c1 clt
      wbr vu cv cB cpj cfv cfv cno cfv c2 cexp co c1 c2 cexp co clt wbr wb vu
      cv chil wcel vu cv cB cpj cfv cfv cno cfv cr wcel cc0 vu cv cB cpj cfv
      cfv cno cfv cle wbr wa c1 cr wcel cc0 c1 cle wbr vu cv cB cpj cfv cfv cno
      cfv c1 clt wbr vu cv cB cpj cfv cfv cno cfv c2 cexp co c1 c2 cexp co clt
      wbr wb 1re cc0 c1 0re 1re lt01 ltleii vu cv cB cpj cfv cfv cno cfv c1
      lt2sq mpanr12 vu cv chil wcel vu cv cB cpj cfv cfv chil wcel vu cv cB cpj
      cfv cfv cno cfv cr wcel vu cv cB strlem3.4 pjhcli vu cv cB cpj cfv cfv
      normcl syl vu cv chil wcel vu cv cB cpj cfv cfv chil wcel cc0 vu cv cB
      cpj cfv cfv cno cfv cle wbr vu cv cB strlem3.4 pjhcli vu cv cB cpj cfv
      cfv normge0 syl sylanc 3syl adantr mpbid cB cch wcel cB cS cfv vu cv cB
      cpj cfv cfv cno cfv c2 cexp co wceq strlem3.4 vx vy vu cB cS strlem3.1
      strlem2 ax-mp syl5eqbr sq1 syl6breq sylbi $.
      $( [2-Nov-1999] $)

    $( Lemma for strong state theorem. $)
    strlem6 $p |- ( ph -> -. ( ( S ` A ) = 1 -> ( S ` B ) = 1 ) ) $=
      wph cA cS cfv c1 wceq cB cS cfv c1 wceq wn wa cA cS cfv c1 wceq cB cS cfv
      c1 wceq wi wn wph cA cS cfv c1 wceq cB cS cfv c1 wceq wn wph vx vy vu cA
      cB cS strlem3.1 strlem3.2 strlem3.3 strlem3.4 strlem4 wph cB cS cfv c1
      wne cB cS cfv c1 wceq wn wph c1 cB cS cfv cB cS cfv cr wcel cB cS cfv c1
      clt wbr c1 cB cS cfv wne wph cB cS cfv cr wcel c1 cr wcel cB cS cfv c1
      clt wbr c1 cB cS cfv wne 1re cB cS cfv c1 ltne mp3an2 wph cS cst wcel cB
      cS cfv cr wcel wph vx vy vu cA cB cS strlem3.1 strlem3.2 strlem3.3
      strlem3.4 strlem3 cS cst wcel cB cch wcel cB cS cfv cr wcel strlem3.4 cB
      cS stcl mpi syl wph vx vy vu cA cB cS strlem3.1 strlem3.2 strlem3.3
      strlem3.4 strlem5 sylanc necomd cB cS cfv c1 df-ne sylib jca cA cS cfv c1
      wceq cB cS cfv c1 wceq annim sylib $.
      $( [2-Nov-1999] $)
  $}

  ${
    $d x y u f A $.  $d x y u f B $.
    str.1 $e |- A e. CH $.
    str.2 $e |- B e. CH $.
    $( Strong state theorem.  The states on a Hilbert lattice define an
       ordering.  Remark in [Mayet] p. 370. $)
    stri $p |- ( A. f e. States ( ( f ` A ) = 1 -> ( f ` B ) = 1 ) ->
              A C_ B ) $=
      cA vf cv cfv c1 wceq cB vf cv cfv c1 wceq wi vf cst wral cA vf cv cfv c1
      wceq cB vf cv cfv c1 wceq wi wn vf cst wrex wn cA cB wss cA vf cv cfv c1
      wceq cB vf cv cfv c1 wceq wi vf cst dfral2 cA cB wss cA vf cv cfv c1 wceq
      cB vf cv cfv c1 wceq wi wn vf cst wrex cA cB wss wn vu cv cno cfv c1 wceq
      vu cA cB cdif wrex cA vf cv cfv c1 wceq cB vf cv cfv c1 wceq wi wn vf cst
      wrex vu cA cB str.1 str.2 strlem1 vu cv cno cfv c1 wceq cA vf cv cfv c1
      wceq cB vf cv cfv c1 wceq wi wn vf cst wrex vu cA cB cdif vx cv cch wcel
      vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq wa vx vy copab cst
      wcel cA vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co
      wceq wa vx vy copab cfv c1 wceq cB vx cv cch wcel vy cv vu cv vx cv cpj
      cfv cfv cno cfv c2 cexp co wceq wa vx vy copab cfv c1 wceq wi wn cA vf cv
      cfv c1 wceq cB vf cv cfv c1 wceq wi wn vf cst wrex vu cv cA cB cdif wcel
      vu cv cno cfv c1 wceq wa cA vf cv cfv c1 wceq cB vf cv cfv c1 wceq wi wn
      cA vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq
      wa vx vy copab cfv c1 wceq cB vx cv cch wcel vy cv vu cv vx cv cpj cfv
      cfv cno cfv c2 cexp co wceq wa vx vy copab cfv c1 wceq wi wn vf vx cv cch
      wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq wa vx vy copab
      cst vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co
      wceq wa vx vy copab wceq cA vf cv cfv c1 wceq cB vf cv cfv c1 wceq wi cA
      vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq wa
      vx vy copab cfv c1 wceq cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv
      cno cfv c2 cexp co wceq wa vx vy copab cfv c1 wceq wi vf cv vx cv cch
      wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq wa vx vy copab
      wceq cA vf cv cfv c1 wceq cA vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv
      cno cfv c2 cexp co wceq wa vx vy copab cfv c1 wceq cB vf cv cfv c1 wceq
      cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq
      wa vx vy copab cfv c1 wceq vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv
      cfv cno cfv c2 cexp co wceq wa vx vy copab wceq cA vf cv cfv cA vx cv cch
      wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq wa vx vy copab
      cfv c1 cA vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2
      cexp co wceq wa vx vy copab fveq1 eqeq1d vf cv vx cv cch wcel vy cv vu cv
      vx cv cpj cfv cfv cno cfv c2 cexp co wceq wa vx vy copab wceq cB vf cv
      cfv cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co
      wceq wa vx vy copab cfv c1 cB vf cv vx cv cch wcel vy cv vu cv vx cv cpj
      cfv cfv cno cfv c2 cexp co wceq wa vx vy copab fveq1 eqeq1d imbi12d
      notbid rcla4ev vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa vx vy vu cA
      cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2 cexp co wceq
      wa vx vy copab vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno cfv c2
      cexp co wceq wa vx vy copab eqid vu cv cA cB cdif wcel vu cv cno cfv c1
      wceq wa biid str.1 str.2 strlem3 vu cv cA cB cdif wcel vu cv cno cfv c1
      wceq wa vx vy vu cA cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv cno
      cfv c2 cexp co wceq wa vx vy copab vx cv cch wcel vy cv vu cv vx cv cpj
      cfv cfv cno cfv c2 cexp co wceq wa vx vy copab eqid vu cv cA cB cdif wcel
      vu cv cno cfv c1 wceq wa biid str.1 str.2 strlem6 sylanc r19.23aiva syl
      con1i sylbi $.
      $( [2-Nov-1999] $)

    $( Strong state theorem (bidirectional version). $)
    strbi $p |- ( A. f e. States ( ( f ` A ) = 1 -> ( f ` B ) = 1 ) <->
              A C_ B ) $=
      cA vf cv cfv c1 wceq cB vf cv cfv c1 wceq wi vf cst wral cA cB wss cA cB
      vf str.1 str.2 stri cA cB wss cA vf cv cfv c1 wceq cB vf cv cfv c1 wceq
      wi vf cst vf cv cst wcel cA cB wss cA vf cv cfv c1 wceq cB vf cv cfv c1
      wceq wi cA cB vf cv str.1 str.2 stlesi com12 r19.21aiv impbii $.
      $( [7-Apr-2001] $)
  $}

  ${
    $d x y C $.  $d x y u $.
    hstrlem2.1 $e |- S = { <. x , y >. | ( x e. CH /\
                      y = ( ( proj ` x ) ` u ) ) } $.
    $( Lemma for strong set of CH states theorem. $)
    hstrlem2 $p |- ( C e. CH ->
                  ( S ` C ) = ( ( proj ` C ) ` u ) ) $=
      vx vy cC vu cv vx cv cpj cfv cfv vu cv cC cpj cfv cfv cch cS vx cv cC
      wceq vu cv vx cv cpj cfv cC cpj cfv vx cv cC cpj fveq2 fveq1d hstrlem2.1
      vu cv cC cpj cfv fvex fvopab4 $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)
  $}

  ${
    $d x z w u $.  $d z w S $.  $d x y u $.  $d y z w $.
    hstrlem3a.1 $e |- S = { <. x , y >. | ( x e. CH /\
                      y = ( ( proj ` x ) ` u ) ) } $.
    $( Lemma for strong set of CH states theorem:  the function ` S ` , that
       maps a closed subspace to the square of the norm of its projection onto
       a unit vector, is a state. $)
    hstrlem3a $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) -> S e. CHStates ) $=
      vu cv chil wcel vu cv cno cfv c1 wceq wa cch chil cS wf chil cS cfv cno
      cfv c1 wceq vz cv vw cv cort cfv wss vz cv cS cfv vw cv cS cfv csp co cc0
      wceq vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv cva co wceq wa
      wi vw cch wral vz cch wral w3a cS chst wcel vu cv chil wcel vu cv cno cfv
      c1 wceq wa cch chil cS wf chil cS cfv cno cfv c1 wceq vz cv vw cv cort
      cfv wss vz cv cS cfv vw cv cS cfv csp co cc0 wceq vz cv vw cv chj co cS
      cfv vz cv cS cfv vw cv cS cfv cva co wceq wa wi vw cch wral vz cch wral
      vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv vx cv cpj cfv cfv chil
      wcel vx cch wral cch chil cS wf vu cv chil wcel vu cv cno cfv c1 wceq wa
      vu cv vx cv cpj cfv cfv chil wcel vx cch vx cv cch wcel vu cv chil wcel
      vu cv cno cfv c1 wceq wa vu cv vx cv cpj cfv cfv chil wcel vx cv cch wcel
      vu cv chil wcel vu cv vx cv cpj cfv cfv chil wcel vu cv cno cfv c1 wceq
      vu cv vx cv pjhcl adantrr expcom r19.21aiv vx vy cch chil vu cv vx cv cpj
      cfv cfv cS hstrlem3a.1 fopab2 sylib vu cv chil wcel vu cv cno cfv c1 wceq
      wa vu cv chil cpj cfv cfv cno cfv c1 chil cS cfv cno cfv vu cv chil wcel
      vu cv cno cfv c1 wceq vu cv chil cpj cfv cfv cno cfv vu cv cno cfv c1 vu
      cv chil wcel vu cv chil cpj cfv cfv vu cv cno vu cv pjch1 fveq2d vu cv
      cno cfv c1 wceq id sylan9eq chil cS cfv vu cv chil cpj cfv cfv cno chil
      cch wcel chil cS cfv vu cv chil cpj cfv cfv wceq helch vx vy vu chil cS
      hstrlem3a.1 hstrlem2 ax-mp fveq2i syl5eq vu cv chil wcel vu cv cno cfv c1
      wceq wa vz cv vw cv cort cfv wss vz cv cS cfv vw cv cS cfv csp co cc0
      wceq vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv cva co wceq wa
      wi vw cch wral vz cch vu cv chil wcel vu cv cno cfv c1 wceq wa vz cv cch
      wcel vz cv vw cv cort cfv wss vz cv cS cfv vw cv cS cfv csp co cc0 wceq
      vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv cva co wceq wa wi vw
      cch vu cv chil wcel vz cv cch wcel vw cv cch wcel vz cv vw cv cort cfv
      wss vz cv cS cfv vw cv cS cfv csp co cc0 wceq vz cv vw cv chj co cS cfv
      vz cv cS cfv vw cv cS cfv cva co wceq wa wi wi wi vu cv cno cfv c1 wceq
      vz cv cch wcel vw cv cch wcel vu cv chil wcel vz cv vw cv cort cfv wss vz
      cv cS cfv vw cv cS cfv csp co cc0 wceq vz cv vw cv chj co cS cfv vz cv cS
      cfv vw cv cS cfv cva co wceq wa wi vz cv cch wcel vw cv cch wcel vu cv
      chil wcel vz cv vw cv cort cfv wss vz cv cS cfv vw cv cS cfv csp co cc0
      wceq vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv cva co wceq wa
      vz cv cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort cfv
      wss wa vz cv cS cfv vw cv cS cfv csp co cc0 wceq vz cv vw cv chj co cS
      cfv vz cv cS cfv vw cv cS cfv cva co wceq vz cv cch wcel vw cv cch wcel
      vu cv chil wcel w3a vz cv vw cv cort cfv wss wa vz cv cS cfv vw cv cS cfv
      csp co vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv csp co cc0 vz cv
      cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv cS cfv vw cv cS cfv csp
      co vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv csp co wceq vz cv vw
      cv cort cfv wss vz cv cch wcel vw cv cch wcel vz cv cS cfv vw cv cS cfv
      csp co vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv csp co wceq vu cv
      chil wcel vz cv cch wcel vw cv cch wcel vz cv cS cfv vu cv vz cv cpj cfv
      cfv vw cv cS cfv vu cv vw cv cpj cfv cfv csp vx vy vu vz cv cS
      hstrlem3a.1 hstrlem2 vx vy vu vw cv cS hstrlem3a.1 hstrlem2 opreqan12d
      3adant3 adantr vu cv vz cv vw cv pjoi0 eqtrd vz cv cch wcel vw cv cch
      wcel vu cv chil wcel w3a vz cv vw cv cort cfv wss wa vu cv vz cv vw cv
      chj co cpj cfv cfv vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv cva co
      vz cv vw cv chj co cS cfv vz cv cS cfv vw cv cS cfv cva co vz cv cch wcel
      vw cv cch wcel vu cv chil wcel w3a vz cv vw cv cort cfv wss vu cv vz cv
      vw cv chj co cpj cfv cfv vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv
      cva co wceq vu cv vw cv vz cv pjcjt2 imp vz cv cch wcel vw cv cch wcel vu
      cv chil wcel w3a vz cv vw cv chj co cS cfv vu cv vz cv vw cv chj co cpj
      cfv cfv wceq vz cv vw cv cort cfv wss vz cv cch wcel vw cv cch wcel vz cv
      vw cv chj co cS cfv vu cv vz cv vw cv chj co cpj cfv cfv wceq vu cv chil
      wcel vz cv cch wcel vw cv cch wcel wa vz cv vw cv chj co cch wcel vz cv
      vw cv chj co cS cfv vu cv vz cv vw cv chj co cpj cfv cfv wceq vz cv vw cv
      chjcl vx vy vu vz cv vw cv chj co cS hstrlem3a.1 hstrlem2 syl 3adant3
      adantr vz cv cch wcel vw cv cch wcel vu cv chil wcel w3a vz cv cS cfv vw
      cv cS cfv cva co vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv cva co
      wceq vz cv vw cv cort cfv wss vz cv cch wcel vw cv cch wcel vz cv cS cfv
      vw cv cS cfv cva co vu cv vz cv cpj cfv cfv vu cv vw cv cpj cfv cfv cva
      co wceq vu cv chil wcel vz cv cch wcel vw cv cch wcel vz cv cS cfv vu cv
      vz cv cpj cfv cfv vw cv cS cfv vu cv vw cv cpj cfv cfv cva vx vy vu vz cv
      cS hstrlem3a.1 hstrlem2 vx vy vu vw cv cS hstrlem3a.1 hstrlem2 opreqan12d
      3adant3 adantr 3eqtr4d jca 3exp1 com3r adantr r19.21adv r19.21aiv 3jca vz
      vw cS hstel sylibr $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)
  $}

  ${
    $d x z w ph $.  $d z w S $.  $d x y u $.  $d y z w $.
    $d x y A $.  $d x y B $.
    hstrlem3.1 $e |- S = { <. x , y >. | ( x e. CH /\
                      y = ( ( proj ` x ) ` u ) ) } $.
    hstrlem3.2 $e |- ( ph <-> ( u e. ( A \ B ) /\ ( normh ` u ) = 1 ) ) $.
    hstrlem3.3 $e |- A e. CH $.
    hstrlem3.4 $e |- B e. CH $.
    $( Lemma for strong set of CH states theorem:  the function ` S ` ,
       that maps a closed  subspace to the square of the norm of its projection
       onto a unit vector, is a state.  This lemma restates the hypotheses in a
       more convenient form to work with. $)
    hstrlem3 $p |- ( ph -> S e. CHStates ) $=
      wph vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa cS chst wcel
      hstrlem3.2 vu cv chil wcel vu cv cno cfv c1 wceq cS chst wcel vu cv cA cB
      cdif wcel vx vy vu cS hstrlem3.1 hstrlem3a vu cv cA cB cdif wcel vu cv cA
      wcel vu cv chil wcel vu cv cA cB eldifi vu cv cA hstrlem3.3 cheli syl
      sylan sylbi $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)

    $( Lemma for strong set of CH states theorem. $)
    hstrlem4 $p |- ( ph -> ( normh ` ( S ` A ) ) = 1 ) $=
      wph vu cv cA cpj cfv cfv cno cfv c1 cA cS cfv cno cfv wph vu cv cA cB
      cdif wcel vu cv cno cfv c1 wceq wa vu cv cA cpj cfv cfv cno cfv c1 wceq
      hstrlem3.2 vu cv cA wcel vu cv cno cfv c1 wceq vu cv cA cpj cfv cfv cno
      cfv c1 wceq vu cv cA cB cdif wcel vu cv cno cfv c1 wceq vu cv cA wcel vu
      cv cA cpj cfv cfv cno cfv c1 wceq vu cv cno cfv c1 wceq vu cv cA cpj cfv
      cfv cno cfv vu cv cno cfv wceq vu cv cA cpj cfv cfv cno cfv c1 wceq vu cv
      cA wcel vu cv cno cfv c1 vu cv cA cpj cfv cfv cno cfv eqeq2 vu cv cA wcel
      vu cv cA cpj cfv cfv vu cv cno cA cch wcel vu cv cA wcel vu cv cA cpj cfv
      cfv vu cv wceq hstrlem3.3 vu cv cA pjid mpan fveq2d syl5bi impcom vu cv
      cA cB eldifi sylan sylbi cA cS cfv vu cv cA cpj cfv cfv cno cA cch wcel
      cA cS cfv vu cv cA cpj cfv cfv wceq hstrlem3.3 vx vy vu cA cS hstrlem3.1
      hstrlem2 ax-mp fveq2i syl5eq $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)

    $( Lemma for strong set of CH states theorem. $)
    hstrlem5 $p |- ( ph -> ( normh ` ( S ` B ) ) < 1 ) $=
      wph vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa cB cS cfv cno cfv c1
      clt wbr hstrlem3.2 vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa vu cv
      cB cpj cfv cfv cno cfv c1 cB cS cfv cno cfv clt vu cv cno cfv c1 wceq vu
      cv cA cB cdif wcel vu cv cB cpj cfv cfv cno cfv c1 clt wbr vu cv cno cfv
      c1 wceq vu cv cB cpj cfv cfv cno cfv vu cv cno cfv clt wbr vu cv cB cpj
      cfv cfv cno cfv c1 clt wbr vu cv cA cB cdif wcel vu cv cno cfv c1 vu cv
      cB cpj cfv cfv cno cfv clt breq2 vu cv cA cB cdif wcel vu cv cA wcel vu
      cv cB wcel wn wa vu cv cB cpj cfv cfv cno cfv vu cv cno cfv clt wbr vu cv
      cA cB eldif vu cv chil wcel vu cv cB wcel wn vu cv cB cpj cfv cfv cno cfv
      vu cv cno cfv clt wbr vu cv cA wcel vu cv chil wcel vu cv cB wcel wn vu
      cv cB cpj cfv cfv cno cfv vu cv cno cfv clt wbr cB cch wcel vu cv chil
      wcel vu cv cB wcel wn vu cv cB cpj cfv cfv cno cfv vu cv cno cfv clt wbr
      wb hstrlem3.4 vu cv cB pjnel mpan biimpa vu cv cA hstrlem3.3 cheli sylan
      sylbi syl5bi impcom cB cch wcel cB cS cfv cno cfv vu cv cB cpj cfv cfv
      cno cfv wceq hstrlem3.4 cB cch wcel cB cS cfv vu cv cB cpj cfv cfv cno vx
      vy vu cB cS hstrlem3.1 hstrlem2 fveq2d ax-mp syl5eqbr sylbi $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)

    $( Lemma for strong set of CH states theorem. $)
    hstrlem6 $p |- ( ph -> -. ( ( normh ` ( S ` A ) ) = 1 ->
                    ( normh ` ( S ` B ) ) = 1 ) ) $=
      wph cA cS cfv cno cfv c1 wceq cB cS cfv cno cfv c1 wceq wn wa cA cS cfv
      cno cfv c1 wceq cB cS cfv cno cfv c1 wceq wi wn wph cA cS cfv cno cfv c1
      wceq cB cS cfv cno cfv c1 wceq wn wph vx vy vu cA cB cS hstrlem3.1
      hstrlem3.2 hstrlem3.3 hstrlem3.4 hstrlem4 wph cB cS cfv cno cfv c1 wne cB
      cS cfv cno cfv c1 wceq wn wph c1 cB cS cfv cno cfv cB cS cfv cno cfv cr
      wcel cB cS cfv cno cfv c1 clt wbr c1 cB cS cfv cno cfv wne wph cB cS cfv
      cno cfv cr wcel c1 cr wcel cB cS cfv cno cfv c1 clt wbr c1 cB cS cfv cno
      cfv wne 1re cB cS cfv cno cfv c1 ltne mp3an2 wph cS chst wcel cB cS cfv
      chil wcel cB cS cfv cno cfv cr wcel wph vx vy vu cA cB cS hstrlem3.1
      hstrlem3.2 hstrlem3.3 hstrlem3.4 hstrlem3 cS chst wcel cB cch wcel cB cS
      cfv chil wcel hstrlem3.4 cB cS hstcl mpan2 cB cS cfv normcl 3syl wph vx
      vy vu cA cB cS hstrlem3.1 hstrlem3.2 hstrlem3.3 hstrlem3.4 hstrlem5
      sylanc necomd cB cS cfv cno cfv c1 df-ne sylib jca cA cS cfv cno cfv c1
      wceq cB cS cfv cno cfv c1 wceq annim sylib $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)
  $}

  ${
    $d x y u f A $.  $d x y u f B $.
    hstr.1 $e |- A e. CH $.
    hstr.2 $e |- B e. CH $.
    $( Hilbert space admits a strong set of Hilbert-space-valued states
       (CH-states).  Theorem in [Mayet3] p. 10. $)
    hstri $p |- ( A. f e. CHStates ( ( normh ` ( f ` A ) ) = 1 ->
                ( normh ` ( f ` B ) ) = 1 ) -> A C_ B ) $=
      cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi vf chst wral
      cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi wn vf chst
      wrex wn cA cB wss cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1
      wceq wi vf chst dfral2 cA cB wss cA vf cv cfv cno cfv c1 wceq cB vf cv
      cfv cno cfv c1 wceq wi wn vf chst wrex cA cB wss wn vu cv cno cfv c1 wceq
      vu cA cB cdif wrex cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1
      wceq wi wn vf chst wrex vu cA cB hstr.1 hstr.2 strlem1 vu cv cno cfv c1
      wceq cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi wn vf
      chst wrex vu cA cB cdif vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq
      wa vx vy copab chst wcel cA vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv
      wceq wa vx vy copab cfv cno cfv c1 wceq cB vx cv cch wcel vy cv vu cv vx
      cv cpj cfv cfv wceq wa vx vy copab cfv cno cfv c1 wceq wi wn cA vf cv cfv
      cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi wn vf chst wrex vu cv cA
      cB cdif wcel vu cv cno cfv c1 wceq wa cA vf cv cfv cno cfv c1 wceq cB vf
      cv cfv cno cfv c1 wceq wi wn cA vx cv cch wcel vy cv vu cv vx cv cpj cfv
      cfv wceq wa vx vy copab cfv cno cfv c1 wceq cB vx cv cch wcel vy cv vu cv
      vx cv cpj cfv cfv wceq wa vx vy copab cfv cno cfv c1 wceq wi wn vf vx cv
      cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab chst vf cv vx
      cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab wceq cA vf
      cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi cA vx cv cch wcel
      vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab cfv cno cfv c1 wceq cB
      vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab cfv cno
      cfv c1 wceq wi vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa
      vx vy copab wceq cA vf cv cfv cno cfv c1 wceq cA vx cv cch wcel vy cv vu
      cv vx cv cpj cfv cfv wceq wa vx vy copab cfv cno cfv c1 wceq cB vf cv cfv
      cno cfv c1 wceq cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa
      vx vy copab cfv cno cfv c1 wceq vf cv vx cv cch wcel vy cv vu cv vx cv
      cpj cfv cfv wceq wa vx vy copab wceq cA vf cv cfv cno cfv cA vx cv cch
      wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab cfv cno cfv c1 vf
      cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab wceq
      cA vf cv cfv cA vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx
      vy copab cfv cno cA vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv
      wceq wa vx vy copab fveq1 fveq2d eqeq1d vf cv vx cv cch wcel vy cv vu cv
      vx cv cpj cfv cfv wceq wa vx vy copab wceq cB vf cv cfv cno cfv cB vx cv
      cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab cfv cno cfv c1
      vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa vx vy copab
      wceq cB vf cv cfv cB vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv wceq wa
      vx vy copab cfv cno cB vf cv vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv
      wceq wa vx vy copab fveq1 fveq2d eqeq1d imbi12d notbid rcla4ev vu cv cA
      cB cdif wcel vu cv cno cfv c1 wceq wa vx vy vu cA cB vx cv cch wcel vy cv
      vu cv vx cv cpj cfv cfv wceq wa vx vy copab vx cv cch wcel vy cv vu cv vx
      cv cpj cfv cfv wceq wa vx vy copab eqid vu cv cA cB cdif wcel vu cv cno
      cfv c1 wceq wa biid hstr.1 hstr.2 hstrlem3 vu cv cA cB cdif wcel vu cv
      cno cfv c1 wceq wa vx vy vu cA cB vx cv cch wcel vy cv vu cv vx cv cpj
      cfv cfv wceq wa vx vy copab vx cv cch wcel vy cv vu cv vx cv cpj cfv cfv
      wceq wa vx vy copab eqid vu cv cA cB cdif wcel vu cv cno cfv c1 wceq wa
      biid hstr.1 hstr.2 hstrlem6 sylanc r19.23aiva syl con1i sylbi $.
      $( [23-Jul-2006] $) $( [30-Jun-2006] $)

    $( Strong CH-state theorem (bidirectional version).  Theorem in [Mayet3]
       p. 10 and its converse. $)
    hstrbi $p |- ( A. f e. CHStates ( ( normh ` ( f ` A ) ) = 1 ->
              ( normh ` ( f ` B ) ) = 1 ) <-> A C_ B ) $=
      cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi vf chst wral
      cA cB wss cA cB vf hstr.1 hstr.2 hstri cA cB wss cA vf cv cfv cno cfv c1
      wceq cB vf cv cfv cno cfv c1 wceq wi vf chst vf cv chst wcel cA cB wss cA
      vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi vf cv chst wcel
      cA cch wcel cA cB wss cA vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv
      c1 wceq wi hstr.1 vf cv chst wcel cA cch wcel wa cB cch wcel cA cB wss cA
      vf cv cfv cno cfv c1 wceq cB vf cv cfv cno cfv c1 wceq wi hstr.2 cA cB vf
      cv hstles mpanr1 mpanl2 expcom r19.21aiv impbii $.
      $( [7-Oct-2006] $) $( [30-Jun-2006] $)
  $}

  ${
    $d f A $.
    large.1 $e |- A e. CH $.
    $( A Hilbert lattice admits a largei set of states.  Remark in [Mayet]
       p. 370. $)
    largei $p |- ( -. A = 0H <-> E. f e. States ( f ` A ) = 1 ) $=
      cA vf cv cfv c1 wceq vf cst wrex cA c0h wceq cA vf cv cfv c1 wceq vf cst
      wrex wn cA vf cv cfv c1 wceq wn vf cst wral cA c0h wceq cA vf cv cfv c1
      wceq vf cst ralnex cA vf cv cfv c1 wceq wn vf cst wral cA vf cv cfv c1
      wceq c0h vf cv cfv c1 wceq wi vf cst wral cA c0h wss cA c0h wceq cA vf cv
      cfv c1 wceq wn cA vf cv cfv c1 wceq c0h vf cv cfv c1 wceq wi vf cst vf cv
      cst wcel c0h vf cv cfv c1 wceq wn cA vf cv cfv c1 wceq wn cA vf cv cfv c1
      wceq c0h vf cv cfv c1 wceq wi wb vf cv cst wcel c0h vf cv cfv c1 wceq c1
      cc0 wceq c1 cc0 wne c1 cc0 wceq wn ax1ne0 c1 cc0 df-ne mpbi vf cv cst
      wcel c0h vf cv cfv c1 wceq cc0 c1 wceq c1 cc0 wceq vf cv cst wcel c0h vf
      cv cfv cc0 c1 vf cv st0 eqeq1d cc0 c1 eqcom syl6bb mtbiri c0h vf cv cfv
      c1 wceq cA vf cv cfv c1 wceq mtt syl ralbiia cA c0h vf large.1 h0elch
      strbi cA large.1 chle0i 3bitri bitr3i con1bii $.
      $( [7-Apr-2001] $)
  $}

  ${
    jplem1.1 $e |- A e. CH $.
    $( Lemma for Jauch-Piron theorem. $)
    jplem1 $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) ->
          ( u e. A <-> ( ( normh ` ( ( proj ` A ) ` u ) ) ^ 2 ) = 1 ) ) $=
      vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv cA wcel vu cv cA cpj cfv
      cfv cno cfv c1 wceq vu cv cA cpj cfv cfv cno cfv c2 cexp co c1 wceq vu cv
      chil wcel vu cv cA wcel vu cv cA cpj cfv cfv cno cfv vu cv cno cfv wceq
      vu cv cno cfv c1 wceq vu cv cA cpj cfv cfv cno cfv c1 wceq cA cch wcel vu
      cv chil wcel vu cv cA wcel vu cv cA cpj cfv cfv cno cfv vu cv cno cfv
      wceq wb jplem1.1 vu cv cA pjnorm2 mpan vu cv cno cfv c1 vu cv cA cpj cfv
      cfv cno cfv eqeq2 sylan9bb vu cv chil wcel vu cv cA cpj cfv cfv cno cfv
      c2 cexp co c1 wceq vu cv cA cpj cfv cfv cno cfv c1 wceq wb vu cv cno cfv
      c1 wceq vu cv chil wcel vu cv cA cpj cfv cfv cno cfv c2 cexp co c1 c2
      cexp co wceq vu cv cA cpj cfv cfv cno cfv c1 wceq vu cv cA cpj cfv cfv
      cno cfv c2 cexp co c1 wceq vu cv cA cpj cfv cfv cno cfv cr wcel cc0 vu cv
      cA cpj cfv cfv cno cfv cle wbr vu cv cA cpj cfv cfv cno cfv c2 cexp co c1
      c2 cexp co wceq vu cv cA cpj cfv cfv cno cfv c1 wceq wb vu cv chil wcel
      vu cv cA cpj cfv cfv cno cfv cr wcel cc0 vu cv cA cpj cfv cfv cno cfv cle
      wbr wa c1 cr wcel cc0 c1 cle wbr vu cv cA cpj cfv cfv cno cfv c2 cexp co
      c1 c2 cexp co wceq vu cv cA cpj cfv cfv cno cfv c1 wceq wb 1re cc0 c1 0re
      1re lt01 ltleii vu cv cA cpj cfv cfv cno cfv c1 sq11 mpanr12 vu cv chil
      wcel vu cv cA cpj cfv cfv chil wcel vu cv cA cpj cfv cfv cno cfv cr wcel
      vu cv cA jplem1.1 pjhcli vu cv cA cpj cfv cfv normcl syl vu cv chil wcel
      vu cv cA cpj cfv cfv chil wcel cc0 vu cv cA cpj cfv cfv cno cfv cle wbr
      vu cv cA jplem1.1 pjhcli vu cv cA cpj cfv cfv normge0 syl sylanc c1 c2
      cexp co c1 vu cv cA cpj cfv cfv cno cfv c2 cexp co sq1 eqeq2i syl5bbr
      adantr bitr4d $.
      $( [31-Jul-2006] $) $( [8-Apr-2001] $)
  $}

  ${
    $d x z w u $.  $d z w S $.  $d x y u $.  $d y z w $.
    $d x y A $.  $d x y B $.
    jp.1 $e |- S = { <. x , y >. | ( x e. CH /\
                    y = ( ( normh ` ( ( proj ` x ) ` u ) ) ^ 2 ) ) } $.
    jp.2 $e |- A e. CH $.
    $( Lemma for Jauch-Piron theorem. $)
    jplem2 $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) ->
                 ( u e. A <-> ( S ` A ) = 1 ) ) $=
      vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv cA wcel vu cv cA cpj cfv
      cfv cno cfv c2 cexp co c1 wceq cA cS cfv c1 wceq vu cA jp.2 jplem1 cA cS
      cfv vu cv cA cpj cfv cfv cno cfv c2 cexp co c1 cA cch wcel cA cS cfv vu
      cv cA cpj cfv cfv cno cfv c2 cexp co wceq jp.2 vx vy vu cA cS jp.1
      strlem2 ax-mp eqeq1i syl6bbr $.
      $( [8-Apr-2001] $)

    ${
      jp.3 $e |- B e. CH $.
      $( The function ` S ` , that maps a closed subspace to the square of the
         norm of its projection onto a unit vector, is a Jauch-Piron state.
         Remark in [Mayet] p. 370.  (See ~ strlem3a for the proof that ` S ` is
         a state.) $)
      jpi $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) -> ( ( ( S ` A ) = 1
               /\ ( S ` B ) = 1 ) <-> ( S ` ( A i^i B ) ) = 1 ) ) $=
        vu cv chil wcel vu cv cno cfv c1 wceq wa vu cv cA cB cin wcel cA cS cfv
        c1 wceq cB cS cfv c1 wceq wa cA cB cin cS cfv c1 wceq vu cv chil wcel
        vu cv cno cfv c1 wceq wa vu cv cA wcel vu cv cB wcel wa cA cS cfv c1
        wceq cB cS cfv c1 wceq wa vu cv cA cB cin wcel vu cv chil wcel vu cv
        cno cfv c1 wceq wa vu cv cA wcel cA cS cfv c1 wceq vu cv cB wcel cB cS
        cfv c1 wceq vx vy vu cA cS jp.1 jp.2 jplem2 vx vy vu cB cS jp.1 jp.3
        jplem2 anbi12d vu cv cA cB elin syl5bb vx vy vu cA cB cin cS jp.1 cA cB
        jp.2 jp.3 chincli jplem2 bitr3d $.
        $( [8-Apr-2001] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Godowski's equation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    golem1.1 $e |- A e. CH $.
    golem1.2 $e |- B e. CH $.
    golem1.3 $e |- C e. CH $.
    golem1.4 $e |- F = ( ( _|_ ` A ) vH ( A i^i B ) ) $.
    golem1.5 $e |- G = ( ( _|_ ` B ) vH ( B i^i C ) ) $.
    golem1.6 $e |- H = ( ( _|_ ` C ) vH ( C i^i A ) ) $.
    golem1.7 $e |- D = ( ( _|_ ` B ) vH ( B i^i A ) ) $.
    golem1.8 $e |- R = ( ( _|_ ` C ) vH ( C i^i B ) ) $.
    golem1.9 $e |- S = ( ( _|_ ` A ) vH ( A i^i C ) ) $.
    $( Lemma for Godowski's equation. $)
    golem1 $p |- ( f e. States -> ( ( ( f ` F ) + ( f ` G ) ) + ( f ` H ) ) =
                 ( ( ( f ` D ) + ( f ` R ) ) + ( f ` S ) ) ) $=
      vf cv cst wcel cA cort cfv cA cB cin chj co vf cv cfv cB cort cfv cB cC
      cin chj co vf cv cfv caddc co cC cort cfv cC cA cin chj co vf cv cfv
      caddc co cB cort cfv cB cA cin chj co vf cv cfv cC cort cfv cC cB cin chj
      co vf cv cfv caddc co cA cort cfv cA cC cin chj co vf cv cfv caddc co cF
      vf cv cfv cG vf cv cfv caddc co cH vf cv cfv caddc co cD vf cv cfv cR vf
      cv cfv caddc co cS vf cv cfv caddc co vf cv cst wcel cA cort cfv vf cv
      cfv cA cB cin vf cv cfv caddc co cB cort cfv vf cv cfv cB cC cin vf cv
      cfv caddc co caddc co cC cort cfv vf cv cfv cC cA cin vf cv cfv caddc co
      caddc co cB cort cfv vf cv cfv cA cB cin vf cv cfv caddc co cC cort cfv
      vf cv cfv cB cC cin vf cv cfv caddc co caddc co cA cort cfv vf cv cfv cC
      cA cin vf cv cfv caddc co caddc co cA cort cfv cA cB cin chj co vf cv cfv
      cB cort cfv cB cC cin chj co vf cv cfv caddc co cC cort cfv cC cA cin chj
      co vf cv cfv caddc co cB cort cfv cB cA cin chj co vf cv cfv cC cort cfv
      cC cB cin chj co vf cv cfv caddc co cA cort cfv cA cC cin chj co vf cv
      cfv caddc co vf cv cst wcel cA cort cfv vf cv cfv cB cort cfv vf cv cfv
      caddc co cA cB cin vf cv cfv cB cC cin vf cv cfv caddc co caddc co cC
      cort cfv vf cv cfv cC cA cin vf cv cfv caddc co caddc co cB cort cfv vf
      cv cfv cC cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf cv
      cfv caddc co caddc co cA cort cfv vf cv cfv cC cA cin vf cv cfv caddc co
      caddc co cA cort cfv vf cv cfv cA cB cin vf cv cfv caddc co cB cort cfv
      vf cv cfv cB cC cin vf cv cfv caddc co caddc co cC cort cfv vf cv cfv cC
      cA cin vf cv cfv caddc co caddc co cB cort cfv vf cv cfv cA cB cin vf cv
      cfv caddc co cC cort cfv vf cv cfv cB cC cin vf cv cfv caddc co caddc co
      cA cort cfv vf cv cfv cC cA cin vf cv cfv caddc co caddc co vf cv cst
      wcel cA cort cfv vf cv cfv cB cort cfv vf cv cfv caddc co cC cort cfv vf
      cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf cv cfv caddc co cC cA
      cin vf cv cfv caddc co caddc co cB cort cfv vf cv cfv cC cort cfv vf cv
      cfv caddc co cA cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin
      vf cv cfv caddc co cC cA cin vf cv cfv caddc co caddc co cA cort cfv vf
      cv cfv cB cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf cv
      cfv caddc co caddc co cC cort cfv vf cv cfv cC cA cin vf cv cfv caddc co
      caddc co cB cort cfv vf cv cfv cC cort cfv vf cv cfv caddc co cA cB cin
      vf cv cfv cB cC cin vf cv cfv caddc co caddc co cA cort cfv vf cv cfv cC
      cA cin vf cv cfv caddc co caddc co vf cv cst wcel cA cort cfv vf cv cfv
      cB cort cfv vf cv cfv caddc co cC cort cfv vf cv cfv caddc co cB cort cfv
      vf cv cfv cC cort cfv vf cv cfv caddc co cA cort cfv vf cv cfv caddc co
      cA cB cin vf cv cfv cB cC cin vf cv cfv caddc co cC cA cin vf cv cfv
      caddc co caddc vf cv cst wcel cA cort cfv vf cv cfv cB cort cfv vf cv cfv
      caddc co cC cort cfv vf cv cfv caddc co cA cort cfv vf cv cfv cB cort cfv
      vf cv cfv cC cort cfv vf cv cfv caddc co caddc co cB cort cfv vf cv cfv
      cC cort cfv vf cv cfv caddc co cA cort cfv vf cv cfv caddc co cA cort cfv
      vf cv cfv cc wcel cB cort cfv vf cv cfv cc wcel cC cort cfv vf cv cfv cc
      wcel cA cort cfv vf cv cfv cB cort cfv vf cv cfv caddc co cC cort cfv vf
      cv cfv caddc co cA cort cfv vf cv cfv cB cort cfv vf cv cfv cC cort cfv
      vf cv cfv caddc co caddc co wceq vf cv cst wcel cA cort cfv vf cv cfv cB
      cort cfv vf cv cfv cC cort cfv vf cv cfv addass vf cv cst wcel cA cort
      cfv vf cv cfv vf cv cst wcel cA cort cfv cch wcel cA cort cfv vf cv cfv
      cr wcel cA golem1.1 choccli cA cort cfv vf cv stcl mpi recnd vf cv cst
      wcel cB cort cfv vf cv cfv vf cv cst wcel cB cort cfv cch wcel cB cort
      cfv vf cv cfv cr wcel cB golem1.2 choccli cB cort cfv vf cv stcl mpi
      recnd vf cv cst wcel cC cort cfv vf cv cfv vf cv cst wcel cC cort cfv cch
      wcel cC cort cfv vf cv cfv cr wcel cC golem1.3 choccli cC cort cfv vf cv
      stcl mpi recnd syl3anc cA cort cfv vf cv cfv cc wcel cB cort cfv vf cv
      cfv cC cort cfv vf cv cfv caddc co cc wcel cA cort cfv vf cv cfv cB cort
      cfv vf cv cfv cC cort cfv vf cv cfv caddc co caddc co cB cort cfv vf cv
      cfv cC cort cfv vf cv cfv caddc co cA cort cfv vf cv cfv caddc co wceq vf
      cv cst wcel cA cort cfv vf cv cfv cB cort cfv vf cv cfv cC cort cfv vf cv
      cfv caddc co addcom vf cv cst wcel cA cort cfv vf cv cfv vf cv cst wcel
      cA cort cfv cch wcel cA cort cfv vf cv cfv cr wcel cA golem1.1 choccli cA
      cort cfv vf cv stcl mpi recnd cB cort cfv vf cv cfv cc wcel cC cort cfv
      vf cv cfv cc wcel cB cort cfv vf cv cfv cC cort cfv vf cv cfv caddc co cc
      wcel vf cv cst wcel cB cort cfv vf cv cfv cC cort cfv vf cv cfv addcl vf
      cv cst wcel cB cort cfv vf cv cfv vf cv cst wcel cB cort cfv cch wcel cB
      cort cfv vf cv cfv cr wcel cB golem1.2 choccli cB cort cfv vf cv stcl mpi
      recnd vf cv cst wcel cC cort cfv vf cv cfv vf cv cst wcel cC cort cfv cch
      wcel cC cort cfv vf cv cfv cr wcel cC golem1.3 choccli cC cort cfv vf cv
      stcl mpi recnd sylanc sylanc eqtrd opreq1d cA cort cfv vf cv cfv cB cort
      cfv vf cv cfv caddc co cc wcel cA cB cin vf cv cfv cB cC cin vf cv cfv
      caddc co cc wcel cC cort cfv vf cv cfv cc wcel cC cA cin vf cv cfv cc
      wcel cA cort cfv vf cv cfv cB cort cfv vf cv cfv caddc co cA cB cin vf cv
      cfv cB cC cin vf cv cfv caddc co caddc co cC cort cfv vf cv cfv cC cA cin
      vf cv cfv caddc co caddc co cA cort cfv vf cv cfv cB cort cfv vf cv cfv
      caddc co cC cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf
      cv cfv caddc co cC cA cin vf cv cfv caddc co caddc co wceq vf cv cst wcel
      cA cort cfv vf cv cfv cB cort cfv vf cv cfv caddc co cA cB cin vf cv cfv
      cB cC cin vf cv cfv caddc co cC cort cfv vf cv cfv cC cA cin vf cv cfv
      add4 cA cort cfv vf cv cfv cc wcel cB cort cfv vf cv cfv cc wcel cA cort
      cfv vf cv cfv cB cort cfv vf cv cfv caddc co cc wcel vf cv cst wcel cA
      cort cfv vf cv cfv cB cort cfv vf cv cfv addcl vf cv cst wcel cA cort cfv
      vf cv cfv vf cv cst wcel cA cort cfv cch wcel cA cort cfv vf cv cfv cr
      wcel cA golem1.1 choccli cA cort cfv vf cv stcl mpi recnd vf cv cst wcel
      cB cort cfv vf cv cfv vf cv cst wcel cB cort cfv cch wcel cB cort cfv vf
      cv cfv cr wcel cB golem1.2 choccli cB cort cfv vf cv stcl mpi recnd
      sylanc cA cB cin vf cv cfv cc wcel cB cC cin vf cv cfv cc wcel cA cB cin
      vf cv cfv cB cC cin vf cv cfv caddc co cc wcel vf cv cst wcel cA cB cin
      vf cv cfv cB cC cin vf cv cfv addcl vf cv cst wcel cA cB cin vf cv cfv vf
      cv cst wcel cA cB cin cch wcel cA cB cin vf cv cfv cr wcel cA cB golem1.1
      golem1.2 chincli cA cB cin vf cv stcl mpi recnd vf cv cst wcel cB cC cin
      vf cv cfv vf cv cst wcel cB cC cin cch wcel cB cC cin vf cv cfv cr wcel
      cB cC golem1.2 golem1.3 chincli cB cC cin vf cv stcl mpi recnd sylanc vf
      cv cst wcel cC cort cfv vf cv cfv vf cv cst wcel cC cort cfv cch wcel cC
      cort cfv vf cv cfv cr wcel cC golem1.3 choccli cC cort cfv vf cv stcl mpi
      recnd vf cv cst wcel cC cA cin vf cv cfv vf cv cst wcel cC cA cin cch
      wcel cC cA cin vf cv cfv cr wcel cC cA golem1.3 golem1.1 chincli cC cA
      cin vf cv stcl mpi recnd syl2anc cB cort cfv vf cv cfv cC cort cfv vf cv
      cfv caddc co cc wcel cA cB cin vf cv cfv cB cC cin vf cv cfv caddc co cc
      wcel cA cort cfv vf cv cfv cc wcel cC cA cin vf cv cfv cc wcel cB cort
      cfv vf cv cfv cC cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC
      cin vf cv cfv caddc co caddc co cA cort cfv vf cv cfv cC cA cin vf cv cfv
      caddc co caddc co cB cort cfv vf cv cfv cC cort cfv vf cv cfv caddc co cA
      cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf cv cfv caddc
      co cC cA cin vf cv cfv caddc co caddc co wceq vf cv cst wcel cB cort cfv
      vf cv cfv cC cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf
      cv cfv caddc co cA cort cfv vf cv cfv cC cA cin vf cv cfv add4 cB cort
      cfv vf cv cfv cc wcel cC cort cfv vf cv cfv cc wcel cB cort cfv vf cv cfv
      cC cort cfv vf cv cfv caddc co cc wcel vf cv cst wcel cB cort cfv vf cv
      cfv cC cort cfv vf cv cfv addcl vf cv cst wcel cB cort cfv vf cv cfv vf
      cv cst wcel cB cort cfv cch wcel cB cort cfv vf cv cfv cr wcel cB
      golem1.2 choccli cB cort cfv vf cv stcl mpi recnd vf cv cst wcel cC cort
      cfv vf cv cfv vf cv cst wcel cC cort cfv cch wcel cC cort cfv vf cv cfv
      cr wcel cC golem1.3 choccli cC cort cfv vf cv stcl mpi recnd sylanc cA cB
      cin vf cv cfv cc wcel cB cC cin vf cv cfv cc wcel cA cB cin vf cv cfv cB
      cC cin vf cv cfv caddc co cc wcel vf cv cst wcel cA cB cin vf cv cfv cB
      cC cin vf cv cfv addcl vf cv cst wcel cA cB cin vf cv cfv vf cv cst wcel
      cA cB cin cch wcel cA cB cin vf cv cfv cr wcel cA cB golem1.1 golem1.2
      chincli cA cB cin vf cv stcl mpi recnd vf cv cst wcel cB cC cin vf cv cfv
      vf cv cst wcel cB cC cin cch wcel cB cC cin vf cv cfv cr wcel cB cC
      golem1.2 golem1.3 chincli cB cC cin vf cv stcl mpi recnd sylanc vf cv cst
      wcel cA cort cfv vf cv cfv vf cv cst wcel cA cort cfv cch wcel cA cort
      cfv vf cv cfv cr wcel cA golem1.1 choccli cA cort cfv vf cv stcl mpi
      recnd vf cv cst wcel cC cA cin vf cv cfv vf cv cst wcel cC cA cin cch
      wcel cC cA cin vf cv cfv cr wcel cC cA golem1.3 golem1.1 chincli cC cA
      cin vf cv stcl mpi recnd syl2anc 3eqtr4d vf cv cst wcel cA cort cfv vf cv
      cfv cA cB cin vf cv cfv caddc co cB cort cfv vf cv cfv cB cC cin vf cv
      cfv caddc co caddc co cA cort cfv vf cv cfv cB cort cfv vf cv cfv caddc
      co cA cB cin vf cv cfv cB cC cin vf cv cfv caddc co caddc co cC cort cfv
      vf cv cfv cC cA cin vf cv cfv caddc co caddc cA cort cfv vf cv cfv cc
      wcel cA cB cin vf cv cfv cc wcel cB cort cfv vf cv cfv cc wcel cB cC cin
      vf cv cfv cc wcel cA cort cfv vf cv cfv cA cB cin vf cv cfv caddc co cB
      cort cfv vf cv cfv cB cC cin vf cv cfv caddc co caddc co cA cort cfv vf
      cv cfv cB cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC cin vf cv
      cfv caddc co caddc co wceq vf cv cst wcel cA cort cfv vf cv cfv cA cB cin
      vf cv cfv cB cort cfv vf cv cfv cB cC cin vf cv cfv add4 vf cv cst wcel
      cA cort cfv vf cv cfv vf cv cst wcel cA cort cfv cch wcel cA cort cfv vf
      cv cfv cr wcel cA golem1.1 choccli cA cort cfv vf cv stcl mpi recnd vf cv
      cst wcel cA cB cin vf cv cfv vf cv cst wcel cA cB cin cch wcel cA cB cin
      vf cv cfv cr wcel cA cB golem1.1 golem1.2 chincli cA cB cin vf cv stcl
      mpi recnd vf cv cst wcel cB cort cfv vf cv cfv vf cv cst wcel cB cort cfv
      cch wcel cB cort cfv vf cv cfv cr wcel cB golem1.2 choccli cB cort cfv vf
      cv stcl mpi recnd vf cv cst wcel cB cC cin vf cv cfv vf cv cst wcel cB cC
      cin cch wcel cB cC cin vf cv cfv cr wcel cB cC golem1.2 golem1.3 chincli
      cB cC cin vf cv stcl mpi recnd syl2anc opreq1d vf cv cst wcel cB cort cfv
      vf cv cfv cA cB cin vf cv cfv caddc co cC cort cfv vf cv cfv cB cC cin vf
      cv cfv caddc co caddc co cB cort cfv vf cv cfv cC cort cfv vf cv cfv
      caddc co cA cB cin vf cv cfv cB cC cin vf cv cfv caddc co caddc co cA
      cort cfv vf cv cfv cC cA cin vf cv cfv caddc co caddc cB cort cfv vf cv
      cfv cc wcel cA cB cin vf cv cfv cc wcel cC cort cfv vf cv cfv cc wcel cB
      cC cin vf cv cfv cc wcel cB cort cfv vf cv cfv cA cB cin vf cv cfv caddc
      co cC cort cfv vf cv cfv cB cC cin vf cv cfv caddc co caddc co cB cort
      cfv vf cv cfv cC cort cfv vf cv cfv caddc co cA cB cin vf cv cfv cB cC
      cin vf cv cfv caddc co caddc co wceq vf cv cst wcel cB cort cfv vf cv cfv
      cA cB cin vf cv cfv cC cort cfv vf cv cfv cB cC cin vf cv cfv add4 vf cv
      cst wcel cB cort cfv vf cv cfv vf cv cst wcel cB cort cfv cch wcel cB
      cort cfv vf cv cfv cr wcel cB golem1.2 choccli cB cort cfv vf cv stcl mpi
      recnd vf cv cst wcel cA cB cin vf cv cfv vf cv cst wcel cA cB cin cch
      wcel cA cB cin vf cv cfv cr wcel cA cB golem1.1 golem1.2 chincli cA cB
      cin vf cv stcl mpi recnd vf cv cst wcel cC cort cfv vf cv cfv vf cv cst
      wcel cC cort cfv cch wcel cC cort cfv vf cv cfv cr wcel cC golem1.3
      choccli cC cort cfv vf cv stcl mpi recnd vf cv cst wcel cB cC cin vf cv
      cfv vf cv cst wcel cB cC cin cch wcel cB cC cin vf cv cfv cr wcel cB cC
      golem1.2 golem1.3 chincli cB cC cin vf cv stcl mpi recnd syl2anc opreq1d
      3eqtr4d vf cv cst wcel cA cort cfv cA cB cin chj co vf cv cfv cB cort cfv
      cB cC cin chj co vf cv cfv caddc co cA cort cfv vf cv cfv cA cB cin vf cv
      cfv caddc co cB cort cfv vf cv cfv cB cC cin vf cv cfv caddc co caddc co
      cC cort cfv cC cA cin chj co vf cv cfv cC cort cfv vf cv cfv cC cA cin vf
      cv cfv caddc co caddc vf cv cst wcel cA cort cfv cA cB cin chj co vf cv
      cfv cA cort cfv vf cv cfv cA cB cin vf cv cfv caddc co cB cort cfv cB cC
      cin chj co vf cv cfv cB cort cfv vf cv cfv cB cC cin vf cv cfv caddc co
      caddc cA cB vf cv golem1.1 golem1.2 stji1i cB cC vf cv golem1.2 golem1.3
      stji1i opreq12d cC cA vf cv golem1.3 golem1.1 stji1i opreq12d vf cv cst
      wcel cB cort cfv cB cA cin chj co vf cv cfv cC cort cfv cC cB cin chj co
      vf cv cfv caddc co cB cort cfv vf cv cfv cA cB cin vf cv cfv caddc co cC
      cort cfv vf cv cfv cB cC cin vf cv cfv caddc co caddc co cA cort cfv cA
      cC cin chj co vf cv cfv cA cort cfv vf cv cfv cC cA cin vf cv cfv caddc
      co caddc vf cv cst wcel cB cort cfv cB cA cin chj co vf cv cfv cB cort
      cfv vf cv cfv cA cB cin vf cv cfv caddc co cC cort cfv cC cB cin chj co
      vf cv cfv cC cort cfv vf cv cfv cB cC cin vf cv cfv caddc co caddc vf cv
      cst wcel cB cort cfv cB cA cin chj co vf cv cfv cB cort cfv vf cv cfv cB
      cA cin vf cv cfv caddc co cB cort cfv vf cv cfv cA cB cin vf cv cfv caddc
      co cB cA vf cv golem1.2 golem1.1 stji1i cB cA cin vf cv cfv cA cB cin vf
      cv cfv cB cort cfv vf cv cfv caddc cB cA cin cA cB cin vf cv cB cA incom
      fveq2i opreq2i syl6eq vf cv cst wcel cC cort cfv cC cB cin chj co vf cv
      cfv cC cort cfv vf cv cfv cC cB cin vf cv cfv caddc co cC cort cfv vf cv
      cfv cB cC cin vf cv cfv caddc co cC cB vf cv golem1.3 golem1.2 stji1i cC
      cB cin vf cv cfv cB cC cin vf cv cfv cC cort cfv vf cv cfv caddc cC cB
      cin cB cC cin vf cv cC cB incom fveq2i opreq2i syl6eq opreq12d vf cv cst
      wcel cA cort cfv cA cC cin chj co vf cv cfv cA cort cfv vf cv cfv cA cC
      cin vf cv cfv caddc co cA cort cfv vf cv cfv cC cA cin vf cv cfv caddc co
      cA cC vf cv golem1.1 golem1.3 stji1i cA cC cin vf cv cfv cC cA cin vf cv
      cfv cA cort cfv vf cv cfv caddc cA cC cin cC cA cin vf cv cA cC incom
      fveq2i opreq2i syl6eq opreq12d 3eqtr4d cF vf cv cfv cG vf cv cfv caddc co
      cA cort cfv cA cB cin chj co vf cv cfv cB cort cfv cB cC cin chj co vf cv
      cfv caddc co cH vf cv cfv cC cort cfv cC cA cin chj co vf cv cfv caddc cF
      vf cv cfv cA cort cfv cA cB cin chj co vf cv cfv cG vf cv cfv cB cort cfv
      cB cC cin chj co vf cv cfv caddc cF cA cort cfv cA cB cin chj co vf cv
      golem1.4 fveq2i cG cB cort cfv cB cC cin chj co vf cv golem1.5 fveq2i
      opreq12i cH cC cort cfv cC cA cin chj co vf cv golem1.6 fveq2i opreq12i
      cD vf cv cfv cR vf cv cfv caddc co cB cort cfv cB cA cin chj co vf cv cfv
      cC cort cfv cC cB cin chj co vf cv cfv caddc co cS vf cv cfv cA cort cfv
      cA cC cin chj co vf cv cfv caddc cD vf cv cfv cB cort cfv cB cA cin chj
      co vf cv cfv cR vf cv cfv cC cort cfv cC cB cin chj co vf cv cfv caddc cD
      cB cort cfv cB cA cin chj co vf cv golem1.7 fveq2i cR cC cort cfv cC cB
      cin chj co vf cv golem1.8 fveq2i opreq12i cS cA cort cfv cA cC cin chj co
      vf cv golem1.9 fveq2i opreq12i 3eqtr4g $.
      $( [10-Nov-2002] $)


    $( Lemma for Godowski's equation. $)
    golem2 $p |- ( f e. States ->
              ( ( f ` ( ( F i^i G ) i^i H ) ) = 1 -> ( f ` D ) = 1 ) ) $=
      vf cv cst wcel cF cG cin cH cin vf cv cfv c1 wceq cD vf cv cfv cR vf cv
      cfv caddc co cS vf cv cfv caddc co c3 wceq cD vf cv cfv c1 wceq vf cv cst
      wcel cF cG cin cH cin vf cv cfv c1 wceq cF vf cv cfv cG vf cv cfv caddc
      co cH vf cv cfv caddc co c3 wceq cD vf cv cfv cR vf cv cfv caddc co cS vf
      cv cfv caddc co c3 wceq cF cG cH vf cv cF cA cort cfv cA cB cin chj co
      cch golem1.4 cA cort cfv cA cB cin cA golem1.1 choccli cA cB golem1.1
      golem1.2 chincli chjcli eqeltri cG cB cort cfv cB cC cin chj co cch
      golem1.5 cB cort cfv cB cC cin cB golem1.2 choccli cB cC golem1.2
      golem1.3 chincli chjcli eqeltri cH cC cort cfv cC cA cin chj co cch
      golem1.6 cC cort cfv cC cA cin cC golem1.3 choccli cC cA golem1.3
      golem1.1 chincli chjcli eqeltri stm1add3i vf cv cst wcel cF vf cv cfv cG
      vf cv cfv caddc co cH vf cv cfv caddc co cD vf cv cfv cR vf cv cfv caddc
      co cS vf cv cfv caddc co c3 cA cB cC cD cR cS vf cF cG cH golem1.1
      golem1.2 golem1.3 golem1.4 golem1.5 golem1.6 golem1.7 golem1.8 golem1.9
      golem1 eqeq1d sylibd cD cR cS vf cv cD cB cort cfv cB cA cin chj co cch
      golem1.7 cB cort cfv cB cA cin cB golem1.2 choccli cB cA golem1.2
      golem1.1 chincli chjcli eqeltri cR cC cort cfv cC cB cin chj co cch
      golem1.8 cC cort cfv cC cB cin cC golem1.3 choccli cC cB golem1.3
      golem1.2 chincli chjcli eqeltri cS cA cort cfv cA cC cin chj co cch
      golem1.9 cA cort cfv cA cC cin cA golem1.1 choccli cA cC golem1.1
      golem1.3 chincli chjcli eqeltri stadd3i syld $.
      $( [13-Nov-1999] $)
  $}

  ${
    $d f F $.  $d f G $.  $d f H $.  $d f D $.
    goeq.1 $e |- A e. CH $.
    goeq.2 $e |- B e. CH $.
    goeq.3 $e |- C e. CH $.
    goeq.4 $e |- F = ( ( _|_ ` A ) vH ( A i^i B ) ) $.
    goeq.5 $e |- G = ( ( _|_ ` B ) vH ( B i^i C ) ) $.
    goeq.6 $e |- H = ( ( _|_ ` C ) vH ( C i^i A ) ) $.
    goeq.7 $e |- D = ( ( _|_ ` B ) vH ( B i^i A ) ) $.
    $( Godowski's equation, shown here as a variant equivalent to
       Equation SF of [Godowski] p. 730. $)
    goeqi $p |- ( ( F i^i G ) i^i H ) C_ D $=
      cF cG cin cH cin vf cv cfv c1 wceq cD vf cv cfv c1 wceq wi cF cG cin cH
      cin cD wss vf cst cF cG cin cH cin cD vf cF cG cin cH cF cG cF cA cort
      cfv cA cB cin chj co cch goeq.4 cA cort cfv cA cB cin cA goeq.1 choccli
      cA cB goeq.1 goeq.2 chincli chjcli eqeltri cG cB cort cfv cB cC cin chj
      co cch goeq.5 cB cort cfv cB cC cin cB goeq.2 choccli cB cC goeq.2 goeq.3
      chincli chjcli eqeltri chincli cH cC cort cfv cC cA cin chj co cch goeq.6
      cC cort cfv cC cA cin cC goeq.3 choccli cC cA goeq.3 goeq.1 chincli
      chjcli eqeltri chincli cD cB cort cfv cB cA cin chj co cch goeq.7 cB cort
      cfv cB cA cin cB goeq.2 choccli cB cA goeq.2 goeq.1 chincli chjcli
      eqeltri stri cA cB cC cD cC cort cfv cC cB cin chj co cA cort cfv cA cC
      cin chj co vf cF cG cH goeq.1 goeq.2 goeq.3 goeq.4 goeq.5 goeq.6 goeq.7
      cC cort cfv cC cB cin chj co eqid cA cort cfv cA cC cin chj co eqid
      golem2 mprg $.
      $( [10-Nov-2002] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y S $.
    stcltr1.1 $e |- ( ph <-> ( S e. States /\ A. x e. CH A. y e. CH
                ( ( ( S ` x ) = 1 -> ( S ` y ) = 1 ) -> x C_ y ) ) ) $.
    stcltr1.2 $e |- A e. CH $.
    ${
      stcltr1.3 $e |- B e. CH $.
      $( Property of a strong classical state. $)
      stcltr1i $p |- ( ph ->
               ( ( ( S ` A ) = 1 -> ( S ` B ) = 1 ) -> A C_ B ) ) $=
        wph cS cst wcel vx cv cS cfv c1 wceq vy cv cS cfv c1 wceq wi vx cv vy
        cv wss wi vy cch wral vx cch wral wa cA cS cfv c1 wceq cB cS cfv c1
        wceq wi cA cB wss wi stcltr1.1 vx cv cS cfv c1 wceq vy cv cS cfv c1
        wceq wi vx cv vy cv wss wi vy cch wral vx cch wral cA cS cfv c1 wceq cB
        cS cfv c1 wceq wi cA cB wss wi cS cst wcel cA cch wcel cB cch wcel vx
        cv cS cfv c1 wceq vy cv cS cfv c1 wceq wi vx cv vy cv wss wi vy cch
        wral vx cch wral cA cS cfv c1 wceq cB cS cfv c1 wceq wi cA cB wss wi wi
        stcltr1.2 stcltr1.3 vx cv cS cfv c1 wceq vy cv cS cfv c1 wceq wi vx cv
        vy cv wss wi cA cS cfv c1 wceq cB cS cfv c1 wceq wi cA cB wss wi cA cS
        cfv c1 wceq vy cv cS cfv c1 wceq wi cA vy cv wss wi vx vy cA cB cch cch
        vx cv cA wceq vx cv cS cfv c1 wceq vy cv cS cfv c1 wceq wi cA cS cfv c1
        wceq vy cv cS cfv c1 wceq wi vx cv vy cv wss cA vy cv wss vx cv cA wceq
        vx cv cS cfv c1 wceq cA cS cfv c1 wceq vy cv cS cfv c1 wceq vx cv cA
        wceq vx cv cS cfv cA cS cfv c1 vx cv cA cS fveq2 eqeq1d imbi1d vx cv cA
        vy cv sseq1 imbi12d vy cv cB wceq cA cS cfv c1 wceq vy cv cS cfv c1
        wceq wi cA cS cfv c1 wceq cB cS cfv c1 wceq wi cA vy cv wss cA cB wss
        vy cv cB wceq vy cv cS cfv c1 wceq cB cS cfv c1 wceq cA cS cfv c1 wceq
        vy cv cB wceq vy cv cS cfv cB cS cfv c1 vy cv cB cS fveq2 eqeq1d imbi2d
        vy cv cB cA sseq2 imbi12d rcla42v mp2an adantl sylbi $.
        $( [24-Oct-1999] $)
    $}

    $( Property of a strong classical state. $)
    stcltr2i $p |- ( ph -> ( ( S ` A ) = 1 -> A = ~H ) ) $=
      wph cA cS cfv c1 wceq chil cA wss cA chil wceq wph chil cS cfv c1 wceq cA
      cS cfv c1 wceq wi chil cA wss cA cS cfv c1 wceq wph vx vy chil cA cS
      stcltr1.1 helch stcltr1.2 stcltr1i cA cS cfv c1 wceq chil cS cfv c1 wceq
      ax-1 syl5 cA chil wceq cA chil wss chil cA wss cA chil eqss cA stcltr1.2
      chssii mpbiran syl6ibr $.
      $( [24-Oct-1999] $)

    ${
      stcltrlem1.3 $e |- B e. CH $.
      $( Lemma for strong classical state theorem. $)
      stcltrlem1 $p |- ( ph -> ( ( S ` B ) = 1 ->
                    ( S ` ( ( _|_ ` A ) vH ( A i^i B ) ) ) = 1 ) ) $=
        wph cB cS cfv c1 wceq cA cort cfv cA cB cin chj co cS cfv c1 wceq wph
        cB cS cfv c1 wceq wa cA cort cfv cA cB cin chj co cS cfv cA cort cfv cS
        cfv cA cB cin cS cfv caddc co cA cort cfv cS cfv cA cS cfv caddc co c1
        wph cA cort cfv cA cB cin chj co cS cfv cA cort cfv cS cfv cA cB cin cS
        cfv caddc co wceq cB cS cfv c1 wceq wph cS cst wcel cA cort cfv cA cB
        cin chj co cS cfv cA cort cfv cS cfv cA cB cin cS cfv caddc co wceq wph
        cS cst wcel vx cv cS cfv c1 wceq vy cv cS cfv c1 wceq wi vx cv vy cv
        wss wi vy cch wral vx cch wral stcltr1.1 pm3.26bi cA cB cS stcltr1.2
        stcltrlem1.3 stji1i syl adantr wph cB cS cfv c1 wceq wa cA cB cin cS
        cfv cA cS cfv cA cort cfv cS cfv caddc wph cB cS cfv c1 wceq wa cA cB
        cin cA cS wph cB cS cfv c1 wceq wa cB chil wceq cA cB cin cA wceq wph
        cB cS cfv c1 wceq cB chil wceq wph vx vy cB cS stcltr1.1 stcltrlem1.3
        stcltr2i imp cB chil wceq cA cB cin cA chil cin cA cB chil cA ineq2 cA
        stcltr1.2 chm1i syl6eq syl fveq2d opreq2d wph cB cS cfv c1 wceq wa cS
        cst wcel cA cort cfv cS cfv cA cS cfv caddc co c1 wceq wph cS cst wcel
        cB cS cfv c1 wceq wph cS cst wcel vx cv cS cfv c1 wceq vy cv cS cfv c1
        wceq wi vx cv vy cv wss wi vy cch wral vx cch wral stcltr1.1 pm3.26bi
        adantr cS cst wcel cA cort cfv cS cfv cA cS cfv caddc co cA cS cfv cA
        cort cfv cS cfv caddc co c1 cA cort cfv cS cfv cc wcel cA cS cfv cc
        wcel cA cort cfv cS cfv cA cS cfv caddc co cA cS cfv cA cort cfv cS cfv
        caddc co wceq cS cst wcel cA cort cfv cS cfv cA cS cfv addcom cS cst
        wcel cA cort cfv cS cfv cS cst wcel cA cort cfv cch wcel cA cort cfv cS
        cfv cr wcel cA stcltr1.2 choccli cA cort cfv cS stcl mpi recnd cS cst
        wcel cA cS cfv cS cst wcel cA cch wcel cA cS cfv cr wcel stcltr1.2 cA
        cS stcl mpi recnd sylanc cA cS stcltr1.2 sto1i eqtrd syl 3eqtrd ex $.
        $( [24-Oct-1999] $)

      $( Lemma for strong classical state theorem. $)
      stcltrlem2 $p |- ( ph -> B C_ ( ( _|_ ` A ) vH ( A i^i B ) ) ) $=
        wph cB cS cfv c1 wceq cA cort cfv cA cB cin chj co cS cfv c1 wceq wi cB
        cA cort cfv cA cB cin chj co wss wph vx vy cA cB cS stcltr1.1 stcltr1.2
        stcltrlem1.3 stcltrlem1 wph vx vy cB cA cort cfv cA cB cin chj co cS
        stcltr1.1 stcltrlem1.3 cA cort cfv cA cB cin cA stcltr1.2 choccli cA cB
        stcltr1.2 stcltrlem1.3 chincli chjcli stcltr1i mpd $.
        $( [24-Oct-1999] $)
    $}
  $}

  ${
    $d x y s A $.  $d x y s B $.
    stcltrth.1 $e |- A e. CH $.
    stcltrth.2 $e |- B e. CH $.
    stcltrth.3 $e |- E. s e. States A. x e. CH A. y e. CH
                ( ( ( s ` x ) = 1 -> ( s ` y ) = 1 ) -> x C_ y ) $.
    $( Theorem for classically strong set of states.  If there exists a
       "classically strong set of states" on lattice ` CH ` (or actually
       any ortholattice, which would have an identical proof), then any two
       elements of the lattice commute, i.e., the lattice is distributive.
       (Proof due to Mladen Pavicic.)  Theorem 3.3 of [MegillPavicic]
       p. 2344. $)
    stcltrthi $p |- B C_ ( ( _|_ ` A ) vH ( A i^i B ) ) $=
      vx cv vs cv cfv c1 wceq vy cv vs cv cfv c1 wceq wi vx cv vy cv wss wi vy
      cch wral vx cch wral vs cst wrex cB cA cort cfv cA cB cin chj co wss
      stcltrth.3 vx cv vs cv cfv c1 wceq vy cv vs cv cfv c1 wceq wi vx cv vy cv
      wss wi vy cch wral vx cch wral cB cA cort cfv cA cB cin chj co wss vs cst
      vs cv cst wcel vx cv vs cv cfv c1 wceq vy cv vs cv cfv c1 wceq wi vx cv
      vy cv wss wi vy cch wral vx cch wral wa vx vy cA cB vs cv vs cv cst wcel
      vx cv vs cv cfv c1 wceq vy cv vs cv cfv c1 wceq wi vx cv vy cv wss wi vy
      cch wral vx cch wral wa biid stcltrth.1 stcltrth.2 stcltrlem2 r19.23aiva
      ax-mp $.
      $( [24-Oct-1999] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Covering relation; modular pairs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Define the covers relation (on the Hilbert lattice).  Definition 3.2.18
       of [PtakPulmannova] p. 68, whose notation we use.  Ptak/Pulmannova's
       notation ` A <o B ` is read " ` B ` covers ` A ` " or " ` A ` is covered
       by ` B ` " , and it means that ` B ` is larger than ` A ` and there is
       nothing in between.  See ~ cvbr and ~ cvbr2 for membership
       relations. $)
    df-cv $a |- <o = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
              ( x C. y /\ -. E. z e. CH ( x C. z /\ z C. y ) ) ) } $.

    $( Define the modular pair relation (on the Hilbert lattice).  Definition
       1.1 of [MaedaMaeda] p. 1, who use the notation (x,y)M for "the ordered
       pair <x,y> is a modular pair."  See ~ mdbr for membership relation. $)
    df-md $a |- MH = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
    A. z e. CH ( z C_ y -> ( ( z vH x ) i^i y ) = ( z vH ( x i^i y ) ) ) ) } $.

    $( Define the dual modular pair relation (on the Hilbert lattice).
       Definition 1.1 of [MaedaMaeda] p. 1, who use the notation (x,y)M* for
       "the ordered pair <x,y> is a dual modular pair."  See ~ dmdbr for
       membership relation. $)
    df-dmd $a |- MH* = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
    A. z e. CH ( y C_ z -> ( ( z i^i x ) vH y ) = ( z i^i ( x vH y ) ) ) ) } $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( Binary relation expressing ` B ` covers ` A ` , which means that ` B `
       is larger than ` A ` and there is nothing in between.  Definition
       3.2.18 of [PtakPulmannova] p. 68. $)
    cvbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A <o B <->
              ( A C. B /\ -. E. x e. CH ( A C. x /\ x C. B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB ccv wbr cA cB wpss cA vx cv wpss vx cv
      cB wpss wa vx cch wrex wn wa vy cv cch wcel vz cv cch wcel wa vy cv vz cv
      wpss vy cv vx cv wpss vx cv vz cv wpss wa vx cch wrex wn wa wa cA cch
      wcel vz cv cch wcel wa cA vz cv wpss cA vx cv wpss vx cv vz cv wpss wa vx
      cch wrex wn wa wa cA cch wcel cB cch wcel wa cA cB wpss cA vx cv wpss vx
      cv cB wpss wa vx cch wrex wn wa wa vy vz cA cB cch cch ccv vy cv cA wceq
      vy cv cch wcel vz cv cch wcel wa cA cch wcel vz cv cch wcel wa vy cv vz
      cv wpss vy cv vx cv wpss vx cv vz cv wpss wa vx cch wrex wn wa cA vz cv
      wpss cA vx cv wpss vx cv vz cv wpss wa vx cch wrex wn wa vy cv cA wceq vy
      cv cch wcel cA cch wcel vz cv cch wcel vy cv cA cch eleq1 anbi1d vy cv cA
      wceq vy cv vz cv wpss cA vz cv wpss vy cv vx cv wpss vx cv vz cv wpss wa
      vx cch wrex wn cA vx cv wpss vx cv vz cv wpss wa vx cch wrex wn vy cv cA
      vz cv psseq1 vy cv cA wceq vy cv vx cv wpss vx cv vz cv wpss wa vx cch
      wrex cA vx cv wpss vx cv vz cv wpss wa vx cch wrex vy cv cA wceq vy cv vx
      cv wpss vx cv vz cv wpss wa cA vx cv wpss vx cv vz cv wpss wa vx cch vy
      cv cA wceq vy cv vx cv wpss cA vx cv wpss vx cv vz cv wpss vy cv cA vx cv
      psseq1 anbi1d rexbidv notbid anbi12d anbi12d vz cv cB wceq cA cch wcel vz
      cv cch wcel wa cA cch wcel cB cch wcel wa cA vz cv wpss cA vx cv wpss vx
      cv vz cv wpss wa vx cch wrex wn wa cA cB wpss cA vx cv wpss vx cv cB wpss
      wa vx cch wrex wn wa vz cv cB wceq vz cv cch wcel cB cch wcel cA cch wcel
      vz cv cB cch eleq1 anbi2d vz cv cB wceq cA vz cv wpss cA cB wpss cA vx cv
      wpss vx cv vz cv wpss wa vx cch wrex wn cA vx cv wpss vx cv cB wpss wa vx
      cch wrex wn vz cv cB cA psseq2 vz cv cB wceq cA vx cv wpss vx cv vz cv
      wpss wa vx cch wrex cA vx cv wpss vx cv cB wpss wa vx cch wrex vz cv cB
      wceq cA vx cv wpss vx cv vz cv wpss wa cA vx cv wpss vx cv cB wpss wa vx
      cch vz cv cB wceq vx cv vz cv wpss vx cv cB wpss cA vx cv wpss vz cv cB
      vx cv psseq2 anbi2d rexbidv notbid anbi12d anbi12d vy vz vx df-cv brabg
      bianabs $.
      $( [11-Jun-2004] $) $( [4-Jun-2004] $)

    $( Binary relation expressing ` B ` covers ` A ` .  Definition of covers
       in [Kalmbach] p. 15. $)
    cvbr2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A <o B <->
             ( A C. B /\ A. x e. CH ( ( A C. x /\ x C_ B ) -> x = B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB ccv wbr cA cB wpss cA vx cv wpss vx cv
      cB wpss wa vx cch wrex wn wa cA cB wpss cA vx cv wpss vx cv cB wss wa vx
      cv cB wceq wi vx cch wral wa vx cA cB cvbr cA vx cv wpss vx cv cB wss wa
      vx cv cB wceq wi vx cch wral cA vx cv wpss vx cv cB wpss wa vx cch wrex
      wn cA cB wpss cA vx cv wpss vx cv cB wss wa vx cv cB wceq wi vx cch wral
      cA vx cv wpss vx cv cB wpss wa wn vx cch wral cA vx cv wpss vx cv cB wpss
      wa vx cch wrex wn cA vx cv wpss vx cv cB wss wa vx cv cB wceq wi cA vx cv
      wpss vx cv cB wpss wa wn vx cch cA vx cv wpss vx cv cB wss wa vx cv cB
      wceq wi cA vx cv wpss vx cv cB wss wa vx cv cB wceq wn wa wn cA vx cv
      wpss vx cv cB wpss wa wn cA vx cv wpss vx cv cB wss wa vx cv cB wceq iman
      cA vx cv wpss vx cv cB wss wa vx cv cB wceq wn wa cA vx cv wpss vx cv cB
      wpss wa cA vx cv wpss vx cv cB wss wa vx cv cB wceq wn wa cA vx cv wpss
      vx cv cB wss vx cv cB wceq wn wa wa cA vx cv wpss vx cv cB wpss wa cA vx
      cv wpss vx cv cB wss vx cv cB wceq wn anass vx cv cB wpss vx cv cB wss vx
      cv cB wceq wn wa cA vx cv wpss vx cv cB dfpss2 anbi2i bitr4i notbii bitri
      ralbii cA vx cv wpss vx cv cB wpss wa vx cch ralnex bitri anbi2i syl6bbr
      $.
      $( [11-Jun-2004] $) $( [9-Jun-2004] $)

    $( Contraposition law for the covers relation. $)
    cvcon3 $p |- ( ( A e. CH /\ B e. CH ) ->
                   ( A <o B <-> ( _|_ ` B ) <o ( _|_ ` A ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB wpss cA vx cv wpss vx cv cB wpss wa vx
      cch wrex wn wa cB cort cfv cA cort cfv wpss cB cort cfv vy cv wpss vy cv
      cA cort cfv wpss wa vy cch wrex wn wa cA cB ccv wbr cB cort cfv cA cort
      cfv ccv wbr cA cch wcel cB cch wcel wa cA cB wpss cB cort cfv cA cort cfv
      wpss cA vx cv wpss vx cv cB wpss wa vx cch wrex wn cB cort cfv vy cv wpss
      vy cv cA cort cfv wpss wa vy cch wrex wn cA cB chpsscon3 cA cch wcel cB
      cch wcel wa cA vx cv wpss vx cv cB wpss wa vx cch wrex cB cort cfv vy cv
      wpss vy cv cA cort cfv wpss wa vy cch wrex cA cch wcel cB cch wcel wa cA
      vx cv wpss vx cv cB wpss wa vx cch wrex cB cort cfv vy cv wpss vy cv cA
      cort cfv wpss wa vy cch wrex cA cch wcel cB cch wcel wa cA vx cv wpss vx
      cv cB wpss wa cB cort cfv vy cv wpss vy cv cA cort cfv wpss wa vy cch
      wrex vx cch cA cch wcel cB cch wcel wa vx cv cch wcel wa cA vx cv wpss vx
      cv cB wpss wa vx cv cort cfv cA cort cfv wpss cB cort cfv vx cv cort cfv
      wpss wa cB cort cfv vy cv wpss vy cv cA cort cfv wpss wa vy cch wrex cA
      cch wcel cB cch wcel wa vx cv cch wcel wa cA vx cv wpss vx cv cort cfv cA
      cort cfv wpss vx cv cB wpss cB cort cfv vx cv cort cfv wpss cA cch wcel
      vx cv cch wcel cA vx cv wpss vx cv cort cfv cA cort cfv wpss wb cB cch
      wcel cA vx cv chpsscon3 adantlr cB cch wcel vx cv cch wcel vx cv cB wpss
      cB cort cfv vx cv cort cfv wpss wb cA cch wcel vx cv cch wcel cB cch wcel
      vx cv cB wpss cB cort cfv vx cv cort cfv wpss wb vx cv cB chpsscon3
      ancoms adantll anbi12d vx cv cch wcel vx cv cort cfv cA cort cfv wpss cB
      cort cfv vx cv cort cfv wpss wa cB cort cfv vy cv wpss vy cv cA cort cfv
      wpss wa vy cch wrex wi cA cch wcel cB cch wcel wa vx cv cch wcel cB cort
      cfv vx cv cort cfv wpss vx cv cort cfv cA cort cfv wpss cB cort cfv vy cv
      wpss vy cv cA cort cfv wpss wa vy cch wrex vx cv cch wcel cB cort cfv vx
      cv cort cfv wpss vx cv cort cfv cA cort cfv wpss wa cB cort cfv vy cv
      wpss vy cv cA cort cfv wpss wa vy cch wrex vx cv cort cfv cch wcel cB
      cort cfv vx cv cort cfv wpss vx cv cort cfv cA cort cfv wpss wa cB cort
      cfv vy cv wpss vy cv cA cort cfv wpss wa vy cch wrex vx cv cch wcel cB
      cort cfv vy cv wpss vy cv cA cort cfv wpss wa cB cort cfv vx cv cort cfv
      wpss vx cv cort cfv cA cort cfv wpss wa vy vx cv cort cfv cch vy cv vx cv
      cort cfv wceq cB cort cfv vy cv wpss cB cort cfv vx cv cort cfv wpss vy
      cv cA cort cfv wpss vx cv cort cfv cA cort cfv wpss vy cv vx cv cort cfv
      cB cort cfv psseq2 vy cv vx cv cort cfv cA cort cfv psseq1 anbi12d
      rcla4ev vx cv choccl sylan ex ancomsd adantl sylbid r19.23adva cA cch
      wcel cB cch wcel wa cB cort cfv vy cv wpss vy cv cA cort cfv wpss wa cA
      vx cv wpss vx cv cB wpss wa vx cch wrex vy cch cA cch wcel cB cch wcel wa
      vy cv cch wcel wa cB cort cfv vy cv wpss vy cv cA cort cfv wpss wa vy cv
      cort cfv cB wpss cA vy cv cort cfv wpss wa cA vx cv wpss vx cv cB wpss wa
      vx cch wrex cA cch wcel cB cch wcel wa vy cv cch wcel wa cB cort cfv vy
      cv wpss vy cv cort cfv cB wpss vy cv cA cort cfv wpss cA vy cv cort cfv
      wpss cB cch wcel vy cv cch wcel cB cort cfv vy cv wpss vy cv cort cfv cB
      wpss wb cA cch wcel cB vy cv chpsscon1 adantll cA cch wcel vy cv cch wcel
      vy cv cA cort cfv wpss cA vy cv cort cfv wpss wb cB cch wcel vy cv cch
      wcel cA cch wcel vy cv cA cort cfv wpss cA vy cv cort cfv wpss wb vy cv
      cA chpsscon2 ancoms adantlr anbi12d vy cv cch wcel vy cv cort cfv cB wpss
      cA vy cv cort cfv wpss wa cA vx cv wpss vx cv cB wpss wa vx cch wrex wi
      cA cch wcel cB cch wcel wa vy cv cch wcel cA vy cv cort cfv wpss vy cv
      cort cfv cB wpss cA vx cv wpss vx cv cB wpss wa vx cch wrex vy cv cch
      wcel cA vy cv cort cfv wpss vy cv cort cfv cB wpss wa cA vx cv wpss vx cv
      cB wpss wa vx cch wrex vy cv cort cfv cch wcel cA vy cv cort cfv wpss vy
      cv cort cfv cB wpss wa cA vx cv wpss vx cv cB wpss wa vx cch wrex vy cv
      cch wcel cA vx cv wpss vx cv cB wpss wa cA vy cv cort cfv wpss vy cv cort
      cfv cB wpss wa vx vy cv cort cfv cch vx cv vy cv cort cfv wceq cA vx cv
      wpss cA vy cv cort cfv wpss vx cv cB wpss vy cv cort cfv cB wpss vx cv vy
      cv cort cfv cA psseq2 vx cv vy cv cort cfv cB psseq1 anbi12d rcla4ev vy
      cv choccl sylan ex ancomsd adantl sylbid r19.23adva impbid notbid anbi12d
      vx cA cB cvbr cB cch wcel cA cch wcel cB cort cfv cA cort cfv ccv wbr cB
      cort cfv cA cort cfv wpss cB cort cfv vy cv wpss vy cv cA cort cfv wpss
      wa vy cch wrex wn wa wb cB cort cfv cch wcel cA cort cfv cch wcel cB cort
      cfv cA cort cfv ccv wbr cB cort cfv cA cort cfv wpss cB cort cfv vy cv
      wpss vy cv cA cort cfv wpss wa vy cch wrex wn wa wb cB cch wcel cA cch
      wcel vy cB cort cfv cA cort cfv cvbr cB choccl cA choccl syl2an ancoms
      3bitr4d $.
      $( [11-Jul-2004] $) $( [12-Jun-2004] $)

    $( The covering relation implies proper subset. $)
    cvpss $p |- ( ( A e. CH /\ B e. CH ) -> ( A <o B -> A C. B ) ) $=
      cA cch wcel cB cch wcel wa cA cB ccv wbr cA cB wpss cA vx cv wpss vx cv
      cB wpss wa vx cch wrex wn wa cA cB wpss vx cA cB cvbr cA cB wpss cA vx cv
      wpss vx cv cB wpss wa vx cch wrex wn pm3.26 syl6bi $.
      $( [11-Jul-2004] $) $( [10-Jun-2004] $)

    $( The covering relation implies no in-betweenness. $)
    cvnbtwn $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <o B ->
                  -. ( A C. C /\ C C. B ) ) ) $=
      cA cch wcel cB cch wcel cC cch wcel cA cB ccv wbr cA cC wpss cC cB wpss
      wa wn wi cA cch wcel cB cch wcel wa cA cB ccv wbr cC cch wcel cA cC wpss
      cC cB wpss wa wn cA cch wcel cB cch wcel wa cA cB ccv wbr cA cB wpss cA
      vx cv wpss vx cv cB wpss wa vx cch wrex wn wa cC cch wcel cA cC wpss cC
      cB wpss wa wn wi vx cA cB cvbr cA vx cv wpss vx cv cB wpss wa vx cch wrex
      wn cC cch wcel cA cC wpss cC cB wpss wa wn wi cA cB wpss cC cch wcel cA
      vx cv wpss vx cv cB wpss wa vx cch wrex wn cA cC wpss cC cB wpss wa wn cC
      cch wcel cA cC wpss cC cB wpss wa cA vx cv wpss vx cv cB wpss wa vx cch
      wrex cC cch wcel cA cC wpss cC cB wpss wa cA vx cv wpss vx cv cB wpss wa
      vx cch wrex cA vx cv wpss vx cv cB wpss wa cA cC wpss cC cB wpss wa vx cC
      cch vx cv cC wceq cA vx cv wpss cA cC wpss vx cv cB wpss cC cB wpss vx cv
      cC cA psseq2 vx cv cC cB psseq1 anbi12d rcla4ev ex con3d com12 adantl
      syl6bi com23 3impia $.
      $( [11-Jul-2004] $) $( [12-Jun-2004] $)
  $}

  $( The covering relation implies no in-betweenness. $)
  cvnbtwn2 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <o B ->
                ( ( A C. C /\ C C_ B ) -> C = B ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccv wbr cA cC wpss cC cB wpss
    wa wn cA cC wpss cC cB wss wa cC cB wceq wi cA cB cC cvnbtwn cA cC wpss cC
    cB wss wa cC cB wceq wi cA cC wpss cC cB wss wa cC cB wceq wn wa wn cA cC
    wpss cC cB wpss wa wn cA cC wpss cC cB wss wa cC cB wceq iman cA cC wpss cC
    cB wss wa cC cB wceq wn wa cA cC wpss cC cB wpss wa cA cC wpss cC cB wss wa
    cC cB wceq wn wa cA cC wpss cC cB wss cC cB wceq wn wa wa cA cC wpss cC cB
    wpss wa cA cC wpss cC cB wss cC cB wceq wn anass cC cB wpss cC cB wss cC cB
    wceq wn wa cA cC wpss cC cB dfpss2 anbi2i bitr4i notbii bitr2i syl6ib $.
    $( [21-Jul-2004] $) $( [12-Jun-2004] $)

  $( The covering relation implies no in-betweenness. $)
  cvnbtwn3 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <o B ->
                ( ( A C_ C /\ C C. B ) -> C = A ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccv wbr cA cC wpss cC cB wpss
    wa wn cA cC wss cC cB wpss wa cC cA wceq wi cA cB cC cvnbtwn cA cC wss cC
    cB wpss wa cA cC wceq wi cA cC wss cC cB wpss wa cA cC wceq wn wa wn cA cC
    wss cC cB wpss wa cC cA wceq wi cA cC wpss cC cB wpss wa wn cA cC wss cC cB
    wpss wa cA cC wceq iman cC cA wceq cA cC wceq cA cC wss cC cB wpss wa cC cA
    eqcom imbi2i cA cC wpss cC cB wpss wa cA cC wss cC cB wpss wa cA cC wceq wn
    wa cA cC wpss cC cB wpss wa cA cC wss cA cC wceq wn wa cC cB wpss wa cA cC
    wss cC cB wpss wa cA cC wceq wn wa cA cC wpss cA cC wss cA cC wceq wn wa cC
    cB wpss cA cC dfpss2 anbi1i cA cC wss cA cC wceq wn cC cB wpss an23 bitri
    notbii 3bitr4ri syl6ib $.
    $( [21-Jul-2004] $) $( [12-Jun-2004] $)

  $( The covering relation implies no in-betweenness.  Part of proof of Lemma
     7.5.1 of [MaedaMaeda] p. 31. $)
  cvnbtwn4 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <o B ->
                ( ( A C_ C /\ C C_ B ) -> ( C = A \/ C = B ) ) ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB ccv wbr cA cC wpss cC cB wpss
    wa wn cA cC wss cC cB wss wa cC cA wceq cC cB wceq wo wi cA cB cC cvnbtwn
    cA cC wss cC cB wss wa cC cA wceq cC cB wceq wo wi cA cC wss cC cB wss wa
    cC cA wceq cC cB wceq wo wn wa wn cA cC wpss cC cB wpss wa wn cA cC wss cC
    cB wss wa cC cA wceq cC cB wceq wo iman cA cC wss cC cB wss wa cC cA wceq
    cC cB wceq wo wn wa cA cC wpss cC cB wpss wa cA cC wss cC cB wss wa cA cC
    wceq wn cC cB wceq wn wa wa cA cC wss cA cC wceq wn wa cC cB wss cC cB wceq
    wn wa wa cA cC wss cC cB wss wa cC cA wceq cC cB wceq wo wn wa cA cC wpss
    cC cB wpss wa cA cC wss cC cB wss cA cC wceq wn cC cB wceq wn an4 cC cA
    wceq cC cB wceq wo wn cA cC wceq wn cC cB wceq wn wa cA cC wss cC cB wss wa
    cC cA wceq cC cB wceq wo wn cC cA wceq wn cC cB wceq wn wa cA cC wceq wn cC
    cB wceq wn wa cC cA wceq cC cB wceq ioran cC cA wceq wn cA cC wceq wn cC cB
    wceq wn cC cA wceq cA cC wceq cC cA eqcom notbii anbi1i bitri anbi2i cA cC
    wpss cA cC wss cA cC wceq wn wa cC cB wpss cC cB wss cC cB wceq wn wa cA cC
    dfpss2 cC cB dfpss2 anbi12i 3bitr4i notbii bitr2i syl6ib $.
    $( [10-Nov-2004] $) $( [12-Jun-2004] $)

  $( The covering relation is not symmetric. $)
  cvnsym $p |- ( ( A e. CH /\ B e. CH ) -> ( A <o B -> -. B <o A ) ) $=
    cA cch wcel cB cch wcel wa cA cB ccv wbr cA cB wpss cB cA ccv wbr wn cA cB
    cvpss cA cch wcel cB cch wcel wa cB cA ccv wbr cA cB wpss cA cch wcel cB
    cch wcel wa cB cA ccv wbr cB cA wpss cA cB wpss wn cB cch wcel cA cch wcel
    cB cA ccv wbr cB cA wpss wi cB cA cvpss ancoms cB cA wpss cA cB wpss wn wi
    cB cA wpss cA cB wpss wa wn cB cA pssn2lp cB cA wpss cA cB wpss imnan mpbir
    syl6 con2d syld $.
    $( [22-Nov-2004] $) $( [26-Jun-2004] $)

  $( The covering relation is not reflexive. $)
  cvnref $p |- ( A e. CH -> -. A <o A ) $=
    cA cch wcel cA cA ccv wbr cA cch wcel cA cA ccv wbr cA cA ccv wbr wn wi cA
    cA cvnsym anidms pm2.01d $.
    $( [22-Nov-2004] $) $( [26-Jun-2004] $)

  $( The covering relation is not transitive. $)
  cvntr $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
                ( ( A <o B /\ B <o C ) -> -. A <o C ) ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB wpss cB cC wpss cA cC ccv wbr
    wn cA cB ccv wbr cB cC ccv wbr cA cch wcel cB cch wcel cC cch wcel w3a cA
    cC ccv wbr cA cB wpss cB cC wpss wa cA cch wcel cC cch wcel cB cch wcel cA
    cC ccv wbr cA cB wpss cB cC wpss wa wn wi cA cC cB cvnbtwn 3com23 con2d cA
    cch wcel cB cch wcel cA cB ccv wbr cA cB wpss wi cC cch wcel cA cB cvpss
    3adant3 cB cch wcel cC cch wcel cB cC ccv wbr cB cC wpss wi cA cch wcel cB
    cC cvpss 3adant1 syl2and $.
    $( [29-Jul-2004] $) $( [26-Jun-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Hilbert space has the covering property (using spans of singletons to
       represent atoms).  Proposition 1(ii) of [Kalmbach] p. 153. $)
    spansncv2 $p |- ( ( A e. CH /\ B e. ~H ) -> ( -. ( span ` { B } ) C_ A ->
                     A <o ( A vH ( span ` { B } ) ) ) ) $=
      cA cch wcel cB chil wcel wa cA cA cB csn cspn cfv chj co wpss cA cA cB
      csn cspn cfv chj co wpss cA vx cv wpss vx cv cA cB csn cspn cfv chj co
      wss wa vx cv cA cB csn cspn cfv chj co wceq wi vx cch wral wa cB csn cspn
      cfv cA wss wn cA cA cB csn cspn cfv chj co ccv wbr cA cA cB csn cspn cfv
      chj co wpss cA cch wcel cB chil wcel wa cA cA cB csn cspn cfv chj co wpss
      cA vx cv wpss vx cv cA cB csn cspn cfv chj co wss wa vx cv cA cB csn cspn
      cfv chj co wceq wi vx cch wral wa cA cch wcel cB chil wcel wa cA vx cv
      wpss vx cv cA cB csn cspn cfv chj co wss wa vx cv cA cB csn cspn cfv chj
      co wceq wi vx cch wral cA cA cB csn cspn cfv chj co wpss cA cch wcel cB
      chil wcel wa cA vx cv wpss vx cv cA cB csn cspn cfv chj co wss wa vx cv
      cA cB csn cspn cfv chj co wceq wi vx cch cA cch wcel cB chil wcel vx cv
      cch wcel cA vx cv wpss vx cv cA cB csn cspn cfv chj co wss wa vx cv cA cB
      csn cspn cfv chj co wceq wi wi cA cch wcel vx cv cch wcel cB chil wcel cA
      vx cv wpss vx cv cA cB csn cspn cfv chj co wss wa vx cv cA cB csn cspn
      cfv chj co wceq wi cA cch wcel vx cv cch wcel cB chil wcel cA vx cv wpss
      vx cv cA cB csn cspn cfv chj co wss wa vx cv cA cB csn cspn cfv chj co
      wceq wi cA vx cv cB spansncv 3exp com23 imp r19.21aiv anim2i expcom cA
      cch wcel cB csn cspn cfv cch wcel cB csn cspn cfv cA wss wn cA cA cB csn
      cspn cfv chj co wpss wb cB chil wcel cA cB csn cspn cfv chnle cB spansnch
      sylan2 cA cch wcel cB chil wcel cA cB csn cspn cfv chj co cch wcel cA cA
      cB csn cspn cfv chj co ccv wbr cA cA cB csn cspn cfv chj co wpss cA vx cv
      wpss vx cv cA cB csn cspn cfv chj co wss wa vx cv cA cB csn cspn cfv chj
      co wceq wi vx cch wral wa wb cA cch wcel cB csn cspn cfv cch wcel cA cB
      csn cspn cfv chj co cch wcel cB chil wcel cA cB csn cspn cfv chjcl cB
      spansnch sylan2 vx cA cA cB csn cspn cfv chj co cvbr2 syldan 3imtr4d $.
      $( [21-Jul-2004] $) $( [9-Jun-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( Binary relation expressing ` <. A , B >. ` is a modular pair.
       Definition 1.1 of [MaedaMaeda] p. 1. $)
    mdbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <->
    A. x e. CH ( x C_ B -> ( ( x vH A ) i^i B ) = ( x vH ( A i^i B ) ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cmd wbr vx cv cB wss vx cv cA chj co cB
      cin vx cv cA cB cin chj co wceq wi vx cch wral vy cv cch wcel vz cv cch
      wcel wa vx cv vz cv wss vx cv vy cv chj co vz cv cin vx cv vy cv vz cv
      cin chj co wceq wi vx cch wral wa cA cch wcel vz cv cch wcel wa vx cv vz
      cv wss vx cv cA chj co vz cv cin vx cv cA vz cv cin chj co wceq wi vx cch
      wral wa cA cch wcel cB cch wcel wa vx cv cB wss vx cv cA chj co cB cin vx
      cv cA cB cin chj co wceq wi vx cch wral wa vy vz cA cB cch cch cmd vy cv
      cA wceq vy cv cch wcel vz cv cch wcel wa cA cch wcel vz cv cch wcel wa vx
      cv vz cv wss vx cv vy cv chj co vz cv cin vx cv vy cv vz cv cin chj co
      wceq wi vx cch wral vx cv vz cv wss vx cv cA chj co vz cv cin vx cv cA vz
      cv cin chj co wceq wi vx cch wral vy cv cA wceq vy cv cch wcel cA cch
      wcel vz cv cch wcel vy cv cA cch eleq1 anbi1d vy cv cA wceq vx cv vz cv
      wss vx cv vy cv chj co vz cv cin vx cv vy cv vz cv cin chj co wceq wi vx
      cv vz cv wss vx cv cA chj co vz cv cin vx cv cA vz cv cin chj co wceq wi
      vx cch vy cv cA wceq vx cv vy cv chj co vz cv cin vx cv vy cv vz cv cin
      chj co wceq vx cv cA chj co vz cv cin vx cv cA vz cv cin chj co wceq vx
      cv vz cv wss vy cv cA wceq vx cv vy cv chj co vz cv cin vx cv cA chj co
      vz cv cin vx cv vy cv vz cv cin chj co vx cv cA vz cv cin chj co vy cv cA
      wceq vx cv vy cv chj co vx cv cA chj co vz cv vy cv cA vx cv chj opreq2
      ineq1d vy cv cA wceq vy cv vz cv cin cA vz cv cin vx cv chj vy cv cA vz
      cv ineq1 opreq2d eqeq12d imbi2d ralbidv anbi12d vz cv cB wceq cA cch wcel
      vz cv cch wcel wa cA cch wcel cB cch wcel wa vx cv vz cv wss vx cv cA chj
      co vz cv cin vx cv cA vz cv cin chj co wceq wi vx cch wral vx cv cB wss
      vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi vx cch wral vz cv
      cB wceq vz cv cch wcel cB cch wcel cA cch wcel vz cv cB cch eleq1 anbi2d
      vz cv cB wceq vx cv vz cv wss vx cv cA chj co vz cv cin vx cv cA vz cv
      cin chj co wceq wi vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wceq wi vx cch vz cv cB wceq vx cv vz cv wss vx cv cB wss vx cv cA
      chj co vz cv cin vx cv cA vz cv cin chj co wceq vx cv cA chj co cB cin vx
      cv cA cB cin chj co wceq vz cv cB vx cv sseq2 vz cv cB wceq vx cv cA chj
      co vz cv cin vx cv cA chj co cB cin vx cv cA vz cv cin chj co vx cv cA cB
      cin chj co vz cv cB vx cv cA chj co ineq2 vz cv cB wceq cA vz cv cin cA
      cB cin vx cv chj vz cv cB cA ineq2 opreq2d eqeq12d imbi12d ralbidv
      anbi12d vy vz vx df-md brabg bianabs $.
      $( [21-Jul-2004] $) $( [14-Jun-2004] $)

    $( Consequence of the modular pair property. $)
    mdi $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A MH B /\
              C C_ B ) ) -> ( ( C vH A ) i^i B ) = ( C vH ( A i^i B ) ) ) $=
      cA cch wcel cB cch wcel cC cch wcel w3a cA cB cmd wbr cC cB wss cC cA chj
      co cB cin cC cA cB cin chj co wceq cA cch wcel cB cch wcel cC cch wcel cA
      cB cmd wbr cC cB wss cC cA chj co cB cin cC cA cB cin chj co wceq wi wi
      cA cch wcel cB cch wcel wa cA cB cmd wbr vx cv cB wss vx cv cA chj co cB
      cin vx cv cA cB cin chj co wceq wi vx cch wral cC cch wcel cC cB wss cC
      cA chj co cB cin cC cA cB cin chj co wceq wi cA cch wcel cB cch wcel wa
      cA cB cmd wbr vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq wi vx cch wral vx cA cB mdbr biimpd vx cv cB wss vx cv cA chj co cB
      cin vx cv cA cB cin chj co wceq wi cC cB wss cC cA chj co cB cin cC cA cB
      cin chj co wceq wi vx cC cch vx cv cC wceq vx cv cB wss cC cB wss vx cv
      cA chj co cB cin vx cv cA cB cin chj co wceq cC cA chj co cB cin cC cA cB
      cin chj co wceq vx cv cC cB sseq1 vx cv cC wceq vx cv cA chj co cB cin cC
      cA chj co cB cin vx cv cA cB cin chj co cC cA cB cin chj co vx cv cC wceq
      vx cv cA chj co cC cA chj co cB vx cv cC cA chj opreq1 ineq1d vx cv cC cA
      cB cin chj opreq1 eqeq12d imbi12d rcla4v sylan9 3impa imp32 $.
      $( [24-Dec-2006] $) $( [22-Jun-2004] $)

    $( Binary relation expressing the modular pair property.  This version
       has a weaker constraint than ~ mdbr . $)
    mdbr2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <->
   A. x e. CH ( x C_ B -> ( ( x vH A ) i^i B ) C_ ( x vH ( A i^i B ) ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cmd wbr vx cv cB wss vx cv cA chj co cB
      cin vx cv cA cB cin chj co wceq wi vx cch wral vx cv cB wss vx cv cA chj
      co cB cin vx cv cA cB cin chj co wss wi vx cch wral vx cA cB mdbr cA cch
      wcel cB cch wcel wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wceq wi vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wss wi vx cch cA cch wcel cB cch wcel wa vx cv cch wcel wa vx cv cB wss
      vx cv cA chj co cB cin vx cv cA cB cin chj co wceq vx cv cA chj co cB cin
      vx cv cA cB cin chj co wss cA cch wcel cB cch wcel wa vx cv cch wcel wa
      vx cv cB wss vx cv cA cB cin chj co vx cv cA chj co cB cin wss vx cv cA
      chj co cB cin vx cv cA cB cin chj co wceq vx cv cA chj co cB cin vx cv cA
      cB cin chj co wss wb cA cch wcel cB cch wcel wa vx cv cch wcel wa vx cv
      cB wss vx cv vx cv cA chj co cB cin wss cA cB cin vx cv cA chj co cB cin
      wss wa vx cv cA cB cin chj co vx cv cA chj co cB cin wss cA cch wcel vx
      cv cch wcel vx cv cB wss vx cv vx cv cA chj co cB cin wss cA cB cin vx cv
      cA chj co cB cin wss wa wi cB cch wcel cA cch wcel vx cv cch wcel wa vx
      cv cB wss vx cv vx cv cA chj co cB cin wss cA cB cin vx cv cA chj co cB
      cin wss vx cv cB wss vx cv vx cv cA chj co wss vx cv vx cv cA chj co cB
      cin wss cA cch wcel vx cv cch wcel wa vx cv cB wss vx cv vx cv cA chj co
      wss vx cv vx cv cA chj co wss vx cv cB wss wa vx cv vx cv cA chj co cB
      cin wss vx cv cB wss vx cv vx cv cA chj co wss iba vx cv vx cv cA chj co
      cB ssin syl6bb vx cv cch wcel cA cch wcel vx cv vx cv cA chj co wss vx cv
      cA chub1 ancoms syl5cbi cA cch wcel vx cv cch wcel wa cA vx cv cA chj co
      wss cA cB cin vx cv cA chj co cB cin wss cA vx cv chub2 cA vx cv cA chj
      co cB ssrin syl jctird adantlr vx cv cch wcel cA cB cin cch wcel vx cv cA
      chj co cB cin cch wcel vx cv vx cv cA chj co cB cin wss cA cB cin vx cv
      cA chj co cB cin wss wa vx cv cA cB cin chj co vx cv cA chj co cB cin wss
      wb cA cch wcel cB cch wcel wa vx cv cch wcel wa vx cv cA cB cin vx cv cA
      chj co cB cin chlub cA cch wcel cB cch wcel wa vx cv cch wcel pm3.27 cA
      cch wcel cB cch wcel wa cA cB cin cch wcel vx cv cch wcel cA cB chincl
      adantr cA cch wcel vx cv cch wcel cB cch wcel vx cv cA chj co cB cin cch
      wcel vx cv cA chj co cch wcel cB cch wcel vx cv cA chj co cB cin cch wcel
      cA cch wcel vx cv cch wcel wa vx cv cA chj co cB chincl vx cv cch wcel cA
      cch wcel vx cv cA chj co cch wcel vx cv cA chjcl ancoms sylan an1rs
      syl3anc sylibd vx cv cA cB cin chj co vx cv cA chj co cB cin wss vx cv cA
      chj co cB cin vx cv cA cB cin chj co wss vx cv cA chj co cB cin vx cv cA
      cB cin chj co wss vx cv cA cB cin chj co vx cv cA chj co cB cin wss wa vx
      cv cA chj co cB cin vx cv cA cB cin chj co wceq vx cv cA cB cin chj co vx
      cv cA chj co cB cin wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss
      iba vx cv cA chj co cB cin vx cv cA cB cin chj co eqss syl6rbbr syl6
      pm5.74d ralbidva bitrd $.
      $( [29-Jul-2004] $) $( [15-Jun-2004] $)

    $( Binary relation expressing the modular pair property.  This version
       quantifies an equality instead of an inference. $)
    mdbr3 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <-> A. x e. CH
         ( ( ( x i^i B ) vH A ) i^i B ) = ( ( x i^i B ) vH ( A i^i B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cmd wbr vy cv cB wss vy cv cA chj co cB
      cin vy cv cA cB cin chj co wceq wi vy cch wral vx cv cB cin cA chj co cB
      cin vx cv cB cin cA cB cin chj co wceq vx cch wral vy cA cB mdbr cB cch
      wcel vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin chj co wceq wi
      vy cch wral vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co
      wceq vx cch wral wb cA cch wcel cB cch wcel vy cv cB wss vy cv cA chj co
      cB cin vy cv cA cB cin chj co wceq wi vy cch wral vx cv cB cin cA chj co
      cB cin vx cv cB cin cA cB cin chj co wceq vx cch wral cB cch wcel vy cv
      cB wss vy cv cA chj co cB cin vy cv cA cB cin chj co wceq wi vy cch wral
      vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co wceq vx cch
      vx cv cch wcel cB cch wcel vy cv cB wss vy cv cA chj co cB cin vy cv cA
      cB cin chj co wceq wi vy cch wral vx cv cB cin cA chj co cB cin vx cv cB
      cin cA cB cin chj co wceq vx cv cch wcel cB cch wcel vy cv cB wss vy cv
      cA chj co cB cin vy cv cA cB cin chj co wceq wi vy cch wral vx cv cB cin
      cA chj co cB cin vx cv cB cin cA cB cin chj co wceq wi vx cv cch wcel cB
      cch wcel wa vx cv cB cin cch wcel vy cv cB wss vy cv cA chj co cB cin vy
      cv cA cB cin chj co wceq wi vy cch wral vx cv cB cin cA chj co cB cin vx
      cv cB cin cA cB cin chj co wceq wi vx cv cB chincl vx cv cB cin cch wcel
      vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin chj co wceq wi vy cch
      wral vx cv cB cin cB wss vx cv cB cin cA chj co cB cin vx cv cB cin cA cB
      cin chj co wceq vx cv cB inss2 vy cv cB wss vy cv cA chj co cB cin vy cv
      cA cB cin chj co wceq wi vx cv cB cin cB wss vx cv cB cin cA chj co cB
      cin vx cv cB cin cA cB cin chj co wceq wi vy vx cv cB cin cch vy cv vx cv
      cB cin wceq vy cv cB wss vx cv cB cin cB wss vy cv cA chj co cB cin vy cv
      cA cB cin chj co wceq vx cv cB cin cA chj co cB cin vx cv cB cin cA cB
      cin chj co wceq vy cv vx cv cB cin cB sseq1 vy cv vx cv cB cin wceq vy cv
      cA chj co cB cin vx cv cB cin cA chj co cB cin vy cv cA cB cin chj co vx
      cv cB cin cA cB cin chj co vy cv vx cv cB cin wceq vy cv cA chj co vx cv
      cB cin cA chj co cB vy cv vx cv cB cin cA chj opreq1 ineq1d vy cv vx cv
      cB cin cA cB cin chj opreq1 eqeq12d imbi12d rcla4v mpii syl ex com3l
      r19.21adv vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co
      wceq vx cch wral vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj
      co wceq wi vx cch wral vy cv cB wss vy cv cA chj co cB cin vy cv cA cB
      cin chj co wceq wi vy cch wral vx cv cB cin cA chj co cB cin vx cv cB cin
      cA cB cin chj co wceq vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wceq wi vx cch vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wceq vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co
      wceq vx cv cB wss vx cv cA chj co cB cin vx cv cB cin cA chj co cB cin vx
      cv cA cB cin chj co vx cv cB cin cA cB cin chj co vx cv cB wss vx cv cA
      chj co vx cv cB cin cA chj co cB vx cv cB wss vx cv vx cv cB cin cA chj
      vx cv cB wss vx cv vx cv cB cin wceq vx cv cB dfss biimpi opreq1d ineq1d
      vx cv cB wss vx cv vx cv cB cin cA cB cin chj vx cv cB wss vx cv vx cv cB
      cin wceq vx cv cB dfss biimpi opreq1d eqeq12d biimprcd r19.20si vx cv cB
      wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi vy cv cB wss vy
      cv cA chj co cB cin vy cv cA cB cin chj co wceq wi vx vy cch vx cv vy cv
      wceq vx cv cB wss vy cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj
      co wceq vy cv cA chj co cB cin vy cv cA cB cin chj co wceq vx cv vy cv cB
      sseq1 vx cv vy cv wceq vx cv cA chj co cB cin vy cv cA chj co cB cin vx
      cv cA cB cin chj co vy cv cA cB cin chj co vx cv vy cv wceq vx cv cA chj
      co vy cv cA chj co cB vx cv vy cv cA chj opreq1 ineq1d vx cv vy cv cA cB
      cin chj opreq1 eqeq12d imbi12d cbvralv sylib impbid1 adantl bitrd $.
      $( [22-Nov-2004] $) $( [6-Jul-2004] $)

    $( Binary relation expressing the modular pair property.  This version
       quantifies an ordering instead of an inference. $)
    mdbr4 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <-> A. x e. CH
        ( ( ( x i^i B ) vH A ) i^i B ) C_ ( ( x i^i B ) vH ( A i^i B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cmd wbr vy cv cB wss vy cv cA chj co cB
      cin vy cv cA cB cin chj co wss wi vy cch wral vx cv cB cin cA chj co cB
      cin vx cv cB cin cA cB cin chj co wss vx cch wral vy cA cB mdbr2 cB cch
      wcel vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin chj co wss wi vy
      cch wral vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co wss
      vx cch wral wb cA cch wcel cB cch wcel vy cv cB wss vy cv cA chj co cB
      cin vy cv cA cB cin chj co wss wi vy cch wral vx cv cB cin cA chj co cB
      cin vx cv cB cin cA cB cin chj co wss vx cch wral cB cch wcel vy cv cB
      wss vy cv cA chj co cB cin vy cv cA cB cin chj co wss wi vy cch wral vx
      cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co wss vx cch vx cv
      cch wcel cB cch wcel vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin
      chj co wss wi vy cch wral vx cv cB cin cA chj co cB cin vx cv cB cin cA
      cB cin chj co wss vx cv cch wcel cB cch wcel vy cv cB wss vy cv cA chj co
      cB cin vy cv cA cB cin chj co wss wi vy cch wral vx cv cB cin cA chj co
      cB cin vx cv cB cin cA cB cin chj co wss wi vx cv cch wcel cB cch wcel wa
      vx cv cB cin cch wcel vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin
      chj co wss wi vy cch wral vx cv cB cin cA chj co cB cin vx cv cB cin cA
      cB cin chj co wss wi vx cv cB chincl vx cv cB cin cch wcel vy cv cB wss
      vy cv cA chj co cB cin vy cv cA cB cin chj co wss wi vy cch wral vx cv cB
      cin cB wss vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co
      wss vx cv cB inss2 vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin
      chj co wss wi vx cv cB cin cB wss vx cv cB cin cA chj co cB cin vx cv cB
      cin cA cB cin chj co wss wi vy vx cv cB cin cch vy cv vx cv cB cin wceq
      vy cv cB wss vx cv cB cin cB wss vy cv cA chj co cB cin vy cv cA cB cin
      chj co wss vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co
      wss vy cv vx cv cB cin cB sseq1 vy cv vx cv cB cin wceq vy cv cA chj co
      cB cin vx cv cB cin cA chj co cB cin vy cv cA cB cin chj co vx cv cB cin
      cA cB cin chj co vy cv vx cv cB cin wceq vy cv cA chj co vx cv cB cin cA
      chj co cB vy cv vx cv cB cin cA chj opreq1 ineq1d vy cv vx cv cB cin cA
      cB cin chj opreq1 sseq12d imbi12d rcla4v mpii syl ex com3l r19.21adv vx
      cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co wss vx cch wral
      vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss wi vx cch
      wral vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin chj co wss wi vy
      cch wral vx cv cB cin cA chj co cB cin vx cv cB cin cA cB cin chj co wss
      vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss wi vx cch
      vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv cB
      cin cA chj co cB cin vx cv cB cin cA cB cin chj co wss vx cv cB wss vx cv
      cA chj co cB cin vx cv cB cin cA chj co cB cin vx cv cA cB cin chj co vx
      cv cB cin cA cB cin chj co vx cv cB wss vx cv cA chj co vx cv cB cin cA
      chj co cB vx cv cB wss vx cv vx cv cB cin cA chj vx cv cB wss vx cv vx cv
      cB cin wceq vx cv cB dfss biimpi opreq1d ineq1d vx cv cB wss vx cv vx cv
      cB cin cA cB cin chj vx cv cB wss vx cv vx cv cB cin wceq vx cv cB dfss
      biimpi opreq1d sseq12d biimprcd r19.20si vx cv cB wss vx cv cA chj co cB
      cin vx cv cA cB cin chj co wss wi vy cv cB wss vy cv cA chj co cB cin vy
      cv cA cB cin chj co wss wi vx vy cch vx cv vy cv wceq vx cv cB wss vy cv
      cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss vy cv cA chj co
      cB cin vy cv cA cB cin chj co wss vx cv vy cv cB sseq1 vx cv vy cv wceq
      vx cv cA chj co cB cin vy cv cA chj co cB cin vx cv cA cB cin chj co vy
      cv cA cB cin chj co vx cv vy cv wceq vx cv cA chj co vy cv cA chj co cB
      vx cv vy cv cA chj opreq1 ineq1d vx cv vy cv cA cB cin chj opreq1 sseq12d
      imbi12d cbvralv sylib impbid1 adantl bitrd $.
      $( [22-Nov-2004] $) $( [6-Jul-2004] $)

    $( Binary relation expressing the dual modular pair property. $)
    dmdbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
    A. x e. CH ( B C_ x -> ( ( x i^i A ) vH B ) = ( x i^i ( A vH B ) ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cdmd wbr cB vx cv wss vx cv cA cin cB
      chj co vx cv cA cB chj co cin wceq wi vx cch wral vy cv cch wcel vz cv
      cch wcel wa vz cv vx cv wss vx cv vy cv cin vz cv chj co vx cv vy cv vz
      cv chj co cin wceq wi vx cch wral wa cA cch wcel vz cv cch wcel wa vz cv
      vx cv wss vx cv cA cin vz cv chj co vx cv cA vz cv chj co cin wceq wi vx
      cch wral wa cA cch wcel cB cch wcel wa cB vx cv wss vx cv cA cin cB chj
      co vx cv cA cB chj co cin wceq wi vx cch wral wa vy vz cA cB cch cch cdmd
      vy cv cA wceq vy cv cch wcel vz cv cch wcel wa cA cch wcel vz cv cch wcel
      wa vz cv vx cv wss vx cv vy cv cin vz cv chj co vx cv vy cv vz cv chj co
      cin wceq wi vx cch wral vz cv vx cv wss vx cv cA cin vz cv chj co vx cv
      cA vz cv chj co cin wceq wi vx cch wral vy cv cA wceq vy cv cch wcel cA
      cch wcel vz cv cch wcel vy cv cA cch eleq1 anbi1d vy cv cA wceq vz cv vx
      cv wss vx cv vy cv cin vz cv chj co vx cv vy cv vz cv chj co cin wceq wi
      vz cv vx cv wss vx cv cA cin vz cv chj co vx cv cA vz cv chj co cin wceq
      wi vx cch vy cv cA wceq vx cv vy cv cin vz cv chj co vx cv vy cv vz cv
      chj co cin wceq vx cv cA cin vz cv chj co vx cv cA vz cv chj co cin wceq
      vz cv vx cv wss vy cv cA wceq vx cv vy cv cin vz cv chj co vx cv cA cin
      vz cv chj co vx cv vy cv vz cv chj co cin vx cv cA vz cv chj co cin vy cv
      cA wceq vx cv vy cv cin vx cv cA cin vz cv chj vy cv cA vx cv ineq2
      opreq1d vy cv cA wceq vy cv vz cv chj co cA vz cv chj co vx cv vy cv cA
      vz cv chj opreq1 ineq2d eqeq12d imbi2d ralbidv anbi12d vz cv cB wceq cA
      cch wcel vz cv cch wcel wa cA cch wcel cB cch wcel wa vz cv vx cv wss vx
      cv cA cin vz cv chj co vx cv cA vz cv chj co cin wceq wi vx cch wral cB
      vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi vx cch
      wral vz cv cB wceq vz cv cch wcel cB cch wcel cA cch wcel vz cv cB cch
      eleq1 anbi2d vz cv cB wceq vz cv vx cv wss vx cv cA cin vz cv chj co vx
      cv cA vz cv chj co cin wceq wi cB vx cv wss vx cv cA cin cB chj co vx cv
      cA cB chj co cin wceq wi vx cch vz cv cB wceq vz cv vx cv wss cB vx cv
      wss vx cv cA cin vz cv chj co vx cv cA vz cv chj co cin wceq vx cv cA cin
      cB chj co vx cv cA cB chj co cin wceq vz cv cB vx cv sseq1 vz cv cB wceq
      vx cv cA cin vz cv chj co vx cv cA cin cB chj co vx cv cA vz cv chj co
      cin vx cv cA cB chj co cin vz cv cB vx cv cA cin chj opreq2 vz cv cB wceq
      cA vz cv chj co cA cB chj co vx cv vz cv cB cA chj opreq2 ineq2d eqeq12d
      imbi12d ralbidv anbi12d vy vz vx df-dmd brabg bianabs $.
      $( [29-Apr-2006] $) $( [27-Apr-2006] $)

    $( The dual modular pair property expressed in terms of the modular pair
       property, that hold in Hilbert lattices.  Remark 29.6 of [MaedaMaeda]
       p. 130. $)
    dmdmd $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
                   ( _|_ ` A ) MH ( _|_ ` B ) ) ) $=
      cA cch wcel cB cch wcel wa vy cv cB cort cfv wss vy cv cA cort cfv chj co
      cB cort cfv cin vy cv cA cort cfv cB cort cfv cin chj co wceq wi vy cch
      wral cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi
      vx cch wral cA cort cfv cB cort cfv cmd wbr cA cB cdmd wbr cA cch wcel cB
      cch wcel wa vy cv cB cort cfv wss vy cv cA cort cfv chj co cB cort cfv
      cin vy cv cA cort cfv cB cort cfv cin chj co wceq wi vy cch wral cB vx cv
      wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi vx cch wral cA
      cch wcel cB cch wcel wa vy cv cB cort cfv wss vy cv cA cort cfv chj co cB
      cort cfv cin vy cv cA cort cfv cB cort cfv cin chj co wceq wi vy cch wral
      cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi vx cch
      cA cch wcel cB cch wcel wa vx cv cort cfv cch wcel vx cv cort cfv cB cort
      cfv wss vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx cv cort cfv
      cA cort cfv cB cort cfv cin chj co wceq wi wi vx cv cch wcel cB vx cv wss
      vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi wi vy cv cB cort
      cfv wss vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv cB
      cort cfv cin chj co wceq wi vy cch wral cA cch wcel cB cch wcel wa vx cv
      cch wcel vx cv cort cfv cch wcel vx cv cort cfv cB cort cfv wss vx cv
      cort cfv cA cort cfv chj co cB cort cfv cin vx cv cort cfv cA cort cfv cB
      cort cfv cin chj co wceq wi wi cB vx cv wss vx cv cA cin cB chj co vx cv
      cA cB chj co cin wceq wi cA cch wcel cB cch wcel wa vx cv cch wcel vx cv
      cort cfv cch wcel vx cv cort cfv cB cort cfv wss vx cv cort cfv cA cort
      cfv chj co cB cort cfv cin vx cv cort cfv cA cort cfv cB cort cfv cin chj
      co wceq wi wi cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin
      wceq wi wi cA cch wcel cB cch wcel wa vx cv cch wcel wa vx cv cort cfv
      cch wcel vx cv cort cfv cB cort cfv wss vx cv cort cfv cA cort cfv chj co
      cB cort cfv cin vx cv cort cfv cA cort cfv cB cort cfv cin chj co wceq wi
      wi vx cv cort cfv cB cort cfv wss vx cv cort cfv cA cort cfv chj co cB
      cort cfv cin vx cv cort cfv cA cort cfv cB cort cfv cin chj co wceq wi cB
      vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi vx cv cch
      wcel vx cv cort cfv cch wcel vx cv cort cfv cB cort cfv wss vx cv cort
      cfv cA cort cfv chj co cB cort cfv cin vx cv cort cfv cA cort cfv cB cort
      cfv cin chj co wceq wi wi vx cv cort cfv cB cort cfv wss vx cv cort cfv
      cA cort cfv chj co cB cort cfv cin vx cv cort cfv cA cort cfv cB cort cfv
      cin chj co wceq wi wi cA cch wcel cB cch wcel wa vx cv cort cfv cch wcel
      vx cv cort cfv cB cort cfv wss vx cv cort cfv cA cort cfv chj co cB cort
      cfv cin vx cv cort cfv cA cort cfv cB cort cfv cin chj co wceq wi wi vx
      cv cch wcel vx cv cort cfv cB cort cfv wss vx cv cort cfv cA cort cfv chj
      co cB cort cfv cin vx cv cort cfv cA cort cfv cB cort cfv cin chj co wceq
      wi vx cv cch wcel vx cv cort cfv cch wcel vx cv cort cfv cB cort cfv wss
      vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx cv cort cfv cA cort
      cfv cB cort cfv cin chj co wceq wi vx cv choccl imim1i com12 adantl cA
      cch wcel cB cch wcel wa vx cv cch wcel wa cB vx cv wss vx cv cort cfv cB
      cort cfv wss vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx cv cort
      cfv cA cort cfv cB cort cfv cin chj co wceq vx cv cA cin cB chj co vx cv
      cA cB chj co cin wceq cB cch wcel vx cv cch wcel cB vx cv wss vx cv cort
      cfv cB cort cfv wss wi cA cch wcel cB cch wcel vx cv cch wcel wa cB vx cv
      wss vx cv cort cfv cB cort cfv wss cB vx cv chsscon3 biimpd adantll cA
      cch wcel cB cch wcel wa vx cv cch wcel wa vx cv cort cfv cA cort cfv chj
      co cB cort cfv cin cort cfv vx cv cort cfv cA cort cfv cB cort cfv cin
      chj co cort cfv wceq vx cv cA cin cB chj co vx cv cA cB chj co cin wceq
      vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx cv cort cfv cA cort
      cfv cB cort cfv cin chj co wceq vx cv cch wcel cA cch wcel cB cch wcel wa
      vx cv cort cfv cA cort cfv chj co cB cort cfv cin cort cfv vx cv cort cfv
      cA cort cfv cB cort cfv cin chj co cort cfv wceq vx cv cA cin cB chj co
      vx cv cA cB chj co cin wceq wb vx cv cch wcel cA cch wcel cB cch wcel wa
      wa vx cv cort cfv cA cort cfv chj co cB cort cfv cin cort cfv vx cv cA
      cin cB chj co vx cv cort cfv cA cort cfv cB cort cfv cin chj co cort cfv
      vx cv cA cB chj co cin vx cv cch wcel cA cch wcel cB cch wcel vx cv cort
      cfv cA cort cfv chj co cB cort cfv cin cort cfv vx cv cA cin cB chj co
      wceq vx cv cch wcel cA cch wcel wa cB cch wcel wa vx cv cort cfv cA cort
      cfv chj co cB cort cfv cin cort cfv vx cv cort cfv cA cort cfv chj co
      cort cfv cB chj co vx cv cA cin cB chj co vx cv cort cfv cA cort cfv chj
      co cch wcel cB cch wcel vx cv cort cfv cA cort cfv chj co cB cort cfv cin
      cort cfv vx cv cort cfv cA cort cfv chj co cort cfv cB chj co wceq vx cv
      cch wcel cA cch wcel wa vx cv cort cfv cA cort cfv chj co cB chdmm3 vx cv
      cort cfv cch wcel cA cort cfv cch wcel vx cv cort cfv cA cort cfv chj co
      cch wcel vx cv cch wcel cA cch wcel vx cv cort cfv cA cort cfv chjcl vx
      cv choccl cA choccl syl2an sylan vx cv cch wcel cA cch wcel wa cB cch
      wcel wa vx cv cort cfv cA cort cfv chj co cort cfv vx cv cA cin cB chj vx
      cv cch wcel cA cch wcel wa vx cv cort cfv cA cort cfv chj co cort cfv vx
      cv cA cin wceq cB cch wcel vx cv cA chdmj4 adantr opreq1d eqtrd anasss vx
      cv cch wcel cA cch wcel cB cch wcel wa wa vx cv cort cfv cA cort cfv cB
      cort cfv cin chj co cort cfv vx cv cA cort cfv cB cort cfv cin cort cfv
      cin vx cv cA cB chj co cin vx cv cch wcel cA cort cfv cB cort cfv cin cch
      wcel vx cv cort cfv cA cort cfv cB cort cfv cin chj co cort cfv vx cv cA
      cort cfv cB cort cfv cin cort cfv cin wceq cA cch wcel cB cch wcel wa vx
      cv cA cort cfv cB cort cfv cin chdmj2 cA cort cfv cch wcel cB cort cfv
      cch wcel cA cort cfv cB cort cfv cin cch wcel cA cch wcel cB cch wcel cA
      cort cfv cB cort cfv chincl cA choccl cB choccl syl2an sylan2 vx cv cch
      wcel cA cch wcel cB cch wcel wa wa cA cort cfv cB cort cfv cin cort cfv
      cA cB chj co vx cv cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv cin
      cort cfv cA cB chj co wceq vx cv cch wcel cA cB chdmm4 adantl ineq2d
      eqtrd eqeq12d ancoms vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx
      cv cort cfv cA cort cfv cB cort cfv cin chj co cort fveq2 syl5bi imim12d
      syld ex com23 vy cv cB cort cfv wss vy cv cA cort cfv chj co cB cort cfv
      cin vy cv cA cort cfv cB cort cfv cin chj co wceq wi vx cv cort cfv cB
      cort cfv wss vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx cv cort
      cfv cA cort cfv cB cort cfv cin chj co wceq wi vy vx cv cort cfv cch vy
      cv vx cv cort cfv wceq vy cv cB cort cfv wss vx cv cort cfv cB cort cfv
      wss vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv cB cort
      cfv cin chj co wceq vx cv cort cfv cA cort cfv chj co cB cort cfv cin vx
      cv cort cfv cA cort cfv cB cort cfv cin chj co wceq vy cv vx cv cort cfv
      cB cort cfv sseq1 vy cv vx cv cort cfv wceq vy cv cA cort cfv chj co cB
      cort cfv cin vx cv cort cfv cA cort cfv chj co cB cort cfv cin vy cv cA
      cort cfv cB cort cfv cin chj co vx cv cort cfv cA cort cfv cB cort cfv
      cin chj co vy cv vx cv cort cfv wceq vy cv cA cort cfv chj co vx cv cort
      cfv cA cort cfv chj co cB cort cfv vy cv vx cv cort cfv cA cort cfv chj
      opreq1 ineq1d vy cv vx cv cort cfv cA cort cfv cB cort cfv cin chj opreq1
      eqeq12d imbi12d rcla4cv syl5 r19.21adv cA cch wcel cB cch wcel wa cB vx
      cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi vx cch wral
      vy cv cB cort cfv wss vy cv cA cort cfv chj co cB cort cfv cin vy cv cA
      cort cfv cB cort cfv cin chj co wceq wi vy cch cA cch wcel cB cch wcel wa
      vy cv cort cfv cch wcel cB vy cv cort cfv wss vy cv cort cfv cA cin cB
      chj co vy cv cort cfv cA cB chj co cin wceq wi wi vy cv cch wcel vy cv cB
      cort cfv wss vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv
      cB cort cfv cin chj co wceq wi wi cB vx cv wss vx cv cA cin cB chj co vx
      cv cA cB chj co cin wceq wi vx cch wral cA cch wcel cB cch wcel wa vy cv
      cch wcel vy cv cort cfv cch wcel cB vy cv cort cfv wss vy cv cort cfv cA
      cin cB chj co vy cv cort cfv cA cB chj co cin wceq wi wi vy cv cB cort
      cfv wss vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv cB
      cort cfv cin chj co wceq wi cA cch wcel cB cch wcel wa vy cv cch wcel vy
      cv cort cfv cch wcel cB vy cv cort cfv wss vy cv cort cfv cA cin cB chj
      co vy cv cort cfv cA cB chj co cin wceq wi wi vy cv cB cort cfv wss vy cv
      cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv cB cort cfv cin chj
      co wceq wi wi cA cch wcel cB cch wcel wa vy cv cch wcel wa vy cv cort cfv
      cch wcel cB vy cv cort cfv wss vy cv cort cfv cA cin cB chj co vy cv cort
      cfv cA cB chj co cin wceq wi wi cB vy cv cort cfv wss vy cv cort cfv cA
      cin cB chj co vy cv cort cfv cA cB chj co cin wceq wi vy cv cB cort cfv
      wss vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv cB cort
      cfv cin chj co wceq wi vy cv cch wcel vy cv cort cfv cch wcel cB vy cv
      cort cfv wss vy cv cort cfv cA cin cB chj co vy cv cort cfv cA cB chj co
      cin wceq wi wi cB vy cv cort cfv wss vy cv cort cfv cA cin cB chj co vy
      cv cort cfv cA cB chj co cin wceq wi wi cA cch wcel cB cch wcel wa vy cv
      cort cfv cch wcel cB vy cv cort cfv wss vy cv cort cfv cA cin cB chj co
      vy cv cort cfv cA cB chj co cin wceq wi wi vy cv cch wcel cB vy cv cort
      cfv wss vy cv cort cfv cA cin cB chj co vy cv cort cfv cA cB chj co cin
      wceq wi vy cv cch wcel vy cv cort cfv cch wcel cB vy cv cort cfv wss vy
      cv cort cfv cA cin cB chj co vy cv cort cfv cA cB chj co cin wceq wi vy
      cv choccl imim1i com12 adantl cA cch wcel cB cch wcel wa vy cv cch wcel
      wa vy cv cB cort cfv wss cB vy cv cort cfv wss vy cv cort cfv cA cin cB
      chj co vy cv cort cfv cA cB chj co cin wceq vy cv cA cort cfv chj co cB
      cort cfv cin vy cv cA cort cfv cB cort cfv cin chj co wceq cB cch wcel vy
      cv cch wcel vy cv cB cort cfv wss cB vy cv cort cfv wss wi cA cch wcel cB
      cch wcel vy cv cch wcel wa cB vy cv cort cfv wss vy cv cB cort cfv wss cB
      vy cv chsscon2 biimprd adantll cA cch wcel cB cch wcel wa vy cv cch wcel
      wa vy cv cort cfv cA cin cB chj co cort cfv vy cv cort cfv cA cB chj co
      cin cort cfv wceq vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort
      cfv cB cort cfv cin chj co wceq vy cv cort cfv cA cin cB chj co vy cv
      cort cfv cA cB chj co cin wceq vy cv cch wcel cA cch wcel cB cch wcel wa
      vy cv cort cfv cA cin cB chj co cort cfv vy cv cort cfv cA cB chj co cin
      cort cfv wceq vy cv cA cort cfv chj co cB cort cfv cin vy cv cA cort cfv
      cB cort cfv cin chj co wceq wb vy cv cch wcel cA cch wcel cB cch wcel wa
      wa vy cv cort cfv cA cin cB chj co cort cfv vy cv cA cort cfv chj co cB
      cort cfv cin vy cv cort cfv cA cB chj co cin cort cfv vy cv cA cort cfv
      cB cort cfv cin chj co vy cv cch wcel cA cch wcel cB cch wcel vy cv cort
      cfv cA cin cB chj co cort cfv vy cv cA cort cfv chj co cB cort cfv cin
      wceq vy cv cch wcel cA cch wcel wa cB cch wcel wa vy cv cort cfv cA cin
      cB chj co cort cfv vy cv cort cfv cA cin cort cfv cB cort cfv cin vy cv
      cA cort cfv chj co cB cort cfv cin vy cv cort cfv cA cin cch wcel cB cch
      wcel vy cv cort cfv cA cin cB chj co cort cfv vy cv cort cfv cA cin cort
      cfv cB cort cfv cin wceq vy cv cch wcel cA cch wcel wa vy cv cort cfv cA
      cin cB chdmj1 vy cv cort cfv cch wcel cA cch wcel vy cv cort cfv cA cin
      cch wcel vy cv cch wcel vy cv cort cfv cA chincl vy cv choccl sylan sylan
      vy cv cch wcel cA cch wcel wa cB cch wcel wa vy cv cort cfv cA cin cort
      cfv vy cv cA cort cfv chj co cB cort cfv vy cv cch wcel cA cch wcel wa vy
      cv cort cfv cA cin cort cfv vy cv cA cort cfv chj co wceq cB cch wcel vy
      cv cA chdmm2 adantr ineq1d eqtrd anasss vy cv cch wcel cA cch wcel cB cch
      wcel wa wa vy cv cort cfv cA cB chj co cin cort cfv vy cv cA cB chj co
      cort cfv chj co vy cv cA cort cfv cB cort cfv cin chj co vy cv cch wcel
      cA cB chj co cch wcel vy cv cort cfv cA cB chj co cin cort cfv vy cv cA
      cB chj co cort cfv chj co wceq cA cch wcel cB cch wcel wa vy cv cA cB chj
      co chdmm2 cA cB chjcl sylan2 vy cv cch wcel cA cch wcel cB cch wcel wa wa
      cA cB chj co cort cfv cA cort cfv cB cort cfv cin vy cv chj cA cch wcel
      cB cch wcel wa cA cB chj co cort cfv cA cort cfv cB cort cfv cin wceq vy
      cv cch wcel cA cB chdmj1 adantl opreq2d eqtrd eqeq12d ancoms vy cv cort
      cfv cA cin cB chj co vy cv cort cfv cA cB chj co cin cort fveq2 syl5bi
      imim12d syld ex com23 cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj
      co cin wceq wi cB vy cv cort cfv wss vy cv cort cfv cA cin cB chj co vy
      cv cort cfv cA cB chj co cin wceq wi vx vy cv cort cfv cch vx cv vy cv
      cort cfv wceq cB vx cv wss cB vy cv cort cfv wss vx cv cA cin cB chj co
      vx cv cA cB chj co cin wceq vy cv cort cfv cA cin cB chj co vy cv cort
      cfv cA cB chj co cin wceq vx cv vy cv cort cfv cB sseq2 vx cv vy cv cort
      cfv wceq vx cv cA cin cB chj co vy cv cort cfv cA cin cB chj co vx cv cA
      cB chj co cin vy cv cort cfv cA cB chj co cin vx cv vy cv cort cfv wceq
      vx cv cA cin vy cv cort cfv cA cin cB chj vx cv vy cv cort cfv cA ineq1
      opreq1d vx cv vy cv cort cfv cA cB chj co ineq1 eqeq12d imbi12d rcla4cv
      syl5 r19.21adv impbid cA cort cfv cch wcel cB cort cfv cch wcel cA cort
      cfv cB cort cfv cmd wbr vy cv cB cort cfv wss vy cv cA cort cfv chj co cB
      cort cfv cin vy cv cA cort cfv cB cort cfv cin chj co wceq wi vy cch wral
      wb cA cch wcel cB cch wcel vy cA cort cfv cB cort cfv mdbr cA choccl cB
      choccl syl2an vx cA cB dmdbr 3bitr4rd $.
      $( [24-May-2006] $) $( [27-Apr-2006] $)

    $( The modular pair property expressed in terms of the dual modular pair
       property. $)
    mddmd $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <->
                   ( _|_ ` A ) MH* ( _|_ ` B ) ) ) $=
      cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv cdmd wbr cA cort cfv
      cort cfv cB cort cfv cort cfv cmd wbr cA cB cmd wbr cA cort cfv cch wcel
      cB cort cfv cch wcel cA cort cfv cB cort cfv cdmd wbr cA cort cfv cort
      cfv cB cort cfv cort cfv cmd wbr wb cA cch wcel cB cch wcel cA cort cfv
      cB cort cfv dmdmd cA choccl cB choccl syl2an cA cch wcel cB cch wcel cA
      cort cfv cort cfv cA cB cort cfv cort cfv cB cmd cA ococ cB ococ
      breqan12d bitr2d $.
      $( [28-May-2006] $) $( [27-Apr-2006] $)

    $( Consequence of the dual modular pair property. $)
    dmdi $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A MH* B /\
              B C_ C ) ) -> ( ( C i^i A ) vH B ) = ( C i^i ( A vH B ) ) ) $=
      cA cch wcel cB cch wcel cC cch wcel w3a cA cB cdmd wbr cB cC wss cC cA
      cin cB chj co cC cA cB chj co cin wceq cA cch wcel cB cch wcel cC cch
      wcel cA cB cdmd wbr cB cC wss cC cA cin cB chj co cC cA cB chj co cin
      wceq wi wi cA cch wcel cB cch wcel wa cA cB cdmd wbr cB vx cv wss vx cv
      cA cin cB chj co vx cv cA cB chj co cin wceq wi vx cch wral cC cch wcel
      cB cC wss cC cA cin cB chj co cC cA cB chj co cin wceq wi cA cch wcel cB
      cch wcel wa cA cB cdmd wbr cB vx cv wss vx cv cA cin cB chj co vx cv cA
      cB chj co cin wceq wi vx cch wral vx cA cB dmdbr biimpd cB vx cv wss vx
      cv cA cin cB chj co vx cv cA cB chj co cin wceq wi cB cC wss cC cA cin cB
      chj co cC cA cB chj co cin wceq wi vx cC cch vx cv cC wceq cB vx cv wss
      cB cC wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq cC cA cin cB
      chj co cC cA cB chj co cin wceq vx cv cC cB sseq2 vx cv cC wceq vx cv cA
      cin cB chj co cC cA cin cB chj co vx cv cA cB chj co cin cC cA cB chj co
      cin vx cv cC wceq vx cv cA cin cC cA cin cB chj vx cv cC cA ineq1 opreq1d
      vx cv cC cA cB chj co ineq1 eqeq12d imbi12d rcla4v sylan9 3impa imp32 $.
      $( [6-Jan-2007] $) $( [27-Apr-2006] $)

    $( Binary relation expressing the dual modular pair property.  This version
       has a weaker constraint than ~ dmdbr . $)
    dmdbr2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
   A. x e. CH ( B C_ x -> ( x i^i ( A vH B ) ) C_ ( ( x i^i A ) vH B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cdmd wbr cB vx cv wss vx cv cA cin cB
      chj co vx cv cA cB chj co cin wceq wi vx cch wral cB vx cv wss vx cv cA
      cB chj co cin vx cv cA cin cB chj co wss wi vx cch wral vx cA cB dmdbr cA
      cch wcel cB cch wcel wa cB vx cv wss vx cv cA cin cB chj co vx cv cA cB
      chj co cin wceq wi cB vx cv wss vx cv cA cB chj co cin vx cv cA cin cB
      chj co wss wi vx cch cA cch wcel cB cch wcel wa vx cv cch wcel wa cB vx
      cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq vx cv cA cB chj
      co cin vx cv cA cin cB chj co wss cA cch wcel cB cch wcel wa vx cv cch
      wcel wa cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wss vx
      cv cA cin cB chj co vx cv cA cB chj co cin wceq vx cv cA cB chj co cin vx
      cv cA cin cB chj co wss wb cA cch wcel cB cch wcel wa vx cv cch wcel wa
      cB vx cv wss vx cv cA cin cB chj co vx cv wss vx cv cA cin cB chj co cA
      cB chj co wss wa vx cv cA cin cB chj co vx cv cA cB chj co cin wss cA cch
      wcel cB cch wcel wa vx cv cch wcel wa cB vx cv wss vx cv cA cin cB chj co
      vx cv wss vx cv cA cin cB chj co cA cB chj co wss vx cv cA cin cch wcel
      cB cch wcel vx cv cch wcel cB vx cv wss vx cv cA cin cB chj co vx cv wss
      wi cA cch wcel cB cch wcel wa vx cv cch wcel wa vx cv cA cin cch wcel cB
      cch wcel vx cv cch wcel w3a vx cv cA cin vx cv wss cB vx cv wss vx cv cA
      cin cB chj co vx cv wss vx cv cA inss1 vx cv cA cin cch wcel cB cch wcel
      vx cv cch wcel w3a vx cv cA cin vx cv wss cB vx cv wss wa vx cv cA cin cB
      chj co vx cv wss vx cv cA cin cB vx cv chlub biimpd mpani cA cch wcel vx
      cv cch wcel vx cv cA cin cch wcel cB cch wcel vx cv cch wcel cA cch wcel
      vx cv cA cin cch wcel vx cv cA chincl ancoms adantlr cA cch wcel cB cch
      wcel vx cv cch wcel simplr cA cch wcel cB cch wcel wa vx cv cch wcel
      pm3.27 syl3anc vx cv cA cin cch wcel cA cch wcel cB cch wcel vx cv cA cin
      cB chj co cA cB chj co wss cA cch wcel cB cch wcel wa vx cv cch wcel wa
      vx cv cA cin cch wcel cA cch wcel cB cch wcel w3a vx cv cA cin cA wss vx
      cv cA cin cB chj co cA cB chj co wss vx cv cA inss2 vx cv cA cin cA cB
      chlej1 mpan2 cA cch wcel vx cv cch wcel vx cv cA cin cch wcel cB cch wcel
      vx cv cch wcel cA cch wcel vx cv cA cin cch wcel vx cv cA chincl ancoms
      adantlr cA cch wcel cB cch wcel vx cv cch wcel simpll cA cch wcel cB cch
      wcel vx cv cch wcel simplr syl3anc jctird vx cv cA cin cB chj co vx cv cA
      cB chj co ssin syl6ib vx cv cA cin cB chj co vx cv cA cB chj co cin wceq
      vx cv cA cin cB chj co vx cv cA cB chj co cin wss vx cv cA cB chj co cin
      vx cv cA cin cB chj co wss vx cv cA cin cB chj co vx cv cA cB chj co cin
      eqss baib syl6 pm5.74d ralbidva bitrd $.
      $( [24-Jul-2007] $) $( [30-Jun-2004] $)

    $( Consequence of the dual modular pair property. $)
    dmdi2 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A MH* B /\ B C_ C
         ) ) -> ( C i^i ( A vH B ) ) C_ ( ( C i^i A ) vH B ) ) $=
      cA cch wcel cB cch wcel cC cch wcel w3a cA cB cdmd wbr cB cC wss wa wa cC
      cA cin cB chj co cC cA cB chj co cin wceq cC cA cB chj co cin cC cA cin
      cB chj co wss cA cB cC dmdi cC cA cB chj co cin cC cA cin cB chj co
      eqimss2 syl $.
      $( [7-Jul-2008] $) $( [14-Jan-2005] $)

    $( Binary relation expressing the dual modular pair property.  This version
       quantifies an equality instead of an inference. $)
    dmdbr3 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <-> A. x e. CH
           ( ( ( x vH B ) i^i A ) vH B ) = ( ( x vH B ) i^i ( A vH B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cdmd wbr cB vy cv wss vy cv cA cin cB
      chj co vy cv cA cB chj co cin wceq wi vy cch wral vx cv cB chj co cA cin
      cB chj co vx cv cB chj co cA cB chj co cin wceq vx cch wral vy cA cB
      dmdbr cB cch wcel cB vy cv wss vy cv cA cin cB chj co vy cv cA cB chj co
      cin wceq wi vy cch wral vx cv cB chj co cA cin cB chj co vx cv cB chj co
      cA cB chj co cin wceq vx cch wral wb cA cch wcel cB cch wcel cB vy cv wss
      vy cv cA cin cB chj co vy cv cA cB chj co cin wceq wi vy cch wral vx cv
      cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq vx cch
      wral cB cch wcel cB vy cv wss vy cv cA cin cB chj co vy cv cA cB chj co
      cin wceq wi vy cch wral vx cv cB chj co cA cin cB chj co vx cv cB chj co
      cA cB chj co cin wceq vx cch vx cv cch wcel cB cch wcel cB vy cv wss vy
      cv cA cin cB chj co vy cv cA cB chj co cin wceq wi vy cch wral vx cv cB
      chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq vx cv cch
      wcel cB cch wcel cB vy cv wss vy cv cA cin cB chj co vy cv cA cB chj co
      cin wceq wi vy cch wral vx cv cB chj co cA cin cB chj co vx cv cB chj co
      cA cB chj co cin wceq wi vx cv cch wcel cB cch wcel wa cB vy cv wss vy cv
      cA cin cB chj co vy cv cA cB chj co cin wceq wi vy cch wral cB vx cv cB
      chj co wss vx cv cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co
      cin wceq cB cch wcel vx cv cch wcel cB vx cv cB chj co wss cB vx cv chub2
      ancoms vx cv cch wcel cB cch wcel wa vx cv cB chj co cch wcel cB vy cv
      wss vy cv cA cin cB chj co vy cv cA cB chj co cin wceq wi vy cch wral cB
      vx cv cB chj co wss vx cv cB chj co cA cin cB chj co vx cv cB chj co cA
      cB chj co cin wceq wi wi vx cv cB chjcl cB vy cv wss vy cv cA cin cB chj
      co vy cv cA cB chj co cin wceq wi cB vx cv cB chj co wss vx cv cB chj co
      cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq wi vy vx cv cB chj
      co cch vy cv vx cv cB chj co wceq cB vy cv wss cB vx cv cB chj co wss vy
      cv cA cin cB chj co vy cv cA cB chj co cin wceq vx cv cB chj co cA cin cB
      chj co vx cv cB chj co cA cB chj co cin wceq vy cv vx cv cB chj co cB
      sseq2 vy cv vx cv cB chj co wceq vy cv cA cin cB chj co vx cv cB chj co
      cA cin cB chj co vy cv cA cB chj co cin vx cv cB chj co cA cB chj co cin
      vy cv vx cv cB chj co wceq vy cv cA cin vx cv cB chj co cA cin cB chj vy
      cv vx cv cB chj co cA ineq1 opreq1d vy cv vx cv cB chj co cA cB chj co
      ineq1 eqeq12d imbi12d rcla4v syl mpid ex com3l r19.21adv cB cch wcel vx
      cv cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq vx
      cch wral cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq
      wi vx cch wral cB vy cv wss vy cv cA cin cB chj co vy cv cA cB chj co cin
      wceq wi vy cch wral cB cch wcel vx cv cB chj co cA cin cB chj co vx cv cB
      chj co cA cB chj co cin wceq cB vx cv wss vx cv cA cin cB chj co vx cv cA
      cB chj co cin wceq wi vx cch cB cch wcel vx cv cch wcel wa cB vx cv wss
      vx cv cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq vx
      cv cA cin cB chj co vx cv cA cB chj co cin wceq cB cch wcel vx cv cch
      wcel wa cB vx cv wss vx cv cB chj co cA cin cB chj co vx cv cB chj co cA
      cB chj co cin wceq vx cv cA cin cB chj co vx cv cA cB chj co cin wceq wi
      cB cch wcel vx cv cch wcel wa cB vx cv wss wa vx cv cB chj co cA cin cB
      chj co vx cv cB chj co cA cB chj co cin wceq vx cv cA cin cB chj co vx cv
      cA cB chj co cin wceq cB cch wcel vx cv cch wcel wa cB vx cv wss wa vx cv
      cB chj co cA cin cB chj co vx cv cA cin cB chj co vx cv cB chj co cA cB
      chj co cin vx cv cA cB chj co cin cB cch wcel vx cv cch wcel wa cB vx cv
      wss wa vx cv cB chj co cA cin vx cv cA cin cB chj cB cch wcel vx cv cch
      wcel wa cB vx cv wss wa vx cv cB chj co vx cv cA cB cch wcel vx cv cch
      wcel wa cB vx cv wss vx cv cB chj co vx cv wceq cB vx cv chlejb2 biimpa
      ineq1d opreq1d cB cch wcel vx cv cch wcel wa cB vx cv wss wa vx cv cB chj
      co vx cv cA cB chj co cB cch wcel vx cv cch wcel wa cB vx cv wss vx cv cB
      chj co vx cv wceq cB vx cv chlejb2 biimpa ineq1d eqeq12d biimpd ex com23
      r19.20dva cB vx cv wss vx cv cA cin cB chj co vx cv cA cB chj co cin wceq
      wi cB vy cv wss vy cv cA cin cB chj co vy cv cA cB chj co cin wceq wi vx
      vy cch vx cv vy cv wceq cB vx cv wss cB vy cv wss vx cv cA cin cB chj co
      vx cv cA cB chj co cin wceq vy cv cA cin cB chj co vy cv cA cB chj co cin
      wceq vx cv vy cv cB sseq2 vx cv vy cv wceq vx cv cA cin cB chj co vy cv
      cA cin cB chj co vx cv cA cB chj co cin vy cv cA cB chj co cin vx cv vy
      cv wceq vx cv cA cin vy cv cA cin cB chj vx cv vy cv cA ineq1 opreq1d vx
      cv vy cv cA cB chj co ineq1 eqeq12d imbi12d cbvralv syl6ib impbid adantl
      bitrd $.
      $( [11-Aug-2007] $) $( [6-Jul-2004] $)

    $( Binary relation expressing the dual modular pair property.  This version
       quantifies an ordering instead of an inference. $)
    dmdbr4 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <-> A. x e. CH
          ( ( x vH B ) i^i ( A vH B ) ) C_ ( ( ( x vH B ) i^i A ) vH B ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cdmd wbr cB vy cv wss vy cv cA cB chj co
      cin vy cv cA cin cB chj co wss wi vy cch wral vx cv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co wss vx cch wral vy cA cB dmdbr2
      cB cch wcel cB vy cv wss vy cv cA cB chj co cin vy cv cA cin cB chj co
      wss wi vy cch wral vx cv cB chj co cA cB chj co cin vx cv cB chj co cA
      cin cB chj co wss vx cch wral wb cA cch wcel cB cch wcel cB vy cv wss vy
      cv cA cB chj co cin vy cv cA cin cB chj co wss wi vy cch wral vx cv cB
      chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cch wral
      cB cch wcel cB vy cv wss vy cv cA cB chj co cin vy cv cA cin cB chj co
      wss wi vy cch wral vx cv cB chj co cA cB chj co cin vx cv cB chj co cA
      cin cB chj co wss vx cch vx cv cch wcel cB cch wcel cB vy cv wss vy cv cA
      cB chj co cin vy cv cA cin cB chj co wss wi vy cch wral vx cv cB chj co
      cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cv cch wcel cB
      cch wcel cB vy cv wss vy cv cA cB chj co cin vy cv cA cin cB chj co wss
      wi vy cch wral vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss wi vx cv cch wcel cB cch wcel wa cB vy cv wss vy cv cA cB chj
      co cin vy cv cA cin cB chj co wss wi vy cch wral cB vx cv cB chj co wss
      vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss cB
      cch wcel vx cv cch wcel cB vx cv cB chj co wss cB vx cv chub2 ancoms vx
      cv cch wcel cB cch wcel wa vx cv cB chj co cch wcel cB vy cv wss vy cv cA
      cB chj co cin vy cv cA cin cB chj co wss wi vy cch wral cB vx cv cB chj
      co wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co
      wss wi wi vx cv cB chjcl cB vy cv wss vy cv cA cB chj co cin vy cv cA cin
      cB chj co wss wi cB vx cv cB chj co wss vx cv cB chj co cA cB chj co cin
      vx cv cB chj co cA cin cB chj co wss wi vy vx cv cB chj co cch vy cv vx
      cv cB chj co wceq cB vy cv wss cB vx cv cB chj co wss vy cv cA cB chj co
      cin vy cv cA cin cB chj co wss vx cv cB chj co cA cB chj co cin vx cv cB
      chj co cA cin cB chj co wss vy cv vx cv cB chj co cB sseq2 vy cv vx cv cB
      chj co wceq vy cv cA cB chj co cin vx cv cB chj co cA cB chj co cin vy cv
      cA cin cB chj co vx cv cB chj co cA cin cB chj co vy cv vx cv cB chj co
      cA cB chj co ineq1 vy cv vx cv cB chj co wceq vy cv cA cin vx cv cB chj
      co cA cin cB chj vy cv vx cv cB chj co cA ineq1 opreq1d sseq12d imbi12d
      rcla4v syl mpid ex com3l r19.21adv cB cch wcel vx cv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co wss vx cch wral cB vx cv wss vx
      cv cA cB chj co cin vx cv cA cin cB chj co wss wi vx cch wral cB vy cv
      wss vy cv cA cB chj co cin vy cv cA cin cB chj co wss wi vy cch wral cB
      cch wcel vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj
      co wss cB vx cv wss vx cv cA cB chj co cin vx cv cA cin cB chj co wss wi
      vx cch cB cch wcel vx cv cch wcel wa cB vx cv wss vx cv cB chj co cA cB
      chj co cin vx cv cB chj co cA cin cB chj co wss vx cv cA cB chj co cin vx
      cv cA cin cB chj co wss cB cch wcel vx cv cch wcel wa cB vx cv wss vx cv
      cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cv cA
      cB chj co cin vx cv cA cin cB chj co wss wi cB cch wcel vx cv cch wcel wa
      cB vx cv wss wa vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin
      cB chj co wss vx cv cA cB chj co cin vx cv cA cin cB chj co wss cB cch
      wcel vx cv cch wcel wa cB vx cv wss wa vx cv cB chj co cA cB chj co cin
      vx cv cA cB chj co cin vx cv cB chj co cA cin cB chj co vx cv cA cin cB
      chj co cB cch wcel vx cv cch wcel wa cB vx cv wss wa vx cv cB chj co vx
      cv cA cB chj co cB cch wcel vx cv cch wcel wa cB vx cv wss vx cv cB chj
      co vx cv wceq cB vx cv chlejb2 biimpa ineq1d cB cch wcel vx cv cch wcel
      wa cB vx cv wss wa vx cv cB chj co cA cin vx cv cA cin cB chj cB cch wcel
      vx cv cch wcel wa cB vx cv wss wa vx cv cB chj co vx cv cA cB cch wcel vx
      cv cch wcel wa cB vx cv wss vx cv cB chj co vx cv wceq cB vx cv chlejb2
      biimpa ineq1d opreq1d sseq12d biimpd ex com23 r19.20dva cB vx cv wss vx
      cv cA cB chj co cin vx cv cA cin cB chj co wss wi cB vy cv wss vy cv cA
      cB chj co cin vy cv cA cin cB chj co wss wi vx vy cch vx cv vy cv wceq cB
      vx cv wss cB vy cv wss vx cv cA cB chj co cin vx cv cA cin cB chj co wss
      vy cv cA cB chj co cin vy cv cA cin cB chj co wss vx cv vy cv cB sseq2 vx
      cv vy cv wceq vx cv cA cB chj co cin vy cv cA cB chj co cin vx cv cA cin
      cB chj co vy cv cA cin cB chj co vx cv vy cv cA cB chj co ineq1 vx cv vy
      cv wceq vx cv cA cin vy cv cA cin cB chj vx cv vy cv cA ineq1 opreq1d
      sseq12d imbi12d cbvralv syl6ib impbid adantl bitrd $.
      $( [5-Aug-2007] $) $( [6-Jul-2004] $)

    $( Consequence of the dual modular pair property. $)
    dmdi4 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
              ( A MH* B ->
         ( ( C vH B ) i^i ( A vH B ) ) C_ ( ( ( C vH B ) i^i A ) vH B ) ) ) $=
      cA cch wcel cB cch wcel cC cch wcel cA cB cdmd wbr cC cB chj co cA cB chj
      co cin cC cB chj co cA cin cB chj co wss wi cA cch wcel cB cch wcel wa cA
      cB cdmd wbr vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss vx cch wral cC cch wcel cC cB chj co cA cB chj co cin cC cB
      chj co cA cin cB chj co wss cA cch wcel cB cch wcel wa cA cB cdmd wbr vx
      cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cch
      wral vx cA cB dmdbr4 biimpd vx cv cB chj co cA cB chj co cin vx cv cB chj
      co cA cin cB chj co wss cC cB chj co cA cB chj co cin cC cB chj co cA cin
      cB chj co wss vx cC cch vx cv cC wceq vx cv cB chj co cA cB chj co cin cC
      cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co cC cB chj co
      cA cin cB chj co vx cv cC wceq vx cv cB chj co cC cB chj co cA cB chj co
      vx cv cC cB chj opreq1 ineq1d vx cv cC wceq vx cv cB chj co cA cin cC cB
      chj co cA cin cB chj vx cv cC wceq vx cv cB chj co cC cB chj co cA vx cv
      cC cB chj opreq1 ineq1d opreq1d sseq12d rcla4v sylan9 3impa $.
      $( [12-Aug-2007] $) $( [14-Jan-2005] $)

    $( Binary relation expressing the dual modular pair property. $)
    dmdbr5 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
    A. x e. CH ( x C_ ( A vH B ) -> x C_ ( ( ( x vH B ) i^i A ) vH B ) ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB cdmd wbr vx cv cA cB chj co wss vx cv vx
      cv cB chj co cA cin cB chj co wss wi vx cch wral cA cch wcel cB cch wcel
      wa cA cB cdmd wbr vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin
      cB chj co wss vx cch wral vx cv cA cB chj co wss vx cv vx cv cB chj co cA
      cin cB chj co wss wi vx cch wral vx cA cB dmdbr4 cB cch wcel vx cv cB chj
      co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cch wral vx
      cv cA cB chj co wss vx cv vx cv cB chj co cA cin cB chj co wss wi vx cch
      wral wi cA cch wcel cB cch wcel vx cv cB chj co cA cB chj co cin vx cv cB
      chj co cA cin cB chj co wss vx cv cA cB chj co wss vx cv vx cv cB chj co
      cA cin cB chj co wss wi vx cch cB cch wcel vx cv cch wcel wa vx cv cA cB
      chj co wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj
      co wss vx cv vx cv cB chj co cA cin cB chj co wss cB cch wcel vx cv cch
      wcel wa vx cv cA cB chj co wss vx cv cB chj co cA cB chj co cin vx cv cB
      chj co cA cin cB chj co wss vx cv vx cv cB chj co cA cin cB chj co wss wi
      vx cv vx cv cB chj co wss vx cv cA cB chj co wss vx cv cB chj co cA cB
      chj co cin vx cv cB chj co cA cin cB chj co wss vx cv vx cv cB chj co cA
      cin cB chj co wss wi cB cch wcel vx cv cch wcel wa vx cv vx cv cB chj co
      wss vx cv cA cB chj co wss wa vx cv vx cv cB chj co cA cB chj co cin wss
      vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx
      cv vx cv cB chj co cA cin cB chj co wss wi vx cv vx cv cB chj co cA cB
      chj co ssin vx cv vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin
      cB chj co sstr2 sylbi vx cv cch wcel cB cch wcel vx cv vx cv cB chj co
      wss vx cv cB chub1 ancoms sylan ex com23 r19.20dva adantl sylbid cA cch
      wcel cB cch wcel wa vx cv cA cB chj co wss vx cv vx cv cB chj co cA cin
      cB chj co wss wi vx cch wral vy cv cB chj co cA cB chj co cin vy cv cB
      chj co cA cin cB chj co wss vy cch wral cA cB cdmd wbr cA cch wcel cB cch
      wcel wa vx cv cA cB chj co wss vx cv vx cv cB chj co cA cin cB chj co wss
      wi vx cch wral vy cv cB chj co cA cB chj co cin vy cv cB chj co cA cin cB
      chj co wss vy cch cA cch wcel cB cch wcel wa vy cv cB chj co cA cB chj co
      cin cch wcel vy cv cB chj co cA cB chj co cin cA cB chj co wss vy cv cB
      chj co cA cB chj co cin vy cv cB chj co cA cB chj co cin cB chj co cA cin
      cB chj co wss wi wi vy cv cch wcel vy cv cB chj co cA cB chj co cin vy cv
      cB chj co cA cin cB chj co wss wi vx cv cA cB chj co wss vx cv vx cv cB
      chj co cA cin cB chj co wss wi vx cch wral cA cch wcel cB cch wcel wa vy
      cv cch wcel vy cv cB chj co cA cB chj co cin cch wcel vy cv cB chj co cA
      cB chj co cin cA cB chj co wss vy cv cB chj co cA cB chj co cin vy cv cB
      chj co cA cB chj co cin cB chj co cA cin cB chj co wss wi wi vy cv cB chj
      co cA cB chj co cin vy cv cB chj co cA cin cB chj co wss cA cch wcel cB
      cch wcel wa vy cv cch wcel vy cv cB chj co cA cB chj co cin cch wcel vy
      cv cB chj co cA cB chj co cin cA cB chj co wss vy cv cB chj co cA cB chj
      co cin vy cv cB chj co cA cB chj co cin cB chj co cA cin cB chj co wss wi
      wi vy cv cB chj co cA cB chj co cin vy cv cB chj co cA cin cB chj co wss
      wi cA cch wcel cB cch wcel wa vy cv cch wcel wa vy cv cB chj co cA cB chj
      co cin cch wcel vy cv cB chj co cA cB chj co cin cA cB chj co wss vy cv
      cB chj co cA cB chj co cin vy cv cB chj co cA cB chj co cin cB chj co cA
      cin cB chj co wss wi wi vy cv cB chj co cA cB chj co cin vy cv cB chj co
      cA cB chj co cin cB chj co cA cin cB chj co wss vy cv cB chj co cA cB chj
      co cin vy cv cB chj co cA cin cB chj co wss cA cch wcel cB cch wcel wa vy
      cv cch wcel wa vy cv cB chj co cch wcel cA cB chj co cch wcel wa vy cv cB
      chj co cA cB chj co cin cch wcel vy cv cB chj co cA cB chj co cin cch
      wcel vy cv cB chj co cA cB chj co cin cA cB chj co wss vy cv cB chj co cA
      cB chj co cin vy cv cB chj co cA cB chj co cin cB chj co cA cin cB chj co
      wss wi wi vy cv cB chj co cA cB chj co cin vy cv cB chj co cA cB chj co
      cin cB chj co cA cin cB chj co wss wi cA cch wcel cB cch wcel wa vy cv
      cch wcel wa vy cv cB chj co cch wcel cA cB chj co cch wcel cB cch wcel vy
      cv cch wcel vy cv cB chj co cch wcel cA cch wcel vy cv cch wcel cB cch
      wcel vy cv cB chj co cch wcel vy cv cB chjcl ancoms adantll cA cch wcel
      cB cch wcel wa cA cB chj co cch wcel vy cv cch wcel cA cB chjcl adantr
      jca vy cv cB chj co cA cB chj co chincl vy cv cB chj co cA cB chj co cin
      cch wcel vy cv cB chj co cA cB chj co cin cch wcel vy cv cB chj co cA cB
      chj co cin cA cB chj co wss vy cv cB chj co cA cB chj co cin vy cv cB chj
      co cA cB chj co cin cB chj co cA cin cB chj co wss wi wi vy cv cB chj co
      cA cB chj co cin cA cB chj co wss vy cv cB chj co cA cB chj co cin vy cv
      cB chj co cA cB chj co cin cB chj co cA cin cB chj co wss vy cv cB chj co
      cA cB chj co inss2 vy cv cB chj co cA cB chj co cin cch wcel vy cv cB chj
      co cA cB chj co cin cA cB chj co wss vy cv cB chj co cA cB chj co cin vy
      cv cB chj co cA cB chj co cin cB chj co cA cin cB chj co wss wi pm2.27
      mpii 3syl cA cch wcel cB cch wcel wa vy cv cch wcel wa vy cv cB chj co cA
      cB chj co cin cB chj co cA cin cB chj co vy cv cB chj co cA cin cB chj co
      vy cv cB chj co cA cB chj co cin cA cch wcel cB cch wcel wa vy cv cch
      wcel wa vy cv cB chj co cA cB chj co cin cB chj co cA cin vy cv cB chj co
      cA cin cB chj cA cch wcel cB cch wcel wa vy cv cch wcel wa vy cv cB chj
      co cA cB chj co cin cB chj co cA cin vy cv cB chj co cA cB chj co cin cA
      cin vy cv cB chj co cA cin cA cch wcel cB cch wcel wa vy cv cch wcel wa
      vy cv cB chj co cA cB chj co cin cB chj co vy cv cB chj co cA cB chj co
      cin cA cA cch wcel cB cch wcel wa vy cv cch wcel wa cB vy cv cB chj co cA
      cB chj co cin wss vy cv cB chj co cA cB chj co cin cB chj co vy cv cB chj
      co cA cB chj co cin wceq cA cch wcel cB cch wcel wa vy cv cch wcel wa cB
      vy cv cB chj co wss cB cA cB chj co wss wa cB vy cv cB chj co cA cB chj
      co cin wss cA cch wcel cB cch wcel wa vy cv cch wcel wa cB vy cv cB chj
      co wss cB cA cB chj co wss cB cch wcel vy cv cch wcel cB vy cv cB chj co
      wss cA cch wcel cB vy cv chub2 adantll cA cch wcel cB cch wcel wa cB cA
      cB chj co wss vy cv cch wcel cB cch wcel cA cch wcel cB cA cB chj co wss
      cB cA chub2 ancoms adantr jca cB vy cv cB chj co cA cB chj co ssin sylib
      cB cch wcel vy cv cB chj co cA cB chj co cin cch wcel cB vy cv cB chj co
      cA cB chj co cin wss vy cv cB chj co cA cB chj co cin cB chj co vy cv cB
      chj co cA cB chj co cin wceq wb cA cch wcel cB cch wcel wa vy cv cch wcel
      wa cB vy cv cB chj co cA cB chj co cin chlejb2 cA cch wcel cB cch wcel vy
      cv cch wcel simplr vy cv cB chj co cch wcel cA cB chj co cch wcel vy cv
      cB chj co cA cB chj co cin cch wcel cA cch wcel cB cch wcel wa vy cv cch
      wcel wa vy cv cB chj co cA cB chj co chincl cB cch wcel vy cv cch wcel vy
      cv cB chj co cch wcel cA cch wcel vy cv cch wcel cB cch wcel vy cv cB chj
      co cch wcel vy cv cB chjcl ancoms adantll cA cch wcel cB cch wcel wa cA
      cB chj co cch wcel vy cv cch wcel cA cB chjcl adantr sylanc sylanc mpbid
      ineq1d cA cch wcel cB cch wcel wa vy cv cB chj co cA cB chj co cin cA cin
      vy cv cB chj co cA cin wceq vy cv cch wcel cA cch wcel cB cch wcel wa vy
      cv cB chj co cA cB chj co cA cin cin vy cv cB chj co cA cin vy cv cB chj
      co cA cB chj co cin cA cin cA cch wcel cB cch wcel wa cA cB chj co cA cin
      cA vy cv cB chj co cA cch wcel cB cch wcel wa cA cA cB chj co cin cA cA
      cB chj co cA cin cA cB chabs2 cA cB chj co cA incom syl5eq ineq2d vy cv
      cB chj co cA cB chj co cA inass syl5eq adantr eqtrd opreq1d sseq2d sylibd
      ex com23 vx cv cA cB chj co wss vx cv vx cv cB chj co cA cin cB chj co
      wss wi vy cv cB chj co cA cB chj co cin cA cB chj co wss vy cv cB chj co
      cA cB chj co cin vy cv cB chj co cA cB chj co cin cB chj co cA cin cB chj
      co wss wi vx vy cv cB chj co cA cB chj co cin cch vx cv vy cv cB chj co
      cA cB chj co cin wceq vx cv cA cB chj co wss vy cv cB chj co cA cB chj co
      cin cA cB chj co wss vx cv vx cv cB chj co cA cin cB chj co wss vy cv cB
      chj co cA cB chj co cin vy cv cB chj co cA cB chj co cin cB chj co cA cin
      cB chj co wss vx cv vy cv cB chj co cA cB chj co cin cA cB chj co sseq1
      vx cv vy cv cB chj co cA cB chj co cin wceq vx cv vy cv cB chj co cA cB
      chj co cin vx cv cB chj co cA cin cB chj co vy cv cB chj co cA cB chj co
      cin cB chj co cA cin cB chj co vx cv vy cv cB chj co cA cB chj co cin
      wceq id vx cv vy cv cB chj co cA cB chj co cin wceq vx cv cB chj co cA
      cin vy cv cB chj co cA cB chj co cin cB chj co cA cin cB chj vx cv vy cv
      cB chj co cA cB chj co cin wceq vx cv cB chj co vy cv cB chj co cA cB chj
      co cin cB chj co cA vx cv vy cv cB chj co cA cB chj co cin cB chj opreq1
      ineq1d opreq1d sseq12d imbi12d rcla4cv syl5 r19.21adv vy cA cB dmdbr4
      sylibrd impbid $.
      $( [12-Jul-2008] $) $( [15-Jan-2005] $)

    $( Relationship between modular pairs and dual-modular pairs.  Lemma 1.2
       of [MaedaMaeda] p. 1. $)
    mddmd2 $p |- ( A e. CH -> ( A. x e. CH A MH x <->
                A. x e. CH A MH* x ) ) $=
      cA cch wcel cA vx cv cmd wbr vx cch wral vx cv vy cv wss vy cv cA cin vx
      cv chj co vy cv cA vx cv chj co cin wceq wi vy cch wral vx cch wral cA vx
      cv cdmd wbr vx cch wral cA cch wcel cA vx cv cmd wbr vx cch wral vx cv vy
      cv wss vy cv cA cin vx cv chj co vy cv cA vx cv chj co cin wceq wi vx cch
      wral vy cch wral vx cv vy cv wss vy cv cA cin vx cv chj co vy cv cA vx cv
      chj co cin wceq wi vy cch wral vx cch wral cA cch wcel cA vy cv cmd wbr
      vy cch wral vx cv vy cv wss vy cv cA cin vx cv chj co vy cv cA vx cv chj
      co cin wceq wi vx cch wral vy cch wral cA vx cv cmd wbr vx cch wral cA
      cch wcel cA vy cv cmd wbr vx cv vy cv wss vy cv cA cin vx cv chj co vy cv
      cA vx cv chj co cin wceq wi vx cch wral vy cch cA cch wcel vy cv cch wcel
      wa cA vy cv cmd wbr vx cv vy cv wss vx cv cA chj co vy cv cin vx cv cA vy
      cv cin chj co wceq wi vx cch wral vx cv vy cv wss vy cv cA cin vx cv chj
      co vy cv cA vx cv chj co cin wceq wi vx cch wral vx cA vy cv mdbr cA cch
      wcel vy cv cch wcel wa vx cv vy cv wss vx cv cA chj co vy cv cin vx cv cA
      vy cv cin chj co wceq wi vx cv vy cv wss vy cv cA cin vx cv chj co vy cv
      cA vx cv chj co cin wceq wi vx cch cA cch wcel vy cv cch wcel wa vx cv
      cch wcel wa vx cv cA chj co vy cv cin vx cv cA vy cv cin chj co wceq vy
      cv cA cin vx cv chj co vy cv cA vx cv chj co cin wceq vx cv vy cv wss cA
      cch wcel vy cv cch wcel wa vx cv cch wcel wa vx cv cA chj co vy cv cin vx
      cv cA vy cv cin chj co wceq vy cv cA vx cv chj co cin vy cv cA cin vx cv
      chj co wceq vy cv cA cin vx cv chj co vy cv cA vx cv chj co cin wceq cA
      cch wcel vy cv cch wcel wa vx cv cch wcel wa vx cv cA chj co vy cv cin vy
      cv cA vx cv chj co cin vx cv cA vy cv cin chj co vy cv cA cin vx cv chj
      co cA cch wcel vx cv cch wcel vx cv cA chj co vy cv cin vy cv cA vx cv
      chj co cin wceq vy cv cch wcel cA cch wcel vx cv cch wcel wa cA vx cv chj
      co vy cv cin vx cv cA chj co vy cv cin vy cv cA vx cv chj co cin cA cch
      wcel vx cv cch wcel wa cA vx cv chj co vx cv cA chj co vy cv cA vx cv
      chjcom ineq1d cA vx cv chj co vy cv incom syl5reqr adantlr cA cch wcel vy
      cv cch wcel wa vx cv cch wcel wa cA vy cv cin vx cv chj co vx cv cA vy cv
      cin chj co vy cv cA cin vx cv chj co cA vy cv cin cch wcel vx cv cch wcel
      cA vy cv cin vx cv chj co vx cv cA vy cv cin chj co wceq cA cch wcel vy
      cv cch wcel wa cA vy cv cin vx cv chjcom cA vy cv chincl sylan cA vy cv
      cin vy cv cA cin vx cv chj cA vy cv incom opreq1i syl5reqr eqeq12d vy cv
      cA vx cv chj co cin vy cv cA cin vx cv chj co eqcom syl6bb imbi2d
      ralbidva bitrd ralbidva cA vx cv cmd wbr cA vy cv cmd wbr vx vy cch vx cv
      vy cv cA cmd breq2 cbvralv syl5bb vx cv vy cv wss vy cv cA cin vx cv chj
      co vy cv cA vx cv chj co cin wceq wi vy vx cch cch ralcom syl6bb cA cch
      wcel cA vx cv cdmd wbr vx cv vy cv wss vy cv cA cin vx cv chj co vy cv cA
      vx cv chj co cin wceq wi vy cch wral vx cch vy cA vx cv dmdbr ralbidva
      bitr4d $.
      $( [27-Jul-2007] $) $( [21-Jun-2004] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    $( A sublattice condition that transfers the modular pair property.
       Exercise 12 of [Kalmbach] p. 103.  Also Lemma 1.5.3 of [MaedaMaeda]
       p. 2. $)
    mdsl0 $p |- ( ( ( A e. CH /\ B e. CH ) /\ ( C e. CH /\ D e. CH ) ) -> (
  ( ( ( C C_ A /\ D C_ B ) /\ ( A i^i B ) = 0H ) /\ A MH B ) -> C MH D ) ) $=
      cA cch wcel cB cch wcel wa cC cch wcel cD cch wcel wa wa cC cA wss cD cB
      wss wa cA cB cin c0h wceq wa cA cB cmd wbr cC cD cmd wbr cA cch wcel cB
      cch wcel wa cC cch wcel cD cch wcel wa wa cC cA wss cD cB wss wa cA cB
      cin c0h wceq wa wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wss wi vx cch wral vx cv cD wss vx cv cC chj co cD cin vx cv cC cD
      cin chj co wss wi vx cch wral cA cB cmd wbr cC cD cmd wbr cA cch wcel cB
      cch wcel wa cC cch wcel cD cch wcel wa wa cC cA wss cD cB wss wa cA cB
      cin c0h wceq wa wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wss wi vx cv cD wss vx cv cC chj co cD cin vx cv cC cD cin chj co
      wss wi vx cch cA cch wcel cB cch wcel wa cC cch wcel cD cch wcel wa wa cC
      cA wss cD cB wss wa cA cB cin c0h wceq wa wa vx cv cch wcel wa vx cv cD
      wss vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv
      cC chj co cD cin vx cv cC cD cin chj co wss cC cA wss cD cB wss wa cA cB
      cin c0h wceq wa vx cv cD wss vx cv cB wss wi cA cch wcel cB cch wcel wa
      cC cch wcel cD cch wcel wa wa vx cv cch wcel cD cB wss vx cv cD wss vx cv
      cB wss wi cC cA wss cA cB cin c0h wceq vx cv cD wss cD cB wss vx cv cB
      wss vx cv cD cB sstr2 com12 ad2antlr ad2antlr cA cch wcel cB cch wcel wa
      cC cch wcel cD cch wcel wa wa vx cv cch wcel cC cA wss cD cB wss wa cA cB
      cin c0h wceq wa vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv
      cC chj co cD cin vx cv cC cD cin chj co wss wi vx cv cC chj co cD cin vx
      cv cA chj co cB cin wss vx cv cA cB cin chj co vx cv cC cD cin chj co wss
      vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv cC chj co cD cin
      vx cv cC cD cin chj co wss wi cA cch wcel cB cch wcel wa cC cch wcel cD
      cch wcel wa wa vx cv cch wcel wa cC cA wss cD cB wss wa cA cB cin c0h
      wceq wa wa vx cv cC chj co cD cin vx cv cA chj co cB cin wss vx cv cA chj
      co cB cin vx cv cA cB cin chj co wss vx cv cA cB cin chj co vx cv cC cD
      cin chj co wss vx cv cC chj co cD cin vx cv cC cD cin chj co wss vx cv cC
      chj co cD cin vx cv cA chj co cB cin wss vx cv cA chj co cB cin vx cv cA
      cB cin chj co wss vx cv cC chj co cD cin vx cv cA cB cin chj co wss vx cv
      cA cB cin chj co vx cv cC cD cin chj co wss vx cv cC chj co cD cin vx cv
      cC cD cin chj co wss wi vx cv cC chj co cD cin vx cv cA chj co cB cin vx
      cv cA cB cin chj co sstr2 vx cv cC chj co cD cin vx cv cA cB cin chj co
      vx cv cC cD cin chj co sstr2 syl6 com23 cA cch wcel cB cch wcel wa cC cch
      wcel cD cch wcel wa wa vx cv cch wcel wa cC cA wss cD cB wss wa vx cv cC
      chj co cD cin vx cv cA chj co cB cin wss cA cB cin c0h wceq cA cch wcel
      cB cch wcel wa cC cch wcel cD cch wcel wa wa vx cv cch wcel cC cA wss cD
      cB wss vx cv cC chj co cD cin vx cv cA chj co cB cin wss cA cch wcel cC
      cch wcel vx cv cch wcel cC cA wss cD cB wss vx cv cC chj co cD cin vx cv
      cA chj co cB cin wss wi wi wi cB cch wcel cD cch wcel cC cch wcel cA cch
      wcel vx cv cch wcel cC cA wss cD cB wss vx cv cC chj co cD cin vx cv cA
      chj co cB cin wss wi wi wi cC cch wcel cA cch wcel vx cv cch wcel cC cA
      wss cD cB wss vx cv cC chj co cD cin vx cv cA chj co cB cin wss wi wi cC
      cch wcel cA cch wcel vx cv cch wcel w3a cC cA wss cD cB wss vx cv cC chj
      co cD cin vx cv cA chj co cB cin wss wi cC cch wcel cA cch wcel vx cv cch
      wcel w3a cC cA wss wa vx cv cC chj co vx cv cA chj co wss cD cB wss vx cv
      cC chj co cD cin vx cv cA chj co cB cin wss wi cC cA vx cv chlej2 vx cv
      cC chj co vx cv cA chj co wss cD cB wss vx cv cC chj co cD cin vx cv cA
      chj co cB cin wss vx cv cC chj co vx cv cA chj co cD cB ss2in ex syl ex
      3expia ancoms ad2ant2r imp43 adantrr cA cch wcel cB cch wcel wa cC cch
      wcel cD cch wcel wa wa vx cv cch wcel wa cA cB cin c0h wceq vx cv cA cB
      cin chj co vx cv cC cD cin chj co wss cC cA wss cD cB wss wa cA cch wcel
      cB cch wcel wa cC cch wcel cD cch wcel wa wa vx cv cch wcel cA cB cin c0h
      wceq vx cv cA cB cin chj co vx cv cC cD cin chj co wss cC cch wcel cD cch
      wcel wa vx cv cch wcel cA cB cin c0h wceq wa vx cv cA cB cin chj co vx cv
      cC cD cin chj co wss cA cch wcel cB cch wcel wa cC cch wcel cD cch wcel
      wa vx cv cch wcel cA cB cin c0h wceq wa wa vx cv cA cB cin chj co vx cv
      vx cv cC cD cin chj co vx cv cch wcel cA cB cin c0h wceq wa vx cv cA cB
      cin chj co vx cv wceq cC cch wcel cD cch wcel wa cA cB cin c0h wceq vx cv
      cch wcel vx cv cA cB cin chj co vx cv c0h chj co vx cv cA cB cin c0h vx
      cv chj opreq2 vx cv chj0 sylan9eqr adantl cC cch wcel cD cch wcel wa vx
      cv cch wcel vx cv vx cv cC cD cin chj co wss cA cB cin c0h wceq cC cD cin
      cch wcel vx cv cch wcel vx cv vx cv cC cD cin chj co wss cC cch wcel cD
      cch wcel wa vx cv cch wcel cC cD cin cch wcel vx cv vx cv cC cD cin chj
      co wss vx cv cC cD cin chub1 ancoms cC cD chincl sylan adantrr eqsstrd
      adantll anassrs adantrl sylc an1rs imim12d r19.20dva cA cch wcel cB cch
      wcel wa cA cB cmd wbr vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wss wi vx cch wral wb cC cch wcel cD cch wcel wa cC cA wss cD cB
      wss wa cA cB cin c0h wceq wa vx cA cB mdbr2 ad2antrr cC cch wcel cD cch
      wcel wa cC cD cmd wbr vx cv cD wss vx cv cC chj co cD cin vx cv cC cD cin
      chj co wss wi vx cch wral wb cA cch wcel cB cch wcel wa cC cA wss cD cB
      wss wa cA cB cin c0h wceq wa vx cC cD mdbr2 ad2antlr 3imtr4d expimpd $.
      $( [30-Jan-2005] $) $( [22-Jun-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Ordering implies the modular pair property.  Remark in [MaedaMaeda]
       p. 1. $)
    ssmd1 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) -> A MH B ) $=
      cA cch wcel cB cch wcel cA cB wss cA cB cmd wbr cA cch wcel cB cch wcel
      wa cA cB cmd wbr vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj
      co wss wi vx cch wral cA cB wss vx cA cB mdbr2 cA cB wss vx cv cB wss vx
      cv cA chj co cB cin vx cv cA cB cin chj co wss wi vx cch cA cB wss vx cv
      cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss wi vx cv cch
      wcel cA cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv cB
      wss cA cB wss vx cv cA chj co cB cin vx cv cA chj co vx cv cA cB cin chj
      co vx cv cA chj co cB cin vx cv cA chj co wss cA cB wss vx cv cA chj co
      cB inss1 a1i cA cB wss cA cA cB cin vx cv chj cA cB wss cA cA cB cin wceq
      cA cB dfss biimpi opreq2d sseqtrd a1d a1d r19.21aiv syl5bir 3impia $.
      $( [24-Dec-2006] $) $( [21-Jun-2004] $)

    $( Ordering implies the modular pair property.  Remark in [MaedaMaeda]
       p. 1. $)
     ssmd2 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) -> B MH A ) $=
       cA cch wcel cB cch wcel cA cB wss cB cA cmd wbr cA cch wcel cB cch wcel
       wa cA cB wss vx cv cA wss vx cv cB chj co cA cin vx cv cB cA cin chj co
       wss wi vx cch wral cB cA cmd wbr cA cch wcel cA cB wss vx cv cA wss vx
       cv cB chj co cA cin vx cv cB cA cin chj co wss wi vx cch wral wi cB cch
       wcel cA cch wcel cA cB wss vx cv cA wss vx cv cB chj co cA cin vx cv cB
       cA cin chj co wss wi vx cch cA cch wcel cA cB wss vx cv cch wcel vx cv
       cA wss vx cv cB chj co cA cin vx cv cB cA cin chj co wss wi cA cch wcel
       cA cB wss vx cv cch wcel wa wa vx cv cB chj co cA cin vx cv cB cA cin
       chj co wss vx cv cA wss cA cch wcel cA cB wss vx cv cch wcel wa wa vx cv
       cB chj co cA cin vx cv cA chj co vx cv cB cA cin chj co cA cch wcel vx
       cv cch wcel vx cv cB chj co cA cin vx cv cA chj co wss cA cB wss cA cch
       wcel vx cv cch wcel wa vx cv cB chj co cA cin cA vx cv cA chj co vx cv
       cB chj co cA cin cA wss cA cch wcel vx cv cch wcel wa vx cv cB chj co cA
       inss2 a1i cA vx cv chub2 sstrd adantrl cA cch wcel cA cB wss vx cv cch
       wcel wa wa cB cA cin cA vx cv chj cA cB wss vx cv cch wcel wa cB cA cin
       cA wceq cA cch wcel cA cB wss vx cv cch wcel wa cA cB wss cB cA cin cA
       wceq cA cB wss vx cv cch wcel pm3.26 cA cB sseqin2 sylib adantl opreq2d
       sseqtr4d a1d exp32 r19.21adv adantr cB cch wcel cA cch wcel cB cA cmd
       wbr vx cv cA wss vx cv cB chj co cA cin vx cv cB cA cin chj co wss wi vx
       cch wral wb vx cB cA mdbr2 ancoms sylibrd 3impia $.
       $( [28-Jan-2007] $) $( [21-Jun-2004] $)
  $}

  $( Ordering implies the dual modular pair property.  Remark in [MaedaMaeda]
     p. 1. $)
  ssdmd1 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) ->
                  A MH* B ) $=
    cA cch wcel cB cch wcel cA cB wss cA cB cdmd wbr cA cch wcel cB cch wcel wa
    cB cort cfv cA cort cfv wss cA cort cfv cB cort cfv cmd wbr cA cB wss cA cB
    cdmd wbr cB cch wcel cA cch wcel cB cort cfv cA cort cfv wss cA cort cfv cB
    cort cfv cmd wbr wi cB cort cfv cch wcel cA cort cfv cch wcel cB cort cfv
    cA cort cfv wss cA cort cfv cB cort cfv cmd wbr wi cB cch wcel cA cch wcel
    cB cort cfv cch wcel cA cort cfv cch wcel cB cort cfv cA cort cfv wss cA
    cort cfv cB cort cfv cmd wbr cB cort cfv cA cort cfv ssmd2 3expia cB choccl
    cA choccl syl2an ancoms cA cB chsscon3 cA cB dmdmd 3imtr4d 3impia $.
    $( [27-Jul-2007] $) $( [22-Jun-2004] $)

  $( Ordering implies the dual modular pair property.  Remark in [MaedaMaeda]
     p. 1. $)
  ssdmd2 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) ->
               ( _|_ ` B ) MH ( _|_ ` A ) ) $=
    cA cch wcel cB cch wcel cA cB wss cB cort cfv cA cort cfv cmd wbr cA cch
    wcel cB cch wcel wa cA cB wss cB cort cfv cA cort cfv wss cB cort cfv cA
    cort cfv cmd wbr cA cB chsscon3 cB cch wcel cA cch wcel cB cort cfv cA cort
    cfv wss cB cort cfv cA cort cfv cmd wbr wi cB cort cfv cch wcel cA cort cfv
    cch wcel cB cort cfv cA cort cfv wss cB cort cfv cA cort cfv cmd wbr wi cB
    cch wcel cA cch wcel cB cort cfv cch wcel cA cort cfv cch wcel cB cort cfv
    cA cort cfv wss cB cort cfv cA cort cfv cmd wbr cB cort cfv cA cort cfv
    ssmd1 3expia cB choccl cA choccl syl2an ancoms sylbid 3impia $.
    $( [5-Feb-2005] $) $( [22-Jun-2004] $)

  $( Sublattice mapping for a dual-modular pair.  Part of Theorem 1.3 of
     [MaedaMaeda] p. 2. $)
  dmdsl3 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
               ( B MH* A /\ A C_ C /\ C C_ ( A vH B ) ) ) ->
                   ( ( C i^i B ) vH A ) = C ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cB cA cdmd wbr cA cC wss cC cA cB
    chj co wss w3a wa cC cB cin cA chj co cC cB cA chj co cin cC cA cch wcel cB
    cch wcel cC cch wcel w3a cB cA cdmd wbr cA cC wss cC cB cin cA chj co cC cB
    cA chj co cin wceq cC cA cB chj co wss cA cch wcel cB cch wcel cC cch wcel
    w3a cB cA cdmd wbr cA cC wss cC cB cin cA chj co cC cB cA chj co cin wceq
    cB cch wcel cA cch wcel cC cch wcel cB cA cdmd wbr cA cC wss cC cB cin cA
    chj co cC cB cA chj co cin wceq wi wi cB cch wcel cA cch wcel cC cch wcel
    w3a cB cA cdmd wbr cA cC wss cC cB cin cA chj co cC cB cA chj co cin wceq
    cB cA cC dmdi exp32 3com12 imp32 3adantr3 cA cch wcel cB cch wcel cC cch
    wcel w3a cB cA cdmd wbr cC cA cB chj co wss cC cB cA chj co cin cC wceq cA
    cC wss cA cch wcel cB cch wcel cC cch wcel w3a cC cA cB chj co wss cC cB cA
    chj co cin cC cA cB chj co cin cC cA cch wcel cB cch wcel cC cA cB chj co
    cin cC cB cA chj co cin wceq cC cch wcel cA cch wcel cB cch wcel wa cA cB
    chj co cB cA chj co cC cA cB chjcom ineq2d 3adant3 cC cA cB chj co wss cC
    cA cB chj co cin cC wceq cC cA cB chj co df-ss biimpi sylan9req 3ad2antr3
    eqtrd $.
    $( [3-Jun-2006] $) $( [26-Apr-2006] $)

  $( Sublattice mapping for a modular pair.  Part of Theorem 1.3 of
     [MaedaMaeda] p. 2. $)
  mdsl3 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
               ( A MH B /\ ( A i^i B ) C_ C /\ C C_ B ) ) ->
                   ( ( C vH A ) i^i B ) = C ) $=
    cA cch wcel cB cch wcel cC cch wcel w3a cA cB cmd wbr cA cB cin cC wss cC
    cB wss w3a wa cC cA chj co cB cin cC cA cB cin chj co cC cA cch wcel cB cch
    wcel cC cch wcel w3a cA cB cmd wbr cC cB wss cC cA chj co cB cin cC cA cB
    cin chj co wceq cA cB cin cC wss cA cB cC mdi 3adantr2 cA cch wcel cB cch
    wcel cC cch wcel w3a cA cB cmd wbr cA cB cin cC wss cC cA cB cin chj co cC
    wceq cC cB wss cA cch wcel cB cch wcel cC cch wcel w3a cA cB cin cC wss cC
    cA cB cin chj co cC wceq cA cch wcel cB cch wcel cC cch wcel cA cB cin cC
    wss cC cA cB cin chj co cC wceq wb cA cB cin cch wcel cC cch wcel cA cB cin
    cC wss cC cA cB cin chj co cC wceq wb cA cch wcel cB cch wcel wa cA cB cin
    cC chlejb2 cA cB chincl sylan 3impa biimpa 3ad2antr2 eqtrd $.
    $( [3-Jun-2006] $) $( [26-Apr-2006] $)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    mdslle1.1 $e |- A e. CH $.
    mdslle1.2 $e |- B e. CH $.
    mdslle1.3 $e |- C e. CH $.
    mdslle1.4 $e |- D e. CH $.
    $( Order preservation of the one-to-one onto mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2. $)
    mdslle1i $p |- ( ( B MH* A /\ A C_ ( C i^i D ) /\ ( C vH D )
            C_ ( A vH B ) ) -> ( C C_ D <-> ( C i^i B ) C_ ( D i^i B ) ) ) $=
      cB cA cdmd wbr cA cC cD cin wss cC cD chj co cA cB chj co wss w3a cC cD
      wss cC cB cin cD cB cin wss cC cD cB ssrin cB cA cdmd wbr cA cC cD cin
      wss cC cD chj co cA cB chj co wss w3a cC cB cin cA chj co cD cB cin cA
      chj co wss cC cD wss cC cB cin cD cB cin wss cB cA cdmd wbr cA cC cD cin
      wss cC cD chj co cA cB chj co wss w3a cC cB cin cA chj co cC cD cB cin cA
      chj co cD cB cA cdmd wbr cA cC wss cC cA cB chj co wss cC cB cin cA chj
      co cC wceq cB cA cdmd wbr cA cC cD cin wss cC cD chj co cA cB chj co wss
      cA cch wcel cB cch wcel cC cch wcel w3a cB cA cdmd wbr cA cC wss cC cA cB
      chj co wss w3a cC cB cin cA chj co cC wceq cA cch wcel cB cch wcel cC cch
      wcel mdslle1.1 mdslle1.2 mdslle1.3 3pm3.2i cA cB cC dmdsl3 mpan cB cA
      cdmd wbr id cA cC cD cin wss cA cC wss cA cD wss cA cC wss cA cD wss wa
      cA cC cD cin wss cA cC cD ssin bicomi pm3.26bi cC cD chj co cA cB chj co
      wss cC cA cB chj co wss cD cA cB chj co wss cC cA cB chj co wss cD cA cB
      chj co wss wa cC cD chj co cA cB chj co wss cC cD cA cB chj co mdslle1.3
      mdslle1.4 cA cB mdslle1.1 mdslle1.2 chjcli chlubi bicomi pm3.26bi syl3an
      cB cA cdmd wbr cA cD wss cD cA cB chj co wss cD cB cin cA chj co cD wceq
      cB cA cdmd wbr cA cC cD cin wss cC cD chj co cA cB chj co wss cA cch wcel
      cB cch wcel cD cch wcel w3a cB cA cdmd wbr cA cD wss cD cA cB chj co wss
      w3a cD cB cin cA chj co cD wceq cA cch wcel cB cch wcel cD cch wcel
      mdslle1.1 mdslle1.2 mdslle1.4 3pm3.2i cA cB cD dmdsl3 mpan cB cA cdmd wbr
      id cA cC cD cin wss cA cC wss cA cD wss cA cC wss cA cD wss wa cA cC cD
      cin wss cA cC cD ssin bicomi pm3.27bi cC cD chj co cA cB chj co wss cC cA
      cB chj co wss cD cA cB chj co wss cC cA cB chj co wss cD cA cB chj co wss
      wa cC cD chj co cA cB chj co wss cC cD cA cB chj co mdslle1.3 mdslle1.4
      cA cB mdslle1.1 mdslle1.2 chjcli chlubi bicomi pm3.27bi syl3an sseq12d cC
      cB cin cD cB cin cA cC cB mdslle1.3 mdslle1.2 chincli cD cB mdslle1.4
      mdslle1.2 chincli mdslle1.1 chlej1i syl5bi impbid2 $.
      $( [3-Jun-2006] $) $( [27-Apr-2006] $)

    $( Order preservation of the one-to-one onto mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2. $)
    mdslle2i $p |- ( ( A MH B /\ ( A i^i B ) C_ ( C i^i D ) /\ ( C vH D )
            C_ B ) -> ( C C_ D <-> ( C vH A ) C_ ( D vH A ) ) ) $=
      cA cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss w3a cC cD wss
      cC cA chj co cD cA chj co wss cC cD cA mdslle1.3 mdslle1.4 mdslle1.1
      chlej1i cA cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss w3a cC
      cA chj co cB cin cD cA chj co cB cin wss cC cD wss cC cA chj co cD cA chj
      co wss cA cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss w3a cC
      cA chj co cB cin cC cD cA chj co cB cin cD cA cB cmd wbr cA cB cin cC wss
      cC cB wss cC cA chj co cB cin cC wceq cA cB cmd wbr cA cB cin cC cD cin
      wss cC cD chj co cB wss cA cch wcel cB cch wcel cC cch wcel w3a cA cB cmd
      wbr cA cB cin cC wss cC cB wss w3a cC cA chj co cB cin cC wceq cA cch
      wcel cB cch wcel cC cch wcel mdslle1.1 mdslle1.2 mdslle1.3 3pm3.2i cA cB
      cC mdsl3 mpan cA cB cmd wbr id cA cB cin cC cD cin wss cA cB cin cC wss
      cA cB cin cD wss cA cB cin cC wss cA cB cin cD wss wa cA cB cin cC cD cin
      wss cA cB cin cC cD ssin bicomi pm3.26bi cC cD chj co cB wss cC cB wss cD
      cB wss cC cB wss cD cB wss wa cC cD chj co cB wss cC cD cB mdslle1.3
      mdslle1.4 mdslle1.2 chlubi bicomi pm3.26bi syl3an cA cB cmd wbr cA cB cin
      cD wss cD cB wss cD cA chj co cB cin cD wceq cA cB cmd wbr cA cB cin cC
      cD cin wss cC cD chj co cB wss cA cch wcel cB cch wcel cD cch wcel w3a cA
      cB cmd wbr cA cB cin cD wss cD cB wss w3a cD cA chj co cB cin cD wceq cA
      cch wcel cB cch wcel cD cch wcel mdslle1.1 mdslle1.2 mdslle1.4 3pm3.2i cA
      cB cD mdsl3 mpan cA cB cmd wbr id cA cB cin cC cD cin wss cA cB cin cC
      wss cA cB cin cD wss cA cB cin cC wss cA cB cin cD wss wa cA cB cin cC cD
      cin wss cA cB cin cC cD ssin bicomi pm3.27bi cC cD chj co cB wss cC cB
      wss cD cB wss cC cB wss cD cB wss wa cC cD chj co cB wss cC cD cB
      mdslle1.3 mdslle1.4 mdslle1.2 chlubi bicomi pm3.27bi syl3an sseq12d cC cA
      chj co cD cA chj co cB ssrin syl5bi impbid2 $.
      $( [23-Oct-2006] $) $( [27-Apr-2006] $)

    $( Join preservation of the one-to-one onto mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2. $)
    mdslj1i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( A C_ ( C i^i D ) /\ ( C vH D ) C_ ( A vH B ) ) ) ->
                ( ( C vH D ) i^i B ) = ( ( C i^i B ) vH ( D i^i B ) ) ) $=
      cA cB cmd wbr cB cA cdmd wbr wa cA cC cD cin wss cC cD chj co cA cB chj
      co wss wa wa cC cD chj co cB cin cC cB cin cD cB cin chj co cA cB cmd wbr
      cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj
      co wss wa wa cC cD chj co cB cin cC cB cin cD cB cin chj co wss cA cC cD
      cin wss cC cD chj co cA cB chj co wss wa cA cB cmd wbr cB cA cdmd wbr wa
      cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa cC cD
      chj co cB cin cC cB cin cD cB cin chj co wss cA cB cmd wbr cB cA cdmd wbr
      wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa w3a
      cC cD chj co cB cin cC cB cin cD cB cin chj co cA chj co cB cin cC cB cin
      cD cB cin chj co cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
      cC cA cB chj co wss cD cA cB chj co wss wa w3a cC cD chj co cC cB cin cD
      cB cin chj co cA chj co wss cC cD chj co cB cin cC cB cin cD cB cin chj
      co cA chj co cB cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
      wss wa cC cA cB chj co wss cD cA cB chj co wss wa w3a cC cC cB cin cD cB
      cin chj co cA chj co wss cD cC cB cin cD cB cin chj co cA chj co wss wa
      cC cD chj co cC cB cin cD cB cin chj co cA chj co wss cA cB cmd wbr cB cA
      cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
      wss wa w3a cC cC cB cin cD cB cin chj co cA chj co wss cD cC cB cin cD cB
      cin chj co cA chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
      wss wa cC cA cB chj co wss cD cA cB chj co wss wa w3a cC cC cB cin cA chj
      co cC cB cin cD cB cin chj co cA chj co cB cA cdmd wbr cA cC wss cC cA cB
      chj co wss cC cB cin cA chj co cC wceq cA cB cmd wbr cB cA cdmd wbr wa cA
      cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa cA cch
      wcel cB cch wcel cC cch wcel w3a cB cA cdmd wbr cA cC wss cC cA cB chj co
      wss w3a cC cB cin cA chj co cC wceq cA cch wcel cB cch wcel cC cch wcel
      mdslle1.1 mdslle1.2 mdslle1.3 3pm3.2i cA cB cC dmdsl3 mpan cA cB cmd wbr
      cB cA cdmd wbr pm3.27 cA cC wss cA cD wss pm3.26 cC cA cB chj co wss cD
      cA cB chj co wss pm3.26 syl3an cC cB cin cA chj co cC cB cin cD cB cin
      chj co cA chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
      wa cC cA cB chj co wss cD cA cB chj co wss wa w3a cC cB cin cC cB cin cD
      cB cin chj co wss cC cB cin cA chj co cC cB cin cD cB cin chj co cA chj
      co wss cC cB cin cD cB cin cC cB mdslle1.3 mdslle1.2 chincli cD cB
      mdslle1.4 mdslle1.2 chincli chub1i cC cB cin cC cB cin cD cB cin chj co
      cA cC cB mdslle1.3 mdslle1.2 chincli cC cB cin cD cB cin cC cB mdslle1.3
      mdslle1.2 chincli cD cB mdslle1.4 mdslle1.2 chincli chjcli mdslle1.1
      chlej1i ax-mp a1i eqsstr3d cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA
      cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa w3a cD cD cB cin cA
      chj co cC cB cin cD cB cin chj co cA chj co cB cA cdmd wbr cA cD wss cD
      cA cB chj co wss cD cB cin cA chj co cD wceq cA cB cmd wbr cB cA cdmd wbr
      wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa cA
      cch wcel cB cch wcel cD cch wcel w3a cB cA cdmd wbr cA cD wss cD cA cB
      chj co wss w3a cD cB cin cA chj co cD wceq cA cch wcel cB cch wcel cD cch
      wcel mdslle1.1 mdslle1.2 mdslle1.4 3pm3.2i cA cB cD dmdsl3 mpan cA cB cmd
      wbr cB cA cdmd wbr pm3.27 cA cC wss cA cD wss pm3.27 cC cA cB chj co wss
      cD cA cB chj co wss pm3.27 syl3an cD cB cin cA chj co cC cB cin cD cB cin
      chj co cA chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
      wa cC cA cB chj co wss cD cA cB chj co wss wa w3a cD cB cin cC cB cin cD
      cB cin chj co wss cD cB cin cA chj co cC cB cin cD cB cin chj co cA chj
      co wss cD cB cin cC cB cin cD cB mdslle1.4 mdslle1.2 chincli cC cB
      mdslle1.3 mdslle1.2 chincli chub2i cD cB cin cC cB cin cD cB cin chj co
      cA cD cB mdslle1.4 mdslle1.2 chincli cC cB cin cD cB cin cC cB mdslle1.3
      mdslle1.2 chincli cD cB mdslle1.4 mdslle1.2 chincli chjcli mdslle1.1
      chlej1i ax-mp a1i eqsstr3d jca cC cD cC cB cin cD cB cin chj co cA chj co
      mdslle1.3 mdslle1.4 cC cB cin cD cB cin chj co cA cC cB cin cD cB cin cC
      cB mdslle1.3 mdslle1.2 chincli cD cB mdslle1.4 mdslle1.2 chincli chjcli
      mdslle1.1 chjcli chlubi sylib cC cD chj co cC cB cin cD cB cin chj co cA
      chj co cB ssrin syl cA cB cmd wbr cA cB cin cC cB cin cD cB cin chj co
      wss cC cB cin cD cB cin chj co cB wss cC cB cin cD cB cin chj co cA chj
      co cB cin cC cB cin cD cB cin chj co wceq cA cB cmd wbr cB cA cdmd wbr wa
      cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa cA cch
      wcel cB cch wcel cC cB cin cD cB cin chj co cch wcel w3a cA cB cmd wbr cA
      cB cin cC cB cin cD cB cin chj co wss cC cB cin cD cB cin chj co cB wss
      w3a cC cB cin cD cB cin chj co cA chj co cB cin cC cB cin cD cB cin chj
      co wceq cA cch wcel cB cch wcel cC cB cin cD cB cin chj co cch wcel
      mdslle1.1 mdslle1.2 cC cB cin cD cB cin cC cB mdslle1.3 mdslle1.2 chincli
      cD cB mdslle1.4 mdslle1.2 chincli chjcli 3pm3.2i cA cB cC cB cin cD cB
      cin chj co mdsl3 mpan cA cB cmd wbr cB cA cdmd wbr pm3.26 cA cC wss cA cB
      cin cC cB cin cD cB cin chj co wss cA cD wss cA cC wss cA cB cin cC cB
      cin wss cA cB cin cC cB cin cD cB cin chj co wss cA cC cB ssrin cA cB cin
      cC cB cin wss cC cB cin cC cB cin cD cB cin chj co wss cA cB cin cC cB
      cin cD cB cin chj co wss cC cB cin cD cB cin cC cB mdslle1.3 mdslle1.2
      chincli cD cB mdslle1.4 mdslle1.2 chincli chub1i cA cB cin cC cB cin cC
      cB cin cD cB cin chj co sstr mpan2 syl adantr cC cB cin cD cB cin chj co
      cB wss cC cA cB chj co wss cD cA cB chj co wss wa cC cB cin cD cB cin chj
      co cB wss cC cB cin cB wss cD cB cin cB wss cC cB cin cB wss cD cB cin cB
      wss wa cC cB cin cD cB cin chj co cB wss cC cB cin cD cB cin cB cC cB
      mdslle1.3 mdslle1.2 chincli cD cB mdslle1.4 mdslle1.2 chincli mdslle1.2
      chlubi bicomi cC cB inss2 cD cB inss2 mpbir2an a1i syl3an sseqtrd 3expb
      cA cC cD cin wss cA cC wss cA cD wss wa cC cD chj co cA cB chj co wss cC
      cA cB chj co wss cD cA cB chj co wss wa cA cC wss cA cD wss wa cA cC cD
      cin wss cA cC cD ssin bicomi cC cA cB chj co wss cD cA cB chj co wss wa
      cC cD chj co cA cB chj co wss cC cD cA cB chj co mdslle1.3 mdslle1.4 cA
      cB mdslle1.1 mdslle1.2 chjcli chlubi bicomi anbi12i sylan2b cC cB cin cD
      cB cin chj co cC cD chj co cB cin wss cA cB cmd wbr cB cA cdmd wbr wa cA
      cC cD cin wss cC cD chj co cA cB chj co wss wa wa cC cD cB mdslle1.3
      mdslle1.4 mdslle1.2 lediri a1i eqssd $.
      $( [3-Jun-2006] $) $( [27-Apr-2006] $)

    $( Meet preservation of the reverse mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2. $)
    mdslj2i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( ( A i^i B ) C_ ( C i^i D ) /\ ( C vH D ) C_ B ) ) ->
                ( ( C i^i D ) vH A ) = ( ( C vH A ) i^i ( D vH A ) ) ) $=
      cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC cD cin wss cC cD chj co cB
      wss wa wa cC cD cin cA chj co cC cA chj co cD cA chj co cin cC cD cin cA
      chj co cC cA chj co cD cA chj co cin wss cA cB cmd wbr cB cA cdmd wbr wa
      cA cB cin cC cD cin wss cC cD chj co cB wss wa wa cC cD cA mdslle1.3
      mdslle1.4 mdslle1.1 lejdiri a1i cA cB cmd wbr cB cA cdmd wbr wa cA cB cin
      cC wss cA cB cin cD wss wa cC cB wss cD cB wss wa wa cC cA chj co cD cA
      chj co cin cC cD cin cA chj co wss cA cB cin cC cD cin wss cC cD chj co
      cB wss wa cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB cin cD
      wss wa cC cB wss cD cB wss wa cC cA chj co cD cA chj co cin cC cD cin cA
      chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB cin cD
      wss wa cC cB wss cD cB wss wa w3a cC cA chj co cD cA chj co cin cC cA chj
      co cD cA chj co cin cB cin cA chj co cC cD cin cA chj co cB cA cdmd wbr
      cA cC cA chj co cD cA chj co cin wss cC cA chj co cD cA chj co cin cA cB
      chj co wss cC cA chj co cD cA chj co cin cB cin cA chj co cC cA chj co cD
      cA chj co cin wceq cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB
      cin cD wss wa cC cB wss cD cB wss wa cA cch wcel cB cch wcel cC cA chj co
      cD cA chj co cin cch wcel w3a cB cA cdmd wbr cA cC cA chj co cD cA chj co
      cin wss cC cA chj co cD cA chj co cin cA cB chj co wss w3a cC cA chj co
      cD cA chj co cin cB cin cA chj co cC cA chj co cD cA chj co cin wceq cA
      cch wcel cB cch wcel cC cA chj co cD cA chj co cin cch wcel mdslle1.1
      mdslle1.2 cC cA chj co cD cA chj co cC cA mdslle1.3 mdslle1.1 chjcli cD
      cA mdslle1.4 mdslle1.1 chjcli chincli 3pm3.2i cA cB cC cA chj co cD cA
      chj co cin dmdsl3 mpan cA cB cmd wbr cB cA cdmd wbr pm3.27 cA cC cA chj
      co cD cA chj co cin wss cA cB cin cC wss cA cB cin cD wss wa cA cC cA chj
      co cD cA chj co cA cC mdslle1.1 mdslle1.3 chub2i cA cD mdslle1.1
      mdslle1.4 chub2i ssini a1i cC cB wss cC cA chj co cD cA chj co cin cA cB
      chj co wss cD cB wss cC cB wss cC cA chj co cA cB chj co wss cC cA chj co
      cD cA chj co cin cA cB chj co wss cC cB wss cC cA chj co cB cA chj co cA
      cB chj co cC cB cA mdslle1.3 mdslle1.2 mdslle1.1 chlej1i cB cA mdslle1.2
      mdslle1.1 chjcomi syl6ss cC cA chj co cD cA chj co cA cB chj co ssinss1
      syl adantr syl3an cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB
      cin cD wss wa cC cB wss cD cB wss wa w3a cC cA chj co cD cA chj co cin cB
      cin cC cD cin wss cC cA chj co cD cA chj co cin cB cin cA chj co cC cD
      cin cA chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB
      cin cD wss wa cC cB wss cD cB wss wa w3a cC cA chj co cD cA chj co cin cB
      cin cC wss cC cA chj co cD cA chj co cin cB cin cD wss wa cC cA chj co cD
      cA chj co cin cB cin cC cD cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cB
      cin cC wss cA cB cin cD wss wa cC cB wss cD cB wss wa w3a cC cA chj co cD
      cA chj co cin cB cin cC wss cC cA chj co cD cA chj co cin cB cin cD wss
      cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB cin cD wss wa cC
      cB wss cD cB wss wa w3a cC cA chj co cD cA chj co cin cB cin cC cA chj co
      cB cin cC cC cA chj co cD cA chj co cin cB cin cC cA chj co cB cin wss cA
      cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB cin cD wss wa cC cB
      wss cD cB wss wa w3a cC cA chj co cD cA chj co cin cC cA chj co wss cC cA
      chj co cD cA chj co cin cB cin cC cA chj co cB cin wss cC cA chj co cD cA
      chj co inss1 cC cA chj co cD cA chj co cin cC cA chj co cB ssrin ax-mp
      a1i cA cB cmd wbr cA cB cin cC wss cC cB wss cC cA chj co cB cin cC wceq
      cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC wss cA cB cin cD wss wa cC
      cB wss cD cB wss wa cA cch wcel cB cch wcel cC cch wcel w3a cA cB cmd wbr
      cA cB cin cC wss cC cB wss w3a cC cA chj co cB cin cC wceq cA cch wcel cB
      cch wcel cC cch wcel mdslle1.1 mdslle1.2 mdslle1.3 3pm3.2i cA cB cC mdsl3
      mpan cA cB cmd wbr cB cA cdmd wbr pm3.26 cA cB cin cC wss cA cB cin cD
      wss pm3.26 cC cB wss cD cB wss pm3.26 syl3an sseqtrd cA cB cmd wbr cB cA
      cdmd wbr wa cA cB cin cC wss cA cB cin cD wss wa cC cB wss cD cB wss wa
      w3a cC cA chj co cD cA chj co cin cB cin cD cA chj co cB cin cD cC cA chj
      co cD cA chj co cin cB cin cD cA chj co cB cin wss cA cB cmd wbr cB cA
      cdmd wbr wa cA cB cin cC wss cA cB cin cD wss wa cC cB wss cD cB wss wa
      w3a cC cA chj co cD cA chj co cin cD cA chj co wss cC cA chj co cD cA chj
      co cin cB cin cD cA chj co cB cin wss cC cA chj co cD cA chj co inss2 cC
      cA chj co cD cA chj co cin cD cA chj co cB ssrin ax-mp a1i cA cB cmd wbr
      cA cB cin cD wss cD cB wss cD cA chj co cB cin cD wceq cA cB cmd wbr cB
      cA cdmd wbr wa cA cB cin cC wss cA cB cin cD wss wa cC cB wss cD cB wss
      wa cA cch wcel cB cch wcel cD cch wcel w3a cA cB cmd wbr cA cB cin cD wss
      cD cB wss w3a cD cA chj co cB cin cD wceq cA cch wcel cB cch wcel cD cch
      wcel mdslle1.1 mdslle1.2 mdslle1.4 3pm3.2i cA cB cD mdsl3 mpan cA cB cmd
      wbr cB cA cdmd wbr pm3.26 cA cB cin cC wss cA cB cin cD wss pm3.27 cC cB
      wss cD cB wss pm3.27 syl3an sseqtrd jca cC cA chj co cD cA chj co cin cB
      cin cC cD ssin sylib cC cA chj co cD cA chj co cin cB cin cC cD cin cA cC
      cA chj co cD cA chj co cin cB cC cA chj co cD cA chj co cC cA mdslle1.3
      mdslle1.1 chjcli cD cA mdslle1.4 mdslle1.1 chjcli chincli mdslle1.2
      chincli cC cD mdslle1.3 mdslle1.4 chincli mdslle1.1 chlej1i syl eqsstr3d
      3expb cA cB cin cC cD cin wss cA cB cin cC wss cA cB cin cD wss wa cC cD
      chj co cB wss cC cB wss cD cB wss wa cA cB cin cC wss cA cB cin cD wss wa
      cA cB cin cC cD cin wss cA cB cin cC cD ssin bicomi cC cB wss cD cB wss
      wa cC cD chj co cB wss cC cD cB mdslle1.3 mdslle1.4 mdslle1.2 chlubi
      bicomi anbi12i sylan2b eqssd $.
      $( [7-Oct-2006] $) $( [27-Apr-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    mdsl.1 $e |- A e. CH $.
    mdsl.2 $e |- B e. CH $.
    $( If the modular pair property holds in a sublattice, it holds in the
       whole lattice.  Lemma 1.4 of [MaedaMaeda] p. 2. $)
    mdsl1i $p |- ( A. x e. CH ( ( ( A i^i B ) C_ x /\ x C_ ( A vH B ) ) ->
   ( x C_ B -> ( ( x vH A ) i^i B ) = ( x vH ( A i^i B ) ) ) ) <-> A MH B ) $=
      cA cB cin vx cv wss vx cv cA cB chj co wss wa vx cv cB wss vx cv cA chj
      co cB cin vx cv cA cB cin chj co wceq wi wi vx cch wral cA cB cmd wbr cA
      cB cin vx cv wss vx cv cA cB chj co wss wa vx cv cB wss vx cv cA chj co
      cB cin vx cv cA cB cin chj co wceq wi wi vx cch wral vy cv cB wss vy cv
      cA chj co cB cin vy cv cA cB cin chj co wceq wi vy cch wral cA cB cmd wbr
      cA cB cin vx cv wss vx cv cA cB chj co wss wa vx cv cB wss vx cv cA chj
      co cB cin vx cv cA cB cin chj co wceq wi wi vx cch wral vy cv cB wss vy
      cv cA chj co cB cin vy cv cA cB cin chj co wceq wi vy cch vy cv cch wcel
      vy cv cA cB cin chj co cch wcel cA cB cin vy cv cA cB cin chj co wss vy
      cv cA cB cin chj co cA cB chj co wss wa vy cv cA cB cin chj co cB wss vy
      cv cA cB cin chj co cA chj co cB cin vy cv cA cB cin chj co cA cB cin chj
      co wceq wi wi wi vy cv cB wss vy cv cA chj co cB cin vy cv cA cB cin chj
      co wceq wi cA cB cin vx cv wss vx cv cA cB chj co wss wa vx cv cB wss vx
      cv cA chj co cB cin vx cv cA cB cin chj co wceq wi wi vx cch wral vy cv
      cch wcel vy cv cA cB cin chj co cch wcel cA cB cin vy cv cA cB cin chj co
      wss vy cv cA cB cin chj co cA cB chj co wss wa wa vy cv cA cB cin chj co
      cB wss wa vy cv cA cB cin chj co cA chj co cB cin vy cv cA cB cin chj co
      cA cB cin chj co wceq wi vy cv cB wss vy cv cA chj co cB cin vy cv cA cB
      cin chj co wceq wi vy cv cA cB cin chj co cch wcel cA cB cin vy cv cA cB
      cin chj co wss vy cv cA cB cin chj co cA cB chj co wss wa vy cv cA cB cin
      chj co cB wss vy cv cA cB cin chj co cA chj co cB cin vy cv cA cB cin chj
      co cA cB cin chj co wceq wi wi wi vy cv cch wcel vy cv cB wss vy cv cA cB
      cin chj co cch wcel cA cB cin vy cv cA cB cin chj co wss vy cv cA cB cin
      chj co cA cB chj co wss wa wa vy cv cA cB cin chj co cB wss wa vy cv cA
      cB cin chj co cA chj co cB cin vy cv cA cB cin chj co cA cB cin chj co
      wceq vy cv cA chj co cB cin vy cv cA cB cin chj co wceq vy cv cch wcel vy
      cv cB wss vy cv cA cB cin chj co cch wcel cA cB cin vy cv cA cB cin chj
      co wss vy cv cA cB cin chj co cA cB chj co wss wa wa vy cv cA cB cin chj
      co cB wss vy cv cch wcel vy cv cB wss cA cB cin vy cv cA cB cin chj co
      wss vy cv cA cB cin chj co cA cB chj co wss wa vy cv cA cB cin chj co cch
      wcel vy cv cch wcel vy cv cB wss vy cv cA cB cin chj co cA cB chj co wss
      cA cB cin vy cv cA cB cin chj co wss vy cv cch wcel vy cv cB wss vy cv cA
      cB cin chj co cB wss vy cv cA cB cin chj co cA cB chj co wss vy cv cch
      wcel vy cv cB wss cA cB cin cB wss vy cv cA cB cin chj co cB wss cA cB
      inss2 vy cv cch wcel vy cv cB wss cA cB cin cB wss wa vy cv cA cB cin chj
      co cB wss vy cv cch wcel cA cB cin cch wcel cB cch wcel vy cv cB wss cA
      cB cin cB wss wa vy cv cA cB cin chj co cB wss wb cA cB mdsl.1 mdsl.2
      chincli mdsl.2 vy cv cA cB cin cB chlub mp3an23 biimpd mpan2i vy cv cA cB
      cin chj co cB wss cB cA cB chj co wss vy cv cA cB cin chj co cA cB chj co
      wss cB cA mdsl.2 mdsl.1 chub2i vy cv cA cB cin chj co cB cA cB chj co
      sstr mpan2 syl6 cA cB cin cch wcel vy cv cch wcel cA cB cin vy cv cA cB
      cin chj co wss cA cB mdsl.1 mdsl.2 chincli cA cB cin vy cv chub2 mpan
      jctild vy cv cch wcel cA cB cin cch wcel vy cv cA cB cin chj co cch wcel
      cA cB mdsl.1 mdsl.2 chincli vy cv cA cB cin chjcl mpan2 jctild vy cv cch
      wcel vy cv cB wss cA cB cin cB wss vy cv cA cB cin chj co cB wss cA cB
      inss2 vy cv cch wcel vy cv cB wss cA cB cin cB wss wa vy cv cA cB cin chj
      co cB wss vy cv cch wcel cA cB cin cch wcel cB cch wcel vy cv cB wss cA
      cB cin cB wss wa vy cv cA cB cin chj co cB wss wb cA cB mdsl.1 mdsl.2
      chincli mdsl.2 vy cv cA cB cin cB chlub mp3an23 biimpd mpan2i jcad vy cv
      cch wcel vy cv cA cB cin chj co cA chj co cB cin vy cv cA cB cin chj co
      cA cB cin chj co wceq vy cv cA chj co cB cin vy cv cA cB cin chj co wceq
      vy cv cch wcel vy cv cA cB cin chj co cA chj co cB cin vy cv cA chj co cB
      cin vy cv cA cB cin chj co cA cB cin chj co vy cv cA cB cin chj co vy cv
      cch wcel vy cv cA cB cin chj co cA chj co vy cv cA chj co cB vy cv cch
      wcel vy cv cA cB cin chj co cA chj co vy cv cA cB cin cA chj co chj co vy
      cv cA chj co vy cv cch wcel cA cB cin cch wcel cA cch wcel vy cv cA cB
      cin chj co cA chj co vy cv cA cB cin cA chj co chj co wceq cA cB mdsl.1
      mdsl.2 chincli mdsl.1 vy cv cA cB cin cA chjass mp3an23 cA cB cin cA chj
      co cA vy cv chj cA cB cin cA chj co cA cA cB cin chj co cA cA cB cin cA
      cA cB mdsl.1 mdsl.2 chincli mdsl.1 chjcomi cA cB mdsl.1 mdsl.2 chabs1i
      eqtri opreq2i syl6eq ineq1d vy cv cch wcel vy cv cA cB cin chj co cA cB
      cin chj co vy cv cA cB cin cA cB cin chj co chj co vy cv cA cB cin chj co
      vy cv cch wcel cA cB cin cch wcel cA cB cin cch wcel vy cv cA cB cin chj
      co cA cB cin chj co vy cv cA cB cin cA cB cin chj co chj co wceq cA cB
      mdsl.1 mdsl.2 chincli cA cB mdsl.1 mdsl.2 chincli vy cv cA cB cin cA cB
      cin chjass mp3an23 cA cB cin cA cB cin chj co cA cB cin vy cv chj cA cB
      cin cA cB mdsl.1 mdsl.2 chincli chjidmi opreq2i syl6eq eqeq12d biimpd
      imim12d vy cv cA cB cin chj co cch wcel cA cB cin vy cv cA cB cin chj co
      wss vy cv cA cB cin chj co cA cB chj co wss wa wa vy cv cA cB cin chj co
      cB wss wa vy cv cA cB cin chj co cA chj co cB cin vy cv cA cB cin chj co
      cA cB cin chj co wceq wi vy cv cA cB cin chj co cch wcel cA cB cin vy cv
      cA cB cin chj co wss vy cv cA cB cin chj co cA cB chj co wss wa wa vy cv
      cA cB cin chj co cB wss vy cv cA cB cin chj co cA chj co cB cin vy cv cA
      cB cin chj co cA cB cin chj co wceq wi wi vy cv cA cB cin chj co cch wcel
      cA cB cin vy cv cA cB cin chj co wss vy cv cA cB cin chj co cA cB chj co
      wss wa vy cv cA cB cin chj co cB wss vy cv cA cB cin chj co cA chj co cB
      cin vy cv cA cB cin chj co cA cB cin chj co wceq wi wi wi vy cv cA cB cin
      chj co cch wcel cA cB cin vy cv cA cB cin chj co wss vy cv cA cB cin chj
      co cA cB chj co wss wa wa vy cv cA cB cin chj co cB wss vy cv cA cB cin
      chj co cA chj co cB cin vy cv cA cB cin chj co cA cB cin chj co wceq
      impexp vy cv cA cB cin chj co cch wcel cA cB cin vy cv cA cB cin chj co
      wss vy cv cA cB cin chj co cA cB chj co wss wa vy cv cA cB cin chj co cB
      wss vy cv cA cB cin chj co cA chj co cB cin vy cv cA cB cin chj co cA cB
      cin chj co wceq wi impexp bitr2i syl5ib cA cB cin vx cv wss vx cv cA cB
      chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq wi wi cA cB cin vy cv cA cB cin chj co wss vy cv cA cB cin chj co cA
      cB chj co wss wa vy cv cA cB cin chj co cB wss vy cv cA cB cin chj co cA
      chj co cB cin vy cv cA cB cin chj co cA cB cin chj co wceq wi wi vx vy cv
      cA cB cin chj co cch vx cv vy cv cA cB cin chj co wceq cA cB cin vx cv
      wss vx cv cA cB chj co wss wa cA cB cin vy cv cA cB cin chj co wss vy cv
      cA cB cin chj co cA cB chj co wss wa vx cv cB wss vx cv cA chj co cB cin
      vx cv cA cB cin chj co wceq wi vy cv cA cB cin chj co cB wss vy cv cA cB
      cin chj co cA chj co cB cin vy cv cA cB cin chj co cA cB cin chj co wceq
      wi vx cv vy cv cA cB cin chj co wceq cA cB cin vx cv wss cA cB cin vy cv
      cA cB cin chj co wss vx cv cA cB chj co wss vy cv cA cB cin chj co cA cB
      chj co wss vx cv vy cv cA cB cin chj co cA cB cin sseq2 vx cv vy cv cA cB
      cin chj co cA cB chj co sseq1 anbi12d vx cv vy cv cA cB cin chj co wceq
      vx cv cB wss vy cv cA cB cin chj co cB wss vx cv cA chj co cB cin vx cv
      cA cB cin chj co wceq vy cv cA cB cin chj co cA chj co cB cin vy cv cA cB
      cin chj co cA cB cin chj co wceq vx cv vy cv cA cB cin chj co cB sseq1 vx
      cv vy cv cA cB cin chj co wceq vx cv cA chj co cB cin vy cv cA cB cin chj
      co cA chj co cB cin vx cv cA cB cin chj co vy cv cA cB cin chj co cA cB
      cin chj co vx cv vy cv cA cB cin chj co wceq vx cv cA chj co vy cv cA cB
      cin chj co cA chj co cB vx cv vy cv cA cB cin chj co cA chj opreq1 ineq1d
      vx cv vy cv cA cB cin chj co cA cB cin chj opreq1 eqeq12d imbi12d imbi12d
      rcla4cv syl5com r19.21aiv cA cch wcel cB cch wcel cA cB cmd wbr vy cv cB
      wss vy cv cA chj co cB cin vy cv cA cB cin chj co wceq wi vy cch wral wb
      mdsl.1 mdsl.2 vy cA cB mdbr mp2an sylibr cA cB cmd wbr vx cv cB wss vx cv
      cA chj co cB cin vx cv cA cB cin chj co wceq wi vx cch wral cA cB cin vx
      cv wss vx cv cA cB chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx
      cv cA cB cin chj co wceq wi wi vx cch wral cA cch wcel cB cch wcel cA cB
      cmd wbr vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq
      wi vx cch wral wb mdsl.1 mdsl.2 vx cA cB mdbr mp2an vx cv cB wss vx cv cA
      chj co cB cin vx cv cA cB cin chj co wceq wi cA cB cin vx cv wss vx cv cA
      cB chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj
      co wceq wi wi vx cch vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wceq wi cA cB cin vx cv wss vx cv cA cB chj co wss wa ax-1
      r19.20si sylbi impbii $.
      $( [4-Jun-2006] $) $( [27-Apr-2006] $)

    $( If the modular pair property holds in a sublattice, it holds in the
       whole lattice.  Lemma 1.4 of [MaedaMaeda] p. 2. $)
    mdsl2i $p |- ( A MH B <-> A. x e. CH ( ( ( A i^i B ) C_ x /\ x C_ B ) ->
                ( ( x vH A ) i^i B ) C_ ( x vH ( A i^i B ) ) ) ) $=
      cA cB cin vx cv wss vx cv cB wss wa vx cv cA chj co cB cin vx cv cA cB
      cin chj co wss wi vx cch wral cA cB cin vx cv wss vx cv cA cB chj co wss
      wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi wi
      vx cch wral cA cB cmd wbr cA cB cin vx cv wss vx cv cB wss wa vx cv cA
      chj co cB cin vx cv cA cB cin chj co wss wi cA cB cin vx cv wss vx cv cA
      cB chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj
      co wceq wi wi vx cch vx cv cch wcel cA cB cin vx cv wss vx cv cB wss wa
      vx cv cA chj co cB cin vx cv cA cB cin chj co wss wi cA cB cin vx cv wss
      vx cv cA cB chj co wss wa vx cv cB wss wa vx cv cA chj co cB cin vx cv cA
      cB cin chj co wceq wi cA cB cin vx cv wss vx cv cA cB chj co wss wa vx cv
      cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi wi vx cv cch
      wcel cA cB cin vx cv wss vx cv cB wss wa vx cv cA chj co cB cin vx cv cA
      cB cin chj co wceq wi cA cB cin vx cv wss vx cv cB wss wa vx cv cA chj co
      cB cin vx cv cA cB cin chj co wss wi cA cB cin vx cv wss vx cv cA cB chj
      co wss wa vx cv cB wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq wi vx cv cch wcel cA cB cin vx cv wss vx cv cB wss wa vx cv cA chj
      co cB cin vx cv cA cB cin chj co wceq vx cv cA chj co cB cin vx cv cA cB
      cin chj co wss vx cv cch wcel vx cv cB wss vx cv cA chj co cB cin vx cv
      cA cB cin chj co wceq vx cv cA chj co cB cin vx cv cA cB cin chj co wss
      wb cA cB cin vx cv wss vx cv cch wcel vx cv cB wss vx cv cA cB cin chj co
      vx cv cA chj co cB cin wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq vx cv cA chj co cB cin vx cv cA cB cin chj co wss wb vx cv cch wcel
      vx cv cB wss vx cv vx cv cA chj co cB cin wss cA cB cin vx cv cA chj co
      cB cin wss wa vx cv cA cB cin chj co vx cv cA chj co cB cin wss vx cv cch
      wcel vx cv cB wss vx cv vx cv cA chj co cB cin wss cA cB cin vx cv cA chj
      co cB cin wss vx cv cB wss vx cv vx cv cA chj co wss vx cv vx cv cA chj
      co cB cin wss vx cv cch wcel vx cv cB wss vx cv vx cv cA chj co wss vx cv
      vx cv cA chj co wss vx cv cB wss wa vx cv vx cv cA chj co cB cin wss vx
      cv cB wss vx cv vx cv cA chj co wss iba vx cv vx cv cA chj co cB ssin
      syl6bb vx cv cch wcel cA cch wcel vx cv vx cv cA chj co wss mdsl.1 vx cv
      cA chub1 mpan2 syl5cbi vx cv cch wcel cA vx cv cA chj co wss cA cB cin vx
      cv cA chj co cB cin wss cA cch wcel vx cv cch wcel cA vx cv cA chj co wss
      mdsl.1 cA vx cv chub2 mpan cA vx cv cA chj co cB ssrin syl jctird vx cv
      cch wcel vx cv cA chj co cB cin cch wcel vx cv vx cv cA chj co cB cin wss
      cA cB cin vx cv cA chj co cB cin wss wa vx cv cA cB cin chj co vx cv cA
      chj co cB cin wss wb vx cv cch wcel vx cv cA chj co cch wcel vx cv cA chj
      co cB cin cch wcel vx cv cch wcel cA cch wcel vx cv cA chj co cch wcel
      mdsl.1 vx cv cA chjcl mpan2 vx cv cA chj co cch wcel cB cch wcel vx cv cA
      chj co cB cin cch wcel mdsl.2 vx cv cA chj co cB chincl mpan2 syl vx cv
      cch wcel cA cB cin cch wcel vx cv cA chj co cB cin cch wcel vx cv vx cv
      cA chj co cB cin wss cA cB cin vx cv cA chj co cB cin wss wa vx cv cA cB
      cin chj co vx cv cA chj co cB cin wss wb cA cB mdsl.1 mdsl.2 chincli vx
      cv cA cB cin vx cv cA chj co cB cin chlub mp3an2 mpdan sylibd vx cv cA cB
      cin chj co vx cv cA chj co cB cin wss vx cv cA chj co cB cin vx cv cA cB
      cin chj co wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv cA
      cB cin chj co vx cv cA chj co cB cin wss wa vx cv cA chj co cB cin vx cv
      cA cB cin chj co wceq vx cv cA cB cin chj co vx cv cA chj co cB cin wss
      vx cv cA chj co cB cin vx cv cA cB cin chj co wss iba vx cv cA chj co cB
      cin vx cv cA cB cin chj co eqss syl6rbbr syl6 adantld pm5.74d cA cB cin
      vx cv wss vx cv cB wss wa cA cB cin vx cv wss vx cv cA cB chj co wss wa
      vx cv cB wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co wceq cA cB
      cin vx cv wss vx cv cB wss wa cA cB cin vx cv wss vx cv cA cB chj co wss
      vx cv cB wss wa wa cA cB cin vx cv wss vx cv cA cB chj co wss wa vx cv cB
      wss wa vx cv cB wss vx cv cA cB chj co wss vx cv cB wss wa cA cB cin vx
      cv wss vx cv cB wss vx cv cA cB chj co wss vx cv cB wss cB cA cB chj co
      wss vx cv cA cB chj co wss cB cA mdsl.2 mdsl.1 chub2i vx cv cB cA cB chj
      co sstr mpan2 pm4.71ri anbi2i cA cB cin vx cv wss vx cv cA cB chj co wss
      vx cv cB wss anass bitr4i imbi1i syl5rbbr cA cB cin vx cv wss vx cv cA cB
      chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq impexp syl6bb ralbiia vx cA cB mdsl.1 mdsl.2 mdsl1i bitr2i $.
      $( [4-Jun-2006] $) $( [28-Apr-2006] $)

    $( If the modular pair property holds in a sublattice, it holds in the
       whole lattice.  Lemma 1.4 of [MaedaMaeda] p. 2. $)
    mdsl2bi $p |- ( A MH B <-> A. x e. CH ( ( ( A i^i B ) C_ x /\ x C_ B ) ->
                ( ( x vH A ) i^i B ) = ( x vH ( A i^i B ) ) ) ) $=
      cA cB cmd wbr cA cB cin vx cv wss vx cv cB wss wa vx cv cA chj co cB cin
      vx cv cA cB cin chj co wss wi vx cch wral cA cB cin vx cv wss vx cv cB
      wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi vx cch wral
      vx cA cB mdsl.1 mdsl.2 mdsl2i cA cB cin vx cv wss vx cv cB wss wa vx cv
      cA chj co cB cin vx cv cA cB cin chj co wss wi cA cB cin vx cv wss vx cv
      cB wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi vx cch vx
      cv cch wcel cA cB cin vx cv wss vx cv cB wss wa vx cv cA chj co cB cin vx
      cv cA cB cin chj co wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq vx cv cch wcel vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin
      chj co wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wb cA cB
      cin vx cv wss vx cv cch wcel vx cv cB wss vx cv cA chj co cB cin vx cv cA
      cB cin chj co wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wb
      vx cv cch wcel vx cv cB wss wa vx cv cA chj co cB cin vx cv cA cB cin chj
      co wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss vx cv cA cB cin
      chj co vx cv cA chj co cB cin wss wa vx cv cA chj co cB cin vx cv cA cB
      cin chj co wceq vx cv cch wcel vx cv cB wss wa vx cv cA cB cin chj co vx
      cv cA chj co cB cin wss vx cv cA chj co cB cin vx cv cA cB cin chj co wss
      vx cv cch wcel vx cv cB wss wa vx cv cA cB cin chj co vx cv cA chj co wss
      vx cv cA cB cin chj co cB wss wa vx cv cA cB cin chj co vx cv cA chj co
      cB cin wss vx cv cch wcel vx cv cB wss wa vx cv cA cB cin chj co vx cv cA
      chj co wss vx cv cA cB cin chj co cB wss vx cv cch wcel vx cv cA cB cin
      chj co vx cv cA chj co wss vx cv cB wss cA cB cin cch wcel cA cch wcel vx
      cv cch wcel vx cv cA cB cin chj co vx cv cA chj co wss cA cB mdsl.1
      mdsl.2 chincli mdsl.1 cA cB cin cch wcel cA cch wcel vx cv cch wcel w3a
      cA cB cin cA wss vx cv cA cB cin chj co vx cv cA chj co wss cA cB inss1
      cA cB cin cA vx cv chlej2 mpan2 mp3an12 adantr vx cv cch wcel vx cv cB
      wss wa vx cv cB wss cA cB cin cB wss wa vx cv cA cB cin chj co cB wss vx
      cv cch wcel vx cv cB wss wa vx cv cB wss cA cB cin cB wss vx cv cch wcel
      vx cv cB wss pm3.27 cA cB inss2 jctir vx cv cch wcel vx cv cB wss cA cB
      cin cB wss wa vx cv cA cB cin chj co cB wss wb vx cv cB wss vx cv cch
      wcel cA cB cin cch wcel cB cch wcel vx cv cB wss cA cB cin cB wss wa vx
      cv cA cB cin chj co cB wss wb cA cB mdsl.1 mdsl.2 chincli mdsl.2 vx cv cA
      cB cin cB chlub mp3an23 adantr mpbid jca vx cv cA cB cin chj co vx cv cA
      chj co cB ssin sylib biantrud vx cv cA chj co cB cin vx cv cA cB cin chj
      co eqss syl6bbr ex adantld pm5.74d ralbiia bitri $.
      $( [8-Jan-2007] $) $( [24-Dec-2006] $)

    $( The covering property implies the modular pair property.  Lemma 7.5.1 of
       [MaedaMaeda] p. 31. $)
    cvmdi $p |- ( ( A i^i B ) <o B -> A MH B ) $=
      cA cB cin cB ccv wbr cA cB cin vx cv wss vx cv cA cB chj co wss wa vx cv
      cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co wceq wi wi vx cch
      wral cA cB cmd wbr cA cB cin cB ccv wbr cA cB cin vx cv wss vx cv cA cB
      chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq wi wi vx cch cA cB cin cB ccv wbr vx cv cch wcel cA cB cin vx cv wss
      vx cv cA cB chj co wss wa vx cv cB wss vx cv cA chj co cB cin vx cv cA cB
      cin chj co wceq cA cB cin cB ccv wbr vx cv cch wcel wa cA cB cin vx cv
      wss vx cv cB wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co wceq cA
      cB cin vx cv wss vx cv cA cB chj co wss wa vx cv cB wss wa cA cB cin cB
      ccv wbr vx cv cch wcel wa cA cB cin vx cv wss vx cv cB wss wa vx cv cA cB
      cin wceq vx cv cB wceq wo vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq vx cv cch wcel cA cB cin cB ccv wbr cA cB cin vx cv wss vx cv cB wss
      wa vx cv cA cB cin wceq vx cv cB wceq wo wi cA cB cin cch wcel cB cch
      wcel vx cv cch wcel cA cB cin cB ccv wbr cA cB cin vx cv wss vx cv cB wss
      wa vx cv cA cB cin wceq vx cv cB wceq wo wi wi cA cB mdsl.1 mdsl.2
      chincli mdsl.2 cA cB cin cB vx cv cvnbtwn4 mp3an12 impcom vx cv cA cB cin
      wceq vx cv cA chj co cB cin vx cv cA cB cin chj co wceq vx cv cB wceq vx
      cv cA cB cin wceq cA cB cin cA chj co cB cin cA cB cin cA cB cin chj co
      vx cv cA chj co cB cin vx cv cA cB cin chj co cA cB cin cA chj co cB cin
      cA cB cin cA cB cin cA cB cin chj co cA cB cin cA chj co cA cB cA cB cin
      cA chj co cA cA cB cin chj co cA cA cB cin cA cA cB mdsl.1 mdsl.2 chincli
      mdsl.1 chjcomi cA cB mdsl.1 mdsl.2 chabs1i eqtri ineq1i cA cB cin cA cB
      mdsl.1 mdsl.2 chincli chjidmi eqtr4i vx cv cA cB cin wceq vx cv cA chj co
      cA cB cin cA chj co cB vx cv cA cB cin cA chj opreq1 ineq1d vx cv cA cB
      cin cA cB cin chj opreq1 3eqtr4a vx cv cB wceq cB cA chj co cB cin cB cA
      cB cin chj co vx cv cA chj co cB cin vx cv cA cB cin chj co cB cA chj co
      cB cin cB cB cA chj co cin cB cB cA cB cin chj co cB cA chj co cB incom
      cB cA mdsl.2 mdsl.1 chabs2i cB cB cA cin chj co cB cB cA cB cin chj co cB
      cA mdsl.2 mdsl.1 chabs1i cB cA cin cA cB cin cB chj cB cA incom opreq2i
      eqtr3i 3eqtri vx cv cB wceq vx cv cA chj co cB cA chj co cB vx cv cB cA
      chj opreq1 ineq1d vx cv cB cA cB cin chj opreq1 3eqtr4a jaoi syl6 cA cB
      cin vx cv wss vx cv cA cB chj co wss wa vx cv cB wss wa cA cB cin vx cv
      wss vx cv cA cB chj co wss vx cv cB wss wa wa cA cB cin vx cv wss vx cv
      cB wss wa cA cB cin vx cv wss vx cv cA cB chj co wss vx cv cB wss anass
      vx cv cB wss vx cv cA cB chj co wss vx cv cB wss wa cA cB cin vx cv wss
      vx cv cB wss vx cv cA cB chj co wss vx cv cB wss cB cA cB chj co wss vx
      cv cA cB chj co wss cB cA mdsl.2 mdsl.1 chub2i vx cv cB cA cB chj co sstr
      mpan2 pm4.71ri anbi2i bitr4i syl5ib exp4b r19.21aiv vx cA cB mdsl.1
      mdsl.2 mdsl1i sylib $.
      $( [13-Feb-2005] $) $( [16-Jun-2004] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    mdslmd.1 $e |- A e. CH $.
    mdslmd.2 $e |- B e. CH $.
    mdslmd.3 $e |- C e. CH $.
    mdslmd.4 $e |- D e. CH $.
    ${
      mdslmd1lem.5 $e |- R e. CH $.
      $( MAY BE REVISED.  This proof was done quickly and is inefficient.
         Need to use adantr, etc. earlier for unused antecendent pieces. $)
      $( Lemma for ~ mdslmd1i . $)
      mdslmd1lem1 $p |- ( ( ( A MH B /\ B MH* A ) /\ ( ( A C_ C /\ A C_
         D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) -> ( ( (
         R vH A ) C_ D -> ( ( ( R vH A ) vH C ) i^i D ) C_ ( ( R vH A ) vH ( C
         i^i D ) ) ) -> ( ( ( ( C i^i B ) i^i ( D i^i B ) ) C_ R /\ R C_ ( D
         i^i B ) ) -> ( ( R vH ( C i^i B ) ) i^i ( D i^i B ) ) C_ ( R vH ( ( C
         i^i B ) i^i ( D i^i B ) ) ) ) ) ) $=
        cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
        wss cD cA cB chj co wss wa wa wa cR cA chj co cD wss cR cA chj co cC
        chj co cD cin cR cA chj co cC cD cin chj co wss wi cC cB cin cD cB cin
        cin cR wss cR cD cB cin wss wa cR cA chj co cC chj co cD cin cR cA chj
        co cC cD cin chj co wss wi cC cB cin cD cB cin cin cR wss cR cD cB cin
        wss wa cR cC cB cin chj co cD cB cin cin cR cC cB cin cD cB cin cin chj
        co wss wi cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA
        cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR
        wss cR cD cB cin wss wa cR cA chj co cD wss cR cA chj co cC chj co cD
        cin cR cA chj co cC cD cin chj co wss cA cB cmd wbr cB cA cdmd wbr wa
        cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa
        cR cD cB cin wss cR cA chj co cD wss cC cB cin cD cB cin cin cR wss cA
        cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss
        cD cA cB chj co wss wa wa wa cR cA chj co cD cB cin cA chj co wss cR cA
        chj co cD wss cR cD cB cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cD cB
        cin cA chj co cD cR cA chj co cA cB cmd wbr cB cA cdmd wbr wa cA cC wss
        cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa cD cB cin cA
        chj co cD wceq cB cA cdmd wbr cA cD wss cD cA cB chj co wss cD cB cin
        cA chj co cD wceq cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
        wa cC cA cB chj co wss cD cA cB chj co wss wa cA cch wcel cB cch wcel
        cD cch wcel w3a cB cA cdmd wbr cA cD wss cD cA cB chj co wss w3a cD cB
        cin cA chj co cD wceq cA cch wcel cB cch wcel cD cch wcel mdslmd.1
        mdslmd.2 mdslmd.4 3pm3.2i cA cB cD dmdsl3 mpan cA cB cmd wbr cB cA cdmd
        wbr pm3.27 cA cC wss cA cD wss pm3.27 cC cA cB chj co wss cD cA cB chj
        co wss pm3.27 syl3an 3expb sseq2d cR cD cB cin cA mdslmd1lem.5 cD cB
        mdslmd.4 mdslmd.2 chincli mdslmd.1 chlej1i syl5bi adantld imim1d cA cB
        cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin
        wss wa cR cA chj co cC chj co cD cin cR cA chj co cC cD cin chj co wss
        cR cC cB cin chj co cD cB cin cin cR cC cB cin cD cB cin cin chj co wss
        cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
        wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD
        cB cin wss wa cR cA chj co cC chj co cD cin cR cA chj co cC cD cin chj
        co wss cR cC cB cin chj co cD cB cin cin cR cC cB cin cD cB cin cin chj
        co wss wi cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA
        cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR
        wss cR cD cB cin wss wa wa cR cC cB cin chj co cD cB cin cin cR cC cB
        cin cD cB cin cin chj co wss cR cA chj co cC chj co cD cin cR cA chj co
        cC cD cin chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB
        cin cin cR wss cR cD cB cin wss wa wa cR cC cB cin chj co cD cB cin cin
        cR cC cB cin cD cB cin cin chj co wss cR cA chj co cC chj co cD cin cB
        cin cR cA chj co cC cD cin chj co cB cin wss cR cA chj co cC chj co cD
        cin cR cA chj co cC cD cin chj co wss cA cB cmd wbr cB cA cdmd wbr wa
        cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa
        cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR cC cB cin chj
        co cD cB cin cin cR cA chj co cC chj co cD cin cB cin cR cC cB cin cD
        cB cin cin chj co cR cA chj co cC cD cin chj co cB cin cA cB cmd wbr cB
        cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj
        co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa
        cR cC cB cin chj co cD cB cin cin cR cA chj co cC chj co cB cin cD cB
        cin cin cR cA chj co cC chj co cD cin cB cin cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR cC cB
        cin chj co cR cA chj co cC chj co cB cin cD cB cin cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR
        cA chj co cC chj co cB cin cR cA chj co cB cin cC cB cin chj co cR cC
        cB cin chj co cA cB cmd wbr cB cA cdmd wbr wa cA cR cA chj co cC cin
        wss cR cA chj co cC chj co cA cB chj co wss wa cR cA chj co cC chj co
        cB cin cR cA chj co cB cin cC cB cin chj co wceq cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA
        cB cR cA chj co cC mdslmd.1 mdslmd.2 cR cA mdslmd1lem.5 mdslmd.1 chjcli
        mdslmd.3 mdslj1i cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa cC cB cin cD cB cin cin
        cR wss cR cD cB cin wss wa simpll cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cR cA chj co cC cin
        wss cR cA chj co cC chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cR cA
        chj co wss cA cC wss wa cA cR cA chj co cC cin wss cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA
        cC wss cA cR cA chj co wss cA cC wss cA cD wss wa cC cA cB chj co wss
        cD cA cB chj co wss wa wa cA cC wss cA cB cmd wbr cB cA cdmd wbr wa cC
        cB cin cD cB cin cin cR wss cR cD cB cin wss wa cA cC wss cA cD wss cC
        cA cB chj co wss cD cA cB chj co wss wa simpll ad2antlr cA cR mdslmd.1
        mdslmd1lem.5 chub2i jctil cA cR cA chj co cC ssin sylib cA cB cmd wbr
        cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa
        wa cR cA chj co cA cB chj co wss cC cA cB chj co wss wa cR cA chj co cC
        chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB
        cin cin cR wss cR cD cB cin wss wa wa cR cA chj co cA cB chj co wss cC
        cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin
        cin cR wss cR cD cB cin wss wa wa cR cA cB chj co wss cA cA cB chj co
        wss wa cR cA chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA
        cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC
        cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR cA cB chj co wss
        cA cA cB chj co wss cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa cR cD cB cin wss cR cA cB chj co wss cA cB cmd wbr cB
        cA cdmd wbr wa cC cB cin cD cB cin cin cR wss cC cA cB chj co wss cD cA
        cB chj co wss wa cR cD cB cin wss cR cA cB chj co wss cA cC wss cA cD
        wss wa cD cA cB chj co wss cR cD cB cin wss cR cA cB chj co wss cC cA
        cB chj co wss cR cD cB cin wss cD cA cB chj co wss cR cA cB chj co wss
        cR cD wss cD cA cB chj co wss cR cA cB chj co wss cR cD cB cin wss cR
        cD cA cB chj co sstr cR cD cB cin wss cD cB cin cD wss cR cD wss cD cB
        inss1 cR cD cB cin cD sstr mpan2 sylan ancoms adantll adantll ad2ant2l
        cA cB mdslmd.1 mdslmd.2 chub1i jctir cR cA cA cB chj co mdslmd1lem.5
        mdslmd.1 cA cB mdslmd.1 mdslmd.2 chjcli chlubi sylib cA cB cmd wbr cB
        cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj
        co wss wa wa wa cC cA cB chj co wss cC cB cin cD cB cin cin cR wss cR
        cD cB cin wss wa cC cA cB chj co wss cD cA cB chj co wss wa cC cA cB
        chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA
        cB chj co wss cD cA cB chj co wss pm3.26 ad2antll adantr jca cR cA chj
        co cC cA cB chj co cR cA mdslmd1lem.5 mdslmd.1 chjcli mdslmd.3 cA cB
        mdslmd.1 mdslmd.2 chjcli chlubi sylib jca sylanc cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR
        cA chj co cB cin cR cC cB cin chj cA cB cmd wbr cA cB cin cR wss cR cB
        wss cR cA chj co cB cin cR wceq cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cch wcel cB cch wcel
        cR cch wcel w3a cA cB cmd wbr cA cB cin cR wss cR cB wss w3a cR cA chj
        co cB cin cR wceq cA cch wcel cB cch wcel cR cch wcel mdslmd.1 mdslmd.2
        mdslmd1lem.5 3pm3.2i cA cB cR mdsl3 mpan cA cB cmd wbr cB cA cdmd wbr
        wa cA cB cmd wbr cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa cA
        cB cmd wbr cB cA cdmd wbr pm3.26 ad2antrr cA cB cmd wbr cB cA cdmd wbr
        wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa
        wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cB cin cC
        cB cin cD cB cin cin cR cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB
        cin cin cR wss cR cD cB cin wss wa wa cA cB cin cC cD cin cB cin cC cB
        cin cD cB cin cin cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
        wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin
        cin cR wss cR cD cB cin wss wa wa cA cC cD cin wss cA cB cin cC cD cin
        cB cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA
        cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR
        wss cR cD cB cin wss wa wa cA cC wss cA cD wss wa cA cC cD cin wss cA
        cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss
        cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB
        cin wss wa wa cA cC wss cA cD wss cA cC wss cA cD wss wa cC cA cB chj
        co wss cD cA cB chj co wss wa wa cA cC wss cA cB cmd wbr cB cA cdmd wbr
        wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa cA cC wss cA cD
        wss cC cA cB chj co wss cD cA cB chj co wss wa simpll ad2antlr cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cA cD
        wss cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin cR wss cR
        cD cB cin wss wa cA cC wss cA cD wss cC cA cB chj co wss cD cA cB chj
        co wss wa simplr ad2antlr jca cA cC cD ssin sylib cA cC cD cin cB ssrin
        syl cC cD cB inindir syl6ss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss
        cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin
        cD cB cin cin cR wss cR cD cB cin wss simprl sstrd cR cD cB cin wss cR
        cB wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB
        chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss
        cR cD cB cin wss cD cB cin cB wss cR cB wss cD cB inss2 cR cD cB cin cB
        sstr mpan2 ad2antll syl3anc opreq1d eqtr2d ineq1d cR cA chj co cC chj
        co cD cB inindir syl6eqr cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA
        cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD
        cB cin cin cR wss cR cD cB cin wss wa wa cR cA chj co cC cD cin chj co
        cB cin cR cA chj co cB cin cC cD cin cB cin chj co cR cC cB cin cD cB
        cin cin chj co cA cB cmd wbr cB cA cdmd wbr wa cA cR cA chj co cC cD
        cin cin wss cR cA chj co cC cD cin chj co cA cB chj co wss wa cR cA chj
        co cC cD cin chj co cB cin cR cA chj co cB cin cC cD cin cB cin chj co
        wceq cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB
        chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss
        cR cD cB cin wss wa wa cA cB cR cA chj co cC cD cin mdslmd.1 mdslmd.2
        cR cA mdslmd1lem.5 mdslmd.1 chjcli cC cD mdslmd.3 mdslmd.4 chincli
        mdslj1i cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB
        chj co wss cD cA cB chj co wss wa wa cC cB cin cD cB cin cin cR wss cR
        cD cB cin wss wa simpll cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB
        cin cin cR wss cR cD cB cin wss wa wa cA cR cA chj co cC cD cin cin wss
        cR cA chj co cC cD cin chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cR cA
        chj co wss cA cC cD cin wss wa cA cR cA chj co cC cD cin cin wss cA cB
        cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin
        wss wa wa cA cC cD cin wss cA cR cA chj co wss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cC
        wss cA cD wss wa cA cC cD cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cC wss cA cD wss cA
        cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cA cC
        wss cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin cR wss cR
        cD cB cin wss wa cA cC wss cA cD wss cC cA cB chj co wss cD cA cB chj
        co wss wa simpll ad2antlr cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa cA cD wss cA cB cmd wbr cB cA cdmd wbr wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa cA cC wss cA cD wss cC cA
        cB chj co wss cD cA cB chj co wss wa simplr ad2antlr jca cA cC cD ssin
        sylib cA cR mdslmd.1 mdslmd1lem.5 chub2i jctil cA cR cA chj co cC cD
        cin ssin sylib cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin
        cin cR wss cR cD cB cin wss wa wa cR cA chj co cA cB chj co wss cC cD
        cin cA cB chj co wss wa cR cA chj co cC cD cin chj co cA cB chj co wss
        cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
        wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD
        cB cin wss wa wa cR cA chj co cA cB chj co wss cC cD cin cA cB chj co
        wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj
        co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR
        cD cB cin wss wa wa cR cA cB chj co wss cA cA cB chj co wss wa cR cA
        chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB
        cin cin cR wss cR cD cB cin wss wa wa cR cA cB chj co wss cA cA cB chj
        co wss cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa cR cD cB cin wss cR cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr
        wa cC cB cin cD cB cin cin cR wss cC cA cB chj co wss cD cA cB chj co
        wss wa cR cD cB cin wss cR cA cB chj co wss cA cC wss cA cD wss wa cD
        cA cB chj co wss cR cD cB cin wss cR cA cB chj co wss cC cA cB chj co
        wss cR cD cB cin wss cD cA cB chj co wss cR cA cB chj co wss cR cD wss
        cD cA cB chj co wss cR cA cB chj co wss cR cD cB cin wss cR cD cA cB
        chj co sstr cR cD cB cin wss cD cB cin cD wss cR cD wss cD cB inss1 cR
        cD cB cin cD sstr mpan2 sylan ancoms adantll adantll ad2ant2l cA cB
        mdslmd.1 mdslmd.2 chub1i jctir cR cA cA cB chj co mdslmd1lem.5 mdslmd.1
        cA cB mdslmd.1 mdslmd.2 chjcli chlubi sylib cA cC wss cA cD wss wa cC
        cA cB chj co wss cD cA cB chj co wss wa wa cC cD cin cA cB chj co wss
        cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin cR wss cR cD cB
        cin wss wa cC cA cB chj co wss cC cD cin cA cB chj co wss cA cC wss cA
        cD wss wa cD cA cB chj co wss cC cD cA cB chj co ssinss1 ad2antrl
        ad2antlr jca cR cA chj co cC cD cin cA cB chj co cR cA mdslmd1lem.5
        mdslmd.1 chjcli cC cD mdslmd.3 mdslmd.4 chincli cA cB mdslmd.1 mdslmd.2
        chjcli chlubi sylib jca sylanc cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR cA chj co cB cin cR
        cC cD cin cB cin cC cB cin cD cB cin cin chj cA cB cmd wbr cA cB cin cR
        wss cR cB wss cR cA chj co cB cin cR wceq cA cB cmd wbr cB cA cdmd wbr
        wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa
        wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cch wcel cB
        cch wcel cR cch wcel w3a cA cB cmd wbr cA cB cin cR wss cR cB wss w3a
        cR cA chj co cB cin cR wceq cA cch wcel cB cch wcel cR cch wcel
        mdslmd.1 mdslmd.2 mdslmd1lem.5 3pm3.2i cA cB cR mdsl3 mpan cA cB cmd
        wbr cB cA cdmd wbr wa cA cB cmd wbr cA cC wss cA cD wss wa cC cA cB chj
        co wss cD cA cB chj co wss wa wa cC cB cin cD cB cin cin cR wss cR cD
        cB cin wss wa cA cB cmd wbr cB cA cdmd wbr pm3.26 ad2antrr cA cB cmd
        wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA
        cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss
        wa wa cA cB cin cC cB cin cD cB cin cin cR cA cB cmd wbr cB cA cdmd wbr
        wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa
        wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cB cin cC
        cD cin cB cin cC cB cin cD cB cin cin cA cB cmd wbr cB cA cdmd wbr wa
        cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa
        cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cC cD cin wss
        cA cB cin cC cD cin cB cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cC wss cA cD wss wa
        cA cC cD cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin
        cin cR wss cR cD cB cin wss wa wa cA cC wss cA cD wss cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cA cC wss cA cB
        cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin cR wss cR cD cB cin
        wss wa cA cC wss cA cD wss cC cA cB chj co wss cD cA cB chj co wss wa
        simpll ad2antlr cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj
        co wss wa wa cA cD wss cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB
        cin cin cR wss cR cD cB cin wss wa cA cC wss cA cD wss cC cA cB chj co
        wss cD cA cB chj co wss wa simplr ad2antlr jca cA cC cD ssin sylib cA
        cC cD cin cB ssrin syl cC cD cB inindir syl6ss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss simprl sstrd
        cR cD cB cin wss cR cB wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA
        cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD
        cB cin cin cR wss cR cD cB cin wss cD cB cin cB wss cR cB wss cD cB
        inss2 cR cD cB cin cB sstr mpan2 ad2antll syl3anc cC cD cin cB cin cC
        cB cin cD cB cin cin wceq cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA
        cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD
        cB cin cin cR wss cR cD cB cin wss wa wa cC cD cB inindir a1i opreq12d
        eqtr2d sseq12d cB cA cdmd wbr cA cR cA chj co cC chj co cD cin cR cA
        chj co cC cD cin chj co cin wss cR cA chj co cC chj co cD cin cR cA chj
        co cC cD cin chj co chj co cA cB chj co wss cR cA chj co cC chj co cD
        cin cR cA chj co cC cD cin chj co wss cR cA chj co cC chj co cD cin cB
        cin cR cA chj co cC cD cin chj co cB cin wss wb cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA
        cB cR cA chj co cC chj co cD cin cR cA chj co cC cD cin chj co mdslmd.1
        mdslmd.2 cR cA chj co cC chj co cD cR cA chj co cC cR cA mdslmd1lem.5
        mdslmd.1 chjcli mdslmd.3 chjcli mdslmd.4 chincli cR cA chj co cC cD cin
        cR cA mdslmd1lem.5 mdslmd.1 chjcli cC cD mdslmd.3 mdslmd.4 chincli
        chjcli mdslle1i cA cB cmd wbr cB cA cdmd wbr wa cB cA cdmd wbr cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cC cB
        cin cD cB cin cin cR wss cR cD cB cin wss wa cA cB cmd wbr cB cA cdmd
        wbr pm3.27 ad2antrr cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
        wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin
        cin cR wss cR cD cB cin wss wa wa cA cR cA chj co cC chj co cD cin wss
        cA cR cA chj co cC cD cin chj co wss wa cA cR cA chj co cC chj co cD
        cin cR cA chj co cC cD cin chj co cin wss cA cB cmd wbr cB cA cdmd wbr
        wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa
        wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cA cR cA chj
        co cC chj co cD cin wss cA cR cA chj co cC cD cin chj co wss cA cB cmd
        wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA
        cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss
        wa wa cA cR cA chj co cC chj co wss cA cD wss wa cA cR cA chj co cC chj
        co cD cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC
        cA cB chj co wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin
        cR wss cR cD cB cin wss wa wa cA cD wss cA cR cA chj co cC chj co wss
        cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cA
        cD wss cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin cR wss
        cR cD cB cin wss wa cA cC wss cA cD wss cC cA cB chj co wss cD cA cB
        chj co wss wa simplr ad2antlr cA cR cA chj co cR cA chj co cC chj co cA
        cR mdslmd.1 mdslmd1lem.5 chub2i cR cA chj co cC cR cA mdslmd1lem.5
        mdslmd.1 chjcli mdslmd.3 chub1i sstri jctil cA cR cA chj co cC chj co
        cD ssin sylib cA cR cA chj co cR cA chj co cC cD cin chj co cA cR
        mdslmd.1 mdslmd1lem.5 chub2i cR cA chj co cC cD cin cR cA mdslmd1lem.5
        mdslmd.1 chjcli cC cD mdslmd.3 mdslmd.4 chincli chub1i sstri jctir cA
        cR cA chj co cC chj co cD cin cR cA chj co cC cD cin chj co ssin sylib
        cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
        wss cD cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD
        cB cin wss wa wa cR cA chj co cC chj co cD cin cA cB chj co wss cR cA
        chj co cC cD cin chj co cA cB chj co wss wa cR cA chj co cC chj co cD
        cin cR cA chj co cC cD cin chj co chj co cA cB chj co wss cA cB cmd wbr
        cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa
        wa cR cA chj co cC chj co cD cin cA cB chj co wss cR cA chj co cC cD
        cin chj co cA cB chj co wss cA cC wss cA cD wss wa cC cA cB chj co wss
        cD cA cB chj co wss wa wa cR cA chj co cC chj co cD cin cA cB chj co
        wss cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin cR wss cR
        cD cB cin wss wa cD cA cB chj co wss cR cA chj co cC chj co cD cin cA
        cB chj co wss cA cC wss cA cD wss wa cC cA cB chj co wss cR cA chj co
        cC chj co cD cin cD wss cD cA cB chj co wss cR cA chj co cC chj co cD
        cin cA cB chj co wss cR cA chj co cC chj co cD inss2 cR cA chj co cC
        chj co cD cin cD cA cB chj co sstr mpan ad2antll ad2antlr cA cB cmd wbr
        cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa
        wa cR cA chj co cA cB chj co wss cC cD cin cA cB chj co wss wa cR cA
        chj co cC cD cin chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr
        wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa
        wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR cA chj co
        cA cB chj co wss cC cD cin cA cB chj co wss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin wss wa wa cR cA cB
        chj co wss cA cA cB chj co wss wa cR cA chj co cA cB chj co wss cA cB
        cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa wa cC cB cin cD cB cin cin cR wss cR cD cB cin
        wss wa wa cR cA cB chj co wss cA cA cB chj co wss cA cC wss cA cD wss
        wa cC cA cB chj co wss cD cA cB chj co wss wa wa cR cD cB cin wss cR cA
        cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cC cB cin cD cB cin cin
        cR wss cC cA cB chj co wss cD cA cB chj co wss wa cR cD cB cin wss cR
        cA cB chj co wss cA cC wss cA cD wss wa cD cA cB chj co wss cR cD cB
        cin wss cR cA cB chj co wss cC cA cB chj co wss cR cD cB cin wss cD cA
        cB chj co wss cR cA cB chj co wss cR cD wss cD cA cB chj co wss cR cA
        cB chj co wss cR cD cB cin wss cR cD cA cB chj co sstr cR cD cB cin wss
        cD cB cin cD wss cR cD wss cD cB inss1 cR cD cB cin cD sstr mpan2 sylan
        ancoms adantll adantll ad2ant2l cA cB mdslmd.1 mdslmd.2 chub1i jctir cR
        cA cA cB chj co mdslmd1lem.5 mdslmd.1 cA cB mdslmd.1 mdslmd.2 chjcli
        chlubi sylib cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa cC cD cin cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cC
        cB cin cD cB cin cin cR wss cR cD cB cin wss wa cC cA cB chj co wss cC
        cD cin cA cB chj co wss cA cC wss cA cD wss wa cD cA cB chj co wss cC
        cD cA cB chj co ssinss1 ad2antrl ad2antlr jca cR cA chj co cC cD cin cA
        cB chj co cR cA mdslmd1lem.5 mdslmd.1 chjcli cC cD mdslmd.3 mdslmd.4
        chincli cA cB mdslmd.1 mdslmd.2 chjcli chlubi sylib jca cR cA chj co cC
        chj co cD cin cR cA chj co cC cD cin chj co cA cB chj co cR cA chj co
        cC chj co cD cR cA chj co cC cR cA mdslmd1lem.5 mdslmd.1 chjcli
        mdslmd.3 chjcli mdslmd.4 chincli cR cA chj co cC cD cin cR cA
        mdslmd1lem.5 mdslmd.1 chjcli cC cD mdslmd.3 mdslmd.4 chincli chjcli cA
        cB mdslmd.1 mdslmd.2 chjcli chlubi sylib syl3anc bitr4d biimprd ex a2d
        syld $.
        $( [29-Apr-2006] $) $( [29-Apr-2006] $)

      $( MAY BE REVISED.  This proof was done quickly and is inefficient.
         Need to use adantr, etc. earlier for unused antecendent pieces. $)
      $( Lemma for ~ mdslmd1i . $)
      mdslmd1lem2 $p |- ( ( ( A MH B /\ B MH* A ) /\ ( ( A C_
         C /\ A C_ D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) ->
         ( ( ( R i^i B ) C_ ( D i^i B ) -> ( ( ( R i^i B ) vH ( C i^i B ) ) i^i
         ( D i^i B ) ) C_ ( ( R i^i B ) vH ( ( C i^i B ) i^i ( D i^i B ) ) ) )
         -> ( ( ( C i^i D ) C_ R /\ R C_ D ) -> ( ( R vH C ) i^i D ) C_ ( R vH
         ( C i^i D ) ) ) ) ) $=
        cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
        wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR cD wss wa cR cB
        cin cC cB cin chj co cD cB cin cin cR cB cin cC cB cin cD cB cin cin
        chj co wss wi cC cD cin cR wss cR cD wss wa cR cC chj co cD cin cR cC
        cD cin chj co wss wi cR cB cin cD cB cin wss cR cB cin cC cB cin chj co
        cD cB cin cin cR cB cin cC cB cin cD cB cin cin chj co wss wi cA cB cmd
        wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA
        cB chj co wss wa wa wa cC cD cin cR wss cR cD wss wa cR cB cin cC cB
        cin chj co cD cB cin cin cR cB cin cC cB cin cD cB cin cin chj co wss
        cR cC chj co cD cin cR cC cD cin chj co wss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cD cin cR wss cR cD wss wa cR cB cin cC cB cin chj co cD cB
        cin cin cR cB cin cC cB cin cD cB cin cin chj co wss cR cC chj co cD
        cin cR cC cD cin chj co wss wi cA cB cmd wbr cB cA cdmd wbr wa cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD
        cin cR wss cR cD wss wa wa cR cC chj co cD cin cR cC cD cin chj co wss
        cR cB cin cC cB cin chj co cD cB cin cin cR cB cin cC cB cin cD cB cin
        cin chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR cD
        wss wa wa cR cC chj co cD cin cR cC cD cin chj co wss cR cC chj co cD
        cin cB cin cR cC cD cin chj co cB cin wss cR cB cin cC cB cin chj co cD
        cB cin cin cR cB cin cC cB cin cD cB cin cin chj co wss cB cA cdmd wbr
        cA cR cC chj co cD cin cR cC cD cin chj co cin wss cR cC chj co cD cin
        cR cC cD cin chj co chj co cA cB chj co wss cR cC chj co cD cin cR cC
        cD cin chj co wss cR cC chj co cD cin cB cin cR cC cD cin chj co cB cin
        wss wb cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB
        chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR cD wss wa
        wa cA cB cR cC chj co cD cin cR cC cD cin chj co mdslmd.1 mdslmd.2 cR
        cC chj co cD cR cC mdslmd1lem.5 mdslmd.3 chjcli mdslmd.4 chincli cR cC
        cD cin mdslmd1lem.5 cC cD mdslmd.3 mdslmd.4 chincli chjcli mdslle1i cA
        cB cmd wbr cB cA cdmd wbr wa cB cA cdmd wbr cA cC wss cA cD wss wa cC
        cA cB chj co wss cD cA cB chj co wss wa wa cC cD cin cR wss cR cD wss
        wa cA cB cmd wbr cB cA cdmd wbr pm3.27 ad2antrr cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cD cin cR wss cR cD wss wa wa cA cR cC chj co cD cin
        wss cA cR cC cD cin chj co wss wa cA cR cC chj co cD cin cR cC cD cin
        chj co cin wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR cD
        wss wa wa cA cR cC chj co cD cin wss cA cR cC cD cin chj co wss cA cB
        cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa wa cC cD cin cR wss cR cD wss wa wa cA cR cC chj
        co wss cA cD wss wa cA cR cC chj co cD cin wss cA cB cmd wbr cB cA cdmd
        wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss
        wa wa wa cC cD cin cR wss cR cD wss wa wa cA cR cC chj co wss cA cD wss
        cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cA
        cR cC chj co wss cA cB cmd wbr cB cA cdmd wbr wa cC cD cin cR wss cR cD
        wss wa cA cC wss cA cR cC chj co wss cA cD wss cC cA cB chj co wss cD
        cA cB chj co wss wa cA cC wss cC cR cC chj co wss cA cR cC chj co wss
        cC cR mdslmd.3 mdslmd1lem.5 chub2i cA cC cR cC chj co sstr mpan2
        ad2antrr ad2antlr cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa cA cD wss cA cB cmd wbr cB cA cdmd wbr wa cC cD cin cR
        wss cR cD wss wa cA cC wss cA cD wss cC cA cB chj co wss cD cA cB chj
        co wss wa simplr ad2antlr jca cA cR cC chj co cD ssin sylib cA cC wss
        cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cA cR cC cD
        cin chj co wss cA cB cmd wbr cB cA cdmd wbr wa cC cD cin cR wss cR cD
        wss wa cA cC wss cA cD wss wa cA cR cC cD cin chj co wss cC cA cB chj
        co wss cD cA cB chj co wss wa cA cC wss cA cD wss wa cA cC cD cin wss
        cA cR cC cD cin chj co wss cA cC cD ssin cA cC cD cin wss cC cD cin cR
        cC cD cin chj co wss cA cR cC cD cin chj co wss cC cD cin cR cC cD
        mdslmd.3 mdslmd.4 chincli mdslmd1lem.5 chub2i cA cC cD cin cR cC cD cin
        chj co sstr mpan2 sylbi adantr ad2antlr jca cA cR cC chj co cD cin cR
        cC cD cin chj co ssin sylib cA cB cmd wbr cB cA cdmd wbr wa cA cC wss
        cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin
        cR wss cR cD wss wa wa cR cC chj co cD cin cA cB chj co wss cR cC cD
        cin chj co cA cB chj co wss wa cR cC chj co cD cin cR cC cD cin chj co
        chj co cA cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR
        wss cR cD wss wa wa cR cC chj co cD cin cA cB chj co wss cR cC cD cin
        chj co cA cB chj co wss cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa cR cC chj co cD cin cA cB chj co wss cA cB cmd
        wbr cB cA cdmd wbr wa cC cD cin cR wss cR cD wss wa cD cA cB chj co wss
        cR cC chj co cD cin cA cB chj co wss cA cC wss cA cD wss wa cC cA cB
        chj co wss cR cC chj co cD cin cD wss cD cA cB chj co wss cR cC chj co
        cD cin cA cB chj co wss cR cC chj co cD inss2 cR cC chj co cD cin cD cA
        cB chj co sstr mpan ad2antll ad2antlr cA cB cmd wbr cB cA cdmd wbr wa
        cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa
        cC cD cin cR wss cR cD wss wa wa cR cA cB chj co wss cC cD cin cA cB
        chj co wss wa cR cC cD cin chj co cA cB chj co wss cA cB cmd wbr cB cA
        cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
        wss wa wa wa cC cD cin cR wss cR cD wss wa wa cR cA cB chj co wss cC cD
        cin cA cB chj co wss cA cC wss cA cD wss wa cC cA cB chj co wss cD cA
        cB chj co wss wa wa cC cD cin cR wss cR cD wss wa cR cA cB chj co wss
        cA cB cmd wbr cB cA cdmd wbr wa cC cA cB chj co wss cD cA cB chj co wss
        wa cC cD cin cR wss cR cD wss wa cR cA cB chj co wss cA cC wss cA cD
        wss wa cD cA cB chj co wss cR cD wss cR cA cB chj co wss cC cA cB chj
        co wss cC cD cin cR wss cR cD wss cD cA cB chj co wss cR cA cB chj co
        wss cR cD cA cB chj co sstr ancoms ad2ant2l adantll adantll cA cC wss
        cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cC cD cin cA
        cB chj co wss cA cB cmd wbr cB cA cdmd wbr wa cC cD cin cR wss cR cD
        wss wa cC cA cB chj co wss cC cD cin cA cB chj co wss cA cC wss cA cD
        wss wa cD cA cB chj co wss cC cD cA cB chj co ssinss1 ad2antrl ad2antlr
        jca cR cC cD cin cA cB chj co mdslmd1lem.5 cC cD mdslmd.3 mdslmd.4
        chincli cA cB mdslmd.1 mdslmd.2 chjcli chlubi sylib jca cR cC chj co cD
        cin cR cC cD cin chj co cA cB chj co cR cC chj co cD cR cC mdslmd1lem.5
        mdslmd.3 chjcli mdslmd.4 chincli cR cC cD cin mdslmd1lem.5 cC cD
        mdslmd.3 mdslmd.4 chincli chjcli cA cB mdslmd.1 mdslmd.2 chjcli chlubi
        sylib syl3anc cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC
        cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR cD
        wss wa wa cR cB cin cC cB cin chj co cD cB cin cin cR cC chj co cD cin
        cB cin cR cB cin cC cB cin cD cB cin cin chj co cR cC cD cin chj co cB
        cin cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj
        co wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR cD wss wa wa cR
        cC chj co cB cin cD cB cin cin cR cB cin cC cB cin chj co cD cB cin cin
        cR cC chj co cD cin cB cin cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA
        cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR
        wss cR cD wss wa wa cR cC chj co cB cin cR cB cin cC cB cin chj co cD
        cB cin cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB
        chj co wss cD cA cB chj co wss wa wa cC cD cin cR wss cR cD wss wa cR
        cC chj co cB cin cR cB cin cC cB cin chj co wceq cA cB cmd wbr cB cA
        cdmd wbr wa cA cR cC cin wss cR cC chj co cA cB chj co wss wa cR cC chj
        co cB cin cR cB cin cC cB cin chj co wceq cA cC wss cA cD wss wa cC cA
        cB chj co wss cD cA cB chj co wss wa wa cC cD cin cR wss cR cD wss wa
        wa cA cB cR cC mdslmd.1 mdslmd.2 mdslmd1lem.5 mdslmd.3 mdslj1i cA cC
        wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cC cD
        cin cR wss cR cD wss wa wa cA cR cC cin wss cR cC chj co cA cB chj co
        wss cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa
        wa cC cD cin cR wss cR cD wss wa wa cA cR wss cA cC wss wa cA cR cC cin
        wss cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa
        wa cC cD cin cR wss cR cD wss wa wa cA cR wss cA cC wss cA cC wss cA cD
        wss wa cC cD cin cR wss cA cR wss cC cA cB chj co wss cD cA cB chj co
        wss wa cR cD wss cA cC cD cin wss cC cD cin cR wss cA cR wss cA cC wss
        cA cD wss wa cA cC cD cin cR sstr cA cC cD ssin sylanb ad2ant2r cA cC
        wss cA cD wss wa cA cC wss cC cA cB chj co wss cD cA cB chj co wss wa
        cC cD cin cR wss cR cD wss wa cA cC wss cA cD wss pm3.26 ad2antrr jca
        cA cR cC ssin sylib cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa cC cD cin cR wss cR cD wss wa wa cR cA cB chj co wss
        cC cA cB chj co wss wa cR cC chj co cA cB chj co wss cA cC wss cA cD
        wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa cC cD cin cR wss
        cR cD wss wa wa cR cA cB chj co wss cC cA cB chj co wss cC cA cB chj co
        wss cD cA cB chj co wss wa cC cD cin cR wss cR cD wss wa cR cA cB chj
        co wss cA cC wss cA cD wss wa cD cA cB chj co wss cR cD wss cR cA cB
        chj co wss cC cA cB chj co wss cC cD cin cR wss cR cD wss cD cA cB chj
        co wss cR cA cB chj co wss cR cD cA cB chj co sstr ancoms ad2ant2l
        adantll cC cA cB chj co wss cD cA cB chj co wss wa cC cA cB chj co wss
        cA cC wss cA cD wss wa cC cD cin cR wss cR cD wss wa cC cA cB chj co
        wss cD cA cB chj co wss pm3.26 ad2antlr jca cR cC cA cB chj co
        mdslmd1lem.5 mdslmd.3 cA cB mdslmd.1 mdslmd.2 chjcli chlubi sylib jca
        sylan2 anassrs ineq1d cR cC chj co cD cB inindir syl5req cA cB cmd wbr
        cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
        chj co wss wa wa wa cC cD cin cR wss cR cD wss wa wa cR cC cD cin chj
        co cB cin cR cB cin cC cD cin cB cin chj co cR cB cin cC cB cin cD cB
        cin cin chj co cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
        cC cA cB chj co wss cD cA cB chj co wss wa wa cC cD cin cR wss cR cD
        wss wa cR cC cD cin chj co cB cin cR cB cin cC cD cin cB cin chj co
        wceq cA cB cmd wbr cB cA cdmd wbr wa cA cR cC cD cin cin wss cR cC cD
        cin chj co cA cB chj co wss wa cR cC cD cin chj co cB cin cR cB cin cC
        cD cin cB cin chj co wceq cA cC wss cA cD wss wa cC cA cB chj co wss cD
        cA cB chj co wss wa wa cC cD cin cR wss cR cD wss wa wa cA cB cR cC cD
        cin mdslmd.1 mdslmd.2 mdslmd1lem.5 cC cD mdslmd.3 mdslmd.4 chincli
        mdslj1i cA cC wss cA cD wss wa cC cD cin cR wss cC cA cB chj co wss cD
        cA cB chj co wss wa cR cD wss cA cR cC cD cin cin wss cR cC cD cin chj
        co cA cB chj co wss wa cA cC wss cA cD wss wa cC cD cin cR wss wa cA cR
        cC cD cin cin wss cC cA cB chj co wss cD cA cB chj co wss wa cR cD wss
        wa cR cC cD cin chj co cA cB chj co wss cA cC wss cA cD wss wa cC cD
        cin cR wss wa cA cR wss cA cC cD cin wss wa cA cR cC cD cin cin wss cA
        cC wss cA cD wss wa cC cD cin cR wss wa cA cR wss cA cC cD cin wss cA
        cC cD cin wss cC cD cin cR wss cA cR wss cA cC wss cA cD wss wa cA cC
        cD cin cR sstr cA cC cD ssin sylanb cA cC wss cA cD wss wa cA cC cD cin
        wss cC cD cin cR wss cA cC wss cA cD wss wa cA cC cD cin wss cA cC cD
        ssin biimpi adantr jca cA cR cC cD cin ssin sylib cC cA cB chj co wss
        cD cA cB chj co wss wa cR cD wss wa cR cA cB chj co wss cC cD cin cA cB
        chj co wss wa cR cC cD cin chj co cA cB chj co wss cC cA cB chj co wss
        cD cA cB chj co wss wa cR cD wss wa cR cA cB chj co wss cC cD cin cA cB
        chj co wss cD cA cB chj co wss cR cD wss cR cA cB chj co wss cC cA cB
        chj co wss cR cD wss cD cA cB chj co wss cR cA cB chj co wss cR cD cA
        cB chj co sstr ancoms adantll cC cA cB chj co wss cC cD cin cA cB chj
        co wss cD cA cB chj co wss cR cD wss cC cD cA cB chj co ssinss1
        ad2antrr jca cR cC cD cin cA cB chj co mdslmd1lem.5 cC cD mdslmd.3
        mdslmd.4 chincli cA cB mdslmd.1 mdslmd.2 chjcli chlubi sylib anim12i
        an4s sylan2 anassrs cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
        wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa cC cD cin cR wss cR
        cD wss wa wa cC cD cin cB cin cC cB cin cD cB cin cin cR cB cin chj cC
        cD cin cB cin cC cB cin cD cB cin cin wceq cA cB cmd wbr cB cA cdmd wbr
        wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa
        wa cC cD cin cR wss cR cD wss wa wa cC cD cB inindir a1i opreq2d eqtr2d
        sseq12d bitr4d biimprd ex a2d cC cD cin cR wss cR cD wss wa cR cB cin
        cD cB cin wss cR cB cin cC cB cin chj co cD cB cin cin cR cB cin cC cB
        cin cD cB cin cin chj co wss cR cD wss cR cB cin cD cB cin wss cC cD
        cin cR wss cR cD cB ssrin adantl imim1i syl5 $.
        $( [29-Apr-2006] $) $( [29-Apr-2006] $)
    $}

    $( Lemma for ~ mdslmd1i . $)
    mdslmd1lem3 $p |- ( ( x e. CH /\ ( ( A MH B /\ B MH* A ) /\ ( ( A C_ C /\ A
        C_ D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) ) -> ( ( (
        x vH A ) C_ D -> ( ( ( x vH A ) vH C ) i^i D ) C_ ( ( x vH A ) vH ( C
        i^i D ) ) ) -> ( ( ( ( C i^i B ) i^i ( D i^i B ) ) C_ x /\ x C_ ( D i^i
        B ) ) -> ( ( x vH ( C i^i B ) ) i^i ( D i^i B ) ) C_ ( x vH ( ( C i^i B
        ) i^i ( D i^i B ) ) ) ) ) ) $=
      vx cv cch wcel cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC
      cA cB chj co wss cD cA cB chj co wss wa wa wa vx cv cA chj co cD wss vx
      cv cA chj co cC chj co cD cin vx cv cA chj co cC cD cin chj co wss wi cC
      cB cin cD cB cin cin vx cv wss vx cv cD cB cin wss wa vx cv cC cB cin chj
      co cD cB cin cin vx cv cC cB cin cD cB cin cin chj co wss wi wi vx cv cch
      wcel cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj
      co wss cD cA cB chj co wss wa wa wa vx cv cA chj co cD wss vx cv cA chj
      co cC chj co cD cin vx cv cA chj co cC cD cin chj co wss wi cC cB cin cD
      cB cin cin vx cv wss vx cv cD cB cin wss wa vx cv cC cB cin chj co cD cB
      cin cin vx cv cC cB cin cD cB cin cin chj co wss wi wi wi cA cB cmd wbr
      cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj
      co wss wa wa wa vx cv cch wcel vx cv c0h cif cA chj co cD wss vx cv cch
      wcel vx cv c0h cif cA chj co cC chj co cD cin vx cv cch wcel vx cv c0h
      cif cA chj co cC cD cin chj co wss wi cC cB cin cD cB cin cin vx cv cch
      wcel vx cv c0h cif wss vx cv cch wcel vx cv c0h cif cD cB cin wss wa vx
      cv cch wcel vx cv c0h cif cC cB cin chj co cD cB cin cin vx cv cch wcel
      vx cv c0h cif cC cB cin cD cB cin cin chj co wss wi wi wi vx cv c0h vx cv
      vx cv cch wcel vx cv c0h cif wceq vx cv cA chj co cD wss vx cv cA chj co
      cC chj co cD cin vx cv cA chj co cC cD cin chj co wss wi cC cB cin cD cB
      cin cin vx cv wss vx cv cD cB cin wss wa vx cv cC cB cin chj co cD cB cin
      cin vx cv cC cB cin cD cB cin cin chj co wss wi wi vx cv cch wcel vx cv
      c0h cif cA chj co cD wss vx cv cch wcel vx cv c0h cif cA chj co cC chj co
      cD cin vx cv cch wcel vx cv c0h cif cA chj co cC cD cin chj co wss wi cC
      cB cin cD cB cin cin vx cv cch wcel vx cv c0h cif wss vx cv cch wcel vx
      cv c0h cif cD cB cin wss wa vx cv cch wcel vx cv c0h cif cC cB cin chj co
      cD cB cin cin vx cv cch wcel vx cv c0h cif cC cB cin cD cB cin cin chj co
      wss wi wi cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB
      chj co wss cD cA cB chj co wss wa wa wa vx cv vx cv cch wcel vx cv c0h
      cif wceq vx cv cA chj co cD wss vx cv cA chj co cC chj co cD cin vx cv cA
      chj co cC cD cin chj co wss wi vx cv cch wcel vx cv c0h cif cA chj co cD
      wss vx cv cch wcel vx cv c0h cif cA chj co cC chj co cD cin vx cv cch
      wcel vx cv c0h cif cA chj co cC cD cin chj co wss wi cC cB cin cD cB cin
      cin vx cv wss vx cv cD cB cin wss wa vx cv cC cB cin chj co cD cB cin cin
      vx cv cC cB cin cD cB cin cin chj co wss wi cC cB cin cD cB cin cin vx cv
      cch wcel vx cv c0h cif wss vx cv cch wcel vx cv c0h cif cD cB cin wss wa
      vx cv cch wcel vx cv c0h cif cC cB cin chj co cD cB cin cin vx cv cch
      wcel vx cv c0h cif cC cB cin cD cB cin cin chj co wss wi vx cv vx cv cch
      wcel vx cv c0h cif wceq vx cv cA chj co cD wss vx cv cch wcel vx cv c0h
      cif cA chj co cD wss vx cv cA chj co cC chj co cD cin vx cv cA chj co cC
      cD cin chj co wss vx cv cch wcel vx cv c0h cif cA chj co cC chj co cD cin
      vx cv cch wcel vx cv c0h cif cA chj co cC cD cin chj co wss vx cv vx cv
      cch wcel vx cv c0h cif wceq vx cv cA chj co vx cv cch wcel vx cv c0h cif
      cA chj co cD vx cv vx cv cch wcel vx cv c0h cif cA chj opreq1 sseq1d vx
      cv vx cv cch wcel vx cv c0h cif wceq vx cv cA chj co cC chj co cD cin vx
      cv cch wcel vx cv c0h cif cA chj co cC chj co cD cin vx cv cA chj co cC
      cD cin chj co vx cv cch wcel vx cv c0h cif cA chj co cC cD cin chj co vx
      cv vx cv cch wcel vx cv c0h cif wceq vx cv cA chj co cC chj co vx cv cch
      wcel vx cv c0h cif cA chj co cC chj co cD vx cv vx cv cch wcel vx cv c0h
      cif wceq vx cv cA chj co vx cv cch wcel vx cv c0h cif cA chj co cC chj vx
      cv vx cv cch wcel vx cv c0h cif cA chj opreq1 opreq1d ineq1d vx cv vx cv
      cch wcel vx cv c0h cif wceq vx cv cA chj co vx cv cch wcel vx cv c0h cif
      cA chj co cC cD cin chj vx cv vx cv cch wcel vx cv c0h cif cA chj opreq1
      opreq1d sseq12d imbi12d vx cv vx cv cch wcel vx cv c0h cif wceq cC cB cin
      cD cB cin cin vx cv wss vx cv cD cB cin wss wa cC cB cin cD cB cin cin vx
      cv cch wcel vx cv c0h cif wss vx cv cch wcel vx cv c0h cif cD cB cin wss
      wa vx cv cC cB cin chj co cD cB cin cin vx cv cC cB cin cD cB cin cin chj
      co wss vx cv cch wcel vx cv c0h cif cC cB cin chj co cD cB cin cin vx cv
      cch wcel vx cv c0h cif cC cB cin cD cB cin cin chj co wss vx cv vx cv cch
      wcel vx cv c0h cif wceq cC cB cin cD cB cin cin vx cv wss cC cB cin cD cB
      cin cin vx cv cch wcel vx cv c0h cif wss vx cv cD cB cin wss vx cv cch
      wcel vx cv c0h cif cD cB cin wss vx cv vx cv cch wcel vx cv c0h cif cC cB
      cin cD cB cin cin sseq2 vx cv vx cv cch wcel vx cv c0h cif cD cB cin
      sseq1 anbi12d vx cv vx cv cch wcel vx cv c0h cif wceq vx cv cC cB cin chj
      co cD cB cin cin vx cv cch wcel vx cv c0h cif cC cB cin chj co cD cB cin
      cin vx cv cC cB cin cD cB cin cin chj co vx cv cch wcel vx cv c0h cif cC
      cB cin cD cB cin cin chj co vx cv vx cv cch wcel vx cv c0h cif wceq vx cv
      cC cB cin chj co vx cv cch wcel vx cv c0h cif cC cB cin chj co cD cB cin
      vx cv vx cv cch wcel vx cv c0h cif cC cB cin chj opreq1 ineq1d vx cv vx
      cv cch wcel vx cv c0h cif cC cB cin cD cB cin cin chj opreq1 sseq12d
      imbi12d imbi12d imbi2d cA cB cC cD vx cv cch wcel vx cv c0h cif mdslmd.1
      mdslmd.2 mdslmd.3 mdslmd.4 vx cv c0h cch h0elch elimel mdslmd1lem1 dedth
      imp $.
      $( [29-Apr-2006] $) $( [29-Apr-2006] $)

    $( Lemma for ~ mdslmd1i . $)
    mdslmd1lem4 $p |- ( ( x e. CH /\ ( ( A MH B /\ B MH* A ) /\ ( ( A C_
       C /\ A C_ D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) ) -> ( ( ( x
       i^i B ) C_ ( D i^i B ) -> ( ( ( x i^i B ) vH ( C i^i B ) ) i^i ( D i^i B
       ) ) C_ ( ( x i^i B ) vH ( ( C i^i B ) i^i ( D i^i B ) ) ) ) -> ( ( ( C
       i^i D ) C_ x /\ x C_ D ) -> ( ( x vH C ) i^i D ) C_ ( x vH ( C i^i D ) )
       ) ) ) $=
      vx cv cch wcel cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC
      cA cB chj co wss cD cA cB chj co wss wa wa wa vx cv cB cin cD cB cin wss
      vx cv cB cin cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin cD cB
      cin cin chj co wss wi cC cD cin vx cv wss vx cv cD wss wa vx cv cC chj co
      cD cin vx cv cC cD cin chj co wss wi wi vx cv cch wcel cA cB cmd wbr cB
      cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
      wss wa wa wa vx cv cB cin cD cB cin wss vx cv cB cin cC cB cin chj co cD
      cB cin cin vx cv cB cin cC cB cin cD cB cin cin chj co wss wi cC cD cin
      vx cv wss vx cv cD wss wa vx cv cC chj co cD cin vx cv cC cD cin chj co
      wss wi wi wi cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA
      cB chj co wss cD cA cB chj co wss wa wa wa vx cv cch wcel vx cv c0h cif
      cB cin cD cB cin wss vx cv cch wcel vx cv c0h cif cB cin cC cB cin chj co
      cD cB cin cin vx cv cch wcel vx cv c0h cif cB cin cC cB cin cD cB cin cin
      chj co wss wi cC cD cin vx cv cch wcel vx cv c0h cif wss vx cv cch wcel
      vx cv c0h cif cD wss wa vx cv cch wcel vx cv c0h cif cC chj co cD cin vx
      cv cch wcel vx cv c0h cif cC cD cin chj co wss wi wi wi vx cv c0h vx cv
      vx cv cch wcel vx cv c0h cif wceq vx cv cB cin cD cB cin wss vx cv cB cin
      cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin cD cB cin cin chj
      co wss wi cC cD cin vx cv wss vx cv cD wss wa vx cv cC chj co cD cin vx
      cv cC cD cin chj co wss wi wi vx cv cch wcel vx cv c0h cif cB cin cD cB
      cin wss vx cv cch wcel vx cv c0h cif cB cin cC cB cin chj co cD cB cin
      cin vx cv cch wcel vx cv c0h cif cB cin cC cB cin cD cB cin cin chj co
      wss wi cC cD cin vx cv cch wcel vx cv c0h cif wss vx cv cch wcel vx cv
      c0h cif cD wss wa vx cv cch wcel vx cv c0h cif cC chj co cD cin vx cv cch
      wcel vx cv c0h cif cC cD cin chj co wss wi wi cA cB cmd wbr cB cA cdmd
      wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa
      wa wa vx cv vx cv cch wcel vx cv c0h cif wceq vx cv cB cin cD cB cin wss
      vx cv cB cin cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin cD cB
      cin cin chj co wss wi vx cv cch wcel vx cv c0h cif cB cin cD cB cin wss
      vx cv cch wcel vx cv c0h cif cB cin cC cB cin chj co cD cB cin cin vx cv
      cch wcel vx cv c0h cif cB cin cC cB cin cD cB cin cin chj co wss wi cC cD
      cin vx cv wss vx cv cD wss wa vx cv cC chj co cD cin vx cv cC cD cin chj
      co wss wi cC cD cin vx cv cch wcel vx cv c0h cif wss vx cv cch wcel vx cv
      c0h cif cD wss wa vx cv cch wcel vx cv c0h cif cC chj co cD cin vx cv cch
      wcel vx cv c0h cif cC cD cin chj co wss wi vx cv vx cv cch wcel vx cv c0h
      cif wceq vx cv cB cin cD cB cin wss vx cv cch wcel vx cv c0h cif cB cin
      cD cB cin wss vx cv cB cin cC cB cin chj co cD cB cin cin vx cv cB cin cC
      cB cin cD cB cin cin chj co wss vx cv cch wcel vx cv c0h cif cB cin cC cB
      cin chj co cD cB cin cin vx cv cch wcel vx cv c0h cif cB cin cC cB cin cD
      cB cin cin chj co wss vx cv vx cv cch wcel vx cv c0h cif wceq vx cv cB
      cin vx cv cch wcel vx cv c0h cif cB cin cD cB cin vx cv vx cv cch wcel vx
      cv c0h cif cB ineq1 sseq1d vx cv vx cv cch wcel vx cv c0h cif wceq vx cv
      cB cin cC cB cin chj co cD cB cin cin vx cv cch wcel vx cv c0h cif cB cin
      cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin cD cB cin cin chj
      co vx cv cch wcel vx cv c0h cif cB cin cC cB cin cD cB cin cin chj co vx
      cv vx cv cch wcel vx cv c0h cif wceq vx cv cB cin cC cB cin chj co vx cv
      cch wcel vx cv c0h cif cB cin cC cB cin chj co cD cB cin vx cv vx cv cch
      wcel vx cv c0h cif wceq vx cv cB cin vx cv cch wcel vx cv c0h cif cB cin
      cC cB cin chj vx cv vx cv cch wcel vx cv c0h cif cB ineq1 opreq1d ineq1d
      vx cv vx cv cch wcel vx cv c0h cif wceq vx cv cB cin vx cv cch wcel vx cv
      c0h cif cB cin cC cB cin cD cB cin cin chj vx cv vx cv cch wcel vx cv c0h
      cif cB ineq1 opreq1d sseq12d imbi12d vx cv vx cv cch wcel vx cv c0h cif
      wceq cC cD cin vx cv wss vx cv cD wss wa cC cD cin vx cv cch wcel vx cv
      c0h cif wss vx cv cch wcel vx cv c0h cif cD wss wa vx cv cC chj co cD cin
      vx cv cC cD cin chj co wss vx cv cch wcel vx cv c0h cif cC chj co cD cin
      vx cv cch wcel vx cv c0h cif cC cD cin chj co wss vx cv vx cv cch wcel vx
      cv c0h cif wceq cC cD cin vx cv wss cC cD cin vx cv cch wcel vx cv c0h
      cif wss vx cv cD wss vx cv cch wcel vx cv c0h cif cD wss vx cv vx cv cch
      wcel vx cv c0h cif cC cD cin sseq2 vx cv vx cv cch wcel vx cv c0h cif cD
      sseq1 anbi12d vx cv vx cv cch wcel vx cv c0h cif wceq vx cv cC chj co cD
      cin vx cv cch wcel vx cv c0h cif cC chj co cD cin vx cv cC cD cin chj co
      vx cv cch wcel vx cv c0h cif cC cD cin chj co vx cv vx cv cch wcel vx cv
      c0h cif wceq vx cv cC chj co vx cv cch wcel vx cv c0h cif cC chj co cD vx
      cv vx cv cch wcel vx cv c0h cif cC chj opreq1 ineq1d vx cv vx cv cch wcel
      vx cv c0h cif cC cD cin chj opreq1 sseq12d imbi12d imbi12d imbi2d cA cB
      cC cD vx cv cch wcel vx cv c0h cif mdslmd.1 mdslmd.2 mdslmd.3 mdslmd.4 vx
      cv c0h cch h0elch elimel mdslmd1lem2 dedth imp $.
      $( [29-Apr-2006] $) $( [29-Apr-2006] $)

    $( Preservation of the modular pair property in the one-to-one onto mapping
       between the two sublattices in Lemma 1.3 of [MaedaMaeda] p. 2 (meet
       version). $)
    mdslmd1i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( A C_ ( C i^i D ) /\ ( C vH D ) C_ ( A vH B ) ) ) ->
                ( C MH D <-> ( C i^i B ) MH ( D i^i B ) ) ) $=
      cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
      wss cD cA cB chj co wss wa wa cC cD cmd wbr cC cB cin cD cB cin cmd wbr
      wb cA cC cD cin wss cC cD chj co cA cB chj co wss wa cA cB cmd wbr cB cA
      cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
      wss wa wa wa cC cD cmd wbr cC cB cin cD cB cin cmd wbr cA cB cmd wbr cB
      cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co
      wss wa wa wa vy cv cD wss vy cv cC chj co cD cin vy cv cC cD cin chj co
      wss wi vy cch wral cC cB cin cD cB cin cin vx cv wss vx cv cD cB cin wss
      wa vx cv cC cB cin chj co cD cB cin cin vx cv cC cB cin cD cB cin cin chj
      co wss wi vx cch wral cC cD cmd wbr cC cB cin cD cB cin cmd wbr cA cB cmd
      wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB
      chj co wss wa wa wa vy cv cD wss vy cv cC chj co cD cin vy cv cC cD cin
      chj co wss wi vy cch wral cC cB cin cD cB cin cin vx cv wss vx cv cD cB
      cin wss wa vx cv cC cB cin chj co cD cB cin cin vx cv cC cB cin cD cB cin
      cin chj co wss wi vx cch vx cv cch wcel cA cB cmd wbr cB cA cdmd wbr wa
      cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa
      vy cv cD wss vy cv cC chj co cD cin vy cv cC cD cin chj co wss wi vy cch
      wral cC cB cin cD cB cin cin vx cv wss vx cv cD cB cin wss wa vx cv cC cB
      cin chj co cD cB cin cin vx cv cC cB cin cD cB cin cin chj co wss wi vx
      cv cch wcel cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA
      cB chj co wss cD cA cB chj co wss wa wa wa vy cv cD wss vy cv cC chj co
      cD cin vy cv cC cD cin chj co wss wi vy cch wral cC cB cin cD cB cin cin
      vx cv wss vx cv cD cB cin wss wa vx cv cC cB cin chj co cD cB cin cin vx
      cv cC cB cin cD cB cin cin chj co wss wi wi vx cv cch wcel cA cB cmd wbr
      cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj
      co wss wa wa wa wa vy cv cD wss vy cv cC chj co cD cin vy cv cC cD cin
      chj co wss wi vy cch wral vx cv cA chj co cD wss vx cv cA chj co cC chj
      co cD cin vx cv cA chj co cC cD cin chj co wss wi cC cB cin cD cB cin cin
      vx cv wss vx cv cD cB cin wss wa vx cv cC cB cin chj co cD cB cin cin vx
      cv cC cB cin cD cB cin cin chj co wss wi vx cv cch wcel vy cv cD wss vy
      cv cC chj co cD cin vy cv cC cD cin chj co wss wi vy cch wral vx cv cA
      chj co cD wss vx cv cA chj co cC chj co cD cin vx cv cA chj co cC cD cin
      chj co wss wi wi cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa
      cC cA cB chj co wss cD cA cB chj co wss wa wa wa vx cv cch wcel vx cv cA
      chj co cch wcel vy cv cD wss vy cv cC chj co cD cin vy cv cC cD cin chj
      co wss wi vy cch wral vx cv cA chj co cD wss vx cv cA chj co cC chj co cD
      cin vx cv cA chj co cC cD cin chj co wss wi wi vx cv cch wcel cA cch wcel
      vx cv cA chj co cch wcel mdslmd.1 vx cv cA chjcl mpan2 vy cv cD wss vy cv
      cC chj co cD cin vy cv cC cD cin chj co wss wi vx cv cA chj co cD wss vx
      cv cA chj co cC chj co cD cin vx cv cA chj co cC cD cin chj co wss wi vy
      vx cv cA chj co cch vy cv vx cv cA chj co wceq vy cv cD wss vx cv cA chj
      co cD wss vy cv cC chj co cD cin vy cv cC cD cin chj co wss vx cv cA chj
      co cC chj co cD cin vx cv cA chj co cC cD cin chj co wss vy cv vx cv cA
      chj co cD sseq1 vy cv vx cv cA chj co wceq vy cv cC chj co cD cin vx cv
      cA chj co cC chj co cD cin vy cv cC cD cin chj co vx cv cA chj co cC cD
      cin chj co vy cv vx cv cA chj co wceq vy cv cC chj co vx cv cA chj co cC
      chj co cD vy cv vx cv cA chj co cC chj opreq1 ineq1d vy cv vx cv cA chj
      co cC cD cin chj opreq1 sseq12d imbi12d rcla4v syl adantr vx cA cB cC cD
      mdslmd.1 mdslmd.2 mdslmd.3 mdslmd.4 mdslmd1lem3 syld ex com3l r19.21adv
      cC cch wcel cD cch wcel cC cD cmd wbr vy cv cD wss vy cv cC chj co cD cin
      vy cv cC cD cin chj co wss wi vy cch wral wb mdslmd.3 mdslmd.4 vy cC cD
      mdbr2 mp2an vx cC cB cin cD cB cin cC cB mdslmd.3 mdslmd.2 chincli cD cB
      mdslmd.4 mdslmd.2 chincli mdsl2i 3imtr4g cA cB cmd wbr cB cA cdmd wbr wa
      cA cC wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa
      vy cv cD cB cin wss vy cv cC cB cin chj co cD cB cin cin vy cv cC cB cin
      cD cB cin cin chj co wss wi vy cch wral cC cD cin vx cv wss vx cv cD wss
      wa vx cv cC chj co cD cin vx cv cC cD cin chj co wss wi vx cch wral cC cB
      cin cD cB cin cmd wbr cC cD cmd wbr cA cB cmd wbr cB cA cdmd wbr wa cA cC
      wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa vy cv
      cD cB cin wss vy cv cC cB cin chj co cD cB cin cin vy cv cC cB cin cD cB
      cin cin chj co wss wi vy cch wral cC cD cin vx cv wss vx cv cD wss wa vx
      cv cC chj co cD cin vx cv cC cD cin chj co wss wi vx cch vx cv cch wcel
      cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co
      wss cD cA cB chj co wss wa wa wa vy cv cD cB cin wss vy cv cC cB cin chj
      co cD cB cin cin vy cv cC cB cin cD cB cin cin chj co wss wi vy cch wral
      cC cD cin vx cv wss vx cv cD wss wa vx cv cC chj co cD cin vx cv cC cD
      cin chj co wss wi vx cv cch wcel cA cB cmd wbr cB cA cdmd wbr wa cA cC
      wss cA cD wss wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa vy cv
      cD cB cin wss vy cv cC cB cin chj co cD cB cin cin vy cv cC cB cin cD cB
      cin cin chj co wss wi vy cch wral cC cD cin vx cv wss vx cv cD wss wa vx
      cv cC chj co cD cin vx cv cC cD cin chj co wss wi wi vx cv cch wcel cA cB
      cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss wa cC cA cB chj co wss cD
      cA cB chj co wss wa wa wa wa vy cv cD cB cin wss vy cv cC cB cin chj co
      cD cB cin cin vy cv cC cB cin cD cB cin cin chj co wss wi vy cch wral vx
      cv cB cin cD cB cin wss vx cv cB cin cC cB cin chj co cD cB cin cin vx cv
      cB cin cC cB cin cD cB cin cin chj co wss wi cC cD cin vx cv wss vx cv cD
      wss wa vx cv cC chj co cD cin vx cv cC cD cin chj co wss wi vx cv cch
      wcel vy cv cD cB cin wss vy cv cC cB cin chj co cD cB cin cin vy cv cC cB
      cin cD cB cin cin chj co wss wi vy cch wral vx cv cB cin cD cB cin wss vx
      cv cB cin cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin cD cB cin
      cin chj co wss wi wi cA cB cmd wbr cB cA cdmd wbr wa cA cC wss cA cD wss
      wa cC cA cB chj co wss cD cA cB chj co wss wa wa wa vx cv cch wcel vx cv
      cB cin cch wcel vy cv cD cB cin wss vy cv cC cB cin chj co cD cB cin cin
      vy cv cC cB cin cD cB cin cin chj co wss wi vy cch wral vx cv cB cin cD
      cB cin wss vx cv cB cin cC cB cin chj co cD cB cin cin vx cv cB cin cC cB
      cin cD cB cin cin chj co wss wi wi vx cv cch wcel cB cch wcel vx cv cB
      cin cch wcel mdslmd.2 vx cv cB chincl mpan2 vy cv cD cB cin wss vy cv cC
      cB cin chj co cD cB cin cin vy cv cC cB cin cD cB cin cin chj co wss wi
      vx cv cB cin cD cB cin wss vx cv cB cin cC cB cin chj co cD cB cin cin vx
      cv cB cin cC cB cin cD cB cin cin chj co wss wi vy vx cv cB cin cch vy cv
      vx cv cB cin wceq vy cv cD cB cin wss vx cv cB cin cD cB cin wss vy cv cC
      cB cin chj co cD cB cin cin vy cv cC cB cin cD cB cin cin chj co wss vx
      cv cB cin cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin cD cB cin
      cin chj co wss vy cv vx cv cB cin cD cB cin sseq1 vy cv vx cv cB cin wceq
      vy cv cC cB cin chj co cD cB cin cin vx cv cB cin cC cB cin chj co cD cB
      cin cin vy cv cC cB cin cD cB cin cin chj co vx cv cB cin cC cB cin cD cB
      cin cin chj co vy cv vx cv cB cin wceq vy cv cC cB cin chj co vx cv cB
      cin cC cB cin chj co cD cB cin vy cv vx cv cB cin cC cB cin chj opreq1
      ineq1d vy cv vx cv cB cin cC cB cin cD cB cin cin chj opreq1 sseq12d
      imbi12d rcla4v syl adantr vx cA cB cC cD mdslmd.1 mdslmd.2 mdslmd.3
      mdslmd.4 mdslmd1lem4 syld ex com3l r19.21adv cC cB cin cch wcel cD cB cin
      cch wcel cC cB cin cD cB cin cmd wbr vy cv cD cB cin wss vy cv cC cB cin
      chj co cD cB cin cin vy cv cC cB cin cD cB cin cin chj co wss wi vy cch
      wral wb cC cB mdslmd.3 mdslmd.2 chincli cD cB mdslmd.4 mdslmd.2 chincli
      vy cC cB cin cD cB cin mdbr2 mp2an vx cC cD mdslmd.3 mdslmd.4 mdsl2i
      3imtr4g impbid cA cC wss cA cD wss wa cA cC cD cin wss cC cA cB chj co
      wss cD cA cB chj co wss wa cC cD chj co cA cB chj co wss cA cC cD ssin cC
      cD cA cB chj co mdslmd.3 mdslmd.4 cA cB mdslmd.1 mdslmd.2 chjcli chlubi
      anbi12i sylan2br $.
      $( [4-Jun-2006] $) $( [27-Apr-2006] $)

    $( Preservation of the modular pair property in the one-to-one onto mapping
       between the two sublattices in Lemma 1.3 of [MaedaMaeda] p. 2 (join
       version). $)
    mdslmd2i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( ( A i^i B ) C_ ( C i^i D ) /\ ( C vH D ) C_ B ) ) ->
                ( C MH D <-> ( C vH A ) MH ( D vH A ) ) ) $=
      cA cB cmd wbr cB cA cdmd wbr wa cA cB cin cC cD cin wss cC cD chj co cB
      wss wa wa cC cA chj co cD cA chj co cmd wbr cC cA chj co cB cin cD cA chj
      co cB cin cmd wbr cC cD cmd wbr cA cB cmd wbr cB cA cdmd wbr wa cA cC cA
      chj co cD cA chj co cin wss cC cA chj co cD cA chj co chj co cA cB chj co
      wss wa cC cA chj co cD cA chj co cmd wbr cC cA chj co cB cin cD cA chj co
      cB cin cmd wbr wb cA cB cin cC cD cin wss cC cD chj co cB wss wa cA cB cC
      cA chj co cD cA chj co mdslmd.1 mdslmd.2 cC cA mdslmd.3 mdslmd.1 chjcli
      cD cA mdslmd.4 mdslmd.1 chjcli mdslmd1i cA cB cin cC cD cin wss cC cD chj
      co cB wss wa cC cA chj co cD cA chj co chj co cA cB chj co wss cA cC cA
      chj co cD cA chj co cin wss cC cD chj co cB wss cC cA chj co cD cA chj co
      chj co cA cB chj co wss cA cB cin cC cD cin wss cC cD chj co cB wss cC cD
      chj co cA chj co cB cA chj co cC cA chj co cD cA chj co chj co cA cB chj
      co cC cD chj co cB cA cC cD mdslmd.3 mdslmd.4 chjcli mdslmd.2 mdslmd.1
      chlej1i cC cD cA mdslmd.3 mdslmd.4 mdslmd.1 chjjdiri cB cA mdslmd.2
      mdslmd.1 chjcomi 3sstr3g adantl cA cC cA chj co cD cA chj co cA cC
      mdslmd.1 mdslmd.3 chub2i cA cD mdslmd.1 mdslmd.4 chub2i ssini jctil
      sylan2 cA cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss wa cC cA
      chj co cB cin cD cA chj co cB cin cmd wbr cC cD cmd wbr wb cB cA cdmd wbr
      cA cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss cC cA chj co cB
      cin cD cA chj co cB cin cmd wbr cC cD cmd wbr wb cA cB cmd wbr cA cB cin
      cC cD cin wss cC cD chj co cB wss w3a cC cA chj co cB cin cC cD cA chj co
      cB cin cD cmd cA cB cmd wbr cA cB cin cC wss cC cB wss cC cA chj co cB
      cin cC wceq cA cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss cA
      cch wcel cB cch wcel cC cch wcel w3a cA cB cmd wbr cA cB cin cC wss cC cB
      wss w3a cC cA chj co cB cin cC wceq cA cch wcel cB cch wcel cC cch wcel
      mdslmd.1 mdslmd.2 mdslmd.3 3pm3.2i cA cB cC mdsl3 mpan cA cB cmd wbr id
      cA cB cin cC cD cin wss cC cD cin cC wss cA cB cin cC wss cC cD inss1 cA
      cB cin cC cD cin cC sstr mpan2 cC cC cD chj co wss cC cD chj co cB wss cC
      cB wss cC cD mdslmd.3 mdslmd.4 chub1i cC cC cD chj co cB sstr mpan syl3an
      cA cB cmd wbr cA cB cin cD wss cD cB wss cD cA chj co cB cin cD wceq cA
      cB cmd wbr cA cB cin cC cD cin wss cC cD chj co cB wss cA cch wcel cB cch
      wcel cD cch wcel w3a cA cB cmd wbr cA cB cin cD wss cD cB wss w3a cD cA
      chj co cB cin cD wceq cA cch wcel cB cch wcel cD cch wcel mdslmd.1
      mdslmd.2 mdslmd.4 3pm3.2i cA cB cD mdsl3 mpan cA cB cmd wbr id cA cB cin
      cC cD cin wss cC cD cin cD wss cA cB cin cD wss cC cD inss2 cA cB cin cC
      cD cin cD sstr mpan2 cD cC cD chj co wss cC cD chj co cB wss cD cB wss cD
      cC mdslmd.4 mdslmd.3 chub2i cD cC cD chj co cB sstr mpan syl3an breq12d
      3expb adantlr bitr2d $.
      $( [4-Jun-2006] $) $( [29-Apr-2006] $)

    $( Preservation of the dual modular pair property in the one-to-one onto
       mapping between the two sublattices in Lemma 1.3 of [MaedaMaeda]
       p. 2. $)
    mdsldmd1i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( A C_ ( C i^i D ) /\ ( C vH D ) C_ ( A vH B ) ) ) ->
                ( C MH* D <-> ( C i^i B ) MH* ( D i^i B ) ) ) $=
      cB cort cfv cA cort cfv cmd wbr cA cort cfv cB cort cfv cdmd wbr wa cB
      cort cfv cA cort cfv cin cC cort cfv cD cort cfv cin wss cC cort cfv cD
      cort cfv chj co cA cort cfv wss wa wa cC cort cfv cD cort cfv cmd wbr cC
      cort cfv cB cort cfv chj co cD cort cfv cB cort cfv chj co cmd wbr wb cA
      cB cmd wbr cB cA cdmd wbr wa cA cC cD cin wss cC cD chj co cA cB chj co
      wss wa wa cC cD cdmd wbr cC cB cin cD cB cin cdmd wbr wb cB cort cfv cA
      cort cfv cC cort cfv cD cort cfv cB mdslmd.2 choccli cA mdslmd.1 choccli
      cC mdslmd.3 choccli cD mdslmd.4 choccli mdslmd2i cA cB cmd wbr cB cA cdmd
      wbr wa cB cort cfv cA cort cfv cmd wbr cA cort cfv cB cort cfv cdmd wbr
      wa cA cC cD cin wss cC cD chj co cA cB chj co wss wa cB cort cfv cA cort
      cfv cin cC cort cfv cD cort cfv cin wss cC cort cfv cD cort cfv chj co cA
      cort cfv wss wa cA cB cmd wbr cB cA cdmd wbr wa cB cA cdmd wbr cA cB cmd
      wbr wa cB cort cfv cA cort cfv cmd wbr cA cort cfv cB cort cfv cdmd wbr
      wa cA cB cmd wbr cB cA cdmd wbr ancom cB cA cdmd wbr cB cort cfv cA cort
      cfv cmd wbr cA cB cmd wbr cA cort cfv cB cort cfv cdmd wbr cB cch wcel cA
      cch wcel cB cA cdmd wbr cB cort cfv cA cort cfv cmd wbr wb mdslmd.2
      mdslmd.1 cB cA dmdmd mp2an cA cch wcel cB cch wcel cA cB cmd wbr cA cort
      cfv cB cort cfv cdmd wbr wb mdslmd.1 mdslmd.2 cA cB mddmd mp2an anbi12i
      bitri cA cC cD cin wss cC cD chj co cA cB chj co wss wa cC cD chj co cA
      cB chj co wss cA cC cD cin wss wa cB cort cfv cA cort cfv cin cC cort cfv
      cD cort cfv cin wss cC cort cfv cD cort cfv chj co cA cort cfv wss wa cA
      cC cD cin wss cC cD chj co cA cB chj co wss ancom cC cD chj co cA cB chj
      co wss cB cort cfv cA cort cfv cin cC cort cfv cD cort cfv cin wss cA cC
      cD cin wss cC cort cfv cD cort cfv chj co cA cort cfv wss cC cD chj co cA
      cB chj co wss cA cB chj co cort cfv cC cD chj co cort cfv wss cB cort cfv
      cA cort cfv cin cC cort cfv cD cort cfv cin wss cC cD chj co cA cB chj co
      cC cD mdslmd.3 mdslmd.4 chjcli cA cB mdslmd.1 mdslmd.2 chjcli chsscon3i
      cA cB chj co cort cfv cB cort cfv cA cort cfv cin cC cD chj co cort cfv
      cC cort cfv cD cort cfv cin cA cB chj co cort cfv cA cort cfv cB cort cfv
      cin cB cort cfv cA cort cfv cin cA cB mdslmd.1 mdslmd.2 chdmj1i cA cort
      cfv cB cort cfv incom eqtri cC cD mdslmd.3 mdslmd.4 chdmj1i sseq12i bitri
      cA cC cD cin wss cC cD cin cort cfv cA cort cfv wss cC cort cfv cD cort
      cfv chj co cA cort cfv wss cA cC cD cin mdslmd.1 cC cD mdslmd.3 mdslmd.4
      chincli chsscon3i cC cD cin cort cfv cC cort cfv cD cort cfv chj co cA
      cort cfv cC cD mdslmd.3 mdslmd.4 chdmm1i sseq1i bitri anbi12i bitri
      anbi12i cC cD cdmd wbr cC cort cfv cD cort cfv cmd wbr cC cB cin cD cB
      cin cdmd wbr cC cort cfv cB cort cfv chj co cD cort cfv cB cort cfv chj
      co cmd wbr cC cch wcel cD cch wcel cC cD cdmd wbr cC cort cfv cD cort cfv
      cmd wbr wb mdslmd.3 mdslmd.4 cC cD dmdmd mp2an cC cB cin cD cB cin cdmd
      wbr cC cB cin cort cfv cD cB cin cort cfv cmd wbr cC cort cfv cB cort cfv
      chj co cD cort cfv cB cort cfv chj co cmd wbr cC cB cin cch wcel cD cB
      cin cch wcel cC cB cin cD cB cin cdmd wbr cC cB cin cort cfv cD cB cin
      cort cfv cmd wbr wb cC cB mdslmd.3 mdslmd.2 chincli cD cB mdslmd.4
      mdslmd.2 chincli cC cB cin cD cB cin dmdmd mp2an cC cB cin cort cfv cC
      cort cfv cB cort cfv chj co cD cB cin cort cfv cD cort cfv cB cort cfv
      chj co cmd cC cB mdslmd.3 mdslmd.2 chdmm1i cD cB mdslmd.4 mdslmd.2
      chdmm1i breq12i bitri bibi12i 3imtr4i $.
      $( [8-Jun-2006] $) $( [29-Apr-2006] $)

    $( Modular pair conditions that imply the modular pair property in a
       sublattice.  Lemma 1.5.1 of [MaedaMaeda] p. 2. $)
    mdslmd3i $p |- ( ( ( A MH B /\ ( A i^i B ) MH C ) /\ ( ( A i^i C ) C_ D /\
                  D C_ A ) ) -> D MH ( B i^i C ) ) $=
      cA cB cmd wbr cA cB cin cC cmd wbr wa cA cC cin cD wss cD cA wss wa wa vx
      cv cB cC cin wss vx cv cD chj co cB cC cin cin vx cv cD cB cC cin cin chj
      co wss wi vx cch wral cD cB cC cin cmd wbr cA cB cmd wbr cA cB cin cC cmd
      wbr wa cA cC cin cD wss cD cA wss wa wa vx cv cB cC cin wss vx cv cD chj
      co cB cC cin cin vx cv cD cB cC cin cin chj co wss wi vx cch cA cB cmd
      wbr cA cB cin cC cmd wbr wa cA cC cin cD wss cD cA wss wa wa vx cv cch
      wcel wa vx cv cB cC cin wss vx cv cD chj co cB cC cin cin vx cv cD cB cC
      cin cin chj co wss cA cB cmd wbr cA cB cin cC cmd wbr wa cA cC cin cD wss
      cD cA wss wa wa vx cv cch wcel wa vx cv cB cC cin wss wa vx cv cD chj co
      cB cC cin cin vx cv cA chj co cB cC cin cin vx cv cD cB cC cin cin chj co
      cA cB cmd wbr cA cB cin cC cmd wbr wa cA cC cin cD wss cD cA wss wa wa vx
      cv cch wcel wa vx cv cD chj co cB cC cin cin vx cv cA chj co cB cC cin
      cin wss vx cv cB cC cin wss cA cC cin cD wss cD cA wss wa vx cv cch wcel
      vx cv cD chj co cB cC cin cin vx cv cA chj co cB cC cin cin wss cA cB cmd
      wbr cA cB cin cC cmd wbr wa cD cA wss vx cv cch wcel vx cv cD chj co cB
      cC cin cin vx cv cA chj co cB cC cin cin wss cA cC cin cD wss cD cA wss
      vx cv cch wcel wa vx cv cD chj co vx cv cA chj co wss vx cv cD chj co cB
      cC cin cin vx cv cA chj co cB cC cin cin wss vx cv cch wcel cD cA wss vx
      cv cD chj co vx cv cA chj co wss cD cch wcel cA cch wcel vx cv cch wcel
      cD cA wss vx cv cD chj co vx cv cA chj co wss wi mdslmd.4 mdslmd.1 cD cch
      wcel cA cch wcel vx cv cch wcel w3a cD cA wss vx cv cD chj co vx cv cA
      chj co wss cD cA vx cv chlej2 ex mp3an12 impcom vx cv cD chj co vx cv cA
      chj co cB cC cin ssrin syl adantll adantll adantr cA cB cmd wbr cA cB cin
      cC cmd wbr wa cA cC cin cD wss cD cA wss wa wa vx cv cch wcel wa vx cv cB
      cC cin wss wa vx cv cA chj co cB cC cin cin vx cv cA cB cC cin cin chj co
      vx cv cD cB cC cin cin chj co cA cB cmd wbr cA cB cin cC cmd wbr wa vx cv
      cch wcel vx cv cB cC cin wss vx cv cA chj co cB cC cin cin vx cv cA cB cC
      cin cin chj co wceq cA cC cin cD wss cD cA wss wa cA cB cmd wbr cA cB cin
      cC cmd wbr wa vx cv cch wcel wa vx cv cB wss vx cv cC wss wa vx cv cA chj
      co cB cC cin cin vx cv cA cB cC cin cin chj co wceq vx cv cB cC cin wss
      cA cB cmd wbr cA cB cin cC cmd wbr wa vx cv cB wss vx cv cC wss wa vx cv
      cch wcel vx cv cA chj co cB cC cin cin vx cv cA cB cC cin cin chj co wceq
      vx cv cch wcel cA cB cmd wbr cA cB cin cC cmd wbr wa vx cv cB wss vx cv
      cC wss wa wa vx cv cA chj co cB cC cin cin vx cv cA cB cC cin cin chj co
      wceq vx cv cch wcel cA cB cmd wbr cA cB cin cC cmd wbr wa vx cv cB wss vx
      cv cC wss wa wa wa vx cv cA chj co cB cC cin cin vx cv cA cB cin chj co
      cC cin vx cv cA cB cC cin cin chj co vx cv cch wcel cA cB cmd wbr cA cB
      cin cC cmd wbr wa vx cv cB wss vx cv cA chj co cB cC cin cin vx cv cA cB
      cin chj co cC cin wceq vx cv cC wss vx cv cch wcel cA cB cmd wbr vx cv cB
      wss vx cv cA chj co cB cC cin cin vx cv cA cB cin chj co cC cin wceq cA
      cB cin cC cmd wbr vx cv cch wcel cA cB cmd wbr vx cv cB wss wa wa vx cv
      cA chj co cB cin cC cin vx cv cA cB cin chj co cC cin vx cv cA chj co cB
      cC cin cin vx cv cch wcel cA cB cmd wbr vx cv cB wss wa wa vx cv cA chj
      co cB cin vx cv cA cB cin chj co cC cB cch wcel vx cv cch wcel cA cB cmd
      wbr vx cv cB wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co wceq
      mdslmd.2 cA cch wcel cB cch wcel vx cv cch wcel cA cB cmd wbr vx cv cB
      wss wa vx cv cA chj co cB cin vx cv cA cB cin chj co wceq mdslmd.1 cA cB
      vx cv mdi mp3anl1 mpanl1 ineq1d vx cv cA chj co cB cC inass syl5eqr
      adantrlr adantrrr vx cv cch wcel cA cB cmd wbr cA cB cin cC cmd wbr wa vx
      cv cC wss vx cv cA cB cin chj co cC cin vx cv cA cB cC cin cin chj co
      wceq vx cv cB wss vx cv cch wcel cA cB cin cC cmd wbr vx cv cC wss vx cv
      cA cB cin chj co cC cin vx cv cA cB cC cin cin chj co wceq cA cB cmd wbr
      vx cv cch wcel cA cB cin cC cmd wbr vx cv cC wss wa wa vx cv cA cB cin
      chj co cC cin vx cv cA cB cin cC cin chj co vx cv cA cB cC cin cin chj co
      cC cch wcel vx cv cch wcel cA cB cin cC cmd wbr vx cv cC wss wa vx cv cA
      cB cin chj co cC cin vx cv cA cB cin cC cin chj co wceq mdslmd.3 cA cB
      cin cch wcel cC cch wcel vx cv cch wcel cA cB cin cC cmd wbr vx cv cC wss
      wa vx cv cA cB cin chj co cC cin vx cv cA cB cin cC cin chj co wceq cA cB
      mdslmd.1 mdslmd.2 chincli cA cB cin cC vx cv mdi mp3anl1 mpanl1 cA cB cin
      cC cin cA cB cC cin cin vx cv chj cA cB cC inass opreq2i syl6eq adantrll
      adantrrl eqtrd ancoms an1rs vx cv cB cC ssin sylan2br adantllr cA cB cmd
      wbr cA cB cin cC cmd wbr wa cA cC cin cD wss cD cA wss wa wa vx cv cA cB
      cC cin cin chj co vx cv cD cB cC cin cin chj co wceq vx cv cch wcel vx cv
      cB cC cin wss cA cC cin cD wss cD cA wss wa vx cv cA cB cC cin cin chj co
      vx cv cD cB cC cin cin chj co wceq cA cB cmd wbr cA cB cin cC cmd wbr wa
      cA cC cin cD wss cD cA wss wa cA cB cC cin cin cD cB cC cin cin vx cv chj
      cA cC cin cD wss cD cA wss wa cA cB cC cin cin cD cB cC cin cin wss cD cB
      cC cin cin cA cB cC cin cin wss wa cA cB cC cin cin cD cB cC cin cin wceq
      cA cC cin cD wss cA cB cC cin cin cD cB cC cin cin wss cD cA wss cD cB cC
      cin cin cA cB cC cin cin wss cA cC cin cD wss cA cC cin cB cC cin cin cD
      cB cC cin cin cA cB cC cin cin cA cC cin cD cB cC cin ssrin cA cC cin cB
      cC cin cin cA cC cB cC cin cin cin cA cB cC cin cin cA cC cB cC cin inass
      cC cB cC cin cin cB cC cin cA cC cB cC cin cin cB cC cC cin cin cB cC cin
      cC cB cC in12 cC cC cin cC cB cC inidm ineq2i eqtri ineq2i eqtr2i syl5ss
      cD cA cB cC cin ssrin anim12i cA cB cC cin cin cD cB cC cin cin eqss
      sylibr opreq2d adantl ad2antrr eqtrd sseqtrd ex r19.21aiva cD cch wcel cB
      cC cin cch wcel cD cB cC cin cmd wbr vx cv cB cC cin wss vx cv cD chj co
      cB cC cin cin vx cv cD cB cC cin cin chj co wss wi vx cch wral wb
      mdslmd.4 cB cC mdslmd.2 mdslmd.3 chincli vx cD cB cC cin mdbr2 mp2an
      sylibr $.
      $( [24-Dec-2006] $) $( [23-Dec-2006] $)

    $( Modular pair condition that implies the modular pair property in a
       sublattice.  Lemma 1.5.2 of [MaedaMaeda] p. 2. $)
    mdslmd4i $p |- ( ( A MH B /\ ( ( A i^i B ) C_ C /\ C C_ A ) /\
                  ( ( A i^i B ) C_ D /\ D C_ B ) ) -> C MH D ) $=
      cA cB cmd wbr cA cB cin cC wss cC cA wss wa cA cB cin cD wss cD cB wss wa
      w3a cC cB cD cin cD cmd cA cB cmd wbr cA cB cin cD cmd wbr cA cD cin cC
      wss cC cA wss cC cB cD cin cmd wbr cA cB cmd wbr cA cB cin cC wss cC cA
      wss wa cA cB cin cD wss cD cB wss wa w3a cA cB cD cC mdslmd.1 mdslmd.2
      mdslmd.4 mdslmd.3 mdslmd3i cA cB cmd wbr cA cB cin cC wss cC cA wss wa cA
      cB cin cD wss cD cB wss wa 3simp1 cA cB cin cD wss cD cB wss wa cA cB cmd
      wbr cA cB cin cD cmd wbr cA cB cin cC wss cC cA wss wa cA cB cin cD wss
      cA cB cin cD cmd wbr cD cB wss cA cB cin cch wcel cD cch wcel cA cB cin
      cD wss cA cB cin cD cmd wbr cA cB mdslmd.1 mdslmd.2 chincli mdslmd.4 cA
      cB cin cD ssmd1 mp3an12 adantr 3ad2ant3 cA cB cin cC wss cC cA wss wa cA
      cB cin cD wss cD cB wss wa cA cD cin cC wss cA cB cmd wbr cA cB cin cC
      wss cD cB wss cA cD cin cC wss cC cA wss cA cB cin cD wss cD cB wss cA cB
      cin cC wss cA cD cin cC wss cA cD cin cA cB cin wss cA cB cin cC wss cA
      cD cin cC wss cD cB wss cA cD cin cA cB cin cC sstr cD cB cA sslin sylan
      ancoms ad2ant2rl 3adant1 cA cB cin cC wss cC cA wss wa cA cB cmd wbr cC
      cA wss cA cB cin cD wss cD cB wss wa cA cB cin cC wss cC cA wss pm3.27
      3ad2ant2 syl2anc cA cB cin cD wss cD cB wss wa cA cB cmd wbr cB cD cin cD
      wceq cA cB cin cC wss cC cA wss wa cD cB wss cB cD cin cD wceq cA cB cin
      cD wss cD cB wss cB cD cin cD wceq cD cB sseqin2 biimpi adantl 3ad2ant3
      breqtrd $.
      $( [3-Jan-2007] $) $( [24-Dec-2006] $)
  $}

  ${
    $d x A $.  $d c x B $.
    csmdsym.1 $e |- A e. CH $.
    csmdsym.2 $e |- B e. CH $.
    $( Cross-symmetry implies M-symmetry.  Theorem 1.9.1 of [MaedaMaeda]
       p. 3. $)
    csmdsymi $p |- ( ( A. c e. CH ( c MH B -> B MH* c ) /\ A MH B ) ->
                   B MH A ) $=
      vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch wral cA cB cmd wbr wa cB cA
      cin vx cv wss vx cv cA wss wa vx cv cB chj co cA cin vx cv cB cA cin chj
      co wceq wi vx cch wral cB cA cmd wbr vc cv cB cmd wbr cB vc cv cdmd wbr
      wi vc cch wral cA cB cmd wbr wa cB cA cin vx cv wss vx cv cA wss wa vx cv
      cB chj co cA cin vx cv cB cA cin chj co wceq wi vx cch vc cv cB cmd wbr
      cB vc cv cdmd wbr wi vc cch wral cA cB cmd wbr wa vx cv cch wcel wa cA cB
      cin vx cv wss vx cv cA wss vx cv cB chj co cA cin vx cv cB cA cin chj co
      wceq cB cA cin vx cv wss vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch
      wral cA cB cmd wbr wa vx cv cch wcel wa cA cB cin vx cv wss vx cv cA wss
      wa vx cv cB chj co cA cin vx cv cB cA cin chj co wceq vc cv cB cmd wbr cB
      vc cv cdmd wbr wi vc cch wral cA cB cmd wbr wa vx cv cch wcel wa cA cB
      cin vx cv wss vx cv cA wss wa wa vx cv cB chj co cA cin cA cB vx cv chj
      co cin cA cB cin vx cv chj co vx cv cB cA cin chj co vx cv cch wcel vx cv
      cB chj co cA cin cA cB vx cv chj co cin wceq vc cv cB cmd wbr cB vc cv
      cdmd wbr wi vc cch wral cA cB cmd wbr wa cA cB cin vx cv wss vx cv cA wss
      wa vx cv cch wcel vx cv cB chj co cA cin cB vx cv chj co cA cin cA cB vx
      cv chj co cin vx cv cch wcel vx cv cB chj co cB vx cv chj co cA vx cv cch
      wcel cB cch wcel vx cv cB chj co cB vx cv chj co wceq csmdsym.2 vx cv cB
      chjcom mpan2 ineq1d cB vx cv chj co cA incom syl6eq ad2antlr cB cch wcel
      vx cv cch wcel cA cch wcel w3a cB vx cv cdmd wbr vx cv cA wss wa cA cB
      cin vx cv chj co cA cB vx cv chj co cin wceq vc cv cB cmd wbr cB vc cv
      cdmd wbr wi vc cch wral cA cB cmd wbr wa vx cv cch wcel wa cA cB cin vx
      cv wss vx cv cA wss wa wa cB vx cv cA dmdi vx cv cch wcel cB cch wcel vx
      cv cch wcel cA cch wcel w3a vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch
      wral cA cB cmd wbr wa cA cB cin vx cv wss vx cv cA wss wa vx cv cch wcel
      cB cch wcel vx cv cch wcel cA cch wcel cB cch wcel vx cv cch wcel
      csmdsym.2 a1i vx cv cch wcel id cA cch wcel vx cv cch wcel csmdsym.1 a1i
      3jca ad2antlr vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch wral cA cB cmd
      wbr wa vx cv cch wcel wa cA cB cin vx cv wss vx cv cA wss wa wa cB vx cv
      cdmd wbr vx cv cA wss vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch wral
      cA cB cmd wbr wa vx cv cch wcel wa cA cB cin vx cv wss vx cv cA wss wa wa
      vx cv cB cmd wbr cB vx cv cdmd wbr cA cB cmd wbr vx cv cch wcel cA cB cin
      vx cv wss vx cv cA wss wa vx cv cB cmd wbr vc cv cB cmd wbr cB vc cv cdmd
      wbr wi vc cch wral cA cB cmd wbr cA cB cin vx cv wss vx cv cA wss wa vx
      cv cch wcel vx cv cB cmd wbr cA cB cmd wbr cA cB cin vx cv wss vx cv cA
      wss wa wa vx cv cch wcel vx cv cB cmd wbr cA cB cmd wbr cA cB cin vx cv
      wss vx cv cA wss wa cA cB cin cB wss cB cB wss wa vx cv cch wcel vx cv cB
      cmd wbr wi cA cB cin cB wss cB cB wss cA cB inss2 cB ssid pm3.2i vx cv
      cch wcel cA cB cmd wbr cA cB cin vx cv wss vx cv cA wss wa cA cB cin cB
      wss cB cB wss wa w3a vx cv cB cmd wbr vx cv cch wcel cA cB cmd wbr cA cB
      cin vx cv wss vx cv cA wss wa cA cB cin cB wss cB cB wss wa w3a vx cv cB
      cmd wbr wi cA cB cmd wbr cA cB cin vx cv cch wcel vx cv c0h cif wss vx cv
      cch wcel vx cv c0h cif cA wss wa cA cB cin cB wss cB cB wss wa w3a vx cv
      cch wcel vx cv c0h cif cB cmd wbr wi vx cv c0h vx cv vx cv cch wcel vx cv
      c0h cif wceq cA cB cmd wbr cA cB cin vx cv wss vx cv cA wss wa cA cB cin
      cB wss cB cB wss wa w3a cA cB cmd wbr cA cB cin vx cv cch wcel vx cv c0h
      cif wss vx cv cch wcel vx cv c0h cif cA wss wa cA cB cin cB wss cB cB wss
      wa w3a vx cv cB cmd wbr vx cv cch wcel vx cv c0h cif cB cmd wbr vx cv vx
      cv cch wcel vx cv c0h cif wceq cA cB cin vx cv wss vx cv cA wss wa cA cB
      cin vx cv cch wcel vx cv c0h cif wss vx cv cch wcel vx cv c0h cif cA wss
      wa cA cB cmd wbr cA cB cin cB wss cB cB wss wa vx cv vx cv cch wcel vx cv
      c0h cif wceq cA cB cin vx cv wss cA cB cin vx cv cch wcel vx cv c0h cif
      wss vx cv cA wss vx cv cch wcel vx cv c0h cif cA wss vx cv vx cv cch wcel
      vx cv c0h cif cA cB cin sseq2 vx cv vx cv cch wcel vx cv c0h cif cA sseq1
      anbi12d 3anbi2d vx cv vx cv cch wcel vx cv c0h cif cB cmd breq1 imbi12d
      cA cB vx cv cch wcel vx cv c0h cif cB csmdsym.1 csmdsym.2 vx cv c0h cch
      h0elch elimel csmdsym.2 mdslmd4i dedth com12 mp3an3 imp an1rs adantlll vc
      cv cB cmd wbr cB vc cv cdmd wbr wi vc cch wral cA cB cmd wbr wa vx cv cch
      wcel wa vx cv cB cmd wbr cB vx cv cdmd wbr wi cA cB cin vx cv wss vx cv
      cA wss wa vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch wral vx cv cch
      wcel vx cv cB cmd wbr cB vx cv cdmd wbr wi cA cB cmd wbr vc cv cB cmd wbr
      cB vc cv cdmd wbr wi vx cv cB cmd wbr cB vx cv cdmd wbr wi vc vx cv cch
      vc cv vx cv wceq vc cv cB cmd wbr vx cv cB cmd wbr cB vc cv cdmd wbr cB
      vx cv cdmd wbr vc cv vx cv cB cmd breq1 vc cv vx cv cB cdmd breq2 imbi12d
      rcla4cva adantlr adantr mpd vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch
      wral cA cB cmd wbr wa vx cv cch wcel wa cA cB cin vx cv wss vx cv cA wss
      simprr jca sylanc vx cv cch wcel cA cB cin vx cv chj co vx cv cB cA cin
      chj co wceq vc cv cB cmd wbr cB vc cv cdmd wbr wi vc cch wral cA cB cmd
      wbr wa cA cB cin vx cv wss vx cv cA wss wa vx cv cch wcel cA cB cin vx cv
      chj co vx cv cA cB cin chj co vx cv cB cA cin chj co cA cB cin cch wcel
      vx cv cch wcel cA cB cin vx cv chj co vx cv cA cB cin chj co wceq cA cB
      csmdsym.1 csmdsym.2 chincli cA cB cin vx cv chjcom mpan cA cB cin cB cA
      cin vx cv chj cA cB incom opreq2i syl6eq ad2antlr 3eqtr2d ex cA cB cin vx
      cv wss cB cA cin vx cv wss cA cB cin cB cA cin vx cv cA cB incom sseq1i
      biimpri sylani r19.21aiva vx cB cA csmdsym.2 csmdsym.1 mdsl2bi sylibr $.
      $( [15-Jan-2007] $) $( [24-Dec-2006] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    mdexch.1 $e |- A e. CH $.
    mdexch.2 $e |- B e. CH $.
    mdexch.3 $e |- C e. CH $.
    $( An exchange lemma for modular pairs.  Lemma 1.6 of [MaedaMaeda] p. 2. $)
    mdexchi $p |- ( ( A MH B /\ C MH ( A vH B ) /\ ( C i^i ( A vH B ) ) C_ A )
      -> ( ( C vH A ) MH B /\ ( ( C vH A ) i^i B ) = ( A i^i B ) ) ) $=
      cA cB cmd wbr cC cA cB chj co cmd wbr cC cA cB chj co cin cA wss w3a cC
      cA chj co cB cmd wbr cC cA chj co cB cin cA cB cin wceq cA cB cmd wbr cC
      cA cB chj co cmd wbr cC cA cB chj co cin cA wss w3a vx cv cB wss vx cv cC
      cA chj co chj co cB cin vx cv cC cA chj co cB cin chj co wss wi vx cch
      wral cC cA chj co cB cmd wbr cA cB cmd wbr cC cA cB chj co cmd wbr cC cA
      cB chj co cin cA wss w3a vx cv cB wss vx cv cC cA chj co chj co cB cin vx
      cv cC cA chj co cB cin chj co wss wi vx cch cA cB cmd wbr cC cA cB chj co
      cmd wbr cC cA cB chj co cin cA wss vx cv cch wcel vx cv cB wss vx cv cC
      cA chj co chj co cB cin vx cv cC cA chj co cB cin chj co wss wi wi vx cv
      cch wcel vx cv cB wss cA cB cmd wbr cC cA cB chj co cmd wbr cC cA cB chj
      co cin cA wss wa wa vx cv cC cA chj co chj co cB cin vx cv cC cA chj co
      cB cin chj co wss vx cv cch wcel vx cv cB wss cA cB cmd wbr cC cA cB chj
      co cmd wbr cC cA cB chj co cin cA wss wa wa vx cv cC cA chj co chj co cB
      cin vx cv cC cA chj co cB cin chj co wss vx cv cch wcel vx cv cB wss wa
      cA cB cmd wbr cC cA cB chj co cmd wbr cC cA cB chj co cin cA wss wa wa wa
      vx cv cC cA chj co chj co cB cin vx cv cA chj co cB cin vx cv cC cA chj
      co cB cin chj co vx cv cch wcel vx cv cB wss wa cC cA cB chj co cmd wbr
      cC cA cB chj co cin cA wss wa vx cv cC cA chj co chj co cB cin vx cv cA
      chj co cB cin wss cA cB cmd wbr vx cv cch wcel vx cv cB wss wa cC cA cB
      chj co cmd wbr cC cA cB chj co cin cA wss wa wa vx cv cC cA chj co chj co
      cB cin cA vx cv chj co cC chj co cA cB chj co cin cB cin vx cv cA chj co
      cB cin vx cv cch wcel vx cv cC cA chj co chj co cB cin cA vx cv chj co cC
      chj co cA cB chj co cin cB cin wceq vx cv cB wss cC cA cB chj co cmd wbr
      cC cA cB chj co cin cA wss wa vx cv cch wcel vx cv cC cA chj co chj co cB
      cin cA vx cv chj co cC chj co cB cin cA vx cv chj co cC chj co cA cB chj
      co cin cB cin vx cv cch wcel vx cv cC cA chj co chj co cA vx cv chj co cC
      chj co cB vx cv cch wcel cC cA chj co vx cv chj co cC cA vx cv chj co chj
      co vx cv cC cA chj co chj co cA vx cv chj co cC chj co cC cch wcel cA cch
      wcel vx cv cch wcel cC cA chj co vx cv chj co cC cA vx cv chj co chj co
      wceq mdexch.3 mdexch.1 cC cA vx cv chjass mp3an12 vx cv cch wcel cC cA
      chj co cch wcel vx cv cC cA chj co chj co cC cA chj co vx cv chj co wceq
      cC cA mdexch.3 mdexch.1 chjcli vx cv cC cA chj co chjcom mpan2 vx cv cch
      wcel cA vx cv chj co cch wcel cA vx cv chj co cC chj co cC cA vx cv chj
      co chj co wceq cA cch wcel vx cv cch wcel cA vx cv chj co cch wcel
      mdexch.1 cA vx cv chjcl mpan cA vx cv chj co cch wcel cC cch wcel cA vx
      cv chj co cC chj co cC cA vx cv chj co chj co wceq mdexch.3 cA vx cv chj
      co cC chjcom mpan2 syl 3eqtr4d ineq1d cA vx cv chj co cC chj co cA cB chj
      co cin cB cin cA vx cv chj co cC chj co cA cB chj co cB cin cin cA vx cv
      chj co cC chj co cB cin cA vx cv chj co cC chj co cA cB chj co cB inass
      cA cB chj co cB cin cB cA vx cv chj co cC chj co cA cB chj co cB cin cB
      cA cB chj co cin cB cB cA chj co cin cB cA cB chj co cB incom cA cB chj
      co cB cA chj co cB cA cB mdexch.1 mdexch.2 chjcomi ineq2i cB cA mdexch.2
      mdexch.1 chabs2i 3eqtri ineq2i eqtri syl6eqr ad2antrr vx cv cch wcel vx
      cv cB wss wa cC cA cB chj co cmd wbr cC cA cB chj co cin cA wss wa wa cA
      vx cv chj co cC chj co cA cB chj co cin vx cv cA chj co wss cA vx cv chj
      co cC chj co cA cB chj co cin cB cin vx cv cA chj co cB cin wss vx cv cch
      wcel vx cv cB wss wa cC cA cB chj co cmd wbr cC cA cB chj co cin cA wss
      wa wa cA vx cv chj co cC chj co cA cB chj co cin cA vx cv chj co cC cA cB
      chj co cin chj co vx cv cA chj co vx cv cch wcel vx cv cB wss wa cC cA cB
      chj co cmd wbr cA vx cv chj co cC chj co cA cB chj co cin cA vx cv chj co
      cC cA cB chj co cin chj co wceq cC cA cB chj co cin cA wss vx cv cch wcel
      vx cv cB wss cC cA cB chj co cmd wbr cA vx cv chj co cC chj co cA cB chj
      co cin cA vx cv chj co cC cA cB chj co cin chj co wceq vx cv cch wcel vx
      cv cB wss cA vx cv chj co cA cB chj co wss cC cA cB chj co cmd wbr cA vx
      cv chj co cC chj co cA cB chj co cin cA vx cv chj co cC cA cB chj co cin
      chj co wceq wi vx cv cch wcel cB cch wcel cA cch wcel vx cv cB wss cA vx
      cv chj co cA cB chj co wss wi mdexch.2 mdexch.1 vx cv cch wcel cB cch
      wcel cA cch wcel w3a vx cv cB wss cA vx cv chj co cA cB chj co wss vx cv
      cB cA chlej2 ex mp3an23 vx cv cch wcel cC cA cB chj co cmd wbr cA vx cv
      chj co cA cB chj co wss cA vx cv chj co cC chj co cA cB chj co cin cA vx
      cv chj co cC cA cB chj co cin chj co wceq vx cv cch wcel cA vx cv chj co
      cch wcel cC cA cB chj co cmd wbr cA vx cv chj co cA cB chj co wss cA vx
      cv chj co cC chj co cA cB chj co cin cA vx cv chj co cC cA cB chj co cin
      chj co wceq wi wi cA cch wcel vx cv cch wcel cA vx cv chj co cch wcel
      mdexch.1 cA vx cv chjcl mpan cC cch wcel cA cB chj co cch wcel cA vx cv
      chj co cch wcel cC cA cB chj co cmd wbr cA vx cv chj co cA cB chj co wss
      cA vx cv chj co cC chj co cA cB chj co cin cA vx cv chj co cC cA cB chj
      co cin chj co wceq wi wi mdexch.3 cA cB mdexch.1 mdexch.2 chjcli cC cch
      wcel cA cB chj co cch wcel cA vx cv chj co cch wcel w3a cC cA cB chj co
      cmd wbr cA vx cv chj co cA cB chj co wss cA vx cv chj co cC chj co cA cB
      chj co cin cA vx cv chj co cC cA cB chj co cin chj co wceq cC cA cB chj
      co cA vx cv chj co mdi exp32 mp3an12 syl com23 syld imp31 adantrr vx cv
      cch wcel cC cA cB chj co cin cA wss cA vx cv chj co cC cA cB chj co cin
      chj co vx cv cA chj co wss vx cv cB wss cC cA cB chj co cmd wbr vx cv cch
      wcel cC cA cB chj co cin cA wss wa cA vx cv chj co cC cA cB chj co cin
      chj co cA vx cv chj co cA chj co vx cv cA chj co vx cv cch wcel cC cA cB
      chj co cin cA wss cA vx cv chj co cC cA cB chj co cin chj co cA vx cv chj
      co cA chj co wss vx cv cch wcel cA vx cv chj co cch wcel cC cA cB chj co
      cin cA wss cA vx cv chj co cC cA cB chj co cin chj co cA vx cv chj co cA
      chj co wss wi cA cch wcel vx cv cch wcel cA vx cv chj co cch wcel
      mdexch.1 cA vx cv chjcl mpan cC cA cB chj co cin cch wcel cA cch wcel cA
      vx cv chj co cch wcel cC cA cB chj co cin cA wss cA vx cv chj co cC cA cB
      chj co cin chj co cA vx cv chj co cA chj co wss wi cC cA cB chj co
      mdexch.3 cA cB mdexch.1 mdexch.2 chjcli chincli mdexch.1 cC cA cB chj co
      cin cch wcel cA cch wcel cA vx cv chj co cch wcel w3a cC cA cB chj co cin
      cA wss cA vx cv chj co cC cA cB chj co cin chj co cA vx cv chj co cA chj
      co wss cC cA cB chj co cin cA cA vx cv chj co chlej2 ex mp3an12 syl imp
      vx cv cch wcel cA vx cv chj co cA chj co vx cv cA chj co wceq cC cA cB
      chj co cin cA wss vx cv cch wcel cA vx cv chj co cA chj co cA cA vx cv
      chj co chj co cA vx cv chj co vx cv cA chj co vx cv cch wcel cA vx cv chj
      co cch wcel cA vx cv chj co cA chj co cA cA vx cv chj co chj co wceq cA
      cch wcel vx cv cch wcel cA vx cv chj co cch wcel mdexch.1 cA vx cv chjcl
      mpan cA vx cv chj co cch wcel cA cch wcel cA vx cv chj co cA chj co cA cA
      vx cv chj co chj co wceq mdexch.1 cA vx cv chj co cA chjcom mpan2 syl vx
      cv cch wcel cA cA chj co vx cv chj co cA cA vx cv chj co chj co cA vx cv
      chj co cA cch wcel cA cch wcel vx cv cch wcel cA cA chj co vx cv chj co
      cA cA vx cv chj co chj co wceq mdexch.1 mdexch.1 cA cA vx cv chjass
      mp3an12 cA cA chj co cA vx cv chj cA mdexch.1 chjidmi opreq1i syl5reqr cA
      cch wcel vx cv cch wcel cA vx cv chj co vx cv cA chj co wceq mdexch.1 cA
      vx cv chjcom mpan 3eqtrd adantr sseqtrd ad2ant2rl eqsstrd cA vx cv chj co
      cC chj co cA cB chj co cin vx cv cA chj co cB ssrin syl eqsstrd adantrl
      vx cv cch wcel vx cv cB wss wa cA cB cmd wbr vx cv cA chj co cB cin vx cv
      cC cA chj co cB cin chj co wss cC cA cB chj co cmd wbr cC cA cB chj co
      cin cA wss wa vx cv cch wcel vx cv cB wss wa cA cB cmd wbr wa vx cv cA
      chj co cB cin vx cv cA cB cin chj co vx cv cC cA chj co cB cin chj co vx
      cv cch wcel vx cv cB wss cA cB cmd wbr vx cv cA chj co cB cin vx cv cA cB
      cin chj co wceq vx cv cch wcel cA cB cmd wbr vx cv cB wss vx cv cA chj co
      cB cin vx cv cA cB cin chj co wceq cA cch wcel cB cch wcel vx cv cch wcel
      cA cB cmd wbr vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq wi wi mdexch.1 mdexch.2 cA cch wcel cB cch wcel vx cv cch wcel w3a
      cA cB cmd wbr vx cv cB wss vx cv cA chj co cB cin vx cv cA cB cin chj co
      wceq cA cB vx cv mdi exp32 mp3an12 com23 imp31 vx cv cch wcel vx cv cA cB
      cin chj co vx cv cC cA chj co cB cin chj co wss vx cv cB wss cA cB cmd
      wbr vx cv cch wcel cA cB cin cC cA chj co cB cin wss vx cv cA cB cin chj
      co vx cv cC cA chj co cB cin chj co wss cA cC cA chj co wss cA cB cin cC
      cA chj co cB cin wss cA cC mdexch.1 mdexch.3 chub2i cA cC cA chj co cB
      ssrin ax-mp cA cB cin cch wcel cC cA chj co cB cin cch wcel vx cv cch
      wcel cA cB cin cC cA chj co cB cin wss vx cv cA cB cin chj co vx cv cC cA
      chj co cB cin chj co wss wi cA cB mdexch.1 mdexch.2 chincli cC cA chj co
      cB cC cA mdexch.3 mdexch.1 chjcli mdexch.2 chincli cA cB cin cch wcel cC
      cA chj co cB cin cch wcel vx cv cch wcel w3a cA cB cin cC cA chj co cB
      cin wss vx cv cA cB cin chj co vx cv cC cA chj co cB cin chj co wss cA cB
      cin cC cA chj co cB cin vx cv chlej2 ex mp3an12 mpi ad2antrr eqsstrd
      adantrr sstrd exp31 com3r 3impb r19.21aiv cC cA chj co cch wcel cB cch
      wcel cC cA chj co cB cmd wbr vx cv cB wss vx cv cC cA chj co chj co cB
      cin vx cv cC cA chj co cB cin chj co wss wi vx cch wral wb cC cA mdexch.3
      mdexch.1 chjcli mdexch.2 vx cC cA chj co cB mdbr2 mp2an sylibr cC cA cB
      chj co cmd wbr cC cA cB chj co cin cA wss cC cA chj co cB cin cA cB cin
      wceq cA cB cmd wbr cC cA cB chj co cmd wbr cC cA cB chj co cin cA wss wa
      cA cC chj co cA cB chj co cB cin cin cA cB cin cC cA chj co cB cin cC cA
      cB chj co cmd wbr cC cA cB chj co cin cA wss wa cA cC chj co cA cB chj co
      cin cB cin cA cB cin cA cC chj co cA cB chj co cB cin cin cC cA cB chj co
      cmd wbr cC cA cB chj co cin cA wss wa cA cC chj co cA cB chj co cin cA cB
      cC cA cB chj co cmd wbr cC cA cB chj co cin cA wss cA cC chj co cA cB chj
      co cin cA cC cA cB chj co cin chj co cA cC cA cB chj co cmd wbr cA cA cB
      chj co wss cA cC chj co cA cB chj co cin cA cC cA cB chj co cin chj co
      wceq cA cB mdexch.1 mdexch.2 chub1i cC cch wcel cA cB chj co cch wcel cA
      cch wcel cC cA cB chj co cmd wbr cA cA cB chj co wss cA cC chj co cA cB
      chj co cin cA cC cA cB chj co cin chj co wceq wi wi mdexch.3 cA cB
      mdexch.1 mdexch.2 chjcli mdexch.1 cC cch wcel cA cB chj co cch wcel cA
      cch wcel w3a cC cA cB chj co cmd wbr cA cA cB chj co wss cA cC chj co cA
      cB chj co cin cA cC cA cB chj co cin chj co wceq cC cA cB chj co cA mdi
      exp32 mp3an mpi cC cA cB chj co cin cA wss cC cA cB chj co cin cA chj co
      cA cA cC cA cB chj co cin chj co cC cA cB chj co cin cA wss cC cA cB chj
      co cin cA chj co cA wceq cC cA cB chj co cin cA cC cA cB chj co mdexch.3
      cA cB mdexch.1 mdexch.2 chjcli chincli mdexch.1 chlejb1i biimpi cA cC cA
      cB chj co cin mdexch.1 cC cA cB chj co mdexch.3 cA cB mdexch.1 mdexch.2
      chjcli chincli chjcomi syl5eq sylan9eq ineq1d cA cC chj co cA cB chj co
      cB inass syl5eqr cC cA chj co cA cC chj co cB cA cB chj co cB cin cC cA
      mdexch.3 mdexch.1 chjcomi cB cA cB chj co cin cB cB cA chj co cin cA cB
      chj co cB cin cB cA cB chj co cB cA chj co cB cA cB mdexch.1 mdexch.2
      chjcomi ineq2i cB cA cB chj co incom cB cA mdexch.2 mdexch.1 chabs2i
      3eqtr3ri ineq12i syl5eq 3adant1 jca $.
      $( [21-Feb-2005] $) $( [22-Jun-2004] $)
  $}

  $( The covering property implies the modular pair property.  Lemma 7.5.1 of
     [MaedaMaeda] p. 31. $)
  cvmd $p |- ( ( A e. CH /\ B e. CH /\ ( A i^i B ) <o B ) -> A MH B ) $=
    cA cch wcel cB cch wcel cA cB cin cB ccv wbr cA cB cmd wbr cA cch wcel cB
    cch wcel cA cB cin cB ccv wbr cA cB cmd wbr wi cA cch wcel cA chil cif cB
    cin cB ccv wbr cA cch wcel cA chil cif cB cmd wbr wi cA cch wcel cA chil
    cif cB cch wcel cB chil cif cin cB cch wcel cB chil cif ccv wbr cA cch wcel
    cA chil cif cB cch wcel cB chil cif cmd wbr wi cA cB chil chil cA cA cch
    wcel cA chil cif wceq cA cB cin cB ccv wbr cA cch wcel cA chil cif cB cin
    cB ccv wbr cA cB cmd wbr cA cch wcel cA chil cif cB cmd wbr cA cA cch wcel
    cA chil cif wceq cA cB cin cA cch wcel cA chil cif cB cin cB ccv cA cA cch
    wcel cA chil cif cB ineq1 breq1d cA cA cch wcel cA chil cif cB cmd breq1
    imbi12d cB cB cch wcel cB chil cif wceq cA cch wcel cA chil cif cB cin cB
    ccv wbr cA cch wcel cA chil cif cB cch wcel cB chil cif cin cB cch wcel cB
    chil cif ccv wbr cA cch wcel cA chil cif cB cmd wbr cA cch wcel cA chil cif
    cB cch wcel cB chil cif cmd wbr cB cB cch wcel cB chil cif wceq cA cch wcel
    cA chil cif cB cin cA cch wcel cA chil cif cB cch wcel cB chil cif cin cB
    cB cch wcel cB chil cif ccv cB cB cch wcel cB chil cif cA cch wcel cA chil
    cif ineq2 cB cB cch wcel cB chil cif wceq id breq12d cB cB cch wcel cB chil
    cif cA cch wcel cA chil cif cmd breq2 imbi12d cA cch wcel cA chil cif cB
    cch wcel cB chil cif cA chil cch helch elimel cB chil cch helch elimel
    cvmdi dedth2h 3impia $.
    $( [25-Jul-2007] $) $( [21-Jun-2004] $)

  $( The covering property implies the dual modular pair property.  Lemma
     7.5.2 of [MaedaMaeda] p. 31. $)
  cvdmd $p |- ( ( A e. CH /\ B e. CH /\ B <o ( A vH B ) ) -> A MH* B ) $=
    cA cch wcel cB cch wcel cB cA cB chj co ccv wbr cA cB cdmd wbr cA cch wcel
    cB cch wcel wa cA cort cfv cB cort cfv cin cB cort cfv ccv wbr cA cort cfv
    cB cort cfv cmd wbr cB cA cB chj co ccv wbr cA cB cdmd wbr cA cort cfv cch
    wcel cB cort cfv cch wcel cA cort cfv cB cort cfv cin cB cort cfv ccv wbr
    cA cort cfv cB cort cfv cmd wbr wi cA cch wcel cB cch wcel cA cort cfv cch
    wcel cB cort cfv cch wcel cA cort cfv cB cort cfv cin cB cort cfv ccv wbr
    cA cort cfv cB cort cfv cmd wbr cA cort cfv cB cort cfv cvmd 3expia cA
    choccl cB choccl syl2an cA cch wcel cB cch wcel wa cB cA cB chj co ccv wbr
    cA cB chj co cort cfv cB cort cfv ccv wbr cA cort cfv cB cort cfv cin cB
    cort cfv ccv wbr cB cch wcel cA cB chj co cch wcel cB cA cB chj co ccv wbr
    cA cB chj co cort cfv cB cort cfv ccv wbr wb cA cch wcel cB cch wcel wa cB
    cA cB chj co cvcon3 cA cch wcel cB cch wcel pm3.27 cA cB chjcl sylanc cA
    cch wcel cB cch wcel wa cA cB chj co cort cfv cA cort cfv cB cort cfv cin
    cB cort cfv ccv cA cB chdmj1 breq1d bitrd cA cB dmdmd 3imtr4d 3impia $.
    $( [27-Jul-2007] $) $( [21-Jun-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Atoms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Define the set of atoms in a Hilbert lattice.  An atom is a non-zero
       element of a lattice such that anything less than it is zero, i.e. it
       is a smallest non-zero element of the lattice.  Definition of atom in
       [Kalmbach] p. 15.  See ~ ela and ~ elat2 for membership relations. $)
    df-at $a |- Atoms = { x e. CH | 0H <o x } $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Atoms in a Hilbert lattice are the elements that cover the zero
       subspace.  Definition of atom in [Kalmbach] p. 15. $)
    ela $p |- ( A e. Atoms <-> ( A e. CH /\ 0H <o A ) ) $=
      c0h vx cv ccv wbr c0h cA ccv wbr vx cA cch cat vx cv cA c0h ccv breq2 vx
      df-at elrab2 $.
      $( [12-Jun-2004] $) $( [9-Jun-2004] $)

    $( Expanded membership relation for the set of atoms, i.e. the predicate
       "is an atom (of the Hilbert lattice)."  An atom is a non-zero element of
       a lattice such that anything less than it is zero, i.e. it is a smallest
       non-zero element of the lattice. $)
    elat2 $p |- ( A e. Atoms <-> ( A e. CH /\ ( A =/= 0H /\
                 A. x e. CH ( x C_ A -> ( x = A \/ x = 0H ) ) ) ) ) $=
      cA cat wcel cA cch wcel c0h cA ccv wbr wa cA cch wcel cA c0h wne vx cv cA
      wss vx cv cA wceq vx cv c0h wceq wo wi vx cch wral wa wa cA ela cA cch
      wcel cA c0h wne vx cv cA wss vx cv cA wceq vx cv c0h wceq wo wi vx cch
      wral wa c0h cA ccv wbr cA cch wcel c0h cA ccv wbr c0h cA wpss c0h vx cv
      wpss vx cv cA wss wa vx cv cA wceq wi vx cch wral wa cA c0h wne vx cv cA
      wss vx cv cA wceq vx cv c0h wceq wo wi vx cch wral wa c0h cch wcel cA cch
      wcel c0h cA ccv wbr c0h cA wpss c0h vx cv wpss vx cv cA wss wa vx cv cA
      wceq wi vx cch wral wa wb h0elch vx c0h cA cvbr2 mpan cA cch wcel c0h cA
      wpss cA c0h wne c0h vx cv wpss vx cv cA wss wa vx cv cA wceq wi vx cch
      wral vx cv cA wss vx cv cA wceq vx cv c0h wceq wo wi vx cch wral cA
      ch0pss c0h vx cv wpss vx cv cA wss wa vx cv cA wceq wi vx cch wral vx cv
      cA wss vx cv cA wceq vx cv c0h wceq wo wi vx cch wral wb cA cch wcel c0h
      vx cv wpss vx cv cA wss wa vx cv cA wceq wi vx cv cA wss vx cv cA wceq vx
      cv c0h wceq wo wi vx cch vx cv cch wcel vx cv cA wss c0h vx cv wpss vx cv
      cA wceq wi wi vx cv cA wss vx cv c0h wne vx cv cA wceq wi wi c0h vx cv
      wpss vx cv cA wss wa vx cv cA wceq wi vx cv cA wss vx cv cA wceq vx cv
      c0h wceq wo wi vx cv cch wcel c0h vx cv wpss vx cv cA wceq wi vx cv c0h
      wne vx cv cA wceq wi vx cv cA wss vx cv cch wcel c0h vx cv wpss vx cv c0h
      wne vx cv cA wceq vx cv ch0pss imbi1d imbi2d c0h vx cv wpss vx cv cA wss
      wa vx cv cA wceq wi c0h vx cv wpss vx cv cA wss vx cv cA wceq wi wi vx cv
      cA wss c0h vx cv wpss vx cv cA wceq wi wi c0h vx cv wpss vx cv cA wss vx
      cv cA wceq impexp c0h vx cv wpss vx cv cA wss vx cv cA wceq bi2.04 bitri
      vx cv cA wceq vx cv c0h wceq wo vx cv c0h wne vx cv cA wceq wi vx cv cA
      wss vx cv cA wceq vx cv c0h wceq wo vx cv c0h wceq vx cv cA wceq wo vx cv
      c0h wne vx cv cA wceq wi vx cv cA wceq vx cv c0h wceq orcom vx cv cA wceq
      vx cv c0h neor bitri imbi2i 3bitr4g ralbiia a1i anbi12d bitr2d pm5.32i
      bitr4i $.
      $( [18-Jun-2006] $) $( [9-Jun-2004] $)

    $( A Hilbert lattice element is an atom iff it covers the zero subspace. $)
    elatcv0 $p |- ( A e. CH -> ( A e. Atoms <-> 0H <o A ) ) $=
      cA cat wcel cA cch wcel c0h cA ccv wbr cA ela baib $.
      $( [14-Feb-2005] $) $( [26-Jun-2004] $)

    $( An atom covers the zero subspace. $)
    atcv0 $p |- ( A e. Atoms -> 0H <o A ) $=
      cA cat wcel cA cch wcel c0h cA ccv wbr cA ela pm3.27bi $.
      $( [22-Jul-2004] $) $( [26-Jun-2004] $)

    $( Atoms are a subset of the Hilbert lattice. $)
    atssch $p |- Atoms C_ CH $=
      cat c0h vx cv ccv wbr vx cch crab cch vx df-at c0h vx cv ccv wbr vx cch
      ssrab2 eqsstri $.
      $( [14-Aug-2002] $)

    $( An atom is a Hilbert lattice element. $)
    atelch $p |- ( A e. Atoms -> A e. CH ) $=
      cat cch cA atssch sseli $.
      $( [22-Jun-2004] $) $( [22-Jun-2004] $)

    $( An atom is not the Hilbert lattice zero. $)
    atn0 $p |- ( A e. Atoms -> A =/= 0H ) $=
      cA cat wcel cA cch wcel cA c0h wne vx cv cA wss vx cv cA wceq vx cv c0h
      wceq wo wi vx cch wral wa wa cA c0h wne vx cA elat2 cA cch wcel cA c0h
      wne vx cv cA wss vx cv cA wceq vx cv c0h wceq wo wi vx cch wral simprl
      sylbi $.
      $( [27-Jun-2006] $) $( [13-Aug-2002] $)

    $( A lattice element smaller than an atom is either the atom or zero. $)
    atss $p |- ( ( A e. CH /\ B e. Atoms ) ->
               ( A C_ B -> ( A = B \/ A = 0H ) ) ) $=
      cA cch wcel cB cch wcel cB c0h wne vx cv cB wss vx cv cB wceq vx cv c0h
      wceq wo wi vx cch wral wa wa cA cB wss cA cB wceq cA c0h wceq wo wi cB
      cat wcel cA cch wcel cB cch wcel cB c0h wne vx cv cB wss vx cv cB wceq vx
      cv c0h wceq wo wi vx cch wral wa wa cA cB wss cA cB wceq cA c0h wceq wo
      wi cA cch wcel cB c0h wne vx cv cB wss vx cv cB wceq vx cv c0h wceq wo wi
      vx cch wral wa cA cB wss cA cB wceq cA c0h wceq wo wi cB cch wcel cA cch
      wcel vx cv cB wss vx cv cB wceq vx cv c0h wceq wo wi vx cch wral cA cB
      wss cA cB wceq cA c0h wceq wo wi cB c0h wne vx cv cB wss vx cv cB wceq vx
      cv c0h wceq wo wi cA cB wss cA cB wceq cA c0h wceq wo wi vx cA cch vx cv
      cA wceq vx cv cB wss cA cB wss vx cv cB wceq vx cv c0h wceq wo cA cB wceq
      cA c0h wceq wo vx cv cA cB sseq1 vx cv cA wceq vx cv cB wceq cA cB wceq
      vx cv c0h wceq cA c0h wceq vx cv cA cB eqeq1 vx cv cA c0h eqeq1 orbi12d
      imbi12d rcla4v adantld adantld imp vx cB elat2 sylan2b $.
      $( [23-Jul-2004] $) $( [25-Jun-2004] $)
  $}

  $( Two atoms in a subset relationship are equal. $)
  atsseq $p |- ( ( A e. Atoms /\ B e. Atoms ) -> ( A C_ B <-> A = B ) ) $=
    cA cat wcel cB cat wcel wa cA cB wss cA cB wceq cA cat wcel cB cat wcel wa
    cA cB wss cA cB wceq cA cat wcel cB cat wcel wa cA cB wss wa cA c0h wne cA
    cB wceq cA cat wcel cA c0h wne cB cat wcel cA cB wss cA atn0 ad2antrr cA
    cat wcel cB cat wcel wa cA cB wss wa cA cB wceq cA c0h cA cat wcel cB cat
    wcel wa cA cB wss wa cA cB wceq cA c0h wceq cA cat wcel cB cat wcel wa cA
    cB wss cA cB wceq cA c0h wceq wo cA cch wcel cB cat wcel cA cB wss cA cB
    wceq cA c0h wceq wo wi cA cat wcel cA cB atss cA atelch sylan imp ord
    necon1ad mpd ex cA cB eqimss impbid1 $.
    $( [23-Jul-2004] $) $( [26-Jun-2004] $)

  $( A Hilbert lattice element covered by an atom must be the zero subspace. $)
  atcveq0 $p |- ( ( A e. CH /\ B e. Atoms ) -> ( A <o B <-> A = 0H ) ) $=
    cA cch wcel cB cat wcel wa cA cB ccv wbr cA c0h wceq cA cch wcel cB cat
    wcel wa cA cB ccv wbr c0h cA wss cA cB wpss wa cA c0h wceq cA cch wcel cB
    cat wcel wa cA cB ccv wbr cA cB wpss c0h cA wss cA cch wcel cB cch wcel cA
    cB ccv wbr cA cB wpss wi cB cat wcel cA cB cvpss cB atelch sylan2 cA cch
    wcel c0h cA wss cB cat wcel cA ch0le adantr jctild cB cat wcel cA cch wcel
    c0h cA wss cA cB wpss wa cA c0h wceq wi cB cat wcel cA cch wcel wa c0h cB
    ccv wbr c0h cA wss cA cB wpss wa cA c0h wceq wi cB cat wcel c0h cB ccv wbr
    cA cch wcel cB atcv0 adantr cB cch wcel cA cch wcel c0h cB ccv wbr c0h cA
    wss cA cB wpss wa cA c0h wceq wi wi cB cat wcel c0h cch wcel cB cch wcel cA
    cch wcel c0h cB ccv wbr c0h cA wss cA cB wpss wa cA c0h wceq wi wi h0elch
    c0h cB cA cvnbtwn3 mp3an1 cB atelch sylan mpd ancoms syld cB cat wcel cA
    c0h wceq cA cB ccv wbr wi cA cch wcel cA c0h wceq cA cB ccv wbr c0h cB ccv
    wbr cB cat wcel cA c0h cB ccv breq1 cB atcv0 syl5cbir adantl impbid $.
    $( [23-Jul-2004] $) $( [11-Jun-2004] $)

  ${
    $d x A $.
    $( A 1-dimensional subspace is an atom. $)
    h1da $p |- ( ( A e. ~H /\ A =/= 0h ) ->
                ( _|_ ` ( _|_ ` { A } ) ) e. Atoms ) $=
      cA chil wcel cA c0v wne wa cA csn cort cfv cort cfv cch wcel cA csn cort
      cfv cort cfv c0h wne vx cv cA csn cort cfv cort cfv wss vx cv cA csn cort
      cfv cort cfv wceq vx cv c0h wceq wo wi vx cch wral wa wa cA csn cort cfv
      cort cfv cat wcel cA chil wcel cA c0v wne wa cA csn cort cfv cort cfv cch
      wcel cA csn cort cfv cort cfv c0h wne vx cv cA csn cort cfv cort cfv wss
      vx cv cA csn cort cfv cort cfv wceq vx cv c0h wceq wo wi vx cch wral wa
      cA chil wcel cA csn cort cfv cort cfv cch wcel cA c0v wne cA chil wcel cA
      csn chil wss cA csn cort cfv cch wcel cA csn cort cfv cort cfv cch wcel
      cA chil snssi cA csn occl cA csn cort cfv choccl 3syl adantr cA chil wcel
      cA c0v wne wa cA csn cort cfv cort cfv c0h wne vx cv cA csn cort cfv cort
      cfv wss vx cv cA csn cort cfv cort cfv wceq vx cv c0h wceq wo wi vx cch
      wral cA h1dn0 cA chil wcel vx cv cA csn cort cfv cort cfv wss vx cv cA
      csn cort cfv cort cfv wceq vx cv c0h wceq wo wi vx cch wral cA c0v wne cA
      chil wcel vx cv cA csn cort cfv cort cfv wss vx cv cA csn cort cfv cort
      cfv wceq vx cv c0h wceq wo wi vx cch vx cv cch wcel cA chil wcel vx cv cA
      csn cort cfv cort cfv wss vx cv cA csn cort cfv cort cfv wceq vx cv c0h
      wceq wo wi vx cv cA h1datom expcom r19.21aiv adantr jca jca vx cA csn
      cort cfv cort cfv elat2 sylibr $.
      $( [2-Jun-2007] $) $( [22-Jul-2001] $)
  $}

  $( The span of the singleton of a vector is an atom. $)
  spansna $p |- ( ( A e. ~H /\ A =/= 0h ) -> ( span ` { A } ) e. Atoms ) $=
    cA chil wcel cA c0v wne wa cA csn cspn cfv cA csn cort cfv cort cfv cat cA
    chil wcel cA csn cspn cfv cA csn cort cfv cort cfv wceq cA c0v wne cA
    spansn adantr cA h1da eqeltrd $.
    $( [20-Jun-2006] $) $( [18-Dec-2004] $)

  $( A 1-dimensional subspace is less than or equal to any subspace
     containing its generating vector. $)
  sh1dle $p |- ( ( A e. SH /\ B e. A ) -> ( _|_ ` ( _|_ ` { B } ) ) C_ A ) $=
    cA csh wcel cB cA wcel wa cB csn cort cfv cort cfv cB csn cspn cfv cA cA
    csh wcel cB cA wcel wa cB chil wcel cB csn cspn cfv cB csn cort cfv cort
    cfv wceq cB cA shel cB spansn syl cA cB spansnss eqsstr3d $.
    $( [26-Nov-2004] $) $( [24-Nov-2004] $)

  $( A 1-dimensional subspace is less than or equal to any member of ` CH `
     containing its generating vector. $)
  ch1dle $p |- ( ( A e. CH /\ B e. A ) -> ( _|_ ` ( _|_ ` { B } ) ) C_ A ) $=
    cA csh wcel cB cA wcel cB csn cort cfv cort cfv cA wss cA cch wcel cA cB
    sh1dle cA chsh sylan $.
    $( [31-May-2004] $) $( [30-May-2004] $)

  ${
    $d x y z A $.
    $( The 1-dimensional subspaces of Hilbert space are its atoms.  Part of
       Remark 10.3.5 of [BeltramettiCassinelli] p. 107. $)
    atom1d $p |- ( A e. Atoms <->
                E. x e. ~H ( x =/= 0h /\ A = ( span ` { x } ) ) ) $=
      cA cat wcel vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq wa vx chil
      wrex vx cv c0v wne cA vx cv csn cspn cfv wceq wa vx chil wrex cA cat wcel
      vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq wa vx chil wrex cA cat
      wcel cA cch wcel cA c0h wne vy cv cA wss vy cv cA wceq vy cv c0h wceq wo
      wi vy cch wral wa wa vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq wa
      vx chil wrex vy cA elat2 cA cch wcel cA c0h wne vy cv cA wss vy cv cA
      wceq vy cv c0h wceq wo wi vy cch wral vx cv c0v wne cA vx cv csn cort cfv
      cort cfv wceq wa vx chil wrex cA cch wcel cA c0h wne vx cv c0v wne vx cA
      wrex vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy cch wral vx cv
      c0v wne cA vx cv csn cort cfv cort cfv wceq wa vx chil wrex wi vx cA
      chne0 cA cch wcel vx cv c0v wne vy cv cA wss vy cv cA wceq vy cv c0h wceq
      wo wi vy cch wral vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq wa vx
      chil wrex wi vx cA cA cch wcel vx ax-17 vy cv cA wss vy cv cA wceq vy cv
      c0h wceq wo wi vy cch wral vx cv c0v wne cA vx cv csn cort cfv cort cfv
      wceq wa vx chil wrex vx vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi
      vy cch wral vx ax-17 vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq wa
      vx chil hbre1 hbim cA cch wcel vx cv cA wcel vx cv c0v wne vy cv cA wss
      vy cv cA wceq vy cv c0h wceq wo wi vy cch wral vx cv c0v wne cA vx cv csn
      cort cfv cort cfv wceq wa vx chil wrex vx cv chil wcel vx cv c0v wne cA
      vx cv csn cort cfv cort cfv wceq wa vx cv c0v wne cA vx cv csn cort cfv
      cort cfv wceq wa vx chil wrex cA cch wcel vx cv cA wcel vx cv c0v wne wa
      vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy cch wral wa wa vx cv
      c0v wne cA vx cv csn cort cfv cort cfv wceq wa vx chil ra4e cA cch wcel
      vx cv cA wcel vx cv c0v wne wa vx cv chil wcel vy cv cA wss vy cv cA wceq
      vy cv c0h wceq wo wi vy cch wral cA cch wcel vx cv cA wcel vx cv chil
      wcel vx cv c0v wne vx cv cA chel adantrr adantrr cA cch wcel vx cv cA
      wcel vx cv c0v wne wa vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy
      cch wral wa wa vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq vx cv cA
      wcel vx cv c0v wne wa vx cv c0v wne cA cch wcel vy cv cA wss vy cv cA
      wceq vy cv c0h wceq wo wi vy cch wral vx cv cA wcel vx cv c0v wne pm3.27
      ad2antrl cA cch wcel vx cv cA wcel vx cv c0v wne wa vy cv cA wss vy cv cA
      wceq vy cv c0h wceq wo wi vy cch wral wa wa vx cv csn cort cfv cort cfv
      cA cA cch wcel vx cv cA wcel vx cv c0v wne wa vy cv cA wss vy cv cA wceq
      vy cv c0h wceq wo wi vy cch wral wa wa vx cv csn cort cfv cort cfv c0h
      wne vx cv csn cort cfv cort cfv cA wceq cA cch wcel vx cv cA wcel vx cv
      c0v wne wa vx cv csn cort cfv cort cfv c0h wne vy cv cA wss vy cv cA wceq
      vy cv c0h wceq wo wi vy cch wral cA cch wcel vx cv cA wcel vx cv c0v wne
      vx cv csn cort cfv cort cfv c0h wne vx cv chil wcel vx cv c0v wne vx cv
      csn cort cfv cort cfv c0h wne cA cch wcel vx cv cA wcel wa vx cv h1dn0 vx
      cv cA chel sylan anasss adantrr cA cch wcel vx cv cA wcel vx cv c0v wne
      wa vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy cch wral wa wa vx
      cv csn cort cfv cort cfv cA wceq wn vx cv csn cort cfv cort cfv c0h wceq
      vx cv csn cort cfv cort cfv c0h wne wn cA cch wcel vx cv cA wcel vx cv
      c0v wne wa vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy cch wral wa
      wa vx cv csn cort cfv cort cfv cA wceq vx cv csn cort cfv cort cfv c0h
      wceq cA cch wcel vx cv cA wcel vy cv cA wss vy cv cA wceq vy cv c0h wceq
      wo wi vy cch wral vx cv csn cort cfv cort cfv cA wceq vx cv csn cort cfv
      cort cfv c0h wceq wo vx cv c0v wne cA cch wcel vx cv cA wcel vy cv cA wss
      vy cv cA wceq vy cv c0h wceq wo wi vy cch wral vx cv csn cort cfv cort
      cfv cA wceq vx cv csn cort cfv cort cfv c0h wceq wo cA cch wcel vx cv cA
      wcel vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy cch wral vx cv
      csn cort cfv cort cfv cA wceq vx cv csn cort cfv cort cfv c0h wceq wo wi
      cA cch wcel vx cv cA wcel wa vy cv cA wss vy cv cA wceq vy cv c0h wceq wo
      wi vy cch wral vx cv csn cort cfv cort cfv cA wss vx cv csn cort cfv cort
      cfv cA wceq vx cv csn cort cfv cort cfv c0h wceq wo cA vx cv ch1dle cA
      cch wcel vx cv cA wcel wa vx cv csn cort cfv cch wcel vx cv csn cort cfv
      cort cfv cch wcel vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vy cch
      wral vx cv csn cort cfv cort cfv cA wss vx cv csn cort cfv cort cfv cA
      wceq vx cv csn cort cfv cort cfv c0h wceq wo wi wi cA cch wcel vx cv cA
      wcel wa vx cv chil wcel vx cv csn chil wss vx cv csn cort cfv cch wcel vx
      cv cA chel vx cv chil snssi vx cv csn occl 3syl vx cv csn cort cfv choccl
      vy cv cA wss vy cv cA wceq vy cv c0h wceq wo wi vx cv csn cort cfv cort
      cfv cA wss vx cv csn cort cfv cort cfv cA wceq vx cv csn cort cfv cort
      cfv c0h wceq wo wi vy vx cv csn cort cfv cort cfv cch vy cv vx cv csn
      cort cfv cort cfv wceq vy cv cA wss vx cv csn cort cfv cort cfv cA wss vy
      cv cA wceq vy cv c0h wceq wo vx cv csn cort cfv cort cfv cA wceq vx cv
      csn cort cfv cort cfv c0h wceq wo vy cv vx cv csn cort cfv cort cfv cA
      sseq1 vy cv vx cv csn cort cfv cort cfv wceq vy cv cA wceq vx cv csn cort
      cfv cort cfv cA wceq vy cv c0h wceq vx cv csn cort cfv cort cfv c0h wceq
      vy cv vx cv csn cort cfv cort cfv cA eqeq1 vy cv vx cv csn cort cfv cort
      cfv c0h eqeq1 orbi12d imbi12d rcla4v 3syl mpid ex imp32 adantrlr ord vx
      cv csn cort cfv cort cfv c0h nne syl6ibr mt4d eqcomd jca sylanc exp44
      r19.23ad sylbid imp32 sylbi vx cv c0v wne cA vx cv csn cort cfv cort cfv
      wceq wa cA cat wcel vx chil vx cv chil wcel vx cv c0v wne cA vx cv csn
      cort cfv cort cfv wceq cA cat wcel cA vx cv csn cort cfv cort cfv wceq vx
      cv chil wcel vx cv c0v wne cA cat wcel cA vx cv csn cort cfv cort cfv
      wceq vx cv chil wcel vx cv c0v wne cA cat wcel cA vx cv csn cort cfv cort
      cfv wceq cA cat wcel vx cv csn cort cfv cort cfv cat wcel vx cv chil wcel
      vx cv c0v wne wa cA vx cv csn cort cfv cort cfv cat eleq1 vx cv h1da
      syl5bir exp3a com3l imp3a r19.23aiv impbii vx cv c0v wne cA vx cv csn
      cspn cfv wceq wa vx cv c0v wne cA vx cv csn cort cfv cort cfv wceq wa vx
      chil vx cv chil wcel cA vx cv csn cspn cfv wceq cA vx cv csn cort cfv
      cort cfv wceq vx cv c0v wne vx cv chil wcel vx cv csn cspn cfv vx cv csn
      cort cfv cort cfv cA vx cv spansn eqeq2d anbi2d rexbiia bitr4i $.
      $( [25-Jun-2006] $) $( [4-Jun-2004] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Superposition principle
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d x y z B $.  $d v w x y z $.
    $( Superposition Principle.  If ` A ` and ` B ` are distinct atoms, there
       exists a third atom, distinct from ` A ` and ` B ` , that is the
       superposition of ` A ` and ` B ` .  Definition 3.4-3(a) in
       [MegillPavicic] p. 2345 (PDF p. 8). $)
    superpos $p |- ( ( A e. Atoms /\ B e. Atoms /\ A =/= B ) ->
                   E. x e. Atoms ( x =/= A /\ x =/= B /\ x C_ ( A vH B ) ) ) $=
      cA cat wcel cB cat wcel cA cB wne vx cv cA wne vx cv cB wne vx cv cA cB
      chj co wss w3a vx cat wrex vy cv c0v wne cA vy cv csn cspn cfv wceq wa vy
      chil wrex vz cv c0v wne cB vz cv csn cspn cfv wceq wa vz chil wrex cA cB
      wne vx cv cA wne vx cv cB wne vx cv cA cB chj co wss w3a vx cat wrex wi
      cA cat wcel cB cat wcel vy cv c0v wne cA vy cv csn cspn cfv wceq wa vy
      chil wrex vz cv c0v wne cB vz cv csn cspn cfv wceq wa vz chil wrex wa vy
      cv c0v wne cA vy cv csn cspn cfv wceq wa vz cv c0v wne cB vz cv csn cspn
      cfv wceq wa wa vz chil wrex vy chil wrex cA cB wne vx cv cA wne vx cv cB
      wne vx cv cA cB chj co wss w3a vx cat wrex wi vy cv c0v wne cA vy cv csn
      cspn cfv wceq wa vz cv c0v wne cB vz cv csn cspn cfv wceq wa vy vz chil
      chil reeanv vy cv c0v wne cA vy cv csn cspn cfv wceq wa vz cv c0v wne cB
      vz cv csn cspn cfv wceq wa wa cA cB wne vx cv cA wne vx cv cB wne vx cv
      cA cB chj co wss w3a vx cat wrex wi vy vz chil chil vy cv chil wcel vz cv
      chil wcel wa vy cv c0v wne vz cv c0v wne wa cA vy cv csn cspn cfv wceq cB
      vz cv csn cspn cfv wceq wa wa cA cB wne vx cv cA wne vx cv cB wne vx cv
      cA cB chj co wss w3a vx cat wrex wi vy cv c0v wne cA vy cv csn cspn cfv
      wceq wa vz cv c0v wne cB vz cv csn cspn cfv wceq wa wa vy cv chil wcel vz
      cv chil wcel wa vy cv c0v wne vz cv c0v wne wa cA vy cv csn cspn cfv wceq
      cB vz cv csn cspn cfv wceq wa wa cA cB wne vx cv cA wne vx cv cB wne vx
      cv cA cB chj co wss w3a vx cat wrex wi vy cv chil wcel vz cv chil wcel wa
      vy cv c0v wne vz cv c0v wne wa cA vy cv csn cspn cfv wceq cB vz cv csn
      cspn cfv wceq wa cA cB wne vx cv cA wne vx cv cB wne vx cv cA cB chj co
      wss w3a vx cat wrex wi vy cv chil wcel vz cv chil wcel wa vy cv c0v wne
      vz cv c0v wne wa wa cA vy cv csn cspn cfv wceq cB vz cv csn cspn cfv wceq
      wa wa cA cB wne vy cv csn cspn cfv vz cv csn cspn cfv wne vx cv cA wne vx
      cv cB wne vx cv cA cB chj co wss w3a vx cat wrex cA vy cv csn cspn cfv
      wceq cB vz cv csn cspn cfv wceq wa cA cB wne vy cv csn cspn cfv vz cv csn
      cspn cfv wne wb vy cv chil wcel vz cv chil wcel wa vy cv c0v wne vz cv
      c0v wne wa wa cA vy cv csn cspn cfv wceq cA cB wne vy cv csn cspn cfv cB
      wne cB vz cv csn cspn cfv wceq vy cv csn cspn cfv vz cv csn cspn cfv wne
      cA vy cv csn cspn cfv cB neeq1 cB vz cv csn cspn cfv vy cv csn cspn cfv
      neeq2 sylan9bb adantl vy cv chil wcel vz cv chil wcel wa vy cv c0v wne vz
      cv c0v wne wa wa cA vy cv csn cspn cfv wceq cB vz cv csn cspn cfv wceq wa
      wa vy cv csn cspn cfv vz cv csn cspn cfv wne vx cv cA wne vx cv cB wne vx
      cv cA cB chj co wss w3a vx cat wrex vy cv vz cv cva co csn cspn cfv cat
      wcel vy cv vz cv cva co csn cspn cfv cA wne vy cv vz cv cva co csn cspn
      cfv cB wne vy cv vz cv cva co csn cspn cfv cA cB chj co wss w3a vx cv cA
      wne vx cv cB wne vx cv cA cB chj co wss w3a vx cat wrex vy cv chil wcel
      vz cv chil wcel wa vy cv c0v wne vz cv c0v wne wa wa cA vy cv csn cspn
      cfv wceq cB vz cv csn cspn cfv wceq wa wa vy cv csn cspn cfv vz cv csn
      cspn cfv wne wa vx cv cA wne vx cv cB wne vx cv cA cB chj co wss w3a vy
      cv vz cv cva co csn cspn cfv cA wne vy cv vz cv cva co csn cspn cfv cB
      wne vy cv vz cv cva co csn cspn cfv cA cB chj co wss w3a vx vy cv vz cv
      cva co csn cspn cfv cat vx cv vy cv vz cv cva co csn cspn cfv wceq vx cv
      cA wne vy cv vz cv cva co csn cspn cfv cA wne vx cv cB wne vy cv vz cv
      cva co csn cspn cfv cB wne vx cv cA cB chj co wss vy cv vz cv cva co csn
      cspn cfv cA cB chj co wss vx cv vy cv vz cv cva co csn cspn cfv cA neeq1
      vx cv vy cv vz cv cva co csn cspn cfv cB neeq1 vx cv vy cv vz cv cva co
      csn cspn cfv cA cB chj co sseq1 3anbi123d rcla4ev vy cv chil wcel vz cv
      chil wcel wa vy cv c0v wne vz cv c0v wne wa wa vy cv csn cspn cfv vz cv
      csn cspn cfv wne vy cv vz cv cva co csn cspn cfv cat wcel cA vy cv csn
      cspn cfv wceq cB vz cv csn cspn cfv wceq wa vy cv chil wcel vz cv chil
      wcel wa vy cv csn cspn cfv vz cv csn cspn cfv wne vy cv vz cv cva co csn
      cspn cfv cat wcel vy cv c0v wne vz cv c0v wne wa vy cv vz cv cva co chil
      wcel vy cv vz cv cva co c0v wne vy cv vz cv cva co csn cspn cfv cat wcel
      vy cv chil wcel vz cv chil wcel wa vy cv csn cspn cfv vz cv csn cspn cfv
      wne wa vy cv vz cv cva co spansna vy cv chil wcel vz cv chil wcel wa vy
      cv vz cv cva co chil wcel vy cv csn cspn cfv vz cv csn cspn cfv wne vy cv
      vz cv hvaddcl adantr vy cv chil wcel vz cv chil wcel wa vy cv csn cspn
      cfv vz cv csn cspn cfv wne vy cv vz cv cva co c0v wne vy cv chil wcel vz
      cv chil wcel wa vy cv vz cv cva co c0v vy cv csn cspn cfv vz cv csn cspn
      cfv vy cv chil wcel vz cv chil wcel wa vy cv vz cv cva co c0v wceq vy cv
      c1 cneg vz cv csm co wceq vy cv csn cspn cfv vz cv csn cspn cfv wceq vy
      cv vz cv hvaddeq0 vz cv chil wcel vy cv c1 cneg vz cv csm co wceq vy cv
      csn cspn cfv vz cv csn cspn cfv wceq wi vy cv chil wcel vz cv chil wcel
      vy cv c1 cneg vz cv csm co wceq vy cv csn cspn cfv vz cv csn cspn cfv
      wceq vy cv c1 cneg vz cv csm co wceq vz cv chil wcel vy cv csn cspn cfv
      c1 cneg vz cv csm co csn cspn cfv vz cv csn cspn cfv vy cv c1 cneg vz cv
      csm co wceq vy cv csn c1 cneg vz cv csm co csn cspn vy cv c1 cneg vz cv
      csm co sneq fveq2d vz cv chil wcel c1 cneg cc wcel c1 cneg cc0 wne c1
      cneg vz cv csm co csn cspn cfv vz cv csn cspn cfv wceq c1 ax1cn negcli c1
      ax1cn ax1ne0 negne0i vz cv c1 cneg spansncol mp3an23 sylan9eqr ex adantl
      sylbid necon3d imp sylanc adantlr adantlr vy cv chil wcel vz cv chil wcel
      wa vy cv c0v wne vz cv c0v wne wa wa cA vy cv csn cspn cfv wceq cB vz cv
      csn cspn cfv wceq wa wa vy cv csn cspn cfv vz cv csn cspn cfv wne wa vy
      cv vz cv cva co csn cspn cfv cA wne vy cv vz cv cva co csn cspn cfv cB
      wne vy cv vz cv cva co csn cspn cfv cA cB chj co wss vy cv chil wcel vz
      cv chil wcel wa vy cv c0v wne vz cv c0v wne wa wa cA vy cv csn cspn cfv
      wceq cB vz cv csn cspn cfv wceq wa wa vy cv csn cspn cfv vz cv csn cspn
      cfv wne vy cv vz cv cva co csn cspn cfv cA wne vy cv chil wcel vz cv chil
      wcel wa vy cv c0v wne vz cv c0v wne wa wa cA vy cv csn cspn cfv wceq vy
      cv csn cspn cfv vz cv csn cspn cfv wne vy cv vz cv cva co csn cspn cfv cA
      wne wi cB vz cv csn cspn cfv wceq vy cv chil wcel vz cv chil wcel wa vz
      cv c0v wne cA vy cv csn cspn cfv wceq vy cv csn cspn cfv vz cv csn cspn
      cfv wne vy cv vz cv cva co csn cspn cfv cA wne wi vy cv c0v wne vy cv
      chil wcel vz cv chil wcel wa vz cv c0v wne wa cA vy cv csn cspn cfv wceq
      wa vy cv vz cv cva co csn cspn cfv cA vy cv csn cspn cfv vz cv csn cspn
      cfv cA vy cv csn cspn cfv wceq vy cv vz cv cva co csn cspn cfv cA wceq vy
      cv vz cv cva co csn cspn cfv vy cv csn cspn cfv wceq vy cv chil wcel vz
      cv chil wcel wa vz cv c0v wne wa vy cv csn cspn cfv vz cv csn cspn cfv
      wceq cA vy cv csn cspn cfv wceq vy cv vz cv cva co csn cspn cfv cA wceq
      vy cv vz cv cva co csn cspn cfv vy cv csn cspn cfv wceq cA vy cv csn cspn
      cfv vy cv vz cv cva co csn cspn cfv eqeq2 biimpd vy cv chil wcel vz cv
      chil wcel wa vz cv c0v wne wa vy cv vz cv cva co csn cspn cfv vy cv csn
      cspn cfv wceq vz cv vy cv csn cspn cfv wcel vy cv csn cspn cfv vz cv csn
      cspn cfv wceq vy cv chil wcel vz cv chil wcel wa vy cv vz cv cva co csn
      cspn cfv vy cv csn cspn cfv wceq vz cv vy cv csn cspn cfv wcel wi vz cv
      c0v wne vy cv chil wcel vz cv chil wcel wa vy cv vz cv cva co csn cspn
      cfv vy cv csn cspn cfv wceq vz cv vw cv vy cv csm co wceq vw cc wrex vz
      cv vy cv csn cspn cfv wcel vy cv chil wcel vz cv chil wcel wa vy cv vz cv
      cva co csn cspn cfv vy cv csn cspn cfv wceq vy cv vz cv cva co vy cv csn
      cspn cfv wcel vz cv vw cv vy cv csm co wceq vw cc wrex vy cv chil wcel vz
      cv chil wcel wa vy cv vz cv cva co chil wcel vy cv vz cv cva co csn cspn
      cfv vy cv csn cspn cfv wceq vy cv vz cv cva co vy cv csn cspn cfv wcel wi
      vy cv vz cv hvaddcl vy cv vz cv cva co vy cv spansneleqi syl vy cv chil
      wcel vz cv chil wcel wa vy cv vz cv cva co vy cv csn cspn cfv wcel vy cv
      vz cv cva co vv cv vy cv csm co wceq vv cc wrex vz cv vw cv vy cv csm co
      wceq vw cc wrex vy cv chil wcel vy cv vz cv cva co vy cv csn cspn cfv
      wcel vy cv vz cv cva co vv cv vy cv csm co wceq vv cc wrex wb vz cv chil
      wcel vv vy cv vy cv vz cv cva co elspansn adantr vy cv chil wcel vz cv
      chil wcel wa vy cv vz cv cva co vv cv vy cv csm co wceq vz cv vw cv vy cv
      csm co wceq vw cc wrex vv cc vy cv chil wcel vz cv chil wcel wa vv cv cc
      wcel vy cv vz cv cva co vv cv vy cv csm co wceq vz cv vw cv vy cv csm co
      wceq vw cc wrex vv cv c1 cneg caddc co cc wcel vz cv vv cv c1 cneg caddc
      co vy cv csm co wceq vz cv vw cv vy cv csm co wceq vw cc wrex vy cv chil
      wcel vz cv chil wcel wa vv cv cc wcel wa vy cv vz cv cva co vv cv vy cv
      csm co wceq wa vz cv vw cv vy cv csm co wceq vz cv vv cv c1 cneg caddc co
      vy cv csm co wceq vw vv cv c1 cneg caddc co cc vw cv vv cv c1 cneg caddc
      co wceq vw cv vy cv csm co vv cv c1 cneg caddc co vy cv csm co vz cv vw
      cv vv cv c1 cneg caddc co vy cv csm opreq1 eqeq2d rcla4ev vv cv cc wcel
      vv cv c1 cneg caddc co cc wcel vy cv chil wcel vz cv chil wcel wa vy cv
      vz cv cva co vv cv vy cv csm co wceq vv cv cc wcel c1 cneg cc wcel vv cv
      c1 cneg caddc co cc wcel c1 ax1cn negcli vv cv c1 cneg addcl mpan2
      ad2antlr vy cv chil wcel vz cv chil wcel wa vv cv cc wcel wa vy cv vz cv
      cva co vv cv vy cv csm co wceq wa vv cv vy cv csm co vy cv cmv co vz cv
      vv cv c1 cneg caddc co vy cv csm co vy cv chil wcel vz cv chil wcel wa vv
      cv cc wcel wa vv cv vy cv csm co vy cv cmv co vz cv wceq vy cv vz cv cva
      co vv cv vy cv csm co wceq vv cv vy cv csm co chil wcel vy cv chil wcel
      vz cv chil wcel vv cv vy cv csm co vy cv cmv co vz cv wceq vy cv vz cv
      cva co vv cv vy cv csm co wceq wb vy cv chil wcel vz cv chil wcel wa vv
      cv cc wcel wa vv cv vy cv csm co vy cv vz cv hvsubadd vy cv chil wcel vv
      cv cc wcel vv cv vy cv csm co chil wcel vz cv chil wcel vv cv cc wcel vy
      cv chil wcel vv cv vy cv csm co chil wcel vv cv vy cv hvmulcl ancoms
      adantlr vy cv chil wcel vz cv chil wcel vv cv cc wcel simpll vy cv chil
      wcel vz cv chil wcel vv cv cc wcel simplr syl3anc biimpar vy cv chil wcel
      vz cv chil wcel wa vv cv cc wcel wa vv cv vy cv csm co vy cv cmv co vv cv
      c1 cneg caddc co vy cv csm co wceq vy cv vz cv cva co vv cv vy cv csm co
      wceq vy cv chil wcel vv cv cc wcel vv cv vy cv csm co vy cv cmv co vv cv
      c1 cneg caddc co vy cv csm co wceq vz cv chil wcel vv cv cc wcel vy cv
      chil wcel vv cv vy cv csm co vy cv cmv co vv cv c1 cneg caddc co vy cv
      csm co wceq vv cv cc wcel vy cv chil wcel wa vv cv vy cv csm co vy cv cmv
      co vv cv vy cv csm co c1 cneg vy cv csm co cva co vv cv c1 cneg caddc co
      vy cv csm co vv cv cc wcel vy cv chil wcel vv cv vy cv csm co chil wcel
      vv cv vy cv csm co vy cv cmv co vv cv vy cv csm co c1 cneg vy cv csm co
      cva co wceq vv cv vy cv hvmulcl vv cv vy cv csm co vy cv hvsubval
      sylancom vv cv cc wcel c1 cneg cc wcel vy cv chil wcel vv cv c1 cneg
      caddc co vy cv csm co vv cv vy cv csm co c1 cneg vy cv csm co cva co wceq
      c1 ax1cn negcli vv cv c1 cneg vy cv ax-hvdistr2 mp3an2 eqtr4d ancoms
      adantlr adantr eqtr3d sylanc exp31 r19.23adv sylbid syld vy cv chil wcel
      vz cv vy cv csn cspn cfv wcel vz cv vw cv vy cv csm co wceq vw cc wrex wb
      vz cv chil wcel vw vy cv vz cv elspansn adantr sylibrd adantr vy cv chil
      wcel vz cv c0v wne vz cv vy cv csn cspn cfv wcel vy cv csn cspn cfv vz cv
      csn cspn cfv wceq wi vz cv chil wcel vy cv chil wcel vz cv c0v wne wa vz
      cv vy cv csn cspn cfv wcel vz cv csn cspn cfv vy cv csn cspn cfv wceq vy
      cv csn cspn cfv vz cv csn cspn cfv wceq vz cv vy cv spansneleq vz cv csn
      cspn cfv vy cv csn cspn cfv eqcom syl6ib adantlr syld sylan9r necon3d
      adantlrl adantrr imp vy cv chil wcel vz cv chil wcel wa vy cv c0v wne vz
      cv c0v wne wa wa cA vy cv csn cspn cfv wceq cB vz cv csn cspn cfv wceq wa
      wa vy cv csn cspn cfv vz cv csn cspn cfv wne vy cv vz cv cva co csn cspn
      cfv cB wne vy cv chil wcel vz cv chil wcel wa vy cv c0v wne vz cv c0v wne
      wa wa cB vz cv csn cspn cfv wceq vy cv csn cspn cfv vz cv csn cspn cfv
      wne vy cv vz cv cva co csn cspn cfv cB wne wi cA vy cv csn cspn cfv wceq
      vy cv chil wcel vz cv chil wcel wa vy cv c0v wne cB vz cv csn cspn cfv
      wceq vy cv csn cspn cfv vz cv csn cspn cfv wne vy cv vz cv cva co csn
      cspn cfv cB wne wi vz cv c0v wne vy cv chil wcel vz cv chil wcel wa vy cv
      c0v wne wa cB vz cv csn cspn cfv wceq wa vy cv vz cv cva co csn cspn cfv
      cB vy cv csn cspn cfv vz cv csn cspn cfv cB vz cv csn cspn cfv wceq vy cv
      vz cv cva co csn cspn cfv cB wceq vy cv vz cv cva co csn cspn cfv vz cv
      csn cspn cfv wceq vy cv chil wcel vz cv chil wcel wa vy cv c0v wne wa vy
      cv csn cspn cfv vz cv csn cspn cfv wceq cB vz cv csn cspn cfv wceq vy cv
      vz cv cva co csn cspn cfv cB wceq vy cv vz cv cva co csn cspn cfv vz cv
      csn cspn cfv wceq cB vz cv csn cspn cfv vy cv vz cv cva co csn cspn cfv
      eqeq2 biimpd vy cv chil wcel vz cv chil wcel wa vy cv c0v wne wa vy cv vz
      cv cva co csn cspn cfv vz cv csn cspn cfv wceq vy cv vz cv csn cspn cfv
      wcel vy cv csn cspn cfv vz cv csn cspn cfv wceq vy cv chil wcel vz cv
      chil wcel wa vy cv vz cv cva co csn cspn cfv vz cv csn cspn cfv wceq vy
      cv vz cv csn cspn cfv wcel wi vy cv c0v wne vy cv chil wcel vz cv chil
      wcel wa vy cv vz cv cva co csn cspn cfv vz cv csn cspn cfv wceq vy cv vw
      cv vz cv csm co wceq vw cc wrex vy cv vz cv csn cspn cfv wcel vy cv chil
      wcel vz cv chil wcel wa vy cv vz cv cva co csn cspn cfv vz cv csn cspn
      cfv wceq vy cv vz cv cva co vz cv csn cspn cfv wcel vy cv vw cv vz cv csm
      co wceq vw cc wrex vy cv chil wcel vz cv chil wcel wa vy cv vz cv cva co
      chil wcel vy cv vz cv cva co csn cspn cfv vz cv csn cspn cfv wceq vy cv
      vz cv cva co vz cv csn cspn cfv wcel wi vy cv vz cv hvaddcl vy cv vz cv
      cva co vz cv spansneleqi syl vy cv chil wcel vz cv chil wcel wa vy cv vz
      cv cva co vz cv csn cspn cfv wcel vy cv vz cv cva co vv cv vz cv csm co
      wceq vv cc wrex vy cv vw cv vz cv csm co wceq vw cc wrex vz cv chil wcel
      vy cv vz cv cva co vz cv csn cspn cfv wcel vy cv vz cv cva co vv cv vz cv
      csm co wceq vv cc wrex wb vy cv chil wcel vv vz cv vy cv vz cv cva co
      elspansn adantl vy cv chil wcel vz cv chil wcel wa vy cv vz cv cva co vv
      cv vz cv csm co wceq vy cv vw cv vz cv csm co wceq vw cc wrex vv cc vy cv
      chil wcel vz cv chil wcel wa vv cv cc wcel vy cv vz cv cva co vv cv vz cv
      csm co wceq vy cv vw cv vz cv csm co wceq vw cc wrex vv cv c1 cneg caddc
      co cc wcel vy cv vv cv c1 cneg caddc co vz cv csm co wceq vy cv vw cv vz
      cv csm co wceq vw cc wrex vy cv chil wcel vz cv chil wcel wa vv cv cc
      wcel wa vy cv vz cv cva co vv cv vz cv csm co wceq wa vy cv vw cv vz cv
      csm co wceq vy cv vv cv c1 cneg caddc co vz cv csm co wceq vw vv cv c1
      cneg caddc co cc vw cv vv cv c1 cneg caddc co wceq vw cv vz cv csm co vv
      cv c1 cneg caddc co vz cv csm co vy cv vw cv vv cv c1 cneg caddc co vz cv
      csm opreq1 eqeq2d rcla4ev vv cv cc wcel vv cv c1 cneg caddc co cc wcel vy
      cv chil wcel vz cv chil wcel wa vy cv vz cv cva co vv cv vz cv csm co
      wceq vv cv cc wcel c1 cneg cc wcel vv cv c1 cneg caddc co cc wcel c1
      ax1cn negcli vv cv c1 cneg addcl mpan2 ad2antlr vy cv chil wcel vz cv
      chil wcel wa vv cv cc wcel wa vy cv vz cv cva co vv cv vz cv csm co wceq
      wa vv cv vz cv csm co vz cv cmv co vy cv vv cv c1 cneg caddc co vz cv csm
      co vy cv chil wcel vz cv chil wcel wa vv cv cc wcel wa vv cv vz cv csm co
      vz cv cmv co vy cv wceq vy cv vz cv cva co vv cv vz cv csm co wceq vy cv
      chil wcel vz cv chil wcel wa vv cv cc wcel wa vv cv vz cv csm co vz cv
      cmv co vy cv wceq vz cv vy cv cva co vv cv vz cv csm co wceq vy cv vz cv
      cva co vv cv vz cv csm co wceq vv cv vz cv csm co chil wcel vz cv chil
      wcel vy cv chil wcel vv cv vz cv csm co vz cv cmv co vy cv wceq vz cv vy
      cv cva co vv cv vz cv csm co wceq wb vy cv chil wcel vz cv chil wcel wa
      vv cv cc wcel wa vv cv vz cv csm co vz cv vy cv hvsubadd vz cv chil wcel
      vv cv cc wcel vv cv vz cv csm co chil wcel vy cv chil wcel vv cv cc wcel
      vz cv chil wcel vv cv vz cv csm co chil wcel vv cv vz cv hvmulcl ancoms
      adantll vy cv chil wcel vz cv chil wcel vv cv cc wcel simplr vy cv chil
      wcel vz cv chil wcel vv cv cc wcel simpll syl3anc vy cv chil wcel vz cv
      chil wcel wa vv cv cc wcel wa vy cv vz cv cva co vz cv vy cv cva co vv cv
      vz cv csm co vy cv chil wcel vz cv chil wcel wa vy cv vz cv cva co vz cv
      vy cv cva co wceq vv cv cc wcel vy cv vz cv ax-hvcom adantr eqeq1d bitr4d
      biimpar vy cv chil wcel vz cv chil wcel wa vv cv cc wcel wa vv cv vz cv
      csm co vz cv cmv co vv cv c1 cneg caddc co vz cv csm co wceq vy cv vz cv
      cva co vv cv vz cv csm co wceq vz cv chil wcel vv cv cc wcel vv cv vz cv
      csm co vz cv cmv co vv cv c1 cneg caddc co vz cv csm co wceq vy cv chil
      wcel vv cv cc wcel vz cv chil wcel vv cv vz cv csm co vz cv cmv co vv cv
      c1 cneg caddc co vz cv csm co wceq vv cv cc wcel vz cv chil wcel wa vv cv
      vz cv csm co vz cv cmv co vv cv vz cv csm co c1 cneg vz cv csm co cva co
      vv cv c1 cneg caddc co vz cv csm co vv cv cc wcel vz cv chil wcel vv cv
      vz cv csm co chil wcel vv cv vz cv csm co vz cv cmv co vv cv vz cv csm co
      c1 cneg vz cv csm co cva co wceq vv cv vz cv hvmulcl vv cv vz cv csm co
      vz cv hvsubval sylancom vv cv cc wcel c1 cneg cc wcel vz cv chil wcel vv
      cv c1 cneg caddc co vz cv csm co vv cv vz cv csm co c1 cneg vz cv csm co
      cva co wceq c1 ax1cn negcli vv cv c1 cneg vz cv ax-hvdistr2 mp3an2 eqtr4d
      ancoms adantll adantr eqtr3d sylanc exp31 r19.23adv sylbid syld vz cv
      chil wcel vy cv vz cv csn cspn cfv wcel vy cv vw cv vz cv csm co wceq vw
      cc wrex wb vy cv chil wcel vw vz cv vy cv elspansn adantl sylibrd adantr
      vz cv chil wcel vy cv c0v wne vy cv vz cv csn cspn cfv wcel vy cv csn
      cspn cfv vz cv csn cspn cfv wceq wi vy cv chil wcel vy cv vz cv
      spansneleq adantll syld sylan9r necon3d adantlrr adantrl imp vy cv chil
      wcel vz cv chil wcel wa vy cv c0v wne vz cv c0v wne wa wa cA vy cv csn
      cspn cfv wceq cB vz cv csn cspn cfv wceq wa wa vy cv vz cv cva co csn
      cspn cfv cA cB chj co wss vy cv csn cspn cfv vz cv csn cspn cfv wne vy cv
      chil wcel vz cv chil wcel wa cA vy cv csn cspn cfv wceq cB vz cv csn cspn
      cfv wceq wa vy cv vz cv cva co csn cspn cfv cA cB chj co wss vy cv c0v
      wne vz cv c0v wne wa vy cv chil wcel vz cv chil wcel wa cA vy cv csn cspn
      cfv wceq cB vz cv csn cspn cfv wceq wa wa vy cv vz cv cva co csn cspn cfv
      vy cv vz cv cpr cspn cfv cA cB chj co vy cv chil wcel vz cv chil wcel wa
      vy cv vz cv cva co csn cspn cfv vy cv vz cv cpr cspn cfv wss cA vy cv csn
      cspn cfv wceq cB vz cv csn cspn cfv wceq wa vy cv vz cv spanpr adantr cA
      vy cv csn cspn cfv wceq cB vz cv csn cspn cfv wceq wa vy cv chil wcel vz
      cv chil wcel wa cA cB chj co vy cv csn cspn cfv vz cv csn cspn cfv chj co
      vy cv vz cv cpr cspn cfv cA vy cv csn cspn cfv cB vz cv csn cspn cfv chj
      opreq12 vy cv chil wcel vz cv chil wcel wa vy cv vz cv cpr cspn cfv vy cv
      csn cspn cfv vz cv csn cspn cfv cph co vy cv csn cspn cfv vz cv csn cspn
      cfv chj co vy cv chil wcel vz cv chil wcel wa vy cv csn vz cv csn cun
      cspn cfv vy cv csn cspn cfv vz cv csn cspn cfv cph co vy cv vz cv cpr
      cspn cfv vy cv csn chil wss vz cv csn chil wss vy cv csn vz cv csn cun
      cspn cfv vy cv csn cspn cfv vz cv csn cspn cfv cph co wceq vy cv chil
      wcel vz cv chil wcel vy cv csn vz cv csn spanun vy cv chil snssi vz cv
      chil snssi syl2an vy cv vz cv cpr vy cv csn vz cv csn cun cspn vy cv vz
      cv df-pr fveq2i syl5eq vy cv csn cspn cfv cch wcel vz cv chil wcel vy cv
      csn cspn cfv vz cv csn cspn cfv cph co vy cv csn cspn cfv vz cv csn cspn
      cfv chj co wceq vy cv chil wcel vy cv csn cspn cfv vz cv spansnj vy cv
      spansnch sylan eqtr2d sylan9eqr sseqtr4d adantlr adantr 3jca sylanc ex
      sylbid anasss ex vy cv c0v wne cA vy cv csn cspn cfv wceq vz cv c0v wne
      cB vz cv csn cspn cfv wceq an4 syl5ib r19.23aivv sylbir vy cA atom1d vz
      cB atom1d syl2anb 3impia $.
      $( [26-Jun-2006] $) $( [9-Jun-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Atoms, exchange and covering properties, atomicity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.
    $( The Hilbert lattice has the covering property.  Proposition 1(ii) of
       [Kalmbach] p. 140 (and its converse). $)
    chcv1 $p |- ( ( A e. CH /\ B e. Atoms ) ->
                ( -. B C_ A <-> A <o ( A vH B ) ) ) $=
      cA cch wcel cB cat wcel wa cB cA wss wn cA cA cB chj co ccv wbr cA cch
      wcel vx cv c0v wne cB vx cv csn cspn cfv wceq wa vx chil wrex cB cA wss
      wn cA cA cB chj co ccv wbr wi cB cat wcel cA cch wcel vx cv c0v wne cB vx
      cv csn cspn cfv wceq wa vx chil wrex cB cA wss wn cA cA cB chj co ccv wbr
      wi cA cch wcel vx cv c0v wne cB vx cv csn cspn cfv wceq wa cB cA wss wn
      cA cA cB chj co ccv wbr wi vx chil cA cch wcel vx cv chil wcel wa cB vx
      cv csn cspn cfv wceq cB cA wss wn cA cA cB chj co ccv wbr wi vx cv c0v
      wne cB vx cv csn cspn cfv wceq cB cA wss wn cA cA cB chj co ccv wbr wi vx
      cv csn cspn cfv cA wss wn cA cA vx cv csn cspn cfv chj co ccv wbr wi cA
      cch wcel vx cv chil wcel wa cB vx cv csn cspn cfv wceq cB cA wss wn vx cv
      csn cspn cfv cA wss wn cA cA cB chj co ccv wbr cA cA vx cv csn cspn cfv
      chj co ccv wbr cB vx cv csn cspn cfv wceq cB cA wss vx cv csn cspn cfv cA
      wss cB vx cv csn cspn cfv cA sseq1 notbid cB vx cv csn cspn cfv wceq cA
      cB chj co cA vx cv csn cspn cfv chj co cA ccv cB vx cv csn cspn cfv cA
      chj opreq2 breq2d imbi12d cA vx cv spansncv2 syl5cbir adantld r19.23adva
      imp vx cB atom1d sylan2b cA cch wcel cB cch wcel cA cA cB chj co ccv wbr
      cB cA wss wn wi cB cat wcel cA cch wcel cB cch wcel wa cA cA cB chj co
      ccv wbr cA cA cB chj co wpss cB cA wss wn cA cch wcel cB cch wcel cA cB
      chj co cch wcel cA cA cB chj co ccv wbr cA cA cB chj co wpss wi cA cB
      chjcl cA cA cB chj co cvpss syldan cA cB chnle sylibrd cB atelch sylan2
      impbid $.
      $( [26-Jul-2004] $) $( [11-Jun-2004] $)

    $( The Hilbert lattice has the covering property. $)
    chcv2 $p |- ( ( A e. CH /\ B e. Atoms ) ->
                ( A C. ( A vH B ) <-> A <o ( A vH B ) ) ) $=
      cA cch wcel cB cat wcel wa cB cA wss wn cA cA cB chj co wpss cA cA cB chj
      co ccv wbr cA cch wcel cB cch wcel cB cA wss wn cA cA cB chj co wpss wb
      cB cat wcel cA cB chnle cB atelch sylan2 cA cB chcv1 bitr3d $.
      $( [26-Jul-2004] $) $( [11-Jun-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( The join of a closed subspace and an atom equals their subspace sum.
       Special case of remark in [Kalmbach] p. 65, stating that if ` A ` or
       ` B ` is finite dimensional, then this equality holds. $)
    chjatom $p |- ( ( A e. CH /\ B e. Atoms ) -> ( A +H B ) = ( A vH B ) ) $=
      cA cch wcel cB cat wcel cA cB cph co cA cB chj co wceq cA cch wcel vx cv
      c0v wne cB vx cv csn cspn cfv wceq wa vx chil wrex cA cB cph co cA cB chj
      co wceq cB cat wcel cA cch wcel vx cv c0v wne cB vx cv csn cspn cfv wceq
      wa cA cB cph co cA cB chj co wceq vx chil vx cv c0v wne cB vx cv csn cspn
      cfv wceq wa cA cch wcel vx cv chil wcel cA cB cph co cA cB chj co wceq cB
      vx cv csn cspn cfv wceq cA cch wcel vx cv chil wcel cA cB cph co cA cB
      chj co wceq wi wi vx cv c0v wne cB vx cv csn cspn cfv wceq cA cch wcel vx
      cv chil wcel cA cB cph co cA cB chj co wceq cB vx cv csn cspn cfv wceq cA
      cB cph co cA cB chj co wceq cA vx cv csn cspn cfv cph co cA vx cv csn
      cspn cfv chj co wceq cA cch wcel vx cv chil wcel wa cB vx cv csn cspn cfv
      wceq cA cB cph co cA vx cv csn cspn cfv cph co cA cB chj co cA vx cv csn
      cspn cfv chj co cB vx cv csn cspn cfv cA cph opreq2 cB vx cv csn cspn cfv
      cA chj opreq2 eqeq12d cA vx cv spansnj syl5bir exp3a adantl com3l
      r19.23adv vx cB atom1d syl5ib imp $.
      $( [27-Feb-2005] $) $( [4-Jun-2004] $)
  $}

  ${
    $d x y A $.
    shatomic.1 $e |- A e. SH $.
    $( The lattice of Hilbert subspaces is atomic, i.e. any non-zero element is
       greater than or equal to some atom.  Part of proof of Theorem 16.9 of
       [MaedaMaeda] p. 70. $)
    shatomici $p |- ( A =/= 0H -> E. x e. Atoms x C_ A ) $=
      cA c0h wne vy cv c0v wne vy cA wrex vx cv cA wss vx cat wrex vy cA
      shatomic.1 shne0i vy cv c0v wne vx cv cA wss vx cat wrex vy cA vy cv csn
      cort cfv cort cfv cat wcel vy cv csn cort cfv cort cfv cA wss vx cv cA
      wss vx cat wrex vy cv cA wcel vy cv c0v wne wa vx cv cA wss vy cv csn
      cort cfv cort cfv cA wss vx vy cv csn cort cfv cort cfv cat vx cv vy cv
      csn cort cfv cort cfv cA sseq1 rcla4ev vy cv chil wcel vy cv c0v wne vy
      cv csn cort cfv cort cfv cat wcel vy cv cA wcel vy cv h1da vy cv cA
      shatomic.1 sheli sylan vy cv cA wcel vy cv csn cort cfv cort cfv cA wss
      vy cv c0v wne cA csh wcel vy cv cA wcel vy cv csn cort cfv cort cfv cA
      wss shatomic.1 cA vy cv sh1dle mpan adantr sylanc r19.23aiva sylbi $.
      $( [30-Jun-2006] $) $( [24-Nov-2004] $)
  $}

  ${
    $d x y A $.
    hatomic.1 $e |- A e. CH $.
    $( The Hilbert lattice is atomic, i.e. any non-zero element is greater than
       or equal to some atom.  Remark in [Kalmbach] p. 140. $)
    hatomici $p |- ( A =/= 0H -> E. x e. Atoms x C_ A ) $=
      vx cA cA hatomic.1 chshii shatomici $.
      $( [2-Jul-2006] $) $( [22-Jul-2001] $)
  $}

  ${
    $d x y A $.
    $( A Hilbert lattice is atomic, i.e. any non-zero element is greater than
       or equal to some atom.  Remark in [Kalmbach] p. 140.  Also Definition
       3.4-2 in [MegillPavicic] p. 2345 (PDF p. 8). $)
    hatomic $p |- ( ( A e. CH /\ A =/= 0H ) -> E. x e. Atoms x C_ A ) $=
      cA cch wcel cA c0h wne vx cv cA wss vx cat wrex cA cch wcel cA c0h wne vx
      cv cA wss vx cat wrex wi cA cch wcel cA c0h cif c0h wne vx cv cA cch wcel
      cA c0h cif wss vx cat wrex wi cA c0h cA cA cch wcel cA c0h cif wceq cA
      c0h wne cA cch wcel cA c0h cif c0h wne vx cv cA wss vx cat wrex vx cv cA
      cch wcel cA c0h cif wss vx cat wrex cA cA cch wcel cA c0h cif c0h neeq1
      cA cA cch wcel cA c0h cif wceq vx cv cA wss vx cv cA cch wcel cA c0h cif
      wss vx cat cA cA cch wcel cA c0h cif vx cv sseq2 rexbidv imbi12d vx cA
      cch wcel cA c0h cif cA c0h cch h0elch elimel hatomici dedth imp $.
      $( [7-Oct-2006] $) $( [24-Jun-2004] $)
  $}

  ${
    $d x y A $.
    shatomistic.1 $e |- A e. SH $.
    $( The lattice of Hilbert subspaces is atomistic, i.e. any element is the
       supremum of its atoms.  Part of proof of Theorem 16.9 of [MaedaMaeda]
       p. 70. $)
    shatomistici $p |- A = ( span ` U. { x e. Atoms | x C_ A } ) $=
      cA vx cv cA wss vx cat crab cuni cspn cfv vy cA vx cv cA wss vx cat crab
      cuni cspn cfv vy cv cA wcel vy cv vx cv cA wss vx cat crab cuni cspn cfv
      wcel c0v vx cv cA wss vx cat crab cuni cspn cfv wcel vy cv c0v vy cv c0v
      vx cv cA wss vx cat crab cuni cspn cfv eleq1 vy cv cA wcel vy cv c0v wne
      wa vy cv csn cspn cfv vx cv cA wss vx cat crab cuni cspn cfv vy cv vy cv
      cA wcel vy cv c0v wne wa vy cv csn cspn cfv vy cv csn cspn cfv cspn cfv
      vx cv cA wss vx cat crab cuni cspn cfv vy cv cA wcel vy cv csn cspn cfv
      cspn cfv vy cv csn cspn cfv wceq vy cv c0v wne vy cv cA wcel vy cv chil
      wcel vy cv csn cspn cfv csh wcel vy cv csn cspn cfv cspn cfv vy cv csn
      cspn cfv wceq vy cv cA shatomistic.1 sheli vy cv spansnsh vy cv csn cspn
      cfv spanid 3syl adantr vy cv cA wcel vy cv c0v wne wa vy cv csn cspn cfv
      vx cv cA wss vx cat crab wcel vy cv csn cspn cfv vx cv cA wss vx cat crab
      cuni wss vy cv csn cspn cfv cspn cfv vx cv cA wss vx cat crab cuni cspn
      cfv wss vy cv cA wcel vy cv c0v wne wa vy cv csn cspn cfv cat wcel vy cv
      csn cspn cfv cA wss wa vy cv csn cspn cfv vx cv cA wss vx cat crab wcel
      vy cv cA wcel vy cv c0v wne wa vy cv csn cspn cfv cat wcel vy cv csn cspn
      cfv cA wss vy cv chil wcel vy cv c0v wne vy cv csn cspn cfv cat wcel vy
      cv cA wcel vy cv spansna vy cv cA shatomistic.1 sheli sylan vy cv cA wcel
      vy cv csn cspn cfv cA wss vy cv c0v wne cA csh wcel vy cv cA wcel vy cv
      csn cspn cfv cA wss shatomistic.1 cA vy cv spansnss mpan adantr jca vx cv
      cA wss vy cv csn cspn cfv cA wss vx vy cv csn cspn cfv cat vx cv vy cv
      csn cspn cfv cA sseq1 elrab sylibr vy cv csn cspn cfv vx cv cA wss vx cat
      crab elssuni vx cv cA wss vx cat crab cuni chil wss vy cv csn cspn cfv vx
      cv cA wss vx cat crab cuni wss vy cv csn cspn cfv cspn cfv vx cv cA wss
      vx cat crab cuni cspn cfv wss vx cv cA wss vx cat crab cuni vx cv cA wss
      vx csh crab cuni chil vx cv cA wss vx cat crab vx cv cA wss vx csh crab
      wss vx cv cA wss vx cat crab cuni vx cv cA wss vx csh crab cuni wss cat
      csh wss vx cv cA wss vx cat crab vx cv cA wss vx csh crab wss cat cch csh
      atssch chsssh sstri vx cv cA wss vx cat csh rabss2 ax-mp vx cv cA wss vx
      cat crab vx cv cA wss vx csh crab uniss ax-mp vx cv cA wss vx csh crab
      cuni cA chil cA csh wcel vx cv cA wss vx csh crab cuni cA wceq
      shatomistic.1 vx cA csh unimax ax-mp cA shatomistic.1 shssii eqsstri
      sstri vy cv csn cspn cfv vx cv cA wss vx cat crab cuni spanss mpan 3syl
      eqsstr3d vy cv cA wcel vy cv vy cv csn cspn cfv wcel vy cv c0v wne vy cv
      cA wcel vy cv chil wcel vy cv vy cv csn cspn cfv wcel vy cv cA
      shatomistic.1 sheli vy cv spansnid syl adantr sseldd c0v vx cv cA wss vx
      cat crab cuni cspn cfv wcel vy cv cA wcel vx cv cA wss vx cat crab cuni
      cspn cfv csh wcel c0v vx cv cA wss vx cat crab cuni cspn cfv wcel vx cv
      cA wss vx cat crab cuni chil wss vx cv cA wss vx cat crab cuni cspn cfv
      csh wcel vx cv cA wss vx cat crab cuni vx cv cA wss vx csh crab cuni chil
      vx cv cA wss vx cat crab vx cv cA wss vx csh crab wss vx cv cA wss vx cat
      crab cuni vx cv cA wss vx csh crab cuni wss cat csh wss vx cv cA wss vx
      cat crab vx cv cA wss vx csh crab wss cat cch csh atssch chsssh sstri vx
      cv cA wss vx cat csh rabss2 ax-mp vx cv cA wss vx cat crab vx cv cA wss
      vx csh crab uniss ax-mp vx cv cA wss vx csh crab cuni cA chil cA csh wcel
      vx cv cA wss vx csh crab cuni cA wceq shatomistic.1 vx cA csh unimax
      ax-mp cA shatomistic.1 shssii eqsstri sstri vx cv cA wss vx cat crab cuni
      spancl ax-mp vx cv cA wss vx cat crab cuni cspn cfv sh0 ax-mp a1i
      pm2.61ne ssriv vx cv cA wss vx cat crab cuni cspn cfv vx cv cA wss vx csh
      crab cuni cspn cfv cA vx cv cA wss vx csh crab cuni chil wss vx cv cA wss
      vx cat crab cuni vx cv cA wss vx csh crab cuni wss vx cv cA wss vx cat
      crab cuni cspn cfv vx cv cA wss vx csh crab cuni cspn cfv wss vx cv cA
      wss vx csh crab cuni cA chil cA csh wcel vx cv cA wss vx csh crab cuni cA
      wceq shatomistic.1 vx cA csh unimax ax-mp cA shatomistic.1 shssii eqsstri
      vx cv cA wss vx cat crab vx cv cA wss vx csh crab wss vx cv cA wss vx cat
      crab cuni vx cv cA wss vx csh crab cuni wss cat csh wss vx cv cA wss vx
      cat crab vx cv cA wss vx csh crab wss cat cch csh atssch chsssh sstri vx
      cv cA wss vx cat csh rabss2 ax-mp vx cv cA wss vx cat crab vx cv cA wss
      vx csh crab uniss ax-mp vx cv cA wss vx cat crab cuni vx cv cA wss vx csh
      crab cuni spanss mp2an vx cv cA wss vx csh crab cuni cspn cfv cA cspn cfv
      cA vx cv cA wss vx csh crab cuni cA cspn cA csh wcel vx cv cA wss vx csh
      crab cuni cA wceq shatomistic.1 vx cA csh unimax ax-mp fveq2i cA csh wcel
      cA cspn cfv cA wceq shatomistic.1 cA spanid ax-mp eqtri sseqtri eqssi $.
      $( [16-Jan-2005] $) $( [26-Nov-2004] $)
  $}

  ${
    $d x y A $.
    hatomistic.1 $e |- A e. CH $.
    $( ` CH ` is atomistic, i.e. any element is the supremum of its atoms.
       Remark in [Kalmbach] p. 140. $)
    hatomistici $p |- A = ( \/H ` { x e. Atoms | x C_ A } ) $=
      vx cv cA wss vx cat crab chsup cfv cA vx cv cA wss vx cat crab chsup cfv
      cA vx cv cA wss vx cat crab cch wss vx cv cA wss vx cat crab chsup cfv
      cch wcel vx cv cA wss vx cat crab cat cch vx cv cA wss vx cat ssrab2
      atssch sstri vx cv cA wss vx cat crab chsupcl ax-mp cA hatomistic.1
      chshii vx cv cA wss vx cat crab chsup cfv vx cv cA wss vx cch crab chsup
      cfv cA vx cv cA wss vx cat crab vx cv cA wss vx cch crab wss vx cv cA wss
      vx cat crab chsup cfv vx cv cA wss vx cch crab chsup cfv wss vy vx cv cA
      wss vx cat crab vx cv cA wss vx cch crab vy cv cat wcel vy cv cA wss wa
      vy cv cch wcel vy cv cA wss wa vy cv vx cv cA wss vx cat crab wcel vy cv
      vx cv cA wss vx cch crab wcel vy cv cat wcel vy cv cch wcel vy cv cA wss
      vy cv atelch anim1i vx cv cA wss vy cv cA wss vx vy cv cat vx cv vy cv cA
      sseq1 elrab vx cv cA wss vy cv cA wss vx vy cv cch vx cv vy cv cA sseq1
      elrab 3imtr4i ssriv vx cv cA wss vx cat crab cch wss vx cv cA wss vx cch
      crab cch wss vx cv cA wss vx cat crab vx cv cA wss vx cch crab wss vx cv
      cA wss vx cat crab chsup cfv vx cv cA wss vx cch crab chsup cfv wss wi vx
      cv cA wss vx cat crab cat cch vx cv cA wss vx cat ssrab2 atssch sstri vx
      cv cA wss vx cch ssrab2 vx cv cA wss vx cat crab vx cv cA wss vx cch crab
      chsupss mp2an ax-mp cA cch wcel vx cv cA wss vx cch crab chsup cfv cA
      wceq hatomistic.1 vx cA chsupid ax-mp sseqtri vy cv cA vx cv cA wss vx
      cat crab chsup cfv cort cfv cin wss vy cat wrex wn cA vx cv cA wss vx cat
      crab chsup cfv cort cfv cin c0h wceq vy cv cA vx cv cA wss vx cat crab
      chsup cfv cort cfv cin wss vy cat vy cv cat wcel vy cv cA wss vy cv vx cv
      cA wss vx cat crab chsup cfv cort cfv wss wa wn vy cv cA vx cv cA wss vx
      cat crab chsup cfv cort cfv cin wss wn vy cv cat wcel vy cv cA wss vy cv
      vx cv cA wss vx cat crab chsup cfv cort cfv wss wn wi vy cv cA wss vy cv
      vx cv cA wss vx cat crab chsup cfv cort cfv wss wa wn vy cv cat wcel vy
      cv cA wss vy cv vx cv cA wss vx cat crab chsup cfv wss vy cv vx cv cA wss
      vx cat crab chsup cfv cort cfv wss wn vy cv cat wcel vy cv cA wss vy cv
      vx cv cA wss vx cat crab chsup cfv wss vy cv cat wcel vy cv cA wss wa vy
      cv vx cv cA wss vx cat crab cuni wss vy cv vx cv cA wss vx cat crab chsup
      cfv wss vy cv cat wcel vy cv cA wss wa vy cv vx cv cA wss vx cat crab
      wcel vy cv vx cv cA wss vx cat crab cuni wss vx cv cA wss vy cv cA wss vx
      vy cv cat vx cv vy cv cA sseq1 elrab vy cv vx cv cA wss vx cat crab
      elssuni sylbir vy cv vx cv cA wss vx cat crab cuni wss vx cv cA wss vx
      cat crab cuni vx cv cA wss vx cat crab chsup cfv wss vy cv vx cv cA wss
      vx cat crab chsup cfv wss vx cv cA wss vx cat crab cch wss vx cv cA wss
      vx cat crab cuni vx cv cA wss vx cat crab chsup cfv wss vx cv cA wss vx
      cat crab cat cch vx cv cA wss vx cat ssrab2 atssch sstri vx cv cA wss vx
      cat crab chsupunss ax-mp vy cv vx cv cA wss vx cat crab cuni vx cv cA wss
      vx cat crab chsup cfv sstr2 mpi syl ex vy cv cat wcel vy cv vx cv cA wss
      vx cat crab chsup cfv wss vy cv vx cv cA wss vx cat crab chsup cfv cort
      cfv wss wn vy cv cat wcel vy cv vx cv cA wss vx cat crab chsup cfv wss wa
      vy cv c0h wne vy cv vx cv cA wss vx cat crab chsup cfv cort cfv wss wn vy
      cv cat wcel vy cv c0h wne vy cv vx cv cA wss vx cat crab chsup cfv wss vy
      cv atn0 adantr vy cv cat wcel vy cv vx cv cA wss vx cat crab chsup cfv
      wss wa vy cv vx cv cA wss vx cat crab chsup cfv cort cfv wss vy cv c0h vy
      cv cat wcel vy cv vx cv cA wss vx cat crab chsup cfv wss vy cv vx cv cA
      wss vx cat crab chsup cfv cort cfv wss vy cv c0h wceq wi vy cv cat wcel
      vy cv vx cv cA wss vx cat crab chsup cfv wss vy cv vx cv cA wss vx cat
      crab chsup cfv cort cfv wss vy cv c0h wceq vy cv cat wcel vy cv vx cv cA
      wss vx cat crab chsup cfv wss vy cv vx cv cA wss vx cat crab chsup cfv
      cort cfv wss wa vy cv c0h wceq vy cv cat wcel vy cv c0h wss vy cv c0h
      wceq vy cv vx cv cA wss vx cat crab chsup cfv wss vy cv vx cv cA wss vx
      cat crab chsup cfv cort cfv wss wa vy cv cat wcel vy cv cch wcel vy cv
      c0h wss vy cv c0h wceq wb vy cv atelch vy cv chle0 syl vy cv vx cv cA wss
      vx cat crab chsup cfv wss vy cv vx cv cA wss vx cat crab chsup cfv cort
      cfv wss wa vy cv vx cv cA wss vx cat crab chsup cfv vx cv cA wss vx cat
      crab chsup cfv cort cfv cin wss vy cv c0h wss vy cv vx cv cA wss vx cat
      crab chsup cfv vx cv cA wss vx cat crab chsup cfv cort cfv ssin vx cv cA
      wss vx cat crab chsup cfv vx cv cA wss vx cat crab chsup cfv cort cfv cin
      c0h vy cv vx cv cA wss vx cat crab chsup cfv vx cv cA wss vx cat crab cch
      wss vx cv cA wss vx cat crab chsup cfv cch wcel vx cv cA wss vx cat crab
      cat cch vx cv cA wss vx cat ssrab2 atssch sstri vx cv cA wss vx cat crab
      chsupcl ax-mp chocini sseq2i bitr2i syl5bbr biimpa exp32 imp necon3ad mpd
      ex syld vy cv cA wss vy cv vx cv cA wss vx cat crab chsup cfv cort cfv
      wss imnan sylib vy cv cA wss vy cv vx cv cA wss vx cat crab chsup cfv
      cort cfv wss wa vy cv cA vx cv cA wss vx cat crab chsup cfv cort cfv cin
      wss vy cv cA vx cv cA wss vx cat crab chsup cfv cort cfv ssin notbii
      sylib nrex vy cv cA vx cv cA wss vx cat crab chsup cfv cort cfv cin wss
      vy cat wrex cA vx cv cA wss vx cat crab chsup cfv cort cfv cin c0h vy cA
      vx cv cA wss vx cat crab chsup cfv cort cfv cin cA vx cv cA wss vx cat
      crab chsup cfv cort cfv hatomistic.1 vx cv cA wss vx cat crab chsup cfv
      vx cv cA wss vx cat crab cch wss vx cv cA wss vx cat crab chsup cfv cch
      wcel vx cv cA wss vx cat crab cat cch vx cv cA wss vx cat ssrab2 atssch
      sstri vx cv cA wss vx cat crab chsupcl ax-mp choccli chincli hatomici
      necon1bi ax-mp omlsii eqcomi $.
      $( [14-Aug-2002] $)
  $}

  ${
    $d x A $.  $d x B $.
    chpssat.1 $e |- A e. CH $.
    chpssat.2 $e |- B e. CH $.
    $( Two Hilbert lattice elements in a proper subset relationship imply
       the existence of an atom less than or equal to one but not the other. $)
    chpssati $p |- ( A C. B -> E. x e. Atoms ( x C_ B /\ -. x C_ A ) ) $=
      cA cB wpss cB cA wss wn vx cv cB wss vx cv cA wss wn wa vx cat wrex cA cB
      wpss cA cB wss cB cA wss wn cA cB dfpss3 pm3.27bi cB cA wss wn vx cv cB
      wss vx cv cA wss wn wa wn vx cat wral wn vx cv cB wss vx cv cA wss wn wa
      vx cat wrex vx cv cB wss vx cv cA wss wn wa wn vx cat wral cB cA wss vx
      cv cB wss vx cv cA wss wn wa wn vx cat wral vx cv cB wss vx cv cA wss wi
      vx cat wral cB cA wss vx cv cB wss vx cv cA wss wi vx cv cB wss vx cv cA
      wss wn wa wn vx cat vx cv cB wss vx cv cA wss iman ralbii vx cv cB wss vx
      cv cA wss wi vx cat wral vx cv cB wss vx cat crab vx cv cA wss vx cat
      crab wss cB cA wss vx cv cB wss vx cv cA wss vx cat ss2rab vx cv cB wss
      vx cat crab vx cv cA wss vx cat crab wss vx cv cB wss vx cat crab chsup
      cfv vx cv cA wss vx cat crab chsup cfv cB cA vx cv cB wss vx cat crab cch
      wss vx cv cA wss vx cat crab cch wss vx cv cB wss vx cat crab vx cv cA
      wss vx cat crab wss vx cv cB wss vx cat crab chsup cfv vx cv cA wss vx
      cat crab chsup cfv wss wi vx cv cB wss vx cat crab cat cch vx cv cB wss
      vx cat ssrab2 atssch sstri vx cv cA wss vx cat crab cat cch vx cv cA wss
      vx cat ssrab2 atssch sstri vx cv cB wss vx cat crab vx cv cA wss vx cat
      crab chsupss mp2an vx cB chpssat.2 hatomistici vx cA chpssat.1
      hatomistici 3sstr4g sylbir sylbir con3i vx cv cB wss vx cv cA wss wn wa
      vx cat dfrex2 sylibr syl $.
      $( [26-Jul-2004] $) $( [10-Jun-2004] $)

    $( The Hilbert lattice is relatively atomic.  Remark 2 of [Kalmbach]
       p. 149. $)
    chrelati $p |- ( A C. B ->
                  E. x e. Atoms ( A C. ( A vH x ) /\ ( A vH x ) C_ B ) ) $=
      cA cB wpss vx cv cB wss vx cv cA wss wn wa vx cat wrex cA cA vx cv chj co
      wpss cA vx cv chj co cB wss wa vx cat wrex vx cA cB chpssat.1 chpssat.2
      chpssati cA cB wpss vx cv cB wss vx cv cA wss wn wa cA cA vx cv chj co
      wpss cA vx cv chj co cB wss wa vx cat cA cB wpss vx cv cat wcel wa vx cv
      cA wss wn vx cv cB wss wa cA cA vx cv chj co wpss cA vx cv chj co cB wss
      wa vx cv cB wss vx cv cA wss wn wa cA cB wss vx cv cch wcel vx cv cA wss
      wn vx cv cB wss wa cA cA vx cv chj co wpss cA vx cv chj co cB wss wa wb
      cA cB wpss vx cv cat wcel cA cB wss vx cv cch wcel wa vx cv cA wss wn cA
      cA vx cv chj co wpss vx cv cB wss cA vx cv chj co cB wss vx cv cch wcel
      vx cv cA wss wn cA cA vx cv chj co wpss wb cA cB wss cA cch wcel vx cv
      cch wcel vx cv cA wss wn cA cA vx cv chj co wpss wb chpssat.1 cA vx cv
      chnle mpan adantl cA cB wss vx cv cB wss cA cB wss vx cv cB wss wa vx cv
      cch wcel cA vx cv chj co cB wss cA cB wss vx cv cB wss ibar cA cch wcel
      vx cv cch wcel cB cch wcel cA cB wss vx cv cB wss wa cA vx cv chj co cB
      wss wb chpssat.1 chpssat.2 cA vx cv cB chlub mp3an13 sylan9bb anbi12d cA
      cB pssss vx cv atelch syl2an vx cv cB wss vx cv cA wss wn ancom syl5bb
      rexbidva mpbid $.
      $( [26-Jul-2004] $) $( [11-Jun-2004] $)

    $( A consequence of relative atomicity. $)
    chrelat2i $p |- ( -. A C_ B <-> E. x e. Atoms ( x C_ A /\ -. x C_ B ) ) $=
      cA cB wss wn vx cv cA wss vx cv cB wss wn wa vx cat wrex cA cB wss wn cA
      cB cin cA wpss vx cv cA wss vx cv cB wss wn wa vx cat wrex cA cB nssinpss
      cA cB cin cA wpss cA cB cin cA cB cin vx cv chj co wpss cA cB cin vx cv
      chj co cA wss wa vx cat wrex vx cv cA wss vx cv cB wss wn wa vx cat wrex
      vx cA cB cin cA cA cB chpssat.1 chpssat.2 chincli chpssat.1 chrelati cA
      cB cin cA cB cin vx cv chj co wpss cA cB cin vx cv chj co cA wss wa vx cv
      cA wss vx cv cB wss wn wa vx cat vx cv cat wcel vx cv cch wcel cA cB cin
      cA cB cin vx cv chj co wpss cA cB cin vx cv chj co cA wss wa vx cv cA wss
      vx cv cB wss wn wa wi vx cv atelch vx cv cch wcel cA cB cin cA cB cin vx
      cv chj co wpss cA cB cin vx cv chj co cA wss wa vx cv cA wss vx cv cB wss
      wn vx cv cch wcel cA cB cin vx cv chj co cA wss vx cv cA wss cA cB cin cA
      cB cin vx cv chj co wpss vx cv cch wcel cA cB cin vx cv chj co cA wss cA
      cB cin cA wss vx cv cA wss wa vx cv cA wss cA cB cin cch wcel vx cv cch
      wcel cA cch wcel cA cB cin cA wss vx cv cA wss wa cA cB cin vx cv chj co
      cA wss wb cA cB chpssat.1 chpssat.2 chincli chpssat.1 cA cB cin vx cv cA
      chlub mp3an13 cA cB cin cA wss vx cv cA wss pm3.27 syl6bir adantld vx cv
      cch wcel cA cB cin cA cB cin vx cv chj co wpss cA cB cin vx cv chj co cA
      wss wa vx cv cA wss vx cv cB wss wa wn cA cB cin cA wss vx cv cA wss wa
      wa vx cv cB wss wn vx cv cch wcel vx cv cA wss vx cv cB wss wa wn cA cB
      cin cA cB cin vx cv chj co wpss cA cB cin cA wss vx cv cA wss wa cA cB
      cin vx cv chj co cA wss vx cv cch wcel vx cv cA cB cin wss wn cA cB cin
      cA cB cin vx cv chj co wpss vx cv cA wss vx cv cB wss wa wn cA cB cin cch
      wcel vx cv cch wcel vx cv cA cB cin wss wn cA cB cin cA cB cin vx cv chj
      co wpss wb cA cB chpssat.1 chpssat.2 chincli cA cB cin vx cv chnle mpan
      vx cv cA wss vx cv cB wss wa vx cv cA cB cin wss vx cv cA cB ssin notbii
      syl5bb cA cB cin cch wcel vx cv cch wcel cA cch wcel cA cB cin cA wss vx
      cv cA wss wa cA cB cin vx cv chj co cA wss wb cA cB chpssat.1 chpssat.2
      chincli chpssat.1 cA cB cin vx cv cA chlub mp3an13 anbi12d vx cv cA wss
      vx cv cB wss wa wn vx cv cA wss vx cv cB wss wn cA cB cin cA wss vx cv cB
      wss vx cv cA wss vx cv cB wss wa wn vx cv cA wss wa vx cv cB wss vx cv cA
      wss vx cv cA wss vx cv cB wss wa wi vx cv cA wss vx cv cB wss wa wn vx cv
      cA wss wa wn vx cv cB wss vx cv cA wss pm3.21 vx cv cA wss vx cv cB wss
      wa wn vx cv cA wss wa wn vx cv cA wss vx cv cB wss wa wn wn vx cv cA wss
      wn wo vx cv cA wss vx cv cB wss wa vx cv cA wss wn wo vx cv cA wss vx cv
      cA wss vx cv cB wss wa wi vx cv cA wss vx cv cB wss wa wn vx cv cA wss
      ianor vx cv cA wss vx cv cB wss wa vx cv cA wss vx cv cB wss wa wn wn vx
      cv cA wss wn vx cv cA wss vx cv cB wss wa notnot orbi1i vx cv cA wss vx
      cv cB wss wa vx cv cA wss wn wo vx cv cA wss wn vx cv cA wss vx cv cB wss
      wa wo vx cv cA wss vx cv cA wss vx cv cB wss wa wi vx cv cA wss vx cv cB
      wss wa vx cv cA wss wn orcom vx cv cA wss vx cv cA wss vx cv cB wss wa
      imor bitr4i 3bitr2ri sylib con2i adantrl syl6bir jcad syl r19.22i syl
      sylbi cA cB wss vx cv cA wss vx cv cB wss wn wa vx cat wrex cA cB wss vx
      cv cA wss vx cv cB wss wi vx cat wral vx cv cA wss vx cv cB wss wn wa vx
      cat wrex wn cA cB wss vx cv cA wss vx cv cB wss wi vx cat cA cB wss vx cv
      cA wss vx cv cB wss wi vx cv cat wcel vx cv cA wss cA cB wss vx cv cB wss
      vx cv cA cB sstr2 com12 a1d r19.21aiv vx cv cA wss vx cv cB wss wi vx cat
      wral vx cv cA wss vx cv cB wss wn wa wn vx cat wral vx cv cA wss vx cv cB
      wss wn wa vx cat wrex wn vx cv cA wss vx cv cB wss wi vx cv cA wss vx cv
      cB wss wn wa wn vx cat vx cv cA wss vx cv cB wss iman ralbii vx cv cA wss
      vx cv cB wss wn wa vx cat ralnex bitri sylib con2i impbii $.
      $( [26-Jul-2004] $) $( [30-Jun-2004] $)

    $( If a Hilbert lattice element covers another, it equals the other joined
       with some atom.  This is a consequence of the relative atomicity of
       Hilbert space. $)
    cvati $p |- ( A <o B -> E. x e. Atoms ( A vH x ) = B ) $=
      cA cB ccv wbr cA cA vx cv chj co wpss cA vx cv chj co cB wss wa vx cat
      wrex cA vx cv chj co cB wceq vx cat wrex cA cB ccv wbr cA cB wpss cA cA
      vx cv chj co wpss cA vx cv chj co cB wss wa vx cat wrex cA cch wcel cB
      cch wcel cA cB ccv wbr cA cB wpss wi chpssat.1 chpssat.2 cA cB cvpss
      mp2an vx cA cB chpssat.1 chpssat.2 chrelati syl cA cB ccv wbr cA cA vx cv
      chj co wpss cA vx cv chj co cB wss wa cA vx cv chj co cB wceq vx cat vx
      cv cat wcel cA cB ccv wbr cA cA vx cv chj co wpss cA vx cv chj co cB wss
      wa cA vx cv chj co cB wceq wi vx cv cat wcel cA vx cv chj co cch wcel cA
      cB ccv wbr cA cA vx cv chj co wpss cA vx cv chj co cB wss wa cA vx cv chj
      co cB wceq wi wi vx cv cat wcel vx cv cch wcel cA vx cv chj co cch wcel
      vx cv atelch cA cch wcel vx cv cch wcel cA vx cv chj co cch wcel
      chpssat.1 cA vx cv chjcl mpan syl cA cch wcel cB cch wcel cA vx cv chj co
      cch wcel cA cB ccv wbr cA cA vx cv chj co wpss cA vx cv chj co cB wss wa
      cA vx cv chj co cB wceq wi wi chpssat.1 chpssat.2 cA cB cA vx cv chj co
      cvnbtwn2 mp3an12 syl com12 r19.22dv mpd $.
      $( [30-Mar-2005] $) $( [30-Nov-2004] $)

    $( An alternate way to express the covering property. $)
    cvbr3i $p |- ( A <o B <-> ( A C. B /\ E. x e. Atoms ( A vH x ) = B ) ) $=
      cA cB ccv wbr cA cB wpss cA vx cv chj co cB wceq vx cat wrex wa cA cB ccv
      wbr cA cB wpss cA vx cv chj co cB wceq vx cat wrex cA cch wcel cB cch
      wcel cA cB ccv wbr cA cB wpss wi chpssat.1 chpssat.2 cA cB cvpss mp2an vx
      cA cB chpssat.1 chpssat.2 cvati jca cA cB wpss cA vx cv chj co cB wceq vx
      cat wrex cA cB ccv wbr cA cB wpss cA vx cv chj co cB wceq cA cB ccv wbr
      vx cat vx cv cat wcel cA vx cv chj co cB wceq cA cB wpss cA cB ccv wbr vx
      cv cat wcel cA vx cv chj co cB wceq cA cB wpss cA cB ccv wbr wi vx cv cat
      wcel cA vx cv chj co cB wceq wa cA cB wpss cA cB ccv wbr vx cv cat wcel
      cA vx cv chj co cB wceq wa cA cA vx cv chj co wpss cA cA vx cv chj co ccv
      wbr cA cB wpss cA cB ccv wbr vx cv cat wcel cA cA vx cv chj co wpss cA cA
      vx cv chj co ccv wbr wb cA vx cv chj co cB wceq cA cch wcel vx cv cat
      wcel cA cA vx cv chj co wpss cA cA vx cv chj co ccv wbr wb chpssat.1 cA
      vx cv chcv2 mpan adantr cA vx cv chj co cB wceq cA cA vx cv chj co wpss
      cA cB wpss wb vx cv cat wcel cA vx cv chj co cB cA psseq2 adantl cA vx cv
      chj co cB wceq cA cA vx cv chj co ccv wbr cA cB ccv wbr wb vx cv cat wcel
      cA vx cv chj co cB cA ccv breq2 adantl 3bitr3d biimpd ex com3r r19.23adv
      imp impbii $.
      $( [10-Jun-2005] $) $( [30-Nov-2004] $)

    $( Lemma for ~ cvexchi . $)
    cvexchlem $p |- ( ( A i^i B ) <o B -> A <o ( A vH B ) ) $=
      vx cv cB wss vx cv cA cB cin wss wn wa vx cat wrex cA cB cin cB ccv wbr
      cA cA cB chj co ccv wbr cA cB cin cB ccv wbr cA cB cin cB wpss vx cv cB
      wss vx cv cA cB cin wss wn wa vx cat wrex cA cB cin cch wcel cB cch wcel
      cA cB cin cB ccv wbr cA cB cin cB wpss wi cA cB chpssat.1 chpssat.2
      chincli chpssat.2 cA cB cin cB cvpss mp2an vx cA cB cin cB cA cB
      chpssat.1 chpssat.2 chincli chpssat.2 chpssati syl vx cv cB wss vx cv cA
      cB cin wss wn wa cA cB cin cB ccv wbr cA cA cB chj co ccv wbr wi vx cat
      vx cv cat wcel vx cv cB wss vx cv cA cB cin wss wn wa cA cB cin cB ccv
      wbr cA cA cB chj co ccv wbr vx cv cat wcel vx cv cB wss vx cv cA cB cin
      wss wn wa cA cB cin cB ccv wbr wa wa cA cA vx cv chj co cA cB chj co ccv
      vx cv cat wcel vx cv cB wss vx cv cA cB cin wss wn wa cA cA vx cv chj co
      ccv wbr cA cB cin cB ccv wbr vx cv cat wcel vx cv cA wss wn cA cA vx cv
      chj co ccv wbr vx cv cB wss vx cv cA cB cin wss wn wa vx cv cat wcel vx
      cv cA wss wn cA cA vx cv chj co ccv wbr cA cch wcel vx cv cat wcel vx cv
      cA wss wn cA cA vx cv chj co ccv wbr wb chpssat.1 cA vx cv chcv1 mpan
      biimpa vx cv cB wss vx cv cA wss wn vx cv cA cB cin wss wn vx cv cB wss
      vx cv cA wss vx cv cA cB cin wss vx cv cA cB cin wss vx cv cB wss vx cv
      cA wss vx cv cA cB cin wss vx cv cA wss vx cv cB wss wa vx cv cB wss vx
      cv cA wss wa vx cv cA cB ssin vx cv cA wss vx cv cB wss ancom bitr3i
      baibr notbid biimpar sylan2 adantrr vx cv cch wcel vx cv cB wss vx cv cA
      cB cin wss wn wa cA cB cin cB ccv wbr wa cA vx cv chj co cA cB chj co
      wceq vx cv cat wcel vx cv cch wcel vx cv cB wss vx cv cA cB cin wss wn wa
      cA cB cin cB ccv wbr wa wa cA cA cB cin vx cv chj co chj co cA vx cv chj
      co cA cB chj co vx cv cch wcel cA cA cB cin vx cv chj co chj co cA vx cv
      chj co wceq vx cv cB wss vx cv cA cB cin wss wn wa cA cB cin cB ccv wbr
      wa vx cv cch wcel cA cA cB cin chj co vx cv chj co cA cA cB cin vx cv chj
      co chj co cA vx cv chj co cA cch wcel cA cB cin cch wcel vx cv cch wcel
      cA cA cB cin chj co vx cv chj co cA cA cB cin vx cv chj co chj co wceq
      chpssat.1 cA cB chpssat.1 chpssat.2 chincli cA cA cB cin vx cv chjass
      mp3an12 cA cA cB cin chj co cA vx cv chj cA cB chpssat.1 chpssat.2
      chabs1i opreq1i syl5reqr adantr vx cv cch wcel vx cv cB wss vx cv cA cB
      cin wss wn wa cA cB cin cB ccv wbr wa wa cA cB cin vx cv chj co cB cA chj
      vx cv cch wcel vx cv cB wss vx cv cA cB cin wss wn wa cA cB cin cB ccv
      wbr cA cB cin vx cv chj co cB wceq vx cv cch wcel vx cv cB wss vx cv cA
      cB cin wss wn wa cA cB cin cA cB cin vx cv chj co wpss cA cB cin vx cv
      chj co cB wss wa cA cB cin cB ccv wbr cA cB cin vx cv chj co cB wceq wi
      vx cv cch wcel vx cv cA cB cin wss wn vx cv cB wss wa cA cB cin cA cB cin
      vx cv chj co wpss cA cB cin vx cv chj co cB wss wa vx cv cB wss vx cv cA
      cB cin wss wn wa vx cv cch wcel vx cv cA cB cin wss wn cA cB cin cA cB
      cin vx cv chj co wpss vx cv cB wss cA cB cin vx cv chj co cB wss cA cB
      cin cch wcel vx cv cch wcel vx cv cA cB cin wss wn cA cB cin cA cB cin vx
      cv chj co wpss wb cA cB chpssat.1 chpssat.2 chincli cA cB cin vx cv chnle
      mpan vx cv cch wcel cA cB cin cB wss vx cv cB wss wa cA cB cin vx cv chj
      co cB wss vx cv cB wss cA cB cin cch wcel vx cv cch wcel cB cch wcel cA
      cB cin cB wss vx cv cB wss wa cA cB cin vx cv chj co cB wss wb cA cB
      chpssat.1 chpssat.2 chincli chpssat.2 cA cB cin vx cv cB chlub mp3an13 cA
      cB cin cB wss vx cv cB wss cA cB inss2 biantrur syl5bb anbi12d vx cv cB
      wss vx cv cA cB cin wss wn ancom syl5bb vx cv cch wcel cA cB cin cB ccv
      wbr cA cB cin cA cB cin vx cv chj co wpss cA cB cin vx cv chj co cB wss
      wa cA cB cin vx cv chj co cB wceq vx cv cch wcel cA cB cin vx cv chj co
      cch wcel cA cB cin cB ccv wbr cA cB cin cA cB cin vx cv chj co wpss cA cB
      cin vx cv chj co cB wss wa cA cB cin vx cv chj co cB wceq wi wi cA cB cin
      cch wcel vx cv cch wcel cA cB cin vx cv chj co cch wcel cA cB chpssat.1
      chpssat.2 chincli cA cB cin vx cv chjcl mpan cA cB cin cch wcel cB cch
      wcel cA cB cin vx cv chj co cch wcel cA cB cin cB ccv wbr cA cB cin cA cB
      cin vx cv chj co wpss cA cB cin vx cv chj co cB wss wa cA cB cin vx cv
      chj co cB wceq wi wi cA cB chpssat.1 chpssat.2 chincli chpssat.2 cA cB
      cin cB cA cB cin vx cv chj co cvnbtwn2 mp3an12 syl com23 sylbid imp32
      opreq2d eqtr3d vx cv atelch sylan breqtrd exp32 r19.23aiv mpcom $.
      $( [26-Jul-2004] $) $( [10-Jun-2004] $)

    $( The Hilbert lattice satisfies the exchange axiom.  Proposition 1(iii) of
       [Kalmbach] p. 140 and its converse.  Originally proved by Garrett
       Birkhoff in 1933. $)
    cvexchi $p |- ( ( A i^i B ) <o B <-> A <o ( A vH B ) ) $=
      cA cB cin cB ccv wbr cA cA cB chj co ccv wbr cA cB chpssat.1 chpssat.2
      cvexchlem cA cB chj co cort cfv cA cort cfv ccv wbr cB cort cfv cA cB cin
      cort cfv ccv wbr cA cA cB chj co ccv wbr cA cB cin cB ccv wbr cB cort cfv
      cA cort cfv cin cA cort cfv ccv wbr cB cort cfv cB cort cfv cA cort cfv
      chj co ccv wbr cA cB chj co cort cfv cA cort cfv ccv wbr cB cort cfv cA
      cB cin cort cfv ccv wbr cB cort cfv cA cort cfv cB chpssat.2 choccli cA
      chpssat.1 choccli cvexchlem cA cB chj co cort cfv cB cort cfv cA cort cfv
      cin cA cort cfv ccv cA cB chj co cort cfv cA cort cfv cB cort cfv cin cB
      cort cfv cA cort cfv cin cA cB chpssat.1 chpssat.2 chdmj1i cA cort cfv cB
      cort cfv incom eqtri breq1i cA cB cin cort cfv cB cort cfv cA cort cfv
      chj co cB cort cfv ccv cA cB cin cort cfv cA cort cfv cB cort cfv chj co
      cB cort cfv cA cort cfv chj co cA cB chpssat.1 chpssat.2 chdmm1i cA cort
      cfv cB cort cfv cA chpssat.1 choccli cB chpssat.2 choccli chjcomi eqtri
      breq2i 3imtr4i cA cch wcel cA cB chj co cch wcel cA cA cB chj co ccv wbr
      cA cB chj co cort cfv cA cort cfv ccv wbr wb chpssat.1 cA cB chpssat.1
      chpssat.2 chjcli cA cA cB chj co cvcon3 mp2an cA cB cin cch wcel cB cch
      wcel cA cB cin cB ccv wbr cB cort cfv cA cB cin cort cfv ccv wbr wb cA cB
      chpssat.1 chpssat.2 chincli chpssat.2 cA cB cin cB cvcon3 mp2an 3imtr4i
      impbii $.
      $( [26-Jul-2004] $) $( [12-Jun-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    $( A consequence of relative atomicity. $)
    chrelat2 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( -. A C_ B <-> E. x e. Atoms ( x C_ A /\ -. x C_ B ) ) ) $=
      cA cch wcel cB cch wcel cA cB wss wn vx cv cA wss vx cv cB wss wn wa vx
      cat wrex wb cA cch wcel cA chil cif cB wss wn vx cv cA cch wcel cA chil
      cif wss vx cv cB wss wn wa vx cat wrex wb cA cch wcel cA chil cif cB cch
      wcel cB chil cif wss wn vx cv cA cch wcel cA chil cif wss vx cv cB cch
      wcel cB chil cif wss wn wa vx cat wrex wb cA cB chil chil cA cA cch wcel
      cA chil cif wceq cA cB wss wn cA cch wcel cA chil cif cB wss wn vx cv cA
      wss vx cv cB wss wn wa vx cat wrex vx cv cA cch wcel cA chil cif wss vx
      cv cB wss wn wa vx cat wrex cA cA cch wcel cA chil cif wceq cA cB wss cA
      cch wcel cA chil cif cB wss cA cA cch wcel cA chil cif cB sseq1 notbid cA
      cA cch wcel cA chil cif wceq vx cv cA wss vx cv cB wss wn wa vx cv cA cch
      wcel cA chil cif wss vx cv cB wss wn wa vx cat cA cA cch wcel cA chil cif
      wceq vx cv cA wss vx cv cA cch wcel cA chil cif wss vx cv cB wss wn cA cA
      cch wcel cA chil cif vx cv sseq2 anbi1d rexbidv bibi12d cB cB cch wcel cB
      chil cif wceq cA cch wcel cA chil cif cB wss wn cA cch wcel cA chil cif
      cB cch wcel cB chil cif wss wn vx cv cA cch wcel cA chil cif wss vx cv cB
      wss wn wa vx cat wrex vx cv cA cch wcel cA chil cif wss vx cv cB cch wcel
      cB chil cif wss wn wa vx cat wrex cB cB cch wcel cB chil cif wceq cA cch
      wcel cA chil cif cB wss cA cch wcel cA chil cif cB cch wcel cB chil cif
      wss cB cB cch wcel cB chil cif cA cch wcel cA chil cif sseq2 notbid cB cB
      cch wcel cB chil cif wceq vx cv cA cch wcel cA chil cif wss vx cv cB wss
      wn wa vx cv cA cch wcel cA chil cif wss vx cv cB cch wcel cB chil cif wss
      wn wa vx cat cB cB cch wcel cB chil cif wceq vx cv cB wss wn vx cv cB cch
      wcel cB chil cif wss wn vx cv cA cch wcel cA chil cif wss cB cB cch wcel
      cB chil cif wceq vx cv cB wss vx cv cB cch wcel cB chil cif wss cB cB cch
      wcel cB chil cif vx cv sseq2 notbid anbi2d rexbidv bibi12d vx cA cch wcel
      cA chil cif cB cch wcel cB chil cif cA chil cch helch elimel cB chil cch
      helch elimel chrelat2i dedth2h $.
      $( [27-Jul-2004] $) $( [1-Jul-2004] $)

    $( A consequence of relative atomicity. $)
    chrelat3 $p |- ( ( A e. CH /\ B e. CH ) ->
                   ( A C_ B <-> A. x e. Atoms ( x C_ A -> x C_ B ) ) ) $=
      cA cch wcel cB cch wcel wa cA cB wss vx cv cA wss vx cv cB wss wn wa wn
      vx cat wral vx cv cA wss vx cv cB wss wi vx cat wral cA cch wcel cB cch
      wcel wa cA cB wss vx cv cA wss vx cv cB wss wn wa wn vx cat wral cA cch
      wcel cB cch wcel wa cA cB wss wn vx cv cA wss vx cv cB wss wn wa vx cat
      wrex vx cv cA wss vx cv cB wss wn wa wn vx cat wral wn vx cA cB chrelat2
      vx cv cA wss vx cv cB wss wn wa vx cat dfrex2 syl6bb con4bid vx cv cA wss
      vx cv cB wss wi vx cv cA wss vx cv cB wss wn wa wn vx cat vx cv cA wss vx
      cv cB wss iman ralbii syl6bbr $.
      $( [27-Jul-2004] $) $( [2-Jul-2004] $)
  $}

  ${
    $d x A $.  $d x B $.
    chrelat3.1 $e |- A e. CH $.
    chrelat3.2 $e |- B e. CH $.
    $( A consequence of the relative atomicity of Hilbert space: the ordering
       of Hilbert lattice elements is completely determined by the atoms they
       majorize. $)
    chrelat3i $p |- ( A C_ B <-> A. x e. Atoms ( x C_ A -> x C_ B ) ) $=
      cA cch wcel cB cch wcel cA cB wss vx cv cA wss vx cv cB wss wi vx cat
      wral wb chrelat3.1 chrelat3.2 vx cA cB chrelat3 mp2an $.
      $( [29-May-2005] $) $( [30-Jun-2004] $)

    $( A consequence of relative atomicity.  Extensionality principle:
       two lattice elements are equal iff they majorize the same atoms. $)
    chrelat4i $p |- ( A = B <-> A. x e. Atoms ( x C_ A <-> x C_ B ) ) $=
      cA cB wss cB cA wss wa vx cv cA wss vx cv cB wss wi vx cat wral vx cv cB
      wss vx cv cA wss wi vx cat wral wa cA cB wceq vx cv cA wss vx cv cB wss
      wb vx cat wral cA cB wss vx cv cA wss vx cv cB wss wi vx cat wral cB cA
      wss vx cv cB wss vx cv cA wss wi vx cat wral vx cA cB chrelat3.1
      chrelat3.2 chrelat3i vx cB cA chrelat3.2 chrelat3.1 chrelat3i anbi12i cA
      cB eqss vx cv cA wss vx cv cB wss wb vx cat wral vx cv cA wss vx cv cB
      wss wi vx cv cB wss vx cv cA wss wi wa vx cat wral vx cv cA wss vx cv cB
      wss wi vx cat wral vx cv cB wss vx cv cA wss wi vx cat wral wa vx cv cA
      wss vx cv cB wss wb vx cv cA wss vx cv cB wss wi vx cv cB wss vx cv cA
      wss wi wa vx cat vx cv cA wss vx cv cB wss dfbi2 ralbii vx cv cA wss vx
      cv cB wss wi vx cv cB wss vx cv cA wss wi vx cat r19.26 bitri 3bitr4i $.
      $( [26-Jul-2005] $) $( [30-Jun-2004] $)
  $}

  $( The Hilbert lattice satisfies the exchange axiom.  Proposition 1(iii) of
     [Kalmbach] p. 140 and its converse.  Originally proved by Garrett
     Birkhoff in 1933. $)
  cvexch $p |- ( ( A e. CH /\ B e. CH ) ->
                ( ( A i^i B ) <o B <-> A <o ( A vH B ) ) ) $=
    cA cch wcel cB cch wcel cA cB cin cB ccv wbr cA cA cB chj co ccv wbr wb cA
    cch wcel cA chil cif cB cin cB ccv wbr cA cch wcel cA chil cif cA cch wcel
    cA chil cif cB chj co ccv wbr wb cA cch wcel cA chil cif cB cch wcel cB
    chil cif cin cB cch wcel cB chil cif ccv wbr cA cch wcel cA chil cif cA cch
    wcel cA chil cif cB cch wcel cB chil cif chj co ccv wbr wb cA cB chil chil
    cA cA cch wcel cA chil cif wceq cA cB cin cB ccv wbr cA cch wcel cA chil
    cif cB cin cB ccv wbr cA cA cB chj co ccv wbr cA cch wcel cA chil cif cA
    cch wcel cA chil cif cB chj co ccv wbr cA cA cch wcel cA chil cif wceq cA
    cB cin cA cch wcel cA chil cif cB cin cB ccv cA cA cch wcel cA chil cif cB
    ineq1 breq1d cA cA cch wcel cA chil cif wceq cA cA cch wcel cA chil cif cA
    cB chj co cA cch wcel cA chil cif cB chj co ccv cA cA cch wcel cA chil cif
    wceq id cA cA cch wcel cA chil cif cB chj opreq1 breq12d bibi12d cB cB cch
    wcel cB chil cif wceq cA cch wcel cA chil cif cB cin cB ccv wbr cA cch wcel
    cA chil cif cB cch wcel cB chil cif cin cB cch wcel cB chil cif ccv wbr cA
    cch wcel cA chil cif cA cch wcel cA chil cif cB chj co ccv wbr cA cch wcel
    cA chil cif cA cch wcel cA chil cif cB cch wcel cB chil cif chj co ccv wbr
    cB cB cch wcel cB chil cif wceq cA cch wcel cA chil cif cB cin cA cch wcel
    cA chil cif cB cch wcel cB chil cif cin cB cB cch wcel cB chil cif ccv cB
    cB cch wcel cB chil cif cA cch wcel cA chil cif ineq2 cB cB cch wcel cB
    chil cif wceq id breq12d cB cB cch wcel cB chil cif wceq cA cch wcel cA
    chil cif cB chj co cA cch wcel cA chil cif cB cch wcel cB chil cif chj co
    cA cch wcel cA chil cif ccv cB cB cch wcel cB chil cif cA cch wcel cA chil
    cif chj opreq2 breq2d bibi12d cA cch wcel cA chil cif cB cch wcel cB chil
    cif cA chil cch helch elimel cB chil cch helch elimel cvexchi dedth2h $.
    $( [27-Jul-2004] $) $( [21-Jun-2004] $)

  $( The Hilbert lattice satisfies the covering property of Definition 7.4
     of [MaedaMaeda] p. 31 and its converse. $)
  cvp $p |- ( ( A e. CH /\ B e. Atoms ) ->
            ( ( A i^i B ) = 0H <-> A <o ( A vH B ) ) ) $=
    cA cch wcel cB cat wcel wa cA cB cin cB ccv wbr cA cB cin c0h wceq cA cA cB
    chj co ccv wbr cA cch wcel cB cat wcel cA cB cin cch wcel cA cB cin cB ccv
    wbr cA cB cin c0h wceq wb cA cch wcel cB cch wcel cA cB cin cch wcel cB cat
    wcel cA cB chincl cB atelch sylan2 cA cB cin cB atcveq0 sylancom cA cch
    wcel cB cch wcel cA cB cin cB ccv wbr cA cA cB chj co ccv wbr wb cB cat
    wcel cA cB cvexch cB atelch sylan2 bitr3d $.
    $( [27-Jul-2004] $) $( [21-Jun-2004] $)

  $( The meet of a Hilbert lattice element and an incomparable atom is the zero
     subspace. $)
  atnssm0 $p |- ( ( A e. CH /\ B e. Atoms ) ->
             ( -. B C_ A <-> ( A i^i B ) = 0H ) ) $=
    cA cch wcel cB cat wcel wa cB cA wss wn cA cA cB chj co ccv wbr cA cB cin
    c0h wceq cA cB chcv1 cA cB cvp bitr4d $.
    $( [27-Jul-2004] $) $( [30-Jun-2004] $)

  $( The meet of distinct atoms is the zero subspace. $)
  atnem0 $p |- ( ( A e. Atoms /\ B e. Atoms ) ->
             ( A =/= B <-> ( A i^i B ) = 0H ) ) $=
    cA cat wcel cB cat wcel wa cB cA wss wn cA cB wne cA cB cin c0h wceq cA cat
    wcel cB cat wcel wa cB cA wss cA cB cB cat wcel cA cat wcel cB cA wss cA cB
    wceq wb cB cat wcel cA cat wcel wa cB cA wss cB cA wceq cA cB wceq cB cA
    atsseq cB cA eqcom syl6bb ancoms necon3bbid cA cch wcel cB cat wcel cB cA
    wss wn cA cB cin c0h wceq wb cA cat wcel cA cB atnssm0 cA atelch sylan
    bitr3d $.
    $( [25-Sep-2009] $) $( [25-Jun-2004] $)

  $( The meet of distinct atoms is the zero subspace. $)
  atnem0OLD $p |- ( ( A e. Atoms /\ B e. Atoms ) ->
             ( -. A = B <-> ( A i^i B ) = 0H ) ) $=
    cA cat wcel cB cat wcel wa cB cA wss wn cA cB wceq wn cA cB cin c0h wceq cA
    cat wcel cB cat wcel wa cB cA wss cA cB wceq cB cat wcel cA cat wcel cB cA
    wss cA cB wceq wb cB cat wcel cA cat wcel wa cB cA wss cB cA wceq cA cB
    wceq cB cA atsseq cB cA eqcom syl6bb ancoms notbid cA cch wcel cB cat wcel
    cB cA wss wn cA cB cin c0h wceq wb cA cat wcel cA cB atnssm0 cA atelch
    sylan bitr3d $.
    $( [27-Jul-2004] $) $( [25-Jun-2004] $)

  $( The meet with an atom's superset is the atom. $)
  atssma $p |- ( ( A e. Atoms /\ B e. CH ) ->
            ( A C_ B <-> ( A i^i B ) e. Atoms ) ) $=
    cA cat wcel cB cch wcel wa cA cB wss cA cB cin cat wcel cA cat wcel cA cB
    wss cA cB cin cat wcel wi cB cch wcel cA cB wss cA cB cin cat wcel cA cat
    wcel cA cB wss cA cB cin cA cat cA cB wss cA cB cin cA wceq cA cB df-ss
    biimpi eleq1d biimprcd adantr cA cat wcel cB cch wcel wa cB cA cin c0h wceq
    wn cA cB wss cA cB cin cat wcel cA cat wcel cB cch wcel wa cA cB wss cB cA
    cin c0h wceq cA cat wcel cB cch wcel wa cA cB wss wn cB cA cin c0h wceq cB
    cch wcel cA cat wcel cA cB wss wn cB cA cin c0h wceq wb cB cA atnssm0
    ancoms biimpd con1d cA cB cin cat wcel cB cA cin cat wcel cB cA cin c0h
    wceq wn cA cB cin cB cA cin cat cA cB incom eleq1i cB cA cin cat wcel cB cA
    cin c0h wne cB cA cin c0h wceq wn cB cA cin atn0 cB cA cin c0h df-ne sylib
    sylbi syl5 impbid $.
    $( [2-Jul-2006] $) $( [12-Jun-2006] $)

  $( Two atoms covering the zero subspace are equal. $)
  atcv0eq $p |- ( ( A e. Atoms /\ B e. Atoms ) ->
               ( 0H <o ( A vH B ) <-> A = B ) ) $=
    cA cat wcel cB cat wcel wa c0h cA cB chj co ccv wbr cA cB wceq cA cat wcel
    cB cat wcel wa cA cB wceq c0h cA cB chj co ccv wbr cA cat wcel cB cat wcel
    wa cA cB wceq wn c0h cA ccv wbr cA cA cB chj co ccv wbr wa c0h cA cB chj co
    ccv wbr wn cA cat wcel cB cat wcel wa cA cB wceq wn cA cB cin c0h wceq cA
    cA cB chj co ccv wbr c0h cA ccv wbr cA cA cB chj co ccv wbr wa cA cB
    atnem0OLD cA cch wcel cB cat wcel cA cB cin c0h wceq cA cA cB chj co ccv
    wbr wb cA cat wcel cA cB cvp cA atelch sylan cA cat wcel cB cat wcel wa c0h
    cA ccv wbr cA cA cB chj co ccv wbr cA cat wcel c0h cA ccv wbr cB cat wcel
    cA atcv0 adantr biantrurd 3bitrd cA cch wcel cB cch wcel c0h cA ccv wbr cA
    cA cB chj co ccv wbr wa c0h cA cB chj co ccv wbr wn wi cA cat wcel cB cat
    wcel cA cch wcel cB cch wcel cA cB chj co cch wcel c0h cA ccv wbr cA cA cB
    chj co ccv wbr wa c0h cA cB chj co ccv wbr wn wi cA cB chjcl c0h cch wcel
    cA cch wcel cA cB chj co cch wcel c0h cA ccv wbr cA cA cB chj co ccv wbr wa
    c0h cA cB chj co ccv wbr wn wi h0elch c0h cA cA cB chj co cvntr mp3an1
    syldan cA atelch cB atelch syl2an sylbid con4d cB cat wcel cA cB wceq c0h
    cA cB chj co ccv wbr wi cA cat wcel cA cB wceq cB cat wcel cA cB chj co cat
    wcel c0h cA cB chj co ccv wbr cA cB wceq cB cat wcel cA cB chj co cat wcel
    cA cB wceq cB cat wcel cB cat wcel cA cB chj co cat wcel wb cA cB wceq cB
    cat wcel wa cB cA cB chj co cat cA cB wceq cB cat wcel wa cA cB chj co cB
    cA cB wceq cB cat wcel cA cB chj co cB cB chj co cB cA cB cB chj opreq1 cB
    cat wcel cB cch wcel cB cB chj co cB wceq cB atelch cB chjidm syl sylan9eq
    eqcomd eleq1d ex ibd cA cB chj co atcv0 syl6com adantl impbid $.
    $( [29-Jul-2004] $) $( [26-Jun-2004] $)

  $( Two atoms covering the zero subspace are equal. $)
  atcv1 $p |- ( ( ( A e. CH /\ B e. Atoms /\ C e. Atoms ) /\
                A <o ( B vH C ) ) -> ( A = 0H <-> B = C ) ) $=
    cA cch wcel cB cat wcel cC cat wcel w3a cA cB cC chj co ccv wbr wa cA c0h
    wceq cB cC wceq cA cch wcel cB cat wcel cC cat wcel w3a cA cB cC chj co ccv
    wbr cA c0h wceq cB cC wceq wi cB cat wcel cC cat wcel cA cB cC chj co ccv
    wbr cA c0h wceq cB cC wceq wi wi cA cch wcel cB cat wcel cC cat wcel wa cA
    c0h wceq cA cB cC chj co ccv wbr cB cC wceq cB cat wcel cC cat wcel wa cA
    c0h wceq cA cB cC chj co ccv wbr cB cC wceq wi cB cat wcel cC cat wcel wa
    cA c0h wceq wa cA cB cC chj co ccv wbr cB cC wceq cA c0h wceq cA cB cC chj
    co ccv wbr c0h cB cC chj co ccv wbr cB cat wcel cC cat wcel wa cB cC wceq
    cA c0h cB cC chj co ccv breq1 cB cC atcv0eq sylan9bbr biimpd ex com23
    3adant1 imp cA cch wcel cB cat wcel cC cat wcel w3a cA cB cC chj co ccv wbr
    cB cC wceq cA c0h wceq wi cA cch wcel cC cat wcel cA cB cC chj co ccv wbr
    cB cC wceq cA c0h wceq wi wi cB cat wcel cA cch wcel cC cat wcel cA cB cC
    chj co ccv wbr cB cC wceq cA c0h wceq wi wi cA cch wcel cC cat wcel cB cC
    wceq cA cB cC chj co ccv wbr cA c0h wceq cA cch wcel cC cat wcel cB cC wceq
    cA cB cC chj co ccv wbr cA c0h wceq wi cA cch wcel cC cat wcel cB cC wceq
    wa wa cA cB cC chj co ccv wbr cA c0h wceq cA cch wcel cB cC chj co cat wcel
    cA cB cC chj co ccv wbr cA c0h wceq wb cC cat wcel cB cC wceq wa cA cB cC
    chj co atcveq0 cB cC wceq cC cat wcel cB cC chj co cat wcel cB cC wceq cC
    cat wcel cB cC chj co cat wcel cB cC wceq cC cat wcel cC cat wcel cB cC chj
    co cat wcel wb cB cC wceq cC cat wcel wa cC cB cC chj co cat cB cC wceq cC
    cat wcel wa cB cC chj co cC cB cC wceq cC cat wcel cB cC chj co cC cC chj
    co cC cB cC cC chj opreq1 cC cat wcel cC cch wcel cC cC chj co cC wceq cC
    atelch cC chjidm syl sylan9eq eqcomd eleq1d ex ibd impcom sylan2 biimpd
    exp32 com34 imp 3adant2 imp impbid $.
    $( [29-Jul-2004] $) $( [26-Jun-2004] $)

  $( The Hilbert lattice satisfies the atom exchange property.  Proposition
     1(i) of [Kalmbach] p. 140.  A version of this theorem related to vector
     analysis was originally proved by Hermann Grassmann in 1862.  Also
     Definition 3.4-3(b) in [MegillPavicic] p. 2345 (PDF p. 8) (use ~ atnem0
     to obtain atom inequality). $)
  atexch $p |- ( ( A e. CH /\ B e. Atoms /\ C e. Atoms ) ->
            ( ( B C_ ( A vH C ) /\ ( A i^i B ) = 0H ) -> C C_ ( A vH B ) ) ) $=
    cA cch wcel cB cat wcel cC cat wcel w3a cB cA cC chj co wss cA cB cin c0h
    wceq wa cC cA cB chj co wss cA cch wcel cB cat wcel cC cat wcel w3a cB cA
    cC chj co wss cA cB cin c0h wceq wa wa cC cA cC chj co cA cB chj co cA cch
    wcel cB cat wcel cC cat wcel w3a cC cA cC chj co wss cB cA cC chj co wss cA
    cB cin c0h wceq wa cA cch wcel cC cat wcel cC cA cC chj co wss cB cat wcel
    cA cch wcel cC cch wcel cC cA cC chj co wss cC cat wcel cC cch wcel cA cch
    wcel cC cA cC chj co wss cC cA chub2 ancoms cC atelch sylan2 3adant2 adantr
    cA cch wcel cB cat wcel cC cat wcel w3a cB cA cC chj co wss cA cB cin c0h
    wceq wa wa cA cA cB chj co wpss cA cB chj co cA cC chj co wss wa cA cB chj
    co cA cC chj co wceq cA cch wcel cB cat wcel cC cat wcel w3a cB cA cC chj
    co wss cA cB cin c0h wceq wa cA cA cB chj co wpss cA cB chj co cA cC chj co
    wss wa cA cch wcel cB cat wcel cC cat wcel w3a cB cA cC chj co wss cA cB
    cin c0h wceq wa cA cA cB chj co wpss cA cB chj co cA cC chj co wss cA cch
    wcel cB cat wcel cC cat wcel w3a cA cB cin c0h wceq cA cA cB chj co wpss cB
    cA cC chj co wss cA cch wcel cB cat wcel cA cB cin c0h wceq cA cA cB chj co
    wpss wi cC cat wcel cA cch wcel cB cat wcel wa cA cB cin c0h wceq cA cA cB
    chj co ccv wbr cA cA cB chj co wpss cA cB cvp cA cch wcel cB cat wcel cA cB
    chj co cch wcel cA cA cB chj co ccv wbr cA cA cB chj co wpss wi cA cch wcel
    cB cch wcel cA cB chj co cch wcel cB cat wcel cA cB chjcl cB atelch sylan2
    cA cA cB chj co cvpss syldan sylbid 3adant3 adantld cA cch wcel cB cat wcel
    cC cat wcel w3a cB cA cC chj co wss cA cB chj co cA cC chj co wss cA cB cin
    c0h wceq cA cch wcel cB cch wcel cC cch wcel cB cA cC chj co wss cA cB chj
    co cA cC chj co wss wi cA cch wcel cB cat wcel cC cat wcel cA cch wcel cB
    cch wcel cC cch wcel w3a cB cA cC chj co wss cA cA cC chj co wss cB cA cC
    chj co wss wa cA cB chj co cA cC chj co wss cA cch wcel cB cch wcel cC cch
    wcel w3a cB cA cC chj co wss cA cA cC chj co wss cA cch wcel cB cch wcel cC
    cch wcel w3a cA cA cC chj co wss cB cA cC chj co wss cA cch wcel cC cch
    wcel cA cA cC chj co wss cB cch wcel cA cC chub1 3adant2 a1d ancrd cA cch
    wcel cB cch wcel cA cC chj co cch wcel cA cA cC chj co wss cB cA cC chj co
    wss wa cA cB chj co cA cC chj co wss wb cC cch wcel cA cB cA cC chj co
    chlub cA cch wcel cC cch wcel cA cC chj co cch wcel cB cch wcel cA cC chjcl
    3adant2 syld3an3 sylibd cA cch wcel id cB atelch cC atelch syl3an adantrd
    jcad imp cA cch wcel cB cat wcel cC cat wcel w3a cB cA cC chj co wss cA cB
    cin c0h wceq wa cA cA cB chj co wpss cA cB chj co cA cC chj co wss wa cA cB
    chj co cA cC chj co wceq wi cA cch wcel cB cat wcel cC cat wcel w3a cB cA
    cC chj co wss cA cB cin c0h wceq wa cA cA cC chj co ccv wbr cA cA cB chj co
    wpss cA cB chj co cA cC chj co wss wa cA cB chj co cA cC chj co wceq wi cA
    cch wcel cB cat wcel cC cat wcel w3a cB cA cC chj co wss cA cB cin c0h wceq
    wa cA cA cC chj co wpss cA cA cC chj co ccv wbr cA cch wcel cB cat wcel cC
    cat wcel w3a cB cA cC chj co wss cA cB cin c0h wceq wa cA cA cB chj co wpss
    cA cB chj co cA cC chj co wss wa cA cA cC chj co wpss cA cch wcel cB cat
    wcel cC cat wcel w3a cA cB cin c0h wceq cB cA cC chj co wss cA cA cB chj co
    wpss cA cB chj co cA cC chj co wss wa cA cch wcel cB cat wcel cC cat wcel
    w3a cA cB cin c0h wceq cA cA cB chj co wpss cB cA cC chj co wss cA cB chj
    co cA cC chj co wss cA cch wcel cB cat wcel cA cB cin c0h wceq cA cA cB chj
    co wpss wi cC cat wcel cA cch wcel cB cat wcel wa cA cB cin c0h wceq cA cA
    cB chj co ccv wbr cA cA cB chj co wpss cA cB cvp cA cch wcel cB cat wcel cA
    cB chj co cch wcel cA cA cB chj co ccv wbr cA cA cB chj co wpss wi cA cch
    wcel cB cch wcel cA cB chj co cch wcel cB cat wcel cA cB chjcl cB atelch
    sylan2 cA cA cB chj co cvpss syldan sylbid 3adant3 cA cch wcel cB cch wcel
    cC cch wcel cB cA cC chj co wss cA cB chj co cA cC chj co wss wi cA cch
    wcel cB cat wcel cC cat wcel cA cch wcel cB cch wcel cC cch wcel w3a cB cA
    cC chj co wss cA cA cC chj co wss cB cA cC chj co wss wa cA cB chj co cA cC
    chj co wss cA cch wcel cB cch wcel cC cch wcel w3a cB cA cC chj co wss cA
    cA cC chj co wss cA cch wcel cB cch wcel cC cch wcel w3a cA cA cC chj co
    wss cB cA cC chj co wss cA cch wcel cC cch wcel cA cA cC chj co wss cB cch
    wcel cA cC chub1 3adant2 a1d ancrd cA cch wcel cB cch wcel cA cC chj co cch
    wcel cA cA cC chj co wss cB cA cC chj co wss wa cA cB chj co cA cC chj co
    wss wb cC cch wcel cA cB cA cC chj co chlub cA cch wcel cC cch wcel cA cC
    chj co cch wcel cB cch wcel cA cC chjcl 3adant2 syld3an3 sylibd cA cch wcel
    id cB atelch cC atelch syl3an anim12d ancomsd cA cA cB chj co cA cC chj co
    psssstr syl6 cA cch wcel cC cat wcel cA cA cC chj co wpss cA cA cC chj co
    ccv wbr wb cB cat wcel cA cC chcv2 3adant2 sylibd cA cch wcel cB cat wcel
    cC cat wcel w3a cA cch wcel cA cC chj co cch wcel cA cB chj co cch wcel w3a
    cA cA cC chj co ccv wbr cA cA cB chj co wpss cA cB chj co cA cC chj co wss
    wa cA cB chj co cA cC chj co wceq wi wi cA cch wcel cB cch wcel cC cch wcel
    cA cch wcel cA cC chj co cch wcel cA cB chj co cch wcel w3a cA cch wcel cB
    cat wcel cC cat wcel cA cch wcel cB cch wcel cC cch wcel w3a cA cch wcel cA
    cC chj co cch wcel cA cB chj co cch wcel cA cch wcel cB cch wcel cC cch
    wcel 3simp1 cA cch wcel cC cch wcel cA cC chj co cch wcel cB cch wcel cA cC
    chjcl 3adant2 cA cch wcel cB cch wcel cA cB chj co cch wcel cC cch wcel cA
    cB chjcl 3adant3 3jca cA cch wcel id cB atelch cC atelch syl3an cA cA cC
    chj co cA cB chj co cvnbtwn2 syl syld imp mpd sseqtr4d ex $.
    $( [27-Jul-2004] $) $( [27-Jun-2004] $)

  ${
    $d x A $.  $d x B $.  $d x C $.
    atoml.1 $e |- A e. CH $.
    $( An assertion holding in atomic orthomodular lattices that is equivalent
       to the exchange axiom.  Proposition 3.2.17 of [PtakPulmannova] p. 66. $)
    atomli $p |- ( B e. Atoms ->
                ( ( A vH B ) i^i ( _|_ ` A ) ) e. ( Atoms u. { 0H } ) ) $=
      cB cat wcel cA cB chj co cA cort cfv cin cat wcel cA cB chj co cA cort
      cfv cin c0h wceq wo cA cB chj co cA cort cfv cin cat c0h csn cun wcel cB
      cat wcel cA cB chj co cA cort cfv cin cat wcel cA cB chj co cA cort cfv
      cin c0h wceq cB cat wcel cA cB chj co cA cort cfv cin cat wcel cA cB chj
      co cA cort cfv cin c0h cB cat wcel cA cB chj co cA cort cfv cin c0h wne
      cA cB chj co cA cort cfv cin cat wcel cB cat wcel cA cB chj co cA cort
      cfv cin c0h wne wa vx cv cA cB chj co cA cort cfv cin wss vx cat wrex cA
      cB chj co cA cort cfv cin cat wcel cB cat wcel cA cB chj co cA cort cfv
      cin c0h wne vx cv cA cB chj co cA cort cfv cin wss vx cat wrex cB cat
      wcel cA cB chj co cch wcel cA cB chj co cA cort cfv cin cch wcel cA cB
      chj co cA cort cfv cin c0h wne vx cv cA cB chj co cA cort cfv cin wss vx
      cat wrex wi cB cat wcel cB cch wcel cA cB chj co cch wcel cB atelch cA
      cch wcel cB cch wcel cA cB chj co cch wcel atoml.1 cA cB chjcl mpan syl
      cA cB chj co cch wcel cA cort cfv cch wcel cA cB chj co cA cort cfv cin
      cch wcel cA atoml.1 choccli cA cB chj co cA cort cfv chincl mpan2 cA cB
      chj co cA cort cfv cin cch wcel cA cB chj co cA cort cfv cin c0h wne vx
      cv cA cB chj co cA cort cfv cin wss vx cat wrex vx cA cB chj co cA cort
      cfv cin hatomic ex 3syl imp cB cat wcel cA cB chj co cA cort cfv cin c0h
      wne wa vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA cort cfv
      cin cat wcel vx cat cB cat wcel cA cB chj co cA cort cfv cin c0h wne wa
      vx cv cA cB chj co cA cort cfv cin wss vx cv cat wcel cA cB chj co cA
      cort cfv cin cat wcel cB cat wcel cA cB chj co cA cort cfv cin c0h wne wa
      vx cv cA cB chj co cA cort cfv cin wss vx cv cat wcel cA cB chj co cA
      cort cfv cin cat wcel wi cB cat wcel cA cB chj co cA cort cfv cin c0h wne
      wa vx cv cA cB chj co cA cort cfv cin wss wa vx cv cat wcel cA cB chj co
      cA cort cfv cin cat wcel cB cat wcel cA cB chj co cA cort cfv cin c0h wne
      vx cv cA cB chj co cA cort cfv cin wss vx cv cat wcel vx cv cat wcel cA
      cB chj co cA cort cfv cin cat wcel wb wi cB cat wcel vx cv cat wcel vx cv
      cA cB chj co cA cort cfv cin wss cA cB chj co cA cort cfv cin c0h wne vx
      cv cat wcel cA cB chj co cA cort cfv cin cat wcel wb cB cat wcel vx cv
      cat wcel vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA cort cfv
      cin c0h wne vx cv cat wcel cA cB chj co cA cort cfv cin cat wcel wb cB
      cat wcel vx cv cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB
      chj co cA cort cfv cin c0h wne wa wa vx cv cA cB chj co cA cort cfv cin
      cat cB cat wcel vx cv cat wcel wa vx cv cA cB chj co cA cort cfv cin wss
      cA cB chj co cA cort cfv cin c0h wne wa wa cA vx cv chj co cA cort cfv
      cin vx cv cA cB chj co cA cort cfv cin vx cv cat wcel vx cv cA cB chj co
      cA cort cfv cin wss cA vx cv chj co cA cort cfv cin vx cv wceq cB cat
      wcel cA cB chj co cA cort cfv cin c0h wne vx cv cch wcel vx cv cA cort
      cfv wss cA vx cv chj co cA cort cfv cin vx cv wceq vx cv cat wcel vx cv
      cA cB chj co cA cort cfv cin wss vx cv cch wcel vx cv cA cort cfv wss wa
      cA cort cfv cA cort cfv cort cfv vx cv chj co cin vx cv cA vx cv chj co
      cA cort cfv cin vx cv cch wcel vx cv cA cort cfv wss cA cort cfv cA cort
      cfv cort cfv vx cv chj co cin vx cv wceq cA cort cfv cch wcel vx cv cch
      wcel vx cv cA cort cfv wss cA cort cfv cA cort cfv cort cfv vx cv chj co
      cin vx cv wceq wi cA atoml.1 choccli cA cort cfv vx cv pjoml3 mpan imp cA
      cort cfv cort cfv vx cv chj co cA cort cfv cin cA vx cv chj co cA cort
      cfv cin cA cort cfv cA cort cfv cort cfv vx cv chj co cin cA cort cfv
      cort cfv vx cv chj co cA vx cv chj co cA cort cfv cA cort cfv cort cfv cA
      vx cv chj cA atoml.1 pjococi opreq1i ineq1i cA cort cfv cort cfv vx cv
      chj co cA cort cfv incom eqtr3i syl5eq vx cv atelch vx cv cA cB chj co cA
      cort cfv cin wss cA cB chj co cA cort cfv cin cA cort cfv wss vx cv cA
      cort cfv wss cA cB chj co cA cort cfv inss2 vx cv cA cB chj co cA cort
      cfv cin cA cort cfv sstr mpan2 syl2an ad2ant2lr cB cat wcel vx cv cat
      wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA cort cfv
      cin c0h wne wa wa cA vx cv chj co cA cB chj co cA cort cfv cB cat wcel vx
      cv cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA
      cort cfv cin c0h wne wa wa cA vx cv chj co cA cB chj co cB cat wcel vx cv
      cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA vx cv chj co cA cB
      chj co wss cA cB chj co cA cort cfv cin c0h wne cB cat wcel vx cv cat
      wcel wa vx cv cA cB chj co wss cA vx cv chj co cA cB chj co wss vx cv cA
      cB chj co cA cort cfv cin wss cB cat wcel vx cv cat wcel wa vx cv cA cB
      chj co wss cA vx cv chj co cA cB chj co wss cB cch wcel vx cv cch wcel vx
      cv cA cB chj co wss cA vx cv chj co cA cB chj co wss wi cB cat wcel vx cv
      cat wcel cB cch wcel vx cv cch wcel wa cA cA cB chj co wss vx cv cA cB
      chj co wss cA vx cv chj co cA cB chj co wss cB cch wcel cA cA cB chj co
      wss vx cv cch wcel cA cch wcel cB cch wcel cA cA cB chj co wss atoml.1 cA
      cB chub1 mpan adantr vx cv cch wcel cB cch wcel cA cA cB chj co wss vx cv
      cA cB chj co wss wa cA vx cv chj co cA cB chj co wss wi vx cv cch wcel cB
      cch wcel wa cA cA cB chj co wss vx cv cA cB chj co wss wa cA vx cv chj co
      cA cB chj co wss vx cv cch wcel cA cB chj co cch wcel cA cA cB chj co wss
      vx cv cA cB chj co wss wa cA vx cv chj co cA cB chj co wss wb cB cch wcel
      cA cch wcel vx cv cch wcel cA cB chj co cch wcel cA cA cB chj co wss vx
      cv cA cB chj co wss wa cA vx cv chj co cA cB chj co wss wb atoml.1 cA vx
      cv cA cB chj co chlub mp3an1 cA cch wcel cB cch wcel cA cB chj co cch
      wcel atoml.1 cA cB chjcl mpan sylan2 biimpd ancoms mpand cB atelch vx cv
      atelch syl2an imp vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA
      cort cfv cin cA cB chj co wss vx cv cA cB chj co wss cA cB chj co cA cort
      cfv inss1 vx cv cA cB chj co cA cort cfv cin cA cB chj co sstr mpan2
      sylan2 adantrr cB cch wcel cA vx cv chj co cch wcel wa cB cA vx cv chj co
      wss wa cA cA vx cv chj co wss cA cB chj co cA vx cv chj co wss cB cat
      wcel vx cv cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB chj
      co cA cort cfv cin c0h wne wa wa cB cch wcel cA vx cv chj co cch wcel wa
      cB cA vx cv chj co wss cA cA vx cv chj co wss cA cB chj co cA vx cv chj
      co wss wi cB cch wcel cA vx cv chj co cch wcel wa cA cA vx cv chj co wss
      cB cA vx cv chj co wss cA cB chj co cA vx cv chj co wss cB cch wcel cA vx
      cv chj co cch wcel wa cA cA vx cv chj co wss cB cA vx cv chj co wss cA cB
      chj co cA vx cv chj co wss cB cch wcel cA vx cv chj co cch wcel wa cA cA
      vx cv chj co wss cB cA vx cv chj co wss wa cA cB chj co cA vx cv chj co
      wss cA cch wcel cB cch wcel cA vx cv chj co cch wcel cA cA vx cv chj co
      wss cB cA vx cv chj co wss wa cA cB chj co cA vx cv chj co wss wb atoml.1
      cA cB cA vx cv chj co chlub mp3an1 biimpd exp3a com23 imp cB cat wcel vx
      cv cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA
      cort cfv cin c0h wne wa wa cB cch wcel cA vx cv chj co cch wcel wa cB cA
      vx cv chj co wss cB cat wcel vx cv cat wcel wa cB cch wcel cA vx cv chj
      co cch wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA
      cort cfv cin c0h wne wa cB cat wcel cB cch wcel vx cv cat wcel cA vx cv
      chj co cch wcel cB atelch vx cv cat wcel vx cv cch wcel cA vx cv chj co
      cch wcel vx cv atelch cA cch wcel vx cv cch wcel cA vx cv chj co cch wcel
      atoml.1 cA vx cv chjcl mpan syl anim12i adantr vx cv cat wcel cB cat wcel
      wa vx cv cA cB chj co wss cA vx cv cin c0h wceq wa cB cA vx cv chj co wss
      cB cat wcel vx cv cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA
      cB chj co cA cort cfv cin c0h wne wa wa cA cch wcel vx cv cat wcel cB cat
      wcel vx cv cA cB chj co wss cA vx cv cin c0h wceq wa cB cA vx cv chj co
      wss wi atoml.1 cA vx cv cB atexch mp3an1 cB cat wcel vx cv cat wcel wa vx
      cv cat wcel cB cat wcel wa vx cv cA cB chj co cA cort cfv cin wss cA cB
      chj co cA cort cfv cin c0h wne wa cB cat wcel vx cv cat wcel pm3.22
      adantr vx cv cat wcel vx cv cA cB chj co cA cort cfv cin wss vx cv cA cB
      chj co wss cA vx cv cin c0h wceq wa cB cat wcel cA cB chj co cA cort cfv
      cin c0h wne vx cv cat wcel vx cv cA cB chj co cA cort cfv cin wss wa vx
      cv cA cB chj co wss cA vx cv cin c0h wceq vx cv cA cB chj co cA cort cfv
      cin wss vx cv cA cB chj co wss vx cv cat wcel vx cv cA cB chj co cA cort
      cfv cin wss cA cB chj co cA cort cfv cin cA cB chj co wss vx cv cA cB chj
      co wss cA cB chj co cA cort cfv inss1 vx cv cA cB chj co cA cort cfv cin
      cA cB chj co sstr mpan2 adantl vx cv cch wcel vx cv cA cort cfv wss cA vx
      cv cin c0h wceq vx cv cat wcel vx cv cA cB chj co cA cort cfv cin wss vx
      cv cch wcel vx cv cA cort cfv wss wa vx cv cA cin c0h cA vx cv cin vx cv
      cch wcel vx cv cA cort cfv wss vx cv cA cin c0h wceq vx cv cch wcel vx cv
      csh wcel vx cv cA cort cfv wss vx cv cA cin c0h wceq wi vx cv chsh vx cv
      csh wcel cA csh wcel vx cv cA cort cfv wss vx cv cA cin c0h wceq wi cA
      atoml.1 chshii vx cv cA orthin mpan2 syl imp cA vx cv incom syl5eq vx cv
      atelch vx cv cA cB chj co cA cort cfv cin wss cA cB chj co cA cort cfv
      cin cA cort cfv wss vx cv cA cort cfv wss cA cB chj co cA cort cfv inss2
      vx cv cA cB chj co cA cort cfv cin cA cort cfv sstr mpan2 syl2an jca
      ad2ant2lr sylc jca vx cv cat wcel cA cA vx cv chj co wss cB cat wcel vx
      cv cA cB chj co cA cort cfv cin wss cA cB chj co cA cort cfv cin c0h wne
      wa vx cv cat wcel vx cv cch wcel cA cA vx cv chj co wss vx cv atelch cA
      cch wcel vx cv cch wcel cA cA vx cv chj co wss atoml.1 cA vx cv chub1
      mpan syl ad2antlr sylc eqssd ineq1d eqtr3d eleq1d exp43 com24 imp31 ibd
      ex com23 r19.23adv mpd ex necon1bd orrd cA cB chj co cA cort cfv cin cat
      c0h csn cun wcel cA cB chj co cA cort cfv cin cat wcel cA cB chj co cA
      cort cfv cin c0h csn wcel wo cA cB chj co cA cort cfv cin cat wcel cA cB
      chj co cA cort cfv cin c0h wceq wo cA cB chj co cA cort cfv cin cat c0h
      csn elun cA cB chj co cA cort cfv cin c0h csn wcel cA cB chj co cA cort
      cfv cin c0h wceq cA cB chj co cA cort cfv cin cat wcel cA cB chj co cA
      cort cfv cin c0h cA cort cfv cA cB chj co cA cort fvex inex2 elsnc orbi2i
      bitri sylibr $.
      $( [9-May-2005] $) $( [24-Jun-2004] $)

    $( An assertion holding in atomic orthomodular lattices that is equivalent
       to the exchange axiom.  Proposition P8(ii) of [BeltramettiCassinelli1]
       p. 400. $)
    atoml2i $p |- ( ( B e. Atoms /\ -. B C_ A ) ->
                ( ( A vH B ) i^i ( _|_ ` A ) ) e. Atoms ) $=
      cB cat wcel cB cA wss wn cA cB chj co cA cort cfv cin cat wcel cB cat
      wcel cB cA wss wn cA cB chj co cA cort cfv cin c0h wceq wn cA cB chj co
      cA cort cfv cin cat wcel cB cat wcel cA cB chj co cA cort cfv cin c0h
      wceq cB cA wss cB cat wcel cA cB chj co cA cort cfv cin c0h wceq cA cB
      chj co cA wceq cB cA wss cB cat wcel cA cB chj co cA cort cfv cin c0h
      wceq cA cB chj co cA wceq cB cat wcel cA cB chj co cA cort cfv cin c0h
      wceq cA cB chj co cA cA cort cfv cA cB chj co cin chj co cA cB cat wcel
      cB cch wcel cA cA cort cfv cA cB chj co cin chj co cA cB chj co wceq cB
      atelch cA cch wcel cB cch wcel cA cA cort cfv cA cB chj co cin chj co cA
      cB chj co wceq atoml.1 cA cB pjoml5 mpan syl cA cB chj co cA cort cfv cin
      c0h wceq cA cA cort cfv cA cB chj co cin chj co cA c0h chj co cA cA cB
      chj co cA cort cfv cin c0h wceq cA cort cfv cA cB chj co cin c0h cA chj
      cA cB chj co cA cort cfv cin c0h wceq cA cort cfv cA cB chj co cin c0h
      wceq cA cB chj co cA cort cfv cin cA cort cfv cA cB chj co cin c0h cA cB
      chj co cA cort cfv incom eqeq1i biimpi opreq2d cA atoml.1 chj0i syl6eq
      sylan9req ex cB cat wcel cB cch wcel cB cA wss cA cB chj co cA wceq wb cB
      atelch cB cch wcel cA cch wcel cB cA wss cA cB chj co cA wceq wb atoml.1
      cB cA chlejb2 mpan2 syl sylibrd con3d cB cat wcel cA cB chj co cA cort
      cfv cin c0h wceq cA cB chj co cA cort cfv cin cat wcel cB cat wcel cA cB
      chj co cA cort cfv cin cat c0h csn cun wcel cA cB chj co cA cort cfv cin
      c0h wceq cA cB chj co cA cort cfv cin cat wcel wo cA cB atoml.1 atomli cA
      cB chj co cA cort cfv cin cat c0h csn cun wcel cA cB chj co cA cort cfv
      cin cat wcel cA cB chj co cA cort cfv cin c0h csn wcel wo cA cB chj co cA
      cort cfv cin cat wcel cA cB chj co cA cort cfv cin c0h wceq wo cA cB chj
      co cA cort cfv cin c0h wceq cA cB chj co cA cort cfv cin cat wcel wo cA
      cB chj co cA cort cfv cin cat c0h csn elun cA cB chj co cA cort cfv cin
      c0h csn wcel cA cB chj co cA cort cfv cin c0h wceq cA cB chj co cA cort
      cfv cin cat wcel cA cB chj co cA cort cfv cin c0h c0h cch h0elch elisseti
      elsnc2 orbi2i cA cB chj co cA cort cfv cin cat wcel cA cB chj co cA cort
      cfv cin c0h wceq orcom 3bitri sylib ord syld imp $.
      $( [2-Jul-2006] $) $( [12-Jun-2006] $)

    $( An ordering law for a Hilbert lattice atom and a commuting subspace. $)
    atordi $p |- ( ( B e. Atoms /\ A C_H B ) ->
                ( B C_ A \/ B C_ ( _|_ ` A ) ) ) $=
      cB cat wcel cA cB ccm wbr wa cB cA wss cB cA cort cfv wss cB cat wcel cA
      cB ccm wbr wa cB cA wss wn cB cA cort cfv wss cB cat wcel cA cB ccm wbr
      wa cB cA wss wn wa cB cA cort cfv wss cB cA cort cfv cin cat wcel cB cat
      wcel cA cB ccm wbr wa cB cA wss wn wa cB cA cort cfv cin cA cB chj co cA
      cort cfv cin cat cB cat wcel cA cB ccm wbr wa cB cA cort cfv cin cA cB
      chj co cA cort cfv cin wceq cB cA wss wn cB cat wcel cA cB ccm wbr wa cB
      cA cort cfv cin cA cort cfv cA cB chj co cin cA cB chj co cA cort cfv cin
      cB cch wcel cA cB ccm wbr cB cA cort cfv cin cA cort cfv cA cB chj co cin
      wceq cB cat wcel cB cch wcel cA cB ccm wbr wa cB cA cort cfv cin cA cort
      cfv cA cin cA cort cfv cB cin chj co cA cort cfv cA cB chj co cin cB cch
      wcel cB cA cort cfv cin cA cort cfv cA cin cA cort cfv cB cin chj co wceq
      cA cB ccm wbr cB cch wcel cB cA cort cfv cin c0h cA cort cfv cB cin chj
      co cA cort cfv cA cin cA cort cfv cB cin chj co cB cch wcel cA cort cfv
      cB cin c0h chj co cB cA cort cfv cin c0h cA cort cfv cB cin chj co cB cch
      wcel cA cort cfv cB cin c0h chj co cA cort cfv cB cin cB cA cort cfv cin
      cB cch wcel cA cort cfv cB cin cch wcel cA cort cfv cB cin c0h chj co cA
      cort cfv cB cin wceq cA cort cfv cch wcel cB cch wcel cA cort cfv cB cin
      cch wcel cA atoml.1 choccli cA cort cfv cB chincl mpan cA cort cfv cB cin
      chj0 syl cA cort cfv cB incom syl6eq cB cch wcel cA cort cfv cB cin cch
      wcel cA cort cfv cB cin c0h chj co c0h cA cort cfv cB cin chj co wceq cA
      cort cfv cch wcel cB cch wcel cA cort cfv cB cin cch wcel cA atoml.1
      choccli cA cort cfv cB chincl mpan cA cort cfv cB cin cch wcel c0h cch
      wcel cA cort cfv cB cin c0h chj co c0h cA cort cfv cB cin chj co wceq
      h0elch cA cort cfv cB cin c0h chjcom mpan2 syl eqtr3d cA cort cfv cA cin
      c0h cA cort cfv cB cin chj cA cort cfv cA cin cA cA cort cfv cin c0h cA
      cort cfv cA incom cA atoml.1 chocini eqtri opreq1i syl6eqr adantr cA cort
      cfv cch wcel cB cch wcel cA cB ccm wbr cA cort cfv cA cB chj co cin cA
      cort cfv cA cin cA cort cfv cB cin chj co wceq cA atoml.1 choccli cA cort
      cfv cch wcel cA cch wcel cB cch wcel cA cB ccm wbr cA cort cfv cA cB chj
      co cin cA cort cfv cA cin cA cort cfv cB cin chj co wceq atoml.1 cA cort
      cfv cch wcel cA cch wcel cB cch wcel w3a cA cA cort cfv ccm wbr cA cB ccm
      wbr cA cort cfv cA cB chj co cin cA cort cfv cA cin cA cort cfv cB cin
      chj co wceq cA cA atoml.1 atoml.1 cA atoml.1 cmidi cmcm2ii cA cort cfv cA
      cB fh2 mpanr1 mp3anl2 mpanl1 eqtr4d cB atelch sylan cA cort cfv cA cB chj
      co incom syl6eq adantr cB cat wcel cB cA wss wn cA cB chj co cA cort cfv
      cin cat wcel cA cB ccm wbr cA cB atoml.1 atoml2i adantlr eqeltrd cB cat
      wcel cB cA cort cfv wss cB cA cort cfv cin cat wcel wb cA cB ccm wbr cB
      cA wss wn cB cat wcel cA cort cfv cch wcel cB cA cort cfv wss cB cA cort
      cfv cin cat wcel wb cA atoml.1 choccli cB cA cort cfv atssma mpan2
      ad2antrr mpbird ex orrd $.
      $( [4-Jul-2006] $) $( [12-Jun-2006] $)

    $( Lemma for ~ atcvati . $)
    atcvatlem $p |- ( ( ( B e. Atoms /\ C e. Atoms ) /\
        ( A =/= 0H /\ A C. ( B vH C ) ) ) -> ( -. B C_ A -> A e. Atoms ) ) $=
      cB cat wcel cC cat wcel wa cA c0h wne cA cB cC chj co wpss cB cA wss wn
      cA cat wcel wi cB cat wcel cC cat wcel wa vx cv cA wss vx cat wrex cA cB
      cC chj co wpss cB cA wss wn cA cat wcel wi wi cA c0h wne cB cat wcel cC
      cat wcel wa vx cv cA wss cA cB cC chj co wpss cB cA wss wn cA cat wcel wi
      wi vx cat cB cat wcel cC cat wcel wa vx cv cat wcel wa vx cv cA wss cA cB
      cC chj co wpss cB cA wss wn cA cat wcel cB cat wcel cC cat wcel wa vx cv
      cat wcel vx cv cA wss cA cB cC chj co wpss cB cA wss wn wa wa cA cat wcel
      wi cB cat wcel cC cat wcel wa vx cv cat wcel vx cv cA wss cA cB cC chj co
      wpss cB cA wss wn wa wa cA cat wcel wi vx cv cat wcel cB cat wcel cC cat
      wcel wa vx cv cat wcel vx cv cA wss cA cB cC chj co wpss cB cA wss wn wa
      wa cA cat wcel cB cat wcel cC cat wcel wa vx cv cat wcel wa vx cv cA wss
      cA cB cC chj co wpss cB cA wss wn wa wa wa cA cat wcel vx cv cat wcel cB
      cat wcel cC cat wcel wa vx cv cat wcel wa vx cv cA wss cA cB cC chj co
      wpss cB cA wss wn wa wa wa cA vx cv cat cB cat wcel cC cat wcel wa vx cv
      cat wcel wa vx cv cA wss cA cB cC chj co wpss cB cA wss wn wa wa wa vx cv
      cB vx cv chj co ccv wbr cA cB vx cv chj co wpss cA vx cv wceq cB cat wcel
      cC cat wcel wa vx cv cat wcel wa vx cv cA wss cA cB cC chj co wpss cB cA
      wss wn wa wa vx cv cB vx cv chj co ccv wbr cB cat wcel vx cv cat wcel vx
      cv cA wss cA cB cC chj co wpss cB cA wss wn wa wa vx cv cB vx cv chj co
      ccv wbr wi cC cat wcel vx cv cat wcel cB cat wcel vx cv cA wss cA cB cC
      chj co wpss cB cA wss wn wa wa vx cv cB vx cv chj co ccv wbr wi vx cv cat
      wcel cB cat wcel wa vx cv cA wss cA cB cC chj co wpss cB cA wss wn wa wa
      vx cv cB cin c0h wceq vx cv cB vx cv chj co ccv wbr vx cv cat wcel cB cat
      wcel wa vx cv cB wceq wn vx cv cB cin c0h wceq vx cv cA wss cA cB cC chj
      co wpss cB cA wss wn wa wa vx cv cB atnem0OLD vx cv cA wss cB cA wss wn
      vx cv cB wceq wn cA cB cC chj co wpss vx cv cA wss cB cA wss wn vx cv cB
      wceq wn vx cv cA wss vx cv cB wceq cB cA wss vx cv cB wceq vx cv cA wss
      cB cA wss vx cv cB cA sseq1 biimpcd con3d imp adantrl syl5bi vx cv cch
      wcel cB cat wcel vx cv cB cin c0h wceq vx cv cB vx cv chj co ccv wbr wb
      vx cv cat wcel vx cv cch wcel cB cat wcel wa vx cv cB cin c0h wceq vx cv
      vx cv cB chj co ccv wbr vx cv cB vx cv chj co ccv wbr vx cv cB cvp vx cv
      cch wcel cB cat wcel wa vx cv cB chj co cB vx cv chj co vx cv ccv vx cv
      cch wcel cB cch wcel vx cv cB chj co cB vx cv chj co wceq cB cat wcel vx
      cv cB chjcom cB atelch sylan2 breq2d bitrd vx cv atelch sylan sylibd
      ancoms adantlr imp cB cat wcel cC cat wcel wa vx cv cat wcel wa vx cv cA
      wss cA cB cC chj co wpss cB cA wss wn cA cB vx cv chj co wpss cB cat wcel
      cC cat wcel wa vx cv cat wcel wa vx cv cA wss cB cA wss wn cA cB cC chj
      co wpss cA cB vx cv chj co wpss cB cat wcel vx cv cat wcel cC cat wcel vx
      cv cA wss cB cA wss wn cA cB cC chj co wpss cA cB vx cv chj co wpss wi wi
      wi cB cat wcel vx cv cat wcel cC cat wcel vx cv cA wss cB cA wss wn cA cB
      cC chj co wpss cA cB vx cv chj co wpss wi wi wi cB cat wcel vx cv cat
      wcel cC cat wcel w3a vx cv cA wss cB cA wss wn cA cB cC chj co wpss cA cB
      vx cv chj co wpss wi cB cat wcel vx cv cat wcel cC cat wcel w3a vx cv cA
      wss cB cA wss wn wa wa cA cB cC chj co wpss cA cB vx cv chj co wpss cB
      cat wcel vx cv cat wcel cC cat wcel w3a vx cv cA wss cB cA wss wn wa wa
      cA cB cC chj co wpss cA cB cC chj co wpss cA cB vx cv chj co wpss wb cB
      cat wcel vx cv cat wcel cC cat wcel w3a vx cv cA wss cB cA wss wn wa wa
      cA cB cC chj co wpss wa cB cC chj co cB vx cv chj co cA cB cat wcel vx cv
      cat wcel cC cat wcel w3a vx cv cA wss cB cA wss wn wa cA cB cC chj co
      wpss cB cC chj co cB vx cv chj co wceq cB cat wcel vx cv cat wcel cC cat
      wcel w3a vx cv cA wss cB cA wss wn wa cA cB cC chj co wpss wa wa cB cC
      chj co cB vx cv chj co cB cat wcel vx cv cat wcel cC cat wcel w3a vx cv
      cA wss cB cA wss wn wa cA cB cC chj co wpss wa wa cB cB vx cv chj co wss
      cC cB vx cv chj co wss wa cB cC chj co cB vx cv chj co wss cB cat wcel vx
      cv cat wcel cC cat wcel w3a vx cv cA wss cB cA wss wn wa cA cB cC chj co
      wpss wa wa cB cB vx cv chj co wss cC cB vx cv chj co wss cB cat wcel vx
      cv cat wcel cC cat wcel w3a cB cB vx cv chj co wss vx cv cA wss cB cA wss
      wn wa cA cB cC chj co wpss wa cB cat wcel vx cv cat wcel cB cB vx cv chj
      co wss cC cat wcel cB cch wcel vx cv cch wcel cB cB vx cv chj co wss cB
      cat wcel vx cv cat wcel cB vx cv chub1 cB atelch vx cv atelch syl2an
      3adant3 adantr cB cat wcel vx cv cat wcel cC cat wcel w3a vx cv cA wss cB
      cA wss wn wa cA cB cC chj co wpss wa wa vx cv cB cC chj co wss cB vx cv
      cin c0h wceq cC cB vx cv chj co wss vx cv cA wss cB cA wss wn wa cA cB cC
      chj co wpss wa vx cv cB cC chj co wss cB cat wcel vx cv cat wcel cC cat
      wcel w3a vx cv cA wss cA cB cC chj co wpss vx cv cB cC chj co wss cB cA
      wss wn vx cv cA wss cA cB cC chj co wss vx cv cB cC chj co wss cA cB cC
      chj co wpss vx cv cA cB cC chj co sstr cA cB cC chj co pssss sylan2
      adantlr adantl cB cat wcel vx cv cat wcel cC cat wcel w3a vx cv cA wss cB
      cA wss wn wa cB vx cv cin c0h wceq cA cB cC chj co wpss cB cat wcel vx cv
      cat wcel cC cat wcel w3a vx cv cA wss cB cA wss wn wa wa vx cv cB cin c0h
      cB vx cv cin cB cat wcel vx cv cat wcel cC cat wcel w3a vx cv cA wss cB
      cA wss wn wa vx cv cB cin c0h wceq cB cat wcel vx cv cat wcel vx cv cA
      wss cB cA wss wn wa vx cv cB cin c0h wceq wi cC cat wcel vx cv cat wcel
      cB cat wcel vx cv cA wss cB cA wss wn wa vx cv cB cin c0h wceq wi vx cv
      cat wcel cB cat wcel wa vx cv cB wceq wn vx cv cB cin c0h wceq vx cv cA
      wss cB cA wss wn wa vx cv cB atnem0OLD vx cv cA wss cB cA wss wn vx cv cB
      wceq wn vx cv cA wss vx cv cB wceq cB cA wss vx cv cB wceq vx cv cA wss
      cB cA wss vx cv cB cA sseq1 biimpcd con3d imp syl5bi ancoms 3adant3 imp
      cB vx cv incom syl5eq adantrr cB cat wcel vx cv cat wcel cC cat wcel w3a
      vx cv cB cC chj co wss cB vx cv cin c0h wceq wa cC cB vx cv chj co wss wi
      vx cv cA wss cB cA wss wn wa cA cB cC chj co wpss wa cB cch wcel vx cv
      cat wcel cC cat wcel vx cv cB cC chj co wss cB vx cv cin c0h wceq wa cC
      cB vx cv chj co wss wi cB cat wcel cB vx cv cC atexch cB atelch syl3an1
      adantr mp2and jca cB cat wcel vx cv cat wcel cC cat wcel w3a cB cB vx cv
      chj co wss cC cB vx cv chj co wss wa cB cC chj co cB vx cv chj co wss wb
      vx cv cA wss cB cA wss wn wa cA cB cC chj co wpss wa cB cat wcel vx cv
      cat wcel cC cat wcel w3a cB cch wcel cC cch wcel cB vx cv chj co cch wcel
      w3a cB cB vx cv chj co wss cC cB vx cv chj co wss wa cB cC chj co cB vx
      cv chj co wss wb cB cch wcel vx cv cch wcel cC cch wcel cB cch wcel cC
      cch wcel cB vx cv chj co cch wcel w3a cB cat wcel vx cv cat wcel cC cat
      wcel cB cch wcel vx cv cch wcel cC cch wcel w3a cB cch wcel cC cch wcel
      cB vx cv chj co cch wcel cB cch wcel vx cv cch wcel cC cch wcel 3simp1 cB
      cch wcel vx cv cch wcel cC cch wcel 3simp3 cB cch wcel vx cv cch wcel cB
      vx cv chj co cch wcel cC cch wcel cB vx cv chjcl 3adant3 3jca cB atelch
      vx cv atelch cC atelch syl3an cB cC cB vx cv chj co chlub syl adantr
      mpbid cB cch wcel vx cv cch wcel cC cch wcel vx cv cA wss cB cA wss wn wa
      cA cB cC chj co wpss wa cB vx cv chj co cB cC chj co wss cB cat wcel vx
      cv cat wcel cC cat wcel cB cch wcel vx cv cch wcel cC cch wcel w3a vx cv
      cA wss cB cA wss wn wa cA cB cC chj co wpss wa wa cB cB cC chj co wss vx
      cv cB cC chj co wss wa cB vx cv chj co cB cC chj co wss cB cch wcel vx cv
      cch wcel cC cch wcel w3a cB cB cC chj co wss vx cv cA wss cB cA wss wn wa
      cA cB cC chj co wpss wa vx cv cB cC chj co wss cB cch wcel cC cch wcel cB
      cB cC chj co wss vx cv cch wcel cB cC chub1 3adant2 vx cv cA wss cA cB cC
      chj co wpss vx cv cB cC chj co wss cB cA wss wn vx cv cA wss cA cB cC chj
      co wss vx cv cB cC chj co wss cA cB cC chj co wpss vx cv cA cB cC chj co
      sstr cA cB cC chj co pssss sylan2 adantlr anim12i cB cch wcel vx cv cch
      wcel cC cch wcel w3a cB cB cC chj co wss vx cv cB cC chj co wss wa cB vx
      cv chj co cB cC chj co wss wb vx cv cA wss cB cA wss wn wa cA cB cC chj
      co wpss wa cB cch wcel vx cv cch wcel cB cC chj co cch wcel cB cB cC chj
      co wss vx cv cB cC chj co wss wa cB vx cv chj co cB cC chj co wss wb cC
      cch wcel cB vx cv cB cC chj co chlub cB cch wcel cC cch wcel cB cC chj co
      cch wcel vx cv cch wcel cB cC chjcl 3adant2 syld3an3 adantr mpbid cB
      atelch vx cv atelch cC atelch syl3anl eqssd anassrs psseq2d ex ibd exp32
      3expa an1rs com34 imp45 cB cat wcel cC cat wcel wa vx cv cat wcel wa vx
      cv cA wss vx cv cB vx cv chj co ccv wbr cA cB vx cv chj co wpss wa cA vx
      cv wceq wi cA cB cC chj co wpss cB cA wss wn wa cB cat wcel cC cat wcel
      wa vx cv cat wcel wa vx cv cA wss vx cv cB vx cv chj co ccv wbr cA cB vx
      cv chj co wpss wa cA vx cv wceq wi cB cat wcel vx cv cat wcel vx cv cA
      wss vx cv cB vx cv chj co ccv wbr cA cB vx cv chj co wpss wa cA vx cv
      wceq wi wi cC cat wcel cB cat wcel vx cv cat wcel wa vx cv cch wcel cB vx
      cv chj co cch wcel wa vx cv cA wss vx cv cB vx cv chj co ccv wbr cA cB vx
      cv chj co wpss wa cA vx cv wceq wi wi cB cch wcel vx cv cch wcel vx cv
      cch wcel cB vx cv chj co cch wcel wa cB cat wcel vx cv cat wcel cB cch
      wcel vx cv cch wcel wa vx cv cch wcel cB vx cv chj co cch wcel cB cch
      wcel vx cv cch wcel pm3.27 cB vx cv chjcl jca cB atelch vx cv atelch
      syl2an vx cv cch wcel cB vx cv chj co cch wcel wa vx cv cA wss vx cv cB
      vx cv chj co ccv wbr cA cB vx cv chj co wpss cA vx cv wceq vx cv cch wcel
      cB vx cv chj co cch wcel wa vx cv cB vx cv chj co ccv wbr vx cv cA wss cA
      cB vx cv chj co wpss cA vx cv wceq wi vx cv cch wcel cB vx cv chj co cch
      wcel wa vx cv cB vx cv chj co ccv wbr vx cv cA wss cA cB vx cv chj co
      wpss cA vx cv wceq vx cv cch wcel cB vx cv chj co cch wcel cA cch wcel vx
      cv cB vx cv chj co ccv wbr vx cv cA wss cA cB vx cv chj co wpss wa cA vx
      cv wceq wi wi atoml.1 vx cv cB vx cv chj co cA cvnbtwn3 mp3an3 exp4a
      com23 imp4a syl adantlr imp adantrr mp2and eleq1d biimprcd exp4c pm2.43b
      imp exp4d r19.23adva vx cA atoml.1 hatomici syl5 imp32 $.
      $( [23-Mar-2007] $) $( [27-Jun-2004] $)

    $( A nonzero Hilbert lattice element less than the join of two atoms
       is an atom. $)
    atcvati $p |- ( ( B e. Atoms /\ C e. Atoms ) ->
                 ( ( A =/= 0H /\ A C. ( B vH C ) ) -> A e. Atoms ) ) $=
      cB cat wcel cC cat wcel wa cA c0h wne cA cB cC chj co wpss wa cA cat wcel
      cB cat wcel cC cat wcel wa cA c0h wne cA cB cC chj co wpss wa wa cB cA
      wss wn cC cA wss wn wo cA cat wcel cB cat wcel cC cat wcel wa cA cB cC
      chj co wpss cB cA wss wn cC cA wss wn wo cA c0h wne cB cat wcel cC cat
      wcel wa cA cB cC chj co wpss cB cA wss wn cC cA wss wn wo cB cch wcel cC
      cch wcel cA cB cC chj co wpss cB cA wss wn cC cA wss wn wo wi cB cat wcel
      cC cat wcel cA cch wcel cB cch wcel cC cch wcel cA cB cC chj co wpss cB
      cA wss wn cC cA wss wn wo wi atoml.1 cA cch wcel cB cch wcel cC cch wcel
      w3a cA cB cC chj co wpss cB cA wss cC cA wss wa wn cB cA wss wn cC cA wss
      wn wo cA cch wcel cB cch wcel cC cch wcel w3a cB cA wss cC cA wss wa cA
      cB cC chj co wpss cA cch wcel cB cch wcel cC cch wcel w3a cB cA wss cC cA
      wss wa cB cC chj co cA wss cA cB cC chj co wpss wn cB cch wcel cC cch
      wcel cA cch wcel cB cA wss cC cA wss wa cB cC chj co cA wss wb cB cC cA
      chlub 3comr cB cC chj co cA ssnpss syl6bi con2d cB cA wss cC cA wss ianor
      syl6ib mp3an1 cB atelch cC atelch syl2an imp adantrl cB cat wcel cC cat
      wcel wa cA c0h wne cA cB cC chj co wpss wa wa cB cA wss wn cA cat wcel cC
      cA wss wn cA cB cC atoml.1 atcvatlem cB cat wcel cC cat wcel wa cA c0h
      wne cA cB cC chj co wpss wa cC cA wss wn cA cat wcel wi cC cat wcel cB
      cat wcel cA c0h wne cA cB cC chj co wpss wa cC cA wss wn cA cat wcel wi
      wi cC cat wcel cB cat wcel wa cA c0h wne cA cB cC chj co wpss wa cA c0h
      wne cA cC cB chj co wpss wa cC cA wss wn cA cat wcel wi cC cat wcel cB
      cat wcel wa cA cC cB chj co wpss cA cB cC chj co wpss cA c0h wne cC cat
      wcel cB cat wcel wa cC cB chj co cB cC chj co cA cC cch wcel cB cch wcel
      cC cB chj co cB cC chj co wceq cC cat wcel cB cat wcel cC cB chjcom cC
      atelch cB atelch syl2an psseq2d anbi2d cC cat wcel cB cat wcel wa cA c0h
      wne cA cC cB chj co wpss wa cC cA wss wn cA cat wcel wi cA cC cB atoml.1
      atcvatlem ex sylbird ancoms imp jaod mpd ex $.
      $( [25-Mar-2007] $) $( [28-Jun-2004] $)

    $( A Hilbert lattice element covered by the join of two distinct atoms
       is an atom. $)
    atcvat2i $p |- ( ( B e. Atoms /\ C e. Atoms ) ->
                 ( ( -. B = C /\ A <o ( B vH C ) ) -> A e. Atoms ) ) $=
      cB cat wcel cC cat wcel wa cB cC wceq wn cA cB cC chj co ccv wbr cA cat
      wcel cB cat wcel cC cat wcel wa cA cB cC chj co ccv wbr cB cC wceq wn cA
      cat wcel cB cat wcel cC cat wcel wa cA cB cC chj co ccv wbr cB cC wceq wn
      cA cat wcel wi cB cat wcel cC cat wcel wa cA cB cC chj co ccv wbr wa cB
      cC wceq wn cA c0h wne cA cat wcel cB cat wcel cC cat wcel wa cA cB cC chj
      co ccv wbr wa cB cC wceq cA c0h cA cch wcel cB cat wcel cC cat wcel cA cB
      cC chj co ccv wbr cA c0h wceq cB cC wceq wb atoml.1 cA cB cC atcv1
      mp3anl1 necon3abid cB cat wcel cC cat wcel wa cA cB cC chj co ccv wbr cA
      c0h wne cA cat wcel wi cB cat wcel cC cat wcel wa cA cB cC chj co ccv wbr
      cA cB cC chj co wpss cA c0h wne cA cat wcel wi cB cat wcel cC cat wcel wa
      cB cC chj co cch wcel cA cB cC chj co ccv wbr cA cB cC chj co wpss wi cB
      cch wcel cC cch wcel cB cC chj co cch wcel cB cat wcel cC cat wcel cB cC
      chjcl cB atelch cC atelch syl2an cA cch wcel cB cC chj co cch wcel cA cB
      cC chj co ccv wbr cA cB cC chj co wpss wi atoml.1 cA cB cC chj co cvpss
      mpan syl cB cat wcel cC cat wcel wa cA c0h wne cA cB cC chj co wpss cA
      cat wcel cB cat wcel cC cat wcel wa cA c0h wne cA cB cC chj co wpss cA
      cat wcel cA cB cC atoml.1 atcvati exp3a com23 syld imp sylbird ex com23
      imp3a $.
      $( [29-Jul-2004] $) $( [26-Jun-2004] $)
  $}

  $( An ordering law for a Hilbert lattice atom and a commuting subspace. $)
  atord $p |- ( ( A e. CH /\ B e. Atoms /\ A C_H B ) ->
              ( B C_ A \/ B C_ ( _|_ ` A ) ) ) $=
    cA cch wcel cB cat wcel cA cB ccm wbr cB cA wss cB cA cort cfv wss wo cA
    cch wcel cB cat wcel cA cB ccm wbr wa cB cA wss cB cA cort cfv wss wo wi cB
    cat wcel cA cch wcel cA c0h cif cB ccm wbr wa cB cA cch wcel cA c0h cif wss
    cB cA cch wcel cA c0h cif cort cfv wss wo wi cA c0h cA cA cch wcel cA c0h
    cif wceq cB cat wcel cA cB ccm wbr wa cB cat wcel cA cch wcel cA c0h cif cB
    ccm wbr wa cB cA wss cB cA cort cfv wss wo cB cA cch wcel cA c0h cif wss cB
    cA cch wcel cA c0h cif cort cfv wss wo cA cA cch wcel cA c0h cif wceq cA cB
    ccm wbr cA cch wcel cA c0h cif cB ccm wbr cB cat wcel cA cA cch wcel cA c0h
    cif cB ccm breq1 anbi2d cA cA cch wcel cA c0h cif wceq cB cA wss cB cA cch
    wcel cA c0h cif wss cB cA cort cfv wss cB cA cch wcel cA c0h cif cort cfv
    wss cA cA cch wcel cA c0h cif cB sseq2 cA cA cch wcel cA c0h cif wceq cA
    cort cfv cA cch wcel cA c0h cif cort cfv cB cA cA cch wcel cA c0h cif cort
    fveq2 sseq2d orbi12d imbi12d cA cch wcel cA c0h cif cB cA c0h cch h0elch
    elimel atordi dedth 3impib $.
    $( [7-Jul-2006] $) $( [12-Jun-2006] $)

  $( A Hilbert lattice element covered by the join of two distinct atoms
     is an atom. $)
  atcvat2 $p |- ( ( A e. CH /\ B e. Atoms /\ C e. Atoms ) ->
               ( ( -. B = C /\ A <o ( B vH C ) ) -> A e. Atoms ) ) $=
    cA cch wcel cB cat wcel cC cat wcel cB cC wceq wn cA cB cC chj co ccv wbr
    wa cA cat wcel wi cA cch wcel cB cat wcel cC cat wcel wa cB cC wceq wn cA
    cB cC chj co ccv wbr wa cA cat wcel wi wi cB cat wcel cC cat wcel wa cB cC
    wceq wn cA cch wcel cA c0h cif cB cC chj co ccv wbr wa cA cch wcel cA c0h
    cif cat wcel wi wi cA c0h cA cA cch wcel cA c0h cif wceq cB cC wceq wn cA
    cB cC chj co ccv wbr wa cA cat wcel wi cB cC wceq wn cA cch wcel cA c0h cif
    cB cC chj co ccv wbr wa cA cch wcel cA c0h cif cat wcel wi cB cat wcel cC
    cat wcel wa cA cA cch wcel cA c0h cif wceq cB cC wceq wn cA cB cC chj co
    ccv wbr wa cB cC wceq wn cA cch wcel cA c0h cif cB cC chj co ccv wbr wa cA
    cat wcel cA cch wcel cA c0h cif cat wcel cA cA cch wcel cA c0h cif wceq cA
    cB cC chj co ccv wbr cA cch wcel cA c0h cif cB cC chj co ccv wbr cB cC wceq
    wn cA cA cch wcel cA c0h cif cB cC chj co ccv breq1 anbi2d cA cA cch wcel
    cA c0h cif cat eleq1 imbi12d imbi2d cA cch wcel cA c0h cif cB cC cA c0h cch
    h0elch elimel atcvat2i dedth 3impib $.
    $( [29-Jul-2004] $) $( [29-Jun-2004] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Irreducibility
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d p q r x A $.
    irred.1 $e |- A e. CH $.
    $( Lemma for ~ irredi . $)
    irredlem1 $p |- ( ( ( p e. Atoms /\ ( q e. CH /\ q C_ ( _|_ ` A ) ) )
     /\ ( ( r e. Atoms /\ r C_ A ) /\ r C_ ( p vH q ) ) ) ->
       ( p i^i ( _|_ ` r ) ) = 0H ) $=
      vp cv cat wcel vq cv cch wcel vq cv cA cort cfv wss wa vr cv cat wcel vr
      cv cA wss wa vr cv vp cv vq cv chj co wss vp cv vr cv cort cfv cin c0h
      wceq vp cv cat wcel vq cv cch wcel vq cv cA cort cfv wss vr cv cat wcel
      vr cv cA wss wa vr cv vp cv vq cv chj co wss vp cv vr cv cort cfv cin c0h
      wceq wi wi vq cv cA cort cfv wss vr cv cat wcel vr cv cA wss wa vp cv cat
      wcel vq cv cch wcel vr cv vp cv vq cv chj co wss vp cv vr cv cort cfv cin
      c0h wceq wi vq cv cA cort cfv wss vr cv cat wcel vr cv cA wss wa vq cv vr
      cv cort cfv wss vp cv cat wcel vq cv cch wcel vr cv vp cv vq cv chj co
      wss vp cv vr cv cort cfv cin c0h wceq wi wi wi vq cv cA cort cfv wss cA
      cort cfv vr cv cort cfv wss vq cv vr cv cort cfv wss vr cv cat wcel vr cv
      cA wss wa vq cv cA cort cfv vr cv cort cfv sstr2 vr cv cch wcel vr cv cA
      wss cA cort cfv vr cv cort cfv wss vr cv cat wcel vr cv cch wcel vr cv cA
      wss cA cort cfv vr cv cort cfv wss vr cv cch wcel cA cch wcel vr cv cA
      wss cA cort cfv vr cv cort cfv wss wb irred.1 vr cv cA chsscon3 mpan2
      biimpa vr cv atelch sylan syl5 vr cv cat wcel vq cv vr cv cort cfv wss vp
      cv cat wcel vq cv cch wcel vr cv vp cv vq cv chj co wss vp cv vr cv cort
      cfv cin c0h wceq wi wi wi wi vr cv cA wss vr cv cat wcel vq cv vr cv cort
      cfv wss vp cv cat wcel vq cv cch wcel vr cv vp cv vq cv chj co wss vp cv
      vr cv cort cfv cin c0h wceq wi vr cv cat wcel vq cv vr cv cort cfv wss wa
      vp cv cat wcel vq cv cch wcel wa wa vr cv vp cv vq cv chj co wss vp cv vr
      cv cort cfv wss wn vp cv vr cv cort cfv cin c0h wceq vr cv cat wcel vq cv
      vr cv cort cfv wss wa vp cv cch wcel vq cv cch wcel vr cv vp cv vq cv chj
      co wss vp cv vr cv cort cfv wss wn wi vp cv cat wcel vr cv cat wcel vq cv
      vr cv cort cfv wss wa vp cv cch wcel vq cv cch wcel wa wa vr cv vp cv vq
      cv chj co wss vp cv vr cv cort cfv wss wn vr cv cat wcel vq cv vr cv cort
      cfv wss wa vp cv cch wcel vq cv cch wcel wa wa vr cv vp cv vq cv chj co
      wss wa vp cv vr cv cort cfv wss vr cv c0h wceq vr cv cat wcel vq cv vr cv
      cort cfv wss wa vr cv c0h wceq wn vp cv cch wcel vq cv cch wcel wa vr cv
      vp cv vq cv chj co wss vr cv cat wcel vr cv c0h wceq wn vq cv vr cv cort
      cfv wss vr cv cat wcel vr cv c0h wne vr cv c0h wceq wn vr cv atn0 vr cv
      c0h df-ne sylib adantr ad2antrr vr cv cat wcel vq cv vr cv cort cfv wss
      wa vp cv cch wcel vq cv cch wcel wa wa vr cv vp cv vq cv chj co wss wa vp
      cv vr cv cort cfv wss vr cv vr cv cort cfv wss vr cv c0h wceq vr cv cat
      wcel vq cv vr cv cort cfv wss wa vp cv cch wcel vq cv cch wcel wa wa vr
      cv vp cv vq cv chj co wss wa vp cv vr cv cort cfv wss vr cv vr cv cort
      cfv wss vr cv cat wcel vq cv vr cv cort cfv wss wa vp cv cch wcel vq cv
      cch wcel wa wa vr cv vp cv vq cv chj co wss wa vp cv vr cv cort cfv wss
      wa vr cv vr cv cort cfv vq cv chj co vr cv cort cfv vr cv cat wcel vq cv
      vr cv cort cfv wss wa vp cv cch wcel vq cv cch wcel wa wa vr cv vp cv vq
      cv chj co wss wa vp cv vr cv cort cfv wss wa vr cv vp cv vq cv chj co vr
      cv cort cfv vq cv chj co vr cv cat wcel vq cv vr cv cort cfv wss wa vp cv
      cch wcel vq cv cch wcel wa wa vr cv vp cv vq cv chj co wss vp cv vr cv
      cort cfv wss simplr vr cv cat wcel vq cv vr cv cort cfv wss wa vp cv cch
      wcel vq cv cch wcel wa wa vp cv vr cv cort cfv wss vp cv vq cv chj co vr
      cv cort cfv vq cv chj co wss vr cv vp cv vq cv chj co wss vr cv cat wcel
      vp cv cch wcel vq cv cch wcel wa vp cv vr cv cort cfv wss vp cv vq cv chj
      co vr cv cort cfv vq cv chj co wss vq cv vr cv cort cfv wss vr cv cat
      wcel vp cv cch wcel vq cv cch wcel vp cv vr cv cort cfv wss vp cv vq cv
      chj co vr cv cort cfv vq cv chj co wss vp cv cch wcel vr cv cort cfv cch
      wcel vq cv cch wcel vp cv vr cv cort cfv wss vp cv vq cv chj co vr cv
      cort cfv vq cv chj co wss wi wi vr cv cat wcel vp cv cch wcel vr cv cort
      cfv cch wcel vq cv cch wcel vp cv vr cv cort cfv wss vp cv vq cv chj co
      vr cv cort cfv vq cv chj co wss vp cv vr cv cort cfv vq cv chlej1 3exp1
      vr cv cat wcel vr cv cch wcel vr cv cort cfv cch wcel vr cv atelch vr cv
      choccl syl syl5com imp42 adantllr adantlr sstrd vr cv cat wcel vq cv vr
      cv cort cfv wss wa vp cv cch wcel vq cv cch wcel wa wa vr cv cort cfv vq
      cv chj co vr cv cort cfv wceq vr cv vp cv vq cv chj co wss vp cv vr cv
      cort cfv wss vr cv cat wcel vq cv vr cv cort cfv wss wa vq cv cch wcel vr
      cv cort cfv vq cv chj co vr cv cort cfv wceq vp cv cch wcel vr cv cat
      wcel vq cv cch wcel vq cv vr cv cort cfv wss vr cv cort cfv vq cv chj co
      vr cv cort cfv wceq vr cv cort cfv cch wcel vq cv cch wcel vq cv vr cv
      cort cfv wss vr cv cort cfv vq cv chj co vr cv cort cfv wceq vr cv cat
      wcel vr cv cort cfv cch wcel vq cv cch wcel wa vq cv vr cv cort cfv wss
      vr cv cort cfv vq cv chj co vr cv cort cfv wceq vq cv cch wcel vr cv cort
      cfv cch wcel vq cv vr cv cort cfv wss vr cv cort cfv vq cv chj co vr cv
      cort cfv wceq wb vq cv vr cv cort cfv chlejb2 ancoms biimpa vr cv cat
      wcel vr cv cch wcel vr cv cort cfv cch wcel vr cv atelch vr cv choccl syl
      sylanl1 an1rs adantrl ad2antrr sseqtrd ex vr cv cat wcel vq cv vr cv cort
      cfv wss wa vr cv vr cv cort cfv wss vr cv c0h wceq wi vp cv cch wcel vq
      cv cch wcel wa vr cv vp cv vq cv chj co wss vr cv cat wcel vr cv vr cv
      cort cfv wss vr cv c0h wceq wi vq cv vr cv cort cfv wss vr cv cat wcel vr
      cv cch wcel vr cv vr cv cort cfv wss vr cv c0h wceq wi vr cv atelch vr cv
      cch wcel vr cv vr cv cort cfv wss vr cv c0h wceq vr cv chssoc biimpd syl
      adantr ad2antrr syld mtod ex vp cv atelch sylanr1 vr cv cat wcel vp cv
      cat wcel vp cv vr cv cort cfv wss wn vp cv vr cv cort cfv cin c0h wceq wb
      vq cv vr cv cort cfv wss vq cv cch wcel vr cv cort cfv cch wcel vp cv cat
      wcel vp cv vr cv cort cfv wss wn vp cv vr cv cort cfv cin c0h wceq wb vr
      cv cat wcel vr cv cort cfv cch wcel vp cv cat wcel wa vp cv vr cv cort
      cfv wss wn vr cv cort cfv vp cv cin c0h wceq vp cv vr cv cort cfv cin c0h
      wceq vr cv cort cfv vp cv atnssm0 vr cv cort cfv vp cv cin vp cv vr cv
      cort cfv cin c0h vr cv cort cfv vp cv incom eqeq1i syl6bb vr cv cat wcel
      vr cv cch wcel vr cv cort cfv cch wcel vr cv atelch vr cv choccl syl
      sylan ad2ant2r sylibd exp43 adantr sylcom com4t imp3a imp43 $.
      $( [8-Jul-2006] $) $( [14-Jun-2006] $)

    $( Lemma for ~ irredi . $)
    irredlem2 $p |- ( ( ( ( p e. Atoms /\ p C_ A ) /\ ( q e. CH /\
      q C_ ( _|_ ` A ) ) ) /\ ( ( r e. Atoms /\ r C_ A ) /\ r C_ ( p vH q ) ) )
                  -> ( ( _|_ ` r ) i^i ( p vH q ) ) = q ) $=
      vp cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa
      vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa wa vr cv
      cort cfv vp cv vq cv chj co cin vr cv cort cfv vq cv vp cv chj co cin vr
      cv cort cfv vq cv cin vr cv cort cfv vp cv cin chj co vq cv vp cv cat
      wcel vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat
      wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa wa vp cv vq cv chj
      co vq cv vp cv chj co vr cv cort cfv vp cv cat wcel vp cv cA wss wa vq cv
      cch wcel vq cv cA cort cfv wss wa wa vp cv vq cv chj co vq cv vp cv chj
      co wceq vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa vp
      cv cat wcel vq cv cch wcel vp cv vq cv chj co vq cv vp cv chj co wceq vp
      cv cA wss vq cv cA cort cfv wss vp cv cch wcel vq cv cch wcel vp cv vq cv
      chj co vq cv vp cv chj co wceq vp cv cat wcel vp cv vq cv chjcom vp cv
      atelch sylan ad2ant2r adantr ineq2d vr cv cort cfv cch wcel vq cv cch
      wcel vp cv cch wcel w3a vq cv vr cv cort cfv ccm wbr vq cv vp cv ccm wbr
      wa vr cv cort cfv vq cv vp cv chj co cin vr cv cort cfv vq cv cin vr cv
      cort cfv vp cv cin chj co wceq vp cv cat wcel vp cv cA wss wa vq cv cch
      wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss wa vr cv vp
      cv vq cv chj co wss wa wa vr cv cort cfv vq cv vp cv fh2 vp cv cat wcel
      vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel
      vr cv cA wss wa vr cv cort cfv cch wcel vq cv cch wcel vp cv cch wcel w3a
      vr cv vp cv vq cv chj co wss vp cv cat wcel vp cv cA wss wa vq cv cch
      wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cort cfv cch wcel
      vq cv cch wcel vp cv cch wcel w3a vr cv cA wss vp cv cat wcel vp cv cA
      wss wa vq cv cch wcel vr cv cat wcel vr cv cort cfv cch wcel vq cv cch
      wcel vp cv cch wcel w3a vq cv cA cort cfv wss vp cv cat wcel vq cv cch
      wcel vr cv cat wcel vr cv cort cfv cch wcel vq cv cch wcel vp cv cch wcel
      w3a vp cv cA wss vp cv cat wcel vq cv cch wcel vr cv cat wcel vr cv cort
      cfv cch wcel vq cv cch wcel vp cv cch wcel w3a vr cv cat wcel vq cv cch
      wcel vp cv cat wcel vr cv cort cfv cch wcel vq cv cch wcel vp cv cch wcel
      w3a vr cv cat wcel vr cv cort cfv cch wcel vq cv cch wcel vq cv cch wcel
      vp cv cat wcel vp cv cch wcel vr cv cat wcel vr cv cch wcel vr cv cort
      cfv cch wcel vr cv atelch vr cv choccl syl vq cv cch wcel id vp cv atelch
      3anim123i 3com13 3expa adantllr adantlrr adantrr adantrr vp cv cat wcel
      vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel
      vr cv cA wss wa vr cv vp cv vq cv chj co wss wa wa vq cv vr cv cort cfv
      ccm wbr vq cv vp cv ccm wbr vq cv cch wcel vq cv cA cort cfv wss wa vr cv
      cat wcel vr cv cA wss wa vq cv vr cv cort cfv ccm wbr vp cv cat wcel vp
      cv cA wss wa vr cv vp cv vq cv chj co wss vq cv cch wcel vr cv cort cfv
      cch wcel vq cv vr cv cort cfv wss vq cv vr cv cort cfv ccm wbr vq cv cch
      wcel vq cv cA cort cfv wss wa vr cv cat wcel vr cv cA wss wa wa vq cv vr
      cv cort cfv lecm vq cv cch wcel vq cv cA cort cfv wss vr cv cat wcel vr
      cv cA wss wa simpll vr cv cat wcel vr cv cort cfv cch wcel vq cv cch wcel
      vq cv cA cort cfv wss wa vr cv cA wss vr cv cat wcel vr cv cch wcel vr cv
      cort cfv cch wcel vr cv atelch vr cv choccl syl ad2antrl vq cv cA cort
      cfv wss vr cv cat wcel vr cv cA wss wa vq cv vr cv cort cfv wss vq cv cch
      wcel vq cv cA cort cfv wss cA cort cfv vr cv cort cfv wss vq cv vr cv
      cort cfv wss vr cv cat wcel vr cv cA wss wa vq cv cA cort cfv vr cv cort
      cfv sstr vr cv cat wcel vr cv cA wss cA cort cfv vr cv cort cfv wss vr cv
      cat wcel vr cv cch wcel vr cv cA wss cA cort cfv vr cv cort cfv wss wb vr
      cv atelch vr cv cch wcel cA cch wcel vr cv cA wss cA cort cfv vr cv cort
      cfv wss wb irred.1 vr cv cA chsscon3 mpan2 syl biimpa sylan2 adantll
      syl3anc ad2ant2lr vp cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv cA
      cort cfv wss wa wa vq cv vp cv ccm wbr vr cv cat wcel vr cv cA wss wa vr
      cv vp cv vq cv chj co wss wa vp cv cat wcel vq cv cch wcel vp cv cA wss
      vq cv cA cort cfv wss vq cv vp cv ccm wbr vq cv cch wcel vp cv cat wcel
      vp cv cA wss vq cv cA cort cfv wss wa vq cv vp cv ccm wbr vq cv cch wcel
      vp cv cch wcel vp cv cA wss vq cv cA cort cfv wss wa vq cv vp cv ccm wbr
      vp cv cat wcel vq cv cch wcel vp cv cch wcel wa vp cv cA wss vq cv cA
      cort cfv wss wa wa vq cv vp cv cort cfv wss vq cv vp cv ccm wbr vp cv cch
      wcel vp cv cA wss vq cv cA cort cfv wss wa vq cv vp cv cort cfv wss vq cv
      cch wcel vp cv cch wcel vq cv cA cort cfv wss vp cv cA wss vq cv vp cv
      cort cfv wss vq cv cA cort cfv wss vp cv cch wcel vp cv cA wss vq cv vp
      cv cort cfv wss vq cv cA cort cfv wss cA cort cfv vp cv cort cfv wss vq
      cv vp cv cort cfv wss vp cv cch wcel vp cv cA wss wa vq cv cA cort cfv vp
      cv cort cfv sstr vp cv cch wcel vp cv cA wss cA cort cfv vp cv cort cfv
      wss vp cv cch wcel cA cch wcel vp cv cA wss cA cort cfv vp cv cort cfv
      wss wb irred.1 vp cv cA chsscon3 mpan2 biimpa sylan2 an1s ancom2s adantll
      vq cv cch wcel vp cv cch wcel wa vq cv vp cv cort cfv wss vq cv vp cv ccm
      wbr wi vp cv cA wss vq cv cA cort cfv wss wa vq cv cch wcel vp cv cch
      wcel wa vq cv vp cv cort cfv wss vq cv vp cv cort cfv ccm wbr vq cv vp cv
      ccm wbr vq cv cch wcel vp cv cch wcel vq cv vp cv cort cfv wss vq cv vp
      cv cort cfv ccm wbr vq cv cch wcel vp cv cort cfv cch wcel vq cv vp cv
      cort cfv wss vq cv vp cv cort cfv ccm wbr vp cv cch wcel vq cv vp cv cort
      cfv lecm vp cv choccl syl3an2 3expia vq cv vp cv cmcm2 sylibrd adantr mpd
      vp cv atelch sylanl2 ancom1s an4s adantr jca sylanc vp cv cat wcel vp cv
      cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv
      cA wss wa vr cv vp cv vq cv chj co wss wa wa vr cv cort cfv vq cv cin vr
      cv cort cfv vp cv cin chj co vq cv c0h chj co vq cv vp cv cat wcel vp cv
      cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv
      cA wss wa vr cv vp cv vq cv chj co wss wa wa vr cv cort cfv vq cv cin vq
      cv vr cv cort cfv vp cv cin c0h chj vq cv cch wcel vq cv cA cort cfv wss
      wa vr cv cat wcel vr cv cA wss wa vr cv cort cfv vq cv cin vq cv wceq vp
      cv cat wcel vp cv cA wss wa vr cv vp cv vq cv chj co wss vq cv cch wcel
      vq cv cA cort cfv wss wa vr cv cat wcel vr cv cA wss wa wa vq cv vr cv
      cort cfv wss vr cv cort cfv vq cv cin vq cv wceq vq cv cA cort cfv wss vr
      cv cat wcel vr cv cA wss wa vq cv vr cv cort cfv wss vq cv cch wcel vq cv
      cA cort cfv wss cA cort cfv vr cv cort cfv wss vq cv vr cv cort cfv wss
      vr cv cat wcel vr cv cA wss wa vq cv cA cort cfv vr cv cort cfv sstr vr
      cv cat wcel vr cv cA wss cA cort cfv vr cv cort cfv wss vr cv cat wcel vr
      cv cch wcel vr cv cA wss cA cort cfv vr cv cort cfv wss wb vr cv atelch
      vr cv cch wcel cA cch wcel vr cv cA wss cA cort cfv vr cv cort cfv wss wb
      irred.1 vr cv cA chsscon3 mpan2 syl biimpa sylan2 adantll vq cv vr cv
      cort cfv sseqin2 sylib ad2ant2lr vp cv cat wcel vp cv cA wss wa vq cv cch
      wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss wa vr cv vp
      cv vq cv chj co wss wa wa vp cv vr cv cort cfv cin c0h vr cv cort cfv vp
      cv cin vp cv cat wcel vq cv cch wcel vq cv cA cort cfv wss wa vr cv cat
      wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa vp cv vr cv cort cfv
      cin c0h wceq vp cv cA wss cA vr vq vp irred.1 irredlem1 adantllr vr cv
      cort cfv vp cv incom syl5eq opreq12d vq cv cch wcel vq cv cA cort cfv wss
      wa vq cv c0h chj co vq cv wceq vp cv cat wcel vp cv cA wss wa vr cv cat
      wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa vq cv cch wcel vq cv
      c0h chj co vq cv wceq vq cv cA cort cfv wss vq cv chj0 adantr ad2antlr
      eqtrd 3eqtrd $.
      $( [8-Jul-2006] $) $( [15-Jun-2006] $)

    ${
      irred.2 $e |- ( x e. CH -> A C_H x ) $.
      $( Lemma for ~ irredi . $)
      irredlem3 $p |- ( ( ( ( p e. Atoms /\ p C_ A ) /\ ( q e. Atoms /\
        q C_ ( _|_ ` A ) ) ) /\ ( r e. Atoms /\ r C_ ( p vH q ) ) )
                    -> ( r C_ A -> r = p ) ) $=
        vp cv cat wcel vp cv cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa
        wa vr cv cat wcel vr cv vp cv vq cv chj co wss vr cv cA wss vr cv vp cv
        wceq wi vp cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv
        wss vr cv cat wcel vr cv vp cv vq cv chj co wss vr cv cA wss vr cv vp
        cv wceq wi wi wi vq cv cat wcel vp cv cat wcel vp cv cA wss wa vq cv
        cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss vr cv
        vp cv vq cv chj co wss vr cv vp cv wceq vp cv cat wcel vp cv cA wss wa
        vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss
        vr cv vp cv vq cv chj co wss vr cv vp cv wceq vp cv cat wcel vp cv cA
        wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv
        cA wss wa vr cv vp cv vq cv chj co wss wa wa vr cv c0h chj co vp cv c0h
        chj co vr cv vp cv vp cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv
        cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv
        chj co wss wa wa cA vr cv cin cA vq cv cin chj co cA vp cv cin cA vq cv
        cin chj co vr cv c0h chj co vp cv c0h chj co vp cv cat wcel vp cv cA
        wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv
        cA wss wa vr cv vp cv vq cv chj co wss wa wa cA vr cv vq cv chj co cin
        cA vp cv vq cv chj co cin cA vr cv cin cA vq cv cin chj co cA vp cv cin
        cA vq cv cin chj co vp cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv
        cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv
        chj co wss wa wa vr cv vq cv chj co vp cv vq cv chj co cA vp cv cat
        wcel vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv
        cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa wa vr cv vr cv
        cort cfv vp cv vq cv chj co cin chj co vr cv vq cv chj co vp cv vq cv
        chj co vp cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv
        wss wa wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss
        wa wa vr cv cort cfv vp cv vq cv chj co cin vq cv vr cv chj cA vr vq vp
        irred.1 irredlem2 opreq2d vp cv cat wcel vp cv cA wss wa vq cv cch wcel
        vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss wa vr cv vp cv
        vq cv chj co wss vr cv vr cv cort cfv vp cv vq cv chj co cin chj co vp
        cv vq cv chj co wceq vr cv cat wcel vr cv cA wss wa vp cv cat wcel vp
        cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv vp cv vq
        cv chj co wss vr cv vr cv cort cfv vp cv vq cv chj co cin chj co vp cv
        vq cv chj co wceq vr cv cch wcel vp cv vq cv chj co cch wcel vr cv vp
        cv vq cv chj co wss vr cv vr cv cort cfv vp cv vq cv chj co cin chj co
        vp cv vq cv chj co wceq vr cv cat wcel vr cv cA wss wa vp cv cat wcel
        vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv vp cv
        vq cv chj co wss vr cv vp cv vq cv chj co pjoml2 vr cv cat wcel vr cv
        cch wcel vr cv cA wss vr cv atelch adantr vp cv cat wcel vq cv cch wcel
        vp cv vq cv chj co cch wcel vp cv cA wss vq cv cA cort cfv wss vp cv
        cch wcel vq cv cch wcel vp cv vq cv chj co cch wcel vp cv cat wcel vp
        cv vq cv chjcl vp cv atelch sylan ad2ant2r vr cv vp cv vq cv chj co wss
        id syl3an 3com12 3expb eqtr3d ineq2d vq cv cch wcel vq cv cA cort cfv
        wss wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa
        cA vr cv vq cv chj co cin cA vr cv cin cA vq cv cin chj co wceq vp cv
        cat wcel vp cv cA wss wa vq cv cch wcel vr cv cat wcel vr cv cA wss wa
        cA vr cv vq cv chj co cin cA vr cv cin cA vq cv cin chj co wceq vq cv
        cA cort cfv wss vr cv vp cv vq cv chj co wss vq cv cch wcel vr cv cat
        wcel cA vr cv vq cv chj co cin cA vr cv cin cA vq cv cin chj co wceq vr
        cv cA wss vr cv cat wcel vq cv cch wcel cA vr cv vq cv chj co cin cA vr
        cv cin cA vq cv cin chj co wceq vr cv cch wcel vq cv cch wcel cA vr cv
        vq cv chj co cin cA vr cv cin cA vq cv cin chj co wceq vr cv cat wcel
        vr cv cch wcel vq cv cch wcel wa cA vr cv ccm wbr cA vq cv ccm wbr wa
        cA vr cv vq cv chj co cin cA vr cv cin cA vq cv cin chj co wceq vr cv
        cch wcel cA vr cv ccm wbr vq cv cch wcel cA vq cv ccm wbr cA vx cv ccm
        wbr cA vr cv ccm wbr vx vr cv cch vx cv vr cv cA ccm breq2 irred.2
        vtoclga cA vx cv ccm wbr cA vq cv ccm wbr vx vq cv cch vx cv vq cv cA
        ccm breq2 irred.2 vtoclga anim12i cA cch wcel vr cv cch wcel vq cv cch
        wcel cA vr cv ccm wbr cA vq cv ccm wbr wa cA vr cv vq cv chj co cin cA
        vr cv cin cA vq cv cin chj co wceq irred.1 cA vr cv vq cv fh1 mp3anl1
        mpdan vr cv atelch sylan ancoms adantrr ad2ant2r adantll vp cv cat wcel
        vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa cA vp cv vq
        cv chj co cin cA vp cv cin cA vq cv cin chj co wceq vr cv cat wcel vr
        cv cA wss wa vr cv vp cv vq cv chj co wss wa vp cv cat wcel vq cv cch
        wcel cA vp cv vq cv chj co cin cA vp cv cin cA vq cv cin chj co wceq vp
        cv cA wss vq cv cA cort cfv wss vp cv cch wcel vq cv cch wcel cA vp cv
        vq cv chj co cin cA vp cv cin cA vq cv cin chj co wceq vp cv cat wcel
        vp cv cch wcel vq cv cch wcel wa cA vp cv ccm wbr cA vq cv ccm wbr wa
        cA vp cv vq cv chj co cin cA vp cv cin cA vq cv cin chj co wceq vp cv
        cch wcel cA vp cv ccm wbr vq cv cch wcel cA vq cv ccm wbr cA vx cv ccm
        wbr cA vp cv ccm wbr vx vp cv cch vx cv vp cv cA ccm breq2 irred.2
        vtoclga cA vx cv ccm wbr cA vq cv ccm wbr vx vq cv cch vx cv vq cv cA
        ccm breq2 irred.2 vtoclga anim12i cA cch wcel vp cv cch wcel vq cv cch
        wcel cA vp cv ccm wbr cA vq cv ccm wbr wa cA vp cv vq cv chj co cin cA
        vp cv cin cA vq cv cin chj co wceq irred.1 cA vp cv vq cv fh1 mp3anl1
        mpdan vp cv atelch sylan ad2ant2r adantr 3eqtr3d vp cv cat wcel vp cv
        cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr
        cv cA wss wa vr cv vp cv vq cv chj co wss wa wa cA vr cv cin vr cv cA
        vq cv cin c0h chj vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj
        co wss wa cA vr cv cin vr cv wceq vp cv cat wcel vp cv cA wss wa vq cv
        cch wcel vq cv cA cort cfv wss wa wa vr cv cA wss cA vr cv cin vr cv
        wceq vr cv cat wcel vr cv vp cv vq cv chj co wss vr cv cA wss cA vr cv
        cin vr cv wceq vr cv cA sseqin2 biimpi ad2antlr adantl vq cv cch wcel
        vq cv cA cort cfv wss wa cA vq cv cin c0h wceq vp cv cat wcel vp cv cA
        wss wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa
        vq cv cch wcel vq cv cA cort cfv wss wa vq cv cA cin c0h cA vq cv cin
        vq cv cch wcel vq cv cA cort cfv wss vq cv cA cin c0h wceq vq cv cch
        wcel vq cv csh wcel vq cv cA cort cfv wss vq cv cA cin c0h wceq wi vq
        cv chsh vq cv csh wcel cA csh wcel vq cv cA cort cfv wss vq cv cA cin
        c0h wceq wi cA irred.1 chshii vq cv cA orthin mpan2 syl imp cA vq cv
        incom syl5eq ad2antlr opreq12d vp cv cat wcel vp cv cA wss wa vq cv cch
        wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr cv cA wss wa vr cv
        vp cv vq cv chj co wss wa wa cA vp cv cin vp cv cA vq cv cin c0h chj vp
        cv cat wcel vp cv cA wss wa cA vp cv cin vp cv wceq vq cv cch wcel vq
        cv cA cort cfv wss wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv
        chj co wss wa vp cv cA wss cA vp cv cin vp cv wceq vp cv cat wcel vp cv
        cA wss cA vp cv cin vp cv wceq vp cv cA sseqin2 biimpi adantl ad2antrr
        vq cv cch wcel vq cv cA cort cfv wss wa cA vq cv cin c0h wceq vp cv cat
        wcel vp cv cA wss wa vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv
        chj co wss wa vq cv cch wcel vq cv cA cort cfv wss wa vq cv cA cin c0h
        cA vq cv cin vq cv cch wcel vq cv cA cort cfv wss vq cv cA cin c0h wceq
        vq cv cch wcel vq cv csh wcel vq cv cA cort cfv wss vq cv cA cin c0h
        wceq wi vq cv chsh vq cv csh wcel cA csh wcel vq cv cA cort cfv wss vq
        cv cA cin c0h wceq wi cA irred.1 chshii vq cv cA orthin mpan2 syl imp
        cA vq cv incom syl5eq ad2antlr opreq12d 3eqtr3d vr cv cat wcel vr cv cA
        wss wa vr cv vp cv vq cv chj co wss wa vr cv c0h chj co vr cv wceq vp
        cv cat wcel vp cv cA wss wa vq cv cch wcel vq cv cA cort cfv wss wa wa
        vr cv cat wcel vr cv c0h chj co vr cv wceq vr cv cA wss vr cv vp cv vq
        cv chj co wss vr cv cat wcel vr cv cch wcel vr cv c0h chj co vr cv wceq
        vr cv atelch vr cv chj0 syl ad2antrr adantl vp cv cat wcel vp cv cA wss
        wa vp cv c0h chj co vp cv wceq vq cv cch wcel vq cv cA cort cfv wss wa
        vr cv cat wcel vr cv cA wss wa vr cv vp cv vq cv chj co wss wa vp cv
        cat wcel vp cv c0h chj co vp cv wceq vp cv cA wss vp cv cat wcel vp cv
        cch wcel vp cv c0h chj co vp cv wceq vp cv atelch vp cv chj0 syl adantr
        ad2antrr 3eqtr3d exp44 com34 vq cv atelch sylanr1 imp32 $.
        $( [8-Jul-2006] $) $( [15-Jun-2006] $)

      $( Lemma for ~ irredi . $)
      irredlem4 $p |- ( ( ( ( p e. Atoms /\ p C_ A ) /\ ( q e. Atoms /\
        q C_ ( _|_ ` A ) ) ) /\ ( r e. Atoms /\
              r C_ ( p vH q ) ) ) -> ( r = p \/ r = q ) ) $=
        vp cv cat wcel vp cv cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa
        wa vr cv cat wcel vr cv vp cv vq cv chj co wss wa wa vr cv cA wss vr cv
        cA cort cfv wss wo vr cv vp cv wceq vr cv vq cv wceq wo vr cv cat wcel
        vr cv cA wss vr cv cA cort cfv wss wo vp cv cat wcel vp cv cA wss wa vq
        cv cat wcel vq cv cA cort cfv wss wa wa vr cv vp cv vq cv chj co wss vr
        cv cat wcel cA vr cv ccm wbr vr cv cA wss vr cv cA cort cfv wss wo vr
        cv cat wcel vr cv cch wcel cA vr cv ccm wbr vr cv atelch cA vx cv ccm
        wbr cA vr cv ccm wbr vx vr cv cch vx cv vr cv cA ccm breq2 irred.2
        vtoclga syl cA vr cv irred.1 atordi mpdan ad2antrl vp cv cat wcel vp cv
        cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa wa vr cv cat wcel vr
        cv vp cv vq cv chj co wss wa wa vr cv cA wss vr cv vp cv wceq vr cv cA
        cort cfv wss vr cv vq cv wceq vx cA vr vq vp irred.1 irred.2 irredlem3
        vq cv cat wcel vq cv cA cort cfv wss wa vp cv cat wcel vp cv cA wss wa
        vr cv cat wcel vr cv vp cv vq cv chj co wss wa vr cv cA cort cfv wss vr
        cv vq cv wceq wi vq cv cat wcel vq cv cA cort cfv wss wa vp cv cat wcel
        vp cv cA wss wa wa vr cv cat wcel vr cv vp cv vq cv chj co wss wa vr cv
        cA cort cfv wss vr cv vq cv wceq wi vq cv cat wcel vq cv cA cort cfv
        wss wa vp cv cat wcel vp cv cA cort cfv cort cfv wss vr cv cat wcel vr
        cv vp cv vq cv chj co wss wa vr cv cA cort cfv wss vr cv vq cv wceq wi
        wi vp cv cA wss vq cv cat wcel vq cv cA cort cfv wss wa vp cv cat wcel
        vp cv cA cort cfv cort cfv wss wa wa vr cv cat wcel vr cv vp cv vq cv
        chj co wss wa vr cv cat wcel vr cv vq cv vp cv chj co wss wa vr cv cA
        cort cfv wss vr cv vq cv wceq wi vq cv cat wcel vp cv cat wcel vr cv
        cat wcel vr cv vq cv vp cv chj co wss wa vr cv cat wcel vr cv vp cv vq
        cv chj co wss wa wb vq cv cA cort cfv wss vp cv cA cort cfv cort cfv
        wss vq cv cat wcel vp cv cat wcel wa vr cv vq cv vp cv chj co wss vr cv
        vp cv vq cv chj co wss vr cv cat wcel vq cv cat wcel vp cv cat wcel wa
        vq cv vp cv chj co vp cv vq cv chj co vr cv vq cv cch wcel vp cv cch
        wcel vq cv vp cv chj co vp cv vq cv chj co wceq vq cv cat wcel vp cv
        cat wcel vq cv vp cv chjcom vq cv atelch vp cv atelch syl2an sseq2d
        anbi2d ad2ant2r vq cv cat wcel vq cv cA cort cfv wss wa vp cv cat wcel
        vp cv cA cort cfv cort cfv wss wa wa vr cv cat wcel vr cv vq cv vp cv
        chj co wss wa vr cv cA cort cfv wss vr cv vq cv wceq wi vx cA cort cfv
        vr vp vq cA irred.1 choccli vx cv cch wcel cA vx cv ccm wbr cA cort cfv
        vx cv ccm wbr irred.2 cA cch wcel vx cv cch wcel cA vx cv ccm wbr cA
        cort cfv vx cv ccm wbr wb irred.1 cA vx cv cmcm3 mpan mpbid irredlem3
        ex sylbird vp cv cA cort cfv cort cfv wss vp cv cA wss cA cort cfv cort
        cfv cA vp cv cA irred.1 ococi sseq2i biimpri sylanr2 imp ancom1s
        orim12d mpd $.
        $( [8-Jul-2006] $) $( [15-Jun-2006] $)

      $( The Hilbert lattice is irreducible:  any element that commutes with
         all elements must be zero or one.  Theorem 14.8.4 of
         [BeltramettiCassinelli] p. 166. $)
      irredi $p |- ( A = 0H \/ A = ~H ) $=
        cA c0h wceq cA cort cfv c0h wceq wo cA c0h wceq cA chil wceq wo c0h c0h
        wceq cA c0h wceq cA cort cfv c0h wceq wo c0h eqid cA c0h wceq cA cort
        cfv c0h wceq wo c0h c0h wceq cA c0h wceq cA cort cfv c0h wceq wo wn cA
        c0h wne cA cort cfv c0h wne wa c0h c0h wceq wn cA c0h wceq cA cort cfv
        c0h wceq wo wn cA c0h wceq wn cA cort cfv c0h wceq wn wa cA c0h wne cA
        cort cfv c0h wne wa cA c0h wceq cA cort cfv c0h wceq ioran cA c0h wne
        cA c0h wceq wn cA cort cfv c0h wne cA cort cfv c0h wceq wn cA c0h df-ne
        cA cort cfv c0h df-ne anbi12i bitr4i cA c0h wne cA cort cfv c0h wne wa
        vp cv cA wss vq cv cA cort cfv wss wa vq cat wrex vp cat wrex c0h c0h
        wceq wn cA c0h wne cA cort cfv c0h wne wa vp cv cA wss vp cat wrex vq
        cv cA cort cfv wss vq cat wrex wa vp cv cA wss vq cv cA cort cfv wss wa
        vq cat wrex vp cat wrex cA c0h wne vp cv cA wss vp cat wrex cA cort cfv
        c0h wne vq cv cA cort cfv wss vq cat wrex vp cA irred.1 hatomici vq cA
        cort cfv cA irred.1 choccli hatomici anim12i vp cv cA wss vq cv cA cort
        cfv wss vp vq cat cat reeanv sylibr vp cv cA wss vq cv cA cort cfv wss
        wa c0h c0h wceq wn vp vq cat cat vp cv cat wcel vq cv cat wcel wa vp cv
        cA wss vq cv cA cort cfv wss wa c0h c0h wceq wn vp cv cat wcel vp cv cA
        wss vq cv cat wcel vq cv cA cort cfv wss c0h c0h wceq wn vp cv cat wcel
        vp cv cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa wa vr cv vp cv
        wne vr cv vq cv wne vr cv vp cv vq cv chj co wss w3a vr cat wrex c0h
        c0h wceq wn vp cv cat wcel vq cv cat wcel vp cv vq cv wne vr cv vp cv
        wne vr cv vq cv wne vr cv vp cv vq cv chj co wss w3a vr cat wrex vp cv
        cat wcel vp cv cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa wa vr
        vp cv vq cv superpos vp cv cat wcel vp cv cA wss vq cv cat wcel vq cv
        cA cort cfv wss wa simpll vp cv cat wcel vp cv cA wss wa vq cv cat wcel
        vq cv cA cort cfv wss simprl vp cv cat wcel vp cv cA wss wa vq cv cA
        cort cfv wss vp cv vq cv wne vq cv cat wcel vp cv cat wcel vp cv cA wss
        wa vq cv cA cort cfv wss vq cv vp cv cort cfv wss vp cv vq cv wne vq cv
        cA cort cfv wss vp cv cat wcel vp cv cA wss wa vq cv vp cv cort cfv wss
        vq cv cA cort cfv wss cA cort cfv vp cv cort cfv wss vq cv vp cv cort
        cfv wss vp cv cat wcel vp cv cA wss wa vq cv cA cort cfv vp cv cort cfv
        sstr vp cv cat wcel vp cv cA wss cA cort cfv vp cv cort cfv wss vp cv
        cat wcel vp cv cch wcel vp cv cA wss cA cort cfv vp cv cort cfv wss wb
        vp cv atelch vp cv cch wcel cA cch wcel vp cv cA wss cA cort cfv vp cv
        cort cfv wss wb irred.1 vp cv cA chsscon3 mpan2 syl biimpa sylan2
        ancoms vp cv cat wcel vq cv vp cv cort cfv wss vp cv vq cv wne vp cv cA
        wss vp cv cat wcel vq cv vp cv cort cfv wss wa vp cv c0h wne vp cv vq
        cv wne vp cv cat wcel vp cv c0h wne vq cv vp cv cort cfv wss vp cv atn0
        adantr vp cv cat wcel vq cv vp cv cort cfv wss wa vp cv vq cv vp cv c0h
        vp cv cat wcel vq cv vp cv cort cfv wss wa vp cv vq cv wceq vp cv c0h
        wceq vp cv cat wcel vp cv vq cv wceq vq cv vp cv cort cfv wss vp cv c0h
        wceq vp cv cat wcel vp cv vq cv wceq wa vq cv vp cv cort cfv wss vp cv
        c0h wceq vp cv vq cv wceq vq cv vp cv cort cfv wss vp cv vp cv cort cfv
        wss vp cv cat wcel vp cv c0h wceq vp cv vq cv wceq vp cv vp cv cort cfv
        wss vq cv vp cv cort cfv wss vp cv vq cv vp cv cort cfv sseq1 bicomd vp
        cv cat wcel vp cv cch wcel vp cv vp cv cort cfv wss vp cv c0h wceq wb
        vp cv atelch vp cv chssoc syl sylan9bbr biimpa an1rs ex necon3d mpd
        adantlr syldan adantrl syl3anc vp cv cat wcel vp cv cA wss wa vq cv cat
        wcel vq cv cA cort cfv wss wa wa vr cv vp cv wne vr cv vq cv wne vr cv
        vp cv vq cv chj co wss w3a c0h c0h wceq wn vr cat vp cv cat wcel vp cv
        cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa wa vr cv cat wcel wa
        vr cv vp cv wceq vr cv vq cv wceq wo wn vr cv vp cv vq cv chj co wss wa
        c0h c0h wceq wn vr cv vp cv wne vr cv vq cv wne vr cv vp cv vq cv chj
        co wss w3a vp cv cat wcel vp cv cA wss wa vq cv cat wcel vq cv cA cort
        cfv wss wa wa vr cv cat wcel wa vr cv vp cv wceq vr cv vq cv wceq wo wn
        vr cv vp cv vq cv chj co wss c0h c0h wceq wn vp cv cat wcel vp cv cA
        wss wa vq cv cat wcel vq cv cA cort cfv wss wa wa vr cv cat wcel wa vr
        cv vp cv vq cv chj co wss vr cv vp cv wceq vr cv vq cv wceq wo wn c0h
        c0h wceq wn vp cv cat wcel vp cv cA wss wa vq cv cat wcel vq cv cA cort
        cfv wss wa wa vr cv cat wcel wa vr cv vp cv vq cv chj co wss vr cv vp
        cv wceq vr cv vq cv wceq wo wn c0h c0h wceq wn wi vp cv cat wcel vp cv
        cA wss wa vq cv cat wcel vq cv cA cort cfv wss wa wa vr cv cat wcel wa
        vr cv vp cv vq cv chj co wss wa vr cv vp cv wceq vr cv vq cv wceq wo
        c0h c0h wceq wn vp cv cat wcel vp cv cA wss wa vq cv cat wcel vq cv cA
        cort cfv wss wa wa vr cv cat wcel vr cv vp cv vq cv chj co wss vr cv vp
        cv wceq vr cv vq cv wceq wo vx cA vr vq vp irred.1 irred.2 irredlem4
        anassrs pm2.24d ex com23 imp3a vr cv vp cv wne vr cv vq cv wne vr cv vp
        cv vq cv chj co wss w3a vr cv vp cv wne vr cv vq cv wne wa vr cv vp cv
        vq cv chj co wss wa vr cv vp cv wceq vr cv vq cv wceq wo wn vr cv vp cv
        vq cv chj co wss wa vr cv vp cv wne vr cv vq cv wne vr cv vp cv vq cv
        chj co wss df-3an vr cv vp cv wne vr cv vq cv wne wa vr cv vp cv wceq
        vr cv vq cv wceq wo wn vr cv vp cv vq cv chj co wss vr cv vp cv vr cv
        vq cv neanior anbi1i bitri syl5ib r19.23adva mpd an4s ex r19.23aivv syl
        sylbi con4i ax-mp cA cort cfv c0h wceq cA chil wceq cA c0h wceq cA cort
        cfv c0h wceq cA cort cfv cort cfv c0h cort cfv cA chil cA cort cfv c0h
        cort fveq2 cA irred.1 ococi choc0 3eqtr3g orim2i ax-mp $.
        $( [8-Jul-2006] $) $( [15-Jun-2006] $)
    $}
  $}

  ${
    $d x y z A $.
    $( The Hilbert lattice is irreducible:  any element that commutes with all
       elements must be zero or one.  Theorem 14.8.4 of [BeltramettiCassinelli]
       p. 166. $)
    irred $p |- ( ( A e. CH /\ A. x e. CH A C_H x ) ->
                 ( A = 0H \/ A = ~H ) ) $=
      cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h wceq cA chil wceq wo
      cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif c0h wceq cA cch
      wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif chil wceq wo cA c0h cA cA
      cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif wceq cA c0h wceq cA
      cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif c0h wceq cA chil wceq
      cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif chil wceq cA cA
      cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif c0h eqeq1 cA cA cch
      wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif chil eqeq1 orbi12d vy cA
      cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA c0h cif cch wcel cA cch wcel cA vx cv ccm wbr
      vx cch wral wa cA c0h cif vx cv ccm wbr vx cch wral cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h
      cif cch wcel cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vx cv
      ccm wbr vx cch wral wa c0h cch wcel c0h vx cv ccm wbr vx cch wral wa cA
      c0h cA cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif wceq cA cch
      wcel cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif cch wcel cA
      vx cv ccm wbr vx cch wral cA cch wcel cA vx cv ccm wbr vx cch wral wa cA
      c0h cif vx cv ccm wbr vx cch wral cA cA cch wcel cA vx cv ccm wbr vx cch
      wral wa cA c0h cif cch eleq1 cA cA cch wcel cA vx cv ccm wbr vx cch wral
      wa cA c0h cif wceq cA vx cv ccm wbr cA cch wcel cA vx cv ccm wbr vx cch
      wral wa cA c0h cif vx cv ccm wbr vx cch vx vy vy cA cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA c0h cif vy cv cA wcel vx ax-17 cA cch wcel cA
      vx cv ccm wbr vx cch wral wa vx vy cA c0h cA cch wcel cA vx cv ccm wbr vx
      cch wral vx cA cch wcel vx ax-17 cA vx cv ccm wbr vx cch hbra1 hban vy cv
      cA wcel vx ax-17 vy cv c0h wcel vx ax-17 hbif hbeq cA cA cch wcel cA vx
      cv ccm wbr vx cch wral wa cA c0h cif vx cv ccm breq1 ralbid anbi12d c0h
      cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif wceq c0h cch wcel
      cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif cch wcel c0h vx cv
      ccm wbr vx cch wral cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h
      cif vx cv ccm wbr vx cch wral c0h cA cch wcel cA vx cv ccm wbr vx cch
      wral wa cA c0h cif cch eleq1 c0h cA cch wcel cA vx cv ccm wbr vx cch wral
      wa cA c0h cif wceq c0h vx cv ccm wbr cA cch wcel cA vx cv ccm wbr vx cch
      wral wa cA c0h cif vx cv ccm wbr vx cch vx vy vy c0h cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA c0h cif vy cv c0h wcel vx ax-17 cA cch wcel cA
      vx cv ccm wbr vx cch wral wa vx vy cA c0h cA cch wcel cA vx cv ccm wbr vx
      cch wral vx cA cch wcel vx ax-17 cA vx cv ccm wbr vx cch hbra1 hban vy cv
      cA wcel vx ax-17 vy cv c0h wcel vx ax-17 hbif hbeq c0h cA cch wcel cA vx
      cv ccm wbr vx cch wral wa cA c0h cif vx cv ccm breq1 ralbid anbi12d c0h
      cch wcel c0h vx cv ccm wbr vx cch wral h0elch c0h vx cv ccm wbr vx cch vx
      cv cm0 rgen pm3.2i elimhyp pm3.26i vy cv cch wcel cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA c0h cif vx cv ccm wbr vx cch wral cA cch wcel
      cA vx cv ccm wbr vx cch wral wa cA c0h cif vy cv ccm wbr cA cch wcel cA
      vx cv ccm wbr vx cch wral wa cA c0h cif cch wcel cA cch wcel cA vx cv ccm
      wbr vx cch wral wa cA c0h cif vx cv ccm wbr vx cch wral cA cch wcel cA vx
      cv ccm wbr vx cch wral wa cA cch wcel cA vx cv ccm wbr vx cch wral wa cA
      c0h cif cch wcel cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif
      vx cv ccm wbr vx cch wral wa c0h cch wcel c0h vx cv ccm wbr vx cch wral
      wa cA c0h cA cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif wceq
      cA cch wcel cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif cch
      wcel cA vx cv ccm wbr vx cch wral cA cch wcel cA vx cv ccm wbr vx cch
      wral wa cA c0h cif vx cv ccm wbr vx cch wral cA cA cch wcel cA vx cv ccm
      wbr vx cch wral wa cA c0h cif cch eleq1 cA cA cch wcel cA vx cv ccm wbr
      vx cch wral wa cA c0h cif wceq cA vx cv ccm wbr cA cch wcel cA vx cv ccm
      wbr vx cch wral wa cA c0h cif vx cv ccm wbr vx cch vx vy vy cA cA cch
      wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vy cv cA wcel vx ax-17 cA
      cch wcel cA vx cv ccm wbr vx cch wral wa vx vy cA c0h cA cch wcel cA vx
      cv ccm wbr vx cch wral vx cA cch wcel vx ax-17 cA vx cv ccm wbr vx cch
      hbra1 hban vy cv cA wcel vx ax-17 vy cv c0h wcel vx ax-17 hbif hbeq cA cA
      cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vx cv ccm breq1
      ralbid anbi12d c0h cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif
      wceq c0h cch wcel cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif
      cch wcel c0h vx cv ccm wbr vx cch wral cA cch wcel cA vx cv ccm wbr vx
      cch wral wa cA c0h cif vx cv ccm wbr vx cch wral c0h cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA c0h cif cch eleq1 c0h cA cch wcel cA vx cv ccm
      wbr vx cch wral wa cA c0h cif wceq c0h vx cv ccm wbr cA cch wcel cA vx cv
      ccm wbr vx cch wral wa cA c0h cif vx cv ccm wbr vx cch vx vy vy c0h cA
      cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vy cv c0h wcel vx
      ax-17 cA cch wcel cA vx cv ccm wbr vx cch wral wa vx vy cA c0h cA cch
      wcel cA vx cv ccm wbr vx cch wral vx cA cch wcel vx ax-17 cA vx cv ccm
      wbr vx cch hbra1 hban vy cv cA wcel vx ax-17 vy cv c0h wcel vx ax-17 hbif
      hbeq c0h cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vx cv ccm
      breq1 ralbid anbi12d c0h cch wcel c0h vx cv ccm wbr vx cch wral h0elch
      c0h vx cv ccm wbr vx cch vx cv cm0 rgen pm3.2i elimhyp pm3.27i cA cch
      wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vx cv ccm wbr cA cch wcel
      cA vx cv ccm wbr vx cch wral wa cA c0h cif vy cv ccm wbr vx vy cv cch vx
      vz cA cch wcel cA vx cv ccm wbr vx cch wral wa cA c0h cif vy cv ccm cA
      cch wcel cA vx cv ccm wbr vx cch wral wa vx vz cA c0h cA cch wcel cA vx
      cv ccm wbr vx cch wral vx cA cch wcel vx ax-17 cA vx cv ccm wbr vx cch
      hbra1 hban vz cv cA wcel vx ax-17 vz cv c0h wcel vx ax-17 hbif vz cv ccm
      wcel vx ax-17 vz cv vy cv wcel vx ax-17 hbbr vx cv vy cv cA cch wcel cA
      vx cv ccm wbr vx cch wral wa cA c0h cif ccm breq2 rcla4 mpi irredi dedth
      $.
      $( [1-Oct-2006] $) $( [16-Jun-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Atoms (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.  $d x C $.
    atcvat3.1 $e |- A e. CH $.
    $( A condition implying that a certain lattice element is an atom.  Part
       of Lemma 3.2.20 of [PtakPulmannova] p. 68. $)
    atcvat3i $p |- ( ( B e. Atoms /\ C e. Atoms ) ->
          ( ( ( -. B = C /\ -. C C_ A ) /\ B C_ ( A vH C ) ) ->
          ( A i^i ( B vH C ) ) e. Atoms ) ) $=
      cB cat wcel cC cat wcel wa cB cC wceq wn cC cA wss wn cB cA cC chj co wss
      cA cB cC chj co cin cat wcel cB cat wcel cC cat wcel wa cB cC wceq wn cC
      cA wss wn cB cA cC chj co wss cA cB cC chj co cin cat wcel cB cat wcel cC
      cat wcel wa cB cC wceq wn wa cC cA wss wn cB cA cC chj co wss wa cA cB cC
      chj co cin cB cC chj co ccv wbr cA cB cC chj co cin cat wcel cB cat wcel
      cC cat wcel wa cC cA wss wn cB cA cC chj co wss wa cA cB cC chj co cin cB
      cC chj co ccv wbr wi cB cC wceq wn cB cat wcel cC cat wcel wa cC cA wss
      wn cB cA cC chj co wss wa cA cA cB cC chj co chj co ccv wbr cA cB cC chj
      co cin cB cC chj co ccv wbr cB cat wcel cC cat wcel wa cC cA wss wn cB cA
      cC chj co wss wa cA cA cB cC chj co chj co ccv wbr cB cat wcel cC cat
      wcel wa cC cA wss wn cB cA cC chj co wss wa wa cA cA cB cC chj co chj co
      ccv wbr cA cA cC chj co ccv wbr cC cat wcel cC cA wss wn cA cA cC chj co
      ccv wbr cB cat wcel cB cA cC chj co wss cC cat wcel cC cA wss wn cA cA cC
      chj co ccv wbr cA cch wcel cC cat wcel cC cA wss wn cA cA cC chj co ccv
      wbr wb atcvat3.1 cA cC chcv1 mpan biimpa ad2ant2lr cB cat wcel cC cat
      wcel wa cB cA cC chj co wss cA cA cB cC chj co chj co ccv wbr cA cA cC
      chj co ccv wbr wb cC cA wss wn cB cat wcel cC cat wcel wa cB cA cC chj co
      wss wa cA cB cC chj co chj co cA cC chj co cA ccv cB cch wcel cC cch wcel
      wa cB cA cC chj co wss cA cB cC chj co chj co cA cC chj co wceq cB cat
      wcel cC cat wcel wa cB cch wcel cC cch wcel wa cB cA cC chj co wss wa cA
      cB cC chj co chj co cA cC chj co cB cch wcel cC cch wcel wa cB cA cC chj
      co wss wa cA cB cC chj co chj co cA cC chj co cA cC chj co chj co cA cC
      chj co cB cch wcel cC cch wcel wa cB cA cC chj co wss wa cA cB cC chj co
      chj co cA cC chj co cB chj co cA cC chj co cA cC chj co chj co cB cch
      wcel cC cch wcel wa cA cB cC chj co chj co cA cC chj co cB chj co wceq cB
      cA cC chj co wss cB cch wcel cC cch wcel wa cA cB cC chj co chj co cA cC
      cB chj co chj co cA cC chj co cB chj co cB cch wcel cC cch wcel wa cB cC
      chj co cC cB chj co cA chj cB cC chjcom opreq2d cC cch wcel cB cch wcel
      cA cC chj co cB chj co cA cC cB chj co chj co wceq cA cch wcel cC cch
      wcel cB cch wcel cA cC chj co cB chj co cA cC cB chj co chj co wceq
      atcvat3.1 cA cC cB chjass mp3an1 ancoms eqtr4d adantr cB cch wcel cC cch
      wcel wa cB cA cC chj co wss cA cC chj co cB chj co cA cC chj co cA cC chj
      co chj co wss cB cch wcel cA cC chj co cch wcel cA cC chj co cch wcel cB
      cA cC chj co wss cA cC chj co cB chj co cA cC chj co cA cC chj co chj co
      wss wi cB cch wcel cC cch wcel wa cB cch wcel cA cC chj co cch wcel cA cC
      chj co cch wcel w3a cB cA cC chj co wss cA cC chj co cB chj co cA cC chj
      co cA cC chj co chj co wss cB cA cC chj co cA cC chj co chlej2 ex cB cch
      wcel cC cch wcel pm3.26 cC cch wcel cA cC chj co cch wcel cB cch wcel cA
      cch wcel cC cch wcel cA cC chj co cch wcel atcvat3.1 cA cC chjcl mpan
      adantl cC cch wcel cA cC chj co cch wcel cB cch wcel cA cch wcel cC cch
      wcel cA cC chj co cch wcel atcvat3.1 cA cC chjcl mpan adantl syl3anc imp
      eqsstrd cC cch wcel cA cC chj co cA cC chj co chj co cA cC chj co wceq cB
      cch wcel cB cA cC chj co wss cC cch wcel cA cC chj co cch wcel cA cC chj
      co cA cC chj co chj co cA cC chj co wceq cA cch wcel cC cch wcel cA cC
      chj co cch wcel atcvat3.1 cA cC chjcl mpan cA cC chj co chjidm syl
      ad2antlr sseqtrd cB cch wcel cC cch wcel wa cA cC chj co cA cB cC chj co
      chj co wss cB cA cC chj co wss cC cch wcel cB cC chj co cch wcel wa cC cB
      cC chj co wss cA cC chj co cA cB cC chj co chj co wss cB cch wcel cC cch
      wcel wa cC cch wcel cB cC chj co cch wcel cA cch wcel cC cB cC chj co wss
      cA cC chj co cA cB cC chj co chj co wss atcvat3.1 cC cB cC chj co cA
      chlej2 mp3anl3 cB cch wcel cC cch wcel wa cC cch wcel cB cC chj co cch
      wcel cB cch wcel cC cch wcel pm3.27 cB cC chjcl jca cC cch wcel cB cch
      wcel cC cB cC chj co wss cC cB chub2 ancoms sylanc adantr eqssd cB cat
      wcel cB cch wcel cC cat wcel cC cch wcel cB atelch cC atelch anim12i
      sylan breq2d adantrl mpbird ex cB cat wcel cC cat wcel wa cA cch wcel cB
      cC chj co cch wcel wa cA cB cC chj co cin cB cC chj co ccv wbr cA cA cB
      cC chj co chj co ccv wbr wb cB cch wcel cC cch wcel cA cch wcel cB cC chj
      co cch wcel wa cB cat wcel cC cat wcel cB cch wcel cC cch wcel wa cB cC
      chj co cch wcel cA cch wcel cB cC chjcl atcvat3.1 jctil cB atelch cC
      atelch syl2an cA cB cC chj co cvexch syl sylibrd adantr cB cat wcel cC
      cat wcel wa cB cC wceq wn cA cB cC chj co cin cB cC chj co ccv wbr cA cB
      cC chj co cin cat wcel cA cB cC chj co cin cch wcel cB cat wcel cC cat
      wcel cB cC wceq wn cA cB cC chj co cin cB cC chj co ccv wbr wa cA cB cC
      chj co cin cat wcel wi cB cat wcel cC cat wcel wa cA cB cC chj co cin cB
      cC atcvat2 cB cch wcel cC cch wcel cA cB cC chj co cin cch wcel cB cat
      wcel cC cat wcel cB cch wcel cC cch wcel wa cA cch wcel cB cC chj co cch
      wcel wa cA cB cC chj co cin cch wcel cB cch wcel cC cch wcel wa cB cC chj
      co cch wcel cA cch wcel cB cC chjcl atcvat3.1 jctil cA cB cC chj co
      chincl syl cB atelch cC atelch syl2an cB cat wcel cC cat wcel pm3.26 cB
      cat wcel cC cat wcel pm3.27 syl3anc expdimp syld exp4b imp4c $.
      $( [29-Jul-2004] $) $( [2-Jul-2004] $)

    $( A condition implying existence of an atom with the properties shown.
       Lemma 3.2.20 of [PtakPulmannova] p. 68. $)
    atcvat4i $p |- ( ( B e. Atoms /\ C e. Atoms ) ->
          ( ( A =/= 0H /\ B C_ ( A vH C ) ) ->
          E. x e. Atoms ( x C_ A /\ B C_ ( C vH x ) ) ) ) $=
      cB cat wcel cC cat wcel wa cB cC wceq cC cA wss cA c0h wne cB cA cC chj
      co wss wa vx cv cA wss cB cC vx cv chj co wss wa vx cat wrex wi cC cat
      wcel cB cC wceq cA c0h wne cB cA cC chj co wss wa vx cv cA wss cB cC vx
      cv chj co wss wa vx cat wrex wi wi cB cat wcel cC cat wcel cB cC wceq cA
      c0h wne cB cA cC chj co wss vx cv cA wss cB cC vx cv chj co wss wa vx cat
      wrex cB cA cC chj co wss cC cat wcel cB cC wceq cA c0h wne vx cv cA wss
      cB cC vx cv chj co wss wa vx cat wrex cC cat wcel cB cC wceq cA c0h wne
      vx cv cA wss cB cC vx cv chj co wss wa vx cat wrex wi wi wi cB cA cC chj
      co wss cC cat wcel cB cC wceq cA c0h wne vx cv cA wss cB cC vx cv chj co
      wss wa vx cat wrex wi cC cat wcel cB cC wceq wa vx cv cA wss vx cat wrex
      vx cv cA wss cB cC vx cv chj co wss wa vx cat wrex cA c0h wne cC cat wcel
      cB cC wceq wa vx cv cA wss vx cv cA wss cB cC vx cv chj co wss wa vx cat
      cC cat wcel cB cC wceq wa vx cv cA wss vx cv cat wcel vx cv cA wss cB cC
      vx cv chj co wss wa cC cat wcel cB cC wceq wa vx cv cA wss vx cv cat wcel
      vx cv cA wss cB cC vx cv chj co wss wa cC cat wcel cB cC wceq wa vx cv
      cat wcel cB cC vx cv chj co wss vx cv cA wss cB cC wceq cC cat wcel vx cv
      cat wcel cB cC vx cv chj co wss wi cB cC wceq cC cat wcel vx cv cat wcel
      cB cC vx cv chj co wss cB cC wceq cB cC vx cv chj co wss cC cC vx cv chj
      co wss cC cat wcel vx cv cat wcel wa cB cC cC vx cv chj co sseq1 cC cch
      wcel vx cv cch wcel cC cC vx cv chj co wss cC cat wcel vx cv cat wcel cC
      vx cv chub1 cC atelch vx cv atelch syl2an syl5bir exp3a impcom anim2d
      exp3a com23 r19.22dv vx cA atcvat3.1 hatomici syl5 ex a1i com4l imp4a
      adantl cB cat wcel cC cat wcel wa cC cA wss cA c0h wne cB cA cC chj co
      wss wa vx cv cA wss cB cC vx cv chj co wss wa vx cat wrex cB cat wcel cC
      cat wcel wa cC cA wss wa cB cA cC chj co wss vx cv cA wss cB cC vx cv chj
      co wss wa vx cat wrex cA c0h wne cB cat wcel cC cat wcel wa cC cA wss wa
      cB cA cC chj co wss wa cB cat wcel cB cA wss cB cC cB chj co wss wa wa vx
      cv cA wss cB cC vx cv chj co wss wa vx cat wrex cB cat wcel cC cat wcel
      wa cC cA wss cB cA cC chj co wss cB cat wcel cB cA wss cB cC cB chj co
      wss wa wa cB cat wcel cC cat wcel wa cC cA wss cB cA cC chj co wss wa cB
      cat wcel cB cA wss cB cC cB chj co wss wa wa cB cat wcel cC cat wcel wa
      cC cA wss cB cA cC chj co wss wa cB cA wss cB cC cB chj co wss wa cB cat
      wcel cB cch wcel cC cch wcel cC cA wss cB cA cC chj co wss wa cB cA wss
      cB cC cB chj co wss wa wi cB cat wcel cC cat wcel cB cch wcel cC cch wcel
      wa cC cA wss cB cA cC chj co wss wa cB cA wss cB cC cB chj co wss cC cch
      wcel cC cA wss cB cA cC chj co wss wa cB cA wss wi cB cch wcel cC cch
      wcel cC cA wss cB cA cC chj co wss wa cB cA wss cC cch wcel cC cA wss cB
      cA cC chj co wss cB cA wss cC cch wcel cC cA wss wa cB cA cC chj co wss
      cB cA wss cC cch wcel cC cA wss wa cA cC chj co cA cB cC cch wcel cC cA
      wss cA cC chj co cA wceq cC cch wcel cA cch wcel cC cA wss cA cC chj co
      cA wceq wb atcvat3.1 cC cA chlejb2 mpan2 biimpa sseq2d biimpa anasss ex
      adantl cB cC chub2 jctird cB atelch cC atelch syl2an cB cat wcel cC cat
      wcel pm3.26 jctild imp anassrs vx cv cA wss cB cC vx cv chj co wss wa cB
      cA wss cB cC cB chj co wss wa vx cB cat vx cv cB wceq vx cv cA wss cB cA
      wss cB cC vx cv chj co wss cB cC cB chj co wss vx cv cB cA sseq1 vx cv cB
      wceq cC vx cv chj co cC cB chj co cB vx cv cB cC chj opreq2 sseq2d
      anbi12d rcla4ev syl adantrl exp31 cB cat wcel cC cat wcel wa cB cC wceq
      cC cA wss wo wn cB cA cC chj co wss vx cv cA wss cB cC vx cv chj co wss
      wa vx cat wrex cA c0h wne cB cA cC chj co wss wa cB cat wcel cC cat wcel
      wa cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss vx cv cA wss cB cC
      vx cv chj co wss wa vx cat wrex wi cB cC wceq cC cA wss wo wn cB cat wcel
      cC cat wcel wa cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss vx cv cA
      wss cB cC vx cv chj co wss wa vx cat wrex cB cat wcel cC cat wcel wa cB
      cC wceq wn cC cA wss wn wa cB cA cC chj co wss wa cA cB cC chj co cin cat
      wcel cA cB cC chj co cin cA wss cB cC cA cB cC chj co cin chj co wss wa
      wa vx cv cA wss cB cC vx cv chj co wss wa vx cat wrex cB cat wcel cC cat
      wcel wa cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss wa cA cB cC chj
      co cin cat wcel cA cB cC chj co cin cA wss cB cC cA cB cC chj co cin chj
      co wss wa cA cB cC atcvat3.1 atcvat3i cB cat wcel cC cat wcel wa cB cC
      wceq wn cC cA wss wn wa cB cA cC chj co wss wa cA cB cC chj co cin cA wss
      cB cC cA cB cC chj co cin chj co wss wa cB cat wcel cC cat wcel wa cB cC
      wceq wn cC cA wss wn wa cB cA cC chj co wss wa wa cB cC cA cB cC chj co
      cin chj co wss cA cB cC chj co cin cA wss cC cch wcel cA cB cC chj co cin
      cat wcel cB cat wcel w3a cA cB cC chj co cin cC cB chj co wss cC cA cB cC
      chj co cin cin c0h wceq wa cB cC cA cB cC chj co cin chj co wss cB cat
      wcel cC cat wcel wa cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss wa
      wa cC cA cB cC chj co cin cB atexch cB cat wcel cC cat wcel wa cB cC wceq
      wn cC cA wss wn wa cB cA cC chj co wss wa wa cC cch wcel cA cB cC chj co
      cin cat wcel cB cat wcel cC cat wcel cC cch wcel cB cat wcel cB cC wceq
      wn cC cA wss wn wa cB cA cC chj co wss wa cC atelch ad2antlr cB cat wcel
      cC cat wcel wa cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss wa cA cB
      cC chj co cin cat wcel cA cB cC atcvat3.1 atcvat3i imp cB cat wcel cC cat
      wcel cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss wa simpll 3jca cB
      cat wcel cC cat wcel wa cB cC wceq wn cC cA wss wn wa cB cA cC chj co wss
      wa wa cA cB cC chj co cin cC cB chj co wss cC cA cB cC chj co cin cin c0h
      wceq cB cat wcel cC cat wcel wa cA cB cC chj co cin cC cB chj co wss cB
      cC wceq wn cC cA wss wn wa cB cA cC chj co wss wa cB cat wcel cC cat wcel
      wa cA cB cC chj co cin cB cC chj co cC cB chj co cA cB cC chj co cin cB
      cC chj co wss cB cat wcel cC cat wcel wa cA cB cC chj co inss2 a1i cB cch
      wcel cC cch wcel cB cC chj co cC cB chj co wceq cB cat wcel cC cat wcel
      cB cC chjcom cB atelch cC atelch syl2an sseqtrd adantr cB cat wcel cC cat
      wcel wa cB cC wceq wn cC cA wss wn wa cC cA cB cC chj co cin cin c0h wceq
      cB cA cC chj co wss cB cat wcel cC cat wcel wa cC cA wss wn cC cA cB cC
      chj co cin cin c0h wceq cB cC wceq wn cB cat wcel cC cat wcel wa cC cA
      wss wn cC cA cB cC chj co cin cin c0h wceq cB cat wcel cC cat wcel wa cC
      cA wss wn cA cC cin c0h wceq cC cA cB cC chj co cin cin c0h wceq cC cat
      wcel cC cA wss wn cA cC cin c0h wceq wb cB cat wcel cA cch wcel cC cat
      wcel cC cA wss wn cA cC cin c0h wceq wb atcvat3.1 cA cC atnssm0 mpan
      adantl cB cat wcel cC cat wcel wa cC cA cB cC chj co cin cin c0h wss cC
      cA cB cC chj co cin cin c0h wceq cA cC cin c0h wceq cB cat wcel cC cat
      wcel wa cC cA cB cC chj co cin cin cch wcel cC cA cB cC chj co cin cin
      c0h wss cC cA cB cC chj co cin cin c0h wceq wb cB cch wcel cC cch wcel cC
      cA cB cC chj co cin cin cch wcel cB cat wcel cC cat wcel cC cch wcel cA
      cB cC chj co cin cch wcel cC cA cB cC chj co cin cin cch wcel cB cch wcel
      cC cch wcel wa cC cA cB cC chj co cin chincl cB cch wcel cC cch wcel
      pm3.27 cB cch wcel cC cch wcel wa cB cC chj co cch wcel cA cB cC chj co
      cin cch wcel cB cC chjcl cA cch wcel cB cC chj co cch wcel cA cB cC chj
      co cin cch wcel atcvat3.1 cA cB cC chj co chincl mpan syl sylanc cB
      atelch cC atelch syl2an cC cA cB cC chj co cin cin chle0 syl cA cC cin
      c0h wceq cC cA cB cC chj co cin cin cA cC cin wss cC cA cB cC chj co cin
      cin c0h wss cC cA cB cC chj co cin cin cC cA cin cA cC cin cA cB cC chj
      co cin cA wss cC cA cB cC chj co cin cin cC cA cin wss cA cB cC chj co
      inss1 cA cB cC chj co cin cA cC sslin ax-mp cC cA incom sseqtri cA cC cin
      c0h cC cA cB cC chj co cin cin sseq2 mpbii syl5bi sylbid imp adantrl
      adantrr jca sylc cA cB cC chj co inss1 jctil ex jcad vx cv cA wss cB cC
      vx cv chj co wss wa cA cB cC chj co cin cA wss cB cC cA cB cC chj co cin
      chj co wss wa vx cA cB cC chj co cin cat vx cv cA cB cC chj co cin wceq
      vx cv cA wss cA cB cC chj co cin cA wss cB cC vx cv chj co wss cB cC cA
      cB cC chj co cin chj co wss vx cv cA cB cC chj co cin cA sseq1 vx cv cA
      cB cC chj co cin wceq cC vx cv chj co cC cA cB cC chj co cin chj co cB vx
      cv cA cB cC chj co cin cC chj opreq2 sseq2d anbi12d rcla4ev syl6 exp3a cB
      cC wceq cC cA wss ioran syl5ib cA c0h wne cB cA cC chj co wss pm3.27 syl7
      ecase3d $.
      $( [22-Apr-2007] $) $( [2-Jul-2004] $)
  $}

  $( Two Hilbert lattice elements have the dual modular pair property if the
     first is an atom.  Theorem 7.6(c) of [MaedaMaeda] p. 31. $)
  atdmd $p |- ( ( A e. Atoms /\ B e. CH ) -> A MH* B ) $=
    cA cat wcel cB cch wcel wa cB cA cin c0h wceq cA cB cdmd wbr cA cat wcel cB
    cch wcel wa cB cA cin c0h wceq cB cA cB chj co ccv wbr cA cB cdmd wbr cB
    cch wcel cA cat wcel cB cA cin c0h wceq cB cA cB chj co ccv wbr wb cB cch
    wcel cA cat wcel wa cB cA cin c0h wceq cB cB cA chj co ccv wbr cB cA cB chj
    co ccv wbr cB cA cvp cB cch wcel cA cat wcel wa cB cA chj co cA cB chj co
    cB ccv cB cch wcel cA cch wcel cB cA chj co cA cB chj co wceq cA cat wcel
    cB cA chjcom cA atelch sylan2 breq2d bitrd ancoms cA cch wcel cB cch wcel
    cB cA cB chj co ccv wbr cA cB cdmd wbr wi cA cat wcel cA cch wcel cB cch
    wcel cB cA cB chj co ccv wbr cA cB cdmd wbr cA cB cvdmd 3expia cA atelch
    sylan sylbid cA cat wcel cB cch wcel wa cB cA cin c0h wceq wn cA cB wss cA
    cB cdmd wbr cA cat wcel cB cch wcel wa cA cB wss cB cA cin c0h wceq cB cch
    wcel cA cat wcel cA cB wss wn cB cA cin c0h wceq wb cB cA atnssm0 ancoms
    con1bid cA cch wcel cB cch wcel cA cB wss cA cB cdmd wbr wi cA cat wcel cA
    cch wcel cB cch wcel cA cB wss cA cB cdmd wbr cA cB ssdmd1 3expia cA atelch
    sylan sylbid pm2.61d $.
    $( [27-Jul-2007] $) $( [22-Jun-2004] $)

  ${
    $d x A $.  $d x B $.
    $( Two Hilbert lattice elements have the modular pair property if the
       first is an atom.  Theorem 7.6(b) of [MaedaMaeda] p. 31. $)
    atmd $p |- ( ( A e. Atoms /\ B e. CH ) -> A MH B ) $=
      cA cat wcel cB cch wcel wa cA vx cv cmd wbr vx cch wral cA cB cmd wbr cA
      cat wcel cA vx cv cmd wbr vx cch wral cB cch wcel cA cat wcel cA vx cv
      cmd wbr vx cch wral cA vx cv cdmd wbr vx cch wral cA cat wcel cA vx cv
      cdmd wbr vx cch cA vx cv atdmd r19.21aiva cA cat wcel cA cch wcel cA vx
      cv cmd wbr vx cch wral cA vx cv cdmd wbr vx cch wral wb cA atelch vx cA
      mddmd2 syl mpbird adantr cB cch wcel cA vx cv cmd wbr vx cch wral cA cB
      cmd wbr wi cA cat wcel cA vx cv cmd wbr cA cB cmd wbr vx cB cch vx cv cB
      cA cmd breq2 rcla4v adantl mpd $.
      $( [12-Aug-2005] $) $( [22-Jun-2004] $)
  $}

  $( Two Hilbert lattice elements have the dual modular pair property if the
     second is an atom.  Part of Exercise 6 of [Kalmbach] p. 103. $)
  atmd2 $p |- ( ( A e. CH /\ B e. Atoms ) -> A MH B ) $=
    cA cch wcel cB cat wcel wa cA cB cin c0h wceq cA cB cmd wbr cA cch wcel cB
    cat wcel wa cA cB cin c0h wceq cA cA cB chj co ccv wbr cA cB cmd wbr cA cB
    cvp cA cch wcel cB cch wcel cA cA cB chj co ccv wbr cA cB cmd wbr wi cB cat
    wcel cA cch wcel cB cch wcel wa cA cA cB chj co ccv wbr cA cB cin cB ccv
    wbr cA cB cmd wbr cA cB cvexch cA cch wcel cB cch wcel cA cB cin cB ccv wbr
    cA cB cmd wbr cA cB cvmd 3expia sylbird cB atelch sylan2 sylbid cA cch wcel
    cB cat wcel wa cA cB cin c0h wceq wn cB cA wss cA cB cmd wbr cA cch wcel cB
    cat wcel wa cB cA wss cA cB cin c0h wceq cA cB atnssm0 con1bid cA cch wcel
    cB cat wcel cB cA wss cA cB cmd wbr cA cch wcel cB cch wcel cB cA wss cA cB
    cmd wbr cB cat wcel cB cch wcel cA cch wcel cB cA wss cA cB cmd wbr cB cA
    ssmd2 3com12 cB atelch syl3an2 3expia sylbid pm2.61d $.
    $( [23-Sep-2005] $) $( [22-Jun-2004] $)

  ${
    atabs.1 $e |- A e. CH $.
    atabs.2 $e |- B e. CH $.
    $( Absorption of an incomparable atom.  Similar to Exercise 7.1 of
       [MaedaMaeda] p. 34. $)
    atabsi $p |- ( C e. Atoms -> ( -. C C_ ( A vH B ) ->
                ( ( A vH C ) i^i B ) = ( A i^i B ) ) ) $=
      cC cat wcel cC cA cB chj co wss wn cA cC chj co cB cin cA cB cin wceq cC
      cat wcel cC cA cB chj co wss wn wa cA cC chj co cA cB chj co cin cB cin
      cA cB cin cA cC chj co cB cin cC cat wcel cC cA cB chj co wss wn wa cA cC
      chj co cA cB chj co cin cA cB cC cat wcel cC cA cB chj co wss wn wa cA cC
      chj co cA cB chj co cin cA cC cA cB chj co cin chj co cA cC cat wcel cA
      cC chj co cA cB chj co cin cA cC cA cB chj co cin chj co wceq cC cA cB
      chj co wss wn cC cat wcel cA cA cB chj co wss cA cC chj co cA cB chj co
      cin cA cC cA cB chj co cin chj co wceq cA cB atabs.1 atabs.2 chub1i cC
      cch wcel cC cA cB chj co cmd wbr cA cA cB chj co wss cA cC chj co cA cB
      chj co cin cA cC cA cB chj co cin chj co wceq wi cC cat wcel cC cch wcel
      cA cB chj co cch wcel cA cch wcel cC cA cB chj co cmd wbr cA cA cB chj co
      wss cA cC chj co cA cB chj co cin cA cC cA cB chj co cin chj co wceq wi
      wi cA cB atabs.1 atabs.2 chjcli atabs.1 cC cch wcel cA cB chj co cch wcel
      cA cch wcel w3a cC cA cB chj co cmd wbr cA cA cB chj co wss cA cC chj co
      cA cB chj co cin cA cC cA cB chj co cin chj co wceq cC cA cB chj co cA
      mdi exp32 mp3an23 cC atelch cC cat wcel cA cB chj co cch wcel cC cA cB
      chj co cmd wbr cA cB atabs.1 atabs.2 chjcli cC cA cB chj co atmd mpan2
      sylc mpi adantr cC cat wcel cC cA cB chj co wss wn wa cA cC cA cB chj co
      cin chj co cA c0h chj co cA cC cat wcel cC cA cB chj co wss wn wa cC cA
      cB chj co cin c0h cA chj cC cat wcel cC cA cB chj co wss wn wa cA cB chj
      co cC cin c0h cC cA cB chj co cin cC cat wcel cC cA cB chj co wss wn cA
      cB chj co cC cin c0h wceq cA cB chj co cch wcel cC cat wcel cC cA cB chj
      co wss wn cA cB chj co cC cin c0h wceq wb cA cB atabs.1 atabs.2 chjcli cA
      cB chj co cC atnssm0 mpan biimpa cC cA cB chj co incom syl5eq opreq2d cA
      atabs.1 chj0i syl6eq eqtrd ineq1d cA cC chj co cA cB chj co cin cB cin cA
      cC chj co cA cB chj co cB cin cin cA cC chj co cB cin cA cC chj co cA cB
      chj co cB inass cA cB chj co cB cin cB cA cC chj co cA cB chj co cB cin
      cB cA chj co cB cin cB cB cA chj co cin cB cA cB chj co cB cA chj co cB
      cA cB atabs.1 atabs.2 chjcomi ineq1i cB cA chj co cB incom cB cA atabs.2
      atabs.1 chabs2i 3eqtri ineq2i eqtr2i syl5eq ex $.
      $( [29-Dec-2005] $) $( [15-Jul-2004] $)

    $( Absorption of an incomparable atom. $)
    atabs2i $p |- ( C e. Atoms -> ( -. C C_ ( A vH B ) ->
                ( ( A vH C ) i^i ( A vH B ) ) = A ) ) $=
      cC cat wcel cC cA cA cB chj co chj co wss wn cA cC chj co cA cB chj co
      cin cA cA cB chj co cin wceq cC cA cB chj co wss wn cA cC chj co cA cB
      chj co cin cA wceq cA cA cB chj co cC atabs.1 cA cB atabs.1 atabs.2
      chjcli atabsi cC cA cA cB chj co chj co wss cC cA cB chj co wss cA cA cB
      chj co chj co cA cB chj co cC cA cA chj co cB chj co cA cA cB chj co chj
      co cA cB chj co cA cA cB atabs.1 atabs.1 atabs.2 chjassi cA cA chj co cA
      cB chj cA atabs.1 chjidmi opreq1i eqtr3i sseq2i notbii cA cA cB chj co
      cin cA cA cC chj co cA cB chj co cin cA cB atabs.1 atabs.2 chabs2i eqeq2i
      3imtr3g $.
      $( [19-Feb-2006] $) $( [18-Jul-2004] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Modular symmetry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d q r C $.
    $d c p q r A $.  $d c p q r B $.
    mdsymlem1.1 $e |- A e. CH $.
    mdsymlem1.2 $e |- B e. CH $.
    mdsymlem1.3 $e |- C = ( A vH p ) $.
    $( Lemma for ~ mdsymi . $)
    mdsymlem1 $p |- ( ( ( p e. CH /\ ( B i^i C ) C_ A ) /\
            ( B MH* A /\ p C_ ( A vH B ) ) ) -> p C_ A ) $=
      vp cv cch wcel cB cC cin cA wss wa cB cA cdmd wbr vp cv cA cB chj co wss
      wa wa vp cv cC cB cA chj co cin cA vp cv cch wcel vp cv cA cB chj co wss
      vp cv cC cB cA chj co cin wss cB cC cin cA wss cB cA cdmd wbr vp cv cch
      wcel vp cv cA cB chj co wss wa vp cv cC wss vp cv cB cA chj co wss wa vp
      cv cC cB cA chj co cin wss vp cv cch wcel vp cv cC wss vp cv cA cB chj co
      wss vp cv cB cA chj co wss vp cv cch wcel vp cv cA vp cv chj co cC vp cv
      cch wcel cA cch wcel vp cv cA vp cv chj co wss mdsymlem1.1 vp cv cA chub2
      mpan2 mdsymlem1.3 syl6ssr vp cv cA cB chj co wss vp cv cB cA chj co wss
      cA cB chj co cB cA chj co vp cv cA cB mdsymlem1.1 mdsymlem1.2 chjcomi
      sseq2i biimpi anim12i vp cv cC cB cA chj co ssin sylib ad2ant2rl vp cv
      cch wcel cB cC cin cA wss wa cB cA cdmd wbr cC cB cA chj co cin cA wceq
      vp cv cA cB chj co wss vp cv cch wcel cB cC cin cA wss wa cB cA cdmd wbr
      wa cC cB cin cA chj co cC cB cA chj co cin cA vp cv cch wcel cB cA cdmd
      wbr cC cB cin cA chj co cC cB cA chj co cin wceq cB cC cin cA wss cC cch
      wcel cB cA cdmd wbr cA cC wss wa cC cB cin cA chj co cC cB cA chj co cin
      wceq vp cv cch wcel cB cA cdmd wbr wa cA cch wcel cC cch wcel cB cA cdmd
      wbr cA cC wss wa cC cB cin cA chj co cC cB cA chj co cin wceq mdsymlem1.1
      cB cch wcel cA cch wcel cC cch wcel cB cA cdmd wbr cA cC wss wa cC cB cin
      cA chj co cC cB cA chj co cin wceq mdsymlem1.2 cB cA cC dmdi mp3anl1
      mpanl1 vp cv cch wcel cC cch wcel cB cA cdmd wbr vp cv cch wcel cA vp cv
      chj co cch cC cA cch wcel vp cv cch wcel cA vp cv chj co cch wcel
      mdsymlem1.1 cA vp cv chjcl mpan mdsymlem1.3 syl5eqel adantr cB cA cdmd
      wbr vp cv cch wcel cB cA cdmd wbr cA cC wss wa vp cv cch wcel cA cC wss
      cB cA cdmd wbr vp cv cch wcel cA cA vp cv chj co cC cA cch wcel vp cv cch
      wcel cA cA vp cv chj co wss mdsymlem1.1 cA vp cv chub1 mpan mdsymlem1.3
      syl6ssr anim2i ancoms sylanc adantlr vp cv cch wcel cB cC cin cA wss wa
      cC cB cin cA chj co cA wceq cB cA cdmd wbr vp cv cch wcel cB cC cin cA
      wss wa cB cC cin cA chj co cA cC cB cin cA chj co vp cv cch wcel cB cC
      cin cA wss cB cC cin cA chj co cA wceq vp cv cch wcel cC cch wcel cB cC
      cin cch wcel cB cC cin cA wss cB cC cin cA chj co cA wceq wb vp cv cch
      wcel cA vp cv chj co cch cC cA cch wcel vp cv cch wcel cA vp cv chj co
      cch wcel mdsymlem1.1 cA vp cv chjcl mpan mdsymlem1.3 syl5eqel cB cch wcel
      cC cch wcel cB cC cin cch wcel mdsymlem1.2 cB cC chincl mpan cB cC cin
      cch wcel cA cch wcel cB cC cin cA wss cB cC cin cA chj co cA wceq wb
      mdsymlem1.1 cB cC cin cA chlejb1 mpan2 3syl biimpa cC cB cin cB cC cin cA
      chj cC cB incom opreq1i syl5eq adantr eqtr3d adantrr sseqtrd $.
      $( [29-Jul-2007] $) $( [1-Jul-2004] $)

    $( Lemma for ~ mdsymi . $)
    mdsymlem2 $p |- ( ( ( p e. Atoms /\ ( B i^i C ) C_ A ) /\
         ( B MH* A /\ p C_ ( A vH B ) ) ) -> ( B =/= 0H -> E. r e. Atoms
         E. q e. Atoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) ) $=
      vp cv cat wcel cB cC cin cA wss wa cB cA cdmd wbr vp cv cA cB chj co wss
      wa wa vr cv cB wss vr cat wrex vp cv vq cv vr cv chj co wss vq cv cA wss
      vr cv cB wss wa wa vq cat wrex vr cat wrex cB c0h wne vp cv cat wcel cB
      cC cin cA wss wa cB cA cdmd wbr vp cv cA cB chj co wss wa wa vr cv cB wss
      vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex
      vr cat vp cv cat wcel cB cC cin cA wss wa cB cA cdmd wbr vp cv cA cB chj
      co wss wa wa vr cv cat wcel vr cv cB wss vp cv vq cv vr cv chj co wss vq
      cv cA wss vr cv cB wss wa wa vq cat wrex vp cv cat wcel vp cv vp cv vr cv
      chj co wss vp cv cA wss vr cv cB wss wa wa vp cv vq cv vr cv chj co wss
      vq cv cA wss vr cv cB wss wa wa vq cat wrex vp cv cat wcel cB cC cin cA
      wss wa cB cA cdmd wbr vp cv cA cB chj co wss wa wa vr cv cat wcel vr cv
      cB wss wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa
      vp cv vp cv vr cv chj co wss vp cv cA wss vr cv cB wss wa wa vq vp cv cat
      vq cv vp cv wceq vp cv vq cv vr cv chj co wss vp cv vp cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa vp cv cA wss vr cv cB wss wa vq cv vp cv
      wceq vq cv vr cv chj co vp cv vr cv chj co vp cv vq cv vp cv vr cv chj
      opreq1 sseq2d vq cv vp cv wceq vq cv cA wss vp cv cA wss vr cv cB wss vq
      cv vp cv cA sseq1 anbi1d anbi12d rcla4ev vp cv cat wcel cB cC cin cA wss
      wa vp cv cat wcel cB cA cdmd wbr vp cv cA cB chj co wss wa vr cv cat wcel
      vr cv cB wss wa vp cv cat wcel cB cC cin cA wss pm3.26 ad2antrr vp cv cat
      wcel cB cC cin cA wss wa cB cA cdmd wbr vp cv cA cB chj co wss wa wa vr
      cv cat wcel vr cv cB wss vp cv vp cv vr cv chj co wss vp cv cA wss vr cv
      cB wss wa wa vp cv cat wcel cB cC cin cA wss wa cB cA cdmd wbr vp cv cA
      cB chj co wss wa wa vr cv cat wcel wa vr cv cB wss wa vp cv vp cv vr cv
      chj co wss vp cv cA wss wa vr cv cB wss wa vp cv vp cv vr cv chj co wss
      vp cv cA wss vr cv cB wss wa wa vp cv cat wcel cB cC cin cA wss wa cB cA
      cdmd wbr vp cv cA cB chj co wss wa wa vr cv cat wcel wa vp cv vp cv vr cv
      chj co wss vp cv cA wss wa vr cv cB wss vp cv cat wcel cB cC cin cA wss
      wa cB cA cdmd wbr vp cv cA cB chj co wss wa wa vr cv cat wcel wa vp cv vp
      cv vr cv chj co wss vp cv cA wss vp cv cat wcel cB cC cin cA wss wa vr cv
      cat wcel vp cv vp cv vr cv chj co wss cB cA cdmd wbr vp cv cA cB chj co
      wss wa vp cv cat wcel vr cv cat wcel vp cv vp cv vr cv chj co wss cB cC
      cin cA wss vp cv cch wcel vr cv cch wcel vp cv vp cv vr cv chj co wss vp
      cv cat wcel vr cv cat wcel vp cv vr cv chub1 vp cv atelch vr cv atelch
      syl2an adantlr adantlr vp cv cat wcel cB cC cin cA wss wa cB cA cdmd wbr
      vp cv cA cB chj co wss wa wa vp cv cA wss vr cv cat wcel vp cv cch wcel
      cB cC cin cA wss cB cA cdmd wbr vp cv cA cB chj co wss wa vp cv cA wss vp
      cv cat wcel cA cB cC vp mdsymlem1.1 mdsymlem1.2 mdsymlem1.3 mdsymlem1 vp
      cv atelch sylanl1 adantr jca anim1i vp cv vp cv vr cv chj co wss vp cv cA
      wss vr cv cB wss anass sylib anasss sylanc exp32 r19.22dv vr cB
      mdsymlem1.2 hatomici syl5 $.
      $( [29-Jul-2007] $) $( [1-Jul-2004] $)

    $( Lemma for ~ mdsymi . $)
    mdsymlem3 $p |- ( ( ( ( p e. Atoms /\ -. ( B i^i C ) C_ A ) /\
               p C_ ( A vH B ) ) /\ A =/= 0H ) ->
   E. r e. Atoms E. q e. Atoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) $=
      vp cv cat wcel cB cC cin cA wss wn wa vp cv cA cB chj co wss wa cA c0h
      wne wa vr cv cB cC cin wss vr cv cA wss wn wa vr cat wrex vp cv vq cv vr
      cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat wrex vp
      cv cat wcel cB cC cin cA wss wn wa vr cv cB cC cin wss vr cv cA wss wn wa
      vr cat wrex vp cv cA cB chj co wss cA c0h wne vp cv cat wcel cB cC cin cA
      wss wn vr cv cB cC cin wss vr cv cA wss wn wa vr cat wrex vp cv cat wcel
      vp cv cch wcel cB cC cin cch wcel cB cC cin cA wss wn vr cv cB cC cin wss
      vr cv cA wss wn wa vr cat wrex wb vp cv atelch vp cv cch wcel cC cch wcel
      cB cC cin cch wcel vp cv cch wcel cA vp cv chj co cch cC cA cch wcel vp
      cv cch wcel cA vp cv chj co cch wcel mdsymlem1.1 cA vp cv chjcl mpan
      mdsymlem1.3 syl5eqel cB cch wcel cC cch wcel cB cC cin cch wcel
      mdsymlem1.2 cB cC chincl mpan syl cB cC cin cch wcel cA cch wcel cB cC
      cin cA wss wn vr cv cB cC cin wss vr cv cA wss wn wa vr cat wrex wb
      mdsymlem1.1 vr cB cC cin cA chrelat2 mpan2 3syl biimpa ad2antrr vp cv cat
      wcel cB cC cin cA wss wn wa vp cv cA cB chj co wss wa cA c0h wne wa vr cv
      cB cC cin wss vr cv cA wss wn wa vp cv vq cv vr cv chj co wss vq cv cA
      wss vr cv cB wss wa wa vq cat wrex vr cat vp cv cat wcel cB cC cin cA wss
      wn wa vp cv cA cB chj co wss wa cA c0h wne wa vr cv cat wcel vr cv cB cC
      cin wss vr cv cA wss wn wa vp cv vq cv vr cv chj co wss vq cv cA wss vr
      cv cB wss wa wa vq cat wrex vp cv cat wcel cB cC cin cA wss wn wa vp cv
      cA cB chj co wss wa cA c0h wne wa vr cv cat wcel vr cv cB cC cin wss vr
      cv cA wss wn wa wa wa vq cv cA wss vr cv vp cv vq cv chj co wss wa vq cat
      wrex vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat
      wrex vp cv cat wcel cB cC cin cA wss wn wa vp cv cA cB chj co wss wa cA
      c0h wne wa vr cv cat wcel vr cv cB cC cin wss vr cv cA wss wn wa wa vq cv
      cA wss vr cv vp cv vq cv chj co wss wa vq cat wrex vp cv cat wcel cB cC
      cin cA wss wn wa cA c0h wne vr cv cat wcel vr cv cB cC cin wss vr cv cA
      wss wn wa wa vq cv cA wss vr cv vp cv vq cv chj co wss wa vq cat wrex wi
      vp cv cA cB chj co wss vp cv cat wcel cA c0h wne vr cv cat wcel vr cv cB
      cC cin wss vr cv cA wss wn wa wa vq cv cA wss vr cv vp cv vq cv chj co
      wss wa vq cat wrex wi cB cC cin cA wss wn vr cv cat wcel vr cv cB cC cin
      wss vr cv cA wss wn wa wa vp cv cat wcel cA c0h wne wa vq cv cA wss vr cv
      vp cv vq cv chj co wss wa vq cat wrex vr cv cat wcel vr cv cB cC cin wss
      vp cv cat wcel cA c0h wne wa vq cv cA wss vr cv vp cv vq cv chj co wss wa
      vq cat wrex wi vr cv cA wss wn vr cv cat wcel vr cv cA vp cv chj co wss
      vp cv cat wcel cA c0h wne wa vq cv cA wss vr cv vp cv vq cv chj co wss wa
      vq cat wrex wi vr cv cB cC cin wss vr cv cat wcel vr cv cA vp cv chj co
      wss vp cv cat wcel cA c0h wne vq cv cA wss vr cv vp cv vq cv chj co wss
      wa vq cat wrex vr cv cat wcel vp cv cat wcel vr cv cA vp cv chj co wss cA
      c0h wne vq cv cA wss vr cv vp cv vq cv chj co wss wa vq cat wrex wi vr cv
      cat wcel vp cv cat wcel cA c0h wne vr cv cA vp cv chj co wss vq cv cA wss
      vr cv vp cv vq cv chj co wss wa vq cat wrex vr cv cat wcel vp cv cat wcel
      cA c0h wne vr cv cA vp cv chj co wss vq cv cA wss vr cv vp cv vq cv chj
      co wss wa vq cat wrex vq cA vr cv vp cv mdsymlem1.1 atcvat4i exp4b com34
      com23 imp4b vr cv cB cC cin wss vr cv cB wss vr cv cC wss wa vr cv cA vp
      cv chj co wss vr cv cB cC ssin vr cv cC wss vr cv cA vp cv chj co wss vr
      cv cB wss vr cv cC wss vr cv cA vp cv chj co wss cC cA vp cv chj co vr cv
      mdsymlem1.3 sseq2i biimpi adantl sylbir sylan2 adantrr com12 adantlr
      adantlr imp vp cv cat wcel cB cC cin cA wss wn wa vp cv cA cB chj co wss
      wa cA c0h wne wa vr cv cat wcel vr cv cB cC cin wss vr cv cA wss wn wa wa
      wa vq cv cA wss vr cv vp cv vq cv chj co wss wa vp cv vq cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa wa vq cat vp cv cat wcel cB cC cin cA
      wss wn wa vp cv cA cB chj co wss wa vr cv cat wcel vr cv cB cC cin wss vr
      cv cA wss wn wa wa vq cv cat wcel vq cv cA wss vr cv vp cv vq cv chj co
      wss wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa wi wi
      cA c0h wne vp cv cat wcel cB cC cin cA wss wn wa vr cv cat wcel vr cv cB
      cC cin wss vr cv cA wss wn wa wa vq cv cat wcel vq cv cA wss vr cv vp cv
      vq cv chj co wss wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa wi wi vp cv cA cB chj co wss vp cv cat wcel vr cv cat wcel vr
      cv cB cC cin wss vr cv cA wss wn wa wa vq cv cat wcel vq cv cA wss vr cv
      vp cv vq cv chj co wss wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv
      cB wss wa wa wi wi cB cC cin cA wss wn vp cv cat wcel vr cv cat wcel vr
      cv cB cC cin wss vr cv cA wss wn wa wa wa vq cv cat wcel vq cv cA wss vr
      cv vp cv vq cv chj co wss wa vp cv vq cv vr cv chj co wss vq cv cA wss vr
      cv cB wss wa wa vp cv cat wcel vr cv cat wcel vr cv cB cC cin wss vr cv
      cA wss wn wa wa wa vq cv cat wcel vq cv cA wss vr cv vp cv vq cv chj co
      wss wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa vp cv
      cat wcel vr cv cat wcel vr cv cB cC cin wss vr cv cA wss wn wa vq cv cat
      wcel vq cv cA wss vr cv vp cv vq cv chj co wss wa wa vp cv vq cv vr cv
      chj co wss wi vp cv cat wcel vr cv cat wcel wa vr cv cB cC cin wss vr cv
      cA wss wn wa vq cv cat wcel vq cv cA wss vr cv vp cv vq cv chj co wss wa
      vp cv vq cv vr cv chj co wss vp cv cat wcel vr cv cat wcel wa vq cv cA
      wss vr cv vp cv vq cv chj co wss wa vq cv cat wcel vr cv cB cC cin wss vr
      cv cA wss wn wa vp cv vq cv vr cv chj co wss vp cv cat wcel vr cv cat
      wcel wa vq cv cA wss vr cv vp cv vq cv chj co wss vq cv cat wcel vr cv cB
      cC cin wss vr cv cA wss wn wa vp cv vq cv vr cv chj co wss wi wi vp cv
      cat wcel vr cv cat wcel wa vq cv cat wcel vr cv vp cv vq cv chj co wss vq
      cv cA wss vr cv cB cC cin wss vr cv cA wss wn wa vp cv vq cv vr cv chj co
      wss wi vp cv cat wcel vr cv cat wcel wa vq cv cat wcel vr cv vp cv vq cv
      chj co wss vq cv cA wss vr cv cB cC cin wss vr cv cA wss wn wa vp cv vq
      cv vr cv chj co wss wi wi vp cv cat wcel vr cv cat wcel wa vq cv cat wcel
      wa vr cv vp cv vq cv chj co wss wa vq cv cA wss vr cv cB cC cin wss vr cv
      cA wss wn wa vp cv vq cv vr cv chj co wss vp cv cat wcel vr cv cat wcel
      wa vq cv cat wcel wa vr cv vp cv vq cv chj co wss wa vq cv cA wss vr cv
      cB cC cin wss vr cv cA wss wn wa wa vq cv vr cv cin c0h wceq vp cv vq cv
      vr cv chj co wss vp cv cat wcel vr cv cat wcel wa vq cv cat wcel wa vq cv
      cA wss vr cv cB cC cin wss vr cv cA wss wn wa wa vq cv vr cv cin c0h wceq
      wi vr cv vp cv vq cv chj co wss vr cv cat wcel vq cv cat wcel vq cv cA
      wss vr cv cB cC cin wss vr cv cA wss wn wa wa vq cv vr cv cin c0h wceq wi
      vp cv cat wcel vr cv cat wcel vq cv cat wcel wa vq cv vr cv wceq wn vq cv
      vr cv cin c0h wceq vq cv cA wss vr cv cB cC cin wss vr cv cA wss wn wa wa
      vq cv cat wcel vr cv cat wcel vq cv vr cv wceq wn vq cv vr cv cin c0h
      wceq wb vq cv vr cv atnem0OLD ancoms vq cv cA wss vr cv cA wss wn vq cv
      vr cv wceq wn vr cv cB cC cin wss vq cv cA wss vr cv cA wss wn vq cv vr
      cv wceq wn vq cv cA wss vq cv vr cv wceq vr cv cA wss vq cv vr cv wceq vq
      cv cA wss vr cv cA wss vq cv vr cv cA sseq1 biimpcd con3d imp adantrl
      syl5bi adantll adantr vp cv cat wcel vr cv cat wcel wa vq cv cat wcel wa
      vr cv vp cv vq cv chj co wss vq cv vr cv cin c0h wceq vp cv vq cv vr cv
      chj co wss wi vp cv cat wcel vr cv cat wcel wa vq cv cat wcel wa vr cv vp
      cv vq cv chj co wss vr cv vq cv vp cv chj co wss vq cv vr cv cin c0h wceq
      vp cv vq cv vr cv chj co wss wi vp cv cat wcel vr cv cat wcel wa vq cv
      cat wcel wa vp cv vq cv chj co vq cv vp cv chj co vr cv vp cv cat wcel vq
      cv cat wcel vp cv vq cv chj co vq cv vp cv chj co wceq vr cv cat wcel vp
      cv cch wcel vq cv cch wcel vp cv vq cv chj co vq cv vp cv chj co wceq vp
      cv cat wcel vq cv cat wcel vp cv vq cv chjcom vp cv atelch vq cv atelch
      syl2an adantlr sseq2d vp cv cat wcel vr cv cat wcel wa vq cv cat wcel wa
      vr cv vq cv vp cv chj co wss vq cv vr cv cin c0h wceq vp cv vq cv vr cv
      chj co wss vp cv cat wcel vr cv cat wcel vq cv cat wcel vr cv vq cv vp cv
      chj co wss vq cv vr cv cin c0h wceq wa vp cv vq cv vr cv chj co wss wi vq
      cv cat wcel vr cv cat wcel vp cv cat wcel vr cv vq cv vp cv chj co wss vq
      cv vr cv cin c0h wceq wa vp cv vq cv vr cv chj co wss wi vq cv cch wcel
      vr cv cat wcel vp cv cat wcel vr cv vq cv vp cv chj co wss vq cv vr cv
      cin c0h wceq wa vp cv vq cv vr cv chj co wss wi vq cv cat wcel vq cv vr
      cv vp cv atexch vq cv atelch syl3an1 3com13 3expa exp3a sylbid imp syld
      exp3a exp31 com24 imp3a com24 imp4b anasss vp cv cat wcel vr cv cat wcel
      vr cv cB cC cin wss vr cv cA wss wn wa wa wa vq cv cat wcel vq cv cA wss
      vr cv vp cv vq cv chj co wss wa wa vq cv cA wss vr cv cB wss vq cv cat
      wcel vq cv cA wss vr cv vp cv vq cv chj co wss wa wa vq cv cA wss wi vp
      cv cat wcel vr cv cat wcel vr cv cB cC cin wss vr cv cA wss wn wa wa wa
      vq cv cat wcel vq cv cA wss vr cv vp cv vq cv chj co wss simprl a1i vr cv
      cat wcel vr cv cB cC cin wss vr cv cA wss wn wa wa vr cv cB wss vp cv cat
      wcel vr cv cB cC cin wss vr cv cB wss vr cv cat wcel vr cv cA wss wn vr
      cv cB cC cin wss vr cv cB wss vr cv cC wss wa vr cv cB wss vr cv cB cC
      ssin vr cv cB wss vr cv cC wss pm3.26 sylbir ad2antrl adantl jctird jcad
      exp3a adantlr adantlr adantlr r19.22dv mpd exp32 r19.22dv mpd $.
      $( [18-May-2007] $) $( [2-Jul-2004] $)

    $( Lemma for ~ mdsymi .  This is the forward direction of Lemma 4(i) of
       [Maeda] p. 168. $)
    mdsymlem4 $p |- ( p e. Atoms -> ( ( B MH* A /\
            ( ( A =/= 0H /\ B =/= 0H ) /\ p C_ ( A vH B ) ) ) -> E. q e. Atoms
               E. r e. Atoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) ) $=
      vp cv cat wcel cB cA cdmd wbr cA c0h wne cB c0h wne wa vp cv cA cB chj co
      wss wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq
      cat wrex vr cat wrex vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vr cat wrex vq cat wrex vp cv cat wcel cB cC cin cA wss cB cA
      cdmd wbr cA c0h wne cB c0h wne wa vp cv cA cB chj co wss wa wa vp cv vq
      cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat
      wrex wi cB cA cdmd wbr cA c0h wne cB c0h wne wa vp cv cA cB chj co wss wa
      wa vp cv cat wcel cB cC cin cA wss vp cv vq cv vr cv chj co wss vq cv cA
      wss vr cv cB wss wa wa vq cat wrex vr cat wrex cB cA cdmd wbr cA c0h wne
      cB c0h wne vp cv cA cB chj co wss vp cv cat wcel cB cC cin cA wss vp cv
      vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat
      wrex wi wi cB cA cdmd wbr cB c0h wne vp cv cA cB chj co wss vp cv cat
      wcel cB cC cin cA wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vq cat wrex vr cat wrex wi wi wi wi cA c0h wne cB cA cdmd wbr
      vp cv cA cB chj co wss cB c0h wne vp cv cat wcel cB cC cin cA wss vp cv
      vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat
      wrex wi wi cB cA cdmd wbr vp cv cA cB chj co wss cB c0h wne vp cv cat
      wcel cB cC cin cA wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vq cat wrex vr cat wrex wi wi wi vp cv cat wcel cB cC cin cA
      wss cB cA cdmd wbr vp cv cA cB chj co wss wa cB c0h wne vp cv vq cv vr cv
      chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat wrex vp cv
      cat wcel cB cC cin cA wss cB cA cdmd wbr vp cv cA cB chj co wss wa cB c0h
      wne vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat
      wrex vr cat wrex wi cA cB cC vr vq vp mdsymlem1.1 mdsymlem1.2 mdsymlem1.3
      mdsymlem2 exp31 com4t ex com23 a1d imp44 com3l cB cA cdmd wbr cA c0h wne
      cB c0h wne wa vp cv cA cB chj co wss wa wa vp cv cat wcel cB cC cin cA
      wss wn vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq
      cat wrex vr cat wrex cA c0h wne cB c0h wne wa vp cv cA cB chj co wss wa
      vp cv cat wcel cB cC cin cA wss wn vp cv vq cv vr cv chj co wss vq cv cA
      wss vr cv cB wss wa wa vq cat wrex vr cat wrex wi wi cB cA cdmd wbr cA
      c0h wne vp cv cA cB chj co wss vp cv cat wcel cB cC cin cA wss wn vp cv
      vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat
      wrex wi wi cB c0h wne vp cv cA cB chj co wss cA c0h wne vp cv cat wcel cB
      cC cin cA wss wn vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss
      wa wa vq cat wrex vr cat wrex wi wi vp cv cat wcel cB cC cin cA wss wn vp
      cv cA cB chj co wss cA c0h wne wa vp cv vq cv vr cv chj co wss vq cv cA
      wss vr cv cB wss wa wa vq cat wrex vr cat wrex vp cv cat wcel cB cC cin
      cA wss wn vp cv cA cB chj co wss cA c0h wne wa vp cv vq cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat wrex vp cv cat
      wcel cB cC cin cA wss wn wa vp cv cA cB chj co wss cA c0h wne vp cv vq cv
      vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cat wrex vr cat wrex
      cA cB cC vr vq vp mdsymlem1.1 mdsymlem1.2 mdsymlem1.3 mdsymlem3 anasss
      exp31 com3r ancoms adantlr adantl com3l pm2.61d vp cv vq cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa wa vr vq cat cat rexcom syl6ib $.
      $( [30-Jul-2007] $) $( [2-Jul-2004] $)

    $( Lemma for ~ mdsymi . $)
    mdsymlem5 $p |- ( ( q e. Atoms /\ r e. Atoms ) -> ( -. q = p ->
                    ( ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ->
                    ( ( ( c e. CH /\ A C_ c ) /\ p e. Atoms ) ->
                    ( p C_ c -> p C_ ( ( c i^i B ) vH A ) ) ) ) ) ) $=
      vq cv cat wcel vr cv cat wcel wa vc cv cch wcel cA vc cv wss wa vp cv cat
      wcel wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq
      cv vp cv wceq wn vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi vq
      cv cat wcel vr cv cat wcel wa vc cv cch wcel cA vc cv wss vp cv cat wcel
      vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv
      wceq wn vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi wi wi vq cv
      cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel cA vc cv wss vp
      cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv
      wceq wn vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi wi wi vq cv
      cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel cA vc cv wss vp
      cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv
      wceq wn vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi wi wi wi vq
      cv cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc
      cv wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv
      vp cv wceq wn vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi vq cv
      cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv
      wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp
      cv wceq wn wa wa vp cv vc cv wss vp cv vc cv cB cin cA chj co wss vq cv
      cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv
      wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp
      cv wceq wn wa wa vp cv vc cv wss wa wa vr cv vc cv cB cin wss vp cv vc cv
      cB cin cA chj co wss vq cv cat wcel vr cv cat wcel wa vc cv cch wcel vp
      cv cat wcel wa wa cA vc cv wss vp cv vq cv vr cv chj co wss vq cv cA wss
      vr cv cB wss wa wa vq cv vp cv wceq wn wa wa vp cv vc cv wss wa wa vr cv
      vc cv wss vr cv cB wss wa vr cv vc cv cB cin wss vq cv cat wcel vr cv cat
      wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv wss vp cv vq cv vr
      cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv wceq wn wa wa
      vp cv vc cv wss wa wa vr cv vc cv wss vr cv cB wss vq cv cat wcel vr cv
      cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv wss vp cv vq cv
      vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv wceq wn wa
      wa vp cv vc cv wss wa wa vr cv vq cv vp cv chj co vc cv vq cv cat wcel vr
      cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv wss vp cv vq
      cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv wceq wn
      wa wa vr cv vq cv vp cv chj co wss vp cv vc cv wss vq cv cat wcel vr cv
      cat wcel wa vc cv cch wcel vp cv cat wcel wa wa vp cv vq cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv wceq wn wa vr cv vq cv vp
      cv chj co wss cA vc cv wss vq cv cat wcel vr cv cat wcel wa vc cv cch
      wcel vp cv cat wcel wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv
      cB wss wa wa vq cv vp cv wceq wn vr cv vq cv vp cv chj co wss vq cv cat
      wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa vp cv vq cv vr
      cv chj co wss vq cv vp cv wceq wn vr cv vq cv vp cv chj co wss wi vq cv
      cA wss vr cv cB wss wa vq cv cat wcel vr cv cat wcel wa vp cv cat wcel vp
      cv vq cv vr cv chj co wss vq cv vp cv wceq wn vr cv vq cv vp cv chj co
      wss wi wi vc cv cch wcel vq cv cat wcel vr cv cat wcel vp cv cat wcel vp
      cv vq cv vr cv chj co wss vq cv vp cv wceq wn vr cv vq cv vp cv chj co
      wss wi wi vq cv cat wcel vp cv cat wcel vr cv cat wcel vp cv vq cv vr cv
      chj co wss vq cv vp cv wceq wn vr cv vq cv vp cv chj co wss wi wi vq cv
      cat wcel vp cv cat wcel vr cv cat wcel w3a vp cv vq cv vr cv chj co wss
      vq cv vp cv wceq wn vr cv vq cv vp cv chj co wss vq cv cat wcel vp cv cat
      wcel vr cv cat wcel w3a vp cv vq cv vr cv chj co wss vq cv vp cv wceq wn
      wa vp cv vq cv vr cv chj co wss vq cv vp cv cin c0h wceq wa vr cv vq cv
      vp cv chj co wss vq cv cat wcel vp cv cat wcel vp cv vq cv vr cv chj co
      wss vq cv vp cv wceq wn wa vp cv vq cv vr cv chj co wss vq cv vp cv cin
      c0h wceq wa wb vr cv cat wcel vq cv cat wcel vp cv cat wcel wa vq cv vp
      cv wceq wn vq cv vp cv cin c0h wceq vp cv vq cv vr cv chj co wss vq cv vp
      cv atnem0OLD anbi2d 3adant3 vq cv cch wcel vp cv cat wcel vr cv cat wcel
      vp cv vq cv vr cv chj co wss vq cv vp cv cin c0h wceq wa vr cv vq cv vp
      cv chj co wss wi vq cv cat wcel vq cv vp cv vr cv atexch vq cv atelch
      syl3an1 sylbid exp3a 3com23 3expa adantrl adantrd imp32 adantrl adantrr
      vq cv cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA
      vc cv wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq
      cv vp cv wceq wn wa vp cv vc cv wss vq cv vp cv chj co vc cv wss vq cv
      cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv
      wss vq cv cA wss vp cv vc cv wss vq cv vp cv chj co vc cv wss wi vp cv vq
      cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv wceq wn
      wa vq cv cat wcel vc cv cch wcel vp cv cat wcel wa cA vc cv wss vq cv cA
      wss vp cv vc cv wss vq cv vp cv chj co vc cv wss wi wi wi vr cv cat wcel
      vq cv cch wcel vp cv cch wcel vc cv cch wcel wa cA vc cv wss vq cv cA wss
      vp cv vc cv wss vq cv vp cv chj co vc cv wss wi wi wi vq cv cat wcel vc
      cv cch wcel vp cv cat wcel wa vq cv cch wcel vp cv cch wcel vc cv cch
      wcel cA vc cv wss vq cv cA wss vp cv vc cv wss vq cv vp cv chj co vc cv
      wss wi wi wi vq cv cch wcel vp cv cch wcel wa vc cv cch wcel wa cA vc cv
      wss vq cv cA wss vp cv vc cv wss vq cv vp cv chj co vc cv wss vq cv cch
      wcel vp cv cch wcel wa vc cv cch wcel wa cA vc cv wss vq cv cA wss vp cv
      vc cv wss wa wa wa vq cv vp cv chj co vc cv cA chj co vc cv vq cv cch
      wcel vp cv cch wcel wa vc cv cch wcel wa vq cv cA wss vp cv vc cv wss wa
      vq cv vp cv chj co vc cv cA chj co wss cA vc cv wss vq cv cch wcel vp cv
      cch wcel wa vc cv cch wcel wa vq cv cA wss vp cv vc cv wss wa wa vq cv vc
      cv cA chj co wss vp cv vc cv cA chj co wss wa vq cv vp cv chj co vc cv cA
      chj co wss vc cv cch wcel vq cv cA wss vp cv vc cv wss wa vq cv vc cv cA
      chj co wss vp cv vc cv cA chj co wss wa vq cv cch wcel vp cv cch wcel wa
      vq cv cA wss vp cv vc cv wss wa vc cv cch wcel vq cv vc cv cA chj co wss
      vp cv vc cv cA chj co wss wa vq cv cA wss vp cv vc cv wss vc cv cch wcel
      vq cv vc cv cA chj co wss vp cv vc cv cA chj co wss wa vq cv cA wss vc cv
      cch wcel wa vq cv vc cv cA chj co wss vp cv vc cv wss vc cv cch wcel wa
      vp cv vc cv cA chj co wss vq cv cA wss cA vc cv cA chj co wss vq cv vc cv
      cA chj co wss vc cv cch wcel vq cv cA vc cv cA chj co sstr cA cch wcel vc
      cv cch wcel cA vc cv cA chj co wss mdsymlem1.1 cA vc cv chub2 mpan sylan2
      vp cv vc cv wss vc cv vc cv cA chj co wss vp cv vc cv cA chj co wss vc cv
      cch wcel vp cv vc cv vc cv cA chj co sstr vc cv cch wcel cA cch wcel vc
      cv vc cv cA chj co wss mdsymlem1.1 vc cv cA chub1 mpan2 sylan2 anim12i
      anandirs ancoms adantll vq cv cch wcel vp cv cch wcel wa vc cv cch wcel
      wa vq cv vc cv cA chj co wss vp cv vc cv cA chj co wss wa vq cv vp cv chj
      co vc cv cA chj co wss wb vq cv cA wss vp cv vc cv wss wa vq cv cch wcel
      vp cv cch wcel vc cv cch wcel vq cv vc cv cA chj co wss vp cv vc cv cA
      chj co wss wa vq cv vp cv chj co vc cv cA chj co wss wb vq cv cch wcel vp
      cv cch wcel vc cv cA chj co cch wcel vq cv vc cv cA chj co wss vp cv vc
      cv cA chj co wss wa vq cv vp cv chj co vc cv cA chj co wss wb vc cv cch
      wcel vq cv vp cv vc cv cA chj co chlub vc cv cch wcel cA cch wcel vc cv
      cA chj co cch wcel mdsymlem1.1 vc cv cA chjcl mpan2 syl3an3 3expa adantr
      mpbid adantrl vc cv cch wcel cA vc cv wss vc cv cA chj co vc cv wceq vq
      cv cch wcel vp cv cch wcel wa vq cv cA wss vp cv vc cv wss wa vc cv cch
      wcel cA vc cv wss vc cv cA chj co vc cv wceq cA cch wcel vc cv cch wcel
      cA vc cv wss vc cv cA chj co vc cv wceq wb mdsymlem1.1 cA vc cv chlejb2
      mpan biimpa ad2ant2lr sseqtrd exp45 anasss vq cv atelch vp cv cat wcel vc
      cv cch wcel vp cv cch wcel vc cv cch wcel wa vp cv cat wcel vp cv cch
      wcel vc cv cch wcel vp cv atelch anim1i ancoms syl2an adantlr vq cv cA
      wss vr cv cB wss wa vq cv cA wss vp cv vq cv vr cv chj co wss vq cv vp cv
      wceq wn vq cv cA wss vr cv cB wss pm3.26 ad2antlr syl7 imp44 sstrd cA vc
      cv wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv
      vp cv wceq wn wa wa vp cv vc cv wss wa vr cv cB wss vq cv cat wcel vr cv
      cat wcel wa vc cv cch wcel vp cv cat wcel wa wa vp cv vq cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv wceq wn wa vr cv cB wss
      cA vc cv wss vp cv vc cv wss vq cv cA wss vr cv cB wss wa vr cv cB wss vp
      cv vq cv vr cv chj co wss vq cv vp cv wceq wn vq cv cA wss vr cv cB wss
      pm3.27 ad2antlr ad2antlr adantl jca vr cv vc cv cB ssin sylib vq cv cat
      wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel wa wa cA vc cv wss
      vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vq cv vp cv
      wceq wn wa wa vr cv vc cv cB cin wss vp cv vc cv cB cin cA chj co wss wi
      vp cv vc cv wss vq cv cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat
      wcel wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa
      vq cv vp cv wceq wn wa vr cv vc cv cB cin wss vp cv vc cv cB cin cA chj
      co wss wi cA vc cv wss vq cv cat wcel vr cv cat wcel wa vc cv cch wcel vp
      cv cat wcel wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss
      wa wa vr cv vc cv cB cin wss vp cv vc cv cB cin cA chj co wss wi vq cv vp
      cv wceq wn vq cv cat wcel vr cv cat wcel wa vc cv cch wcel vp cv cat wcel
      wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa vr cv vc
      cv cB cin wss vp cv vc cv cB cin cA chj co wss wi vq cv cat wcel vr cv
      cat wcel wa vc cv cch wcel vp cv cat wcel wa wa vp cv vq cv vr cv chj co
      wss wa vq cv cA wss vr cv vc cv cB cin wss vp cv vc cv cB cin cA chj co
      wss wi vr cv cB wss vq cv cat wcel vr cv cat wcel wa vc cv cch wcel vp cv
      cat wcel wa wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv vc cv cB
      cin wss vp cv vc cv cB cin cA chj co wss wi vq cv cat wcel vr cv cat wcel
      wa vc cv cch wcel vp cv vq cv vr cv chj co wss vq cv cA wss vr cv vc cv
      cB cin wss vp cv vc cv cB cin cA chj co wss wi wi wi vp cv cat wcel vq cv
      cch wcel vr cv cch wcel wa vc cv cch wcel vp cv vq cv vr cv chj co wss vq
      cv cA wss vr cv vc cv cB cin wss vp cv vc cv cB cin cA chj co wss wi wi
      wi vq cv cat wcel vr cv cat wcel wa vq cv cch wcel vr cv cch wcel wa vc
      cv cch wcel wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv vc cv cB
      cin wss vp cv vc cv cB cin cA chj co wss wi vq cv cch wcel vr cv cch wcel
      wa vc cv cch wcel wa vp cv vq cv vr cv chj co wss vq cv cA wss wa wa vr
      cv vc cv cB cin wss vq cv vr cv chj co vc cv cB cin cA chj co wss vp cv
      vc cv cB cin cA chj co wss vq cv cch wcel vr cv cch wcel wa vc cv cch
      wcel wa vq cv cA wss vr cv vc cv cB cin wss vq cv vr cv chj co vc cv cB
      cin cA chj co wss wi vp cv vq cv vr cv chj co wss vq cv cch wcel vr cv
      cch wcel wa vc cv cch wcel wa vq cv cA wss wa vr cv vc cv cB cin wss vr
      cv vq cv chj co vc cv cB cin vq cv chj co wss vq cv vr cv chj co vc cv cB
      cin cA chj co wss vq cv cch wcel vr cv cch wcel wa vc cv cch wcel wa vr
      cv vc cv cB cin wss vr cv vq cv chj co vc cv cB cin vq cv chj co wss wi
      vq cv cA wss vq cv cch wcel vr cv cch wcel vc cv cch wcel vr cv vc cv cB
      cin wss vr cv vq cv chj co vc cv cB cin vq cv chj co wss wi vr cv cch
      wcel vc cv cch wcel vq cv cch wcel vr cv vc cv cB cin wss vr cv vq cv chj
      co vc cv cB cin vq cv chj co wss wi vr cv cch wcel vc cv cB cin cch wcel
      vq cv cch wcel vr cv vc cv cB cin wss vr cv vq cv chj co vc cv cB cin vq
      cv chj co wss wi vc cv cch wcel vr cv cch wcel vc cv cB cin cch wcel vq
      cv cch wcel w3a vr cv vc cv cB cin wss vr cv vq cv chj co vc cv cB cin vq
      cv chj co wss vr cv vc cv cB cin vq cv chlej1 ex vc cv cch wcel cB cch
      wcel vc cv cB cin cch wcel mdsymlem1.2 vc cv cB chincl mpan2 syl3an2
      3comr 3expa adantr vq cv cch wcel vr cv cch wcel wa vc cv cch wcel wa vq
      cv cA wss wa vr cv vq cv chj co vc cv cB cin vq cv chj co wss vr cv vq cv
      chj co vc cv cB cin cA chj co wss vq cv vr cv chj co vc cv cB cin cA chj
      co wss vr cv vq cv chj co vc cv cB cin vq cv chj co wss vc cv cB cin vq
      cv chj co vc cv cB cin cA chj co wss vr cv vq cv chj co vc cv cB cin cA
      chj co wss vq cv cch wcel vr cv cch wcel wa vc cv cch wcel wa vq cv cA
      wss wa vr cv vq cv chj co vc cv cB cin vq cv chj co vc cv cB cin cA chj
      co sstr2 vq cv cch wcel vc cv cch wcel vq cv cA wss vc cv cB cin vq cv
      chj co vc cv cB cin cA chj co wss vr cv cch wcel vq cv cch wcel vc cv cB
      cin cch wcel vq cv cA wss vc cv cB cin vq cv chj co vc cv cB cin cA chj
      co wss vc cv cch wcel vq cv cch wcel cA cch wcel vc cv cB cin cch wcel vq
      cv cA wss vc cv cB cin vq cv chj co vc cv cB cin cA chj co wss
      mdsymlem1.1 vq cv cA vc cv cB cin chlej2 mp3anl2 vc cv cch wcel cB cch
      wcel vc cv cB cin cch wcel mdsymlem1.2 vc cv cB chincl mpan2 sylanl2
      adantllr syl5com vq cv cch wcel vr cv cch wcel wa vc cv cch wcel wa vq cv
      cA wss wa vq cv vr cv chj co vr cv vq cv chj co vc cv cB cin cA chj co vq
      cv cch wcel vr cv cch wcel wa vq cv vr cv chj co vr cv vq cv chj co wceq
      vc cv cch wcel vq cv cA wss vq cv vr cv chjcom ad2antrr sseq1d sylibrd
      syld adantrl vp cv vq cv vr cv chj co wss vq cv vr cv chj co vc cv cB cin
      cA chj co wss vp cv vc cv cB cin cA chj co wss wi vq cv cch wcel vr cv
      cch wcel wa vc cv cch wcel wa vq cv cA wss vp cv vq cv vr cv chj co vc cv
      cB cin cA chj co sstr2 ad2antrl syld exp32 vq cv cat wcel vq cv cch wcel
      vr cv cat wcel vr cv cch wcel vq cv atelch vr cv atelch anim12i sylan
      adantrr imp31 adantrr anasss adantrr adantrl adantrr mpd exp32 exp4d
      exp32 com34 imp4c com24 $.
      $( [1-Aug-2004] $) $( [2-Jul-2004] $)

    $( Lemma for ~ mdsymi .  This is the converse direction of Lemma 4(i) of
       [Maeda] p. 168, and is based on the proof of Theorem 1(d) to (e) of
       [Maeda] p. 167. $)
    mdsymlem6 $p |- ( A. p e. Atoms ( p C_ ( A vH B ) ->
      E. q e. Atoms E. r e. Atoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) )
                   -> B MH* A ) $=
      vp cv cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vr cat wrex vq cat wrex wi vp cat wral cA vc cv wss vc cv cB cA
      chj co cin vc cv cB cin cA chj co wss wi vc cch wral cB cA cdmd wbr vp cv
      cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss
      wa wa vr cat wrex vq cat wrex wi vp cat wral cA vc cv wss vc cv cB cA chj
      co cin vc cv cB cin cA chj co wss wi vc cch vc cv cch wcel cA vc cv wss
      vp cv cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vr cat wrex vq cat wrex wi vp cat wral vc cv cB cA chj co cin
      vc cv cB cin cA chj co wss vc cv cch wcel cA vc cv wss vp cv cA cB chj co
      wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr cat
      wrex vq cat wrex wi vp cat wral vc cv cB cA chj co cin vc cv cB cin cA
      chj co wss wi vc cv cch wcel cA vc cv wss wa vp cv cA cB chj co wss vp cv
      vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr cat wrex vq cat
      wrex wi vp cat wral vp cv vc cv cB cA chj co cin wss vp cv vc cv cB cin
      cA chj co wss wi vp cat wral vc cv cB cA chj co cin vc cv cB cin cA chj
      co wss vc cv cch wcel cA vc cv wss wa vp cv cA cB chj co wss vp cv vq cv
      vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr cat wrex vq cat wrex
      wi vp cv vc cv cB cA chj co cin wss vp cv vc cv cB cin cA chj co wss wi
      vp cat vc cv cch wcel cA vc cv wss wa vp cv cat wcel wa vp cv cA cB chj
      co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr
      cat wrex vq cat wrex wi vp cv vc cv cB cA chj co cin wss vp cv vc cv cB
      cin cA chj co wss wi vc cv cch wcel cA vc cv wss wa vp cv cat wcel wa vp
      cv cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vr cat wrex vq cat wrex wi wa vp cv vc cv wss vp cv cA cB chj
      co wss wa vp cv vc cv cB cin cA chj co wss vp cv vc cv cB cA chj co cin
      wss vc cv cch wcel cA vc cv wss wa vp cv cat wcel wa vp cv cA cB chj co
      wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr cat
      wrex vq cat wrex wi vp cv vc cv wss vp cv cA cB chj co wss vp cv vc cv cB
      cin cA chj co wss vc cv cch wcel cA vc cv wss wa vp cv cat wcel wa vp cv
      cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss
      wa wa vr cat wrex vq cat wrex wi vp cv cA cB chj co wss vp cv vc cv wss
      vp cv vc cv cB cin cA chj co wss vc cv cch wcel cA vc cv wss wa vp cv cat
      wcel wa vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr
      cat wrex vq cat wrex vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi
      vp cv cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB
      wss wa wa vr cat wrex vq cat wrex vc cv cch wcel cA vc cv wss wa vp cv
      cat wcel wa vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi vp cv vq
      cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vc cv cch wcel cA vc
      cv wss wa vp cv cat wcel wa vp cv vc cv wss vp cv vc cv cB cin cA chj co
      wss wi wi vq vr cat cat vq cv cat wcel vr cv cat wcel wa vq cv vp cv wceq
      vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vc cv cch
      wcel cA vc cv wss wa vp cv cat wcel wa vp cv vc cv wss vp cv vc cv cB cin
      cA chj co wss wi wi wi cA cB cC vr vq vp vc mdsymlem1.1 mdsymlem1.2
      mdsymlem1.3 mdsymlem5 vq cv vp cv wceq vp cv vq cv vr cv chj co wss vq cv
      cA wss vr cv cB wss wa wa vc cv cch wcel cA vc cv wss wa vp cv cat wcel
      wa vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi vp cv vq cv vr cv
      chj co wss vq cv cA wss vr cv cB wss wa wa vc cv cch wcel cA vc cv wss wa
      vp cv cat wcel wa wa vq cv vp cv wceq vp cv vc cv wss vp cv vc cv cB cin
      cA chj co wss wi vq cv cA wss vr cv cB wss wa vc cv cch wcel cA vc cv wss
      wa vp cv cat wcel wa vq cv vp cv wceq vp cv vc cv wss vp cv vc cv cB cin
      cA chj co wss wi wi vp cv vq cv vr cv chj co wss vq cv cA wss vc cv cch
      wcel cA vc cv wss wa vq cv vp cv wceq vp cv vc cv wss vp cv vc cv cB cin
      cA chj co wss wi wi vr cv cB wss vp cv cat wcel vq cv cA wss vc cv cch
      wcel vq cv vp cv wceq vp cv vc cv wss vp cv vc cv cB cin cA chj co wss wi
      wi cA vc cv wss vp cv vc cv wss vq cv vp cv wceq vq cv cA wss vc cv cch
      wcel wa vp cv vc cv cB cin cA chj co wss vq cv vp cv wceq vq cv cA wss vc
      cv cch wcel wa vp cv vc cv cB cin cA chj co wss wi wi vp cv vc cv wss vq
      cv vp cv wceq vq cv cA wss vc cv cch wcel vp cv vc cv cB cin cA chj co
      wss vq cv vp cv wceq vq cv cA wss vp cv cA wss vc cv cch wcel vp cv vc cv
      cB cin cA chj co wss wi vq cv vp cv cA sseq1 vp cv cA wss cA vc cv cB cin
      cA chj co wss vp cv vc cv cB cin cA chj co wss vc cv cch wcel vp cv cA vc
      cv cB cin cA chj co sstr2 vc cv cch wcel vc cv cB cin cch wcel cA vc cv
      cB cin cA chj co wss vc cv cch wcel cB cch wcel vc cv cB cin cch wcel
      mdsymlem1.2 vc cv cB chincl mpan2 cA cch wcel vc cv cB cin cch wcel cA vc
      cv cB cin cA chj co wss mdsymlem1.1 cA vc cv cB cin chub2 mpan syl syl5
      syl6bi imp3a a1i com13 adantrr ad2ant2r adantll com12 exp3a pm2.61d2
      r19.23aivv com12 imim2d com34 imp4b vp cv vc cv wss vp cv cA cB chj co
      wss wa vp cv vc cv wss vp cv cB cA chj co wss wa vp cv vc cv cB cA chj co
      cin wss vp cv cA cB chj co wss vp cv cB cA chj co wss vp cv vc cv wss cA
      cB chj co cB cA chj co vp cv cA cB mdsymlem1.1 mdsymlem1.2 chjcomi sseq2i
      anbi2i vp cv vc cv cB cA chj co ssin bitri syl5ibr ex r19.20dva vc cv cch
      wcel vc cv cB cA chj co cin vc cv cB cin cA chj co wss vp cv vc cv cB cA
      chj co cin wss vp cv vc cv cB cin cA chj co wss wi vp cat wral wb cA vc
      cv wss vc cv cB cA chj co cin cch wcel vc cv cB cin cA chj co cch wcel vc
      cv cB cA chj co cin vc cv cB cin cA chj co wss vp cv vc cv cB cA chj co
      cin wss vp cv vc cv cB cin cA chj co wss wi vp cat wral wb vc cv cch wcel
      vp vc cv cB cA chj co cin vc cv cB cin cA chj co chrelat3 vc cv cch wcel
      cB cA chj co cch wcel vc cv cB cA chj co cin cch wcel cB cA mdsymlem1.2
      mdsymlem1.1 chjcli vc cv cB cA chj co chincl mpan2 vc cv cch wcel vc cv
      cB cin cch wcel vc cv cB cin cA chj co cch wcel vc cv cch wcel cB cch
      wcel vc cv cB cin cch wcel mdsymlem1.2 vc cv cB chincl mpan2 vc cv cB cin
      cch wcel cA cch wcel vc cv cB cin cA chj co cch wcel mdsymlem1.1 vc cv cB
      cin cA chjcl mpan2 syl sylanc adantr sylibrd ex com3r r19.21aiv cB cch
      wcel cA cch wcel cB cA cdmd wbr cA vc cv wss vc cv cB cA chj co cin vc cv
      cB cin cA chj co wss wi vc cch wral wb mdsymlem1.2 mdsymlem1.1 vc cB cA
      dmdbr2 mp2an sylibr $.
      $( [30-Jul-2007] $) $( [2-Jul-2004] $)

    $( Lemma for ~ mdsymi .  Lemma 4(i) of [Maeda] p. 168.  Note that Maeda's
       1965 definition of dual modular pair has reversed arguments compared to
       the later (1970) definition given in Remark 29.6 of [MaedaMaeda] p. 130,
       which is the one that we use. $)
    mdsymlem7 $p |- ( ( A =/= 0H /\ B =/= 0H ) ->
                    ( B MH* A <->
   A. p e. Atoms ( p C_ ( A vH B ) -> E. q e. Atoms E. r e. Atoms
            ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) ) ) $=
      cA c0h wne cB c0h wne wa cB cA cdmd wbr vp cv cA cB chj co wss vp cv vq
      cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr cat wrex vq cat
      wrex wi vp cat wral cA c0h wne cB c0h wne wa cB cA cdmd wbr vp cv cA cB
      chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa wa
      vr cat wrex vq cat wrex wi vp cat vp cv cat wcel cB cA cdmd wbr cA c0h
      wne cB c0h wne wa vp cv cA cB chj co wss vp cv vq cv vr cv chj co wss vq
      cv cA wss vr cv cB wss wa wa vr cat wrex vq cat wrex wi vp cv cat wcel cB
      cA cdmd wbr cA c0h wne cB c0h wne wa vp cv cA cB chj co wss vp cv vq cv
      vr cv chj co wss vq cv cA wss vr cv cB wss wa wa vr cat wrex vq cat wrex
      cA cB cC vr vq vp mdsymlem1.1 mdsymlem1.2 mdsymlem1.3 mdsymlem4 exp4d
      com13 r19.21adv cA cB cC vr vq vp mdsymlem1.1 mdsymlem1.2 mdsymlem1.3
      mdsymlem6 impbid1 $.
      $( [30-Jul-2007] $) $( [3-Jul-2004] $)

    $( Lemma for ~ mdsymi .  Lemma 4(ii) of [Maeda] p. 168. $)
    mdsymlem8 $p |- ( ( A =/= 0H /\ B =/= 0H ) -> ( B MH* A <-> A MH* B ) ) $=
      cA c0h wne cB c0h wne wa vp cv cA cB chj co wss vp cv vq cv vr cv chj co
      wss vq cv cA wss vr cv cB wss wa wa vr cat wrex vq cat wrex wi vp cat
      wral vp cv cB cA chj co wss vp cv vr cv vq cv chj co wss vr cv cB wss vq
      cv cA wss wa wa vq cat wrex vr cat wrex wi vp cat wral cB cA cdmd wbr cA
      cB cdmd wbr vp cv cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA
      wss vr cv cB wss wa wa vr cat wrex vq cat wrex wi vp cat wral vp cv cB cA
      chj co wss vp cv vr cv vq cv chj co wss vr cv cB wss vq cv cA wss wa wa
      vq cat wrex vr cat wrex wi vp cat wral wb cA c0h wne cB c0h wne wa vp cv
      cA cB chj co wss vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss
      wa wa vr cat wrex vq cat wrex wi vp cv cB cA chj co wss vp cv vr cv vq cv
      chj co wss vr cv cB wss vq cv cA wss wa wa vq cat wrex vr cat wrex wi vp
      cat vp cv cA cB chj co wss vp cv cB cA chj co wss vp cv vq cv vr cv chj
      co wss vq cv cA wss vr cv cB wss wa wa vr cat wrex vq cat wrex vp cv vr
      cv vq cv chj co wss vr cv cB wss vq cv cA wss wa wa vq cat wrex vr cat
      wrex cA cB chj co cB cA chj co vp cv cA cB mdsymlem1.1 mdsymlem1.2
      chjcomi sseq2i vp cv vq cv vr cv chj co wss vq cv cA wss vr cv cB wss wa
      wa vr cat wrex vq cat wrex vp cv vr cv vq cv chj co wss vr cv cB wss vq
      cv cA wss wa wa vr cat wrex vq cat wrex vp cv vr cv vq cv chj co wss vr
      cv cB wss vq cv cA wss wa wa vq cat wrex vr cat wrex vp cv vq cv vr cv
      chj co wss vq cv cA wss vr cv cB wss wa wa vp cv vr cv vq cv chj co wss
      vr cv cB wss vq cv cA wss wa wa vq vr cat cat vq cv cat wcel vr cv cat
      wcel wa vp cv vq cv vr cv chj co wss vp cv vr cv vq cv chj co wss vq cv
      cA wss vr cv cB wss wa vr cv cB wss vq cv cA wss wa vq cv cat wcel vr cv
      cat wcel wa vq cv vr cv chj co vr cv vq cv chj co vp cv vq cv cch wcel vr
      cv cch wcel vq cv vr cv chj co vr cv vq cv chj co wceq vq cv cat wcel vr
      cv cat wcel vq cv vr cv chjcom vq cv atelch vr cv atelch syl2an sseq2d vq
      cv cA wss vr cv cB wss wa vr cv cB wss vq cv cA wss wa wb vq cv cat wcel
      vr cv cat wcel wa vq cv cA wss vr cv cB wss ancom a1i anbi12d 2rexbiia vp
      cv vr cv vq cv chj co wss vr cv cB wss vq cv cA wss wa wa vq vr cat cat
      rexcom bitri imbi12i ralbii a1i cA cB cC vr vq vp mdsymlem1.1 mdsymlem1.2
      mdsymlem1.3 mdsymlem7 cB c0h wne cA c0h wne cA cB cdmd wbr vp cv cB cA
      chj co wss vp cv vr cv vq cv chj co wss vr cv cB wss vq cv cA wss wa wa
      vq cat wrex vr cat wrex wi vp cat wral wb cB cA cB vp cv chj co vq vr vp
      mdsymlem1.2 mdsymlem1.1 cB vp cv chj co eqid mdsymlem7 ancoms 3bitr4d $.
      $( [30-Jul-2007] $) $( [3-Jul-2004] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.
    mdsym.1 $e |- A e. CH $.
    mdsym.2 $e |- B e. CH $.
    $( M-symmetry of the Hilbert lattice.  Lemma 5 of [Maeda] p. 168. $)
    mdsymi $p |- ( A MH B <-> B MH A ) $=
      cB cort cfv c0h wceq cA cort cfv c0h wceq cA cB cmd wbr cB cA cmd wbr wb
      cB cort cfv c0h wceq cA cB wss cA cB cmd wbr cB cA cmd wbr wa cA cB cmd
      wbr cB cA cmd wbr wb cB cort cfv c0h wceq cA cB wss cA chil wss cA
      mdsym.1 chssii cB cort cfv c0h wceq cB chil cA cB cort cfv c0h wceq cB
      cort cfv cort cfv c0h cort cfv cB chil cB cort cfv c0h cort fveq2 cB
      mdsym.2 pjococi choc0 3eqtr3g sseq2d mpbiri cA cB wss cA cB cmd wbr cB cA
      cmd wbr cA cch wcel cB cch wcel cA cB wss cA cB cmd wbr mdsym.1 mdsym.2
      cA cB ssmd1 mp3an12 cA cch wcel cB cch wcel cA cB wss cB cA cmd wbr
      mdsym.1 mdsym.2 cA cB ssmd2 mp3an12 jca cA cB cmd wbr cB cA cmd wbr pm5.1
      3syl cA cort cfv c0h wceq cB cA wss cA cB cmd wbr cB cA cmd wbr wa cA cB
      cmd wbr cB cA cmd wbr wb cA cort cfv c0h wceq cB cA wss cB chil wss cB
      mdsym.2 chssii cA cort cfv c0h wceq cA chil cB cA cort cfv c0h wceq cA
      cort cfv cort cfv c0h cort cfv cA chil cA cort cfv c0h cort fveq2 cA
      mdsym.1 pjococi choc0 3eqtr3g sseq2d mpbiri cB cA wss cA cB cmd wbr cB cA
      cmd wbr cB cch wcel cA cch wcel cB cA wss cA cB cmd wbr mdsym.2 mdsym.1
      cB cA ssmd2 mp3an12 cB cch wcel cA cch wcel cB cA wss cB cA cmd wbr
      mdsym.2 mdsym.1 cB cA ssmd1 mp3an12 jca cA cB cmd wbr cB cA cmd wbr pm5.1
      3syl cB cort cfv c0h wceq cA cort cfv c0h wceq wo wn cB cort cfv c0h wne
      cA cort cfv c0h wne wa cA cB cmd wbr cB cA cmd wbr wb cB cort cfv c0h cA
      cort cfv c0h neanior cB cort cfv c0h wne cA cort cfv c0h wne wa cA cort
      cfv cB cort cfv cdmd wbr cB cort cfv cA cort cfv cdmd wbr cA cB cmd wbr
      cB cA cmd wbr cB cort cfv cA cort cfv cB cort cfv vx cv chj co vx cB
      mdsym.2 choccli cA mdsym.1 choccli cB cort cfv vx cv chj co eqid
      mdsymlem8 cA cch wcel cB cch wcel cA cB cmd wbr cA cort cfv cB cort cfv
      cdmd wbr wb mdsym.1 mdsym.2 cA cB mddmd mp2an cB cch wcel cA cch wcel cB
      cA cmd wbr cB cort cfv cA cort cfv cdmd wbr wb mdsym.2 mdsym.1 cB cA
      mddmd mp2an 3bitr4g sylbir ecase3 $.
      $( [2-Aug-2004] $) $( [3-Jul-2004] $)
  $}

  $( M-symmetry of the Hilbert lattice.  Lemma 5 of [Maeda] p. 168. $)
  mdsym $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <-> B MH A ) ) $=
    cA cch wcel cB cch wcel cA cB cmd wbr cB cA cmd wbr wb cA cch wcel cA chil
    cif cB cmd wbr cB cA cch wcel cA chil cif cmd wbr wb cA cch wcel cA chil
    cif cB cch wcel cB chil cif cmd wbr cB cch wcel cB chil cif cA cch wcel cA
    chil cif cmd wbr wb cA cB chil chil cA cA cch wcel cA chil cif wceq cA cB
    cmd wbr cA cch wcel cA chil cif cB cmd wbr cB cA cmd wbr cB cA cch wcel cA
    chil cif cmd wbr cA cA cch wcel cA chil cif cB cmd breq1 cA cA cch wcel cA
    chil cif cB cmd breq2 bibi12d cB cB cch wcel cB chil cif wceq cA cch wcel
    cA chil cif cB cmd wbr cA cch wcel cA chil cif cB cch wcel cB chil cif cmd
    wbr cB cA cch wcel cA chil cif cmd wbr cB cch wcel cB chil cif cA cch wcel
    cA chil cif cmd wbr cB cB cch wcel cB chil cif cA cch wcel cA chil cif cmd
    breq2 cB cB cch wcel cB chil cif cA cch wcel cA chil cif cmd breq1 bibi12d
    cA cch wcel cA chil cif cB cch wcel cB chil cif cA chil cch helch elimel cB
    chil cch helch elimel mdsymi dedth2h $.
    $( [14-Jun-2006] $) $( [6-Jul-2004] $)

  $( Dual M-symmetry of the Hilbert lattice. $)
  dmdsym $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <-> B MH* A ) ) $=
    cA cch wcel cB cch wcel wa cA cort cfv cB cort cfv cmd wbr cB cort cfv cA
    cort cfv cmd wbr cA cB cdmd wbr cB cA cdmd wbr cA cort cfv cch wcel cB cort
    cfv cch wcel cA cort cfv cB cort cfv cmd wbr cB cort cfv cA cort cfv cmd
    wbr wb cA cch wcel cB cch wcel cA cort cfv cB cort cfv mdsym cA choccl cB
    choccl syl2an cA cB dmdmd cB cch wcel cA cch wcel cB cA cdmd wbr cB cort
    cfv cA cort cfv cmd wbr wb cB cA dmdmd ancoms 3bitr4d $.
    $( [12-Aug-2007] $) $( [25-Jul-2007] $)

  $( Two Hilbert lattice elements have the dual modular pair property if the
     second is an atom. $)
  atdmd2 $p |- ( ( A e. CH /\ B e. Atoms ) -> A MH* B ) $=
    cA cch wcel cB cat wcel wa cA cB cdmd wbr cB cA cdmd wbr cB cat wcel cA cch
    wcel cB cA cdmd wbr cB cA atdmd ancoms cA cch wcel cB cch wcel cA cB cdmd
    wbr cB cA cdmd wbr wb cB cat wcel cA cB dmdsym cB atelch sylan2 mpbird $.
    $( [12-Jul-2008] $) $( [6-Jul-2004] $)

  ${
    $d x y z w A $.  $d x y z w B $.  $d y z w C $.
    sumdmdi.1 $e |- A e. CH $.
    sumdmdi.2 $e |- B e. CH $.
    $( If the subspace sum of two Hilbert lattice elements is closed, then the
       elements are a dual modular pair.  Remark in [MaedaMaeda] p. 139. $)
    sumdmdii $p |- ( ( A +H B ) = ( A vH B ) -> A MH* B ) $=
      cA cB cph co cA cB chj co wceq cB vx cv wss vx cv cA cB chj co cin vx cv
      cA cin cB chj co wss wi vx cch wral cA cB cdmd wbr cA cB cph co cA cB chj
      co wceq cB vx cv wss vx cv cA cB chj co cin vx cv cA cin cB chj co wss wi
      vx cch cA cB cph co cA cB chj co wceq vx cv cch wcel cB vx cv wss vx cv
      cA cB chj co cin vx cv cA cin cB chj co wss cA cB cph co cA cB chj co
      wceq vx cv cch wcel cB vx cv wss wa wa vx cv cA cB chj co cin vx cv cA
      cin cB cph co vx cv cA cin cB chj co cA cB cph co cA cB chj co wceq vx cv
      cch wcel cB vx cv wss wa wa vx cv cA cB chj co cin vx cv cA cB cph co cin
      vx cv cA cin cB cph co cA cB cph co cA cB chj co wceq vx cv cA cB cph co
      cin vx cv cA cB chj co cin wceq vx cv cch wcel cB vx cv wss wa cA cB cph
      co cA cB chj co vx cv ineq2 adantr vx cv cch wcel cB vx cv wss wa vx cv
      cA cB cph co cin vx cv cA cin cB cph co wss cA cB cph co cA cB chj co
      wceq vx cv cch wcel cB vx cv wss wa vy vx cv cA cB cph co cin vx cv cA
      cin cB cph co vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel vy cv cA cB
      cph co wcel wa vy cv vx cv cA cin cB cph co wcel vy cv vx cv cA cB cph co
      cin wcel vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel vy cv cA cB cph
      co wcel vy cv vx cv cA cin cB cph co wcel vx cv cch wcel cB vx cv wss wa
      vy cv vx cv wcel wa vy cv vz cv vw cv cva co wceq vw cB wrex vz cA wrex
      vy cv vx cv cA cin cB cph co wcel vy cv cA cB cph co wcel vx cv cch wcel
      cB vx cv wss wa vy cv vx cv wcel wa vy cv vz cv vw cv cva co wceq vw cB
      wrex vz cA wrex vy cv vz cv vw cv cva co wceq vw cB wrex vz vx cv cA cin
      wrex vy cv vx cv cA cin cB cph co wcel vx cv cch wcel cB vx cv wss wa vy
      cv vx cv wcel wa vy cv vz cv vw cv cva co wceq vw cB wrex vz cA wrex vz
      cv vx cv wcel vy cv vz cv vw cv cva co wceq vw cB wrex wa vz cA wrex vy
      cv vz cv vw cv cva co wceq vw cB wrex vz vx cv cA cin wrex vx cv cch wcel
      cB vx cv wss wa vy cv vx cv wcel wa vy cv vz cv vw cv cva co wceq vw cB
      wrex vz cv vx cv wcel vy cv vz cv vw cv cva co wceq vw cB wrex wa vz cA
      vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa vz cv cA wcel wa vy cv
      vz cv vw cv cva co wceq vw cB wrex vz cv vx cv wcel vy cv vz cv vw cv cva
      co wceq wa vw cB wrex vz cv vx cv wcel vy cv vz cv vw cv cva co wceq vw
      cB wrex wa vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa vz cv cA
      wcel wa vy cv vz cv vw cv cva co wceq vz cv vx cv wcel vy cv vz cv vw cv
      cva co wceq wa vw cB vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa
      vz cv cA wcel wa vw cv cB wcel vy cv vz cv vw cv cva co wceq vz cv vx cv
      wcel vy cv vz cv vw cv cva co wceq wa vx cv cch wcel cB vx cv wss wa vy
      cv vx cv wcel wa vz cv cA wcel wa vw cv cB wcel wa vy cv vz cv vw cv cva
      co wceq wa vz cv vx cv wcel vy cv vz cv vw cv cva co wceq vx cv cch wcel
      cB vx cv wss wa vy cv vx cv wcel wa vz cv cA wcel wa vw cv cB wcel wa vy
      cv vz cv vw cv cva co wceq wa vy cv vw cv cmv co vx cv wcel vz cv vx cv
      wcel vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa vz cv cA wcel wa
      vw cv cB wcel wa vy cv vw cv cmv co vx cv wcel vy cv vz cv vw cv cva co
      wceq vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa vw cv cB wcel vy
      cv vw cv cmv co vx cv wcel vz cv cA wcel vx cv cch wcel cB vx cv wss vy
      cv vx cv wcel vw cv cB wcel vy cv vw cv cmv co vx cv wcel vx cv cch wcel
      vy cv vx cv wcel cB vx cv wss vw cv cB wcel vy cv vw cv cmv co vx cv wcel
      wi vx cv cch wcel vy cv vx cv wcel cB vx cv wss vw cv cB wcel vy cv vw cv
      cmv co vx cv wcel vx cv cch wcel vy cv vx cv wcel vw cv vx cv wcel vy cv
      vw cv cmv co vx cv wcel cB vx cv wss vw cv cB wcel wa vx cv cch wcel vx
      cv csh wcel vy cv vx cv wcel vw cv vx cv wcel vy cv vw cv cmv co vx cv
      wcel wi wi vx cv chsh vx cv csh wcel vy cv vx cv wcel vw cv vx cv wcel vy
      cv vw cv cmv co vx cv wcel vy cv vw cv vx cv shsubclOLD exp3a syl cB vx
      cv vw cv ssel2 syl7 exp4a com23 imp41 adantlr adantr vx cv cch wcel cB vx
      cv wss wa vy cv vx cv wcel wa vz cv cA wcel wa vw cv cB wcel wa vy cv vz
      cv vw cv cva co wceq vy cv vw cv cmv co vx cv wcel vz cv vx cv wcel wb vx
      cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa vz cv cA wcel wa vw cv cB
      wcel wa vy cv vz cv vw cv cva co wceq vy cv vw cv cmv co vz cv wceq vy cv
      vw cv cmv co vx cv wcel vz cv vx cv wcel wb vx cv cch wcel cB vx cv wss
      wa vy cv vx cv wcel wa vz cv cA wcel vw cv cB wcel vy cv vw cv cmv co vz
      cv wceq vy cv vz cv vw cv cva co wceq wb vy cv chil wcel vz cv chil wcel
      vw cv chil wcel vy cv vw cv cmv co vz cv wceq vy cv vz cv vw cv cva co
      wceq wb vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa vz cv cA wcel
      vw cv cB wcel vy cv chil wcel vw cv chil wcel vz cv chil wcel vy cv vw cv
      cmv co vz cv wceq vy cv vz cv vw cv cva co wceq wb vy cv chil wcel vw cv
      chil wcel vz cv chil wcel w3a vy cv vw cv cmv co vz cv wceq vw cv vz cv
      cva co vy cv wceq vy cv vz cv vw cv cva co wceq vy cv vw cv vz cv
      hvsubadd vw cv chil wcel vz cv chil wcel vw cv vz cv cva co vy cv wceq vy
      cv vz cv vw cv cva co wceq wb vy cv chil wcel vw cv chil wcel vz cv chil
      wcel wa vw cv vz cv cva co vy cv wceq vz cv vw cv cva co vy cv wceq vy cv
      vz cv vw cv cva co wceq vw cv chil wcel vz cv chil wcel wa vw cv vz cv
      cva co vz cv vw cv cva co vy cv vw cv vz cv ax-hvcom eqeq1d vz cv vw cv
      cva co vy cv eqcom syl6bb 3adant1 bitrd 3com23 vx cv cch wcel vy cv vx cv
      wcel vy cv chil wcel cB vx cv wss vy cv vx cv chel adantlr vz cv cA
      sumdmdi.1 cheli vw cv cB sumdmdi.2 cheli syl3an 3expa vy cv vw cv cmv co
      vz cv vx cv eleq1 syl6bir imp mpbid vx cv cch wcel cB vx cv wss wa vy cv
      vx cv wcel wa vz cv cA wcel wa vw cv cB wcel wa vy cv vz cv vw cv cva co
      wceq pm3.27 jca exp31 r19.22dv vz cv vx cv wcel vy cv vz cv vw cv cva co
      wceq vw cB r19.42v syl6ib r19.22dva vy cv vz cv vw cv cva co wceq vw cB
      wrex vz cv vx cv wcel vy cv vz cv vw cv cva co wceq vw cB wrex wa vz vx
      cv cA cin cA vz cv vx cv cA cin wcel vy cv vz cv vw cv cva co wceq vw cB
      wrex wa vz cv cA wcel vz cv vx cv wcel wa vy cv vz cv vw cv cva co wceq
      vw cB wrex wa vz cv cA wcel vz cv vx cv wcel vy cv vz cv vw cv cva co
      wceq vw cB wrex wa wa vz cv vx cv cA cin wcel vz cv cA wcel vz cv vx cv
      wcel wa vy cv vz cv vw cv cva co wceq vw cB wrex vz cv vx cv cA cin wcel
      vz cv vx cv wcel vz cv cA wcel wa vz cv cA wcel vz cv vx cv wcel wa vz cv
      vx cv cA elin vz cv vx cv wcel vz cv cA wcel ancom bitri anbi1i vz cv cA
      wcel vz cv vx cv wcel vy cv vz cv vw cv cva co wceq vw cB wrex anass
      bitri rexbii2 syl6ibr vx cv cch wcel cB vx cv wss wa vy cv vx cv wcel wa
      vx cv cA cin csh wcel vy cv vx cv cA cin cB cph co wcel vy cv vz cv vw cv
      cva co wceq vw cB wrex vz vx cv cA cin wrex wb vx cv cch wcel vx cv cA
      cin csh wcel cB vx cv wss vy cv vx cv wcel vx cv cch wcel vx cv csh wcel
      vx cv cA cin csh wcel vx cv chsh vx cv csh wcel cA csh wcel vx cv cA cin
      csh wcel cA sumdmdi.1 chshii vx cv cA shincl mpan2 syl ad2antrr vx cv cA
      cin csh wcel cB csh wcel vy cv vx cv cA cin cB cph co wcel vy cv vz cv vw
      cv cva co wceq vw cB wrex vz vx cv cA cin wrex wb cB sumdmdi.2 chshii vz
      vw vx cv cA cin cB vy cv shsel mpan2 syl sylibrd vz vw cA cB vy cv
      sumdmdi.1 sumdmdi.2 chseli syl5ib expimpd vy cv vx cv cA cB cph co elin
      syl5ib ssrdv adantl eqsstr3d vx cv cch wcel vx cv cA cin cB cph co vx cv
      cA cin cB chj co wss cA cB cph co cA cB chj co wceq cB vx cv wss vx cv
      cch wcel vx cv cA cin cch wcel vx cv cA cin cB cph co vx cv cA cin cB chj
      co wss vx cv cch wcel cA cch wcel vx cv cA cin cch wcel sumdmdi.1 vx cv
      cA chincl mpan2 vx cv cA cin cch wcel cB cch wcel vx cv cA cin cB cph co
      vx cv cA cin cB chj co wss sumdmdi.2 vx cv cA cin cB chslej mpan2 syl
      ad2antrl sstrd exp32 r19.21aiv cA cch wcel cB cch wcel cA cB cdmd wbr cB
      vx cv wss vx cv cA cB chj co cin vx cv cA cin cB chj co wss wi vx cch
      wral wb sumdmdi.1 sumdmdi.2 vx cA cB dmdbr2 mp2an sylibr $.
      $( [25-Jul-2007] $) $( [12-Jul-2004] $)

    $( Commuting subspaces form a modular pair. $)
    cmmdi $p |- ( A C_H B -> A MH B ) $=
      cA cB ccm wbr cA cort cfv cB cort cfv cdmd wbr cA cB cmd wbr cA cB ccm
      wbr cA cort cfv cB cort cfv cph co cA cort cfv cB cort cfv chj co wceq cA
      cort cfv cB cort cfv cdmd wbr cA cB ccm wbr cA cort cfv cB cort cfv ccm
      wbr cA cort cfv cB cort cfv cph co cA cort cfv cB cort cfv chj co wceq cA
      cB sumdmdi.1 sumdmdi.2 cmcm4i cA cort cfv cB cort cfv cA sumdmdi.1
      choccli cB sumdmdi.2 choccli osumcor2i sylbi cA cort cfv cB cort cfv cA
      sumdmdi.1 choccli cB sumdmdi.2 choccli sumdmdii syl cA cch wcel cB cch
      wcel cA cB cmd wbr cA cort cfv cB cort cfv cdmd wbr wb sumdmdi.1
      sumdmdi.2 cA cB mddmd mp2an sylibr $.
      $( [13-Aug-2005] $) $( [16-Jan-2005] $)

    $( Commuting subspaces form a dual modular pair. $)
    cmdmdi $p |- ( A C_H B -> A MH* B ) $=
      cA cort cfv cB cort cfv ccm wbr cA cort cfv cB cort cfv cmd wbr cA cB ccm
      wbr cA cB cdmd wbr cA cort cfv cB cort cfv cA sumdmdi.1 choccli cB
      sumdmdi.2 choccli cmmdi cA cB sumdmdi.1 sumdmdi.2 cmcm4i cA cch wcel cB
      cch wcel cA cB cdmd wbr cA cort cfv cB cort cfv cmd wbr wb sumdmdi.1
      sumdmdi.2 cA cB dmdmd mp2an 3imtr4i $.
      $( [24-May-2006] $) $( [25-Apr-2006] $)

    $( Lemma for ~ sumdmdi .  The span of vector ` C ` not in the subspace sum
       is "trimmed off." $)
    sumdmdlem $p |- ( ( C e. ~H /\ -. C e. ( A +H B ) ) ->
                    ( ( B +H ( span ` { C } ) ) i^i A ) = ( B i^i A ) ) $=
      cC chil wcel cC cA cB cph co wcel wn wa cB cC csn cspn cfv cph co cA cin
      cB cA cin cC chil wcel cC cA cB cph co wcel wn wa vy cB cC csn cspn cfv
      cph co cA cin cB cA cin cC chil wcel cC cA cB cph co wcel wn wa vy cv cB
      cC csn cspn cfv cph co wcel vy cv cA wcel wa vy cv cB cA cin wcel vy cv
      cB cC csn cspn cfv cph co cA cin wcel cC chil wcel cC cA cB cph co wcel
      wn vy cv cB cC csn cspn cfv cph co wcel vy cv cA wcel vy cv cB cA cin
      wcel cC chil wcel vy cv cB cC csn cspn cfv cph co wcel cC cA cB cph co
      wcel wn vy cv cA wcel vy cv cB cA cin wcel wi cC chil wcel vy cv cB cC
      csn cspn cfv cph co wcel vy cv vz cv vw cv cva co wceq vw cC csn cspn cfv
      wrex vz cB wrex cC cA cB cph co wcel wn vy cv cA wcel vy cv cB cA cin
      wcel wi wi cC chil wcel cC csn cspn cfv csh wcel vy cv cB cC csn cspn cfv
      cph co wcel vy cv vz cv vw cv cva co wceq vw cC csn cspn cfv wrex vz cB
      wrex wb cC spansnsh cB csh wcel cC csn cspn cfv csh wcel vy cv cB cC csn
      cspn cfv cph co wcel vy cv vz cv vw cv cva co wceq vw cC csn cspn cfv
      wrex vz cB wrex wb cB sumdmdi.2 chshii vz vw cB cC csn cspn cfv vy cv
      shsel mpan syl cC chil wcel vy cv vz cv vw cv cva co wceq cC cA cB cph co
      wcel wn vy cv cA wcel vy cv cB cA cin wcel wi wi vz vw cB cC csn cspn cfv
      cC chil wcel vz cv cB wcel vw cv cC csn cspn cfv wcel wa vy cv vz cv vw
      cv cva co wceq cC cA cB cph co wcel wn vy cv cA wcel vy cv cB cA cin wcel
      wi wi vy cv cA wcel cC chil wcel vz cv cB wcel vw cv cC csn cspn cfv wcel
      wa vy cv vz cv vw cv cva co wceq wa cC cA cB cph co wcel wn vy cv cB cA
      cin wcel vy cv cA wcel vz cv cB wcel vw cv cC csn cspn cfv wcel wa vy cv
      vz cv vw cv cva co wceq wa cC chil wcel cC cA cB cph co wcel wn vy cv cB
      cA cin wcel wi vy cv cA wcel vz cv cB wcel vw cv cC csn cspn cfv wcel wa
      vy cv vz cv vw cv cva co wceq wa cC chil wcel cC cA cB cph co wcel wn vy
      cv cB cA cin wcel vy cv cA wcel vz cv cB wcel vw cv cC csn cspn cfv wcel
      vy cv vz cv vw cv cva co wceq cC chil wcel cC cA cB cph co wcel wn wa vy
      cv cB cA cin wcel wi vy cv vz cv vw cv cva co wceq vy cv cA wcel vz cv cB
      wcel vw cv cC csn cspn cfv wcel cC chil wcel cC cA cB cph co wcel wn wa
      vy cv cB cA cin wcel wi vy cv vz cv vw cv cva co wceq vy cv cA wcel vz cv
      cB wcel vw cv cC csn cspn cfv wcel cC chil wcel cC cA cB cph co wcel wn
      wa vy cv cB cA cin wcel wi wi vy cv vz cv vw cv cva co wceq vy cv cA wcel
      vz cv cB wcel wa wa cC chil wcel cC cA cB cph co wcel wn wa vw cv cC csn
      cspn cfv wcel vy cv cB cA cin wcel vy cv vz cv vw cv cva co wceq vy cv cA
      wcel vz cv cB wcel wa wa cC chil wcel cC cA cB cph co wcel wn wa vw cv cC
      csn cspn cfv wcel vy cv cB cA cin wcel wi vy cv vz cv vw cv cva co wceq
      vy cv cA wcel vz cv cB wcel wa wa cC chil wcel cC cA cB cph co wcel wn wa
      wa vw cv cC csn cspn cfv wcel vw cv c0v wceq vy cv cB cA cin wcel vy cv
      vz cv vw cv cva co wceq vy cv cA wcel vz cv cB wcel wa wa cC chil wcel cC
      cA cB cph co wcel wn wa wa vw cv cC csn cspn cfv wcel vw cv cA cB cph co
      wcel vw cv c0v wceq vy cv vz cv vw cv cva co wceq vy cv cA wcel vz cv cB
      wcel wa wa cC chil wcel vw cv cC csn cspn cfv wcel vw cv cA cB cph co
      wcel wi cC cA cB cph co wcel wn vy cv vz cv vw cv cva co wceq vy cv cA
      wcel vz cv cB wcel wa cC chil wcel vw cv cC csn cspn cfv wcel vw cv cA cB
      cph co wcel wi vy cv cA wcel vz cv cB wcel wa cC chil wcel vw cv cC csn
      cspn cfv wcel vy cv vz cv vw cv cva co wceq vw cv cA cB cph co wcel vy cv
      cA wcel vz cv cB wcel wa cC chil wcel vw cv cC csn cspn cfv wcel vy cv vz
      cv vw cv cva co wceq vw cv cA cB cph co wcel wi vy cv cA wcel vz cv cB
      wcel wa cC chil wcel vw cv cC csn cspn cfv wcel wa wa vy cv vz cv vw cv
      cva co wceq vy cv vz cv cmv co vw cv wceq vw cv cA cB cph co wcel vy cv
      cA wcel vz cv cB wcel cC chil wcel vw cv cC csn cspn cfv wcel wa vy cv vz
      cv cmv co vw cv wceq vy cv vz cv vw cv cva co wceq wb vy cv chil wcel vz
      cv chil wcel vw cv chil wcel vy cv vz cv cmv co vw cv wceq vy cv vz cv vw
      cv cva co wceq wb vy cv cA wcel vz cv cB wcel cC chil wcel vw cv cC csn
      cspn cfv wcel wa vy cv chil wcel vz cv chil wcel vw cv chil wcel w3a vy
      cv vz cv cmv co vw cv wceq vz cv vw cv cva co vy cv wceq vy cv vz cv vw
      cv cva co wceq vy cv vz cv vw cv hvsubadd vz cv vw cv cva co vy cv eqcom
      syl6bb vy cv cA sumdmdi.1 cheli vz cv cB sumdmdi.2 cheli cC vw cv
      elspansncl syl3an 3expa vy cv cA wcel vz cv cB wcel wa vy cv vz cv cmv co
      vw cv wceq vw cv cA cB cph co wcel wi cC chil wcel vw cv cC csn cspn cfv
      wcel wa vy cv vz cv cmv co vw cv wceq vy cv vz cv cmv co cA cB cph co
      wcel vw cv cA cB cph co wcel vy cv cA wcel vz cv cB wcel wa vy cv vz cv
      cmv co vw cv cA cB cph co eleq1 cA cB vy cv vz cv cA sumdmdi.1 chshii cB
      sumdmdi.2 chshii shsvsi syl5cbi adantr sylbird exp32 com4r imp31 adantrr
      cC chil wcel cC cA cB cph co wcel wn wa vw cv cC csn cspn cfv wcel vw cv
      cA cB cph co wcel vw cv c0v wceq wi wi vy cv vz cv vw cv cva co wceq vy
      cv cA wcel vz cv cB wcel wa wa cC chil wcel cC cA cB cph co wcel wn wa vw
      cv cC csn cspn cfv wcel vw cv cA cB cph co wcel vw cv c0v wceq cA cB cph
      co csh wcel cC chil wcel cC cA cB cph co wcel wn wa vw cv cC csn cspn cfv
      wcel vw cv cA cB cph co wcel wa wa vw cv c0v wceq wi cA cB cA sumdmdi.1
      chshii cB sumdmdi.2 chshii shscli cA cB cph co cC vw cv elspansn5 ax-mp
      exp32 adantl mpdd vy cv vz cv vw cv cva co wceq vy cv cA wcel vz cv cB
      wcel wa wa vw cv cC csn cspn cfv wcel vw cv c0v wceq vy cv cB cA cin wcel
      wi wi cC chil wcel cC cA cB cph co wcel wn wa vy cv vz cv vw cv cva co
      wceq vy cv cA wcel vz cv cB wcel wa wa vw cv c0v wceq vy cv cB cA cin
      wcel wi vw cv cC csn cspn cfv wcel vy cv vz cv vw cv cva co wceq vy cv cA
      wcel vz cv cB wcel wa vw cv c0v wceq vy cv cB cA cin wcel wi vy cv vz cv
      vw cv cva co wceq vy cv cA wcel vz cv cB wcel wa vw cv c0v wceq vy cv cB
      cA cin wcel vy cv vz cv vw cv cva co wceq vy cv cA wcel vz cv cB wcel wa
      vw cv c0v wceq wa wa vy cv vz cv wceq vy cv cB cA cin wcel vy cv cA wcel
      vz cv cB wcel wa vw cv c0v wceq wa vy cv vz cv vw cv cva co wceq vy cv vz
      cv wceq vz cv cB wcel vw cv c0v wceq vy cv vz cv vw cv cva co wceq vy cv
      vz cv wceq wb vy cv cA wcel vz cv cB wcel vw cv c0v wceq wa vz cv vw cv
      cva co vz cv vy cv vz cv chil wcel vw cv c0v wceq vz cv vw cv cva co vz
      cv wceq vz cv cB wcel vw cv c0v wceq vz cv chil wcel vz cv vw cv cva co
      vz cv c0v cva co vz cv vw cv c0v vz cv cva opreq2 vz cv ax-hvaddid
      sylan9eqr vz cv cB sumdmdi.2 cheli sylan eqeq2d adantll biimpac vy cv cA
      wcel vz cv cB wcel wa vy cv vz cv wceq vy cv cB cA cin wcel wi vy cv vz
      cv vw cv cva co wceq vw cv c0v wceq vy cv cA wcel vz cv cB wcel wa vy cv
      vz cv wceq vy cv cB cA cin wcel vy cv cA wcel vz cv cB wcel vy cv vz cv
      wceq vy cv cB cA cin wcel vy cv cA wcel vy cv cB wcel vy cv cB cA cin
      wcel vz cv cB wcel vy cv vz cv wceq wa vy cv cB wcel vy cv cA wcel vy cv
      cB cA cin wcel vy cv cB cA cin wcel vy cv cB wcel vy cv cA wcel wa vy cv
      cB cA elin biimpri ancoms vy cv vz cv wceq vy cv cB wcel vz cv cB wcel vy
      cv vz cv cB eleq1 biimparc sylan2 anassrs ex ad2antrl mpd exp32 imp a1d
      adantr mpdd ex com23 exp32 com4l imp4c exp4a com23 com4l exp3a r19.23advv
      sylbid com23 imp4b vy cv cB cC csn cspn cfv cph co cA elin syl5ib ssrdv
      cC chil wcel cB cA cin cB cC csn cspn cfv cph co cA cin wss cC cA cB cph
      co wcel wn cC chil wcel cC csn cspn cfv csh wcel cB cB cC csn cspn cfv
      cph co wss cB cA cin cB cC csn cspn cfv cph co cA cin wss cC spansnsh cB
      csh wcel cC csn cspn cfv csh wcel cB cB cC csn cspn cfv cph co wss cB
      sumdmdi.2 chshii cB cC csn cspn cfv shsub1 mpan cB cB cC csn cspn cfv cph
      co cA ssrin 3syl adantr eqssd $.
      $( [23-Dec-2004] $) $( [18-Dec-2004] $)

    $( Lemma for ~ sumdmdi . $)
    sumdmdlem2 $p |- ( A. x e. Atoms ( ( x vH B ) i^i ( A vH B ) ) C_
                  ( ( ( x vH B ) i^i A ) vH B ) -> ( A +H B ) = ( A vH B ) ) $=
      vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx
      cat wral cA cB cph co cA cB chj co wss cA cB chj co cA cB cph co wss wa
      cA cB cph co cA cB chj co wceq vx cv cB chj co cA cB chj co cin vx cv cB
      chj co cA cin cB chj co wss vx cat wral cA cB chj co cA cB cph co wss cA
      cB cph co cA cB chj co wss vx cv cB chj co cA cB chj co cin vx cv cB chj
      co cA cin cB chj co wss vx cat wral vy cA cB chj co cA cB cph co vx cv cB
      chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cat wral
      vy cv cA cB chj co wcel vy cv cA cB cph co wcel vx cv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co wss vx cat wral vy cv chil wcel
      vy cv cA cB chj co wcel vy cv cA cB cph co wcel wi vy cv cA cB chj co
      wcel vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co
      wss vx cat wral vy cv chil wcel vy cv cA cB chj co wcel vy cv cA cB cph
      co wcel wn vy cv cA cB cph co wcel wi vy cv cA cB cph co wcel vx cv cB
      chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cat wral
      vy cv chil wcel vy cv cA cB cph co wcel wn vy cv cA cB chj co wcel vy cv
      cA cB cph co wcel vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin
      cB chj co wss vx cat wral vy cv chil wcel vy cv cA cB cph co wcel wn vy
      cv cA cB chj co wcel vy cv cA cB cph co wcel wi vx cv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co wss vx cat wral vy cv chil wcel
      vy cv cA cB cph co wcel wn wa wa vy cv cB vy cv csn cspn cfv cph co wcel
      vy cv cA cB chj co wcel vy cv cA cB cph co wcel vy cv chil wcel vy cv cB
      vy cv csn cspn cfv cph co wcel vx cv cB chj co cA cB chj co cin vx cv cB
      chj co cA cin cB chj co wss vx cat wral vy cv cA cB cph co wcel wn vy cv
      chil wcel vy cv csn cspn cfv cB vy cv csn cspn cfv cph co vy cv vy cv
      chil wcel vy cv csn cspn cfv csh wcel vy cv csn cspn cfv cB vy cv csn
      cspn cfv cph co wss vy cv spansnsh vy cv csn cspn cfv csh wcel cB csh
      wcel vy cv csn cspn cfv cB vy cv csn cspn cfv cph co wss cB sumdmdi.2
      chshii vy cv csn cspn cfv cB shsub2 mpan2 syl vy cv spansnid sseldd
      ad2antrl vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj
      co wss vx cat wral vy cv chil wcel vy cv cA cB cph co wcel wn wa wa vy cv
      cB vy cv csn cspn cfv cph co cA cB chj co cin wcel vy cv cA cB cph co
      wcel vy cv cB vy cv csn cspn cfv cph co wcel vy cv cA cB chj co wcel wa
      vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx
      cat wral vy cv chil wcel vy cv cA cB cph co wcel wn wa wa cB vy cv csn
      cspn cfv cph co cA cB chj co cin cA cB cph co vy cv vx cv cB chj co cA cB
      chj co cin vx cv cB chj co cA cin cB chj co wss vx cat wral vy cv chil
      wcel vy cv cA cB cph co wcel wn wa wa cB vy cv csn cspn cfv cph co cA cB
      chj co cin cB vy cv csn cspn cfv cph co cA cin cB chj co cA cB cph co vx
      cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cat
      wral vy cv chil wcel cB vy cv csn cspn cfv cph co cA cB chj co cin cB vy
      cv csn cspn cfv cph co cA cin cB chj co wss vy cv cA cB cph co wcel wn vx
      cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cat
      wral vy cv chil wcel wa vy cv c0v wceq cB vy cv csn cspn cfv cph co cA cB
      chj co cin cB vy cv csn cspn cfv cph co cA cin cB chj co wss vx cv cB chj
      co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cat wral vy
      cv chil wcel vy cv c0v wceq wn cB vy cv csn cspn cfv cph co cA cB chj co
      cin cB vy cv csn cspn cfv cph co cA cin cB chj co wss vy cv chil wcel vy
      cv c0v wceq wn wa vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin
      cB chj co wss vx cat wral cB vy cv csn cspn cfv cph co cA cB chj co cin
      cB vy cv csn cspn cfv cph co cA cin cB chj co wss vy cv chil wcel vy cv
      c0v wceq wn wa vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss vx cat wral vy cv csn cspn cfv cB chj co cA cB chj co cin vy
      cv csn cspn cfv cB chj co cA cin cB chj co wss cB vy cv csn cspn cfv cph
      co cA cB chj co cin cB vy cv csn cspn cfv cph co cA cin cB chj co wss vy
      cv chil wcel vy cv c0v wceq wn wa vy cv csn cspn cfv cat wcel vx cv cB
      chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cat wral
      vy cv csn cspn cfv cB chj co cA cB chj co cin vy cv csn cspn cfv cB chj
      co cA cin cB chj co wss wi vy cv chil wcel vy cv c0v wne vy cv csn cspn
      cfv cat wcel vy cv c0v wceq wn vy cv spansna vy cv c0v df-ne sylan2br vx
      cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vy cv
      csn cspn cfv cB chj co cA cB chj co cin vy cv csn cspn cfv cB chj co cA
      cin cB chj co wss vx vy cv csn cspn cfv cat vx cv vy cv csn cspn cfv wceq
      vx cv cB chj co cA cB chj co cin vy cv csn cspn cfv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co vy cv csn cspn cfv cB chj co cA
      cin cB chj co vx cv vy cv csn cspn cfv wceq vx cv cB chj co vy cv csn
      cspn cfv cB chj co cA cB chj co vx cv vy cv csn cspn cfv cB chj opreq1
      ineq1d vx cv vy cv csn cspn cfv wceq vx cv cB chj co cA cin vy cv csn
      cspn cfv cB chj co cA cin cB chj vx cv vy cv csn cspn cfv wceq vx cv cB
      chj co vy cv csn cspn cfv cB chj co cA vx cv vy cv csn cspn cfv cB chj
      opreq1 ineq1d opreq1d sseq12d rcla4v syl vy cv chil wcel cB vy cv csn
      cspn cfv cph co cA cB chj co cin cB vy cv csn cspn cfv cph co cA cin cB
      chj co wss vy cv csn cspn cfv cB chj co cA cB chj co cin vy cv csn cspn
      cfv cB chj co cA cin cB chj co wss wb vy cv c0v wceq wn vy cv chil wcel
      cB vy cv csn cspn cfv cph co cA cB chj co cin vy cv csn cspn cfv cB chj
      co cA cB chj co cin cB vy cv csn cspn cfv cph co cA cin cB chj co vy cv
      csn cspn cfv cB chj co cA cin cB chj co vy cv chil wcel cB vy cv csn cspn
      cfv cph co vy cv csn cspn cfv cB chj co cA cB chj co cB cch wcel vy cv
      chil wcel cB vy cv csn cspn cfv cph co vy cv csn cspn cfv cB chj co wceq
      sumdmdi.2 cB cch wcel vy cv chil wcel wa cB vy cv csn cspn cfv cph co cB
      vy cv csn cspn cfv chj co vy cv csn cspn cfv cB chj co cB vy cv spansnj
      cB cch wcel vy cv csn cspn cfv cch wcel cB vy cv csn cspn cfv chj co vy
      cv csn cspn cfv cB chj co wceq vy cv chil wcel cB vy cv csn cspn cfv
      chjcom vy cv spansnch sylan2 eqtrd mpan ineq1d vy cv chil wcel cB vy cv
      csn cspn cfv cph co cA cin vy cv csn cspn cfv cB chj co cA cin cB chj vy
      cv chil wcel cB vy cv csn cspn cfv cph co vy cv csn cspn cfv cB chj co cA
      cB cch wcel vy cv chil wcel cB vy cv csn cspn cfv cph co vy cv csn cspn
      cfv cB chj co wceq sumdmdi.2 cB cch wcel vy cv chil wcel wa cB vy cv csn
      cspn cfv cph co cB vy cv csn cspn cfv chj co vy cv csn cspn cfv cB chj co
      cB vy cv spansnj cB cch wcel vy cv csn cspn cfv cch wcel cB vy cv csn
      cspn cfv chj co vy cv csn cspn cfv cB chj co wceq vy cv chil wcel cB vy
      cv csn cspn cfv chjcom vy cv spansnch sylan2 eqtrd mpan ineq1d opreq1d
      sseq12d adantr sylibrd com12 expdimp vy cv c0v wceq cB vy cv csn cspn cfv
      cph co cA cB chj co cin cB vy cv csn cspn cfv cph co cA cin cB chj co wss
      cB cB wss cB ssid vy cv c0v wceq cB vy cv csn cspn cfv cph co cA cB chj
      co cin cB cB vy cv csn cspn cfv cph co cA cin cB chj co cB vy cv c0v wceq
      cB vy cv csn cspn cfv cph co cA cB chj co cin cB cA cB chj co cin cB vy
      cv c0v wceq cB vy cv csn cspn cfv cph co cB cA cB chj co vy cv c0v wceq
      cB vy cv csn cspn cfv cph co cB c0h cph co cB vy cv c0v wceq vy cv csn
      cspn cfv c0h cB cph vy cv c0v wceq vy cv csn cspn cfv c0v csn cspn cfv
      c0h vy cv c0v wceq vy cv csn c0v csn cspn vy cv c0v sneq fveq2d spansn0
      syl6eq opreq2d cB cB sumdmdi.2 chshii shs0i syl6eq ineq1d cB cA cB chj co
      cin cB cB cA cB chj co inss1 cB cB cA cB chj co cB ssid cB cA sumdmdi.2
      sumdmdi.1 chub2i ssini eqssi syl6eq vy cv c0v wceq cB vy cv csn cspn cfv
      cph co cA cin cB chj co cB cA cin cB chj co cB vy cv c0v wceq cB vy cv
      csn cspn cfv cph co cA cin cB cA cin cB chj vy cv c0v wceq cB vy cv csn
      cspn cfv cph co cB cA vy cv c0v wceq cB vy cv csn cspn cfv cph co cB c0h
      cph co cB vy cv c0v wceq vy cv csn cspn cfv c0h cB cph vy cv c0v wceq vy
      cv csn cspn cfv c0v csn cspn cfv c0h vy cv c0v wceq vy cv csn c0v csn
      cspn vy cv c0v sneq fveq2d spansn0 syl6eq opreq2d cB cB sumdmdi.2 chshii
      shs0i syl6eq ineq1d opreq1d cB cA cin cB chj co cB cB cA cin chj co cB cB
      cA cin cB cB cA sumdmdi.2 sumdmdi.1 chincli sumdmdi.2 chjcomi cB cA
      sumdmdi.2 sumdmdi.1 chabs1i eqtri syl6eq sseq12d mpbiri pm2.61d2 adantrr
      vy cv chil wcel vy cv cA cB cph co wcel wn wa cB vy cv csn cspn cfv cph
      co cA cin cB chj co cA cB cph co wss vx cv cB chj co cA cB chj co cin vx
      cv cB chj co cA cin cB chj co wss vx cat wral vy cv chil wcel vy cv cA cB
      cph co wcel wn wa cB vy cv csn cspn cfv cph co cA cin cB chj co cA cB cph
      co wss cB cA cB cph co wss cB cA cB sumdmdi.2 chshii cA sumdmdi.1 chshii
      shsub2i vy cv chil wcel vy cv cA cB cph co wcel wn wa cB vy cv csn cspn
      cfv cph co cA cin cB chj co cB cA cB cph co vy cv chil wcel vy cv cA cB
      cph co wcel wn wa cB vy cv csn cspn cfv cph co cA cin cB chj co cB cA cin
      cB chj co cB vy cv chil wcel vy cv cA cB cph co wcel wn wa cB vy cv csn
      cspn cfv cph co cA cin cB cA cin cB chj cA cB vy cv sumdmdi.1 sumdmdi.2
      sumdmdlem opreq1d cB cA cin cB chj co cB cB cA cin chj co cB cB cA cin cB
      cB cA sumdmdi.2 sumdmdi.1 chincli sumdmdi.2 chjcomi cB cA sumdmdi.2
      sumdmdi.1 chabs1i eqtri syl6eq sseq1d mpbiri adantl sstrd sseld vy cv cB
      vy cv csn cspn cfv cph co cA cB chj co elin syl5ibr mpand exp32 com34 vy
      cv cA cB cph co wcel pm2.18 syl8 vy cv cA cB chj co cA cB sumdmdi.1
      sumdmdi.2 chjcli cheli syl5 pm2.43d ssrdv cA cB sumdmdi.1 sumdmdi.2
      chsleji jctil cA cB cph co cA cB chj co eqss sylibr $.
      $( [23-Dec-2004] $) $( [15-Jan-2005] $)

    $( The subspace sum of two Hilbert lattice elements is closed iff the
       elements are a dual modular pair.  Theorem 2 of [Holland] p. 1519. $)
    sumdmdi $p |- ( ( A +H B ) = ( A vH B ) <-> A MH* B ) $=
      cA cB cph co cA cB chj co wceq cA cB cdmd wbr cA cB sumdmdi.1 sumdmdi.2
      sumdmdii cA cB cdmd wbr vx cv cB chj co cA cB chj co cin vx cv cB chj co
      cA cin cB chj co wss vx cat wral cA cB cph co cA cB chj co wceq cA cB
      cdmd wbr vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj
      co wss vx cch wral vx cv cB chj co cA cB chj co cin vx cv cB chj co cA
      cin cB chj co wss vx cat wral cA cch wcel cB cch wcel cA cB cdmd wbr vx
      cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cch
      wral wb sumdmdi.1 sumdmdi.2 vx cA cB dmdbr4 mp2an vx cv cB chj co cA cB
      chj co cin vx cv cB chj co cA cin cB chj co wss vx cv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co wss vx cch cat vx cv cat wcel vx
      cv cch wcel vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss vx cv atelch imim1i r19.20i2 sylbi vx cA cB sumdmdi.1
      sumdmdi.2 sumdmdlem2 syl impbii $.
      $( [5-Aug-2007] $) $( [14-Dec-2004] $)

    $( Dual modular pair property in terms of atoms. $)
    dmdbr4ati $p |- ( A MH* B <-> A. x e. Atoms
            ( ( x vH B ) i^i ( A vH B ) ) C_ ( ( ( x vH B ) i^i A ) vH B ) ) $=
      cA cB cdmd wbr vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss vx cat wral cA cB cdmd wbr vx cv cB chj co cA cB chj co cin vx
      cv cB chj co cA cin cB chj co wss vx cch wral vx cv cB chj co cA cB chj
      co cin vx cv cB chj co cA cin cB chj co wss vx cat wral cA cch wcel cB
      cch wcel cA cB cdmd wbr vx cv cB chj co cA cB chj co cin vx cv cB chj co
      cA cin cB chj co wss vx cch wral wb sumdmdi.1 sumdmdi.2 vx cA cB dmdbr4
      mp2an vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co
      wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss
      vx cch cat vx cv cat wcel vx cv cch wcel vx cv cB chj co cA cB chj co cin
      vx cv cB chj co cA cin cB chj co wss vx cv atelch imim1i r19.20i2 sylbi
      vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss vx
      cat wral cA cB cph co cA cB chj co wceq cA cB cdmd wbr vx cA cB sumdmdi.1
      sumdmdi.2 sumdmdlem2 cA cB sumdmdi.1 sumdmdi.2 sumdmdi sylib impbii $.
      $( [13-Jul-2008] $) $( [15-Jan-2005] $)

    $( Dual modular pair property in terms of atoms. $)
    dmdbr5ati $p |- ( A MH* B <->
   A. x e. Atoms ( x C_ ( A vH B ) -> x C_ ( ( ( x vH B ) i^i A ) vH B ) ) ) $=
      cA cB cdmd wbr vx cv cA cB chj co wss vx cv cB chj co cA cB chj co cin vx
      cv cB chj co cA cin cB chj co wss wi vx cat wral vx cv cA cB chj co wss
      vx cv vx cv cB chj co cA cin cB chj co wss wi vx cat wral cA cB cdmd wbr
      vx cv cA cB chj co wss vx cv cB chj co cA cB chj co cin vx cv cB chj co
      cA cin cB chj co wss wi vx cat wral cA cB cdmd wbr vx cv cA cB chj co wss
      vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss wi
      vx cat cA cB cdmd wbr vx cv cat wcel vx cv cB chj co cA cB chj co cin vx
      cv cB chj co cA cin cB chj co wss vx cv cA cB chj co wss cA cB cdmd wbr
      vx cv cch wcel vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss vx cv cat wcel vx cv cch wcel cA cB cdmd wbr vx cv cB chj co
      cA cB chj co cin vx cv cB chj co cA cin cB chj co wss cA cch wcel cB cch
      wcel vx cv cch wcel cA cB cdmd wbr vx cv cB chj co cA cB chj co cin vx cv
      cB chj co cA cin cB chj co wss wi sumdmdi.1 sumdmdi.2 cA cB vx cv dmdi4
      mp3an12 com12 vx cv atelch syl5 a1dd r19.21aiv vx cv cA cB chj co wss vx
      cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss wi vx
      cat wral cA cB cph co cA cB chj co wceq cA cB cdmd wbr vx cv cA cB chj co
      wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss
      wi vx cat wral vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss vx cat wral cA cB cph co cA cB chj co wceq vx cv cA cB chj co
      wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss
      wi vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss
      vx cat vx cv cat wcel vx cv cA cB chj co wss vx cv cB chj co cA cB chj co
      cin vx cv cB chj co cA cin cB chj co wss wi vx cv cA cB chj co wss vx cv
      cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss wi vx cv
      cA cB chj co wss wn vx cv cB chj co cA cB chj co cin vx cv cB chj co cA
      cin cB chj co wss wi wa vx cv cB chj co cA cB chj co cin vx cv cB chj co
      cA cin cB chj co wss vx cv cat wcel vx cv cA cB chj co wss wn vx cv cB
      chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss wi vx cv cA
      cB chj co wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB
      chj co wss wi vx cv cat wcel vx cv cA cB chj co wss wn vx cv cB chj co cA
      cB chj co cin vx cv cB chj co cA cin cB chj co wss vx cv cat wcel vx cv
      cA cB chj co wss wn wa vx cv cB chj co cA cB chj co cin cB vx cv cB chj
      co cA cin cB chj co vx cv cat wcel vx cv cA cB chj co wss wn wa cB vx cv
      chj co cB cA chj co cin vx cv cB chj co cA cB chj co cin cB vx cv cat
      wcel cB vx cv chj co cB cA chj co cin vx cv cB chj co cA cB chj co cin
      wceq vx cv cA cB chj co wss wn vx cv cat wcel cB vx cv chj co cB cA chj
      co cin vx cv cB chj co cB cA chj co cin vx cv cB chj co cA cB chj co cin
      vx cv cat wcel cB vx cv chj co vx cv cB chj co cB cA chj co vx cv cat
      wcel vx cv cch wcel cB vx cv chj co vx cv cB chj co wceq vx cv atelch cB
      cch wcel vx cv cch wcel cB vx cv chj co vx cv cB chj co wceq sumdmdi.2 cB
      vx cv chjcom mpan syl ineq1d cA cB chj co cB cA chj co vx cv cB chj co cA
      cB sumdmdi.1 sumdmdi.2 chjcomi ineq2i syl6eqr adantr vx cv cat wcel vx cv
      cB cA chj co wss wn cB vx cv chj co cB cA chj co cin cB wceq vx cv cA cB
      chj co wss wn vx cv cat wcel vx cv cB cA chj co wss wn cB vx cv chj co cB
      cA chj co cin cB wceq cB cA vx cv sumdmdi.2 sumdmdi.1 atabs2i imp vx cv
      cA cB chj co wss vx cv cB cA chj co wss cA cB chj co cB cA chj co vx cv
      cA cB sumdmdi.1 sumdmdi.2 chjcomi sseq2i notbii sylan2b eqtr3d vx cv cat
      wcel cB vx cv cB chj co cA cin cB chj co wss vx cv cA cB chj co wss wn vx
      cv cat wcel vx cv cB chj co cch wcel vx cv cB chj co cA cin cch wcel cB
      vx cv cB chj co cA cin cB chj co wss vx cv cat wcel vx cv cch wcel vx cv
      cB chj co cch wcel vx cv atelch vx cv cch wcel cB cch wcel vx cv cB chj
      co cch wcel sumdmdi.2 vx cv cB chjcl mpan2 syl vx cv cB chj co cch wcel
      cA cch wcel vx cv cB chj co cA cin cch wcel sumdmdi.1 vx cv cB chj co cA
      chincl mpan2 cB cch wcel vx cv cB chj co cA cin cch wcel cB vx cv cB chj
      co cA cin cB chj co wss sumdmdi.2 cB vx cv cB chj co cA cin chub2 mpan
      3syl adantr eqsstrd ex biantrud vx cv cA cB chj co wss vx cv cB chj co cA
      cB chj co cin vx cv cB chj co cA cin cB chj co wss pm4.83 syl6bb ralbiia
      vx cA cB sumdmdi.1 sumdmdi.2 sumdmdlem2 sylbi cA cB sumdmdi.1 sumdmdi.2
      sumdmdi sylib impbii vx cv cA cB chj co wss vx cv cB chj co cA cB chj co
      cin vx cv cB chj co cA cin cB chj co wss wi vx cv cA cB chj co wss vx cv
      vx cv cB chj co cA cin cB chj co wss wi vx cat vx cv cat wcel vx cv cch
      wcel vx cv cA cB chj co wss vx cv cB chj co cA cB chj co cin vx cv cB chj
      co cA cin cB chj co wss wi vx cv cA cB chj co wss vx cv vx cv cB chj co
      cA cin cB chj co wss wi wb vx cv atelch vx cv cch wcel vx cv cA cB chj co
      wss vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj co wss
      vx cv vx cv cB chj co cA cin cB chj co wss vx cv cch wcel vx cv cA cB chj
      co wss wa vx cv cB chj co cA cB chj co cin vx cv cB chj co cA cin cB chj
      co wss vx cv cB chj co vx cv cB chj co cA cin cB chj co wss vx cv vx cv
      cB chj co cA cin cB chj co wss vx cv cch wcel vx cv cA cB chj co wss wa
      vx cv cB chj co cA cB chj co cin vx cv cB chj co vx cv cB chj co cA cin
      cB chj co vx cv cch wcel vx cv cA cB chj co wss wa vx cv cB chj co cA cB
      chj co cin vx cv cB chj co wss vx cv cB chj co vx cv cB chj co cA cB chj
      co cin wss wa vx cv cB chj co cA cB chj co cin vx cv cB chj co wceq vx cv
      cch wcel vx cv cA cB chj co wss wa vx cv cB chj co vx cv cB chj co cA cB
      chj co cin wss vx cv cB chj co cA cB chj co cin vx cv cB chj co wss vx cv
      cch wcel vx cv cA cB chj co wss vx cv cB chj co vx cv cB chj co cA cB chj
      co cin wss vx cv cch wcel vx cv cA cB chj co wss vx cv cB chj co cA cB
      chj co wss vx cv cB chj co vx cv cB chj co cA cB chj co cin wss vx cv cch
      wcel vx cv cA cB chj co wss cB cA cB chj co wss wa vx cv cB chj co cA cB
      chj co wss vx cv cA cB chj co wss vx cv cch wcel cB cch wcel cA cB chj co
      cch wcel vx cv cA cB chj co wss cB cA cB chj co wss wa vx cv cB chj co cA
      cB chj co wss wb sumdmdi.2 cA cB sumdmdi.1 sumdmdi.2 chjcli vx cv cB cA
      cB chj co chlub mp3an23 cB cA cB chj co wss vx cv cA cB chj co wss cB cA
      sumdmdi.2 sumdmdi.1 chub2i biantru syl5bb vx cv cB chj co cA cB chj co
      wss vx cv cB chj co vx cv cB chj co wss vx cv cB chj co cA cB chj co wss
      wa vx cv cB chj co vx cv cB chj co cA cB chj co cin wss vx cv cB chj co
      vx cv cB chj co wss vx cv cB chj co cA cB chj co wss vx cv cB chj co ssid
      biantrur vx cv cB chj co vx cv cB chj co cA cB chj co ssin bitri syl6bb
      biimpa vx cv cB chj co cA cB chj co inss1 jctil vx cv cB chj co cA cB chj
      co cin vx cv cB chj co eqss sylibr sseq1d vx cv cch wcel vx cv vx cv cB
      chj co cA cin cB chj co wss vx cv cB chj co vx cv cB chj co cA cin cB chj
      co wss wb vx cv cA cB chj co wss vx cv cch wcel vx cv vx cv cB chj co cA
      cin cB chj co wss vx cv vx cv cB chj co cA cin cB chj co wss cB vx cv cB
      chj co cA cin cB chj co wss wa vx cv cB chj co vx cv cB chj co cA cin cB
      chj co wss vx cv cch wcel cB vx cv cB chj co cA cin cB chj co wss vx cv
      vx cv cB chj co cA cin cB chj co wss vx cv cch wcel vx cv cB chj co cch
      wcel vx cv cB chj co cA cin cch wcel cB vx cv cB chj co cA cin cB chj co
      wss vx cv cch wcel cB cch wcel vx cv cB chj co cch wcel sumdmdi.2 vx cv
      cB chjcl mpan2 vx cv cB chj co cch wcel cA cch wcel vx cv cB chj co cA
      cin cch wcel sumdmdi.1 vx cv cB chj co cA chincl mpan2 cB cch wcel vx cv
      cB chj co cA cin cch wcel cB vx cv cB chj co cA cin cB chj co wss
      sumdmdi.2 cB vx cv cB chj co cA cin chub2 mpan 3syl biantrud vx cv cch
      wcel vx cv cB chj co cA cin cB chj co cch wcel vx cv vx cv cB chj co cA
      cin cB chj co wss cB vx cv cB chj co cA cin cB chj co wss wa vx cv cB chj
      co vx cv cB chj co cA cin cB chj co wss wb vx cv cch wcel vx cv cB chj co
      cch wcel vx cv cB chj co cA cin cch wcel vx cv cB chj co cA cin cB chj co
      cch wcel vx cv cch wcel cB cch wcel vx cv cB chj co cch wcel sumdmdi.2 vx
      cv cB chjcl mpan2 vx cv cB chj co cch wcel cA cch wcel vx cv cB chj co cA
      cin cch wcel sumdmdi.1 vx cv cB chj co cA chincl mpan2 vx cv cB chj co cA
      cin cch wcel cB cch wcel vx cv cB chj co cA cin cB chj co cch wcel
      sumdmdi.2 vx cv cB chj co cA cin cB chjcl mpan2 3syl vx cv cch wcel cB
      cch wcel vx cv cB chj co cA cin cB chj co cch wcel vx cv vx cv cB chj co
      cA cin cB chj co wss cB vx cv cB chj co cA cin cB chj co wss wa vx cv cB
      chj co vx cv cB chj co cA cin cB chj co wss wb sumdmdi.2 vx cv cB vx cv
      cB chj co cA cin cB chj co chlub mp3an2 mpdan bitrd adantr bitr4d
      pm5.74da syl ralbiia bitri $.
      $( [12-Aug-2007] $) $( [14-Jan-2005] $)

    $( Dual modular pair property in terms of atoms.  The modular law takes
       the form of the shearing identity. $)
    dmdbr6ati $p |- ( A MH* B <-> A. x e. Atoms
            ( ( A vH B ) i^i x ) = ( ( ( ( x vH B ) i^i A ) vH B ) i^i x ) ) $=
      cA cB cdmd wbr cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co vx
      cv cin wceq vx cat wral cA cB cdmd wbr cA cB chj co vx cv cin vx cv cB
      chj co cA cin cB chj co vx cv cin wceq vx cch wral cA cB chj co vx cv cin
      vx cv cB chj co cA cin cB chj co vx cv cin wceq vx cat wral cA cB cdmd
      wbr vx cv cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin
      wceq vx cch wral cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co
      vx cv cin wceq vx cch wral cA cch wcel cB cch wcel cA cB cdmd wbr vx cv
      cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq vx cch
      wral wb sumdmdi.1 sumdmdi.2 vx cA cB dmdbr3 mp2an vx cv cB chj co cA cin
      cB chj co vx cv cB chj co cA cB chj co cin wceq cA cB chj co vx cv cin vx
      cv cB chj co cA cin cB chj co vx cv cin wceq vx cch vx cv cch wcel vx cv
      cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq wa cA cB
      chj co vx cv cin vx cv cB chj co cA cB chj co cin vx cv cin vx cv cB chj
      co cA cin cB chj co vx cv cin vx cv cch wcel cA cB chj co vx cv cin vx cv
      cB chj co cA cB chj co cin vx cv cin wceq vx cv cB chj co cA cin cB chj
      co vx cv cB chj co cA cB chj co cin wceq vx cv cch wcel cA cB chj co vx
      cv vx cv cB chj co cin cin cA cB chj co vx cv cin vx cv cB chj co cA cB
      chj co cin vx cv cin vx cv cch wcel vx cv vx cv cB chj co cin vx cv cA cB
      chj co vx cv cch wcel cB cch wcel vx cv vx cv cB chj co cin vx cv wceq
      sumdmdi.2 vx cv cB chabs2 mpan2 ineq2d cA cB chj co vx cv vx cv cB chj co
      cin cin vx cv vx cv cB chj co cin cA cB chj co cin vx cv vx cv cB chj co
      cA cB chj co cin cin vx cv cB chj co cA cB chj co cin vx cv cin cA cB chj
      co vx cv vx cv cB chj co cin incom vx cv vx cv cB chj co cA cB chj co
      inass vx cv vx cv cB chj co cA cB chj co cin incom 3eqtri syl5reqr adantr
      vx cv cB chj co cA cin cB chj co vx cv cB chj co cA cB chj co cin wceq vx
      cv cB chj co cA cin cB chj co vx cv cin vx cv cB chj co cA cB chj co cin
      vx cv cin wceq vx cv cch wcel vx cv cB chj co cA cin cB chj co vx cv cB
      chj co cA cB chj co cin vx cv ineq1 adantl eqtr4d r19.20ia sylbi cA cB
      chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv cin wceq cA cB
      chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv cin wceq vx cch
      cat vx cv cat wcel vx cv cch wcel cA cB chj co vx cv cin vx cv cB chj co
      cA cin cB chj co vx cv cin wceq vx cv atelch imim1i r19.20i2 syl cA cB
      chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv cin wceq vx cat
      wral vx cv cA cB chj co wss vx cv vx cv cB chj co cA cin cB chj co wss wi
      vx cat wral cA cB cdmd wbr cA cB chj co vx cv cin vx cv cB chj co cA cin
      cB chj co vx cv cin wceq vx cv cA cB chj co wss vx cv vx cv cB chj co cA
      cin cB chj co wss wi vx cat vx cv cA cB chj co wss cA cB chj co vx cv cin
      vx cv cB chj co cA cin cB chj co wss vx cv vx cv cB chj co cA cin cB chj
      co wss cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv cin
      wceq vx cv cA cB chj co wss cA cB chj co vx cv cin vx cv vx cv cB chj co
      cA cin cB chj co vx cv cA cB chj co wss vx cv cA cB chj co cin vx cv cA
      cB chj co vx cv cin vx cv cA cB chj co wss vx cv cA cB chj co cin vx cv
      wceq vx cv cA cB chj co df-ss biimpi cA cB chj co vx cv incom syl5eq
      sseq1d cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv cin
      wceq cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co wss vx cv cB
      chj co cA cin cB chj co vx cv cin vx cv cB chj co cA cin cB chj co wss vx
      cv cB chj co cA cin cB chj co vx cv inss1 cA cB chj co vx cv cin vx cv cB
      chj co cA cin cB chj co vx cv cin vx cv cB chj co cA cin cB chj co sseq1
      mpbiri syl5cbi r19.20si vx cA cB sumdmdi.1 sumdmdi.2 dmdbr5ati sylibr
      impbii $.
      $( [13-Feb-2008] $) $( [18-Jan-2005] $)

    $( Dual modular pair property in terms of atoms. $)
    dmdbr7ati $p |- ( A MH* B <->
       A. x e. Atoms ( ( A vH B ) i^i x ) C_ ( ( ( x vH B ) i^i A ) vH B ) ) $=
      cA cB cdmd wbr cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co
      wss vx cat wral cA cB cdmd wbr cA cB chj co vx cv cin vx cv cB chj co cA
      cin cB chj co vx cv cin wceq vx cat wral cA cB chj co vx cv cin vx cv cB
      chj co cA cin cB chj co wss vx cat wral vx cA cB sumdmdi.1 sumdmdi.2
      dmdbr6ati cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv
      cin wceq cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co wss vx
      cat cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co vx cv cin
      wceq cA cB chj co vx cv cin vx cv cB chj co cA cin cB chj co wss vx cv cB
      chj co cA cin cB chj co vx cv cin vx cv cB chj co cA cin cB chj co wss vx
      cv cB chj co cA cin cB chj co vx cv inss1 cA cB chj co vx cv cin vx cv cB
      chj co cA cin cB chj co vx cv cin vx cv cB chj co cA cin cB chj co sseq1
      mpbiri r19.20si sylbi cA cB chj co vx cv cin vx cv cB chj co cA cin cB
      chj co wss vx cat wral vx cv cA cB chj co wss vx cv vx cv cB chj co cA
      cin cB chj co wss wi vx cat wral cA cB cdmd wbr cA cB chj co vx cv cin vx
      cv cB chj co cA cin cB chj co wss vx cv cA cB chj co wss vx cv vx cv cB
      chj co cA cin cB chj co wss wi vx cat vx cv cA cB chj co wss cA cB chj co
      vx cv cin vx cv cB chj co cA cin cB chj co wss vx cv vx cv cB chj co cA
      cin cB chj co wss vx cv cA cB chj co wss cA cB chj co vx cv cin vx cv vx
      cv cB chj co cA cin cB chj co vx cv cA cB chj co wss cA cB chj co vx cv
      cin vx cv wceq vx cv cA cB chj co sseqin2 biimpi sseq1d biimpcd r19.20si
      vx cA cB sumdmdi.1 sumdmdi.2 dmdbr5ati sylibr impbii $.
      $( [14-Jul-2008] $) $( [18-Jan-2005] $)
  $}

  ${
    mdoc1.1 $e |- A e. CH $.
    $( Orthocomplements form a modular pair. $)
    mdoc1i $p |- A MH ( _|_ ` A ) $=
      cA cA cort cfv ccm wbr cA cA cort cfv cmd wbr cA cA mdoc1.1 mdoc1.1 cA
      mdoc1.1 cmidi cmcm2ii cA cA cort cfv mdoc1.1 cA mdoc1.1 choccli cmmdi
      ax-mp $.
      $( [15-Jun-2006] $) $( [29-Apr-2006] $)

    $( Orthocomplements form a modular pair. $)
    mdoc2i $p |- ( _|_ ` A ) MH A $=
      cA cort cfv cA cort cfv cort cfv cA cmd cA cort cfv cA mdoc1.1 choccli
      mdoc1i cA mdoc1.1 ococi breqtri $.
      $( [3-Oct-2006] $) $( [29-Apr-2006] $)

    $( Orthocomplements form a dual modular pair. $)
    dmdoc1i $p |- A MH* ( _|_ ` A ) $=
      cA cA cort cfv ccm wbr cA cA cort cfv cdmd wbr cA cA mdoc1.1 mdoc1.1 cA
      mdoc1.1 cmidi cmcm2ii cA cA cort cfv mdoc1.1 cA mdoc1.1 choccli cmdmdi
      ax-mp $.
      $( [6-Jun-2006] $) $( [29-Apr-2006] $)

    $( Orthocomplements form a dual modular pair. $)
    dmdoc2i $p |- ( _|_ ` A ) MH* A $=
      cA cort cfv cA cort cfv cort cfv cA cdmd cA cort cfv cA mdoc1.1 choccli
      dmdoc1i cA mdoc1.1 ococi breqtri $.
      $( [15-Jun-2006] $) $( [29-Apr-2006] $)
  $}


  ${
    mdcompl.1 $e |- A e. CH $.
    mdcompl.2 $e |- B e. CH $.
    $( A condition equivalent to the modular pair property.  Part of proof of
       Theorem 1.14 of [MaedaMaeda] p. 4. $)
    mdcompli $p |- ( A MH B <-> ( A i^i ( _|_ ` ( A i^i B ) ) ) MH
                  ( B i^i ( _|_ ` ( A i^i B ) ) ) ) $=
      cA cB cin cA cB cin cort cfv cmd wbr cA cB cin cort cfv cA cB cin cdmd
      wbr wa cA cB cin cA cB cin wss cA cB chj co cA cB cin cA cB cin cort cfv
      chj co wss wa cA cB cmd wbr cA cA cB cin cort cfv cin cB cA cB cin cort
      cfv cin cmd wbr wb cA cB cin cA cB cin cort cfv cmd wbr cA cB cin cort
      cfv cA cB cin cdmd wbr cA cB cin cA cB mdcompl.1 mdcompl.2 chincli mdoc1i
      cA cB cin cA cB mdcompl.1 mdcompl.2 chincli dmdoc2i pm3.2i cA cB cin cA
      cB cin wss cA cB chj co cA cB cin cA cB cin cort cfv chj co wss cA cB cin
      ssid cA cB chj co chil cA cB cin cA cB cin cort cfv chj co cA cB chj co
      cA cB mdcompl.1 mdcompl.2 chjcli chssii cA cB cin cA cB mdcompl.1
      mdcompl.2 chincli chjoi sseqtr4i pm3.2i cA cB cin cA cB cin cort cfv cA
      cB cA cB mdcompl.1 mdcompl.2 chincli cA cB cin cA cB mdcompl.1 mdcompl.2
      chincli choccli mdcompl.1 mdcompl.2 mdslmd1i mp2an $.
      $( [15-Jun-2006] $) $( [29-Apr-2006] $)

    $( A condition equivalent to the dual modular pair property. $)
    dmdcompli $p |- ( A MH* B <-> ( A i^i ( _|_ ` ( A i^i B ) ) ) MH*
                  ( B i^i ( _|_ ` ( A i^i B ) ) ) ) $=
      cA cB cin cA cB cin cort cfv cmd wbr cA cB cin cort cfv cA cB cin cdmd
      wbr wa cA cB cin cA cB cin wss cA cB chj co cA cB cin cA cB cin cort cfv
      chj co wss wa cA cB cdmd wbr cA cA cB cin cort cfv cin cB cA cB cin cort
      cfv cin cdmd wbr wb cA cB cin cA cB cin cort cfv cmd wbr cA cB cin cort
      cfv cA cB cin cdmd wbr cA cB cin cA cB mdcompl.1 mdcompl.2 chincli mdoc1i
      cA cB cin cA cB mdcompl.1 mdcompl.2 chincli dmdoc2i pm3.2i cA cB cin cA
      cB cin wss cA cB chj co cA cB cin cA cB cin cort cfv chj co wss cA cB cin
      ssid cA cB chj co chil cA cB cin cA cB cin cort cfv chj co cA cB chj co
      cA cB mdcompl.1 mdcompl.2 chjcli chssii cA cB cin cA cB mdcompl.1
      mdcompl.2 chincli chjoi sseqtr4i pm3.2i cA cB cin cA cB cin cort cfv cA
      cB cA cB mdcompl.1 mdcompl.2 chincli cA cB cin cA cB mdcompl.1 mdcompl.2
      chincli choccli mdcompl.1 mdcompl.2 mdsldmd1i mp2an $.
      $( [18-Jun-2006] $) $( [29-Apr-2006] $)
  $}

  ${
    $d x y A $.  $d x y B $.
    mddmdin0.1 $e |- A e. CH $.
    mddmdin0.2 $e |- B e. CH $.
    mddmdin0.3 $e |- A. x e. CH A. y e. CH ( ( x MH* y /\ ( x i^i y ) = 0H ) ->
                     x MH y ) $.
    $( If dual modular implies modular whenever meet is zero, then dual
       modular implies modular for arbitrary lattice elements.  This theorem is
       needed for the remark after Lemma 7 of [Holland] p. 1524 to hold. $)
    mddmdin0i $p |- ( A MH* B -> A MH B ) $=
      cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin cdmd wbr cA cA cB cin
      cort cfv cin cB cA cB cin cort cfv cin cmd wbr cA cB cdmd wbr cA cB cmd
      wbr cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin cdmd wbr cA cA cB
      cin cort cfv cin cB cA cB cin cort cfv cin cin c0h wceq cA cA cB cin cort
      cfv cin cB cA cB cin cort cfv cin cmd wbr cA cB cin cA cB cin cort cfv
      cin cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin cin c0h cA cB cA
      cB cin cort cfv inindir cA cB cin cA cB mddmdin0.1 mddmdin0.2 chincli
      chocini eqtr3i vx cv vy cv cdmd wbr vx cv vy cv cin c0h wceq wa vx cv vy
      cv cmd wbr wi vy cch wral vx cch wral cA cA cB cin cort cfv cin cB cA cB
      cin cort cfv cin cdmd wbr cA cA cB cin cort cfv cin cB cA cB cin cort cfv
      cin cin c0h wceq wa cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin
      cmd wbr wi mddmdin0.3 cA cA cB cin cort cfv cin cch wcel cB cA cB cin
      cort cfv cin cch wcel vx cv vy cv cdmd wbr vx cv vy cv cin c0h wceq wa vx
      cv vy cv cmd wbr wi vy cch wral vx cch wral cA cA cB cin cort cfv cin cB
      cA cB cin cort cfv cin cdmd wbr cA cA cB cin cort cfv cin cB cA cB cin
      cort cfv cin cin c0h wceq wa cA cA cB cin cort cfv cin cB cA cB cin cort
      cfv cin cmd wbr wi wi cA cA cB cin cort cfv mddmdin0.1 cA cB cin cA cB
      mddmdin0.1 mddmdin0.2 chincli choccli chincli cB cA cB cin cort cfv
      mddmdin0.2 cA cB cin cA cB mddmdin0.1 mddmdin0.2 chincli choccli chincli
      vx cv vy cv cdmd wbr vx cv vy cv cin c0h wceq wa vx cv vy cv cmd wbr wi
      cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin cdmd wbr cA cA cB cin
      cort cfv cin cB cA cB cin cort cfv cin cin c0h wceq wa cA cA cB cin cort
      cfv cin cB cA cB cin cort cfv cin cmd wbr wi cA cA cB cin cort cfv cin vy
      cv cdmd wbr cA cA cB cin cort cfv cin vy cv cin c0h wceq wa cA cA cB cin
      cort cfv cin vy cv cmd wbr wi vx vy cA cA cB cin cort cfv cin cB cA cB
      cin cort cfv cin cch cch vx cv cA cA cB cin cort cfv cin wceq vx cv vy cv
      cdmd wbr vx cv vy cv cin c0h wceq wa cA cA cB cin cort cfv cin vy cv cdmd
      wbr cA cA cB cin cort cfv cin vy cv cin c0h wceq wa vx cv vy cv cmd wbr
      cA cA cB cin cort cfv cin vy cv cmd wbr vx cv cA cA cB cin cort cfv cin
      wceq vx cv vy cv cdmd wbr cA cA cB cin cort cfv cin vy cv cdmd wbr vx cv
      vy cv cin c0h wceq cA cA cB cin cort cfv cin vy cv cin c0h wceq vx cv cA
      cA cB cin cort cfv cin vy cv cdmd breq1 vx cv cA cA cB cin cort cfv cin
      wceq vx cv vy cv cin cA cA cB cin cort cfv cin vy cv cin c0h vx cv cA cA
      cB cin cort cfv cin vy cv ineq1 eqeq1d anbi12d vx cv cA cA cB cin cort
      cfv cin vy cv cmd breq1 imbi12d vy cv cB cA cB cin cort cfv cin wceq cA
      cA cB cin cort cfv cin vy cv cdmd wbr cA cA cB cin cort cfv cin vy cv cin
      c0h wceq wa cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin cdmd wbr
      cA cA cB cin cort cfv cin cB cA cB cin cort cfv cin cin c0h wceq wa cA cA
      cB cin cort cfv cin vy cv cmd wbr cA cA cB cin cort cfv cin cB cA cB cin
      cort cfv cin cmd wbr vy cv cB cA cB cin cort cfv cin wceq cA cA cB cin
      cort cfv cin vy cv cdmd wbr cA cA cB cin cort cfv cin cB cA cB cin cort
      cfv cin cdmd wbr cA cA cB cin cort cfv cin vy cv cin c0h wceq cA cA cB
      cin cort cfv cin cB cA cB cin cort cfv cin cin c0h wceq vy cv cB cA cB
      cin cort cfv cin cA cA cB cin cort cfv cin cdmd breq2 vy cv cB cA cB cin
      cort cfv cin wceq cA cA cB cin cort cfv cin vy cv cin cA cA cB cin cort
      cfv cin cB cA cB cin cort cfv cin cin c0h vy cv cB cA cB cin cort cfv cin
      cA cA cB cin cort cfv cin ineq2 eqeq1d anbi12d vy cv cB cA cB cin cort
      cfv cin cA cA cB cin cort cfv cin cmd breq2 imbi12d rcla42v mp2an ax-mp
      mpan2 cA cB mddmdin0.1 mddmdin0.2 dmdcompli cA cB mddmdin0.1 mddmdin0.2
      mdcompli 3imtr4i $.
      $( [7-Oct-2006] $) $( [29-Apr-2006] $)
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.
    cdjreu.1 $e |- A e. SH $.
    cdjreu.2 $e |- B e. SH $.
    $( A member of the sum of disjoint subspaces has a unique decomposition.
       Part of Lemma 5 of [Holland] p. 1520. $)
    cdjreui $p |- ( ( C e. ( A +H B ) /\ ( A i^i B ) = 0H ) ->
                 E! x e. A E. y e. B C = ( x +h y ) ) $=
      cC cA cB cph co wcel cA cB cin c0h wceq wa cC vx cv vy cv cva co wceq vy
      cB wrex vx cA wrex cC vx cv vy cv cva co wceq vy cB wrex cC vz cv vw cv
      cva co wceq vw cB wrex wa vx cv vz cv wceq wi vz cA wral vx cA wral wa cC
      vx cv vy cv cva co wceq vy cB wrex vx cA wreu cC cA cB cph co wcel cC vx
      cv vy cv cva co wceq vy cB wrex vx cA wrex cA cB cin c0h wceq cC vx cv vy
      cv cva co wceq vy cB wrex cC vz cv vw cv cva co wceq vw cB wrex wa vx cv
      vz cv wceq wi vz cA wral vx cA wral cC cA cB cph co wcel cC vx cv vy cv
      cva co wceq vy cB wrex vx cA wrex vx vy cA cB cC cdjreu.1 cdjreu.2 shseli
      biimpi cA cB cin c0h wceq cC vx cv vy cv cva co wceq vy cB wrex cC vz cv
      vw cv cva co wceq vw cB wrex wa vx cv vz cv wceq wi vx vz cA cA cA cB cin
      c0h wceq vx cv cA wcel vz cv cA wcel wa cC vx cv vy cv cva co wceq vy cB
      wrex cC vz cv vw cv cva co wceq vw cB wrex wa vx cv vz cv wceq wi cA cB
      cin c0h wceq vx cv cA wcel vz cv cA wcel wa wa cC vx cv vy cv cva co wceq
      cC vz cv vw cv cva co wceq wa vw cB wrex vy cB wrex vx cv vz cv wceq cC
      vx cv vy cv cva co wceq vy cB wrex cC vz cv vw cv cva co wceq vw cB wrex
      wa cA cB cin c0h wceq vx cv cA wcel vz cv cA wcel wa wa cC vx cv vy cv
      cva co wceq cC vz cv vw cv cva co wceq wa vx cv vz cv wceq vy vw cB cB cA
      cB cin c0h wceq vx cv cA wcel vz cv cA wcel wa wa vy cv cB wcel vw cv cB
      wcel wa cC vx cv vy cv cva co wceq cC vz cv vw cv cva co wceq wa vx cv vz
      cv wceq wi cA cB cin c0h wceq vx cv cA wcel vz cv cA wcel wa wa vy cv cB
      wcel vw cv cB wcel wa wa vx cv vy cv cva co vz cv vw cv cva co wceq vx cv
      vz cv wceq cC vx cv vy cv cva co wceq cC vz cv vw cv cva co wceq wa cA cB
      cin c0h wceq vx cv cA wcel vz cv cA wcel wa wa vy cv cB wcel vw cv cB
      wcel wa wa vx cv vy cv cva co vz cv vw cv cva co wceq vx cv vz cv cmv co
      vw cv vy cv cmv co wceq vx cv vz cv wceq vx cv cA wcel vz cv cA wcel wa
      vy cv cB wcel vw cv cB wcel wa vx cv vy cv cva co vz cv vw cv cva co wceq
      vx cv vz cv cmv co vw cv vy cv cmv co wceq wb cA cB cin c0h wceq vx cv cA
      wcel vy cv cB wcel vz cv cA wcel vw cv cB wcel vx cv vy cv cva co vz cv
      vw cv cva co wceq vx cv vz cv cmv co vw cv vy cv cmv co wceq wb vx cv
      chil wcel vy cv chil wcel wa vz cv chil wcel vw cv chil wcel wa vx cv vy
      cv cva co vz cv vw cv cva co wceq vx cv vz cv cmv co vw cv vy cv cmv co
      wceq wb vx cv cA wcel vy cv cB wcel wa vz cv cA wcel vw cv cB wcel wa vx
      cv vy cv vz cv vw cv hvaddsub4 vx cv cA wcel vx cv chil wcel vy cv cB
      wcel vy cv chil wcel vx cv cA cdjreu.1 sheli vy cv cB cdjreu.2 sheli
      anim12i vz cv cA wcel vz cv chil wcel vw cv cB wcel vw cv chil wcel vz cv
      cA cdjreu.1 sheli vw cv cB cdjreu.2 sheli anim12i syl2an an4s adantll cA
      cB cin c0h wceq vx cv cA wcel vz cv cA wcel wa wa vy cv cB wcel vw cv cB
      wcel wa wa vx cv vz cv cmv co vw cv vy cv cmv co wceq vx cv vz cv cmv co
      c0h wcel vx cv vz cv wceq cA cB cin c0h wceq vx cv cA wcel vz cv cA wcel
      wa wa vy cv cB wcel vw cv cB wcel wa wa vx cv vz cv cmv co vw cv vy cv
      cmv co wceq vx cv vz cv cmv co cA wcel vx cv vz cv cmv co cB wcel wa vx
      cv vz cv cmv co c0h wcel vx cv cA wcel vz cv cA wcel wa vy cv cB wcel vw
      cv cB wcel wa vx cv vz cv cmv co vw cv vy cv cmv co wceq vx cv vz cv cmv
      co cA wcel vx cv vz cv cmv co cB wcel wa wi cA cB cin c0h wceq vx cv cA
      wcel vz cv cA wcel wa vy cv cB wcel vw cv cB wcel wa wa vx cv vz cv cmv
      co vw cv vy cv cmv co wceq vx cv vz cv cmv co cB wcel vx cv vz cv cmv co
      cA wcel vy cv cB wcel vw cv cB wcel wa vx cv vz cv cmv co vw cv vy cv cmv
      co wceq vx cv vz cv cmv co cB wcel wi vx cv cA wcel vz cv cA wcel wa vx
      cv vz cv cmv co vw cv vy cv cmv co wceq vx cv vz cv cmv co cB wcel vw cv
      vy cv cmv co cB wcel vy cv cB wcel vw cv cB wcel wa vx cv vz cv cmv co vw
      cv vy cv cmv co cB eleq1 vw cv cB wcel vy cv cB wcel vw cv vy cv cmv co
      cB wcel cB csh wcel vw cv cB wcel vy cv cB wcel wa vw cv vy cv cmv co cB
      wcel wi cdjreu.2 vw cv vy cv cB shsubclOLD ax-mp ancoms syl5cbir adantl
      vx cv cA wcel vz cv cA wcel wa vx cv vz cv cmv co cA wcel vy cv cB wcel
      vw cv cB wcel wa cA csh wcel vx cv cA wcel vz cv cA wcel wa vx cv vz cv
      cmv co cA wcel wi cdjreu.1 vx cv vz cv cA shsubclOLD ax-mp adantr jctild
      adantll cA cB cin c0h wceq vx cv vz cv cmv co cA wcel vx cv vz cv cmv co
      cB wcel wa vx cv vz cv cmv co c0h wcel wb vx cv cA wcel vz cv cA wcel wa
      vy cv cB wcel vw cv cB wcel wa cA cB cin c0h wceq vx cv vz cv cmv co cA
      cB cin wcel vx cv vz cv cmv co c0h wcel vx cv vz cv cmv co cA wcel vx cv
      vz cv cmv co cB wcel wa cA cB cin c0h vx cv vz cv cmv co eleq2 vx cv vz
      cv cmv co cA cB elin syl5bbr ad2antrr sylibd vx cv cA wcel vz cv cA wcel
      wa vx cv vz cv cmv co c0h wcel vx cv vz cv wceq wb cA cB cin c0h wceq vy
      cv cB wcel vw cv cB wcel wa vx cv chil wcel vz cv chil wcel vx cv vz cv
      cmv co c0h wcel vx cv vz cv wceq wb vx cv cA wcel vz cv cA wcel vx cv
      chil wcel vz cv chil wcel wa vx cv vz cv cmv co c0v wceq vx cv vz cv wceq
      vx cv vz cv cmv co c0h wcel vx cv vz cv hvsubeq0 vx cv vz cv cmv co elch0
      syl5bb vx cv cA cdjreu.1 sheli vz cv cA cdjreu.1 sheli syl2an ad2antlr
      sylibd sylbid cC vx cv vy cv cva co vz cv vw cv cva co eqtr2 syl5 ex
      r19.23advv cC vx cv vy cv cva co wceq cC vz cv vw cv cva co wceq vy vw cB
      cB reeanv syl5ibr ex r19.21aivv anim12i cC vx cv vy cv cva co wceq vy cB
      wrex cC vz cv vw cv cva co wceq vw cB wrex vx vz cA vx cv vz cv wceq cC
      vx cv vy cv cva co wceq vy cB wrex cC vz cv vy cv cva co wceq vy cB wrex
      cC vz cv vw cv cva co wceq vw cB wrex vx cv vz cv wceq cC vx cv vy cv cva
      co wceq cC vz cv vy cv cva co wceq vy cB vx cv vz cv wceq vx cv vy cv cva
      co vz cv vy cv cva co cC vx cv vz cv vy cv cva opreq1 eqeq2d rexbidv cC
      vz cv vy cv cva co wceq cC vz cv vw cv cva co wceq vy vw cB vy cv vw cv
      wceq vz cv vy cv cva co vz cv vw cv cva co cC vy cv vw cv vz cv cva
      opreq2 eqeq2d cbvrexv syl6bb reu4 sylibr $.
      $( [26-Jul-2005] $) $( [20-May-2005] $)
  $}

  ${
    $d x y z w A $.  $d x y z w v B $.
    cdj1.1 $e |- A e. SH $.
    cdj1.2 $e |- B e. SH $.
    $( Two ways to express " ` A ` and ` B ` are completely disjoint
       subspaces."  (1) => (2) in Lemma 5 of [Holland] p. 1520. $)
    cdj1i $p |- ( E. w e. RR ( 0 < w /\ A. y e. A A. v e. B
      ( ( normh ` y ) + ( normh ` v ) ) <_ ( w x. ( normh ` ( y +h v ) ) ) ) ->
                    E. x e. RR ( 0 < x /\ A. y e. A A. z e. B
                    ( ( normh ` y ) = 1 -> x <_ ( normh ` ( y -h z ) ) ) ) ) $=
      cc0 vw cv clt wbr vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv
      cva co cno cfv cmul co cle wbr vv cB wral vy cA wral wa cc0 vx cv clt wbr
      vy cv cno cfv c1 wceq vx cv vy cv vz cv cmv co cno cfv cle wbr wi vz cB
      wral vy cA wral wa vx cr wrex vw cr vw cv cr wcel cc0 vw cv clt wbr vy cv
      cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co
      cle wbr vv cB wral vy cA wral wa c1 vw cv cdiv co cr wcel cc0 c1 vw cv
      cdiv co clt wbr vy cv cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co
      cno cfv cle wbr wi vz cB wral vy cA wral wa wa cc0 vx cv clt wbr vy cv
      cno cfv c1 wceq vx cv vy cv vz cv cmv co cno cfv cle wbr wi vz cB wral vy
      cA wral wa vx cr wrex vw cv cr wcel cc0 vw cv clt wbr vy cv cno cfv vv cv
      cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB
      wral vy cA wral wa c1 vw cv cdiv co cr wcel cc0 c1 vw cv cdiv co clt wbr
      vy cv cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr
      wi vz cB wral vy cA wral wa wa vw cv cr wcel cc0 vw cv clt wbr vy cv cno
      cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle
      wbr vv cB wral vy cA wral wa wa c1 vw cv cdiv co cr wcel cc0 c1 vw cv
      cdiv co clt wbr vy cv cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co
      cno cfv cle wbr wi vz cB wral vy cA wral wa vw cv cr wcel cc0 vw cv clt
      wbr c1 vw cv cdiv co cr wcel vy cv cno cfv vv cv cno cfv caddc co vw cv
      vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cA wral vw cv cr
      wcel cc0 vw cv clt wbr vw cv cc0 wne c1 vw cv cdiv co cr wcel vw cv
      gt0ne0 vw cv rereccl syldan adantrr vw cv cr wcel cc0 vw cv clt wbr vy cv
      cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co
      cle wbr vv cB wral vy cA wral wa wa cc0 c1 vw cv cdiv co clt wbr vy cv
      cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr wi vz
      cB wral vy cA wral vw cv cr wcel cc0 vw cv clt wbr cc0 c1 vw cv cdiv co
      clt wbr vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno
      cfv cmul co cle wbr vv cB wral vy cA wral vw cv recgt0 adantrr vw cv cr
      wcel cc0 vw cv clt wbr vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv
      vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cA wral vy cv cno cfv
      c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr wi vz cB wral
      vy cA wral vw cv cr wcel cc0 vw cv clt wbr vy cv cno cfv vv cv cno cfv
      caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy
      cA wral vy cv cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv
      cle wbr wi vz cB wral vy cA wral wi vw cv cr wcel cc0 vw cv clt wbr wa vy
      cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul
      co cle wbr vv cB wral vy cv cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv
      cmv co cno cfv cle wbr wi vz cB wral vy cA vw cv cr wcel cc0 vw cv clt
      wbr wa vy cv cA wcel wa vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv
      vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq c1
      vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr wi vz cB vw cv cr wcel
      cc0 vw cv clt wbr wa vy cv cA wcel wa vz cv cB wcel vy cv cno cfv vv cv
      cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB
      wral vy cv cno cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv
      cle wbr wi vw cv cr wcel cc0 vw cv clt wbr wa vy cv cA wcel wa vz cv cB
      wcel vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno
      cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq c1 vw cv cdiv co vy
      cv vz cv cmv co cno cfv cle wbr vw cv cr wcel cc0 vw cv clt wbr wa vy cv
      cA wcel wa vz cv cB wcel wa vy cv cno cfv vv cv cno cfv caddc co vw cv vy
      cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq
      wa wa c1 vw cv cdiv co vw cv vy cv vz cv cmv co cno cfv cmul co vw cv
      cdiv co vy cv vz cv cmv co cno cfv cle vw cv cr wcel cc0 vw cv clt wbr wa
      vy cv cA wcel wa vz cv cB wcel wa vy cv cno cfv vv cv cno cfv caddc co vw
      cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1
      wceq wa c1 vw cv cdiv co vw cv vy cv vz cv cmv co cno cfv cmul co vw cv
      cdiv co cle wbr vw cv cr wcel cc0 vw cv clt wbr wa vy cv cA wcel wa vz cv
      cB wcel wa vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co
      cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq wa c1 vw cv vy
      cv vz cv cmv co cno cfv cmul co cle wbr c1 vw cv cdiv co vw cv vy cv vz
      cv cmv co cno cfv cmul co vw cv cdiv co cle wbr vw cv cr wcel vy cv cA
      wcel vz cv cB wcel vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv
      cva co cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq wa c1 vw
      cv vy cv vz cv cmv co cno cfv cmul co cle wbr wi cc0 vw cv clt wbr vw cv
      cr wcel vy cv cA wcel wa vz cv cB wcel wa vy cv cno cfv vv cv cno cfv
      caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy
      cv cno cfv c1 wceq wa c1 vw cv vy cv vz cv cmv co cno cfv cmul co cle wbr
      vw cv cr wcel vy cv cA wcel wa vz cv cB wcel wa vy cv cno cfv vv cv cno
      cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral
      vy cv cno cfv c1 wceq wa wa c1 c1 c1 cneg vz cv csm co cno cfv caddc co
      vw cv vy cv vz cv cmv co cno cfv cmul co c1 cr wcel vw cv cr wcel vy cv
      cA wcel wa vz cv cB wcel wa vy cv cno cfv vv cv cno cfv caddc co vw cv vy
      cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq
      wa wa 1re a1i vw cv cr wcel vy cv cA wcel wa vz cv cB wcel wa c1 c1 cneg
      vz cv csm co cno cfv caddc co cr wcel vy cv cno cfv vv cv cno cfv caddc
      co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy cv cno
      cfv c1 wceq wa vw cv cr wcel vy cv cA wcel wa vz cv cB wcel wa c1 cneg vz
      cv csm co cno cfv cr wcel c1 c1 cneg vz cv csm co cno cfv caddc co cr
      wcel vz cv cB wcel c1 cneg vz cv csm co cno cfv cr wcel vw cv cr wcel vy
      cv cA wcel wa vz cv cB wcel c1 cneg vz cv csm co chil wcel c1 cneg vz cv
      csm co cno cfv cr wcel vz cv cB wcel vz cv chil wcel c1 cneg vz cv csm co
      chil wcel vz cv cB cdj1.2 sheli c1 cneg cc wcel vz cv chil wcel c1 cneg
      vz cv csm co chil wcel c1 ax1cn negcli c1 cneg vz cv hvmulcl mpan syl c1
      cneg vz cv csm co normcl syl adantl c1 cr wcel c1 cneg vz cv csm co cno
      cfv cr wcel c1 c1 cneg vz cv csm co cno cfv caddc co cr wcel 1re c1 c1
      cneg vz cv csm co cno cfv readdcl mpan syl adantr vw cv cr wcel vy cv cA
      wcel wa vz cv cB wcel wa vw cv vy cv vz cv cmv co cno cfv cmul co cr wcel
      vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv
      cmul co cle wbr vv cB wral vy cv cno cfv c1 wceq wa vw cv cr wcel vy cv
      cA wcel vz cv cB wcel vw cv vy cv vz cv cmv co cno cfv cmul co cr wcel vw
      cv cr wcel vy cv vz cv cmv co cno cfv cr wcel vw cv vy cv vz cv cmv co
      cno cfv cmul co cr wcel vy cv cA wcel vz cv cB wcel wa vw cv vy cv vz cv
      cmv co cno cfv remulcl vy cv cA wcel vz cv cB wcel wa vy cv vz cv cmv co
      chil wcel vy cv vz cv cmv co cno cfv cr wcel vy cv chil wcel vz cv chil
      wcel vy cv vz cv cmv co chil wcel vy cv cA wcel vz cv cB wcel vy cv vz cv
      hvsubcl vy cv cA cdj1.1 sheli vz cv cB cdj1.2 sheli syl2an vy cv vz cv
      cmv co normcl syl sylan2 anassrs adantr vz cv cB wcel c1 c1 c1 cneg vz cv
      csm co cno cfv caddc co cle wbr vw cv cr wcel vy cv cA wcel wa vy cv cno
      cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle
      wbr vv cB wral vy cv cno cfv c1 wceq wa c1 cneg vz cv csm co cno cfv cr
      wcel cc0 c1 cneg vz cv csm co cno cfv cle wbr c1 c1 c1 cneg vz cv csm co
      cno cfv caddc co cle wbr vz cv cB wcel c1 cneg vz cv csm co cno cfv cr
      wcel cc0 c1 cneg vz cv csm co cno cfv cle wbr c1 c1 c1 cneg vz cv csm co
      cno cfv caddc co cle wbr c1 cr wcel c1 cneg vz cv csm co cno cfv cr wcel
      cc0 c1 cneg vz cv csm co cno cfv cle wbr c1 c1 c1 cneg vz cv csm co cno
      cfv caddc co cle wbr wb 1re c1 c1 cneg vz cv csm co cno cfv addge01 mpan
      biimpa vz cv cB wcel c1 cneg vz cv csm co chil wcel c1 cneg vz cv csm co
      cno cfv cr wcel vz cv cB wcel vz cv chil wcel c1 cneg vz cv csm co chil
      wcel vz cv cB cdj1.2 sheli c1 cneg cc wcel vz cv chil wcel c1 cneg vz cv
      csm co chil wcel c1 ax1cn negcli c1 cneg vz cv hvmulcl mpan syl c1 cneg
      vz cv csm co normcl syl vz cv cB wcel c1 cneg vz cv csm co chil wcel cc0
      c1 cneg vz cv csm co cno cfv cle wbr vz cv cB wcel vz cv chil wcel c1
      cneg vz cv csm co chil wcel vz cv cB cdj1.2 sheli c1 cneg cc wcel vz cv
      chil wcel c1 cneg vz cv csm co chil wcel c1 ax1cn negcli c1 cneg vz cv
      hvmulcl mpan syl c1 cneg vz cv csm co normge0 syl sylanc ad2antlr vw cv
      cr wcel vy cv cA wcel wa vz cv cB wcel wa vy cv cno cfv vv cv cno cfv
      caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy
      cv cno cfv c1 wceq wa wa vy cv cno cfv c1 cneg vz cv csm co cno cfv caddc
      co vw cv vy cv c1 cneg vz cv csm co cva co cno cfv cmul co c1 c1 cneg vz
      cv csm co cno cfv caddc co vw cv vy cv vz cv cmv co cno cfv cmul co cle
      vz cv cB wcel vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva
      co cno cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 cneg vz cv csm co
      cno cfv caddc co vw cv vy cv c1 cneg vz cv csm co cva co cno cfv cmul co
      cle wbr vw cv cr wcel vy cv cA wcel wa vy cv cno cfv c1 wceq vz cv cB
      wcel vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno
      cfv cmul co cle wbr vv cB wral vy cv cno cfv c1 cneg vz cv csm co cno cfv
      caddc co vw cv vy cv c1 cneg vz cv csm co cva co cno cfv cmul co cle wbr
      vz cv cB wcel c1 cneg vz cv csm co cB wcel vy cv cno cfv vv cv cno cfv
      caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv cB wral vy
      cv cno cfv c1 cneg vz cv csm co cno cfv caddc co vw cv vy cv c1 cneg vz
      cv csm co cva co cno cfv cmul co cle wbr wi c1 cneg cc wcel vz cv cB wcel
      c1 cneg vz cv csm co cB wcel c1 ax1cn negcli cB csh wcel c1 cneg cc wcel
      vz cv cB wcel wa c1 cneg vz cv csm co cB wcel wi cdj1.2 c1 cneg vz cv cB
      shmulclOLD ax-mp mpan vy cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv
      cv cva co cno cfv cmul co cle wbr vy cv cno cfv c1 cneg vz cv csm co cno
      cfv caddc co vw cv vy cv c1 cneg vz cv csm co cva co cno cfv cmul co cle
      wbr vv c1 cneg vz cv csm co cB vv cv c1 cneg vz cv csm co wceq vy cv cno
      cfv vv cv cno cfv caddc co vy cv cno cfv c1 cneg vz cv csm co cno cfv
      caddc co vw cv vy cv vv cv cva co cno cfv cmul co vw cv vy cv c1 cneg vz
      cv csm co cva co cno cfv cmul co cle vv cv c1 cneg vz cv csm co wceq vv
      cv cno cfv c1 cneg vz cv csm co cno cfv vy cv cno cfv caddc vv cv c1 cneg
      vz cv csm co cno fveq2 opreq2d vv cv c1 cneg vz cv csm co wceq vy cv vv
      cv cva co cno cfv vy cv c1 cneg vz cv csm co cva co cno cfv vw cv cmul vv
      cv c1 cneg vz cv csm co wceq vy cv vv cv cva co vy cv c1 cneg vz cv csm
      co cva co cno vv cv c1 cneg vz cv csm co vy cv cva opreq2 fveq2d opreq2d
      breq12d rcla4v syl imp ad2ant2lr vy cv cno cfv c1 wceq c1 c1 cneg vz cv
      csm co cno cfv caddc co vy cv cno cfv c1 cneg vz cv csm co cno cfv caddc
      co wceq vw cv cr wcel vy cv cA wcel wa vz cv cB wcel wa vy cv cno cfv vv
      cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv
      cB wral c1 c1 cneg vz cv csm co cno cfv caddc co vy cv cno cfv c1 cneg vz
      cv csm co cno cfv caddc co wceq c1 vy cv cno cfv c1 vy cv cno cfv c1 cneg
      vz cv csm co cno cfv caddc opreq1 eqcoms ad2antll vw cv cr wcel vy cv cA
      wcel wa vz cv cB wcel wa vw cv vy cv vz cv cmv co cno cfv cmul co vw cv
      vy cv c1 cneg vz cv csm co cva co cno cfv cmul co wceq vy cv cno cfv vv
      cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul co cle wbr vv
      cB wral vy cv cno cfv c1 wceq wa vy cv cA wcel vz cv cB wcel vw cv vy cv
      vz cv cmv co cno cfv cmul co vw cv vy cv c1 cneg vz cv csm co cva co cno
      cfv cmul co wceq vw cv cr wcel vy cv cA wcel vz cv cB wcel wa vy cv vz cv
      cmv co cno cfv vy cv c1 cneg vz cv csm co cva co cno cfv vw cv cmul vy cv
      cA wcel vz cv cB wcel wa vy cv vz cv cmv co vy cv c1 cneg vz cv csm co
      cva co cno vy cv chil wcel vz cv chil wcel vy cv vz cv cmv co vy cv c1
      cneg vz cv csm co cva co wceq vy cv cA wcel vz cv cB wcel vy cv vz cv
      hvsubval vy cv cA cdj1.1 sheli vz cv cB cdj1.2 sheli syl2an fveq2d
      opreq2d adantll adantr 3brtr4d letrd ex adantllr vw cv vy cv vz cv cmv co
      cno cfv cmul co cr wcel vw cv cr wcel wa cc0 vw cv clt wbr c1 vw cv vy cv
      vz cv cmv co cno cfv cmul co cle wbr c1 vw cv cdiv co vw cv vy cv vz cv
      cmv co cno cfv cmul co vw cv cdiv co cle wbr wb vw cv cr wcel cc0 vw cv
      clt wbr wa vy cv cA wcel wa vz cv cB wcel wa c1 cr wcel vw cv vy cv vz cv
      cmv co cno cfv cmul co cr wcel vw cv cr wcel cc0 vw cv clt wbr c1 vw cv
      vy cv vz cv cmv co cno cfv cmul co cle wbr c1 vw cv cdiv co vw cv vy cv
      vz cv cmv co cno cfv cmul co vw cv cdiv co cle wbr wb 1re c1 vw cv vy cv
      vz cv cmv co cno cfv cmul co vw cv lediv1OLD mp3anl1 vw cv cr wcel cc0 vw
      cv clt wbr wa vy cv cA wcel wa vz cv cB wcel wa vw cv vy cv vz cv cmv co
      cno cfv cmul co cr wcel vw cv cr wcel vw cv cr wcel vy cv cA wcel vz cv
      cB wcel vw cv vy cv vz cv cmv co cno cfv cmul co cr wcel cc0 vw cv clt
      wbr vw cv cr wcel vy cv cA wcel vz cv cB wcel vw cv vy cv vz cv cmv co
      cno cfv cmul co cr wcel vw cv cr wcel vy cv vz cv cmv co cno cfv cr wcel
      vw cv vy cv vz cv cmv co cno cfv cmul co cr wcel vy cv cA wcel vz cv cB
      wcel wa vw cv vy cv vz cv cmv co cno cfv remulcl vy cv cA wcel vz cv cB
      wcel wa vy cv vz cv cmv co chil wcel vy cv vz cv cmv co cno cfv cr wcel
      vy cv chil wcel vz cv chil wcel vy cv vz cv cmv co chil wcel vy cv cA
      wcel vz cv cB wcel vy cv vz cv hvsubcl vy cv cA cdj1.1 sheli vz cv cB
      cdj1.2 sheli syl2an vy cv vz cv cmv co normcl syl sylan2 anassrs adantllr
      vw cv cr wcel cc0 vw cv clt wbr wa vw cv cr wcel vy cv cA wcel vz cv cB
      wcel vw cv cr wcel cc0 vw cv clt wbr pm3.26 ad2antrr jca vw cv cr wcel
      cc0 vw cv clt wbr wa cc0 vw cv clt wbr vy cv cA wcel vz cv cB wcel vw cv
      cr wcel cc0 vw cv clt wbr pm3.27 ad2antrr sylanc sylibd imp vw cv cr wcel
      cc0 vw cv clt wbr wa vy cv cA wcel wa vz cv cB wcel wa vw cv vy cv vz cv
      cmv co cno cfv cmul co vw cv cdiv co vy cv vz cv cmv co cno cfv wceq vy
      cv cno cfv vv cv cno cfv caddc co vw cv vy cv vv cv cva co cno cfv cmul
      co cle wbr vv cB wral vy cv cno cfv c1 wceq wa vy cv vz cv cmv co cno cfv
      cc wcel vw cv cc wcel vw cv cc0 wne vw cv vy cv vz cv cmv co cno cfv cmul
      co vw cv cdiv co vy cv vz cv cmv co cno cfv wceq vw cv cr wcel cc0 vw cv
      clt wbr wa vy cv cA wcel wa vz cv cB wcel wa vy cv vz cv cmv co cno cfv
      vw cv divcan3 vy cv cA wcel vz cv cB wcel vy cv vz cv cmv co cno cfv cc
      wcel vw cv cr wcel cc0 vw cv clt wbr wa vy cv cA wcel vz cv cB wcel wa vy
      cv vz cv cmv co cno cfv vy cv cA wcel vz cv cB wcel wa vy cv vz cv cmv co
      chil wcel vy cv vz cv cmv co cno cfv cr wcel vy cv chil wcel vz cv chil
      wcel vy cv vz cv cmv co chil wcel vy cv cA wcel vz cv cB wcel vy cv vz cv
      hvsubcl vy cv cA cdj1.1 sheli vz cv cB cdj1.2 sheli syl2an vy cv vz cv
      cmv co normcl syl recnd adantll vw cv cr wcel cc0 vw cv clt wbr wa vw cv
      cc wcel vy cv cA wcel vz cv cB wcel vw cv cr wcel vw cv cc wcel cc0 vw cv
      clt wbr vw cv recn adantr ad2antrr vw cv cr wcel cc0 vw cv clt wbr wa vw
      cv cc0 wne vy cv cA wcel vz cv cB wcel vw cv gt0ne0 ad2antrr syl3anc
      adantr breqtrd exp43 com23 r19.21adv r19.20dva ex imp32 jca jca ex cc0 vx
      cv clt wbr vy cv cno cfv c1 wceq vx cv vy cv vz cv cmv co cno cfv cle wbr
      wi vz cB wral vy cA wral wa cc0 c1 vw cv cdiv co clt wbr vy cv cno cfv c1
      wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr wi vz cB wral vy
      cA wral wa vx c1 vw cv cdiv co cr vx cv c1 vw cv cdiv co wceq cc0 vx cv
      clt wbr cc0 c1 vw cv cdiv co clt wbr vy cv cno cfv c1 wceq vx cv vy cv vz
      cv cmv co cno cfv cle wbr wi vz cB wral vy cA wral vy cv cno cfv c1 wceq
      c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr wi vz cB wral vy cA
      wral vx cv c1 vw cv cdiv co cc0 clt breq2 vx cv c1 vw cv cdiv co wceq vy
      cv cno cfv c1 wceq vx cv vy cv vz cv cmv co cno cfv cle wbr wi vy cv cno
      cfv c1 wceq c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr wi vy vz
      cA cB vx cv c1 vw cv cdiv co wceq vx cv vy cv vz cv cmv co cno cfv cle
      wbr c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle wbr vy cv cno cfv c1
      wceq vx cv c1 vw cv cdiv co vy cv vz cv cmv co cno cfv cle breq1 imbi2d
      2ralbidv anbi12d rcla4ev syl6 r19.23aiv $.
      $( [6-Oct-2006] $) $( [21-May-2005] $)

    $( A property of " ` A ` and ` B ` are completely disjoint subspaces."
       Part of Lemma 5 of [Holland] p. 1520. $)
    cdj3lem1 $p |- ( E. x e. RR ( 0 < x /\ A. y e. A A. z e. B
      ( ( normh ` y ) + ( normh ` z ) ) <_ ( x x. ( normh ` ( y +h z ) ) ) ) ->
                    ( A i^i B ) = 0H ) $=
      cc0 vx cv clt wbr vy cv cno cfv vz cv cno cfv caddc co vx cv vy cv vz cv
      cva co cno cfv cmul co cle wbr vz cB wral vy cA wral wa cA cB cin c0h
      wceq vx cr vx cv cr wcel vy cv cno cfv vz cv cno cfv caddc co vx cv vy cv
      vz cv cva co cno cfv cmul co cle wbr vz cB wral vy cA wral cA cB cin c0h
      wceq cc0 vx cv clt wbr vx cv cr wcel vy cv cno cfv vz cv cno cfv caddc co
      vx cv vy cv vz cv cva co cno cfv cmul co cle wbr vz cB wral vy cA wral cA
      cB cin c0h wss cA cB cin c0h wceq vx cv cr wcel vy cv cno cfv vz cv cno
      cfv caddc co vx cv vy cv vz cv cva co cno cfv cmul co cle wbr vz cB wral
      vy cA wral cA cB cin c0h wss vx cv cr wcel vy cv cno cfv vz cv cno cfv
      caddc co vx cv vy cv vz cv cva co cno cfv cmul co cle wbr vz cB wral vy
      cA wral wa vw cA cB cin c0h vx cv cr wcel vy cv cno cfv vz cv cno cfv
      caddc co vx cv vy cv vz cv cva co cno cfv cmul co cle wbr vz cB wral vy
      cA wral wa vw cv cA cB cin wcel vw cv c0v wceq vw cv c0h wcel vx cv cr
      wcel vy cv cno cfv vz cv cno cfv caddc co vx cv vy cv vz cv cva co cno
      cfv cmul co cle wbr vz cB wral vy cA wral vw cv cA cB cin wcel vw cv c0v
      wceq wi vx cv cr wcel vw cv cA cB cin wcel vy cv cno cfv vz cv cno cfv
      caddc co vx cv vy cv vz cv cva co cno cfv cmul co cle wbr vz cB wral vy
      cA wral vw cv c0v wceq vx cv cr wcel vw cv cA cB cin wcel vy cv cno cfv
      vz cv cno cfv caddc co vx cv vy cv vz cv cva co cno cfv cmul co cle wbr
      vz cB wral vy cA wral vw cv c0v wceq wi vx cv cr wcel vw cv cA cB cin
      wcel wa vy cv cno cfv vz cv cno cfv caddc co vx cv vy cv vz cv cva co cno
      cfv cmul co cle wbr vz cB wral vy cA wral vw cv cno cfv c1 cneg vw cv csm
      co cno cfv caddc co vx cv vw cv c1 cneg vw cv csm co cva co cno cfv cmul
      co cle wbr vw cv c0v wceq vw cv cA cB cin wcel vy cv cno cfv vz cv cno
      cfv caddc co vx cv vy cv vz cv cva co cno cfv cmul co cle wbr vz cB wral
      vy cA wral vw cv cno cfv c1 cneg vw cv csm co cno cfv caddc co vx cv vw
      cv c1 cneg vw cv csm co cva co cno cfv cmul co cle wbr wi vx cv cr wcel
      vw cv cA cB cin wcel vw cv cA wcel c1 cneg vw cv csm co cB wcel wa vy cv
      cno cfv vz cv cno cfv caddc co vx cv vy cv vz cv cva co cno cfv cmul co
      cle wbr vz cB wral vy cA wral vw cv cno cfv c1 cneg vw cv csm co cno cfv
      caddc co vx cv vw cv c1 cneg vw cv csm co cva co cno cfv cmul co cle wbr
      wi vw cv cA cB cin wcel vw cv cA wcel vw cv cB wcel wa vw cv cA wcel c1
      cneg vw cv csm co cB wcel wa vw cv cA cB elin vw cv cB wcel c1 cneg vw cv
      csm co cB wcel vw cv cA wcel c1 cneg cc wcel vw cv cB wcel c1 cneg vw cv
      csm co cB wcel c1 ax1cn negcli cB csh wcel c1 cneg cc wcel vw cv cB wcel
      wa c1 cneg vw cv csm co cB wcel wi cdj1.2 c1 cneg vw cv cB shmulclOLD
      ax-mp mpan anim2i sylbi vy cv cno cfv vz cv cno cfv caddc co vx cv vy cv
      vz cv cva co cno cfv cmul co cle wbr vw cv cno cfv c1 cneg vw cv csm co
      cno cfv caddc co vx cv vw cv c1 cneg vw cv csm co cva co cno cfv cmul co
      cle wbr vw cv cno cfv vz cv cno cfv caddc co vx cv vw cv vz cv cva co cno
      cfv cmul co cle wbr vy vz vw cv c1 cneg vw cv csm co cA cB vy cv vw cv
      wceq vy cv cno cfv vz cv cno cfv caddc co vw cv cno cfv vz cv cno cfv
      caddc co vx cv vy cv vz cv cva co cno cfv cmul co vx cv vw cv vz cv cva
      co cno cfv cmul co cle vy cv vw cv wceq vy cv cno cfv vw cv cno cfv vz cv
      cno cfv caddc vy cv vw cv cno fveq2 opreq1d vy cv vw cv wceq vy cv vz cv
      cva co cno cfv vw cv vz cv cva co cno cfv vx cv cmul vy cv vw cv wceq vy
      cv vz cv cva co vw cv vz cv cva co cno vy cv vw cv vz cv cva opreq1
      fveq2d opreq2d breq12d vz cv c1 cneg vw cv csm co wceq vw cv cno cfv vz
      cv cno cfv caddc co vw cv cno cfv c1 cneg vw cv csm co cno cfv caddc co
      vx cv vw cv vz cv cva co cno cfv cmul co vx cv vw cv c1 cneg vw cv csm co
      cva co cno cfv cmul co cle vz cv c1 cneg vw cv csm co wceq vz cv cno cfv
      c1 cneg vw cv csm co cno cfv vw cv cno cfv caddc vz cv c1 cneg vw cv csm
      co cno fveq2 opreq2d vz cv c1 cneg vw cv csm co wceq vw cv vz cv cva co
      cno cfv vw cv c1 cneg vw cv csm co cva co cno cfv vx cv cmul vz cv c1
      cneg vw cv csm co wceq vw cv vz cv cva co vw cv c1 cneg vw cv csm co cva
      co cno vz cv c1 cneg vw cv csm co vw cv cva opreq2 fveq2d opreq2d breq12d
      rcla42v syl adantl vx cv cr wcel vw cv chil wcel vw cv cno cfv c1 cneg vw
      cv csm co cno cfv caddc co vx cv vw cv c1 cneg vw cv csm co cva co cno
      cfv cmul co cle wbr vw cv c0v wceq wb vw cv cA cB cin wcel vx cv cr wcel
      vw cv chil wcel wa vw cv cno cfv c1 cneg vw cv csm co cno cfv caddc co vx
      cv vw cv c1 cneg vw cv csm co cva co cno cfv cmul co cle wbr c2 vw cv cno
      cfv cmul co c2 cc0 cmul co cle wbr vw cv c0v wceq vx cv cr wcel vw cv
      chil wcel wa vw cv cno cfv c1 cneg vw cv csm co cno cfv caddc co c2 vw cv
      cno cfv cmul co vx cv vw cv c1 cneg vw cv csm co cva co cno cfv cmul co
      c2 cc0 cmul co cle vw cv chil wcel vw cv cno cfv c1 cneg vw cv csm co cno
      cfv caddc co c2 vw cv cno cfv cmul co wceq vx cv cr wcel vw cv chil wcel
      vw cv cno cfv c1 cneg vw cv csm co cno cfv caddc co vw cv cno cfv vw cv
      cno cfv caddc co c2 vw cv cno cfv cmul co vw cv chil wcel c1 cneg vw cv
      csm co cno cfv vw cv cno cfv vw cv cno cfv caddc vw cv normneg opreq2d vw
      cv chil wcel vw cv cno cfv cc wcel c2 vw cv cno cfv cmul co vw cv cno cfv
      vw cv cno cfv caddc co wceq vw cv chil wcel vw cv cno cfv vw cv normcl
      recnd vw cv cno cfv 2times syl eqtr4d adantl vx cv cr wcel vw cv chil
      wcel wa vx cv vw cv c1 cneg vw cv csm co cva co cno cfv cmul co cc0 c2
      cc0 cmul co vw cv chil wcel vx cv cr wcel vx cv vw cv c1 cneg vw cv csm
      co cva co cno cfv cmul co vx cv cc0 cmul co cc0 vw cv chil wcel vw cv c1
      cneg vw cv csm co cva co cno cfv cc0 vx cv cmul vw cv chil wcel vw cv c1
      cneg vw cv csm co cva co cno cfv c0v cno cfv cc0 vw cv chil wcel vw cv c1
      cneg vw cv csm co cva co c0v cno vw cv hvnegid fveq2d norm0 syl6eq
      opreq2d vx cv cr wcel vx cv cc wcel vx cv cc0 cmul co cc0 wceq vx cv recn
      vx cv mul01 syl sylan9eqr c2 2cn mul01i syl6eqr breq12d vw cv chil wcel
      c2 vw cv cno cfv cmul co c2 cc0 cmul co cle wbr vw cv c0v wceq wb vx cv
      cr wcel vw cv chil wcel c2 vw cv cno cfv cmul co c2 cc0 cmul co cle wbr
      vw cv cno cfv cc0 cle wbr cc0 vw cv cno cfv cle wbr wa vw cv cno cfv cc0
      wceq vw cv c0v wceq vw cv chil wcel vw cv cno cfv cc0 cle wbr c2 vw cv
      cno cfv cmul co c2 cc0 cmul co cle wbr vw cv cno cfv cc0 cle wbr cc0 vw
      cv cno cfv cle wbr wa vw cv chil wcel vw cv cno cfv cr wcel vw cv cno cfv
      cc0 cle wbr c2 vw cv cno cfv cmul co c2 cc0 cmul co cle wbr wb vw cv
      normcl vw cv cno cfv cr wcel cc0 cr wcel c2 cr wcel vw cv cno cfv cc0 cle
      wbr c2 vw cv cno cfv cmul co c2 cc0 cmul co cle wbr wb 0re 2re vw cv cno
      cfv cr wcel cc0 cr wcel c2 cr wcel w3a cc0 c2 clt wbr vw cv cno cfv cc0
      cle wbr c2 vw cv cno cfv cmul co c2 cc0 cmul co cle wbr wb 2pos vw cv cno
      cfv cc0 c2 lemul2OLD mpan2 mp3an23 syl vw cv chil wcel cc0 vw cv cno cfv
      cle wbr vw cv cno cfv cc0 cle wbr vw cv normge0 biantrud bitr3d vw cv
      chil wcel vw cv cno cfv cr wcel vw cv cno cfv cc0 wceq vw cv cno cfv cc0
      cle wbr cc0 vw cv cno cfv cle wbr wa wb vw cv normcl vw cv cno cfv cr
      wcel cc0 cr wcel vw cv cno cfv cc0 wceq vw cv cno cfv cc0 cle wbr cc0 vw
      cv cno cfv cle wbr wa wb 0re vw cv cno cfv cc0 letri3 mpan2 syl vw cv
      norm-i 3bitr2d adantl bitrd vw cv cA cB cin cA cB cdj1.1 cdj1.2 shincli
      sheli sylan2 sylibd ex com23 imp vw cv elch0 syl6ibr ssrdv ex cA cB cin
      csh wcel cA cB cin c0h wss cA cB cin c0h wceq wb cA cB cdj1.1 cdj1.2
      shincli cA cB cin shle0 ax-mp syl6ib adantld r19.23aiv $.
      $( [23-May-2005] $) $( [23-May-2005] $)
  $}

  ${
    $d x y z w v u t h A $.  $d x y z w v u t h B $.  $d x y z w v u C $.
    $d x y z w D $.
    cdj3lem2.1 $e |- A e. SH $.
    cdj3lem2.2 $e |- B e. SH $.
    ${
      $d v u t h S $.
      cdj3lem2.3 $e |- S = { <. x , y >. | ( x e. ( A +H B ) /\
                     y = U. { z e. A | E. w e. B x = ( z +h w ) } ) } $.
      $( Lemma for ~ cdj3i .  Value of the first-component function ` S ` . $)
      cdj3lem2 $p |- ( ( C e. A /\ D e. B /\ ( A i^i B ) = 0H ) ->
                    ( S ` ( C +h D ) ) = C ) $=
        cC cA wcel cD cB wcel cA cB cin c0h wceq w3a cC cD cva co cS cfv cC cD
        cva co vz cv vw cv cva co wceq vw cB wrex vz cA crab cuni cC cC cA wcel
        cD cB wcel cC cD cva co cS cfv cC cD cva co vz cv vw cv cva co wceq vw
        cB wrex vz cA crab cuni wceq cA cB cin c0h wceq cC cA wcel cD cB wcel
        wa cC cD cva co cA cB cph co wcel cC cD cva co cS cfv cC cD cva co vz
        cv vw cv cva co wceq vw cB wrex vz cA crab cuni wceq cA cB cC cD
        cdj3lem2.1 cdj3lem2.2 shsvai vx vy cC cD cva co vx cv vz cv vw cv cva
        co wceq vw cB wrex vz cA crab cuni cC cD cva co vz cv vw cv cva co wceq
        vw cB wrex vz cA crab cuni cA cB cph co cS vx cv cC cD cva co wceq vx
        cv vz cv vw cv cva co wceq vw cB wrex vz cA crab cC cD cva co vz cv vw
        cv cva co wceq vw cB wrex vz cA crab vx cv cC cD cva co wceq vx cv vz
        cv vw cv cva co wceq vw cB wrex cC cD cva co vz cv vw cv cva co wceq vw
        cB wrex vz cA vx cv cC cD cva co wceq vx cv vz cv vw cv cva co wceq cC
        cD cva co vz cv vw cv cva co wceq vw cB vx cv cC cD cva co vz cv vw cv
        cva co eqeq1 rexbidv rabbisdv unieqd cdj3lem2.3 cC cD cva co vz cv vw
        cv cva co wceq vw cB wrex vz cA crab cC cD cva co vz cv vw cv cva co
        wceq vw cB wrex vz cA cA csh cdj3lem2.1 elisseti rabex uniex fvopab4
        syl 3adant3 cC cA wcel cD cB wcel cA cB cin c0h wceq w3a cC cD cva co
        cC vw cv cva co wceq vw cB wrex cC cD cva co vz cv vw cv cva co wceq vw
        cB wrex vz cA crab cuni cC wceq cD cB wcel cC cA wcel cC cD cva co cC
        vw cv cva co wceq vw cB wrex cA cB cin c0h wceq cD cB wcel cC cD cva co
        cC cD cva co wceq cC cD cva co cC vw cv cva co wceq vw cB wrex cC cD
        cva co eqid cC cD cva co cC vw cv cva co wceq cC cD cva co cC cD cva co
        wceq vw cD cB vw cv cD wceq cC vw cv cva co cC cD cva co cC cD cva co
        vw cv cD cC cva opreq2 eqeq2d rcla4ev mpan2 3ad2ant2 cC cA wcel cC cD
        cva co vz cv vw cv cva co wceq vw cB wrex vz cA wreu cC cD cva co cC vw
        cv cva co wceq vw cB wrex cC cD cva co vz cv vw cv cva co wceq vw cB
        wrex vz cA crab cuni cC wceq wb cC cA wcel cD cB wcel cA cB cin c0h
        wceq w3a cC cD cva co vz cv vw cv cva co wceq vw cB wrex cC cD cva co
        cC vw cv cva co wceq vw cB wrex vz cA cC vz cv cC wceq cC cD cva co vz
        cv vw cv cva co wceq cC cD cva co cC vw cv cva co wceq vw cB vz cv cC
        wceq vz cv vw cv cva co cC vw cv cva co cC cD cva co vz cv cC vw cv cva
        opreq1 eqeq2d rexbidv reuuni2 cC cA wcel cD cB wcel cA cB cin c0h wceq
        3simp1 cC cA wcel cD cB wcel cA cB cin c0h wceq cC cD cva co vz cv vw
        cv cva co wceq vw cB wrex vz cA wreu cC cD cva co cA cB cph co wcel cA
        cB cin c0h wceq cC cD cva co vz cv vw cv cva co wceq vw cB wrex vz cA
        wreu cC cA wcel cD cB wcel wa vz vw cA cB cC cD cva co cdj3lem2.1
        cdj3lem2.2 cdjreui cA cB cC cD cdj3lem2.1 cdj3lem2.2 shsvai sylan 3impa
        sylanc mpbid eqtrd $.
        $( [23-May-2005] $) $( [23-May-2005] $)

      $( Lemma for ~ cdj3i .  Closure of the first-component function
         ` S ` . $)
      cdj3lem2a $p |- ( ( C e. ( A +H B ) /\ ( A i^i B ) = 0H ) ->
                    ( S ` C ) e. A ) $=
        cA cB cin c0h wceq cC cA cB cph co wcel cC cS cfv cA wcel cA cB cin c0h
        wceq cC vv cv vu cv cva co wceq vu cB wrex vv cA wrex cC cS cfv cA wcel
        cC cA cB cph co wcel cA cB cin c0h wceq cC vv cv vu cv cva co wceq cC
        cS cfv cA wcel vv vu cA cB cC vv cv vu cv cva co wceq vv cv cA wcel vu
        cv cB wcel wa cA cB cin c0h wceq cC cS cfv cA wcel cC vv cv vu cv cva
        co wceq vv cv cA wcel vu cv cB wcel wa cA cB cin c0h wceq cC cS cfv cA
        wcel cC vv cv vu cv cva co wceq cC cS cfv cA wcel vv cv vu cv cva co cS
        cfv cA wcel vv cv cA wcel vu cv cB wcel wa cA cB cin c0h wceq wa cC vv
        cv vu cv cva co wceq cC cS cfv vv cv vu cv cva co cS cfv cA cC vv cv vu
        cv cva co cS fveq2 eleq1d vv cv cA wcel vu cv cB wcel cA cB cin c0h
        wceq vv cv vu cv cva co cS cfv cA wcel vv cv cA wcel vu cv cB wcel cA
        cB cin c0h wceq w3a vv cv vu cv cva co cS cfv vv cv cA vx vy vz vw cA
        cB vv cv vu cv cS cdj3lem2.1 cdj3lem2.2 cdj3lem2.3 cdj3lem2 vv cv cA
        wcel vu cv cB wcel cA cB cin c0h wceq 3simp1 eqeltrd 3expa syl5bir
        exp3a com13 r19.23advv vv vu cA cB cC cdj3lem2.1 cdj3lem2.2 shseli
        syl5ib impcom $.
        $( [25-May-2005] $) $( [25-May-2005] $)

      $( Lemma for ~ cdj3i .  The first-component function ` S ` is bounded if
         the subspaces are completely disjoint. $)
      cdj3lem2b $p |- ( E. v e. RR ( 0 < v /\ A. x e. A A. y e. B
      ( ( normh ` x ) + ( normh ` y ) ) <_ ( v x. ( normh ` ( x +h y ) ) ) ) ->
                    E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( S ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $=
        cA cB cin c0h wceq cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc
        co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA
        wral wa vv cr wrex cc0 vv cv clt wbr vu cv cS cfv cno cfv vv cv vu cv
        cno cfv cmul co cle wbr vu cA cB cph co wral wa vv cr wrex vv vx vy cA
        cB cdj3lem2.1 cdj3lem2.2 cdj3lem1 cA cB cin c0h wceq cc0 vv cv clt wbr
        vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv
        cmul co cle wbr vy cB wral vx cA wral wa cc0 vv cv clt wbr vu cv cS cfv
        cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vv
        cr cA cB cin c0h wceq vv cv cr wcel wa vx cv cno cfv vy cv cno cfv
        caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx
        cA wral vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA
        cB cph co wral cc0 vv cv clt wbr cA cB cin c0h wceq vv cv cr wcel wa vx
        cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul
        co cle wbr vy cB wral vx cA wral vu cv cS cfv cno cfv vv cv vu cv cno
        cfv cmul co cle wbr vu cA cB cph co vu cv cA cB cph co wcel cA cB cin
        c0h wceq vv cv cr wcel wa vx cv cno cfv vy cv cno cfv caddc co vv cv vx
        cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral vu cv cS
        cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cv cA cB cph co wcel
        cA cB cin c0h wceq vv cv cr wcel wa vx cv cno cfv vy cv cno cfv caddc
        co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA
        wral vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr wi vu cv
        cA cB cph co wcel cA cB cin c0h wceq vv cv cr wcel wa wa vu cv vt cv vh
        cv cva co wceq vh cB wrex vt cA wrex vx cv cno cfv vy cv cno cfv caddc
        co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA
        wral vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr wi vu cv
        cA cB cph co wcel cA cB cin c0h wceq vu cv vt cv vh cv cva co wceq vh
        cB wrex vt cA wrex vv cv cr wcel vu cv cA cB cph co wcel cA cB cin c0h
        wceq wa vu cv vt cv vh cv cva co wceq vh cB wrex vt cA wreu vu cv vt cv
        vh cv cva co wceq vh cB wrex vt cA wrex vt vh cA cB vu cv cdj3lem2.1
        cdj3lem2.2 cdjreui vu cv vt cv vh cv cva co wceq vh cB wrex vt cA
        reurex syl adantrr cA cB cin c0h wceq vv cv cr wcel wa vu cv vt cv vh
        cv cva co wceq vh cB wrex vt cA wrex vx cv cno cfv vy cv cno cfv caddc
        co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA
        wral vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr wi wi vu
        cv cA cB cph co wcel cA cB cin c0h wceq vv cv cr wcel wa vu cv vt cv vh
        cv cva co wceq vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv
        cva co cno cfv cmul co cle wbr vy cB wral vx cA wral vu cv cS cfv cno
        cfv vv cv vu cv cno cfv cmul co cle wbr wi vt vh cA cB vu cv vt cv vh
        cv cva co wceq vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv
        cva co cno cfv cmul co cle wbr vy cB wral vx cA wral cA cB cin c0h wceq
        vv cv cr wcel wa vt cv cA wcel vh cv cB wcel wa vu cv cS cfv cno cfv vv
        cv vu cv cno cfv cmul co cle wbr vt cv cA wcel vh cv cB wcel wa vx cv
        cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co
        cle wbr vy cB wral vx cA wral cA cB cin c0h wceq vv cv cr wcel wa vu cv
        vt cv vh cv cva co wceq vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul
        co cle wbr vt cv cA wcel vh cv cB wcel wa vx cv cno cfv vy cv cno cfv
        caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx
        cA wral vt cv cno cfv vh cv cno cfv caddc co vv cv vt cv vh cv cva co
        cno cfv cmul co cle wbr cA cB cin c0h wceq vv cv cr wcel wa vu cv vt cv
        vh cv cva co wceq vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle
        wbr wi wi vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co
        cno cfv cmul co cle wbr vt cv cno cfv vh cv cno cfv caddc co vv cv vt
        cv vh cv cva co cno cfv cmul co cle wbr vt cv cno cfv vy cv cno cfv
        caddc co vv cv vt cv vy cv cva co cno cfv cmul co cle wbr vx vy vt cv
        vh cv cA cB vx cv vt cv wceq vx cv cno cfv vy cv cno cfv caddc co vt cv
        cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co
        vv cv vt cv vy cv cva co cno cfv cmul co cle vx cv vt cv wceq vx cv cno
        cfv vt cv cno cfv vy cv cno cfv caddc vx cv vt cv cno fveq2 opreq1d vx
        cv vt cv wceq vx cv vy cv cva co cno cfv vt cv vy cv cva co cno cfv vv
        cv cmul vx cv vt cv wceq vx cv vy cv cva co vt cv vy cv cva co cno vx
        cv vt cv vy cv cva opreq1 fveq2d opreq2d breq12d vy cv vh cv wceq vt cv
        cno cfv vy cv cno cfv caddc co vt cv cno cfv vh cv cno cfv caddc co vv
        cv vt cv vy cv cva co cno cfv cmul co vv cv vt cv vh cv cva co cno cfv
        cmul co cle vy cv vh cv wceq vy cv cno cfv vh cv cno cfv vt cv cno cfv
        caddc vy cv vh cv cno fveq2 opreq2d vy cv vh cv wceq vt cv vy cv cva co
        cno cfv vt cv vh cv cva co cno cfv vv cv cmul vy cv vh cv wceq vt cv vy
        cv cva co vt cv vh cv cva co cno vy cv vh cv vt cv cva opreq2 fveq2d
        opreq2d breq12d rcla42v vt cv cA wcel vh cv cB wcel wa vt cv cno cfv vh
        cv cno cfv caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr cA
        cB cin c0h wceq vv cv cr wcel wa vu cv vt cv vh cv cva co wceq vu cv cS
        cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr wi vu cv vt cv vh cv
        cva co wceq vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vt
        cv vh cv cva co cS cfv cno cfv vv cv vt cv vh cv cva co cno cfv cmul co
        cle wbr vt cv cA wcel vh cv cB wcel wa vt cv cno cfv vh cv cno cfv
        caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr wa cA cB cin
        c0h wceq vv cv cr wcel wa wa vu cv vt cv vh cv cva co wceq vu cv cS cfv
        cno cfv vt cv vh cv cva co cS cfv cno cfv vv cv vu cv cno cfv cmul co
        vv cv vt cv vh cv cva co cno cfv cmul co cle vu cv vt cv vh cv cva co
        wceq vu cv cS cfv vt cv vh cv cva co cS cfv cno vu cv vt cv vh cv cva
        co cS fveq2 fveq2d vu cv vt cv vh cv cva co wceq vu cv cno cfv vt cv vh
        cv cva co cno cfv vv cv cmul vu cv vt cv vh cv cva co cno fveq2 opreq2d
        breq12d vt cv cA wcel vh cv cB wcel wa vt cv cno cfv vh cv cno cfv
        caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr wa cA cB cin
        c0h wceq vv cv cr wcel wa wa vt cv vh cv cva co cS cfv cno cfv vt cv
        cno cfv vv cv vt cv vh cv cva co cno cfv cmul co cle vt cv cA wcel vh
        cv cB wcel wa cA cB cin c0h wceq vt cv vh cv cva co cS cfv cno cfv vt
        cv cno cfv wceq vt cv cno cfv vh cv cno cfv caddc co vv cv vt cv vh cv
        cva co cno cfv cmul co cle wbr vv cv cr wcel vt cv cA wcel vh cv cB
        wcel wa cA cB cin c0h wceq wa vt cv vh cv cva co cS cfv vt cv cno vt cv
        cA wcel vh cv cB wcel cA cB cin c0h wceq vt cv vh cv cva co cS cfv vt
        cv wceq vx vy vz vw cA cB vt cv vh cv cS cdj3lem2.1 cdj3lem2.2
        cdj3lem2.3 cdj3lem2 3expa fveq2d ad2ant2r vt cv cA wcel vh cv cB wcel
        wa vt cv cno cfv vh cv cno cfv caddc co vv cv vt cv vh cv cva co cno
        cfv cmul co cle wbr wa vv cv cr wcel vt cv cno cfv vv cv vt cv vh cv
        cva co cno cfv cmul co cle wbr cA cB cin c0h wceq vt cv cA wcel vh cv
        cB wcel wa vv cv cr wcel vt cv cno cfv vh cv cno cfv caddc co vv cv vt
        cv vh cv cva co cno cfv cmul co cle wbr vt cv cno cfv vv cv vt cv vh cv
        cva co cno cfv cmul co cle wbr vt cv cA wcel vh cv cB wcel wa vv cv cr
        wcel wa vt cv cno cfv vh cv cno cfv caddc co vv cv vt cv vh cv cva co
        cno cfv cmul co cle wbr vt cv cno cfv vv cv vt cv vh cv cva co cno cfv
        cmul co cle wbr vt cv cA wcel vh cv cB wcel wa vv cv cr wcel wa vt cv
        cno cfv vt cv cno cfv vh cv cno cfv caddc co cle wbr vt cv cno cfv vh
        cv cno cfv caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr vt
        cv cno cfv vv cv vt cv vh cv cva co cno cfv cmul co cle wbr vt cv cA
        wcel vh cv cB wcel wa vt cv cno cfv vt cv cno cfv vh cv cno cfv caddc
        co cle wbr vv cv cr wcel vt cv cA wcel vh cv cB wcel wa cc0 vh cv cno
        cfv cle wbr vt cv cno cfv vt cv cno cfv vh cv cno cfv caddc co cle wbr
        vh cv cB wcel cc0 vh cv cno cfv cle wbr vt cv cA wcel vh cv cB wcel vh
        cv chil wcel cc0 vh cv cno cfv cle wbr vh cv cB cdj3lem2.2 sheli vh cv
        normge0 syl adantl vt cv cno cfv cr wcel vh cv cno cfv cr wcel cc0 vh
        cv cno cfv cle wbr vt cv cno cfv vt cv cno cfv vh cv cno cfv caddc co
        cle wbr wb vt cv cA wcel vh cv cB wcel vt cv cno cfv vh cv cno cfv
        addge01 vt cv cA wcel vt cv chil wcel vt cv cno cfv cr wcel vt cv cA
        cdj3lem2.1 sheli vt cv normcl syl vh cv cB wcel vh cv chil wcel vh cv
        cno cfv cr wcel vh cv cB cdj3lem2.2 sheli vh cv normcl syl syl2an mpbid
        adantr vt cv cno cfv cr wcel vt cv cno cfv vh cv cno cfv caddc co cr
        wcel vv cv vt cv vh cv cva co cno cfv cmul co cr wcel vt cv cno cfv vt
        cv cno cfv vh cv cno cfv caddc co cle wbr vt cv cno cfv vh cv cno cfv
        caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno
        cfv vv cv vt cv vh cv cva co cno cfv cmul co cle wbr wi vt cv cA wcel
        vh cv cB wcel wa vv cv cr wcel wa vt cv cno cfv vt cv cno cfv vh cv cno
        cfv caddc co vv cv vt cv vh cv cva co cno cfv cmul co letr vt cv cA
        wcel vt cv cno cfv cr wcel vh cv cB wcel vv cv cr wcel vt cv cA wcel vt
        cv chil wcel vt cv cno cfv cr wcel vt cv cA cdj3lem2.1 sheli vt cv
        normcl syl ad2antrr vt cv cA wcel vh cv cB wcel wa vt cv cno cfv vh cv
        cno cfv caddc co cr wcel vv cv cr wcel vt cv cno cfv cr wcel vh cv cno
        cfv cr wcel vt cv cno cfv vh cv cno cfv caddc co cr wcel vt cv cA wcel
        vh cv cB wcel vt cv cno cfv vh cv cno cfv readdcl vt cv cA wcel vt cv
        chil wcel vt cv cno cfv cr wcel vt cv cA cdj3lem2.1 sheli vt cv normcl
        syl vh cv cB wcel vh cv chil wcel vh cv cno cfv cr wcel vh cv cB
        cdj3lem2.2 sheli vh cv normcl syl syl2an adantr vv cv cr wcel vt cv cA
        wcel vh cv cB wcel wa vv cv vt cv vh cv cva co cno cfv cmul co cr wcel
        vv cv cr wcel vt cv vh cv cva co cno cfv cr wcel vv cv vt cv vh cv cva
        co cno cfv cmul co cr wcel vt cv cA wcel vh cv cB wcel wa vv cv vt cv
        vh cv cva co cno cfv remulcl vt cv cA wcel vh cv cB wcel wa vt cv vh cv
        cva co chil wcel vt cv vh cv cva co cno cfv cr wcel vt cv chil wcel vh
        cv chil wcel vt cv vh cv cva co chil wcel vt cv cA wcel vh cv cB wcel
        vt cv vh cv hvaddcl vt cv cA cdj3lem2.1 sheli vh cv cB cdj3lem2.2 sheli
        syl2an vt cv vh cv cva co normcl syl sylan2 ancoms syl3anc mpand imp
        an1rs adantrl eqbrtrd syl5cbir exp31 syld com14 com4t r19.23advv adantl
        mpd ex com3l r19.21adv anim2d r19.22dva mpcom $.
        $( [23-May-2005] $) $( [26-May-2005] $)
    $}

    ${
      $d v u t h T $.
      cdj3lem3.3 $e |- T = { <. x , y >. | ( x e. ( A +H B ) /\
                     y = U. { w e. B | E. z e. A x = ( z +h w ) } ) } $.
      $( Lemma for ~ cdj3i .  Value of the second-component function ` T ` . $)
      cdj3lem3 $p |- ( ( C e. A /\ D e. B /\ ( A i^i B ) = 0H ) ->
                    ( T ` ( C +h D ) ) = D ) $=
        cD cB wcel cC cA wcel cA cB cin c0h wceq cC cD cva co cT cfv cD wceq cD
        cB wcel cC cA wcel cB cA cin c0h wceq cC cD cva co cT cfv cD wceq cA cB
        cin c0h wceq cD cB wcel cC cA wcel cB cA cin c0h wceq w3a cD cC cva co
        cT cfv cC cD cva co cT cfv cD cD cB wcel cC cA wcel cD cC cva co cT cfv
        cC cD cva co cT cfv wceq cB cA cin c0h wceq cD cB wcel cC cA wcel wa cD
        cC cva co cC cD cva co cT cD chil wcel cC chil wcel cD cC cva co cC cD
        cva co wceq cD cB wcel cC cA wcel cD cC ax-hvcom cD cB cdj3lem2.2 sheli
        cC cA cdj3lem2.1 sheli syl2an fveq2d 3adant3 vx vy vw vz cB cA cD cC cT
        cdj3lem2.2 cdj3lem2.1 cT vx cv cA cB cph co wcel vy cv vx cv vz cv vw
        cv cva co wceq vz cA wrex vw cB crab cuni wceq wa vx vy copab vx cv cB
        cA cph co wcel vy cv vx cv vw cv vz cv cva co wceq vz cA wrex vw cB
        crab cuni wceq wa vx vy copab cdj3lem3.3 vx cv cB cA cph co wcel vy cv
        vx cv vw cv vz cv cva co wceq vz cA wrex vw cB crab cuni wceq wa vx cv
        cA cB cph co wcel vy cv vx cv vz cv vw cv cva co wceq vz cA wrex vw cB
        crab cuni wceq wa vx vy vx cv cB cA cph co wcel vx cv cA cB cph co wcel
        vy cv vx cv vw cv vz cv cva co wceq vz cA wrex vw cB crab cuni wceq vy
        cv vx cv vz cv vw cv cva co wceq vz cA wrex vw cB crab cuni wceq cB cA
        cph co cA cB cph co vx cv cB cA cdj3lem2.2 cdj3lem2.1 shscomi eleq2i vx
        cv vw cv vz cv cva co wceq vz cA wrex vw cB crab cuni vx cv vz cv vw cv
        cva co wceq vz cA wrex vw cB crab cuni vy cv vx cv vw cv vz cv cva co
        wceq vz cA wrex vw cB crab vx cv vz cv vw cv cva co wceq vz cA wrex vw
        cB crab vx cv vw cv vz cv cva co wceq vz cA wrex vx cv vz cv vw cv cva
        co wceq vz cA wrex vw cB vw cv cB wcel vx cv vw cv vz cv cva co wceq vx
        cv vz cv vw cv cva co wceq vz cA vw cv cB wcel vz cv cA wcel wa vw cv
        vz cv cva co vz cv vw cv cva co vx cv vw cv chil wcel vz cv chil wcel
        vw cv vz cv cva co vz cv vw cv cva co wceq vw cv cB wcel vz cv cA wcel
        vw cv vz cv ax-hvcom vw cv cB cdj3lem2.2 sheli vz cv cA cdj3lem2.1
        sheli syl2an eqeq2d rexbidva rabbii unieqi eqeq2i anbi12i opabbii
        eqtr4i cdj3lem2 eqtr3d cA cB cin cB cA cin c0h cA cB incom eqeq1i
        syl3an3b 3com12 $.
        $( [23-May-2005] $) $( [23-May-2005] $)

      $( Lemma for ~ cdj3i .  Closure of the second-component function
         ` T ` . $)
      cdj3lem3a $p |- ( ( C e. ( A +H B ) /\ ( A i^i B ) = 0H ) ->
                    ( T ` C ) e. B ) $=
        cA cB cin c0h wceq cC cA cB cph co wcel cC cT cfv cB wcel cA cB cin c0h
        wceq cC vv cv vu cv cva co wceq vu cB wrex vv cA wrex cC cT cfv cB wcel
        cC cA cB cph co wcel cA cB cin c0h wceq cC vv cv vu cv cva co wceq cC
        cT cfv cB wcel vv vu cA cB cC vv cv vu cv cva co wceq vv cv cA wcel vu
        cv cB wcel wa cA cB cin c0h wceq cC cT cfv cB wcel cC vv cv vu cv cva
        co wceq vv cv cA wcel vu cv cB wcel wa cA cB cin c0h wceq cC cT cfv cB
        wcel cC vv cv vu cv cva co wceq cC cT cfv cB wcel vv cv vu cv cva co cT
        cfv cB wcel vv cv cA wcel vu cv cB wcel wa cA cB cin c0h wceq wa cC vv
        cv vu cv cva co wceq cC cT cfv vv cv vu cv cva co cT cfv cB cC vv cv vu
        cv cva co cT fveq2 eleq1d vv cv cA wcel vu cv cB wcel cA cB cin c0h
        wceq vv cv vu cv cva co cT cfv cB wcel vv cv cA wcel vu cv cB wcel cA
        cB cin c0h wceq w3a vv cv vu cv cva co cT cfv vu cv cB vx vy vz vw cA
        cB vv cv vu cv cT cdj3lem2.1 cdj3lem2.2 cdj3lem3.3 cdj3lem3 vv cv cA
        wcel vu cv cB wcel cA cB cin c0h wceq 3simp2 eqeltrd 3expa syl5bir
        exp3a com13 r19.23advv vv vu cA cB cC cdj3lem2.1 cdj3lem2.2 shseli
        syl5ib impcom $.
        $( [26-May-2005] $) $( [26-May-2005] $)

      $( Lemma for ~ cdj3i .  The second-component function ` T ` is bounded if
         the subspaces are completely disjoint. $)
      cdj3lem3b $p |- ( E. v e. RR ( 0 < v /\ A. x e. A A. y e. B
      ( ( normh ` x ) + ( normh ` y ) ) <_ ( v x. ( normh ` ( x +h y ) ) ) ) ->
                    E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( T ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $=
        cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy
        cv cva co cno cfv cmul co cle wbr vy cA wral vx cB wral wa vv cr wrex
        cc0 vv cv clt wbr vu cv cT cfv cno cfv vv cv vu cv cno cfv cmul co cle
        wbr vu cB cA cph co wral wa vv cr wrex cc0 vv cv clt wbr vx cv cno cfv
        vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr
        vy cB wral vx cA wral wa vv cr wrex cc0 vv cv clt wbr vu cv cT cfv cno
        cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vv cr
        wrex vx vy vw vz vv vu cB cA cT cdj3lem2.2 cdj3lem2.1 cT vx cv cA cB
        cph co wcel vy cv vx cv vz cv vw cv cva co wceq vz cA wrex vw cB crab
        cuni wceq wa vx vy copab vx cv cB cA cph co wcel vy cv vx cv vw cv vz
        cv cva co wceq vz cA wrex vw cB crab cuni wceq wa vx vy copab
        cdj3lem3.3 vx cv cB cA cph co wcel vy cv vx cv vw cv vz cv cva co wceq
        vz cA wrex vw cB crab cuni wceq wa vx cv cA cB cph co wcel vy cv vx cv
        vz cv vw cv cva co wceq vz cA wrex vw cB crab cuni wceq wa vx vy vx cv
        cB cA cph co wcel vx cv cA cB cph co wcel vy cv vx cv vw cv vz cv cva
        co wceq vz cA wrex vw cB crab cuni wceq vy cv vx cv vz cv vw cv cva co
        wceq vz cA wrex vw cB crab cuni wceq cB cA cph co cA cB cph co vx cv cB
        cA cdj3lem2.2 cdj3lem2.1 shscomi eleq2i vx cv vw cv vz cv cva co wceq
        vz cA wrex vw cB crab cuni vx cv vz cv vw cv cva co wceq vz cA wrex vw
        cB crab cuni vy cv vx cv vw cv vz cv cva co wceq vz cA wrex vw cB crab
        vx cv vz cv vw cv cva co wceq vz cA wrex vw cB crab vx cv vw cv vz cv
        cva co wceq vz cA wrex vx cv vz cv vw cv cva co wceq vz cA wrex vw cB
        vw cv cB wcel vx cv vw cv vz cv cva co wceq vx cv vz cv vw cv cva co
        wceq vz cA vw cv cB wcel vz cv cA wcel wa vw cv vz cv cva co vz cv vw
        cv cva co vx cv vw cv chil wcel vz cv chil wcel vw cv vz cv cva co vz
        cv vw cv cva co wceq vw cv cB wcel vz cv cA wcel vw cv vz cv ax-hvcom
        vw cv cB cdj3lem2.2 sheli vz cv cA cdj3lem2.1 sheli syl2an eqeq2d
        rexbidva rabbii unieqi eqeq2i anbi12i opabbii eqtr4i cdj3lem2b cc0 vv
        cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva
        co cno cfv cmul co cle wbr vy cB wral vx cA wral wa cc0 vv cv clt wbr
        vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv
        cmul co cle wbr vy cA wral vx cB wral wa vv cr vx cv cno cfv vy cv cno
        cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB
        wral vx cA wral vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv
        cva co cno cfv cmul co cle wbr vy cA wral vx cB wral cc0 vv cv clt wbr
        vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv
        cmul co cle wbr vy cB wral vx cA wral vt cv cno cfv vh cv cno cfv caddc
        co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr vh cB wral vt cA
        wral vt cv cno cfv vh cv cno cfv caddc co vv cv vt cv vh cv cva co cno
        cfv cmul co cle wbr vt cA wral vh cB wral vx cv cno cfv vy cv cno cfv
        caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cA wral vx
        cB wral vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co
        cno cfv cmul co cle wbr vt cv cno cfv vh cv cno cfv caddc co vv cv vt
        cv vh cv cva co cno cfv cmul co cle wbr vt cv cno cfv vy cv cno cfv
        caddc co vv cv vt cv vy cv cva co cno cfv cmul co cle wbr vx vy vt vh
        cA cB vx cv vt cv wceq vx cv cno cfv vy cv cno cfv caddc co vt cv cno
        cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co vv
        cv vt cv vy cv cva co cno cfv cmul co cle vx cv vt cv wceq vx cv cno
        cfv vt cv cno cfv vy cv cno cfv caddc vx cv vt cv cno fveq2 opreq1d vx
        cv vt cv wceq vx cv vy cv cva co cno cfv vt cv vy cv cva co cno cfv vv
        cv cmul vx cv vt cv wceq vx cv vy cv cva co vt cv vy cv cva co cno vx
        cv vt cv vy cv cva opreq1 fveq2d opreq2d breq12d vy cv vh cv wceq vt cv
        cno cfv vy cv cno cfv caddc co vt cv cno cfv vh cv cno cfv caddc co vv
        cv vt cv vy cv cva co cno cfv cmul co vv cv vt cv vh cv cva co cno cfv
        cmul co cle vy cv vh cv wceq vy cv cno cfv vh cv cno cfv vt cv cno cfv
        caddc vy cv vh cv cno fveq2 opreq2d vy cv vh cv wceq vt cv vy cv cva co
        cno cfv vt cv vh cv cva co cno cfv vv cv cmul vy cv vh cv wceq vt cv vy
        cv cva co vt cv vh cv cva co cno vy cv vh cv vt cv cva opreq2 fveq2d
        opreq2d breq12d cbvral2v vt cv cno cfv vh cv cno cfv caddc co vv cv vt
        cv vh cv cva co cno cfv cmul co cle wbr vt vh cA cB ralcom vx cv cno
        cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle
        wbr vy cA wral vx cB wral vy cv cno cfv vx cv cno cfv caddc co vv cv vy
        cv vx cv cva co cno cfv cmul co cle wbr vy cA wral vx cB wral vt cv cno
        cfv vh cv cno cfv caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle
        wbr vt cA wral vh cB wral vx cv cno cfv vy cv cno cfv caddc co vv cv vx
        cv vy cv cva co cno cfv cmul co cle wbr vy cA wral vy cv cno cfv vx cv
        cno cfv caddc co vv cv vy cv vx cv cva co cno cfv cmul co cle wbr vy cA
        wral vx cB vx cv cB wcel vx cv cno cfv vy cv cno cfv caddc co vv cv vx
        cv vy cv cva co cno cfv cmul co cle wbr vy cv cno cfv vx cv cno cfv
        caddc co vv cv vy cv vx cv cva co cno cfv cmul co cle wbr vy cA vx cv
        cB wcel vy cv cA wcel wa vx cv cno cfv vy cv cno cfv caddc co vy cv cno
        cfv vx cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co vv
        cv vy cv vx cv cva co cno cfv cmul co cle vx cv cno cfv cc wcel vy cv
        cno cfv cc wcel vx cv cno cfv vy cv cno cfv caddc co vy cv cno cfv vx
        cv cno cfv caddc co wceq vx cv cB wcel vy cv cA wcel vx cv cno cfv vy
        cv cno cfv addcom vx cv cB wcel vx cv cno cfv vx cv cB wcel vx cv chil
        wcel vx cv cno cfv cr wcel vx cv cB cdj3lem2.2 sheli vx cv normcl syl
        recnd vy cv cA wcel vy cv cno cfv vy cv cA wcel vy cv chil wcel vy cv
        cno cfv cr wcel vy cv cA cdj3lem2.1 sheli vy cv normcl syl recnd syl2an
        vx cv cB wcel vy cv cA wcel wa vx cv vy cv cva co cno cfv vy cv vx cv
        cva co cno cfv vv cv cmul vx cv cB wcel vy cv cA wcel wa vx cv vy cv
        cva co vy cv vx cv cva co cno vx cv chil wcel vy cv chil wcel vx cv vy
        cv cva co vy cv vx cv cva co wceq vx cv cB wcel vy cv cA wcel vx cv vy
        cv ax-hvcom vx cv cB cdj3lem2.2 sheli vy cv cA cdj3lem2.1 sheli syl2an
        fveq2d opreq2d breq12d ralbidva ralbiia vy cv cno cfv vx cv cno cfv
        caddc co vv cv vy cv vx cv cva co cno cfv cmul co cle wbr vt cv cno cfv
        vh cv cno cfv caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr
        vy cv cno cfv vh cv cno cfv caddc co vv cv vy cv vh cv cva co cno cfv
        cmul co cle wbr vx vy vh vt cB cA vx cv vh cv wceq vy cv cno cfv vx cv
        cno cfv caddc co vy cv cno cfv vh cv cno cfv caddc co vv cv vy cv vx cv
        cva co cno cfv cmul co vv cv vy cv vh cv cva co cno cfv cmul co cle vx
        cv vh cv wceq vx cv cno cfv vh cv cno cfv vy cv cno cfv caddc vx cv vh
        cv cno fveq2 opreq2d vx cv vh cv wceq vy cv vx cv cva co cno cfv vy cv
        vh cv cva co cno cfv vv cv cmul vx cv vh cv wceq vy cv vx cv cva co vy
        cv vh cv cva co cno vx cv vh cv vy cv cva opreq2 fveq2d opreq2d breq12d
        vy cv vt cv wceq vy cv cno cfv vh cv cno cfv caddc co vt cv cno cfv vh
        cv cno cfv caddc co vv cv vy cv vh cv cva co cno cfv cmul co vv cv vt
        cv vh cv cva co cno cfv cmul co cle vy cv vt cv wceq vy cv cno cfv vt
        cv cno cfv vh cv cno cfv caddc vy cv vt cv cno fveq2 opreq1d vy cv vt
        cv wceq vy cv vh cv cva co cno cfv vt cv vh cv cva co cno cfv vv cv
        cmul vy cv vt cv wceq vy cv vh cv cva co vt cv vh cv cva co cno vy cv
        vt cv vh cv cva opreq1 fveq2d opreq2d breq12d cbvral2v bitr2i 3bitri
        anbi2i rexbii cc0 vv cv clt wbr vu cv cT cfv cno cfv vv cv vu cv cno
        cfv cmul co cle wbr vu cA cB cph co wral wa cc0 vv cv clt wbr vu cv cT
        cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cB cA cph co wral wa
        vv cr vu cv cT cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB
        cph co wral vu cv cT cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu
        cB cA cph co wral cc0 vv cv clt wbr cA cB cph co cB cA cph co wceq vu
        cv cT cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co
        wral vu cv cT cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cB cA
        cph co wral wb cA cB cdj3lem2.1 cdj3lem2.2 shscomi vu cv cT cfv cno cfv
        vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co cB cA cph co raleq1
        ax-mp anbi2i rexbii 3imtr4i $.
        $( [31-May-2005] $) $( [31-May-2005] $)
    $}
  $}

  ${
    $d x y z w v u t h f g A $.  $d x y z w v u t h f g B $.
    $d v u t h f g S $.  $d v u t h f g T $.
    cdj3.1 $e |- A e. SH $.
    cdj3.2 $e |- B e. SH $.
    cdj3.3 $e |- S = { <. x , y >. | ( x e. ( A +H B ) /\
                   y = U. { z e. A | E. w e. B x = ( z +h w ) } ) } $.
    cdj3.4 $e |- T = { <. x , y >. | ( x e. ( A +H B ) /\
                   y = U. { w e. B | E. z e. A x = ( z +h w ) } ) } $.
    cdj3.5 $e |- ( ph <-> E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( S ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $.
    cdj3.6 $e |- ( ps <-> E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( T ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $.
    $( Two ways to express " ` A ` and ` B ` are completely disjoint
       subspaces."  (1) <=> (3) in Lemma 5 of [Holland] p. 1520. $)
    cdj3i $p |- ( E. v e. RR ( 0 < v /\ A. x e. A A. y e. B
      ( ( normh ` x ) + ( normh ` y ) ) <_ ( v x. ( normh ` ( x +h y ) ) ) )
         <-> ( ( A i^i B ) = 0H /\ ph /\ ps ) ) $=
      cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv
      cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv cr wrex cA cB
      cin c0h wceq wph wps w3a cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv
      caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx
      cA wral wa vv cr wrex cA cB cin c0h wceq wph wps vv vx vy cA cB cdj3.1
      cdj3.2 cdj3lem1 cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv
      cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv
      cr wrex cc0 vv cv clt wbr vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul
      co cle wbr vu cA cB cph co wral wa vv cr wrex wph vx vy vz vw vv vu cA cB
      cS cdj3.1 cdj3.2 cdj3.3 cdj3lem2b cdj3.5 sylibr cc0 vv cv clt wbr vx cv
      cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co
      cle wbr vy cB wral vx cA wral wa vv cr wrex cc0 vv cv clt wbr vu cv cT
      cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa
      vv cr wrex wps vx vy vz vw vv vu cA cB cT cdj3.1 cdj3.2 cdj3.4 cdj3lem3b
      cdj3.6 sylibr 3jca cA cB cin c0h wceq wph wps cc0 vv cv clt wbr vx cv cno
      cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle
      wbr vy cB wral vx cA wral wa vv cr wrex cA cB cin c0h wceq cc0 vf cv clt
      wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph
      co wral wa cc0 vg cv clt wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv
      cmul co cle wbr vu cA cB cph co wral wa wa vg cr wrex vf cr wrex cc0 vv
      cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co
      cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv cr wrex wph wps wa cA
      cB cin c0h wceq cc0 vf cv clt wbr vu cv cS cfv cno cfv vf cv vu cv cno
      cfv cmul co cle wbr vu cA cB cph co wral wa cc0 vg cv clt wbr vu cv cT
      cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa
      wa cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy
      cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv cr wrex vf
      vg cr cr cA cB cin c0h wceq vf cv cr wcel vg cv cr wcel wa cc0 vf cv clt
      wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph
      co wral wa cc0 vg cv clt wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv
      cmul co cle wbr vu cA cB cph co wral wa wa cc0 vv cv clt wbr vx cv cno
      cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle
      wbr vy cB wral vx cA wral wa vv cr wrex wi cA cB cin c0h wceq vf cv cr
      wcel vg cv cr wcel wa wa cc0 vf cv clt wbr cc0 vg cv clt wbr wa vu cv cS
      cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral vu
      cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph co
      wral wa wa cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv
      vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv cr
      wrex cc0 vf cv clt wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co
      cle wbr vu cA cB cph co wral wa cc0 vg cv clt wbr vu cv cT cfv cno cfv vg
      cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa wa cA cB cin c0h
      wceq vf cv cr wcel vg cv cr wcel wa wa cc0 vf cv vg cv caddc co clt wbr
      vt cv cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt cv vh cv cva
      co cno cfv cmul co cle wbr vh cB wral vt cA wral cc0 vv cv clt wbr vx cv
      cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co
      cle wbr vy cB wral vx cA wral wa vv cr wrex cc0 vf cv clt wbr cc0 vg cv
      clt wbr wa vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA
      cB cph co wral vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr
      vu cA cB cph co wral wa vf cv cr wcel vg cv cr wcel wa cc0 vf cv vg cv
      caddc co clt wbr vt cv cno cfv vh cv cno cfv caddc co vf cv vg cv caddc
      co vt cv vh cv cva co cno cfv cmul co cle wbr vh cB wral vt cA wral wa
      cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv
      cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv cr wrex wi cA
      cB cin c0h wceq vf cv cr wcel vg cv cr wcel wa vf cv vg cv caddc co cr
      wcel cc0 vf cv vg cv caddc co clt wbr vt cv cno cfv vh cv cno cfv caddc
      co vf cv vg cv caddc co vt cv vh cv cva co cno cfv cmul co cle wbr vh cB
      wral vt cA wral wa cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co
      vv cv vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa
      vv cr wrex wi vf cv vg cv readdcl vf cv vg cv caddc co cr wcel cc0 vf cv
      vg cv caddc co clt wbr vt cv cno cfv vh cv cno cfv caddc co vf cv vg cv
      caddc co vt cv vh cv cva co cno cfv cmul co cle wbr vh cB wral vt cA wral
      wa cc0 vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy
      cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral wa vv cr wrex cc0
      vv cv clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva
      co cno cfv cmul co cle wbr vy cB wral vx cA wral wa cc0 vf cv vg cv caddc
      co clt wbr vt cv cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt
      cv vh cv cva co cno cfv cmul co cle wbr vh cB wral vt cA wral wa vv vf cv
      vg cv caddc co cr vv cv vf cv vg cv caddc co wceq cc0 vv cv clt wbr cc0
      vf cv vg cv caddc co clt wbr vx cv cno cfv vy cv cno cfv caddc co vv cv
      vx cv vy cv cva co cno cfv cmul co cle wbr vy cB wral vx cA wral vt cv
      cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt cv vh cv cva co
      cno cfv cmul co cle wbr vh cB wral vt cA wral vv cv vf cv vg cv caddc co
      cc0 clt breq2 vv cv vf cv vg cv caddc co wceq vt cv cno cfv vh cv cno cfv
      caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr vh cB wral vt
      cA wral vt cv cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt cv
      vh cv cva co cno cfv cmul co cle wbr vh cB wral vt cA wral vx cv cno cfv
      vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul co cle wbr
      vy cB wral vx cA wral vv cv vf cv vg cv caddc co wceq vt cv cno cfv vh cv
      cno cfv caddc co vv cv vt cv vh cv cva co cno cfv cmul co cle wbr vt cv
      cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt cv vh cv cva co
      cno cfv cmul co cle wbr vt vh cA cB vv cv vf cv vg cv caddc co wceq vv cv
      vt cv vh cv cva co cno cfv cmul co vf cv vg cv caddc co vt cv vh cv cva
      co cno cfv cmul co vt cv cno cfv vh cv cno cfv caddc co cle vv cv vf cv
      vg cv caddc co vt cv vh cv cva co cno cfv cmul opreq1 breq2d 2ralbidv vx
      cv cno cfv vy cv cno cfv caddc co vv cv vx cv vy cv cva co cno cfv cmul
      co cle wbr vt cv cno cfv vh cv cno cfv caddc co vv cv vt cv vh cv cva co
      cno cfv cmul co cle wbr vt cv cno cfv vy cv cno cfv caddc co vv cv vt cv
      vy cv cva co cno cfv cmul co cle wbr vx vy vt vh cA cB vx cv vt cv wceq
      vx cv cno cfv vy cv cno cfv caddc co vt cv cno cfv vy cv cno cfv caddc co
      vv cv vx cv vy cv cva co cno cfv cmul co vv cv vt cv vy cv cva co cno cfv
      cmul co cle vx cv vt cv wceq vx cv cno cfv vt cv cno cfv vy cv cno cfv
      caddc vx cv vt cv cno fveq2 opreq1d vx cv vt cv wceq vx cv vy cv cva co
      cno cfv vt cv vy cv cva co cno cfv vv cv cmul vx cv vt cv wceq vx cv vy
      cv cva co vt cv vy cv cva co cno vx cv vt cv vy cv cva opreq1 fveq2d
      opreq2d breq12d vy cv vh cv wceq vt cv cno cfv vy cv cno cfv caddc co vt
      cv cno cfv vh cv cno cfv caddc co vv cv vt cv vy cv cva co cno cfv cmul
      co vv cv vt cv vh cv cva co cno cfv cmul co cle vy cv vh cv wceq vy cv
      cno cfv vh cv cno cfv vt cv cno cfv caddc vy cv vh cv cno fveq2 opreq2d
      vy cv vh cv wceq vt cv vy cv cva co cno cfv vt cv vh cv cva co cno cfv vv
      cv cmul vy cv vh cv wceq vt cv vy cv cva co vt cv vh cv cva co cno vy cv
      vh cv vt cv cva opreq2 fveq2d opreq2d breq12d cbvral2v syl5bb anbi12d
      rcla4ev ex syl adantl vf cv cr wcel vg cv cr wcel wa cc0 vf cv clt wbr
      cc0 vg cv clt wbr wa cc0 vf cv vg cv caddc co clt wbr wi cA cB cin c0h
      wceq vf cv cr wcel vg cv cr wcel wa cc0 vf cv clt wbr cc0 vg cv clt wbr
      wa cc0 vf cv vg cv caddc co clt wbr vf cv vg cv addgt0 ex adantl cA cB
      cin c0h wceq vf cv cr wcel vg cv cr wcel wa wa vu cv cS cfv cno cfv vf cv
      vu cv cno cfv cmul co cle wbr vu cA cB cph co wral vu cv cT cfv cno cfv
      vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vt cv cno cfv
      vh cv cno cfv caddc co vf cv vg cv caddc co vt cv vh cv cva co cno cfv
      cmul co cle wbr vt vh cA cB cA cB cin c0h wceq vf cv cr wcel vg cv cr
      wcel wa wa vt cv cA wcel vh cv cB wcel wa wa vu cv cS cfv cno cfv vf cv
      vu cv cno cfv cmul co cle wbr vu cA cB cph co wral vu cv cT cfv cno cfv
      vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vt cv vh cv
      cva co cS cfv cno cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vt
      cv vh cv cva co cT cfv cno cfv vg cv vt cv vh cv cva co cno cfv cmul co
      cle wbr wa vt cv cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt
      cv vh cv cva co cno cfv cmul co cle wbr vt cv cA wcel vh cv cB wcel wa vu
      cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph co
      wral vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB
      cph co wral wa vt cv vh cv cva co cS cfv cno cfv vf cv vt cv vh cv cva co
      cno cfv cmul co cle wbr vt cv vh cv cva co cT cfv cno cfv vg cv vt cv vh
      cv cva co cno cfv cmul co cle wbr wa wi cA cB cin c0h wceq vf cv cr wcel
      vg cv cr wcel wa wa vt cv cA wcel vh cv cB wcel wa vt cv vh cv cva co cA
      cB cph co wcel vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr
      vu cA cB cph co wral vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle
      wbr vu cA cB cph co wral wa vt cv vh cv cva co cS cfv cno cfv vf cv vt cv
      vh cv cva co cno cfv cmul co cle wbr vt cv vh cv cva co cT cfv cno cfv vg
      cv vt cv vh cv cva co cno cfv cmul co cle wbr wa wi cA cB vt cv vh cv
      cdj3.1 cdj3.2 shsvai vt cv vh cv cva co cA cB cph co wcel vu cv cS cfv
      cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral vt cv vh
      cv cva co cS cfv cno cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr
      vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph co
      wral vt cv vh cv cva co cT cfv cno cfv vg cv vt cv vh cv cva co cno cfv
      cmul co cle wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr
      vt cv vh cv cva co cS cfv cno cfv vf cv vt cv vh cv cva co cno cfv cmul
      co cle wbr vu vt cv vh cv cva co cA cB cph co vu cv vt cv vh cv cva co
      wceq vu cv cS cfv cno cfv vt cv vh cv cva co cS cfv cno cfv vf cv vu cv
      cno cfv cmul co vf cv vt cv vh cv cva co cno cfv cmul co cle vu cv vt cv
      vh cv cva co wceq vu cv cS cfv vt cv vh cv cva co cS cfv cno vu cv vt cv
      vh cv cva co cS fveq2 fveq2d vu cv vt cv vh cv cva co wceq vu cv cno cfv
      vt cv vh cv cva co cno cfv vf cv cmul vu cv vt cv vh cv cva co cno fveq2
      opreq2d breq12d rcla4v vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co
      cle wbr vt cv vh cv cva co cT cfv cno cfv vg cv vt cv vh cv cva co cno
      cfv cmul co cle wbr vu vt cv vh cv cva co cA cB cph co vu cv vt cv vh cv
      cva co wceq vu cv cT cfv cno cfv vt cv vh cv cva co cT cfv cno cfv vg cv
      vu cv cno cfv cmul co vg cv vt cv vh cv cva co cno cfv cmul co cle vu cv
      vt cv vh cv cva co wceq vu cv cT cfv vt cv vh cv cva co cT cfv cno vu cv
      vt cv vh cv cva co cT fveq2 fveq2d vu cv vt cv vh cv cva co wceq vu cv
      cno cfv vt cv vh cv cva co cno cfv vg cv cmul vu cv vt cv vh cv cva co
      cno fveq2 opreq2d breq12d rcla4v anim12d syl adantl cA cB cin c0h wceq vf
      cv cr wcel vg cv cr wcel wa wa vt cv cA wcel vh cv cB wcel wa wa vt cv
      cno cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vh cv cno cfv vg
      cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno cfv vh cv cno
      cfv caddc co vf cv vt cv vh cv cva co cno cfv cmul co vg cv vt cv vh cv
      cva co cno cfv cmul co caddc co cle wbr vt cv vh cv cva co cS cfv cno cfv
      vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vt cv vh cv cva co cT
      cfv cno cfv vg cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno
      cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt cv vh cv cva co cno
      cfv cmul co cle wbr vf cv cr wcel vg cv cr wcel wa vt cv cA wcel vh cv cB
      wcel wa vt cv cno cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vh
      cv cno cfv vg cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno
      cfv vh cv cno cfv caddc co vf cv vt cv vh cv cva co cno cfv cmul co vg cv
      vt cv vh cv cva co cno cfv cmul co caddc co cle wbr wi cA cB cin c0h wceq
      vt cv cno cfv cr wcel vh cv cno cfv cr wcel wa vf cv vt cv vh cv cva co
      cno cfv cmul co cr wcel vg cv vt cv vh cv cva co cno cfv cmul co cr wcel
      wa vt cv cno cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vh cv
      cno cfv vg cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno cfv
      vh cv cno cfv caddc co vf cv vt cv vh cv cva co cno cfv cmul co vg cv vt
      cv vh cv cva co cno cfv cmul co caddc co cle wbr wi vf cv cr wcel vg cv
      cr wcel wa vt cv cA wcel vh cv cB wcel wa wa vt cv cno cfv vh cv cno cfv
      vf cv vt cv vh cv cva co cno cfv cmul co vg cv vt cv vh cv cva co cno cfv
      cmul co le2add vt cv cA wcel vh cv cB wcel wa vt cv cno cfv cr wcel vh cv
      cno cfv cr wcel wa vf cv cr wcel vg cv cr wcel wa vt cv cA wcel vt cv cno
      cfv cr wcel vh cv cB wcel vh cv cno cfv cr wcel vt cv cA wcel vt cv chil
      wcel vt cv cno cfv cr wcel vt cv cA cdj3.1 sheli vt cv normcl syl vh cv
      cB wcel vh cv chil wcel vh cv cno cfv cr wcel vh cv cB cdj3.2 sheli vh cv
      normcl syl anim12i adantl vf cv cr wcel vg cv cr wcel wa vt cv cA wcel vh
      cv cB wcel wa wa vf cv vt cv vh cv cva co cno cfv cmul co cr wcel vg cv
      vt cv vh cv cva co cno cfv cmul co cr wcel vf cv cr wcel vt cv cA wcel vh
      cv cB wcel wa vf cv vt cv vh cv cva co cno cfv cmul co cr wcel vg cv cr
      wcel vf cv cr wcel vt cv vh cv cva co cno cfv cr wcel vf cv vt cv vh cv
      cva co cno cfv cmul co cr wcel vt cv cA wcel vh cv cB wcel wa vf cv vt cv
      vh cv cva co cno cfv remulcl vt cv cA wcel vh cv cB wcel wa vt cv vh cv
      cva co chil wcel vt cv vh cv cva co cno cfv cr wcel vt cv chil wcel vh cv
      chil wcel vt cv vh cv cva co chil wcel vt cv cA wcel vh cv cB wcel vt cv
      vh cv hvaddcl vt cv cA cdj3.1 sheli vh cv cB cdj3.2 sheli syl2an vt cv vh
      cv cva co normcl syl sylan2 adantlr vg cv cr wcel vt cv cA wcel vh cv cB
      wcel wa vg cv vt cv vh cv cva co cno cfv cmul co cr wcel vf cv cr wcel vg
      cv cr wcel vt cv vh cv cva co cno cfv cr wcel vg cv vt cv vh cv cva co
      cno cfv cmul co cr wcel vt cv cA wcel vh cv cB wcel wa vg cv vt cv vh cv
      cva co cno cfv remulcl vt cv cA wcel vh cv cB wcel wa vt cv vh cv cva co
      chil wcel vt cv vh cv cva co cno cfv cr wcel vt cv chil wcel vh cv chil
      wcel vt cv vh cv cva co chil wcel vt cv cA wcel vh cv cB wcel vt cv vh cv
      hvaddcl vt cv cA cdj3.1 sheli vh cv cB cdj3.2 sheli syl2an vt cv vh cv
      cva co normcl syl sylan2 adantll jca sylanc adantll cA cB cin c0h wceq vt
      cv cA wcel vh cv cB wcel wa vt cv vh cv cva co cS cfv cno cfv vf cv vt cv
      vh cv cva co cno cfv cmul co cle wbr vt cv vh cv cva co cT cfv cno cfv vg
      cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno cfv vf cv vt
      cv vh cv cva co cno cfv cmul co cle wbr vh cv cno cfv vg cv vt cv vh cv
      cva co cno cfv cmul co cle wbr wa wb vf cv cr wcel vg cv cr wcel wa vt cv
      cA wcel vh cv cB wcel wa cA cB cin c0h wceq vt cv vh cv cva co cS cfv cno
      cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vt cv vh cv cva co
      cT cfv cno cfv vg cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv
      cno cfv vf cv vt cv vh cv cva co cno cfv cmul co cle wbr vh cv cno cfv vg
      cv vt cv vh cv cva co cno cfv cmul co cle wbr wa wb vt cv cA wcel vh cv
      cB wcel cA cB cin c0h wceq vt cv vh cv cva co cS cfv cno cfv vf cv vt cv
      vh cv cva co cno cfv cmul co cle wbr vt cv vh cv cva co cT cfv cno cfv vg
      cv vt cv vh cv cva co cno cfv cmul co cle wbr wa vt cv cno cfv vf cv vt
      cv vh cv cva co cno cfv cmul co cle wbr vh cv cno cfv vg cv vt cv vh cv
      cva co cno cfv cmul co cle wbr wa wb vt cv cA wcel vh cv cB wcel cA cB
      cin c0h wceq w3a vt cv vh cv cva co cS cfv cno cfv vf cv vt cv vh cv cva
      co cno cfv cmul co cle wbr vt cv cno cfv vf cv vt cv vh cv cva co cno cfv
      cmul co cle wbr vt cv vh cv cva co cT cfv cno cfv vg cv vt cv vh cv cva
      co cno cfv cmul co cle wbr vh cv cno cfv vg cv vt cv vh cv cva co cno cfv
      cmul co cle wbr vt cv cA wcel vh cv cB wcel cA cB cin c0h wceq w3a vt cv
      vh cv cva co cS cfv cno cfv vt cv cno cfv vf cv vt cv vh cv cva co cno
      cfv cmul co cle vt cv cA wcel vh cv cB wcel cA cB cin c0h wceq w3a vt cv
      vh cv cva co cS cfv vt cv cno vx vy vz vw cA cB vt cv vh cv cS cdj3.1
      cdj3.2 cdj3.3 cdj3lem2 fveq2d breq1d vt cv cA wcel vh cv cB wcel cA cB
      cin c0h wceq w3a vt cv vh cv cva co cT cfv cno cfv vh cv cno cfv vg cv vt
      cv vh cv cva co cno cfv cmul co cle vt cv cA wcel vh cv cB wcel cA cB cin
      c0h wceq w3a vt cv vh cv cva co cT cfv vh cv cno vx vy vz vw cA cB vt cv
      vh cv cT cdj3.1 cdj3.2 cdj3.4 cdj3lem3 fveq2d breq1d anbi12d 3expa ancoms
      adantlr vf cv cr wcel vg cv cr wcel wa vt cv cA wcel vh cv cB wcel wa vt
      cv cno cfv vh cv cno cfv caddc co vf cv vg cv caddc co vt cv vh cv cva co
      cno cfv cmul co cle wbr vt cv cno cfv vh cv cno cfv caddc co vf cv vt cv
      vh cv cva co cno cfv cmul co vg cv vt cv vh cv cva co cno cfv cmul co
      caddc co cle wbr wb cA cB cin c0h wceq vf cv cr wcel vg cv cr wcel wa vt
      cv cA wcel vh cv cB wcel wa wa vf cv vg cv caddc co vt cv vh cv cva co
      cno cfv cmul co vf cv vt cv vh cv cva co cno cfv cmul co vg cv vt cv vh
      cv cva co cno cfv cmul co caddc co vt cv cno cfv vh cv cno cfv caddc co
      cle vf cv cr wcel vg cv cr wcel vt cv cA wcel vh cv cB wcel wa vf cv vg
      cv caddc co vt cv vh cv cva co cno cfv cmul co vf cv vt cv vh cv cva co
      cno cfv cmul co vg cv vt cv vh cv cva co cno cfv cmul co caddc co wceq vf
      cv cc wcel vg cv cc wcel vt cv vh cv cva co cno cfv cc wcel vf cv vg cv
      caddc co vt cv vh cv cva co cno cfv cmul co vf cv vt cv vh cv cva co cno
      cfv cmul co vg cv vt cv vh cv cva co cno cfv cmul co caddc co wceq vf cv
      cr wcel vg cv cr wcel vt cv cA wcel vh cv cB wcel wa vf cv vg cv vt cv vh
      cv cva co cno cfv adddir vf cv recn vg cv recn vt cv cA wcel vh cv cB
      wcel wa vt cv vh cv cva co cno cfv vt cv cA wcel vh cv cB wcel wa vt cv
      vh cv cva co chil wcel vt cv vh cv cva co cno cfv cr wcel vt cv chil wcel
      vh cv chil wcel vt cv vh cv cva co chil wcel vt cv cA wcel vh cv cB wcel
      vt cv vh cv hvaddcl vt cv cA cdj3.1 sheli vh cv cB cdj3.2 sheli syl2an vt
      cv vh cv cva co normcl syl recnd syl3an 3expa breq2d adantll 3imtr4d syld
      r19.21advva syl2and cc0 vf cv clt wbr vu cv cS cfv cno cfv vf cv vu cv
      cno cfv cmul co cle wbr vu cA cB cph co wral cc0 vg cv clt wbr vu cv cT
      cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral an4
      syl5ib ex r19.23advv wph wps wa cc0 vf cv clt wbr vu cv cS cfv cno cfv vf
      cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vf cr wrex cc0
      vg cv clt wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu
      cA cB cph co wral wa vg cr wrex wa cc0 vf cv clt wbr vu cv cS cfv cno cfv
      vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa cc0 vg cv clt
      wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph
      co wral wa wa vg cr wrex vf cr wrex wph cc0 vf cv clt wbr vu cv cS cfv
      cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vf cr
      wrex wps cc0 vg cv clt wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul
      co cle wbr vu cA cB cph co wral wa vg cr wrex wph cc0 vv cv clt wbr vu cv
      cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral
      wa vv cr wrex cc0 vf cv clt wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv
      cmul co cle wbr vu cA cB cph co wral wa vf cr wrex cdj3.5 cc0 vv cv clt
      wbr vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph
      co wral wa cc0 vf cv clt wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv
      cmul co cle wbr vu cA cB cph co wral wa vv vf cr vv cv vf cv wceq cc0 vv
      cv clt wbr cc0 vf cv clt wbr vu cv cS cfv cno cfv vv cv vu cv cno cfv
      cmul co cle wbr vu cA cB cph co wral vu cv cS cfv cno cfv vf cv vu cv cno
      cfv cmul co cle wbr vu cA cB cph co wral vv cv vf cv cc0 clt breq2 vv cv
      vf cv wceq vu cv cS cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cv
      cS cfv cno cfv vf cv vu cv cno cfv cmul co cle wbr vu cA cB cph co vv cv
      vf cv wceq vv cv vu cv cno cfv cmul co vf cv vu cv cno cfv cmul co vu cv
      cS cfv cno cfv cle vv cv vf cv vu cv cno cfv cmul opreq1 breq2d ralbidv
      anbi12d cbvrexv bitri wps cc0 vv cv clt wbr vu cv cT cfv cno cfv vv cv vu
      cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vv cr wrex cc0 vg cv
      clt wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB
      cph co wral wa vg cr wrex cdj3.6 cc0 vv cv clt wbr vu cv cT cfv cno cfv
      vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa cc0 vg cv clt
      wbr vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB cph
      co wral wa vv vg cr vv cv vg cv wceq cc0 vv cv clt wbr cc0 vg cv clt wbr
      vu cv cT cfv cno cfv vv cv vu cv cno cfv cmul co cle wbr vu cA cB cph co
      wral vu cv cT cfv cno cfv vg cv vu cv cno cfv cmul co cle wbr vu cA cB
      cph co wral vv cv vg cv cc0 clt breq2 vv cv vg cv wceq vu cv cT cfv cno
      cfv vv cv vu cv cno cfv cmul co cle wbr vu cv cT cfv cno cfv vg cv vu cv
      cno cfv cmul co cle wbr vu cA cB cph co vv cv vg cv wceq vv cv vu cv cno
      cfv cmul co vg cv vu cv cno cfv cmul co vu cv cT cfv cno cfv cle vv cv vg
      cv vu cv cno cfv cmul opreq1 breq2d ralbidv anbi12d cbvrexv bitri anbi12i
      cc0 vf cv clt wbr vu cv cS cfv cno cfv vf cv vu cv cno cfv cmul co cle
      wbr vu cA cB cph co wral wa cc0 vg cv clt wbr vu cv cT cfv cno cfv vg cv
      vu cv cno cfv cmul co cle wbr vu cA cB cph co wral wa vf vg cr cr reeanv
      bitr4i syl5ib 3impib impbii $.
      $( [3-Jun-2006] $) $( [1-Jun-2005] $)
  $}

$(

@(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Calculus
                    Version of 10-Aug-2005 Roy F. Longton
                            9-Sep-2005  neighex added
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
@)

  @c neigh @.

  @( Extend the definition of classes to include neighborhoods.  (Contributed
    by Roy F. Longton, 7-Aug-2005.) @)
  cneigh @a class neigh @.

  @{
    @d x y z w @.
    @( Define the notion of neighborhoods: "neigh" is a relation that relates
      a subset of the real numbers to a point within it for which it acts as a
      neighborhood.  (Contributed by Roy F. Longton, 7-Aug-2005.) @)
    df-neigh @a |- neigh = { <. x , y >. | ( ( x C_ RR /\ y e. RR ) /\ E. z e.
      RR ( 0 < z /\ A. w e. RR ( ( 0 <_ w /\ w < z ) -> ( ( y + w ) e. x /\
      ( y - w ) e.  x ) ) ) ) } @.
  @}

  @{
    @d x y z w @.
    @( The notion of neighborhoods is a relation.  (Contributed by Roy F.
       Longton, 7-Aug-2005.) @)
    neighrel @p |- Rel neigh @=
      ( vx vy vz vw cneigh wrel cv cr wss wcel wa cc0 clt wbr cle caddc co
      cmin wi wral wrex copab relopab wceq wb df-neigh releq ax-mp mpbir ) EFZA
      GZHIBGZHJKLCGZMNLDGZONUNUMMNKULUNPQUKJULUNRQUKJKSDHTKCHUAKZABUBZFZUOABUCE
      UPUDUJUQUEABCDUFEUPUGUHUI @.
      @( [ ?] @) @( [7-Aug-2005] @)
  @}

  @{
    @d S x y z w @.  @d A x y z w @.
    neigh.1 @e |- S e. _V @.
    neigh.2 @e |- A e. _V @.
    @( Express the predicate: ` S ` is a neighborhood of ` A ` .  (Contributed
       by Roy F. Longton, 7-Aug-2005.) @)
    neighbr @p |- ( S neigh A <->
      ( ( S C_ RR /\ A e. RR ) /\ E. z e. RR ( 0 < z
      /\ A. w e. RR ( ( 0 <_ w /\ w < z ) -> ( ( A + w ) e. S /\ ( A - w ) e.
      S ) ) ) ) ) @=
      ( vx vy cv cr wss wcel wa cc0 clt wbr cle caddc co cmin wi wral wrex
      cneigh wceq sseq1 anbi1d eleq2 anbi12d imbi2d ralbidv anbi2d rexbidv
      eleq1 opreq1 eleq1d df-neigh brab ) GIZJKZHIZJLZMZNAIZOPZNBIZQPVFVDOPMZVA
      VFRSZUSLZVAVFTSZUSLZMZUAZBJUBZMZAJUCZMDJKZVBMZVEVGVHDLZVJDLZMZUAZBJUBZMZA
      JUCZMVQCJLZMZVEVGCVFRSZDLZCVFTSZDLZMZUAZBJUBZMZAJUCZMGHDCUDEFUSDUEZVCVRVP
      WEWQUTVQVBUSDJUFUGWQVOWDAJWQVNWCVEWQVMWBBJWQVLWAVGWQVIVSVKVTUSDVHUHUSDVJU
      HUIUJUKULUMUIVACUEZVRWGWEWPWRVBWFVQVACJUNULWRWDWOAJWRWCWNVEWRWBWMBJWRWAWL
      VGWRVSWIVTWKWRVHWHDVACVFRUOUPWRVJWJDVACVFTUOUPUIUJUKULUMUIGHABUQUR @.
      @( [ ?] @) @( [10-Aug-2005] @)
  @}

  @{
    @d A z w @.
    reneigh.1 @e |- A e. RR @.
    @( The set of real numbers acts as a neighborhood for every real number. @)
    reneigh @p |- RR neigh A @=
      ( vz vw cr cneigh wbr wss wcel wa cc0 cv clt cle caddc co cmin wi wral
      wrex reex elisseti neighbr ssid pm3.2i c1 1re lt01 axaddrcl mpan
      resubcl jca a1d rgen wceq breq2 anbi2d imbi1d ralbidv anbi12d rcla4ev
      mp2an mpbir2an ) EAFGEEHZAEIZJKCLZMGZKDLZNGZVHVFMGZJZAVHOPEIZAVHQPEIZJZRZ
      DESZJZCETZCDAEUAAEBUBUCVDVEEUDBUEUFEIKUFMGZVIVHUFMGZJZVNRZDESZJZVRUGVSWCU
      HWBDEVHEIZVNWAWEVLVMVEWEVLBAVHUIUJVEWEVMBAVHUKUJULUMUNUEVQWDCUFEVFUFUOZVG
      VSVPWCVFUFKMUPWFVOWBDEWFVKWAVNWFVJVTVIVFUFVHMUPUQURUSUTVAVBVC @.
      @( [ ?] @) @( [8-Aug-2005] @)
  @}

    @c OpenROY @.

    @( Extend the definition of classes to include open sets.  (Contributed by
      Roy F. Longton, 7-Aug-2005.) @)
    copen @a class OpenROY @.

  @{
    @d x y z @.
    @( Define the notion of an open set: "Open" is the class of all open sets.
      A set is open if all of its members each have a neighborhood completely
      contained within the set.  (Contributed by Roy F. Longton,
      7-Aug-2005.) @)
    df-openROY @a |- OpenROY =
                     { x | A. y e. x E. z ( z C_ x /\ z neigh y ) } @.
  @}

    @c cont @.

    @( Extend the definition of classes to include function continuity.
      (Contributed by Roy F. Longton, 7-Aug-2005.) @)
    ccont @a class cont @.

  @{
    @d f x y z @.
    @( Define the notion of function continuity: "cont" is a relation that
      relates a function to a (sub)domain on which it is continuous.  A
      function is continuous on a domain if and only if every open subset of
      its range has an open preimage under the function.  (Contributed by Roy
      F. Longton, 7-Aug-2005.) @)
    df-cont @a |- cont = { <. f , x >. | ( f Fn x /\ A. y ( y C_ ( f " x ) ->
  ( OpenROY y -> ( E. z ( z C_ x /\ OpenROY z /\ y = ( f " z ) ) ) ) ) ) ) } @.
  @}

    @( Two nonnegative numbers compare the same as their squares.
       (Contributed by Roy F. Longton, 8-Aug-2005.) @)
    lt2sqtROY @p |- ( ( A e. RR /\ B e. RR ) -> ( ( 0 <_ A /\ 0 <_ B ) ->
        ( A < B <-> ( A x. A ) < ( B x. B ) ) ) ) @=
      ( cr wcel cc0 cle wbr wa clt cmul co wb wi cif wceq breq2 anbi1d breq1
      opreq12 anidms breq1d bibi12d imbi12d anbi2d breq2d 0re elimel lt2msqi
      dedth2h ) ACDZBCDZEAFGZEBFGZHZABIGZAAJKZBBJKZIGZLZMEUJAENZFGZUMHZUTBIGZUT
      UTJKZUQIGZLZMVAEUKBENZFGZHZUTVGIGZVDVGVGJKZIGZLZMABEEAUTOZUNVBUSVFVNULVAU
      MAUTEFPQVNUOVCURVEAUTBIRVNUPVDUQIVNUPVDOAUTAUTJSTUAUBUCBVGOZVBVIVFVMVOUMV
      HVABVGEFPUDVOVCVJVEVLBVGUTIPVOUQVKVDIVOUQVKOBVGBVGJSTUEUBUCUTVGAECUFUGBEC
      UFUGUHUI @.
      @( [ ?] @) @( [8-Aug-2005] @)

  @{
    sqrlt.1 @e |- A e. RR @.
    sqrlt.2 @e |- B e. RR @.
    @( Square root is strictly monotonic.  (Contributed by Roy F. Longton,
      8-Aug-2005.) @)
    sqrltROY @p |- ( ( 0 <_ A /\ 0 <_ B ) -> ( A < B <-> ( sqr ` A ) <
      ( sqr ` B ) ) ) @=
      ( cc0 cle wbr wa csqr cfv clt cmul co wb cr wcel wi lt2sqtROY sqrcli
      syl2an sqrge0i syl2ani pm2.43i sqrthi breqan12d
      bitr2d ) EAFGZEBFGZHZAIJZBI
      JZKGZUJUJLMZUKUKLMZKGZABKGUIULUONZUIEUJFGZEUKFGZUPUGUHUJOPUKOPUQURHUPQUGU
      HUJUKRACSBDSTACUABDUAUBUCUGUHUMAUNBKACUDBDUDUEUF @.
      @( [ ?] @) @( [8-Aug-2005] @)
  @}

    @( The square root of 2 is bounded by 1 and 2.  (Contributed by Roy F.
       Longton, 8-Aug-2005.) @)
    sqr2gt1lt2ROY @p |- ( 1 < ( sqr ` 2 ) /\ ( sqr ` 2 ) < 2 ) @=
      ( c1 c2 csqr cfv clt wbr sqr1 1lt2 cc0 cle wb 0re 1re lt01 ltleii 2re
      2pos sqrltROY mp2an mpbi eqbrtrri c4 caddc co sqrlem15 2p2e4 breqtri 4re
      4pos sqr4 pm3.2i ) ABCDZEFULBEFACDZAULEGABEFZUMULEFZHIAJFIBJFZUNUOKIALMNO
      IBLPQOZABMPRSTUAULUBCDZBEBUBEFZULUREFZBBBUCUDUBEBBBPQPQPQUEUFUGUPIUBJFUSU
      TKUQIUBLUHUIOBUBPUHRSTUJUGUK @.
      @( [ ?] @) @( [8-Aug-2005] @)

  @{
    @d A w z @.  @d B w z @.
    neighre.1 @e |- A e. _V @.
    neighre.2 @e |- B e. _V @.
    @( Every neighborhood is a subset of ` RR ` .  (Contributed by Roy F.
      Longton, 8-Aug-2005.) @)
    neighre @p |- ( A neigh B -> A C_ RR ) @=
      ( vz vw cneigh wbr cr wss wcel wa cc0 cv clt cle caddc co cmin wi wral
      wrex neighbr pm3.26bi pm3.26d ) ABGHZAIJZBIKZUFUGUHLMENZOHMFNZPHUJUIOHLBU
      JQRAKBUJSRAKLTFIUALEIUBEFBACDUCUDUE @.
      @( [ ?] @) @( [9-Aug-2005] @)
  @}

  @(
  @{
    @d A w z @.  @d B w z @.
    ncenre.1 @e |- B e. _V @.
    This was probably not provable with the old df-neigh.
    ncenre @p |- ( A neigh B -> B e. RR ) @=
      cA cB cneigh wbr cB cr wcel cB cr wcel wa wi cA cB cneigh wbr cB cr
      wcel wi
      cA cB cneigh wbr cB cr wcel cB cr wcel ? ? jca cA cB cneigh wbr cB
      cr wcel
      cB cr wcel wa wi cA cB cneigh wbr cB cr wcel wi cA cB cneigh wbr cB
       cr wcel
      anidmdbi biimpi ax-mp @.
  @}
  @)

  @{
    @v et @.
    preneighlem.wet @f wff et @.
    preneighlem.1 @e |- ( ph -> ( ps -> ( ch -> ta ) ) ) @.
    preneighlem.2 @e |- ( ph -> ( ps -> ( th -> et ) ) ) @.
    @( Technical lemma for ~ preneigh .  This lemma is unusual because it is of
       a different branch of mathmatics than its parent theorem (the
       propositional calculus vs. real number analysis). @)
    preneighlem @p |- ( ph -> ( ps -> ( ( ch /\ th ) -> ( ta /\ et ) ) ) )
      @=
      ( wa wi imp com12 adantr impcom adantl jca exp31 ) ABCDIZEFIABIZRIEFRSECS
      EJDSCEABCEJGKLMNRSFDSFJCSDFABDFJHKLONPQ @.
      @( [ ?] @) @( [9-Aug-2005] @)
  @}

  @{
    @d A x z w @.
    preneigh.1 @e |- A e. RR @.
    preneigh @p |- ( 0 < A -> { x e. RR | 0 < x } neigh A ) @=
      ( vz vw cc0 clt wbr cv cr crab wss wcel wa cle caddc co cmin wi wral
      wrex cneigh ssrab2 a1i jca c2 cdiv 2nn nnrei nngt0i gt0ne0ii redivcli
      divgt0i2i wal cab wsbc wceq wex oprex cla4ev syl sbc5 sylibr df-sbc sylib
      df-rab eleq2i ex preneighlem ax-gen df-ral mpbir ax-1 ax-17 19.21 mpbi
      pm3.2i breq2 anbi2d imbi1d ralbidv anbi12d imbi2d rcla4ev ax-mp 19.37v
      reex rabex elisseti neighbr ) FBGHZFAIZGHZAJKZJLZBJMZNZFDIZGHZFEIZOHZWTWR
      GHZNZBWTPQZWNMZBWTRQZWNMZNZSZEJTZNZDJUAZNWNBUBHWKWQXLWKWOWPWOWKWMAJUCUDWP
      WKCUDUEWKXKSZDJUAZWKXLSBUFUGQZJMZWKFXOGHZXAWTXOGHZNZXHSZEJTZNZSZNXNXPYCBU
      FCUFUHUIZUFYDUFUHUJZUKULWKXQYABUFCYDYEUMWKXTSZEJTZWKYASYGWTJMZYFSZEUNYIEY
      HWKXAXRXEXGYHWKXAXESYHWKNZXAXEYJXANZXDWLJMWMNZAUOZMZXEYKYLAXDUPZYNYKWLXDU
      QYLNZAURZYOYK?YQ?YP?AXDBWTPUSZ?UTVAYLAXDYRVBVCYLAXDVDVEWNYMXDWMAJVFZVGVCV
      HVHYHWKXRXGSYJXRXGYJXRNZXFYMMZXGYTYLAXFUPZUUAYTWLXFUQYLNZAURZUUBYT?UUD?UU
      C?AXFBWTRUSZ?UTVAYLAXFUUEVBVCYLAXFVDVEWNYMXFYSVGVCVHVHVIVJYFEJVKVLWKXT?WK
      YHWKSZEUNZWKEJTWKUUFSZEUNWKUUGSUUHEWKYHVMVJWKUUFEWKEVNVOVPWKEJVKVCVOVPUEV
      QXMYCDXOJWRXOUQZXKYBWKUUIWSXQXJYAWRXOFGVRUUIXIXTEJUUIXCXSXHUUIXBXRXAWRXOW
      TGVRVSVTWAWBWCWDWEWKXK?WFVPUEDEBWNWMAJWGWHBJCWIWJVC @.
      @( [ ?] @) @( [9-Aug-2005] @)
  @}

  @{
    genneigh.1 @e |- A e. RR @.
    genneigh.2 @e |- B e. RR @.
    genneigh.3 @e |- C e. RR @.
    genneigh @p |- ( ( 0 < B /\ 0 < C ) -> { x e. RR |
      ( A - B ) < x /\ x < ( A + C ) } neigh A ) @=
      (  ) ? @.
  @}

  @{
    @d x y z w @.
    @( The class of all neighborhoods exists.
  (Contributed by Roy F. Longton,
      29-Aug-2005.) @)
    neighex @p |- neigh e. _V @=
      ( vx vy vz vw cneigh cv cr wss wcel wa cc0 clt wbr cle caddc co cmin wi
      wral wrex copab cvv df-neigh cpw cxp reex pwex xpex pm3.26 ssopab2i
      df-pw abeq2i anbi1i opabbii sseqtr4i df-xp ssexi
      eqeltri ) EAFZGHZBFZGIZJZK
      CFZLMKDFZNMVEVDLMJVAVEOPUSIVAVEQPUSIJRDGSJCGTZJZABUAZUBABCDUCVHGUDZGUEZVI
      GGUFUGUFUHVHUSVIIZVBJZABUAZVJVHVCABUAVMVGVCABVCVFUIUJVLVCABVKUTVBUTAVIAGU
      KULUMUNUOABVIGUPUOUQUR @.
      @( [ ?] @) @( [29-Aug-2005] @)
  @}



  @{
    @d x y z @.
    open @p |- ( x e. OpenROY <-> A. y e. x E. z ( z C_ x /\ z neigh y ) ) @=
      ( cv wss cneigh wbr wa wex wral copen df-openROY abeq2i ) CDZADZENBDFGHCI
      BOJAKABCLM @.
      @( [ ?] @) @( [10-Aug-2005] @)
  @}

    openex @p |- OpenROY e. _V @=
      (  ) ? @.

    reopen @p |- RR e. OpenROY @=
      (  ) ? @.

  @{
    openneigh.1 @e |- OpenROY A @.
    openneigh @p |- E. x e. RR A neigh x @=
      (  ) ? @.
  @}

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathboxes for user contributions
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Mathbox guidelines
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( (_This theorem is a dummy placeholder for these guidelines.  The name of
     this theorem, "mathbox", is hard-coded into the Metamath program to
     identify the start of the mathbox section for web page generation_.)

     A "mathbox" is a user-contributed section that is maintained by its
     contributor independently from the main part of set.mm.

     _For contributors_:

     By making a contribution, you agree to release it into the public domain,
     according to the statement at the beginning of set.mm.

     Mathboxes are provided to help keep your work synchronized with changes
     in set.mm, but they shouldn't be depended on as a permanent archive.  If
     you want to preserve your original contribution, it is your
     responsibility to keep your own copy of it along with the version of
     set.mm that works with it.

     _Guidelines_:

     1. If at all possible, please use only 0-ary class constants for new
        definitions.

     2. Try to follow the style of the rest of set.mm in terms of indentation,
        line length (79 characters or less), and comment markup (see
        "Auxiliary keywords" under HELP LANGUAGE in metamath.exe).  Each $p and
        $a statement must be immediately preceded with the comment that will be
        shown on its web page description.  All mathbox content will be on
        public display and should hopefully reflect the overall quality of the
        web site.

     3. Before submitting a revised mathbox, please make sure it verifies
        against the current set.mm.

     _Notes_:

     1. I may decide to move some theorems to the main part of set.mm for
        general use.  In that case, an author acknowledgment will be added to
        the description of the theorem.

     2. I may make changes to mathboxes to maintain the overall quality of
        set.mm.  Normally I will let you know if a change might impact what
        you are working on.

     3. If you use theorems from another user's mathbox, I don't provide
        assurance that they are based on correct or consistent $a statements.
        (If you find such a problem, please let me know so it can be
        corrected.) $)
  mathbox $p |- x = x $=
    vx equid $.
    $( [20-Feb-2007] $) $( [20-Feb-2007] $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Stefan Allan
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

 ${
   foo3.1 $e |- ph $.
   $( A theorem about the universal class. $)
   foo3 $p |- _V = { x | ph } $=
     cvv vx cv vx cv wceq vx cab wph vx cab vx df-v vx cv vx cv wceq wph vx vx
     cv vx cv wceq wph vx equid foo3.1 2th abbii eqtri $.
     $( [11-Dec-2008] $) $( [9-Dec-2008] $)
  $}

  $( A partial converse to ~ 19.9t . $)
  xfree $p |- ( A. x ( ph -> A. x ph ) <-> A. x ( E. x ph -> ph ) ) $=
    wph wph vx wal wi vx wal wph vx wex wph wi vx wal wph wph vx wal wi wph vx
    wex wph wi vx wph vx 19.9t a5i wph vx wex wph wi wph wph vx wal wi vx wph
    vx wex wph wi vx wal wph vx wex wph vx wal wph wph vx wex wph vx wph vx
    hbe1 stdpc5 wph vx 19.8a syl5 a5i impbii $.
    $( [21-Dec-2008] $) $( [21-Dec-2008] $)

  $( A partial converse to ~ 19.9t . $)
  xfree2 $p |- ( A. x ( ph -> A. x ph ) <-> A. x ( -. ph -> A. x -. ph ) ) $=
    wph wph vx wal wi vx wal wph vx wex wph wi vx wal wph wn wph wn vx wal wi
    vx wal wph vx xfree wph vx wex wph wi wph wn wph wn vx wal wi vx wph vx wex
    wph wi wph wn vx wal wn wph wi wph wn wph wn vx wal wi wph vx wex wph wn vx
    wal wn wph wph vx df-ex imbi1i wph wn vx wal wph con1b bitri albii bitri $.
    $( [21-Dec-2008] $) $( [21-Dec-2008] $)

  $( A proof readability experiment for ~ addltmul .  (Contributed by Stefan
     Allan, 30-Oct-2010.) $)
  addltmulALT $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 2 < A /\ 2 < B ) )
              -> ( A + B ) < ( A x. B ) ) $=
    cA cr wcel cB cr wcel wa c2 cA clt wbr c2 cB clt wbr wa wa c1 cA c1 cmin co
    clt wbr c1 cB c1 cmin co clt wbr wa cA cB caddc co cA cB cmul co clt wbr cA
    cr wcel c2 cA clt wbr cB cr wcel c2 cB clt wbr c1 cA c1 cmin co clt wbr c1
    cB c1 cmin co clt wbr wa cA cr wcel c2 cA clt wbr wa c1 cA c1 cmin co clt
    wbr cB cr wcel c2 cB clt wbr wa c1 cB c1 cmin co clt wbr cA cr wcel c2 cA
    clt wbr wa c2 cA clt wbr c1 cA c1 cmin co clt wbr cA cr wcel c2 cA clt wbr
    pm3.27 cA cr wcel c2 cA clt wbr wa c2 cA clt wbr c2 c1 cmin co cA c1 cmin
    co clt wbr c1 cA c1 cmin co clt wbr cA cr wcel c2 cA clt wbr wa c2 cr wcel
    cA cr wcel c1 cr wcel w3a c2 cA clt wbr c2 c1 cmin co cA c1 cmin co clt wbr
    wb cA cr wcel c2 cA clt wbr wa c2 cr wcel cA cr wcel c1 cr wcel c2 cr wcel
    cA cr wcel c2 cA clt wbr wa 2re a1i cA cr wcel c2 cA clt wbr pm3.26 c1 cr
    wcel cA cr wcel c2 cA clt wbr wa 1re a1i 3jca c2 cA c1 ltsub1 syl c2 c1
    cmin co cA c1 cmin co clt wbr c1 cA c1 cmin co clt wbr wb cA cr wcel c2 cA
    clt wbr wa c2 c1 cmin co c1 cA c1 cmin co clt c2 c1 c1 2cn ax1cn ax1cn c2
    c1 c1 caddc co df-2 eqcomi subaddrii breq1i a1i bitrd mpbid cB cr wcel c2
    cB clt wbr wa c2 cB clt wbr c1 cB c1 cmin co clt wbr cB cr wcel c2 cB clt
    wbr pm3.27 cB cr wcel c2 cB clt wbr wa c2 cB clt wbr c2 c1 cmin co cB c1
    cmin co clt wbr c1 cB c1 cmin co clt wbr cB cr wcel c2 cB clt wbr wa c2 cr
    wcel cB cr wcel c1 cr wcel w3a c2 cB clt wbr c2 c1 cmin co cB c1 cmin co
    clt wbr wb cB cr wcel c2 cB clt wbr wa c2 cr wcel cB cr wcel c1 cr wcel c2
    cr wcel cB cr wcel c2 cB clt wbr wa 2re a1i cB cr wcel c2 cB clt wbr pm3.26
    c1 cr wcel cB cr wcel c2 cB clt wbr wa 1re a1i 3jca c2 cB c1 ltsub1 syl c2
    c1 cmin co cB c1 cmin co clt wbr c1 cB c1 cmin co clt wbr wb cB cr wcel c2
    cB clt wbr wa c2 c1 cmin co c1 cB c1 cmin co clt c2 c1 c1 2cn ax1cn ax1cn
    c2 c1 c1 caddc co df-2 eqcomi subaddrii breq1i a1i bitrd mpbid anim12i an4s
    cA cr wcel cB cr wcel wa c2 cA clt wbr c2 cB clt wbr wa wa c1 cA c1 cmin co
    clt wbr c1 cB c1 cmin co clt wbr wa c1 cA c1 cmin co cB c1 cmin co cmul co
    clt wbr c1 cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co clt wbr cA cB caddc co cA cB cmul co clt wbr cA cr wcel cB
    cr wcel wa c1 cA c1 cmin co clt wbr c1 cB c1 cmin co clt wbr wa c1 cA c1
    cmin co cB c1 cmin co cmul co clt wbr wi c2 cA clt wbr c2 cB clt wbr wa cA
    cr wcel cB cr wcel wa c1 cA c1 cmin co clt wbr c1 cB c1 cmin co clt wbr wa
    c1 cA c1 cmin co cB c1 cmin co cmul co clt wbr cA cr wcel cB cr wcel wa c1
    cA c1 cmin co clt wbr c1 cB c1 cmin co clt wbr wa wa cA c1 cmin co cr wcel
    cB c1 cmin co cr wcel wa c1 cA c1 cmin co clt wbr c1 cB c1 cmin co clt wbr
    wa wa c1 cA c1 cmin co cB c1 cmin co cmul co clt wbr cA cr wcel cB cr wcel
    wa cA c1 cmin co cr wcel cB c1 cmin co cr wcel wa c1 cA c1 cmin co clt wbr
    c1 cB c1 cmin co clt wbr wa cA cr wcel cA c1 cmin co cr wcel cB cr wcel cB
    c1 cmin co cr wcel cA peano2rem cB peano2rem anim12i anim1i cA c1 cmin co
    cB c1 cmin co mulgt1 syl ex adantr cA cr wcel cB cr wcel wa c1 cA c1 cmin
    co cB c1 cmin co cmul co clt wbr c1 cA cB cmul co c1 c1 cmul co caddc co cA
    c1 cmul co cB c1 cmul co caddc co cmin co clt wbr wi c2 cA clt wbr c2 cB
    clt wbr wa cA cr wcel cB cr wcel wa c1 cA c1 cmin co cB c1 cmin co cmul co
    clt wbr c1 cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co clt wbr cA cr wcel cB cr wcel wa cA c1 cmin co cB c1 cmin
    co cmul co cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co c1 clt cA cr wcel cB cr wcel wa cA cc wcel c1 cc wcel wa
    cB cc wcel c1 cc wcel wa wa cA c1 cmin co cB c1 cmin co cmul co cA cB cmul
    co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co caddc co cmin co wceq
    cA cr wcel cA cc wcel c1 cc wcel wa cB cr wcel cB cc wcel c1 cc wcel wa cA
    cr wcel cA cc wcel c1 cc wcel cA recn c1 cc wcel cA cr wcel ax1cn a1i jca
    cB cr wcel cB cc wcel c1 cc wcel cB recn c1 cc wcel cB cr wcel ax1cn a1i
    jca anim12i cA c1 cB c1 mulsub syl breq2d biimpd adantr cA cr wcel cB cr
    wcel wa c1 cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1 cmul co
    caddc co cmin co clt wbr cA cB caddc co cA cB cmul co clt wbr wi c2 cA clt
    wbr c2 cB clt wbr wa cA cr wcel cB cr wcel wa c1 cA cB cmul co c1 c1 cmul
    co caddc co cA c1 cmul co cB c1 cmul co caddc co cmin co clt wbr c1 cA cB
    cmul co c1 caddc co cA cB caddc co cmin co clt wbr cA cB caddc co cA cB
    cmul co clt wbr cA cr wcel cB cr wcel wa cA cB cmul co c1 caddc co cA cB
    caddc co cmin co cA cB cmul co c1 c1 cmul co caddc co cA c1 cmul co cB c1
    cmul co caddc co cmin co c1 clt cA cr wcel cB cr wcel wa cA cB cmul co c1
    caddc co cA cB cmul co c1 c1 cmul co caddc co cA cB caddc co cA c1 cmul co
    cB c1 cmul co caddc co cmin cA cr wcel cB cr wcel wa c1 c1 c1 cmul co cA cB
    cmul co caddc c1 c1 c1 cmul co wceq cA cr wcel cB cr wcel wa c1 c1 cmul co
    c1 wceq c1 c1 c1 cmul co wceq c1 ax1cn mulid2i c1 c1 cmul co c1 wceq c1 c1
    c1 cmul co wceq c1 c1 cmul co c1 eqcom biimpi ax-mp a1i opreq2d cA cr wcel
    cB cr wcel wa cA cA c1 cmul co cB cB c1 cmul co caddc cA cr wcel cA cA c1
    cmul co wceq cB cr wcel cA cr wcel cA cc wcel cA cA c1 cmul co wceq cA recn
    cA cc wcel cA c1 cmul co cA wceq cA cA c1 cmul co wceq cA mulid1 cA c1 cmul
    co cA wceq cA cA c1 cmul co wceq cA c1 cmul co cA eqcom biimpi syl syl
    adantr cB cr wcel cB cB c1 cmul co wceq cA cr wcel cB cr wcel cB c1 cmul co
    cB wceq cB cB c1 cmul co wceq cB cr wcel cB cc wcel cB c1 cmul co cB wceq
    cB recn cB mulid1 syl cB c1 cmul co cB wceq cB cB c1 cmul co wceq cB c1
    cmul co cB eqcom biimpi syl adantl opreq12d opreq12d breq2d cA cr wcel cB
    cr wcel wa c1 cA cB cmul co c1 caddc co cA cB caddc co cmin co clt wbr cA
    cB caddc co c1 caddc co cA cB cmul co c1 caddc co clt wbr cA cB caddc co cA
    cB cmul co clt wbr cA cr wcel cB cr wcel wa cA cB caddc co cr wcel c1 cr
    wcel cA cB cmul co c1 caddc co cr wcel w3a cA cB caddc co c1 caddc co cA cB
    cmul co c1 caddc co clt wbr c1 cA cB cmul co c1 caddc co cA cB caddc co
    cmin co clt wbr wb cA cr wcel cB cr wcel wa cA cB caddc co cr wcel c1 cr
    wcel cA cB cmul co c1 caddc co cr wcel cA cB axaddrcl c1 cr wcel cA cr wcel
    cB cr wcel wa 1re a1i cA cr wcel cB cr wcel wa cA cB cmul co cr wcel c1 cr
    wcel wa cA cB cmul co c1 caddc co cr wcel cA cr wcel cB cr wcel wa cA cB
    cmul co cr wcel c1 cr wcel cA cB axmulrcl c1 cr wcel cA cr wcel cB cr wcel
    wa 1re a1i jca cA cB cmul co c1 readdcl syl 3jca cA cB caddc co c1 cA cB
    cmul co c1 caddc co ltaddsub2 syl cA cr wcel cB cr wcel wa cA cB caddc co
    c1 caddc co cA cB cmul co c1 caddc co clt wbr cA cB caddc co cA cB cmul co
    clt wbr cA cr wcel cB cr wcel wa cA cB caddc co cA cB cmul co clt wbr cA cB
    caddc co c1 caddc co cA cB cmul co c1 caddc co clt wbr cA cr wcel cB cr
    wcel wa cA cB caddc co cr wcel cA cB cmul co cr wcel c1 cr wcel w3a cA cB
    caddc co cA cB cmul co clt wbr cA cB caddc co c1 caddc co cA cB cmul co c1
    caddc co clt wbr wb cA cr wcel cB cr wcel wa cA cB caddc co cr wcel cA cB
    cmul co cr wcel c1 cr wcel cA cB axaddrcl cA cB axmulrcl c1 cr wcel cA cr
    wcel cB cr wcel wa 1re a1i 3jca cA cB caddc co cA cB cmul co c1 ltadd1 syl
    bicomd biimpd sylbird sylbird adantr 3syld mpd $.
    $( [30-Oct-2010] $) $( [30-Oct-2010] $)

$( (End of Stefan Allan's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Paul Chapman
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Miscellaneous theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Division of both sides of 'less than or equal to' by a nonnegative
       number. $)
    lediv2aALT $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
                       ( C e. RR /\ 0 <_ C ) ) ->
                     ( A <_ B -> ( C / B ) <_ ( C / A ) ) ) $=
      cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0
      cC cle wbr wa w3a c1 cB cdiv co c1 cA cdiv co cle wbr cC c1 cB cdiv co
      cmul co cC c1 cA cdiv co cmul co cle wbr cA cB cle wbr cC cB cdiv co cC
      cA cdiv co cle wbr cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr
      wa cC cr wcel cc0 cC cle wbr wa w3a c1 cB cdiv co cr wcel c1 cA cdiv co
      cr wcel cC cr wcel cc0 cC cle wbr wa w3a c1 cB cdiv co c1 cA cdiv co cle
      wbr cC c1 cB cdiv co cmul co cC c1 cA cdiv co cmul co cle wbr wi cA cr
      wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC cle
      wbr wa w3a c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel wa cC cr wcel cc0
      cC cle wbr wa wa c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel cC cr wcel
      cc0 cC cle wbr wa w3a cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt
      wbr wa cC cr wcel cc0 cC cle wbr wa w3a c1 cB cdiv co cr wcel c1 cA cdiv
      co cr wcel wa cC cr wcel cc0 cC cle wbr wa cA cr wcel cc0 cA clt wbr wa
      cB cr wcel cc0 cB clt wbr wa c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel
      wa cC cr wcel cc0 cC cle wbr wa cB cr wcel cc0 cB clt wbr wa cA cr wcel
      cc0 cA clt wbr wa c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel wa cB cr
      wcel cc0 cB clt wbr wa c1 cB cdiv co cr wcel cA cr wcel cc0 cA clt wbr wa
      c1 cA cdiv co cr wcel cB cr wcel cc0 cB clt wbr cB cc0 wne c1 cB cdiv co
      cr wcel cB gt0ne0 cB rereccl syldan cA cr wcel cc0 cA clt wbr cA cc0 wne
      c1 cA cdiv co cr wcel cA gt0ne0 cA rereccl syldan anim12i ancoms 3adant3
      cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0
      cC cle wbr wa 3simp3 jca c1 cB cdiv co cr wcel c1 cA cdiv co cr wcel cC
      cr wcel cc0 cC cle wbr wa df-3an sylibr c1 cB cdiv co c1 cA cdiv co cC
      lemul2aALT syl cA cr wcel cc0 cA clt wbr wa cB cr wcel cc0 cB clt wbr wa
      cA cB cle wbr c1 cB cdiv co c1 cA cdiv co cle wbr wb cC cr wcel cc0 cC
      cle wbr wa cA cB lerec 3adant3 cA cr wcel cc0 cA clt wbr wa cB cr wcel
      cc0 cB clt wbr wa cC cr wcel cc0 cC cle wbr wa w3a cC cB cdiv co cC c1 cB
      cdiv co cmul co cC cA cdiv co cC c1 cA cdiv co cmul co cle cB cr wcel cc0
      cB clt wbr wa cC cr wcel cc0 cC cle wbr wa cC cB cdiv co cC c1 cB cdiv co
      cmul co wceq cA cr wcel cc0 cA clt wbr wa cC cr wcel cc0 cC cle wbr wa cB
      cr wcel cc0 cB clt wbr wa cC cB cdiv co cC c1 cB cdiv co cmul co wceq cC
      cr wcel cc0 cC cle wbr wa cB cr wcel cc0 cB clt wbr wa wa cC cc wcel cB
      cc wcel cB cc0 wne w3a cC cB cdiv co cC c1 cB cdiv co cmul co wceq cC cr
      wcel cc0 cC cle wbr wa cB cr wcel cc0 cB clt wbr wa wa cC cc wcel cB cc
      wcel cB cc0 wne wa wa cC cc wcel cB cc wcel cB cc0 wne w3a cC cr wcel cc0
      cC cle wbr wa cC cc wcel cB cr wcel cc0 cB clt wbr wa cB cc wcel cB cc0
      wne wa cC cr wcel cC cc wcel cc0 cC cle wbr cC recn adantr cB cr wcel cc0
      cB clt wbr wa cB cc wcel cB cc0 wne cB cr wcel cB cc wcel cc0 cB clt wbr
      cB recn adantr cB gt0ne0 jca anim12i cC cc wcel cB cc wcel cB cc0 wne
      3anass sylibr cC cB divrec syl ancoms 3adant1 cA cr wcel cc0 cA clt wbr
      wa cC cr wcel cc0 cC cle wbr wa cC cA cdiv co cC c1 cA cdiv co cmul co
      wceq cB cr wcel cc0 cB clt wbr wa cC cr wcel cc0 cC cle wbr wa cA cr wcel
      cc0 cA clt wbr wa cC cA cdiv co cC c1 cA cdiv co cmul co wceq cC cr wcel
      cc0 cC cle wbr wa cA cr wcel cc0 cA clt wbr wa wa cC cc wcel cA cc wcel
      cA cc0 wne w3a cC cA cdiv co cC c1 cA cdiv co cmul co wceq cC cr wcel cc0
      cC cle wbr wa cA cr wcel cc0 cA clt wbr wa wa cC cc wcel cA cc wcel cA
      cc0 wne wa wa cC cc wcel cA cc wcel cA cc0 wne w3a cC cr wcel cc0 cC cle
      wbr wa cC cc wcel cA cr wcel cc0 cA clt wbr wa cA cc wcel cA cc0 wne wa
      cC cr wcel cC cc wcel cc0 cC cle wbr cC recn adantr cA cr wcel cc0 cA clt
      wbr wa cA cc wcel cA cc0 wne cA cr wcel cA cc wcel cc0 cA clt wbr cA recn
      adantr cA gt0ne0 jca anim12i cC cc wcel cA cc wcel cA cc0 wne 3anass
      sylibr cC cA divrec syl ancoms 3adant2 breq12d 3imtr4d $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    abs2sqlei.1 $e |- A e. CC $.
    abs2sqlei.2 $e |- B e. CC $.
    $( The absolute values of two numbers compare as their squares. $)
    abs2sqlei $p |- ( ( abs ` A ) <_ ( abs ` B ) <->
                     ( ( abs ` A ) ^ 2 ) <_ ( ( abs ` B ) ^ 2 ) ) $=
      cc0 cA cabs cfv cle wbr cc0 cB cabs cfv cle wbr cA cabs cfv cB cabs cfv
      cle wbr cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co cle wbr wb cA
      abs2sqlei.1 absge0i cB abs2sqlei.2 absge0i cA cabs cfv cB cabs cfv cA
      abs2sqlei.1 abscli cB abs2sqlei.2 abscli le2sqi mp2an $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    abs2sqlti.1 $e |- A e. CC $.
    abs2sqlti.2 $e |- B e. CC $.
    $( The absolute values of two numbers compare as their squares. $)
    abs2sqlti $p |- ( ( abs ` A ) < ( abs ` B ) <->
                     ( ( abs ` A ) ^ 2 ) < ( ( abs ` B ) ^ 2 ) ) $=
      cc0 cA cabs cfv cle wbr cc0 cB cabs cfv cle wbr cA cabs cfv cB cabs cfv
      clt wbr cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co clt wbr wb cA
      abs2sqlti.1 absge0i cB abs2sqlti.2 absge0i cA cabs cfv cB cabs cfv cA
      abs2sqlti.1 abscli cB abs2sqlti.2 abscli lt2sqi mp2an $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    $( The absolute values of two numbers compare as their squares. $)
    abs2sqle $p |- ( ( A e. CC /\ B e. CC ) ->
                      ( ( abs ` A ) <_ ( abs ` B ) <->
                        ( ( abs ` A ) ^ 2 ) <_ ( ( abs ` B ) ^ 2 ) ) ) $=
      cA cc wcel cB cc wcel cA cabs cfv cB cabs cfv cle wbr cA cabs cfv c2 cexp
      co cB cabs cfv c2 cexp co cle wbr wb cA cc wcel cA cc0 cif cabs cfv cB
      cabs cfv cle wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp co cB cabs cfv c2
      cexp co cle wbr wb cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0 cif
      cabs cfv cle wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp co cB cc wcel cB
      cc0 cif cabs cfv c2 cexp co cle wbr wb cA cB cc0 cc0 cA cA cc wcel cA cc0
      cif wceq cA cabs cfv cB cabs cfv cle wbr cA cc wcel cA cc0 cif cabs cfv
      cB cabs cfv cle wbr cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co cle wbr
      cA cc wcel cA cc0 cif cabs cfv c2 cexp co cB cabs cfv c2 cexp co cle wbr
      cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA cc0 cif cabs cfv
      cB cabs cfv cle cA cA cc wcel cA cc0 cif cabs fveq2 breq1d cA cA cc wcel
      cA cc0 cif wceq cA cabs cfv c2 cexp co cA cc wcel cA cc0 cif cabs cfv c2
      cexp co cB cabs cfv c2 cexp co cle cA cA cc wcel cA cc0 cif wceq cA cabs
      cfv cA cc wcel cA cc0 cif cabs cfv c2 cexp cA cA cc wcel cA cc0 cif cabs
      fveq2 opreq1d breq1d bibi12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA
      cc0 cif cabs cfv cB cabs cfv cle wbr cA cc wcel cA cc0 cif cabs cfv cB cc
      wcel cB cc0 cif cabs cfv cle wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp
      co cB cabs cfv c2 cexp co cle wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp
      co cB cc wcel cB cc0 cif cabs cfv c2 cexp co cle wbr cB cB cc wcel cB cc0
      cif wceq cB cabs cfv cB cc wcel cB cc0 cif cabs cfv cA cc wcel cA cc0 cif
      cabs cfv cle cB cB cc wcel cB cc0 cif cabs fveq2 breq2d cB cB cc wcel cB
      cc0 cif wceq cB cabs cfv cB cc wcel cB cc0 cif cabs cfv wceq cA cc wcel
      cA cc0 cif cabs cfv c2 cexp co cB cabs cfv c2 cexp co cle wbr cA cc wcel
      cA cc0 cif cabs cfv c2 cexp co cB cc wcel cB cc0 cif cabs cfv c2 cexp co
      cle wbr wb cB cB cc wcel cB cc0 cif cabs fveq2 cB cabs cfv cB cc wcel cB
      cc0 cif cabs cfv wceq cB cabs cfv c2 cexp co cB cc wcel cB cc0 cif cabs
      cfv c2 cexp co cA cc wcel cA cc0 cif cabs cfv c2 cexp co cle cB cabs cfv
      cB cc wcel cB cc0 cif cabs cfv c2 cexp opreq1 breq2d syl bibi12d cA cc
      wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
      elimel abs2sqlei dedth2h $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    $( The absolute values of two numbers compare as their squares. $)
    abs2sqlt $p |- ( ( A e. CC /\ B e. CC ) ->
                      ( ( abs ` A ) < ( abs ` B ) <->
                        ( ( abs ` A ) ^ 2 ) < ( ( abs ` B ) ^ 2 ) ) ) $=
      cA cc wcel cB cc wcel cA cabs cfv cB cabs cfv clt wbr cA cabs cfv c2 cexp
      co cB cabs cfv c2 cexp co clt wbr wb cA cc wcel cA cc0 cif cabs cfv cB
      cabs cfv clt wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp co cB cabs cfv c2
      cexp co clt wbr wb cA cc wcel cA cc0 cif cabs cfv cB cc wcel cB cc0 cif
      cabs cfv clt wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp co cB cc wcel cB
      cc0 cif cabs cfv c2 cexp co clt wbr wb cA cB cc0 cc0 cA cA cc wcel cA cc0
      cif wceq cA cabs cfv cB cabs cfv clt wbr cA cc wcel cA cc0 cif cabs cfv
      cB cabs cfv clt wbr cA cabs cfv c2 cexp co cB cabs cfv c2 cexp co clt wbr
      cA cc wcel cA cc0 cif cabs cfv c2 cexp co cB cabs cfv c2 cexp co clt wbr
      cA cA cc wcel cA cc0 cif wceq cA cabs cfv cA cc wcel cA cc0 cif cabs cfv
      cB cabs cfv clt cA cA cc wcel cA cc0 cif cabs fveq2 breq1d cA cA cc wcel
      cA cc0 cif wceq cA cabs cfv c2 cexp co cA cc wcel cA cc0 cif cabs cfv c2
      cexp co cB cabs cfv c2 cexp co clt cA cA cc wcel cA cc0 cif wceq cA cabs
      cfv cA cc wcel cA cc0 cif cabs cfv c2 cexp cA cA cc wcel cA cc0 cif cabs
      fveq2 opreq1d breq1d bibi12d cB cB cc wcel cB cc0 cif wceq cA cc wcel cA
      cc0 cif cabs cfv cB cabs cfv clt wbr cA cc wcel cA cc0 cif cabs cfv cB cc
      wcel cB cc0 cif cabs cfv clt wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp
      co cB cabs cfv c2 cexp co clt wbr cA cc wcel cA cc0 cif cabs cfv c2 cexp
      co cB cc wcel cB cc0 cif cabs cfv c2 cexp co clt wbr cB cB cc wcel cB cc0
      cif wceq cB cabs cfv cB cc wcel cB cc0 cif cabs cfv cA cc wcel cA cc0 cif
      cabs cfv clt cB cB cc wcel cB cc0 cif cabs fveq2 breq2d cB cB cc wcel cB
      cc0 cif wceq cB cabs cfv cB cc wcel cB cc0 cif cabs cfv wceq cA cc wcel
      cA cc0 cif cabs cfv c2 cexp co cB cabs cfv c2 cexp co clt wbr cA cc wcel
      cA cc0 cif cabs cfv c2 cexp co cB cc wcel cB cc0 cif cabs cfv c2 cexp co
      clt wbr wb cB cB cc wcel cB cc0 cif cabs fveq2 cB cabs cfv cB cc wcel cB
      cc0 cif cabs cfv wceq cB cabs cfv c2 cexp co cB cc wcel cB cc0 cif cabs
      cfv c2 cexp co cA cc wcel cA cc0 cif cabs cfv c2 cexp co clt cB cabs cfv
      cB cc wcel cB cc0 cif cabs cfv c2 cexp opreq1 breq2d syl bibi12d cA cc
      wcel cA cc0 cif cB cc wcel cB cc0 cif cA cc0 cc 0cn elimel cB cc0 cc 0cn
      elimel abs2sqlti dedth2h $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    abs2difi.1 $e |- A e. CC $.
    abs2difi.2 $e |- B e. CC $.
    $( Difference of absolute values. $)
    abs2difi $p |- ( ( abs ` A ) - ( abs ` B ) ) <_ ( abs ` ( A - B ) ) $=
      cA cc wcel cB cc wcel cA cabs cfv cB cabs cfv cmin co cA cB cmin co cabs
      cfv cle wbr abs2difi.1 abs2difi.2 cA cB abs2dif mp2an $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

  ${
    abs2difabsi.1 $e |- A e. CC $.
    abs2difabsi.2 $e |- B e. CC $.
    $( Absolute value of difference of absolute values. $)
    abs2difabsi $p |- ( abs ` ( ( abs ` A ) - ( abs ` B ) ) ) <_
                     ( abs ` ( A - B ) ) $=
      cA cc wcel cB cc wcel cA cabs cfv cB cabs cfv cmin co cabs cfv cA cB cmin
      co cabs cfv cle wbr abs2difabsi.1 abs2difabsi.2 cA cB abs2difabs mp2an $.
      $( [7-Sep-2007] $) $( [7-Sep-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Group homomorphism and isomorphism
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.  $d B y $.  $d F w x y z $.  $d G x y $.  $d H w x y z $.
    $d M y z $.  $d S x y $.  $d T x y $.  $d X w x y z $.  $d Z w x y z $.
    ghomgrpilem1.1 $e |- G e. Grp $.
    ghomgrpilem1.2 $e |- H e. Grp $.
    ghomgrpilem1.3 $e |- F e. ( G GrpHom H ) $.
    ghomgrpilem1.4 $e |- X = ran G $.
    ghomgrpilem1.5 $e |- U = ( Id ` G ) $.
    ghomgrpilem1.6 $e |- N = ( inv ` G ) $.
    ghomgrpilem1.7 $e |- W = ran H $.
    ghomgrpilem1.8 $e |- T = ( Id ` H ) $.
    ghomgrpilem1.9 $e |- M = ( inv ` H ) $.
    ghomgrpilem1.10 $e |- Z = ran F $.
    ghomgrpilem1.11 $e |- S = ( H |` ( Z X. Z ) ) $.

    $( Lemma for ~ ghomgrpi . $)
    ghomgrpilem1 $p |- ( ( A e. X /\ B e. X ) ->
                         ( ( F ` A ) H ( F ` B ) ) = ( F ` ( A G B ) ) ) $=
      cA cX wcel cA cF cfv vy cv cF cfv cH co cA vy cv cG co cF cfv wceq vy cX
      wral cB cX wcel cA cF cfv cB cF cfv cH co cA cB cG co cF cfv wceq vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral cA cF
      cfv vy cv cF cfv cH co cA vy cv cG co cF cfv wceq vy cX wral vx cA cX vx
      cv cA wceq vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq
      cA cF cfv vy cv cF cfv cH co cA vy cv cG co cF cfv wceq vy cX vx cv cA
      wceq vx cv cF cfv vy cv cF cfv cH co cA cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv cA vy cv cG co cF cfv vx cv cA wceq vx cv cF cfv cA cF
      cfv vy cv cF cfv cH vx cv cA cF fveq2 opreq1d vx cv cA wceq vx cv vy cv
      cG co cA vy cv cG co cF vx cv cA vy cv cG opreq1 fveq2d eqeq12d ralbidv
      cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq
      vy cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv cF cfv vy
      cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa
      ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cW cF wf
      vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral
      vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW cX
      ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.27i vtoclri cA cF cfv
      vy cv cF cfv cH co cA vy cv cG co cF cfv wceq cA cF cfv cB cF cfv cH co
      cA cB cG co cF cfv wceq vy cB cX vy cv cB wceq cA cF cfv vy cv cF cfv cH
      co cA cF cfv cB cF cfv cH co cA vy cv cG co cF cfv cA cB cG co cF cfv vy
      cv cB wceq vy cv cF cfv cB cF cfv cA cF cfv cH vy cv cB cF fveq2 opreq2d
      vy cv cB wceq cA vy cv cG co cA cB cG co cF vy cv cB cA cG opreq2 fveq2d
      eqeq12d rcla4v mpan9 $.
      $( [3-Mar-2008] $) $( [25-Feb-2008] $)

    $( Lemma for ~ ghomgrpi . $)
    ghomgrpilem2 $p |- S e. ( SubGrp ` H ) $=
      vx vy cT cH cS cM cW cZ ghomgrpilem1.2 ghomgrpilem1.7 ghomgrpilem1.8
      ghomgrpilem1.9 cZ cF crn cW ghomgrpilem1.10 cX cW cF wf cF crn cW wss cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv cF cfv vy cv
      cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa
      ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cW cF wf
      vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral
      vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW cX
      ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.26i cX cW cF frn
      ax-mp eqsstri ghomgrpilem1.11 vx cv cZ wcel vy cv cZ wcel wa vz cv cF cfv
      vx cv wceq vw cv cF cfv vy cv wceq wa vw cX wrex vz cX wrex vx cv vy cv
      cH co cZ wcel vx cv cZ wcel vy cv cZ wcel wa vz cv cF cfv vx cv wceq vz
      cX wrex vw cv cF cfv vy cv wceq vw cX wrex wa vz cv cF cfv vx cv wceq vw
      cv cF cfv vy cv wceq wa vw cX wrex vz cX wrex vx cv cZ wcel vz cv cF cfv
      vx cv wceq vz cX wrex vy cv cZ wcel vw cv cF cfv vy cv wceq vw cX wrex vx
      cv cZ wcel vz cv cF cfv vx cv wceq vz cX wrex vx cv cZ wcel vx cv cF crn
      wcel vz cv cF cfv vx cv wceq vz cX wrex cZ cF crn vx cv ghomgrpilem1.10
      eleq2i cF cX wfn vx cv cF crn wcel vz cv cF cfv vx cv wceq vz cX wrex wb
      cX cW cF wf cF cX wfn cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG
      co cF cfv wceq vy cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2
      vx vy cF cG cH cW cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi
      pm3.26i cX cW cF ffn ax-mp vz cX vx cv cF fvelrnb ax-mp bitri biimpi vy
      cv cZ wcel vw cv cF cfv vy cv wceq vw cX wrex vy cv cZ wcel vy cv cF crn
      wcel vw cv cF cfv vy cv wceq vw cX wrex cZ cF crn vy cv ghomgrpilem1.10
      eleq2i cF cX wfn vy cv cF crn wcel vw cv cF cfv vy cv wceq vw cX wrex wb
      cX cW cF wf cF cX wfn cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG
      co cF cfv wceq vy cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2
      vx vy cF cG cH cW cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi
      pm3.26i cX cW cF ffn ax-mp vw cX vy cv cF fvelrnb ax-mp bitri biimpi
      anim12i vz cv cF cfv vx cv wceq vw cv cF cfv vy cv wceq vz vw cX cX
      reeanv sylibr vz cv cF cfv vx cv wceq vw cv cF cfv vy cv wceq wa vx cv vy
      cv cH co cZ wcel vz vw cX cX vz cv cF cfv vx cv wceq vw cv cF cfv vy cv
      wceq wa vz cv cF cfv vw cv cF cfv cH co cZ wcel vx cv vy cv cH co cZ wcel
      vz cv cX wcel vw cv cX wcel wa vz cv cF cfv vx cv wceq vw cv cF cfv vy cv
      wceq wa vz cv cF cfv vw cv cF cfv cH co vx cv vy cv cH co cZ vz cv cF cfv
      vx cv vw cv cF cfv vy cv cH opreq12 eleq1d vz cv cX wcel vw cv cX wcel wa
      vz cv cF cfv vw cv cF cfv cH co vz cv vw cv cG co cF cfv cZ vz cv vw cv
      cS cT cU cF cG cH cM cN cW cX cZ ghomgrpilem1.1 ghomgrpilem1.2
      ghomgrpilem1.3 ghomgrpilem1.4 ghomgrpilem1.5 ghomgrpilem1.6
      ghomgrpilem1.7 ghomgrpilem1.8 ghomgrpilem1.9 ghomgrpilem1.10
      ghomgrpilem1.11 ghomgrpilem1 vz cv cX wcel vw cv cX wcel wa vz cv vw cv
      cG co cX wcel vz cv vw cv cG co cF cfv cZ wcel cG cgr wcel vz cv cX wcel
      vw cv cX wcel vz cv vw cv cG co cX wcel ghomgrpilem1.1 vz cv vw cv cG cX
      ghomgrpilem1.4 grpcl mp3an1 cX cZ vz cv vw cv cG co cF cX cZ cF wf cX cF
      crn cF wf cF cX wfn cX cF crn cF wf cX cW cF wf cF cX wfn cX cW cF wf vx
      cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx
      cX wral cF cG cH cghom co wcel cX cW cF wf vx cv cF cfv vy cv cF cfv cH
      co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa ghomgrpilem1.3
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cW cF wf vx cv cF cfv
      vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa
      wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW cX ghomgrpilem1.4
      ghomgrpilem1.7 elghom mp2an mpbi pm3.26i cX cW cF ffn ax-mp cX cF dffn3
      mpbi cZ cF crn wceq cX cZ cF wf cX cF crn cF wf wb ghomgrpilem1.10 cZ cF
      crn cX cF feq3 ax-mp mpbir ffvelrni syl eqeltrd syl5cbi r19.23aivv syl cT
      cU cF cfv cZ cT cH cgi cfv cU cF cfv ghomgrpilem1.8 cU cF cfv cH cgi cfv
      wceq cU cF cfv cU cF cfv cH co cU cF cfv wceq cU cF cfv cU cF cfv cH co
      cU cU cG co cF cfv cU cF cfv cU cX wcel cU cX wcel cU cF cfv cU cF cfv cH
      co cU cU cG co cF cfv wceq cG cgr wcel cU cX wcel ghomgrpilem1.1 cU cG cX
      ghomgrpilem1.4 ghomgrpilem1.5 grpidcl ax-mp cG cgr wcel cU cX wcel
      ghomgrpilem1.1 cU cG cX ghomgrpilem1.4 ghomgrpilem1.5 grpidcl ax-mp cU cU
      cS cT cU cF cG cH cM cN cW cX cZ ghomgrpilem1.1 ghomgrpilem1.2
      ghomgrpilem1.3 ghomgrpilem1.4 ghomgrpilem1.5 ghomgrpilem1.6
      ghomgrpilem1.7 ghomgrpilem1.8 ghomgrpilem1.9 ghomgrpilem1.10
      ghomgrpilem1.11 ghomgrpilem1 mp2an cU cU cG co cU cF cG cgr wcel cU cX
      wcel cU cU cG co cU wceq ghomgrpilem1.1 cG cgr wcel cU cX wcel
      ghomgrpilem1.1 cU cG cX ghomgrpilem1.4 ghomgrpilem1.5 grpidcl ax-mp cU cU
      cG cX ghomgrpilem1.4 ghomgrpilem1.5 grplid mp2an fveq2i eqtri cH cgr wcel
      cU cF cfv cW wcel cU cF cfv cH cgi cfv wceq cU cF cfv cU cF cfv cH co cU
      cF cfv wceq wb ghomgrpilem1.2 cX cW cF wf cU cX wcel cU cF cfv cW wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv cF cfv vy cv
      cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa
      ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cW cF wf
      vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral
      vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW cX
      ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.26i cG cgr wcel cU cX
      wcel ghomgrpilem1.1 cU cG cX ghomgrpilem1.4 ghomgrpilem1.5 grpidcl ax-mp
      cX cW cU cF ffvelrn mp2an cU cF cfv cH cgi cfv cH cW ghomgrpilem1.7 cH
      cgi cfv eqid grpid mp2an mpbir eqtr4i cX cZ cF wf cU cX wcel cU cF cfv cZ
      wcel cX cZ cF wf cX cF crn cF wf cF cX wfn cX cF crn cF wf cX cW cF wf cF
      cX wfn cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX
      wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW
      cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.26i cX cW cF ffn
      ax-mp cX cF dffn3 mpbi cZ cF crn wceq cX cZ cF wf cX cF crn cF wf wb
      ghomgrpilem1.10 cZ cF crn cX cF feq3 ax-mp mpbir cG cgr wcel cU cX wcel
      ghomgrpilem1.1 cU cG cX ghomgrpilem1.4 ghomgrpilem1.5 grpidcl ax-mp cX cZ
      cU cF ffvelrn mp2an eqeltri vx cv cZ wcel vz cv cF cfv vx cv wceq vz cX
      wrex vx cv cM cfv cZ wcel vx cv cZ wcel vx cv cF crn wcel vz cv cF cfv vx
      cv wceq vz cX wrex cZ cF crn vx cv ghomgrpilem1.10 eleq2i cF cX wfn vx cv
      cF crn wcel vz cv cF cfv vx cv wceq vz cX wrex wb cX cW cF wf cF cX wfn
      cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq
      vy cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv cF cfv vy
      cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa
      ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cW cF wf
      vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral
      vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW cX
      ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.26i cX cW cF ffn
      ax-mp vz cX vx cv cF fvelrnb ax-mp bitri vz cv cF cfv vx cv wceq vx cv cM
      cfv cZ wcel vz cX vz cv cF cfv vx cv wceq vz cv cF cfv cM cfv cZ wcel vx
      cv cM cfv cZ wcel vz cv cX wcel vz cv cF cfv vx cv wceq vz cv cF cfv cM
      cfv vx cv cM cfv cZ vz cv cF cfv vx cv cM fveq2 eleq1d vz cv cX wcel vz
      cv cF cfv cM cfv vz cv cN cfv cF cfv cZ vz cv cX wcel vz cv cF cfv cM cfv
      vz cv cN cfv cF cfv wceq vz cv cF cfv vz cv cN cfv cF cfv cH co cT wceq
      vz cv cX wcel vz cv cF cfv vz cv cN cfv cF cfv cH co cU cF cfv cT vz cv
      cX wcel vz cv cF cfv vz cv cN cfv cF cfv cH co vz cv vz cv cN cfv cG co
      cF cfv cU cF cfv vz cv cX wcel vz cv cN cfv cX wcel vz cv cF cfv vz cv cN
      cfv cF cfv cH co vz cv vz cv cN cfv cG co cF cfv wceq cG cgr wcel vz cv
      cX wcel vz cv cN cfv cX wcel ghomgrpilem1.1 vz cv cG cN cX ghomgrpilem1.4
      ghomgrpilem1.6 grpinvcl mpan vz cv vz cv cN cfv cS cT cU cF cG cH cM cN
      cW cX cZ ghomgrpilem1.1 ghomgrpilem1.2 ghomgrpilem1.3 ghomgrpilem1.4
      ghomgrpilem1.5 ghomgrpilem1.6 ghomgrpilem1.7 ghomgrpilem1.8
      ghomgrpilem1.9 ghomgrpilem1.10 ghomgrpilem1.11 ghomgrpilem1 mpdan vz cv
      cX wcel vz cv vz cv cN cfv cG co cU cF cG cgr wcel vz cv cX wcel vz cv vz
      cv cN cfv cG co cU wceq ghomgrpilem1.1 vz cv cU cG cN cX ghomgrpilem1.4
      ghomgrpilem1.5 ghomgrpilem1.6 grprinv mpan fveq2d eqtrd cT cH cgi cfv cU
      cF cfv ghomgrpilem1.8 cU cF cfv cH cgi cfv wceq cU cF cfv cU cF cfv cH co
      cU cF cfv wceq cU cF cfv cU cF cfv cH co cU cU cG co cF cfv cU cF cfv cU
      cX wcel cU cX wcel cU cF cfv cU cF cfv cH co cU cU cG co cF cfv wceq cG
      cgr wcel cU cX wcel ghomgrpilem1.1 cU cG cX ghomgrpilem1.4 ghomgrpilem1.5
      grpidcl ax-mp cG cgr wcel cU cX wcel ghomgrpilem1.1 cU cG cX
      ghomgrpilem1.4 ghomgrpilem1.5 grpidcl ax-mp cU cU cS cT cU cF cG cH cM cN
      cW cX cZ ghomgrpilem1.1 ghomgrpilem1.2 ghomgrpilem1.3 ghomgrpilem1.4
      ghomgrpilem1.5 ghomgrpilem1.6 ghomgrpilem1.7 ghomgrpilem1.8
      ghomgrpilem1.9 ghomgrpilem1.10 ghomgrpilem1.11 ghomgrpilem1 mp2an cU cU
      cG co cU cF cG cgr wcel cU cX wcel cU cU cG co cU wceq ghomgrpilem1.1 cG
      cgr wcel cU cX wcel ghomgrpilem1.1 cU cG cX ghomgrpilem1.4 ghomgrpilem1.5
      grpidcl ax-mp cU cU cG cX ghomgrpilem1.4 ghomgrpilem1.5 grplid mp2an
      fveq2i eqtri cH cgr wcel cU cF cfv cW wcel cU cF cfv cH cgi cfv wceq cU
      cF cfv cU cF cfv cH co cU cF cfv wceq wb ghomgrpilem1.2 cX cW cF wf cU cX
      wcel cU cF cfv cW wcel cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG
      co cF cfv wceq vy cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2
      vx vy cF cG cH cW cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi
      pm3.26i cG cgr wcel cU cX wcel ghomgrpilem1.1 cU cG cX ghomgrpilem1.4
      ghomgrpilem1.5 grpidcl ax-mp cX cW cU cF ffvelrn mp2an cU cF cfv cH cgi
      cfv cH cW ghomgrpilem1.7 cH cgi cfv eqid grpid mp2an mpbir eqtr4i syl6eqr
      vz cv cF cfv cW wcel vz cv cN cfv cF cfv cW wcel vz cv cF cfv cM cfv vz
      cv cN cfv cF cfv wceq vz cv cF cfv vz cv cN cfv cF cfv cH co cT wceq wb
      vz cv cX wcel cH cgr wcel vz cv cF cfv cW wcel vz cv cN cfv cF cfv cW
      wcel vz cv cF cfv cM cfv vz cv cN cfv cF cfv wceq vz cv cF cfv vz cv cN
      cfv cF cfv cH co cT wceq wb ghomgrpilem1.2 vz cv cF cfv vz cv cN cfv cF
      cfv cT cH cM cW ghomgrpilem1.7 ghomgrpilem1.8 ghomgrpilem1.9 grpinvid1
      mp3an1 cX cW vz cv cF cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG
      co cF cfv wceq vy cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2
      vx vy cF cG cH cW cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi
      pm3.26i ffvelrni vz cv cX wcel vz cv cN cfv cX wcel vz cv cN cfv cF cfv
      cW wcel cG cgr wcel vz cv cX wcel vz cv cN cfv cX wcel ghomgrpilem1.1 vz
      cv cG cN cX ghomgrpilem1.4 ghomgrpilem1.6 grpinvcl mpan cX cW vz cv cN
      cfv cF cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX
      wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW
      cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.26i ffvelrni syl
      sylanc mpbird vz cv cX wcel vz cv cN cfv cX wcel vz cv cN cfv cF cfv cZ
      wcel cG cgr wcel vz cv cX wcel vz cv cN cfv cX wcel ghomgrpilem1.1 vz cv
      cG cN cX ghomgrpilem1.4 ghomgrpilem1.6 grpinvcl mpan cX cZ vz cv cN cfv
      cF cX cZ cF wf cX cF crn cF wf cF cX wfn cX cF crn cF wf cX cW cF wf cF
      cX wfn cX cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cX wral vx cX wral cF cG cH cghom co wcel cX cW cF wf vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX
      wral wa ghomgrpilem1.3 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX
      cW cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy
      cX wral vx cX wral wa wb ghomgrpilem1.1 ghomgrpilem1.2 vx vy cF cG cH cW
      cX ghomgrpilem1.4 ghomgrpilem1.7 elghom mp2an mpbi pm3.26i cX cW cF ffn
      ax-mp cX cF dffn3 mpbi cZ cF crn wceq cX cZ cF wf cX cF crn cF wf wb
      ghomgrpilem1.10 cZ cF crn cX cF feq3 ax-mp mpbir ffvelrni syl eqeltrd
      syl5cbi r19.23aiv sylbi issubgi $.
      $( [3-Mar-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    ghomgrpi.1 $e |- G e. Grp $.
    ghomgrpi.2 $e |- H e. Grp $.
    ghomgrpi.3 $e |- F e. ( G GrpHom H ) $.
    ghomgrpi.4 $e |- Y = ran F $.
    ghomgrpi.5 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( The image of a group homomorphism from ` G ` to ` H ` is a subgroup of
       ` H ` (inference version).  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    ghomgrpi $p |- S e. ( SubGrp ` H ) $=
      cS cH cgi cfv cG cgi cfv cF cG cH cH cgn cfv cG cgn cfv cH crn cG crn cY
      ghomgrpi.1 ghomgrpi.2 ghomgrpi.3 cG crn eqid cG cgi cfv eqid cG cgn cfv
      eqid cH crn eqid cH cgi cfv eqid cH cgn cfv eqid ghomgrpi.4 ghomgrpi.5
      ghomgrpilem2 $.
      $( [3-Mar-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d A x y $.  $d G x y $.
    ghomsn.1 $e |- A e. _V $.
    ghomsn.2 $e |- G = { <. <. A , A >. , A >. } $.
    $( The endomorphism of the trivial group.  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    ghomsn $p |- ( _I |` { A } ) e. ( G GrpHom G ) $=
      cid cA csn cres cG cG cghom co wcel cA csn cA csn cid cA csn cres wf vx
      cv cid cA csn cres cfv vy cv cid cA csn cres cfv cG co vx cv vy cv cG co
      cid cA csn cres cfv wceq vy cA csn wral vx cA csn wral cG cgr wcel cG cgr
      wcel cid cA csn cres cG cG cghom co wcel cA csn cA csn cid cA csn cres wf
      vx cv cid cA csn cres cfv vy cv cid cA csn cres cfv cG co vx cv vy cv cG
      co cid cA csn cres cfv wceq vy cA csn wral vx cA csn wral wa wb cG cA cA
      cop cA cop csn cgr ghomsn.2 cA ghomsn.1 grpsn eqeltri cG cA cA cop cA cop
      csn cgr ghomsn.2 cA ghomsn.1 grpsn eqeltri vx vy cid cA csn cres cG cG cA
      csn cA csn cG crn cA cA cop cA cop csn crn cA csn cG cA cA cop cA cop csn
      ghomsn.2 rneqi cA cA cop cA cA cA opex ghomsn.1 rnsnop eqtr2i cG crn cA
      cA cop cA cop csn crn cA csn cG cA cA cop cA cop csn ghomsn.2 rneqi cA cA
      cop cA cA cA opex ghomsn.1 rnsnop eqtr2i elghom mp2an cA csn cA csn cid
      cA csn cres wf1o cA csn cA csn cid cA csn cres wf cA csn f1oi cA csn cA
      csn cid cA csn cres f1of ax-mp vx cv cid cA csn cres cfv vy cv cid cA csn
      cres cfv cG co vx cv vy cv cG co cid cA csn cres cfv wceq vx vy cA csn vx
      cv cA csn wcel vy cv cA csn wcel wa vx cv cid cA csn cres cfv vy cv cid
      cA csn cres cfv cG co vx cv vy cv cG co vx cv vy cv cG co cid cA csn cres
      cfv vx cv cA wceq vy cv cA wceq vx cv cid cA csn cres cfv vy cv cid cA
      csn cres cfv cG co vx cv vy cv cG co wceq vx cv cA csn wcel vy cv cA csn
      wcel vx cv cA wceq vy cv cA wceq wa vx cv cid cA csn cres cfv vy cv cid
      cA csn cres cfv cG co cA cA cG co vx cv vy cv cG co vx cv cA wceq vy cv
      cA wceq vx cv cid cA csn cres cfv cA vy cv cid cA csn cres cfv cA cG vx
      cv cA wceq vx cv cid cA csn cres cfv cA cid cA csn cres cfv cA vx cv cA
      cid cA csn cres fveq2 cA cA csn wcel cA cid cA csn cres cfv cA wceq cA
      ghomsn.1 snid cA csn cA fvresi ax-mp syl6eq vy cv cA wceq vy cv cid cA
      csn cres cfv cA cid cA csn cres cfv cA vy cv cA cid cA csn cres fveq2 cA
      cA csn wcel cA cid cA csn cres cfv cA wceq cA ghomsn.1 snid cA csn cA
      fvresi ax-mp syl6eq opreqan12d vx cv cA vy cv cA cG opreq12 eqtr4d vx cA
      elsn vy cA elsn syl2anb vx cv cA csn wcel vy cv cA csn wcel wa vx cv vy
      cv cG co cA csn wcel vx cv vy cv cG co cid cA csn cres cfv vx cv vy cv cG
      co wceq cG cgr wcel vx cv cA csn wcel vy cv cA csn wcel vx cv vy cv cG co
      cA csn wcel cG cA cA cop cA cop csn cgr ghomsn.2 cA ghomsn.1 grpsn
      eqeltri vx cv vy cv cG cA csn cG crn cA cA cop cA cop csn crn cA csn cG
      cA cA cop cA cop csn ghomsn.2 rneqi cA cA cop cA cA cA opex ghomsn.1
      rnsnop eqtr2i grpcl mp3an1 cA csn vx cv vy cv cG co fvresi syl eqtr4d
      rgen2a mpbir2an $.
      $( [3-Mar-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    ghomgrplem.1 $e |- ( ph ->
                          ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ) $.
    ghomgrplem.2 $e |- S = { <. <. z , z >. , z >. } $.
    ghomgrplem.3 $e |- J = ( _I |` { z } ) $.
    $( Lemma for ~ ghomgrp . $)
    ghomgrplem $p |- ( ph -> ( H |` ( ran F X. ran F ) ) e. ( SubGrp ` H ) ) $=
      wph cH cF crn cF crn cxp cres cH csubg cfv wcel wph cH cS cif cF crn cF
      crn cxp cres wph cH cS cif csubg cfv wcel wph cH cS cif wph cF cJ cif crn
      wph cF cJ cif crn cxp cres wph cH cS cif csubg cfv wcel cH cF cS cJ cH
      wph cH cS cif wceq cH cF crn cF crn cxp cres wph cH cS cif cF crn cF crn
      cxp cres cH csubg cfv wph cH cS cif csubg cfv cH wph cH cS cif cF crn cF
      crn cxp reseq1 cH wph cH cS cif csubg fveq2 eleq12d cF wph cF cJ cif wceq
      wph cH cS cif cF crn cF crn cxp cres wph cH cS cif wph cF cJ cif crn wph
      cF cJ cif crn cxp cres wph cH cS cif csubg cfv cF wph cF cJ cif wceq cF
      crn wph cF cJ cif crn wceq wph cH cS cif cF crn cF crn cxp cres wph cH cS
      cif wph cF cJ cif crn wph cF cJ cif crn cxp cres wceq cF wph cF cJ cif
      rneq cF crn wph cF cJ cif crn wceq cF crn cF crn cxp wph cF cJ cif crn
      wph cF cJ cif crn cxp wceq wph cH cS cif cF crn cF crn cxp cres wph cH cS
      cif wph cF cJ cif crn wph cF cJ cif crn cxp cres wceq cF crn wph cF cJ
      cif crn wceq cF crn cF crn cxp wph cF cJ cif crn cF crn cxp wph cF cJ cif
      crn wph cF cJ cif crn cxp cF crn wph cF cJ cif crn cF crn xpeq1 cF crn
      wph cF cJ cif crn wph cF cJ cif crn xpeq2 eqtrd cF crn cF crn cxp wph cF
      cJ cif crn wph cF cJ cif crn cxp wph cH cS cif reseq2 syl syl eleq1d wph
      cH cS cif wph cF cJ cif crn wph cF cJ cif crn cxp cres wph cF cJ cif wph
      cG cS cif wph cH cS cif wph cF cJ cif crn wph cG cgr wcel wph cG cS cif
      cgr wcel cS cgr wcel cG cS wph cG cgr wcel cH cgr wcel cF cG cH cghom co
      wcel ghomgrplem.1 3simp1d cG wph cG cS cif cgr eleq1 cS wph cG cS cif cgr
      eleq1 cS vz cv vz cv cop vz cv cop csn cgr ghomgrplem.2 vz cv vz visset
      grpsn eqeltri elimdhyp wph cH cgr wcel wph cH cS cif cgr wcel cS cgr wcel
      cH cS wph cG cgr wcel cH cgr wcel cF cG cH cghom co wcel ghomgrplem.1
      3simp2d cH wph cH cS cif cgr eleq1 cS wph cH cS cif cgr eleq1 cS vz cv vz
      cv cop vz cv cop csn cgr ghomgrplem.2 vz cv vz visset grpsn eqeltri
      elimdhyp wph cG cH cF cghom cS cS cJ wph cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel ghomgrplem.1 3simp3d cJ cid vz cv csn cres cS cS cghom co
      ghomgrplem.3 vz cv cS vz visset ghomgrplem.2 ghomsn eqeltri elimdeloprv
      wph cF cJ cif crn eqid wph cH cS cif wph cF cJ cif crn wph cF cJ cif crn
      cxp cres eqid ghomgrpi dedth2v $.
      $( [26-Mar-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    ghomgrp.1 $e |- Y = ran F $.
    ghomgrp.2 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( The image of a group homomorphism from ` G ` to ` H ` is a subgroup of
       ` H ` .  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    ghomgrp $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
                     S e. ( SubGrp ` H ) ) $=
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cH cF crn cF crn cxp
      cres cH csubg cfv cS cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a
      vx vx cv vx cv cop vx cv cop csn cF cG cH cid vx cv csn cres cG cgr wcel
      cH cgr wcel cF cG cH cghom co wcel w3a id vx cv vx cv cop vx cv cop csn
      eqid cid vx cv csn cres eqid ghomgrplem cS cH cY cY cxp cres cH cF crn cF
      crn cxp cres ghomgrp.2 cY cF crn wceq cH cY cY cxp cres cH cF crn cF crn
      cxp cres wceq ghomgrp.1 cY cF crn wceq cY cY cxp cF crn cF crn cxp wceq
      cH cY cY cxp cres cH cF crn cF crn cxp cres wceq cY cF crn xpid11 cY cY
      cxp cF crn cF crn cxp cH reseq2 sylbir ax-mp eqtri syl5eqel $.
      $( [26-Mar-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.  $d X x y $.
    ghomfo.1 $e |- X = ran G $.
    ghomfo.2 $e |- Y = ran F $.
    ghomfo.3 $e |- S = ( H |` ( Y X. Y ) ) $.
    ghomfo.4 $e |- Z = ran S $.

    $( A group homomorphism maps onto its image.  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomfo $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
                   F : X -onto-> Z ) $=
      cF cX wfn cF crn cZ wceq cX cZ cF wfo cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel w3a cX cZ cF wfo cF cX wfn cF crn cZ wceq wa cX cZ cF df-fo
      biimpri cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cH crn cF
      wf cF cX wfn cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cH crn
      cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX
      wral vx cX wral cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cH crn
      cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX
      wral vx cX wral wa vx vy cF cG cH cH crn cX ghomfo.1 cH crn eqid elghom
      biimp3a pm3.26d cX cH crn cF ffn syl cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel w3a cZ cY cF crn cG cgr wcel cH cgr wcel cF cG cH cghom co
      wcel w3a cZ cZ cxp cY cY cxp wceq cZ cY wceq cG cgr wcel cH cgr wcel cF
      cG cH cghom co wcel w3a cZ cZ cxp cH cY cY cxp cres cdm cY cY cxp cG cgr
      wcel cH cgr wcel cF cG cH cghom co wcel w3a cS cdm cZ cZ cxp cH cY cY cxp
      cres cdm cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cS cgr wcel
      cS cdm cZ cZ cxp wceq cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a
      cH cgr wcel cS cgr wcel cS cH wss cG cgr wcel cH cgr wcel cF cG cH cghom
      co wcel w3a cS cH csubg cfv wcel cH cgr wcel cS cgr wcel cS cH wss w3a cS
      cF cG cH cY ghomfo.2 ghomfo.3 ghomgrp cH cS issubg sylib 3simp2d cS cgr
      wcel cZ cZ cxp cZ cS wfo cZ cZ cxp cZ cS wf cS cdm cZ cZ cxp wceq cS cZ
      ghomfo.4 grpfo cZ cZ cxp cZ cS fof cZ cZ cxp cZ cS fdm 3syl syl cS cH cY
      cY cxp cres ghomfo.3 dmeqi syl5reqr cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel w3a cY cY cxp cH crn cH crn cxp wss cH cY cY cxp cres cdm
      cY cY cxp wceq cY cH crn wss cY cH crn wss cY cY cxp cH crn cH crn cxp
      wss cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cY cH crn cY cH
      crn ssxp cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cF crn cH crn
      cY cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cH crn cF wf cF
      crn cH crn wss cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cH
      crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq
      vy cX wral vx cX wral cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX
      cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv
      wceq vy cX wral vx cX wral wa vx vy cF cG cH cH crn cX ghomfo.1 cH crn
      eqid elghom biimp3a pm3.26d cX cH crn cF frn syl ghomfo.2 syl5ss cG cgr
      wcel cH cgr wcel cF cG cH cghom co wcel w3a cF crn cH crn cY cG cgr wcel
      cH cgr wcel cF cG cH cghom co wcel w3a cX cH crn cF wf cF crn cH crn wss
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cH crn cF wf vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX
      wral cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cH crn cF wf vx cv
      cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX
      wral wa vx vy cF cG cH cH crn cX ghomfo.1 cH crn eqid elghom biimp3a
      pm3.26d cX cH crn cF frn syl ghomfo.2 syl5ss sylanc cH cgr wcel cG cgr
      wcel cY cY cxp cH crn cH crn cxp wss cH cY cY cxp cres cdm cY cY cxp wceq
      wb cF cG cH cghom co wcel cH cgr wcel cY cY cxp cH cdm wss cY cY cxp cH
      crn cH crn cxp wss cH cY cY cxp cres cdm cY cY cxp wceq cH cgr wcel cH
      cdm cH crn cH crn cxp cY cY cxp cH cgr wcel cH crn cH crn cxp cH crn cH
      wfo cH crn cH crn cxp cH crn cH wf cH cdm cH crn cH crn cxp wceq cH cH
      crn cH crn eqid grpfo cH crn cH crn cxp cH crn cH fof cH crn cH crn cxp
      cH crn cH fdm 3syl sseq2d cY cY cxp cH ssdmres syl5rbbr 3ad2ant2 mpbid
      eqtrd cZ cY xpid11 sylib ghomfo.2 syl6req sylanc $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)

    $( Closure of a group homomorphism.  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomcl $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
                   ( A e. X -> ( F ` A ) e. Z ) ) $=
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cZ cF wfo cX cZ cF
      wf cA cX wcel cA cF cfv cZ wcel wi cS cF cG cH cX cY cZ ghomfo.1 ghomfo.2
      ghomfo.3 ghomfo.4 ghomfo cX cZ cF fof cX cZ cF wf cA cX wcel cA cF cfv cZ
      wcel cX cZ cA cF ffvelrn ex 3syl $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d A x y $.  $d B y $.  $d F x y $.  $d G x y $.  $d H x y $.  $d X x y $.
    ghomlin.1 $e |- X = ran G $.
    $( Linearity of a group homomorphism.  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomlin $p |- ( ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) /\
                      ( A e. X /\ B e. X ) ) ->
                    ( ( F ` A ) H ( F ` B ) ) = ( F ` ( A G B ) ) ) $=
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vx cv cF cfv vy cv cF
      cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral cA cX wcel
      cB cX wcel wa cA cF cfv cB cF cfv cH co cA cB cG co cF cfv wceq cG cgr
      wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cH crn cF wf vx cv cF cfv
      vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral cG
      cgr wcel cH cgr wcel cF cG cH cghom co wcel cX cH crn cF wf vx cv cF cfv
      vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq vy cX wral vx cX wral wa
      vx vy cF cG cH cH crn cX ghomlin.1 cH crn eqid elghom biimp3a pm3.27d vx
      cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv wceq cA cF cfv cB
      cF cfv cH co cA cB cG co cF cfv wceq cA cF cfv vy cv cF cfv cH co cA vy
      cv cG co cF cfv wceq vx vy cA cB cX cX vx cv cA wceq vx cv cF cfv vy cv
      cF cfv cH co cA cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv cA vy
      cv cG co cF cfv vx cv cA wceq vx cv cF cfv cA cF cfv vy cv cF cfv cH vx
      cv cA cF fveq2 opreq1d vx cv cA wceq vx cv vy cv cG co cA vy cv cG co cF
      vx cv cA vy cv cG opreq1 fveq2d eqeq12d vy cv cB wceq cA cF cfv vy cv cF
      cfv cH co cA cF cfv cB cF cfv cH co cA vy cv cG co cF cfv cA cB cG co cF
      cfv vy cv cB wceq vy cv cF cfv cB cF cfv cA cF cfv cH vy cv cB cF fveq2
      opreq2d vy cv cB wceq cA vy cv cG co cA cB cG co cF vy cv cB cA cG opreq2
      fveq2d eqeq12d rcla42v mpan9 $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.
    ghomid.1 $e |- U = ( Id ` G ) $.
    ghomid.2 $e |- T = ( Id ` H ) $.
    $( A group homomorphism maps identity element to identity element.
       (Contributed by Paul Chapman, 3-Mar-2008.) $)
    ghomid $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
                   ( F ` U ) = T ) $=
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cU cF cfv cT wceq cU
      cF cfv cU cF cfv cH co cU cF cfv wceq cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel w3a cU cF cfv cU cF cfv cH co cU cU cG co cF cfv cU cF cfv
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cU cG crn wcel cU cG
      crn wcel wa cU cF cfv cU cF cfv cH co cU cU cG co cF cfv wceq cG cgr wcel
      cH cgr wcel cF cG cH cghom co wcel w3a cU cG crn wcel cU cG crn wcel cG
      cgr wcel cH cgr wcel cU cG crn wcel cF cG cH cghom co wcel cU cG cG crn
      cG crn eqid ghomid.1 grpidcl 3ad2ant1 cG cgr wcel cH cgr wcel cU cG crn
      wcel cF cG cH cghom co wcel cU cG cG crn cG crn eqid ghomid.1 grpidcl
      3ad2ant1 jca cU cU cF cG cH cG crn cG crn eqid ghomlin mpdan cG cgr wcel
      cH cgr wcel cU cU cG co cF cfv cU cF cfv wceq cF cG cH cghom co wcel cG
      cgr wcel cU cU cG co cU cF cG cgr wcel cU cG crn wcel cU cU cG co cU wceq
      cU cG cG crn cG crn eqid ghomid.1 grpidcl cU cU cG cG crn cG crn eqid
      ghomid.1 grplid mpdan fveq2d 3ad2ant1 eqtrd cG cgr wcel cH cgr wcel cF cG
      cH cghom co wcel w3a cU cF cfv cH crn wcel cU cF cfv cT wceq cU cF cfv cU
      cF cfv cH co cU cF cfv wceq wb cG crn cH crn cF wf cU cG crn wcel cU cF
      cfv cH crn wcel cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cG crn
      cH crn cU cF ffvelrn cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a
      cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF
      cfv wceq vy cG crn wral vx cG crn wral cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa vx vy cF cG cH
      cH crn cG crn cG crn eqid cH crn eqid elghom biimp3a pm3.26d cG cgr wcel
      cH cgr wcel cU cG crn wcel cF cG cH cghom co wcel cU cG cG crn cG crn
      eqid ghomid.1 grpidcl 3ad2ant1 sylanc cH cgr wcel cG cgr wcel cU cF cfv
      cH crn wcel cU cF cfv cT wceq cU cF cfv cU cF cfv cH co cU cF cfv wceq wb
      wi cF cG cH cghom co wcel cH cgr wcel cU cF cfv cH crn wcel cU cF cfv cT
      wceq cU cF cfv cU cF cfv cH co cU cF cfv wceq wb cU cF cfv cT cH cH crn
      cH crn eqid ghomid.2 grpid ex 3ad2ant2 mpd mpbird $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.  $d S x y $.
    ghomgsg.1 $e |- Y = ran F $.
    ghomgsg.2 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( A group homomorphism from ` G ` to ` H ` is also a group homomorphism
       from ` G ` to its image in ` H ` .  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomgsg $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
                    F e. ( G GrpHom S ) ) $=
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cG crn cS crn cF wf vx
      cv cF cfv vy cv cF cfv cS co vx cv vy cv cG co cF cfv wceq vy cG crn wral
      vx cG crn wral cF cG cS cghom co wcel cG cgr wcel cH cgr wcel cF cG cH
      cghom co wcel w3a cG crn cS crn cF wfo cG crn cS crn cF wf cS cF cG cH cG
      crn cY cS crn cG crn eqid ghomgsg.1 ghomgsg.2 cS crn eqid ghomfo cG crn
      cS crn cF fof syl cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vx
      cv cF cfv vy cv cF cfv cS co vx cv vy cv cG co cF cfv wceq vy cG crn wral
      vx cG crn wral vx cv cF cfv vy cv cF cfv cH co vx cv vy cv cG co cF cfv
      wceq vy cG crn wral vx cG crn wral cG cgr wcel cH cgr wcel cF cG cH cghom
      co wcel w3a cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy
      cv cG co cF cfv wceq vy cG crn wral vx cG crn wral cG cgr wcel cH cgr
      wcel cF cG cH cghom co wcel cG crn cH crn cF wf vx cv cF cfv vy cv cF cfv
      cH co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa vx
      vy cF cG cH cH crn cG crn cG crn eqid cH crn eqid elghom biimp3a pm3.27d
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vx cv cF cfv vy cv cF
      cfv cS co vx cv vy cv cG co cF cfv wceq vx cv cF cfv vy cv cF cfv cH co
      vx cv vy cv cG co cF cfv wceq vx vy cG crn cG crn cG cgr wcel cH cgr wcel
      cF cG cH cghom co wcel w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vx
      cv cF cfv vy cv cF cfv cS co vx cv cF cfv vy cv cF cfv cH co vx cv vy cv
      cG co cF cfv cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vx cv cG
      crn wcel vy cv cG crn wcel wa vx cv cF cfv vy cv cF cfv cS co vx cv cF
      cfv vy cv cF cfv cH co wceq cG cgr wcel cH cgr wcel cF cG cH cghom co
      wcel w3a vx cv cF cfv cS crn wcel vy cv cF cfv cS crn wcel vx cv cF cfv
      vy cv cF cfv cS co vx cv cF cfv vy cv cF cfv cH co wceq vx cv cG crn wcel
      vy cv cG crn wcel cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cS
      cH csubg cfv wcel vx cv cF cfv cS crn wcel vy cv cF cfv cS crn wcel wa vx
      cv cF cfv vy cv cF cfv cS co vx cv cF cfv vy cv cF cfv cH co wceq wi cS
      cF cG cH cY ghomgsg.1 ghomgsg.2 ghomgrp vx cv cF cfv vy cv cF cfv cH cS
      cS crn cS crn eqid subgopr syl vx cv cS cF cG cH cG crn cY cS crn cG crn
      eqid ghomgsg.1 ghomgsg.2 cS crn eqid ghomcl vy cv cS cF cG cH cG crn cY
      cS crn cG crn eqid ghomgsg.1 ghomgsg.2 cS crn eqid ghomcl syl2and imp
      eqeq1d 2ralbidva mpbird cG cgr wcel cS cgr wcel cF cG cH cghom co wcel cG
      crn cS crn cF wf vx cv cF cfv vy cv cF cfv cS co vx cv vy cv cG co cF cfv
      wceq vy cG crn wral vx cG crn wral wa cF cG cS cghom co wcel wi cH cgr
      wcel cG cgr wcel cS cgr wcel cG crn cS crn cF wf vx cv cF cfv vy cv cF
      cfv cS co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa
      cF cG cS cghom co wcel wi cF cG cH cghom co wcel cG cgr wcel cS cgr wcel
      wa cF cG cS cghom co wcel cG crn cS crn cF wf vx cv cF cfv vy cv cF cfv
      cS co vx cv vy cv cG co cF cfv wceq vy cG crn wral vx cG crn wral wa vx
      vy cF cG cS cS crn cG crn cG crn eqid cS crn eqid elghom biimprd 3adant3
      cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cH cgr wcel cS cgr
      wcel cS cH wss cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cS cH
      csubg cfv wcel cH cgr wcel cS cgr wcel cS cH wss w3a cS cF cG cH cY
      ghomgsg.1 ghomgsg.2 ghomgrp cH cS issubg sylib 3simp2d syld3an2 mp2and $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d F x $.  $d G x $.  $d H x $.  $d T x $.  $d U x $.  $d X x $.  $d Z x $.
    ghomf1olem.1 $e |- X = ran G $.
    ghomf1olem.2 $e |- Y = ran F $.
    ghomf1olem.3 $e |- S = ( H |` ( Y X. Y ) ) $.
    ghomf1olem.4 $e |- Z = ran S $.
    ghomf1olem.5 $e |- U = ( Id ` G ) $.
    ghomf1olem.6 $e |- T = ( Id ` H ) $.

    ${
      $d F x y z $.  $d G y z $.  $d H y z $.  $d N x $.  $d T y z $.
      $d U y z $.  $d X y z $.
      ghomf1olem.7 $e |- N = ( inv ` G ) $.
      $( Lemma for ~ ghomf1o . $)
      ghomf1olem $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
          ( F : X -1-1-onto-> Z <-> A. x e. X ( ( F ` x ) = T -> x = U ) ) ) $=
        cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cZ cF wf1o vx cv
        cF cfv cT wceq vx cv cU wceq wi vx cX wral cG cgr wcel cH cgr wcel cF
        cG cH cghom co wcel w3a cX cZ cF wf1o vx cv cF cfv cT wceq vx cv cU
        wceq wi vx cX cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cX cZ
        cF wf1o vx cv cX wcel vx cv cF cfv cU cF cfv wceq vx cv cU wceq wi wi
        vx cv cX wcel vx cv cF cfv cT wceq vx cv cU wceq wi wi cG cgr wcel cH
        cgr wcel cF cG cH cghom co wcel w3a vy cv cF cfv vz cv cF cfv wceq vy
        cv vz cv wceq wi vz cX wral vy cX wral vx cv cX wcel vx cv cF cfv cU cF
        cfv wceq vx cv cU wceq wi wi cX cZ cF wf1o cG cgr wcel cH cgr wcel vy
        cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi vz cX wral vy cX wral
        vx cv cX wcel vx cv cF cfv cU cF cfv wceq vx cv cU wceq wi wi wi cF cG
        cH cghom co wcel cG cgr wcel vx cv cX wcel vy cv cF cfv vz cv cF cfv
        wceq vy cv vz cv wceq wi vz cX wral vy cX wral vx cv cF cfv cU cF cfv
        wceq vx cv cU wceq wi cG cgr wcel cU cX wcel vx cv cX wcel vy cv cF cfv
        vz cv cF cfv wceq vy cv vz cv wceq wi vz cX wral vy cX wral vx cv cF
        cfv cU cF cfv wceq vx cv cU wceq wi wi wi cU cG cX ghomf1olem.1
        ghomf1olem.5 grpidcl vx cv cX wcel cU cX wcel vy cv cF cfv vz cv cF cfv
        wceq vy cv vz cv wceq wi vz cX wral vy cX wral vx cv cF cfv cU cF cfv
        wceq vx cv cU wceq wi wi vy cv cF cfv vz cv cF cfv wceq vy cv vz cv
        wceq wi vx cv cF cfv cU cF cfv wceq vx cv cU wceq wi vx cv cF cfv vz cv
        cF cfv wceq vx cv vz cv wceq wi vy vz vx cv cU cX cX vy cv vx cv wceq
        vy cv cF cfv vz cv cF cfv wceq vx cv cF cfv vz cv cF cfv wceq vy cv vz
        cv wceq vx cv vz cv wceq vy cv vx cv wceq vy cv cF cfv vx cv cF cfv vz
        cv cF cfv vy cv vx cv cF fveq2 eqeq1d vy vx vz equequ1 imbi12d vz cv cU
        wceq vx cv cF cfv vz cv cF cfv wceq vx cv cF cfv cU cF cfv wceq vx cv
        vz cv wceq vx cv cU wceq vz cv cU wceq vz cv cF cfv cU cF cfv vx cv cF
        cfv vz cv cU cF fveq2 eqeq2d vz cv cU vx cv eqeq2 imbi12d rcla42v
        expcom syl com23 3ad2ant1 cX cZ cF wf1o cX cZ cF wf vy cv cF cfv vz cv
        cF cfv wceq vy cv vz cv wceq wi vz cX wral vy cX wral cX cZ cF wf1o cX
        cZ cF wf1 cX cZ cF wf vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq
        wi vz cX wral vy cX wral wa cX cZ cF f1of1 vy vz cX cZ cF dff13 sylib
        pm3.27d syl5 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vx cv
        cF cfv cU cF cfv wceq vx cv cU wceq wi vx cv cF cfv cT wceq vx cv cU
        wceq wi vx cv cX wcel cG cgr wcel cH cgr wcel cF cG cH cghom co wcel
        w3a vx cv cF cfv cU cF cfv wceq vx cv cF cfv cT wceq vx cv cU wceq cG
        cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a cU cF cfv cT vx cv cF
        cfv cT cU cF cG cH ghomf1olem.5 ghomf1olem.6 ghomid eqeq2d imbi1d
        imbi2d sylibd r19.21adv cG cgr wcel cH cgr wcel cF cG cH cghom co wcel
        w3a vx cv cF cfv cT wceq vx cv cU wceq wi vx cX wral cX cZ cF wf1o cX
        cZ cF wf1 cX cZ cF wfo cX cZ cF wf1o cG cgr wcel cH cgr wcel cF cG cH
        cghom co wcel w3a vx cv cF cfv cT wceq vx cv cU wceq wi vx cX wral wa
        cX cZ cF wf1o cX cZ cF wf1 cX cZ cF wfo wa cX cZ cF df-f1o biimpri cX
        cZ cF wf vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi vz cX wral
        vy cX wral cX cZ cF wf1 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel
        w3a vx cv cF cfv cT wceq vx cv cU wceq wi vx cX wral wa cX cZ cF wf1 cX
        cZ cF wf vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi vz cX wral
        vy cX wral wa vy vz cX cZ cF dff13 biimpri cG cgr wcel cH cgr wcel cF
        cG cH cghom co wcel w3a vx cv cF cfv cT wceq vx cv cU wceq wi vx cX
        wral wa cX cZ cF wfo cX cZ cF wf cG cgr wcel cH cgr wcel cF cG cH cghom
        co wcel w3a cX cZ cF wfo vx cv cF cfv cT wceq vx cv cU wceq wi vx cX
        wral cS cF cG cH cX cY cZ ghomf1olem.1 ghomf1olem.2 ghomf1olem.3
        ghomf1olem.4 ghomfo adantr cX cZ cF fof syl cG cgr wcel cH cgr wcel cF
        cG cH cghom co wcel w3a vx cv cF cfv cT wceq vx cv cU wceq wi vx cX
        wral wa vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi vy vz cX cX
        cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vx cv cF cfv cT wceq
        vx cv cU wceq wi vx cX wral vy cv cX wcel vz cv cX wcel wa vy cv cF cfv
        vz cv cF cfv wceq vy cv vz cv wceq wi wi cG cgr wcel cH cgr wcel cF cG
        cH cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa vx cv cF cfv cT
        wceq vx cv cU wceq wi vx cX wral vy cv cF cfv vz cv cF cfv wceq vy cv
        vz cv wceq wi cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv
        cX wcel vz cv cX wcel wa vx cv cF cfv cT wceq vx cv cU wceq wi vx cX
        wral vy cv cF cfv vz cv cF cfv wceq vy cv vz cv wceq wi wi cG cgr wcel
        cH cgr wcel cF cG cH cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa
        wa vx cv cF cfv cT wceq vx cv cU wceq wi vx cX wral vy cv vz cv cN cfv
        cG co cF cfv cT wceq vy cv vz cv cN cfv cG co cU wceq wi vy cv cF cfv
        vz cv cF cfv wceq vy cv vz cv wceq wi cG cgr wcel cH cgr wcel cF cG cH
        cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa vx cv cF cfv cT wceq
        vx cv cU wceq wi vx cX wral vy cv vz cv cN cfv cG co cF cfv cT wceq vy
        cv vz cv cN cfv cG co cU wceq wi wi cG cgr wcel cH cgr wcel cF cG cH
        cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa vy cv vz cv cN cfv cG
        co cX wcel vx cv cF cfv cT wceq vx cv cU wceq wi vx cX wral vy cv vz cv
        cN cfv cG co cF cfv cT wceq vy cv vz cv cN cfv cG co cU wceq wi wi cG
        cgr wcel cH cgr wcel vy cv cX wcel vz cv cX wcel wa vy cv vz cv cN cfv
        cG co cX wcel wi cF cG cH cghom co wcel cG cgr wcel vy cv cX wcel vz cv
        cX wcel vy cv vz cv cN cfv cG co cX wcel cG cgr wcel vy cv cX wcel vz
        cv cN cfv cX wcel vy cv vz cv cN cfv cG co cX wcel vz cv cX wcel vy cv
        vz cv cN cfv cG cX ghomf1olem.1 grpcl cG cgr wcel vz cv cX wcel vz cv
        cN cfv cX wcel vy cv cX wcel vz cv cG cN cX ghomf1olem.1 ghomf1olem.7
        grpinvcl 3adant2 syld3an3 3expib 3ad2ant1 vx cv cF cfv cT wceq vx cv cU
        wceq wi vy cv vz cv cN cfv cG co cF cfv cT wceq vy cv vz cv cN cfv cG
        co cU wceq wi vx vy cv vz cv cN cfv cG co cX vx cv vy cv vz cv cN cfv
        cG co wceq vx cv cF cfv cT wceq vy cv vz cv cN cfv cG co cF cfv cT wceq
        vx cv cU wceq vy cv vz cv cN cfv cG co cU wceq vx cv vy cv vz cv cN cfv
        cG co wceq vx cv cF cfv vy cv vz cv cN cfv cG co cF cfv cT vx cv vy cv
        vz cv cN cfv cG co cF fveq2 eqeq1d vx cv vy cv vz cv cN cfv cG co cU
        eqeq1 imbi12d rcla4v syl6 imp cG cgr wcel cH cgr wcel cF cG cH cghom co
        wcel w3a vy cv cX wcel vz cv cX wcel wa wa vy cv cF cfv vz cv cF cfv
        wceq vy cv vz cv cN cfv cG co cF cfv cT wceq vy cv vz cv cN cfv cG co
        cU wceq vy cv vz cv wceq cG cgr wcel cH cgr wcel cF cG cH cghom co wcel
        w3a vy cv cX wcel vz cv cX wcel wa vy cv cF cfv vz cv cF cfv wceq vy cv
        vz cv cN cfv cG co cF cfv cT wceq cG cgr wcel cH cgr wcel cF cG cH
        cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa vy cv cF cfv vz cv cF
        cfv wceq w3a vy cv cF cfv vz cv cN cfv cF cfv cH co vz cv cF cfv vz cv
        cN cfv cF cfv cH co vy cv vz cv cN cfv cG co cF cfv cT vy cv cF cfv vz
        cv cF cfv wceq cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv
        cF cfv vz cv cN cfv cF cfv cH co vz cv cF cfv vz cv cN cfv cF cfv cH co
        wceq vy cv cX wcel vz cv cX wcel wa vy cv cF cfv vz cv cF cfv vz cv cN
        cfv cF cfv cH opreq1 3ad2ant3 cG cgr wcel cH cgr wcel cF cG cH cghom co
        wcel w3a vy cv cX wcel vz cv cX wcel wa vy cv cF cfv vz cv cN cfv cF
        cfv cH co vy cv vz cv cN cfv cG co cF cfv wceq vy cv cF cfv vz cv cF
        cfv wceq cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv cX
        wcel vz cv cX wcel wa vy cv cX wcel vz cv cN cfv cX wcel wa vy cv cF
        cfv vz cv cN cfv cF cfv cH co vy cv vz cv cN cfv cG co cF cfv wceq cG
        cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv cX wcel vz cv cX
        wcel wa wa vy cv cX wcel vz cv cN cfv cX wcel cG cgr wcel cH cgr wcel
        cF cG cH cghom co wcel w3a vy cv cX wcel vz cv cX wcel simprl cG cgr
        wcel cH cgr wcel cF cG cH cghom co wcel w3a vz cv cX wcel vz cv cN cfv
        cX wcel vy cv cX wcel cG cgr wcel cH cgr wcel vz cv cX wcel vz cv cN
        cfv cX wcel cF cG cH cghom co wcel vz cv cG cN cX ghomf1olem.1
        ghomf1olem.7 grpinvcl 3ad2antl1 adantrl jca vy cv vz cv cN cfv cF cG cH
        cX ghomf1olem.1 ghomlin syldan 3adant3 cG cgr wcel cH cgr wcel cF cG cH
        cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa vz cv cF cfv vz cv cN
        cfv cF cfv cH co cT wceq vy cv cF cfv vz cv cF cfv wceq cG cgr wcel cH
        cgr wcel cF cG cH cghom co wcel w3a vy cv cX wcel vz cv cX wcel wa wa
        vz cv cF cfv vz cv cN cfv cF cfv cH co vz cv vz cv cN cfv cG co cF cfv
        cU cF cfv cT cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv
        cX wcel vz cv cX wcel wa vz cv cX wcel vz cv cN cfv cX wcel wa vz cv cF
        cfv vz cv cN cfv cF cfv cH co vz cv vz cv cN cfv cG co cF cfv wceq cG
        cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv cX wcel vz cv cX
        wcel wa wa vz cv cX wcel vz cv cN cfv cX wcel cG cgr wcel cH cgr wcel
        cF cG cH cghom co wcel w3a vy cv cX wcel vz cv cX wcel simprr cG cgr
        wcel cH cgr wcel cF cG cH cghom co wcel w3a vz cv cX wcel vz cv cN cfv
        cX wcel vy cv cX wcel cG cgr wcel cH cgr wcel vz cv cX wcel vz cv cN
        cfv cX wcel cF cG cH cghom co wcel vz cv cG cN cX ghomf1olem.1
        ghomf1olem.7 grpinvcl 3ad2antl1 adantrl jca vz cv vz cv cN cfv cF cG cH
        cX ghomf1olem.1 ghomlin syldan cG cgr wcel cH cgr wcel cF cG cH cghom
        co wcel w3a vy cv cX wcel vz cv cX wcel wa wa vz cv vz cv cN cfv cG co
        cU cF cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vz cv cX wcel
        vz cv vz cv cN cfv cG co cU wceq vy cv cX wcel cG cgr wcel cH cgr wcel
        vz cv cX wcel vz cv vz cv cN cfv cG co cU wceq cF cG cH cghom co wcel
        vz cv cU cG cN cX ghomf1olem.1 ghomf1olem.5 ghomf1olem.7 grprinv
        3ad2antl1 adantrl fveq2d cG cgr wcel cH cgr wcel cF cG cH cghom co wcel
        w3a cU cF cfv cT wceq vy cv cX wcel vz cv cX wcel wa cT cU cF cG cH
        ghomf1olem.5 ghomf1olem.6 ghomid adantr 3eqtrd 3adant3 3eqtr3d 3expia
        cG cgr wcel cH cgr wcel cF cG cH cghom co wcel w3a vy cv cX wcel vz cv
        cX wcel wa wa vy cv vz cv wceq vy cv vz cv cN cfv cG co cU wceq cG cgr
        wcel cH cgr wcel vy cv cX wcel vz cv cX wcel wa vy cv vz cv wceq vy cv
        vz cv cN cfv cG co cU wceq wb cF cG cH cghom co wcel cG cgr wcel vy cv
        cX wcel vz cv cX wcel vy cv vz cv wceq vy cv vz cv cN cfv cG co cU wceq
        wb cG cgr wcel vy cv cX wcel vz cv cX wcel w3a vz cv vy cv wceq vy cv
        vz cv cN cfv cG co cU wceq vy cv vz cv wceq cG cgr wcel vy cv cX wcel
        vz cv cX wcel w3a vz cv cN cfv cN cfv vy cv wceq vz cv vy cv wceq vy cv
        vz cv cN cfv cG co cU wceq cG cgr wcel vy cv cX wcel vz cv cX wcel w3a
        vz cv cN cfv cN cfv vz cv vy cv cG cgr wcel vz cv cX wcel vz cv cN cfv
        cN cfv vz cv wceq vy cv cX wcel vz cv cG cN cX ghomf1olem.1
        ghomf1olem.7 grp2inv 3adant2 eqeq1d cG cgr wcel vy cv cX wcel vz cv cN
        cfv cX wcel vz cv cN cfv cN cfv vy cv wceq vy cv vz cv cN cfv cG co cU
        wceq wb vz cv cX wcel cG cgr wcel vz cv cN cfv cX wcel vy cv cX wcel vz
        cv cN cfv cN cfv vy cv wceq vy cv vz cv cN cfv cG co cU wceq wb vz cv
        cN cfv vy cv cU cG cN cX ghomf1olem.1 ghomf1olem.5 ghomf1olem.7
        grpinvid2 3com23 cG cgr wcel vz cv cX wcel vz cv cN cfv cX wcel vy cv
        cX wcel vz cv cG cN cX ghomf1olem.1 ghomf1olem.7 grpinvcl 3adant2
        syld3an3 bitr3d vz vy equcom syl5bbr 3expb 3ad2antl1 biimprd imim12d
        syld ex com23 imp r19.21aivv sylanc cG cgr wcel cH cgr wcel cF cG cH
        cghom co wcel w3a cX cZ cF wfo vx cv cF cfv cT wceq vx cv cU wceq wi vx
        cX wral cS cF cG cH cX cY cZ ghomf1olem.1 ghomf1olem.2 ghomf1olem.3
        ghomf1olem.4 ghomfo adantr sylanc ex impbid $.
        $( [3-Mar-2008] $) $( [3-Mar-2008] $)
    $}

    $( Two ways of saying a group homomorphism is 1-1-onto its image.
       (Contributed by Paul Chapman, 3-Mar-2008.) $)
    ghomf1o $p |- ( ( G e. Grp /\ H e. Grp /\ F e. ( G GrpHom H ) ) ->
        ( F : X -1-1-onto-> Z <-> A. x e. X ( ( F ` x ) = T -> x = U ) ) ) $=
      vx cS cT cU cF cG cH cG cgn cfv cX cY cZ ghomf1olem.1 ghomf1olem.2
      ghomf1olem.3 ghomf1olem.4 ghomf1olem.5 ghomf1olem.6 cG cgn cfv eqid
      ghomf1olem $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d F f $.  $d G f g h s $.  $d H f g h s $.
    $( Membership in the set of group isomorphisms from ` G ` to ` H ` .
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    elgiso $p |- ( ( G e. Grp /\ H e. Grp ) -> ( F e. ( G GrpIso H ) <->
        ( F e. ( G GrpHom H ) /\ F : ran G -1-1-onto-> ran H ) ) ) $=
      cG cgr wcel cH cgr wcel wa cF cG cH cgiso co wcel cF cG crn cH crn vf cv
      wf1o vf cG cH cghom co crab wcel cF cG cH cghom co wcel cG crn cH crn cF
      wf1o wa cG cgr wcel cH cgr wcel wa cG cH cgiso co cG crn cH crn vf cv
      wf1o vf cG cH cghom co crab cF vg vh vs cG cH cgr cgr vg cv crn vh cv crn
      vf cv wf1o vf vg cv vh cv cghom co crab cG crn cH crn vf cv wf1o vf cG cH
      cghom co crab cgiso cG crn vh cv crn vf cv wf1o vf cG vh cv cghom co crab
      cG crn cH crn vf cv wf1o vf cG cH cghom co cG cH cghom oprex rabex vg cv
      cG wceq vg cv crn vh cv crn vf cv wf1o vf vg cv vh cv cghom co crab cG
      crn vh cv crn vf cv wf1o vf vg cv vh cv cghom co crab cG crn vh cv crn vf
      cv wf1o vf cG vh cv cghom co crab vg cv cG wceq vg cv crn vh cv crn vf cv
      wf1o cG crn vh cv crn vf cv wf1o vf vg cv vh cv cghom co vg cv cG wceq vg
      cv crn cG crn wceq vg cv crn vh cv crn vf cv wf1o cG crn vh cv crn vf cv
      wf1o wb vg cv cG rneq vg cv crn cG crn vh cv crn vf cv f1oeq2 syl
      rabbisdv vg cv cG wceq vg cv vh cv cghom co cG vh cv cghom co wceq cG crn
      vh cv crn vf cv wf1o vf vg cv vh cv cghom co crab cG crn vh cv crn vf cv
      wf1o vf cG vh cv cghom co crab wceq vg cv cG vh cv cghom opreq1 cG crn vh
      cv crn vf cv wf1o vf vg cv vh cv cghom co cG vh cv cghom co rabeq syl
      eqtrd vh cv cH wceq cG crn vh cv crn vf cv wf1o vf cG vh cv cghom co crab
      cG crn cH crn vf cv wf1o vf cG vh cv cghom co crab cG crn cH crn vf cv
      wf1o vf cG cH cghom co crab vh cv cH wceq cG crn vh cv crn vf cv wf1o cG
      crn cH crn vf cv wf1o vf cG vh cv cghom co vh cv cH wceq vh cv crn cH crn
      wceq cG crn vh cv crn vf cv wf1o cG crn cH crn vf cv wf1o wb vh cv cH
      rneq vh cv crn cH crn cG crn vf cv f1oeq3 syl rabbisdv vh cv cH wceq cG
      vh cv cghom co cG cH cghom co wceq cG crn cH crn vf cv wf1o vf cG vh cv
      cghom co crab cG crn cH crn vf cv wf1o vf cG cH cghom co crab wceq vh cv
      cH cG cghom opreq2 cG crn cH crn vf cv wf1o vf cG vh cv cghom co cG cH
      cghom co rabeq syl eqtrd vf vg vh vs df-giso oprabval2 eleq2d cG crn cH
      crn vf cv wf1o cG crn cH crn cF wf1o vf cF cG cH cghom co cG crn cH crn
      vf cv cF f1oeq1 elrab syl6bb $.
      $( [25-Feb-2008] $) $( [25-Feb-2008] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Symmetry groups and Cayley's Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.
    $( The symmetry group on ` A ` is a group.  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    symggrp $p |- ( A e. B -> ( SymGrp ` A ) e. Grp ) $=
      vx cv csymgrp cfv cgr wcel cA csymgrp cfv cgr wcel vx cA cB vx cv cA wceq
      vx cv csymgrp cfv cA csymgrp cfv cgr vx cv cA csymgrp fveq2 eleq1d vx cv
      vx visset symggrpi vtoclg $.
      $( [25-Feb-2008] $) $( [25-Feb-2008] $)
  $}

  ${
    $d A a b f g h $.  $d F f w x y z $.  $d G a b c f g h w x y z $.
    $d H w x y z $.  $d P c g h $.  $d S y $.  $d U a b y $.
    $d X a b c f g h w x y z $.  $d Y y $.

    cayleylem1.1 $e |- G e. Grp $.
    cayleylem1.2 $e |- P = { f | f : X -1-1-onto-> X } $.
    cayleylem1.3 $e |- X = ran G $.
    cayleylem1.4 $e |- U = ( Id ` G ) $.
    cayleylem1.5 $e |- H = ( SymGrp ` X ) $.
    cayleylem1.6 $e |- F = { <. g , h >. | ( g e. X /\ h = { <. a , b >. |
                             ( a e. X /\ b = ( g G a ) ) } ) } $.
    cayleylem1.7 $e |- Y = ran F $.
    cayleylem1.8 $e |- S = ( H |` ( Y X. Y ) ) $.

    $( Lemma for ~ cayleyi . $)
    cayleylem1 $p |- ( A e. X -> ( F ` A ) e. P ) $=
      cA cX wcel cX cX cA cF cfv wf1o cA cF cfv cP wcel cG cgr wcel cA cX wcel
      cX cX cA cF cfv wf1o cayleylem1.1 cA vg vh cF cG cX va vb cayleylem1.6
      cayleylem1.3 grplactf1o mpan vf cX cP cA cF cfv cX cG crn cvv
      cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp
      eqeltri cayleylem1.2 elsymgrn sylibr $.
      $( [18-Mar-2008] $) $( [3-Mar-2008] $)

    $( Lemma for ~ cayleyi . $)
    cayleylem2 $p |- F e. ( G GrpHom H ) $=
      cF cG cH cghom co wcel cX cP cF wf vx cv cF cfv vy cv cF cfv cH co vx cv
      vy cv cG co cF cfv wceq vy cX wral vx cX wral cG cgr wcel cH cgr wcel cF
      cG cH cghom co wcel cX cP cF wf vx cv cF cfv vy cv cF cfv cH co vx cv vy
      cv cG co cF cfv wceq vy cX wral vx cX wral wa wb cayleylem1.1 cH cX
      csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG
      crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri vx
      vy cF cG cH cP cX cayleylem1.3 cP cX csymgrp cfv crn cH crn cX csymgrp
      cfv cP cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel
      cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi cP cP cxp cP cX csymgrp
      cfv vf cX cP cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel
      cayleylem1.1 cG cgr rnexg ax-mp eqeltri cayleylem1.2 symgf fdmi grprn cH
      cX csymgrp cfv cayleylem1.5 rneqi eqtr4i elghom mp2an va cv cX wcel vb cv
      vc cv va cv cG co wceq wa va vb copab cP wcel vc cX wral cX cP cF wf va
      cv cX wcel vb cv vc cv va cv cG co wceq wa va vb copab cP wcel vc cX vc
      cv cX wcel vc cv cF cfv va cv cX wcel vb cv vc cv va cv cG co wceq wa va
      vb copab cP cG cgr wcel vc cv cX wcel vc cv cF cfv va cv cX wcel vb cv vc
      cv va cv cG co wceq wa va vb copab wceq cayleylem1.1 vc cv vg vh cF cG cX
      va vb cayleylem1.6 cayleylem1.3 grplactfval mpan vc cv cP cS cU vf vg vh
      cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4
      cayleylem1.5 cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem1 eqeltrrd
      rgen va cv cX wcel vb cv vc cv va cv cG co wceq wa va vb copab cP wcel vc
      cX wral va cv cX wcel vb cv vg cv va cv cG co wceq wa va vb copab cP wcel
      vg cX wral cX cP cF wf va cv cX wcel vb cv vc cv va cv cG co wceq wa va
      vb copab cP wcel va cv cX wcel vb cv vg cv va cv cG co wceq wa va vb
      copab cP wcel vc vg cX vc cv vg cv wceq va cv cX wcel vb cv vc cv va cv
      cG co wceq wa va vb copab va cv cX wcel vb cv vg cv va cv cG co wceq wa
      va vb copab cP vc cv vg cv wceq va cv cX wcel vb cv vc cv va cv cG co
      wceq wa va cv cX wcel vb cv vg cv va cv cG co wceq wa va vb vc cv vg cv
      wceq vb cv vc cv va cv cG co wceq vb cv vg cv va cv cG co wceq va cv cX
      wcel vc cv vg cv wceq vc cv va cv cG co vg cv va cv cG co vb cv vc cv vg
      cv va cv cG opreq1 eqeq2d anbi2d opabbidv eleq1d cbvralv vg vh cX cP va
      cv cX wcel vb cv vg cv va cv cG co wceq wa va vb copab cF cayleylem1.6
      fopab2 bitri mpbi vz cv cF cfv vw cv cF cfv cH co vz cv vw cv cG co cF
      cfv wceq vw cX wral vz cX wral vx cv cF cfv vy cv cF cfv cH co vx cv vy
      cv cG co cF cfv wceq vy cX wral vx cX wral vz cv cF cfv vw cv cF cfv cH
      co vz cv vw cv cG co cF cfv wceq vz vw cX vz cv cX wcel vw cv cX wcel wa
      vz cv cF cfv vw cv cF cfv cH co vz cv cF cfv vw cv cF cfv ccom vz cv vw
      cv cG co cF cfv vz cv cX wcel vw cv cX wcel wa vz cv cF cfv vw cv cF cfv
      cX csymgrp cfv co vz cv cF cfv vw cv cF cfv ccom vz cv cF cfv vw cv cF
      cfv cH co vz cv cF cfv cP wcel vw cv cF cfv cP wcel vz cv cF cfv vw cv cF
      cfv cX csymgrp cfv co vz cv cF cfv vw cv cF cfv ccom wceq vz cv cX wcel
      vw cv cX wcel vf cX cP vz cv cF cfv vw cv cF cfv cX cG crn cvv
      cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp
      eqeltri cayleylem1.2 symgoprv vz cv cP cS cU vf vg vh cF cG cH cX cY va
      vb cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5
      cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem1 vw cv cP cS cU vf vg vh
      cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4
      cayleylem1.5 cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem1 syl2an cH
      cX csymgrp cfv vz cv cF cfv vw cv cF cfv cayleylem1.5 opreqi syl5eq vz cv
      cX wcel vw cv cX wcel wa vx cv vz cv cF cfv vw cv cF cfv ccom cfv vx cv
      vz cv vw cv cG co cF cfv cfv wceq vx cX wral vz cv cF cfv vw cv cF cfv
      ccom vz cv vw cv cG co cF cfv wceq vz cv cX wcel vw cv cX wcel wa vx cv
      vz cv cF cfv vw cv cF cfv ccom cfv vx cv vz cv vw cv cG co cF cfv cfv
      wceq vx cX vz cv cX wcel vw cv cX wcel vx cv cX wcel vx cv vz cv cF cfv
      vw cv cF cfv ccom cfv vx cv vz cv vw cv cG co cF cfv cfv wceq vz cv cX
      wcel vw cv cX wcel vx cv cX wcel w3a vz cv vw cv cG co vx cv cG co vz cv
      vw cv vx cv cG co cG co vx cv vz cv vw cv cG co cF cfv cfv vx cv vz cv cF
      cfv vw cv cF cfv ccom cfv cG cgr wcel vz cv cX wcel vw cv cX wcel vx cv
      cX wcel w3a vz cv vw cv cG co vx cv cG co vz cv vw cv vx cv cG co cG co
      wceq cayleylem1.1 vz cv vw cv vx cv cG cX cayleylem1.3 grpass mpan vz cv
      cX wcel vw cv cX wcel vx cv cX wcel vx cv vz cv vw cv cG co cF cfv cfv vz
      cv vw cv cG co vx cv cG co wceq vz cv vw cv cG co cX wcel vx cv cX wcel
      vx cv vz cv vw cv cG co cF cfv cfv vz cv vw cv cG co vx cv cG co wceq vz
      cv cX wcel vw cv cX wcel wa cG cgr wcel vz cv vw cv cG co cX wcel vx cv
      cX wcel vx cv vz cv vw cv cG co cF cfv cfv vz cv vw cv cG co vx cv cG co
      wceq cayleylem1.1 vz cv vw cv cG co vx cv vg vh cF cG cX va vb
      cayleylem1.6 cayleylem1.3 grplactval mp3an1 cG cgr wcel vz cv cX wcel vw
      cv cX wcel vz cv vw cv cG co cX wcel cayleylem1.1 vz cv vw cv cG cX
      cayleylem1.3 grpcl mp3an1 sylan 3impa vz cv cX wcel vw cv cX wcel vx cv
      cX wcel w3a vx cv vz cv cF cfv vw cv cF cfv ccom cfv vx cv vw cv cF cfv
      cfv vz cv cF cfv cfv vw cv vx cv cG co vz cv cF cfv cfv vz cv vw cv vx cv
      cG co cG co vz cv cX wcel vw cv cX wcel vx cv cX wcel vx cv vz cv cF cfv
      vw cv cF cfv ccom cfv vx cv vw cv cF cfv cfv vz cv cF cfv cfv wceq vz cv
      cF cfv wfun vw cv cF cfv cX wfn vx cv cX wcel vx cv vz cv cF cfv vw cv cF
      cfv ccom cfv vx cv vw cv cF cfv cfv vz cv cF cfv cfv wceq wi vz cv cX
      wcel vw cv cX wcel vz cv cF cfv wfun vw cv cF cfv cX wfn vx cv cX wcel vx
      cv vz cv cF cfv vw cv cF cfv ccom cfv vx cv vw cv cF cfv cfv vz cv cF cfv
      cfv wceq cX vx cv vz cv cF cfv vw cv cF cfv fvco2 3expia vz cv cX wcel vz
      cv cF cfv cX wfn vz cv cF cfv wfun vz cv cX wcel cX cX vz cv cF cfv wf1o
      cX cX vz cv cF cfv wf vz cv cF cfv cX wfn vz cv cX wcel vz cv cF cfv cP
      wcel cX cX vz cv cF cfv wf1o vz cv cP cS cU vf vg vh cF cG cH cX cY va vb
      cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5
      cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem1 vf cX cP vz cv cF cfv
      cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG
      cgr rnexg ax-mp eqeltri cayleylem1.2 elsymgrn sylib cX cX vz cv cF cfv
      f1of cX cX vz cv cF cfv ffn 3syl cX vz cv cF cfv fnfun syl vw cv cX wcel
      cX cX vw cv cF cfv wf1o cX cX vw cv cF cfv wf vw cv cF cfv cX wfn vw cv
      cX wcel vw cv cF cfv cP wcel cX cX vw cv cF cfv wf1o vw cv cP cS cU vf vg
      vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2 cayleylem1.3
      cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7 cayleylem1.8
      cayleylem1 vf cX cP vw cv cF cfv cX cG crn cvv cayleylem1.3 cG cgr wcel
      cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri cayleylem1.2
      elsymgrn sylib cX cX vw cv cF cfv f1of cX cX vw cv cF cfv ffn 3syl syl2an
      3impia vw cv cX wcel vx cv cX wcel vx cv vw cv cF cfv cfv vz cv cF cfv
      cfv vw cv vx cv cG co vz cv cF cfv cfv wceq vz cv cX wcel vw cv cX wcel
      vx cv cX wcel wa vx cv vw cv cF cfv cfv vw cv vx cv cG co vz cv cF cfv cG
      cgr wcel vw cv cX wcel vx cv cX wcel vx cv vw cv cF cfv cfv vw cv vx cv
      cG co wceq cayleylem1.1 vw cv vx cv vg vh cF cG cX va vb cayleylem1.6
      cayleylem1.3 grplactval mp3an1 fveq2d 3adant1 vz cv cX wcel vw cv cX wcel
      vx cv cX wcel vw cv vx cv cG co vz cv cF cfv cfv vz cv vw cv vx cv cG co
      cG co wceq vz cv cX wcel vw cv vx cv cG co cX wcel vw cv vx cv cG co vz
      cv cF cfv cfv vz cv vw cv vx cv cG co cG co wceq vw cv cX wcel vx cv cX
      wcel wa cG cgr wcel vz cv cX wcel vw cv vx cv cG co cX wcel vw cv vx cv
      cG co vz cv cF cfv cfv vz cv vw cv vx cv cG co cG co wceq cayleylem1.1 vz
      cv vw cv vx cv cG co vg vh cF cG cX va vb cayleylem1.6 cayleylem1.3
      grplactval mp3an1 cG cgr wcel vw cv cX wcel vx cv cX wcel vw cv vx cv cG
      co cX wcel cayleylem1.1 vw cv vx cv cG cX cayleylem1.3 grpcl mp3an1
      sylan2 3impb 3eqtrd 3eqtr4rd 3expia r19.21aiv vz cv cX wcel vw cv cX wcel
      wa vz cv cF cfv vw cv cF cfv ccom vz cv vw cv cG co cF cfv wceq vx cv vz
      cv cF cfv vw cv cF cfv ccom cfv vx cv vz cv vw cv cG co cF cfv cfv wceq
      vx cX wral vz cv cF cfv vw cv cF cfv ccom cX wfn vz cv vw cv cG co cF cfv
      cX wfn vz cv cF cfv vw cv cF cfv ccom vz cv vw cv cG co cF cfv wceq vx cv
      vz cv cF cfv vw cv cF cfv ccom cfv vx cv vz cv vw cv cG co cF cfv cfv
      wceq vx cX wral wb vz cv cX wcel vw cv cX wcel wa vx cX vz cv cF cfv vw
      cv cF cfv ccom vz cv vw cv cG co cF cfv eqfnfv2 vz cv cX wcel vw cv cX
      wcel vz cv cF cfv vw cv cF cfv ccom cX wfn vz cv cF cfv cX wfn vw cv cF
      cfv cX wfn vw cv cF cfv crn cX wss vz cv cF cfv vw cv cF cfv ccom cX wfn
      vz cv cX wcel vw cv cX wcel vw cv cX wcel cX cX vz cv cF cfv vw cv cF cfv
      fnco vz cv cX wcel cX cX vz cv cF cfv wf1o cX cX vz cv cF cfv wf vz cv cF
      cfv cX wfn vz cv cX wcel vz cv cF cfv cP wcel cX cX vz cv cF cfv wf1o vz
      cv cP cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem1 vf cX cP vz cv cF cfv cX cG crn cvv cayleylem1.3
      cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri
      cayleylem1.2 elsymgrn sylib cX cX vz cv cF cfv f1of cX cX vz cv cF cfv
      ffn 3syl vw cv cX wcel cX cX vw cv cF cfv wf1o cX cX vw cv cF cfv wf vw
      cv cF cfv cX wfn vw cv cX wcel vw cv cF cfv cP wcel cX cX vw cv cF cfv
      wf1o vw cv cP cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1
      cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6
      cayleylem1.7 cayleylem1.8 cayleylem1 vf cX cP vw cv cF cfv cX cG crn cvv
      cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp
      eqeltri cayleylem1.2 elsymgrn sylib cX cX vw cv cF cfv f1of cX cX vw cv
      cF cfv ffn 3syl vw cv cX wcel cX cX vw cv cF cfv wf1o cX cX vw cv cF cfv
      wf vw cv cF cfv crn cX wss vw cv cX wcel vw cv cF cfv cP wcel cX cX vw cv
      cF cfv wf1o vw cv cP cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1
      cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6
      cayleylem1.7 cayleylem1.8 cayleylem1 vf cX cP vw cv cF cfv cX cG crn cvv
      cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp
      eqeltri cayleylem1.2 elsymgrn sylib cX cX vw cv cF cfv f1of cX cX vw cv
      cF cfv frn 3syl syl3an 3anidm23 vz cv cX wcel vw cv cX wcel wa vz cv vw
      cv cG co cX wcel vz cv vw cv cG co cF cfv cX wfn cG cgr wcel vz cv cX
      wcel vw cv cX wcel vz cv vw cv cG co cX wcel cayleylem1.1 vz cv vw cv cG
      cX cayleylem1.3 grpcl mp3an1 vz cv vw cv cG co cX wcel cX cX vz cv vw cv
      cG co cF cfv wf1o cX cX vz cv vw cv cG co cF cfv wf vz cv vw cv cG co cF
      cfv cX wfn vz cv vw cv cG co cX wcel vz cv vw cv cG co cF cfv cP wcel cX
      cX vz cv vw cv cG co cF cfv wf1o vz cv vw cv cG co cP cS cU vf vg vh cF
      cG cH cX cY va vb cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4
      cayleylem1.5 cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem1 vf cX cP
      vz cv vw cv cG co cF cfv cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn
      cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri cayleylem1.2 elsymgrn
      sylib cX cX vz cv vw cv cG co cF cfv f1of cX cX vz cv vw cv cG co cF cfv
      ffn 3syl syl sylanc biimprd mpd eqtrd rgen2a vz cv cF cfv vw cv cF cfv cH
      co vz cv vw cv cG co cF cfv wceq vx cv cF cfv vy cv cF cfv cH co vx cv vy
      cv cG co cF cfv wceq vx cv cF cfv vw cv cF cfv cH co vx cv vw cv cG co cF
      cfv wceq vz vw vx vy cX cX vz cv vx cv wceq vz cv cF cfv vw cv cF cfv cH
      co vx cv cF cfv vw cv cF cfv cH co vz cv vw cv cG co cF cfv vx cv vw cv
      cG co cF cfv vz cv vx cv wceq vz cv cF cfv vx cv cF cfv vw cv cF cfv cH
      vz cv vx cv cF fveq2 opreq1d vz cv vx cv wceq vz cv vw cv cG co vx cv vw
      cv cG co cF vz cv vx cv vw cv cG opreq1 fveq2d eqeq12d vw cv vy cv wceq
      vx cv cF cfv vw cv cF cfv cH co vx cv cF cfv vy cv cF cfv cH co vx cv vw
      cv cG co cF cfv vx cv vy cv cG co cF cfv vw cv vy cv wceq vw cv cF cfv vy
      cv cF cfv vx cv cF cfv cH vw cv vy cv cF fveq2 opreq2d vw cv vy cv wceq
      vx cv vw cv cG co vx cv vy cv cG co cF vw cv vy cv vx cv cG opreq2 fveq2d
      eqeq12d cbvral2v mpbi mpbir2an $.
      $( [25-Jul-2008] $) $( [3-Mar-2008] $)

    $( Lemma for ~ cayleyi . $)
    cayleylem3 $p |- ( S e. ( SubGrp ` H ) /\ F e. ( G GrpIso S ) ) $=
      cS cH csubg cfv wcel cF cG cS cgiso co wcel cS cF cG cH cY cayleylem1.1
      cH cX csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr
      wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi
      eqeltri cP cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem2 cayleylem1.7 cayleylem1.8 ghomgrpi cF cG cS cgiso
      co wcel cF cG cS cghom co wcel cG crn cS crn cF wf1o cG cgr wcel cS cgr
      wcel cF cG cS cgiso co wcel cF cG cS cghom co wcel cG crn cS crn cF wf1o
      wa wb cayleylem1.1 cH cgr wcel cS cgr wcel cS cH wss cS cH csubg cfv wcel
      cH cgr wcel cS cgr wcel cS cH wss w3a cS cF cG cH cY cayleylem1.1 cH cX
      csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG
      crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri cP
      cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem2 cayleylem1.7 cayleylem1.8 ghomgrpi cH cS issubg
      mpbi 3simp2i cF cG cS elgiso mp2an cG cgr wcel cH cgr wcel cF cG cH cghom
      co wcel cF cG cS cghom co wcel cayleylem1.1 cH cX csymgrp cfv cgr
      cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel
      cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri cP cS cU vf vg
      vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2 cayleylem1.3
      cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7 cayleylem1.8
      cayleylem2 cS cF cG cH cY cayleylem1.7 cayleylem1.8 ghomgsg mp3an cX cY
      cF wf1o cG crn cS crn cF wf1o cX cY cF wf1o vy cv cF cfv cS cgi cfv wceq
      vy cv cU wceq wi vy cX cG cgr wcel cS cgr wcel cF cG cS cghom co wcel cX
      cY cF wf1o vy cv cF cfv cS cgi cfv wceq vy cv cU wceq wi vy cX wral wb
      cayleylem1.1 cH cgr wcel cS cgr wcel cS cH wss cS cH csubg cfv wcel cH
      cgr wcel cS cgr wcel cS cH wss w3a cS cF cG cH cY cayleylem1.1 cH cX
      csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG
      crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri cP
      cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem2 cayleylem1.7 cayleylem1.8 ghomgrpi cH cS issubg
      mpbi 3simp2i cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cF cG cS
      cghom co wcel cayleylem1.1 cH cX csymgrp cfv cgr cayleylem1.5 cX cX cG
      crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr
      rnexg ax-mp eqeltri symggrpi eqeltri cP cS cU vf vg vh cF cG cH cX cY va
      vb cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5
      cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem2 cS cF cG cH cY
      cayleylem1.7 cayleylem1.8 ghomgsg mp3an vy cS cS cgi cfv cU cF cG cS cX
      cY cY cayleylem1.3 cayleylem1.7 cS cY cY cxp cres cS cS cgr wcel cS cY cY
      cxp cres cS wceq cH cgr wcel cS cgr wcel cS cH wss cS cH csubg cfv wcel
      cH cgr wcel cS cgr wcel cS cH wss w3a cS cF cG cH cY cayleylem1.1 cH cX
      csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG
      crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri cP
      cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem2 cayleylem1.7 cayleylem1.8 ghomgrpi cH cS issubg
      mpbi 3simp2i cS cgr wcel cS cY cY cxp wfn cS cY cY cxp cres cS wceq cS
      cgr wcel cY cY cxp cY cS wfo cS cY cY cxp wfn cS cY cY cF crn cS crn
      cayleylem1.7 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel cF crn cS crn
      wceq cayleylem1.1 cH cX csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv
      cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp
      eqeltri symggrpi eqeltri cP cS cU vf vg vh cF cG cH cX cY va vb
      cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5
      cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem2 cG cgr wcel cH cgr wcel
      cF cG cH cghom co wcel w3a cX cS crn cF wfo cF crn cS crn wceq cS cF cG
      cH cX cY cS crn cayleylem1.3 cayleylem1.7 cayleylem1.8 cS crn eqid ghomfo
      cX cS crn cF forn syl mp3an eqtri grpfo cY cY cxp cY cS fofn syl cY cY
      cxp cS fnresdm syl ax-mp eqcomi cY cF crn cS crn cayleylem1.7 cG cgr wcel
      cH cgr wcel cF cG cH cghom co wcel cF crn cS crn wceq cayleylem1.1 cH cX
      csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG
      crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri cP
      cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem2 cG cgr wcel cH cgr wcel cF cG cH cghom co wcel
      w3a cX cS crn cF wfo cF crn cS crn wceq cS cF cG cH cX cY cS crn
      cayleylem1.3 cayleylem1.7 cayleylem1.8 cS crn eqid ghomfo cX cS crn cF
      forn syl mp3an eqtri cayleylem1.4 cS cgi cfv eqid ghomf1o mp3an vy cv cX
      wcel cU vy cv cF cfv cfv cU wceq vy cv cU wceq vy cv cF cfv cS cgi cfv
      wceq vy cv cX wcel cU vy cv cF cfv cfv vy cv cU vy cv cX wcel cU vy cv cF
      cfv cfv vy cv cU cG co vy cv cG cgr wcel vy cv cX wcel cU cX wcel cU vy
      cv cF cfv cfv vy cv cU cG co wceq cayleylem1.1 cG cgr wcel cU cX wcel
      cayleylem1.1 cU cG cX cayleylem1.3 cayleylem1.4 grpidcl ax-mp vy cv cU vg
      vh cF cG cX va vb cayleylem1.6 cayleylem1.3 grplactval mp3an13 cG cgr
      wcel vy cv cX wcel vy cv cU cG co vy cv wceq cayleylem1.1 vy cv cU cG cX
      cayleylem1.3 cayleylem1.4 grprid mpan eqtrd eqeq1d vy cv cF cfv cS cgi
      cfv wceq vy cv cF cfv cid cX cres wceq cU vy cv cF cfv cfv cU wceq cid cX
      cres cS cgi cfv vy cv cF cfv cS cgi cfv cH cgi cfv cid cX cres cS cH
      csubg cfv wcel cS cgi cfv cH cgi cfv wceq cS cF cG cH cY cayleylem1.1 cH
      cX csymgrp cfv cgr cayleylem1.5 cX cX cG crn cvv cayleylem1.3 cG cgr wcel
      cG crn cvv wcel cayleylem1.1 cG cgr rnexg ax-mp eqeltri symggrpi eqeltri
      cP cS cU vf vg vh cF cG cH cX cY va vb cayleylem1.1 cayleylem1.2
      cayleylem1.3 cayleylem1.4 cayleylem1.5 cayleylem1.6 cayleylem1.7
      cayleylem1.8 cayleylem2 cayleylem1.7 cayleylem1.8 ghomgrpi cS cgi cfv cH
      cgi cfv cH cS cH cgi cfv eqid cS cgi cfv eqid subgid ax-mp cH cgi cfv cX
      csymgrp cfv cgi cfv cid cX cres cH cX csymgrp cfv cgi cayleylem1.5 fveq2i
      cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG
      cgr rnexg ax-mp eqeltri symgidi eqtri eqtr2i eqeq2i vy cv cF cfv cid cX
      cres wceq cU vy cv cF cfv cfv cU cid cX cres cfv cU cU vy cv cF cfv cid
      cX cres fveq1 cU cX wcel cU cid cX cres cfv cU wceq cG cgr wcel cU cX
      wcel cayleylem1.1 cU cG cX cayleylem1.3 cayleylem1.4 grpidcl ax-mp cX cU
      fvresi ax-mp syl6eq sylbir syl5bi mprgbir cX cY cF wf1o cX cS crn cF wf1o
      cG crn cS crn cF wf1o cY cS crn wceq cX cY cF wf1o cX cS crn cF wf1o wb
      cY cF crn cS crn cayleylem1.7 cG cgr wcel cH cgr wcel cF cG cH cghom co
      wcel cF crn cS crn wceq cayleylem1.1 cH cX csymgrp cfv cgr cayleylem1.5
      cX cX cG crn cvv cayleylem1.3 cG cgr wcel cG crn cvv wcel cayleylem1.1 cG
      cgr rnexg ax-mp eqeltri symggrpi eqeltri cP cS cU vf vg vh cF cG cH cX cY
      va vb cayleylem1.1 cayleylem1.2 cayleylem1.3 cayleylem1.4 cayleylem1.5
      cayleylem1.6 cayleylem1.7 cayleylem1.8 cayleylem2 cG cgr wcel cH cgr wcel
      cF cG cH cghom co wcel w3a cX cS crn cF wfo cF crn cS crn wceq cS cF cG
      cH cX cY cS crn cayleylem1.3 cayleylem1.7 cayleylem1.8 cS crn eqid ghomfo
      cX cS crn cF forn syl mp3an eqtri cY cS crn cX cF f1oeq3 ax-mp cX cG crn
      wceq cX cS crn cF wf1o cG crn cS crn cF wf1o wb cayleylem1.3 cX cG crn cS
      crn cF f1oeq2 ax-mp bitri mpbi mpbir2an pm3.2i $.
      $( [18-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d F f $.  $d G a b f g h $.  $d X a b f g h $.
    cayleyi.1 $e |- G e. Grp $.
    cayleyi.2 $e |- X = ran G $.
    cayleyi.3 $e |- H = ( SymGrp ` X ) $.
    cayleyi.4 $e |- F = { <. g , h >. | ( g e. X /\ h = { <. a , b >. |
                          ( a e. X /\ b = ( g G a ) ) } ) } $.
    cayleyi.5 $e |- Y = ran F $.
    cayleyi.6 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( Cayley's Theorem (constructive version): given group ` G ` , ` F ` is
       an isomorphism between ` G ` and the subgroup ` S ` of the symmetry
       group ` H ` on the underlying set ` X ` of ` G ` .  (Contributed by
       Paul Chapman, 3-Mar-2008.) $)
    cayleyi $p |- ( S e. ( SubGrp ` H ) /\ F e. ( G GrpIso S ) ) $=
      cX cX vf cv wf1o vf cab cS cG cgi cfv vf vg vh cF cG cH cX cY va vb
      cayleyi.1 cX cX vf cv wf1o vf cab eqid cayleyi.2 cG cgi cfv eqid
      cayleyi.3 cayleyi.4 cayleyi.5 cayleyi.6 cayleylem3 $.
      $( [18-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d F f h $.  $d G a b g j $.  $d G f h $.  $d H f h $.  $d Q a b g j $.
    $d Q f h $.  $d S h $.  $d X a b g j $.
    cayleythlem.1 $e |- Q = { <. <. x , x >. , x >. } $.
    cayleythlem.2 $e |- X = ran if ( G e. Grp , G , Q ) $.
    cayleythlem.3 $e |- H = ( SymGrp ` X ) $.
    cayleythlem.4 $e |- F = { <. g , j >. | ( g e. X /\ j = { <. a , b >. |
      ( a e. X /\ b = ( g if ( G e. Grp , G , Q ) a ) ) } ) } $.
    cayleythlem.5 $e |- Y = ran F $.
    cayleythlem.6 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( Lemma for ~ cayleyth . $)
    cayleythlem $p |- ( G e. Grp ->
        E. f E. h e. ( SubGrp ` ( SymGrp ` ran G ) ) f e. ( G GrpIso h ) ) $=
      cG cgr wcel vf cv cG vh cv cgiso co wcel vh cH csubg cfv wrex vf wex vf
      cv cG vh cv cgiso co wcel vh cG crn csymgrp cfv csubg cfv wrex vf wex cG
      cgr wcel vf cv cG vh cv cgiso co wcel vh cH csubg cfv wrex vf wex vf cv
      cG cgr wcel cG cQ cif vh cv cgiso co wcel vh cH csubg cfv wrex vf wex cG
      cQ cG cG cgr wcel cG cQ cif wceq vf cv cG vh cv cgiso co wcel vh cH csubg
      cfv wrex vf cv cG cgr wcel cG cQ cif vh cv cgiso co wcel vh cH csubg cfv
      wrex vf cG cG cgr wcel cG cQ cif wceq vf cv cG vh cv cgiso co wcel vf cv
      cG cgr wcel cG cQ cif vh cv cgiso co wcel vh cH csubg cfv cG cG cgr wcel
      cG cQ cif wceq cG vh cv cgiso co cG cgr wcel cG cQ cif vh cv cgiso co vf
      cv cG cG cgr wcel cG cQ cif vh cv cgiso opreq1 eleq2d rexbidv exbidv cF
      cG cgr wcel cG cQ cif vh cv cgiso co wcel vh cH csubg cfv wrex vf cv cG
      cgr wcel cG cQ cif vh cv cgiso co wcel vh cH csubg cfv wrex vf wex cS cH
      csubg cfv wcel cF cG cgr wcel cG cQ cif cS cgiso co wcel wa cF cG cgr
      wcel cG cQ cif vh cv cgiso co wcel vh cH csubg cfv wrex cS vg vj cF cG
      cgr wcel cG cQ cif cH cX cY va vb cG cQ cgr cQ vx cv vx cv cop vx cv cop
      csn cgr cayleythlem.1 vx cv vx visset grpsn eqeltri elimel cayleythlem.2
      cayleythlem.3 cayleythlem.4 cayleythlem.5 cayleythlem.6 cayleyi cF cG cgr
      wcel cG cQ cif vh cv cgiso co wcel cF cG cgr wcel cG cQ cif cS cgiso co
      wcel vh cS cH csubg cfv vh cv cS wceq cG cgr wcel cG cQ cif vh cv cgiso
      co cG cgr wcel cG cQ cif cS cgiso co cF vh cv cS cG cgr wcel cG cQ cif
      cgiso opreq2 eleq2d rcla4ev ax-mp vf cv cG cgr wcel cG cQ cif vh cv cgiso
      co wcel vh cH csubg cfv wrex cF cG cgr wcel cG cQ cif vh cv cgiso co wcel
      vh cH csubg cfv wrex vf cF vg vj cX va cv cX wcel vb cv vg cv va cv cG
      cgr wcel cG cQ cif co wceq wa va vb copab cF cX cG cgr wcel cG cQ cif crn
      cvv cayleythlem.2 cG cgr wcel cG cQ cif cgr wcel cG cgr wcel cG cQ cif
      crn cvv wcel cG cQ cgr cQ vx cv vx cv cop vx cv cop csn cgr cayleythlem.1
      vx cv vx visset grpsn eqeltri elimel cG cgr wcel cG cQ cif cgr rnexg
      ax-mp eqeltri cayleythlem.4 fopabex2 vf cv cF wceq vf cv cG cgr wcel cG
      cQ cif vh cv cgiso co wcel cF cG cgr wcel cG cQ cif vh cv cgiso co wcel
      vh cH csubg cfv vf cv cF cG cgr wcel cG cQ cif vh cv cgiso co eleq1
      rexbidv cla4ev ax-mp dedth cG cgr wcel vf cv cG vh cv cgiso co wcel vh cH
      csubg cfv wrex vf cv cG vh cv cgiso co wcel vh cG crn csymgrp cfv csubg
      cfv wrex vf cG cgr wcel vf cv cG vh cv cgiso co wcel vh cH csubg cfv cG
      crn csymgrp cfv csubg cfv cG cgr wcel cH cG crn csymgrp cfv csubg cG cgr
      wcel cX csymgrp cfv cG crn csymgrp cfv cH cG cgr wcel cX cG crn csymgrp
      cG cgr wcel cG cgr wcel cG cQ cif crn cG crn cX cG cgr wcel cG cgr wcel
      cG cQ cif cG cG cgr wcel cG cQ iftrue rneqd cayleythlem.2 syl5eq fveq2d
      cayleythlem.3 syl5eq fveq2d rexeq1d exbidv mpbid $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

  ${
    $d G a b f g h j $.  $d a b f g h j x $.
    $( Cayley's Theorem (existence version): every group ` G ` is isomorphic
       to a subgroup of the symmetry group on the underlying set of ` G ` .
       (For any group ` G ` there exists an isomorphism ` f ` between ` G ` and
       a subgroup ` h ` of the symmetry group on the underlying set of ` G ` .)
       (Contributed by Paul Chapman, 3-Mar-2008.) $)
    cayleyth $p |- ( G e. Grp -> E. f E. h e. ( SubGrp ` ( SymGrp ` ran G ) )
                                      f e. ( G GrpIso h ) ) $=
      vx vx cv vx cv cop vx cv cop csn cG cgr wcel cG vx cv vx cv cop vx cv cop
      csn cif crn csymgrp cfv vg cv cG cgr wcel cG vx cv vx cv cop vx cv cop
      csn cif crn wcel vj cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn
      cif crn wcel vb cv vg cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop
      csn cif co wceq wa va vb copab wceq wa vg vj copab crn vg cv cG cgr wcel
      cG vx cv vx cv cop vx cv cop csn cif crn wcel vj cv va cv cG cgr wcel cG
      vx cv vx cv cop vx cv cop csn cif crn wcel vb cv vg cv va cv cG cgr wcel
      cG vx cv vx cv cop vx cv cop csn cif co wceq wa va vb copab wceq wa vg vj
      copab crn cxp cres vf vg vh vj vg cv cG cgr wcel cG vx cv vx cv cop vx cv
      cop csn cif crn wcel vj cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop
      csn cif crn wcel vb cv vg cv va cv cG cgr wcel cG vx cv vx cv cop vx cv
      cop csn cif co wceq wa va vb copab wceq wa vg vj copab cG cG cgr wcel cG
      vx cv vx cv cop vx cv cop csn cif crn csymgrp cfv cG cgr wcel cG vx cv vx
      cv cop vx cv cop csn cif crn vg cv cG cgr wcel cG vx cv vx cv cop vx cv
      cop csn cif crn wcel vj cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop
      csn cif crn wcel vb cv vg cv va cv cG cgr wcel cG vx cv vx cv cop vx cv
      cop csn cif co wceq wa va vb copab wceq wa vg vj copab crn va vb vx cv vx
      cv cop vx cv cop csn eqid cG cgr wcel cG vx cv vx cv cop vx cv cop csn
      cif crn eqid cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif crn csymgrp
      cfv eqid vg cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif crn wcel
      vj cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif crn wcel vb
      cv vg cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif co wceq
      wa va vb copab wceq wa vg vj copab eqid vg cv cG cgr wcel cG vx cv vx cv
      cop vx cv cop csn cif crn wcel vj cv va cv cG cgr wcel cG vx cv vx cv cop
      vx cv cop csn cif crn wcel vb cv vg cv va cv cG cgr wcel cG vx cv vx cv
      cop vx cv cop csn cif co wceq wa va vb copab wceq wa vg vj copab crn eqid
      cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif crn csymgrp cfv vg cv cG
      cgr wcel cG vx cv vx cv cop vx cv cop csn cif crn wcel vj cv va cv cG cgr
      wcel cG vx cv vx cv cop vx cv cop csn cif crn wcel vb cv vg cv va cv cG
      cgr wcel cG vx cv vx cv cop vx cv cop csn cif co wceq wa va vb copab wceq
      wa vg vj copab crn vg cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif
      crn wcel vj cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif crn
      wcel vb cv vg cv va cv cG cgr wcel cG vx cv vx cv cop vx cv cop csn cif
      co wceq wa va vb copab wceq wa vg vj copab crn cxp cres eqid cayleythlem
      $.
      $( [3-Mar-2008] $) $( [3-Mar-2008] $)
  $}

$( (End of Paul Chapmans's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Scott Fenton
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)


  $( ~ ax-ext without distinct variable conditions or defined symbols. $)
  axextprim $p |- -. A. x -. ( ( x e. y -> x e. z ) ->
               ( ( x e. z -> x e. y ) -> y = z ) ) $=
    vx vy wel vx vz wel wb vy vz weq wi vx wex vx vy wel vx vz wel wi vx vz wel
    vx vy wel wi vy vz weq wi wi wn vx wal wn vx vy vz axextnd vx vy wel vx vz
    wel wb vy vz weq wi vx wex vx vy wel vx vz wel wi vx vz wel vx vy wel wi vy
    vz weq wi wi vx wex vx vy wel vx vz wel wi vx vz wel vx vy wel wi vy vz weq
    wi wi wn vx wal wn vx vy wel vx vz wel wb vy vz weq wi vx vy wel vx vz wel
    wi vx vz wel vx vy wel wi vy vz weq wi wi vx vx vy wel vx vz wel wb vy vz
    weq wi vx vy wel vx vz wel wi vx vz wel vx vy wel wi wa vy vz weq wi vx vy
    wel vx vz wel wi vx vz wel vx vy wel wi vy vz weq wi wi vx vy wel vx vz wel
    wb vx vy wel vx vz wel wi vx vz wel vx vy wel wi wa vy vz weq vx vy wel vx
    vz wel dfbi2 imbi1i vx vy wel vx vz wel wi vx vz wel vx vy wel wi vy vz weq
    impexp bitri exbii vx vy wel vx vz wel wi vx vz wel vx vy wel wi vy vz weq
    wi wi vx df-ex bitri mpbi $.
    $( [31-Oct-2010] $) $( [13-Oct-2010] $)

  $( ~ ax-rep without distinct variable conditions or defined symbols. $)
  axrepprim $p |- -. A. x -. ( -. A. y -. A. z ( ph -> z = y ) ->
               A. z -. ( ( A. y z e. x -> -. A. x ( A. z x e. y ->
               -. A. y ph ) ) -> -. ( -. A. x ( A. z x e. y -> -. A. y ph )
               -> A. y z e. x ) ) ) $=
    wph vz vy weq wi vz wal vy wex vz vx wel vy wal vx vy wel vz wal wph vy wal
    wa vx wex wb vz wal wi vx wex wph vz vy weq wi vz wal wn vy wal wn vz vx
    wel vy wal vx vy wel vz wal wph vy wal wn wi vx wal wn wi vx vy wel vz wal
    wph vy wal wn wi vx wal wn vz vx wel vy wal wi wn wi wn vz wal wi wn vx wal
    wn wph vx vy vz axrepnd wph vz vy weq wi vz wal vy wex vz vx wel vy wal vx
    vy wel vz wal wph vy wal wa vx wex wb vz wal wi vx wex wph vz vy weq wi vz
    wal wn vy wal wn vz vx wel vy wal vx vy wel vz wal wph vy wal wn wi vx wal
    wn wi vx vy wel vz wal wph vy wal wn wi vx wal wn vz vx wel vy wal wi wn wi
    wn vz wal wi vx wex wph vz vy weq wi vz wal wn vy wal wn vz vx wel vy wal
    vx vy wel vz wal wph vy wal wn wi vx wal wn wi vx vy wel vz wal wph vy wal
    wn wi vx wal wn vz vx wel vy wal wi wn wi wn vz wal wi wn vx wal wn wph vz
    vy weq wi vz wal vy wex vz vx wel vy wal vx vy wel vz wal wph vy wal wa vx
    wex wb vz wal wi wph vz vy weq wi vz wal wn vy wal wn vz vx wel vy wal vx
    vy wel vz wal wph vy wal wn wi vx wal wn wi vx vy wel vz wal wph vy wal wn
    wi vx wal wn vz vx wel vy wal wi wn wi wn vz wal wi vx wph vz vy weq wi vz
    wal vy wex wph vz vy weq wi vz wal wn vy wal wn vz vx wel vy wal vx vy wel
    vz wal wph vy wal wa vx wex wb vz wal vz vx wel vy wal vx vy wel vz wal wph
    vy wal wn wi vx wal wn wi vx vy wel vz wal wph vy wal wn wi vx wal wn vz vx
    wel vy wal wi wn wi wn vz wal wph vz vy weq wi vz wal vy df-ex vz vx wel vy
    wal vx vy wel vz wal wph vy wal wa vx wex wb vz vx wel vy wal vx vy wel vz
    wal wph vy wal wn wi vx wal wn wi vx vy wel vz wal wph vy wal wn wi vx wal
    wn vz vx wel vy wal wi wn wi wn vz vz vx wel vy wal vx vy wel vz wal wph vy
    wal wa vx wex wb vz vx wel vy wal vx vy wel vz wal wph vy wal wn wi vx wal
    wn wb vz vx wel vy wal vx vy wel vz wal wph vy wal wn wi vx wal wn wi vx vy
    wel vz wal wph vy wal wn wi vx wal wn vz vx wel vy wal wi wn wi wn vx vy
    wel vz wal wph vy wal wa vx wex vx vy wel vz wal wph vy wal wn wi vx wal wn
    vz vx wel vy wal vx vy wel vz wal wph vy wal wa vx wex vx vy wel vz wal wph
    vy wal wn wi wn vx wex vx vy wel vz wal wph vy wal wn wi vx wal wn vx vy
    wel vz wal wph vy wal wa vx vy wel vz wal wph vy wal wn wi wn vx vx vy wel
    vz wal wph vy wal df-an exbii vx vy wel vz wal wph vy wal wn wi vx exnal
    bitri bibi2i vz vx wel vy wal vx vy wel vz wal wph vy wal wn wi vx wal wn
    dfbi1 bitri albii imbi12i exbii wph vz vy weq wi vz wal wn vy wal wn vz vx
    wel vy wal vx vy wel vz wal wph vy wal wn wi vx wal wn wi vx vy wel vz wal
    wph vy wal wn wi vx wal wn vz vx wel vy wal wi wn wi wn vz wal wi vx df-ex
    bitri mpbi $.
    $( [31-Oct-2010] $) $( [13-Oct-2010] $)

  $( ~ ax-un without distinct variable conditions or defined symbols. $)
  axunprim $p  |- -. A. x -. A. y ( -. A. x ( y e. x -> -. x e. z )
               -> y e. x ) $=
    vy vx wel vx vz wel wa vx wex vy vx wel wi vy wal vx wex vy vx wel vx vz
    wel wn wi vx wal wn vy vx wel wi vy wal wn vx wal wn vx vy vz axunnd vy vx
    wel vx vz wel wa vx wex vy vx wel wi vy wal vx wex vy vx wel vx vz wel wn
    wi vx wal wn vy vx wel wi vy wal vx wex vy vx wel vx vz wel wn wi vx wal wn
    vy vx wel wi vy wal wn vx wal wn vy vx wel vx vz wel wa vx wex vy vx wel wi
    vy wal vy vx wel vx vz wel wn wi vx wal wn vy vx wel wi vy wal vx vy vx wel
    vx vz wel wa vx wex vy vx wel wi vy vx wel vx vz wel wn wi vx wal wn vy vx
    wel wi vy vy vx wel vx vz wel wa vx wex vy vx wel vx vz wel wn wi vx wal wn
    vy vx wel vy vx wel vx vz wel wa vx wex vy vx wel vx vz wel wn wi wn vx wex
    vy vx wel vx vz wel wn wi vx wal wn vy vx wel vx vz wel wa vy vx wel vx vz
    wel wn wi wn vx vy vx wel vx vz wel df-an exbii vy vx wel vx vz wel wn wi
    vx exnal bitri imbi1i albii exbii vy vx wel vx vz wel wn wi vx wal wn vy vx
    wel wi vy wal vx df-ex bitri mpbi $.
    $( [31-Oct-2010] $) $( [13-Oct-2010] $)

  $( ~ ax-pow without distinct variable conditions or defined symbols. $)
  axpowprim $p |- ( A. x -. A. y ( A. x ( -. A. z -. x e. y -> A. y x e. z )
               -> y e. x ) -> x = y ) $=
    vx vy weq vx vy wel wn vz wal wn vx vz wel vy wal wi vx wal vy vx wel wi vy
    wal wn vx wal vx vy weq wn vx vy wel vz wex vx vz wel vy wal wi vx wal vy
    vx wel wi vy wal vx wex vx vy wel wn vz wal wn vx vz wel vy wal wi vx wal
    vy vx wel wi vy wal wn vx wal wn vx vy vz axpownd vx vy wel vz wex vx vz
    wel vy wal wi vx wal vy vx wel wi vy wal vx wex vx vy wel wn vz wal wn vx
    vz wel vy wal wi vx wal vy vx wel wi vy wal vx wex vx vy wel wn vz wal wn
    vx vz wel vy wal wi vx wal vy vx wel wi vy wal wn vx wal wn vx vy wel vz
    wex vx vz wel vy wal wi vx wal vy vx wel wi vy wal vx vy wel wn vz wal wn
    vx vz wel vy wal wi vx wal vy vx wel wi vy wal vx vx vy wel vz wex vx vz
    wel vy wal wi vx wal vy vx wel wi vx vy wel wn vz wal wn vx vz wel vy wal
    wi vx wal vy vx wel wi vy vx vy wel vz wex vx vz wel vy wal wi vx wal vx vy
    wel wn vz wal wn vx vz wel vy wal wi vx wal vy vx wel vx vy wel vz wex vx
    vz wel vy wal wi vx vy wel wn vz wal wn vx vz wel vy wal wi vx vx vy wel vz
    wex vx vy wel wn vz wal wn vx vz wel vy wal vx vy wel vz df-ex imbi1i albii
    imbi1i albii exbii vx vy wel wn vz wal wn vx vz wel vy wal wi vx wal vy vx
    wel wi vy wal vx df-ex bitri sylib con4i $.
    $( [31-Oct-2010] $) $( [13-Oct-2010] $)

  $( ~ ax-reg without distinct variable conditions or defined symbols. $)
  axregprim $p |- ( x e. y ->
               -. A. x ( x e. y -> -. A. z ( z e. x -> -. z e. y ) ) ) $=
    vx vy wel vx vy wel vz vx wel vz vy wel wn wi vz wal wa vx wex vx vy wel vz
    vx wel vz vy wel wn wi vz wal wn wi vx wal wn vx vy vz axregnd vx vy wel vz
    vx wel vz vy wel wn wi vz wal wa vx wex vx vy wel vz vx wel vz vy wel wn wi
    vz wal wn wi wn vx wex vx vy wel vz vx wel vz vy wel wn wi vz wal wn wi vx
    wal wn vx vy wel vz vx wel vz vy wel wn wi vz wal wa vx vy wel vz vx wel vz
    vy wel wn wi vz wal wn wi wn vx vx vy wel vz vx wel vz vy wel wn wi vz wal
    df-an exbii vx vy wel vz vx wel vz vy wel wn wi vz wal wn wi vx exnal bitri
    sylib $.
    $( [31-Oct-2010] $) $( [13-Oct-2010] $)

  $( ~ ax-inf without distinct variable conditions or defined symbols. $)
  axinfprim $p |- -. A. x -. ( y e. z -> -. ( y e. x ->
               -. A. y ( y e. x -> -. A. z ( y e. z -> -. z e. x ) ) ) ) $=
    vy vz wel vy vx wel vy vx wel vy vz wel vz vx wel wa vz wex wi vy wal wa wi
    vx wex vy vz wel vy vx wel vy vx wel vy vz wel vz vx wel wn wi vz wal wn wi
    vy wal wn wi wn wi wn vx wal wn vx vy vz axinfnd vy vz wel vy vx wel vy vx
    wel vy vz wel vz vx wel wa vz wex wi vy wal wa wi vx wex vy vz wel vy vx
    wel vy vx wel vy vz wel vz vx wel wn wi vz wal wn wi vy wal wn wi wn wi vx
    wex vy vz wel vy vx wel vy vx wel vy vz wel vz vx wel wn wi vz wal wn wi vy
    wal wn wi wn wi wn vx wal wn vy vz wel vy vx wel vy vx wel vy vz wel vz vx
    wel wa vz wex wi vy wal wa wi vy vz wel vy vx wel vy vx wel vy vz wel vz vx
    wel wn wi vz wal wn wi vy wal wn wi wn wi vx vy vx wel vy vx wel vy vz wel
    vz vx wel wa vz wex wi vy wal wa vy vx wel vy vx wel vy vz wel vz vx wel wn
    wi vz wal wn wi vy wal wn wi wn vy vz wel vy vx wel vy vx wel vy vz wel vz
    vx wel wa vz wex wi vy wal wa vy vx wel vy vx wel vy vz wel vz vx wel wn wi
    vz wal wn wi vy wal wa vy vx wel vy vx wel vy vz wel vz vx wel wn wi vz wal
    wn wi vy wal wn wi wn vy vx wel vy vz wel vz vx wel wa vz wex wi vy wal vy
    vx wel vy vz wel vz vx wel wn wi vz wal wn wi vy wal vy vx wel vy vx wel vy
    vz wel vz vx wel wa vz wex wi vy vx wel vy vz wel vz vx wel wn wi vz wal wn
    wi vy vy vz wel vz vx wel wa vz wex vy vz wel vz vx wel wn wi vz wal wn vy
    vx wel vy vz wel vz vx wel wa vz wex vy vz wel vz vx wel wn wi wn vz wex vy
    vz wel vz vx wel wn wi vz wal wn vy vz wel vz vx wel wa vy vz wel vz vx wel
    wn wi wn vz vy vz wel vz vx wel df-an exbii vy vz wel vz vx wel wn wi vz
    exnal bitri imbi2i albii anbi2i vy vx wel vy vx wel vy vz wel vz vx wel wn
    wi vz wal wn wi vy wal df-an bitri imbi2i exbii vy vz wel vy vx wel vy vx
    wel vy vz wel vz vx wel wn wi vz wal wn wi vy wal wn wi wn wi vx df-ex
    bitri mpbi $.
    $( [31-Oct-2010] $) $( [13-Oct-2010] $)

  $( ~ ax-ac without distinct variable conditions or defined symbols. $)
  axacprim  $p |- -. A. x -. A. y A. z ( A. x -. ( y e. z -> -. z e. w ) ->
                  -. A. w -. A. y -. ( ( -. A. w ( y e. z -> ( z e. w ->
                  ( y e. w -> -. w e. x ) ) ) -> y = w ) -> -. ( y = w ->
                  -. A. w ( y e. z -> ( z e. w -> ( y e. w -> -. w e. x )
                  ) ) ) ) ) $=
    vy vz wel vz vw wel wa vx wal vy vz wel vz vw wel wa vy vw wel vw vx wel wa
    wa vw wex vy vw weq wb vy wal vw wex wi vz wal vy wal vx wex vy vz wel vz
    vw wel wn wi wn vx wal vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi
    vw wal wn vy vw weq wi vy vw weq vy vz wel vz vw wel vy vw wel vw vx wel wn
    wi wi wi vw wal wn wi wn wi wn vy wal wn vw wal wn wi vz wal vy wal wn vx
    wal wn vx vy vz vw axacnd vy vz wel vz vw wel wa vx wal vy vz wel vz vw wel
    wa vy vw wel vw vx wel wa wa vw wex vy vw weq wb vy wal vw wex wi vz wal vy
    wal vx wex vy vz wel vz vw wel wn wi wn vx wal vy vz wel vz vw wel vy vw
    wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz wel vz vw
    wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy wal wn vw wal
    wn wi vz wal vy wal vx wex vy vz wel vz vw wel wn wi wn vx wal vy vz wel vz
    vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy
    vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy
    wal wn vw wal wn wi vz wal vy wal wn vx wal wn vy vz wel vz vw wel wa vx
    wal vy vz wel vz vw wel wa vy vw wel vw vx wel wa wa vw wex vy vw weq wb vy
    wal vw wex wi vz wal vy wal vy vz wel vz vw wel wn wi wn vx wal vy vz wel
    vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq
    vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn
    vy wal wn vw wal wn wi vz wal vy wal vx vy vz wel vz vw wel wa vx wal vy vz
    wel vz vw wel wa vy vw wel vw vx wel wa wa vw wex vy vw weq wb vy wal vw
    wex wi vy vz wel vz vw wel wn wi wn vx wal vy vz wel vz vw wel vy vw wel vw
    vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz wel vz vw wel vy
    vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy wal wn vw wal wn wi
    vy vz vy vz wel vz vw wel wa vx wal vy vz wel vz vw wel wn wi wn vx wal vy
    vz wel vz vw wel wa vy vw wel vw vx wel wa wa vw wex vy vw weq wb vy wal vw
    wex vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq
    wi vy vw weq vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn
    wi wn wi wn vy wal wn vw wal wn vy vz wel vz vw wel wa vy vz wel vz vw wel
    wn wi wn vx vy vz wel vz vw wel df-an albii vy vz wel vz vw wel wa vy vw
    wel vw vx wel wa wa vw wex vy vw weq wb vy wal vw wex vy vz wel vz vw wel
    vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz wel
    vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy wal vw
    wex vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq
    wi vy vw weq vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn
    wi wn wi wn vy wal wn vw wal wn vy vz wel vz vw wel wa vy vw wel vw vx wel
    wa wa vw wex vy vw weq wb vy wal vy vz wel vz vw wel vy vw wel vw vx wel wn
    wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz wel vz vw wel vy vw wel vw
    vx wel wn wi wi wi vw wal wn wi wn wi wn vy wal vw vy vz wel vz vw wel wa
    vy vw wel vw vx wel wa wa vw wex vy vw weq wb vy vz wel vz vw wel vy vw wel
    vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz wel vz vw wel
    vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy vy vz wel vz vw
    wel wa vy vw wel vw vx wel wa wa vw wex vy vw weq wb vy vz wel vz vw wel vy
    vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wb vy vz wel vz vw wel vy
    vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz wel vz
    vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy vz wel vz
    vw wel wa vy vw wel vw vx wel wa wa vw wex vy vz wel vz vw wel vy vw wel vw
    vx wel wn wi wi wi vw wal wn vy vw weq vy vz wel vz vw wel wa vy vw wel vw
    vx wel wa wa vw wex vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi wn
    vw wex vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vz
    wel vz vw wel wa vy vw wel vw vx wel wa wa vy vz wel vz vw wel vy vw wel vw
    vx wel wn wi wi wi wn vw vy vz wel vz vw wel wa vy vw wel vw vx wel wa wa
    vy vz wel vz vw wel vy vw wel vw vx wel wa wa wa vy vz wel vz vw wel vy vw
    wel vw vx wel wn wi wi wn wa vy vz wel vz vw wel vy vw wel vw vx wel wn wi
    wi wi wn vy vz wel vz vw wel vy vw wel vw vx wel wa anass vz vw wel vy vw
    wel vw vx wel wn wi wi wn vz vw wel vy vw wel vw vx wel wa wa vy vz wel vz
    vw wel vy vw wel vw vx wel wn wi wi wn vz vw wel vy vw wel vw vx wel wn wi
    wn wa vz vw wel vy vw wel vw vx wel wa wa vz vw wel vy vw wel vw vx wel wn
    wi annim vy vw wel vw vx wel wn wi wn vy vw wel vw vx wel wa vz vw wel vy
    vw wel vw vx wel pm4.63 anbi2i bitr3i anbi2i vy vz wel vz vw wel vy vw wel
    vw vx wel wn wi wi annim 3bitr2i exbii vy vz wel vz vw wel vy vw wel vw vx
    wel wn wi wi wi vw exnal bitri bibi1i vy vz wel vz vw wel vy vw wel vw vx
    wel wn wi wi wi vw wal wn vy vw weq dfbi1 bitri albii exbii vy vz wel vz vw
    wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy vw weq vy vz
    wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn wi wn vy wal
    vw df-ex bitri imbi12i 2albii exbii vy vz wel vz vw wel wn wi wn vx wal vy
    vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn vy vw weq wi vy
    vw weq vy vz wel vz vw wel vy vw wel vw vx wel wn wi wi wi vw wal wn wi wn
    wi wn vy wal wn vw wal wn wi vz wal vy wal vx df-ex bitri mpbi $.
    $( [31-Oct-2010] $) $( [26-Oct-2010] $)


  ${ $d x y z A $.
     $( A class of transitive sets is partially ordered by ` _E ` . $)
     elpotr $p |- ( A. z e. A Tr z -> _E Po A ) $=
       vx vy wel vy vz wel wa vx vz wel wi vy wal vx wal vz cA wral vx vy wel
       vy vz wel wa vx vz wel wi vz cA wral vy cA wral vx cA wral vz cv wtr vz
       cA wral cA cep wpo vx vy wel vy vz wel wa vx vz wel wi vy wal vx wal vz
       cA wral vx vy wel vy vz wel wa vx vz wel wi vy cA wral vx cA wral vz cA
       wral vx vy wel vy vz wel wa vx vz wel wi vz cA wral vy cA wral vx cA
       wral vx vy wel vy vz wel wa vx vz wel wi vy wal vx wal vx vy wel vy vz
       wel wa vx vz wel wi vy cA wral vx cA wral vz cA vx vy wel vy vz wel wa
       vx vz wel wi vy wal vx wal vx vy wel vy vz wel wa vx vz wel wi vy cA
       wral vx wal vx vy wel vy vz wel wa vx vz wel wi vy cA wral vx cA wral vx
       vy wel vy vz wel wa vx vz wel wi vy wal vx vy wel vy vz wel wa vx vz wel
       wi vy cA wral vx vx vy wel vy vz wel wa vx vz wel wi vy cA alral 19.20i
       vx vy wel vy vz wel wa vx vz wel wi vy cA wral vx cA alral syl r19.20si
       vx vy wel vy vz wel wa vx vz wel wi vy cA wral vx cA wral vz cA wral vx
       vy wel vy vz wel wa vx vz wel wi vy cA wral vz cA wral vx cA wral vx vy
       wel vy vz wel wa vx vz wel wi vz cA wral vy cA wral vx cA wral vx vy wel
       vy vz wel wa vx vz wel wi vy cA wral vz vx cA cA ralcom vx vy wel vy vz
       wel wa vx vz wel wi vy cA wral vz cA wral vx vy wel vy vz wel wa vx vz
       wel wi vz cA wral vy cA wral vx cA vx vy wel vy vz wel wa vx vz wel wi
       vz vy cA cA ralcom ralbii bitri sylib vz cv wtr vx vy wel vy vz wel wa
       vx vz wel wi vy wal vx wal vz cA vx vy vz cv dftr2 ralbii cA cep wpo vx
       cv vx cv cep wbr wn vx cv vy cv cep wbr vy cv vz cv cep wbr wa vx cv vz
       cv cep wbr wi wa vz cA wral vy cA wral vx cA wral vx vy wel vy vz wel wa
       vx vz wel wi vz cA wral vy cA wral vx cA wral vx vy vz cA cep df-po vx
       vy wel vy vz wel wa vx vz wel wi vz cA wral vx cv vx cv cep wbr wn vx cv
       vy cv cep wbr vy cv vz cv cep wbr wa vx cv vz cv cep wbr wi wa vz cA
       wral vx vy cA cA vx vy wel vy vz wel wa vx vz wel wi vx cv vx cv cep wbr
       wn vx cv vy cv cep wbr vy cv vz cv cep wbr wa vx cv vz cv cep wbr wi wa
       vz cA vx vy wel vy vz wel wa vx vz wel wi vx cv vy cv cep wbr vy cv vz
       cv cep wbr wa vx cv vz cv cep wbr wi vx cv vx cv cep wbr wn vx cv vy cv
       cep wbr vy cv vz cv cep wbr wa vx cv vz cv cep wbr wi wa vx cv vy cv cep
       wbr vy cv vz cv cep wbr wa vx vy wel vy vz wel wa vx cv vz cv cep wbr vx
       vz wel vx cv vy cv cep wbr vx vy wel vy cv vz cv cep wbr vy vz wel vx vy
       epel vy vz epel anbi12i vx vz epel imbi12i vx cv vx cv cep wbr wn vx cv
       vy cv cep wbr vy cv vz cv cep wbr wa vx cv vz cv cep wbr wi vx cv vx cv
       cep wbr vx vx wel vx elirrv vx vx epel mtbir biantrur bitr3i ralbii
       2ralbii bitr4i 3imtr4i $.
       $( [31-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${ $d x y A $.
     $( Assuming ~ ax-reg , an ordinal is a transitive class totally ordered
        by inclusion. $)
     dford2 $p |- ( Ord A <-> ( Tr A /\
                    A. x e. A A. y e. A ( x e. y \/ x = y \/ y e. x ) ) ) $=
       cA word cA wtr cA cep wwe wa cA wtr vx vy wel vx vy weq vy vx wel w3o vy
       cA wral vx cA wral wa cA df-ord cA cep wwe vx vy wel vx vy weq vy vx wel
       w3o vy cA wral vx cA wral cA wtr cA cep wwe cA cep wfr vx cv vy cv cep
       wbr vx vy weq vy cv vx cv cep wbr w3o vy cA wral vx cA wral wa vx cv vy
       cv cep wbr vx vy weq vy cv vx cv cep wbr w3o vy cA wral vx cA wral vx vy
       wel vx vy weq vy vx wel w3o vy cA wral vx cA wral vx vy cA cep dfwe2 cA
       cep wfr vx cv vy cv cep wbr vx vy weq vy cv vx cv cep wbr w3o vy cA wral
       vx cA wral cA zfregfr biantrur vx cv vy cv cep wbr vx vy weq vy cv vx cv
       cep wbr w3o vx vy wel vx vy weq vy vx wel w3o vx vy cA cA vx cv vy cv
       cep wbr vx vy wel vx vy weq vx vy weq vy cv vx cv cep wbr vy vx wel vx
       vy epel vx vy weq biid vy vx epel 3orbi123i 2ralbii 3bitr2i anbi2i bitri
       $.
       $( [31-Oct-2010] $) $( [27-Oct-2010] $)
  $}

  ${ $d x y $.
     $( The domain of the epsilon relation is the universe. $)
     domep $p |- dom _E = _V $=
       cep cdm vx cv vy cv cep wbr vy wex vx cab cvv vx vy cep df-dm cvv vx cv
       vx cv wceq vx cab vx cv vy cv cep wbr vy wex vx cab vx df-v vx cv vx cv
       wceq vx cv vy cv cep wbr vy wex vx vx cv vx cv wceq vx cv vy cv cep wbr
       vy wex vx equid vx cv vy cv cep wbr vy wex vx cv vy cv wcel vy wex vx vy
       el vx cv vy cv cep wbr vx cv vy cv wcel vy vx vy epel exbii mpbir 2th
       abbii eqtri eqtr4i $.
       $( [31-Oct-2010] $) $( [27-Oct-2010] $)
  $}

  ${ $d y A $. $d y C $. $d y B $. $d y D $. $d x y $.
     mpteq.1 $e |- A = C $.
     mpteq.2 $e |- B = D $.
     $( An equality inference for the maps to notation. $)
     mpteqi $p |- ( x e. A |-> B ) = ( x e. C |-> D ) $=
       vx cv cA wcel vy cv cB wceq wa vx vy copab vx cv cC wcel vy cv cD wceq
       wa vx vy copab vx cA cB cmpt vx cC cD cmpt vx cv cA wcel vy cv cB wceq
       wa vx cv cC wcel vy cv cD wceq wa vx vy vx cv cA wcel vx cv cC wcel vy
       cv cB wceq vy cv cD wceq cA cC vx cv mpteq.1 eleq2i cB cD vy cv mpteq.2
       eqeq2i anbi12i opabbii vx vy cA cB df-mpt vx vy cC cD df-mpt 3eqtr4i $.
       $( [31-Oct-2010] $) $( [27-Oct-2010] $)
  $}

  $( A biconditional in the antecedent is the same as two implications. $)
  biimpexp $p |- ( ( ( ph <-> ps ) -> ch )
                   <-> ( ( ph -> ps ) -> ( ( ps -> ph ) -> ch ) ) ) $=
    wph wps wb wch wi wph wps wi wps wph wi wa wch wi wph wps wi wps wph wi wch
    wi wi wph wps wb wph wps wi wps wph wi wa wch wph wps dfbi2 imbi1i wph wps
    wi wps wph wi wch impexp bitri $.
    $( [15-Dec-2010] $) $( [12-Dec-2010] $)

  $( A version of ~ ax-ext for use with defined equality. $)
  axextdfeq $p |- E. z ( ( z e. x -> z e. y )
                    -> ( ( z e. y -> z e. x ) -> ( x e. w -> y e. w ) ) ) $=
    vz vx wel vz vy wel wb vx vw wel vy vw wel wi wi vz wex vz vx wel vz vy wel
    wi vz vy wel vz vx wel wi vx vw wel vy vw wel wi wi wi vz wex vz vx wel vz
    vy wel wb vx vy weq wi vz wex vz vx wel vz vy wel wb vx vw wel vy vw wel wi
    wi vz wex vz vx vy axextnd vz vx wel vz vy wel wb vx vy weq wi vz vx wel vz
    vy wel wb vx vw wel vy vw wel wi wi vz vx vy weq vx vw wel vy vw wel wi vz
    vx wel vz vy wel wb vx vy vw ax-13 imim2i 19.22i ax-mp vz vx wel vz vy wel
    wb vx vw wel vy vw wel wi wi vz vx wel vz vy wel wi vz vy wel vz vx wel wi
    vx vw wel vy vw wel wi wi wi vz vz vx wel vz vy wel vx vw wel vy vw wel wi
    biimpexp exbii mpbi $.
    $( [15-Dec-2010] $) $( [12-Dec-2010] $)

  $( A version of ~ ax-13 for use with defined equality. $)
  ax13dfeq $p |- E. z ( ( z e. x -> z e. y ) -> ( w e. x -> w e. y ) ) $=
    vz vw weq vz wex vz vx wel vz vy wel wi vw vx wel vw vy wel wi wi vz wex vz
    vw a9e vz vw weq vz vx wel vz vy wel wi vw vx wel vw vy wel wi wi vz vz vw
    weq vw vx wel vz vx wel vz vy wel vw vy wel vw vx wel vz vx wel wi vw vz vw
    vz vx ax-13 equcoms vz vw vy ax-13 imim12d 19.22i ax-mp $.
    $( [15-Dec-2010] $) $( [12-Dec-2010] $)

 ${
   $d w x $. $d w y $. $d z w $.
   $( ~ ax-ext with distinctors instead of distinct variable restrictions. $)
   axextdist $p |- ( ( -. A. z z = x /\ -. A. z z = y )
                      -> ( A. z ( z e. x <-> z e. y ) -> x = y ) ) $=
     vz vx weq vz wal wn vz vy weq vz wal wn wa vz vx wel vz vy wel wb vz wal
     vw vx wel vw vy wel wb vw wal vx vy weq vz vx weq vz wal wn vz vy weq vz
     wal wn wa vw vx wel vw vy wel wb vz vx wel vz vy wel wb vw vz vz vx weq vz
     wal wn vz vy weq vz wal wn vz vz vx vz hbnae vz vy vz hbnae hban vz vx weq
     vz wal wn vz vy weq vz wal wn wa vw vx wel vw vy wel vz vz vx weq vz wal
     wn vz vy weq vz wal wn vz vz vx vz hbnae vz vy vz hbnae hban vz vx weq vz
     wal wn vw vx wel vw vx wel vz wal wi vz vy weq vz wal wn vz vx vw dveel2
     adantr vz vy weq vz wal wn vw vy wel vw vy wel vz wal wi vz vx weq vz wal
     wn vz vy vw dveel2 adantl hbbid vw vz weq vw vx wel vw vy wel wb vz vx wel
     vz vy wel wb wb wi vz vx weq vz wal wn vz vy weq vz wal wn wa vw vz weq vw
     vx wel vz vx wel vw vy wel vz vy wel vw vz vx elequ1 vw vz vy elequ1
     bibi12d a1i cbvald vx vy vw axext3 syl6bir $.
     $( [15-Dec-2010] $) $( [13-Dec-2010] $)

   $( ~ axext4 with distinctors instead of distinct variable restrictions. $)
   axext4dist $p |- ( ( -. A. z z = x /\ -. A. z z = y )
                      -> ( x = y <-> A. z ( z e. x <-> z e. y ) ) ) $=
     vz vx weq vz wal wn vz vy weq vz wal wn wa vx vy weq vz vx wel vz vy wel
     wb vz wal vz vx weq vz wal wn vz vy weq vz wal wn wa vx vy weq vx vy weq
     vz wal vz vx wel vz vy wel wb vz wal vz vx weq vz wal wn vz vy weq vz wal
     wn vx vy weq vx vy weq vz wal wi vx vy vz ax-12 imp vz vx weq vz wal wn vz
     vy weq vz wal wn wa vx vy weq vz vx wel vz vy wel wb vz vz vx weq vz wal
     wn vz vy weq vz wal wn vz vz vx vz hbnae vz vy vz hbnae hban vx vy weq vz
     vx wel vz vy wel wb wi vz vx weq vz wal wn vz vy weq vz wal wn wa vx vy vz
     elequ2 a1i 19.20d syld vx vy vz axextdist impbid $.
     $( [15-Dec-2010] $) $( [13-Dec-2010] $)
  $}

  ${ $d x y $.
     19.12b.1 $e |- ( ph -> A. y ph ) $.
     19.12b.2 $e |- ( ps -> A. x ps ) $.
     $( ~ 19.12vv with not-free hypotheses, instead of distinct variable
        condition.s $)
     19.12b $p |- ( E. x A. y ( ph -> ps ) <-> A. y E. x ( ph -> ps ) ) $=
       wph wps wi vy wal vx wex wph wps vy wal wi vx wex wph vx wal wps vy wal
       wi wph wps wi vx wex vy wal wph wps wi vy wal wph wps vy wal wi vx wph
       wps vy 19.12b.1 19.21 exbii wph wps vy wal vx wps vx vy 19.12b.2 hbal
       19.36 wph wps wi vx wex vy wal wph vx wal wps wi vy wal wph vx wal wps
       vy wal wi wph wps wi vx wex wph vx wal wps wi vy wph wps vx 19.12b.2
       19.36 albii wph vx wal wps vy wph vy vx 19.12b.1 hbal 19.21 bitr2i
       3bitri $.
       $( [15-Dec-2010] $) $( [13-Dec-2010] $)
  $}

  ${
     jad.1 $e |- ( ph -> ( -. ps -> th ) ) $.
     jad.2 $e |- ( ph -> ( ch -> th ) ) $.
     $( Deduction form of ~ ja . $)
     jad $p |- ( ph -> ( ( ps -> ch ) -> th ) ) $=
       wph wps wch wi wps wn wi wps wch wi wth wi wph wps wn wth wps wch wi
       jad.1 imim2d wph wps wps wch wi wth wi wps wch wi wps wn wi wn wps wps
       wch wi wch wph wth wps wch pm2.27 jad.2 syl9r wps wch wi wps pm3.27im
       syl5 pm2.61d $.
       $( [15-Dec-2010] $) $( [13-Dec-2010] $)
  $}

  $( A more general form of ~ hbnt . $)
  hbntg $p |- ( A. x ( ph -> A. x ps ) -> ( -. ps -> A. x -. ph ) ) $=
    wph wps vx wal wi vx wal wps vx wal wn vx wal wph wn vx wal wps wn wph wps
    vx wal wi wps vx wal wn wph wn vx wph wps vx wal con3 19.20ii wps vx wal wn
    vx wal wps wps vx ax-6o con1i syl5 $.
    $( [15-Dec-2010] $) $( [13-Dec-2010] $)

  $( A more general and closed form of ~ hbim . $)
  hbimtg $p |- ( ( A. x ( ph -> A. x ch ) /\ ( ps -> A. x th ) ) ->
                ( ( ch -> ps ) -> A. x ( ph -> th ) ) ) $=
    wph wch vx wal wi vx wal wps wth vx wal wi wa wch wps wph wth wi vx wal wph
    wch vx wal wi vx wal wch wn wph wth wi vx wal wi wps wth vx wal wi wph wch
    vx wal wi vx wal wch wn wph wn vx wal wph wth wi vx wal wph wch vx hbntg
    wph wn wph wth wi vx wph wth pm2.21 19.20i syl6 adantr wps wth vx wal wi
    wps wph wth wi vx wal wi wph wch vx wal wi vx wal wth vx wal wph wth wi vx
    wal wps wth wph wth wi vx wth wph ax-1 19.20i imim2i adantl jad $.
    $( [15-Dec-2010] $) $( [13-Dec-2010] $)

  $( A more general and closed form of ~ hbal . $)
  hbaltg $p |- ( A. x ( ph -> A. y ps ) -> ( A. x ph -> A. y A. x ps ) ) $=
    wph wps vy wal wi vx wal wph vx wal wps vy wal vx wal wi wi wph wps vy wal
    wi vx wal wph vx wal wps vx wal vy wal wi wi wph wps vy wal vx 19.20 wph vx
    wal wps vy wal vx wal wi wph vx wal wps vx wal vy wal wi wph wps vy wal wi
    vx wal wps vy wal vx wal wps vx wal vy wal wph vx wal wps vx vy ax-7 imim2i
    imim2i ax-mp $.
    $( [15-Dec-2010] $) $( [13-Dec-2010] $)

  ${
     hbg.1 $e |- ( ph -> A. x ps ) $.
     $( A more general form of ~ hbn . $)
     hbng $p |- ( -. ps -> A. x -. ph ) $=
       wph wps vx wal wi wps wn wph wn vx wal wi vx wph wps vx hbntg hbg.1 mpg
       $.
       $( [15-Dec-2010] $) $( [13-Dec-2010] $)

     ${
        hbg.2 $e |- ( ch -> A. x th ) $.
        $( A more general form of ~ hbim . $)
        hbimg $p |- ( ( ps -> ch ) -> A. x ( ph -> th ) ) $=
          wph wps vx wal wi vx wal wch wth vx wal wi wps wch wi wph wth wi vx
          wal wi wph wps vx wal wi vx hbg.1 ax-gen hbg.2 wph wch wps wth vx
          hbimtg mp2an $.
          $( [15-Dec-2010] $) $( [13-Dec-2010] $)
     $}
  $}

  $( There is always a set not in ` y ` . $)
  exnel $p |- E. x -. x e. y $=
    vy cv vy cv wcel wn vx cv vy cv wcel wn vx wex vy cv elirr vy cv vy cv wcel
    wn vx cv vy cv wcel wn vx vy vy cv vy cv wcel wn vx vy cv elirr hbth vx cv
    vy cv wceq vx cv vy cv wcel vy cv vy cv wcel vx vy vy ax-13 con3d a4ime
    ax-mp $.
    $( [15-Dec-2010] $) $( [13-Dec-2010] $)

  ${ $d x z $. $d y z $.
     $( Distinctors in terms of membership.  (NOTE: this only works
        with relations where we can prove ~ el and ~ elirrv .) $)
     distel $p |- ( -. A. y y = x <-> -. A. y -. x e. y ) $=
       vy vx weq vy wal wn vx vy wel wn vy wal wn vy vx weq vy wal wn vx vy wel
       vy wex vx vy wel wn vy wal wn vy vx weq vy wal wn vx vz wel vz wex vx vy
       wel vy wex vx vz el vy vx weq vy wal wn vx vz wel wn vz wal wn vx vy wel
       wn vy wal wn vx vz wel vz wex vx vy wel vy wex vy vx weq vy wal wn vx vz
       wel wn vz wal vx vy wel wn vy wal vy vx weq vy wal wn vx vz wel wn vx vy
       wel wn vz vy vy vx vy hbnae vy vx weq vy wal wn vx vz wel vy vy vx vy
       hbnae vy vx vz dveel1 hbnd vz vy weq vx vz wel wn vx vy wel wn wb wi vy
       vx weq vy wal wn vz vy weq vx vz wel vx vy wel vz vy vx elequ2 notbid
       a1i cbvald notbid vx vz wel vz df-ex vx vy wel vy df-ex 3bitr4g mpbii vx
       vy wel vy df-ex sylib vy vx weq vy wal vx vy wel wn vy wal vy vx weq vx
       vy wel wn vy vy vx weq vy vy wel vx vy wel vy elirrv vy vx vy elequ1
       mtbii 19.20i con3i impbii $.
       $( [15-Dec-2010] $) $( [15-Dec-2010] $)
  $}

  $( ~ axextnd as a biconditional. $)
  axextndbi $p |- E. z ( x = y <-> ( z e. x <-> z e. y ) ) $=
    vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb wb vz wex vx cv vy cv
    wceq vz cv vx cv wcel vz cv vy cv wcel wb wi vz cv vx cv wcel vz cv vy cv
    wcel wb vx cv vy cv wceq wi wa vz wex vz cv vx cv wcel vz cv vy cv wcel wb
    vx cv vy cv wceq wi vz wex vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv
    wcel wb wi vz cv vx cv wcel vz cv vy cv wcel wb vx cv vy cv wceq wi wa vz
    wex vz vx vy axextnd vz cv vx cv wcel vz cv vy cv wcel wb vx cv vy cv wceq
    wi vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb wi vz cv vx cv
    wcel vz cv vy cv wcel wb vx cv vy cv wceq wi wa vz vx cv vy cv wceq vz cv
    vx cv wcel vz cv vy cv wcel wb wi vz cv vx cv wcel vz cv vy cv wcel wb vx
    cv vy cv wceq wi vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb wi
    vz cv vx cv wcel vz cv vy cv wcel wb vx cv vy cv wceq wi wa wi vx vy vz
    elequ2 vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb wi vz cv vx cv
    wcel vz cv vy cv wcel wb vx cv vy cv wceq wi pm3.2 ax-mp 19.22i ax-mp vx cv
    vy cv wceq vz cv vx cv wcel vz cv vy cv wcel wb wb vx cv vy cv wceq vz cv
    vx cv wcel vz cv vy cv wcel wb wi vz cv vx cv wcel vz cv vy cv wcel wb vx
    cv vy cv wceq wi wa vz vx cv vy cv wceq vz cv vx cv wcel vz cv vy cv wcel
    wb dfbi2 exbii mpbir $.
    $( [15-Dec-2010] $) $( [14-Dec-2010] $)

$( (End of Scott Fenton's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Mathbox for Anthony Hart
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Boolean Algebra
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c T. $.
  $c F. $.

  $( ` T. ` is a wff. $)
  wtru $a wff T. $.

  $( ` F. ` is a wff. $)
  wfal $a wff F. $.

  $( Definition of ` T. ` , a tautology. ` T. ` is a constant true.
    In this definition ~ biid is used as an antecedent, however, any
    true wff, such as an axiom, can be used in its place. $)
  df-tru $a |- ( T. <-> ( ph <-> ph ) ) $.

  $( Definition of ` F. ` , a contradiction. ` F. ` is a constant false.
  $)
  df-fal $a |- ( F. <-> -. T. ) $.

  $( ` T. ` is true. $)
  trutru $p |- T. $=
    wtru wph wph wb wph biid wph df-tru mpbir $.
    $( [23-Oct-2010] $) $( [13-Oct-2010] $)

  $( ` F. ` is not true. $)
  nofaltru $p |- -. F. $=
    wtru wfal wn trutru wfal wtru df-fal con2bii mpbi $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  ${
    truvar.1 $e |- ph $.
    $( If something is true, it outputs ` T. ` . $)
    truvar $p |- ( ph <-> T. ) $=
      wph wtru truvar.1 trutru 2th $.
      $( [23-Oct-2010] $) $( [22-Oct-2010] $)
  $}

  ${
    falvar.1 $e |- -. ph $.
    $( If something is not true, it outputs ` F. ` . $)
    falvar $p |- ( ph <-> F. ) $=
      wph wfal wph wn wfal wn falvar.1 nofaltru 2th con4bii $.
      $( [23-Oct-2010] $) $( [22-Oct-2010] $)
  $}

  $( A ` /\ ` identity.  $)
  TTAi $p |- ( ( T. /\ T. ) <-> T. ) $=
    wtru anidm $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` /\ ` identity.  $)
  TFAi $p |- ( ( T. /\ F. ) <-> F. ) $=
    wtru wfal wa wfal wtru wfal wa wn wfal wn wfal wtru nofaltru intnan
    nofaltru 2th con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` /\ ` identity.  $)
  FTAi $p |- ( ( F. /\ T. ) <-> F. ) $=
    wfal wtru wa wfal wfal wtru wa wn wfal wn wfal wtru nofaltru intnanr
    nofaltru 2th con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` /\ ` identity.  $)
  FFAi $p |- ( ( F. /\ F. ) <-> F. ) $=
    wfal anidm $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` \/ ` identity.  $)
  TTOi $p |- ( ( T. \/ T. ) <-> T. ) $=
    wtru wtru wo wtru wtru wtru trutru orci trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` \/ ` identity.  $)
  TFOi $p |- ( ( T. \/ F. ) <-> T. ) $=
    wtru wfal wo wtru wtru wfal trutru orci trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` \/ ` identity.  $)
  FTOi $p |- ( ( F. \/ T. ) <-> T. ) $=
    wfal wtru wo wtru wtru wfal trutru olci trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` \/ ` identity.  $)
  FFOi $p |- ( ( F. \/ F. ) <-> F. ) $=
    wfal wfal wo wfal wfal wfal wo wn wfal wn wfal wn wfal wn wa wfal wfal wo
    wn wfal wn wfal wn nofaltru nofaltru pm3.2i wfal wfal pm4.56 mpbi nofaltru
    2th con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -> ` identity.  $)
  TTIi $p |- ( ( T. -> T. ) <-> T. ) $=
    wtru wtru wi wtru wtru wtru trutru a1i trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -> ` identity.  $)
  TFIi $p |- ( ( T. -> F. ) <-> F. ) $=
    wtru wfal wi wfal wtru wfal wi wn wfal wn wtru wfal wn wa wtru wfal wi wn
    wtru wfal wn trutru nofaltru pm3.2i wtru wfal annim mpbi nofaltru 2th
    con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -> ` identity.  $)
  FTIi $p |- ( ( F. -> T. ) <-> T. ) $=
    wfal wtru wi wtru wtru wfal trutru a1i trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -> ` identity.  $)
  FFIi $p |- ( ( F. -> F. ) <-> T. ) $=
    wfal wfal wi wtru wfal id trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -. ` identity.  $)
  TNi $p |- ( -. T. <-> F. ) $=
    wfal wtru wn df-fal bicomi $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -. ` identity.  $)
  FNi $p |- ( -. F. <-> T. ) $=
    wfal wn wtru wtru wfal wn trutru a1i wfal wn wtru nofaltru a1i impbii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` <-> ` identity.  $)
  TTBi $p |- ( ( T. <-> T. ) <-> T. ) $=
    wtru wtru wb wtru wtru wtru trutru trutru 2th trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` <-> ` identity.  $)
  TFBi $p |- ( ( T. <-> F. ) <-> F. ) $=
    wtru wfal wb wfal wtru wfal wb wn wfal wn wtru wn wfal wb wtru wfal wb wn
    TNi wtru wfal nbbn mpbi nofaltru 2th con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` <-> ` identity.  $)
  FTBi $p |- ( ( F. <-> T. ) <-> F. ) $=
    wfal wtru wb wfal wfal wtru wb wn wfal wn wfal wn wtru wb wfal wtru wb wn
    FNi wfal wtru nbbn mpbi nofaltru 2th con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` <-> ` identity.  $)
  FFBi $p |- ( ( F. <-> F. ) <-> T. ) $=
    wfal wfal wb wtru wfal biid trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -/\ ` identity.  $)
  TTSi $p |- ( ( T. -/\ T. ) <-> F. ) $=
    wtru wtru wnand wfal wtru wtru wnand wn wfal wn wtru wtru wa wtru wtru
    wnand wn wtru wtru wa wtru trutru TTAi mpbir wtru wtru wnand wtru wtru wa
    wtru wtru df-nand con2bii mpbi nofaltru 2th con4bii $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

  $( A ` -/\ ` identity.  $)
  TFSi $p |- ( ( T. -/\ F. ) <-> T. ) $=
    wtru wfal wnand wtru wtru wfal wnand wtru wfal wa wn wtru wfal wa wn wtru
    trutru wtru wtru wfal wa wn wtru wfal wa wtru wtru wfal wa wfal wtru wn
    TFAi wtru wn wfal TNi bicomi bitri con2bii bicomi mpbir wtru wfal df-nand
    mpbir trutru 2th $.
    $( [23-Oct-2010] $) $( [23-Oct-2010] $)

  $( A ` -/\ ` identity.  $)
  FTSi $p |- ( ( F. -/\ T. ) <-> T. ) $=
    wfal wtru wnand wtru wfal wtru wnand wfal wtru wa wn wfal wtru wa wn wtru
    trutru wtru wfal wtru wa wn wfal wtru wa wtru wfal wtru wa wfal wtru wn
    FTAi wtru wn wfal TNi bicomi bitri con2bii bicomi mpbir wfal wtru df-nand
    mpbir trutru 2th $.
    $( [23-Oct-2010] $) $( [23-Oct-2010] $)

  $( A ` -/\ ` identity.  $)
  FFSi $p |- ( ( F. -/\ F. ) <-> T. ) $=
    wfal wfal wnand wtru wfal wfal wnand wfal wfal wa wn wtru wfal wfal wa wn
    trutru wfal wfal wa wtru wfal wfal wa wfal wtru wn FFAi wtru wn wfal TNi
    bicomi bitri con2bii mpbi wfal wfal df-nand mpbir trutru 2th $.
    $( [23-Oct-2010] $) $( [22-Oct-2010] $)

$( (End of Anthony Hart's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Jeff Hoffman
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Inferences for finite induction on generic function values
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( findrec.mm - Inferences for finite induction on generic function values
     and specifically, functions defined via rec(G, A). $)

  $( Please add description here. $)
  fveleq $p |- ( A = B ->
             ( ( ph -> ( F ` A ) e. P ) <-> ( ph -> ( F ` B ) e. P ) ) ) $=
    cA cB wceq cA cF cfv cP wcel cB cF cfv cP wcel wph cA cB wceq cA cF cfv cB
    cF cfv cP cA cB cF fveq2 eleq1d imbi2d $.
    $( [19-Feb-2008] $) $( [12-Feb-2008] $)

  ${
    $d F x y $.  $d P x y $.  $d x y ph $.  $d x A $.
    findfvcl.1 $e |- ( ph -> ( F ` (/) ) e. P ) $.
    findfvcl.2 $e |- ( y e. om -> ( ph -> ( ( F ` y ) e. P ->
                     ( F ` suc y ) e. P ) ) ) $.
    $( Please add description here. $)
    findfvcl $p |- ( A e. om -> ( ph -> ( F ` A ) e. P ) ) $=
      wph vx cv cF cfv cP wcel wi wph c0 cF cfv cP wcel wi wph vy cv cF cfv cP
      wcel wi wph vy cv csuc cF cfv cP wcel wi wph cA cF cfv cP wcel wi vx vy
      cA wph vx cv c0 cP cF fveleq wph vx cv vy cv cP cF fveleq wph vx cv vy cv
      csuc cP cF fveleq wph vx cv cA cP cF fveleq findfvcl.1 vy cv com wcel wph
      vy cv cF cfv cP wcel vy cv csuc cF cfv cP wcel findfvcl.2 a2d finds $.
      $( [19-Feb-2008] $) $( [12-Feb-2008] $)
  $}

  ${
    $d y z $.  $d G y $.  $d A y $.  $d P y $.
              $d G z $.  $d A z $.  $d P z $.
    findreccl.1 $e |- ( z e. P -> ( G ` z ) e. P ) $.
    $( Please add description here. $)
    findreccl $p |- ( C e. om -> ( A e. P -> ( rec ( G , A ) ` C ) e. P ) ) $=
      cA cP wcel vy cC cP cG cA crdg cA cP wcel c0 cG cA crdg cfv cA wceq c0 cG
      cA crdg cfv cP wcel cA cP cG rdg0g cA cP c0 cG cA crdg cfv eleq1a mpd vy
      cv com wcel vy cv cG cA crdg cfv cP wcel vy cv csuc cG cA crdg cfv cP
      wcel wi cA cP wcel vy cv com wcel vy cv con0 wcel vy cv cG cA crdg cfv cP
      wcel vy cv csuc cG cA crdg cfv cP wcel wi vy cv nnon vy cv con0 wcel vy
      cv csuc cG cA crdg cfv cP wcel vy cv cG cA crdg cfv cG cfv cP wcel vy cv
      cG cA crdg cfv cP wcel vy cv con0 wcel vy cv csuc cG cA crdg cfv vy cv cG
      cA crdg cfv cG cfv cP cA vy cv cG rdgsuc eleq1d vz cv cG cfv cP wcel vy
      cv cG cA crdg cfv cG cfv cP wcel vz vy cv cG cA crdg cfv cP vz cv vy cv
      cG cA crdg cfv wceq vz cv cG cfv vy cv cG cA crdg cfv cG cfv cP vz cv vy
      cv cG cA crdg cfv cG fveq2 eleq1d findreccl.1 vtoclga syl5bir syl a1d
      findfvcl $.
      $( [19-Feb-2008] $) $( [19-Feb-2008] $)
  $}

  ${
    $d G x y $.  $d A x y $.  $d C x y $.  $d P y $.
    $d G z $.  $d A z $.               $d P z $.
    findabrcl.1 $e |- ( z e. P -> ( G ` z ) e. P ) $.
    $( Please add description here. $)
    findabrcl $p |- ( ( C e. om /\ A e. P ) ->
                  ( { <. x , y >. | y = ( rec ( G , A ) ` x ) } ` C ) e. P ) $=
      cC com wcel cA cP wcel cC cG cA crdg cfv cP wcel cC vy cv vx cv cG cA
      crdg cfv wceq vx vy copab cfv cP wcel cC com wcel cA cP wcel cC cG cA
      crdg cfv cP wcel vz cA cC cP cG findabrcl.1 findreccl imp cC com wcel cC
      cG cA crdg cfv cP wcel cC vy cv vx cv cG cA crdg cfv wceq vx vy copab cfv
      cP wcel cC com wcel cC cG cA crdg cfv cP wcel wa cC vy cv vx cv cG cA
      crdg cfv wceq vx vy copab cfv cP wcel cC cG cA crdg cfv cP wcel cC com
      wcel cC cG cA crdg cfv cP wcel wa cC vy cv vx cv cG cA crdg cfv wceq vx
      vy copab cfv cC cG cA crdg cfv cP vx vy cC vx cv cG cA crdg cfv cC cG cA
      crdg cfv com cP vx cv cC cG cA crdg fveq2 fvopabg eleq1d biimparc anabss7
      syldan $.
      $( [19-Feb-2008] $) $( [16-Feb-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              gdc.mm
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( gdc.mm  9-Apr-2008 $)

  ${
    nnssi2.1 $e |- NN C_ D $.
    nnssi2.2 $e |- ( B e. NN -> ph ) $.
    nnssi2.3 $e |- ( ( A e. D /\ B e. D /\ ph ) -> ps ) $.
    $( Convert a theorem for real/complex numbers into one for natural
       numbers. $)
    nnssi2 $p |- ( ( A e. NN /\ B e. NN ) -> ps ) $=
      cA cn wcel cB cn wcel wa cA cD wcel cB cD wcel wph w3a wps cA cn wcel cB
      cn wcel cA cD wcel cB cD wcel wph w3a cA cn wcel cA cD wcel cB cn wcel cB
      cD wcel cB cn wcel wph cn cD cA nnssi2.1 sseli cn cD cB nnssi2.1 sseli
      nnssi2.2 3anim123i 3anidm23 nnssi2.3 syl $.
      $( [17-Jun-2008] $) $( [17-Jun-2008] $)
  $}

  ${
    nnssi3.1 $e |- NN C_ D $.
    nnssi3.2 $e |- ( C e. NN -> ph ) $.
    nnssi3.3 $e |- ( ( ( A e. D /\ B e. D /\ C e. D ) /\ ph ) -> ps ) $.
    $( Convert a theorem for real/complex numbers into one for natural
       numbers. $)
    nnssi3 $p |- ( ( A e. NN /\ B e. NN /\ C e. NN ) -> ps ) $=
      cA cD wcel cB cD wcel cC cD wcel w3a wph wps cA cn wcel cB cn wcel cC cn
      wcel w3a nnssi3.3 cA cn wcel cA cD wcel cB cn wcel cB cD wcel cC cn wcel
      cC cD wcel cn cD cA nnssi3.1 sseli cn cD cB nnssi3.1 sseli cn cD cC
      nnssi3.1 sseli 3anim123i cC cn wcel cA cn wcel wph cB cn wcel nnssi3.2
      3ad2ant3 sylanc $.
      $( [17-Jun-2008] $) $( [17-Jun-2008] $)
  $}

  $( Please add description here. $)
  nndivsub $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN )
                       /\ ( ( A / C ) e. NN /\ A < B ) )
                    -> ( ( B / C ) e. NN <-> ( ( B - A ) / C ) e. NN ) ) $=
    cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv co cn wcel cA cB clt wbr wa
    wa cB cC cdiv co cn wcel cB cC cdiv co cA cC cdiv co cmin co cn wcel cB cA
    cmin co cC cdiv co cn wcel cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv
    co cn wcel cA cB clt wbr wa wa cB cC cdiv co cn wcel cB cC cdiv co cA cC
    cdiv co cmin co cn wcel cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv co
    cn wcel cA cB clt wbr cB cC cdiv co cn wcel cB cC cdiv co cA cC cdiv co
    cmin co cn wcel wi cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv co cn
    wcel cB cC cdiv co cn wcel cA cB clt wbr cB cC cdiv co cA cC cdiv co cmin
    co cn wcel cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv co cn wcel cB cC
    cdiv co cn wcel cA cB clt wbr cB cC cdiv co cA cC cdiv co cmin co cn wcel
    wi cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv co cn wcel cB cC cdiv co
    cn wcel wa wa cA cB clt wbr cB cC cdiv co cA cC cdiv co cmin co cn wcel cA
    cn wcel cB cn wcel cC cn wcel w3a cA cB clt wbr cA cC cdiv co cB cC cdiv co
    clt wbr cA cC cdiv co cn wcel cB cC cdiv co cn wcel wa cB cC cdiv co cA cC
    cdiv co cmin co cn wcel cc0 cC clt wbr cA cB clt wbr cA cC cdiv co cB cC
    cdiv co clt wbr wb cA cB cC cr nnssre cC nngt0 cA cB cC ltdiv1OLD nnssi3 cA
    cC cdiv co cB cC cdiv co nnsub sylan9bb biimpd exp32 com34 imp32 cA cn wcel
    cB cn wcel cC cn wcel w3a cA cC cdiv co cn wcel cB cC cdiv co cA cC cdiv co
    cmin co cn wcel cB cC cdiv co cn wcel wi cA cB clt wbr cA cC cdiv co cn
    wcel cB cC cdiv co cA cC cdiv co cmin co cn wcel cB cC cdiv co cA cC cdiv
    co cmin co cA cC cdiv co caddc co cn wcel cA cn wcel cB cn wcel cC cn wcel
    w3a cB cC cdiv co cn wcel cB cC cdiv co cA cC cdiv co cmin co cn wcel cA cC
    cdiv co cn wcel cB cC cdiv co cA cC cdiv co cmin co cA cC cdiv co caddc co
    cn wcel cB cC cdiv co cA cC cdiv co cmin co cA cC cdiv co nnaddcl expcom cA
    cn wcel cB cn wcel cC cn wcel w3a cB cC cdiv co cA cC cdiv co cmin co cA cC
    cdiv co caddc co cn wcel cB cC cdiv co cn wcel cA cn wcel cB cn wcel cC cn
    wcel w3a cB cC cdiv co cA cC cdiv co cmin co cA cC cdiv co caddc co cB cC
    cdiv co cn cA cn wcel cB cn wcel cC cn wcel w3a cA cC cdiv co cc wcel cB cC
    cdiv co cc wcel wa cB cC cdiv co cA cC cdiv co cmin co cA cC cdiv co caddc
    co cB cC cdiv co wceq cA cn wcel cC cn wcel cB cn wcel cA cC cdiv co cc
    wcel cB cC cdiv co cc wcel wa cA cn wcel cC cn wcel wa cA cC cdiv co cc
    wcel cB cn wcel cC cn wcel wa cB cC cdiv co cc wcel cC cc0 wne cA cC cdiv
    co cc wcel cA cC cc nnsscn cC nnne0 cA cC divcl nnssi2 cC cc0 wne cB cC
    cdiv co cc wcel cB cC cc nnsscn cC nnne0 cB cC divcl nnssi2 anim12i 3impdir
    cB cC cdiv co cc wcel cA cC cdiv co cc wcel cB cC cdiv co cA cC cdiv co
    cmin co cA cC cdiv co caddc co cB cC cdiv co wceq cB cC cdiv co cA cC cdiv
    co npcan ancoms syl eleq1d biimpd sylan9r adantrr impbid cA cn wcel cB cn
    wcel cC cn wcel w3a cB cA cmin co cC cdiv co cn wcel cB cC cdiv co cA cC
    cdiv co cmin co cn wcel wb cA cC cdiv co cn wcel cA cB clt wbr wa cA cn
    wcel cB cn wcel cC cn wcel w3a cB cA cmin co cC cdiv co cB cC cdiv co cA cC
    cdiv co cmin co cn cB cc wcel cA cc wcel cC cc wcel cC cc0 wne wa cB cA
    cmin co cC cdiv co cB cC cdiv co cA cC cdiv co cmin co wceq cA cn wcel cB
    cn wcel cC cn wcel w3a cB cA cC divsubdir cB cn wcel cA cn wcel cB cc wcel
    cC cn wcel cB nncn 3ad2ant2 cA cn wcel cB cn wcel cA cc wcel cC cn wcel cA
    nncn 3ad2ant1 cC cn wcel cA cn wcel cC cc wcel cC cc0 wne wa cB cn wcel cC
    cn wcel cC cc wcel cC cc0 wne cC nncn cC nnne0 jca 3ad2ant3 syl3anc eleq1d
    adantr bitr4d $.
    $( [17-Jun-2008] $) $( [17-Jun-2008] $)

  $( A factor of a natural number cannot exceed it. $)
  nndivlub $p |- ( ( A e. NN /\ B e. NN )
        -> ( ( A / B ) e. NN ->  B <_ A ) ) $=
    cA cn wcel cB cn wcel wa cB cr wcel cc0 cB clt wbr wa cA cr wcel cc0 cA clt
    wbr wa wa cA cB cdiv co cn wcel cB cA cle wbr wi cB cn wcel cA cn wcel cB
    cr wcel cc0 cB clt wbr wa cA cr wcel cc0 cA clt wbr wa wa cB cn wcel cB cr
    wcel cc0 cB clt wbr wa cA cn wcel cA cr wcel cc0 cA clt wbr wa cB cn wcel
    cB cr wcel cc0 cB clt wbr cB nnre cB nngt0 jca cA cn wcel cA cr wcel cc0 cA
    clt wbr cA nnre cA nngt0 jca anim12i ancoms cB cr wcel cc0 cB clt wbr wa cA
    cr wcel cc0 cA clt wbr wa wa cB cA cle wbr c1 cA cB cdiv co cle wbr cA cB
    cdiv co cn wcel cB cr wcel cc0 cB clt wbr wa cA cr wcel cc0 cA clt wbr wa
    wa cB cA cle wbr cA cA cdiv co cA cB cdiv co cle wbr c1 cA cB cdiv co cle
    wbr cB cr wcel cc0 cB clt wbr wa cA cr wcel cc0 cA clt wbr wa cB cA cle wbr
    cA cA cdiv co cA cB cdiv co cle wbr wb cB cA cA lediv2 3anidm23 cA cr wcel
    cc0 cA clt wbr wa cA cA cdiv co cA cB cdiv co cle wbr c1 cA cB cdiv co cle
    wbr wb cB cr wcel cc0 cB clt wbr wa cA cc wcel cA cc0 wne cA cA cdiv co cA
    cB cdiv co cle wbr c1 cA cB cdiv co cle wbr wb cA cr wcel cc0 cA clt wbr wa
    cA cc wcel cA cc0 wne wa cA cA cdiv co c1 cA cB cdiv co cle cA divid breq1d
    cA cr wcel cA cc wcel cc0 cA clt wbr cA recn adantr cc0 cr wcel cA cr wcel
    cc0 cA clt wbr cA cc0 wne 0re cc0 cA ltne mp3an1 sylanc adantl bitrd cA cB
    cdiv co nnge1 syl5bir syl $.
    $( [17-Jun-2008] $) $( [17-Jun-2008] $)

  $c gcd $. $( The greatest common divisor $)

  $( Extend class notation to include the gdc function. $)
  wgcd $a class gcd ( A , B ) $.

  ${
    $d x A $.  $d x B $.
    $( ` gcd ( A , B ) ` is the largest natural number that evenly divides both
     ` A ` and ` B ` . $)
    df-gcd $a |- gcd ( A , B ) = sup ( { x e. NN | ( ( A / x ) e. NN
                                           /\ ( B / x ) e. NN ) } , NN , < ) $.

    $( Lemma for Euclid's Elements, Book 7, proposition 2. The original
       mentions the smaller measure being 'continually subtracted' from the
       larger.  Many authors interpret this phrase as ` A ` mod ` B ` . Here,
       just one subtraction step is proved to preserve the ` gcd ` . The
       ` rec ` function will be used in other proofs for iterated
       subtraction. $)
    ee7.2a $p |- ( ( A e. NN /\ B e. NN )
         -> (  A < B -> gcd ( A , B ) = gcd ( A , ( B - A ) ) ) ) $=
      cA cn wcel cB cn wcel wa cA cB clt wbr cA cB wgcd cA cB cA cmin co wgcd
      wceq cA cn wcel cB cn wcel wa cA cB clt wbr wa cA vx cv cdiv co cn wcel
      cB vx cv cdiv co cn wcel wa vx cn crab cn clt csup cA vx cv cdiv co cn
      wcel cB cA cmin co vx cv cdiv co cn wcel wa vx cn crab cn clt csup cA cB
      wgcd cA cB cA cmin co wgcd cA cn wcel cB cn wcel wa cA cB clt wbr wa cA
      vx cv cdiv co cn wcel cB vx cv cdiv co cn wcel wa vx cn crab cA vx cv
      cdiv co cn wcel cB cA cmin co vx cv cdiv co cn wcel wa vx cn crab wceq cA
      vx cv cdiv co cn wcel cB vx cv cdiv co cn wcel wa vx cn crab cn clt csup
      cA vx cv cdiv co cn wcel cB cA cmin co vx cv cdiv co cn wcel wa vx cn
      crab cn clt csup wceq cA cn wcel cB cn wcel wa cA cB clt wbr wa cA vx cv
      cdiv co cn wcel cB vx cv cdiv co cn wcel wa cA vx cv cdiv co cn wcel cB
      cA cmin co vx cv cdiv co cn wcel wa vx cn cA cn wcel cB cn wcel wa cA cB
      clt wbr wa vx cv cn wcel wa cA vx cv cdiv co cn wcel cB vx cv cdiv co cn
      wcel cB cA cmin co vx cv cdiv co cn wcel cA cn wcel cB cn wcel wa cA cB
      clt wbr wa vx cv cn wcel cA vx cv cdiv co cn wcel cB vx cv cdiv co cn
      wcel cB cA cmin co vx cv cdiv co cn wcel wb wi cA cn wcel cB cn wcel wa
      cA cB clt wbr vx cv cn wcel cA vx cv cdiv co cn wcel cB vx cv cdiv co cn
      wcel cB cA cmin co vx cv cdiv co cn wcel wb wi wi cA cn wcel cB cn wcel
      wa vx cv cn wcel cA cB clt wbr cA vx cv cdiv co cn wcel cB vx cv cdiv co
      cn wcel cB cA cmin co vx cv cdiv co cn wcel wb wi cA cn wcel cB cn wcel
      vx cv cn wcel cA cB clt wbr cA vx cv cdiv co cn wcel cB vx cv cdiv co cn
      wcel cB cA cmin co vx cv cdiv co cn wcel wb wi wi cA cn wcel cB cn wcel
      vx cv cn wcel w3a cA vx cv cdiv co cn wcel cA cB clt wbr cB vx cv cdiv co
      cn wcel cB cA cmin co vx cv cdiv co cn wcel wb cA cn wcel cB cn wcel vx
      cv cn wcel w3a cA vx cv cdiv co cn wcel cA cB clt wbr cB vx cv cdiv co cn
      wcel cB cA cmin co vx cv cdiv co cn wcel wb cA cB vx cv nndivsub exp32
      com23 3expia com23 imp imp pm5.32d rabbidv cn cA vx cv cdiv co cn wcel cB
      vx cv cdiv co cn wcel wa vx cn crab cA vx cv cdiv co cn wcel cB cA cmin
      co vx cv cdiv co cn wcel wa vx cn crab clt supeq1 syl vx cA cB df-gcd vx
      cA cB cA cmin co df-gcd 3eqtr4g ex $.
      $( [17-Jun-2008] $) $( [17-Jun-2008] $)
  $}

$( (End of Jeff Hoffman's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Fr&eacute;d&eacute;ric Lin&eacute;
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$( The following comment is to assist editor searches $)
$( Mathbox for Frederic Line $)

$( In the sequel "JFM" is the "Journal of Formalized Mathematics".
   http://mizar.uwb.edu.pl/JFM/mmlident.html

   "CAT_1" means  Bylinski Czeslaw, Introduction to Categories and Functors,
   Journal of Formalized Mathematics, 1990, volume 1, nb 2, pages 409--420,

   "CAT_2" means Bylinski Czeslaw, Subcategories and Products of Categories,
   Journal of Formalized Mathematics, 1990, volume 1, nb 4, pages 725--732,

   "CLASSES1" means Grzegorz Bancerek, Tarski's Classes and Ranks,
    Journal of Formalized Mathematics volume 1, nb 3, pages 563--567

   "Bourbaki" means Bourbaki's treatise. Notably the book
    General Topology (called TG here (for Topologie G&eacute;n&eacute;rale))
    The treatise is translated in English. At least the "General Topology"
    book.

   "Aitken" means "Incidence betweenness geometry".
   Notes by Professor Aitken. Spring 2007
   http://public.csusm.edu/aitken_html/m410/betweenness.pdf

   "Viro" means O. Ya. Viro, O. A. Ivanov, N. Yu. Netsvetaev, V. M. Kharlamov,
   Elementary topology. Available on the net.
$)

  $v A1 $.
  $v A2 $.
  $v B1 $.
  $v B2 $.
  $v C1 $.
  $v C2 $.
  $v D1 $.
  $v D2 $.
  $v F1 $.
  $v F2 $.
  $v G1 $.
  $v G2 $.
  $v H1 $.
  $v H2 $.
  $v I1 $.
  $v I2 $.
  $v L1 $.
  $v L2 $.
  $v M1 $.
  $v M2 $.
  $v O1 $.
  $v O2 $.
  $v Ro1 $.
  $v Ro2 $.
  $v S1 $.
  $v S2 $.
  $v V1 $.
  $v V2 $.
  $v V3 $.


  $( Let ` A1 ` be a class variable. $)
  cA1 $f class A1 $.
  $( Let ` A2 ` be a class variable. $)
  cA2 $f class A2 $.

  $( Let ` B1 ` be a class variable. $)
  cB1 $f class B1 $.
  $( Let ` B2 ` be a class variable. $)
  cB2 $f class B2 $.

  $( Let ` O1 ` be a class variable. $)
  co1 $f class O1 $.
  $( Let ` M1 ` be a class variable. $)
  cm1 $f class M1 $.

  $( Let ` O2 ` be a class variable. $)
  co2 $f class O2 $.
  $( Let ` M2 ` be a class variable. $)
  cm2 $f class M2 $.

  $( Let ` I1 ` be a class variable. $)
  ci1 $f class I1 $.
  $( Let ` D1 ` be a class variable. $)
  cd1 $f class D1 $.
  $( Let ` C1 ` be a class variable. $)
  cc1 $f class C1 $.
  $( Let ` Ro1 ` be a class variable. $)
  cro1 $f class Ro1 $.

  $( Let ` I2 ` be a class variable. $)
  ci2 $f class I2 $.
  $( Let ` D2 ` be a class variable. $)
  cd2 $f class D2 $.
  $( Let ` C2 ` be a class variable. $)
  cc2 $f class C2 $.
  $( Let ` Ro2 ` be a class variable. $)
  cro2 $f class Ro2 $.

  $( Let ` F1 ` be a class variable. $)
  cF1 $f class F1 $.
  $( Let ` F2 ` be a class variable. $)
  cF2 $f class F2 $.

  $( Let ` G1 ` be a class variable. $)
  cG1 $f class G1 $.
  $( Let ` G2 ` be a class variable. $)
  cG2 $f class G2 $.

  $( Let ` H1 ` be a class variable. $)
  cH1 $f class H1 $.
  $( Let ` H2 ` be a class variable. $)
  cH2 $f class H2 $.

  $( Let ` L1 ` be a class variable. $)
  cL1 $f class L1 $.
  $( Let ` L2 ` be a class variable. $)
  cL2 $f class L2 $.

  $( Let ` S1 ` be a class variable. $)
  cS1 $f class S1 $.
  $( Let ` S2 ` be a class variable. $)
  cS2 $f class S2 $.

  $( Let ` V1 ` be a class variable. $)
  cV1 $f class V1 $.
  $( Let ` V2 ` be a class variable. $)
  cV2 $f class V2 $.
  $( Let ` V3 ` be a class variable. $)
  cV3 $f class V3 $.

  $v plus_t $.
  $v minus_t $.
  $v dot_t $.
  $v tild_t $.
  $v zero_t $.
  $v one_t $.
  $v plus_w $.
  $v minus_w $.
  $v dot_w $.
  $v zero_w $.
  $v tild_w $.

  $( Let ` plus_t ` be a class variable. I suggest to use variables consisting
     in the signs ` + ` or ` x. ` and in letters to name the various
     occurences of the highly overloaded addition and multiplication signs. $)
  cpls $f class plus_t $.

  $( Let ` minus_t ` be a class variable. $)
  cmnu $f class minus_t $.

  $( Let ` dot_t ` be a class variable. $)
  cmus $f class dot_t $.

  $( Let ` tild_t ` be a class variable. $)
  cnes $f class tild_t $.

  $( Let ` zero_t ` be a class variable. $)
  czert $f class zero_t $.

  $( Let ` one_t ` be a class variable. $)
  conet $f class one_t $.

  $( Let ` plus_w ` be a class variable. $)
  cplw $f class plus_w $.

  $( Let ` minus_w ` be a class variable. $)
  cminw $f class minus_w $.

  $( Let ` dot_w ` be a class variable. $)
  cmw $f class dot_w $.

  $( Let ` zero_w ` be a class variable. $)
  czerw $f class zero_w $.

  $( Let ` tild_w ` be a class variable. $)
  cnegw $f class tild_w $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Propositional and predicate calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    intn3and.1 $e |- ( ph -> -. ps ) $.
    $( Introduction of a triple conjunct inside a contradiction. $)
    intn3an1d $p |- ( ph -> -. ( ps /\ ch /\ th ) ) $=
      wph wps wch wa wth wa wn wps wch wth w3a wn wph wps wch wa wth wph wps
      wch intn3and.1 intnanrd intnanrd wps wch wth w3a wps wch wa wth wa wps
      wch wth df-3an notbii sylibr $.
      $( [3-Jan-2008] $) $( [27-Dec-2007] $)

    $( Introduction of a triple conjunct inside a contradiction. $)
    intn3an2d $p |- ( ph -> -. ( ch /\ ps /\ th ) ) $=
      wph wch wps wa wth wa wn wch wps wth w3a wn wph wch wps wa wth wph wps
      wch intn3and.1 intnand intnanrd wch wps wth w3a wch wps wa wth wa wch wps
      wth df-3an notbii sylibr $.
      $( [3-Jan-2008] $) $( [27-Dec-2007] $)

    $( Introduction of a triple conjunct inside a contradiction. $)
    intn3an3d $p |- ( ph -> -. ( ch /\ th /\ ps ) ) $=
      wph wch wth wa wps wa wn wch wth wps w3a wn wph wps wch wth wa intn3and.1
      intnand wch wth wps w3a wch wth wa wps wa wch wth wps df-3an notbii
      sylibr $.
      $( [3-Jan-2008] $) $( [27-Dec-2007] $)
  $}

  $( A consequence of ` /\ ` associativity in a triple conjunct. $)
  and4as $p |- ( ( ph /\ ps /\ ( ch /\ th ) ) <->
    ( ( ph /\ ps /\ ch ) /\ th ) ) $=
    wph wps wch wth wa w3a wph wps wch w3a wth wa wph wps wch wth wa wph wps
    wch w3a wth wa wph wps wch wth wph wps wch w3a wth wa wph wps wch wth wph
    wps wch w3a wth wa wi wph wps wch w3a wth pm3.2 3exp imp4a 3imp wph wps wch
    wth wph wps wch wth wa w3a wph wps wch wth wph wps wch wth wa w3a wph wps
    wch wth wa wph wps wch wth wa w3a wph wps wch wth wa w3a id 3exp exp4a
    3imp1 impbii $.
    $( [14-Jul-2007] $) $( [14-Jul-2007] $)

  $( A consequence of ` /\ ` associativity in a triple conjunct. $)
  and4com $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) <->
    ( ( ph /\ ps /\ ch ) /\ th ) ) $=
    wph wps wch wth w3a wa wph wps wch w3a wth wa wph wps wch wth wph wps wch
    w3a wth wa wph wps wch wth wph wps wch w3a wth wa wi wph wps wch w3a wth
    pm3.2 3exp 3imp2 wph wps wch wth wph wps wch wth w3a wa wph wps wch wth wph
    wps wch wth w3a wa wph wps wch wth w3a pm3.2 3expd 3imp1 impbii $.
    $( [14-Jul-2007] $) $( [14-Jul-2007] $)

  ${ $v et $. $( Greek eta $)
    anddi2.wet $f wff et $.
    $( Conjunction of triple disjunctions. $)
    anddi2 $p |- ( ( ( ph \/ ps \/ ch ) /\ ( th \/ ta \/ et ) ) <->
              ( ( ( ph /\ th ) \/ ( ph /\ ta ) \/ ( ph /\ et ) ) \/
              ( ( ps /\ th ) \/ ( ps /\ ta ) \/ ( ps /\ et ) ) \/
              ( ( ch /\ th ) \/ ( ch /\ ta ) \/ ( ch /\ et ) ) ) ) $=
      wph wps wch w3o wth wta anddi2.wet w3o wa wph wps wo wch wo wth wta wo
      anddi2.wet wo wa wph wps wo wth wta wo wa wph wps wo anddi2.wet wa wo wch
      wth wta wo wa wch anddi2.wet wa wo wo wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wch wth wa
      wch wta wa wch anddi2.wet wa w3o w3o wph wps wch w3o wph wps wo wch wo
      wth wta anddi2.wet w3o wth wta wo anddi2.wet wo wph wps wch df-3or wth
      wta anddi2.wet df-3or anbi12i wph wps wo wch wth wta wo anddi2.wet anddi
      wph wps wo wth wta wo wa wph wps wo anddi2.wet wa wo wch wth wta wo wa
      wch anddi2.wet wa wo wo wph wth wa wph wta wa wo wps wth wa wps wta wa wo
      wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch wth wa wch wta wa wo wch
      anddi2.wet wa wo wo wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth
      wa wps wta wa wps anddi2.wet wa w3o wch wth wa wch wta wa wch anddi2.wet
      wa w3o w3o wph wps wo wth wta wo wa wph wps wo anddi2.wet wa wo wph wth
      wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wta wo wa wch anddi2.wet wa wo wch wth wa wch
      wta wa wo wch anddi2.wet wa wo wph wps wo wth wta wo wa wph wth wa wph
      wta wa wo wps wth wa wps wta wa wo wo wph wps wo anddi2.wet wa wph
      anddi2.wet wa wps anddi2.wet wa wo wph wps wth wta anddi wph wps
      anddi2.wet andir orbi12i wch wth wta wo wa wch wth wa wch wta wa wo wch
      anddi2.wet wa wch wth wta andi orbi1i orbi12i wph wth wa wph wta wa wo
      wps wth wa wps wta wa wo wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch
      wth wa wch wta wa wo wch anddi2.wet wa wo wo wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wch wth wa
      wch wta wa wch anddi2.wet wa w3o w3o wph wth wa wph wta wa wo wps wth wa
      wps wta wa wo wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch wth wa wch
      wta wa wo wch anddi2.wet wa wo wo wph wth wa wph wta wa wph anddi2.wet wa
      w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa
      wch anddi2.wet wa w3o wo wph wth wa wph wta wa wph anddi2.wet wa w3o wps
      wth wa wps wta wa wps anddi2.wet wa w3o wch wth wa wch wta wa wch
      anddi2.wet wa w3o w3o wph wth wa wph wta wa wo wps wth wa wps wta wa wo
      wo wph anddi2.wet wa wps anddi2.wet wa wo wo wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth
      wa wch wta wa wch anddi2.wet wa w3o wo wch wth wa wch wta wa wo wch
      anddi2.wet wa wo wph wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph
      wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa wps
      anddi2.wet wa w3o wo wch wth wa wch wta wa wch anddi2.wet wa w3o wo wph
      anddi2.wet wa wps anddi2.wet wa wo wph wth wa wph wta wa wo wph wth wa
      wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa
      w3o wo wch wth wa wch wta wa wch anddi2.wet wa w3o wo wps wth wa wps wta
      wa wo wph wth wa wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa
      wps wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa wch anddi2.wet
      wa w3o wo wph wta wa wph wth wa wph wth wa wph wta wa wph anddi2.wet wa
      w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa
      wch anddi2.wet wa w3o wph wth wa wph wth wa wph wta wa wph anddi2.wet wa
      w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wph wth wa wph wta wa wph
      anddi2.wet wa 3mix1 orcd orcd wph wta wa wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth
      wa wch wta wa wch anddi2.wet wa w3o wph wta wa wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wph wta wa
      wph wth wa wph anddi2.wet wa 3mix2 orcd orcd jaoi wps wth wa wph wth wa
      wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa
      w3o wo wch wth wa wch wta wa wch anddi2.wet wa w3o wo wps wta wa wps wth
      wa wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa wps
      anddi2.wet wa w3o wo wch wth wa wch wta wa wch anddi2.wet wa w3o wps wth
      wa wps wth wa wps wta wa wps anddi2.wet wa w3o wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa 3mix1 olcd orcd
      wps wta wa wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta
      wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa wch anddi2.wet wa w3o
      wps wta wa wps wth wa wps wta wa wps anddi2.wet wa w3o wph wth wa wph wta
      wa wph anddi2.wet wa w3o wps wta wa wps wth wa wps anddi2.wet wa 3mix2
      olcd orcd jaoi jaoi wph anddi2.wet wa wph wth wa wph wta wa wph
      anddi2.wet wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth
      wa wch wta wa wch anddi2.wet wa w3o wo wps anddi2.wet wa wph anddi2.wet
      wa wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa wps
      anddi2.wet wa w3o wo wch wth wa wch wta wa wch anddi2.wet wa w3o wph
      anddi2.wet wa wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps
      wta wa wps anddi2.wet wa w3o wph anddi2.wet wa wph wth wa wph wta wa
      3mix3 orcd orcd wps anddi2.wet wa wph wth wa wph wta wa wph anddi2.wet wa
      w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa
      wch anddi2.wet wa w3o wps anddi2.wet wa wps wth wa wps wta wa wps
      anddi2.wet wa w3o wph wth wa wph wta wa wph anddi2.wet wa w3o wps
      anddi2.wet wa wps wth wa wps wta wa 3mix3 olcd orcd jaoi jaoi wch wth wa
      wch wta wa wo wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps
      wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa wch anddi2.wet wa
      w3o wo wch anddi2.wet wa wch wth wa wph wth wa wph wta wa wph anddi2.wet
      wa w3o wps wth wa wps wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta
      wa wch anddi2.wet wa w3o wo wch wta wa wch wth wa wch wth wa wch wta wa
      wch anddi2.wet wa w3o wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth
      wa wps wta wa wps anddi2.wet wa w3o wo wch wth wa wch wta wa wch
      anddi2.wet wa 3mix1 olcd wch wta wa wch wth wa wch wta wa wch anddi2.wet
      wa w3o wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa
      wps anddi2.wet wa w3o wo wch wta wa wch wth wa wch anddi2.wet wa 3mix2
      olcd jaoi wch anddi2.wet wa wch wth wa wch wta wa wch anddi2.wet wa w3o
      wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta wa wps
      anddi2.wet wa w3o wo wch anddi2.wet wa wch wth wa wch wta wa 3mix3 olcd
      jaoi jaoi wph wth wa wph wta wa wph anddi2.wet wa w3o wps wth wa wps wta
      wa wps anddi2.wet wa w3o wch wth wa wch wta wa wch anddi2.wet wa w3o
      df-3or sylibr wph wth wa wph wta wa wph anddi2.wet wa w3o wph wth wa wph
      wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps anddi2.wet wa
      wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wo wps wth wa wps wta
      wa wps anddi2.wet wa w3o wch wth wa wch wta wa wch anddi2.wet wa w3o wph
      wth wa wph wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph
      anddi2.wet wa wps anddi2.wet wa wo wo wch wth wa wch wta wa wo wch
      anddi2.wet wa wo wo wph wta wa wph anddi2.wet wa wph wth wa wph wth wa
      wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wph wth
      wa wph wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa
      wps anddi2.wet wa wo wph wth wa wph wth wa wph wta wa wo wps wth wa wps
      wta wa wo wph wth wa wph wta wa orc orcd orcd orcd wph wta wa wph wth wa
      wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wph wta
      wa wph wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa
      wps anddi2.wet wa wo wph wta wa wph wth wa wph wta wa wo wps wth wa wps
      wta wa wo wph wta wa wph wth wa olc orcd orcd orcd wph anddi2.wet wa wph
      wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wph
      anddi2.wet wa wph anddi2.wet wa wps anddi2.wet wa wo wph wth wa wph wta
      wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps anddi2.wet wa orc
      olcd orcd 3jaoi wps wth wa wph wth wa wph wta wa wo wps wth wa wps wta wa
      wo wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch wth wa wch wta wa wo
      wch anddi2.wet wa wo wo wps wta wa wps anddi2.wet wa wps wth wa wph wth
      wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wps wth
      wa wph wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa
      wps anddi2.wet wa wo wps wth wa wps wth wa wps wta wa wo wph wth wa wph
      wta wa wo wps wth wa wps wta wa orc olcd orcd orcd wps wta wa wph wth wa
      wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wps wta
      wa wph wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa
      wps anddi2.wet wa wo wps wta wa wps wth wa wps wta wa wo wph wth wa wph
      wta wa wo wps wta wa wps wth wa olc olcd orcd orcd wps anddi2.wet wa wph
      wth wa wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wth wa wch wta wa wo wch anddi2.wet wa wo wps
      anddi2.wet wa wph anddi2.wet wa wps anddi2.wet wa wo wph wth wa wph wta
      wa wo wps wth wa wps wta wa wo wo wps anddi2.wet wa wph anddi2.wet wa olc
      olcd orcd 3jaoi wch wth wa wph wth wa wph wta wa wo wps wth wa wps wta wa
      wo wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch wth wa wch wta wa wo
      wch anddi2.wet wa wo wo wch wta wa wch anddi2.wet wa wch wth wa wch wth
      wa wch wta wa wo wch anddi2.wet wa wo wph wth wa wph wta wa wo wps wth wa
      wps wta wa wo wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch wth wa wch
      wth wa wch wta wa wo wch anddi2.wet wa wch wth wa wch wta wa orc orcd
      olcd wch wta wa wch wth wa wch wta wa wo wch anddi2.wet wa wo wph wth wa
      wph wta wa wo wps wth wa wps wta wa wo wo wph anddi2.wet wa wps
      anddi2.wet wa wo wo wch wta wa wch wth wa wch wta wa wo wch anddi2.wet wa
      wch wta wa wch wth wa olc orcd olcd wch anddi2.wet wa wch wth wa wch wta
      wa wo wch anddi2.wet wa wo wph wth wa wph wta wa wo wps wth wa wps wta wa
      wo wo wph anddi2.wet wa wps anddi2.wet wa wo wo wch anddi2.wet wa wch wth
      wa wch wta wa wo olc olcd 3jaoi 3jaoi impbii bitri 3bitri $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${
    $d w ps $.  $d x ps $.  $d y ps $.  $d z ps $.
    $( Theorem 19.41 of [Margaris] p. 90 with 4 quantifiers. $)
    19.41vvvv $p |- ( E. w E. x E. y E. z ( ph /\ ps ) <->
                     ( E. w E. x E. y E. z ph /\ ps ) ) $=
      wph wps wa vz wex vy wex vx wex vw wex wph vz wex vy wex vx wex wps wa vw
      wex wph vz wex vy wex vx wex vw wex wps wa wph wps wa vz wex vy wex vx
      wex wph vz wex vy wex vx wex wps wa vw wph wps vx vy vz 19.41vvv exbii
      wph vz wex vy wex vx wex wps vw 19.41v bitri $.
      $( [14-Jul-2007] $) $( [14-Jul-2007] $)
  $}

  ${ $d ch w x z $.  $d ph x y $.  $d ph x z $.  $d ps w y $.
     $d ps w z $.  $d th w x y $.
    $( Rearrange existential quantifiers. $)
    eeeeanv $p |- ( E. w E. x E. y E. z ( ( ph /\ ps /\ ch ) /\ th ) <->
                 ( ( E. w ph /\ E. x ps /\ E. y ch ) /\ E. z th ) ) $=
      wps wch wth w3a wph wa vz wex vy wex vx wex vw wex wph vw wex wps vx wex
      wch vy wex wth vz wex w3a wa wph wps wch w3a wth wa vz wex vy wex vx wex
      vw wex wph vw wex wps vx wex wch vy wex w3a wth vz wex wa wps wch wth w3a
      wph wa vz wex vy wex vx wex vw wex wph wps vx wex wch vy wex wth vz wex
      w3a wa vw wex wph vw wex wps vx wex wch vy wex wth vz wex w3a wa wps wch
      wth w3a wph wa vz wex vy wex vx wex wph wps vx wex wch vy wex wth vz wex
      w3a wa vw wps wch wth w3a wph wa vz wex vy wex vx wex wps wch wth w3a vz
      wex vy wex vx wex wph wa wph wps wch wth w3a vz wex vy wex vx wex wa wph
      wps vx wex wch vy wex wth vz wex w3a wa wps wch wth w3a wph vx vy vz
      19.41vvv wps wch wth w3a vz wex vy wex vx wex wph ancom wps wch wth w3a
      vz wex vy wex vx wex wps vx wex wch vy wex wth vz wex w3a wph wps wch wth
      vx vy vz eeeanv anbi2i 3bitri exbii wph wps vx wex wch vy wex wth vz wex
      w3a vw 19.41v bitri wps wch wth w3a wph wa vz wex vy wex vx wex wph wps
      wch w3a wth wa vz wex vy wex vx wex vw wps wch wth w3a wph wa wph wps wch
      w3a wth wa vx vy vz wps wch wth w3a wph wa wph wps wch wth w3a wa wph wps
      wch w3a wth wa wps wch wth w3a wph ancom wph wps wch wth and4com bitri
      3exbii exbii wph vw wex wps vx wex wch vy wex wth vz wex and4com 3bitr3i
      $.
      $( [14-Jul-2007] $) $( [14-Jul-2007] $)
  $}

  ${ $d x A $.
    r19.3rzvb.1 $e |- ( ph -> A. x ph ) $.
    $( Restricted quantification of a proposition where the variable is not
       free. See ~ r19.3rzv . $)
    r19.3rzvb $p |- ( A =/= (/) -> ( ph <-> A. x e. A ph ) ) $=
      cA c0 wne wph vx cv cA wcel vx wex wph wi wph vx cA wral cA c0 wne vx cv
      cA wcel vx wex wph vx cv cA wcel vx wex wph wi wb vx cA n0 vx cv cA wcel
      vx wex wph biimt sylbi wph vx cA wral vx cv cA wcel wph wi vx wal vx cv
      cA wcel vx wex wph wi wph vx cA df-ral vx cv cA wcel wph vx r19.3rzvb.1
      19.23 bitri syl6bbr $.
      $( [3-Jan-2008] $) $( [3-Jan-2008] $)
  $}

  ${
    pm2.01bd.1 $e |- ( ph -> ( -. ps -> ps ) ) $.
    $( Deduction based on reductio ad absurdum. $)
    pm2.01bd $p |- ( ph -> ps ) $=
      wph wps wn wn wps wph wps wn wph wps wn wps pm2.01bd.1 con3d pm2.01d wps
      notnot sylibr $.
      $( [3-Aug-2009] $) $( [12-Jul-2009] $)
  $}

  $( Negation of a complex predicate calculus formula. $)
  negcmpprcal1 $p |- ( -. E. x e. A A. y e. B ( ph -> ps )
     <-> A. x e. A E. y e. B ( ph /\ -. ps ) ) $=
    wph wps wn wa vy cB wrex vx cA wral wph wps wi vy cB wral wn vx cA wral wph
    wps wi vy cB wral vx cA wrex wn wph wps wn wa vy cB wrex wph wps wi vy cB
    wral wn vx cA wph wps vy cB rexanali ralbii wph wps wi vy cB wral vx cA
    ralnex bitr2i $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  $( Negation of a complex predicated inequality. $)
  negcmpprcal2 $p |- ( -. E. x e. A A. y e. B C =/= D
    <-> A. x e. A E. y e. B C = D ) $=
    cC cD wne vy cB wral wn vx cA wral cC cD wne wn vy cB wrex vx cA wral cC cD
    wne vy cB wral vx cA wrex wn cC cD wceq vy cB wrex vx cA wral cC cD wne vy
    cB wral wn cC cD wne wn vy cB wrex vx cA cC cD wne wn vy cB wrex cC cD wne
    vy cB wral wn cC cD wne vy cB rexnal bicomi ralbii cC cD wne vy cB wral vx
    cA ralnex cC cD wne wn vy cB wrex cC cD wceq vy cB wrex vx cA cC cD wne wn
    cC cD wceq vy cB cC cD nne rexbii ralbii 3bitr3i $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  $( Declare connectives for exclusive disjunction ('xor'). $)
  $c (+) $. $( Oplus (read:  'xor') $)

  $( Extend wff definition to include exclusive disjunction ('xor'). $)
  wxo $a wff ( ph (+) ps ) $.

  $( Define exclusive disjunction (logical 'xor'). $)
  df-xor $a |- ( ( ph (+) ps ) <-> -. ( ph <-> ps ) ) $.

  $( ` (+) ` is associative. $)
  assxor $p |- ( ( ( ph (+) ps ) (+) ch ) <-> ( ph (+) ( ps (+) ch ) ) ) $=
    wph wps wxo wch wxo wph wps wb wn wch wb wn wph wps wch wb wn wb wn wph wps
    wch wxo wxo wph wps wxo wch wxo wph wps wxo wch wb wn wph wps wb wn wch wb
    wn wph wps wxo wch df-xor wph wps wxo wch wb wph wps wb wn wch wb wph wps
    wxo wph wps wb wn wch wph wps df-xor bibi1i notbii bitri wph wps wb wn wch
    wb wph wps wch wb wn wb wph wps wb wn wch wb wps wph wb wn wch wb wps wn
    wph wb wch wb wph wps wch wb wn wb wph wps wb wn wps wph wb wn wch wph wps
    wb wps wph wb wph wps bicom notbii bibi1i wps wph wb wn wps wn wph wb wch
    wps wn wph wb wps wph wb wn wps wph nbbn bicomi bibi1i wps wn wph wb wch wb
    wph wps wn wb wch wb wph wps wn wch wb wb wph wps wch wb wn wb wps wn wph
    wb wph wps wn wb wch wps wn wph bicom bibi1i wph wps wn wch biass wps wn
    wch wb wps wch wb wn wph wps wch nbbn bibi2i 3bitri 3bitri notbii wph wps
    wch wxo wxo wph wps wch wxo wb wn wph wps wch wb wn wb wn wph wps wch wxo
    df-xor wph wps wch wxo wb wph wps wch wb wn wb wps wch wxo wps wch wb wn
    wph wps wch df-xor bibi2i notbii bitr2i 3bitri $.
    $( [6-Dec-2010] $) $( [22-Nov-2010] $)

  $( This tautology shows that xor is really exclusive. $)
  excxor $p |- ( ( ph (+) ps ) <->
       ( ( ph /\ -. ps ) \/ ( -. ph /\ ps ) ) ) $=
    wph wps wxo wph wps wb wn wph wps wn wa wps wph wn wa wo wph wps wn wa wph
    wn wps wa wo wph wps df-xor wph wps xor wps wph wn wa wph wn wps wa wph wps
    wn wa wps wph wn ancom orbi2i 3bitri $.
    $( [6-Dec-2010] $) $( [22-Nov-2010] $)

  ${
    $d A y $. $d B y $. $d x y $.
    eqriv2.1 $e |- ( y e. A -> A. x y e. A ) $.
    eqriv2.2 $e |- ( y e. B -> A. x y e. B ) $.
    eqriv2.3 $e |- ( x e. A <-> x e. B ) $.
    $( Infer equality of classes from equivalence of membership. $)
    eqriv2 $p |- A = B $=
      cA cB wceq vx cv cA wcel vx cv cB wcel wb vx vx vy cA cB eqriv2.1
      eqriv2.2 cleqf eqriv2.3 mpgbir $.
      $( [6-Dec-2010] $) $( [22-Nov-2010] $)
  $}

  $( Theorem 19.26 of [Margaris] p. 90 with restricted quantifiers and three
     propositional variables. $)
  r19.26t $p |- ( A. x e. A ( ph /\ ps /\ ch ) <->
               ( A. x e. A ph /\ A. x e. A ps /\ A. x e. A ch ) ) $=
    wph wps wch w3a vx cA wral wph wps wa wch wa vx cA wral wph wps wa vx cA
    wral wch vx cA wral wa wph vx cA wral wps vx cA wral wch vx cA wral w3a wph
    wps wch w3a wph wps wa wch wa vx cA wph wps wch df-3an ralbii wph wps wa
    wch vx cA r19.26 wph wps wa vx cA wral wch vx cA wral wa wph vx cA wral wps
    vx cA wral wa wch vx cA wral wa wph vx cA wral wps vx cA wral wch vx cA
    wral w3a wph wps wa vx cA wral wph vx cA wral wps vx cA wral wa wch vx cA
    wral wph wps vx cA r19.26 anbi1i wph vx cA wral wps vx cA wral wch vx cA
    wral df-3an bitr4i 3bitri $.
    $( [6-Dec-2010] $) $( [22-Nov-2010] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${ $d x y z $.
    $( Two ways to state the domains of the variables of an operation. $)
    twsvbdop $p |-
      { <. <. x , y >. , z >. | ( <. x , y >. e. ( A X. B ) /\ ph ) } =
        { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ph ) } $=
      vx cv vy cv cop cA cB cxp wcel wph wa vx cv cA wcel vy cv cB wcel wa wph
      wa vx vy vz vx cv vy cv cop cA cB cxp wcel vx cv cA wcel vy cv cB wcel wa
      wph vx cv vy cv cA cB vy visset opelxp anbi1i oprabbii $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${ $d ch u $. $d ph u x z $. $d ph u y z $. $d ps u $.
    ssoprab2g.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference of operation class abstraction subclass from implication. $)
    ssoprab2g $p |- ( ph -> { <. <. x , y >. , z >. | ps } C_
        { <. <. x , y >. , z >. | ch } ) $=
      wph vu cv vx cv vy cv cop wceq wps wa vy wex vx wex vu vz copab vu cv vx
      cv vy cv cop wceq wch wa vy wex vx wex vu vz copab wps vx vy vz copab2
      wch vx vy vz copab2 wph vu cv vx cv vy cv cop wceq wps wa vy wex vx wex
      vu cv vx cv vy cv cop wceq wch wa vy wex vx wex wi vz wal vu wal vu cv vx
      cv vy cv cop wceq wps wa vy wex vx wex vu vz copab vu cv vx cv vy cv cop
      wceq wch wa vy wex vx wex vu vz copab wss wph vu cv vx cv vy cv cop wceq
      wps wa vy wex vx wex vu cv vx cv vy cv cop wceq wch wa vy wex vx wex wi
      vu vz wph vu cv vx cv vy cv cop wceq wps wa vu cv vx cv vy cv cop wceq
      wch wa vx vy wph wps wch vu cv vx cv vy cv cop wceq ssoprab2g.1 anim2d
      19.22dvv 19.21aivv vu cv vx cv vy cv cop wceq wps wa vy wex vx wex vu cv
      vx cv vy cv cop wceq wch wa vy wex vx wex vu vz ssopab2 sylibr wps vx vy
      vz vu dfoprab2 wch vx vy vz vu dfoprab2 3sstr4g $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${ $d A x y z $. $d B x y z $.
    $( The domain of an operation class abstraction. Compare ~ dmoprabss . $)
    dmoprabsss $p |- dom { <. <. x , y >. , z >. |
    ( <. x , y >. e. ( A X. B ) /\ ph ) } C_ ( A X. B ) $=
      vx cv vy cv cop cA cB cxp wcel wph wa vx vy vz copab2 cdm vx cv cA wcel
      vy cv cB wcel wa wph wa vx vy vz copab2 cdm cA cB cxp vx cv vy cv cop cA
      cB cxp wcel wph wa vx vy vz copab2 vx cv cA wcel vy cv cB wcel wa wph wa
      vx vy vz copab2 wph vx vy vz cA cB twsvbdop dmeqi wph vx vy vz cA cB
      dmoprabss eqsstri $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z S $.
    $d x ps $.  $d x y ch $.  $d x y z th $.
    oprabvaligg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    oprabvaligg.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    oprabvaligg.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    oprabvaligg.4 $e |- E* z ph $.
    oprabvaligg.5 $e |- F =
                  { <. <. x , y >. , z >. | ph } $.
    $( The value of an operation class abstraction. See ~ oprabvalig .
       The conditions ` ( x e. R /\ y e. S ) ` has been removed. $)
    oprabvaligg $p |- ( ( A e. R /\ B e. S /\ C e. D ) ->
                         ( th -> ( A F B ) = C ) ) $=
      cA cR wcel cB cS wcel cC cD wcel w3a wth cA cB cop wph vx vy vz copab2
      cfv cC wceq cA cB cF co cC wceq cA cR wcel cB cS wcel cC cD wcel w3a wth
      cA cB cop cC cop wph vx vy vz copab2 wcel cA cB cop wph vx vy vz copab2
      cfv cC wceq wph wps wch wth vx vy vz cA cB cC cR cS cD oprabvaligg.1
      oprabvaligg.2 oprabvaligg.3 eloprabg cC cD wcel cA cR wcel cA cB cop cC
      cop wph vx vy vz copab2 wcel cA cB cop wph vx vy vz copab2 cfv cC wceq wi
      cB cS wcel cC cD wcel wph vx vy vz copab2 wfun cA cB cop cC cop wph vx vy
      vz copab2 wcel cA cB cop wph vx vy vz copab2 cfv cC wceq wi wph vx vy vz
      oprabvaligg.4 funoprab cA cB cop cC cD wph vx vy vz copab2 funopfvg mpan2
      3ad2ant3 sylbird cA cB cF co cA cB cop wph vx vy vz copab2 cfv cC cA cB
      cF co cA cB cop cF cfv cA cB cop wph vx vy vz copab2 cfv cA cB cF df-opr
      cA cB cop cF wph vx vy vz copab2 oprabvaligg.5 fveq1i eqtri eqeq1i
      syl6ibr $.
      $( [14-Sep-1999] $)
  $}

  $( The value of a member of the domain of a subclass of an operation.
     A more general version of ~ oprssoprv adapted to partial functions.
   $)
  oprssoprvg $p |- ( ( Fun F /\ G C_ F /\ <. A , B >. e. dom G )
    -> ( A F B ) = ( A G B ) ) $=
    cF wfun cG cF wss cA cB cop cG cdm wcel w3a cA cB cF cG cdm cres co cA cB
    cF co cA cB cG co cA cB cop cG cdm wcel cF wfun cA cB cF cG cdm cres co cA
    cB cF co wceq cG cF wss cA cB cop cG cdm wcel cA cB cop cF cG cdm cres cfv
    cA cB cop cF cfv cA cB cF cG cdm cres co cA cB cF co cA cB cop cG cdm cF
    fvres cA cB cF cG cdm cres df-opr cA cB cF df-opr 3eqtr4g 3ad2ant3 cF wfun
    cG cF wss cA cB cF cG cdm cres co cA cB cG co wceq cA cB cop cG cdm wcel cF
    wfun cG cF wss wa cF cG cdm cres cG cA cB cF cG funssres opreqd 3adant3
    eqtr3d $.
    $( [6-Oct-2009] $) $( [5-Oct-2009] $)

  ${
    $d A x y z $. $d B z $.
    dmoprabss5.1 $e |- B e. C $.
    $( A version of ~ dmoprabss more adapted to partial operations. $)
    dmoprabss6 $p |- ( Rel A ->
     dom { <. <. x , y >. , z >. | ( <. x , y >. e. A /\ z = B ) } = A ) $=
      cA wrel vx cv vy cv cop cA wcel vz cv cB wceq wa vz wex vx vy copab cA vx
      cv vy cv cop cA wcel vz cv cB wceq wa vx vy vz copab2 cdm cA wrel vx cv
      vy cv cop cA wcel vx vy copab cA vx cv vy cv cop cA wcel vz cv cB wceq wa
      vz wex vx vy copab vx vy cA opabid2 vx cv vy cv cop cA wcel vz cv cB wceq
      wa vz wex vx vy copab vx cv vy cv cop cA wcel vz cv cB wceq vz wex wa vx
      vy copab vx cv vy cv cop cA wcel vx vy copab vx cv vy cv cop cA wcel vz
      cv cB wceq wa vz wex vx cv vy cv cop cA wcel vz cv cB wceq vz wex wa vx
      vy vx cv vy cv cop cA wcel vz cv cB wceq vz 19.42v opabbii vx cv vy cv
      cop cA wcel vz cv cB wceq vz wex wa vx cv vy cv cop cA wcel vx vy vx cv
      vy cv cop cA wcel vz cv cB wceq vz wex wa vx cv vy cv cop cA wcel vx cv
      vy cv cop cA wcel vz cv cB wceq vz wex pm3.26 vx cv vy cv cop cA wcel vz
      cv cB wceq vz wex vz cB cB cC dmoprabss5.1 elisseti isseti jctr impbii
      opabbii eqtri syl5eq vx cv vy cv cop cA wcel vz cv cB wceq wa vx vy vz
      dmoprab syl5eq $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
    $d A z $. $d B x y z $. $d R x y z $.
    $( An adaption of ~ oprabex2g to partial operations. Here must
       be a relation, but it can be something else than a cross
       product (on the contrary it is mandatory in ~ oprabex2g ). $)
    oprabex2gpop $p |- ( ( R e. B /\ Rel R ) -> { <. <. x ,  y >. ,  z >.
      |  (  <. x , y >. e. R /\ z = A ) } e. _V ) $=
      vx cv vy cv cop cR wcel vz cv cA wceq wa vx vy vz copab2 vx cv vy cv cop
      cR cdm cR crn cxp wcel vz cv cA wceq wa vx vy vz copab2 wss vx cv vy cv
      cop cR cdm cR crn cxp wcel vz cv cA wceq wa vx vy vz copab2 cvv wcel vx
      cv vy cv cop cR wcel vz cv cA wceq wa vx vy vz copab2 cvv wcel cR cB wcel
      cR wrel wa vx cv vy cv cop cR wcel vz cv cA wceq wa vx vy vz copab2 vx cv
      vy cv cop cR cdm cR crn cxp wcel vz cv cA wceq wa vx vy vz copab2 cvv
      ssexg cR cB wcel cR wrel wa vx cv vy cv cop cR wcel vz cv cA wceq wa vx
      cv vy cv cop cR cdm cR crn cxp wcel vz cv cA wceq wa vx vy vz cR cB wcel
      cR wrel wa vx cv vy cv cop cR wcel vx cv vy cv cop cR cdm cR crn cxp wcel
      vz cv cA wceq cR cB wcel cR wrel wa cR cR cdm cR crn cxp vx cv vy cv cop
      cR wrel cR cR cdm cR crn cxp wss cR cB wcel cR relssdmrn adantl sseld
      anim1d ssoprab2g cR cB wcel cR wrel wa vx cv cR cdm wcel vy cv cR crn
      wcel wa vz cv cA wceq wa vx vy vz copab2 cvv vx cv vy cv cop cR cdm cR
      crn cxp wcel vz cv cA wceq wa vx vy vz copab2 cR cB wcel cR wrel wa cR
      cdm cvv wcel cR crn cvv wcel wa vx cv cR cdm wcel vy cv cR crn wcel wa vz
      cv cA wceq wa vx vy vz copab2 cvv wcel cR cB wcel cR cdm cvv wcel cR crn
      cvv wcel wa cR wrel cR cB wcel cR cdm cvv wcel cR crn cvv wcel cR cB
      dmexg cR cB rnexg jca adantr vx vy vz cR cdm cR crn cA cvv cvv vx cv cR
      cdm wcel vy cv cR crn wcel wa vz cv cA wceq wa vx vy vz copab2 vx cv cR
      cdm wcel vy cv cR crn wcel wa vz cv cA wceq wa vx vy vz copab2 eqid
      oprabex2g syl vz cv cA wceq vx vy vz cR cdm cR crn twsvbdop syl5eqel
      sylanc $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
    $d F w x y z $. $d R w x y z $.
    $( An adaptation of ~ fnoprv to partial operations. $)
    fnoprvpop $p |- ( Rel R -> ( F Fn R <->
    F = { <. <. x , y >. , z >. | ( <. x , y >. e. R  /\ z = ( x F y ) ) } ) )
    $=
      cR wrel cF vw cv cR wcel vz cv vw cv cF cfv wceq wa vw vz copab wceq cF
      vx cv vy cv cop cR wcel vz cv vx cv vy cv cF co wceq wa vx vy vz copab2
      wceq cF cR wfn cR wrel vw cv cR wcel vz cv vw cv cF cfv wceq wa vw vz
      copab vx cv vy cv cop cR wcel vz cv vx cv vy cv cF co wceq wa vx vy vz
      copab2 cF cR wrel vw cv cR wcel vz cv vw cv cF cfv wceq wa vw vz copab vw
      cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv vx cv vy cv cF co
      wceq wa wa vy wex vx wex vw vz copab vx cv vy cv cop cR wcel vz cv vx cv
      vy cv cF co wceq wa vx vy vz copab2 cR wrel vw cv cR wcel vz cv vw cv cF
      cfv wceq wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv vx
      cv vy cv cF co wceq wa wa vy wex vx wex vw vz cR wrel vw cv cR wcel vz cv
      vw cv cF cfv wceq wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel
      wa vy wex vx wex vz cv vw cv cF cfv wceq wa vw cv vx cv vy cv cop wceq vx
      cv vy cv cop cR wcel wa vz cv vw cv cF cfv wceq wa vy wex vx wex vw cv vx
      cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv vx cv vy cv cF co wceq wa
      wa vy wex vx wex cR wrel vw cv cR wcel vw cv vx cv vy cv cop wceq vx cv
      vy cv cop cR wcel wa vy wex vx wex vz cv vw cv cF cfv wceq cR wrel vw cv
      cR wcel vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel wa vy wex vx
      wex cR wrel vw cv cR wcel vw cv vx cv vy cv cop wceq vx cv vy cv cop cR
      wcel wa vy wex vx wex cR wrel vw cv cR wcel vw cv cR wcel vw cv vx cv vy
      cv cop wceq vx cv vy cv cop cR wcel wa vy wex vx wex wi vw cv cR wcel vw
      cv vx cv vy cv cop wceq vy wex vx wex vw cv vx cv vy cv cop wceq vx cv vy
      cv cop cR wcel wa vy wex vx wex cR wrel vw cv cR wcel wa vw cv cR wcel vw
      cv vx cv vy cv cop wceq vw cv vx cv vy cv cop wceq vx cv vy cv cop cR
      wcel wa vx vy vw cv cR wcel vw cv vx cv vy cv cop wceq vx cv vy cv cop cR
      wcel vw cv vx cv vy cv cop wceq vw cv cR wcel vx cv vy cv cop cR wcel vw
      cv vx cv vy cv cop cR eleq1 biimpcd ancld 19.22dvv vx vy vw cv cR elrel
      syl5com ex pm2.43d vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel wa
      vw cv cR wcel vx vy vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vw
      cv cR wcel vx cv vy cv cop cR wcel vw cv cR wcel wi vx cv vy cv cop vw cv
      vx cv vy cv cop vw cv wceq vx cv vy cv cop cR wcel vw cv cR wcel vx cv vy
      cv cop vw cv cR eleq1 biimpd eqcoms imp 19.23aivv impbid1 anbi1d vw cv vx
      cv vy cv cop wceq vx cv vy cv cop cR wcel wa vz cv vw cv cF cfv wceq wa
      vy wex vx wex vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel wa vy
      wex vx wex vz cv vw cv cF cfv wceq wa wb cR wrel vw cv vx cv vy cv cop
      wceq vx cv vy cv cop cR wcel wa vz cv vw cv cF cfv wceq vx vy 19.41vv a1i
      cR wrel vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel wa vz cv vw cv
      cF cfv wceq wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv
      vx cv vy cv cF co wceq wa wa vx vy vw cv vx cv vy cv cop wceq vx cv vy cv
      cop cR wcel wa vz cv vw cv cF cfv wceq wa vw cv vx cv vy cv cop wceq vx
      cv vy cv cop cR wcel vz cv vx cv vy cv cF co wceq wa wa wb cR wrel vw cv
      vx cv vy cv cop wceq vx cv vy cv cop cR wcel wa vz cv vw cv cF cfv wceq
      wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv vw cv cF cfv
      wceq wa wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel vz cv vx cv
      vy cv cF co wceq wa wa vw cv vx cv vy cv cop wceq vx cv vy cv cop cR wcel
      vz cv vw cv cF cfv wceq anass vw cv vx cv vy cv cop wceq vx cv vy cv cop
      cR wcel vz cv vw cv cF cfv wceq wa vx cv vy cv cop cR wcel vz cv vx cv vy
      cv cF co wceq wa vw cv vx cv vy cv cop wceq vz cv vw cv cF cfv wceq vz cv
      vx cv vy cv cF co wceq vx cv vy cv cop cR wcel vw cv vx cv vy cv cop wceq
      vw cv cF cfv vx cv vy cv cF co vz cv vw cv vx cv vy cv cop wceq vw cv cF
      cfv vx cv vy cv cop cF cfv vx cv vy cv cF co vw cv vx cv vy cv cop cF
      fveq2 vx cv vy cv cF df-opr syl6eqr eqeq2d anbi2d pm5.32i bitri a1i
      2exbidv 3bitr2d opabbidv vx cv vy cv cop cR wcel vz cv vx cv vy cv cF co
      wceq wa vx vy vz vw dfoprab2 syl6eqr eqeq2d vw vz cR cF dffn5 syl5bb $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
    $d R w x y z $. $d ph w $. $d ps x y $.
    dfoprab4spop.1 $e |- ( <. x , y >. = w -> ( ph <-> ps ) ) $.
    $( An adaptation of ~ dfoprab4s to partial operations. $)
    dfoprab4spop $p |- ( Rel R ->
         { <. <. x , y >. , z >. | ( <. x , y >. e. R /\ ph ) }
       = { <. w , z >. | ( w e. R /\ ps ) } ) $=
      cR wrel vw cv cvv cvv cxp wcel vw cv cR wcel wps wa wa vw vz copab vw cv
      cR wcel wps wa vw vz copab vx cv vy cv cop cR wcel wph wa vx vy vz copab2
      cR wrel vw cv cvv cvv cxp wcel vw cv cR wcel wps wa wa vw cv cR wcel wps
      wa vw vz cR wrel vw cv cvv cvv cxp wcel vw cv cR wcel wa wps wa vw cv cR
      wcel wps wa vw cv cvv cvv cxp wcel vw cv cR wcel wps wa wa cR wrel vw cv
      cvv cvv cxp wcel vw cv cR wcel wa vw cv cR wcel wps cR wrel vw cv cvv cvv
      cxp cR cin wcel vw cv cR wcel vw cv cvv cvv cxp wcel vw cv cR wcel wa cR
      wrel cR cvv cvv cxp wss vw cv cvv cvv cxp cR cin wcel vw cv cR wcel wb cR
      df-rel cR cvv cvv cxp wss cR cvv cvv cxp cin cR wceq vw cv cvv cvv cxp cR
      cin wcel vw cv cR wcel wb cR cvv cvv cxp df-ss cvv cvv cxp cR cin cR cvv
      cvv cxp cin wceq cR cvv cvv cxp cin cR wceq vw cv cvv cvv cxp cR cin wcel
      vw cv cR wcel wb cvv cvv cxp cR incom cvv cvv cxp cR cin cR cvv cvv cxp
      cin wceq cR cvv cvv cxp cin cR wceq wa cvv cvv cxp cR cin cR vw cv cvv
      cvv cxp cR cin cR cvv cvv cxp cin cR eqtr eleq2d mpan sylbi sylbi vw cv
      cvv cvv cxp cR elin syl5bbr anbi1d vw cv cvv cvv cxp wcel vw cv cR wcel
      wps anass syl5bbr opabbidv vx cv vy cv cop cR wcel wph wa vw cv cR wcel
      wps wa vx vy vz vw vx cv vy cv cop vw cv wceq vx cv vy cv cop cR wcel vw
      cv cR wcel wph wps vx cv vy cv cop vw cv cR eleq1 dfoprab4spop.1 anbi12d
      dfoprab3s syl5eq $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}



$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              General Set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c x u v $.  $d a b x C $.  $d a b c x B $.  $d a b x u v A $.
    $d R a b u v x $.  $d C a b c x $.
    uninqs.1 $e |- Er R $.
    $( Class union distributes over the intersection of two subclasses of a
       quotient space.  Compare ~ uniin . $)
    uninqs  $p |- ( ( B C_ ( A /. R ) /\ C C_ ( A /. R ) ) ->
      U. ( B i^i C ) = ( U. B i^i U. C ) ) $=
      cB cA cR cqs wss cC cA cR cqs wss wa cB cC cin cuni cB cuni cC cuni cin
      wss cB cuni cC cuni cin cB cC cin cuni wss wa cB cC cin cuni cB cuni cC
      cuni cin wceq cB cA cR cqs wss cC cA cR cqs wss wa cB cuni cC cuni cin cB
      cC cin cuni wss cB cC cin cuni cB cuni cC cuni cin wss cB cA cR cqs wss
      cC cA cR cqs wss wa vx cB cuni cC cuni cin cB cC cin cuni cB cA cR cqs
      wss cC cA cR cqs wss wa vx cv cB cuni wcel vx cv cC cuni wcel wa vx cv vc
      cv wcel vc cv cB cC cin wcel wa vc wex vx cv cB cuni cC cuni cin wcel vx
      cv cB cC cin cuni wcel cB cA cR cqs wss cC cA cR cqs wss wa vx cv cB cuni
      wcel vx cv cC cuni wcel vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex
      cB cA cR cqs wss cC cA cR cqs wss wa vx cv vb cv wcel vb cv cB wcel wa vb
      wex vx cv cC cuni wcel vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi
      vx cv cB cuni wcel cB cA cR cqs wss cC cA cR cqs wss wa vx cv vb cv wcel
      vb cv cB wcel wa vb wex vx cv va cv wcel va cv cC wcel wa va wex vx cv vc
      cv wcel vc cv cB cC cin wcel wa vc wex vx cv cC cuni wcel vx cv vb cv
      wcel vb cv cB wcel wa vb wex cB cA cR cqs wss cC cA cR cqs wss wa vx cv
      va cv wcel va cv cC wcel wa va wex vx cv vc cv wcel vc cv cB cC cin wcel
      wa vc wex wi vx cv vb cv wcel vb cv cB wcel wa cB cA cR cqs wss cC cA cR
      cqs wss wa vx cv va cv wcel va cv cC wcel wa va wex vx cv vc cv wcel vc
      cv cB cC cin wcel wa vc wex wi wi vb vx cv va cv wcel va cv cC wcel wa va
      wex cB cA cR cqs wss cC cA cR cqs wss wa vx cv vb cv wcel vb cv cB wcel
      wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex vx cv va cv wcel va cv
      cC wcel wa cB cA cR cqs wss cC cA cR cqs wss wa vx cv vb cv wcel vb cv cB
      wcel wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi va cB cA cR
      cqs wss cC cA cR cqs wss wa vx cv va cv wcel va cv cC wcel wa vx cv vb cv
      wcel vb cv cB wcel wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi
      cB cA cR cqs wss cC cA cR cqs wss vx cv va cv wcel va cv cC wcel wa vx cv
      vb cv wcel vb cv cB wcel wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc
      wex wi wi cB cA cR cqs wss vb cv cB wcel vb cv cA cR cqs wcel wi vb wal
      cC cA cR cqs wss vx cv va cv wcel va cv cC wcel wa vx cv vb cv wcel vb cv
      cB wcel wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi vb cB
      cA cR cqs dfss2 vb cv cB wcel vb cv cA cR cqs wcel wi cC cA cR cqs wss vx
      cv va cv wcel va cv cC wcel wa vx cv vb cv wcel vb cv cB wcel wa vx cv vc
      cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi vb cC cA cR cqs wss vb cv
      cB wcel vb cv cA cR cqs wcel wi vx cv va cv wcel va cv cC wcel wa vx cv
      vb cv wcel vb cv cB wcel wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc
      wex wi wi cC cA cR cqs wss va cv cC wcel va cv cA cR cqs wcel wi va wal
      vb cv cB wcel vb cv cA cR cqs wcel wi vx cv va cv wcel va cv cC wcel wa
      vx cv vb cv wcel vb cv cB wcel wa vx cv vc cv wcel vc cv cB cC cin wcel
      wa vc wex wi wi wi va cC cA cR cqs dfss2 va cv cC wcel va cv cA cR cqs
      wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi vx cv va cv wcel va cv cC
      wcel wa vx cv vb cv wcel vb cv cB wcel wa vx cv vc cv wcel vc cv cB cC
      cin wcel wa vc wex wi wi wi va vx cv va cv wcel va cv cC wcel wa vx cv vb
      cv wcel vb cv cB wcel wa va cv cC wcel va cv cA cR cqs wcel wi vb cv cB
      wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc
      wex vx cv va cv wcel va cv cC wcel vx cv vb cv wcel vb cv cB wcel wa va
      cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi
      vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi vx cv vb cv wcel
      vb cv cB wcel wa va cv cC wcel vx cv va cv wcel va cv cC wcel va cv cA cR
      cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv
      cB cC cin wcel wa vc wex wi wi vx cv vb cv wcel vb cv cB wcel va cv cC
      wcel vx cv va cv wcel va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel
      vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex
      wi wi wi wi vx cv vb cv wcel vb cv cB wcel va cv cC wcel vx cv va cv wcel
      va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel
      wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi wi wi vb cv
      cB wcel vx cv vb cv wcel vx cv vb cv wcel va cv cC wcel vx cv va cv wcel
      va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel
      wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi wi vx cv vb
      cv wcel vb cv cB wcel vx cv vb cv wcel va cv cC wcel vx cv va cv wcel va
      cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi
      vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi wi wi vb cv cB
      wcel vx cv vb cv wcel vb cv cB wcel vx cv vb cv wcel va cv cC wcel vx cv
      va cv wcel va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA
      cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi
      wi wi wi va cv cC wcel vb cv cB wcel vx cv vb cv wcel vb cv cB wcel vx cv
      vb cv wcel wa vx cv va cv wcel va cv cC wcel va cv cA cR cqs wcel wi vb
      cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin wcel
      wa vc wex wi wi wi vb cv cB wcel va cv cC wcel vx cv vb cv wcel vb cv cB
      wcel vx cv vb cv wcel wa vx cv va cv wcel va cv cC wcel va cv cA cR cqs
      wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB
      cC cin wcel wa vc wex wi wi wi wi wi va cv cC wcel vb cv cB wcel va cv cC
      wcel vx cv vb cv wcel vb cv cB wcel vx cv vb cv wcel wa vx cv va cv wcel
      va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel
      wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi wi wi wi va
      cv cC wcel vb cv cB wcel wa vx cv vb cv wcel va cv cC wcel vb cv cB wcel
      vx cv vb cv wcel wa vx cv va cv wcel va cv cC wcel va cv cA cR cqs wcel
      wi vb cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin
      wcel wa vc wex wi wi wi wi va cv cC wcel vb cv cB wcel wa vx cv vb cv
      wcel va cv cC wcel vb cv cB wcel vx cv vb cv wcel wa vx cv va cv wcel va
      cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi
      vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi wi wi va cv cC
      wcel vb cv cB wcel vx cv vb cv wcel wa va cv cC wcel vb cv cB wcel wa vx
      cv vb cv wcel wa vx cv va cv wcel va cv cC wcel va cv cA cR cqs wcel wi
      vb cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin
      wcel wa vc wex wi wi wi va cv cC wcel vb cv cB wcel vx cv vb cv wcel wa
      va cv cC wcel vb cv cB wcel wa vx cv vb cv wcel wa vx cv va cv wcel va cv
      cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi vx
      cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi wi wi va cv cC wcel vb
      cv cB wcel vx cv vb cv wcel wa wa vx cv va cv wcel va cv cC wcel vb cv cB
      wcel wa vx cv vb cv wcel wa va cv cC wcel va cv cA cR cqs wcel wi vb cv
      cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin wcel wa
      vc wex wi wi va cv cC wcel vb cv cB wcel vx cv vb cv wcel wa wa vx cv va
      cv wcel va cv cC wcel vb cv cB wcel wa vx cv vb cv wcel wa va cv cC wcel
      va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv
      wcel vc cv cB cC cin wcel wa vc wex wi wi wi va cv cC wcel vb cv cB wcel
      vx cv vb cv wcel wa wa vx cv va cv wcel wa va cv cC wcel va cv cA cR cqs
      wcel wi va cv cC wcel vb cv cB wcel wa vx cv vb cv wcel wa vb cv cB wcel
      vb cv cA cR cqs wcel wi vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex
      wi va cv cC wcel vb cv cB wcel vx cv vb cv wcel wa wa vx cv va cv wcel wa
      va cv cC wcel va cv cA cR cqs wcel wi va cv cC wcel vb cv cB wcel wa vx
      cv vb cv wcel wa vb cv cB wcel vb cv cA cR cqs wcel wi vx cv vc cv wcel
      vc cv cB cC cin wcel wa vc wex wi wi va cv cC wcel vb cv cB wcel vx cv vb
      cv wcel wa wa vx cv va cv wcel wa va cv cC wcel va cv cA cR cqs wcel wi
      wa vb cv cB wcel vb cv cA cR cqs wcel wi va cv vb cv wceq va cv cC wcel
      vb cv cB wcel wa vx cv vb cv wcel wa vx cv vc cv wcel vc cv cB cC cin
      wcel wa vc wex va cv cC wcel vb cv cB wcel vx cv vb cv wcel wa wa vx cv
      va cv wcel va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb cv cA
      cR cqs wcel wi va cv vb cv wceq wi va cv cC wcel vb cv cB wcel vx cv vb
      cv wcel wa wa vb cv cB wcel vb cv cA cR cqs wcel wi va cv cC wcel va cv
      cA cR cqs wcel wi vx cv va cv wcel va cv vb cv wceq va cv cC wcel vb cv
      cB wcel vx cv vb cv wcel wa vb cv cB wcel vb cv cA cR cqs wcel wi va cv
      cC wcel va cv cA cR cqs wcel wi vx cv va cv wcel va cv vb cv wceq wi wi
      wi va cv cC wcel va cv cC wcel va cv cA cR cqs wcel wi vb cv cB wcel vb
      cv cA cR cqs wcel wi vb cv cB wcel vx cv vb cv wcel wa vx cv va cv wcel
      va cv vb cv wceq wi va cv cC wcel va cv cC wcel va cv cA cR cqs wcel wi
      vb cv cB wcel vb cv cA cR cqs wcel wi vb cv cB wcel vx cv vb cv wcel wa
      vx cv va cv wcel va cv vb cv wceq wi wi wi va cv cC wcel va cv cC wcel va
      cv cA cR cqs wcel wi wa va cv cA cR cqs wcel vb cv cB wcel vb cv cA cR
      cqs wcel wi vb cv cB wcel vx cv vb cv wcel wa vx cv va cv wcel va cv vb
      cv wceq wi wi wi va cv cC wcel va cv cA cR cqs wcel pm3.35 vb cv cB wcel
      vx cv vb cv wcel wa vb cv cB wcel vb cv cA cR cqs wcel wi va cv cA cR cqs
      wcel vx cv va cv wcel va cv vb cv wceq wi vb cv cB wcel vx cv vb cv wcel
      vb cv cB wcel vb cv cA cR cqs wcel wi va cv cA cR cqs wcel vx cv va cv
      wcel va cv vb cv wceq wi wi wi vb cv cB wcel vb cv cB wcel vb cv cA cR
      cqs wcel wi vx cv vb cv wcel va cv cA cR cqs wcel vx cv va cv wcel va cv
      vb cv wceq wi wi vb cv cB wcel vb cv cB wcel vb cv cA cR cqs wcel wi vx
      cv vb cv wcel va cv cA cR cqs wcel vx cv va cv wcel va cv vb cv wceq wi
      wi wi vb cv cB wcel vb cv cB wcel vb cv cA cR cqs wcel wi wa vb cv cA cR
      cqs wcel vx cv vb cv wcel va cv cA cR cqs wcel vx cv va cv wcel va cv vb
      cv wceq wi wi wi vb cv cB wcel vb cv cA cR cqs wcel pm3.35 vb cv cA cR
      cqs wcel vb cv vu cv cR cec wceq vu cA wrex vx cv vb cv wcel va cv cA cR
      cqs wcel vx cv va cv wcel va cv vb cv wceq wi wi wi vu cA vb cv cR vb
      visset elqs vb cv vu cv cR cec wceq vx cv vb cv wcel va cv cA cR cqs wcel
      vx cv va cv wcel va cv vb cv wceq wi wi wi vu cA vb cv vu cv cR cec wceq
      vx cv vb cv wcel va cv cA cR cqs wcel vx cv va cv wcel va cv vb cv wceq
      wi wi wi wi vu cv cA wcel va cv cA cR cqs wcel vb cv vu cv cR cec wceq vx
      cv vb cv wcel vx cv va cv wcel va cv vb cv wceq wi va cv cA cR cqs wcel
      va cv vv cv cR cec wceq vv cA wrex vb cv vu cv cR cec wceq vx cv vb cv
      wcel vx cv va cv wcel va cv vb cv wceq wi wi wi vv cA va cv cR va visset
      elqs va cv vv cv cR cec wceq vb cv vu cv cR cec wceq vx cv vb cv wcel vx
      cv va cv wcel va cv vb cv wceq wi wi wi vv cA va cv vv cv cR cec wceq vb
      cv vu cv cR cec wceq vx cv vb cv wcel vx cv va cv wcel va cv vb cv wceq
      wi wi wi wi vv cv cA wcel va cv vv cv cR cec wceq vb cv vu cv cR cec wceq
      vx cv vb cv wcel vx cv va cv wcel va cv vb cv wceq wi wi va cv vv cv cR
      cec wceq vb cv vu cv cR cec wceq wa vx cv vb cv wcel vx cv va cv wcel va
      cv vb cv wceq wi wi va cv vv cv cR cec wceq vb cv vu cv cR cec wceq wa vx
      cv va cv wcel vx cv vb cv wcel va cv vv cv cR cec wceq vb cv vu cv cR cec
      wceq wa va cv vb cv wceq va cv vv cv cR cec wceq vb cv vu cv cR cec wceq
      wa vx cv va cv wcel vx cv vb cv wcel va cv vv cv cR cec wceq vb cv vu cv
      cR cec wceq wa va cv vb cv wceq wi va cv vv cv cR cec wceq vx cv va cv
      wcel vb cv vu cv cR cec wceq vx cv vb cv wcel va cv vv cv cR cec wceq vb
      cv vu cv cR cec wceq wa va cv vb cv wceq wi vx cv vv cv cR cec wcel vx cv
      vu cv cR cec wcel va cv vv cv cR cec wceq vb cv vu cv cR cec wceq wa va
      cv vb cv wceq wi va cv vv cv cR cec wceq vx cv va cv wcel wa vb cv vu cv
      cR cec wceq vx cv vb cv wcel wa vx cv vv cv cR cec wcel vx cv vu cv cR
      cec wcel wa vv cv cR cec vu cv cR cec cin c0 wne va cv vv cv cR cec wceq
      vb cv vu cv cR cec wceq wa va cv vb cv wceq wi vx cv vv cv cR cec vu cv
      cR cec inelcm vv cv cR cec vu cv cR cec cin c0 wne vv cv cR cec vu cv cR
      cec cin c0 wceq wn va cv vv cv cR cec wceq vb cv vu cv cR cec wceq wa va
      cv vb cv wceq wi vv cv cR cec vu cv cR cec cin c0 df-ne vv cv cR cec vu
      cv cR cec wceq vv cv cR cec vu cv cR cec cin c0 wceq wo vv cv cR cec vu
      cv cR cec cin c0 wceq wn va cv vv cv cR cec wceq vb cv vu cv cR cec wceq
      wa va cv vb cv wceq wi vv cv vu cv cR vv visset vu visset uninqs.1 erdisj
      vv cv cR cec vu cv cR cec wceq vv cv cR cec vu cv cR cec cin c0 wceq wo
      vv cv cR cec vu cv cR cec cin c0 wceq wn wa vv cv cR cec vu cv cR cec
      wceq vv cv cR cec vu cv cR cec cin c0 wceq wn wa va cv vv cv cR cec wceq
      vb cv vu cv cR cec wceq wa va cv vb cv wceq wi vv cv cR cec vu cv cR cec
      wceq vv cv cR cec vu cv cR cec cin c0 wceq pm5.61 vv cv cR cec vu cv cR
      cec wceq va cv vv cv cR cec wceq vb cv vu cv cR cec wceq wa va cv vb cv
      wceq wi vv cv cR cec vu cv cR cec cin c0 wceq wn va cv vv cv cR cec wceq
      vb cv vu cv cR cec wceq wa va cv vb cv wceq vv cv cR cec vu cv cR cec
      wceq va cv vv cv cR cec vb cv vu cv cR cec eqeq12 biimprcd adantr sylbi
      mpan sylbi syl va cv vv cv cR cec wceq vx cv va cv wcel vx cv vv cv cR
      cec wcel va cv vv cv cR cec vx cv eleq2 biimpa vb cv vu cv cR cec wceq vx
      cv vb cv wcel vx cv vu cv cR cec wcel vb cv vu cv cR cec vx cv eleq2
      biimpa syl2an an4s exp32 com24 pm2.43i ex a1i r19.23aiv sylbi com3l a1i
      r19.23aiv sylbi syl ex com23 imp com13 syl ex com24 imp com24 imp31 va cv
      cC wcel vb cv cB wcel wa vx cv vb cv wcel va cv vb cv wceq vx cv vc cv
      wcel vc cv cB cC cin wcel wa vc wex wi va cv cC wcel vb cv cB wcel wa va
      cv vb cv wceq vx cv vb cv wcel vx cv vc cv wcel vc cv cB cC cin wcel wa
      vc wex va cv cC wcel vb cv cB wcel va cv vb cv wceq vx cv vb cv wcel vx
      cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi wi va cv vb cv wceq va cv
      cC wcel vb cv cB wcel vx cv vb cv wcel vx cv vc cv wcel vc cv cB cC cin
      wcel wa vc wex wi va cv vb cv wceq va cv cC wcel vb cv cC wcel vb cv cB
      wcel vx cv vb cv wcel vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi
      wi va cv vb cv cC eleq1 vb cv cC wcel vb cv cB wcel vx cv vb cv wcel vx
      cv vc cv wcel vc cv cB cC cin wcel wa vc wex wi vb cv cC wcel vb cv cB
      wcel wa vb cv cC cB cin wcel vx cv vb cv wcel vx cv vc cv wcel vc cv cB
      cC cin wcel wa vc wex wi vb cv cC cB elin vx cv vb cv wcel vb cv cC cB
      cin wcel vx cv vc cv wcel vc cv cB cC cin wcel wa vc wex vx cv vb cv wcel
      vb cv cC cB cin wcel wa vx cv vc cv wcel vc cv cB cC cin wcel wa vc vb vc
      cv vb cv wceq vx cv vb cv wcel vx cv vc cv wcel vb cv cC cB cin wcel vc
      cv cB cC cin wcel vc cv vb cv wceq vx cv vc cv wcel vx cv vb cv wcel vc
      vb vx elequ2 biimprd vc cv vb cv wceq vb cv cC cB cin wcel vc cv cB cC
      cin wcel vb cv cC cB cin wcel vc cv cB cC cin wcel wb vb vc vb cv vc cv
      wceq vb cv cC cB cin wcel vc cv cC cB cin wcel vc cv cB cC cin wcel vb cv
      vc cv cC cB cin eleq1 cC cB cin cB cC cin vc cv cC cB incom eleq2i syl6bb
      equcoms biimpd anim12d a4imev expcom sylbir ex syl6bi com3l imp com23 imp
      syl9 ex com23 ex com23 ex com3r ex com23 ex pm2.43a com14 ex pm2.43a
      com13 pm2.43i imp com13 imp com4t a4s sylbi com12 a4s sylbi imp com12
      19.23aiv com13 19.23aiv com12 va vx cv cC eluni syl7ib vb vx cv cB eluni
      syl5ib imp3a vx cv cB cuni cC cuni elin vc vx cv cB cC cin eluni 3imtr4g
      ssrdv cB cC uniin jctil cB cC cin cuni cB cuni cC cuni cin eqss sylibr $.
      $( [4-Jun-2007] $) $( [25-May-2007] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    erdisj2.1 $e |- A e. _V $.
    erdisj2.2 $e |- B e. _V $.
    $( Equivalence classes do not overlap. $)
    erdisj2 $p |- ( Er R -> ( [ A ] R = [ B ] R \/
      ( [ A ] R i^i [ B ] R ) = (/) ) ) $=
      cR wer cA cR cec cB cR cec wceq cA cR cec cB cR cec cin c0 wceq wo cA cR
      wer cR cid cif cec cB cR wer cR cid cif cec wceq cA cR wer cR cid cif cec
      cB cR wer cR cid cif cec cin c0 wceq wo cR cid cR cR wer cR cid cif wceq
      cA cR cec cB cR cec wceq cA cR wer cR cid cif cec cB cR wer cR cid cif
      cec wceq cA cR cec cB cR cec cin c0 wceq cA cR wer cR cid cif cec cB cR
      wer cR cid cif cec cin c0 wceq cR cR wer cR cid cif wceq cA cR cec cA cR
      wer cR cid cif cec cB cR cec cB cR wer cR cid cif cec cR cR wer cR cid
      cif cA eceq1 cR cR wer cR cid cif cB eceq1 eqeq12d cR cR wer cR cid cif
      wceq cA cR cec cB cR cec cin cA cR wer cR cid cif cec cB cR wer cR cid
      cif cec cin c0 cR cR wer cR cid cif wceq cA cR cec cA cR wer cR cid cif
      cec cB cR cec cB cR wer cR cid cif cec cR cR wer cR cid cif cA eceq1 cR
      cR wer cR cid cif cB eceq1 ineq12d eqeq1d orbi12d cA cB cR wer cR cid cif
      erdisj2.1 erdisj2.2 cR wer cR wer cR cid cif wer cid wer cR cid cR cR wer
      cR cid cif ereq cid cR wer cR cid cif ereq ider elimhyp erdisj dedth $.
      $( [4-Jun-2007] $) $( [1-Jun-2007] $)
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Inference from membership to difference. $)
    difeqri2 $p |- ( A. x ( ( x e. A /\ -. x e. B ) <-> x e. C )
      -> ( A \ B ) = C ) $=
      vx cv cA wcel vx cv cB wcel wn wa vx cv cC wcel wb vx wal cC vx cv cA
      wcel vx cv cB wcel wn wa vx cab cA cB cdif vx cv cA wcel vx cv cB wcel wn
      wa vx cv cC wcel wb vx wal vx cv cC wcel vx cv cA wcel vx cv cB wcel wn
      wa wb vx wal cC vx cv cA wcel vx cv cB wcel wn wa vx cab wceq vx cv cA
      wcel vx cv cB wcel wn wa vx cv cC wcel wb vx wal vx cv cC wcel vx cv cA
      wcel vx cv cB wcel wn wa wb vx wal vx cv cA wcel vx cv cB wcel wn wa vx
      cv cC wcel wb vx cv cC wcel vx cv cA wcel vx cv cB wcel wn wa wb vx vx cv
      cA wcel vx cv cB wcel wn wa vx cv cC wcel bicom albii biimpi vx cv cA
      wcel vx cv cB wcel wn wa vx cC abeq2 sylibr vx cA cB df-dif syl6reqr $.
      $( [18-Jun-2007] $) $( [6-Jun-2007] $)
  $}

  ${ $d A u v w y z $.  $d B u v w y z $.  $d C u v w y z $.  $d D u v w y z $.
     $d ph u x $.  $d ta u v w y z $.  $d v w x y z $.
    elo.1 $e |-   ( y = A -> ( ph <-> ps ) ) $.
    elo.2 $e |-   ( z = B -> ( ps <-> ch ) ) $.
    elo.3 $e |-   ( v = C -> ( ch <-> th ) ) $.
    elo.4 $e |-   ( w = D -> ( th <-> ta ) ) $.
    $( The law of concretion for operation class abstraction.  Compare with
       ~ eloprabg . This version is to be used with categories. $)
    elo $p |- ( ( ( A e. Q /\ B e. R /\ C e. S ) /\ D e. T ) ->
      ( <. <. A , B >. , <. C , D >. >. e. { x  | E. y E. z E. v E. w
      ( x = <. <. y , z >. , <. v , w >. >. /\ ph ) } <-> ta ) ) $=
      cA cvv wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel cA cB cop cC cD cop
      cop vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex
      vz wex vy wex vx cab wcel wta wb cA cQ wcel cB cR wcel cC cS wcel w3a cD
      cT wcel cA cvv wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa cA cB cop
      cC cD cop cop vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw
      wex vv wex vz wex vy wex vx cab wcel wta wb wi vu cA cB cop cC cD cop cop
      cA cB cop cC cD cop opex cA cvv wcel cB cvv wcel cC cvv wcel w3a cD cvv
      wcel wa vu cv cA cB cop cC cD cop cop wceq cA cB cop cC cD cop cop vx cv
      vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy
      wex vx cab wcel wta wb cA cvv wcel cB cvv wcel cC cvv wcel w3a cD cvv
      wcel wa vu cv cA cB cop cC cD cop cop wceq wa vu cv vy cv vz cv cop vv cv
      vw cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vy cv cA wceq vz cv
      cB wceq vv cv cC wceq w3a vw cv cD wceq wa wta wa vw wex vv wex vz wex vy
      wex cA cB cop cC cD cop cop vx cv vy cv vz cv cop vv cv vw cv cop cop
      wceq wph wa vw wex vv wex vz wex vy wex vx cab wcel wta cA cvv wcel cB
      cvv wcel cC cvv wcel w3a cD cvv wcel wa vu cv cA cB cop cC cD cop cop
      wceq wa vu cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vy cv cA
      wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wta wa vy vz vv vw
      cA cvv wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa vu cv cA cB cop cC
      cD cop cop wceq wa vu cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa
      vy cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wph wa vy
      cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wta wa cA cvv
      wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa vu cv cA cB cop cC cD cop
      cop wceq wa vu cv vy cv vz cv cop vv cv vw cv cop cop wceq vy cv cA wceq
      vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wph vu cv cA cB cop cC
      cD cop cop wceq vu cv vy cv vz cv cop vv cv vw cv cop cop wceq vy cv vz
      cv cop vv cv vw cv cop cop cA cB cop cC cD cop cop wceq cA cvv wcel cB
      cvv wcel cC cvv wcel w3a cD cvv wcel wa vy cv cA wceq vz cv cB wceq vv cv
      cC wceq w3a vw cv cD wceq wa vu cv cA cB cop cC cD cop cop wceq vu cv vy
      cv vz cv cop vv cv vw cv cop cop wceq cA cB cop cC cD cop cop vy cv vz cv
      cop vv cv vw cv cop cop wceq vy cv vz cv cop vv cv vw cv cop cop cA cB
      cop cC cD cop cop wceq vu cv cA cB cop cC cD cop cop vy cv vz cv cop vv
      cv vw cv cop cop eqeq1 cA cB cop cC cD cop cop vy cv vz cv cop vv cv vw
      cv cop cop eqcom syl6bb cB cvv wcel cC cD cop cvv cvv cxp wcel cD cvv
      wcel vy cv vz cv cop vv cv vw cv cop cop cA cB cop cC cD cop cop wceq vy
      cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wb cA cvv
      wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa cB cvv wcel cC cD cop cvv
      cvv cxp wcel cD cvv wcel w3a vy cv vz cv cop vv cv vw cv cop cop cA cB
      cop cC cD cop cop wceq vy cv cA wceq vz cv cB wceq vv cv vw cv cop cC cD
      cop wceq w3a vy cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq
      wa cB cvv wcel cC cD cop cvv cvv cxp wcel vy cv vz cv cop vv cv vw cv cop
      cop cA cB cop cC cD cop cop wceq vy cv cA wceq vz cv cB wceq vv cv vw cv
      cop cC cD cop wceq w3a wb cD cvv wcel vy cv vz cv cA cB vv cv vw cv cop
      cC cD cop cvv cvv cvv cxp vy visset vz visset vv cv vw cv opex otthg
      3adant3 cD cvv wcel cB cvv wcel vy cv cA wceq vz cv cB wceq vv cv vw cv
      cop cC cD cop wceq w3a vy cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw
      cv cD wceq wa wb cC cD cop cvv cvv cxp wcel cD cvv wcel vy cv cA wceq vz
      cv cB wceq vv cv vw cv cop cC cD cop wceq w3a vy cv cA wceq vz cv cB wceq
      vv cv cC wceq vw cv cD wceq wa w3a vy cv cA wceq vz cv cB wceq vv cv cC
      wceq w3a vw cv cD wceq wa cD cvv wcel vv cv vw cv cop cC cD cop wceq vv
      cv cC wceq vw cv cD wceq wa vy cv cA wceq vz cv cB wceq vv cv vw cv cC cD
      cvv vv visset vw visset opthg 3anbi3d vy cv cA wceq vz cv cB wceq vv cv
      cC wceq vw cv cD wceq and4as syl6bb 3ad2ant3 bitrd cA cvv wcel cB cvv
      wcel cC cvv wcel w3a cB cvv wcel cD cvv wcel cA cvv wcel cB cvv wcel cC
      cvv wcel 3simp2 adantr cC cvv wcel cA cvv wcel cD cvv wcel cC cD cop cvv
      cvv cxp wcel cB cvv wcel cC cD cvv cvv opelxpi 3ad2antl3 cA cvv wcel cB
      cvv wcel cC cvv wcel w3a cD cvv wcel pm3.27 syl3anc sylan9bbr anbi1d vy
      cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wph wta vy cv
      cA wceq vz cv cB wceq vv cv cC wceq w3a wph wth vw cv cD wceq wta vy cv
      cA wceq wph wps vz cv cB wceq wch vv cv cC wceq wth elo.1 elo.2 elo.3
      syl3an9b elo.4 sylan9bb pm5.32i syl6bb 4exbidv vu cv cA cB cop cC cD cop
      cop wceq vu cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv
      wex vz wex vy wex cA cB cop cC cD cop cop vx cv vy cv vz cv cop vv cv vw
      cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vx cab wcel wb cA cvv
      wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa vu cv cA cB cop cC cD cop
      cop wceq vu cv vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw
      wex vv wex vz wex vy wex vx cab wcel cA cB cop cC cD cop cop vx cv vy cv
      vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vx
      cab wcel vu cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv
      wex vz wex vy wex vu cv cA cB cop cC cD cop cop vx cv vy cv vz cv cop vv
      cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vx cab eleq1 vx
      cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex
      vy wex vu cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv
      wex vz wex vy wex vx vu cv vu visset vx cv vu cv wceq vx cv vy cv vz cv
      cop vv cv vw cv cop cop wceq wph wa vu cv vy cv vz cv cop vv cv vw cv cop
      cop wceq wph wa vy vz vv vw vx cv vu cv wceq vx cv vy cv vz cv cop vv cv
      vw cv cop cop wceq vu cv vy cv vz cv cop vv cv vw cv cop cop wceq wph vx
      cv vu cv vy cv vz cv cop vv cv vw cv cop cop eqeq1 anbi1d 4exbidv elab
      syl5bbr adantl cA cvv wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa vy
      cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wta wa vw wex
      vv wex vz wex vy wex wta wb vu cv cA cB cop cC cD cop cop wceq cA cvv
      wcel cB cvv wcel cC cvv wcel w3a cD cvv wcel wa wta vy cv cA wceq vz cv
      cB wceq vv cv cC wceq w3a vw cv cD wceq wa vw wex vv wex vz wex vy wex
      wta wa vy cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq wa wta
      wa vw wex vv wex vz wex vy wex cA cvv wcel cB cvv wcel cC cvv wcel w3a cD
      cvv wcel wa vy cv cA wceq vz cv cB wceq vv cv cC wceq w3a vw cv cD wceq
      wa vw wex vv wex vz wex vy wex wta cA cvv wcel cB cvv wcel cC cvv wcel
      w3a cD cvv wcel wa vy cv cA wceq vy wex vz cv cB wceq vz wex vv cv cC
      wceq vv wex w3a vw cv cD wceq vw wex wa vy cv cA wceq vz cv cB wceq vv cv
      cC wceq w3a vw cv cD wceq wa vw wex vv wex vz wex vy wex cA cvv wcel cB
      cvv wcel cC cvv wcel w3a vy cv cA wceq vy wex vz cv cB wceq vz wex vv cv
      cC wceq vv wex w3a cD cvv wcel vw cv cD wceq vw wex cA cvv wcel vy cv cA
      wceq vy wex cB cvv wcel vz cv cB wceq vz wex cC cvv wcel vv cv cC wceq vv
      wex vy cA cvv elex vz cB cvv elex vv cC cvv elex 3anim123i vw cD cvv elex
      anim12i vy cv cA wceq vz cv cB wceq vv cv cC wceq vw cv cD wceq vz vv vw
      vy eeeeanv sylibr biantrurd vy cv cA wceq vz cv cB wceq vv cv cC wceq w3a
      vw cv cD wceq wa wta vz vv vw vy 19.41vvvv syl6rbbr adantr 3bitr3d expcom
      vtocle cA cQ wcel cA cvv wcel cB cR wcel cB cvv wcel cC cS wcel cC cvv
      wcel cA cQ elisset cB cR elisset cC cS elisset 3anim123i cD cT elisset
      syl2an $.
      $( [14-Jul-2007] $) $( [14-Jul-2007] $)
  $}

  ${
    $d a b x y A $.  $d a b x y B $.  $d a b x y C $.
    $( The intersection of two finite intersections is finite. $)
    infi1 $p |- ( ( A e. { x | E. y ( y C_ C /\ y e. Fin /\ x = |^| y ) }
                    /\ B e. { x | E. y ( y C_ C /\ y e. Fin /\ x = |^| y ) } )
        -> ( A i^i B ) e. { x | E. y ( y C_ C /\ y e. Fin /\ x = |^| y ) } ) $=
      cA vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab wcel wa cA cB cin vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx cab wcel cA vy cv cC wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel wa cA vy cv cC wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vx cab wcel wa cA cB cin cvv wcel cA cB cin
      vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel
      cA vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wcel cA cB cin cvv wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel cA cB vy cv cC wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab inex1g adantr cA vy cv cC wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wa cA vy cv cC wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cC wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wa cA cB cin
      cvv wcel cA cB cin vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab wcel wi cA vy cv cC wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel cA vy cv cC wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wcel cA cB cin cvv wcel cA cB cin vy cv
      cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wi cA
      vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel
      cA vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vx cab wcel wa cA cB cin cvv wcel cA cB cin vy cv cC wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wcel wi cA vy cv cC wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cA vy cv cC wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cC wss vy cv
      cfn wcel cA vy cv cint wceq w3a vy wex cB vy cv cC wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wcel wa cA cB cin cvv wcel cA cB
      cin vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wcel wi wi vx vy cA vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab cC spfi cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel wa vy cv cC wss vy cv cfn wcel cA vy cv
      cint wceq w3a vy wex cA cB cin cvv wcel cA cB cin vy cv cC wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wi cB vy cv cC wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cC wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cC wss
      vy cv cfn wcel cA vy cv cint wceq w3a vy wex cA cB cin cvv wcel cA cB cin
      vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel
      wi wi cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab wcel cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vx cab wcel vy cv cC wss vy cv cfn wcel cB vy cv cint wceq w3a vy wex vy
      cv cC wss vy cv cfn wcel cA vy cv cint wceq w3a vy wex cA cB cin cvv wcel
      cA cB cin vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab wcel wi wi vx vy cB vy cv cC wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx cab cC spfi vy cv cC wss vy cv cfn wcel cB vy cv cint wceq
      w3a vy wex vy cv cC wss vy cv cfn wcel cA vy cv cint wceq w3a vy wex cA
      cB cin cvv wcel cA cB cin vy cv cC wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel vy cv cC wss vy cv cfn wcel cB vy cv cint
      wceq w3a vy wex vy cv cC wss vy cv cfn wcel cA vy cv cint wceq w3a vy wex
      cA cB cin cvv wcel w3a vy cv cC wss vy cv cfn wcel cA cB cin vy cv cint
      wceq w3a vy wex cA cB cin vy cv cC wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel vy cv cC wss vy cv cfn wcel cB vy cv cint
      wceq w3a vy wex vy cv cC wss vy cv cfn wcel cA vy cv cint wceq w3a vy wex
      vy cv cC wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex cA cB
      cin cvv wcel va cv cC wss va cv cfn wcel cB va cv cint wceq w3a va wex vb
      cv cC wss vb cv cfn wcel cA vb cv cint wceq w3a vb wex vy cv cC wss vy cv
      cfn wcel cA cB cin vy cv cint wceq w3a vy wex vy cv cC wss vy cv cfn wcel
      cB vy cv cint wceq w3a vy wex vy cv cC wss vy cv cfn wcel cA vy cv cint
      wceq w3a vy wex va cv cC wss va cv cfn wcel cB va cv cint wceq w3a va wex
      vb cv cC wss vb cv cfn wcel cA vb cv cint wceq w3a vb wex vy cv cC wss vy
      cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex va cv cC wss va cv cfn
      wcel cB va cv cint wceq w3a vb cv cC wss vb cv cfn wcel cA vb cv cint
      wceq w3a vb wex vy cv cC wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a
      vy wex wi va vb cv cC wss vb cv cfn wcel cA vb cv cint wceq w3a vb wex va
      cv cC wss va cv cfn wcel cB va cv cint wceq w3a vy cv cC wss vy cv cfn
      wcel cA cB cin vy cv cint wceq w3a vy wex vb cv cC wss vb cv cfn wcel cA
      vb cv cint wceq w3a va cv cC wss va cv cfn wcel cB va cv cint wceq w3a vy
      cv cC wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex wi vb va cv
      cC wss va cv cfn wcel cB va cv cint wceq w3a vb cv cC wss vb cv cfn wcel
      cA vb cv cint wceq w3a vy cv cC wss vy cv cfn wcel cA cB cin vy cv cint
      wceq w3a vy wex va cv vb cv cun cvv wcel va cv vb cv cun cC wss va cv vb
      cv cun cfn wcel cA cB cin va cv vb cv cun cint wceq w3a vy cv cC wss vy
      cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex va cv cC wss va cv cfn
      wcel cB va cv cint wceq w3a vb cv cC wss vb cv cfn wcel cA vb cv cint
      wceq w3a wa vy cv cC wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a va
      cv vb cv cun cC wss va cv vb cv cun cfn wcel cA cB cin va cv vb cv cun
      cint wceq w3a vy va cv vb cv cun cvv vy cv va cv vb cv cun wceq vy cv cC
      wss va cv vb cv cun cC wss vy cv cfn wcel va cv vb cv cun cfn wcel cA cB
      cin vy cv cint wceq cA cB cin va cv vb cv cun cint wceq vy cv va cv vb cv
      cun cC sseq1 vy cv va cv vb cv cun cfn eleq1 vy cv va cv vb cv cun wceq
      vy cv cint va cv vb cv cun cint cA cB cin vy cv va cv vb cv cun inteq
      eqeq2d 3anbi123d cla4egv va cv vb cv cun cvv wcel va cv cC wss va cv cfn
      wcel cB va cv cint wceq w3a vb cv cC wss vb cv cfn wcel cA vb cv cint
      wceq w3a wa va cv vb cv va visset vb visset unex a1i va cv cC wss va cv
      cfn wcel cB va cv cint wceq w3a vb cv cC wss vb cv cfn wcel cA vb cv cint
      wceq w3a wa va cv cC wss vb cv cC wss wa va cv cfn wcel vb cv cfn wcel wa
      cB va cv cint wceq cA vb cv cint wceq wa w3a va cv vb cv cun cC wss va cv
      vb cv cun cfn wcel cA cB cin va cv vb cv cun cint wceq w3a va cv cC wss
      va cv cfn wcel cB va cv cint wceq vb cv cC wss vb cv cfn wcel cA vb cv
      cint wceq an6 va cv cC wss vb cv cC wss wa va cv vb cv cun cC wss va cv
      cfn wcel vb cv cfn wcel wa va cv vb cv cun cfn wcel cB va cv cint wceq cA
      vb cv cint wceq wa cA cB cin va cv vb cv cun cint wceq va cv cC wss vb cv
      cC wss wa va cv vb cv cun cC wss va cv vb cv cC unss biimpi va cv vb cv
      unfi cB va cv cint wceq cA vb cv cint wceq wa cA cB cin cA va cv cint cin
      vb cv cint va cv cint cin va cv vb cv cun cint cB va cv cint wceq cA cB
      cin cA va cv cint cin wceq cA vb cv cint wceq cB va cv cint cA ineq2
      adantr cA vb cv cint wceq cA va cv cint cin vb cv cint va cv cint cin
      wceq cB va cv cint wceq cA vb cv cint va cv cint ineq1 adantl vb cv cint
      va cv cint cin va cv vb cv cun cint wceq cB va cv cint wceq cA vb cv cint
      wceq wa vb cv cint va cv cint cin va cv cint vb cv cint cin va cv vb cv
      cun cint vb cv cint va cv cint incom va cv vb cv intun eqtr4i a1i 3eqtrd
      3anim123i sylbi sylc expcom 19.23aiv com12 19.23aiv imp vy cv cC wss vy
      cv cfn wcel cB vy cv cint wceq w3a va cv cC wss va cv cfn wcel cB va cv
      cint wceq w3a vy va vy cv va cv wceq vy cv cC wss va cv cC wss vy cv cfn
      wcel va cv cfn wcel cB vy cv cint wceq cB va cv cint wceq vy cv va cv cC
      sseq1 vy cv va cv cfn eleq1 vy cv va cv wceq vy cv cint va cv cint cB vy
      cv va cv inteq eqeq2d 3anbi123d cbvexv vy cv cC wss vy cv cfn wcel cA vy
      cv cint wceq w3a vb cv cC wss vb cv cfn wcel cA vb cv cint wceq w3a vy vb
      vy cv vb cv wceq vy cv cC wss vb cv cC wss vy cv cfn wcel vb cv cfn wcel
      cA vy cv cint wceq cA vb cv cint wceq vy cv vb cv cC sseq1 vy cv vb cv
      cfn eleq1 vy cv vb cv wceq vy cv cint vb cv cint cA vy cv vb cv inteq
      eqeq2d 3anbi123d cbvexv syl2anb 3adant3 cA cB cin cvv wcel vy cv cC wss
      vy cv cfn wcel cB vy cv cint wceq w3a vy wex vy cv cC wss vy cv cfn wcel
      cA cB cin vy cv cint wceq w3a vy wex cA cB cin vy cv cC wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wb vy cv cC wss vy cv
      cfn wcel cA vy cv cint wceq w3a vy wex cA cB cin cvv wcel cA cB cin vy cv
      cC wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv
      cC wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex vx vy cA cB
      cin cvv cC spfi bicomd 3ad2ant3 mpbid 3exp syl6bi imp com12 syl6bi imp31
      an4s ex mpid pm2.43i $.
      $( [2-Sep-2008] $) $( [31-Oct-2007] $)
  $}

  ${
    $d A x y $.  $d B x y $.
    $( If ` A ` is the intersection of a finite set of elements of ` B ` then
       ` A C_ U. B ` . $)
    fiiu $p |- ( A e. { x | E. y ( y C_ B /\ y e. Fin /\ x = |^| y ) }
           -> A C_ U. B ) $=
      cA vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wcel cA cB cuni wss cA vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx cab wcel cA vy cv cB wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel cA cvv wceq wn cA cB cuni wss cA vy cv cB wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cA cvv wceq
      cvv vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      wcel vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab
      nvel cA cvv wceq cA vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab wcel cvv vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx cab wcel cA cvv vy cv cB wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab eleq1 biimpcd mtoi cA vy cv cB wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cA vy cv cB wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cB wss vy cv
      cfn wcel cA vy cv cint wceq w3a vy wex cA cvv wceq wn cA cB cuni wss wi
      vx vy cA vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx
      cab cB spfi vy cv cB wss vy cv cfn wcel cA vy cv cint wceq w3a cA cvv
      wceq wn cA cB cuni wss wi vy vy cv cB wss vy cv cfn wcel cA vy cv cint
      wceq cA cvv wceq wn cA cB cuni wss wi cA vy cv cint wceq cA cvv wceq wn
      vy cv cB wss vy cv cfn wcel cA cB cuni wss cA vy cv cint wceq cA cvv wceq
      wn vy cv cB wss vy cv cfn wcel cA cB cuni wss wi wi wi cA cvv wceq wn cA
      vy cv cint wceq cA vy cv cint wceq vy cv cB wss vy cv cfn wcel cA cB cuni
      wss wi wi cA vy cv cint wceq cA cvv wceq wn vy cv cint cvv wceq wn cA vy
      cv cint wceq vy cv cB wss vy cv cfn wcel cA cB cuni wss wi wi wi cA vy cv
      cint wceq cA cvv wceq wn vy cv cint cvv wceq wn cA vy cv cint wceq cA cvv
      wceq vy cv cint cvv wceq cA vy cv cint cvv eqeq1 notbid biimpd c0 cint
      cvv wceq vy cv cint cvv wceq wn cA vy cv cint wceq vy cv cB wss vy cv cfn
      wcel cA cB cuni wss wi wi wi wi int0 c0 cint cvv wceq vy cv cint cvv wceq
      wn vy cv cint c0 cint wceq wn cA vy cv cint wceq vy cv cB wss vy cv cfn
      wcel cA cB cuni wss wi wi wi c0 cint cvv wceq vy cv cint cvv wceq vy cv
      cint c0 cint wceq c0 cint cvv wceq vy cv cint c0 cint wceq vy cv cint cvv
      wceq c0 cint cvv vy cv cint eqeq2 bicomd notbid vy cv cint c0 cint wceq
      wn vy cv c0 wceq wn cA vy cv cint wceq vy cv cB wss vy cv cfn wcel cA cB
      cuni wss wi wi wi vy cv c0 wceq vy cv cint c0 cint wceq vy cv c0 inteq
      con3i vy cv c0 wceq wn vy cv cfn wcel vy cv cB wss cA vy cv cint wceq cA
      cB cuni wss vy cv c0 wceq wn vy cv cfn wcel vy cv cB wss cA vy cv cint
      wceq cA cB cuni wss wi cA vy cv cint wceq vy cv cint cB cuni wss cA cB
      cuni wss vy cv c0 wceq wn vy cv cfn wcel vy cv cB wss w3a vy cv cint cB
      cuni wss cA cB cuni wss wi vy cv cint cA vy cv cint cA wceq vy cv cint cB
      cuni wss cA cB cuni wss vy cv cint cA cB cuni sseq1 biimpd eqcoms vy cv
      c0 wceq wn vy cv cB wss vy cv cint cB cuni wss vy cv cfn wcel vy cv cB
      wss vy cv c0 wceq wn vy cv cint cB cuni wss vy cv cB wss vy cv c0 wne vy
      cv cint cB cuni wss vy cv c0 wceq wn vy cv cB intssuni2 vy cv c0 df-ne
      sylan2br ancoms 3adant2 syl5com 3exp com24 syl syl6bi ax-mp syl6com com13
      pm2.43i com4t 3imp 19.23aiv syl6bi mpid pm2.43i $.
      $( [2-Sep-2008] $) $( [30-Nov-2007] $)
  $}


  $( An intersection with a member of a powerset belongs to this powerset. $)
  inpws1 $p |- ( A e. ~P C -> ( A i^i B ) e. ~P C ) $=
    cA cB cin cvv wcel cA cC cpw wcel cA cB cin cC cpw wcel cA cB cC cpw inex1g
    cA cB cin cvv wcel cA cB cin cC cpw wcel cA cB cin cC wss cA cC cpw wcel cA
    cB cin cC cvv elpwg cA cC cpw wcel cA cC wss cA cB cin cC wss cA cC elpwi
    cA cB cC ssinss1 syl syl5bir mpcom $.
    $( [28-Oct-2007] $) $( [25-Sep-2007] $)

  $( An intersection with a member of a powerset belongs to this powerset. $)
  inpws2 $p |- ( B e. ~P C -> ( A i^i B ) e. ~P C ) $=
    cB cC cpw wcel cB cA cin cC cpw cA cB cin cB cA cC inpws1 cA cB incom
    syl5eqel $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)

  ${
    $d v x $.  $d w x $.
    $d x y $.  $d x z $.
  $( Structure of the class abstraction used by ` Alg ` , ` Cat ` and
     ` Ded ` . $)
  stcat $p |- { x | E. y E. z E. v E. w ( x = <. <. y , z >. , <. v , w >. >.
       /\ ph ) } C_ ( ( _V X. _V ) X. ( _V X. _V ) ) $=
    vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex
    vy wex vx cvv cvv cxp cvv cvv cxp cxp vx cv vy cv vz cv cop vv cv vw cv cop
    cop wceq wph wa vw wex vv wex vx cv cvv cvv cxp cvv cvv cxp cxp wcel vy vz
    vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vx cv cvv cvv cxp cvv
    cvv cxp cxp wcel vv vw vx cv vy cv vz cv cop vv cv vw cv cop cop wceq vx cv
    cvv cvv cxp cvv cvv cxp cxp wcel wph vx cv vy cv vz cv cop vv cv vw cv cop
    cop wceq vx cv cvv cvv cxp cvv cvv cxp cxp wcel vy cv vz cv cop vv cv vw cv
    cop cop cvv cvv cxp cvv cvv cxp cxp wcel vy cv vz cv cop vv cv vw cv cop
    cop cvv cvv cxp cvv cvv cxp cxp wcel vy cv vz cv cop cvv cvv cxp wcel vv cv
    vw cv cop cvv cvv cxp wcel vy cv vz cv cop vv cv vw cv cop cvv cvv cxp cvv
    cvv cxp vv cv vw cv opex opelxp vy cv vz cv cop cvv cvv cxp wcel vy cv cvv
    wcel vz cv cvv wcel vy cv vz cv cvv cvv vz visset opelxp vy visset vz
    visset mpbir2an vv cv vw cv cop cvv cvv cxp wcel vv cv cvv wcel vw cv cvv
    wcel vv cv vw cv cvv cvv vw visset opelxp vv visset vw visset mpbir2an
    mpbir2an vx cv vy cv vz cv cop vv cv vw cv cop cop cvv cvv cxp cvv cvv cxp
    cxp eleq1 mpbiri adantr 19.23aivv 19.23aivv abssi $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)
  $}

  $( A theorem of the ~ 1st2nd family. $)
  11st22nd $p |- ( ( ( Rel B /\ Rel dom B /\ Rel ran B ) /\ A e. B ) ->
     A = <. <. ( 1st ` ( 1st ` A ) ) , ( 2nd ` ( 1st ` A ) ) >. ,
            <. ( 1st ` ( 2nd ` A ) ) , ( 2nd ` ( 2nd ` A ) ) >. >. ) $=
    cB wrel cB cdm wrel cB crn wrel w3a cA cB wcel wa cA cA c1st cfv cA c2nd
    cfv cop cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv c1st cfv
    cA c2nd cfv c2nd cfv cop cop cB wrel cB cdm wrel cA cB wcel cA cA c1st cfv
    cA c2nd cfv cop wceq cB crn wrel cA cB 1st2nd 3ad2antl1 cB wrel cB cdm wrel
    cB crn wrel w3a cA cB wcel wa cA c1st cfv cA c1st cfv c1st cfv cA c1st cfv
    c2nd cfv cop cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop cB
    wrel cB cdm wrel cB crn wrel cA cB wcel cA c1st cfv cA c1st cfv c1st cfv cA
    c1st cfv c2nd cfv cop wceq cB crn wrel cB cdm wrel cB wrel cA cB wcel cA
    c1st cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq wi cB cdm wrel
    cB wrel cA cB wcel cA c1st cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv
    cop wceq wi wi wi cB crn wrel cB cdm wrel cB wrel cA cB wcel cA c1st cfv cA
    c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq cB cdm wrel cA c1st cfv cB
    cdm wcel cA c1st cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq cB
    wrel cA cB wcel wa cA c1st cfv cB cdm 1st2nd cA cB 1stdm sylan2 exp32 a1i
    com13 3imp1 cB wrel cB cdm wrel cB crn wrel cA cB wcel cA c2nd cfv cA c2nd
    cfv c1st cfv cA c2nd cfv c2nd cfv cop wceq cB cdm wrel cB crn wrel cB wrel
    cA cB wcel cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop wceq
    wi cB crn wrel cB wrel cA cB wcel cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd
    cfv c2nd cfv cop wceq wi wi wi cB cdm wrel cB crn wrel cB wrel cA cB wcel
    cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop wceq cB crn wrel
    cA c2nd cfv cB crn wcel cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv c2nd
    cfv cop wceq cB wrel cA cB wcel wa cA c2nd cfv cB crn 1st2nd cA cB 2ndrn
    sylan2 exp32 a1i com3r 3imp1 opeq12d eqtrd $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)

  ${ $d A x $.
    $( The union of a part of a powerset belongs to it. $)
    ump $p |- ( A e. B -> U. { x e. ~P A | ph } e. ~P A ) $=
      cA cB wcel wph vx cA cpw crab cuni cA cpw wcel wph vx cA cpw crab cuni cA
      wss wph vx cA cpw crab cA cpw wss wph vx cA cpw crab cuni cA wss wph vx
      cA cpw ssrab2 wph vx cA cpw crab cA sspwuni mpbi wph vx cA cpw crab cuni
      cA cB elpw2g mpbiri $.
      $( [29-Nov-2007] $) $( [16-Nov-2007] $)
  $}

  ${
    $( ` { A , A } ` has only one element. $)
    boe $p |- ( A e. B -> { A , A } ~~ 1o ) $=
      cA cB wcel cA cA cpr cA csn c1o cen cA cA cpr cA csn wceq cA cB wcel cA
      csn cA cA cpr cA dfsn2 eqcomi a1i cA cB ensn1g eqbrtrd $.
      $( [15-Feb-2010] $) $( [15-Feb-2010] $)

  $}

  $( Moving an element ` B ` out from the intersection of a class ` A ` . $)
  moec $p |- ( B e. A -> |^| A = ( B i^i |^| ( A \ { B } ) ) ) $=
    cB cA wcel cA cint cA cB csn cdif cB csn cun cint cA cB csn cdif cint cB
    csn cint cin cB cA cB csn cdif cint cin cB cA wcel cA cA cB csn cdif cB csn
    cun cB cA wcel cA cB csn cdif cB csn cun cA cA cB difsnid eqcomd inteqd cA
    cB csn cdif cB csn cun cint cA cB csn cdif cint cB csn cint cin wceq cB cA
    wcel cA cB csn cdif cB csn intun a1i cB cA wcel cA cB csn cdif cint cB csn
    cint cin cA cB csn cdif cint cB cin cB cA cB csn cdif cint cin cB cA wcel
    cB csn cint cB cA cB csn cdif cint cB cA wcel cB cvv wcel cB csn cint cB
    wceq cB cA elisset cB cvv wcel cB csn cint cB wceq cB cvv wcel cB c0 cif
    csn cint cB cvv wcel cB c0 cif wceq cB c0 cB cB cvv wcel cB c0 cif wceq cB
    csn cint cB cvv wcel cB c0 cif csn cint cB cB cvv wcel cB c0 cif cB cB cvv
    wcel cB c0 cif wceq cB csn cB cvv wcel cB c0 cif csn cB cB cvv wcel cB c0
    cif sneq inteqd cB cB cvv wcel cB c0 cif wceq id eqeq12d cB cvv wcel cB c0
    cif cB c0 cvv 0ex elimel intsn dedth syl ineq2d cA cB csn cdif cint cB
    incom syl6eq 3eqtrd $.
    $( [29-Nov-2007] $) $( [29-Nov-2007] $)


  ${
    $( A function's value belongs to its range. A more general version
       of ~ fnoprvrn .  To be used with partial operations. $)
    fnoprvrn2 $p |- ( ( Fun F /\ <. A , B >. e. dom F ) ->
      ( A F B ) e. ran F ) $=
      cF wfun cA cB cop cF cdm wcel wa cA cB cop cF cfv cF crn cA cB cF co cA
      cB cop cF fvelrn cA cB cF df-opr syl5eqel $.
      $( [10-Mar-2008] $) $( [10-Mar-2008] $)
  $}

  ${
    $d A a b x y $.  $d B a b x y $.  $d L a b x y $.
    ficli.1 $e |- F = { x | E. y ( y C_ L /\ y e. Fin /\ x = |^| y ) } $.
    $( The class of finite intersections of a class ` L ` are closed under
       intersection. $)
    ficli $p |- ( ( A e. F /\ B e. F ) -> ( A i^i B ) e. F ) $=
      cA cF wcel cB cF wcel wa cA cB cin cF wcel vy cv cL wss vy cv cfn wcel cA
      cB cin vy cv cint wceq w3a vy wex cA vy cv cL wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vx cab wcel cB vy cv cL wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn wcel cA cB
      cin vy cv cint wceq w3a vy wex cA cF wcel cB cF wcel cA vy cv cL wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cL wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wa vy cv cL
      wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex cA vy cv cL wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cL
      wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel wa cA vy
      cv cL wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cB
      vy cv cL wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel
      wa vy cv cL wss vy cv cfn wcel cA vy cv cint wceq w3a vy wex vy cv cL wss
      vy cv cfn wcel cB vy cv cint wceq w3a vy wex wa vy cv cL wss vy cv cfn
      wcel cA cB cin vy cv cint wceq w3a vy wex cA vy cv cL wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wcel cA vy cv cL wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn
      wcel cA vy cv cint wceq w3a vy wex cB vy cv cL wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cL wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn wcel cB
      vy cv cint wceq w3a vy wex cA vy cv cL wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel cA vy cv cL wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn wcel cA vy cv
      cint wceq w3a vy wex vx vy cA vy cv cL wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab cL spfi biimpd cB vy cv cL wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cL wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn
      wcel cB vy cv cint wceq w3a vy wex vx vy cB vy cv cL wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab cL spfi biimpd im2anan9 va cv cL
      wss va cv cfn wcel cA va cv cint wceq w3a va wex vb cv cL wss vb cv cfn
      wcel cB vb cv cint wceq w3a vb wex vy cv cL wss vy cv cfn wcel cA cB cin
      vy cv cint wceq w3a vy wex vy cv cL wss vy cv cfn wcel cA vy cv cint wceq
      w3a vy wex vy cv cL wss vy cv cfn wcel cB vy cv cint wceq w3a vy wex va
      cv cL wss va cv cfn wcel cA va cv cint wceq w3a va wex vb cv cL wss vb cv
      cfn wcel cB vb cv cint wceq w3a vb wex vy cv cL wss vy cv cfn wcel cA cB
      cin vy cv cint wceq w3a vy wex va cv cL wss va cv cfn wcel cA va cv cint
      wceq w3a vb cv cL wss vb cv cfn wcel cB vb cv cint wceq w3a vb wex vy cv
      cL wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex wi va vb cv cL
      wss vb cv cfn wcel cB vb cv cint wceq w3a vb wex va cv cL wss va cv cfn
      wcel cA va cv cint wceq w3a vy cv cL wss vy cv cfn wcel cA cB cin vy cv
      cint wceq w3a vy wex vb cv cL wss vb cv cfn wcel cB vb cv cint wceq w3a
      va cv cL wss va cv cfn wcel cA va cv cint wceq w3a vy cv cL wss vy cv cfn
      wcel cA cB cin vy cv cint wceq w3a vy wex wi vb vb cv cL wss vb cv cfn
      wcel cB vb cv cint wceq w3a va cv cL wss va cv cfn wcel cA va cv cint
      wceq w3a vy cv cL wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex
      vb cv cL wss vb cv cfn wcel cB vb cv cint wceq w3a va cv cL wss va cv cfn
      wcel cA va cv cint wceq w3a wa vy cv cfn wcel cA cB cin vy cv cint wceq
      wa vy cL cpw wrex vy cv cL wss vy cv cfn wcel cA cB cin vy cv cint wceq
      w3a vy wex vb cv cL wss vb cv cfn wcel cB vb cv cint wceq w3a va cv cL
      wss va cv cfn wcel cA va cv cint wceq w3a wa va cv vb cv cun cL cpw wcel
      va cv vb cv cun cfn wcel cA cB cin va cv vb cv cun cint wceq wa wa vy cv
      cfn wcel cA cB cin vy cv cint wceq wa vy cL cpw wrex vb cv cL wss vb cv
      cfn wcel cB vb cv cint wceq w3a va cv cL wss va cv cfn wcel cA va cv cint
      wceq w3a wa vb cv cL wss va cv cL wss wa vb cv cfn wcel va cv cfn wcel wa
      cB vb cv cint wceq cA va cv cint wceq wa w3a va cv vb cv cun cL cpw wcel
      va cv vb cv cun cfn wcel cA cB cin va cv vb cv cun cint wceq wa wa vb cv
      cL wss vb cv cfn wcel cB vb cv cint wceq va cv cL wss va cv cfn wcel cA
      va cv cint wceq an6 vb cv cL wss va cv cL wss wa vb cv cfn wcel va cv cfn
      wcel wa cB vb cv cint wceq cA va cv cint wceq wa va cv vb cv cun cL cpw
      wcel va cv vb cv cun cfn wcel cA cB cin va cv vb cv cun cint wceq wa wa
      vb cv cL wss va cv cL wss wa va cv vb cv cun cL cpw wcel vb cv cfn wcel
      va cv cfn wcel wa cB vb cv cint wceq cA va cv cint wceq wa wa va cv vb cv
      cun cfn wcel cA cB cin va cv vb cv cun cint wceq wa vb cv cL wss va cv cL
      wss wa va cv vb cv cun cL wss va cv vb cv cun cL cpw wcel va cv cL wss vb
      cv cL wss va cv vb cv cun cL wss va cv cL wss vb cv cL wss wa va cv vb cv
      cun cL wss va cv vb cv cL unss biimpi ancoms va cv vb cv cun cL va cv vb
      cv va visset vb visset unex elpw sylibr vb cv cfn wcel va cv cfn wcel wa
      va cv vb cv cun cfn wcel cB vb cv cint wceq cA va cv cint wceq wa cA cB
      cin va cv vb cv cun cint wceq va cv cfn wcel vb cv cfn wcel va cv vb cv
      cun cfn wcel va cv vb cv unfi ancoms cA va cv cint wceq cB vb cv cint
      wceq cA cB cin va cv vb cv cun cint wceq cA va cv cint wceq cB vb cv cint
      wceq wa cA cB cin va cv cint vb cv cint cin va cv vb cv cun cint cA va cv
      cint cB vb cv cint ineq12 va cv vb cv intun syl6eqr ancoms anim12i
      anim12i 3impb sylbi vy cv cfn wcel cA cB cin vy cv cint wceq wa va cv vb
      cv cun cfn wcel cA cB cin va cv vb cv cun cint wceq wa vy va cv vb cv cun
      cL cpw vy cv va cv vb cv cun wceq vy cv cfn wcel va cv vb cv cun cfn wcel
      cA cB cin vy cv cint wceq cA cB cin va cv vb cv cun cint wceq vy cv va cv
      vb cv cun cfn eleq1 vy cv va cv vb cv cun wceq vy cv cint va cv vb cv cun
      cint cA cB cin vy cv va cv vb cv cun inteq eqeq2d anbi12d rcla4ev syl vy
      cv cL wss vy cv cfn wcel cA cB cin vy cv cint wceq w3a vy wex vy cv cL
      cpw wcel vy cv cfn wcel cA cB cin vy cv cint wceq wa wa vy wex vy cv cfn
      wcel cA cB cin vy cv cint wceq wa vy cL cpw wrex vy cv cL wss vy cv cfn
      wcel cA cB cin vy cv cint wceq w3a vy cv cL cpw wcel vy cv cfn wcel cA cB
      cin vy cv cint wceq wa wa vy vy cv cL wss vy cv cfn wcel cA cB cin vy cv
      cint wceq w3a vy cv cL cpw wcel vy cv cfn wcel cA cB cin vy cv cint wceq
      w3a vy cv cL cpw wcel vy cv cfn wcel cA cB cin vy cv cint wceq wa wa vy
      cv cL wss vy cv cL cpw wcel vy cv cfn wcel cA cB cin vy cv cint wceq vy
      cv cL cpw wcel vy cv cL wss vy cv cL vy visset elpw bicomi 3anbi1i vy cv
      cL cpw wcel vy cv cfn wcel cA cB cin vy cv cint wceq 3anass bitri exbii
      vy cv cfn wcel cA cB cin vy cv cint wceq wa vy cL cpw df-rex bitr4i
      sylibr ex 19.23aiv com12 19.23aiv imp vy cv cL wss vy cv cfn wcel cA vy
      cv cint wceq w3a va cv cL wss va cv cfn wcel cA va cv cint wceq w3a vy va
      vy cv va cv wceq vy cv cL wss va cv cL wss vy cv cfn wcel va cv cfn wcel
      cA vy cv cint wceq cA va cv cint wceq vy cv va cv cL sseq1 vy cv va cv
      cfn eleq1 vy cv va cv wceq vy cv cint va cv cint cA vy cv va cv inteq
      eqeq2d 3anbi123d cbvexv vy cv cL wss vy cv cfn wcel cB vy cv cint wceq
      w3a vb cv cL wss vb cv cfn wcel cB vb cv cint wceq w3a vy vb vy cv vb cv
      wceq vy cv cL wss vb cv cL wss vy cv cfn wcel vb cv cfn wcel cB vy cv
      cint wceq cB vb cv cint wceq vy cv vb cv cL sseq1 vy cv vb cv cfn eleq1
      vy cv vb cv wceq vy cv cint vb cv cint cB vy cv vb cv inteq eqeq2d
      3anbi123d cbvexv syl2anb syl6 pm2.43i cF vy cv cL wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vx cab cA ficli.1 eleq2i cF vy cv cL wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab cB ficli.1 eleq2i
      syl2anb cA cF wcel cB cF wcel wa cA cB cin vy cv cL wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn wcel cA
      cB cin vy cv cint wceq w3a vy wex cA cB cin cF wcel cA cF wcel cB cF wcel
      wa cA cB cin cvv wcel cA cB cin vy cv cL wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel vy cv cL wss vy cv cfn wcel cA cB cin vy
      cv cint wceq w3a vy wex wb cA cF wcel cA cB cin cvv wcel cB cF wcel cA cB
      cF inex1g adantr vx vy cA cB cin cvv cL spfi syl cF vy cv cL wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab cA cB cin ficli.1 eleq2i
      syl5bb mpbird $.
      $( [2-Sep-2008] $) $( [27-Apr-2008] $)
  $}

  $( If an intersection is not empty its operands are not empty. $)
   neiopne $p |- ( ( A i^i B ) =/= (/) -> ( A =/= (/) /\ B =/= (/) ) ) $=
     cA cB cin c0 wceq wn cA c0 wceq cB c0 wceq wo wn cA cB cin c0 wne cA c0
     wne cB c0 wne wa cA c0 wceq cB c0 wceq wo cA cB cin c0 wceq cA c0 wceq cA
     cB cin c0 wceq cB c0 wceq cA c0 wceq cA cB cin c0 cB cin wceq cA cB cin c0
     wceq cA c0 cB ineq1 cA cB cin c0 cB cin wceq c0 cB cin cB c0 cin wceq cA
     cB cin c0 wceq c0 cB incom cA cB cin c0 cB cin wceq c0 cB cin cB c0 cin
     wceq wa cA cB cin cB c0 cin c0 cA cB cin c0 cB cin cB c0 cin eqtr cB in0
     syl6eq mpan2 syl cB c0 wceq cA cB cin cA c0 cin c0 cB c0 cA ineq2 cA in0
     syl6eq jaoi con3i cA cB cin c0 df-ne cA c0 cB c0 neanior 3imtr4i $.
     $( [27-Apr-2008] $) $( [27-Apr-2008] $)

  $( Image of a pre-image. $)
  f2imacnv $p |- ( ( F : A -1-1-onto-> B /\ C C_ B ) ->
                 ( F " ( `' F " C ) ) = C ) $=
    cA cB cF wf1o cC cB wss cF cF ccnv cC cima cima cC wceq cA cB cF wf1o cB cA
    cF ccnv wf1o cB cA cF ccnv wf1 cC cB wss cF cF ccnv cC cima cima cC wceq wi
    cA cB cF f1ocnv cB cA cF ccnv f1of1 cB cA cF ccnv wf1 cC cB wss cF cF ccnv
    cC cima cima cC wceq cB cA cF ccnv wf1 cC cB wss wa cF ccnv ccnv cF ccnv cC
    cima cima cC cF cF ccnv cC cima cima cB cA cC cF ccnv f1imacnv cF cF ccnv
    cC cima imacnvcnv syl5eqr ex 3syl imp $.
    $( [1-Jun-2008] $) $( [1-Jun-2008] $)


  $( Symmetrical equality of the images and of their antecedents when
     the mapping is one to one. $)
  oooeqim2 $p |- ( ( F : A -1-1-> B /\ X C_ A /\ Y C_ A )
     -> ( ( F " X ) = ( F " Y ) <-> X = Y ) ) $=
    cA cB cF wf1 cX cA wss cY cA wss w3a cF cX cima cF cY cima wceq cX cY wceq
    cA cB cF wf1 cX cA wss cY cA wss w3a cF ccnv cF cX cima cima cF ccnv cF cY
    cima cima wceq cX cY wceq cF cX cima cF cY cima wceq cA cB cF wf1 cX cA wss
    cY cA wss w3a cF ccnv cF cX cima cima cX wceq cF ccnv cF cY cima cima cY
    wceq wa cF ccnv cF cX cima cima cF ccnv cF cY cima cima wceq cX cY wceq wi
    cA cB cF wf1 cX cA wss cY cA wss cF ccnv cF cX cima cima cX wceq cF ccnv cF
    cY cima cima cY wceq wa cA cB cF wf1 cX cA wss cF ccnv cF cX cima cima cX
    wceq cY cA wss cF ccnv cF cY cima cima cY wceq cA cB cF wf1 cX cA wss cF
    ccnv cF cX cima cima cX wceq cA cB cX cF f1imacnv ex cA cB cF wf1 cY cA wss
    cF ccnv cF cY cima cima cY wceq cA cB cY cF f1imacnv ex anim12d 3impib cF
    ccnv cF cX cima cima cX wceq cF ccnv cF cY cima cima cY wceq cF ccnv cF cX
    cima cima cF ccnv cF cY cima cima wceq cX cY wceq wi cF ccnv cF cY cima
    cima cY wceq cF ccnv cF cX cima cima cF ccnv cF cY cima cima wceq cX cY
    wceq wi wi cX cF ccnv cF cX cima cima cX cF ccnv cF cX cima cima wceq cF
    ccnv cF cX cima cima cF ccnv cF cY cima cima wceq cF ccnv cF cY cima cima
    cY wceq cX cY wceq cX cF ccnv cF cX cima cima wceq cF ccnv cF cX cima cima
    cF ccnv cF cY cima cima wceq cF ccnv cF cY cima cima cY wceq cX cY wceq wi
    cX cF ccnv cF cX cima cima wceq cF ccnv cF cX cima cima cF ccnv cF cY cima
    cima wceq wa cX cF ccnv cF cY cima cima wceq cF ccnv cF cY cima cima cY
    wceq cX cY wceq wi cX cF ccnv cF cX cima cima cF ccnv cF cY cima cima eqtr
    cX cF ccnv cF cY cima cima wceq cF ccnv cF cY cima cima cY wceq cX cY wceq
    cX cF ccnv cF cY cima cima cY eqtr ex syl ex com23 eqcoms imp syl cF cX
    cima cF cY cima cF ccnv imaeq2 syl5 cX cY cF imaeq2 impbid1 $.
    $( [1-Jun-2008] $) $( [1-Jun-2008] $)

  $( A  theorem about things which don't exist ` _V ` and
     ` ( _V X. _V ) ` . $)
  vxveqv $p |- ( _V X. _V ) =/= _V $=
    cvv cvv cxp cvv wne cvv cvv cxp cvv wceq wn cvv cvv cxp cvv wpss cvv cvv
    cxp cvv wceq wn cvv cvv cxp cvv wpss cvv cvv cxp cvv wss cvv cvv cvv cxp
    wss wn cvv cvv cxp cvv dfpss3 cvv cvv cxp ssv cvv cvv cvv cxp wss wn vx cv
    cvv wcel vx cv cvv cvv cxp wcel wn wa vx wex c0 cvv wcel c0 cvv cvv cxp
    wcel wn vx cv cvv wcel vx cv cvv cvv cxp wcel wn wa vx wex 0ex cvv cvv
    0nelxp vx cv cvv wcel vx cv cvv cvv cxp wcel wn wa c0 cvv wcel c0 cvv cvv
    cxp wcel wn wa vx c0 0ex vx cv c0 wceq vx cv cvv wcel c0 cvv wcel vx cv cvv
    cvv cxp wcel wn c0 cvv cvv cxp wcel wn vx cv c0 cvv eleq1 vx cv c0 wceq vx
    cv cvv cvv cxp wcel c0 cvv cvv cxp wcel vx cv c0 cvv cvv cxp eleq1 notbid
    anbi12d cla4ev mp2an vx cvv cvv cvv cxp nss mpbir mpbir2an cvv cvv cxp pssv
    mpbi cvv cvv cxp cvv df-ne mpbir $.
    $( [23-Sep-2008] $) $( [22-Sep-2008] $)

  $( The double union of the converse of a class ` A ` is included in the
     double union of the class. $)
  ducidu $p |- U. U. `' A C_ U. U. A $=
    cA ccnv cuni cuni cA cdm cA crn cun cA cuni cuni cA unidmrn cA dmrnssfld
    eqsstri $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  $( if ` R ` is a relation, its double union equals the double union of its
     converse. $)
  relcnvfld $p |- ( Rel R -> U. U. R = U. U. `' R ) $=
    cR wrel cR cuni cuni cR cdm cR crn cun cR ccnv cuni cuni cR relfld cR
    unidmrn syl6eqr $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)

  ${ $d R x $.
  $( Domain and range of a reflexive relation are equal. $)
  domrngref $p |- ( ( Rel R /\ A. x e. U. U. R x R x ) -> dom R = ran R ) $=
    cR wrel vx cv vx cv cR wbr vx cR cuni cuni wral wa vx cv cR cdm wcel vx cv
    cR crn wcel wb vx wal cR cdm cR crn wceq cR wrel vx cv vx cv cR wbr vx cR
    cuni cuni wral vx cv cR cdm wcel vx cv cR crn wcel wb vx wal cR wrel vx cv
    cR cuni cuni wcel vx cv vx cv cR wbr wi vx wal vx cv cR cdm wcel vx cv cR
    crn wcel wb vx wal vx cv vx cv cR wbr vx cR cuni cuni wral cR wrel vx cv cR
    cuni cuni wcel vx cv vx cv cR wbr wi vx cv cR cdm wcel vx cv cR crn wcel wb
    vx cR wrel vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv cR cdm cR
    crn cun wcel vx cv vx cv cR wbr wi vx cv cR cdm wcel vx cv cR crn wcel wb
    cR wrel vx cv cR cdm cR crn cun wcel vx cv cR cuni cuni wcel vx cv vx cv cR
    wbr cR wrel vx cv cR cdm cR crn cun wcel vx cv cR cuni cuni wcel cR wrel cR
    cdm cR crn cun cR cuni cuni vx cv cR wrel cR cuni cuni cR cdm cR crn cun cR
    relfld eqcomd eleq2d biimpd imim1d vx cv cR cdm cR crn cun wcel vx cv vx cv
    cR wbr wi vx cv cR cdm wcel vx cv cR crn wcel wo vx cv vx cv cR wbr wi vx
    cv cR cdm wcel vx cv cR crn wcel wb vx cv cR cdm cR crn cun wcel vx cv cR
    cdm wcel vx cv cR crn wcel wo vx cv vx cv cR wbr vx cv cR cdm cR crn elun
    imbi1i vx cv cR cdm wcel vx cv cR crn wcel wo vx cv vx cv cR wbr wi vx cv
    cR cdm wcel vx cv vx cv cR wbr wi vx cv cR crn wcel vx cv vx cv cR wbr wi
    wa vx cv cR cdm wcel vx cv cR crn wcel wb vx cv cR cdm wcel vx cv vx cv cR
    wbr vx cv cR crn wcel jaob vx cv cR cdm wcel vx cv vx cv cR wbr wi vx cv cR
    crn wcel vx cv vx cv cR wbr wi wa vx cv cR cdm wcel vx cv cR crn wcel vx cv
    cR cdm wcel vx cv vx cv cR wbr wi vx cv cR cdm wcel vx cv cR crn wcel wi vx
    cv cR crn wcel vx cv vx cv cR wbr wi vx cv vx cv cR wbr vx cv cR crn wcel
    vx cv cR cdm wcel vx cv vx cv cR vx visset vx visset brelrn imim2i adantr
    vx cv cR crn wcel vx cv vx cv cR wbr wi vx cv cR crn wcel vx cv cR cdm wcel
    wi vx cv cR cdm wcel vx cv vx cv cR wbr wi vx cv vx cv cR wbr vx cv cR cdm
    wcel vx cv cR crn wcel vx cv vx cv cR vx visset breldm imim2i adantl impbid
    sylbi sylbi syl6 19.20dv vx cv vx cv cR wbr vx cR cuni cuni df-ral syl5ib
    imp vx cR cdm cR crn dfcleq sylibr $.
    $( [7-Oct-2008] $) $( [6-Oct-2008] $)

  $( The domain of a reflexive relation is equal to its field . $)
  domfldref $p |- ( ( Rel R /\ A. x e. U. U. R x R x ) -> dom R = U. U. R ) $=
    cR wrel vx cv vx cv cR wbr vx cR cuni cuni wral cR cdm cR cuni cuni wceq cR
    wrel vx cv vx cv cR wbr vx cR cuni cuni wral wa cR cuni cuni cR cdm cR crn
    cun wceq cR cdm cR cuni cuni wceq cR wrel cR wrel vx cv vx cv cR wbr vx cR
    cuni cuni wral wa cR cdm cR crn wceq cR cuni cuni cR cdm cR crn cun wceq cR
    cdm cR cuni cuni wceq wi vx cR domrngref cR cuni cuni cR cdm cR crn cun
    wceq cR cdm cR crn cun cR cdm cR cdm cun wceq cR cdm cR cuni cuni wceq cR
    cdm cR crn wceq cR cuni cuni cR cdm cR crn cun wceq cR cdm cR crn cun cR
    cdm cR cdm cun wceq cR cdm cR cuni cuni wceq cR cuni cuni cR cdm cR crn cun
    wceq cR cdm cR crn cun cR cdm cR cdm cun wceq wa cR cuni cuni cR cdm cR cdm
    cun cR cdm cR cuni cuni cR cdm cR crn cun cR cdm cR cdm cun eqtr cR cdm
    unidm syl6req ex cR cdm cR crn wceq cR cdm cR cdm cun cR cdm cR crn cun cR
    cdm cR crn cR cdm uneq2 eqcomd syl5com syl cR relfld syl5com anabsi5 $.
    $( [7-Oct-2008] $) $( [6-Oct-2008] $)

  $}

  ${ $d x R $. $d x A $.
    domintreflem.1 $e |- A e. _V $.
    $( Lemma for ~ domintref . $)
    domintreflem $p |- ( ( Rel R /\ A. x e. U. U. R x R x ) ->
      ( A e. dom R <-> <. A , A >. e. R ) ) $=
      cR wrel vx cv vx cv cR wbr vx cR cuni cuni wral wa cA cR cdm wcel cA cA
      cop cR wcel cR cdm cR cuni cuni wceq cR wrel vx cv vx cv cR wbr vx cR
      cuni cuni wral wa cA cR cdm wcel cA cA cop cR wcel wi vx cR domfldref cR
      cdm cR cuni cuni wceq cA cR cdm wcel cA cR cuni cuni wcel cR wrel vx cv
      vx cv cR wbr vx cR cuni cuni wral wa cA cA cop cR wcel cR cdm cR cuni
      cuni wceq cA cR cdm wcel cA cR cuni cuni wcel cR cdm cR cuni cuni cA
      eleq2 biimpd vx cv vx cv cR wbr vx cR cuni cuni wral cA cR cuni cuni wcel
      cA cA cop cR wcel wi cR wrel vx cv vx cv cR wbr cA cA cop cR wcel vx cA
      cR cuni cuni vx cv cA wceq vx cv vx cv cR wbr cA cA cR wbr cA cA cop cR
      wcel vx cv cA wceq vx cv vx cv cR wbr cA cA cR wbr wb vx cv cA vx cv cA
      cR breq12 anidms cA cA cR df-br syl6bb rcla4cv adantl syl9 mpcom cA cA cR
      domintreflem.1 opeldm impbid1 $.
      $( [7-Oct-2008] $) $( [6-Oct-2008] $)
  $}

  ${ $d R x y $. $d S x y $.
    $( The domain of the intersection of two reflexive relations is the
       intersection of their domains. Compare with ~ dmin . $)
    domintref $p |- ( ( ( Rel R /\ A. x e. U. U. R x R x ) /\
     ( Rel S /\ A. x e. U. U. S x S x ) ) ->
      dom ( R i^i S ) = ( dom R i^i dom S ) ) $=
      cR wrel vx cv vx cv cR wbr vx cR cuni cuni wral wa cS wrel vx cv vx cv cS
      wbr vx cS cuni cuni wral wa wa vy cR cS cin cdm cR cdm cS cdm cin cR wrel
      vx cv vx cv cR wbr vx cR cuni cuni wral wa vy cv cR cdm wcel vy cv vy cv
      cop cR wcel wb cS wrel vx cv vx cv cS wbr vx cS cuni cuni wral wa vy cv
      cR cS cin cdm wcel vy cv cR cdm cS cdm cin wcel wb vx vy cv cR vy visset
      domintreflem cS wrel vx cv vx cv cS wbr vx cS cuni cuni wral wa vy cv cS
      cdm wcel vy cv vy cv cop cS wcel wb vy cv cR cdm wcel vy cv vy cv cop cR
      wcel wb vy cv cR cS cin cdm wcel vy cv cR cdm cS cdm cin wcel wb wi vx vy
      cv cS vy visset domintreflem vy cv cS cdm wcel vy cv vy cv cop cS wcel wb
      vy cv cR cdm wcel vy cv vy cv cop cR wcel wb vy cv cR cS cin cdm wcel vy
      cv cR cdm cS cdm cin wcel wb vy cv cS cdm wcel vy cv vy cv cop cS wcel wb
      vy cv cR cdm wcel vy cv vy cv cop cR wcel wb wa vy cv cR cS cin cdm wcel
      vy cv cR cdm cS cdm cin wcel cR cS cin cdm cR cdm cS cdm cin vy cv cR cS
      dmin sseli vy cv cR cdm cS cdm cin wcel vy cv cS cdm wcel vy cv vy cv cop
      cS wcel wb vy cv cR cdm wcel vy cv vy cv cop cR wcel wb wa vy cv cR cS
      cin cdm wcel vy cv cR cdm cS cdm cin wcel vy cv cR cdm wcel vy cv cS cdm
      wcel wa vy cv cS cdm wcel vy cv vy cv cop cS wcel wb vy cv cR cdm wcel vy
      cv vy cv cop cR wcel wb wa vy cv cR cS cin cdm wcel wi vy cv cR cdm cS
      cdm elin vy cv cS cdm wcel vy cv cR cdm wcel vy cv cS cdm wcel vy cv vy
      cv cop cS wcel wb vy cv cR cdm wcel vy cv vy cv cop cR wcel wb wa vy cv
      cR cS cin cdm wcel wi vy cv cS cdm wcel vy cv cR cdm wcel wa vy cv cS cdm
      wcel vy cv vy cv cop cS wcel wb vy cv cR cdm wcel vy cv vy cv cop cR wcel
      wb wa vy cv vy cv cop cS wcel vy cv vy cv cop cR wcel wa vy cv cR cS cin
      cdm wcel vy cv cS cdm wcel vy cv cS cdm wcel vy cv vy cv cop cS wcel wb
      vy cv vy cv cop cS wcel vy cv cR cdm wcel vy cv cR cdm wcel vy cv vy cv
      cop cR wcel wb vy cv vy cv cop cR wcel vy cv cS cdm wcel vy cv vy cv cop
      cS wcel wb vy cv cS cdm wcel vy cv vy cv cop cS wcel vy cv cS cdm wcel vy
      cv vy cv cop cS wcel bi1 com12 vy cv cR cdm wcel vy cv vy cv cop cR wcel
      wb vy cv cR cdm wcel vy cv vy cv cop cR wcel vy cv cR cdm wcel vy cv vy
      cv cop cR wcel bi1 com12 im2anan9 vy cv vy cv cop cS wcel vy cv vy cv cop
      cR wcel wa vy cv vy cv cop cS cR cin wcel vy cv cR cS cin cdm wcel vy cv
      vy cv cop cS cR elin vy cv vy cv cop cS cR cin wcel vy cv vy cv cop cR cS
      cin wcel vy cv cR cS cin cdm wcel cS cR cin cR cS cin vy cv vy cv cop cS
      cR incom eleq2i vy cv vy cv cR cS cin vy visset opeldm sylbi sylbir syl6
      ancoms sylbi com12 impbid2 ex syl mpan9 eqrdv $.
      $( [7-Oct-2008] $) $( [6-Oct-2008] $)
  $}

  ${ $d A x y $. $d R x y $.
  $( If ` R ` is a reflexive relation and ` A ` a part of its field,
     ` A ` is a part of the image of ` A ` by ` R ` . $)
  imgfldref2 $p |- ( ( A. x e. U. U. R x R x /\ A C_ U. U. R )
    -> A C_ ( R " A ) ) $=
    vx cv vx cv cR wbr vx cR cuni cuni wral cA cR cuni cuni wss wa cA vy cv vx
    cv cR wbr vy cA wrex vx cab cR cA cima vx cv vx cv cR wbr vx cR cuni cuni
    wral cA cR cuni cuni wss wa vx cv cA wcel vy cv vx cv cR wbr vy cA wrex wi
    vx wal cA vy cv vx cv cR wbr vy cA wrex vx cab wss vx cv vx cv cR wbr vx cR
    cuni cuni wral cA cR cuni cuni wss wa vx cv cA wcel vy cv vx cv cR wbr vy
    cA wrex wi vx vx cv vx cv cR wbr vx cR cuni cuni wral cA cR cuni cuni wss
    vx vx cv vx cv cR wbr vx cR cuni cuni hbra1 cA cR cuni cuni wss vx ax-17
    hban vx cv vx cv cR wbr vx cR cuni cuni wral cA cR cuni cuni wss vx cv cA
    wcel vy cv vx cv cR wbr vy cA wrex wi vx cv cA wcel vx cv vx cv cR wbr vx
    cR cuni cuni wral cA cR cuni cuni wss vy cv vx cv cR wbr vy cA wrex vx cv
    cA wcel vx cv vx cv cR wbr vx cR cuni cuni wral cA cR cuni cuni wss vy cv
    vx cv cR wbr vy cA wrex wi wi vx cv cA wcel cA cR cuni cuni wss vx cv vx cv
    cR wbr vx cR cuni cuni wral vx cv cA wcel vy cv vx cv cR wbr vy cA wrex cA
    cR cuni cuni wss vx cv cA wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr
    vx cR cuni cuni wral vx cv cA wcel vy cv vx cv cR wbr vy cA wrex wi wi cA
    cR cuni cuni vx cv ssel vx cv vx cv cR wbr vx cR cuni cuni wral vx cv cR
    cuni cuni wcel vx cv vx cv cR wbr vx cv cA wcel vy cv vx cv cR wbr vy cA
    wrex wi vx cv vx cv cR wbr vx cR cuni cuni ra4 vx cv cA wcel vx cv vx cv cR
    wbr vy cv vx cv cR wbr vy cA wrex vy cv vx cv cR wbr vx cv vx cv cR wbr vy
    vx cv cA vx cv vx cv cR wbr vy ax-17 vy cv vx cv vx cv cR breq1 rcla4e
    expcom syl6com syl6com com24 pm2.43i com3l imp 19.21ai vy cv vx cv cR wbr
    vy cA wrex vx cA ssab sylibr vy vx cR cA dfima2 syl6ssr $.
    $( [3-Aug-2009] $) $( [3-Jul-2009] $)
  $}

  ${
    $d R x $.
    $( The converse of a reflexive relation is reflexive. $)
    cnvref $p |- ( A. x e. ( dom R u. ran R ) x R x <->
    A. x e. ( dom `' R u. ran `' R ) x `' R x ) $=
      vx cv vx cv cR wbr vx cR cdm cR crn cun wral vx cv vx cv cR ccnv wbr vx
      cR cdm cR crn cun wral vx cv vx cv cR ccnv wbr vx cR ccnv cdm cR ccnv crn
      cun wral vx cv vx cv cR wbr vx cv vx cv cR ccnv wbr vx cR cdm cR crn cun
      vx cv cR cdm cR crn cun wcel vx cv vx cv cR wbr vx cv vx cv cR ccnv wbr
      wb vx cv cR cdm cR crn cun wcel vx cv cR cdm cR crn cun wcel wa vx cv vx
      cv cR ccnv wbr vx cv vx cv cR wbr vx cv vx cv cR cdm cR crn cun cR cdm cR
      crn cun cR brcnvg bicomd anidms ralbiia cR cdm cR crn cun cR ccnv cdm cR
      ccnv crn cun wceq vx cv vx cv cR ccnv wbr vx cR cdm cR crn cun wral vx cv
      vx cv cR ccnv wbr vx cR ccnv cdm cR ccnv crn cun wral wb cR cdm cR crn
      cun cR ccnv cuni cuni cR ccnv cdm cR ccnv crn cun cR ccnv cuni cuni cR
      cdm cR crn cun cR unidmrn eqcomi cR ccnv wrel cR ccnv cuni cuni cR ccnv
      cdm cR ccnv crn cun wceq cR relcnv cR ccnv relfld ax-mp eqtri vx cv vx cv
      cR ccnv wbr vx cR cdm cR crn cun cR ccnv cdm cR ccnv crn cun raleq1 ax-mp
      bitri $.
      $( [3-Aug-2009] $) $( [31-Jul-2009] $)
  $}

  $( ` <. A , A >. ` belongs to a restriction of the identity class iff ` A `
     belongs to the restricting class. $)
  eltids $p |- ( A e. C -> ( A e. B <-> <. A , A >. e. ( _I |` B ) ) ) $=
    cA cC wcel cA cB wcel cA cA cop cid wcel cA cB wcel wa cA cA cop cid cB
    cres wcel cA cC wcel cA cA cop cid wcel cA cB wcel cA cC wcel cA cA cid wbr
    cA cA cop cid wcel cA cC ididg cA cA cid df-br sylib biantrurd cA cA cid cB
    cC opelresg bitr4d $.
    $( [17-Nov-2008] $) $( [27-Oct-2008] $)

  ${ $d R u x y $.
    $( Replace U. U. R by ( dom R u. ran R ) ? $)
    $( Two ways to state a relation is reflexive. (Adapted from Tarski.) $)
    ref3w $p |- ( A. x e. U. U. R x R x <->
        ( _I |` U. U. R ) C_ R ) $=
      vx cv vx cv cR wbr vx cR cuni cuni wral vx cv cR cuni cuni wcel vx cv vx
      cv cR wbr wi vx wal vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx
      cv cop cR wcel wi vx wal cid cR cuni cuni cres cR wss vx cv vx cv cR wbr
      vx cR cuni cuni df-ral vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx
      cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx vx
      cv cR cuni cuni wcel vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx
      cv cR wbr vx cv vx cv cop cR wcel vx cv cvv wcel vx cv cR cuni cuni wcel
      vx cv vx cv cop cid cR cuni cuni cres wcel wb vx visset vx cv cR cuni
      cuni cvv eltids ax-mp vx cv vx cv cR df-br imbi12i albii vx cv vx cv cop
      cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx wal cid cR cuni
      cuni cres cR wss vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv
      cop cR wcel wi vx wal vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi
      vy wal cid cR cuni cuni cres cR wss vx cv vx cv cop cid cR cuni cuni cres
      wcel vx cv vx cv cop cR wcel wi vx wal vx cv vx cv cop cid cR cuni cuni
      cres wcel vx cv vx cv cop cR wcel wi vx cvv wral vx cvv wral vy cv cid cR
      cuni cuni cres wcel vy cv cR wcel wi vy wal vx cv vx cv cop cid cR cuni
      cuni cres wcel vx cv vx cv cop cR wcel wi vx cvv wral vx cvv wral vx cv
      vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx cvv
      wral vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel
      wi vx wal vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR
      wcel wi vx cvv ralidm vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx
      cv cop cR wcel wi vx ralv bitri vx cv vx cv cop cid cR cuni cuni cres
      wcel vx cv vx cv cop cR wcel wi vx cvv wral vx cvv wral vy cv cid cR cuni
      cuni cres wcel vy cv cR wcel wi vy cvv cvv cxp wral vy cv cid cR cuni
      cuni cres wcel vy cv cR wcel wi vy wal vx cv vx cv cop cid cR cuni cuni
      cres wcel vx cv vx cv cop cR wcel wi vx cvv wral vx cvv wral vx cv vu cv
      cop cid cR cuni cuni cres wcel vx cv vu cv cop cR wcel wi vu cvv wral vx
      cvv wral vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi vy cvv cvv cxp
      wral vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel
      wi vx cvv wral vx cv vu cv cop cid cR cuni cuni cres wcel vx cv vu cv cop
      cR wcel wi vu cvv wral vx cvv vx cv vx cv cop cid cR cuni cuni cres wcel
      vx cv vx cv cop cR wcel wi vx cvv wral vx cv cvv wcel vx cv vx cv cop cid
      cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi wi vx wal vx cv vu cv
      cop cid cR cuni cuni cres wcel vx cv vu cv cop cR wcel wi vu cvv wral vx
      cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx cvv
      df-ral vx cv cvv wcel vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx
      cv cop cR wcel wi wi vx cv vu cv cop cid cR cuni cuni cres wcel vx cv vu
      cv cop cR wcel wi vu cvv wral vx vx cv cvv wcel vx cv cvv wcel vx cv vx
      cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi wi vx cv vu
      cv cop cid cR cuni cuni cres wcel vx cv vu cv cop cR wcel wi vu cvv wral
      wi vx visset vx cv cvv wcel vx cv cvv wcel vx cv vx cv cop cid cR cuni
      cuni cres wcel vx cv vx cv cop cR wcel wi wi vx cv vx cv cop cid cR cuni
      cuni cres wcel vx cv vx cv cop cR wcel wi vx cv vu cv cop cid cR cuni
      cuni cres wcel vx cv vu cv cop cR wcel wi vu cvv wral vx cv cvv wcel vx
      cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi pm2.27
      vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx
      cv vu cv cop cid cR cuni cuni cres wcel vx cv vu cv cop cR wcel wi vu cvv
      vu cv cvv wcel vx cv vu cv cop cid cR cuni cuni cres wcel vx cv vx cv cop
      cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx cv vu cv cop cR
      wcel vu cv cvv wcel vx cv vu cv cop cid cR cuni cuni cres wcel vx cv vu
      cv cop cid wcel vx cv cR cuni cuni wcel wa vx cv vx cv cop cid cR cuni
      cuni cres wcel vx cv vx cv cop cR wcel wi vx cv vu cv cop cR wcel wi vx
      cv vu cv cid cR cuni cuni cvv opelresg vx cv vu cv cop cid wcel vx cv cR
      cuni cuni wcel vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop
      cR wcel wi vx cv vu cv cop cR wcel wi vx cv vu cv cop cid wcel vx cv vu
      cv cid wbr vx cv cR cuni cuni wcel vx cv vx cv cop cid cR cuni cuni cres
      wcel vx cv vx cv cop cR wcel wi vx cv vu cv cop cR wcel wi wi vx cv vu cv
      cid df-br vx cv vu cv cid wbr vx cv vu cv wceq vx cv cR cuni cuni wcel vx
      cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx cv
      vu cv cop cR wcel wi wi vx cv vu cv vu visset ideq vx cv cR cuni cuni
      wcel vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel
      wi vx cv vu cv wceq vx cv vu cv cop cR wcel vx cv cR cuni cuni wcel vx cv
      vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx cv vu
      cv wceq vx cv vu cv cop cR wcel wi wi vx cv cR cuni cuni wcel vx cv cR
      cuni cuni wcel vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop
      cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi vx cv vu cv wceq vx
      cv vu cv cop cR wcel wi wi vx cv cR cuni cuni cR cuni cuni eltids vx cv
      vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cid cR cuni cuni
      cres wcel vx cv vx cv cop cR wcel wi vx cv vx cv cop cR wcel vx cv vu cv
      wceq vx cv vu cv cop cR wcel wi vx cv vx cv cop cid cR cuni cuni cres
      wcel vx cv vx cv cop cR wcel pm2.27 vx cv vu cv wceq vx cv vx cv cop cR
      wcel vx cv vu cv cop cR wcel vx cv vu cv wceq vx cv vx cv cop vx cv vu cv
      cop cR vx cv vu cv vx cv opeq2 eleq1d biimpcd syl6 syl6bi pm2.43i com3r
      sylbi sylbir imp syl6bi com3r r19.21aiv syl6 ax-mp a4s sylbi r19.20si vy
      cv cid cR cuni cuni cres wcel vy cv cR wcel wi vx cv vu cv cop cid cR
      cuni cuni cres wcel vx cv vu cv cop cR wcel wi vy vx vu cvv cvv vy cv vx
      cv vu cv cop wceq vy cv cid cR cuni cuni cres wcel vx cv vu cv cop cid cR
      cuni cuni cres wcel vy cv cR wcel vx cv vu cv cop cR wcel vy cv vx cv vu
      cv cop cid cR cuni cuni cres eleq1 vy cv vx cv vu cv cop cR eleq1 imbi12d
      ralxp sylibr vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi vy cvv cvv
      cxp wral vy cv cvv cvv cxp wcel vy cv cid cR cuni cuni cres wcel vy cv cR
      wcel wi wi vy wal vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi vy
      wal vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi vy cvv cvv cxp
      df-ral vy cv cvv cvv cxp wcel vy cv cid cR cuni cuni cres wcel vy cv cR
      wcel wi wi vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi vy vy cv cvv
      cvv cxp wcel vy cv cid cR cuni cuni cres wcel vy cv cR wcel wi wi vy cv
      cvv cvv cxp wcel vy cv cid cR cuni cuni cres wcel wa vy cv cR wcel vy cv
      cid cR cuni cuni cres wcel vy cv cvv cvv cxp wcel vy cv cid cR cuni cuni
      cres wcel vy cv cR wcel pm3.31 vy cv cid cR cuni cuni cres wcel vy cv cvv
      cvv cxp wcel cid cR cuni cuni cres cvv cvv cxp vy cv cid cR cuni cuni
      cres wrel cid cR cuni cuni cres cvv cvv cxp wss cid cR cuni cuni relres
      cid cR cuni cuni cres df-rel mpbi sseli ancri syl5 19.20i sylbi syl
      sylbir vy cid cR cuni cuni cres cR dfss2 sylibr cid cR cuni cuni cres cR
      wss vx cv vx cv cop cid cR cuni cuni cres wcel vx cv vx cv cop cR wcel wi
      vx cid cR cuni cuni cres cR vx cv vx cv cop ssel 19.21aiv impbii 3bitri
      $.
      $( [17-Nov-2008] $) $( [27-Oct-2008] $)
  $}

  $( Equality theorem for functions. $)
  feq123 $p |- ( ( F = G /\ A = C /\ B = D ) ->
    ( F : A --> B <-> G : C --> D ) ) $=
    cF cG wceq cA cC wceq cB cD wceq w3a cA cB cF wf cA cB cG wf cC cD cG wf cF
    cG wceq cA cC wceq cA cB cF wf cA cB cG wf wb cB cD wceq cA cB cF cG feq1
    3ad2ant1 cA cC wceq cB cD wceq cA cB cG wf cC cD cG wf wb cF cG wceq cA cB
    cC cD cG feq23 3adant1 bitrd $.
    $( [17-Nov-2008] $) $( [16-Nov-2008] $)

  $( A class whose union is finite is finite. $)
  unfinsef $p |- ( U. A e. Fin -> A e. Fin ) $=
    cA cuni cfn wcel cA cuni cpw cfn wcel cA cfn wcel cA cuni pwfi cA cuni cpw
    cfn wcel cA cA cuni cpw wss cA cfn wcel cA pwuni cA cuni cpw cA ssfi mpan2
    sylbi $.
    $( [22-Dec-2008] $) $( [22-Dec-2008] $)

  ${
    opreq123d.1 $e |- ( ph -> F = G ) $.
    opreq123d.2 $e |- ( ph -> A = B ) $.
    opreq123d.3 $e |- ( ph -> C = D ) $.
    $( Equality deduction for operation value. $)
    opreq123d $p |- ( ph -> ( A F C ) = ( B G D ) ) $=
      wph cA cC cF co cA cC cG co cB cC cG co cB cD cG co wph cF cG cA cC
      opreq123d.1 opreqd wph cA cB cC cG opreq123d.2 opreq1d wph cC cD cB cG
      opreq123d.3 opreq2d 3eqtrd $.
      $( [22-Dec-2008] $) $( [22-Dec-2008] $)
  $}

  $( If the domain of a bijection is finite its range is finite and
     reciprocally. $)
  f1ofi $p |- ( F : A -1-1-onto-> B -> ( A e. Fin <-> B e. Fin ) ) $=
    cA cB cF wf1o cA cfn wcel cB cfn wcel cA cfn wcel cA cB cF wfo cB cfn wcel
    cA cB cF wf1o cA cfn wcel cA cB cF wfo cB cfn wcel cA cB cF fofi ex cA cB
    cF f1ofo syl5com cA cB cF wf1o cB cA cF ccnv wf1o cB cA cF ccnv wfo cB cfn
    wcel cA cfn wcel wi cA cB cF f1ocnv cB cA cF ccnv f1ofo cB cfn wcel cB cA
    cF ccnv wfo cA cfn wcel cB cA cF ccnv fofi expcom 3syl impbid $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  ${ $d A B F x $.
    f1fi.1 $e |- F e. C $.
    $( If a 1-to-1 function has a finite codomain its domain is finite. $)
    f1fi $p |- ( ( B e. Fin /\ F : A -1-1-> B ) -> A e. Fin ) $=
      cA cB cF wf1 cB cfn wcel cA cfn wcel cA cB cF wf1 cA vx cv cF wf1o vx cv
      cB wss wa vx wex cB cfn wcel cA cfn wcel wi vx cA cB cF cF cC f1fi.1
      elisseti f11o cA vx cv cF wf1o vx cv cB wss wa cB cfn wcel cA cfn wcel wi
      vx cA vx cv cF wf1o vx cv cB wss cB cfn wcel cA cfn wcel wi cB cfn wcel
      vx cv cB wss cA vx cv cF wf1o cA cfn wcel cB cfn wcel vx cv cB wss cA vx
      cv cF wf1o cA cfn wcel wi cA vx cv cF wf1o cA cfn wcel vx cv cfn wcel cB
      cfn wcel vx cv cB wss wa cA vx cv cF f1ofi cB vx cv ssfi syl5cbir ex
      com13 imp 19.23aiv sylbi impcom $.
      $( [3-Aug-2009] $) $( [31-Jul-2009] $)
  $}

  $( Field of a square cross product. $)
  fldsqcp2 $p |- U. U. ( A X. A ) = A $=
    cA c0 wceq cA cA cxp cuni cuni cA wceq cA cA cxp c0 wceq cA c0 wceq cA cA
    cxp cuni cuni cA wceq cA c0 wceq cA cA cxp c0 cA cxp c0 cA c0 cA xpeq1 cA
    xp0r syl6eq cA cA cxp c0 wceq cA cA cxp cuni cuni c0 cuni cuni wceq cA c0
    wceq cA cA cxp cuni cuni cA wceq wi cA cA cxp c0 wceq cA cA cxp cuni c0
    cuni cA cA cxp c0 unieq unieqd cA cA cxp cuni cuni c0 cuni cuni wceq c0
    cuni cuni c0 wceq cA c0 wceq cA cA cxp cuni cuni cA wceq wi c0 cuni cuni c0
    cuni c0 c0 cuni c0 uni0 unieqi uni0 eqtri cA c0 wceq cA cA cxp cuni cuni c0
    wceq cA cA cxp cuni cuni cA wceq cA cA cxp cuni cuni c0 cuni cuni wceq c0
    cuni cuni c0 wceq wa cA cA cxp cuni cuni c0 wceq cA cA cxp cuni cuni cA
    wceq wi c0 cA cA cA cxp cuni cuni c0 wceq c0 cA wceq cA cA cxp cuni cuni cA
    wceq cA cA cxp cuni cuni c0 cA eqtr expcom eqcoms cA cA cxp cuni cuni c0
    cuni cuni c0 eqtr syl5com mpan2 syl mpcom cA c0 wne cA c0 wne cA cA cxp
    cuni cuni cA wceq cA c0 wceq wn cA c0 wne cA c0 wne wa cA cA cxp c0 wne cA
    cA cxp cuni cuni cA wceq cA cA xpnz cA cA cxp c0 wne cA cA cxp cuni cuni cA
    cA cun cA cA cA unixp cA unidm syl6eq sylbi cA c0 df-ne cA c0 df-ne
    sylancbr pm2.61i $.
    $( [3-Nov-2009] $) $( [10-Oct-2009] $)

  $( To be deleted. $)
  $( Field of a square cross product. $)
  fldsqcp $p |- ( A =/= (/) -> U. U. ( A X. A ) = A ) $=
    cA c0 wne cA cA cxp cuni cuni cA wceq cA c0 wne cA c0 wne wa cA cA cxp c0
    wne cA cA cxp cuni cuni cA wceq cA cA xpnz cA cA cxp c0 wne cA cA cxp cuni
    cuni cA cA cun cA cA cA unixp cA unidm syl6eq sylbi anidms $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)


  ${ $d A x y z $.
  $( A square cross product ` ( A X. A ) ` is a transitive relation. $)
  cpref $p |- ( ( A X. A ) o. ( A X. A ) ) C_ ( A X. A ) $=
    cA cA cxp cA cA cxp ccom cA cA cxp wss vx cv vy cv cA cA cxp wbr vy cv vz
    cv cA cA cxp wbr wa vx cv vz cv cA cA cxp wbr wi vz wal vy wal vx wal vx cv
    vy cv cA cA cxp wbr vy cv vz cv cA cA cxp wbr wa vx cv vz cv cA cA cxp wbr
    wi vz wal vx vy vx cv vy cv cA cA cxp wbr vy cv vz cv cA cA cxp wbr wa vx
    cv vz cv cA cA cxp wbr wi vz vx cv vy cv cA cA cxp wbr vy cv vz cv cA cA
    cxp wbr vx cv vz cv cA cA cxp wbr vx cv vy cv cA cA cxp wbr vx cv cA wcel
    vy cv cA wcel wa vy cv vz cv cA cA cxp wbr vx cv vz cv cA cA cxp wbr wi vx
    cv vy cv cA cA vy visset brxp vx cv cA wcel vy cv vz cv cA cA cxp wbr vx cv
    vz cv cA cA cxp wbr wi vy cv cA wcel vy cv vz cv cA cA cxp wbr vx cv cA
    wcel vx cv vz cv cA cA cxp wbr vy cv vz cv cA cA cxp wbr vy cv cA wcel vz
    cv cA wcel wa vx cv cA wcel vx cv vz cv cA cA cxp wbr wi vy cv vz cv cA cA
    vz visset brxp vz cv cA wcel vx cv cA wcel vx cv vz cv cA cA cxp wbr wi vy
    cv cA wcel vx cv cA wcel vz cv cA wcel vx cv vz cv cA cA cxp wbr vx cv vz
    cv cA cA cxp wbr vx cv cA wcel vz cv cA wcel wa vx cv vz cv cA cA vz visset
    brxp biimpri expcom adantl sylbi com12 adantr sylbi imp ax-gen gen2 vx vy
    vz cA cA cxp cotr mpbir $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)
  $}

  $( A square cross product ` ( A X. A ) ` is reflexive. $)
  scprefat $p |- ( _I |` U. U. ( A X. A ) ) C_ ( A X. A ) $=
    cid cA cA cxp cuni cuni cres cA cA cxp wss cA c0 cA c0 wceq cid cA cA cxp
    cuni cuni cres cA cA cxp wss cid c0 c0 cxp cuni cuni cres c0 c0 cxp wss c0
    c0 cun c0 wceq c0 c0 cxp cuni cuni c0 c0 cun wss cid c0 c0 cxp cuni cuni
    cres c0 c0 cxp wss c0 unidm c0 c0 unixpss c0 c0 cun c0 wceq c0 c0 cxp cuni
    cuni c0 c0 cun wss c0 c0 cxp cuni cuni c0 wss cid c0 c0 cxp cuni cuni cres
    c0 c0 cxp wss c0 c0 cun c0 c0 c0 cxp cuni cuni sseq2 c0 c0 cxp cuni cuni c0
    wss c0 c0 cxp cuni cuni c0 wceq cid c0 c0 cxp cuni cuni cres c0 c0 cxp wss
    c0 c0 cxp cuni cuni ss0 c0 c0 cxp cuni cuni c0 wceq cid c0 c0 cxp cuni cuni
    cres c0 c0 cxp wss cid c0 cres c0 c0 cxp wss c0 c0 cid c0 cres wf1o cid c0
    cres c0 c0 cxp wss c0 f1oi c0 c0 cid c0 cres wf1o c0 c0 cid c0 cres wf cid
    c0 cres c0 c0 cxp wss c0 c0 cid c0 cres f1of c0 c0 cid c0 cres fssxp syl
    ax-mp c0 c0 cxp cuni cuni c0 wceq cid c0 c0 cxp cuni cuni cres cid c0 cres
    c0 c0 cxp c0 c0 cxp cuni cuni c0 cid reseq2 sseq1d mpbiri syl syl6bi mp2 cA
    c0 wceq cid cA cA cxp cuni cuni cres cid c0 c0 cxp cuni cuni cres cA cA cxp
    c0 c0 cxp cA c0 wceq cA cA cxp cuni cuni c0 c0 cxp cuni cuni wceq cid cA cA
    cxp cuni cuni cres cid c0 c0 cxp cuni cuni cres wceq cA c0 wceq cA cA cxp
    cuni c0 c0 cxp cuni cA c0 wceq cA cA cxp c0 c0 cxp cA c0 wceq cA cA cxp c0
    cA cxp c0 c0 cxp cA c0 cA xpeq1 cA c0 c0 xpeq2 eqtrd unieqd unieqd cA cA
    cxp cuni cuni c0 c0 cxp cuni cuni cid reseq2 syl cA c0 wceq cA cA cxp c0 cA
    cxp c0 c0 cxp cA c0 cA xpeq1 cA c0 c0 xpeq2 eqtrd sseq12d mpbiri cA c0 wne
    cA cA cxp cuni cuni cA wceq cid cA cA cxp cuni cuni cres cA cA cxp wss cA
    fldsqcp cA cA cxp cuni cuni cA wceq cid cA cA cxp cuni cuni cres cid cA
    cres wceq cid cA cA cxp cuni cuni cres cA cA cxp wss cA cA cxp cuni cuni cA
    cid reseq2 cid cA cA cxp cuni cuni cres cid cA cres wceq cid cA cA cxp cuni
    cuni cres cA cA cxp wss cid cA cres cA cA cxp wss cA cA cid cA cres wf1o
    cid cA cres cA cA cxp wss cA f1oi cA cA cid cA cres wf1o cA cA cid cA cres
    wf cid cA cres cA cA cxp wss cA cA cid cA cres f1of cA cA cid cA cres fssxp
    syl ax-mp cid cA cA cxp cuni cuni cres cid cA cres cA cA cxp sseq1 mpbiri
    syl syl pm2.61ine $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  $( A square cross product ` ( A X. A ) ` is reflexive. $)
  scprefat2 $p |- ( _I |` A ) C_ ( A X. A ) $=
    cid cA cres cA cA cxp wss cA c0 cid cA cres c0 wceq cA cA cxp c0 wceq cid
    cA cres cA cA cxp wss cA c0 wceq cid cA cres c0 wceq cA cA cxp c0 wceq wa
    cid cA cres cA cA cxp wss c0 c0 wss c0 ssid cid cA cres c0 cA cA cxp c0
    sseq12 mpbiri cA c0 wceq cid cA cres cid c0 cres c0 cA c0 cid reseq2 cid
    res0 syl6eq cA c0 wceq cA cA cxp c0 c0 cxp wceq cA cA cxp c0 wceq cA c0
    xpid11 cA cA cxp c0 c0 cxp wceq cA cA cxp c0 wceq c0 c0 cxp c0 cA cA cxp c0
    xp0r eqeq2i biimpi sylbir sylanc cA c0 wne cA cA cxp cuni cuni cA wceq cid
    cA cres cA cA cxp wss cA fldsqcp cA cA cxp cuni cuni cA wceq cid cA cA cxp
    cuni cuni cres cid cA cres wceq cid cA cres cA cA cxp wss cA cA cxp cuni
    cuni cA cid reseq2 cid cA cres cA cA cxp wss cid cA cres cid cA cA cxp cuni
    cuni cres cid cA cres cid cA cA cxp cuni cuni cres wceq cid cA cres cA cA
    cxp wss cid cA cA cxp cuni cuni cres cA cA cxp wss cA scprefat cid cA cres
    cid cA cA cxp cuni cuni cres cA cA cxp sseq1 mpbiri eqcoms syl syl
    pm2.61ine $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)


  $( A square cross product ` ( A X. A ) ` is symmetric. $)
  sqpsym $p |- `' ( A X. A ) C_ ( A X. A ) $=
    cA cA cxp ccnv cA cA cxp cA cA cnvxp eqimssi $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  $( A square cross product is an equivalence relation (in general
     it's not a poset). $)
  sqpeq $p |- Er ( A X. A ) $=
    cA cA cxp wer cA cA cxp ccnv cA cA cxp cA cA cxp ccom cun cA cA cxp wss cA
    cA cxp ccnv cA cA cxp wceq cA cA cxp cA cA cxp ccom cA cA cxp wss cA cA cxp
    ccnv cA cA cxp cA cA cxp ccom cun cA cA cxp wss cA cA cnvxp cA cpref cA cA
    cxp ccnv cA cA cxp wceq cA cA cxp ccnv cA cA cxp cA cA cxp ccom cun cA cA
    cxp ccnv cA cA cxp cun wss cA cA cxp ccnv cA cA cxp cA cA cxp ccom cun cA
    cA cxp wss cA cA cxp cA cA cxp ccom cA cA cxp wss cA cA cxp ccnv cA cA cxp
    wceq cA cA cxp ccnv cA cA cxp cun cA cA cxp cA cA cxp cun wceq cA cA cxp
    ccnv cA cA cxp cA cA cxp ccom cun cA cA cxp ccnv cA cA cxp cun wss cA cA
    cxp ccnv cA cA cxp cA cA cxp ccom cun cA cA cxp wss wi cA cA cxp ccnv cA cA
    cxp cA cA cxp uneq1 cA cA cxp ccnv cA cA cxp cun cA cA cxp cA cA cxp cun
    wceq cA cA cxp cA cA cxp cun cA cA cxp wceq cA cA cxp ccnv cA cA cxp cA cA
    cxp ccom cun cA cA cxp ccnv cA cA cxp cun wss cA cA cxp ccnv cA cA cxp cA
    cA cxp ccom cun cA cA cxp wss wi cA cA cxp unidm cA cA cxp ccnv cA cA cxp
    cun cA cA cxp cA cA cxp cun wceq cA cA cxp cA cA cxp cun cA cA cxp wceq wa
    cA cA cxp ccnv cA cA cxp cun cA cA cxp wceq cA cA cxp ccnv cA cA cxp cA cA
    cxp ccom cun cA cA cxp ccnv cA cA cxp cun wss cA cA cxp ccnv cA cA cxp cA
    cA cxp ccom cun cA cA cxp wss wi cA cA cxp ccnv cA cA cxp cun cA cA cxp cA
    cA cxp cun cA cA cxp eqtr cA cA cxp ccnv cA cA cxp cun cA cA cxp wceq cA cA
    cxp ccnv cA cA cxp cA cA cxp ccom cun cA cA cxp ccnv cA cA cxp cun wss cA
    cA cxp ccnv cA cA cxp cA cA cxp ccom cun cA cA cxp wss cA cA cxp ccnv cA cA
    cxp cun cA cA cxp cA cA cxp ccnv cA cA cxp cA cA cxp ccom cun sseq2 biimpd
    syl mpan2 syl cA cA cxp cA cA cxp ccom cA cA cxp cA cA cxp ccnv unss2 syl5
    mp2 cA cA cxp df-er mpbir $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  ${ $d R x y z $. $d S x y z $.
    $( The intersection of two transitive relations is transitive. $)
    inttr $p |- ( ( ( R o. R ) C_ R /\ ( S o. S ) C_ S )
      -> ( ( R i^i S ) o. ( R i^i S ) ) C_ ( R i^i S ) ) $=
      cR cR ccom cR wss cS cS ccom cS wss wa vx cv vy cv cR cS cin wbr vy cv vz
      cv cR cS cin wbr wa vx cv vz cv cR cS cin wbr wi vz wal vy wal vx wal cR
      cS cin cR cS cin ccom cR cS cin wss cR cR ccom cR wss cS cS ccom cS wss
      vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz cv cR cS
      cin wbr wi vz wal vy wal vx wal cR cR ccom cR wss vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal cS cS ccom
      cS wss vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz cv
      cR cS cin wbr wi vz wal vy wal vx wal wi vx vy vz cR cotr cS cS ccom cS
      wss vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal
      vy wal vx wal vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx
      cv vz cv cR cS cin wbr wi vz wal vy wal vx wal cS cS ccom cS wss vx cv vy
      cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vy wal vx
      wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal
      vy wal vx wal vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx
      cv vz cv cR cS cin wbr wi vz wal vy wal vx wal wi vx vy vz cS cotr vx cv
      vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vy wal vx
      wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal
      vy wal vx wal vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx
      cv vz cv cR cS cin wbr wi vz wal vy wal vx wal vx cv vy cv cS wbr vy cv
      vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vy wal vx wal vx cv vy cv cR
      wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx wal wa
      vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vy
      wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal
      vy wal wa vx wal vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa
      vx cv vz cv cR cS cin wbr wi vz wal vy wal vx wal vx cv vy cv cS wbr vy
      cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vy wal vx cv vy cv cR wbr
      vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal vx 19.26 vx cv
      vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vy wal vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy wal
      wa vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz cv cR
      cS cin wbr wi vz wal vy wal vx vx cv vy cv cS wbr vy cv vz cv cS wbr wa
      vx cv vz cv cS wbr wi vz wal vy wal vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vx cv vz cv cR wbr wi vz wal vy wal wa vx cv vy cv cS wbr vy cv vz cv
      cS wbr wa vx cv vz cv cS wbr wi vz wal vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa vx cv vz cv cR wbr wi vz wal wa vy wal vx cv vy cv cR cS cin wbr
      vy cv vz cv cR cS cin wbr wa vx cv vz cv cR cS cin wbr wi vz wal vy wal
      vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz wal vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal vy
      19.26 vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vz
      wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi vz wal
      wa vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz cv cR
      cS cin wbr wi vz wal vy vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz
      cv cS wbr wi vz wal vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv
      cR wbr wi vz wal wa vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv
      cS wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      wa vz wal vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz
      cv cR cS cin wbr wi vz wal vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv
      vz cv cS wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi vz 19.26 vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS
      wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa
      vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz cv cR cS
      cin wbr wi vz vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr
      wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx
      cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr wa vx cv vz cv cR wbr vx
      cv vz cv cS wbr wa vx cv vz cv cR cS cin wbr vx cv vy cv cR cS cin wbr vy
      cv vz cv cR cS cin wbr wa vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv
      vz cv cS wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi wa vx cv vz cv cR wbr vx cv vz cv cS wbr wa vx cv vy cv cR wbr vx
      cv vy cv cS wbr wa vy cv vz cv cR wbr vy cv vz cv cS wbr wa vx cv vy cv
      cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vx cv vy cv cR wbr vy
      cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx cv vz cv cR wbr vx cv vz
      cv cS wbr wa wi vx cv vy cv cR cS cin wbr vy cv vz cv cR cS cin wbr vx cv
      vy cv cR wbr vy cv vz cv cR wbr vx cv vy cv cS wbr vy cv vz cv cS wbr vx
      cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx cv vz cv cR wbr
      vx cv vz cv cS wbr wa wi vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv
      vz cv cS wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR
      wbr wi wa vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vy cv cS wbr vy
      cv vz cv cS wbr wa wa vx cv vz cv cR wbr vx cv vz cv cS wbr wa vx cv vy
      cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi vx cv vy cv cR wbr
      vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr vx cv vy cv cS wbr vy cv vz cv cS wbr
      wa vx cv vz cv cS wbr vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz
      cv cS wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi pm3.27 vx cv vy cv cS wbr vy cv vz cv cS wbr wa vx cv vz cv cS wbr wi
      vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi pm3.26
      anim12d com12 an4s vx cv vy cv cR cS int2rel vy cv vz cv cR cS int2rel
      syl2anb com12 vx cv vz cv cR cS int2rel syl6ibr 19.20i sylbir 19.20i
      sylbir 19.20i sylbir ex sylbi com12 sylbi imp vx vy vz cR cS cin cotr
      sylibr $.
      $( [3-Aug-2009] $) $( [31-Jul-2009] $)
  $}

  $( If a relation is transitive, its intersection with a square cross product
     is transitive. (taking the intersection of a relation with a square cross
     product is a way to restrict a relation to a subset of its field). $)
  tricptr $p |- ( ( R o. R ) C_ R ->
  ( ( R i^i ( A X. A ) ) o. ( R i^i ( A X. A ) ) ) C_ ( R i^i ( A X. A ) ) ) $=
    cR cR ccom cR wss cA cA cxp cA cA cxp ccom cA cA cxp wss cR cA cA cxp cin
    cR cA cA cxp cin ccom cR cA cA cxp cin wss cA cpref cR cA cA cxp inttr
    mpan2 $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)

  $( The members of a 'less than or equal' relationship are extended reals. $)
  mlteqer $p |- ( B e. C -> ( A <_ B -> ( A e. RR* /\ B e. RR* ) ) ) $=
    cA cB cle wbr cB cC wcel cA cxr wcel cB cxr wcel wa cA cB cle wbr cA cB cop
    cle wcel cB cC wcel cA cxr wcel cB cxr wcel wa wi cA cB cle df-br cA cB cop
    cle wcel cA cB cop cxr cxr cxp clt ccnv cdif wcel cB cC wcel cA cxr wcel cB
    cxr wcel wa wi cle cxr cxr cxp clt ccnv cdif cA cB cop df-le eleq2i cA cB
    cop cxr cxr cxp clt ccnv cdif wcel cA cB cop cxr cxr cxp wcel cA cB cop clt
    ccnv wcel wn wa cB cC wcel cA cxr wcel cB cxr wcel wa wi cA cB cop cxr cxr
    cxp clt ccnv eldif cA cB cop cxr cxr cxp wcel cB cC wcel cA cxr wcel cB cxr
    wcel wa wi cA cB cop clt ccnv wcel wn cB cC wcel cA cB cop cxr cxr cxp wcel
    cA cxr wcel cB cxr wcel wa cA cB cxr cxr cC opelxpg biimpcd adantr sylbi
    sylbi sylbi com12 $.
    $( [3-Aug-2009] $) $( [31-Jul-2009] $)


  $( Transitive law for ordering on extended reals ( compare ~ xrletr ). $)
  xrletr2 $p |- ( C e. D ->
             ( ( A <_ B /\ B <_ C ) -> A <_ C ) ) $=
    cA cB cle wbr cB cC cle wbr wa cC cD wcel cA cC cle wbr cB cC cle wbr cA cB
    cle wbr cC cD wcel cA cC cle wbr wi cB cC cle wbr cA cB cle wbr cC cD wcel
    cA cC cle wbr wi wi cC cD wcel cB cC cle wbr cB cC cle wbr cA cB cle wbr cA
    cC cle wbr cC cD wcel cB cC cle wbr cB cxr wcel cC cxr wcel wa cB cC cle
    wbr cA cB cle wbr cA cC cle wbr wi wi cB cC cD mlteqer cB cxr wcel cC cxr
    wcel cB cC cle wbr cA cB cle wbr cA cC cle wbr wi wi cA cB cle wbr cB cxr
    wcel cC cxr wcel cB cC cle wbr cA cC cle wbr cA cB cle wbr cB cxr wcel cC
    cxr wcel cB cC cle wbr cA cC cle wbr wi wi wi cB cxr wcel cA cB cle wbr cA
    cB cle wbr cC cxr wcel cB cC cle wbr cA cC cle wbr wi wi cB cxr wcel cA cB
    cle wbr cA cxr wcel cB cxr wcel wa cA cB cle wbr cC cxr wcel cB cC cle wbr
    cA cC cle wbr wi wi wi cA cB cxr mlteqer cA cxr wcel cB cxr wcel wa cC cxr
    wcel cA cB cle wbr cB cC cle wbr cA cC cle wbr wi cA cxr wcel cB cxr wcel
    cC cxr wcel cA cB cle wbr cB cC cle wbr cA cC cle wbr wi wi cA cxr wcel cB
    cxr wcel cC cxr wcel w3a cA cB cle wbr cB cC cle wbr cA cC cle wbr cA cB cC
    xrletr exp3a 3expia com23 syl6 com3l pm2.43i com4l imp syl6 com4l pm2.43i
    impcom com12 $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $( Trichotomy law. $)
  letri31 $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A = B <-> ( A <_ B /\ B <_ A ) ) ) $=
    cA cxr wcel cB cxr wcel wa cA cB wceq cB cA clt wbr wn cA cB clt wbr wn wa
    cA cB cle wbr cB cA cle wbr wa cA cxr wcel cB cxr wcel wa cA cB wceq cA cB
    clt wbr wn cB cA clt wbr wn wa cB cA clt wbr wn cA cB clt wbr wn wa cA cB
    xrlttri3 cB cA clt wbr wn cA cB clt wbr wn ancom syl6bbr cA cxr wcel cB cxr
    wcel wa cA cB cle wbr cB cA clt wbr wn cB cA cle wbr cA cB clt wbr wn cA cB
    xrlenlt cB cxr wcel cA cxr wcel cB cA cle wbr cA cB clt wbr wn wb cB cA
    xrlenlt ancoms anbi12d bitr4d $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  ${ $d x y $.
    $( domain of ` <_ ` is ` RR* ` . $)
    domleqt $p |- dom <_ = RR* $=
      cle cdm vx cv vy cv cle wbr vy wex vx cab cxr vx vy cle df-dm vx cv vy cv
      cle wbr vy wex vx cab cxr wceq vx cv vy cv cle wbr vy wex vx cv cxr wcel
      wb vx vx cv vy cv cle wbr vy wex vx cxr abeq1 vx cv vy cv cle wbr vy wex
      vx cv cxr wcel vx cv vy cv cle wbr vx cv cxr wcel vy vx cv vy cv cle wbr
      vx cv cxr wcel vy cv cxr wcel vy cv cvv wcel vx cv vy cv cle wbr vx cv
      cxr wcel vy cv cxr wcel wa wi vy visset vx cv vy cv cvv mlteqer ax-mp
      pm3.26d 19.23aiv vx cv cxr wcel vx cv vy cv cle wbr vy vx cv cxr wcel vx
      cv cpnf cle wbr wi vx cv cxr wcel vx cv vy cv cle wbr wi vy wex vx cv
      pnfge vx cv cxr wcel vx cv vy cv cle wbr wi vx cv cxr wcel vx cv cpnf cle
      wbr wi vy cpnf cpnf cxr pnfxr elisseti vy cv cpnf wceq vx cv vy cv cle
      wbr vx cv cpnf cle wbr vx cv cxr wcel vy cv cpnf vx cv cle breq2 imbi2d
      cla4ev ax-mp 19.37aiv impbii mpgbir eqtri $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

   $( The range of ` <_ ` is included in the extended reals. $)
   ranleqt $p |- ran <_ C_ RR* $=
     cle crn cxr cxr cxp clt ccnv cdif crn cxr cle cxr cxr cxp clt ccnv cdif
     df-le rneqi cxr cxr cxp clt ccnv cdif crn cxr cxr cxp crn cxr cxr cxr cxp
     clt ccnv cdif cxr cxr cxp wss cxr cxr cxp clt ccnv cdif crn cxr cxr cxp
     crn wss cxr cxr cxp clt ccnv difss cxr cxr cxp clt ccnv cdif cxr cxr cxp
     rnss ax-mp cxr c0 wne cxr cxr cxp crn cxr wceq cpnf cxr wcel cxr c0 wne
     pnfxr cxr cpnf ne0i ax-mp cxr cxr rnxp ax-mp sseqtri eqsstri $.
     $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $( 'Less or equal to' is a relation. $)
  leqrl $p |- Rel <_ $=
    cle wrel cxr cxr cxp clt ccnv cdif wrel cxr cxr cxp wrel cxr cxr cxp clt
    ccnv cdif wrel cxr cxr relxp cxr cxr cxp clt ccnv reldif ax-mp cle cxr cxr
    cxp clt ccnv cdif df-le releqi mpbir $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $( The field of the 'less or equal to' relationship on the extended real. $)
  fldleqt $p |- U. U. <_ = RR* $=
    cle cuni cuni cle cdm cle crn cun cxr cle wrel cle cuni cuni cle cdm cle
    crn cun wceq leqrl cle relfld ax-mp vx cle cdm cle crn cxr vx cv cle cdm
    wcel vx cv cle crn wcel wo vx cv cxr wcel vx cv cle cdm wcel vx cv cxr wcel
    vx cv cle crn wcel vx cv cle cdm wcel vx cv cxr wcel cle cdm cxr vx cv
    domleqt eleq2i biimpi cle crn cxr vx cv ranleqt sseli jaoi vx cv cxr wcel
    vx cv cle cdm wcel vx cv cle crn wcel vx cv cle cdm wcel vx cv cxr wcel cle
    cdm cxr vx cv domleqt eleq2i biimpri orcd impbii uneqri eqtri $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)


  ${ $d A x $. $d B x $.
  $( If an infinite set ` A ` is included in the underlying set of a finite
     cover ` B ` then there exists a set of the cover that contains an infinite
     number of element
  of ` A ` . $)
  isunscov $p |- ( ( -. A e. Fin /\ B e. Fin /\ A C_ U. B ) ->
    E. x e. B -. ( A i^i x ) e. Fin ) $=
    cA cfn wcel wn cB cfn wcel cA cB cuni wss w3a cA vx cv cin cfn wcel wn vx
    cB wrex cA cfn wcel wn cB cfn wcel cA cB cuni wss w3a cA vx cv cin cfn wcel
    vx cB wral cA vx cv cin cfn wcel wn vx cB wrex cA vx cv cin cfn wcel wn vx
    cB wrex wn cA cfn wcel wn cB cfn wcel cA cB cuni wss cA vx cv cin cfn wcel
    vx cB wral cA vx cv cin cfn wcel wn vx cB wrex wi cB cfn wcel cA cfn wcel
    wn cA cB cuni wss cA vx cv cin cfn wcel vx cB wral cA vx cv cin cfn wcel wn
    vx cB wrex wi wi cB cfn wcel cA vx cv cin cfn wcel vx cB wral cA cB cuni
    wss cA cfn wcel wn cA vx cv cin cfn wcel wn vx cB wrex cB cfn wcel cA vx cv
    cin cfn wcel vx cB wral cA cB cuni wss cA cfn wcel wn cA vx cv cin cfn wcel
    wn vx cB wrex wi wi cB cfn wcel cA vx cv cin cfn wcel vx cB wral wa vx cB
    cA vx cv cin ciun cfn wcel cA cB cuni wss cA cfn wcel wn cA vx cv cin cfn
    wcel wn vx cB wrex wi wi vx cB cA vx cv cin iunfi vx cB cA vx cv cin ciun
    cfn wcel cA vx cB vx cv ciun cin cfn wcel cA cB cuni wss cA cfn wcel wn cA
    vx cv cin cfn wcel wn vx cB wrex wi wi vx cB cA vx cv cin ciun cA vx cB vx
    cv ciun cin cfn vx cB cA vx cv iunin2 eleq1i cA vx cB vx cv ciun cin cfn
    wcel cA cB cuni cin cfn wcel cA cB cuni wss cA cfn wcel wn cA vx cv cin cfn
    wcel wn vx cB wrex wi wi cA vx cB vx cv ciun cin cA cB cuni cin cfn vx cB
    vx cv ciun cB cuni cA cB cuni vx cB vx cv ciun vx cB uniiun eqcomi ineq2i
    eleq1i cA cB cuni wss cA cB cuni cin cfn wcel cA cfn wcel wn cA vx cv cin
    cfn wcel wn vx cB wrex wi cA cB cuni wss cA cB cuni cin cA wceq cA cB cuni
    cin cfn wcel cA cfn wcel wn cA vx cv cin cfn wcel wn vx cB wrex wi wi cA cB
    cuni df-ss cA cB cuni cin cA wceq cA cB cuni cin cfn wcel cA cfn wcel cA
    cfn wcel wn cA vx cv cin cfn wcel wn vx cB wrex wi cA cB cuni cin cA cfn
    eleq1 cA cfn wcel cA vx cv cin cfn wcel wn vx cB wrex pm2.24 syl6bi sylbi
    com12 sylbi sylbi syl ex com24 com12 3imp cA vx cv cin cfn wcel vx cB
    dfral2 syl5ibr pm2.01bd $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  $( You can remove a class only once. $)
  remcon $p |- ( ( A \ B ) \ B ) = ( A \ B ) $=
    cA cB cB cun cdif cA cB cdif cB cdif cA cB cdif cA cB cB difun1 cB cB cun
    cB cA cB unidm difeq2i eqtr3i $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  ${ $d A f x $.
  $( ~ ac5 with the premisse transformed into an antecedent. $)
  ac5g $p |- ( A e. _V ->
     E. f ( f Fn A /\ A. x e. A ( x =/= (/) -> ( f ` x ) e. x ) ) ) $=
    cA cvv wcel vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx cA
    wral wa vf wex vf cv cA cvv wcel cA c0 cif wfn vx cv c0 wne vx cv vf cv cfv
    vx cv wcel wi vx cA cvv wcel cA c0 cif wral wa vf wex cA c0 cA cA cvv wcel
    cA c0 cif wceq vf cv cA wfn vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx
    cA wral wa vf cv cA cvv wcel cA c0 cif wfn vx cv c0 wne vx cv vf cv cfv vx
    cv wcel wi vx cA cvv wcel cA c0 cif wral wa vf cA cA cvv wcel cA c0 cif
    wceq vf cv cA wfn vf cv cA cvv wcel cA c0 cif wfn vx cv c0 wne vx cv vf cv
    cfv vx cv wcel wi vx cA wral vx cv c0 wne vx cv vf cv cfv vx cv wcel wi vx
    cA cvv wcel cA c0 cif wral cA cA cvv wcel cA c0 cif vf cv fneq2 vx cv c0
    wne vx cv vf cv cfv vx cv wcel wi vx cA cA cvv wcel cA c0 cif raleq1
    anbi12d exbidv vx cA cvv wcel cA c0 cif vf cA c0 cvv 0ex elimel ac5 dedth
    $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${ $d A x $. $d B x $. $d C x $. $d F x $. $d H x $. $d K x $.
    $( An injection is left-cancelable. $)
    njtlc $p |- ( ( F : B -1-1-> C /\ H : A --> B /\ K : A --> B ) ->
      ( ( F o. H ) = ( F o. K ) -> H = K ) ) $=
      cB cC cF wf1 cA cB cH wf cA cB cK wf w3a cA cA wceq vx cv cF cH ccom cfv
      vx cv cF cK ccom cfv wceq vx cA wral wa cA cA wceq vx cv cH cfv vx cv cK
      cfv wceq vx cA wral wa cF cH ccom cF cK ccom wceq cH cK wceq cB cC cF wf1
      cA cB cH wf cA cB cK wf w3a vx cv cF cH ccom cfv vx cv cF cK ccom cfv
      wceq vx cA wral vx cv cH cfv vx cv cK cfv wceq vx cA wral cA cA wceq cB
      cC cF wf1 cA cB cH wf cA cB cK wf w3a vx cv cF cH ccom cfv vx cv cF cK
      ccom cfv wceq vx cv cH cfv vx cv cK cfv wceq vx cA cB cC cF wf1 cA cB cH
      wf cA cB cK wf w3a vx cv cA wcel wa vx cv cF cH ccom cfv vx cv cF cK ccom
      cfv wceq vx cv cH cfv cF cfv vx cv cK cfv cF cfv wceq vx cv cH cfv vx cv
      cK cfv wceq cB cC cF wf1 cA cB cH wf cA cB cK wf w3a vx cv cA wcel wa vx
      cv cF cH ccom cfv vx cv cH cfv cF cfv vx cv cF cK ccom cfv vx cv cK cfv
      cF cfv cF wfun cA cB cH wf vx cv cA wcel vx cv cF cH ccom cfv vx cv cH
      cfv cF cfv wceq cB cC cF wf1 cA cB cH wf cA cB cK wf w3a vx cv cA wcel wa
      cA cB vx cv cF cH fvco3 cB cC cF wf1 cA cB cH wf cA cB cK wf w3a cF wfun
      vx cv cA wcel cB cC cF wf1 cA cB cH wf cF wfun cA cB cK wf cB cC cF wf1
      cB cC cF wf cF wfun cB cC cF f1f cB cC cF ffun syl 3ad2ant1 adantr cB cC
      cF wf1 cA cB cH wf cA cB cK wf w3a cA cB cH wf vx cv cA wcel cB cC cF wf1
      cA cB cH wf cA cB cK wf 3simp2 adantr cB cC cF wf1 cA cB cH wf cA cB cK
      wf w3a vx cv cA wcel pm3.27 syl3anc cF wfun cA cB cK wf vx cv cA wcel vx
      cv cF cK ccom cfv vx cv cK cfv cF cfv wceq cB cC cF wf1 cA cB cH wf cA cB
      cK wf w3a vx cv cA wcel wa cA cB vx cv cF cK fvco3 cB cC cF wf1 cA cB cH
      wf cA cB cK wf w3a cF wfun vx cv cA wcel cB cC cF wf1 cA cB cH wf cF wfun
      cA cB cK wf cB cC cF wf1 cB cC cF wf cF wfun cB cC cF f1f cB cC cF ffun
      syl 3ad2ant1 adantr cB cC cF wf1 cA cB cH wf cA cB cK wf w3a cA cB cK wf
      vx cv cA wcel cB cC cF wf1 cA cB cH wf cA cB cK wf 3simp3 adantr cB cC cF
      wf1 cA cB cH wf cA cB cK wf w3a vx cv cA wcel pm3.27 syl3anc eqeq12d cB
      cC cF wf1 vx cv cH cfv cB wcel vx cv cK cfv cB wcel wa vx cv cH cfv cF
      cfv vx cv cK cfv cF cfv wceq vx cv cH cfv vx cv cK cfv wceq wi cB cC cF
      wf1 cA cB cH wf cA cB cK wf w3a vx cv cA wcel wa cB cC cF wf1 vx cv cH
      cfv cB wcel vx cv cK cfv cB wcel wa wa vx cv cH cfv cF cfv vx cv cK cfv
      cF cfv wceq vx cv cH cfv vx cv cK cfv wceq cB cC vx cv cH cfv vx cv cK
      cfv cF f1fveq biimpd cB cC cF wf1 cA cB cH wf cA cB cK wf w3a cB cC cF
      wf1 vx cv cA wcel cB cC cF wf1 cA cB cH wf cA cB cK wf 3simp1 adantr cB
      cC cF wf1 cA cB cH wf cA cB cK wf w3a vx cv cA wcel wa vx cv cH cfv cB
      wcel vx cv cK cfv cB wcel cA cB cH wf cB cC cF wf1 vx cv cA wcel vx cv cH
      cfv cB wcel cA cB cK wf cA cB vx cv cH ffvelrn 3ad2antl2 cA cB cK wf cB
      cC cF wf1 vx cv cA wcel vx cv cK cfv cB wcel cA cB cH wf cA cB vx cv cK
      ffvelrn 3ad2antl3 jca sylanc sylbid r19.20dva anim2d cF cH ccom cA wfn cF
      cK ccom cA wfn cF cH ccom cF cK ccom wceq cA cA wceq vx cv cF cH ccom cfv
      vx cv cF cK ccom cfv wceq vx cA wral wa wb cB cC cF wf1 cA cB cH wf cA cB
      cK wf w3a vx cA cA cF cH ccom cF cK ccom eqfnfv cB cC cF wf1 cA cB cH wf
      cF cH ccom cA wfn cA cB cK wf cB cC cF wf1 cA cB cH wf cF cH ccom cA wfn
      cB cC cF wf1 cB cC cF wf cF cB wfn cA cB cH wf cF cH ccom cA wfn wi cB cC
      cF f1f cB cC cF ffn cF cB wfn cA cB cH wf cF cH ccom cA wfn cB cA cF cH
      fnfco ex 3syl imp 3adant3 cB cC cF wf1 cA cB cK wf cF cK ccom cA wfn cA
      cB cH wf cB cC cF wf1 cA cB cK wf cF cK ccom cA wfn cB cC cF wf1 cB cC cF
      wf cF cB wfn cA cB cK wf cF cK ccom cA wfn wi cB cC cF f1f cB cC cF ffn
      cF cB wfn cA cB cK wf cF cK ccom cA wfn cB cA cF cK fnfco ex 3syl imp
      3adant2 sylanc cB cC cF wf1 cA cB cH wf cA cB cK wf w3a cH cA wfn cK cA
      wfn wa cH cK wceq cA cA wceq vx cv cH cfv vx cv cK cfv wceq vx cA wral wa
      wb cA cB cH wf cA cB cK wf cH cA wfn cK cA wfn wa cB cC cF wf1 cA cB cH
      wf cH cA wfn cA cB cK wf cK cA wfn cA cB cH ffn cA cB cK ffn anim12i
      3adant1 vx cA cA cH cK eqfnfv syl 3imtr4d $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${ $d A x y $.
  $( Restriction of the identity to a singleton. $)
  restidsing $p |- ( _I |` { A } ) = ( { A } X. { A } ) $=
    vx vy cid cA csn cres cA csn cA csn cxp cid cA csn relres cA csn cA csn
    relxp vx cv vy cv cop cid wcel vx cv cA csn wcel wa vx cv cA csn wcel vy cv
    cA csn wcel wa vx cv vy cv cop cid cA csn cres wcel vx cv vy cv cop cA csn
    cA csn cxp wcel vx cv vy cv cop cid wcel vx cv cA csn wcel wa vx cv vy cv
    cid wbr vx cv cA csn wcel wa vx cv cA csn wcel vy cv cA csn wcel wa vx cv
    vy cv cop cid wcel vx cv vy cv cid wbr vx cv cA csn wcel vx cv vy cv cid
    wbr vx cv vy cv cop cid wcel vx cv vy cv cid df-br bicomi anbi1i vx cv vy
    cv cid wbr vx cv cA csn wcel wa vx cv cA csn wcel vy cv cA csn wcel wa vx
    cv vy cv cid wbr vx cv cA csn wcel wa vx cv cA csn wcel vy cv cA csn wcel
    vx cv vy cv cid wbr vx cv cA csn wcel pm3.27 vx cv vy cv cid wbr vx cv cA
    csn wcel vy cv cA csn wcel vx cv vy cv cid wbr vx cv cA wceq vy cv cA csn
    wcel vx cv cA csn wcel vx cv vy cv cid wbr vx vy weq vx cv cA wceq vy cv cA
    csn wcel wi vy cv cvv wcel vx cv vy cv cid wbr vx vy weq wi vy visset vy cv
    cvv wcel vx cv vy cv cid wbr vx vy weq vx cv vy cv cvv ideqg biimpd ax-mp
    vx vy weq vx cv cA wceq vy cv cA wceq vy cv cA csn wcel vx vy weq vx cv cA
    wceq vy cv cA wceq vx cv vy cv cA eqtr2 ex vy cA elsn syl6ibr syl vx cA
    elsn syl5ib imp jca vx cv cA csn wcel vy cv cA csn wcel wa vx cv vy cv cid
    wbr vx cv cA csn wcel vx cv cA csn wcel vy cv cA csn wcel vx cv vy cv cid
    wbr vx cv cA csn wcel vx cv cA wceq vy cv cA csn wcel vx cv vy cv cid wbr
    wi vx cA elsn vy cv cA csn wcel vx cv cA wceq vx cv vy cv cid wbr vy cv cA
    csn wcel vy cv cA wceq vx cv cA wceq vx cv vy cv cid wbr wi vy cA elsn vy
    cv cA wceq vx cv cA wceq vx cv vy cv cid wbr vy cv cA wceq vx cv cA wceq wa
    vy vx weq vx cv vy cv cid wbr vy cv vx cv cA eqtr3 vx cv vy cv cid wbr vx
    vy weq vy vx weq vx cv vy cv vy visset ideq vx vy equcom bitri sylibr ex
    sylbi com12 sylbi imp vx cv cA csn wcel vy cv cA csn wcel pm3.26 jca impbii
    bitri vx cv vy cv cid cA csn vy visset opelres vx cv vy cv cA csn cA csn vy
    visset opelxp 3bitr4i eqrelriv $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  $( The intersection of the identity function with a square cross
     product. $)
  residcp $p |- ( _I i^i ( A X. A ) ) = ( _I |` A ) $=
    cid cA cA cxp cin cid cA cres cid cA cA cxp cin cid cA cvv cxp cin cid cA
    cres cA cA cxp cA cvv cxp wss cid cA cA cxp cin cid cA cvv cxp cin wss cA
    cA wss cA cvv wss cA cA cxp cA cvv cxp wss cA ssid cA ssv cA cA cA cvv ssxp
    mp2an cA cA cxp cA cvv cxp cid sslin ax-mp cid cA df-res sseqtr4i cid cA
    cres cid cA cA cxp cid cA resss cA scprefat2 ssini eqssi $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

   $( Image under a restricted class. $)
   imrescl $p |- ( A C_ B -> ( ( C |` B ) " A ) = ( C " A ) ) $=
     cA cB wss cC cB cres cA cima cC cB cres cA cres crn cC cB cA cin cres crn
     cC cA cima cC cB cres cA cima cC cB cres cA cres crn wceq cA cB wss cC cB
     cres cA df-ima a1i cC cB cres cA cres crn cC cB cA cin cres crn wceq cA cB
     wss cC cB cres cA cres cC cB cA cin cres cC cB cA resres rneqi a1i cA cB
     wss cA cB cin cA wceq cC cB cA cin cres crn cC cA cima wceq cA cB df-ss cA
     cB cin cA wceq cC cB cA cin cres crn cC cA cB cin cres crn cC cA cres crn
     cC cA cima cA cB cin cA wceq cC cB cA cin cres cC cA cB cin cres cA cB cin
     cA wceq cB cA cin cA cB cin wceq cC cB cA cin cres cC cA cB cin cres wceq
     cB cA cin cA cB cin wceq cA cB cin cA wceq cB cA incom a1i cB cA cin cA cB
     cin cC reseq2 syl rneqd cA cB cin cA wceq cC cA cB cin cres cC cA cres cA
     cB cin cA cC reseq2 rneqd cC cA cres crn cC cA cima wceq cA cB cin cA wceq
     cC cA cima cC cA cres crn cC cA df-ima eqcomi a1i 3eqtrd sylbi 3eqtrd $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)


  ${ $d R x y $.
    $( Two ways of saying a relation is symmetric. $)
    twsymr $p |- ( Rel R -> ( R = `' R <-> A. x A. y ( x R y -> y R x ) ) ) $=
      cR wrel cR cR ccnv wss cR ccnv cR wss wa vx cv vy cv cR wbr vy cv vx cv
      cR wbr wi vy wal vx wal cR cR ccnv wceq cR wrel cR cR ccnv wss cR ccnv cR
      wss wa vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal cR cR ccnv
      wss cR ccnv cR wss wa cR wrel vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy
      wal vx wal cR ccnv cR wss cR wrel vx cv vy cv cR wbr vy cv vx cv cR wbr
      wi vy wal vx wal wi cR cR ccnv wss cR ccnv cR wss vx cv vy cv cR wbr vy
      cv vx cv cR wbr wi vy wal vx wal cR wrel cR ccnv cR wss vx cv vy cv cR
      wbr vy cv vx cv cR wbr wi vy wal vx wal vx vy cR cnvsym biimpi a1d adantl
      com12 cR wrel vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal cR
      cR ccnv wss cR ccnv cR wss wa cR wrel vx cv vy cv cR wbr vy cv vx cv cR
      wbr wi vy wal vx wal wa cR cR ccnv wss cR ccnv cR wss cR wrel vx cv vy cv
      cR wbr vy cv vx cv cR wbr wi vy wal vx wal cR cR ccnv wss cR wrel cR ccnv
      ccnv cR wceq vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx wal cR cR
      ccnv wss wi cR dfrel2 vx cv vy cv cR wbr vy cv vx cv cR wbr wi vy wal vx
      wal cR ccnv ccnv cR wceq cR cR ccnv wss vx cv vy cv cR wbr vy cv vx cv cR
      wbr wi vy wal vx wal cR ccnv cR wss cR ccnv ccnv cR wceq cR cR ccnv wss
      wi vx vy cR cnvsym cR ccnv ccnv cR wceq cR ccnv ccnv cR ccnv wss cR cR
      ccnv wss cR ccnv cR wss cR ccnv ccnv cR cR ccnv sseq1 cR ccnv cR cnvss
      syl5cbi sylbir com12 sylbi imp vx cv vy cv cR wbr vy cv vx cv cR wbr wi
      vy wal vx wal cR ccnv cR wss cR wrel cR ccnv cR wss vx cv vy cv cR wbr vy
      cv vx cv cR wbr wi vy wal vx wal vx vy cR cnvsym biimpri adantl jca ex
      impbid cR cR ccnv eqss syl5bb $.
      $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}


  ${ $d R u y z $. $d R x y z $.
  $( Note: I suspect ` Rel R ` is useless ` . $)
  $( Projection of the first elements of the pairs of a class ` A ` . $)
  prj1 $p |- ( Rel R -> ( ( 1st |` ( _V X. _V ) ) " R ) =
    { x | E. y <. x , y >. e. R } ) $=
    cR wrel vz c1st cvv cvv cxp cres cR cima vx cv vy cv cop cR wcel vy wex vx
    cab cR wrel vu cv vz cv c1st cvv cvv cxp cres wbr vu cR wrex vz cv vy cv
    cop cR wcel vy wex vz cv c1st cvv cvv cxp cres cR cima wcel vz cv vx cv vy
    cv cop cR wcel vy wex vx cab wcel cR wrel vu cv vz cv c1st cvv cvv cxp cres
    wbr vu cR wrex vz cv vy cv cop cR wcel vy wex vu cv vz cv c1st cvv cvv cxp
    cres wbr vu cR wrex cR wrel vz cv vy cv cop cR wcel vy wex vu cv vz cv c1st
    cvv cvv cxp cres wbr cR wrel vz cv vy cv cop cR wcel vy wex wi vu cR vu cv
    cR wcel vu cv vz cv c1st cvv cvv cxp cres wbr cR wrel vz cv vu cv c2nd cfv
    cop cR wcel vz cv vy cv cop cR wcel vy wex vu cv cR wcel vu cv vz cv c1st
    cvv cvv cxp cres wbr cR wrel vz cv vu cv c2nd cfv cop cR wcel wi wi cR wrel
    vu cv cR wcel vu cv vz cv c1st cvv cvv cxp cres wbr vu cv cR wcel vz cv vu
    cv c2nd cfv cop cR wcel cR wrel cR cvv cvv cxp wss vu cv cR wcel vu cv vz
    cv c1st cvv cvv cxp cres wbr vu cv cR wcel vz cv vu cv c2nd cfv cop cR wcel
    wi wi wi cR df-rel cR cvv cvv cxp wss vu cv cR wcel vu cv cvv cvv cxp wcel
    vu cv vz cv c1st cvv cvv cxp cres wbr vu cv cR wcel vz cv vu cv c2nd cfv
    cop cR wcel wi wi cR cvv cvv cxp vu cv ssel vu cv cvv cvv cxp wcel vu cv vz
    cv c1st cvv cvv cxp cres wbr vu cv cR wcel vz cv vu cv c2nd cfv cop cR wcel
    wi wi vu cv cvv cvv cxp wcel vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq
    vu cv c1st cfv cvv wcel vu cv c2nd cfv cvv wcel wa wa vu cv cvv cvv cxp
    wcel vu cv vz cv c1st cvv cvv cxp cres wbr vu cv cR wcel vz cv vu cv c2nd
    cfv cop cR wcel wi wi wi vu cv cvv cvv elxp6 vu cv vu cv c1st cfv vu cv
    c2nd cfv cop wceq vu cv c1st cfv cvv wcel vu cv c2nd cfv cvv wcel wa wa vu
    cv cR wcel vu cv vz cv c1st cvv cvv cxp cres wbr vu cv cvv cvv cxp wcel vz
    cv vu cv c2nd cfv cop cR wcel vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq
    vu cv c1st cfv cvv wcel vu cv c2nd cfv cvv wcel wa vu cv cR wcel vu cv vz
    cv c1st cvv cvv cxp cres wbr vu cv cvv cvv cxp wcel vz cv vu cv c2nd cfv
    cop cR wcel wi wi wi vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv cR
    wcel vu cv c1st cfv cvv wcel vu cv c2nd cfv cvv wcel wa vu cv vz cv c1st
    cvv cvv cxp cres wbr vu cv cvv cvv cxp wcel vz cv vu cv c2nd cfv cop cR
    wcel wi wi vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv cR wcel vu cv
    c1st cfv vu cv c2nd cfv cop cR wcel vu cv c1st cfv cvv wcel vu cv c2nd cfv
    cvv wcel wa vu cv vz cv c1st cvv cvv cxp cres wbr vu cv cvv cvv cxp wcel vz
    cv vu cv c2nd cfv cop cR wcel wi wi wi vu cv vu cv c1st cfv vu cv c2nd cfv
    cop cR eleq1 vu cv vz cv c1st cvv cvv cxp cres wbr vu cv c1st cfv cvv wcel
    vu cv c2nd cfv cvv wcel wa vu cv c1st cfv vu cv c2nd cfv cop cR wcel vu cv
    cvv cvv cxp wcel vz cv vu cv c2nd cfv cop cR wcel wi vu cv vz cv c1st cvv
    cvv cxp cres wbr vu cv c1st cvv cvv cxp cres cfv vz cv wceq vu cv c1st cfv
    cvv wcel vu cv c2nd cfv cvv wcel wa vu cv c1st cfv vu cv c2nd cfv cop cR
    wcel vu cv cvv cvv cxp wcel vz cv vu cv c2nd cfv cop cR wcel wi wi wi c1st
    cvv cvv cxp cres wfun vu cv vz cv c1st cvv cvv cxp cres wbr vu cv c1st cvv
    cvv cxp cres cfv vz cv wceq wi c1st wfun c1st cvv cvv cxp cres wfun cvv cvv
    c1st wfo c1st wfun fo1st cvv cvv c1st fofun ax-mp cvv cvv cxp c1st funres
    ax-mp vu cv vz cv c1st cvv cvv cxp cres vz visset funbrfv ax-mp vu cv cvv
    cvv cxp wcel vu cv c1st cvv cvv cxp cres cfv vz cv wceq vu cv c1st cfv cvv
    wcel vu cv c2nd cfv cvv wcel wa vu cv c1st cfv vu cv c2nd cfv cop cR wcel
    vz cv vu cv c2nd cfv cop cR wcel vu cv cvv cvv cxp wcel vu cv c1st cvv cvv
    cxp cres cfv vu cv c1st cfv wceq vu cv c1st cvv cvv cxp cres cfv vz cv wceq
    vu cv c1st cfv cvv wcel vu cv c2nd cfv cvv wcel wa vu cv c1st cfv vu cv
    c2nd cfv cop cR wcel vz cv vu cv c2nd cfv cop cR wcel wi wi wi vu cv cvv
    cvv cxp c1st fvres vu cv c1st cvv cvv cxp cres cfv vu cv c1st cfv wceq vu
    cv c1st cvv cvv cxp cres cfv vz cv wceq vu cv c1st cfv vz cv wceq vu cv
    c1st cfv cvv wcel vu cv c2nd cfv cvv wcel wa vu cv c1st cfv vu cv c2nd cfv
    cop cR wcel vz cv vu cv c2nd cfv cop cR wcel wi wi vu cv c1st cvv cvv cxp
    cres cfv vu cv c1st cfv wceq vu cv c1st cvv cvv cxp cres cfv vz cv wceq vu
    cv c1st cfv vz cv wceq vu cv c1st cvv cvv cxp cres cfv vu cv c1st cfv vz cv
    eqtr2 ex vu cv c1st cfv vz cv wceq vu cv c1st cfv vu cv c2nd cfv cop cR
    wcel vz cv vu cv c2nd cfv cop cR wcel wi vu cv c1st cfv cvv wcel vu cv c2nd
    cfv cvv wcel wa vu cv c1st cfv vz cv wceq vu cv c1st cfv vu cv c2nd cfv cop
    cR wcel vz cv vu cv c2nd cfv cop cR wcel vu cv c1st cfv vz cv wceq vu cv
    c1st cfv vu cv c2nd cfv cop vz cv vu cv c2nd cfv cop cR vu cv c1st cfv vz
    cv vu cv c2nd cfv opeq1 eleq1d biimpd a1d syl6 syl com4l syl com13 syl6bi
    com23 imp com24 sylbi pm2.43i syl6 sylbi com14 pm2.43i vz cv vy cv cop cR
    wcel vz cv vu cv c2nd cfv cop cR wcel vy vu cv c2nd cfv vu cv c2nd fvex vy
    cv vu cv c2nd cfv wceq vz cv vy cv cop vz cv vu cv c2nd cfv cop cR vy cv vu
    cv c2nd cfv vz cv opeq2 eleq1d cla4ev syl8 r19.23aiv com12 vz cv vy cv cop
    cR wcel vu cv vz cv c1st cvv cvv cxp cres wbr vu cR wrex vy vz cv vy cv cop
    cR wcel vz cv vy cv cop vz cv c1st cvv cvv cxp cres wbr vu cv vz cv c1st
    cvv cvv cxp cres wbr vu cR wrex vz cv vy cv cop vz cv c1st cvv cvv cxp cres
    wbr vz cv vy cv cop vz cv cop c1st cvv cvv cxp cres wcel vz cv vy cv c1st
    cvv cvv cxp cres co vz cv wceq vz cv vy cv cop vz cv cop c1st cvv cvv cxp
    cres wcel vz cv vy cv c1st cvv cvv cxp cres co vz cv vy cv cop c1st cvv cvv
    cxp cres cfv vz cv vy cv cop c1st cfv vz cv vz cv vy cv c1st cvv cvv cxp
    cres df-opr vz cv vy cv cop cvv cvv cxp wcel vz cv vy cv cop c1st cvv cvv
    cxp cres cfv vz cv vy cv cop c1st cfv wceq vz cv vy cv cop cvv cvv cxp wcel
    vz cv cvv wcel vy cv cvv wcel vz cv vy cv cvv cvv vy visset opelxp vz
    visset vy visset mpbir2an vz cv vy cv cop cvv cvv cxp c1st fvres ax-mp vz
    cv vy cv vz visset op1st 3eqtri c1st cvv cvv cxp cres cvv cvv cxp wfn vz cv
    cvv wcel vy cv cvv wcel vz cv vy cv c1st cvv cvv cxp cres co vz cv wceq vz
    cv vy cv cop vz cv cop c1st cvv cvv cxp cres wcel wb c1st cvv cvv cxp cres
    cvv cvv cxp wfn cvv cvv cxp cvv wss cvv cvv cxp ssv c1st cvv wfn c1st cvv
    cvv cxp cres cvv cvv cxp wfn cvv cvv cxp cvv wss wb cvv cvv c1st wfo c1st
    cvv wfn fo1st cvv cvv c1st fofn ax-mp cvv cvv cvv cxp c1st fnssresb ax-mp
    mpbir vz visset vy visset cvv cvv vz cv vy cv vz cv c1st cvv cvv cxp cres
    vz visset fnotoprb mp3an mpbi vz cv vy cv cop vz cv c1st cvv cvv cxp cres
    df-br mpbir vu cv vz cv c1st cvv cvv cxp cres wbr vz cv vy cv cop vz cv
    c1st cvv cvv cxp cres wbr vu vz cv vy cv cop cR vu cv vz cv vy cv cop vz cv
    c1st cvv cvv cxp cres breq1 rcla4ev mpan2 19.23aiv impbid1 vu vz cv c1st
    cvv cvv cxp cres cR vz visset elima vx cv vy cv cop cR wcel vy wex vz cv vy
    cv cop cR wcel vy wex vx vz cv vz visset vx vz weq vx cv vy cv cop cR wcel
    vz cv vy cv cop cR wcel vy vx vz weq vx cv vy cv cop vz cv vy cv cop cR vx
    cv vz cv vy cv opeq1 eleq1d exbidv elab 3bitr4g eqrdv $.
    $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}

  ${ $d A x $.
   $( The image under ` 1st ` of a class with no pairs inside. $)
   imfstnrelc $p |- ( ( ( A i^i ( _V X. _V ) ) = (/) /\ A =/= (/) )
   -> ( 1st " A ) = { (/) } ) $=
     cA cvv cvv cxp cin c0 wceq cA c0 wne wa c1st cA cima vx cA vx cv c1st cfv
     csn ciun vx cA c0 csn ciun c0 csn cA cvv cvv cxp cin c0 wceq cA c0 wne wa
     c1st wfun cA c1st cdm wss wa c1st cA cima vx cA vx cv c1st cfv csn ciun
     wceq c1st wfun cA c1st cdm wss wa cA cvv cvv cxp cin c0 wceq cA c0 wne wa
     c1st wfun cA c1st cdm wss cvv cvv c1st wfo c1st wfun fo1st cvv cvv c1st
     fofun ax-mp cA cvv c1st cdm cA ssv c1st cvv wfn c1st cdm cvv wceq cvv cvv
     c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp cvv c1st fndm ax-mp
     sseqtr4i pm3.2i a1i vx cA c1st dfimafn2 syl cA cvv cvv cxp cin c0 wceq cA
     c0 wne wa vx cA vx cv c1st cfv csn c0 csn cA cvv cvv cxp cin c0 wceq cA c0
     wne wa vx cv cA wcel wa vx cv c1st cfv c0 cA cvv cvv cxp cin c0 wceq cA c0
     wne wa vx cv cA wcel wa vx cv csn cdm cuni c0 vx cv c1st cfv cA cvv cvv
     cxp cin c0 wceq cA c0 wne wa vx cv cA wcel wa vx cv csn cdm c0 csn wss vx
     cv csn cdm cuni c0 wceq cA cvv cvv cxp cin c0 wceq cA c0 wne wa vx cv cA
     wcel wa vx cv cvv cvv cxp wcel wn vx cv csn cdm c0 csn wss cA cvv cvv cxp
     cin c0 wceq cA c0 wne wa vx cv cA wcel vx cv cvv cvv cxp wcel wn cA cvv
     cvv cxp cin c0 wceq vx cv cA wcel vx cv cvv cvv cxp wcel wn wi cA c0 wne
     cA cvv cvv cxp cin c0 wceq vx cv cA wcel vx cv cvv cvv cxp wcel wn wi vx
     cA cvv cvv cxp cin c0 wceq vx cv cvv cvv cxp wcel wn vx cA wral vx cv cA
     wcel vx cv cvv cvv cxp wcel wn wi vx wal cA cvv cvv cxp cin c0 wceq vx cv
     cvv cvv cxp wcel wn vx cA wral vx cA cvv cvv cxp disj biimpi vx cv cvv cvv
     cxp wcel wn vx cA df-ral sylib 19.21bi adantr imp vx cv cvv cvv cxp wcel
     wn vx cv csn cdm c0 wceq vx cv csn cdm c0 csn wss vx cv cvv cvv cxp wcel
     vx cv csn cdm c0 vx cv cvv cvv cxp wcel vx cv csn cdm c0 wne vx cv dmsnn0
     bicomi necon1bbii vx cv csn cdm c0 wceq vx cv csn cdm c0 csn wss c0 c0 csn
     wss c0 csn 0ss vx cv csn cdm c0 c0 csn sseq1 mpbiri sylbi syl vx cv csn
     cdm uni0b sylibr vx cv 1stval syl5eq sneqd iuneq2dv cA c0 wne vx cA c0 csn
     ciun c0 csn wceq cA cvv cvv cxp cin c0 wceq vx cA c0 csn iunconst adantl
     3eqtrd $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}


 ${ $d R x y $.
  $( Projection of the first elements of the pairs of a relation ` R ` . $)
  prj1b $p |- ( Rel R -> ( 1st " R ) = { x | E. y <. x , y >. e. R } ) $=
    cR wrel c1st cR cima c1st cvv cvv cxp cres cR cima vx cv vy cv cop cR wcel
    vy wex vx cab cR wrel cR cvv cvv cxp wss c1st cR cima c1st cvv cvv cxp cres
    cR cima wceq cR df-rel cR cvv cvv cxp wss c1st cvv cvv cxp cres cR cima
    c1st cR cima cR cvv cvv cxp c1st imrescl eqcomd sylbi vx vy cR prj1 eqtrd
    $.
    $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}

  ${ $d R x y $.
  $( The projection of the first elements of the pairs of a relation ` R `
     is its domain. $)
  prjdmn $p |- ( Rel R -> ( 1st " R ) = dom R ) $=
    cR wrel c1st cR cima vx cv vy cv cop cR wcel vy wex vx cab cR cdm vx vy cR
    prj1b vx vy cR dfdm3 syl6eqr $.
    $( [6-Oct-2009] $) $( [5-Oct-2009] $)
  $}

  $( Projection of a cross product. $)
  prjcp1 $p |- ( B =/= (/) -> ( 1st " ( A X. B ) ) = A ) $=
    cB c0 wne c1st cA cB cxp cima cA cB cxp cdm cA cA cB cxp wrel cB c0 wne
    c1st cA cB cxp cima cA cB cxp cdm wceq wi cA cB relxp cA cB cxp wrel c1st
    cA cB cxp cima cA cB cxp cdm wceq cB c0 wne cA cB cxp prjdmn a1d ax-mp cA
    cB dmxp eqtrd $.
    $( [6-Oct-2009] $) $( [5-Oct-2009] $)

  $( Equality theorem for cross product. $)
  xpeq12 $p |- ( ( A = B /\ C = D ) -> ( A X. C ) = ( B X. D ) ) $=
    cA cB wceq cC cD wceq cA cC cxp cB cC cxp cB cD cxp cA cB cC xpeq1 cC cD cB
    xpeq2 sylan9eq $.
    $( [7-Sep-2009] $) $( [31-Aug-2009] $)

  $( Equality theorem for class difference. $)
  difeq12 $p |- ( ( A = B /\ C = D ) -> ( A \ C ) = ( B \ D ) ) $=
    cA cB wceq cC cD wceq cA cC cdif cB cC cdif cB cD cdif cA cB cC difeq1 cC
    cD cB difeq2 sylan9eq $.
    $( [7-Sep-2009] $) $( [31-Aug-2009] $)

  ${
    xpeq12i.1 $e |- A = B $.
    xpeq12i.2 $e |- C = D $.
    $( Equality theorem for cross product. $)
    xpeq12i $p |- ( A X. C ) = ( B X. D ) $=
      cA cB wceq cC cD wceq cA cC cxp cB cD cxp wceq xpeq12i.1 xpeq12i.2 cA cB
      cC cD xpeq12 mp2an $.
      $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}

  ${ $d A v w x y z $.  $d ph x $.  $d ta v w y z $.
    eloi.1 $e |- ( y = ( 1st ` ( 1st ` A ) ) -> ( ph <-> ps ) ) $.
    eloi.2 $e |- ( z = ( 2nd ` ( 1st ` A ) ) -> ( ps <-> ch ) ) $.
    eloi.3 $e |- ( v = ( 1st ` ( 2nd ` A ) ) -> ( ch <-> th ) ) $.
    eloi.4 $e |- ( w = ( 2nd ` ( 2nd ` A ) ) -> ( th <-> ta ) ) $.
    $( A consequence of membership in a class abstraction whose elements
       belong to ` ( ( _V X. _V ) X. ( _V X. _V ) ) `  using ordered pair
       extractors. (Used by category theory). $)
    eloi $p |- ( A e. { x | E. y E. z E. v E. w
      ( x = <. <. y , z >. , <. v , w >. >. /\ ph ) } -> ta ) $=
      cA vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz
      wex vy wex vx cab wcel cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop
      cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop cop wceq wta cA vx cv vy cv
      vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vx
      cab wcel cA vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex
      vz wex vy wex cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd
      cfv c1st cfv cA c2nd cfv c2nd cfv cop cop wceq cA vx cv vy cv vz cv cop
      vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vx cab wcel
      cA vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex
      vy wex vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv
      wex vz wex vy wex cA vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw
      wex vv wex vz wex vy wex vx cA vx cv vy cv vz cv cop vv cv vw cv cop cop
      wceq wph wa vw wex vv wex vz wex vy wex vx cab vx cv cA wceq vx cv vy cv
      vz cv cop vv cv vw cv cop cop wceq wph wa cA vy cv vz cv cop vv cv vw cv
      cop cop wceq wph wa vy vz vv vw vx cv cA wceq vx cv vy cv vz cv cop vv cv
      vw cv cop cop wceq cA vy cv vz cv cop vv cv vw cv cop cop wceq wph vx cv
      cA vy cv vz cv cop vv cv vw cv cop cop eqeq1 anbi1d 4exbidv elabg ibi cA
      vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex cA cA c1st
      cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv c1st cfv cA c2nd cfv
      c2nd cfv cop cop wceq vy vz cA vy cv vz cv cop vv cv vw cv cop cop wceq
      wph wa cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv c1st
      cfv cA c2nd cfv c2nd cfv cop cop wceq vv vw cA vy cv vz cv cop vv cv vw
      cv cop cop wceq cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd
      cfv c1st cfv cA c2nd cfv c2nd cfv cop cop wceq wph cA vy cv vz cv cop vv
      cv vw cv cop cop wceq cA cA c1st cfv cA c2nd cfv cop cA c1st cfv c1st cfv
      cA c1st cfv c2nd cfv cop cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop
      cop cA vy cv vz cv cop vv cv vw cv cop cop wceq cA cvv cvv cxp wcel cA cA
      c1st cfv cA c2nd cfv cop wceq cA vy cv vz cv cop vv cv vw cv cop cop wceq
      cA vy cv vz cv cop vv cv vw cv cop cop cvv cvv cxp cA vy cv vz cv cop vv
      cv vw cv cop cop wceq id vy cv vz cv cop cvv wcel vv cv vw cv cop cvv
      wcel vy cv vz cv cop vv cv vw cv cop cop cvv cvv cxp wcel vy cv vz cv
      opex vv cv vw cv opex vy cv vz cv cop vv cv vw cv cop cvv cvv opelxpi
      mp2an syl6eqel cvv cvv cxp wrel cA cvv cvv cxp wcel cA cA c1st cfv cA
      c2nd cfv cop wceq cvv cvv relxp cA cvv cvv cxp 1st2nd mpan syl cA vy cv
      vz cv cop vv cv vw cv cop cop wceq cA c1st cfv cA c1st cfv c1st cfv cA
      c1st cfv c2nd cfv cop cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv c2nd
      cfv cop cA vy cv vz cv cop vv cv vw cv cop cop wceq cA c1st cfv cvv cvv
      cxp wcel cA c1st cfv cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq
      cA vy cv vz cv cop vv cv vw cv cop cop wceq cA c1st cfv vy cv vz cv cop
      cvv cvv cxp cA vy cv vz cv cop vv cv vw cv cop cop wceq cA c1st cfv vy cv
      vz cv cop vv cv vw cv cop cop c1st cfv vy cv vz cv cop cA vy cv vz cv cop
      vv cv vw cv cop cop c1st fveq2 vy cv vz cv cop vv cv vw cv cop vy cv vz
      cv opex op1st syl6eq vy cv cvv wcel vz cv cvv wcel vy cv vz cv cop cvv
      cvv cxp wcel vy visset vz visset vy cv vz cv cvv cvv opelxpi mp2an
      syl6eqel cvv cvv cxp wrel cA c1st cfv cvv cvv cxp wcel cA c1st cfv cA
      c1st cfv c1st cfv cA c1st cfv c2nd cfv cop wceq cvv cvv relxp cA c1st cfv
      cvv cvv cxp 1st2nd mpan syl cA vy cv vz cv cop vv cv vw cv cop cop wceq
      cA c2nd cfv cvv cvv cxp wcel cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv
      c2nd cfv cop wceq cA vy cv vz cv cop vv cv vw cv cop cop wceq cA c2nd cfv
      vv cv vw cv cop cvv cvv cxp cA vy cv vz cv cop vv cv vw cv cop cop wceq
      cA c2nd cfv vy cv vz cv cop vv cv vw cv cop cop c2nd cfv vv cv vw cv cop
      cA vy cv vz cv cop vv cv vw cv cop cop c2nd fveq2 vy cv vz cv cop vv cv
      vw cv cop vy cv vz cv opex vv cv vw cv opex op2nd syl6eq vv cv cvv wcel
      vw cv cvv wcel vv cv vw cv cop cvv cvv cxp wcel vv visset vw visset vv cv
      vw cv cvv cvv opelxpi mp2an syl6eqel cvv cvv cxp wrel cA c2nd cfv cvv cvv
      cxp wcel cA c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop wceq
      cvv cvv relxp cA c2nd cfv cvv cvv cxp 1st2nd mpan syl opeq12d eqtrd
      adantr 19.23aivv 19.23aivv syl cA cA c1st cfv c1st cfv cA c1st cfv c2nd
      cfv cop cA c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop cop wceq cA vx cv
      vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy
      wex vx cab wcel wta cA cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA
      c2nd cfv c1st cfv cA c2nd cfv c2nd cfv cop cop wceq cA vx cv vy cv vz cv
      cop vv cv vw cv cop cop wceq wph wa vw wex vv wex vz wex vy wex vx cab
      wcel cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv c1st cfv
      cA c2nd cfv c2nd cfv cop cop vx cv vy cv vz cv cop vv cv vw cv cop cop
      wceq wph wa vw wex vv wex vz wex vy wex vx cab wcel wta cA cA c1st cfv
      c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv c1st cfv cA c2nd cfv c2nd
      cfv cop cop vx cv vy cv vz cv cop vv cv vw cv cop cop wceq wph wa vw wex
      vv wex vz wex vy wex vx cab eleq1 cA c1st cfv c1st cfv cvv wcel cA c1st
      cfv c2nd cfv cvv wcel cA c2nd cfv c1st cfv cvv wcel w3a cA c2nd cfv c2nd
      cfv cvv wcel cA c1st cfv c1st cfv cA c1st cfv c2nd cfv cop cA c2nd cfv
      c1st cfv cA c2nd cfv c2nd cfv cop cop vx cv vy cv vz cv cop vv cv vw cv
      cop cop wceq wph wa vw wex vv wex vz wex vy wex vx cab wcel wta wb cA
      c1st cfv c1st cfv cvv wcel cA c1st cfv c2nd cfv cvv wcel cA c2nd cfv c1st
      cfv cvv wcel cA c1st cfv c1st fvex cA c1st cfv c2nd fvex cA c2nd cfv c1st
      fvex 3pm3.2i cA c2nd cfv c2nd fvex wph wps wch wth wta vx vy vz vw vv cA
      c1st cfv c1st cfv cA c1st cfv c2nd cfv cA c2nd cfv c1st cfv cA c2nd cfv
      c2nd cfv cvv cvv cvv cvv eloi.1 eloi.2 eloi.3 eloi.4 elo mp2an syl6bb
      biimpcd mpd $.
      $( [24-Sep-2007] $) $( [24-Sep-2007] $)
  $}

  $c t+ $.
  $c t* $.

  ctcl $a class t+ $. $( Extend class notation with transitive closure. $)
  crtcl $a class t* $. $( Extend class notation with reflexive transitive
    closure. $)

  ${ $d x y z $.
    $( Transitive closure of a relation. Experimental. $)
    trcl-df $a |- t+ = { <. x , y >. |
      y = |^| { z | ( x C_ z /\ ( z o. z ) C_ z ) } } $.

    $( Reflexive-transitive closure of a relation. Experimental. $)
    rtrcl-df $a |- t* = { <. x , y >. |
      y = |^| { z | ( ( _I |` ( dom x u. ran x ) ) C_ z /\ x C_ z
      /\ ( z o. z ) C_ z ) } } $.
  $}


  $( The double union of an intersection is a part of the intersections of the
     unions. $)
  uuniin $p |- U. U. ( A i^i B ) C_ ( U. U. A i^i U. U. B ) $=
    cA cB cin cuni cA cuni cB cuni cin wss cA cB cin cuni cuni cA cuni cuni cB
    cuni cuni cin wss cA cB uniin cA cB cin cuni cA cuni cB cuni cin wss cA cB
    cin cuni cuni cA cuni cB cuni cin cuni wss cA cB cin cuni cuni cA cuni cuni
    cB cuni cuni cin wss cA cB cin cuni cA cuni cB cuni cin uniss cA cB cin
    cuni cuni cA cuni cB cuni cin cuni wss cA cuni cB cuni cin cuni cA cuni
    cuni cB cuni cuni cin wss cA cB cin cuni cuni cA cuni cuni cB cuni cuni cin
    wss cA cuni cB cuni uniin cA cB cin cuni cuni cA cuni cB cuni cin cuni cA
    cuni cuni cB cuni cuni cin sstr2 mpi syl ax-mp $.
    $( [24-Jan-2010] $) $( [24-Jan-2010] $)

  $( A finite set is equal to its subset if they are equinumerous. $)
  sfseqeq $p |- ( ( B e. Fin /\ A C_ B /\ A ~~ B ) -> A = B ) $=
    cA cB cen wbr cA cB wss cB cfn wcel cA cB wceq cA cB cen wbr cA cB wss cB
    cfn wcel cA cB wceq cA cB cen wbr cA cB wss wa cB cfn wcel cA cB cA cB cen
    wbr cA cB wss cA cB wne cB cfn wcel wn cA cB cen wbr cA cB wpss cB cfn wcel
    wn cA cB wss cA cB wne wa cA cB wpss cA cB cen wbr cB cfn wcel wn cA cB
    pssinf expcom cA cB df-pss syl5ibr expdimp necon4ad 3impia 3com13 $.
    $( [6-Sep-2008] $) $( [11-Aug-2008] $)

  $( Conditions to have a set of two elements. To be suppressed.
     See ~ unpde2eg22 instead. $)
  unpde2eg2 $p |- ( ( A e. C /\ B e. D /\ A =/= B ) -> { A , B } ~~ 2o ) $=
    cA cC wcel cB cD wcel cA cB wne cA cB cpr c2o cen wbr cA cC wcel cB cD wcel
    cA csn cB csn cin c0 wceq cA cB cpr c2o cen wbr cA cB wne cA cC wcel cB cD
    wcel cA csn cB csn cin c0 wceq cA cB cpr c2o cen wbr wi cA csn c1o cen wbr
    cB csn c1o cen wbr cA csn cB csn cin c0 wceq cA cB cpr c2o cen wbr wi cA cC
    wcel cB cD wcel cA csn c1o cen wbr cB csn c1o cen wbr wa cA csn cB csn cin
    c0 wceq cA cB cpr c2o cen wbr cA csn c1o cen wbr cB csn c1o cen wbr wa cA
    csn cB csn cin c0 wceq cA csn cB csn cun c2o cen wbr cA cB cpr c2o cen wbr
    cA csn cB csn pm54.43 cA cB cpr cA csn cB csn cun c2o cen cA cB df-pr
    breq1i syl6bbr biimpd cA cC ensn1g cB cD ensn1g syl2an ex cA cB disjsn2
    syl7 3imp $.
    $( [1-Sep-2008] $) $( [17-Aug-2008] $)

  $( If an unordered pair has two elements they are different. $)
  unpde2eg22 $p |- ( ( A e. C /\ B e. D ) ->
    ( { A , B } ~~ 2o <->  A =/= B ) ) $=
    cA cC wcel cB cD wcel wa cA cB cpr c2o cen wbr cA cB wne cA cC wcel cB cD
    wcel wa cA cB cpr c2o cen wbr cA cB cA cC wcel cB cD wcel wa cA cB cpr cA
    cA cpr wceq cA cB cpr c2o cen wbr wn cA cB wceq cA cB cpr cA cA cpr wceq cA
    cC wcel cB cD wcel wa cA cB cpr c2o cen wbr wn cA cC wcel cB cD wcel cA cB
    cpr cA cA cpr wceq cA cC wcel cB cD wcel wa cA cB cpr c2o cen wbr wn wi wi
    cA cC wcel cA cB cpr cA cA cpr wceq cB cD wcel cA cC wcel cB cD wcel wa cA
    cB cpr c2o cen wbr wn wi cA cC wcel cA cA cpr c1o cen wbr cA cB cpr cA cA
    cpr wceq cB cD wcel cA cC wcel cB cD wcel wa cA cB cpr c2o cen wbr wn wi wi
    wi cA cC boe cA cA cpr c1o cen wbr cA cB cpr cA cA cpr wceq cA cC wcel cB
    cD wcel wa cA cB cpr c2o cen wbr wn wi cB cD wcel cA cB cpr cA cA cpr wceq
    cA cA cpr c1o cen wbr cA cC wcel cB cD wcel wa cA cB cpr c2o cen wbr wn wi
    cA cB cpr cA cA cpr wceq cA cB cpr cA cA cpr cen wbr cA cA cpr c1o cen wbr
    cA cC wcel cB cD wcel wa cA cB cpr c2o cen wbr wn wi wi cA cB cpr cvv wcel
    cA cB cpr cA cA cpr wceq cA cB cpr cA cA cpr cen wbr wi cA cB prex cA cB
    cpr cA cA cpr cvv eqeng ax-mp cA cB cpr cA cA cpr cen wbr cA cA cpr c1o cen
    wbr cA cC wcel cB cD wcel wa cA cB cpr c2o cen wbr wn wi cA cB cpr cA cA
    cpr cen wbr cA cA cpr c1o cen wbr wa cA cB cpr c1o cen wbr cA cC wcel cB cD
    wcel wa cA cB cpr c2o cen wbr wn wi cA cB cpr cA cA cpr c1o entr cA cB cpr
    c1o cen wbr cA cB cpr c2o cen wbr wn cA cC wcel cB cD wcel wa cA cB cpr c1o
    cen wbr cA cB cpr c2o cen wbr c1o c2o cen wbr c1o c2o csdm wbr c1o c2o cen
    wbr wn 1sdom2 c1o c2o sdomnen ax-mp cA cB cpr c1o cen wbr c1o cA cB cpr cen
    wbr cA cB cpr c2o cen wbr c1o c2o cen wbr wi cA cB cpr c1o c1o con0 1on
    elisseti ensym c1o cA cB cpr cen wbr cA cB cpr c2o cen wbr c1o c2o cen wbr
    c1o cA cB cpr c2o entr ex syl mtoi a1d syl ex syl com12 a1dd syl com23 imp
    pm2.43a cA cB cpr cA cA cpr wceq cB cA cB cA cA preq2 eqcoms syl5 necon2ad
    cA cC wcel cB cD wcel cA cB wne cA cB cpr c2o cen wbr cA cB cC cD unpde2eg2
    3expia impbid $.
    $( [18-Feb-2010] $) $( [14-Feb-2010] $)

  $( Building a set with two elements. $)
  set2elt $p |- ( ( C ~~ 2o /\ A e. C /\ B e. C )
     -> ( A =/= B -> C = { A , B } ) ) $=
    cC c2o cen wbr cA cC wcel cB cC wcel cA cB wne cC cA cB cpr wceq wi cA cC
    wcel cB cC wcel wa cC c2o cen wbr cA cB wne cC cA cB cpr wceq wi cA cC wcel
    cB cC wcel wa cC c2o cen wbr cA cB wne cC cA cB cpr wceq wi wi cA cC wcel
    cB cC wcel wa cA cC wcel cB cC wcel wa cA cB cpr cC wss cC c2o cen wbr cA
    cB wne cC cA cB cpr wceq wi wi cA cB cC cC cC prssg cA cC wcel cB cC wcel
    wa cA cB wne cC c2o cen wbr cA cB cpr cC wss cC cA cB cpr wceq cA cC wcel
    cB cC wcel cA cB wne cC c2o cen wbr cA cB cpr cC wss cC cA cB cpr wceq wi
    wi cC c2o cen wbr cA cB cpr c2o cen wbr cA cB cpr cC wss cC cA cB cpr wceq
    wi cA cC wcel cB cC wcel cA cB wne w3a cC cfn wcel cC c2o cen wbr cA cB cpr
    c2o cen wbr cA cB cpr cC wss cC cA cB cpr wceq wi wi cC c2o cen wbr cC cfn
    wcel c2o cfn wcel c2o com wcel c2o c2o wss c2o cfn wcel 2onn c2o ssid c2o
    c2o ssnnfi mp2an c2o com wcel cC c2o cen wbr cC cfn wcel c2o cfn wcel wb
    2onn cC c2o com enfi mpan mpbiri cA cB cpr c2o cen wbr cC c2o cen wbr cC
    cfn wcel cA cB cpr cC wss cC cA cB cpr wceq wi cC c2o cen wbr c2o cA cB cpr
    cen wbr cC cfn wcel cA cB cpr cC wss cC cA cB cpr wceq wi wi cA cB cpr c2o
    cen wbr cC c2o cen wbr c2o cA cB cpr cen wbr cC cfn wcel cA cB cpr cC wss
    cC cA cB cpr wceq wi wi cC c2o cen wbr c2o cA cB cpr cen wbr wa cC cA cB
    cpr cen wbr cC cfn wcel cA cB cpr cC wss cC cA cB cpr wceq wi wi cC c2o cA
    cB cpr entr cC cA cB cpr cen wbr cA cB cpr cC cen wbr cC cfn wcel cA cB cpr
    cC wss cC cA cB cpr wceq wi wi cC cA cB cpr cA cB prex ensym cC cfn wcel cA
    cB cpr cC wss cA cB cpr cC cen wbr cC cA cB cpr wceq cC cfn wcel cA cB cpr
    cC wss cA cB cpr cC cen wbr cC cA cB cpr wceq cC cfn wcel cA cB cpr cC wss
    cA cB cpr cC cen wbr w3a cA cB cpr cC cA cB cpr cC sfseqeq eqcomd 3exp
    com3r syl syl ex c2o com wcel cA cB cpr c2o cen wbr c2o cA cB cpr cen wbr
    wi 2onn cA cB cpr c2o com ensymg ax-mp syl5com com13 mpcom cA cB cC cC
    unpde2eg2 syl5com 3expia com24 sylbid pm2.43i com12 3impib $.
    $( [6-Sep-2008] $) $( [11-Aug-2008] $)

  $( Building a set with only one element. $)
  setwoe $p |- ( ( A e. B /\ B ~~ 1o ) -> B = { A } ) $=
    cA cB wcel cB c1o cen wbr wa cA csn cB cB cfn wcel cA csn cB wss cA csn cB
    cen wbr cA csn cB wceq cA cB wcel cB c1o cen wbr wa cA csn cB sfseqeq cB
    c1o cen wbr cB cfn wcel cA cB wcel cB c1o cen wbr cB cfn wcel c1o cfn wcel
    c1o com wcel c1o c1o wss c1o cfn wcel 1onn c1o ssid c1o c1o ssnnfi mp2an
    c1o com wcel cB c1o cen wbr cB cfn wcel c1o cfn wcel wb 1onn cB c1o com
    enfi mpan mpbiri adantl cA cB wcel cA csn cB wss cB c1o cen wbr cA cB snssi
    adantr cA csn c1o cen wbr c1o cB cen wbr cA csn cB cen wbr cA cB wcel cB
    c1o cen wbr cA csn c1o cB entr cA cB ensn1g c1o com wcel cB c1o cen wbr c1o
    cB cen wbr wi 1onn cB c1o com ensymg ax-mp syl2an syl3anc eqcomd $.
    $( [6-Sep-2008] $) $( [18-Aug-2008] $)

  $( The range of a square cross product. $)
  rnxpid $p |- ran ( A X. A ) = A $=
    cA cA cxp crn cA wceq cA c0 cA c0 wceq c0 crn c0 cA cA cxp crn cA rn0 cA c0
    wceq cA cA cxp c0 cA c0 wceq cA cA cxp cA c0 cxp c0 cA c0 cA xpeq2 cA xp0
    syl6eq rneqd cA c0 wceq id 3eqtr4a cA cA rnxp pm2.61ine $.
    $( [18-May-2010] $) $( [17-May-2010] $)

  ${
    opreq123i.1 $e |- A = C $.
    opreq123i.2 $e |- B = D $.
    opreq123i.3 $e |- F = G $.
    $( Equality inference for operation value. $)
    opreq123i $p |- ( A F B ) = ( C G D ) $=
      cA cB cF co cC cD cF co cC cD cG co cA cC cB cD cF opreq123i.1
      opreq123i.2 opreq12i cF cG cC cD opreq123i.3 opreqi eqtri $.
      $( [11-Jul-2010] $) $( [11-Jul-2010] $)
  $}

  $( A class builder defined by a negation. $)
  clsbldneg $p |- { x | -. ph } = ( _V \ { x | ph } ) $=
    wph wn vx cvv crab vx cv cvv wcel wph wn wa vx cab wph wn vx cab cvv wph vx
    cab cdif wph wn vx cvv df-rab wph wn vx rabab vx cv cvv wcel vx cab wph vx
    cab cdif vx cv cvv wcel wph wn wa vx cab cvv wph vx cab cdif vx cv cvv wcel
    wph vx difab vx cv cvv wcel vx cab cvv wph vx cab vx cvv abid2 difeq1i
    eqtr3i 3eqtr3i $.
    $( [20-Sep-2010] $) $( [18-Sep-2010] $)


  $( A class builder defined by an implication. $)
  clsbldimp $p |- { x | ( ph -> ps ) } =
                  ( { x | -. ph } u. { x | ps } ) $=
    wph wps wi vx cab wph wn wps wo vx cab wph wn vx cab wps vx cab cun wph wps
    wi wph wn wps wo vx wph wps imor abbii wph wn wps vx unab eqtr4i $.
    $( [20-Sep-2010] $) $( [18-Sep-2010] $)


  $( A mapping is a member of the powerset of the cross product of its
     domain and codomain. $)
  mappow $p |- ( ( A e. R /\ B e. S ) ->
    ( F : A --> B -> F e. ~P ( A X. B ) ) ) $=
    cA cR wcel cB cS wcel wa cA cB cF wf cF cB cA cm co wcel cF cA cB cxp cpw
    wcel cB cS wcel cA cR wcel cF cB cA cm co wcel cA cB cF wf wb cB cA cF cS
    cR elmapg ancoms cA cR wcel cB cS wcel wa cB cA cm co cA cB cxp cpw cF cA
    cR wcel cB cA cm co cA cB cxp cpw wss cB cS wcel cB cA cR mapsspw adantr
    sseld sylbird $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  ${ $d A x y $. $d ph y $.
    $( Membership in the intersection of a class abstraction. $)
    elintabg $p |- ( A e. B ->
      ( A e. |^| { x | ph } <-> A. x ( ph -> A e. x ) ) ) $=
      vy cv wph vx cab cint wcel wph vy vx wel wi vx wal wb cA wph vx cab cint
      wcel wph cA vx cv wcel wi vx wal wb vy cA cB vy cv cA wceq vy cv wph vx
      cab cint wcel cA wph vx cab cint wcel wph vy vx wel wi vx wal wph cA vx
      cv wcel wi vx wal vy cv cA wph vx cab cint eleq1 vy cv cA wceq wph vy vx
      wel wi wph cA vx cv wcel wi vx vy cv cA wceq vy vx wel cA vx cv wcel wph
      vy cv cA vx cv eleq1 imbi2d albidv bibi12d wph vx vy cv vy visset elintab
      vtoclg $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  $( A singleton of a set belongs to the power class of a class containing
       the set. $)
  snelpwg $p |- ( A e. C -> ( A e. B <-> { A } e. ~P B ) ) $=
    cA cC wcel cA cvv wcel cA cB wcel cA csn cB cpw wcel wb cA cC elisset cA
    cvv wcel cA cB wcel cA csn cB cpw wcel wb cA cvv wcel cA c0 cif cB wcel cA
    cvv wcel cA c0 cif csn cB cpw wcel wb cA c0 cA cA cvv wcel cA c0 cif wceq
    cA cB wcel cA cvv wcel cA c0 cif cB wcel cA csn cB cpw wcel cA cvv wcel cA
    c0 cif csn cB cpw wcel cA cA cvv wcel cA c0 cif cB eleq1 cA cA cvv wcel cA
    c0 cif wceq cA csn cA cvv wcel cA c0 cif csn cB cpw cA cA cvv wcel cA c0
    cif sneq eleq1d bibi12d cA cvv wcel cA c0 cif cB cA c0 cvv 0ex elimel
    snelpw dedth syl $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  ${
    $d A x y $. $d F z $. $d x y z $.
    dff1o6f.1 $e |- ( z e. F -> A. x z e. F ) $.
    dff1o6f.2 $e |- ( z e. F -> A. y z e. F ) $.
    $( A one-to-one onto function in terms of function values. $)
    dff1o6f $p |- ( F : A -1-1-onto-> B <-> ( F Fn A /\ ran F = B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      cA cB cF wf1o cA cB cF wf1 cA cB cF wfo wa cA cB cF wf vx cv cF cfv vy cv
      cF cfv wceq vx vy weq wi vy cA wral vx cA wral wa cF cA wfn cF crn cB
      wceq wa wa cF cA wfn cF crn cB wceq vx cv cF cfv vy cv cF cfv wceq vx vy
      weq wi vy cA wral vx cA wral w3a cA cB cF df-f1o cA cB cF wf1 cA cB cF wf
      vx cv cF cfv vy cv cF cfv wceq vx vy weq wi vy cA wral vx cA wral wa cA
      cB cF wfo cF cA wfn cF crn cB wceq wa vx vy vz cA cB cF dff1o6f.1
      dff1o6f.2 dff13f cA cB cF df-fo anbi12i cF cA wfn cF crn cB wceq vx cv cF
      cfv vy cv cF cfv wceq vx vy weq wi vy cA wral vx cA wral w3a cF cA wfn cF
      crn cB wceq wa vx cv cF cfv vy cv cF cfv wceq vx vy weq wi vy cA wral vx
      cA wral wa cA cB cF wf cF cA wfn cF crn cB wceq wa wa vx cv cF cfv vy cv
      cF cfv wceq vx vy weq wi vy cA wral vx cA wral wa cA cB cF wf vx cv cF
      cfv vy cv cF cfv wceq vx vy weq wi vy cA wral vx cA wral wa cF cA wfn cF
      crn cB wceq wa wa cF cA wfn cF crn cB wceq vx cv cF cfv vy cv cF cfv wceq
      vx vy weq wi vy cA wral vx cA wral df-3an cF cA wfn cF crn cB wceq wa cA
      cB cF wf cF cA wfn cF crn cB wceq wa wa vx cv cF cfv vy cv cF cfv wceq vx
      vy weq wi vy cA wral vx cA wral cF cA wfn cF crn cB wceq wa cA cB cF wf
      cF cA wfn cF crn cB wceq wa cF cA wfn cF crn cB wss wa cA cB cF wf cF crn
      cB wceq cF crn cB wss cF cA wfn cF crn cB eqimss anim2i cA cB cF df-f
      sylibr pm4.71ri anbi1i cA cB cF wf cF cA wfn cF crn cB wceq wa vx cv cF
      cfv vy cv cF cfv wceq vx vy weq wi vy cA wral vx cA wral an23 3bitrri
      3bitri $.
      $( [1-Jan-2011] $) $( [1-Jan-2011] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The "maps to" notation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    fnoprab2ga.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    ${
      $d A x y z $. $d B x y z $. $d C z $.
      $( Functionality and domain of a class given by the "maps to" notation.
         Equivalent to ~ fnoprab2g . $)
      fnoprab2ga $p |- ( A. x e. A A. y e. B C e. _V <-> F Fn ( A X. B ) ) $=
        vx vy vz cA cB cC cF cF vx vy cA cB cC cmpt2 vx cv cA wcel vy cv cB
        wcel wa vz cv cC wceq wa vx vy vz copab2 fnoprab2ga.1 vx vy vz cA cB cC
        df-mpt2 eqtri fnoprab2g $.
        $( [18-May-2010] $) $( [17-May-2010] $)
    $}

    ${
      fnoprab2g.2 $e |- C e. _V $.
      ${
        $d A x y z $. $d B x y z $. $d C z $.
        $( Functionality  and  domain  of  a  class given  by  the  "maps  to"
           notation. Equivalent to ~ fnoprab2 . $)
        fnoprab2a $p |- F Fn ( A X. B ) $=
          vx vy vz cA cB cC cF fnoprab2g.2 cF vx vy cA cB cC cmpt2 vx cv cA
          wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 fnoprab2ga.1
          vx vy vz cA cB cC df-mpt2 eqtri fnoprab2 $.
          $( [18-May-2010] $) $( [17-May-2010] $)

        $( Domain of  a class given by the "maps to"  notation. Equivalent to
           ~ dmoprab2 . $)
        dmoprab2a $p |- dom F = ( A X. B ) $=
          vx vy vz cA cB cC cF fnoprab2g.2 cF vx vy cA cB cC cmpt2 vx cv cA
          wcel vy cv cB wcel wa vz cv cC wceq wa vx vy vz copab2 fnoprab2ga.1
          vx vy vz cA cB cC df-mpt2 eqtri dmoprab2 $.
          $( [18-May-2010] $) $( [17-May-2010] $)
      $}

      ${
        $d A x y z $. $d B x y z $. $d C z $. $d D x y z $.
        $( Functionality,  domain and range of  a class given by  the "maps to"
           notation. Equivalent to ~ foprab2 . $)
        foprab2a $p |- ( A. x e. A A. y e. B C e. D
          <-> F : ( A X. B ) --> D ) $=
          vx vy vz cA cB cC cD cF cF vx vy cA cB cC cmpt2 vx cv cA wcel vy cv
          cB wcel wa vz cv cC wceq wa vx vy vz copab2 fnoprab2ga.1 vx vy vz cA
          cB cC df-mpt2 eqtri foprab2 $.
          $( [18-May-2010] $) $( [17-May-2010] $)
      $}

    $}

    ${ $d A x y z $. $d B x y z $. $d C z $. $d D x $.
       $d X x y z $. $d Y x y z $. $d Z y z $.
      oprabval2ga.1 $e |- ( x = X -> C = D ) $.
      oprabval2ga.2 $e |- ( y = Y -> D = Z ) $.
      $( Todo: change the variables. $)
      $( The value of an operation class abstraction.  Special case. Equivalent
         to ~ oprabval2g . $)
      oprabval2ga $p |- ( ( X e. A /\ Y e. B /\ Z e. N )
          -> ( X F Y ) = Z ) $=
        vx vy vz cX cY cA cB cC cZ cF cD cN oprabval2ga.1 oprabval2ga.2 cF vx
        vy cA cB cC cmpt2 vx cv cA wcel vy cv cB wcel wa vz cv cC wceq wa vx vy
        vz copab2 fnoprab2ga.1 vx vy vz cA cB cC df-mpt2 eqtri oprabval2g $.
        $( [18-May-2010] $) $( [17-May-2010] $)

    $}

    ${ $d A x y z $. $d B x y z $. $d C z $.
      $( Existence of an operation class abstraction (special case). $)
      oprabex2ga $p |- ( ( A e. R /\ B e. S ) -> F e. _V ) $=
        vx vy vz cA cB cC cR cS cF cF vx vy cA cB cC cmpt2 vx cv cA wcel vy cv
        cB wcel wa vz cv cC wceq wa vx vy vz copab2 fnoprab2ga.1 vx vy vz cA cB
        cC df-mpt2 eqtri oprabex2g $.
        $( [18-May-2010] $) $( [17-May-2010] $)
    $}

  $}

  ${ $d A z $.  $d B z $.  $d x y $.  $d x z $.
    $( ` x ` is bound in the "maps to" notation. $)
    hbcmpt $p |- ( y e. ( x e. A |-> B ) -> A. x y e. ( x e. A |-> B ) ) $=
      vx vy vx cA cB cmpt vx cv cA wcel vz cv cB wceq wa vx vz copab vx vz cA
      cB df-mpt vx cv cA wcel vz cv cB wceq wa vx vz vy hbopab1 hbxfr $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${
    $d A y $. $d B y $. $d x y $.
    fvopab2b.1 $e |- F = ( x e. A |-> B ) $.
    $( Value of a function given by the "maps to" notation. Equivalent to
       ~ fvopab2 . $)
    fvopab2b $p |- ( ( x e. A /\ B e. C ) -> ( F ` x ) = B ) $=
      vx cv cA wcel cB cC wcel wa vx cv vx cv cA wcel vy cv cB wceq wa vx vy
      copab cfv cB vx cv cF cfv vx vy cA cB cC fvopab2 vx cv cF vx cv cA wcel
      vy cv cB wceq wa vx vy copab cF vx cA cB cmpt vx cv cA wcel vy cv cB wceq
      wa vx vy copab fvopab2b.1 vx vy cA cB df-mpt eqtri fveq1i syl5eq $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${
    $d A w x y z $. $d B w y z $. $d C w x z $.
    cmpbvb.1 $e |- F = ( x e. A |-> B ) $.
    cmpbvb.2 $e |- ( x = y -> B = C ) $.
    $( Rule to change a bound variable in the "maps to" notation. $)
    cmpbvb $p |- F = ( y e. A |-> C ) $=
      cF vx cA cB cmpt vx cv cA wcel vz cv cB wceq wa vx vz copab vy cA cC cmpt
      cmpbvb.1 vx vz cA cB df-mpt vx cv cA wcel vz cv cB wceq wa vx vz copab vy
      cv cA wcel vw cv cC wceq wa vy vw copab vy cA cC cmpt vx cv cA wcel vz cv
      cB wceq wa vy cv cA wcel vw cv cC wceq wa vx vz vy vw vx vy weq vz vw weq
      wa vx cv cA wcel vy cv cA wcel vz cv cB wceq vw cv cC wceq vx vy weq vz
      vw weq wa vx cv vy cv cA vx vy weq vz vw weq pm3.26 eleq1d vx vy weq vz
      vw weq wa vz cv vw cv cB cC vx vy weq vz vw weq pm3.27 vx vy weq cB cC
      wceq vz vw weq cmpbvb.2 adantr eqeq12d anbi12d cbvopabv vy vw cA cC
      df-mpt eqtr4i 3eqtri $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${ $d A x y $.  $d C y $.
    fopab2ga.1 $e |- F = ( x e. A |-> C ) $.
    $( Functionality and domain of a class given by the "maps to" notation. $)
    fopab2ga $p |- ( A. x e. A C e. _V <-> F Fn A ) $=
      vx vy cA cC cF cF vx cA cC cmpt vx cv cA wcel vy cv cC wceq wa vx vy
      copab fopab2ga.1 vx vy cA cC df-mpt eqtri fnopab2g $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${ $d A x y  $.  $d B x y  $.  $d C y $.
    fopab2a.1 $e |- F = ( x e. A |-> C ) $.
    $( Functionality of a class given by the "maps to" notation. $)
    fopab2a $p |- ( A. x e. A C e. B <-> F : A --> B ) $=
      vx vy cA cB cC cF cF vx cA cC cmpt vx cv cA wcel vy cv cC wceq wa vx vy
      copab fopab2a.1 vx vy cA cC df-mpt eqtri fopab2 $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${ $d A y $.  $d B y $.  $d x y $.
    cmp.1 $e |- F = ( x e. A |-> B ) $.
    $( Functionality of a class given by a "maps to" notation. $)
    cmpfun $p |- Fun F $=
      vx cA cB cmpt wfun cF wfun vx cA cB cmpt wfun vx cv cA wcel vy cv cB wceq
      wa vx vy copab wfun vx cv cA wcel vy cv cB wceq wa vx vy copab vy cv cB
      wceq vx vy copab wss vy cv cB wceq vx vy copab wfun vx cv cA wcel vy cv
      cB wceq wa vx vy copab wfun vx cv cA wcel vy cv cB wceq wa vy cv cB wceq
      vx vy vx cv cA wcel vy cv cB wceq pm3.27 ssopab2i vx vy cB funopabeq vx
      cv cA wcel vy cv cB wceq wa vx vy copab vy cv cB wceq vx vy copab funss
      mp2 vx cA cB cmpt vx cv cA wcel vy cv cB wceq wa vx vy copab wceq vx cA
      cB cmpt wfun vx cv cA wcel vy cv cB wceq wa vx vy copab wfun wb vx vy cA
      cB df-mpt vx cA cB cmpt vx cv cA wcel vy cv cB wceq wa vx vy copab funeq
      ax-mp mpbir cF vx cA cB cmpt wceq vx cA cB cmpt wfun cF wfun wb cmp.1 cF
      vx cA cB cmpt wceq cF wfun vx cA cB cmpt wfun cF vx cA cB cmpt funeq
      bicomd ax-mp mpbi $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${
    $d A x y $.  $d B y $.
    cmpdom.1 $e |- F = ( x e. A |-> B ) $.
    $( Domain of a class given by the "maps to" notation. $)
    cmpdom $p |- ( A. x e. A B e. _V <-> dom F = A ) $=
      cB cvv wcel vx cA wral cF cdm cA wceq cF wfun cF cA wfn cF wfun cF cdm cA
      wceq wa cB cvv wcel vx cA wral cF cdm cA wceq cF wfun wa cF cA df-fn vx
      cA cB cF cmpdom.1 fopab2ga cF cdm cA wceq cF wfun ancom 3bitr4i vx cA cB
      cF cmpdom.1 cmpfun mpbiran2 $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${
    $d A x $.
    cmpdom2.1 $e |- F = ( x e. A |-> ( B G C ) ) $.
    $( Domain of a class given by the "maps to" notation. $)
    cmpdom2 $p |- dom F = A $=
      cB cC cG co cvv wcel vx cA wral cF cdm cA wceq cB cC cG co cvv wcel vx cA
      cB cC cG co cvv wcel vx cv cA wcel cB cC cG oprex a1i rgen vx cA cB cC cG
      co cF cmpdom2.1 cmpdom mpbi $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${ $d A y $.  $d B y $.  $d x y $.
    cmpran.1 $e |- F = ( x e. A |-> B ) $.
    $( Range of a class given by the "maps to" notation. $)
    cmpran $p |- ran F = { y | E. x e. A y = B } $=
      cF crn vx cA cB cmpt crn vx cv cA wcel vy cv cB wceq wa vx vy copab crn
      vy cv cB wceq vx cA wrex vy cab cF vx cA cB cmpt cmpran.1 rneqi vx cA cB
      cmpt vx cv cA wcel vy cv cB wceq wa vx vy copab vx vy cA cB df-mpt rneqi
      vx vy cA cB rnopab2 3eqtri $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Operations on subsets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


 $c cset $.

 $( Extend class notation with an operator that derives an operation on
    subsets of a set from an operation on the elements of this set. $)
 ccst $a class cset $.

  ${
    $d g h x y z a u v $.
    $( Define  an  operation `  h  ` on  the subsets  derived from  an
       operation `  g `  on the elements.   Meaningful if  ` g `  is a
       binary internal operation. $)
    df-cst $a |- cset = { <. g , h >. | h = { <. <. x , y >. , z >. |
     ( x e. ~P dom dom g /\ y e. ~P dom dom g
          /\  z = { a | E. u e. x E. v e. y a = ( u g v ) } ) } } $.
  $}

  ${
    iscst1.1 $e |- X = dom dom G $.
    iscst1.2 $e |- H = ( cset ` G ) $.
    ${
      $d G a g h u v x y z  $. $d X g h x y z $.
      $( An operation on the subsets derived from an operation
         on the elements. $)
      iscst1 $p |- ( G e. A ->  H = { <. <. x , y >. , z >. |
        ( x e. ~P X /\ y e. ~P X
           /\  z = { a | E. u e. x E. v e. y a = ( u G v ) } ) } ) $=
        cG cA wcel cG ccst cfv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv
        vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx
        vy vz copab2 cH cG cvv wcel vx cv cX cpw wcel vy cv cX cpw wcel vz cv
        va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq
        w3a vx vy vz copab2 cvv wcel cG ccst cfv vx cv cX cpw wcel vy cv cX cpw
        wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va
        cab wceq w3a vx vy vz copab2 wceq cG cA wcel vg vh cG vx cv vg cv cdm
        cdm cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va cv vu cv vv cv vg cv
        co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 vx
        cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv
        vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 cvv cvv ccst
        vg cv cG wceq vx cv vg cv cdm cdm cpw wcel vy cv vg cv cdm cdm cpw wcel
        vz cv va cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx cv wrex va
        cab wceq w3a vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv
        cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz vg
        cv cG wceq vx cv vg cv cdm cdm cpw wcel vx cv cX cpw wcel vy cv vg cv
        cdm cdm cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv vg cv co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq vz cv va cv vu cv vv cv cG
        co wceq vv vy cv wrex vu vx cv wrex va cab wceq vg cv cG wceq vg cv cdm
        cdm cpw cX cpw vx cv vg cv cG wceq vg cv cdm cdm cpw cG cdm cdm cpw cX
        cpw vg cv cG wceq vg cv cdm cdm cG cdm cdm wceq vg cv cdm cdm cpw cG
        cdm cdm cpw wceq vg cv cG wceq vg cv cdm cG cdm vg cv cG dmeq dmeqd vg
        cv cdm cdm cG cdm cdm pweq syl cX cG cdm cdm wceq cX cpw cG cdm cdm cpw
        wceq iscst1.1 cX cG cdm cdm pweq ax-mp syl6eqr eleq2d vg cv cG wceq vg
        cv cdm cdm cpw cX cpw vy cv vg cv cG wceq vg cv cdm cdm cpw cG cdm cdm
        cpw cX cpw vg cv cG wceq vg cv cdm cdm cG cdm cdm wceq vg cv cdm cdm
        cpw cG cdm cdm cpw wceq vg cv cG wceq vg cv cdm cG cdm vg cv cG dmeq
        dmeqd vg cv cdm cdm cG cdm cdm pweq syl cX cG cdm cdm wceq cX cpw cG
        cdm cdm cpw wceq iscst1.1 cX cG cdm cdm pweq ax-mp syl6eqr eleq2d vg cv
        cG wceq va cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx cv wrex va
        cab va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab vz
        cv vg cv cG wceq va cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx cv
        wrex va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va vg cv
        cG wceq va cv vu cv vv cv vg cv co wceq vv vy cv wrex va cv vu cv vv cv
        cG co wceq vv vy cv wrex vu vx cv vg cv cG wceq va cv vu cv vv cv vg cv
        co wceq va cv vu cv vv cv cG co wceq vv vy cv vg cv cG wceq vu cv vv cv
        vg cv co vu cv vv cv cG co va cv vu cv vv cv vg cv cG opreq eqeq2d
        rexbidv rexbidv abbidv eqeq2d 3anbi123d oprabbidv ccst vh cv vx cv vg
        cv cdm cdm cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va cv vu cv vv
        cv vg cv co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz
        copab2 wceq vg vh copab cvv cres vg cv cvv wcel vh cv vx cv vg cv cdm
        cdm cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va cv vu cv vv cv vg cv
        co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2
        wceq wa vg vh copab vh cv vx cv vg cv cdm cdm cpw wcel vy cv vg cv cdm
        cdm cpw wcel vz cv va cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx
        cv wrex va cab wceq w3a vx vy vz copab2 wceq vg vh copab wrel ccst vh
        cv vx cv vg cv cdm cdm cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va
        cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx cv wrex va cab wceq
        w3a vx vy vz copab2 wceq vg vh copab cvv cres wceq vh cv vx cv vg cv
        cdm cdm cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va cv vu cv vv cv
        vg cv co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz
        copab2 wceq vg vh relopab vh cv vx cv vg cv cdm cdm cpw wcel vy cv vg
        cv cdm cdm cpw wcel vz cv va cv vu cv vv cv vg cv co wceq vv vy cv wrex
        vu vx cv wrex va cab wceq w3a vx vy vz copab2 wceq vg vh copab wrel vh
        cv vx cv vg cv cdm cdm cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va
        cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx cv wrex va cab wceq
        w3a vx vy vz copab2 wceq vg vh copab cvv cres vh cv vx cv vg cv cdm cdm
        cpw wcel vy cv vg cv cdm cdm cpw wcel vz cv va cv vu cv vv cv vg cv co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 wceq
        vg vh copab ccst vh cv vx cv vg cv cdm cdm cpw wcel vy cv vg cv cdm cdm
        cpw wcel vz cv va cv vu cv vv cv vg cv co wceq vv vy cv wrex vu vx cv
        wrex va cab wceq w3a vx vy vz copab2 wceq vg vh copab resid vx vy vz vv
        vu vg vh va df-cst syl6reqr ax-mp vh cv vx cv vg cv cdm cdm cpw wcel vy
        cv vg cv cdm cdm cpw wcel vz cv va cv vu cv vv cv vg cv co wceq vv vy
        cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 wceq vg vh cvv
        resopab eqtri fvopab4g cG cA elisset cG cA wcel cX cpw cvv wcel cX cpw
        cvv wcel wa vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv
        cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2
        cvv wcel cG cA wcel cX cvv wcel cX cpw cvv wcel cX cpw cvv wcel wa cG
        cA wcel cG cdm cdm cvv cX cG cA wcel cG cdm cvv wcel cG cdm cdm cvv
        wcel cG cA dmexg cG cdm cvv dmexg syl iscst1.1 syl5eqel cX cvv wcel cX
        cpw cvv wcel cX cpw cvv wcel cX cvv pwexg cX cvv pwexg jca syl vx vy vz
        cX cpw cX cpw va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex
        va cab cvv cvv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv
        cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz
        copab2 vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG
        co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx cv cX cpw wcel
        vy cv cX cpw wcel wa vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex
        vu vx cv wrex va cab wceq wa vx vy vz vx cv cX cpw wcel vy cv cX cpw
        wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va
        cab wceq df-3an oprabbii oprabex2g syl sylanc iscst1.2 syl5eq $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}

    ${
      $d A a m n u $. $d B a n u v $. $d G a m n u v x y z $.
      $d X m n x y z $.
      $( The value of the couple ` <. A , B >. ` through
         the derived operation. $)
      iscst2 $p |- ( ( G e. M /\ A e. ~P X /\ B e. ~P X ) ->
        ( A H B ) = { a | E. u e. A E. v e. B a = ( u G v ) } ) $=
        cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a cA cB cH co va cv vu cv vv
        cv cG co wceq vv cB wrex vu cA wrex va cab wceq cA cB vx cv cX cpw wcel
        vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu
        vx cv wrex va cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co
        wceq vv cB wrex vu cA wrex va cab wceq cA cX cpw wcel cB cX cpw wcel cA
        cB vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 co va
        cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab wceq cG cM wcel
        cA cX cpw wcel cB cX cpw wcel wa cA cB vx cv cX cpw wcel vy cv cX cpw
        wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va
        cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co wceq vv cB wrex
        vu cA wrex va cab wceq vm cv cX cpw wcel vn cv cX cpw wcel wa vm cv vn
        cv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 co va
        cv vu cv vv cv cG co wceq vv vn cv wrex vu vm cv wrex va cab wceq wi cA
        cX cpw wcel vn cv cX cpw wcel wa cA vn cv vx cv cX cpw wcel vy cv cX
        cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex
        va cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co wceq vv vn
        cv wrex vu cA wrex va cab wceq wi cA cX cpw wcel cB cX cpw wcel wa cA
        cB vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 co va
        cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab wceq wi vm vn cA
        cB cX cpw cX cpw vm cv cA wceq vm cv cX cpw wcel vn cv cX cpw wcel wa
        cA cX cpw wcel vn cv cX cpw wcel wa vm cv vn cv vx cv cX cpw wcel vy cv
        cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv
        wrex va cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co wceq vv
        vn cv wrex vu vm cv wrex va cab wceq cA vn cv vx cv cX cpw wcel vy cv
        cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv
        wrex va cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co wceq vv
        vn cv wrex vu cA wrex va cab wceq vm cv cA wceq vm cv cX cpw wcel cA cX
        cpw wcel vn cv cX cpw wcel vm cv cA cX cpw eleq1 anbi1d vm cv cA wceq
        vm cv vn cv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv
        cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2
        co cA vn cv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv
        cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2
        co va cv vu cv vv cv cG co wceq vv vn cv wrex vu vm cv wrex va cab va
        cv vu cv vv cv cG co wceq vv vn cv wrex vu cA wrex va cab vm cv cA vn
        cv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 opreq1
        vm cv cA wceq va cv vu cv vv cv cG co wceq vv vn cv wrex vu vm cv wrex
        va cv vu cv vv cv cG co wceq vv vn cv wrex vu cA wrex va va cv vu cv vv
        cv cG co wceq vv vn cv wrex vu vm cv cA rexeq1 abbidv eqeq12d imbi12d
        vn cv cB wceq cA cX cpw wcel vn cv cX cpw wcel wa cA cX cpw wcel cB cX
        cpw wcel wa cA vn cv vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu
        cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy
        vz copab2 co va cv vu cv vv cv cG co wceq vv vn cv wrex vu cA wrex va
        cab wceq cA cB vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv
        cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz
        copab2 co va cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab
        wceq vn cv cB wceq vn cv cX cpw wcel cB cX cpw wcel cA cX cpw wcel vn
        cv cB cX cpw eleq1 anbi2d vn cv cB wceq cA vn cv vx cv cX cpw wcel vy
        cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx
        cv wrex va cab wceq w3a vx vy vz copab2 co cA cB vx cv cX cpw wcel vy
        cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx
        cv wrex va cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co wceq
        vv vn cv wrex vu cA wrex va cab va cv vu cv vv cv cG co wceq vv cB wrex
        vu cA wrex va cab vn cv cB cA vx cv cX cpw wcel vy cv cX cpw wcel vz cv
        va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq
        w3a vx vy vz copab2 opreq2 vn cv cB wceq va cv vu cv vv cv cG co wceq
        vv vn cv wrex vu cA wrex va cv vu cv vv cv cG co wceq vv cB wrex vu cA
        wrex va vn cv cB wceq va cv vu cv vv cv cG co wceq vv vn cv wrex va cv
        vu cv vv cv cG co wceq vv cB wrex vu cA va cv vu cv vv cv cG co wceq vv
        vn cv cB rexeq1 rexbidv abbidv eqeq12d imbi12d vx vy vz vm cv vn cv cX
        cpw cX cpw va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va
        cab va cv vu cv vv cv cG co wceq vv vn cv wrex vu vm cv wrex va cab vx
        cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv
        vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 va cv vu cv vv
        cv cG co wceq vv vy cv wrex vu vm cv wrex va cab vu vv va vm cv vn cv
        cG vm visset vn visset oprvex vx vm weq va cv vu cv vv cv cG co wceq vv
        vy cv wrex vu vx cv wrex va cv vu cv vv cv cG co wceq vv vy cv wrex vu
        vm cv wrex va va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv vm cv
        rexeq1 abbidv vy vn weq va cv vu cv vv cv cG co wceq vv vy cv wrex vu
        vm cv wrex va cv vu cv vv cv cG co wceq vv vn cv wrex vu vm cv wrex va
        vy vn weq va cv vu cv vv cv cG co wceq vv vy cv wrex va cv vu cv vv cv
        cG co wceq vv vn cv wrex vu vm cv va cv vu cv vv cv cG co wceq vv vy cv
        vn cv rexeq1 rexbidv abbidv vx cv cX cpw wcel vy cv cX cpw wcel vz cv
        va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq
        w3a vx cv cX cpw wcel vy cv cX cpw wcel wa vz cv va cv vu cv vv cv cG
        co wceq vv vy cv wrex vu vx cv wrex va cab wceq wa vx vy vz vx cv cX
        cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv
        wrex vu vx cv wrex va cab wceq df-3an oprabbii oprabval2 vtocl2g
        pm2.43i 3adant1 cG cM wcel cA cX cpw wcel cB cX cpw wcel cA cB cH co va
        cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab wceq cA cB vx cv
        cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy
        cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 co va cv vu cv vv
        cv cG co wceq vv cB wrex vu cA wrex va cab wceq wb cG cM wcel cH vx cv
        cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy
        cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 wceq cA cX cpw
        wcel cB cX cpw wcel cA cB cH co va cv vu cv vv cv cG co wceq vv cB wrex
        vu cA wrex va cab wceq cA cB vx cv cX cpw wcel vy cv cX cpw wcel vz cv
        va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq
        w3a vx vy vz copab2 co va cv vu cv vv cv cG co wceq vv cB wrex vu cA
        wrex va cab wceq wb wi wi vx vy vz vv vu cM cG cH cX va iscst1.1
        iscst1.2 iscst1 cA cX cpw wcel cB cX cpw wcel cH vx cv cX cpw wcel vy
        cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu vx
        cv wrex va cab wceq w3a vx vy vz copab2 wceq cA cB cH co va cv vu cv vv
        cv cG co wceq vv cB wrex vu cA wrex va cab wceq cA cB vx cv cX cpw wcel
        vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co wceq vv vy cv wrex vu
        vx cv wrex va cab wceq w3a vx vy vz copab2 co va cv vu cv vv cv cG co
        wceq vv cB wrex vu cA wrex va cab wceq wb cA cX cpw wcel cB cX cpw wcel
        cH vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 wceq
        cA cB cH co va cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab
        wceq cA cB vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv
        cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2
        co va cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab wceq wb wi
        cH vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 wceq
        cA cB cH co cA cB vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv
        vv cv cG co wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz
        copab2 co va cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab cA
        cB cH vx cv cX cpw wcel vy cv cX cpw wcel vz cv va cv vu cv vv cv cG co
        wceq vv vy cv wrex vu vx cv wrex va cab wceq w3a vx vy vz copab2 opreq
        eqeq1d a1i12 com3r syl 3imp mpbird $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}

    ${
      $d A a u v $. $d B a u v $. $d C a u v $. $d G a u v $.
      $( Property equivalent to the fact of belonging to the value of
         a pair through the derived operation. $)
      iscst3 $p |- ( ( C e. D /\ ( G e. M /\ A e. ~P X /\ B e. ~P X ) ) ->
        ( C e. ( A H B ) <->
           E. u e. A E. v e. B C = ( u G v ) ) ) $=
        cC cD wcel cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a wa cC cA cB cH
        co wcel cC va cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cab
        wcel cC vu cv vv cv cG co wceq vv cB wrex vu cA wrex cC cD wcel cG cM
        wcel cA cX cpw wcel cB cX cpw wcel w3a wa cA cB cH co va cv vu cv vv cv
        cG co wceq vv cB wrex vu cA wrex va cab cC cG cM wcel cA cX cpw wcel cB
        cX cpw wcel w3a cA cB cH co va cv vu cv vv cv cG co wceq vv cB wrex vu
        cA wrex va cab wceq cC cD wcel vv vu cA cB cG cH cM cX va iscst1.1
        iscst1.2 iscst2 adantl eleq2d cC cD wcel cC va cv vu cv vv cv cG co
        wceq vv cB wrex vu cA wrex va cab wcel cC vu cv vv cv cG co wceq vv cB
        wrex vu cA wrex wb cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a va cv
        vu cv vv cv cG co wceq vv cB wrex vu cA wrex cC vu cv vv cv cG co wceq
        vv cB wrex vu cA wrex va cC cD va cv cC wceq va cv vu cv vv cv cG co
        wceq cC vu cv vv cv cG co wceq vu vv cA cB va cv cC vu cv vv cv cG co
        eqeq1 2rexbidv elabg adantr bitrd $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}

    ${
      $d A a u x $. $d B a u v x $. $d G a u v x $. $d G a u w x $.
      $d M a u x $. $d X a u x $.
      $( The value of the couple ` <. A , B >. ` through
         the derived operation ` H ` (expressed with a union). $)
      iscst4 $p |- ( ( G e. M /\ A e. ~P X /\ B e. ~P X )
        -> ( A H B ) = U_ x e. B ( A H { x } ) ) $=
        cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a cA cB cH co va cv vu cv vv
        cv cG co wceq vv cB wrex vu cA wrex va cab vx cB va cv vu cv vw cv cG
        co wceq vw vx cv csn wrex vu cA wrex va cab ciun vx cB cA vx cv csn cH
        co ciun vv vu cA cB cG cH cM cX va iscst1.1 iscst1.2 iscst2 cG cM wcel
        cA cX cpw wcel cB cX cpw wcel w3a va cv vu cv vv cv cG co wceq vv cB
        wrex vu cA wrex va cab va cv vu cv vw cv cG co wceq vw vx cv csn wrex
        vu cA wrex vx cB wrex va cab vx cB va cv vu cv vw cv cG co wceq vw vx
        cv csn wrex vu cA wrex va cab ciun cG cM wcel cA cX cpw wcel cB cX cpw
        wcel w3a va cv vu cv vv cv cG co wceq vv cB wrex vu cA wrex va cv vu cv
        vw cv cG co wceq vw vx cv csn wrex vu cA wrex vx cB wrex va cG cM wcel
        cA cX cpw wcel cB cX cpw wcel w3a va cv vu cv vv cv cG co wceq vv cB
        wrex vu cA wrex va cv vu cv vw cv cG co wceq vw vx cv csn wrex vx cB
        wrex vu cA wrex va cv vu cv vw cv cG co wceq vw vx cv csn wrex vu cA
        wrex vx cB wrex cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a va cv vu
        cv vv cv cG co wceq vv cB wrex va cv vu cv vw cv cG co wceq vw vx cv
        csn wrex vx cB wrex vu cA cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a
        va cv vu cv vx cv cG co wceq vx cB wrex va cv vu cv vw cv cG co wceq vw
        vx cv csn wrex vx cB wrex va cv vu cv vv cv cG co wceq vv cB wrex va cv
        vu cv vx cv cG co wceq vx cB wrex va cv vu cv vw cv cG co wceq vw vx cv
        csn wrex vx cB wrex wb cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a va
        cv vu cv vx cv cG co wceq va cv vu cv vw cv cG co wceq vw vx cv csn
        wrex vx cB va cv vu cv vw cv cG co wceq vw vx cv csn wrex vw cv vx cv
        csn wcel va cv vu cv vw cv cG co wceq wa vw wex vw vx weq va cv vu cv
        vw cv cG co wceq wa vw wex va cv vu cv vx cv cG co wceq va cv vu cv vw
        cv cG co wceq vw vx cv csn df-rex vw cv vx cv csn wcel va cv vu cv vw
        cv cG co wceq wa vw vx weq va cv vu cv vw cv cG co wceq wa vw vw cv vx
        cv csn wcel vw vx weq va cv vu cv vw cv cG co wceq vw vx cv elsn anbi1i
        exbii va cv vu cv vw cv cG co wceq va cv vu cv vx cv cG co wceq vw vx
        cv vx visset vw vx weq vu cv vw cv cG co vu cv vx cv cG co va cv vw cv
        vx cv vu cv cG opreq2 eqeq2d ceqsexv 3bitrri rexbii a1i va cv vu cv vv
        cv cG co wceq va cv vu cv vx cv cG co wceq vv vx cB vv vx weq vu cv vv
        cv cG co vu cv vx cv cG co va cv vv cv vx cv vu cv cG opreq2 eqeq2d
        cbvrexv syl5bb rexbidv va cv vu cv vw cv cG co wceq vw vx cv csn wrex
        vu vx cA cB rexcom syl6bb abbidv va cv vu cv vw cv cG co wceq vw vx cv
        csn wrex vu cA wrex vx va cB iunab syl6eqr cG cM wcel cA cX cpw wcel cB
        cX cpw wcel w3a cA vx cv csn cH co va cv vu cv vw cv cG co wceq vw vx
        cv csn wrex vu cA wrex va cab wceq vx cB wral vx cB va cv vu cv vw cv
        cG co wceq vw vx cv csn wrex vu cA wrex va cab ciun vx cB cA vx cv csn
        cH co ciun wceq cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a cA vx cv
        csn cH co va cv vu cv vw cv cG co wceq vw vx cv csn wrex vu cA wrex va
        cab wceq vx cB cG cM wcel cA cX cpw wcel vx cv csn cX cpw wcel cA vx cv
        csn cH co va cv vu cv vw cv cG co wceq vw vx cv csn wrex vu cA wrex va
        cab wceq cG cM wcel cA cX cpw wcel cB cX cpw wcel w3a vx cv cB wcel wa
        vw vu cA vx cv csn cG cH cM cX va iscst1.1 iscst1.2 iscst2 cG cM wcel
        cA cX cpw wcel cB cX cpw wcel vx cv cB wcel 3simpl1 cG cM wcel cA cX
        cpw wcel cB cX cpw wcel vx cv cB wcel 3simpl2 cB cX cpw wcel cG cM wcel
        vx cv cB wcel vx cv csn cX cpw wcel cA cX cpw wcel cB cX cpw wcel vx cv
        cB wcel wa vx cv cX wcel vx cv csn cX cpw wcel vx cv cB wcel cB cX cpw
        wcel vx cv cX wcel vx cv cB cX bepart ancoms vx cv cX vx visset snelpw
        sylib 3ad2antl3 syl3anc r19.21aiva cA vx cv csn cH co va cv vu cv vw cv
        cG co wceq vw vx cv csn wrex vu cA wrex va cab wceq vx cB wral vx cB cA
        vx cv csn cH co ciun vx cB va cv vu cv vw cv cG co wceq vw vx cv csn
        wrex vu cA wrex va cab ciun vx cB cA vx cv csn cH co va cv vu cv vw cv
        cG co wceq vw vx cv csn wrex vu cA wrex va cab iuneq2 eqcomd syl 3eqtrd
        $.
        $( [31-Dec-2010] $) $( [31-Dec-2010] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)



  ${
    3timesi.1 $e |- A e. CC $.
    $( Three times a number. $)
    3timesi $p |- ( 3 x. A ) = ( A + ( A + A ) ) $=
      c3 cA cmul co c2 c1 caddc co cA cmul co cA cA cA caddc co caddc co c3 c2
      c1 caddc co cA cmul df-3 opreq1i c2 c1 caddc co cA cmul co c2 cA cmul co
      c1 cA cmul co caddc co cA cA cA caddc co caddc co c2 c1 cA 2cn ax1cn
      3timesi.1 adddiri c2 cA cmul co c1 cA cmul co caddc co cA cA caddc co cA
      caddc co cA cA cA caddc co caddc co c2 cA cmul co cA cA caddc co c1 cA
      cmul co cA caddc cA 3timesi.1 2timesi cA 3timesi.1 mulid2i opreq12i cA cA
      caddc co cA cA cA 3timesi.1 3timesi.1 addcli 3timesi.1 addcomi eqtri
      eqtri eqtri $.
      $( [17-Oct-2010] $) $( [17-Oct-2010] $)
  $}

  $( The number 3 is nonzero. $)
  3ne0 $p |- 3 =/= 0 $=
    c3 cc0 wne c3 cc0 wne c3 3re 3pos gt0ne0ii notnoti notnotri $.
    $( [17-Oct-2010] $) $( [17-Oct-2010] $)

  $( The number 3 is a complex number. $)
  3cn $p |- 3 e. CC $=
    c3 c3 3nn nnrei recni $.
    $( [17-Oct-2010] $) $( [17-Oct-2010] $)

  $( ` 2 ` equals ` 3 ` minus ` 1 `. $)
  2eq3m1 $p |- 2 = ( 3 - 1 ) $=
    c3 c1 cmin co c2 c3 c1 c2 3cn ax1cn 2cn c1 c2 caddc co c2 c1 caddc co c3 c1
    c2 ax1cn 2cn addcomi df-3 eqtr4i subaddrii eqcomi $.
    $( [17-Oct-2010] $) $( [17-Oct-2010] $)

  ${
    $d N x y z $.
    $( Two ways to define ` n ZZ ` . $)
    nZdef $p |- ( N e. ZZ -> ( { N } ( cset ` ( x. |` ( ZZ X. ZZ ) ) ) ZZ ) =
      { x | E. y e. ZZ x = ( N x. y ) } ) $=
      cN cz wcel cN csn cz cmul cz cz cxp cres ccst cfv co vx cv vz cv vy cv
      cmul cz cz cxp cres co wceq vy cz wrex vz cN csn wrex vx cab vx cv cN vy
      cv cmul co wceq vy cz wrex vx cab cmul cz cz cxp cres cvv wcel cN csn cz
      cpw wcel cz cz cpw wcel cN csn cz cmul cz cz cxp cres ccst cfv co vx cv
      vz cv vy cv cmul cz cz cxp cres co wceq vy cz wrex vz cN csn wrex vx cab
      wceq cN cz wcel vy vz cN csn cz cmul cz cz cxp cres cmul cz cz cxp cres
      ccst cfv cvv cz vx cmul cdm cc cc cxp wceq cmul cz cz cxp cres cdm cz cz
      cxp cmul cdm cin wceq cz cmul cz cz cxp cres cdm cdm wceq cc cc cxp cc
      cmul axmulopr fdmi cmul cz cz cxp dmres cmul cz cz cxp cres cdm cz cz cxp
      cmul cdm cin wceq cz cz cxp cmul cdm cin cz cz cxp cc cc cxp cin wceq cz
      cmul cz cz cxp cres cdm cdm wceq cmul cdm cc cc cxp wceq cmul cz cz cxp
      cres cdm cz cz cxp cmul cdm cin wceq cz cz cxp cmul cdm cin cz cz cxp cc
      cc cxp cin wceq cz cmul cz cz cxp cres cdm cdm wceq cmul cz cz cxp cres
      cdm cz cz cxp cmul cdm cin wceq cz cz cxp cmul cdm cin cz cz cxp cc cc
      cxp cin wceq wa cmul cz cz cxp cres cdm cz cz cxp cc cc cxp cin wceq cz
      cmul cz cz cxp cres cdm cdm wceq cmul cz cz cxp cres cdm cz cz cxp cmul
      cdm cin cz cz cxp cc cc cxp cin eqtr cz cc cin cz wceq cz cz cxp cc cc
      cxp cin cz cc cin cz cc cin cxp wceq cmul cz cz cxp cres cdm cz cz cxp cc
      cc cxp cin wceq cz cmul cz cz cxp cres cdm cdm wceq wi cz cc wss cz cc
      cin cz wceq zsscn cz cc df-ss mpbi cz cz cc cc inxp cz cc cin cz wceq cz
      cc cin cz cc cin cxp cz cz cxp wceq cz cz cxp cc cc cxp cin cz cc cin cz
      cc cin cxp wceq cmul cz cz cxp cres cdm cz cz cxp cc cc cxp cin wceq cz
      cmul cz cz cxp cres cdm cdm wceq wi wi cz cc cin cz xpid11 cz cz cxp cc
      cc cxp cin cz cc cin cz cc cin cxp wceq cz cc cin cz cc cin cxp cz cz cxp
      wceq cmul cz cz cxp cres cdm cz cz cxp cc cc cxp cin wceq cz cmul cz cz
      cxp cres cdm cdm wceq wi cmul cz cz cxp cres cdm cz cz cxp cc cc cxp cin
      wceq cz cz cxp cc cc cxp cin cz cz cxp wceq cz cmul cz cz cxp cres cdm
      cdm wceq cz cz cxp cc cc cxp cin cz cc cin cz cc cin cxp wceq cz cc cin
      cz cc cin cxp cz cz cxp wceq wa cmul cz cz cxp cres cdm cz cz cxp cc cc
      cxp cin wceq cz cz cxp cc cc cxp cin cz cz cxp wceq cz cmul cz cz cxp
      cres cdm cdm wceq cmul cz cz cxp cres cdm cz cz cxp cc cc cxp cin wceq cz
      cz cxp cc cc cxp cin cz cz cxp wceq wa cmul cz cz cxp cres cdm cz cz cxp
      wceq cz cmul cz cz cxp cres cdm cdm wceq cmul cz cz cxp cres cdm cz cz
      cxp cc cc cxp cin cz cz cxp eqtr cmul cz cz cxp cres cdm cz cz cxp wceq
      cmul cz cz cxp cres cdm cdm cz cz cxp cdm cz cmul cz cz cxp cres cdm cz
      cz cxp dmeq cz dmxpid syl6req syl ex cz cz cxp cc cc cxp cin cz cc cin cz
      cc cin cxp cz cz cxp eqtr syl5com expcom sylbir mp2 syl ex cmul cdm cc cc
      cxp cz cz cxp ineq2 syl5com mp2 cmul cz cz cxp cres ccst cfv eqid iscst2
      cmul cz cz cxp cres cvv wcel cN cz wcel cmul cvv wcel cmul cz cz cxp cres
      cvv wcel mulex cmul cz cz cxp cvv resexg ax-mp a1i cN cz wcel cN csn cz
      cpw wcel vx cv cz wcel vx cv csn cz cpw wcel cN cz wcel cN csn cz cpw
      wcel vx cN cz vx cv cN cz eleq1 vx cv cN wceq vx cv csn cN csn cz cpw vx
      cv cN sneq eleq1d vx cv cz vx visset snelpw vtoclbg ibi cz cz cpw wcel cN
      cz wcel cz zex pwid a1i syl3anc cN cz wcel vx cv vz cv vy cv cmul cz cz
      cxp cres co wceq vy cz wrex vz cN csn wrex vx cv cN vy cv cmul co wceq vy
      cz wrex vx cN cz wcel vx cv vz cv vy cv cmul cz cz cxp cres co wceq vy cz
      wrex vz cN csn wrex vx cv cN vy cv cmul co wceq vy cz wrex cN cz wcel vx
      cv vz cv vy cv cmul cz cz cxp cres co wceq vz cN csn wrex vy cz wrex vx
      cv cN vy cv cmul co wceq vy cz wrex vx cv vz cv vy cv cmul cz cz cxp cres
      co wceq vy cz wrex vz cN csn wrex cN cz wcel vx cv vz cv vy cv cmul cz cz
      cxp cres co wceq vz cN csn wrex vx cv cN vy cv cmul co wceq vy cz vx cv
      vz cv vy cv cmul cz cz cxp cres co wceq vz cN csn wrex cN cz wcel vy cv
      cz wcel wa vx cv cN vy cv cmul co wceq vx cv vz cv vy cv cmul cz cz cxp
      cres co wceq cN cz wcel vy cv cz wcel wa vx cv cN vy cv cmul co wceq wi
      vz cN csn vz cv cN csn wcel vz cv cN wceq vx cv vz cv vy cv cmul cz cz
      cxp cres co wceq cN cz wcel vy cv cz wcel wa vx cv cN vy cv cmul co wceq
      wi wi vz cv cN elsni vz cv cN wceq vx cv vz cv vy cv cmul cz cz cxp cres
      co wceq vx cv cN vy cv cmul cz cz cxp cres co wceq cN cz wcel vy cv cz
      wcel wa vx cv cN vy cv cmul co wceq wi vz cv cN wceq vz cv vy cv cmul cz
      cz cxp cres co cN vy cv cmul cz cz cxp cres co vx cv vz cv cN vy cv cmul
      cz cz cxp cres opreq1 eqeq2d cN cz wcel vy cv cz wcel wa vx cv cN vy cv
      cmul cz cz cxp cres co wceq vx cv cN vy cv cmul co wceq cN cz wcel vy cv
      cz wcel wa cN vy cv cmul cz cz cxp cres co cN vy cv cmul co vx cv cN vy
      cv cz cz cmul oprvres eqeq2d biimpcd syl6bi syl r19.23aiv com12 r19.22dva
      vx cv vz cv vy cv cmul cz cz cxp cres co wceq vz vy cN csn cz rexcom
      syl5ib cN cz wcel vx cv cN vy cv cmul co wceq vy cz wrex vx cv vz cv vy
      cv cmul cz cz cxp cres co wceq vz cN csn wrex vy cz wrex vx cv vz cv vy
      cv cmul cz cz cxp cres co wceq vy cz wrex vz cN csn wrex cN cz wcel vx cv
      cN vy cv cmul co wceq vx cv vz cv vy cv cmul cz cz cxp cres co wceq vz cN
      csn wrex vy cz vx cv cN vy cv cmul co wceq vx cv vz cv vy cv cmul cz cz
      cxp cres co wceq vz cN csn wrex cN vy cv cmul co vz cv vy cv cmul cz cz
      cxp cres co wceq vz cN csn wrex cN cz wcel vy cv cz wcel wa vx cv cN vy
      cv cmul co wceq vx cv vz cv vy cv cmul cz cz cxp cres co wceq cN vy cv
      cmul co vz cv vy cv cmul cz cz cxp cres co wceq vz cN csn vx cv cN vy cv
      cmul co wceq vz cv cN csn wcel wa vx cv cN vy cv cmul co vz cv vy cv cmul
      cz cz cxp cres co vx cv cN vy cv cmul co wceq vz cv cN csn wcel pm3.26
      eqeq1d rexbidva cN cN csn wcel cN vy cv cmul co cN vy cv cmul cz cz cxp
      cres co wceq cN vy cv cmul co vz cv vy cv cmul cz cz cxp cres co wceq vz
      cN csn wrex cN cz wcel vy cv cz wcel wa cN vy cv cmul co vz cv vy cv cmul
      cz cz cxp cres co wceq cN vy cv cmul co cN vy cv cmul cz cz cxp cres co
      wceq vz cN cN csn vz cv cN wceq vz cv vy cv cmul cz cz cxp cres co cN vy
      cv cmul cz cz cxp cres co cN vy cv cmul co vz cv cN vy cv cmul cz cz cxp
      cres opreq1 eqeq2d rcla4ev cN cz wcel cN cN csn wcel vy cv cz wcel cN cz
      snidg adantr cN cz wcel vy cv cz wcel wa cN vy cv cmul cz cz cxp cres co
      cN vy cv cmul co cN vy cv cz cz cmul oprvres eqcomd sylanc syl5cbir
      r19.22dva vx cv vz cv vy cv cmul cz cz cxp cres co wceq vz vy cN csn cz
      rexcom syl6ibr impbid abbidv eqtrd $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Sequences and series
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d A x $. $d C k u x $. $d F u x $. $d G u x $. $d M k x $.
    iserzmulc1b.1 $e |- A e. _V $.
    iserzmulc1b.2 $e |- F e. _V $.
    iserzmulc1b.3 $e |- G e. _V $.
    iserzmulc1b.4 $e |- ( x e. F -> A. k x e. F ) $.
    iserzmulc1b.5 $e |- ( x e. G -> A. k x e. G ) $.
    $( Multiplication of an infinite series by a constant. $)
    iserzmulc1b $p |- ( ( M e. ZZ /\ C e. CC /\ A. k e. ( ZZ>= ` M )
       ( ( F ` k ) e. CC /\ ( G ` k ) = ( C x. ( F ` k ) ) ) ) ->
     ( ( <. M , + >. seq F ) ~~> A ->
       ( <. M , + >. seq G ) ~~> ( C x. A ) ) ) $=
      cM cz wcel cC cc wcel vx cv cF cfv cc wcel vx cv cG cfv cC vx cv cF cfv
      cmul co wceq wa vx cM cuz cfv wral cM caddc cop cF cseqz co cA cli wbr cM
      caddc cop cG cseqz co cC cA cmul co cli wbr wi vk cv cF cfv cc wcel vk cv
      cG cfv cC vk cv cF cfv cmul co wceq wa vk cM cuz cfv wral cA cC vx cF cG
      cM iserzmulc1b.1 iserzmulc1b.2 iserzmulc1b.3 iserzmulc1 vx cv cF cfv cc
      wcel vx cv cG cfv cC vx cv cF cfv cmul co wceq wa vk cv cF cfv cc wcel vk
      cv cG cfv cC vk cv cF cfv cmul co wceq wa vx vk cM cuz cfv vx cv cF cfv
      cc wcel vx cv cG cfv cC vx cv cF cfv cmul co wceq vk vk vu vu vx cv cF
      cfv cc vk vu vx cv cF vk vx vu cF iserzmulc1b.4 hblem vu vx wel vk ax-17
      hbfv vu cv cc wcel vk ax-17 hbel vk vu vu vx cv cG cfv cC vx cv cF cfv
      cmul co vk vu vx cv cG vk vx vu cG iserzmulc1b.5 hblem vu vx wel vk ax-17
      hbfv vk vu cC vx cv cF cfv cmul vu cv cC wcel vk ax-17 vu cv cmul wcel vk
      ax-17 vk vu vx cv cF vk vx vu cF iserzmulc1b.4 hblem vu vx wel vk ax-17
      hbfv hbopr hbeq hban vk cv cF cfv cc wcel vk cv cG cfv cC vk cv cF cfv
      cmul co wceq wa vx ax-17 vx vk weq vx cv cF cfv cc wcel vk cv cF cfv cc
      wcel vx cv cG cfv cC vx cv cF cfv cmul co wceq vk cv cG cfv cC vk cv cF
      cfv cmul co wceq vx vk weq vx cv cF cfv vk cv cF cfv cc vx cv vk cv cF
      fveq2 eleq1d vx vk weq vx cv cG cfv vk cv cG cfv cC vx cv cF cfv cmul co
      cC vk cv cF cfv cmul co vx cv vk cv cG fveq2 vx vk weq vx cv cF cfv vk cv
      cF cfv cC cmul vx cv vk cv cF fveq2 opreq2d eqeq12d anbi12d cbvral
      syl3an3br $.
      $( [17-Oct-2010] $) $( [17-Oct-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Lattice (algebraic definition)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $c LatAlg $.

  $( Extend class notation to include the class of lattices. $)
  clatalg $a class LatAlg $.

  ${ $d j m t x y z $.
  $( Algebraic definition of a lattice. ` j ` is called the join
     of the lattice (and is denoted by ` \/ ` in textbooks) ,
     ` m ` is called the meet (and is denoted
     by ` /\ ` in textbooks). $)
  df-latalg $a |- LatAlg = { <. j , m >. | E. t ( j : ( t X. t ) --> t /\
    m : ( t X. t ) --> t /\
    A. x e. t A. y e. t ( ( x j y ) = ( y j x ) /\  ( x m y ) = ( y m x ) /\
     ( ( x m ( x j y ) ) = x /\ ( x j ( x m y ) ) = x /\
     A. z e. t ( ( x m ( y m z ) ) = ( ( x m y ) m z ) /\
                 ( x j ( y j z ) ) = ( ( x j y ) j z ) ) ) ) ) } $.
   $}

  ${ $d J j m t x y z $. $d M j m x y z $. $d X j m t x y z $.
    islatalg.1 $e |- X = dom dom J $.
    $( The predicate "is a lattice". $)
    islatalg $p |- ( ( J e. A /\ M e. B ) -> ( <. J , M >. e. LatAlg <->
   ( J : ( X X. X ) --> X /\ M : ( X X. X ) --> X /\
    A. x e. X A. y e. X ( ( x J y ) = ( y J x ) /\  ( x M y ) = ( y M x ) /\
     ( ( x M ( x J y ) ) = x /\ ( x J ( x M y ) ) = x /\
     A. z e. X ( ( x M ( y M z ) ) = ( ( x M y ) M z ) /\
                 ( x J ( y J z ) ) = ( ( x J y ) J z ) ) ) ) ) ) ) $=
      cJ cA wcel cM cB wcel wa cJ cM cop clatalg wcel cJ cM cop vt cv vt cv cxp
      vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv co vy cv
      vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv
      vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co vj cv
      co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz
      cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co
      vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral
      w3a vt wex vj vm copab wcel cX cX cxp cX cJ wf cX cX cxp cX cM wf vx cv
      vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co
      wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ
      co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co
      wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa
      vz cX wral w3a w3a vy cX wral vx cX wral w3a cJ cA wcel cM cB wcel wa
      clatalg vt cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vx
      cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx
      cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx
      cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co
      vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv
      co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy
      vt cv wral vx vt cv wral w3a vt wex vj vm copab cJ cM cop clatalg vt cv
      vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv
      co vy cv vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co
      wceq vx cv vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm
      cv co vj cv co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv
      vm cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy
      cv vj cv co vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx
      vt cv wral w3a vt wex vj vm copab wceq cJ cA wcel cM cB wcel wa vx vy vz
      vt vj vm df-latalg a1i eleq2d vt cv vt cv cxp vt cv vj cv wf vt cv vt cv
      cxp vt cv vm cv wf vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv
      vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv
      co vx cv wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv
      vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy
      cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz
      vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a vt wex cX cX cxp cX cJ
      wf cX cX cxp cX vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv
      vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co
      vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv
      vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz
      cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a w3a
      vy cX wral vx cX wral w3a cX cX cxp cX cJ wf cX cX cxp cX cM wf vx cv vy
      cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co wceq
      vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx
      cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq
      vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX
      wral w3a w3a vy cX wral vx cX wral w3a vj vm cJ cM cA cB vj cv cJ wceq vt
      cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj
      cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co
      wceq vx cv vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm
      cv co vj cv co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv
      vm cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy
      cv vj cv co vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx
      vt cv wral w3a vt wex vt cv vj cv cdm cdm wceq vt cv vt cv cxp vt cv vj
      cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv co vy cv vx cv vj
      cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy
      cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co vj cv co vx cv
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj
      cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a wa vt
      wex vt cv cX wceq vt cv vt cv cxp vt cv cJ wf vt cv vt cv cxp vt cv vm cv
      wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx
      cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv
      vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv
      vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy
      cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv
      wral w3a wa vt wex cX cX cxp cX cJ wf cX cX cxp cX vm cv wf vx cv vy cv
      cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co
      wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv
      co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv
      co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz
      cv cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cX wral w3a vt cv vt cv
      cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv co vy
      cv vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx
      cv vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co vj
      cv co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co
      vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv
      co vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv
      wral w3a vt wex vt cv vj cv cdm cdm wceq vt cv vt cv cxp vt cv vj cv wf
      vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv co vy cv vx cv vj cv co
      wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj
      cv co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq
      vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co
      wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv
      co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a wa vt
      wex wb vj cv cJ wceq vt cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv
      vm cv wf vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv
      co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv
      wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm
      cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv
      vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv
      wral w3a w3a vy vt cv wral vx vt cv wral w3a vt cv vj cv cdm cdm wceq vt
      cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj
      cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co
      wceq vx cv vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm
      cv co vj cv co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv
      vm cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy
      cv vj cv co vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx
      vt cv wral w3a wa vt vt cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv
      vm cv wf vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv
      co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv
      wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm
      cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv
      vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv
      wral w3a w3a vy vt cv wral vx vt cv wral w3a vt cv vj cv cdm cdm wceq vt
      cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv wf vt cv vj cv
      cdm cdm wceq vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv
      vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv co vx
      cv wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv
      vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz
      cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv
      wral w3a w3a vy vt cv wral vx vt cv wral vt cv vt cv cxp vt cv vj cv wf
      vj cv cdm vt cv vt cv cxp wceq vt cv vj cv cdm cdm wceq vt cv vt cv cxp
      vt cv vj cv fdm vt cv vj cv cdm cdm wceq vt cv vt cv cxp vj cv cdm vt cv
      vt cv cxp vj cv cdm wceq vt cv vt cv cxp cdm vj cv cdm cdm vt cv vt cv vt
      cv cxp vj cv cdm dmeq vt cv dmxpid syl5eqr eqcoms syl 3ad2ant1 pm4.71ri
      exbii a1i vj cv cJ wceq vt cv vj cv cdm cdm wceq vt cv vt cv cxp vt cv vj
      cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv co vy cv vx cv vj
      cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy
      cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co vj cv co vx cv
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj
      cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a wa vt
      wex vt cv cJ cdm cdm wceq vt cv vt cv cxp vt cv cJ wf vt cv vt cv cxp vt
      cv vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co
      vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx
      cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv
      co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co
      vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a vy vt cv wral
      vx vt cv wral w3a wa vt wex vt cv cX wceq vt cv vt cv cxp vt cv cJ wf vt
      cv vt cv cxp vt cv vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx
      cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv
      co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz
      cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv
      vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a
      w3a vy vt cv wral vx vt cv wral w3a wa vt wex vj cv cJ wceq vt cv vj cv
      cdm cdm wceq vt cv vt cv cxp vt cv vj cv wf vt cv vt cv cxp vt cv vm cv
      wf vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv co vy
      cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv wceq vx
      cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm cv co vm
      cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co
      vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv wral w3a
      w3a vy vt cv wral vx vt cv wral w3a wa vt cv cJ cdm cdm wceq vt cv vt cv
      cxp vt cv cJ wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv cJ co vy cv vx
      cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv
      vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq
      wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a wa vt vj cv cJ
      wceq vt cv vj cv cdm cdm wceq vt cv cJ cdm cdm wceq vt cv vt cv cxp vt cv
      vj cv wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv vj cv co vy cv vx cv
      vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv
      vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co vj cv co vx
      cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm
      cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv
      vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a vt
      cv vt cv cxp vt cv cJ wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv cJ co
      vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx
      cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co
      vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv
      vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a vj cv cJ
      wceq vj cv cdm cdm cJ cdm cdm vt cv vj cv cJ wceq vj cv cdm cJ cdm vj cv
      cJ dmeq dmeqd eqeq2d vj cv cJ wceq vt cv vt cv cxp vt cv vj cv wf vt cv
      vt cv cxp vt cv cJ wf vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx
      cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm
      cv co vx cv wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy
      cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv
      vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa
      vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral vx cv vy cv cJ co vy cv
      vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx
      cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq
      wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral vt cv vt cv cxp vt
      cv vm cv wf vt cv vt cv cxp vt cv vj cv cJ feq1 vj cv cJ wceq vx cv vy cv
      vj cv co vy cv vx cv vj cv co wceq vx cv vy cv vm cv co vy cv vx cv vm cv
      co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv wceq vx cv vx cv vy cv
      vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy
      cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv
      vy cv vj cv co vz cv vj cv co wceq wa vz vt cv wral w3a w3a vy vt cv wral
      vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv
      vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy
      cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy
      cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv
      cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv vj
      cv cJ wceq vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv vm
      cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv
      wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm
      cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv
      vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv
      wral w3a w3a vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv
      co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq
      vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm
      cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ
      co vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a vy vt cv
      vj cv cJ wceq vx cv vy cv vj cv co vy cv vx cv vj cv co wceq vx cv vy cv
      cJ co vy cv vx cv cJ co wceq vx cv vx cv vy cv vj cv co vm cv co vx cv
      wceq vx cv vx cv vy cv vm cv co vj cv co vx cv wceq vx cv vy cv vz cv vm
      cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv
      vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq wa vz vt cv
      wral w3a vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm
      cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm
      cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co
      vz cv cJ co wceq wa vz vt cv wral w3a vx cv vy cv vm cv co vy cv vx cv vm
      cv co wceq vj cv cJ wceq vx cv vy cv vj cv co vx cv vy cv cJ co vy cv vx
      cv vj cv co vy cv vx cv cJ co vx cv vy cv vj cv cJ opreq vy cv vx cv vj
      cv cJ opreq eqeq12d vj cv cJ wceq vx cv vx cv vy cv vj cv co vm cv co vx
      cv wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm
      cv co vj cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx
      cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq
      vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co
      wceq wa vz vt cv wral vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm
      cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co
      vz cv cJ co wceq wa vz vt cv wral vj cv cJ wceq vx cv vx cv vy cv vj cv
      co vm cv co vx cv vx cv vy cv cJ co vm cv co vx cv vj cv cJ wceq vx cv vy
      cv vj cv co vx cv vy cv cJ co vx cv vm cv vx cv vy cv vj cv cJ opreq
      opreq2d eqeq1d vj cv cJ wceq vx cv vx cv vy cv vm cv co vj cv co vx cv vx
      cv vy cv vm cv co cJ co vx cv vx cv vx cv vy cv vm cv co vj cv cJ opreq
      eqeq1d vj cv cJ wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm
      cv co vz cv vm cv co wceq vx cv vy cv vz cv vj cv co vj cv co vx cv vy cv
      vj cv co vz cv vj cv co wceq wa vx cv vy cv vz cv vm cv co vm cv co vx cv
      vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy
      cv cJ co vz cv cJ co wceq wa vz vt cv vj cv cJ wceq vx cv vy cv vz cv vj
      cv co vj cv co vx cv vy cv vj cv co vz cv vj cv co wceq vx cv vy cv vz cv
      cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq vx cv vy cv vz cv vm cv co
      vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vj cv cJ wceq vx cv vy
      cv vz cv vj cv co vj cv co vx cv vy cv vz cv cJ co cJ co vx cv vy cv vj
      cv co vz cv vj cv co vx cv vy cv cJ co vz cv cJ co vj cv cJ wceq vx cv vx
      cv vy cv vz cv vj cv co vy cv vz cv cJ co vj cv cJ vj cv cJ wceq id vj cv
      cJ wceq vx cv eqidd vy cv vz cv vj cv cJ opreq opreq123d vj cv cJ wceq vx
      cv vy cv vj cv co vx cv vy cv cJ co vz cv vz cv vj cv cJ vj cv cJ wceq id
      vx cv vy cv vj cv cJ opreq vj cv cJ wceq vz cv eqidd opreq123d eqeq12d
      anbi2d ralbidv 3anbi123d 3anbi13d ralbidv ralbidv 3anbi13d anbi12d exbidv
      vj cv cJ wceq vt cv cJ cdm cdm wceq vt cv vt cv cxp vt cv cJ wf vt cv vt
      cv cxp vt cv vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy
      cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx
      cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm
      cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv
      cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a
      vy vt cv wral vx vt cv wral w3a wa vt cv cX wceq vt cv vt cv cxp vt cv cJ
      wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co
      wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ
      co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv
      vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx
      cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv
      wral w3a w3a vy vt cv wral vx vt cv wral w3a wa vt vj cv cJ wceq vt cv cJ
      cdm cdm wceq vt cv cX wceq vt cv vt cv cxp vt cv cJ wf vt cv vt cv cxp vt
      cv vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co
      vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx
      cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv
      co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co
      vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a vy vt cv wral
      vx vt cv wral w3a vt cv cJ cdm cdm wceq vt cv cX wceq wb vj cv cJ wceq cJ
      cdm cdm cX vt cv cX cJ cdm cdm islatalg.1 eqcomi eqeq2i a1i anbi1d exbidv
      bitrd vj cv cJ wceq cX cvv wcel vt cv cX wceq vt cv vt cv cxp vt cv cJ wf
      vt cv vt cv cxp vt cv vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq
      vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm
      cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv
      vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy
      cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral
      w3a w3a vy vt cv wral vx vt cv wral w3a wa vt wex cX cX cxp cX cJ wf cX
      cX cxp cX vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv
      vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv
      wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv
      co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ
      co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a w3a vy cX
      wral vx cX wral w3a wb vj cv cJ wceq vj cv cdm cJ cdm wceq vj cv cdm cdm
      cJ cdm cdm wceq cX cvv wcel vj cv cJ dmeq vj cv cdm cJ cdm dmeq vj cv cdm
      cdm cJ cdm cdm wceq vj cv cdm cdm cvv wcel cX cvv wcel vj cv cdm vj cv vj
      visset dmex dmex vj cv cdm cdm cJ cdm cdm wceq vj cv cdm cdm cvv wcel cJ
      cdm cdm cvv wcel cX cvv wcel vj cv cdm cdm cJ cdm cdm wceq vj cv cdm cdm
      cvv wcel cJ cdm cdm cvv wcel vj cv cdm cdm cJ cdm cdm cvv eleq1 biimpd cJ
      cdm cdm cX cvv cX cJ cdm cdm islatalg.1 eqcomi eleq1i syl6ib mpi 3syl vt
      cv vt cv cxp vt cv cJ wf vt cv vt cv cxp vt cv vm cv wf vx cv vy cv cJ co
      vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx
      cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co
      vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv
      vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz vt cv wral w3a w3a vy vt cv wral vx vt cv wral w3a cX cX cxp
      cX cJ wf cX cX cxp cX vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq
      vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm
      cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv
      vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy
      cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a
      w3a vy cX wral vx cX wral w3a vt cX cvv vt cv cX wceq vt cv vt cv cxp vt
      cv cJ wf cX cX cxp cX cJ wf vt cv vt cv cxp vt cv vm cv wf cX cX cxp cX
      vm cv wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy
      cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv
      vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co
      vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx
      cv vy cv cJ co vz cv cJ co wceq wa vz vt cv wral w3a w3a vy vt cv wral vx
      vt cv wral vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co
      vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx
      cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv
      co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co
      vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cX
      wral vt cv vt cv cxp cX cX cxp wceq vt cv cX wceq vt cv vt cv cxp vt cv
      cJ wf cX cX cxp cX cJ wf wb vt cv cX wceq vt cv vt cv cxp cX cX cxp wceq
      vt cv cX vt cv cX xpeq12 anidms vt cv vt cv cxp vt cv cX cX cxp cX cJ
      feq23 mpancom vt cv vt cv cxp cX cX cxp wceq vt cv cX wceq vt cv vt cv
      cxp vt cv vm cv wf cX cX cxp cX vm cv wf wb vt cv cX wceq vt cv vt cv cxp
      cX cX cxp wceq vt cv cX vt cv cX xpeq12 anidms vt cv vt cv cxp vt cv cX
      cX cxp cX vm cv feq23 mpancom vt cv cX wceq vx cv vy cv cJ co vy cv vx cv
      cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy
      cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq
      vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co
      wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa
      vz vt cv wral w3a w3a vy vt cv wral vx cv vy cv cJ co vy cv vx cv cJ co
      wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ
      co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv
      vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx
      cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX
      wral w3a w3a vy cX wral vx vt cv cX vt cv cX wceq id vt cv cX wceq vx cv
      vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv
      co wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm
      cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm
      cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co
      vz cv cJ co wceq wa vz vt cv wral w3a w3a vx cv vy cv cJ co vy cv vx cv
      cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy
      cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq
      vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co
      wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa
      vz cX wral w3a w3a vy vt cv cX vt cv cX wceq id vt cv cX wceq vx cv vx cv
      vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq
      wa vz vt cv wral w3a vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx
      cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx
      cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv
      vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a vx cv vy cv cJ co vy cv vx
      cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vt cv cX
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq
      wa vz vt cv wral vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co
      vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv
      cJ co wceq wa vz cX wral vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx
      cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv
      co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co
      vx cv vy cv cJ co vz cv cJ co wceq wa vz vt cv cX raleq1 3anbi3d 3anbi3d
      raleq12d raleq12d 3anbi123d ceqsexgv syl 3bitrd vm cv cM wceq cX cX cxp
      cX vm cv wf cX cX cxp cX cM wf vx cv vy cv cJ co vy cv vx cv cJ co wceq
      vx cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm
      cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv
      vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy
      cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a
      w3a vy cX wral vx cX wral vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv
      vy cv cM co vy cv vx cv cM co wceq vx cv vx cv vy cv cJ co cM co vx cv
      wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM
      co vx cv vy cv cM co vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv
      vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cX wral
      cX cX cxp cX cJ wf cX cX cxp cX vm cv cM feq1 vm cv cM wceq vx cv vy cv
      cJ co vy cv vx cv cJ co wceq vx cv vy cv vm cv co vy cv vx cv vm cv co
      wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv
      co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv
      co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz
      cv cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cv vy cv cJ co vy cv vx
      cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx cv vy cv
      cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx cv vy
      cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy cv vz cv
      cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a w3a vy
      cX wral vx cX vm cv cM wceq vx cv vy cv cJ co vy cv vx cv cJ co wceq vx
      cv vy cv vm cv co vy cv vx cv vm cv co wceq vx cv vx cv vy cv cJ co vm cv
      co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx cv vy cv vz
      cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv
      vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral w3a
      w3a vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx
      cv cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv
      cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz
      cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz cX wral w3a w3a vy cX vm cv cM wceq vx cv vy cv vm cv co vy cv
      vx cv vm cv co wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx cv
      vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv
      wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv vm cv
      co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq
      wa vz cX wral w3a vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy
      cv cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co
      vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ
      co wceq wa vz cX wral w3a vx cv vy cv cJ co vy cv vx cv cJ co wceq vm cv
      cM wceq vx cv vy cv vm cv co vx cv vy cv cM co vy cv vx cv vm cv co vy cv
      vx cv cM co vx cv vy cv vm cv cM opreq vy cv vx cv vm cv cM opreq eqeq12d
      vm cv cM wceq vx cv vx cv vy cv cJ co vm cv co vx cv wceq vx cv vx cv vy
      cv cJ co cM co vx cv wceq vx cv vx cv vy cv vm cv co cJ co vx cv wceq vx
      cv vx cv vy cv cM co cJ co vx cv wceq vx cv vy cv vz cv vm cv co vm cv co
      vx cv vy cv vm cv co vz cv vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx
      cv vy cv cJ co vz cv cJ co wceq wa vz cX wral vx cv vy cv vz cv cM co cM
      co vx cv vy cv cM co vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv
      vy cv cJ co vz cv cJ co wceq wa vz cX wral vm cv cM wceq vx cv vx cv vy
      cv cJ co vm cv co vx cv vx cv vy cv cJ co cM co vx cv vx cv vx cv vy cv
      cJ co vm cv cM opreq eqeq1d vm cv cM wceq vx cv vx cv vy cv vm cv co cJ
      co vx cv vx cv vy cv cM co cJ co vx cv vm cv cM wceq vx cv vy cv vm cv co
      vx cv vy cv cM co vx cv cJ vx cv vy cv vm cv cM opreq opreq2d eqeq1d vm
      cv cM wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz cv
      vm cv co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq
      vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX
      vm cv cM wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vm cv co vz
      cv vm cv co wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM
      co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq
      vm cv cM wceq vx cv vy cv vz cv vm cv co vm cv co vx cv vy cv vz cv cM co
      cM co vx cv vy cv vm cv co vz cv vm cv co vx cv vy cv cM co vz cv cM co
      vm cv cM wceq vx cv vx cv vy cv vz cv vm cv co vy cv vz cv cM co vm cv cM
      vm cv cM wceq id vm cv cM wceq vx cv eqidd vy cv vz cv vm cv cM opreq
      opreq123d vm cv cM wceq vx cv vy cv vm cv co vx cv vy cv cM co vz cv vz
      cv vm cv cM vm cv cM wceq id vx cv vy cv vm cv cM opreq vm cv cM wceq vz
      cv eqidd opreq123d eqeq12d anbi1d ralbidv 3anbi123d 3anbi23d ralbidv
      ralbidv 3anbi23d opelopabg bitrd $.
      $( [14-Dec-2009] $) $( [11-Dec-2009] $)
  $}

  ${ $d J x y z $. $d M x y z $. $d X x y z $.
    jop1 $e |- X = dom dom J $.
    ${
    $( Join is a binary internal operation. $)
    jop $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> J : ( X X. X ) --> X ) $=
      cJ cA wcel cM cB wcel cJ cM cop clatalg wcel cX cX cxp cX cJ wf cJ cA
      wcel cM cB wcel wa cJ cM cop clatalg wcel cX cX cxp cX cJ wf cX cX cxp cX
      cM wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx
      cv cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv
      cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz
      cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz cX wral w3a w3a vy cX wral vx cX wral w3a cX cX cxp cX cJ wf
      vx vy vz cA cB cJ cM cX jop1 islatalg cX cX cxp cX cJ wf cX cX cxp cX cM
      wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv
      cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM
      co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv
      cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz cX wral w3a w3a vy cX wral vx cX wral 3simp1 syl6bi 3impia $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d J x y z $. $d M x y z $. $d X x y z $.
    $( Meet is a binary internal operation. $)
    mop $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> M : ( X X. X ) --> X ) $=
      cJ cA wcel cM cB wcel cJ cM cop clatalg wcel cX cX cxp cX cM wf cJ cA
      wcel cM cB wcel wa cJ cM cop clatalg wcel cX cX cxp cX cJ wf cX cX cxp cX
      cM wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx
      cv cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv
      cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz
      cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz cX wral w3a w3a vy cX wral vx cX wral w3a cX cX cxp cX cM wf
      vx vy vz cA cB cJ cM cX jop1 islatalg cX cX cxp cX cJ wf cX cX cxp cX cM
      wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv
      cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM
      co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv
      cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co
      wceq wa vz cX wral w3a w3a vy cX wral vx cX wral 3simp2 syl6bi 3impia $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d J x y z $. $d M x y z $. $d X x y z $.
    $( Closure of join. $)
    cljo $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> ( ( P e. X /\ Q e. X ) -> ( P J Q ) e. X ) ) $=
      cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX wcel wa
      cX cX cxp cX cJ wf cP cX wcel cQ cX wcel w3a cP cQ cJ co cX wcel cJ cA
      wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX wcel wa cX cX
      cxp cX cJ wf cP cX wcel cQ cX wcel w3a cJ cA wcel cM cB wcel cJ cM cop
      clatalg wcel w3a cP cX wcel cQ cX wcel wa wa cX cX cxp cX cJ wf cP cX
      wcel cQ cX wcel cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cX cX
      cxp cX cJ wf cP cX wcel cQ cX wcel wa cA cB cJ cM cX jop1 jop adantr cJ
      cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX wcel
      simprl cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX
      wcel simprr 3jca ex cP cQ cX cX cX cJ foprrn syl6 $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d J x y z $. $d M x y z $. $d X x y z $.
    $( Closure of meet. $)
    clme $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> ( ( P e. X /\ Q e. X ) -> ( P M Q ) e. X ) ) $=
      cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX wcel wa
      cX cX cxp cX cM wf cP cX wcel cQ cX wcel w3a cP cQ cM co cX wcel cJ cA
      wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX wcel wa cX cX
      cxp cX cM wf cP cX wcel cQ cX wcel w3a cJ cA wcel cM cB wcel cJ cM cop
      clatalg wcel w3a cP cX wcel cQ cX wcel wa wa cX cX cxp cX cM wf cP cX
      wcel cQ cX wcel cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cX cX
      cxp cX cM wf cP cX wcel cQ cX wcel wa cA cB cJ cM cX jop1 mop adantr cJ
      cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX wcel
      simprl cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cQ cX
      wcel simprr 3jca ex cP cQ cX cX cX cM foprrn syl6 $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d J x y z $. $d M x y z $. $d X x y z $.
      $( Absorption law. ` ( x /\ ( x \/ y ) ) = x ` $)
      labs1 $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> A. x e. X A. y e. X ( x M ( x J y ) ) = x ) $=
        cJ cA wcel cM cB wcel cJ cM cop clatalg wcel vx cv vx cv vy cv cJ co cM
        co vx cv wceq vy cX wral vx cX wral cJ cA wcel cM cB wcel wa cJ cM cop
        clatalg wcel cX cX cxp cX cJ wf cX cX cxp cX cM wf vx cv vy cv cJ co vy
        cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx
        cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv
        wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq
        vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz
        cX wral w3a w3a vy cX wral vx cX wral w3a vx cv vx cv vy cv cJ co cM co
        vx cv wceq vy cX wral vx cX wral vx vy vz cA cB cJ cM cX jop1 islatalg
        vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv
        cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv
        cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co
        vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv
        cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cX wral cX cX cxp cX cJ
        wf vx cv vx cv vy cv cJ co cM co vx cv wceq vy cX wral vx cX wral cX cX
        cxp cX cM wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co
        vy cv vx cv cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv
        vx cv vy cv cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv
        vy cv cM co vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv
        cJ co vz cv cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cv vx cv vy
        cv cJ co cM co vx cv wceq vy cX wral vx cX vx cv vy cv cJ co vy cv vx
        cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx cv vy
        cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx
        cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy
        cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral
        w3a w3a vx cv vx cv vy cv cJ co cM co vx cv wceq vy cX vx cv vx cv vy
        cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx
        cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy
        cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral
        w3a vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vx cv vy cv cJ co cM
        co vx cv wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx cv vy
        cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx
        cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy
        cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral
        3simp1 3ad2ant3 r19.20si r19.20si 3ad2ant3 syl6bi 3impia $.
        $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d J x y $. $d M x y $. $d P x y $. $d Q y $. $d X x y $.
      $( Absorption law.  $)
      labss1 $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
           -> ( ( P e. X /\ Q e. X ) -> ( P M ( P J Q ) ) = P ) ) $=
        cP cX wcel cQ cX wcel wa vx cv vx cv vy cv cJ co cM co vx cv wceq vy cX
        wral vx cX wral cP cP cQ cJ co cM co cP wceq cJ cA wcel cM cB wcel cJ
        cM cop clatalg wcel w3a vx cv vx cv vy cv cJ co cM co vx cv wceq cP cP
        cQ cJ co cM co cP wceq cP cP vy cv cJ co cM co cP wceq vx vy cP cQ cX
        cX vx cv cP wceq vx cv vx cv vy cv cJ co cM co cP cP vy cv cJ co cM co
        vx cv cP vx cv cP wceq vx cv cP vx cv vy cv cJ co cP vy cv cJ co cM vx
        cv cP wceq id vx cv cP vy cv cJ opreq1 opreq12d vx cv cP wceq id
        eqeq12d vy cv cQ wceq cP cP vy cv cJ co cM co cP cP cQ cJ co cM co cP
        vy cv cQ wceq cP vy cv cJ co cP cQ cJ co cP cM vy cv cQ cP cJ opreq2
        opreq2d eqeq1d rcla42v vx vy cA cB cJ cM cX jop1 labs1 syl5com $.
        $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}


    ${ $d J x y z $. $d M x y z $. $d X x y z $.
      $( Absorption law. ` ( x \/ ( x /\ y ) ) = x ` $)
      labs2 $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
           -> A. x e. X A. y e. X ( x J ( x M y ) ) = x ) $=
        cJ cA wcel cM cB wcel cJ cM cop clatalg wcel vx cv vx cv vy cv cM co cJ
        co vx cv wceq vy cX wral vx cX wral cJ cA wcel cM cB wcel wa cJ cM cop
        clatalg wcel cX cX cxp cX cJ wf cX cX cxp cX cM wf vx cv vy cv cJ co vy
        cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx
        cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv
        wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq
        vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz
        cX wral w3a w3a vy cX wral vx cX wral w3a vx cv vx cv vy cv cM co cJ co
        vx cv wceq vy cX wral vx cX wral vx vy vz cA cB cJ cM cX jop1 islatalg
        vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co vy cv vx cv
        cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv vx cv vy cv
        cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv vy cv cM co
        vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv
        cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cX wral cX cX cxp cX cJ
        wf vx cv vx cv vy cv cM co cJ co vx cv wceq vy cX wral vx cX wral cX cX
        cxp cX cM wf vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vy cv cM co
        vy cv vx cv cM co wceq vx cv vx cv vy cv cJ co cM co vx cv wceq vx cv
        vx cv vy cv cM co cJ co vx cv wceq vx cv vy cv vz cv cM co cM co vx cv
        vy cv cM co vz cv cM co wceq vx cv vy cv vz cv cJ co cJ co vx cv vy cv
        cJ co vz cv cJ co wceq wa vz cX wral w3a w3a vy cX wral vx cv vx cv vy
        cv cM co cJ co vx cv wceq vy cX wral vx cX vx cv vy cv cJ co vy cv vx
        cv cJ co wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx cv vy
        cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx
        cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy
        cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral
        w3a w3a vx cv vx cv vy cv cM co cJ co vx cv wceq vy cX vx cv vx cv vy
        cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx
        cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy
        cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral
        w3a vx cv vy cv cJ co vy cv vx cv cJ co wceq vx cv vx cv vy cv cM co cJ
        co vx cv wceq vx cv vy cv cM co vy cv vx cv cM co wceq vx cv vx cv vy
        cv cJ co cM co vx cv wceq vx cv vx cv vy cv cM co cJ co vx cv wceq vx
        cv vy cv vz cv cM co cM co vx cv vy cv cM co vz cv cM co wceq vx cv vy
        cv vz cv cJ co cJ co vx cv vy cv cJ co vz cv cJ co wceq wa vz cX wral
        3simp2 3ad2ant3 r19.20si r19.20si 3ad2ant3 syl6bi 3impia $.
        $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d J x y $. $d M x y $. $d P x y $. $d Q y $. $d X x y $.
      $( Absorption law. $)
      labss2 $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
           -> ( ( P e. X /\ Q e. X ) -> ( P J ( P M Q ) ) = P ) ) $=
        cP cX wcel cQ cX wcel wa vx cv vx cv vy cv cM co cJ co vx cv wceq vy cX
        wral vx cX wral cP cP cQ cM co cJ co cP wceq cJ cA wcel cM cB wcel cJ
        cM cop clatalg wcel w3a vx cv vx cv vy cv cM co cJ co vx cv wceq cP cP
        cQ cM co cJ co cP wceq cP cP vy cv cM co cJ co cP wceq vx vy cP cQ cX
        cX vx cv cP wceq vx cv vx cv vy cv cM co cJ co cP cP vy cv cM co cJ co
        vx cv cP vx cv cP wceq vx cv cP vx cv vy cv cM co cP vy cv cM co cJ vx
        cv cP wceq id vx cv cP vy cv cM opreq1 opreq12d vx cv cP wceq id
        eqeq12d vy cv cQ wceq cP cP vy cv cM co cJ co cP cP cQ cM co cJ co cP
        vy cv cQ wceq cP vy cv cM co cP cQ cM co cP cJ vy cv cQ cP cM opreq2
        opreq2d eqeq1d rcla42v vx vy cA cB cJ cM cX jop1 labs2 syl5com $.
        $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    $( Join is idempotent. ` ( P \/ P ) = P ` $)
    jidd $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg ) ->
      ( P e. X -> ( P J P ) = P ) ) $=
      cP cX wcel cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cP cJ co
      cP wceq cP cX wcel cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cP
      cJ co cP wceq wi cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX
      wcel cP cX wcel wa cP cP cJ co cP wceq cP cP cP cJ co cM co cP wceq cP cP
      cP cP cJ co cM co cJ co cP wceq cP cP cJ co cP wceq cJ cA wcel cM cB wcel
      cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel wa wa cP cP cP cJ co cM
      co cP wceq cP cP cP cP cJ co cM co cJ co cP cP cJ co wceq cP cP cP cP cJ
      co cM co cJ co cP wceq cP cP cJ co cP wceq wi cP cP cP cJ co cM co cP cP
      cJ opreq2 cP cP cP cP cJ co cM co cJ co cP wceq cP cP cJ co cP wceq wi cP
      cP cJ co cP cP cP cP cJ co cM co cJ co cP cP cJ co cP cP cP cP cJ co cM
      co cJ co wceq cP cP cP cP cJ co cM co cJ co cP wceq cP cP cJ co cP wceq
      cP cP cJ co cP cP cP cP cJ co cM co cJ co cP eqtr ex eqcoms syl cJ cA
      wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel wa cP cP
      cP cJ co cM co cP wceq cA cB cP cP cJ cM cX jop1 labss1 imp cJ cA wcel cM
      cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cP cJ co cX wcel wa cP
      cP cP cP cJ co cM co cJ co cP wceq cJ cA wcel cM cB wcel cJ cM cop
      clatalg wcel w3a cP cX wcel cP cX wcel wa wa cA cB cP cP cP cJ co cJ cM
      cX jop1 labss2 cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX
      wcel cP cX wcel wa pm3.26 cJ cA wcel cM cB wcel cJ cM cop clatalg wcel
      w3a cP cX wcel cP cX wcel wa wa cP cX wcel cP cP cJ co cX wcel cJ cA wcel
      cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel simprl cJ cA
      wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel wa cP cP
      cJ co cX wcel cA cB cP cP cJ cM cX jop1 cljo imp jca sylc sylc expcom
      anidms com12 $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)

    $( Meet is idempotent. ` ( P /\ P ) = P ` $)
    midd $p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg ) ->
      ( P e. X -> ( P M P ) = P ) ) $=
      cP cX wcel cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cP cM co
      cP wceq cP cX wcel cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cP
      cM co cP wceq wi cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX
      wcel cP cX wcel wa cP cP cM co cP wceq cP cP cP cM co cJ co cP wceq cP cP
      cP cP cM co cJ co cM co cP wceq cP cP cM co cP wceq cJ cA wcel cM cB wcel
      cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel wa wa cP cP cP cM co cJ
      co cP wceq cP cP cP cP cM co cJ co cM co cP cP cM co wceq cP cP cP cP cM
      co cJ co cM co cP wceq cP cP cM co cP wceq wi cP cP cP cM co cJ co cP cP
      cM opreq2 cP cP cP cP cM co cJ co cM co cP wceq cP cP cM co cP wceq wi cP
      cP cM co cP cP cP cP cM co cJ co cM co cP cP cM co cP cP cP cP cM co cJ
      co cM co wceq cP cP cP cP cM co cJ co cM co cP wceq cP cP cM co cP wceq
      cP cP cM co cP cP cP cP cM co cJ co cM co cP eqtr ex eqcoms syl cJ cA
      wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel wa cP cP
      cP cM co cJ co cP wceq cA cB cP cP cJ cM cX jop1 labss2 imp cJ cA wcel cM
      cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cP cM co cX wcel wa cP
      cP cP cP cM co cJ co cM co cP wceq cJ cA wcel cM cB wcel cJ cM cop
      clatalg wcel w3a cP cX wcel cP cX wcel wa wa cA cB cP cP cP cM co cJ cM
      cX jop1 labss1 cJ cA wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX
      wcel cP cX wcel wa pm3.26 cJ cA wcel cM cB wcel cJ cM cop clatalg wcel
      w3a cP cX wcel cP cX wcel wa wa cP cX wcel cP cP cM co cX wcel cJ cA wcel
      cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel simprl cJ cA
      wcel cM cB wcel cJ cM cop clatalg wcel w3a cP cX wcel cP cX wcel wa cP cP
      cM co cX wcel cA cB cP cP cJ cM cX jop1 clme imp jca sylc sylc expcom
      anidms com12 $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Currying and Partial Mappings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c cur1 $.
  $c cur2 $.

  $( Extend class notation with the definition of currying. $)
  ccur1 $a class cur1 $.

  $( Extend class notation with the definition of currying. $)
  ccur2 $a class cur2 $.

  ${ $d f g x y $.
  $( Definition of currying (1st sort). Currying the operation ` f ` consists
     in creating a mapping that returns for every value ` x ` of ` dom dom f `
     the partial application of ` f ` to ` x ` . $)
  df-cur1 $a |- cur1 = { <. f , g >. | ( ( Fun f /\ Rel dom f ) /\
   g = { <. x , y >. | ( x e. dom dom f
     /\ y = ( f o. `' ( 2nd |` ( { x } X. _V ) ) ) ) } ) } $.


  $( Definition of currying (2nd sort). Currying the operation ` f ` consists
     in creating a mapping that returns for every value ` x ` of ` ran dom f `
     the partial application of ` f ` to ` x ` . $)
  df-cur2 $a |- cur2 = { <. f , g >. | ( Fun f /\ Rel dom f /\
   g = { <. x , y >. | ( x e. ran dom f
     /\ y = ( f o. `' ( 1st |` ( _V X. { x } ) ) ) ) } ) } $.
  $}

  ${
    $d F f g x y $.
    $( The value of a curried operation. $)
    cur1val $p |- ( ( F e. A /\ Fun F  /\ Rel dom F ) -> ( cur1 ` F )
      = { <. x , y >. | ( x e. dom dom F /\
        y = ( F o. `' ( 2nd |` ( { x } X. _V ) ) ) ) } ) $=
      cF cvv wcel vx cv cF cdm cdm wcel vy cv cF c2nd vx cv csn cvv cxp cres
      ccnv ccom wceq wa vx vy copab cvv wcel cF wfun cF cdm wrel wa cF ccur1
      cfv vx cv cF cdm cdm wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom
      wceq wa vx vy copab wceq cF cA wcel cF wfun cF cdm wrel w3a vf cv wfun vf
      cv cdm wrel wa cF wfun cF cdm wrel wa vf vg cF vx cv vf cv cdm cdm wcel
      vy cv vf cv c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy copab vx
      cv cF cdm cdm wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa
      vx vy copab cvv cvv ccur1 vx vy vf vg df-cur1 vf cv cF wceq vf cv wfun cF
      wfun vf cv cdm wrel cF cdm wrel vf cv cF funeq vf cv cF wceq vf cv cdm cF
      cdm wceq vf cv cdm wrel cF cdm wrel wb vf cv cF dmeq vf cv cdm cF cdm
      releq syl anbi12d vf cv cF wceq vx cv vf cv cdm cdm wcel vy cv vf cv c2nd
      vx cv csn cvv cxp cres ccnv ccom wceq wa vx cv cF cdm cdm wcel vy cv cF
      c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy vf cv cF wceq vx cv
      vf cv cdm cdm wcel vx cv cF cdm cdm wcel vy cv vf cv c2nd vx cv csn cvv
      cxp cres ccnv ccom wceq vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom
      wceq vf cv cF wceq vf cv cdm cdm cF cdm cdm vx cv vf cv cF wceq vf cv cdm
      cF cdm vf cv cF dmeq dmeqd eleq2d vf cv cF wceq vf cv c2nd vx cv csn cvv
      cxp cres ccnv ccom cF c2nd vx cv csn cvv cxp cres ccnv ccom vy cv vf cv
      cF c2nd vx cv csn cvv cxp cres ccnv coeq1 eqeq2d anbi12d opabbidv fvopab6
      cF cA wcel cF wfun cF cvv wcel cF cdm wrel cF cA elisset 3ad2ant1 cF cA
      wcel cF wfun cF cdm wrel w3a cF cdm cdm cvv wcel vx cv cF cdm cdm wcel vy
      cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy copab cvv wcel
      cF cA wcel cF wfun cF cdm cdm cvv wcel cF cdm wrel cF cA wcel cF cdm cvv
      wcel cF cdm cdm cvv wcel cF cA dmexg cF cdm cvv dmexg syl 3ad2ant1 vx vy
      cF cdm cdm cF c2nd vx cv csn cvv cxp cres ccnv ccom cvv opabex2g syl cF
      cA wcel cF wfun cF cdm wrel 3simpc syl3anc $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${
    $d A x y $. $d B x y $. $d C x y $. $d D x y $. $d F x y $.
    $( The value of a curried operation. $)
    cur1vald $p |- (
      ( ( F Fn ( A X. B ) /\ B =/= (/) ) /\ ( A e. C /\ B e. D ) )
        -> ( cur1 ` F ) = { <. x , y >. | ( x e. A /\
          y = ( F o. `' ( 2nd |` ( { x } X. _V ) ) ) ) } ) $=
      cF cA cB cxp wfn cB c0 wne wa cA cC wcel cB cD wcel wa wa cF ccur1 cfv vx
      cv cF cdm cdm wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa
      vx vy copab vx cv cA wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom
      wceq wa vx vy copab cF cvv wcel cF wfun cF cdm wrel cF ccur1 cfv vx cv cF
      cdm cdm wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy
      copab wceq cF cA cB cxp wfn cB c0 wne wa cA cC wcel cB cD wcel wa wa vx
      vy cvv cF cur1val cF cA cB cxp wfn cB c0 wne wa cA cC wcel cB cD wcel wa
      cF cvv wcel cF cA cB cxp wfn cA cC wcel cB cD wcel wa cF cvv wcel wi cB
      c0 wne cF cA cB cxp wfn cA cC wcel cB cD wcel cF cvv wcel cF cA cB cxp
      wfn cA cB cxp cvv wcel cF cvv wcel cF cA cB cxp wfn cA cC wcel cB cD wcel
      w3a cA cB cxp cvv cF fnex cF cA cB cxp wfn cA cC wcel cB cD wcel 3simp1
      cA cC wcel cB cD wcel cA cB cxp cvv wcel cF cA cB cxp wfn cA cB cC cD
      xpexg 3adant1 sylanc 3expib adantr imp cF cA cB cxp wfn cF wfun cB c0 wne
      cA cC wcel cB cD wcel wa cA cB cxp cF fnfun ad2antrr cF cA cB cxp wfn cF
      cdm wrel cB c0 wne cA cC wcel cB cD wcel wa cF cA cB cxp wfn cF cdm cA cB
      cxp wceq cF cdm wrel cA cB cxp cF fndm cF cdm cA cB cxp wceq cA cB cxp
      wrel cF cdm wrel cA cB relxp cA cB cxp wrel cF cdm wrel wb cA cB cxp cF
      cdm cA cB cxp cF cdm releq eqcoms mpbii syl ad2antrr syl3anc cF cA cB cxp
      wfn cB c0 wne wa cA cC wcel cB cD wcel wa wa vx cv cA wcel vy cv cF c2nd
      vx cv csn cvv cxp cres ccnv ccom wceq wa vx cv cF cdm cdm wcel vy cv cF
      c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy cF cA cB cxp wfn cB
      c0 wne wa cA cC wcel cB cD wcel wa wa vx cv cA wcel vx cv cF cdm cdm wcel
      vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq cF cA cB cxp wfn cB
      c0 wne wa cA cC wcel cB cD wcel wa wa cA cF cdm cdm vx cv cF cA cB cxp
      wfn cB c0 wne wa cA cF cdm cdm wceq cA cC wcel cB cD wcel wa cF cA cB cxp
      wfn cB c0 wne cA cF cdm cdm wceq cF cA cB cxp wfn cF cdm cA cB cxp wceq
      cB c0 wne cA cF cdm cdm wceq wi cA cB cxp cF fndm cF cdm cA cB cxp wceq
      cF cdm cdm cA cB cxp cdm wceq cB c0 wne cA cF cdm cdm wceq wi cF cdm cA
      cB cxp dmeq cB c0 wne cA cF cdm cdm wceq wi cA cB cxp cdm cF cdm cdm cB
      c0 wne cA cB cxp cdm cF cdm cdm wceq cA cF cdm cdm wceq cB c0 wne cA cB
      cxp cdm cA cF cdm cdm cA cB dmxp eqeq1d biimpcd eqcoms syl syl imp adantr
      eleq2d anbi1d opabbidv eqtr4d $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d A x y $. $d B f x y $. $d C x y $. $d D x y $. $d F f x y $.
    domrancur1b.1 $e |- A e. C $.
    domrancur1b.2 $e |- B e. D $.
    domrancur1b.3 $e |- B =/= (/) $.
    domrancur1b.4 $e |- F Fn ( A X. B ) $.
    $( The currying of a mapping ` F ` whose domain is ` ( A X. B ) `
       is a mapping whose domain is ` A ` and the range, the class
       of all the functions from ` B ` to ` ran F ` . $)
    domrancur1b $p |-
      ( cur1 ` F ) : A --> { f | f : B --> ran F } $=
      cF c2nd vx cv csn cvv cxp cres ccnv ccom cB cF crn vf cv wf vf cab wcel
      vx cA wral cA cB cF crn vf cv wf vf cab cF ccur1 cfv wf cF c2nd vx cv csn
      cvv cxp cres ccnv ccom cB cF crn vf cv wf vf cab wcel vx cA vx cv cA wcel
      cF c2nd vx cv csn cvv cxp cres ccnv ccom cB cF crn vf cv wf vf cab wcel
      cB cF crn cF c2nd vx cv csn cvv cxp cres ccnv ccom wf vx cv cA wcel cF
      c2nd vx cv csn cvv cxp cres ccnv ccom cB wfn cF c2nd vx cv csn cvv cxp
      cres ccnv ccom crn cF crn wss wa cB cF crn cF c2nd vx cv csn cvv cxp cres
      ccnv ccom wf vx cv cA wcel cF c2nd vx cv csn cvv cxp cres ccnv ccom cB
      wfn cF c2nd vx cv csn cvv cxp cres ccnv ccom crn cF crn wss vx cv cA wcel
      cF c2nd vx cv csn cvv cxp cres ccnv ccom wfun cF c2nd vx cv csn cvv cxp
      cres ccnv ccom cdm cB wceq wa cF c2nd vx cv csn cvv cxp cres ccnv ccom cB
      wfn vx cv cA wcel cF c2nd vx cv csn cvv cxp cres ccnv ccom wfun cF c2nd
      vx cv csn cvv cxp cres ccnv ccom cdm cB wceq vx cv cA wcel cF wfun c2nd
      vx cv csn cvv cxp cres ccnv wfun wa cF c2nd vx cv csn cvv cxp cres ccnv
      ccom wfun vx cv cA wcel cF wfun c2nd vx cv csn cvv cxp cres ccnv wfun cF
      wfun vx cv cA wcel cF cA cB cxp wfn cF wfun domrancur1b.4 cA cB cxp cF
      fnfun ax-mp a1i vx cv cA wcel vx cv csn cvv cxp cvv c2nd vx cv csn cvv
      cxp cres wf1o c2nd vx cv csn cvv cxp cres ccnv wfun vx cv cvv cA 2ndconst
      vx cv csn cvv cxp cvv c2nd vx cv csn cvv cxp cres wf1o vx cv csn cvv cxp
      cvv c2nd vx cv csn cvv cxp cres wfo c2nd vx cv csn cvv cxp cres ccnv wfun
      vx cv csn cvv cxp cvv c2nd vx cv csn cvv cxp cres dff1o3 pm3.27bi syl jca
      cF c2nd vx cv csn cvv cxp cres ccnv funco syl vx cv cA wcel cF c2nd vx cv
      csn cvv cxp cres ccnv ccom cdm c2nd vx cv csn cvv cxp cres ccnv ccnv cF
      cdm cima cB cF c2nd vx cv csn cvv cxp cres ccnv ccom cdm c2nd vx cv csn
      cvv cxp cres ccnv ccnv cF cdm cima wceq vx cv cA wcel cF c2nd vx cv csn
      cvv cxp cres ccnv dmco a1i vx cv cA wcel c2nd vx cv csn cvv cxp cres ccnv
      ccnv cF cdm cima c2nd vx cv csn cvv cxp cres cF cdm cima cB c2nd vx cv
      csn cvv cxp cres ccnv ccnv cF cdm cima c2nd vx cv csn cvv cxp cres cF cdm
      cima wceq vx cv cA wcel c2nd vx cv csn cvv cxp cres cF cdm imacnvcnv a1i
      vx cv cA wcel c2nd vx cv csn cvv cxp cres cF cdm cima c2nd vx cv csn cvv
      cxp cres cA cB cxp cima cB c2nd vx cv csn cvv cxp cres cF cdm cima c2nd
      vx cv csn cvv cxp cres cA cB cxp cima wceq vx cv cA wcel cF cdm cA cB cxp
      c2nd vx cv csn cvv cxp cres cF cA cB cxp wfn cF cdm cA cB cxp wceq
      domrancur1b.4 cA cB cxp cF fndm ax-mp imaeq2i a1i vx cv cA wcel c2nd vx
      cv csn cvv cxp cres cA cB cxp cima c2nd vx cv csn cvv cxp cres cA cB cxp
      cres crn cB c2nd vx cv csn cvv cxp cres cA cB cxp cima c2nd vx cv csn cvv
      cxp cres cA cB cxp cres crn wceq vx cv cA wcel c2nd vx cv csn cvv cxp
      cres cA cB cxp df-ima a1i vx cv cA wcel c2nd vx cv csn cvv cxp cres cA cB
      cxp cres crn c2nd vx cv csn cvv cxp cA cB cxp cin cres crn cB c2nd vx cv
      csn cvv cxp cres cA cB cxp cres crn c2nd vx cv csn cvv cxp cA cB cxp cin
      cres crn wceq vx cv cA wcel c2nd vx cv csn cvv cxp cres cA cB cxp cres
      c2nd vx cv csn cvv cxp cA cB cxp cin cres c2nd vx cv csn cvv cxp cA cB
      cxp resres rneqi a1i vx cv cA wcel c2nd vx cv csn cvv cxp cA cB cxp cin
      cres crn c2nd vx cv csn cB cxp cres crn cB vx cv cA wcel c2nd vx cv csn
      cvv cxp cA cB cxp cin cres c2nd vx cv csn cB cxp cres vx cv cA wcel vx cv
      csn cvv cxp cA cB cxp cin vx cv csn cB cxp wceq c2nd vx cv csn cvv cxp cA
      cB cxp cin cres c2nd vx cv csn cB cxp cres wceq vx cv cA wcel vx cv csn
      cvv cxp cA cB cxp cin vx cv csn cA cin cvv cB cin cxp vx cv csn cB cxp vx
      cv csn cvv cxp cA cB cxp cin vx cv csn cA cin cvv cB cin cxp wceq vx cv
      cA wcel vx cv csn cvv cA cB inxp a1i vx cv cA wcel vx cv csn cA cin vx cv
      csn wceq cvv cB cin cB wceq wa vx cv csn cA cin cvv cB cin cxp vx cv csn
      cB cxp wceq vx cv cA wcel vx cv csn cA cin vx cv csn wceq cvv cB cin cB
      wceq vx cv cA wcel vx cv csn cA wss vx cv csn cA cin vx cv csn wceq vx cv
      cA wcel vx cv csn cA wss vx cv cA vx visset snss biimpi vx cv csn cA
      df-ss sylib cvv cB cin cB wceq vx cv cA wcel cvv cB cin cB cvv cin cB cvv
      cB incom cB inv1 eqtri a1i jca vx cv csn cA cin vx cv csn cvv cB cin cB
      xpeq12 syl eqtrd vx cv csn cvv cxp cA cB cxp cin vx cv csn cB cxp c2nd
      reseq2 syl rneqd vx cv cA wcel vx cv csn cB cxp cB c2nd vx cv csn cB cxp
      cres wfo c2nd vx cv csn cB cxp cres crn cB wceq vx cv cA wcel vx cv csn
      c0 wne vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres wfo vx cv cA snnzg
      vx cv csn cB fo2ndres syl vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres
      forn syl eqtrd eqtrd eqtrd eqtrd eqtrd eqtrd jca cF c2nd vx cv csn cvv
      cxp cres ccnv ccom cB df-fn sylibr cF c2nd vx cv csn cvv cxp cres ccnv
      ccom crn cF crn wss vx cv cA wcel cF c2nd vx cv csn cvv cxp cres ccnv
      rncoss a1i jca cB cF crn cF c2nd vx cv csn cvv cxp cres ccnv ccom df-f
      sylibr vx cv cA wcel cF c2nd vx cv csn cvv cxp cres ccnv ccom cB cF crn
      vf cv wf vf cab wcel cB cF crn cF c2nd vx cv csn cvv cxp cres ccnv ccom
      wf cF c2nd vx cv csn cvv cxp cres ccnv ccom cvv wcel cF c2nd vx cv csn
      cvv cxp cres ccnv ccom cB cF crn vf cv wf vf cab wcel cF c2nd vx cv csn
      cvv cxp cres ccnv ccom cvv wcel vx cv cA wcel cF c2nd vx cv csn cvv cxp
      cres ccnv ccom cB cF crn vf cv wf vf cab elisset adantl cB cF crn cF c2nd
      vx cv csn cvv cxp cres ccnv ccom wf cF c2nd vx cv csn cvv cxp cres ccnv
      ccom cvv wcel vx cv cA wcel cB cF crn cF c2nd vx cv csn cvv cxp cres ccnv
      ccom wf cF c2nd vx cv csn cvv cxp cres ccnv ccom cF crn cB cpm co wcel cF
      c2nd vx cv csn cvv cxp cres ccnv ccom cvv wcel cB cF crn cF c2nd vx cv
      csn cvv cxp cres ccnv ccom cB cD wcel cB cvv wcel domrancur1b.2 cB cD
      elisset ax-mp cF cdm cvv wcel cF wfun wa cF crn cvv wcel cF cdm cvv wcel
      cF wfun cF cdm cA cB cxp wceq cF cdm cvv wcel cF cA cB cxp wfn cF cdm cA
      cB cxp wceq domrancur1b.4 cA cB cxp cF fndm ax-mp cF cdm cA cB cxp wceq
      cF cdm cvv wcel cA cB cxp cvv wcel cA cB cxp cvv wcel cF cdm cA cB cxp
      wceq cA cC wcel cB cD wcel wa cA cB cxp cvv wcel cA cC wcel cB cD wcel
      domrancur1b.1 domrancur1b.2 pm3.2i cA cB cC cD xpexg ax-mp a1i cF cdm cA
      cB cxp cvv eleq1 mpbird ax-mp cF cA cB cxp wfn cF wfun domrancur1b.4 cA
      cB cxp cF fnfun ax-mp pm3.2i cF cdm cvv wcel cF wfun cF crn cvv wcel cvv
      cF funrnex imp ax-mp fpm cF c2nd vx cv csn cvv cxp cres ccnv ccom cF crn
      cB cpm co elisset syl adantl cB cF crn vf cv wf cB cF crn cF c2nd vx cv
      csn cvv cxp cres ccnv ccom wf vf cF c2nd vx cv csn cvv cxp cres ccnv ccom
      cB cF crn vf cv wf vf cab cvv cB cF crn vf cv cF c2nd vx cv csn cvv cxp
      cres ccnv ccom feq1 cB cF crn vf cv wf vf cab eqid elab2g pm5.21nd mpbird
      rgen vx vy cA cB cF crn vf cv wf vf cab cF c2nd vx cv csn cvv cxp cres
      ccnv ccom cF ccur1 cfv cF cA cB cxp wfn cB c0 wne wa cA cC wcel cB cD
      wcel wa wa cF ccur1 cfv vx cv cA wcel vy cv cF c2nd vx cv csn cvv cxp
      cres ccnv ccom wceq wa vx vy copab wceq cF cA cB cxp wfn cB c0 wne wa cA
      cC wcel cB cD wcel wa cF cA cB cxp wfn cB c0 wne domrancur1b.4
      domrancur1b.3 pm3.2i cA cC wcel cB cD wcel domrancur1b.1 domrancur1b.2
      pm3.2i pm3.2i vx vy cA cB cC cD cF cur1vald ax-mp fopab2 mpbi $.
      $( [18-May-2010] $) $( [28-Apr-2010] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C y z $. $d F x z $.
    $( Functionality of an ordered-pair class abstraction. $)
    fopab2g $p |- ( F = { <. x , y >. | ( x e. A /\ y = C ) } ->
       ( A. x e. A C e. B <-> F : A --> B ) ) $=
      cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cC cB wcel vx cA wral
      cA cB cF wf cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cC cB wcel
      vx cA wral wa cF cA wfn cF crn cB wss wa cA cB cF wf cF vx cv cA wcel vy
      cv cC wceq wa vx vy copab wceq cC cB wcel vx cA wral wa cF cA wfn cF crn
      cB wss cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cC cB wcel vx
      cA wral wa cF cA wfn vx cv cA wcel vy cv cC wceq wa vx vy copab cA wfn cF
      vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cC cB wcel vx cA wral wa
      vy cv cC wceq vy weu vx cA wral vx cv cA wcel vy cv cC wceq wa vx vy
      copab cA wfn cC cB wcel vx cA wral vy cv cC wceq vy weu vx cA wral cF vx
      cv cA wcel vy cv cC wceq wa vx vy copab wceq cC cB wcel vy cv cC wceq vy
      weu vx cA cC cB wcel cC cvv wcel vy cv cC wceq vy weu cC cB elisset vy cC
      eueq sylib r19.20si adantl vy cv cC wceq vx vy cA vx cv cA wcel vy cv cC
      wceq wa vx vy copab vx cv cA wcel vy cv cC wceq wa vx vy copab eqid
      fnopabg sylib cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cF cA
      wfn vx cv cA wcel vy cv cC wceq wa vx vy copab cA wfn wb cC cB wcel vx cA
      wral cA cF vx cv cA wcel vy cv cC wceq wa vx vy copab fneq1 adantr mpbird
      cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cC cB wcel vx cA wral
      cF crn cB wss cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cF crn
      cB wss vx cv cA wcel vy cv cC wceq wa vx vy copab crn cB wss cC cB wcel
      vx cA wral cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cF crn vx
      cv cA wcel vy cv cC wceq wa vx vy copab crn cB cF vx cv cA wcel vy cv cC
      wceq wa vx vy copab rneq sseq1d cC cB wcel vx cA wral vy cv vx cv cA wcel
      vy cv cC wceq wa vx vy copab crn wcel vy cv cB wcel wi vy wal vx cv cA
      wcel vy cv cC wceq wa vx vy copab crn cB wss cC cB wcel vx cA wral vy cv
      vx cv cA wcel vy cv cC wceq wa vx vy copab crn wcel vy cv cB wcel wi vy
      cC cB wcel vx cA wral vx cv cA wcel vy cv cC wceq wa vx wex vy cv cB wcel
      vy cv vx cv cA wcel vy cv cC wceq wa vx vy copab crn wcel cC cB wcel vx
      cA wral vx cv cA wcel vy cv cC wceq wa vy cv cB wcel vx cC cB wcel vx cA
      hbra1 vy cv cB wcel vx ax-17 cC cB wcel vx cA wral vx cv cA wcel cC cB
      wcel wi vx cv cA wcel vy cv cC wceq wa vy cv cB wcel wi cC cB wcel vx cA
      ra4 vx cv cA wcel cC cB wcel wi vx cv cA wcel vy cv cC wceq vy cv cB wcel
      cC cB wcel vy cv cC wceq vy cv cB wcel wi vx cv cA wcel cC cB vy cv
      eleq1a imim2i imp3a syl 19.23ad vx cv cA wcel vy cv cC wceq wa vx wex vy
      vx cv cA wcel vy cv cC wceq wa vx vy copab crn vx cv cA wcel vy cv cC
      wceq wa vx vy rnopab abeq2i syl5ib 19.21aiv vy vz vx cv cA wcel vy cv cC
      wceq wa vx vy copab crn cB vy vz vx cv cA wcel vy cv cC wceq wa vx vy
      copab vx cv cA wcel vy cv cC wceq wa vx vy vz hbopab2 hbrn vz cv cB wcel
      vy ax-17 dfss2f sylibr syl5bir imp jca cA cB cF df-f sylibr cF vx cv cA
      wcel vy cv cC wceq wa vx vy copab wceq cA cB cF wf wa cC cvv wcel vx cA
      wral cC cB wcel vx cA wral cF vx cv cA wcel vy cv cC wceq wa vx vy copab
      wceq cA cB cF wf cC cvv wcel vx cA wral cF vx cv cA wcel vy cv cC wceq wa
      vx vy copab wceq cF cdm cA wceq cC cvv wcel vx cA wral cA cB cF wf cF vx
      cv cA wcel vy cv cC wceq wa vx vy copab wceq cF cdm vx cv cA wcel vy cv
      cC wceq wa vx vy copab cdm wceq cF cdm cA wceq cC cvv wcel vx cA wral wi
      cF vx cv cA wcel vy cv cC wceq wa vx vy copab dmeq cF cdm cA wceq cC cvv
      wcel vx cA wral wi vx cv cA wcel vy cv cC wceq wa vx vy copab cdm cF cdm
      vx cv cA wcel vy cv cC wceq wa vx vy copab cdm cF cdm wceq cF cdm cA wceq
      cC cvv wcel vx cA wral vx cv cA wcel vy cv cC wceq wa vx vy copab cdm cF
      cdm wceq cF cdm cA wceq wa vx cv cA wcel vy cv cC wceq wa vx vy copab cdm
      cA wceq cC cvv wcel vx cA wral vx cv cA wcel vy cv cC wceq wa vx vy copab
      cdm cF cdm cA eqtr vx cv cA wcel vy cv cC wceq wa vx vy copab cdm cA wceq
      vy cv cC wceq vy wex vx cA wral cC cvv wcel vx cA wral vy cv cC wceq vx
      vy cA dmopab3 vy cv cC wceq vy wex vx cA wral cC cvv wcel vx cA wral vy
      cv cC wceq vy wex cC cvv wcel vx cA cC cvv wcel vy cv cC wceq vy wex vy
      cC isset bicomi ralbii biimpi sylbir syl ex eqcoms syl cA cB cF fdm syl5
      imp cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cA cB cF wf wa cC
      cvv wcel cC cB wcel vx cA cF vx cv cA wcel vy cv cC wceq wa vx vy copab
      wceq cA cB cF wf vx vx vz vz cF vx cv cA wcel vy cv cC wceq wa vx vy
      copab vz cv cF wcel vx ax-17 vx cv cA wcel vy cv cC wceq wa vx vy vz
      hbopab1 hbeq cA cB cF wf vx ax-17 hban cF vx cv cA wcel vy cv cC wceq wa
      vx vy copab wceq cA cB cF wf wa vx cv cA wcel cC cvv wcel cC cB wcel wi
      vx cv cA wcel cC cvv wcel cF vx cv cA wcel vy cv cC wceq wa vx vy copab
      wceq cA cB cF wf wa cC cB wcel vx cv cA wcel cC cvv wcel cF vx cv cA wcel
      vy cv cC wceq wa vx vy copab wceq cA cB cF wf wa cC cB wcel wi vx cv cA
      wcel cC cvv wcel wa vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv
      cC wceq cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cA cB cF wf wa
      cC cB wcel wi vx vy cA cC cvv fvopab2 vx cv cA wcel vx cv vx cv cA wcel
      vy cv cC wceq wa vx vy copab cfv cC wceq cF vx cv cA wcel vy cv cC wceq
      wa vx vy copab wceq cA cB cF wf wa cC cB wcel wi wi cC cvv wcel cF vx cv
      cA wcel vy cv cC wceq wa vx vy copab wceq cA cB cF wf wa vx cv cA wcel vx
      cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq cC cB wcel cF
      vx cv cA wcel vy cv cC wceq wa vx vy copab wceq cA cB cF wf vx cv cA wcel
      vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq cC cB wcel
      wi wi cA cB cF wf vx cv cA wcel cF vx cv cA wcel vy cv cC wceq wa vx vy
      copab wceq vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq
      cC cB wcel wi cA cB cF wf vx cv cA wcel cF vx cv cA wcel vy cv cC wceq wa
      vx vy copab wceq vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC
      wceq cC cB wcel wi wi cA cB cF wf vx cv cA wcel wa vx cv cF cfv cB wcel
      cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq vx cv vx cv cA wcel vy
      cv cC wceq wa vx vy copab cfv cC wceq cC cB wcel wi wi cA cB vx cv cF
      ffvelrn vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq cF
      vx cv cA wcel vy cv cC wceq wa vx vy copab wceq vx cv cF cfv cB wcel cC
      cB wcel vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq cF
      vx cv cA wcel vy cv cC wceq wa vx vy copab wceq vx cv cF cfv cB wcel cC
      cB wcel wi vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC wceq
      cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq wa vx cv cF cfv cB
      wcel cC cB wcel vx cv vx cv cA wcel vy cv cC wceq wa vx vy copab cfv cC
      wceq cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq wa vx cv cF cfv
      cC cB cF vx cv cA wcel vy cv cC wceq wa vx vy copab wceq vx cv vx cv cA
      wcel vy cv cC wceq wa vx vy copab cfv cC wceq vx cv cF cfv cC wceq cF vx
      cv cA wcel vy cv cC wceq wa vx vy copab wceq vx cv vx cv cA wcel vy cv cC
      wceq wa vx vy copab cfv vx cv cF cfv cC cF vx cv cA wcel vy cv cC wceq wa
      vx vy copab wceq vx cv cF cfv vx cv vx cv cA wcel vy cv cC wceq wa vx vy
      copab cfv vx cv cF vx cv cA wcel vy cv cC wceq wa vx vy copab fveq1
      eqcomd eqeq1d biimpac eleq1d biimpd ex com13 syl ex com3r imp com3l
      adantr mpd ex com3r imp r19.20da mpd impbida $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $( Lemma for ~ domrancur1c . $)
    domrancur1clem $p |- ( ( F Fn ( A X. B ) /\ ( A e. C /\ B e. D ) )
       -> ( F o. `' ( 2nd |` M ) ) e. _V ) $=
      cF cvv wcel c2nd cM cres ccnv ccnv wfun cF c2nd cM cres ccnv ccom cvv
      wcel cF cA cB cxp wfn cA cC wcel cB cD wcel wa wa cF c2nd cM cres ccnv
      cvv cofunex2g cF cA cB cxp wfn cA cB cxp cvv wcel cF cvv wcel cA cC wcel
      cB cD wcel wa cA cB cxp cvv cF fnex cA cB cC cD xpexg sylan2 c2nd cM cres
      wfun c2nd cM cres ccnv ccnv wfun c2nd wfun c2nd cM cres wfun cvv cvv c2nd
      wfo c2nd wfun fo2nd cvv cvv c2nd fofun ax-mp cM c2nd funres ax-mp c2nd cM
      cres funcnvcnv ax-mp sylancl $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d A x y $. $d B f x y $. $d C x y $. $d D x y $. $d F f x y $.
    $( The currying of a mapping ` F ` whose domain is ` ( A X. B ) `
       is a mapping whose domain is ` A ` and the range, the class
       of all the functions from ` B ` to ` ran F ` . $)
    domrancur1c $p |-
      ( ( ( A e. C /\ B e. D ) /\ ( B =/= (/) /\ F Fn ( A X. B ) ) ) ->
        ( cur1 ` F ) : A --> { f | f : B --> ran F } ) $=
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa cF c2nd vx cv
      csn cvv cxp cres ccnv ccom cB cF crn vf cv wf vf cab wcel vx cA wral cA
      cB cF crn vf cv wf vf cab cF ccur1 cfv wf cA cC wcel cB cD wcel wa cB c0
      wne cF cA cB cxp wfn wa wa cF c2nd vx cv csn cvv cxp cres ccnv ccom cB cF
      crn vf cv wf vf cab wcel vx cA cA cC wcel cB cD wcel wa cB c0 wne cF cA
      cB cxp wfn wa wa vx cv cA wcel wa cF c2nd vx cv csn cvv cxp cres ccnv
      ccom cB cF crn vf cv wf vf cab wcel cB cF crn cF c2nd vx cv csn cvv cxp
      cres ccnv ccom wf cB cF c2nd vx cv csn cvv cxp cres ccnv ccom crn cF c2nd
      vx cv csn cvv cxp cres ccnv ccom wf cF c2nd vx cv csn cvv cxp cres ccnv
      ccom crn cF crn wss cB cF crn cF c2nd vx cv csn cvv cxp cres ccnv ccom wf
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel
      wa cB cF c2nd vx cv csn cvv cxp cres ccnv ccom crn cF crn cF c2nd vx cv
      csn cvv cxp cres ccnv ccom fss cA cC wcel cB cD wcel wa cB c0 wne cF cA
      cB cxp wfn wa wa vx cv cA wcel wa cF c2nd vx cv csn cvv cxp cres ccnv
      ccom cB wfn cB cF c2nd vx cv csn cvv cxp cres ccnv ccom crn cF c2nd vx cv
      csn cvv cxp cres ccnv ccom wf cA cC wcel cB cD wcel wa cB c0 wne cF cA cB
      cxp wfn wa wa vx cv cA wcel wa cF c2nd vx cv csn cvv cxp cres ccnv ccom
      wfun cF c2nd vx cv csn cvv cxp cres ccnv ccom cdm cB wceq wa cF c2nd vx
      cv csn cvv cxp cres ccnv ccom cB wfn cA cC wcel cB cD wcel wa cB c0 wne
      cF cA cB cxp wfn wa wa vx cv cA wcel wa cF c2nd vx cv csn cvv cxp cres
      ccnv ccom wfun cF c2nd vx cv csn cvv cxp cres ccnv ccom cdm cB wceq cvv
      vx cv csn cvv cxp c2nd vx cv csn cvv cxp cres ccnv wf1o cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa cF c2nd vx cv
      csn cvv cxp cres ccnv ccom wfun wi vx cv csn cvv cxp cvv c2nd vx cv csn
      cvv cxp cres wf1o cvv vx cv csn cvv cxp c2nd vx cv csn cvv cxp cres ccnv
      wf1o vx cv cvv wcel vx cv csn cvv cxp cvv c2nd vx cv csn cvv cxp cres
      wf1o vx visset vx cv cvv cvv 2ndconst ax-mp vx cv csn cvv cxp cvv c2nd vx
      cv csn cvv cxp cres f1ocnv ax-mp cA cC wcel cB cD wcel wa cB c0 wne cF cA
      cB cxp wfn wa wa vx cv cA wcel wa c2nd vx cv csn cvv cxp cres ccnv wfun
      cF c2nd vx cv csn cvv cxp cres ccnv ccom wfun cvv vx cv csn cvv cxp c2nd
      vx cv csn cvv cxp cres ccnv wf1o cB c0 wne cF cA cB cxp wfn wa c2nd vx cv
      csn cvv cxp cres ccnv wfun cF c2nd vx cv csn cvv cxp cres ccnv ccom wfun
      wi cA cC wcel cB cD wcel wa vx cv cA wcel cF cA cB cxp wfn c2nd vx cv csn
      cvv cxp cres ccnv wfun cF c2nd vx cv csn cvv cxp cres ccnv ccom wfun wi
      cB c0 wne cF cA cB cxp wfn cF wfun c2nd vx cv csn cvv cxp cres ccnv wfun
      cF c2nd vx cv csn cvv cxp cres ccnv ccom wfun wi cA cB cxp cF fnfun cF
      wfun c2nd vx cv csn cvv cxp cres ccnv wfun cF c2nd vx cv csn cvv cxp cres
      ccnv ccom wfun cF c2nd vx cv csn cvv cxp cres ccnv funco ex syl adantl
      ad2antlr cvv vx cv csn cvv cxp c2nd vx cv csn cvv cxp cres ccnv f1ofun
      syl5com ax-mp cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa
      vx cv cA wcel wa cF c2nd vx cv csn cvv cxp cres ccnv ccom cdm c2nd vx cv
      csn cvv cxp cres ccnv ccnv cF cdm cima c2nd ccnv ccnv vx cv csn cvv cxp
      cres cF cdm cima cB cF c2nd vx cv csn cvv cxp cres ccnv ccom cdm c2nd vx
      cv csn cvv cxp cres ccnv ccnv cF cdm cima wceq cA cC wcel cB cD wcel wa
      cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa cF c2nd vx cv csn cvv
      cxp cres ccnv dmco a1i c2nd vx cv csn cvv cxp cres ccnv ccnv cF cdm cima
      c2nd ccnv ccnv vx cv csn cvv cxp cres cF cdm cima wceq cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa c2nd vx cv csn
      cvv cxp cres ccnv ccnv c2nd ccnv ccnv vx cv csn cvv cxp cres cF cdm c2nd
      vx cv csn cvv cxp cnvcnvres imaeq1i a1i cA cC wcel cB cD wcel wa cB c0
      wne cF cA cB cxp wfn wa wa vx cv cA wcel wa c2nd ccnv ccnv vx cv csn cvv
      cxp cres cF cdm cima c2nd ccnv ccnv vx cv csn cvv cxp cres cF cdm cres
      crn c2nd ccnv ccnv vx cv csn cvv cxp cF cdm cin cres crn cB c2nd ccnv
      ccnv vx cv csn cvv cxp cres cF cdm cima c2nd ccnv ccnv vx cv csn cvv cxp
      cres cF cdm cres crn wceq cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp
      wfn wa wa vx cv cA wcel wa c2nd ccnv ccnv vx cv csn cvv cxp cres cF cdm
      df-ima a1i cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx
      cv cA wcel wa c2nd ccnv ccnv vx cv csn cvv cxp cres cF cdm cres c2nd ccnv
      ccnv vx cv csn cvv cxp cF cdm cin cres c2nd ccnv ccnv vx cv csn cvv cxp
      cres cF cdm cres c2nd ccnv ccnv vx cv csn cvv cxp cF cdm cin cres wceq cA
      cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa
      c2nd ccnv ccnv vx cv csn cvv cxp cF cdm resres a1i rneqd cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa c2nd ccnv ccnv
      vx cv csn cvv cxp cF cdm cin cres crn c2nd vx cv csn cvv cxp cF cdm cin
      cres crn cB cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx
      cv cA wcel wa c2nd ccnv ccnv vx cv csn cvv cxp cF cdm cin cres c2nd vx cv
      csn cvv cxp cF cdm cin cres c2nd ccnv ccnv vx cv csn cvv cxp cF cdm cin
      cres c2nd vx cv csn cvv cxp cF cdm cin cres wceq cA cC wcel cB cD wcel wa
      cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa c2nd vx cv csn cvv cxp
      cF cdm cin rescnvcnv a1i rneqd cA cC wcel cB cD wcel wa cB c0 wne cF cA
      cB cxp wfn wa wa vx cv cA wcel c2nd vx cv csn cvv cxp cF cdm cin cres crn
      cB wceq cB c0 wne cF cA cB cxp wfn wa cA cC wcel cB cD wcel wa vx cv cA
      wcel c2nd vx cv csn cvv cxp cF cdm cin cres crn cB wceq wi cF cA cB cxp
      wfn cA cC wcel cB cD wcel wa vx cv cA wcel c2nd vx cv csn cvv cxp cF cdm
      cin cres crn cB wceq wi wi cB c0 wne cF cA cB cxp wfn cF cdm cA cB cxp
      wceq cA cC wcel cB cD wcel wa vx cv cA wcel c2nd vx cv csn cvv cxp cF cdm
      cin cres crn cB wceq wi wi cA cB cxp cF fndm vx cv cA wcel cA cC wcel cB
      cD wcel wa cF cdm cA cB cxp wceq c2nd vx cv csn cvv cxp cF cdm cin cres
      crn cB wceq vx cv cA wcel cA cC wcel cB cD wcel wa cF cdm cA cB cxp wceq
      c2nd vx cv csn cvv cxp cF cdm cin cres crn cB wceq vx cv cA wcel cA cC
      wcel cB cD wcel wa wa cF cdm cA cB cxp wceq wa c2nd vx cv csn cvv cxp cF
      cdm cin cres crn c2nd vx cv csn cvv cxp cA cB cxp cin cres crn cB vx cv
      cA wcel cA cC wcel cB cD wcel wa wa cF cdm cA cB cxp wceq wa c2nd vx cv
      csn cvv cxp cF cdm cin cres c2nd vx cv csn cvv cxp cA cB cxp cin cres vx
      cv cA wcel cA cC wcel cB cD wcel wa wa cF cdm cA cB cxp wceq wa vx cv csn
      cvv cxp cF cdm cin vx cv csn cvv cxp cA cB cxp cin wceq c2nd vx cv csn
      cvv cxp cF cdm cin cres c2nd vx cv csn cvv cxp cA cB cxp cin cres wceq vx
      cv cA wcel cA cC wcel cB cD wcel wa wa cF cdm cA cB cxp wceq wa cF cdm cA
      cB cxp vx cv csn cvv cxp vx cv cA wcel cA cC wcel cB cD wcel wa wa cF cdm
      cA cB cxp wceq pm3.27 ineq2d vx cv csn cvv cxp cF cdm cin vx cv csn cvv
      cxp cA cB cxp cin c2nd reseq2 syl rneqd vx cv cA wcel cA cC wcel cB cD
      wcel wa wa cF cdm cA cB cxp wceq wa c2nd vx cv csn cvv cxp cA cB cxp cin
      cres crn c2nd vx cv csn cA cin cvv cB cin cxp cres crn c2nd vx cv csn cB
      cxp cres crn cB c2nd vx cv csn cvv cxp cA cB cxp cin cres crn c2nd vx cv
      csn cA cin cvv cB cin cxp cres crn wceq vx cv cA wcel cA cC wcel cB cD
      wcel wa wa cF cdm cA cB cxp wceq wa c2nd vx cv csn cvv cxp cA cB cxp cin
      cres c2nd vx cv csn cA cin cvv cB cin cxp cres vx cv csn cvv cxp cA cB
      cxp cin vx cv csn cA cin cvv cB cin cxp wceq c2nd vx cv csn cvv cxp cA cB
      cxp cin cres c2nd vx cv csn cA cin cvv cB cin cxp cres wceq vx cv csn cvv
      cA cB inxp vx cv csn cvv cxp cA cB cxp cin vx cv csn cA cin cvv cB cin
      cxp c2nd reseq2 ax-mp rneqi a1i vx cv cA wcel c2nd vx cv csn cA cin cvv
      cB cin cxp cres crn c2nd vx cv csn cB cxp cres crn wceq cA cC wcel cB cD
      wcel wa cF cdm cA cB cxp wceq vx cv cA wcel c2nd vx cv csn cA cin cvv cB
      cin cxp cres c2nd vx cv csn cB cxp cres vx cv cA wcel vx cv csn cA cin
      cvv cB cin cxp vx cv csn cB cxp wceq c2nd vx cv csn cA cin cvv cB cin cxp
      cres c2nd vx cv csn cB cxp cres wceq vx cv csn cA cin vx cv csn wceq cvv
      cB cin cB wceq vx cv csn cA cin cvv cB cin cxp vx cv csn cB cxp wceq vx
      cv cA wcel vx cv csn cA cin vx cv csn cvv cB cin cB xpeq12 vx cv cA wcel
      vx cv csn cA wss vx cv csn cA cin vx cv csn wceq vx cv cA snssi vx cv csn
      cA df-ss sylib cvv cB cin cB cvv cin cB cvv cB incom cB inv1 eqtri
      sylancl vx cv csn cA cin cvv cB cin cxp vx cv csn cB cxp c2nd reseq2 syl
      rneqd ad2antrr vx cv cA wcel cA cC wcel cB cD wcel wa wa cF cdm cA cB cxp
      wceq wa vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres wfo c2nd vx cv csn
      cB cxp cres crn cB wceq vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres
      wfo vx cv cA wcel cA cC wcel cB cD wcel wa wa cF cdm cA cB cxp wceq wa vx
      cv cvv wcel vx cv cvv wcel vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres
      wf1o wi vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres wfo vx visset vx
      cv cB cvv 2ndconst vx cv cvv wcel vx cv cvv wcel vx cv csn cB cxp cB c2nd
      vx cv csn cB cxp cres wf1o wi vx cv csn cB cxp cB c2nd vx cv csn cB cxp
      cres wf1o vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres wfo vx cv cvv
      wcel vx cv csn cB cxp cB c2nd vx cv csn cB cxp cres wf1o pm2.27 vx cv csn
      cB cxp cB c2nd vx cv csn cB cxp cres f1ofo syl6 mp2 a1i vx cv csn cB cxp
      cB c2nd vx cv csn cB cxp cres forn syl 3eqtrd eqtrd exp31 com13 syl
      adantl impcom imp eqtrd 3eqtrd 3eqtrd jca cF c2nd vx cv csn cvv cxp cres
      ccnv ccom cB df-fn sylibr cB cF c2nd vx cv csn cvv cxp cres ccnv ccom
      dffn3 sylib cF c2nd vx cv csn cvv cxp cres ccnv rncoss sylancl cA cC wcel
      cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa cF c2nd
      vx cv csn cvv cxp cres ccnv ccom cvv wcel cF c2nd vx cv csn cvv cxp cres
      ccnv ccom cB cF crn vf cv wf vf cab wcel cB cF crn cF c2nd vx cv csn cvv
      cxp cres ccnv ccom wf wb cF cvv wcel c2nd vx cv csn cvv cxp cres ccnv
      ccnv wfun cF c2nd vx cv csn cvv cxp cres ccnv ccom cvv wcel cA cC wcel cB
      cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa cF c2nd vx
      cv csn cvv cxp cres ccnv cvv cofunex2g cA cC wcel cB cD wcel wa cB c0 wne
      cF cA cB cxp wfn wa wa cF cvv wcel vx cv cA wcel cB c0 wne cF cA cB cxp
      wfn wa cA cC wcel cB cD wcel wa cF cvv wcel cF cA cB cxp wfn cA cC wcel
      cB cD wcel wa cF cvv wcel wi cB c0 wne cF cA cB cxp wfn cA cB cxp cvv
      wcel cF cvv wcel cA cC wcel cB cD wcel wa cF cA cB cxp wfn cA cB cxp cvv
      wcel cF cvv wcel cA cB cxp cvv cF fnex ex cA cB cC cD xpexg syl5 adantl
      impcom adantr cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa
      vx cv cA wcel wa c2nd vx cv csn cvv cxp cres wfun c2nd vx cv csn cvv cxp
      cres ccnv ccnv wfun c2nd vx cv csn cvv cxp cres wfun cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa wa vx cv cA wcel wa c2nd wfun c2nd
      vx cv csn cvv cxp cres wfun cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv c2nd
      fofun ax-mp vx cv csn cvv cxp c2nd funres ax-mp a1i c2nd vx cv csn cvv
      cxp cres funcnvcnv syl sylanc cB cF crn vf cv wf cB cF crn cF c2nd vx cv
      csn cvv cxp cres ccnv ccom wf vf cF c2nd vx cv csn cvv cxp cres ccnv ccom
      cvv cB cF crn vf cv cF c2nd vx cv csn cvv cxp cres ccnv ccom feq1 elabg
      syl mpbird r19.21aiva cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn
      wa wa cF cA cB cxp wfn cB c0 wne wa cA cC wcel cB cD wcel wa wa cF ccur1
      cfv vx cv cA wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa
      vx vy copab wceq cF c2nd vx cv csn cvv cxp cres ccnv ccom cB cF crn vf cv
      wf vf cab wcel vx cA wral cA cB cF crn vf cv wf vf cab cF ccur1 cfv wf wb
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa wa cF cA cB cxp
      wfn cB c0 wne wa cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa
      cF cA cB cxp wfn cB c0 wne wa cA cC wcel cB cD wcel wa cB c0 wne cF cA cB
      cxp wfn pm3.22 adantl cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn
      wa pm3.26 jca vx vy cA cB cC cD cF cur1vald vx vy cA cB cF crn vf cv wf
      vf cab cF c2nd vx cv csn cvv cxp cres ccnv ccom cF ccur1 cfv fopab2g 3syl
      mpbid $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d B f $. $d F f $. $d O f $.
    $( The value of a curried function at ` 0 e. A ` is a mapping. $)
    valcurfn $p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ O e. A )
        ->
        ( ( cur1 ` F ) ` O ) : B --> ran F )  $=
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel cB cF
      crn cO cF ccur1 cfv cfv wf cA cC wcel cB cD wcel wa cB c0 wne cF cA cB
      cxp wfn wa wa cA cB cF crn vf cv wf vf cab cF ccur1 cfv wf cO cA wcel cB
      cF crn cO cF ccur1 cfv cfv wf wi cA cB cC cD vf cF domrancur1c cA cB cF
      crn vf cv wf vf cab cF ccur1 cfv wf cO cA wcel cB cF crn cO cF ccur1 cfv
      cfv wf cA cB cF crn vf cv wf vf cab cF ccur1 cfv wf cO cA wcel wa cO cF
      ccur1 cfv cfv cB cF crn vf cv wf vf cab wcel cB cF crn cO cF ccur1 cfv
      cfv wf cA cB cF crn vf cv wf vf cab cO cF ccur1 cfv ffvelrn cB cF crn vf
      cv wf cB cF crn cO cF ccur1 cfv cfv wf vf cO cF ccur1 cfv cfv cO cF ccur1
      cfv fvex cB cF crn vf cv cO cF ccur1 cfv cfv feq1 elab sylib ex syl
      3impia $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d F x y $. $d G x y $. $d O x y $.
    valcurfn1.1 $e |- G = ( F o. `' ( 2nd |` ( { O } X. _V ) ) ) $.
    $( The value of a curried function at ` O e. A ` is a partial
       application. $)
    valcurfn1 $p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ O e. A )
        ->
        ( ( cur1 ` F ) ` O ) = G  ) $=
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel w3a cO
      cF ccur1 cfv cfv cO vx cv cF cdm cdm wcel vy cv cF c2nd vx cv csn cvv cxp
      cres ccnv ccom wceq wa vx vy copab cfv cG cA cC wcel cB cD wcel wa cB c0
      wne cF cA cB cxp wfn wa cO cA wcel w3a cO cF ccur1 cfv vx cv cF cdm cdm
      wcel vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy copab
      cF cvv wcel cF wfun cF cdm wrel cF ccur1 cfv vx cv cF cdm cdm wcel vy cv
      cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy copab wceq cA cC
      wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel w3a vx vy cvv
      cF cur1val cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cF cvv
      wcel cO cA wcel cB c0 wne cF cA cB cxp wfn wa cA cC wcel cB cD wcel wa cF
      cvv wcel cF cA cB cxp wfn cA cC wcel cB cD wcel wa cF cvv wcel wi cB c0
      wne cF cA cB cxp wfn cA cB cxp cvv wcel cF cvv wcel cA cC wcel cB cD wcel
      wa cF cA cB cxp wfn cA cB cxp cvv wcel cF cvv wcel cA cB cxp cvv cF fnex
      ex cA cB cC cD xpexg syl5 adantl impcom 3adant3 cB c0 wne cF cA cB cxp
      wfn wa cA cC wcel cB cD wcel wa cF wfun cO cA wcel cF cA cB cxp wfn cF
      wfun cB c0 wne cA cB cxp cF fnfun adantl 3ad2ant2 cB c0 wne cF cA cB cxp
      wfn wa cA cC wcel cB cD wcel wa cF cdm wrel cO cA wcel cF cA cB cxp wfn
      cF cdm wrel cB c0 wne cF cA cB cxp wfn cF cdm cA cB cxp wceq cF cdm wrel
      cA cB cxp cF fndm cF cdm cA cB cxp wceq cF cdm wrel cA cB cxp wrel cA cB
      relxp cF cdm cA cB cxp releq mpbiri syl adantl 3ad2ant2 syl3anc fveq1d cO
      cF cdm cdm wcel cG cvv wcel cO vx cv cF cdm cdm wcel vy cv cF c2nd vx cv
      csn cvv cxp cres ccnv ccom wceq wa vx vy copab cfv cG wceq cA cC wcel cB
      cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel w3a vx vy cO cF c2nd
      vx cv csn cvv cxp cres ccnv ccom cG cF cdm cdm cvv vx cv cF cdm cdm wcel
      vy cv cF c2nd vx cv csn cvv cxp cres ccnv ccom wceq wa vx vy copab vx cv
      cO wceq cF c2nd vx cv csn cvv cxp cres ccnv ccom cF c2nd cO csn cvv cxp
      cres ccnv ccom cG vx cv cO wceq c2nd vx cv csn cvv cxp cres ccnv c2nd cO
      csn cvv cxp cres ccnv cF vx cv cO wceq c2nd vx cv csn cvv cxp cres c2nd
      cO csn cvv cxp cres wceq c2nd vx cv csn cvv cxp cres ccnv c2nd cO csn cvv
      cxp cres ccnv wceq vx cv cO wceq vx cv csn cvv cxp cO csn cvv cxp wceq
      c2nd vx cv csn cvv cxp cres c2nd cO csn cvv cxp cres wceq vx cv cO wceq
      vx cv csn cO csn wceq vx cv csn cvv cxp cO csn cvv cxp wceq vx cv cO sneq
      vx cv csn cO csn cvv xpeq1 syl vx cv csn cvv cxp cO csn cvv cxp c2nd
      reseq2 syl c2nd vx cv csn cvv cxp cres c2nd cO csn cvv cxp cres cnveq syl
      coeq2d valcurfn1.1 syl6eqr vx cv cF cdm cdm wcel vy cv cF c2nd vx cv csn
      cvv cxp cres ccnv ccom wceq wa vx vy copab eqid fvopab4g cB c0 wne cF cA
      cB cxp wfn wa cO cA wcel cO cF cdm cdm wcel cA cC wcel cB cD wcel wa cB
      c0 wne cF cA cB cxp wfn wa cO cA wcel cO cF cdm cdm wcel cB c0 wne cF cA
      cB cxp wfn wa cA cF cdm cdm cO cF cA cB cxp wfn cB c0 wne cA cF cdm cdm
      wceq cF cA cB cxp wfn cF cdm cA cB cxp wceq cB c0 wne cA cF cdm cdm wceq
      wi cA cB cxp cF fndm cF cdm cA cB cxp wceq cF cdm cdm cA cB cxp cdm wceq
      cB c0 wne cA cF cdm cdm wceq wi cF cdm cA cB cxp dmeq cF cdm cdm cA cB
      cxp cdm wceq cA cB cxp cdm cA wceq cA cF cdm cdm wceq cB c0 wne cF cdm
      cdm cA cB cxp cdm wceq cA cB cxp cdm cA wceq cA cF cdm cdm wceq cF cdm
      cdm cA cB cxp cdm wceq cA cB cxp cdm cA wceq wa cF cdm cdm cA cF cdm cdm
      cA cB cxp cdm cA eqtr eqcomd ex cA cB dmxp syl5 syl syl impcom eleq2d
      biimpa 3adant1 cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO
      cA wcel w3a cF c2nd cO csn cvv cxp cres ccnv ccom cvv cG cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel w3a cF cA cB cxp wfn cA
      cC wcel cB cD wcel wa wa cF c2nd cO csn cvv cxp cres ccnv ccom cvv wcel
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cF cA cB cxp wfn
      cA cC wcel cB cD wcel wa wa cO cA wcel cA cC wcel cB cD wcel wa cB c0 wne
      cF cA cB cxp wfn wa wa cF cA cB cxp wfn cA cC wcel cB cD wcel wa cA cC
      wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn simprr cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa pm3.26 jca 3adant3 cA cB cC cD cF
      cO csn cvv cxp domrancur1clem syl valcurfn1.1 syl5eqel sylanc eqtrd $.
      $( [18-May-2010] $) $( [17-May-2010] $)

  $}

  ${
    $d A x y $. $d B x y $. $d F x y $. $d O x y $.
    $( The value of a curried function at ` O e. A ` is a partial
       application. $)
    valcurfn2 $p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ O e. A )
        ->
        ( ( cur1 ` F ) ` O ) =
        { <. x , y >. | ( x e. B /\ y = ( O F x ) ) }  ) $=
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel w3a cO
      cF ccur1 cfv cfv cF c2nd cO csn cvv cxp cres ccnv ccom vx cv cB wcel vy
      cv cO vx cv cF co wceq wa vx vy copab cA cB cC cD cF cF c2nd cO csn cvv
      cxp cres ccnv ccom cO cF c2nd cO csn cvv cxp cres ccnv ccom eqid
      valcurfn1 cF cA cB cxp wfn cO cA wcel cF c2nd cO csn cvv cxp cres ccnv
      ccom vx cv cB wcel vy cv cO vx cv cF co wceq wa vx vy copab wceq cA cC
      wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel w3a vx vy cA
      cB cO cF cF c2nd cO csn cvv cxp cres ccnv ccom cF c2nd cO csn cvv cxp
      cres ccnv ccom eqid curry1 cA cC wcel cB cD wcel wa cB c0 wne cF cA cB
      cxp wfn wa cF cA cB cxp wfn cO cA wcel cA cC wcel cB cD wcel wa cB c0 wne
      cF cA cB cxp wfn simprr 3adant3 cA cC wcel cB cD wcel wa cB c0 wne cF cA
      cB cxp wfn wa cO cA wcel 3simp3 sylanc eqtrd $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d A x y $. $d B x y $. $d F x y $. $d O x y $. $d P x y $.
    $( The value at ` P e. B ` of the value of a curried function
       at ` 0 e. A ` equals ` ( O F P ) ` . $)
    valvalcurfn $p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ ( O e. A /\ P e. B ) )
        ->
        ( ( ( cur1 ` F ) ` O ) ` P ) = ( O F P ) )  $=
      cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel cP cB
      wcel wa w3a cP cO cF ccur1 cfv cfv cfv cP vx cv cB wcel vy cv cO vx cv cF
      co wceq wa vx vy copab cfv cO cP cF co cA cC wcel cB cD wcel wa cB c0 wne
      cF cA cB cxp wfn wa cO cA wcel cP cB wcel wa w3a cP cO cF ccur1 cfv cfv
      vx cv cB wcel vy cv cO vx cv cF co wceq wa vx vy copab cA cC wcel cB cD
      wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA wcel cO cF ccur1 cfv cfv vx
      cv cB wcel vy cv cO vx cv cF co wceq wa vx vy copab wceq cP cB wcel vx vy
      cA cB cC cD cF cO valcurfn2 3adant3r fveq1d cP cB wcel cO cP cF co cvv
      wcel cP vx cv cB wcel vy cv cO vx cv cF co wceq wa vx vy copab cfv cO cP
      cF co wceq cA cC wcel cB cD wcel wa cB c0 wne cF cA cB cxp wfn wa cO cA
      wcel cP cB wcel wa w3a vx vy cP cO vx cv cF co cO cP cF co cB cvv vx cv
      cB wcel vy cv cO vx cv cF co wceq wa vx vy copab vx cv cP cO cF opreq2 vx
      cv cB wcel vy cv cO vx cv cF co wceq wa vx vy copab eqid fvopab4g cO cA
      wcel cP cB wcel wa cA cC wcel cB cD wcel wa cP cB wcel cB c0 wne cF cA cB
      cxp wfn wa cO cA wcel cP cB wcel pm3.27 3ad2ant3 cO cP cF oprex sylancl
      eqtrd $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Order theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c mxl $.
  $c mnl $.
  $c ge $.
  $c le $.

  $( Extend class notation with a function that returns the maximal
     elements of a part of a poset. $)
  cmxl $a class mxl $.

  $( Extend class notation with a function that returns the minimal
     elements of a part of a poset. $)
  cmnl $a class mnl $.

  $( Extend class notation with a function that returns the greatest
     element of a part of a poset. $)
  cge $a class ge $.

  $( Extend class notation with a function that returns the least
     element of a part of a poset. $)
  cse $a class le $.

  ${ $d r x y a b $.
    $( Define the maximal elements of a part of a poset. I.e. the elements of
       the part that are not smaller than the other elements of the part. Read
       ` R mxl A ` as the ` R ` -maximal elements of set ` A ` .  Experimental.
       Bourbaki E.R.28 6. $)
    df-mxl $a |- mxl = { <. <. r , x >. , y >. |
       y = { a e. x | A. b e. x -. ( a r b /\ a =/= b ) } } $.
  $}

  ${ $d r x y $.
    $( Define the minimal elements of a part of a poset. I.e. the elements of
       the part that are not greater than the other elements of the part. Read
       ` R mnl A ` as the ` R ` -minimal elements of set ` A ` .  Experimental.
       Bourbaki E.R.28 6. $)
    df-mnl $a |- mnl = { <. <. r , x >. , y >. | y = ( `' r mxl x ) } $.
  $}

  ${ $d r x y z w a $.
    $( Define the greatest element of a part of a poset. I. e. the (unique if
       it exists) element of a part that is greater than the other elements of
       the part. Experimental. Bourbaki E.R. 25 5 $)
    df-ge $a |- ge = { <. <. r , x >. , y >. | E. z (
      z = { w e. x | A. a e. x a r w }
        /\ y = if ( z =/= (/) , U. z , ~P U. U. U. r ) ) } $.
  $}


  ${ $d r x y $.
    $( Define the least element of a part of a poset. I. e. the (unique if
       it exists) element of a part that is less than the other elements of
       the part. Experimental. Bourbaki E.R. 25 5 $)
    df-lea $a |- le = { <. <. r , x >. , y >. | y = ( `' r ge x ) } $.
  $}


  ${ $d A x y $. $d B x y $.
    inposetlem.1 $e |- A e. _V $.
    inposetlem.2 $e |- B e. _V $.
    inposetlem.3  $e |- C = { <. x , y >. | x C_ y } $.
    $( Lemma for ~ inposet . Definition of inclusion of sets using a class. $)
    inposetlem $p |- ( A C B <-> A C_ B ) $=
      vx cv vy cv wss cA vy cv wss cA cB wss vx vy cA cB cC inposetlem.1
      inposetlem.2 vx cv cA vy cv sseq1 vy cv cB cA sseq2 inposetlem.3 brab $.
      $( [23-Sep-2008] $) $( [22-Sep-2008] $)
  $}

  ${ $d x y $.
    inpc.1  $e |- C = { <. x , y >. | x C_ y } $.
    $( Inclusion is a proper class. $)
    inpc $p |- -. C e. _V $=
      cC cvv wcel cC cdm cvv wcel cC cdm cvv wcel cvv cvv wcel vprc cC cdm cvv
      cvv cC cdm vx cv vy cv wss vx vy copab cdm vx cv vy cv wss vy wex vx cab
      cvv cC vx cv vy cv wss vx vy copab inpc.1 dmeqi vx cv vy cv wss vx vy
      dmopab vx cv vy cv wss vy wex vx cab cvv wceq vx cv vy cv wss vy wex vx
      cv cvv wcel wb vx vx cv vy cv wss vy wex vx cvv abeq1 vx cv vy cv wss vy
      wex vx cv cvv wcel vx cv vx cv wss vx cv vy cv wss vy wex vx cv ssid vx
      cv vx cv wss vx cv vy cv wss vy vx vy cv vx cv wceq vx cv vx cv wss vx cv
      vy cv wss vy cv vx cv wceq vx cv vy cv vx cv vy vx equcomi sseq2d biimpd
      a4imev ax-mp vx visset 2th mpgbir 3eqtri eleq1i mtbir cC cvv dmexg mto $.
      $( [23-Sep-2008] $) $( [22-Sep-2008] $)
  $}

  ${ $d A a b x y z $. $d C a b x y z $.
    inposet.1  $e |- C = { <. x , y >. | x C_ y } $.
    $( Inclusion partially orders any set. $)
    inposet $p |- ( A e. B -> ( C i^i ( A X. A ) ) e. Poset ) $=
      cA cB wcel cC cA cA cxp cin cps wcel cC cA cA cxp cin wrel cC cA cA cxp
      cin cC cA cA cxp cin ccom cC cA cA cxp cin wss cC cA cA cxp cin cC cA cA
      cxp cin ccnv cin cid cC cA cA cxp cin cuni cuni cres wceq w3a cC cA cA
      cxp cin wrel cC cA cA cxp cin cC cA cA cxp cin ccom cC cA cA cxp cin wss
      cC cA cA cxp cin cC cA cA cxp cin ccnv cin cid cC cA cA cxp cin cuni cuni
      cres wceq cA cA cxp wrel cC cA cA cxp cin wrel cA cA relxp cC cA cA cxp
      relin2 ax-mp vx cv vz cv cC cA cA cxp cin wbr vz cv vy cv cC cA cA cxp
      cin wbr wa vz wex vx vy copab vx cv vy cv wss vx cv cA wcel vy cv cA wcel
      wa wa vx vy copab cC cA cA cxp cin cC cA cA cxp cin ccom cC cA cA cxp cin
      vx cv vz cv cC cA cA cxp cin wbr vz cv vy cv cC cA cA cxp cin wbr wa vz
      wex vx cv vy cv wss vx cv cA wcel vy cv cA wcel wa wa vx vy vx cv vz cv
      cC cA cA cxp cin wbr vz cv vy cv cC cA cA cxp cin wbr wa vx cv vy cv wss
      vx cv cA wcel vy cv cA wcel wa wa vz vx cv cA wcel vz cv cA wcel vx cv vz
      cv cC wbr w3a vz cv cA wcel vy cv cA wcel vz cv vy cv cC wbr w3a vx cv vy
      cv wss vx cv cA wcel vy cv cA wcel wa wa vx cv vz cv cC cA cA cxp cin wbr
      vz cv vy cv cC cA cA cxp cin wbr vx cv cA wcel vz cv cA wcel vx cv vz cv
      cC wbr w3a vz cv cA wcel vy cv cA wcel vz cv vy cv cC wbr w3a wa vx cv vy
      cv wss vx cv cA wcel vy cv cA wcel wa vx cv cA wcel vz cv cA wcel vx cv
      vz cv cC wbr w3a vz cv cA wcel vy cv cA wcel vz cv vy cv cC wbr w3a vx cv
      vy cv wss vx cv vz cv cC wbr vx cv cA wcel vz cv cA wcel vy cv cA wcel vz
      cv vy cv cC wbr w3a vx cv vy cv wss wi vz cv cA wcel vz cv cA wcel vy cv
      cA wcel vz cv vy cv cC wbr w3a vx cv vz cv cC wbr vx cv vy cv wss vz cv
      vy cv cC wbr vz cv cA wcel vx cv vz cv cC wbr vx cv vy cv wss wi vy cv cA
      wcel vz cv vy cv cC wbr va cv vz cv cC wbr va cv vy cv wss wi wi vz cv vy
      cv cC wbr vx cv vz cv cC wbr vx cv vy cv wss wi wi va vx va cv vx cv wceq
      va cv vz cv cC wbr va cv vy cv wss wi vx cv vz cv cC wbr vx cv vy cv wss
      wi vz cv vy cv cC wbr va cv vx cv wceq va cv vz cv cC wbr vx cv vz cv cC
      wbr va cv vy cv wss vx cv vy cv wss va cv vx cv vz cv cC breq1 va cv vx
      cv vy cv sseq1 imbi12d imbi2d vz cv vb cv cC wbr va cv vz cv cC wbr va cv
      vb cv wss wi wi vz cv vy cv cC wbr va cv vz cv cC wbr va cv vy cv wss wi
      wi vb vy vb cv vy cv wceq vz cv vb cv cC wbr vz cv vy cv cC wbr va cv vz
      cv cC wbr va cv vb cv wss wi va cv vz cv cC wbr va cv vy cv wss wi vb cv
      vy cv vz cv cC breq2 vb cv vy cv wceq va cv vb cv wss va cv vy cv wss va
      cv vz cv cC wbr vb cv vy cv va cv sseq2 imbi2d imbi12d vz cv vb cv cC wbr
      vz cv vb cv wss va cv vz cv cC wbr va cv vb cv wss wi vx vy vz cv vb cv
      cC vz visset vb visset inposet.1 inposetlem va cv vz cv cC wbr vz cv vb
      cv wss va cv vb cv wss va cv vz cv cC wbr va cv vz cv wss vz cv vb cv wss
      va cv vb cv wss wi vx vy va cv vz cv cC va visset vz visset inposet.1
      inposetlem va cv vz cv vb cv sstr2 sylbi com12 sylbi chvarv chvarv
      3ad2ant3 com12 3ad2ant3 imp vx cv cA wcel vz cv cA wcel vx cv vz cv cC
      wbr w3a vx cv cA wcel vz cv cA wcel vy cv cA wcel vz cv vy cv cC wbr w3a
      vy cv cA wcel vx cv cA wcel vz cv cA wcel vx cv vz cv cC wbr 3simp1 vz cv
      cA wcel vy cv cA wcel vz cv vy cv cC wbr 3simp2 anim12i jca vz cv cvv
      wcel vx cv vz cv cC cA cA cxp cin wbr vx cv cA wcel vz cv cA wcel vx cv
      vz cv cC wbr w3a wb vz visset vx cv vz cv cA cA cC cvv brinxp2 ax-mp vy
      cv cvv wcel vz cv vy cv cC cA cA cxp cin wbr vz cv cA wcel vy cv cA wcel
      vz cv vy cv cC wbr w3a wb vy visset vz cv vy cv cA cA cC cvv brinxp2
      ax-mp syl2anb 19.23aiv ssopab2i vx vy vz cC cA cA cxp cin cC cA cA cxp
      cin df-co cC cA cA cxp cin vx cv vy cv wss vx vy copab cA cA cxp cin vx
      cv vy cv wss vx vy copab vx cv cA wcel vy cv cA wcel wa vx vy copab cin
      vx cv vy cv wss vx cv cA wcel vy cv cA wcel wa wa vx vy copab cC vx cv vy
      cv wss vx vy copab cA cA cxp inposet.1 ineq1i cA cA cxp vx cv cA wcel vy
      cv cA wcel wa vx vy copab vx cv vy cv wss vx vy copab vx vy cA cA df-xp
      ineq2i vx cv vy cv wss vx cv cA wcel vy cv cA wcel wa vx vy inopab 3eqtri
      3sstr4i cC cA cA cxp cin cC cA cA cxp cin ccnv cin cid cC cA cA cxp cin
      cuni cuni cres wceq va cv vb cv cC cA cA cxp cin wbr vb cv va cv cC cA cA
      cxp cin wbr wa va cv vb cv wceq wb vb wal va cC cA cA cxp cin cuni cuni
      va vb cC cA cA cxp cin asymref va cv cC cA cA cxp cin cuni cuni wcel va
      cv cA wcel va cv vb cv cC cA cA cxp cin wbr vb cv va cv cC cA cA cxp cin
      wbr wa va cv vb cv wceq wb vb wal va cv cC cA cA cxp cin cuni cuni wcel
      va cv cC cuni cA cA cxp cuni cin cuni wcel va cv cC cuni cuni cA cA cxp
      cuni cuni cin wcel va cv cA wcel cC cA cA cxp cin cuni cuni cC cuni cA cA
      cxp cuni cin cuni va cv cC cA cA cxp cin cuni cC cuni cA cA cxp cuni cin
      wss cC cA cA cxp cin cuni cuni cC cuni cA cA cxp cuni cin cuni wss cC cA
      cA cxp uniin cC cA cA cxp cin cuni cC cuni cA cA cxp cuni cin uniss ax-mp
      sseli cC cuni cA cA cxp cuni cin cuni cC cuni cuni cA cA cxp cuni cuni
      cin va cv cC cuni cA cA cxp cuni uniin sseli va cv cC cuni cuni cA cA cxp
      cuni cuni cin wcel va cv cC cuni cuni wcel va cv cA cA cxp cuni cuni wcel
      wa va cv cA wcel va cv cC cuni cuni cA cA cxp cuni cuni elin va cv cA cA
      cxp cuni cuni wcel va cv cA wcel va cv cC cuni cuni wcel va cv cA cA cxp
      cuni cuni wcel va cv cA cA cun cA cA cA cxp cuni cuni cA cA cun va cv cA
      cA unixpss sseli cA unidm syl6eleq adantl sylbi 3syl va cv cA wcel va cv
      vb cv cC cA cA cxp cin wbr vb cv va cv cC cA cA cxp cin wbr wa va cv vb
      cv wceq wb vb va cv cA wcel va cv vb cv cC cA cA cxp cin wbr vb cv va cv
      cC cA cA cxp cin wbr wa va cv vb cv wceq va cv cA wcel va cv cA wcel vb
      cv cA wcel va cv vb cv cC wbr w3a vb cv cA wcel va cv cA wcel vb cv va cv
      cC wbr w3a wa va cv vb cv wceq va cv vb cv cC cA cA cxp cin wbr vb cv va
      cv cC cA cA cxp cin wbr wa va cv cA wcel vb cv cA wcel va cv vb cv cC wbr
      w3a vb cv cA wcel va cv cA wcel vb cv va cv cC wbr w3a wa va cv vb cv
      wceq wi va cv cA wcel va cv cA wcel vb cv cA wcel va cv vb cv cC wbr w3a
      vb cv cA wcel va cv cA wcel vb cv va cv cC wbr w3a va cv vb cv wceq va cv
      vb cv cC wbr va cv cA wcel vb cv cA wcel va cv cA wcel vb cv va cv cC wbr
      w3a va cv vb cv wceq wi vb cv cA wcel va cv vb cv cC wbr va cv vb cv wss
      vb cv cA wcel va cv cA wcel vb cv va cv cC wbr w3a va cv vb cv wceq wi vx
      vy va cv vb cv cC va visset vb visset inposet.1 inposetlem vb cv cA wcel
      va cv cA wcel vb cv va cv cC wbr w3a va cv vb cv wss va cv vb cv wceq vb
      cv va cv cC wbr vb cv cA wcel va cv vb cv wss va cv vb cv wceq wi va cv
      cA wcel vb cv va cv cC wbr vb cv va cv wss va cv vb cv wss va cv vb cv
      wceq wi vx vy vb cv va cv cC vb visset va visset inposet.1 inposetlem va
      cv vb cv wss vb cv va cv wss va cv vb cv wceq va cv vb cv wceq va cv vb
      cv wss vb cv va cv wss wa va cv vb cv eqss biimpri expcom sylbi 3ad2ant3
      com12 sylbi 3ad2ant3 imp a1i va cv vb cv cC cA cA cxp cin wbr va cv cA
      wcel vb cv cA wcel va cv vb cv cC wbr w3a vb cv va cv cC cA cA cxp cin
      wbr vb cv cA wcel va cv cA wcel vb cv va cv cC wbr w3a vb cv cvv wcel va
      cv vb cv cC cA cA cxp cin wbr va cv cA wcel vb cv cA wcel va cv vb cv cC
      wbr w3a wb vb visset va cv vb cv cA cA cC cvv brinxp2 ax-mp va cv cvv
      wcel vb cv va cv cC cA cA cxp cin wbr vb cv cA wcel va cv cA wcel vb cv
      va cv cC wbr w3a wb va visset vb cv va cv cA cA cC cvv brinxp2 ax-mp
      anbi12i syl5ib va cv vb cv wceq va cv cA wcel va cv vb cv cC cA cA cxp
      cin wbr vb cv va cv cC cA cA cxp cin wbr wa va cv vb cv wceq va cv cA
      wcel va cv vb cv cC cA cA cxp cin wbr vb cv va cv cC cA cA cxp cin wbr wa
      wi vb cv cA wcel vb cv vb cv cC cA cA cxp cin wbr vb cv vb cv cC cA cA
      cxp cin wbr wa wi vb cv cA wcel vb cv vb cv cC cA cA cxp cin wbr vb cv vb
      cv cC cA cA cxp cin wbr wa wi vb cv cA wcel vb cv vb cv cC cA cA cxp cin
      wbr wi vb cv cA wcel vb cv vb cv cC cA cA cxp cin wbr vb cv cA wcel vb cv
      cA wcel vb cv vb cv cC wbr w3a vb cv cA wcel vb cv cA wcel vb cv cA wcel
      vb cv vb cv cC wbr vb cv cA wcel id vb cv cA wcel id vb cv vb cv cC wbr
      vb cv cA wcel vb cv vb cv cC wbr vb cv vb cv wss vb cv ssid vx vy vb cv
      vb cv cC vb visset vb visset inposet.1 inposetlem mpbir a1i 3jca vb cv vb
      cv cA cA cC cA brinxp2 mpbird vb cv cA wcel vb cv vb cv cC cA cA cxp cin
      wbr anidmdbi mpbir va cv vb cv wceq va cv cA wcel vb cv cA wcel va cv vb
      cv cC cA cA cxp cin wbr vb cv va cv cC cA cA cxp cin wbr wa vb cv vb cv
      cC cA cA cxp cin wbr vb cv vb cv cC cA cA cxp cin wbr wa va cv vb cv cA
      eleq1 va cv vb cv wceq va cv vb cv cC cA cA cxp cin wbr vb cv vb cv cC cA
      cA cxp cin wbr vb cv va cv cC cA cA cxp cin wbr vb cv vb cv cC cA cA cxp
      cin wbr va cv vb cv vb cv cC cA cA cxp cin breq1 va cv vb cv vb cv cC cA
      cA cxp cin breq2 anbi12d imbi12d mpbiri com12 impbid 19.21aiv syl mprgbir
      3pm3.2i cA cB wcel cC cA cA cxp cin cvv wcel cC cA cA cxp cin cps wcel cC
      cA cA cxp cin wrel cC cA cA cxp cin cC cA cA cxp cin ccom cC cA cA cxp
      cin wss cC cA cA cxp cin cC cA cA cxp cin ccnv cin cid cC cA cA cxp cin
      cuni cuni cres wceq w3a wb cA cB wcel cA cA cxp cvv wcel cC cA cA cxp cin
      cvv wcel cA cB wcel cA cA cxp cvv wcel cA cA cB cB xpexg anidms cA cA cxp
      cvv wcel cA cA cxp cC cin cvv cC cA cA cxp cin cA cA cxp cC cvv inex1g cC
      cA cA cxp incom syl5eqel syl cvv cC cA cA cxp cin isps syl mpbiri $.
      $( [23-Sep-2008] $) $( [22-Sep-2008] $)
  $}

  ${ $d F x y $. $d G x y $.
    definc.1  $e |- G e. X $.
    definc.2  $e |- F e. Y $.
    definc.3  $e |- C = { <. x , y >. | x C_ y } $.
    $( Note: remove definc. 1 using opelxp1. $)
    $( Definition of the inclusion. $)
    definc $p |- ( G ( C i^i ( A X. B ) ) F <->
      ( G e. A /\ F e. B /\ G C_ F ) ) $=
      cG cF cC cA cB cxp cin wbr cG cF cC wbr cG cF cA cB cxp wbr wa cG cF wss
      cG cA wcel cF cB wcel wa wa cG cA wcel cF cB wcel cG cF wss w3a cG cF cC
      cA cB cxp int2rel cG cF cC wbr cG cF wss cG cF cA cB cxp wbr cG cA wcel
      cF cB wcel wa vx vy cG cF cC cG cX definc.1 elisseti cF cY definc.2
      elisseti definc.3 inposetlem cG cF cA cB cF cY definc.2 elisseti brxp
      anbi12i cG cF wss cG cA wcel cF cB wcel wa wa cG cA wcel cF cB wcel cG cF
      wss w3a cG cF wss cG cA wcel cF cB wcel wa wa cG cA wcel cF cB wcel cG cF
      wss cG cF wss cG cA wcel cF cB wcel simprl cG cF wss cG cA wcel cF cB
      wcel simprr cG cF wss cG cA wcel cF cB wcel wa pm3.26 3jca cG cA wcel cF
      cB wcel cG cF wss w3a cG cF wss cG cA wcel cF cB wcel wa cG cA wcel cF cB
      wcel cG cF wss 3simp3 cG cA wcel cF cB wcel cG cF wss 3simpa jca impbii
      3bitri $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${ $d C x $. $d x y $.
    dominc.1  $e |- C = { <. x , y >. | x C_ y } $.
    $( The domain of the inclusion relation is ` _V ` . $)
    dominc $p |- dom C = _V $=
      cC cdm cvv wceq vx cv cC cdm wcel vx vx cC cdm eqv vx cv vx cv vy cv wss
      vy wex vx cab cC cdm vx cv vx cv vy cv wss vy wex vx cab wcel vx cv vy cv
      wss vy wex vx cv vx cv wss vx cv vy cv wss vy wex vx cv ssid vx cv vx cv
      wss vx cv vy cv wss vy vx vy vx weq vx cv vx cv wss vx cv vy cv wss vx cv
      vx cv wss vx cv vy cv wss wb vx vy vx cv vy cv vx cv sseq2 equcoms biimpd
      a4imev ax-mp vx cv vy cv wss vy wex vx abid mpbir cC cdm vx cv vy cv wss
      vx vy copab cdm vx cv vy cv wss vy wex vx cab cC vx cv vy cv wss vx vy
      copab dominc.1 dmeqi vx cv vy cv wss vx vy dmopab eqtri eleqtrri mpgbir
      $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${ $d C y $. $d x y $.
    rninc.1  $e |- C = { <. x , y >. | x C_ y } $.
    $( The range of the inclusion relation is ` _V ` . $)
    rninc $p |- ran C = _V $=
      cC crn cvv wceq vy cv cC crn wcel vy vy cC crn eqv vy cv vx cv vy cv wss
      vx wex vy cab cC crn vy cv vx cv vy cv wss vx wex vy cab wcel vx cv vy cv
      wss vx wex vy cv vy cv wss vx cv vy cv wss vx wex vy cv ssid vy cv vy cv
      wss vx cv vy cv wss vx vy vx vy weq vy cv vy cv wss vx cv vy cv wss vy cv
      vy cv wss vx cv vy cv wss wb vy vx vy cv vx cv vy cv sseq1 equcoms biimpd
      a4imev ax-mp vx cv vy cv wss vx wex vy abid mpbir cC crn vx cv vy cv wss
      vx vy copab crn vx cv vy cv wss vx wex vy cab cC vx cv vy cv wss vx vy
      copab rninc.1 rneqi vx cv vy cv wss vx vy rnopab eqtri eleqtrri mpgbir $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${ $d A x y $.
    domncnt.1  $e |- C = { <. x , y >. | x C_ y } $.
    $( Domain of the intersection of the inclusion with a square
       cross product. $)
    domncnt $p |- dom ( C i^i ( A X. A ) ) = A $=
      cC cA cA cxp cin cdm vx cv vy cv wss vx vy copab vx cv cA wcel vy cv cA
      wcel wa vx vy copab cin cdm vx cv cA wcel vy cv cA wcel vx cv vy cv wss
      wa wa vx vy copab cdm cA cC cA cA cxp cin vx cv vy cv wss vx vy copab vx
      cv cA wcel vy cv cA wcel wa vx vy copab cin cC vx cv vy cv wss vx vy
      copab cA cA cxp vx cv cA wcel vy cv cA wcel wa vx vy copab domncnt.1 vx
      vy cA cA df-xp ineq12i dmeqi vx cv vy cv wss vx vy copab vx cv cA wcel vy
      cv cA wcel wa vx vy copab cin vx cv cA wcel vy cv cA wcel vx cv vy cv wss
      wa wa vx vy copab vx cv vy cv wss vx vy copab vx cv cA wcel vy cv cA wcel
      wa vx vy copab cin vx cv vy cv wss vx cv cA wcel vy cv cA wcel wa wa vx
      vy copab vx cv cA wcel vy cv cA wcel vx cv vy cv wss wa wa vx vy copab vx
      cv vy cv wss vx cv cA wcel vy cv cA wcel wa vx vy inopab vx cv vy cv wss
      vx cv cA wcel vy cv cA wcel wa wa vx cv cA wcel vy cv cA wcel vx cv vy cv
      wss wa wa vx vy vx cv vy cv wss vx cv cA wcel vy cv cA wcel wa wa vx cv
      cA wcel vy cv cA wcel vx cv vy cv wss wa wa vx cv vy cv wss vx cv cA wcel
      vy cv cA wcel wa wa vx cv cA wcel vy cv cA wcel vx cv vy cv wss wa vx cv
      vy cv wss vx cv cA wcel vy cv cA wcel simprl vx cv vy cv wss vx cv cA
      wcel vy cv cA wcel wa wa vy cv cA wcel vx cv vy cv wss vx cv vy cv wss vx
      cv cA wcel vy cv cA wcel simprr vx cv vy cv wss vx cv cA wcel vy cv cA
      wcel wa pm3.26 jca jca vx cv cA wcel vy cv cA wcel vx cv vy cv wss wa wa
      vx cv vy cv wss vx cv cA wcel vy cv cA wcel wa vx cv cA wcel vy cv cA
      wcel vx cv vy cv wss simprr vx cv cA wcel vy cv cA wcel vx cv vy cv wss
      wa wa vx cv cA wcel vy cv cA wcel vx cv cA wcel vy cv cA wcel vx cv vy cv
      wss wa pm3.26 vx cv cA wcel vy cv cA wcel vx cv vy cv wss simprl jca jca
      impbii opabbii eqtri dmeqi vy cv cA wcel vx cv vy cv wss wa vy wex vx cA
      wral vx cv cA wcel vy cv cA wcel vx cv vy cv wss wa wa vx vy copab cdm cA
      wceq vy cv cA wcel vx cv vy cv wss wa vy wex vx cA vx cv cA wcel vx cv vy
      cv wss vy cA wrex vy cv cA wcel vx cv vy cv wss wa vy wex vx cv cA wcel
      vx cv vx cv wss vx cv vy cv wss vy cA wrex vx cv ssid vx cv vy cv wss vx
      cv vx cv wss vy vx cv cA vy cv vx cv vx cv sseq2 rcla4ev mpan2 vx cv vy
      cv wss vy cA df-rex sylib rgen vy cv cA wcel vx cv vy cv wss wa vx vy cA
      dmopab3 mpbi 3eqtri $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${ $d A x y $.
    ranncnt.1  $e |- C = { <. x , y >. | x C_ y } $.
    $( Range of the intersection of the inclusion with a square
       cross product. $)
    ranncnt $p |- ran ( C i^i ( A X. A ) ) = A $=
      cC cA cA cxp cin crn vx cv vy cv wss vx vy copab vx cv cA wcel vy cv cA
      wcel wa vx vy copab cin crn vx cv cA wcel vy cv cA wcel wa vx cv vy cv
      wss wa vx vy copab crn cA cC cA cA cxp cin vx cv vy cv wss vx vy copab vx
      cv cA wcel vy cv cA wcel wa vx vy copab cin cC vx cv vy cv wss vx vy
      copab cA cA cxp vx cv cA wcel vy cv cA wcel wa vx vy copab ranncnt.1 vx
      vy cA cA df-xp ineq12i rneqi vx cv vy cv wss vx vy copab vx cv cA wcel vy
      cv cA wcel wa vx vy copab cin vx cv cA wcel vy cv cA wcel wa vx cv vy cv
      wss wa vx vy copab vx cv vy cv wss vx vy copab vx cv cA wcel vy cv cA
      wcel wa vx vy copab cin vx cv cA wcel vy cv cA wcel wa vx vy copab vx cv
      vy cv wss vx vy copab cin vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss
      wa vx vy copab vx cv vy cv wss vx vy copab vx cv cA wcel vy cv cA wcel wa
      vx vy copab incom vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss vx vy
      inopab eqtri rneqi vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vx
      vy copab crn vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vx vy
      copab ccnv cdm vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vy vx
      copab cdm cA vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vx vy
      copab df-rn vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vx vy copab
      ccnv vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vy vx copab vx cv
      cA wcel vy cv cA wcel wa vx cv vy cv wss wa vx vy cnvopab dmeqi vx cv cA
      wcel vy cv cA wcel wa vx cv vy cv wss wa vy vx copab cdm vy cv cA wcel vx
      cv cA wcel vx cv vy cv wss wa wa vy vx copab cdm cA vx cv cA wcel vy cv
      cA wcel wa vx cv vy cv wss wa vy vx copab vy cv cA wcel vx cv cA wcel vx
      cv vy cv wss wa wa vy vx copab vx cv cA wcel vy cv cA wcel wa vx cv vy cv
      wss wa vy cv cA wcel vx cv cA wcel vx cv vy cv wss wa wa vy vx vx cv cA
      wcel vy cv cA wcel wa vx cv vy cv wss wa vy cv cA wcel vx cv cA wcel vx
      cv vy cv wss wa wa vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa vy
      cv cA wcel vx cv cA wcel vx cv vy cv wss wa vx cv cA wcel vy cv cA wcel
      vx cv vy cv wss simplr vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss wa
      vx cv cA wcel vx cv vy cv wss vx cv cA wcel vy cv cA wcel vx cv vy cv wss
      simpll vx cv cA wcel vy cv cA wcel wa vx cv vy cv wss pm3.27 jca jca vy
      cv cA wcel vx cv cA wcel vx cv vy cv wss wa wa vx cv cA wcel vy cv cA
      wcel wa vx cv vy cv wss vy cv cA wcel vx cv cA wcel vx cv vy cv wss wa wa
      vx cv cA wcel vy cv cA wcel vy cv cA wcel vx cv cA wcel vx cv vy cv wss
      simprl vy cv cA wcel vx cv cA wcel vx cv vy cv wss wa pm3.26 jca vy cv cA
      wcel vx cv cA wcel vx cv vy cv wss simprr jca impbii opabbii dmeqi vx cv
      cA wcel vx cv vy cv wss wa vx wex vy cA wral vy cv cA wcel vx cv cA wcel
      vx cv vy cv wss wa wa vy vx copab cdm cA wceq vx cv cA wcel vx cv vy cv
      wss wa vx wex vy cA vy cv vy cv wss vy cv cA wcel vx cv cA wcel vx cv vy
      cv wss wa vx wex vy cv ssid vy cv vy cv wss vy cv cA wcel wa vx cv vy cv
      wss vx cA wrex vx cv cA wcel vx cv vy cv wss wa vx wex vy cv cA wcel vy
      cv vy cv wss vx cv vy cv wss vx cA wrex vx cv vy cv wss vy cv vy cv wss
      vx vy cv cA vx cv vy cv vy cv sseq1 rcla4ev ancoms vx cv vy cv wss vx cA
      df-rex sylib mpan rgen vx cv cA wcel vx cv vy cv wss wa vy vx cA dmopab3
      mpbi eqtri 3eqtri 3eqtri $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${ $d A r x y $. $d R r x y $.
  $( Value of an infimum under a weak ordering. $)
  nfwval $p |- ( ( R e. U /\ A e. W ) -> ( R infw A ) = ( `' R supw A ) ) $=
    vr vx vy cR cA cU cW vr cv ccnv vx cv cspw co cR ccnv cA cspw co cinf cR
    ccnv vx cv cspw co cR ccnv cA cspw oprex vr cv cR wceq vr cv ccnv cR ccnv
    vx cv cspw vr cv cR cnveq opreq1d vx cv cA cR ccnv cspw opreq2 vx vy vr
    df-nfw oprabval5 $.
    $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  $( The empty set is a poset. $)
  empos $p |- (/) e. Poset $=
    c0 cps wcel c0 wrel c0 c0 ccom c0 wss c0 c0 ccnv cin cid c0 cuni cuni cres
    wceq w3a c0 wrel c0 c0 ccom c0 wss c0 c0 ccnv cin cid c0 cuni cuni cres
    wceq rel0 c0 c0 ccom c0 c0 co01 eqimssi c0 c0 ccnv cin c0 c0 cin c0 cid c0
    cuni cuni cres c0 ccnv c0 c0 cnv0 ineq2i c0 inidm cid c0 cuni cuni cres cid
    c0 cres c0 c0 cuni cuni c0 wceq cid c0 cuni cuni cres cid c0 cres wceq c0
    cuni cuni c0 cuni c0 c0 cuni c0 uni0 unieqi uni0 eqtri c0 cuni cuni c0 cid
    reseq2 ax-mp cid res0 eqtr2i 3eqtri 3pm3.2i c0 cvv wcel c0 cps wcel c0 wrel
    c0 c0 ccom c0 wss c0 c0 ccnv cin cid c0 cuni cuni cres wceq w3a wb 0ex cvv
    c0 isps ax-mp mpbir $.
    $( [7-Oct-2008] $) $( [6-Oct-2008] $)

  $( The converse of a poset is a poset. In the general case
     ` ( ``' R e. Poset -> R e. Poset ) ` is not true. See ~ dupos2
     for a special case where the property holds. $)
  dupos1 $p |- ( R e. Poset -> `' R e. Poset ) $=
    cR cps wcel cR ccnv cps wcel cR ccnv wrel cR ccnv cR ccnv ccom cR ccnv wss
    cR ccnv cR ccnv ccnv cin cid cR ccnv cuni cuni cres wceq w3a cR cps wcel cR
    ccnv wrel cR ccnv cR ccnv ccom cR ccnv wss cR ccnv cR ccnv ccnv cin cid cR
    ccnv cuni cuni cres wceq w3a cR cps wcel cR cps wcel cR wrel cR cR ccom cR
    wss cR cR ccnv cin cid cR cuni cuni cres wceq w3a cR ccnv wrel cR ccnv cR
    ccnv ccom cR ccnv wss cR ccnv cR ccnv ccnv cin cid cR ccnv cuni cuni cres
    wceq w3a cps cR isps cR cps wcel cR wrel cR ccnv wrel cR cR ccom cR wss cR
    ccnv cR ccnv ccom cR ccnv wss cR cR ccnv cin cid cR cuni cuni cres wceq cR
    ccnv cR ccnv ccnv cin cid cR ccnv cuni cuni cres wceq cR wrel cR ccnv wrel
    wi cR cps wcel cR ccnv wrel cR wrel cR relcnv a1i a1i cR cR ccom cR wss cR
    ccnv cR ccnv ccom cR ccnv wss wi cR cps wcel cR cR ccom cR wss cR cR ccom
    ccnv cR ccnv cR ccnv cR ccnv ccom cR cR ccom cR cnvss cR cR cnvco syl5ssr
    a1i cR wrel cR cuni cuni cR ccnv cuni cuni wceq cR cR ccnv cin cid cR cuni
    cuni cres wceq cR ccnv cR ccnv ccnv cin cid cR ccnv cuni cuni cres wceq wi
    cR cps wcel cR wrel cR ccnv ccnv cR wceq cR cuni cuni cR ccnv cuni cuni
    wceq cR cR ccnv cin cid cR cuni cuni cres wceq cR ccnv cR ccnv ccnv cin cid
    cR ccnv cuni cuni cres wceq wi wi cR dfrel2 cR ccnv ccnv cR wceq cR cR ccnv
    cin cid cR cuni cuni cres wceq cR ccnv cR ccnv ccnv cin cid cR ccnv cuni
    cuni cres wceq wi cR cR ccnv cin cid cR cuni cuni cres wceq cR ccnv cR cin
    cid cR ccnv cuni cuni cres wceq wi cR cuni cuni cR ccnv cuni cuni wceq cR
    ccnv ccnv cR wceq cR ccnv cR ccnv ccnv cin cid cR ccnv cuni cuni cres wceq
    cR ccnv cR cin cid cR ccnv cuni cuni cres wceq cR cR ccnv cin cid cR cuni
    cuni cres wceq cR ccnv ccnv cR wceq cR ccnv cR ccnv ccnv cin cR ccnv cR cin
    cid cR ccnv cuni cuni cres cR ccnv ccnv cR cR ccnv ineq2 eqeq1d imbi2d cR
    cuni cuni cR ccnv cuni cuni wceq cR cR ccnv cin cid cR cuni cuni cres wceq
    cR ccnv cR cin cid cR ccnv cuni cuni cres wceq cR cuni cuni cR ccnv cuni
    cuni wceq cR cR ccnv cin cid cR cuni cuni cres wceq wa cR cR ccnv cin cid
    cR ccnv cuni cuni cres cR ccnv cR cin cR cuni cuni cR ccnv cuni cuni wceq
    cR cR ccnv cin cid cR cuni cuni cres wceq cR cR ccnv cin cid cR ccnv cuni
    cuni cres wceq cR cuni cuni cR ccnv cuni cuni wceq cid cR cuni cuni cres
    cid cR ccnv cuni cuni cres cR cR ccnv cin cR cuni cuni cR ccnv cuni cuni
    cid reseq2 eqeq2d biimpa cR ccnv cR incom syl5eq ex syl5bir sylbi cR psrel
    cR cps wcel cR wrel cR cuni cuni cR ccnv cuni cuni wceq cR psrel cR
    relcnvfld syl sylc 3anim123d sylbid pm2.43i cR cps wcel cR ccnv cvv wcel cR
    ccnv cps wcel cR ccnv wrel cR ccnv cR ccnv ccom cR ccnv wss cR ccnv cR ccnv
    ccnv cin cid cR ccnv cuni cuni cres wceq w3a wb cR cps cnvexg cvv cR ccnv
    isps syl mpbird $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)

  $( The converse of a poset is a poset. $)
  dupos2 $p |- ( Rel R -> ( R e. Poset <-> `' R e. Poset ) ) $=
    cR wrel cR cps wcel cR ccnv cps wcel cR dupos1 cR wrel cR ccnv ccnv cps
    wcel cR cps wcel cR ccnv cps wcel cR wrel cR ccnv ccnv cR wceq cR ccnv ccnv
    cps wcel cR cps wcel wi cR dfrel2 cR ccnv ccnv cR wceq cR ccnv ccnv cps
    wcel cR cps wcel cR ccnv ccnv cR cps eleq1 biimpd sylbi cR ccnv dupos1 syl5
    impbid2 $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)

  ${ $d x y z $.
    $( The "less than or equal to" relationship on the extended reals
       is a poset. $)
    lteqtpos  $p |- <_ e. Poset $=
      cle cvv wcel cle cps wcel cle cxr cxr cxp clt ccnv cdif cvv df-le cxr cxr
      cxp cvv wcel cxr cxr cxp clt ccnv cdif cvv wcel cxr cxr xrex xrex xpex
      cxr cxr cxp clt ccnv cvv difexg ax-mp eqeltri cle cvv wcel cle cps wcel
      cle wrel cle cle ccom cle wss cle cle ccnv cin cid cle cuni cuni cres
      wceq w3a cle wrel cle cle ccom cle wss cle cle ccnv cin cid cle cuni cuni
      cres wceq leqrl cle cle ccom cle wss vx cv vy cv cle wbr vy cv vz cv cle
      wbr wa vx cv vz cv cle wbr wi vz wal vy wal vx wal vx cv vy cv cle wbr vy
      cv vz cv cle wbr wa vx cv vz cv cle wbr wi vz wal vx vy vx cv vy cv cle
      wbr vy cv vz cv cle wbr wa vx cv vz cv cle wbr wi vz vz cv cvv wcel vx cv
      vy cv cle wbr vy cv vz cv cle wbr wa vx cv vz cv cle wbr wi vz visset vx
      cv vy cv vz cv cvv xrletr2 ax-mp ax-gen gen2 vx vy vz cle cotr mpbir cle
      cle ccnv cin cid cle cuni cuni cres wceq vx cv vy cv cle wbr vy cv vx cv
      cle wbr wa vx vy weq wb vy wal vx cle cuni cuni vx vy cle asymref vx cv
      cle cuni cuni wcel vx cv cxr wcel vx cv vy cv cle wbr vy cv vx cv cle wbr
      wa vx vy weq wb vy wal cle cuni cuni cxr vx cv fldleqt eleq2i vx cv cxr
      wcel vx cv vy cv cle wbr vy cv vx cv cle wbr wa vx vy weq wb vy vx cv cxr
      wcel vx cv vy cv cle wbr vy cv vx cv cle wbr wa vx vy weq vx cv vy cv cle
      wbr vy cv vx cv cle wbr wa vx cv cxr wcel vx vy weq vy cv vx cv cle wbr
      vx cv vy cv cle wbr vx cv cxr wcel vx vy weq wi vy cv vx cv cle wbr vx cv
      vy cv cle wbr vx cv cxr wcel vx vy weq wi wi vx cv cxr wcel vy cv vx cv
      cle wbr vy cv vx cv cle wbr vx cv vy cv cle wbr vx vy weq vx cv cxr wcel
      vy cv vx cv cle wbr vy cv cxr wcel vx cv cxr wcel wa vy cv vx cv cle wbr
      vx cv vy cv cle wbr vx vy weq wi wi vy cv vx cv cxr mlteqer vx cv cxr
      wcel vy cv cxr wcel vy cv vx cv cle wbr vx cv vy cv cle wbr vx vy weq wi
      wi vx cv cxr wcel vy cv cxr wcel wa vx cv vy cv cle wbr vy cv vx cv cle
      wbr vx vy weq vx cv cxr wcel vy cv cxr wcel wa vx cv vy cv cle wbr vy cv
      vx cv cle wbr vx vy weq vx cv cxr wcel vy cv cxr wcel wa vx vy weq vx cv
      vy cv cle wbr vy cv vx cv cle wbr wa vx cv vy cv letri31 biimprd exp3a
      com23 ancoms syl6 com4l pm2.43i impcom com12 vx cv cxr wcel vx vy weq vx
      cv vy cv cle wbr vy cv vx cv cle wbr wa wi vx vy weq vx cv cxr wcel vx cv
      cxr wcel vx cv vy cv cle wbr vy cv vx cv cle wbr wa vx cv cxr wcel vx vy
      weq vx cv cxr wcel vx cv vy cv cle wbr vy cv vx cv cle wbr wa wi vx vy
      weq vx cv cxr wcel vy cv cxr wcel vx vy weq vx cv cxr wcel vx cv vy cv
      cle wbr vy cv vx cv cle wbr wa wi wi vx cv vy cv cxr eleq1 vx cv cxr wcel
      vy cv cxr wcel vx vy weq vx cv vy cv cle wbr vy cv vx cv cle wbr wa vx cv
      cxr wcel vy cv cxr wcel vx vy weq vx cv vy cv cle wbr vy cv vx cv cle wbr
      wa wi vx cv cxr wcel vy cv cxr wcel wa vx vy weq vx cv vy cv cle wbr vy
      cv vx cv cle wbr wa vx cv vy cv letri31 biimpd ex com3l syl6bi pm2.43a
      com13 pm2.43i impbid 19.21aiv sylbi mprgbir 3pm3.2i cvv cle isps mpbiri
      ax-mp $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  $( A restriction of the identity is a poset. $)
  dispos $p |- ( A e. B -> ( _I |` A ) e. Poset ) $=
    cA cB wcel cid cA cres cps wcel cid cA cres wrel cid cA cres cid cA cres
    ccom cid cA cres wss cid cA cres cid cA cres ccnv cin cid cid cA cres cuni
    cuni cres wceq w3a cid cA cres wrel cid cA cres cid cA cres ccom cid cA
    cres wss cid cA cres cid cA cres ccnv cin cid cid cA cres cuni cuni cres
    wceq cid cA relres cid cA cres cid cA cres ccom cid cA cres cA cA cid cA
    cres wf cid cA cres cid cA cres ccom cid cA cres wceq cA cA cid cA cres
    wf1o cA cA cid cA cres wf cA f1oi cA cA cid cA cres f1of ax-mp cA cA cid cA
    cres fcoi1 ax-mp eqimssi cid cA cres cid cA cres ccnv cin cid cA cres cid
    cA cres cin cid cA cres cid cid cA cres cuni cuni cres cid cA cres ccnv cid
    cA cres cid cA cres cA cnvresid ineq2i cid cA cres inidm cA cid cA cres
    cuni cuni wceq cid cA cres cid cid cA cres cuni cuni cres wceq cid cA cres
    cuni cuni cid cA cres cdm cid cA cres crn cun cA cA cun cA cid cA cres wrel
    cid cA cres cuni cuni cid cA cres cdm cid cA cres crn cun wceq cid cA
    relres cid cA cres relfld ax-mp cid cA cres cdm cA cid cA cres crn cA cA
    dmresi cA rnresi uneq12i cA unidm 3eqtrri cA cid cA cres cuni cuni cid
    reseq2 ax-mp 3eqtri 3pm3.2i cA cB wcel cid cA cres cvv wcel cid cA cres cps
    wcel cid cA cres wrel cid cA cres cid cA cres ccom cid cA cres wss cid cA
    cres cid cA cres ccnv cin cid cid cA cres cuni cuni cres wceq w3a wb cA cB
    resiexg cvv cid cA cres isps syl mpbiri $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $( An idiom to "dereflexivate" a relation. $)
  deref $p |- ( A e. B -> -. A ( C \ _I ) A ) $=
    cA cB wcel cA cA cop cC cid cdif wcel wn cA cA cC cid cdif wbr wn cA cB
    wcel cA cA cop cC wcel cA cA cop cid wcel wn wa wn cA cA cop cC cid cdif
    wcel wn cA cB wcel cA cA cop cid wcel wn cA cA cop cC wcel cA cB wcel cA cA
    cop cid wcel cA cA cop cid wcel wn wn cA cB wcel cA cA cid wbr cA cA cop
    cid wcel cA cB ididg cA cA cid df-br sylib cA cA cop cid wcel notnot sylib
    intnand cA cA cop cC cid cdif wcel cA cA cop cC wcel cA cA cop cid wcel wn
    wa cA cA cop cC cid eldif notbii sylibr cA cA cC cid cdif wbr cA cA cop cC
    cid cdif wcel cA cA cC cid cdif df-br notbii sylibr $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  ${
    $d A x y z $. $d B x y z $. $d C x y z $.
    $( If a class ` A ` is included in a class ` B ` , the class
       ` ( A o. C ) ` is included in ` ( B o. C ) ` . $)
    inclrel $p |- ( A C_ B -> ( A o. C ) C_ ( B o. C ) )  $=
      cA cB wss vx cv vy cv cC wbr vy cv vz cv cA wbr wa vy wex vx vz copab vx
      cv vy cv cC wbr vy cv vz cv cB wbr wa vy wex vx vz copab cA cC ccom cB cC
      ccom cA cB wss vx cv vy cv cC wbr vy cv vz cv cA wbr wa vy wex vx cv vy
      cv cC wbr vy cv vz cv cB wbr wa vy wex wi vz wal vx wal vx cv vy cv cC
      wbr vy cv vz cv cA wbr wa vy wex vx vz copab vx cv vy cv cC wbr vy cv vz
      cv cB wbr wa vy wex vx vz copab wss cA cB wss vx cv vy cv cC wbr vy cv vz
      cv cA wbr wa vy wex vx cv vy cv cC wbr vy cv vz cv cB wbr wa vy wex wi vx
      vz cA cB wss vx cv vy cv cC wbr vy cv vz cv cA wbr wa vx cv vy cv cC wbr
      vy cv vz cv cB wbr wa vy cA cB wss vy cv vz cv cA wbr vy cv vz cv cB wbr
      vx cv vy cv cC wbr cA cB wss vy cv vz cv cop cA wcel vy cv vz cv cop cB
      wcel vy cv vz cv cA wbr vy cv vz cv cB wbr cA cB vy cv vz cv cop ssel vy
      cv vz cv cA df-br vy cv vz cv cB df-br 3imtr4g anim2d 19.22dv 19.21aivv
      vx cv vy cv cC wbr vy cv vz cv cA wbr wa vy wex vx cv vy cv cC wbr vy cv
      vz cv cB wbr wa vy wex vx vz ssopab2 sylibr vx vz vy cA cC df-co vx vz vy
      cB cC df-co 3sstr4g $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d r x $.
    $( Alternate definition of a poset. Bourbaki E.III.2 prop. 1. $)
    dfps2 $p |- Poset = { r | ( Rel r /\ ( r o. r ) = r /\
              ( r i^i `' r ) = ( _I |` U. U. r ) ) } $=
      cps vr cv wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccnv cin cid vr cv
      cuni cuni cres wceq w3a vr cab vr cv wrel vr cv vr cv ccom vr cv wceq vr
      cv vr cv ccnv cin cid vr cv cuni cuni cres wceq w3a vr cab vr df-ps vr cv
      wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccnv cin cid vr cv cuni cuni
      cres wceq w3a vr cv wrel vr cv vr cv ccom vr cv wceq vr cv vr cv ccnv cin
      cid vr cv cuni cuni cres wceq w3a vr vr cv wrel vr cv vr cv ccom vr cv
      wss vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq w3a vr cv wrel vr
      cv vr cv ccom vr cv wceq vr cv vr cv ccnv cin cid vr cv cuni cuni cres
      wceq w3a vr cv wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccnv cin cid
      vr cv cuni cuni cres wceq w3a vr cv wrel vr cv vr cv ccom vr cv wceq vr
      cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv wrel vr cv vr cv
      ccom vr cv wss vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq 3simp1
      vr cv wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccnv cin cid vr cv cuni
      cuni cres wceq vr cv vr cv ccom vr cv wceq vr cv vr cv ccnv cin cid vr cv
      cuni cuni cres wceq vr cv vr cv ccom vr cv wss vr cv wrel vr cv vr cv
      ccom vr cv wceq cid vr cv cuni cuni cres vr cv vr cv ccnv cin wss vr cv
      vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv vr cv ccom vr cv wss
      vr cv wrel vr cv vr cv ccom vr cv wceq wi wi cid vr cv cuni cuni cres vr
      cv vr cv ccnv cin eqimss2 cid vr cv cuni cuni cres vr cv vr cv ccnv cin
      wss cid vr cv cuni cuni cres vr cv wss cid vr cv cuni cuni cres vr cv
      ccnv wss wa vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv vr
      cv ccom vr cv wss vr cv wrel vr cv vr cv ccom vr cv wceq wi wi wi cid vr
      cv cuni cuni cres vr cv vr cv ccnv ssin cid vr cv cuni cuni cres vr cv
      wss vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv vr cv ccom
      vr cv wss vr cv wrel vr cv vr cv ccom vr cv wceq wi wi wi cid vr cv cuni
      cuni cres vr cv ccnv wss cid vr cv cuni cuni cres vr cv wss vx cv vx cv
      vr cv wbr vx vr cv cuni cuni wral vr cv vr cv ccnv cin cid vr cv cuni
      cuni cres wceq vr cv vr cv ccom vr cv wss vr cv wrel vr cv vr cv ccom vr
      cv wceq wi wi wi vx vr cv ref3w vr cv wrel vx cv vx cv vr cv wbr vx vr cv
      cuni cuni wral vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv
      vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq vx cv vx cv vr cv wbr vx
      vr cv cuni cuni wral vr cv wrel vr cv vr cv ccnv cin cid vr cv cuni cuni
      cres wceq vr cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi vr
      cv wrel vx cv vx cv vr cv wbr vx vr cv cuni cuni wral vr cv wrel vr cv vr
      cv ccnv cin cid vr cv cuni cuni cres wceq vr cv vr cv ccom vr cv wss vr
      cv vr cv ccom vr cv wceq wi wi wi vr cv cdm vr cv crn wceq vr cv cdm vr
      cv cuni cuni wceq vr cv wrel vr cv vr cv ccnv cin cid vr cv cuni cuni
      cres wceq vr cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi wi
      vr cv wrel vx cv vx cv vr cv wbr vx vr cv cuni cuni wral wa vr cv cdm vr
      cv cuni cuni wceq vr cv wrel vr cv vr cv ccnv cin cid vr cv cuni cuni
      cres wceq vr cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi wi
      wi vr cv crn vr cv cdm vr cv crn vr cv cdm wceq vr cv cdm vr cv cuni cuni
      wceq vr cv wrel vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv
      vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi wi vr cv crn vr cv
      cdm wceq vr cv cdm vr cv cuni cuni wceq wa vr cv crn vr cv cuni cuni wceq
      vr cv wrel vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv vr cv
      ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi wi vr cv crn vr cv cdm
      vr cv cuni cuni eqtr vr cv crn vr cv cuni cuni wceq vr cv vr cv ccnv cin
      cid vr cv cuni cuni cres wceq vr cv wrel vr cv vr cv ccom vr cv wss vr cv
      vr cv ccom vr cv wceq wi vr cv crn vr cv cuni cuni wceq vr cv vr cv ccnv
      cin cid vr cv cuni cuni cres wceq vr cv vr cv ccnv cin cid vr cv crn cres
      wceq vr cv wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi
      wi vr cv crn vr cv cuni cuni wceq cid vr cv cuni cuni cres cid vr cv crn
      cres vr cv vr cv ccnv cin cid vr cv cuni cuni cres cid vr cv crn cres
      wceq vr cv cuni cuni vr cv crn vr cv cuni cuni vr cv crn cid reseq2
      eqcoms eqeq2d vr cv vr cv ccnv cin vr cv wss cid vr cv crn cres vr cv
      ccom cid vr cv ccom wceq vr cv vr cv ccnv cin cid vr cv crn cres wceq vr
      cv wrel vr cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi wi
      vr cv vr cv ccnv inss1 vr cv crn vr cv crn wss cid vr cv crn cres vr cv
      ccom cid vr cv ccom wceq vr cv crn ssid cid vr cv vr cv crn cores ax-mp
      vr cv vr cv ccnv cin cid vr cv crn cres wceq vr cv vr cv ccnv cin vr cv
      wss cid vr cv crn cres vr cv ccom cid vr cv ccom wceq vr cv wrel vr cv vr
      cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi vr cv vr cv ccnv cin
      cid vr cv crn cres wceq vr cv vr cv ccnv cin vr cv wss cid vr cv crn cres
      vr cv wss cid vr cv crn cres vr cv ccom cid vr cv ccom wceq vr cv wrel vr
      cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi wi vr cv vr cv
      ccnv cin cid vr cv crn cres vr cv sseq1 cid vr cv crn cres vr cv wss cid
      vr cv crn cres vr cv ccom vr cv vr cv ccom wss cid vr cv crn cres vr cv
      ccom cid vr cv ccom wceq vr cv wrel vr cv vr cv ccom vr cv wss vr cv vr
      cv ccom vr cv wceq wi wi wi cid vr cv crn cres vr cv vr cv inclrel vr cv
      wrel cid vr cv crn cres vr cv ccom vr cv vr cv ccom wss cid vr cv crn
      cres vr cv ccom cid vr cv ccom wceq vr cv vr cv ccom vr cv wss vr cv vr
      cv ccom vr cv wceq wi vr cv wrel cid vr cv ccom vr cv wceq cid vr cv crn
      cres vr cv ccom vr cv vr cv ccom wss cid vr cv crn cres vr cv ccom cid vr
      cv ccom wceq vr cv vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi wi
      wi vr cv coi2 cid vr cv crn cres vr cv ccom cid vr cv ccom wceq cid vr cv
      ccom vr cv wceq cid vr cv crn cres vr cv ccom vr cv vr cv ccom wss vr cv
      vr cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi cid vr cv crn cres vr
      cv ccom cid vr cv ccom wceq cid vr cv ccom vr cv wceq cid vr cv crn cres
      vr cv ccom vr cv vr cv ccom wss vr cv vr cv ccom vr cv wss vr cv vr cv
      ccom vr cv wceq wi wi cid vr cv crn cres vr cv ccom cid vr cv ccom wceq
      cid vr cv ccom vr cv wceq wa cid vr cv crn cres vr cv ccom vr cv wceq cid
      vr cv crn cres vr cv ccom vr cv vr cv ccom wss vr cv vr cv ccom vr cv wss
      vr cv vr cv ccom vr cv wceq wi wi cid vr cv crn cres vr cv ccom cid vr cv
      ccom vr cv eqtr cid vr cv crn cres vr cv ccom vr cv wceq cid vr cv crn
      cres vr cv ccom vr cv vr cv ccom wss vr cv vr cv vr cv ccom wss vr cv vr
      cv ccom vr cv wss vr cv vr cv ccom vr cv wceq wi cid vr cv crn cres vr cv
      ccom vr cv vr cv vr cv ccom sseq1 vr cv vr cv ccom vr cv wss vr cv vr cv
      vr cv ccom wss vr cv vr cv ccom vr cv wceq vr cv vr cv ccom vr cv wceq vr
      cv vr cv ccom vr cv wss vr cv vr cv vr cv ccom wss wa vr cv vr cv ccom vr
      cv eqss biimpri expcom syl6bi syl ex com3l syl com3l syl syl6bi com3l mp2
      syl6bi com23 syl ex eqcoms vx vr cv domrngref vx vr cv domfldref sylc ex
      pm2.43a com4l sylbir adantr sylbir mpcom com13 3imp vr cv wrel vr cv vr
      cv ccom vr cv wss vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq
      3simp3 3jca vr cv wrel vr cv vr cv ccom vr cv wceq vr cv vr cv ccnv cin
      cid vr cv cuni cuni cres wceq w3a vr cv wrel vr cv vr cv ccom vr cv wss
      vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv wrel vr cv vr cv
      ccom vr cv wceq vr cv vr cv ccnv cin cid vr cv cuni cuni cres wceq 3simp1
      vr cv vr cv ccom vr cv wceq vr cv wrel vr cv vr cv ccom vr cv wss vr cv
      vr cv ccnv cin cid vr cv cuni cuni cres wceq vr cv vr cv ccom vr cv
      eqimss 3ad2ant2 vr cv wrel vr cv vr cv ccom vr cv wceq vr cv vr cv ccnv
      cin cid vr cv cuni cuni cres wceq 3simp3 3jca impbii abbii eqtri $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${ $d A x y $. $d R x y $. $d R x z $.
    $( Any subset of a partially ordered set is partially ordered. $)
    pospos $p |- ( R e. Poset -> ( R i^i ( A X. A ) ) e. Poset )  $=
      cR cps wcel cR cA cA cxp cin cps wcel cR cA cA cxp cin wrel cR cA cA cxp
      cin cR cA cA cxp cin ccom cR cA cA cxp cin wss cR cA cA cxp cin cR cA cA
      cxp cin ccnv cin cid cR cA cA cxp cin cuni cuni cres wceq w3a cR cps wcel
      cR cA cA cxp cin wrel cR cA cA cxp cin cR cA cA cxp cin ccom cR cA cA cxp
      cin wss cR cA cA cxp cin cR cA cA cxp cin ccnv cin cid cR cA cA cxp cin
      cuni cuni cres wceq w3a cR cps wcel cR cps wcel cR wrel cR cR ccom cR wss
      cR cR ccnv cin cid cR cuni cuni cres wceq w3a cR cA cA cxp cin wrel cR cA
      cA cxp cin cR cA cA cxp cin ccom cR cA cA cxp cin wss cR cA cA cxp cin cR
      cA cA cxp cin ccnv cin cid cR cA cA cxp cin cuni cuni cres wceq w3a cps
      cR isps cR wrel cR cA cA cxp cin wrel cR cR ccom cR wss cR cA cA cxp cin
      cR cA cA cxp cin ccom cR cA cA cxp cin wss cR cR ccnv cin cid cR cuni
      cuni cres wceq cR cA cA cxp cin cR cA cA cxp cin ccnv cin cid cR cA cA
      cxp cin cuni cuni cres wceq cR cA cA cxp relin1 cA cR tricptr cR cR ccnv
      cin cid cR cuni cuni cres wceq vx cv vx cv cR cA cA cxp cin wbr vx cR cA
      cA cxp cin cuni cuni wral vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR
      cA cA cxp cin wbr wa vx vy weq wi vy wal vx wal wa cR cA cA cxp cin cR cA
      cA cxp cin ccnv cin cid cR cA cA cxp cin cuni cuni cres wceq cR cR ccnv
      cin cid cR cuni cuni cres wceq vx cv vx cv cR cA cA cxp cin wbr vx cR cA
      cA cxp cin cuni cuni wral vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR
      cA cA cxp cin wbr wa vx vy weq wi vy wal vx wal cR cR ccnv cin cid cR
      cuni cuni cres wceq vx cv vx cv cR cA cA cxp cin wbr vx cR cA cA cxp cin
      cuni cuni cR cR ccnv cin cid cR cuni cuni cres wceq vx cv vx cv cR wbr vx
      cR cuni cuni wral vx cv vz cv cR wbr vz cv vx cv cR wbr wa vx vz weq wi
      vz wal vx wal wa vx cv cR cA cA cxp cin cuni cuni wcel vx cv vx cv cR cA
      cA cxp cin wbr wi vx vz cR asymref2 vx cv vx cv cR wbr vx cR cuni cuni
      wral vx cv cR cA cA cxp cin cuni cuni wcel vx cv vx cv cR cA cA cxp cin
      wbr wi vx cv vz cv cR wbr vz cv vx cv cR wbr wa vx vz weq wi vz wal vx
      wal vx cv vx cv cR wbr vx cR cuni cuni wral vx cv cR cuni cuni wcel vx cv
      vx cv cR wbr wi vx wal vx cv cR cA cA cxp cin cuni cuni wcel vx cv vx cv
      cR cA cA cxp cin wbr wi vx cv vx cv cR wbr vx cR cuni cuni df-ral vx cv
      cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv cR cA cA cxp cin cuni cuni
      wcel vx cv vx cv cR cA cA cxp cin wbr wi vx vx cv cR cA cA cxp cin cuni
      cuni wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx cv cR cA
      cA cxp cin wbr cR cA cA cxp cin cuni cuni cR cuni cuni cA cA cxp cuni
      cuni cin wss vx cv cR cA cA cxp cin cuni cuni wcel vx cv cR cuni cuni
      wcel vx cv vx cv cR wbr wi vx cv vx cv cR cA cA cxp cin wbr wi wi cR cA
      cA cxp uuniin cR cA cA cxp cin cuni cuni cR cuni cuni cA cA cxp cuni cuni
      cin wss vx cv cR cA cA cxp cin cuni cuni wcel vx cv cR cuni cuni cA cA
      cxp cuni cuni cin wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx
      cv vx cv cR cA cA cxp cin wbr wi cR cA cA cxp cin cuni cuni cR cuni cuni
      cA cA cxp cuni cuni cin vx cv ssel vx cv cR cuni cuni cA cA cxp cuni cuni
      cin wcel vx cv cR cuni cuni wcel vx cv cA cA cxp cuni cuni wcel wa vx cv
      cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx cv cR cA cA cxp cin wbr
      wi vx cv cR cuni cuni cA cA cxp cuni cuni elin vx cv cA cA cxp cuni cuni
      wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr
      wi vx cv vx cv cR cA cA cxp cin wbr wi vx cv cA wcel vx cv cA wcel vx cv
      cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx
      cv cR cA cA cxp cin wbr wi wi vx cv cA cA cxp cuni cuni wcel vx cv cA
      wcel vx cv cA wcel wa vx cv vx cv cA cA cxp wbr vx cv cR cuni cuni wcel
      vx cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx cv cR cA cA cxp
      cin wbr wi wi vx cv vx cv cA cA vx visset brxp vx cv cR cuni cuni wcel vx
      cv cR cuni cuni wcel vx cv vx cv cR wbr wi vx cv vx cv cA cA cxp wbr vx
      cv vx cv cR cA cA cxp cin wbr vx cv cR cuni cuni wcel vx cv cR cuni cuni
      wcel vx cv vx cv cR wbr wi vx cv vx cv cR wbr vx cv vx cv cA cA cxp wbr
      vx cv vx cv cR cA cA cxp cin wbr wi vx cv cR cuni cuni wcel vx cv vx cv
      cR wbr pm2.27 vx cv vx cv cR wbr vx cv vx cv cA cA cxp wbr vx cv vx cv cR
      cA cA cxp cin wbr vx cv vx cv cR cA cA cxp cin wbr vx cv vx cv cR wbr vx
      cv vx cv cA cA cxp wbr wa vx cv vx cv cR cA cA cxp int2rel biimpri ex
      syl6 com3r sylbir cA cA cxp cuni cuni cA vx cv cA fldsqcp2 eleq2i cA cA
      cxp cuni cuni cA vx cv cA fldsqcp2 eleq2i sylancb impcom sylbi syl6 ax-mp
      com12 a4s sylbi adantr sylbi r19.21aiv cR cR ccnv cin cid cR cuni cuni
      cres wceq vx cv vx cv cR wbr vx cR cuni cuni wral vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa vx vy weq wi vy wal vx wal wa vx cv vy cv cR cA cA cxp
      cin wbr vy cv vx cv cR cA cA cxp cin wbr wa vx vy weq wi vy wal vx wal vx
      vy cR asymref2 vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq wi vy
      wal vx wal vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin
      wbr wa vx vy weq wi vy wal vx wal vx cv vx cv cR wbr vx cR cuni cuni wral
      vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq wi vx cv vy cv cR cA
      cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wa vx vy weq wi vx vy vx
      cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wa vx cv
      vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq wi vx vy weq vx cv vy cv cR
      cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr vx cv vy cv cR wbr vy
      cv vx cv cR wbr wa vx vy weq wi vx vy weq wi vx cv vy cv cR cA cA cxp cin
      wbr vx cv vy cv cR wbr vx cv vy cv cA cA cxp wbr wa vy cv vx cv cR cA cA
      cxp cin wbr vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq wi vx vy
      weq wi wi vx cv vy cv cR cA cA cxp int2rel vx cv vy cv cR wbr vy cv vx cv
      cR cA cA cxp cin wbr vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq
      wi vx vy weq wi wi vx cv vy cv cA cA cxp wbr vy cv vx cv cR cA cA cxp cin
      wbr vx cv vy cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq
      wi vx vy weq wi vy cv vx cv cR cA cA cxp cin wbr vy cv vx cv cR wbr vy cv
      vx cv cA cA cxp wbr wa vx cv vy cv cR wbr vx cv vy cv cR wbr vy cv vx cv
      cR wbr wa vx vy weq wi vx vy weq wi wi vy cv vx cv cR cA cA cxp int2rel
      vy cv vx cv cR wbr vx cv vy cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa vx vy weq wi vx vy weq wi wi vy cv vx cv cA cA cxp wbr vx cv vy cv
      cR wbr vy cv vx cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy
      weq wi vx vy weq wi vx cv vy cv cR wbr vy cv vx cv cR wbr wa vx vy weq
      pm2.27 expcom adantr sylbi com12 adantr sylbi imp com12 19.20i2 adantl
      sylbi jca vx vy cR cA cA cxp cin asymref2 sylibr 3anim123i syl6bi pm2.43i
      cR cps wcel cR cA cA cxp cin cvv wcel cR cA cA cxp cin cps wcel cR cA cA
      cxp cin wrel cR cA cA cxp cin cR cA cA cxp cin ccom cR cA cA cxp cin wss
      cR cA cA cxp cin cR cA cA cxp cin ccnv cin cid cR cA cA cxp cin cuni cuni
      cres wceq w3a wb cR cA cA cxp cps inex1g cvv cR cA cA cxp cin isps syl
      mpbird $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${ $d A x y $. $d R x y $.
  $( Any subset of a totally ordered set is totally ordered. $)
  tostos $p |- ( R e. Toset -> ( R i^i ( A X. A ) ) e. Toset )  $=
    cR ccha wcel cR cA cA cxp cin ccha wcel cR ccha wcel cR ccha wcel cR cps
    wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral vx cR
    cuni cuni wral wa cR cA cA cxp cin ccha wcel cR ccha wcel cR ccha wcel cR
    cps wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral vx
    cR cuni cuni wral wa vx vy ccha cR cR cuni cuni cR cuni cuni eqid istoset
    biimpd cR cps wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral vx cR cuni cuni wral wa cR ccha wcel cR cA cA cxp cin ccha wcel cR cps
    wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral vx cR
    cuni cuni wral wa cR ccha wcel wa cR cA cA cxp cin ccha wcel cR cA cA cxp
    cin cps wcel vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin
    wbr wo vy cR cA cA cxp cin cuni cuni wral vx cR cA cA cxp cin cuni cuni
    wral wa cR cps wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni
    cuni wral vx cR cuni cuni wral wa cR cA cA cxp cin cps wcel vx cv vy cv cR
    cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wo vy cR cA cA cxp cin
    cuni cuni wral vx cR cA cA cxp cin cuni cuni wral wa cR ccha wcel cR cps
    wcel cR cA cA cxp cin cps wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy
    cR cuni cuni wral vx cR cuni cuni wral vx cv vy cv cR cA cA cxp cin wbr vy
    cv vx cv cR cA cA cxp cin wbr wo vy cR cA cA cxp cin cuni cuni wral vx cR
    cA cA cxp cin cuni cuni wral cA cR pospos vx cv vy cv cR wbr vy cv vx cv cR
    wbr wo vy cR cuni cuni wral vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR
    cA cA cxp cin wbr wo vy cR cA cA cxp cin cuni cuni wral vx cR cuni cuni cR
    cA cA cxp cin cuni cuni vx cv cR cA cA cxp cin cuni cuni wcel vx cv cR cuni
    cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi
    vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wo vy cR
    cA cA cxp cin cuni cuni wral cR cA cA cxp cin cuni cuni cR cuni cuni cA cA
    cxp cuni cuni cin wss vx cv cR cA cA cxp cin cuni cuni wcel vx cv cR cuni
    cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi
    vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wo vy cR
    cA cA cxp cin cuni cuni wral wi cR cA cA cxp uuniin cR cA cA cxp cin cuni
    cuni cR cuni cuni cA cA cxp cuni cuni cin wss vx cv cR cA cA cxp cin cuni
    cuni wcel wa vx cv cR cuni cuni cA cA cxp cuni cuni cin wcel vx cv cR cuni
    cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi
    vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wo vy cR
    cA cA cxp cin cuni cuni wral wi cR cA cA cxp cin cuni cuni cR cuni cuni cA
    cA cxp cuni cuni cin vx cv ssel2 vx cv cR cuni cuni cA cA cxp cuni cuni cin
    wcel vx cv cR cuni cuni wcel vx cv cA cA cxp cuni cuni wcel wa vx cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral wi vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr
    wo vy cR cA cA cxp cin cuni cuni wral wi vx cv cR cuni cuni cA cA cxp cuni
    cuni elin vx cv cR cuni cuni wcel vx cv cA cA cxp cuni cuni wcel vx cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral wi vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr
    wo vy cR cA cA cxp cin cuni cuni wral wi vx cv cR cuni cuni wcel vx cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral wi vx cv cA cA cxp cuni cuni wcel vx cv vy cv cR cA cA cxp cin wbr vy
    cv vx cv cR cA cA cxp cin wbr wo vy cR cA cA cxp cin cuni cuni wral vx cv
    cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR
    wbr wo vy cR cuni cuni wral wi vx cv cA cA cxp cuni cuni wcel vx cv vy cv
    cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wo vy cR cA cA cxp
    cin cuni cuni wral vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vy
    cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv cA cA cxp
    cuni cuni wcel w3a vx cv vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA
    cxp cin wbr wo vy cR cA cA cxp cin cuni cuni vx cv cR cuni cuni wcel vx cv
    cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral wi vx cv cA cA cxp cuni cuni wcel vy vx cv cR cuni cuni wcel vy ax-17
    vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni
    cuni wral vy vx cv cR cuni cuni wcel vy ax-17 vx cv vy cv cR wbr vy cv vx
    cv cR wbr wo vy cR cuni cuni hbra1 hbim vx cv cA cA cxp cuni cuni wcel vy
    ax-17 hb3an vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vy cv cR
    wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv cA cA cxp cuni cuni
    wcel w3a vy cv cR cA cA cxp cin cuni cuni wcel vx cv vy cv cR cA cA cxp cin
    wbr vy cv vx cv cR cA cA cxp cin wbr wo vx cv cR cuni cuni wcel vx cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral wi vx cv cA cA cxp cuni cuni wcel w3a vy cv cR cA cA cxp cin cuni cuni
    wcel wa vx cv vy cv cR wbr vx cv vy cv cA cA cxp wbr wa vy cv vx cv cR wbr
    vy cv vx cv cA cA cxp wbr wa wo vx cv vy cv cR cA cA cxp cin wbr vy cv vx
    cv cR cA cA cxp cin wbr wo vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel
    vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv cA
    cA cxp cuni cuni wcel w3a vy cv cR cA cA cxp cin cuni cuni wcel wa vx cv vy
    cv cR wbr vx cv vy cv cA cA cxp wbr wa vy cv vx cv cR wbr vx cv vy cv cA cA
    cxp wbr wa wo vx cv vy cv cR wbr vx cv vy cv cA cA cxp wbr wa vy cv vx cv
    cR wbr vy cv vx cv cA cA cxp wbr wa wo vx cv cR cuni cuni wcel vx cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral wi vx cv cA cA cxp cuni cuni wcel w3a vy cv cR cA cA cxp cin cuni cuni
    wcel wa vx cv vy cv cR wbr vy cv vx cv cR wbr wo vx cv vy cv cA cA cxp wbr
    wa vx cv vy cv cR wbr vx cv vy cv cA cA cxp wbr wa vy cv vx cv cR wbr vx cv
    vy cv cA cA cxp wbr wa wo vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel
    vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv cA
    cA cxp cuni cuni wcel w3a vy cv cR cA cA cxp cin cuni cuni wcel wa vx cv vy
    cv cR wbr vy cv vx cv cR wbr wo vx cv vy cv cA cA cxp wbr vx cv cR cuni
    cuni wcel vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo
    vy cR cuni cuni wral wi vx cv cA cA cxp cuni cuni wcel w3a vy cv cR cA cA
    cxp cin cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vx cv cR
    cuni cuni wcel vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR
    wbr wo vy cR cuni cuni wral wi vx cv cA cA cxp cuni cuni wcel w3a vy cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cv cR cA cA cxp
    cin cuni cuni wcel vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vy
    cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv cA cA cxp
    cuni cuni wcel vy cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR
    wbr wo wi vx cv cR cuni cuni wcel vx cv cR cuni cuni wcel vx cv vy cv cR
    wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv vy cv cR wbr vy cv
    vx cv cR wbr wo vy cR cuni cuni wral vx cv cA cA cxp cuni cuni wcel vy cv
    cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo wi wi vx cv cR
    cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni
    wral pm2.27 vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral
    vy cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo wi vx cv
    cA cA cxp cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR
    cuni cuni ra4 a1d syl6 3imp vy cv cR cA cA cxp cin cuni cuni wcel vy cv cR
    cuni cuni cA cA cxp cuni cuni cin wcel vy cv cR cuni cuni wcel cR cA cA cxp
    cin cuni cuni cR cuni cuni cA cA cxp cuni cuni cin vy cv cR cA cA cxp
    uuniin sseli vy cv cR cuni cuni cA cA cxp cuni cuni cin wcel vy cv cR cuni
    cuni wcel vy cv cA cA cxp cuni cuni wcel vy cv cR cuni cuni cA cA cxp cuni
    cuni elin pm3.26bi syl syl5 imp vx cv cR cuni cuni wcel vx cv cR cuni cuni
    wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv
    cA cA cxp cuni cuni wcel w3a vy cv cR cA cA cxp cin cuni cuni wcel wa vx cv
    cA wcel vy cv cA wcel wa vx cv vy cv cA cA cxp wbr vx cv cR cuni cuni wcel
    vx cv cR cuni cuni wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR cuni
    cuni wral wi vx cv cA cA cxp cuni cuni wcel w3a vx cv cA wcel vy cv cR cA
    cA cxp cin cuni cuni wcel vy cv cA wcel vx cv cA cA cxp cuni cuni wcel vx
    cv cR cuni cuni wcel vx cv cA wcel vx cv cR cuni cuni wcel vx cv vy cv cR
    wbr vy cv vx cv cR wbr wo vy cR cuni cuni wral wi vx cv cA cA cxp cuni cuni
    wcel vx cv cA wcel cA cA cxp cuni cuni cA vx cv cA fldsqcp2 eleq2i biimpi
    3ad2ant3 vy cv cR cA cA cxp cin cuni cuni wcel vy cv cR cuni cuni cA cA cxp
    cuni cuni cin wcel vy cv cA wcel cR cA cA cxp cin cuni cuni cR cuni cuni cA
    cA cxp cuni cuni cin vy cv cR cA cA cxp uuniin sseli vy cv cR cuni cuni cA
    cA cxp cuni cuni cin wcel vy cv cR cuni cuni wcel vy cv cA cA cxp cuni cuni
    wcel wa vy cv cA wcel vy cv cR cuni cuni cA cA cxp cuni cuni elin vy cv cA
    cA cxp cuni cuni wcel vy cv cA wcel vy cv cR cuni cuni wcel vy cv cA cA cxp
    cuni cuni wcel vy cv cA wcel cA cA cxp cuni cuni cA vy cv cA fldsqcp2
    eleq2i biimpi adantl sylbi syl anim12i vx cv vy cv cA cA vy visset brxp
    sylibr jca vx cv vy cv cR wbr vy cv vx cv cR wbr vx cv vy cv cA cA cxp wbr
    andir sylib vy cv vx cv cR wbr vx cv vy cv cA cA cxp wbr wa vy cv vx cv cR
    wbr vy cv vx cv cA cA cxp wbr wa vx cv vy cv cR wbr vx cv vy cv cA cA cxp
    wbr wa vx cv vy cv cA cA cxp wbr vy cv vx cv cA cA cxp wbr vy cv vx cv cR
    wbr vx cv vy cv cA cA cxp vx visset vy visset cA sqpeq ersymb anbi2i orbi2i
    sylib vx cv vy cv cR cA cA cxp cin wbr vx cv vy cv cR wbr vx cv vy cv cA cA
    cxp wbr wa vy cv vx cv cR cA cA cxp cin wbr vy cv vx cv cR wbr vy cv vx cv
    cA cA cxp wbr wa vx cv vy cv cR cA cA cxp int2rel vy cv vx cv cR cA cA cxp
    int2rel orbi12i sylibr ex r19.21ai 3exp com23 imp sylbi syl mpan com12
    r19.20i2 anim12i adantr cR cps wcel vx cv vy cv cR wbr vy cv vx cv cR wbr
    wo vy cR cuni cuni wral vx cR cuni cuni wral wa cR ccha wcel wa cR cA cA
    cxp cin cvv wcel cR cA cA cxp cin ccha wcel cR cA cA cxp cin cps wcel vx cv
    vy cv cR cA cA cxp cin wbr vy cv vx cv cR cA cA cxp cin wbr wo vy cR cA cA
    cxp cin cuni cuni wral vx cR cA cA cxp cin cuni cuni wral wa wb cR cps wcel
    cR cA cA cxp cin cvv wcel vx cv vy cv cR wbr vy cv vx cv cR wbr wo vy cR
    cuni cuni wral vx cR cuni cuni wral cR ccha wcel cR cA cA cxp cps inex1g
    ad2antrr vx vy cvv cR cA cA cxp cin cR cA cA cxp cin cuni cuni cR cA cA cxp
    cin cuni cuni eqid istoset syl mpbird ex syli pm2.43i $.
    $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}


  ${ $d C a u v x y $. $d J a u v x y $.
    toplat.1  $e |- C = { <. u , v >. | u C_ v } $.
    $( A topology is a lattice. This fact leads to the idea of pointless
       topology. $)
    toplat $p |- ( J e. Top -> ( C i^i ( J X. J ) ) e. Lat ) $=
      cJ ctop wcel cC cJ cJ cxp cin cps wcel cC cJ cJ cxp cin vx cv vy cv cpr
      cspw co cJ wcel cC cJ cJ cxp cin vx cv vy cv cpr cinf co cJ wcel wa vy cJ
      wral vx cJ wral wa cC cJ cJ cxp cin cla wcel cJ ctop wcel cC cJ cJ cxp
      cin cps wcel cC cJ cJ cxp cin vx cv vy cv cpr cspw co cJ wcel cC cJ cJ
      cxp cin vx cv vy cv cpr cinf co cJ wcel wa vy cJ wral vx cJ wral vu vv cJ
      ctop cC toplat.1 inposet cJ ctop wcel cC cJ cJ cxp cin vx cv vy cv cpr
      cspw co cJ wcel cC cJ cJ cxp cin vx cv vy cv cpr cinf co cJ wcel wa vx vy
      cJ cJ cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa cC cJ cJ cxp cin vx cv
      vy cv cpr cspw co cJ wcel cC cJ cJ cxp cin vx cv vy cv cpr cinf co cJ
      wcel wa cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa cC cJ cJ cxp cin
      vx cv vy cv cpr cspw co cJ wcel cC cJ cJ cxp cin vx cv vy cv cpr cinf co
      cJ wcel cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa cC cJ cJ cxp cin
      vx cv vy cv cpr cspw co vx cv vy cv cpr cuni cJ cC cJ cJ cxp cin cps wcel
      vx cv vy cv cpr cuni cvv wcel wa vx cv vx cv vy cv cpr cuni cC cJ cJ cxp
      cin wbr vy cv vx cv vy cv cpr cuni cC cJ cJ cxp cin wbr wa vx cv va cv cC
      cJ cJ cxp cin wbr vy cv va cv cC cJ cJ cxp cin wbr wa vx cv vy cv cpr
      cuni va cv cC cJ cJ cxp cin wbr wi va cJ wral cC cJ cJ cxp cin vx cv vy
      cv cpr cspw co vx cv vy cv cpr cuni wceq cJ ctop wcel vx cv cJ wcel vy cv
      cJ wcel wa wa va vx cv vy cv vx cv vy cv cpr cuni cvv cC cJ cJ cxp cin cJ
      cC cJ cJ cxp cin cdm cJ vu vv cJ cC toplat.1 domncnt eqcomi spwpr4 cJ
      ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa cC cJ cJ cxp cin cps wcel vx
      cv vy cv cpr cuni cvv wcel cJ ctop wcel cC cJ cJ cxp cin cps wcel vx cv
      cJ wcel vy cv cJ wcel wa vu vv cJ ctop cC toplat.1 inposet adantr vx cv
      vy cv cpr vx vy zfpair uniex jctir cJ ctop wcel vx cv cJ wcel vy cv cJ
      wcel wa wa vx cv vx cv vy cv cpr cuni cC cJ cJ cxp cin wbr vy cv vx cv vy
      cv cpr cuni cC cJ cJ cxp cin wbr cJ ctop wcel vx cv cJ wcel vy cv cJ wcel
      wa wa vx cv cJ wcel vx cv vy cv cpr cuni cJ wcel vx cv vx cv vy cv cpr
      cuni wss w3a vx cv vx cv vy cv cpr cuni cC cJ cJ cxp cin wbr cJ ctop wcel
      vx cv cJ wcel vy cv cJ wcel wa wa vx cv cJ wcel vx cv vy cv cpr cuni cJ
      wcel vx cv vx cv vy cv cpr cuni wss cJ ctop wcel vx cv cJ wcel vy cv cJ
      wcel simprl cJ ctop wcel vx cv vy cv cpr cJ wss vx cv vy cv cpr cuni cJ
      wcel vx cv cJ wcel vy cv cJ wcel wa vx cv vy cv cpr cJ uniopn vx cv vy cv
      cJ vx visset vy visset prss sylan2b cJ ctop wcel vx cv cJ wcel vy cv cJ
      wcel wa wa vx cv vx cv wss vx cv vx cv vy cv cpr wcel wa vx cv vx cv vy
      cv cpr cuni wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv vx
      cv vy cv cpr wcel vx cv vx cv wss vx cv vx cv vy cv cpr wcel cJ ctop wcel
      vx cv cJ wcel vy cv cJ wcel wa wa vx cv vy cv vx visset prid1 a1i vx cv
      ssid jctil vx cv vx cv vx cv vy cv cpr ssuni syl 3jca vu vv cJ cJ cC vx
      cv vy cv cpr cuni vx cv cvv cvv vx visset vx cv vy cv cpr vx vy zfpair
      uniex toplat.1 definc sylibr cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa
      wa vy cv cJ wcel vx cv vy cv cpr cuni cJ wcel vy cv vx cv vy cv cpr cuni
      wss w3a vy cv vx cv vy cv cpr cuni cC cJ cJ cxp cin wbr cJ ctop wcel vx
      cv cJ wcel vy cv cJ wcel wa wa vy cv cJ wcel vx cv vy cv cpr cuni cJ wcel
      vy cv vx cv vy cv cpr cuni wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel
      simprr cJ ctop wcel vx cv vy cv cpr cJ wss vx cv vy cv cpr cuni cJ wcel
      vx cv cJ wcel vy cv cJ wcel wa vx cv vy cv cpr cJ uniopn vx cv vy cv cJ
      vx visset vy visset prss sylan2b cJ ctop wcel vx cv cJ wcel vy cv cJ wcel
      wa wa vy cv vy cv wss vy cv vx cv vy cv cpr wcel wa vy cv vx cv vy cv cpr
      cuni wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vy cv vx cv vy cv
      cpr wcel vy cv vy cv wss vy cv vx cv vy cv cpr wcel cJ ctop wcel vx cv cJ
      wcel vy cv cJ wcel wa wa vx cv vy cv vy visset prid2 a1i vy cv ssid jctil
      vy cv vy cv vx cv vy cv cpr ssuni syl 3jca vu vv cJ cJ cC vx cv vy cv cpr
      cuni vy cv cvv cvv vy visset vx cv vy cv cpr vx vy zfpair uniex toplat.1
      definc sylibr jca cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv va
      cv cC cJ cJ cxp cin wbr vy cv va cv cC cJ cJ cxp cin wbr wa vx cv vy cv
      cpr cuni va cv cC cJ cJ cxp cin wbr wi va cJ vx cv va cv cC cJ cJ cxp cin
      wbr vy cv va cv cC cJ cJ cxp cin wbr wa cJ ctop wcel vx cv cJ wcel vy cv
      cJ wcel wa wa va cv cJ wcel wa vx cv vy cv cpr cuni va cv cC cJ cJ cxp
      cin wbr vx cv va cv cC cJ cJ cxp cin wbr vy cv va cv cC cJ cJ cxp cin wbr
      cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa vx cv vy
      cv cpr cuni va cv cC cJ cJ cxp cin wbr wi vx cv va cv cC cJ cJ cxp cin
      wbr vx cv cJ wcel va cv cJ wcel vx cv va cv wss w3a vy cv va cv cC cJ cJ
      cxp cin wbr cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel
      wa vx cv vy cv cpr cuni va cv cC cJ cJ cxp cin wbr wi wi vu vv cJ cJ cC
      va cv vx cv cvv cvv vx visset va visset toplat.1 definc vx cv va cv wss
      vx cv cJ wcel vy cv va cv cC cJ cJ cxp cin wbr cJ ctop wcel vx cv cJ wcel
      vy cv cJ wcel wa wa va cv cJ wcel wa vx cv vy cv cpr cuni va cv cC cJ cJ
      cxp cin wbr wi wi va cv cJ wcel vy cv va cv cC cJ cJ cxp cin wbr vx cv va
      cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa vx
      cv vy cv cpr cuni va cv cC cJ cJ cxp cin wbr wi vy cv va cv cC cJ cJ cxp
      cin wbr vy cv cJ wcel va cv cJ wcel vy cv va cv wss w3a vx cv va cv wss
      cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa vx cv vy
      cv cpr cuni va cv cC cJ cJ cxp cin wbr wi wi vu vv cJ cJ cC va cv vy cv
      cvv cvv vy visset va visset toplat.1 definc vy cv va cv wss vy cv cJ wcel
      vx cv va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ
      wcel wa vx cv vy cv cpr cuni va cv cC cJ cJ cxp cin wbr wi wi va cv cJ
      wcel vx cv va cv wss vy cv va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ
      wcel wa wa va cv cJ wcel wa vx cv vy cv cpr cuni va cv cC cJ cJ cxp cin
      wbr wi vx cv va cv wss vy cv va cv wss wa vx cv vy cv cun va cv wss cJ
      ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa vx cv vy cv
      cpr cuni va cv cC cJ cJ cxp cin wbr wi vx cv vy cv va cv unss vx cv vy cv
      cun va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ
      wcel wa vx cv vy cv cpr cuni va cv cC cJ cJ cxp cin wbr vx cv vy cv cun
      va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa
      wa vx cv vy cv cpr cuni cJ wcel va cv cJ wcel vx cv vy cv cpr cuni va cv
      wss w3a vx cv vy cv cpr cuni va cv cC cJ cJ cxp cin wbr vx cv vy cv cun
      va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa
      wa vx cv vy cv cpr cuni cJ wcel va cv cJ wcel vx cv vy cv cpr cuni va cv
      wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv vy cv cpr cuni
      cJ wcel vx cv vy cv cun va cv wss va cv cJ wcel cJ ctop wcel vx cv vy cv
      cpr cJ wss vx cv vy cv cpr cuni cJ wcel vx cv cJ wcel vy cv cJ wcel wa vx
      cv vy cv cpr cJ uniopn vx cv vy cv cJ vx visset vy visset prss sylan2b
      ad2antrl vx cv vy cv cun va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ
      wcel wa wa va cv cJ wcel simprr vx cv vy cv cun va cv wss vx cv vy cv cpr
      cuni va cv wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ
      wcel wa vx cv vy cv cun va cv wss vx cv vy cv cpr cuni va cv wss vx cv vy
      cv cun vx cv vy cv cpr cuni va cv vx cv vy cv cpr cuni vx cv vy cv cun vx
      cv vy cv vx visset vy visset unipr eqcomi sseq1i biimpi adantr 3jca vu vv
      cJ cJ cC va cv vx cv vy cv cpr cuni cvv cvv vx cv vy cv cpr vx vy zfpair
      uniex va visset toplat.1 definc sylibr ex sylbi expcom 3ad2ant3 sylbi
      com12 3ad2ant3 sylbi imp com12 r19.21aiva syl3anc cJ ctop wcel vx cv vy
      cv cpr cJ wss vx cv vy cv cpr cuni cJ wcel vx cv cJ wcel vy cv cJ wcel wa
      vx cv vy cv cpr cJ uniopn vx cv vy cv cJ vx visset vy visset prss sylan2b
      eqeltrd cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa cC cJ cJ cxp cin
      vx cv vy cv cpr cinf co vx cv vy cv cin cJ cJ ctop wcel vx cv cJ wcel vy
      cv cJ wcel wa wa cC cJ cJ cxp cin vx cv vy cv cpr cinf co cC cJ cJ cxp
      cin ccnv vx cv vy cv cpr cspw co vx cv vy cv cpr cint vx cv vy cv cin cJ
      ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa cC cJ cJ cxp cin cps wcel vx
      cv vy cv cpr cvv wcel wa cC cJ cJ cxp cin vx cv vy cv cpr cinf co cC cJ
      cJ cxp cin ccnv vx cv vy cv cpr cspw co wceq cJ ctop wcel vx cv cJ wcel
      vy cv cJ wcel wa wa cC cJ cJ cxp cin cps wcel vx cv vy cv cpr cvv wcel cJ
      ctop wcel cC cJ cJ cxp cin cps wcel vx cv cJ wcel vy cv cJ wcel wa vu vv
      cJ ctop cC toplat.1 inposet adantr vx vy zfpair jctir vx cv vy cv cpr cC
      cJ cJ cxp cin cps cvv nfwval syl cC cJ cJ cxp cin ccnv cps wcel vx cv vy
      cv cpr cint cvv wcel wa vx cv vx cv vy cv cpr cint cC cJ cJ cxp cin ccnv
      wbr vy cv vx cv vy cv cpr cint cC cJ cJ cxp cin ccnv wbr wa vx cv va cv
      cC cJ cJ cxp cin ccnv wbr vy cv va cv cC cJ cJ cxp cin ccnv wbr wa vx cv
      vy cv cpr cint va cv cC cJ cJ cxp cin ccnv wbr wi va cJ wral cC cJ cJ cxp
      cin ccnv vx cv vy cv cpr cspw co vx cv vy cv cpr cint wceq cJ ctop wcel
      vx cv cJ wcel vy cv cJ wcel wa wa va vx cv vy cv vx cv vy cv cpr cint cvv
      cC cJ cJ cxp cin ccnv cJ cC cJ cJ cxp cin crn cJ cC cJ cJ cxp cin ccnv
      cdm vu vv cJ cC toplat.1 ranncnt cC cJ cJ cxp cin df-rn eqtr3i spwpr4 cJ
      ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa cC cJ cJ cxp cin ccnv cps
      wcel vx cv vy cv cpr cint cvv wcel cJ ctop wcel cC cJ cJ cxp cin ccnv cps
      wcel vx cv cJ wcel vy cv cJ wcel wa cJ ctop wcel cC cJ cJ cxp cin cps
      wcel cC cJ cJ cxp cin ccnv cps wcel vu vv cJ ctop cC toplat.1 inposet cC
      cJ cJ cxp cin dupos1 syl adantr vx cv vy cv cpr c0 wne vx cv vy cv cpr
      cint cvv wcel vx cv vy cv vx visset prnz vx cv vy cv cpr intex mpbi jctir
      vx cv cJ wcel vy cv cJ wcel wa vx cv vy cv cpr cint cJ wcel vx cv vx cv
      vy cv cpr cint cC cJ cJ cxp cin ccnv wbr vy cv vx cv vy cv cpr cint cC cJ
      cJ cxp cin ccnv wbr wa cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx
      cv cJ wcel vy cv cJ wcel wa vx cv vy cv cpr cint cJ wcel wa vx cv vx cv
      vy cv cpr cint cC cJ cJ cxp cin ccnv wbr vy cv vx cv vy cv cpr cint cC cJ
      cJ cxp cin ccnv wbr vx cv cJ wcel vx cv vy cv cpr cint cJ wcel vx cv vx
      cv vy cv cpr cint cC cJ cJ cxp cin ccnv wbr vy cv cJ wcel vx cv cJ wcel
      vx cv vy cv cpr cint cJ wcel wa vx cv vx cv vy cv cpr cint cC cJ cJ cxp
      cin ccnv wbr vx cv vy cv cpr cint vx cv cC cJ cJ cxp cin wbr vx cv cJ
      wcel vx cv vy cv cpr cint cJ wcel wa vx cv vy cv cin vx cv vx cv vy cv
      cpr cint cC cJ cJ cxp cin vx cv cJ wcel vx cv vy cv cpr cint cJ wcel wa
      vx cv vy cv cin cJ wcel vx cv cJ wcel vx cv vy cv cin vx cv wss w3a vx cv
      vy cv cin vx cv cC cJ cJ cxp cin wbr vx cv cJ wcel vx cv vy cv cpr cint
      cJ wcel wa vx cv vy cv cin cJ wcel vx cv cJ wcel vx cv vy cv cin vx cv
      wss vx cv vy cv cpr cint cJ wcel vx cv vy cv cin cJ wcel vx cv cJ wcel vx
      cv vy cv cpr cint cJ wcel vx cv vy cv cin cJ wcel vx cv vy cv cpr cint vx
      cv vy cv cin cJ vx cv vy cv vx visset vy visset intpr eleq1i biimpi
      adantl vx cv cJ wcel vx cv vy cv cpr cint cJ wcel pm3.26 vx cv vy cv cin
      vx cv wss vx cv cJ wcel vx cv vy cv cpr cint cJ wcel wa vx cv vy cv inss1
      a1i 3jca vu vv cJ cJ cC vx cv vx cv vy cv cin cvv cvv vx cv vy cv vx
      visset inex1 vx visset toplat.1 definc sylibr vx cv vy cv vx visset vy
      visset intpr syl5eqbr vx cv vx cv vy cv cpr cint cJ cJ cC cJ cJ cxp cin
      brcnvg mpbird adantlr vy cv cJ wcel vx cv vy cv cpr cint cJ wcel vy cv vx
      cv vy cv cpr cint cC cJ cJ cxp cin ccnv wbr vx cv cJ wcel vy cv cJ wcel
      vx cv vy cv cpr cint cJ wcel wa vy cv vx cv vy cv cpr cint cC cJ cJ cxp
      cin ccnv wbr vx cv vy cv cpr cint vy cv cC cJ cJ cxp cin wbr vy cv cJ
      wcel vx cv vy cv cpr cint cJ wcel wa vx cv vy cv cpr cint cJ wcel vy cv
      cJ wcel vx cv vy cv cpr cint vy cv wss w3a vx cv vy cv cpr cint vy cv cC
      cJ cJ cxp cin wbr vy cv cJ wcel vx cv vy cv cpr cint cJ wcel wa vx cv vy
      cv cpr cint cJ wcel vy cv cJ wcel vx cv vy cv cpr cint vy cv wss vy cv cJ
      wcel vx cv vy cv cpr cint cJ wcel pm3.27 vy cv cJ wcel vx cv vy cv cpr
      cint cJ wcel pm3.26 vx cv vy cv cpr cint vy cv wss vy cv cJ wcel vx cv vy
      cv cpr cint cJ wcel wa vx cv vy cv cpr cint vx cv vy cv cin vy cv vx cv
      vy cv vx visset vy visset intpr vx cv vy cv inss2 eqsstri a1i 3jca vu vv
      cJ cJ cC vy cv vx cv vy cv cpr cint cvv cvv vx cv vy cv cpr c0 wne vx cv
      vy cv cpr cint cvv wcel vx cv vy cv vx visset prnz vx cv vy cv cpr intex
      mpbi vy visset toplat.1 definc sylibr vy cv vx cv vy cv cpr cint cJ cJ cC
      cJ cJ cxp cin brcnvg mpbird adantll jca cJ ctop wcel vx cv cJ wcel vy cv
      cJ wcel wa pm3.27 cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv vy
      cv cin cJ vx cv vy cv cpr cint cJ ctop wcel vx cv cJ wcel vy cv cJ wcel
      vx cv vy cv cin cJ wcel vx cv vy cv cJ inopn 3expb vx cv vy cv vx visset
      vy visset intpr syl5eqel sylanc cJ ctop wcel vx cv cJ wcel vy cv cJ wcel
      wa wa vx cv va cv cC cJ cJ cxp cin ccnv wbr vy cv va cv cC cJ cJ cxp cin
      ccnv wbr wa vx cv vy cv cpr cint va cv cC cJ cJ cxp cin ccnv wbr wi va cJ
      cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel vx cv va cv
      cC cJ cJ cxp cin ccnv wbr vy cv va cv cC cJ cJ cxp cin ccnv wbr wa vx cv
      vy cv cpr cint va cv cC cJ cJ cxp cin ccnv wbr cJ ctop wcel vx cv cJ wcel
      vy cv cJ wcel wa wa va cv cJ wcel wa vx cv va cv cC cJ cJ cxp cin ccnv
      wbr vy cv va cv cC cJ cJ cxp cin ccnv wbr wa wa vx cv vy cv cpr cint va
      cv cC cJ cJ cxp cin ccnv wbr va cv vx cv vy cv cpr cint cC cJ cJ cxp cin
      wbr cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa vx cv
      va cv cC cJ cJ cxp cin ccnv wbr vy cv va cv cC cJ cJ cxp cin ccnv wbr wa
      va cv vx cv vy cv cpr cint cC cJ cJ cxp cin wbr cJ ctop wcel vx cv cJ
      wcel vy cv cJ wcel wa wa va cv cJ wcel wa va cv vx cv cC cJ cJ cxp cin
      wbr va cv vy cv cC cJ cJ cxp cin wbr va cv vx cv vy cv cpr cint cC cJ cJ
      cxp cin wbr vx cv va cv cC cJ cJ cxp cin ccnv wbr vy cv va cv cC cJ cJ
      cxp cin ccnv wbr cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ
      wcel wa va cv cJ wcel vx cv cJ wcel va cv vx cv wss w3a va cv cJ wcel vy
      cv cJ wcel va cv vy cv wss w3a va cv vx cv vy cv cpr cint cC cJ cJ cxp
      cin wbr va cv vx cv cC cJ cJ cxp cin wbr va cv vy cv cC cJ cJ cxp cin wbr
      cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa va cv cJ
      wcel vx cv cJ wcel va cv vx cv wss w3a va cv cJ wcel vy cv cJ wcel va cv
      vy cv wss w3a wa va cv vx cv vy cv cpr cint cC cJ cJ cxp cin wbr cJ ctop
      wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa va cv cJ wcel vx
      cv cJ wcel va cv vx cv wss w3a va cv cJ wcel vy cv cJ wcel va cv vy cv
      wss w3a wa wa va cv cJ wcel vx cv vy cv cpr cint cJ wcel va cv vx cv vy
      cv cpr cint wss w3a va cv vx cv vy cv cpr cint cC cJ cJ cxp cin wbr cJ
      ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa va cv cJ
      wcel vx cv cJ wcel va cv vx cv wss w3a va cv cJ wcel vy cv cJ wcel va cv
      vy cv wss w3a wa wa va cv cJ wcel vx cv vy cv cpr cint cJ wcel va cv vx
      cv vy cv cpr cint wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va
      cv cJ wcel va cv cJ wcel vx cv cJ wcel va cv vx cv wss w3a va cv cJ wcel
      vy cv cJ wcel va cv vy cv wss w3a wa simplr cJ ctop wcel vx cv cJ wcel vy
      cv cJ wcel wa wa vx cv vy cv cpr cint cJ wcel va cv cJ wcel va cv cJ wcel
      vx cv cJ wcel va cv vx cv wss w3a va cv cJ wcel vy cv cJ wcel va cv vy cv
      wss w3a wa cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv vy cv cin
      cJ vx cv vy cv cpr cint cJ ctop wcel vx cv cJ wcel vy cv cJ wcel vx cv vy
      cv cin cJ wcel vx cv vy cv cJ inopn 3expb vx cv vy cv vx visset vy visset
      intpr syl5eqel ad2antrr va cv cJ wcel vx cv cJ wcel va cv vx cv wss w3a
      va cv cJ wcel vy cv cJ wcel va cv vy cv wss w3a wa va cv vx cv vy cv cpr
      cint wss cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa
      va cv cJ wcel vx cv cJ wcel va cv vx cv wss w3a va cv cJ wcel vy cv cJ
      wcel va cv vy cv wss w3a va cv vx cv vy cv cpr cint wss va cv vx cv wss
      va cv cJ wcel va cv cJ wcel vy cv cJ wcel va cv vy cv wss w3a va cv vx cv
      vy cv cpr cint wss wi vx cv cJ wcel va cv cJ wcel vy cv cJ wcel va cv vy
      cv wss w3a va cv vx cv wss va cv vx cv vy cv cpr cint wss va cv vy cv wss
      va cv cJ wcel va cv vx cv wss va cv vx cv vy cv cpr cint wss wi vy cv cJ
      wcel va cv vx cv wss va cv vy cv wss va cv vx cv vy cv cpr cint wss va cv
      vx cv wss va cv vy cv wss wa va cv vx cv vy cv cin vx cv vy cv cpr cint
      va cv vx cv wss va cv vy cv wss wa va cv vx cv vy cv cin wss va cv vx cv
      vy cv ssin biimpi vx cv vy cv vx visset vy visset intpr syl6ssr expcom
      3ad2ant3 com12 3ad2ant3 imp adantl 3jca vu vv cJ cJ cC vx cv vy cv cpr
      cint va cv cvv cvv va visset vx cv vy cv cpr c0 wne vx cv vy cv cpr cint
      cvv wcel vx cv vy cv vx visset prnz vx cv vy cv cpr intex mpbi toplat.1
      definc sylibr ex va cv vx cv cC cJ cJ cxp cin wbr va cv cJ wcel vx cv cJ
      wcel va cv vx cv wss w3a vu vv cJ cJ cC vx cv va cv cvv cvv va visset vx
      visset toplat.1 definc biimpi va cv vy cv cC cJ cJ cxp cin wbr va cv cJ
      wcel vy cv cJ wcel va cv vy cv wss w3a vu vv cJ cJ cC vy cv va cv cvv cvv
      va visset vy visset toplat.1 definc biimpi syl2ani cJ ctop wcel vx cv cJ
      wcel vy cv cJ wcel wa wa va cv cJ wcel wa vx cv va cv cC cJ cJ cxp cin
      ccnv wbr va cv vx cv cC cJ cJ cxp cin wbr vx cv cJ wcel va cv cJ wcel vx
      cv va cv cC cJ cJ cxp cin ccnv wbr va cv vx cv cC cJ cJ cxp cin wbr wb cJ
      ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vx cv va cv cJ cJ cC cJ cJ
      cxp cin brcnvg cJ ctop wcel vx cv cJ wcel vy cv cJ wcel simprl sylan
      biimpd cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va cv cJ wcel wa vy
      cv va cv cC cJ cJ cxp cin ccnv wbr va cv vy cv cC cJ cJ cxp cin wbr vy cv
      cJ wcel va cv cJ wcel vy cv va cv cC cJ cJ cxp cin ccnv wbr va cv vy cv
      cC cJ cJ cxp cin wbr wb cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa vy
      cv va cv cJ cJ cC cJ cJ cxp cin brcnvg cJ ctop wcel vx cv cJ wcel vy cv
      cJ wcel simprr sylan biimpd syl2and imp cJ ctop wcel vx cv cJ wcel vy cv
      cJ wcel wa wa va cv cJ wcel wa vx cv va cv cC cJ cJ cxp cin ccnv wbr vy
      cv va cv cC cJ cJ cxp cin ccnv wbr wa wa vx cv vy cv cpr cint cvv wcel va
      cv cvv wcel wa vx cv vy cv cpr cint va cv cC cJ cJ cxp cin ccnv wbr va cv
      vx cv vy cv cpr cint cC cJ cJ cxp cin wbr wb vx cv vy cv cpr cint cvv
      wcel va cv cvv wcel wa cJ ctop wcel vx cv cJ wcel vy cv cJ wcel wa wa va
      cv cJ wcel wa vx cv va cv cC cJ cJ cxp cin ccnv wbr vy cv va cv cC cJ cJ
      cxp cin ccnv wbr wa wa vx cv vy cv cpr cint cvv wcel va cv cvv wcel vx cv
      vy cv cpr c0 wne vx cv vy cv cpr cint cvv wcel vx cv vy cv vx visset prnz
      vx cv vy cv cpr intex mpbi va visset pm3.2i a1i vx cv vy cv cpr cint va
      cv cvv cvv cC cJ cJ cxp cin brcnvg syl mpbird exp31 r19.21aiv syl3anc vx
      cv vy cv cpr cint vx cv vy cv cin wceq cJ ctop wcel vx cv cJ wcel vy cv
      cJ wcel wa wa vx cv vy cv vx visset vy visset intpr a1i 3eqtrd cJ ctop
      wcel vx cv cJ wcel vy cv cJ wcel vx cv vy cv cin cJ wcel vx cv vy cv cJ
      inopn 3expb eqeltrd jca ex r19.21aivv jca vx vy cC cJ cJ cxp cin cJ cC cJ
      cJ cxp cin cdm cJ vu vv cJ cC toplat.1 domncnt eqcomi isla sylibr $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite composites ( i. e. finite sums, products ... )
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c prod_ $. $( Product sign. $)

  $( Extend class notation to include finite products/sums. $)
  cprd $a class prod_ k e. A G B $.

  ${
    $d m n x y k $. $d m n x y A $.  $d m n x y G $.  $d m n x y B $.
    $( Define the composite for the law  ` G ` of a finite sequence of
       elements whose values  are defined by the expression  ` B ` and
       whose set of indices  is ` A ` . It may  be thougt as a product
       (if ` G ` is a multiplication), a sum (if ` G ` is an addition)
       or whatever.  The variable ` k ` is normally a free variable in
       ` B `  ( i.e.  ` B `  can be thought of as  ` B ( k )  ` ). The
       definition  is  meaningful  when `  A  `  is  a finite  set  of
       sequential integers  and ` G  ` is an internal  operation.  Our
       definition corresponds to the first part of the definition of
       ~ df-sum . The  operation ` + ` has been  replaced by the generic
       operation `  G ` .  The reference to  the concept of  limit has
       been removed because  one wants to use the  product in contexts
       where limits are irrelevant.  I could be still more generic and
       replace `  ( m ...  n )  ` by a  finite totally ordered  set. I
       would then  get the definition  given by Bourbaki in  the first
       chapter of the algebra book of  his treatise ( A I.3 def.4 ). I
       don't because the present definition is easier to deal with and
       because there  exists an  order isomorphism between  any finite
       totally ordered  set and any  finite sets of integers.  I don't
       specify anything about ` G ` because nothing is required of ` g `
       in the  definition  of `  seq  ` .  I hope  it  will be  ok.
       Otherwise one could add ` G e. Magma ` . $)
    df-prod $a |- prod_ k e. A G B = { x | E. m E. n e. ( ZZ>= ` m )
        ( A = ( m ... n ) /\
      x e. ( ( <. m , G >. seq ( { <. k , y >. | y = B } |` ZZ ) ) ` n ) ) } $.
  $}

  ${
    $d A m n x y $. $d B m n x y $. $d G m n x y $. $d k m n x y $.
    $( A finite composite is a set. $)
    prodex $p |- prod_ k e. A G B e. _V $=
      cA cB vk cG cprd cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy
      cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex
      vm wex vx cab cvv vx vy cA cB vk vm vn cG df-prod cA vm cv vn cv cfz co
      wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz co
      cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cab vm cv vn cv cle wbr cA vm
      cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab
      cz cres cseqz co cfv wcel wa wa vn cz wrex vm cz wrex vx cab cvv cA vm cv
      vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz
      cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vm cv vn cv cle
      wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk
      vy copab cz cres cseqz co cfv wcel wa wa vn cz wrex vm cz wrex vx cA vm
      cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab
      cz cres cseqz co cfv wcel wa vm vn 2rexuz abbii vm cv vn cv cle wbr cA vm
      cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab
      cz cres cseqz co cfv wcel wa wa vn cz wrex vm vx cz zex vm cv vn cv cle
      wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk
      vy copab cz cres cseqz co cfv wcel wa wa vn vx cz zex vm cv vn cv cle wbr
      cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv wcel wa wa vx cab vn cv vm cv cG cop vy cv cB
      wceq vk vy copab cz cres cseqz co cfv vn cv vm cv cG cop vy cv cB wceq vk
      vy copab cz cres cseqz co fvex vm cv vn cv cle wbr cA vm cv vn cv cfz co
      wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz co
      cfv wcel wa wa vx cab vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab
      cz cres cseqz co cfv wcel vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq
      wa wa vx cab vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz
      co cfv vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm cv
      cG cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa wa vx cv vn
      cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel vm cv
      vn cv cle wbr cA vm cv vn cv cfz co wceq wa wa vx vm cv vn cv cle wbr cA
      vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv wcel wa wa vm cv vn cv cle wbr cA vm cv vn cv
      cfz co wceq wa vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv wcel wa vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab
      cz cres cseqz co cfv wcel vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq
      wa wa vm cv vn cv cle wbr cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel anass vm cv vn cv
      cle wbr cA vm cv vn cv cfz co wceq wa vx cv vn cv vm cv cG cop vy cv cB
      wceq vk vy copab cz cres cseqz co cfv wcel ancom bitr3i abbii vm cv vn cv
      cle wbr cA vm cv vn cv cfz co wceq wa vx vn cv vm cv cG cop vy cv cB wceq
      vk vy copab cz cres cseqz co cfv ssab2 eqsstri ssexi abrexex2 abrexex2
      eqeltri eqeltri $.
      $( [23-Jun-2010] $) $( [23-Jun-2010] $)
  $}

  ${
    $d A m n x y $. $d B m n x y $. $d C m n x y $. $d G m n x y $.
    $d k m n x y $.
    $( Equality theorem for a composite. $)
    prodeq1 $p |- ( A = B -> prod_ k e. A G C = prod_ k e. B G C ) $=
      cA cB wceq cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab cB vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab cA cC vk cG cprd cB cC vk cG cprd cA cB wceq cA vm cv vn cv
      cfz co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex cB vm cv vn cv cfz co
      wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz co
      cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cA cB wceq cA vm cv vn cv cfz
      co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex cB vm cv vn cv cfz co wceq vx cv vn
      cv vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn
      vm cv cuz cfv wrex vm cA cB wceq cA vm cv vn cv cfz co wceq vx cv vn cv
      vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa cB vm
      cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab
      cz cres cseqz co cfv wcel wa vn vm cv cuz cfv cA cB wceq cA vm cv vn cv
      cfz co wceq cB vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC
      wceq vk vy copab cz cres cseqz co cfv wcel cA cB vm cv vn cv cfz co eqeq1
      anbi1d rexbidv exbidv abbidv vx vy cA cC vk vm vn cG df-prod vx vy cB cC
      vk vm vn cG df-prod 3eqtr4g $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A k m n x y $. $d B m n x y $. $d G k m n x y $.
    hbprod1.1 $e |- ( x e. A -> A. k x e. A ) $.
    $( Bound-variable hypothesis builder for ` prod_ ` . $)
    hbprod1 $p |- ( x e. prod_ k e. A G B -> A. k x e. prod_ k e. A G B )
       $=
      vk vx cA cB vk cG cprd cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG
      cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm wex vx cab vx vy cA cB vk vm vn cG df-prod cA vm cv vn cv cfz
      co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vm wex vk vx vx cA vm cv vn cv cfz
      co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vk vm cA vm cv vn cv cfz co wceq vx
      cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel
      wa vk vn vm cv cuz cfv vn cv vm cv cuz cfv wcel vk ax-17 cA vm cv vn cv
      cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv wcel vk cA vm cv vn cv cfz co wceq vk ax-17 vk vx vn cv vm
      cv cG cop vy cv cB wceq vk vy copab cz cres cseqz co vk vx vm cv cG cop
      vy cv cB wceq vk vy copab cz cres cseqz vx cv vm cv cG cop wcel vk ax-17
      vx cv cseqz wcel vk ax-17 vk vx vy cv cB wceq vk vy copab cz vy cv cB
      wceq vk vy vx hbopab1 vx cv cz wcel vk ax-17 hbres hbopr vx vn wel vk
      ax-17 hbfv hban hbrex hbex hbab hbxfr $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d A m n w y z $. $d B m n w y z $. $d G m n w y z $.
    $d k m n w x z $. $d x y z $.
    hbprod.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbprod.2 $e |- ( y e. G -> A. x y e. G ) $.
    hbprod.3 $e |- ( y e. B -> A. x y e. B ) $.
    $( Bound-variable  hypothesis builder for  ` prod_ ` . If ` x  ` is
       (effectively) not free in `  A ` , ` G ` and ` B  ` , it is not
       free in ` prod_ k e. A G B ` . $)
    hbprod $p |- ( y e. prod_ k e. A G B -> A. x y e. prod_ k e. A G B ) $=
      vx vy cA cB vk cG cprd cA vm cv vn cv cfz co wceq vz cv vn cv vm cv cG
      cop vw cv cB wceq vk vw copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm wex vz cab vz vw cA cB vk vm vn cG df-prod cA vm cv vn cv cfz
      co wceq vz cv vn cv vm cv cG cop vw cv cB wceq vk vw copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx vz vy cA vm cv vn cv cfz
      co wceq vz cv vn cv vm cv cG cop vw cv cB wceq vk vw copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vx vm cA vm cv vn cv cfz co wceq vz
      cv vn cv vm cv cG cop vw cv cB wceq vk vw copab cz cres cseqz co cfv wcel
      wa vx vn vm cv cuz cfv vn cv vm cv cuz cfv wcel vx ax-17 cA vm cv vn cv
      cfz co wceq vz cv vn cv vm cv cG cop vw cv cB wceq vk vw copab cz cres
      cseqz co cfv wcel vx vx vy vy cA vm cv vn cv cfz co hbprod.1 vy cv vm cv
      vn cv cfz co wcel vx ax-17 hbeq vx vz vn cv vm cv cG cop vw cv cB wceq vk
      vw copab cz cres cseqz co vx vz vm cv cG cop vw cv cB wceq vk vw copab cz
      cres cseqz vy cv vm cv cG cop wcel vy cv vm cv cG cop wcel vx wal wi vz
      cv vm cv cG cop wcel vz cv vm cv cG cop wcel vx wal wi vy vz vz cv vm cv
      cG cop wcel vz cv vm cv cG cop wcel vx wal wi vy ax-17 vy vz weq vy cv vm
      cv cG cop wcel vz cv vm cv cG cop wcel vy cv vm cv cG cop wcel vx wal vz
      cv vm cv cG cop wcel vx wal vy cv vz cv vm cv cG cop eleq1 vy vz weq vy
      cv vm cv cG cop wcel vz cv vm cv cG cop wcel vx vy vz weq vx ax-17 vy cv
      vz cv vm cv cG cop eleq1 albid imbi12d vx vy vm cv cG vy vm wel vx ax-17
      hbprod.2 hbop chvar vz cv cseqz wcel vx ax-17 vx vz vw cv cB wceq vk vw
      copab cz vw cv cB wceq vk vw vx vz vx vy vy vw cv cB vy vw wel vx ax-17
      hbprod.3 hbeq hbopab vz cv cz wcel vx ax-17 hbres hbopr vz vn wel vx
      ax-17 hbfv hban hbrex hbex hbab hbxfr $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A k m n x y $. $d B m n x y $. $d C m n x y $. $d G m n x y $.
    prodeq2.1 $e |- G e. D $.
    $( Equality theorem for a composite. $)
    prodeq2 $p |- ( A. k e. A B = C
      -> prod_ k e. A G B = prod_ k e. A G C ) $=
      cB cC wceq vk cA wral cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop
      vy cv cB wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vx cab cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy
      cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex
      vm wex vx cab cA cB vk cG cprd cA cC vk cG cprd cB cC wceq vk cA wral cA
      vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex cA vm cv
      vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz
      cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cB cC wceq vk
      cA wral cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq
      vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex cA vm cv
      vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz
      cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm cB cC wceq vk cA wral
      cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv wcel wa cA vm cv vn cv cfz co wceq vx cv vn cv
      vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm
      cv cuz cfv cB cC wceq vk cA wral vn cv vm cv cuz cfv wcel wa cA vm cv vn
      cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cB wceq vk vy copab cz cres
      cseqz co cfv wcel vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz
      cres cseqz co cfv wcel cB cC wceq vk cA wral vn cv vm cv cuz cfv wcel wa
      cA vm cv vn cv cfz co wceq wa vn cv vm cv cG cop vy cv cB wceq vk vy
      copab cz cres cseqz co cfv vn cv vm cv cG cop vy cv cC wceq vk vy copab
      cz cres cseqz co cfv vx cv cB cC wceq vk cA wral vn cv vm cv cuz cfv wcel
      wa cA vm cv vn cv cfz co wceq wa vn cv vm cv cG cop vy cv cB wceq vk vy
      copab vm cv vn cv cfz co cres cseqz co cfv vn cv vm cv cG cop vy cv cC
      wceq vk vy copab vm cv vn cv cfz co cres cseqz co cfv vn cv vm cv cG cop
      vy cv cB wceq vk vy copab cz cres cseqz co cfv vn cv vm cv cG cop vy cv
      cC wceq vk vy copab cz cres cseqz co cfv cB cC wceq vk cA wral cA vm cv
      vn cv cfz co wceq vn cv vm cv cG cop vy cv cB wceq vk vy copab vm cv vn
      cv cfz co cres cseqz co cfv vn cv vm cv cG cop vy cv cC wceq vk vy copab
      vm cv vn cv cfz co cres cseqz co cfv wceq vn cv vm cv cuz cfv wcel cB cC
      wceq vk cA wral cA vm cv vn cv cfz co wceq wa vn cv vm cv cG cop vy cv cB
      wceq vk vy copab vm cv vn cv cfz co cres cseqz co vm cv cG cop vy cv cC
      wceq vk vy copab vm cv vn cv cfz co cres cseqz co cB cC wceq vk cA wral
      cA vm cv vn cv cfz co wceq wa vy cv cB wceq vk vy copab vm cv vn cv cfz
      co cres vy cv cC wceq vk vy copab vm cv vn cv cfz co cres vm cv cG cop
      cseqz cB cC wceq vk cA wral cA vm cv vn cv cfz co wceq wa vy cv cB wceq
      vk vy copab cA cres vy cv cC wceq vk vy copab cA cres vy cv cB wceq vk vy
      copab vm cv vn cv cfz co cres vy cv cC wceq vk vy copab vm cv vn cv cfz
      co cres cB cC wceq vk cA wral vy cv cB wceq vk vy copab cA cres vy cv cC
      wceq vk vy copab cA cres wceq cA vm cv vn cv cfz co wceq cB cC wceq vk cA
      wral vk cv cA wcel vy cv cB wceq wa vk vy copab vk cv cA wcel vy cv cC
      wceq wa vk vy copab vy cv cB wceq vk vy copab cA cres vy cv cC wceq vk vy
      copab cA cres cB cC wceq vk cA wral vk cv cA wcel vy cv cB wceq wa vk cv
      cA wcel vy cv cC wceq wa vk vy cB cC wceq vk cA hbra1 cB cC wceq vk cA
      wral vy ax-17 cB cC wceq vk cA wral vk cv cA wcel vy cv cB wceq vy cv cC
      wceq cB cC wceq vk cA wral vk cv cA wcel wa cB cC vy cv cB cC wceq vk cA
      wral vk cv cA wcel cB cC wceq cB cC wceq vk cA ra4 imp eqeq2d pm5.32da
      opabbid vy cv cB wceq vk vy cA resopab vy cv cC wceq vk vy cA resopab
      3eqtr4g adantr cA vm cv vn cv cfz co wceq vy cv cB wceq vk vy copab cA
      cres vy cv cB wceq vk vy copab vm cv vn cv cfz co cres wceq cB cC wceq vk
      cA wral cA vm cv vn cv cfz co vy cv cB wceq vk vy copab reseq2 adantl cA
      vm cv vn cv cfz co wceq vy cv cC wceq vk vy copab cA cres vy cv cC wceq
      vk vy copab vm cv vn cv cfz co cres wceq cB cC wceq vk cA wral cA vm cv
      vn cv cfz co vy cv cC wceq vk vy copab reseq2 adantl 3eqtr3d opreq2d
      fveq1d adantlr vn cv vm cv cuz cfv wcel vn cv vm cv cG cop vy cv cB wceq
      vk vy copab cz cres cseqz co cfv vn cv vm cv cG cop vy cv cB wceq vk vy
      copab vm cv vn cv cfz co cres cseqz co cfv wceq cB cC wceq vk cA wral cA
      vm cv vn cv cfz co wceq vn cv vm cv cuz cfv wcel vx cv vy cv cB wceq vk
      vy copab cz cres cfv vx cv vy cv cB wceq vk vy copab vm cv vn cv cfz co
      cres cfv wceq vx vm cv vn cv cfz co wral vn cv vm cv cG cop vy cv cB wceq
      vk vy copab cz cres cseqz co cfv vn cv vm cv cG cop vy cv cB wceq vk vy
      copab vm cv vn cv cfz co cres cseqz co cfv wceq vx cv vy cv cB wceq vk vy
      copab cz cres cfv vx cv vy cv cB wceq vk vy copab vm cv vn cv cfz co cres
      cfv wceq vx vm cv vn cv cfz co vx cv vm cv vn cv cfz co wcel vx cv vy cv
      cB wceq vk vy copab cz cres cfv vx cv vy cv cB wceq vk vy copab cfv vx cv
      vy cv cB wceq vk vy copab vm cv vn cv cfz co cres cfv vx cv vm cv vn cv
      cfz co wcel vx cv cz wcel vx cv vy cv cB wceq vk vy copab cz cres cfv vx
      cv vy cv cB wceq vk vy copab cfv wceq vx cv vm cv vn cv elfzelz vx cv cz
      vy cv cB wceq vk vy copab fvres syl vx cv vm cv vn cv cfz co vy cv cB
      wceq vk vy copab fvres eqtr4d rgen cG vx vy cv cB wceq vk vy copab cz
      cres vy cv cB wceq vk vy copab vm cv vn cv cfz co cres vm cv vn cv cG cD
      prodeq2.1 elisseti vy cv cB wceq vk vy copab wfun cz cvv wcel vy cv cB
      wceq vk vy copab cz cres cvv wcel vk vy cB funopabeq zex vy cv cB wceq vk
      vy copab cz cvv resfunexg mp2an vy cv cB wceq vk vy copab wfun vm cv vn
      cv cfz co cvv wcel vy cv cB wceq vk vy copab vm cv vn cv cfz co cres cvv
      wcel vk vy cB funopabeq vm cv vn cv cfz oprex vy cv cB wceq vk vy copab
      vm cv vn cv cfz co cvv resfunexg mp2an seqzfveq mpan2 ad2antlr vn cv vm
      cv cuz cfv wcel vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv vn cv vm cv cG cop vy cv cC wceq vk vy copab vm cv vn cv cfz
      co cres cseqz co cfv wceq cB cC wceq vk cA wral cA vm cv vn cv cfz co
      wceq vn cv vm cv cuz cfv wcel vx cv vy cv cC wceq vk vy copab cz cres cfv
      vx cv vy cv cC wceq vk vy copab vm cv vn cv cfz co cres cfv wceq vx vm cv
      vn cv cfz co wral vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv vn cv vm cv cG cop vy cv cC wceq vk vy copab vm cv vn cv cfz
      co cres cseqz co cfv wceq vx cv vy cv cC wceq vk vy copab cz cres cfv vx
      cv vy cv cC wceq vk vy copab vm cv vn cv cfz co cres cfv wceq vx vm cv vn
      cv cfz co vx cv vm cv vn cv cfz co wcel vx cv vy cv cC wceq vk vy copab
      cz cres cfv vx cv vy cv cC wceq vk vy copab cfv vx cv vy cv cC wceq vk vy
      copab vm cv vn cv cfz co cres cfv vx cv vm cv vn cv cfz co wcel vx cv cz
      wcel vx cv vy cv cC wceq vk vy copab cz cres cfv vx cv vy cv cC wceq vk
      vy copab cfv wceq vx cv vm cv vn cv elfzelz vx cv cz vy cv cC wceq vk vy
      copab fvres syl vx cv vm cv vn cv cfz co vy cv cC wceq vk vy copab fvres
      eqtr4d rgen cG vx vy cv cC wceq vk vy copab cz cres vy cv cC wceq vk vy
      copab vm cv vn cv cfz co cres vm cv vn cv cG cD prodeq2.1 elisseti vy cv
      cC wceq vk vy copab wfun cz cvv wcel vy cv cC wceq vk vy copab cz cres
      cvv wcel vk vy cC funopabeq zex vy cv cC wceq vk vy copab cz cvv
      resfunexg mp2an vy cv cC wceq vk vy copab wfun vm cv vn cv cfz co cvv
      wcel vy cv cC wceq vk vy copab vm cv vn cv cfz co cres cvv wcel vk vy cC
      funopabeq vm cv vn cv cfz oprex vy cv cC wceq vk vy copab vm cv vn cv cfz
      co cvv resfunexg mp2an seqzfveq mpan2 ad2antlr 3eqtr4d eleq2d pm5.32da
      rexbidva exbidv abbidv vx vy cA cB vk vm vn cG df-prod vx vy cA cC vk vm
      vn cG df-prod 3eqtr4g $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A m n x y $. $d B m n x y $. $d C m n x y $. $d G m n x y $.
    $d j k m n x y $.
    cbvprod.1 $e |- ( x e. B -> A. k x e. B ) $.
    cbvprod.2 $e |- ( x e. C -> A. j x e. C ) $.
    cbvprod.3 $e |- ( j = k -> B = C ) $.
    $( Change bound variable in a finite composite. $)
    cbvprodi $p |- prod_ j e. A G B = prod_ k e. A G C $=
      cA vm cv vn cv cfz co wceq vy cv vn cv vm cv cG cop vx cv cB wceq vj vx
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vy cab cA
      vm cv vn cv cfz co wceq vy cv vn cv vm cv cG cop vx cv cC wceq vk vx
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vy cab cA
      cB vj cG cprd cA cC vk cG cprd cA vm cv vn cv cfz co wceq vy cv vn cv vm
      cv cG cop vx cv cB wceq vj vx copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex cA vm cv vn cv cfz co wceq vy cv vn cv vm cv cG cop
      vx cv cC wceq vk vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      wrex vm wex vy cA vm cv vn cv cfz co wceq vy cv vn cv vm cv cG cop vx cv
      cB wceq vj vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex cA
      vm cv vn cv cfz co wceq vy cv vn cv vm cv cG cop vx cv cC wceq vk vx
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm cA vm cv vn
      cv cfz co wceq vy cv vn cv vm cv cG cop vx cv cB wceq vj vx copab cz cres
      cseqz co cfv wcel wa cA vm cv vn cv cfz co wceq vy cv vn cv vm cv cG cop
      vx cv cC wceq vk vx copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv
      vy cv vn cv vm cv cG cop vx cv cB wceq vj vx copab cz cres cseqz co cfv
      wcel vy cv vn cv vm cv cG cop vx cv cC wceq vk vx copab cz cres cseqz co
      cfv wcel cA vm cv vn cv cfz co wceq vn cv vm cv cG cop vx cv cB wceq vj
      vx copab cz cres cseqz co cfv vn cv vm cv cG cop vx cv cC wceq vk vx
      copab cz cres cseqz co cfv vy cv vn cv vm cv cG cop vx cv cB wceq vj vx
      copab cz cres cseqz co vm cv cG cop vx cv cC wceq vk vx copab cz cres
      cseqz co vx cv cB wceq vj vx copab cz cres vx cv cC wceq vk vx copab cz
      cres vm cv cG cop cseqz vx cv cB wceq vj vx copab vx cv cC wceq vk vx
      copab wceq vx cv cB wceq vj vx copab cz cres vx cv cC wceq vk vx copab cz
      cres wceq vx cv cB wceq vx cv cC wceq vj vx vk vk vx cB cbvprod.1 hbeleq
      vj vx cC cbvprod.2 hbeleq vj vk weq cB cC vx cv cbvprod.3 eqeq2d cbvopab1
      vx cv cB wceq vj vx copab vx cv cC wceq vk vx copab cz reseq1 ax-mp
      opreq2i fveq1i eleq2i anbi2i rexbii exbii abbii vy vx cA cB vj vm vn cG
      df-prod vy vx cA cC vk vm vn cG df-prod 3eqtr4i $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A m n x y $. $d C m n x y $. $d G m n x y $. $d H m n x y $.
    $d k m n x y $.
    $( Equality theorem for a composite. $)
    prodeq3 $p |- ( G = H ->  prod_ k e. A G C = prod_ k e. A H C ) $=
      cG cH wceq cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cC
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab cA vm cv vn cv cfz co wceq vx cv vn cv vm cv cH cop vy cv cC
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vx cab cA cC vk cG cprd cA cC vk cH cprd cG cH wceq cA vm cv vn cv
      cfz co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex cA vm cv vn cv cfz co
      wceq vx cv vn cv vm cv cH cop vy cv cC wceq vk vy copab cz cres cseqz co
      cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cG cH wceq cA vm cv vn cv cfz
      co wceq vx cv vn cv vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex cA vm cv vn cv cfz co wceq vx cv vn
      cv vm cv cH cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa vn
      vm cv cuz cfv wrex vm cG cH wceq cA vm cv vn cv cfz co wceq vx cv vn cv
      vm cv cG cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel wa cA vm
      cv vn cv cfz co wceq vx cv vn cv vm cv cH cop vy cv cC wceq vk vy copab
      cz cres cseqz co cfv wcel wa vn vm cv cuz cfv cG cH wceq vx cv vn cv vm
      cv cG cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel vx cv vn cv
      vm cv cH cop vy cv cC wceq vk vy copab cz cres cseqz co cfv wcel cA vm cv
      vn cv cfz co wceq cG cH wceq vn cv vm cv cG cop vy cv cC wceq vk vy copab
      cz cres cseqz co cfv vn cv vm cv cH cop vy cv cC wceq vk vy copab cz cres
      cseqz co cfv vx cv cG cH wceq vn cv vm cv cG cop vy cv cC wceq vk vy
      copab cz cres cseqz co vm cv cH cop vy cv cC wceq vk vy copab cz cres
      cseqz co cG cH wceq vm cv cG cop vm cv cH cop vy cv cC wceq vk vy copab
      cz cres cseqz cG cH vm cv opeq2 opreq1d fveq1d eleq2d anbi2d rexbidv
      exbidv abbidv vx vy cA cC vk vm vn cG df-prod vx vy cA cC vk vm vn cH
      df-prod 3eqtr4g $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A k $.
    prodeq123i.1 $e |- A = B  $.
    prodeq123i.2 $e |- G = H  $.
    prodeq123i.3 $e |- ( k e. A -> C = D ) $.
    prodeq123i.4 $e |- G e. F $.
    $( Conditions for two composites to be equal. $)
    prodeq123i $p |-  prod_ k e. A G C = prod_ k e. B H D $=
      cC cD wceq cA cC vk cG cprd cB cD vk cH cprd wceq vk cA cC cD wceq vk cA
      wral cA cC vk cG cprd cA cD vk cG cprd cB cD vk cH cprd cA cC cD cF vk cG
      prodeq123i.4 prodeq2 cA cD vk cG cprd cB cD vk cG cprd cB cD vk cH cprd
      cA cB wceq cA cD vk cG cprd cB cD vk cG cprd wceq prodeq123i.1 cA cB cD
      vk cG prodeq1 ax-mp cG cH wceq cB cD vk cG cprd cB cD vk cH cprd wceq
      prodeq123i.2 cB cD vk cG cH prodeq3 ax-mp eqtri syl6eq prodeq123i.3 mprg
      $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${ $d A k $.
    prodeq123d.1 $e |- ( ph -> A = B  ) $.
    prodeq123d.2 $e |- ( ph -> G = H  ) $.
    prodeq123d.3 $e |- ( ph -> A. k e. A C = D ) $.
    prodeq123d.4 $e |- G e. F $.
    $( Conditions for two composites to be equal. $)
    prodeq123d $p |-  ( ph -> prod_ k e. A G C = prod_ k e. B H D ) $=
      wph cA cC vk cG cprd cA cD vk cG cprd cA cD vk cH cprd cB cD vk cH cprd
      wph cC cD wceq vk cA wral cA cC vk cG cprd cA cD vk cG cprd wceq
      prodeq123d.3 cA cC cD cF vk cG prodeq123d.4 prodeq2 syl wph cG cH wceq cA
      cD vk cG cprd cA cD vk cH cprd wceq prodeq123d.2 cA cD vk cG cH prodeq3
      syl wph cA cB wceq cA cD vk cH cprd cB cD vk cH cprd wceq prodeq123d.1 cA
      cB cD vk cH prodeq1 syl 3eqtrd $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    prodeq1d.1 $e |- ( ph -> A = B  ) $.
    $( Conditions for two composites to be equal. $)
    prodeq1d $p |-  ( ph -> prod_ k e. A G C = prod_ k e. B G C ) $=
      wph cA cB wceq cA cC vk cG cprd cB cC vk cG cprd wceq prodeq1d.1 cA cB cC
      vk cG prodeq1 syl $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    prodeq2d.2 $e |- ( ph -> G = H  ) $.
    $( Conditions for two composites to be equal. $)
    prodeq2d $p |-  ( ph -> prod_ k e. A G C = prod_ k e. A H C ) $=
      wph cG cH wceq cA cC vk cG cprd cA cC vk cH cprd wceq prodeq2d.2 cA cC vk
      cG cH prodeq3 syl $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${ $d A k $.
    prodeq3d.3 $e |- ( ph -> A. k e. A C = D ) $.
    prodeq3d.4 $e |- G e. F $.
    $( Conditions for two composites to be equal. $)
    prodeq3d $p |-  ( ph -> prod_ k e. A G C = prod_ k e. A G D ) $=
      wph cC cD wceq vk cA wral cA cC vk cG cprd cA cD vk cG cprd wceq
      prodeq3d.3 cA cC cD cF vk cG prodeq3d.4 prodeq2 syl $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A y $. $d B k y $. $d C k $.
    prodeqfv.1 $e |- A e. D $.
    prodeqfv.2 $e |- F = { <. k , y >. | ( k e. B /\ y = A ) } $.
    prodeqfv.3 $e |- G e. F $.
    $( Convert a composite of  function values to a composite of classes
       A(k). $)
    prodeqfv $p |- ( C C_ B
     -> prod_ k e. C G ( F ` k ) = prod_ k e. C G A ) $=
      cC cB wss cC vk cv cF cfv cA vk cF cG cC cB wss vk cv cF cfv cA wceq vk
      cC cC cB wss vk cv cC wcel wa vk cv cB wcel vk cv cF cfv cA wceq cC cB vk
      cv ssel2 vk cv cB wcel vk cv vk cv cB wcel vy cv cA wceq wa vk vy copab
      cfv cA vk cv cF cfv vk cv cB wcel cA cD wcel vk cv vk cv cB wcel vy cv cA
      wceq wa vk vy copab cfv cA wceq prodeqfv.1 vk vy cB cA cD fvopab2 mpan2
      vk cv cF vk cv cB wcel vy cv cA wceq wa vk vy copab prodeqfv.2 fveq1i
      syl5eq syl r19.21aiva prodeqfv.3 prodeq3d $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A m n x y $. $d G m n x y $. $d M m n x y $. $d N m n x y $.
    $d k m n x y $.
    $( Special case of composite over a finite index set. $)
    dffprod $p |- ( N e. ( ZZ>= ` M ) -> prod_ k e. ( M ... N ) G A =
     ( (  <. M , G >. seq ( { <. k , y >. | y = A } |` ZZ ) ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv
      cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv
      cuz cfv wrex vm wex vx cab cN cM cG cop vy cv cA wceq vk vy copab cz cres
      cseqz co cfv cM cN cfz co cA vk cG cprd cN cM cuz cfv wcel cM cN cfz co
      vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cA wceq vk vy
      copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx cN cM
      cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv cN cM cuz cfv wcel
      cM cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv cG cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm
      wex vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv cG cop vy cv cA wceq
      vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm wex vx
      cv cN cM cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel cN cM
      cuz cfv wcel cM cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv cG
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz
      cfv wrex vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm cv cG cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel wa vn vm cv cuz cfv wrex vm cN
      cM cuz cfv wcel cM cN cfz co vm cv vn cv cfz co wceq vx cv vn cv vm cv cG
      cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa vm cv cM wceq
      vn cv cN wceq wa vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz
      cres cseqz co cfv wcel wa vn vm cv cuz cfv cN cM cuz cfv wcel cM cN cfz
      co vm cv vn cv cfz co wceq vm cv cM wceq vn cv cN wceq wa vx cv vn cv vm
      cv cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel cN cM cuz
      cfv wcel cM cN cfz co vm cv vn cv cfz co wceq cM vm cv wceq cN vn cv wceq
      wa vm cv cM wceq vn cv cN wceq wa cN cM cuz cfv wcel vn cv cvv wcel cM cN
      cfz co vm cv vn cv cfz co wceq cM vm cv wceq cN vn cv wceq wa wb vn
      visset cvv vm cv vn cv cM cN fzopth mpan2 cM vm cv wceq vm cv cM wceq cN
      vn cv wceq vn cv cN wceq cM vm cv eqcom cN vn cv eqcom anbi12i syl6bb
      anbi1d rexbidv exbidv cN cM cuz cfv wcel vm cv cM wceq vn cv cN wceq wa
      vm cv vn cv cle wbr vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz
      cres cseqz co cfv wcel wa wa vn cz wrex vm cz wrex vx cv cN cM cG cop vy
      cv cA wceq vk vy copab cz cres cseqz co cfv wcel vm cv cM wceq vn cv cN
      wceq wa vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa vn vm cv cuz cfv wrex vm wex cN cM cuz cfv wcel vm cv cM
      wceq vn cv cN wceq wa vm cv vn cv cle wbr vx cv vn cv vm cv cG cop vy cv
      cA wceq vk vy copab cz cres cseqz co cfv wcel wa wa vn cz wrex vm cz wrex
      cM cN cle wbr vx cv cN cM cG cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa vx cv cN cM cG cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel cM cz wcel cN cz wcel vm cv cM wceq vn cv cN wceq wa vm cv vn
      cv cle wbr vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres
      cseqz co cfv wcel wa wa vn cz wrex vm cz wrex cM cN cle wbr vx cv cN cM
      cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa wb cN cM
      cuz cfv wcel vm cv vn cv cle wbr vx cv vn cv vm cv cG cop vy cv cA wceq
      vk vy copab cz cres cseqz co cfv wcel wa cM vn cv cle wbr vx cv vn cv cM
      cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa cM cN cle
      wbr vx cv cN cM cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv
      wcel wa vm vn cM cN cz cz vm cv cM wceq vm cv vn cv cle wbr cM vn cv cle
      wbr vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz co
      cfv wcel vx cv vn cv cM cG cop vy cv cA wceq vk vy copab cz cres cseqz co
      cfv wcel vm cv cM vn cv cle breq1 vm cv cM wceq vn cv vm cv cG cop vy cv
      cA wceq vk vy copab cz cres cseqz co cfv vn cv cM cG cop vy cv cA wceq vk
      vy copab cz cres cseqz co cfv vx cv vm cv cM wceq vn cv vm cv cG cop vy
      cv cA wceq vk vy copab cz cres cseqz co cM cG cop vy cv cA wceq vk vy
      copab cz cres cseqz co vm cv cM wceq vm cv cG cop cM cG cop vy cv cA wceq
      vk vy copab cz cres cseqz vm cv cM cG opeq1 opreq1d fveq1d eleq2d anbi12d
      vn cv cN wceq cM vn cv cle wbr cM cN cle wbr vx cv vn cv cM cG cop vy cv
      cA wceq vk vy copab cz cres cseqz co cfv wcel vx cv cN cM cG cop vy cv cA
      wceq vk vy copab cz cres cseqz co cfv wcel vn cv cN cM cle breq2 vn cv cN
      wceq vn cv cM cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv cN cM
      cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv vx cv vn cv cN cM
      cG cop vy cv cA wceq vk vy copab cz cres cseqz co fveq2 eleq2d anbi12d
      ceqsrex2v cM cN eluzel2 cM cN eluzelz sylanc cN cM cuz cfv wcel cM cN cle
      wbr vx cv cN cM cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv
      wcel cM cN eluzle biantrurd bitr4d vm cv cM wceq vn cv cN wceq wa vx cv
      vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel wa
      vn vm cv cuz cfv wrex vm wex vm cv vn cv cle wbr vm cv cM wceq vn cv cN
      wceq wa vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa wa vn cz wrex vm cz wrex vm cv cM wceq vn cv cN wceq wa vm
      cv vn cv cle wbr vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz
      cres cseqz co cfv wcel wa wa vn cz wrex vm cz wrex vm cv cM wceq vn cv cN
      wceq wa vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa vm vn 2rexuz vm cv vn cv cle wbr vm cv cM wceq vn cv cN
      wceq wa vx cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz
      co cfv wcel wa wa vm cv cM wceq vn cv cN wceq wa vm cv vn cv cle wbr vx
      cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel
      wa wa vm vn cz cz vm cv vn cv cle wbr vm cv cM wceq vn cv cN wceq wa vx
      cv vn cv vm cv cG cop vy cv cA wceq vk vy copab cz cres cseqz co cfv wcel
      an12 2rexbii bitri syl5bb bitrd abbi1dv vx vy cM cN cfz co cA vk vm vn cG
      df-prod syl5eq $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d F k y $. $d G y $. $d M y $. $d N y $.
    fprodserz.1 $e |-   F e. A $.
    fprodserz.2 $e |-   G e. B $.
    $( A finite composite expressed in terms of a partial composite of
       an infinite series. $)
    fprodserz $p |- ( N e. ( ZZ>= ` M ) ->
      prod_ k e. ( M ... N ) G ( F ` k ) = ( ( <. M , G >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vk cv cF cfv vk cG cprd cN cM cG cop vy
      cv vk cv cF cfv wceq vk vy copab cz cres cseqz co cfv cN cM cG cop cF
      cseqz co cfv vy vk cv cF cfv vk cG cM cN dffprod cN cM cuz cfv wcel cN cM
      cG cop vy cv vk cv cF cfv wceq vk vy copab cz cres cseqz co cM cG cop cF
      cseqz co cN cM cuz cfv wcel cM cz wcel cM cG cop vy cv vk cv cF cfv wceq
      vk vy copab cz cres cseqz co cM cG cop cF cseqz co wceq cM cN eluzel2 vy
      cG vk cF cM cG cB fprodserz.2 elisseti cF cA fprodserz.1 elisseti
      seqzres2 syl fveq1d eqtrd $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)

  $}

  ${
    $d F j x $. $d G x $. $d M x $. $d N x $. $d j k x $.
    fprodserzfi.1 $e |- F e. A $.
    fprodserzfi.2 $e |-   G e. B $.
    fprodserzfi.3 $e |- ( x e. F -> A. k x e. F ) $.
    $( Version of ~ fprodserz with a bound-variable hypothesis instead of a
       distinct variable condition. $)
    fprodserzfi $p |- ( N e. ( ZZ>= ` M ) -> prod_ k e. ( M ... N ) G ( F ` k )
                   = ( ( <. M , G >. seq F ) ` N ) ) $=
      cN cM cuz cfv wcel cM cN cfz co vj cv cF cfv vj cG cprd cN cM cG cop cF
      cseqz co cfv cM cN cfz co vk cv cF cfv vk cG cprd cA cB vj cF cG cM cN
      fprodserzfi.1 fprodserzfi.2 fprodserz vx cM cN cfz co vk cv cF cfv vj cv
      cF cfv vk vj cG vx cv vk cv cF cfv wcel vj ax-17 vk vx vj cv cF
      fprodserzfi.3 vx vj wel vk ax-17 hbfv vk cv vj cv cF fveq2 cbvprodi
      syl5eq $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A x y $. $d B k y $. $d G x $. $d M k x y $.
    fprod1.1 $e |- ( k = M -> A = B ) $.
    fprod1.2 $e |- G e. D $.
    $( The finite composite of ` A ( k ) ` from ` k = M ` to ` M `
       (i.e. a composite with only one term) is ` B ` i.e. ` A ( M ) ` . $)
    fprod1i $p |- ( ( B e. C /\ M e. ZZ ) ->
                   prod_ k e. ( M ... M ) G A = B ) $=
      cB cC wcel cM cz wcel wa cM cM cfz co cA vk cG cprd cM cM cG cop vk cv cz
      wcel vy cv cA wceq wa vk vy copab cseqz co cfv cM vk cv cz wcel vy cv cA
      wceq wa vk vy copab cfv cB cB cC wcel cM cz wcel cM cM cfz co cA vk cG
      cprd cM cM cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk
      cG cprd cM cM cG cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co
      cfv cB cC wcel cB cvv wcel cA cvv wcel vk cM cM cfz co wral cM cM cfz co
      vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk cG cprd cM cM cfz
      co cA vk cG cprd wceq cB cC elisset cB cvv wcel cA cvv wcel vk cM cM cfz
      co cB cvv wcel vk cv cM wceq cA cvv wcel vk cv cM cM cfz co wcel vk cv cM
      wceq cA cvv wcel cB cvv wcel vk cv cM wceq cA cB cvv fprod1.1 eleq1d
      biimprcd vk cv cM elfz1eq syl5 r19.21aiv cA cvv wcel vk cM cM cfz co wral
      cM cM cfz co vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA vk
      cD cG cA cvv wcel vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA
      wceq vk cM cM cfz co vk cv cM cM cfz co wcel vk cv cz wcel cA cvv wcel vk
      cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA wceq wi vk cv cM cM
      elfzelz vk cv cz wcel cA cvv wcel vk cv vk cv cz wcel vy cv cA wceq wa vk
      vy copab cfv cA wceq vk vy cz cA cvv fvopab2 ex syl r19.20i fprod1.2
      prodeq3d 3syl cM cz wcel cM cM cuz cfv wcel cM cM cfz co vk cv vk cv cz
      wcel vy cv cA wceq wa vk vy copab cfv vk cG cprd cM cM cG cop vk cv cz
      wcel vy cv cA wceq wa vk vy copab cseqz co cfv wceq cM uzid vx cvv cD vk
      vk cv cz wcel vy cv cA wceq wa vk vy copab cG cM cM vk vy cz cA zex
      opabex2 fprod1.2 vk cv cz wcel vy cv cA wceq wa vk vy vx hbopab1
      fprodserzfi syl sylan9req cM cz wcel cM cM cG cop vk cv cz wcel vy cv cA
      wceq wa vk vy copab cseqz co cfv cM vk cv cz wcel vy cv cA wceq wa vk vy
      copab cfv wceq cB cC wcel cG vk cv cz wcel vy cv cA wceq wa vk vy copab
      cM cG cD fprod1.2 elisseti vk vy cz cA zex opabex2 seqz1 adantl cM cz
      wcel cB cC wcel cM vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cB wceq
      vk vy cM cA cB cz cC vk cv cz wcel vy cv cA wceq wa vk vy copab fprod1.1
      vk cv cz wcel vy cv cA wceq wa vk vy copab eqid fvopab4g ancoms 3eqtrd $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A x y $. $d B k y $. $d G x $. $d M k x $. $d N k x y $.
    fprodp1i.1 $e |- A e. C $.
    fprodp1i.2 $e |- B e. D $.
    fprodp1i.3 $e |- G e. F $.
    fprodp1i.4 $e |- ( k = ( N + 1 ) -> A = B ) $.
    $( The composite of the next term in a finite composite of
       ` A ( k ) `  is the  previous term  composed with
       ` A (  N +  1 )  = B ` . $)
    fprodp1i $p |- ( N e. ( ZZ>= ` M ) -> prod_ k e. ( M ... ( N + 1 ) ) G A =
                ( prod_ k e. ( M ... N ) G A G B ) ) $=
      cN cM cuz cfv wcel cM cN c1 caddc co cfz co cA vk cG cprd cN c1 caddc co
      cM cG cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cN cM
      cG cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cN c1
      caddc co vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cG co cM cN cfz
      co cA vk cG cprd cB cG co cN cM cuz cfv wcel cM cN c1 caddc co cfz co vk
      cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk cG cprd cN c1 caddc
      co cM cG cop vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cM
      cN c1 caddc co cfz co cA vk cG cprd cN cM cuz cfv wcel cN c1 caddc co cM
      cuz cfv wcel cM cN c1 caddc co cfz co vk cv vk cv cz wcel vy cv cA wceq
      wa vk vy copab cfv vk cG cprd cN c1 caddc co cM cG cop vk cv cz wcel vy
      cv cA wceq wa vk vy copab cseqz co cfv wceq cM cN peano2uz vx cvv cvv vk
      vk cv cz wcel vy cv cA wceq wa vk vy copab cG cM cN c1 caddc co vk vy cz
      cA zex opabex2 cG cF fprodp1i.3 elisseti vk cv cz wcel vy cv cA wceq wa
      vk vy vx hbopab1 fprodserzfi syl vk cv vk cv cz wcel vy cv cA wceq wa vk
      vy copab cfv cA wceq cM cN c1 caddc co cfz co vk cv vk cv cz wcel vy cv
      cA wceq wa vk vy copab cfv vk cG cprd cM cN c1 caddc co cfz co cA vk cG
      cprd wceq vk cM cN c1 caddc co cfz co cM cN c1 caddc co cfz co vk cv vk
      cv cz wcel vy cv cA wceq wa vk vy copab cfv cA cF vk cG fprodp1i.3
      prodeq2 vk cv cz wcel cA cC wcel vk cv vk cv cz wcel vy cv cA wceq wa vk
      vy copab cfv cA wceq vk cv cM cN c1 caddc co cfz co wcel vk vy cz cA cC
      fvopab2 vk cv cM cN c1 caddc co elfzelz fprodp1i.1 sylancl mprg syl5eqr
      cG vk cv cz wcel vy cv cA wceq wa vk vy copab cM cN cG cF fprodp1i.3
      elisseti vk vy cz cA zex opabex2 seqzp1 cN cM cuz cfv wcel cN cM cG cop
      vk cv cz wcel vy cv cA wceq wa vk vy copab cseqz co cfv cM cN cfz co cA
      vk cG cprd cN c1 caddc co vk cv cz wcel vy cv cA wceq wa vk vy copab cfv
      cB cG cN cM cuz cfv wcel cM cN cfz co vk cv vk cv cz wcel vy cv cA wceq
      wa vk vy copab cfv vk cG cprd cN cM cG cop vk cv cz wcel vy cv cA wceq wa
      vk vy copab cseqz co cfv cM cN cfz co cA vk cG cprd vx cvv cF vk vk cv cz
      wcel vy cv cA wceq wa vk vy copab cG cM cN vk vy cz cA zex opabex2
      fprodp1i.3 vk cv cz wcel vy cv cA wceq wa vk vy vx hbopab1 fprodserzfi vk
      cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA wceq cM cN cfz co vk
      cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv vk cG cprd cM cN cfz co
      cA vk cG cprd wceq vk cM cN cfz co cM cN cfz co vk cv vk cv cz wcel vy cv
      cA wceq wa vk vy copab cfv cA cF vk cG fprodp1i.3 prodeq2 vk cv cz wcel
      cA cC wcel vk cv vk cv cz wcel vy cv cA wceq wa vk vy copab cfv cA wceq
      vk cv cM cN cfz co wcel vk vy cz cA cC fvopab2 vk cv cM cN elfzelz
      fprodp1i.1 sylancl mprg syl5reqr cN cM cuz cfv wcel cN cz wcel cN c1
      caddc co cz wcel cN c1 caddc co vk cv cz wcel vy cv cA wceq wa vk vy
      copab cfv cB wceq cM cN eluzelz cN peano2z vk vy cN c1 caddc co cA cB cz
      vk cv cz wcel vy cv cA wceq wa vk vy copab fprodp1i.4 vk cv cz wcel vy cv
      cA wceq wa vk vy copab eqid cB cD fprodp1i.2 elisseti fvopab4 3syl
      opreq12d 3eqtrd $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A j y $. $d B j x $. $d G y $. $d M j k x $. $d M j k y $.
    fprod1fi.2 $e |- G e. D $.
    fprod1fi.3 $e |- ( x e. B -> A. k x e. B ) $.
    fprod1fi.4 $e |- ( k = M -> A = B ) $.
    $( The finite composite of a term ` A (  k ) ` from ` M ` to ` M `
       (i.e. a  composite with only  one term) is  ` A ( M  ) = B  ` ,
       where ` k ` is effectively not free in ` B ` . $)
    fprod1fi $p |- ( ( B e. C /\ M e. ZZ )
       -> prod_ k e. ( M ... M ) G A = B ) $=
      cB cC wcel cM cz wcel wa cM cM cfz co vk vj cv cA csb vj cG cprd cB cM cM
      cfz co cA vk cG cprd vk vj cv cA csb cB cC cD vj cG cM vk vj vx cM cA cB
      vx cv cM wcel vk ax-17 fprod1fi.3 fprod1fi.4 csbhypf fprod1fi.2 fprod1i
      vy cM cM cfz co cA vk vj cv cA csb vk vj cG vy cv cA wcel vj ax-17 vk vy
      vj cv cA vj visset vy vj wel vk ax-17 hbcsb1 vk vj cv cA csbeq1a cbvprodi
      syl5eq $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A x y $. $d G x $. $d M x $. $d k x y $.
    fprod1slem.1 $e |- A e. B $.
    fprod1slem.2 $e |- G e. D $.
    $( Lemma for ~ fsum1s . $)
    fprod1slem $p |- ( M e. ZZ ->
                    prod_ k e. ( M ... M ) G A = [_ M / k ]_ A ) $=
      vx cv vx cv cfz co cA vk cG cprd vk vx cv cA csb wceq cM cM cfz co cA vk
      cG cprd vk cM cA csb wceq vx cM cz vx cv cM wceq vx cv vx cv cfz co cA vk
      cG cprd cM cM cfz co cA vk cG cprd vk vx cv cA csb vk cM cA csb vx cv cM
      wceq vx cv vx cv cfz co cM cM cfz co cA vk cG vx cv cM wceq vx cv vx cv
      cfz co cM cM cfz co wceq vx cv cM vx cv cM cfz opreq12 anidms prodeq1d vk
      vx cv cM cA csbeq1 eqeq12d vk vx cv cA csb cvv wcel vx cv cz wcel vx cv
      vx cv cfz co cA vk cG cprd vk vx cv cA csb wceq vk vx cv cA vx visset cA
      cB fprod1slem.1 elisseti csbex vy cA vk vx cv cA csb cvv cD vk cG vx cv
      fprod1slem.2 vk vy vx cv cA vx visset vy vx wel vk ax-17 hbcsb1 vk vx cv
      cA csbeq1a fprod1fi mpan vtoclga $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A x $. $d M k $. $d k y $.
    fprod1s.1 $e |- G e. D $.
    $( The finite composite of a sequence ` A  ( k ) ` from ` M ` to `
       M ` (i.e. a composite with only one term) is ` A ( M ) ` . $)
    fprod1s $p |- ( ( M e. ZZ /\ A. k e. ( M ... M ) A e. B ) ->
                    prod_ k e. ( M ... M ) G A = [_ M / k ]_ A ) $=
      cM cz wcel cA cvv wcel vk cM cM cfz co wral cM cM cfz co cA vk cG cprd vk
      cM cA csb wceq cA cB wcel vk cM cM cfz co wral cM cz wcel cA cvv wcel vk
      cM cM cfz co wral wa cM cM cfz co cA cvv wcel vx cA crab vk cG cprd vk cM
      cA cvv wcel vx cA crab csb cM cM cfz co cA vk cG cprd vk cM cA csb cM cz
      wcel cM cM cfz co cA cvv wcel vx cA crab vk cG cprd vk cM cA cvv wcel vx
      cA crab csb wceq cA cvv wcel vk cM cM cfz co wral cA cvv wcel vx cA crab
      cvv cD vk cG cM vx cA class2set fprod1s.1 fprod1slem adantr cA cvv wcel
      vk cM cM cfz co wral cM cM cfz co cA cvv wcel vx cA crab vk cG cprd cM cM
      cfz co cA vk cG cprd wceq cM cz wcel cA cvv wcel vk cM cM cfz co wral cM
      cM cfz co cA cvv wcel vx cA crab cA vk cD cG cA cvv wcel cA cvv wcel vx
      cA crab cA wceq vk cM cM cfz co vx cA cvv class2seteq r19.20si fprod1s.1
      prodeq3d adantl cM cz wcel cA cvv wcel vk cM cM cfz co wral vk cM cA cvv
      wcel vx cA crab csb vk cM cA csb wceq cM cz wcel cA cvv wcel vk cM cM cfz
      co wral cA cvv wcel vx cA crab cA wceq vk cM wsbc vk cM cA cvv wcel vx cA
      crab csb vk cM cA csb wceq cM cz wcel cA cvv wcel vk cM cM cfz co wral cA
      cvv wcel vk cM wsbc cA cvv wcel vx cA crab cA wceq vk cM wsbc cA cvv wcel
      vk cM fz1sbc vy vy weq cM cz wcel cA cvv wcel vk cM wsbc cA cvv wcel vx
      cA crab cA wceq vk cM wsbc wi vy equid vy vy weq cA cvv wcel cA cvv wcel
      vx cA crab cA wceq vk cM cz cA cvv wcel cA cvv wcel vx cA crab cA wceq wi
      vy vy weq vx cA cvv class2seteq a1i sbc19.20dv mpan sylbid vk cM cA cvv
      wcel vx cA crab cA cz sbceqdig sylibd imp 3eqtr3d cA cB wcel cA cvv wcel
      vk cM cM cfz co cA cB elisset r19.20si sylan2 $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)

    ${
      $d M k $.
      $( The finite composite of a sequence ` A ( k ) ` from ` M ` to ` M `
         (i.e. a composite with only one term) is ` A ( M ) ` . $)
      fprod1s2 $p |- ( ( M e. ZZ /\ [_ M / k ]_ A e. B ) ->
                    prod_ k e. ( M ... M ) G A = [_ M / k ]_ A ) $=
        cM cz wcel vk cM cA csb cB wcel cA cvv wcel vk cM cM cfz co wral cM cM
        cfz co cA vk cG cprd vk cM cA csb wceq cM cz wcel vk cM cA csb cB wcel
        cA cvv wcel vk cM cM cfz co wral cM cz wcel cA cvv wcel vk cM cM cfz co
        wral vk cM cA csb cvv wcel vk cM cA csb cB wcel cM cz wcel cA cvv wcel
        vk cM cM cfz co wral cA cvv wcel vk cM wsbc vk cM cA csb cvv wcel cA
        cvv wcel vk cM fz1sbc vk cM cA cvv cz sbcel1g bitrd vk cM cA csb cB
        elisset syl5bir imp cA cvv cD vk cG cM fprod1s.1 fprod1s syldan $.
        $( [20-Sep-2010] $) $( [5-Sep-2010] $)
    $}
  $}

  ${
    $d M k $.
    $( The finite composite of a sequence ` A  ( k ) ` from ` M ` to `
       M ` (i.e. a composite with only one term) is ` A ( M ) ` . $)
    fprod1s1 $p |- ( ( G e. D /\ M e. ZZ /\ A. k e. ( M ... M ) A e. B ) ->
                    prod_ k e. ( M ... M ) G A = [_ M / k ]_ A ) $=
      cG cD wcel cM cz wcel cA cB wcel vk cM cM cfz co wral cM cM cfz co cA vk
      cG cprd vk cM cA csb wceq cG cD wcel cG cvv wcel cM cz wcel cA cB wcel vk
      cM cM cfz co wral cM cM cfz co cA vk cG cprd vk cM cA csb wceq wi wi cG
      cD elisset cG cvv wcel cM cz wcel cA cB wcel vk cM cM cfz co wral cM cM
      cfz co cA vk cG cprd vk cM cA csb wceq wi wi cM cz wcel cA cB wcel vk cM
      cM cfz co wral cM cM cfz co cA vk cG cvv wcel cG caddc cif cprd vk cM cA
      csb wceq wi wi cG caddc cG cG cvv wcel cG caddc cif wceq cA cB wcel vk cM
      cM cfz co wral cM cM cfz co cA vk cG cprd vk cM cA csb wceq wi cA cB wcel
      vk cM cM cfz co wral cM cM cfz co cA vk cG cvv wcel cG caddc cif cprd vk
      cM cA csb wceq wi cM cz wcel cG cG cvv wcel cG caddc cif wceq cM cM cfz
      co cA vk cG cprd vk cM cA csb wceq cM cM cfz co cA vk cG cvv wcel cG
      caddc cif cprd vk cM cA csb wceq cA cB wcel vk cM cM cfz co wral cG cG
      cvv wcel cG caddc cif wceq cM cM cfz co cA vk cG cprd cM cM cfz co cA vk
      cG cvv wcel cG caddc cif cprd vk cM cA csb cM cM cfz co cA vk cG cG cvv
      wcel cG caddc cif prodeq3 eqeq1d imbi2d imbi2d cM cz wcel cA cB wcel vk
      cM cM cfz co wral cM cM cfz co cA vk cG cvv wcel cG caddc cif cprd vk cM
      cA csb wceq cA cB cvv vk cG cvv wcel cG caddc cif cM cG caddc cvv addex
      elimel fprod1s ex dedth syl 3imp $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A j z $. $d B x z $. $d G z $. $d M z $. $d N k z $.
    $d j k z $. $d k x z $. $d B j $. $d M j $. $d N j $.
    fprodp1fi.1 $e |- A e. C $.
    fprodp1fi.2 $e |- B e. D $.
    fprodp1fi.3 $e |- ( x e. B -> A. k x e. B ) $.
    fprodp1fi.4 $e |- ( k = ( N + 1 ) -> A = B ) $.
    fprodp1fi.5 $e |- G e. F $.
    $( The composite of the next term in a finite composite of ` A ( k ) ` is
       the previous term composed with ` A ( N + 1 ) = B ` . $)
    fprodp1fi $p |- ( N e. ( ZZ>= ` M ) -> prod_ k e. ( M ... ( N + 1 ) ) G A =
                ( prod_ k e. ( M ... N ) G A G B ) ) $=
      cN cM cuz cfv wcel cM cN c1 caddc co cfz co vk vj cv cA csb vj cG cprd cM
      cN cfz co vk vj cv cA csb vj cG cprd cB cG co cM cN c1 caddc co cfz co cA
      vk cG cprd cM cN cfz co cA vk cG cprd cB cG co vk vj cv cA csb cB cvv cD
      vj cF cG cM cN vk vj cv cA vj visset cA cC fprodp1fi.1 elisseti csbex
      fprodp1fi.2 fprodp1fi.5 vk vj vz cN c1 caddc co cA cB vz cv cN c1 caddc
      co wcel vk ax-17 vk vx vz cB fprodp1fi.3 hblem fprodp1fi.4 csbhypf
      fprodp1i vz cM cN c1 caddc co cfz co cA vk vj cv cA csb vk vj cG vz cv cA
      wcel vj ax-17 vk vz vj cv cA vj visset vz vj wel vk ax-17 hbcsb1 vk vj cv
      cA csbeq1a cbvprodi cM cN cfz co cA vk cG cprd cM cN cfz co vk vj cv cA
      csb vj cG cprd cB cG vz cM cN cfz co cA vk vj cv cA csb vk vj cG vz cv cA
      wcel vj ax-17 vk vz vj cv cA vj visset vz vj wel vk ax-17 hbcsb1 vk vj cv
      cA csbeq1a cbvprodi opreq1i 3eqtr4g $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A j x $. $d G j $. $d M j $. $d N j $. $d j k x $.
    fprodp1slem.1 $e |- A e. B $.
    fprodp1slem.2 $e |- G e. D $.
    $( Lemma for ~ fprodp1s . $)
    fprodp1slem $p |- ( N e. ( ZZ>= ` M ) -> prod_ k e. ( M ... ( N + 1 ) ) G A
           = ( prod_ k e. ( M ... N ) G A G [_ ( N + 1 ) / k ]_ A ) ) $=
      cM vj cv c1 caddc co cfz co cA vk cG cprd cM vj cv cfz co cA vk cG cprd
      vk vj cv c1 caddc co cA csb cG co wceq cM cN c1 caddc co cfz co cA vk cG
      cprd cM cN cfz co cA vk cG cprd vk cN c1 caddc co cA csb cG co wceq vj cN
      cM cuz cfv vj cv cN wceq cM vj cv c1 caddc co cfz co cA vk cG cprd cM cN
      c1 caddc co cfz co cA vk cG cprd cM vj cv cfz co cA vk cG cprd vk vj cv
      c1 caddc co cA csb cG co cM cN cfz co cA vk cG cprd vk cN c1 caddc co cA
      csb cG co vj cv cN wceq cM vj cv c1 caddc co cfz co cM cN c1 caddc co cfz
      co cA vk cG vj cv cN wceq vj cv c1 caddc co cN c1 caddc co cM cfz vj cv
      cN c1 caddc opreq1 opreq2d prodeq1d vj cv cN wceq cM vj cv cfz co cA vk
      cG cprd cM cN cfz co cA vk cG cprd vk vj cv c1 caddc co cA csb vk cN c1
      caddc co cA csb cG vj cv cN wceq cM vj cv cfz co cM cN cfz co cA vk cG vj
      cv cN cM cfz opreq2 prodeq1d vj cv cN wceq vk vj cv c1 caddc co cN c1
      caddc co cA vj cv cN c1 caddc opreq1 csbeq1d opreq12d eqeq12d vx cA vk vj
      cv c1 caddc co cA csb cB cvv vk cD cG cM vj cv fprodp1slem.1 vk vj cv c1
      caddc co cA vj cv c1 caddc oprex cA cB fprodp1slem.1 elisseti csbex vk vx
      vj cv c1 caddc co cA vj cv c1 caddc oprex vx cv vj cv c1 caddc co wcel vk
      ax-17 hbcsb1 vk vj cv c1 caddc co cA csbeq1a fprodp1slem.2 fprodp1fi
      vtoclga $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d A x $. $d M k $. $d N k $. $d k x $.
    fprodp1s.1 $e |- G e. D $.
    $( The composite of the next term in a finite sum of ` A ( k ) ` is the
       previous term composed with ` A ( N + 1 ) ` . $)
    fprodp1s $p |- ( ( N e. ( ZZ>= ` M )
               /\ A. k e. ( M ... ( N + 1 ) ) A e. B )
            -> prod_ k e. ( M ... ( N + 1 ) ) G A =
                ( prod_ k e. ( M ... N ) G A G [_ ( N + 1 ) / k ]_ A ) ) $=
      cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral cM cN c1
      caddc co cfz co cA vk cG cprd cM cN cfz co cA vk cG cprd vk cN c1 caddc
      co cA csb cG co wceq cA cB wcel vk cM cN c1 caddc co cfz co wral cN cM
      cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral wa cM cN c1
      caddc co cfz co cA cvv wcel vx cA crab vk cG cprd cM cN cfz co cA cvv
      wcel vx cA crab vk cG cprd vk cN c1 caddc co cA cvv wcel vx cA crab csb
      cG co cM cN c1 caddc co cfz co cA vk cG cprd cM cN cfz co cA vk cG cprd
      vk cN c1 caddc co cA csb cG co cN cM cuz cfv wcel cM cN c1 caddc co cfz
      co cA cvv wcel vx cA crab vk cG cprd cM cN cfz co cA cvv wcel vx cA crab
      vk cG cprd vk cN c1 caddc co cA cvv wcel vx cA crab csb cG co wceq cA cvv
      wcel vk cM cN c1 caddc co cfz co wral cA cvv wcel vx cA crab cvv cD vk cG
      cM cN vx cA class2set fprodp1s.1 fprodp1slem adantr cA cvv wcel vk cM cN
      c1 caddc co cfz co wral cM cN c1 caddc co cfz co cA cvv wcel vx cA crab
      vk cG cprd cM cN c1 caddc co cfz co cA vk cG cprd wceq cN cM cuz cfv wcel
      cA cvv wcel vk cM cN c1 caddc co cfz co wral cM cN c1 caddc co cfz co cA
      cvv wcel vx cA crab cA vk cD cG cA cvv wcel cA cvv wcel vx cA crab cA
      wceq vk cM cN c1 caddc co cfz co vx cA cvv class2seteq r19.20si
      fprodp1s.1 prodeq3d adantl cN cM cuz cfv wcel cA cvv wcel vk cM cN c1
      caddc co cfz co wral wa cM cN cfz co cA cvv wcel vx cA crab vk cG cprd cM
      cN cfz co cA vk cG cprd vk cN c1 caddc co cA cvv wcel vx cA crab csb vk
      cN c1 caddc co cA csb cG cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc
      co cfz co wral wa cM cN cfz co cA cvv wcel vx cA crab cA vk cD cG cN cM
      cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral cA cvv wcel vx
      cA crab cA wceq vk cM cN cfz co wral cN cM cuz cfv wcel cA cvv wcel cA
      cvv wcel vx cA crab cA wceq vk cM cN c1 caddc co cfz co cM cN cfz co cN
      cM cuz cfv wcel vk cv cM cN cfz co wcel vk cv cM cN c1 caddc co cfz co
      wcel cA cvv wcel cA cvv wcel vx cA crab cA wceq cN cM cuz cfv wcel cM cN
      cfz co cM cN c1 caddc co cfz co vk cv cM cz wcel cN cz wcel cM cN cfz co
      cM cN c1 caddc co cfz co wss cN cM cuz cfv wcel cM cN fzssp1 cM cN
      eluzel2 cM cN eluzelz sylanc sseld cA cvv wcel cA cvv wcel vx cA crab cA
      wceq wi cN cM cuz cfv wcel vx cA cvv class2seteq a1i imim12d r19.20dv2
      imp fprodp1s.1 prodeq3d cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc
      co cfz co wral wa cA cvv wcel vx cA crab cA wceq vk cN c1 caddc co wsbc
      vk cN c1 caddc co cA cvv wcel vx cA crab csb vk cN c1 caddc co cA csb
      wceq cN cM cuz cfv wcel cA cvv wcel vk cM cN c1 caddc co cfz co wral wa
      cA cvv wcel vk cN c1 caddc co wsbc cA cvv wcel vx cA crab cA wceq vk cN
      c1 caddc co wsbc cN c1 caddc co cM cN c1 caddc co cfz co wcel cA cvv wcel
      vk cM cN c1 caddc co cfz co wral cA cvv wcel vk cN c1 caddc co wsbc cN cM
      cuz cfv wcel cA cvv wcel vk cN c1 caddc co cM cN c1 caddc co cfz co
      ra4sbca cN cM cuz cfv wcel cN c1 caddc co cM cuz cfv wcel cN c1 caddc co
      cM cN c1 caddc co cfz co wcel cM cN peano2uz cM cN c1 caddc co eluzfz2
      syl sylan vx vx weq cN c1 caddc co cvv wcel cA cvv wcel vk cN c1 caddc co
      wsbc cA cvv wcel vx cA crab cA wceq vk cN c1 caddc co wsbc wi vx equid cN
      c1 caddc oprex vx vx weq cA cvv wcel cA cvv wcel vx cA crab cA wceq vk cN
      c1 caddc co cvv cA cvv wcel cA cvv wcel vx cA crab cA wceq wi vx vx weq
      vx cA cvv class2seteq a1i sbc19.20dv mp2an syl cN c1 caddc co cvv wcel cA
      cvv wcel vx cA crab cA wceq vk cN c1 caddc co wsbc vk cN c1 caddc co cA
      cvv wcel vx cA crab csb vk cN c1 caddc co cA csb wceq wb cN c1 caddc
      oprex vk cN c1 caddc co cA cvv wcel vx cA crab cA cvv sbceqdig ax-mp
      sylib opreq12d 3eqtr3d cA cB wcel cA cvv wcel vk cM cN c1 caddc co cfz co
      cA cB elisset r19.20si sylan2 $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d M k $. $d N k $.
    $( The composite of the next term in a finite composite of ` A ( k ) `
       is the previous term composed with ` A ( N + 1 ) ` . ( Closed form
       of ~ fprodp1s .) $)
    fprodp1s1 $p |- ( ( G e. D /\ N e. ( ZZ>= ` M ) /\
        A. k e. ( M ... ( N + 1 ) ) A e. B )
            -> prod_ k e. ( M ... ( N + 1 ) ) G A =
                ( prod_ k e. ( M ... N ) G A G [_ ( N + 1 ) / k ]_ A ) ) $=
      cG cD wcel cN cM cuz cfv wcel cA cB wcel vk cM cN c1 caddc co cfz co wral
      cM cN c1 caddc co cfz co cA vk cG cprd cM cN cfz co cA vk cG cprd vk cN
      c1 caddc co cA csb cG co wceq cG cD wcel cG cvv wcel cN cM cuz cfv wcel
      cA cB wcel vk cM cN c1 caddc co cfz co wral cM cN c1 caddc co cfz co cA
      vk cG cprd cM cN cfz co cA vk cG cprd vk cN c1 caddc co cA csb cG co wceq
      wi wi cG cD elisset cG cvv wcel cN cM cuz cfv wcel cA cB wcel vk cM cN c1
      caddc co cfz co wral cM cN c1 caddc co cfz co cA vk cG cprd cM cN cfz co
      cA vk cG cprd vk cN c1 caddc co cA csb cG co wceq wi wi cN cM cuz cfv
      wcel cA cB wcel vk cM cN c1 caddc co cfz co wral cM cN c1 caddc co cfz co
      cA vk cG cvv wcel cG caddc cif cprd cM cN cfz co cA vk cG cvv wcel cG
      caddc cif cprd vk cN c1 caddc co cA csb cG cvv wcel cG caddc cif co wceq
      wi wi cG caddc cG cG cvv wcel cG caddc cif wceq cA cB wcel vk cM cN c1
      caddc co cfz co wral cM cN c1 caddc co cfz co cA vk cG cprd cM cN cfz co
      cA vk cG cprd vk cN c1 caddc co cA csb cG co wceq wi cA cB wcel vk cM cN
      c1 caddc co cfz co wral cM cN c1 caddc co cfz co cA vk cG cvv wcel cG
      caddc cif cprd cM cN cfz co cA vk cG cvv wcel cG caddc cif cprd vk cN c1
      caddc co cA csb cG cvv wcel cG caddc cif co wceq wi cN cM cuz cfv wcel cG
      cG cvv wcel cG caddc cif wceq cM cN c1 caddc co cfz co cA vk cG cprd cM
      cN cfz co cA vk cG cprd vk cN c1 caddc co cA csb cG co wceq cM cN c1
      caddc co cfz co cA vk cG cvv wcel cG caddc cif cprd cM cN cfz co cA vk cG
      cvv wcel cG caddc cif cprd vk cN c1 caddc co cA csb cG cvv wcel cG caddc
      cif co wceq cA cB wcel vk cM cN c1 caddc co cfz co wral cG cG cvv wcel cG
      caddc cif wceq cM cN c1 caddc co cfz co cA vk cG cprd cM cN c1 caddc co
      cfz co cA vk cG cvv wcel cG caddc cif cprd cM cN cfz co cA vk cG cprd vk
      cN c1 caddc co cA csb cG co cM cN cfz co cA vk cG cvv wcel cG caddc cif
      cprd vk cN c1 caddc co cA csb cG cvv wcel cG caddc cif co cM cN c1 caddc
      co cfz co cA vk cG cG cvv wcel cG caddc cif prodeq3 cG cG cvv wcel cG
      caddc cif wceq cM cN cfz co cA vk cG cprd cM cN cfz co cA vk cG cvv wcel
      cG caddc cif cprd vk cN c1 caddc co cA csb vk cN c1 caddc co cA csb cG cG
      cvv wcel cG caddc cif cG cG cvv wcel cG caddc cif wceq id cM cN cfz co cA
      vk cG cG cvv wcel cG caddc cif prodeq3 cG cG cvv wcel cG caddc cif wceq
      vk cN c1 caddc co cA csb eqidd opreq123d eqeq12d imbi2d imbi2d cN cM cuz
      cfv wcel cA cB wcel vk cM cN c1 caddc co cfz co wral cM cN c1 caddc co
      cfz co cA vk cG cvv wcel cG caddc cif cprd cM cN cfz co cA vk cG cvv wcel
      cG caddc cif cprd vk cN c1 caddc co cA csb cG cvv wcel cG caddc cif co
      wceq cA cB cvv vk cG cvv wcel cG caddc cif cM cN cG caddc cvv addex
      elimel fprodp1s ex dedth syl 3imp $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d B y  $. $d M y $. $d N y $. $d k y $.
    $( Relation between ` sum_ ` and ` prod_ ` .  $)
    relsumprd $p |- ( N e. ( ZZ>= ` M ) ->
        sum_ k e. ( M ... N ) B = prod_ k e. ( M ... N ) +  B ) $=
      cN cM cuz cfv wcel cM cN cfz co cB vk csu cN cM caddc cop vy cv cB wceq
      vk vy copab cz cres cseqz co cfv cM cN cfz co cB vk caddc cprd vy cB vk
      cM cN dffsum vy cB vk caddc cM cN dffprod eqtr4d $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d B k $. $d M k $.
    fprod1i2.1 $e |- ( k = M -> A = B ) $.
    $( The finite composite of ` A ( k ) ` from ` k = M ` to ` M `
       (i.e. a composite with only one term) is ` B ` i.e. ` A ( M ) ` . $)
    fprod1i2 $p |- ( ( B e. C /\ M e. ZZ /\ G e. D ) ->
                   prod_ k e. ( M ... M ) G A = B ) $=
      cB cC wcel cM cz wcel cG cD wcel cM cM cfz co cA vk cG cprd cB wceq cG cD
      wcel cB cC wcel cM cz wcel cM cM cfz co cA vk cG cprd cB wceq cG cD wcel
      cG cvv wcel cB cC wcel cM cz wcel cM cM cfz co cA vk cG cprd cB wceq wi
      wi cG cD elisset cG cvv wcel cB cC wcel cM cz wcel cM cM cfz co cA vk cG
      cprd cB wceq wi wi cB cC wcel cM cz wcel cM cM cfz co cA vk cG cvv wcel
      cG caddc cif cprd cB wceq wi wi cG caddc cG cG cvv wcel cG caddc cif wceq
      cM cz wcel cM cM cfz co cA vk cG cprd cB wceq wi cM cz wcel cM cM cfz co
      cA vk cG cvv wcel cG caddc cif cprd cB wceq wi cB cC wcel cG cG cvv wcel
      cG caddc cif wceq cM cM cfz co cA vk cG cprd cB wceq cM cM cfz co cA vk
      cG cvv wcel cG caddc cif cprd cB wceq cM cz wcel cG cG cvv wcel cG caddc
      cif wceq cM cM cfz co cA vk cG cprd cM cM cfz co cA vk cG cvv wcel cG
      caddc cif cprd cB cM cM cfz co cA vk cG cG cvv wcel cG caddc cif prodeq3
      eqeq1d imbi2d imbi2d cB cC wcel cM cz wcel cM cM cfz co cA vk cG cvv wcel
      cG caddc cif cprd cB wceq cA cB cC cvv vk cG cvv wcel cG caddc cif cM
      fprod1i2.1 cG caddc cvv addex elimel fprod1i ex dedth syl com3l 3imp $.
      $( [20-Sep-2010] $) $( [5-Sep-2010] $)
  $}

  ${
    $d B1 k $. $d B2 a k $. $d C k $. $d M k $.
    fprod1b.1 $e |- ( k = M -> A = B1 ) $.
    fprod1b.2 $e |- ( k = ( M + 1 ) -> A = B2 ) $.
    fprod1b.3 $e |- G e. D $.
    $( The finite composite of ` A ( k ) ` from ` k = M ` to ` ( M + 1 ) `
       (i.e. a composite with two terms) is ` ( B1 G B2 ) ` i.e.
       ` ( A ( M ) G A ( M + 1 ) ) ` . $)
    fprod1ib $p |- ( ( B1 e. C /\ B2 e. C /\ M e. ZZ ) ->
                   prod_ k e. ( M ... ( M + 1 ) ) G A = ( B1 G B2 ) ) $=
      cB1 cC wcel cB2 cC wcel cM cz wcel w3a cM cM c1 caddc co cfz co cA vk cG
      cprd cM cM cfz co cA vk cG cprd vk cM c1 caddc co cA csb cG co cB1 cB2 cG
      co cG cD wcel cM cM cuz cfv wcel cA cC wcel vk cM cM c1 caddc co cfz co
      wral cM cM c1 caddc co cfz co cA vk cG cprd cM cM cfz co cA vk cG cprd vk
      cM c1 caddc co cA csb cG co wceq cB1 cC wcel cB2 cC wcel cM cz wcel w3a
      cA cC cD vk cG cM cM fprodp1s1 cG cD wcel cB1 cC wcel cB2 cC wcel cM cz
      wcel w3a fprod1b.3 a1i cM cz wcel cB1 cC wcel cM cM cuz cfv wcel cB2 cC
      wcel cM uzid 3ad2ant3 cB1 cC wcel cB2 cC wcel cM cz wcel w3a cA cC wcel
      vk cM cM c1 caddc co cfz co cB1 cC wcel cB2 cC wcel cM cz wcel w3a vk cv
      cM cM c1 caddc co cfz co wcel cA cB1 wceq cA cB2 wceq wo cA cC wcel cB1
      cC wcel cB2 cC wcel cM cz wcel w3a vk cv cM cM c1 caddc co cfz co wcel vk
      cv cM cM c1 caddc co cpr wcel cA cB1 wceq cA cB2 wceq wo cB1 cC wcel cB2
      cC wcel cM cz wcel w3a cM cM c1 caddc co cfz co cM cM c1 caddc co cpr vk
      cv cM cz wcel cB1 cC wcel cM cM c1 caddc co cfz co cM cM c1 caddc co cpr
      wceq cB2 cC wcel cM fzpr 3ad2ant3 eleq2d vk cv cM cM c1 caddc co cpr wcel
      cB1 cC wcel cB2 cC wcel cM cz wcel w3a cA cB1 wceq cA cB2 wceq wo vk cv
      cM cM c1 caddc co cpr wcel vk cv cM wceq vk cv cM c1 caddc co wceq wo cB1
      cC wcel cB2 cC wcel cM cz wcel w3a cA cB1 wceq cA cB2 wceq wo wi vk cv cM
      cM c1 caddc co vk visset elpr vk cv cM wceq vk cv cM c1 caddc co wceq wo
      cA cB1 wceq cA cB2 wceq wo cB1 cC wcel cB2 cC wcel cM cz wcel w3a vk cv
      cM wceq cA cB1 wceq vk cv cM c1 caddc co wceq cA cB2 wceq fprod1b.1
      fprod1b.2 orim12i a1d sylbi com12 sylbid cB1 cC wcel cB2 cC wcel cA cB1
      wceq cA cB2 wceq wo cA cC wcel wi cM cz wcel cB1 cC wcel cA cB1 wceq cA
      cC wcel cB2 cC wcel cA cB2 wceq cB1 cC cA eleq1a cB2 cC cA eleq1a jaao
      3adant3 syld r19.21aiv syl3anc cB1 cC wcel cB2 cC wcel cM cz wcel w3a cM
      cM cfz co cA vk cG cprd cB1 vk cM c1 caddc co cA csb cB2 cG cB1 cC wcel
      cM cz wcel cM cM cfz co cA vk cG cprd cB1 wceq cB2 cC wcel cA cB1 cC cD
      vk cG cM fprod1b.1 fprod1b.3 fprod1i 3adant2 vk cM c1 caddc co cA csb cB2
      wceq cB1 cC wcel cB2 cC wcel cM cz wcel w3a vk va cM c1 caddc co cA cB2
      cM c1 caddc oprex va cv cB2 wcel vk ax-17 fprod1b.2 csbief a1i opreq12d
      eqtrd $.
      $( [6-Dec-2010] $) $( [22-Nov-2010] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Operation properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Com1 $.

  $( Extend class notation with a class that adds commutativity to semi-groups,
     monoids and so on. $)
  ccm1 $a class Com1 $.


  ${ $d g x y $.
    $( A device to add commutativity to magmas, semi-groups,
       monoids and so on. A commutative group is composed of 5 properties
       (internal operation, commutativity, associativity, existence of
       a neutral element and an inverse. If we switch on
       or off those four properties we get 32 structures. Instead of
       giving a name to those 32 structures, I suggest we use intersected
       classes and speak of ` ( Magma i^i Com1 ) ` or
       ` ( Magma i^i ExId ) ` . $)
    df-com1 $a |- Com1 = { g |  A. x e. dom dom g A. y e. dom dom g
      ( x g y ) = ( y g x ) } $.
  $}

  $c Ass $.

  $( Extend class notation with a device to add associativity to internal
     operations. $)
  cass $a class Ass $.

  ${ $d g x y z $.
  $( A device to add associativity to various sorts of internal operations.
     The definition is meaningful when ` g ` is a magma at least. $)
  df-ass $a |- Ass = { g | A. x e. dom dom g A. y e. dom dom g
    A. z e. dom dom g ( ( x g y ) g z ) = ( x g ( y g z ) ) } $.
  $}

  ${
    iscom.1 $e |- X = dom dom G $.
    ${
      $d G a x y $. $d X a $.
      $( The predicate "is a commutative operation". $)
      iscom $p |- ( G e. A -> ( G e. Com1 <-> A. x e. X A. y e. X
      ( x G y ) = ( y G x ) ) ) $=
        vx cv vy cv va cv co vy cv vx cv va cv co wceq vy va cv cdm cdm wral vx
        va cv cdm cdm wral vx cv vy cv cG co vy cv vx cv cG co wceq vy cX wral
        vx cX wral va cG ccm1 cA va cv cG wceq vx cv vy cv va cv co vy cv vx cv
        va cv co wceq vy va cv cdm cdm wral vx cv vy cv cG co vy cv vx cv cG co
        wceq vy cX wral vx va cv cdm cdm cX va cv cG wceq vx cv va cv cdm cdm
        wcel vx cv cX wcel vx cv vy cv va cv co vy cv vx cv va cv co wceq vy va
        cv cdm cdm wral vx cv vy cv cG co vy cv vx cv cG co wceq vy cX wral va
        cv cG wceq va cv cdm cdm cX vx cv va cv cG wceq cG cdm cdm va cv cdm
        cdm cX va cv cG wceq cG cdm va cv cdm va cv cG wceq va cv cdm cG cdm va
        cv cG dmeq eqcomd dmeqd iscom.1 syl5req eleq2d va cv cG wceq vx cv vy
        cv va cv co vy cv vx cv va cv co wceq vx cv vy cv cG co vy cv vx cv cG
        co wceq vy va cv cdm cdm cX va cv cG wceq vy cv va cv cdm cdm wcel vy
        cv cX wcel vx cv vy cv va cv co vy cv vx cv va cv co wceq vx cv vy cv
        cG co vy cv vx cv cG co wceq va cv cG wceq va cv cdm cdm cX vy cv va cv
        cG wceq cG cdm cdm va cv cdm cdm cX va cv cG wceq cG cdm va cv cdm va
        cv cG wceq va cv cdm cG cdm va cv cG dmeq eqcomd dmeqd iscom.1 syl5req
        eleq2d va cv cG wceq vx cv vy cv va cv co vx cv vy cv cG co vy cv vx cv
        va cv co vy cv vx cv cG co vx cv vy cv va cv cG opreq vy cv vx cv va cv
        cG opreq eqeq12d imbi12d ralbidv2 imbi12d ralbidv2 vx vy va df-com1
        elab2g $.
        $( [20-Sep-2010] $) $( [5-Sep-2010] $)
    $}

    ${
    $d A x y $. $d B y $. $d G x y $. $d X x y $.
    $( The predicate "is a commutative operation". $)
    iscomb $p |- ( ( G e. Com1 /\ A e. X /\ B e. X )
       -> ( A G B ) = ( B G A ) ) $=
      cG ccm1 wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq cG ccm1
      wcel cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq wi wi cG ccm1
      wcel cG ccm1 wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cX wral vx
      cX wral cA cX wcel cB cX wcel cA cB cG co cB cA cG co wceq wi wi vx vy
      ccm1 cG cX iscom.1 iscom cA cX wcel cB cX wcel vx cv vy cv cG co vy cv vx
      cv cG co wceq vy cX wral vx cX wral cA cB cG co cB cA cG co wceq cA cX
      wcel cB cX wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cX wral vx cX
      wral cA cB cG co cB cA cG co wceq wi vx cv vy cv cG co vy cv vx cv cG co
      wceq cA cB cG co cB cA cG co wceq cA vy cv cG co vy cv cA cG co wceq vx
      vy cA cB cX cX vx cv cA wceq vx cv vy cv cG co cA vy cv cG co vy cv vx cv
      cG co vy cv cA cG co vx cv cA vy cv cG opreq1 vx cv cA vy cv cG opreq2
      eqeq12d vy cv cB wceq cA vy cv cG co cA cB cG co vy cv cA cG co cB cA cG
      co vy cv cB cA cG opreq2 vy cv cB cA cG opreq1 eqeq12d rcla42v ex com3r
      syl6bi pm2.43i 3imp $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
    $}
  $}


  ${ $d G g x y z $. $d X g x y z $.
    isass.1 $e |- X = dom dom G $.
    $( The predicate "is an associative operation". $)
    isass $p |- ( G e. A -> ( G e. Ass <-> A. x e. X A. y e. X  A. z e. X
      ( ( x G y ) G z ) = ( x G ( y G z ) ) ) ) $=
      vx cv vy cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg cv co vg cv co
      wceq vz vg cv cdm cdm wral vy vg cv cdm cdm wral vx vg cv cdm cdm wral vx
      cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral
      vy cX wral vx cX wral vg cG cass cA vg cv cG wceq vx cv vy cv vg cv co vz
      cv vg cv co vx cv vy cv vz cv vg cv co vg cv co wceq vz vg cv cdm cdm
      wral vy vg cv cdm cdm wral vx vg cv cdm cdm wral vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm
      wral vx cG cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vy cX wral vx cX wral vg cv cG wceq vx cv vg
      cv cdm cdm wcel vy cv vg cv cdm cdm wcel vz cv vg cv cdm cdm wcel w3a vx
      cv vy cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg cv co vg cv co wceq
      wi vz wal vy wal vx wal vx cv cG cdm cdm wcel vy cv cG cdm cdm wcel vz cv
      cG cdm cdm wcel w3a vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co
      cG co wceq wi vz wal vy wal vx wal vx cv vy cv vg cv co vz cv vg cv co vx
      cv vy cv vz cv vg cv co vg cv co wceq vz vg cv cdm cdm wral vy vg cv cdm
      cdm wral vx vg cv cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm
      cdm wral vg cv cG wceq vx cv vg cv cdm cdm wcel vy cv vg cv cdm cdm wcel
      vz cv vg cv cdm cdm wcel w3a vx cv vy cv vg cv co vz cv vg cv co vx cv vy
      cv vz cv vg cv co vg cv co wceq wi vz wal vx cv cG cdm cdm wcel vy cv cG
      cdm cdm wcel vz cv cG cdm cdm wcel w3a vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq wi vz wal vx vy vg cv cG wceq vx cv vg cv
      cdm cdm wcel vy cv vg cv cdm cdm wcel vz cv vg cv cdm cdm wcel w3a vx cv
      vy cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg cv co vg cv co wceq wi
      vx cv cG cdm cdm wcel vy cv cG cdm cdm wcel vz cv cG cdm cdm wcel w3a vx
      cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq wi vz vg cv
      cG wceq vx cv vg cv cdm cdm wcel vy cv vg cv cdm cdm wcel vz cv vg cv cdm
      cdm wcel w3a vx cv cG cdm cdm wcel vy cv cG cdm cdm wcel vz cv cG cdm cdm
      wcel w3a vx cv vy cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg cv co
      vg cv co wceq vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vg cv cG wceq vx cv vg cv cdm cdm wcel vx cv cG cdm cdm wcel vy cv
      vg cv cdm cdm wcel vy cv cG cdm cdm wcel vz cv vg cv cdm cdm wcel vz cv
      cG cdm cdm wcel vg cv cG wceq vg cv cdm cdm cG cdm cdm vx cv vg cv cG
      wceq vg cv cdm cG cdm vg cv cG dmeq dmeqd eleq2d vg cv cG wceq vg cv cdm
      cdm cG cdm cdm vy cv vg cv cG wceq vg cv cdm cG cdm vg cv cG dmeq dmeqd
      eleq2d vg cv cG wceq vg cv cdm cdm cG cdm cdm vz cv vg cv cG wceq vg cv
      cdm cG cdm vg cv cG dmeq dmeqd eleq2d 3anbi123d vg cv cG wceq vx cv vy cv
      vg cv co vz cv vg cv co vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      vg cv co vg cv co vx cv vy cv vz cv cG co cG co vg cv cG wceq vx cv vy cv
      vg cv co vz cv vg cv co vx cv vy cv cG co vz cv vg cv co vx cv vy cv cG
      co vz cv cG co vg cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG co vz cv
      vg cv vx cv vy cv vg cv cG opreq opreq1d vx cv vy cv cG co vz cv vg cv cG
      opreq eqtrd vg cv cG wceq vx cv vy cv vz cv vg cv co vg cv co vx cv vy cv
      vz cv cG co vg cv co vx cv vy cv vz cv cG co cG co vg cv cG wceq vy cv vz
      cv vg cv co vy cv vz cv cG co vx cv vg cv vy cv vz cv vg cv cG opreq
      opreq2d vx cv vy cv vz cv cG co vg cv cG opreq eqtrd eqeq12d imbi12d
      albidv 2albidv vx cv vy cv vg cv co vz cv vg cv co vx cv vy cv vz cv vg
      cv co vg cv co wceq vx vy vz vg cv cdm cdm vg cv cdm cdm vg cv cdm cdm
      r3al vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vx
      vy vz cG cdm cdm cG cdm cdm cG cdm cdm r3al 3bitr4g vg cv cG wceq vx cv
      vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm
      wral vy cG cdm cdm wral vx cG cdm cdm wral vx cv vy cv cG co vz cv cG co
      vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm wral
      vx cX wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cG cdm cdm wral vy cX wral vx cX wral vx cv vy cv cG co vz cv cG
      co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vg
      cv cG wceq vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm cdm cX cG cdm cdm cX
      wceq vg cv cG wceq cX cG cdm cdm isass.1 eqcomi a1i raleq1d vg cv cG wceq
      vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG
      cdm cdm wral vy cG cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cG cdm cdm wral vy cX wral vx cX vg cv cG wceq
      vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG
      cdm cdm wral vy cG cdm cdm cX cG cdm cdm cX wceq vg cv cG wceq cX cG cdm
      cdm isass.1 eqcomi a1i raleq1d ralbidv vg cv cG wceq vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vx cv vy
      cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vx vy
      cX cX vg cv cG wceq vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co
      cG co wceq vz cG cdm cdm cX cG cdm cdm cX wceq vg cv cG wceq cX cG cdm
      cdm isass.1 eqcomi a1i raleq1d 2ralbidv 3bitrd bitrd vx vy vz vg df-ass
      elab2g $.
      $( [3-Nov-2009] $) $( [1-Nov-2009] $)
  $}

  $c ExId $.

  $( Extend class notation with the class of all the internal operations
     with an identity element. $)
  cexid $a class ExId $.

  ${ $d g x y $.
  $( A device to add an identity element to various sorts
     of internal operations. $)
  df-exid $a |- ExId = { g | E. x e. dom dom g A. y e. dom dom g
    ( ( y g x ) = y /\ ( x g y ) = y ) } $.
  $}

  ${ $d G g x y $. $d X g $.
    isexid.1 $e |- X = dom dom G $.
    $( The predicate ` G ` has a left and right identity element. $)
    isexid $p |- ( G e. A -> ( G e. ExId <-> E. x e. X A. y e. X
      ( ( y G x ) = y /\ ( x G y ) = y ) ) ) $=
      vy cv vx cv vg cv co vy cv wceq vx cv vy cv vg cv co vy cv wceq wa vy vg
      cv cdm cdm wral vx vg cv cdm cdm wrex vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cX wral vx cX wrex vg cG cexid cA vg cv cG
      wceq vy cv vx cv vg cv co vy cv wceq vx cv vy cv vg cv co vy cv wceq wa
      vy vg cv cdm cdm wral vx vg cv cdm cdm wrex vy cv vx cv cG co vy cv wceq
      vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex vy
      cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx
      cX wrex vg cv cG wceq vy cv vx cv vg cv co vy cv wceq vx cv vy cv vg cv
      co vy cv wceq wa vy vg cv cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx vg cv cdm cdm cG cdm cdm
      vg cv cG wceq vg cv cdm cG cdm vg cv cG dmeq dmeqd vg cv cG wceq vy cv vx
      cv vg cv co vy cv wceq vx cv vy cv vg cv co vy cv wceq wa vy cv vx cv cG
      co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy vg cv cdm cdm cG cdm cdm
      vg cv cG wceq vg cv cdm cG cdm vg cv cG dmeq dmeqd vg cv cG wceq vy cv vx
      cv vg cv co vy cv wceq vy cv vx cv cG co vy cv wceq vx cv vy cv vg cv co
      vy cv wceq vx cv vy cv cG co vy cv wceq vg cv cG wceq vy cv vx cv vg cv
      co vy cv vx cv cG co vy cv vy cv vx cv vg cv cG opreq eqeq1d vg cv cG
      wceq vx cv vy cv vg cv co vx cv vy cv cG co vy cv vx cv vy cv vg cv cG
      opreq eqeq1d anbi12d raleq12d rexeq12d vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cG cdm cdm wral vy cv vx cv cG co vy cv wceq
      vx cv vy cv cG co vy cv wceq wa vy cX wral vx cG cdm cdm cX vx cv cG cdm
      cdm wcel vx cv cX wcel vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy
      cv wceq wa vy cG cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG
      co vy cv wceq wa vy cX wral cG cdm cdm cX vx cv cX cG cdm cdm isexid.1
      eqcomi eleq2i vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
      wa vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm
      cdm cX vy cv cG cdm cdm wcel vy cv cX wcel vy cv vx cv cG co vy cv wceq
      vx cv vy cv cG co vy cv wceq wa cG cdm cdm cX vy cv cX cG cdm cdm
      isexid.1 eqcomi eleq2i imbi1i ralbii2 anbi12i rexbii2 syl6bb vx vy vg
      df-exid elab2g $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}



$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Groups and related structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( ` RR `  is a group for addition. $)
  rrisgrp $p |- ( + |` ( RR X. RR ) ) e. Grp $=
    caddc cgr wcel caddc cr cr cxp cres cgr wcel caddc cr cr cxp cres caddc wss
    caddc cr cr cxp cres caddc csubg cfv wcel caddc cgr wcel caddc cr cr cxp
    cres cgr wcel caddc cr cr cxp cres caddc wss w3a readdsubg caddc caddc cr
    cr cxp cres issubg mpbi 3simp2i $.
    $( [22-Dec-2008] $) $( [22-Dec-2008] $)

  $( A way to express the domain of a group. $)
  dmrngrp $p |- ( G e. Grp -> dom G = ( ran G X. ran G ) ) $=
    cG cgr wcel cG crn cG crn cxp cG crn cG wfo cG cdm cG crn cG crn cxp wceq
    cG cG crn cG crn eqid grpfo cG crn cG crn cxp cG crn cG wfo cG crn cG crn
    cxp cG crn cG wf cG cdm cG crn cG crn cxp wceq cG crn cG crn cxp cG crn cG
    fof cG crn cG crn cxp cG crn cG fdm syl syl $.
    $( [9-Jan-2011] $) $( [9-Jan-2011] $)

  $c Magma $.

  $( Extend class notation with the class of all magmas. $)
  cmagm $a class Magma $.

  ${ $d g t $.
    $( A magma is a binary internal operation. $)
    df-mgm $a |- Magma = { g | E. t g : ( t X. t ) --> t } $.
  $}

  ${ $d G g t $. $d X t $.
    ismgm.1 $e |- X = dom dom G $.
    $( The predicate "is a magma". $)
    ismgm $p |- ( G e. A -> ( G e. Magma <-> G : ( X X. X ) --> X ) ) $=
      cG cA wcel cG cmagm wcel vt cv cG cdm cdm wceq vt cv vt cv cxp vt cv cG
      wf wa vt wex cX cX cxp cX cG wf cG cA wcel cG cmagm wcel vt cv vt cv cxp
      vt cv cG wf vt wex vt cv cG cdm cdm wceq vt cv vt cv cxp vt cv cG wf wa
      vt wex vt cv vt cv cxp vt cv vg cv wf vt wex vt cv vt cv cxp vt cv cG wf
      vt wex vg cG cmagm cA vg cv cG wceq vt cv vt cv cxp vt cv vg cv wf vt cv
      vt cv cxp vt cv cG wf vt vt cv vt cv cxp vt cv vg cv cG feq1 exbidv vt vg
      df-mgm elab2g vt cv vt cv cxp vt cv cG wf vt cv cG cdm cdm wceq vt cv vt
      cv cxp vt cv cG wf wa vt vt cv vt cv cxp vt cv cG wf vt cv cG cdm cdm
      wceq vt cv c0 wceq vt cv vt cv cxp vt cv cG wf vt cv cG cdm cdm wceq wi
      vt cv c0 wceq vt cv vt cv cxp vt cv cG wf vt cv cG cdm cdm wceq wi c0 c0
      cxp c0 cG wf c0 cG cdm cdm wceq wi c0 c0 cxp c0 cG wf cG c0 wceq c0 c0
      cxp c0 wceq wa c0 cG cdm cdm wceq c0 c0 cxp cG f00 cG c0 wceq c0 cG cdm
      cdm wceq c0 c0 cxp c0 wceq cG c0 wceq cG cdm c0 cdm wceq c0 cG cdm cdm
      wceq cG c0 dmeq cG cdm c0 cdm wceq cG cdm cdm c0 cdm cdm c0 cG cdm c0 cdm
      dmeq c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtri syl6req syl
      adantr sylbi vt cv c0 wceq vt cv vt cv cxp vt cv cG wf c0 c0 cxp c0 cG wf
      vt cv cG cdm cdm wceq c0 cG cdm cdm wceq vt cv vt cv cxp c0 c0 cxp wceq
      vt cv c0 wceq vt cv vt cv cxp vt cv cG wf c0 c0 cxp c0 cG wf wb vt cv c0
      wceq vt cv vt cv cxp c0 c0 cxp wceq vt cv c0 vt cv c0 xpeq12 anidms vt cv
      vt cv cxp vt cv c0 c0 cxp c0 cG feq23 mpancom vt cv c0 cG cdm cdm eqeq1
      imbi12d mpbiri vt cv vt cv cxp vt cv cG wf vt cv c0 wceq wn vt cv cG cdm
      cdm wceq vt cv vt cv cxp vt cv cG wf cG cdm vt cv vt cv cxp wceq vt cv c0
      wceq wn vt cv cG cdm cdm wceq wi vt cv vt cv cxp vt cv cG fdm cG cdm vt
      cv vt cv cxp wceq cG cdm cdm vt cv vt cv cxp cdm wceq vt cv c0 wceq wn vt
      cv cG cdm cdm wceq wi cG cdm vt cv vt cv cxp dmeq vt cv c0 wceq wn vt cv
      cG cdm cdm wceq wi vt cv vt cv cxp cdm cG cdm cdm vt cv c0 wceq wn vt cv
      vt cv cxp cdm cG cdm cdm wceq vt cv cG cdm cdm wceq vt cv c0 wceq wn vt
      cv vt cv cxp cdm vt cv cG cdm cdm vt cv c0 wceq wn vt cv c0 wne vt cv vt
      cv cxp cdm vt cv wceq vt cv c0 df-ne vt cv vt cv dmxp sylbir eqeq1d
      biimpcd eqcoms syl syl com12 pm2.61i pm4.71ri exbii syl6bb cG cA wcel cG
      cdm cdm cvv wcel vt cv cG cdm cdm wceq vt cv vt cv cxp vt cv cG wf wa vt
      wex cX cX cxp cX cG wf wb cG cA wcel cG cdm cvv wcel cG cdm cdm cvv wcel
      cG cA dmexg cG cdm cvv dmexg syl vt cv vt cv cxp vt cv cG wf cX cX cxp cX
      cG wf vt cG cdm cdm cvv vt cv cG cdm cdm wceq vt cv vt cv cxp vt cv cG wf
      cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf cX cX cxp cX cG wf vt cv vt cv
      cxp cG cdm cdm cG cdm cdm cxp wceq vt cv cG cdm cdm wceq vt cv vt cv cxp
      vt cv cG wf cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf wb vt cv cG cdm
      cdm wceq vt cv vt cv cxp cG cdm cdm cG cdm cdm cxp wceq vt cv cG cdm cdm
      vt cv cG cdm cdm xpeq12 anidms vt cv vt cv cxp vt cv cG cdm cdm cG cdm
      cdm cxp cG cdm cdm cG feq23 mpancom cG cdm cdm cG cdm cdm cxp cX cX cxp
      wceq cG cdm cdm cX wceq cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf cX cX
      cxp cX cG wf wb cG cdm cdm cX cG cdm cdm cX cX cG cdm cdm ismgm.1 eqcomi
      cX cG cdm cdm ismgm.1 eqcomi xpeq12i cX cG cdm cdm ismgm.1 eqcomi cG cdm
      cdm cG cdm cdm cxp cG cdm cdm cX cX cxp cX cG feq23 mp2an syl6bb ceqsexgv
      syl bitrd $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${
    clmgm.1 $e |- X = dom dom G $.
    $( Closure of a magma. $)
    clmgm $p |- ( ( G e. Magma /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      cG cmagm wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cG cmagm wcel cA
      cX wcel cB cX wcel cA cB cG co cX wcel wi wi cG cmagm wcel cG cmagm wcel
      cX cX cxp cX cG wf cA cX wcel cB cX wcel cA cB cG co cX wcel wi wi cmagm
      cG cX clmgm.1 ismgm cX cX cxp cX cG wf cA cX wcel cB cX wcel cA cB cG co
      cX wcel cA cB cX cX cX cG foprrn 3exp syl6bi pm2.43i 3imp $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${ $d G u x z $. $d G u y z $. $d X u x z $.
     $d X u y z $.
    opidon.1 $e |- X = dom dom G $.
    $( An operation with a left and right identity element is onto. $)
    opidon $p |- ( G e. ( Magma i^i ExId ) ->
      G : ( X X. X ) -onto-> X ) $=
      cG cmagm cexid cin wcel cX cX cxp cX cG wf vz cv vu cv vy cv cG co wceq
      vy cX wrex vu cX wrex vz cX wral wa cX cX cxp cX cG wfo cG cmagm cexid
      cin wcel cX cX cxp cX cG wf vz cv vu cv vy cv cG co wceq vy cX wrex vu cX
      wrex vz cX wral cG cmagm cexid cin wcel cG cmagm wcel cX cX cxp cX cG wf
      cmagm cexid cin cmagm cG cmagm cexid inss1 sseli cG cmagm wcel cX cX cxp
      cX cG wf cmagm cG cX opidon.1 ismgm ibi syl cG cmagm cexid cin wcel vx cv
      vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vx cX wral vu cX
      wrex vz cv vu cv vy cv cG co wceq vy cX wrex vu cX wrex vz cX wral cG
      cexid wcel cG cexid wcel vx cv vu cv cG co vx cv wceq vu cv vx cv cG co
      vx cv wceq wa vx cX wral vu cX wrex cG cmagm cexid cin wcel cG cexid wcel
      cG cexid wcel vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq
      wa vx cX wral vu cX wrex vu vx cexid cG cX opidon.1 isexid biimpd cmagm
      cexid cin cexid cG cmagm cexid inss2 sseli cmagm cexid cin cexid cG cmagm
      cexid inss2 sseli sylc vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx
      cv wceq wa vx cX wral vu cX wrex vz cv vu cv vy cv cG co wceq vy cX wrex
      vu cX wrex vz cX vz cv cX wcel vx cv vu cv cG co vx cv wceq vu cv vx cv
      cG co vx cv wceq wa vx cX wral vu cX wrex vz cv vu cv vy cv cG co wceq vy
      cX wrex vu cX wrex vz cv cX wcel vx cv vu cv cG co vx cv wceq vu cv vx cv
      cG co vx cv wceq wa vx cX wral vz cv vu cv vy cv cG co wceq vy cX wrex vu
      cX vz cv cX wcel vu cv vx cv cG co vx cv wceq vx cX wral vz cv vu cv vy
      cv cG co wceq vy cX wrex vx cv vu cv cG co vx cv wceq vu cv vx cv cG co
      vx cv wceq wa vx cX wral vz cv cX wcel vu cv vx cv cG co vx cv wceq vx cX
      wral vu cv vz cv cG co vz cv wceq vz cv vu cv vy cv cG co wceq vy cX wrex
      vu cv vx cv cG co vx cv wceq vu cv vz cv cG co vz cv wceq vx vz cv cX vx
      vz weq vu cv vx cv cG co vu cv vz cv cG co vx cv vz cv vx cv vz cv vu cv
      cG opreq2 vx vz weq id eqeq12d rcla4v vz cv cX wcel vu cv vz cv cG co vz
      cv wceq vz cv vu cv vy cv cG co wceq vy cX wrex vz cv vu cv vy cv cG co
      wceq vu cv vz cv cG co vz cv wceq vy vz cv cX vy vz weq vu cv vy cv cG co
      vz cv wceq vu cv vz cv cG co vz cv wceq vz cv vu cv vy cv cG co wceq vy
      vz weq vu cv vy cv cG co vu cv vz cv cG co vz cv vy cv vz cv vu cv cG
      opreq2 eqeq1d vz cv vu cv vy cv cG co eqcom syl5bb rcla4ev ex syld vx cv
      vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vu cv vx cv cG co
      vx cv wceq vx cX vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv
      wceq pm3.27 r19.20si syl5 r19.22sdv impcom r19.21aiva syl jca vu vy vz cX
      cX cX cG fooprv sylibr $.
      $( [14-Dec-2009] $) $( [2-Nov-2009] $)
  $}

  $( Range of an operation with a left and right identity element. $)
  rngopid $p |- ( G e. ( Magma i^i ExId ) -> ran G = dom dom G ) $=
    cG cmagm cexid cin wcel cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wfo cG crn
    cG cdm cdm wceq cG cG cdm cdm cG cdm cdm eqid opidon cG cdm cdm cG cdm cdm
    cxp cG cdm cdm cG forn syl $.
    $( [14-Dec-2009] $) $( [2-Nov-2009] $)

  ${
    opidon2.1 $e |- X = ran G $.
    $( An operation with a left and right identity element is onto. $)
    opidon2 $p |- ( G e. ( Magma i^i ExId ) ->
      G : ( X X. X ) -onto-> X ) $=
      cG cmagm cexid cin wcel cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wfo cX cX
      cxp cX cG wfo cG cG cdm cdm cG cdm cdm eqid opidon cG cdm cdm cX wceq cG
      cdm cdm cG cdm cdm cxp cG cdm cdm cG wfo cX cX cxp cX cG wfo cG cdm cdm
      cG cdm cdm cxp cG cdm cdm cG wfo cG crn cG cdm cdm cX cG cdm cdm cG cdm
      cdm cxp cG cdm cdm cG forn opidon2.1 syl5req cG cdm cdm cX wceq cG cdm
      cdm cG cdm cdm cxp cG cdm cdm cG wfo cX cX cxp cX cG wfo cG cdm cdm cX
      wceq cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wfo cX cX cxp cG cdm cdm cG
      wfo cX cX cxp cX cG wfo cG cdm cdm cX wceq cG cdm cdm cG cdm cdm cxp cX
      cX cxp wceq cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wfo cX cX cxp cG cdm
      cdm cG wfo wb cG cdm cdm cX wceq cG cdm cdm cG cdm cdm cxp cX cX cxp wceq
      cG cdm cdm cX cG cdm cdm cX xpeq12 anidms cG cdm cdm cG cdm cdm cxp cX cX
      cxp cG cdm cdm cG foeq2 syl cG cdm cdm cX cX cX cxp cG foeq3 bitrd biimpd
      mpcom syl $.
      $( [14-Dec-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G u y $. $d X u y $.
    isexid2.1 $e |- X = ran G $.
    $( If ` G e. ( Magma i^i ExId ) ` then it has a left and right identity
       element that belongs to the range of the operation. $)
    isexid2 $p |- ( G e. ( Magma i^i ExId ) -> E. u e. X A. y e. X
      ( ( y G u ) = y /\ ( u G y ) = y ) ) $=
      cX cG crn wceq cG cmagm cexid cin wcel vy cv vu cv cG co vy cv wceq vu cv
      vy cv cG co vy cv wceq wa vy cX wral vu cX wrex wi isexid2.1 cX cG crn
      wceq cG cmagm cexid cin wcel vy cv vu cv cG co vy cv wceq vu cv vy cv cG
      co vy cv wceq wa vy cG crn wral vu cG crn wrex vy cv vu cv cG co vy cv
      wceq vu cv vy cv cG co vy cv wceq wa vy cX wral vu cX wrex cG cmagm cexid
      cin wcel cX cG crn wceq vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy
      cv wceq wa vy cG crn wral vu cG crn wrex cG crn cG cdm cdm wceq cG cmagm
      cexid cin wcel cX cG crn wceq vy cv vu cv cG co vy cv wceq vu cv vy cv cG
      co vy cv wceq wa vy cG crn wral vu cG crn wrex wi cG rngopid cG crn cG
      cdm cdm wceq cX cG crn wceq vy cv vu cv cG co vy cv wceq vu cv vy cv cG
      co vy cv wceq wa vy cG crn wral vu cG crn wrex wi cX cG cdm cdm wceq vy
      cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG cdm cdm
      wral vu cG cdm cdm wrex wi cG cmagm cexid cin wcel cG crn cG cdm cdm wceq
      cX cG crn wceq cX cG cdm cdm wceq vy cv vu cv cG co vy cv wceq vu cv vy
      cv cG co vy cv wceq wa vy cG crn wral vu cG crn wrex vy cv vu cv cG co vy
      cv wceq vu cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vu cG cdm cdm
      wrex cG crn cG cdm cdm cX eqeq2 cG crn cG cdm cdm wceq vy cv vu cv cG co
      vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG crn wral vy cv vu cv cG
      co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vu cG
      crn cG cdm cdm cG crn cG cdm cdm wceq vu cv cG crn wcel vu cv cG cdm cdm
      wcel vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG
      crn wral vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy
      cG cdm cdm wral cG crn cG cdm cdm vu cv eleq2 vy cv vu cv cG co vy cv
      wceq vu cv vy cv cG co vy cv wceq wa vy cG crn cG cdm cdm raleq1 anbi12d
      rexbidv2 imbi12d cG cmagm cexid cin wcel cG cmagm wcel cG cexid wcel wa
      cX cG cdm cdm wceq vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv
      wceq wa vy cG cdm cdm wral vu cG cdm cdm wrex wi cG cmagm cexid elin cG
      cexid wcel cX cG cdm cdm wceq vy cv vu cv cG co vy cv wceq vu cv vy cv cG
      co vy cv wceq wa vy cG cdm cdm wral vu cG cdm cdm wrex wi cG cmagm wcel
      cG cexid wcel vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq
      wa vy cG cdm cdm wral vu cG cdm cdm wrex cX cG cdm cdm wceq cG cexid wcel
      vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG cdm
      cdm wral vu cG cdm cdm wrex vu vy cexid cG cG cdm cdm cG cdm cdm eqid
      isexid ibi a1d adantl sylbi syl5bir mpcom com12 cX cG crn wceq vy cv vu
      cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cX wral vy cv vu
      cv cG co vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG crn wral vu cX
      cG crn cX cG crn wceq vu cv cX wcel vu cv cG crn wcel vy cv vu cv cG co
      vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cX wral vy cv vu cv cG co
      vy cv wceq vu cv vy cv cG co vy cv wceq wa vy cG crn wral cX cG crn vu cv
      eleq2 cX cG crn wceq vy cv vu cv cG co vy cv wceq vu cv vy cv cG co vy cv
      wceq wa vy cX cG crn cX cG crn wceq id raleq1d anbi12d rexbidv2 sylibrd
      ax-mp $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}


  ${ $d G u w x z $. $d X u w x z $.
    exidu1.1 $e |- X = ran G $.
    $( Unicity of the left and right identity element of a magma when it
       exists. $)
    exidu1 $p |- ( G e. ( Magma i^i ExId ) ->
      E! u e. X A. x e. X ( ( u G x ) = x /\ ( x G u ) = x ) ) $=
      cG cmagm cexid cin wcel vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx
      cv wceq wa vx cX wral vw cv vx cv cG co vx cv wceq vx cv vw cv cG co vx
      cv wceq wa vx cX wral vu vw weq wi vw cX wral wa vu cX wrex vu cv vx cv
      cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX wreu cG
      cmagm cexid cin wcel vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz cv
      wceq wa vz cX wral vu cX wrex vu cv vx cv cG co vx cv wceq vx cv vu cv cG
      co vx cv wceq wa vx cX wral vw cv vx cv cG co vx cv wceq vx cv vw cv cG
      co vx cv wceq wa vx cX wral vu vw weq wi vw cX wral wa vu cX wrex vz vu
      cG cX exidu1.1 isexid2 cG cmagm cexid cin wcel vz cv vu cv cG co vz cv
      wceq vu cv vz cv cG co vz cv wceq wa vz cX wral vu cv vx cv cG co vx cv
      wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vw cv vx cv cG co vx cv
      wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vu vw weq wi vw cX wral
      wa vu cX cG cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv
      wceq vu cv vz cv cG co vz cv wceq wa vz cX wral vu cv vx cv cG co vx cv
      wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vw cv vx cv cG co vx cv
      wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vu vw weq wi vw cX wral
      wa cG cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq
      vu cv vz cv cG co vz cv wceq wa vz cX wral wa vu cv vx cv cG co vx cv
      wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vw cv vx cv cG co vx cv
      wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vu vw weq wi vw cX wral
      vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vz cX wral
      vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral
      cG cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq vu
      cv vz cv cG co vz cv wceq wa vz cX wral vu cv vx cv cG co vx cv wceq vx
      cv vu cv cG co vx cv wceq wa vx cX wral vz cv vu cv cG co vz cv wceq vu
      cv vz cv cG co vz cv wceq wa vu cv vx cv cG co vx cv wceq vx cv vu cv cG
      co vx cv wceq wa vz vx cX vz vx weq vu cv vz cv cG co vz cv wceq vz cv vu
      cv cG co vz cv wceq wa vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx
      cv wceq wa vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa
      vz vx weq vu cv vz cv cG co vz cv wceq vu cv vx cv cG co vx cv wceq vz cv
      vu cv cG co vz cv wceq vx cv vu cv cG co vx cv wceq vz vx weq vu cv vz cv
      cG co vu cv vx cv cG co vz cv vx cv vz cv vx cv vu cv cG opreq2 vz vx weq
      id eqeq12d vz vx weq vz cv vu cv cG co vx cv vu cv cG co vz cv vx cv vz
      cv vx cv vu cv cG opreq1 vz vx weq id eqeq12d anbi12d vz cv vu cv cG co
      vz cv wceq vu cv vz cv cG co vz cv wceq ancom syl5bb cbvralv biimpi
      adantl cG cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv
      wceq vu cv vz cv cG co vz cv wceq wa vz cX wral wa vw cv vx cv cG co vx
      cv wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vu vw weq wi vw cX cG
      cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq vu cv
      vz cv cG co vz cv wceq wa vz cX wral wa vw cv cX wcel wa vw cv vx cv cG
      co vx cv wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vu vw weq cG
      cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq vu cv
      vz cv cG co vz cv wceq wa vz cX wral wa vw cv cX wcel wa vw cv vx cv cG
      co vx cv wceq vx cv vw cv cG co vx cv wceq wa vx cX wral wa vw cv vu cv
      cG co vu cv vw cv cG co vu cv vw cv cG cmagm cexid cin wcel vu cv cX wcel
      wa vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vz cX
      wral wa vw cv cX wcel wa vw cv vu cv cG co vu cv vw cv cG co wceq vw cv
      vx cv cG co vx cv wceq vx cv vw cv cG co vx cv wceq wa vx cX wral cG
      cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq vu cv
      vz cv cG co vz cv wceq wa vz cX wral wa vw cv cX wcel vw cv vu cv cG co
      vu cv vw cv cG co wceq vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz
      cv wceq wa vz cX wral vw cv cX wcel vw cv vu cv cG co vu cv vw cv cG co
      wceq wi cG cmagm cexid cin wcel vu cv cX wcel wa vw cv cX wcel vz cv vu
      cv cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vz cX wral vw cv vu
      cv cG co vu cv vw cv cG co wceq vw cv cX wcel vz cv vu cv cG co vz cv
      wceq vu cv vz cv cG co vz cv wceq wa vz cX wral wa vw cv vu cv cG co vw
      cv wceq vu cv vw cv cG co vw cv wceq wa vw cv vu cv cG co vu cv vw cv cG
      co wceq vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vw
      cv vu cv cG co vw cv wceq vu cv vw cv cG co vw cv wceq wa vz vw cv cX vz
      vw weq vz cv vu cv cG co vz cv wceq vw cv vu cv cG co vw cv wceq vu cv vz
      cv cG co vz cv wceq vu cv vw cv cG co vw cv wceq vz vw weq vz cv vu cv cG
      co vw cv vu cv cG co vz cv vw cv vz cv vw cv vu cv cG opreq1 vz vw weq id
      eqeq12d vz vw weq vu cv vz cv cG co vu cv vw cv cG co vz cv vw cv vz cv
      vw cv vu cv cG opreq2 vz vw weq id eqeq12d anbi12d rcla4va vw cv vu cv cG
      co vu cv vw cv cG co vw cv eqtr3 syl expcom adantl imp adantr cG cmagm
      cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq vu cv vz cv
      cG co vz cv wceq wa vz cX wral wa vw cv cX wcel wa vw cv vx cv cG co vx
      cv wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vw cv vu cv cG co vu
      cv wceq cG cmagm cexid cin wcel vu cv cX wcel wa vw cv vx cv cG co vx cv
      wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vw cv vu cv cG co vu cv
      wceq wi vz cv vu cv cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vz
      cX wral vw cv cX wcel vu cv cX wcel vw cv vx cv cG co vx cv wceq vx cv vw
      cv cG co vx cv wceq wa vx cX wral vw cv vu cv cG co vu cv wceq wi cG
      cmagm cexid cin wcel vu cv cX wcel vw cv vx cv cG co vx cv wceq vx cv vw
      cv cG co vx cv wceq wa vx cX wral vw cv vu cv cG co vu cv wceq vu cv cX
      wcel vw cv vx cv cG co vx cv wceq vx cv vw cv cG co vx cv wceq wa vx cX
      wral wa vw cv vu cv cG co vu cv wceq vu cv vw cv cG co vu cv wceq vw cv
      vx cv cG co vx cv wceq vx cv vw cv cG co vx cv wceq wa vw cv vu cv cG co
      vu cv wceq vu cv vw cv cG co vu cv wceq wa vx vu cv cX vx vu weq vw cv vx
      cv cG co vx cv wceq vw cv vu cv cG co vu cv wceq vx cv vw cv cG co vx cv
      wceq vu cv vw cv cG co vu cv wceq vx vu weq vw cv vx cv cG co vw cv vu cv
      cG co vx cv vu cv vx cv vu cv vw cv cG opreq2 vx vu weq id eqeq12d vx vu
      weq vx cv vw cv cG co vu cv vw cv cG co vx cv vu cv vx cv vu cv vw cv cG
      opreq1 vx vu weq id eqeq12d anbi12d rcla4va pm3.26d ex adantl ad2antrr
      imp cG cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv cG co vz cv wceq
      vu cv vz cv cG co vz cv wceq wa vz cX wral wa vw cv cX wcel wa vu cv vw
      cv cG co vw cv wceq vw cv vx cv cG co vx cv wceq vx cv vw cv cG co vx cv
      wceq wa vx cX wral cG cmagm cexid cin wcel vu cv cX wcel wa vz cv vu cv
      cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vz cX wral wa vw cv cX
      wcel vu cv vw cv cG co vw cv wceq vz cv vu cv cG co vz cv wceq vu cv vz
      cv cG co vz cv wceq wa vz cX wral vw cv cX wcel vu cv vw cv cG co vw cv
      wceq wi cG cmagm cexid cin wcel vu cv cX wcel wa vw cv cX wcel vu cv vz
      cv cG co vz cv wceq vz cX wral vu cv vw cv cG co vw cv wceq vz cv vu cv
      cG co vz cv wceq vu cv vz cv cG co vz cv wceq wa vz cX wral vw cv cX wcel
      vu cv vz cv cG co vz cv wceq vz cX wral vu cv vw cv cG co vw cv wceq vu
      cv vz cv cG co vz cv wceq vu cv vw cv cG co vw cv wceq vz vw cv cX vz vw
      weq vu cv vz cv cG co vu cv vw cv cG co vz cv vw cv vz cv vw cv vu cv cG
      opreq2 vz vw weq id eqeq12d rcla4va ex vz cv vu cv cG co vz cv wceq vu cv
      vz cv cG co vz cv wceq wa vu cv vz cv cG co vz cv wceq vz cX vz cv vu cv
      cG co vz cv wceq vu cv vz cv cG co vz cv wceq pm3.27 r19.20si syl5com
      adantl imp adantr 3eqtr3d ex r19.21aiva jca ex r19.22dva mpd vu cv vx cv
      cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vw cv vx cv
      cG co vx cv wceq vx cv vw cv cG co vx cv wceq wa vx cX wral vu vw cX vu
      vw weq vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vw cv
      vx cv cG co vx cv wceq vx cv vw cv cG co vx cv wceq wa vx cX vu vw weq vu
      cv vx cv cG co vx cv wceq vw cv vx cv cG co vx cv wceq vx cv vu cv cG co
      vx cv wceq vx cv vw cv cG co vx cv wceq vu vw weq vu cv vx cv cG co vw cv
      vx cv cG co vx cv vu cv vw cv vx cv cG opreq1 eqeq1d vu vw weq vx cv vu
      cv cG co vx cv vw cv cG co vx cv vu cv vw cv vx cv cG opreq2 eqeq1d
      anbi12d ralbidv reu8 sylibr $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}

  ${ $d G x y $. $d X x y $.
    bsmgrli.1 $e |- X = ran G $.
    $( The base set of an operation with a right and left identity
       element is not empty. $)
    bsmgrli $p |- ( G e. ( Magma i^i ExId ) -> X =/= (/) ) $=
      cG cmagm cexid cin wcel vx cv vy cv cG co vx cv wceq vy cv vx cv cG co vx
      cv wceq wa vx cX wral vy cX wrex cX c0 wne vx vy cG cX bsmgrli.1 isexid2
      vx cv vy cv cG co vx cv wceq vy cv vx cv cG co vx cv wceq wa vx cX wral
      vy cX rexn0 syl $.
      $( [18-Feb-2010] $) $( [18-Feb-2010] $)
  $}


  ${ $d G g u x y $. $d X g u x y $.
    idrval.1 $e |- X = ran G $.
    idrval.2 $e |- U = ( Id ` G ) $.
    $( The value of the identity element. $)
    idrval $p |- ( G e. A ->
                   U = U. { u e. X | A. x e. X ( ( u G x ) = x
      /\ ( x G u ) = x ) } ) $=
      cG cA wcel cG cgi cfv vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx
      cv wceq wa vx cX wral vu cX crab cuni cU cG cvv wcel vu cv vx cv cG co vx
      cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX crab cuni cvv
      wcel cG cgi cfv vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq
      wa vx cX wral vu cX crab cuni wceq cG cA wcel vg vy cG vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg
      cv crn crab cuni vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
      wceq wa vx cX wral vu cX crab cuni cvv cvv cgi vg cv cG wceq vu cv vx cv
      vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral
      vu vg cv crn crab vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
      wceq wa vx cX wral vu cX crab vg cv cG wceq vu cv vx cv vg cv co vx cv
      wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
      crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa
      vx vg cv crn wral vu cX crab vu cv vx cv cG co vx cv wceq vx cv vu cv cG
      co vx cv wceq wa vx cX wral vu cX crab vg cv cG wceq vg cv crn cX wceq vu
      cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv
      crn wral vu vg cv crn crab vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg
      cv co vx cv wceq wa vx vg cv crn wral vu cX crab wceq vg cv cG wceq vg cv
      crn cG crn cX vg cv cG rneq idrval.1 syl6eqr vu cv vx cv vg cv co vx cv
      wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn cX
      rabeq syl vg cv cG wceq vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv
      co vx cv wceq wa vx vg cv crn wral vu cv vx cv cG co vx cv wceq vx cv vu
      cv cG co vx cv wceq wa vx cX wral vu cX vg cv cG wceq vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vu cv vx cv cG co vx cv
      wceq vx cv vu cv cG co vx cv wceq wa vx vg cv crn cX vg cv cG wceq vg cv
      crn cG crn cX vg cv cG rneq idrval.1 syl6eqr vg cv cG wceq vu cv vx cv vg
      cv co vx cv wceq vu cv vx cv cG co vx cv wceq vx cv vu cv vg cv co vx cv
      wceq vx cv vu cv cG co vx cv wceq vg cv cG wceq vu cv vx cv vg cv co vu
      cv vx cv cG co vx cv vu cv vx cv vg cv cG opreq eqeq1d vg cv cG wceq vx
      cv vu cv vg cv co vx cv vu cv cG co vx cv vx cv vu cv vg cv cG opreq
      eqeq1d anbi12d raleq12d rabbisdv eqtrd unieqd cgi vy cv vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg
      cv crn crab cuni wceq vg vy copab cvv cres vg cv cvv wcel vy cv vu cv vx
      cv vg cv co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn
      wral vu vg cv crn crab cuni wceq wa vg vy copab vy cv vu cv vx cv vg cv
      co vx cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg
      cv crn crab cuni wceq vg vy copab wrel cgi vy cv vu cv vx cv vg cv co vx
      cv wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
      crab cuni wceq vg vy copab cvv cres wceq vy cv vu cv vx cv vg cv co vx cv
      wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
      crab cuni wceq vg vy relopab vy cv vu cv vx cv vg cv co vx cv wceq vx cv
      vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni
      wceq vg vy copab wrel vy cv vu cv vx cv vg cv co vx cv wceq vx cv vu cv
      vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni wceq vg
      vy copab cvv cres vy cv vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv
      co vx cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni wceq vg vy
      copab cgi vy cv vu cv vx cv vg cv co vx cv wceq vx cv vu cv vg cv co vx
      cv wceq wa vx vg cv crn wral vu vg cv crn crab cuni wceq vg vy copab
      resid vx vy vu vg df-gid syl6reqr ax-mp vy cv vu cv vx cv vg cv co vx cv
      wceq vx cv vu cv vg cv co vx cv wceq wa vx vg cv crn wral vu vg cv crn
      crab cuni wceq vg vy cvv resopab eqtri fvopab4g cG cA elisset cG cA wcel
      cX cvv wcel vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa
      vx cX wral vu cX crab cvv wcel vu cv vx cv cG co vx cv wceq vx cv vu cv
      cG co vx cv wceq wa vx cX wral vu cX crab cuni cvv wcel cG cA wcel cG crn
      cvv cX cG cA rnexg idrval.1 syl5eqel vu cv vx cv cG co vx cv wceq vx cv
      vu cv cG co vx cv wceq wa vx cX wral vu cX cvv rabexg vu cv vx cv cG co
      vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX crab cvv
      uniexg 3syl sylanc idrval.2 syl5eq $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}

  ${ $d G u x $. $d X u x $.
    iorlid.1 $e |- X = ran G $.
    iorlid.2 $e |- U = ( Id ` G ) $.
    $( A magma right and left identity belongs to the underlying
       set of the operation. $)
    iorlid $p |- ( G e. ( Magma i^i ExId ) -> U e. X ) $=
      cG cmagm cexid cin wcel cU vu cv vx cv cG co vx cv wceq vx cv vu cv cG co
      vx cv wceq wa vx cX wral vu cX crab cuni cX vx vu cmagm cexid cin cU cG
      cX iorlid.1 iorlid.2 idrval cG cmagm cexid cin wcel vu cv vx cv cG co vx
      cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX wreu vu cv vx cv
      cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX crab
      cuni cX wcel vx vu cG cX iorlid.1 exidu1 vu cv vx cv cG co vx cv wceq vx
      cv vu cv cG co vx cv wceq wa vx cX wral vu cX reucl syl eqeltrd $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}


  ${ $d A x $. $d G u x $. $d U u x $. $d X u x $.
    cmpidelt.1 $e |- X = ran G $.
    cmpidelt.2 $e |- U = ( Id ` G ) $.
    $( A magma right and left identity element keeps the other elements
       unchanged. $)
    cmpidelt $p |- ( ( G e. ( Magma i^i ExId ) /\ A e. X ) ->
      ( ( U G A ) = A /\ ( A G U ) = A ) ) $=
      cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa vx cX wral cA cX
      wcel cU cA cG co cA wceq cA cU cG co cA wceq wa cG cmagm cexid cin wcel
      cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa cU cA cG co cA
      wceq cA cU cG co cA wceq wa vx cA cX vx cv cA wceq cU vx cv cG co vx cv
      wceq cU cA cG co cA wceq vx cv cU cG co vx cv wceq cA cU cG co cA wceq vx
      cv cA wceq cU vx cv cG co cU cA cG co vx cv cA vx cv cA cU cG opreq2 vx
      cv cA wceq id eqeq12d vx cv cA wceq vx cv cU cG co cA cU cG co vx cv cA
      vx cv cA cU cG opreq1 vx cv cA wceq id eqeq12d anbi12d rcla4cva cG cmagm
      cexid cin wcel cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa vx
      cX wral vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx
      cX wral vu cX crab cuni cU wceq cG cmagm cexid cin wcel cU vu cv vx cv cG
      co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral vu cX crab cuni
      vx vu cmagm cexid cin cU cG cX cmpidelt.1 cmpidelt.2 idrval eqcomd cU cX
      wcel vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX
      wral vu cX wreu cU vx cv cG co vx cv wceq vx cv cU cG co vx cv wceq wa vx
      cX wral vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx
      cX wral vu cX crab cuni cU wceq wb cG cmagm cexid cin wcel vu cv vx cv cG
      co vx cv wceq vx cv vu cv cG co vx cv wceq wa vx cX wral cU vx cv cG co
      vx cv wceq vx cv cU cG co vx cv wceq wa vx cX wral vu cX cU vu cv cU wceq
      vu cv vx cv cG co vx cv wceq vx cv vu cv cG co vx cv wceq wa cU vx cv cG
      co vx cv wceq vx cv cU cG co vx cv wceq wa vx cX vu cv cU wceq vu cv vx
      cv cG co vx cv wceq cU vx cv cG co vx cv wceq vx cv vu cv cG co vx cv
      wceq vx cv cU cG co vx cv wceq vu cv cU wceq vu cv vx cv cG co cU vx cv
      cG co vx cv vu cv cU vx cv cG opreq1 eqeq1d vu cv cU wceq vx cv vu cv cG
      co vx cv cU cG co vx cv vu cv cU vx cv cG opreq2 eqeq1d anbi12d ralbidv
      reuuni2 cU cG cX cmpidelt.1 cmpidelt.2 iorlid vx vu cG cX cmpidelt.1
      exidu1 sylanc mpbird sylan $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}

  $c SemiGrp $.

  $( Extend class notation with the class of all semi-groups. $)
  csem $a class SemiGrp $.

  $( A semi-group is an associative magma. $)
  df-sgr $a |- SemiGrp = ( Magma i^i Ass ) $.

  $( A semi-group is a magma. $)
  smgrpismgm $p |- ( G e. SemiGrp -> G e. Magma ) $=
    cG csem wcel cG cmagm cass cin wcel cG cmagm wcel csem cmagm cass cin cG
    df-sgr eleq2i cG cmagm cass cin wcel cG cmagm wcel cG cass wcel cG cmagm
    cass elin pm3.26bi sylbi $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)

  $( A semi-group is associative. $)
  smgrpisass $p |- ( G e. SemiGrp -> G e. Ass ) $=
    cG csem wcel cG cmagm cass cin wcel cG cass wcel csem cmagm cass cin cG
    df-sgr eleq2i cG cmagm cass cin wcel cG cmagm wcel cG cass wcel cG cmagm
    cass elin pm3.27bi sylbi $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)


  ${ $d G x y z $. $d X x y z $.
    issmgrp.1 $e |- X = dom dom G $.
    $( The predicate "is a semi-group". $)
    issmgrp $p |- ( G e. A -> ( G e. SemiGrp <-> ( G : ( X X. X ) --> X /\
     A. x e. X A. y e. X A. z e. X ( ( x G y ) G z ) = ( x G ( y G z ) ) ) ) )
     $=
      cG cA wcel cG cmagm cass cin wcel cX cX cxp cX cG wf vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX
      wral wa cG csem wcel cG cA wcel cG cmagm wcel cG cass wcel wa cX cX cxp
      cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
      vz cX wral vy cX wral vx cX wral wa cG cmagm cass cin wcel cG cA wcel cG
      cmagm wcel cX cX cxp cX cG wf cG cass wcel vx cv vy cv cG co vz cv cG co
      vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral cA cG
      cX issmgrp.1 ismgm vx vy vz cA cG cX issmgrp.1 isass anbi12d cG cmagm
      cass elin syl5bb csem cmagm cass cin cG df-sgr eleq2i syl5bb $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G x y z $. $d X x y z $.
    smgrpmgm.1 $e |- X = dom dom G $.
    $( A semi-group is a magma. $)
    smgrpmgm $p |- ( G e. SemiGrp -> G : ( X X. X ) --> X ) $=
      cG csem wcel cX cX cxp cX cG wf cG csem wcel cG csem wcel cX cX cxp cX cG
      wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX
      wral vy cX wral vx cX wral wa cX cX cxp cX cG wf vx vy vz csem cG cX
      smgrpmgm.1 issmgrp cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral pm3.26
      syl6bi pm2.43i $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G x y z $. $d X x y z $.
    smgrpass.1 $e |- X = dom dom G $.
    $( A semi-group is associative. $)
    smgrpass $p |- ( G e. SemiGrp ->
      A. x e. X A. y e. X A. z e. X ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $=
      cG csem wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cX wral vy cX wral vx cX wral cG csem wcel cG csem wcel cX cX cxp
      cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
      vz cX wral vy cX wral vx cX wral wa vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vx vy vz
      csem cG cX smgrpass.1 issmgrp cX cX cxp cX cG wf vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral
      pm3.27 syl6bi pm2.43i $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d A x y z $. $d B y z $. $d C z $. $d G x y z $. $d X x y z $.
    smgrpass2.1 $e |- X = dom dom G $.
    $( A semi-group is associative. $)
    smgrpass2 $p |- ( ( G e. SemiGrp /\ ( A e. X /\ B e. X /\ C e. X ) )
      -> ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cG csem wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cX wral vy cX wral vx cX wral cA cX wcel cB cX wcel cC cX wcel
      w3a cA cB cG co cC cG co cA cB cC cG co cG co wceq vx vy vz cG cX
      smgrpass2.1 smgrpass vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG
      co cG co wceq cA cB cG co cC cG co cA cB cC cG co cG co wceq cA vy cv cG
      co vz cv cG co cA vy cv vz cv cG co cG co wceq cA cB cG co vz cv cG co cA
      cB vz cv cG co cG co wceq vx vy vz cA cB cC cX cX cX vx cv cA wceq vx cv
      vy cv cG co vz cv cG co cA vy cv cG co vz cv cG co vx cv vy cv vz cv cG
      co cG co cA vy cv vz cv cG co cG co vx cv cA wceq vx cv vy cv cG co cA vy
      cv cG co vz cv cG vx cv cA vy cv cG opreq1 opreq1d vx cv cA vy cv vz cv
      cG co cG opreq1 eqeq12d vy cv cB wceq cA vy cv cG co vz cv cG co cA cB cG
      co vz cv cG co cA vy cv vz cv cG co cG co cA cB vz cv cG co cG co vy cv
      cB wceq cA vy cv cG co cA cB cG co vz cv cG vy cv cB cA cG opreq2 opreq1d
      vy cv cB wceq vy cv vz cv cG co cB vz cv cG co cA cG vy cv cB vz cv cG
      opreq1 opreq2d eqeq12d vz cv cC wceq cA cB cG co vz cv cG co cA cB cG co
      cC cG co cA cB vz cv cG co cG co cA cB cC cG co cG co vz cv cC cA cB cG
      co cG opreq2 vz cv cC wceq cB vz cv cG co cB cC cG co cA cG vz cv cC cB
      cG opreq2 opreq2d eqeq12d rcla43v mpan9 $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}

  ${
    $d G x y $.
    $( An abelian group is a commutative group. $)
    ablcomgrp $p |- ( G e. Abel -> G e. ( Grp i^i Com1 ) ) $=
      cG cgr wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cG crn wral vx cG
      crn wral wa cG cgr wcel cG ccm1 wcel wa cG cabl wcel cG cgr ccm1 cin wcel
      cG cgr wcel vx cv vy cv cG co vy cv vx cv cG co wceq vy cG crn wral vx cG
      crn wral cG ccm1 wcel cG crn cG cdm cdm wceq cG cgr wcel vx cv vy cv cG
      co vy cv vx cv cG co wceq vy cG crn wral vx cG crn wral cG ccm1 wcel wi
      cG grprndm cG crn cG cdm cdm wceq vx cv vy cv cG co vy cv vx cv cG co
      wceq vy cG crn wral vx cG crn wral cG ccm1 wcel wi vx cv vy cv cG co vy
      cv vx cv cG co wceq vy cG cdm cdm wral vx cG cdm cdm wral cG ccm1 wcel wi
      cG cgr wcel cG crn cG cdm cdm wceq vx cv vy cv cG co vy cv vx cv cG co
      wceq vy cG crn wral vx cG crn wral vx cv vy cv cG co vy cv vx cv cG co
      wceq vy cG cdm cdm wral vx cG cdm cdm wral cG ccm1 wcel cG crn cG cdm cdm
      wceq vx cv vy cv cG co vy cv vx cv cG co wceq vy cG crn wral vx cv vy cv
      cG co vy cv vx cv cG co wceq vy cG cdm cdm wral vx cG crn cG cdm cdm cG
      crn cG cdm cdm wceq vx cv cG crn wcel vx cv cG cdm cdm wcel vx cv vy cv
      cG co vy cv vx cv cG co wceq vy cG crn wral vx cv vy cv cG co vy cv vx cv
      cG co wceq vy cG cdm cdm wral cG crn cG cdm cdm vx cv eleq2 vx cv vy cv
      cG co vy cv vx cv cG co wceq vy cG crn cG cdm cdm raleq1 imbi12d ralbidv2
      imbi1d cG cgr wcel cG ccm1 wcel vx cv vy cv cG co vy cv vx cv cG co wceq
      vy cG cdm cdm wral vx cG cdm cdm wral vx vy cgr cG cG cdm cdm cG cdm cdm
      eqid iscom biimprd syl5bir mpcom imdistani vx vy cG cG crn cG crn eqid
      isabl cG cgr ccm1 elin 3imtr4i $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}



  ${
    reacomsmgrp1.1 $e |- X = dom dom G $.
    $( Rearrangement of three terms in an commutative semi-group. $)
    reacomsmgrp1 $p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( A G ( B G C ) ) = ( B G ( A G C ) ) ) $=
      cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cG
      co cG co cA cB cG co cC cG co cB cA cG co cC cG co cB cA cC cG co cG co
      cG csem wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cC cG co cG co cA
      cB cG co cC cG co wceq cG csem ccm1 cin wcel cG csem wcel cA cX wcel cB
      cX wcel cC cX wcel w3a wa cA cB cG co cC cG co cA cB cC cG co cG co cA cB
      cC cG cX reacomsmgrp1.1 smgrpass2 eqcomd csem ccm1 cin csem cG csem ccm1
      inss1 sseli sylan cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa cA cB cG co cB cA cG co cC cG cG ccm1 wcel cA cX wcel cB cX wcel
      cA cB cG co cB cA cG co wceq cG csem ccm1 cin wcel cA cX wcel cB cX wcel
      cC cX wcel w3a wa cA cB cG cX reacomsmgrp1.1 iscomb cG csem ccm1 cin wcel
      cG ccm1 wcel cA cX wcel cB cX wcel cC cX wcel w3a csem ccm1 cin ccm1 cG
      csem ccm1 inss2 sseli adantr cG csem ccm1 cin wcel cA cX wcel cB cX wcel
      cC cX wcel 3simpr1 cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      3simpr2 syl3anc opreq1d cG csem wcel cB cX wcel cA cX wcel cC cX wcel w3a
      cB cA cG co cC cG co cB cA cC cG co cG co wceq cG csem ccm1 cin wcel cA
      cX wcel cB cX wcel cC cX wcel w3a cB cA cC cG cX reacomsmgrp1.1 smgrpass2
      csem ccm1 cin csem cG csem ccm1 inss1 sseli cA cX wcel cB cX wcel cC cX
      wcel w3a cB cX wcel cA cX wcel cC cX wcel cA cX wcel cB cX wcel cC cX
      wcel 3simp2 cA cX wcel cB cX wcel cC cX wcel 3simp1 cA cX wcel cB cX wcel
      cC cX wcel 3simp3 3jca syl2an 3eqtrd $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)


    $( Rearrangement of three terms in an commutative semi-group. $)
    reacomsmgrp2 $p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( A G ( B G C ) ) = ( C G ( B G A ) ) ) $=
      cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cG
      co cG co cA cB cG co cC cG co cB cA cG co cC cG co cC cB cA cG co cG co
      cG csem wcel cA cX wcel cB cX wcel cC cX wcel w3a cA cB cC cG co cG co cA
      cB cG co cC cG co wceq cG csem ccm1 cin wcel cG csem wcel cA cX wcel cB
      cX wcel cC cX wcel w3a wa cA cB cG co cC cG co cA cB cC cG co cG co cA cB
      cC cG cX reacomsmgrp1.1 smgrpass2 eqcomd csem ccm1 cin csem cG csem ccm1
      inss1 sseli sylan cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa cA cB cG co cB cA cG co cC cG cG ccm1 wcel cA cX wcel cB cX wcel
      cA cB cG co cB cA cG co wceq cG csem ccm1 cin wcel cA cX wcel cB cX wcel
      cC cX wcel w3a wa cA cB cG cX reacomsmgrp1.1 iscomb cG csem ccm1 cin wcel
      cG ccm1 wcel cA cX wcel cB cX wcel cC cX wcel w3a csem ccm1 cin ccm1 cG
      csem ccm1 inss2 sseli adantr cG csem ccm1 cin wcel cA cX wcel cB cX wcel
      cC cX wcel 3simpr1 cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      3simpr2 syl3anc opreq1d cG ccm1 wcel cB cA cG co cX wcel cC cX wcel cB cA
      cG co cC cG co cC cB cA cG co cG co wceq cG csem ccm1 cin wcel cA cX wcel
      cB cX wcel cC cX wcel w3a wa cB cA cG co cC cG cX reacomsmgrp1.1 iscomb
      cG csem ccm1 cin wcel cG ccm1 wcel cA cX wcel cB cX wcel cC cX wcel w3a
      csem ccm1 cin ccm1 cG csem ccm1 inss2 sseli adantr cG csem ccm1 cin wcel
      cG cmagm wcel cA cX wcel cB cX wcel cC cX wcel w3a cB cA cG co cX wcel cG
      csem ccm1 cin wcel cG csem wcel cG cmagm wcel csem ccm1 cin csem cG csem
      ccm1 inss1 sseli cG smgrpismgm syl cA cX wcel cB cX wcel cG cmagm wcel cB
      cA cG co cX wcel wi cC cX wcel cA cX wcel cB cX wcel cG cmagm wcel cB cA
      cG co cX wcel wi cG cmagm wcel cB cX wcel cA cX wcel cB cA cG co cX wcel
      cG cmagm wcel cB cX wcel cA cX wcel cB cA cG co cX wcel cB cA cG cX
      reacomsmgrp1.1 clmgm 3exp com13 imp 3adant3 mpan9 cG csem ccm1 cin wcel
      cA cX wcel cB cX wcel cC cX wcel 3simpr3 syl3anc 3eqtrd $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)


    $( Rearrangement of three terms in an commutative semi-group. $)
    reacomsmgrp3 $p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( ( A G B ) G C ) = ( ( A G C ) G B ) )  $=
      cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cG co
      cC cG co cC cA cB cG co cG co cB cA cC cG co cG co cA cC cG co cB cG co
      cG ccm1 wcel cA cB cG co cX wcel cC cX wcel cA cB cG co cC cG co cC cA cB
      cG co cG co wceq cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa cA cB cG co cC cG cX reacomsmgrp1.1 iscomb cG csem ccm1 cin wcel
      cG ccm1 wcel cA cX wcel cB cX wcel cC cX wcel w3a csem ccm1 cin ccm1 cG
      csem ccm1 inss2 sseli adantr cG cmagm wcel cA cX wcel cB cX wcel cA cB cG
      co cX wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel w3a wa
      cA cB cG cX reacomsmgrp1.1 clmgm cG csem ccm1 cin wcel cG cmagm wcel cA
      cX wcel cB cX wcel cC cX wcel w3a cG csem ccm1 cin wcel cG csem wcel cG
      cmagm wcel csem ccm1 cin csem cG csem ccm1 inss1 sseli cG smgrpismgm syl
      adantr cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel 3simpr1 cG
      csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel 3simpr2 syl3anc cG
      csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel 3simpr3 syl3anc cG
      csem ccm1 cin wcel cC cX wcel cA cX wcel cB cX wcel w3a cC cA cB cG co cG
      co cB cA cC cG co cG co wceq cA cX wcel cB cX wcel cC cX wcel w3a cC cA
      cB cG cX reacomsmgrp1.1 reacomsmgrp2 cA cX wcel cB cX wcel cC cX wcel w3a
      cC cX wcel cA cX wcel cB cX wcel cA cX wcel cB cX wcel cC cX wcel 3simp3
      cA cX wcel cB cX wcel cC cX wcel 3simp1 cA cX wcel cB cX wcel cC cX wcel
      3simp2 3jca sylan2 cG ccm1 wcel cB cX wcel cA cC cG co cX wcel cB cA cC
      cG co cG co cA cC cG co cB cG co wceq cG csem ccm1 cin wcel cA cX wcel cB
      cX wcel cC cX wcel w3a wa cB cA cC cG co cG cX reacomsmgrp1.1 iscomb cG
      csem ccm1 cin wcel cG ccm1 wcel cA cX wcel cB cX wcel cC cX wcel w3a csem
      ccm1 cin ccm1 cG csem ccm1 inss2 sseli adantr cG csem ccm1 cin wcel cA cX
      wcel cB cX wcel cC cX wcel 3simpr2 cG cmagm wcel cA cX wcel cC cX wcel cA
      cC cG co cX wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa cA cC cG cX reacomsmgrp1.1 clmgm cG csem ccm1 cin wcel cG cmagm
      wcel cA cX wcel cB cX wcel cC cX wcel w3a cG csem ccm1 cin wcel cG csem
      wcel cG cmagm wcel csem ccm1 cin csem cG csem ccm1 inss1 sseli cG
      smgrpismgm syl adantr cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX
      wcel 3simpr1 cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel
      3simpr3 syl3anc syl3anc 3eqtrd $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)


    $( Rearrangement of terms in an commutative semi-group. $)
    reacomsmgrp4 $p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( A G ( B G C ) ) = ( ( C G B ) G A ) ) $=
      cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cB cC cG
      co cG co cC cB cA cG co cG co cC cB cG co cA cG co cA cB cC cG cX
      reacomsmgrp1.1 reacomsmgrp2 cG csem wcel cC cX wcel cB cX wcel cA cX wcel
      w3a cC cB cA cG co cG co cC cB cG co cA cG co wceq cG csem ccm1 cin wcel
      cA cX wcel cB cX wcel cC cX wcel w3a cG csem wcel cC cX wcel cB cX wcel
      cA cX wcel w3a wa cC cB cG co cA cG co cC cB cA cG co cG co cC cB cA cG
      cX reacomsmgrp1.1 smgrpass2 eqcomd csem ccm1 cin csem cG csem ccm1 inss1
      sseli cA cX wcel cB cX wcel cC cX wcel w3a cC cX wcel cB cX wcel cA cX
      wcel cA cX wcel cB cX wcel cC cX wcel 3simp3 cA cX wcel cB cX wcel cC cX
      wcel 3simp2 cA cX wcel cB cX wcel cC cX wcel 3simp1 3jca syl2an eqtrd $.
      $( [20-Sep-2010] $) $( [18-Sep-2010] $)

  $}



  ${
    $d A g j m $. $d G g k $. $d M g j k m $. $d N g j k $.
    clfsebs.1 $e |- X = dom dom G $.
    $( Closure of a finite composite of elements of the base set of an internal
       operation. $)
    clfsebs $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Magma /\
                      A. k e. ( M ... N ) A e. X )
       -> prod_ k e. ( M ... N ) G A e. X ) $=
      cN cM cuz cfv wcel cG cmagm wcel cA cG cdm cdm wcel vk cM cN cfz co wral
      w3a cM cN cfz co cA vk cG cprd cG cdm cdm wcel cN cM cuz cfv wcel cG
      cmagm wcel cA cX wcel vk cM cN cfz co wral w3a cM cN cfz co cA vk cG cprd
      cX wcel cN cM cuz cfv wcel cG cmagm wcel cA cG cdm cdm wcel vk cM cN cfz
      co wral w3a cM cN cfz co cA vk cG cprd cG cdm cdm wcel cG cmagm wcel cN
      cM cuz cfv wcel cN cM cuz cfv wcel cG cmagm wcel cA cG cdm cdm wcel vk cM
      cN cfz co wral w3a cM cN cfz co cA vk cG cprd cG cdm cdm wcel wi cA cG
      cdm cdm wcel vk cM cN cfz co wral cN cM cuz cfv wcel vg cv cmagm wcel cA
      vg cv cdm cdm wcel vk cM cN cfz co wral w3a cM cN cfz co cA vk vg cv cprd
      vg cv cdm cdm wcel wi cN cM cuz cfv wcel cG cmagm wcel cA cG cdm cdm wcel
      vk cM cN cfz co wral w3a cM cN cfz co cA vk cG cprd cG cdm cdm wcel wi vg
      cG cmagm vg cv cG wceq cN cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm
      cdm wcel vk cM cN cfz co wral w3a cN cM cuz cfv wcel cG cmagm wcel cA cG
      cdm cdm wcel vk cM cN cfz co wral w3a cM cN cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel cM cN cfz co cA vk cG cprd cG cdm cdm wcel vg cv cG wceq vg
      cv cmagm wcel cG cmagm wcel cA vg cv cdm cdm wcel vk cM cN cfz co wral cA
      cG cdm cdm wcel vk cM cN cfz co wral cN cM cuz cfv wcel vg cv cG cmagm
      eleq1 vg cv cG wceq cA vg cv cdm cdm wcel cA cG cdm cdm wcel vk cM cN cfz
      co vg cv cG wceq vg cv cdm cdm cG cdm cdm cA vg cv cG wceq vg cv cdm cG
      cdm vg cv cG dmeq dmeqd eleq2d ralbidv 3anbi23d vg cv cG wceq cM cN cfz
      co cA vk vg cv cprd cM cN cfz co cA vk cG cprd vg cv cdm cdm cG cdm cdm
      cM cN cfz co cA vk vg cv cG prodeq3 vg cv cG wceq vg cv cdm cG cdm vg cv
      cG dmeq dmeqd eleq12d imbi12d cN cM cuz cfv wcel vg cv cmagm wcel cA vg
      cv cdm cdm wcel vk cM cN cfz co wral cM cN cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vj cv cfz co
      wral cM vj cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi wi vg cv
      cmagm wcel cA vg cv cdm cdm wcel vk cM cM cfz co wral cM cM cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel wi wi vg cv cmagm wcel cA vg cv cdm cdm
      wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm
      cdm wcel wi wi vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel wi wi vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM cN cfz co
      wral cM cN cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi wi vj vm cM cN
      vj cv cM wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cM vj cv cfz
      co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM cM
      cfz co wral cM cM cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vg cv
      cmagm wcel vj cv cM wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cA
      vg cv cdm cdm wcel vk cM cM cfz co wral cM vj cv cfz co cA vk vg cv cprd
      vg cv cdm cdm wcel cM cM cfz co cA vk vg cv cprd vg cv cdm cdm wcel vj cv
      cM wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co cM cM cfz co vj cv cM cM
      cfz opreq2 raleq1d vj cv cM wceq cM vj cv cfz co cA vk vg cv cprd cM cM
      cfz co cA vk vg cv cprd vg cv cdm cdm vj cv cM wceq cM vj cv cfz co cM cM
      cfz co cA vk vg cv vj cv cM cM cfz opreq2 prodeq1d eleq1d imbi12d imbi2d
      vj vm weq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cM vj cv cfz co
      cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv
      cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vg cv
      cmagm wcel vj vm weq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cA vg
      cv cdm cdm wcel vk cM vm cv cfz co wral cM vj cv cfz co cA vk vg cv cprd
      vg cv cdm cdm wcel cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel vj
      vm weq cA vg cv cdm cdm wcel vk cM vj cv cfz co cM vm cv cfz co vj cv vm
      cv cM cfz opreq2 raleq1d vj vm weq cM vj cv cfz co cA vk vg cv cprd cM vm
      cv cfz co cA vk vg cv cprd vg cv cdm cdm vj vm weq cM vj cv cfz co cM vm
      cv cfz co cA vk vg cv vj cv vm cv cM cfz opreq2 prodeq1d eleq1d imbi12d
      imbi2d vj cv vm cv c1 caddc co wceq cA vg cv cdm cdm wcel vk cM vj cv cfz
      co wral cM vj cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv
      cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz
      co cA vk vg cv cprd vg cv cdm cdm wcel wi vg cv cmagm wcel vj cv vm cv c1
      caddc co wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cA vg cv cdm
      cdm wcel vk cM vm cv c1 caddc co cfz co wral cM vj cv cfz co cA vk vg cv
      cprd vg cv cdm cdm wcel cM vm cv c1 caddc co cfz co cA vk vg cv cprd vg
      cv cdm cdm wcel vj cv vm cv c1 caddc co wceq cA vg cv cdm cdm wcel vk cM
      vj cv cfz co cM vm cv c1 caddc co cfz co vj cv vm cv c1 caddc co cM cfz
      opreq2 raleq1d vj cv vm cv c1 caddc co wceq cM vj cv cfz co cA vk vg cv
      cprd cM vm cv c1 caddc co cfz co cA vk vg cv cprd vg cv cdm cdm vj cv vm
      cv c1 caddc co wceq cM vj cv cfz co cM vm cv c1 caddc co cfz co cA vk vg
      cv vj cv vm cv c1 caddc co cM cfz opreq2 prodeq1d eleq1d imbi12d imbi2d
      vj cv cN wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cM vj cv cfz
      co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM cN
      cfz co wral cM cN cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vg cv
      cmagm wcel vj cv cN wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co wral cA
      vg cv cdm cdm wcel vk cM cN cfz co wral cM vj cv cfz co cA vk vg cv cprd
      vg cv cdm cdm wcel cM cN cfz co cA vk vg cv cprd vg cv cdm cdm wcel vj cv
      cN wceq cA vg cv cdm cdm wcel vk cM vj cv cfz co cM cN cfz co vj cv cN cM
      cfz opreq2 raleq1d vj cv cN wceq cM vj cv cfz co cA vk vg cv cprd cM cN
      cfz co cA vk vg cv cprd vg cv cdm cdm vj cv cN wceq cM vj cv cfz co cM cN
      cfz co cA vk vg cv vj cv cN cM cfz opreq2 prodeq1d eleq1d imbi12d imbi2d
      vg cv cmagm wcel cM cz wcel cA vg cv cdm cdm wcel vk cM cM cfz co wral cM
      cM cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vg cv cmagm wcel cM cz
      wcel cA vg cv cdm cdm wcel vk cM cM cfz co wral cM cM cfz co cA vk vg cv
      cprd vg cv cdm cdm wcel vg cv cmagm wcel cM cz wcel cA vg cv cdm cdm wcel
      vk cM cM cfz co wral w3a cM cM cfz co cA vk vg cv cprd vk cM cA csb vg cv
      cdm cdm cA vg cv cdm cdm cmagm vk vg cv cM fprod1s1 cM cz wcel cA vg cv
      cdm cdm wcel vk cM cM cfz co wral vk cM cA csb vg cv cdm cdm wcel vg cv
      cmagm wcel cM cM cM cfz co wcel cA vg cv cdm cdm wcel vk cM cM cfz co
      wral vk cM cA csb vg cv cdm cdm wcel cM cz wcel vk cM cM cM cfz co cA vg
      cv cdm cdm ra4csbela cM elfz3 sylan 3adant1 eqeltrd 3exp com12 vm cv cM
      cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co
      wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm
      cdm wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co
      cA vk vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz cfv wcel vg cv cmagm
      wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel wi vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm
      wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm
      cdm wcel wi w3a cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral
      cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv
      cprd vk vm cv c1 caddc co cA csb vg cv co wceq cM vm cv c1 caddc co cfz
      co cA vk vg cv cprd vg cv cdm cdm wcel vm cv cM cuz cfv wcel vg cv cmagm
      wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm
      cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq wi
      vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv
      cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg
      cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv c1 caddc co
      cfz co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1
      caddc co cA csb vg cv co wceq wi wi wi vm cv cM cuz cfv wcel cM cz wcel
      vm cv cz wcel cM vm cv cle wbr w3a vm cv cM cuz cfv wcel vg cv cmagm wcel
      cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv
      cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co
      cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm cv cfz co
      cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq wi wi wi wi cM
      vm cv eluz2 cM cz wcel vm cv cz wcel vm cv cM cuz cfv wcel vg cv cmagm
      wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm
      cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq wi
      wi wi wi cM vm cv cle wbr cM cz wcel vm cv cz wcel wa cM vm cv cfz co cM
      vm cv c1 caddc co cfz co wss vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg
      cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd
      vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz
      co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm cv cfz co cA
      vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq wi wi wi wi cM vm
      cv fzssp1 cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA vg cv cdm
      cdm wcel vk cM vm cv c1 caddc co cfz co wral vg cv cmagm wcel cA vg cv
      cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg
      cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1 caddc co cfz co cA
      vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA
      csb vg cv co wceq cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA vg
      cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral vg cv cmagm wcel cA
      vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv
      cprd vg cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1 caddc co cfz
      co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co
      cA csb vg cv co wceq wi wi wi cM vm cv cfz co cM vm cv c1 caddc co cfz co
      wss cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral wa vg cv
      cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co
      cA vk vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1
      caddc co cfz co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm
      cv c1 caddc co cA csb vg cv co wceq wi wi wi cM vm cv cfz co cM vm cv c1
      caddc co cfz co wss cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co
      wral cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA vg cv cdm cdm
      wcel vk cM vm cv c1 caddc co cfz co wral wa vg cv cmagm wcel cA vg cv cdm
      cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1 caddc co cfz co cA vk
      vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb
      vg cv co wceq wi wi wi wi cM vm cv cfz co cM vm cv c1 caddc co cfz co wss
      cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cA vg cv cdm
      cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cM vm cv c1 caddc co cfz
      co wss cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral wa vg cv
      cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co
      cA vk vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1
      caddc co cfz co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm
      cv c1 caddc co cA csb vg cv co wceq wi wi wi wi cA vg cv cdm cdm wcel vk
      cM vm cv cfz co cM vm cv c1 caddc co cfz co ssralv cA vg cv cdm cdm wcel
      vk cM vm cv cfz co wral cM vm cv cfz co cM vm cv c1 caddc co cfz co wss
      cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral wa vg cv cmagm
      wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1 caddc
      co cfz co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1
      caddc co cA csb vg cv co wceq wi wi cA vg cv cdm cdm wcel vk cM vm cv cfz
      co wral cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA vg cv cdm cdm
      wcel vk cM vm cv c1 caddc co cfz co wral wa vg cv cmagm wcel w3a cA vg cv
      cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg
      cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv c1 caddc co cfz co cA
      vk vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA
      csb vg cv co wceq vm cv cM cuz cfv wcel cA vg cv cdm cdm wcel vk cM vm cv
      c1 caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM
      vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq
      cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cM vm cv c1
      caddc co cfz co wss cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co
      wral wa vg cv cmagm wcel w3a cA vg cv cdm cdm wcel vk cM vm cv cfz co
      wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz
      cfv wcel w3a cA vg cv cdm cdm cvv vk vg cv cM vm cv vg visset fprodp1s cA
      vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cM vm cv c1
      caddc co cfz co wss cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co
      wral wa vg cv cmagm wcel w3a cA vg cv cdm cdm wcel vk cM vm cv cfz co
      wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz
      cfv wcel 3simp3 cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv
      cfz co cM vm cv c1 caddc co cfz co wss cA vg cv cdm cdm wcel vk cM vm cv
      c1 caddc co cfz co wral wa vg cv cmagm wcel w3a cA vg cv cdm cdm wcel vk
      cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel
      wi cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral vm cv cM cuz
      cfv wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA vg cv cdm cdm
      wcel vk cM vm cv c1 caddc co cfz co wral wa cA vg cv cdm cdm wcel vk cM
      vm cv cfz co wral cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co
      wral vg cv cmagm wcel cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA
      vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral pm3.27 3ad2ant2
      3ad2ant1 sylanc 3exp 3exp syl6 imp pm2.43i ex com25 syl 3adant3 sylbi
      pm2.43i 3imp vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel
      vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm
      wcel wi w3a cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cM
      vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm cv cfz co cA vk vg cv
      cprd vk vm cv c1 caddc co cA csb vg cv co wceq cM vm cv c1 caddc co cfz
      co cA vk vg cv cprd vg cv cdm cdm wcel vm cv cM cuz cfv wcel vg cv cmagm
      wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel wi w3a cA vg cv cdm cdm wcel vk cM vm cv c1
      caddc co cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm
      cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq w3a
      cM vm cv c1 caddc co cfz co cA vk vg cv cprd vg cv cdm cdm wcel cM vm cv
      cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co vg cv cdm
      cdm wcel vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk
      cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel
      wi w3a cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv
      cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co vg cv cdm
      cdm wcel cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm cv cfz co cA
      vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co wceq vg cv cmagm wcel
      cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel vk vm cv c1 caddc co
      cA csb vg cv cdm cdm wcel cM vm cv cfz co cA vk vg cv cprd vk vm cv c1
      caddc co cA csb vg cv co vg cv cdm cdm wcel vm cv cM cuz cfv wcel vg cv
      cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co
      cA vk vg cv cprd vg cv cdm cdm wcel wi w3a cA vg cv cdm cdm wcel vk cM vm
      cv c1 caddc co cfz co wral wa cM vm cv cfz co cA vk vg cv cprd vk vm cv
      c1 caddc co cA csb vg cv vg cv cdm cdm vg cv cdm cdm eqid clmgm vm cv cM
      cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co
      wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm
      cdm wcel vk cM vm cv c1 caddc co cfz co wral 3simpl2 vm cv cM cuz cfv
      wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm
      cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk
      cM vm cv c1 caddc co cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel vm cv cz wcel cM cz wcel wa vm cv cM cuz cfv wcel vg cv
      cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co
      cA vk vg cv cprd vg cv cdm cdm wcel wi cA vg cv cdm cdm wcel vk cM vm cv
      c1 caddc co cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm
      wcel wi wi wi vm cv cM cuz cfv wcel vm cv cz wcel cM cz wcel cM vm cv
      eluzelz cM vm cv eluzel2 jca vm cv cz wcel cM cz wcel wa cA vg cv cdm cdm
      wcel vk cM vm cv c1 caddc co cfz co wral vg cv cmagm wcel cA vg cv cdm
      cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv
      cdm cdm wcel wi vm cv cM cuz cfv wcel cM vm cv cfz co cA vk vg cv cprd vg
      cv cdm cdm wcel vm cv cz wcel cM cz wcel wa cA vg cv cdm cdm wcel vk cM
      vm cv c1 caddc co cfz co wral cA vg cv cdm cdm wcel vk cM vm cv cfz co
      wral vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm
      cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vm cv cM cuz cfv wcel cM
      vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi wi wi vm cv cz wcel
      cM cz wcel wa cM vm cv cfz co cM vm cv c1 caddc co cfz co wss cA vg cv
      cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cA vg cv cdm cdm wcel vk
      cM vm cv cfz co wral wi cM cz wcel vm cv cz wcel cM vm cv cfz co cM vm cv
      c1 caddc co cfz co wss cM vm cv fzssp1 ancoms cA vg cv cdm cdm wcel vk cM
      vm cv cfz co cM vm cv c1 caddc co cfz co ssralv syl cA vg cv cdm cdm wcel
      vk cM vm cv cfz co wral cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM
      vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi vg cv cmagm wcel vm
      cv cM cuz cfv wcel cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi
      cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cA vg cv cdm cdm wcel vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi
      cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel vg cv cmagm wcel vm
      cv cM cuz cfv wcel cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi
      wi cA vg cv cdm cdm wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg
      cv cprd vg cv cdm cdm wcel pm2.27 vm cv cM cuz cfv wcel vg cv cmagm wcel
      cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel vg cv cmagm wcel cM vm cv cfz co cA vk vg
      cv cprd vg cv cdm cdm wcel cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm
      wcel wi wi vm cv cM cuz cfv wcel vg cv cmagm wcel cM vm cv cfz co cA vk
      vg cv cprd vg cv cdm cdm wcel idd a1i com13 syl6 com23 syl6 com25 mpcom
      3imp1 vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM
      vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi
      w3a cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral wa vm cv c1
      caddc co cM vm cv c1 caddc co cfz co wcel cA vg cv cdm cdm wcel vk cM vm
      cv c1 caddc co cfz co wral wa vk vm cv c1 caddc co cA csb vg cv cdm cdm
      wcel vm cv c1 caddc co cM cuz cfv wcel cA vg cv cdm cdm wcel vk cM vm cv
      c1 caddc co cfz co wral vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral wa vm cv
      cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co
      wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi w3a vm cv c1
      caddc co cM cuz cfv wcel vm cv c1 caddc co cM vm cv c1 caddc co cfz co
      wcel cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co cfz co wral cM vm cv
      c1 caddc co eluzfz2 anim1i vm cv cM cuz cfv wcel vg cv cmagm wcel vm cv
      c1 caddc co cM cuz cfv wcel cA vg cv cdm cdm wcel vk cM vm cv cfz co wral
      cM vm cv cfz co cA vk vg cv cprd vg cv cdm cdm wcel wi cM vm cv peano2uz
      3ad2ant1 sylan vk vm cv c1 caddc co cM vm cv c1 caddc co cfz co cA vg cv
      cdm cdm ra4csbela syl syl3anc 3adant3 cM vm cv c1 caddc co cfz co cA vk
      vg cv cprd cM vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb
      vg cv co wceq vm cv cM cuz cfv wcel vg cv cmagm wcel cA vg cv cdm cdm
      wcel vk cM vm cv cfz co wral cM vm cv cfz co cA vk vg cv cprd vg cv cdm
      cdm wcel wi w3a cM vm cv c1 caddc co cfz co cA vk vg cv cprd vg cv cdm
      cdm wcel cM vm cv cfz co cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg
      cv co vg cv cdm cdm wcel wb cA vg cv cdm cdm wcel vk cM vm cv c1 caddc co
      cfz co wral cM vm cv c1 caddc co cfz co cA vk vg cv cprd cM vm cv cfz co
      cA vk vg cv cprd vk vm cv c1 caddc co cA csb vg cv co vg cv cdm cdm eleq1
      3ad2ant3 mpbird 3exp mpdd 3exp a2d uzind4 3imp vtoclg 3ad2ant2 pm2.43i cA
      cG cdm cdm wcel vk cM cN cfz co wral cA cX wcel vk cM cN cfz co wral cN
      cM cuz cfv wcel cG cmagm wcel cA cG cdm cdm wcel cA cX wcel vk cM cN cfz
      co cG cdm cdm cX cA cX cG cdm cdm clfsebs.1 eqcomi eleq2i ralbii 3anbi3i
      cG cdm cdm cX cM cN cfz co cA vk cG cprd cX cG cdm cdm clfsebs.1 eqcomi
      eleq2i 3imtr3i $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d G k $. $d M k $. $d N k $.
    $( Closure of a finite composite of elements of the base set of an internal
       operation. (Closed version.) $)
    clfsebsg $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Magma /\
                      A. k e. ( M ... N ) A e. dom dom G )
       -> prod_ k e. ( M ... N ) G A e. dom dom G ) $=
      cA vk cG cM cN cG cdm cdm cG cdm cdm eqid clfsebs $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d G k $. $d M k $. $d N k $.
    clfsebsr.1 $e |- X = ran G $.
    $( Closure of a finite composite of elements of the base set of an internal
       operation. (Case of a magma with an identity element.) $)
    clfsebsr $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. ( Magma i^i ExId ) /\
                      A. k e. ( M ... N ) A e. X )
       -> prod_ k e. ( M ... N ) G A e. X ) $=
      cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co
      wral w3a cM cN cfz co cA vk cG cprd cG cdm cdm cX cN cM cuz cfv wcel cG
      cmagm wcel cA cG cdm cdm wcel vk cM cN cfz co wral cM cN cfz co cA vk cG
      cprd cG cdm cdm wcel cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX
      wcel vk cM cN cfz co wral w3a cA vk cG cM cN clfsebsg cN cM cuz cfv wcel
      cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co wral 3simp1 cG cmagm
      cexid cin wcel cN cM cuz cfv wcel cG cmagm wcel cA cX wcel vk cM cN cfz
      co wral cmagm cexid cin cmagm cG cmagm cexid inss1 sseli 3ad2ant2 cN cM
      cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co wral cA
      cG cdm cdm wcel vk cM cN cfz co wral cG cmagm cexid cin wcel cA cX wcel
      vk cM cN cfz co wral cA cG cdm cdm wcel vk cM cN cfz co wral wi wi cN cM
      cuz cfv wcel cG cmagm cexid cin wcel cG crn cG cdm cdm wceq cA cX wcel vk
      cM cN cfz co wral cA cG cdm cdm wcel vk cM cN cfz co wral wi cG rngopid
      cG crn cG cdm cdm wceq cA cX wcel vk cM cN cfz co wral cA cG cdm cdm wcel
      vk cM cN cfz co wral cG crn cG cdm cdm wceq cA cX wcel cA cG cdm cdm wcel
      vk cM cN cfz co cG crn cG cdm cdm wceq cX cG cdm cdm cA cG crn cG cdm cdm
      wceq cX cG cdm cdm wceq cG crn cX cG cdm cdm cX cG crn clfsebsr.1 eqcomi
      eqeq1i biimpi eleq2d ralbidv biimpd syl a1i 3imp syl3anc cG cmagm cexid
      cin wcel cN cM cuz cfv wcel cX cG cdm cdm wceq cA cX wcel vk cM cN cfz co
      wral cG cmagm cexid cin wcel cG crn cG cdm cdm cX cG rngopid clfsebsr.1
      syl5eq 3ad2ant2 eleqtrrd $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}


  ${
    $d G k $. $d M k $. $d N k $. $d X k $.
    clfsebs2.1 $e |- X = ran G $.
    $d G k $. $d M k $. $d N k $.
    $( Closure of a finite composite of elements of the base set of an internal
       operation (when the operation has an identity element). $)
    clfsebs2 $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. ( Magma i^i ExId ) /\
                      A. k e. ( M ... N ) A e. X )
       -> prod_ k e. ( M ... N ) G A e. X ) $=
      cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co
      wral w3a cM cN cfz co cA vk cG cprd cX wcel cG cmagm cexid cin wcel cN cM
      cuz cfv wcel cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel vk cM
      cN cfz co wral w3a cM cN cfz co cA vk cG cprd cX wcel wi cA cX wcel vk cM
      cN cfz co wral cX cG crn wceq cG crn cG cdm cdm wceq cN cM cuz cfv wcel
      cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co wral w3a cM cN cfz co
      cA vk cG cprd cX wcel wi cG cmagm cexid cin wcel cX cG crn wceq cG crn cG
      cdm cdm wceq wa cX cG cdm cdm wceq cN cM cuz cfv wcel cG cmagm cexid cin
      wcel cA cX wcel vk cM cN cfz co wral w3a cM cN cfz co cA vk cG cprd cX
      wcel wi cX cG crn cG cdm cdm eqtr cX cG cdm cdm wceq cN cM cuz cfv wcel
      cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co wral w3a cM cN cfz co
      cA vk cG cprd cX wcel wi cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cG
      cdm cdm wcel vk cM cN cfz co wral w3a cM cN cfz co cA vk cG cprd cG cdm
      cdm wcel wi cN cM cuz cfv wcel cG cmagm wcel cA cG cdm cdm wcel vk cM cN
      cfz co wral cM cN cfz co cA vk cG cprd cG cdm cdm wcel cG cmagm cexid cin
      wcel cA vk cG cM cN cG cdm cdm cG cdm cdm eqid clfsebs cmagm cexid cin
      cmagm cG cmagm cexid inss1 sseli syl3an2 cX cG cdm cdm wceq cN cM cuz cfv
      wcel cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co wral w3a cN cM
      cuz cfv wcel cG cmagm cexid cin wcel cA cG cdm cdm wcel vk cM cN cfz co
      wral w3a cM cN cfz co cA vk cG cprd cX wcel cM cN cfz co cA vk cG cprd cG
      cdm cdm wcel cX cG cdm cdm wceq cA cX wcel vk cM cN cfz co wral cA cG cdm
      cdm wcel vk cM cN cfz co wral cN cM cuz cfv wcel cG cmagm cexid cin wcel
      cX cG cdm cdm wceq cA cX wcel cA cG cdm cdm wcel vk cM cN cfz co cX cG
      cdm cdm cA eleq2 ralbidv 3anbi3d cX cG cdm cdm cM cN cfz co cA vk cG cprd
      eleq2 imbi12d mpbiri syl clfsebs2.1 cG rngopid sylancr 3ad2ant2 pm2.43i
      $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d G g $. $d M g j k l $. $d N g j k $. $d U g k $. $d g k l y $.
    fincmpzer.1 $e |- U = ( Id ` G ) $.
    $( Finite composite of identity elements. $)
    fincmpzer $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. ( Magma i^i ExId ) )
       -> prod_ k e. ( M ... N ) G U = U ) $=
      cN cM cuz cfv wcel cG cmagm cexid cin wcel wa cU cG cgi cfv wceq cM cN
      cfz co cU vk cG cprd cU wceq fincmpzer.1 cN cM cuz cfv wcel cG cmagm
      cexid cin wcel cU cG cgi cfv wceq cM cN cfz co cU vk cG cprd cU wceq wi
      cN cM cuz cfv wcel vg cv cmagm cexid cin wcel wa cU vg cv cgi cfv wceq cM
      cN cfz co cU vk vg cv cprd cU wceq wi wi cN cM cuz cfv wcel cG cmagm
      cexid cin wcel wa cU cG cgi cfv wceq cM cN cfz co cU vk cG cprd cU wceq
      wi wi vg cG cmagm cexid cin vg cv cG wceq cN cM cuz cfv wcel vg cv cmagm
      cexid cin wcel wa cN cM cuz cfv wcel cG cmagm cexid cin wcel wa cU vg cv
      cgi cfv wceq cM cN cfz co cU vk vg cv cprd cU wceq wi cU cG cgi cfv wceq
      cM cN cfz co cU vk cG cprd cU wceq wi vg cv cG wceq vg cv cmagm cexid cin
      wcel cG cmagm cexid cin wcel cN cM cuz cfv wcel vg cv cG cmagm cexid cin
      eleq1 anbi2d vg cv cG wceq cU vg cv cgi cfv wceq cU cG cgi cfv wceq cM cN
      cfz co cU vk vg cv cprd cU wceq cM cN cfz co cU vk cG cprd cU wceq vg cv
      cG wceq vg cv cgi cfv cG cgi cfv cU vg cv cG cgi fveq2 eqeq2d vg cv cG
      wceq cM cN cfz co cU vk vg cv cprd cM cN cfz co cU vk cG cprd cU cM cN
      cfz co cU vk vg cv cG prodeq3 eqeq1d imbi12d imbi12d cU vg cv cgi cfv
      wceq cM cN cfz co cU vk vg cv cprd cU wceq cM cN cfz co vg cv cgi cfv vk
      vg cv cprd vg cv cgi cfv wceq cN cM cuz cfv wcel vg cv cmagm cexid cin
      wcel wa cU vg cv cgi cfv wceq cM cN cfz co cU vk vg cv cprd cM cN cfz co
      vg cv cgi cfv vk vg cv cprd cU vg cv cgi cfv cU vg cv cgi cfv wceq cU vg
      cv cgi cfv wceq vk wal cM cN cfz co cU vk vg cv cprd cM cN cfz co vg cv
      cgi cfv vk vg cv cprd wceq cU vg cv cgi cfv wceq vk ax-17 cU vg cv cgi
      cfv wceq vk wal cM cN cfz co cU vg cv cgi cfv vk cvv vg cv cU vg cv cgi
      cfv wceq vk cM cN cfz co alral vg visset prodeq3d syl cU vg cv cgi cfv
      wceq id eqeq12d cN cM cuz cfv wcel vg cv cmagm cexid cin wcel cM cN cfz
      co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq vg cv cmagm cexid cin
      wcel cM vj cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq wi vg
      cv cmagm cexid cin wcel cM cM cfz co vg cv cgi cfv vk vg cv cprd vg cv
      cgi cfv wceq wi vg cv cmagm cexid cin wcel cM vl cv cfz co vg cv cgi cfv
      vk vg cv cprd vg cv cgi cfv wceq wi vg cv cmagm cexid cin wcel cM vl cv
      c1 caddc co cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq wi vg
      cv cmagm cexid cin wcel cM cN cfz co vg cv cgi cfv vk vg cv cprd vg cv
      cgi cfv wceq wi vj vl cM cN vj cv cM wceq cM vj cv cfz co vg cv cgi cfv
      vk vg cv cprd vg cv cgi cfv wceq cM cM cfz co vg cv cgi cfv vk vg cv cprd
      vg cv cgi cfv wceq vg cv cmagm cexid cin wcel vj cv cM wceq cM vj cv cfz
      co vg cv cgi cfv vk vg cv cprd cM cM cfz co vg cv cgi cfv vk vg cv cprd
      vg cv cgi cfv vj cv cM wceq cM vj cv cfz co cM cM cfz co vg cv cgi cfv vk
      vg cv vj cv cM cM cfz opreq2 prodeq1d eqeq1d imbi2d vj vl weq cM vj cv
      cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq cM vl cv cfz co vg
      cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq vg cv cmagm cexid cin wcel vj
      vl weq cM vj cv cfz co vg cv cgi cfv vk vg cv cprd cM vl cv cfz co vg cv
      cgi cfv vk vg cv cprd vg cv cgi cfv vj vl weq cM vj cv cfz co cM vl cv
      cfz co vg cv cgi cfv vk vg cv vj cv vl cv cM cfz opreq2 prodeq1d eqeq1d
      imbi2d vj cv vl cv c1 caddc co wceq cM vj cv cfz co vg cv cgi cfv vk vg
      cv cprd vg cv cgi cfv wceq cM vl cv c1 caddc co cfz co vg cv cgi cfv vk
      vg cv cprd vg cv cgi cfv wceq vg cv cmagm cexid cin wcel vj cv vl cv c1
      caddc co wceq cM vj cv cfz co vg cv cgi cfv vk vg cv cprd cM vl cv c1
      caddc co cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv vj cv vl cv c1
      caddc co wceq cM vj cv cfz co cM vl cv c1 caddc co cfz co vg cv cgi cfv
      vk vg cv vj cv vl cv c1 caddc co cM cfz opreq2 prodeq1d eqeq1d imbi2d vj
      cv cN wceq cM vj cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq
      cM cN cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq vg cv cmagm
      cexid cin wcel vj cv cN wceq cM vj cv cfz co vg cv cgi cfv vk vg cv cprd
      cM cN cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv vj cv cN wceq cM
      vj cv cfz co cM cN cfz co vg cv cgi cfv vk vg cv vj cv cN cM cfz opreq2
      prodeq1d eqeq1d imbi2d cM cz wcel cM cM cfz co vg cv cgi cfv vk vg cv
      cprd vg cv cgi cfv wceq vg cv cmagm cexid cin wcel vg cv cgi cfv cvv wcel
      cM cz wcel cM cM cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq vg
      cv cgi fvex vg cv cgi cfv vg cv cgi cfv cvv cvv vk vg cv cM vk cv cM wceq
      vg cv cgi cfv eqidd vg visset fprod1i mpan a1d vl cv cM cuz cfv wcel vg
      cv cmagm cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv
      cgi cfv wceq wi vg cv cmagm cexid cin wcel cM vl cv c1 caddc co cfz co vg
      cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq vl cv cM cuz cfv wcel vg cv
      cmagm cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv
      cgi cfv wceq wi vg cv cmagm cexid cin wcel w3a cM vl cv c1 caddc co cfz
      co vg cv cgi cfv vk vg cv cprd cM vl cv cfz co vg cv cgi cfv vk vg cv
      cprd vk vl cv c1 caddc co vg cv cgi cfv csb vg cv co vg cv cgi cfv vg cv
      cgi cfv vg cv co vg cv cgi cfv vl cv cM cuz cfv wcel vg cv cgi cfv cvv
      wcel vk cM vl cv c1 caddc co cfz co wral cM vl cv c1 caddc co cfz co vg
      cv cgi cfv vk vg cv cprd cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vk
      vl cv c1 caddc co vg cv cgi cfv csb vg cv co wceq vl cv cM cuz cfv wcel
      vg cv cmagm cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg
      cv cgi cfv wceq wi vg cv cmagm cexid cin wcel w3a vg cv cgi cfv cvv cvv
      vk vg cv cM vl cv vg visset fprodp1s vl cv cM cuz cfv wcel vg cv cmagm
      cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv
      wceq wi vg cv cmagm cexid cin wcel 3simp1 vg cv cgi cfv cvv wcel vk cM vl
      cv c1 caddc co cfz co vg cv cgi cfv cvv wcel vk cv cM vl cv c1 caddc co
      cfz co wcel vg cv cgi fvex a1i rgen sylancl vl cv cM cuz cfv wcel vg cv
      cmagm cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv
      cgi cfv wceq wi vg cv cmagm cexid cin wcel w3a cM vl cv cfz co vg cv cgi
      cfv vk vg cv cprd vg cv cgi cfv vk vl cv c1 caddc co vg cv cgi cfv csb vg
      cv cgi cfv vg cv vl cv cM cuz cfv wcel vg cv cmagm cexid cin wcel cM vl
      cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq wi vg cv cmagm
      cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv
      wceq vl cv cM cuz cfv wcel vg cv cmagm cexid cin wcel cM vl cv cfz co vg
      cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq wi idd 3imp vk vl cv c1 caddc
      co vg cv cgi cfv csb vg cv cgi cfv wceq vl cv cM cuz cfv wcel vg cv cmagm
      cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv
      wceq wi vg cv cmagm cexid cin wcel w3a vl cv c1 caddc co cvv wcel vk vl
      cv c1 caddc co vg cv cgi cfv csb vg cv cgi cfv wceq vl cv c1 caddc oprex
      vk vy vl cv c1 caddc co vg cv cgi cfv cvv vy cv vg cv cgi cfv wcel vk
      ax-17 csbconstgf ax-mp a1i opreq12d vl cv cM cuz cfv wcel vg cv cmagm
      cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv
      wceq wi vg cv cmagm cexid cin wcel w3a vg cv cgi cfv vg cv cgi cfv vg cv
      co vg cv cgi cfv wceq vg cv cgi cfv vg cv cgi cfv vg cv co vg cv cgi cfv
      wceq vg cv cmagm cexid cin wcel vg cv cgi cfv vg cv crn wcel vg cv cgi
      cfv vg cv cgi cfv vg cv co vg cv cgi cfv wceq vg cv cgi cfv vg cv cgi cfv
      vg cv co vg cv cgi cfv wceq wa vl cv cM cuz cfv wcel vg cv cmagm cexid
      cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq
      wi vg cv cmagm cexid cin wcel w3a vg cv cgi cfv vg cv cgi cfv vg cv vg cv
      crn vg cv crn eqid vg cv cgi cfv eqid cmpidelt vl cv cM cuz cfv wcel vg
      cv cmagm cexid cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv
      cgi cfv wceq wi vg cv cmagm cexid cin wcel 3simp3 vg cv cmagm cexid cin
      wcel vl cv cM cuz cfv wcel vg cv cgi cfv vg cv crn wcel vg cv cmagm cexid
      cin wcel cM vl cv cfz co vg cv cgi cfv vk vg cv cprd vg cv cgi cfv wceq
      wi vg cv cgi cfv vg cv vg cv crn vg cv crn eqid vg cv cgi cfv eqid iorlid
      3ad2ant3 sylanc pm3.26d 3eqtrd 3exp uzind4 imp syl5cbir vtoclg anabsi7
      mpi $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
  resgcom.1 $e |- X = dom dom G $.
  $( Rearrangement of four terms in a commutative, associative magma. $)
  resgcom $p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
  ( ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X ) ) )
   -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
    cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa
    wa cA cB cG co cC cD cG co cG co cA cB cC cD cG co cG co cG co cA cC cB cD
    cG co cG co cG co cA cC cG co cB cD cG co cG co cG csem wcel cA cX wcel cB
    cX wcel cC cD cG co cX wcel w3a cA cB cG co cC cD cG co cG co cA cB cC cD
    cG co cG co cG co wceq cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cC cX
    wcel cD cX wcel wa wa wa cA cB cC cD cG co cG cX resgcom.1 smgrpass2 cG
    csem ccm1 cin wcel cG csem wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX
    wcel wa wa csem ccm1 cin csem cG csem ccm1 inss1 sseli adantr cG csem ccm1
    cin wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa wa cA cX wcel
    cB cX wcel cC cD cG co cX wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel
    cC cX wcel cD cX wcel wa simprll cG csem ccm1 cin wcel cA cX wcel cB cX
    wcel cC cX wcel cD cX wcel wa simprlr cG csem ccm1 cin wcel cA cX wcel cB
    cX wcel wa cC cX wcel cD cX wcel wa wa cC cD cG co cX wcel cG csem ccm1 cin
    wcel cG csem wcel cG cmagm wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX
    wcel wa wa cC cD cG co cX wcel wi csem ccm1 cin csem cG csem ccm1 inss1
    sseli cG smgrpismgm cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cG
    cmagm wcel cC cD cG co cX wcel cC cX wcel cD cX wcel wa cG cmagm wcel cC cD
    cG co cX wcel wi cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel cG cmagm
    wcel cC cD cG co cX wcel wi cG cmagm wcel cC cX wcel cD cX wcel cC cD cG co
    cX wcel cG cmagm wcel cC cX wcel cD cX wcel cC cD cG co cX wcel cC cD cG cX
    resgcom.1 clmgm 3exp com3l imp adantl com12 3syl imp 3jca sylanc cG csem
    ccm1 cin wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa wa cB cC
    cD cG co cG co cC cB cD cG co cG co cA cG cG csem ccm1 cin wcel cB cX wcel
    cC cX wcel cD cX wcel w3a cB cC cD cG co cG co cC cB cD cG co cG co wceq cA
    cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cB cC cD cG cX resgcom.1
    reacomsmgrp1 cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa cB cX
    wcel cC cX wcel cD cX wcel cA cX wcel cB cX wcel cC cX wcel cD cX wcel wa
    simplr cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel simprl cA cX wcel cB
    cX wcel wa cC cX wcel cD cX wcel simprr 3jca sylan2 opreq2d cG csem wcel cA
    cX wcel cC cX wcel cB cD cG co cX wcel w3a cA cC cB cD cG co cG co cG co cA
    cC cG co cB cD cG co cG co wceq cG csem ccm1 cin wcel cA cX wcel cB cX wcel
    wa cC cX wcel cD cX wcel wa wa wa cG csem wcel cA cX wcel cC cX wcel cB cD
    cG co cX wcel w3a wa cA cC cG co cB cD cG co cG co cA cC cB cD cG co cG co
    cG co cA cC cB cD cG co cG cX resgcom.1 smgrpass2 eqcomd cG csem ccm1 cin
    wcel cG csem wcel cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa csem
    ccm1 cin csem cG csem ccm1 inss1 sseli adantr cG csem ccm1 cin wcel cA cX
    wcel cB cX wcel wa cC cX wcel cD cX wcel wa wa wa cA cX wcel cC cX wcel cB
    cD cG co cX wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel cC cX wcel cD
    cX wcel wa simprll cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cC cX
    wcel cD cX wcel simprrl cG csem ccm1 cin wcel cG cmagm wcel cA cX wcel cB
    cX wcel wa cC cX wcel cD cX wcel wa wa cB cD cG co cX wcel cG csem ccm1 cin
    wcel cG csem wcel cG cmagm wcel csem ccm1 cin csem cG csem ccm1 inss1 sseli
    cG smgrpismgm syl cA cX wcel cB cX wcel wa cC cX wcel cD cX wcel wa cG
    cmagm wcel cB cD cG co cX wcel wi cB cX wcel cC cX wcel cD cX wcel wa cG
    cmagm wcel cB cD cG co cX wcel wi wi cA cX wcel cC cX wcel cD cX wcel wa cB
    cX wcel cG cmagm wcel cB cD cG co cX wcel wi cD cX wcel cB cX wcel cG cmagm
    wcel cB cD cG co cX wcel wi wi cC cX wcel cG cmagm wcel cB cX wcel cD cX
    wcel cB cD cG co cX wcel cG cmagm wcel cB cX wcel cD cX wcel cB cD cG co cX
    wcel cB cD cG cX resgcom.1 clmgm 3exp com13 adantl com12 adantl imp mpan9
    3jca sylanc 3eqtrd $.
    $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d A j l $. $d B j l $. $d G j k l $. $d M j k l $. $d N j k $.
    $d X j k l $.
    fprodadd.1 $e |- X = dom dom G $.
    $( The composite of two finite composites. $)
    fprodadd $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
       ( A e. X /\ B e. X ) /\ G e. ( SemiGrp i^i Com1 ) ) ->
       prod_ k e. ( M ... N ) G ( A G B ) =
         ( prod_ k e. ( M ... N ) G A G prod_ k e. ( M ... N ) G B ) ) $=
      cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG csem
      ccm1 cin wcel cM cN cfz co cA cB cG co vk cG cprd cM cN cfz co cA vk cG
      cprd cM cN cfz co cB vk cG cprd cG co wceq cA cX wcel cB cX wcel wa vk cM
      vj cv cfz co wral cG csem ccm1 cin wcel wa cM vj cv cfz co cA cB cG co vk
      cG cprd cM vj cv cfz co cA vk cG cprd cM vj cv cfz co cB vk cG cprd cG co
      wceq wi cA cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin
      wcel wa cM cM cfz co cA cB cG co vk cG cprd cM cM cfz co cA vk cG cprd cM
      cM cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl
      cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG
      cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co
      wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel wa cM vl cv c1 caddc co cfz co cA cB cG co vk cG cprd
      cM vl cv c1 caddc co cfz co cA vk cG cprd cM vl cv c1 caddc co cfz co cB
      vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG
      csem ccm1 cin wcel wa cM cN cfz co cA cB cG co vk cG cprd cM cN cfz co cA
      vk cG cprd cM cN cfz co cB vk cG cprd cG co wceq wi vj vl cM cN vj cv cM
      wceq cA cX wcel cB cX wcel wa vk cM vj cv cfz co wral cG csem ccm1 cin
      wcel wa cA cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin
      wcel wa cM vj cv cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG
      cprd cM vj cv cfz co cB vk cG cprd cG co wceq cM cM cfz co cA cB cG co vk
      cG cprd cM cM cfz co cA vk cG cprd cM cM cfz co cB vk cG cprd cG co wceq
      vj cv cM wceq cA cX wcel cB cX wcel wa vk cM vj cv cfz co wral cA cX wcel
      cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel vj cv cM wceq cA
      cX wcel cB cX wcel wa vk cM vj cv cfz co cM cM cfz co vj cv cM cM cfz
      opreq2 raleq1d anbi1d vj cv cM wceq cM vj cv cfz co cA cB cG co vk cG
      cprd cM cM cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG cprd cM
      vj cv cfz co cB vk cG cprd cG co cM cM cfz co cA vk cG cprd cM cM cfz co
      cB vk cG cprd cG co vj cv cM wceq cM vj cv cfz co cM cM cfz co cA cB cG
      co vk cG vj cv cM cM cfz opreq2 prodeq1d vj cv cM wceq cM vj cv cfz co cA
      vk cG cprd cM cM cfz co cA vk cG cprd cM vj cv cfz co cB vk cG cprd cM cM
      cfz co cB vk cG cprd cG vj cv cM wceq cM vj cv cfz co cM cM cfz co cA vk
      cG vj cv cM cM cfz opreq2 prodeq1d vj cv cM wceq cM vj cv cfz co cM cM
      cfz co cB vk cG vj cv cM cM cfz opreq2 prodeq1d opreq12d eqeq12d imbi12d
      vj vl weq cA cX wcel cB cX wcel wa vk cM vj cv cfz co wral cG csem ccm1
      cin wcel wa cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1
      cin wcel wa cM vj cv cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk
      cG cprd cM vj cv cfz co cB vk cG cprd cG co wceq cM vl cv cfz co cA cB cG
      co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd
      cG co wceq vj vl weq cA cX wcel cB cX wcel wa vk cM vj cv cfz co wral cA
      cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel vj vl
      weq cA cX wcel cB cX wcel wa vk cM vj cv cfz co cM vl cv cfz co vj cv vl
      cv cM cfz opreq2 raleq1d anbi1d vj vl weq cM vj cv cfz co cA cB cG co vk
      cG cprd cM vl cv cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG
      cprd cM vj cv cfz co cB vk cG cprd cG co cM vl cv cfz co cA vk cG cprd cM
      vl cv cfz co cB vk cG cprd cG co vj vl weq cM vj cv cfz co cM vl cv cfz
      co cA cB cG co vk cG vj cv vl cv cM cfz opreq2 prodeq1d vj vl weq cM vj
      cv cfz co cA vk cG cprd cM vl cv cfz co cA vk cG cprd cM vj cv cfz co cB
      vk cG cprd cM vl cv cfz co cB vk cG cprd cG vj vl weq cM vj cv cfz co cM
      vl cv cfz co cA vk cG vj cv vl cv cM cfz opreq2 prodeq1d vj vl weq cM vj
      cv cfz co cM vl cv cfz co cB vk cG vj cv vl cv cM cfz opreq2 prodeq1d
      opreq12d eqeq12d imbi12d vj cv vl cv c1 caddc co wceq cA cX wcel cB cX
      wcel wa vk cM vj cv cfz co wral cG csem ccm1 cin wcel wa cA cX wcel cB cX
      wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa cM
      vj cv cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG cprd cM vj
      cv cfz co cB vk cG cprd cG co wceq cM vl cv c1 caddc co cfz co cA cB cG
      co vk cG cprd cM vl cv c1 caddc co cfz co cA vk cG cprd cM vl cv c1 caddc
      co cfz co cB vk cG cprd cG co wceq vj cv vl cv c1 caddc co wceq cA cX
      wcel cB cX wcel wa vk cM vj cv cfz co wral cA cX wcel cB cX wcel wa vk cM
      vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel vj cv vl cv c1 caddc
      co wceq cA cX wcel cB cX wcel wa vk cM vj cv cfz co cM vl cv c1 caddc co
      cfz co vj cv vl cv c1 caddc co cM cfz opreq2 raleq1d anbi1d vj cv vl cv
      c1 caddc co wceq cM vj cv cfz co cA cB cG co vk cG cprd cM vl cv c1 caddc
      co cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG cprd cM vj cv
      cfz co cB vk cG cprd cG co cM vl cv c1 caddc co cfz co cA vk cG cprd cM
      vl cv c1 caddc co cfz co cB vk cG cprd cG co vj cv vl cv c1 caddc co wceq
      cM vj cv cfz co cM vl cv c1 caddc co cfz co cA cB cG co vk cG vj cv vl cv
      c1 caddc co cM cfz opreq2 prodeq1d vj cv vl cv c1 caddc co wceq cM vj cv
      cfz co cA vk cG cprd cM vl cv c1 caddc co cfz co cA vk cG cprd cM vj cv
      cfz co cB vk cG cprd cM vl cv c1 caddc co cfz co cB vk cG cprd cG vj cv
      vl cv c1 caddc co wceq cM vj cv cfz co cM vl cv c1 caddc co cfz co cA vk
      cG vj cv vl cv c1 caddc co cM cfz opreq2 prodeq1d vj cv vl cv c1 caddc co
      wceq cM vj cv cfz co cM vl cv c1 caddc co cfz co cB vk cG vj cv vl cv c1
      caddc co cM cfz opreq2 prodeq1d opreq12d eqeq12d imbi12d vj cv cN wceq cA
      cX wcel cB cX wcel wa vk cM vj cv cfz co wral cG csem ccm1 cin wcel wa cA
      cX wcel cB cX wcel wa vk cM cN cfz co wral cG csem ccm1 cin wcel wa cM vj
      cv cfz co cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG cprd cM vj cv
      cfz co cB vk cG cprd cG co wceq cM cN cfz co cA cB cG co vk cG cprd cM cN
      cfz co cA vk cG cprd cM cN cfz co cB vk cG cprd cG co wceq vj cv cN wceq
      cA cX wcel cB cX wcel wa vk cM vj cv cfz co wral cA cX wcel cB cX wcel wa
      vk cM cN cfz co wral cG csem ccm1 cin wcel vj cv cN wceq cA cX wcel cB cX
      wcel wa vk cM vj cv cfz co cM cN cfz co vj cv cN cM cfz opreq2 raleq1d
      anbi1d vj cv cN wceq cM vj cv cfz co cA cB cG co vk cG cprd cM cN cfz co
      cA cB cG co vk cG cprd cM vj cv cfz co cA vk cG cprd cM vj cv cfz co cB
      vk cG cprd cG co cM cN cfz co cA vk cG cprd cM cN cfz co cB vk cG cprd cG
      co vj cv cN wceq cM vj cv cfz co cM cN cfz co cA cB cG co vk cG vj cv cN
      cM cfz opreq2 prodeq1d vj cv cN wceq cM vj cv cfz co cA vk cG cprd cM cN
      cfz co cA vk cG cprd cM vj cv cfz co cB vk cG cprd cM cN cfz co cB vk cG
      cprd cG vj cv cN wceq cM vj cv cfz co cM cN cfz co cA vk cG vj cv cN cM
      cfz opreq2 prodeq1d vj cv cN wceq cM vj cv cfz co cM cN cfz co cB vk cG
      vj cv cN cM cfz opreq2 prodeq1d opreq12d eqeq12d imbi12d cM cz wcel cA cX
      wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel wa cM cM
      cfz co cA cB cG co vk cG cprd cM cM cfz co cA vk cG cprd cM cM cfz co cB
      vk cG cprd cG co wceq cM cz wcel cA cX wcel cB cX wcel wa vk cM cM cfz co
      wral cG csem ccm1 cin wcel wa wa vk cM cA cB cG co csb vk cM cA csb vk cM
      cB csb cG co cM cM cfz co cA cB cG co vk cG cprd cM cM cfz co cA vk cG
      cprd cM cM cfz co cB vk cG cprd cG co cM cz wcel vk cM cA cB cG co csb vk
      cM cA csb vk cM cB csb cG co wceq cA cX wcel cB cX wcel wa vk cM cM cfz
      co wral cG csem ccm1 cin wcel wa vk cM cA cB cz cG csbopr12g adantr cG
      csem ccm1 cin wcel cM cz wcel cA cB cG co cX wcel vk cM cM cfz co wral cM
      cM cfz co cA cB cG co vk cG cprd vk cM cA cB cG co csb wceq cM cz wcel cA
      cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel wa wa cA
      cB cG co cX csem ccm1 cin vk cG cM fprod1s1 cM cz wcel cA cX wcel cB cX
      wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel simprr cM cz wcel cA
      cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel wa
      pm3.26 cA cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin
      wcel wa cA cB cG co cX wcel vk cM cM cfz co wral cM cz wcel cG csem ccm1
      cin wcel cA cX wcel cB cX wcel wa vk cM cM cfz co wral cA cB cG co cX
      wcel vk cM cM cfz co wral cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa
      cA cB cG co cX wcel vk cM cM cfz co cG csem ccm1 cin wcel cA cX wcel cB
      cX wcel cA cB cG co cX wcel cG csem ccm1 cin wcel cG cmagm wcel cA cX
      wcel cB cX wcel cA cB cG co cX wcel wi wi cG csem ccm1 cin wcel cG csem
      wcel cG cmagm wcel csem ccm1 cin csem cG csem ccm1 inss1 sseli cG
      smgrpismgm syl cG cmagm wcel cA cX wcel cB cX wcel cA cB cG co cX wcel cA
      cB cG cX fprodadd.1 clmgm 3exp syl imp3a r19.20sdv impcom adantl syl3anc
      cM cz wcel cA cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin
      wcel wa wa cM cM cfz co cA vk cG cprd vk cM cA csb cM cM cfz co cB vk cG
      cprd vk cM cB csb cG cG csem ccm1 cin wcel cM cz wcel cA cX wcel vk cM cM
      cfz co wral cM cM cfz co cA vk cG cprd vk cM cA csb wceq cM cz wcel cA cX
      wcel cB cX wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel wa wa cA cX
      csem ccm1 cin vk cG cM fprod1s1 cM cz wcel cA cX wcel cB cX wcel wa vk cM
      cM cfz co wral cG csem ccm1 cin wcel simprr cM cz wcel cA cX wcel cB cX
      wcel wa vk cM cM cfz co wral cG csem ccm1 cin wcel wa pm3.26 cA cX wcel
      cB cX wcel wa vk cM cM cfz co wral cA cX wcel vk cM cM cfz co wral cM cz
      wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cA cX wcel vk cM cM
      cfz co cA cX wcel cB cX wcel pm3.26 r19.20si ad2antrl syl3anc cG csem
      ccm1 cin wcel cM cz wcel cB cX wcel vk cM cM cfz co wral cM cM cfz co cB
      vk cG cprd vk cM cB csb wceq cM cz wcel cA cX wcel cB cX wcel wa vk cM cM
      cfz co wral cG csem ccm1 cin wcel wa wa cB cX csem ccm1 cin vk cG cM
      fprod1s1 cM cz wcel cA cX wcel cB cX wcel wa vk cM cM cfz co wral cG csem
      ccm1 cin wcel simprr cM cz wcel cA cX wcel cB cX wcel wa vk cM cM cfz co
      wral cG csem ccm1 cin wcel wa pm3.26 cA cX wcel cB cX wcel wa vk cM cM
      cfz co wral cB cX wcel vk cM cM cfz co wral cM cz wcel cG csem ccm1 cin
      wcel cA cX wcel cB cX wcel wa cB cX wcel vk cM cM cfz co cA cX wcel cB cX
      wcel pm3.27 r19.20si ad2antrl syl3anc opreq12d 3eqtr4d ex vl cv cM cuz
      cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1
      cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk
      cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel
      wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa cM vl cv
      c1 caddc co cfz co cA cB cG co vk cG cprd cM vl cv c1 caddc co cfz co cA
      vk cG cprd cM vl cv c1 caddc co cfz co cB vk cG cprd cG co wceq vl cv cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem
      ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co
      cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB
      cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa
      w3a cM vl cv cfz co cA cB cG co vk cG cprd vk vl cv c1 caddc co cA cB cG
      co csb cG co cM vl cv cfz co cA vk cG cprd vk vl cv c1 caddc co cA csb cG
      co cM vl cv cfz co cB vk cG cprd vk vl cv c1 caddc co cB csb cG co cG co
      cM vl cv c1 caddc co cfz co cA cB cG co vk cG cprd cM vl cv c1 caddc co
      cfz co cA vk cG cprd cM vl cv c1 caddc co cfz co cB vk cG cprd cG co vl
      cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG
      csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz
      co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel
      wa w3a cM vl cv cfz co cA cB cG co vk cG cprd vk vl cv c1 caddc co cA cB
      cG co csb cG co cM vl cv cfz co cA cB cG co vk cG cprd vk vl cv c1 caddc
      co cA csb vk vl cv c1 caddc co cB csb cG co cG co cM vl cv cfz co cA vk
      cG cprd cM vl cv cfz co cB vk cG cprd cG co vk vl cv c1 caddc co cA csb
      vk vl cv c1 caddc co cB csb cG co cG co cM vl cv cfz co cA vk cG cprd vk
      vl cv c1 caddc co cA csb cG co cM vl cv cfz co cB vk cG cprd vk vl cv c1
      caddc co cB csb cG co cG co vl cv cM cuz cfv wcel cA cX wcel cB cX wcel
      wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB
      cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG
      cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz
      co wral cG csem ccm1 cin wcel wa w3a vk vl cv c1 caddc co cA cB cG co csb
      vk vl cv c1 caddc co cA csb vk vl cv c1 caddc co cB csb cG co cM vl cv
      cfz co cA cB cG co vk cG cprd cG vl cv cM cuz cfv wcel cA cX wcel cB cX
      wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co
      cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB
      vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co
      cfz co wral cG csem ccm1 cin wcel wa w3a vl cv c1 caddc co cvv wcel vk vl
      cv c1 caddc co cA cB cG co csb vk vl cv c1 caddc co cA csb vk vl cv c1
      caddc co cB csb cG co wceq vl cv c1 caddc co cvv wcel vl cv cM cuz cfv
      wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa
      vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa w3a vl cv c1
      caddc oprex a1i vk vl cv c1 caddc co cA cB cvv cG csbopr12g syl opreq2d
      vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG
      csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz
      co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel
      wa w3a cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co vk vl cv c1 caddc co cA csb vk
      vl cv c1 caddc co cB csb cG co cG vl cv cM cuz cfv wcel cA cX wcel cB cX
      wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co
      cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB
      vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co
      cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG
      cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co
      wceq vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc
      co cfz co wral cG csem ccm1 cin wcel wa cA cX wcel cB cX wcel wa vk cM vl
      cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG
      cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co
      wceq wi cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq vl cv cM cuz cfv wcel cA cX
      wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin
      wcel wa cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cM vl cv cfz co cA cB cG
      co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd
      cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem
      ccm1 cin wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem
      ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co
      cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cM vl cv cfz co
      cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB
      vk cG cprd cG co wceq wi vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa
      vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa wa cA cX
      wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl
      cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv
      cfz co cB vk cG cprd cG co wceq pm2.27 cA cX wcel cB cX wcel wa vk cM vl
      cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa vl cv cM cuz cfv wcel
      cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cA cX wcel cB cX wcel wa
      vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel vl cv cM cuz
      cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral wi vl cv cM cuz
      cfv wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa vk cM vl cv c1
      caddc co cfz co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral vl
      cv cM cuz cfv wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa vk cM
      vl cv c1 caddc co cfz co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co
      wral wi vl cv cM cuz cfv wcel cG csem ccm1 cin wcel wa cA cX wcel cB cX
      wcel wa cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co cM vl cv
      cfz co vl cv cM cuz cfv wcel cG csem ccm1 cin wcel wa vk cv cM vl cv cfz
      co wcel vk cv cM vl cv c1 caddc co cfz co wcel cA cX wcel cB cX wcel wa
      vl cv cM cuz cfv wcel vk cv cM vl cv cfz co wcel vk cv cM vl cv c1 caddc
      co cfz co wcel wi cG csem ccm1 cin wcel vl cv cM cuz cfv wcel cM vl cv
      cfz co cM vl cv c1 caddc co cfz co vk cv cM cz wcel vl cv cz wcel cM vl
      cv cfz co cM vl cv c1 caddc co cfz co wss vl cv cM cuz cfv wcel cM vl cv
      fzssp1 cM vl cv eluzel2 cM vl cv eluzelz sylanc sseld adantr imim1d
      r19.20dv2 ex com13 imp impcom vl cv cM cuz cfv wcel cA cX wcel cB cX wcel
      wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel simprr
      sylanc ex com23 3imp opreq1d cG csem ccm1 cin wcel cM vl cv cfz co cA vk
      cG cprd cX wcel cM vl cv cfz co cB vk cG cprd cX wcel wa vk vl cv c1
      caddc co cA csb cX wcel vk vl cv c1 caddc co cB csb cX wcel wa wa cM vl
      cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co vk vl cv c1
      caddc co cA csb vk vl cv c1 caddc co cB csb cG co cG co cM vl cv cfz co
      cA vk cG cprd vk vl cv c1 caddc co cA csb cG co cM vl cv cfz co cB vk cG
      cprd vk vl cv c1 caddc co cB csb cG co cG co wceq vl cv cM cuz cfv wcel
      cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa
      cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM
      vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM
      vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa w3a cM vl cv cfz
      co cA vk cG cprd cM vl cv cfz co cB vk cG cprd vk vl cv c1 caddc co cA
      csb vk vl cv c1 caddc co cB csb cG cX fprodadd.1 resgcom cA cX wcel cB cX
      wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa vl
      cv cM cuz cfv wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa vk cM
      vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk
      cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co
      wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel pm3.27 3ad2ant3 vl cv cM cuz cfv wcel cA cX wcel cB cX
      wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co
      cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB
      vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co
      cfz co wral cG csem ccm1 cin wcel wa w3a cM vl cv cfz co cA vk cG cprd cX
      wcel cM vl cv cfz co cB vk cG cprd cX wcel vk vl cv c1 caddc co cA csb cX
      wcel vk vl cv c1 caddc co cB csb cX wcel wa vl cv cM cuz cfv wcel cG
      cmagm wcel cA cX wcel vk cM vl cv cfz co wral cM vl cv cfz co cA vk cG
      cprd cX wcel vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv
      cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG
      cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co
      wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel wa w3a cA vk cG cM vl cv cX fprodadd.1 clfsebs vl cv
      cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem
      ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co
      cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB
      cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa
      3simp1 cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cG cmagm wcel cA cX wcel cB
      cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz
      co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co
      cB vk cG cprd cG co wceq wi cG csem ccm1 cin wcel cG cmagm wcel cA cX
      wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin
      wcel cG csem wcel cG cmagm wcel csem ccm1 cin csem cG csem ccm1 inss1
      sseli cG smgrpismgm syl adantl 3ad2ant3 vl cv cM cuz cfv wcel cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel
      wa cA cX wcel vk cM vl cv cfz co wral cA cX wcel cB cX wcel wa vk cM vl
      cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG
      cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co
      wceq wi cM vl cv cfz co cM vl cv c1 caddc co cfz co wss cA cX wcel vk cM
      vl cv c1 caddc co cfz co wral cA cX wcel vk cM vl cv cfz co wral vl cv cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral
      cG csem ccm1 cin wcel wa wa cA cX wcel vk cM vl cv cfz co cM vl cv c1
      caddc co cfz co ssralv vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk
      cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa wa cM cz wcel
      vl cv cz wcel wa cM vl cv cfz co cM vl cv c1 caddc co cfz co wss vl cv cM
      cuz cfv wcel cM cz wcel vl cv cz wcel wa cA cX wcel cB cX wcel wa vk cM
      vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa vl cv cM cuz cfv
      wcel cM cz wcel vl cv cz wcel cM vl cv eluzel2 cM vl cv eluzelz jca
      adantr cM vl cv fzssp1 syl cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc
      co cfz co wral cA cX wcel vk cM vl cv c1 caddc co cfz co wral vl cv cM
      cuz cfv wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cA cX wcel vk
      cM vl cv c1 caddc co cfz co cA cX wcel cB cX wcel pm3.26 r19.20si
      ad2antrl sylc 3adant2 syl3anc vl cv cM cuz cfv wcel cG cmagm wcel cB cX
      wcel vk cM vl cv cfz co wral cM vl cv cfz co cB vk cG cprd cX wcel vl cv
      cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem
      ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co
      cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB
      cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa
      w3a cB vk cG cM vl cv cX fprodadd.1 clfsebs vl cv cM cuz cfv wcel cA cX
      wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl
      cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv
      cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv
      c1 caddc co cfz co wral cG csem ccm1 cin wcel wa 3simp1 cA cX wcel cB cX
      wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa vl
      cv cM cuz cfv wcel cG cmagm wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz
      co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd
      cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi
      cG csem ccm1 cin wcel cG cmagm wcel cA cX wcel cB cX wcel wa vk cM vl cv
      c1 caddc co cfz co wral cG csem ccm1 cin wcel cG csem wcel cG cmagm wcel
      csem ccm1 cin csem cG csem ccm1 inss1 sseli cG smgrpismgm syl adantl
      3ad2ant3 vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv c1
      caddc co cfz co wral cG csem ccm1 cin wcel wa cB cX wcel vk cM vl cv cfz
      co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cM vl cv cfz co cM vl cv
      c1 caddc co cfz co wss cB cX wcel vk cM vl cv c1 caddc co cfz co wral cB
      cX wcel vk cM vl cv cfz co wral vl cv cM cuz cfv wcel cA cX wcel cB cX
      wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa wa
      cB cX wcel vk cM vl cv cfz co cM vl cv c1 caddc co cfz co ssralv vl cv cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral
      cG csem ccm1 cin wcel wa wa cM cz wcel vl cv cz wcel wa cM vl cv cfz co
      cM vl cv c1 caddc co cfz co wss vl cv cM cuz cfv wcel cM cz wcel vl cv cz
      wcel wa cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cM cz wcel vl cv cz wcel cM
      vl cv eluzel2 cM vl cv eluzelz jca adantr cM vl cv fzssp1 syl cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cB cX wcel vk cM vl cv
      c1 caddc co cfz co wral vl cv cM cuz cfv wcel cG csem ccm1 cin wcel cA cX
      wcel cB cX wcel wa cB cX wcel vk cM vl cv c1 caddc co cfz co cA cX wcel
      cB cX wcel pm3.27 r19.20si ad2antrl sylc 3adant2 syl3anc vl cv cM cuz cfv
      wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa
      vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa w3a vk vl cv
      c1 caddc co cA csb cX wcel vk vl cv c1 caddc co cB csb cX wcel vl cv c1
      caddc co cM vl cv c1 caddc co cfz co wcel cA cX wcel vk cM vl cv c1 caddc
      co cfz co wral vk vl cv c1 caddc co cA csb cX wcel vl cv cM cuz cfv wcel
      cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa
      cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM
      vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM
      vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa w3a vk vl cv c1
      caddc co cM vl cv c1 caddc co cfz co cA cX ra4csbela vl cv cM cuz cfv
      wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi vl cv c1 caddc co cM vl
      cv c1 caddc co cfz co wcel cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc
      co cfz co wral cG csem ccm1 cin wcel wa vl cv cM cuz cfv wcel vl cv c1
      caddc co cM cuz cfv wcel vl cv c1 caddc co cM vl cv c1 caddc co cfz co
      wcel cM vl cv peano2uz cM vl cv c1 caddc co eluzfz2 syl 3ad2ant1 cA cX
      wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin
      wcel wa vl cv cM cuz cfv wcel cA cX wcel vk cM vl cv c1 caddc co cfz co
      wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa
      vk cM vl cv c1 caddc co cfz co wral cA cX wcel vk cM vl cv c1 caddc co
      cfz co wral cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cA cX wcel vk
      cM vl cv c1 caddc co cfz co cA cX wcel cB cX wcel pm3.26 r19.20si adantr
      3ad2ant3 sylanc vl cv c1 caddc co cM vl cv c1 caddc co cfz co wcel cB cX
      wcel vk cM vl cv c1 caddc co cfz co wral vk vl cv c1 caddc co cB csb cX
      wcel vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co
      wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM
      vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA
      cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1
      cin wcel wa w3a vk vl cv c1 caddc co cM vl cv c1 caddc co cfz co cB cX
      ra4csbela vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz
      co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd
      cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi
      vl cv c1 caddc co cM vl cv c1 caddc co cfz co wcel cA cX wcel cB cX wcel
      wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa vl cv cM
      cuz cfv wcel vl cv c1 caddc co cM cuz cfv wcel vl cv c1 caddc co cM vl cv
      c1 caddc co cfz co wcel cM vl cv peano2uz cM vl cv c1 caddc co eluzfz2
      syl 3ad2ant1 cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral
      cG csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cB cX wcel vk cM vl cv c1
      caddc co cfz co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG
      csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz
      co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cB cX wcel vk cM vl cv
      c1 caddc co cfz co wral cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cB
      cX wcel vk cM vl cv c1 caddc co cfz co cA cX wcel cB cX wcel pm3.27
      r19.20si adantr 3ad2ant3 sylanc jca jca31 sylanc 3eqtrd cG csem ccm1 cin
      wcel vl cv cM cuz cfv wcel cA cB cG co cX wcel vk cM vl cv c1 caddc co
      cfz co wral cM vl cv c1 caddc co cfz co cA cB cG co vk cG cprd cM vl cv
      cfz co cA cB cG co vk cG cprd vk vl cv c1 caddc co cA cB cG co csb cG co
      wceq vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co
      wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM
      vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA
      cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1
      cin wcel wa w3a cA cB cG co cX csem ccm1 cin vk cG cM vl cv fprodp1s1 cA
      cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1
      cin wcel wa vl cv cM cuz cfv wcel cG csem ccm1 cin wcel cA cX wcel cB cX
      wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co
      cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB
      vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co
      cfz co wral cG csem ccm1 cin wcel pm3.27 3ad2ant3 vl cv cM cuz cfv wcel
      cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa
      cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM
      vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM
      vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa 3simp1 cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel
      wa vl cv cM cuz cfv wcel cA cB cG co cX wcel vk cM vl cv c1 caddc co cfz
      co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cG csem ccm1 cin wcel cA
      cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cA cB cG co cX
      wcel vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel cA cX wcel
      cB cX wcel wa cA cB cG co cX wcel vk cM vl cv c1 caddc co cfz co cG csem
      ccm1 cin wcel cA cX wcel cB cX wcel wa cG cmagm wcel cA cX wcel cB cX
      wcel w3a cA cB cG co cX wcel cG csem ccm1 cin wcel cA cX wcel cB cX wcel
      wa cG cmagm wcel cA cX wcel cB cX wcel w3a cG csem ccm1 cin wcel cA cX
      wcel cB cX wcel wa wa cG cmagm wcel cA cX wcel cB cX wcel cG csem ccm1
      cin wcel cG cmagm wcel cA cX wcel cB cX wcel wa cG csem ccm1 cin wcel cG
      csem wcel cG cmagm wcel csem ccm1 cin csem cG csem ccm1 inss1 sseli cG
      smgrpismgm syl adantr cG csem ccm1 cin wcel cA cX wcel cB cX wcel simprl
      cG csem ccm1 cin wcel cA cX wcel cB cX wcel simprr 3jca ex cA cB cG cX
      fprodadd.1 clmgm syl6 r19.20sdv impcom 3ad2ant3 syl3anc vl cv cM cuz cfv
      wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin
      wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG
      cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa
      vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa w3a cM vl cv
      c1 caddc co cfz co cA vk cG cprd cM vl cv cfz co cA vk cG cprd vk vl cv
      c1 caddc co cA csb cG co cM vl cv c1 caddc co cfz co cB vk cG cprd cM vl
      cv cfz co cB vk cG cprd vk vl cv c1 caddc co cB csb cG co cG cG csem ccm1
      cin wcel vl cv cM cuz cfv wcel cA cX wcel vk cM vl cv c1 caddc co cfz co
      wral cM vl cv c1 caddc co cfz co cA vk cG cprd cM vl cv cfz co cA vk cG
      cprd vk vl cv c1 caddc co cA csb cG co wceq vl cv cM cuz cfv wcel cA cX
      wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl
      cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv
      cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv
      c1 caddc co cfz co wral cG csem ccm1 cin wcel wa w3a cA cX csem ccm1 cin
      vk cG cM vl cv fprodp1s1 cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co
      cfz co wral cG csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cG csem ccm1
      cin wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1
      cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk
      cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel
      wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel pm3.27
      3ad2ant3 vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz
      co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd
      cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi
      cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1
      cin wcel wa 3simp1 cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz
      co wral cG csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cA cX wcel vk cM
      vl cv c1 caddc co cfz co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co
      wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM
      vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA
      cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cA cX wcel vk
      cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel cA cX wcel cB cX
      wcel wa cA cX wcel vk cM vl cv c1 caddc co cfz co cA cX wcel cB cX wcel
      pm3.26 r19.20si adantr 3ad2ant3 syl3anc cG csem ccm1 cin wcel vl cv cM
      cuz cfv wcel cB cX wcel vk cM vl cv c1 caddc co cfz co wral cM vl cv c1
      caddc co cfz co cB vk cG cprd cM vl cv cfz co cB vk cG cprd vk vl cv c1
      caddc co cB csb cG co wceq vl cv cM cuz cfv wcel cA cX wcel cB cX wcel wa
      vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG
      co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv cfz co cB vk cG cprd
      cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co
      wral cG csem ccm1 cin wcel wa w3a cB cX csem ccm1 cin vk cG cM vl cv
      fprodp1s1 cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cG csem ccm1 cin wcel cA cX
      wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem ccm1 cin wcel wa cM vl
      cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co cA vk cG cprd cM vl cv
      cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB cX wcel wa vk cM vl cv
      c1 caddc co cfz co wral cG csem ccm1 cin wcel pm3.27 3ad2ant3 vl cv cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG csem
      ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz co
      cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel cB
      cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG csem ccm1 cin wcel wa
      3simp1 cA cX wcel cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cG
      csem ccm1 cin wcel wa vl cv cM cuz cfv wcel cB cX wcel vk cM vl cv c1
      caddc co cfz co wral cA cX wcel cB cX wcel wa vk cM vl cv cfz co wral cG
      csem ccm1 cin wcel wa cM vl cv cfz co cA cB cG co vk cG cprd cM vl cv cfz
      co cA vk cG cprd cM vl cv cfz co cB vk cG cprd cG co wceq wi cA cX wcel
      cB cX wcel wa vk cM vl cv c1 caddc co cfz co wral cB cX wcel vk cM vl cv
      c1 caddc co cfz co wral cG csem ccm1 cin wcel cA cX wcel cB cX wcel wa cB
      cX wcel vk cM vl cv c1 caddc co cfz co cA cX wcel cB cX wcel pm3.27
      r19.20si adantr 3ad2ant3 syl3anc opreq12d 3eqtr4d 3exp uzind4 3impib $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    ablinvop.1 $e |- X = ran G $.
    ablinvop.2 $e |- N = ( inv ` G ) $.
    $( The inverse of the abelian group operation doesn't reverse
       the arguments.  cf ~ grpinvop . $)
    ablinvop $p |- ( ( G e. Abel /\ A e. X /\ B e. X ) ->
                   ( N ` ( A G B ) ) = ( ( N ` A ) G ( N ` B ) ) ) $=
      cG cabl wcel cA cX wcel cB cX wcel w3a cA cB cG co cN cfv cB cN cfv cA cN
      cfv cG co cA cN cfv cB cN cfv cG co cG cgr wcel cA cX wcel cB cX wcel cA
      cB cG co cN cfv cB cN cfv cA cN cfv cG co wceq cG cabl wcel cA cB cG cN
      cX ablinvop.1 ablinvop.2 grpinvop cG ablgrp syl3an1 cG cabl wcel cB cN
      cfv cX wcel cA cN cfv cX wcel cB cN cfv cA cN cfv cG co cA cN cfv cB cN
      cfv cG co wceq cG cabl wcel cA cX wcel cB cX wcel w3a cB cN cfv cA cN cfv
      cG cX ablinvop.1 ablcom cG cabl wcel cA cX wcel cB cX wcel 3simp1 cG cgr
      wcel cA cX wcel cB cX wcel cB cN cfv cX wcel cG cabl wcel cG cgr wcel cB
      cX wcel cB cN cfv cX wcel cA cX wcel cB cG cN cX ablinvop.1 ablinvop.2
      grpinvcl 3adant2 cG ablgrp syl3an1 cG cgr wcel cA cX wcel cB cX wcel cA
      cN cfv cX wcel cG cabl wcel cG cgr wcel cA cX wcel cA cN cfv cX wcel cB
      cX wcel cA cG cN cX ablinvop.1 ablinvop.2 grpinvcl 3adant3 cG ablgrp
      syl3an1 syl3anc eqtrd $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    isppm.1 $e |- X = dom dom G $.
    ${ $d F f g $. $d G g  $.
      $( The sequence of partial composites of elements of a magma is a
         sequence of elements of this magma. $)
      isppm $p |- ( ( G e. Magma /\ F : NN --> X ) ->
        ( G seq1 F ) : NN --> X ) $=
        cX cG cdm cdm wceq cG cmagm wcel cn cX cF wf wa cn cX cG cF cseq1 co wf
        wi isppm.1 cX cG cdm cdm wceq cG cmagm wcel cn cX cF wf wa cn cX cG cF
        cseq1 co wf wi cG cmagm wcel cn cG cdm cdm cF wf wa cn cG cdm cdm cG cF
        cseq1 co wf wi cG cvv wcel cG cmagm wcel cn cG cdm cdm cF wf wa cn cG
        cdm cdm cG cF cseq1 co wf cG cmagm wcel cG cvv wcel cn cG cdm cdm cF wf
        cG cmagm elisset adantr vg cv cmagm wcel cn vg cv cdm cdm cF wf wa cn
        vg cv cdm cdm vg cv cF cseq1 co wf wi cG cmagm wcel cn cG cdm cdm cF wf
        wa cn cG cdm cdm cG cF cseq1 co wf wi vg cG cvv vg cv cG wceq vg cv
        cmagm wcel cn vg cv cdm cdm cF wf wa cG cmagm wcel cn cG cdm cdm cF wf
        wa cn vg cv cdm cdm vg cv cF cseq1 co wf cn cG cdm cdm cG cF cseq1 co
        wf vg cv cG wceq vg cv cmagm wcel cG cmagm wcel cn vg cv cdm cdm cF wf
        cn cG cdm cdm cF wf vg cv cG cmagm eleq1 cF cF wceq cn cn wceq vg cv
        cdm cdm cG cdm cdm wceq cn vg cv cdm cdm cF wf cn cG cdm cdm cF wf wb
        vg cv cG wceq cn vg cv cdm cdm cn cG cdm cdm cF cF feq123 vg cv cG wceq
        cF eqidd vg cv cG wceq cn eqidd vg cv cG wceq vg cv cdm cG cdm vg cv cG
        dmeq dmeqd syl3anc anbi12d vg cv cF cseq1 co cG cF cseq1 co wceq cn cn
        wceq vg cv cdm cdm cG cdm cdm wceq cn vg cv cdm cdm vg cv cF cseq1 co
        wf cn cG cdm cdm cG cF cseq1 co wf wb vg cv cG wceq cn vg cv cdm cdm cn
        cG cdm cdm vg cv cF cseq1 co cG cF cseq1 co feq123 vg cv cG cF cseq1
        opreq1 vg cv cG wceq cn eqidd vg cv cG wceq vg cv cdm cG cdm vg cv cG
        dmeq dmeqd syl3anc imbi12d cF cvv wcel vg cv cmagm wcel cn vg cv cdm
        cdm cF wf wa cn vg cv cdm cdm vg cv cF cseq1 co wf cn vg cv cdm cdm cF
        wf cF cvv wcel vg cv cmagm wcel cn vg cv cdm cdm cF wf cn cvv wcel cF
        cvv wcel nnex cn vg cv cdm cdm cvv cF fex mpan2 adantl vg cv cmagm wcel
        cn vg cv cdm cdm vf cv wf wa cn vg cv cdm cdm vg cv vf cv cseq1 co wf
        wi vg cv cmagm wcel cn vg cv cdm cdm cF wf wa cn vg cv cdm cdm vg cv cF
        cseq1 co wf wi vf cF cvv vf cv cF wceq vg cv cmagm wcel cn vg cv cdm
        cdm vf cv wf wa vg cv cmagm wcel cn vg cv cdm cdm cF wf wa cn vg cv cdm
        cdm vg cv vf cv cseq1 co wf cn vg cv cdm cdm vg cv cF cseq1 co wf vf cv
        cF wceq cn vg cv cdm cdm vf cv wf cn vg cv cdm cdm cF wf vg cv cmagm
        wcel cn vg cv cdm cdm vf cv cF feq1 anbi2d vf cv cF wceq cn vg cv cdm
        cdm vg cv vf cv cseq1 co vg cv cF cseq1 co vf cv cF vg cv cseq1 opreq2
        feq1d imbi12d vg cv cmagm wcel cn vg cv cdm cdm vf cv wf wa vg cv vf cv
        cseq1 co cn wfn vg cv vf cv cseq1 co crn vg cv cdm cdm wss wa cn vg cv
        cdm cdm vg cv vf cv cseq1 co wf vg cv cmagm wcel cn vg cv cdm cdm vf cv
        wf wa vg cv vf cv cseq1 co crn vg cv cdm cdm wss vg cv vf cv cseq1 co
        cn wfn vg cv cmagm wcel vg cv cdm cdm vg cv cdm cdm cxp vg cv cdm cdm
        vg cv wf cn vg cv cdm cdm vf cv wf vg cv vf cv cseq1 co crn vg cv cdm
        cdm wss vg cv cmagm wcel vg cv cdm cdm vg cv cdm cdm cxp vg cv cdm cdm
        vg cv wf cmagm vg cv vg cv cdm cdm vg cv cdm cdm eqid ismgm ibi cn vg
        cv cdm cdm vf cv wf vg cv cdm cdm vg cv cdm cdm cxp vg cv cdm cdm vg cv
        wf vg cv vf cv cseq1 co crn vg cv cdm cdm wss vg cv cdm cdm vg cv vf cv
        vg visset vf visset seq1rn ex mpan9 vg cv vf cv vg visset vf visset
        seq1fn jctil cn vg cv cdm cdm vg cv vf cv cseq1 co df-f sylibr vtoclg
        mpcom vtoclg mpcom cX cG cdm cdm wceq cG cmagm wcel cn cX cF wf wa cG
        cmagm wcel cn cG cdm cdm cF wf wa cn cX cG cF cseq1 co wf cn cG cdm cdm
        cG cF cseq1 co wf cX cG cdm cdm wceq cn cX cF wf cn cG cdm cdm cF wf cG
        cmagm wcel cX cG cdm cdm cn cF feq3 anbi2d cX cG cdm cdm cn cG cF cseq1
        co feq3 imbi12d mpbiri ax-mp $.
        $( [24-Jan-2010] $) $( [24-Jan-2010] $)
    $}

    ${
      seqzp2.1 $e |- G e. SemiGrp   $.
      seqzp2.2 $e |- F : ( ZZ>= ` M ) --> X $.

      ${  $d F j k $. $d G j k $. $d M j k $. $d N j $.
        $( Value of the arbitrary-based recursive sequence builder at a
           successor value when the operation ` G ` is associative. Compare
           with ~ seqzp1 . $)
        seqzp2   $p |- ( N e. ( ZZ>= ` M ) ->
          ( ( <. M , G >. seq F ) ` ( N + 1 ) ) =
            ( ( F ` M ) G ( ( <. ( M + 1 ) , G >. seq F ) ` ( N + 1 ) ) ) ) $=
          cN cM cuz cfv wcel cM cz wcel cN cz wcel cM cN cle wbr w3a cN c1
          caddc co cM cG cop cF cseqz co cfv cM cF cfv cN c1 caddc co cM c1
          caddc co cG cop cF cseqz co cfv cG co wceq cM cN eluz2 vj cv c1 caddc
          co cM cG cop cF cseqz co cfv cM cF cfv vj cv c1 caddc co cM c1 caddc
          co cG cop cF cseqz co cfv cG co wceq cM c1 caddc co cM cG cop cF
          cseqz co cfv cM cF cfv cM c1 caddc co cM c1 caddc co cG cop cF cseqz
          co cfv cG co wceq vk cv c1 caddc co cM cG cop cF cseqz co cfv cM cF
          cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co
          wceq vk cv c1 caddc co c1 caddc co cM cG cop cF cseqz co cfv cM cF
          cfv vk cv c1 caddc co c1 caddc co cM c1 caddc co cG cop cF cseqz co
          cfv cG co wceq cN c1 caddc co cM cG cop cF cseqz co cfv cM cF cfv cN
          c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co wceq vj vk cM
          cN vj cv cM wceq vj cv c1 caddc co cM cG cop cF cseqz co cfv cM c1
          caddc co cM cG cop cF cseqz co cfv cM cF cfv vj cv c1 caddc co cM c1
          caddc co cG cop cF cseqz co cfv cG co cM cF cfv cM c1 caddc co cM c1
          caddc co cG cop cF cseqz co cfv cG co vj cv cM wceq vj cv c1 caddc co
          cM c1 caddc co cM cG cop cF cseqz co vj cv cM c1 caddc opreq1 fveq2d
          vj cv cM wceq vj cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv
          cM c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cM cF cfv cG vj
          cv cM wceq vj cv c1 caddc co cM c1 caddc co cM c1 caddc co cG cop cF
          cseqz co vj cv cM c1 caddc opreq1 fveq2d opreq2d eqeq12d vj vk weq vj
          cv c1 caddc co cM cG cop cF cseqz co cfv vk cv c1 caddc co cM cG cop
          cF cseqz co cfv cM cF cfv vj cv c1 caddc co cM c1 caddc co cG cop cF
          cseqz co cfv cG co cM cF cfv vk cv c1 caddc co cM c1 caddc co cG cop
          cF cseqz co cfv cG co vj vk weq vj cv c1 caddc co vk cv c1 caddc co
          cM cG cop cF cseqz co vj cv vk cv c1 caddc opreq1 fveq2d vj vk weq vj
          cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv vk cv c1 caddc
          co cM c1 caddc co cG cop cF cseqz co cfv cM cF cfv cG vj vk weq vj cv
          c1 caddc co vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co vj cv
          vk cv c1 caddc opreq1 fveq2d opreq2d eqeq12d vj cv vk cv c1 caddc co
          wceq vj cv c1 caddc co cM cG cop cF cseqz co cfv vk cv c1 caddc co c1
          caddc co cM cG cop cF cseqz co cfv cM cF cfv vj cv c1 caddc co cM c1
          caddc co cG cop cF cseqz co cfv cG co cM cF cfv vk cv c1 caddc co c1
          caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co vj cv vk cv c1
          caddc co wceq vj cv c1 caddc co vk cv c1 caddc co c1 caddc co cM cG
          cop cF cseqz co vj cv vk cv c1 caddc co c1 caddc opreq1 fveq2d vj cv
          vk cv c1 caddc co wceq vj cv c1 caddc co cM c1 caddc co cG cop cF
          cseqz co cfv vk cv c1 caddc co c1 caddc co cM c1 caddc co cG cop cF
          cseqz co cfv cM cF cfv cG vj cv vk cv c1 caddc co wceq vj cv c1 caddc
          co vk cv c1 caddc co c1 caddc co cM c1 caddc co cG cop cF cseqz co vj
          cv vk cv c1 caddc co c1 caddc opreq1 fveq2d opreq2d eqeq12d vj cv cN
          wceq vj cv c1 caddc co cM cG cop cF cseqz co cfv cN c1 caddc co cM cG
          cop cF cseqz co cfv cM cF cfv vj cv c1 caddc co cM c1 caddc co cG cop
          cF cseqz co cfv cG co cM cF cfv cN c1 caddc co cM c1 caddc co cG cop
          cF cseqz co cfv cG co vj cv cN wceq vj cv c1 caddc co cN c1 caddc co
          cM cG cop cF cseqz co vj cv cN c1 caddc opreq1 fveq2d vj cv cN wceq
          vj cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cN c1 caddc
          co cM c1 caddc co cG cop cF cseqz co cfv cM cF cfv cG vj cv cN wceq
          vj cv c1 caddc co cN c1 caddc co cM c1 caddc co cG cop cF cseqz co vj
          cv cN c1 caddc opreq1 fveq2d opreq2d eqeq12d cM cz wcel cM c1 caddc
          co cM cG cop cF cseqz co cfv cM cM cG cop cF cseqz co cfv cM c1 caddc
          co cF cfv cG co cM cF cfv cM c1 caddc co cF cfv cG co cM cF cfv cM c1
          caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co cM cz wcel cM cM
          cuz cfv wcel cM c1 caddc co cM cG cop cF cseqz co cfv cM cM cG cop cF
          cseqz co cfv cM c1 caddc co cF cfv cG co wceq cM uzid cG cF cM cM cG
          csem seqzp2.1 elisseti cM cuz cfv cX cF wf cM cuz cfv cvv wcel cF cvv
          wcel seqzp2.2 cM cuz fvex cM cuz cfv cX cF wf cF cM cuz cfv wfn cM
          cuz cfv cvv wcel cF cvv wcel wi cM cuz cfv cX cF ffn cF cM cuz cfv
          wfn cM cuz cfv cvv wcel cF cvv wcel cM cuz cfv cvv cF fnex ex syl mp2
          seqzp1 syl cM cz wcel cM cM cG cop cF cseqz co cfv cM cF cfv cM c1
          caddc co cF cfv cG cG cF cM cG csem seqzp2.1 elisseti cM cuz cfv cX
          cF wf cM cuz cfv cvv wcel cF cvv wcel seqzp2.2 cM cuz fvex cM cuz cfv
          cX cF wf cF cM cuz cfv wfn cM cuz cfv cvv wcel cF cvv wcel wi cM cuz
          cfv cX cF ffn cF cM cuz cfv wfn cM cuz cfv cvv wcel cF cvv wcel cM
          cuz cfv cvv cF fnex ex syl mp2 seqz1 opreq1d cM cz wcel cM c1 caddc
          co cF cfv cM c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cM cF
          cfv cG cM cz wcel cM c1 caddc co cM c1 caddc co cG cop cF cseqz co
          cfv cM c1 caddc co cF cfv cM cz wcel cM c1 caddc co cz wcel cM c1
          caddc co cM c1 caddc co cG cop cF cseqz co cfv cM c1 caddc co cF cfv
          wceq cM peano2z cG cF cM c1 caddc co cG csem seqzp2.1 elisseti cM cuz
          cfv cX cF wf cM cuz cfv cvv wcel cF cvv wcel seqzp2.2 cM cuz fvex cM
          cuz cfv cX cF wf cF cM cuz cfv wfn cM cuz cfv cvv wcel cF cvv wcel wi
          cM cuz cfv cX cF ffn cF cM cuz cfv wfn cM cuz cfv cvv wcel cF cvv
          wcel cM cuz cfv cvv cF fnex ex syl mp2 seqz1 syl eqcomd opreq2d
          3eqtrd cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a vk cv c1 caddc
          co cM cG cop cF cseqz co cfv cM cF cfv vk cv c1 caddc co cM c1 caddc
          co cG cop cF cseqz co cfv cG co wceq vk cv c1 caddc co c1 caddc co cM
          cG cop cF cseqz co cfv cM cF cfv vk cv c1 caddc co c1 caddc co cM c1
          caddc co cG cop cF cseqz co cfv cG co wceq cM cz wcel vk cv cz wcel
          cM vk cv cle wbr w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv cM
          cF cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co
          wceq wa vk cv c1 caddc co c1 caddc co cM cG cop cF cseqz co cfv cM cF
          cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co vk
          cv c1 caddc co c1 caddc co cF cfv cG co cM cF cfv vk cv c1 caddc co
          cM c1 caddc co cG cop cF cseqz co cfv vk cv c1 caddc co c1 caddc co
          cF cfv cG co cG co cM cF cfv vk cv c1 caddc co c1 caddc co cM c1
          caddc co cG cop cF cseqz co cfv cG co cM cz wcel vk cv cz wcel cM vk
          cv cle wbr w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv cM cF cfv
          vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co wceq vk
          cv c1 caddc co c1 caddc co cM cG cop cF cseqz co cfv vk cv c1 caddc
          co cM cG cop cF cseqz co cfv vk cv c1 caddc co c1 caddc co cF cfv cG
          co cM cF cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv
          cG co vk cv c1 caddc co c1 caddc co cF cfv cG co cM cz wcel vk cv cz
          wcel cM vk cv cle wbr w3a vk cv c1 caddc co cM cuz cfv wcel vk cv c1
          caddc co c1 caddc co cM cG cop cF cseqz co cfv vk cv c1 caddc co cM
          cG cop cF cseqz co cfv vk cv c1 caddc co c1 caddc co cF cfv cG co
          wceq cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM cz wcel vk cv
          c1 caddc co cz wcel cM vk cv c1 caddc co cle wbr w3a vk cv c1 caddc
          co cM cuz cfv wcel cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM
          cz wcel vk cv c1 caddc co cz wcel cM vk cv c1 caddc co cle wbr cM cz
          wcel vk cv cz wcel cM vk cv cle wbr 3simp1 vk cv cz wcel cM cz wcel
          vk cv c1 caddc co cz wcel cM vk cv cle wbr vk cv peano2z 3ad2ant2 cM
          cr wcel vk cv cr wcel cM vk cv cle wbr cM vk cv c1 caddc co cle wbr
          cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM vk cv letrp1 cM cz
          wcel vk cv cz wcel cM cr wcel cM vk cv cle wbr cM zre 3ad2ant1 vk cv
          cz wcel cM cz wcel vk cv cr wcel cM vk cv cle wbr vk cv zre 3ad2ant2
          cM cz wcel vk cv cz wcel cM vk cv cle wbr 3simp3 syl3anc 3jca cM vk
          cv c1 caddc co eluz2 sylibr cG cF cM vk cv c1 caddc co cG csem
          seqzp2.1 elisseti cM cuz cfv cX cF wf cM cuz cfv cvv wcel cF cvv wcel
          seqzp2.2 cM cuz fvex cM cuz cfv cX cF wf cF cM cuz cfv wfn cM cuz cfv
          cvv wcel cF cvv wcel wi cM cuz cfv cX cF ffn cF cM cuz cfv wfn cM cuz
          cfv cvv wcel cF cvv wcel cM cuz cfv cvv cF fnex ex syl mp2 seqzp1 syl
          vk cv c1 caddc co cM cG cop cF cseqz co cfv cM cF cfv vk cv c1 caddc
          co cM c1 caddc co cG cop cF cseqz co cfv cG co vk cv c1 caddc co c1
          caddc co cF cfv cG opreq1 sylan9eq cG csem wcel cM cF cfv cG cdm cdm
          wcel vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG cdm
          cdm wcel vk cv c1 caddc co c1 caddc co cF cfv cG cdm cdm wcel w3a cM
          cF cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co
          vk cv c1 caddc co c1 caddc co cF cfv cG co cM cF cfv vk cv c1 caddc
          co cM c1 caddc co cG cop cF cseqz co cfv vk cv c1 caddc co c1 caddc
          co cF cfv cG co cG co wceq cM cz wcel vk cv cz wcel cM vk cv cle wbr
          w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv cM cF cfv vk cv c1
          caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co wceq wa cM cF
          cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv vk cv c1
          caddc co c1 caddc co cF cfv cG cG cdm cdm cG cdm cdm eqid smgrpass2
          seqzp2.1 cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM cF cfv cG
          cdm cdm wcel vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv
          cG cdm cdm wcel vk cv c1 caddc co c1 caddc co cF cfv cG cdm cdm wcel
          w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv cM cF cfv vk cv c1
          caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co wceq cM cz wcel
          vk cv cz wcel cM vk cv cle wbr w3a cM cF cfv cG cdm cdm wcel vk cv c1
          caddc co cM c1 caddc co cG cop cF cseqz co cfv cG cdm cdm wcel vk cv
          c1 caddc co c1 caddc co cF cfv cG cdm cdm wcel cM cz wcel vk cv cz
          wcel cM cF cfv cG cdm cdm wcel cM vk cv cle wbr cM cuz cfv cX cF wf
          cM cM cuz cfv wcel cM cF cfv cG cdm cdm wcel cM cz wcel cM cuz cfv cX
          cF wf cM cM cuz cfv wcel wa cM cF cfv cX cG cdm cdm cM cuz cfv cX cM
          cF ffvelrn isppm.1 syl6eleq seqzp2.2 cM uzid sylancr 3ad2ant1 cM cz
          wcel vk cv cz wcel cM vk cv cle wbr w3a vk cv c1 caddc co cM c1 caddc
          co cG cop cF cseqz co cfv vk cv c1 caddc co cM c1 caddc co cG cop cF
          cM c1 caddc co cuz cfv cres cseqz co cfv cG cdm cdm cM cz wcel vk cv
          cz wcel cM vk cv cle wbr w3a vk cv c1 caddc co cM c1 caddc co cG cop
          cF cseqz co cM c1 caddc co cG cop cF cM c1 caddc co cuz cfv cres
          cseqz co cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM c1 caddc co
          cz wcel cM c1 caddc co cG cop cF cseqz co cM c1 caddc co cG cop cF cM
          c1 caddc co cuz cfv cres cseqz co wceq cM cz wcel vk cv cz wcel cM c1
          caddc co cz wcel cM vk cv cle wbr cM peano2z 3ad2ant1 cM c1 caddc co
          cz wcel cM c1 caddc co cG cop cF cM c1 caddc co cuz cfv cres cseqz co
          cM c1 caddc co cG cop cF cseqz co cG cF cM c1 caddc co cG csem
          seqzp2.1 elisseti cM cuz cfv cX cF wf cM cuz cfv cvv wcel cF cvv wcel
          seqzp2.2 cM cuz fvex cM cuz cfv cX cF wf cF cM cuz cfv wfn cM cuz cfv
          cvv wcel cF cvv wcel wi cM cuz cfv cX cF ffn cF cM cuz cfv wfn cM cuz
          cfv cvv wcel cF cvv wcel cM cuz cfv cvv cF fnex ex syl mp2 seqzres
          eqcomd syl fveq1d vk cv c1 caddc co cM c1 caddc co cuz cfv wcel cM c1
          caddc co cuz cfv cG cdm cdm cF cM c1 caddc co cuz cfv cres wf cG cdm
          cdm cG cdm cdm cxp cG cdm cdm cG wf vk cv c1 caddc co cM c1 caddc co
          cG cop cF cM c1 caddc co cuz cfv cres cseqz co cfv cG cdm cdm wcel cM
          cz wcel vk cv cz wcel cM vk cv cle wbr w3a cG cdm cdm cG cF cM c1
          caddc co cuz cfv cres cM c1 caddc co vk cv c1 caddc co cG csem
          seqzp2.1 elisseti cF wfun cM c1 caddc co cuz cfv cvv wcel cF cM c1
          caddc co cuz cfv cres cvv wcel cM cuz cfv cX cF wf cF wfun seqzp2.2
          cM cuz cfv cX cF ffun ax-mp cM c1 caddc co cuz fvex cF cM c1 caddc co
          cuz cfv cvv resfunexg mp2an seqzcl cM cz wcel vk cv cz wcel cM vk cv
          cle wbr w3a cM c1 caddc co cz wcel vk cv c1 caddc co cz wcel cM c1
          caddc co vk cv c1 caddc co cle wbr w3a vk cv c1 caddc co cM c1 caddc
          co cuz cfv wcel cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM c1
          caddc co cz wcel vk cv c1 caddc co cz wcel cM c1 caddc co vk cv c1
          caddc co cle wbr cM cz wcel vk cv cz wcel cM c1 caddc co cz wcel cM
          vk cv cle wbr cM peano2z 3ad2ant1 vk cv cz wcel cM cz wcel vk cv c1
          caddc co cz wcel cM vk cv cle wbr vk cv peano2z 3ad2ant2 cM cz wcel
          vk cv cz wcel cM vk cv cle wbr cM c1 caddc co vk cv c1 caddc co cle
          wbr cM cr wcel vk cv cr wcel c1 cr wcel cM vk cv cle wbr cM c1 caddc
          co vk cv c1 caddc co cle wbr wb cM cz wcel vk cv cz wcel wa cM vk cv
          c1 leadd1 cM cz wcel cM cr wcel vk cv cz wcel cM zre adantr vk cv cz
          wcel vk cv cr wcel cM cz wcel vk cv zre adantl c1 cr wcel cM cz wcel
          vk cv cz wcel wa 1re a1i syl3anc biimp3a 3jca cM c1 caddc co vk cv c1
          caddc co eluz2 sylibr cM cuz cfv cG cdm cdm cF wf cM c1 caddc co cuz
          cfv cM cuz cfv wss cM c1 caddc co cuz cfv cG cdm cdm cF cM c1 caddc
          co cuz cfv cres wf cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM
          cuz cfv cG cdm cdm cM c1 caddc co cuz cfv cF fssres cM cuz cfv cG cdm
          cdm cF wf cM cuz cfv cX cF wf seqzp2.2 cG cdm cdm cX wceq cM cuz cfv
          cG cdm cdm cF wf cM cuz cfv cX cF wf wb cX cG cdm cdm isppm.1 eqcomi
          cG cdm cdm cX cM cuz cfv cF feq3 ax-mp mpbir cM cz wcel vk cv cz wcel
          cM vk cv cle wbr w3a cM c1 caddc co cM cuz cfv wcel cM c1 caddc co
          cuz cfv cM cuz cfv wss cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a
          cM cz wcel cM c1 caddc co cz wcel cM cM c1 caddc co cle wbr w3a cM c1
          caddc co cM cuz cfv wcel cM cz wcel vk cv cz wcel cM vk cv cle wbr
          w3a cM cz wcel cM c1 caddc co cz wcel cM cM c1 caddc co cle wbr cM cz
          wcel vk cv cz wcel cM vk cv cle wbr 3simp1 cM cz wcel vk cv cz wcel
          cM c1 caddc co cz wcel cM vk cv cle wbr cM peano2z 3ad2ant1 cM cz
          wcel vk cv cz wcel cM cM c1 caddc co cle wbr cM vk cv cle wbr cM cz
          wcel cM cr wcel cM cM c1 caddc co cle wbr cM zre cM lep1 syl 3ad2ant1
          3jca cM cM c1 caddc co eluz2 sylibr cM cM c1 caddc co uzss syl
          sylancr cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf cM cz wcel vk cv
          cz wcel cM vk cv cle wbr w3a cG csem wcel cG cdm cdm cG cdm cdm cxp
          cG cdm cdm cG wf seqzp2.1 cG cG cdm cdm cG cdm cdm eqid smgrpmgm
          ax-mp a1i syl3anc eqeltrd cM cuz cfv cG cdm cdm cF wf vk cv c1 caddc
          co c1 caddc co cM cuz cfv wcel vk cv c1 caddc co c1 caddc co cF cfv
          cG cdm cdm wcel cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM cuz
          cfv cG cdm cdm vk cv c1 caddc co c1 caddc co cF ffvelrn cM cuz cfv cG
          cdm cdm cF wf cM cuz cfv cX cF wf seqzp2.2 cX cG cdm cdm wceq cM cuz
          cfv cG cdm cdm cF wf cM cuz cfv cX cF wf wb isppm.1 cX cG cdm cdm
          wceq cM cuz cfv cX cF wf cM cuz cfv cG cdm cdm cF wf cX cG cdm cdm cM
          cuz cfv cF feq3 bicomd ax-mp mpbir cM cz wcel vk cv cz wcel cM vk cv
          cle wbr w3a cM cz wcel vk cv c1 caddc co c1 caddc co cz wcel cM vk cv
          c1 caddc co c1 caddc co cle wbr w3a vk cv c1 caddc co c1 caddc co cM
          cuz cfv wcel cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a cM cz wcel
          vk cv c1 caddc co c1 caddc co cz wcel cM vk cv c1 caddc co c1 caddc
          co cle wbr cM cz wcel vk cv cz wcel cM vk cv cle wbr 3simp1 vk cv cz
          wcel cM cz wcel vk cv c1 caddc co c1 caddc co cz wcel cM vk cv cle
          wbr vk cv cz wcel vk cv c1 caddc co vk cv peano2z peano2zdi 3ad2ant2
          cM cr wcel vk cv c1 caddc co cr wcel cM vk cv c1 caddc co cle wbr cM
          vk cv c1 caddc co c1 caddc co cle wbr cM cz wcel vk cv cz wcel cM vk
          cv cle wbr w3a cM vk cv c1 caddc co letrp1 cM cz wcel vk cv cz wcel
          cM cr wcel cM vk cv cle wbr cM zre 3ad2ant1 vk cv cz wcel cM cz wcel
          vk cv c1 caddc co cr wcel cM vk cv cle wbr vk cv cz wcel vk cv c1
          caddc co cz wcel vk cv c1 caddc co cr wcel vk cv peano2z vk cv c1
          caddc co zre syl 3ad2ant2 cM cr wcel vk cv cr wcel cM vk cv cle wbr
          cM vk cv c1 caddc co cle wbr cM cz wcel vk cv cz wcel cM vk cv cle
          wbr w3a cM vk cv letrp1 cM cz wcel vk cv cz wcel cM cr wcel cM vk cv
          cle wbr cM zre 3ad2ant1 vk cv cz wcel cM cz wcel vk cv cr wcel cM vk
          cv cle wbr vk cv zre 3ad2ant2 cM cz wcel vk cv cz wcel cM vk cv cle
          wbr 3simp3 syl3anc syl3anc 3jca cM vk cv c1 caddc co c1 caddc co
          eluz2 sylibr sylancr 3jca adantr sylancr cM cz wcel vk cv cz wcel cM
          vk cv cle wbr w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv cM cF
          cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co
          wceq wa vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv vk cv
          c1 caddc co c1 caddc co cF cfv cG co vk cv c1 caddc co c1 caddc co cM
          c1 caddc co cG cop cF cseqz co cfv cM cF cfv cG cM cz wcel vk cv cz
          wcel cM vk cv cle wbr w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv
          cM cF cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG
          co wceq wa vk cv c1 caddc co c1 caddc co cM c1 caddc co cG cop cF
          cseqz co cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv
          vk cv c1 caddc co c1 caddc co cF cfv cG co cM cz wcel vk cv cz wcel
          cM vk cv cle wbr w3a vk cv c1 caddc co cM cG cop cF cseqz co cfv cM
          cF cfv vk cv c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv cG co
          wceq wa vk cv c1 caddc co cM c1 caddc co cuz cfv wcel vk cv c1 caddc
          co c1 caddc co cM c1 caddc co cG cop cF cseqz co cfv vk cv c1 caddc
          co cM c1 caddc co cG cop cF cseqz co cfv vk cv c1 caddc co c1 caddc
          co cF cfv cG co wceq cM cz wcel vk cv cz wcel cM vk cv cle wbr w3a vk
          cv c1 caddc co cM c1 caddc co cuz cfv wcel vk cv c1 caddc co cM cG
          cop cF cseqz co cfv cM cF cfv vk cv c1 caddc co cM c1 caddc co cG cop
          cF cseqz co cfv cG co wceq cM cz wcel vk cv cz wcel cM vk cv cle wbr
          w3a vk cv cM cuz cfv wcel vk cv c1 caddc co cM c1 caddc co cuz cfv
          wcel cM vk cv eluz2 cM vk cv eluzp1p1 sylbir adantr cG cF cM c1 caddc
          co vk cv c1 caddc co cG csem seqzp2.1 elisseti cM cuz cfv cX cF wf cM
          cuz cfv cvv wcel cF cvv wcel seqzp2.2 cM cuz fvex cM cuz cfv cX cF wf
          cF cM cuz cfv wfn cM cuz cfv cvv wcel cF cvv wcel wi cM cuz cfv cX cF
          ffn cF cM cuz cfv wfn cM cuz cfv cvv wcel cF cvv wcel cM cuz cfv cvv
          cF fnex ex syl mp2 seqzp1 syl eqcomd opreq2d 3eqtrd ex uzind sylbi $.
          $( [24-Jan-2010] $) $( [24-Jan-2010] $)
      $}
    $}
  $}



  $c Mnd $.

  $( Extend class notation with the class of all monoids. $)
  cmnd $a class Mnd $.

  $( A monoid is a semi-group with an identity element. $)
  df-mnd $a |- Mnd = ( SemiGrp i^i ExId ) $.

  $( A monoid is a semi-group. $)
  mndissmgrp $p |- ( G e. Mnd -> G e. SemiGrp ) $=
    cG cmnd wcel cG csem cexid cin wcel cG csem wcel cmnd csem cexid cin cG
    df-mnd eleq2i cG csem cexid cin wcel cG csem wcel cG cexid wcel cG csem
    cexid elin pm3.26bi sylbi $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)


  $( A monoid has an identity element. $)
  mndisexid $p |- ( G e. Mnd -> G e. ExId ) $=
    cG cmnd wcel cG csem cexid cin wcel cG cexid wcel cmnd csem cexid cin cG
    df-mnd eleq2i cG csem cexid cin wcel cG csem wcel cG cexid wcel cG csem
    cexid elin pm3.27bi sylbi $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)

  $( A monoid is a magma. $)
  mndismgm $p |- ( G e. Mnd -> G e. Magma ) $=
    cG cmnd wcel cG csem wcel cG cmagm wcel cG mndissmgrp cG smgrpismgm syl $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)

  $( A monoid is a magma with an identity element. $)
  mndmgmid $p |- ( G e. Mnd -> G e. ( Magma i^i ExId ) ) $=
    cG cmnd wcel cG cmagm wcel cG cexid wcel wa cG cmagm cexid cin wcel cG cmnd
    wcel cG cmagm wcel cG cexid wcel cG mndismgm cG mndisexid jca cG cmagm
    cexid elin sylibr $.
    $( [18-Feb-2010] $) $( [18-Feb-2010] $)

  $( A monoid is associative. $)
  mndisass $p |- ( G e. Mnd -> G e. Ass ) $=
    cG cmnd wcel cG csem wcel cG cass wcel cG mndissmgrp cG smgrpisass syl $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)


  ${ $d G x y $.
    ismond.1 $e |- X = dom dom G $.
    $( The predicate "is a monoid". $)
    ismnd $p |- ( G e. A -> ( G e. Mnd
     <-> ( G e. SemiGrp /\ E. x e. X A. y e. X
      ( ( y G x ) = y /\ ( x G y ) = y ) ) ) ) $=
      cG cA wcel cG csem cexid cin wcel cG csem wcel vy cv vx cv cG co vy cv
      wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex wa cG cmnd
      wcel cG cA wcel cG csem wcel cG cexid wcel wa cG csem wcel vy cv vx cv cG
      co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex wa cG
      csem cexid cin wcel cG cA wcel cG cexid wcel vy cv vx cv cG co vy cv wceq
      vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex cG csem wcel vx vy
      cA cG cX ismond.1 isexid anbi2d cG csem cexid elin syl5bb cmnd csem cexid
      cin cG df-mnd eleq2i syl5bb $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G x y z $. $d X x y z $.
    ismnd1.1 $e |- X = dom dom G $.
    $( The predicate "is a monoid". $)
    ismnd1 $p |- ( G e. A -> ( G e. Mnd <->
      ( G : ( X X. X ) --> X /\
        A. x e. X A. y e. X A. z e. X
          ( ( x G y ) G z ) = ( x G ( y G z ) ) /\
        E. x e. X A. y e. X
         ( ( y G x ) = y /\ ( x G y ) = y ) ) ) ) $=
      cG cA wcel cG cmnd wcel cG csem wcel vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cX wral vx cX wrex wa cX cX cxp cX cG wf vx
      cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral
      vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy
      cv wceq wa vy cX wral vx cX wrex w3a vx vy cA cG cX ismnd1.1 ismnd cG cA
      wcel cG csem wcel vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv
      wceq wa vy cX wral vx cX wrex wa cX cX cxp cX cG wf vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX
      wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX
      wral vx cX wrex w3a cG cA wcel cG csem wcel vy cv vx cv cG co vy cv wceq
      vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex wa wa cX cX cxp cX
      cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG
      co vy cv wceq wa vy cX wral vx cX wrex cG csem wcel cX cX cxp cX cG wf cG
      cA wcel vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy
      cX wral vx cX wrex cG cX ismnd1.1 smgrpmgm ad2antrl cG csem wcel vx cv vy
      cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX
      wral vx cX wral cG cA wcel vy cv vx cv cG co vy cv wceq vx cv vy cv cG co
      vy cv wceq wa vy cX wral vx cX wrex vx vy vz cG cX ismnd1.1 smgrpass
      ad2antrl cG cA wcel cG csem wcel vy cv vx cv cG co vy cv wceq vx cv vy cv
      cG co vy cv wceq wa vy cX wral vx cX wrex simprr 3jca cG cA wcel cX cX
      cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cX wral vx cX wrex w3a wa cG csem wcel vy cv
      vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX
      wrex cG cA wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy
      cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG
      co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex w3a
      cG csem wcel cG cA wcel cG csem wcel cX cX cxp cX cG wf vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx
      cX wral wa cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co
      vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex w3a vx
      vy vz cA cG cX ismnd1.1 issmgrp cX cX cxp cX cG wf vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX
      wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX
      wral vx cX wrex 3simpa syl5bir imp cX cX cxp cX cG wf vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx
      cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy
      cX wral vx cX wrex w3a vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy
      cv wceq wa vy cX wral vx cX wrex cG cA wcel cX cX cxp cX cG wf vx cv vy
      cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX
      wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
      wa vy cX wral vx cX wrex 3simp3 adantl jca impbida bitrd $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G x y z $. $d X x y z $.
    ismnd2.1 $e |- X = ran G $.
    $( The predicate "is a monoid". $)
    ismnd2 $p |- ( G e. A -> ( G e. Mnd <->
      ( G : ( X X. X ) --> X /\
        A. x e. X A. y e. X A. z e. X
          ( ( x G y ) G z ) = ( x G ( y G z ) ) /\
        E. x e. X A. y e. X
         ( ( y G x ) = y /\ ( x G y ) = y ) ) ) ) $=
      cG cA wcel cG cmnd wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co
      vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv
      vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX
      wrex w3a cG cA wcel cG cmnd wcel cG crn cG cdm cdm wceq cX cX cxp cX cG
      wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX
      wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co
      vy cv wceq wa vy cX wral vx cX wrex w3a cG cmnd wcel cG cmagm cexid cin
      wcel cG crn cG cdm cdm wceq cG cmnd wcel cG cmagm wcel cG cexid wcel wa
      cG cmagm cexid cin wcel cG cmnd wcel cG cmagm wcel cG cexid wcel cG
      mndismgm cG mndisexid jca cG cmagm cexid elin sylibr cG rngopid syl cG cA
      wcel cG cmnd wcel cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf vx cv vy cv
      cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral
      vy cG cdm cdm wral vx cG cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex w3a cG
      crn cG cdm cdm wceq cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx
      cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex
      w3a wi vx vy vz cA cG cG cdm cdm cG cdm cdm eqid ismnd1 cG crn cG cdm cdm
      wceq cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm
      wral vx cG cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy
      cv wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex w3a cX cX cxp cX cG wf
      vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX
      wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co
      vy cv wceq wa vy cX wral vx cX wrex w3a cG crn cG cdm cdm wceq cG cdm cdm
      cG cdm cdm cxp cG cdm cdm cG wf cX cX cxp cX cG wf vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm
      cdm wral vx cG cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy
      cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG cdm cdm
      wrex vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX
      wral vx cX wrex cG crn cG cdm cdm wceq cG cdm cdm cG cdm cdm cxp cX cX
      cxp wceq cG cdm cdm cX wceq wa cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf
      cX cX cxp cX cG wf wb cX cG crn wceq cG crn cG cdm cdm wceq cG cdm cdm cG
      cdm cdm cxp cX cX cxp wceq cG cdm cdm cX wceq wa ismnd2.1 cX cG crn wceq
      cG crn cG cdm cdm wceq wa cX cG cdm cdm wceq cG cdm cdm cG cdm cdm cxp cX
      cX cxp wceq cG cdm cdm cX wceq wa cX cG crn cG cdm cdm eqtr cG cdm cdm cG
      cdm cdm cxp cX cX cxp wceq cG cdm cdm cX wceq wa cG cdm cdm cX cG cdm cdm
      cX wceq cG cdm cdm cG cdm cdm cxp cX cX cxp wceq cG cdm cdm cG cdm cdm
      cxp cX cX cxp wceq cG cdm cdm cX wceq cG cdm cdm cX xpid11 biimpri ancri
      eqcoms syl mpan cG cdm cdm cG cdm cdm cxp cG cdm cdm cX cX cxp cX cG
      feq23 syl cX cG crn wceq cG crn cG cdm cdm wceq vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm
      wral vx cG cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vy cX wral vx cX wral wb ismnd2.1 cX cG crn
      wceq cG crn cG cdm cdm wceq wa cX cG cdm cdm wceq vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm
      wral vx cG cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vy cX wral vx cX wral wb cX cG crn cG cdm cdm
      eqtr vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      cG cdm cdm wral vy cG cdm cdm wral vx cG cdm cdm wral vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx
      cX wral wb cG cdm cdm cX vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx
      cG cdm cdm cX vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cG cdm cdm wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vy cG cdm cdm cX vx cv vy cv cG co vz cv cG
      co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm cX raleq1 raleqd
      raleqd eqcoms syl mpan cX cG crn wceq cG crn cG cdm cdm wceq vy cv vx cv
      cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG
      cdm cdm wrex vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa
      vy cX wral vx cX wrex wb ismnd2.1 cX cG crn wceq cG crn cG cdm cdm wceq
      wa cX cG cdm cdm wceq vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy
      cv wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex vy cv vx cv cG co vy cv
      wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex wb cX cG crn
      cG cdm cdm eqtr vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
      wa vy cG cdm cdm wral vx cG cdm cdm wrex vy cv vx cv cG co vy cv wceq vx
      cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex wb cG cdm cdm cX vy cv
      vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral
      vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral
      vx cG cdm cdm cX vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv
      wceq wa vy cG cdm cdm cX raleq1 rexeqd eqcoms syl mpan 3anbi123d biimpcd
      syl6bi mpdi cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co
      vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex w3a cG
      cA wcel cG cmnd wcel cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx
      cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex
      cG cA wcel cG cmnd wcel wi cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG
      co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy
      cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx
      cX wrex cG cA wcel cG cmnd wcel wi wi wi cX cX cxp cX cG wf cG cdm cX cX
      cxp wceq cG cdm cdm cX cX cxp cdm wceq cX cX cxp cX cG wf vx cv vy cv cG
      co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral
      vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa
      vy cX wral vx cX wrex cG cA wcel cG cmnd wcel wi wi wi wi cX cX cxp cX cG
      fdm cG cdm cX cX cxp dmeq cG cdm cdm cX cX cxp cdm wceq cX cX cxp cdm cX
      wceq cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv
      wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex cG cA wcel cG
      cmnd wcel wi wi wi wi cX dmxpid cG cdm cdm cX cX cxp cdm wceq cX cX cxp
      cdm cX wceq wa cG cdm cdm cX wceq cX cX cxp cX cG wf vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX
      wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX
      wral vx cX wrex cG cA wcel cG cmnd wcel wi wi wi wi cG cdm cdm cX cX cxp
      cdm cX eqtr cG cdm cdm cX wceq cX cX cxp cX cG wf vx cv vy cv cG co vz cv
      cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral
      vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral
      vx cX wrex cG cA wcel cG cmnd wcel wi wi cG cdm cdm cX wceq cX cX cxp cX
      cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      cX wral vy cX wral vx cX wral w3a vy cv vx cv cG co vy cv wceq vx cv vy
      cv cG co vy cv wceq wa vy cX wral vx cX wrex cG cdm cdm cG cdm cdm cxp cG
      cdm cdm cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm cdm wral vy cv vx cv
      cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG
      cdm cdm wrex w3a cG cA wcel cG cmnd wcel wi cG cdm cdm cX wceq cX cX cxp
      cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
      vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv
      cG co vy cv wceq wa vy cX wral vx cX wrex cG cdm cdm cG cdm cdm cxp cG
      cdm cdm cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm cdm wral vy cv vx cv
      cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG
      cdm cdm wrex w3a wi cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx
      cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex
      cG cdm cdm cX wceq cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf vx cv vy cv
      cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral
      vy cG cdm cdm wral vx cG cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex w3a cX cX
      cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cX wral vx cX wrex cG cdm cdm cX wceq cG cdm
      cdm cG cdm cdm cxp cG cdm cdm cG wf vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG
      cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa
      vy cG cdm cdm wral vx cG cdm cdm wrex w3a wi cG cdm cdm cX wceq cX cX cxp
      cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
      vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv
      cG co vy cv wceq wa vy cX wral vx cX wrex w3a cG cdm cdm cG cdm cdm cxp
      cG cdm cdm cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG
      co wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm cdm wral vy cv vx
      cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx
      cG cdm cdm wrex w3a cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx
      cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx
      cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex
      w3a cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf vx cv vy cv cG co vz cv cG
      co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm
      wral vx cG cdm cdm wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy
      cv wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex w3a wb cX cG cdm cdm cX
      cG cdm cdm wceq cX cX cxp cX cG wf cG cdm cdm cG cdm cdm cxp cG cdm cdm
      cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
      cX wral vy cX wral vx cX wral vx cv vy cv cG co vz cv cG co vx cv vy cv
      vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm
      cdm wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy
      cX wral vx cX wrex vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv
      wceq wa vy cG cdm cdm wral vx cG cdm cdm wrex cX cX cxp cG cdm cdm cG cdm
      cdm cxp wceq cX cG cdm cdm wceq cX cX cxp cX cG wf cG cdm cdm cG cdm cdm
      cxp cG cdm cdm cG wf wb cX cX cxp cG cdm cdm cG cdm cdm cxp wceq cX cG
      cdm cdm wceq cX cG cdm cdm xpid11 biimpri cX cX cxp cX cG cdm cdm cG cdm
      cdm cxp cG cdm cdm cG feq23 mpancom vx cv vy cv cG co vz cv cG co vx cv
      vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cv vy cv cG co vz
      cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG cdm cdm wral vy cG cdm
      cdm wral vx cX cG cdm cdm vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv
      cG co cG co wceq vz cX wral vx cv vy cv cG co vz cv cG co vx cv vy cv vz
      cv cG co cG co wceq vz cG cdm cdm wral vy cX cG cdm cdm vx cv vy cv cG co
      vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX cG cdm cdm raleq1
      raleqd raleqd vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
      wa vy cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
      wa vy cG cdm cdm wral vx cX cG cdm cdm vy cv vx cv cG co vy cv wceq vx cv
      vy cv cG co vy cv wceq wa vy cX cG cdm cdm raleq1 rexeqd 3anbi123d eqcoms
      biimpcd 3exp com4r 3imp cG cA wcel cG cmnd wcel cG cdm cdm cG cdm cdm cxp
      cG cdm cdm cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG
      co wceq vz cG cdm cdm wral vy cG cdm cdm wral vx cG cdm cdm wral vy cv vx
      cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG cdm cdm wral vx
      cG cdm cdm wrex w3a vx vy vz cA cG cG cdm cdm cG cdm cdm eqid ismnd1
      biimprcd syl6 3exp syl mpan2 3syl pm2.43i 3imp com12 impbid $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G x y z $. $d X x y z $.
  mndid.1 $e |- X = ran G $.
  $( A monoid has an identity element. $)
  mndid $p |- ( G e. Mnd -> E. x e. X A. y e. X
      ( ( y G x ) = y /\ ( x G y ) = y ) ) $=
    cG cmnd wcel vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa
    vy cX wral vx cX wrex cG cmnd wcel cG cmnd wcel cX cX cxp cX cG wf vx cv vy
    cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX
    wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
    wa vy cX wral vx cX wrex w3a vy cv vx cv cG co vy cv wceq vx cv vy cv cG co
    vy cv wceq wa vy cX wral vx cX wrex vx vy vz cmnd cG cX mndid.1 ismnd2 cX
    cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
    wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy
    cv cG co vy cv wceq wa vy cX wral vx cX wrex 3simp3 syl6bi pm2.43i $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)

  $}

  ${ $d G x y z $. $d X x y z $.
  mndio.1 $e |- X = ran G $.
  $( A monoid is an internal operation. $)
  mndio $p |- ( G e. Mnd ->
      G : ( X X. X ) --> X ) $=
    cG cmnd wcel cX cX cxp cX cG wf cG cmnd wcel cG cmnd wcel cX cX cxp cX cG
    wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cX
    wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv cG co
    vy cv wceq wa vy cX wral vx cX wrex w3a cX cX cxp cX cG wf vx vy vz cmnd cG
    cX mndio.1 ismnd2 cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy
    cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy cv vx cv cG
    co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX wrex 3simp1
    syl6bi pm2.43i $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d G x y z $. $d X x y z $.
  mndass.1 $e |- X = ran G $.
  $( A monoid is associative. $)
  mndass $p |- ( G e. Mnd ->
        A. x e. X A. y e. X A. z e. X
          ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $=
    cG cmnd wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
    wceq vz cX wral vy cX wral vx cX wral cG cmnd wcel cG cmnd wcel cX cX cxp
    cX cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
    vz cX wral vy cX wral vx cX wral vy cv vx cv cG co vy cv wceq vx cv vy cv
    cG co vy cv wceq wa vy cX wral vx cX wrex w3a vx cv vy cv cG co vz cv cG co
    vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vx vy
    vz cmnd cG cX mndass.1 ismnd2 cX cX cxp cX cG wf vx cv vy cv cG co vz cv cG
    co vx cv vy cv vz cv cG co cG co wceq vz cX wral vy cX wral vx cX wral vy
    cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cX wral vx cX
    wrex 3simp2 syl6bi pm2.43i $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d A x y z $. $d B y z $. $d C z $. $d G x y z $. $d X x y z $.
    mndass2.1 $e |- X = ran G $.
    $( A monoid is associative. $)
    mndass2 $p |- ( ( G e. Mnd /\ ( A e. X /\ B e. X /\ C e. X ) )
      -> ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      cG cmnd wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
      wceq vz cX wral vy cX wral vx cX wral cA cX wcel cB cX wcel cC cX wcel
      w3a cA cB cG co cC cG co cA cB cC cG co cG co wceq vx vy vz cG cX
      mndass2.1 mndass vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG
      co wceq cA cB cG co cC cG co cA cB cC cG co cG co wceq cA vy cv cG co vz
      cv cG co cA vy cv vz cv cG co cG co wceq cA cB cG co vz cv cG co cA cB vz
      cv cG co cG co wceq vx vy vz cA cB cC cX cX cX vx cv cA wceq vx cv vy cv
      cG co vz cv cG co cA vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG
      co cA vy cv vz cv cG co cG co vx cv cA wceq vx cv vy cv cG co cA vy cv cG
      co vz cv cG vx cv cA vy cv cG opreq1 opreq1d vx cv cA vy cv vz cv cG co
      cG opreq1 eqeq12d vy cv cB wceq cA vy cv cG co vz cv cG co cA cB cG co vz
      cv cG co cA vy cv vz cv cG co cG co cA cB vz cv cG co cG co vy cv cB wceq
      cA vy cv cG co cA cB cG co vz cv cG vy cv cB cA cG opreq2 opreq1d vy cv
      cB wceq vy cv vz cv cG co cB vz cv cG co cA cG vy cv cB vz cv cG opreq1
      opreq2d eqeq12d vz cv cC wceq cA cB cG co vz cv cG co cA cB cG co cC cG
      co cA cB vz cv cG co cG co cA cB cC cG co cG co vz cv cC cA cB cG co cG
      opreq2 vz cv cC wceq cB vz cv cG co cB cC cG co cA cG vz cv cC cB cG
      opreq2 opreq2d eqeq12d rcla43v mpan9 $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
  $}

  ${ $d G w x y z $.
  $( A group is a monoid. $)
  grpmnd $p |- ( G e. Grp -> G e. Mnd ) $=
    cG cgr wcel cG cmnd wcel cG cgr wcel cG cgr wcel cG crn cG crn cxp cG crn
    cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz
    cG crn wral vy cG crn wral vx cG crn wral vw cv vx cv cG co vx cv wceq vy
    cv vx cv cG co vw cv wceq vy cG crn wrex wa vx cG crn wral vw cG crn wrex
    w3a cG cmnd wcel cG cgr wcel cG cgr wcel cG crn cG crn cxp cG crn cG wf vx
    cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn
    wral vy cG crn wral vx cG crn wral vw cv vx cv cG co vx cv wceq vy cv vx cv
    cG co vw cv wceq vy cG crn wrex wa vx cG crn wral vw cG crn wrex w3a vx vy
    vz vw cgr cG cG crn cG crn eqid isgrp biimpd cG crn cG crn cxp cG crn cG wf
    vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn
    wral vy cG crn wral vx cG crn wral vw cv vx cv cG co vx cv wceq vy cv vx cv
    cG co vw cv wceq vy cG crn wrex wa vx cG crn wral vw cG crn wrex cG cgr
    wcel cG cmnd wcel wi vw cv vx cv cG co vx cv wceq vy cv vx cv cG co vw cv
    wceq vy cG crn wrex wa vx cG crn wral vw cG crn wrex vx cv vy cv cG co vz
    cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn wral vy cG crn wral
    vx cG crn wral cG crn cG crn cxp cG crn cG wf cG cgr wcel cG cmnd wcel wi
    vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn
    wral vy cG crn wral vx cG crn wral cG crn cG crn cxp cG crn cG wf cG cgr
    wcel cG cmnd wcel wi wi wi vw cv vx cv cG co vx cv wceq vy cv vx cv cG co
    vw cv wceq vy cG crn wrex wa vx cG crn wral vw cG crn wrex vx cv vy cv cG
    co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn wral vy cG crn
    wral vx cG crn wral cG crn cG crn cxp cG crn cG wf cG cgr wcel cG cmnd wcel
    wi cG cgr wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co
    wceq vz cG crn wral vy cG crn wral vx cG crn wral cG crn cG crn cxp cG crn
    cG wf wa cG cmnd wcel vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv
    wceq wa vw cv vy cv cG co vx cv wceq vy cv vw cv cG co vx cv wceq wa vw cG
    crn wrex wa vy cG crn wral vx cG crn wrex cG cgr wcel vx cv vy cv cG co vz
    cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn wral vy cG crn wral
    vx cG crn wral cG crn cG crn cxp cG crn cG wf wa cG cmnd wcel wi vy vw vx
    cG cG crn cG crn eqid grpidinv vx cv vy cv cG co vy cv wceq vy cv vx cv cG
    co vy cv wceq wa vw cv vy cv cG co vx cv wceq vy cv vw cv cG co vx cv wceq
    wa vw cG crn wrex wa vy cG crn wral vx cG crn wrex vx cv vy cv cG co vy cv
    wceq vy cv vx cv cG co vy cv wceq wa vy cG crn wral vx cG crn wrex cG cgr
    wcel vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG
    crn wral vy cG crn wral vx cG crn wral cG crn cG crn cxp cG crn cG wf wa cG
    cmnd wcel wi wi vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv wceq
    wa vw cv vy cv cG co vx cv wceq vy cv vw cv cG co vx cv wceq wa vw cG crn
    wrex wa vy cG crn wral vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv
    wceq wa vy cG crn wral vx cG crn vx cv vy cv cG co vy cv wceq vy cv vx cv
    cG co vy cv wceq wa vw cv vy cv cG co vx cv wceq vy cv vw cv cG co vx cv
    wceq wa vw cG crn wrex wa vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy
    cv wceq wa vy cG crn vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv
    wceq wa vw cv vy cv cG co vx cv wceq vy cv vw cv cG co vx cv wceq wa vw cG
    crn wrex pm3.26 r19.20si r19.22si vx cv vy cv cG co vz cv cG co vx cv vy cv
    vz cv cG co cG co wceq vz cG crn wral vy cG crn wral vx cG crn wral cG crn
    cG crn cxp cG crn cG wf wa vx cv vy cv cG co vy cv wceq vy cv vx cv cG co
    vy cv wceq wa vy cG crn wral vx cG crn wrex cG cgr wcel cG cmnd wcel cG crn
    cG crn cxp cG crn cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG
    co cG co wceq vz cG crn wral vy cG crn wral vx cG crn wral vx cv vy cv cG
    co vy cv wceq vy cv vx cv cG co vy cv wceq wa vy cG crn wral vx cG crn wrex
    cG cgr wcel cG cmnd wcel wi wi cG crn cG crn cxp cG crn cG wf vx cv vy cv
    cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq vz cG crn wral vy cG
    crn wral vx cG crn wral vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy
    cv wceq wa vy cG crn wral vx cG crn wrex cG cgr wcel cG cmnd wcel wi cG cgr
    wcel cG cmnd wcel cG crn cG crn cxp cG crn cG wf vx cv vy cv cG co vz cv cG
    co vx cv vy cv vz cv cG co cG co wceq vz cG crn wral vy cG crn wral vx cG
    crn wral vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv wceq wa vy cG
    crn wral vx cG crn wrex w3a cG cgr wcel cG cmnd wcel cG crn cG crn cxp cG
    crn cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co cG co wceq
    vz cG crn wral vy cG crn wral vx cG crn wral vy cv vx cv cG co vy cv wceq
    vx cv vy cv cG co vy cv wceq wa vy cG crn wral vx cG crn wrex w3a cG crn cG
    crn cxp cG crn cG wf vx cv vy cv cG co vz cv cG co vx cv vy cv vz cv cG co
    cG co wceq vz cG crn wral vy cG crn wral vx cG crn wral vx cv vy cv cG co
    vy cv wceq vy cv vx cv cG co vy cv wceq wa vy cG crn wral vx cG crn wrex
    w3a vx vy vz cgr cG cG crn cG crn eqid ismnd2 cG cgr wcel vy cv vx cv cG co
    vy cv wceq vx cv vy cv cG co vy cv wceq wa vy cG crn wral vx cG crn wrex vx
    cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv wceq wa vy cG crn wral vx
    cG crn wrex cG crn cG crn cxp cG crn cG wf vx cv vy cv cG co vz cv cG co vx
    cv vy cv vz cv cG co cG co wceq vz cG crn wral vy cG crn wral vx cG crn
    wral cG cgr wcel vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq
    wa vx cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv wceq wa vx vy cG
    crn cG crn vy cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq wa vx
    cv vy cv cG co vy cv wceq vy cv vx cv cG co vy cv wceq wa wb cG cgr wcel vy
    cv vx cv cG co vy cv wceq vx cv vy cv cG co vy cv wceq ancom a1i rexralbidv
    3anbi3d bitrd biimprcd 3exp impcom com3l syl mpcom com12 ex a1i com13 3imp
    syli pm2.43i $.
    $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  $c ^md $.
  clsg $a class ^md $. $( Extend class notation with monoid exponentiation. $)

  ${ $d g f a b c $.
  $( Define the exponentiation of an element of a monoid.  Experimental.
     I define exponentiation on a monoid (and not on a
     semi-group or a magma ) because I need an identity element for the basis
     hypothesis and associativity for interesting properties such as the
     composite of two exponentiated elements. ` ZZ ` is used in  ~ df-gx  here
     I used ` NN0 `
     because the inverse is not defined in a monoid. $)
  expsg-df $a |- ^md = { <. g , f >. | ( g e. Mnd /\
     f = { <. <. x , y >. , z >. | ( ( x e. ran g /\ y e. NN0 ) /\
       z = if ( y = 0 , ( Id ` g ) ,
         ( ( g seq1 ( NN x. { x } ) ) ` y ) ) ) } ) } $.
  $}

  ${
    expmiz.2 $e |- F =
        ( rec ( { <. a , b >. | b = ( a G A ) } , ( Id ` G ) ) |` om ) $.
    ${
      $( Value of a member of a monoid (or any other structure where
         ` Id ` is defined ) raised to the 0th power. $)
      expmiz $p |- ( F ` (/) ) = ( Id ` G ) $=
        c0 cF cfv c0 vb cv va cv cA cG co wceq va vb copab cG cgi cfv crdg com
        cres cfv cG cgi cfv c0 cF vb cv va cv cA cG co wceq va vb copab cG cgi
        cfv crdg com cres expmiz.2 fveq1i cG cgi cfv cvv wcel c0 vb cv va cv cA
        cG co wceq va vb copab cG cgi cfv crdg com cres cfv cG cgi cfv wceq cG
        cgi fvex cG cgi cfv cvv vb cv va cv cA cG co wceq va vb copab fr0g
        ax-mp eqtri $.
        $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    ${ $d A a b $. $d F a b $. $d G a b $. $d N a b $.
      $( Exponentiation of a monoid. The value at a successor. What
         I am calculating is ` ( A ( ^md `` G )  N ) ` . $)
    expm $p |- ( N e. om ->
      ( F ` suc N ) = ( ( F ` N ) G A ) ) $=
      cN com wcel cN csuc vb cv va cv cA cG co wceq va vb copab cG cgi cfv crdg
      com cres cfv cN vb cv va cv cA cG co wceq va vb copab cG cgi cfv crdg com
      cres cfv vb cv va cv cA cG co wceq va vb copab cfv cN csuc cF cfv cN cF
      cfv cA cG co cG cgi cfv cN vb cv va cv cA cG co wceq va vb copab frsuc cN
      csuc cF cfv cN csuc vb cv va cv cA cG co wceq va vb copab cG cgi cfv crdg
      com cres cfv cN csuc cF vb cv va cv cA cG co wceq va vb copab cG cgi cfv
      crdg com cres expmiz.2 fveq1i eqcomi cN cF cfv vb cv va cv cA cG co wceq
      va vb copab cfv cN vb cv va cv cA cG co wceq va vb copab cG cgi cfv crdg
      com cres cfv vb cv va cv cA cG co wceq va vb copab cfv cN cF cfv cA cG co
      cN cF cfv cN vb cv va cv cA cG co wceq va vb copab cG cgi cfv crdg com
      cres cfv vb cv va cv cA cG co wceq va vb copab cN cF vb cv va cv cA cG co
      wceq va vb copab cG cgi cfv crdg com cres expmiz.2 fveq1i fveq2i cN cF
      cfv cvv wcel cN cF cfv cA cG co cvv wcel cN cF cfv vb cv va cv cA cG co
      wceq va vb copab cfv cN cF cfv cA cG co wceq cN cF fvex cN cF cfv cA cG
      oprex va vb cN cF cfv va cv cA cG co cN cF cfv cA cG co cvv cvv va cv cN
      cF cfv cA cG opreq1 fvopabg mp2an eqtr3i 3eqtr3g $.
      $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

    expus.1 $e |- G e. Mnd $.
    expus.3 $e |- A e. X $.
    expus.4 $e |- X = ran G $.
    ${ $d A a b $. $d F a b y $. $d F x y $. $d G a b $. $d X x y $.
      $( The exponentiation of a member of a  monoid belongs to the underlying
         set. $)
      expus $p |- ( x e. om -> ( F ` x ) e. X ) $=
        vx cv cF cfv cX wcel c0 cF cfv cX wcel vy cv cF cfv cX wcel vy cv csuc
        cF cfv cX wcel vx vy vx cv c0 wceq vx cv cF cfv c0 cF cfv cX vx cv c0
        cF fveq2 eleq1d vx vy weq vx cv cF cfv vy cv cF cfv cX vx cv vy cv cF
        fveq2 eleq1d vx cv vy cv csuc wceq vx cv cF cfv vy cv csuc cF cfv cX vx
        cv vy cv csuc cF fveq2 eleq1d cG cmagm cexid cin wcel c0 cF cfv cX wcel
        cG cmnd wcel cG cmagm cexid cin wcel expus.1 cG cmnd wcel cG cmagm wcel
        cG cexid wcel wa cG cmagm cexid cin wcel cG cmnd wcel cG cmagm wcel cG
        cexid wcel cG mndismgm cG mndisexid jca cG cmagm cexid elin sylibr
        ax-mp c0 cF cfv cG cX expus.4 cA cF cG va vb expmiz.2 expmiz iorlid
        ax-mp vy cv com wcel vy cv cF cfv cX wcel vy cv csuc cF cfv cX wcel vy
        cv com wcel vy cv cF cfv cX wcel wa vy cv csuc cF cfv vy cv cF cfv cA
        cG co cX vy cv com wcel vy cv csuc cF cfv vy cv cF cfv cA cG co wceq vy
        cv cF cfv cX wcel cA cF cG vy cv va vb expmiz.2 expm adantr vy cv cF
        cfv cX wcel vy cv cF cfv cA cG co cX wcel vy cv com wcel cX cX cxp cX
        cG wf vy cv cF cfv cX wcel cA cX wcel vy cv cF cfv cA cG co cX wcel cG
        cmnd wcel cX cX cxp cX cG wf expus.1 cG cX expus.4 mndio ax-mp expus.3
        vy cv cF cfv cA cX cX cX cG foprrn mp3an13 adantl eqeltrd ex finds1 $.
        $( [14-Dec-2009] $) $( [12-Dec-2009] $)
    $}

  $}

  $( The range of the domain of a magma equals the domain of the domain. $)
  mgmrddd $p |- ( G e. Magma  -> ran dom G = dom dom G ) $=
    cG cmagm wcel cG cdm crn cG cdm cdm wceq cG cmagm wcel cG cmagm wcel cG cdm
    cdm cG cdm cdm cxp cG cdm cdm cG wf cG cdm crn cG cdm cdm wceq cmagm cG cG
    cdm cdm cG cdm cdm eqid ismgm cG cdm cdm cG cdm cdm cxp cG cdm cdm cG wf cG
    cdm cG cdm cdm cG cdm cdm cxp wceq cG cdm crn cG cdm cdm wceq cG cdm cdm cG
    cdm cdm cxp cG cdm cdm cG fdm cG cdm cG cdm cdm cG cdm cdm cxp wceq cG cdm
    crn cG cdm cdm cG cdm cdm cxp crn cG cdm cdm cG cdm cG cdm cdm cG cdm cdm
    cxp rneq cG cdm cdm rnxpid syl6eq syl syl6bi pm2.43i $.
    $( [18-May-2010] $) $( [17-May-2010] $)

  ${
    unsgrp.1 $e |- X = ran G $.
    $( The underlying set of a group is a set. $)
    unsgrp $p |- ( G e. Grp -> X e. _V ) $=
      cG cgr wcel cG crn cvv cX cG cgr rnexg unsgrp.1 syl5eqel $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d G x y z $.
    $( A group operation is a left group action of the group on itself. $)
    ltlga $p |- ( G e. Grp -> <. G , G >. e. GrpAct ) $=
      cG cgr wcel cG cG cop cga wcel cG cgr wcel cG crn cG cdm crn cxp cG cdm
      crn cG wf cG cgi cfv vx cv cG co vx cv wceq vy cv vz cv cG co vx cv cG co
      vy cv vz cv vx cv cG co cG co wceq vz cG crn wral vy cG crn wral wa vx cG
      cdm crn wral w3a cG cgr wcel cG cgr wcel cG crn cG cdm crn cxp cG cdm crn
      cG wf cG cgi cfv vx cv cG co vx cv wceq vy cv vz cv cG co vx cv cG co vy
      cv vz cv vx cv cG co cG co wceq vz cG crn wral vy cG crn wral wa vx cG
      cdm crn wral cG cgr wcel id cG cgr wcel cG crn cG cdm crn cxp cG cdm crn
      cG wf cG cgr wcel cG cmnd wcel cG crn cG crn cxp cG crn cG wf cG cgr wcel
      cG crn cG cdm crn cxp cG cdm crn cG wf wi cG grpmnd cG cG crn cG crn eqid
      mndio cG cgr wcel cG crn cG crn cxp cG crn cG wf cG crn cG cdm crn cxp cG
      cdm crn cG wf cG crn cG crn cxp cG crn cG cdm crn cxp wceq cG crn cG cdm
      crn wceq cG crn cG crn cxp cG crn cG wf cG crn cG cdm crn cxp cG cdm crn
      cG wf wb cG cgr wcel cG crn cG crn cxp cG crn cG crn cG cdm crn cxp cG
      cdm crn cG feq23 cG cgr wcel cG crn cG cdm crn wceq cG crn cG crn cxp cG
      crn cG cdm crn cxp wceq cG cgr wcel cG crn cG cdm cdm cG cdm crn cG
      grprndm cG cgr wcel cG cmagm wcel cG cdm crn cG cdm cdm wceq cG cgr wcel
      cG cmnd wcel cG cmagm wcel cG grpmnd cG mndismgm syl cG mgmrddd syl
      eqtr4d cG crn cG cdm crn cG crn xpeq2 syl cG cgr wcel cG crn cG cdm cdm
      cG cdm crn cG grprndm cG cgr wcel cG cmagm wcel cG cdm crn cG cdm cdm
      wceq cG cgr wcel cG cmnd wcel cG cmagm wcel cG grpmnd cG mndismgm syl cG
      mgmrddd syl eqtr4d sylanc biimpcd 3syl pm2.43i cG cgr wcel cG cgi cfv vx
      cv cG co vx cv wceq vy cv vz cv cG co vx cv cG co vy cv vz cv vx cv cG co
      cG co wceq vz cG crn wral vy cG crn wral wa vx cG cdm crn cG cgr wcel vx
      cv cG cdm crn wcel vx cv cG crn wcel cG cgi cfv vx cv cG co vx cv wceq vy
      cv vz cv cG co vx cv cG co vy cv vz cv vx cv cG co cG co wceq vz cG crn
      wral vy cG crn wral wa cG cgr wcel cG cdm crn cG crn vx cv cG cgr wcel cG
      cdm crn cG cdm cdm cG crn cG cgr wcel cG cmagm wcel cG cdm crn cG cdm cdm
      wceq cG cgr wcel cG cmnd wcel cG cmagm wcel cG grpmnd cG mndismgm syl cG
      mgmrddd syl cG grprndm eqtr4d eleq2d cG cgr wcel vx cv cG crn wcel cG cgi
      cfv vx cv cG co vx cv wceq vy cv vz cv cG co vx cv cG co vy cv vz cv vx
      cv cG co cG co wceq vz cG crn wral vy cG crn wral wa cG cgr wcel vx cv cG
      crn wcel wa cG cgi cfv vx cv cG co vx cv wceq vy cv vz cv cG co vx cv cG
      co vy cv vz cv vx cv cG co cG co wceq vz cG crn wral vy cG crn wral vx cv
      cG cgi cfv cG cG crn cG crn eqid cG cgi cfv eqid grplid cG cgr wcel vx cv
      cG crn wcel wa vy cv vz cv cG co vx cv cG co vy cv vz cv vx cv cG co cG
      co wceq vy vz cG crn cG crn cG cgr wcel vx cv cG crn wcel vy cv cG crn
      wcel vz cv cG crn wcel vy cv vz cv cG co vx cv cG co vy cv vz cv vx cv cG
      co cG co wceq cG cgr wcel vz cv cG crn wcel vy cv cG crn wcel vx cv cG
      crn wcel vy cv vz cv cG co vx cv cG co vy cv vz cv vx cv cG co cG co wceq
      cG cgr wcel vy cv cG crn wcel vz cv cG crn wcel vx cv cG crn wcel vy cv
      vz cv cG co vx cv cG co vy cv vz cv vx cv cG co cG co wceq wi cG cgr wcel
      vy cv cG crn wcel vz cv cG crn wcel vx cv cG crn wcel vy cv vz cv cG co
      vx cv cG co vy cv vz cv vx cv cG co cG co wceq vy cv vz cv vx cv cG cG
      crn cG crn eqid grpass 3exp2 com23 com24 imp4b r19.21aivv jca ex sylbid
      r19.21aiv 3jca vx vy vz cgr cG cgi cfv cG cG cG crn cG cdm crn cG crn
      eqid cG cdm crn eqid cG cgi cfv eqid isga mpbird $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}


  ${
    $d A f g $. $d A g x $. $d P f $.
    symgfo.1 $e |- A e. _V $.
    symgfo.2 $e |- P = { x | x : A -1-1-onto-> A } $.
    $( The operation of a symetry group is onto. $)
    symgfo $p |- ( SymGrp ` A ) : ( P X. P ) -onto-> P $=
      cA csymgrp cfv cmagm cexid cin wcel cP cP cxp cP cA csymgrp cfv wfo cA
      csymgrp cfv cmagm cexid cin wcel cA csymgrp cfv cmagm wcel cA csymgrp cfv
      cexid wcel cA csymgrp cfv cmagm cexid elin cA csymgrp cfv cmagm wcel cP
      cP cxp cP cA csymgrp cfv wf vx cA cP symgfo.1 symgfo.2 symgf cA csymgrp
      cfv cgr wcel cA csymgrp cfv cmagm wcel cP cP cxp cP cA csymgrp cfv wf wb
      cA symgfo.1 symggrpi cgr cA csymgrp cfv cP cP cP cxp cP cA csymgrp cfv wf
      cP cA csymgrp cfv cdm cdm wceq vx cA cP symgfo.1 symgfo.2 symgf cP cP cxp
      cP cA csymgrp cfv wf cA csymgrp cfv cdm cP cP cxp wceq cA csymgrp cfv cdm
      cdm cP cP cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq cP cP cxp cP cA
      csymgrp cfv fdm cA csymgrp cfv cdm cP cP cxp dmeq cP cP cxp cdm cP wceq
      cA csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq
      wi cP dmxpid cA csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cA csymgrp cfv
      cdm cdm wceq wi cP cP cP cxp cdm cA csymgrp cfv cdm cdm cP cP cxp cdm
      wceq cP cP cP cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq cP cP cP cxp
      cdm wceq cP cA csymgrp cfv cdm cdm wceq wi cP cP cxp cdm cA csymgrp cfv
      cdm cdm cP cP cP cxp cdm wceq cP cP cxp cdm cA csymgrp cfv cdm cdm wceq
      cP cA csymgrp cfv cdm cdm wceq cP cP cP cxp cdm cA csymgrp cfv cdm cdm
      eqtr expcom eqcoms com12 eqcoms ax-mp 3syl ax-mp ismgm ax-mp mpbir cA
      csymgrp cfv cexid wcel vg cv vf cv cA csymgrp cfv co vg cv wceq vf cv vg
      cv cA csymgrp cfv co vg cv wceq wa vg cP wral vf cP wrex cid cA cres cP
      wcel vg cv cid cA cres cA csymgrp cfv co vg cv wceq cid cA cres vg cv cA
      csymgrp cfv co vg cv wceq wa vg cP wral vg cv vf cv cA csymgrp cfv co vg
      cv wceq vf cv vg cv cA csymgrp cfv co vg cv wceq wa vg cP wral vf cP wrex
      cid cA cres cA cA vx cv wf1o vx cab cP cid cA cres cA cA vx cv wf1o vx
      cab wcel cA cA cid cA cres wf1o cA f1oi vx cA cA cA vx cv wf1o vx cab cid
      cA cres symgfo.1 cA cA vx cv wf1o vx cab eqid elsymgrn mpbir symgfo.2
      eleqtrri vg cv cid cA cres cA csymgrp cfv co vg cv wceq cid cA cres vg cv
      cA csymgrp cfv co vg cv wceq wa vg cP vg cv cP wcel vg cv cid cA cres cA
      csymgrp cfv co vg cv wceq cid cA cres vg cv cA csymgrp cfv co vg cv wceq
      vg cv cP wcel cid cA cres cP wcel vg cv cid cA cres cA csymgrp cfv co vg
      cv wceq cid cA cres cA cA vx cv wf1o vx cab cP cid cA cres cA cA vx cv
      wf1o vx cab wcel cA cA cid cA cres wf1o cA f1oi vx cA cA cA vx cv wf1o vx
      cab cid cA cres symgfo.1 cA cA vx cv wf1o vx cab eqid elsymgrn mpbir
      symgfo.2 eleqtrri vg cv cP wcel cid cA cres cP wcel wa vg cv cid cA cres
      cA csymgrp cfv co vg cv cid cA cres ccom vg cv vx cA cP vg cv cid cA cres
      symgfo.1 symgfo.2 symgoprv vg cv cP wcel vg cv cid cA cres ccom vg cv
      wceq cid cA cres cP wcel vg cv cP wcel vg cv cA cA vx cv wf1o vx cab wcel
      vg cv cid cA cres ccom vg cv wceq cP cA cA vx cv wf1o vx cab vg cv
      symgfo.2 eleq2i vg cv cA cA vx cv wf1o vx cab wcel cA cA vg cv wf1o vg cv
      cid cA cres ccom vg cv wceq vx cA cA cA vx cv wf1o vx cab vg cv symgfo.1
      cA cA vx cv wf1o vx cab eqid elsymgrn cA cA vg cv wf1o cA cA vg cv wf vg
      cv cid cA cres ccom vg cv wceq cA cA vg cv f1of cA cA vg cv fcoi1 syl
      sylbi sylbi adantr eqtrd mpan2 cid cA cres cP wcel vg cv cP wcel cid cA
      cres vg cv cA csymgrp cfv co vg cv wceq cid cA cres cA cA vx cv wf1o vx
      cab cP cid cA cres cA cA vx cv wf1o vx cab wcel cA cA cid cA cres wf1o cA
      f1oi vx cA cA cA vx cv wf1o vx cab cid cA cres symgfo.1 cA cA vx cv wf1o
      vx cab eqid elsymgrn mpbir symgfo.2 eleqtrri cid cA cres cP wcel vg cv cP
      wcel wa cid cA cres vg cv cA csymgrp cfv co cid cA cres vg cv ccom vg cv
      vx cA cP cid cA cres vg cv symgfo.1 symgfo.2 symgoprv vg cv cP wcel cid
      cA cres vg cv ccom vg cv wceq cid cA cres cP wcel vg cv cP wcel vg cv cA
      cA vx cv wf1o vx cab wcel cid cA cres vg cv ccom vg cv wceq cP cA cA vx
      cv wf1o vx cab vg cv symgfo.2 eleq2i vg cv cA cA vx cv wf1o vx cab wcel
      cA cA vg cv wf1o cid cA cres vg cv ccom vg cv wceq vx cA cA cA vx cv wf1o
      vx cab vg cv symgfo.1 cA cA vx cv wf1o vx cab eqid elsymgrn cA cA vg cv
      wf1o cA cA vg cv wf cid cA cres vg cv ccom vg cv wceq cA cA vg cv f1of cA
      cA vg cv fcoi2 syl sylbi sylbi adantl eqtrd mpan jca rgen vg cv vf cv cA
      csymgrp cfv co vg cv wceq vf cv vg cv cA csymgrp cfv co vg cv wceq wa vg
      cP wral vg cv cid cA cres cA csymgrp cfv co vg cv wceq cid cA cres vg cv
      cA csymgrp cfv co vg cv wceq wa vg cP wral vf cid cA cres cP vf cv cid cA
      cres wceq vg cv vf cv cA csymgrp cfv co vg cv wceq vf cv vg cv cA csymgrp
      cfv co vg cv wceq wa vg cv cid cA cres cA csymgrp cfv co vg cv wceq cid
      cA cres vg cv cA csymgrp cfv co vg cv wceq wa vg cP vf cv cid cA cres
      wceq vg cv vf cv cA csymgrp cfv co vg cv wceq vg cv cid cA cres cA
      csymgrp cfv co vg cv wceq vf cv vg cv cA csymgrp cfv co vg cv wceq cid cA
      cres vg cv cA csymgrp cfv co vg cv wceq vf cv cid cA cres wceq vg cv vf
      cv cA csymgrp cfv co vg cv cid cA cres cA csymgrp cfv co vg cv vf cv cid
      cA cres vg cv cA csymgrp cfv opreq2 eqeq1d vf cv cid cA cres wceq vf cv
      vg cv cA csymgrp cfv co cid cA cres vg cv cA csymgrp cfv co vg cv vf cv
      cid cA cres vg cv cA csymgrp cfv opreq1 eqeq1d anbi12d ralbidv rcla4ev
      mp2an cA csymgrp cfv cgr wcel cA csymgrp cfv cexid wcel vg cv vf cv cA
      csymgrp cfv co vg cv wceq vf cv vg cv cA csymgrp cfv co vg cv wceq wa vg
      cP wral vf cP wrex wb cA symgfo.1 symggrpi vf vg cgr cA csymgrp cfv cP cP
      cP cxp cP cA csymgrp cfv wf cP cA csymgrp cfv cdm cdm wceq vx cA cP
      symgfo.1 symgfo.2 symgf cP cP cxp cP cA csymgrp cfv wf cA csymgrp cfv cdm
      cP cP cxp wceq cA csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cA csymgrp
      cfv cdm cdm wceq cP cP cxp cP cA csymgrp cfv fdm cA csymgrp cfv cdm cP cP
      cxp dmeq cP cP cxp cdm cP wceq cA csymgrp cfv cdm cdm cP cP cxp cdm wceq
      cP cA csymgrp cfv cdm cdm wceq wi cP dmxpid cA csymgrp cfv cdm cdm cP cP
      cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq wi cP cP cP cxp cdm cA
      csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cP cP cxp cdm wceq cP cA
      csymgrp cfv cdm cdm wceq cP cP cP cxp cdm wceq cP cA csymgrp cfv cdm cdm
      wceq wi cP cP cxp cdm cA csymgrp cfv cdm cdm cP cP cP cxp cdm wceq cP cP
      cxp cdm cA csymgrp cfv cdm cdm wceq cP cA csymgrp cfv cdm cdm wceq cP cP
      cP cxp cdm cA csymgrp cfv cdm cdm eqtr expcom eqcoms com12 eqcoms ax-mp
      3syl ax-mp isexid ax-mp mpbir mpbir2an cA csymgrp cfv cP cP cP cxp cP cA
      csymgrp cfv wf cP cA csymgrp cfv cdm cdm wceq vx cA cP symgfo.1 symgfo.2
      symgf cP cP cxp cP cA csymgrp cfv wf cA csymgrp cfv cdm cP cP cxp wceq cA
      csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq cP
      cP cxp cP cA csymgrp cfv fdm cA csymgrp cfv cdm cP cP cxp dmeq cP cP cxp
      cdm cP wceq cA csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cA csymgrp cfv
      cdm cdm wceq wi cP dmxpid cA csymgrp cfv cdm cdm cP cP cxp cdm wceq cP cA
      csymgrp cfv cdm cdm wceq wi cP cP cP cxp cdm cA csymgrp cfv cdm cdm cP cP
      cxp cdm wceq cP cP cP cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq cP cP
      cP cxp cdm wceq cP cA csymgrp cfv cdm cdm wceq wi cP cP cxp cdm cA
      csymgrp cfv cdm cdm cP cP cP cxp cdm wceq cP cP cxp cdm cA csymgrp cfv
      cdm cdm wceq cP cA csymgrp cfv cdm cdm wceq cP cP cP cxp cdm cA csymgrp
      cfv cdm cdm eqtr expcom eqcoms com12 eqcoms ax-mp 3syl ax-mp opidon ax-mp
      $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    gaplc.1 $e |- X = ran G $.
    gaplc.2 $e |- Y = ran M $.
    $( The action of a particular group element is left-cancelable. $)
    gaplc $p |- ( ( M e. N /\ <. G , M >. e. GrpAct /\
                  ( C e. X /\ A e. Y /\ B e. Y ) )
      -> ( ( C M A ) = ( C M B ) -> A = B ) ) $=
      cM cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel w3a w3a cM
      crn cM crn cM c2nd cC csn cvv cxp cres ccnv ccom wf1o cC cA cM co cC cB
      cM co wceq cA cB wceq wi cM cN wcel cG cM cop cga wcel cC cG crn wcel cM
      crn cM crn cM c2nd cC csn cvv cxp cres ccnv ccom wf1o cC cX wcel cA cY
      wcel cB cY wcel w3a cC cN cM c2nd cC csn cvv cxp cres ccnv ccom cG cM cG
      crn cM crn cG crn eqid cM crn eqid cM c2nd cC csn cvv cxp cres ccnv ccom
      eqid gapm cC cX wcel cA cY wcel cC cG crn wcel cB cY wcel cC cX wcel cC
      cG crn wcel cX cG crn cC gaplc.1 eleq2i biimpi 3ad2ant1 syl3an3 cM cN
      wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel w3a w3a cM crn
      cM crn cM c2nd cC csn cvv cxp cres ccnv ccom wf1o wa cA cC cM ccur1 cfv
      cfv cfv cC cA cM co wceq cB cC cM ccur1 cfv cfv cfv cC cB cM co wceq wa
      cC cA cM co cC cB cM co wceq cA cB wceq wi cM cN wcel cG cM cop cga wcel
      cC cX wcel cA cY wcel cB cY wcel w3a w3a cM crn cM crn cM c2nd cC csn cvv
      cxp cres ccnv ccom wf1o wa cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY
      cxp wfn wa cC cX wcel cA cY wcel wa w3a cX cvv wcel cY cvv wcel wa cY c0
      wne cM cX cY cxp wfn wa cC cX wcel cB cY wcel wa w3a wa cA cC cM ccur1
      cfv cfv cfv cC cA cM co wceq cB cC cM ccur1 cfv cfv cfv cC cB cM co wceq
      wa cM cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel w3a w3a
      cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY cxp wfn wa cC cX wcel cA cY
      wcel wa w3a cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY cxp wfn wa cC
      cX wcel cB cY wcel wa w3a wa cM crn cM crn cM c2nd cC csn cvv cxp cres
      ccnv ccom wf1o cM cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY
      wcel w3a w3a cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY cxp wfn wa cC
      cX wcel cA cY wcel wa w3a cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY
      cxp wfn wa cC cX wcel cB cY wcel wa w3a cM cN wcel cG cM cop cga wcel cC
      cX wcel cA cY wcel cB cY wcel w3a w3a cX cvv wcel cY cvv wcel wa cY c0
      wne cM cX cY cxp wfn wa cC cX wcel cA cY wcel wa cM cN wcel cG cM cop cga
      wcel cX cvv wcel cY cvv wcel wa cC cX wcel cA cY wcel cB cY wcel w3a cG
      cgr wcel cM cN wcel cG cM cop cga wcel wa cX cvv wcel cY cvv wcel wa cN
      cG cM gagrp cG cgr wcel cX cvv wcel cM cN wcel cG cM cop cga wcel wa cY
      cvv wcel cG cX gaplc.1 unsgrp cM cN wcel cY cvv wcel cG cM cop cga wcel
      cM cN wcel cM crn cvv cY cM cN rnexg gaplc.2 syl5eqel adantr anim12i
      mpancom 3adant3 cM cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY
      wcel w3a w3a cY c0 wne cM cX cY cxp wfn cC cX wcel cA cY wcel cB cY wcel
      w3a cM cN wcel cY c0 wne cG cM cop cga wcel cA cY wcel cC cX wcel cY c0
      wne cB cY wcel cY cA ne0i 3ad2ant2 3ad2ant3 cM cN wcel cG cM cop cga wcel
      cM cX cY cxp wfn cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel cG cM
      cop cga wcel wa cG crn cM crn cxp cM crn cM wf cM cX cY cxp wfn cN cG cM
      cG crn cM crn cG crn eqid cM crn eqid gaf cG crn cM crn cxp cM crn cM wf
      cM cG crn cM crn cxp wfn cM cX cY cxp wfn cG crn cM crn cxp cM crn cM ffn
      cG crn cM crn cxp cX cY cxp wceq cM cG crn cM crn cxp wfn cM cX cY cxp
      wfn wi cG crn cM crn cxp cX cM crn cxp cX cY cxp cX cG crn wceq cG crn cM
      crn cxp cX cM crn cxp wceq gaplc.1 cX cG crn wceq cX cM crn cxp cG crn cM
      crn cxp cX cG crn cM crn xpeq1 eqcomd ax-mp cY cM crn wceq cX cM crn cxp
      cX cY cxp wceq gaplc.2 cY cM crn wceq cX cY cxp cX cM crn cxp cY cM crn
      cX xpeq2 eqcomd ax-mp eqtri cG crn cM crn cxp cX cY cxp wceq cM cG crn cM
      crn cxp wfn cM cX cY cxp wfn cG crn cM crn cxp cX cY cxp cM fneq2 biimpd
      ax-mp syl syl 3adant3 jca cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel
      cC cX wcel cA cY wcel wa cG cM cop cga wcel cC cX wcel cA cY wcel cB cY
      wcel 3simpa 3ad2ant3 3jca cM cN wcel cG cM cop cga wcel cC cX wcel cA cY
      wcel cB cY wcel w3a w3a cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY cxp
      wfn wa cC cX wcel cB cY wcel wa cM cN wcel cG cM cop cga wcel cX cvv wcel
      cY cvv wcel wa cC cX wcel cA cY wcel cB cY wcel w3a cG cgr wcel cM cN
      wcel cG cM cop cga wcel wa cX cvv wcel cY cvv wcel wa cN cG cM gagrp cG
      cgr wcel cX cvv wcel cM cN wcel cG cM cop cga wcel wa cY cvv wcel cG cX
      gaplc.1 unsgrp cM cN wcel cY cvv wcel cG cM cop cga wcel cM cN wcel cM
      crn cvv cY cM cN rnexg gaplc.2 syl5eqel adantr anim12i mpancom 3adant3 cM
      cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel w3a w3a cY c0
      wne cM cX cY cxp wfn cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel cY
      c0 wne cG cM cop cga wcel cA cY wcel cC cX wcel cY c0 wne cB cY wcel cY
      cA ne0i 3ad2ant2 3ad2ant3 cM cN wcel cG cM cop cga wcel cM cX cY cxp wfn
      cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel cG cM cop cga wcel wa cG
      crn cM crn cxp cM crn cM wf cM cX cY cxp wfn cN cG cM cG crn cM crn cG
      crn eqid cM crn eqid gaf cG crn cM crn cxp cM crn cM wf cM cG crn cM crn
      cxp wfn cM cX cY cxp wfn cG crn cM crn cxp cM crn cM ffn cG crn cM crn
      cxp cX cY cxp wceq cM cG crn cM crn cxp wfn cM cX cY cxp wfn wi cG crn cM
      crn cxp cX cM crn cxp cX cY cxp cX cG crn wceq cG crn cM crn cxp cX cM
      crn cxp wceq gaplc.1 cX cG crn wceq cX cM crn cxp cG crn cM crn cxp cX cG
      crn cM crn xpeq1 eqcomd ax-mp cY cM crn wceq cX cM crn cxp cX cY cxp wceq
      gaplc.2 cY cM crn wceq cX cY cxp cX cM crn cxp cY cM crn cX xpeq2 eqcomd
      ax-mp eqtri cG crn cM crn cxp cX cY cxp wceq cM cG crn cM crn cxp wfn cM
      cX cY cxp wfn cG crn cM crn cxp cX cY cxp cM fneq2 biimpd ax-mp syl syl
      3adant3 jca cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel cC cX wcel cB
      cY wcel wa cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel 3simpb
      3ad2ant3 3jca jca adantr cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY
      cxp wfn wa cC cX wcel cA cY wcel wa w3a cA cC cM ccur1 cfv cfv cfv cC cA
      cM co wceq cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY cxp wfn wa cC cX
      wcel cB cY wcel wa w3a cB cC cM ccur1 cfv cfv cfv cC cB cM co wceq cX cY
      cvv cvv cA cM cC valvalcurfn cX cY cvv cvv cB cM cC valvalcurfn anim12i
      syl cA cC cM ccur1 cfv cfv cfv cC cA cM co wceq cB cC cM ccur1 cfv cfv
      cfv cC cB cM co wceq wa cC cA cM co cC cB cM co wceq cA cC cM ccur1 cfv
      cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cM cN wcel cG cM cop cga wcel cC
      cX wcel cA cY wcel cB cY wcel w3a w3a cM crn cM crn cM c2nd cC csn cvv
      cxp cres ccnv ccom wf1o wa cA cB wceq cA cC cM ccur1 cfv cfv cfv cC cA cM
      co wceq cB cC cM ccur1 cfv cfv cfv cC cB cM co wceq wa cC cA cM co cC cB
      cM co wceq cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cA
      cC cM ccur1 cfv cfv cfv cC cA cM co wceq cB cC cM ccur1 cfv cfv cfv cC cB
      cM co wceq cC cA cM co cA cC cM ccur1 cfv cfv cfv cC cB cM co cB cC cM
      ccur1 cfv cfv cfv cA cC cM ccur1 cfv cfv cfv cC cA cM co wceq cC cA cM co
      cA cC cM ccur1 cfv cfv cfv wceq cA cC cM ccur1 cfv cfv cfv cC cA cM co
      eqcom biimpi cB cC cM ccur1 cfv cfv cfv cC cB cM co wceq cC cB cM co cB
      cC cM ccur1 cfv cfv cfv wceq cB cC cM ccur1 cfv cfv cfv cC cB cM co eqcom
      biimpi eqeqan12d biimpd cM cN wcel cG cM cop cga wcel cC cX wcel cA cY
      wcel cB cY wcel w3a w3a cM crn cM crn cM c2nd cC csn cvv cxp cres ccnv
      ccom wf1o cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cA
      cB wceq wi cC cM ccur1 cfv cfv cM c2nd cC csn cvv cxp cres ccnv ccom wceq
      cM cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel w3a w3a cM
      crn cM crn cM c2nd cC csn cvv cxp cres ccnv ccom wf1o cA cC cM ccur1 cfv
      cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cA cB wceq wi wi cX cvv wcel cY
      cvv wcel wa cY c0 wne cM cX cY cxp wfn wa cC cX wcel cC cM ccur1 cfv cfv
      cM c2nd cC csn cvv cxp cres ccnv ccom wceq cM cN wcel cG cM cop cga wcel
      cC cX wcel cA cY wcel cB cY wcel w3a w3a cX cY cvv cvv cM cM c2nd cC csn
      cvv cxp cres ccnv ccom cC cM c2nd cC csn cvv cxp cres ccnv ccom eqid
      valcurfn1 cM cN wcel cG cM cop cga wcel cX cvv wcel cY cvv wcel wa cC cX
      wcel cA cY wcel cB cY wcel w3a cG cgr wcel cM cN wcel cG cM cop cga wcel
      wa cX cvv wcel cY cvv wcel wa cN cG cM gagrp cG cgr wcel cX cvv wcel cM
      cN wcel cG cM cop cga wcel wa cY cvv wcel cG cX gaplc.1 unsgrp cM cN wcel
      cY cvv wcel cG cM cop cga wcel cM cN wcel cM crn cvv cY cM cN rnexg
      gaplc.2 syl5eqel adantr anim12i mpancom 3adant3 cM cN wcel cG cM cop cga
      wcel cC cX wcel cA cY wcel cB cY wcel w3a w3a cY c0 wne cM cX cY cxp wfn
      cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel cY c0 wne cG cM cop cga
      wcel cA cY wcel cC cX wcel cY c0 wne cB cY wcel cY cA ne0i 3ad2ant2
      3ad2ant3 cM cN wcel cG cM cop cga wcel cM cX cY cxp wfn cC cX wcel cA cY
      wcel cB cY wcel w3a cM cN wcel cG cM cop cga wcel wa cG crn cM crn cxp cM
      crn cM wf cM cX cY cxp wfn cN cG cM cG crn cM crn cG crn eqid cM crn eqid
      gaf cG crn cM crn cxp cM crn cM wf cM cG crn cM crn cxp wfn cM cX cY cxp
      wfn cG crn cM crn cxp cM crn cM ffn cG crn cM crn cxp cX cY cxp wceq cM
      cG crn cM crn cxp wfn cM cX cY cxp wfn wi cG crn cM crn cxp cX cM crn cxp
      cX cY cxp cX cG crn wceq cG crn cM crn cxp cX cM crn cxp wceq gaplc.1 cX
      cG crn wceq cX cM crn cxp cG crn cM crn cxp cX cG crn cM crn xpeq1 eqcomd
      ax-mp cY cM crn wceq cX cM crn cxp cX cY cxp wceq gaplc.2 cY cM crn wceq
      cX cY cxp cX cM crn cxp cY cM crn cX xpeq2 eqcomd ax-mp eqtri cG crn cM
      crn cxp cX cY cxp wceq cM cG crn cM crn cxp wfn cM cX cY cxp wfn cG crn
      cM crn cxp cX cY cxp cM fneq2 biimpd ax-mp syl syl 3adant3 jca cC cX wcel
      cA cY wcel cB cY wcel w3a cM cN wcel cC cX wcel cG cM cop cga wcel cC cX
      wcel cA cY wcel cB cY wcel 3simp1 3ad2ant3 syl3anc cC cM ccur1 cfv cfv cM
      c2nd cC csn cvv cxp cres ccnv ccom wceq cM crn cM crn cM c2nd cC csn cvv
      cxp cres ccnv ccom wf1o cM cN wcel cG cM cop cga wcel cC cX wcel cA cY
      wcel cB cY wcel w3a w3a cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv
      cfv wceq cA cB wceq wi cC cM ccur1 cfv cfv cM c2nd cC csn cvv cxp cres
      ccnv ccom wceq cM crn cM crn cM c2nd cC csn cvv cxp cres ccnv ccom wf1o
      cM crn cM crn cC cM ccur1 cfv cfv wf1o cM cN wcel cG cM cop cga wcel cC
      cX wcel cA cY wcel cB cY wcel w3a w3a cA cC cM ccur1 cfv cfv cfv cB cC cM
      ccur1 cfv cfv cfv wceq cA cB wceq wi wi cM crn cM crn cC cM ccur1 cfv cfv
      cM c2nd cC csn cvv cxp cres ccnv ccom f1oeq1 cY cM crn wceq cM crn cM crn
      cC cM ccur1 cfv cfv wf1o cM cN wcel cG cM cop cga wcel cC cX wcel cA cY
      wcel cB cY wcel w3a w3a cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv
      cfv wceq cA cB wceq wi wi wi gaplc.2 cM crn cM crn cC cM ccur1 cfv cfv
      wf1o cM cN wcel cG cM cop cga wcel cC cX wcel cA cY wcel cB cY wcel w3a
      w3a cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cA cB wceq
      wi wi wi cM crn cY cM crn cY wceq cM crn cM crn cC cM ccur1 cfv cfv wf1o
      cY cY cC cM ccur1 cfv cfv wf1o cM cN wcel cG cM cop cga wcel cC cX wcel
      cA cY wcel cB cY wcel w3a w3a cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1
      cfv cfv cfv wceq cA cB wceq wi wi cM crn cY wceq cM crn cM crn cC cM
      ccur1 cfv cfv wf1o cY cM crn cC cM ccur1 cfv cfv wf1o cY cY cC cM ccur1
      cfv cfv wf1o cM crn cY cM crn cC cM ccur1 cfv cfv f1oeq2 cM crn cY cY cC
      cM ccur1 cfv cfv f1oeq3 bitrd cM cN wcel cG cM cop cga wcel cC cX wcel cA
      cY wcel cB cY wcel w3a w3a cY cY cC cM ccur1 cfv cfv wf1 cA cC cM ccur1
      cfv cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cA cB wceq wi cY cY cC cM
      ccur1 cfv cfv wf1o cC cX wcel cA cY wcel cB cY wcel w3a cM cN wcel cY cY
      cC cM ccur1 cfv cfv wf1 cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv
      cfv wceq cA cB wceq wi wi cG cM cop cga wcel cA cY wcel cB cY wcel cY cY
      cC cM ccur1 cfv cfv wf1 cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv
      cfv wceq cA cB wceq wi wi cC cX wcel cY cY cC cM ccur1 cfv cfv wf1 cA cY
      wcel cB cY wcel wa cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv cfv
      wceq cA cB wceq wi cY cY cC cM ccur1 cfv cfv wf1 cA cY wcel cB cY wcel wa
      wa cA cC cM ccur1 cfv cfv cfv cB cC cM ccur1 cfv cfv cfv wceq cA cB wceq
      cY cY cA cB cC cM ccur1 cfv cfv f1fveq biimpd expcom 3adant1 3ad2ant3 cY
      cY cC cM ccur1 cfv cfv f1of1 syl5com syl6bi eqcoms ax-mp syl6bir com23
      mpcom imp syl9r mpd mpdan $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    gapm2.1 $e |- X = ran G $.
    gapm2.2 $e |- Y = ran M $.
    ${
      $( The action of a particular group element is a permutation of the base
         set. ~ gapm expressed with the currying operator. $)
      gapm2 $p |-
        ( ( M e. B /\ <. G , M >. e. GrpAct /\ ( A e. X /\ Y =/= (/) ) ) ->
        ( ( cur1 ` M ) ` A ) : Y -1-1-onto-> Y ) $=
        cA cM ccur1 cfv cfv cM c2nd cA csn cvv cxp cres ccnv ccom wceq cY cY cM
        c2nd cA csn cvv cxp cres ccnv ccom wf1o cY cY cA cM ccur1 cfv cfv wf1o
        cM cB wcel cG cM cop cga wcel cA cX wcel cY c0 wne wa w3a cY cY cM c2nd
        cA csn cvv cxp cres ccnv ccom wf1o cY cY cA cM ccur1 cfv cfv wf1o wi cM
        c2nd cA csn cvv cxp cres ccnv ccom cA cM ccur1 cfv cfv cM c2nd cA csn
        cvv cxp cres ccnv ccom cA cM ccur1 cfv cfv wceq cY cY cM c2nd cA csn
        cvv cxp cres ccnv ccom wf1o cY cY cA cM ccur1 cfv cfv wf1o cY cY cM
        c2nd cA csn cvv cxp cres ccnv ccom cA cM ccur1 cfv cfv f1oeq1 biimpd
        eqcoms cX cvv wcel cY cvv wcel wa cY c0 wne cM cX cY cxp wfn wa cA cX
        wcel cA cM ccur1 cfv cfv cM c2nd cA csn cvv cxp cres ccnv ccom wceq cM
        cB wcel cG cM cop cga wcel cA cX wcel cY c0 wne wa w3a cX cY cvv cvv cM
        cM c2nd cA csn cvv cxp cres ccnv ccom cA cM c2nd cA csn cvv cxp cres
        ccnv ccom eqid valcurfn1 cM cB wcel cG cM cop cga wcel cA cX wcel cY c0
        wne wa w3a cX cvv wcel cY cvv wcel cM cB wcel cG cM cop cga wcel cX cvv
        wcel cA cX wcel cY c0 wne wa cM cB wcel cG cM cop cga wcel wa cG cgr
        wcel cX cvv wcel cB cG cM gagrp cG cX gapm2.1 unsgrp syl 3adant3 cM cB
        wcel cG cM cop cga wcel cY cvv wcel cA cX wcel cY c0 wne wa cM cB wcel
        cM crn cvv cY cM cB rnexg gapm2.2 syl5eqel 3ad2ant1 jca cM cB wcel cG
        cM cop cga wcel cA cX wcel cY c0 wne wa w3a cY c0 wne cM cX cY cxp wfn
        cA cX wcel cY c0 wne wa cM cB wcel cY c0 wne cG cM cop cga wcel cA cX
        wcel cY c0 wne pm3.27 3ad2ant3 cM cB wcel cG cM cop cga wcel cM cX cY
        cxp wfn cA cX wcel cY c0 wne wa cM cB wcel cG cM cop cga wcel wa cX cY
        cxp cY cM wf cM cX cY cxp wfn cB cG cM cX cY gapm2.1 gapm2.2 gaf cX cY
        cxp cY cM ffn syl 3adant3 jca cA cX wcel cY c0 wne wa cM cB wcel cA cX
        wcel cG cM cop cga wcel cA cX wcel cY c0 wne pm3.26 3ad2ant3 syl3anc cM
        cB wcel cG cM cop cga wcel cA cX wcel cY cY cM c2nd cA csn cvv cxp cres
        ccnv ccom wf1o cY c0 wne cA cB cM c2nd cA csn cvv cxp cres ccnv ccom cG
        cM cX cY gapm2.1 gapm2.2 cM c2nd cA csn cvv cxp cres ccnv ccom eqid
        gapm 3adant3r sylc $.
        $( [18-May-2010] $) $( [17-May-2010] $)
    $}

    ${
      $( The range of the action of a particular group element equals the
         range of the action. $)
      rngapm $p |- (
        ( M e. B /\ <. G , M >. e. GrpAct /\ ( A e. X /\ Y =/= (/) ) )
        -> ran ( ( cur1 ` M ) ` A ) = ran M ) $=
        cM cB wcel cG cM cop cga wcel cA cX wcel cY c0 wne wa w3a cY cY cA cM
        ccur1 cfv cfv wf1o cA cM ccur1 cfv cfv crn cM crn wceq cA cB cG cM cX
        cY gapm2.1 gapm2.2 gapm2 cY cY cA cM ccur1 cfv cfv wf1o cY cY cA cM
        ccur1 cfv cfv wfo cA cM ccur1 cfv cfv crn cY wceq cA cM ccur1 cfv cfv
        crn cM crn wceq cY cY cA cM ccur1 cfv cfv f1ofo cY cY cA cM ccur1 cfv
        cfv forn cA cM ccur1 cfv cfv crn cY wceq cA cM ccur1 cfv cfv crn cM crn
        wceq cY cM crn cA cM ccur1 cfv cfv crn gapm2.2 eqeq2i biimpi 3syl syl
        $.
        $( [18-May-2010] $) $( [17-May-2010] $)
    $}
  $}

  ${
    $( The proof has been designed so that B and x needn't be distinct. $)
    $d A x y $. $d B y $. $d C x y $. $d F t $. $d G t $. $d H t x $.
    $d H x y $.
    fnopabco2b.2 $e |- F = { <. x , y >. | ( x e. A /\ y = B ) } $.
    fnopabco2b. $e |- G = { <. x , y >. | ( x e. A /\ y = ( H ` B ) ) } $.
    $( Composition of a function with a function abstraction.
       Adapted from ~ fnopabco . $)
    fnopabco2b $p |- ( ( A. x e. A B e. C /\ H Fn C )
        -> G = ( H o. F ) ) $=
      cB cC wcel vx cA wral cH cC wfn wa cG cH cF ccom wceq vx cv cG cfv vx cv
      cH cF ccom cfv wceq vx cA wral cB cC wcel vx cA wral cH cC wfn wa vx cv
      cG cfv vx cv cH cF ccom cfv wceq vx cA cB cC wcel vx cA wral cH cC wfn vx
      cB cC wcel vx cA hbra1 cH cC wfn vx ax-17 hban cB cC wcel vx cA wral cH
      cC wfn vx cv cA wcel vx cv cG cfv vx cv cH cF ccom cfv wceq wi vx cv cA
      wcel cB cC wcel vx cA wral cH cC wfn vx cv cG cfv vx cv cH cF ccom cfv
      wceq vx cv cA wcel cB cC wcel vx cA wral cH cC wfn vx cv cG cfv vx cv cH
      cF ccom cfv wceq wi vx cv cA wcel cB cC wcel vx cA wral wa cH cC wfn vx
      cv cG cfv vx cv cH cF ccom cfv wceq wi vx cv cA wcel cB cC wcel vx cA
      wral vx cv cA wcel cB cC wcel vx cA wral wa cH cC wfn vx cv cG cfv vx cv
      cH cF ccom cfv wceq wi wi cB cC wcel vx cA wral vx cv cA wcel cB cC wcel
      vx cv cA wcel cB cC wcel vx cA wral wa cH cC wfn vx cv cG cfv vx cv cH cF
      ccom cfv wceq wi wi cB cC wcel vx cA ra4 cB cC wcel vx cv cA wcel cB cC
      wcel vx cA wral wa cH cC wfn vx cv cG cfv vx cv cH cF ccom cfv wceq cB cC
      wcel vx cv cA wcel cB cC wcel vx cA wral wa cH cC wfn w3a vx cv cF cfv cH
      cfv cB cH cfv vx cv cH cF ccom cfv vx cv cG cfv cB cC wcel vx cv cA wcel
      cH cC wfn vx cv cF cfv cH cfv cB cH cfv wceq cB cC wcel vx cA wral cB cC
      wcel vx cv cA wcel cH cC wfn w3a vx cv cF cfv cB cH cB cC wcel vx cv cA
      wcel vx cv cF cfv cB wceq cH cC wfn vx cv cA wcel cB cC wcel vx cv cF cfv
      cB wceq vx cv cA wcel cB cC wcel wa vx cv vx cv cA wcel vy cv cB wceq wa
      vx vy copab cfv cB vx cv cF cfv vx vy cA cB cC fvopab2 vx cv vx cv cA
      wcel vy cv cB wceq wa vx vy copab cF cF vx cv cA wcel vy cv cB wceq wa vx
      vy copab fnopabco2b.2 eqcomi fveq1i syl5eqr ancoms 3adant3 fveq2d
      3adant2r cH wfun cF cA wfn vx cv cA wcel vx cv cH cF ccom cfv vx cv cF
      cfv cH cfv wceq cB cC wcel vx cv cA wcel cB cC wcel vx cA wral wa cH cC
      wfn w3a cA vx cv cH cF fvco2 cH cC wfn cB cC wcel cH wfun vx cv cA wcel
      cB cC wcel vx cA wral wa cC cH fnfun 3ad2ant3 vx cv cA wcel cB cC wcel vx
      cA wral wa cB cC wcel cF cA wfn cH cC wfn cB cC wcel vx cA wral cF cA wfn
      vx cv cA wcel cB cC wcel vx cA wral cB cvv wcel vx cA wral cF cA wfn cB
      cC wcel cB cvv wcel vx cA cB cC elisset r19.20si vx vy cA cB cF
      fnopabco2b.2 fnopab2g sylib adantl 3ad2ant2 vx cv cA wcel cB cC wcel vx
      cA wral wa cB cC wcel vx cv cA wcel cH cC wfn vx cv cA wcel cB cC wcel vx
      cA wral pm3.26 3ad2ant2 syl3anc cB cC wcel vx cv cA wcel cB cC wcel vx cA
      wral wa cH cC wfn w3a vx cv vx cv cA wcel vy cv cB cH cfv wceq wa vx vy
      copab cfv cB cH cfv vx cv cG cfv cB cC wcel vx cv cA wcel cB cC wcel vx
      cA wral wa cH cC wfn w3a vx cv cA wcel cB cH cfv cvv wcel wa vx cv vx cv
      cA wcel vy cv cB cH cfv wceq wa vx vy copab cfv cB cH cfv wceq vx cv cA
      wcel cB cC wcel vx cA wral wa cB cC wcel vx cv cA wcel cB cH cfv cvv wcel
      wa cH cC wfn vx cv cA wcel cB cC wcel vx cA wral wa vx cv cA wcel cB cH
      cfv cvv wcel vx cv cA wcel cB cC wcel vx cA wral pm3.26 cB cH fvex jctir
      3ad2ant2 vx vy cA cB cH cfv cvv fvopab2 syl vx cv cG vx cv cA wcel vy cv
      cB cH cfv wceq wa vx vy copab fnopabco2b. fveq1i syl5eq 3eqtr4rd 3exp
      syl6com imp pm2.43i ex com3l imp r19.21ai cG cA wfn cH cF ccom cA wfn cG
      cH cF ccom wceq vx cv cG cfv vx cv cH cF ccom cfv wceq vx cA wral wb cB
      cC wcel vx cA wral cH cC wfn wa vx vt cA cG cH cF ccom vx vt cG vx cv cA
      wcel vy cv cB cH cfv wceq wa vx vy copab fnopabco2b. vx cv cA wcel vy cv
      cB cH cfv wceq wa vx vy vt hbopab1 hbxfr vx vt cH cF vt cv cH wcel vx
      ax-17 vx vt cF vx cv cA wcel vy cv cB wceq wa vx vy copab fnopabco2b.2 vx
      cv cA wcel vy cv cB wceq wa vx vy vt hbopab1 hbxfr hbco eqfnfvf2 vx vy cA
      cB cH cfv cG cB cH fvex fnopabco2b. fnopab2 cH cC wfn cF cA wfn cF crn cC
      wss cH cF ccom cA wfn cB cC wcel vx cA wral cH cC wfn wa cC cA cH cF fnco
      cB cC wcel vx cA wral cH cC wfn pm3.27 cB cC wcel vx cA wral cF cA wfn cH
      cC wfn cB cC wcel vx cA wral cB cvv wcel vx cA wral cF cA wfn cB cC wcel
      cB cvv wcel vx cA cB cC elisset r19.20si vx vy cA cB cF fnopabco2b.2
      fnopab2g sylib adantr cB cC wcel vx cA wral cH cC wfn wa cA cC cF wf cF
      crn cC wss cB cC wcel vx cA wral cA cC cF wf cH cC wfn cB cC wcel vx cA
      wral cA cC cF wf vx vy cA cC cB cF fnopabco2b.2 fopab2 biimpi adantr cA
      cC cF frn syl syl3anc sylancr mpbird $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    $d G a b m n x y $. $d G a f m n x y $. $d M a b m n x y $.
    $d M a f m n x y $. $d M a b x y z $.
    curgrpact.1 $e |- M e. A $.
    curgrpact.2 $e |- ran M =/= (/) $.
    $( The currying of a group action is a group homomorphism between the
       group ` G ` and the symetry group ` ( SymGrp `` ran M ) ` . $)
    curgrpact $p |- ( <. G , M >. e. GrpAct ->
      ( cur1 ` M ) e. ( G GrpHom ( SymGrp ` ran M ) ) ) $=
      cM cA wcel cG cM cop cga wcel cM ccur1 cfv cG cM crn csymgrp cfv cghom co
      wcel wi curgrpact.1 cM cA wcel cG cM cop cga wcel cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a cM ccur1 cfv cG cM crn csymgrp cfv cghom co
      wcel vf vx vy cA cG cgi cfv cG cM cG crn cM crn cG crn eqid cM crn eqid
      cG cgi cfv eqid isga2 cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      cM ccur1 cfv cG cM crn csymgrp cfv cghom co wcel cG crn cM crn cM crn vf
      cv wf1o vf cab cM ccur1 cfv wf vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv
      cfv cM crn csymgrp cfv co vx cv vy cv cG co cM ccur1 cfv cfv wceq vy cG
      crn wral vx cG crn wral wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a cG crn cM crn cM crn vf cv wf1o vf cab cM ccur1 cfv wf vx cv cM ccur1
      cfv cfv vy cv cM ccur1 cfv cfv cM crn csymgrp cfv co vx cv vy cv cG co cM
      ccur1 cfv cfv wceq vy cG crn wral vx cG crn wral cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a cM ccur1 cfv cG crn wfn va cv cM ccur1 cfv cfv
      cM crn cM crn vf cv wf1o vf cab wcel va cG crn wral wa cG crn cM crn cM
      crn vf cv wf1o vf cab cM ccur1 cfv wf cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a cM ccur1 cfv cG crn wfn va cv cM ccur1 cfv cfv cM crn cM crn
      vf cv wf1o vf cab wcel va cG crn wral cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a cM ccur1 cfv wfun cM ccur1 cfv cdm cG crn wceq wa cM ccur1
      cfv cG crn wfn cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf
      cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co
      cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cM ccur1
      cfv wfun cM ccur1 cfv cdm cG crn wceq cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a cG crn cvv wcel cM crn cvv wcel wa cM crn c0 wne cM cG crn
      cM crn cxp wfn wa wa cG crn cM crn cM crn vz cv wf vz cab cM ccur1 cfv wf
      cM ccur1 cfv wfun cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG crn
      cvv wcel cM crn cvv wcel cM crn c0 wne cM cG crn cM crn cxp wfn wa cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG crn cvv wcel cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral cG cgr rnexg
      3ad2ant1 cM crn cvv wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a cM cA wcel cM crn cvv wcel curgrpact.1 cM cA rnexg ax-mp a1i cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a cM cG crn cM crn cxp wfn cM crn
      c0 wne cG crn cM crn cxp cM crn cM wf cG cgr wcel cM cG crn cM crn cxp
      wfn cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral cG crn cM crn cxp cM crn cM ffn 3ad2ant2 curgrpact.2 jctil jca31 cG
      crn cM crn cvv cvv vz cM domrancur1c cG crn cM crn cM crn vz cv wf vz cab
      cM ccur1 cfv ffun 3syl cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      cG crn cM crn cM crn vz cv wf vz cab cM ccur1 cfv wf cM ccur1 cfv cdm cG
      crn wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG crn cvv wcel
      cM crn cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp wfn wa wa cG crn cM
      crn cM crn vz cv wf vz cab cM ccur1 cfv wf cG cgr wcel cG crn cM crn cxp
      cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf
      cM crn wral w3a cG crn cvv wcel cM crn cvv wcel cM crn c0 wne cM cG crn
      cM crn cxp wfn wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG crn cvv
      wcel cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx
      cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral cG cgr rnexg 3ad2ant1 cM crn cvv wcel cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a cM cA wcel cM crn cvv wcel curgrpact.1 cM cA rnexg
      ax-mp a1i cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cM cG crn cM crn
      cxp wfn cM crn c0 wne cG crn cM crn cxp cM crn cM wf cG cgr wcel cM cG
      crn cM crn cxp wfn cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral cG crn cM crn cxp cM crn cM ffn 3ad2ant2 curgrpact.2
      jctil jca31 cG crn cM crn cvv cvv vz cM domrancur1c syl cG crn cM crn cM
      crn vz cv wf vz cab cM ccur1 cfv fdm syl jca cM ccur1 cfv cG crn df-fn
      sylibr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cM ccur1
      cfv cfv cM crn cM crn vf cv wf1o vf cab wcel va cG crn cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a va cv cG crn wcel va cv cM ccur1 cfv cfv
      cM crn cM crn vf cv wf1o vf cab wcel cG cgr wcel cG crn cM crn cxp cM crn
      cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx
      cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a va cv cG crn wcel wa cM crn cM crn va cv cM ccur1 cfv cfv
      wf1o va cv cM ccur1 cfv cfv cM crn cM crn vf cv wf1o vf cab wcel cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa va cv cM
      ccur1 cfv cfv cM crn wfn va cv cM ccur1 cfv cfv crn cM crn wceq vx cv va
      cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1 cfv cfv cfv wceq vx vy weq
      wi vy cM crn wral vx cM crn wral w3a cM crn cM crn va cv cM ccur1 cfv cfv
      wf1o cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      va cv cM ccur1 cfv cfv cM crn wfn va cv cM ccur1 cfv cfv crn cM crn wceq
      vx cv va cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1 cfv cfv cfv wceq vx
      vy weq wi vy cM crn wral vx cM crn wral cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a va cv cG crn wcel wa cG crn cvv wcel cM crn cvv wcel wa cM
      crn c0 wne cM cG crn cM crn cxp wfn wa va cv cG crn wcel w3a cM crn cM
      crn va cv cM ccur1 cfv cfv wf va cv cM ccur1 cfv cfv cM crn wfn cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa cG crn cvv
      wcel cM crn cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp wfn wa va cv
      cG crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG crn cvv
      wcel cM crn cvv wcel wa va cv cG crn wcel cG cgr wcel cG crn cM crn cxp
      cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf
      cM crn wral w3a cG crn cvv wcel cM crn cvv wcel cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG crn cvv wcel cG cgi cfv vf cv cM co vf cv wceq vx cv
      vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral
      vx cG crn wral wa vf cM crn wral cG cgr rnexg 3ad2ant1 cM cA wcel cM crn
      cvv wcel curgrpact.1 cM cA rnexg ax-mp jctir adantr cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a va cv cG crn wcel wa cM cG crn cM crn cxp wfn
      cM crn c0 wne cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cM cG crn cM
      crn cxp wfn va cv cG crn wcel cG crn cM crn cxp cM crn cM wf cG cgr wcel
      cM cG crn cM crn cxp wfn cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral cG crn cM crn cxp cM crn cM ffn 3ad2ant2
      adantr curgrpact.2 jctil cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a va cv cG crn wcel pm3.27 3jca cG crn cM crn cvv cvv cM va cv valcurfn
      cM crn cM crn va cv cM ccur1 cfv cfv ffn 3syl cM cA wcel cG cM cop cga
      wcel va cv cG crn wcel cM crn c0 wne wa va cv cM ccur1 cfv cfv crn cM crn
      wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      va cv cA cG cM cG crn cM crn cG crn eqid cM crn eqid rngapm cM cA wcel cG
      cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      curgrpact.1 a1i cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf
      cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co
      cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG cM cop
      cga wcel va cv cG crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a cG cM cop cga wcel cM cA wcel cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral w3a cG cM cop cga wcel wb curgrpact.1 cM cA wcel cG cM cop cga wcel
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a vf vx vy cA cG cgi cfv
      cG cM cG crn cM crn cG crn eqid cM crn eqid cG cgi cfv eqid isga2 bicomd
      ax-mp biimpi adantr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv
      cG crn wcel wa va cv cG crn wcel cM crn c0 wne cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a va cv cG crn wcel pm3.27 curgrpact.2 jctir syl3anc
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx
      cv va cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1 cfv cfv cfv wceq vx vy
      weq wi vy cM crn wral vx cM crn cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral w3a va cv cG crn wcel vx cG cgr wcel cG crn cM crn cxp cM crn cM wf
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      vx cG cgr wcel vx ax-17 cG crn cM crn cxp cM crn cM wf vx ax-17 cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vx vf cM crn vf cv
      cM crn wcel vx ax-17 cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral vx cG cgi cfv vf cv cM co vf cv wceq vx ax-17 vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      hbra1 hban hbral hb3an va cv cG crn wcel vx ax-17 hban cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx cv cM crn wcel vx
      cv va cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1 cfv cfv cfv wceq vx vy
      weq wi vy cM crn wral cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      va cv cG crn wcel wa vx cv cM crn wcel wa vx cv va cv cM ccur1 cfv cfv
      cfv vy cv va cv cM ccur1 cfv cfv cfv wceq vx vy weq wi vy cM crn cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx cv cM
      crn wcel vy cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn
      wcel vy cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral vy cG cgr wcel vy
      ax-17 cG crn cM crn cxp cM crn cM wf vy ax-17 cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vy vf cM crn vf cv cM crn wcel vy ax-17
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral vy cG cgi cfv vf
      cv cM co vf cv wceq vy ax-17 vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vy vx cG crn vx cv cG crn wcel vy
      ax-17 vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn hbra1 hbral hban hbral hb3an va cv cG crn wcel vy ax-17 hban vx cv
      cM crn wcel vy ax-17 hban cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a va cv cG crn wcel wa vx cv cM crn wcel wa vy cv cM crn wcel vx cv va
      cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1 cfv cfv cfv wceq vx vy weq
      wi cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      vx cv cM crn wcel wa vy cv cM crn wcel wa vx cv va cv cM ccur1 cfv cfv
      cfv va cv vx cv cM co wceq vy cv va cv cM ccur1 cfv cfv cfv va cv vy cv
      cM co wceq wa vx cv va cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1 cfv
      cfv cfv wceq vx vy weq wi cG crn cvv wcel cM crn cvv wcel wa cM crn c0
      wne cM cG crn cM crn cxp wfn wa va cv cG crn wcel vx cv cM crn wcel wa
      w3a cG crn cvv wcel cM crn cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp
      wfn wa va cv cG crn wcel vy cv cM crn wcel wa w3a vx cv va cv cM ccur1
      cfv cfv cfv va cv vx cv cM co wceq vy cv va cv cM ccur1 cfv cfv cfv va cv
      vy cv cM co wceq wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv
      cG crn wcel wa vx cv cM crn wcel wa vy cv cM crn wcel wa cG crn cvv wcel
      cM crn cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp wfn wa va cv cG crn
      wcel vx cv cM crn wcel wa w3a vx cv va cv cM ccur1 cfv cfv cfv va cv vx
      cv cM co wceq cG crn cvv wcel cM crn cvv wcel wa cM crn c0 wne cM cG crn
      cM crn cxp wfn wa va cv cG crn wcel vy cv cM crn wcel wa w3a vy cv va cv
      cM ccur1 cfv cfv cfv va cv vy cv cM co wceq cG crn cM crn cvv cvv vx cv
      cM va cv valvalcurfn cG crn cM crn cvv cvv vy cv cM va cv valvalcurfn
      anim12i cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn
      wcel wa vx cv cM crn wcel wa vy cv cM crn wcel wa cG crn cvv wcel cM crn
      cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp wfn wa va cv cG crn wcel
      vx cv cM crn wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      va cv cG crn wcel wa cG crn cvv wcel cM crn cvv wcel wa vx cv cM crn wcel
      vy cv cM crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG crn
      cvv wcel cM crn cvv wcel wa va cv cG crn wcel cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a cG crn cvv wcel cM crn cvv wcel cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG crn cvv wcel cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral cG cgr rnexg 3ad2ant1 cM cA
      wcel cM crn cvv wcel curgrpact.1 cM cA rnexg ax-mp jctir adantr ad2antrr
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa cM
      crn c0 wne cM cG crn cM crn cxp wfn wa vx cv cM crn wcel vy cv cM crn
      wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      cM cG crn cM crn cxp wfn cM crn c0 wne cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a cM cG crn cM crn cxp wfn va cv cG crn wcel cG crn cM crn cxp
      cM crn cM wf cG cgr wcel cM cG crn cM crn cxp wfn cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral cG crn cM crn cxp cM
      crn cM ffn 3ad2ant2 adantr curgrpact.2 jctil ad2antrr cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx cv cM crn wcel wa
      vy cv cM crn wcel wa va cv cG crn wcel vx cv cM crn wcel cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a va cv cG crn wcel vx cv cM crn wcel vy cv
      cM crn wcel simpllr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv
      cG crn wcel wa vx cv cM crn wcel vy cv cM crn wcel simplr jca 3jca cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx cv cM
      crn wcel wa vy cv cM crn wcel wa cG crn cvv wcel cM crn cvv wcel wa cM
      crn c0 wne cM cG crn cM crn cxp wfn wa va cv cG crn wcel vy cv cM crn
      wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn
      wcel wa vx cv cM crn wcel wa cG crn cvv wcel cM crn cvv wcel wa vy cv cM
      crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn
      wcel wa vx cv cM crn wcel wa cG crn cvv wcel cM crn cvv wcel cG cgr wcel
      cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy
      cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx
      cG crn wral wa vf cM crn wral w3a cG crn cvv wcel va cv cG crn wcel vx cv
      cM crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG crn cvv wcel cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral cG
      cgr rnexg 3ad2ant1 ad2antrr cM cA wcel cM crn cvv wcel curgrpact.1 cM cA
      rnexg ax-mp jctir adantr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a va cv cG crn wcel wa vx cv cM crn wcel wa vy cv cM crn wcel wa cM cG
      crn cM crn cxp wfn cM crn c0 wne cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral w3a va cv cG crn wcel wa cM cG crn cM crn cxp wfn vx cv cM crn wcel
      vy cv cM crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cM cG
      crn cM crn cxp wfn va cv cG crn wcel cG crn cM crn cxp cM crn cM wf cG
      cgr wcel cM cG crn cM crn cxp wfn cG cgi cfv vf cv cM co vf cv wceq vx cv
      vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral
      vx cG crn wral wa vf cM crn wral cG crn cM crn cxp cM crn cM ffn 3ad2ant2
      adantr ad2antrr curgrpact.2 jctil cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral w3a va cv cG crn wcel wa vx cv cM crn wcel wa vy cv cM crn wcel wa
      va cv cG crn wcel vy cv cM crn wcel cG cgr wcel cG crn cM crn cxp cM crn
      cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx
      cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a va cv cG crn wcel vx cv cM crn wcel vy cv cM crn wcel
      simpllr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn
      wcel wa vx cv cM crn wcel wa vy cv cM crn wcel pm3.27 jca 3jca sylanc vx
      cv va cv cM ccur1 cfv cfv cfv va cv vx cv cM co wceq vy cv va cv cM ccur1
      cfv cfv cfv va cv vy cv cM co wceq wa vx cv va cv cM ccur1 cfv cfv cfv vy
      cv va cv cM ccur1 cfv cfv cfv wceq va cv vx cv cM co va cv vy cv cM co
      wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      vx cv cM crn wcel wa vy cv cM crn wcel wa vx vy weq vx cv va cv cM ccur1
      cfv cfv cfv va cv vx cv cM co wceq vy cv va cv cM ccur1 cfv cfv cfv va cv
      vy cv cM co wceq wa vx cv va cv cM ccur1 cfv cfv cfv vy cv va cv cM ccur1
      cfv cfv cfv wceq va cv vx cv cM co va cv vy cv cM co wceq vx cv va cv cM
      ccur1 cfv cfv cfv va cv vx cv cM co vy cv va cv cM ccur1 cfv cfv cfv va
      cv vy cv cM co eqeq12 biimpd cM cvv wcel cG cM cop cga wcel va cv cG crn
      wcel vx cv cM crn wcel vy cv cM crn wcel w3a va cv vx cv cM co va cv vy
      cv cM co wceq vx vy weq wi cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a va cv cG crn wcel wa vx cv cM crn wcel wa vy cv cM crn wcel wa vx cv
      vy cv va cv cG cM cvv cG crn cM crn cG crn eqid cM crn eqid gaplc cM cvv
      wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa
      vx cv cM crn wcel wa vy cv cM crn wcel wa cM cA curgrpact.1 elisseti a1i
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa cG
      cM cop cga wcel vx cv cM crn wcel vy cv cM crn wcel cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a cG cM cop cga wcel va cv cG crn wcel cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a cG cM cop cga wcel cM cA wcel
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a cG cM cop cga wcel wb
      curgrpact.1 cM cA wcel cG cM cop cga wcel cG cgr wcel cG crn cM crn cxp
      cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf
      cM crn wral w3a vf vx vy cA cG cgi cfv cG cM cG crn cM crn cG crn eqid cM
      crn eqid cG cgi cfv eqid isga2 bicomd ax-mp biimpi adantr ad2antrr cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx cv cM
      crn wcel wa vy cv cM crn wcel wa va cv cG crn wcel vx cv cM crn wcel vy
      cv cM crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf
      cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co
      cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a va cv cG
      crn wcel vx cv cM crn wcel vy cv cM crn wcel simpllr cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a va cv cG crn wcel wa vx cv cM crn wcel vy
      cv cM crn wcel simplr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      va cv cG crn wcel wa vx cv cM crn wcel wa vy cv cM crn wcel pm3.27 3jca
      syl3anc syl9r mpd ex r19.21ai ex r19.21ai 3jca vx vy cM crn cM crn va cv
      cM ccur1 cfv cfv dff1o6 sylibr cM crn cM crn vf cv wf1o cM crn cM crn va
      cv cM ccur1 cfv cfv wf1o vf va cv cM ccur1 cfv cfv va cv cM ccur1 cfv
      fvex cM crn cM crn vf cv va cv cM ccur1 cfv cfv f1oeq1 elab sylibr ex
      r19.21aiv jca va cG crn cM crn cM crn vf cv wf1o vf cab cM ccur1 cfv
      ffnfv sylibr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cM
      ccur1 cfv cfv vy cv cM ccur1 cfv cfv cM crn csymgrp cfv co vx cv vy cv cG
      co cM ccur1 cfv cfv wceq vy cG crn wral vx cG crn cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral vx cG cgr wcel vx ax-17 cG crn cM crn cxp cM crn
      cM wf vx ax-17 cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv
      cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa
      vx vf cM crn vf cv cM crn wcel vx ax-17 cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral vx cG cgi cfv vf cv cM co vf cv wceq vx ax-17 vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn hbra1 hban hbral hb3an cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv
      cfv cM crn csymgrp cfv co vx cv vy cv cG co cM ccur1 cfv cfv wceq vy cG
      crn wral cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel wa vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv cfv cM crn csymgrp cfv
      co vx cv vy cv cG co cM ccur1 cfv cfv wceq vy cG crn cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral vy cG cgr wcel vy ax-17 cG crn cM crn cxp cM crn
      cM wf vy ax-17 cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv
      cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa
      vy vf cM crn vf cv cM crn wcel vy ax-17 cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral vy cG cgi cfv vf cv cM co vf cv wceq vy ax-17 vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vy vx cG crn vx cv cG crn wcel vy ax-17 vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn hbra1 hbral hban hbral
      hb3an vx cv cG crn wcel vy ax-17 hban cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vy cv cG crn wcel vx cv cM ccur1 cfv cfv
      vy cv cM ccur1 cfv cfv cM crn csymgrp cfv co vx cv vy cv cG co cM ccur1
      cfv cfv wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel vy cv cG crn wcel wa vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv cfv
      cM crn csymgrp cfv co vx cv vy cv cG co cM ccur1 cfv cfv wceq cG cgr wcel
      cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy
      cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx
      cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa
      wa vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq
      wa va vb copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv
      vm cv cM co wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv
      vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab
      wceq w3a vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv cfv cM crn csymgrp cfv
      co vx cv vy cv cG co cM ccur1 cfv cfv wceq cG cgr wcel cG crn cM crn cxp
      cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf
      cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vx cv cM ccur1
      cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab
      wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM co
      wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM crn
      wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq cG crn
      cvv wcel cM crn cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp wfn wa vx
      cv cG crn wcel vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv
      cM co wceq wa va vb copab wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a vx cv cG crn wcel vy cv cG crn wcel wa wa va vb cG crn cM crn cvv cvv
      cM vx cv valcurfn2 cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG crn
      cvv wcel cM crn cvv wcel wa vx cv cG crn wcel vy cv cG crn wcel wa cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a cG crn cvv wcel cM crn cvv wcel
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG crn cvv wcel cG cgi cfv vf
      cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co
      cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral cG cgr rnexg
      3ad2ant1 cM cA wcel cM crn cvv wcel curgrpact.1 cM cA rnexg ax-mp jctir
      adantr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cM crn c0 wne cM
      cG crn cM crn cxp wfn wa vx cv cG crn wcel vy cv cG crn wcel wa cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a cM cG crn cM crn cxp wfn cM crn
      c0 wne cG crn cM crn cxp cM crn cM wf cG cgr wcel cM cG crn cM crn cxp
      wfn cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral cG crn cM crn cxp cM crn cM ffn 3ad2ant2 curgrpact.2 jctil adantr cG
      cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG
      crn wcel simprl syl3anc cG crn cvv wcel cM crn cvv wcel wa cM crn c0 wne
      cM cG crn cM crn cxp wfn wa vy cv cG crn wcel vy cv cM ccur1 cfv cfv vm
      cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn
      wcel wa wa vm vn cG crn cM crn cvv cvv cM vy cv valcurfn2 cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a cG crn cvv wcel cM crn cvv wcel wa vx cv
      cG crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral w3a cG crn cvv wcel cM crn cvv wcel cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG crn cvv wcel cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral cG cgr rnexg 3ad2ant1 cM cA wcel cM crn cvv
      wcel curgrpact.1 cM cA rnexg ax-mp jctir adantr cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a cM crn c0 wne cM cG crn cM crn cxp wfn wa vx cv cG
      crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM wf
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a cM cG crn cM crn cxp wfn cM crn c0 wne cG crn cM crn cxp cM crn cM wf
      cG cgr wcel cM cG crn cM crn cxp wfn cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral cG crn cM crn cxp cM crn cM ffn
      3ad2ant2 curgrpact.2 jctil adantr cG cgr wcel cG crn cM crn cxp cM crn cM
      wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv
      vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn
      wral w3a vx cv cG crn wcel vy cv cG crn wcel simprr syl3anc cG crn cvv
      wcel cM crn cvv wcel wa cM crn c0 wne cM cG crn cM crn cxp wfn wa vx cv
      vy cv cG co cG crn wcel vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM crn
      wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn
      wcel wa wa vm vn cG crn cM crn cvv cvv cM vx cv vy cv cG co valcurfn2 cG
      cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral w3a cG crn cvv wcel cM crn cvv
      wcel wa vx cv cG crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a cG crn cvv wcel cM crn cvv wcel cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG crn cvv wcel cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral cG cgr rnexg 3ad2ant1 cM cA
      wcel cM crn cvv wcel curgrpact.1 cM cA rnexg ax-mp jctir adantr cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a cM crn c0 wne cM cG crn cM crn
      cxp wfn wa vx cv cG crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a cM cG crn cM crn cxp wfn cM crn c0 wne cG crn
      cM crn cxp cM crn cM wf cG cgr wcel cM cG crn cM crn cxp wfn cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral cG crn cM
      crn cxp cM crn cM ffn 3ad2ant2 curgrpact.2 jctil adantr cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa vx
      cv vy cv cG co cG crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf vx
      cv cG crn wcel vy cv cG crn wcel wa vx cv vy cv cG co cG crn wcel wi cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral cG
      cgr wcel vx cv cG crn wcel vy cv cG crn wcel vx cv vy cv cG co cG crn
      wcel vx cv vy cv cG cG crn cG crn eqid grpcl 3expib 3ad2ant1 imp syl3anc
      3jca cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy
      cv cG crn wcel wa wa vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn
      wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq vx cv vy cv cG co
      cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co
      wceq wa vm vn copab wceq w3a wa vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv
      cfv cM crn csymgrp cfv co va cv cM crn wcel vb cv vx cv va cv cM co wceq
      wa va vb copab vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn
      copab cM crn csymgrp cfv co vm cv cM crn wcel vn cv vx cv vy cv cG co vm
      cv cM co wceq wa vm vn copab vx cv vy cv cG co cM ccur1 cfv cfv vx cv cM
      ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb
      copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM
      co wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM
      crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq w3a
      vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv cfv cM crn csymgrp cfv co va cv
      cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab vm cv cM crn wcel
      vn cv vy cv vm cv cM co wceq wa vm vn copab cM crn csymgrp cfv co wceq cG
      cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG
      crn wcel wa wa vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv
      cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel
      vn cv vy cv vm cv cM co wceq wa vm vn copab wceq vx cv cM ccur1 cfv cfv
      vy cv cM ccur1 cfv cfv cM crn csymgrp cfv co va cv cM crn wcel vb cv vx
      cv va cv cM co wceq wa va vb copab vm cv cM crn wcel vn cv vy cv vm cv cM
      co wceq wa vm vn copab cM crn csymgrp cfv co wceq vx cv vy cv cG co cM
      ccur1 cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq
      wa vm vn copab wceq vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab vy cv cM ccur1 cfv cfv vm cv cM crn wcel
      vn cv vy cv vm cv cM co wceq wa vm vn copab cM crn csymgrp cfv opreq12
      3adant3 adantl cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf
      cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co
      cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG
      crn wcel vy cv cG crn wcel wa wa vx cv cM ccur1 cfv cfv va cv cM crn wcel
      vb cv vx cv va cv cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv
      vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq vx cv
      vy cv cG co cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm
      cv cM co wceq wa vm vn copab wceq w3a wa va cv cM crn wcel vb cv vx cv va
      cv cM co wceq wa va vb copab vm cv cM crn wcel vn cv vy cv vm cv cM co
      wceq wa vm vn copab cM crn csymgrp cfv co va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab vm cv cM crn wcel vn cv vy cv vm cv cM co
      wceq wa vm vn copab ccom vm cv cM crn wcel vn cv vy cv vm cv cM co va cv
      cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab cfv wceq wa vm vn
      copab vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn
      copab cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel vy cv cG crn wcel wa wa vx cv cM ccur1 cfv cfv va cv cM crn wcel vb
      cv vx cv va cv cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv vm
      cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq vx cv vy
      cv cG co cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv
      cM co wceq wa vm vn copab wceq w3a wa va cv cM crn wcel vb cv vx cv va cv
      cM co wceq wa va vb copab cM crn cM crn vz cv wf1o vz cab wcel vm cv cM
      crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab cM crn cM crn vz cv
      wf1o vz cab wcel wa va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va
      vb copab vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab cM
      crn csymgrp cfv co va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va
      vb copab vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab
      ccom wceq vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM
      co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn
      cv vy cv vm cv cM co wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1
      cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm
      vn copab wceq w3a cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv
      cG crn wcel vy cv cG crn wcel wa wa va cv cM crn wcel vb cv vx cv va cv
      cM co wceq wa va vb copab cM crn cM crn vz cv wf1o vz cab wcel vm cv cM
      crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab cM crn cM crn vz cv
      wf1o vz cab wcel wa vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn
      wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa
      va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab cM crn cM
      crn vz cv wf1o vz cab wcel vm cv cM crn wcel vn cv vy cv vm cv cM co wceq
      wa vm vn copab cM crn cM crn vz cv wf1o vz cab wcel wa wi vx cv vy cv cG
      co cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co
      wceq wa vm vn copab wceq vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv
      vx cv va cv cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv cfv vm cv
      cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq wa cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn
      wcel wa wa va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab
      cM crn cM crn vz cv wf1o vz cab wcel vm cv cM crn wcel vn cv vy cv vm cv
      cM co wceq wa vm vn copab cM crn cM crn vz cv wf1o vz cab wcel wa vx cv
      cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb
      copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM
      co wceq wa vm vn copab wceq wa cG cgr wcel cG crn cM crn cxp cM crn cM wf
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a vx cv cG crn wcel vy cv cG crn wcel wa wa wa va cv cM crn wcel vb cv
      vx cv va cv cM co wceq wa va vb copab cM crn cM crn vz cv wf1o vz cab
      wcel vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab cM crn
      cM crn vz cv wf1o vz cab wcel vx cv cM ccur1 cfv cfv va cv cM crn wcel vb
      cv vx cv va cv cM co wceq wa va vb copab wceq cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa va cv cM
      crn wcel vb cv vx cv va cv cM co wceq wa va vb copab cM crn cM crn vz cv
      wf1o vz cab wcel vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm
      cv cM co wceq wa vm vn copab wceq vx cv cM ccur1 cfv cfv va cv cM crn
      wcel vb cv vx cv va cv cM co wceq wa va vb copab wceq cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa
      wa vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq
      wa va vb copab cM crn cM crn vz cv wf1o vz cab vx cv cM ccur1 cfv cfv va
      cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab wceq cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn
      wcel wa wa pm3.26 cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv
      cG crn wcel vy cv cG crn wcel wa wa vx cv cM ccur1 cfv cfv cM crn cM crn
      vz cv wf1o vz cab wcel vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv vx
      cv va cv cM co wceq wa va vb copab wceq cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa cM crn cM crn vx
      cv cM ccur1 cfv cfv wf1o vx cv cM ccur1 cfv cfv cM crn cM crn vz cv wf1o
      vz cab wcel cM cA wcel cG cM cop cga wcel vx cv cG crn wcel cM crn c0 wne
      wa cM crn cM crn vx cv cM ccur1 cfv cfv wf1o cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vx cv cA
      cG cM cG crn cM crn cG crn eqid cM crn eqid gapm2 cM cA wcel cG cgr wcel
      cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy
      cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx
      cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa
      wa curgrpact.1 a1i cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG cM
      cop cga wcel vx cv cG crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a cG cM cop cga wcel cM cA wcel cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a cG cM cop cga wcel wb curgrpact.1 cM cA
      wcel cG cM cop cga wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      vf vx vy cA cG cgi cfv cG cM cG crn cM crn cG crn eqid cM crn eqid cG cgi
      cfv eqid isga2 bicomd ax-mp biimpi adantr cG cgr wcel cG crn cM crn cxp
      cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf
      cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vx cv cG crn
      wcel cM crn c0 wne cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv
      cG crn wcel vy cv cG crn wcel simprl curgrpact.2 jctir syl3anc vx cv cM
      ccur1 cfv cfv cvv wcel vx cv cM ccur1 cfv cfv cM crn cM crn vz cv wf1o vz
      cab wcel cM crn cM crn vx cv cM ccur1 cfv cfv wf1o wb vx cv cM ccur1 cfv
      fvex cM crn cM crn vz cv wf1o cM crn cM crn vx cv cM ccur1 cfv cfv wf1o
      vz vx cv cM ccur1 cfv cfv cvv cM crn cM crn vz cv vx cv cM ccur1 cfv cfv
      f1oeq1 elabg ax-mp sylibr adantl eqeltrrd adantlr vy cv cM ccur1 cfv cfv
      vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn
      wcel wa wa vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab
      cM crn cM crn vz cv wf1o vz cab wcel vx cv cM ccur1 cfv cfv va cv cM crn
      wcel vb cv vx cv va cv cM co wceq wa va vb copab wceq vy cv cM ccur1 cfv
      cfv vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq cG
      cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq
      vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG
      crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG
      crn wcel wa wa wa vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm
      cv cM co wceq wa vm vn copab cM crn cM crn vz cv wf1o vz cab vy cv cM
      ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn
      copab wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel vy cv cG crn wcel wa wa pm3.26 cG cgr wcel cG crn cM crn cxp cM crn
      cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx
      cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vy cv cM ccur1 cfv
      cfv cM crn cM crn vz cv wf1o vz cab wcel vy cv cM ccur1 cfv cfv vm cv cM
      crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab wceq cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa
      cM crn cM crn vy cv cM ccur1 cfv cfv wf1o vy cv cM ccur1 cfv cfv cM crn
      cM crn vz cv wf1o vz cab wcel cM cA wcel cG cM cop cga wcel vy cv cG crn
      wcel cM crn c0 wne wa cM crn cM crn vy cv cM ccur1 cfv cfv wf1o cG cgr
      wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx
      cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn
      wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn
      wcel wa wa vy cv cA cG cM cG crn cM crn cG crn eqid cM crn eqid gapm2 cM
      cA wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel vy cv cG crn wcel wa wa curgrpact.1 a1i cG cgr wcel cG crn cM crn
      cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral w3a cG cM cop cga wcel vx cv cG crn wcel vy cv cG crn
      wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co
      vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG cM cop cga
      wcel cM cA wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf
      cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co
      cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a cG cM cop
      cga wcel wb curgrpact.1 cM cA wcel cG cM cop cga wcel cG cgr wcel cG crn
      cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG
      co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vf vx vy cA cG cgi cfv cG cM cG crn cM crn
      cG crn eqid cM crn eqid cG cgi cfv eqid isga2 bicomd ax-mp biimpi adantr
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv
      cG crn wcel wa wa vy cv cG crn wcel cM crn c0 wne cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel simprr
      curgrpact.2 jctir syl3anc vy cv cM ccur1 cfv cfv cvv wcel vy cv cM ccur1
      cfv cfv cM crn cM crn vz cv wf1o vz cab wcel cM crn cM crn vy cv cM ccur1
      cfv cfv wf1o wb vy cv cM ccur1 cfv fvex cM crn cM crn vz cv wf1o cM crn
      cM crn vy cv cM ccur1 cfv cfv wf1o vz vy cv cM ccur1 cfv cfv cvv cM crn
      cM crn vz cv vy cv cM ccur1 cfv cfv f1oeq1 elabg ax-mp sylibr adantl
      eqeltrrd adantll jca ex 3adant3 impcom vz cM crn cM crn cM crn vz cv wf1o
      vz cab va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab vm
      cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab cM cA wcel cM
      crn cvv wcel curgrpact.1 cM cA rnexg ax-mp cM crn cM crn vz cv wf1o vz
      cab eqid symgoprv syl vy cv vm cv cM co cM crn wcel vm cM crn wral va cv
      cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab cM crn wfn va cv
      cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab vm cv cM crn wcel
      vn cv vy cv vm cv cM co wceq wa vm vn copab ccom vm cv cM crn wcel vn cv
      vy cv vm cv cM co va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb
      copab cfv wceq wa vm vn copab wceq cG cgr wcel cG crn cM crn cxp cM crn
      cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx
      cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vx cv cM ccur1 cfv
      cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab wceq vy
      cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm
      vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM crn wcel vn cv
      vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq w3a wa vy cv vm cv
      cM co cM crn wcel vm cM crn wral va cv cM crn wcel vb cv vx cv va cv cM
      co wceq wa va vb copab cM crn wfn wa vm cv cM crn wcel vn cv vy cv vm cv
      cM co va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab cfv
      wceq wa vm vn copab va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va
      vb copab vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab
      ccom vm vn cM crn vy cv vm cv cM co cM crn vm cv cM crn wcel vn cv vy cv
      vm cv cM co wceq wa vm vn copab vm cv cM crn wcel vn cv vy cv vm cv cM co
      va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab cfv wceq wa
      vm vn copab va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab
      vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn copab eqid vm cv
      cM crn wcel vn cv vy cv vm cv cM co va cv cM crn wcel vb cv vx cv va cv
      cM co wceq wa va vb copab cfv wceq wa vm vn copab eqid fnopabco2b eqcomd
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv
      cG crn wcel wa wa vy cv vm cv cM co cM crn wcel vm cM crn wral vx cv cM
      ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb
      copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM
      co wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM
      crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq w3a
      vx cv cG crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vy cv vm cv cM co cM crn wcel vm cM crn wral vx cv cG crn
      wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a wa vy cv vm cv cM co cM crn wcel vm cM crn vx cv cG crn wcel vy cv cG
      crn wcel wa cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vm cv cM crn
      wcel vy cv vm cv cM co cM crn wcel wi vy cv cG crn wcel cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vm cv cM crn wcel vy cv vm cv cM co cM crn
      wcel wi wi vx cv cG crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a vy cv cG crn wcel vm cv cM crn wcel vy cv vm cv cM co cM crn wcel wi
      cG crn cM crn cxp cM crn cM wf cG cgr wcel vy cv cG crn wcel vm cv cM crn
      wcel vy cv vm cv cM co cM crn wcel wi wi cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral cG crn cM crn cxp cM crn cM
      wf vy cv cG crn wcel vm cv cM crn wcel vy cv vm cv cM co cM crn wcel vy
      cv vm cv cM crn cG crn cM crn cM foprrn 3exp 3ad2ant2 com12 adantl imp
      r19.21aiv ancoms adantr cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi
      cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a
      vx cv cG crn wcel vy cv cG crn wcel wa wa va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab cM crn wfn vx cv cM ccur1 cfv cfv va cv
      cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab wceq vy cv cM
      ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn
      copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx
      cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq w3a cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa
      vx cv va cv cM co cvv wcel va cM crn wral va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab cM crn wfn vx cv va cv cM co cvv wcel va
      cM crn wral cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel vy cv cG crn wcel wa wa vx cv va cv cM co cvv wcel va cM crn vx cv
      va cv cM co cvv wcel va cv cM crn wcel vx cv va cv cM oprex a1i rgen a1i
      va vb cM crn vx cv va cv cM co va cv cM crn wcel vb cv vx cv va cv cM co
      wceq wa va vb copab va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va
      vb copab eqid fnopab2g sylib adantr sylanc cG cgr wcel cG crn cM crn cxp
      cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM
      co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf
      cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vm cv cM crn
      wcel vn cv vy cv vm cv cM co va cv cM crn wcel vb cv vx cv va cv cM co
      wceq wa va vb copab cfv wceq wa vm vn copab vm cv cM crn wcel vn cv vx cv
      vy cv cG co vm cv cM co wceq wa vm vn copab wceq vx cv cM ccur1 cfv cfv
      va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb copab wceq vy cv
      cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM co wceq wa vm vn
      copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx
      cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq w3a cG cgr wcel cG
      crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv
      cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa
      vm cv cM crn wcel vn cv vy cv vm cv cM co va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab cfv wceq wa vm cv cM crn wcel vn cv vx cv
      vy cv cG co vm cv cM co wceq wa vm vn cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vm cv cM crn wcel
      vn cv vy cv vm cv cM co va cv cM crn wcel vb cv vx cv va cv cM co wceq wa
      va vb copab cfv wceq vn cv vx cv vy cv cG co vm cv cM co wceq cG cgr wcel
      cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy
      cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx
      cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa
      wa vm cv cM crn wcel wa vy cv vm cv cM co va cv cM crn wcel vb cv vx cv
      va cv cM co wceq wa va vb copab cfv vx cv vy cv cG co vm cv cM co vn cv
      cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn wcel vy cv
      cG crn wcel wa wa vm cv cM crn wcel wa vy cv vm cv cM co va cv cM crn
      wcel vb cv vx cv va cv cM co wceq wa va vb copab cfv vx cv vy cv vm cv cM
      co cM co vx cv vy cv cG co vm cv cM co vy cv vm cv cM co cM crn wcel vx
      cv vy cv vm cv cM co cM co cvv wcel vy cv vm cv cM co va cv cM crn wcel
      vb cv vx cv va cv cM co wceq wa va vb copab cfv vx cv vy cv vm cv cM co
      cM co wceq cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv cG crn
      wcel vy cv cG crn wcel wa wa vm cv cM crn wcel wa va vb vy cv vm cv cM co
      vx cv va cv cM co vx cv vy cv vm cv cM co cM co cM crn cvv va cv cM crn
      wcel vb cv vx cv va cv cM co wceq wa va vb copab va cv vy cv vm cv cM co
      vx cv cM opreq2 va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb
      copab eqid fvopab4g cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv
      cG crn wcel vy cv cG crn wcel wa wa vm cv cM crn wcel vy cv vm cv cM co
      cM crn wcel vx cv cG crn wcel vy cv cG crn wcel wa cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral w3a vm cv cM crn wcel vy cv vm cv cM co cM crn
      wcel wi vy cv cG crn wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG
      cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv
      vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      w3a vm cv cM crn wcel vy cv vm cv cM co cM crn wcel wi wi vx cv cG crn
      wcel cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf
      cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vy cv cG crn wcel vm
      cv cM crn wcel vy cv vm cv cM co cM crn wcel wi cG crn cM crn cxp cM crn
      cM wf cG cgr wcel vy cv cG crn wcel vm cv cM crn wcel vy cv vm cv cM co
      cM crn wcel wi wi cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf
      cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral
      wa vf cM crn wral cG crn cM crn cxp cM crn cM wf vy cv cG crn wcel vm cv
      cM crn wcel vy cv vm cv cM co cM crn wcel vy cv vm cv cM crn cG crn cM
      crn cM foprrn 3exp 3ad2ant2 com12 adantl impcom imp vx cv vy cv vm cv cM
      co cM oprex sylancl cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv
      vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM
      co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx cv
      cG crn wcel vy cv cG crn wcel wa vm cv cM crn wcel vx cv vy cv vm cv cM
      co cM co vx cv vy cv cG co vm cv cM co wceq cG cgi cfv vf cv cM co vf cv
      wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf cM crn wral cG cgr wcel vx cv cG crn
      wcel vy cv cG crn wcel wa vm cv cM crn wcel vx cv vy cv vm cv cM co cM co
      vx cv vy cv cG co vm cv cM co wceq wi wi cG crn cM crn cxp cM crn cM wf
      cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy
      cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM crn wral
      cG cgi cfv vm cv cM co vm cv wceq vx cv vy cv cG co vm cv cM co vx cv vy
      cv vm cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vm cM crn wral
      vx cv cG crn wcel vy cv cG crn wcel wa vm cv cM crn wcel vx cv vy cv vm
      cv cM co cM co vx cv vy cv cG co vm cv cM co wceq wi wi cG cgi cfv vf cv
      cM co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM
      co wceq vy cG crn wral vx cG crn wral wa cG cgi cfv vm cv cM co vm cv
      wceq vx cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vf vm cM crn vf vm weq cG cgi cfv vf cv cM
      co vf cv wceq cG cgi cfv vm cv cM co vm cv wceq vx cv vy cv cG co vf cv
      cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral vx
      cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq vy cG crn
      wral vx cG crn wral vf vm weq cG cgi cfv vf cv cM co cG cgi cfv vm cv cM
      co vf cv vm cv vf cv vm cv cG cgi cfv cM opreq2 vf vm weq id eqeq12d vf
      vm weq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co wceq
      vy cG crn wral vx cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM
      co wceq vy cG crn wral vx cG crn vf vm weq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vx cv vy cv cG co vm cv cM co vx cv vy
      cv vm cv cM co cM co wceq vy cG crn vf vm weq vx cv vy cv cG co vf cv cM
      co vx cv vy cv cG co vm cv cM co vx cv vy cv vf cv cM co cM co vx cv vy
      cv vm cv cM co cM co vf cv vm cv vx cv vy cv cG co cM opreq2 vf vm weq vy
      cv vf cv cM co vy cv vm cv cM co vx cv cM vf cv vm cv vy cv cM opreq2
      opreq2d eqeq12d ralbidv ralbidv anbi12d cbvralv cG cgi cfv vm cv cM co vm
      cv wceq vx cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq
      vy cG crn wral vx cG crn wral wa vm cM crn wral vm cv cM crn wcel vx cv
      cG crn wcel vy cv cG crn wcel wa vx cv vy cv vm cv cM co cM co vx cv vy
      cv cG co vm cv cM co wceq cG cgi cfv vm cv cM co vm cv wceq vx cv vy cv
      cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq vy cG crn wral vx cG
      crn wral wa vm cM crn wral vm cv cM crn wcel cG cgi cfv vm cv cM co vm cv
      wceq vx cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq vy
      cG crn wral vx cG crn wral wa vx cv cG crn wcel vy cv cG crn wcel wa vx
      cv vy cv vm cv cM co cM co vx cv vy cv cG co vm cv cM co wceq wi cG cgi
      cfv vm cv cM co vm cv wceq vx cv vy cv cG co vm cv cM co vx cv vy cv vm
      cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vm cM crn ra4 vx cv
      vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq vy cG crn wral
      vx cG crn wral vx cv cG crn wcel vy cv cG crn wcel wa vx cv vy cv vm cv
      cM co cM co vx cv vy cv cG co vm cv cM co wceq wi cG cgi cfv vm cv cM co
      vm cv wceq vx cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co
      wceq vy cG crn wral vx cG crn wral vx cv cG crn wcel vy cv cG crn wcel wa
      vx cv vy cv vm cv cM co cM co vx cv vy cv cG co vm cv cM co wceq vx cv vy
      cv cG co vm cv cM co vx cv vy cv vm cv cM co cM co wceq vy cG crn wral vx
      cG crn wral vx cv cG crn wcel vy cv cG crn wcel wa wa vx cv vy cv cG co
      vm cv cM co vx cv vy cv vm cv cM co cM co vx cv vy cv cG co vm cv cM co
      vx cv vy cv vm cv cM co cM co wceq vy cG crn wral vx cG crn wral vx cv cG
      crn wcel vy cv cG crn wcel wa vx cv vy cv cG co vm cv cM co vx cv vy cv
      vm cv cM co cM co wceq vx cv vy cv cG co vm cv cM co vx cv vy cv vm cv cM
      co cM co wceq vx vy cG crn cG crn ra42 imp eqcomd ex adantl syl6 com23
      sylbi 3ad2ant3 imp31 eqtrd eqeq2d pm5.32da opabbidv adantr 3eqtrd vx cv
      cM ccur1 cfv cfv va cv cM crn wcel vb cv vx cv va cv cM co wceq wa va vb
      copab wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv cM
      co wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv cM
      crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq w3a
      vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab
      vx cv vy cv cG co cM ccur1 cfv cfv wceq cG cgr wcel cG crn cM crn cxp cM
      crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co vf cv cM co
      vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn wral wa vf cM
      crn wral w3a vx cv cG crn wcel vy cv cG crn wcel wa wa vx cv vy cv cG co
      cM ccur1 cfv cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co
      wceq wa vm vn copab wceq vx cv cM ccur1 cfv cfv va cv cM crn wcel vb cv
      vx cv va cv cM co wceq wa va vb copab wceq vm cv cM crn wcel vn cv vx cv
      vy cv cG co vm cv cM co wceq wa vm vn copab vx cv vy cv cG co cM ccur1
      cfv cfv wceq vy cv cM ccur1 cfv cfv vm cv cM crn wcel vn cv vy cv vm cv
      cM co wceq wa vm vn copab wceq vx cv vy cv cG co cM ccur1 cfv cfv vm cv
      cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab wceq
      vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn copab
      vx cv vy cv cG co cM ccur1 cfv cfv wceq vx cv vy cv cG co cM ccur1 cfv
      cfv vm cv cM crn wcel vn cv vx cv vy cv cG co vm cv cM co wceq wa vm vn
      copab eqcom biimpi 3ad2ant3 adantl 3eqtrd mpdan ex expdimp r19.21ai ex
      r19.21ai jca cG cgr wcel cM crn csymgrp cfv cgr wcel cM ccur1 cfv cG cM
      crn csymgrp cfv cghom co wcel cG crn cM crn cM crn vf cv wf1o vf cab cM
      ccur1 cfv wf vx cv cM ccur1 cfv cfv vy cv cM ccur1 cfv cfv cM crn csymgrp
      cfv co vx cv vy cv cG co cM ccur1 cfv cfv wceq vy cG crn wral vx cG crn
      wral wa wb cG cgr wcel cG crn cM crn cxp cM crn cM wf cG cgi cfv vf cv cM
      co vf cv wceq vx cv vy cv cG co vf cv cM co vx cv vy cv vf cv cM co cM co
      wceq vy cG crn wral vx cG crn wral wa vf cM crn wral w3a vx vy cM ccur1
      cfv cG cM crn csymgrp cfv cM crn cM crn vf cv wf1o vf cab cG crn cG crn
      eqid cM crn cM crn vf cv wf1o vf cab cM crn cM crn vf cv wf1o vf cab cxp
      cM crn cM crn vf cv wf1o vf cab cM crn csymgrp cfv wfo cM crn cM crn vf
      cv wf1o vf cab cM crn csymgrp cfv crn wceq vf cM crn cM crn cM crn vf cv
      wf1o vf cab cM cM cA curgrpact.1 elisseti rnex cM crn cM crn vf cv wf1o
      vf cab eqid symgfo cM crn cM crn vf cv wf1o vf cab cM crn cM crn vf cv
      wf1o vf cab cxp cM crn cM crn vf cv wf1o vf cab cM crn csymgrp cfv wfo cM
      crn csymgrp cfv crn cM crn cM crn vf cv wf1o vf cab cM crn cM crn vf cv
      wf1o vf cab cM crn cM crn vf cv wf1o vf cab cxp cM crn cM crn vf cv wf1o
      vf cab cM crn csymgrp cfv forn eqcomd ax-mp elghom cG cgr wcel cG crn cM
      crn cxp cM crn cM wf cG cgi cfv vf cv cM co vf cv wceq vx cv vy cv cG co
      vf cv cM co vx cv vy cv vf cv cM co cM co wceq vy cG crn wral vx cG crn
      wral wa vf cM crn wral 3simp1 cM crn cM cM cA curgrpact.1 elisseti rnex
      symggrpi sylancl mpbird syl6bi ax-mp $.
      $( [18-May-2010] $) $( [17-May-2010] $)
  $}

  ${
    grpdivfo.1 $e |- X = ran G $.
    grpdivfo.2 $e |- D = ( /g `  G ) $.
    ${
      grpdivfo.3 $e |- U = ( Id ` G ) $.
      $( "Division" by the neutral element of a group. $)
      grpdivone $p |- ( ( G e. Grp /\ A e. X ) -> ( A D U ) = A ) $=
        cG cgr wcel cA cX wcel cA cU cD co cA wceq cG cgr wcel cA cX wcel cU cX
        wcel cA cU cD co cA wceq cU cG cX grpdivfo.1 grpdivfo.3 grpidcl cG cgr
        wcel cA cX wcel cU cX wcel cA cU cD co cA wceq cG cgr wcel cA cX wcel
        cU cX wcel w3a cA cU cD co cA cU cG cgn cfv cfv cG co wceq cA cU cD co
        cA wceq cA cU cD cG cG cgn cfv cX grpdivfo.1 cG cgn cfv eqid grpdivfo.2
        grpdivval cG cgr wcel cA cX wcel cU cX wcel w3a cA cU cD co cA cU cG
        cgn cfv cfv cG co wceq cA cU cD co cA wceq wi cG cgr wcel cA cX wcel cG
        cgr wcel cA cX wcel cU cX wcel w3a cA cU cD co cA cU cG cgn cfv cfv cG
        co wceq cA cU cD co cA wceq wi wi cU cX wcel cG cgr wcel cU cG cgn cfv
        cfv cU wceq cG cgr wcel cA cX wcel cU cX wcel w3a cA cU cD co cA cU cG
        cgn cfv cfv cG co wceq cA cU cD co cA wceq wi wi cU cG cG cgn cfv
        grpdivfo.3 cG cgn cfv eqid grpinvid cU cG cgn cfv cfv cU wceq cA cU cG
        cgn cfv cfv cG co cA cU cG co wceq cG cgr wcel cA cX wcel cU cX wcel
        w3a cA cU cD co cA cU cG cgn cfv cfv cG co wceq cA cU cD co cA wceq wi
        wi cU cG cgn cfv cfv cU cA cG opreq2 cA cU cD co cA cU cG cgn cfv cfv
        cG co wceq cA cU cG cgn cfv cfv cG co cA cU cG co wceq cG cgr wcel cA
        cX wcel cU cX wcel w3a cA cU cD co cA wceq cA cU cD co cA cU cG cgn cfv
        cfv cG co wceq cA cU cG cgn cfv cfv cG co cA cU cG co wceq cA cU cD co
        cA cU cG co wceq cG cgr wcel cA cX wcel cU cX wcel w3a cA cU cD co cA
        wceq wi cA cU cD co cA cU cG cgn cfv cfv cG co wceq cA cU cG cgn cfv
        cfv cG co cA cU cG co wceq cA cU cD co cA cU cG co wceq cA cU cD co cA
        cU cG cgn cfv cfv cG co cA cU cG co eqtr ex cG cgr wcel cA cX wcel cU
        cX wcel w3a cA cU cD co cA cU cG co wceq cA cU cD co cA wceq cG cgr
        wcel cA cX wcel cA cU cD co cA cU cG co wceq cA cU cD co cA wceq wi cU
        cX wcel cA cU cD co cA cU cG co wceq cA cU cG co cA wceq cA cU cD co cA
        wceq cG cgr wcel cA cX wcel wa cA cU cD co cA cU cG co wceq cA cU cG co
        cA wceq cA cU cD co cA wceq cA cU cD co cA cU cG co cA eqtr ex cA cU cG
        cX grpdivfo.1 grpdivfo.3 grprid syl5com 3adant3 com12 syl6 com3l syl
        syl 3ad2ant1 pm2.43i mpd 3exp mpid imp $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d D x y z $. $d G x y z $. $d X x y z $.
      $( Todo: suppress grpdivf ? $)
      $( A "division" maps onto the group's underlying set. $)
      grpdivfo $p |- ( G e. Grp -> D : ( X X. X ) -onto-> X ) $=
        cG cgr wcel cX cX cxp cX cD wfo cX cX cxp cX cD wf cD crn cX wceq wa cG
        cgr wcel cX cX cxp cX cD wf cD crn cX wceq cD cG cX grpdivfo.1
        grpdivfo.2 grpdivf cG cgr wcel cD crn vx cv vy cv vz cv cD co wceq vz
        cX wrex vy cX wrex vx cab cX cG cgr wcel cD cX cX cxp wfn cD crn vx cv
        vy cv vz cv cD co wceq vz cX wrex vy cX wrex vx cab wceq cG cgr wcel cX
        cX cxp cX cD wf cD cX cX cxp wfn cD cG cX grpdivfo.1 grpdivfo.2 grpdivf
        cX cX cxp cX cD ffn syl vy vz vx cX cX cD fnrnoprv syl cG cgr wcel vx
        cv vy cv vz cv cD co wceq vz cX wrex vy cX wrex vx cab cX wceq vx cv vy
        cv vz cv cD co wceq vz cX wrex vy cX wrex vx cv cX wcel wb vx wal cG
        cgr wcel vx cv vy cv vz cv cD co wceq vz cX wrex vy cX wrex vx cv cX
        wcel wb vx cG cgr wcel vx cv vy cv vz cv cD co wceq vz cX wrex vy cX
        wrex vx cv cX wcel vx cv vy cv vz cv cD co wceq vz cX wrex vy cX wrex
        cG cgr wcel vx cv cX wcel vx cv vy cv vz cv cD co wceq vz cX wrex cG
        cgr wcel vx cv cX wcel wi vy cX vx cv vy cv vz cv cD co wceq vz cX wrex
        vy cv cX wcel cG cgr wcel vx cv cX wcel wi vx cv vy cv vz cv cD co wceq
        vy cv cX wcel cG cgr wcel vx cv cX wcel wi wi vz cX vy cv cX wcel vz cv
        cX wcel vx cv vy cv vz cv cD co wceq cG cgr wcel vx cv cX wcel wi vy cv
        cX wcel vz cv cX wcel cG cgr wcel vx cv vy cv vz cv cD co wceq vx cv cX
        wcel cG cgr wcel vy cv cX wcel vz cv cX wcel vx cv vy cv vz cv cD co
        wceq vx cv cX wcel wi cG cgr wcel cX cX cxp cX cD wf vy cv cX wcel vz
        cv cX wcel vx cv vy cv vz cv cD co wceq vx cv cX wcel wi wi wi cD cG cX
        grpdivfo.1 grpdivfo.2 grpdivf cX cX cxp cX cD wf vy cv cX wcel vz cv cX
        wcel vx cv vy cv vz cv cD co wceq vx cv cX wcel wi cX cX cxp cX cD wf
        vy cv cX wcel vz cv cX wcel w3a vy cv vz cv cD co cX wcel vx cv vy cv
        vz cv cD co wceq vx cv cX wcel wi vy cv vz cv cX cX cX cD foprrn vx cv
        vy cv vz cv cD co wceq vy cv vz cv cD co cX wcel vx cv cX wcel vy cv vz
        cv cD co cX wcel vx cv cX wcel wi vy cv vz cv cD co vx cv vy cv vz cv
        cD co vx cv wceq vy cv vz cv cD co cX wcel vx cv cX wcel vy cv vz cv cD
        co vx cv cX eleq1 biimpd eqcoms com12 syl 3exp syl com3l com34 com3l
        r19.23aiv com12 r19.23aiv com12 cG cgr wcel vx cv cX wcel vx cv vy cv
        vz cv cD co wceq vz cX wrex vy cX wrex wi cG cgr wcel cG cgi cfv cX
        wcel cG cgr wcel vx cv cX wcel vx cv vy cv vz cv cD co wceq vz cX wrex
        vy cX wrex wi wi cG cgi cfv cG cX grpdivfo.1 cG cgi cfv eqid grpidcl cG
        cgr wcel vx cv cX wcel cG cgi cfv cX wcel vx cv vy cv vz cv cD co wceq
        vz cX wrex vy cX wrex cG cgr wcel vx cv cX wcel cG cgi cfv cX wcel vx
        cv vy cv vz cv cD co wceq vz cX wrex vy cX wrex wi cG cgr wcel vx cv cX
        wcel wa cG cgi cfv cX wcel vx cv vy cv vz cv cD co wceq vz cX wrex vy
        cX wrex wi cG cgr wcel vx cv cX wcel wa vx cv cG cgi cfv cD co vx cv
        wceq cG cgr wcel vx cv cX wcel wa cG cgi cfv cX wcel vx cv vy cv vz cv
        cD co wceq vz cX wrex vy cX wrex wi wi vx cv cD cG cgi cfv cG cX
        grpdivfo.1 grpdivfo.2 cG cgi cfv eqid grpdivone cG cgr wcel vx cv cX
        wcel wa cG cgi cfv cX wcel vx cv vy cv vz cv cD co wceq vz cX wrex vy
        cX wrex wi wi vx cv vx cv cG cgi cfv cD co cG cgr wcel vx cv cX wcel wa
        cG cgi cfv cX wcel vx cv vx cv cG cgi cfv cD co wceq vx cv vy cv vz cv
        cD co wceq vz cX wrex vy cX wrex vx cv cX wcel cG cgi cfv cX wcel vx cv
        vx cv cG cgi cfv cD co wceq vx cv vy cv vz cv cD co wceq vz cX wrex vy
        cX wrex wi wi cG cgr wcel vx cv cX wcel cG cgi cfv cX wcel vx cv vx cv
        cG cgi cfv cD co wceq vx cv vy cv vz cv cD co wceq vz cX wrex vy cX
        wrex vy vz cX cX vx cv cG cgi cfv vx cv cD rcla4eopr 3exp adantl com3r
        eqcoms syl pm2.43i ex com3r syl pm2.43i impbid 19.21aiv vx cv vy cv vz
        cv cD co wceq vz cX wrex vy cX wrex vx cab cX wceq vx cv vy cv vz cv cD
        co wceq vz cX wrex vy cX wrex vx cv cX wcel wb vx wal wb cG cgr wcel vx
        cv vy cv vz cv cD co wceq vz cX wrex vy cX wrex vx cX abeq1 a1i mpbird
        eqtrd jca cX cX cxp cX cD wfo cX cX cxp cX cD wf cD crn cX wceq wa wb
        cG cgr wcel cX cX cxp cX cD dffo2 a1i mpbird $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}
  $}


  ${
    grpdrcan.1 $e |- X = ran G $.
    grpdrcan.2 $e |- D = ( /g ` G ) $.
    $( Right cancellation law for group "substraction" (or "division"). $)
    grpdrcan $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A D C ) = ( B D C ) <-> A = B ) ) $=
      cA cC cD co cA cC cG cgn cfv cfv cG co wceq cG cgr wcel cA cX wcel cB cX
      wcel cC cX wcel w3a wa cA cC cD co cB cC cD co wceq cA cB wceq wb cG cgr
      wcel cA cX wcel cC cX wcel cA cC cD co cA cC cG cgn cfv cfv cG co wceq cB
      cX wcel cA cC cD cG cG cgn cfv cX grpdrcan.1 cG cgn cfv eqid grpdrcan.2
      grpdivval 3adant3r2 cA cC cD co cA cC cG cgn cfv cfv cG co wceq cA cC cD
      co cB cC cD co wceq cA cB wceq wb cA cC cG cgn cfv cfv cG co cB cC cD co
      wceq cA cB wceq wb cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA
      cC cD co cA cC cG cgn cfv cfv cG co wceq cA cC cD co cB cC cD co wceq cA
      cC cG cgn cfv cfv cG co cB cC cD co wceq cA cB wceq cA cC cD co cA cC cG
      cgn cfv cfv cG co cB cC cD co eqeq1 bibi1d cB cC cD co cB cC cG cgn cfv
      cfv cG co wceq cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cC
      cG cgn cfv cfv cG co cB cC cD co wceq cA cB wceq wb cG cgr wcel cB cX
      wcel cC cX wcel cB cC cD co cB cC cG cgn cfv cfv cG co wceq cA cX wcel cB
      cC cD cG cG cgn cfv cX grpdrcan.1 cG cgn cfv eqid grpdrcan.2 grpdivval
      3adant3r1 cB cC cD co cB cC cG cgn cfv cfv cG co wceq cA cC cG cgn cfv
      cfv cG co cB cC cD co wceq cA cB wceq wb cA cC cG cgn cfv cfv cG co cB cC
      cG cgn cfv cfv cG co wceq cA cB wceq wb cG cgr wcel cA cX wcel cB cX wcel
      cC cX wcel w3a wa cB cC cD co cB cC cG cgn cfv cfv cG co wceq cA cC cG
      cgn cfv cfv cG co cB cC cD co wceq cA cC cG cgn cfv cfv cG co cB cC cG
      cgn cfv cfv cG co wceq cA cB wceq cB cC cD co cB cC cG cgn cfv cfv cG co
      cA cC cG cgn cfv cfv cG co eqeq2 bibi1d cG cgr wcel cA cX wcel cB cX wcel
      cC cX wcel w3a cA cX wcel cB cX wcel cC cG cgn cfv cfv cX wcel w3a cA cC
      cG cgn cfv cfv cG co cB cC cG cgn cfv cfv cG co wceq cA cB wceq wb cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cA cX wcel cB cX wcel cC cG
      cgn cfv cfv cX wcel cG cgr wcel cA cX wcel cB cX wcel cC cX wcel 3simpr1
      cG cgr wcel cA cX wcel cB cX wcel cC cX wcel 3simpr2 cG cgr wcel cA cX
      wcel cC cX wcel cC cG cgn cfv cfv cX wcel cB cX wcel cC cG cG cgn cfv cX
      grpdrcan.1 cG cgn cfv eqid grpinvcl 3ad2antr3 3jca cA cB cC cG cgn cfv
      cfv cG cX grpdrcan.1 grprcan syldan syl5bir mpcom syl5bir mpcom $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)


    $( Left cancellation law for group "substraction" (or "division"). $)
    grpdlcan $p |- ( ( G e. Grp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C D A ) = ( C D B ) <-> A = B ) ) $=
      cC cA cD co cC cA cG cgn cfv cfv cG co wceq cC cB cD co cC cB cG cgn cfv
      cfv cG co wceq wa cG cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cC
      cA cD co cC cB cD co wceq cA cB wceq wb cG cgr wcel cA cX wcel cB cX wcel
      cC cX wcel w3a wa cC cA cD co cC cA cG cgn cfv cfv cG co wceq cC cB cD co
      cC cB cG cgn cfv cfv cG co wceq cA cX wcel cB cX wcel cC cX wcel w3a cG
      cgr wcel cC cA cD co cC cA cG cgn cfv cfv cG co wceq cA cX wcel cC cX
      wcel cG cgr wcel cC cA cD co cC cA cG cgn cfv cfv cG co wceq wi cB cX
      wcel cA cX wcel cC cX wcel cG cgr wcel cC cA cD co cC cA cG cgn cfv cfv
      cG co wceq wi cG cgr wcel cC cX wcel cA cX wcel cC cA cD co cC cA cG cgn
      cfv cfv cG co wceq cG cgr wcel cC cX wcel cA cX wcel cC cA cD co cC cA cG
      cgn cfv cfv cG co wceq cC cA cD cG cG cgn cfv cX grpdrcan.1 cG cgn cfv
      eqid grpdrcan.2 grpdivval 3exp com13 imp 3adant2 impcom cA cX wcel cB cX
      wcel cC cX wcel w3a cG cgr wcel cC cB cD co cC cB cG cgn cfv cfv cG co
      wceq cB cX wcel cC cX wcel cG cgr wcel cC cB cD co cC cB cG cgn cfv cfv
      cG co wceq wi cA cX wcel cB cX wcel cC cX wcel cG cgr wcel cC cB cD co cC
      cB cG cgn cfv cfv cG co wceq wi cG cgr wcel cC cX wcel cB cX wcel cC cB
      cD co cC cB cG cgn cfv cfv cG co wceq cG cgr wcel cC cX wcel cB cX wcel
      cC cB cD co cC cB cG cgn cfv cfv cG co wceq cC cB cD cG cG cgn cfv cX
      grpdrcan.1 cG cgn cfv eqid grpdrcan.2 grpdivval 3exp com13 imp 3adant1
      impcom jca cC cA cD co cC cA cG cgn cfv cfv cG co wceq cC cB cD co cC cB
      cG cgn cfv cfv cG co wceq wa cG cgr wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa cC cA cG cgn cfv cfv cG co cC cB cG cgn cfv cfv cG co wceq cA cB
      wceq wb cC cA cD co cC cB cD co wceq cA cB wceq wb cC cA cD co cC cA cG
      cgn cfv cfv cG co wceq cC cB cD co cC cB cG cgn cfv cfv cG co wceq wa cG
      cgr wcel cA cX wcel cB cX wcel cC cX wcel w3a wa cC cA cG cgn cfv cfv cG
      co cC cB cG cgn cfv cfv cG co wceq cA cB wceq wb cC cA cD co cC cA cG cgn
      cfv cfv cG co wceq cC cB cD co cC cB cG cgn cfv cfv cG co wceq wa cG cgr
      wcel cA cX wcel cB cX wcel cC cX wcel w3a wa wa cC cA cG cgn cfv cfv cG
      co cC cB cG cgn cfv cfv cG co wceq cA cG cgn cfv cfv cB cG cgn cfv cfv
      wceq cA cB wceq cC cA cD co cC cA cG cgn cfv cfv cG co wceq cC cB cD co
      cC cB cG cgn cfv cfv cG co wceq wa cG cgr wcel cA cX wcel cB cX wcel cC
      cX wcel w3a wa wa cG cgr wcel cA cG cgn cfv cfv cX wcel cB cG cgn cfv cfv
      cX wcel cC cX wcel w3a wa cC cA cG cgn cfv cfv cG co cC cB cG cgn cfv cfv
      cG co wceq cA cG cgn cfv cfv cB cG cgn cfv cfv wceq wb cG cgr wcel cA cX
      wcel cB cX wcel cC cX wcel w3a wa cG cgr wcel cA cG cgn cfv cfv cX wcel
      cB cG cgn cfv cfv cX wcel cC cX wcel w3a wa cC cA cD co cC cA cG cgn cfv
      cfv cG co wceq cC cB cD co cC cB cG cgn cfv cfv cG co wceq wa cG cgr wcel
      cA cX wcel cB cX wcel cC cX wcel w3a wa cG cgr wcel cA cG cgn cfv cfv cX
      wcel cB cG cgn cfv cfv cX wcel cC cX wcel w3a cG cgr wcel cA cX wcel cB
      cX wcel cC cX wcel w3a pm3.26 cG cgr wcel cA cX wcel cB cX wcel cC cX
      wcel w3a wa cA cG cgn cfv cfv cX wcel cB cG cgn cfv cfv cX wcel cC cX
      wcel cG cgr wcel cB cX wcel cA cX wcel cA cG cgn cfv cfv cX wcel cC cX
      wcel cA cG cG cgn cfv cX grpdrcan.1 cG cgn cfv eqid grpinvcl 3ad2antr1 cG
      cgr wcel cA cX wcel cB cX wcel cB cG cgn cfv cfv cX wcel cC cX wcel cB cG
      cG cgn cfv cX grpdrcan.1 cG cgn cfv eqid grpinvcl 3ad2antr2 cG cgr wcel
      cA cX wcel cB cX wcel cC cX wcel 3simpr3 3jca jca adantl cA cG cgn cfv
      cfv cB cG cgn cfv cfv cC cG cX grpdrcan.1 grplcan syl cX cX cG cgn cfv
      wf1 cA cX wcel cB cX wcel wa cA cG cgn cfv cfv cB cG cgn cfv cfv wceq cA
      cB wceq wb cC cA cD co cC cA cG cgn cfv cfv cG co wceq cC cB cD co cC cB
      cG cgn cfv cfv cG co wceq wa cG cgr wcel cA cX wcel cB cX wcel cC cX wcel
      w3a wa wa cX cX cA cB cG cgn cfv f1fveq cG cgr wcel cX cX cG cgn cfv wf1
      cC cA cD co cC cA cG cgn cfv cfv cG co wceq cC cB cD co cC cB cG cgn cfv
      cfv cG co wceq wa cA cX wcel cB cX wcel cC cX wcel w3a cG cgr wcel cX cX
      cG cgn cfv wf1o cX cX cG cgn cfv wf1 cG cG cgn cfv cX grpdrcan.1 cG cgn
      cfv eqid grpinvf cX cX cG cgn cfv f1of1 syl ad2antrl cA cX wcel cB cX
      wcel cC cX wcel w3a cA cX wcel cB cX wcel wa cC cA cD co cC cA cG cgn cfv
      cfv cG co wceq cC cB cD co cC cB cG cgn cfv cfv cG co wceq wa cG cgr wcel
      cA cX wcel cB cX wcel cC cX wcel 3simpa ad2antll sylanc bitrd ex cC cA cD
      co cC cA cG cgn cfv cfv cG co wceq cC cB cD co cC cB cG cgn cfv cfv cG co
      wceq wa cC cA cD co cC cB cD co wceq cC cA cG cgn cfv cfv cG co cC cB cG
      cgn cfv cfv cG co wceq cA cB wceq cC cA cD co cC cA cG cgn cfv cfv cG co
      cC cB cD co cC cB cG cgn cfv cfv cG co eqeq12 bibi1d sylibrd mpcom $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}


  ${
    grpdivzer.1 $e |- X = ran G $.
    grpdivzer.2 $e |- U = ( Id ` G ) $.
    grpdivzer.3 $e |- D = ( /g ` G ) $.
    $( Condition for a "substraction" (or "division") value to be
       equal to the identity element. $)
    grpdivzer $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
                   ( ( A D B ) = U <-> A = B ) ) $=
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cD co cU wceq cA cB cG cgn
      cfv cfv cG co cU wceq cA cG cgn cfv cfv cB cG cgn cfv cfv wceq cA cB wceq
      cG cgr wcel cA cX wcel cB cX wcel w3a cA cB cD co cA cB cG cgn cfv cfv cG
      co cU cA cB cD cG cG cgn cfv cX grpdivzer.1 cG cgn cfv eqid grpdivzer.3
      grpdivval eqeq1d cG cgr wcel cA cX wcel cB cG cgn cfv cfv cX wcel cA cG
      cgn cfv cfv cB cG cgn cfv cfv wceq cA cB cG cgn cfv cfv cG co cU wceq wb
      cB cX wcel cA cB cG cgn cfv cfv cU cG cG cgn cfv cX grpdivzer.1
      grpdivzer.2 cG cgn cfv eqid grpinvid1 cG cgr wcel cB cX wcel cB cG cgn
      cfv cfv cX wcel cA cX wcel cB cG cG cgn cfv cX grpdivzer.1 cG cgn cfv
      eqid grpinvcl 3adant2 syld3an3 cX cX cG cgn cfv wf1 cA cX wcel cB cX wcel
      wa cA cG cgn cfv cfv cB cG cgn cfv cfv wceq cA cB wceq wb cG cgr wcel cA
      cX wcel cB cX wcel w3a cX cX cA cB cG cgn cfv f1fveq cG cgr wcel cA cX
      wcel cX cX cG cgn cfv wf1 cB cX wcel cG cgr wcel cX cX cG cgn cfv wf1o cX
      cX cG cgn cfv wf1 cG cG cgn cfv cX grpdivzer.1 cG cgn cfv eqid grpinvf cX
      cX cG cgn cfv f1of1 syl 3ad2ant1 cG cgr wcel cA cX wcel cB cX wcel 3simpc
      sylanc 3bitr2d $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d A a g l $. $d A g j l $. $d G g k $. $d M1 a g k l $. $d M1 g j k l $.
    $d M2 g j k $. $d N g k $. $d X g k $.
    fprodneg.1 $e |- X = ran G $.
    fprodneg.2 $e |- N = ( inv ` G ) $.
    $( The inverse of a finite composite in the case of an abelian group. $)
    fprodneg $p |- ( ( M2 e. ( ZZ>= ` M1 ) /\ A. k e. ( M1 ... M2 )
       A e. X /\ G e. Abel ) ->
       ( N ` prod_ k e. ( M1 ... M2 ) G A ) =
         prod_ k e. ( M1 ... M2 ) G ( N ` A  ) ) $=
      cN cG cgn cfv wceq cm2 cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co wral
      cG cabl wcel w3a cm1 cm2 cfz co cA vk cG cprd cN cfv cm1 cm2 cfz co cA cN
      cfv vk cG cprd wceq fprodneg.2 cN cG cgn cfv wceq cm2 cm1 cuz cfv wcel cA
      cX wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a wa cm1 cm2 cfz co cA vk
      cG cprd cG cgn cfv cfv cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd cm1
      cm2 cfz co cA vk cG cprd cN cfv cm1 cm2 cfz co cA cN cfv vk cG cprd cm2
      cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cm1
      cm2 cfz co cA vk cG cprd cG cgn cfv cfv cm1 cm2 cfz co cA cG cgn cfv cfv
      vk cG cprd wceq cN cG cgn cfv wceq cX cG crn wceq cm2 cm1 cuz cfv wcel cA
      cX wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cm1 cm2 cfz co cA vk cG
      cprd cG cgn cfv cfv cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd wceq wi
      fprodneg.1 cX cG crn wceq cm2 cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz
      co wral cG cabl wcel w3a cm2 cm1 cuz cfv wcel cA cG crn wcel vk cm1 cm2
      cfz co wral cG cabl wcel w3a cm1 cm2 cfz co cA vk cG cprd cG cgn cfv cfv
      cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd wceq cX cG crn wceq cA cX
      wcel vk cm1 cm2 cfz co wral cA cG crn wcel vk cm1 cm2 cfz co wral cm2 cm1
      cuz cfv wcel cG cabl wcel cX cG crn wceq cA cX wcel cA cG crn wcel vk cm1
      cm2 cfz co cX cG crn cA eleq2 ralbidv 3anbi2d cm2 cm1 cuz cfv wcel cA cG
      crn wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cm1 cm2 cfz co cA vk cG
      cprd cG cgn cfv cfv cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd wceq cG
      cabl wcel cm2 cm1 cuz cfv wcel cm2 cm1 cuz cfv wcel cA cG crn wcel vk cm1
      cm2 cfz co wral cG cabl wcel w3a cm1 cm2 cfz co cA vk cG cprd cG cgn cfv
      cfv cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd wceq wi cA cG crn wcel vk
      cm1 cm2 cfz co wral cm2 cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 cm2 cfz
      co wral vg cv cabl wcel w3a cm1 cm2 cfz co cA vk vg cv cprd vg cv cgn cfv
      cfv cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi cm2 cm1 cuz
      cfv wcel cA cG crn wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cm1 cm2
      cfz co cA vk cG cprd cG cgn cfv cfv cm1 cm2 cfz co cA cG cgn cfv cfv vk
      cG cprd wceq wi vg cG cabl vg cv cG wceq cm2 cm1 cuz cfv wcel cA vg cv
      crn wcel vk cm1 cm2 cfz co wral vg cv cabl wcel w3a cm2 cm1 cuz cfv wcel
      cA cG crn wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cm1 cm2 cfz co cA
      vk vg cv cprd vg cv cgn cfv cfv cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq cm1 cm2 cfz co cA vk cG cprd cG cgn cfv cfv cm1 cm2 cfz co
      cA cG cgn cfv cfv vk cG cprd wceq vg cv cG wceq cA vg cv crn wcel vk cm1
      cm2 cfz co wral cA cG crn wcel vk cm1 cm2 cfz co wral vg cv cabl wcel cG
      cabl wcel cm2 cm1 cuz cfv wcel vg cv cG wceq cA vg cv crn wcel cA cG crn
      wcel vk cm1 cm2 cfz co vg cv cG wceq vg cv crn cG crn cA vg cv cG rneq
      eleq2d ralbidv vg cv cG cabl eleq1 3anbi23d vg cv cG wceq cm1 cm2 cfz co
      cA vk vg cv cprd vg cv cgn cfv cfv cm1 cm2 cfz co cA vk cG cprd cG cgn
      cfv cfv cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg cv cprd cm1 cm2 cfz co
      cA cG cgn cfv cfv vk cG cprd vg cv cG wceq cm1 cm2 cfz co cA vk vg cv
      cprd cm1 cm2 cfz co cA vk cG cprd vg cv cgn cfv cG cgn cfv vg cv cG cgn
      fveq2 cm1 cm2 cfz co cA vk vg cv cG prodeq3 fveq12d vg cv cG wceq cm1 cm2
      cfz co cm1 cm2 cfz co cA vg cv cgn cfv cfv cA cG cgn cfv cfv vk cvv vg cv
      cG vg cv cG wceq cm1 cm2 cfz co eqidd vg cv cG wceq id vg cv cG wceq cA
      vg cv cgn cfv cfv cA cG cgn cfv cfv wceq vk cm1 cm2 cfz co vg cv cG wceq
      cA vg cv cgn cfv cfv cA cG cgn cfv cfv wceq vk cv cm1 cm2 cfz co wcel vg
      cv cG wceq cA vg cv cgn cfv cG cgn cfv vg cv cG cgn fveq2 fveq1d adantr
      r19.21aiva vg visset prodeq123d eqeq12d imbi12d cm2 cm1 cuz cfv wcel cA
      vg cv crn wcel vk cm1 cm2 cfz co wral vg cv cabl wcel cm1 cm2 cfz co cA
      vk vg cv cprd vg cv cgn cfv cfv cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq cA vg cv crn wcel vk cm1 vj cv cfz co wral vg cv cabl wcel
      cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj cv cfz co cA
      vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 cm1
      cfz co wral vg cv cabl wcel cm1 cm1 cfz co cA vk vg cv cprd vg cv cgn cfv
      cfv cm1 cm1 cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv
      crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk
      vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral
      vg cv cabl wcel cm1 vl cv c1 caddc co cfz co cA vk vg cv cprd vg cv cgn
      cfv cfv cm1 vl cv c1 caddc co cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq wi wi cA vg cv crn wcel vk cm1 cm2 cfz co wral vg cv cabl wcel cm1
      cm2 cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 cm2 cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd wceq wi wi vj vl cm1 cm2 vj cv cm1 wceq cA vg cv
      crn wcel vk cm1 vj cv cfz co wral cA vg cv crn wcel vk cm1 cm1 cfz co
      wral vg cv cabl wcel cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vj cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi vg cv cabl
      wcel cm1 cm1 cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 cm1 cfz co cA
      vg cv cgn cfv cfv vk vg cv cprd wceq wi vj cv cm1 wceq cA vg cv crn wcel
      vk cm1 vj cv cfz co cm1 cm1 cfz co vj cv cm1 cm1 cfz opreq2 raleq1d vj cv
      cm1 wceq cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj cv
      cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq cm1 cm1 cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 cm1 cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq vg cv cabl wcel vj cv cm1 wceq cm1 vj cv cfz co cA vk vg cv cprd vg
      cv cgn cfv cfv cm1 cm1 cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj
      cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd cm1 cm1 cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd vj cv cm1 wceq cm1 vj cv cfz co cA vk vg cv cprd
      cm1 cm1 cfz co cA vk vg cv cprd vg cv cgn cfv vj cv cm1 wceq cm1 vj cv
      cfz co cm1 cm1 cfz co cA vk vg cv vj cv cm1 cm1 cfz opreq2 prodeq1d
      fveq2d vj cv cm1 wceq cm1 vj cv cfz co cm1 cm1 cfz co cA vg cv cgn cfv
      cfv vk vg cv vj cv cm1 cm1 cfz opreq2 prodeq1d eqeq12d imbi2d imbi12d vj
      vl weq cA vg cv crn wcel vk cm1 vj cv cfz co wral cA vg cv crn wcel vk
      cm1 vl cv cfz co wral vg cv cabl wcel cm1 vj cv cfz co cA vk vg cv cprd
      vg cv cgn cfv cfv cm1 vj cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq wi vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv
      cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi vj vl weq
      cA vg cv crn wcel vk cm1 vj cv cfz co cm1 vl cv cfz co vj cv vl cv cm1
      cfz opreq2 raleq1d vj vl weq cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn
      cfv cfv cm1 vj cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq cm1 vl
      cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq vg cv cabl wcel vj vl weq cm1 vj cv cfz co
      cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vk vg cv cprd vg
      cv cgn cfv cfv cm1 vj cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd cm1 vl
      cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd vj vl weq cm1 vj cv cfz co
      cA vk vg cv cprd cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv vj vl
      weq cm1 vj cv cfz co cm1 vl cv cfz co cA vk vg cv vj cv vl cv cm1 cfz
      opreq2 prodeq1d fveq2d vj vl weq cm1 vj cv cfz co cm1 vl cv cfz co cA vg
      cv cgn cfv cfv vk vg cv vj cv vl cv cm1 cfz opreq2 prodeq1d eqeq12d
      imbi2d imbi12d vj cv vl cv c1 caddc co wceq cA vg cv crn wcel vk cm1 vj
      cv cfz co wral cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral vg
      cv cabl wcel cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj
      cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi vg cv cabl wcel cm1
      vl cv c1 caddc co cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv c1
      caddc co cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi vj cv vl cv c1
      caddc co wceq cA vg cv crn wcel vk cm1 vj cv cfz co cm1 vl cv c1 caddc co
      cfz co vj cv vl cv c1 caddc co cm1 cfz opreq2 raleq1d vj cv vl cv c1
      caddc co wceq cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj
      cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq cm1 vl cv c1 caddc co
      cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv c1 caddc co cfz co cA
      vg cv cgn cfv cfv vk vg cv cprd wceq vg cv cabl wcel vj cv vl cv c1 caddc
      co wceq cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv c1
      caddc co cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj cv cfz co cA vg
      cv cgn cfv cfv vk vg cv cprd cm1 vl cv c1 caddc co cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd vj cv vl cv c1 caddc co wceq cm1 vj cv cfz co cA vk
      vg cv cprd cm1 vl cv c1 caddc co cfz co cA vk vg cv cprd vg cv cgn cfv vj
      cv vl cv c1 caddc co wceq cm1 vj cv cfz co cm1 vl cv c1 caddc co cfz co
      cA vk vg cv vj cv vl cv c1 caddc co cm1 cfz opreq2 prodeq1d fveq2d vj cv
      vl cv c1 caddc co wceq cm1 vj cv cfz co cm1 vl cv c1 caddc co cfz co cA
      vg cv cgn cfv cfv vk vg cv vj cv vl cv c1 caddc co cm1 cfz opreq2
      prodeq1d eqeq12d imbi2d imbi12d vj cv cm2 wceq cA vg cv crn wcel vk cm1
      vj cv cfz co wral cA vg cv crn wcel vk cm1 cm2 cfz co wral vg cv cabl
      wcel cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd wceq wi vg cv cabl wcel cm1 cm2 cfz co
      cA vk vg cv cprd vg cv cgn cfv cfv cm1 cm2 cfz co cA vg cv cgn cfv cfv vk
      vg cv cprd wceq wi vj cv cm2 wceq cA vg cv crn wcel vk cm1 vj cv cfz co
      cm1 cm2 cfz co vj cv cm2 cm1 cfz opreq2 raleq1d vj cv cm2 wceq cm1 vj cv
      cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj cv cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd wceq cm1 cm2 cfz co cA vk vg cv cprd vg cv cgn cfv
      cfv cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq vg cv cabl
      wcel vj cv cm2 wceq cm1 vj cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 cm2 cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vj cv cfz co cA vg
      cv cgn cfv cfv vk vg cv cprd cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd vj cv cm2 wceq cm1 vj cv cfz co cA vk vg cv cprd cm1 cm2 cfz co cA
      vk vg cv cprd vg cv cgn cfv vj cv cm2 wceq cm1 vj cv cfz co cm1 cm2 cfz
      co cA vk vg cv vj cv cm2 cm1 cfz opreq2 prodeq1d fveq2d vj cv cm2 wceq
      cm1 vj cv cfz co cm1 cm2 cfz co cA vg cv cgn cfv cfv vk vg cv vj cv cm2
      cm1 cfz opreq2 prodeq1d eqeq12d imbi2d imbi12d cm1 cz wcel cA vg cv crn
      wcel vk cm1 cm1 cfz co wral vg cv cabl wcel cm1 cm1 cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 cm1 cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq cm1 cz wcel cA vg cv crn wcel vk cm1 cm1 cfz co wral vg cv cabl wcel
      w3a cm1 cm1 cfz co cA vg cv cgn cfv cfv vk vg cv cprd vk cm1 cA vg cv cgn
      cfv cfv csb vk cm1 cA csb vg cv cgn cfv cfv cm1 cm1 cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 cz wcel cA vg cv cgn cfv cfv cvv wcel vk cm1
      cm1 cfz co wral cm1 cm1 cfz co cA vg cv cgn cfv cfv vk vg cv cprd vk cm1
      cA vg cv cgn cfv cfv csb wceq cm1 cz wcel cA vg cv crn wcel vk cm1 cm1
      cfz co wral vg cv cabl wcel w3a cA vg cv cgn cfv cfv cvv cvv vk vg cv cm1
      vg visset fprod1s cm1 cz wcel cA vg cv crn wcel vk cm1 cm1 cfz co wral vg
      cv cabl wcel 3simp1 cA vg cv cgn cfv cfv cvv wcel vk cm1 cm1 cfz co cA vg
      cv cgn cfv cfv cvv wcel vk cv cm1 cm1 cfz co wcel cA vg cv cgn cfv fvex
      a1i rgen sylancl cm1 cz wcel cA vg cv crn wcel vk cm1 cm1 cfz co wral vk
      cm1 cA vg cv cgn cfv cfv csb vk cm1 cA csb vg cv cgn cfv cfv wceq vg cv
      cabl wcel vk cm1 cA cz vg cv cgn cfv csbfv2g 3ad2ant1 cm1 cz wcel cA vg
      cv crn wcel vk cm1 cm1 cfz co wral vg cv cabl wcel w3a vk cm1 cA csb cm1
      cm1 cfz co cA vk vg cv cprd vg cv cgn cfv cm1 cz wcel cA vg cv crn wcel
      vk cm1 cm1 cfz co wral vk cm1 cA csb cm1 cm1 cfz co cA vk vg cv cprd wceq
      vg cv cabl wcel cm1 cz wcel cA vg cv crn wcel vk cm1 cm1 cfz co wral wa
      cm1 cm1 cfz co cA vk vg cv cprd vk cm1 cA csb cA vg cv crn cvv vk vg cv
      cm1 vg visset fprod1s eqcomd 3adant3 fveq2d 3eqtrrd 3exp vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral vg cv cabl wcel cm1 vl cv c1 caddc co cfz co cA vk
      vg cv cprd vg cv cgn cfv cfv cm1 vl cv c1 caddc co cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd wceq vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk
      cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd
      vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral w3a vg
      cv cabl wcel wa cm1 vl cv c1 caddc co cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd vk vl cv c1
      caddc co cA vg cv cgn cfv cfv csb vg cv co cm1 vl cv cfz co cA vk vg cv
      cprd vk vl cv c1 caddc co cA csb vg cv co vg cv cgn cfv cfv cm1 vl cv c1
      caddc co cfz co cA vk vg cv cprd vg cv cgn cfv cfv vl cv cm1 cuz cfv wcel
      cA vg cv cgn cfv cfv vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral
      cm1 vl cv c1 caddc co cfz co cA vg cv cgn cfv cfv vk vg cv cprd cm1 vl cv
      cfz co cA vg cv cgn cfv cfv vk vg cv cprd vk vl cv c1 caddc co cA vg cv
      cgn cfv cfv csb vg cv co wceq vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk
      cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd
      vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral w3a vg
      cv cabl wcel wa cA vg cv cgn cfv cfv vg cv crn cvv vk vg cv cm1 vl cv vg
      visset fprodp1s vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz
      co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv
      cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg
      cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral vg cv cabl wcel 3simpl1
      vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv
      cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv
      cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk
      cm1 vl cv c1 caddc co cfz co wral vg cv cabl wcel cA vg cv cgn cfv cfv vg
      cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral vl cv cm1 cuz cfv wcel
      cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz
      co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv
      cfv vk vg cv cprd wceq wi wi vg cv cabl wcel cA vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co wral cA vg cv cgn cfv cfv vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co wral vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk
      cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd
      vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq wi wi vg cv cabl wcel cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz
      co wral cA vg cv cgn cfv cfv vg cv crn wcel vk cm1 vl cv c1 caddc co cfz
      co wral wi vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co
      wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi vg cv cabl
      wcel w3a cA vg cv crn wcel cA vg cv cgn cfv cfv vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl
      cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv
      cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi
      wi vg cv cabl wcel vk vl cv cm1 cuz cfv wcel vk ax-17 cA vg cv crn wcel
      vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd wceq wi vk cA vg cv crn wcel vk cm1 vl cv cfz co hbra1 vg cv cabl
      wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd wceq vk vg cv cabl wcel vk ax-17 vk va
      va cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd vk va cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv va cv vg cv cgn cfv wcel vk ax-17 va cm1 vl cv cfz co
      cA vk vg cv va cv cm1 vl cv cfz co wcel vk ax-17 hbprod1 hbfv va cm1 vl
      cv cfz co cA vg cv cgn cfv cfv vk vg cv va cv cm1 vl cv cfz co wcel vk
      ax-17 hbprod1 hbeq hbim hbim vg cv cabl wcel vk ax-17 hb3an vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi vg cv cabl wcel w3a cA vg cv crn
      wcel cA vg cv cgn cfv cfv vg cv crn wcel wi vk cv cm1 vl cv c1 caddc co
      cfz co wcel vg cv cabl wcel vl cv cm1 cuz cfv wcel cA vg cv crn wcel cA
      vg cv cgn cfv cfv vg cv crn wcel wi cA vg cv crn wcel vk cm1 vl cv cfz co
      wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi vg cv cabl
      wcel vg cv cgr wcel cA vg cv crn wcel cA vg cv cgn cfv cfv vg cv crn wcel
      wi vg cv ablgrp vg cv cgr wcel cA vg cv crn wcel cA vg cv cgn cfv cfv vg
      cv crn wcel cA vg cv vg cv cgn cfv vg cv crn vg cv crn eqid vg cv cgn cfv
      eqid grpinvcl ex syl 3ad2ant3 adantr r19.20da 3exp com34 3imp1 sylanc vl
      cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl
      wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co wral w3a vg cv cabl wcel wa cm1 vl cv cfz co cA vk
      vg cv cprd vk vl cv c1 caddc co cA csb vg cv co vg cv cgn cfv cfv cm1 vl
      cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv vk vl cv c1 caddc co cA csb
      vg cv cgn cfv cfv vg cv co cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd vk vl cv c1 caddc co cA vg cv cgn cfv cfv csb vg cv co vg cv cabl
      wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv crn wcel vk vl cv c1 caddc
      co cA csb vg cv crn wcel cm1 vl cv cfz co cA vk vg cv cprd vk vl cv c1
      caddc co cA csb vg cv co vg cv cgn cfv cfv cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv vk vl cv c1 caddc co cA csb vg cv cgn cfv cfv vg
      cv co wceq vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co
      wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv
      crn wcel vk cm1 vl cv c1 caddc co cfz co wral w3a vg cv cabl wcel wa cm1
      vl cv cfz co cA vk vg cv cprd vk vl cv c1 caddc co cA csb vg cv vg cv cgn
      cfv vg cv crn vg cv crn eqid vg cv cgn cfv eqid ablinvop vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral w3a vg cv cabl wcel pm3.27 vl cv cm1 cuz cfv wcel vg
      cv cmagm cexid cin wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral cm1 vl
      cv cfz co cA vk vg cv cprd vg cv crn wcel vl cv cm1 cuz cfv wcel cA vg cv
      crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk
      vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral
      w3a vg cv cabl wcel wa cA vk vg cv cm1 vl cv vg cv crn vg cv crn eqid
      clfsebs2 vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co
      wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv
      crn wcel vk cm1 vl cv c1 caddc co cfz co wral vg cv cabl wcel 3simpl1 vg
      cv cabl wcel vg cv cmagm cexid cin wcel vl cv cm1 cuz cfv wcel cA vg cv
      crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk
      vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral
      w3a vg cv cabl wcel vg cv cgr wcel vg cv cmnd wcel vg cv cmagm cexid cin
      wcel vg cv ablgrp vg cv grpmnd vg cv mndmgmid 3syl adantl vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral w3a cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv
      cabl wcel vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co
      wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv
      crn wcel vk cm1 vl cv c1 caddc co cfz co wral cA vg cv crn wcel vk cm1 vl
      cv cfz co wral vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz
      co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv
      cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi wa cm1
      vl cv cfz co cm1 vl cv c1 caddc co cfz co wss cA vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co wral cA vg cv crn wcel vk cm1 vl cv cfz co wral wi
      vl cv c1 caddc co vl cv cuz cfv wcel cm1 cz wcel cm1 vl cv cfz co cm1 vl
      cv c1 caddc co cfz co wss vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1
      vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv
      cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi
      wi wa vl cv cm1 vl cv c1 caddc co fzss2 vl cv cm1 cuz cfv wcel cA vg cv
      crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk
      vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq wi wi wa vl cv cz wcel vl cv vl cv cuz cfv wcel vl cv c1
      caddc co vl cv cuz cfv wcel vl cv cm1 cuz cfv wcel vl cv cz wcel cA vg cv
      crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk
      vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg
      cv cprd wceq wi wi cm1 vl cv eluzelz adantr vl cv uzid vl cv vl cv
      peano2uz 3syl vl cv cm1 cuz cfv wcel cm1 cz wcel cA vg cv crn wcel vk cm1
      vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv
      cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi
      wi cm1 vl cv eluzel2 adantr sylanc cA vg cv crn wcel vk cm1 vl cv cfz co
      cm1 vl cv c1 caddc co cfz co ssralv syl 3impia adantr syl3anc vl cv c1
      caddc co cm1 vl cv c1 caddc co cfz co wcel cA vg cv crn wcel vk cm1 vl cv
      c1 caddc co cfz co wral vk vl cv c1 caddc co cA csb vg cv crn wcel vl cv
      cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl
      wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co wral w3a vg cv cabl wcel wa vk vl cv c1 caddc co
      cm1 vl cv c1 caddc co cfz co cA vg cv crn ra4csbela vl cv cm1 cuz cfv
      wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv
      cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc
      co cfz co wral w3a vg cv cabl wcel wa vl cv c1 caddc co cm1 cuz cfv wcel
      vl cv c1 caddc co cm1 vl cv c1 caddc co cfz co wcel vl cv cm1 cuz cfv
      wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv
      cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn
      cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc
      co cfz co wral w3a vl cv c1 caddc co cm1 cuz cfv wcel vg cv cabl wcel vl
      cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl
      wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi vl cv c1 caddc co cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral cm1 vl cv
      peano2uz 3ad2ant1 adantr cm1 vl cv c1 caddc co eluzfz2 syl vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral vg cv cabl wcel 3simpl3 sylanc syl3anc vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral w3a vg cv cabl wcel wa cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd vk vl cv c1 caddc co cA csb vg cv cgn cfv cfv vk vl cv c1 caddc co
      cA vg cv cgn cfv cfv csb vg cv vl cv cm1 cuz cfv wcel cA vg cv crn wcel
      vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral vg
      cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl
      cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq vl cv cm1 cuz cfv wcel
      cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral cA vg cv crn wcel
      vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd wceq wi wi vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv
      cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi
      vl cv cm1 cuz cfv wcel cm1 cz wcel vl cv cz wcel cm1 vl cv cle wbr w3a cA
      vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral cA vg cv crn wcel vk
      cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd
      vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd
      wceq wi wi vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn
      cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi wi
      cm1 vl cv eluz2 cm1 cz wcel vl cv cz wcel cA vg cv crn wcel vk cm1 vl cv
      c1 caddc co cfz co wral cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv
      cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv
      cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi wi cm1 vl cv cle wbr cm1 cz wcel vl
      cv cz wcel wa cm1 vl cv cfz co cm1 vl cv c1 caddc co cfz co wss cA vg cv
      crn wcel vk cm1 vl cv c1 caddc co cfz co wral cA vg cv crn wcel vk cm1 vl
      cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv
      cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi
      wi vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv
      cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi wi cm1 vl
      cv fzssp1 cm1 vl cv cfz co cm1 vl cv c1 caddc co cfz co wss cA vg cv crn
      wcel vk cm1 vl cv c1 caddc co cfz co wral cA vg cv crn wcel vk cm1 vl cv
      cfz co wral cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel
      cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA
      vg cv cgn cfv cfv vk vg cv cprd wceq wi wi vg cv cabl wcel cm1 vl cv cfz
      co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv
      cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv cfz co cm1 vl
      cv c1 caddc co cfz co ssralv cA vg cv crn wcel vk cm1 vl cv cfz co wral
      vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1
      vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi pm2.27 syl6 syl
      3adant3 sylbi com23 3imp1 vk vl cv c1 caddc co cA csb vg cv cgn cfv cfv
      vk vl cv c1 caddc co cA vg cv cgn cfv cfv csb wceq vl cv cm1 cuz cfv wcel
      cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz
      co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv
      cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co
      cfz co wral w3a vg cv cabl wcel wa vl cv c1 caddc co cvv wcel vk vl cv c1
      caddc co cA csb vg cv cgn cfv cfv vk vl cv c1 caddc co cA vg cv cgn cfv
      cfv csb wceq vl cv c1 caddc oprex vl cv c1 caddc co cvv wcel vk vl cv c1
      caddc co cA vg cv cgn cfv cfv csb vk vl cv c1 caddc co cA csb vg cv cgn
      cfv cfv vk vl cv c1 caddc co cA cvv vg cv cgn cfv csbfv2g eqcomd ax-mp
      a1i opreq12d eqtrd vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv
      cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn
      cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA
      vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral w3a vg cv cabl wcel
      wa cm1 vl cv cfz co cA vk vg cv cprd vk vl cv c1 caddc co cA csb vg cv co
      cm1 vl cv c1 caddc co cfz co cA vk vg cv cprd vg cv cgn cfv vl cv cm1 cuz
      cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl wcel cm1
      vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv
      cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral w3a vg cv cabl wcel wa cm1 vl cv c1 caddc co cfz co
      cA vk vg cv cprd cm1 vl cv cfz co cA vk vg cv cprd vk vl cv c1 caddc co
      cA csb vg cv co vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv c1
      caddc co cfz co wral cm1 vl cv c1 caddc co cfz co cA vk vg cv cprd cm1 vl
      cv cfz co cA vk vg cv cprd vk vl cv c1 caddc co cA csb vg cv co wceq vl
      cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl cv cfz co wral vg cv cabl
      wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv cgn cfv cfv cm1 vl cv cfz co
      cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cA vg cv crn wcel vk cm1 vl
      cv c1 caddc co cfz co wral w3a vg cv cabl wcel wa cA vg cv crn cvv vk vg
      cv cm1 vl cv vg visset fprodp1s vl cv cm1 cuz cfv wcel cA vg cv crn wcel
      vk cm1 vl cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv
      cprd vg cv cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv
      cprd wceq wi wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral vg
      cv cabl wcel 3simpl1 vl cv cm1 cuz cfv wcel cA vg cv crn wcel vk cm1 vl
      cv cfz co wral vg cv cabl wcel cm1 vl cv cfz co cA vk vg cv cprd vg cv
      cgn cfv cfv cm1 vl cv cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi
      wi cA vg cv crn wcel vk cm1 vl cv c1 caddc co cfz co wral vg cv cabl wcel
      3simpl3 sylanc eqcomd fveq2d 3eqtr2rd 3exp1 uzind4 3imp vtoclg 3ad2ant3
      pm2.43i syl6bi ax-mp adantl cN cG cgn cfv wceq cm1 cm2 cfz co cA vk cG
      cprd cN cfv cm1 cm2 cfz co cA vk cG cprd cG cgn cfv cfv wceq cm2 cm1 cuz
      cfv wcel cA cX wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cm1 cm2 cfz
      co cA vk cG cprd cN cG cgn cfv fveq1 adantr cm2 cm1 cuz cfv wcel cA cX
      wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cN cG cgn cfv wceq cm1 cm2
      cfz co cA cN cfv vk cG cprd cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd
      wceq cm2 cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co wral cG cabl wcel
      w3a cN cG cgn cfv wceq cm1 cm2 cfz co cA cN cfv vk cG cprd cm1 cm2 cfz co
      cA cG cgn cfv cfv vk cG cprd wceq wi cG cabl wcel cm2 cm1 cuz cfv wcel
      cm2 cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a
      cN cG cgn cfv wceq cm1 cm2 cfz co cA cN cfv vk cG cprd cm1 cm2 cfz co cA
      cG cgn cfv cfv vk cG cprd wceq wi wi cA cX wcel vk cm1 cm2 cfz co wral
      cm2 cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co wral vg cv cabl wcel
      w3a cN vg cv cgn cfv wceq cm1 cm2 cfz co cA cN cfv vk vg cv cprd cm1 cm2
      cfz co cA vg cv cgn cfv cfv vk vg cv cprd wceq wi wi cm2 cm1 cuz cfv wcel
      cA cX wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cN cG cgn cfv wceq cm1
      cm2 cfz co cA cN cfv vk cG cprd cm1 cm2 cfz co cA cG cgn cfv cfv vk cG
      cprd wceq wi wi vg cG cabl vg cv cG wceq cm2 cm1 cuz cfv wcel cA cX wcel
      vk cm1 cm2 cfz co wral vg cv cabl wcel w3a cm2 cm1 cuz cfv wcel cA cX
      wcel vk cm1 cm2 cfz co wral cG cabl wcel w3a cN vg cv cgn cfv wceq cm1
      cm2 cfz co cA cN cfv vk vg cv cprd cm1 cm2 cfz co cA vg cv cgn cfv cfv vk
      vg cv cprd wceq wi cN cG cgn cfv wceq cm1 cm2 cfz co cA cN cfv vk cG cprd
      cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd wceq wi vg cv cG wceq vg cv
      cabl wcel cG cabl wcel cm2 cm1 cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co
      wral vg cv cG cabl eleq1 3anbi3d vg cv cG wceq cN vg cv cgn cfv wceq cN
      cG cgn cfv wceq cm1 cm2 cfz co cA cN cfv vk vg cv cprd cm1 cm2 cfz co cA
      vg cv cgn cfv cfv vk vg cv cprd wceq cm1 cm2 cfz co cA cN cfv vk cG cprd
      cm1 cm2 cfz co cA cG cgn cfv cfv vk cG cprd wceq vg cv cG wceq vg cv cgn
      cfv cG cgn cfv cN vg cv cG cgn fveq2 eqeq2d vg cv cG wceq cm1 cm2 cfz co
      cA cN cfv vk vg cv cprd cm1 cm2 cfz co cA cN cfv vk cG cprd cm1 cm2 cfz
      co cA vg cv cgn cfv cfv vk vg cv cprd cm1 cm2 cfz co cA cG cgn cfv cfv vk
      cG cprd cm1 cm2 cfz co cA cN cfv vk vg cv cG prodeq3 vg cv cG wceq cm1
      cm2 cfz co cm1 cm2 cfz co cA vg cv cgn cfv cfv cA cG cgn cfv cfv vk cvv
      vg cv cG vg cv cG wceq cm1 cm2 cfz co eqidd vg cv cG wceq id vg cv cG
      wceq cA vg cv cgn cfv cfv cA cG cgn cfv cfv wceq vk cm1 cm2 cfz co vg cv
      cG wceq cA vg cv cgn cfv cfv cA cG cgn cfv cfv wceq vk cv cm1 cm2 cfz co
      wcel vg cv cG wceq cA vg cv cgn cfv cG cgn cfv vg cv cG cgn fveq2 fveq1d
      adantr r19.21aiva vg visset prodeq123d eqeq12d imbi12d imbi12d cm2 cm1
      cuz cfv wcel cA cX wcel vk cm1 cm2 cfz co wral vg cv cabl wcel w3a cN vg
      cv cgn cfv wceq cm1 cm2 cfz co cA cN cfv vk vg cv cprd cm1 cm2 cfz co cA
      vg cv cgn cfv cfv vk vg cv cprd wceq cm2 cm1 cuz cfv wcel cA cX wcel vk
      cm1 cm2 cfz co wral vg cv cabl wcel w3a cN vg cv cgn cfv wceq wa cm1 cm2
      cfz co cA cN cfv cA vg cv cgn cfv cfv vk cvv vg cv cN vg cv cgn cfv wceq
      cA cN cfv cA vg cv cgn cfv cfv wceq vk cm1 cm2 cfz co wral cm2 cm1 cuz
      cfv wcel cA cX wcel vk cm1 cm2 cfz co wral vg cv cabl wcel w3a cN vg cv
      cgn cfv wceq cA cN cfv cA vg cv cgn cfv cfv wceq vk cm1 cm2 cfz co cN vg
      cv cgn cfv wceq cA cN cfv cA vg cv cgn cfv cfv wceq vk cv cm1 cm2 cfz co
      wcel cA cN vg cv cgn cfv fveq1 adantr r19.21aiva adantl vg visset
      prodeq3d ex vtoclg 3ad2ant3 pm2.43i impcom 3eqtr4d mpan $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}


  ${
    $d A g $. $d B g $. $d D g k $. $d G g k $. $d M g k $. $d N g k $.
    $d X k $.
    fprodsub.1 $e |- X = ran G $.
    fprodsub.2 $e |- D = ( /g ` G ) $.
    $( The "difference" (or "quotient") of two finite composites. $)
    fprodsub $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
       ( A e. X /\ B e. X ) /\ G e. Abel ) ->
       prod_ k e. ( M ... N ) G ( A D B ) =
         ( prod_ k e. ( M ... N ) G A D prod_ k e. ( M ... N ) G B ) ) $=
      cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG cabl
      wcel w3a cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co cA vk cG cprd
      cM cN cfz co cB vk cG cprd cG cgn cfv cfv cG co cM cN cfz co cA vk cG
      cprd cM cN cfz co cB vk cG cprd cD co cN cM cuz cfv wcel cA cX wcel cB cX
      wcel wa vk cM cN cfz co wral cG cabl wcel w3a cM cN cfz co cA cB cD co vk
      cG cprd cM cN cfz co cA cB cG cgn cfv cfv cG co vk cG cprd cM cN cfz co
      cA vk cG cprd cM cN cfz co cB cG cgn cfv cfv vk cG cprd cG co cM cN cfz
      co cA vk cG cprd cM cN cfz co cB vk cG cprd cG cgn cfv cfv cG co cX cG
      crn wceq cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral
      cG cabl wcel w3a cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co cA cB
      cG cgn cfv cfv cG co vk cG cprd wceq wi fprodsub.1 cX cG crn wceq cN cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG cabl wcel
      w3a cN cM cuz cfv wcel cA cG crn wcel cB cG crn wcel wa vk cM cN cfz co
      wral cG cabl wcel w3a cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co cA
      cB cG cgn cfv cfv cG co vk cG cprd wceq cX cG crn wceq cA cX wcel cB cX
      wcel wa vk cM cN cfz co wral cA cG crn wcel cB cG crn wcel wa vk cM cN
      cfz co wral cN cM cuz cfv wcel cG cabl wcel cX cG crn wceq cA cX wcel cB
      cX wcel wa cA cG crn wcel cB cG crn wcel wa vk cM cN cfz co cX cG crn
      wceq cA cX wcel cA cG crn wcel cB cX wcel cB cG crn wcel cX cG crn cA
      eleq2 cX cG crn cB eleq2 anbi12d ralbidv 3anbi2d cN cM cuz cfv wcel cA cG
      crn wcel cB cG crn wcel wa vk cM cN cfz co wral cG cabl wcel w3a cD cG
      cgs cfv wceq cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co cA cB cG
      cgn cfv cfv cG co vk cG cprd wceq fprodsub.2 cN cM cuz cfv wcel cA cG crn
      wcel cB cG crn wcel wa vk cM cN cfz co wral cG cabl wcel cD cG cgs cfv
      wceq cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co cA cB cG cgn cfv
      cfv cG co vk cG cprd wceq wi cG cabl wcel cN cM cuz cfv wcel cA cG crn
      wcel cB cG crn wcel wa vk cM cN cfz co wral cD cG cgs cfv wceq cM cN cfz
      co cA cB cD co vk cG cprd cM cN cfz co cA cB cG cgn cfv cfv cG co vk cG
      cprd wceq wi cN cM cuz cfv wcel cA vg cv crn wcel cB vg cv crn wcel wa vk
      cM cN cfz co wral cD vg cv cgs cfv wceq cM cN cfz co cA cB cD co vk vg cv
      cprd cM cN cfz co cA cB vg cv cgn cfv cfv vg cv co vk vg cv cprd wceq wi
      wi wi cN cM cuz cfv wcel cA cG crn wcel cB cG crn wcel wa vk cM cN cfz co
      wral cD cG cgs cfv wceq cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co
      cA cB cG cgn cfv cfv cG co vk cG cprd wceq wi wi wi vg cG cabl vg cv cG
      wceq cA vg cv crn wcel cB vg cv crn wcel wa vk cM cN cfz co wral cD vg cv
      cgs cfv wceq cM cN cfz co cA cB cD co vk vg cv cprd cM cN cfz co cA cB vg
      cv cgn cfv cfv vg cv co vk vg cv cprd wceq wi wi cA cG crn wcel cB cG crn
      wcel wa vk cM cN cfz co wral cD cG cgs cfv wceq cM cN cfz co cA cB cD co
      vk cG cprd cM cN cfz co cA cB cG cgn cfv cfv cG co vk cG cprd wceq wi wi
      cN cM cuz cfv wcel vg cv cG wceq cA vg cv crn wcel cB vg cv crn wcel wa
      vk cM cN cfz co wral cA cG crn wcel cB cG crn wcel wa vk cM cN cfz co
      wral cD vg cv cgs cfv wceq cM cN cfz co cA cB cD co vk vg cv cprd cM cN
      cfz co cA cB vg cv cgn cfv cfv vg cv co vk vg cv cprd wceq wi cD cG cgs
      cfv wceq cM cN cfz co cA cB cD co vk cG cprd cM cN cfz co cA cB cG cgn
      cfv cfv cG co vk cG cprd wceq wi vg cv cG wceq cA vg cv crn wcel cB vg cv
      crn wcel wa cA cG crn wcel cB cG crn wcel wa vk cM cN cfz co vg cv cG
      wceq cA vg cv crn wcel cA cG crn wcel cB vg cv crn wcel cB cG crn wcel vg
      cv cG wceq vg cv crn cG crn cA vg cv cG rneq eleq2d vg cv cG wceq vg cv
      crn cG crn cB vg cv cG rneq eleq2d anbi12d ralbidv vg cv cG wceq cD vg cv
      cgs cfv wceq cD cG cgs cfv wceq cM cN cfz co cA cB cD co vk vg cv cprd cM
      cN cfz co cA cB vg cv cgn cfv cfv vg cv co vk vg cv cprd wceq cM cN cfz
      co cA cB cD co vk cG cprd cM cN cfz co cA cB cG cgn cfv cfv cG co vk cG
      cprd wceq vg cv cG wceq vg cv cgs cfv cG cgs cfv cD vg cv cG cgs fveq2
      eqeq2d vg cv cG wceq cM cN cfz co cA cB cD co vk vg cv cprd cM cN cfz co
      cA cB cD co vk cG cprd cM cN cfz co cA cB vg cv cgn cfv cfv vg cv co vk
      vg cv cprd cM cN cfz co cA cB cG cgn cfv cfv cG co vk cG cprd cM cN cfz
      co cA cB cD co vk vg cv cG prodeq3 vg cv cG wceq cM cN cfz co cM cN cfz
      co cA cB vg cv cgn cfv cfv vg cv co cA cB cG cgn cfv cfv cG co vk cvv vg
      cv cG vg cv cG wceq cM cN cfz co eqidd vg cv cG wceq id vg cv cG wceq cA
      cB vg cv cgn cfv cfv vg cv co cA cB cG cgn cfv cfv cG co wceq vk cM cN
      cfz co vg cv cG wceq cA cB vg cv cgn cfv cfv vg cv co cA cB cG cgn cfv
      cfv cG co wceq vk cv cM cN cfz co wcel vg cv cG wceq cA cA cB vg cv cgn
      cfv cfv cB cG cgn cfv cfv vg cv cG vg cv cG wceq id vg cv cG wceq cA
      eqidd vg cv cG wceq cB vg cv cgn cfv cG cgn cfv vg cv cG cgn fveq2 fveq1d
      opreq123d adantr r19.21aiva vg visset prodeq123d eqeq12d imbi12d imbi12d
      imbi2d cN cM cuz cfv wcel cA vg cv crn wcel cB vg cv crn wcel wa vk cM cN
      cfz co wral vg cv cabl wcel cD vg cv cgs cfv wceq cM cN cfz co cA cB cD
      co vk vg cv cprd cM cN cfz co cA cB vg cv cgn cfv cfv vg cv co vk vg cv
      cprd wceq wi cN cM cuz cfv wcel cA vg cv crn wcel cB vg cv crn wcel wa vk
      cM cN cfz co wral vg cv cabl wcel cD vg cv cgs cfv wceq cM cN cfz co cA
      cB cD co vk vg cv cprd cM cN cfz co cA cB vg cv cgn cfv cfv vg cv co vk
      vg cv cprd wceq cN cM cuz cfv wcel cA vg cv crn wcel cB vg cv crn wcel wa
      vk cM cN cfz co wral vg cv cabl wcel w3a cD vg cv cgs cfv wceq wa cM cN
      cfz co cA cB cD co cA cB vg cv cgn cfv cfv vg cv co vk cvv vg cv cN cM
      cuz cfv wcel cA vg cv crn wcel cB vg cv crn wcel wa vk cM cN cfz co wral
      vg cv cabl wcel w3a cD vg cv cgs cfv wceq cA cB cD co cA cB vg cv cgn cfv
      cfv vg cv co wceq vk cM cN cfz co wral cD vg cv cgs cfv wceq cA cB cD co
      cA cB vg cv cgn cfv cfv vg cv co wceq vk cM cN cfz co wral cA cB vg cv
      cgs cfv co cA cB vg cv cgn cfv cfv vg cv co wceq vk cM cN cfz co wral cN
      cM cuz cfv wcel cA vg cv crn wcel cB vg cv crn wcel wa vk cM cN cfz co
      wral vg cv cabl wcel w3a cD vg cv cgs cfv wceq cA cB cD co cA cB vg cv
      cgn cfv cfv vg cv co wceq cA cB vg cv cgs cfv co cA cB vg cv cgn cfv cfv
      vg cv co wceq vk cM cN cfz co cD vg cv cgs cfv wceq cA cB cD co cA cB vg
      cv cgs cfv co cA cB vg cv cgn cfv cfv vg cv co cA cB cD vg cv cgs cfv
      opreq eqeq1d ralbidv cN cM cuz cfv wcel cA vg cv crn wcel cB vg cv crn
      wcel wa vk cM cN cfz co wral vg cv cabl wcel cA cB vg cv cgs cfv co cA cB
      vg cv cgn cfv cfv vg cv co wceq vk cM cN cfz co wral cN cM cuz cfv wcel
      vg cv cabl wcel cA vg cv crn wcel cB vg cv crn wcel wa vk cM cN cfz co
      wral cA cB vg cv cgs cfv co cA cB vg cv cgn cfv cfv vg cv co wceq vk cM
      cN cfz co wral cN cM cuz cfv wcel vg cv cabl wcel cA vg cv crn wcel cB vg
      cv crn wcel wa vk cM cN cfz co wral cA cB vg cv cgs cfv co cA cB vg cv
      cgn cfv cfv vg cv co wceq vk cM cN cfz co wral wi cN cM cuz cfv wcel vg
      cv cabl wcel wa cA vg cv crn wcel cB vg cv crn wcel wa cA cB vg cv cgs
      cfv co cA cB vg cv cgn cfv cfv vg cv co wceq vk cM cN cfz co cN cM cuz
      cfv wcel vg cv cabl wcel wa cA vg cv crn wcel cB vg cv crn wcel wa cA cB
      vg cv cgs cfv co cA cB vg cv cgn cfv cfv vg cv co wceq vg cv cabl wcel cA
      vg cv crn wcel cB vg cv crn wcel cA cB vg cv cgs cfv co cA cB vg cv cgn
      cfv cfv vg cv co wceq cN cM cuz cfv wcel vg cv cabl wcel wa cA vg cv crn
      wcel cB vg cv crn wcel wa wa vg cv cgr wcel cA vg cv crn wcel cB vg cv
      crn wcel cA cB vg cv cgs cfv co cA cB vg cv cgn cfv cfv vg cv co wceq vg
      cv cabl wcel cA cB vg cv cgs cfv vg cv vg cv cgn cfv vg cv crn vg cv crn
      eqid vg cv cgn cfv eqid vg cv cgs cfv eqid grpdivval vg cv ablgrp syl3an1
      cN cM cuz cfv wcel vg cv cabl wcel cA vg cv crn wcel cB vg cv crn wcel wa
      simplr cN cM cuz cfv wcel vg cv cabl wcel wa cA vg cv crn wcel cB vg cv
      crn wcel simprl cN cM cuz cfv wcel vg cv cabl wcel wa cA vg cv crn wcel
      cB vg cv crn wcel simprr syl3anc ex r19.20sdv ex com23 3imp syl5cbir imp
      vg visset prodeq3d 3exp1 com3r vtoclga com3l 3imp mpi syl6bi ax-mp cN cM
      cuz cfv wcel cA cG cdm cdm wcel cB cG cgn cfv cfv cG cdm cdm wcel wa vk
      cM cN cfz co wral cG csem ccm1 cin wcel cM cN cfz co cA cB cG cgn cfv cfv
      cG co vk cG cprd cM cN cfz co cA vk cG cprd cM cN cfz co cB cG cgn cfv
      cfv vk cG cprd cG co wceq cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk
      cM cN cfz co wral cG cabl wcel w3a cA cB cG cgn cfv cfv vk cG cM cN cG
      cdm cdm cG cdm cdm eqid fprodadd cN cM cuz cfv wcel cA cX wcel cB cX wcel
      wa vk cM cN cfz co wral cG cabl wcel 3simp1 cA cX wcel cB cX wcel wa vk
      cM cN cfz co wral cG cabl wcel cA cG cdm cdm wcel cB cG cgn cfv cfv cG
      cdm cdm wcel wa vk cM cN cfz co wral cN cM cuz cfv wcel cG cabl wcel cA
      cX wcel cB cX wcel wa vk cM cN cfz co wral cA cG cdm cdm wcel cB cG cgn
      cfv cfv cG cdm cdm wcel wa vk cM cN cfz co wral cG cabl wcel cA cX wcel
      cB cX wcel wa cA cG cdm cdm wcel cB cG cgn cfv cfv cG cdm cdm wcel wa vk
      cM cN cfz co cG cabl wcel cA cX wcel cA cG cdm cdm wcel cB cX wcel cB cG
      cgn cfv cfv cG cdm cdm wcel cG cabl wcel cA cX wcel cA cG cdm cdm wcel cG
      cabl wcel cX cG cdm cdm cA cG cabl wcel cG cgr wcel cX cG cdm cdm wceq cG
      ablgrp cG cgr wcel cG crn cG cdm cdm cX cG grprndm fprodsub.1 syl5eq syl
      eleq2d biimpd cG cabl wcel cG cgr wcel cB cX wcel cB cG cgn cfv cfv cG
      cdm cdm wcel wi cG ablgrp cG cgr wcel cB cX wcel cB cG cgn cfv cfv cG cdm
      cdm wcel cG cgr wcel cB cX wcel wa cB cG cgn cfv cfv cX cG cdm cdm cB cG
      cG cgn cfv cX fprodsub.1 cG cgn cfv eqid grpinvcl cG cgr wcel cX cG cdm
      cdm wceq cB cX wcel cG cgr wcel cG crn cG cdm cdm cX cG grprndm
      fprodsub.1 syl5eq adantr eleqtrd ex syl anim12d r19.20sdv impcom 3adant1
      cG cabl wcel cN cM cuz cfv wcel cG csem ccm1 cin wcel cA cX wcel cB cX
      wcel wa vk cM cN cfz co wral cG cabl wcel cG cgr ccm1 cin wcel cG csem
      ccm1 cin wcel cG ablcomgrp cG cgr wcel cG ccm1 wcel wa cG csem wcel cG
      ccm1 wcel wa cG cgr ccm1 cin wcel cG csem ccm1 cin wcel cG cgr wcel cG
      csem wcel cG ccm1 wcel cG cgr wcel cG cmnd wcel cG csem wcel cG grpmnd cG
      mndissmgrp syl anim1i cG cgr ccm1 elin cG csem ccm1 elin 3imtr4i syl
      3ad2ant3 syl3anc cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz
      co wral cG cabl wcel w3a cM cN cfz co cB cG cgn cfv cfv vk cG cprd cM cN
      cfz co cB vk cG cprd cG cgn cfv cfv cM cN cfz co cA vk cG cprd cG cN cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG cabl wcel
      w3a cM cN cfz co cB vk cG cprd cG cgn cfv cfv cM cN cfz co cB cG cgn cfv
      cfv vk cG cprd cN cM cuz cfv wcel cB cX wcel vk cM cN cfz co wral cG cabl
      wcel cM cN cfz co cB vk cG cprd cG cgn cfv cfv cM cN cfz co cB cG cgn cfv
      cfv vk cG cprd wceq cA cX wcel cB cX wcel wa vk cM cN cfz co wral cB vk
      cG cG cgn cfv cX cM cN fprodsub.1 cG cgn cfv eqid fprodneg cA cX wcel cB
      cX wcel wa cB cX wcel vk cM cN cfz co cA cX wcel cB cX wcel pm3.27
      r19.20si syl3an2 eqcomd opreq2d 3eqtrd cG cabl wcel cM cN cfz co cA vk cG
      cprd cX wcel cM cN cfz co cB vk cG cprd cX wcel cM cN cfz co cA vk cG
      cprd cM cN cfz co cB vk cG cprd cD co cM cN cfz co cA vk cG cprd cM cN
      cfz co cB vk cG cprd cG cgn cfv cfv cG co wceq cN cM cuz cfv wcel cA cX
      wcel cB cX wcel wa vk cM cN cfz co wral cG cabl wcel w3a cG cgr wcel cM
      cN cfz co cA vk cG cprd cX wcel cM cN cfz co cB vk cG cprd cX wcel cM cN
      cfz co cA vk cG cprd cM cN cfz co cB vk cG cprd cD co cM cN cfz co cA vk
      cG cprd cM cN cfz co cB vk cG cprd cG cgn cfv cfv cG co wceq cG cabl wcel
      cM cN cfz co cA vk cG cprd cM cN cfz co cB vk cG cprd cD cG cG cgn cfv cX
      fprodsub.1 cG cgn cfv eqid fprodsub.2 grpdivval cG ablgrp syl3an1 cN cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG cabl wcel
      3simp3 cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz
      co wral cM cN cfz co cA vk cG cprd cX wcel cN cM cuz cfv wcel cA cX wcel
      cB cX wcel wa vk cM cN cfz co wral cG cabl wcel w3a cA vk cG cM cN cX
      fprodsub.1 clfsebsr cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN
      cfz co wral cG cabl wcel 3simp1 cG cabl wcel cN cM cuz cfv wcel cG cmagm
      cexid cin wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG cabl wcel
      cG cmnd wcel cG cmagm cexid cin wcel cG cabl wcel cG cgr wcel cG cmnd
      wcel cG ablgrp cG grpmnd syl cG mndmgmid syl 3ad2ant3 cA cX wcel cB cX
      wcel wa vk cM cN cfz co wral cN cM cuz cfv wcel cA cX wcel vk cM cN cfz
      co wral cG cabl wcel cA cX wcel cB cX wcel wa cA cX wcel vk cM cN cfz co
      cA cX wcel cB cX wcel pm3.26 r19.20si 3ad2ant2 syl3anc cN cM cuz cfv wcel
      cG cmagm cexid cin wcel cB cX wcel vk cM cN cfz co wral cM cN cfz co cB
      vk cG cprd cX wcel cN cM cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN
      cfz co wral cG cabl wcel w3a cB vk cG cM cN cX fprodsub.1 clfsebsr cN cM
      cuz cfv wcel cA cX wcel cB cX wcel wa vk cM cN cfz co wral cG cabl wcel
      3simp1 cG cabl wcel cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel
      cB cX wcel wa vk cM cN cfz co wral cG cabl wcel cG cmnd wcel cG cmagm
      cexid cin wcel cG cabl wcel cG cgr wcel cG cmnd wcel cG ablgrp cG grpmnd
      syl cG mndmgmid syl 3ad2ant3 cA cX wcel cB cX wcel wa vk cM cN cfz co
      wral cN cM cuz cfv wcel cB cX wcel vk cM cN cfz co wral cG cabl wcel cA
      cX wcel cB cX wcel wa cB cX wcel vk cM cN cfz co cA cX wcel cB cX wcel
      pm3.27 r19.20si 3ad2ant2 syl3anc syl3anc eqtr4d $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    clfsebs3.1 $e |- X = ran G $.
    ${
      $d G k $. $d M k $. $d N k $. $d X k $.
      $( Closure of a finite composite of elements of the base set of an
         internal operation. (When the operation is a monoid.) $)
      clfsebs3 $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Mnd /\
                      A. k e. ( M ... N ) A e. X )
       -> prod_ k e. ( M ... N ) G A e. X ) $=
        cN cM cuz cfv wcel cG cmagm cexid cin wcel cA cX wcel vk cM cN cfz co
        wral cM cN cfz co cA vk cG cprd cX wcel cG cmnd wcel cA vk cG cM cN cX
        clfsebs3.1 clfsebs2 cG mndmgmid syl3an2 $.
        $( [6-Dec-2010] $) $( [22-Nov-2010] $)
    $}

    ${
      $d G k $. $d M k $. $d N k $. $d X k $.
      $( Closure of a finite composite of elements of the base set of an
         internal operation. (When the operation is a group.) $)
      clfsebs4 $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Grp /\
                      A. k e. ( M ... N ) A e. X )
       -> prod_ k e. ( M ... N ) G A e. X ) $=
        cN cM cuz cfv wcel cG cmnd wcel cA cX wcel vk cM cN cfz co wral cM cN
        cfz co cA vk cG cprd cX wcel cG cgr wcel cA vk cG cM cN cX clfsebs3.1
        clfsebs3 cG grpmnd syl3an2 $.
        $( [6-Dec-2010] $) $( [22-Nov-2010] $)
    $}

    ${
      $d G k $. $d M k $. $d N k $. $d X k $.
      $( Closure of a finite composite of elements of the base set of an
         internal operation. (When the operation is an abelian group.) $)
      clfsebs5 $p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Abel /\
                      A. k e. ( M ... N ) A e. X )
       -> prod_ k e. ( M ... N ) G A e. X ) $=
        cN cM cuz cfv wcel cG cgr wcel cA cX wcel vk cM cN cfz co wral cM cN
        cfz co cA vk cG cprd cX wcel cG cabl wcel cA vk cG cM cN cX clfsebs3.1
        clfsebs4 cG ablgrp syl3an2 $.
        $( [6-Dec-2010] $) $( [22-Nov-2010] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Translations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    trfun.2 $e |- F = ( x e. X |-> ( x G A ) ) $.
    trinv.1 $e |- X = ran G $.
    ${
      $d A x $. $d G x $. $d X x $.
      $( The domain of a right translation. $)
      trdom2 $p |- ( ( G e. Grp /\ A e. X ) -> dom F = X ) $=
        cG cgr wcel cA cX wcel wa vx cv cA cG co cvv wcel vx cX wral cF cdm cX
        wceq cG cgr wcel cA cX wcel wa vx cv cA cG co cvv wcel vx cX vx cv cA
        cG co cvv wcel cG cgr wcel cA cX wcel wa vx cv cX wcel wa vx cv cA cG
        oprex a1i r19.21aiva vx cX vx cv cA cG co cF trfun.2 cmpdom sylib $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d X x $.
      $( A right translation is a set. $)
      trset $p |- ( G e. Grp -> F e. _V ) $=
        cF wfun cF cdm cvv wcel cF cvv wcel cG cgr wcel cvv cF funex vx cX vx
        cv cA cG co cF trfun.2 cmpfun cG cgr wcel cX cvv cF cdm cG cX trinv.1
        unsgrp vx cX vx cv cA cF cG trfun.2 cmpdom2 syl5eqel sylancr $.
        $( [20-Sep-2010] $) $( [19-Sep-2010] $)
    $}

    ${
      $d A x y $. $d G x y $. $d X x y $.
      $( The range of a right translation. $)
      trran2 $p |- ( ( G e. Grp /\ A e. X ) -> ran F = X ) $=
        cG cgr wcel cA cX wcel wa vy cv vx cv cA cG co wceq vx cX wrex vy cab
        cX cF crn cG cgr wcel cA cX wcel wa vy cv vx cv cA cG co wceq vx cX
        wrex vy cX cG cgr wcel cA cX wcel wa vy cv vx cv cA cG co wceq vx cX
        wrex vy cv cX wcel cG cgr wcel cA cX wcel wa vy cv vx cv cA cG co wceq
        vy cv cX wcel vx cX vx cv cX wcel cG cgr wcel cA cX wcel wa vy cv vx cv
        cA cG co wceq vy cv cX wcel wi vy cv vx cv cA cG co wceq vy cv cX wcel
        vx cv cA cG co cX wcel vx cv cX wcel cG cgr wcel cA cX wcel wa wa vy cv
        vx cv cA cG co cX eleq1 cG cgr wcel cA cX wcel wa vx cv cX wcel vx cv
        cA cG co cX wcel cG cgr wcel cA cX wcel vx cv cX wcel vx cv cA cG co cX
        wcel wi cG cgr wcel vx cv cX wcel cA cX wcel vx cv cA cG co cX wcel cG
        cgr wcel vx cv cX wcel cA cX wcel vx cv cA cG co cX wcel vx cv cA cG cX
        trinv.1 grpcl 3exp com23 imp impcom syl5cbir expcom r19.23adv cG cgr
        wcel cA cX wcel wa vy cv cX wcel vy cv vx cv cA cG co wceq vx cX wrex
        vy cv cA cG cgn cfv cfv cG co cX wcel vy cv vy cv cA cG cgn cfv cfv cG
        co cA cG co wceq vy cv vx cv cA cG co wceq vx cX wrex cG cgr wcel cA cX
        wcel wa vy cv cX wcel wa vy cv vx cv cA cG co wceq vy cv vy cv cA cG
        cgn cfv cfv cG co cA cG co wceq vx vy cv cA cG cgn cfv cfv cG co cX vx
        cv vy cv cA cG cgn cfv cfv cG co wceq vx cv cA cG co vy cv cA cG cgn
        cfv cfv cG co cA cG co vy cv vx cv vy cv cA cG cgn cfv cfv cG co cA cG
        opreq1 eqeq2d rcla4ev cG cgr wcel vy cv cX wcel cA cG cgn cfv cfv cX
        wcel vy cv cA cG cgn cfv cfv cG co cX wcel cG cgr wcel cA cX wcel wa vy
        cv cX wcel wa vy cv cA cG cgn cfv cfv cG cX trinv.1 grpcl cG cgr wcel
        cA cX wcel vy cv cX wcel simpll cG cgr wcel cA cX wcel wa vy cv cX wcel
        pm3.27 cG cgr wcel cA cX wcel wa cA cG cgn cfv cfv cX wcel vy cv cX
        wcel cA cG cG cgn cfv cX trinv.1 cG cgn cfv eqid grpinvcl adantr
        syl3anc cG cgr wcel cA cX wcel wa vy cv cX wcel wa vy cv cG cgi cfv cG
        co vy cv cA cG cgn cfv cfv cA cG co cG co vy cv vy cv cA cG cgn cfv cfv
        cG co cA cG co cG cgr wcel cA cX wcel wa vy cv cX wcel wa cG cgi cfv cA
        cG cgn cfv cfv cA cG co vy cv cG cG cgr wcel cA cX wcel wa vy cv cX
        wcel wa cA cG cgn cfv cfv cA cG co cG cgi cfv cG cgr wcel cA cX wcel wa
        cA cG cgn cfv cfv cA cG co cG cgi cfv wceq vy cv cX wcel cA cG cgi cfv
        cG cG cgn cfv cX trinv.1 cG cgi cfv eqid cG cgn cfv eqid grplinv adantr
        eqcomd opreq2d cG cgr wcel vy cv cX wcel vy cv vy cv cG cgi cfv cG co
        wceq cA cX wcel cG cgr wcel vy cv cX wcel wa vy cv cG cgi cfv cG co vy
        cv vy cv cG cgi cfv cG cX trinv.1 cG cgi cfv eqid grprid eqcomd adantlr
        cG cgr wcel vy cv cX wcel cA cG cgn cfv cfv cX wcel cA cX wcel w3a vy
        cv cA cG cgn cfv cfv cG co cA cG co vy cv cA cG cgn cfv cfv cA cG co cG
        co wceq cG cgr wcel cA cX wcel wa vy cv cX wcel wa vy cv cA cG cgn cfv
        cfv cA cG cX trinv.1 grpass cG cgr wcel cA cX wcel vy cv cX wcel simpll
        cG cgr wcel cA cX wcel wa vy cv cX wcel wa vy cv cX wcel cA cG cgn cfv
        cfv cX wcel cA cX wcel cG cgr wcel cA cX wcel wa vy cv cX wcel pm3.27
        cG cgr wcel cA cX wcel wa cA cG cgn cfv cfv cX wcel vy cv cX wcel cA cG
        cG cgn cfv cX trinv.1 cG cgn cfv eqid grpinvcl adantr cG cgr wcel cA cX
        wcel vy cv cX wcel simplr 3jca sylanc 3eqtr4d sylanc ex impbid abbi1dv
        vx vy cX vx cv cA cG co cF trfun.2 cmpran syl5eq $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d A x y z $. $d G x y z $. $d X x y z $.
      $( A right translation is a bijection. $)
      trooo $p |- ( ( G e. Grp /\ A e. X ) -> F : X -1-1-onto-> X ) $=
        cG cgr wcel cA cX wcel wa cF cX wfn cF crn cX wceq vx cv cF cfv vy cv
        cF cfv wceq vx vy weq wi vy cX wral vx cX wral w3a cX cX cF wf1o cG cgr
        wcel cA cX wcel wa cF cX wfn cF crn cX wceq vx cv cF cfv vy cv cF cfv
        wceq vx vy weq wi vy cX wral vx cX wral cG cgr wcel cA cX wcel wa vx cv
        cA cG co cvv wcel vx cX wral cF cX wfn vx cv cA cG co cvv wcel vx cX vx
        cv cA cG co cvv wcel vx cv cX wcel vx cv cA cG oprex a1i rgen vx cv cA
        cG co cvv wcel vx cX wral cF cX wfn wb cG cgr wcel cA cX wcel wa vx cX
        vx cv cA cG co cF trfun.2 fopab2ga a1i mpbii vx cA cF cG cX trfun.2
        trinv.1 trran2 cG cgr wcel cA cX wcel wa vx cv cF cfv vy cv cF cfv wceq
        vx vy weq wi vx vy cX cX cG cgr wcel cA cX wcel wa vx cv cX wcel vy cv
        cX wcel wa vx cv cF cfv vy cv cF cfv wceq vx vy weq wi cG cgr wcel cA
        cX wcel wa vx cv cX wcel vy cv cX wcel wa wa vx cv cF cfv vy cv cF cfv
        wceq vx cv cA cG co vy cv cA cG co wceq vx vy weq cG cgr wcel cA cX
        wcel wa vx cv cX wcel vy cv cX wcel wa wa vx cv cF cfv vy cv cF cfv
        wceq vx cv cA cG co vy cv cA cG co wceq cG cgr wcel cA cX wcel wa vx cv
        cX wcel vy cv cX wcel wa wa vx cv cF cfv vx cv cA cG co vy cv cF cfv vy
        cv cA cG co vx cv cX wcel vx cv cF cfv vx cv cA cG co wceq cG cgr wcel
        cA cX wcel wa vy cv cX wcel vx cv cX wcel vx cv cA cG co cvv wcel vx cv
        cF cfv vx cv cA cG co wceq vx cv cA cG oprex vx cX vx cv cA cG co cvv
        cF trfun.2 fvopab2b mpan2 ad2antrl cG cgr wcel cA cX wcel wa vx cv cX
        wcel vy cv cX wcel wa wa vy cv cX wcel vy cv cA cG co cvv wcel wa vy cv
        cF cfv vy cv cA cG co wceq vx cv cX wcel vy cv cX wcel wa vy cv cX wcel
        vy cv cA cG co cvv wcel wa cG cgr wcel cA cX wcel wa vx cv cX wcel vy
        cv cX wcel wa vy cv cX wcel vy cv cA cG co cvv wcel vx cv cX wcel vy cv
        cX wcel pm3.27 vy cv cA cG oprex jctir adantl vx vy cv vx cv cA cG co
        vy cv cA cG co cX cvv cF vx cv vy cv cA cG opreq1 trfun.2 mptg syl
        eqeq12d biimpd cG cgr wcel cA cX wcel vx cv cX wcel vy cv cX wcel wa vx
        cv cA cG co vy cv cA cG co wceq vx vy weq wb cG cgr wcel vx cv cX wcel
        vy cv cX wcel wa cA cX wcel vx cv cA cG co vy cv cA cG co wceq vx vy
        weq wb cG cgr wcel vx cv cX wcel vy cv cX wcel cA cX wcel vx cv cA cG
        co vy cv cA cG co wceq vx vy weq wb wi cG cgr wcel vx cv cX wcel vy cv
        cX wcel cA cX wcel vx cv cA cG co vy cv cA cG co wceq vx vy weq wb vx
        cv vy cv cA cG cX trinv.1 grprcan 3exp2 imp3a com23 imp31 sylibd ex
        r19.21aivv 3jca cX cX vx cX vx cv cA cG co cmpt wf1o vx cX vx cv cA cG
        co cmpt cX wfn vx cX vx cv cA cG co cmpt crn cX wceq vx cv vx cX vx cv
        cA cG co cmpt cfv vy cv vx cX vx cv cA cG co cmpt cfv wceq vx vy weq wi
        vy cX wral vx cX wral w3a cX cX cF wf1o cF cX wfn cF crn cX wceq vx cv
        cF cfv vy cv cF cfv wceq vx vy weq wi vy cX wral vx cX wral w3a vx vy
        vz cX cX vx cX vx cv cA cG co cmpt vx vz cX vx cv cA cG co hbcmpt vz cv
        vx cX vx cv cA cG co cmpt wcel vy ax-17 dff1o6f cF vx cX vx cv cA cG co
        cmpt wceq cX cX cF wf1o cX cX vx cX vx cv cA cG co cmpt wf1o wb trfun.2
        cX cX cF vx cX vx cv cA cG co cmpt f1oeq1 ax-mp cF cX wfn vx cX vx cv
        cA cG co cmpt cX wfn cF crn cX wceq vx cX vx cv cA cG co cmpt crn cX
        wceq vx cv cF cfv vy cv cF cfv wceq vx vy weq wi vy cX wral vx cX wral
        vx cv vx cX vx cv cA cG co cmpt cfv vy cv vx cX vx cv cA cG co cmpt cfv
        wceq vx vy weq wi vy cX wral vx cX wral cF vx cX vx cv cA cG co cmpt
        wceq cF cX wfn vx cX vx cv cA cG co cmpt cX wfn wb trfun.2 cX cF vx cX
        vx cv cA cG co cmpt fneq1 ax-mp cF crn vx cX vx cv cA cG co cmpt crn cX
        cF vx cX vx cv cA cG co cmpt trfun.2 rneqi eqeq1i vx cv cF cfv vy cv cF
        cfv wceq vx vy weq wi vx cv vx cX vx cv cA cG co cmpt cfv vy cv vx cX
        vx cv cA cG co cmpt cfv wceq vx vy weq wi vx vy cX cX vx cv cF cfv vy
        cv cF cfv wceq vx cv vx cX vx cv cA cG co cmpt cfv vy cv vx cX vx cv cA
        cG co cmpt cfv wceq vx vy weq vx cv cF cfv vx cv vx cX vx cv cA cG co
        cmpt cfv vy cv cF cfv vy cv vx cX vx cv cA cG co cmpt cfv vx cv cF vx
        cX vx cv cA cG co cmpt trfun.2 fveq1i vy cv cF vx cX vx cv cA cG co
        cmpt trfun.2 fveq1i eqeq12i imbi1i 2ralbii 3anbi123i 3bitr4i sylibr $.
        $( [31-Dec-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d A x y $. $d A x z $. $d D y $. $d D z $. $d G x y $. $d G x z $.
      $d X x y $. $d X x z $.
      trinv.2 $e |- D = ( /g ` G ) $.
      $( The converse of a right translation. $)
      trinv $p |- ( ( G e. Grp /\ A e. X )
          -> `' F = ( x e. X |-> ( x D A ) ) ) $=
        cG cgr wcel cA cX wcel wa cF ccnv vx cX vx cv cA cD co cmpt wceq vx cv
        cF ccnv cfv vx cv vx cX vx cv cA cD co cmpt cfv wceq vx cX wral cG cgr
        wcel cA cX wcel wa vx cv cF ccnv cfv vx cv vx cX vx cv cA cD co cmpt
        cfv wceq vx cX cG cgr wcel cA cX wcel wa vx cv cX wcel wa vx cv cF ccnv
        cfv vx cv cA cD co vx cv vx cX vx cv cA cD co cmpt cfv cX cX cF wf1o vx
        cv cA cD co cX wcel wa vx cv cA cD co cF cfv vx cv wceq vx cv cF ccnv
        cfv vx cv cA cD co wceq cG cgr wcel cA cX wcel wa vx cv cX wcel wa cX
        cX vx cv cA cD co vx cv cF f1ocnvfv cG cgr wcel cA cX wcel wa vx cv cX
        wcel wa cX cX cF wf1o vx cv cA cD co cX wcel cG cgr wcel cA cX wcel wa
        cX cX cF wf1o vx cv cX wcel vx cA cF cG cX trfun.2 trinv.1 trooo adantr
        cG cgr wcel cA cX wcel vx cv cX wcel vx cv cA cD co cX wcel cG cgr wcel
        vx cv cX wcel cA cX wcel vx cv cA cD co cX wcel cG cgr wcel vx cv cX
        wcel cA cX wcel vx cv cA cD co cX wcel vx cv cA cD cG cX trinv.1
        trinv.2 grpdivcl 3exp com23 imp31 jca cG cgr wcel cA cX wcel wa vx cv
        cX wcel wa vx cv cA cD co cF cfv vx cv cA cD co cA cG co vx cv vx cv cA
        cD co cX wcel vx cv cA cD co cA cG co cvv wcel vx cv cA cD co cF cfv vx
        cv cA cD co cA cG co wceq cG cgr wcel cA cX wcel wa vx cv cX wcel wa vy
        vx cv cA cD co vy cv cA cG co vx cv cA cD co cA cG co cX cvv cF vy cv
        vx cv cA cD co cA cG opreq1 vx vy cX vx cv cA cG co vy cv cA cG co cF
        trfun.2 vx cv vy cv cA cG opreq1 cmpbvb mptg cG cgr wcel cA cX wcel vx
        cv cX wcel vx cv cA cD co cX wcel cG cgr wcel vx cv cX wcel cA cX wcel
        vx cv cA cD co cX wcel cG cgr wcel vx cv cX wcel cA cX wcel vx cv cA cD
        co cX wcel vx cv cA cD cG cX trinv.1 trinv.2 grpdivcl 3exp com23 imp31
        vx cv cA cD co cA cG oprex sylancl cG cgr wcel cA cX wcel vx cv cX wcel
        vx cv cA cD co cA cG co vx cv wceq cG cgr wcel vx cv cX wcel cA cX wcel
        vx cv cA cD co cA cG co vx cv wceq cG cgr wcel vx cv cX wcel cA cX wcel
        vx cv cA cD co cA cG co vx cv wceq vx cv cA cD cG cX trinv.1 trinv.2
        grpnpcan 3exp com23 imp31 eqtrd sylc vx cv cX wcel vx cv cA cD co cvv
        wcel vx cv vx cX vx cv cA cD co cmpt cfv vx cv cA cD co wceq cG cgr
        wcel cA cX wcel wa vx cv cX wcel wa vx cX vx cv cA cD co cvv vx cX vx
        cv cA cD co cmpt vx cX vx cv cA cD co cmpt eqid fvopab2b cG cgr wcel cA
        cX wcel wa vx cv cX wcel pm3.27 vx cv cA cD oprex sylancl eqtr4d
        r19.21aiva cF ccnv cX wfn vx cX vx cv cA cD co cmpt cX wfn cF ccnv vx
        cX vx cv cA cD co cmpt wceq vx cv cF ccnv cfv vx cv vx cX vx cv cA cD
        co cmpt cfv wceq vx cX wral wb cG cgr wcel cA cX wcel wa vx cX vx cv cA
        cG co cmpt ccnv cX wfn vx cX vx cv cA cD co cmpt cX wfn wa vx cX vx cv
        cA cG co cmpt ccnv vx cX vx cv cA cD co cmpt wceq vx cv vx cX vx cv cA
        cG co cmpt ccnv cfv vx cv vx cX vx cv cA cD co cmpt cfv wceq vx cX wral
        wb cF ccnv cX wfn vx cX vx cv cA cD co cmpt cX wfn wa cF ccnv vx cX vx
        cv cA cD co cmpt wceq vx cv cF ccnv cfv vx cv vx cX vx cv cA cD co cmpt
        cfv wceq vx cX wral wb vx vz cX vx cX vx cv cA cG co cmpt ccnv vx cX vx
        cv cA cD co cmpt vx vz vx cX vx cv cA cG co cmpt vx vz cX vx cv cA cG
        co hbcmpt hbcnv vx vz cX vx cv cA cD co hbcmpt eqfnfvf2 cF ccnv cX wfn
        vx cX vx cv cA cG co cmpt ccnv cX wfn vx cX vx cv cA cD co cmpt cX wfn
        cF ccnv vx cX vx cv cA cG co cmpt ccnv wceq cF ccnv cX wfn vx cX vx cv
        cA cG co cmpt ccnv cX wfn wb cF vx cX vx cv cA cG co cmpt trfun.2
        cnveqi cX cF ccnv vx cX vx cv cA cG co cmpt ccnv fneq1 ax-mp anbi1i cF
        ccnv vx cX vx cv cA cD co cmpt wceq vx cX vx cv cA cG co cmpt ccnv vx
        cX vx cv cA cD co cmpt wceq vx cv cF ccnv cfv vx cv vx cX vx cv cA cD
        co cmpt cfv wceq vx cX wral vx cv vx cX vx cv cA cG co cmpt ccnv cfv vx
        cv vx cX vx cv cA cD co cmpt cfv wceq vx cX wral cF ccnv vx cX vx cv cA
        cG co cmpt ccnv vx cX vx cv cA cD co cmpt cF vx cX vx cv cA cG co cmpt
        trfun.2 cnveqi eqeq1i vx cv cF ccnv cfv vx cv vx cX vx cv cA cD co cmpt
        cfv wceq vx cv vx cX vx cv cA cG co cmpt ccnv cfv vx cv vx cX vx cv cA
        cD co cmpt cfv wceq vx cX vx cv cF ccnv cfv vx cv vx cX vx cv cA cG co
        cmpt ccnv cfv vx cv vx cX vx cv cA cD co cmpt cfv vx cv cF ccnv vx cX
        vx cv cA cG co cmpt ccnv cF vx cX vx cv cA cG co cmpt trfun.2 cnveqi
        fveq1i eqeq1i ralbii bibi12i 3imtr4i cG cgr wcel cA cX wcel wa cX cX cF
        wf1o cF ccnv cX wfn vx cA cF cG cX trfun.2 trinv.1 trooo cX cX cF wf1o
        cF cX wfn cF ccnv cX wfn cX cX cF dff1o4 pm3.27bi syl cG cgr wcel cA cX
        wcel wa vx cv cA cD co cvv wcel vx cX wral vx cX vx cv cA cD co cmpt cX
        wfn vx cv cA cD co cvv wcel vx cX vx cv cA cD co cvv wcel vx cv cX wcel
        vx cv cA cD oprex a1i rgen vx cv cA cD co cvv wcel vx cX wral vx cX vx
        cv cA cD co cmpt cX wfn wb cG cgr wcel cA cX wcel wa vx cX vx cv cA cD
        co vx cX vx cv cA cD co cmpt vx cX vx cv cA cD co cmpt eqid fopab2ga
        a1i mpbii sylanc mpbird $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d A a b x y $. $d B a b x y $. $d F x $. $d G a b x y $.
      $d X a b x y $.
      cmprtr.1 $e |- G = ( x e. X |-> ( x G B ) ) $.
      $( Composite of two right translations. $)
      cmprtr $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
           ( F o. G ) = ( x e. X |-> ( x G ( B G A ) ) ) ) $=
        cG cgr wcel cA cX wcel cB cX wcel w3a cF cG ccom vx cv cX wcel vy cv vx
        cv cB cG co cA cG co wceq wa vx vy copab vx cv cX wcel vy cv vx cv cB
        cA cG co cG co wceq wa vx vy copab vx cX vx cv cB cA cG co cG co cmpt
        cG cgr wcel cA cX wcel cB cX wcel w3a cG crn cX wss cF cG ccom vx cv cX
        wcel vy cv vx cv cB cG co cA cG co wceq wa vx vy copab wceq cG crn cX
        wss cG cgr wcel cA cX wcel cB cX wcel w3a cX cG crn trinv.1 eqimss2i
        a1i vx vy va vb vy cX cX vx cv cB cG co va cv cA cG co vx cv cB cG co
        cA cG co cG cF vx cv cX wcel vy cv vx cv cB cG co cA cG co wceq wa vx
        vy copab vx cv cB cG oprex va cv cA cG oprex vx cv cB cG co cA cG oprex
        va cv vx cv cB cG co cA cG opreq1 cG vx cX vx cv cB cG co cmpt vx cv cX
        wcel vy cv vx cv cB cG co wceq wa vx vy copab cmprtr.1 vx vy cX vx cv
        cB cG co df-mpt eqtri cF vx cX vx cv cA cG co cmpt vx cv cX wcel vy cv
        vx cv cA cG co wceq wa vx vy copab va cv cX wcel vb cv va cv cA cG co
        wceq wa va vb copab trfun.2 vx vy cX vx cv cA cG co df-mpt vx cv cX
        wcel vy cv vx cv cA cG co wceq wa va cv cX wcel vb cv va cv cA cG co
        wceq wa vx vy va vb vx cv cX wcel vy cv vx cv cA cG co wceq wa va ax-17
        vx cv cX wcel vy cv vx cv cA cG co wceq wa vb ax-17 va cv cX wcel vb cv
        va cv cA cG co wceq wa vx ax-17 va cv cX wcel vb cv va cv cA cG co wceq
        wa vy ax-17 vx va weq vy vb weq wa vx cv cX wcel va cv cX wcel vy cv vx
        cv cA cG co wceq vb cv va cv cA cG co wceq vx va weq vx cv cX wcel va
        cv cX wcel wb vy vb weq vx cv va cv cX eleq1 adantr vx va weq vy vb weq
        wa vy cv vb cv vx cv cA cG co va cv cA cG co vx va weq vy vb weq pm3.27
        vx va weq vx cv cA cG co va cv cA cG co wceq vy vb weq vx cv va cv cA
        cG opreq1 adantr eqeq12d anbi12d cbvopab 3eqtri vx cv cX wcel vy cv vx
        cv cB cG co cA cG co wceq wa vx vy copab eqid fopabco syl cG cgr wcel
        cA cX wcel cB cX wcel w3a vx cv cX wcel vy cv vx cv cB cG co cA cG co
        wceq wa vx cv cX wcel vy cv vx cv cB cA cG co cG co wceq wa vx vy cG
        cgr wcel cA cX wcel cB cX wcel w3a vx ax-17 cG cgr wcel cA cX wcel cB
        cX wcel w3a vy ax-17 cG cgr wcel cA cX wcel cB cX wcel w3a vx cv cX
        wcel vy cv vx cv cB cG co cA cG co wceq vy cv vx cv cB cA cG co cG co
        wceq cG cgr wcel cA cX wcel cB cX wcel w3a vx cv cX wcel wa vx cv cB cG
        co cA cG co vx cv cB cA cG co cG co vy cv cG cgr wcel vx cv cX wcel cB
        cX wcel cA cX wcel w3a vx cv cB cG co cA cG co vx cv cB cA cG co cG co
        wceq cG cgr wcel cA cX wcel cB cX wcel w3a vx cv cX wcel wa vx cv cB cA
        cG cX trinv.1 grpass cG cgr wcel cA cX wcel cB cX wcel vx cv cX wcel
        3simpl1 cG cgr wcel cA cX wcel cB cX wcel w3a vx cv cX wcel wa vx cv cX
        wcel cB cX wcel cA cX wcel cG cgr wcel cA cX wcel cB cX wcel w3a vx cv
        cX wcel pm3.27 cG cgr wcel cA cX wcel cB cX wcel vx cv cX wcel 3simpl3
        cG cgr wcel cA cX wcel cB cX wcel vx cv cX wcel 3simpl2 3jca sylanc
        eqeq2d pm5.32da opabbid vx cv cX wcel vy cv vx cv cB cA cG co cG co
        wceq wa vx vy copab vx cX vx cv cB cA cG co cG co cmpt wceq cG cgr wcel
        cA cX wcel cB cX wcel w3a vx cX vx cv cB cA cG co cG co cmpt vx cv cX
        wcel vy cv vx cv cB cA cG co cG co wceq wa vx vy copab vx vy cX vx cv
        cB cA cG co cG co df-mpt eqcomi a1i 3eqtrd $.
        $( [17-Oct-2010] $) $( [17-Oct-2010] $)
    $}

    ${
      $d A x y $. $d B x y $. $d F y $. $d G x y $. $d X x y $.
      cmprtr2.1 $e |- G = ( x e. X |-> ( x G B ) ) $.
      $( Composite of two right translations. ( ~ cmprtr with a distinct
         variable condition relaxed.) $)
      cmprtr2 $p |- ( ( G e. Grp /\ A e. X /\ B e. X ) ->
           ( F o. G ) = ( x e. X |-> ( x G ( B G A ) ) ) ) $=
        cG cgr wcel cA cX wcel cB cX wcel w3a cF cG ccom vy cX vy cv cB cA cG
        co cG co cmpt vx cX vx cv cB cA cG co cG co cmpt vy cA cB cF cG cX cF
        vx cX vx cv cA cG co cmpt vy cX vy cv cA cG co cmpt trfun.2 vx vy cX vx
        cv cA cG co vy cv cA cG co vx cX vx cv cA cG co cmpt vx cX vx cv cA cG
        co cmpt eqid vx cv vy cv cA cG opreq1 cmpbvb eqtri trinv.1 cG vx cX vx
        cv cB cG co cmpt vy cX vy cv cB cG co cmpt cmprtr2.1 vx vy cX vx cv cB
        cG co vy cv cB cG co vx cX vx cv cB cG co cmpt vx cX vx cv cB cG co
        cmpt eqid vx cv vy cv cB cG opreq1 cmpbvb eqtri cmprtr vy vx cX vy cv
        cB cA cG co cG co vx cv cB cA cG co cG co vy cX vy cv cB cA cG co cG co
        cmpt vy cX vy cv cB cA cG co cG co cmpt eqid vy cv vx cv cB cA cG co cG
        opreq1 cmpbvb syl6eq $.
        $( [1-Jan-2011] $) $( [1-Jan-2011] $)
    $}

    ${
      $d A x $. $d B a u $. $d F a u $. $d G x $. $d X x $.
     $( The image of a set through a translation. $)
     imtr $p |- ( ( G e. Grp /\ A e. X /\ B e. ~P X ) ->
       ( F " B ) = { a | E. u e. B a = ( F ` u ) } ) $=
       cG cgr wcel cA cX wcel cB cX cpw wcel w3a cF cB cima vu cv cF cfv va cv
       wceq vu cB wrex va cab va cv vu cv cF cfv wceq vu cB wrex va cab cF wfun
       cB cF cdm wss cF cB cima vu cv cF cfv va cv wceq vu cB wrex va cab wceq
       cG cgr wcel cA cX wcel cB cX cpw wcel w3a vu va cB cF dfimafn vx cX vx
       cv cA cG co cF trfun.2 cmpfun cG cgr wcel cA cX wcel cB cX cpw wcel cB
       cF cdm wss cG cgr wcel cA cX wcel wa cF cdm cX wceq cB cX cpw wcel cB cF
       cdm wss wi vx cA cF cG cX trfun.2 trinv.1 trdom2 cF cdm cX wceq cB cX
       cpw wcel cB cF cdm cpw wcel cB cF cdm wss cB cX cpw wcel cB cF cdm cpw
       wcel wi cX cF cdm cX cF cdm wceq cB cX cpw wcel cB cF cdm cpw wcel cX cF
       cdm wceq cX cpw cF cdm cpw cB cX cF cdm pweq eleq2d biimpd eqcoms cB cF
       cdm elpwi syl6 syl 3impia sylancr vu cv cF cfv va cv wceq vu cB wrex va
       cv vu cv cF cfv wceq vu cB wrex va vu cv cF cfv va cv wceq va cv vu cv
       cF cfv wceq vu cB vu cv cF cfv va cv eqcom rexbii abbii syl6eq $.
       $( [30-Dec-2010] $) $( [30-Dec-2010] $)
    $}

    ${
      $d A a v x $. $d B a x $. $d F a x $. $d G a v x $. $d X a x $.
      prsubrtr.1 $e |- H = ( cset ` G ) $.
      $( The product of a subset ` B ` of ` X ` by an element of ` X `
         is the image of ` B ` by a right translation. $)
      prsubrtr $p |- ( ( G e. Grp /\ A e. X /\ B e. ~P X )
        -> ( B H { A } ) = ( F " B ) ) $=
        cG cgr wcel cA cX wcel cB cX cpw wcel w3a va cv vx cv vv cv cG co wceq
        vv cA csn wrex vx cB wrex va cab va cv vx cv cF cfv wceq vx cB wrex va
        cab cB cA csn cH co cF cB cima cG cgr wcel cA cX wcel cB cX cpw wcel
        w3a va cv vx cv vv cv cG co wceq vv cA csn wrex vx cB wrex va cv vx cv
        cF cfv wceq vx cB wrex va cG cgr wcel cA cX wcel cB cX cpw wcel w3a va
        cv vx cv vv cv cG co wceq vv cA csn wrex va cv vx cv cF cfv wceq vx cB
        cG cgr wcel cA cX wcel cB cX cpw wcel w3a vx cv cB wcel wa va cv vx cv
        vv cv cG co wceq vv cA csn wrex va cv vx cv cA cG co wceq va cv vx cv
        cF cfv wceq cG cgr wcel cA cX wcel cB cX cpw wcel w3a vx cv cB wcel wa
        va cv vx cv cA cG co wceq vv cA csn wrex va cv vx cv cA cG co wceq va
        cv vx cv vv cv cG co wceq vv cA csn wrex cG cgr wcel cA cX wcel cB cX
        cpw wcel w3a vx cv cB wcel wa cA csn c0 wne va cv vx cv cA cG co wceq
        vv cA csn wrex va cv vx cv cA cG co wceq wb cG cgr wcel cA cX wcel cB
        cX cpw wcel w3a cA csn c0 wne vx cv cB wcel cA cX wcel cG cgr wcel cA
        csn c0 wne cB cX cpw wcel cA cX snnzg 3ad2ant2 adantr cA csn c0 wne va
        cv vx cv cA cG co wceq va cv vx cv cA cG co wceq vv cA csn wrex va cv
        vx cv cA cG co wceq vv cA csn r19.9rzv bicomd syl va cv vx cv vv cv cG
        co wceq va cv vx cv cA cG co wceq vv cA csn vv cv cA csn wcel vv cv cA
        wceq va cv vx cv vv cv cG co wceq va cv vx cv cA cG co wceq wb vv cA
        elsn vv cv cA wceq vx cv vv cv cG co vx cv cA cG co va cv vv cv cA vx
        cv cG opreq2 eqeq2d sylbi rexbiia syl5bb cG cgr wcel cA cX wcel cB cX
        cpw wcel w3a vx cv cB wcel wa vx cv cA cG co vx cv cF cfv va cv cG cgr
        wcel cA cX wcel cB cX cpw wcel w3a vx cv cB wcel wa vx cv cF cfv vx cv
        cA cG co vx cv cX wcel vx cv cA cG co cvv wcel vx cv cF cfv vx cv cA cG
        co wceq cG cgr wcel cA cX wcel cB cX cpw wcel w3a vx cv cB wcel wa vx
        cX vx cv cA cG co cvv cF trfun.2 fvopab2b cG cgr wcel cA cX wcel cB cX
        cpw wcel w3a vx cv cB wcel vx cv cX wcel cB cX cpw wcel cG cgr wcel vx
        cv cB wcel vx cv cX wcel wi cA cX wcel vx cv cB wcel cB cX cpw wcel vx
        cv cX wcel vx cv cB cX bepart expcom 3ad2ant3 imp vx cv cA cG oprex
        sylancl eqcomd eqeq2d bitrd rexbidva abbidv cG cgr wcel cB cG cdm cdm
        cpw wcel cA csn cG cdm cdm cpw wcel cB cA csn cH co va cv vx cv vv cv
        cG co wceq vv cA csn wrex vx cB wrex va cab wceq cG cgr wcel cA cX wcel
        cB cX cpw wcel w3a vv vx cB cA csn cG cH cgr cG cdm cdm va cG cdm cdm
        eqid prsubrtr.1 iscst2 cG cgr wcel cA cX wcel cB cX cpw wcel 3simp1 cG
        cgr wcel cB cX cpw wcel cB cG cdm cdm cpw wcel cA cX wcel cG cgr wcel
        cB cX cpw wcel cB cG cdm cdm cpw wcel cG cgr wcel cX cpw cG cdm cdm cpw
        cB cG cgr wcel cX cG cdm cdm wceq cX cpw cG cdm cdm cpw wceq cG cgr
        wcel cG crn cG cdm cdm cX cG grprndm trinv.1 syl5eq cX cG cdm cdm pweq
        syl eleq2d biimpa 3adant2 cG cgr wcel cA cX wcel cA csn cG cdm cdm cpw
        wcel cB cX cpw wcel cG cgr wcel cA cX wcel wa cA cG cdm cdm wcel cA csn
        cG cdm cdm cpw wcel cG cgr wcel cA cX wcel cA cG cdm cdm wcel cG cgr
        wcel cX cG cdm cdm cA cG cgr wcel cG crn cG cdm cdm cX cG grprndm
        trinv.1 syl5eq eleq2d biimpa cA cX wcel cA cG cdm cdm wcel cA csn cG
        cdm cdm cpw wcel wb cG cgr wcel cA cG cdm cdm cX snelpwg adantl mpbid
        3adant3 syl3anc vx vx cA cB cF cG cX va trfun.2 trinv.1 imtr 3eqtr4d $.
        $( [30-Dec-2010] $) $( [30-Dec-2010] $)
    $}

    ${
      $d A a x $. $d B a $. $d F a $. $d G a x $. $d X a x $.
      prsubrtr2.1 $e |- H = ( cset ` G ) $.
      $( The product of a subset ` B ` of ` X ` by an element of ` X `
         is the image of ` B ` by a right translation.
         ( ~ prsubrtr with a distinct variable condition relaxed.) $)
      prsubrtr2 $p |- ( ( G e. Grp /\ A e. X /\ B e. ~P X )
        -> ( B H { A } ) = ( F " B ) ) $=
        va cA cB cF cG cH cX cF vx cX vx cv cA cG co cmpt va cX va cv cA cG co
        cmpt trfun.2 vx va cX vx cv cA cG co va cv cA cG co vx cX vx cv cA cG
        co cmpt vx cX vx cv cA cG co cmpt eqid vx cv va cv cA cG opreq1 cmpbvb
        eqtri trinv.1 prsubrtr2.1 prsubrtr $.
        $( [1-Jan-2011] $) $( [1-Jan-2011] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Fields and Rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $c Com2 $.

  $( Extend class notation with a class that adds commutativity to various
    flavors of rings. $)
  ccm2 $a class Com2 $.


  ${ $d g h a b $.
   $( A device to add commutativity to various sorts of rings. I use
      ` ran g ` because I suppose ` g ` has a neutral element and
      therefore is onto. $)
   df-com2 $a |- Com2 = { <. g , h >. | A. a e. ran g A. b e. ran g
     ( a h b ) = ( b h a ) } $.
  $}

  ${ $d G a b x y $. $d H a b x y $.
   $( A device to add commutativity to various sorts of rings. $)
   iscom2 $p |- ( ( G e. A /\ H e. B ) -> ( <. G , H >. e. Com2 <->
     A. a e. ran G A. b e. ran G ( a H b ) = ( b H a ) ) ) $=
     cG cA wcel cH cB wcel wa cG cH cop ccm2 wcel cG cH cop va cv vb cv vy cv
     co vb cv va cv vy cv co wceq vb vx cv crn wral va vx cv crn wral vx vy
     copab wcel va cv vb cv cH co vb cv va cv cH co wceq vb cG crn wral va cG
     crn wral cG cA wcel cH cB wcel wa ccm2 va cv vb cv vy cv co vb cv va cv vy
     cv co wceq vb vx cv crn wral va vx cv crn wral vx vy copab cG cH cop ccm2
     va cv vb cv vy cv co vb cv va cv vy cv co wceq vb vx cv crn wral va vx cv
     crn wral vx vy copab wceq cG cA wcel cH cB wcel wa vx vy va vb df-com2 a1i
     eleq2d va cv vb cv vy cv co vb cv va cv vy cv co wceq vb vx cv crn wral va
     vx cv crn wral va cv vb cv vy cv co vb cv va cv vy cv co wceq vb cG crn
     wral va cG crn wral va cv vb cv cH co vb cv va cv cH co wceq vb cG crn
     wral va cG crn wral vx vy cG cH cA cB vx cv cG wceq va cv vb cv vy cv co
     vb cv va cv vy cv co wceq vb vx cv crn wral va cv vb cv vy cv co vb cv va
     cv vy cv co wceq vb cG crn wral va vx cv crn cG crn vx cv cG rneq vx cv cG
     wceq va cv vb cv vy cv co vb cv va cv vy cv co wceq vb vx cv crn cG crn vx
     cv cG rneq raleq1d raleq12d vy cv cH wceq va cv vb cv vy cv co vb cv va cv
     vy cv co wceq vb cG crn wral va cv vb cv cH co vb cv va cv cH co wceq vb
     cG crn wral va cG crn cG crn vy cv cH wceq cG crn eqidd vy cv cH wceq va
     cv vb cv vy cv co vb cv va cv vy cv co wceq va cv vb cv cH co vb cv va cv
     cH co wceq vb cG crn cG crn vy cv cH wceq cG crn eqidd vy cv cH wceq va cv
     vb cv vy cv co va cv vb cv cH co vb cv va cv vy cv co vb cv va cv cH co va
     cv vb cv vy cv cH opreq vb cv va cv vy cv cH opreq eqeq12d raleq12d
     raleq12d opelopabg bitrd $.
     $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${
    $d H g h $. $d R a b g h $. $d X a b g h $.
    com2i.1 $e |- G = ( 1st ` R ) $.
    com2i.2 $e |- H = ( 2nd ` R ) $.
    com2i.3 $e |- X = ran G $.
    $( Property of a commutative structure with two operation. $)
    com2i $p |- ( R e. Com2 -> A. a e. X A. b e. X ( a H b ) = ( b H a ) ) $=
      cR ccm2 wcel cR va cv vb cv vh cv co vb cv va cv vh cv co wceq vb vg cv
      crn wral va vg cv crn wral vg vh copab wcel va cv vb cv cH co vb cv va cv
      cH co wceq vb cX wral va cX wral ccm2 va cv vb cv vh cv co vb cv va cv vh
      cv co wceq vb vg cv crn wral va vg cv crn wral vg vh copab cR vg vh va vb
      df-com2 eleq2i va cv vb cv vh cv co vb cv va cv vh cv co wceq vb vg cv
      crn wral va vg cv crn wral va cv vb cv vh cv co vb cv va cv vh cv co wceq
      vb cX wral va cX wral va cv vb cv cH co vb cv va cv cH co wceq vb cX wral
      va cX wral vg vh cR vg cv cR c1st cfv wceq vg cv cG wceq va cv vb cv vh
      cv co vb cv va cv vh cv co wceq vb vg cv crn wral va vg cv crn wral va cv
      vb cv vh cv co vb cv va cv vh cv co wceq vb cX wral va cX wral wb cR c1st
      cfv cG vg cv cG cR c1st cfv com2i.1 eqcomi eqeq2i vg cv cG wceq vg cv crn
      cX wceq va cv vb cv vh cv co vb cv va cv vh cv co wceq vb vg cv crn wral
      va vg cv crn wral va cv vb cv vh cv co vb cv va cv vh cv co wceq vb cX
      wral va cX wral wb vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq
      com2i.3 syl6eqr va cv vb cv vh cv co vb cv va cv vh cv co wceq vb vg cv
      crn wral va cv vb cv vh cv co vb cv va cv vh cv co wceq vb cX wral va vg
      cv crn cX va cv vb cv vh cv co vb cv va cv vh cv co wceq vb vg cv crn cX
      raleq1 raleqd syl sylbi vh cv cR c2nd cfv wceq va cv vb cv vh cv co vb cv
      va cv vh cv co wceq va cv vb cv cH co vb cv va cv cH co wceq va vb cX cX
      vh cv cR c2nd cfv wceq vh cv cH wceq va cv vb cv vh cv co vb cv va cv vh
      cv co wceq va cv vb cv cH co vb cv va cv cH co wceq wb cR c2nd cfv cH vh
      cv cH cR c2nd cfv com2i.2 eqcomi eqeq2i vh cv cH wceq va cv vb cv vh cv
      co va cv vb cv cH co vb cv va cv vh cv co vb cv va cv cH co va cv vb cv
      vh cv cH opreq vb cv va cv vh cv cH opreq eqeq12d sylbi 2ralbidv elopabi
      sylbi $.
      $( [18-Feb-2010] $) $( [14-Feb-2010] $)
  $}


  ${ $d v w x y z $.
   $( The class of all unital rings is a relation. $)
   relrng $p |- Rel Ring $=
     cring wrel vw cv cabl wcel vw cv crn vw cv crn cxp vw cv crn vv cv wf wa
     vx cv vy cv vv cv co vz cv vv cv co vx cv vy cv vz cv vv cv co vv cv co
     wceq vx cv vy cv vz cv vw cv co vv cv co vx cv vy cv vv cv co vx cv vz cv
     vv cv co vw cv co wceq vx cv vy cv vw cv co vz cv vv cv co vx cv vz cv vv
     cv co vy cv vz cv vv cv co vw cv co wceq w3a vz vw cv crn wral vy vw cv
     crn wral vx vw cv crn wral vy cv vx cv vv cv co vy cv wceq vx cv vy cv vv
     cv co vy cv wceq wa vy vw cv crn wral vx vw cv crn wrex wa wa vw vv copab
     wrel vw cv cabl wcel vw cv crn vw cv crn cxp vw cv crn vv cv wf wa vx cv
     vy cv vv cv co vz cv vv cv co vx cv vy cv vz cv vv cv co vv cv co wceq vx
     cv vy cv vz cv vw cv co vv cv co vx cv vy cv vv cv co vx cv vz cv vv cv co
     vw cv co wceq vx cv vy cv vw cv co vz cv vv cv co vx cv vz cv vv cv co vy
     cv vz cv vv cv co vw cv co wceq w3a vz vw cv crn wral vy vw cv crn wral vx
     vw cv crn wral vy cv vx cv vv cv co vy cv wceq vx cv vy cv vv cv co vy cv
     wceq wa vy vw cv crn wral vx vw cv crn wrex wa wa vw vv relopab cring vw
     cv cabl wcel vw cv crn vw cv crn cxp vw cv crn vv cv wf wa vx cv vy cv vv
     cv co vz cv vv cv co vx cv vy cv vz cv vv cv co vv cv co wceq vx cv vy cv
     vz cv vw cv co vv cv co vx cv vy cv vv cv co vx cv vz cv vv cv co vw cv co
     wceq vx cv vy cv vw cv co vz cv vv cv co vx cv vz cv vv cv co vy cv vz cv
     vv cv co vw cv co wceq w3a vz vw cv crn wral vy vw cv crn wral vx vw cv
     crn wral vy cv vx cv vv cv co vy cv wceq vx cv vy cv vv cv co vy cv wceq
     wa vy vw cv crn wral vx vw cv crn wrex wa wa vw vv copab vx vy vz vw vv
     df-ring releqi mpbir $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}


  ${
    rngn0.1 $e |- G = ( 1st ` R ) $.
    rngn0.2 $e |- X = ran G $.
    $( The base set of a ring is not empty. $)
    rngn0 $p |- ( R e. Ring -> X =/= (/) ) $=
      cR cring wcel cG cgr wcel cX c0 wne cR cG rngn0.1 ringgrp cG cX rngn0.2
      grpn0 syl $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${ $d X u $.
    $( The domain of the first variable of an internal operation with a
       left and right identity element equals its base set. $)
    rngmgmbs3 $p |- ( ( G : ( X X. X ) --> X /\
      E. u e. X  A. x e. X ( ( x G u ) = x /\ ( u G x ) = x ) )
         -> dom dom G = X ) $=
      vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vx cX wral
      vu cX wrex cX cX cxp cX cG wf cG cdm cdm cX wceq cX cX cxp cX cG wf cX c0
      wne cG cdm cdm cX wceq vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx
      cv wceq wa vx cX wral vu cX wrex cX cX cxp cX cG wf cG cdm cX cX cxp wceq
      cX c0 wne cG cdm cdm cX wceq wi cX cX cxp cX cG fdm cG cdm cX cX cxp wceq
      cG cdm cdm cX cX cxp cdm wceq cX c0 wne cG cdm cdm cX wceq wi cG cdm cX
      cX cxp dmeq cG cdm cdm cX cX cxp cdm wceq cX cX cxp cdm cX wceq cG cdm
      cdm cX wceq cX c0 wne cG cdm cdm cX cX cxp cdm wceq cX cX cxp cdm cX wceq
      cG cdm cdm cX wceq cG cdm cdm cX cX cxp cdm cX eqtr ex cX cX dmxp syl5
      syl syl vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vx
      cX wral vu cX rexn0 syl5com impcom $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${ $d G u x z $. $d G u y z $. $d X u x z $. $d X u y z $.
    $( The range of an internal operation with a left and right identity
       element equals its base set. $)
    rngmgmbs4 $p |- ( ( G : ( X X. X ) --> X /\
      E. u e. X  A. x e. X ( ( x G u ) = x /\ ( u G x ) = x ) )
         -> ran G = X ) $=
      cX cX cxp cX cG wf vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv
      wceq wa vx cX wral vu cX wrex wa cX cX cxp cX cG wfo cG crn cX wceq cX cX
      cxp cX cG wf vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa
      vx cX wral vu cX wrex wa cX cX cxp cX cG wf vz cv vu cv vy cv cG co wceq
      vy cX wrex vu cX wrex vz cX wral wa cX cX cxp cX cG wfo vx cv vu cv cG co
      vx cv wceq vu cv vx cv cG co vx cv wceq wa vx cX wral vu cX wrex vz cv vu
      cv vy cv cG co wceq vy cX wrex vu cX wrex vz cX wral cX cX cxp cX cG wf
      vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vx cX wral
      vu cX wrex vz cv vu cv vy cv cG co wceq vy cX wrex vu cX wrex vz cX vz cv
      cX wcel vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vx
      cX wral vu cX wrex vz cv vu cv vy cv cG co wceq vy cX wrex vu cX wrex vz
      cv cX wcel vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa
      vx cX wral vz cv vu cv vy cv cG co wceq vy cX wrex vu cX vz cv cX wcel vu
      cv vx cv cG co vx cv wceq vx cX wral vz cv vu cv vy cv cG co wceq vy cX
      wrex vx cv vu cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq wa vx cX
      wral vz cv cX wcel vu cv vx cv cG co vx cv wceq vx cX wral vu cv vz cv cG
      co vz cv wceq vz cv vu cv vy cv cG co wceq vy cX wrex vu cv vx cv cG co
      vx cv wceq vu cv vz cv cG co vz cv wceq vx vz cv cX vx vz weq vu cv vx cv
      cG co vu cv vz cv cG co vx cv vz cv vx cv vz cv vu cv cG opreq2 vx vz weq
      id eqeq12d rcla4v vz cv cX wcel vu cv vz cv cG co vz cv wceq vz cv vu cv
      vy cv cG co wceq vy cX wrex vz cv vu cv vy cv cG co wceq vu cv vz cv cG
      co vz cv wceq vy vz cv cX vy vz weq vu cv vy cv cG co vz cv wceq vu cv vz
      cv cG co vz cv wceq vz cv vu cv vy cv cG co wceq vy vz weq vu cv vy cv cG
      co vu cv vz cv cG co vz cv vy cv vz cv vu cv cG opreq2 eqeq1d vz cv vu cv
      vy cv cG co eqcom syl5bb rcla4ev ex syld vx cv vu cv cG co vx cv wceq vu
      cv vx cv cG co vx cv wceq wa vu cv vx cv cG co vx cv wceq vx cX vx cv vu
      cv cG co vx cv wceq vu cv vx cv cG co vx cv wceq pm3.27 r19.20si syl5
      r19.22sdv impcom r19.21aiva anim2i vu vy vz cX cX cX cG fooprv sylibr cX
      cX cxp cX cG forn syl $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${
    mlrngmgex.1 $e |- H = ( 2nd ` R ) $.
    ${
      mlrngmgex.2 $e |- G = ( 1st ` R ) $.
      $( In a unital ring the domain of the first variable of the addition
         equals the domain of the first variable of the multiplication. $)
      rnplrnml0 $p |- ( R e. Ring -> dom dom G = dom dom H ) $=
        cR cring wcel cG crn cG crn cxp cG crn cH wf cG cdm cdm cH cdm cdm wceq
        cR cG cH cG crn mlrngmgex.2 mlrngmgex.1 cG crn eqid ringsm cR cring
        wcel cG cgr wcel cG crn cG crn cxp cG crn cG wfo cG crn cG crn cxp cG
        crn cH wf cG cdm cdm cH cdm cdm wceq wi cR cG mlrngmgex.2 ringgrp cG cG
        crn cG crn eqid grpfo cG crn cG crn cxp cG crn cG wfo cG crn cG crn cxp
        cG crn cG wf cG cdm cG crn cG crn cxp wceq cG crn cG crn cxp cG crn cH
        wf cG cdm cdm cH cdm cdm wceq wi cG crn cG crn cxp cG crn cG fof cG crn
        cG crn cxp cG crn cG fdm cG crn cG crn cxp cG crn cH wf cG cdm cG crn
        cG crn cxp wceq cG cdm cdm cH cdm cdm wceq cG crn cG crn cxp cG crn cH
        wf cH cdm cG crn cG crn cxp wceq cG cdm cG crn cG crn cxp wceq cG cdm
        cdm cH cdm cdm wceq wi cG crn cG crn cxp cG crn cH fdm cG cdm cG crn cG
        crn cxp wceq cG cdm cdm cH cdm cdm wceq wi cG crn cG crn cxp cH cdm cG
        cdm cG crn cG crn cxp wceq cG crn cG crn cxp cH cdm wceq cG cdm cdm cH
        cdm cdm wceq cG cdm cG crn cG crn cxp wceq cG crn cG crn cxp cH cdm
        wceq wa cG cdm cH cdm cG cdm cG crn cG crn cxp cH cdm eqtr dmeqd expcom
        eqcoms syl com12 3syl 3syl mpd $.
        $( [24-Jan-2010] $) $( [24-Jan-2010] $)

      $( In a unital ring the range of the addition equals the domain of the
         first variable of the multiplication. $)
      rnplrnml2 $p |- ( R e. Ring -> ran G = dom dom H ) $=
        cR cring wcel cG crn cG cdm cdm cH cdm cdm cR cring wcel cG cgr wcel cG
        crn cG cdm cdm wceq cR cG mlrngmgex.2 ringgrp cG grprndm syl cR cG cH
        mlrngmgex.1 mlrngmgex.2 rnplrnml0 eqtrd $.
        $( [24-Jan-2010] $) $( [24-Jan-2010] $)

      ${ $d G x y z $. $d H x y z $.
        $( In a unital ring the range of the addition equals the range of the
           multiplication. $)
        rnplrnml $p |- ( R e. Ring -> ran G = ran H ) $=
          cR cring wcel cH crn cG crn cG crn cG crn cxp cG crn cH wf vx cv vy
          cv cH co vx cv wceq vy cv vx cv cH co vx cv wceq wa vx cG crn wral vy
          cG crn wrex cH crn cG crn wceq cR cring wcel vx vy cH cG crn
          rngmgmbs4 cR cG cH cG crn mlrngmgex.2 mlrngmgex.1 cG crn eqid ringsm
          cR cring wcel cG cabl wcel cG crn cG crn cxp cG crn cH wf wa vy cv vx
          cv cH co vz cv cH co vy cv vx cv vz cv cH co cH co wceq vy cv vx cv
          vz cv cG co cH co vy cv vx cv cH co vy cv vz cv cH co cG co wceq vy
          cv vx cv cG co vz cv cH co vy cv vz cv cH co vx cv vz cv cH co cG co
          wceq w3a vz cG crn wral vx cG crn wral vy cG crn wral vx cv vy cv cH
          co vx cv wceq vy cv vx cv cH co vx cv wceq wa vx cG crn wral vy cG
          crn wrex wa wa vx cv vy cv cH co vx cv wceq vy cv vx cv cH co vx cv
          wceq wa vx cG crn wral vy cG crn wrex vy vx vz cR cG cH cG crn
          mlrngmgex.2 mlrngmgex.1 cG crn eqid ringi cG cabl wcel cG crn cG crn
          cxp cG crn cH wf wa vy cv vx cv cH co vz cv cH co vy cv vx cv vz cv
          cH co cH co wceq vy cv vx cv vz cv cG co cH co vy cv vx cv cH co vy
          cv vz cv cH co cG co wceq vy cv vx cv cG co vz cv cH co vy cv vz cv
          cH co vx cv vz cv cH co cG co wceq w3a vz cG crn wral vx cG crn wral
          vy cG crn wral vx cv vy cv cH co vx cv wceq vy cv vx cv cH co vx cv
          wceq wa vx cG crn wral vy cG crn wrex simprr syl sylanc eqcomd $.
          $( [24-Jan-2010] $) $( [24-Jan-2010] $)
      $}

    $}

    ${
    $( In a unital ring the range of the multiplication equals the domain of
       the first variable. $)
    rngdmdmrn $p |- ( R e. Ring -> dom dom H = ran H ) $=
      cR cring wcel cR c1st cfv crn cH cdm cdm cH crn cR cR c1st cfv cH
      mlrngmgex.1 cR c1st cfv eqid rnplrnml2 cR cR c1st cfv cH mlrngmgex.1 cR
      c1st cfv eqid rnplrnml eqtr3d $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
    $}
  $}

  ${
    rnplrnml3.1 $e |- G = ( 1st ` R ) $.
    $( In a unital ring the domain of the first operand of the addition equals
       the domain of the second operand of the addition. $)
    rnplrnml3 $p |- ( R e. Ring -> dom dom G = ran dom G ) $=
      cG cgr wcel cG cgr wcel cG cdm cdm cG cdm crn wceq cR cring wcel cG cgr
      wcel cG crn cG crn cxp cG crn cG wfo cG crn cG crn cxp cG crn cG wf cG
      cgr wcel cG cdm cdm cG cdm crn wceq wi cG cG crn cG crn eqid grpfo cG crn
      cG crn cxp cG crn cG fof cG crn cG crn cxp cG crn cG wf cG cdm cG crn cG
      crn cxp wceq cG cgr wcel cG cdm cdm cG cdm crn wceq wi cG crn cG crn cxp
      cG crn cG fdm cG cdm cG crn cG crn cxp wceq cG crn c0 wne cG cdm cdm cG
      cdm crn wceq cG cgr wcel cG cdm cdm cG crn wceq cG cdm cG crn cG crn cxp
      wceq cG crn c0 wne cG cdm cdm cG cdm crn wceq wi cG cdm cG crn cG crn cxp
      wceq cG cdm cdm cG crn cG crn cxp cdm cG crn cG cdm cG crn cG crn cxp
      dmeq cG crn dmxpid syl6eq cG crn c0 wne cG cdm cG crn cG crn cxp wceq cG
      cdm cdm cG crn wceq cG cdm cdm cG cdm crn wceq cG crn c0 wne cG cdm cG
      crn cG crn cxp wceq cG cdm crn cG crn wceq cG cdm cdm cG crn wceq cG cdm
      cdm cG cdm crn wceq wi cG crn c0 wne cG cdm crn cG crn cG crn cxp crn
      wceq cG cdm crn cG crn wceq cG cdm cG crn cG crn cxp wceq cG cdm crn cG
      crn cG crn cxp crn wceq cG crn cG crn cxp crn cG crn wceq cG cdm crn cG
      crn wceq cG crn c0 wne cG cdm crn cG crn cG crn cxp crn wceq cG crn cG
      crn cxp crn cG crn wceq cG cdm crn cG crn wceq cG cdm crn cG crn cG crn
      cxp crn cG crn eqtr ex cG crn cG crn rnxp syl5com cG cdm cG crn cG crn
      cxp rneq syl5 cG cdm cdm cG crn wceq cG cdm cdm cG cdm crn wceq wi cG crn
      cG cdm crn cG cdm cdm cG crn wceq cG crn cG cdm crn wceq cG cdm cdm cG
      cdm crn wceq cG cdm cdm cG crn cG cdm crn eqtr expcom eqcoms syl6 com13
      mpcom cG cG crn cG crn eqid grpn0 syl5 syl 3syl cR cG rnplrnml3.1 ringgrp
      cR cG rnplrnml3.1 ringgrp sylc $.
      $( [18-Feb-2010] $) $( [11-Feb-2010] $)
  $}

  ${
    unmnd.1 $e |- H = ( 2nd ` R ) $.
    ${
      $d H w x y $. $d H x y z $. $d R w x y $. $d R x y z $.
      $( In a unital ring the multiplication is a monoid. $)
      unmnd $p |- ( R e. Ring -> H e. Mnd ) $=
        cR cring wcel cH cdm cdm cH cdm cdm cxp cH cdm cdm cH wf vx cv vy cv cH
        co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cH cdm cdm wral vy
        cH cdm cdm wral vx cH cdm cdm wral vy cv vx cv cH co vy cv wceq vx cv
        vy cv cH co vy cv wceq wa vy cH cdm cdm wral vx cH cdm cdm wrex w3a cH
        cmnd wcel cR cring wcel cH cdm cdm cH cdm cdm cxp cH cdm cdm cH wf vx
        cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cH cdm
        cdm wral vy cH cdm cdm wral vx cH cdm cdm wral vy cv vx cv cH co vy cv
        wceq vx cv vy cv cH co vy cv wceq wa vy cH cdm cdm wral vx cH cdm cdm
        wrex w3a cR c1st cfv crn cR c1st cfv crn cxp cR c1st cfv crn cH wf vx
        cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cR
        c1st cfv crn wral vy cR c1st cfv crn wral vx cR c1st cfv crn wral vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cR c1st cfv
        crn wral vx cR c1st cfv crn wrex w3a cR cring wcel cR c1st cfv crn cR
        c1st cfv crn cxp cR c1st cfv crn cH wf vx cv vy cv cH co vz cv cH co vx
        cv vy cv vz cv cH co cH co wceq vz cR c1st cfv crn wral vy cR c1st cfv
        crn wral vx cR c1st cfv crn wral vy cv vx cv cH co vy cv wceq vx cv vy
        cv cH co vy cv wceq wa vy cR c1st cfv crn wral vx cR c1st cfv crn wrex
        cR cR c1st cfv cH cR c1st cfv crn cR c1st cfv eqid unmnd.1 cR c1st cfv
        crn eqid ringsm cR cring wcel vx cv vy cv cH co vz cv cH co vx cv vy cv
        vz cv cH co cH co wceq vz cR c1st cfv crn wral vx vy cR c1st cfv crn cR
        c1st cfv crn cR cring wcel vx cv cR c1st cfv crn wcel vy cv cR c1st cfv
        crn wcel wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co
        wceq vz cR c1st cfv crn wral cR cring wcel vx cv cR c1st cfv crn wcel
        vy cv cR c1st cfv crn wcel wa wa vx cv vy cv cH co vz cv cH co vx cv vy
        cv vz cv cH co cH co wceq vz cR c1st cfv crn vx cv cR c1st cfv crn wcel
        vy cv cR c1st cfv crn wcel wa cR cring wcel vz cv cR c1st cfv crn wcel
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq wi vx
        cv cR c1st cfv crn wcel vy cv cR c1st cfv crn wcel cR cring wcel vz cv
        cR c1st cfv crn wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH
        co cH co wceq wi wi vx cv cR c1st cfv crn wcel vy cv cR c1st cfv crn
        wcel vz cv cR c1st cfv crn wcel cR cring wcel vx cv vy cv cH co vz cv
        cH co vx cv vy cv vz cv cH co cH co wceq vx cv cR c1st cfv crn wcel vy
        cv cR c1st cfv crn wcel vz cv cR c1st cfv crn wcel cR cring wcel vx cv
        vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq wi cR cring
        wcel vx cv cR c1st cfv crn wcel vy cv cR c1st cfv crn wcel vz cv cR
        c1st cfv crn wcel w3a vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv
        cH co cH co wceq vx cv vy cv vz cv cR cR c1st cfv cH cR c1st cfv crn cR
        c1st cfv eqid unmnd.1 cR c1st cfv crn eqid ringass expcom 3exp com34
        imp impcom r19.21aiv ex r19.21aivv cR cring wcel vx cv vy cv cH co vw
        cv cH co vx cv vy cv vw cv cH co cH co wceq vx cv vy cv vw cv cR c1st
        cfv co cH co vx cv vy cv cH co vx cv vw cv cH co cR c1st cfv co wceq vx
        cv vy cv cR c1st cfv co vw cv cH co vx cv vw cv cH co vy cv vw cv cH co
        cR c1st cfv co wceq w3a vw cR c1st cfv crn wral vy cR c1st cfv crn wral
        vx cR c1st cfv crn wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
        vy cv wceq wa vy cR c1st cfv crn wral vx cR c1st cfv crn wrex cR cring
        wcel cR c1st cfv cabl wcel cR c1st cfv crn cR c1st cfv crn cxp cR c1st
        cfv crn cH wf wa vx cv vy cv cH co vw cv cH co vx cv vy cv vw cv cH co
        cH co wceq vx cv vy cv vw cv cR c1st cfv co cH co vx cv vy cv cH co vx
        cv vw cv cH co cR c1st cfv co wceq vx cv vy cv cR c1st cfv co vw cv cH
        co vx cv vw cv cH co vy cv vw cv cH co cR c1st cfv co wceq w3a vw cR
        c1st cfv crn wral vy cR c1st cfv crn wral vx cR c1st cfv crn wral vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cR c1st cfv
        crn wral vx cR c1st cfv crn wrex wa vx vy vw cR cR c1st cfv cH cR c1st
        cfv crn cR c1st cfv eqid unmnd.1 cR c1st cfv crn eqid ringi pm3.27d
        pm3.27d 3jca cR cring wcel cR c1st cfv crn cH cdm cdm wceq cH cdm cdm
        cH cdm cdm cxp cH cdm cdm cH wf vx cv vy cv cH co vz cv cH co vx cv vy
        cv vz cv cH co cH co wceq vz cH cdm cdm wral vy cH cdm cdm wral vx cH
        cdm cdm wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq
        wa vy cH cdm cdm wral vx cH cdm cdm wrex w3a cR c1st cfv crn cR c1st
        cfv crn cxp cR c1st cfv crn cH wf vx cv vy cv cH co vz cv cH co vx cv
        vy cv vz cv cH co cH co wceq vz cR c1st cfv crn wral vy cR c1st cfv crn
        wral vx cR c1st cfv crn wral vy cv vx cv cH co vy cv wceq vx cv vy cv
        cH co vy cv wceq wa vy cR c1st cfv crn wral vx cR c1st cfv crn wrex w3a
        wb cR cR c1st cfv cH unmnd.1 cR c1st cfv eqid rnplrnml2 cH cdm cdm cH
        cdm cdm cxp cH cdm cdm cH wf vx cv vy cv cH co vz cv cH co vx cv vy cv
        vz cv cH co cH co wceq vz cH cdm cdm wral vy cH cdm cdm wral vx cH cdm
        cdm wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa
        vy cH cdm cdm wral vx cH cdm cdm wrex w3a cR c1st cfv crn cR c1st cfv
        crn cxp cR c1st cfv crn cH wf vx cv vy cv cH co vz cv cH co vx cv vy cv
        vz cv cH co cH co wceq vz cR c1st cfv crn wral vy cR c1st cfv crn wral
        vx cR c1st cfv crn wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
        vy cv wceq wa vy cR c1st cfv crn wral vx cR c1st cfv crn wrex w3a wb cH
        cdm cdm cR c1st cfv crn cH cdm cdm cR c1st cfv crn wceq cH cdm cdm cH
        cdm cdm cxp cH cdm cdm cH wf cR c1st cfv crn cR c1st cfv crn cxp cR
        c1st cfv crn cH wf vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH
        co cH co wceq vz cH cdm cdm wral vy cH cdm cdm wral vx cH cdm cdm wral
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cR
        c1st cfv crn wral vy cR c1st cfv crn wral vx cR c1st cfv crn wral vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cH cdm cdm
        wral vx cH cdm cdm wrex vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
        vy cv wceq wa vy cR c1st cfv crn wral vx cR c1st cfv crn wrex cH cdm
        cdm cH cdm cdm cxp cR c1st cfv crn cR c1st cfv crn cxp wceq cH cdm cdm
        cR c1st cfv crn wceq cH cdm cdm cH cdm cdm cxp cH cdm cdm cH wf cR c1st
        cfv crn cR c1st cfv crn cxp cR c1st cfv crn cH wf wb cH cdm cdm cH cdm
        cdm cxp cR c1st cfv crn cR c1st cfv crn cxp wceq cH cdm cdm cR c1st cfv
        crn wceq cH cdm cdm cR c1st cfv crn xpid11 biimpri cH cdm cdm cH cdm
        cdm cxp cH cdm cdm cR c1st cfv crn cR c1st cfv crn cxp cR c1st cfv crn
        cH feq23 mpancom cH cdm cdm cR c1st cfv crn wceq vx cv vy cv cH co vz
        cv cH co vx cv vy cv vz cv cH co cH co wceq vz cH cdm cdm wral vy cH
        cdm cdm wral vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
        co wceq vz cR c1st cfv crn wral vy cR c1st cfv crn wral vx cH cdm cdm
        cR c1st cfv crn cH cdm cdm cR c1st cfv crn wceq vx cv cH cdm cdm wcel
        vx cv cR c1st cfv crn wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz
        cv cH co cH co wceq vz cH cdm cdm wral vy cH cdm cdm wral vx cv vy cv
        cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cR c1st cfv crn
        wral vy cR c1st cfv crn wral cH cdm cdm cR c1st cfv crn vx cv eleq2 cH
        cdm cdm cR c1st cfv crn wceq vx cv vy cv cH co vz cv cH co vx cv vy cv
        vz cv cH co cH co wceq vz cH cdm cdm wral vx cv vy cv cH co vz cv cH co
        vx cv vy cv vz cv cH co cH co wceq vz cR c1st cfv crn wral vy cH cdm
        cdm cR c1st cfv crn cH cdm cdm cR c1st cfv crn wceq vy cv cH cdm cdm
        wcel vy cv cR c1st cfv crn wcel vx cv vy cv cH co vz cv cH co vx cv vy
        cv vz cv cH co cH co wceq vz cH cdm cdm wral vx cv vy cv cH co vz cv cH
        co vx cv vy cv vz cv cH co cH co wceq vz cR c1st cfv crn wral cH cdm
        cdm cR c1st cfv crn vy cv eleq2 cH cdm cdm cR c1st cfv crn wceq vx cv
        vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv
        cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cH cdm cdm cR
        c1st cfv crn cH cdm cdm cR c1st cfv crn wceq vz cv cH cdm cdm wcel vz
        cv cR c1st cfv crn wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv
        cH co cH co wceq cH cdm cdm cR c1st cfv crn vz cv eleq2 imbi1d ralbidv2
        imbi12d ralbidv2 imbi12d ralbidv2 cH cdm cdm cR c1st cfv crn wceq vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cH cdm cdm
        wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cR
        c1st cfv crn wral vx cH cdm cdm cR c1st cfv crn cH cdm cdm cR c1st cfv
        crn wceq vx cv cH cdm cdm wcel vx cv cR c1st cfv crn wcel vy cv vx cv
        cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cH cdm cdm wral vy
        cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cR c1st
        cfv crn wral cH cdm cdm cR c1st cfv crn vx cv eleq2 cH cdm cdm cR c1st
        cfv crn wceq vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq
        wa vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cH
        cdm cdm cR c1st cfv crn cH cdm cdm cR c1st cfv crn wceq vy cv cH cdm
        cdm wcel vy cv cR c1st cfv crn wcel vy cv vx cv cH co vy cv wceq vx cv
        vy cv cH co vy cv wceq wa cH cdm cdm cR c1st cfv crn vy cv eleq2 imbi1d
        ralbidv2 anbi12d rexbidv2 3anbi123d eqcoms syl mpbird cH cR c2nd cfv
        wceq cH cmnd wcel cH cdm cdm cH cdm cdm cxp cH cdm cdm cH wf vx cv vy
        cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cH cdm cdm
        wral vy cH cdm cdm wral vx cH cdm cdm wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cH cdm cdm wral vx cH cdm cdm wrex
        w3a wb unmnd.1 cH cR c2nd cfv wceq cH cvv wcel cH cmnd wcel cH cdm cdm
        cH cdm cdm cxp cH cdm cdm cH wf vx cv vy cv cH co vz cv cH co vx cv vy
        cv vz cv cH co cH co wceq vz cH cdm cdm wral vy cH cdm cdm wral vx cH
        cdm cdm wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq
        wa vy cH cdm cdm wral vx cH cdm cdm wrex w3a wb cH cR c2nd cfv wceq cH
        cvv wcel cR c2nd cfv cvv wcel cR c2nd fvex cH cR c2nd cfv cvv eleq1
        mpbiri vx vy vz cvv cH cH cdm cdm cH cdm cdm eqid ismnd1 syl ax-mp
        sylibr $.
        $( [24-Jan-2010] $) $( [24-Jan-2010] $)
    $}
  $}

  ${
   fora1.1 $e |- G e. A $.
   $( In a unital ring the addition is an abelian group. $)
   fora1 $p |- ( <. G , H >. e. Ring -> G e. Abel ) $=
     cG cH cop cG cG cH cop c1st cfv cG cG cH cG cA fora1.1 elisseti op1st
     eqcomi ringabl $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}

  ${
   $( In a unital ring the addition is an abelian group. $)
   fora2 $p |- ( ( G e. A /\ <. G , H >. e. Ring ) -> G e. Abel ) $=
     cG cA wcel cG cH cop cring wcel cG cabl wcel cG cA wcel cG cvv wcel cG cH
     cop cring wcel cG cabl wcel wi cG cA elisset cG cvv wcel cG cH cop cring
     wcel cG cabl wcel wi cG cvv wcel cG cA cA cop cA cop csn cif cH cop cring
     wcel cG cvv wcel cG cA cA cop cA cop csn cif cabl wcel wi cG cA cA cop cA
     cop csn cG cG cvv wcel cG cA cA cop cA cop csn cif wceq cG cH cop cring
     wcel cG cvv wcel cG cA cA cop cA cop csn cif cH cop cring wcel cG cabl
     wcel cG cvv wcel cG cA cA cop cA cop csn cif cabl wcel cG cG cvv wcel cG
     cA cA cop cA cop csn cif wceq cG cH cop cG cvv wcel cG cA cA cop cA cop
     csn cif cH cop cring cG cG cvv wcel cG cA cA cop cA cop csn cif cH opeq1
     eleq1d cG cG cvv wcel cG cA cA cop cA cop csn cif cabl eleq1 imbi12d cvv
     cG cvv wcel cG cA cA cop cA cop csn cif cH cG cA cA cop cA cop csn cvv cA
     cA cop cA cop snex elimel fora1 dedth syl imp $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}

  $( In a unital ring the addition is an abelian group. $)
  fora $p |- ( <. G , H >. e. Ring -> G e. Abel ) $=
    cG cvv wcel cG cH cop cring wcel cG cabl wcel cG cH cop cring wcel cG cH
    cring wbr cG cvv wcel cG cH cring df-br cG cH cring relrng brrelexi sylbir
    cvv cG cH fora2 mpancom $.
    $( [7-Sep-2009] $) $( [31-Aug-2009] $)

  ${

    ununr.1 $e |- H = ( 2nd ` R ) $.
    ununr.2 $e |- X = ran ( 1st ` R ) $.
    ${
      $d H a x y $. $d H x y z $. $d R x y z $. $d X a x y $. $d X x y z $.
      $( The unit of a unital ring is unique. $)
      ununr $p |- ( R e. Ring -> E! x e. X
        A. y e. X ( ( y H x ) = y /\ ( x H y ) = y ) ) $=
        cR cring wcel vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq
        wa vy cX wral vx cX wrex vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
        vy cv wceq wa vy cX wral vy cv va cv cH co vy cv wceq va cv vy cv cH co
        vy cv wceq wa vy cX wral wa vx va weq wi va cX wral vx cX wral wa vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX
        wreu cR cring wcel vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
        wceq wa vy cX wral vx cX wrex vy cv vx cv cH co vy cv wceq vx cv vy cv
        cH co vy cv wceq wa vy cX wral vy cv va cv cH co vy cv wceq va cv vy cv
        cH co vy cv wceq wa vy cX wral wa vx va weq wi va cX wral vx cX wral cR
        cring wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co
        wceq vx cv vy cv vz cv cR c1st cfv co cH co vx cv vy cv cH co vx cv vz
        cv cH co cR c1st cfv co wceq vx cv vy cv cR c1st cfv co vz cv cH co vx
        cv vz cv cH co vy cv vz cv cH co cR c1st cfv co wceq w3a vz cX wral vy
        cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
        wceq wa vy cX wral vx cX wrex cR cring wcel cR c1st cfv cabl wcel cX cX
        cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co
        cH co wceq vx cv vy cv vz cv cR c1st cfv co cH co vx cv vy cv cH co vx
        cv vz cv cH co cR c1st cfv co wceq vx cv vy cv cR c1st cfv co vz cv cH
        co vx cv vz cv cH co vy cv vz cv cH co cR c1st cfv co wceq w3a vz cX
        wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH
        co vy cv wceq wa vy cX wral vx cX wrex wa vx vy vz cR cR c1st cfv cH cX
        cR c1st cfv eqid ununr.1 ununr.2 ringi pm3.27d pm3.27d vy cv vx cv cH
        co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vy cv va cv cH
        co vy cv wceq va cv vy cv cH co vy cv wceq wa vy cX wral wa vx va weq
        wi vx va cX vx cv cX wcel va cv cX wcel vy cv vx cv cH co vy cv wceq vx
        cv vy cv cH co vy cv wceq wa vy cX wral vy cv va cv cH co vy cv wceq va
        cv vy cv cH co vy cv wceq wa vy cX wral vx va weq vx cv cX wcel vy cv
        va cv cH co vy cv wceq va cv vy cv cH co vy cv wceq wa vy cX wral vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral va cv
        cX wcel vx va weq vx cv cX wcel vy cv va cv cH co vy cv wceq va cv vy
        cv cH co vy cv wceq wa vy cX wral vx cv va cv cH co vx cv wceq va cv vx
        cv cH co vx cv wceq wa vy cv vx cv cH co vy cv wceq vx cv vy cv cH co
        vy cv wceq wa vy cX wral va cv cX wcel vx va weq wi wi vy cv va cv cH
        co vy cv wceq va cv vy cv cH co vy cv wceq wa vx cv va cv cH co vx cv
        wceq va cv vx cv cH co vx cv wceq wa vy vx cv cX vy vx weq vy cv va cv
        cH co vy cv wceq vx cv va cv cH co vx cv wceq va cv vy cv cH co vy cv
        wceq va cv vx cv cH co vx cv wceq vy vx weq vy cv va cv cH co vx cv va
        cv cH co vy cv vx cv vy cv vx cv va cv cH opreq1 vy vx weq id eqeq12d
        vy vx weq va cv vy cv cH co va cv vx cv cH co vy cv vx cv vy cv vx cv
        va cv cH opreq2 vy vx weq id eqeq12d anbi12d rcla4v va cv cX wcel vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cv
        va cv cH co vx cv wceq va cv vx cv cH co vx cv wceq wa vx va weq va cv
        cX wcel vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy
        cX wral va cv vx cv cH co va cv wceq vx cv va cv cH co va cv wceq wa vx
        cv va cv cH co vx cv wceq va cv vx cv cH co vx cv wceq wa vx va weq wi
        vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa va cv vx
        cv cH co va cv wceq vx cv va cv cH co va cv wceq wa vy va cv cX vy va
        weq vy cv vx cv cH co vy cv wceq va cv vx cv cH co va cv wceq vx cv vy
        cv cH co vy cv wceq vx cv va cv cH co va cv wceq vy va weq vy cv vx cv
        cH co va cv vx cv cH co vy cv va cv vy cv va cv vx cv cH opreq1 vy va
        weq id eqeq12d vy va weq vx cv vy cv cH co vx cv va cv cH co vy cv va
        cv vy cv va cv vx cv cH opreq2 vy va weq id eqeq12d anbi12d rcla4v va
        cv vx cv cH co va cv wceq vx cv va cv cH co vx cv wceq va cv vx cv cH
        co vx cv wceq wa vx va weq wi vx cv va cv cH co va cv wceq vx cv va cv
        cH co vx cv wceq va cv vx cv cH co vx cv wceq wa va cv vx cv cH co va
        cv wceq vx va weq va cv vx cv cH co vx cv wceq va cv vx cv cH co va cv
        wceq vx va weq wi vx cv va cv cH co vx cv wceq va cv vx cv cH co vx cv
        wceq va cv vx cv cH co va cv wceq vx va weq va cv vx cv cH co vx cv va
        cv eqeq1 biimpd adantl com12 adantr syl6 com13 syl6 com24 imp4b rgen2a
        jctir vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy
        cX wral vy cv va cv cH co vy cv wceq va cv vy cv cH co vy cv wceq wa vy
        cX wral vx va cX vx va weq vy cv vx cv cH co vy cv wceq vx cv vy cv cH
        co vy cv wceq wa vy cv va cv cH co vy cv wceq va cv vy cv cH co vy cv
        wceq wa vy cX vx va weq vy cv vx cv cH co vy cv wceq vy cv va cv cH co
        vy cv wceq vx cv vy cv cH co vy cv wceq va cv vy cv cH co vy cv wceq vx
        va weq vy cv vx cv cH co vy cv va cv cH co vy cv vx cv va cv vy cv cH
        opreq2 eqeq1d vx va weq vx cv vy cv cH co va cv vy cv cH co vy cv vx cv
        va cv vy cv cH opreq1 eqeq1d anbi12d ralbidv reu4 sylibr $.
        $( [3-Aug-2009] $) $( [12-Jul-2009] $)
    $}

    ${
      uridm.2 $e |- U = ( Id ` H ) $.
      $( The unit of a ring is an identity element for the multiplication. $)
      uridm $p |- ( ( R e. Ring /\ A e. X ) ->
        ( ( U H A ) = A /\ ( A H U ) = A ) ) $=
        cR cring wcel cA cX wcel cU cA cH co cA wceq cA cU cH co cA wceq wa cR
        cring wcel cA cX wcel cU cA cH co cA wceq cA cU cH co cA wceq wa wi cA
        cH crn wcel cU cA cH co cA wceq cA cU cH co cA wceq wa wi cR cring wcel
        cH cmnd wcel cH cmagm cexid cin wcel cA cH crn wcel cU cA cH co cA wceq
        cA cU cH co cA wceq wa wi cR cH ununr.1 unmnd cH mndmgmid cH cmagm
        cexid cin wcel cA cH crn wcel cU cA cH co cA wceq cA cU cH co cA wceq
        wa cA cU cH cH crn cH crn eqid uridm.2 cmpidelt ex 3syl cR c1st cfv crn
        cH crn wceq cR cring wcel cA cX wcel cU cA cH co cA wceq cA cU cH co cA
        wceq wa wi cA cH crn wcel cU cA cH co cA wceq cA cU cH co cA wceq wa wi
        wb cR cR c1st cfv cH ununr.1 cR c1st cfv eqid rnplrnml cX cR c1st cfv
        crn wceq cR c1st cfv crn cH crn wceq cR cring wcel cA cX wcel cU cA cH
        co cA wceq cA cU cH co cA wceq wa wi cA cH crn wcel cU cA cH co cA wceq
        cA cU cH co cA wceq wa wi wb wi ununr.2 cX cR c1st cfv crn wceq cR c1st
        cfv crn cH crn wceq wa cX cH crn wceq cR cring wcel cA cX wcel cU cA cH
        co cA wceq cA cU cH co cA wceq wa wi cA cH crn wcel cU cA cH co cA wceq
        cA cU cH co cA wceq wa wi wb wi cX cR c1st cfv crn cH crn eqtr cX cH
        crn wceq cR cring wcel cA cX wcel cU cA cH co cA wceq cA cU cH co cA
        wceq wa wi cA cH crn wcel cU cA cH co cA wceq cA cU cH co cA wceq wa wi
        wb cX cH crn wceq cR cring wcel wa cA cX wcel cA cH crn wcel cU cA cH
        co cA wceq cA cU cH co cA wceq wa cX cH crn wceq cR cring wcel wa cX cH
        crn cA cX cH crn wceq cR cring wcel pm3.26 eleq2d imbi1d ex syl mpan
        mpcom mpbird imp $.
        $( [18-Feb-2010] $) $( [18-Feb-2010] $)

      $( The unit of a ring is an identity element for the multiplication. $)
      uridm1 $p |- ( ( R e. Ring /\ A e. X ) -> ( U H A ) = A ) $=
        cR cring wcel cA cX wcel wa cU cA cH co cA wceq cA cU cH co cA wceq cA
        cR cU cH cX ununr.1 ununr.2 uridm.2 uridm pm3.26d $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)

      $( The unit of a ring is an identity element for the multiplication. $)
      uridm2 $p |- ( ( R e. Ring /\ A e. X ) -> ( A H U ) = A ) $=
        cR cring wcel cA cX wcel wa cU cA cH co cA wceq cA cU cH co cA wceq cA
        cR cU cH cX ununr.1 ununr.2 uridm.2 uridm pm3.27d $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
   $}

  $}

  ${
    rnginvcl.1 $e |- X = ran G $.
    rnginvcl.2 $e |- N = ( inv ` G ) $.
    $( The additive inverse of a unital ring element pertains to
       the unital ring. $)
    rnginvcl $p |- ( ( <. G , H >. e. Ring /\ A e. X ) -> ( N ` A ) e. X ) $=
      cG cH cop cring wcel cA cX wcel cA cN cfv cX wcel cG cH cop cring wcel cG
      cabl wcel cG cgr wcel cA cX wcel cA cN cfv cX wcel wi cG cH fora cG
      ablgrp cG cgr wcel cA cX wcel cA cN cfv cX wcel cA cG cN cX rnginvcl.1
      rnginvcl.2 grpinvcl ex 3syl imp $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
   zerab.1 $e |- Z = ( Id ` G ) $.
   zerab.2 $e |- X = ran G $.
   zerab.3 $e |- G = ( 1st ` R ) $.
   zerab.4 $e |- H = ( 2nd ` R ) $.
   $( The zero of a unital ring is a left absorbing element. $)
   zerab $p |- ( ( R e. Ring /\ A e. X ) -> ( Z H A ) = Z ) $=
     cR cring wcel cA cX wcel wa cZ cA cH co cZ cA cH co cG co cZ cA cH co cZ
     cG co wceq cZ cA cH co cZ wceq cR cring wcel cA cX wcel wa cZ cZ cG co cA
     cH co cZ cA cH co cZ cA cH co cZ cA cH co cG co cZ cA cH co cZ cG co cR
     cring wcel cA cX wcel wa cZ cZ cG co cZ cA cH cR cring wcel cZ cZ cG co cZ
     wceq cA cX wcel cR cring wcel cG cgr wcel cZ cZ cG co cZ wceq cR cG
     zerab.3 ringgrp cG cgr wcel cZ cX wcel cZ cZ cG co cZ wceq cZ cG cX
     zerab.2 zerab.1 grpidcl cZ cZ cG cX zerab.2 zerab.1 grplid mpdan syl
     adantr opreq1d cR cring wcel cA cX wcel cZ cX wcel cZ cX wcel cA cX wcel
     w3a cZ cZ cG co cA cH co cZ cA cH co cZ cA cH co cG co wceq cR cring wcel
     cA cX wcel wa cZ cX wcel cZ cX wcel cA cX wcel cR cring wcel cZ cX wcel cA
     cX wcel cR cG cX cZ zerab.3 zerab.2 zerab.1 ring0cl adantr cR cring wcel
     cZ cX wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2 zerab.1 ring0cl adantr
     cR cring wcel cA cX wcel pm3.27 3jca cZ cZ cA cR cG cH cX zerab.3 zerab.4
     zerab.2 ringdir syldan cG cgr wcel cZ cA cH co cX wcel cZ cA cH co cZ cA
     cH co cZ cG co wceq cR cring wcel cA cX wcel wa cG cgr wcel cZ cA cH co cX
     wcel wa cZ cA cH co cZ cG co cZ cA cH co cZ cA cH co cZ cG cX zerab.2
     zerab.1 grprid eqcomd cR cring wcel cG cgr wcel cA cX wcel cR cG zerab.3
     ringgrp adantr cR cring wcel cZ cX wcel cA cX wcel cZ cA cH co cX wcel cR
     cring wcel cA cX wcel wa cZ cA cR cG cH cX zerab.3 zerab.4 zerab.2 ringcl
     cR cring wcel cA cX wcel pm3.26 cR cring wcel cZ cX wcel cA cX wcel cR cG
     cX cZ zerab.3 zerab.2 zerab.1 ring0cl adantr cR cring wcel cA cX wcel
     pm3.27 syl3anc sylanc 3eqtr3d cG cgr wcel cZ cA cH co cX wcel cZ cX wcel
     cZ cA cH co cX wcel w3a cZ cA cH co cZ cA cH co cG co cZ cA cH co cZ cG co
     wceq cZ cA cH co cZ wceq wb cR cring wcel cA cX wcel wa cZ cA cH co cZ cZ
     cA cH co cG cX zerab.2 grplcan cR cring wcel cG cgr wcel cA cX wcel cR cG
     zerab.3 ringgrp adantr cR cring wcel cA cX wcel wa cZ cA cH co cX wcel cZ
     cX wcel cZ cA cH co cX wcel cR cring wcel cZ cX wcel cA cX wcel cZ cA cH
     co cX wcel cR cring wcel cA cX wcel wa cZ cA cR cG cH cX zerab.3 zerab.4
     zerab.2 ringcl cR cring wcel cA cX wcel pm3.26 cR cring wcel cZ cX wcel cA
     cX wcel cR cG cX cZ zerab.3 zerab.2 zerab.1 ring0cl adantr cR cring wcel
     cA cX wcel pm3.27 syl3anc cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ
     zerab.3 zerab.2 zerab.1 ring0cl adantr cR cring wcel cZ cX wcel cA cX wcel
     cZ cA cH co cX wcel cR cring wcel cA cX wcel wa cZ cA cR cG cH cX zerab.3
     zerab.4 zerab.2 ringcl cR cring wcel cA cX wcel pm3.26 cR cring wcel cZ cX
     wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2 zerab.1 ring0cl adantr cR
     cring wcel cA cX wcel pm3.27 syl3anc 3jca sylanc mpbid $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)

   $( The zero of a unital ring is a right absorbing element. $)
   zerab2 $p |- ( ( R e. Ring /\ A e. X ) -> ( A H Z ) = Z ) $=
     cR cring wcel cA cX wcel wa cA cZ cH co cA cZ cH co cG co cZ cA cZ cH co
     cG co wceq cA cZ cH co cZ wceq cR cring wcel cA cX wcel wa cA cZ cZ cG co
     cH co cA cZ cH co cA cZ cH co cA cZ cH co cG co cZ cA cZ cH co cG co cR
     cring wcel cA cX wcel wa cZ cZ cG co cZ cA cH cR cring wcel cZ cZ cG co cZ
     wceq cA cX wcel cR cring wcel cG cgr wcel cZ cZ cG co cZ wceq cR cG
     zerab.3 ringgrp cG cgr wcel cZ cX wcel cZ cZ cG co cZ wceq cZ cG cX
     zerab.2 zerab.1 grpidcl cZ cZ cG cX zerab.2 zerab.1 grplid mpdan syl
     adantr opreq2d cR cring wcel cA cX wcel cA cX wcel cZ cX wcel cZ cX wcel
     w3a cA cZ cZ cG co cH co cA cZ cH co cA cZ cH co cG co wceq cR cring wcel
     cA cX wcel wa cA cX wcel cZ cX wcel cZ cX wcel cR cring wcel cA cX wcel
     pm3.27 cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2
     zerab.1 ring0cl adantr cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ
     zerab.3 zerab.2 zerab.1 ring0cl adantr 3jca cA cZ cZ cR cG cH cX zerab.3
     zerab.4 zerab.2 ringdi syldan cG cgr wcel cA cZ cH co cX wcel cA cZ cH co
     cZ cA cZ cH co cG co wceq cR cring wcel cA cX wcel wa cG cgr wcel cA cZ cH
     co cX wcel wa cZ cA cZ cH co cG co cA cZ cH co cA cZ cH co cZ cG cX
     zerab.2 zerab.1 grplid eqcomd cR cring wcel cG cgr wcel cA cX wcel cR cG
     zerab.3 ringgrp adantr cR cring wcel cA cX wcel cZ cX wcel cA cZ cH co cX
     wcel cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2
     zerab.1 ring0cl adantr cA cZ cR cG cH cX zerab.3 zerab.4 zerab.2 ringcl
     mpd3an3 sylanc 3eqtr3d cG cgr wcel cA cZ cH co cX wcel cZ cX wcel cA cZ cH
     co cX wcel w3a cA cZ cH co cA cZ cH co cG co cZ cA cZ cH co cG co wceq cA
     cZ cH co cZ wceq wb cR cring wcel cA cX wcel wa cA cZ cH co cZ cA cZ cH co
     cG cX zerab.2 grprcan cR cring wcel cG cgr wcel cA cX wcel cR cG zerab.3
     ringgrp adantr cR cring wcel cA cX wcel wa cA cZ cH co cX wcel cZ cX wcel
     cA cZ cH co cX wcel cR cring wcel cA cX wcel cZ cX wcel cA cZ cH co cX
     wcel cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2
     zerab.1 ring0cl adantr cA cZ cR cG cH cX zerab.3 zerab.4 zerab.2 ringcl
     mpd3an3 cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2
     zerab.1 ring0cl adantr cR cring wcel cA cX wcel cZ cX wcel cA cZ cH co cX
     wcel cR cring wcel cZ cX wcel cA cX wcel cR cG cX cZ zerab.3 zerab.2
     zerab.1 ring0cl adantr cA cZ cR cG cH cX zerab.3 zerab.4 zerab.2 ringcl
     mpd3an3 3jca sylanc mpbid $.
     $( [7-Sep-2009] $) $( [31-Aug-2009] $)
  $}

  ${
   multinv.1 $e |- X = ran G $.
   multinv.2 $e |- G = ( 1st ` R ) $.
   multinv.3 $e |- H = ( 2nd ` R ) $.
   $( Multiplication by an additive inverse. $)
   multinv $p |- (  ( R e. Ring /\ A e. X /\ B e. X )
    ->   ( ( ( inv ` G ) ` A ) H B ) = ( ( inv ` G ) ` ( A H B ) ) ) $=
     cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH co cG cgn cfv cfv cA cG
     cgn cfv cfv cB cH co cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH co
     cG cgn cfv cfv cA cG cgn cfv cfv cB cH co wceq cA cB cH co cA cG cgn cfv
     cfv cB cH co cG co cG cgi cfv wceq cR cring wcel cA cX wcel cB cX wcel w3a
     cA cB cH co cA cG cgn cfv cfv cB cH co cG co cA cA cG cgn cfv cfv cG co cB
     cH co cG cgi cfv cB cH co cG cgi cfv cR cring wcel cA cX wcel cA cG cgn
     cfv cfv cX wcel cB cX wcel w3a cA cB cH co cA cG cgn cfv cfv cB cH co cG
     co cA cA cG cgn cfv cfv cG co cB cH co wceq cR cring wcel cA cX wcel cB cX
     wcel w3a cR cring wcel cA cX wcel cA cG cgn cfv cfv cX wcel cB cX wcel w3a
     wa cA cA cG cgn cfv cfv cG co cB cH co cA cB cH co cA cG cgn cfv cfv cB cH
     co cG co cA cA cG cgn cfv cfv cB cR cG cH cX multinv.2 multinv.3 multinv.1
     ringdir eqcomd cR cring wcel cA cX wcel cB cX wcel 3simp1 cR cring wcel cA
     cX wcel cB cX wcel w3a cA cX wcel cA cG cgn cfv cfv cX wcel cB cX wcel cR
     cring wcel cA cX wcel cB cX wcel 3simp2 cR cring wcel cA cX wcel cB cX
     wcel cA cG cgn cfv cfv cX wcel cR cring wcel cA cX wcel cA cG cgn cfv cfv
     cX wcel cB cX wcel cR cring wcel cG cgr wcel cA cX wcel cA cG cgn cfv cfv
     cX wcel wi cR cG multinv.2 ringgrp cG cgr wcel cA cX wcel cA cG cgn cfv
     cfv cX wcel cA cG cG cgn cfv cX multinv.1 cG cgn cfv eqid grpinvcl ex syl
     a1dd 3imp cR cring wcel cA cX wcel cB cX wcel 3simp3 3jca sylanc cR cring
     wcel cA cX wcel cB cX wcel w3a cA cA cG cgn cfv cfv cG co cG cgi cfv cB cH
     cG cgr wcel cA cX wcel cA cA cG cgn cfv cfv cG co cG cgi cfv wceq cR cring
     wcel cA cX wcel cB cX wcel w3a cA cG cgi cfv cG cG cgn cfv cX multinv.1 cG
     cgi cfv eqid cG cgn cfv eqid grprinv cR cring wcel cA cX wcel cG cgr wcel
     cB cX wcel cR cG multinv.2 ringgrp 3ad2ant1 cR cring wcel cA cX wcel cB cX
     wcel 3simp2 sylanc opreq1d cR cring wcel cB cX wcel cG cgi cfv cB cH co cG
     cgi cfv wceq cA cX wcel cB cR cG cH cX cG cgi cfv cG cgi cfv eqid
     multinv.1 multinv.2 multinv.3 zerab 3adant2 3eqtrd cG cgr wcel cA cB cH co
     cX wcel cA cG cgn cfv cfv cB cH co cX wcel cA cB cH co cG cgn cfv cfv cA
     cG cgn cfv cfv cB cH co wceq cA cB cH co cA cG cgn cfv cfv cB cH co cG co
     cG cgi cfv wceq wb cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH co cA
     cG cgn cfv cfv cB cH co cG cgi cfv cG cG cgn cfv cX multinv.1 cG cgi cfv
     eqid cG cgn cfv eqid grpinvid1 cR cring wcel cA cX wcel cG cgr wcel cB cX
     wcel cR cG multinv.2 ringgrp 3ad2ant1 cA cB cR cG cH cX multinv.2
     multinv.3 multinv.1 ringcl cR cring wcel cA cG cgn cfv cfv cX wcel cB cX
     wcel cA cG cgn cfv cfv cB cH co cX wcel cA cX wcel cA cG cgn cfv cfv cB cR
     cG cH cX multinv.2 multinv.3 multinv.1 ringcl cR cring wcel cA cX wcel cB
     cX wcel cA cG cgn cfv cfv cX wcel cR cring wcel cA cX wcel cA cG cgn cfv
     cfv cX wcel cB cX wcel cR cring wcel cG cgr wcel cA cX wcel cA cG cgn cfv
     cfv cX wcel wi cR cG multinv.2 ringgrp cG cgr wcel cA cX wcel cA cG cgn
     cfv cfv cX wcel cA cG cG cgn cfv cX multinv.1 cG cgn cfv eqid grpinvcl ex
     syl a1dd 3imp syld3an2 syl3anc mpbird eqcomd $.
     $( [7-Sep-2009] $) $( [2-Sep-2009] $)

   $( Multiplication by an additive inverse. $)
   multinvb $p |- (  ( R e. Ring /\ A e. X /\ B e. X )
     ->   ( A H ( ( inv ` G ) ` B ) ) = ( ( inv ` G ) ` ( A H B ) ) ) $=
     cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH co cG cgn cfv cfv cA cB
     cG cgn cfv cfv cH co cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH co
     cG cgn cfv cfv cA cB cG cgn cfv cfv cH co wceq cA cB cH co cA cB cG cgn
     cfv cfv cH co cG co cG cgi cfv wceq cR cring wcel cA cX wcel cB cX wcel
     w3a cA cB cB cG cgn cfv cfv cG co cH co cA cG cgi cfv cH co cA cB cH co cA
     cB cG cgn cfv cfv cH co cG co cG cgi cfv cR cring wcel cA cX wcel cB cX
     wcel w3a cB cB cG cgn cfv cfv cG co cG cgi cfv cA cH cG cgr wcel cB cX
     wcel cB cB cG cgn cfv cfv cG co cG cgi cfv wceq cR cring wcel cA cX wcel
     cB cX wcel w3a cB cG cgi cfv cG cG cgn cfv cX multinv.1 cG cgi cfv eqid cG
     cgn cfv eqid grprinv cR cring wcel cA cX wcel cG cgr wcel cB cX wcel cR cG
     multinv.2 ringgrp 3ad2ant1 cR cring wcel cA cX wcel cB cX wcel 3simp3
     sylanc opreq2d cR cring wcel cA cX wcel cB cX wcel cB cG cgn cfv cfv cX
     wcel w3a cA cB cB cG cgn cfv cfv cG co cH co cA cB cH co cA cB cG cgn cfv
     cfv cH co cG co wceq cR cring wcel cA cX wcel cB cX wcel w3a cA cB cB cG
     cgn cfv cfv cR cG cH cX multinv.2 multinv.3 multinv.1 ringdi cR cring wcel
     cA cX wcel cB cX wcel 3simp1 cR cring wcel cA cX wcel cB cX wcel w3a cA cX
     wcel cB cX wcel cB cG cgn cfv cfv cX wcel cR cring wcel cA cX wcel cB cX
     wcel 3simp2 cR cring wcel cA cX wcel cB cX wcel 3simp3 cR cring wcel cA cX
     wcel cB cX wcel cB cG cgn cfv cfv cX wcel cR cring wcel cB cX wcel cB cG
     cgn cfv cfv cX wcel wi cA cX wcel cR cring wcel cG cgr wcel cB cX wcel cB
     cG cgn cfv cfv cX wcel wi cR cG multinv.2 ringgrp cG cgr wcel cB cX wcel
     cB cG cgn cfv cfv cX wcel cB cG cG cgn cfv cX multinv.1 cG cgn cfv eqid
     grpinvcl ex syl a1d 3imp 3jca sylanc cR cring wcel cA cX wcel cA cG cgi
     cfv cH co cG cgi cfv wceq cB cX wcel cA cR cG cH cX cG cgi cfv cG cgi cfv
     eqid multinv.1 multinv.2 multinv.3 zerab2 3adant3 3eqtr3d cG cgr wcel cA
     cB cH co cX wcel cA cB cG cgn cfv cfv cH co cX wcel cA cB cH co cG cgn cfv
     cfv cA cB cG cgn cfv cfv cH co wceq cA cB cH co cA cB cG cgn cfv cfv cH co
     cG co cG cgi cfv wceq wb cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH
     co cA cB cG cgn cfv cfv cH co cG cgi cfv cG cG cgn cfv cX multinv.1 cG cgi
     cfv eqid cG cgn cfv eqid grpinvid1 cR cring wcel cA cX wcel cG cgr wcel cB
     cX wcel cR cG multinv.2 ringgrp 3ad2ant1 cA cB cR cG cH cX multinv.2
     multinv.3 multinv.1 ringcl cR cring wcel cA cX wcel cB cG cgn cfv cfv cX
     wcel cA cB cG cgn cfv cfv cH co cX wcel cB cX wcel cA cB cG cgn cfv cfv cR
     cG cH cX multinv.2 multinv.3 multinv.1 ringcl cR cring wcel cA cX wcel cB
     cX wcel cB cG cgn cfv cfv cX wcel cR cring wcel cB cX wcel cB cG cgn cfv
     cfv cX wcel wi cA cX wcel cR cring wcel cG cgr wcel cB cX wcel cB cG cgn
     cfv cfv cX wcel wi cR cG multinv.2 ringgrp cG cgr wcel cB cX wcel cB cG
     cgn cfv cfv cX wcel cB cG cG cgn cfv cX multinv.1 cG cgn cfv eqid grpinvcl
     ex syl a1d 3imp syld3an3 syl3anc mpbird eqcomd $.
     $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${
   mult2inv.1 $e |- X = ran G $.
   mult2inv.2 $e |- G = ( 1st ` R ) $.
   mult2inv.3 $e |- H = ( 2nd ` R ) $.
   $( Multiplication of two additive inverses. $)
   mult2inv $p |- ( ( R e. Ring /\ A e. X /\ B e. X )
     ->   ( ( ( inv ` G ) ` A ) H ( ( inv ` G ) ` B ) ) = ( A H B ) ) $=
     cR cring wcel cA cX wcel cB cX wcel w3a cA cG cgn cfv cfv cB cG cgn cfv
     cfv cH co cA cB cG cgn cfv cfv cH co cG cgn cfv cfv cA cB cH co cG cgn cfv
     cfv cG cgn cfv cfv cA cB cH co cR cring wcel cA cX wcel cB cG cgn cfv cfv
     cX wcel cA cG cgn cfv cfv cB cG cgn cfv cfv cH co cA cB cG cgn cfv cfv cH
     co cG cgn cfv cfv wceq cB cX wcel cA cB cG cgn cfv cfv cR cG cH cX
     mult2inv.1 mult2inv.2 mult2inv.3 multinv cG cgr wcel cB cX wcel cB cG cgn
     cfv cfv cX wcel cR cring wcel cA cX wcel cB cX wcel w3a cB cG cG cgn cfv
     cX mult2inv.1 cG cgn cfv eqid grpinvcl cR cring wcel cA cX wcel cG cgr
     wcel cB cX wcel cR cG mult2inv.2 ringgrp 3ad2ant1 cR cring wcel cA cX wcel
     cB cX wcel 3simp3 sylanc syld3an3 cR cring wcel cA cX wcel cB cX wcel w3a
     cA cB cG cgn cfv cfv cH co cA cB cH co cG cgn cfv cfv cG cgn cfv cA cB cR
     cG cH cX mult2inv.1 mult2inv.2 mult2inv.3 multinvb fveq2d cG cgr wcel cA
     cB cH co cX wcel cA cB cH co cG cgn cfv cfv cG cgn cfv cfv cA cB cH co
     wceq cR cring wcel cA cX wcel cB cX wcel w3a cA cB cH co cG cG cgn cfv cX
     mult2inv.1 cG cgn cfv eqid grp2inv cR cring wcel cA cX wcel cG cgr wcel cB
     cX wcel cR cG mult2inv.2 ringgrp 3ad2ant1 cA cB cR cG cH cX mult2inv.2
     mult2inv.3 mult2inv.1 ringcl sylanc 3eqtrd $.
     $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${
    $d A x $. $d R x $. $d X x $.
    on1el3.1 $e |- G = ( 1st ` R ) $.
    on1el3.2 $e |- X = ran G $.
    $( The only unital ring with a base set consisting in one element
       is the zero ring. $)
    on1el3 $p |- ( ( R e. Ring /\ A e. B ) -> ( X = { A } <-> R =
       <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >. ) ) $=
      cA cB wcel cR cring wcel cX cA csn wceq cR cA cA cop cA cop csn cA cA cop
      cA cop csn cop wceq wb cR cring wcel cX vx cv csn wceq cR vx cv vx cv cop
      vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq wb wi cR cring wcel
      cX cA csn wceq cR cA cA cop cA cop csn cA cA cop cA cop csn cop wceq wb
      wi vx cA cB vx cv cA wceq cX vx cv csn wceq cR vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop wceq wb cX cA csn wceq cR cA cA cop
      cA cop csn cA cA cop cA cop csn cop wceq wb cR cring wcel vx cv cA wceq
      cX vx cv csn wceq cX cA csn wceq cR vx cv vx cv cop vx cv cop csn vx cv
      vx cv cop vx cv cop csn cop wceq cR cA cA cop cA cop csn cA cA cop cA cop
      csn cop wceq vx cv cA wceq vx cv csn cA csn cX vx cv cA sneq eqeq2d vx cv
      cA wceq vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      cA cA cop cA cop csn cA cA cop cA cop csn cop cR vx cv cA wceq vx cv vx
      cv cop vx cv cop csn cA cA cop cA cop csn vx cv vx cv cop vx cv cop csn
      cA cA cop cA cop csn vx cv cA wceq vx cv vx cv cop vx cv cop cA cA cop cA
      cop vx cv vx cv cop cA cA cop wceq vx cv cA wceq vx cv vx cv cop vx cv
      cop cA cA cop cA cop wceq vx cv cA wceq vx cv vx cv cop cA cA cop wceq vx
      cv vx cv cA cA opeq12 anidms vx cv vx cv cop vx cv cA cA cop cA opeq12
      mpancom sneqd vx cv cA wceq vx cv vx cv cop vx cv cop cA cA cop cA cop vx
      cv vx cv cop cA cA cop wceq vx cv cA wceq vx cv vx cv cop vx cv cop cA cA
      cop cA cop wceq vx cv cA wceq vx cv vx cv cop cA cA cop wceq vx cv vx cv
      cA cA opeq12 anidms vx cv vx cv cop vx cv cA cA cop cA opeq12 mpancom
      sneqd opeq12d eqeq2d bibi12d imbi2d cR cring wcel cX vx cv csn wceq cR vx
      cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq cR
      cring wcel cX cX cxp vx cv csn vx cv csn cxp wceq cR vx cv vx cv cop vx
      cv cop csn vx cv vx cv cop vx cv cop csn cop wceq cX vx cv csn wceq cR
      cring wcel cX cX cxp cX cR c1st cfv wf cX cX cxp vx cv csn vx cv csn cxp
      wceq cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      wceq wi cR cring wcel cR c1st cfv cgr wcel cX cX cxp cX cR c1st cfv wfo
      cX cX cxp cX cR c1st cfv wf cR cR c1st cfv cR c1st cfv eqid ringgrp cR
      c1st cfv cX cX cG crn cR c1st cfv crn on1el3.2 cG cR c1st cfv on1el3.1
      rneqi eqtri grpfo cX cX cxp cX cR c1st cfv fof 3syl cR cring wcel cX cX
      cxp cX cR c2nd cfv wf cX cX cxp cX cR c1st cfv wf cX cX cxp vx cv csn vx
      cv csn cxp wceq cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
      cop csn cop wceq wi wi cR cG cR c2nd cfv cX on1el3.1 cR c2nd cfv eqid
      on1el3.2 ringsm cR cring wcel cX cX cxp cX cR c2nd cfv wf cX cX cxp cX cR
      c1st cfv wf cX cX cxp vx cv csn vx cv csn cxp wceq cR vx cv vx cv cop vx
      cv cop csn vx cv vx cv cop vx cv cop csn cop wceq cR cring wcel cX cX cxp
      cX cR c2nd cfv wf cX cX cxp cX cR c1st cfv wf cX cX cxp vx cv csn vx cv
      csn cxp wceq w3a cR cvv cvv cxp wcel cR c1st cfv vx cv vx cv cop vx cv
      cop csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn wceq wa wa cR vx
      cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq cR
      cring wcel cX cX cxp cX cR c2nd cfv wf cX cX cxp cX cR c1st cfv wf cX cX
      cxp vx cv csn vx cv csn cxp wceq w3a cR c1st cfv vx cv vx cv cop vx cv
      cop csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn wceq wa cR cvv cvv
      cxp wcel cX cX cxp cX cR c2nd cfv wf cX cX cxp cX cR c1st cfv wf cX cX
      cxp vx cv csn vx cv csn cxp wceq w3a cR c1st cfv vx cv vx cv cop vx cv
      cop csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn wceq wa wi cR
      cring wcel cX cX cxp cX cR c2nd cfv wf cX cX cxp cX cR c1st cfv wf cX cX
      cxp vx cv csn vx cv csn cxp wceq cR c1st cfv vx cv vx cv cop vx cv cop
      csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn wceq wa cX cX cxp vx
      cv csn vx cv csn cxp wceq cX cX cxp cX cR c1st cfv wf cX cX cxp cX cR
      c2nd cfv wf cR c1st cfv vx cv vx cv cop vx cv cop csn wceq cR c2nd cfv vx
      cv vx cv cop vx cv cop csn wceq wa cX cX cxp vx cv csn vx cv csn cxp wceq
      cX cX cxp cX cR c1st cfv wf cX cX cxp cX cR c2nd cfv wf cR c1st cfv vx cv
      vx cv cop vx cv cop csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn
      wceq wa cX cX cxp vx cv csn vx cv csn cxp wceq cX cX cxp cX cR c1st cfv
      wf cX cX cxp cX cR c2nd cfv wf wa cR c1st cfv vx cv vx cv cop vx cv cop
      csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn wceq wa wi cX cX cxp
      vx cv csn vx cv csn cxp wceq cX vx cv csn wceq cX cX cxp cX cR c1st cfv
      wf cX cX cxp cX cR c2nd cfv wf wa cR c1st cfv vx cv vx cv cop vx cv cop
      csn wceq cR c2nd cfv vx cv vx cv cop vx cv cop csn wceq wa wi cX cX cxp
      vx cv csn vx cv csn cxp wceq cX cX cxp vx cv csn vx cv csn cxp wceq cX vx
      cv csn wceq cX cX cxp cX cR c1st cfv wf cX cX cxp cX cR c2nd cfv wf wa cR
      c1st cfv vx cv vx cv cop vx cv cop csn wceq cR c2nd cfv vx cv vx cv cop
      vx cv cop csn wceq wa wi cX cX cxp vx cv csn vx cv csn cxp wceq cX vx cv
      csn wceq wa cX cX cxp cX cR c1st cfv wf cR c1st cfv vx cv vx cv cop vx cv
      cop csn wceq cX cX cxp cX cR c2nd cfv wf cR c2nd cfv vx cv vx cv cop vx
      cv cop csn wceq cX cX cxp vx cv csn vx cv csn cxp wceq cX vx cv csn wceq
      wa cX cX cxp cX cR c1st cfv wf vx cv csn vx cv csn cxp vx cv csn cR c1st
      cfv wf cR c1st cfv vx cv vx cv cop vx cv cop csn wceq cX cX cxp cX vx cv
      csn vx cv csn cxp vx cv csn cR c1st cfv feq23 vx cv csn vx cv csn cxp vx
      cv vx cv cop csn wceq vx cv csn vx cv csn cxp vx cv csn cR c1st cfv wf cR
      c1st cfv vx cv vx cv cop vx cv cop csn wceq wi vx cv vx cv vx visset vx
      visset xpsn vx cv csn vx cv csn cxp vx cv vx cv cop csn wceq vx cv csn vx
      cv csn cxp vx cv csn cR c1st cfv wf vx cv vx cv cop csn vx cv csn cR c1st
      cfv wf cR c1st cfv vx cv vx cv cop vx cv cop csn wceq vx cv csn vx cv csn
      cxp vx cv vx cv cop csn vx cv csn cR c1st cfv feq2 vx cv vx cv cop csn vx
      cv csn cR c1st cfv wf cR c1st cfv vx cv vx cv cop csn vx cv csn cxp vx cv
      vx cv cop vx cv cop csn vx cv vx cv cop csn vx cv csn cR c1st cfv wf cR
      c1st cfv vx cv vx cv cop csn vx cv csn cxp wceq vx cv vx cv cop csn vx cv
      cR c1st cfv vx visset fconst2 biimpi vx cv vx cv cop vx cv vx cv vx cv
      opex vx visset xpsn syl6eq syl6bi ax-mp syl6bi cX cX cxp vx cv csn vx cv
      csn cxp wceq cX vx cv csn wceq wa cX cX cxp cX cR c2nd cfv wf vx cv csn
      vx cv csn cxp vx cv csn cR c2nd cfv wf cR c2nd cfv vx cv vx cv cop vx cv
      cop csn wceq cX cX cxp cX vx cv csn vx cv csn cxp vx cv csn cR c2nd cfv
      feq23 vx cv csn vx cv csn cxp vx cv vx cv cop csn wceq vx cv csn vx cv
      csn cxp vx cv csn cR c2nd cfv wf cR c2nd cfv vx cv vx cv cop vx cv cop
      csn wceq wi vx cv vx cv vx visset vx visset xpsn vx cv csn vx cv csn cxp
      vx cv vx cv cop csn wceq vx cv csn vx cv csn cxp vx cv csn cR c2nd cfv wf
      vx cv vx cv cop csn vx cv csn cR c2nd cfv wf cR c2nd cfv vx cv vx cv cop
      vx cv cop csn wceq vx cv csn vx cv csn cxp vx cv vx cv cop csn vx cv csn
      cR c2nd cfv feq2 vx cv vx cv cop csn vx cv csn cR c2nd cfv wf cR c2nd cfv
      vx cv vx cv cop csn vx cv csn cxp vx cv vx cv cop vx cv cop csn vx cv vx
      cv cop csn vx cv csn cR c2nd cfv wf cR c2nd cfv vx cv vx cv cop csn vx cv
      csn cxp wceq vx cv vx cv cop csn vx cv cR c2nd cfv vx visset fconst2
      biimpi vx cv vx cv cop vx cv vx cv vx cv opex vx visset xpsn syl6eq
      syl6bi ax-mp syl6bi anim12d ex cX vx cv csn xpid11 syl5ib pm2.43i exp3a
      com13 3imp a1i cring cvv cvv cxp cR cring cring cdm cring crn cxp cvv cvv
      cxp cring wrel cring cring cdm cring crn cxp wss relrng cring relssdmrn
      ax-mp cring cdm cring crn xpss sstri sseli jctild cR vx cv vx cv cop vx
      cv cop csn vx cv vx cv cop vx cv cop csn eqopi syl6 3expd mpd mpd cX vx
      cv csn xpid11 syl5ibr cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
      cv cop csn cop wceq cR c1st cfv vx cv vx cv cop vx cv cop csn vx cv vx cv
      cop vx cv cop csn cop c1st cfv wceq cR c1st cfv vx cv vx cv cop vx cv cop
      csn wceq cX vx cv csn wceq cR vx cv vx cv cop vx cv cop csn vx cv vx cv
      cop vx cv cop csn cop c1st fveq2 cR c1st cfv vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop c1st cfv wceq vx cv vx cv cop vx cv
      cop csn vx cv vx cv cop vx cv cop csn cop c1st cfv vx cv vx cv cop vx cv
      cop csn wceq cR c1st cfv vx cv vx cv cop vx cv cop csn wceq vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop
      snex op1st cR c1st cfv vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
      cv cop csn cop c1st cfv vx cv vx cv cop vx cv cop csn eqtr mpan2 cR c1st
      cfv vx cv vx cv cop vx cv cop csn wceq cR c1st cfv crn vx cv vx cv cop vx
      cv cop csn crn cX vx cv csn cR c1st cfv vx cv vx cv cop vx cv cop csn
      rneq cX cR c1st cfv crn cG cR c1st cfv wceq cX cR c1st cfv crn wceq
      on1el3.1 cG cR c1st cfv wceq cG crn cR c1st cfv crn cX cG cR c1st cfv
      rneq on1el3.2 syl5eq ax-mp eqcomi vx cv vx cv cop vx cv vx cv vx cv opex
      vx visset rnsnop 3eqtr3g 3syl impbid1 vtoclg impcom $.
      $( [18-Feb-2010] $) $( [13-Feb-2010] $)

    ${
      $d A x $. $d R x $. $d X x $.
      $( The only unital ring with one element is the zero ring. $)
      on1el4 $p |- ( ( R e. Ring /\ A e. X ) -> ( X ~~ 1o <-> R =
       <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >. ) ) $=
        cA cX wcel cR cring wcel cX c1o cen wbr cR cA cA cop cA cop csn cA cA
        cop cA cop csn cop wceq wb cR cring wcel cX c1o cen wbr cR vx cv vx cv
        cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq wb wi cR cring
        wcel cX c1o cen wbr cR cA cA cop cA cop csn cA cA cop cA cop csn cop
        wceq wb wi vx cA cX vx cv cA wceq cX c1o cen wbr cR vx cv vx cv cop vx
        cv cop csn vx cv vx cv cop vx cv cop csn cop wceq wb cX c1o cen wbr cR
        cA cA cop cA cop csn cA cA cop cA cop csn cop wceq wb cR cring wcel vx
        cv cA wceq cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop
        csn cop wceq cR cA cA cop cA cop csn cA cA cop cA cop csn cop wceq cX
        c1o cen wbr vx cv cA wceq vx cv vx cv cop vx cv cop csn vx cv vx cv cop
        vx cv cop csn cop cA cA cop cA cop csn cA cA cop cA cop csn cop cR vx
        cv cA wceq vx cv vx cv cop vx cv cop csn cA cA cop cA cop csn vx cv vx
        cv cop vx cv cop csn cA cA cop cA cop csn vx cv cA wceq vx cv vx cv cop
        vx cv cop cA cA cop cA cop vx cv vx cv cop cA cA cop wceq vx cv cA wceq
        vx cv vx cv cop vx cv cop cA cA cop cA cop wceq vx cv cA wceq vx cv vx
        cv cop cA cA cop wceq vx cv vx cv cA cA opeq12 anidms vx cv vx cv cop
        vx cv cA cA cop cA opeq12 mpancom sneqd vx cv cA wceq vx cv vx cv cop
        vx cv cop cA cA cop cA cop vx cv vx cv cop cA cA cop wceq vx cv cA wceq
        vx cv vx cv cop vx cv cop cA cA cop cA cop wceq vx cv cA wceq vx cv vx
        cv cop cA cA cop wceq vx cv vx cv cA cA opeq12 anidms vx cv vx cv cop
        vx cv cA cA cop cA opeq12 mpancom sneqd opeq12d eqeq2d bibi2d imbi2d vx
        cv cX wcel cR cring wcel cX c1o cen wbr cR vx cv vx cv cop vx cv cop
        csn vx cv vx cv cop vx cv cop csn cop wceq wb vx cv cX wcel cR cring
        wcel wa cX c1o cen wbr cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop
        vx cv cop csn cop wceq vx cv cX wcel cR cring wcel cX c1o cen wbr cR vx
        cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq wi vx
        cv cX wcel cX c1o cen wbr cR cring wcel cR vx cv vx cv cop vx cv cop
        csn vx cv vx cv cop vx cv cop csn cop wceq cX c1o cen wbr vx cv cX wcel
        cR cring wcel cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
        cop csn cop wceq wi vx cv cX wcel cX c1o cen wbr vx cv cX wcel cR cring
        wcel cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
        wceq wi wi vx cv cX wcel cX c1o cen wbr wa cX vx cv csn wceq vx cv cX
        wcel cR cring wcel cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
        cv cop csn cop wceq wi wi vx cv cX setwoe cR cring wcel vx cv cX wcel
        cX vx cv csn wceq cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
        cv cop csn cop wceq cR cring wcel vx cv cX wcel cX vx cv csn wceq cR vx
        cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq wi cR
        cring wcel vx cv cX wcel wa cX vx cv csn wceq cR vx cv vx cv cop vx cv
        cop csn vx cv vx cv cop vx cv cop csn cop wceq vx cv cX cR cG cX
        on1el3.1 on1el3.2 on1el3 biimpd ex com13 syl ex pm2.43a com23 imp vx cv
        cX wcel cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
        cop wceq cX c1o cen wbr wi cR cring wcel cR vx cv vx cv cop vx cv cop
        csn vx cv vx cv cop vx cv cop csn cop wceq vx cv cX wcel cX c1o cen wbr
        cR vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop wceq
        cR c1st cfv vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
        cop c1st cfv wceq vx cv cX wcel cX c1o cen wbr wi cR vx cv vx cv cop vx
        cv cop csn vx cv vx cv cop vx cv cop csn cop c1st fveq2 cR c1st cfv vx
        cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop c1st cfv
        wceq vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
        c1st cfv vx cv vx cv cop vx cv cop csn wceq vx cv cX wcel cX c1o cen
        wbr wi vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn vx
        cv vx cv cop vx cv cop snex op1st cR c1st cfv vx cv vx cv cop vx cv cop
        csn vx cv vx cv cop vx cv cop csn cop c1st cfv wceq vx cv vx cv cop vx
        cv cop csn vx cv vx cv cop vx cv cop csn cop c1st cfv vx cv vx cv cop
        vx cv cop csn wceq wa cR c1st cfv vx cv vx cv cop vx cv cop csn wceq vx
        cv cX wcel cX c1o cen wbr wi cR c1st cfv vx cv vx cv cop vx cv cop csn
        vx cv vx cv cop vx cv cop csn cop c1st cfv vx cv vx cv cop vx cv cop
        csn eqtr cR c1st cfv vx cv vx cv cop vx cv cop csn wceq cR c1st cfv crn
        vx cv vx cv cop vx cv cop csn crn wceq vx cv cX wcel cX c1o cen wbr wi
        cR c1st cfv vx cv vx cv cop vx cv cop csn rneq cG cR c1st cfv wceq cR
        c1st cfv crn vx cv vx cv cop vx cv cop csn crn wceq vx cv cX wcel cX
        c1o cen wbr wi wi on1el3.1 cX cG crn wceq cG crn cR c1st cfv crn wceq
        cR c1st cfv crn vx cv vx cv cop vx cv cop csn crn wceq vx cv cX wcel cX
        c1o cen wbr wi wi cG cR c1st cfv wceq cX cG crn wceq cG crn cR c1st cfv
        crn wceq wa cX cR c1st cfv crn wceq cR c1st cfv crn vx cv vx cv cop vx
        cv cop csn crn wceq vx cv cX wcel cX c1o cen wbr wi wi cX cG crn cR
        c1st cfv crn eqtr cX cR c1st cfv crn wceq cR c1st cfv crn vx cv vx cv
        cop vx cv cop csn crn wceq vx cv cX wcel cX c1o cen wbr wi cX cR c1st
        cfv crn wceq cR c1st cfv crn vx cv vx cv cop vx cv cop csn crn wceq wa
        cX vx cv vx cv cop vx cv cop csn crn wceq vx cv cX wcel cX c1o cen wbr
        wi cX cR c1st cfv crn vx cv vx cv cop vx cv cop csn crn eqtr cX vx cv
        vx cv cop vx cv cop csn crn wceq vx cv vx cv cop vx cv cop csn crn vx
        cv csn wceq vx cv cX wcel cX c1o cen wbr wi vx cv vx cv cop vx cv vx cv
        vx cv opex vx visset rnsnop cX vx cv vx cv cop vx cv cop csn crn wceq
        vx cv vx cv cop vx cv cop csn crn vx cv csn wceq wa cX vx cv csn wceq
        vx cv cX wcel cX c1o cen wbr wi cX vx cv vx cv cop vx cv cop csn crn vx
        cv csn eqtr cX vx cv csn wceq cX c1o cen wbr vx cv cX wcel cX vx cv csn
        wceq cX c1o cen wbr vx cv csn c1o cen wbr vx cv vx visset ensn1 cX vx
        cv csn c1o cen breq1 mpbiri a1d syl mpan2 syl ex syl on1el3.2 cG cR
        c1st cfv rneq sylancr ax-mp syl syl mpan2 syl com12 adantr impbid ex
        vtoclga impcom $.
        $( [18-Feb-2010] $) $( [14-Feb-2010] $)
    $}

    ${
      on1el3.3 $e |- Z = ( Id ` G ) $.
      $( The only unital ring with one element is the zero ring. $)
      on1el6 $p |- ( R e. Ring -> ( X ~~ 1o <-> R =
        <. { <. <. Z , Z >. , Z >. } , { <. <. Z , Z >. , Z >. } >. ) ) $=
        cR cring wcel cZ cX wcel cX c1o cen wbr cR cZ cZ cop cZ cop csn cZ cZ
        cop cZ cop csn cop wceq wb cR cG cX cZ on1el3.1 on1el3.2 on1el3.3
        ring0cl cZ cR cG cX on1el3.1 on1el3.2 on1el4 mpdan $.
        $( [18-Feb-2010] $) $( [15-Feb-2010] $)
    $}
  $}

  ${
    $d H u x $. $d X u x $.
    rngunval2.1 $e |- X = ran ( 1st ` R ) $.
    rngunval2.2 $e |- H = ( 2nd ` R ) $.
    rngunval2.3 $e |- U = ( Id ` H ) $.
    $( The value of the unit of a ring. $)
    rngunval2 $p |- ( R e. Ring -> U = U. { u e. X |
     A. x e. X ( ( u H x ) = x /\ ( x H u ) = x ) } ) $=
      cR cring wcel cU vu cv vx cv cH co vx cv wceq vx cv vu cv cH co vx cv
      wceq wa vx cH crn wral vu cH crn crab cuni vu cv vx cv cH co vx cv wceq
      vx cv vu cv cH co vx cv wceq wa vx cX wral vu cX crab cuni cR cring wcel
      cH cvv wcel cU vu cv vx cv cH co vx cv wceq vx cv vu cv cH co vx cv wceq
      wa vx cH crn wral vu cH crn crab cuni wceq cR cring wcel cH cR c2nd cfv
      cvv cH cR c2nd cfv wceq cR cring wcel rngunval2.2 a1i cR c2nd fvex
      syl6eqel vx vu cvv cU cH cH crn cH crn eqid rngunval2.3 idrval syl cR
      cring wcel vu cv vx cv cH co vx cv wceq vx cv vu cv cH co vx cv wceq wa
      vx cX wral vu cX crab vu cv vx cv cH co vx cv wceq vx cv vu cv cH co vx
      cv wceq wa vx cH crn wral vu cH crn crab cR cring wcel cX cH crn wceq vu
      cv vx cv cH co vx cv wceq vx cv vu cv cH co vx cv wceq wa vx cX wral vu
      cX crab vu cv vx cv cH co vx cv wceq vx cv vu cv cH co vx cv wceq wa vx
      cH crn wral vu cH crn crab wceq cR cring wcel cR c1st cfv crn cH crn cX
      cR cR c1st cfv cH rngunval2.2 cR c1st cfv eqid rnplrnml rngunval2.1
      syl5eq cX cH crn wceq vu cv vx cv cH co vx cv wceq vx cv vu cv cH co vx
      cv wceq wa vx cX wral vu cX crab vu cv vx cv cH co vx cv wceq vx cv vu cv
      cH co vx cv wceq wa vx cX wral vu cH crn crab vu cv vx cv cH co vx cv
      wceq vx cv vu cv cH co vx cv wceq wa vx cH crn wral vu cH crn crab vu cv
      vx cv cH co vx cv wceq vx cv vu cv cH co vx cv wceq wa vx cX wral vu cX
      cH crn rabeq cX cH crn wceq vu cv vx cv cH co vx cv wceq vx cv vu cv cH
      co vx cv wceq wa vx cX wral vu cv vx cv cH co vx cv wceq vx cv vu cv cH
      co vx cv wceq wa vx cH crn wral vu cH crn vu cv vx cv cH co vx cv wceq vx
      cv vu cv cH co vx cv wceq wa vx cX cH crn raleq1 rabbisdv eqtrd syl
      unieqd eqtr4d $.
      $( [18-Feb-2010] $) $( [12-Feb-2010] $)

   $( The unit of a ring belongs to the base set. $)
   ring1cl $p |- ( R e. Ring -> U e. X ) $=
     cR cring wcel cU cX wcel cU cR c2nd cfv crn wcel cR cring wcel cR c2nd cfv
     cmagm cexid cin wcel cU cR c2nd cfv crn wcel cR cring wcel cR c2nd cfv
     cmagm wcel cR c2nd cfv cexid wcel wa cR c2nd cfv cmagm cexid cin wcel cR
     cring wcel cH cmnd wcel cR c2nd cfv cmagm wcel cR c2nd cfv cexid wcel wa
     cR cH rngunval2.2 unmnd cH cmnd wcel cR c2nd cfv cmnd wcel cR c2nd cfv
     cmagm wcel cR c2nd cfv cexid wcel wa cH cR c2nd cfv cmnd rngunval2.2
     eleq1i cR c2nd cfv cmnd wcel cR c2nd cfv cmagm wcel cR c2nd cfv cexid wcel
     cR c2nd cfv mndismgm cR c2nd cfv mndisexid jca sylbi syl cR c2nd cfv cmagm
     cexid elin sylibr cU cR c2nd cfv cR c2nd cfv crn cR c2nd cfv crn eqid cU
     cH cgi cfv cR c2nd cfv cgi cfv rngunval2.3 cH cR c2nd cfv cgi rngunval2.2
     fveq2i eqtri iorlid syl cX cR c1st cfv crn wceq cR c1st cfv crn cR c2nd
     cfv crn wceq cU cX wcel cU cR c2nd cfv crn wcel wb cR cring wcel cX cR
     c1st cfv crn wceq cR c1st cfv crn cR c2nd cfv crn wceq wa cX cR c2nd cfv
     crn cU cX cR c1st cfv crn cR c2nd cfv crn eqtr eleq2d rngunval2.1 cR cR
     c1st cfv cR c2nd cfv cR c2nd cfv eqid cR c1st cfv eqid rnplrnml sylancr
     mpbird $.
     $( [18-Feb-2010] $) $( [12-Feb-2010] $)
  $}

  ${
    $d R x $. $d U x $. $d X x $. $d Z x $.
    uznzr.1 $e |- G = ( 1st ` R ) $.
    uznzr.2 $e |- H = ( 2nd ` R ) $.
    uznzr.3 $e |- Z = ( Id ` G ) $.
    uznzr.4 $e |- U = ( Id ` H ) $.
    uznzr.5 $e |- X = ran G $.
    $( In a unital ring the zero equals the unity iff the ring
       is the zero ring.  $)
    uznzr $p |- ( R e. Ring -> ( X ~~ 1o <-> U = Z ) ) $=
      cR cring wcel cX c1o cen wbr cU cZ wceq cZ cX wcel cR cring wcel cX c1o
      cen wbr cU cZ wceq wi cR cG cX cZ uznzr.1 uznzr.5 uznzr.3 ring0cl cZ cX
      wcel cX c1o cen wbr cR cring wcel cU cZ wceq cZ cX wcel cX c1o cen wbr cR
      cring wcel cU cZ wceq wi cR cring wcel cX cZ csn wceq cU cZ wceq cZ cX
      wcel cX c1o cen wbr wa cR cring wcel cU cG crn wcel cX cZ csn wceq cU cZ
      wceq wi cR cU cH cG crn cG cR c1st cfv uznzr.1 rneqi uznzr.2 uznzr.4
      ring1cl cU cG crn wcel cU cX wcel cX cZ csn wceq cU cZ wceq wi cG crn cX
      cU cX cG crn uznzr.5 eqcomi eleq2i cX cZ csn wceq cU cX wcel cU cZ csn
      wcel cU cZ wceq cX cZ csn wceq cU cX wcel cU cZ csn wcel cX cZ csn cU
      eleq2 biimpd cU cZ elsni syl6com sylbi syl cZ cX setwoe syl5com ex com23
      mpcom cX c0 wne cR cring wcel cU cZ wceq cX c1o cen wbr wi cR cG cX
      uznzr.1 uznzr.5 rngn0 cU cZ wceq cR cring wcel cX c0 wne cX c1o cen wbr
      cR cring wcel vx cv cU cH co vx cv cZ cH co wceq vx cX wral cX c0 wne cX
      c1o cen wbr wi cU cZ wceq cR cring wcel vx cv cZ cH co cZ wceq vx cX wral
      vx cv cU cH co vx cv cZ cH co wceq vx cX wral cX c0 wne cX c1o cen wbr wi
      wi cR cring wcel vx cv cZ cH co cZ wceq vx cX vx cv cR cG cH cX cZ
      uznzr.3 uznzr.5 uznzr.1 uznzr.2 zerab2 r19.21aiva vx cv cU cH co vx cv
      wceq vx cX wral cR cring wcel vx cv cZ cH co cZ wceq vx cX wral vx cv cU
      cH co vx cv cZ cH co wceq vx cX wral cX c0 wne cX c1o cen wbr wi wi wi cR
      cring wcel vx cv cU cH co vx cv wceq vx cX cR cring wcel vx cv cX wcel wa
      cU vx cv cH co vx cv wceq vx cv cU cH co vx cv wceq vx cv cR cU cH cX
      uznzr.2 cX cG crn cR c1st cfv crn uznzr.5 cG cR c1st cfv uznzr.1 rneqi
      eqtri uznzr.4 uridm pm3.27d r19.21aiva vx cv cU cH co vx cv wceq vx cX
      wral vx cv cU cH co vx cv cZ cH co wceq vx cX wral vx cv cZ cH co cZ wceq
      vx cX wral cR cring wcel cX c0 wne cX c1o cen wbr wi vx cv cU cH co vx cv
      wceq vx cX wral vx cv cU cH co vx cv cZ cH co wceq vx cX wral vx cv cZ cH
      co cZ wceq vx cX wral cR cring wcel cX c0 wne cX c1o cen wbr wi wi wi vx
      cv cU cH co vx cv wceq vx cX wral vx cv cU cH co vx cv cZ cH co wceq vx
      cX wral wa vx cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ cH co wceq
      wa vx cX wral vx cv cZ cH co cZ wceq vx cX wral cR cring wcel cX c0 wne
      cX c1o cen wbr wi wi wi vx cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ
      cH co wceq vx cX r19.26 vx cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ
      cH co wceq wa vx cX wral vx cv cZ cH co cZ wceq vx cX wral cR cring wcel
      cX c0 wne cX c1o cen wbr wi wi vx cv cU cH co vx cv wceq vx cv cU cH co
      vx cv cZ cH co wceq wa vx cX wral vx cv cZ cH co cZ wceq vx cX wral wa vx
      cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ cH co wceq wa vx cv cZ cH
      co cZ wceq wa vx cX wral cR cring wcel cX c0 wne cX c1o cen wbr wi wi vx
      cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ cH co wceq wa vx cv cZ cH
      co cZ wceq vx cX r19.26 vx cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ
      cH co wceq wa vx cv cZ cH co cZ wceq wa vx cX wral vx cv cZ wceq vx cX
      wral cR cring wcel cX c0 wne cX c1o cen wbr wi wi vx cv cU cH co vx cv
      wceq vx cv cU cH co vx cv cZ cH co wceq wa vx cv cZ cH co cZ wceq wa vx
      cv cZ wceq vx cX vx cv cU cH co vx cv wceq vx cv cU cH co vx cv cZ cH co
      wceq vx cv cZ cH co cZ wceq vx cv cZ wceq vx cv cU cH co vx cv cZ cH co
      wceq vx cv cZ cH co cZ wceq vx cv cZ wceq wi wi vx cv vx cv cU cH co vx
      cv vx cv cU cH co wceq vx cv cU cH co vx cv cZ cH co wceq vx cv cZ cH co
      cZ wceq vx cv cZ wceq wi vx cv vx cv cU cH co wceq vx cv cU cH co vx cv
      cZ cH co wceq wa vx cv vx cv cZ cH co wceq vx cv cZ cH co cZ wceq vx cv
      cZ wceq wi vx cv vx cv cU cH co vx cv cZ cH co eqtr vx cv vx cv cZ cH co
      wceq vx cv cZ cH co cZ wceq vx cv cZ wceq vx cv vx cv cZ cH co cZ eqtr ex
      syl ex eqcoms imp31 r19.20si cX c0 wne vx cv cZ wceq vx cX wral cR cring
      wcel cX c1o cen wbr cX c0 wne vx cv cZ wceq vx cX wral cX cZ csn wceq cR
      cring wcel cX c1o cen wbr wi vx cX cZ eqsn cX cZ csn wceq cX c1o cen wbr
      cZ csn c1o cen wbr cR cring wcel cX cZ csn c1o cen breq1 cR cring wcel cZ
      cX wcel cZ csn c1o cen wbr cR cG cX cZ uznzr.1 uznzr.5 uznzr.3 ring0cl cZ
      cX ensn1g syl syl5bir syl6bir com3l syl sylbir ex sylbir ex com24 mpcom
      mpd cU cZ wceq vx cv cU cH co vx cv cZ cH co wceq vx cX cU cZ wceq vx cv
      cU cH co vx cv cZ cH co wceq vx cv cX wcel cU cZ vx cv cH opreq2 adantr
      r19.21aiva syl5com com13 mpcom impbid $.
      $( [18-Feb-2010] $) $( [14-Feb-2010] $)
  $}


  ${ $d G g h $. $d H g h $. $d x y $.
  $( The predicate "is a division ring". $)
  isdivrng $p |- ( H e. A -> ( <. G , H >. e. DivRing
     <-> ( <. G , H >. e. Ring /\ ( H |` (
       ( ran G \ { ( Id ` G ) } ) X. ( ran G \ { ( Id ` G ) } ) ) )
         e. Grp ) ) ) $=
    cH cA wcel cG cH cop cdrng wcel cG cH cop cring wcel cH cG crn cG cgi cfv
    csn cdif cG crn cG cgi cfv csn cdif cxp cres cgr wcel wa cG cvv wcel cH cA
    wcel wa cG cH cop cdrng wcel cH cA wcel cG cvv wcel cH cA wcel wa cG cH cop
    cdrng wcel cG cvv wcel cH cA wcel cG cH cop cdrng wcel cG cH cdrng wbr cG
    cvv wcel cG cH cdrng df-br cG cH cdrng cdrng wrel vx cv vy cv cop cring
    wcel vy cv vx cv crn vx cv cgi cfv csn cdif vx cv crn vx cv cgi cfv csn
    cdif cxp cres cgr wcel wa vx vy copab wrel vx cv vy cv cop cring wcel vy cv
    vx cv crn vx cv cgi cfv csn cdif vx cv crn vx cv cgi cfv csn cdif cxp cres
    cgr wcel wa vx vy relopab cdrng vx cv vy cv cop cring wcel vy cv vx cv crn
    vx cv cgi cfv csn cdif vx cv crn vx cv cgi cfv csn cdif cxp cres cgr wcel
    wa vx vy copab vx vy df-drng releqi mpbir brrelexi sylbir anim1i ancoms cH
    cA wcel cG cH cop cring wcel cH cG crn cG cgi cfv csn cdif cG crn cG cgi
    cfv csn cdif cxp cres cgr wcel wa wa cG cvv wcel cH cA wcel cG cH cop cring
    wcel cG cvv wcel cH cA wcel cH cG crn cG cgi cfv csn cdif cG crn cG cgi cfv
    csn cdif cxp cres cgr wcel cG cH cop cring wcel cG cabl wcel cG cvv wcel cG
    cH fora cG cabl elisset syl ad2antrl cH cA wcel cG cH cop cring wcel cH cG
    crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres cgr wcel wa
    pm3.26 jca cG cvv wcel cH cA wcel wa cG cH cop vg cv vh cv cop cring wcel
    vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp
    cres cgr wcel wa vg vh copab wcel cG cH cop cring wcel cH cG crn cG cgi cfv
    csn cdif cG crn cG cgi cfv csn cdif cxp cres cgr wcel wa cG cH cop cdrng
    wcel vg cv vh cv cop cring wcel vh cv vg cv crn vg cv cgi cfv csn cdif vg
    cv crn vg cv cgi cfv csn cdif cxp cres cgr wcel wa cG vh cv cop cring wcel
    vh cv cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres cgr
    wcel wa cG cH cop cring wcel cH cG crn cG cgi cfv csn cdif cG crn cG cgi
    cfv csn cdif cxp cres cgr wcel wa vg vh cG cH cvv cA vg cv cG wceq vg cv vh
    cv cop cring wcel cG vh cv cop cring wcel vh cv vg cv crn vg cv cgi cfv csn
    cdif vg cv crn vg cv cgi cfv csn cdif cxp cres cgr wcel vh cv cG crn cG cgi
    cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres cgr wcel vg cv cG wceq vg
    cv vh cv cop cG vh cv cop cring vg cv cG vh cv opeq1 eleq1d vg cv cG wceq
    vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp
    cres vh cv cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres
    cgr vg cv cG wceq vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv
    csn cdif cxp cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp wceq
    vh cv vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp
    cres vh cv cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres
    wceq vg cv crn vg cv cgi cfv csn cdif cG crn cG cgi cfv csn cdif wceq vg cv
    crn vg cv cgi cfv csn cdif cG crn cG cgi cfv csn cdif wceq vg cv crn vg cv
    cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp cG crn cG cgi cfv csn
    cdif cG crn cG cgi cfv csn cdif cxp wceq vg cv cG wceq vg cv crn vg cv cgi
    cfv csn cdif cG crn cG cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cG
    crn cG cgi cfv csn cdif xpeq12 vg cv crn cG crn wceq vg cv cgi cfv csn cG
    cgi cfv csn wceq vg cv crn vg cv cgi cfv csn cdif cG crn cG cgi cfv csn
    cdif wceq vg cv cG wceq vg cv crn cG crn vg cv cgi cfv csn cG cgi cfv csn
    difeq12 vg cv cG rneq vg cv cG wceq vg cv cgi cfv cG cgi cfv vg cv cG cgi
    fveq2 sneqd sylanc vg cv crn cG crn wceq vg cv cgi cfv csn cG cgi cfv csn
    wceq vg cv crn vg cv cgi cfv csn cdif cG crn cG cgi cfv csn cdif wceq vg cv
    cG wceq vg cv crn cG crn vg cv cgi cfv csn cG cgi cfv csn difeq12 vg cv cG
    rneq vg cv cG wceq vg cv cgi cfv cG cgi cfv vg cv cG cgi fveq2 sneqd sylanc
    sylanc vg cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif
    cxp cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp vh cv reseq2
    syl eleq1d anbi12d vh cv cH wceq cG vh cv cop cring wcel cG cH cop cring
    wcel vh cv cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres
    cgr wcel cH cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp cres
    cgr wcel vh cv cH wceq cG vh cv cop cG cH cop cring vh cv cH cG opeq2
    eleq1d vh cv cH wceq vh cv cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn
    cdif cxp cres cH cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp
    cres cgr vh cv cH cG crn cG cgi cfv csn cdif cG crn cG cgi cfv csn cdif cxp
    reseq1 eleq1d anbi12d opelopabg cdrng vg cv vh cv cop cring wcel vh cv vg
    cv crn vg cv cgi cfv csn cdif vg cv crn vg cv cgi cfv csn cdif cxp cres cgr
    wcel wa vg vh copab cG cH cop vg vh df-drng eleq2i syl5bb pm5.21nd $.
    $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${ $d A u x  $.
    zrdivrng.1 $e |- A e. B $.
    $( The zero ring is not a division ring. $)
    zrdivrng $p |- -.
      <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >.
         e. DivRing $=
      cA cA cop cA cop csn cvv wcel cA cA cop cA cop csn cA cA cop cA cop csn
      cop cdrng wcel wn cA cA cop cA cop snex cA cA cop cA cop csn cvv wcel cA
      cA cop cA cop csn cA cA cop cA cop csn cop cdrng wcel cA cA cop cA cop
      csn cA cA cop cA cop csn cop cring wcel cA cA cop cA cop csn cA cA cop cA
      cop csn crn cA cA cop cA cop csn cgi cfv csn cdif cA cA cop cA cop csn
      crn cA cA cop cA cop csn cgi cfv csn cdif cxp cres cgr wcel wa cA cA cop
      cA cop csn cvv wcel cA cA cop cA cop csn cA cA cop cA cop csn crn cA cA
      cop cA cop csn cgi cfv csn cdif cA cA cop cA cop csn crn cA cA cop cA cop
      csn cgi cfv csn cdif cxp cres cgr wcel cA cA cop cA cop csn cA cA cop cA
      cop csn cop cring wcel cA cA cop cA cop csn cA cA cop cA cop csn crn cA
      cA cop cA cop csn cgi cfv csn cdif cA cA cop cA cop csn crn cA cA cop cA
      cop csn cgi cfv csn cdif cxp cres cgr wcel wn cA cA cop cA cop csn cvv
      wcel cA cA cop cA cop csn cA cA cop cA cop csn crn cA cA cop cA cop csn
      cgi cfv csn cdif cA cA cop cA cop csn crn cA cA cop cA cop csn cgi cfv
      csn cdif cxp cres cgr wcel c0 cgr wcel 0ngrp cA cA cop cA cop csn cA cA
      cop cA cop csn crn cA cA cop cA cop csn cgi cfv csn cdif cA cA cop cA cop
      csn crn cA cA cop cA cop csn cgi cfv csn cdif cxp cres c0 cgr cA cA cop
      cA cop csn cA cA cop cA cop csn crn cA cA cop cA cop csn cgi cfv csn cdif
      cA cA cop cA cop csn crn cA cA cop cA cop csn cgi cfv csn cdif cxp cres
      cA cA cop cA cop csn c0 cres c0 cA cA cop cA cop csn crn cA cA cop cA cop
      csn cgi cfv csn cdif cA cA cop cA cop csn crn cA cA cop cA cop csn cgi
      cfv csn cdif cxp c0 wceq cA cA cop cA cop csn cA cA cop cA cop csn crn cA
      cA cop cA cop csn cgi cfv csn cdif cA cA cop cA cop csn crn cA cA cop cA
      cop csn cgi cfv csn cdif cxp cres cA cA cop cA cop csn c0 cres wceq cA cA
      cop cA cop csn crn cA cA cop cA cop csn cgi cfv csn cdif cA cA cop cA cop
      csn crn cA cA cop cA cop csn cgi cfv csn cdif cxp c0 cA cA cop cA cop csn
      crn cA cA cop cA cop csn cgi cfv csn cdif cxp c0 cA cA cop cA cop csn crn
      cA cA cop cA cop csn cgi cfv csn cdif c0 cA cA cop cA cop csn crn cA cA
      cop cA cop csn cgi cfv csn cdif cA cA cop cA cop csn crn cA cA cop cA cop
      csn cgi cfv csn cdif cA csn cA csn cdif c0 cA cA cop cA cop csn crn cA
      csn cA cA cop cA cop csn cgi cfv csn cA csn cA cA cop cA cA cA opex cA cB
      zrdivrng.1 elisseti rnsnop cA cA cop cA cop csn cgr wcel cA cA cop cA cop
      csn cgi cfv csn cA csn wceq cA cA cB zrdivrng.1 elisseti grpsn cA cA cop
      cA cop csn cgr wcel cA cA cop cA cop csn cgi cfv cA cA cA cop cA cop csn
      cgr wcel cA cA cop cA cop csn cgi cfv vu cv vx cv cA cA cop cA cop csn co
      vx cv wceq vx cA csn wral vu cA csn crab cuni cA vx vu cA cA cop cA cop
      csn cgi cfv cA cA cop cA cop csn cA csn cA cA cop cA cop csn crn cA csn
      cA cA cop cA cA cA opex cA cB zrdivrng.1 elisseti rnsnop eqcomi cA cA cop
      cA cop csn cgi cfv eqid grpidval vu cv vx cv cA cA cop cA cop csn co vx
      cv wceq vx cA csn wral vu cA csn crab cuni cA csn cuni cA vu cv vx cv cA
      cA cop cA cop csn co vx cv wceq vx cA csn wral vu cA csn crab cA csn vu
      cv cA csn wcel vu cv vx cv cA cA cop cA cop csn co vx cv wceq vx cA csn
      wral wa vu cab vu cv cA wceq vu cab vu cv vx cv cA cA cop cA cop csn co
      vx cv wceq vx cA csn wral vu cA csn crab cA csn vu cv cA csn wcel vu cv
      vx cv cA cA cop cA cop csn co vx cv wceq vx cA csn wral wa vu cv cA wceq
      vu vu cv cA csn wcel vu cv vx cv cA cA cop cA cop csn co vx cv wceq vx cA
      csn wral wa vu cv cA wceq vu cv cA csn wcel vu cv cA wceq vu cv vx cv cA
      cA cop cA cop csn co vx cv wceq vx cA csn wral vu cv cA elsni adantr vu
      cv cA wceq vu cv cA csn wcel vu cv vx cv cA cA cop cA cop csn co vx cv
      wceq vx cA csn wral vu cv cA csn wcel vu cv cA wceq vu cA elsn biimpri vu
      cv cA wceq vu cv vx cv cA cA cop cA cop csn co vx cv wceq vx cA csn vx cv
      cA csn wcel vu cv cA wceq vu cv vx cv cA cA cop cA cop csn co vx cv wceq
      vx cv cA csn wcel vx cv cA wceq vu cv cA wceq vu cv vx cv cA cA cop cA
      cop csn co vx cv wceq wi vx cA elsn vx cv cA wceq vu cv cA wceq vu cv vx
      cv cA cA cop cA cop csn co vx cv wceq vx cv cA wceq vu cv cA wceq wa vu
      cv vx cv cA cA cop cA cop csn co vx cv wceq cA cA cA cA cop cA cop csn co
      cA wceq cA cA cop cA cop csn cA csn cA csn cxp wfn cA cA csn wcel cA cA
      csn wcel cA cA cA cA cop cA cop csn co cA wceq cA cA cop cA cop csn cA
      csn cA csn cxp wfn cA cA cop cA cop csn wfun cA cA cop cA cop csn cdm cA
      csn cA csn cxp wceq cA cA cop cA cop csn cA csn cA csn cxp df-fn cA cA
      cop cA cA cA opex cA cB zrdivrng.1 elisseti funsn cA cA cop cA cop csn
      cdm cA cA cop csn cA csn cA csn cxp cA cA cop cA dmsnop cA cA cA cB
      zrdivrng.1 elisseti cA cB zrdivrng.1 elisseti xpsn eqtr4i mpbir2an cA cA
      cB zrdivrng.1 elisseti snid cA cA cB zrdivrng.1 elisseti snid cA cA cop
      cA cop csn cA csn cA csn cxp wfn cA cA csn wcel cA cA csn wcel w3a cA cA
      cA cA cop cA cop csn co cA wceq cA cA cop cA cop cA cA cop cA cop csn
      wcel cA cA cop cA cop cA cA cop cA opex snid cA csn cA csn cA cA cA cA cA
      cop cA cop csn cA cB zrdivrng.1 elisseti fnotoprb mpbiri mp3an vx cv cA
      wceq vu cv cA wceq wa vu cv vx cv cA cA cop cA cop csn co vx cv wceq cA
      vx cv cA cA cop cA cop csn co vx cv wceq cA cA cA cA cop cA cop csn co cA
      wceq vx cv cA wceq vu cv cA wceq wa vu cv vx cv cA cA cop cA cop csn co
      cA vx cv cA cA cop cA cop csn co vx cv vx cv cA wceq vu cv cA wceq wa vu
      cv cA vx cv cA cA cop cA cop csn vx cv cA wceq vu cv cA wceq pm3.27
      opreq1d eqeq1d vx cv cA wceq vu cv cA wceq wa cA vx cv cA cA cop cA cop
      csn co cA cA cA cA cop cA cop csn co vx cv cA vx cv cA wceq vu cv cA wceq
      wa vx cv cA cA cA cA cop cA cop csn vx cv cA wceq vu cv cA wceq pm3.26
      opreq2d vx cv cA wceq vu cv cA wceq pm3.26 eqeq12d bitrd mpbiri ex sylbi
      com12 r19.21aiv jca impbii abbii vu cv vx cv cA cA cop cA cop csn co vx
      cv wceq vx cA csn wral vu cA csn df-rab vu cA df-sn 3eqtr4i unieqi cA cA
      cB zrdivrng.1 elisseti unisn eqtri syl6eq sneqd ax-mp difeq12i cA csn
      difid eqtri xpeq1i cA cA cop cA cop csn crn cA cA cop cA cop csn cgi cfv
      csn cdif xp0r eqtri cA cA cop cA cop csn crn cA cA cop cA cop csn cgi cfv
      csn cdif cA cA cop cA cop csn crn cA cA cop cA cop csn cgi cfv csn cdif
      cxp c0 cA cA cop cA cop csn reseq2 ax-mp cA cA cop cA cop csn res0 eqtri
      eleq1i mtbir a1i intnand cvv cA cA cop cA cop csn cA cA cop cA cop csn
      isdivrng mtbird ax-mp $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${
    dvrunz.1 $e |- G = ( 1st ` R ) $.
    dvrunz.2 $e |- H = ( 2nd ` R ) $.
    dvrunz.3 $e |- X = ran G $.
    dvrunz.4 $e |- Z = ( Id ` G ) $.
    dvrunz.5 $e |- U = ( Id ` H ) $.
    $( In a division ring the unit is different from the zero. $)
    dvrunz $p |- ( R e. DivRing -> U =/= Z ) $=
      cR cdrng wcel cZ cZ cop cZ cop csn cZ cZ cop cZ cop csn cop cdrng wcel wn
      cU cZ wne cZ cvv cZ cG cgi cfv cvv dvrunz.4 cG cgi fvex eqeltri zrdivrng
      cR cdrng wcel cZ cZ cop cZ cop csn cZ cZ cop cZ cop csn cop cdrng wcel cU
      cZ cR cdrng wcel cU cZ wceq cX c1o cen wbr cZ cZ cop cZ cop csn cZ cZ cop
      cZ cop csn cop cdrng wcel cR cdrng wcel cR cring wcel cX c1o cen wbr cU
      cZ wceq wb cR cdrng wcel cR cring wcel cH cX cZ csn cdif cX cZ csn cdif
      cxp cres cgr wcel cR cG cH cX cZ dvrunz.1 dvrunz.2 dvrunz.3 dvrunz.4
      drngi pm3.26d cR cU cG cH cX cZ dvrunz.1 dvrunz.2 dvrunz.4 dvrunz.5
      dvrunz.3 uznzr syl cX c1o cen wbr cR cdrng wcel cZ cZ cop cZ cop csn cZ
      cZ cop cZ cop csn cop cdrng wcel cR cdrng wcel cX c1o cen wbr cR cZ cZ
      cop cZ cop csn cZ cZ cop cZ cop csn cop wceq cR cdrng wcel cZ cZ cop cZ
      cop csn cZ cZ cop cZ cop csn cop cdrng wcel wi cR cdrng wcel cR cring
      wcel cX c1o cen wbr cR cZ cZ cop cZ cop csn cZ cZ cop cZ cop csn cop wceq
      wb cR cdrng wcel cR cring wcel cH cX cZ csn cdif cX cZ csn cdif cxp cres
      cgr wcel cR cG cH cX cZ dvrunz.1 dvrunz.2 dvrunz.3 dvrunz.4 drngi pm3.26d
      cR cG cX cZ dvrunz.1 dvrunz.3 dvrunz.4 on1el6 syl cR cZ cZ cop cZ cop csn
      cZ cZ cop cZ cop csn cop wceq cR cdrng wcel cZ cZ cop cZ cop csn cZ cZ
      cop cZ cop csn cop cdrng wcel cR cZ cZ cop cZ cop csn cZ cZ cop cZ cop
      csn cop cdrng eleq1 biimpd syl6bi pm2.43a sylbird necon3bd mpi $.
      $( [18-Feb-2010] $) $( [14-Feb-2010] $)
  $}

  $c Fld $.

  $( Extend class notation with the class of all fields. $)
  cfld $a class Fld $.

  $( Add alternate definition. Add Kennington's one (=/= the zero ring),
       and Mizar's one: ` ( Id `` G ) =/= ( Id `` H ) ` $)
  $( Definition of a field. A field is a commutative division ring. $)
  df-fld $a |- Fld = ( DivRing i^i Com2 ) $.

  ${ $d G x y $. $d H x y $.
    $( The predicate "is a field". $)
    isfld $p |- ( ( G e. A /\ H e. B ) -> ( <. G , H >. e. Fld <->
      ( <. G , H >. e. DivRing
      /\ A. x e. ran G A. y e. ran G ( x H y ) = ( y H x ) ) ) ) $=
      cG cA wcel cH cB wcel wa cG cH cop cfld wcel cG cH cop cdrng ccm2 cin
      wcel cG cH cop cdrng wcel cG cH cop ccm2 wcel wa cG cH cop cdrng wcel vx
      cv vy cv cH co vy cv vx cv cH co wceq vy cG crn wral vx cG crn wral wa cG
      cA wcel cH cB wcel wa cfld cdrng ccm2 cin cG cH cop cfld cdrng ccm2 cin
      wceq cG cA wcel cH cB wcel wa df-fld a1i eleq2d cG cH cop cdrng ccm2 cin
      wcel cG cH cop cdrng wcel cG cH cop ccm2 wcel wa wb cG cA wcel cH cB wcel
      wa cG cH cop cdrng ccm2 elin a1i cG cA wcel cH cB wcel wa cG cH cop ccm2
      wcel vx cv vy cv cH co vy cv vx cv cH co wceq vy cG crn wral vx cG crn
      wral cG cH cop cdrng wcel cA cB cG cH vx vy iscom2 anbi2d 3bitrd $.
      $( [7-Sep-2009] $) $( [6-Sep-2009] $)
  $}

  ${
    fldi.1 $e |- G = ( 1st ` R ) $.
    fldi.2 $e |- H = ( 2nd ` R ) $.
    fldi.3 $e |- X = ran G $.
    fldi.4 $e |- Z = ( Id ` G ) $.
    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      $( The "axioms" of a field. $)
      fldi $p |- ( R e. Fld ->
         (
              ( G e. Abel /\ H : ( X X. X ) --> X )
              /\ (
                 A. x e. X A. y e. X A. z e. X (
                         ( ( x H y ) H z ) = ( x H ( y H z ) )
                        /\ ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) )
                        /\ ( ( x G y ) H z ) = ( ( x H z ) G ( y H z ) ) )
                 /\ E. x e. X A. y e. X (
                         ( y H x ) = y
                        /\ ( x H y ) = y ) )
               /\ (
                  ( H |` ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. Grp
                 /\ A. x e. X A. y e. X ( x H y ) = ( y H x ) ) ) ) $=
        cR cfld wcel cR cdrng ccm2 cin wcel cG cabl wcel cX cX cxp cX cH wf wa
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv
        vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
        vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa w3a cfld cdrng ccm2 cin cR df-fld
        eleq2i cR cdrng ccm2 cin wcel cR cdrng wcel cR ccm2 wcel wa cG cabl
        wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz
        cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx
        cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH
        co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy
        cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx
        cX wrex wa cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy
        cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral wa w3a cR cdrng
        ccm2 elin cR cdrng wcel cR ccm2 wcel cG cabl wcel cX cX cxp cX cH wf wa
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv
        vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
        vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa w3a cR cdrng wcel cR cring wcel cH cX
        cZ csn cdif cX cZ csn cdif cxp cres cgr wcel wa cR ccm2 wcel cG cabl
        wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz
        cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx
        cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH
        co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy
        cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx
        cX wrex wa cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy
        cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral wa w3a wi cR cG
        cH cX cZ fldi.1 fldi.2 fldi.3 fldi.4 drngi cR cring wcel cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel wa vx cv vy cv cH co vy cv vx cv
        cH co wceq vy cX wral vx cX wral cG cabl wcel cX cX cxp cX cH wf wa vx
        cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
        cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx
        cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa w3a cR ccm2 wcel cR cring wcel cH cX
        cZ csn cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx
        cv cH co wceq vy cX wral vx cX wral cG cabl wcel cX cX cxp cX cH wf wa
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv
        vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
        vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa w3a cR cring wcel cG cabl wcel cX cX
        cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co
        cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv
        cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv
        vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv
        cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex
        wa wa cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH
        co vy cv vx cv cH co wceq vy cX wral vx cX wral wa cG cabl wcel cX cX
        cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co
        cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv
        cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv
        vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv
        cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex
        wa cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co
        vy cv vx cv cH co wceq vy cX wral vx cX wral wa w3a wi vx vy vz cR cG
        cH cX fldi.1 fldi.2 fldi.3 ringi cG cabl wcel cX cX cxp cX cH wf wa vx
        cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
        cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx
        cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa cG cabl wcel cX cX cxp cX cH wf wa vx
        cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
        cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx
        cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa w3a cG cabl wcel cX cX cxp cX cH wf wa
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv
        vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
        vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq
        vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cZ csn
        cdif cX cZ csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH
        co wceq vy cX wral vx cX wral wa w3a id 3expia syl expdimp cR cG cH cX
        vx vy fldi.1 fldi.2 fldi.3 com2i syl5 syl imp sylbi sylbi $.
        $( [18-Sep-2010] $) $( [15-Sep-2010] $)
    $}
  $}

  ${
    $d G x y z $. $d R x y z $.
    fldax1.1 $e |- G = ( 1st ` R ) $.
    $( 1st "axiom" of a field. The addition is an abelian group. $)
    fldax1 $p |- ( R e. Fld -> G e. Abel ) $=
      cR cfld wcel cG cabl wcel cG crn cG crn cxp cG crn cR c2nd cfv wf cR cfld
      wcel cG cabl wcel cG crn cG crn cxp cG crn cR c2nd cfv wf wa vx cv vy cv
      cR c2nd cfv co vz cv cR c2nd cfv co vx cv vy cv vz cv cR c2nd cfv co cR
      c2nd cfv co wceq vx cv vy cv vz cv cG co cR c2nd cfv co vx cv vy cv cR
      c2nd cfv co vx cv vz cv cR c2nd cfv co cG co wceq vx cv vy cv cG co vz cv
      cR c2nd cfv co vx cv vz cv cR c2nd cfv co vy cv vz cv cR c2nd cfv co cG
      co wceq w3a vz cG crn wral vy cG crn wral vx cG crn wral vy cv vx cv cR
      c2nd cfv co vy cv wceq vx cv vy cv cR c2nd cfv co vy cv wceq wa vy cG crn
      wral vx cG crn wrex wa cR c2nd cfv cG crn cG cgi cfv csn cdif cG crn cG
      cgi cfv csn cdif cxp cres cgr wcel vx cv vy cv cR c2nd cfv co vy cv vx cv
      cR c2nd cfv co wceq vy cG crn wral vx cG crn wral wa vx vy vz cR cG cR
      c2nd cfv cG crn cG cgi cfv fldax1.1 cR c2nd cfv eqid cG crn eqid cG cgi
      cfv eqid fldi 3simp1d pm3.26d $.
      $( [11-Jul-2010] $) $( [11-Jul-2010] $)
  $}

  ${
    fldax.1 $e |- G = ( 1st ` R ) $.
    fldax.2 $e |- H = ( 2nd ` R ) $.
    fldax.3 $e |- X = ran G $.

    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      $( 2nd "axiom" of a field.  The multiplication is an internal
         operation. $)
      fldax2 $p |- ( R e. Fld -> H : ( X X. X ) --> X ) $=
        cR cfld wcel cG cabl wcel cX cX cxp cX cH wf cR cfld wcel cG cabl wcel
        cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv
        cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv
        vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co
        vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv
        vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX
        wrex wa cH cX cG cgi cfv csn cdif cX cG cgi cfv csn cdif cxp cres cgr
        wcel vx cv vy cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral wa
        vx vy vz cR cG cH cX cG cgi cfv fldax.1 fldax.2 fldax.3 cG cgi cfv eqid
        fldi 3simp1d pm3.27d $.
        $( [11-Jul-2010] $) $( [11-Jul-2010] $)
    $}

    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      $( 3rd "axiom" of a field. The multiplication is associative. $)
      fldax3 $p |- ( R e. Fld ->  A. x e. X A. y e. X A. z e. X
                         ( ( x H y ) H z ) = ( x H ( y H z ) ) ) $=
        cR cfld wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
        co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH
        co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
        cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH
        co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa
        vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vz cX
        wral vy cX wral vx cX wral cR cfld wcel cG cabl wcel cX cX cxp cX cH wf
        wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx
        cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co
        wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co
        cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH co vy cv
        wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa cH cX cG
        cgi cfv csn cdif cX cG cgi cfv csn cdif cxp cres cgr wcel vx cv vy cv
        cH co vy cv vx cv cH co wceq vy cX wral vx cX wral wa vx vy vz cR cG cH
        cX cG cgi cfv fldax.1 fldax.2 fldax.3 cG cgi cfv eqid fldi 3simp2d vx
        cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy
        cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx
        cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co
        wceq w3a vz cX wral vy cX wral vx cX wral vx cv vy cv cH co vz cv cH co
        vx cv vy cv vz cv cH co cH co wceq vz cX wral vy cX wral vx cX wral vy
        cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx
        cX wrex vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co
        wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co
        cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv
        cH co cG co wceq w3a vz cX wral vy cX wral vx cv vy cv cH co vz cv cH
        co vx cv vy cv vz cv cH co cH co wceq vz cX wral vy cX wral vx cX vx cv
        vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv
        vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv
        vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq
        w3a vz cX wral vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
        co wceq vz cX wral vy cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz
        cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx
        cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH
        co vy cv vz cv cH co cG co wceq w3a vx cv vy cv cH co vz cv cH co vx cv
        vy cv vz cv cH co cH co wceq vz cX vx cv vy cv cH co vz cv cH co vx cv
        vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv
        cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv
        vz cv cH co vy cv vz cv cH co cG co wceq 3simp1 r19.20si r19.20si
        r19.20si adantr syl $.
        $( [11-Jul-2010] $) $( [11-Jul-2010] $)
    $}


    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      $( 4th "axiom" of a field. The multiplication is distributive. $)
      fldax4 $p |- ( R e. Fld ->  A. x e. X A. y e. X A. z e. X
                        ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) ) $=
        cR cfld wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH
        co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH
        co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz
        cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv cH
        co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex wa
        vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co
        wceq vz cX wral vy cX wral vx cX wral cR cfld wcel cG cabl wcel cX cX
        cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co
        cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv
        cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv
        vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv
        cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex
        wa cH cX cG cgi cfv csn cdif cX cG cgi cfv csn cdif cxp cres cgr wcel
        vx cv vy cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral wa vx vy
        vz cR cG cH cX cG cgi cfv fldax.1 fldax.2 fldax.3 cG cgi cfv eqid fldi
        3simp2d vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co
        wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co
        cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv
        cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vx cv vy cv vz cv
        cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vz cX wral
        vy cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy
        cv wceq wa vy cX wral vx cX wrex vx cv vy cv cH co vz cv cH co vx cv vy
        cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH
        co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz
        cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cv
        vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq
        vz cX wral vy cX wral vx cX vx cv vy cv cH co vz cv cH co vx cv vy cv
        vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co
        vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv
        cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vx cv vy cv vz cv cG
        co cH co vx cv vy cv cH co vx cv vz cv cH co cG co wceq vz cX wral vy
        cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co cH co wceq vx
        cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv cH co cG co
        wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv vz cv cH co
        cG co wceq w3a vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz
        cv cH co cG co wceq vz cX vx cv vy cv cH co vz cv cH co vx cv vy cv vz
        cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx
        cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH
        co vy cv vz cv cH co cG co wceq 3simp2 r19.20si r19.20si r19.20si
        adantr syl $.
        $( [11-Jul-2010] $) $( [11-Jul-2010] $)
    $}


    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      $( 5th "axiom" of a field. Existence of a neutral element. $)
      fldax5 $p |- ( R e. Fld -> E. x e. X A. y e. X ( y H x ) = y ) $=
        cR cfld wcel vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq
        wa vy cX wral vx cX wrex vy cv vx cv cH co vy cv wceq vy cX wral vx cX
        wrex cR cfld wcel vx cv vy cv cH co vz cv cH co vx cv vy cv vz cv cH co
        cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv cH co vx cv vz cv
        cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv vz cv cH co vy cv
        vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx cX wral vy cv vx cv
        cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vx cX wrex
        cR cfld wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv
        cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co
        vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv
        cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy
        cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
        wceq wa vy cX wral vx cX wrex wa cH cX cG cgi cfv csn cdif cX cG cgi
        cfv csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH co wceq
        vy cX wral vx cX wral wa vx vy vz cR cG cH cX cG cgi cfv fldax.1
        fldax.2 fldax.3 cG cgi cfv eqid fldi 3simp2d pm3.27d vy cv vx cv cH co
        vy cv wceq vx cv vy cv cH co vy cv wceq wa vy cX wral vy cv vx cv cH co
        vy cv wceq vy cX wral vx cX vy cv vx cv cH co vy cv wceq vx cv vy cv cH
        co vy cv wceq wa vy cv vx cv cH co vy cv wceq vy cX vy cv vx cv cH co
        vy cv wceq vx cv vy cv cH co vy cv wceq pm3.26 r19.20si r19.22si syl $.
        $( [11-Jul-2010] $) $( [11-Jul-2010] $)
    $}

    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      fldax.4 $e |- Z = ( Id ` G ) $.
      $( 6th "axiom" of a field. The multiplication is a group on the
         underlying set deprived from zero. $)
      fldax6 $p |- ( R e. Fld -> ( H |`
        ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. Grp ) $=
        cR cfld wcel cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr wcel vx cv
        vy cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral cR cfld wcel
        cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv cH co vx cv
        vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co vx cv vy cv
        cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv cH co vx cv
        vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy cX wral vx
        cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv wceq wa vy
        cX wral vx cX wrex wa cH cX cZ csn cdif cX cZ csn cdif cxp cres cgr
        wcel vx cv vy cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral wa
        vx vy vz cR cG cH cX cZ fldax.1 fldax.2 fldax.3 fldax.4 fldi 3simp3d
        pm3.26d $.
        $( [11-Jul-2010] $) $( [11-Jul-2010] $)
    $}

    ${
      $d G x y z $. $d H x y z $. $d R x y $. $d X x y z $.
      $( 7th "axiom" of a field. The multiplication is commutative. $)
      fldax7 $p |- ( R e. Fld
        -> A. x e. X A. y e. X ( x H y ) = ( y H x ) ) $=
        cR cfld wcel cH cX cG cgi cfv csn cdif cX cG cgi cfv csn cdif cxp cres
        cgr wcel vx cv vy cv cH co vy cv vx cv cH co wceq vy cX wral vx cX wral
        cR cfld wcel cG cabl wcel cX cX cxp cX cH wf wa vx cv vy cv cH co vz cv
        cH co vx cv vy cv vz cv cH co cH co wceq vx cv vy cv vz cv cG co cH co
        vx cv vy cv cH co vx cv vz cv cH co cG co wceq vx cv vy cv cG co vz cv
        cH co vx cv vz cv cH co vy cv vz cv cH co cG co wceq w3a vz cX wral vy
        cX wral vx cX wral vy cv vx cv cH co vy cv wceq vx cv vy cv cH co vy cv
        wceq wa vy cX wral vx cX wrex wa cH cX cG cgi cfv csn cdif cX cG cgi
        cfv csn cdif cxp cres cgr wcel vx cv vy cv cH co vy cv vx cv cH co wceq
        vy cX wral vx cX wral wa vx vy vz cR cG cH cX cG cgi cfv fldax.1
        fldax.2 fldax.3 cG cgi cfv eqid fldi 3simp3d pm3.27d $.
        $( [11-Jul-2010] $) $( [11-Jul-2010] $)
    $}

  $}

  ${
    zrfld.1 $e |- A e. B $.
    $( The zero ring is not a field. $)
    zrfld $p |- -. <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >.
      e. Fld $=
      cA cA cop cA cop csn cA cA cop cA cop csn cop cfld wcel cA cA cop cA cop
      csn cA cA cop cA cop csn cop cdrng ccm2 cin wcel cA cA cop cA cop csn cA
      cA cop cA cop csn cop cdrng ccm2 cin wcel cA cA cop cA cop csn cA cA cop
      cA cop csn cop cdrng wcel cA cA cop cA cop csn cA cA cop cA cop csn cop
      ccm2 wcel wa cA cA cop cA cop csn cA cA cop cA cop csn cop cdrng wcel cA
      cA cop cA cop csn cA cA cop cA cop csn cop ccm2 wcel cA cB zrfld.1
      zrdivrng intnanr cA cA cop cA cop csn cA cA cop cA cop csn cop cdrng ccm2
      elin mtbir cfld cdrng ccm2 cin cA cA cop cA cop csn cA cA cop cA cop csn
      cop df-fld eleq2i mtbir $.
      $( [24-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${
    zerdivemp.1 $e |- G = ( 1st ` R ) $.
    zerdivemp.2 $e |- H = ( 2nd ` R ) $.
    zerdivemp.3 $e |- Z = ( Id ` G ) $.
    zerdivemp.4 $e |- X = ran G $.
    zerdivemp.5 $e |- U = ( Id ` H ) $.
    ${
      $d A a $. $d B a $. $d H a $. $d R a $. $d X a $. $d Z a $.
      $( In a unitary ring a left invertible element is not a zero
         divisor. $)
      zerdivemp1 $p |- ( ( R e. Ring /\ A e. ( X \ Z ) /\
      E. a e. X ( a H A ) = U ) ->
         ( B e. X -> ( ( A H B ) = Z -> B = Z ) ) ) $=
        cR cring wcel cA cX cZ cdif wcel va cv cA cH co cU wceq va cX wrex cB
        cX wcel cA cB cH co cZ wceq cB cZ wceq wi wi va cv cA cH co cU wceq va
        cX wrex cA cX cZ cdif wcel cR cring wcel cB cX wcel cA cB cH co cZ wceq
        cB cZ wceq wi wi va cv cA cH co cU wceq cA cX cZ cdif wcel cR cring
        wcel cB cX wcel cA cB cH co cZ wceq cB cZ wceq wi wi wi wi va cX va cv
        cX wcel va cv cA cH co cU wceq cA cX cZ cdif wcel cR cring wcel cB cX
        wcel cA cB cH co cZ wceq cB cZ wceq wi wi wi cA cB cH co cZ wceq cR
        cring wcel cB cX wcel va cv cX wcel va cv cA cH co cU wceq cA cX cZ
        cdif wcel w3a cB cZ wceq cR cring wcel va cv cA cB cH co cH co va cv cZ
        cH co wceq cB cX wcel va cv cX wcel va cv cA cH co cU wceq cA cX cZ
        cdif wcel w3a cB cZ wceq wi wi cA cB cH co cZ wceq cR cring wcel va cv
        cA cB cH co cH co va cv cZ cH co wceq cB cX wcel va cv cX wcel va cv cA
        cH co cU wceq cA cX cZ cdif wcel w3a cB cZ wceq cR cring wcel va cv cA
        cB cH co cH co va cv cZ cH co wceq cB cX wcel w3a va cv cX wcel va cv
        cA cH co cU wceq cA cX cZ cdif wcel w3a wa cB cZ wceq cR cring wcel va
        cv cA cB cH co cH co va cv cZ cH co wceq cB cX wcel w3a va cv cX wcel
        va cv cA cH co cU wceq cA cX cZ cdif wcel w3a wa cR cring wcel va cv cX
        wcel cA cX wcel cB cX wcel w3a wa va cv cA cH co cB cH co va cv cA cB
        cH co cH co wceq cR cring wcel va cv cA cB cH co cH co va cv cZ cH co
        wceq cB cX wcel w3a va cv cX wcel va cv cA cH co cU wceq cA cX cZ cdif
        wcel w3a wa cB cZ wceq wi cR cring wcel va cv cA cB cH co cH co va cv
        cZ cH co wceq cB cX wcel w3a va cv cX wcel va cv cA cH co cU wceq cA cX
        cZ cdif wcel w3a wa cR cring wcel va cv cX wcel cA cX wcel cB cX wcel
        w3a cR cring wcel va cv cA cB cH co cH co va cv cZ cH co wceq cB cX
        wcel va cv cX wcel va cv cA cH co cU wceq cA cX cZ cdif wcel w3a
        3simpl1 cR cring wcel va cv cA cB cH co cH co va cv cZ cH co wceq cB cX
        wcel w3a va cv cX wcel va cv cA cH co cU wceq cA cX cZ cdif wcel w3a wa
        va cv cX wcel cA cX wcel cB cX wcel cR cring wcel va cv cA cB cH co cH
        co va cv cZ cH co wceq cB cX wcel w3a va cv cX wcel va cv cA cH co cU
        wceq cA cX cZ cdif wcel 3simpr1 va cv cX wcel va cv cA cH co cU wceq cA
        cX cZ cdif wcel w3a cA cX wcel cR cring wcel va cv cA cB cH co cH co va
        cv cZ cH co wceq cB cX wcel w3a cA cX cZ cdif wcel va cv cX wcel cA cX
        wcel va cv cA cH co cU wceq cA cX cZ eldifi 3ad2ant3 adantl cR cring
        wcel va cv cA cB cH co cH co va cv cZ cH co wceq cB cX wcel va cv cX
        wcel va cv cA cH co cU wceq cA cX cZ cdif wcel w3a 3simpl3 3jca jca va
        cv cA cB cR cG cH cX zerdivemp.1 zerdivemp.2 zerdivemp.4 ringass cR
        cring wcel va cv cA cB cH co cH co va cv cZ cH co wceq cB cX wcel w3a
        va cv cX wcel va cv cA cH co cU wceq cA cX cZ cdif wcel w3a wa va cv cA
        cH co cB cH co va cv cA cB cH co cH co wceq cB cZ wceq cR cring wcel va
        cv cA cB cH co cH co va cv cZ cH co wceq cB cX wcel va cv cX wcel va cv
        cA cH co cU wceq cA cX cZ cdif wcel w3a va cv cA cH co cB cH co va cv
        cA cB cH co cH co wceq cB cZ wceq wi va cv cA cH co cB cH co va cv cA
        cB cH co cH co wceq va cv cA cB cH co cH co va cv cZ cH co wceq cB cX
        wcel va cv cX wcel va cv cA cH co cU wceq cA cX cZ cdif wcel w3a cR
        cring wcel cB cZ wceq va cv cA cH co cB cH co va cv cA cB cH co cH co
        wceq va cv cA cB cH co cH co va cv cZ cH co wceq va cv cA cH co cB cH
        co va cv cZ cH co wceq cB cX wcel va cv cX wcel va cv cA cH co cU wceq
        cA cX cZ cdif wcel w3a cR cring wcel cB cZ wceq wi wi wi va cv cA cH co
        cB cH co va cv cA cB cH co cH co wceq va cv cA cB cH co cH co va cv cZ
        cH co wceq va cv cA cH co cB cH co va cv cZ cH co wceq va cv cA cH co
        cB cH co va cv cA cB cH co cH co va cv cZ cH co eqtr ex va cv cX wcel
        va cv cA cH co cU wceq cA cX cZ cdif wcel w3a cB cX wcel va cv cA cH co
        cB cH co va cv cZ cH co wceq cR cring wcel cB cZ wceq wi va cv cX wcel
        va cv cA cH co cU wceq cA cX cZ cdif wcel cB cX wcel va cv cA cH co cB
        cH co va cv cZ cH co wceq cR cring wcel cB cZ wceq wi wi wi va cv cA cH
        co cU wceq va cv cX wcel cA cX cZ cdif wcel cB cX wcel va cv cA cH co
        cB cH co va cv cZ cH co wceq cR cring wcel cB cZ wceq wi wi wi wi va cv
        cA cH co cU wceq va cv cA cH co cB cH co cU cB cH co wceq va cv cX wcel
        cA cX cZ cdif wcel cB cX wcel va cv cA cH co cB cH co va cv cZ cH co
        wceq cR cring wcel cB cZ wceq wi wi wi wi wi va cv cA cH co cU cB cH
        opreq1 va cv cA cH co cB cH co cU cB cH co wceq va cv cA cH co cB cH co
        va cv cZ cH co wceq cA cX cZ cdif wcel cB cX wcel va cv cX wcel cR
        cring wcel cB cZ wceq wi va cv cA cH co cB cH co va cv cZ cH co wceq cA
        cX cZ cdif wcel cB cX wcel va cv cX wcel cR cring wcel cB cZ wceq wi wi
        wi wi wi cU cB cH co va cv cA cH co cB cH co cU cB cH co va cv cA cH co
        cB cH co wceq va cv cA cH co cB cH co va cv cZ cH co wceq cA cX cZ cdif
        wcel cB cX wcel va cv cX wcel cR cring wcel cB cZ wceq wi wi wi wi cU
        cB cH co va cv cA cH co cB cH co wceq va cv cA cH co cB cH co va cv cZ
        cH co wceq wa cU cB cH co va cv cZ cH co wceq cA cX cZ cdif wcel cB cX
        wcel va cv cX wcel cR cring wcel cB cZ wceq wi wi wi wi cU cB cH co va
        cv cA cH co cB cH co va cv cZ cH co eqtr cU cB cH co va cv cZ cH co
        wceq va cv cX wcel cB cX wcel cA cX cZ cdif wcel cR cring wcel cB cZ
        wceq wi cR cring wcel va cv cX wcel cB cX wcel cA cX cZ cdif wcel cU cB
        cH co va cv cZ cH co wceq cB cZ wceq cR cring wcel va cv cX wcel cB cX
        wcel cA cX cZ cdif wcel cU cB cH co va cv cZ cH co wceq cB cZ wceq wi
        wi va cv cZ cH co cZ wceq cU cB cH co cB wceq cA cX cZ cdif wcel cU cB
        cH co va cv cZ cH co wceq cB cZ wceq wi wi cR cring wcel va cv cX wcel
        cB cX wcel w3a cA cX cZ cdif wcel cU cB cH co cB wceq va cv cZ cH co cZ
        wceq cU cB cH co va cv cZ cH co wceq cB cZ wceq wi cU cB cH co va cv cZ
        cH co wceq cU cB cH co cB wceq va cv cZ cH co cZ wceq cA cX cZ cdif
        wcel cB cZ wceq cU cB cH co va cv cZ cH co wceq cU cB cH co cB wceq va
        cv cZ cH co cZ wceq cA cX cZ cdif wcel cB cZ wceq wi cU cB cH co va cv
        cZ cH co wceq cU cB cH co cB wceq va cv cZ cH co cZ wceq w3a cB cZ wceq
        cA cX cZ cdif wcel cU cB cH co va cv cZ cH co wceq cU cB cH co cB wceq
        va cv cZ cH co cZ wceq w3a cU cB cH co va cv cZ cH co cB cZ cU cB cH co
        va cv cZ cH co wceq cU cB cH co cB wceq va cv cZ cH co cZ wceq 3simp1
        cU cB cH co va cv cZ cH co wceq cU cB cH co cB wceq va cv cZ cH co cZ
        wceq 3simp2 cU cB cH co va cv cZ cH co wceq cU cB cH co cB wceq va cv
        cZ cH co cZ wceq 3simp3 3eqtr3d a1d 3exp com14 com13 cR cring wcel va
        cv cX wcel va cv cZ cH co cZ wceq cB cX wcel va cv cR cG cH cX cZ
        zerdivemp.3 zerdivemp.4 zerdivemp.1 zerdivemp.2 zerab2 3adant3 cR cring
        wcel cB cX wcel cU cB cH co cB wceq va cv cX wcel cB cR cU cH cX
        zerdivemp.2 cX cG crn cR c1st cfv crn zerdivemp.4 cG cR c1st cfv
        zerdivemp.1 rneqi eqtri zerdivemp.5 uridm1 3adant2 sylc 3exp com15
        com24 syl ex eqcoms com25 syl com12 3imp com13 syl6 com15 3imp1 com12
        3syl pm2.43i 3exp1 cA cB cH co cZ va cv cH opreq2 syl5com com14 3exp
        r19.23aiv com13 3imp $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}

    ${
      $d A a $. $d R a $. $d U a $. $d X a $. $d Z a $.
      $( In a unitary ring a left invertible element is different from
         zero iff ` 1 =/= 0 ` . $)
      rngridfz $p |- ( ( R e. Ring /\ A e. X /\
         E. a e. X ( a H A ) = U ) -> ( A =/= Z <-> U =/= Z ) ) $=
        cR cring wcel cA cX wcel va cv cA cH co cU wceq va cX wrex w3a cA cZ cU
        cZ cR cring wcel cA cX wcel va cv cA cH co cU wceq va cX wrex cA cZ
        wceq cU cZ wceq wb va cv cA cH co cU wceq va cX wrex cA cX wcel cR
        cring wcel cA cZ wceq cU cZ wceq wb va cv cA cH co cU wceq cA cX wcel
        cR cring wcel cA cZ wceq cU cZ wceq wb wi wi va cX va cv cX wcel va cv
        cA cH co cU wceq cA cX wcel cR cring wcel cA cZ wceq cU cZ wceq wb va
        cv cX wcel va cv cA cH co cU wceq cA cX wcel w3a cR cring wcel wa cA cZ
        wceq cU cZ wceq va cv cX wcel va cv cA cH co cU wceq cA cX wcel w3a cR
        cring wcel wa va cv cA cH co va cv cZ cH co wceq cU cZ wceq cA cZ wceq
        va cv cX wcel va cv cA cH co cU wceq cA cX wcel w3a cR cring wcel va cv
        cA cH co va cv cZ cH co wceq cU cZ wceq wi va cv cX wcel va cv cA cH co
        cU wceq cR cring wcel va cv cA cH co va cv cZ cH co wceq cU cZ wceq wi
        wi cA cX wcel va cv cX wcel va cv cA cH co cU wceq cR cring wcel va cv
        cA cH co va cv cZ cH co wceq cU cZ wceq wi wi cR cring wcel va cv cX
        wcel va cv cA cH co cU wceq va cv cA cH co va cv cZ cH co wceq cU cZ
        wceq wi cR cring wcel va cv cX wcel va cv cA cH co cU wceq va cv cA cH
        co va cv cZ cH co wceq cU cZ wceq wi wi va cv cA cH co cU wceq va cv cZ
        cH co cZ wceq va cv cA cH co va cv cZ cH co wceq cU cZ wceq wi cR cring
        wcel va cv cX wcel wa va cv cA cH co cU wceq va cv cZ cH co cZ wceq va
        cv cA cH co va cv cZ cH co wceq cU cZ wceq wi va cv cA cH co cU wceq va
        cv cZ cH co cZ wceq wa va cv cA cH co va cv cZ cH co wceq cU cZ wceq va
        cv cA cH co cU va cv cZ cH co cZ eqeq12 biimpd ex va cv cR cG cH cX cZ
        zerdivemp.3 zerdivemp.4 zerdivemp.1 zerdivemp.2 zerab2 syl5com ex com3l
        imp 3adant3 imp cA cZ va cv cH opreq2 syl5 va cv cX wcel va cv cA cH co
        cU wceq cA cX wcel w3a cR cring wcel wa cA cU cH co cA cZ cH co wceq cA
        cZ wceq cU cZ wceq va cv cX wcel va cv cA cH co cU wceq cA cX wcel w3a
        cR cring wcel cA cU cH co cA cZ cH co wceq cA cZ wceq wi cA cX wcel va
        cv cX wcel cR cring wcel cA cU cH co cA cZ cH co wceq cA cZ wceq wi wi
        va cv cA cH co cU wceq cR cring wcel cA cX wcel cA cU cH co cA cZ cH co
        wceq cA cZ wceq wi cA cU cH co cA wceq cA cZ cH co cZ wceq cA cU cH co
        cA cZ cH co wceq cA cZ wceq wi cR cring wcel cA cX wcel wa cA cU cH co
        cA wceq cA cZ cH co cZ wceq wa cA cU cH co cA cZ cH co wceq cA cZ wceq
        cA cU cH co cA cA cZ cH co cZ eqeq12 biimpd cA cR cU cH cX zerdivemp.2
        cX cG crn cR c1st cfv crn zerdivemp.4 cG cR c1st cfv zerdivemp.1 rneqi
        eqtri zerdivemp.5 uridm2 cA cR cG cH cX cZ zerdivemp.3 zerdivemp.4
        zerdivemp.1 zerdivemp.2 zerab2 sylanc expcom 3ad2ant3 imp cU cZ cA cH
        opreq2 syl5 impbid 3exp1 r19.23aiv com13 3imp necon3bid $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}
  $}

  ${
    $d x y $.
    $( ` ZZ ` is a commutative ring. $)
    zintdom $p |- <. + , x. >. e. ( Ring i^i Com2 ) $=
      caddc cmul cop cring ccm2 cin wcel caddc cmul cop cring wcel caddc cmul
      cop ccm2 wcel caddc cmul cop cring ccm2 elin cnring caddc cmul cop ccm2
      wcel vx cv vy cv cmul co vy cv vx cv cmul co wceq vy caddc crn wral vx
      caddc crn wral vx cv vy cv cmul co vy cv vx cv cmul co wceq vx vy caddc
      crn vx cv cc wcel vy cv cc wcel vx cv vy cv cmul co vy cv vx cv cmul co
      wceq vx cv caddc crn wcel vy cv caddc crn wcel vx cv vy cv axmulcom caddc
      crn cc vx cv cc cc cxp cc caddc wfo caddc crn cc wceq caddc cabl wcel cc
      cc cxp cc caddc wfo cnaddabl caddc cabl wcel caddc cgr wcel caddc cmnd
      wcel cc cc cxp cc caddc wfo caddc ablgrp caddc grpmnd caddc cmnd wcel
      caddc cmagm cexid cin wcel cc cc cxp cc caddc wfo caddc mndmgmid caddc cc
      cc cc cxp cc caddc wf cc caddc cdm cdm wceq axaddopr cc cc cxp cc caddc
      wf caddc cdm cc cc cxp wceq caddc cdm cdm cc cc cxp cdm wceq cc caddc cdm
      cdm wceq cc cc cxp cc caddc fdm caddc cdm cc cc cxp dmeq cc cc cxp cdm cc
      wceq caddc cdm cdm cc cc cxp cdm wceq cc caddc cdm cdm wceq wi cc dmxpid
      caddc cdm cdm cc cc cxp cdm wceq cc caddc cdm cdm wceq wi cc cc cc cxp
      cdm caddc cdm cdm cc cc cxp cdm wceq cc cc cc cxp cdm wceq cc caddc cdm
      cdm wceq cc cc cc cxp cdm wceq cc caddc cdm cdm wceq wi cc cc cxp cdm
      caddc cdm cdm cc cc cc cxp cdm wceq cc cc cxp cdm caddc cdm cdm wceq cc
      caddc cdm cdm wceq cc cc cc cxp cdm caddc cdm cdm eqtr expcom eqcoms
      com12 eqcoms ax-mp 3syl ax-mp opidon syl 3syl ax-mp cc cc cxp cc caddc
      forn ax-mp eleq2i caddc crn cc vy cv cc cc cxp cc caddc wfo caddc crn cc
      wceq caddc cabl wcel cc cc cxp cc caddc wfo cnaddabl caddc cabl wcel
      caddc cgr wcel caddc cmnd wcel cc cc cxp cc caddc wfo caddc ablgrp caddc
      grpmnd caddc cmnd wcel caddc cmagm cexid cin wcel cc cc cxp cc caddc wfo
      caddc mndmgmid caddc cc cc cc cxp cc caddc wf cc caddc cdm cdm wceq
      axaddopr cc cc cxp cc caddc wf caddc cdm cc cc cxp wceq caddc cdm cdm cc
      cc cxp cdm wceq cc caddc cdm cdm wceq cc cc cxp cc caddc fdm caddc cdm cc
      cc cxp dmeq cc cc cxp cdm cc wceq caddc cdm cdm cc cc cxp cdm wceq cc
      caddc cdm cdm wceq wi cc dmxpid caddc cdm cdm cc cc cxp cdm wceq cc caddc
      cdm cdm wceq wi cc cc cc cxp cdm caddc cdm cdm cc cc cxp cdm wceq cc cc
      cc cxp cdm wceq cc caddc cdm cdm wceq cc cc cc cxp cdm wceq cc caddc cdm
      cdm wceq wi cc cc cxp cdm caddc cdm cdm cc cc cc cxp cdm wceq cc cc cxp
      cdm caddc cdm cdm wceq cc caddc cdm cdm wceq cc cc cc cxp cdm caddc cdm
      cdm eqtr expcom eqcoms com12 eqcoms ax-mp 3syl ax-mp opidon syl 3syl
      ax-mp cc cc cxp cc caddc forn ax-mp eleq2i syl2anb rgen2a caddc cvv wcel
      cmul cvv wcel caddc cmul cop ccm2 wcel vx cv vy cv cmul co vy cv vx cv
      cmul co wceq vy caddc crn wral vx caddc crn wral wb addex mulex cvv cvv
      caddc cmul vx vy iscom2 mp2an mpbir mpbir2an $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  $c Tofld $.

  $( Extend class notation with the class of all totally ordered fields. $)
  ctofld $a class Tofld $.

  ${
    $d g h r x y z $.
    $( Definition of a totally ordered field. Experimental. $)
    df-tofld $a |- Tofld = { <. <. g , h >.  , r >. | ( <. g , h >. e. Fld
     /\ ( r e. Toset /\ U. U. r = ran g ) /\ A. x e. U. U. r A. y e. U. U. r
        A. z e. U. U. r ( ( x r y -> ( x g z ) r ( y g z ) ) /\
        ( ( Id ` g ) r z -> ( x h z ) r ( y h z ) ) ) ) } $.
  $}

  $c zeroDiv $.

  $( Extend class notation with the class of all the zero divisors. $)
  czerodiv $a class zeroDiv $.

  $( Definition of the zero divisors of a ring. Experimental. $)
  df-zd $a |- zeroDiv = { <. r , y >. | y = { a e. ran ( 1st ` r ) |
      ( a =/= ( Id ` ( 1st ` r ) ) /\
        E. b e. ran ( 1st ` r )
           ( b =/= ( Id ` ( 1st ` r ) ) /\
           ( a ( 2nd ` r ) b ) = ( Id ` ( 1st ` r ) ) ) ) } } $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Generic modules and vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Vec $.

  $( Extend class notation with the class of all generic vector spaces
     and modules. $)
  cvec $a class Vec $.

  ${ $d g h s a b u x v y $.
    $( Definition of a vector space ( ` <. g , h >. ` is a field ), or
    of a module ( ` <. g , h >. ` is a ring ). $)
    df-vec $a |- Vec = { z | E. g E. h E. a E. b
     ( z = <. <. g , h >. , <. a , b >. >. /\
        ( a e. Abel
         /\ b : ( ran g X. ran a ) --> ran a
         /\ A. u e. ran a ( ( ( Id ` h ) b u ) = u /\ A. x e. ran g
           ( A. v e. ran a  ( x b ( u a  v ) ) = ( ( x b u ) a ( x b v ) )
              /\ A. y e. ran g ( ( ( x g y ) b u ) = ( ( x b u ) a ( y b u ) )
              /\   ( ( x h y ) b u ) = ( x b ( y b u ) ) ) ) ) ) ) } $.
  $}


  ${
    $d A a b g h u v x y $. $d B a b g h u v x y $. $d G a b g h u x y $.
    $d H a b g h u x y $. $d a b g h u v x y z $.
    vecval1b.1 $e |- X = ran G $.
    vecval1b.4 $e |- W = ran A $.
    $( The predicate "is a vector space" or "is a module". $)
    vecval1b $p |- ( ( ( G e. M /\ H e. N /\  A e. O ) /\ B e. P )
      -> ( <. G , H >. Vec <. A , B >. <->
      ( A e. Abel /\ B : ( X X. W ) --> W
       /\ A. u e. W ( ( ( Id ` H ) B u ) = u
          /\ A. x e. X (
             A. v e. W
                 ( x B ( u A  v ) ) = ( ( x B u ) A ( x B v ) )
             /\ A. y e. X ( ( ( x G y ) B u ) = ( ( x B u ) A ( y B u ) )
             /\   ( ( x H y ) B u ) = ( x B ( y B u ) ) ) ) ) ) ) ) $=
      cG cM wcel cH cN wcel cA cO wcel w3a cB cP wcel wa cG cH cop cA cB cop
      cvec wbr cA cabl wcel cG crn cA crn cxp cA crn cB wf cH cgi cfv vu cv cB
      co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv
      cB co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv
      cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy
      cv vu cv cB co cB co wceq wa vy cG crn wral wa vx cG crn wral wa vu cA
      crn wral w3a cA cabl wcel cX cW cxp cW cB wf cH cgi cfv vu cv cB co vu cv
      wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA
      co wceq vv cW wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv
      vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB
      co cB co wceq wa vy cX wral wa vx cX wral wa vu cW wral w3a cG cM wcel cH
      cN wcel cA cO wcel w3a cB cP wcel wa cG cH cop cA cB cop cop cvec wcel cA
      cabl wcel cG crn cA crn cxp cA crn cB wf cH cgi cfv vu cv cB co vu cv
      wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA
      co wceq vv cA crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy
      cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv
      cB co cB co wceq wa vy cG crn wral wa vx cG crn wral wa vu cA crn wral
      w3a cG cH cop cA cB cop cvec wbr cG cM wcel cH cN wcel cA cO wcel w3a cB
      cP wcel wa cG cH cop cA cB cop cop vz cv vg cv vh cv cop va cv vb cv cop
      cop wceq va cv cabl wcel vg cv crn va cv crn cxp va cv crn vb cv wf vh cv
      cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx
      cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx
      cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv
      co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb
      cv co vb cv co wceq wa vy vg cv crn wral wa vx vg cv crn wral wa vu va cv
      crn wral w3a wa vb wex va wex vh wex vg wex vz cab wcel cA cabl wcel cG
      crn cA crn cxp cA crn cB wf cH cgi cfv vu cv cB co vu cv wceq vx cv vu cv
      vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA
      crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB
      co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co
      wceq wa vy cG crn wral wa vx cG crn wral wa vu cA crn wral w3a cG cH cop
      cA cB cop cop cvec wcel va cv cabl wcel vg cv crn va cv crn cxp va cv crn
      vb cv wf vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv
      co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va
      cv crn wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy
      cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv
      vy cv vu cv vb cv co vb cv co wceq wa vy vg cv crn wral wa vx vg cv crn
      wral wa vu va cv crn wral w3a va cv cabl wcel cG crn va cv crn cxp va cv
      crn vb cv wf vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va
      cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv
      va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy
      cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv
      vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral wa
      vu va cv crn wral w3a va cv cabl wcel cG crn va cv crn cxp va cv crn vb
      cv wf cH cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb
      cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv
      crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu
      cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral wa vu va cv
      crn wral w3a cA cabl wcel cG crn cA crn cxp cA crn vb cv wf cH cgi cfv vu
      cv vb cv co vu cv wceq vx cv vu cv vv cv cA co vb cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv
      vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq vx cv vy cv
      cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG
      crn wral wa vx cG crn wral wa vu cA crn wral w3a cA cabl wcel cG crn cA
      crn cxp cA crn cB wf cH cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv
      cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA crn wral
      vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co
      wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa
      vy cG crn wral wa vx cG crn wral wa vu cA crn wral w3a vz vg vh vb va cG
      cH cA cB cM cN cO cP vg cv cG wceq vg cv crn va cv crn cxp va cv crn vb
      cv wf cG crn va cv crn cxp va cv crn vb cv wf vh cv cgi cfv vu cv vb cv
      co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx
      cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv vg cv co vu
      cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv
      vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa
      vy vg cv crn wral wa vx vg cv crn wral wa vu va cv crn wral vh cv cgi cfv
      vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv
      vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv
      cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co
      wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co wceq wa vy cG crn wral wa vx cG crn wral wa vu va cv crn wral va cv
      cabl wcel vg cv cG wceq vg cv crn cG crn wceq vg cv crn va cv crn cxp cG
      crn va cv crn cxp wceq vg cv crn va cv crn cxp va cv crn vb cv wf cG crn
      va cv crn cxp va cv crn vb cv wf wb vg cv cG rneq vg cv crn cG crn va cv
      crn xpeq1 vg cv crn va cv crn cxp cG crn va cv crn cxp va cv crn vb cv
      feq2 3syl vg cv cG wceq vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu
      cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va
      cv co wceq vv va cv crn wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv
      vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy vg cv crn wral wa
      vx vg cv crn wral wa vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv
      vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv
      co wceq vv va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG
      crn wral wa vu va cv crn vg cv cG wceq vx cv vu cv vv cv va cv co vb cv
      co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn
      wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv
      vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vy vg cv crn wral wa vx vg cv crn wral vx cv
      vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      va cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv
      vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx
      cG crn wral vh cv cgi cfv vu cv vb cv co vu cv wceq vg cv cG wceq vx cv
      vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      va cv co wceq vv va cv crn wral vx cv vy cv vg cv co vu cv vb cv co vx cv
      vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu
      cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy vg cv crn wral
      wa vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv
      vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv
      co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn
      wral wa vx vg cv crn cG crn vg cv cG rneq vg cv cG wceq vx cv vy cv vg cv
      co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq
      vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co
      wceq wa vy vg cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral vx cv vu cv
      vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv
      co wceq vv va cv crn wral vg cv cG wceq vx cv vy cv vg cv co vu cv vb cv
      co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh
      cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vx cv vy
      cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv
      co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb
      cv co wceq wa vy vg cv crn cG crn vg cv cG rneq vg cv cG wceq vx cv vy cv
      vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv
      co wceq vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv
      vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq vg cv cG wceq vx cv vy cv vg cv co vu cv vb cv
      co vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb
      cv co va cv co vg cv cG wceq vx cv vy cv vg cv co vx cv vy cv cG co vu cv
      vb cv vx cv vy cv vg cv cG opreq opreq1d eqeq1d anbi1d raleq12d anbi2d
      raleq12d anbi2d ralbidv 3anbi23d vh cv cH wceq vh cv cgi cfv vu cv vb cv
      co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx
      cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv
      vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy
      cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy
      cG crn wral wa vx cG crn wral wa vu va cv crn wral cH cgi cfv vu cv vb cv
      co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx
      cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv
      vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy
      cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG
      crn wral wa vx cG crn wral wa vu va cv crn wral va cv cabl wcel cG crn va
      cv crn cxp va cv crn vb cv wf vh cv cH wceq vh cv cgi cfv vu cv vb cv co
      vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv
      vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv
      vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG
      crn wral wa vx cG crn wral wa cH cgi cfv vu cv vb cv co vu cv wceq vx cv
      vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      va cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb
      cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG
      crn wral wa vu va cv crn vh cv cH wceq vh cv cgi cfv vu cv vb cv co vu cv
      wceq cH cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb
      cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv
      crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu
      cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv
      vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral vx cv vu
      cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va
      cv co wceq vv va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG
      crn wral vh cv cH wceq vh cv cgi cfv vu cv vb cv co cH cgi cfv vu cv vb
      cv co vu cv vh cv cH wceq vh cv cgi cfv cH cgi cfv vu cv vb cv vh cv cH
      cgi fveq2 opreq1d eqeq1d vh cv cH wceq vx cv vu cv vv cv va cv co vb cv
      co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn
      wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb
      cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cG crn wral wa vx cv vu cv vv cv va cv co vb
      cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv
      crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu
      cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn vh cv cH wceq vx
      cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co
      va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv
      co vb cv co wceq wa vy cG crn wral vx cv vy cv cG co vu cv vb cv co vx cv
      vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cH co vu cv
      vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral vx cv
      vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      va cv co wceq vv va cv crn wral vh cv cH wceq vx cv vy cv cG co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv
      vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vx cv
      vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va
      cv co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb
      cv co wceq wa vy cG crn vh cv cH wceq vx cv vy cv vh cv co vu cv vb cv co
      vx cv vy cv vu cv vb cv co vb cv co wceq vx cv vy cv cH co vu cv vb cv co
      vx cv vy cv vu cv vb cv co vb cv co wceq vx cv vy cv cG co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vh cv cH wceq vx
      cv vy cv vh cv co vu cv vb cv co vx cv vy cv cH co vu cv vb cv co vx cv
      vy cv vu cv vb cv co vb cv co vh cv cH wceq vx cv vy cv vh cv co vx cv vy
      cv cH co vu cv vb cv vx cv vy cv vh cv cH opreq opreq1d eqeq1d anbi2d
      ralbidv anbi2d ralbidv anbi12d ralbidv 3anbi3d va cv cA wceq va cv cabl
      wcel cA cabl wcel cG crn va cv crn cxp va cv crn vb cv wf cG crn cA crn
      cxp cA crn vb cv wf cH cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv
      cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co
      wceq vv va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv
      co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb cv co vx
      cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral
      wa vu va cv crn wral cH cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv
      cv cA co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co cA co wceq vv
      cA crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv
      vu cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral wa vu cA
      crn wral va cv cA cabl eleq1 cG crn va cv crn cxp cG crn cA crn cxp wceq
      va cv crn cA crn wceq cG crn va cv crn cxp va cv crn vb cv wf cG crn cA
      crn cxp cA crn vb cv wf wb va cv cA wceq cG crn va cv crn cxp va cv crn
      cG crn cA crn cxp cA crn vb cv feq23 va cv cA wceq va cv crn cA crn wceq
      cG crn va cv crn cxp cG crn cA crn cxp wceq va cv cA rneq va cv crn cA
      crn cG crn xpeq2 syl va cv cA rneq sylanc va cv cA wceq cH cgi cfv vu cv
      vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cG co
      vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx
      cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa
      vy cG crn wral wa vx cG crn wral wa cH cgi cfv vu cv vb cv co vu cv wceq
      vx cv vu cv vv cv cA co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv
      co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co
      vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn
      wral wa vu va cv crn cA crn va cv cA rneq va cv cA wceq vx cv vu cv vv cv
      va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq
      vv va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co
      vy cv vu cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb cv co vx cv
      vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral vx
      cv vu cv vv cv cA co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      cA co wceq vv cA crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx
      cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral
      cH cgi cfv vu cv vb cv co vu cv wceq va cv cA wceq vx cv vu cv vv cv va
      cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv
      va cv crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy
      cv vu cv vb cv co va cv co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy
      cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cv vu cv vv cv cA
      co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co cA co wceq vv cA
      crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu
      cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn va cv cA wceq vx cv
      vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      va cv co wceq vv va cv crn wral vx cv vu cv vv cv cA co vb cv co vx cv vu
      cv vb cv co vx cv vv cv vb cv co cA co wceq vv cA crn wral vx cv vy cv cG
      co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq
      vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq
      wa vy cG crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co
      vy cv vu cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy
      cv vu cv vb cv co vb cv co wceq wa vy cG crn wral va cv cA wceq vx cv vu
      cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va
      cv co wceq vx cv vu cv vv cv cA co vb cv co vx cv vu cv vb cv co vx cv vv
      cv vb cv co cA co wceq vv va cv crn cA crn va cv cA rneq va cv cA wceq vx
      cv vu cv vv cv va cv co vb cv co vx cv vu cv vv cv cA co vb cv co vx cv
      vu cv vb cv co vx cv vv cv vb cv co va cv co vx cv vu cv vb cv co vx cv
      vv cv vb cv co cA co va cv cA wceq vu cv vv cv va cv co vu cv vv cv cA co
      vx cv vb cv vu cv vv cv va cv cA opreq opreq2d vx cv vu cv vb cv co vx cv
      vv cv vb cv co va cv cA opreq eqeq12d raleq12d va cv cA wceq vx cv vy cv
      cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co
      wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co
      wceq wa vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv
      vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb
      cv co vb cv co wceq wa vy cG crn va cv cA wceq vx cv vy cv cG co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv
      cG co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq
      vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq
      va cv cA wceq vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co cA co vx cv vy cv cG co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv cA opreq eqeq2d anbi1d
      ralbidv anbi12d ralbidv anbi2d raleq12d 3anbi123d vb cv cB wceq cG crn cA
      crn cxp cA crn vb cv wf cG crn cA crn cxp cA crn cB wf cH cgi cfv vu cv
      vb cv co vu cv wceq vx cv vu cv vv cv cA co vb cv co vx cv vu cv vb cv co
      vx cv vv cv vb cv co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq vx cv vy cv cH
      co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn
      wral wa vx cG crn wral wa vu cA crn wral cH cgi cfv vu cv cB co vu cv
      wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA
      co wceq vv cA crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy
      cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv
      cB co cB co wceq wa vy cG crn wral wa vx cG crn wral wa vu cA crn wral cA
      cabl wcel cG crn cA crn cxp cA crn vb cv cB feq1 vb cv cB wceq cH cgi cfv
      vu cv vb cv co vu cv wceq vx cv vu cv vv cv cA co vb cv co vx cv vu cv vb
      cv co vx cv vv cv vb cv co cA co wceq vv cA crn wral vx cv vy cv cG co vu
      cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq vx cv vy
      cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG
      crn wral wa vx cG crn wral wa cH cgi cfv vu cv cB co vu cv wceq vx cv vu
      cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA
      crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB
      co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co
      wceq wa vy cG crn wral wa vx cG crn wral wa vu cA crn vb cv cB wceq cH
      cgi cfv vu cv vb cv co vu cv wceq cH cgi cfv vu cv cB co vu cv wceq vx cv
      vu cv vv cv cA co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co cA
      co wceq vv cA crn wral vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv
      co vy cv vu cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx cv
      vy cv vu cv vb cv co vb cv co wceq wa vy cG crn wral wa vx cG crn wral vx
      cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq
      vv cA crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu
      cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co
      cB co wceq wa vy cG crn wral wa vx cG crn wral vb cv cB wceq cH cgi cfv
      vu cv vb cv co cH cgi cfv vu cv cB co vu cv cH cgi cfv vu cv vb cv cB
      opreq eqeq1d vb cv cB wceq vx cv vu cv vv cv cA co vb cv co vx cv vu cv
      vb cv co vx cv vv cv vb cv co cA co wceq vv cA crn wral vx cv vy cv cG co
      vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq vx cv
      vy cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy
      cG crn wral wa vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv
      cv cB co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv cB co vx cv vu
      cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv
      vy cv vu cv cB co cB co wceq wa vy cG crn wral wa vx cG crn vb cv cB wceq
      vx cv vu cv vv cv cA co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv
      co cA co wceq vv cA crn wral vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq vx cv vy cv cH
      co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cG crn
      wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA
      co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq
      wa vy cG crn wral vb cv cB wceq vx cv vu cv vv cv cA co vb cv co vx cv vu
      cv vb cv co vx cv vv cv vb cv co cA co wceq vx cv vu cv vv cv cA co cB co
      vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA crn vb cv cB wceq vx
      cv vu cv vv cv cA co vb cv co vx cv vu cv vv cv cA co cB co vx cv vu cv
      vb cv co vx cv vv cv vb cv co cA co vx cv vu cv cB co vx cv vv cv cB co
      cA co vx cv vu cv vv cv cA co vb cv cB opreq vb cv cB wceq vx cv vu cv vb
      cv co vx cv vu cv cB co vx cv vv cv vb cv co vx cv vv cv cB co cA vx cv
      vu cv vb cv cB opreq vx cv vv cv vb cv cB opreq opreq12d eqeq12d ralbidv
      vb cv cB wceq vx cv vy cv cG co vu cv vb cv co vx cv vu cv vb cv co vy cv
      vu cv vb cv co cA co wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vx cv vy cv cG co vu cv cB co vx cv vu cv cB
      co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv
      vu cv cB co cB co wceq wa vy cG crn vb cv cB wceq vx cv vy cv cG co vu cv
      vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cA co wceq vx cv vy cv
      cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy
      cv cH co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq vx cv vy
      cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq vb cv cB wceq vx
      cv vy cv cG co vu cv vb cv co vx cv vy cv cG co vu cv cB co vx cv vu cv
      vb cv co vy cv vu cv vb cv co cA co vx cv vu cv cB co vy cv vu cv cB co
      cA co vx cv vy cv cG co vu cv vb cv cB opreq vb cv cB wceq vx cv vu cv vb
      cv co vx cv vu cv cB co vy cv vu cv vb cv co vy cv vu cv cB co cA vx cv
      vu cv vb cv cB opreq vy cv vu cv vb cv cB opreq opreq12d eqeq12d vb cv cB
      wceq vx cv vy cv cH co vu cv vb cv co vx cv vy cv cH co vu cv cB co vx cv
      vy cv vu cv vb cv co vb cv co vx cv vy cv vu cv cB co cB co vx cv vy cv
      cH co vu cv vb cv cB opreq vb cv cB wceq vx cv vx cv vy cv vu cv vb cv co
      vy cv vu cv cB co vb cv cB vb cv cB wceq id vb cv cB wceq vx cv eqidd vy
      cv vu cv vb cv cB opreq opreq123d eqeq12d anbi12d ralbidv anbi12d ralbidv
      anbi12d ralbidv 3anbi23d elo cvec vz cv vg cv vh cv cop va cv vb cv cop
      cop wceq va cv cabl wcel vg cv crn va cv crn cxp va cv crn vb cv wf vh cv
      cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx
      cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx
      cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv
      co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb
      cv co vb cv co wceq wa vy vg cv crn wral wa vx vg cv crn wral wa vu va cv
      crn wral w3a wa vb wex va wex vh wex vg wex vz cab cG cH cop cA cB cop
      cop vx vy vz vv vu vg vh va vb df-vec eleq2i syl5bb cG cH cop cA cB cop
      cvec df-br syl5bb cA cabl wcel cA cabl wcel cG crn cA crn cxp cA crn cB
      wf cX cW cxp cW cB wf cH cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv
      cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA crn wral
      vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co
      wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa
      vy cG crn wral wa vx cG crn wral wa vu cA crn wral cH cgi cfv vu cv cB co
      vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB
      co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co
      vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu
      cv cB co cB co wceq wa vy cX wral wa vx cX wral wa vu cW wral cA cabl
      wcel biid cG crn cA crn cxp cX cW cxp wceq cA crn cW wceq cG crn cA crn
      cxp cA crn cB wf cX cW cxp cW cB wf wb cG crn cX cA crn cW cX cG crn
      vecval1b.1 eqcomi cW cA crn vecval1b.4 eqcomi xpeq12i cW cA crn
      vecval1b.4 eqcomi cG crn cA crn cxp cA crn cX cW cxp cW cB feq23 mp2an cH
      cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv
      cB co vx cv vv cv cB co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv
      cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu
      cv cB co vx cv vy cv vu cv cB co cB co wceq wa vy cG crn wral wa vx cG
      crn wral wa cH cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB
      co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv
      cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy
      cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa
      vx cX wral wa vu cA crn cW vu cv cA crn wcel vu cv cW wcel cH cgi cfv vu
      cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv
      vv cv cB co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv cB co vx cv
      vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx
      cv vy cv vu cv cB co cB co wceq wa vy cG crn wral wa vx cG crn wral wa cH
      cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv
      cB co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB
      co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv
      cB co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral wa
      cA crn cW vu cv cW cA crn vecval1b.4 eqcomi eleq2i vx cv vu cv vv cv cA
      co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA crn wral vx
      cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq
      vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa vy cG
      crn wral wa vx cG crn wral vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co
      vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB
      co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral cH cgi
      cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cA crn wral vx cv vy cv cG co vu cv cB
      co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv
      cB co vx cv vy cv vu cv cB co cB co wceq wa vy cG crn wral wa vx cv vu cv
      vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cW
      wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA
      co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq
      wa vy cX wral wa vx cG crn cX vx cv cG crn wcel vx cv cX wcel vx cv vu cv
      vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cA
      crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB
      co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co
      wceq wa vy cG crn wral wa vx cv vu cv vv cv cA co cB co vx cv vu cv cB co
      vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co vx
      cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co
      vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa cG crn cX vx cv cX cG
      crn vecval1b.1 eqcomi eleq2i vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cA crn wral vx cv vu cv vv cv cA co cB
      co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv
      cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy
      cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa vy cG crn wral
      vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co
      wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa
      vy cX wral vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB
      co cA co wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv
      cB co cA co wceq vv cA crn cW vv cv cA crn wcel vv cv cW wcel vx cv vu cv
      vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq cA crn
      cW vv cv cW cA crn vecval1b.4 eqcomi eleq2i imbi1i ralbii2 vx cv vy cv cG
      co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv
      cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa vx cv vy cv cG co
      vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH
      co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa vy cG crn cX vy cv
      cG crn wcel vy cv cX wcel vx cv vy cv cG co vu cv cB co vx cv vu cv cB co
      vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu
      cv cB co cB co wceq wa cG crn cX vy cv cX cG crn vecval1b.1 eqcomi eleq2i
      imbi1i ralbii2 anbi12i imbi12i ralbii2 anbi2i imbi12i ralbii2 3anbi123i
      syl6bb $.
      $( [20-Sep-2010] $) $( [12-Jul-2010] $)
  $}

  ${
    $d A a b g h $. $d B a b g h $. $d G a b g h $. $d H a b g h $.
    $d R a b g h u v x y z $. $d W a b g h $. $d X a b g h $.
    vecval3b.1 $e |- X = ran G $.
    vecval3b.2 $e |- G = ( 1st ` ( 1st ` R ) ) $.
    vecval3b.3 $e |- H = ( 2nd ` ( 1st ` R ) ) $.
    vecval3b.4 $e |- A = ( 1st ` ( 2nd ` R ) ) $.
    vecval3b.5 $e |- B = ( 2nd ` ( 2nd ` R ) ) $.
    vecval3b.6 $e |- W = ran A $.
    $( The "axioms" of a vector space or module. $)
    vecval3b $p |- ( R e. Vec ->
      ( A e. Abel /\ B : ( X X. W ) --> W
       /\ A. u e. W ( ( ( Id ` H ) B u ) = u
          /\ A. x e. X (
             A. v e. W
                 ( x B ( u A  v ) ) = ( ( x B u ) A ( x B v ) )
             /\ A. y e. X ( ( ( x G y ) B u ) = ( ( x B u ) A ( y B u ) )
             /\   ( ( x H y ) B u ) = ( x B ( y B u ) ) ) ) ) ) ) $=
      cR cvec wcel cR vz cv vg cv vh cv cop va cv vb cv cop cop wceq va cv cabl
      wcel vg cv crn va cv crn cxp va cv crn vb cv wf vh cv cgi cfv vu cv vb cv
      co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx
      cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv vg cv co vu
      cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv
      vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa
      vy vg cv crn wral wa vx vg cv crn wral wa vu va cv crn wral w3a wa vb wex
      va wex vh wex vg wex vz cab wcel cA cabl wcel cX cW cxp cW cB wf cH cgi
      cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co
      vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB
      co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral wa vu
      cW wral w3a cvec vz cv vg cv vh cv cop va cv vb cv cop cop wceq va cv
      cabl wcel vg cv crn va cv crn cxp va cv crn vb cv wf vh cv cgi cfv vu cv
      vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv vg cv
      co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq
      vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co
      wceq wa vy vg cv crn wral wa vx vg cv crn wral wa vu va cv crn wral w3a
      wa vb wex va wex vh wex vg wex vz cab cR vx vy vz vv vu vg vh va vb
      df-vec eleq2i va cv cabl wcel vg cv crn va cv crn cxp va cv crn vb cv wf
      vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv
      co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn
      wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv
      vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vy vg cv crn wral wa vx vg cv crn wral wa vu
      va cv crn wral w3a va cv cabl wcel cR c1st cfv c1st cfv crn va cv crn cxp
      va cv crn vb cv wf vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv
      cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co
      wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv
      co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st
      cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu va cv crn
      wral w3a va cv cabl wcel cR c1st cfv c1st cfv crn va cv crn cxp va cv crn
      vb cv wf cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx cv vu
      cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va
      cv co wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv
      crn wral wa vu va cv crn wral w3a cR c2nd cfv c1st cfv cabl wcel cR c1st
      cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp cR c2nd cfv c1st cfv crn vb
      cv wf cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv
      vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv co vx cv vv cv
      vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx
      cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy
      cv vu cv vb cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy
      cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu
      cR c2nd cfv c1st cfv crn wral w3a cA cabl wcel cX cW cxp cW cB wf cH cgi
      cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co
      vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB
      co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral wa vu
      cW wral w3a vz vg vh vb va cR vg cv cR c1st cfv c1st cfv wceq vg cv crn
      va cv crn cxp va cv crn vb cv wf cR c1st cfv c1st cfv crn va cv crn cxp
      va cv crn vb cv wf vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv
      cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co
      wceq vv va cv crn wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy vg cv crn wral wa vx vg
      cv crn wral wa vu va cv crn wral vh cv cgi cfv vu cv vb cv co vu cv wceq
      vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb
      cv co va cv co wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co
      vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx
      cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq
      wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral
      wa vu va cv crn wral va cv cabl wcel vg cv crn va cv crn cxp cR c1st cfv
      c1st cfv crn va cv crn cxp wceq va cv crn va cv crn wceq vg cv crn va cv
      crn cxp va cv crn vb cv wf cR c1st cfv c1st cfv crn va cv crn cxp va cv
      crn vb cv wf wb vg cv cR c1st cfv c1st cfv wceq vg cv crn va cv crn cxp
      va cv crn cR c1st cfv c1st cfv crn va cv crn cxp va cv crn vb cv feq23 vg
      cv cR c1st cfv c1st cfv wceq vg cv crn cR c1st cfv c1st cfv crn wceq vg
      cv crn va cv crn cxp cR c1st cfv c1st cfv crn va cv crn cxp wceq vg cv cR
      c1st cfv c1st cfv rneq vg cv crn cR c1st cfv c1st cfv crn va cv crn xpeq1
      syl vg cv cR c1st cfv c1st cfv wceq va cv crn eqidd sylanc vg cv cR c1st
      cfv c1st cfv wceq vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv
      cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co
      wceq vv va cv crn wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy vg cv crn wral wa vx vg
      cv crn wral wa vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv
      va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq
      vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx
      cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co
      vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv
      c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu va cv crn vg
      cv cR c1st cfv c1st cfv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu
      cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy
      cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va
      cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co
      vb cv co wceq wa vy vg cv crn wral wa vx vg cv crn wral vx cv vu cv vv cv
      va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq
      vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx
      cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co
      vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv
      c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral vh cv cgi cfv vu cv
      vb cv co vu cv wceq vg cv cR c1st cfv c1st cfv wceq vx cv vu cv vv cv va
      cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv
      va cv crn wral vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co
      vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx
      cv vy cv vu cv vb cv co vb cv co wceq wa vy vg cv crn wral wa vx cv vu cv
      vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv
      co wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv
      co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh
      cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR
      c1st cfv c1st cfv crn wral wa vx vg cv crn cR c1st cfv c1st cfv crn vg cv
      cR c1st cfv c1st cfv rneq vg cv cR c1st cfv c1st cfv wceq vx cv vy cv vg
      cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co
      wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co wceq wa vy vg cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv
      vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR
      c1st cfv c1st cfv crn wral vx cv vu cv vv cv va cv co vb cv co vx cv vu
      cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vg cv cR
      c1st cfv c1st cfv wceq vx cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq wa vx cv vy cv cR c1st cfv
      c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va
      cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co
      vb cv co wceq wa vy vg cv crn cR c1st cfv c1st cfv crn vg cv cR c1st cfv
      c1st cfv wceq vy cv vg cv crn wcel vy cv cR c1st cfv c1st cfv crn wcel vx
      cv vy cv vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv
      co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb
      cv co vb cv co wceq wa vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv
      co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vg cv cR
      c1st cfv c1st cfv wceq vg cv crn cR c1st cfv c1st cfv crn vy cv vg cv cR
      c1st cfv c1st cfv rneq eleq2d vg cv cR c1st cfv c1st cfv wceq vx cv vy cv
      vg cv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv
      co wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb
      cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv
      co vx cv vy cv vu cv vb cv co vb cv co wceq vg cv cR c1st cfv c1st cfv
      wceq vx cv vy cv vg cv co vu cv vb cv co vx cv vy cv cR c1st cfv c1st cfv
      co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co vg
      cv cR c1st cfv c1st cfv wceq vx cv vy cv vg cv co vx cv vy cv cR c1st cfv
      c1st cfv co vu cv vb cv vx cv vy cv vg cv cR c1st cfv c1st cfv opreq
      opreq1d eqeq1d anbi1d imbi12d ralbidv2 anbi2d raleq12d anbi2d ralbidv
      3anbi23d vh cv cR c1st cfv c2nd cfv wceq vh cv cgi cfv vu cv vb cv co vu
      cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv
      cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st
      cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co
      wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv
      crn wral wa vu va cv crn wral cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co
      vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv
      vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cR c1st cfv
      c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va
      cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv
      vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR
      c1st cfv c1st cfv crn wral wa vu va cv crn wral va cv cabl wcel cR c1st
      cfv c1st cfv crn va cv crn cxp va cv crn vb cv wf vh cv cR c1st cfv c2nd
      cfv wceq vh cv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv
      co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va
      cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv
      vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st
      cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa cR c1st cfv c2nd cfv
      cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co vb cv co vx
      cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx
      cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy
      cv vu cv vb cv co va cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv
      vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st
      cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu va cv crn vh cv cR
      c1st cfv c2nd cfv wceq vh cv cgi cfv vu cv vb cv co vu cv wceq cR c1st
      cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va cv co
      vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv
      crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb
      cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv
      crn wral wa vx cR c1st cfv c1st cfv crn wral vx cv vu cv vv cv va cv co
      vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv
      crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR
      c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral vh cv cR
      c1st cfv c2nd cfv wceq vh cv cgi cfv vu cv vb cv co cR c1st cfv c2nd cfv
      cgi cfv vu cv vb cv co vu cv vh cv cR c1st cfv c2nd cfv wceq vh cv cgi
      cfv cR c1st cfv c2nd cfv cgi cfv vu cv vb cv vh cv cR c1st cfv c2nd cfv
      cgi fveq2 opreq1d eqeq1d vh cv cR c1st cfv c2nd cfv wceq vx cv vu cv vv
      cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co
      wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv
      co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st
      cfv c1st cfv crn wral wa vx cv vu cv vv cv va cv co vb cv co vx cv vu cv
      vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv
      cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv
      vb cv co va cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co
      vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn
      wral wa vx cR c1st cfv c1st cfv crn vh cv cR c1st cfv c2nd cfv wceq vx cv
      vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv
      vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy
      cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral vx cv
      vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv
      vu cv vb cv co va cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb
      cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv
      crn wral vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv
      vv cv vb cv co va cv co wceq vv va cv crn wral vh cv cR c1st cfv c2nd cfv
      wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv
      co vy cv vu cv vb cv co va cv co wceq vx cv vy cv vh cv co vu cv vb cv co
      vx cv vy cv vu cv vb cv co vb cv co wceq wa vx cv vy cv cR c1st cfv c1st
      cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn vh cv cR c1st cfv
      c2nd cfv wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv vu cv vb cv
      co vb cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv
      vy cv vu cv vb cv co vb cv co wceq vx cv vy cv cR c1st cfv c1st cfv co vu
      cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vh cv
      cR c1st cfv c2nd cfv wceq vx cv vy cv vh cv co vu cv vb cv co vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co vh cv cR c1st cfv c2nd cfv wceq vx cv vy cv vh cv co vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv vb cv vx cv vy cv vh cv cR c1st cfv c2nd cfv
      opreq opreq1d eqeq1d anbi2d ralbidv anbi2d ralbidv anbi12d ralbidv
      3anbi3d va cv cR c2nd cfv c1st cfv wceq va cv cabl wcel cR c2nd cfv c1st
      cfv cabl wcel cR c1st cfv c1st cfv crn va cv crn cxp va cv crn vb cv wf
      cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp cR c2nd cfv c1st
      cfv crn vb cv wf cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq
      vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb
      cv co va cv co wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co
      vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx
      cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv
      co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv
      c1st cfv crn wral wa vu va cv crn wral cR c1st cfv c2nd cfv cgi cfv vu cv
      vb cv co vu cv wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx
      cv vu cv vb cv co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR
      c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st
      cfv c1st cfv crn wral wa vu cR c2nd cfv c1st cfv crn wral va cv cR c2nd
      cfv c1st cfv cabl eleq1 cR c1st cfv c1st cfv crn va cv crn cxp cR c1st
      cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp wceq va cv crn cR c2nd cfv
      c1st cfv crn wceq cR c1st cfv c1st cfv crn va cv crn cxp va cv crn vb cv
      wf cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp cR c2nd cfv c1st
      cfv crn vb cv wf wb va cv cR c2nd cfv c1st cfv wceq cR c1st cfv c1st cfv
      crn va cv crn cxp va cv crn cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv
      crn cxp cR c2nd cfv c1st cfv crn vb cv feq23 va cv cR c2nd cfv c1st cfv
      wceq va cv crn cR c2nd cfv c1st cfv crn wceq cR c1st cfv c1st cfv crn va
      cv crn cxp cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp wceq va
      cv cR c2nd cfv c1st cfv rneq va cv crn cR c2nd cfv c1st cfv crn cR c1st
      cfv c1st cfv crn xpeq2 syl va cv cR c2nd cfv c1st cfv rneq sylanc va cv
      cR c2nd cfv c1st cfv wceq cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu
      cv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv
      cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st
      cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st
      cfv c1st cfv crn wral wa cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu
      cv wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb
      cv co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv
      c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx
      cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co wceq vx cv
      vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co
      vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st
      cfv crn wral wa vu va cv crn cR c2nd cfv c1st cfv crn va cv cR c2nd cfv
      c1st cfv wceq vu cv va cv crn wcel vu cv cR c2nd cfv c1st cfv crn wcel cR
      c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv va
      cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv
      va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv
      vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy
      cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa cR
      c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv cR
      c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co
      cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx cv vy cv
      cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv
      vb cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co
      vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv
      c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa va cv cR c2nd
      cfv c1st cfv wceq va cv crn cR c2nd cfv c1st cfv crn vu cv va cv cR c2nd
      cfv c1st cfv rneq eleq2d va cv cR c2nd cfv c1st cfv wceq vx cv vu cv vv
      cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co
      wceq vv va cv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co
      vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co
      wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn
      wral vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st
      cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv
      crn wral cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq va cv cR
      c2nd cfv c1st cfv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb
      cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral vx cv vy cv cR
      c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb
      cv co va cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx
      cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral
      wa vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st
      cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu
      cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv
      co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv
      crn va cv cR c2nd cfv c1st cfv wceq vx cv vu cv vv cv va cv co vb cv co
      vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co wceq vv va cv crn wral
      vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv co
      vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv
      crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR
      c1st cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral va cv cR c2nd
      cfv c1st cfv wceq vx cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co va cv co wceq vx cv vu cv vv cv cR c2nd cfv c1st
      cfv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co cR c2nd cfv
      c1st cfv co wceq vv va cv crn cR c2nd cfv c1st cfv crn va cv cR c2nd cfv
      c1st cfv wceq vv cv va cv crn wcel vv cv cR c2nd cfv c1st cfv crn wcel vx
      cv vu cv vv cv va cv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv
      co va cv co wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv
      vu cv vb cv co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq va cv cR
      c2nd cfv c1st cfv wceq va cv crn cR c2nd cfv c1st cfv crn vv cv va cv cR
      c2nd cfv c1st cfv rneq eleq2d va cv cR c2nd cfv c1st cfv wceq vx cv vu cv
      vv cv va cv co vb cv co vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv
      co vx cv vu cv vb cv co vx cv vv cv vb cv co va cv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co va cv cR c2nd cfv c1st
      cfv wceq vu cv vv cv va cv co vu cv vv cv cR c2nd cfv c1st cfv co vx cv
      vb cv vu cv vv cv va cv cR c2nd cfv c1st cfv opreq opreq2d vx cv vu cv vb
      cv co vx cv vv cv vb cv co va cv cR c2nd cfv c1st cfv opreq eqeq12d
      imbi12d ralbidv2 va cv cR c2nd cfv c1st cfv wceq vx cv vy cv cR c1st cfv
      c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va
      cv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv
      vu cv vb cv co vb cv co wceq wa vx cv vy cv cR c1st cfv c1st cfv co vu cv
      vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv
      co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu
      cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn va cv cR c2nd
      cfv c1st cfv wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx
      cv vu cv vb cv co vy cv vu cv vb cv co va cv co wceq vx cv vy cv cR c1st
      cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co
      cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb
      cv co vx cv vy cv vu cv vb cv co vb cv co wceq va cv cR c2nd cfv c1st cfv
      wceq vx cv vu cv vb cv co vy cv vu cv vb cv co va cv co vx cv vu cv vb cv
      co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co vx cv vy cv cR c1st cfv
      c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co va
      cv cR c2nd cfv c1st cfv opreq eqeq2d anbi1d ralbidv anbi12d ralbidv
      anbi2d imbi12d ralbidv2 3anbi123d vb cv cR c2nd cfv c2nd cfv wceq cR c2nd
      cfv c1st cfv cabl wcel cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn
      cxp cR c2nd cfv c1st cfv crn vb cv wf cR c1st cfv c2nd cfv cgi cfv vu cv
      vb cv co vu cv wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx
      cv vu cv vb cv co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR
      c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st
      cfv c1st cfv crn wral wa vu cR c2nd cfv c1st cfv crn wral w3a cR c2nd cfv
      c1st cfv cabl wcel cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp
      cR c2nd cfv c1st cfv crn cR c2nd cfv c2nd cfv wf cR c1st cfv c2nd cfv cgi
      cfv vu cv cR c2nd cfv c2nd cfv co vu cv wceq vx cv vu cv vv cv cR c2nd
      cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv
      co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR
      c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn
      wral wa vx cR c1st cfv c1st cfv crn wral wa vu cR c2nd cfv c1st cfv crn
      wral w3a cA cabl wcel cX cW cxp cW cB wf cH cgi cfv vu cv cB co vu cv
      wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA
      co wceq vv cW wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv
      vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB
      co cB co wceq wa vy cX wral wa vx cX wral wa vu cW wral w3a vb cv cR c2nd
      cfv c2nd cfv wceq cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp
      cR c2nd cfv c1st cfv crn vb cv wf cR c1st cfv c1st cfv crn cR c2nd cfv
      c1st cfv crn cxp cR c2nd cfv c1st cfv crn cR c2nd cfv c2nd cfv wf cR c1st
      cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx cv vu cv vv cv cR c2nd
      cfv c1st cfv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co cR
      c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx cv vy cv cR
      c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb
      cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu
      cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv
      c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu cR c2nd cfv
      c1st cfv crn wral cR c1st cfv c2nd cfv cgi cfv vu cv cR c2nd cfv c2nd cfv
      co vu cv wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd
      cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd
      cfv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx
      cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vu
      cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cR c2nd
      cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv
      c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv
      c1st cfv crn wral wa vu cR c2nd cfv c1st cfv crn wral cR c2nd cfv c1st
      cfv cabl wcel cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp cR
      c2nd cfv c1st cfv crn vb cv cR c2nd cfv c2nd cfv feq1 vb cv cR c2nd cfv
      c2nd cfv wceq cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co vu cv wceq vx
      cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv co vx
      cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv
      crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co
      wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn
      wral wa cR c1st cfv c2nd cfv cgi cfv vu cv cR c2nd cfv c2nd cfv co vu cv
      wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx
      cv vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR
      c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx cv vy cv cR
      c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd
      cfv c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv
      co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cR c2nd cfv c2nd cfv co
      vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa
      vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa
      vu cR c2nd cfv c1st cfv crn vb cv cR c2nd cfv c2nd cfv wceq cR c1st cfv
      c2nd cfv cgi cfv vu cv vb cv co vu cv wceq cR c1st cfv c2nd cfv cgi cfv
      vu cv cR c2nd cfv c2nd cfv co vu cv wceq vx cv vu cv vv cv cR c2nd cfv
      c1st cfv co vb cv co vx cv vu cv vb cv co vx cv vv cv vb cv co cR c2nd
      cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st
      cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co
      cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb
      cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv c1st cfv
      crn wral wa vx cR c1st cfv c1st cfv crn wral vx cv vu cv vv cv cR c2nd
      cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv
      co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR
      c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn
      wral wa vx cR c1st cfv c1st cfv crn wral vb cv cR c2nd cfv c2nd cfv wceq
      cR c1st cfv c2nd cfv cgi cfv vu cv vb cv co cR c1st cfv c2nd cfv cgi cfv
      vu cv cR c2nd cfv c2nd cfv co vu cv cR c1st cfv c2nd cfv cgi cfv vu cv vb
      cv cR c2nd cfv c2nd cfv opreq eqeq1d vb cv cR c2nd cfv c2nd cfv wceq vx
      cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv co vx
      cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv
      crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv
      vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv vb cv co vb cv co
      wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cv vu cv vv cv cR c2nd cfv
      c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co
      vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR
      c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn
      wral wa vx cR c1st cfv c1st cfv crn vb cv cR c2nd cfv c2nd cfv wceq vx cv
      vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv vb cv co vx cv
      vv cv vb cv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn
      wral vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx
      cv vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR
      c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn wral vx cv vy cv cR
      c1st cfv c1st cfv co vu cv vb cv co vx cv vu cv vb cv co vy cv vu cv vb
      cv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu
      cv vb cv co vx cv vy cv vu cv vb cv co vb cv co wceq wa vy cR c1st cfv
      c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv
      c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv
      co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv
      co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral vb cv
      cR c2nd cfv c2nd cfv wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv
      co vx cv vu cv vb cv co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co wceq
      vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv
      vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn vb cv cR c2nd cfv c2nd
      cfv wceq vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv co vx cv vu cv
      vv cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv vb cv
      co vx cv vv cv vb cv co cR c2nd cfv c1st cfv co vx cv vu cv cR c2nd cfv
      c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co
      vx cv vu cv vv cv cR c2nd cfv c1st cfv co vb cv cR c2nd cfv c2nd cfv
      opreq vb cv cR c2nd cfv c2nd cfv wceq vx cv vu cv vb cv co vx cv vu cv cR
      c2nd cfv c2nd cfv co vx cv vv cv vb cv co vx cv vv cv cR c2nd cfv c2nd
      cfv co cR c2nd cfv c1st cfv vx cv vu cv vb cv cR c2nd cfv c2nd cfv opreq
      vx cv vv cv vb cv cR c2nd cfv c2nd cfv opreq opreq12d eqeq12d ralbidv vb
      cv cR c2nd cfv c2nd cfv wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv vb
      cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy cv vu cv
      vb cv co vb cv co wceq wa vx cv vy cv cR c1st cfv c1st cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn
      vb cv cR c2nd cfv c2nd cfv wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv
      vb cv co vx cv vu cv vb cv co vy cv vu cv vb cv co cR c2nd cfv c1st cfv
      co wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv co
      vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv co
      cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb
      cv co vx cv vy cv vu cv vb cv co vb cv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c2nd cfv co wceq vb cv cR c2nd cfv c2nd cfv wceq
      vx cv vy cv cR c1st cfv c1st cfv co vu cv vb cv co vx cv vy cv cR c1st
      cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vu cv vb cv co vy cv
      vu cv vb cv co cR c2nd cfv c1st cfv co vx cv vu cv cR c2nd cfv c2nd cfv
      co vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co vx cv vy
      cv cR c1st cfv c1st cfv co vu cv vb cv cR c2nd cfv c2nd cfv opreq vb cv
      cR c2nd cfv c2nd cfv wceq vx cv vu cv vb cv co vx cv vu cv cR c2nd cfv
      c2nd cfv co vy cv vu cv vb cv co vy cv vu cv cR c2nd cfv c2nd cfv co cR
      c2nd cfv c1st cfv vx cv vu cv vb cv cR c2nd cfv c2nd cfv opreq vy cv vu
      cv vb cv cR c2nd cfv c2nd cfv opreq opreq12d eqeq12d vb cv cR c2nd cfv
      c2nd cfv wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv co vx cv vy
      cv cR c1st cfv c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu
      cv vb cv co vb cv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c2nd cfv co vx cv vy cv cR c1st cfv c2nd cfv co vu cv vb cv cR c2nd
      cfv c2nd cfv opreq vb cv cR c2nd cfv c2nd cfv wceq vx cv vx cv vy cv vu
      cv vb cv co vy cv vu cv cR c2nd cfv c2nd cfv co vb cv cR c2nd cfv c2nd
      cfv vb cv cR c2nd cfv c2nd cfv wceq id vb cv cR c2nd cfv c2nd cfv wceq vx
      cv eqidd vy cv vu cv vb cv cR c2nd cfv c2nd cfv opreq opreq123d eqeq12d
      anbi12d ralbidv anbi12d ralbidv anbi12d ralbidv 3anbi23d vb cv cR c2nd
      cfv c2nd cfv wceq cR c2nd cfv c1st cfv cabl wcel cA cabl wcel cR c1st cfv
      c1st cfv crn cR c2nd cfv c1st cfv crn cxp cR c2nd cfv c1st cfv crn cR
      c2nd cfv c2nd cfv wf cX cW cxp cW cB wf cR c1st cfv c2nd cfv cgi cfv vu
      cv cR c2nd cfv c2nd cfv co vu cv wceq vx cv vu cv vv cv cR c2nd cfv c1st
      cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv
      vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv
      c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv
      c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv
      co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv
      co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx
      cR c1st cfv c1st cfv crn wral wa vu cR c2nd cfv c1st cfv crn wral cH cgi
      cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB
      co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co
      vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB
      co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral wa vu
      cW wral cR c2nd cfv c1st cfv cabl wcel cA cabl wcel wb vb cv cR c2nd cfv
      c2nd cfv wceq cR c2nd cfv c1st cfv cA cabl cA cR c2nd cfv c1st cfv
      vecval3b.4 eqcomi eleq1i a1i cR c1st cfv c1st cfv crn cR c2nd cfv c1st
      cfv crn cxp cR c2nd cfv c1st cfv crn cR c2nd cfv c2nd cfv wf cX cW cxp cW
      cB wf wb vb cv cR c2nd cfv c2nd cfv wceq cR c2nd cfv c2nd cfv cB wceq cR
      c1st cfv c1st cfv crn cR c2nd cfv c1st cfv crn cxp cX cW cxp wceq cR c2nd
      cfv c1st cfv crn cW wceq cR c1st cfv c1st cfv crn cR c2nd cfv c1st cfv
      crn cxp cR c2nd cfv c1st cfv crn cR c2nd cfv c2nd cfv wf cX cW cxp cW cB
      wf wb cB cR c2nd cfv c2nd cfv vecval3b.5 eqcomi cR c1st cfv c1st cfv crn
      cX cR c2nd cfv c1st cfv crn cW cR c1st cfv c1st cfv crn cG crn cX cR c1st
      cfv c1st cfv cG cG cR c1st cfv c1st cfv vecval3b.2 eqcomi rneqi
      vecval3b.1 eqtr4i cR c2nd cfv c1st cfv crn cA crn cW cR c2nd cfv c1st cfv
      cA cA cR c2nd cfv c1st cfv vecval3b.4 eqcomi rneqi vecval3b.6 eqtr4i
      xpeq12i cR c2nd cfv c1st cfv crn cA crn cW cR c2nd cfv c1st cfv cA cA cR
      c2nd cfv c1st cfv vecval3b.4 eqcomi rneqi vecval3b.6 eqtr4i cR c1st cfv
      c1st cfv crn cR c2nd cfv c1st cfv crn cxp cR c2nd cfv c1st cfv crn cX cW
      cxp cW cR c2nd cfv c2nd cfv cB feq123 mp3an a1i cR c1st cfv c2nd cfv cgi
      cfv vu cv cR c2nd cfv c2nd cfv co vu cv wceq vx cv vu cv vv cv cR c2nd
      cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv
      co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR
      c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn
      wral wa vx cR c1st cfv c1st cfv crn wral wa vu cR c2nd cfv c1st cfv crn
      wral cH cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx
      cv vu cv cB co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co
      vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH
      co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX
      wral wa vu cW wral wb vb cv cR c2nd cfv c2nd cfv wceq cR c1st cfv c2nd
      cfv cgi cfv vu cv cR c2nd cfv c2nd cfv co vu cv wceq vx cv vu cv vv cv cR
      c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd
      cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq
      vv cR c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu
      cv cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu
      cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st
      cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa cH cgi cfv vu cv cB
      co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv
      cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB
      co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv
      vu cv cB co cB co wceq wa vy cX wral wa vx cX wral wa vu cR c2nd cfv c1st
      cfv crn cW vu cv cR c2nd cfv c1st cfv crn wcel vu cv cW wcel cR c1st cfv
      c2nd cfv cgi cfv vu cv cR c2nd cfv c2nd cfv co vu cv wceq vx cv vu cv vv
      cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd
      cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv
      co wceq vv cR c2nd cfv c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv
      co vu cv cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy
      cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv
      cR c2nd cfv c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv
      c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa cH cgi cfv vu cv
      cB co vu cv wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv
      cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB co vx cv vu cv
      cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy
      cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral wa cR c2nd cfv c1st
      cfv crn cW vu cv cR c2nd cfv c1st cfv crn cA crn cW cR c2nd cfv c1st cfv
      cA cA cR c2nd cfv c1st cfv vecval3b.4 eqcomi rneqi vecval3b.6 eqtr4i
      eleq2i cR c1st cfv c2nd cfv cgi cfv vu cv cR c2nd cfv c2nd cfv co vu cv
      wceq cH cgi cfv vu cv cB co vu cv wceq vx cv vu cv vv cv cR c2nd cfv c1st
      cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv
      vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv
      c1st cfv crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv
      c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv
      co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv
      co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx
      cR c1st cfv c1st cfv crn wral vx cv vu cv vv cv cA co cB co vx cv vu cv
      cB co vx cv vv cv cB co cA co wceq vv cW wral vx cv vy cv cG co vu cv cB
      co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv
      cB co vx cv vy cv vu cv cB co cB co wceq wa vy cX wral wa vx cX wral cR
      c1st cfv c2nd cfv cgi cfv vu cv cR c2nd cfv c2nd cfv co cH cgi cfv vu cv
      cB co vu cv cR c1st cfv c2nd cfv cgi cfv vu cv cH cgi cfv vu cv cR c2nd
      cfv c2nd cfv cB cR c1st cfv c2nd cfv cH cgi cH cR c1st cfv c2nd cfv
      vecval3b.3 eqcomi fveq2i vu equid cB cR c2nd cfv c2nd cfv vecval3b.5
      eqcomi opreq123i eqeq1i vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR c2nd
      cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd
      cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv crn
      wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv co vx
      cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv co cR
      c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cv vu cv
      vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cW
      wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA
      co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq
      wa vy cX wral wa vx cR c1st cfv c1st cfv crn cX vx cv cR c1st cfv c1st
      cfv crn wcel vx cv cX wcel vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR
      c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv c1st cfv
      crn wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv
      co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv
      co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv
      cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cv vu cv
      vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cW
      wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA
      co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB co wceq
      wa vy cX wral wa cR c1st cfv c1st cfv crn cX vx cv cR c1st cfv c1st cfv
      crn cG crn cX cR c1st cfv c1st cfv cG cG cR c1st cfv c1st cfv vecval3b.2
      eqcomi rneqi vecval3b.1 eqtr4i eleq2i vx cv vu cv vv cv cR c2nd cfv c1st
      cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv
      vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vv cR c2nd cfv
      c1st cfv crn wral vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv
      vv cv cB co cA co wceq vv cW wral vx cv vy cv cR c1st cfv c1st cfv co vu
      cv cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu
      cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR
      c2nd cfv c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st
      cfv crn wral vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy cv vu cv
      cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB co cB
      co wceq wa vy cX wral vx cv vu cv vv cv cR c2nd cfv c1st cfv co cR c2nd
      cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd
      cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vu cv vv cv cA co cB
      co vx cv vu cv cB co vx cv vv cv cB co cA co wceq vv cR c2nd cfv c1st cfv
      crn cW vv cv cR c2nd cfv c1st cfv crn wcel vv cv cW wcel vx cv vu cv vv
      cv cR c2nd cfv c1st cfv co cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd
      cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv
      co wceq vx cv vu cv vv cv cA co cB co vx cv vu cv cB co vx cv vv cv cB co
      cA co wceq cR c2nd cfv c1st cfv crn cW vv cv cR c2nd cfv c1st cfv crn cA
      crn cW cR c2nd cfv c1st cfv cA cA cR c2nd cfv c1st cfv vecval3b.4 eqcomi
      rneqi vecval3b.6 eqtr4i eleq2i vx cv vu cv vv cv cR c2nd cfv c1st cfv co
      cR c2nd cfv c2nd cfv co vx cv vu cv vv cv cA co cB co vx cv vu cv cR c2nd
      cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv
      co vx cv vu cv cB co vx cv vv cv cB co cA co vx cv vu cv vv cv cR c2nd
      cfv c1st cfv co vx cv vu cv vv cv cA co cR c2nd cfv c2nd cfv cB vx equid
      cR c2nd cfv c1st cfv cA vu cv vv cv cA cR c2nd cfv c1st cfv vecval3b.4
      eqcomi opreqi cB cR c2nd cfv c2nd cfv vecval3b.5 eqcomi opreq123i vx cv
      vu cv cR c2nd cfv c2nd cfv co vx cv vv cv cR c2nd cfv c2nd cfv co vx cv
      vu cv cB co vx cv vv cv cB co cR c2nd cfv c1st cfv cA cR c2nd cfv c2nd
      cfv cB vx cv vu cv cB cR c2nd cfv c2nd cfv vecval3b.5 eqcomi opreqi cR
      c2nd cfv c2nd cfv cB vx cv vv cv cB cR c2nd cfv c2nd cfv vecval3b.5
      eqcomi opreqi cA cR c2nd cfv c1st cfv vecval3b.4 eqcomi opreq123i eqeq12i
      imbi12i ralbii2 vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv
      c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv
      c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv
      co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv
      co cR c2nd cfv c2nd cfv co wceq wa vx cv vy cv cG co vu cv cB co vx cv vu
      cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH co vu cv cB co vx cv
      vy cv vu cv cB co cB co wceq wa vy cR c1st cfv c1st cfv crn cX vy cv cR
      c1st cfv c1st cfv crn wcel vy cv cX wcel vx cv vy cv cR c1st cfv c1st cfv
      co vu cv cR c2nd cfv c2nd cfv co vx cv vu cv cR c2nd cfv c2nd cfv co vy
      cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv vu cv
      cR c2nd cfv c2nd cfv co cR c2nd cfv c2nd cfv co wceq wa vx cv vy cv cG co
      vu cv cB co vx cv vu cv cB co vy cv vu cv cB co cA co wceq vx cv vy cv cH
      co vu cv cB co vx cv vy cv vu cv cB co cB co wceq wa cR c1st cfv c1st cfv
      crn cX vy cv cR c1st cfv c1st cfv crn cG crn cX cR c1st cfv c1st cfv cG
      cG cR c1st cfv c1st cfv vecval3b.2 eqcomi rneqi vecval3b.1 eqtr4i eleq2i
      vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd cfv co vx cv
      vu cv cR c2nd cfv c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c1st cfv co wceq vx cv vy cv cG co vu cv cB co vx cv vu cv cB co vy
      cv vu cv cB co cA co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cR
      c2nd cfv c2nd cfv co vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd
      cfv c2nd cfv co wceq vx cv vy cv cH co vu cv cB co vx cv vy cv vu cv cB
      co cB co wceq vx cv vy cv cR c1st cfv c1st cfv co vu cv cR c2nd cfv c2nd
      cfv co vx cv vy cv cG co vu cv cB co vx cv vu cv cR c2nd cfv c2nd cfv co
      vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c1st cfv co vx cv vu cv
      cB co vy cv vu cv cB co cA co vx cv vy cv cR c1st cfv c1st cfv co vu cv
      vx cv vy cv cG co vu cv cR c2nd cfv c2nd cfv cB cR c1st cfv c1st cfv cG
      vx cv vy cv cG cR c1st cfv c1st cfv vecval3b.2 eqcomi opreqi vu equid cB
      cR c2nd cfv c2nd cfv vecval3b.5 eqcomi opreq123i vx cv vu cv cR c2nd cfv
      c2nd cfv co vy cv vu cv cR c2nd cfv c2nd cfv co vx cv vu cv cB co vy cv
      vu cv cB co cR c2nd cfv c1st cfv cA cR c2nd cfv c2nd cfv cB vx cv vu cv
      cB cR c2nd cfv c2nd cfv vecval3b.5 eqcomi opreqi cR c2nd cfv c2nd cfv cB
      vy cv vu cv cB cR c2nd cfv c2nd cfv vecval3b.5 eqcomi opreqi cA cR c2nd
      cfv c1st cfv vecval3b.4 eqcomi opreq123i eqeq12i vx cv vy cv cR c1st cfv
      c2nd cfv co vu cv cR c2nd cfv c2nd cfv co vx cv vy cv cH co vu cv cB co
      vx cv vy cv vu cv cR c2nd cfv c2nd cfv co cR c2nd cfv c2nd cfv co vx cv
      vy cv vu cv cB co cB co vx cv vy cv cR c1st cfv c2nd cfv co vu cv vx cv
      vy cv cH co vu cv cR c2nd cfv c2nd cfv cB cR c1st cfv c2nd cfv cH vx cv
      vy cv cH cR c1st cfv c2nd cfv vecval3b.3 eqcomi opreqi vu equid cB cR
      c2nd cfv c2nd cfv vecval3b.5 eqcomi opreq123i vx cv vy cv vu cv cR c2nd
      cfv c2nd cfv co vx cv vy cv vu cv cB co cR c2nd cfv c2nd cfv cB vx equid
      cR c2nd cfv c2nd cfv cB vy cv vu cv cB cR c2nd cfv c2nd cfv vecval3b.5
      eqcomi opreqi cB cR c2nd cfv c2nd cfv vecval3b.5 eqcomi opreq123i eqeq12i
      anbi12i imbi12i ralbii2 anbi12i imbi12i ralbii2 anbi12i imbi12i ralbii2
      a1i 3anbi123d bitrd eloi sylbi $.
      $( [20-Sep-2010] $) $( [12-Jul-2010] $)
  $}

  ${
    $d R w x y z $.
    vecax1.1 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    $( 1st "axiom" of a vector space or module. The vector addition
       is an abelian group. $)
    vecax1 $p |- ( R e. Vec -> plus_w e. Abel ) $=
      cR cvec wcel cplw cabl wcel cR c1st cfv c1st cfv crn cplw crn cxp cplw
      crn cR c2nd cfv c2nd cfv wf cR c1st cfv c2nd cfv cgi cfv vw cv cR c2nd
      cfv c2nd cfv co vw cv wceq vx cv vw cv vz cv cplw co cR c2nd cfv c2nd cfv
      co vx cv vw cv cR c2nd cfv c2nd cfv co vx cv vz cv cR c2nd cfv c2nd cfv
      co cplw co wceq vz cplw crn wral vx cv vy cv cR c1st cfv c1st cfv co vw
      cv cR c2nd cfv c2nd cfv co vx cv vw cv cR c2nd cfv c2nd cfv co vy cv vw
      cv cR c2nd cfv c2nd cfv co cplw co wceq vx cv vy cv cR c1st cfv c2nd cfv
      co vw cv cR c2nd cfv c2nd cfv co vx cv vy cv vw cv cR c2nd cfv c2nd cfv
      co cR c2nd cfv c2nd cfv co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx
      cR c1st cfv c1st cfv crn wral wa vw cplw crn wral vx vy vz vw cplw cR
      c2nd cfv c2nd cfv cR cR c1st cfv c1st cfv cR c1st cfv c2nd cfv cplw crn
      cR c1st cfv c1st cfv crn cR c1st cfv c1st cfv crn eqid cR c1st cfv c1st
      cfv eqid cR c1st cfv c2nd cfv eqid vecax1.1 cR c2nd cfv c2nd cfv eqid
      cplw crn eqid vecval3b 3simp1d $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d R w x y z $.
    vecax2.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    vecax2.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax2.6 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    $( 2nd "axiom" of a vector space or module. Domain, codomain and
       functionality of the multiplication of a vector by a scalar. $)
    vecax2 $p |- ( R e. Vec -> dot_w : ( X X. W ) --> W ) $=
      cR cvec wcel cR c2nd cfv c1st cfv cabl wcel cX cW cxp cW cmw wf cR c1st
      cfv c2nd cfv cgi cfv vw cv cmw co vw cv wceq vx cv vw cv vz cv cR c2nd
      cfv c1st cfv co cmw co vx cv vw cv cmw co vx cv vz cv cmw co cR c2nd cfv
      c1st cfv co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vw cv cmw
      co vx cv vw cv cmw co vy cv vw cv cmw co cR c2nd cfv c1st cfv co wceq vx
      cv vy cv cR c1st cfv c2nd cfv co vw cv cmw co vx cv vy cv vw cv cmw co
      cmw co wceq wa vy cX wral wa vx cX wral wa vw cW wral vx vy vz vw cR c2nd
      cfv c1st cfv cmw cR cR c1st cfv c1st cfv cR c1st cfv c2nd cfv cW cX
      vecax2.1 cR c1st cfv c1st cfv eqid cR c1st cfv c2nd cfv eqid cR c2nd cfv
      c1st cfv eqid vecax2.5 vecax2.6 vecval3b 3simp2d $.
      $( [20-Sep-2010] $) $( [14-Sep-2010] $)
  $}

  ${
    $d R u x y z $.
    vecax3.2 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax3.3 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    vecax3.4 $e |- one_t = ( Id ` ( 2nd ` ( 1st ` R ) ) ) $.
    $( 3rd "axiom" of a vector space or module. Multiplication by 1. $)
    vecax3 $p |- ( R e. Vec -> A. u e. W ( one_t dot_w u ) = u ) $=
      cR cvec wcel conet vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv
      c1st cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st
      cfv co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co
      vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv
      vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw
      co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv
      crn wral wa vu cW wral conet vu cv cmw co vu cv wceq vu cW wral cR cvec
      wcel cR c2nd cfv c1st cfv cabl wcel cR c1st cfv c1st cfv crn cW cxp cW
      cmw wf conet vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st
      cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv
      co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv
      vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq
      wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral
      wa vu cW wral cR cvec wcel cR c2nd cfv c1st cfv cabl wcel cR c1st cfv
      c1st cfv crn cW cxp cW cmw wf cR c1st cfv c2nd cfv cgi cfv vu cv cmw co
      vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st cfv co cmw co vx cv vu cv
      cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq vz cW wral vx cv
      vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv
      cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co
      vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cR c1st cfv c1st
      cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu cW wral w3a cR
      c2nd cfv c1st cfv cabl wcel cR c1st cfv c1st cfv crn cW cxp cW cmw wf
      conet vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st cfv co
      cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq
      vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv
      cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa
      vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa
      vu cW wral w3a vx vy vz vu cR c2nd cfv c1st cfv cmw cR cR c1st cfv c1st
      cfv cR c1st cfv c2nd cfv cW cR c1st cfv c1st cfv crn cR c1st cfv c1st cfv
      crn eqid cR c1st cfv c1st cfv eqid cR c1st cfv c2nd cfv eqid cR c2nd cfv
      c1st cfv eqid vecax3.2 vecax3.3 vecval3b conet vu cv cmw co vu cv wceq vx
      cv vu cv vz cv cR c2nd cfv c1st cfv co cmw co vx cv vu cv cmw co vx cv vz
      cv cmw co cR c2nd cfv c1st cfv co wceq vz cW wral vx cv vy cv cR c1st cfv
      c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd
      cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx
      cv vy cv vu cv cmw co cmw co wceq wa vy cR c1st cfv c1st cfv crn wral wa
      vx cR c1st cfv c1st cfv crn wral wa vu cW wral cR c1st cfv c2nd cfv cgi
      cfv vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st cfv co cmw
      co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq vz
      cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw
      co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR c1st
      cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy
      cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral wa vu
      cW wral cR c2nd cfv c1st cfv cabl wcel cR c1st cfv c1st cfv crn cW cxp cW
      cmw wf conet vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st
      cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv
      co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv
      vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv
      cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq
      wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral
      wa cR c1st cfv c2nd cfv cgi cfv vu cv cmw co vu cv wceq vx cv vu cv vz cv
      cR c2nd cfv c1st cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR
      c2nd cfv c1st cfv co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co
      vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv
      co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu
      cv cmw co cmw co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st
      cfv c1st cfv crn wral wa vu cW conet vu cv cmw co vu cv wceq cR c1st cfv
      c2nd cfv cgi cfv vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv
      c1st cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st
      cfv co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co
      vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv
      vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw
      co wceq wa vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv
      crn wral conet vu cv cmw co cR c1st cfv c2nd cfv cgi cfv vu cv cmw co vu
      cv conet cR c1st cfv c2nd cfv cgi cfv vu cv cmw vecax3.4 opreq1i eqeq1i
      anbi1i ralbii 3anbi3i sylibr 3simp3d conet vu cv cmw co vu cv wceq vx cv
      vu cv vz cv cR c2nd cfv c1st cfv co cmw co vx cv vu cv cmw co vx cv vz cv
      cmw co cR c2nd cfv c1st cfv co wceq vz cW wral vx cv vy cv cR c1st cfv
      c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd
      cfv c1st cfv co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx
      cv vy cv vu cv cmw co cmw co wceq wa vy cR c1st cfv c1st cfv crn wral wa
      vx cR c1st cfv c1st cfv crn wral wa conet vu cv cmw co vu cv wceq vu cW
      conet vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st cfv co
      cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq
      vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv
      cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa
      vy cR c1st cfv c1st cfv crn wral wa vx cR c1st cfv c1st cfv crn wral
      pm3.26 r19.20si syl $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)
  $}

  ${
    $d R u v x y $.
    vecax4.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    vecax4.4 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    vecax4.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax4.6 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    $( 4th "axiom" of a vector space or module. Multiplication by a scalar
       distributes over vector addition. $)
    vecax4 $p |- ( R e. Vec ->
          A. u e. W A. x e. X
             A. v e. W
                 ( x dot_w ( u plus_w  v ) ) = ( ( x dot_w u ) plus_w ( x dot_w v ) ) ) $=
      cR cvec wcel cR c1st cfv c2nd cfv cgi cfv vu cv cmw co vu cv wceq vx cv
      vu cv vv cv cplw co cmw co vx cv vu cv cmw co vx cv vv cv cmw co cplw co
      wceq vv cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu
      cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa
      vx cX wral wa vu cW wral vx cv vu cv vv cv cplw co cmw co vx cv vu cv cmw
      co vx cv vv cv cmw co cplw co wceq vv cW wral vx cX wral vu cW wral cR
      cvec wcel cplw cabl wcel cX cW cxp cW cmw wf cR c1st cfv c2nd cfv cgi cfv
      vu cv cmw co vu cv wceq vx cv vu cv vv cv cplw co cmw co vx cv vu cv cmw
      co vx cv vv cv cmw co cplw co wceq vv cW wral vx cv vy cv cR c1st cfv
      c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw co
      wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv
      cmw co cmw co wceq wa vy cX wral wa vx cX wral wa vu cW wral vx vy vv vu
      cplw cmw cR cR c1st cfv c1st cfv cR c1st cfv c2nd cfv cW cX vecax4.1 cR
      c1st cfv c1st cfv eqid cR c1st cfv c2nd cfv eqid vecax4.4 vecax4.5 cW cR
      c2nd cfv c1st cfv crn cplw crn vecax4.6 cR c2nd cfv c1st cfv cplw cplw cR
      c2nd cfv c1st cfv vecax4.4 eqcomi rneqi eqtri vecval3b 3simp3d cR c1st
      cfv c2nd cfv cgi cfv vu cv cmw co vu cv wceq vx cv vu cv vv cv cplw co
      cmw co vx cv vu cv cmw co vx cv vv cv cmw co cplw co wceq vv cW wral vx
      cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu
      cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co
      vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral wa vx cv
      vu cv vv cv cplw co cmw co vx cv vu cv cmw co vx cv vv cv cmw co cplw co
      wceq vv cW wral vx cX wral vu cW vx cv vu cv vv cv cplw co cmw co vx cv
      vu cv cmw co vx cv vv cv cmw co cplw co wceq vv cW wral vx cv vy cv cR
      c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co
      cplw co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv
      vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral vx cv vu cv vv cv
      cplw co cmw co vx cv vu cv cmw co vx cv vv cv cmw co cplw co wceq vv cW
      wral vx cX wral cR c1st cfv c2nd cfv cgi cfv vu cv cmw co vu cv wceq vx
      cv vu cv vv cv cplw co cmw co vx cv vu cv cmw co vx cv vv cv cmw co cplw
      co wceq vv cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv
      vu cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa
      vx cv vu cv vv cv cplw co cmw co vx cv vu cv cmw co vx cv vv cv cmw co
      cplw co wceq vv cW wral vx cX vx cv vu cv vv cv cplw co cmw co vx cv vu
      cv cmw co vx cv vv cv cmw co cplw co wceq vv cW wral vx cv vy cv cR c1st
      cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw
      co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu
      cv cmw co cmw co wceq wa vy cX wral pm3.26 r19.20si adantl r19.20si syl
      $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)
  $}

  ${
    $d R u x y z  $.
    vecax5.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    vecax5.2 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    vecax5.4 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    vecax5.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax5.6 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    $( 5th "axiom" of a vector space or module. Multiplication by a sum of
       scalars. $)
    vecax5 $p |- ( R e. Vec -> A. u e. W A. x e. X  A. y e. X
        ( ( x plus_t y ) dot_w u ) = ( ( x dot_w u ) plus_w ( y dot_w u ) ) ) $=
      cR cvec wcel cR c1st cfv c2nd cfv cgi cfv vu cv cmw co vu cv wceq vx cv
      vu cv vz cv cplw co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cplw co
      wceq vz cW wral vx cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv
      vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw
      co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral wa vu
      cW wral vx cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv vu cv
      cmw co cplw co wceq vy cX wral vx cX wral vu cW wral cR cvec wcel cplw
      cabl wcel cX cW cxp cW cmw wf cR c1st cfv c2nd cfv cgi cfv vu cv cmw co
      vu cv wceq vx cv vu cv vz cv cplw co cmw co vx cv vu cv cmw co vx cv vz
      cv cmw co cplw co wceq vz cW wral vx cv vy cv cpls co vu cv cmw co vx cv
      vu cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa
      vx cX wral wa vu cW wral vx vy vz vu cplw cmw cR cpls cR c1st cfv c2nd
      cfv cW cX cX cR c1st cfv c1st cfv crn cpls crn vecax5.1 cR c1st cfv c1st
      cfv cpls cpls cR c1st cfv c1st cfv vecax5.2 eqcomi rneqi eqtri vecax5.2
      cR c1st cfv c2nd cfv eqid vecax5.4 vecax5.5 cW cR c2nd cfv c1st cfv crn
      cplw crn vecax5.6 cR c2nd cfv c1st cfv cplw cplw cR c2nd cfv c1st cfv
      vecax5.4 eqcomi rneqi eqtri vecval3b 3simp3d cR c1st cfv c2nd cfv cgi cfv
      vu cv cmw co vu cv wceq vx cv vu cv vz cv cplw co cmw co vx cv vu cv cmw
      co vx cv vz cv cmw co cplw co wceq vz cW wral vx cv vy cv cpls co vu cv
      cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR
      c1st cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa
      vy cX wral wa vx cX wral wa vx cv vy cv cpls co vu cv cmw co vx cv vu cv
      cmw co vy cv vu cv cmw co cplw co wceq vy cX wral vx cX wral vu cW vx cv
      vu cv vz cv cplw co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cplw co
      wceq vz cW wral vx cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv
      vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw
      co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral vx cv
      vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw co
      wceq vy cX wral vx cX wral cR c1st cfv c2nd cfv cgi cfv vu cv cmw co vu
      cv wceq vx cv vu cv vz cv cplw co cmw co vx cv vu cv cmw co vx cv vz cv
      cmw co cplw co wceq vz cW wral vx cv vy cv cpls co vu cv cmw co vx cv vu
      cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa
      vx cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co
      cplw co wceq vy cX wral vx cX vx cv vy cv cpls co vu cv cmw co vx cv vu
      cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd
      cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral vx
      cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw
      co wceq vy cX wral vx cv vu cv vz cv cplw co cmw co vx cv vu cv cmw co vx
      cv vz cv cmw co cplw co wceq vz cW wral vx cv vy cv cpls co vu cv cmw co
      vx cv vu cv cmw co vy cv vu cv cmw co cplw co wceq vx cv vy cv cR c1st
      cfv c2nd cfv co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vx
      cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw
      co wceq vy cX vx cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv
      vu cv cmw co cplw co wceq vx cv vy cv cR c1st cfv c2nd cfv co vu cv cmw
      co vx cv vy cv vu cv cmw co cmw co wceq pm3.26 r19.20si adantl r19.20si
      adantl r19.20si syl $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)
  $}

  ${
    $d R u x y z $.
    vecax6.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    vecax6.3 $e |- dot_t = ( 2nd ` ( 1st ` R ) ) $.
    vecax6.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax6.6 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    $( 6th "axiom" of a vector space or module. Relation between scalar
       multiplication and vector multiplication. $)
    vecax6 $p |- ( R e. Vec -> A. u e. W A. x e. X A. y e. X
       ( ( x dot_t y ) dot_w u ) = ( x dot_w ( y dot_w u ) ) ) $=
      cR cvec wcel cmus cgi cfv vu cv cmw co vu cv wceq vx cv vu cv vz cv cR
      c2nd cfv c1st cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd
      cfv c1st cfv co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv
      cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq
      vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa
      vy cX wral wa vx cX wral wa vu cW wral vx cv vy cv cmus co vu cv cmw co
      vx cv vy cv vu cv cmw co cmw co wceq vy cX wral vx cX wral vu cW wral cR
      cvec wcel cR c2nd cfv c1st cfv cabl wcel cX cW cxp cW cmw wf cmus cgi cfv
      vu cv cmw co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st cfv co cmw co
      vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq vz cW
      wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co
      vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cmus co vu cv
      cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral
      wa vu cW wral vx vy vz vu cR c2nd cfv c1st cfv cmw cR cR c1st cfv c1st
      cfv cmus cW cX vecax6.1 cR c1st cfv c1st cfv eqid vecax6.3 cR c2nd cfv
      c1st cfv eqid vecax6.5 vecax6.6 vecval3b 3simp3d cmus cgi cfv vu cv cmw
      co vu cv wceq vx cv vu cv vz cv cR c2nd cfv c1st cfv co cmw co vx cv vu
      cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq vz cW wral vx
      cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu
      cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cmus co vu cv cmw co
      vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral wa vx cv
      vy cv cmus co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq vy cX
      wral vx cX wral vu cW vx cv vu cv vz cv cR c2nd cfv c1st cfv co cmw co vx
      cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq vz cW
      wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co
      vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cmus co vu cv
      cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vy cX wral wa vx cX wral
      vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu cv cmw co cmw co wceq vy
      cX wral vx cX wral cmus cgi cfv vu cv cmw co vu cv wceq vx cv vu cv vz cv
      cR c2nd cfv c1st cfv co cmw co vx cv vu cv cmw co vx cv vz cv cmw co cR
      c2nd cfv c1st cfv co wceq vz cW wral vx cv vy cv cR c1st cfv c1st cfv co
      vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv
      co wceq vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu cv cmw co cmw co
      wceq wa vy cX wral wa vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu cv
      cmw co cmw co wceq vy cX wral vx cX vx cv vy cv cR c1st cfv c1st cfv co
      vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR c2nd cfv c1st cfv
      co wceq vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu cv cmw co cmw co
      wceq wa vy cX wral vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu cv cmw
      co cmw co wceq vy cX wral vx cv vu cv vz cv cR c2nd cfv c1st cfv co cmw
      co vx cv vu cv cmw co vx cv vz cv cmw co cR c2nd cfv c1st cfv co wceq vz
      cW wral vx cv vy cv cR c1st cfv c1st cfv co vu cv cmw co vx cv vu cv cmw
      co vy cv vu cv cmw co cR c2nd cfv c1st cfv co wceq vx cv vy cv cmus co vu
      cv cmw co vx cv vy cv vu cv cmw co cmw co wceq wa vx cv vy cv cmus co vu
      cv cmw co vx cv vy cv vu cv cmw co cmw co wceq vy cX vx cv vy cv cR c1st
      cfv c1st cfv co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cR
      c2nd cfv c1st cfv co wceq vx cv vy cv cmus co vu cv cmw co vx cv vy cv vu
      cv cmw co cmw co wceq pm3.27 r19.20si adantl r19.20si adantl r19.20si syl
      $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)
  $}

  ${
    $d plus_t u x y $. $d plus_w u x y $. $d dot_w u x y $. $d A x y $.
    $d B y $. $d R u x y $. $d U u x y $. $d W u $.
    $d X u x y $.
    vecax5b.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    vecax5b.2 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    vecax5b.4 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.

    vecax5b.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax5b.6 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    $( Multiplication by a sum of scalars. $)
    vecax5b $p |- ( ( R e. Vec /\ ( U e. W /\ A e. X /\ B e. X ) ) ->
        ( ( A plus_t B ) dot_w U ) = ( ( A dot_w U ) plus_w ( B dot_w U ) ) ) $=
      cR cvec wcel vx cv vy cv cpls co vu cv cmw co vx cv vu cv cmw co vy cv vu
      cv cmw co cplw co wceq vy cX wral vx cX wral vu cW wral cU cW wcel cA cX
      wcel cB cX wcel w3a cA cB cpls co cU cmw co cA cU cmw co cB cU cmw co
      cplw co wceq vx vy vu cR cW cX cpls cplw cmw vecax5b.1 vecax5b.2
      vecax5b.4 vecax5b.5 vecax5b.6 vecax5 vx cv vy cv cpls co vu cv cmw co vx
      cv vu cv cmw co vy cv vu cv cmw co cplw co wceq cA cB cpls co cU cmw co
      cA cU cmw co cB cU cmw co cplw co wceq vx cv vy cv cpls co cU cmw co vx
      cv cU cmw co vy cv cU cmw co cplw co wceq cA vy cv cpls co cU cmw co cA
      cU cmw co vy cv cU cmw co cplw co wceq vu vx vy cU cA cB cW cX cX vu cv
      cU wceq vx cv vy cv cpls co vu cv cmw co vx cv vy cv cpls co cU cmw co vx
      cv vu cv cmw co vy cv vu cv cmw co cplw co vx cv cU cmw co vy cv cU cmw
      co cplw co vu cv cU vx cv vy cv cpls co cmw opreq2 vu cv cU wceq vx cv vu
      cv cmw co vx cv cU cmw co vy cv vu cv cmw co vy cv cU cmw co cplw vu cv
      cU vx cv cmw opreq2 vu cv cU vy cv cmw opreq2 opreq12d eqeq12d vx cv cA
      wceq vx cv vy cv cpls co cU cmw co cA vy cv cpls co cU cmw co vx cv cU
      cmw co vy cv cU cmw co cplw co cA cU cmw co vy cv cU cmw co cplw co vx cv
      cA wceq vx cv vy cv cpls co cA vy cv cpls co cU cmw vx cv cA vy cv cpls
      opreq1 opreq1d vx cv cA wceq vx cv cU cmw co cA cU cmw co vy cv cU cmw co
      cplw vx cv cA cU cmw opreq1 opreq1d eqeq12d vy cv cB wceq cA vy cv cpls
      co cU cmw co cA cB cpls co cU cmw co cA cU cmw co vy cv cU cmw co cplw co
      cA cU cmw co cB cU cmw co cplw co vy cv cB wceq cA vy cv cpls co cA cB
      cpls co cU cmw vy cv cB cA cpls opreq2 opreq1d vy cv cB wceq vy cv cU cmw
      co cB cU cmw co cA cU cmw co cplw vy cv cB cU cmw opreq1 opreq2d eqeq12d
      rcla43v mpan9 $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)
  $}

  ${
    claddinvvec.1 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    claddinvvec.2 $e |- tild_w = ( inv ` ( 1st ` ( 2nd ` R ) ) ) $.
    $( Closure of the additive inverse of a vector. $)
    claddinvvec $p |- ( ( R e. Vec
        /\  U e. W )
          -> ( tild_w ` U ) e. W ) $=
      cR cvec wcel cU cW wcel cU cnegw cfv cW wcel cR cvec wcel cR c2nd cfv
      c1st cfv cabl wcel cU cW wcel cU cnegw cfv cW wcel wi cR cR c2nd cfv c1st
      cfv cR c2nd cfv c1st cfv eqid vecax1 cR c2nd cfv c1st cfv cabl wcel cR
      c2nd cfv c1st cfv cgr wcel cU cW wcel cU cnegw cfv cW wcel wi cR c2nd cfv
      c1st cfv ablgrp cR c2nd cfv c1st cfv cgr wcel cU cW wcel cU cnegw cfv cW
      wcel cU cR c2nd cfv c1st cfv cnegw cW claddinvvec.1 claddinvvec.2
      grpinvcl ex syl syl imp $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)

    $( Double inverse law for vector additive inverse. $)
    vec2inv $p |- ( ( R e. Vec /\ U e. W ) -> ( tild_w ` ( tild_w ` U ) ) = U ) $=
      cR cvec wcel cU cW wcel cU cnegw cfv cnegw cfv cU wceq cR cvec wcel cR
      c2nd cfv c1st cfv cabl wcel cR c2nd cfv c1st cfv cgr wcel cU cW wcel cU
      cnegw cfv cnegw cfv cU wceq wi cR cR c2nd cfv c1st cfv cR c2nd cfv c1st
      cfv eqid vecax1 cR c2nd cfv c1st cfv ablgrp cR c2nd cfv c1st cfv cgr wcel
      cU cW wcel cU cnegw cfv cnegw cfv cU wceq cU cR c2nd cfv c1st cfv cnegw
      cW claddinvvec.1 claddinvvec.2 grp2inv ex 3syl imp $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)
  $}


  ${
    sum2vv.1 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    sum2vv.2 $e |- W = ran plus_w $.
    $( The sum of two vectors is a vector. $)
    sum2vv $p |- ( ( R e. Vec /\ V1 e. W /\ V2 e. W )
      -> ( V1 plus_w V2 ) e. W ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV1 cV2 cplw co cW wcel cR cvec wcel
      cplw cabl wcel cplw cgr wcel cV1 cW wcel cV2 cW wcel cV1 cV2 cplw co cW
      wcel wi wi cR cplw sum2vv.1 vecax1 cplw ablgrp cplw cgr wcel cV1 cW wcel
      cV2 cW wcel cV1 cV2 cplw co cW wcel cV1 cV2 cplw cW sum2vv.2 grpcl 3exp
      3syl 3imp $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)

    ${
      addnull1.1 $e |- zero_w = ( Id ` plus_w ) $.
      $( Addition of the null vector. $)
      addnull1 $p |- ( ( R e. Vec /\ U e. W )
        -> ( U plus_w zero_w ) = U ) $=
        cplw cgr wcel cU cW wcel cU czerw cplw co cU wceq cR cvec wcel cU czerw
        cplw cW sum2vv.2 addnull1.1 grprid cR cvec wcel cplw cabl wcel cplw cgr
        wcel cR cplw sum2vv.1 vecax1 cplw ablgrp syl sylan $.
        $( [20-Sep-2010] $) $( [13-Sep-2010] $)


      $( Addition of the null vector. $)
      addnull2 $p |- ( ( R e. Vec /\ U e. W )
        -> ( zero_w plus_w U ) = U ) $=
        cR cvec wcel cU cW wcel czerw cU cplw co cU wceq cR cvec wcel cplw cabl
        wcel cplw cgr wcel cU cW wcel czerw cU cplw co cU wceq wi cR cplw
        sum2vv.1 vecax1 cplw ablgrp cplw cgr wcel cU cW wcel czerw cU cplw co
        cU wceq cU czerw cplw cW sum2vv.2 addnull1.1 grplid ex 3syl imp $.
        $( [20-Sep-2010] $) $( [13-Sep-2010] $)
    $}


    $( The addition of vectors is associative. $)
    addvecass $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) )
       -> ( V1 plus_w ( V2 plus_w V3 ) ) = ( ( V1 plus_w V2 ) plus_w V3 ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV2 cV3 cplw co
      cplw co cV1 cV2 cplw co cV3 cplw co wceq cR cvec wcel cplw cabl wcel cplw
      cgr wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV2 cV3 cplw co cplw
      co cV1 cV2 cplw co cV3 cplw co wceq wi cR cplw sum2vv.1 vecax1 cplw
      ablgrp cplw cgr wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV2 cV3
      cplw co cplw co cV1 cV2 cplw co cV3 cplw co wceq cplw cgr wcel cV1 cW
      wcel cV2 cW wcel cV3 cW wcel w3a wa cV1 cV2 cplw co cV3 cplw co cV1 cV2
      cV3 cplw co cplw co cV1 cV2 cV3 cplw cW sum2vv.2 grpass eqcomd ex 3syl
      imp $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)


    $( The addition of vectors is associative. $)
    addvecom $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
       -> ( V1 plus_w V2 ) = ( V2 plus_w V1 ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel wa cV1 cV2 cplw co cV2 cV1 cplw co
      wceq cR cvec wcel cplw cabl wcel cV1 cW wcel cV2 cW wcel wa cV1 cV2 cplw
      co cV2 cV1 cplw co wceq wi cR cplw sum2vv.1 vecax1 cplw cabl wcel cV1 cW
      wcel cV2 cW wcel cV1 cV2 cplw co cV2 cV1 cplw co wceq cV1 cV2 cplw cW
      sum2vv.2 ablcom 3expib syl imp $.
      $( [20-Sep-2010] $) $( [13-Sep-2010] $)

    ${
      invaddvec.2 $e |- tild_w = ( inv ` plus_w ) $.
      $( Additive inverse of a sum of vectors. $)
      invaddvec $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
         -> ( tild_w ` ( V1 plus_w V2 ) ) = ( ( tild_w ` V1 ) plus_w ( tild_w ` V2 ) ) ) $=
        cR cvec wcel cV1 cW wcel cV2 cW wcel wa wa cV1 cV2 cplw co cnegw cfv
        cV2 cnegw cfv cV1 cnegw cfv cplw co cV1 cnegw cfv cV2 cnegw cfv cplw co
        cR cvec wcel cV1 cW wcel cV2 cW wcel wa cV1 cV2 cplw co cnegw cfv cV2
        cnegw cfv cV1 cnegw cfv cplw co wceq cR cvec wcel cplw cabl wcel cplw
        cgr wcel cV1 cW wcel cV2 cW wcel wa cV1 cV2 cplw co cnegw cfv cV2 cnegw
        cfv cV1 cnegw cfv cplw co wceq wi cR cplw sum2vv.1 vecax1 cplw ablgrp
        cplw cgr wcel cV1 cW wcel cV2 cW wcel cV1 cV2 cplw co cnegw cfv cV2
        cnegw cfv cV1 cnegw cfv cplw co wceq cV1 cV2 cplw cnegw cW sum2vv.2
        invaddvec.2 grpinvop 3expib 3syl imp cR cvec wcel cV1 cW wcel cV2 cW
        wcel wa cV2 cnegw cfv cW wcel cV1 cnegw cfv cW wcel wa cV2 cnegw cfv
        cV1 cnegw cfv cplw co cV1 cnegw cfv cV2 cnegw cfv cplw co wceq cR cvec
        wcel cV1 cW wcel cV2 cW wcel wa wa cV1 cnegw cfv cW wcel cV2 cnegw cfv
        cW wcel cR cvec wcel cV1 cW wcel cV2 cW wcel wa cV1 cnegw cfv cW wcel
        cV2 cnegw cfv cW wcel wa cR cvec wcel cV1 cW wcel cV1 cnegw cfv cW wcel
        cV2 cW wcel cV2 cnegw cfv cW wcel cR cvec wcel cV1 cW wcel cV1 cnegw
        cfv cW wcel cR cV1 cW cnegw cW cplw crn cR c2nd cfv c1st cfv crn
        sum2vv.2 cplw cR c2nd cfv c1st cfv sum2vv.1 rneqi eqtri cnegw cplw cgn
        cfv cR c2nd cfv c1st cfv cgn cfv invaddvec.2 cplw cR c2nd cfv c1st cfv
        cgn sum2vv.1 fveq2i eqtri claddinvvec ex cR cvec wcel cV2 cW wcel cV2
        cnegw cfv cW wcel cR cV2 cW cnegw cW cplw crn cR c2nd cfv c1st cfv crn
        sum2vv.2 cplw cR c2nd cfv c1st cfv sum2vv.1 rneqi eqtri cnegw cplw cgn
        cfv cR c2nd cfv c1st cfv cgn cfv invaddvec.2 cplw cR c2nd cfv c1st cfv
        cgn sum2vv.1 fveq2i eqtri claddinvvec ex anim12d imp ancomd cR cW cV2
        cnegw cfv cV1 cnegw cfv cplw sum2vv.1 sum2vv.2 addvecom syldan eqtrd $.
        $( [20-Sep-2010] $) $( [13-Sep-2010] $)
    $}
  $}

  ${
    prodvs.1 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    prodvs.2 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    prodvs.3 $e |- W = ran plus_w $.
    prodvs.4 $e |- X = ran plus_t $.
    prodvs.5 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    $( The product of a vector by a scalar is a vector. $)
    prodvs $p |- ( ( R e. Vec /\ A e. X /\ U e. W )
      -> ( A dot_w U ) e. W ) $=
      cX cW cxp cW cmw wf cA cX wcel cU cW wcel cA cU cmw co cW wcel cR cvec
      wcel cA cU cW cX cW cmw foprrn cR cW cX cmw cX cpls crn cR c1st cfv c1st
      cfv crn prodvs.4 cpls cR c1st cfv c1st cfv prodvs.5 rneqi eqtri prodvs.2
      cW cplw crn cR c2nd cfv c1st cfv crn prodvs.3 cplw cR c2nd cfv c1st cfv
      prodvs.1 rneqi eqtri vecax2 syl3an1 $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}

  ${
    vecsrcan.1 $e |- minus_w = ( /g ` plus_w ) $.
    vecsrcan.2 $e |- W = ran plus_w $.
    vecsrcan.3 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    $( Right cancellation law for vector substraction. $)
    vecsrcan $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V1 minus_w V3 ) = ( V2 minus_w V3 ) <-> V1 = V2 ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV3 cminw co cV2
      cV3 cminw co wceq cV1 cV2 wceq wb cR cvec wcel cplw cabl wcel cplw cgr
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV3 cminw co cV2 cV3
      cminw co wceq cV1 cV2 wceq wb wi cR cplw vecsrcan.3 vecax1 cplw ablgrp
      cplw cgr wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV3 cminw co
      cV2 cV3 cminw co wceq cV1 cV2 wceq wb cV1 cV2 cV3 cminw cplw cW
      vecsrcan.2 vecsrcan.1 grpdrcan ex 3syl imp $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)


    $( Left cancellation law for vector substraction. $)
    vecslcan $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V3 minus_w V1 ) = ( V3 minus_w V2 ) <-> V1 = V2 ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cV1 cminw co cV3
      cV2 cminw co wceq cV1 cV2 wceq wb cR cvec wcel cplw cabl wcel cplw cgr
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cV1 cminw co cV3 cV2
      cminw co wceq cV1 cV2 wceq wb wi cR cplw vecsrcan.3 vecax1 cplw ablgrp
      cplw cgr wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cV1 cminw co
      cV3 cV2 cminw co wceq cV1 cV2 wceq wb cV1 cV2 cV3 cminw cplw cW
      vecsrcan.2 vecsrcan.1 grpdlcan ex 3syl imp $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)

  $}


  ${
    vwit.1 $e |- zero_w = ( Id ` plus_w ) $.
    vwit.2 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    vwit.3 $e |- minus_w = ( /g ` plus_w ) $.
    vwit.4 $e |- W = ran plus_w $.
    $( A vector minus itself equals zero. $)
    vwit $p |- ( ( R e. Vec /\ U e. W ) -> ( U minus_w U ) = zero_w ) $=
      cplw cgr wcel cU cW wcel cU cU cminw co czerw wceq cR cvec wcel cU cminw
      czerw cplw cW vwit.4 vwit.3 vwit.1 grpdivid cR cvec wcel cplw cabl wcel
      cplw cgr wcel cR cplw vwit.2 vecax1 cplw ablgrp syl sylan $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)

    ${
      vwit.5 $e |- tild_w = ( inv ` plus_w ) $.
      $( Definition of the substraction of two vectors. $)
      sub2vec $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
        -> ( V1 minus_w V2 ) = ( V1 plus_w ( tild_w ` V2 ) ) ) $=
        cplw cgr wcel cV1 cW wcel cV2 cW wcel cV1 cV2 cminw co cV1 cV2 cnegw
        cfv cplw co wceq cR cvec wcel cV1 cW wcel cV2 cW wcel wa wa cV1 cV2
        cminw cplw cnegw cW vwit.4 vwit.5 vwit.3 grpdivval cR cvec wcel cplw
        cgr wcel cV1 cW wcel cV2 cW wcel wa cR cvec wcel cplw cabl wcel cplw
        cgr wcel cR cplw vwit.2 vecax1 cplw ablgrp syl adantr cR cvec wcel cV1
        cW wcel cV2 cW wcel simprl cR cvec wcel cV1 cW wcel cV2 cW wcel simprr
        syl3anc $.
        $( [20-Sep-2010] $) $( [12-Sep-2010] $)
    $}

    $( Moving a vector from the right member of an equation into the
       left member. $)
    mvecrtol $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
         -> ( V1 = V2 <-> ( V1 minus_w V2 ) = zero_w ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel wa wa cV1 cV2 cminw co cV2 cV2 cminw
      co wceq cV1 cV2 wceq cV1 cV2 cminw co czerw wceq cplw cgr wcel cV1 cW
      wcel cV2 cW wcel cV2 cW wcel w3a cV1 cV2 cminw co cV2 cV2 cminw co wceq
      cV1 cV2 wceq wb cR cvec wcel cV1 cW wcel cV2 cW wcel wa wa cV1 cV2 cV2
      cminw cplw cW vwit.4 vwit.3 grpdrcan cR cvec wcel cplw cgr wcel cV1 cW
      wcel cV2 cW wcel wa cR cvec wcel cplw cabl wcel cplw cgr wcel cR cplw
      vwit.2 vecax1 cplw ablgrp syl adantr cR cvec wcel cV1 cW wcel cV2 cW wcel
      wa wa cV1 cW wcel cV2 cW wcel cV2 cW wcel cR cvec wcel cV1 cW wcel cV2 cW
      wcel simprl cR cvec wcel cV1 cW wcel cV2 cW wcel simprr cR cvec wcel cV1
      cW wcel cV2 cW wcel simprr 3jca sylanc cR cvec wcel cV1 cW wcel cV2 cW
      wcel wa wa cV2 cV2 cminw co czerw cV1 cV2 cminw co cR cvec wcel cV2 cW
      wcel cV2 cV2 cminw co czerw wceq cV1 cW wcel cR cV2 cW cplw cminw czerw
      vwit.1 vwit.2 vwit.3 vwit.4 vwit adantrl eqeq2d bitr3d $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)


    $( Double substraction of vectors. $)
    dblsubvec $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) )
         -> ( ( V1 minus_w V2 ) minus_w V3 ) = ( V1 minus_w ( V2 plus_w V3 ) ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV1 cV2 cminw co
      cV3 cminw co cV1 cV2 cplw cgn cfv cfv cplw co cV3 cminw co cV1 cV2 cplw
      cgn cfv cfv cplw co cV3 cplw cgn cfv cfv cplw co cV1 cV2 cV3 cplw co
      cminw co cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV1 cV2
      cminw co cV1 cV2 cplw cgn cfv cfv cplw co cV3 cminw cR cvec wcel cV1 cW
      wcel cV2 cW wcel cV1 cV2 cminw co cV1 cV2 cplw cgn cfv cfv cplw co wceq
      cV3 cW wcel cR cW cV1 cV2 cplw cminw czerw cplw cgn cfv vwit.1 vwit.2
      vwit.3 vwit.4 cplw cgn cfv eqid sub2vec 3adantr3 opreq1d cR cvec wcel cV1
      cV2 cplw cgn cfv cfv cplw co cW wcel cV3 cW wcel cV1 cV2 cplw cgn cfv cfv
      cplw co cV3 cminw co cV1 cV2 cplw cgn cfv cfv cplw co cV3 cplw cgn cfv
      cfv cplw co wceq cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a pm3.26 cR cvec wcel
      cV1 cW wcel cV2 cplw cgn cfv cfv cW wcel cV1 cV2 cplw cgn cfv cfv cplw co
      cW wcel cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cR cW cV1
      cV2 cplw cgn cfv cfv cplw vwit.2 vwit.4 sum2vv cR cvec wcel cV1 cW wcel
      cV2 cW wcel cV3 cW wcel w3a pm3.26 cR cvec wcel cV1 cW wcel cV2 cW wcel
      cV3 cW wcel 3simpr1 cR cvec wcel cV1 cW wcel cV2 cW wcel cV2 cplw cgn cfv
      cfv cW wcel cV3 cW wcel cR cV2 cW cplw cgn cfv cW cplw crn cR c2nd cfv
      c1st cfv crn vwit.4 cplw cR c2nd cfv c1st cfv vwit.2 rneqi eqtri cplw cR
      c2nd cfv c1st cfv cgn vwit.2 fveq2i claddinvvec 3ad2antr2 syl3anc cR cvec
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel 3simpr3 cR cW cV1 cV2 cplw cgn
      cfv cfv cplw co cV3 cplw cminw czerw cplw cgn cfv vwit.1 vwit.2 vwit.3
      vwit.4 cplw cgn cfv eqid sub2vec sylan32c cR cvec wcel cV1 cW wcel cV2 cW
      wcel cV3 cW wcel w3a wa cV1 cV2 cplw cgn cfv cfv cV3 cplw cgn cfv cfv
      cplw co cplw co cV1 cV2 cV3 cplw co cplw cgn cfv cfv cplw co cV1 cV2 cplw
      cgn cfv cfv cplw co cV3 cplw cgn cfv cfv cplw co cV1 cV2 cV3 cplw co
      cminw co cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV2 cplw
      cgn cfv cfv cV3 cplw cgn cfv cfv cplw co cV2 cV3 cplw co cplw cgn cfv cfv
      cV1 cplw cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV2 cV3
      cplw co cplw cgn cfv cfv cV2 cplw cgn cfv cfv cV3 cplw cgn cfv cfv cplw
      co cR cvec wcel cV2 cW wcel cV3 cW wcel cV2 cV3 cplw co cplw cgn cfv cfv
      cV2 cplw cgn cfv cfv cV3 cplw cgn cfv cfv cplw co wceq cV1 cW wcel cR cW
      cV2 cV3 cplw cplw cgn cfv vwit.2 vwit.4 cplw cgn cfv eqid invaddvec
      3adantr1 eqcomd opreq2d cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel
      w3a cV1 cW wcel cV2 cplw cgn cfv cfv cW wcel cV3 cplw cgn cfv cfv cW wcel
      w3a cV1 cV2 cplw cgn cfv cfv cplw co cV3 cplw cgn cfv cfv cplw co cV1 cV2
      cplw cgn cfv cfv cV3 cplw cgn cfv cfv cplw co cplw co wceq cR cvec wcel
      cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV1 cW wcel cV2 cplw cgn cfv
      cfv cW wcel cV3 cplw cgn cfv cfv cW wcel cR cvec wcel cV1 cW wcel cV2 cW
      wcel cV3 cW wcel 3simpr1 cR cvec wcel cV1 cW wcel cV2 cW wcel cV2 cplw
      cgn cfv cfv cW wcel cV3 cW wcel cR cV2 cW cplw cgn cfv cW cplw crn cR
      c2nd cfv c1st cfv crn vwit.4 cplw cR c2nd cfv c1st cfv vwit.2 rneqi eqtri
      cplw cR c2nd cfv c1st cfv cgn vwit.2 fveq2i claddinvvec 3ad2antr2 cR cvec
      wcel cV1 cW wcel cV3 cW wcel cV3 cplw cgn cfv cfv cW wcel cV2 cW wcel cR
      cV3 cW cplw cgn cfv cW cplw crn cR c2nd cfv c1st cfv crn vwit.4 cplw cR
      c2nd cfv c1st cfv vwit.2 rneqi eqtri cplw cR c2nd cfv c1st cfv cgn vwit.2
      fveq2i claddinvvec 3ad2antr3 3jca cR cvec wcel cV1 cW wcel cV2 cplw cgn
      cfv cfv cW wcel cV3 cplw cgn cfv cfv cW wcel w3a wa cV1 cV2 cplw cgn cfv
      cfv cV3 cplw cgn cfv cfv cplw co cplw co cV1 cV2 cplw cgn cfv cfv cplw co
      cV3 cplw cgn cfv cfv cplw co cR cW cV1 cV2 cplw cgn cfv cfv cV3 cplw cgn
      cfv cfv cplw vwit.2 vwit.4 addvecass eqcomd syldan cR cvec wcel cV1 cW
      wcel cV2 cV3 cplw co cW wcel cV1 cV2 cV3 cplw co cminw co cV1 cV2 cV3
      cplw co cplw cgn cfv cfv cplw co wceq cR cvec wcel cV1 cW wcel cV2 cW
      wcel cV3 cW wcel w3a wa cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel
      w3a pm3.26 cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel 3simpr1 cR
      cvec wcel cV2 cW wcel cV3 cW wcel cV2 cV3 cplw co cW wcel cV1 cW wcel cR
      cW cV2 cV3 cplw vwit.2 vwit.4 sum2vv 3adant3r1 cR cW cV1 cV2 cV3 cplw co
      cplw cminw czerw cplw cgn cfv vwit.1 vwit.2 vwit.3 vwit.4 cplw cgn cfv
      eqid sub2vec sylan32c 3eqtr4d 3eqtrd $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)

  ${
    vecrcan.1 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    vecrcan.2 $e |- W = ran plus_w $.
    $( Right cancellation law for vector addition. $)
    vecrcan $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V1 plus_w V3 ) = ( V2 plus_w V3 ) <-> V1 = V2 ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV3 cplw co cV2
      cV3 cplw co wceq cV1 cV2 wceq wb cR cvec wcel cplw cabl wcel cplw cgr
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV3 cplw co cV2 cV3 cplw
      co wceq cV1 cV2 wceq wb wi cR cplw vwit.2 vecax1 cplw ablgrp cplw cgr
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV1 cV3 cplw co cV2 cV3 cplw
      co wceq cV1 cV2 wceq wb cV1 cV2 cV3 cplw cW vwit.4 grprcan ex 3syl imp $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)


    $( Left cancellation law for vector addition. $)
    veclcan $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V3 plus_w V1 ) = ( V3 plus_w V2 ) <-> V1 = V2 ) ) $=
      cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cV1 cplw co cV3
      cV2 cplw co wceq cV1 cV2 wceq wb cR cvec wcel cplw cabl wcel cplw cgr
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cV1 cplw co cV3 cV2 cplw
      co wceq cV1 cV2 wceq wb wi cR cplw vwit.2 vecax1 cplw ablgrp cplw cgr
      wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cV1 cplw co cV3 cV2 cplw
      co wceq cV1 cV2 wceq wb cV1 cV2 cV3 cplw cW vwit.4 grplcan ex 3syl imp $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}


  $( Moving a vector from the right member of an equation into the
     left member. $)
  mvecrtol2 $p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) )
         -> ( V1 = ( V2 plus_w V3 ) <-> ( V1 minus_w V2 ) = V3 ) ) $=
    cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV1 cV2 cminw co
    cV2 cV3 cplw co cV2 cminw co wceq cV1 cV2 cV3 cplw co wceq cV1 cV2 cminw co
    cV3 wceq cplw cgr wcel cV1 cW wcel cV2 cV3 cplw co cW wcel cV2 cW wcel w3a
    cV1 cV2 cminw co cV2 cV3 cplw co cV2 cminw co wceq cV1 cV2 cV3 cplw co wceq
    wb cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV1 cV2 cV3 cplw
    co cV2 cminw cplw cW vwit.4 vwit.3 grpdrcan cR cvec wcel cplw cgr wcel cV1
    cW wcel cV2 cW wcel cV3 cW wcel w3a cR cvec wcel cplw cabl wcel cplw cgr
    wcel cR cplw vwit.2 vecax1 cplw ablgrp syl adantr cR cvec wcel cV1 cW wcel
    cV2 cW wcel cV3 cW wcel w3a wa cV1 cW wcel cV2 cV3 cplw co cW wcel cV2 cW
    wcel cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel 3simpr1 cR cvec wcel
    cV2 cW wcel cV3 cW wcel cV2 cV3 cplw co cW wcel cV1 cW wcel cR cW cV2 cV3
    cplw vwit.2 vwit.4 sum2vv 3adant3r1 cR cvec wcel cV1 cW wcel cV2 cW wcel
    cV3 cW wcel 3simpr2 3jca sylanc cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW
    wcel w3a wa cV2 cV3 cplw co cV2 cminw co cV3 cV1 cV2 cminw co cR cvec wcel
    cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV2 cV3 cplw co cV2 cminw co cV3
    cV2 cplw co cV2 cminw co cV3 cV2 cV2 cminw co cplw co cV3 cR cvec wcel cV1
    cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV2 cV3 cplw co cV3 cV2 cplw co cV2
    cminw cR cvec wcel cV2 cW wcel cV3 cW wcel cV2 cV3 cplw co cV3 cV2 cplw co
    wceq cV1 cW wcel cR cW cV2 cV3 cplw vwit.2 vwit.4 addvecom 3adantr1 opreq1d
    cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV3 cV2 cplw co cV2
    cminw co cV3 cV2 cplw co cV2 cplw cgn cfv cfv cplw co cV3 cV2 cV2 cplw cgn
    cfv cfv cplw co cplw co cV3 cV2 cV2 cminw co cplw co cR cvec wcel cV3 cV2
    cplw co cW wcel cV2 cW wcel cV3 cV2 cplw co cV2 cminw co cV3 cV2 cplw co
    cV2 cplw cgn cfv cfv cplw co wceq cR cvec wcel cV1 cW wcel cV2 cW wcel cV3
    cW wcel w3a wa cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a pm3.26
    cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cR cvec wcel cV3 cV2 cplw co cW
    wcel cV2 cW wcel cV3 cW wcel cR cvec wcel cV3 cV2 cplw co cW wcel wi cV1 cW
    wcel cV3 cW wcel cV2 cW wcel cR cvec wcel cV3 cV2 cplw co cW wcel wi cR
    cvec wcel cV3 cW wcel cV2 cW wcel cV3 cV2 cplw co cW wcel cR cvec wcel cV3
    cW wcel cV2 cW wcel cV3 cV2 cplw co cW wcel cR cW cV3 cV2 cplw vwit.2
    vwit.4 sum2vv 3exp com3l impcom 3adant1 impcom cR cvec wcel cV1 cW wcel cV2
    cW wcel cV3 cW wcel 3simpr2 cR cW cV3 cV2 cplw co cV2 cplw cminw czerw cplw
    cgn cfv vwit.1 vwit.2 vwit.3 vwit.4 cplw cgn cfv eqid sub2vec sylan32c cR
    cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a cV3 cW wcel cV2 cW wcel
    cV2 cplw cgn cfv cfv cW wcel w3a cV3 cV2 cV2 cplw cgn cfv cfv cplw co cplw
    co cV3 cV2 cplw co cV2 cplw cgn cfv cfv cplw co wceq cR cvec wcel cV1 cW
    wcel cV2 cW wcel cV3 cW wcel w3a wa cV3 cW wcel cV2 cW wcel cV2 cplw cgn
    cfv cfv cW wcel cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel 3simpr3 cR
    cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel 3simpr2 cR cvec wcel cV1 cW
    wcel cV2 cW wcel cV2 cplw cgn cfv cfv cW wcel cV3 cW wcel cR cV2 cW cplw
    cgn cfv cW cplw crn cR c2nd cfv c1st cfv crn vwit.4 cplw cR c2nd cfv c1st
    cfv vwit.2 rneqi eqtri cplw cR c2nd cfv c1st cfv cgn vwit.2 fveq2i
    claddinvvec 3ad2antr2 3jca cR cW cV3 cV2 cV2 cplw cgn cfv cfv cplw vwit.2
    vwit.4 addvecass syldan cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel
    w3a wa cV2 cV2 cplw cgn cfv cfv cplw co cV2 cV2 cminw co cV3 cplw cR cvec
    wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV2 cV2 cminw co cV2 cV2
    cplw cgn cfv cfv cplw co cR cvec wcel cV2 cW wcel cV2 cW wcel wa cV2 cV2
    cminw co cV2 cV2 cplw cgn cfv cfv cplw co wceq cV1 cW wcel cV2 cW wcel cV3
    cW wcel w3a cR cW cV2 cV2 cplw cminw czerw cplw cgn cfv vwit.1 vwit.2
    vwit.3 vwit.4 cplw cgn cfv eqid sub2vec cV1 cW wcel cV2 cW wcel cV3 cW wcel
    w3a cV2 cW wcel cV2 cW wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel 3simp2 cV1
    cW wcel cV2 cW wcel cV3 cW wcel 3simp2 jca sylan2 eqcomd opreq2d 3eqtr2d cR
    cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW wcel w3a wa cV3 cV2 cV2 cminw co
    cplw co cV3 czerw cplw co cV3 cR cvec wcel cV1 cW wcel cV2 cW wcel cV3 cW
    wcel w3a wa cV2 cV2 cminw co czerw cV3 cplw cR cvec wcel cV1 cW wcel cV2 cW
    wcel cV2 cV2 cminw co czerw wceq cV3 cW wcel cR cV2 cW cplw cminw czerw
    vwit.1 vwit.2 vwit.3 vwit.4 vwit 3ad2antr2 opreq2d cR cvec wcel cV1 cW wcel
    cV3 cW wcel cV3 czerw cplw co cV3 wceq cV2 cW wcel cR cV3 cW cplw czerw
    vwit.2 vwit.4 vwit.1 addnull1 3ad2antr3 eqtrd 3eqtrd eqeq2d bitr3d $.
    $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}

  ${
    prvs.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    prvs.2 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    prvs.3 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    $( The product of a vector by a scalar is a vector. $)
    prvs $p |- ( ( R e. Vec /\ A e. X /\ U e. W ) -> ( A dot_w U ) e. W ) $=
      cX cW cxp cW cmw wf cA cX wcel cU cW wcel cA cU cmw co cW wcel cR cvec
      wcel cA cU cW cX cW cmw foprrn cR cW cX cmw prvs.1 prvs.3 prvs.2 vecax2
      syl3an1 $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}


  ${
    mulveczer.1 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    mulveczer.2 $e |- zero_t = ( Id ` plus_t ) $.
    mulveczer.3 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    mulveczer.4 $e |- dot_t = ( 2nd ` ( 1st ` R ) ) $.
    mulveczer.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    mulveczer.6 $e |- zero_w = ( Id ` ( 1st ` ( 2nd ` R ) ) ) $.
    $( Multiplication of a vector by zero. $)
    mulveczer $p |- ( ( R e. Vec /\ <. plus_t , dot_t >. e. Ring /\
         U e. W ) -> ( zero_t dot_w U ) = zero_w ) $=
      cR cvec wcel cpls cmus cop cring wcel cU cW wcel w3a czert cU cmw co
      czert cU cmw co cR c2nd cfv c1st cfv cgs cfv co czert cU cmw co czerw cR
      cvec wcel cpls cmus cop cring wcel cU cW wcel w3a czert cU cmw co czert
      cU cmw co czert cU cmw co cR c2nd cfv c1st cfv co wceq czert cU cmw co
      czert cU cmw co cR c2nd cfv c1st cfv cgs cfv co czert cU cmw co wceq cR
      cvec wcel cpls cmus cop cring wcel cU cW wcel w3a czert cU cmw co czert
      czert cpls co cU cmw co czert cU cmw co czert cU cmw co cR c2nd cfv c1st
      cfv co cR cvec wcel cpls cmus cop cring wcel cU cW wcel w3a czert czert
      czert cpls co cU cmw cpls cmus cop cring wcel cR cvec wcel czert czert
      czert cpls co wceq cU cW wcel cpls cmus cop cring wcel czert cpls crn
      wcel czert czert czert cpls co wceq cpls cmus cop cpls cpls crn czert
      cpls cmus cop c1st cfv cpls cpls cmus cpls cR c1st cfv c1st cfv cvv
      mulveczer.3 cR c1st cfv c1st fvex eqeltri op1st eqcomi cpls crn eqid
      mulveczer.2 ring0cl cpls cmus cop cring wcel czert cpls crn wcel wa czert
      czert cpls co czert czert cpls cmus cop cpls cpls crn czert cpls cmus cop
      c1st cfv cpls cpls cmus cpls cR c1st cfv c1st cfv cvv mulveczer.3 cR c1st
      cfv c1st fvex eqeltri op1st eqcomi cpls crn eqid mulveczer.2 ring0lid
      eqcomd mpdan 3ad2ant2 opreq1d cR cvec wcel cU cW wcel czert cR c1st cfv
      c1st cfv crn wcel czert cR c1st cfv c1st cfv crn wcel w3a czert czert
      cpls co cU cmw co czert cU cmw co czert cU cmw co cR c2nd cfv c1st cfv co
      wceq cR cvec wcel cpls cmus cop cring wcel cU cW wcel w3a czert czert cR
      cU cW cR c1st cfv c1st cfv crn cpls cR c2nd cfv c1st cfv cmw cR c1st cfv
      c1st cfv crn eqid mulveczer.3 cR c2nd cfv c1st cfv eqid mulveczer.5
      mulveczer.1 vecax5b cR cvec wcel cpls cmus cop cring wcel cU cW wcel
      3simp1 cR cvec wcel cpls cmus cop cring wcel cU cW wcel w3a cU cW wcel
      czert cR c1st cfv c1st cfv crn wcel czert cR c1st cfv c1st cfv crn wcel
      cR cvec wcel cpls cmus cop cring wcel cU cW wcel 3simp3 cpls cmus cop
      cring wcel cR cvec wcel czert cR c1st cfv c1st cfv crn wcel cU cW wcel
      cpls cmus cop cpls cR c1st cfv c1st cfv crn czert cpls cmus cop c1st cfv
      cpls cpls cmus cpls cR c1st cfv c1st cfv cvv mulveczer.3 cR c1st cfv c1st
      fvex eqeltri op1st eqcomi cR c1st cfv c1st cfv cpls cpls cR c1st cfv c1st
      cfv mulveczer.3 eqcomi rneqi mulveczer.2 ring0cl 3ad2ant2 cpls cmus cop
      cring wcel cR cvec wcel czert cR c1st cfv c1st cfv crn wcel cU cW wcel
      cpls cmus cop cpls cR c1st cfv c1st cfv crn czert cpls cmus cop c1st cfv
      cpls cpls cmus cpls cR c1st cfv c1st cfv cvv mulveczer.3 cR c1st cfv c1st
      fvex eqeltri op1st eqcomi cR c1st cfv c1st cfv cpls cpls cR c1st cfv c1st
      cfv mulveczer.3 eqcomi rneqi mulveczer.2 ring0cl 3ad2ant2 3jca sylanc
      eqtrd cR cvec wcel czert cU cmw co cW wcel czert cU cmw co cW wcel czert
      cU cmw co cW wcel w3a czert cU cmw co czert cU cmw co czert cU cmw co cR
      c2nd cfv c1st cfv co wceq czert cU cmw co czert cU cmw co cR c2nd cfv
      c1st cfv cgs cfv co czert cU cmw co wceq wb cR cvec wcel cpls cmus cop
      cring wcel cU cW wcel w3a cR cW czert cU cmw co czert cU cmw co czert cU
      cmw co cR c2nd cfv c1st cfv cR c2nd cfv c1st cfv cgs cfv czerw
      mulveczer.6 cR c2nd cfv c1st cfv eqid cR c2nd cfv c1st cfv cgs cfv eqid
      mulveczer.1 mvecrtol2 cR cvec wcel cpls cmus cop cring wcel cU cW wcel
      3simp1 cR cvec wcel cpls cmus cop cring wcel cU cW wcel w3a czert cU cmw
      co cW wcel czert cU cmw co cW wcel czert cU cmw co cW wcel cR cvec wcel
      czert cpls crn wcel cU cW wcel czert cU cmw co cW wcel cpls cmus cop
      cring wcel czert cR cU cW cpls crn cpls cR c2nd cfv c1st cfv cmw cR c2nd
      cfv c1st cfv eqid mulveczer.5 mulveczer.1 cpls crn eqid mulveczer.3
      prodvs cpls cmus cop cpls cpls crn czert cpls cmus cop c1st cfv cpls cpls
      cmus cpls cR c1st cfv c1st cfv cvv mulveczer.3 cR c1st cfv c1st fvex
      eqeltri op1st eqcomi cpls crn eqid mulveczer.2 ring0cl syl3an2 cR cvec
      wcel czert cpls crn wcel cU cW wcel czert cU cmw co cW wcel cpls cmus cop
      cring wcel czert cR cU cW cpls crn cpls cR c2nd cfv c1st cfv cmw cR c2nd
      cfv c1st cfv eqid mulveczer.5 mulveczer.1 cpls crn eqid mulveczer.3
      prodvs cpls cmus cop cpls cpls crn czert cpls cmus cop c1st cfv cpls cpls
      cmus cpls cR c1st cfv c1st cfv cvv mulveczer.3 cR c1st cfv c1st fvex
      eqeltri op1st eqcomi cpls crn eqid mulveczer.2 ring0cl syl3an2 cR cvec
      wcel czert cpls crn wcel cU cW wcel czert cU cmw co cW wcel cpls cmus cop
      cring wcel czert cR cU cW cpls crn cpls cR c2nd cfv c1st cfv cmw cR c2nd
      cfv c1st cfv eqid mulveczer.5 mulveczer.1 cpls crn eqid mulveczer.3
      prodvs cpls cmus cop cpls cpls crn czert cpls cmus cop c1st cfv cpls cpls
      cmus cpls cR c1st cfv c1st cfv cvv mulveczer.3 cR c1st cfv c1st fvex
      eqeltri op1st eqcomi cpls crn eqid mulveczer.2 ring0cl syl3an2 3jca
      sylanc mpbid cR cvec wcel czert cU cmw co cW wcel czert cU cmw co czert
      cU cmw co cR c2nd cfv c1st cfv cgs cfv co czerw wceq cR cvec wcel cpls
      cmus cop cring wcel cU cW wcel w3a cR czert cU cmw co cW cR c2nd cfv c1st
      cfv cR c2nd cfv c1st cfv cgs cfv czerw mulveczer.6 cR c2nd cfv c1st cfv
      eqid cR c2nd cfv c1st cfv cgs cfv eqid mulveczer.1 vwit cR cvec wcel cpls
      cmus cop cring wcel cU cW wcel 3simp1 cR cvec wcel czert cpls crn wcel cU
      cW wcel czert cU cmw co cW wcel cpls cmus cop cring wcel czert cR cU cW
      cpls crn cpls cR c2nd cfv c1st cfv cmw cR c2nd cfv c1st cfv eqid
      mulveczer.5 mulveczer.1 cpls crn eqid mulveczer.3 prodvs cpls cmus cop
      cpls cpls crn czert cpls cmus cop c1st cfv cpls cpls cmus cpls cR c1st
      cfv c1st cfv cvv mulveczer.3 cR c1st cfv c1st fvex eqeltri op1st eqcomi
      cpls crn eqid mulveczer.2 ring0cl syl3an2 sylanc eqtr3d $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}


  ${
    mulinvsca.1 $e |- X = ran plus_t $.
    mulinvsca.2 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    mulinvsca.3 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    mulinvsca.4 $e |- tild_t = ( inv ` plus_t ) $.
    mulinvsca.5 $e |- tild_w = ( inv ` ( 1st ` ( 2nd ` R ) ) ) $.
    mulinvsca.6 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    mulinvsca.7 $e |- dot_t = ( 2nd ` ( 1st ` R ) ) $.
      $( Multiplication by the inverse of a scalar. $)
    mulinvsca $p |- ( ( R e. Vec /\ <. plus_t , dot_t >. e. Ring
        /\ ( A e. X /\ U e. W ) )
          -> ( ( tild_t ` A ) dot_w U ) = ( tild_w ` ( A dot_w U ) ) )  $=
      cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cU
      cmw co cA cnes cfv cU cmw co cR c2nd cfv c1st cfv co cA cU cmw co cA cU
      cmw co cnegw cfv cR c2nd cfv c1st cfv co wceq cA cnes cfv cU cmw co cA cU
      cmw co cnegw cfv wceq cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU
      cW wcel wa w3a cA cU cmw co cA cU cmw co cR c2nd cfv c1st cfv cgs cfv co
      cA cA cnes cfv cpls co cU cmw co cA cU cmw co cA cU cmw co cnegw cfv cR
      c2nd cfv c1st cfv co cA cU cmw co cA cnes cfv cU cmw co cR c2nd cfv c1st
      cfv co cR cvec wcel cA cU cmw co cW wcel wa cR cvec wcel cpls cmus cop
      cring wcel cA cX wcel cU cW wcel wa w3a cA cU cmw co cA cU cmw co cR c2nd
      cfv c1st cfv cgs cfv co cA cA cnes cfv cpls co cU cmw co wceq cR cvec
      wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cR cvec wcel
      cA cU cmw co cW wcel cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU
      cW wcel wa 3simp1 cR cvec wcel cA cX wcel cU cW wcel wa cA cU cmw co cW
      wcel cpls cmus cop cring wcel cR cvec wcel cA cX wcel cU cW wcel cA cU
      cmw co cW wcel cA cR cU cW cX cpls cR c2nd cfv c1st cfv cmw cR c2nd cfv
      c1st cfv eqid mulinvsca.3 mulinvsca.2 mulinvsca.1 mulinvsca.6 prodvs
      3expb 3adant2 jca cR cvec wcel cA cU cmw co cW wcel wa cA cU cmw co cA cU
      cmw co cR c2nd cfv c1st cfv cgs cfv co cR c2nd cfv c1st cfv cgi cfv wceq
      cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cU
      cmw co cA cU cmw co cR c2nd cfv c1st cfv cgs cfv co cA cA cnes cfv cpls
      co cU cmw co wceq wi cR cA cU cmw co cW cR c2nd cfv c1st cfv cR c2nd cfv
      c1st cfv cgs cfv cR c2nd cfv c1st cfv cgi cfv cR c2nd cfv c1st cfv cgi
      cfv eqid cR c2nd cfv c1st cfv eqid cR c2nd cfv c1st cfv cgs cfv eqid
      mulinvsca.2 vwit cA cU cmw co cA cU cmw co cR c2nd cfv c1st cfv cgs cfv
      co cR c2nd cfv c1st cfv cgi cfv wceq cR cvec wcel cpls cmus cop cring
      wcel cA cX wcel cU cW wcel wa w3a cA cU cmw co cA cU cmw co cR c2nd cfv
      c1st cfv cgs cfv co cA cA cnes cfv cpls co cU cmw co wceq cA cU cmw co cA
      cU cmw co cR c2nd cfv c1st cfv cgs cfv co cR c2nd cfv c1st cfv cgi cfv
      wceq cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a
      wa cA cU cmw co cA cU cmw co cR c2nd cfv c1st cfv cgs cfv co cR c2nd cfv
      c1st cfv cgi cfv cA cA cnes cfv cpls co cU cmw co cA cU cmw co cA cU cmw
      co cR c2nd cfv c1st cfv cgs cfv co cR c2nd cfv c1st cfv cgi cfv wceq cR
      cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a pm3.26 cR
      cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cR c2nd
      cfv c1st cfv cgi cfv cA cA cnes cfv cpls co cU cmw co wceq cA cU cmw co
      cA cU cmw co cR c2nd cfv c1st cfv cgs cfv co cR c2nd cfv c1st cfv cgi cfv
      wceq cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a
      cpls cgi cfv cU cmw co cR c2nd cfv c1st cfv cgi cfv cA cA cnes cfv cpls
      co cU cmw co cR cvec wcel cpls cmus cop cring wcel cU cW wcel cpls cgi
      cfv cU cmw co cR c2nd cfv c1st cfv cgi cfv wceq cA cX wcel cR cU cW cpls
      cmus cpls cgi cfv cmw cR c2nd cfv c1st cfv cgi cfv mulinvsca.2 cpls cgi
      cfv eqid mulinvsca.6 mulinvsca.7 mulinvsca.3 cR c2nd cfv c1st cfv cgi cfv
      eqid mulveczer 3adant3l cR cvec wcel cpls cmus cop cring wcel cA cX wcel
      cU cW wcel wa w3a cpls cgi cfv cA cA cnes cfv cpls co cU cmw cR cvec wcel
      cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cA cnes cfv cpls
      co cpls cgi cfv cpls cgr wcel cA cX wcel cA cA cnes cfv cpls co cpls cgi
      cfv wceq cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa
      w3a cA cpls cgi cfv cpls cnes cX mulinvsca.1 cpls cgi cfv eqid
      mulinvsca.4 grprinv cpls cmus cop cring wcel cR cvec wcel cpls cgr wcel
      cA cX wcel cU cW wcel wa cpls cmus cop cpls cpls cmus cop c1st cfv cpls
      cpls cmus cpls cR c1st cfv c1st cfv cvv mulinvsca.6 cR c1st cfv c1st fvex
      eqeltri op1st eqcomi ringgrp 3ad2ant2 cA cX wcel cU cW wcel wa cR cvec
      wcel cA cX wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel pm3.26
      3ad2ant3 sylanc eqcomd opreq1d eqtr3d adantl eqtrd ex syl mpcom cR cvec
      wcel cA cU cmw co cW wcel cA cU cmw co cW wcel cA cU cmw co cA cU cmw co
      cR c2nd cfv c1st cfv cgs cfv co cA cU cmw co cA cU cmw co cnegw cfv cR
      c2nd cfv c1st cfv co wceq cR cvec wcel cpls cmus cop cring wcel cA cX
      wcel cU cW wcel wa w3a cR cvec wcel cpls cmus cop cring wcel cA cX wcel
      cU cW wcel wa 3simp1 cR cvec wcel cA cX wcel cU cW wcel cA cU cmw co cW
      wcel cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a
      cA cR cU cW cX cmw cX cpls crn cR c1st cfv c1st cfv crn mulinvsca.1 cpls
      cR c1st cfv c1st cfv mulinvsca.6 rneqi eqtri mulinvsca.2 mulinvsca.3 prvs
      cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa 3simp1 cA
      cX wcel cU cW wcel wa cR cvec wcel cA cX wcel cpls cmus cop cring wcel cA
      cX wcel cU cW wcel pm3.26 3ad2ant3 cA cX wcel cU cW wcel wa cR cvec wcel
      cU cW wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel pm3.27 3ad2ant3
      syl3anc cR cvec wcel cA cX wcel cU cW wcel cA cU cmw co cW wcel cR cvec
      wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cR cU cW cX
      cmw cX cpls crn cR c1st cfv c1st cfv crn mulinvsca.1 cpls cR c1st cfv
      c1st cfv mulinvsca.6 rneqi eqtri mulinvsca.2 mulinvsca.3 prvs cR cvec
      wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa 3simp1 cA cX wcel
      cU cW wcel wa cR cvec wcel cA cX wcel cpls cmus cop cring wcel cA cX wcel
      cU cW wcel pm3.26 3ad2ant3 cA cX wcel cU cW wcel wa cR cvec wcel cU cW
      wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel pm3.27 3ad2ant3
      syl3anc cR cW cA cU cmw co cA cU cmw co cR c2nd cfv c1st cfv cR c2nd cfv
      c1st cfv cgs cfv cR c2nd cfv c1st cfv cgi cfv cnegw cR c2nd cfv c1st cfv
      cgi cfv eqid cR c2nd cfv c1st cfv eqid cR c2nd cfv c1st cfv cgs cfv eqid
      mulinvsca.2 mulinvsca.5 sub2vec sylan32c cR cvec wcel cU cW wcel cA cX
      wcel cA cnes cfv cX wcel w3a cA cA cnes cfv cpls co cU cmw co cA cU cmw
      co cA cnes cfv cU cmw co cR c2nd cfv c1st cfv co wceq cR cvec wcel cpls
      cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cA cnes cfv cR cU cW
      cX cpls cR c2nd cfv c1st cfv cmw cX cpls crn cR c1st cfv c1st cfv crn
      mulinvsca.1 cpls cR c1st cfv c1st cfv mulinvsca.6 rneqi eqtri mulinvsca.6
      cR c2nd cfv c1st cfv eqid mulinvsca.3 mulinvsca.2 vecax5b cR cvec wcel
      cpls cmus cop cring wcel cA cX wcel cU cW wcel wa 3simp1 cR cvec wcel
      cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cU cW wcel cA cX
      wcel cA cnes cfv cX wcel cA cX wcel cU cW wcel wa cR cvec wcel cU cW wcel
      cpls cmus cop cring wcel cA cX wcel cU cW wcel pm3.27 3ad2ant3 cA cX wcel
      cU cW wcel wa cR cvec wcel cA cX wcel cpls cmus cop cring wcel cA cX wcel
      cU cW wcel pm3.26 3ad2ant3 cpls cmus cop cring wcel cA cX wcel cU cW wcel
      wa cA cnes cfv cX wcel cR cvec wcel cpls cmus cop cring wcel cA cX wcel
      cA cnes cfv cX wcel cU cW wcel cA cpls cmus cnes cX mulinvsca.1
      mulinvsca.4 rnginvcl adantrr 3adant1 3jca sylanc 3eqtr3rd cR c2nd cfv
      c1st cfv cgr wcel cA cnes cfv cU cmw co cW wcel cA cU cmw co cnegw cfv cW
      wcel cA cU cmw co cW wcel w3a cA cU cmw co cA cnes cfv cU cmw co cR c2nd
      cfv c1st cfv co cA cU cmw co cA cU cmw co cnegw cfv cR c2nd cfv c1st cfv
      co wceq cA cnes cfv cU cmw co cA cU cmw co cnegw cfv wceq wb cR cvec wcel
      cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cnes cfv cU cmw
      co cA cU cmw co cnegw cfv cA cU cmw co cR c2nd cfv c1st cfv cW
      mulinvsca.2 grplcan cR cvec wcel cpls cmus cop cring wcel cR c2nd cfv
      c1st cfv cgr wcel cA cX wcel cU cW wcel wa cR cvec wcel cR c2nd cfv c1st
      cfv cabl wcel cR c2nd cfv c1st cfv cgr wcel cR cR c2nd cfv c1st cfv cR
      c2nd cfv c1st cfv eqid vecax1 cR c2nd cfv c1st cfv ablgrp syl 3ad2ant1 cR
      cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA cnes
      cfv cU cmw co cW wcel cA cU cmw co cnegw cfv cW wcel cA cU cmw co cW wcel
      cR cvec wcel cA cnes cfv cX wcel cU cW wcel cA cnes cfv cU cmw co cW wcel
      cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa w3a cA
      cnes cfv cR cU cW cX cmw cX cpls crn cR c1st cfv c1st cfv crn mulinvsca.1
      cpls cR c1st cfv c1st cfv mulinvsca.6 rneqi eqtri mulinvsca.2 mulinvsca.3
      prvs cR cvec wcel cpls cmus cop cring wcel cA cX wcel cU cW wcel wa
      3simp1 cpls cmus cop cring wcel cA cX wcel cU cW wcel wa cA cnes cfv cX
      wcel cR cvec wcel cpls cmus cop cring wcel cA cX wcel cA cnes cfv cX wcel
      cU cW wcel cA cpls cmus cnes cX mulinvsca.1 mulinvsca.4 rnginvcl adantrr
      3adant1 cA cX wcel cU cW wcel wa cR cvec wcel cU cW wcel cpls cmus cop
      cring wcel cA cX wcel cU cW wcel pm3.27 3ad2ant3 syl3anc cR cvec wcel cA
      cU cmw co cW wcel cA cU cmw co cnegw cfv cW wcel cR cvec wcel cpls cmus
      cop cring wcel cA cX wcel cU cW wcel wa w3a cR cA cU cmw co cW cnegw
      mulinvsca.2 mulinvsca.5 claddinvvec cR cvec wcel cpls cmus cop cring wcel
      cA cX wcel cU cW wcel wa 3simp1 cR cvec wcel cA cX wcel cU cW wcel wa cA
      cU cmw co cW wcel cpls cmus cop cring wcel cR cvec wcel cA cX wcel cU cW
      wcel cA cU cmw co cW wcel cA cR cU cW cX cpls cR c2nd cfv c1st cfv cmw cR
      c2nd cfv c1st cfv eqid mulinvsca.3 mulinvsca.2 mulinvsca.1 mulinvsca.6
      prodvs 3expb 3adant2 sylanc cR cvec wcel cA cX wcel cU cW wcel wa cA cU
      cmw co cW wcel cpls cmus cop cring wcel cR cvec wcel cA cX wcel cU cW
      wcel cA cU cmw co cW wcel cA cR cU cW cX cpls cR c2nd cfv c1st cfv cmw cR
      c2nd cfv c1st cfv eqid mulinvsca.3 mulinvsca.2 mulinvsca.1 mulinvsca.6
      prodvs 3expb 3adant2 3jca sylanc mpbid $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}

  ${
    $d plus_t u x y $. $d dot_t u x y $. $d R u x y $. $d W x y $. $d X y $.
    muldisc.1 $e |- X = ran ( 1st ` ( 1st ` R ) ) $.
    muldisc.2 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    muldisc.4 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    muldisc.5 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    muldisc.6 $e |- W = ran ( 1st ` ( 2nd ` R ) ) $.
    muldisc.7 $e |- minus_t = ( /g ` plus_t ) $.
    muldisc.8 $e |- minus_w = ( /g ` plus_w ) $.
    muldisc.9 $e |- dot_t = ( 2nd ` ( 1st ` R ) ) $.
    $( Multiplication by a difference  of scalars. $)
    muldisc $p |- ( ( R e. Vec /\ <. plus_t , dot_t >. e. Ring )
        -> A. u e. W A. x e. X  A. y e. X
          ( ( x minus_t y ) dot_w u ) = ( ( x dot_w u ) minus_w ( y dot_w u ) ) ) $=
      cR cvec wcel cpls cmus cop cring wcel wa vx cv vy cv cmnu co vu cv cmw co
      vx cv vu cv cmw co vy cv vu cv cmw co cminw co wceq vy cX wral vu vx cW
      cX cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel
      wa vx cv vy cv cmnu co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co
      cminw co wceq vy cX wral cR cvec wcel cpls cmus cop cring wcel wa vu cv
      cW wcel vx cv cX wcel wa wa vx cv vy cv cmnu co vu cv cmw co vx cv vu cv
      cmw co vy cv vu cv cmw co cminw co wceq vy cX cR cvec wcel cpls cmus cop
      cring wcel wa vu cv cW wcel vx cv cX wcel wa wa vy cv cX wcel wa vx cv vy
      cv cmnu co vu cv cmw co vx cv vu cv cmw co vy cv vu cv cmw co cplw cgn
      cfv cfv cplw co vx cv vu cv cmw co vy cv vu cv cmw co cminw co cR cvec
      wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel wa wa vy cv
      cX wcel wa vx cv vy cv cmnu co vu cv cmw co vx cv vy cv cpls cgn cfv cfv
      cpls co vu cv cmw co vx cv vu cv cmw co vy cv cpls cgn cfv cfv vu cv cmw
      co cplw co vx cv vu cv cmw co vy cv vu cv cmw co cplw cgn cfv cfv cplw co
      cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel wa
      wa vy cv cX wcel wa vx cv vy cv cmnu co vx cv vy cv cpls cgn cfv cfv cpls
      co vu cv cmw cpls cgr wcel vx cv cR c1st cfv c1st cfv crn wcel vy cv cR
      c1st cfv c1st cfv crn wcel vx cv vy cv cmnu co vx cv vy cv cpls cgn cfv
      cfv cpls co wceq cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel
      vx cv cX wcel wa wa vy cv cX wcel wa vx cv vy cv cmnu cpls cpls cgn cfv
      cR c1st cfv c1st cfv crn cpls crn cR c1st cfv c1st cfv crn cpls cR c1st
      cfv c1st cfv muldisc.2 rneqi eqcomi cpls cgn cfv eqid muldisc.7 grpdivval
      cR cvec wcel cpls cmus cop cring wcel wa cpls cgr wcel vu cv cW wcel vx
      cv cX wcel wa vy cv cX wcel cpls cmus cop cring wcel cpls cgr wcel cR
      cvec wcel cpls cmus cop cpls cpls cmus cop c1st cfv cpls cpls cmus cpls
      cR c1st cfv c1st cfv cvv muldisc.2 cR c1st cfv c1st fvex eqeltri op1st
      eqcomi ringgrp adantl ad2antrr vu cv cW wcel vx cv cX wcel wa vx cv cR
      c1st cfv c1st cfv crn wcel cR cvec wcel cpls cmus cop cring wcel wa vy cv
      cX wcel vx cv cX wcel vx cv cR c1st cfv c1st cfv crn wcel vu cv cW wcel
      vx cv cX wcel vx cv cR c1st cfv c1st cfv crn wcel cX cR c1st cfv c1st cfv
      crn vx cv muldisc.1 eleq2i biimpi adantl ad2antlr vy cv cX wcel vy cv cR
      c1st cfv c1st cfv crn wcel cR cvec wcel cpls cmus cop cring wcel wa vu cv
      cW wcel vx cv cX wcel wa wa vy cv cX wcel vy cv cR c1st cfv c1st cfv crn
      wcel cX cR c1st cfv c1st cfv crn vy cv muldisc.1 eleq2i biimpi adantl
      syl3anc opreq1d cR cvec wcel vu cv cW wcel vx cv cX wcel vy cv cpls cgn
      cfv cfv cX wcel w3a vx cv vy cv cpls cgn cfv cfv cpls co vu cv cmw co vx
      cv vu cv cmw co vy cv cpls cgn cfv cfv vu cv cmw co cplw co wceq cR cvec
      wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel wa wa vy cv
      cX wcel wa vx cv vy cv cpls cgn cfv cfv cR vu cv cW cX cpls cplw cmw
      muldisc.1 muldisc.2 muldisc.4 muldisc.5 muldisc.6 vecax5b cR cvec wcel
      cpls cmus cop cring wcel vu cv cW wcel vx cv cX wcel wa vy cv cX wcel
      simplll cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX
      wcel wa wa vy cv cX wcel wa vu cv cW wcel vx cv cX wcel vy cv cpls cgn
      cfv cfv cX wcel cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx
      cv cX wcel vy cv cX wcel simplrl cR cvec wcel cpls cmus cop cring wcel wa
      vu cv cW wcel vx cv cX wcel vy cv cX wcel simplrr cR c1st cfv c1st cfv
      cgr wcel vy cv cX wcel vy cv cpls cgn cfv cfv cX wcel cR cvec wcel cpls
      cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel wa wa vy cv cR c1st
      cfv c1st cfv cpls cgn cfv cX muldisc.1 cpls cR c1st cfv c1st cfv cgn
      muldisc.2 fveq2i grpinvcl cpls cmus cop cring wcel cR c1st cfv c1st cfv
      cgr wcel cR cvec wcel vu cv cW wcel vx cv cX wcel wa cpls cmus cop cring
      wcel cpls cgr cR c1st cfv c1st cfv cpls cmus cop cpls cpls cmus cop c1st
      cfv cpls cpls cmus cpls cR c1st cfv c1st cfv cvv muldisc.2 cR c1st cfv
      c1st fvex eqeltri op1st eqcomi ringgrp muldisc.2 syl5eqelr ad2antlr sylan
      3jca sylanc cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv
      cX wcel wa wa vy cv cX wcel wa vy cv cpls cgn cfv cfv vu cv cmw co vy cv
      vu cv cmw co cplw cgn cfv cfv vx cv vu cv cmw co cplw cR cvec wcel cpls
      cmus cop cring wcel vy cv cR c1st cfv c1st cfv crn wcel vu cv cW wcel wa
      vy cv cpls cgn cfv cfv vu cv cmw co vy cv vu cv cmw co cplw cgn cfv cfv
      wceq cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel
      wa wa vy cv cX wcel wa vy cv cR vu cv cW cR c1st cfv c1st cfv crn cpls
      cmus cpls cgn cfv cmw cplw cgn cfv cR c1st cfv c1st cfv cpls cpls cR c1st
      cfv c1st cfv muldisc.2 eqcomi rneqi muldisc.6 muldisc.5 cpls cgn cfv eqid
      cplw cR c2nd cfv c1st cfv cgn muldisc.4 fveq2i muldisc.2 muldisc.9
      mulinvsca cR cvec wcel cpls cmus cop cring wcel vu cv cW wcel vx cv cX
      wcel wa vy cv cX wcel simplll cR cvec wcel cpls cmus cop cring wcel vu cv
      cW wcel vx cv cX wcel wa vy cv cX wcel simpllr cR cvec wcel cpls cmus cop
      cring wcel wa vu cv cW wcel vx cv cX wcel wa wa vy cv cX wcel wa vy cv cR
      c1st cfv c1st cfv crn wcel vu cv cW wcel vy cv cX wcel vy cv cR c1st cfv
      c1st cfv crn wcel cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel
      vx cv cX wcel wa wa vy cv cX wcel vy cv cR c1st cfv c1st cfv crn wcel cX
      cR c1st cfv c1st cfv crn vy cv muldisc.1 eleq2i biimpi adantl cR cvec
      wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel vy cv cX
      wcel simplrl jca syl3anc opreq2d 3eqtrd cplw cgr wcel vx cv vu cv cmw co
      cW wcel vy cv vu cv cmw co cW wcel vx cv vu cv cmw co vy cv vu cv cmw co
      cminw co vx cv vu cv cmw co vy cv vu cv cmw co cplw cgn cfv cfv cplw co
      wceq cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel
      wa wa vy cv cX wcel wa vx cv vu cv cmw co vy cv vu cv cmw co cminw cplw
      cplw cgn cfv cW cW cR c2nd cfv c1st cfv crn cplw crn muldisc.6 cR c2nd
      cfv c1st cfv cplw cplw cR c2nd cfv c1st cfv muldisc.4 eqcomi rneqi eqtri
      cplw cgn cfv eqid muldisc.8 grpdivval cR cvec wcel cpls cmus cop cring
      wcel wa cplw cgr wcel vu cv cW wcel vx cv cX wcel wa vy cv cX wcel cR
      cvec wcel cplw cgr wcel cpls cmus cop cring wcel cR cvec wcel cplw cabl
      wcel cplw cgr wcel cR cplw muldisc.4 vecax1 cplw ablgrp syl adantr
      ad2antrr cR cvec wcel cpls cmus cop cring wcel wa vu cv cW wcel vx cv cX
      wcel wa wa vx cv vu cv cmw co cW wcel vy cv cX wcel cR cvec wcel cpls
      cmus cop cring wcel wa vu cv cW wcel vx cv cX wcel wa vx cv vu cv cmw co
      cW wcel cR cvec wcel vu cv cW wcel vx cv cX wcel wa vx cv vu cv cmw co cW
      wcel wi cpls cmus cop cring wcel vu cv cW wcel vx cv cX wcel wa cR cvec
      wcel vx cv vu cv cmw co cW wcel vx cv cX wcel vu cv cW wcel cR cvec wcel
      vx cv vu cv cmw co cW wcel wi cR cvec wcel vx cv cX wcel vu cv cW wcel vx
      cv vu cv cmw co cW wcel cR cvec wcel vx cv cX wcel vu cv cW wcel vx cv vu
      cv cmw co cW wcel vx cv cR vu cv cW cX cmw muldisc.1 muldisc.6 muldisc.5
      prvs 3exp com3l impcom com12 adantr imp adantr cR cvec wcel cpls cmus cop
      cring wcel wa vu cv cW wcel vx cv cX wcel wa wa vy cv cX wcel vy cv vu cv
      cmw co cW wcel vu cv cW wcel vx cv cX wcel wa cR cvec wcel cpls cmus cop
      cring wcel wa vy cv cX wcel vy cv vu cv cmw co cW wcel wi vu cv cW wcel
      cR cvec wcel cpls cmus cop cring wcel wa vy cv cX wcel vy cv vu cv cmw co
      cW wcel wi wi vx cv cX wcel cR cvec wcel cpls cmus cop cring wcel wa vy
      cv cX wcel vu cv cW wcel vy cv vu cv cmw co cW wcel cR cvec wcel vy cv cX
      wcel vu cv cW wcel vy cv vu cv cmw co cW wcel wi wi cpls cmus cop cring
      wcel cR cvec wcel vy cv cX wcel vu cv cW wcel vy cv vu cv cmw co cW wcel
      vy cv cR vu cv cW cX cmw muldisc.1 muldisc.6 muldisc.5 prvs 3exp adantr
      com3r adantr impcom imp syl3anc eqtr4d r19.21aiva ex r19.21aivv $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}

  ${
    $d plus_t u x y $. $d minus_t u x y $. $d minus_w u x y $. $d dot_t u x y $. $d dot_w u x y $.
    $d A x y $. $d B y $. $d R u x y $. $d U u x y $. $d W u x y $.
    $d X u x y $.
    vecax5c.1 $e |- X = ran plus_t $.
    vecax5c.2 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    vecax5c.3 $e |- minus_t = ( /g ` plus_t ) $.
    vecax5c.4 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    vecax5c.5 $e |- minus_w = ( /g ` plus_w ) $.
    vecax5c.6 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    vecax5c.7 $e |- W = ran plus_w $.
    vecax5c.8 $e |- dot_t = ( 2nd ` ( 1st ` R ) ) $.
    $( Multiplication by a difference of scalars. $)
    vecax5c $p |- ( ( R e. Vec /\ <. plus_t , dot_t >. e. Ring ) -> (
        ( U e. W /\ A e. X /\ B e. X ) ->
          ( ( A minus_t B ) dot_w U ) = ( ( A dot_w U ) minus_w ( B dot_w U ) ) ) ) $=
      cU cW wcel cA cX wcel cB cX wcel w3a vx cv vy cv cmnu co vu cv cmw co vx
      cv vu cv cmw co vy cv vu cv cmw co cminw co wceq vy cX wral vx cX wral vu
      cW wral cA cB cmnu co cU cmw co cA cU cmw co cB cU cmw co cminw co wceq
      cR cvec wcel cpls cmus cop cring wcel wa vx cv vy cv cmnu co vu cv cmw co
      vx cv vu cv cmw co vy cv vu cv cmw co cminw co wceq cA cB cmnu co cU cmw
      co cA cU cmw co cB cU cmw co cminw co wceq vx cv vy cv cmnu co cU cmw co
      vx cv cU cmw co vy cv cU cmw co cminw co wceq cA vy cv cmnu co cU cmw co
      cA cU cmw co vy cv cU cmw co cminw co wceq vu vx vy cU cA cB cW cX cX vu
      cv cU wceq vx cv vy cv cmnu co vu cv cmw co vx cv vy cv cmnu co cU cmw co
      vx cv vu cv cmw co vy cv vu cv cmw co cminw co vx cv cU cmw co vy cv cU
      cmw co cminw co vu cv cU vx cv vy cv cmnu co cmw opreq2 vu cv cU wceq vx
      cv vu cv cmw co vx cv cU cmw co vy cv vu cv cmw co vy cv cU cmw co cminw
      vu cv cU vx cv cmw opreq2 vu cv cU vy cv cmw opreq2 opreq12d eqeq12d vx
      cv cA wceq vx cv vy cv cmnu co cU cmw co cA vy cv cmnu co cU cmw co vx cv
      cU cmw co vy cv cU cmw co cminw co cA cU cmw co vy cv cU cmw co cminw co
      vx cv cA wceq vx cv vy cv cmnu co cA vy cv cmnu co cU cmw vx cv cA vy cv
      cmnu opreq1 opreq1d vx cv cA wceq vx cv cU cmw co cA cU cmw co vy cv cU
      cmw co cminw vx cv cA cU cmw opreq1 opreq1d eqeq12d vy cv cB wceq cA vy
      cv cmnu co cU cmw co cA cB cmnu co cU cmw co cA cU cmw co vy cv cU cmw co
      cminw co cA cU cmw co cB cU cmw co cminw co vy cv cB wceq cA vy cv cmnu
      co cA cB cmnu co cU cmw vy cv cB cA cmnu opreq2 opreq1d vy cv cB wceq vy
      cv cU cmw co cB cU cmw co cA cU cmw co cminw vy cv cB cU cmw opreq1
      opreq2d eqeq12d rcla43v vx vy vu cR cW cX cpls cmnu cmus cplw cminw cmw
      cX cpls crn cR c1st cfv c1st cfv crn vecax5c.1 cpls cR c1st cfv c1st cfv
      vecax5c.2 rneqi eqtri vecax5c.2 vecax5c.4 vecax5c.6 cW cplw crn cR c2nd
      cfv c1st cfv crn vecax5c.7 cplw cR c2nd cfv c1st cfv vecax5c.4 rneqi
      eqtri vecax5c.3 vecax5c.5 vecax5c.8 muldisc syl5com $.
      $( [20-Sep-2010] $) $( [12-Sep-2010] $)
  $}

  ${
    $d plus_t k s u y $. $d plus_w k s $. $d dot_t k $. $d dot_w s $. $d zero_t s $.
    $d zero_w k s $. $d N k s u y $. $d R k $. $d S1 s u y $.
    $d S2 s u y $. $d U s $. $d W k $. $d X k s y $.
    svli2.1 $e |- X = ran plus_t $.
    svli2.2 $e |- zero_t = ( Id ` plus_t ) $.
    svli2.7 $e |- plus_t = ( 1st ` ( 1st ` R ) ) $.
    svli2.3 $e |- dot_t = ( 2nd ` ( 1st ` R ) ) $.
    svli2.4 $e |- zero_w = ( Id ` plus_w ) $.
    svli2.5 $e |- plus_w = ( 1st ` ( 2nd ` R ) ) $.
    svli2.6 $e |- W = ran plus_w $.
    svli2.8 $e |- dot_w = ( 2nd ` ( 2nd ` R ) ) $.
    $( If a finite sequence of vectors ` U ( k ) ` are linearly independant,
       two combinations of those vectors are equal iff the scalars
       are equal. $)
    svli2 $p |-
       ( (  (      R e. Vec
                /\ <. plus_t , dot_t >. e. Ring
                /\ N e. NN )
         /\ (
                   A. k e. ( 1 ... N ) U e. W
                /\ A. k e. ( 1 ... N ) S1 e. X
                /\ A. k e. ( 1 ... N ) S2 e. X )
         /\ A. s e. ( X ^m ( 1 ... N ) )
                  ( prod_ k e. ( 1 ... N ) plus_w ( ( s ` k ) dot_w U ) = zero_w
                           -> A. k e. ( 1 ... N ) ( s ` k ) = zero_t ) )
        -> (
               prod_ k e. ( 1 ... N ) plus_w ( S1 dot_w U ) =
               prod_ k e. ( 1 ... N ) plus_w ( S2 dot_w U )
                   <-> A. k e. ( 1 ... N ) S1 = S2 ) ) $=
      cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN
      cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co
      wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq
      vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm
      co wral w3a c1 cN cfz co cS1 cU cmw co vk cplw cprd c1 cN cfz co cS2 cU
      cmw co vk cplw cprd wceq c1 cN cfz co cS1 cU cmw co vk cplw cprd c1 cN
      cfz co cS2 cU cmw co vk cplw cprd cplw cgs cfv co czerw wceq c1 cN cfz co
      cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co vk cplw cprd czerw wceq cS1
      cS2 wceq vk c1 cN cfz co wral cR cvec wcel c1 cN cfz co cS1 cU cmw co vk
      cplw cprd cW wcel c1 cN cfz co cS2 cU cmw co vk cplw cprd cW wcel wa c1
      cN cfz co cS1 cU cmw co vk cplw cprd c1 cN cfz co cS2 cU cmw co vk cplw
      cprd wceq c1 cN cfz co cS1 cU cmw co vk cplw cprd c1 cN cfz co cS2 cU cmw
      co vk cplw cprd cplw cgs cfv co czerw wceq wb cR cvec wcel cpls cmus cop
      cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk
      c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv
      vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk
      c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral w3a cR cW c1 cN cfz co
      cS1 cU cmw co vk cplw cprd c1 cN cfz co cS2 cU cmw co vk cplw cprd cplw
      cplw cgs cfv czerw svli2.4 svli2.5 cplw cgs cfv eqid svli2.6 mvecrtol cR
      cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz
      co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral
      w3a cR cvec wcel c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd
      czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN
      cfz co cm co wral cR cvec wcel cpls cmus cop cring wcel cN cn wcel 3simp1
      3ad2ant1 cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel
      vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1
      cN cfz co wral w3a c1 cN cfz co cS1 cU cmw co vk cplw cprd cW wcel c1 cN
      cfz co cS2 cU cmw co vk cplw cprd cW wcel wa c1 cN cfz co vk cv vs cv cfv
      cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz
      co wral wi vs cX c1 cN cfz co cm co wral cR cvec wcel cpls cmus cop cring
      wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN
      cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a wa c1 cN cfz co cS1 cU
      cmw co vk cplw cprd cW wcel c1 cN cfz co cS2 cU cmw co vk cplw cprd cW
      wcel cN c1 cuz cfv wcel cplw cabl wcel cS1 cU cmw co cW wcel vk c1 cN cfz
      co wral c1 cN cfz co cS1 cU cmw co vk cplw cprd cW wcel cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a wa cS1 cU
      cmw co vk cplw c1 cN cW svli2.6 clfsebs5 cR cvec wcel cpls cmus cop cring
      wcel cN cn wcel w3a cN c1 cuz cfv wcel cU cW wcel vk c1 cN cfz co wral
      cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cN
      cn wcel cR cvec wcel cN c1 cuz cfv wcel cpls cmus cop cring wcel cN cn
      wcel cN c1 cuz cfv wcel cN elnnuz biimpi 3ad2ant3 adantr cR cvec wcel
      cpls cmus cop cring wcel cN cn wcel w3a cplw cabl wcel cU cW wcel vk c1
      cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz
      co wral w3a cR cvec wcel cpls cmus cop cring wcel cplw cabl wcel cN cn
      wcel cR cplw svli2.5 vecax1 3ad2ant1 adantr cR cvec wcel cpls cmus cop
      cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk
      c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS1 cU cmw co cW
      wcel vk c1 cN cfz co wral cR cvec wcel cpls cmus cop cring wcel cU cW
      wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk
      c1 cN cfz co wral w3a cS1 cU cmw co cW wcel vk c1 cN cfz co wral wi cN cn
      wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2
      cX wcel vk c1 cN cfz co wral w3a cR cvec wcel cS1 cU cmw co cW wcel vk c1
      cN cfz co wral cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz
      co wral cR cvec wcel cS1 cU cmw co cW wcel vk c1 cN cfz co wral wi cS2 cX
      wcel vk c1 cN cfz co wral cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk
      c1 cN cfz co wral wa cU cW wcel cS1 cX wcel wa vk c1 cN cfz co wral cR
      cvec wcel cS1 cU cmw co cW wcel vk c1 cN cfz co wral wi cU cW wcel cS1 cX
      wcel vk c1 cN cfz co r19.26 cR cvec wcel cU cW wcel cS1 cX wcel wa vk c1
      cN cfz co wral cS1 cU cmw co cW wcel vk c1 cN cfz co wral cR cvec wcel cU
      cW wcel cS1 cX wcel wa cS1 cU cmw co cW wcel vk c1 cN cfz co cU cW wcel
      cS1 cX wcel wa cR cvec wcel cS1 cU cmw co cW wcel cU cW wcel cS1 cX wcel
      cR cvec wcel cS1 cU cmw co cW wcel wi cR cvec wcel cS1 cX wcel cU cW wcel
      cS1 cU cmw co cW wcel cR cvec wcel cS1 cX wcel cU cW wcel cS1 cU cmw co
      cW wcel cS1 cR cU cW cX cpls cplw cmw svli2.5 svli2.8 svli2.6 svli2.1
      svli2.7 prodvs 3exp com13 imp com12 r19.20sdv com12 sylbir 3adant3 com12
      3ad2ant1 imp syl3anc cN c1 cuz cfv wcel cplw cabl wcel cS2 cU cmw co cW
      wcel vk c1 cN cfz co wral c1 cN cfz co cS2 cU cmw co vk cplw cprd cW wcel
      cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN
      cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co
      wral w3a wa cS2 cU cmw co vk cplw c1 cN cW svli2.6 clfsebs5 cR cvec wcel
      cpls cmus cop cring wcel cN cn wcel w3a cN c1 cuz cfv wcel cU cW wcel vk
      c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN
      cfz co wral w3a cN cn wcel cR cvec wcel cN c1 cuz cfv wcel cpls cmus cop
      cring wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi 3ad2ant3 adantr
      cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cplw cabl wcel cU cW
      wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk
      c1 cN cfz co wral w3a cR cvec wcel cpls cmus cop cring wcel cplw cabl
      wcel cN cn wcel cR cplw svli2.5 vecax1 3ad2ant1 adantr cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS2 cU cmw
      co cW wcel vk c1 cN cfz co wral cR cvec wcel cpls cmus cop cring wcel cU
      cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel
      vk c1 cN cfz co wral w3a cS2 cU cmw co cW wcel vk c1 cN cfz co wral wi cN
      cn wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral
      cS2 cX wcel vk c1 cN cfz co wral w3a cR cvec wcel cS2 cU cmw co cW wcel
      vk c1 cN cfz co wral cU cW wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN
      cfz co wral cR cvec wcel cS2 cU cmw co cW wcel vk c1 cN cfz co wral wi
      cS1 cX wcel vk c1 cN cfz co wral cU cW wcel vk c1 cN cfz co wral cS2 cX
      wcel vk c1 cN cfz co wral wa cU cW wcel cS2 cX wcel wa vk c1 cN cfz co
      wral cR cvec wcel cS2 cU cmw co cW wcel vk c1 cN cfz co wral wi cU cW
      wcel cS2 cX wcel vk c1 cN cfz co r19.26 cR cvec wcel cU cW wcel cS2 cX
      wcel wa vk c1 cN cfz co wral cS2 cU cmw co cW wcel vk c1 cN cfz co wral
      cR cvec wcel cU cW wcel cS2 cX wcel wa cS2 cU cmw co cW wcel vk c1 cN cfz
      co cU cW wcel cS2 cX wcel wa cR cvec wcel cS2 cU cmw co cW wcel cU cW
      wcel cS2 cX wcel cR cvec wcel cS2 cU cmw co cW wcel wi cR cvec wcel cS2
      cX wcel cU cW wcel cS2 cU cmw co cW wcel cR cvec wcel cS2 cX wcel cU cW
      wcel cS2 cU cmw co cW wcel cS2 cR cU cW cX cpls cplw cmw svli2.5 svli2.8
      svli2.6 svli2.1 svli2.7 prodvs 3exp com13 imp com12 r19.20sdv com12
      sylbir 3adant2 com12 3ad2ant1 imp syl3anc jca 3adant3 sylanc cR cvec wcel
      cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral
      cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1
      cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv
      cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral w3a
      c1 cN cfz co cS1 cU cmw co vk cplw cprd c1 cN cfz co cS2 cU cmw co vk
      cplw cprd cplw cgs cfv co c1 cN cfz co cS1 cU cmw co cS2 cU cmw co cplw
      cgs cfv co vk cplw cprd czerw cR cvec wcel cpls cmus cop cring wcel cN cn
      wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral
      cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw
      co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co
      wral wi vs cX c1 cN cfz co cm co wral w3a cN c1 cuz cfv wcel cS1 cU cmw
      co cW wcel cS2 cU cmw co cW wcel wa vk c1 cN cfz co wral cplw cabl wcel
      w3a c1 cN cfz co cS1 cU cmw co vk cplw cprd c1 cN cfz co cS2 cU cmw co vk
      cplw cprd cplw cgs cfv co c1 cN cfz co cS1 cU cmw co cS2 cU cmw co cplw
      cgs cfv co vk cplw cprd wceq cR cvec wcel cpls cmus cop cring wcel cN cn
      wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral
      cS2 cX wcel vk c1 cN cfz co wral w3a cN c1 cuz cfv wcel cS1 cU cmw co cW
      wcel cS2 cU cmw co cW wcel wa vk c1 cN cfz co wral cplw cabl wcel w3a c1
      cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv
      cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral cR
      cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz
      co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral
      w3a wa cN c1 cuz cfv wcel cS1 cU cmw co cW wcel cS2 cU cmw co cW wcel wa
      vk c1 cN cfz co wral cplw cabl wcel cR cvec wcel cpls cmus cop cring wcel
      cN cn wcel w3a cN c1 cuz cfv wcel cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cN cn wcel
      cR cvec wcel cN c1 cuz cfv wcel cpls cmus cop cring wcel cN cn wcel cN c1
      cuz cfv wcel cN elnnuz biimpi 3ad2ant3 adantr cS1 cU cmw co cW wcel cS2
      cU cmw co cW wcel wa vk c1 cN cfz co wral cS1 cU cmw co cW wcel vk c1 cN
      cfz co wral cS2 cU cmw co cW wcel vk c1 cN cfz co wral cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a wa cS1 cU
      cmw co cW wcel cS2 cU cmw co cW wcel vk c1 cN cfz co r19.26 cR cvec wcel
      cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral
      cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS1
      cU cmw co cW wcel vk c1 cN cfz co wral cR cvec wcel cpls cmus cop cring
      wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2
      cX wcel vk c1 cN cfz co wral w3a cS1 cU cmw co cW wcel vk c1 cN cfz co
      wral wi cN cn wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN
      cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cR cvec wcel cS1 cU cmw
      co cW wcel vk c1 cN cfz co wral cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cR cvec wcel cS1 cU cmw co cW wcel vk c1 cN cfz
      co wral wi cS2 cX wcel vk c1 cN cfz co wral cU cW wcel vk c1 cN cfz co
      wral cS1 cX wcel vk c1 cN cfz co wral wa cU cW wcel cS1 cX wcel wa vk c1
      cN cfz co wral cR cvec wcel cS1 cU cmw co cW wcel vk c1 cN cfz co wral wi
      cU cW wcel cS1 cX wcel vk c1 cN cfz co r19.26 cR cvec wcel cU cW wcel cS1
      cX wcel wa vk c1 cN cfz co wral cS1 cU cmw co cW wcel vk c1 cN cfz co
      wral cR cvec wcel cU cW wcel cS1 cX wcel wa cS1 cU cmw co cW wcel vk c1
      cN cfz co cU cW wcel cS1 cX wcel wa cR cvec wcel cS1 cU cmw co cW wcel cU
      cW wcel cS1 cX wcel cR cvec wcel cS1 cU cmw co cW wcel wi cR cvec wcel
      cS1 cX wcel cU cW wcel cS1 cU cmw co cW wcel cR cvec wcel cS1 cX wcel cU
      cW wcel cS1 cU cmw co cW wcel cS1 cR cU cW cX cpls cplw cmw svli2.5
      svli2.8 svli2.6 svli2.1 svli2.7 prodvs 3exp com13 imp com12 r19.20sdv
      com12 sylbir 3adant3 com12 3ad2ant1 imp cR cvec wcel cpls cmus cop cring
      wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN
      cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS2 cU cmw co cW wcel vk
      c1 cN cfz co wral cR cvec wcel cpls cmus cop cring wcel cU cW wcel vk c1
      cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz
      co wral w3a cS2 cU cmw co cW wcel vk c1 cN cfz co wral wi cN cn wcel cU
      cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel
      vk c1 cN cfz co wral w3a cR cvec wcel cS2 cU cmw co cW wcel vk c1 cN cfz
      co wral cU cW wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral
      cR cvec wcel cS2 cU cmw co cW wcel vk c1 cN cfz co wral wi cS1 cX wcel vk
      c1 cN cfz co wral cU cW wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN
      cfz co wral wa cU cW wcel cS2 cX wcel wa vk c1 cN cfz co wral cR cvec
      wcel cS2 cU cmw co cW wcel vk c1 cN cfz co wral wi cU cW wcel cS2 cX wcel
      vk c1 cN cfz co r19.26 cR cvec wcel cU cW wcel cS2 cX wcel wa vk c1 cN
      cfz co wral cS2 cU cmw co cW wcel vk c1 cN cfz co wral cR cvec wcel cU cW
      wcel cS2 cX wcel wa cS2 cU cmw co cW wcel vk c1 cN cfz co cU cW wcel cS2
      cX wcel wa cR cvec wcel cS2 cU cmw co cW wcel cU cW wcel cS2 cX wcel cR
      cvec wcel cS2 cU cmw co cW wcel wi cR cvec wcel cS2 cX wcel cU cW wcel
      cS2 cU cmw co cW wcel cR cvec wcel cS2 cX wcel cU cW wcel cS2 cU cmw co
      cW wcel cS2 cR cU cW cX cpls cplw cmw svli2.5 svli2.8 svli2.6 svli2.1
      svli2.7 prodvs 3exp com13 imp com12 r19.20sdv com12 sylbir 3adant2 com12
      3ad2ant1 imp sylanbrc cR cvec wcel cpls cmus cop cring wcel cN cn wcel
      w3a cplw cabl wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN
      cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cR cvec wcel cpls cmus
      cop cring wcel cplw cabl wcel cN cn wcel cR cplw svli2.5 vecax1 3ad2ant1
      adantr 3jca 3adant3 cN c1 cuz cfv wcel cS1 cU cmw co cW wcel cS2 cU cmw
      co cW wcel wa vk c1 cN cfz co wral cplw cabl wcel w3a c1 cN cfz co cS1 cU
      cmw co cS2 cU cmw co cplw cgs cfv co vk cplw cprd c1 cN cfz co cS1 cU cmw
      co vk cplw cprd c1 cN cfz co cS2 cU cmw co vk cplw cprd cplw cgs cfv co
      cS1 cU cmw co cS2 cU cmw co cplw cgs cfv vk cplw c1 cN cW svli2.6 cplw
      cgs cfv eqid fprodsub eqcomd syl eqeq1d cR cvec wcel cpls cmus cop cring
      wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN
      cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv
      cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN
      cfz co wral wi vs cX c1 cN cfz co cm co wral w3a c1 cN cfz co cS1 cU cmw
      co cS2 cU cmw co cplw cgs cfv co vk cplw cprd czerw wceq c1 cN cfz co cS1
      cS2 cpls cgs cfv co cU cmw co vk cplw cprd czerw wceq cS1 cS2 cpls cgs
      cfv co czert wceq vk c1 cN cfz co wral cS1 cS2 wceq vk c1 cN cfz co wral
      cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN
      cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co
      wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq
      vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm
      co wral w3a c1 cN cfz co cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co vk
      cplw cprd c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co vk cplw cprd
      czerw cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk
      c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN
      cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw
      wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz
      co cm co wral w3a cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co cS1 cS2
      cpls cgs cfv co cU cmw co wceq vk c1 cN cfz co wral c1 cN cfz co cS1 cU
      cmw co cS2 cU cmw co cplw cgs cfv co vk cplw cprd c1 cN cfz co cS1 cS2
      cpls cgs cfv co cU cmw co vk cplw cprd wceq cR cvec wcel cpls cmus cop
      cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk
      c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS1 cU cmw co cS2
      cU cmw co cplw cgs cfv co cS1 cS2 cpls cgs cfv co cU cmw co wceq vk c1 cN
      cfz co wral c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw
      wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz
      co cm co wral cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW
      wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk
      c1 cN cfz co wral w3a cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co cS1 cS2
      cpls cgs cfv co cU cmw co wceq vk c1 cN cfz co wral cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel cS1 cX wcel cS2 cX wcel w3a
      vk c1 cN cfz co wral cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co cS1 cS2
      cpls cgs cfv co cU cmw co wceq vk c1 cN cfz co wral cU cW wcel vk c1 cN
      cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co
      wral w3a cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel
      cS1 cX wcel cS2 cX wcel w3a cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co
      cS1 cS2 cpls cgs cfv co cU cmw co wceq vk c1 cN cfz co cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel cS1 cX wcel cS2 cX wcel w3a
      cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co cS1 cS2 cpls cgs cfv co cU
      cmw co wceq cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW
      wcel cS1 cX wcel cS2 cX wcel w3a wa cS1 cS2 cpls cgs cfv co cU cmw co cS1
      cU cmw co cS2 cU cmw co cplw cgs cfv co cR cvec wcel cpls cmus cop cring
      wcel cN cn wcel w3a cU cW wcel cS1 cX wcel cS2 cX wcel w3a cS1 cS2 cpls
      cgs cfv co cU cmw co cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co wceq cR
      cvec wcel cpls cmus cop cring wcel cU cW wcel cS1 cX wcel cS2 cX wcel w3a
      cS1 cS2 cpls cgs cfv co cU cmw co cS1 cU cmw co cS2 cU cmw co cplw cgs
      cfv co wceq wi cN cn wcel cS1 cS2 cR cU cW cX cpls cpls cgs cfv cmus cplw
      cplw cgs cfv cmw svli2.1 svli2.7 cpls cgs cfv eqid svli2.5 cplw cgs cfv
      eqid svli2.8 svli2.6 svli2.3 vecax5c 3adant3 imp eqcomd ex r19.20sdv cU
      cW wcel cS1 cX wcel cS2 cX wcel vk c1 cN cfz co r19.26t syl5ibr imp
      3adant3 c1 cN cfz co cS1 cU cmw co cS2 cU cmw co cplw cgs cfv co cS1 cS2
      cpls cgs cfv co cU cmw co cvv vk cplw cplw cR c2nd cfv c1st cfv cvv
      svli2.5 cR c2nd cfv c1st fvex eqeltri prodeq2 syl eqeq1d cR cvec wcel
      cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral
      cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1
      cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv
      cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral w3a
      vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab
      cX c1 cN cfz co cm co wcel c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co
      vk cplw cprd czerw wceq cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz
      co wral wb cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW
      wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk
      c1 cN cfz co wral w3a vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab cX c1 cN cfz co cm co wcel c1 cN cfz co vk cv vs
      cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1
      cN cfz co wral wi vs cX c1 cN cfz co cm co wral cR cvec wcel cpls cmus
      cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel
      vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a wa c1 cN cfz co
      cX vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy
      copab wf vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk
      vy copab cX c1 cN cfz co cm co wcel cR cvec wcel cpls cmus cop cring wcel
      cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz
      co wral cS2 cX wcel vk c1 cN cfz co wral w3a wa cS1 cS2 cpls cgs cfv co
      cX wcel vk c1 cN cfz co wral c1 cN cfz co cX vk cv c1 cN cfz co wcel vy
      cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab wf cR cvec wcel cpls cmus
      cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel
      vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS1 cS2 cpls
      cgs cfv co cX wcel vk c1 cN cfz co wral cpls cmus cop cring wcel cR cvec
      wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2
      cX wcel vk c1 cN cfz co wral w3a cS1 cS2 cpls cgs cfv co cX wcel vk c1 cN
      cfz co wral wi cN cn wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk
      c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cpls cgr wcel cS1
      cS2 cpls cgs cfv co cX wcel vk c1 cN cfz co wral cpls cmus cop cring wcel
      cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral cpls
      cgr wcel cS1 cS2 cpls cgs cfv co cX wcel vk c1 cN cfz co wral wi cU cW
      wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk
      c1 cN cfz co wral wa cS1 cX wcel cS2 cX wcel wa vk c1 cN cfz co wral cpls
      cgr wcel cS1 cS2 cpls cgs cfv co cX wcel vk c1 cN cfz co wral wi cS1 cX
      wcel cS2 cX wcel vk c1 cN cfz co r19.26 cpls cgr wcel cS1 cX wcel cS2 cX
      wcel wa vk c1 cN cfz co wral cS1 cS2 cpls cgs cfv co cX wcel vk c1 cN cfz
      co wral cpls cgr wcel cS1 cX wcel cS2 cX wcel wa cS1 cS2 cpls cgs cfv co
      cX wcel vk c1 cN cfz co cpls cgr wcel cS1 cX wcel cS2 cX wcel cS1 cS2
      cpls cgs cfv co cX wcel cS1 cS2 cpls cgs cfv cpls cX svli2.1 cpls cgs cfv
      eqid grpdivcl 3expib r19.20sdv com12 sylbir 3adant1 cpls cmus cop cpls
      cpls cmus cop c1st cfv cpls cpls cmus cpls cR c1st cfv c1st cfv cvv
      svli2.7 cR c1st cfv c1st fvex eqeltri op1st eqcomi ringgrp syl5com
      3ad2ant2 imp vk vy c1 cN cfz co cX cS1 cS2 cpls cgs cfv co vk cv c1 cN
      cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab vk cv c1 cN
      cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab eqid fopab2
      sylib cX c1 cN cfz co vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab cX cpls crn cvv svli2.1 cpls cpls cR c1st cfv c1st
      cfv cvv svli2.7 cR c1st cfv c1st fvex eqeltri rnex eqeltri c1 cN cfz
      oprex elmap sylibr 3adant3 cR cvec wcel cpls cmus cop cring wcel cN cn
      wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral
      cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw
      co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co
      wral wi vs cX c1 cN cfz co cm co wral w3a vk cv c1 cN cfz co wcel vy cv
      cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX c1 cN cfz co cm co wcel wa
      c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co vk cplw cprd czerw wceq
      cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz
      co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv
      czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral w3a vk
      cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX
      c1 cN cfz co cm co wcel c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co vk
      cplw cprd czerw wceq cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co
      wral wi c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk
      cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co
      wral cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a vk cv c1 cN cfz
      co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX c1 cN cfz co
      cm co wcel c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co vk cplw cprd
      czerw wceq cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral wi wi
      cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX
      wcel vk c1 cN cfz co wral w3a vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls
      cgs cfv co wceq wa vk vy copab cX c1 cN cfz co cm co wcel c1 cN cfz co vk
      cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq
      vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral c1 cN cfz co cS1
      cS2 cpls cgs cfv co cU cmw co vk cplw cprd czerw wceq cS1 cS2 cpls cgs
      cfv co czert wceq vk c1 cN cfz co wral wi c1 cN cfz co vk cv vs cv cfv cU
      cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co
      wral wi c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co vk cplw cprd czerw
      wceq cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral wi vs vk cv
      c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX c1
      cN cfz co cm co vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab wceq c1 cN cfz co vk cv vs cv cfv cU cmw co vk
      cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi
      c1 cN cfz co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co
      wceq wa vk vy copab cfv cU cmw co vk cplw cprd czerw wceq vk cv vk cv c1
      cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv
      czert wceq vk c1 cN cfz co wral wi c1 cN cfz co cS1 cS2 cpls cgs cfv co
      cU cmw co vk cplw cprd czerw wceq cS1 cS2 cpls cgs cfv co czert wceq vk
      c1 cN cfz co wral wi vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs
      cfv co wceq wa vk vy copab wceq c1 cN cfz co vk cv vs cv cfv cU cmw co vk
      cplw cprd czerw wceq c1 cN cfz co vk cv vk cv c1 cN cfz co wcel vy cv cS1
      cS2 cpls cgs cfv co wceq wa vk vy copab cfv cU cmw co vk cplw cprd czerw
      wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral vk cv vk cv c1 cN
      cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv czert
      wceq vk c1 cN cfz co wral vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2
      cpls cgs cfv co wceq wa vk vy copab wceq c1 cN cfz co vk cv vs cv cfv cU
      cmw co vk cplw cprd c1 cN cfz co vk cv vk cv c1 cN cfz co wcel vy cv cS1
      cS2 cpls cgs cfv co wceq wa vk vy copab cfv cU cmw co vk cplw cprd czerw
      vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy
      copab wceq vk cv vs cv cfv cU cmw co vk cv vk cv c1 cN cfz co wcel vy cv
      cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv cU cmw co wceq vk c1 cN
      cfz co wral c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd c1 cN cfz
      co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk
      vy copab cfv cU cmw co vk cplw cprd wceq vs cv vk cv c1 cN cfz co wcel vy
      cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab wceq vk cv vs cv cfv cU
      cmw co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq
      wa vk vy copab cfv cU cmw co wceq vk c1 cN cfz co vk vu vu vs cv vk cv c1
      cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab vu vs
      wel vk ax-17 vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq
      wa vk vy vu hbopab1 hbeq vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls
      cgs cfv co wceq wa vk vy copab wceq vk cv vs cv cfv cU cmw co vk cv vk cv
      c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv
      cU cmw co wceq vk cv c1 cN cfz co wcel vs cv vk cv c1 cN cfz co wcel vy
      cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab wceq vk cv vs cv cfv vk cv
      vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab
      cfv cU cmw vk cv vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab fveq1 opreq1d a1d r19.21ai c1 cN cfz co vk cv vs
      cv cfv cU cmw co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab cfv cU cmw co cvv vk cplw cplw cR c2nd cfv c1st
      cfv cvv svli2.5 cR c2nd cfv c1st fvex eqeltri prodeq2 syl eqeq1d vs cv vk
      cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab
      wceq vk cv vs cv cfv czert wceq vk cv vk cv c1 cN cfz co wcel vy cv cS1
      cS2 cpls cgs cfv co wceq wa vk vy copab cfv czert wceq vk c1 cN cfz co vk
      vu vu vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa
      vk vy copab vu vs wel vk ax-17 vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls
      cgs cfv co wceq wa vk vy vu hbopab1 hbeq vs cv vk cv c1 cN cfz co wcel vy
      cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab wceq vk cv vs cv cfv vk cv
      vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab
      cfv czert vk cv vs cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab fveq1 eqeq1d ralbid imbi12d c1 cN cfz co vk cv vk
      cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab
      cfv cU cmw co vk cplw cprd czerw wceq c1 cN cfz co cS1 cS2 cpls cgs cfv
      co cU cmw co vk cplw cprd czerw wceq vk cv vk cv c1 cN cfz co wcel vy cv
      cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv czert wceq vk c1 cN cfz
      co wral cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral c1 cN cfz
      co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk
      vy copab cfv cU cmw co vk cplw cprd c1 cN cfz co cS1 cS2 cpls cgs cfv co
      cU cmw co vk cplw cprd czerw vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2
      cpls cgs cfv co wceq wa vk vy copab cfv cU cmw co cS1 cS2 cpls cgs cfv co
      cU cmw co wceq c1 cN cfz co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2
      cpls cgs cfv co wceq wa vk vy copab cfv cU cmw co vk cplw cprd c1 cN cfz
      co cS1 cS2 cpls cgs cfv co cU cmw co vk cplw cprd wceq vk c1 cN cfz co c1
      cN cfz co vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co
      wceq wa vk vy copab cfv cU cmw co cS1 cS2 cpls cgs cfv co cU cmw co cvv
      vk cplw cplw cR c2nd cfv c1st cfv cvv svli2.5 cR c2nd cfv c1st fvex
      eqeltri prodeq2 vk cv c1 cN cfz co wcel vk cv vk cv c1 cN cfz co wcel vy
      cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv cS1 cS2 cpls cgs cfv
      co cU cmw vk cv c1 cN cfz co wcel cS1 cS2 cpls cgs cfv co cvv wcel vk cv
      vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab
      cfv cS1 cS2 cpls cgs cfv co wceq cS1 cS2 cpls cgs cfv oprex vk vy c1 cN
      cfz co cS1 cS2 cpls cgs cfv co cvv fvopab2 mpan2 opreq1d mprg eqeq1i vk
      cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy
      copab cfv czert wceq cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co
      vk cv c1 cN cfz co wcel vk cv vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls
      cgs cfv co wceq wa vk vy copab cfv cS1 cS2 cpls cgs cfv co czert vk cv c1
      cN cfz co wcel cS1 cS2 cpls cgs cfv co cvv wcel vk cv vk cv c1 cN cfz co
      wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cfv cS1 cS2 cpls
      cgs cfv co wceq cS1 cS2 cpls cgs cfv oprex vk vy c1 cN cfz co cS1 cS2
      cpls cgs cfv co cvv fvopab2 mpan2 eqeq1d ralbiia imbi12i syl6bb rcla4v
      com12 3ad2ant3 imp cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a
      cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX
      wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw co vk
      cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi
      vs cX c1 cN cfz co cm co wral w3a vk cv c1 cN cfz co wcel vy cv cS1 cS2
      cpls cgs cfv co wceq wa vk vy copab cX c1 cN cfz co cm co wcel wa cS1 cS2
      cpls cgs cfv co czert wceq vk c1 cN cfz co wral c1 cN cfz co cS1 cS2 cpls
      cgs cfv co cU cmw co vk cplw cprd czerw wceq cR cvec wcel cpls cmus cop
      cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk
      c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv
      vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk
      c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral w3a vk cv c1 cN cfz co
      wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX c1 cN cfz co cm
      co wcel wa cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral wa c1
      cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co vk cplw cprd c1 cN cfz co
      czert cU cmw co vk cplw cprd c1 cN cfz co czerw vk cplw cprd czerw cS1
      cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral c1 cN cfz co cS1 cS2
      cpls cgs cfv co cU cmw co vk cplw cprd c1 cN cfz co czert cU cmw co vk
      cplw cprd wceq cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW
      wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk
      c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd
      czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN
      cfz co cm co wral w3a vk cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv
      co wceq wa vk vy copab cX c1 cN cfz co cm co wcel wa cS1 cS2 cpls cgs cfv
      co czert wceq vk c1 cN cfz co wral cS1 cS2 cpls cgs cfv co cU cmw co
      czert cU cmw co wceq vk c1 cN cfz co wral c1 cN cfz co cS1 cS2 cpls cgs
      cfv co cU cmw co vk cplw cprd c1 cN cfz co czert cU cmw co vk cplw cprd
      wceq cS1 cS2 cpls cgs cfv co czert wceq cS1 cS2 cpls cgs cfv co cU cmw co
      czert cU cmw co wceq vk c1 cN cfz co cS1 cS2 cpls cgs cfv co czert cU cmw
      opreq1 r19.20si c1 cN cfz co cS1 cS2 cpls cgs cfv co cU cmw co czert cU
      cmw co cvv vk cplw cplw cR c2nd cfv c1st cfv cvv svli2.5 cR c2nd cfv c1st
      fvex eqeltri prodeq2 syl adantl cR cvec wcel cpls cmus cop cring wcel cN
      cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co
      wral cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU
      cmw co vk cplw cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co
      wral wi vs cX c1 cN cfz co cm co wral w3a c1 cN cfz co czert cU cmw co vk
      cplw cprd c1 cN cfz co czerw vk cplw cprd wceq vk cv c1 cN cfz co wcel vy
      cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX c1 cN cfz co cm co wcel
      cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral cR cvec wcel cpls
      cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a c1 cN cfz
      co czert cU cmw co vk cplw cprd c1 cN cfz co czerw vk cplw cprd wceq c1
      cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv
      cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral cR
      cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz
      co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral
      w3a wa czert cU cmw co czerw wceq vk c1 cN cfz co wral c1 cN cfz co czert
      cU cmw co vk cplw cprd c1 cN cfz co czerw vk cplw cprd wceq cR cvec wcel
      cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral
      cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a
      czert cU cmw co czerw wceq vk c1 cN cfz co wral cR cvec wcel cpls cmus
      cop cring wcel cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz
      co wral cS2 cX wcel vk c1 cN cfz co wral w3a czert cU cmw co czerw wceq
      vk c1 cN cfz co wral wi cN cn wcel cU cW wcel vk c1 cN cfz co wral cS1 cX
      wcel vk c1 cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cR cvec
      wcel cpls cmus cop cring wcel wa czert cU cmw co czerw wceq vk c1 cN cfz
      co wral cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral
      cR cvec wcel cpls cmus cop cring wcel wa czert cU cmw co czerw wceq vk c1
      cN cfz co wral wi cS2 cX wcel vk c1 cN cfz co wral cR cvec wcel cpls cmus
      cop cring wcel wa cU cW wcel vk c1 cN cfz co wral czert cU cmw co czerw
      wceq vk c1 cN cfz co wral cR cvec wcel cpls cmus cop cring wcel wa cU cW
      wcel czert cU cmw co czerw wceq vk c1 cN cfz co cR cvec wcel cpls cmus
      cop cring wcel cU cW wcel czert cU cmw co czerw wceq cR cU cW cpls cmus
      czert cmw czerw cW cplw crn cR c2nd cfv c1st cfv crn svli2.6 cplw cR c2nd
      cfv c1st cfv svli2.5 rneqi eqtri svli2.2 svli2.7 svli2.3 svli2.8 czerw
      cplw cgi cfv cR c2nd cfv c1st cfv cgi cfv svli2.4 cplw cR c2nd cfv c1st
      cfv cgi svli2.5 fveq2i eqtri mulveczer 3expia r19.20sdv com12 3ad2ant1
      com12 3adant3 imp c1 cN cfz co czert cU cmw co czerw cvv vk cplw cplw cR
      c2nd cfv c1st cfv cvv svli2.5 cR c2nd cfv c1st fvex eqeltri prodeq2 syl
      3adant3 ad2antrr cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU
      cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel
      vk c1 cN cfz co wral w3a c1 cN cfz co vk cv vs cv cfv cU cmw co vk cplw
      cprd czerw wceq vk cv vs cv cfv czert wceq vk c1 cN cfz co wral wi vs cX
      c1 cN cfz co cm co wral w3a c1 cN cfz co czerw vk cplw cprd czerw wceq vk
      cv c1 cN cfz co wcel vy cv cS1 cS2 cpls cgs cfv co wceq wa vk vy copab cX
      c1 cN cfz co cm co wcel cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz
      co wral cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a cU cW wcel
      vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel vk c1
      cN cfz co wral w3a c1 cN cfz co czerw vk cplw cprd czerw wceq c1 cN cfz
      co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv cfv
      czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral cN c1
      cuz cfv wcel cplw cmagm cexid cin wcel c1 cN cfz co czerw vk cplw cprd
      czerw wceq cR cvec wcel cpls cmus cop cring wcel cN cn wcel w3a czerw vk
      cplw c1 cN svli2.4 fincmpzer cN cn wcel cR cvec wcel cN c1 cuz cfv wcel
      cpls cmus cop cring wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi
      3ad2ant3 cR cvec wcel cpls cmus cop cring wcel cplw cmagm cexid cin wcel
      cN cn wcel cR cvec wcel cplw cabl wcel cplw cmnd wcel cplw cmagm cexid
      cin wcel cR cplw svli2.5 vecax1 cplw cabl wcel cplw cgr wcel cplw cmnd
      wcel cplw ablgrp cplw grpmnd syl cplw mndmgmid 3syl 3ad2ant1 sylanc
      3ad2ant1 ad2antrr 3eqtrd ex impbid mpdan cR cvec wcel cpls cmus cop cring
      wcel cN cn wcel w3a cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN
      cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cS1 cS2 cpls cgs cfv co
      czert wceq vk c1 cN cfz co wral cS1 cS2 wceq vk c1 cN cfz co wral wb c1
      cN cfz co vk cv vs cv cfv cU cmw co vk cplw cprd czerw wceq vk cv vs cv
      cfv czert wceq vk c1 cN cfz co wral wi vs cX c1 cN cfz co cm co wral cU
      cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1 cN cfz co wral cS2 cX wcel
      vk c1 cN cfz co wral w3a cR cvec wcel cpls cmus cop cring wcel cN cn wcel
      w3a cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral cS1 cS2 wceq
      vk c1 cN cfz co wral wb cU cW wcel vk c1 cN cfz co wral cS1 cX wcel vk c1
      cN cfz co wral cS2 cX wcel vk c1 cN cfz co wral w3a cU cW wcel cS1 cX
      wcel cS2 cX wcel w3a vk c1 cN cfz co wral cR cvec wcel cpls cmus cop
      cring wcel cN cn wcel w3a cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz
      co wral cS1 cS2 wceq vk c1 cN cfz co wral wb wi cU cW wcel cS1 cX wcel
      cS2 cX wcel vk c1 cN cfz co r19.26t cR cvec wcel cpls cmus cop cring wcel
      cN cn wcel w3a cU cW wcel cS1 cX wcel cS2 cX wcel w3a vk c1 cN cfz co
      wral cS1 cS2 cpls cgs cfv co czert wceq cS1 cS2 wceq wb vk c1 cN cfz co
      wral cS1 cS2 cpls cgs cfv co czert wceq vk c1 cN cfz co wral cS1 cS2 wceq
      vk c1 cN cfz co wral wb cpls cmus cop cring wcel cR cvec wcel cU cW wcel
      cS1 cX wcel cS2 cX wcel w3a vk c1 cN cfz co wral cS1 cS2 cpls cgs cfv co
      czert wceq cS1 cS2 wceq wb vk c1 cN cfz co wral wi cN cn wcel cpls cmus
      cop cring wcel cpls cgr wcel cU cW wcel cS1 cX wcel cS2 cX wcel w3a vk c1
      cN cfz co wral cS1 cS2 cpls cgs cfv co czert wceq cS1 cS2 wceq wb vk c1
      cN cfz co wral wi cpls cmus cop cpls cpls cmus cop c1st cfv cpls cpls
      cmus cpls cR c1st cfv c1st cfv cvv svli2.7 cR c1st cfv c1st fvex eqeltri
      op1st eqcomi ringgrp cpls cgr wcel cU cW wcel cS1 cX wcel cS2 cX wcel w3a
      cS1 cS2 cpls cgs cfv co czert wceq cS1 cS2 wceq wb vk c1 cN cfz co cU cW
      wcel cS1 cX wcel cS2 cX wcel w3a cpls cgr wcel cS1 cS2 cpls cgs cfv co
      czert wceq cS1 cS2 wceq wb cS1 cX wcel cS2 cX wcel cpls cgr wcel cS1 cS2
      cpls cgs cfv co czert wceq cS1 cS2 wceq wb wi cU cW wcel cS1 cX wcel cS2
      cX wcel cpls cgr wcel cS1 cS2 cpls cgs cfv co czert wceq cS1 cS2 wceq wb
      wi cpls cgr wcel cS1 cX wcel cS2 cX wcel cS1 cS2 cpls cgs cfv co czert
      wceq cS1 cS2 wceq wb cpls cgr wcel cS1 cX wcel cS2 cX wcel cS1 cS2 cpls
      cgs cfv co czert wceq cS1 cS2 wceq wb cS1 cS2 cpls cgs cfv czert cpls cX
      svli2.1 svli2.2 cpls cgs cfv eqid grpdivzer 3exp com3l imp 3adant1 com12
      r19.20sdv syl 3ad2ant2 cS1 cS2 cpls cgs cfv co czert wceq cS1 cS2 wceq vk
      c1 cN cfz co r19.15 syl6com sylbir impcom 3adant3 3bitrd 3bitrd $.
      $( [6-Dec-2010] $) $( [9-Nov-2010] $)
  $}

  $c SubVec $.

  $( Extend class notation with the class of all generic subspace
     vector spaces and modules. $)
  csvec $a class SubVec $.

  ${ $d x y v w $.
     $( A sub-vector space ` v ` of a vector space ` x ` is a vector space
        that has the same scalar set than ` x `.  $)
     df-svs $a |- SubVec = { <. x , y >. | ( x e. Vec /\
       y = { v e. Vec | ( ( 1st ` v ) = ( 1st ` x ) /\
       ( 1st ` ( 2nd ` v ) ) C_ ( 1st ` ( 2nd ` x ) ) /\
       ( 2nd ` ( 2nd ` v ) ) = ( ( 2nd ` ( 2nd ` x ) ) |`
          ( ran ( 1st ` ( 1st ` x ) ) X. ran ( 1st ` ( 2nd ` v ) ) ) ) ) } ) }
       $.

     $( A textbook definition. A sub-vector space is a subset that is
        itself a vector space under the inherited operations. $)
     svs2 $p |- SubVec = { <. x , y >. | ( x e. Vec /\
       y = { v e. Vec | ( ( 1st ` v ) = ( 1st ` x ) /\
         E. w e. ~P ran ( 1st ` ( 2nd ` x ) )
         ( ( 1st ` ( 2nd ` v ) ) = ( ( 1st ` ( 2nd ` x ) ) |` ( w X. w ) ) /\
           ( 2nd ` ( 2nd ` v ) ) = ( ( 2nd ` ( 2nd ` x ) ) |`
             ( ran ( 1st ` ( 1st ` x ) ) X. w ) ) ) ) } ) } $=
       csvec vx cv cvec wcel vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq w3a vv cvec crab wceq wa vx vy copab vx cv cvec wcel
       vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq wa
       vw vx cv c2nd cfv c1st cfv crn cpw wrex wa vv cvec crab wceq wa vx vy
       copab vx vy vv df-svs vx cv cvec wcel vy cv vv cv c1st cfv vx cv c1st
       cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd
       cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp cres wceq w3a vv cvec crab wceq wa vx cv cvec
       wcel vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv
       vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq
       wa vw vx cv c2nd cfv c1st cfv crn cpw wrex wa vv cvec crab wceq wa vx vy
       vx cv cvec wcel vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd
       cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq w3a vv cvec crab wceq vy cv vv cv c1st cfv vx cv c1st cfv wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres
       wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st
       cfv crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex
       wa vv cvec crab wceq vx cv cvec wcel vv cv c1st cfv vx cv c1st cfv wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd
       cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp cres wceq w3a vv cvec crab vv cv c1st cfv vx cv c1st
       cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv
       c1st cfv crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw
       wrex wa vv cvec crab vy cv vx cv cvec wcel vv cv c1st cfv vx cv c1st cfv
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv
       c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd
       cfv c1st cfv crn cxp cres wceq w3a vv cv c1st cfv vx cv c1st cfv wceq vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq
       vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex wa vv
       cvec vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv
       c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd
       cfv c1st cfv crn cxp cres wceq wa wa vv cv c1st cfv vx cv c1st cfv wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres
       wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st
       cfv crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex
       wa vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq w3a vx
       cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw
       cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv
       vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq wa vw vx cv c2nd cfv
       c1st cfv crn cpw wrex vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv
       vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wa vv cv c2nd cfv c1st
       cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv
       c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp
       cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex vv cv c2nd cfv c1st
       cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv
       c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq wa vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv
       c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx
       cv c1st cfv c1st cfv crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st
       cfv crn cpw wrex vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv
       cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn
       vv cv c2nd cfv c1st cfv crn cxp cres wceq vx cv cvec wcel vv cv cvec
       wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv
       vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq
       wa vw vx cv c2nd cfv c1st cfv crn cpw wrex wi vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv
       vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vx
       cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq
       vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex wi wi
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c1st
       cfv crn vx cv c2nd cfv c1st cfv crn wss vv cv c2nd cfv c1st cfv crn vx
       cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vx cv cvec
       wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw
       cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex wi wi wi vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv rnss vv cv c2nd cfv c1st
       cfv crn vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv c1st cfv crn
       vx cv c2nd cfv c1st cfv crn wss vv cv c2nd cfv c1st cfv crn vx cv c2nd
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv vv cv c2nd cfv c1st fvex rnex
       elpw biimpri vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv
       c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv
       cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn
       vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv c2nd cfv c1st cfv crn vx
       cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd
       cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq wa vw vx cv
       c2nd cfv c1st cfv crn cpw wrex vx cv cvec wcel vv cv cvec wcel wa vv cv
       c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv c2nd
       cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd
       cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv
       cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex wi vv cv c2nd
       cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd
       cfv c1st cfv crn cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv
       c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vw cv cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn
       cpw wrex vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st
       cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv
       cv c2nd cfv c1st cfv crn cxp cres wceq w3a vv cv c2nd cfv c1st cfv crn
       vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv
       c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wa vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd
       cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv
       cxp cres wceq wa vw vx cv c2nd cfv c1st cfv crn cpw wrex vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd
       cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv
       cxp cres wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vv cv
       c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv
       cv c2nd cfv c1st cfv crn cxp cres wceq wa vw vv cv c2nd cfv c1st cfv crn
       vx cv c2nd cfv c1st cfv crn cpw vw cv vv cv c2nd cfv c1st cfv crn wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv c2nd cfv c2nd
       cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres
       wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vw cv vv cv c2nd cfv
       c1st cfv crn wceq vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres vx cv
       c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres vv cv c2nd cfv c1st cfv vw cv vv cv c2nd cfv c1st cfv crn
       wceq vw cv vw cv cxp vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp wceq vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres vx cv c2nd cfv
       c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq vw cv vv cv c2nd cfv c1st cfv crn wceq vw cv vw cv cxp vv cv
       c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp wceq vw cv vv cv
       c2nd cfv c1st cfv crn vw cv vv cv c2nd cfv c1st cfv crn xpeq12 anidms vw
       cv vw cv cxp vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       vx cv c2nd cfv c1st cfv reseq2 syl eqeq2d vw cv vv cv c2nd cfv c1st cfv
       crn wceq vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp
       cres vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp cres vv cv c2nd cfv c2nd cfv vw cv vv cv c2nd cfv c1st
       cfv crn wceq vx cv c1st cfv c1st cfv crn vw cv cxp vx cv c1st cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp wceq vx cv c2nd cfv c2nd cfv vx
       cv c1st cfv c1st cfv crn vw cv cxp cres vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vw cv vv
       cv c2nd cfv c1st cfv crn vx cv c1st cfv c1st cfv crn xpeq2 vx cv c1st
       cfv c1st cfv crn vw cv cxp vx cv c1st cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp vx cv c2nd cfv c2nd cfv reseq2 syl eqeq2d anbi12d
       rcla4ev ex vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st
       cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv
       cv c2nd cfv c1st cfv crn cxp cres wceq w3a vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vx cv
       cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vx cv
       cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq vx cv cvec wcel vv cv cvec wcel wa vv cv c2nd cfv c1st
       cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq wi vv cv c1st cfv vx cv c1st cfv wceq vx cv cvec wcel vv cv
       cvec wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp cres wceq wi vx cv cvec wcel vx cv c2nd cfv
       c1st cfv cabl wcel vx cv c2nd cfv c1st cfv cgr wcel vv cv cvec wcel vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c1st cfv
       vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st
       cfv crn cxp cres wceq wi wi vx cv vx cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv eqid vecax1 vx cv c2nd cfv c1st cfv ablgrp vx cv c2nd cfv c1st
       cfv cgr wcel vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp
       vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv wfo vx cv c2nd cfv
       c1st cfv wfun vv cv cvec wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wi wi vx cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv
       crn eqid grpfo vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn
       cxp vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv fofun vx cv c2nd
       cfv c1st cfv wfun vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vx
       cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres vv cv c2nd cfv
       c1st cfv wceq vv cv cvec wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq vx cv c2nd cfv c1st cfv wfun vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv wss vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv
       cdm cres vv cv c2nd cfv c1st cfv wceq vx cv c2nd cfv c1st cfv vv cv c2nd
       cfv c1st cfv funssres ex vv cv cvec wcel vv cv c2nd cfv c1st cfv cabl
       wcel vv cv c2nd cfv c1st cfv cgr wcel vx cv c2nd cfv c1st cfv vv cv c2nd
       cfv c1st cfv cdm cres vv cv c2nd cfv c1st cfv wceq vv cv c2nd cfv c1st
       cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp cres wceq wi vv cv vv cv c2nd cfv c1st cfv vv cv c2nd
       cfv c1st cfv eqid vecax1 vv cv c2nd cfv c1st cfv ablgrp vv cv c2nd cfv
       c1st cfv cgr wcel vv cv c2nd cfv c1st cfv cdm vv cv c2nd cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp wceq vx cv c2nd cfv c1st cfv vv cv
       c2nd cfv c1st cfv cdm cres vv cv c2nd cfv c1st cfv wceq vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd
       cfv c1st cfv crn cxp cres wceq wi vv cv c2nd cfv c1st cfv dmrngrp vv cv
       c2nd cfv c1st cfv cdm vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st
       cfv crn cxp wceq vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm
       cres vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp cres wceq vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st
       cfv cdm cres vv cv c2nd cfv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq wi vv cv c2nd cfv c1st cfv cdm vv cv c2nd cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp vx cv c2nd cfv c1st cfv reseq2 vx cv
       c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres vv cv c2nd cfv c1st
       cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv
       c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wi vx cv c2nd cfv
       c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres vx cv c2nd
       cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres wceq vx cv
       c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres vv cv c2nd cfv c1st
       cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vv cv c2nd cfv
       c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vx cv c2nd cfv
       c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres wceq vx cv
       c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres vv cv c2nd cfv c1st
       cfv wceq wa vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp cres vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres vx cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv cdm cres vv cv c2nd
       cfv c1st cfv eqtr eqcomd ex eqcoms syl syl 3syl syl9 3syl 3syl imp
       adantr imp 3adant3 vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx
       cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss
       vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp cres wceq 3simp3 jca syl5com 3exp
       com14 3syl pm2.43i imp com12 vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st
       cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv
       c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq wa vw vx cv
       c2nd cfv c1st cfv crn cpw wrex vx cv cvec wcel vv cv cvec wcel wa vv cv
       c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wa vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw
       cv cxp cres wceq wa vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx
       cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss
       vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wa wi vw vx cv c2nd cfv
       c1st cfv crn cpw vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw
       cv cxp cres wceq wa vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx
       cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss
       vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wa vw cv vx cv c2nd cfv
       c1st cfv crn cpw wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw
       cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv
       vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq wa vx cv cvec wcel vv cv
       cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa w3a vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd
       cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vw cv cxp cres wceq wa vw cv vx cv c2nd cfv c1st cfv
       crn cpw wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vx cv
       cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv
       vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp cres vx cv c2nd cfv c1st cfv wss vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp resss vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp cres vx cv c2nd cfv c1st cfv sseq1 mpbiri
       adantr 3ad2ant2 vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw
       cv cxp cres wceq wa vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx
       cv c1st cfv wceq wa vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx
       cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv
       cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn
       vw cv cxp cres wceq wa vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vx cv
       cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv
       cv c2nd cfv c1st cfv crn cxp cres wceq wi vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq vw
       cv vx cv c2nd cfv c1st cfv crn cpw wcel vx cv cvec wcel vv cv cvec wcel
       wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c2nd cfv vx cv
       c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq wi wi vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       vw cv vw cv cxp cres wceq vx cv cvec wcel vv cv cvec wcel wa vv cv c1st
       cfv vx cv c1st cfv wceq wa vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vv
       cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn
       vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx
       cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vx
       cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vw
       cv vx cv c2nd cfv c1st cfv crn cpw wcel vv cv c2nd cfv c2nd cfv vx cv
       c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres wceq vv cv
       c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv
       cv c2nd cfv c1st cfv crn cxp cres wceq wi vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vx cv cvec wcel vv cv cvec
       wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vw cv vx cv c2nd cfv c1st
       cfv crn cpw wcel w3a vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx
       cv c1st cfv c1st cfv crn vw cv cxp cres wceq vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres wceq vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx
       cv c1st cfv wceq wa vw cv vx cv c2nd cfv c1st cfv crn cpw wcel w3a vx cv
       c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vw cv cxp cres vx cv c2nd
       cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres vv cv c2nd cfv c2nd cfv vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st
       cfv vw cv vw cv cxp cres wceq vx cv cvec wcel vv cv cvec wcel wa vv cv
       c1st cfv vx cv c1st cfv wceq wa vw cv vx cv c2nd cfv c1st cfv crn cpw
       wcel w3a vx cv c1st cfv c1st cfv crn vw cv cxp vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp wceq vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vw cv cxp cres vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vx cv
       cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vw cv
       vx cv c2nd cfv c1st cfv crn cpw wcel w3a vw cv vv cv c2nd cfv c1st cfv
       crn wceq vx cv c1st cfv c1st cfv crn vw cv cxp vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vx cv cvec wcel vv cv cvec
       wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vw cv vx cv c2nd cfv c1st
       cfv crn cpw wcel vw cv vv cv c2nd cfv c1st cfv crn wceq vx cv cvec wcel
       vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vw cv vx cv
       c2nd cfv c1st cfv crn cpw wcel vw cv vv cv c2nd cfv c1st cfv crn wceq wi
       vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq
       vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw cv vv cv c2nd cfv c1st cfv
       crn wceq wi wi vv cv cvec wcel vx cv cvec wcel vv cv c1st cfv vx cv c1st
       cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw cv vv cv c2nd
       cfv c1st cfv crn wceq wi wi wi vv cv cvec wcel vx cv cvec wcel vv cv
       c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st
       cfv vw cv vw cv cxp cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel
       vw cv vv cv c2nd cfv c1st cfv crn wceq wi wi wi wi vv cv cvec wcel vv cv
       c2nd cfv c1st cfv cabl wcel vv cv c2nd cfv c1st cfv cgr wcel vv cv cvec
       wcel vx cv cvec wcel vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vw cv vx cv
       c2nd cfv c1st cfv crn cpw wcel vw cv vv cv c2nd cfv c1st cfv crn wceq wi
       wi wi wi wi vv cv vv cv c2nd cfv c1st cfv vv cv c2nd cfv c1st cfv eqid
       vecax1 vv cv c2nd cfv c1st cfv ablgrp vv cv c2nd cfv c1st cfv cgr wcel
       vv cv c2nd cfv c1st cfv cdm vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp wceq vv cv cvec wcel vx cv cvec wcel vv cv c1st cfv vx
       cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw cv vv
       cv c2nd cfv c1st cfv crn wceq wi wi wi wi wi vv cv c2nd cfv c1st cfv
       dmrngrp vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn vv
       cv c2nd cfv c1st cfv crn cxp cdm wceq vv cv c2nd cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp cdm vv cv c2nd cfv c1st cfv crn wceq vv cv
       cvec wcel vx cv cvec wcel vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vw cv vx
       cv c2nd cfv c1st cfv crn cpw wcel vw cv vv cv c2nd cfv c1st cfv crn wceq
       wi wi wi wi wi vv cv c2nd cfv c1st cfv cdm vv cv c2nd cfv c1st cfv crn
       vv cv c2nd cfv c1st cfv crn cxp wceq vv cv c2nd cfv c1st cfv cdm cdm vv
       cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cdm wceq vv cv
       c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cdm vv cv c2nd cfv
       c1st cfv crn wceq wa vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st
       cfv crn wceq vv cv cvec wcel vx cv cvec wcel vv cv c1st cfv vx cv c1st
       cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw cv vv cv c2nd
       cfv c1st cfv crn wceq wi wi wi wi wi vv cv c2nd cfv c1st cfv cdm cdm vv
       cv c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cdm vv cv c2nd
       cfv c1st cfv crn eqtr vx cv cvec wcel vv cv cvec wcel vv cv c2nd cfv
       c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv c1st cfv vx cv
       c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw
       cv cxp cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw cv vv cv
       c2nd cfv c1st cfv crn wceq wi wi wi vx cv cvec wcel vx cv c2nd cfv c1st
       cfv cabl wcel vx cv c2nd cfv c1st cfv cgr wcel vv cv cvec wcel vv cv
       c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv c1st
       cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       vw cv vw cv cxp cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw
       cv vv cv c2nd cfv c1st cfv crn wceq wi wi wi wi wi vx cv vx cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv eqid vecax1 vx cv c2nd cfv c1st cfv
       ablgrp vx cv c2nd cfv c1st cfv cgr wcel vx cv c2nd cfv c1st cfv cdm vx
       cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wceq vv cv cvec
       wcel vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv
       cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw
       wcel vw cv vv cv c2nd cfv c1st cfv crn wceq wi wi wi wi wi vx cv c2nd
       cfv c1st cfv dmrngrp vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv c1st cfv
       crn vx cv c2nd cfv c1st cfv crn cxp wceq vv cv cvec wcel vv cv c2nd cfv
       c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv c1st cfv vx cv
       c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw
       cv cxp cres wceq vw cv vx cv c2nd cfv c1st cfv crn cpw wcel vw cv vv cv
       c2nd cfv c1st cfv crn wceq wi wi wi vx cv c2nd cfv c1st cfv cdm vx cv
       c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wceq vv cv cvec
       wcel vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq
       w3a vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vw cv vx cv c2nd cfv c1st
       cfv crn cpw wcel vw cv vv cv c2nd cfv c1st cfv crn wceq wi vw cv vx cv
       c2nd cfv c1st cfv crn cpw wcel vx cv c2nd cfv c1st cfv cdm vx cv c2nd
       cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wceq vv cv cvec wcel vv
       cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq w3a vv cv
       c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st
       cfv vw cv vw cv cxp cres wceq w3a vw cv vv cv c2nd cfv c1st cfv crn wceq
       vw cv vx cv c2nd cfv c1st cfv crn wss vw cv vx cv c2nd cfv c1st cfv crn
       wss vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv c1st cfv crn vx cv c2nd
       cfv c1st cfv crn cxp wceq vv cv cvec wcel vv cv c2nd cfv c1st cfv cdm
       cdm vv cv c2nd cfv c1st cfv crn wceq w3a vv cv c1st cfv vx cv c1st cfv
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres wceq w3a vw cv vv cv c2nd cfv c1st cfv crn wceq wi vw cv vx cv c2nd
       cfv c1st cfv crn cpw wcel vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv
       c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wceq vv cv cvec wcel vv cv
       c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq w3a vv cv
       c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st
       cfv vw cv vw cv cxp cres wceq w3a vw cv vw cv cxp vx cv c2nd cfv c1st
       cfv crn vx cv c2nd cfv c1st cfv crn cxp wss vw cv vv cv c2nd cfv c1st
       cfv crn wceq vw cv vx cv c2nd cfv c1st cfv crn wss vw cv vx cv c2nd cfv
       c1st cfv crn wss wa vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv c1st cfv
       crn vx cv c2nd cfv c1st cfv crn cxp wceq vv cv cvec wcel vv cv c2nd cfv
       c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq w3a vv cv c1st cfv vx
       cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres wceq vw cv vw cv cxp vx cv c2nd cfv c1st cfv crn vx cv
       c2nd cfv c1st cfv crn cxp wss vw cv vv cv c2nd cfv c1st cfv crn wceq wi
       vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv
       c1st cfv crn cxp wceq vv cv cvec wcel vv cv c2nd cfv c1st cfv cdm cdm vv
       cv c2nd cfv c1st cfv crn wceq w3a vw cv vw cv cxp vx cv c2nd cfv c1st
       cfv crn vx cv c2nd cfv c1st cfv crn cxp wss vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c1st cfv vx cv c1st
       cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq vx cv c2nd cfv c1st cfv
       cdm vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wceq vv
       cv cvec wcel vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn
       wceq vw cv vw cv cxp vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv
       crn cxp wss vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres wceq vv cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv
       c1st cfv crn wceq wi wi wi vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv
       c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wceq vw cv vw cv cxp vx cv
       c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp wss vv cv c2nd cfv
       c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv
       cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq
       wi wi vw cv vw cv cxp vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st
       cfv crn cxp wss vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv
       crn wceq vv cv cvec wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       vw cv vw cv cxp cres wceq vv cv c1st cfv vx cv c1st cfv wceq vw cv vv cv
       c2nd cfv c1st cfv crn wceq wi wi wi wi wi vx cv c2nd cfv c1st cfv crn vx
       cv c2nd cfv c1st cfv crn cxp vx cv c2nd cfv c1st cfv cdm vx cv c2nd cfv
       c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp vx cv c2nd cfv c1st cfv cdm
       wceq vw cv vw cv cxp vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv
       crn cxp wss vw cv vw cv cxp vx cv c2nd cfv c1st cfv cdm wss vv cv c2nd
       cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq
       vv cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn
       wceq wi wi wi wi vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn
       cxp vx cv c2nd cfv c1st cfv cdm vw cv vw cv cxp sseq2 vw cv vw cv cxp vx
       cv c2nd cfv c1st cfv cdm wss vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres cdm vw cv vw cv cxp wceq vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd
       cfv c1st cfv crn wceq vv cv cvec wcel vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv vw cv vw cv cxp cres wceq vv cv c1st cfv vx cv c1st cfv
       wceq vw cv vv cv c2nd cfv c1st cfv crn wceq wi wi wi wi vw cv vw cv cxp
       vx cv c2nd cfv c1st cfv ssdmres vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres cdm cdm vw cv vw cv cxp cdm wceq vw cv vw cv cxp cdm vw cv wceq vv
       cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec
       wcel vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres wceq vv cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st
       cfv crn wceq wi wi wi wi vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres
       cdm vw cv vw cv cxp wceq vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres
       cdm cdm vw cv vw cv cxp cdm wceq vw cv vw cv cxp cdm vw cv wceq wa vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vw cv wceq vv cv c2nd cfv
       c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres wceq vv
       cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq
       wi wi wi wi vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vw cv
       vw cv cxp cdm vw cv eqtr vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       vw cv vw cv cxp cres wceq vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv
       c1st cfv crn wceq vv cv cvec wcel vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres cdm cdm vw cv wceq vv cv c1st cfv vx cv c1st cfv wceq vw cv vv
       cv c2nd cfv c1st cfv crn wceq wi vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp cres wceq vv cv c2nd cfv c1st cfv cdm vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres cdm wceq vv cv c2nd cfv c1st cfv
       cdm cdm vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm wceq vv cv
       c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec
       wcel vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vw cv wceq vv
       cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq
       wi wi wi wi vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres dmeq vv cv c2nd cfv c1st cfv cdm vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres cdm dmeq vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv
       c1st cfv crn wceq vv cv cvec wcel vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres cdm cdm vw cv wceq vv cv c1st cfv vx cv c1st cfv wceq vw cv vv
       cv c2nd cfv c1st cfv crn wceq wi wi wi wi vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres cdm cdm vv cv c2nd cfv c1st cfv cdm cdm vx cv c2nd cfv
       c1st cfv vw cv vw cv cxp cres cdm cdm vv cv c2nd cfv c1st cfv cdm cdm
       wceq vv cv c2nd cfv c1st cfv cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv
       cv cvec wcel vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vw cv
       wceq vv cv c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv
       crn wceq wi wi wi vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm
       vv cv c2nd cfv c1st cfv cdm cdm wceq vv cv c2nd cfv c1st cfv cdm cdm vv
       cv c2nd cfv c1st cfv crn wceq wa vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vx cv c2nd
       cfv c1st cfv vw cv vw cv cxp cres cdm cdm vw cv wceq vv cv c1st cfv vx
       cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq wi wi wi vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vv cv c2nd cfv c1st cfv
       cdm cdm vv cv c2nd cfv c1st cfv crn eqtr vx cv c2nd cfv c1st cfv vw cv
       vw cv cxp cres cdm cdm vw cv wceq vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres cdm cdm vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vv cv
       c1st cfv vx cv c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq wi
       vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vv cv c2nd cfv c1st
       cfv crn wceq vv cv cvec wcel vv cv c1st cfv vx cv c1st cfv wceq vw cv vv
       cv c2nd cfv c1st cfv crn wceq wi wi wi vw cv vx cv c2nd cfv c1st cfv vw
       cv vw cv cxp cres cdm cdm vw cv vx cv c2nd cfv c1st cfv vw cv vw cv cxp
       cres cdm cdm wceq vx cv c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm
       vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vv cv c1st cfv vx cv
       c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq wi wi vw cv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm wceq vx cv c2nd cfv c1st
       cfv vw cv vw cv cxp cres cdm cdm vv cv c2nd cfv c1st cfv crn wceq wa vw
       cv vv cv c2nd cfv c1st cfv crn wceq vv cv cvec wcel vv cv c1st cfv vx cv
       c1st cfv wceq vw cv vv cv c2nd cfv c1st cfv crn wceq wi wi vw cv vx cv
       c2nd cfv c1st cfv vw cv vw cv cxp cres cdm cdm vv cv c2nd cfv c1st cfv
       crn eqtr vv cv c1st cfv vx cv c1st cfv wceq vv cv cvec wcel vw cv vv cv
       c2nd cfv c1st cfv crn wceq vw cv vv cv c2nd cfv c1st cfv crn wceq vv cv
       cvec wcel vw cv vv cv c2nd cfv c1st cfv crn wceq vw cv vv cv c2nd cfv
       c1st cfv crn wceq wi wi vv cv c1st cfv vx cv c1st cfv wceq vv cv cvec
       wcel vw cv vv cv c2nd cfv c1st cfv crn wceq idd a1i com13 syl ex eqcoms
       com3l syl ex eqcoms 3syl com14 syl vx cv c2nd cfv c1st cfv vw cv vw cv
       cxp cres cdm vw cv vw cv cxp dmeq vw cv dmxpid sylancl sylbi syl6bi
       eqcoms com24 3imp com24 3imp vw cv vx cv c2nd cfv c1st cfv crn vw cv vx
       cv c2nd cfv c1st cfv crn ssxp syl5com vw cv vx cv c2nd cfv c1st cfv crn
       vw visset elpw vw cv vx cv c2nd cfv c1st cfv crn vw visset elpw sylancb
       com12 3exp 3exp syl 3syl com13 syl vv cv c2nd cfv c1st cfv cdm vv cv
       c2nd cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp dmeq vv cv c2nd
       cfv c1st cfv crn dmxpid sylancl syl 3syl pm2.43i impcom imp com12 3imp
       vw cv vv cv c2nd cfv c1st cfv crn vx cv c1st cfv c1st cfv crn xpeq2 syl
       vx cv c1st cfv c1st cfv crn vw cv cxp vx cv c1st cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp vx cv c2nd cfv c2nd cfv reseq2 syl eqeq2d
       biimpd 3exp com24 imp com12 3imp jca 3exp r19.23aiv com12 impbid
       pm5.32da vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv
       vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq
       3anass syl5bb rabbidv eqeq2d pm5.32i opabbii eqtri $.
       $( [31-Dec-2010] $) $( [31-Dec-2010] $)

     $( A very concise definition of a subspace of a vector space. $)
     svs3 $p |- SubVec = { <. x , y >. | ( x e. Vec /\
       y = { v e. Vec | ( ( 1st ` v ) = ( 1st ` x )   /\
       ( 1st ` ( 2nd ` v ) ) C_ ( 1st ` ( 2nd ` x ) ) /\
       ( 2nd ` ( 2nd ` v ) ) C_ ( 2nd ` ( 2nd ` x ) ) ) } ) } $=
       csvec vx cv cvec wcel vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq w3a vv cvec crab wceq wa vx vy copab vx cv cvec wcel
       vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv
       wss w3a vv cvec crab wceq wa vx vy copab vx vy vv df-svs vx cv cvec wcel
       vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx
       cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq w3a
       vv cvec crab wceq wa vx cv cvec wcel vy cv vv cv c1st cfv vx cv c1st cfv
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv
       c2nd cfv vx cv c2nd cfv c2nd cfv wss w3a vv cvec crab wceq wa vx vy vx
       cv cvec wcel vy cv vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd
       cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq w3a vv cvec crab wceq vy cv vv cv c1st cfv vx cv c1st cfv wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd
       cfv vx cv c2nd cfv c2nd cfv wss w3a vv cvec crab wceq vx cv cvec wcel vv
       cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq w3a vv cvec
       crab vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv
       wss w3a vv cvec crab vy cv vx cv cvec wcel vv cv c1st cfv vx cv c1st cfv
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv
       c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd
       cfv c1st cfv crn cxp cres wceq w3a vv cv c1st cfv vx cv c1st cfv wceq vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv
       vx cv c2nd cfv c2nd cfv wss w3a vv cvec vx cv cvec wcel vv cv cvec wcel
       wa vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq wa wa vv
       cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss wa wa
       vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv
       c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres wceq w3a vv
       cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv
       c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss w3a vx
       cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss
       vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss wa vx cv cvec wcel
       vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv
       c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd cfv vx cv c2nd
       cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss vx cv cvec
       wcel vv cv cvec wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv wss wa vv cv c2nd cfv c2nd cfv vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss vv
       cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn
       vv cv c2nd cfv c1st cfv crn cxp cres wceq vv cv c2nd cfv c2nd cfv vx cv
       c2nd cfv c2nd cfv wss vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp cres vx cv c2nd cfv c2nd cfv wss vx
       cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp resss vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp cres vx cv c2nd cfv
       c2nd cfv sseq1 mpbiri vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv
       vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       wss wa vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss vv cv c2nd
       cfv c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp cres wceq vx cv cvec wcel vv cv cvec wcel wa
       vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv wss wa vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss
       wa vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp cres vx cv c2nd cfv c2nd cfv vv cv c2nd cfv c2nd cfv
       cdm cres vv cv c2nd cfv c2nd cfv vx cv cvec wcel vv cv cvec wcel wa vv
       cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv wss wa vv cv c2nd cfv c2nd cfv vx cv c2nd cfv c2nd cfv wss
       wa vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv
       c2nd cfv c2nd cfv cdm wceq vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp cres vx cv c2nd cfv c2nd cfv vv
       cv c2nd cfv c2nd cfv cdm cres wceq vx cv cvec wcel vv cv cvec wcel wa vv
       cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd
       cfv c1st cfv wss wa vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp vv cv c2nd cfv c2nd cfv cdm wceq vv cv c2nd cfv c2nd cfv vx cv
       c2nd cfv c2nd cfv wss vx cv cvec wcel vv cv cvec wcel wa vv cv c1st cfv
       vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       wss vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv
       c2nd cfv c2nd cfv cdm wceq vv cv c1st cfv vx cv c1st cfv wceq vx cv cvec
       wcel vv cv cvec wcel wa vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv
       wss vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv
       c2nd cfv c2nd cfv cdm wceq wi vx cv cvec wcel vv cv cvec wcel wa vv cv
       c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq wi
       wi vx cv c1st cfv vv cv c1st cfv vx cv c1st cfv vv cv c1st cfv wceq vv
       cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq wi
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vx cv c1st cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq
       wi vx cv cvec wcel vv cv cvec wcel wa vx cv c1st cfv vv cv c1st cfv wceq
       vv cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd
       cfv c2nd cfv cdm wceq vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st
       cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv wss vx cv c1st cfv vv cv c1st cfv wceq vv cv c1st
       cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm vx cv
       c1st cfv vv cv c1st cfv wceq vv cv c1st cfv c1st cfv crn vx cv c1st cfv
       c1st cfv crn wceq vv cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv
       crn cxp vx cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp wceq
       vv cv c1st cfv c1st cfv crn vx cv c1st cfv c1st cfv crn wceq vv cv c1st
       cfv vx cv c1st cfv vv cv c1st cfv vx cv c1st cfv wceq vv cv c1st cfv
       c1st cfv vx cv c1st cfv c1st cfv vv cv c1st cfv vx cv c1st cfv c1st
       fveq2 rneqd eqcoms vv cv c1st cfv c1st cfv crn vx cv c1st cfv c1st cfv
       crn vv cv c2nd cfv c1st cfv crn xpeq1 syl eqeq1d imbi2d vv cv cvec wcel
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c1st cfv c1st
       cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq
       wi vx cv cvec wcel vv cv cvec wcel vv cv c1st cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq vv cv c2nd
       cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv cvec wcel vv cv c1st cfv
       c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c1st cfv crn
       vv cv c2nd cfv c2nd cfv wf vv cv c1st cfv c1st cfv crn vv cv c2nd cfv
       c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm wceq vv cv vv cv c2nd cfv
       c1st cfv crn vv cv c1st cfv c1st cfv crn vv cv c2nd cfv c2nd cfv vv cv
       c1st cfv c1st cfv crn eqid vv cv c2nd cfv c2nd cfv eqid vv cv c2nd cfv
       c1st cfv crn eqid vecax2 vv cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st
       cfv crn cxp vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c2nd cfv wf vv cv
       c2nd cfv c2nd cfv cdm vv cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st
       cfv crn cxp vv cv c1st cfv c1st cfv crn vv cv c2nd cfv c1st cfv crn cxp
       vv cv c2nd cfv c1st cfv crn vv cv c2nd cfv c2nd cfv fdm eqcomd syl a1d
       adantl syl5bi eqcoms impcom imp adantr vx cv c1st cfv c1st cfv crn vv cv
       c2nd cfv c1st cfv crn cxp vv cv c2nd cfv c2nd cfv cdm vx cv c2nd cfv
       c2nd cfv reseq2 syl vx cv c2nd cfv c2nd cfv wfun vv cv c2nd cfv c2nd cfv
       vx cv c2nd cfv c2nd cfv wss vx cv c2nd cfv c2nd cfv vv cv c2nd cfv c2nd
       cfv cdm cres vv cv c2nd cfv c2nd cfv wceq vx cv cvec wcel vv cv cvec
       wcel wa vv cv c1st cfv vx cv c1st cfv wceq wa vv cv c2nd cfv c1st cfv vx
       cv c2nd cfv c1st cfv wss wa vx cv c2nd cfv c2nd cfv vv cv c2nd cfv c2nd
       cfv funssres vx cv cvec wcel vv cv cvec wcel wa vx cv c2nd cfv c2nd cfv
       wfun vv cv c1st cfv vx cv c1st cfv wceq vv cv c2nd cfv c1st cfv vx cv
       c2nd cfv c1st cfv wss vx cv cvec wcel vx cv c2nd cfv c2nd cfv wfun vv cv
       cvec wcel vx cv cvec wcel vx cv c1st cfv c1st cfv crn vx cv c2nd cfv
       c1st cfv crn cxp vx cv c2nd cfv c1st cfv crn vx cv c2nd cfv c2nd cfv wf
       vx cv c2nd cfv c2nd cfv wfun vx cv vx cv c2nd cfv c1st cfv crn vx cv
       c1st cfv c1st cfv crn vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv
       crn eqid vx cv c2nd cfv c2nd cfv eqid vx cv c2nd cfv c1st cfv crn eqid
       vecax2 vx cv c1st cfv c1st cfv crn vx cv c2nd cfv c1st cfv crn cxp vx cv
       c2nd cfv c1st cfv crn vx cv c2nd cfv c2nd cfv ffun syl adantr ad2antrr
       sylan eqtr2d ex impbid2 pm5.32da pm5.32da vv cv c1st cfv vx cv c1st cfv
       wceq vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv
       c2nd cfv vx cv c2nd cfv c2nd cfv vx cv c1st cfv c1st cfv crn vv cv c2nd
       cfv c1st cfv crn cxp cres wceq 3anass vv cv c1st cfv vx cv c1st cfv wceq
       vv cv c2nd cfv c1st cfv vx cv c2nd cfv c1st cfv wss vv cv c2nd cfv c2nd
       cfv vx cv c2nd cfv c2nd cfv wss 3anass 3bitr4g rabbidv eqeq2d pm5.32i
       opabbii eqtri $.
       $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Real vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RVec $.

  $( Extend class notation with the class of all real vector spaces. $)
  cvr $a class RVec $.

  ${
    $d g s x y z $.
    $( Define the class of all real vector spaces. The definition of a ` RVec `
       and a ` CVec ` don't much differ. There may be a way to get both in only
       one definition. A ` RVec ` seems mandatory if one wants to do classical
       cartesian geometry. We can't use a ` CVec ` instead. Changing the field
       changes important properties such as the dimension. $)
    df-vr $a |- RVec = { <. g , s >. | ( g e. Abel /\
     s : ( RR X. ran g ) --> ran g /\ A. x e. ran g ( ( 1 s x ) = x /\
       A. y e. RR ( A. z e. ran g ( y s ( x g z ) ) = ( ( y s x ) g ( y s z ) )
         /\ A. z e. RR ( ( ( y + z ) s x ) = ( ( y s x ) g ( z s x ) ) /\
           ( ( y x. z ) s x ) = ( y s ( z s x ) ) ) ) ) ) } $.

    $( The class of all real vector spaces is a relation. $)
    vrrel $p |- Rel RVec $=
      cvr wrel vg cv cabl wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs
      cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co
      vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co
      vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy
      cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq
      wa vz cr wral wa vy cr wral wa vx vg cv crn wral w3a vg vs copab wrel vg
      cv cabl wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv co vx cv
      wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv
      vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv
      co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv
      cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr
      wral wa vy cr wral wa vx vg cv crn wral w3a vg vs relopab cvr vg cv cabl
      wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv co vx cv wceq vy
      cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co
      vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr wral wa
      vy cr wral wa vx vg cv crn wral w3a vg vs copab vx vy vz vg vs df-vr
      releqi mpbir $.
      $( [17-Nov-2008] $) $( [16-Nov-2008] $)
  $}

  ${ $d G g s x y z $. $d S g s x y z $. $d W g s $. $d X g s x z $.
    vri.1 $e |- G = ( 1st ` W ) $.
    vri.2 $e |- S = ( 2nd ` W ) $.
    vri.3 $e |- X = ran G $.
    $( The properties of a real vector space, which is an abelian group
       (i.e. the vectors, with the operation of vector addition) accompanied
       by a scalar multiplication operation on the field of real numbers.
       The variable ` W ` was chosen because ` _V ` is already used for the
       universal class. $)
    vri $p |- ( W e. RVec ->
              ( G e. Abel /\
         S :  ( RR X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. RR ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. RR ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) $=
      cW cvr wcel cW vg cv cabl wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx
      cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs
      cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cr wral wa vy cr wral wa vx vg cv crn wral w3a vg vs
      copab wcel cG cabl wcel cr cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy
      cv vx cv vz cv cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq
      vz cX wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv
      cS co cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co
      cS co wceq wa vz cr wral wa vy cr wral wa vx cX wral w3a cvr vg cv cabl
      wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv co vx cv wceq vy
      cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs cv co vy
      cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv cmul co
      vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr wral wa
      vy cr wral wa vx vg cv crn wral w3a vg vs copab cW vx vy vz vg vs df-vr
      eleq2i vg cv cabl wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx cv vs cv
      co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy
      cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vz cr wral wa vy cr wral wa vx vg cv crn wral w3a cG cabl wcel cr cX cxp
      cX vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv co
      vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz
      cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cr wral wa vy cr wral wa vx cX wral w3a cG cabl wcel cr
      cX cxp cX cS wf c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co
      vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv
      vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cr
      wral wa vy cr wral wa vx cX wral w3a vg vs cW vg cv cW c1st cfv wceq vg
      cv cG wceq vg cv cabl wcel cr vg cv crn cxp vg cv crn vs cv wf c1 vx cv
      vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv
      co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc
      co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq
      vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co
      wceq wa vz cr wral wa vy cr wral wa vx vg cv crn wral w3a cG cabl wcel cr
      cX cxp cX vs cv wf c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co
      vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral
      vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs
      cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs
      cv co vs cv co wceq wa vz cr wral wa vy cr wral wa vx cX wral w3a wb cG
      cW c1st cfv vg cv vri.1 eqeq2i vg cv cG wceq vg cv cabl wcel cG cabl wcel
      cr vg cv crn cxp vg cv crn vs cv wf cr cX cxp cX vs cv wf c1 vx cv vs cv
      co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy
      cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vz cr wral wa vy cr wral wa vx vg cv crn wral c1 vx cv vs cv co vx cv
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx
      cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr wral wa vy cr
      wral wa vx cX wral vg cv cG cabl eleq1 vg cv cG wceq vg cv crn cX wceq vs
      cv vs cv wceq cr vg cv crn cxp cr cX cxp wceq vg cv crn cX wceq w3a cr vg
      cv crn cxp vg cv crn vs cv wf cr cX cxp cX vs cv wf wb vg cv cG wceq vg
      cv crn cG crn cX vg cv cG rneq vri.3 syl6eqr vg cv crn cX wceq vs cv vs
      cv wceq cr vg cv crn cxp cr cX cxp wceq vg cv crn cX wceq vg cv crn cX
      wceq vs cv eqidd vg cv crn cX cr xpeq2 vg cv crn cX wceq id 3jca cr vg cv
      crn cxp vg cv crn cr cX cxp cX vs cv vs cv feq123 3syl vg cv cG wceq c1
      vx cv vs cv co vx cv wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv
      vs cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cr wral wa vy cr wral wa c1 vx cv vs cv co vx cv wceq vy
      cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co
      cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs
      cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co
      vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr wral wa vy cr wral wa
      vx vg cv crn cX vg cv cG wceq vg cv crn cG crn cX vg cv cG rneq vri.3
      syl6eqr vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs
      cv co vy cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cr wral wa vy cr wral vy cv vx cv vz cv cG co vs cv co
      vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz
      cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG
      co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs
      cv co wceq wa vz cr wral wa vy cr wral c1 vx cv vs cv co vx cv wceq vg cv
      cG wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv vz
      cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vz cv caddc co vx cv vs
      cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv
      cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr
      wral wa vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv
      vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv
      vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv
      vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr wral wa vy cr
      vg cv cG wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy
      cv vz cv vs cv co vg cv co wceq vz vg cv crn wral vy cv vx cv vz cv cG co
      vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral
      vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs
      cv co vg cv co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv
      vs cv co vs cv co wceq wa vz cr wral vy cv vz cv caddc co vx cv vs cv co
      vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co
      vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr wral vg
      cv cG wceq vy cv vx cv vz cv vg cv co vs cv co vy cv vx cv vs cv co vy cv
      vz cv vs cv co vg cv co wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv
      vs cv co vy cv vz cv vs cv co cG co wceq vz vg cv crn cX vg cv cG wceq vg
      cv crn cG crn cX vg cv cG rneq vri.3 syl6eqr vg cv cG wceq vy cv vx cv vz
      cv vg cv co vs cv co vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv
      co vy cv vz cv vs cv co vg cv co vy cv vx cv vs cv co vy cv vz cv vs cv
      co cG co vg cv cG wceq vx cv vz cv vg cv co vx cv vz cv cG co vy cv vs cv
      vx cv vz cv vg cv cG opreq opreq2d vy cv vx cv vs cv co vy cv vz cv vs cv
      co vg cv cG opreq eqeq12d raleq12d vg cv cG wceq vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs
      cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs
      cv co vs cv co wceq wa vz cr vg cv cG wceq vy cv vz cv caddc co vx cv vs
      cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co wceq vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv
      co wceq vg cv cG wceq vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv co
      vy cv vx cv vs cv co vz cv vx cv vs cv co cG co vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co vg cv cG opreq
      eqeq2d anbi1d ralbidv anbi12d ralbidv anbi2d raleq12d 3anbi123d sylbir vs
      cv cW c2nd cfv wceq vs cv cS wceq cG cabl wcel cr cX cxp cX vs cv wf c1
      vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs
      cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc co vx
      cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz
      cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz
      cr wral wa vy cr wral wa vx cX wral w3a cG cabl wcel cr cX cxp cX cS wf
      c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv cS co
      vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co
      vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv
      cS co vy cv vz cv vx cv cS co cS co wceq wa vz cr wral wa vy cr wral wa
      vx cX wral w3a wb cS cW c2nd cfv vs cv vri.2 eqeq2i vs cv cS wceq cr cX
      cxp cX vs cv wf cr cX cxp cX cS wf c1 vx cv vs cv co vx cv wceq vy cv vx
      cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs cv co cG co
      wceq vz cX wral vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co
      vz cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv
      vz cv vx cv vs cv co vs cv co wceq wa vz cr wral wa vy cr wral wa vx cX
      wral c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co cS co vy cv vx cv
      cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv
      cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co
      vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cr wral wa vy cr
      wral wa vx cX wral cG cabl wcel cr cX cxp cX vs cv cS feq1 vs cv cS wceq
      c1 vx cv vs cv co vx cv wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv
      vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv caddc co
      vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv
      vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa
      vz cr wral wa vy cr wral wa c1 vx cv cS co vx cv wceq vy cv vx cv vz cv
      cG co cS co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy
      cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co
      wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq
      wa vz cr wral wa vy cr wral wa vx cX vs cv cS wceq c1 vx cv vs cv co vx
      cv wceq c1 vx cv cS co vx cv wceq vy cv vx cv vz cv cG co vs cv co vy cv
      vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv
      co wceq wa vz cr wral wa vy cr wral vy cv vx cv vz cv cG co cS co vy cv
      vx cv cS co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co
      vx cv cS co vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv
      cmul co vx cv cS co vy cv vz cv vx cv cS co cS co wceq wa vz cr wral wa
      vy cr wral vs cv cS wceq c1 vx cv vs cv co c1 vx cv cS co vx cv c1 vx cv
      vs cv cS opreq eqeq1d vs cv cS wceq vy cv vx cv vz cv cG co vs cv co vy
      cv vx cv vs cv co vy cv vz cv vs cv co cG co wceq vz cX wral vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co
      wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv
      co wceq wa vz cr wral wa vy cv vx cv vz cv cG co cS co vy cv vx cv cS co
      vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv cS co
      vy cv vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv
      cS co vy cv vz cv vx cv cS co cS co wceq wa vz cr wral wa vy cr vs cv cS
      wceq vy cv vx cv vz cv cG co vs cv co vy cv vx cv vs cv co vy cv vz cv vs
      cv co cG co wceq vz cX wral vy cv vx cv vz cv cG co cS co vy cv vx cv cS
      co vy cv vz cv cS co cG co wceq vz cX wral vy cv vz cv caddc co vx cv vs
      cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co wceq vy cv vz cv
      cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co vs cv co wceq wa vz cr
      wral vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS co
      wceq wa vz cr wral vs cv cS wceq vy cv vx cv vz cv cG co vs cv co vy cv
      vx cv vs cv co vy cv vz cv vs cv co cG co wceq vy cv vx cv vz cv cG co cS
      co vy cv vx cv cS co vy cv vz cv cS co cG co wceq vz cX vs cv cS wceq vy
      cv vx cv vz cv cG co vs cv co vy cv vx cv vz cv cG co cS co vy cv vx cv
      vs cv co vy cv vz cv vs cv co cG co vy cv vx cv cS co vy cv vz cv cS co
      cG co vy cv vx cv vz cv cG co vs cv cS opreq vs cv cS wceq vy cv vx cv vs
      cv co vy cv vx cv cS co vy cv vz cv vs cv co vy cv vz cv cS co cG vy cv
      vx cv vs cv cS opreq vy cv vz cv vs cv cS opreq opreq12d eqeq12d ralbidv
      vs cv cS wceq vy cv vz cv caddc co vx cv vs cv co vy cv vx cv vs cv co vz
      cv vx cv vs cv co cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz
      cv vx cv vs cv co vs cv co wceq wa vy cv vz cv caddc co vx cv cS co vy cv
      vx cv cS co vz cv vx cv cS co cG co wceq vy cv vz cv cmul co vx cv cS co
      vy cv vz cv vx cv cS co cS co wceq wa vz cr vs cv cS wceq vy cv vz cv
      caddc co vx cv vs cv co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co
      wceq vy cv vz cv caddc co vx cv cS co vy cv vx cv cS co vz cv vx cv cS co
      cG co wceq vy cv vz cv cmul co vx cv vs cv co vy cv vz cv vx cv vs cv co
      vs cv co wceq vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv cS co cS
      co wceq vs cv cS wceq vy cv vz cv caddc co vx cv vs cv co vy cv vz cv
      caddc co vx cv cS co vy cv vx cv vs cv co vz cv vx cv vs cv co cG co vy
      cv vx cv cS co vz cv vx cv cS co cG co vy cv vz cv caddc co vx cv vs cv
      cS opreq vs cv cS wceq vy cv vx cv vs cv co vy cv vx cv cS co vz cv vx cv
      vs cv co vz cv vx cv cS co cG vy cv vx cv vs cv cS opreq vz cv vx cv vs
      cv cS opreq opreq12d eqeq12d vs cv cS wceq vy cv vz cv cmul co vx cv vs
      cv co vy cv vz cv cmul co vx cv cS co vy cv vz cv vx cv vs cv co vs cv co
      vy cv vz cv vx cv cS co cS co vy cv vz cv cmul co vx cv vs cv cS opreq vs
      cv cS wceq vy cv vz cv vx cv vs cv co vs cv co vy cv vz cv vx cv cS co vs
      cv co vy cv vz cv vx cv cS co cS co vs cv cS wceq vz cv vx cv vs cv co vz
      cv vx cv cS co vy cv vs cv vz cv vx cv vs cv cS opreq opreq2d vy cv vz cv
      vx cv cS co vs cv cS opreq eqtrd eqeq12d anbi12d ralbidv anbi12d ralbidv
      anbi12d ralbidv 3anbi23d sylbir elopabi sylbi $.
      $( [17-Nov-2008] $) $( [16-Nov-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Matrices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c +m $.
  $c xm $.
  $c .m $.

  $( Addition of matrices. $)
  cmmat $a class +m $.

  $( Scalar multiplication of matrices. $)
  csmat $a class .m $.

  $( Multiplication of matrices. $)
  cxmat $a class xm $.

  ${
    $d g h m n o j k x y $.
    $( Matrix  addition.  Meaningful if ` g ` is
       a   `    Magma   `    (a  binary   internal    operation)   at
       least. Experimental.  $)
    df-amat $a |- +m = { <. g , h >. | h = { <. <. m , n >. , o >. | E. j e. NN
       E. k e. NN ( m : ( ( 1 ... j ) X. ( 1 ... k ) ) --> dom dom g /\
        n : ( ( 1 ... j ) X. ( 1 ... k ) ) --> dom dom g /\
        o = ( x e. ( 1 ... j ) , y e. ( 1 ... k )
              |-> ( ( m ` <. x , y >. ) g ( n ` <. x , y >. ) ) ) ) } } $.
  $}

  ${
    $d g h m a o j k  x y $.
    $( Matrix  left scalar  multiplication. Meaningful if  ` g `  is a
       binary  external operation.  Experimental. $)
    df-smat $a |- .m = { <. g , h >. | h = { <. <. m , a >. , o >. | E. j e. NN
       E. k e. NN ( m : ( ( 1 ... j ) X. ( 1 ... k ) ) --> ran dom g /\
         a e. dom dom g /\ o = ( x e. ( 1 ... j ) , y e. ( 1 ... k )
           |-> ( a g ( m ` <. x , y >. ) ) ) ) } } $.
  $}

  ${
    $d g h f m n o j k l x y z $.
    $( Matrix multiplication. Meaningful if ` <.  g , h >. ` is a ring
       at  least.   `  prod_  `  here  should  be  `  sum_  `  (to  be
       traditional). But in set.mm ` sum_ ` is ` CC ` oriented and has
       a limit definition  embedded and thus doesn't fit  the needs of
       this  generic definition.   Experimental. $)
    df-mmat $a |- xm = { <. <. g , h >. , f >. |
      f = { <. <. m , n >. , o >. | E. j e. NN E. k e. NN E. l e. NN (
          m : ( ( 1 ... j ) X. ( 1 ... k ) ) --> dom dom g /\
          n : ( ( 1 ... k ) X. ( 1 ... l ) ) --> dom dom g /\
          o = ( x e. ( 1 ... j ) , y e. ( 1 ... l )
            |-> prod_ z e. ( 1 ... k ) g
            ( ( m ` <. x , z >. ) h ( n ` <. z , y >. ) ) ) ) } } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Affine spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RAffSp $.

  $( Extend class notation with the class of all R affine spaces. $)
  raffsp $a class RAffSp $.

  ${ $d x y t a b v $.
    $( Define a ` RR ` affine space id est a ` RR ` vector space ` x ` ( called
       the free vectors class ) together with a function ` y ` . ` y `
       associates to each vector a bijection from a set ` t ` (called the
       space) to itself (here ` t ` is retrieved from the operation.)
       Technically speaking, ` y ` is a faithful (i.e. injective) and
       transitive group action (id est a group homomorphism whose range is the
       underlying set of a symmetry group ). Informally speaking the aim of all
       of that is to associate to each point of ` t ` a unique point of ` t `
       through the "action" of a vector of ` x ` and thus to formalize the
       idea of translation.  When we have embedded the idea of translation
       it is easy to define a repere and thus all the cartesian geometry
       is available. $)
    df-raffsp $a |- RAffSp    = { <. x , y >. | ( x e. RVec /\ E. t
      ( y e. ( ( 1st ` x ) GrpHom ( SymGrp ` t ) ) /\
      y : ran ( 1st ` x ) -1-1-> t /\
     A. a e. t A. b e. t E. v e. ran ( 1st ` x ) ( ( y ` v ) ` a ) = b ) ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Intervals of reals and extended reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.  $d B x $. $( ` x ` is dummy. $)
    $( An open interval is included in ` RR ` if ` A ` and ` B ` belong to
       ` RR* ` . $)
    iooirrsa $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) C_ RR ) $=
      cA cxr wcel cB cxr wcel wa cA cB cioo co cr cpw wcel cA cB cioo co cr wss
      cA cB cr cpw cxr cxr cioo ioof foprcl cA cB cioo co cr elpwi syl $.
      $( [3-Mar-2007] $) $( [3-Mar-2007] $)
  $}


  ${
    $d A x $.  $d B x $.
    $( A closed interval is a set of extended reals. $)
    clsrebb $p |- ( B e. _V -> ( A [,] B ) C_ RR* ) $=
      cB cvv wcel cA cxr wcel cB cxr wcel wa cA cB cicc co cxr wss cB cvv wcel
      cA cxr wcel cB cxr wcel wa wn cA cB cicc co cxr wss cB cvv wcel cA cxr
      wcel cB cxr wcel wa wn wa cA cB cicc co c0 cxr cicc cdm cxr cxr cxp wceq
      cB cvv wcel cA cxr wcel cB cxr wcel wa wn cA cB cicc co c0 wceq cxr cxr
      cxp cxr cpw cicc iccf fdmi cA cB cvv cxr cxr cicc ndmoprg mp3an1 c0 cxr
      wss cB cvv wcel cA cxr wcel cB cxr wcel wa wn wa cxr 0ss a1i eqsstrd ex
      cA cxr wcel cB cxr wcel wa vx cA cB cicc co cxr cA cxr wcel cB cxr wcel
      wa vx cv cA cB cicc co wcel vx cv cxr wcel cA vx cv cle wbr vx cv cB cle
      wbr w3a vx cv cxr wcel cA cB vx cv elicc1 vx cv cxr wcel cA vx cv cle wbr
      vx cv cB cle wbr 3simp1 syl6bi ssrdv pm2.61d2 $.
      $( [28-Jul-2008] $) $( [28-Jul-2008] $)
  $}

  ${
  $d A x y z $.  $d w x y z $.
  $( Membership to the set of open intervals implied the existence of
     two bounds in the set of the extended reals. $)
  bsi $p |- ( A e. ran (,) ->
      E. x e. RR* E. y e. RR* A = ( x (,) y ) ) $=
    cA cioo crn wcel cA vx cv vy cv cioo co wceq vy cxr wrex vx cxr wrex cA
    cioo crn wcel cA cioo crn wcel vx cv cxr wcel vy cv cxr wcel wa cA vx cv vw
    cv clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq wa vy wex vx wex cA vx
    cv vy cv cioo co wceq vy cxr wrex vx cxr wrex cA cioo crn wcel cA vx cv cxr
    wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw
    cxr crab wceq wa vy wex vx wex vz cab wcel vx cv cxr wcel vy cv cxr wcel wa
    cA vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq wa vy wex vx
    wex cA cioo crn wcel cA cioo crn wcel vz cv cA wceq vx cv cxr wcel vy cv
    cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab
    wceq wa vy wex vx wex wa vz wex vx cv cxr wcel vy cv cxr wcel wa cA vx cv
    vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq wa vy wex vx wex cA
    vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt
    wbr wa vw cxr crab wceq wa vy wex vx wex vz cab wcel cA cioo crn wcel vz cv
    cA wceq vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy
    cv clt wbr wa vw cxr crab wceq wa vy wex vx wex wa vz wex vx cv cxr wcel vy
    cv cxr wcel wa cA vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab
    wceq wa vy wex vx wex vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv
    clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq wa vy wex vx wex vx cv cxr
    wcel vy cv cxr wcel wa cA vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr
    crab wceq wa vy wex vx wex vz cA cioo crn vz cv cA wceq vx cv cxr wcel vy
    cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab
    wceq wa vx cv cxr wcel vy cv cxr wcel wa cA vx cv vw cv clt wbr vw cv vy cv
    clt wbr wa vw cxr crab wceq wa vx vy vz cv cA wceq vz cv vx cv vw cv clt
    wbr vw cv vy cv clt wbr wa vw cxr crab wceq cA vx cv vw cv clt wbr vw cv vy
    cv clt wbr wa vw cxr crab wceq vx cv cxr wcel vy cv cxr wcel wa vz cv cA vx
    cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab eqeq1 anbi2d 2exbidv
    ceqsexgv biimpd vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr
    vw cv vy cv clt wbr wa vw cxr crab wceq wa vy wex vx wex vz cA clelab
    syl5ib cA cioo crn wcel cA vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw
    cv clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq wa vx vy vz copab2 crn
    wcel cA vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy
    cv clt wbr wa vw cxr crab wceq wa vy wex vx wex vz cab wcel cioo crn vx cv
    cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt wbr wa
    vw cxr crab wceq wa vx vy vz copab2 crn cA cioo vx cv cxr wcel vy cv cxr
    wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq
    wa vx vy vz copab2 vx vy vz vw df-ioo rneqi eleq2i vx cv cxr wcel vy cv cxr
    wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq
    wa vx vy vz copab2 crn vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv
    clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq wa vy wex vx wex vz cab cA
    vx cv cxr wcel vy cv cxr wcel wa vz cv vx cv vw cv clt wbr vw cv vy cv clt
    wbr wa vw cxr crab wceq wa vx vy vz rnoprab eleq2i bitri syl5ib vx cv cxr
    wcel vy cv cxr wcel wa cA vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr
    crab wceq wa vy wex vx wex vx cv cxr wcel vy cv cxr wcel wa cA vx cv vy cv
    cioo co wceq wa vy wex vx wex cA vx cv vy cv cioo co wceq vy cxr wrex vx
    cxr wrex vx cv cxr wcel vy cv cxr wcel wa cA vx cv vw cv clt wbr vw cv vy
    cv clt wbr wa vw cxr crab wceq wa vx cv cxr wcel vy cv cxr wcel wa cA vx cv
    vy cv cioo co wceq wa vx vy vx cv cxr wcel vy cv cxr wcel wa cA vx cv vw cv
    clt wbr vw cv vy cv clt wbr wa vw cxr crab wceq cA vx cv vy cv cioo co wceq
    vx cv cxr wcel vy cv cxr wcel wa cA vx cv vw cv clt wbr vw cv vy cv clt wbr
    wa vw cxr crab wceq cA vx cv vy cv cioo co wceq vx cv cxr wcel vy cv cxr
    wcel wa vx cv vw cv clt wbr vw cv vy cv clt wbr wa vw cxr crab vx cv vy cv
    cioo co cA vx cv cxr wcel vy cv cxr wcel wa vx cv vy cv cioo co vx cv vw cv
    clt wbr vw cv vy cv clt wbr wa vw cxr crab vw vx cv vy cv iooval eqcomd
    eqeq2d biimpd imdistani 19.22i2 cA vx cv vy cv cioo co wceq vx vy cxr cxr
    r2ex sylibr syl6 pm2.43i $.
    $( [29-Nov-2007] $) $( [31-Oct-2007] $)
  $}

  $( If an open interval has an element, then ` A < B ` . $)
  elioo1t3 $p |- ( C e. ( A (,) B ) -> A < B ) $=
    cA cxr wcel cB cxr wcel wa cC cA cB cioo co wcel cA cB clt wbr wi cA cxr
    wcel cB cxr wcel wa cC cA cB cioo co wcel cC cxr wcel cA cC clt wbr cC cB
    clt wbr w3a cA cB clt wbr cA cB cC elioo1 cA cxr wcel cB cxr wcel wa cC cxr
    wcel cA cC clt wbr cC cB clt wbr cA cB clt wbr cA cxr wcel cB cxr wcel cC
    cxr wcel cA cC clt wbr cC cB clt wbr cA cB clt wbr wi wi cA cxr wcel cC cxr
    wcel cB cxr wcel cA cC clt wbr cC cB clt wbr cA cB clt wbr wi wi cA cxr
    wcel cC cxr wcel cB cxr wcel w3a cA cC clt wbr cC cB clt wbr cA cB clt wbr
    cA cC cB xrlttr exp3a 3com23 3expia 3impd sylbid cA cxr wcel cB cxr wcel wa
    wn cA cB cioo co c0 wceq cC cA cB cioo co wcel cA cB clt wbr wi cA cB
    ndmioo cA cB cioo co c0 wceq cC cA cB cioo co wcel cC c0 wcel cA cB clt wbr
    cA cB cioo co c0 cC eleq2 cC c0 wcel cA cB clt wbr cC noel pm2.21i syl6bi
    syl pm2.61i $.
    $( [14-Sep-2007] $) $( [14-Aug-2007] $)

  $( An open interval with its upper bound equal to ` -oo ` is empty. $)
  oisbmi $p |- ( A (,) -oo ) = (/) $=
    cA cxr wcel cmnf cxr wcel wa cA cmnf cioo co c0 wceq cA cxr wcel cmnf cxr
    wcel wa cA cmnf cioo co c0 wceq cmnf cA cle wbr cA cxr wcel cmnf cA cle wbr
    cmnf cxr wcel cA mnfle adantr cA cmnf ioo0 mpbird cA cmnf ndmioo pm2.61i $.
    $( [14-Sep-2007] $) $( [12-Sep-2007] $)

  $( An open interval with its lower bound equal to ` +oo ` is empty. $)
  oisbmj $p |- ( +oo (,) A ) = (/) $=
    cpnf cxr wcel cA cxr wcel wa cpnf cA cioo co c0 wceq cpnf cxr wcel cA cxr
    wcel wa cpnf cA cioo co c0 wceq cA cpnf cle wbr cA cxr wcel cA cpnf cle wbr
    cpnf cxr wcel cA pnfge adantl cpnf cA ioo0 mpbird cpnf cA ndmioo pm2.61i $.
    $( [14-Sep-2007] $) $( [12-Sep-2007] $)

  $( Closure of translation in a half-infinite interval. $)
  truni1 $p |- ( ( A e. RR* /\ D e. RR /\ 0 < D ) ->
   ( C e. ( A (,) +oo ) -> ( C + D ) e. ( A (,) +oo ) ) ) $=
    cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC cr wcel cA cC clt wbr cC cpnf
    clt wbr w3a cC cD caddc co cr wcel cA cC cD caddc co clt wbr cC cD caddc co
    cpnf clt wbr w3a cC cA cpnf cioo co wcel cC cD caddc co cA cpnf cioo co
    wcel cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC cr wcel cA cC clt wbr cC
    cpnf clt wbr w3a cC cD caddc co cr wcel cA cC cD caddc co clt wbr cC cD
    caddc co cpnf clt wbr w3a cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC cr
    wcel cA cC clt wbr cC cpnf clt wbr w3a wa cC cD caddc co cr wcel cA cC cD
    caddc co clt wbr cC cD caddc co cpnf clt wbr cA cxr wcel cD cr wcel cc0 cD
    clt wbr w3a cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a cC cD caddc co cr
    wcel cD cr wcel cA cxr wcel cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a cC
    cD caddc co cr wcel wi cc0 cD clt wbr cC cr wcel cA cC clt wbr cC cpnf clt
    wbr w3a cD cr wcel cC cD caddc co cr wcel cC cr wcel cA cC clt wbr cD cr
    wcel cC cD caddc co cr wcel wi cC cpnf clt wbr cC cr wcel cD cr wcel cC cD
    caddc co cr wcel cC cD readdcl ex 3ad2ant1 com12 3ad2ant2 imp cA cxr wcel
    cC cxr wcel cC cD caddc co cxr wcel w3a cA cC clt wbr cC cC cD caddc co clt
    wbr wa cA cC cD caddc co clt wbr cA cxr wcel cD cr wcel cc0 cD clt wbr w3a
    cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a wa cA cC cC cD caddc co xrlttr
    cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC cr wcel cA cC clt wbr cC cpnf
    clt wbr w3a wa cA cxr wcel cC cxr wcel cC cD caddc co cxr wcel cA cxr wcel
    cD cr wcel cc0 cD clt wbr w3a cA cxr wcel cC cr wcel cA cC clt wbr cC cpnf
    clt wbr w3a cA cxr wcel cD cr wcel cc0 cD clt wbr 3simp1 adantr cC cr wcel
    cA cC clt wbr cC cpnf clt wbr w3a cC cxr wcel cA cxr wcel cD cr wcel cc0 cD
    clt wbr w3a cC cr wcel cA cC clt wbr cC cxr wcel cC cpnf clt wbr cC rexr
    3ad2ant1 adantl cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC cr wcel cA cC
    clt wbr cC cpnf clt wbr w3a cC cD caddc co cxr wcel cD cr wcel cA cxr wcel
    cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a cC cD caddc co cxr wcel wi cc0
    cD clt wbr cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a cD cr wcel cC cD
    caddc co cxr wcel cC cr wcel cA cC clt wbr cD cr wcel cC cD caddc co cxr
    wcel wi cC cpnf clt wbr cC cr wcel cD cr wcel cC cD caddc co cxr wcel cC cr
    wcel cD cr wcel wa cC cD caddc co cr wcel cC cD caddc co cxr wcel cC cD
    readdcl cC cD caddc co rexr syl ex 3ad2ant1 com12 3ad2ant2 imp 3jca cA cxr
    wcel cD cr wcel cc0 cD clt wbr w3a cC cr wcel cA cC clt wbr cC cpnf clt wbr
    w3a wa cA cC clt wbr cC cC cD caddc co clt wbr cC cr wcel cA cC clt wbr cC
    cpnf clt wbr w3a cA cC clt wbr cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC
    cr wcel cA cC clt wbr cC cpnf clt wbr 3simp2 adantl cA cxr wcel cD cr wcel
    cc0 cD clt wbr w3a cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a cC cC cD
    caddc co clt wbr cD cr wcel cc0 cD clt wbr cC cr wcel cA cC clt wbr cC cpnf
    clt wbr w3a cC cC cD caddc co clt wbr wi cA cxr wcel cC cr wcel cA cC clt
    wbr cC cpnf clt wbr w3a cD cr wcel cc0 cD clt wbr wa cC cC cD caddc co clt
    wbr cC cr wcel cA cC clt wbr cD cr wcel cc0 cD clt wbr wa cC cC cD caddc co
    clt wbr wi cC cpnf clt wbr cD cr wcel cc0 cD clt wbr wa cC cr wcel cC cC cD
    caddc co clt wbr cD cr wcel cc0 cD clt wbr wa cC cr wcel wa cC cD cC caddc
    co cC cD caddc co clt cD cr wcel cc0 cD clt wbr cC cr wcel cC cD cC caddc
    co clt wbr cD cr wcel cC cr wcel cc0 cD clt wbr cC cD cC caddc co clt wbr
    cD cr wcel cC cr wcel cc0 cD clt wbr cC cD cC caddc co clt wbr wi cD cr
    wcel cC cr wcel wa cc0 cD clt wbr cC cD cC caddc co clt wbr cD cC ltaddpos2
    biimpd ex com23 imp31 cC cc wcel cD cc wcel cC cD caddc co cD cC caddc co
    wceq cD cr wcel cc0 cD clt wbr wa cC cr wcel wa cC cD addcom cC cr wcel cC
    cc wcel cD cr wcel cc0 cD clt wbr wa cC recn adantl cD cr wcel cD cc wcel
    cc0 cD clt wbr cC cr wcel cD recn ad2antrr sylanc breqtrrd expcom 3ad2ant1
    com12 3adant1 imp jca sylc cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cC cr
    wcel cA cC clt wbr cC cpnf clt wbr w3a cC cD caddc co cpnf clt wbr cD cr
    wcel cA cxr wcel cC cr wcel cA cC clt wbr cC cpnf clt wbr w3a cC cD caddc
    co cpnf clt wbr wi cc0 cD clt wbr cC cr wcel cA cC clt wbr cC cpnf clt wbr
    w3a cD cr wcel cC cD caddc co cpnf clt wbr cC cr wcel cA cC clt wbr cD cr
    wcel cC cD caddc co cpnf clt wbr wi cC cpnf clt wbr cC cr wcel cD cr wcel
    cC cD caddc co cpnf clt wbr cC cr wcel cD cr wcel wa cC cD caddc co cr wcel
    cC cD caddc co cpnf clt wbr cC cD readdcl cC cD caddc co ltpnf syl ex
    3ad2ant1 com12 3ad2ant2 imp 3jca ex cA cxr wcel cD cr wcel cc0 cD clt wbr
    w3a cA cxr wcel cpnf cxr wcel wa cC cA cpnf cioo co wcel cC cr wcel cA cC
    clt wbr cC cpnf clt wbr w3a wb cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cA
    cxr wcel cpnf cxr wcel cA cxr wcel cD cr wcel cc0 cD clt wbr 3simp1 pnfxr
    jctir cA cpnf cC elioo2 syl cA cxr wcel cD cr wcel cc0 cD clt wbr w3a cA
    cxr wcel cpnf cxr wcel wa cC cD caddc co cA cpnf cioo co wcel cC cD caddc
    co cr wcel cA cC cD caddc co clt wbr cC cD caddc co cpnf clt wbr w3a wb cA
    cxr wcel cD cr wcel cc0 cD clt wbr w3a cA cxr wcel cpnf cxr wcel cA cxr
    wcel cD cr wcel cc0 cD clt wbr 3simp1 pnfxr jctir cA cpnf cC cD caddc co
    elioo2 syl 3imtr4d $.
    $( [14-Sep-2007] $) $( [11-Sep-2007] $)

  $( Closure of translation in a half-infinite interval. $)
  truni2 $p |- ( ( D e. RR /\ 0 < D ) ->
    ( C e. ( A (,) +oo ) -> ( C + D ) e. ( A (,) +oo ) ) ) $=
    cC cA cpnf cioo co wcel cD cr wcel cc0 cD clt wbr wa cC cD caddc co cA cpnf
    cioo co wcel cA cxr wcel cpnf cxr wcel wa cC cA cpnf cioo co wcel cD cr
    wcel cc0 cD clt wbr wa cC cD caddc co cA cpnf cioo co wcel wi cC cA cpnf
    eliooxr cA cxr wcel cC cA cpnf cioo co wcel cD cr wcel cc0 cD clt wbr wa cC
    cD caddc co cA cpnf cioo co wcel wi wi cpnf cxr wcel cA cxr wcel cD cr wcel
    cc0 cD clt wbr wa cC cA cpnf cioo co wcel cC cD caddc co cA cpnf cioo co
    wcel cA cxr wcel cD cr wcel cc0 cD clt wbr cC cA cpnf cioo co wcel cC cD
    caddc co cA cpnf cioo co wcel wi cA cC cD truni1 3expib com23 adantr mpcom
    com12 $.
    $( [28-Jan-2009] $) $( [26-Jan-2009] $)

  $( Closure of translation in a half-infinite interval. $)
  truni3 $p |- ( ( D e. RR /\ 0 < D ) ->
    ( C e. ( -oo (,) A ) -> ( C - D ) e. ( -oo (,) A ) ) ) $=
    cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr wa cC cD cmin co cmnf cA
    cioo co wcel cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co wcel cD cr
    wcel cc0 cD clt wbr wa cC cD cmin co cmnf cA cioo co wcel wi cC cmnf cA
    eliooxr cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co wcel cD cr wcel cc0
    cD clt wbr wa cC cD cmin co cmnf cA cioo co wcel cmnf cxr wcel cA cxr wcel
    wa cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr wa w3a cC cD cmin co
    cmnf cA cioo co wcel cC cD cmin co cr wcel cmnf cC cD cmin co clt wbr cC cD
    cmin co cA clt wbr w3a cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co wcel
    cD cr wcel cc0 cD clt wbr wa w3a cC cD cmin co cr wcel cmnf cC cD cmin co
    clt wbr cC cD cmin co cA clt wbr cC cmnf cA cioo co wcel cD cr wcel cc0 cD
    clt wbr wa cC cD cmin co cr wcel cmnf cxr wcel cA cxr wcel wa cC cr wcel cD
    cr wcel cc0 cD clt wbr wa cC cD cmin co cr wcel cC cmnf cA cioo co wcel cC
    cr wcel cD cr wcel cC cD cmin co cr wcel cc0 cD clt wbr cC cD resubcl
    adantrr cC cmnf cA elioore sylan 3adant1 cmnf cxr wcel cA cxr wcel wa cC
    cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr wa w3a cC cD cmin co cr wcel
    cmnf cC cD cmin co clt wbr cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt
    wbr wa cC cD cmin co cr wcel cmnf cxr wcel cA cxr wcel wa cC cr wcel cD cr
    wcel cc0 cD clt wbr wa cC cD cmin co cr wcel cC cmnf cA cioo co wcel cC cr
    wcel cD cr wcel cC cD cmin co cr wcel cc0 cD clt wbr cC cD resubcl adantrr
    cC cmnf cA elioore sylan 3adant1 cC cD cmin co mnflt syl cC cD cmin co cxr
    wcel cC cxr wcel cA cxr wcel w3a cC cD cmin co cC clt wbr cC cA clt wbr wa
    cC cD cmin co cA clt wbr cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co
    wcel cD cr wcel cc0 cD clt wbr wa w3a cC cD cmin co cC cA xrlttr cmnf cxr
    wcel cA cxr wcel wa cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr wa
    w3a cC cD cmin co cxr wcel cC cxr wcel cA cxr wcel cC cr wcel cD cr wcel cC
    cD cmin co cxr wcel cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co wcel cD
    cr wcel cc0 cD clt wbr wa w3a cC cr wcel cD cr wcel wa cC cD cmin co cr
    wcel cC cD cmin co cxr wcel cC cD resubcl cC cD cmin co rexr syl cC cmnf cA
    cioo co wcel cmnf cxr wcel cA cxr wcel wa cC cr wcel cD cr wcel cc0 cD clt
    wbr wa cC cmnf cA elioore 3ad2ant2 cD cr wcel cc0 cD clt wbr wa cmnf cxr
    wcel cA cxr wcel wa cD cr wcel cC cmnf cA cioo co wcel cD cr wcel cc0 cD
    clt wbr pm3.26 3ad2ant3 sylanc cC cmnf cA cioo co wcel cmnf cxr wcel cA cxr
    wcel wa cC cxr wcel cD cr wcel cc0 cD clt wbr wa cC cmnf cA cioo co wcel cC
    cr wcel cC cxr wcel cC cmnf cA elioore cC rexr syl 3ad2ant2 cmnf cxr wcel
    cA cxr wcel wa cC cmnf cA cioo co wcel cA cxr wcel cD cr wcel cc0 cD clt
    wbr wa cmnf cxr wcel cA cxr wcel pm3.27 3ad2ant1 3jca cmnf cxr wcel cA cxr
    wcel wa cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr wa w3a cC cD cmin
    co cC clt wbr cC cA clt wbr cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co
    wcel cD cr wcel cc0 cD clt wbr wa cC cD cmin co cC clt wbr cC cmnf cA cioo
    co wcel cD cr wcel cc0 cD clt wbr wa cC cD cmin co cC clt wbr wi wi cmnf
    cxr wcel cA cxr wcel wa cD cr wcel cc0 cD clt wbr wa cC cr wcel cC cD cmin
    co cC clt wbr cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr cC cr wcel
    cC cD cmin co cC clt wbr wi cD cr wcel cC cr wcel cc0 cD clt wbr cC cD cmin
    co cC clt wbr cD cr wcel cC cr wcel cc0 cD clt wbr cC cD cmin co cC clt wbr
    wi cD cr wcel cC cr wcel wa cc0 cD clt wbr cC cD cmin co cC clt wbr cD cC
    ltsubpos biimpd ex com23 imp cC cmnf cA elioore syl5com a1i 3imp cmnf cxr
    wcel cA cxr wcel wa cC cmnf cA cioo co wcel cD cr wcel cc0 cD clt wbr wa cC
    cA clt wbr cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co wcel cC cA clt
    wbr cD cr wcel cc0 cD clt wbr wa cmnf cxr wcel cA cxr wcel wa cC cmnf cA
    cioo co wcel cC cr wcel cmnf cC clt wbr cC cA clt wbr w3a cC cA clt wbr
    cmnf cA cC elioo2 cC cr wcel cmnf cC clt wbr cC cA clt wbr 3simp3 syl6bi
    a1dd 3imp jca sylc 3jca cmnf cxr wcel cA cxr wcel wa cC cmnf cA cioo co
    wcel cC cD cmin co cmnf cA cioo co wcel cC cD cmin co cr wcel cmnf cC cD
    cmin co clt wbr cC cD cmin co cA clt wbr w3a wb cD cr wcel cc0 cD clt wbr
    wa cmnf cA cC cD cmin co elioo2 3ad2ant1 mpbird 3exp mpcom com12 $.
    $( [28-Jan-2009] $) $( [26-Jan-2009] $)

  $( The center belongs to a centered interval. $)
  cbci $p |- ( ( A e. RR /\ B e. RR+ ) ->
     A e. ( ( A - B ) (,) ( A + B ) ) ) $=
    cA cr wcel cB crp wcel wa cA cA cB cmin co cA cB caddc co cioo co wcel cA
    cB cmin co cxr wcel cA cB caddc co cxr wcel cA cxr wcel w3a cA cB cmin co
    cA clt wbr cA cA cB caddc co clt wbr wa wa cA cr wcel cB crp wcel wa cA cB
    cmin co cxr wcel cA cB caddc co cxr wcel cA cxr wcel w3a cA cB cmin co cA
    clt wbr cA cA cB caddc co clt wbr wa cA cr wcel cB crp wcel wa cA cB cmin
    co cxr wcel cA cB caddc co cxr wcel cA cxr wcel cA cr wcel cB crp wcel wa
    cA cB cmin co cr wcel cA cB cmin co cxr wcel cA cr wcel cB cr wcel cA cB
    cmin co cr wcel cB crp wcel cA cB resubcl cB rpre sylan2 cA cB cmin co rexr
    syl cA cr wcel cB cr wcel cA cB caddc co cxr wcel cB crp wcel cA cr wcel cB
    cr wcel wa cA cB caddc co cr wcel cA cB caddc co cxr wcel cA cB axaddrcl cA
    cB caddc co rexr syl cB rpre sylan2 cA cr wcel cA cxr wcel cB crp wcel cA
    rexr adantr 3jca cA cr wcel cB crp wcel wa cA cB cmin co cA clt wbr cA cA
    cB caddc co clt wbr cA cr wcel cB crp wcel wa cA cB cmin co cA clt wbr cA
    cA cB caddc co clt wbr cA cr wcel cB crp wcel wa cA cA cmin co cB clt wbr
    cA cA cB caddc co clt wbr cA cr wcel cB crp wcel wa cA cA cmin co cc0 cB
    clt cA cr wcel cA cA cmin co cc0 wceq cB crp wcel cA cr wcel cA cc wcel cA
    cA cmin co cc0 wceq cA recn cA subid syl adantr cB crp wcel cc0 cB clt wbr
    cA cr wcel cB rpgt0 adantl eqbrtrd cA cr wcel cA cr wcel cB cr wcel cA cA
    cmin co cB clt wbr cA cA cB caddc co clt wbr wb cA cr wcel cB crp wcel wa
    cA cA cB ltsubadd2 cA cr wcel cB crp wcel pm3.26 cA cr wcel cB crp wcel
    pm3.26 cB crp wcel cB cr wcel cA cr wcel cB rpre adantl syl3anc mpbid cA cr
    wcel cB cr wcel cA cr wcel cA cB cmin co cA clt wbr cA cA cB caddc co clt
    wbr wb cA cr wcel cB crp wcel wa cA cB cA ltsubadd cA cr wcel cB crp wcel
    pm3.26 cB crp wcel cB cr wcel cA cr wcel cB rpre adantl cA cr wcel cB crp
    wcel pm3.26 syl3anc mpbird cA cr wcel cB crp wcel wa cA cA cmin co cB clt
    wbr cA cA cB caddc co clt wbr cA cr wcel cB crp wcel wa cA cA cmin co cc0
    cB clt cA cr wcel cA cA cmin co cc0 wceq cB crp wcel cA cr wcel cA cc wcel
    cA cA cmin co cc0 wceq cA recn cA subid syl adantr cB crp wcel cc0 cB clt
    wbr cA cr wcel cB rpgt0 adantl eqbrtrd cA cr wcel cA cr wcel cB cr wcel cA
    cA cmin co cB clt wbr cA cA cB caddc co clt wbr wb cA cr wcel cB crp wcel
    wa cA cA cB ltsubadd2 cA cr wcel cB crp wcel pm3.26 cA cr wcel cB crp wcel
    pm3.26 cB crp wcel cB cr wcel cA cr wcel cB rpre adantl syl3anc mpbid jca
    jca cA cr wcel cB crp wcel wa cA cB caddc co cr wcel cA cA cB cmin co cA cB
    caddc co cioo co wcel cA cB cmin co cxr wcel cA cB caddc co cxr wcel cA cxr
    wcel w3a cA cB cmin co cA clt wbr cA cA cB caddc co clt wbr wa wa wb cA cr
    wcel cB cr wcel cA cB caddc co cr wcel cB crp wcel cA cB axaddrcl cB rpre
    sylan2 cA cB cmin co cA cB caddc co cA cr elioo3g syl mpbird $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)

  $( An open interval is included in a bound below interval. $)
  oibbi1 $p |- ( A (,) B ) C_ ( A (,) +oo )  $=
    cA cxr wcel cB cxr wcel wa cA cB cioo co cA cpnf cioo co wss cA cxr wcel cB
    cxr wcel cpnf cxr wcel w3a cB cpnf cle wbr cA cB cioo co cA cpnf cioo co
    wss cA cxr wcel cB cxr wcel wa cA cB cpnf iooss2 cA cxr wcel cB cxr wcel wa
    cA cxr wcel cB cxr wcel cpnf cxr wcel cA cxr wcel cB cxr wcel pm3.26 cA cxr
    wcel cB cxr wcel pm3.27 cpnf cxr wcel cA cxr wcel cB cxr wcel wa pnfxr a1i
    3jca cB cxr wcel cB cpnf cle wbr cA cxr wcel cB pnfge adantl sylanc cA cxr
    wcel cB cxr wcel wa wn cA cB cioo co c0 wceq cA cB cioo co cA cpnf cioo co
    wss cA cB ndmioo cA cB cioo co c0 wceq cA cB cioo co cA cpnf cioo co wss c0
    cA cpnf cioo co wss cA cpnf cioo co 0ss cA cB cioo co c0 cA cpnf cioo co
    sseq1 mpbiri syl pm2.61i $.
    $( [28-Jan-2009] $) $( [26-Jan-2009] $)

  $( An open interval is included in a bound above interval. $)
  oibbi2 $p |- ( A (,) B ) C_ ( -oo (,) B )  $=
    cA cxr wcel cB cxr wcel wa cA cB cioo co cmnf cB cioo co wss cmnf cxr wcel
    cA cxr wcel cB cxr wcel w3a cmnf cA cle wbr cA cB cioo co cmnf cB cioo co
    wss cA cxr wcel cB cxr wcel wa cmnf cA cB iooss1 cA cxr wcel cB cxr wcel wa
    cmnf cxr wcel cA cxr wcel cB cxr wcel cmnf cxr wcel cA cxr wcel cB cxr wcel
    wa mnfxr a1i cA cxr wcel cB cxr wcel pm3.26 cA cxr wcel cB cxr wcel pm3.27
    3jca cA cxr wcel cmnf cA cle wbr cB cxr wcel cA mnfle adantr sylanc cA cxr
    wcel cB cxr wcel wa wn cA cB cioo co c0 wceq cA cB cioo co cmnf cB cioo co
    wss cA cB ndmioo cA cB cioo co c0 wceq cA cB cioo co cmnf cB cioo co wss c0
    cmnf cB cioo co wss cmnf cB cioo co 0ss cA cB cioo co c0 cmnf cB cioo co
    sseq1 mpbiri syl pm2.61i $.
    $( [28-Jan-2009] $) $( [26-Jan-2009] $)

  $( Ordering implied by a member of an open interval of reals. $)
  elioooord $p |- ( A e. ( B (,) C ) -> ( B < A /\ A < C ) ) $=
    cA cB cC cioo co wcel cA cr wcel cB cA clt wbr cA cC clt wbr w3a cB cA clt
    wbr cA cC clt wbr wa cA cB cC cioo co wcel cA cr wcel cB cA clt wbr cA cC
    clt wbr w3a cA cB cC cioo co wcel cB cxr wcel cC cxr wcel wa cA cB cC cioo
    co wcel cA cr wcel cB cA clt wbr cA cC clt wbr w3a wb cA cB cC eliooxr cB
    cC cA elioo2 syl ibi cA cr wcel cB cA clt wbr cA cC clt wbr 3simpc syl $.
    $( [28-Jan-2009] $) $( [26-Jan-2009] $)

  $( Membership in an open interval of extended reals. $)
  nelioo5 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* )
           -> ( -. C e. ( A (,) B ) <-> ( C <_ A \/ B <_ C ) ) ) $=
    cA cxr wcel cB cxr wcel cC cxr wcel w3a cC cA cB cioo co wcel wn cA cC clt
    wbr cC cB clt wbr wa wn cA cC clt wbr wn cC cB clt wbr wn wo cC cA cle wbr
    cB cC cle wbr wo cA cxr wcel cB cxr wcel cC cxr wcel w3a cC cA cB cioo co
    wcel cA cC clt wbr cC cB clt wbr wa cA cB cC elioo5 notbid cA cC clt wbr cC
    cB clt wbr wa wn cA cC clt wbr wn cC cB clt wbr wn wo wb cA cxr wcel cB cxr
    wcel cC cxr wcel w3a cA cC clt wbr cC cB clt wbr ianor a1i cA cxr wcel cB
    cxr wcel cC cxr wcel w3a cA cC clt wbr wn cC cA cle wbr cC cB clt wbr wn cB
    cC cle wbr cA cxr wcel cC cxr wcel cA cC clt wbr wn cC cA cle wbr wb cB cxr
    wcel cA cxr wcel cC cxr wcel wa cC cA cle wbr cA cC clt wbr wn cC cxr wcel
    cA cxr wcel cC cA cle wbr cA cC clt wbr wn wb cC cA xrlenlt ancoms bicomd
    3adant2 cB cxr wcel cC cxr wcel cC cB clt wbr wn cB cC cle wbr wb cA cxr
    wcel cB cxr wcel cC cxr wcel wa cB cC cle wbr cC cB clt wbr wn cB cC
    xrlenlt bicomd 3adant1 orbi12d 3bitrd $.
    $( [7-Dec-2010] $) $( [7-Dec-2010] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( The empty set is not a topology. $)
  empntop $p |- -. (/) e. Top $=
    c0 ctop wcel c0 c0 wcel c0 noel c0 0opn mto $.
    $( [1-Jun-2008] $) $( [1-Jun-2008] $)

  $( A topology is not empty. $)
  topnem $p |- ( J e. Top -> J =/= (/) ) $=
    cJ ctop wcel c0 ctop wcel wn cJ c0 wne empntop cJ ctop wcel c0 ctop wcel wn
    wa cJ c0 wceq wn cJ c0 wne cJ c0 ctop nelneq cJ c0 df-ne sylibr mpan2 $.
    $( [1-Jun-2008] $) $( [1-Jun-2008] $)

  $( A topology includes the indiscrete topology and is included in the
     discrete topology. It also means that when the topologies over the
     same underlying set are ordered by the inclusion, the greater element
     is the discrete topology and the smaller element is the indiscrete one. $)
    topindis $p |- ( J e. Top -> ( { (/) , U. J } C_ J /\ J C_ ~P U. J ) ) $=
      cJ ctop wcel c0 cJ cuni cpr cJ wss cJ cJ cuni cpw wss cJ ctop wcel c0 cJ
      wcel cJ cuni cJ wcel wa c0 cJ cuni cpr cJ wss cJ ctop wcel c0 cJ wcel cJ
      cuni cJ wcel cJ 0opn cJ cJ cuni cJ cuni eqid topopn jca cJ ctop wcel c0
      cvv wcel cJ cuni cvv wcel wa c0 cJ wcel cJ cuni cJ wcel wa c0 cJ cuni cpr
      cJ wss wb cJ ctop wcel cJ cuni cvv wcel c0 cvv wcel cJ ctop uniexg 0ex
      jctil c0 cJ cuni cJ cvv cvv prssg syl mpbid cJ ctop wcel cJ cuni cJ cop
      ctps wcel cJ cJ cuni cpw wss cJ eltopsp cJ cuni cJ cop ctps wcel cJ ctop
      wcel cJ cJ cuni cpw wss wa c0 cJ wcel cJ cuni cJ wcel wa wa cJ cJ cuni
      cpw wss cJ cuni cJ istps2 cJ ctop wcel cJ cJ cuni cpw wss c0 cJ wcel cJ
      cuni cJ wcel wa simplr sylbi sylbir jca $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)

 ${
   clsint.1 $e |- X = U. J $.
   $( The closure of an intersection is included in the intersection of
      the closures. $)
   clsint $p |- ( ( J e. Top /\ S C_ X /\ T C_ X )
     -> ( ( cls ` J ) ` ( S i^i T ) ) C_
     ( ( ( cls ` J ) ` S ) i^i ( ( cls ` J ) ` S ) ) ) $=
     cJ ctop wcel cS cX wss cT cX wss w3a cS cT cin cJ ccl cfv cfv cS cJ ccl
     cfv cfv wss cS cT cin cJ ccl cfv cfv cS cJ ccl cfv cfv wss wa cS cT cin cJ
     ccl cfv cfv cS cJ ccl cfv cfv cS cJ ccl cfv cfv cin wss cJ ctop wcel cS cX
     wss cT cX wss w3a cS cT cin cJ ccl cfv cfv cS cJ ccl cfv cfv wss cS cT cin
     cJ ccl cfv cfv cS cJ ccl cfv cfv wss cJ ctop wcel cS cX wss cS cT cin cS
     wss cS cT cin cJ ccl cfv cfv cS cJ ccl cfv cfv wss cT cX wss cS cS cT cin
     cJ cX clsint.1 clsss cS cT cin cS wss cJ ctop wcel cS cX wss cT cX wss w3a
     cS cT inss1 a1i syld3an3 cJ ctop wcel cS cX wss cS cT cin cS wss cS cT cin
     cJ ccl cfv cfv cS cJ ccl cfv cfv wss cT cX wss cS cS cT cin cJ cX clsint.1
     clsss cS cT cin cS wss cJ ctop wcel cS cX wss cT cX wss w3a cS cT inss1
     a1i syld3an3 jca cS cT cin cJ ccl cfv cfv cS cJ ccl cfv cfv cS cJ ccl cfv
     cfv ssin sylib $.
     $( [3-Aug-2009] $) $( [23-Feb-2009] $)
  $}

  ${ $d J x $. $d P x $. $d S x $. $d X x $.
    islp3.1 $e |- X = U. J $.
    $( The predicate " ` P ` is a limit point of ` S ` " in terms of
       open sets.  see ~ islp2 , ~ elcls , ~ islp . $)
    islp3 $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) ->
     ( P e. ( ( limPt ` J ) ` S ) <->
        A. x e. J ( P e. x -> ( x i^i ( S \ { P } ) ) =/= (/) ) ) ) $=
      cJ ctop wcel cS cX wss cP cX wcel w3a cP cS cJ clp cfv cfv wcel cP cS cP
      csn cdif cJ ccl cfv cfv wcel cP vx cv wcel vx cv cS cP csn cdif cin c0
      wne wi vx cJ wral cJ ctop wcel cS cX wss cP cS cJ clp cfv cfv wcel cP cS
      cP csn cdif cJ ccl cfv cfv wcel wb cP cX wcel cP cS cJ cX islp3.1 islp
      3adant3 cJ ctop wcel cS cP csn cdif cX wss cP cX wcel cP cS cP csn cdif
      cJ ccl cfv cfv wcel cP vx cv wcel vx cv cS cP csn cdif cin c0 wne wi vx
      cJ wral wb cS cX wss vx cP cS cP csn cdif cJ cX islp3.1 elcls cJ ctop
      wcel cS cX wss cP cX wcel w3a cS cP csn cdif cS wss cS cX wss wa cS cP
      csn cdif cX wss cJ ctop wcel cS cX wss cP cX wcel w3a cS cX wss cS cP csn
      cdif cS wss cJ ctop wcel cS cX wss cP cX wcel 3simp2 cS cP csn difss
      jctil cS cP csn cdif cS cX sstr syl syld3an2 bitrd $.
      $( [3-Aug-2009] $) $( [31-Jul-2009] $)
  $}

  ${
    $d A y $. $d B y $. $d F y $. $d J y $.
    mapdiscn2.2 $e |- B = U. J $.
    mapdiscn2.3 $e |- A e. _V $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Continuous functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${ $d x F $.  $d x J $.  $d x K $.  $d x L $.
    $( A mapping remains continuous when the topology associated to
       its domain is replaced by a finer one. $)
    cnrsfin $p |- ( ( J e. Top /\ K e. Top /\ L e. Top ) ->
      ( ( F e. ( J Cn L ) /\ U. J = U. K /\ J C_ K ) -> F e. ( K Cn L ) ) ) $=
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cL ccn co wcel cJ cuni
      cK cuni wceq cJ cK wss w3a cK cuni cL cuni cF wf cF ccnv vx cv cima cK
      wcel vx cL wral wa cF cK cL ccn co wcel cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cF cJ cL ccn co wcel cJ cuni cK cuni wceq cJ cK wss cK cuni cL
      cuni cF wf cF ccnv vx cv cima cK wcel vx cL wral wa cJ ctop wcel cK ctop
      wcel cL ctop wcel w3a cJ cK wss cJ cuni cK cuni wceq cF cJ cL ccn co wcel
      cK cuni cL cuni cF wf cF ccnv vx cv cima cK wcel vx cL wral wa cJ ctop
      wcel cK ctop wcel cL ctop wcel w3a cJ cK wss cJ cuni cK cuni wceq cF cJ
      cL ccn co wcel cK cuni cL cuni cF wf cF ccnv vx cv cima cK wcel vx cL
      wral wa wi cJ ctop wcel cK ctop wcel cL ctop wcel w3a cJ cK wss wa cJ
      cuni cK cuni wceq wa cF cJ cL ccn co wcel cJ cuni cL cuni cF wf cF ccnv
      vx cv cima cJ wcel vx cL wral wa cK cuni cL cuni cF wf cF ccnv vx cv cima
      cK wcel vx cL wral wa cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cL
      ccn co wcel cJ cuni cL cuni cF wf cF ccnv vx cv cima cJ wcel vx cL wral
      wa wb cJ cK wss cJ cuni cK cuni wceq cJ ctop wcel cL ctop wcel cF cJ cL
      ccn co wcel cJ cuni cL cuni cF wf cF ccnv vx cv cima cJ wcel vx cL wral
      wa wb cK ctop wcel vx cF cJ cL cJ cuni cL cuni cJ cuni eqid cL cuni eqid
      iscn 3adant2 ad2antrr cJ ctop wcel cK ctop wcel cL ctop wcel w3a cJ cK
      wss wa cJ cuni cK cuni wceq wa cJ cuni cL cuni cF wf cK cuni cL cuni cF
      wf cF ccnv vx cv cima cJ wcel vx cL wral cF ccnv vx cv cima cK wcel vx cL
      wral cJ cuni cK cuni wceq cJ cuni cL cuni cF wf cK cuni cL cuni cF wf wi
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cJ cK wss wa cJ cuni cK cuni
      wceq cJ cuni cL cuni cF wf cK cuni cL cuni cF wf cJ cuni cK cuni cL cuni
      cF feq2 biimpd adantl cJ cK wss cF ccnv vx cv cima cJ wcel vx cL wral cF
      ccnv vx cv cima cK wcel vx cL wral wi cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cJ cuni cK cuni wceq cJ cK wss cF ccnv vx cv cima cJ wcel cF
      ccnv vx cv cima cK wcel vx cL cJ cK cF ccnv vx cv cima ssel r19.20sdv
      ad2antlr anim12d sylbid exp31 com24 3impd cK ctop wcel cL ctop wcel cF cK
      cL ccn co wcel cK cuni cL cuni cF wf cF ccnv vx cv cima cK wcel vx cL
      wral wa wb cJ ctop wcel vx cF cK cL cK cuni cL cuni cK cuni eqid cL cuni
      eqid iscn 3adant1 sylibrd $.
      $( [1-Jun-2008] $) $( [22-May-2008] $)
  $}

  ${ $d x F $.  $d x J $.  $d x K $.  $d x L $.
    $( A mapping remains continuous when the topology associated to
       its range is replaced by a coarser one. $)
    cnrscoa $p |- ( ( J e. Top /\ K e. Top /\ L e. Top ) ->
      ( ( F e. ( J Cn L ) /\ U. L = U. K /\ K C_ L ) ->
         F e. ( J Cn K ) ) ) $=
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cL ccn co wcel cL cuni
      cK cuni wceq cK cL wss w3a cJ cuni cK cuni cF wf cF ccnv vx cv cima cJ
      wcel vx cK wral wa cF cJ cK ccn co wcel cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cF cJ cL ccn co wcel cL cuni cK cuni wceq cK cL wss cJ cuni cK
      cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa cJ ctop wcel cK ctop
      wcel cL ctop wcel w3a cK cL wss cL cuni cK cuni wceq cF cJ cL ccn co wcel
      cJ cuni cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa cJ ctop
      wcel cK ctop wcel cL ctop wcel w3a cK cL wss cL cuni cK cuni wceq cF cJ
      cL ccn co wcel cJ cuni cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK
      wral wa wi cJ ctop wcel cK ctop wcel cL ctop wcel w3a cK cL wss wa cL
      cuni cK cuni wceq wa cF cJ cL ccn co wcel cJ cuni cL cuni cF wf cF ccnv
      vx cv cima cJ wcel vx cL wral wa cJ cuni cK cuni cF wf cF ccnv vx cv cima
      cJ wcel vx cK wral wa cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cL
      ccn co wcel cJ cuni cL cuni cF wf cF ccnv vx cv cima cJ wcel vx cL wral
      wa wb cK cL wss cL cuni cK cuni wceq cJ ctop wcel cL ctop wcel cF cJ cL
      ccn co wcel cJ cuni cL cuni cF wf cF ccnv vx cv cima cJ wcel vx cL wral
      wa wb cK ctop wcel vx cF cJ cL cJ cuni cL cuni cJ cuni eqid cL cuni eqid
      iscn 3adant2 ad2antrr cJ ctop wcel cK ctop wcel cL ctop wcel w3a cK cL
      wss wa cL cuni cK cuni wceq wa cJ cuni cL cuni cF wf cJ cuni cK cuni cF
      wf cF ccnv vx cv cima cJ wcel vx cL wral cF ccnv vx cv cima cJ wcel vx cK
      wral cL cuni cK cuni wceq cJ cuni cL cuni cF wf cJ cuni cK cuni cF wf wi
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cK cL wss wa cL cuni cK cuni
      wceq cJ cuni cL cuni cF wf cJ cuni cK cuni cF wf cL cuni cK cuni cJ cuni
      cF feq3 biimpd adantl cK cL wss cF ccnv vx cv cima cJ wcel vx cL wral cF
      ccnv vx cv cima cJ wcel vx cK wral wi cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cL cuni cK cuni wceq cF ccnv vx cv cima cJ wcel vx cK cL ssralv
      ad2antlr anim12d sylbid exp31 com24 3impd cJ ctop wcel cK ctop wcel cF cJ
      cK ccn co wcel cJ cuni cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK
      wral wa wb cL ctop wcel vx cF cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni
      eqid iscn 3adant3 sylibrd $.
      $( [1-Jun-2008] $) $( [1-Jun-2008] $)
  $}


  ${ $d A x $.  $d B x $.  $d F x $.  $d J x $.
    mapdiscn.1 $e |- F e. C $.
    mapdiscn.2 $e |- B = U. J $.
    mapdiscn.3 $e |- A e. _V $.
    $( mapdiscn.1 is useless ? $)
    $( Any mapping whose domain is associated to the discrete topology is
       continuous. $)
    mapdiscn $p |- ( ( J e. Top /\ F : A --> B ) ->
      F e. ( ~P A Cn J ) ) $=
      cA cpw ctop wcel cJ ctop wcel cA cB cF wf cF cA cpw cJ ccn co wcel cA
      mapdiscn.3 distop cA cpw ctop wcel cJ ctop wcel wa cA cB cF wf wa cF cA
      cpw cJ ccn co wcel cA cpw cuni cJ cuni cF wf cF ccnv vx cv cima cA cpw
      wcel vx cJ wral wa cA cpw ctop wcel cJ ctop wcel wa cA cB cF wf wa cA cpw
      cuni cJ cuni cF wf cF ccnv vx cv cima cA cpw wcel vx cJ wral cA cB cF wf
      cA cpw cuni cJ cuni cF wf cA cpw ctop wcel cJ ctop wcel wa cA cB cF wf cA
      cpw cuni cJ cuni cF wf cA cA cpw cuni wceq cB cJ cuni wceq cA cB cF wf cA
      cpw cuni cJ cuni cF wf wb cA cpw cuni cA cA unipw eqcomi mapdiscn.2 cA cB
      cA cpw cuni cJ cuni cF feq23 mp2an biimpi adantl cA cpw ctop wcel cJ ctop
      wcel wa cA cB cF wf wa cF ccnv vx cv cima cA cpw wcel vx cJ cA cpw ctop
      wcel cJ ctop wcel wa cA cB cF wf wa vx cv cJ wcel cF ccnv vx cv cima cA
      cpw wcel cF ccnv vx cv cima cF ccnv crn wss cA cpw ctop wcel cJ ctop wcel
      wa cA cB cF wf wa vx cv cJ wcel wa cF ccnv vx cv cima cA cpw wcel wi cF
      ccnv vx cv imassrn cF ccnv vx cv cima cF ccnv crn wss cF ccnv vx cv cima
      cF cdm wss cA cpw ctop wcel cJ ctop wcel wa cA cB cF wf wa vx cv cJ wcel
      wa cF ccnv vx cv cima cA cpw wcel wi cF ccnv crn cF cdm cF ccnv vx cv
      cima cF cdm cF ccnv crn cF dfdm4 eqcomi sseq2i cA cpw ctop wcel cJ ctop
      wcel wa cA cB cF wf wa vx cv cJ wcel wa cF ccnv vx cv cima cF cdm wss cF
      ccnv vx cv cima cA cpw wcel cA cB cF wf cF ccnv vx cv cima cF cdm wss cF
      ccnv vx cv cima cA cpw wcel wi cA cpw ctop wcel cJ ctop wcel wa vx cv cJ
      wcel cF cdm cA wceq cA cB cF wf cF ccnv vx cv cima cF cdm wss cF ccnv vx
      cv cima cA cpw wcel wi cA cB cF fdm cF cdm cA wceq cF ccnv vx cv cima cF
      cdm wss cF ccnv vx cv cima cA wss cA cB cF wf cF ccnv vx cv cima cA cpw
      wcel cF cdm cA wceq cF ccnv vx cv cima cF cdm wss cF ccnv vx cv cima cA
      wss cF cdm cA cF ccnv vx cv cima sseq2 biimpd cA cB cF wf cF ccnv vx cv
      cima cA cpw wcel cF ccnv vx cv cima cA wss cA cB cF wf cF ccnv cvv wcel
      cF ccnv vx cv cima cvv wcel cF ccnv vx cv cima cA cpw wcel cF ccnv vx cv
      cima cA wss wb cA cB cF wf cF cvv wcel cF ccnv cvv wcel cA cB cF wf cA
      cvv wcel cF cvv wcel mapdiscn.3 cA cB cvv cF fex mpan2 cF cvv cnvexg syl
      cF ccnv vx cv cvv imaexg cF ccnv vx cv cima cA cvv elpwg 3syl biimprd
      syl9 mpcom ad2antlr com12 sylbi ax-mp ex r19.21aiv jca cA cpw ctop wcel
      cJ ctop wcel wa cF cA cpw cJ ccn co wcel cA cpw cuni cJ cuni cF wf cF
      ccnv vx cv cima cA cpw wcel vx cJ wral wa wb cA cB cF wf vx cF cA cpw cJ
      cA cpw cuni cJ cuni cA cpw cuni eqid cJ cuni eqid iscn adantr mpbird
      mpanl1 $.
      $( [1-Jun-2008] $) $( [22-May-2008] $)
  $}

  ${ $d A x $.  $d B x $.  $d F x $.  $d J x $.
    mapudiscn.2 $e |- A = U. J $.
    mapudiscn.3 $e |- B e. _V $.
    $( Any mapping whose range is associated to the undiscrete topology is
       continuous. $)
    mapudiscn $p |- ( ( J e. Top /\ F : A --> B ) ->
      F e. ( J Cn { (/) , B } ) ) $=
      cJ ctop wcel c0 cB cpr ctop wcel cA cB cF wf cF cJ c0 cB cpr ccn co wcel
      cB indistop cJ ctop wcel c0 cB cpr ctop wcel wa cA cB cF wf wa cF cJ c0
      cB cpr ccn co wcel cA cB cF wf cF ccnv vx cv cima cJ wcel vx c0 cB cpr
      wral wa cJ ctop wcel c0 cB cpr ctop wcel wa cA cB cF wf wa cA cB cF wf cF
      ccnv vx cv cima cJ wcel vx c0 cB cpr wral cJ ctop wcel c0 cB cpr ctop
      wcel wa cA cB cF wf pm3.27 cJ ctop wcel c0 cB cpr ctop wcel wa cA cB cF
      wf wa cF ccnv vx cv cima cJ wcel vx c0 cB cpr cJ ctop wcel c0 cB cpr ctop
      wcel wa cA cB cF wf wa vx cv c0 wceq vx cv cB wceq wo cF ccnv vx cv cima
      cJ wcel vx cv c0 cB cpr wcel cJ ctop wcel cA cB cF wf vx cv c0 wceq vx cv
      cB wceq wo cF ccnv vx cv cima cJ wcel wi c0 cB cpr ctop wcel vx cv c0
      wceq vx cv cB wceq wo cJ ctop wcel cA cB cF wf wa cF ccnv vx cv cima cJ
      wcel vx cv c0 wceq cJ ctop wcel cA cB cF wf wa cF ccnv vx cv cima cJ wcel
      wi vx cv cB wceq vx cv c0 wceq cJ ctop wcel cF ccnv vx cv cima cJ wcel cA
      cB cF wf vx cv c0 wceq cF ccnv vx cv cima cJ wcel cF ccnv c0 cima cJ wcel
      cJ ctop wcel vx cv c0 wceq cF ccnv vx cv cima cF ccnv c0 cima cJ vx cv c0
      cF ccnv imaeq2 eleq1d cJ ctop wcel c0 cJ cF ccnv c0 cima cJ 0opn cF ccnv
      ima0 syl5eqel syl5bir adantrd vx cv cB wceq cF ccnv vx cv cima cJ wcel cF
      ccnv cB cima cJ wcel cJ ctop wcel cA cB cF wf wa vx cv cB wceq cF ccnv vx
      cv cima cF ccnv cB cima cJ vx cv cB cF ccnv imaeq2 eleq1d cA cB cF wf cJ
      ctop wcel cF ccnv cB cima cJ wcel cA cB cF wf cF ccnv cB cima cA wceq cJ
      ctop wcel cF ccnv cB cima cJ wcel wi cA cB cF fimacnv cF ccnv cB cima cA
      wceq cF ccnv cB cima cJ wcel cA cJ wcel cJ ctop wcel cF ccnv cB cima cA
      cJ eleq1 cJ cA mapudiscn.2 topopn syl5bir syl impcom syl5bir jaoi com12
      adantlr vx cv c0 cB vx visset elpr syl5ib r19.21aiv jca cJ ctop wcel c0
      cB cpr ctop wcel wa cF cJ c0 cB cpr ccn co wcel cA cB cF wf cF ccnv vx cv
      cima cJ wcel vx c0 cB cpr wral wa wb cA cB cF wf vx cF cJ c0 cB cpr cA cB
      mapudiscn.2 c0 cB cpr cuni c0 cB cun cB c0 cun cB c0 cB 0ex mapudiscn.3
      unipr c0 cB uncom cB un0 3eqtrri iscn adantr mpbird mpanl2 $.
      $( [1-Jun-2008] $) $( [1-Jun-2008] $)
  $}

  ${ $d J g s v $. $d X g s v $.
    sallnei.1 $e |- X = U. J $.
    $( Two ways to state the set of all the neighborhoods. $)
    sallnei $p |- (  J e. Top
                      ->   U. ran ( nei ` J )
                         = { v
                           | ( v C_ X /\ E. g e. J g C_ v ) } ) $=
      cJ ctop wcel cJ cnei cfv crn cuni vs cX cpw vs cv cJ cnei cfv cfv ciun vs
      cX cpw vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv
      cab ciun vv cv cX wss vg cv vv cv wss vg cJ wrex wa vv cab cJ ctop wcel
      cJ cnei cfv cX cpw wfn cJ cnei cfv crn cuni vs cX cpw vs cv cJ cnei cfv
      cfv ciun wceq cJ cX sallnei.1 neif cJ cnei cfv cX cpw wfn vs cX cpw vs cv
      cJ cnei cfv cfv ciun cJ cnei cfv crn cuni vs cX cpw cJ cnei cfv fniunfv
      eqcomd syl cJ ctop wcel vs cv cJ cnei cfv cfv vv cv cX wss vs cv vg cv
      wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq vs cX cpw wral vs cX cpw
      vs cv cJ cnei cfv cfv ciun vs cX cpw vv cv cX wss vs cv vg cv wss vg cv
      vv cv wss wa vg cJ wrex wa vv cab ciun wceq cJ ctop wcel vs cv cJ cnei
      cfv cfv vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv
      cab wceq vs cX cpw cJ ctop wcel vs cv cX wss vs cv cJ cnei cfv cfv vv cv
      cX wss vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq vs cv
      cX cpw wcel cJ ctop wcel vs cv cX wss vs cv cJ cnei cfv cfv vv cv cX wss
      vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cab wceq vv vs cv vg
      cJ cX sallnei.1 neival ex vs cv cX vs visset elpw syl5ib r19.21aiv vs cX
      cpw vs cv cJ cnei cfv cfv vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa
      vg cJ wrex wa vv cab iuneq2 syl cJ ctop wcel vv cv cX wss vs cv vg cv wss
      vg cv vv cv wss wa vg cJ wrex wa vs cX cpw wrex vv cab vv cv cX wss vg cv
      vv cv wss vg cJ wrex wa vv cab vs cX cpw vv cv cX wss vs cv vg cv wss vg
      cv vv cv wss wa vg cJ wrex wa vv cab ciun cJ ctop wcel vv cv cX wss vs cv
      vg cv wss vg cv vv cv wss wa vg cJ wrex wa vs cX cpw wrex vv cv cX wss vg
      cv vv cv wss vg cJ wrex wa vv vv cv cX wss vs cv vg cv wss vg cv vv cv
      wss wa vg cJ wrex wa vs cX cpw wrex vv cv cX wss vg cv vv cv wss vg cJ
      wrex wa wb cJ ctop wcel vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa
      vg cJ wrex wa vs cX cpw wrex vv cv cX wss vg cv vv cv wss vg cJ wrex wa
      vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vv cv cX
      wss vg cv vv cv wss vg cJ wrex wa vs cX cpw vv cv cX wss vs cv vg cv wss
      vg cv vv cv wss wa vg cJ wrex wa vv cv cX wss vg cv vv cv wss vg cJ wrex
      wa vs cv cX cpw wcel vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex vg cv
      vv cv wss vg cJ wrex vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa vg
      cv vv cv wss vg cJ vs cv vg cv wss vg cv vv cv wss pm3.27 r19.22si anim2i
      adantl r19.23aiva vv cv cX wss c0 vg cv wss vg cv vv cv wss wa vg cJ wrex
      vv cv cX wss vs cv vg cv wss vg cv vv cv wss wa vg cJ wrex wa vs cX cpw
      wrex vg cv vv cv wss vg cJ wrex c0 cX cpw wcel vv cv cX wss c0 vg cv wss
      vg cv vv cv wss wa vg cJ wrex wa vv cv cX wss vs cv vg cv wss vg cv vv cv
      wss wa vg cJ wrex wa vs cX cpw wrex cX 0elpw vv cv cX wss vs cv vg cv wss
      vg cv vv cv wss wa vg cJ wrex wa vv cv cX wss c0 vg cv wss vg cv vv cv
      wss wa vg cJ wrex wa vs c0 cX cpw vs cv c0 wceq vs cv vg cv wss vg cv vv
      cv wss wa vg cJ wrex c0 vg cv wss vg cv vv cv wss wa vg cJ wrex vv cv cX
      wss vs cv c0 wceq vs cv vg cv wss vg cv vv cv wss wa c0 vg cv wss vg cv
      vv cv wss wa vg cJ vs cv c0 wceq vs cv vg cv wss c0 vg cv wss vg cv vv cv
      wss vs cv c0 vg cv sseq1 anbi1d rexbidv anbi2d rcla4ev mpan vg cv vv cv
      wss c0 vg cv wss vg cv vv cv wss wa vg cJ c0 vg cv wss vg cv vv cv wss vg
      cv 0ss biantrur rexbii sylan2b impbii a1i abbidv vv cv cX wss vs cv vg cv
      wss vg cv vv cv wss wa vg cJ wrex wa vs vv cX cpw iunab syl5eq 3eqtrd $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${ $d J x y z $. $d X y $.
    nsn.1 $e |- X = U. J $.
    $( The neighborhoods of the singletons are neighborhoods. $)
    nsn $p |- ( J e. Top ->
      U_ x e. X ( ( nei ` J ) ` { x } ) C_ U. ran ( nei ` J ) ) $=
      cJ ctop wcel vy vx cX vx cv csn cJ cnei cfv cfv ciun cJ cnei cfv crn cuni
      cJ ctop wcel vy cv vx cX vx cv csn cJ cnei cfv cfv ciun wcel vy cv vz cv
      cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex vy cv cJ cnei cfv crn cuni
      wcel vy cv vx cX vx cv csn cJ cnei cfv cfv ciun wcel cJ ctop wcel vy cv
      vz cv cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex vy cv vx cX vx cv csn
      cJ cnei cfv cfv ciun wcel vy cv vx cv csn cJ cnei cfv cfv wcel vx cX wrex
      cJ ctop wcel vy cv vz cv cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex wi
      vx vy cv cX vx cv csn cJ cnei cfv cfv eliun vy cv vx cv csn cJ cnei cfv
      cfv wcel cJ ctop wcel vy cv vz cv cJ cnei cfv cfv wcel vz cJ cnei cfv cdm
      wrex wi vx cX cJ ctop wcel vx cv cX wcel vy cv vx cv csn cJ cnei cfv cfv
      wcel vy cv vz cv cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex cJ ctop
      wcel vx cv cX wcel vx cv csn cJ cnei cfv cdm wcel vy cv vx cv csn cJ cnei
      cfv cfv wcel vy cv vz cv cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex wi
      cJ ctop wcel vx cv csn cX cpw wcel vx cv csn cJ cnei cfv cdm wcel vx cv
      cX wcel cJ ctop wcel cJ cnei cfv cX cpw wfn vx cv csn cX cpw wcel vx cv
      csn cJ cnei cfv cdm wcel wi cJ cX nsn.1 neif cJ cnei cfv cX cpw wfn cJ
      cnei cfv cdm cX cpw wceq vx cv csn cX cpw wcel vx cv csn cJ cnei cfv cdm
      wcel wi cX cpw cJ cnei cfv fndm vx cv csn cX cpw wcel vx cv csn cJ cnei
      cfv cdm wcel wi cX cpw cJ cnei cfv cdm cX cpw cJ cnei cfv cdm wceq vx cv
      csn cX cpw wcel vx cv csn cJ cnei cfv cdm wcel cX cpw cJ cnei cfv cdm vx
      cv csn eleq2 biimpd eqcoms syl syl vx cv cX vx visset snelpw syl5ib vx cv
      csn cJ cnei cfv cdm wcel vy cv vx cv csn cJ cnei cfv cfv wcel vy cv vz cv
      cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex vy cv vz cv cJ cnei cfv cfv
      wcel vy cv vx cv csn cJ cnei cfv cfv wcel vz vx cv csn cJ cnei cfv cdm vz
      cv vx cv csn wceq vz cv cJ cnei cfv cfv vx cv csn cJ cnei cfv cfv vy cv
      vz cv vx cv csn cJ cnei cfv fveq2 eleq2d rcla4ev ex syl6 com3l r19.23aiv
      sylbi com12 cJ ctop wcel cJ cnei cfv wfun vy cv cJ cnei cfv crn cuni wcel
      vy cv vz cv cJ cnei cfv cfv wcel vz cJ cnei cfv cdm wrex wb cJ ctop wcel
      cJ cnei cfv cJ cuni cpw wfn cJ cnei cfv wfun cJ cJ cuni cJ cuni eqid neif
      cJ cuni cpw cJ cnei cfv fnfun syl vz vy cv cJ cnei cfv elunirn syl
      sylibrd ssrdv $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${ $d A a f $. $d A f x y $. $d J a f $. $d J f x y $. $d X f x y $.
    osneisi.1 $e |- X = U. J $.
    $( The non empty open sets are neighborhoods of the singletons. $)
    osneisi $p |- ( ( J e. Top /\ A =/= (/) ) -> ( A e. J ->
       A e. U_ x e. X ( ( nei ` J ) ` { x } ) ) ) $=
      cJ ctop wcel cA c0 wne wa cA cJ wcel cA vx cX vx cv csn cJ cnei cfv cfv
      ciun wcel cJ ctop wcel cA c0 wne wa cA cJ wcel wa cA vx cv csn cJ cnei
      cfv cfv wcel vx cX wrex cA vx cX vx cv csn cJ cnei cfv cfv ciun wcel cJ
      ctop wcel cA c0 wne wa cA cJ wcel wa cA vx cv csn cJ cnei cfv cfv wcel vx
      cX wrex cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX
      wrex cJ ctop wcel cA c0 wne cA cJ wcel cA cX wss vx cv csn vy cv wss vy
      cv cA wss wa vy cJ wrex wa vx cX wrex cJ ctop wcel cA c0 wne cA cJ wcel
      cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex wi
      wi cJ ctop wcel cJ cvv wcel vf cv cJ wfn va cv c0 wne va cv vf cv cfv va
      cv wcel wi va cJ wral wa vf wex cJ ctop wcel cA c0 wne cA cJ wcel cA cX
      wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex wi wi wi
      cJ ctop elisset va cJ vf ac5g vf cv cJ wfn va cv c0 wne va cv vf cv cfv
      va cv wcel wi va cJ wral wa cJ ctop wcel cA c0 wne cA cJ wcel cA cX wss
      vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex wi wi wi vf
      va cv c0 wne va cv vf cv cfv va cv wcel wi va cJ wral cJ ctop wcel cA c0
      wne cA cJ wcel cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex
      wa vx cX wrex wi wi wi vf cv cJ wfn cA cJ wcel va cv c0 wne va cv vf cv
      cfv va cv wcel wi va cJ wral cJ ctop wcel cA c0 wne cA cX wss vx cv csn
      vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex va cv c0 wne va cv vf
      cv cfv va cv wcel wi va cJ wral cA cJ wcel cJ ctop wcel cA c0 wne cA cX
      wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex wi wi cA
      cJ wcel va cv c0 wne va cv vf cv cfv va cv wcel wi va cJ wral cA c0 wne
      cA vf cv cfv cA wcel wi cA cJ wcel cJ ctop wcel cA c0 wne cA cX wss vx cv
      csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex wi wi wi va cv c0
      wne va cv vf cv cfv va cv wcel wi cA c0 wne cA vf cv cfv cA wcel wi va cA
      cJ va cv cA wceq va cv c0 wne cA c0 wne va cv vf cv cfv va cv wcel cA vf
      cv cfv cA wcel va cv cA c0 neeq1 va cv cA wceq va cv vf cv cfv cA vf cv
      cfv va cv cA va cv cA vf cv fveq2 va cv cA wceq id eleq12d imbi12d rcla4v
      cA c0 wne cA c0 wne cA vf cv cfv cA wcel wi cA cJ wcel cJ ctop wcel cA cX
      wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex cA c0
      wne cA c0 wne cA vf cv cfv cA wcel wi cA vf cv cfv cA wcel cA cJ wcel cJ
      ctop wcel cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx
      cX wrex wi wi cA c0 wne cA vf cv cfv cA wcel pm2.27 cA vf cv cfv cA wcel
      cA cJ wcel cJ ctop wcel cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy
      cJ wrex wa vx cX wrex wi cA vf cv cfv cA wcel cA cJ wcel wa cJ ctop wcel
      cA vf cv cfv cJ cuni wcel cA cX wss vx cv csn vy cv wss vy cv cA wss wa
      vy cJ wrex wa vx cX wrex cA vf cv cfv cA cJ elunii cA vf cv cfv cA wcel
      cA cJ wcel wa cJ ctop wcel cA vf cv cfv cJ cuni wcel cA cX wss vx cv csn
      vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex wi cA vf cv cfv cA
      wcel cA cJ wcel wa cJ ctop wcel wa cA vf cv cfv cX wcel cA cX wss vx cv
      csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cX wrex cA vf cv cfv cJ
      cuni wcel cA vf cv cfv cX wcel cA cX wss cA vf cv cfv csn vy cv wss vy cv
      cA wss wa vy cJ wrex wa cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy
      cJ wrex wa vx cX wrex cA vf cv cfv cA wcel cA cJ wcel wa cJ ctop wcel wa
      cA vf cv cfv cX wcel cA cX wss cA vf cv cfv csn vy cv wss vy cv cA wss wa
      vy cJ wrex wa cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa
      vx cX wrex cA cX wss vx cv csn vy cv wss vy cv cA wss wa vy cJ wrex wa cA
      cX wss cA vf cv cfv csn vy cv wss vy cv cA wss wa vy cJ wrex wa vx cA vf
      cv cfv cX vx cv cA vf cv cfv wceq vx cv csn vy cv wss vy cv cA wss wa vy
      cJ wrex cA vf cv cfv csn vy cv wss vy cv cA wss wa vy cJ wrex cA cX wss
      vx cv cA vf cv cfv wceq vx cv csn vy cv wss vy cv cA wss wa cA vf cv cfv
      csn vy cv wss vy cv cA wss wa vy cJ vx cv cA vf cv cfv wceq vy cv cJ wcel
      wa vx cv csn vy cv wss cA vf cv cfv csn vy cv wss vy cv cA wss vx cv cA
      vf cv cfv wceq vy cv cJ wcel wa vx cv csn cA vf cv cfv csn vy cv vx cv cA
      vf cv cfv wceq vx cv csn cA vf cv cfv csn wceq vy cv cJ wcel vx cv cA vf
      cv cfv sneq adantr sseq1d anbi1d rexbidva anbi2d rcla4ev ex cA vf cv cfv
      cA wcel cA cJ wcel wa cJ ctop wcel wa cA cX wss cA vf cv cfv csn vy cv
      wss vy cv cA wss wa vy cJ wrex cA cJ wcel cA cX wss cA vf cv cfv cA wcel
      cJ ctop wcel cA cJ wcel cA cJ cuni cX cA cJ elssuni osneisi.1 syl6ssr
      ad2antlr cA vf cv cfv cA wcel cA cJ wcel wa cA vf cv cfv csn vy cv wss vy
      cv cA wss wa vy cJ wrex cJ ctop wcel cA vf cv cfv cA wcel cA vf cv cfv
      csn cA wss cA cA wss wa cA cJ wcel cA vf cv cfv csn vy cv wss vy cv cA
      wss wa vy cJ wrex cA vf cv cfv cA wcel cA vf cv cfv csn cA wss cA cA wss
      cA vf cv cfv cA snssi cA ssid jctir cA cJ wcel cA vf cv cfv csn cA wss cA
      cA wss wa cA vf cv cfv csn vy cv wss vy cv cA wss wa vy cJ wrex cA vf cv
      cfv csn vy cv wss vy cv cA wss wa cA vf cv cfv csn cA wss cA cA wss wa vy
      cA cJ vy cv cA wceq cA vf cv cfv csn vy cv wss cA vf cv cfv csn cA wss vy
      cv cA wss cA cA wss vy cv cA cA vf cv cfv csn sseq2 vy cv cA cA sseq1
      anbi12d rcla4ev ex mpan9 adantr jca syl5com cJ cuni cX cA vf cv cfv cX cJ
      cuni osneisi.1 eqcomi eleq2i syl5ib ex mpid ex syl6 com4l syl6 pm2.43a
      com4l adantl 19.23aiv 3syl pm2.43i imp31 cJ ctop wcel cA c0 wne wa cA cJ
      wcel wa cA vx cv csn cJ cnei cfv cfv wcel cA cX wss vx cv csn vy cv wss
      vy cv cA wss wa vy cJ wrex wa vx cX cJ ctop wcel vx cv csn cX wss cA vx
      cv csn cJ cnei cfv cfv wcel cA cX wss vx cv csn vy cv wss vy cv cA wss wa
      vy cJ wrex wa wb cJ ctop wcel cA c0 wne wa cA cJ wcel wa vx cv cX wcel vx
      cv csn vy cJ cA cX osneisi.1 isnei cJ ctop wcel cA c0 wne cA cJ wcel
      simpll vx cv cX snssi syl2an rexbidva mpbird vx cA cX vx cv csn cJ cnei
      cfv cfv eliun sylibr ex $.
      $( [3-Aug-2009] $) $( [16-Jul-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Homeomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( In this section every @d statement has been checked. 10-Feb-2008 $)

  ${ $d F x y $.  $d G x y $.  $d J x y $.  $d K x y $.  $d L x y $.
    $( The composition of two homeomorphisms is a homeomorphism. $)
    cmphmp $p |- ( ( J e. Top /\ K e. Top /\ L e. Top ) ->
     ( ( F e. ( J Homeo K ) /\ G e. ( K Homeo L ) ) ->
     ( G o. F ) e. ( J Homeo L ) ) ) $=
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK chomeosm co wcel cG
      cK cL chomeosm co wcel wa cG cF ccom cJ cL chomeosm co wcel cJ ctop wcel
      cK ctop wcel cL ctop wcel w3a cF cJ cK chomeosm co wcel cG cK cL chomeosm
      co wcel wa wa cG cF ccom cJ cL chomeosm co wcel cJ cuni cL cuni cG cF
      ccom wf1o cG cF ccom vx cv cima cL wcel vx cJ wral cG cF ccom ccnv vx cv
      cima cJ wcel vx cL wral w3a cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF
      cJ cK chomeosm co wcel cG cK cL chomeosm co wcel wa wa cJ cuni cL cuni cG
      cF ccom wf1o cG cF ccom vx cv cima cL wcel vx cJ wral cG cF ccom ccnv vx
      cv cima cJ wcel vx cL wral cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF
      cJ cK chomeosm co wcel cG cK cL chomeosm co wcel wa wa cJ cuni cK cuni cF
      wf1o cK cuni cL cuni cG wf1o wa cK cuni cL cuni cG wf1o cJ cuni cK cuni
      cF wf1o wa cJ cuni cL cuni cG cF ccom wf1o cJ ctop wcel cK ctop wcel cL
      ctop wcel w3a cF cJ cK chomeosm co wcel cG cK cL chomeosm co wcel wa cJ
      cuni cK cuni cF wf1o cK cuni cL cuni cG wf1o wa cJ ctop wcel cK ctop wcel
      cL ctop wcel w3a cF cJ cK chomeosm co wcel cJ cuni cK cuni cF wf1o cG cK
      cL chomeosm co wcel cK cuni cL cuni cG wf1o cJ ctop wcel cK ctop wcel cF
      cJ cK chomeosm co wcel cJ cuni cK cuni cF wf1o wi cL ctop wcel cF cJ cK
      cJ cuni cK cuni cJ cuni eqid cK cuni eqid hmeomap 3adant3 cK ctop wcel cL
      ctop wcel cG cK cL chomeosm co wcel cK cuni cL cuni cG wf1o wi cJ ctop
      wcel cG cK cL cK cuni cL cuni cK cuni eqid cL cuni eqid hmeomap 3adant1
      anim12d imp cJ cuni cK cuni cF wf1o cK cuni cL cuni cG wf1o pm3.22 cJ
      cuni cK cuni cL cuni cG cF f1oco 3syl cJ ctop wcel cK ctop wcel cL ctop
      wcel w3a cF cJ cK chomeosm co wcel cG cK cL chomeosm co wcel wa wa cF vx
      cv cima cK wcel vx cJ wral cG vy cv cima cL wcel vy cK wral wa cG cF ccom
      vx cv cima cL wcel vx cJ wral cJ ctop wcel cK ctop wcel cL ctop wcel w3a
      cF cJ cK chomeosm co wcel cG cK cL chomeosm co wcel wa cF vx cv cima cK
      wcel vx cJ wral cG vy cv cima cL wcel vy cK wral wa cJ ctop wcel cK ctop
      wcel cL ctop wcel w3a cF cJ cK chomeosm co wcel cF vx cv cima cK wcel vx
      cJ wral cG cK cL chomeosm co wcel cG vy cv cima cL wcel vy cK wral cJ
      ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF vx cv cima cK wcel vx
      cJ wral wi cL ctop wcel vx cF cJ cK hmeocnb 3adant3 cK ctop wcel cL ctop
      wcel cG cK cL chomeosm co wcel cG vy cv cima cL wcel vy cK wral wi cJ
      ctop wcel vy cG cK cL hmeocnb 3adant1 anim12d imp cF vx cv cima cK wcel
      vx cJ wral cG vy cv cima cL wcel vy cK wral wa cG cF ccom vx cv cima cL
      wcel vx cJ cF vx cv cima cK wcel vx cJ wral cG vy cv cima cL wcel vy cK
      wral vx cF vx cv cima cK wcel vx cJ hbra1 cG vy cv cima cL wcel vx vy cK
      vy cv cK wcel vx ax-17 cG vy cv cima cL wcel vx ax-17 hbral hban cF vx cv
      cima cK wcel vx cJ wral cG vy cv cima cL wcel vy cK wral vx cv cJ wcel cG
      cF ccom vx cv cima cL wcel wi cF vx cv cima cK wcel vx cJ wral vx cv cJ
      wcel cF vx cv cima cK wcel wi vx wal cG vy cv cima cL wcel vy cK wral vx
      cv cJ wcel cG cF ccom vx cv cima cL wcel wi wi cF vx cv cima cK wcel vx
      cJ df-ral vx cv cJ wcel cF vx cv cima cK wcel wi cG vy cv cima cL wcel vy
      cK wral vx cv cJ wcel cG cF ccom vx cv cima cL wcel wi wi vx vx cv cJ
      wcel cF vx cv cima cK wcel wi cG vy cv cima cL wcel vy cK wral vx cv cJ
      wcel cG cF ccom vx cv cima cL wcel wi vx cv cJ wcel vx cv cJ wcel cF vx
      cv cima cK wcel wi cG vy cv cima cL wcel vy cK wral wa cG cF vx cv cima
      cima cL wcel cG cF ccom vx cv cima cL wcel vx cv cJ wcel vx cv cJ wcel cF
      vx cv cima cK wcel wi cG vy cv cima cL wcel vy cK wral cG cF vx cv cima
      cima cL wcel vx cv cJ wcel vx cv cJ wcel cF vx cv cima cK wcel wi wa cF
      vx cv cima cK wcel cG vy cv cima cL wcel vy cK wral cG cF vx cv cima cima
      cL wcel wi vx cv cJ wcel cF vx cv cima cK wcel pm3.35 cG vy cv cima cL
      wcel cG cF vx cv cima cima cL wcel vy cF vx cv cima cK vy cv cF vx cv
      cima wceq cG vy cv cima cG cF vx cv cima cima cL vy cv cF vx cv cima cG
      imaeq2 eleq1d rcla4v syl expimpd cG cF vx cv cima cima cL wcel cG cF ccom
      vx cv cima cL wcel cG cF vx cv cima cima cG cF ccom vx cv cima cL cG cF
      ccom vx cv cima cG cF vx cv cima cima cG cF vx cv imaco eqcomi eleq1i
      biimpi syl6com ex a4s sylbi imp r19.21ai syl cJ ctop wcel cK ctop wcel cL
      ctop wcel w3a cF cJ cK chomeosm co wcel cG cK cL chomeosm co wcel wa wa
      cF ccnv vy cv cima cJ wcel vy cK wral cG ccnv vx cv cima cK wcel vx cL
      wral wa cG cF ccom ccnv vx cv cima cJ wcel vx cL wral cJ ctop wcel cK
      ctop wcel cL ctop wcel w3a cF cJ cK chomeosm co wcel cG cK cL chomeosm co
      wcel wa cF ccnv vy cv cima cJ wcel vy cK wral cG ccnv vx cv cima cK wcel
      vx cL wral wa cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK
      chomeosm co wcel cF ccnv vy cv cima cJ wcel vy cK wral cG cK cL chomeosm
      co wcel cG ccnv vx cv cima cK wcel vx cL wral cJ ctop wcel cK ctop wcel
      cF cJ cK chomeosm co wcel cF ccnv vy cv cima cJ wcel vy cK wral wi cL
      ctop wcel vy cF cJ cK hmeocna 3adant3 cK ctop wcel cL ctop wcel cG cK cL
      chomeosm co wcel cG ccnv vx cv cima cK wcel vx cL wral wi cJ ctop wcel vx
      cG cK cL hmeocna 3adant1 anim12d imp cF ccnv vy cv cima cJ wcel vy cK
      wral cG ccnv vx cv cima cK wcel vx cL wral wa cG cF ccom ccnv vx cv cima
      cJ wcel vx cL cF ccnv vy cv cima cJ wcel vy cK wral cG ccnv vx cv cima cK
      wcel vx cL wral vx cF ccnv vy cv cima cJ wcel vy cK wral vx ax-17 cG ccnv
      vx cv cima cK wcel vx cL hbra1 hban cG ccnv vx cv cima cK wcel vx cL wral
      cF ccnv vy cv cima cJ wcel vy cK wral vx cv cL wcel cG cF ccom ccnv vx cv
      cima cJ wcel wi cG ccnv vx cv cima cK wcel vx cL wral vx cv cL wcel cG
      ccnv vx cv cima cK wcel wi vx wal cF ccnv vy cv cima cJ wcel vy cK wral
      vx cv cL wcel cG cF ccom ccnv vx cv cima cJ wcel wi wi cG ccnv vx cv cima
      cK wcel vx cL df-ral vx cv cL wcel cG ccnv vx cv cima cK wcel wi cF ccnv
      vy cv cima cJ wcel vy cK wral vx cv cL wcel cG cF ccom ccnv vx cv cima cJ
      wcel wi wi vx vx cv cL wcel cG ccnv vx cv cima cK wcel wi cF ccnv vy cv
      cima cJ wcel vy cK wral vx cv cL wcel cG cF ccom ccnv vx cv cima cJ wcel
      wi vx cv cL wcel vx cv cL wcel cG ccnv vx cv cima cK wcel wi cF ccnv vy
      cv cima cJ wcel vy cK wral wa cF ccnv cG ccnv vx cv cima cima cJ wcel cG
      cF ccom ccnv vx cv cima cJ wcel vx cv cL wcel vx cv cL wcel cG ccnv vx cv
      cima cK wcel wi cF ccnv vy cv cima cJ wcel vy cK wral cF ccnv cG ccnv vx
      cv cima cima cJ wcel vx cv cL wcel vx cv cL wcel cG ccnv vx cv cima cK
      wcel wi wa cG ccnv vx cv cima cK wcel cF ccnv vy cv cima cJ wcel vy cK
      wral cF ccnv cG ccnv vx cv cima cima cJ wcel wi vx cv cL wcel cG ccnv vx
      cv cima cK wcel pm3.35 cF ccnv vy cv cima cJ wcel cF ccnv cG ccnv vx cv
      cima cima cJ wcel vy cG ccnv vx cv cima cK vy cv cG ccnv vx cv cima wceq
      cF ccnv vy cv cima cF ccnv cG ccnv vx cv cima cima cJ vy cv cG ccnv vx cv
      cima cF ccnv imaeq2 eleq1d rcla4v syl expimpd cF ccnv cG ccnv vx cv cima
      cima cJ wcel cG cF ccom ccnv vx cv cima cJ wcel cF ccnv cG ccnv vx cv
      cima cima cG cF ccom ccnv vx cv cima cJ cG cF ccom ccnv vx cv cima cF
      ccnv cG ccnv ccom vx cv cima cF ccnv cG ccnv vx cv cima cima cG cF ccom
      ccnv cF ccnv cG ccnv ccom vx cv cG cF cnvco imaeq1i cF ccnv cG ccnv vx cv
      imaco eqtr2i eleq1i biimpi syl6com ex a4s sylbi impcom r19.21ai syl 3jca
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a cF cJ cK chomeosm co wcel cG
      cK cL chomeosm co wcel wa cG cF ccom cJ cL chomeosm co wcel cJ cuni cL
      cuni cG cF ccom wf1o cG cF ccom vx cv cima cL wcel vx cJ wral cG cF ccom
      ccnv vx cv cima cJ wcel vx cL wral w3a wb cJ ctop wcel cK ctop wcel cL
      ctop wcel w3a cG cF ccom cvv wcel cG cF ccom cJ cL chomeosm co wcel cJ
      cuni cL cuni cG cF ccom wf1o cG cF ccom vx cv cima cL wcel vx cJ wral cG
      cF ccom ccnv vx cv cima cJ wcel vx cL wral w3a wb cF cJ cK chomeosm co
      wcel cG cK cL chomeosm co wcel wa cJ ctop wcel cL ctop wcel cG cF ccom
      cvv wcel cG cF ccom cJ cL chomeosm co wcel cJ cuni cL cuni cG cF ccom
      wf1o cG cF ccom vx cv cima cL wcel vx cJ wral cG cF ccom ccnv vx cv cima
      cJ wcel vx cL wral w3a wb wi cK ctop wcel cJ ctop wcel cL ctop wcel cG cF
      ccom cvv wcel cG cF ccom cJ cL chomeosm co wcel cJ cuni cL cuni cG cF
      ccom wf1o cG cF ccom vx cv cima cL wcel vx cJ wral cG cF ccom ccnv vx cv
      cima cJ wcel vx cL wral w3a wb vx cvv cG cF ccom cJ cL cJ cuni cL cuni cJ
      cuni eqid cL cuni eqid ishomeo 3expia 3adant2 cG cK cL chomeosm co wcel
      cF cJ cK chomeosm co wcel cG cF ccom cvv wcel cG cF cK cL chomeosm co cJ
      cK chomeosm co coexg ancoms syl5 imp mpbird ex $.
      $( [11-Mar-2007] $) $( [9-Mar-2007] $)
  $}

  ${ $d J x $.  $d X x $.
    idhme.1 $e |- X = U. J $.
    $( The identity function is a homeomorphism. $)
    idhme $p |- ( J e. Top -> ( _I |` X ) e. ( J Homeo J ) ) $=
      cJ ctop wcel cid cX cres cvv wcel cid cX cres cJ cJ chomeosm co wcel cJ
      ctop wcel cX cvv wcel cid cX cres cvv wcel cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg idhme.1 syl5eqel cX cvv resiexg syl cJ ctop wcel cid cX cres
      cvv wcel cid cX cres cJ cJ chomeosm co wcel cJ ctop wcel cJ ctop wcel cid
      cX cres cvv wcel w3a cid cX cres cJ cJ chomeosm co wcel cX cX cid cX cres
      wf1o cid cX cres vx cv cima cJ wcel vx cJ wral cid cX cres ccnv vx cv
      cima cJ wcel vx cJ wral w3a cJ ctop wcel cJ ctop wcel cid cX cres cvv
      wcel w3a cX cX cid cX cres wf1o cid cX cres vx cv cima cJ wcel vx cJ wral
      cid cX cres ccnv vx cv cima cJ wcel vx cJ wral cX cX cid cX cres wf1o cJ
      ctop wcel cJ ctop wcel cid cX cres cvv wcel w3a cX f1oi a1i cid cX cres
      vx cv cima cJ wcel vx cJ wral cJ ctop wcel cJ ctop wcel cid cX cres cvv
      wcel w3a cid cX cres vx cv cima cJ wcel vx cJ vx cv cJ wcel cid cX cres
      vx cv cima vx cv cJ vx cv cJ wcel vx cv cJ cuni wss vx cv cX wss cid cX
      cres vx cv cima vx cv wceq vx cv cJ elssuni vx cv cJ cuni wss vx cv cJ
      cuni cX vx cv cJ cuni wss id idhme.1 syl6ssr cX vx cv resiima 3syl vx cv
      cJ wcel id eqeltrd rgen a1i cid cX cres ccnv vx cv cima cJ wcel vx cJ
      wral cJ ctop wcel cJ ctop wcel cid cX cres cvv wcel w3a cid cX cres ccnv
      vx cv cima cJ wcel vx cJ vx cv cJ wcel cid cX cres ccnv vx cv cima vx cv
      cJ vx cv cJ wcel vx cv cJ cuni wss cid cX cres ccnv vx cv cima vx cv wceq
      vx cv cJ elssuni vx cv cJ cuni wss vx cv cX wss cid cX cres ccnv vx cv
      cima vx cv wceq vx cv cJ cuni wss vx cv cJ cuni cX vx cv cJ cuni wss id
      idhme.1 syl6ssr vx cv cX wss cid cX cres ccnv vx cv cima cid cX cres vx
      cv cima vx cv vx cv cX wss cid cX cres ccnv cid cX cres vx cv cid cX cres
      ccnv cid cX cres wceq vx cv cX wss cX cnvresid a1i imaeq1d cX vx cv
      resiima eqtrd syl syl vx cv cJ wcel id eqeltrd rgen a1i 3jca vx cvv cid
      cX cres cJ cJ cX cX idhme.1 idhme.1 ishomeo mpbird 3anidm12 mpdan $.
      $( [20-Feb-2007] $) $( [14-Feb-2007] $)
  $}

  ${ $d F x $.  $d J x $.  $d K x $.
    $( The converse of a homeomorphism is a homeomorphism. $)
    cnvhmphb $p |- ( ( J e. Top /\ K e. Top /\ Rel F ) ->
      ( `' F e. ( J Homeo K ) -> F e. ( K Homeo J ) ) ) $=
      cF ccnv cJ cK chomeosm co wcel cJ ctop wcel cK ctop wcel cF wrel w3a cF
      cK cJ chomeosm co wcel cF ccnv ccnv cvv wcel cF ccnv cJ cK chomeosm co
      wcel cJ ctop wcel cK ctop wcel cF wrel w3a cF cK cJ chomeosm co wcel wi
      cF ccnv cJ cK chomeosm co cnvexg cJ ctop wcel cK ctop wcel cF wrel w3a cF
      ccnv ccnv cvv wcel cF ccnv cJ cK chomeosm co wcel cF cK cJ chomeosm co
      wcel cJ ctop wcel cK ctop wcel cF wrel cF ccnv ccnv cvv wcel cF ccnv cJ
      cK chomeosm co wcel cF cK cJ chomeosm co wcel wi wi cF wrel cF ccnv ccnv
      cvv wcel cJ ctop wcel cK ctop wcel wa cF ccnv cJ cK chomeosm co wcel cF
      cK cJ chomeosm co wcel wi cF ccnv ccnv cvv wcel cF wrel cJ ctop wcel cK
      ctop wcel wa cF ccnv cJ cK chomeosm co wcel cF cK cJ chomeosm co wcel wi
      wi cF wrel cF ccnv ccnv cvv wcel cF cvv wcel cF wrel cJ ctop wcel cK ctop
      wcel wa cF ccnv cJ cK chomeosm co wcel cF cK cJ chomeosm co wcel wi wi wi
      cF wrel cF ccnv ccnv cF cvv cF wrel cF ccnv ccnv cF wceq cF dfrel2 biimpi
      eleq1d cJ ctop wcel cK ctop wcel wa cF cvv wcel cF wrel cF ccnv cJ cK
      chomeosm co wcel cF cK cJ chomeosm co wcel wi cK ctop wcel cJ ctop wcel
      cF cvv wcel cF wrel cF ccnv cJ cK chomeosm co wcel cF cK cJ chomeosm co
      wcel wi wi wi cK ctop wcel cJ ctop wcel cF cvv wcel cF wrel cF ccnv cJ cK
      chomeosm co wcel cF cK cJ chomeosm co wcel wi cK ctop wcel cJ ctop wcel
      cF cvv wcel w3a cF wrel wa cF ccnv cJ cK chomeosm co wcel cK cuni cJ cuni
      cF wf1o cF vx cv cima cJ wcel vx cK wral cF ccnv vx cv cima cK wcel vx cJ
      wral w3a cF cK cJ chomeosm co wcel cK ctop wcel cJ ctop wcel cF cvv wcel
      w3a cF wrel cF ccnv cJ cK chomeosm co wcel cK cuni cJ cuni cF wf1o cF vx
      cv cima cJ wcel vx cK wral cF ccnv vx cv cima cK wcel vx cJ wral w3a wi
      cK ctop wcel cJ ctop wcel cF wrel cF ccnv cJ cK chomeosm co wcel cK cuni
      cJ cuni cF wf1o cF vx cv cima cJ wcel vx cK wral cF ccnv vx cv cima cK
      wcel vx cJ wral w3a wi wi cF cvv wcel cJ ctop wcel cK ctop wcel cF wrel
      cF ccnv cJ cK chomeosm co wcel cK cuni cJ cuni cF wf1o cF vx cv cima cJ
      wcel vx cK wral cF ccnv vx cv cima cK wcel vx cJ wral w3a wi wi cJ ctop
      wcel cK ctop wcel wa cF wrel cF ccnv cJ cK chomeosm co wcel cK cuni cJ
      cuni cF wf1o cF vx cv cima cJ wcel vx cK wral cF ccnv vx cv cima cK wcel
      vx cJ wral w3a cJ ctop wcel cK ctop wcel wa cF wrel wa cF ccnv cJ cK
      chomeosm co wcel wa cK cuni cJ cuni cF wf1o cF vx cv cima cJ wcel vx cK
      wral cF ccnv vx cv cima cK wcel vx cJ wral cJ ctop wcel cK ctop wcel wa
      cF wrel cF ccnv cJ cK chomeosm co wcel cK cuni cJ cuni cF wf1o cJ ctop
      wcel cK ctop wcel wa cF ccnv cJ cK chomeosm co wcel cJ cuni cK cuni cF
      ccnv wf1o cF wrel cK cuni cJ cuni cF wf1o cF ccnv cJ cK cJ cuni cK cuni
      cJ cuni eqid cK cuni eqid hmeomap cF wrel cK cuni cJ cuni cF wf1o cJ cuni
      cK cuni cF ccnv wf1o cK cuni cJ cuni cF f1ocnvb biimprd syl9 imp31 cJ
      ctop wcel cK ctop wcel wa cF wrel cF ccnv cJ cK chomeosm co wcel cF vx cv
      cima cJ wcel vx cK wral cJ ctop wcel cK ctop wcel wa cF ccnv cJ cK
      chomeosm co wcel cF ccnv ccnv vx cv cima cJ wcel vx cK wral cF wrel cF vx
      cv cima cJ wcel vx cK wral vx cF ccnv cJ cK hmeocna cF wrel cF ccnv ccnv
      vx cv cima cJ wcel vx cK wral cF vx cv cima cJ wcel vx cK wral cF wrel cF
      ccnv ccnv vx cv cima cJ wcel cF vx cv cima cJ wcel vx cK cF wrel cF ccnv
      ccnv vx cv cima cF vx cv cima cJ cF wrel cF ccnv ccnv cF vx cv cF wrel cF
      ccnv ccnv cF wceq cF dfrel2 biimpi imaeq1d eleq1d ralbidv biimpd syl9
      imp31 cJ ctop wcel cK ctop wcel wa cF wrel wa cF ccnv cJ cK chomeosm co
      wcel cF ccnv vx cv cima cK wcel vx cJ wral cJ ctop wcel cK ctop wcel wa
      cF ccnv cJ cK chomeosm co wcel cF ccnv vx cv cima cK wcel vx cJ wral wi
      cF wrel vx cF ccnv cJ cK hmeocnb adantr imp 3jca exp31 ancoms 3adant3 imp
      cK ctop wcel cJ ctop wcel cF cvv wcel w3a cF cK cJ chomeosm co wcel cK
      cuni cJ cuni cF wf1o cF vx cv cima cJ wcel vx cK wral cF ccnv vx cv cima
      cK wcel vx cJ wral w3a wb cF wrel vx cvv cF cK cJ cK cuni cJ cuni cK cuni
      eqid cJ cuni eqid ishomeo adantr sylibrd 3exp1 impcom com3l syl6bi
      pm2.43a com3r 3impia com3l mpcom com12 $.
      $( [11-Mar-2007] $) $( [5-Mar-2007] $)
  $}

  ${ $d F j $.  $d J j $.  $d K j $.
    $( The converse of a homeomorphism is a homeomorphism. $)
    cnvhmph $p |- ( ( ( J e. Top /\ K e. Top /\ F e. A ) /\ Rel F ) ->
      ( F e. ( J Homeo K ) <-> `' F e. ( K Homeo J ) ) ) $=
      cJ ctop wcel cK ctop wcel cF cA wcel w3a cF wrel wa cK cuni cJ cuni cF
      ccnv wf1o cF ccnv vj cv cima cJ wcel vj cK wral cF ccnv ccnv vj cv cima
      cK wcel vj cJ wral w3a cJ cuni cK cuni cF wf1o cF vj cv cima cK wcel vj
      cJ wral cF ccnv vj cv cima cJ wcel vj cK wral w3a cF ccnv cK cJ chomeosm
      co wcel cF cJ cK chomeosm co wcel cJ ctop wcel cK ctop wcel cF cA wcel
      w3a cF wrel wa cK cuni cJ cuni cF ccnv wf1o cF ccnv ccnv vj cv cima cK
      wcel vj cJ wral cF ccnv vj cv cima cJ wcel vj cK wral w3a cJ cuni cK cuni
      cF wf1o cF vj cv cima cK wcel vj cJ wral cF ccnv vj cv cima cJ wcel vj cK
      wral w3a cK cuni cJ cuni cF ccnv wf1o cF ccnv vj cv cima cJ wcel vj cK
      wral cF ccnv ccnv vj cv cima cK wcel vj cJ wral w3a cJ ctop wcel cK ctop
      wcel cF cA wcel w3a cF wrel wa cK cuni cJ cuni cF ccnv wf1o cJ cuni cK
      cuni cF wf1o cF ccnv ccnv vj cv cima cK wcel vj cJ wral cF vj cv cima cK
      wcel vj cJ wral cF ccnv vj cv cima cJ wcel vj cK wral cF wrel cK cuni cJ
      cuni cF ccnv wf1o cJ cuni cK cuni cF wf1o wb cJ ctop wcel cK ctop wcel cF
      cA wcel w3a cF wrel cJ cuni cK cuni cF wf1o cK cuni cJ cuni cF ccnv wf1o
      cJ cuni cK cuni cF f1ocnvb bicomd adantl cF wrel cF ccnv ccnv vj cv cima
      cK wcel vj cJ wral cF vj cv cima cK wcel vj cJ wral wb cJ ctop wcel cK
      ctop wcel cF cA wcel w3a cF wrel cF ccnv ccnv vj cv cima cK wcel cF vj cv
      cima cK wcel vj cJ cF wrel cF ccnv ccnv vj cv cima cF vj cv cima cK cF
      wrel cF ccnv ccnv cF vj cv cF wrel cF ccnv ccnv cF wceq cF dfrel2 biimpi
      imaeq1d eleq1d ralbidv adantl 3anbi12d cK cuni cJ cuni cF ccnv wf1o cF
      ccnv vj cv cima cJ wcel vj cK wral cF ccnv ccnv vj cv cima cK wcel vj cJ
      wral 3ancomb syl5bb cJ ctop wcel cK ctop wcel cF cA wcel w3a cF wrel wa
      cK ctop wcel cJ ctop wcel cF ccnv cvv wcel w3a cF ccnv cK cJ chomeosm co
      wcel cK cuni cJ cuni cF ccnv wf1o cF ccnv vj cv cima cJ wcel vj cK wral
      cF ccnv ccnv vj cv cima cK wcel vj cJ wral w3a wb cJ ctop wcel cK ctop
      wcel cF cA wcel w3a cK ctop wcel cJ ctop wcel cF ccnv cvv wcel w3a cF
      wrel cK ctop wcel cJ ctop wcel cF cA wcel cK ctop wcel cJ ctop wcel cF
      ccnv cvv wcel w3a cK ctop wcel cK ctop wcel cJ ctop wcel cJ ctop wcel cF
      cA wcel cF ccnv cvv wcel cK ctop wcel id cJ ctop wcel id cF cA cnvexg
      3anim123i 3com12 adantr vj cvv cF ccnv cK cJ cK cuni cJ cuni cK cuni eqid
      cJ cuni eqid ishomeo syl cJ ctop wcel cK ctop wcel cF cA wcel w3a cF cJ
      cK chomeosm co wcel cJ cuni cK cuni cF wf1o cF vj cv cima cK wcel vj cJ
      wral cF ccnv vj cv cima cJ wcel vj cK wral w3a wb cF wrel vj cA cF cJ cK
      cJ cuni cK cuni cJ cuni eqid cK cuni eqid ishomeo adantr 3bitr4rd $.
      $( [5-Mar-2007] $) $( [15-Feb-2007] $)
  $}

  ${ $d J f g $.  $d J f x $.  $d K f g $.  $d K f x $.
    $( "Is homeomorph to" is symmetric. $)
    hmphsyma $p |- ( ( J e. Top /\ K e. Top ) ->
        ( J ~= K -> K ~= J ) ) $=
      cJ ctop wcel cK ctop wcel wa vf cv cJ cK chomeosm co wcel vf wex vg cv cK
      cJ chomeosm co wcel vg wex cJ cK chomeo wbr cK cJ chomeo wbr cJ ctop wcel
      cK ctop wcel wa vf cv cJ cK chomeosm co wcel vg cv cK cJ chomeosm co wcel
      vg wex vf cJ ctop wcel cK ctop wcel vf cv cvv wcel vf cv cJ cK chomeosm
      co wcel vg cv cK cJ chomeosm co wcel vg wex wi vf visset cJ ctop wcel cK
      ctop wcel vf cv cvv wcel w3a vf cv cJ cK chomeosm co wcel cJ cuni cK cuni
      vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ
      wcel vx cK wral w3a vg cv cK cJ chomeosm co wcel vg wex vx cvv vf cv cJ
      cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid ishomeo cJ ctop wcel cK ctop
      wcel vf cv cvv wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK
      wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vg cv cK cJ
      chomeosm co wcel vg wex vf cv ccnv cvv wcel vf cv ccnv cK cJ chomeosm co
      wcel vg cv cK cJ chomeosm co wcel vg wex cJ ctop wcel cK ctop wcel vf cv
      cvv wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ
      wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa vg cv cK cJ chomeosm
      co wcel vf cv ccnv cK cJ chomeosm co wcel vg vf cv ccnv cvv vg cv vf cv
      ccnv cK cJ chomeosm co eleq1 cla4egv cJ ctop wcel cK ctop wcel vf cv cvv
      wcel w3a vf cv ccnv cvv wcel cJ cuni cK cuni vf cv wf1o vf cv vx cv cima
      cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf cv cvv
      wcel cJ ctop wcel vf cv ccnv cvv wcel cK ctop wcel vf cv cvv cnvexg
      3ad2ant3 adantr cJ ctop wcel cK ctop wcel vf cv cvv wcel w3a cJ cuni cK
      cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima
      cJ wcel vx cK wral w3a wa vf cv ccnv cK cJ chomeosm co wcel cK cuni cJ
      cuni vf cv ccnv wf1o vf cv ccnv vx cv cima cJ wcel vx cK wral vf cv ccnv
      ccnv vx cv cima cK wcel vx cJ wral w3a cJ ctop wcel cK ctop wcel vf cv
      cvv wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ
      wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa cK cuni cJ cuni vf
      cv ccnv wf1o vf cv ccnv ccnv vx cv cima cK wcel vx cJ wral vf cv ccnv vx
      cv cima cJ wcel vx cK wral w3a cK cuni cJ cuni vf cv ccnv wf1o vf cv ccnv
      vx cv cima cJ wcel vx cK wral vf cv ccnv ccnv vx cv cima cK wcel vx cJ
      wral w3a vf cv wrel cJ ctop wcel cK ctop wcel vf cv cvv wcel w3a cJ cuni
      cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv
      cima cJ wcel vx cK wral w3a wa cK cuni cJ cuni vf cv ccnv wf1o vf cv ccnv
      ccnv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK
      wral w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral
      vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vf cv wrel cJ ctop wcel cK
      ctop wcel vf cv cvv wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima
      cK wcel vx cJ wral vf cv wrel vf cv ccnv vx cv cima cJ wcel vx cK wral cJ
      cuni cK cuni vf cv f1orel 3ad2ant1 adantl vf cv wrel cJ ctop wcel cK ctop
      wcel vf cv cvv wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK
      wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a cK cuni cJ
      cuni vf cv ccnv wf1o vf cv ccnv ccnv vx cv cima cK wcel vx cJ wral vf cv
      ccnv vx cv cima cJ wcel vx cK wral w3a vf cv wrel cJ ctop wcel cK ctop
      wcel vf cv cvv wcel w3a wa cJ cuni cK cuni vf cv wf1o cK cuni cJ cuni vf
      cv ccnv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv ccnv vx cv
      cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral vf cv
      ccnv vx cv cima cJ wcel vx cK wral cJ cuni cK cuni vf cv wf1o cK cuni cJ
      cuni vf cv ccnv wf1o wi vf cv wrel cJ ctop wcel cK ctop wcel vf cv cvv
      wcel w3a wa cJ cuni cK cuni vf cv f1ocnv a1i vf cv wrel cJ ctop wcel cK
      ctop wcel vf cv cvv wcel w3a wa vf cv vx cv cima cK wcel vf cv ccnv ccnv
      vx cv cima cK wcel vx cJ vf cv wrel vf cv vx cv cima cK wcel vf cv ccnv
      ccnv vx cv cima cK wcel wi cJ ctop wcel cK ctop wcel vf cv cvv wcel w3a
      vx cv cJ wcel vf cv wrel vf cv vx cv cima cK wcel vf cv ccnv ccnv vx cv
      cima cK wcel vf cv wrel vf cv vx cv cima vf cv ccnv ccnv vx cv cima cK vf
      cv wrel vf cv vf cv ccnv ccnv vx cv vf cv wrel vf cv ccnv ccnv vf cv vf
      cv wrel vf cv ccnv ccnv vf cv wceq vf cv dfrel2 biimpi eqcomd imaeq1d
      eleq1d biimpd ad2antrr r19.20dva vf cv wrel cJ ctop wcel cK ctop wcel vf
      cv cvv wcel w3a wa vf cv ccnv vx cv cima cJ wcel vx cK wral idd 3anim123d
      expimpd mpcom cK cuni cJ cuni vf cv ccnv wf1o vf cv ccnv ccnv vx cv cima
      cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral 3ancomb sylib
      cJ ctop wcel cK ctop wcel vf cv cvv wcel w3a vf cv ccnv cK cJ chomeosm co
      wcel cK cuni cJ cuni vf cv ccnv wf1o vf cv ccnv vx cv cima cJ wcel vx cK
      wral vf cv ccnv ccnv vx cv cima cK wcel vx cJ wral w3a wb cJ cuni cK cuni
      vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ
      wcel vx cK wral w3a cK ctop wcel cJ ctop wcel vf cv cvv wcel vf cv ccnv
      cK cJ chomeosm co wcel cK cuni cJ cuni vf cv ccnv wf1o vf cv ccnv vx cv
      cima cJ wcel vx cK wral vf cv ccnv ccnv vx cv cima cK wcel vx cJ wral w3a
      wb cK ctop wcel cJ ctop wcel vf cv ccnv cvv wcel vf cv ccnv cK cJ
      chomeosm co wcel cK cuni cJ cuni vf cv ccnv wf1o vf cv ccnv vx cv cima cJ
      wcel vx cK wral vf cv ccnv ccnv vx cv cima cK wcel vx cJ wral w3a wb vf
      cv cvv wcel vx cvv vf cv ccnv cK cJ cK cuni cJ cuni cK cuni eqid cJ cuni
      eqid ishomeo vf cv cvv cnvexg syl3an3 3com12 adantr mpbird sylc ex sylbid
      mp3an3 19.23adv vf cJ cK hmph cK ctop wcel cJ ctop wcel cK cJ chomeo wbr
      vg cv cK cJ chomeosm co wcel vg wex wb vg cK cJ hmph ancoms 3imtr4d $.
      $( [11-Mar-2007] $) $( [8-Mar-2007] $)
  $}


  ${
    $( "Is homeomorph to" is symmetric. $)
    hmphsym $p |- ( ( J e. Top /\ K e. Top ) ->
        ( J ~= K <-> K ~= J ) ) $=
      cJ ctop wcel cK ctop wcel wa cJ cK chomeo wbr cK cJ chomeo wbr cJ cK
      hmphsyma cK ctop wcel cJ ctop wcel cK cJ chomeo wbr cJ cK chomeo wbr wi
      cK cJ hmphsyma ancoms impbid $.
      $( [11-Mar-2007] $) $( [22-Feb-2007] $)
  $}

  ${ $d J f $.  $d J x $.
    $( "Is homeomorph to" is reflexive. $)
    hmphre $p |- ( J e. Top -> J ~= J ) $=
      cJ ctop wcel cJ cJ chomeo wbr cJ ctop wcel cJ ctop wcel wa cJ cJ chomeo
      wbr vf cv cJ cJ chomeosm co wcel vf wex cJ ctop wcel cJ ctop wcel vf cv
      cJ cJ chomeosm co wcel vf wex cJ ctop wcel cJ cuni cvv wcel cJ ctop wcel
      vf cv cJ cJ chomeosm co wcel vf wex wi cJ ctop uniexg cJ cuni cvv wcel
      cid cJ cuni cres cvv wcel cJ ctop wcel vf cv cJ cJ chomeosm co wcel vf
      wex wi cJ cuni cvv resiexg cid cJ cuni cres cvv wcel cJ ctop wcel vf cv
      cJ cJ chomeosm co wcel wi vf wex cJ ctop wcel vf cv cJ cJ chomeosm co
      wcel vf wex wi cid cJ cuni cres cvv wcel cJ ctop wcel cid cJ cuni cres cJ
      cJ chomeosm co wcel wi cJ ctop wcel vf cv cJ cJ chomeosm co wcel wi vf
      wex cJ ctop wcel cid cJ cuni cres cvv wcel cid cJ cuni cres cJ cJ
      chomeosm co wcel cJ ctop wcel cid cJ cuni cres cvv wcel cid cJ cuni cres
      cJ cJ chomeosm co wcel wi cJ ctop wcel cJ ctop wcel cid cJ cuni cres cvv
      wcel cid cJ cuni cres cJ cJ chomeosm co wcel cJ ctop wcel cJ ctop wcel
      cid cJ cuni cres cvv wcel w3a cid cJ cuni cres cJ cJ chomeosm co wcel cJ
      cuni cJ cuni cid cJ cuni cres wf1o cid cJ cuni cres vx cv cima cJ wcel vx
      cJ wral cid cJ cuni cres ccnv vx cv cima cJ wcel vx cJ wral w3a cJ ctop
      wcel cJ ctop wcel cid cJ cuni cres cvv wcel w3a cJ cuni cJ cuni cid cJ
      cuni cres wf1o cid cJ cuni cres vx cv cima cJ wcel vx cJ wral cid cJ cuni
      cres ccnv vx cv cima cJ wcel vx cJ wral cJ cuni cJ cuni cid cJ cuni cres
      wf1o cJ ctop wcel cJ ctop wcel cid cJ cuni cres cvv wcel w3a cJ cuni f1oi
      a1i cid cJ cuni cres vx cv cima cJ wcel vx cJ wral cJ ctop wcel cJ ctop
      wcel cid cJ cuni cres cvv wcel w3a cid cJ cuni cres vx cv cima cJ wcel vx
      cJ vx cv cJ wcel vx cv cJ cuni wss cid cJ cuni cres vx cv cima cJ wcel vx
      cv cJ elssuni vx cv cJ cuni wss cid cJ cuni cres vx cv cima cJ wcel vx cv
      cJ wcel vx cv cJ cuni wss cid cJ cuni cres vx cv cima vx cv cJ cJ cuni vx
      cv resiima eleq1d biimprcd mpd rgen a1i cid cJ cuni cres ccnv vx cv cima
      cJ wcel vx cJ wral cJ ctop wcel cJ ctop wcel cid cJ cuni cres cvv wcel
      w3a cid cJ cuni cres ccnv vx cv cima cJ wcel vx cJ vx cv cJ wcel vx cv cJ
      cuni wss cid cJ cuni cres ccnv vx cv cima cJ wcel vx cv cJ elssuni vx cv
      cJ wcel vx cv cJ cuni wss wa cid cJ cuni cres vx cv cima cJ cid cJ cuni
      cres ccnv vx cv cima vx cv cJ wcel vx cv cJ cuni wss wa cid cJ cuni cres
      vx cv cima vx cv cJ vx cv cJ cuni wss cid cJ cuni cres vx cv cima vx cv
      wceq vx cv cJ wcel cJ cuni vx cv resiima adantl vx cv cJ wcel vx cv cJ
      cuni wss pm3.26 eqeltrd cid cJ cuni cres ccnv cid cJ cuni cres vx cv cJ
      cuni cnvresid imaeq1i syl5eqel mpdan rgen a1i 3jca vx cvv cid cJ cuni
      cres cJ cJ cJ cuni cJ cuni cJ cuni eqid cJ cuni eqid ishomeo mpbird 3exp
      pm2.43i com12 cJ ctop wcel vf cv cJ cJ chomeosm co wcel wi cJ ctop wcel
      cid cJ cuni cres cJ cJ chomeosm co wcel wi vf cid cJ cuni cres cvv vf cv
      cid cJ cuni cres wceq vf cv cJ cJ chomeosm co wcel cid cJ cuni cres cJ cJ
      chomeosm co wcel cJ ctop wcel vf cv cid cJ cuni cres cJ cJ chomeosm co
      eleq1 imbi2d cla4egv mpd cJ ctop wcel vf cv cJ cJ chomeosm co wcel vf
      19.37v sylib syl syl imp vf cJ cJ hmph mpbird anidms $.
      $( [5-Mar-2007] $) $( [25-Feb-2007] $)
  $}

  ${ $d J f g h $.  $d K f g $.  $d L f g h $.
    $( "Is homeomorph to" is transitive. $)
    hmphtr $p |- ( ( J e. Top /\ K e. Top /\ L e. Top ) ->
      ( ( J ~= K /\ K ~= L ) -> J ~= L ) ) $=
      cJ ctop wcel cK ctop wcel cL ctop wcel w3a vf cv cJ cK chomeosm co wcel
      vf wex vg cv cK cL chomeosm co wcel vg wex cJ cL chomeo wbr cJ cK chomeo
      wbr cK cL chomeo wbr cJ ctop wcel cK ctop wcel cL ctop wcel w3a vf cv cJ
      cK chomeosm co wcel vf wex vg cv cK cL chomeosm co wcel vg wex wa vh cv
      cJ cL chomeosm co wcel vh wex cJ cL chomeo wbr cJ ctop wcel cK ctop wcel
      cL ctop wcel w3a vf cv cJ cK chomeosm co wcel vf wex vg cv cK cL chomeosm
      co wcel vg wex vh cv cJ cL chomeosm co wcel vh wex cJ ctop wcel cK ctop
      wcel cL ctop wcel w3a vf cv cJ cK chomeosm co wcel vg cv cK cL chomeosm
      co wcel vg wex vh cv cJ cL chomeosm co wcel vh wex wi vf cJ ctop wcel cK
      ctop wcel cL ctop wcel w3a vg cv cK cL chomeosm co wcel vg wex vf cv cJ
      cK chomeosm co wcel vh cv cJ cL chomeosm co wcel vh wex cJ ctop wcel cK
      ctop wcel cL ctop wcel w3a vg cv cK cL chomeosm co wcel vf cv cJ cK
      chomeosm co wcel vh cv cJ cL chomeosm co wcel vh wex wi vg cJ ctop wcel
      cK ctop wcel cL ctop wcel w3a vg cv cK cL chomeosm co wcel vf cv cJ cK
      chomeosm co wcel vh cv cJ cL chomeosm co wcel vh wex vg cv vf cv ccom cvv
      wcel vg cv vf cv ccom cJ cL chomeosm co wcel vh cv cJ cL chomeosm co wcel
      vh wex cJ ctop wcel cK ctop wcel cL ctop wcel w3a vg cv cK cL chomeosm co
      wcel vf cv cJ cK chomeosm co wcel wa wa vh cv cJ cL chomeosm co wcel vg
      cv vf cv ccom cJ cL chomeosm co wcel vh vg cv vf cv ccom cvv vh cv vg cv
      vf cv ccom cJ cL chomeosm co eleq1 cla4egv vg cv cK cL chomeosm co wcel
      vf cv cJ cK chomeosm co wcel wa vg cv vf cv ccom cvv wcel cJ ctop wcel cK
      ctop wcel cL ctop wcel w3a vg cv vf cv cK cL chomeosm co cJ cK chomeosm
      co coexg adantl cJ ctop wcel cK ctop wcel cL ctop wcel w3a vg cv cK cL
      chomeosm co wcel vf cv cJ cK chomeosm co wcel wa vg cv vf cv ccom cJ cL
      chomeosm co wcel cJ ctop wcel cK ctop wcel cL ctop wcel w3a vf cv cJ cK
      chomeosm co wcel vg cv cK cL chomeosm co wcel vg cv vf cv ccom cJ cL
      chomeosm co wcel vf cv vg cv cJ cK cL cmphmp ancomsd imp sylc exp32
      19.23adv com23 19.23adv imp3a cJ ctop wcel cL ctop wcel cJ cL chomeo wbr
      vh cv cJ cL chomeosm co wcel vh wex wb cK ctop wcel vh cJ cL hmph 3adant2
      sylibrd cJ ctop wcel cK ctop wcel cJ cK chomeo wbr vf cv cJ cK chomeosm
      co wcel vf wex wi cL ctop wcel cJ ctop wcel cK ctop wcel wa cJ cK chomeo
      wbr vf cv cJ cK chomeosm co wcel vf wex vf cJ cK hmph biimpd 3adant3 cK
      ctop wcel cL ctop wcel cK cL chomeo wbr vg cv cK cL chomeosm co wcel vg
      wex wi cJ ctop wcel cK ctop wcel cL ctop wcel wa cK cL chomeo wbr vg cv
      cK cL chomeosm co wcel vg wex vg cK cL hmph biimpd 3adant1 syl2and $.
      $( [24-Mar-2007] $) $( [9-Mar-2007] $)
  $}

  ${ $d x y z $.
    $( ` ~= ` is a relation whose domain is included in ` Top ` . $)
    dmhmph $p |- dom ~= C_ Top $=
      chomeo cdm ctop ctop cxp cdm ctop chomeo ctop ctop cxp wss chomeo cdm
      ctop ctop cxp cdm wss chomeo vx cv ctop wcel vy cv ctop wcel wa vz cv vx
      cv vy cv chomeosm co wcel vz wex wa vx vy copab ctop ctop cxp chomeo vx
      cv ctop wcel vy cv ctop wcel vz cv vx cv vy cv chomeosm co wcel vz wex
      w3a vx vy copab vx cv ctop wcel vy cv ctop wcel wa vz cv vx cv vy cv
      chomeosm co wcel vz wex wa vx vy copab vx vy vz df-hmph vx cv ctop wcel
      vy cv ctop wcel vz cv vx cv vy cv chomeosm co wcel vz wex w3a vx cv ctop
      wcel vy cv ctop wcel wa vz cv vx cv vy cv chomeosm co wcel vz wex wa vx
      vy vx cv ctop wcel vy cv ctop wcel vz cv vx cv vy cv chomeosm co wcel vz
      wex df-3an opabbii eqtri vz cv vx cv vy cv chomeosm co wcel vz wex vx vy
      ctop ctop opabssxp eqsstri chomeo ctop ctop cxp dmss ax-mp ctop dmxpid
      sseqtri $.
      $( [24-Mar-2007] $) $( [23-Mar-2007] $)

    $( ` ~= ` is a relation whose range is included in ` Top ` . $)
    rnhmph $p |- ran ~= C_ Top $=
      chomeo crn ctop ctop cxp crn ctop chomeo ctop ctop cxp wss chomeo crn
      ctop ctop cxp crn wss chomeo vx cv ctop wcel vy cv ctop wcel wa vz cv vx
      cv vy cv chomeosm co wcel vz wex wa vx vy copab ctop ctop cxp chomeo vx
      cv ctop wcel vy cv ctop wcel vz cv vx cv vy cv chomeosm co wcel vz wex
      w3a vx vy copab vx cv ctop wcel vy cv ctop wcel wa vz cv vx cv vy cv
      chomeosm co wcel vz wex wa vx vy copab vx vy vz df-hmph vx cv ctop wcel
      vy cv ctop wcel vz cv vx cv vy cv chomeosm co wcel vz wex w3a vx cv ctop
      wcel vy cv ctop wcel wa vz cv vx cv vy cv chomeosm co wcel vz wex wa vx
      vy vx cv ctop wcel vy cv ctop wcel vz cv vx cv vy cv chomeosm co wcel vz
      wex df-3an opabbii eqtri vz cv vx cv vy cv chomeosm co wcel vz wex vx vy
      ctop ctop opabssxp eqsstri chomeo ctop ctop cxp rnss ax-mp ctop ctop
      rnxpss sstri $.
      $( [24-Mar-2007] $) $( [23-Mar-2007] $)
  $}

  ${
    dmhmpha.1 $e |- A e. _V $.
    $( The relation "being homeomorph to" implies the operands are topologies.
    $)
    dmhmpha $p |- ( A ~= B -> A e. Top ) $=
      cA cB chomeo wbr cA chomeo cdm wcel cA ctop wcel cA cB chomeo dmhmpha.1
      breldm chomeo cdm ctop cA dmhmph sseli syl $.
      $( [24-Mar-2007] $) $( [23-Mar-2007] $)
  $}

  ${
    rnhmpha.1 $e |- A e. _V $.
    rnhmpha.2 $e |- B e. _V $.
    $( The relation "being homeomorph to" implies the operands are
       topologies. $)
    rnhmpha $p |- ( A ~= B -> B e. Top ) $=
      cA cB chomeo wbr cB chomeo crn wcel cB ctop wcel cA cB chomeo rnhmpha.1
      rnhmpha.2 brelrn chomeo crn ctop cB rnhmph sseli syl $.
      $( [24-Mar-2007] $) $( [23-Mar-2007] $)
  $}


  ${ $d x y z $.
    $( "Is homeomorph to" is an equivalence relation. $)
    hmpher $p |- Er ~= $=
      vx vy vz chomeo vx cv ctop wcel vy cv ctop wcel wa vx cv vy cv chomeo wbr
      vy cv vx cv chomeo wbr vx cv vy cv chomeo wbr vx cv ctop wcel vy cv ctop
      wcel vx cv vy cv vx visset dmhmpha vx cv vy cv vx visset vy visset
      rnhmpha jca vx cv vy cv hmphsyma mpcom vx cv ctop wcel vy cv ctop wcel vz
      cv ctop wcel w3a vx cv vy cv chomeo wbr vy cv vz cv chomeo wbr wa vx cv
      vz cv chomeo wbr vx cv vy cv chomeo wbr vy cv vz cv chomeo wbr wa vx cv
      ctop wcel vy cv ctop wcel vz cv ctop wcel vx cv vy cv chomeo wbr vx cv
      ctop wcel vy cv vz cv chomeo wbr vx cv vy cv vx visset dmhmpha adantr vy
      cv vz cv chomeo wbr vy cv ctop wcel vx cv vy cv chomeo wbr vy cv vz cv vy
      visset dmhmpha adantl vy cv vz cv chomeo wbr vz cv ctop wcel vx cv vy cv
      chomeo wbr vy cv vz cv vy visset vz visset rnhmpha adantl 3jca vx cv vy
      cv vz cv hmphtr mpcom ster $.
      $( [24-Mar-2007] $) $( [22-Mar-2007] $)
  $}

  ${
    hmphsymv.1 $e |- A e. _V $.
    hmphsymv.2 $e |- B e. _V $.
    $( A more general version of ~ hmphsym .  Certainly not a useful proof
       (since it's a simple consequence of ~ hmpher ) but it shows that the
       conditions of ~ hmphsym could (and should) be weakened. $)
    hmphsymv $p |- ( A ~= B <-> B ~= A ) $=
      cA cB chomeo hmphsymv.1 hmphsymv.2 hmpher ersymb $.
      $( [24-Mar-2007] $) $( [23-Mar-2007] $)

  $}

  ${ $d J a b c j x y z $.  $d f t u v w $.  $d v w x y z $.
  $( Homeomorphisms on a topology ` J ` is a group for composition. This
     means from Felix Klein's point of view that a set equipped with a
     topology is a geometry, namely the  so-called rubber sheet geometry. $)
  hmeogrp $p |- ( J e. Top -> { <. <. x , y >. , z >. |  ( x e. ( J Homeo J )
    /\ y e. ( J Homeo J )  /\ z = ( x o. y ) ) } e. Grp ) $=
    cJ ctop wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz
    cv vx cv vy cv ccom wceq w3a vx vy vz copab2 cgr wcel cJ cJ chomeosm co cJ
    cJ chomeosm co cxp cJ cJ chomeosm co vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 wf va
    cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx
    cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co va cv vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co wceq vc cJ cJ chomeosm co wral vb cJ cJ
    chomeosm co wral va cJ cJ chomeosm co wral vj cv va cv vx cv cJ cJ chomeosm
    co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy
    vz copab2 co va cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vj
    cv wceq vb cJ cJ chomeosm co wrex wa va cJ cJ chomeosm co wral vj cJ cJ
    chomeosm co wrex w3a cJ ctop wcel cJ cJ chomeosm co cJ cJ chomeosm co cxp
    cJ cJ chomeosm co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 wf va cv vb cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv
    vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co vx cv cJ cJ chomeosm co wcel
    vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co wceq vc cJ cJ chomeosm co wral vb cJ cJ chomeosm co wral va cJ cJ
    chomeosm co wral vj cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv
    wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vj cv wceq vb cJ cJ
    chomeosm co wrex wa va cJ cJ chomeosm co wral vj cJ cJ chomeosm co wrex cJ
    ctop wcel vx cv vy cv ccom cJ cJ chomeosm co wcel vy cJ cJ chomeosm co wral
    vx cJ cJ chomeosm co wral cJ cJ chomeosm co cJ cJ chomeosm co cxp cJ cJ
    chomeosm co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 wf cJ ctop wcel vx cv vy cv ccom
    cJ cJ chomeosm co wcel vx vy cJ cJ chomeosm co cJ cJ chomeosm co cJ ctop
    wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa vx cv vy
    cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel cJ ctop wcel vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa vx cv vy cv ccom cJ cJ
    chomeosm co wcel wi cJ ctop wcel cJ ctop wcel cJ ctop wcel vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa vx cv vy cv ccom cJ cJ
    chomeosm co wcel wi cJ ctop wcel cJ ctop wcel cJ ctop wcel w3a vy cv cJ cJ
    chomeosm co wcel vx cv cJ cJ chomeosm co wcel vx cv vy cv ccom cJ cJ
    chomeosm co wcel vy cv vx cv cJ cJ cJ cmphmp ancomsd 3exp pm2.43d pm2.43i
    r19.21aivv vx vy vz cJ cJ chomeosm co cJ cJ chomeosm co vx cv vy cv ccom cJ
    cJ chomeosm co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz
    cv vx cv vy cv ccom wceq w3a vx vy vz copab2 vx cv cJ cJ chomeosm co wcel
    vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa vz cv vx cv vy cv ccom
    wceq wa vx vy vz vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq df-3an oprabbii foprab2 sylib cJ ctop wcel va
    cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx
    cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co va cv vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co wceq vc cJ cJ chomeosm co wral va vb cJ cJ
    chomeosm co cJ cJ chomeosm co cJ ctop wcel va cv cJ cJ chomeosm co wcel vb
    cv cJ cJ chomeosm co wcel wa va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co
    vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv
    vy cv ccom wceq w3a vx vy vz copab2 co va cv vb cv vc cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co wceq vc cJ cJ
    chomeosm co wral cJ ctop wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel wa wa va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co va cv vb cv vc cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co wceq vc cJ cJ chomeosm co cJ
    ctop wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv
    cJ cJ chomeosm co wcel va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co va cv vb cv vc cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co wceq wi cJ ctop wcel va cv cJ
    cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co
    wcel va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co va cv vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co wceq cJ ctop wcel va cv cJ cJ chomeosm co
    wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a wa va cv
    vb cv ccom vc cv ccom va cv vb cv vc cv ccom ccom va cv vb cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv
    vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co vx cv cJ cJ chomeosm co wcel
    vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co va cv vb cv vc cv coass cJ ctop wcel va cv cJ cJ chomeosm co wcel
    vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a wa va cv vb
    cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy
    cv ccom wceq w3a vx vy vz copab2 co vc cv vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2
    co va cv vb cv ccom vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm
    co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv vb cv ccom
    vc cv ccom va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel va cv
    vb cv ccom cvv wcel va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co va cv vb cv ccom vc cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co wceq cJ ctop wcel va cv cJ cJ chomeosm co wcel vb cv
    cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a wa va cv cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel va cv vb cv ccom cvv wcel w3a
    va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv vb cv ccom vc cv vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 vx vy vz va cv vb cv cJ cJ chomeosm co cJ cJ
    chomeosm co vx cv vy cv ccom va cv vb cv ccom vx cv cJ cJ chomeosm co wcel
    vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 va cv vy cv ccom cvv vx cv va cv vy cv coeq1 vy cv vb cv va cv coeq2
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa
    vz cv vx cv vy cv ccom wceq wa vx vy vz vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq df-3an oprabbii
    oprabval2g opreq1d va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co
    wcel vc cv cJ cJ chomeosm co wcel w3a va cv cJ cJ chomeosm co wcel cJ ctop
    wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ
    chomeosm co wcel 3simp1 adantl va cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a vb cv cJ cJ chomeosm co
    wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel
    vc cv cJ cJ chomeosm co wcel 3simp2 adantl va cv cJ cJ chomeosm co wcel vb
    cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a va cv vb cv ccom
    cvv wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co
    wcel va cv vb cv ccom cvv wcel vc cv cJ cJ chomeosm co wcel va cv vb cv cJ
    cJ chomeosm co cJ cJ chomeosm co coexg 3adant3 adantl syl3anc va cv vb cv
    ccom cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel va cv vb cv ccom
    vc cv ccom cvv wcel va cv vb cv ccom vc cv vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2
    co va cv vb cv ccom vc cv ccom wceq cJ ctop wcel va cv cJ cJ chomeosm co
    wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a wa vx vy
    vz va cv vb cv ccom vc cv cJ cJ chomeosm co cJ cJ chomeosm co vx cv vy cv
    ccom va cv vb cv ccom vc cv ccom vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 va cv vb
    cv ccom vy cv ccom cvv vx cv va cv vb cv ccom vy cv coeq1 vy cv vc cv va cv
    vb cv ccom coeq2 vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel wa vz cv vx cv vy cv ccom wceq wa vx vy vz vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    df-3an oprabbii oprabval2g va cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a cJ ctop wcel va cv vb cv
    ccom cJ cJ chomeosm co wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel cJ ctop wcel va cv vb cv ccom cJ cJ chomeosm co wcel wi vc
    cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel va cv cJ cJ chomeosm
    co wcel cJ ctop wcel va cv vb cv ccom cJ cJ chomeosm co wcel wi cJ ctop
    wcel vb cv cJ cJ chomeosm co wcel va cv cJ cJ chomeosm co wcel wa va cv vb
    cv ccom cJ cJ chomeosm co wcel cJ ctop wcel vb cv cJ cJ chomeosm co wcel va
    cv cJ cJ chomeosm co wcel wa va cv vb cv ccom cJ cJ chomeosm co wcel wi cJ
    ctop wcel cJ ctop wcel vb cv cJ cJ chomeosm co wcel va cv cJ cJ chomeosm co
    wcel wa va cv vb cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel cJ ctop
    wcel cJ ctop wcel vb cv cJ cJ chomeosm co wcel va cv cJ cJ chomeosm co wcel
    wa va cv vb cv ccom cJ cJ chomeosm co wcel wi vb cv va cv cJ cJ cJ cmphmp
    3exp pm2.43d pm2.43i com12 ancoms 3adant3 impcom va cv cJ cJ chomeosm co
    wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a vc cv cJ
    cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel vc cv cJ cJ chomeosm co wcel 3simp3 adantl va cv cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel
    w3a va cv vb cv ccom vc cv ccom cvv wcel cJ ctop wcel va cv vb cv ccom cvv
    wcel vc cv cJ cJ chomeosm co wcel va cv vb cv ccom vc cv ccom cvv wcel va
    cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm
    co wcel w3a va cv vb cv ccom vc cv cvv cJ cJ chomeosm co coexg va cv cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel va cv vb cv ccom cvv wcel vc
    cv cJ cJ chomeosm co wcel va cv vb cv cJ cJ chomeosm co cJ cJ chomeosm co
    coexg 3adant3 va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc
    cv cJ cJ chomeosm co wcel 3simp3 sylanc adantl syl3anc eqtrd cJ ctop wcel
    va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ
    chomeosm co wcel w3a wa va cv vb cv vc cv vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2
    co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy
    cv ccom wceq w3a vx vy vz copab2 co va cv vb cv vc cv ccom vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co va cv vb cv vc cv ccom ccom cJ ctop wcel va cv cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel
    w3a wa vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vb cv vc cv ccom va
    cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy
    cv ccom wceq w3a vx vy vz copab2 vb cv cJ cJ chomeosm co wcel vc cv cJ cJ
    chomeosm co wcel vb cv vc cv ccom cJ cJ chomeosm co wcel vb cv vc cv vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co vb cv vc cv ccom wceq cJ ctop wcel va cv cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel
    w3a wa vx vy vz vb cv vc cv cJ cJ chomeosm co cJ cJ chomeosm co vx cv vy cv
    ccom vb cv vc cv ccom vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 vb cv vy cv ccom cJ cJ
    chomeosm co vx cv vb cv vy cv coeq1 vy cv vc cv vb cv coeq2 vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa vz cv vx
    cv vy cv ccom wceq wa vx vy vz vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq df-3an oprabbii oprabval2g va
    cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm
    co wcel w3a vb cv cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm
    co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel 3simp2
    adantl va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ
    cJ chomeosm co wcel w3a vc cv cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ
    cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co
    wcel 3simp3 adantl va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co
    wcel vc cv cJ cJ chomeosm co wcel w3a cJ ctop wcel vb cv vc cv ccom cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel
    cJ ctop wcel vb cv vc cv ccom cJ cJ chomeosm co wcel wi va cv cJ cJ
    chomeosm co wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel
    cJ ctop wcel vb cv vc cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel vc cv
    cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel wa vb cv vc cv ccom cJ
    cJ chomeosm co wcel cJ ctop wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel wa vb cv vc cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel
    cJ ctop wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel wa
    vb cv vc cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel cJ ctop wcel cJ
    ctop wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel wa vb
    cv vc cv ccom cJ cJ chomeosm co wcel wi vc cv vb cv cJ cJ cJ cmphmp 3exp
    pm2.43d pm2.43i com12 ancoms 3adant1 impcom syl3anc opreq2d va cv cJ cJ
    chomeosm co wcel vb cv vc cv ccom cJ cJ chomeosm co wcel va cv vb cv vc cv
    ccom ccom cvv wcel va cv vb cv vc cv ccom vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2
    co va cv vb cv vc cv ccom ccom wceq cJ ctop wcel va cv cJ cJ chomeosm co
    wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel w3a wa vx vy
    vz va cv vb cv vc cv ccom cJ cJ chomeosm co cJ cJ chomeosm co vx cv vy cv
    ccom va cv vb cv vc cv ccom ccom vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 va cv vy
    cv ccom cvv vx cv va cv vy cv coeq1 vy cv vb cv vc cv ccom va cv coeq2 vx
    cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel wa
    vz cv vx cv vy cv ccom wceq wa vx vy vz vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq df-3an oprabbii
    oprabval2g va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv
    cJ cJ chomeosm co wcel w3a va cv cJ cJ chomeosm co wcel cJ ctop wcel va cv
    cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co
    wcel 3simp1 adantl va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co
    wcel vc cv cJ cJ chomeosm co wcel w3a cJ ctop wcel vb cv vc cv ccom cJ cJ
    chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel
    cJ ctop wcel vb cv vc cv ccom cJ cJ chomeosm co wcel wi va cv cJ cJ
    chomeosm co wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel
    cJ ctop wcel vb cv vc cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel vc cv
    cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel wa vb cv vc cv ccom cJ
    cJ chomeosm co wcel cJ ctop wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ
    chomeosm co wcel wa vb cv vc cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel
    cJ ctop wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel wa
    vb cv vc cv ccom cJ cJ chomeosm co wcel wi cJ ctop wcel cJ ctop wcel cJ
    ctop wcel vc cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel wa vb
    cv vc cv ccom cJ cJ chomeosm co wcel wi vc cv vb cv cJ cJ cJ cmphmp 3exp
    pm2.43d pm2.43i com12 ancoms 3adant1 impcom va cv cJ cJ chomeosm co wcel vb
    cv vc cv ccom cvv wcel va cv vb cv vc cv ccom ccom cvv wcel cJ ctop wcel va
    cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm
    co wcel w3a wa va cv vb cv vc cv ccom cJ cJ chomeosm co cvv coexg va cv cJ
    cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co
    wcel w3a va cv cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm co
    wcel vb cv cJ cJ chomeosm co wcel vc cv cJ cJ chomeosm co wcel 3simp1
    adantl va cv cJ cJ chomeosm co wcel vb cv cJ cJ chomeosm co wcel vc cv cJ
    cJ chomeosm co wcel w3a vb cv vc cv ccom cvv wcel cJ ctop wcel vb cv cJ cJ
    chomeosm co wcel vc cv cJ cJ chomeosm co wcel vb cv vc cv ccom cvv wcel va
    cv cJ cJ chomeosm co wcel vb cv vc cv cJ cJ chomeosm co cJ cJ chomeosm co
    coexg 3adant1 adantl sylanc syl3anc eqtrd 3eqtr4a 3exp2 imp32 r19.21aiv ex
    r19.21aivv cid cJ cuni cres cJ cJ chomeosm co wcel cid cJ cuni cres va cv
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co va cv wceq vb cv va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co cid cJ cuni cres wceq vb cJ cJ chomeosm co wrex wa
    va cJ cJ chomeosm co wral vj cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va
    cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vj cv wceq vb cJ cJ
    chomeosm co wrex wa va cJ cJ chomeosm co wral vj cJ cJ chomeosm co wrex cJ
    ctop wcel vj cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv wceq vb cv va
    cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy
    cv ccom wceq w3a vx vy vz copab2 co vj cv wceq vb cJ cJ chomeosm co wrex wa
    va cJ cJ chomeosm co wral cid cJ cuni cres va cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co va cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ
    cuni cres wceq vb cJ cJ chomeosm co wrex wa va cJ cJ chomeosm co wral vj
    cid cJ cuni cres cJ cJ chomeosm co vj cv cid cJ cuni cres wceq vj cv va cv
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co va cv wceq vb cv va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co vj cv wceq vb cJ cJ chomeosm co wrex wa cid cJ cuni
    cres va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv wceq vb cv va cv vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co cid cJ cuni cres wceq vb cJ cJ chomeosm co wrex
    wa va cJ cJ chomeosm co vj cv cid cJ cuni cres wceq vj cv va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co va cv wceq cid cJ cuni cres va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co va cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel
    vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co vj cv wceq vb cJ cJ chomeosm co wrex vb cv va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co cid cJ cuni cres wceq vb cJ cJ chomeosm co wrex vj
    cv cid cJ cuni cres wceq vj cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid
    cJ cuni cres va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv vj cv cid cJ
    cuni cres va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 opreq1 eqeq1d vj cv cid cJ
    cuni cres wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vj cv
    wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ cuni cres wceq vb
    cJ cJ chomeosm co vj cv cid cJ cuni cres vb cv va cv vx cv cJ cJ chomeosm
    co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy
    vz copab2 co eqeq2 rexbidv anbi12d ralbidv rcla4ev cJ cJ cuni cJ cuni eqid
    idhme cJ ctop wcel cid cJ cuni cres va cv vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2
    co va cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm
    co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ cuni cres
    wceq vb cJ cJ chomeosm co wrex wa va cJ cJ chomeosm co cJ ctop wcel va cv
    cJ cJ chomeosm co wcel wa cid cJ cuni cres va cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co va cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ
    cuni cres wceq vb cJ cJ chomeosm co wrex cJ ctop wcel va cv cJ cJ chomeosm
    co wcel wa cid cJ cuni cres va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ
    cuni cres va cv ccom va cv cid cJ cuni cres cJ cJ chomeosm co wcel va cv cJ
    cJ chomeosm co wcel cid cJ cuni cres va cv ccom cJ cJ chomeosm co wcel cid
    cJ cuni cres va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ cuni cres va
    cv ccom wceq cJ ctop wcel va cv cJ cJ chomeosm co wcel wa vx vy vz cid cJ
    cuni cres va cv cJ cJ chomeosm co cJ cJ chomeosm co vx cv vy cv ccom cid cJ
    cuni cres va cv ccom vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 cid cJ cuni cres vy cv
    ccom cJ cJ chomeosm co vx cv cid cJ cuni cres vy cv coeq1 vy cv va cv cid
    cJ cuni cres coeq2 vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel wa vz cv vx cv vy cv ccom wceq wa vx vy vz vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    df-3an oprabbii oprabval2g cJ ctop wcel cid cJ cuni cres cJ cJ chomeosm co
    wcel va cv cJ cJ chomeosm co wcel cJ cJ cuni cJ cuni eqid idhme adantr cJ
    ctop wcel va cv cJ cJ chomeosm co wcel pm3.27 cJ ctop wcel va cv cJ cJ
    chomeosm co wcel cid cJ cuni cres va cv ccom cJ cJ chomeosm co wcel cJ ctop
    wcel va cv cJ cJ chomeosm co wcel cid cJ cuni cres cJ cJ chomeosm co wcel
    cid cJ cuni cres va cv ccom cJ cJ chomeosm co wcel cJ cJ cuni cJ cuni eqid
    idhme cJ ctop wcel va cv cJ cJ chomeosm co wcel cid cJ cuni cres cJ cJ
    chomeosm co wcel cid cJ cuni cres va cv ccom cJ cJ chomeosm co wcel wi wi
    cJ ctop wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel cid cJ cuni cres cJ
    cJ chomeosm co wcel cid cJ cuni cres va cv ccom cJ cJ chomeosm co wcel wi
    wi cJ ctop wcel cJ ctop wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel cid
    cJ cuni cres cJ cJ chomeosm co wcel cid cJ cuni cres va cv ccom cJ cJ
    chomeosm co wcel wi wi cJ ctop wcel cJ ctop wcel cJ ctop wcel w3a va cv cJ
    cJ chomeosm co wcel cid cJ cuni cres cJ cJ chomeosm co wcel cid cJ cuni
    cres va cv ccom cJ cJ chomeosm co wcel va cv cid cJ cuni cres cJ cJ cJ
    cmphmp exp3a 3exp pm2.43d pm2.43i mpid imp syl3anc cJ ctop wcel va cv cJ cJ
    chomeosm co wcel wa cJ cuni cJ cuni va cv wf1o cJ cuni cJ cuni va cv wf cid
    cJ cuni cres va cv ccom va cv wceq cJ ctop wcel va cv cJ cJ chomeosm co
    wcel cJ cuni cJ cuni va cv wf1o cJ ctop wcel va cv cJ cJ chomeosm co wcel
    cJ cuni cJ cuni va cv wf1o wi va cv cJ cJ cJ cuni cJ cuni cJ cuni eqid cJ
    cuni eqid hmeomap anidms imp cJ cuni cJ cuni va cv f1of cJ cuni cJ cuni va
    cv fcoi2 3syl eqtrd va cv ccnv cJ cJ chomeosm co wcel va cv ccnv va cv vx
    cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vx vy vz copab2 co cid cJ cuni cres wceq vb cv va cv vx cv cJ
    cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co cid cJ cuni cres wceq vb cJ cJ chomeosm co wrex
    cJ ctop wcel va cv cJ cJ chomeosm co wcel wa vb cv va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co cid cJ cuni cres wceq va cv ccnv va cv vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vx vy vz copab2 co cid cJ cuni cres wceq vb va cv ccnv cJ cJ chomeosm
    co vb cv va cv ccnv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va
    cv ccnv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz
    cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co cid cJ cuni cres vb cv va
    cv ccnv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz
    cv vx cv vy cv ccom wceq w3a vx vy vz copab2 opreq1 eqeq1d rcla4ev cJ ctop
    wcel va cv cJ cJ chomeosm co wcel va cv ccnv cJ cJ chomeosm co wcel cJ ctop
    wcel va cv cJ cJ chomeosm co wcel va cv ccnv cJ cJ chomeosm co wcel wi va
    cv cJ cJ cnvhmpha anidms imp cJ ctop wcel va cv cJ cJ chomeosm co wcel wa
    va cv ccnv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co va cv ccnv va cv ccom
    cid cJ cuni cres va cv ccnv cJ cJ chomeosm co wcel va cv cJ cJ chomeosm co
    wcel va cv ccnv va cv ccom cJ cJ chomeosm co wcel va cv ccnv va cv vx cv cJ
    cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co va cv ccnv va cv ccom wceq cJ ctop wcel va cv
    cJ cJ chomeosm co wcel wa vx vy vz va cv ccnv va cv cJ cJ chomeosm co cJ cJ
    chomeosm co vx cv vy cv ccom va cv ccnv va cv ccom vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 va cv ccnv vy cv ccom cJ cJ chomeosm co vx cv va cv ccnv vy cv coeq1
    vy cv va cv va cv ccnv coeq2 vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel wa vz cv vx cv vy cv ccom wceq wa vx vy
    vz vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy
    cv ccom wceq df-3an oprabbii oprabval2g cJ ctop wcel va cv cJ cJ chomeosm
    co wcel va cv ccnv cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm
    co wcel va cv ccnv cJ cJ chomeosm co wcel wi va cv cJ cJ cnvhmpha anidms
    imp cJ ctop wcel va cv cJ cJ chomeosm co wcel pm3.27 cJ ctop wcel va cv cJ
    cJ chomeosm co wcel wa va cv ccnv cJ cJ chomeosm co wcel va cv ccnv va cv
    ccom cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel va cv
    ccnv cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel va cv
    ccnv cJ cJ chomeosm co wcel wi va cv cJ cJ cnvhmpha anidms imp cJ ctop wcel
    va cv cJ cJ chomeosm co wcel va cv ccnv cJ cJ chomeosm co wcel va cv ccnv
    va cv ccom cJ cJ chomeosm co wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel
    va cv ccnv cJ cJ chomeosm co wcel wa va cv ccnv va cv ccom cJ cJ chomeosm
    co wcel wi cJ ctop wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel va cv
    ccnv cJ cJ chomeosm co wcel wa va cv ccnv va cv ccom cJ cJ chomeosm co wcel
    wi cJ ctop wcel cJ ctop wcel cJ ctop wcel va cv cJ cJ chomeosm co wcel va
    cv ccnv cJ cJ chomeosm co wcel wa va cv ccnv va cv ccom cJ cJ chomeosm co
    wcel wi va cv va cv ccnv cJ cJ cJ cmphmp 3exp pm2.43d pm2.43i expdimp mpd
    syl3anc cJ ctop wcel va cv cJ cJ chomeosm co wcel wa cJ cuni cJ cuni va cv
    wf1o va cv ccnv va cv ccom cid cJ cuni cres wceq cJ ctop wcel va cv cJ cJ
    chomeosm co wcel cJ cuni cJ cuni va cv wf1o cJ ctop wcel va cv cJ cJ
    chomeosm co wcel cJ cuni cJ cuni va cv wf1o wi va cv cJ cJ cJ cuni cJ cuni
    cJ cuni eqid cJ cuni eqid hmeomap anidms imp cJ cuni cJ cuni va cv
    f1ococnv1 syl eqtrd sylanc jca r19.21aiva sylanc 3jca cJ ctop wcel cJ cJ
    chomeosm co cvv wcel cJ cJ chomeosm co cvv wcel wa vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 cvv wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel
    vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 cgr wcel cJ cJ chomeosm co
    cJ cJ chomeosm co cxp cJ cJ chomeosm co vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 wf
    va cv vb cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx vy vz copab2 co vc cv vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz
    copab2 co va cv vb cv vc cv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 co wceq vc cJ cJ chomeosm co wral vb cJ cJ
    chomeosm co wral va cJ cJ chomeosm co wral vj cv va cv vx cv cJ cJ chomeosm
    co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy
    vz copab2 co va cv wceq vb cv va cv vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 co vj
    cv wceq vb cJ cJ chomeosm co wrex wa va cJ cJ chomeosm co wral vj cJ cJ
    chomeosm co wrex w3a wb cJ cJ chomeosm co cvv wcel cJ cJ chomeosm co cvv
    wcel wa cJ ctop wcel cJ cJ chomeosm co cvv wcel cJ cJ chomeosm co cvv wcel
    cJ cJ chomeosm oprex cJ cJ chomeosm oprex pm3.2i a1i vx vy vz cJ cJ
    chomeosm co cJ cJ chomeosm co vx cv vy cv ccom cvv cvv vx cv cJ cJ chomeosm
    co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy
    vz copab2 vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm
    co wcel wa vz cv vx cv vy cv ccom wceq wa vx vy vz vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq df-3an
    oprabbii oprabex2g va vb vc vj cvv vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz copab2 cJ cJ
    chomeosm co cJ cJ chomeosm co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cab vx cv
    cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vx vy vz copab2 crn cJ ctop wcel cJ cJ chomeosm co vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vy wex vx wex vz cab wceq cJ ctop wcel vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz
    cab cJ cJ chomeosm co cJ ctop wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cJ cJ
    chomeosm co cJ ctop wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm
    co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cv cJ cJ chomeosm
    co wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx
    cv vy cv ccom wceq w3a vy wex vx wex cJ ctop wcel vz cv cJ cJ chomeosm co
    wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv
    vy cv ccom wceq w3a cJ ctop wcel vz cv cJ cJ chomeosm co wcel wi vx vy vx
    cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq cJ ctop wcel vz cv cJ cJ chomeosm co wcel wi vy cv cJ cJ chomeosm
    co wcel vx cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq cJ ctop
    wcel vz cv cJ cJ chomeosm co wcel wi wi cJ ctop wcel vy cv cJ cJ chomeosm
    co wcel vx cv cJ cJ chomeosm co wcel wa vz cv vx cv vy cv ccom wceq vz cv
    cJ cJ chomeosm co wcel cJ ctop wcel vy cv cJ cJ chomeosm co wcel vx cv cJ
    cJ chomeosm co wcel wa vz cv vx cv vy cv ccom wceq vz cv cJ cJ chomeosm co
    wcel wi wi cJ ctop wcel cJ ctop wcel vy cv cJ cJ chomeosm co wcel vx cv cJ
    cJ chomeosm co wcel wa vz cv vx cv vy cv ccom wceq vz cv cJ cJ chomeosm co
    wcel wi wi cJ ctop wcel cJ ctop wcel cJ ctop wcel vy cv cJ cJ chomeosm co
    wcel vx cv cJ cJ chomeosm co wcel wa vz cv vx cv vy cv ccom wceq vz cv cJ
    cJ chomeosm co wcel wi wi cJ ctop wcel cJ ctop wcel cJ ctop wcel w3a vy cv
    cJ cJ chomeosm co wcel vx cv cJ cJ chomeosm co wcel wa vx cv vy cv ccom cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq vz cv cJ cJ chomeosm co
    wcel wi vy cv vx cv cJ cJ cJ cmphmp vx cv vy cv ccom cJ cJ chomeosm co vz
    cv eleq1a syl6 3exp pm2.43d pm2.43i com3l expcom 3imp 19.23aivv com12 cJ
    ctop wcel vz cv cJ cJ chomeosm co wcel vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex cJ
    ctop wcel vz cv cJ cJ chomeosm co wcel wa vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx vz vx
    cv vz cv wceq cJ ctop wcel vz cv cJ cJ chomeosm co wcel wa vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    w3a vy wex wi cJ ctop wcel vx cv cJ cJ chomeosm co wcel wa vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq
    w3a vy wex wi cJ ctop wcel vx cv cJ cJ chomeosm co wcel wa vx cv cJ cJ
    chomeosm co wcel vx cv vx cv vy cv ccom wceq wa vy cJ cJ chomeosm co wrex
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vx cv vx cv vy cv
    ccom wceq w3a vy wex cid cJ cuni cres cJ cJ chomeosm co wcel vx cv cJ cJ
    chomeosm co wcel vx cv vx cv cid cJ cuni cres ccom wceq wa vx cv cJ cJ
    chomeosm co wcel vx cv vx cv vy cv ccom wceq wa vy cJ cJ chomeosm co wrex
    cJ ctop wcel vx cv cJ cJ chomeosm co wcel wa vx cv cJ cJ chomeosm co wcel
    vx cv vx cv vy cv ccom wceq wa vx cv cJ cJ chomeosm co wcel vx cv vx cv cid
    cJ cuni cres ccom wceq wa vy cid cJ cuni cres cJ cJ chomeosm co vy cv cid
    cJ cuni cres wceq vx cv vx cv vy cv ccom wceq vx cv vx cv cid cJ cuni cres
    ccom wceq vx cv cJ cJ chomeosm co wcel vy cv cid cJ cuni cres wceq vx cv vy
    cv ccom vx cv cid cJ cuni cres ccom vx cv vy cv cid cJ cuni cres vx cv
    coeq2 eqeq2d anbi2d rcla4ev cJ ctop wcel cid cJ cuni cres cJ cJ chomeosm co
    wcel vx cv cJ cJ chomeosm co wcel cJ cJ cuni cJ cuni eqid idhme adantr cJ
    ctop wcel vx cv cJ cJ chomeosm co wcel wa vx cv cJ cJ chomeosm co wcel vx
    cv vx cv cid cJ cuni cres ccom wceq cJ ctop wcel vx cv cJ cJ chomeosm co
    wcel pm3.27 cJ ctop wcel vx cv cJ cJ chomeosm co wcel vx cv vx cv cid cJ
    cuni cres ccom wceq cJ ctop wcel vx cv cJ cJ chomeosm co wcel vx cv vx cv
    cid cJ cuni cres ccom wceq wi cJ ctop wcel cJ ctop wcel wa vx cv cJ cJ
    chomeosm co wcel cJ cuni cJ cuni vx cv wf1o vx cv vx cv cid cJ cuni cres
    ccom wceq vx cv cJ cJ cJ cuni cJ cuni cJ cuni eqid cJ cuni eqid hmeomap cJ
    cuni cJ cuni vx cv wf1o vx cv cid cJ cuni cres ccom vx cv cJ cuni cJ cuni
    vx cv wf1o cJ cuni cJ cuni vx cv wf vx cv cid cJ cuni cres ccom vx cv wceq
    cJ cuni cJ cuni vx cv f1of cJ cuni cJ cuni vx cv fcoi1 syl eqcomd syl6
    anidms imp jca sylanc vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vx cv vx cv vy cv ccom wceq w3a vy wex vy cv cJ cJ chomeosm co wcel vx
    cv cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq wa wa vy wex vx cv cJ
    cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq wa vy cJ cJ chomeosm co
    wrex vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vx cv vx cv
    vy cv ccom wceq w3a vy cv cJ cJ chomeosm co wcel vx cv cJ cJ chomeosm co
    wcel vx cv vx cv vy cv ccom wceq wa wa vy vx cv cJ cJ chomeosm co wcel vy
    cv cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq w3a vy cv cJ cJ
    chomeosm co wcel vx cv cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq
    w3a vy cv cJ cJ chomeosm co wcel vx cv cJ cJ chomeosm co wcel vx cv vx cv
    vy cv ccom wceq wa wa vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vx cv vx cv vy cv ccom wceq 3ancoma vy cv cJ cJ chomeosm co wcel vx cv
    cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq 3anass bitri exbii vx cv
    cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq wa vy cJ cJ chomeosm co
    df-rex bitr4i sylibr vx cv vz cv wceq cJ ctop wcel vz cv cJ cJ chomeosm co
    wcel wa cJ ctop wcel vx cv cJ cJ chomeosm co wcel wa vx cv cJ cJ chomeosm
    co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vx cv vx cv vy cv
    ccom wceq w3a vy wex vx cv vz cv wceq vz cv cJ cJ chomeosm co wcel vx cv cJ
    cJ chomeosm co wcel cJ ctop wcel vx cv vz cv wceq vx cv cJ cJ chomeosm co
    wcel vz cv cJ cJ chomeosm co wcel vx cv vz cv cJ cJ chomeosm co eleq1
    bicomd anbi2d vx cv vz cv wceq vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx cv cJ cJ chomeosm co
    wcel vy cv cJ cJ chomeosm co wcel vx cv vx cv vy cv ccom wceq w3a vy vx cv
    vz cv wceq vz cv vx cv vy cv ccom wceq vx cv vx cv vy cv ccom wceq vx cv cJ
    cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vx cv vz cv wceq vx cv vx
    cv vy cv ccom wceq vz cv vx cv vy cv ccom wceq vx cv vz cv vx cv vy cv ccom
    eqeq1 bicomd 3anbi3d exbidv imbi12d mpbiri a4imev ex impbid abbi1dv eqcomd
    cJ ctop wcel wn cJ ctop wcel cJ ctop wcel wa wn cJ cJ chomeosm co vx cv cJ
    cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vy wex vx wex vz cab wceq cJ ctop wcel cJ ctop wcel wa cJ ctop
    wcel cJ ctop wcel cJ ctop wcel pm3.26 con3i cJ cvv wcel cJ ctop wcel cJ
    ctop wcel wa wn cJ cJ chomeosm co vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cab wceq
    wi cJ cvv wcel cJ ctop wcel cJ ctop wcel wa wn cJ cJ chomeosm co vx cv cJ
    cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vy wex vx wex vz cab wceq cJ cvv wcel cJ ctop wcel cJ ctop wcel wa
    wn wa cJ cJ chomeosm co c0 vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cab
    chomeosm cdm ctop ctop cxp wceq cJ cvv wcel cJ ctop wcel cJ ctop wcel wa wn
    cJ cJ chomeosm co c0 wceq vx vy vz ctop ctop vx cv cuni vy cv cuni vv cv
    wf1o vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv
    wcel vw vy cv wral w3a vv cab chomeosm vx cv cuni vy cv cuni vv cv wf1o vv
    cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw
    vy cv wral w3a vv cab vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv
    crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv
    ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vv cab cvv vx cv cuni vy cv
    cuni vv cv wf1o vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv
    cima vx cv wcel vw vy cv wral w3a vx cv cuni vy cv cuni vv cv wf vv cv ccnv
    wfun vv cv crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv
    wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vv vx cv cuni vy
    cv cuni vv cv wf1o vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw
    cv cima vx cv wcel vw vy cv wral w3a vx cv cuni vy cv cuni vv cv wf1o vv cv
    vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy
    cv wral wa wa vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn vy
    cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw
    cv cima vx cv wcel vw vy cv wral wa wa vx cv cuni vy cv cuni vv cv wf1o vv
    cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw
    vy cv wral 3anass vx cv cuni vy cv cuni vv cv wf1o vx cv cuni vy cv cuni vv
    cv wf vv cv ccnv wfun vv cv crn vy cv cuni wceq wa wa vv cv vw cv cima vy
    cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa vx
    cv cuni vy cv cuni vv cv wf1o vx cv cuni vy cv cuni vv cv wf1 vv cv crn vy
    cv cuni wceq wa vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun wa vv cv crn
    vy cv cuni wceq wa vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn
    vy cv cuni wceq wa wa vx cv cuni vy cv cuni vv cv dff1o5 vx cv cuni vy cv
    cuni vv cv wf1 vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun wa vv cv crn
    vy cv cuni wceq vx cv cuni vy cv cuni vv cv df-f1 anbi1i vx cv cuni vy cv
    cuni vv cv wf vv cv ccnv wfun vv cv crn vy cv cuni wceq anass 3bitri anbi1i
    bitri abbii vv cv ccnv wfun vv cv crn vy cv cuni wceq wa vv cv vw cv cima
    vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa
    wa vv vx cv cuni vy cv cuni vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun
    vv cv crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral
    vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vv cab vx cv vx visset
    uniex vy cv vy visset uniex vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun
    vv cv crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral
    vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vx cv cuni vy cv cuni
    vv cv wf vv cv ccnv wfun vv cv crn vy cv cuni wceq wa vv cv vw cv cima vy
    cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa
    wa vv vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn vy cv cuni
    wceq wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx
    cv wcel vw vy cv wral wa anass abbii fabex eqeltri vw vz vv vx vy df-homeo
    dmoprab2 cJ cJ cvv ctop ctop chomeosm ndmoprg mp3an1 cJ cvv wcel cJ ctop
    wcel cJ ctop wcel wa wn wa vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz c0 cJ cvv
    wcel cJ ctop wcel cJ ctop wcel wa wn wa vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cv
    c0 wcel cJ cvv wcel cJ ctop wcel cJ ctop wcel wa wn wa cJ cJ chomeosm co c0
    wceq vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv
    vy cv ccom wceq w3a vy wex vx wex vz cv c0 wcel wi chomeosm cdm ctop ctop
    cxp wceq cJ cvv wcel cJ ctop wcel cJ ctop wcel wa wn cJ cJ chomeosm co c0
    wceq vx vy vz ctop ctop vx cv cuni vy cv cuni vv cv wf1o vv cv vw cv cima
    vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral w3a
    vv cab chomeosm vx cv cuni vy cv cuni vv cv wf1o vv cv vw cv cima vy cv
    wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral w3a vv
    cab vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn vy cv cuni
    wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima
    vx cv wcel vw vy cv wral wa wa vv cab cvv vx cv cuni vy cv cuni vv cv wf1o
    vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel
    vw vy cv wral w3a vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn
    vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv
    vw cv cima vx cv wcel vw vy cv wral wa wa vv vx cv cuni vy cv cuni vv cv
    wf1o vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv
    wcel vw vy cv wral w3a vx cv cuni vy cv cuni vv cv wf1o vv cv vw cv cima vy
    cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa
    vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn vy cv cuni wceq wa
    wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv
    wcel vw vy cv wral wa wa vx cv cuni vy cv cuni vv cv wf1o vv cv vw cv cima
    vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral
    3anass vx cv cuni vy cv cuni vv cv wf1o vx cv cuni vy cv cuni vv cv wf vv
    cv ccnv wfun vv cv crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw
    vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa vx cv cuni vy
    cv cuni vv cv wf1o vx cv cuni vy cv cuni vv cv wf1 vv cv crn vy cv cuni
    wceq wa vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun wa vv cv crn vy cv
    cuni wceq wa vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn vy cv
    cuni wceq wa wa vx cv cuni vy cv cuni vv cv dff1o5 vx cv cuni vy cv cuni vv
    cv wf1 vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun wa vv cv crn vy cv
    cuni wceq vx cv cuni vy cv cuni vv cv df-f1 anbi1i vx cv cuni vy cv cuni vv
    cv wf vv cv ccnv wfun vv cv crn vy cv cuni wceq anass 3bitri anbi1i bitri
    abbii vv cv ccnv wfun vv cv crn vy cv cuni wceq wa vv cv vw cv cima vy cv
    wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vv
    vx cv cuni vy cv cuni vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv
    crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv
    ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vv cab vx cv vx visset uniex
    vy cv vy visset uniex vx cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv
    crn vy cv cuni wceq wa wa vv cv vw cv cima vy cv wcel vw vx cv wral vv cv
    ccnv vw cv cima vx cv wcel vw vy cv wral wa wa vx cv cuni vy cv cuni vv cv
    wf vv cv ccnv wfun vv cv crn vy cv cuni wceq wa vv cv vw cv cima vy cv wcel
    vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw vy cv wral wa wa wa vv vx
    cv cuni vy cv cuni vv cv wf vv cv ccnv wfun vv cv crn vy cv cuni wceq wa vv
    cv vw cv cima vy cv wcel vw vx cv wral vv cv ccnv vw cv cima vx cv wcel vw
    vy cv wral wa anass abbii fabex eqeltri vw vz vv vx vy df-homeo dmoprab2 cJ
    cJ cvv ctop ctop chomeosm ndmoprg mp3an1 cJ cJ chomeosm co c0 wceq vx cv cJ
    cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom
    wceq w3a vz cv c0 wcel vx vy cJ cJ chomeosm co c0 wceq vx cv cJ cJ chomeosm
    co wcel vz cv c0 wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a cJ cJ chomeosm co c0 wceq vx cv cJ cJ
    chomeosm co wcel vx cv c0 wcel vz cv c0 wcel cJ cJ chomeosm co c0 vx cv
    eleq2 vx cv c0 wcel vz cv c0 wcel vx cv noel pm2.21i syl6bi vx cv cJ cJ
    chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq
    3simp1 syl5 19.23advv syl vz cv c0 wcel vx cv cJ cJ chomeosm co wcel vy cv
    cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cv
    noel pm2.21i impbid1 abbi1dv eqtr4d ex cJ cvv wcel wn cJ cJ chomeosm co vx
    cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a vy wex vx wex vz cab wceq cJ ctop wcel cJ ctop wcel wa wn cJ
    cvv wcel wn cJ cJ chomeosm co c0 vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cab cJ cJ
    chomeosm chomeosm cdm wrel vt cv ctop wcel vf cv ctop wcel wa vv cv vt cv
    cuni vf cv cuni vu cv wf1o vu cv vw cv cima vf cv wcel vw vt cv wral vu cv
    ccnv vw cv cima vt cv wcel vw vf cv wral w3a vu cab wceq wa vt vf vv copab2
    cdm wrel vt cv ctop wcel vf cv ctop wcel wa vv cv vt cv cuni vf cv cuni vu
    cv wf1o vu cv vw cv cima vf cv wcel vw vt cv wral vu cv ccnv vw cv cima vt
    cv wcel vw vf cv wral w3a vu cab wceq wa vt vf vv reldmoprab chomeosm cdm
    vt cv ctop wcel vf cv ctop wcel wa vv cv vt cv cuni vf cv cuni vu cv wf1o
    vu cv vw cv cima vf cv wcel vw vt cv wral vu cv ccnv vw cv cima vt cv wcel
    vw vf cv wral w3a vu cab wceq wa vt vf vv copab2 cdm chomeosm vt cv ctop
    wcel vf cv ctop wcel wa vv cv vt cv cuni vf cv cuni vu cv wf1o vu cv vw cv
    cima vf cv wcel vw vt cv wral vu cv ccnv vw cv cima vt cv wcel vw vf cv
    wral w3a vu cab wceq wa vt vf vv copab2 vw vv vu vt vf df-homeo dmeqi
    releqi mpbir oprprc1 cJ cvv wcel wn vx cv cJ cJ chomeosm co wcel vy cv cJ
    cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz c0 cJ
    cvv wcel wn vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vy wex vx wex vz cv c0 wcel cJ cvv wcel wn cJ cJ
    chomeosm co c0 wceq vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co
    wcel vz cv vx cv vy cv ccom wceq w3a vy wex vx wex vz cv c0 wcel wi cJ cJ
    chomeosm chomeosm cdm wrel vt cv ctop wcel vf cv ctop wcel wa vv cv vt cv
    cuni vf cv cuni vu cv wf1o vu cv vw cv cima vf cv wcel vw vt cv wral vu cv
    ccnv vw cv cima vt cv wcel vw vf cv wral w3a vu cab wceq wa vt vf vv copab2
    cdm wrel vt cv ctop wcel vf cv ctop wcel wa vv cv vt cv cuni vf cv cuni vu
    cv wf1o vu cv vw cv cima vf cv wcel vw vt cv wral vu cv ccnv vw cv cima vt
    cv wcel vw vf cv wral w3a vu cab wceq wa vt vf vv reldmoprab chomeosm cdm
    vt cv ctop wcel vf cv ctop wcel wa vv cv vt cv cuni vf cv cuni vu cv wf1o
    vu cv vw cv cima vf cv wcel vw vt cv wral vu cv ccnv vw cv cima vt cv wcel
    vw vf cv wral w3a vu cab wceq wa vt vf vv copab2 cdm chomeosm vt cv ctop
    wcel vf cv ctop wcel wa vv cv vt cv cuni vf cv cuni vu cv wf1o vu cv vw cv
    cima vf cv wcel vw vt cv wral vu cv ccnv vw cv cima vt cv wcel vw vf cv
    wral w3a vu cab wceq wa vt vf vv copab2 vw vv vu vt vf df-homeo dmeqi
    releqi mpbir oprprc1 cJ cJ chomeosm co c0 wceq vx cv cJ cJ chomeosm co wcel
    vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vz cv c0 wcel
    vx vy cJ cJ chomeosm co c0 wceq vx cv cJ cJ chomeosm co wcel vz cv c0 wcel
    vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv vx cv vy cv
    ccom wceq w3a cJ cJ chomeosm co c0 wceq vx cv cJ cJ chomeosm co wcel vx cv
    c0 wcel vz cv c0 wcel cJ cJ chomeosm co c0 vx cv eleq2 vx cv c0 wcel vz cv
    c0 wcel vx cv noel pm2.21i syl6bi vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq 3simp1 syl5 19.23advv syl vz
    cv c0 wcel vx cv cJ cJ chomeosm co wcel vy cv cJ cJ chomeosm co wcel vz cv
    vx cv vy cv ccom wceq w3a vy wex vx wex vz cv noel pm2.21i impbid1 abbi1dv
    eqtr4d a1d pm2.61i syl pm2.61i vx cv cJ cJ chomeosm co wcel vy cv cJ cJ
    chomeosm co wcel vz cv vx cv vy cv ccom wceq w3a vx vy vz rnoprab eqtr4i
    isgrp 3syl mpbird $.
    $( [4-Feb-2008] $) $( [3-Feb-2008] $)
  $}

  ${ $d J a b f g $.  $d J a b f m n x $.  $d K a b f g $.
     $d K a b f m n x $.
  $( Homeomorphisms preserve the cardinality of the topologies. $)
  homcard $p |- ( ( J e. Top /\ K e. Top ) -> ( J ~= K  ->
    J ~~ K ) ) $=
    cJ ctop wcel cK ctop wcel wa cJ cK chomeo wbr vf cv cJ cK chomeosm co wcel
    vf wex cJ cK cen wbr vf cJ cK hmph vf cv cJ cK chomeosm co wcel vf wex cJ
    ctop wcel cK ctop wcel wa cJ cK cen wbr vf cv cJ cK chomeosm co wcel cJ
    ctop wcel cK ctop wcel wa cJ cK cen wbr wi vf vf cv cJ cK chomeosm co wcel
    cJ ctop wcel cK ctop wcel wa cJ cK cen wbr wi cJ ctop wcel cK ctop wcel wa
    vf cv cJ cK chomeosm co wcel vf cv cJ cK chomeosm co wcel cJ cK cen wbr cJ
    ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel vf cv cJ cK chomeosm co
    wcel cJ cK cen wbr wi cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co
    wcel w3a vf cv cJ cK chomeosm co wcel cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a cJ
    cK cen wbr vx cJ cK chomeosm co vf cv cJ cK cJ cuni cK cuni cJ cuni eqid cK
    cuni eqid ishomeo cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel
    w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv
    ccnv vx cv cima cJ wcel vx cK wral w3a cJ cK cen wbr cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa
    cJ cK cen wbr cJ cK vg cv wf1o vg wex va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab cvv wcel cJ cK va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab wf1o cJ cK vg cv wf1o vg wex cJ ctop wcel cK ctop wcel
    vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv
    cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa cJ
    cK vg cv wf1o cJ cK va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb
    copab wf1o vg va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cvv
    cJ cK vg cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab f1oeq1
    cla4egv cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab cvv wcel cJ cuni cK cuni vf
    cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel
    vx cK wral w3a cJ ctop wcel cK ctop wcel va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cvv wcel vf cv cJ cK chomeosm co wcel va vb cJ vf
    cv va cv cima ctop opabex2g 3ad2ant1 adantr cJ ctop wcel cK ctop wcel vf cv
    cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK
    wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa cJ cK va cv
    cJ wcel vb cv vf cv va cv cima wceq wa va vb copab wf1 va cv cJ wcel vb cv
    vf cv va cv cima wceq wa va vb copab crn cK wceq wa cJ cK va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab wf1o cJ ctop wcel cK ctop wcel vf
    cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima
    cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa cJ cK va
    cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab wf1 va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab crn cK wceq cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa
    cJ cK va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab wf vm cv va
    cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv vn cv wceq
    wi vn cJ wral vm cJ wral wa cJ cK va cv cJ wcel vb cv vf cv va cv cima wceq
    wa va vb copab wf1 cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel
    w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv
    ccnv vx cv cima cJ wcel vx cK wral w3a wa cJ cK va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab wf vm cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab cfv wceq vm cv vn cv wceq wi vn cJ wral vm cJ wral cJ
    ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf
    cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel
    vx cK wral w3a wa va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cJ wfn va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab crn cK wss
    wa cJ cK va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab wf cJ
    ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf
    cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel
    vx cK wral w3a wa va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cJ wfn va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab crn cK wss
    cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni
    vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ
    wcel vx cK wral w3a wa vf cv va cv cima cvv wcel va cJ wral va cv cJ wcel
    vb cv vf cv va cv cima wceq wa va vb copab cJ wfn cJ ctop wcel cK ctop wcel
    vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv
    cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa vf
    cv va cv cima cvv wcel va cJ vf cv va cv cima cvv wcel cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa
    va cv cJ wcel wa vf cv cvv wcel vf cv va cv cima cvv wcel vf visset vf cv
    va cv cvv imaexg ax-mp a1i r19.21aiva va vb cJ vf cv va cv cima va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab eqid fnopab2g sylib cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa
    vb cv vf cv va cv cima wceq va cJ wrex vb cab cK va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab crn cJ ctop wcel cK ctop wcel vf cv cJ cK
    chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx
    cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa vb cv vf cv va cv
    cima wceq va cJ wrex vb cv cK wcel wi vb wal vb cv vf cv va cv cima wceq va
    cJ wrex vb cab cK wss cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co
    wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf
    cv ccnv vx cv cima cJ wcel vx cK wral w3a wa vb cv vf cv va cv cima wceq va
    cJ wrex vb cv cK wcel wi vb vb cv vf cv va cv cima wceq va cJ wrex cJ ctop
    wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv
    wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx
    cK wral w3a wa vb cv cK wcel vb cv vf cv va cv cima wceq cJ ctop wcel cK
    ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv
    vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a
    wa vb cv cK wcel wi va cJ vb cv vf cv va cv cima wceq cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa
    vb cv cK wcel wi cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a
    cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv
    vx cv cima cJ wcel vx cK wral w3a wa vf cv va cv cima cK wcel wi va cv cJ
    wcel vb cv vf cv va cv cima wceq vb cv cK wcel vf cv va cv cima cK wcel cJ
    ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf
    cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel
    vx cK wral w3a wa vb cv vf cv va cv cima cK eleq1 imbi2d cJ ctop wcel cK
    ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv
    vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a
    wa va cv cJ wcel vf cv va cv cima cK wcel cJ cuni cK cuni vf cv wf1o vf cv
    vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a
    va cv cJ wcel vf cv va cv cima cK wcel wi cJ ctop wcel cK ctop wcel vf cv
    cJ cK chomeosm co wcel w3a vf cv vx cv cima cK wcel vx cJ wral cJ cuni cK
    cuni vf cv wf1o va cv cJ wcel vf cv va cv cima cK wcel wi vf cv ccnv vx cv
    cima cJ wcel vx cK wral va cv cJ wcel vf cv vx cv cima cK wcel vx cJ wral
    vf cv va cv cima cK wcel vf cv vx cv cima cK wcel vf cv va cv cima cK wcel
    vx va cv cJ vx cv va cv wceq vf cv vx cv cima vf cv va cv cima cK vx cv va
    cv vf cv imaeq2 eleq1d rcla4va expcom 3ad2ant2 adantl com12 syl5cbir
    r19.23aiv com12 19.21aiv vb cv vf cv va cv cima wceq va cJ wrex vb cK abss
    sylibr va vb cJ vf cv va cv cima rnopab2 syl5ss jca cJ cK va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab df-f sylibr cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx
    cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa
    vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va
    cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv vn cv
    wceq wi vm vn cJ cJ cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx
    cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a vm cv cJ wcel vn cv cJ wcel wa vm cv
    va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv vn cv wceq
    wi wi cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral cJ
    ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a vm cv cJ wcel vn cv
    cJ wcel wa vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq
    vm cv vn cv wceq wi wi wi vf cv ccnv vx cv cima cJ wcel vx cK wral cJ ctop
    wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv
    wf1o vm cv cJ wcel vn cv cJ wcel wa vm cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab cfv wceq vm cv vn cv wceq wi wi cJ ctop wcel cK ctop
    wcel cJ cuni cK cuni vf cv wf1o vm cv cJ wcel vn cv cJ wcel wa vm cv va cv
    cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel
    vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv vn cv wceq wi wi
    wi vf cv cJ cK chomeosm co wcel cJ cuni cK cuni vf cv wf1o cJ ctop wcel cK
    ctop wcel wa vm cv cJ wcel vn cv cJ wcel wa vm cv va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv wceq vm cv vn cv wceq wi wi cJ cuni cK cuni vf
    cv wf1o cJ cuni cK cuni vf cv wf1 cJ ctop wcel cK ctop wcel wa vm cv cJ
    wcel vn cv cJ wcel wa vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va
    vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cfv wceq vm cv vn cv wceq wi wi wi cJ cuni cK cuni vf cv f1of1 vf cv cvv
    wcel vf cv cvv wcel cJ cuni cK cuni vf cv wf1 cJ ctop wcel cK ctop wcel wa
    vm cv cJ wcel vn cv cJ wcel wa vm cv va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa
    va vb copab cfv wceq vm cv vn cv wceq wi wi wi wi vf visset vf visset cJ
    cuni cK cuni vf cv wf1 vf cv vm cv cima cvv wcel vf cv vn cv cima cvv wcel
    wa cJ ctop wcel cK ctop wcel wa vm cv cJ wcel vn cv cJ wcel wa vm cv va cv
    cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel
    vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv vn cv wceq wi wi
    wi vf cv cvv wcel vf cv cvv wcel wa vm cv cJ wcel vn cv cJ wcel wa vf cv vm
    cv cima cvv wcel vf cv vn cv cima cvv wcel wa cJ ctop wcel cK ctop wcel wa
    cJ cuni cK cuni vf cv wf1 vm cv va cv cJ wcel vb cv vf cv va cv cima wceq
    wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb
    copab cfv wceq vm cv vn cv wceq wi vm cv cJ wcel vn cv cJ wcel wa vf cv vm
    cv cima cvv wcel vf cv vn cv cima cvv wcel wa vm cv va cv cJ wcel vb cv vf
    cv va cv cima wceq wa va vb copab cfv vf cv vm cv cima wceq vn cv va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vn cv cima wceq
    wa cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni vf cv wf1 vm cv va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv vn cv wceq wi wi wi
    vm cv cJ wcel vf cv vm cv cima cvv wcel vm cv va cv cJ wcel vb cv vf cv va
    cv cima wceq wa va vb copab cfv vf cv vm cv cima wceq vn cv cJ wcel vf cv
    vn cv cima cvv wcel vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va
    vb copab cfv vf cv vn cv cima wceq vm cv cJ wcel vf cv vm cv cima cvv wcel
    vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vm
    cv cima wceq va vb vm cv vf cv va cv cima vf cv vm cv cima cJ cvv va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab va cv vm cv vf cv imaeq2 va
    cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab eqid fvopab4g ex vn
    cv cJ wcel vf cv vn cv cima cvv wcel vn cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv vf cv vn cv cima wceq va vb vn cv vf cv va cv
    cima vf cv vn cv cima cJ cvv va cv cJ wcel vb cv vf cv va cv cima wceq wa
    va vb copab va cv vn cv vf cv imaeq2 va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab eqid fvopab4g ex im2anan9 vm cv cJ wcel vn cv cJ wcel
    wa vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv
    vm cv cima wceq vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb
    copab cfv vf cv vn cv cima wceq wa cJ ctop wcel cK ctop wcel wa cJ cuni cK
    cuni vf cv wf1 vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb
    copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cfv wceq vm cv vn cv wceq wi wi vm cv va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa
    va vb copab cfv wceq vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va
    vb copab cfv vf cv vm cv cima wceq vn cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv vf cv vn cv cima wceq wa cJ ctop wcel cK ctop
    wcel wa wa cJ cuni cK cuni vf cv wf1 vm cv cJ wcel vn cv cJ wcel wa vm cv
    vn cv wceq vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cfv vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq
    vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vm
    cv cima wceq vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cfv vf cv vn cv cima wceq wa cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni
    vf cv wf1 vm cv cJ wcel vn cv cJ wcel wa vm cv vn cv wceq wi wi vm cv va cv
    cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel
    vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab cfv vf cv vm cv cima wceq vn cv va
    cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vn cv cima
    wceq wa vf cv vm cv cima vf cv vn cv cima wceq cJ ctop wcel cK ctop wcel wa
    cJ cuni cK cuni vf cv wf1 vm cv cJ wcel vn cv cJ wcel wa vm cv vn cv wceq
    wi wi wi vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv
    vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vm
    cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vm cv
    cima wceq vn cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    cfv vf cv vn cv cima wceq vf cv vm cv cima vf cv vn cv cima wceq vm cv va
    cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vm cv cima
    wceq vm cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vn
    cv va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv wceq vn cv
    va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab cfv vf cv vn cv
    cima wceq vf cv vm cv cima vf cv vn cv cima wceq wi vm cv va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab cfv wceq vn cv va cv cJ wcel vb cv vf cv va
    cv cima wceq wa va vb copab cfv vf cv vn cv cima wceq vf cv vm cv cima vf
    cv vn cv cima wceq wi wi vf cv vm cv cima vm cv va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab cfv vf cv vm cv cima vm cv va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab cfv wceq vm cv va cv cJ wcel vb cv
    vf cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va
    cv cima wceq wa va vb copab cfv wceq vn cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv vf cv vn cv cima wceq vf cv vm cv cima vf cv
    vn cv cima wceq wi vf cv vm cv cima vm cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv wceq vm cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv cima
    wceq wa va vb copab cfv wceq wa vf cv vm cv cima vn cv va cv cJ wcel vb cv
    vf cv va cv cima wceq wa va vb copab cfv wceq vn cv va cv cJ wcel vb cv vf
    cv va cv cima wceq wa va vb copab cfv vf cv vn cv cima wceq vf cv vm cv
    cima vf cv vn cv cima wceq wi vf cv vm cv cima vm cv va cv cJ wcel vb cv vf
    cv va cv cima wceq wa va vb copab cfv vn cv va cv cJ wcel vb cv vf cv va cv
    cima wceq wa va vb copab cfv eqtr vf cv vm cv cima vn cv va cv cJ wcel vb
    cv vf cv va cv cima wceq wa va vb copab cfv wceq vn cv va cv cJ wcel vb cv
    vf cv va cv cima wceq wa va vb copab cfv vf cv vn cv cima wceq vf cv vm cv
    cima vf cv vn cv cima wceq vf cv vm cv cima vn cv va cv cJ wcel vb cv vf cv
    va cv cima wceq wa va vb copab cfv vf cv vn cv cima eqtr ex syl ex eqcoms
    com12 imp3a cJ ctop wcel cK ctop wcel wa vf cv vm cv cima vf cv vn cv cima
    wceq cJ cuni cK cuni vf cv wf1 vm cv cJ wcel vn cv cJ wcel wa vm cv vn cv
    wceq wi wi cJ ctop wcel cK ctop wcel wa vm cv cJ wcel vn cv cJ wcel wa cJ
    cuni cK cuni vf cv wf1 vf cv vm cv cima vf cv vn cv cima wceq vm cv vn cv
    wceq cJ ctop wcel cK ctop wcel wa vm cv cJ wcel vn cv cJ wcel wa vm cv cJ
    cuni wss vn cv cJ cuni wss wa cJ cuni cK cuni vf cv wf1 vf cv vm cv cima vf
    cv vn cv cima wceq vm cv vn cv wceq wi wi cJ ctop wcel vm cv cJ wcel vn cv
    cJ wcel wa vm cv cJ cuni wss vn cv cJ cuni wss wa wi cK ctop wcel cJ ctop
    wcel vm cv cJ wcel vm cv cJ cuni wss vn cv cJ wcel vn cv cJ cuni wss cJ
    ctop wcel vm cv cJ wcel vm cv cJ cuni wss vm cv cJ cJ cuni cJ cuni eqid
    eltopss ex cJ ctop wcel vn cv cJ wcel vn cv cJ cuni wss vn cv cJ cJ cuni cJ
    cuni eqid eltopss ex anim12d adantr cJ cuni cK cuni vf cv wf1 vm cv cJ cuni
    wss vn cv cJ cuni wss wa vf cv vm cv cima vf cv vn cv cima wceq vm cv vn cv
    wceq wi cJ cuni cK cuni vf cv wf1 vm cv cJ cuni wss vn cv cJ cuni wss vf cv
    vm cv cima vf cv vn cv cima wceq vm cv vn cv wceq wi cJ cuni cK cuni vf cv
    wf1 vm cv cJ cuni wss vn cv cJ cuni wss w3a vf cv vm cv cima vf cv vn cv
    cima wceq vm cv vn cv wceq cJ cuni cK cuni vf cv vm cv vn cv oooeqim2
    biimpd 3expib com12 syl6 com24 com12 syl6 imp3a com14 exp3a syld com14 vf
    cv cvv wcel vf cv vm cv cima cvv wcel vf cv cvv wcel vf cv vn cv cima cvv
    wcel vf cv vm cv cvv imaexg vf cv vn cv cvv imaexg anim12i syl5com mp2an
    syl com12 3adant3 com12 3ad2ant1 impcom r19.21aivv jca vm vn cJ cK va cv cJ
    wcel vb cv vf cv va cv cima wceq wa va vb copab dff13 sylibr cJ ctop wcel
    cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf
    cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral
    w3a wa vb cv vf cv va cv cima wceq va cJ wrex vb cab cK va cv cJ wcel vb cv
    vf cv va cv cima wceq wa va vb copab crn cJ ctop wcel cK ctop wcel vf cv cJ
    cK chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel
    vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a wa vb cv vf cv va
    cv cima wceq va cJ wrex vb cv cK wcel wb vb wal vb cv vf cv va cv cima wceq
    va cJ wrex vb cab cK wceq cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co
    wcel w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf
    cv ccnv vx cv cima cJ wcel vx cK wral w3a wa vx cv vf cv va cv cima wceq va
    cJ wrex vx cv cK wcel wb vx wal vb cv vf cv va cv cima wceq va cJ wrex vb
    cv cK wcel wb vb wal cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel
    w3a cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv
    ccnv vx cv cima cJ wcel vx cK wral w3a wa vx cv vf cv va cv cima wceq va cJ
    wrex vx cv cK wcel wi vx wal vx cv cK wcel vx cv vf cv va cv cima wceq va
    cJ wrex wi vx wal wa vx cv vf cv va cv cima wceq va cJ wrex vx cv cK wcel
    wb vx wal cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a cJ
    cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx
    cv cima cJ wcel vx cK wral w3a wa vx cv vf cv va cv cima wceq va cJ wrex vx
    cv cK wcel wi vx wal vx cv cK wcel vx cv vf cv va cv cima wceq va cJ wrex
    wi vx wal cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ wral vf
    cv ccnv vx cv cima cJ wcel vx cK wral w3a cJ ctop wcel cK ctop wcel vf cv
    cJ cK chomeosm co wcel w3a vx cv vf cv va cv cima wceq va cJ wrex vx cv cK
    wcel wi vx wal vf cv vx cv cima cK wcel vx cJ wral cJ cuni cK cuni vf cv
    wf1o cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a vx cv vf cv
    va cv cima wceq va cJ wrex vx cv cK wcel wi vx wal wi vf cv ccnv vx cv cima
    cJ wcel vx cK wral vf cv vx cv cima cK wcel vx cJ wral cJ ctop wcel cK ctop
    wcel vf cv cJ cK chomeosm co wcel w3a vx cv vf cv va cv cima wceq va cJ
    wrex vx cv cK wcel wi vx wal vf cv vx cv cima cK wcel vx cJ wral cJ ctop
    wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a wa vx cv vf cv va cv
    cima wceq va cJ wrex vx cv cK wcel wi vx vf cv vx cv cima cK wcel vx cJ
    wral cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a vx vf cv vx
    cv cima cK wcel vx cJ hbra1 cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm
    co wcel w3a vx ax-17 hban vx cv vf cv va cv cima wceq va cJ wrex vf cv vx
    cv cima cK wcel vx cJ wral cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm
    co wcel w3a wa vx cv cK wcel vx cv vf cv va cv cima wceq vf cv vx cv cima
    cK wcel vx cJ wral cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel
    w3a wa vx cv cK wcel wi va cJ vf cv vx cv cima cK wcel vx cJ wral cJ ctop
    wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a wa va cv cJ wcel vx cv
    vf cv va cv cima wceq vx cv cK wcel vf cv vx cv cima cK wcel vx cJ wral cJ
    ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a va cv cJ wcel vx cv
    vf cv va cv cima wceq vx cv cK wcel wi wi va cv cJ wcel vf cv vx cv cima cK
    wcel vx cJ wral cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a
    vx cv vf cv va cv cima wceq vx cv cK wcel wi va cv cJ wcel vf cv vx cv cima
    cK wcel vx cJ wral vf cv va cv cima cK wcel cJ ctop wcel cK ctop wcel vf cv
    cJ cK chomeosm co wcel w3a vx cv vf cv va cv cima wceq vx cv cK wcel wi wi
    vf cv vx cv cima cK wcel vf cv va cv cima cK wcel vx va cv cJ vx cv va cv
    wceq vf cv vx cv cima vf cv va cv cima cK vx cv va cv vf cv imaeq2 eleq1d
    rcla4v vf cv va cv cima cK wcel vx cv vf cv va cv cima wceq vx cv cK wcel
    wi cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel w3a vf cv va cv
    cima cK vx cv eleq1a a1d syl6 com3l imp com3l r19.23aiv com12 19.21ai ex
    3ad2ant2 impcom cJ cuni cK cuni vf cv wf1o vf cv vx cv cima cK wcel vx cJ
    wral vf cv ccnv vx cv cima cJ wcel vx cK wral w3a vx cv cK wcel vx cv vf cv
    va cv cima wceq va cJ wrex wi vx wal cJ ctop wcel cK ctop wcel vf cv cJ cK
    chomeosm co wcel w3a cJ cuni cK cuni vf cv wf1o vf cv ccnv vx cv cima cJ
    wcel vx cK wral vx cv cK wcel vx cv vf cv va cv cima wceq va cJ wrex wi vx
    wal vf cv vx cv cima cK wcel vx cJ wral cJ cuni cK cuni vf cv wf1o vf cv
    ccnv vx cv cima cJ wcel vx cK wral wa vx cv cK wcel vx cv vf cv va cv cima
    wceq va cJ wrex wi vx cJ cuni cK cuni vf cv wf1o vf cv ccnv vx cv cima cJ
    wcel vx cK wral vx cJ cuni cK cuni vf cv wf1o vx ax-17 vf cv ccnv vx cv
    cima cJ wcel vx cK hbra1 hban vf cv ccnv vx cv cima cJ wcel vx cK wral cJ
    cuni cK cuni vf cv wf1o vx cv cK wcel vx cv vf cv va cv cima wceq va cJ
    wrex wi vf cv ccnv vx cv cima cJ wcel vx cK wral vx cv cK wcel vf cv ccnv
    vx cv cima cJ wcel wi cJ cuni cK cuni vf cv wf1o vx cv cK wcel vx cv vf cv
    va cv cima wceq va cJ wrex wi wi vf cv ccnv vx cv cima cJ wcel vx cK ra4 vx
    cv cK wcel vx cv cK wcel vf cv ccnv vx cv cima cJ wcel wi cJ cuni cK cuni
    vf cv wf1o vx cv vf cv va cv cima wceq va cJ wrex vx cv cK wcel vf cv ccnv
    vx cv cima cJ wcel wi vx cv cK wcel cJ cuni cK cuni vf cv wf1o vx cv vf cv
    va cv cima wceq va cJ wrex wi vx cv cK wcel vf cv ccnv vx cv cima cJ wcel
    cJ cuni cK cuni vf cv wf1o vx cv vf cv va cv cima wceq va cJ wrex wi vx cv
    cK wcel vx cv cK wcel vx cv cK cuni wss vf cv ccnv vx cv cima cJ wcel cJ
    cuni cK cuni vf cv wf1o vx cv vf cv va cv cima wceq va cJ wrex wi wi vx cv
    cK elssuni cJ cuni cK cuni vf cv wf1o vx cv cK cuni wss vf cv ccnv vx cv
    cima cJ wcel vx cv vf cv va cv cima wceq va cJ wrex cJ cuni cK cuni vf cv
    wf1o vx cv cK cuni wss vf cv ccnv vx cv cima cJ wcel vx cv vf cv va cv cima
    wceq va cJ wrex wi vf cv ccnv vx cv cima cJ wcel vf cv vf cv ccnv vx cv
    cima cima vx cv wceq vx cv vf cv va cv cima wceq va cJ wrex cJ cuni cK cuni
    vf cv wf1o vx cv cK cuni wss wa vf cv ccnv vx cv cima cJ wcel vf cv vf cv
    ccnv vx cv cima cima vx cv wceq vx cv vf cv va cv cima wceq va cJ wrex vx
    cv vf cv va cv cima wceq vf cv vf cv ccnv vx cv cima cima vx cv wceq va vf
    cv ccnv vx cv cima cJ va cv vf cv ccnv vx cv cima wceq vf cv va cv cima vf
    cv vf cv ccnv vx cv cima cima wceq vx cv vf cv va cv cima wceq vf cv vf cv
    ccnv vx cv cima cima vx cv wceq wb va cv vf cv ccnv vx cv cima vf cv imaeq2
    vf cv va cv cima vf cv vf cv ccnv vx cv cima cima wceq vf cv va cv cima vx
    cv wceq vf cv vf cv ccnv vx cv cima cima vx cv wceq vx cv vf cv va cv cima
    wceq vf cv va cv cima vf cv vf cv ccnv vx cv cima cima vx cv eqeq1 vx cv vf
    cv va cv cima eqcom syl5bb syl rcla4ev ex cJ cuni cK cuni vx cv vf cv
    f2imacnv syl5com ex com3l syl imim2d pm2.43a com3l syl impcom 19.21ai
    3adant2 adantl jca vx cv vf cv va cv cima wceq va cJ wrex vx cv cK wcel vx
    albi sylibr vx cv vf cv va cv cima wceq va cJ wrex vx cv cK wcel wb vb cv
    vf cv va cv cima wceq va cJ wrex vb cv cK wcel wb vx vb vx cv vf cv va cv
    cima wceq va cJ wrex vx cv cK wcel wb vb ax-17 vb cv vf cv va cv cima wceq
    va cJ wrex vb cv cK wcel wb vx ax-17 vx cv vb cv wceq vx cv vf cv va cv
    cima wceq va cJ wrex vb cv vf cv va cv cima wceq va cJ wrex vx cv cK wcel
    vb cv cK wcel vx cv vb cv wceq vx cv vf cv va cv cima wceq vb cv vf cv va
    cv cima wceq va cJ vx cv vb cv wceq va ax-17 vx cv vb cv vf cv va cv cima
    eqeq1 rexbid vx cv vb cv cK eleq1 bibi12d cbval sylib vb cv vf cv va cv
    cima wceq va cJ wrex vb cK abeq1 sylibr va vb cJ vf cv va cv cima rnopab2
    syl5eq jca cJ cK va cv cJ wcel vb cv vf cv va cv cima wceq wa va vb copab
    dff1o5 sylibr sylc cJ ctop wcel cK ctop wcel vf cv cJ cK chomeosm co wcel
    w3a cJ cK cen wbr cJ cK vg cv wf1o vg wex wb cJ cuni cK cuni vf cv wf1o vf
    cv vx cv cima cK wcel vx cJ wral vf cv ccnv vx cv cima cJ wcel vx cK wral
    w3a cK ctop wcel cJ ctop wcel cJ cK cen wbr cJ cK vg cv wf1o vg wex wb vf
    cv cJ cK chomeosm co wcel cJ cK ctop vg breng 3ad2ant2 adantr mpbird ex
    sylbid 3expia com3l pm2.43i 19.23aiv com12 sylbid $.
    $( [1-Jun-2008] $) $( [1-Jun-2008] $)
  $}

  ${ $d J f  $.  $d K f $.  $d X f $.  $d Y f $.
    homcardus.1 $e |- X = U. J $.
    homcardus.2 $e |- Y = U. K $.
    $( Homeomorphisms preserve the cardinality of the underlying sets. $)
    homcardus $p |- ( ( J e. Top /\ K e. Top ) -> ( J ~= K  -> X ~~ Y ) ) $=
      cJ ctop wcel cK ctop wcel wa vf cv cJ cK chomeosm co wcel vf wex cX cY vf
      cv wf1o vf wex cJ cK chomeo wbr cX cY cen wbr cJ ctop wcel cK ctop wcel
      wa vf cv cJ cK chomeosm co wcel cX cY vf cv wf1o vf vf cv cJ cK cX cY
      homcardus.1 homcardus.2 hmeomap 19.22dv vf cJ cK hmph cJ ctop wcel cK
      ctop wcel wa cY cvv wcel cX cY cen wbr cX cY vf cv wf1o vf wex wb cK ctop
      wcel cY cvv wcel cJ ctop wcel cK ctop wcel cK cuni cvv cY cK ctop uniexg
      homcardus.2 syl5eqel adantl cX cY cvv vf breng syl 3imtr4d $.
      $( [1-Sep-2008] $) $( [17-Aug-2008] $)
  $}

  ${ $d A f x $.  $d B f x $.
    eqindhome.1 $e |- A e. C $.
    eqindhome.2 $e |- B e. D $.
    $( Equinumerous sets equipped with their indiscrete topologies are
       homeomorph (which means in particular that a segment is homeomorph to a
       circle contrary to what Wikipedia claims). $)
    eqindhome $p |- ( A ~~ B -> { (/) , A } ~= { (/) , B } ) $=
      cA cB vf cv wf1o vf wex vf cv c0 cA cpr c0 cB cpr chomeosm co wcel vf wex
      cA cB cen wbr c0 cA cpr c0 cB cpr chomeo wbr cA cB vf cv wf1o vf cv c0 cA
      cpr c0 cB cpr chomeosm co wcel vf cA cB vf cv wf1o cA cB vf cv wf1o vf cv
      vx cv cima c0 cB cpr wcel vx c0 cA cpr wral vf cv ccnv vx cv cima c0 cA
      cpr wcel vx c0 cB cpr wral w3a vf cv c0 cA cpr c0 cB cpr chomeosm co wcel
      cA cB vf cv wf1o cA cB vf cv wf1o vf cv vx cv cima c0 cB cpr wcel vx c0
      cA cpr wral vf cv ccnv vx cv cima c0 cA cpr wcel vx c0 cB cpr wral cA cB
      vf cv wf1o id cA cB vf cv wf1o vf cv vx cv cima c0 cB cpr wcel vx c0 cA
      cpr cA cB vf cv wf1o vx cv c0 wceq vx cv cA wceq wo vf cv vx cv cima c0
      wceq vf cv vx cv cima cB wceq wo vx cv c0 cA cpr wcel vf cv vx cv cima c0
      cB cpr wcel cA cB vf cv wf1o vx cv c0 wceq vf cv vx cv cima c0 wceq vx cv
      cA wceq vf cv vx cv cima cB wceq vx cv c0 wceq vf cv vx cv cima c0 wceq
      vf cv c0 cima c0 wceq cA cB vf cv wf1o vx cv c0 wceq vf cv vx cv cima vf
      cv c0 cima c0 vx cv c0 vf cv imaeq2 eqeq1d vf cv c0 cima c0 wceq cA cB vf
      cv wf1o vf cv ima0 a1i syl5cbir vx cv cA wceq vf cv vx cv cima cB wceq vf
      cv cA cima cB wceq cA cB vf cv wf1o vx cv cA wceq vf cv vx cv cima vf cv
      cA cima cB vx cv cA vf cv imaeq2 eqeq1d cA cB vf cv wf1o cA cB vf cv wfo
      vf cv cA cima cB wceq cA cB vf cv f1ofo cA cB vf cv foima syl syl5cbir
      orim12d vx cv c0 cA vx visset elpr vf cv vx cv cima c0 cB vf cv cvv wcel
      vf cv vx cv cima cvv wcel vf visset vf cv vx cv cvv imaexg ax-mp elpr
      3imtr4g r19.21aiv cA cB vf cv wf1o vf cv ccnv vx cv cima c0 cA cpr wcel
      vx c0 cB cpr cA cB vf cv wf1o vx cv c0 wceq vx cv cB wceq wo vf cv ccnv
      vx cv cima c0 wceq vf cv ccnv vx cv cima cA wceq wo vx cv c0 cB cpr wcel
      vf cv ccnv vx cv cima c0 cA cpr wcel cA cB vf cv wf1o vx cv c0 wceq vf cv
      ccnv vx cv cima c0 wceq vx cv cB wceq vf cv ccnv vx cv cima cA wceq vx cv
      c0 wceq vf cv ccnv vx cv cima c0 wceq wi cA cB vf cv wf1o vx cv c0 wceq
      vf cv ccnv vx cv cima vf cv ccnv c0 cima c0 vx cv c0 vf cv ccnv imaeq2 vf
      cv ccnv ima0 syl6eq a1i vx cv cB wceq vf cv ccnv vx cv cima cA wceq vf cv
      ccnv cB cima cA wceq cA cB vf cv wf1o vx cv cB wceq vf cv ccnv vx cv cima
      vf cv ccnv cB cima cA vx cv cB vf cv ccnv imaeq2 eqeq1d cA cB vf cv wf1o
      cA cB vf cv wf vf cv ccnv cB cima cA wceq cA cB vf cv f1of cA cB vf cv
      fimacnv syl syl5cbir orim12d vx cv c0 cB vx visset elpr vf cv ccnv vx cv
      cima c0 cA vf cv ccnv cvv wcel vf cv ccnv vx cv cima cvv wcel vf cv vf
      visset cnvex vf cv ccnv vx cv cvv imaexg ax-mp elpr 3imtr4g r19.21aiv
      3jca c0 cA cpr ctop wcel c0 cB cpr ctop wcel vf cv cvv wcel vf cv c0 cA
      cpr c0 cB cpr chomeosm co wcel cA cB vf cv wf1o vf cv vx cv cima c0 cB
      cpr wcel vx c0 cA cpr wral vf cv ccnv vx cv cima c0 cA cpr wcel vx c0 cB
      cpr wral w3a wb cA indistop cB indistop vf visset vx cvv vf cv c0 cA cpr
      c0 cB cpr cA cB c0 cA cpr cuni c0 cA cun cA c0 cun cA c0 cA 0ex cA cC
      eqindhome.1 elisseti unipr c0 cA uncom cA un0 3eqtrri c0 cB cpr cuni c0
      cB cun cB c0 cun cB c0 cB 0ex cB cD eqindhome.2 elisseti unipr c0 cB
      uncom cB un0 3eqtrri ishomeo mp3an sylibr 19.22i cA cB vf cB cD
      eqindhome.2 elisseti bren c0 cA cpr ctop wcel c0 cB cpr ctop wcel c0 cA
      cpr c0 cB cpr chomeo wbr vf cv c0 cA cpr c0 cB cpr chomeosm co wcel vf
      wex wb cA indistop cB indistop vf c0 cA cpr c0 cB cpr hmph mp2an 3imtr4i
      $.
      $( [1-Sep-2008] $) $( [17-Aug-2008] $)
  $}

  $( ` { (/) } ` is the only topology with one element. $)
  top1 $p |- ( J e. Top -> ( J ~~ 1o <-> J = { (/) } ) ) $=
    cJ ctop wcel cJ c1o cen wbr cJ c0 csn wceq cJ ctop wcel c0 cJ wcel cJ c1o
    cen wbr cJ c0 csn wceq wi cJ 0opn c0 cJ wcel cJ c1o cen wbr cJ c0 csn wceq
    c0 cJ setwoe ex syl cJ c0 csn wceq cJ c1o cen wbr c0 csn c1o cen wbr c0 0ex
    ensn1 cJ c0 csn c1o cen breq1 mpbiri impbid1 $.
    $( [1-Sep-2008] $) $( [18-Aug-2008] $)

  $( If a topology has two element it is the indiscrete topology. $)
  top2ind $p |- ( ( J e. Top /\ J ~~ 2o ) -> J = { (/) , U. J } ) $=
    cJ ctop wcel cJ c2o cen wbr cJ c0 cJ cuni cpr wceq cJ ctop wcel cJ c2o cen
    wbr cJ c0 cJ cuni cpr wceq wi cJ ctop wcel cJ ctop wcel c0 cJ wcel cJ c2o
    cen wbr cJ c0 cJ cuni cpr wceq wi cJ 0opn cJ ctop wcel cJ cuni cJ wcel c0
    cJ wcel cJ c2o cen wbr cJ c0 cJ cuni cpr wceq wi wi cJ ctop wcel cJ ctop
    wcel cJ cuni c0 wceq cJ c0 csn wceq wb cJ cuni cJ wcel c0 cJ wcel cJ c2o
    cen wbr cJ c0 cJ cuni cpr wceq wi wi wi cJ 0top cJ c2o cen wbr cJ cuni c0
    wceq cJ c0 csn wceq wb cJ cuni cJ wcel c0 cJ wcel cJ c0 cJ cuni cpr wceq cJ
    c2o cen wbr cJ c0 csn wceq wn cJ cuni c0 wceq cJ c0 csn wceq wb cJ cuni cJ
    wcel c0 cJ wcel cJ c0 cJ cuni cpr wceq wi wi wi cJ c0 csn wceq cJ c2o cen
    wbr cJ c0 csn wceq cJ c1o cen wbr cJ c2o cen wbr wn cJ c0 csn wceq cJ c1o
    cen wbr c0 csn c1o cen wbr c0 0ex ensn1 cJ c0 csn c1o cen breq1 mpbiri cJ
    c1o cen wbr c1o c2o csdm wbr cJ c2o cen wbr wn 1sdom2 cJ c1o cen wbr c1o
    c2o csdm wbr wa cJ c2o csdm wbr cJ c2o cen wbr wn cJ c1o c2o ensdomtr cJ
    c2o sdomnen syl mpan2 syl con2i cJ c0 csn wceq wn cJ cuni c0 wceq cJ c0 csn
    wceq wb cJ c2o cen wbr cJ cuni cJ wcel c0 cJ wcel cJ c0 cJ cuni cpr wceq wi
    wi cJ c0 csn wceq wn cJ cuni c0 wceq cJ c0 csn wceq wb cJ cuni c0 wceq wn
    cJ c2o cen wbr cJ cuni cJ wcel c0 cJ wcel cJ c0 cJ cuni cpr wceq wi wi wi
    cJ cuni c0 wceq cJ c0 csn wceq bibif cJ cuni c0 wceq wn cJ cuni c0 wne cJ
    c2o cen wbr cJ cuni cJ wcel c0 cJ wcel cJ c0 cJ cuni cpr wceq wi wi wi cJ
    cuni c0 df-ne cJ cuni c0 wne c0 cJ cuni wne cJ c2o cen wbr cJ cuni cJ wcel
    c0 cJ wcel cJ c0 cJ cuni cpr wceq wi wi wi cJ cuni c0 necom cJ c2o cen wbr
    c0 cJ cuni wne cJ cuni cJ wcel c0 cJ wcel cJ c0 cJ cuni cpr wceq wi wi cJ
    c2o cen wbr c0 cJ wcel cJ cuni cJ wcel c0 cJ cuni wne cJ c0 cJ cuni cpr
    wceq cJ c2o cen wbr c0 cJ wcel cJ cuni cJ wcel c0 cJ cuni wne cJ c0 cJ cuni
    cpr wceq wi c0 cJ cuni cJ set2elt 3exp com24 com12 sylbi sylbir syl6bi
    com3r mpd com4l syl cJ cJ cuni cJ cuni eqid topopn syl5 mpid pm2.43i imp $.
    $( [1-Sep-2008] $) $( [11-Aug-2008] $)

  $( If a topology has two elements its underlying set can't be empty. $)
  top2usne $p |- ( ( J e. Top /\ J ~~ 2o ) -> U. J =/= (/) ) $=
    cJ ctop wcel cJ c2o cen wbr wa cJ cuni c0 wceq wn cJ cuni c0 wne cJ ctop
    wcel cJ c2o cen wbr wa cJ cuni c0 wceq cJ c0 cJ cuni cpr wceq cJ ctop wcel
    cJ c2o cen wbr wa cJ cuni c0 wceq cJ cuni c0 wceq wn wi cJ top2ind cJ cuni
    c0 wceq cJ ctop wcel cJ c2o cen wbr wa cJ c0 cJ cuni cpr wceq cJ cuni c0
    wceq wn cJ cuni c0 wceq cJ c0 csn wss cJ ctop wcel cJ c2o cen wbr wa cJ c0
    cJ cuni cpr wceq cJ cuni c0 wceq wn wi wi cJ uni0b cJ c0 csn wss cJ c0 wceq
    cJ c0 csn wceq wo cJ ctop wcel cJ c2o cen wbr wa cJ c0 cJ cuni cpr wceq cJ
    cuni c0 wceq wn wi wi cJ c0 sssn cJ c0 wceq cJ ctop wcel cJ c2o cen wbr wa
    cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi wi cJ c0 csn wceq cJ ctop wcel
    cJ c2o cen wbr wa cJ c0 wceq cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi
    cJ c2o cen wbr cJ c0 wceq cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi wi
    cJ ctop wcel cJ c0 cJ cuni cpr wceq cJ c0 wceq cJ c2o cen wbr cJ cuni c0
    wceq wn cJ c0 wceq cJ c2o cen wbr cJ cuni c0 wceq wn wi wi cJ c0 cJ cuni
    cpr wceq cJ c0 wceq cJ c2o cen wbr c0 c2o cen wbr cJ cuni c0 wceq wn cJ c0
    c2o cen breq1 c0 c2o cen wbr cJ cuni c0 wceq wn c0 c2o cen wbr c0 c0 csuc
    csuc cen wbr c0 c0 csuc wss c0 csuc c0 csuc csuc wss c0 c0 csuc csuc cen
    wbr wn c0 sssucid c0 csuc sssucid c0 c0 csuc wss c0 csuc c0 csuc csuc wss
    wa c0 c0 csuc csuc wss c0 c0 csuc csuc cen wbr wn c0 c0 csuc c0 csuc csuc
    sstr c0 c0 csuc csuc wss c0 c0 csuc csuc wne c0 c0 csuc csuc cen wbr wn c0
    csuc csuc c0 wne c0 c0 csuc csuc wne c0 csuc nsuceq0 c0 csuc csuc c0 necom
    mpbi c0 c0 csuc csuc wss c0 c0 csuc csuc wne wa c0 c0 csuc csuc wpss c0 c0
    csuc csuc cen wbr wn c0 c0 csuc csuc df-pss c0 csuc csuc com wcel c0 c0
    csuc csuc wpss c0 c0 csuc csuc cen wbr wn c0 csuc com wcel c0 csuc csuc com
    wcel c0 com wcel c0 csuc com wcel peano1 c0 peano2 ax-mp c0 csuc peano2
    ax-mp c0 csuc csuc com wcel c0 c0 csuc csuc wpss wa c0 csuc csuc c0 cen wbr
    c0 c0 csuc csuc cen wbr c0 csuc csuc c0 php c0 csuc csuc com wcel c0 c0
    csuc csuc cen wbr c0 csuc csuc c0 cen wbr wi c0 csuc com wcel c0 csuc csuc
    com wcel c0 com wcel c0 csuc com wcel peano1 c0 peano2 ax-mp c0 csuc peano2
    ax-mp c0 c0 csuc csuc com ensymg ax-mp nsyl mpan sylbir mpan2 syl mp2an c2o
    c0 csuc csuc c0 cen c2o c1o csuc c0 csuc csuc df-2o c1o c0 csuc wceq c1o
    csuc c0 csuc csuc wceq df-1o c1o c0 csuc suceq ax-mp eqtri breq2i mtbir
    pm2.21i syl6bi a1i com13 adantl com12 cJ c0 csn wceq c0 csn c1o cen wbr cJ
    ctop wcel cJ c2o cen wbr wa cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi wi
    c0 0ex ensn1 c0 csn c1o cen wbr cJ ctop wcel cJ c2o cen wbr wa cJ c0 cJ
    cuni cpr wceq cJ cuni c0 wceq wn wi wi wi c0 csn cJ c0 csn cJ wceq c0 csn
    c1o cen wbr cJ c1o cen wbr cJ ctop wcel cJ c2o cen wbr wa cJ c0 cJ cuni cpr
    wceq cJ cuni c0 wceq wn wi wi c0 csn cJ c1o cen breq1 cJ ctop wcel cJ c2o
    cen wbr wa cJ c1o cen wbr cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi cJ
    c2o cen wbr cJ c1o cen wbr cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi wi
    cJ ctop wcel c2o com wcel cJ c2o cen wbr cJ c1o cen wbr cJ c0 cJ cuni cpr
    wceq cJ cuni c0 wceq wn wi wi wi 2onn c2o com wcel cJ c2o cen wbr c2o cJ
    cen wbr cJ c1o cen wbr cJ c0 cJ cuni cpr wceq cJ cuni c0 wceq wn wi wi cJ
    c2o com ensymg c2o cJ cen wbr cJ c1o cen wbr cJ c0 cJ cuni cpr wceq cJ cuni
    c0 wceq wn wi c2o cJ cen wbr cJ c1o cen wbr wa c2o c1o cen wbr cJ c0 cJ
    cuni cpr wceq cJ cuni c0 wceq wn wi c2o cJ c1o entr c2o c1o cen wbr cJ cuni
    c0 wceq wn cJ c0 cJ cuni cpr wceq c1o cvv wcel c2o c1o cen wbr cJ cuni c0
    wceq wn wi c1o com 1onn elisseti c1o cvv wcel c2o c1o cen wbr c1o c2o cen
    wbr cJ cuni c0 wceq wn c2o c1o cvv ensymg c1o c2o cen wbr cJ cuni c0 wceq
    wn c1o c2o cen wbr c1o c1o csuc cen wbr c1o com wcel c1o c1o csuc cen wbr
    wn 1onn c1o php5 ax-mp c2o c1o csuc c1o cen df-2o breq2i mtbir pm2.21i syl6
    ax-mp a1d syl ex syl6 ax-mp adantl com12 syl6bi eqcoms mpi jaoi sylbi sylbi
    com13 mpcom pm2.01d cJ cuni c0 df-ne sylibr $.
    $( [1-Sep-2008] $) $( [11-Aug-2008] $)

  $( An unnamed topological preservation theorem. $)
  homindlem2 $p |- ( ( K e. Top /\ K ~= { (/) } ) -> K = { (/) } ) $=
    cK ctop wcel cK c0 csn chomeo wbr wa cK c1o cen wbr cK c0 csn wceq cK ctop
    wcel cK c0 csn chomeo wbr wa cK c0 csn cen wbr c0 csn c1o cen wbr wa cK c1o
    cen wbr cK ctop wcel cK c0 csn chomeo wbr wa cK c0 csn cen wbr c0 csn c1o
    cen wbr cK ctop wcel cK c0 csn chomeo wbr cK c0 csn cen wbr cK ctop wcel c0
    csn ctop wcel cK c0 csn chomeo wbr cK c0 csn cen wbr wi sn0top cK c0 csn
    homcard mpan2 imp c0 0ex ensn1 jctir cK c0 csn c1o entr syl cK ctop wcel cK
    c1o cen wbr cK c0 csn wceq wb cK c0 csn chomeo wbr cK top1 adantr mpbid $.
    $( [1-Sep-2008] $) $( [18-Aug-2008] $)

  $( Homeomorphisms preserve topological indiscretion. $)
  homindlem3 $p |- ( ( K e. Top  /\ A =/= (/) /\ A e. B ) -> ( { (/) , A } ~= K
     -> K = { (/) , U. K } ) ) $=
    cK ctop wcel cA c0 wne cA cB wcel w3a c0 cA cpr cK chomeo wbr cK ctop wcel
    cK c2o cen wbr wa cK c0 cK cuni cpr wceq cK ctop wcel cA c0 wne cA cB wcel
    w3a c0 cA cpr cK chomeo wbr cK ctop wcel cK c2o cen wbr wa cK ctop wcel cA
    c0 wne cA cB wcel w3a c0 cA cpr cK chomeo wbr wa cK ctop wcel cK c2o cen
    wbr cK ctop wcel cA c0 wne cA cB wcel w3a cK ctop wcel c0 cA cpr cK chomeo
    wbr cK ctop wcel cA c0 wne cA cB wcel 3simp1 adantr cK c0 cA cpr cen wbr c0
    cA cpr c2o cen wbr cK c2o cen wbr cK ctop wcel cA c0 wne cA cB wcel w3a c0
    cA cpr cK chomeo wbr wa cK c0 cA cpr c2o entr cK ctop wcel cA c0 wne cA cB
    wcel c0 cA cpr cK chomeo wbr cK c0 cA cpr cen wbr cK ctop wcel cA cB wcel
    c0 cA cpr cK chomeo wbr cK c0 cA cpr cen wbr wi wi cA c0 wne cA cB wcel cK
    ctop wcel c0 cA cpr cK chomeo wbr cK c0 cA cpr cen wbr wi cA cB wcel c0 cA
    cpr ctop wcel cK ctop wcel c0 cA cpr cK chomeo wbr cK c0 cA cpr cen wbr wi
    wi cA cB wcel cA cvv wcel c0 cA cpr ctop wcel cA cB elisset cA cvv wcel c0
    cA cpr ctop wcel c0 cA cvv wcel cA c0 cif cpr ctop wcel cA c0 cA cA cvv
    wcel cA c0 cif wceq c0 cA cpr c0 cA cvv wcel cA c0 cif cpr ctop cA cA cvv
    wcel cA c0 cif c0 preq2 eleq1d cA cvv wcel cA c0 cif indistop dedth syl c0
    cA cpr ctop wcel cK ctop wcel c0 cA cpr cK chomeo wbr cK c0 cA cpr cen wbr
    wi c0 cA cpr ctop wcel cK ctop wcel wa c0 cA cpr cK chomeo wbr cK c0 cA cpr
    chomeo wbr cK c0 cA cpr cen wbr c0 cA cpr cK hmphsyma cK ctop wcel c0 cA
    cpr ctop wcel cK c0 cA cpr chomeo wbr cK c0 cA cpr cen wbr wi cK c0 cA cpr
    homcard ancoms syld ex syl com12 a1d 3imp1 cK ctop wcel cA c0 wne cA cB
    wcel w3a c0 cA cpr c2o cen wbr c0 cA cpr cK chomeo wbr cK ctop wcel cA c0
    wne cA cB wcel c0 cA cpr c2o cen wbr cA c0 wne cA cB wcel c0 cA cpr c2o cen
    wbr wi wi cK ctop wcel cA c0 wne cA cB wcel c0 cvv wcel c0 cA cpr c2o cen
    wbr 0ex cA c0 wne c0 cA wne cA cB wcel c0 cvv wcel c0 cA cpr c2o cen wbr wi
    wi cA c0 necom c0 cvv wcel cA cB wcel c0 cA wne c0 cA cpr c2o cen wbr c0
    cvv wcel cA cB wcel c0 cA wne c0 cA cpr c2o cen wbr c0 cA cvv cB unpde2eg2
    3exp com13 sylbi mpii a1i 3imp adantr sylanc jca ex cK top2ind syl6 $.
    $( [1-Sep-2008] $) $( [18-Aug-2008] $)



$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Initial and final topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d A u v $. $d J u v $.
    $( The subspace topology induced by the topology ` J ` on the set
       ` A ` . $)
    subsp2 $p |- ( ( J e. Top /\ A e. _V )
       -> ( subSp ` <. A , J >. ) = { u | E. v e. J u = ( v i^i A ) } )
       $=
      cJ ctop wcel cA cvv wcel cA cJ cop csubsp cfv vu cv vv cv cA cin wceq vv
      cJ wrex vu cab wceq cA cJ ctop wcel cJ c0 csn cif cop csubsp cfv vu cv vv
      cv cA cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu cab wceq cA cvv wcel
      cA c0 cif cJ ctop wcel cJ c0 csn cif cop csubsp cfv vu cv vv cv cA cvv
      wcel cA c0 cif cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu cab wceq cJ
      cA c0 csn c0 cJ cJ ctop wcel cJ c0 csn cif wceq cA cJ cop csubsp cfv cA
      cJ ctop wcel cJ c0 csn cif cop csubsp cfv vu cv vv cv cA cin wceq vv cJ
      wrex vu cab vu cv vv cv cA cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu
      cab cJ cJ ctop wcel cJ c0 csn cif wceq cA cJ cop cA cJ ctop wcel cJ c0
      csn cif cop csubsp cJ cJ ctop wcel cJ c0 csn cif cA opeq2 fveq2d cJ cJ
      ctop wcel cJ c0 csn cif wceq vu cv vv cv cA cin wceq vv cJ wrex vu cv vv
      cv cA cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu vu cv vv cv cA cin
      wceq vv cJ cJ ctop wcel cJ c0 csn cif rexeq1 abbidv eqeq12d cA cA cvv
      wcel cA c0 cif wceq cA cJ ctop wcel cJ c0 csn cif cop csubsp cfv cA cvv
      wcel cA c0 cif cJ ctop wcel cJ c0 csn cif cop csubsp cfv vu cv vv cv cA
      cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu cab vu cv vv cv cA cvv
      wcel cA c0 cif cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu cab cA cA
      cvv wcel cA c0 cif wceq cA cJ ctop wcel cJ c0 csn cif cop cA cvv wcel cA
      c0 cif cJ ctop wcel cJ c0 csn cif cop csubsp cA cA cvv wcel cA c0 cif cJ
      ctop wcel cJ c0 csn cif opeq1 fveq2d cA cA cvv wcel cA c0 cif wceq vu cv
      vv cv cA cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu cv vv cv cA cvv
      wcel cA c0 cif cin wceq vv cJ ctop wcel cJ c0 csn cif wrex vu cA cA cvv
      wcel cA c0 cif wceq vu cv vv cv cA cin wceq vu cv vv cv cA cvv wcel cA c0
      cif cin wceq vv cJ ctop wcel cJ c0 csn cif cA cA cvv wcel cA c0 cif wceq
      vv cv cA cin vv cv cA cvv wcel cA c0 cif cin vu cv cA cA cvv wcel cA c0
      cif vv cv ineq2 eqeq2d rexbidv abbidv eqeq12d vv vu cA cvv wcel cA c0 cif
      cJ ctop wcel cJ c0 csn cif cJ c0 csn ctop sn0top elimel cA c0 cvv 0ex
      elimel subsp dedth2h $.
      $( [20-Sep-2010] $) $( [18-Sep-2010] $)
  $}


  ${ $d J x y $.
    subspemp.1 $e |- J e. Top $.
    $( The subspace topology induced by the topology ` J ` on the empty set. $)
    subspemp $p |- ( subSp ` <. (/) , J >. ) = { (/) } $=
      vx cv vy cv c0 cin wceq vy cJ wrex vx cab vx cv c0 wceq vx cab c0 cJ cop
      csubsp cfv c0 csn vx cv vy cv c0 cin wceq vy cJ wrex vx cv c0 wceq vx vx
      cv vy cv c0 cin wceq vy cJ wrex vx cv c0 wceq vx cv vy cv c0 cin wceq vx
      cv c0 wceq vy cJ vx cv vy cv c0 cin wceq vx cv c0 wceq wi vy cv cJ wcel
      vx cv vy cv c0 cin wceq vy cv c0 cin c0 wceq vx cv c0 wceq vy cv in0 vx
      cv vy cv c0 cin c0 eqtr mpan2 a1i r19.23aiv vx cv c0 wceq vx cv vy cv c0
      cin wceq vy cJ wrex c0 vy cv c0 cin wceq vy cJ wrex c0 cJ wcel c0 c0 c0
      cin wceq c0 vy cv c0 cin wceq vy cJ wrex cJ ctop wcel c0 cJ wcel
      subspemp.1 cJ 0opn ax-mp c0 c0 cin c0 c0 inidm eqcomi c0 vy cv c0 cin
      wceq c0 c0 c0 cin wceq vy c0 cJ vy cv c0 wceq vy cv c0 cin c0 c0 cin c0
      vy cv c0 c0 ineq1 eqeq2d rcla4ev mp2an vx cv c0 wceq vx cv vy cv c0 cin
      wceq c0 vy cv c0 cin wceq vy cJ vx cv c0 vy cv c0 cin eqeq1 rexbidv
      mpbiri impbii abbii vy vx c0 cJ subspemp.1 0ex subsp vx c0 df-sn 3eqtr4i
      $.
      $( [22-Dec-2008] $) $( [22-Dec-2008] $)
  $}

  $( The subspace topology induced by the topology ` J ` on the empty set. $)
  subspemp2 $p |- ( J e. Top -> ( subSp ` <. (/) , J >. ) = { (/) } ) $=
    cJ ctop wcel c0 cJ cop csubsp cfv c0 csn wceq c0 cJ ctop wcel cJ c0 csn cif
    cop csubsp cfv c0 csn wceq cJ c0 csn cJ cJ ctop wcel cJ c0 csn cif wceq c0
    cJ cop csubsp cfv c0 cJ ctop wcel cJ c0 csn cif cop csubsp cfv c0 csn cJ cJ
    ctop wcel cJ c0 csn cif wceq c0 cJ cop c0 cJ ctop wcel cJ c0 csn cif cop
    csubsp cJ cJ ctop wcel cJ c0 csn cif c0 opeq2 fveq2d eqeq1d cJ ctop wcel cJ
    c0 csn cif cJ c0 csn ctop sn0top elimel subspemp dedth $.
    $( [22-Dec-2008] $) $( [22-Dec-2008] $)


  ${ $d A x y $. $d B x $.
    $( The only subspace topology induced by the topology ` { (/) } ` . $)
    sbtpsines $p |- ( A e. B -> ( subSp ` <. A , { (/)  } >. ) = { (/) } )
      $=
      cA cB wcel vx cA c0 csn cop csubsp cfv c0 csn cA cB wcel vx cv cA c0 csn
      cop csubsp cfv wcel vx cv vy cv cA cin wceq vy c0 csn wrex vx cv c0 csn
      wcel cA cB wcel cA cvv wcel vx cv cA c0 csn cop csubsp cfv wcel vx cv vy
      cv cA cin wceq vy c0 csn wrex wb cA cB elisset c0 csn ctop wcel vx cv cvv
      wcel cA cvv wcel vx cv cA c0 csn cop csubsp cfv wcel vx cv vy cv cA cin
      wceq vy c0 csn wrex wb sn0top vx visset vy vx cv cA cvv c0 csn issubspt
      mp3an12 syl vx cv vy cv cA cin wceq vy c0 csn wrex vx cv c0 wceq vx cv c0
      csn wcel vx cv vy cv cA cin wceq vy c0 csn wrex vy cv c0 csn wcel vx cv
      vy cv cA cin wceq wa vy wex vy cv c0 wceq vx cv vy cv cA cin wceq wa vy
      wex vx cv c0 wceq vx cv vy cv cA cin wceq vy c0 csn df-rex vy cv c0 csn
      wcel vx cv vy cv cA cin wceq wa vy cv c0 wceq vx cv vy cv cA cin wceq wa
      vy vy cv c0 csn wcel vy cv c0 wceq vx cv vy cv cA cin wceq vy c0 elsn
      anbi1i exbii vx cv vy cv cA cin wceq vx cv c0 wceq vy c0 0ex vy cv c0
      wceq vx cv vy cv cA cin wceq vx cv c0 cA cin wceq vx cv c0 wceq vy cv c0
      wceq vy cv cA cin c0 cA cin vx cv vy cv c0 cA ineq1 eqeq2d c0 cA cin c0
      vx cv c0 cA cin cA c0 cin c0 c0 cA incom cA in0 eqtri eqeq2i syl6bb
      ceqsexv 3bitri vx c0 elsn bitr4i syl6bb eqrdv $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${
    $d A a b y $. $d A x y $. $d J a b y $. $d J x y $.
    stoig2b.1 $e |- J e. Top $.
    stoig2b.2 $e |- A e. B $.
    $( The underlying set of a subspace topology. $)
    stoig2b $p |- ( J e. Top ->
     U. ( subSp ` <. A , J >. ) C_ A ) $=
      cJ ctop wcel vy cv cA cJ cop csubsp cfv cuni wcel vy cv cA wcel wi vy wal
      cA cJ cop csubsp cfv cuni cA wss cJ ctop wcel vy cv cA cJ cop csubsp cfv
      cuni wcel vy cv cA wcel wi vy vy cv cA cJ cop csubsp cfv cuni wcel cJ
      ctop wcel vy cv cA wcel vy cv cA cJ cop csubsp cfv cuni wcel vy cv va cv
      vb cv cA cin wceq vb cJ wrex va cab cuni wcel cJ ctop wcel vy cv cA wcel
      wi cA cJ cop csubsp cfv cuni va cv vb cv cA cin wceq vb cJ wrex va cab
      cuni vy cv cA cJ cop csubsp cfv va cv vb cv cA cin wceq vb cJ wrex va cab
      vb va cA cJ stoig2b.1 cA cB stoig2b.2 elisseti subsp unieqi eleq2i vy cv
      va cv vb cv cA cin wceq vb cJ wrex va cab cuni wcel vy va wel va cv vb cv
      cA cin wceq vb cJ wrex wa va wex cJ ctop wcel vy cv cA wcel wi va cv vb
      cv cA cin wceq vb cJ wrex va vy cv eluniab vy va wel va cv vb cv cA cin
      wceq vb cJ wrex wa cJ ctop wcel vy cv cA wcel wi va cJ ctop wcel vy cv cA
      wcel wi va ax-17 va cv vb cv cA cin wceq vb cJ wrex vy va wel cJ ctop
      wcel vy cv cA wcel wi va cv vb cv cA cin wceq vb cJ wrex vb cv cJ wcel va
      cv vb cv cA cin wceq wa vb wex vy va wel cJ ctop wcel vy cv cA wcel wi wi
      va cv vb cv cA cin wceq vb cJ df-rex vb cv cJ wcel va cv vb cv cA cin
      wceq wa vy va wel cJ ctop wcel vy cv cA wcel wi wi vb vy va wel cJ ctop
      wcel vy cv cA wcel wi wi vb ax-17 va cv vb cv cA cin wceq vy va wel cJ
      ctop wcel vy cv cA wcel wi wi vb cv cJ wcel va cv vb cv cA cin wceq vy va
      wel vy cv cA wcel cJ ctop wcel va cv vb cv cA cin wceq vy va wel vy cv vb
      cv cA cin wcel vy cv cA wcel va cv vb cv cA cin vy cv eleq2 vb cv cA cin
      cA vy cv vb cv cA inss2 sseli syl6bi a1dd adantl 19.23ai sylbi impcom
      19.23ai sylbi sylbi com12 19.21aiv vy vx cA cJ cop csubsp cfv cuni cA vx
      cv cA cJ cop csubsp cfv cuni wcel vy ax-17 vx cv cA wcel vy ax-17 dfss2f
      sylibr $.
      $( [20-Sep-2010] $) $( [18-Sep-2010] $)
  $}


  ${ $d A x y $. $d J x y $. $d X x $.
    subtopsin2.1 $e |- X = U. J $.
    $( The subspace topology induced by a singleton. $)
    subtopsin2 $p |- ( ( J e. Top /\ A e. X ) ->
      ( subSp ` <. { A } , J >. ) = { (/) , { A } } ) $=
      cJ ctop wcel cA cX wcel wa vx cA csn cJ cop csubsp cfv c0 cA csn cpr cJ
      ctop wcel cA cX wcel wa vx cv cA csn cJ cop csubsp cfv wcel vx cv c0 cA
      csn cpr wcel cJ ctop wcel cA cX wcel wa vx cv cA csn cJ cop csubsp cfv
      wcel vx cv vy cv cA csn cin wceq vy cJ wrex vx cv c0 cA csn cpr wcel cJ
      ctop wcel vx cv cvv wcel cA csn cvv wcel vx cv cA csn cJ cop csubsp cfv
      wcel vx cv vy cv cA csn cin wceq vy cJ wrex wb cJ ctop wcel cA cX wcel wa
      vy vx cv cA csn cvv cJ issubspt cJ ctop wcel cA cX wcel pm3.26 vx cv cvv
      wcel cJ ctop wcel cA cX wcel wa vx visset a1i cA csn cvv wcel cJ ctop
      wcel cA cX wcel wa cA snex a1i syl3anc vx cv vy cv cA csn cin wceq vx cv
      c0 cA csn cpr wcel vy cJ vx cv vy cv cA csn cin wceq vx cv c0 cA csn cpr
      wcel wi vy cv cJ wcel cA vy cv wcel vx cv vy cv cA csn cin wceq vx cv c0
      cA csn cpr wcel wi cA vy cv wcel cA csn vy cv wss vx cv vy cv cA csn cin
      wceq vx cv c0 cA csn cpr wcel wi cA vy cv snssi cA csn vy cv wss cA csn
      vy cv cin cA csn wceq vx cv vy cv cA csn cin wceq vx cv c0 cA csn cpr
      wcel wi cA csn vy cv df-ss vy cv cA csn cin cA csn vy cv cin wceq cA csn
      vy cv cin cA csn wceq vx cv vy cv cA csn cin wceq vx cv c0 cA csn cpr
      wcel wi vy cv cA csn incom vx cv vy cv cA csn cin wceq vy cv cA csn cin
      cA csn wceq vx cv c0 cA csn cpr wcel vy cv cA csn cin cA csn vy cv cin
      wceq cA csn vy cv cin cA csn wceq wa vx cv vy cv cA csn cin wceq vy cv cA
      csn cin cA csn wceq vx cv c0 cA csn cpr wcel vx cv vy cv cA csn cin wceq
      vy cv cA csn cin cA csn wceq wa vx cv cA csn wceq vx cv c0 cA csn cpr
      wcel vx cv vy cv cA csn cin cA csn eqtr vx cv cA csn wceq vx cv c0 wceq
      vx cv cA csn wceq wo vx cv c0 cA csn cpr wcel vx cv cA csn wceq vx cv c0
      wceq olc vx cv c0 cA csn vx visset elpr sylibr syl ex vy cv cA csn cin cA
      csn vy cv cin cA csn eqtr syl5com mpan sylbi syl cA vy cv wcel wn vy cv
      cA csn cin c0 wceq vx cv vy cv cA csn cin wceq vx cv c0 cA csn cpr wcel
      wi vy cv cA disjsn vx cv vy cv cA csn cin wceq vy cv cA csn cin c0 wceq
      vx cv c0 cA csn cpr wcel vx cv vy cv cA csn cin wceq vy cv cA csn cin c0
      wceq wa vx cv c0 wceq vx cv c0 cA csn cpr wcel vx cv vy cv cA csn cin c0
      eqtr vx cv c0 wceq vx cv c0 wceq vx cv cA csn wceq wo vx cv c0 cA csn cpr
      wcel vx cv c0 wceq vx cv cA csn wceq orc vx cv c0 cA csn vx visset elpr
      sylibr syl expcom sylbir pm2.61i a1i r19.23aiv syl6bi vx cv c0 cA csn cpr
      wcel cJ ctop wcel cA cX wcel wa vx cv cA csn cJ cop csubsp cfv wcel vx cv
      c0 cA csn cpr wcel vx cv c0 wceq vx cv cA csn wceq wo cJ ctop wcel cA cX
      wcel wa vx cv cA csn cJ cop csubsp cfv wcel wi vx cv c0 cA csn vx visset
      elpr vx cv c0 wceq cJ ctop wcel cA cX wcel wa vx cv cA csn cJ cop csubsp
      cfv wcel wi vx cv cA csn wceq vx cv c0 wceq vx cv cA csn cJ cop csubsp
      cfv wcel c0 cA csn cJ cop csubsp cfv wcel cJ ctop wcel cA cX wcel wa vx
      cv c0 cA csn cJ cop csubsp cfv eleq1 cJ ctop wcel cA cX wcel wa cA csn cA
      csn cJ cop csubsp cfv cop ctps wcel c0 cA csn cJ cop csubsp cfv wcel cJ
      ctop wcel cA csn cJ cuni wss cA csn cA csn cJ cop csubsp cfv cop ctps
      wcel cA cX wcel cA csn cJ stoig cA cX wcel cA cJ cuni wcel cA csn cJ cuni
      wss cX cJ cuni cA subtopsin2.1 eleq2i cA cJ cuni snssi sylbi sylan2 cA
      csn cA csn cJ cop csubsp cfv cop ctps wcel cA csn cJ cop csubsp cfv ctop
      wcel cA csn cA csn cJ cop csubsp cfv cuni wceq wa c0 cA csn cJ cop csubsp
      cfv wcel cA csn cA csn cJ cop csubsp cfv istps cA csn cJ cop csubsp cfv
      ctop wcel c0 cA csn cJ cop csubsp cfv wcel cA csn cA csn cJ cop csubsp
      cfv cuni wceq cA csn cJ cop csubsp cfv 0opn adantr sylbi syl syl5bir vx
      cv cA csn wceq vx cv cA csn cJ cop csubsp cfv wcel cA csn cA csn cJ cop
      csubsp cfv wcel cJ ctop wcel cA cX wcel wa vx cv cA csn cA csn cJ cop
      csubsp cfv eleq1 cJ ctop wcel cA cX wcel wa cA csn cA csn cJ cop csubsp
      cfv cop ctps wcel cA csn cA csn cJ cop csubsp cfv wcel cJ ctop wcel cA
      csn cJ cuni wss cA csn cA csn cJ cop csubsp cfv cop ctps wcel cA cX wcel
      cA csn cJ stoig cA cX wcel cA cJ cuni wcel cA csn cJ cuni wss cX cJ cuni
      cA subtopsin2.1 eleq2i cA cJ cuni snssi sylbi sylan2 cA csn cA csn cJ cop
      csubsp cfv cop ctps wcel cA csn cJ cop csubsp cfv ctop wcel cA csn cA csn
      cJ cop csubsp cfv cuni wceq wa cA csn cA csn cJ cop csubsp cfv wcel cA
      csn cA csn cJ cop csubsp cfv istps cA csn cJ cop csubsp cfv ctop wcel cA
      csn cJ cop csubsp cfv cuni cA csn cJ cop csubsp cfv wcel cA csn cA csn cJ
      cop csubsp cfv cuni wceq cA csn cA csn cJ cop csubsp cfv wcel cA csn cJ
      cop csubsp cfv cA csn cJ cop csubsp cfv cuni cA csn cJ cop csubsp cfv
      cuni eqid topopn cA csn cJ cop csubsp cfv cuni cA csn cJ cop csubsp cfv
      wcel cA csn cA csn cJ cop csubsp cfv wcel wi cA csn cJ cop csubsp cfv
      cuni cA csn cA csn cJ cop csubsp cfv cuni cA csn wceq cA csn cJ cop
      csubsp cfv cuni cA csn cJ cop csubsp cfv wcel cA csn cA csn cJ cop csubsp
      cfv wcel cA csn cJ cop csubsp cfv cuni cA csn cA csn cJ cop csubsp cfv
      eleq1 biimpd eqcoms mpan9 sylbi syl syl5bir jaoi sylbi com12 impbid eqrdv
      $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}


  ${ $d X x y z $.  $d J x y z $.  $d R x y z $.
    qusp.1 $e |- X = U. J $.
    qusp.2 $e |- Er R $.
    $( A quotient space is a topology. $)
    qusp $p |- ( J e. Top ->
      { x | ( x C_ ( X /. R ) /\ U. x e. J ) } e. Top ) $=
      cJ ctop wcel vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab ctop wcel
      vy cv vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wss vy cv cuni vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel wi vy wal vy cv vz cv
      cin vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel vz vx cv cX cR
      cqs wss vx cv cuni cJ wcel wa vx cab wral vy vx cv cX cR cqs wss vx cv
      cuni cJ wcel wa vx cab wral wa cJ ctop wcel vy cv vx cv cX cR cqs wss vx
      cv cuni cJ wcel wa vx cab wss vy cv cuni vx cv cX cR cqs wss vx cv cuni
      cJ wcel wa vx cab wcel wi vy wal vy cv vz cv cin vx cv cX cR cqs wss vx
      cv cuni cJ wcel wa vx cab wcel vz vx cv cX cR cqs wss vx cv cuni cJ wcel
      wa vx cab wral vy vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wral
      cJ ctop wcel vy cv vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wss
      vy cv cuni vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel wi vy cJ
      ctop wcel vx cv vy cv wcel vx cv cX cR cqs wss vx cv cuni cJ wcel wa wi
      vx wal vy cv cuni cX cR cqs wss vy cv cuni cuni cJ wcel wa vy cv vx cv cX
      cR cqs wss vx cv cuni cJ wcel wa vx cab wss vy cv cuni vx cv cX cR cqs
      wss vx cv cuni cJ wcel wa vx cab wcel cJ ctop wcel vx cv cX cR cqs wss vx
      cv cuni cJ wcel wa vx vy cv wral vy cv cuni cX cR cqs wss vy cv cuni cuni
      cJ wcel wa vx cv vy cv wcel vx cv cX cR cqs wss vx cv cuni cJ wcel wa wi
      vx wal cJ ctop wcel vx cv cX cR cqs wss vx vy cv wral vx cv cuni cJ wcel
      vx vy cv wral wa vy cv cuni cX cR cqs wss vy cv cuni cuni cJ wcel wa vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vx vy cv wral cJ ctop wcel vx cv
      cX cR cqs wss vx vy cv wral vx cv cuni cJ wcel vx vy cv wral vy cv cuni
      cX cR cqs wss vy cv cuni cuni cJ wcel wa cJ ctop wcel vy cv cuni cX cR
      cqs wss vx cv cuni cJ wcel vx vy cv wral vy cv cuni cX cR cqs wss vy cv
      cuni cuni cJ wcel wa wi vx cv cX cR cqs wss vx vy cv wral cJ ctop wcel vy
      cv cuni cX cR cqs wss vx cv cuni cJ wcel vx vy cv wral vy cv cuni cX cR
      cqs wss vy cv cuni cuni cJ wcel wa cJ ctop wcel vy cv cuni cX cR cqs wss
      wa vx cv cuni cJ wcel vx vy cv wral wa vy cv cuni cX cR cqs wss vy cv
      cuni cuni cJ wcel cJ ctop wcel vy cv cuni cX cR cqs wss vx cv cuni cJ
      wcel vx vy cv wral simplr cJ ctop wcel vy cv cuni cX cR cqs wss wa vx cv
      cuni cJ wcel vx vy cv wral wa vz cv vx cv cuni wceq vx cv vy cv wcel wa
      vx wex vz cab cuni cJ vy cv cuni cuni cJ ctop wcel vz cv vx cv cuni wceq
      vx cv vy cv wcel wa vx wex vz cab cJ wss vz cv vx cv cuni wceq vx cv vy
      cv wcel wa vx wex vz cab cuni cJ wcel cJ ctop wcel vy cv cuni cX cR cqs
      wss wa vx cv cuni cJ wcel vx vy cv wral wa vz cv vx cv cuni wceq vx cv vy
      cv wcel wa vx wex vz cab cJ uniopn cJ ctop wcel vy cv cuni cX cR cqs wss
      vx cv cuni cJ wcel vx vy cv wral simpll cJ ctop wcel vy cv cuni cX cR cqs
      wss wa vx cv cuni cJ wcel vx vy cv wral wa vz cv vx cv cuni wceq vx cv vy
      cv wcel wa vx wex vz cv cJ wcel wi vz wal vz cv vx cv cuni wceq vx cv vy
      cv wcel wa vx wex vz cab cJ wss vx cv cuni cJ wcel vx vy cv wral vz cv vx
      cv cuni wceq vx cv vy cv wcel wa vx wex vz cv cJ wcel wi vz wal cJ ctop
      wcel vy cv cuni cX cR cqs wss wa vx cv cuni cJ wcel vx vy cv wral vx cv
      vy cv wcel vx cv cuni cJ wcel wi vx wal vz cv vx cv cuni wceq vx cv vy cv
      wcel wa vx wex vz cv cJ wcel wi vz wal vx cv cuni cJ wcel vx vy cv df-ral
      vx cv vy cv wcel vx cv cuni cJ wcel wi vx wal vz cv vx cv cuni wceq vx cv
      vy cv wcel wa vx wex vz cv cJ wcel wi vz vx cv vy cv wcel vx cv cuni cJ
      wcel wi vx wal vz cv vx cv cuni wceq vx cv vy cv wcel wa vz cv cJ wcel vx
      vx cv vy cv wcel vx cv cuni cJ wcel wi vx hba1 vz cv cJ wcel vx ax-17 vx
      cv vy cv wcel vx cv cuni cJ wcel wi vz cv vx cv cuni wceq vx cv vy cv
      wcel wa vz cv cJ wcel wi vx vx cv vy cv wcel vx cv cuni cJ wcel wi vz cv
      vx cv cuni wceq vx cv vy cv wcel vz cv cJ wcel vx cv vy cv wcel vx cv
      cuni cJ wcel wi vx cv vy cv wcel vz cv vx cv cuni wceq vz cv cJ wcel vx
      cv cuni cJ wcel vz cv vx cv cuni wceq vz cv cJ wcel wi vx cv vy cv wcel
      vx cv cuni cJ vz cv eleq1a imim2i com23 imp3a a4s 19.23ad 19.21aiv sylbi
      adantl vz cv vx cv cuni wceq vx cv vy cv wcel wa vx wex vz cJ abss sylibr
      sylanc vz vx vy cv uniuni syl5eqel jca exp31 vx vy cv cX cR cqs unissb
      syl5ibr imp3a vx cv cX cR cqs wss vx cv cuni cJ wcel vx vy cv r19.26
      syl5ib vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx vy cv df-ral syl5ibr
      vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx vy cv ssab vx cv cX cR cqs
      wss vx cv cuni cJ wcel wa vy cv cuni cX cR cqs wss vy cv cuni cuni cJ
      wcel wa vx vy cv cuni vy cv vy visset uniex vx cv vy cv cuni wceq vx cv
      cX cR cqs wss vy cv cuni cX cR cqs wss vx cv cuni cJ wcel vy cv cuni cuni
      cJ wcel vx cv vy cv cuni cX cR cqs sseq1 vx cv vy cv cuni wceq vx cv cuni
      vy cv cuni cuni cJ vx cv vy cv cuni unieq eleq1d anbi12d elab 3imtr4g
      19.21aiv cJ ctop wcel vy cv vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx
      cab wcel vy cv vz cv cin vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab
      wcel vz vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wral wi vy wal
      vy cv vz cv cin vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel vz
      vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wral vy vx cv cX cR cqs
      wss vx cv cuni cJ wcel wa vx cab wral cJ ctop wcel vy cv vx cv cX cR cqs
      wss vx cv cuni cJ wcel wa vx cab wcel vy cv vz cv cin vx cv cX cR cqs wss
      vx cv cuni cJ wcel wa vx cab wcel vz vx cv cX cR cqs wss vx cv cuni cJ
      wcel wa vx cab wral wi vy cJ ctop wcel vy cv cX cR cqs wss vy cv cuni cJ
      wcel wa vy cv vz cv cin vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab
      wcel vz vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wral vy cv vx cv
      cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel cJ ctop wcel vy cv cX cR
      cqs wss vy cv cuni cJ wcel wa vy cv vz cv cin vx cv cX cR cqs wss vx cv
      cuni cJ wcel wa vx cab wcel vz vx cv cX cR cqs wss vx cv cuni cJ wcel wa
      vx cab wral cJ ctop wcel vy cv cX cR cqs wss vy cv cuni cJ wcel wa wa vy
      cv vz cv cin vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel vz vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab cJ ctop wcel vy cv cX cR
      cqs wss vy cv cuni cJ wcel wa wa vz cv cX cR cqs wss vz cv cuni cJ wcel
      wa vy cv vz cv cin cX cR cqs wss vy cv vz cv cin cuni cJ wcel wa vz cv vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel vy cv vz cv cin vx cv
      cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel cJ ctop wcel vy cv cX cR
      cqs wss vy cv cuni cJ wcel wa vz cv cX cR cqs wss vz cv cuni cJ wcel wa
      vy cv vz cv cin cX cR cqs wss vy cv vz cv cin cuni cJ wcel wa cJ ctop
      wcel vy cv cX cR cqs wss vz cv cX cR cqs wss wa vy cv cuni cJ wcel vz cv
      cuni cJ wcel wa wa vy cv vz cv cin cX cR cqs wss vy cv vz cv cin cuni cJ
      wcel wa vy cv cX cR cqs wss vy cv cuni cJ wcel wa vz cv cX cR cqs wss vz
      cv cuni cJ wcel wa wa cJ ctop wcel vy cv cX cR cqs wss vz cv cX cR cqs
      wss wa vy cv cuni cJ wcel vz cv cuni cJ wcel wa wa vy cv vz cv cin cX cR
      cqs wss vy cv vz cv cin cuni cJ wcel wa cJ ctop wcel vy cv cX cR cqs wss
      vz cv cX cR cqs wss wa vy cv cuni cJ wcel vz cv cuni cJ wcel wa wa wa vy
      cv vz cv cin cX cR cqs wss vy cv vz cv cin cuni cJ wcel vy cv cX cR cqs
      wss vz cv cX cR cqs wss wa vy cv cuni cJ wcel vz cv cuni cJ wcel wa wa vy
      cv vz cv cin cX cR cqs wss cJ ctop wcel vy cv cX cR cqs wss vy cv vz cv
      cin cX cR cqs wss vz cv cX cR cqs wss vy cv cuni cJ wcel vz cv cuni cJ
      wcel wa vy cv vz cv cX cR cqs ssinss1 ad2antrr adantl cJ ctop wcel vy cv
      cX cR cqs wss vz cv cX cR cqs wss wa vy cv cuni cJ wcel vz cv cuni cJ
      wcel wa wa wa vy cv vz cv cin cuni vy cv cuni vz cv cuni cin cJ vy cv cX
      cR cqs wss vz cv cX cR cqs wss wa vy cv vz cv cin cuni vy cv cuni vz cv
      cuni cin wceq cJ ctop wcel vy cv cuni cJ wcel vz cv cuni cJ wcel wa cX vy
      cv vz cv cR qusp.2 uninqs ad2antrl vy cv cX cR cqs wss vz cv cX cR cqs
      wss wa vy cv cuni cJ wcel vz cv cuni cJ wcel wa wa cJ ctop wcel vy cv
      cuni vz cv cuni cin cJ wcel vy cv cuni cJ wcel vz cv cuni cJ wcel wa cJ
      ctop wcel vy cv cuni vz cv cuni cin cJ wcel wi vy cv cX cR cqs wss vz cv
      cX cR cqs wss wa cJ ctop wcel vy cv cuni cJ wcel vz cv cuni cJ wcel wa vy
      cv cuni vz cv cuni cin cJ wcel cJ ctop wcel vy cv cuni cJ wcel vz cv cuni
      cJ wcel vy cv cuni vz cv cuni cin cJ wcel vy cv cuni vz cv cuni cJ inopn
      3expib com12 adantl impcom eqeltrd jca ex vy cv cX cR cqs wss vy cv cuni
      cJ wcel vz cv cX cR cqs wss vz cv cuni cJ wcel an4 syl5ib expdimp vx cv
      cX cR cqs wss vx cv cuni cJ wcel wa vz cv cX cR cqs wss vz cv cuni cJ
      wcel wa vx vz cv vz cv cX cR cqs wss vz cv cuni cJ wcel wa vx ax-17 vz
      visset vx cv vz cv wceq vx cv cX cR cqs wss vz cv cX cR cqs wss vx cv
      cuni cJ wcel vz cv cuni cJ wcel vx cv vz cv cX cR cqs sseq1 vx cv vz cv
      wceq vx cv cuni vz cv cuni cJ vx cv vz cv unieq eleq1d anbi12d elabf vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vy cv vz cv cin cX cR cqs wss vy
      cv vz cv cin cuni cJ wcel wa vx vy cv vz cv cin vy cv vz cv cin cX cR cqs
      wss vy cv vz cv cin cuni cJ wcel wa vx ax-17 vy cv vz cv vy visset inex1
      vx cv vy cv vz cv cin wceq vx cv cX cR cqs wss vy cv vz cv cin cX cR cqs
      wss vx cv cuni cJ wcel vy cv vz cv cin cuni cJ wcel vx cv vy cv vz cv cin
      cX cR cqs sseq1 vx cv vy cv vz cv cin wceq vx cv cuni vy cv vz cv cin
      cuni cJ vx cv vy cv vz cv cin unieq eleq1d anbi12d elabf 3imtr4g
      r19.21aiv ex vx cv cX cR cqs wss vx cv cuni cJ wcel wa vy cv cX cR cqs
      wss vy cv cuni cJ wcel wa vx vy cv vy cv cX cR cqs wss vy cv cuni cJ wcel
      wa vx ax-17 vy visset vx cv vy cv wceq vx cv cX cR cqs wss vy cv cX cR
      cqs wss vx cv cuni cJ wcel vy cv cuni cJ wcel vx cv vy cv cX cR cqs sseq1
      vx cv vy cv wceq vx cv cuni vy cv cuni cJ vx cv vy cv unieq eleq1d
      anbi12d elabf syl5ib 19.21aiv vy cv vz cv cin vx cv cX cR cqs wss vx cv
      cuni cJ wcel wa vx cab wcel vz vx cv cX cR cqs wss vx cv cuni cJ wcel wa
      vx cab wral vy vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab df-ral
      sylibr jca cJ ctop wcel vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab
      cvv wcel vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab ctop wcel vy cv
      vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wss vy cv cuni vx cv cX
      cR cqs wss vx cv cuni cJ wcel wa vx cab wcel wi vy wal vy cv vz cv cin vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab wcel vz vx cv cX cR cqs wss
      vx cv cuni cJ wcel wa vx cab wral vy vx cv cX cR cqs wss vx cv cuni cJ
      wcel wa vx cab wral wa wb cJ ctop wcel vx cv cX cR cqs wss vx cv cuni cJ
      wcel wa vx cab vx cv cX cR cqs cpw wcel vx cv cuni cJ wcel wa vx cab cvv
      cJ ctop wcel vx cv cX cR cqs wss vx cv cuni cJ wcel wa vx cv cX cR cqs
      cpw wcel vx cv cuni cJ wcel wa vx cJ ctop wcel vx cv cX cR cqs wss vx cv
      cX cR cqs cpw wcel vx cv cuni cJ wcel vx cv cX cR cqs wss vx cv cX cR cqs
      cpw wcel wb cJ ctop wcel vx cv cX cR cqs cpw wcel vx cv cX cR cqs wss vx
      cv cX cR cqs vx visset elpw bicomi a1i anbi1d abbidv vx cv cX cR cqs cpw
      wcel vx cv cuni cJ wcel wa vx cab cX cR cqs cpw wss cJ ctop wcel vx cv cX
      cR cqs cpw wcel vx cv cuni cJ wcel wa vx cab cvv wcel vx cv cuni cJ wcel
      vx cX cR cqs cpw ssab2 vx cv cX cR cqs cpw wcel vx cv cuni cJ wcel wa vx
      cab cX cR cqs cpw wss cJ ctop wcel cX cR cqs cpw cvv wcel vx cv cX cR cqs
      cpw wcel vx cv cuni cJ wcel wa vx cab cvv wcel vx cv cX cR cqs cpw wcel
      vx cv cuni cJ wcel wa vx cab cX cR cqs cpw wss cJ ctop wcel wa cX cvv
      wcel cX cR cqs cvv wcel cX cR cqs cpw cvv wcel cJ ctop wcel cX cvv wcel
      vx cv cX cR cqs cpw wcel vx cv cuni cJ wcel wa vx cab cX cR cqs cpw wss
      cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg qusp.1 syl5eqel adantl cX cR
      qsexg cX cR cqs cvv pwexg 3syl vx cv cX cR cqs cpw wcel vx cv cuni cJ
      wcel wa vx cab cX cR cqs cpw cvv ssexg syldan mpan eqeltrd vy vz cvv vx
      cv cX cR cqs wss vx cv cuni cJ wcel wa vx cab istopg syl mpbird $.
      $( [4-Jun-2007] $) $( [4-Jun-2007] $)
  $}

  ${
    $d A x $. $d J u v x z $. $d K u v x z $.
    eltpt.1 $e |- B = { z | E. u e. J E. v e. K z = ( u X. v ) } $.
    $( Condition for a set to belong to a product topology.. $)
    eltpt $p |- ( ( J e. Top /\ K e. Top ) -> ( A e. ( J tX K ) <-> E. x
       ( x C_ B /\ A = U. x ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cA cJ cK ctx co wcel cA vz cv vu cv vv cv
      cxp wceq vv cK wrex vu cJ wrex vz cab ctg cfv wcel vx cv vz cv vu cv vv
      cv cxp wceq vv cK wrex vu cJ wrex vz cab wss cA vx cv cuni wceq wa vx wex
      vx cv cB wss cA vx cv cuni wceq wa vx wex cJ ctop wcel cK ctop wcel wa cJ
      cK ctx co vz cv vu cv vv cv cxp wceq vv cK wrex vu cJ wrex vz cab ctg cfv
      cA vz vv vu cJ cK txval eleq2d cJ ctop wcel cK ctop wcel wa vz cv vu cv
      vv cv cxp wceq vv cK wrex vu cJ wrex vz cab ctb wcel cA vz cv vu cv vv cv
      cxp wceq vv cK wrex vu cJ wrex vz cab ctg cfv wcel vx cv vz cv vu cv vv
      cv cxp wceq vv cK wrex vu cJ wrex vz cab wss cA vx cv cuni wceq wa vx wex
      wb vz vv vu cJ cK txbas vx cA vz cv vu cv vv cv cxp wceq vv cK wrex vu cJ
      wrex vz cab eltg3 syl vx cv vz cv vu cv vv cv cxp wceq vv cK wrex vu cJ
      wrex vz cab wss cA vx cv cuni wceq wa vx wex vx cv cB wss cA vx cv cuni
      wceq wa vx wex wb cJ ctop wcel cK ctop wcel wa vx cv vz cv vu cv vv cv
      cxp wceq vv cK wrex vu cJ wrex vz cab wss cA vx cv cuni wceq wa vx cv cB
      wss cA vx cv cuni wceq wa vx vx cv vz cv vu cv vv cv cxp wceq vv cK wrex
      vu cJ wrex vz cab wss vx cv cB wss cA vx cv cuni wceq vx cv cB wss vx cv
      vz cv vu cv vv cv cxp wceq vv cK wrex vu cJ wrex vz cab wss cB vz cv vu
      cv vv cv cxp wceq vv cK wrex vu cJ wrex vz cab vx cv eltpt.1 sseq2i
      bicomi anbi1i exbii a1i 3bitrd $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
    topgele.1 $e |- X = U. J $.
    $( The topologies over the same set have a greatest element (the discrete
       topology) and a least element (the undiscrete topology). $)
    topgele $p |- ( J e. Top -> ( { (/) , X } C_ J /\ J C_ ~P X ) ) $=
      cJ ctop wcel cJ ctop wcel cJ cJ cuni cpw wss wa c0 cJ wcel cJ cuni cJ
      wcel wa wa c0 cX cpr cJ wss cJ cX cpw wss wa cJ ctop wcel cJ cJ cuni cpw
      wss wa c0 cJ wcel cJ cuni cJ wcel wa wa cJ cuni cJ cop ctps wcel cJ ctop
      wcel cJ cuni cJ istps2 cJ eltopsp bitr3i cJ ctop wcel cJ cJ cuni cpw wss
      c0 cJ wcel cJ cuni cJ wcel wa c0 cX cpr cJ wss cJ cX cpw wss wa cJ cJ
      cuni cpw wss c0 cJ wcel cJ cuni cJ wcel wa c0 cX cpr cJ wss cJ cX cpw wss
      wa wi wi cJ ctop wcel c0 cJ wcel cJ cuni cJ wcel wa cJ cJ cuni cpw wss c0
      cX cpr cJ wss cJ cX cpw wss wa c0 cJ wcel cJ cuni cJ wcel wa c0 cX cpr cJ
      wss cJ cJ cuni cpw wss cJ cX cpw wss c0 cJ wcel cJ cuni cJ wcel wa c0 cJ
      wcel cX cJ wcel wa c0 cX cpr cJ wss cX cJ cuni wceq c0 cJ wcel cJ cuni cJ
      wcel wa c0 cJ wcel cX cJ wcel wa wb topgele.1 cX cJ cuni wceq cJ cuni cJ
      wcel cX cJ wcel c0 cJ wcel cX cJ cuni wceq cJ cuni cX cJ cJ cuni cX wceq
      cJ cuni cX cJ cuni cX wceq id eqcoms eleq1d anbi2d ax-mp c0 cJ wcel cX cJ
      wcel wa c0 cX cpr cJ wss c0 cX cJ cJ cJ prssg ibi sylbi cJ cJ cuni cpw
      wss cJ cX cpw wss cJ cuni cpw cX cpw cJ cX cpw cJ cuni cpw cX cJ cuni
      wceq cX cpw cJ cuni cpw wceq topgele.1 cX cJ cuni pweq ax-mp eqcomi
      sseq2i biimpi anim12i expcom a1i imp31 sylbir $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)

    $( The topologies over the same set have a greatest element (the discrete
       topology). $)
    topge $p |- ( J e. Top -> J C_ ~P X ) $=
      cJ ctop wcel c0 cX cpr cJ wss cJ cX cpw wss cJ cX topgele.1 topgele
      pm3.27d $.
      $( [1-Jan-2011] $) $( [1-Jan-2011] $)
  $}

  ${
    ptincpw.1 $e |- X = U. J $.
    ptincpw.2 $e |- Y = U. K $.
    $( A product topology is included in the powerset of the cross product
       of the underlying sets. The cross product and the empty set are
       elements of a product topology. $)
    ptincpw $p |- ( ( J e. Top /\ K e. Top )
      -> ( { (/) , ( X X. Y ) } C_ ( J tX K )
           /\ ( J tX K ) C_ ~P ( X X. Y ) ) ) $=
      cJ cK ctx co cuni cX cY cxp wceq cJ ctop wcel cK ctop wcel wa c0 cX cY
      cxp cpr cJ cK ctx co wss cJ cK ctx co cX cY cxp cpw wss wa cJ cK cJ cK
      ctx co cX cY cJ cK ctx co eqid ptincpw.1 ptincpw.2 txuni cJ cK ctx co
      cuni cX cY cxp wceq c0 cX cY cxp cpr cJ cK ctx co wss cJ cK ctx co cX cY
      cxp cpw wss wa c0 cJ cK ctx co cuni cpr cJ cK ctx co wss cJ cK ctx co cJ
      cK ctx co cuni cpw wss wa cJ ctop wcel cK ctop wcel wa cJ cK ctx co cuni
      cX cY cxp wceq c0 cX cY cxp cpr cJ cK ctx co wss c0 cJ cK ctx co cuni cpr
      cJ cK ctx co wss cJ cK ctx co cX cY cxp cpw wss cJ cK ctx co cJ cK ctx co
      cuni cpw wss cJ cK ctx co cuni cX cY cxp wceq c0 cX cY cxp cpr c0 cJ cK
      ctx co cuni cpr cJ cK ctx co c0 cX cY cxp cpr c0 cJ cK ctx co cuni cpr
      wceq cX cY cxp cJ cK ctx co cuni cX cY cxp cJ cK ctx co cuni c0 preq2
      eqcoms sseq1d cJ cK ctx co cX cY cxp cpw wss cJ cK ctx co cJ cK ctx co
      cuni cpw wss wb cX cY cxp cJ cK ctx co cuni cX cY cxp cJ cK ctx co cuni
      wceq cX cY cxp cpw cJ cK ctx co cuni cpw cJ cK ctx co cX cY cxp cJ cK ctx
      co cuni pweq sseq2d eqcoms anbi12d cJ ctop wcel cK ctop wcel wa cJ cK ctx
      co ctop wcel c0 cJ cK ctx co cuni cpr cJ cK ctx co wss cJ cK ctx co cJ cK
      ctx co cuni cpw wss wa cJ cK cJ cK ctx co cJ cK ctx co eqid txtop cJ cK
      ctx co topindis syl syl5bir mpcom $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)

  $}

  ${
    $d A a x y  $. $d J a x y $. $d X a x y $.
    ttcnlem.1 $e |- X = U. J $.
    ttcnlem.2 $e |- F = { <. x , y >. | ( x e. X /\ y = <. x , A >. ) } $.
    $( A special case of ~ txcnopab , when one function is constant.
       Bourbaki TG I.26 prop. 4. $)
    ttcn $p |- ( ( J e. Top /\ A e. X ) -> F e. ( J Cn ( J tX J ) ) ) $=
      cJ ctop wcel cA cX wcel wa vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy
      copab cJ cJ cJ ctx co ccn co cF cJ ctop wcel cA cX wcel vx cv cX wcel vy
      cv vx cv cA cop wceq wa vx vy copab cJ cJ cJ ctx co ccn co wcel cJ ctop
      wcel va cv cX wcel wa vx cv cX wcel vy cv vx cv va cv cop wceq wa vx vy
      copab cJ cJ cJ ctx co ccn co wcel wi cJ ctop wcel cA cX wcel wa vx cv cX
      wcel vy cv vx cv cA cop wceq wa vx vy copab cJ cJ cJ ctx co ccn co wcel
      wi va cA cX va cv cA wceq cJ ctop wcel va cv cX wcel wa cJ ctop wcel cA
      cX wcel wa vx cv cX wcel vy cv vx cv va cv cop wceq wa vx vy copab cJ cJ
      cJ ctx co ccn co wcel vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy
      copab cJ cJ cJ ctx co ccn co wcel va cv cA wceq va cv cX wcel cA cX wcel
      cJ ctop wcel va cv cA cX eleq1 anbi2d va cv cA wceq vx cv cX wcel vy cv
      vx cv va cv cop wceq wa vx vy copab vx cv cX wcel vy cv vx cv cA cop wceq
      wa vx vy copab cJ cJ cJ ctx co ccn co va cv cA wceq vx cv cX wcel vy cv
      vx cv va cv cop wceq wa vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy va
      cv cA wceq vy cv vx cv va cv cop wceq vy cv vx cv cA cop wceq vx cv cX
      wcel va cv cA wceq vx cv va cv cop vx cv cA cop vy cv va cv cA vx cv
      opeq2 eqeq2d anbi2d opabbidv eleq1d imbi12d cJ ctop wcel cJ ctop wcel cJ
      ctop wcel w3a cid cX cres cJ cJ ccn co wcel cX va cv csn cxp cJ cJ ccn co
      wcel vx cv cX wcel vy cv vx cv va cv cop wceq wa vx vy copab cJ cJ cJ ctx
      co ccn co wcel cJ ctop wcel va cv cX wcel wa cJ ctop wcel va cv cX wcel
      wa cJ ctop wcel cJ ctop wcel cJ ctop wcel cJ ctop wcel va cv cX wcel
      pm3.26 cJ ctop wcel va cv cX wcel pm3.26 cJ ctop wcel va cv cX wcel
      pm3.26 3jca cJ ctop wcel cid cX cres cJ cJ ccn co wcel va cv cX wcel cJ
      cX ttcnlem.1 idcn adantr cJ ctop wcel cJ ctop wcel va cv cX wcel cX va cv
      csn cX va cv csn cxp wf wa cX va cv csn cxp cJ cJ ccn co wcel cJ ctop
      wcel va cv cX wcel wa cJ ctop wcel va cv cX wcel pm3.26 cJ ctop wcel va
      cv cX wcel pm3.26 cJ ctop wcel va cv cX wcel wa va cv cX wcel cX va cv
      csn cX va cv csn cxp wf cJ ctop wcel va cv cX wcel pm3.27 cX va cv va
      visset fconst jctir va cv cX va cv csn cxp cJ cJ cX cX ttcnlem.1
      ttcnlem.1 cnconst sylan31c vx vy cJ cJ cJ cJ ctx co cJ cid cX cres cX va
      cv csn cxp vx cv cX wcel vy cv vx cv va cv cop wceq wa vx vy copab cX cJ
      cJ ctx co eqid ttcnlem.1 vx cv cX wcel vy cv vx cv va cv cop wceq wa vx
      cv cX wcel vy cv vx cv cid cX cres cfv vx cv cX va cv csn cxp cfv cop
      wceq wa vx vy vx cv cX wcel vy cv vx cv va cv cop wceq vy cv vx cv cid cX
      cres cfv vx cv cX va cv csn cxp cfv cop wceq vx cv cX wcel vx cv va cv
      cop vx cv cid cX cres cfv vx cv cX va cv csn cxp cfv cop vy cv vx cv cX
      wcel vx cv vx cv cid cX cres cfv va cv vx cv cX va cv csn cxp cfv vx cv
      cX wcel vx cv cid cX cres cfv vx cv cX vx cv fvresi eqcomd vx cv cX wcel
      vx cv cX va cv csn cxp cfv va cv cX va cv vx cv va visset fvconst2 eqcomd
      opeq12d eqeq2d pm5.32i opabbii txcnopab sylan32c vtoclg anabsi7 ttcnlem.2
      syl5eqel $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filters
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A u x y w $.  $d B a b u v x y z $.  $d X a b x y z $.
    fgsb.1 $e |- B = { x | E. y
                  ( y C_ A /\ y e. Fin /\ x = |^| y ) } $.
    $( Filter generated by a subbasis ` A ` .  Bourbaki TG I.37 paragraph
       above prop. 1. The theorem has been slightly modified because
       the definitions of the empty set are different in Bourbaki and
       Metamath. $)
    fgsb   $p |- ( ( A C_ ~P X /\ X e. _V /\ A =/= (/) ) -> ( -. (/) e. B ->
      { x e. ~P X | E. y e. B y C_ x } e. Fil ) ) $=
      cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn vy cv vx cv wss vy
      cB wrex vx cX cpw crab cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a
      c0 cB wcel wn wa vy cv vx cv wss vy cB wrex vx cX cpw crab cfil wcel c0
      vy cv vx cv wss vy cB wrex vx cX cpw crab wcel wn vy cv vx cv wss vy cB
      wrex vx cX cpw crab cuni vy cv vx cv wss vy cB wrex vx cX cpw crab wcel
      wa va cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel vb cv vy cv vx cv
      wss vy cB wrex vx cX cpw crab cuni wss va cv vb cv wss w3a vb cv vy cv vx
      cv wss vy cB wrex vx cX cpw crab wcel wi vb wal va wal va cv vb cv cin vy
      cv vx cv wss vy cB wrex vx cX cpw crab wcel vb vy cv vx cv wss vy cB wrex
      vx cX cpw crab wral va vy cv vx cv wss vy cB wrex vx cX cpw crab wral w3a
      cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa c0 vy cv vx cv
      wss vy cB wrex vx cX cpw crab wcel wn vy cv vx cv wss vy cB wrex vx cX
      cpw crab cuni vy cv vx cv wss vy cB wrex vx cX cpw crab wcel wa va cv vy
      cv vx cv wss vy cB wrex vx cX cpw crab wcel vb cv vy cv vx cv wss vy cB
      wrex vx cX cpw crab cuni wss va cv vb cv wss w3a vb cv vy cv vx cv wss vy
      cB wrex vx cX cpw crab wcel wi vb wal va wal va cv vb cv cin vy cv vx cv
      wss vy cB wrex vx cX cpw crab wcel vb vy cv vx cv wss vy cB wrex vx cX
      cpw crab wral va vy cv vx cv wss vy cB wrex vx cX cpw crab wral cA cX cpw
      wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa c0 vy cv vx cv wss vy cB
      wrex vx cX cpw crab wcel wn vy cv vx cv wss vy cB wrex vx cX cpw crab
      cuni vy cv vx cv wss vy cB wrex vx cX cpw crab wcel c0 cB wcel wn c0 vy
      cv vx cv wss vy cB wrex vx cX cpw crab wcel wn cA cX cpw wss cX cvv wcel
      cA c0 wne w3a c0 vy cv vx cv wss vy cB wrex vx cX cpw crab wcel c0 cB
      wcel c0 vy cv vx cv wss vy cB wrex vx cX cpw crab wcel c0 cX cpw wcel vy
      cv c0 wss vy cB wrex wa c0 cB wcel vy cv vx cv wss vy cB wrex vy cv c0
      wss vy cB wrex vx c0 cX cpw vx cv c0 wceq vy cv vx cv wss vy cv c0 wss vy
      cB vx cv c0 vy cv sseq2 rexbidv elrab vy cv c0 wss vy cB wrex c0 cB wcel
      c0 cX cpw wcel vy cv c0 wss c0 cB wcel vy cB vy cv c0 wss vy cv cB wcel
      c0 cB wcel vy cv c0 wss vy cv c0 cB vy cv ss0 eleq1d biimpcd r19.23aiv
      adantl sylbi con3i adantl cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB
      wcel wn wa vy cv vx cv wss vy cB wrex vx cX cpw crab cuni cX cpw wcel vy
      cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vy cB wrex wa vy cv
      vx cv wss vy cB wrex vx cX cpw crab cuni vy cv vx cv wss vy cB wrex vx cX
      cpw crab wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv vx cv wss vy
      cB wrex vx cX cpw crab cuni cX cpw wcel vy cv vy cv vx cv wss vy cB wrex
      vx cX cpw crab cuni wss vy cB wrex wa c0 cB wcel wn cA cX cpw wss cX cvv
      wcel cA c0 wne w3a vy cv vx cv wss vy cB wrex vx cX cpw crab cuni cX cpw
      wcel vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vy cB wrex
      cX cvv wcel cA cX cpw wss vy cv vx cv wss vy cB wrex vx cX cpw crab cuni
      cX cpw wcel cA c0 wne vy cv vx cv wss vy cB wrex vx cX cvv ump 3ad2ant2
      cB c0 wne vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vy cB
      wral vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vy cB wrex
      cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv vy cv vx cv wss vy cB wrex
      vx cX cpw crab cuni wss vy cB r19.2z cA c0 wne cA cX cpw wss cB c0 wne cX
      cvv wcel cA c0 wne vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab c0 wne cB c0 wne vx vy cA fine cB vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab c0 fgsb.1 neeq1i sylibr
      3ad2ant3 cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv vy cv vx cv wss vy
      cB wrex vx cX cpw crab cuni wss vy cB cA cX cpw wss cX cvv wcel cA c0 wne
      w3a vy cv cB wcel wa vy cv vy cv wss vy cv vy cv vx cv wss vy cB wrex vx
      cX cpw crab wcel wa vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni
      wss cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv cB wcel wa vy cv vy cv
      vx cv wss vy cB wrex vx cX cpw crab wcel vy cv vy cv wss cA cX cpw wss cX
      cvv wcel cA c0 wne w3a vy cv cB wcel wa vy cv cX cpw wcel vz cv vy cv wss
      vz cB wrex wa vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel cA cX
      cpw wss cX cvv wcel cA c0 wne w3a vy cv cB wcel wa vy cv cX cpw wcel vz
      cv vy cv wss vz cB wrex cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv cB
      wcel wa vy cv cX wss vy cv cX cpw wcel cA cX cpw wss cX cvv wcel cA c0
      wne w3a vy cv cB wcel wa vy cv cX cpw cuni cX vy cv cB wcel cA cX cpw wss
      cX cvv wcel cA c0 wne w3a vy cv cA cuni cX cpw cuni vu cv cB wcel vu cv
      cA cuni wss wi vy cv cB wcel vy cv cA cuni wss wi vu vy vy cv cB wcel vy
      cv cA cuni wss wi vu ax-17 vu cv vy cv wceq vu cv cB wcel vy cv cB wcel
      vu cv cA cuni wss vy cv cA cuni wss vu cv vy cv cB eleq1 vu cv vy cv cA
      cuni sseq1 imbi12d vu cv cB wcel vu cv vy cv cA wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wcel vu cv cA cuni wss cB vy cv cA wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab vu cv fgsb.1
      eleq2i vx vy vu cv cA fiiu sylbi chvar cA cX cpw wss cX cvv wcel cA cuni
      cX cpw cuni wss cA c0 wne cA cX cpw uniss 3ad2ant1 sylan9ssr cX unipw
      syl6ss vy cv cX vy visset elpw sylibr cA cX cpw wss cX cvv wcel cA c0 wne
      w3a vy cv cB wcel wa vy cv cB wcel vy cv vy cv wss wa vz cv vy cv wss vz
      cB wrex cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv cB wcel wa vy cv cB
      wcel vy cv vy cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv cB
      wcel pm3.27 vy cv ssid jctir vz cv vy cv wss vy cv vy cv wss vz vy cv cB
      vz cv vy cv vy cv sseq1 rcla4ev syl jca vy cv vx cv wss vy cB wrex vz cv
      vy cv wss vz cB wrex vx vy cv cX cpw vx cv vy cv wceq vz cv vx cv wss vz
      cB wrex vz cv vy cv wss vz cB wrex vy cv vx cv wss vy cB wrex vx cv vy cv
      wceq vz cv vx cv wss vz cv vy cv wss vz cB vx cv vy cv vz cv sseq2
      rexbidv vy cv vx cv wss vz cv vx cv wss vy vz cB vy cv vz cv vx cv sseq1
      cbvrexv syl5bb elrab sylibr vy cv ssid jctil vy cv vy cv vy cv vx cv wss
      vy cB wrex vx cX cpw crab ssuni syl r19.21aiva sylanc jca adantr vy cv vx
      cv wss vy cB wrex vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni
      wss vy cB wrex vx vz vy cv vx cv wss vy cB wrex vx cX cpw crab cuni cX
      cpw vx vz vy cv vx cv wss vy cB wrex vx cX cpw crab vy cv vx cv wss vy cB
      wrex vx vz cX cpw hbrab1 hbuni vx vz cX vz cv cX wcel vx ax-17 hbpw vy cv
      vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vx vy cB vy cv cB wcel
      vx ax-17 vx vz vy cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni vz cv
      vy cv wcel vx ax-17 vx vz vy cv vx cv wss vy cB wrex vx cX cpw crab vy cv
      vx cv wss vy cB wrex vx vz cX cpw hbrab1 hbuni hbss hbrex vx cv vy cv vx
      cv wss vy cB wrex vx cX cpw crab cuni wceq vy cv vx cv wss vy cv vy cv vx
      cv wss vy cB wrex vx cX cpw crab cuni wss vy cB vy vw vz vx cv vy cv vx
      cv wss vy cB wrex vx cX cpw crab cuni vw cv vx cv wcel vy ax-17 vy vz vy
      cv vx cv wss vy cB wrex vx cX cpw crab vy cv vx cv wss vy cB wrex vy vx
      vz cX cpw vy cv vx cv wss vy cB hbre1 vz cv cX cpw wcel vy ax-17 hbrab
      hbuni hbeq vx cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni vy cv
      sseq2 rexbid elrabf sylibr jca va cv vy cv vx cv wss vy cB wrex vx cX cpw
      crab wcel vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss va cv
      vb cv wss w3a vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel wi vb
      wal va wal cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa va cv
      vy cv vx cv wss vy cB wrex vx cX cpw crab wcel vb cv vy cv vx cv wss vy
      cB wrex vx cX cpw crab cuni wss va cv vb cv wss w3a vb cv vy cv vx cv wss
      vy cB wrex vx cX cpw crab wcel wi va vb va cv vy cv vx cv wss vy cB wrex
      vx cX cpw crab wcel vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni
      wss va cv vb cv wss w3a vb cv cX cpw wcel vy cv vb cv wss vy cB wrex wa
      vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel va cv cX cpw wcel vy
      cv va cv wss vy cB wrex wa vb cv vy cv vx cv wss vy cB wrex vx cX cpw
      crab cuni wss va cv vb cv wss vb cv cX cpw wcel vy cv vb cv wss vy cB
      wrex wa va cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel va cv cX cpw
      wcel vy cv va cv wss vy cB wrex wa vb cv vy cv vx cv wss vy cB wrex vx cX
      cpw crab cuni wss va cv vb cv wss w3a vb cv cX cpw wcel vy cv vb cv wss
      vy cB wrex vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss va cv
      cX cpw wcel vy cv va cv wss vy cB wrex wa vb cv cX cpw wcel va cv vb cv
      wss vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vb cv vy cv
      vx cv wss vy cB wrex vx cX cpw crab cuni cpw wcel vb cv cX cpw wcel vb cv
      vy cv vx cv wss vy cB wrex vx cX cpw crab cuni vb visset elpw vy cv vx cv
      wss vy cB wrex vx cX cpw crab cuni cpw cX cpw vb cv vy cv vx cv wss vy cB
      wrex vx cX cpw crab cuni cX wss vy cv vx cv wss vy cB wrex vx cX cpw crab
      cuni cpw cX cpw wss vy cv vx cv wss vy cB wrex vx cX cpw crab cuni cX wss
      vz cv cX wss vz vy cv vx cv wss vy cB wrex vx cX cpw crab vz vy cv vx cv
      wss vy cB wrex vx cX cpw crab cX unissb vz cv vy cv vx cv wss vy cB wrex
      vx cX cpw crab wcel vz cv cX cpw wcel vy cv vz cv wss vy cB wrex wa vz cv
      cX wss vy cv vx cv wss vy cB wrex vy cv vz cv wss vy cB wrex vx vz cv cX
      cpw vx cv vz cv wceq vy cv vx cv wss vy cv vz cv wss vy cB vx cv vz cv vy
      cv sseq2 rexbidv elrab vz cv cX cpw wcel vz cv cX wss vy cv vz cv wss vy
      cB wrex vz cv cX elpwi adantr sylbi mprgbir vy cv vx cv wss vy cB wrex vx
      cX cpw crab cuni cX sspwb mpbi sseli sylbir 3ad2ant2 va cv cX cpw wcel vy
      cv va cv wss vy cB wrex wa va cv vb cv wss vy cv vb cv wss vy cB wrex vb
      cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss vy cv va cv wss vy
      cB wrex va cv vb cv wss vy cv vb cv wss vy cB wrex va cv cX cpw wcel vy
      cv va cv wss vy cB wrex va cv vb cv wss wa vy cv va cv wss va cv vb cv
      wss wa vy cB wrex vy cv vb cv wss vy cB wrex vy cv va cv wss va cv vb cv
      wss vy cB r19.41v vy cv va cv wss va cv vb cv wss wa vy cv vb cv wss vy
      cB vy cv va cv vb cv sstr r19.22si sylbir adantll 3adant2 jca vy cv vx cv
      wss vy cB wrex vy cv va cv wss vy cB wrex vx va cv cX cpw vx cv va cv
      wceq vy cv vx cv wss vy cv va cv wss vy cB vx cv va cv vy cv sseq2
      rexbidv elrab syl3an1b vy cv vx cv wss vy cB wrex vy cv vb cv wss vy cB
      wrex vx vb cv cX cpw vx cv vb cv wceq vy cv vx cv wss vy cv vb cv wss vy
      cB vx cv vb cv vy cv sseq2 rexbidv elrab sylibr gen2 a1i va cv vb cv cin
      vy cv vx cv wss vy cB wrex vx cX cpw crab wcel vb vy cv vx cv wss vy cB
      wrex vx cX cpw crab wral va vy cv vx cv wss vy cB wrex vx cX cpw crab
      wral cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa va cv vb cv
      cin vy cv vx cv wss vy cB wrex vx cX cpw crab wcel va vb vy cv vx cv wss
      vy cB wrex vx cX cpw crab vy cv vx cv wss vy cB wrex vx cX cpw crab va cv
      cX cpw wcel vy cv va cv wss vy cB wrex wa vb cv cX cpw wcel vy cv vb cv
      wss vy cB wrex wa va cv vb cv cin vy cv vx cv wss vy cB wrex vx cX cpw
      crab wcel va cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel vb cv vy
      cv vx cv wss vy cB wrex vx cX cpw crab wcel va cv cX cpw wcel vy cv va cv
      wss vy cB wrex wa vb cv cX cpw wcel vy cv vb cv wss vy cB wrex wa wa va
      cv vb cv cin cX cpw wcel vy cv va cv vb cv cin wss vy cB wrex wa va cv vb
      cv cin vy cv vx cv wss vy cB wrex vx cX cpw crab wcel va cv cX cpw wcel
      vb cv cX cpw wcel vy cv va cv wss vy cB wrex vy cv vb cv wss vy cB wrex
      va cv vb cv cin cX cpw wcel vy cv va cv vb cv cin wss vy cB wrex wa va cv
      cX cpw wcel vb cv cX cpw wcel wa va cv vb cv cin cX cpw wcel vy cv va cv
      wss vy cB wrex vy cv vb cv wss vy cB wrex wa vy cv va cv vb cv cin wss vy
      cB wrex va cv cX cpw wcel va cv vb cv cin cX cpw wcel vb cv cX cpw wcel
      va cv vb cv cX inpws1 adantr vu cv va cv wss vu cB wrex vv cv vb cv wss
      vv cB wrex vy cv va cv vb cv cin wss vy cB wrex vy cv va cv wss vy cB
      wrex vy cv vb cv wss vy cB wrex vu cv va cv wss vu cB wrex vv cv vb cv
      wss vv cB wrex vy cv va cv vb cv cin wss vy cB wrex vu cv va cv wss vv cv
      vb cv wss vv cB wrex vy cv va cv vb cv cin wss vy cB wrex wi vu cB vv cv
      vb cv wss vv cB wrex vu cv cB wcel vu cv va cv wss wa vy cv va cv vb cv
      cin wss vy cB wrex vv cv vb cv wss vu cv cB wcel vu cv va cv wss wa vy cv
      va cv vb cv cin wss vy cB wrex wi vv cB vu cv cB wcel vu cv va cv wss wa
      vv cv cB wcel vv cv vb cv wss wa vy cv va cv vb cv cin wss vy cB wrex vu
      cv cB wcel vv cv cB wcel vu cv va cv wss vv cv vb cv wss vy cv va cv vb
      cv cin wss vy cB wrex vu cv vv cv cin cB wcel vu cv vv cv cin va cv vb cv
      cin wss vy cv va cv vb cv cin wss vy cB wrex vu cv cB wcel vv cv cB wcel
      wa vu cv va cv wss vv cv vb cv wss wa vy cv va cv vb cv cin wss vu cv vv
      cv cin va cv vb cv cin wss vy vu cv vv cv cin cB vu cv vv cv cin va cv vb
      cv cin wss vy ax-17 vy cv vu cv vv cv cin va cv vb cv cin sseq1 rcla4e vu
      cv cB wcel vv cv cB wcel wa vu cv vy cv cA wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx cab wcel vv cv vy cv cA wss vy cv cfn wcel vx cv
      vy cv cint wceq w3a vy wex vx cab wcel wa vu cv vv cv cin vy cv cA wss vy
      cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vu cv vv cv cin
      cB wcel vu cv cB wcel vu cv vy cv cA wss vy cv cfn wcel vx cv vy cv cint
      wceq w3a vy wex vx cab wcel vv cv cB wcel vv cv vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vu cv cB wcel vu cv vy
      cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel cB
      vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab vu cv
      fgsb.1 eleq2i biimpi vv cv cB wcel vv cv vy cv cA wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vx cab wcel cB vy cv cA wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab vv cv fgsb.1 eleq2i biimpi
      anim12i vx vy vu cv vv cv cA infi1 vu cv vv cv cin vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vu cv vv cv cin cB wcel
      vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab cB vu
      cv vv cv cin cB vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy
      wex vx cab fgsb.1 eqcomi eleq2i biimpi 3syl vu cv va cv vv cv vb cv ss2in
      syl2an an4s expcom r19.23aiva com12 r19.23aiva imp vy cv va cv wss vu cv
      va cv wss vy vu cB vy cv vu cv va cv sseq1 cbvrexv vy cv vb cv wss vv cv
      vb cv wss vy vv cB vy cv vv cv vb cv sseq1 cbvrexv syl2anb anim12i an4s
      vy cv vx cv wss vy cB wrex vy cv va cv vb cv cin wss vy cB wrex vx va cv
      vb cv cin cX cpw vx cv va cv vb cv cin wceq vy cv vx cv wss vy cv va cv
      vb cv cin wss vy cB vx cv va cv vb cv cin wceq vy cv cB wcel wa vx cv va
      cv vb cv cin vy cv vx cv va cv vb cv cin wceq vy cv cB wcel pm3.26 sseq2d
      rexbidva elrab sylibr vy cv vx cv wss vy cB wrex vy cv va cv wss vy cB
      wrex vx va cv cX cpw vx cv va cv wceq vy cv vx cv wss vy cv va cv wss vy
      cB vx cv va cv wceq vy cv cB wcel wa vx cv va cv vy cv vx cv va cv wceq
      vy cv cB wcel pm3.26 sseq2d rexbidva elrab vy cv vx cv wss vy cB wrex vy
      cv vb cv wss vy cB wrex vx vb cv cX cpw vx cv vb cv wceq vy cv vx cv wss
      vy cv vb cv wss vy cB vx cv vb cv wceq vy cv cB wcel wa vx cv vb cv vy cv
      vx cv vb cv wceq vy cv cB wcel pm3.26 sseq2d rexbidva elrab syl2anb rgen2
      a1i 3jca cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa vy cv
      vx cv wss vy cB wrex vx cX cpw crab cvv wcel vy cv vx cv wss vy cB wrex
      vx cX cpw crab cfil wcel c0 vy cv vx cv wss vy cB wrex vx cX cpw crab
      wcel wn vy cv vx cv wss vy cB wrex vx cX cpw crab cuni vy cv vx cv wss vy
      cB wrex vx cX cpw crab wcel wa va cv vy cv vx cv wss vy cB wrex vx cX cpw
      crab wcel vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab cuni wss va cv
      vb cv wss w3a vb cv vy cv vx cv wss vy cB wrex vx cX cpw crab wcel wi vb
      wal va wal va cv vb cv cin vy cv vx cv wss vy cB wrex vx cX cpw crab wcel
      vb vy cv vx cv wss vy cB wrex vx cX cpw crab wral va vy cv vx cv wss vy
      cB wrex vx cX cpw crab wral w3a wb cA cX cpw wss cX cvv wcel cA c0 wne
      w3a vy cv vx cv wss vy cB wrex vx cX cpw crab cvv wcel c0 cB wcel wn cX
      cvv wcel cA cX cpw wss vy cv vx cv wss vy cB wrex vx cX cpw crab cvv wcel
      cA c0 wne cX cvv wcel cX cpw cvv wcel vy cv vx cv wss vy cB wrex vx cX
      cpw crab cvv wcel cX cvv pwexg vy cv vx cv wss vy cB wrex vx cX cpw cvv
      rabexg syl 3ad2ant2 adantr va vb cvv vy cv vx cv wss vy cB wrex vx cX cpw
      crab vy cv vx cv wss vy cB wrex vx cX cpw crab cuni vy cv vx cv wss vy cB
      wrex vx cX cpw crab cuni eqid isfil syl mpbird ex $.
      $( [2-Sep-2008] $) $( [16-Nov-2007] $)
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d X x y z $.
    efilcp.1 $e |- B = { z | E. y
                  ( y C_ A /\ y e. Fin /\ z = |^| y ) } $.
    $( A filter containing a set ` A ` exists iff ` A ` has the finite
      intersection property (i.e. no finite intersection of elements of ` A `
      is empty).  Bourbaki TG I.37 prop. 1. $)
    efilcp  $p |- ( ( A C_ ~P X /\ X e. _V /\ A =/= (/) ) ->
      ( -. (/) e. B <-> E. x e. Fil A C_ x ) ) $=
      cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn cA vx cv wss vx
      cfil wrex cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn cA vx cv
      wss vx cfil wrex vy cv vz cv wss vy cB wrex vz cX cpw crab cfil wcel cA
      vy cv vz cv wss vy cB wrex vz cX cpw crab wss cA vx cv wss vx cfil wrex
      cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa cA vx cv wss cA
      vy cv vz cv wss vy cB wrex vz cX cpw crab wss vx vy cv vz cv wss vy cB
      wrex vz cX cpw crab cfil vx cv vy cv vz cv wss vy cB wrex vz cX cpw crab
      cA sseq2 rcla4ev cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn vy
      cv vz cv wss vy cB wrex vz cX cpw crab cfil wcel vz vy cA cB cX efilcp.1
      fgsb imp cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wa cA cX
      cpw wss vy cv vz cv wss vy cB wrex vz cA wral wa cA vy cv vz cv wss vy cB
      wrex vz cX cpw crab wss cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB
      wcel wn wa cA cX cpw wss vy cv vz cv wss vy cB wrex vz cA wral cA cX cpw
      wss cX cvv wcel cA c0 wne w3a cA cX cpw wss c0 cB wcel wn cA cX cpw wss
      cX cvv wcel cA c0 wne 3simp1 adantr vy cv vz cv wss vy cB wrex vz cA cA
      cB wss vz cv cA wcel vy cv vz cv wss vy cB wrex cA vy cv cA wss vy cv cfn
      wcel vz cv vy cv cint wceq w3a vy wex vz cab cB vz vy cA abfi efilcp.1
      sseqtr4i cA cB wss vz cv cA wcel wa vz cv cB wcel vy cv vz cv wss vy cB
      wrex cA cB vz cv ssel2 vz cv cB wcel vz cv vz cv wss vy cv vz cv wss vy
      cB wrex vz cv ssid vy cv vz cv wss vz cv vz cv wss vy vz cv cB vy cv vz
      cv vz cv sseq1 rcla4ev mpan2 syl mpan rgen jctir vy cv vz cv wss vy cB
      wrex vz cX cpw cA ssrab sylibr sylanc ex cA vx cv wss vx cfil wrex cA cX
      cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn cA vx cv wss cA cX cpw
      wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn wi vx cfil vx cv cfil wcel cA
      vx cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cB wcel wn vx cv
      cfil wcel cA vx cv wss wa cA cX cpw wss cX cvv wcel cA c0 wne w3a wa vy
      cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex wn c0 cB wcel wn
      vx cv cfil wcel cA vx cv wss wa cA cX cpw wss cX cvv wcel cA c0 wne w3a
      wa vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a vy vx cv cfil wcel
      cA vx cv wss wa cA cX cpw wss cX cvv wcel cA c0 wne w3a wa vy cv cA wss
      vy cv cfn wcel wa c0 vy cv cint wceq wa wn vy cv cA wss vy cv cfn wcel c0
      vy cv cint wceq w3a wn vx cv cfil wcel cA vx cv wss wa cA cX cpw wss cX
      cvv wcel cA c0 wne w3a wa vy cv cA wss vy cv cfn wcel wa c0 vy cv cint
      wceq wa wn wi vx cv cfil wcel cA vx cv wss wa cA cX cpw wss cX cvv wcel
      cA c0 wne w3a wa vy cv cA wss vy cv cfn wcel wa wa c0 vy cv cint wceq wn
      wi vx cv cfil wcel cA vx cv wss wa cA cX cpw wss cX cvv wcel cA c0 wne
      w3a wa vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wn vx cv cfil
      wcel cA vx cv wss wa cA cX cpw wss cX cvv wcel cA c0 wne w3a wa vy cv c0
      wceq vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vx cv cfil
      wcel cA vx cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv c0 wceq
      wn vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi wi vx cv cfil
      wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a cA vx cv wss vy cv c0 wceq
      wn vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi wi vx cv cfil
      wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a cA vx cv wss vy cv c0 wceq
      wn vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi wi wi vy cv cA
      wss vy cv cfn wcel wa cA vx cv wss vy cv c0 wceq wn vx cv cfil wcel cA cX
      cpw wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint wceq wn vy cv cA wss
      vy cv cfn wcel cA vx cv wss vy cv c0 wceq wn vx cv cfil wcel cA cX cpw
      wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint wceq wn wi wi wi vy cv cA
      wss cA vx cv wss vy cv cfn wcel vy cv c0 wceq wn vx cv cfil wcel cA cX
      cpw wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint wceq wn wi wi vy cv cA
      wss cA vx cv wss vy cv cfn wcel vy cv c0 wceq wn vx cv cfil wcel cA cX
      cpw wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint wceq wn wi wi wi vy cv
      cA wss cA vx cv wss wa vy cv vx cv wss vy cv cfn wcel vy cv c0 wceq wn vx
      cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint
      wceq wn wi wi wi vy cv cA vx cv sstr vy cv c0 wceq wn vy cv cfn wcel vy
      cv vx cv wss vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa
      c0 vy cv cint wceq wn wi vy cv c0 wceq wn vy cv c0 wne vy cv cfn wcel vy
      cv vx cv wss vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa
      c0 vy cv cint wceq wn wi wi wi vy cv c0 df-ne vx cv cfil wcel cA cX cpw
      wss cX cvv wcel cA c0 wne w3a wa vy cv cfn wcel vy cv vx cv wss vy cv c0
      wne c0 vy cv cint wceq wn vx cv cfil wcel vy cv cfn wcel vy cv vx cv wss
      vy cv c0 wne c0 vy cv cint wceq wn wi wi wi cA cX cpw wss cX cvv wcel cA
      c0 wne w3a vx cv cfil wcel vy cv vx cv wss vy cv c0 wne vy cv cfn wcel
      w3a vy cv cint c0 wne wi vy cv cfn wcel vy cv vx cv wss vy cv c0 wne c0
      vy cv cint wceq wn wi wi wi vy cv vx cv fipfil2 vy cv vx cv wss vy cv c0
      wne vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint c0 wne wi
      vy cv cfn wcel c0 vy cv cint wceq wn vy cv vx cv wss vy cv c0 wne vy cv
      cfn wcel vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint c0
      wne wi c0 vy cv cint wceq wn vy cv vx cv wss vy cv c0 wne vy cv cfn wcel
      vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint c0 wne wi c0
      vy cv cint wceq wn wi vy cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy
      cv vx cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint c0 wne wi vy cv
      cint c0 wne c0 vy cv cint wceq wn vy cv vx cv wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint c0 wne pm2.27 vy cv cint c0 wne c0 vy cv cint wne c0
      vy cv cint wceq wn c0 vy cv cint necom c0 vy cv cint wne c0 vy cv cint
      wceq wn c0 vy cv cint df-ne biimpi sylbir syl6 3exp com34 com4t syl
      adantr com14 sylbir com13 syl ex com23 imp com14 ex com23 imp31 vy cv c0
      wceq c0 vy cv cint wceq wn vy cv cA wss vy cv cfn wcel wa vy cv c0 wceq
      c0 vy cv cint wne c0 vy cv cint wceq wn vy cv c0 wceq vy cv cint c0 vy cv
      cint c0 wne c0 vy cv c0 vy cv wceq c0 cint vy cv cint wceq vy cv cint c0
      wne c0 vy cv inteq c0 cint vy cv cint wceq cvv vy cv cint wceq vy cv cint
      c0 wne c0 cint cvv vy cv cint int0 eqeq1i cvv vy cv cint wceq cvv c0 wne
      vy cv cint c0 wne vn0 cvv vy cv cint c0 neeq1 mpbii sylbi syl eqcoms
      necomd c0 vy cv cint df-ne sylib a1d pm2.61d2 imp vx cv cfil wcel cA vx
      cv wss wa cA cX cpw wss cX cvv wcel cA c0 wne w3a wa vy cv cA wss vy cv
      cfn wcel wa c0 vy cv cint wceq nan mpbir vy cv cA wss vy cv cfn wcel c0
      vy cv cint wceq w3a vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wa
      vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq df-3an notbii sylibr nexdv
      c0 cB wcel vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex vy
      cv cA wss vy cv cfn wcel vz cv vy cv cint wceq w3a vy wex vy cv cA wss vy
      cv cfn wcel c0 vy cv cint wceq w3a vy wex vz c0 cB 0ex vz cv c0 wceq vy
      cv cA wss vy cv cfn wcel vz cv vy cv cint wceq w3a vy cv cA wss vy cv cfn
      wcel c0 vy cv cint wceq w3a vy vz cv c0 wceq vz cv vy cv cint wceq c0 vy
      cv cint wceq vy cv cA wss vy cv cfn wcel vz cv c0 vy cv cint eqeq1
      3anbi3d exbidv efilcp.1 elab2 notbii sylibr exp31 r19.23aiv com12 impbid
      $.
      $( [2-Sep-2008] $) $( [20-Nov-2007] $)
  $}

  ${ $d A y $.  $d F x y $.
    $( A filter is closed under taking finite intersections. $)
    filint2 $p |- ( F e. Fil -> ( ( A C_ F /\ A =/= (/) /\ A e. Fin )
           -> |^| A e. F ) ) $=
      cF cfil wcel cA cF wss cA c0 wne cA cfn wcel cA cint cF wcel cF cfil wcel
      cA cF wss cA c0 wne cA cfn wcel cA cint cF wcel wi wi wi cA cF wss cF
      cfil wcel cF cfil wcel cA c0 wne cA cfn wcel cA cint cF wcel wi wi cA cF
      wss cF cfil wcel cF cfil wcel cA c0 wne cA cfn wcel cA cint cF wcel wi wi
      wi wi cF cfil wcel cA cF wss cA cF wss cF cfil wcel cA c0 wne cA cfn wcel
      cA cint cF wcel wi wi cF cfil wcel cA cF wss cA cF cpw wcel cA cF wss cF
      cfil wcel cA c0 wne cA cfn wcel cA cint cF wcel wi wi wi wi cA cF cfil
      elpw2g vy cv cF wss cF cfil wcel vy cv c0 wne vy cv cfn wcel vy cv cint
      cF wcel wi wi wi wi cA cF wss cF cfil wcel cA c0 wne cA cfn wcel cA cint
      cF wcel wi wi wi wi vy cA cF cpw vy cv cA wceq vy cv cF wss cA cF wss cF
      cfil wcel vy cv c0 wne vy cv cfn wcel vy cv cint cF wcel wi wi wi cF cfil
      wcel cA c0 wne cA cfn wcel cA cint cF wcel wi wi wi vy cv cA cF sseq1 vy
      cv cA wceq vy cv c0 wne vy cv cfn wcel vy cv cint cF wcel wi wi cA c0 wne
      cA cfn wcel cA cint cF wcel wi wi cF cfil wcel vy cv cA wceq vy cv c0 wne
      cA c0 wne vy cv cfn wcel vy cv cint cF wcel wi cA cfn wcel cA cint cF
      wcel wi vy cv cA c0 neeq1 vy cv cA wceq vy cv cfn wcel cA cfn wcel vy cv
      cint cF wcel cA cint cF wcel vy cv cA cfn eleq1 vy cv cA wceq vy cv cint
      cA cint cF vy cv cA inteq eleq1d imbi12d imbi12d imbi2d imbi12d cF cfil
      wcel vy cv cF wss vy cv c0 wne vy cv cfn wcel vy cv cint cF wcel wi wi cF
      cfil wcel vy cv cF wss vy cv c0 wne vy cv cfn wcel vy cv cint cF wcel cF
      cfil wcel vy cv cF wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint cF wcel
      wi cF cfil wcel cF cfil wcel c0 cF wcel wn cF cuni cF wcel wa vy cv cF
      wcel vx cv cF cuni wss vy cv vx cv wss w3a vx cv cF wcel wi vx wal vy wal
      vy cv vx cv cin cF wcel vx cF wral vy cF wral w3a vy cv cF wss vy cv c0
      wne vy cv cfn wcel w3a vy cv cint cF wcel wi vy vx cfil cF cF cuni cF
      cuni eqid isfil c0 cF wcel wn cF cuni cF wcel wa vy cv cF wcel vx cv cF
      cuni wss vy cv vx cv wss w3a vx cv cF wcel wi vx wal vy wal vy cv vx cv
      cin cF wcel vx cF wral vy cF wral w3a vy cv cF wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint cF wcel wi vy c0 cF wcel wn cF cuni cF wcel wa vy cv
      cF wcel vx cv cF cuni wss vy cv vx cv wss w3a vx cv cF wcel wi vx wal vy
      wal vy cv vx cv cin cF wcel vx cF wral vy cF wral w3a vy cv vx cv cin cF
      wcel vx cF wral vy cF wral vy cv cF wss vy cv c0 wne vy cv cfn wcel w3a
      vy cv cint cF wcel wi vy wal c0 cF wcel wn cF cuni cF wcel wa vy cv cF
      wcel vx cv cF cuni wss vy cv vx cv wss w3a vx cv cF wcel wi vx wal vy wal
      vy cv vx cv cin cF wcel vx cF wral vy cF wral 3simp3 vy vx cF fiint sylib
      19.21bi syl6bi pm2.43i 3expd com12 vtoclg syl6bir com4l pm2.43i com13
      pm2.43i 3impd $.
      $( [2-Sep-2008] $) $( [27-Apr-2008] $)
  $}


  ${ $d A y z $.  $d B y $.  $d C y z $.
    fisub.1 $e |- B = { z | E. y ( y C_ A /\ y e. Fin /\ z = |^| y ) } $.
    fisub.2 $e |- D = { z | E. y ( y C_ C /\ y e. Fin /\ z = |^| y ) } $.
    $( If a set has the finite intersection property, its subsets have also
       this property. $)
    fisub $p |- ( C C_ A -> ( -. (/) e. B -> -. (/) e. D ) ) $=
      cC cA wss c0 cD wcel c0 cB wcel cC cA wss vy cv cC wss vy cv cfn wcel c0
      vy cv cint wceq w3a vy wex c0 cB wcel c0 cD wcel vy cv cC wss vy cv cfn
      wcel c0 vy cv cint wceq w3a vy wex cC cA wss c0 cB wcel vy cv cC wss vy
      cv cfn wcel c0 vy cv cint wceq w3a cC cA wss c0 cB wcel wi vy vy cv cC
      wss vy cv cfn wcel c0 vy cv cint wceq cC cA wss c0 cB wcel wi cC cA wss
      vy cv cC wss vy cv cfn wcel c0 vy cv cint wceq c0 cB wcel vy cv cC wss cC
      cA wss vy cv cfn wcel c0 vy cv cint wceq c0 cB wcel wi wi vy cv cC wss cC
      cA wss wa vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq c0 cB wcel wi wi
      vy cv cC cA sstr vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq c0 cB
      wcel vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a c0 cB wcel vy c0
      cB wcel vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex vy cv
      cA wss vy cv cfn wcel vz cv vy cv cint wceq w3a vy wex vy cv cA wss vy cv
      cfn wcel c0 vy cv cint wceq w3a vy wex vz c0 cB 0ex vz cv c0 wceq vy cv
      cA wss vy cv cfn wcel vz cv vy cv cint wceq w3a vy cv cA wss vy cv cfn
      wcel c0 vy cv cint wceq w3a vy vz cv c0 wceq vz cv vy cv cint wceq c0 vy
      cv cint wceq vy cv cA wss vy cv cfn wcel vz cv c0 vy cv cint eqeq1
      3anbi3d exbidv fisub.1 elab2 biimpri 19.23bi 3exp syl expcom com4l 3imp
      19.23aiv com12 vy cv cC wss vy cv cfn wcel vz cv vy cv cint wceq w3a vy
      wex vy cv cC wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex vz c0 cD
      0ex vz cv c0 wceq vy cv cC wss vy cv cfn wcel vz cv vy cv cint wceq w3a
      vy cv cC wss vy cv cfn wcel c0 vy cv cint wceq w3a vy vz cv c0 wceq vz cv
      vy cv cint wceq c0 vy cv cint wceq vy cv cC wss vy cv cfn wcel vz cv c0
      vy cv cint eqeq1 3anbi3d exbidv fisub.2 elab2 syl5ib con3d $.
      $( [2-Sep-2008] $) $( [27-Apr-2008] $)
  $}

  ${ $d A a b u v y $.  $d A t x y $.  $d A x y z $.  $d X a b x y $.
     $d X t x y $.  $d X x y z $.  $d w x y $.
    $( Filter generated by a subbasis ` A ` .  Bourbaki TG I.37 paragraph
       above prop. 1.  (The theorem has been slightly modified because
       the definitions of the empty set are different in Bourbaki and
       Metamath.) $)
    fgsb2 $p |- ( ( A C_ ~P X /\ X e. _V /\ A =/= (/) ) ->
      ( -. (/) e. ( fi ` A ) ->
         { x e. ~P X | E. y e. ( fi ` A ) y C_ x } e. Fil ) ) $=
      cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel wn vy cv vx cv
      wss vy cA cfi cfv wrex vx cX cpw crab cfil wcel cA cX cpw wss cX cvv wcel
      cA c0 wne w3a c0 cA cfi cfv wcel wn wa vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab cfil wcel c0 vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel wn vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel wa va cv vy cv vx cv wss
      vy cA cfi cfv wrex vx cX cpw crab wcel vb cv vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab cuni wss va cv vb cv wss w3a vb cv vy cv vx cv
      wss vy cA cfi cfv wrex vx cX cpw crab wcel wi vb wal va wal va cv vb cv
      cin vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel vb vy cv vx cv
      wss vy cA cfi cfv wrex vx cX cpw crab wral va vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab wral w3a cA cX cpw wss cX cvv wcel cA c0 wne w3a
      c0 cA cfi cfv wcel wn wa c0 vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel wn vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel wa va cv vy cv vx cv wss
      vy cA cfi cfv wrex vx cX cpw crab wcel vb cv vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab cuni wss va cv vb cv wss w3a vb cv vy cv vx cv
      wss vy cA cfi cfv wrex vx cX cpw crab wcel wi vb wal va wal va cv vb cv
      cin vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel vb vy cv vx cv
      wss vy cA cfi cfv wrex vx cX cpw crab wral va vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab wral cA cX cpw wss cX cvv wcel cA c0 wne w3a c0
      cA cfi cfv wcel wn wa c0 vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel wn vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel c0 cA cfi cfv wcel wn c0
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel wn cA cX cpw wss
      cX cvv wcel cA c0 wne w3a c0 vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel c0 cA cfi cfv wcel c0 vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab wcel c0 cX cpw wcel vy cv c0 wss vy cA cfi cfv wrex wa c0 cA cfi
      cfv wcel vy cv vx cv wss vy cA cfi cfv wrex vy cv c0 wss vy cA cfi cfv
      wrex vx c0 cX cpw vx cv c0 wceq vy cv vx cv wss vy cv c0 wss vy cA cfi
      cfv vx cv c0 vy cv sseq2 rexbidv elrab vy cv c0 wss vy cA cfi cfv wrex c0
      cA cfi cfv wcel c0 cX cpw wcel vy cv c0 wss c0 cA cfi cfv wcel vy cA cfi
      cfv vy cv c0 wss vy cv cA cfi cfv wcel c0 cA cfi cfv wcel vy cv c0 wss vy
      cv c0 cA cfi cfv vy cv ss0 eleq1d biimpcd r19.23aiv adantl sylbi con3i
      adantl cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel wn wa
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni cX cpw wcel vy cv
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss vy cA cfi cfv
      wrex wa vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni vy cv vx
      cv wss vy cA cfi cfv wrex vx cX cpw crab wcel cA cX cpw wss cX cvv wcel
      cA c0 wne w3a vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni cX
      cpw wcel vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss
      vy cA cfi cfv wrex wa c0 cA cfi cfv wcel wn cA cX cpw wss cX cvv wcel cA
      c0 wne w3a vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni cX cpw
      wcel vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss vy
      cA cfi cfv wrex cX cvv wcel cA cX cpw wss vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab cuni cX cpw wcel cA c0 wne vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cvv ump 3ad2ant2 cA cfi cfv c0 wne vy cv vy cv vx cv wss
      vy cA cfi cfv wrex vx cX cpw crab cuni wss vy cA cfi cfv wral vy cv vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss vy cA cfi cfv wrex
      cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab cuni wss vy cA cfi cfv r19.2z cA cvv wcel cA c0
      wne cA cfi cfv c0 wne cA cX cpw wss cX cvv wcel cA c0 wne w3a cA cvv
      fine2 cA cX cpw wss cX cpw cvv wcel cA cvv wcel cA cX cpw wss cX cvv wcel
      cA c0 wne w3a cA cX cpw cvv ssexg cA cX cpw wss cX cvv wcel cA c0 wne
      3simp1 cX cvv wcel cA cX cpw wss cX cpw cvv wcel cA c0 wne cX cvv pwexg
      3ad2ant2 sylanc cA cX cpw wss cX cvv wcel cA c0 wne 3simp3 sylc cA cX cpw
      wss cX cvv wcel cA c0 wne w3a vy cv vy cv vx cv wss vy cA cfi cfv wrex vx
      cX cpw crab cuni wss vy cA cfi cfv cA cX cpw wss cX cvv wcel cA c0 wne
      w3a vy cv cA cfi cfv wcel wa vy cv vy cv wss vy cv vy cv vx cv wss vy cA
      cfi cfv wrex vx cX cpw crab wcel wa vy cv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab cuni wss cA cX cpw wss cX cvv wcel cA c0 wne w3a vy
      cv cA cfi cfv wcel wa vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel vy cv vy cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv
      cA cfi cfv wcel wa vy cv cX cpw wcel vz cv vy cv wss vz cA cfi cfv wrex
      wa vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel cA cX cpw
      wss cX cvv wcel cA c0 wne w3a vy cv cA cfi cfv wcel wa vy cv cX cpw wcel
      vz cv vy cv wss vz cA cfi cfv wrex cA cX cpw wss cX cvv wcel cA c0 wne
      w3a vy cv cA cfi cfv wcel wa vy cv cX wss vy cv cX cpw wcel cA cX cpw wss
      cX cvv wcel cA c0 wne w3a vy cv cA cfi cfv wcel wa vy cv cA cuni cX cA cX
      cpw wss cX cvv wcel cA c0 wne w3a vy cv cA cfi cfv wcel vy cv cA cuni wss
      cA cX cpw wss cX cpw cvv wcel vy cv cA cfi cfv wcel vy cv cA cuni wss wi
      cA cX cpw wss cX cvv wcel cA c0 wne w3a cA cX cpw wss cX cpw cvv wcel wa
      cA cvv wcel vy cv cA cfi cfv wcel vy cv cA cuni wss wi cA cX cpw cvv
      ssexg vy cv cA cvv fiiu2 syl cA cX cpw wss cX cvv wcel cA c0 wne 3simp1
      cX cvv wcel cA cX cpw wss cX cpw cvv wcel cA c0 wne cX cvv pwexg 3ad2ant2
      sylanc imp cA cX cpw wss cX cvv wcel cA c0 wne w3a cA cuni cX wss vy cv
      cA cfi cfv wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a cA cX cpw wss cA
      cuni cX wss cA cX cpw wss cX cvv wcel cA c0 wne 3simp1 cA cX sspwuni
      sylib adantr sstrd vy cv cX vy visset elpw sylibr cA cX cpw wss cX cvv
      wcel cA c0 wne w3a vy cv cA cfi cfv wcel wa vy cv cA cfi cfv wcel vy cv
      vy cv wss wa vz cv vy cv wss vz cA cfi cfv wrex cA cX cpw wss cX cvv wcel
      cA c0 wne w3a vy cv cA cfi cfv wcel wa vy cv cA cfi cfv wcel vy cv vy cv
      wss cA cX cpw wss cX cvv wcel cA c0 wne w3a vy cv cA cfi cfv wcel pm3.27
      vy cv ssid jctir vz cv vy cv wss vy cv vy cv wss vz vy cv cA cfi cfv vz
      cv vy cv vy cv sseq1 rcla4ev syl jca vy cv vx cv wss vy cA cfi cfv wrex
      vz cv vy cv wss vz cA cfi cfv wrex vx vy cv cX cpw vx cv vy cv wceq vz cv
      vx cv wss vz cA cfi cfv wrex vz cv vy cv wss vz cA cfi cfv wrex vy cv vx
      cv wss vy cA cfi cfv wrex vx cv vy cv wceq vz cv vx cv wss vz cv vy cv
      wss vz cA cfi cfv vx cv vy cv vz cv sseq2 rexbidv vy cv vx cv wss vz cv
      vx cv wss vy vz cA cfi cfv vy cv vz cv vx cv sseq1 cbvrexv syl5bb elrab
      sylibr vy cv ssid jctil vy cv vy cv vy cv vx cv wss vy cA cfi cfv wrex vx
      cX cpw crab ssuni syl r19.21aiva sylanc jca adantr vy cv vx cv wss vy cA
      cfi cfv wrex vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni
      wss vy cA cfi cfv wrex vx vz vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cuni cX cpw vx vz vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab
      vy cv vx cv wss vy cA cfi cfv wrex vx vz cX cpw hbrab1 hbuni vx vz cX vz
      cv cX wcel vx ax-17 hbpw vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab cuni wss vx vy cA cfi cfv vy cv cA cfi cfv wcel vx ax-17 vx vz
      vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni vz cv vy cv
      wcel vx ax-17 vx vz vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab vy
      cv vx cv wss vy cA cfi cfv wrex vx vz cX cpw hbrab1 hbuni hbss hbrex vx
      cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wceq vy cv vx
      cv wss vy cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss
      vy cA cfi cfv vy vw vz vx cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cuni vw cv vx cv wcel vy ax-17 vy vz vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab vy cv vx cv wss vy cA cfi cfv wrex vy vx vz cX cpw vy
      cv vx cv wss vy cA cfi cfv hbre1 vz cv cX cpw wcel vy ax-17 hbrab hbuni
      hbeq vx cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni vy cv
      sseq2 rexbid elrabf sylibr jca va cv vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab wcel vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cuni wss va cv vb cv wss w3a vb cv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab wcel wi vb wal va wal cA cX cpw wss cX cvv wcel cA c0
      wne w3a c0 cA cfi cfv wcel wn wa va cv vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab wcel vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cuni wss va cv vb cv wss w3a vb cv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab wcel wi va vb va cv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab wcel vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab cuni wss va cv vb cv wss w3a vb cv cX cpw wcel vy cv vb cv wss
      vy cA cfi cfv wrex wa vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel va cv cX cpw wcel vy cv va cv wss vy cA cfi cfv wrex wa vb cv
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss va cv vb cv
      wss vb cv cX cpw wcel vy cv vb cv wss vy cA cfi cfv wrex wa va cv vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel va cv cX cpw wcel vy cv
      va cv wss vy cA cfi cfv wrex wa vb cv vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab cuni wss va cv vb cv wss w3a vb cv cX cpw wcel vy cv vb cv
      wss vy cA cfi cfv wrex vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cuni wss va cv cX cpw wcel vy cv va cv wss vy cA cfi cfv wrex wa vb
      cv cX cpw wcel va cv vb cv wss vb cv vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab cuni wss vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab cuni cpw wcel vb cv cX cpw wcel vb cv vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab cuni vb visset elpw vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab cuni cpw cX cpw vb cv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab cuni cX wss vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab cuni cpw cX cpw wss vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cuni cX wss vt cv cX wss vt vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab vt vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cX unissb
      vt cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel vt cv cX cpw
      wcel vy cv vt cv wss vy cA cfi cfv wrex wa vt cv cX wss vy cv vx cv wss
      vy cA cfi cfv wrex vy cv vt cv wss vy cA cfi cfv wrex vx vt cv cX cpw vx
      cv vt cv wceq vy cv vx cv wss vy cv vt cv wss vy cA cfi cfv vx cv vt cv
      vy cv sseq2 rexbidv elrab vt cv cX cpw wcel vt cv cX wss vy cv vt cv wss
      vy cA cfi cfv wrex vt cv cX elpwi adantr sylbi mprgbir vy cv vx cv wss vy
      cA cfi cfv wrex vx cX cpw crab cuni cX sspwb mpbi sseli sylbir 3ad2ant2
      va cv cX cpw wcel vy cv va cv wss vy cA cfi cfv wrex wa va cv vb cv wss
      vy cv vb cv wss vy cA cfi cfv wrex vb cv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab cuni wss vy cv va cv wss vy cA cfi cfv wrex va cv vb
      cv wss vy cv vb cv wss vy cA cfi cfv wrex va cv cX cpw wcel vy cv va cv
      wss vy cA cfi cfv wrex va cv vb cv wss wa vy cv va cv wss va cv vb cv wss
      wa vy cA cfi cfv wrex vy cv vb cv wss vy cA cfi cfv wrex vy cv va cv wss
      va cv vb cv wss vy cA cfi cfv r19.41v vy cv va cv wss va cv vb cv wss wa
      vy cv vb cv wss vy cA cfi cfv vy cv va cv vb cv sstr r19.22si sylbir
      adantll 3adant2 jca vy cv vx cv wss vy cA cfi cfv wrex vy cv va cv wss vy
      cA cfi cfv wrex vx va cv cX cpw vx cv va cv wceq vy cv vx cv wss vy cv va
      cv wss vy cA cfi cfv vx cv va cv vy cv sseq2 rexbidv elrab syl3an1b vy cv
      vx cv wss vy cA cfi cfv wrex vy cv vb cv wss vy cA cfi cfv wrex vx vb cv
      cX cpw vx cv vb cv wceq vy cv vx cv wss vy cv vb cv wss vy cA cfi cfv vx
      cv vb cv vy cv sseq2 rexbidv elrab sylibr gen2 a1i va cv vb cv cin vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel vb vy cv vx cv wss vy cA
      cfi cfv wrex vx cX cpw crab wral va vy cv vx cv wss vy cA cfi cfv wrex vx
      cX cpw crab wral cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv
      wcel wn wa va cv vb cv cin vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab wcel va vb vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab vy cv
      vx cv wss vy cA cfi cfv wrex vx cX cpw crab va cv cX cpw wcel vy cv va cv
      wss vy cA cfi cfv wrex wa vb cv cX cpw wcel vy cv vb cv wss vy cA cfi cfv
      wrex wa va cv vb cv cin vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab
      wcel va cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel vb cv
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wcel va cv cX cpw wcel
      vy cv va cv wss vy cA cfi cfv wrex wa vb cv cX cpw wcel vy cv vb cv wss
      vy cA cfi cfv wrex wa wa va cv vb cv cin cX cpw wcel vy cv va cv vb cv
      cin wss vy cA cfi cfv wrex wa va cv vb cv cin vy cv vx cv wss vy cA cfi
      cfv wrex vx cX cpw crab wcel va cv cX cpw wcel vb cv cX cpw wcel vy cv va
      cv wss vy cA cfi cfv wrex vy cv vb cv wss vy cA cfi cfv wrex va cv vb cv
      cin cX cpw wcel vy cv va cv vb cv cin wss vy cA cfi cfv wrex wa va cv cX
      cpw wcel vb cv cX cpw wcel wa va cv vb cv cin cX cpw wcel vy cv va cv wss
      vy cA cfi cfv wrex vy cv vb cv wss vy cA cfi cfv wrex wa vy cv va cv vb
      cv cin wss vy cA cfi cfv wrex va cv cX cpw wcel va cv vb cv cin cX cpw
      wcel vb cv cX cpw wcel va cv vb cv cX inpws1 adantr vu cv va cv wss vu cA
      cfi cfv wrex vv cv vb cv wss vv cA cfi cfv wrex vy cv va cv vb cv cin wss
      vy cA cfi cfv wrex vy cv va cv wss vy cA cfi cfv wrex vy cv vb cv wss vy
      cA cfi cfv wrex vu cv va cv wss vu cA cfi cfv wrex vv cv vb cv wss vv cA
      cfi cfv wrex vy cv va cv vb cv cin wss vy cA cfi cfv wrex vu cv va cv wss
      vv cv vb cv wss vv cA cfi cfv wrex vy cv va cv vb cv cin wss vy cA cfi
      cfv wrex wi vu cA cfi cfv vv cv vb cv wss vv cA cfi cfv wrex vu cv cA cfi
      cfv wcel vu cv va cv wss wa vy cv va cv vb cv cin wss vy cA cfi cfv wrex
      vv cv vb cv wss vu cv cA cfi cfv wcel vu cv va cv wss wa vy cv va cv vb
      cv cin wss vy cA cfi cfv wrex wi vv cA cfi cfv vu cv cA cfi cfv wcel vu
      cv va cv wss wa vv cv cA cfi cfv wcel vv cv vb cv wss wa vy cv va cv vb
      cv cin wss vy cA cfi cfv wrex vu cv cA cfi cfv wcel vv cv cA cfi cfv wcel
      vu cv va cv wss vv cv vb cv wss vy cv va cv vb cv cin wss vy cA cfi cfv
      wrex vu cv vv cv cin cA cfi cfv wcel vu cv vv cv cin va cv vb cv cin wss
      vy cv va cv vb cv cin wss vy cA cfi cfv wrex vu cv cA cfi cfv wcel vv cv
      cA cfi cfv wcel wa vu cv va cv wss vv cv vb cv wss wa vy cv va cv vb cv
      cin wss vu cv vv cv cin va cv vb cv cin wss vy vu cv vv cv cin cA cfi cfv
      vu cv vv cv cin va cv vb cv cin wss vy ax-17 vy cv vu cv vv cv cin va cv
      vb cv cin sseq1 rcla4e vu cv cA cfi cfv wcel vv cv cA cfi cfv wcel vu cv
      vv cv cin cA cfi cfv wcel cA cfi cdm wcel vu cv cA cfi cfv wcel vv cv cA
      cfi cfv wcel vu cv vv cv cin cA cfi cfv wcel wi vu cv cA cfi elfvdm cA
      cfi cdm wcel vu cv cA cfi cfv wcel vv cv cA cfi cfv wcel vu cv vv cv cin
      cA cfi cfv wcel vu cv vv cv cA cfi cdm infi exp3a mpcom imp vu cv va cv
      vv cv vb cv ss2in syl2an an4s expcom r19.23aiva com12 r19.23aiva imp vy
      cv va cv wss vu cv va cv wss vy vu cA cfi cfv vy cv vu cv va cv sseq1
      cbvrexv vy cv vb cv wss vv cv vb cv wss vy vv cA cfi cfv vy cv vv cv vb
      cv sseq1 cbvrexv syl2anb anim12i an4s vy cv vx cv wss vy cA cfi cfv wrex
      vy cv va cv vb cv cin wss vy cA cfi cfv wrex vx va cv vb cv cin cX cpw vx
      cv va cv vb cv cin wceq vy cv vx cv wss vy cv va cv vb cv cin wss vy cA
      cfi cfv vx cv va cv vb cv cin wceq vy cv cA cfi cfv wcel wa vx cv va cv
      vb cv cin vy cv vx cv va cv vb cv cin wceq vy cv cA cfi cfv wcel pm3.26
      sseq2d rexbidva elrab sylibr vy cv vx cv wss vy cA cfi cfv wrex vy cv va
      cv wss vy cA cfi cfv wrex vx va cv cX cpw vx cv va cv wceq vy cv vx cv
      wss vy cv va cv wss vy cA cfi cfv vx cv va cv wceq vy cv cA cfi cfv wcel
      wa vx cv va cv vy cv vx cv va cv wceq vy cv cA cfi cfv wcel pm3.26 sseq2d
      rexbidva elrab vy cv vx cv wss vy cA cfi cfv wrex vy cv vb cv wss vy cA
      cfi cfv wrex vx vb cv cX cpw vx cv vb cv wceq vy cv vx cv wss vy cv vb cv
      wss vy cA cfi cfv vx cv vb cv wceq vy cv cA cfi cfv wcel wa vx cv vb cv
      vy cv vx cv vb cv wceq vy cv cA cfi cfv wcel pm3.26 sseq2d rexbidva elrab
      syl2anb rgen2 a1i 3jca cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi
      cfv wcel wn wa vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cvv wcel
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cfil wcel c0 vy cv vx
      cv wss vy cA cfi cfv wrex vx cX cpw crab wcel wn vy cv vx cv wss vy cA
      cfi cfv wrex vx cX cpw crab cuni vy cv vx cv wss vy cA cfi cfv wrex vx cX
      cpw crab wcel wa va cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab
      wcel vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni wss va
      cv vb cv wss w3a vb cv vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab
      wcel wi vb wal va wal va cv vb cv cin vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab wcel vb vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab
      wral va vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab wral w3a wb cA
      cX cpw wss cX cvv wcel cA c0 wne w3a vy cv vx cv wss vy cA cfi cfv wrex
      vx cX cpw crab cvv wcel c0 cA cfi cfv wcel wn cX cvv wcel cA cX cpw wss
      vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cvv wcel cA c0 wne cX
      cvv wcel cX cpw cvv wcel vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      crab cvv wcel cX cvv pwexg vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw
      cvv rabexg syl 3ad2ant2 adantr va vb cvv vy cv vx cv wss vy cA cfi cfv
      wrex vx cX cpw crab vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab
      cuni vy cv vx cv wss vy cA cfi cfv wrex vx cX cpw crab cuni eqid isfil
      syl mpbird ex $.
      $( [27-Apr-2008] $) $( [27-Apr-2008] $)
  $}

  ${
    $d A x y z $.  $d X x y z $.
    $( A filter containing a set ` A ` exists iff ` A ` has the finite
       intersection property (i.e. no finite intersection of elements of ` A `
       is empty).  Bourbaki TG I.37 prop. 1. $)
    efilcp2  $p |- ( ( A C_ ~P X /\ X e. _V /\ A =/= (/) ) ->
        ( -. (/) e. ( fi ` A )  <-> E. x e. Fil A C_ x ) ) $=
      cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel wn cA vx cv
      wss vx cfil wrex cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv
      wcel wn cA vx cv wss vx cfil wrex vy cv vz cv wss vy cA cfi cfv wrex vz
      cX cpw crab cfil wcel cA vy cv vz cv wss vy cA cfi cfv wrex vz cX cpw
      crab wss cA vx cv wss vx cfil wrex cA cX cpw wss cX cvv wcel cA c0 wne
      w3a c0 cA cfi cfv wcel wn wa cA vx cv wss cA vy cv vz cv wss vy cA cfi
      cfv wrex vz cX cpw crab wss vx vy cv vz cv wss vy cA cfi cfv wrex vz cX
      cpw crab cfil vx cv vy cv vz cv wss vy cA cfi cfv wrex vz cX cpw crab cA
      sseq2 rcla4ev cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel
      wn vy cv vz cv wss vy cA cfi cfv wrex vz cX cpw crab cfil wcel vz vy cA
      cX fgsb2 imp cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel
      wn wa cA cX cpw wss vy cv vz cv wss vy cA cfi cfv wrex vz cA wral wa cA
      vy cv vz cv wss vy cA cfi cfv wrex vz cX cpw crab wss cA cX cpw wss cX
      cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel wn wa cA cX cpw wss vy cv vz cv
      wss vy cA cfi cfv wrex vz cA wral cA cX cpw wss cX cvv wcel cA c0 wne w3a
      cA cX cpw wss c0 cA cfi cfv wcel wn cA cX cpw wss cX cvv wcel cA c0 wne
      3simp1 adantr cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel
      wn wa cA cvv wcel vy cv vz cv wss vy cA cfi cfv wrex vz cA wral cA cX cpw
      wss cX cvv wcel cA c0 wne w3a cA cvv wcel c0 cA cfi cfv wcel wn cA cX cpw
      wss cX cvv wcel cA c0 wne cA cvv wcel cX cvv wcel cA cX cpw wss cA cX cpw
      cpw wcel cA c0 wne cA cvv wcel wi cX cvv wcel cA cX cpw cpw wcel cA cX
      cpw wss cX cvv wcel cX cpw cvv wcel cA cX cpw cpw wcel cA cX cpw wss wb
      cX cvv pwexg cA cX cpw cvv elpw2g syl biimprd cA cX cpw cpw wcel cA cvv
      wcel cA c0 wne cA cX cpw cpw elisset a1d syl6com 3imp adantr cA cvv wcel
      cA cA cfi cfv wss vy cv vz cv wss vy cA cfi cfv wrex vz cA wral cA cvv
      abfi2 cA cA cfi cfv wss vy cv vz cv wss vy cA cfi cfv wrex vz cA cA cA
      cfi cfv wss vz cv cA wcel wa vz cv cA cfi cfv wcel vy cv vz cv wss vy cA
      cfi cfv wrex cA cA cfi cfv vz cv ssel2 vz cv cA cfi cfv wcel vz cv vz cv
      wss vy cv vz cv wss vy cA cfi cfv wrex vz cv ssid vy cv vz cv wss vz cv
      vz cv wss vy vz cv cA cfi cfv vy cv vz cv vz cv sseq1 rcla4ev mpan2 syl
      r19.21aiva syl syl jca vy cv vz cv wss vy cA cfi cfv wrex vz cX cpw cA
      ssrab sylibr sylanc ex cA vx cv wss vx cfil wrex cA cX cpw wss cX cvv
      wcel cA c0 wne w3a c0 cA cfi cfv wcel wn cA vx cv wss cA cX cpw wss cX
      cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel wn wi vx cfil cA cX cpw wss cX
      cvv wcel cA c0 wne w3a cA vx cv wss vx cv cfil wcel c0 cA cfi cfv wcel wn
      cA cvv wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a cA vx cv wss vx cv
      cfil wcel c0 cA cfi cfv wcel wn wi wi cA cX cpw wss cX cvv wcel cA c0 wne
      cA cvv wcel cX cvv wcel cA cX cpw wss cA cX cpw cpw wcel cA c0 wne cA cvv
      wcel wi cX cvv wcel cA cX cpw cpw wcel cA cX cpw wss cX cvv wcel cX cpw
      cvv wcel cA cX cpw cpw wcel cA cX cpw wss wb cX cvv pwexg cA cX cpw cvv
      elpw2g syl biimprd cA cX cpw cpw wcel cA cvv wcel cA c0 wne cA cX cpw cpw
      elisset a1d syl6com 3imp cA cvv wcel vx cv cfil wcel cA vx cv wss cA cX
      cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi cfv wcel wn cA cvv wcel vx cv
      cfil wcel cA vx cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a c0 cA cfi
      cfv wcel wn cA cvv wcel c0 cA cfi cfv wcel wn vy cv cA wss vy cv cfn wcel
      c0 vy cv cint wceq w3a vy wex wn vx cv cfil wcel cA vx cv wss cA cX cpw
      wss cX cvv wcel cA c0 wne w3a w3a cA cvv wcel c0 cA cfi cfv wcel vy cv cA
      wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex c0 cvv wcel cA cvv wcel
      c0 cA cfi cfv wcel vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a vy
      wex wb 0ex vy c0 cvv cA cvv sppfi mpan notbid vx cv cfil wcel cA vx cv
      wss cA cX cpw wss cX cvv wcel cA c0 wne w3a w3a vy cv cA wss vy cv cfn
      wcel c0 vy cv cint wceq w3a vy vx cv cfil wcel cA vx cv wss cA cX cpw wss
      cX cvv wcel cA c0 wne w3a w3a vy cv cA wss vy cv cfn wcel wa c0 vy cv
      cint wceq wa wn vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a wn vx
      cv cfil wcel cA vx cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a w3a vy
      cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq wa wn wi vx cv cfil wcel
      cA vx cv wss cA cX cpw wss cX cvv wcel cA c0 wne w3a w3a vy cv cA wss vy
      cv cfn wcel wa wa c0 vy cv cint wceq wn wi vx cv cfil wcel cA vx cv wss
      cA cX cpw wss cX cvv wcel cA c0 wne w3a w3a vy cv cA wss vy cv cfn wcel
      wa c0 vy cv cint wceq wn vx cv cfil wcel cA vx cv wss cA cX cpw wss cX
      cvv wcel cA c0 wne w3a w3a vy cv c0 wceq vy cv cA wss vy cv cfn wcel wa
      c0 vy cv cint wceq wn wi vx cv cfil wcel cA vx cv wss cA cX cpw wss cX
      cvv wcel cA c0 wne w3a vy cv c0 wceq wn vy cv cA wss vy cv cfn wcel wa c0
      vy cv cint wceq wn wi wi vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0
      wne w3a cA vx cv wss vy cv c0 wceq wn vy cv cA wss vy cv cfn wcel wa c0
      vy cv cint wceq wn wi wi vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0
      wne w3a cA vx cv wss vy cv c0 wceq wn vy cv cA wss vy cv cfn wcel wa c0
      vy cv cint wceq wn wi wi wi vy cv cA wss vy cv cfn wcel wa cA vx cv wss
      vy cv c0 wceq wn vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a
      wa c0 vy cv cint wceq wn vy cv cA wss vy cv cfn wcel cA vx cv wss vy cv
      c0 wceq wn vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa c0
      vy cv cint wceq wn wi wi wi vy cv cA wss cA vx cv wss vy cv cfn wcel vy
      cv c0 wceq wn vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa
      c0 vy cv cint wceq wn wi wi vy cv cA wss cA vx cv wss vy cv cfn wcel vy
      cv c0 wceq wn vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa
      c0 vy cv cint wceq wn wi wi wi vy cv cA wss cA vx cv wss wa vy cv vx cv
      wss vy cv cfn wcel vy cv c0 wceq wn vx cv cfil wcel cA cX cpw wss cX cvv
      wcel cA c0 wne w3a wa c0 vy cv cint wceq wn wi wi wi vy cv cA vx cv sstr
      vy cv c0 wceq wn vy cv cfn wcel vy cv vx cv wss vx cv cfil wcel cA cX cpw
      wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint wceq wn wi vy cv c0 wceq
      wn vy cv c0 wne vy cv cfn wcel vy cv vx cv wss vx cv cfil wcel cA cX cpw
      wss cX cvv wcel cA c0 wne w3a wa c0 vy cv cint wceq wn wi wi wi vy cv c0
      df-ne vx cv cfil wcel cA cX cpw wss cX cvv wcel cA c0 wne w3a wa vy cv
      cfn wcel vy cv vx cv wss vy cv c0 wne c0 vy cv cint wceq wn vx cv cfil
      wcel vy cv cfn wcel vy cv vx cv wss vy cv c0 wne c0 vy cv cint wceq wn wi
      wi wi cA cX cpw wss cX cvv wcel cA c0 wne w3a vx cv cfil wcel vy cv vx cv
      wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint c0 wne wi vy cv cfn wcel
      vy cv vx cv wss vy cv c0 wne c0 vy cv cint wceq wn wi wi wi vy cv vx cv
      fipfil2 vy cv vx cv wss vy cv c0 wne vy cv vx cv wss vy cv c0 wne vy cv
      cfn wcel w3a vy cv cint c0 wne wi vy cv cfn wcel c0 vy cv cint wceq wn vy
      cv vx cv wss vy cv c0 wne vy cv cfn wcel vy cv vx cv wss vy cv c0 wne vy
      cv cfn wcel w3a vy cv cint c0 wne wi c0 vy cv cint wceq wn vy cv vx cv
      wss vy cv c0 wne vy cv cfn wcel vy cv vx cv wss vy cv c0 wne vy cv cfn
      wcel w3a vy cv cint c0 wne wi c0 vy cv cint wceq wn wi vy cv vx cv wss vy
      cv c0 wne vy cv cfn wcel w3a vy cv vx cv wss vy cv c0 wne vy cv cfn wcel
      w3a vy cv cint c0 wne wi vy cv cint c0 wne c0 vy cv cint wceq wn vy cv vx
      cv wss vy cv c0 wne vy cv cfn wcel w3a vy cv cint c0 wne pm2.27 vy cv
      cint c0 wne c0 vy cv cint wne c0 vy cv cint wceq wn c0 vy cv cint necom
      c0 vy cv cint wne c0 vy cv cint wceq wn c0 vy cv cint df-ne biimpi sylbir
      syl6 3exp com34 com4t syl adantr com14 sylbir com13 syl ex com23 imp
      com14 ex com23 3imp vy cv c0 wceq c0 vy cv cint wceq wn vy cv cA wss vy
      cv cfn wcel wa vy cv c0 wceq c0 vy cv cint wne c0 vy cv cint wceq wn vy
      cv c0 wceq vy cv cint c0 vy cv cint c0 wne c0 vy cv c0 vy cv wceq c0 cint
      vy cv cint wceq vy cv cint c0 wne c0 vy cv inteq c0 cint vy cv cint wceq
      cvv vy cv cint wceq vy cv cint c0 wne c0 cint cvv vy cv cint int0 eqeq1i
      cvv vy cv cint wceq cvv c0 wne vy cv cint c0 wne vn0 cvv vy cv cint c0
      neeq1 mpbii sylbi syl eqcoms necomd c0 vy cv cint df-ne sylib a1d
      pm2.61d2 imp vx cv cfil wcel cA vx cv wss cA cX cpw wss cX cvv wcel cA c0
      wne w3a w3a vy cv cA wss vy cv cfn wcel wa c0 vy cv cint wceq nan mpbir
      vy cv cA wss vy cv cfn wcel c0 vy cv cint wceq w3a vy cv cA wss vy cv cfn
      wcel wa c0 vy cv cint wceq wa vy cv cA wss vy cv cfn wcel c0 vy cv cint
      wceq df-3an notbii sylibr nexdv syl5bir 3expd com24 mpcom com13 r19.23aiv
      com12 impbid $.
      $( [2-Sep-2008] $) $( [27-Apr-2008] $)
  $}

  ${
    $d A g $.  $d A x y $.  $d F g $.  $d F x y $.
    $( Condition to have a filter finer than a given filter and containing a
       set ` A ` .  Bourbaki T.G. I.37 cor. 1 $)
    cnfilca  $p |- ( ( F e. Fil /\ A C_ U. F /\ A =/= (/) )
      -> ( E. g e. Fil ( A e. g /\  F C_ g )
         <-> A. x e. F ( x i^i A ) =/= (/) ) ) $=
      cF cfil wcel cA cF cuni wss cA c0 wne w3a cA vg cv wcel cF vg cv wss wa
      vg cfil wrex cA csn cF cun vg cv wss vg cfil wrex c0 cA csn cF cun cfi
      cfv wcel wn vx cv cA cin c0 wne vx cF wral cF cfil wcel cA cF cuni wss cA
      c0 wne w3a cA vg cv wcel cF vg cv wss wa cA csn cF cun vg cv wss vg cfil
      cF cfil wcel cA cF cuni wss cA c0 wne w3a cA cvv wcel cA vg cv wcel cF vg
      cv wss wa cA csn cF cun vg cv wss wb cF cfil wcel cA cF cuni wss cA cvv
      wcel cA c0 wne cA cF cuni wss cF cfil wcel cA cvv wcel cA cF cuni wss cF
      cuni cvv wcel cA cvv wcel cF cfil wcel cA cF cuni cvv ssexg cF cfil
      uniexg sylan2 ancoms 3adant3 cA cvv wcel cA vg cv wcel cF vg cv wss wa cA
      csn vg cv wss cF vg cv wss wa cA csn cF cun vg cv wss cA cvv wcel cA vg
      cv wcel cA csn vg cv wss cF vg cv wss cA vg cv cvv snssg anbi1d cA csn cF
      vg cv unss syl6bb syl rexbidv cA csn cF cun cF cuni cpw wss cF cuni cvv
      wcel cA csn cF cun c0 wne c0 cA csn cF cun cfi cfv wcel wn cA csn cF cun
      vg cv wss vg cfil wrex wb cF cfil wcel cA cF cuni wss cA c0 wne w3a vg cA
      csn cF cun cF cuni efilcp2 cF cfil wcel cA cF cuni wss cA csn cF cun cF
      cuni cpw wss cA c0 wne cF cfil wcel cF cuni cvv wcel cA cF cuni wss cA
      csn cF cun cF cuni cpw wss cF cfil uniexg cF cuni cvv wcel cA cF cuni wss
      cA csn cF cun cF cuni cpw wss cA cF cuni wss cF cuni cvv wcel cA cvv wcel
      cA cF cuni wss cA csn cF cun cF cuni cpw wss wi cA cF cuni wss cF cuni
      cvv wcel cA cvv wcel cA cF cuni cvv ssexg ex cA cvv wcel cA cF cuni wss
      cA csn cF cuni cpw wss cA csn cF cun cF cuni cpw wss cA cvv wcel cA cF
      cuni cpw wcel cA cF cuni wss cA csn cF cuni cpw wss cA cF cuni cvv elpwg
      cA cF cuni cpw cvv snssg bitr3d cA csn cF cuni cpw wss cF cF cuni cpw wss
      cA csn cF cun cF cuni cpw wss cF pwuni cA csn cF cuni cpw wss cF cF cuni
      cpw wss wa cA csn cF cun cF cuni cpw wss cA csn cF cF cuni cpw unss
      biimpi mpan2 syl6bi syl6 pm2.43a mpan9 3adant3 cF cfil wcel cA cF cuni
      wss cF cuni cvv wcel cA c0 wne cF cfil uniexg 3ad2ant1 cF cfil wcel cA cF
      cuni wss cA csn cF cun c0 wne cA c0 wne cF cfil wcel c0 cfil wcel wn cA
      csn cF cun c0 wne emnfil cF cfil wcel c0 cfil wcel wn wa cF c0 wceq wn cA
      csn cF cun c0 wne cF c0 cfil nelneq cF c0 wceq wn cA csn c0 wceq cF c0
      wceq wa wn cA csn cF cun c0 wne cA csn c0 wceq cF c0 wceq wa cF c0 wceq
      cA csn c0 wceq cF c0 wceq pm3.27 con3i cA csn c0 wceq cF c0 wceq wa cA
      csn cF cun c0 cA csn cF un00 necon3bbii sylib syl mpan2 3ad2ant1 syl3anc
      cF cfil wcel cA cF cuni wss cA c0 wne w3a c0 cA csn cF cun cfi cfv wcel
      wn vy cv cA csn cF cun wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex
      wn vx cv cA cin c0 wne vx cF wral cF cfil wcel cA cF cuni wss cA c0 wne
      w3a c0 cvv wcel cA csn cF cun cvv wcel wa c0 cA csn cF cun cfi cfv wcel
      wn vy cv cA csn cF cun wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex
      wn wb cF cfil wcel cA cF cuni wss cA c0 wne w3a cA csn cF cun cvv wcel c0
      cvv wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a cA csn cvv wcel cF cvv
      wcel wa cA csn cF cun cvv wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a
      cF cvv wcel cA csn cvv wcel cF cfil wcel cA cF cuni wss cF cvv wcel cA c0
      wne cF cfil elisset 3ad2ant1 cA snex jctil cA csn cF unexb sylib 0ex
      jctil c0 cvv wcel cA csn cF cun cvv wcel wa c0 cA csn cF cun cfi cfv wcel
      vy cv cA csn cF cun wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex vy
      c0 cvv cA csn cF cun cvv sppfi notbid syl cF cfil wcel cA cF cuni wss cA
      c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq
      wn wi vy wal vx cv cA cin c0 wne vx cF wral vy cv cA csn cF cun wss vy cv
      cfn wcel c0 vy cv cint wceq w3a vy wex wn cF cfil wcel cA cF cuni wss cA
      c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq
      wn wi vy wal vx cv cA cin c0 wne vx cF wral cF cfil wcel cA cF cuni wss
      cA c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint
      wceq wn wi vy wal wa vx cv cA cin c0 wne vx cF cF cfil wcel cA cF cuni
      wss cA c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint
      wceq wn wi vy wal wa vx ax-17 cF cfil wcel cA cF cuni wss cA c0 wne w3a
      vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal
      wa vx cv cF wcel vx cv cA cin c0 wne cF cfil wcel cA cF cuni wss cA c0
      wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn
      wi vy wal wa vx cv cF wcel wa vx cv cA cin c0 wne vx cv cA cpr cint c0
      wne cF cfil wcel cA cF cuni wss cA c0 wne w3a vy cv cA csn cF cun wss vy
      cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal wa vx cv cF wcel wa c0 vx
      cv cA cpr cint cF cfil wcel cA cF cuni wss cA c0 wne w3a vy cv cA csn cF
      cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal wa vx cv cF
      wcel wa c0 vx cv cA cpr cint wceq wn c0 vx cv cA cpr cint wne cF cfil
      wcel cA cF cuni wss cA c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel
      wa c0 vy cv cint wceq wn wi vy wal vx cv cF wcel c0 vx cv cA cpr cint
      wceq wn cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF wcel vy cv cA
      csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal c0 vx cv
      cA cpr cint wceq wn cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF
      wcel vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi
      vy wal c0 vx cv cA cpr cint wceq wn wi cF cfil wcel cA cF cuni wss cA c0
      wne w3a vx cv cF wcel wa vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy
      cv cint wceq wn wi vy wal vx cv cA cpr cA csn cF cun wss vx cv cA cpr cfn
      wcel wa c0 vx cv cA cpr cint wceq wn cF cfil wcel cA cF cuni wss cA c0
      wne w3a vx cv cF wcel wa vx cv cA cpr cA csn cF cun wss vx cv cA cpr cfn
      wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF wcel wa vx cv cA
      cpr cA csn cF cun wss vx cv cA csn cF cun wcel cA cA csn cF cun wcel wa
      cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF wcel wa vx cv cA csn
      cF cun wcel cA cA csn cF cun wcel vx cv cF wcel vx cv cA csn cF cun wcel
      cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF cA csn elun2 adantl cF
      cfil wcel cA cF cuni wss cA c0 wne w3a cA cA csn cF cun wcel vx cv cF
      wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a cA cvv wcel cA cA csn cF
      cun wcel cF cfil wcel cA cF cuni wss cA cvv wcel cA c0 wne cA cF cuni wss
      cF cfil wcel cA cvv wcel cA cF cuni wss cF cuni cvv wcel cA cvv wcel cF
      cfil wcel cA cF cuni cvv ssexg cF cfil uniexg sylan2 ancoms 3adant3 cA
      cvv wcel cA cA csn wcel cA cA csn cF cun wcel cA cvv snidg cA cA csn cF
      elun1 syl syl adantr jca vx cv cF wcel cA cF cuni cpw wcel vx cv cA cpr
      cA csn cF cun wss vx cv cA csn cF cun wcel cA cA csn cF cun wcel wa wb cF
      cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF wcel wa vx cv cF wcel cA
      cF cuni cpw wcel wa vx cv cA csn cF cun wcel cA cA csn cF cun wcel wa vx
      cv cA cpr cA csn cF cun wss vx cv cA cA csn cF cun cF cF cuni cpw prssg
      bicomd cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cF wcel pm3.27 cF
      cfil wcel cA cF cuni wss cA c0 wne w3a cA cF cuni cpw wcel vx cv cF wcel
      cF cfil wcel cA cF cuni wss cA c0 wne w3a cA cF cuni cpw wcel cA cF cuni
      wss cF cfil wcel cA cF cuni wss cA c0 wne 3simp2 cF cfil wcel cA cF cuni
      wss cA c0 wne w3a cA cvv wcel cA cF cuni cpw wcel cA cF cuni wss wb cF
      cfil wcel cA cF cuni wss cA cvv wcel cA c0 wne cA cF cuni wss cF cfil
      wcel cA cvv wcel cA cF cuni wss cF cuni cvv wcel cA cvv wcel cF cfil wcel
      cA cF cuni cvv ssexg cF cfil uniexg sylan2 ancoms 3adant3 cA cF cuni cvv
      elpwg syl mpbird adantr sylanc mpbird vx cv cA prfi jctir cF cfil wcel cA
      cF cuni wss cA c0 wne w3a vx cv cF wcel wa vx cv cA cpr cvv wcel vy cv cA
      csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal vx cv cA
      cpr cA csn cF cun wss vx cv cA cpr cfn wcel wa c0 vx cv cA cpr cint wceq
      wn wi wi vx cv cA cpr cvv wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a
      vx cv cF wcel wa vx cv cA prex a1i vy cv cA csn cF cun wss vy cv cfn wcel
      wa c0 vy cv cint wceq wn wi vx cv cA cpr cA csn cF cun wss vx cv cA cpr
      cfn wcel wa c0 vx cv cA cpr cint wceq wn wi vy vx cv cA cpr cvv vy cv vx
      cv cA cpr wceq vy cv cA csn cF cun wss vy cv cfn wcel wa vx cv cA cpr cA
      csn cF cun wss vx cv cA cpr cfn wcel wa c0 vy cv cint wceq wn c0 vx cv cA
      cpr cint wceq wn vy cv vx cv cA cpr wceq vy cv cA csn cF cun wss vx cv cA
      cpr cA csn cF cun wss vy cv cfn wcel vx cv cA cpr cfn wcel vy cv vx cv cA
      cpr cA csn cF cun sseq1 vy cv vx cv cA cpr cfn eleq1 anbi12d vy cv vx cv
      cA cpr wceq c0 vy cv cint wceq c0 vx cv cA cpr cint wceq vy cv vx cv cA
      cpr wceq vy cv cint vx cv cA cpr cint c0 vy cv vx cv cA cpr inteq eqeq2d
      notbid imbi12d cla4gv syl mpid ex com23 imp31 c0 vx cv cA cpr cint df-ne
      sylibr necomd cF cfil wcel cA cF cuni wss cA c0 wne w3a vy cv cA csn cF
      cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal wa vx cv cF
      wcel wa vx cv cA cin vx cv cA cpr cint c0 cF cfil wcel cA cF cuni wss cA
      c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq
      wn wi vy wal wa vx cv cF wcel wa vx cv cA cpr cint vx cv cA cin cF cfil
      wcel cA cF cuni wss cA c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel
      wa c0 vy cv cint wceq wn wi vy wal wa vx cv cF wcel wa vx cv cvv wcel cA
      cvv wcel wa vx cv cA cpr cint vx cv cA cin wceq cF cfil wcel cA cF cuni
      wss cA c0 wne w3a vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint
      wceq wn wi vy wal wa vx cv cF wcel wa cA cvv wcel vx cv cvv wcel cF cfil
      wcel cA cF cuni wss cA c0 wne w3a cA cvv wcel vy cv cA csn cF cun wss vy
      cv cfn wcel wa c0 vy cv cint wceq wn wi vy wal vx cv cF wcel cF cfil wcel
      cA cF cuni wss cA cvv wcel cA c0 wne cA cF cuni wss cF cfil wcel cA cvv
      wcel cA cF cuni wss cF cuni cvv wcel cA cvv wcel cF cfil wcel cA cF cuni
      cvv ssexg cF cfil uniexg sylan2 ancoms 3adant3 ad2antrr vx visset jctil
      vx cv cA intprd syl eqcomd neeq1d mpbird ex r19.21ai cF cfil wcel cA cF
      cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa vy cv cA csn cF
      cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy cA vy cv wcel cF
      cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa
      vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi wi cA
      vy cv wcel vy cv cint cA vy cv cA csn cdif cint cin wceq cF cfil wcel cA
      cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa vy cv cA csn
      cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi wi vy cv cA moec vy
      cv cA csn cF cun wss vy cv cfn wcel wa cF cfil wcel cA cF cuni wss cA c0
      wne w3a vx cv cA cin c0 wne vx cF wral wa vy cv cint cA vy cv cA csn cdif
      cint cin wceq c0 vy cv cint wceq wn vy cv cA csn cF cun wss vy cv cfn
      wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF
      wral wa vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq
      wn wi wi vy cv cA csn cF cun wss vy cv cA csn cdif cF wss vy cv cfn wcel
      cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral
      wa vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi
      wi wi vy cv cA csn cF ssundif vy cv cA csn cdif c0 wceq vy cv cA csn cdif
      cF wss vy cv cfn wcel cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA
      cin c0 wne vx cF wral wa vy cv cint cA vy cv cA csn cdif cint cin wceq c0
      vy cv cint wceq wn wi wi wi wi cF cfil wcel cA cF cuni wss cA c0 wne w3a
      vx cv cA cin c0 wne vx cF wral wa vy cv cA csn cdif cF wss vy cv cfn wcel
      vy cv cA csn cdif c0 wceq vy cv cint cA vy cv cA csn cdif cint cin wceq
      c0 vy cv cint wceq wn wi cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv
      cA cin c0 wne vx cF wral vy cv cA csn cdif cF wss vy cv cfn wcel vy cv cA
      csn cdif c0 wceq vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi wi wi wi cA c0 wne cF cfil wcel vx cv cA cin c0 wne vx cF
      wral vy cv cA csn cdif cF wss vy cv cfn wcel vy cv cA csn cdif c0 wceq vy
      cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi wi
      wi wi cA cF cuni wss vy cv cfn wcel vx cv cA cin c0 wne vx cF wral vy cv
      cA csn cdif cF wss cA c0 wne vy cv cA csn cdif c0 wceq vy cv cint cA vy
      cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi vx cv cA cin c0
      wne vx cF wral vy cv cA csn cdif cF wss cA c0 wne vy cv cA csn cdif c0
      wceq vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn
      wi wi wi wi wi vy cv cfn wcel vy cv cA csn cdif cF wss cA c0 wne vy cv cA
      csn cdif c0 wceq vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi wi wi wi vx cv cA cin c0 wne vx cF wral cA c0 wne vy cv
      cA csn cdif c0 wceq vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy
      cv cint wceq wn wi wi wi vy cv cA csn cdif cF wss vy cv cA csn cdif c0
      wceq cA c0 wne vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi vy cv cA csn cdif c0 wceq vy cv cA csn cdif cint c0 cint
      wceq cA c0 wne vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi wi vy cv cA csn cdif c0 inteq c0 cint cvv wceq vy cv cA
      csn cdif cint c0 cint wceq cA c0 wne vy cv cint cA vy cv cA csn cdif cint
      cin wceq c0 vy cv cint wceq wn wi wi wi int0 vy cv cA csn cdif cint c0
      cint wceq c0 cint cvv wceq vy cv cA csn cdif cint cvv wceq cA c0 wne vy
      cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi vy
      cv cA csn cdif cint c0 cint wceq c0 cint cvv wceq vy cv cA csn cdif cint
      cvv wceq vy cv cA csn cdif cint c0 cint cvv eqtr ex vy cv cA csn cdif
      cint cvv wceq cA vy cv cA csn cdif cint cin cA cvv cin wceq cA c0 wne vy
      cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi vy
      cv cA csn cdif cint cvv cA ineq2 cA vy cv cA csn cdif cint cin cA cvv cin
      wceq cA cvv cin cA wceq cA c0 wne vy cv cint cA vy cv cA csn cdif cint
      cin wceq c0 vy cv cint wceq wn wi wi cA inv1 cA vy cv cA csn cdif cint
      cin cA cvv cin wceq cA cvv cin cA wceq cA vy cv cA csn cdif cint cin cA
      wceq cA c0 wne vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi wi cA vy cv cA csn cdif cint cin cA cvv cin wceq cA cvv
      cin cA wceq cA vy cv cA csn cdif cint cin cA wceq cA vy cv cA csn cdif
      cint cin cA cvv cin cA eqtr ex vy cv cint cA vy cv cA csn cdif cint cin
      wceq cA vy cv cA csn cdif cint cin cA wceq cA c0 wne c0 vy cv cint wceq
      wn vy cv cint cA vy cv cA csn cdif cint cin wceq cA vy cv cA csn cdif
      cint cin cA wceq vy cv cint cA wceq cA c0 wne c0 vy cv cint wceq wn wi vy
      cv cint cA vy cv cA csn cdif cint cin wceq cA vy cv cA csn cdif cint cin
      cA wceq vy cv cint cA wceq vy cv cint cA vy cv cA csn cdif cint cin cA
      eqtr ex cA c0 wne c0 vy cv cint wceq wn wi cA vy cv cint cA vy cv cint
      wceq cA c0 wne vy cv cint c0 wne c0 vy cv cint wceq wn cA vy cv cint c0
      neeq1 vy cv cint c0 wne c0 vy cv cint wne c0 vy cv cint wceq wn vy cv
      cint c0 necom c0 vy cv cint wne c0 vy cv cint wceq wn c0 vy cv cint df-ne
      biimpi sylbi syl6bi eqcoms syl6 com3l syl6 mpi syl syl6com ax-mp syl
      com12 a1i a1i a1i com14 3ad2ant3 imp com14 vy cv cA csn cdif c0 wceq wn
      vy cv cA csn cdif vy cv wss vy cv cA csn cdif cF wss vy cv cfn wcel cF
      cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa
      vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi
      wi wi vy cv cA csn difss vy cv cfn wcel vy cv cA csn cdif vy cv wss vy cv
      cA csn cdif cF wss vy cv cA csn cdif c0 wceq wn cF cfil wcel cA cF cuni
      wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa vy cv cint cA vy cv
      cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi vy cv cfn wcel vy
      cv cA csn cdif vy cv wss vy cv cA csn cdif cfn wcel vy cv cA csn cdif cF
      wss vy cv cA csn cdif c0 wceq wn cF cfil wcel cA cF cuni wss cA c0 wne
      w3a vx cv cA cin c0 wne vx cF wral wa vy cv cint cA vy cv cA csn cdif
      cint cin wceq c0 vy cv cint wceq wn wi wi wi wi vy cv cfn wcel vy cv cA
      csn cdif vy cv wss vy cv cA csn cdif cfn wcel vy cv vy cv cA csn cdif
      ssfi ex cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx
      cF wral wa vy cv cA csn cdif cF wss vy cv cA csn cdif c0 wceq wn vy cv cA
      csn cdif cfn wcel vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi cF cfil wcel cA cF cuni wss cA c0 wne w3a cF cfil wcel vx
      cv cA cin c0 wne vx cF wral vy cv cA csn cdif cF wss vy cv cA csn cdif c0
      wceq wn vy cv cA csn cdif cfn wcel vy cv cint cA vy cv cA csn cdif cint
      cin wceq c0 vy cv cint wceq wn wi wi wi wi cF cfil wcel cA cF cuni wss cA
      c0 wne 3simp1 vx cv cA cin c0 wne vx cF wral cF cfil wcel vy cv cA csn
      cdif cF wss vy cv cA csn cdif c0 wceq wn vy cv cA csn cdif cfn wcel vy cv
      cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi cF
      cfil wcel vy cv cA csn cdif cF wss vy cv cA csn cdif c0 wceq wn w3a vy cv
      cA csn cdif cfn wcel vx cv cA cin c0 wne vx cF wral vy cv cint cA vy cv
      cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi cF cfil wcel vy cv cA
      csn cdif cF wss vy cv cA csn cdif c0 wceq wn vy cv cA csn cdif cfn wcel
      vx cv cA cin c0 wne vx cF wral vy cv cint cA vy cv cA csn cdif cint cin
      wceq c0 vy cv cint wceq wn wi wi wi vy cv cA csn cdif c0 wceq wn vy cv cA
      csn cdif cF wss cF cfil wcel vy cv cA csn cdif cfn wcel vx cv cA cin c0
      wne vx cF wral vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi wi wi vy cv cA csn cdif c0 wceq wn vy cv cA csn cdif c0
      wne vy cv cA csn cdif cF wss cF cfil wcel vy cv cA csn cdif cfn wcel vx
      cv cA cin c0 wne vx cF wral vy cv cint cA vy cv cA csn cdif cint cin wceq
      c0 vy cv cint wceq wn wi wi wi wi wi vy cv cA csn cdif c0 df-ne cF cfil
      wcel vy cv cA csn cdif cF wss vy cv cA csn cdif c0 wne vy cv cA csn cdif
      cfn wcel vx cv cA cin c0 wne vx cF wral vy cv cint cA vy cv cA csn cdif
      cint cin wceq c0 vy cv cint wceq wn wi wi wi cF cfil wcel vy cv cA csn
      cdif cF wss vy cv cA csn cdif c0 wne vy cv cA csn cdif cfn wcel vx cv cA
      cin c0 wne vx cF wral vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy
      cv cint wceq wn wi wi cF cfil wcel vy cv cA csn cdif cF wss vy cv cA csn
      cdif c0 wne vy cv cA csn cdif cfn wcel w3a vy cv cA csn cdif cint cF wcel
      vx cv cA cin c0 wne vx cF wral vy cv cint cA vy cv cA csn cdif cint cin
      wceq c0 vy cv cint wceq wn wi wi vy cv cA csn cdif cF filint2 vy cv cA
      csn cdif cint cF wcel vx cv cA cin c0 wne vx cF wral vy cv cA csn cdif
      cint cA cin c0 wne vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv
      cint wceq wn wi vx cv cA cin c0 wne vy cv cA csn cdif cint cA cin c0 wne
      vx vy cv cA csn cdif cint cF vx cv vy cv cA csn cdif cint wceq vx cv cA
      cin vy cv cA csn cdif cint cA cin c0 vx cv vy cv cA csn cdif cint cA
      ineq1 neeq1d rcla4v vy cv cA csn cdif cint cA cin cA vy cv cA csn cdif
      cint cin wceq vy cv cA csn cdif cint cA cin c0 wne vy cv cint cA vy cv cA
      csn cdif cint cin wceq c0 vy cv cint wceq wn wi wi vy cv cA csn cdif cint
      cA incom vy cv cA csn cdif cint cA cin cA vy cv cA csn cdif cint cin wceq
      vy cv cA csn cdif cint cA cin c0 wne cA vy cv cA csn cdif cint cin c0 wne
      vy cv cint cA vy cv cA csn cdif cint cin wceq c0 vy cv cint wceq wn wi vy
      cv cA csn cdif cint cA cin cA vy cv cA csn cdif cint cin c0 neeq1 vy cv
      cint cA vy cv cA csn cdif cint cin wceq cA vy cv cA csn cdif cint cin c0
      wne vy cv cint c0 wne c0 vy cv cint wceq wn cA vy cv cA csn cdif cint cin
      c0 wne vy cv cint c0 wne wi cA vy cv cA csn cdif cint cin vy cv cint cA
      vy cv cA csn cdif cint cin vy cv cint wceq cA vy cv cA csn cdif cint cin
      c0 wne vy cv cint c0 wne cA vy cv cA csn cdif cint cin vy cv cint c0
      neeq1 biimpd eqcoms vy cv cint c0 wne c0 vy cv cint wne c0 vy cv cint
      wceq wn vy cv cint c0 necom c0 vy cv cint wne c0 vy cv cint wceq wn c0 vy
      cv cint df-ne biimpi sylbi syl6com syl6bi ax-mp syl6 syl6 3expd com13
      sylbir com13 3imp com3r 3expd mpan9 com14 syl6 com14 mpi pm2.61i sylbi
      imp com13 syl vy cv cA csn cF cun wss vy cv cfn wcel wa cF cfil wcel cA
      cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa cA vy cv wcel
      wn c0 vy cv cint wceq wn vy cv cA csn cF cun wss vy cv cfn wcel cF cfil
      wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa cA vy
      cv wcel wn c0 vy cv cint wceq wn wi wi vy cv cA csn cF cun wss cA vy cv
      wcel wn cF cfil wcel cA cF cuni wss cA c0 wne w3a vx cv cA cin c0 wne vx
      cF wral wa vy cv cfn wcel c0 vy cv cint wceq wn cA vy cv wcel wn vy cv cA
      csn cF cun wss vy cv cF wss cF cfil wcel cA cF cuni wss cA c0 wne w3a vx
      cv cA cin c0 wne vx cF wral wa vy cv cfn wcel c0 vy cv cint wceq wn wi wi
      cA vy cv wcel wn vy cv cA csn cin c0 wceq vy cv cA csn cF cun wss vy cv
      cF wss wi cA vy cv wcel wn vx cv vy cv wcel vx cv cA csn wcel wn wi vx
      wal vy cv cA csn cin c0 wceq cA vy cv wcel wn vx cv vy cv wcel vx cv cA
      csn wcel wn wi vx vx cv vy cv wcel cA vy cv wcel wn vx cv cA csn wcel wn
      vx cv vy cv wcel vx cv cA csn wcel cA vy cv wcel vx cv cA csn wcel vx cv
      vy cv wcel cA vy cv wcel vx cv cA csn wcel vx cv cA wceq vx cv vy cv wcel
      cA vy cv wcel wi vx cv cA elsni vx cv cA wceq vx cv vy cv wcel cA vy cv
      wcel vx cv cA vy cv eleq1 biimpd syl com12 con3d com12 19.21aiv vx vy cv
      cA csn disj1 sylibr vy cv cA csn cin c0 wceq vy cv cA csn cF cun wss vy
      cv cF wss vy cv cA csn cF disjssun biimpd syl cF cfil wcel cA cF cuni wss
      cA c0 wne w3a vx cv cA cin c0 wne vx cF wral wa vy cv cF wss vy cv cfn
      wcel c0 vy cv cint wceq wn wi cF cfil wcel cA cF cuni wss cA c0 wne w3a
      vy cv cF wss vy cv cfn wcel c0 vy cv cint wceq wn wi wi vx cv cA cin c0
      wne vx cF wral cF cfil wcel cA cF cuni wss vy cv cF wss vy cv cfn wcel c0
      vy cv cint wceq wn wi wi cA c0 wne cF cfil wcel vy cv cF wss vy cv cfn
      wcel c0 vy cv cint wceq wn wi wi wi vy cv c0 vy cv cfn wcel cF cfil wcel
      vy cv cF wss vy cv c0 wceq c0 vy cv cint wceq wn cF cfil wcel vy cv cF
      wss vy cv c0 wceq c0 vy cv cint wceq wn wi wi wi vy cv cfn wcel vy cv cF
      wss vy cv c0 wceq c0 vy cv cint wceq wn wi wi cF cfil wcel vy cv c0 wceq
      c0 vy cv cint wceq wn wi vy cv cF wss vy cv c0 wceq vy cv cint c0 cint
      wceq c0 vy cv cint wceq wn vy cv c0 inteq vy cv cint c0 cint wceq c0 cint
      cvv wceq c0 vy cv cint wceq wn int0 vy cv cint c0 cint wceq c0 cint cvv
      wceq vy cv cint cvv wceq c0 vy cv cint wceq wn vy cv cint c0 cint wceq c0
      cint cvv wceq vy cv cint cvv wceq vy cv cint c0 cint cvv eqtr ex c0 vy cv
      cint wceq wn cvv vy cv cint cvv vy cv cint wceq c0 vy cv cint wne c0 vy
      cv cint wceq wn cvv vy cv cint wceq c0 cvv wne c0 vy cv cint wne cvv c0
      wne c0 cvv wne vn0 cvv c0 necom mpbi cvv vy cv cint c0 neeq2 mpbii c0 vy
      cv cint df-ne sylib eqcoms syl6 mpi syl a1i a1i a1i com14 cF cfil wcel vy
      cv cF wss vy cv c0 wne vy cv cfn wcel c0 vy cv cint wceq wn wi cF cfil
      wcel vy cv cF wss vy cv c0 wne vy cv cfn wcel c0 vy cv cint wceq wn cF
      cfil wcel vy cv cF wss vy cv c0 wne vy cv cfn wcel w3a wa c0 vy cv cint
      wne c0 vy cv cint wceq wn cF cfil wcel vy cv cF wss vy cv c0 wne vy cv
      cfn wcel w3a wa vy cv cint c0 cF cfil wcel vy cv cF wss vy cv c0 wne vy
      cv cfn wcel w3a vy cv cint c0 wne vy cv cF fipfil2 imp necomd c0 vy cv
      cint df-ne sylib 3exp2 com3r pm2.61ine 3ad2ant1 adantr com12 syl6com
      com24 imp com13 pm2.61i 19.21aiv impbida vy cv cA csn cF cun wss vy cv
      cfn wcel c0 vy cv cint wceq w3a vy wex wn vy cv cA csn cF cun wss vy cv
      cfn wcel c0 vy cv cint wceq w3a wn vy wal vy cv cA csn cF cun wss vy cv
      cfn wcel wa c0 vy cv cint wceq wn wi vy wal vy cv cA csn cF cun wss vy cv
      cfn wcel c0 vy cv cint wceq w3a vy alnex vy cv cA csn cF cun wss vy cv
      cfn wcel c0 vy cv cint wceq w3a wn vy cv cA csn cF cun wss vy cv cfn wcel
      wa c0 vy cv cint wceq wn wi vy vy cv cA csn cF cun wss vy cv cfn wcel c0
      vy cv cint wceq w3a wn vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv
      cint wceq wa wn vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint
      wceq wn wi vy cv cA csn cF cun wss vy cv cfn wcel c0 vy cv cint wceq w3a
      vy cv cA csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq wa vy cv cA
      csn cF cun wss vy cv cfn wcel c0 vy cv cint wceq df-3an notbii vy cv cA
      csn cF cun wss vy cv cfn wcel wa c0 vy cv cint wceq imnan bitr4i albii
      bitr3i syl5bb bitrd 3bitr2d $.
      $( [2-Sep-2008] $) $( [27-Apr-2008] $)
  $}

  ${
    $d A x $.  $d B b x $.
    $( Lemma for ~ rcfpfil . $)
    rcfpfillem1 $p |- ( B e. C
        -> ( B e. { x | E. b (  b C_ A /\ b e. Fin /\ x = ( A \ b ) ) }
                 <-> E. b ( b C_ A /\ b e. Fin /\ B = ( A \ b ) ) ) ) $=
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vb cv cA
      wss vb cv cfn wcel cB cA vb cv cdif wceq w3a vb wex vx cB cC vx cv cB
      wceq vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb cv cA
      wss vb cv cfn wcel cB cA vb cv cdif wceq w3a vb vx cv cB wceq vx cv cA vb
      cv cdif wceq cB cA vb cv cdif wceq vb cv cA wss vb cv cfn wcel vx cv cB
      cA vb cv cdif eqeq1 3anbi3d exbidv elabg $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}

  ${
    $d A b x $.
    $( Lemma for ~ rcfpfil . $)
    rcfpfillem2 $p |- ( -. A e. Fin -> -. (/) e. { x | E. b
        (  b C_ A /\ b e. Fin /\ x = ( A \ b ) ) }  ) $=
      cA cfn wcel wn vb cv cA wss vb cv cfn wcel c0 cA vb cv cdif wceq w3a vb
      wex wn c0 vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex
      vx cab wcel wn vb cv cA wss vb cv cfn wcel c0 cA vb cv cdif wceq w3a vb
      wex cA cfn wcel vb cv cA wss vb cv cfn wcel c0 cA vb cv cdif wceq w3a cA
      cfn wcel vb vb cv cA wss vb cv cfn wcel c0 cA vb cv cdif wceq cA cfn wcel
      c0 cA vb cv cdif wceq vb cv cfn wcel vb cv cA wss cA cfn wcel c0 cA vb cv
      cdif wceq cA vb cv wss vb cv cfn wcel vb cv cA wss cA cfn wcel wi wi cA
      vb cv wss cA vb cv cdif c0 wceq c0 cA vb cv cdif wceq cA vb cv ssdif0 cA
      vb cv cdif c0 eqcom bitri cA vb cv wss vb cv cA wss vb cv cfn wcel cA cfn
      wcel cA vb cv wss vb cv cA wss vb cv cfn wcel cA cfn wcel wi cA vb cv wss
      vb cv cA wss wa vb cv cA wceq vb cv cfn wcel cA cfn wcel wi vb cv cA wceq
      cA vb cv wceq cA vb cv wss vb cv cA wss wa vb cv cA eqcom cA vb cv eqss
      bitri vb cv cA wceq vb cv cfn wcel cA cfn wcel vb cv cA cfn eleq1 biimpd
      sylbir ex com23 sylbir com13 3imp 19.23aiv con3i c0 cvv wcel c0 vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wn vb
      cv cA wss vb cv cfn wcel c0 cA vb cv cdif wceq w3a vb wex wn wb 0ex c0
      cvv wcel c0 vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab wcel vb cv cA wss vb cv cfn wcel c0 cA vb cv cdif wceq w3a vb
      wex vx cA c0 cvv vb rcfpfillem1 notbid ax-mp sylibr $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}

  ${
    $d A b x y $.  $d B b y $.
    $( Lemma for ~ rcfpfil . $)
    rcfpfillem3 $p |- ( A e. B -> U. { x | E. b
         (  b C_ A /\ b e. Fin /\ x = ( A \ b ) ) } = A ) $=
      cA cB wcel vy vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab cuni cA cA cB wcel vy cv vx cv wcel vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb wex wa vx wex vy cv cA wcel vy cv vb
      cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni
      wcel cA cB wcel vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb
      cv cdif wceq w3a vb wex wa vx wex vy cv cA wcel vy cv vx cv wcel vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex wa vx wex cA cB
      wcel vy cv cA wcel vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb wex wa vx wex vy cv vx cv wcel vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a wa vb wex vx wex cA cB wcel vy cv
      cA wcel wi vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex wa vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a wa vb wex vx vy cv vx cv wcel vb cv cA wss vb
      cv cfn wcel vx cv cA vb cv cdif wceq w3a wa vb wex vy cv vx cv wcel vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex wa vy cv vx cv
      wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb 19.42v
      bicomi exbii vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a wa vb wex vx wex vy cv vx cv wcel vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a wa vx wex vb wex cA cB wcel vy cv cA
      wcel wi vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a wa vx vb excom vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a wa vx wex cA cB wcel vy cv cA wcel wi vb vy cv
      vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a wa vx
      wex vx cv cA vb cv cdif wceq vy cv vx cv wcel wa vb cv cA wss vb cv cfn
      wcel wa wa vx wex vx cv cA vb cv cdif wceq vy cv vx cv wcel wa vx wex vb
      cv cA wss vb cv cfn wcel wa vx wex wa cA cB wcel vy cv cA wcel wi vy cv
      vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a wa vx
      cv cA vb cv cdif wceq vy cv vx cv wcel wa vb cv cA wss vb cv cfn wcel wa
      wa vx vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a wa vx cv cA vb cv cdif wceq vy cv vx cv wcel wa vb cv cA wss vb
      cv cfn wcel wa vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb
      cv cdif wceq w3a wa vx cv cA vb cv cdif wceq vy cv vx cv wcel vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vx cv cA vb cv cdif wceq
      vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      3simp3 adantl vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a pm3.26 jca vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb cv cA wss vb cv cfn wcel wa vy cv vx cv wcel vb cv cA wss vb
      cv cfn wcel vx cv cA vb cv cdif wceq 3simpa adantl jca 19.22i vx cv cA vb
      cv cdif wceq vy cv vx cv wcel wa vb cv cA wss vb cv cfn wcel wa vx 19.40
      vx cv cA vb cv cdif wceq vy cv vx cv wcel wa vx wex cA cB wcel vy cv cA
      wcel wi vb cv cA wss vb cv cfn wcel wa vx wex cA cB wcel vx cv cA vb cv
      cdif wceq vy cv vx cv wcel wa vx wex vy cv cA wcel cA cB wcel cA vb cv
      cdif cvv wcel vx cv cA vb cv cdif wceq vy cv vx cv wcel wa vx wex vy cv
      cA wcel wi cA vb cv cB difexg cA vb cv cdif cvv wcel vx cv cA vb cv cdif
      wceq vy cv vx cv wcel wa vx wex vy cv cA vb cv cdif wcel vy cv cA wcel vy
      cv vx cv wcel vy cv cA vb cv cdif wcel vx cA vb cv cdif cvv vx cv cA vb
      cv cdif vy cv eleq2 ceqsexgv vy cv cA vb cv eldifi syl6bi syl com12
      adantr 3syl 19.23aiv sylbi sylbi com12 vy cv vx cv wcel vb cv cA wss vb
      cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex wa vy cv cA wcel vx cA cB
      vx cv cA wceq vy cv vx cv wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex wa vy cv cA wcel vb cv cA wss vb cv cfn wcel cA cA
      vb cv cdif wceq w3a vb wex wa vy cv cA wcel vx cv cA wceq vy cv vx cv
      wcel vy cv cA wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb wex vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a vb wex
      vx cv cA vy cv eleq2 vx cv cA wceq vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a
      vb vx cv cA wceq vx cv cA vb cv cdif wceq cA cA vb cv cdif wceq vb cv cA
      wss vb cv cfn wcel vx cv cA cA vb cv cdif eqeq1 3anbi3d exbidv anbi12d vy
      cv cA wcel vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a vb wex
      wa vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a vb wex vy cv cA
      wcel vy cv cA wcel vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a
      vb wex ancom c0 cvv wcel c0 cA wss c0 cfn wcel cA cA c0 cdif wceq w3a vb
      cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a vb wex 0ex c0 cA wss
      c0 cfn wcel cA cA c0 cdif wceq cA 0ss emfin cA c0 cdif cA cA dif0 eqcomi
      3pm3.2i vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a c0 cA wss
      c0 cfn wcel cA cA c0 cdif wceq w3a vb c0 cvv vb cv c0 wceq vb cv cA wss
      c0 cA wss vb cv cfn wcel c0 cfn wcel cA cA vb cv cdif wceq cA cA c0 cdif
      wceq vb cv c0 cA sseq1 vb cv c0 cfn eleq1 vb cv c0 wceq cA vb cv cdif cA
      c0 cdif cA vb cv c0 cA difeq2 eqeq2d 3anbi123d cla4egv mp2 mpbiran syl6bb
      cla4egv impbid vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a
      vb wex vx vy cv eluniab syl5bb eqrdv $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}

  ${
    $d A a b c u v x $.  $d B u v $.
    $( Lemma for ~ rcfpfil . $)
    rcfpfillem4 $p |- ( A e. B
        -> A. u e. { x | E. b ( b C_ A /\ b e. Fin /\ x = ( A \ b ) ) }
           A. v e. { x | E. b ( b C_ A /\ b e. Fin /\ x = ( A \ b ) ) }
       ( u i^i v ) e. { x | E. b ( b C_ A /\ b e. Fin /\ x = ( A \ b ) ) } ) $=
      cA cB wcel vu cv vv cv cin vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex vx cab wcel vu vv vb cv cA wss vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb wex vx cab vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb wex vx cab cA cB wcel vb cv cA wss vb cv cfn wcel
      vu cv cA vb cv cdif wceq w3a vb wex vb cv cA wss vb cv cfn wcel vv cv cA
      vb cv cdif wceq w3a vb wex wa vu cv vv cv cin vb cv cA wss vb cv cfn wcel
      vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vu cv vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv cv vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wa cA
      cB wcel vb cv cA wss vb cv cfn wcel vu cv cA vb cv cdif wceq w3a vb wex
      vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex wa vu cv
      vv cv cin vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex
      vx cab wcel cA cB wcel vb cv cA wss vb cv cfn wcel vu cv cA vb cv cdif
      wceq w3a vb wex vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a
      vb wex wa wa vb cv cA wss vb cv cfn wcel vu cv vv cv cin cA vb cv cdif
      wceq w3a vb wex vu cv vv cv cin vb cv cA wss vb cv cfn wcel vx cv cA vb
      cv cdif wceq w3a vb wex vx cab wcel vb cv cA wss vb cv cfn wcel vu cv cA
      vb cv cdif wceq w3a vb wex vb cv cA wss vb cv cfn wcel vv cv cA vb cv
      cdif wceq w3a vb wex wa vb cv cA wss vb cv cfn wcel vu cv vv cv cin cA vb
      cv cdif wceq w3a vb wex cA cB wcel va cv cA wss va cv cfn wcel vu cv cA
      va cv cdif wceq w3a va wex vc cv cA wss vc cv cfn wcel vv cv cA vc cv
      cdif wceq w3a vc wex vb cv cA wss vb cv cfn wcel vu cv vv cv cin cA vb cv
      cdif wceq w3a vb wex vb cv cA wss vb cv cfn wcel vu cv cA vb cv cdif wceq
      w3a vb wex vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb
      wex va cv cA wss va cv cfn wcel vu cv cA va cv cdif wceq w3a va wex vc cv
      cA wss vc cv cfn wcel vv cv cA vc cv cdif wceq w3a vc wex vb cv cA wss vb
      cv cfn wcel vu cv vv cv cin cA vb cv cdif wceq w3a vb wex va cv cA wss va
      cv cfn wcel vu cv cA va cv cdif wceq w3a vc cv cA wss vc cv cfn wcel vv
      cv cA vc cv cdif wceq w3a vc wex vb cv cA wss vb cv cfn wcel vu cv vv cv
      cin cA vb cv cdif wceq w3a vb wex wi va vc cv cA wss vc cv cfn wcel vv cv
      cA vc cv cdif wceq w3a vc wex va cv cA wss va cv cfn wcel vu cv cA va cv
      cdif wceq w3a vb cv cA wss vb cv cfn wcel vu cv vv cv cin cA vb cv cdif
      wceq w3a vb wex vc cv cA wss vc cv cfn wcel vv cv cA vc cv cdif wceq w3a
      va cv cA wss va cv cfn wcel vu cv cA va cv cdif wceq w3a vb cv cA wss vb
      cv cfn wcel vu cv vv cv cin cA vb cv cdif wceq w3a vb wex wi vc vc cv cA
      wss vc cv cfn wcel vv cv cA vc cv cdif wceq w3a va cv cA wss va cv cfn
      wcel vu cv cA va cv cdif wceq w3a va cv vc cv cun cA wss va cv vc cv cun
      cfn wcel vu cv vv cv cin cA va cv vc cv cun cdif wceq w3a vb cv cA wss vb
      cv cfn wcel vu cv vv cv cin cA vb cv cdif wceq w3a vb wex va cv cA wss va
      cv cfn wcel vu cv cA va cv cdif wceq w3a vc cv cA wss vc cv cfn wcel vv
      cv cA vc cv cdif wceq w3a va cv vc cv cun cA wss va cv vc cv cun cfn wcel
      vu cv vv cv cin cA va cv vc cv cun cdif wceq w3a va cv cA wss va cv cfn
      wcel vu cv cA va cv cdif wceq w3a vc cv cA wss vc cv cfn wcel vv cv cA vc
      cv cdif wceq w3a wa va cv cA wss vc cv cA wss wa va cv cfn wcel vc cv cfn
      wcel wa vu cv cA va cv cdif wceq vv cv cA vc cv cdif wceq wa w3a va cv vc
      cv cun cA wss va cv vc cv cun cfn wcel vu cv vv cv cin cA va cv vc cv cun
      cdif wceq w3a va cv cA wss va cv cfn wcel vu cv cA va cv cdif wceq vc cv
      cA wss vc cv cfn wcel vv cv cA vc cv cdif wceq an6 va cv cA wss vc cv cA
      wss wa va cv vc cv cun cA wss va cv cfn wcel vc cv cfn wcel wa va cv vc
      cv cun cfn wcel vu cv cA va cv cdif wceq vv cv cA vc cv cdif wceq wa vu
      cv vv cv cin cA va cv vc cv cun cdif wceq va cv cA wss vc cv cA wss wa va
      cv vc cv cun cA wss va cv vc cv cA unss biimpi va cv vc cv unfi vu cv cA
      va cv cdif wceq vv cv cA vc cv cdif wceq wa vu cv vv cv cin cA va cv cdif
      cA vc cv cdif cin cA va cv vc cv cun cdif vu cv cA va cv cdif vv cv cA vc
      cv cdif ineq12 cA va cv vc cv difundi syl6eqr 3anim123i sylbi expcom vb
      cv cA wss vb cv cfn wcel vu cv vv cv cin cA vb cv cdif wceq w3a va cv vc
      cv cun cA wss va cv vc cv cun cfn wcel vu cv vv cv cin cA va cv vc cv cun
      cdif wceq w3a vb va cv vc cv cun va cv vc cv va visset vc visset unex vb
      cv va cv vc cv cun wceq vb cv cA wss va cv vc cv cun cA wss vb cv cfn
      wcel va cv vc cv cun cfn wcel vu cv vv cv cin cA vb cv cdif wceq vu cv vv
      cv cin cA va cv vc cv cun cdif wceq vb cv va cv vc cv cun cA sseq1 vb cv
      va cv vc cv cun cfn eleq1 vb cv va cv vc cv cun wceq cA vb cv cdif cA va
      cv vc cv cun cdif vu cv vv cv cin vb cv va cv vc cv cun cA difeq2 eqeq2d
      3anbi123d cla4ev syl6 19.23aiv com12 19.23aiv imp vb cv cA wss vb cv cfn
      wcel vu cv cA vb cv cdif wceq w3a va cv cA wss va cv cfn wcel vu cv cA va
      cv cdif wceq w3a vb va vb cv va cv wceq vb cv cA wss va cv cA wss vb cv
      cfn wcel va cv cfn wcel vu cv cA vb cv cdif wceq vu cv cA va cv cdif wceq
      vb cv va cv cA sseq1 vb cv va cv cfn eleq1 vb cv va cv wceq cA vb cv cdif
      cA va cv cdif vu cv vb cv va cv cA difeq2 eqeq2d 3anbi123d cbvexv vb cv
      cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vc cv cA wss vc cv cfn
      wcel vv cv cA vc cv cdif wceq w3a vb vc vb cv vc cv wceq vb cv cA wss vc
      cv cA wss vb cv cfn wcel vc cv cfn wcel vv cv cA vb cv cdif wceq vv cv cA
      vc cv cdif wceq vb cv vc cv cA sseq1 vb cv vc cv cfn eleq1 vb cv vc cv
      wceq cA vb cv cdif cA vc cv cdif vv cv vb cv vc cv cA difeq2 eqeq2d
      3anbi123d cbvexv syl2anb adantl vu cv vv cv cin cvv wcel vu cv vv cv cin
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      wcel vb cv cA wss vb cv cfn wcel vu cv vv cv cin cA vb cv cdif wceq w3a
      vb wex wb vu cv vv cv vu visset inex1 vx cA vu cv vv cv cin cvv vb
      rcfpfillem1 ax-mp sylibr ex vu cv cvv wcel vv cv cvv wcel vu cv vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv cv
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      wcel wa vb cv cA wss vb cv cfn wcel vu cv cA vb cv cdif wceq w3a vb wex
      vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex wa wb vu
      visset vv visset vu cv cvv wcel vu cv vb cv cA wss vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb wex vx cab wcel vb cv cA wss vb cv cfn wcel vu
      cv cA vb cv cdif wceq w3a vb wex vv cv cvv wcel vv cv vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vb cv cA wss vb
      cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex vx cA vu cv cvv vb
      rcfpfillem1 vx cA vv cv cvv vb rcfpfillem1 bi2anan9 mp2an syl5ib
      r19.21aivv $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}

  ${
    $d A b x $.
    $( Lemma for ~ rcfpfil . $)
    rcfpfillem5 $p |- ( A e. B
         -> A e. { x | E. b ( b C_ A /\ b e. Fin /\ x = ( A \ b ) ) } ) $=
      cA cB wcel cA vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab wcel vb cv cA wss vb cv cfn wcel cA cA vb cv cdif wceq w3a vb
      wex c0 cvv wcel c0 cA wss c0 cfn wcel cA cA c0 cdif wceq w3a vb cv cA wss
      vb cv cfn wcel cA cA vb cv cdif wceq w3a vb wex 0ex c0 cA wss c0 cfn wcel
      cA cA c0 cdif wceq cA 0ss emfin cA c0 cin c0 wceq cA cA c0 cdif wceq cA
      in0 cA c0 disj3 mpbi 3pm3.2i vb cv cA wss vb cv cfn wcel cA cA vb cv cdif
      wceq w3a c0 cA wss c0 cfn wcel cA cA c0 cdif wceq w3a vb c0 cvv vb cv c0
      wceq vb cv cA wss c0 cA wss vb cv cfn wcel c0 cfn wcel cA cA vb cv cdif
      wceq cA cA c0 cdif wceq vb cv c0 cA sseq1 vb cv c0 cfn eleq1 vb cv c0
      wceq cA vb cv cdif cA c0 cdif cA vb cv c0 cA difeq2 eqeq2d 3anbi123d
      cla4egv mp2 vx cA cA cB vb rcfpfillem1 mpbiri $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}

  ${
    $d A b c u v x $.
    $( Lemma for ~ rcfpfil . $)
    rcfpfillem6 $p |- ( ( u e. { x | E. b ( b C_ A /\ b e. Fin
                 /\ x = ( A \ b ) ) } /\ v C_ A /\ u C_ v )
           -> v e. { x | E. b ( b C_ A /\ b e. Fin /\ x = ( A \ b ) ) } ) $=
      vu cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab wcel vv cv cA wss vu cv vv cv wss w3a vb cv cA wss vb cv cfn wcel vv
      cv cA vb cv cdif wceq w3a vb wex vv cv vb cv cA wss vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb wex vx cab wcel vu cv vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv cv cA wss vu cv
      vv cv wss vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex
      vu cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab wcel vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vc wex
      vv cv cA wss vu cv vv cv wss vb cv cA wss vb cv cfn wcel vv cv cA vb cv
      cdif wceq w3a vb wex wi wi vu cv cvv wcel vu cv vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vc cv cA wss vc cv
      cfn wcel vu cv cA vc cv cdif wceq w3a vc wex wb vu visset vu cv cvv wcel
      vu cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab wcel vb cv cA wss vb cv cfn wcel vu cv cA vb cv cdif wceq w3a vb wex
      vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vc wex vx cA vu
      cv cvv vb rcfpfillem1 vb cv cA wss vb cv cfn wcel vu cv cA vb cv cdif
      wceq w3a vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vb vc
      vb cv vc cv wceq vb cv cA wss vc cv cA wss vb cv cfn wcel vc cv cfn wcel
      vu cv cA vb cv cdif wceq vu cv cA vc cv cdif wceq vb cv vc cv cA sseq1 vb
      cv vc cv cfn eleq1 vb cv vc cv wceq cA vb cv cdif cA vc cv cdif vu cv vb
      cv vc cv cA difeq2 eqeq2d 3anbi123d cbvexv syl6bb ax-mp vc cv cA wss vc
      cv cfn wcel vu cv cA vc cv cdif wceq w3a vv cv cA wss vu cv vv cv wss vb
      cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex wi wi vc vc
      cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vv cv cA wss vu cv
      vv cv wss vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex
      vc cv vv cv vu cv cdif cdif cA wss vc cv vv cv vu cv cdif cdif cfn wcel
      vv cv cA vc cv vv cv vu cv cdif cdif cdif wceq vb cv cA wss vb cv cfn
      wcel vv cv cA vb cv cdif wceq w3a vb wex vc cv cA wss vc cv cfn wcel vu
      cv cA vc cv cdif wceq w3a vv cv cA wss vu cv vv cv wss w3a vb cv cA wss
      vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vc cv vv cv vu cv cdif cdif
      cA wss vc cv vv cv vu cv cdif cdif cfn wcel vv cv cA vc cv vv cv vu cv
      cdif cdif cdif wceq w3a vb vc cv vv cv vu cv cdif cdif vc cv cvv wcel vc
      cv vv cv vu cv cdif cdif cvv wcel vc visset vc cv vv cv vu cv cdif cvv
      difexg ax-mp vb cv vc cv vv cv vu cv cdif cdif wceq vb cv cA wss vc cv vv
      cv vu cv cdif cdif cA wss vb cv cfn wcel vc cv vv cv vu cv cdif cdif cfn
      wcel vv cv cA vb cv cdif wceq vv cv cA vc cv vv cv vu cv cdif cdif cdif
      wceq vb cv vc cv vv cv vu cv cdif cdif cA sseq1 vb cv vc cv vv cv vu cv
      cdif cdif cfn eleq1 vb cv vc cv vv cv vu cv cdif cdif wceq cA vb cv cdif
      cA vc cv vv cv vu cv cdif cdif cdif vv cv vb cv vc cv vv cv vu cv cdif
      cdif cA difeq2 eqeq2d 3anbi123d cla4ev vc cv cA wss vc cv cfn wcel vu cv
      cA vc cv cdif wceq w3a vv cv cA wss vc cv vv cv vu cv cdif cdif cA wss vu
      cv vv cv wss vc cv cA wss vc cv cfn wcel vc cv vv cv vu cv cdif cdif cA
      wss vu cv cA vc cv cdif wceq vc cv cA vv cv vu cv cdif ssdifss 3ad2ant1
      3ad2ant1 vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vv cv
      cA wss vc cv vv cv vu cv cdif cdif cfn wcel vu cv vv cv wss vc cv cfn
      wcel vc cv cA wss vc cv vv cv vu cv cdif cdif cfn wcel vu cv cA vc cv
      cdif wceq vc cv cfn wcel vc cv vv cv vu cv cdif cdif vc cv wss vc cv vv
      cv vu cv cdif cdif cfn wcel vc cv vv cv vu cv cdif difss vc cv vc cv vv
      cv vu cv cdif cdif ssfi mpan2 3ad2ant2 3ad2ant1 vc cv cA wss vc cv cfn
      wcel vu cv cA vc cv cdif wceq w3a vv cv cA wss vu cv vv cv wss vv cv cA
      vc cv vv cv vu cv cdif cdif cdif wceq vc cv cA wss vc cv cfn wcel vu cv
      cA vc cv cdif wceq w3a cA cA vv cv cdif cdif vv cv wceq vu cv vv cv wss
      vv cv cA vc cv vv cv vu cv cdif cdif cdif wceq wi vv cv cA wss cA cA vv
      cv cdif cdif vv cv wceq vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif
      wceq w3a vu cv vv cv wss vv cv cA vc cv vv cv vu cv cdif cdif cdif wceq
      wi vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vu cv vv cv
      wss vv cv cA vc cv vv cv vu cv cdif cdif cdif wceq wi wi vv cv cA cA vv
      cv cdif cdif vu cv vv cv wss vc cv cA wss vc cv cfn wcel vu cv cA vc cv
      cdif wceq w3a vv cv cA cA vv cv cdif cdif wceq vv cv cA vc cv vv cv vu cv
      cdif cdif cdif wceq vu cv vv cv wss vc cv cA wss vc cv cfn wcel vu cv cA
      vc cv cdif wceq w3a vv cv cA cA vv cv cdif cdif wceq vv cv cA vc cv vv cv
      vu cv cdif cdif cdif wceq wi vu cv vv cv wss vc cv cA wss vc cv cfn wcel
      vu cv cA vc cv cdif wceq w3a wa vv cv cA cA vv cv cdif cdif wceq vv cv cA
      vc cv vv cv vu cv cdif cdif cdif wceq vu cv vv cv wss vc cv cA wss vc cv
      cfn wcel vu cv cA vc cv cdif wceq w3a wa cA cA vv cv cdif cdif cA vc cv
      vv cv vu cv cdif cdif cdif vv cv vu cv vv cv wss vc cv cA wss vc cv cfn
      wcel vu cv cA vc cv cdif wceq w3a wa cA vv cv cdif vc cv vv cv vu cv cdif
      cdif cA vc cv cA wss vc cv cfn wcel vu cv cA vc cv cdif wceq w3a vu cv vv
      cv wss cA vv cv cdif vc cv vv cv vu cv cdif cdif wceq vc cv cA wss vc cv
      cfn wcel vu cv cA vc cv cdif wceq vu cv vv cv wss cA vv cv cdif vc cv vv
      cv vu cv cdif cdif wceq wi vc cv cA wss cA cA vc cv cdif cdif vc cv wceq
      vc cv cfn wcel vu cv cA vc cv cdif wceq vu cv vv cv wss cA vv cv cdif vc
      cv vv cv vu cv cdif cdif wceq wi wi wi vc cv cA dfss4 cA cA vc cv cdif
      cdif vc cv wceq vu cv cA vc cv cdif wceq vu cv vv cv wss cA vv cv cdif vc
      cv vv cv vu cv cdif cdif wceq wi wi vc cv cfn wcel vu cv cA vc cv cdif
      wceq cA cA vc cv cdif cdif vc cv wceq cA vu cv cdif vc cv wceq vu cv vv
      cv wss cA vv cv cdif vc cv vv cv vu cv cdif cdif wceq wi vu cv cA vc cv
      cdif wceq cA cA vc cv cdif cdif vc cv wceq cA vu cv cdif vc cv wceq vu cv
      cA vc cv cdif wceq cA cA vc cv cdif cdif cA vu cv cdif vc cv vu cv cA vc
      cv cdif wceq cA vu cv cdif cA cA vc cv cdif cdif vu cv cA vc cv cdif cA
      difeq2 eqcomd eqeq1d biimpd vu cv vv cv wss cA vu cv cdif vv cv vu cv
      cdif cdif vc cv vv cv vu cv cdif cdif wceq cA vv cv cdif vc cv vv cv vu
      cv cdif cdif wceq cA vu cv cdif vc cv wceq vu cv vv cv wss cA vu cv cdif
      vv cv vu cv cdif cdif cA vv cv cdif vc cv vv cv vu cv cdif cdif vu cv vv
      cv wss cA vu cv vv cv vu cv cdif cun cdif cA vv cv cdif cA vu cv cdif vv
      cv vu cv cdif cdif vu cv vv cv wss vu cv vv cv vu cv cdif cun vv cv wceq
      cA vu cv vv cv vu cv cdif cun cdif cA vv cv cdif wceq vu cv vv cv undif
      vu cv vv cv vu cv cdif cun vv cv cA difeq2 sylbi cA vu cv vv cv vu cv
      cdif difun1 syl5eqr eqeq1d cA vu cv cdif vc cv vv cv vu cv cdif difeq1
      syl5cbi syl6com a1d sylbi 3imp impcom difeq2d eqeq2d biimpd ex com13
      eqcoms com12 vv cv cA dfss4 syl5ib 3imp syl3anc 3exp 19.23aiv sylbi 3imp
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vb cv cA
      wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb wex vx vv cv vv visset
      vx cv vv cv wceq vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a
      vb cv cA wss vb cv cfn wcel vv cv cA vb cv cdif wceq w3a vb vx cv vv cv
      wceq vx cv cA vb cv cdif wceq vv cv cA vb cv cdif wceq vb cv cA wss vb cv
      cfn wcel vx cv vv cv cA vb cv cdif eqeq1 3anbi3d exbidv elab sylibr $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}

  ${
    $d A b u v x y $.  $d B b u v x $.
    $( Relative complements of the finite parts of an infinite set is a
       filter. When ` A = NN ` the set of the relative complements is called
       Frechet's filter and is used to define the concept of limit of
       a sequence. $)
    rcfpfil $p |- ( ( A e. B /\ -. A e. Fin )
          -> { x | E. b ( b C_ A /\ b e. Fin /\ x = ( A \ b ) ) } e. Fil ) $=
      cA cB wcel cA cfn wcel wn wa vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex vx cab cfil wcel c0 vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a vb wex vx cab wcel wn vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wa vu cv vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv
      cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      cuni wss vu cv vv cv wss w3a vv cv vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb wex vx cab wcel wi vv wal vu wal vu cv vv cv cin
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      wcel vv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex
      vx cab wral vu vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a
      vb wex vx cab wral w3a cA cB wcel cA cfn wcel wn wa c0 vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wn vb cv cA wss
      vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wa vu
      cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      wcel vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab cuni wss vu cv vv cv wss w3a vv cv vb cv cA wss vb cv cfn wcel
      vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wi vv wal vu wal vu cv vv
      cv cin vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab wcel vv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab wral vu vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb wex vx cab wral cA cB wcel cA cfn wcel wn wa c0 vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wn vb cv cA wss
      vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel cA cfn
      wcel wn c0 vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab wcel wn cA cB wcel vx cA vb rcfpfillem2 adantl cA cB wcel vb
      cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      wcel cA cfn wcel wn cA cB wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex vx cab cuni cA vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb wex vx cab vx cA cB vb rcfpfillem3 vx cA cB vb
      rcfpfillem5 eqeltrd adantr jca cA cB wcel cA cfn wcel wn wa vu cv vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv
      cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      cuni wss vu cv vv cv wss w3a vv cv vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb wex vx cab wcel wi vu vv vu cv vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv cv vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni wss vu
      cv vv cv wss w3a vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb wex vx cab wcel wi cA cB wcel cA cfn wcel wn wa vu cv vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv
      cv cA wss vu cv vv cv wss vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb
      cv cdif wceq w3a vb wex vx cab wcel vv cv vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a vb wex vx cab cuni wss vx vv vu cA vb
      rcfpfillem6 vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb wex vx cab cuni wss vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex vx cab cuni cA wss vv cv cA wss vb cv cA wss vb cv
      cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni cA wss vy cv cA
      wss vy vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab vy vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab cA unissb vy cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb wex vx cab wcel vb cv cA wss vb cv cfn wcel vy cv cA vb cv cdif
      wceq w3a vb wex vy cv cA wss vb cv cA wss vb cv cfn wcel vx cv cA vb cv
      cdif wceq w3a vb wex vb cv cA wss vb cv cfn wcel vy cv cA vb cv cdif wceq
      w3a vb wex vx vy cv vy visset vx cv vy cv wceq vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb cv cA wss vb cv cfn wcel vy cv cA vb
      cv cdif wceq w3a vb vx cv vy cv wceq vx cv cA vb cv cdif wceq vy cv cA vb
      cv cdif wceq vb cv cA wss vb cv cfn wcel vx cv vy cv cA vb cv cdif eqeq1
      3anbi3d exbidv elab vb cv cA wss vb cv cfn wcel vy cv cA vb cv cdif wceq
      w3a vy cv cA wss vb vy cv cA vb cv cdif wceq vb cv cA wss vy cv cA wss vb
      cv cfn wcel vy cv cA vb cv cdif wceq vy cv cA wss cA vb cv cdif cA wss cA
      vb cv difss vy cv cA vb cv cdif cA sseq1 mpbiri 3ad2ant3 19.23aiv sylbi
      mprgbir vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab cuni cA sstr2 mpi syl3an2 a1i 19.21aivv cA cB wcel vu cv vv cv
      cin vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab wcel vv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab wral vu vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb wex vx cab wral cA cfn wcel wn vx vv vu cA cB vb rcfpfillem4
      adantr 3jca cA cB wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb wex vx cab cfil wcel c0 vb cv cA wss vb cv cfn wcel vx cv cA
      vb cv cdif wceq w3a vb wex vx cab wcel wn vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a vb wex vx cab cuni vb cv cA wss vb cv cfn wcel
      vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wa vu cv vb cv cA wss vb
      cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv cv vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni wss
      vu cv vv cv wss w3a vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb wex vx cab wcel wi vv wal vu wal vu cv vv cv cin vb cv cA wss
      vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel vv vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wral vu
      vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab
      wral w3a wb cA cfn wcel wn cA cB wcel vb cv cA wss vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb wex vx cab cvv wcel vb cv cA wss vb cv cfn wcel
      vx cv cA vb cv cdif wceq w3a vb wex vx cab cfil wcel c0 vb cv cA wss vb
      cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wn vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cuni vb cv
      cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wa
      vu cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb wex vx
      cab wcel vv cv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a
      vb wex vx cab cuni wss vu cv vv cv wss w3a vv cv vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab wcel wi vv wal vu wal vu
      cv vv cv cin vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      wex vx cab wcel vv vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb wex vx cab wral vu vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb wex vx cab wral w3a wb cA cB wcel vb cv cA wss vb cv cfn wcel
      vx cv cA vb cv cdif wceq w3a vb vx copab crn cvv vb cv cA wss vb cv cfn
      wcel vx cv cA vb cv cdif wceq w3a vb wex vx cab cA cB wcel vb cv cA wss
      vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb vx copab cvv wcel vb cv cA
      wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb vx copab crn cvv wcel
      cA cB wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb vx
      copab vb cv cA cpw wcel vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb vx
      copab cvv cA cB wcel vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq
      w3a vb cv cA cpw wcel vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb vx
      cA cB wcel vb cv cA wss vb cv cA cpw wcel vb cv cfn wcel vx cv cA vb cv
      cdif wceq cA cB wcel vb cv cA cpw wcel vb cv cA wss vb cv cA cB elpw2g
      bicomd 3anbi1d opabbidv cA cB wcel vb cv cA cpw wcel vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb vx copab vb cv cA cpw wcel vx cv cA vb cv cdif
      wceq wa vb vx copab wss vb cv cA cpw wcel vx cv cA vb cv cdif wceq wa vb
      vx copab cvv wcel wa vb cv cA cpw wcel vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb vx copab cvv wcel cA cB wcel vb cv cA cpw wcel vx cv cA vb cv
      cdif wceq wa vb vx copab cvv wcel vb cv cA cpw wcel vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb vx copab vb cv cA cpw wcel vx cv cA vb cv cdif
      wceq wa vb vx copab wss cA cB wcel cA cpw cvv wcel vb cv cA cpw wcel vx
      cv cA vb cv cdif wceq wa vb vx copab cvv wcel cA cB pwexg vb vx cA cpw cA
      vb cv cdif cvv opabex2g syl vb cv cA cpw wcel vb cv cfn wcel vx cv cA vb
      cv cdif wceq w3a vb cv cA cpw wcel vx cv cA vb cv cdif wceq wa vb vx vb
      cv cA cpw wcel vb cv cfn wcel vx cv cA vb cv cdif wceq 3simpb ssopab2i
      jctil vb cv cA cpw wcel vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb vx
      copab vb cv cA cpw wcel vx cv cA vb cv cdif wceq wa vb vx copab cvv ssexg
      syl eqeltrd vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif wceq w3a vb
      vx copab cvv rnexg syl vb cv cA wss vb cv cfn wcel vx cv cA vb cv cdif
      wceq w3a vb vx rnopab syl5eqelr vu vv cvv vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a vb wex vx cab vb cv cA wss vb cv cfn wcel vx cv
      cA vb cv cdif wceq w3a vb wex vx cab cuni vb cv cA wss vb cv cfn wcel vx
      cv cA vb cv cdif wceq w3a vb wex vx cab cuni eqid isfil syl adantr mpbird
      $.
      $( [2-Sep-2008] $) $( [14-Jul-2008] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${ $d F a b l $. $d F a b x $. $d J a b l $. $d X a b l $.
     $d X a b x $.
    limfillem1.1 $e |- J e. Top $.
    limfillem1.2 $e |- X = U. J $.
    limfillem1.3 $e |- X = U. F $.
    $( Lemma for ~ plimfil . $)
    limfillem1 $p |- ( F e. Fil ->
      ( ( fLim1 ` J ) ` F ) =
        { l e. X | ( ( nei ` J ) ` { l } ) C_ F } ) $=
      cF cfil wcel cX cF cuni wceq cF cJ cflim1 cfv cfv vl cv csn cJ cnei cfv
      cfv cF wss vl cX crab wceq limfillem1.3 cF cfil wcel cX cF cuni wceq wa
      cF cX vx cv cuni wceq vx cfil crab wcel cF cJ cflim1 cfv cfv vl cv csn cJ
      cnei cfv cfv cF wss vl cX crab wceq cX vx cv cuni wceq cX cF cuni wceq vx
      cF cfil vx cv cF wceq vx cv cuni cF cuni cX vx cv cF unieq eqeq2d elrab
      va vb cF vl cv csn cJ cnei cfv cfv va cv wss vl cX crab vl cv csn cJ cnei
      cfv cfv cF wss vl cX crab cX vx cv cuni wceq vx cfil crab cJ cflim1 cfv
      va cv cF wceq vl cv csn cJ cnei cfv cfv va cv wss vl cv csn cJ cnei cfv
      cfv cF wss vl cX va cv cF vl cv csn cJ cnei cfv cfv sseq2 rabbisdv cJ
      cflim1 cfv va cv cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv
      cfv va cv wss vl cX crab wceq w3a va vb copab va cv cX vx cv cuni wceq vx
      cfil crab wcel vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq
      wa va vb copab cJ ctop wcel cJ cflim1 cfv va cv cfil wcel va cv cuni cX
      wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq w3a va vb
      copab wceq limfillem1.1 cJ cX va vb vl limfillem1.2 sfvlim ax-mp va cv
      cfil wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl
      cX crab wceq w3a va cv cX vx cv cuni wceq vx cfil crab wcel vb cv vl cv
      csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa va vb va cv cfil wcel va
      cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq
      w3a va cv cfil wcel va cv cuni cX wceq wa vb cv vl cv csn cJ cnei cfv cfv
      va cv wss vl cX crab wceq wa va cv cX vx cv cuni wceq vx cfil crab wcel
      vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX crab wceq wa va cv cfil
      wcel va cv cuni cX wceq vb cv vl cv csn cJ cnei cfv cfv va cv wss vl cX
      crab wceq df-3an va cv cfil wcel va cv cuni cX wceq wa va cv cX vx cv
      cuni wceq vx cfil crab wcel vb cv vl cv csn cJ cnei cfv cfv va cv wss vl
      cX crab wceq va cv cX vx cv cuni wceq vx cfil crab wcel va cv cfil wcel
      va cv cuni cX wceq wa cX vx cv cuni wceq va cv cuni cX wceq vx va cv cfil
      vx cv va cv wceq vx cv cuni cX wceq va cv cuni cX wceq cX vx cv cuni wceq
      vx cv va cv wceq vx cv cuni va cv cuni cX vx cv va cv unieq eqeq1d cX vx
      cv cuni eqcom syl5bb elrab bicomi anbi1i bitri opabbii eqtri vl cv csn cJ
      cnei cfv cfv cF wss vl cX cX cJ cuni cvv limfillem1.2 cJ ctop wcel cJ
      cuni cvv wcel limfillem1.1 cJ ctop uniexg ax-mp eqeltri rabex fvopab4
      sylbir mpan2 $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${ $d F l $. $d J l $. $d X l $.
    limfillem2.1 $e |- X = U. J $.
    limfillem2.2 $e |- X = U. F $.
    $( Lemma for ~ plimfil . $)
    limfillem2 $p |- ( ( J e. Top /\ F e. Fil ) ->
        ( ( fLim1 ` J ) ` F ) =
          { l e. X | ( ( nei ` J ) ` { l } ) C_ F } ) $=
      cJ ctop wcel cF cfil wcel cF cJ cflim1 cfv cfv vl cv csn cJ cnei cfv cfv
      cF wss vl cX crab wceq cJ ctop wcel cF cfil wcel cF cJ cflim1 cfv cfv vl
      cv csn cJ cnei cfv cfv cF wss vl cX crab wceq wi cF cfil wcel cF cJ ctop
      wcel cJ c0 c0 csn cpr cif cflim1 cfv cfv vl cv csn cJ ctop wcel cJ c0 c0
      csn cpr cif cnei cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni
      crab wceq wi cJ ctop wcel cF c0 csn csn cif cfil wcel cJ ctop wcel cF c0
      csn csn cif cJ ctop wcel cJ c0 c0 csn cpr cif cflim1 cfv cfv vl cv csn cJ
      ctop wcel cJ c0 c0 csn cpr cif cnei cfv cfv cJ ctop wcel cF c0 csn csn
      cif wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni crab wceq wi cJ cF c0
      c0 csn cpr c0 csn csn cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq cF cJ
      cflim1 cfv cfv vl cv csn cJ cnei cfv cfv cF wss vl cX crab wceq cF cJ
      ctop wcel cJ c0 c0 csn cpr cif cflim1 cfv cfv vl cv csn cJ ctop wcel cJ
      c0 c0 csn cpr cif cnei cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr
      cif cuni crab wceq cF cfil wcel cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq
      cF cJ cflim1 cfv cfv cF cJ ctop wcel cJ c0 c0 csn cpr cif cflim1 cfv cfv
      vl cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ ctop wcel cJ c0
      c0 csn cpr cif cnei cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr cif
      cuni crab cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq cF cJ cflim1 cfv cJ
      ctop wcel cJ c0 c0 csn cpr cif cflim1 cfv cJ cJ ctop wcel cJ c0 c0 csn
      cpr cif cflim1 fveq2 fveq1d cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq vl
      cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv cfv cF wss
      vl cJ cuni crab vl cv csn cJ cnei cfv cfv cF wss vl cJ ctop wcel cJ c0 c0
      csn cpr cif cuni crab vl cv csn cJ ctop wcel cJ c0 c0 csn cpr cif cnei
      cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni crab vl cv csn
      cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv cfv cF wss vl cJ
      cuni crab wceq cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq cX cJ cuni wceq
      vl cv csn cJ cnei cfv cfv cF wss vl cX crab vl cv csn cJ cnei cfv cfv cF
      wss vl cJ cuni crab wceq limfillem2.1 vl cv csn cJ cnei cfv cfv cF wss vl
      cX cJ cuni rabeq ax-mp a1i cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq cJ
      cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni wceq vl cv csn cJ cnei cfv
      cfv cF wss vl cJ cuni crab vl cv csn cJ cnei cfv cfv cF wss vl cJ ctop
      wcel cJ c0 c0 csn cpr cif cuni crab wceq cJ cJ ctop wcel cJ c0 c0 csn cpr
      cif unieq vl cv csn cJ cnei cfv cfv cF wss vl cJ cuni cJ ctop wcel cJ c0
      c0 csn cpr cif cuni rabeq syl cJ cJ ctop wcel cJ c0 c0 csn cpr cif wceq
      vl cv csn cJ cnei cfv cfv cF wss vl cv csn cJ ctop wcel cJ c0 c0 csn cpr
      cif cnei cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ cJ
      ctop wcel cJ c0 c0 csn cpr cif wceq vl cv csn cJ cnei cfv cfv vl cv csn
      cJ ctop wcel cJ c0 c0 csn cpr cif cnei cfv cfv cF cJ cJ ctop wcel cJ c0
      c0 csn cpr cif wceq vl cv csn cJ cnei cfv cJ ctop wcel cJ c0 c0 csn cpr
      cif cnei cfv cJ cJ ctop wcel cJ c0 c0 csn cpr cif cnei fveq2 fveq1d
      sseq1d rabbisdv 3eqtrd eqeq12d imbi2d cF cJ ctop wcel cF c0 csn csn cif
      wceq cF cfil wcel cJ ctop wcel cF c0 csn csn cif cfil wcel cF cJ ctop
      wcel cJ c0 c0 csn cpr cif cflim1 cfv cfv vl cv csn cJ ctop wcel cJ c0 c0
      csn cpr cif cnei cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni
      crab wceq cJ ctop wcel cF c0 csn csn cif cJ ctop wcel cJ c0 c0 csn cpr
      cif cflim1 cfv cfv vl cv csn cJ ctop wcel cJ c0 c0 csn cpr cif cnei cfv
      cfv cJ ctop wcel cF c0 csn csn cif wss vl cJ ctop wcel cJ c0 c0 csn cpr
      cif cuni crab wceq cF cJ ctop wcel cF c0 csn csn cif cfil eleq1 cF cJ
      ctop wcel cF c0 csn csn cif wceq cF cJ ctop wcel cJ c0 c0 csn cpr cif
      cflim1 cfv cfv cJ ctop wcel cF c0 csn csn cif cJ ctop wcel cJ c0 c0 csn
      cpr cif cflim1 cfv cfv vl cv csn cJ ctop wcel cJ c0 c0 csn cpr cif cnei
      cfv cfv cF wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni crab vl cv csn
      cJ ctop wcel cJ c0 c0 csn cpr cif cnei cfv cfv cJ ctop wcel cF c0 csn csn
      cif wss vl cJ ctop wcel cJ c0 c0 csn cpr cif cuni crab cF cJ ctop wcel cF
      c0 csn csn cif cJ ctop wcel cJ c0 c0 csn cpr cif cflim1 cfv fveq2 cF cJ
      ctop wcel cF c0 csn csn cif wceq vl cv csn cJ ctop wcel cJ c0 c0 csn cpr
      cif cnei cfv cfv cF wss vl cv csn cJ ctop wcel cJ c0 c0 csn cpr cif cnei
      cfv cfv cJ ctop wcel cF c0 csn csn cif wss vl cJ ctop wcel cJ c0 c0 csn
      cpr cif cuni cF cJ ctop wcel cF c0 csn csn cif vl cv csn cJ ctop wcel cJ
      c0 c0 csn cpr cif cnei cfv cfv sseq2 rabbisdv eqeq12d imbi12d cJ ctop
      wcel cF c0 csn csn cif cJ ctop wcel cJ c0 c0 csn cpr cif cJ ctop wcel cJ
      c0 c0 csn cpr cif cuni vl cJ c0 c0 csn cpr ctop c0 csn indistop elimel cJ
      ctop wcel cJ c0 c0 csn cpr cif cuni eqid cJ ctop wcel cJ ctop wcel cJ c0
      c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni wceq cJ cJ ctop
      wcel cJ c0 c0 csn cpr cif wceq cF cJ ctop wcel cF c0 csn csn cif wceq cJ
      ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni
      wceq cJ ctop wcel cJ cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni wceq cF
      cuni cJ ctop wcel cF c0 csn csn cif cuni wceq cJ ctop wcel cJ c0 c0 csn
      cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni wceq cJ cJ ctop wcel cJ
      c0 c0 csn cpr cif wceq cF cJ ctop wcel cF c0 csn csn cif wceq cJ cuni cJ
      ctop wcel cJ c0 c0 csn cpr cif cuni wceq cF cuni cJ ctop wcel cF c0 csn
      csn cif cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF
      c0 csn csn cif cuni wceq cF cuni cJ cuni wceq cJ cuni cJ ctop wcel cJ c0
      c0 csn cpr cif cuni wceq cF cuni cJ ctop wcel cF c0 csn csn cif cuni wceq
      cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif
      cuni wceq wi cX cF cuni cJ cuni limfillem2.2 limfillem2.1 eqtr3i cF cuni
      cJ cuni wceq cJ cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni wceq wa cF
      cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni wceq cF cuni cJ ctop wcel cF
      c0 csn csn cif cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop
      wcel cF c0 csn csn cif cuni wceq wi cF cuni cJ cuni cJ ctop wcel cJ c0 c0
      csn cpr cif cuni eqtr cF cuni cJ ctop wcel cF c0 csn csn cif cuni wceq cJ
      ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni
      wceq wi cJ ctop wcel cJ c0 c0 csn cpr cif cuni cF cuni cJ ctop wcel cJ c0
      c0 csn cpr cif cuni cF cuni wceq cF cuni cJ ctop wcel cF c0 csn csn cif
      cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn
      csn cif cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cF cuni cJ ctop
      wcel cF c0 csn csn cif cuni eqtr ex eqcoms syl mpan imp cJ cJ ctop wcel
      cJ c0 c0 csn cpr cif unieq cF cJ ctop wcel cF c0 csn csn cif unieq syl2an
      cJ ctop wcel cJ ctop wcel cJ c0 c0 csn cpr cif cJ cJ ctop wcel cJ c0 c0
      csn cpr iftrue eqcomd cJ ctop wcel cJ ctop wcel cF c0 csn csn cif cF cJ
      ctop wcel cF c0 csn csn iftrue eqcomd sylanc cJ ctop wcel cJ c0 c0 csn
      cpr cif c0 c0 csn cpr wceq cJ ctop wcel cF c0 csn csn cif c0 csn csn wceq
      cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif
      cuni wceq cJ ctop wcel wn cJ ctop wcel cJ c0 c0 csn cpr cif cuni c0 c0
      csn cpr cuni wceq cJ ctop wcel cF c0 csn csn cif cuni c0 csn csn cuni
      wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn
      cif cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif c0 c0 csn cpr wceq cJ
      ctop wcel cF c0 csn csn cif c0 csn csn wceq c0 c0 csn cpr cuni c0 csn csn
      cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni c0 c0 csn cpr cuni wceq
      cJ ctop wcel cF c0 csn csn cif cuni c0 csn csn cuni wceq wa cJ ctop wcel
      cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni wceq wi c0
      c0 csn cpr cuni c0 c0 csn cun c0 csn csn cuni c0 c0 csn 0ex p0ex unipr c0
      csn c0 cun c0 csn c0 c0 csn cun c0 csn csn cuni c0 csn un0 c0 c0 csn
      uncom c0 csn p0ex unisn 3eqtr4i eqtri c0 c0 csn cpr cuni c0 csn csn cuni
      wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni c0 c0 csn cpr cuni wceq cJ
      ctop wcel cF c0 csn csn cif cuni c0 csn csn cuni wceq cJ ctop wcel cJ c0
      c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni wceq cJ ctop wcel
      cJ c0 c0 csn cpr cif cuni c0 c0 csn cpr cuni wceq c0 c0 csn cpr cuni c0
      csn csn cuni wceq cJ ctop wcel cF c0 csn csn cif cuni c0 csn csn cuni
      wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn
      cif cuni wceq wi cJ ctop wcel cJ c0 c0 csn cpr cif cuni c0 c0 csn cpr
      cuni wceq c0 c0 csn cpr cuni c0 csn csn cuni wceq wa cJ ctop wcel cJ c0
      c0 csn cpr cif cuni c0 csn csn cuni wceq cJ ctop wcel cF c0 csn csn cif
      cuni c0 csn csn cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop
      wcel cF c0 csn csn cif cuni wceq wi cJ ctop wcel cJ c0 c0 csn cpr cif
      cuni c0 c0 csn cpr cuni c0 csn csn cuni eqtr cJ ctop wcel cF c0 csn csn
      cif cuni c0 csn csn cuni wceq cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ
      ctop wcel cF c0 csn csn cif cuni wceq wi c0 csn csn cuni cJ ctop wcel cJ
      c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni c0 csn csn
      cuni wceq c0 csn csn cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni wceq cJ
      ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF c0 csn csn cif cuni
      wceq cJ ctop wcel cF c0 csn csn cif cuni c0 csn csn cuni wceq c0 csn csn
      cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni wceq wa cJ ctop wcel cF c0
      csn csn cif cuni cJ ctop wcel cJ c0 c0 csn cpr cif cuni cJ ctop wcel cF
      c0 csn csn cif cuni c0 csn csn cuni cJ ctop wcel cJ c0 c0 csn cpr cif
      cuni eqtr eqcomd expcom eqcoms syl expcom imp3a ax-mp cJ ctop wcel cJ c0
      c0 csn cpr cif c0 c0 csn cpr unieq cJ ctop wcel cF c0 csn csn cif c0 csn
      csn unieq syl2an cJ ctop wcel cJ c0 c0 csn cpr iffalse cJ ctop wcel cF c0
      csn csn iffalse sylanc pm2.61i limfillem1 dedth2v imp $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${ $d F l $. $d J l $. $d L l $. $d X l $.
    plimfil.1 $e |- X = U. J $.
    plimfil.2 $e |- X = U. F $.
    $( The predicate "is a limit of a filter". $)
    plimfil $p |-  ( ( J e. Top /\ F e. Fil /\ L e. X ) ->
    ( L e. ( ( fLim1 ` J ) ` F ) <-> ( ( nei ` J ) ` { L } ) C_ F ) ) $=
      cJ ctop wcel cF cfil wcel cL cX wcel cL cF cJ cflim1 cfv cfv wcel cL csn
      cJ cnei cfv cfv cF wss cJ ctop wcel cF cfil wcel cL cF cJ cflim1 cfv cfv
      wcel cL cX wcel cL csn cJ cnei cfv cfv cF wss wa wb cL cX wcel cJ ctop
      wcel cF cfil wcel wa cL cF cJ cflim1 cfv cfv wcel cL vl cv csn cJ cnei
      cfv cfv cF wss vl cX crab wcel cL cX wcel cL csn cJ cnei cfv cfv cF wss
      wa cJ ctop wcel cF cfil wcel wa cF cJ cflim1 cfv cfv vl cv csn cJ cnei
      cfv cfv cF wss vl cX crab cL cF cJ cX vl plimfil.1 plimfil.2 limfillem2
      eleq2d vl cv csn cJ cnei cfv cfv cF wss cL csn cJ cnei cfv cfv cF wss vl
      cL cX vl cv cL wceq vl cv csn cJ cnei cfv cfv cL csn cJ cnei cfv cfv cF
      vl cv cL wceq vl cv csn cL csn cJ cnei cfv vl cv cL sneq fveq2d sseq1d
      elrab syl6bb 3adant3 ompfl3 $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${
    $d F a $. $d J a $. $d L a $. $d X a $. $d Y a $.
    limvinlv.1 $e |- X = U. J $.
    limvinlv.2 $e |- Y = U. L $.
    limvinlv.3 $e |- A = U. ( ( J fLimf L ) ` F ) $.
    $( The limit value of a convergent function whose values are in a
       Hausdorff space belongs to the set of the limit values. $)
    limvinlv $p |- ( ( ( J e. Haus /\ L e. Fil /\ F : Y --> X ) /\
         ( ( J fLimf L ) ` F ) =/= (/) )
         -> A e. ( ( J fLimf L ) ` F ) ) $=
      va cv cF cJ cL cflimf co cfv wcel va weu cJ cha wcel cL cfil wcel cY cX
      cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf co cfv wcel
      cJ cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne cL
      cfil wcel cJ cha wcel cY cX cF wf w3a va cv cF cJ cL cflimf co cfv wcel
      va weu cJ cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0
      wne wa cL cfil wcel cJ cha wcel cY cX cF wf cJ cha wcel cL cfil wcel cY
      cX cF wf cF cJ cL cflimf co cfv c0 wne 3simpl2 cJ cha wcel cL cfil wcel
      cY cX cF wf cF cJ cL cflimf co cfv c0 wne 3simpl1 cJ cha wcel cL cfil
      wcel cY cX cF wf cF cJ cL cflimf co cfv c0 wne 3simpl3 3jca va cF cJ cL
      cX cY limvinlv.2 limvinlv.1 holimf2 sylancom va cv cF cJ cL cflimf co cfv
      wcel va weu va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv
      wreu cJ cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0
      wne wa cA cF cJ cL cflimf co cfv wcel wi va cv cF cJ cL cflimf co cfv
      wcel va weu va cv cF cJ cL cflimf co cfv wcel va cv cF cJ cL cflimf co
      cfv wcel wa va weu va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf
      co cfv wreu va cv cF cJ cL cflimf co cfv wcel va cv cF cJ cL cflimf co
      cfv wcel va cv cF cJ cL cflimf co cfv wcel wa va va cv cF cJ cL cflimf co
      cfv wcel pm4.24 eubii va cv cF cJ cL cflimf co cfv wcel va cF cJ cL
      cflimf co cfv df-reu bitr4i cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv
      cin va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab wceq
      va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab va cv cF
      cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ
      cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA
      cF cJ cL cflimf co cfv wcel wi va cv cF cJ cL cflimf co cfv wcel va cF cJ
      cL cflimf co cfv wreu cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin
      va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab wceq va
      cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab va cv cF cJ
      cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq wa cF
      cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin va cv cF cJ cL cflimf co
      cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha wcel cL cfil
      wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf
      co cfv wcel wi cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin va cv cF
      cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab va cv cF cJ cL
      cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn eqtr cF cJ cL
      cflimf co cfv cF cJ cL cflimf co cfv cin cF cJ cL cflimf co cfv wceq cF
      cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin va cv cF cJ cL cflimf co
      cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha wcel cL cfil
      wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf
      co cfv wcel wi wi cF cJ cL cflimf co cfv inidm cF cJ cL cflimf co cfv cF
      cJ cL cflimf co cfv cin va cv cF cJ cL cflimf co cfv wcel va cF cJ cL
      cflimf co cfv crab cuni csn wceq cJ cha wcel cL cfil wcel cY cX cF wf w3a
      cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf co cfv wcel wi wi cF
      cJ cL cflimf co cfv cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin cF
      cJ cL cflimf co cfv cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin
      wceq cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin va cv cF cJ cL
      cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha
      wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF
      cJ cL cflimf co cfv wcel wi cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv
      cF cJ cL cflimf co cfv cin wceq cF cJ cL cflimf co cfv cF cJ cL cflimf co
      cfv cin va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab
      cuni csn wceq wa cF cJ cL cflimf co cfv va cv cF cJ cL cflimf co cfv wcel
      va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha wcel cL cfil wcel cY
      cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf co cfv
      wcel wi cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cF cJ cL cflimf co
      cfv cin va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab
      cuni csn eqtr cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin cF cJ cL
      cflimf co cfv wceq cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin va
      cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab wceq cF cJ
      cL cflimf co cfv va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co
      cfv crab cuni csn wceq cJ cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL
      cflimf co cfv c0 wne wa cA cF cJ cL cflimf co cfv wcel wi wi cF cJ cL
      cflimf co cfv inidm va cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv
      dfin5 cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin va cv cF cJ cL
      cflimf co cfv wcel va cF cJ cL cflimf co cfv crab wceq cF cJ cL cflimf co
      cfv va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni
      csn wceq cJ cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv
      c0 wne wa cA cF cJ cL cflimf co cfv wcel wi wi wi cF cJ cL cflimf co cfv
      cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin cF cJ cL cflimf co cfv
      cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cin wceq cF cJ cL cflimf co
      cfv cF cJ cL cflimf co cfv cin va cv cF cJ cL cflimf co cfv wcel va cF cJ
      cL cflimf co cfv crab wceq cF cJ cL cflimf co cfv va cv cF cJ cL cflimf
      co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha wcel cL
      cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL
      cflimf co cfv wcel wi wi cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cF
      cJ cL cflimf co cfv cin wceq cF cJ cL cflimf co cfv cF cJ cL cflimf co
      cfv cin va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab
      wceq wa cF cJ cL cflimf co cfv va cv cF cJ cL cflimf co cfv wcel va cF cJ
      cL cflimf co cfv crab wceq cF cJ cL cflimf co cfv va cv cF cJ cL cflimf
      co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha wcel cL
      cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL
      cflimf co cfv wcel wi wi cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cF
      cJ cL cflimf co cfv cin va cv cF cJ cL cflimf co cfv wcel va cF cJ cL
      cflimf co cfv crab eqtr cF cJ cL cflimf co cfv va cv cF cJ cL cflimf co
      cfv wcel va cF cJ cL cflimf co cfv crab wceq cF cJ cL cflimf co cfv cuni
      va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni
      wceq cF cJ cL cflimf co cfv va cv cF cJ cL cflimf co cfv wcel va cF cJ cL
      cflimf co cfv crab cuni csn wceq cJ cha wcel cL cfil wcel cY cX cF wf w3a
      cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf co cfv wcel wi wi cF
      cJ cL cflimf co cfv va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf
      co cfv crab unieq cF cJ cL cflimf co cfv cuni va cv cF cJ cL cflimf co
      cfv wcel va cF cJ cL cflimf co cfv crab cuni wceq cF cJ cL cflimf co cfv
      cuni csn va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab
      cuni csn wceq cF cJ cL cflimf co cfv va cv cF cJ cL cflimf co cfv wcel va
      cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha wcel cL cfil wcel cY cX
      cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cflimf co cfv wcel
      wi wi cF cJ cL cflimf co cfv cuni va cv cF cJ cL cflimf co cfv wcel va cF
      cJ cL cflimf co cfv crab cuni sneq cF cJ cL cflimf co cfv va cv cF cJ cL
      cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn wceq cJ cha
      wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF
      cJ cL cflimf co cfv wcel wi wi va cv cF cJ cL cflimf co cfv wcel va cF cJ
      cL cflimf co cfv crab cuni csn cF cJ cL cflimf co cfv cuni csn cF cJ cL
      cflimf co cfv va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv
      crab cuni csn wceq va cv cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf
      co cfv crab cuni csn cF cJ cL cflimf co cfv cuni csn wceq cJ cha wcel cL
      cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL
      cflimf co cfv wcel wi cF cJ cL cflimf co cfv va cv cF cJ cL cflimf co cfv
      wcel va cF cJ cL cflimf co cfv crab cuni csn wceq va cv cF cJ cL cflimf
      co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn cF cJ cL cflimf co
      cfv cuni csn wceq wa cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv cuni
      csn wceq cJ cha wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cflimf co cfv
      c0 wne wa cA cF cJ cL cflimf co cfv wcel wi cF cJ cL cflimf co cfv va cv
      cF cJ cL cflimf co cfv wcel va cF cJ cL cflimf co cfv crab cuni csn cF cJ
      cL cflimf co cfv cuni csn eqtr cF cJ cL cflimf co cfv cF cJ cL cflimf co
      cfv cuni csn wceq cA cF cJ cL cflimf co cfv wcel cJ cha wcel cL cfil wcel
      cY cX cF wf w3a cF cJ cL cflimf co cfv c0 wne wa cF cJ cL cflimf co cfv
      cF cJ cL cflimf co cfv cuni csn wceq cF cJ cL cflimf co cfv cuni cF cJ cL
      cflimf co cfv cuni csn wcel cA cF cJ cL cflimf co cfv wcel cF cJ cL
      cflimf co cfv cuni cF cJ cL cflimf co cfv cF cJ cL cflimf co fvex uniex
      snid cF cJ cL cflimf co cfv cuni cF cJ cL cflimf co cfv cuni csn wcel cA
      cF cJ cL cflimf co cfv wcel wi cF cJ cL cflimf co cfv cuni csn cF cJ cL
      cflimf co cfv cF cJ cL cflimf co cfv cuni csn cF cJ cL cflimf co cfv wceq
      cF cJ cL cflimf co cfv cuni cF cJ cL cflimf co cfv cuni csn wcel cF cJ cL
      cflimf co cfv cuni cF cJ cL cflimf co cfv wcel cA cF cJ cL cflimf co cfv
      wcel cF cJ cL cflimf co cfv cuni csn cF cJ cL cflimf co cfv cF cJ cL
      cflimf co cfv cuni eleq2 cA cF cJ cL cflimf co cfv cuni wceq cF cJ cL
      cflimf co cfv cuni cF cJ cL cflimf co cfv wcel cA cF cJ cL cflimf co cfv
      wcel wi limvinlv.3 cF cJ cL cflimf co cfv cuni cF cJ cL cflimf co cfv
      wcel cA cF cJ cL cflimf co cfv wcel wi cF cJ cL cflimf co cfv cuni cA cF
      cJ cL cflimf co cfv cuni cA wceq cF cJ cL cflimf co cfv cuni cF cJ cL
      cflimf co cfv wcel cA cF cJ cL cflimf co cfv wcel cF cJ cL cflimf co cfv
      cuni cA cF cJ cL cflimf co cfv eleq1 biimpd eqcoms ax-mp syl6bi eqcoms
      mpi a1d syl expcom eqcoms syl syl syl ex eqcoms mp2 syl ex eqcoms ax-mp
      syl va cF cJ cL cflimf co cfv cF cJ cL cflimf co cfv dfin5 va cv cF cJ cL
      cflimf co cfv wcel va cF cJ cL cflimf co cfv reuunisn sylancr sylbi mpcom
      $.
      $( [6-Dec-2010] $) $( [14-Nov-2010] $)
  $}

  ${
    $d F s $. $d L s $. $d N s $. $d X s $. $d Y s $.
    flimfneih.1 $e |- X = U. J $.
    flimfneih.2 $e |- Y = U. L $.
    flimfneih.3 $e |- A = U. ( ( J fLimf L ) ` F ) $.
    $( A neighborhood of the limit value of a convergent function whose
       values are in a Hausdorff space
       contains the image of a filter element. $)
    flimfneih $p |- ( ( ( J e. Haus /\ L e. Fil /\ F : Y --> X )
       /\ ( ( J fLimf L ) ` F ) =/= (/)
       /\ N e. ( ( nei ` J ) ` { A } ) ) -> E. s e. L ( F " s ) C_ N  ) $=
      cJ cha wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel
      cN cA csn cJ cnei cfv cfv wcel cF vs cv cima cN wss vs cL wrex cF cJ cL
      cflimf co cfv c0 wne cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ
      cL cflimf co cfv wcel cN cA csn cJ cnei cfv cfv wcel cF vs cv cima cN wss
      vs cL wrex cJ cha wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cN cX cY
      vs flimfneih.1 flimfneih.2 flimfneii cJ cha wcel cJ ctop wcel cL cfil
      wcel cY cX cF wf cJ haustop 3anim1i syl3an1 cJ cha wcel cL cfil wcel cY
      cX cF wf w3a cF cJ cL cflimf co cfv c0 wne cA cF cJ cL cflimf co cfv wcel
      cN cA csn cJ cnei cfv cfv wcel cA cF cJ cL cX cY flimfneih.1 flimfneih.2
      flimfneih.3 limvinlv 3adant3 syld3an2 $.
      $( [6-Dec-2010] $) $( [18-Nov-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Separated spaces: T0, T1, T2 (Hausdorff) ...
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.
    dtopcl.1 $e |- A e. _V $.
    $( The open sets of a discrete topology are closed and its closed sets
       are open. $)
    dtopcl $p |- ~P A = ( Clsd ` ~P A ) $=
      vx cA cpw cA cpw ccld cfv cA cpw ctop wcel vx cv cA cpw wcel vx cv cA cpw
      ccld cfv wcel wb cA dtopcl.1 distop cA cpw ctop wcel vx cv cA cpw ccld
      cfv wcel vx cv cA cpw cuni wss cA cpw cuni vx cv cdif cA cpw wcel wa vx
      cv cA cpw wcel vx cv cA cpw cA cpw cuni cA cpw cuni eqid iscld vx cv cA
      cpw cuni wss cA cpw cuni vx cv cdif cA cpw wcel wa vx cv cA cpw wcel vx
      cv cA cpw cuni wss vx cv cA cpw wcel cA cpw cuni vx cv cdif cA cpw wcel
      vx cv cA cpw cuni wss vx cv cA wss vx cv cA cpw wcel vx cv cA cpw cuni
      wss vx cv cA wss cA cpw cuni cA vx cv cA unipw sseq2i biimpi vx cv cA
      dtopcl.1 elpw2 sylibr adantr vx cv cA cpw wcel vx cv cA cpw cuni wss cA
      cpw cuni vx cv cdif cA cpw wcel vx cv cA cpw elssuni cA cpw cuni vx cv
      cdif cA cpw wcel cA cpw cuni vx cv cdif cA wss cA cpw cuni vx cv cdif cA
      cpw cuni cA cA cpw cuni vx cv difss cA unipw sseqtri cA cpw cuni vx cv
      cdif cA dtopcl.1 elpw2 mpbir jctir impbii syl6rbb ax-mp eqriv $.
      $( [18-Jun-2007] $) $( [7-Jun-2007] $)
  $}

  ${
    $d J x $.
    $( A Hausdorff space is a T1 space. $)
    t2t1 $p |- ( J e. Haus -> J e. Fre ) $=
      cJ cha wcel cJ ctop wcel vx cv csn cJ ccld cfv wcel vx cJ cuni wral wa cJ
      ct1 wcel cJ cha wcel cJ ctop wcel vx cv csn cJ ccld cfv wcel vx cJ cuni
      wral cJ haustop cJ cha wcel vx cv csn cJ ccld cfv wcel vx cJ cuni vx cv
      cJ cJ cuni cJ cuni eqid sncld r19.21aiva jca cJ cJ cuni vx cJ cuni eqid
      ist1 sylibr $.
      $( [18-Jun-2007] $) $( [11-Jun-2007] $)
  $}

  $( A Hausdorff space is a T1 space. $)
  hst1 $p |- Haus C_ Fre $=
    cha ct1 wss vx cv cha wcel vx cv ct1 wcel wi vx vx cha ct1 dfss2 vx cv t2t1
    mpgbir $.
    $( [20-Jul-2007] $) $( [18-Jun-2007] $)

  ${
    $d A u v x y $.
    dtt2.1 $e |- A e. _V $.
    $( A discrete topology is Hausdorff.  Morris, Topology without tears,
       p.72, ex. 13. $)
    dtt2 $p |- ~P A e. Haus $=
      cA cpw cha wcel cA cpw ctop wcel vx cv vy cv wne vx cv vu cv wcel vy cv
      vv cv wcel vu cv vv cv cin c0 wceq w3a vv cA cpw wrex vu cA cpw wrex wi
      vy cA cpw cuni wral vx cA cpw cuni wral vx vy vv vu cA cpw cA cpw cuni cA
      cpw cuni eqid ishaus cA dtt2.1 distop vx cv vy cv wne vx cv vu cv wcel vy
      cv vv cv wcel vu cv vv cv cin c0 wceq w3a vv cA cpw wrex vu cA cpw wrex
      wi vx vy cA cpw cuni vx cv cA cpw cuni wcel vy cv cA cpw cuni wcel wa vx
      cv vy cv wne vx cv vu cv wcel vy cv vv cv wcel vu cv vv cv cin c0 wceq
      w3a wi vv cA cpw wrex vu cA cpw wrex vx cv vy cv wne vx cv vu cv wcel vy
      cv vv cv wcel vu cv vv cv cin c0 wceq w3a vv cA cpw wrex wi vu cA cpw
      wrex vx cv vy cv wne vx cv vu cv wcel vy cv vv cv wcel vu cv vv cv cin c0
      wceq w3a vv cA cpw wrex vu cA cpw wrex wi vx cv cA cpw cuni wcel vy cv cA
      cpw cuni wcel wa vx cv vy cv wne vx cv vx cv csn wcel vy cv vy cv csn
      wcel vx cv csn vy cv csn cin c0 wceq w3a wi vx cv vy cv wne vx cv vu cv
      wcel vy cv vv cv wcel vu cv vv cv cin c0 wceq w3a wi vv cA cpw wrex vu cA
      cpw wrex vx cv vy cv wne vx cv vx cv csn wcel vy cv vy cv csn wcel vx cv
      csn vy cv csn cin c0 wceq vx cv vx cv csn wcel vx cv vy cv wne vx cv vx
      visset snid a1i vy cv vy cv csn wcel vx cv vy cv wne vy cv vy visset snid
      a1i vx cv vy cv disjsn2 3jca vx cv csn cA cpw wcel vy cv csn cA cpw wcel
      vx cv vy cv wne vx cv vx cv csn wcel vy cv vy cv csn wcel vx cv csn vy cv
      csn cin c0 wceq w3a wi vx cv vy cv wne vx cv vu cv wcel vy cv vv cv wcel
      vu cv vv cv cin c0 wceq w3a wi vv cA cpw wrex vu cA cpw wrex wi vx cv cA
      cpw cuni wcel vy cv cA cpw cuni wcel vx cv csn cA cpw wcel vy cv csn cA
      cpw wcel vx cv vy cv wne vx cv vx cv csn wcel vy cv vy cv csn wcel vx cv
      csn vy cv csn cin c0 wceq w3a wi vx cv vy cv wne vx cv vu cv wcel vy cv
      vv cv wcel vu cv vv cv cin c0 wceq w3a wi vv cA cpw wrex vu cA cpw wrex
      vx cv vy cv wne vx cv vu cv wcel vy cv vv cv wcel vu cv vv cv cin c0 wceq
      w3a wi vx cv vy cv wne vx cv vx cv csn wcel vy cv vy cv csn wcel vx cv
      csn vy cv csn cin c0 wceq w3a wi vx cv vy cv wne vx cv vx cv csn wcel vy
      cv vv cv wcel vx cv csn vv cv cin c0 wceq w3a wi vu vv vx cv csn vy cv
      csn cA cpw cA cpw vu cv vx cv csn wceq vx cv vu cv wcel vy cv vv cv wcel
      vu cv vv cv cin c0 wceq w3a vx cv vx cv csn wcel vy cv vv cv wcel vx cv
      csn vv cv cin c0 wceq w3a vx cv vy cv wne vu cv vx cv csn wceq vx cv vu
      cv wcel vx cv vx cv csn wcel vu cv vv cv cin c0 wceq vx cv csn vv cv cin
      c0 wceq vy cv vv cv wcel vu cv vx cv csn vx cv eleq2 vu cv vx cv csn wceq
      vu cv vv cv cin vx cv csn vv cv cin c0 vu cv vx cv csn vv cv ineq1 eqeq1d
      3anbi13d imbi2d vv cv vy cv csn wceq vx cv vx cv csn wcel vy cv vv cv
      wcel vx cv csn vv cv cin c0 wceq w3a vx cv vx cv csn wcel vy cv vy cv csn
      wcel vx cv csn vy cv csn cin c0 wceq w3a vx cv vy cv wne vv cv vy cv csn
      wceq vy cv vv cv wcel vy cv vy cv csn wcel vx cv csn vv cv cin c0 wceq vx
      cv csn vy cv csn cin c0 wceq vx cv vx cv csn wcel vv cv vy cv csn vy cv
      eleq2 vv cv vy cv csn wceq vx cv csn vv cv cin vx cv csn vy cv csn cin c0
      vv cv vy cv csn vx cv csn ineq2 eqeq1d 3anbi23d imbi2d rcla42ev 3expia vx
      cv cA cpw cuni wcel vx cv cA wcel vx cv csn cA cpw wcel vx cv cA cpw cuni
      wcel vx cv cA wcel cA cpw cuni cA vx cv cA unipw eleq2i biimpi vx cv cA
      vx visset snelpw sylib vy cv cA cpw cuni wcel vy cv cA wcel vy cv csn cA
      cpw wcel vy cv cA cpw cuni wcel vy cv cA wcel cA cpw cuni cA vy cv cA
      unipw eleq2i biimpi vy cv cA vy visset snelpw sylib syl2an mpi vx cv vy
      cv wne vx cv vu cv wcel vy cv vv cv wcel vu cv vv cv cin c0 wceq w3a wi
      vv cA cpw wrex vx cv vy cv wne vx cv vu cv wcel vy cv vv cv wcel vu cv vv
      cv cin c0 wceq w3a vv cA cpw wrex wi vu cA cpw vx cv vy cv wne vx cv vu
      cv wcel vy cv vv cv wcel vu cv vv cv cin c0 wceq w3a vv cA cpw r19.37av
      r19.22si vx cv vy cv wne vx cv vu cv wcel vy cv vv cv wcel vu cv vv cv
      cin c0 wceq w3a vv cA cpw wrex vu cA cpw r19.37av 3syl rgen2a mpbir2an $.
      $( [14-Jul-2007] $) $( [24-Jun-2007] $)
  $}

  ${
    dtt1.1 $e |- A e. _V $.
    $( A discrete topology is T1.  Morris, Topology without tears. $)
    dtt1 $p |- ~P A e. Fre $=
      cA cpw cha wcel cA cpw ct1 wcel cA dtt1.1 dtt2 cA cpw t2t1 ax-mp $.
      $( [18-Jun-2007] $) $( [8-Jun-2007] $)
   $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Compactness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The singleton of the empty set is compact. $)
  sinempcomp $p |- { (/) } e. Comp $=
    c0 csn ctop cfn cin wcel c0 csn ccomp wcel c0 csn ctop cfn cin wcel c0 csn
    ctop wcel c0 csn cfn wcel c0 csn ctop cfn elin sn0top c0 snfi mpbir2an c0
    csn fintopcomp ax-mp $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $( The subspace topology induced by the empty set is compact. $)
  subempcomp $p |- ( J e. Top -> ( subSp ` <. (/) , J >. ) e. Comp ) $=
    cJ ctop wcel c0 cJ cop csubsp cfv c0 csn ccomp cJ subspemp2 sinempcomp
    syl6eqel $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $( The indiscrete topology is compact. $)
  indcomp $p |- { (/) , A } e. Comp $=
    c0 cA cpr ctop cfn cin wcel c0 cA cpr ccomp wcel c0 cA cpr ctop cfn cin
    wcel c0 cA cpr ctop wcel c0 cA cpr cfn wcel c0 cA cpr ctop cfn elin cA
    indistop c0 cA prfi mpbir2an c0 cA cpr fintopcomp ax-mp $.
    $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  ${
    subsincomp.1 $e |- X = U. J $.
    $( The subspace topology induced by a singleton is compact. $)
    subsincomp $p |- ( ( J e. Top /\ A e. X ) ->
    ( subSp ` <. { A } , J >. ) e. Comp ) $=
      cJ ctop wcel cA cX wcel wa cA csn cJ cop csubsp cfv c0 cA csn cpr ccomp
      cA cJ cX subsincomp.1 subtopsin2 cA csn indcomp syl6eqel $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  $( A topology whose underlying set is finite is compact. $)
  topunfincomp $p |- ( ( J e. Top /\ U. J e. Fin ) -> J e. Comp ) $=
    cJ ctop wcel cJ cfn wcel cJ ccomp wcel cJ cuni cfn wcel cJ ctop wcel cJ cfn
    wcel wa cJ ctop cfn cin wcel cJ ccomp wcel cJ ctop cfn elin cJ fintopcomp
    sylbir cJ unfinsef sylan2 $.
    $( [22-Dec-2008] $) $( [22-Dec-2008] $)

  ${ $d x y z $.
    $( A compact topology is a topology. $)
    cmptop $p |- Comp C_ Top $=
      vx ccomp ctop vx cv ccomp wcel vx cv ctop wcel vx cv cuni vy cv cuni wceq
      vx cv cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wi vy vx cv cpw wral
      vy vz vx cv iscomp pm3.26bi ssriv $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${
    stfincomp.1 $e |- X = U. J $.
    $( The subspace topology induced by a finite part of the underlying set
       of a topology is compact. $)
    stfincomp $p |- ( ( J e. Top /\ A e. ( ~P X i^i  Fin ) ) ->
      ( subSp ` <. A , J >. ) e. Comp ) $=
      cJ ctop wcel cA cX cpw cfn cin wcel wa cA cJ cop csubsp cfv ctop wcel cA
      cJ cop csubsp cfv cuni cfn wcel wa cA cJ cop csubsp cfv ccomp wcel cA cX
      cpw cfn cin wcel cJ ctop wcel cA cJ cop csubsp cfv ctop wcel cA cJ cop
      csubsp cfv cuni cfn wcel wa cA cX cpw cfn cin wcel cA cX wss cA cfn wcel
      wa cA cJ cuni wss cA cfn wcel wa cJ ctop wcel cA cJ cop csubsp cfv ctop
      wcel cA cJ cop csubsp cfv cuni cfn wcel wa wi cA cX cpw cfn cin wcel cA
      cX cpw wcel cA cfn wcel wa cA cX wss cA cfn wcel wa cA cX cpw cfn elin cA
      cX cpw wcel cA cX wss cA cfn wcel cA cX elpwi anim1i sylbi cA cX wss cA
      cJ cuni wss cA cfn wcel cA cX wss cA cJ cuni wss cX cJ cuni cA
      stfincomp.1 sseq2i biimpi anim1i cA cJ cuni wss cA cfn wcel wa cJ ctop
      wcel cA cJ cop csubsp cfv ctop wcel cA cJ cop csubsp cfv cuni cfn wcel wa
      cA cJ cuni wss cA cfn wcel wa cJ ctop wcel wa cA cJ cop csubsp cfv ctop
      wcel cA cJ cop csubsp cfv cuni cfn wcel cA cJ cuni wss cA cfn wcel wa cJ
      ctop wcel cA cJ cop csubsp cfv ctop wcel cA cJ cuni wss cJ ctop wcel cA
      cJ cop csubsp cfv ctop wcel wi cA cfn wcel cJ ctop wcel cA cJ cuni wss cA
      cJ cop csubsp cfv ctop wcel cA cJ stoig3 expcom adantr imp cA cJ cuni wss
      cA cfn wcel wa cJ ctop wcel wa cA cJ cop csubsp cfv cuni cA cfn cA cJ
      cuni wss cA cfn wcel wa cJ ctop wcel cA cJ cop csubsp cfv cuni cA wceq cA
      cJ cuni wss cJ ctop wcel cA cJ cop csubsp cfv cuni cA wceq wi cA cfn wcel
      cJ ctop wcel cA cJ cuni wss cA cJ cop csubsp cfv cuni cA wceq cA cJ
      stoig2 expcom adantr imp cA cJ cuni wss cA cfn wcel cJ ctop wcel simplr
      eqeltrd jca ex 3syl impcom cA cJ cop csubsp cfv topunfincomp syl $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${
    $d A b f x z $. $d A f o x $. $d J a f z $. $d J b f x z $. $d J f o x $.
    $d X b f x z $. $d X f o x $.
   bwt2.1 $e |- X = U. J $.
   $( The  glorious Bolzano-Weierstrass  theorem.  Certainly the  first general
      topology  theorem ever  proved. In  his  course Weierstrass  called it  a
      lemma. He  certainly didn't  know how famous  this theorem would  be.  He
      used an  euclidian space instead of  a general compact space.  And he was
      not  conscious  of the  Heine-Borel  property.   Cantor  was one  of  his
      students. He used the concept of neighborhood and limit point invented by
      his master  when he  studied the linear  point sets  and the rest  of the
      general topology followed from that. $)
   bwt2 $p |- ( ( J e. Comp /\ A C_ X /\ -. A e. Fin ) ->
     E. x e. X  x e. ( ( limPt ` J ) ` A ) ) $=
     cJ ccomp wcel cA cX wss cA cfn wcel wn w3a vx cv cA cJ clp cfv cfv wcel vx
     cX wrex cJ ccomp wcel cA cX wss cA cfn wcel wn w3a vx cv cA cJ clp cfv cfv
     wcel vx cX wrex wn vx vo wel vo cv cA vx cv csn cdif cin c0 wne wi vo cJ
     wral vx cX wrex wn vx cv cA cJ clp cfv cfv wcel vx cX wrex cJ ccomp wcel
     cA cX wss vx cv cA cJ clp cfv cfv wcel vx cX wrex wn vx vo wel vo cv cA vx
     cv csn cdif cin c0 wne wi vo cJ wral vx cX wrex wn wb cA cfn wcel wn cJ
     ccomp wcel cA cX wss wa vx cv cA cJ clp cfv cfv wcel vx cX wrex vx vo wel
     vo cv cA vx cv csn cdif cin c0 wne wi vo cJ wral vx cX wrex cJ ccomp wcel
     cA cX wss wa vx cv cA cJ clp cfv cfv wcel vx vo wel vo cv cA vx cv csn
     cdif cin c0 wne wi vo cJ wral vx cX cJ ccomp wcel cA cX wss vx cv cX wcel
     vx cv cA cJ clp cfv cfv wcel vx vo wel vo cv cA vx cv csn cdif cin c0 wne
     wi vo cJ wral wb cJ ccomp wcel cJ ctop wcel cA cX wss vx cv cX wcel vx cv
     cA cJ clp cfv cfv wcel vx vo wel vo cv cA vx cv csn cdif cin c0 wne wi vo
     cJ wral wb wi wi ccomp ctop cJ cmptop sseli cJ ctop wcel cA cX wss vx cv
     cX wcel vx cv cA cJ clp cfv cfv wcel vx vo wel vo cv cA vx cv csn cdif cin
     c0 wne wi vo cJ wral wb vo vx cv cA cJ cX bwt2.1 islp3 3exp syl imp31
     rexbidva notbid 3adant3 cJ ccomp wcel cA cX wss cA cfn wcel wn w3a vx vo
     wel vo cv cA vx cv csn cdif cin c0 wne wn wa vo cJ wrex vx cX wral vx cv
     cA cJ clp cfv cfv wcel vx cX wrex vx vo wel vo cv cA vx cv csn cdif cin c0
     wne wi vo cJ wral vx cX wrex wn cJ ccomp wcel cA cX wss cA cfn wcel wn w3a
     vx vo wel vo cv cA vx cv csn cdif cin c0 wne wn wa vo cJ wrex vx cX wral
     cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn
     cdif cin c0 wceq wa vx cX wral wa vf wex vx cv cA cJ clp cfv cfv wcel vx
     cX wrex cJ ccomp wcel cA cX wss vx vo wel vo cv cA vx cv csn cdif cin c0
     wne wn wa vo cJ wrex vx cX wral cX cJ vf cv wf vx cv vx cv vf cv cfv wcel
     vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vf wex wi
     cA cfn wcel wn cJ ccomp wcel cX cvv wcel vx vo wel vo cv cA vx cv csn cdif
     cin c0 wne wn wa vo cJ wrex vx cX wral cX cJ vf cv wf vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vf
     wex wi cJ ccomp wcel cJ cuni cvv cX cJ ccomp uniexg bwt2.1 syl5eqel vx vo
     wel vo cv cA vx cv csn cdif cin c0 wne wn wa vx cv vx cv vf cv cfv wcel vx
     cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx vo cX cJ vf vo cv vx cv
     vf cv cfv wceq vx vo wel vx cv vx cv vf cv cfv wcel vo cv cA vx cv csn
     cdif cin c0 wne wn vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq vo cv vx
     cv vf cv cfv vx cv eleq2 vo cv vx cv vf cv cfv wceq vo cv cA vx cv csn
     cdif cin c0 wceq vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq vo cv cA vx
     cv csn cdif cin c0 wne wn vo cv vx cv vf cv cfv wceq vo cv cA vx cv csn
     cdif cin vx cv vf cv cfv cA vx cv csn cdif cin c0 vo cv vx cv vf cv cfv cA
     vx cv csn cdif ineq1 eqeq1d vo cv cA vx cv csn cdif cin c0 nne syl5bb
     anbi12d ac6sg syl 3ad2ant1 cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv
     vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vf wex cJ ccomp
     wcel cA cX wss cA cfn wcel wn w3a vx cv cA cJ clp cfv cfv wcel vx cX wrex
     cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn
     cdif cin c0 wceq wa vx cX wral wa cJ ccomp wcel cA cX wss cA cfn wcel wn
     w3a vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vf vf cv crn cJ cpw wcel cJ
     cuni vf cv crn cuni wceq wa cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx
     cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa cJ ccomp wcel
     cA cX wss cA cfn wcel wn w3a vx cv cA cJ clp cfv cfv wcel vx cX wrex wi cX
     cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif
     cin c0 wceq wa vx cX wral wa vf cv crn cJ cpw wcel cJ cuni vf cv crn cuni
     wceq cX cJ vf cv wf vf cv crn cJ cpw wcel vx cv vx cv vf cv cfv wcel vx cv
     vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral cX cJ vf cv wf vf cv
     crn cJ wss vf cv crn cJ cpw wcel cX cJ vf cv frn vf cv crn cJ vf cv vf
     visset rnex elpw sylibr adantr cX cJ vf cv wf vx cv vx cv vf cv cfv wcel
     vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral cJ cuni vf cv
     crn cuni wceq vf cv crn cuni cJ cuni wss cX cJ vf cv wf vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral cJ
     cuni vf cv crn cuni wceq wi cX cJ vf cv wf vf cv crn cJ wss vf cv crn cuni
     cJ cuni wss cX cJ vf cv frn vf cv crn cJ uniss syl vf cv crn cuni cJ cuni
     wss cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn
     cdif cin c0 wceq wa vx cX wral cJ cuni vf cv crn cuni wceq vf cv crn cuni
     cJ cuni wss cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA
     vx cv csn cdif cin c0 wceq wa vx cX wral w3a cJ cuni vf cv crn cuni vf cv
     crn cuni cJ cuni wss cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv
     cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral w3a vx cv cJ cuni wcel vx
     cv vf cv crn cuni wcel wi vx wal cJ cuni vf cv crn cuni wss vf cv crn cuni
     cJ cuni wss cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA
     vx cv csn cdif cin c0 wceq wa vx cX wral vx cv cJ cuni wcel vx cv vf cv
     crn cuni wcel wi vx wal vf cv crn cuni cJ cuni wss cX cJ vf cv wf wa vx cv
     cX wcel vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin
     c0 wceq wa wi vx wal vx cv cJ cuni wcel vx cv vf cv crn cuni wcel wi vx
     wal vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0
     wceq wa vx cX wral vf cv crn cuni cJ cuni wss cX cJ vf cv wf wa vx cv cX
     wcel vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0
     wceq wa wi vx cv cJ cuni wcel vx cv vf cv crn cuni wcel wi vx vf cv crn
     cuni cJ cuni wss cX cJ vf cv wf wa vx ax-17 vx cv cJ cuni wcel vx cv cX
     wcel vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0
     wceq wa wi vf cv crn cuni cJ cuni wss cX cJ vf cv wf wa vx cv vf cv crn
     cuni wcel vx cv cJ cuni wcel vx cv cX wcel vx cv cX wcel vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa wi vf cv crn
     cuni cJ cuni wss cX cJ vf cv wf wa vx cv vf cv crn cuni wcel wi wi cJ cuni
     cX vx cv cX cJ cuni bwt2.1 eqcomi eleq2i vx cv cX wcel vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa wi vx cv cX wcel
     vf cv crn cuni cJ cuni wss cX cJ vf cv wf wa vx cv vf cv crn cuni wcel wi
     vx cv cX wcel vx cv cX wcel vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA
     vx cv csn cdif cin c0 wceq wa wi vx cv vx cv vf cv cfv wcel vx cv vf cv
     cfv cA vx cv csn cdif cin c0 wceq wa vx cv cX wcel vf cv crn cuni cJ cuni
     wss cX cJ vf cv wf wa vx cv vf cv crn cuni wcel wi wi vx cv cX wcel vx cv
     vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa
     pm2.27 vx cv vx cv vf cv cfv wcel vx cv cX wcel vf cv crn cuni cJ cuni wss
     cX cJ vf cv wf wa vx cv vf cv crn cuni wcel wi wi vx cv vf cv cfv cA vx cv
     csn cdif cin c0 wceq vf cv crn cuni cJ cuni wss cX cJ vf cv wf wa vx cv cX
     wcel vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel cX cJ vf cv wf
     vf cv crn cuni cJ cuni wss vx cv cX wcel vx cv vx cv vf cv cfv wcel vx cv
     vf cv crn cuni wcel wi wi vf cv cdm cX wceq cX cJ vf cv wf vf cv crn cuni
     cJ cuni wss vx cv cX wcel vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni
     wcel wi wi wi cX cJ vf cv fdm cX cJ vf cv wf vf cv crn cuni cJ cuni wss vx
     cv cX wcel vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel wi wi wi
     wi cX vf cv cdm vx cv cX wcel cX vf cv cdm wceq cX cJ vf cv wf vf cv crn
     cuni cJ cuni wss vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel wi
     cX vf cv cdm wceq vx cv cX wcel vx cv vf cv cdm wcel cX cJ vf cv wf vf cv
     crn cuni cJ cuni wss vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel
     wi wi wi cX vf cv cdm wceq vx cv cX wcel vx cv vf cv cdm wcel cX vf cv cdm
     vx cv eleq2 biimpd cX cJ vf cv wf vx cv vf cv cdm wcel vf cv crn cuni cJ
     cuni wss vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel wi wi vf cv
     wfun cX cJ vf cv wf vx cv vf cv cdm wcel vf cv crn cuni cJ cuni wss vx cv
     vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel wi wi wi cX cJ vf cv ffun
     vf cv wfun vx cv vf cv cdm wcel cX cJ vf cv wf vf cv crn cuni cJ cuni wss
     vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel wi wi vf cv wfun vx
     cv vf cv cdm wcel vx cv vf cv cfv vf cv crn wcel cX cJ vf cv wf vf cv crn
     cuni cJ cuni wss vx cv vx cv vf cv cfv wcel vx cv vf cv crn cuni wcel wi
     wi wi vf cv wfun vx cv vf cv cdm wcel vx cv vf cv cfv vf cv crn wcel vx cv
     vf cv fvelrn ex vx cv vx cv vf cv cfv wcel vx cv vf cv cfv vf cv crn wcel
     cX cJ vf cv wf vf cv crn cuni cJ cuni wss vx cv vf cv crn cuni wcel vx cv
     vx cv vf cv cfv wcel vx cv vf cv cfv vf cv crn wcel vx cv vf cv crn cuni
     wcel cX cJ vf cv wf vf cv crn cuni cJ cuni wss vx cv vf cv crn cuni wcel
     wi wi vx cv vx cv vf cv cfv wcel vx cv vf cv cfv vf cv crn wcel vx cv vf
     cv crn cuni wcel vx cv vx cv vf cv cfv vf cv crn elunii ex vf cv crn cuni
     cJ cuni wss cX cJ vf cv wf vx cv vf cv crn cuni wcel vx cv vf cv crn cuni
     wcel cX cJ vf cv wf vx cv vf cv crn cuni wcel vx cv vf cv crn cuni wcel wi
     wi vf cv crn cuni cJ cuni wss cX cJ vf cv wf vx cv vf cv crn cuni wcel idd
     a1i com13 syl6 com4l syl6 com23 mpcom com12 syl6com com4l eqcoms mpcom
     impcom com13 adantr syl6 pm2.43a sylbi com13 19.20d vx cv vx cv vf cv cfv
     wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX df-ral syl5ib
     3impia vx cJ cuni vf cv crn cuni dfss2 sylibr vf cv crn cuni cJ cuni wss
     cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn
     cdif cin c0 wceq wa vx cX wral 3simp1 eqssd 3exp mpcom imp jca cJ ccomp
     wcel cA cX wss cA cfn wcel wn w3a cX cJ vf cv wf vx cv vx cv vf cv cfv
     wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vf cv
     crn cJ cpw wcel cJ cuni vf cv crn cuni wceq wa vx cv cA cJ clp cfv cfv
     wcel vx cX wrex cJ ccomp wcel cA cX wss cA cfn wcel wn cX cJ vf cv wf vx
     cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa
     vx cX wral wa vf cv crn cJ cpw wcel cJ cuni vf cv crn cuni wceq wa vx cv
     cA cJ clp cfv cfv wcel vx cX wrex wi wi cJ ccomp wcel cJ ctop wcel cJ cuni
     va cv cuni wceq cJ cuni vz cv cuni wceq vz va cv cpw cfn cin wrex wi va cJ
     cpw wral wa cA cX wss cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv
     wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vf cv
     crn cJ cpw wcel cJ cuni vf cv crn cuni wceq wa vx cv cA cJ clp cfv cfv
     wcel vx cX wrex wi wi wi wi va vz cJ iscomp cJ cuni va cv cuni wceq cJ
     cuni vz cv cuni wceq vz va cv cpw cfn cin wrex wi va cJ cpw wral cA cX wss
     cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv
     cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vf cv crn cJ cpw wcel cJ
     cuni vf cv crn cuni wceq wa vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi
     wi wi cJ ctop wcel cJ cuni va cv cuni wceq cJ cuni vz cv cuni wceq vz va
     cv cpw cfn cin wrex wi va cJ cpw wral cA cX wss cA cfn wcel wn cX cJ vf cv
     wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0
     wceq wa vx cX wral wa vf cv crn cJ cpw wcel cJ cuni vf cv crn cuni wceq wa
     vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vf cv crn cJ cpw wcel cJ cuni
     vf cv crn cuni wceq wa cJ cuni va cv cuni wceq cJ cuni vz cv cuni wceq vz
     va cv cpw cfn cin wrex wi va cJ cpw wral cA cX wss cA cfn wcel wn cX cJ vf
     cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0
     wceq wa vx cX wral wa w3a vx cv cA cJ clp cfv cfv wcel vx cX wrex vf cv
     crn cJ cpw wcel cJ cuni vf cv crn cuni wceq cJ cuni va cv cuni wceq cJ
     cuni vz cv cuni wceq vz va cv cpw cfn cin wrex wi va cJ cpw wral cA cX wss
     cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv
     cA vx cv csn cdif cin c0 wceq wa vx cX wral wa w3a vx cv cA cJ clp cfv cfv
     wcel vx cX wrex wi wi vf cv crn cJ cpw wcel cJ cuni va cv cuni wceq cJ
     cuni vz cv cuni wceq vz va cv cpw cfn cin wrex wi va cJ cpw wral cJ cuni
     vf cv crn cuni wceq cA cX wss cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf
     cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa
     w3a vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vf cv crn cJ cpw wcel cJ
     cuni va cv cuni wceq cJ cuni vz cv cuni wceq vz va cv cpw cfn cin wrex wi
     va cJ cpw wral cJ cuni vf cv crn cuni wceq cJ cuni vz cv cuni wceq vz vf
     cv crn cpw cfn cin wrex cA cX wss cA cfn wcel wn cX cJ vf cv wf vx cv vx
     cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX
     wral wa w3a vx cv cA cJ clp cfv cfv wcel vx cX wrex wi cJ cuni va cv cuni
     wceq cJ cuni vz cv cuni wceq vz va cv cpw cfn cin wrex wi cJ cuni vf cv
     crn cuni wceq cJ cuni vz cv cuni wceq vz vf cv crn cpw cfn cin wrex wi va
     vf cv crn cJ cpw cJ cuni vf cv crn cuni wceq cJ cuni vz cv cuni wceq vz vf
     cv crn cpw cfn cin wrex wi va ax-17 va cv vf cv crn wceq cJ cuni va cv
     cuni wceq cJ cuni vf cv crn cuni wceq cJ cuni vz cv cuni wceq vz va cv cpw
     cfn cin wrex cJ cuni vz cv cuni wceq vz vf cv crn cpw cfn cin wrex va cv
     vf cv crn wceq va cv cuni vf cv crn cuni cJ cuni va cv vf cv crn unieq
     eqeq2d va cv vf cv crn wceq cJ cuni vz cv cuni wceq vz va cv cpw cfn cin
     vf cv crn cpw cfn cin va cv vf cv crn wceq va cv cpw vf cv crn cpw cfn va
     cv vf cv crn pweq ineq1d rexeq1d imbi12d rcla4 cJ cuni vz cv cuni wceq vz
     vf cv crn cpw cfn cin wrex cA cX wss cA cfn wcel wn cX cJ vf cv wf vx cv
     vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx
     cX wral wa vx cv cA cJ clp cfv cfv wcel vx cX wrex cJ cuni vz cv cuni wceq
     cA cX wss cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv
     vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vx cv cA cJ clp
     cfv cfv wcel vx cX wrex wi wi wi vz vf cv crn cpw cfn cin vz cv vf cv crn
     cpw cfn cin wcel vz cv vf cv crn cpw wcel vz cv cfn wcel wa cJ cuni vz cv
     cuni wceq cA cX wss cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv
     wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vx cv
     cA cJ clp cfv cfv wcel vx cX wrex wi wi wi wi vz cv vf cv crn cpw cfn elin
     cJ cuni vz cv cuni wceq cA cX wss vz cv vf cv crn cpw wcel vz cv cfn wcel
     wa cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv
     cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vx cv cA cJ clp cfv cfv
     wcel vx cX wrex wi wi cJ cuni vz cv cuni wceq cX vz cv cuni wceq cA cX wss
     vz cv vf cv crn cpw wcel vz cv cfn wcel wa cA cfn wcel wn cX cJ vf cv wf
     vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq
     wa vx cX wral wa vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi wi wi cJ
     cuni cX vz cv cuni cX cJ cuni bwt2.1 eqcomi eqeq1i cX vz cv cuni wceq cA
     cX wss cA vz cv cuni wss vz cv vf cv crn cpw wcel vz cv cfn wcel wa cA cfn
     wcel wn cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv
     csn cdif cin c0 wceq wa vx cX wral wa vx cv cA cJ clp cfv cfv wcel vx cX
     wrex wi wi wi cX vz cv cuni cA sseq2 vz cv vf cv crn cpw wcel vz cv cfn
     wcel wa cA vz cv cuni wss cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vx
     cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vz cv vf cv crn cpw wcel vz cv
     cfn wcel cA vz cv cuni wss cA cfn wcel wn cX cJ vf cv wf vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa vx
     cv cA cJ clp cfv cfv wcel vx cX wrex wi wi wi vz cv cfn wcel cA vz cv cuni
     wss cA cfn wcel wn vz cv vf cv crn cpw wcel cX cJ vf cv wf vx cv vx cv vf
     cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa
     vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vz cv cfn wcel cA vz cv cuni
     wss cA cfn wcel wn cA vb cv cin cfn wcel wn vb vz cv wrex vz cv vf cv crn
     cpw wcel cX cJ vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx
     cv csn cdif cin c0 wceq wa vx cX wral wa vx cv cA cJ clp cfv cfv wcel vx
     cX wrex wi wi cA cfn wcel wn vz cv cfn wcel cA vz cv cuni wss cA vb cv cin
     cfn wcel wn vb vz cv wrex cA cfn wcel wn vz cv cfn wcel cA vz cv cuni wss
     cA vb cv cin cfn wcel wn vb vz cv wrex vb cA vz cv isunscov 3exp com3l cA
     vb cv cin cfn wcel wn vz cv vf cv crn cpw wcel cX cJ vf cv wf vx cv vx cv
     vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral
     wa vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vb vz cv vb vz wel vz cv
     vf cv crn cpw wcel cA vb cv cin cfn wcel wn cX cJ vf cv wf vx cv vx cv vf
     cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral wa
     vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vb vz wel vz cv vf cv crn cpw
     wcel vb cv vf cv crn wcel cA vb cv cin cfn wcel wn cX cJ vf cv wf vx cv vx
     cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX
     wral wa vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vb vz wel vz cv vf
     cv crn cpw wcel vb cv vf cv crn wcel vb cv vz cv vf cv crn bepart ex cX cJ
     vf cv wf vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin
     c0 wceq wa vx cX wral wa cA vb cv cin cfn wcel wn vb cv vf cv crn wcel vx
     cv cA cJ clp cfv cfv wcel vx cX wrex cX cJ vf cv wf vx cv vx cv vf cv cfv
     wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral cA vb cv
     cin cfn wcel wn vb cv vf cv crn wcel vx cv cA cJ clp cfv cfv wcel vx cX
     wrex wi wi cX cJ vf cv wf vf cv cX wfn vx cv vx cv vf cv cfv wcel vx cv vf
     cv cfv cA vx cv csn cdif cin c0 wceq wa vx cX wral cA vb cv cin cfn wcel
     wn vb cv vf cv crn wcel vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi wi
     cX cJ vf cv ffn vf cv cX wfn vb cv vf cv crn wcel cA vb cv cin cfn wcel wn
     vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq
     wa vx cX wral vx cv cA cJ clp cfv cfv wcel vx cX wrex vf cv cX wfn vb cv
     vf cv crn wcel vx cv vf cv cfv vb cv wceq vx cX wrex cA vb cv cin cfn wcel
     wn vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0
     wceq wa vx cX wral vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vx cX vb
     cv vf cv fvelrnb vx cv vf cv cfv vb cv wceq cA vb cv cin cfn wcel wn vx cv
     vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa vx
     cX wral vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vx cX cA vb cv cin
     cfn wcel wn vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif
     cin c0 wceq wa vx cX wral vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vx cA
     vb cv cin cfn wcel wn vx ax-17 vx cv vx cv vf cv cfv wcel vx cv vf cv cfv
     cA vx cv csn cdif cin c0 wceq wa vx cX wral vx cv cA cJ clp cfv cfv wcel
     vx cX wrex vx vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif
     cin c0 wceq wa vx cX hbra1 vx cv cA cJ clp cfv cfv wcel vx cX hbre1 hbim
     hbim vx cv vf cv cfv vb cv wceq cA vb cv cin cfn wcel wn vx cv cX wcel vx
     cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa
     vx cX wral vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vx cv vf cv cfv vb
     cv wceq cA vb cv cin cfn wcel wn cA vx cv vf cv cfv cin cfn wcel wn vx cv
     cX wcel vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin
     c0 wceq wa vx cX wral vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi cA vb
     cv cin cfn wcel wn cA vx cv vf cv cfv cin cfn wcel wn wi vb cv vx cv vf cv
     cfv vb cv vx cv vf cv cfv wceq cA vb cv cin cfn wcel wn cA vx cv vf cv cfv
     cin cfn wcel wn vb cv vx cv vf cv cfv wceq cA vb cv cin cfn wcel cA vx cv
     vf cv cfv cin cfn wcel vb cv vx cv vf cv cfv wceq cA vb cv cin cA vx cv vf
     cv cfv cin cfn vb cv vx cv vf cv cfv cA ineq2 eleq1d notbid biimpd eqcoms
     vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq
     wa vx cX wral vx cv cX wcel cA vx cv vf cv cfv cin cfn wcel wn vx cv cA cJ
     clp cfv cfv wcel vx cX wrex vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA
     vx cv csn cdif cin c0 wceq wa vx cX wral vx cv cX wcel vx cv vx cv vf cv
     cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa wi vx wal vx cv
     cX wcel cA vx cv vf cv cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx
     cX wrex wi wi vx cv vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif
     cin c0 wceq wa vx cX df-ral vx cv cX wcel vx cv vx cv vf cv cfv wcel vx cv
     vf cv cfv cA vx cv csn cdif cin c0 wceq wa wi vx cv cX wcel cA vx cv vf cv
     cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vx vx cv
     vx cv vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq wa cA
     vx cv vf cv cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx cX wrex wi
     vx cv cX wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq cA vx cv vf cv
     cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vx cv vx cv
     vf cv cfv wcel vx cv vf cv cfv cA vx cv csn cdif cin c0 wceq vx cv vf cv
     cfv cA vx cv csn cdif cin vx cv csn cdif c0 vx cv csn cdif wceq cA vx cv
     vf cv cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vx cv
     vf cv cfv cA vx cv csn cdif cin c0 vx cv csn difeq1 vx cv vf cv cfv cA vx
     cv csn cdif cin vx cv csn cdif c0 vx cv csn cdif wceq c0 vx cv csn cdif c0
     wceq cA vx cv vf cv cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx cX
     wrex wi vx cv csn 0dif vx cv vf cv cfv cA vx cv csn cdif cin vx cv csn
     cdif c0 vx cv csn cdif wceq c0 vx cv csn cdif c0 wceq vx cv vf cv cfv cA
     vx cv csn cdif cin vx cv csn cdif c0 wceq cA vx cv vf cv cfv cin cfn wcel
     wn vx cv cA cJ clp cfv cfv wcel vx cX wrex wi vx cv vf cv cfv cA vx cv csn
     cdif cin vx cv csn cdif c0 vx cv csn cdif wceq c0 vx cv csn cdif c0 wceq
     vx cv vf cv cfv cA vx cv csn cdif cin vx cv csn cdif c0 wceq vx cv vf cv
     cfv cA vx cv csn cdif cin vx cv csn cdif c0 vx cv csn cdif c0 eqtr ex vx
     cv vf cv cfv cA vx cv csn cdif cin vx cv csn cdif vx cv vf cv cfv vx cv
     csn cdif cA vx cv csn cdif vx cv csn cdif cin wceq vx cv vf cv cfv cA vx
     cv csn cdif cin vx cv csn cdif c0 wceq cA vx cv vf cv cfv cin cfn wcel wn
     vx cv cA cJ clp cfv cfv wcel vx cX wrex wi wi vx cv vf cv cfv cA vx cv csn
     cdif vx cv csn difindir vx cv vf cv cfv cA vx cv csn cdif cin vx cv csn
     cdif c0 wceq cA vx cv vf cv cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv
     wcel vx cX wrex wi wi vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif vx
     cv csn cdif cin vx cv vf cv cfv cA vx cv csn cdif cin vx cv csn cdif vx cv
     vf cv cfv vx cv csn cdif cA vx cv csn cdif vx cv csn cdif cin vx cv vf cv
     cfv cA vx cv csn cdif cin vx cv csn cdif wceq vx cv vf cv cfv cA vx cv csn
     cdif cin vx cv csn cdif c0 wceq cA vx cv vf cv cfv cin cfn wcel wn vx cv
     cA cJ clp cfv cfv wcel vx cX wrex wi vx cv vf cv cfv vx cv csn cdif cA vx
     cv csn cdif vx cv csn cdif cin vx cv vf cv cfv cA vx cv csn cdif cin vx cv
     csn cdif wceq vx cv vf cv cfv cA vx cv csn cdif cin vx cv csn cdif c0 wceq
     wa vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif vx cv csn cdif cin c0
     wceq cA vx cv vf cv cfv cin cfn wcel wn vx cv cA cJ clp cfv cfv wcel vx cX
     wrex wi vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif vx cv csn cdif
     cin vx cv vf cv cfv cA vx cv csn cdif cin vx cv csn cdif c0 eqtr vx cv vf
     cv cfv vx cv csn cdif cA vx cv csn cdif vx cv csn cdif cin c0 wceq cA vx
     cv vf cv cfv cin cfn wcel vx cv cA cJ clp cfv cfv wcel vx cX wrex vx cv vf
     cv cfv vx cv csn cdif cA vx cv csn cdif vx cv csn cdif cin vx cv vf cv cfv
     vx cv csn cdif cA vx cv csn cdif cin wceq vx cv vf cv cfv vx cv csn cdif
     cA vx cv csn cdif vx cv csn cdif cin c0 wceq cA vx cv vf cv cfv cin cfn
     wcel cA vx cv csn cdif vx cv csn cdif cA vx cv csn cdif vx cv vf cv cfv vx
     cv csn cdif cA vx cv csn remcon ineq2i vx cv vf cv cfv vx cv csn cdif cA
     vx cv csn cdif vx cv csn cdif cin vx cv vf cv cfv vx cv csn cdif cA vx cv
     csn cdif cin wceq vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif vx cv
     csn cdif cin c0 wceq wa vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif
     cin c0 wceq cA vx cv vf cv cfv cin cfn wcel vx cv vf cv cfv vx cv csn cdif
     cA vx cv csn cdif vx cv csn cdif cin vx cv vf cv cfv vx cv csn cdif cA vx
     cv csn cdif cin c0 eqtr2 vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif
     cin vx cv vf cv cfv cA cin vx cv csn cdif wceq vx cv vf cv cfv vx cv csn
     cdif cA vx cv csn cdif cin c0 wceq cA vx cv vf cv cfv cin cfn wcel vx cv
     vf cv cfv cA cin vx cv csn cdif vx cv vf cv cfv vx cv csn cdif cA vx cv
     csn cdif cin vx cv vf cv cfv cA vx cv csn difindir eqcomi vx cv vf cv cfv
     vx cv csn cdif cA vx cv csn cdif cin vx cv vf cv cfv cA cin vx cv csn cdif
     wceq vx cv vf cv cfv vx cv csn cdif cA vx cv csn cdif cin c0 wceq wa vx cv
     vf cv cfv cA cin vx cv csn cdif c0 wceq cA vx cv vf cv cfv cin cfn wcel vx
     cv vf cv cfv vx cv csn cdif cA vx cv csn cdif cin vx cv vf cv cfv cA cin
     vx cv csn cdif c0 eqtr2 vx cv vf cv cfv cA cin vx cv csn cdif c0 wceq cA
     vx cv vf cv cfv cin vx cv csn cdif cfn wcel cA vx cv vf cv cfv cin cfn
     wcel vx cv vf cv cfv cA cin vx cv csn cdif c0 wceq cA vx cv vf cv cfv cin
     vx cv csn cdif cfn wcel c0 cfn wcel emfin vx cv vf cv cfv cA cin vx cv csn
     cdif c0 wceq vx cv vf cv cfv cA cin vx cv csn cdif cfn wcel c0 cfn wcel cA
     vx cv vf cv cfv cin vx cv csn cdif cfn wcel vx cv vf cv cfv cA cin vx cv
     csn cdif c0 cfn eleq1 vx cv vf cv cfv cA cin vx cv csn cdif cA vx cv vf cv
     cfv cin vx cv csn cdif cfn vx cv vf cv cfv cA cin cA vx cv vf cv cfv cin
     vx cv csn vx cv vf cv cfv cA incom difeq1i eleq1i syl5bbr mpbiri cA vx cv
     vf cv cfv cin cfn wcel cA vx cv vf cv cfv cin vx cv csn cdif cfn wcel cA
     vx cv vf cv cfv cin cfn wcel wn vx cv csn cfn wcel cA vx cv vf cv cfv cin
     vx cv csn cdif cfn wcel wn vx cv snfi cA vx cv vf cv cfv cin vx cv csn
     islfin mpan2 con4i syl syl mpan syl mpan pm2.24d syl ex eqcoms ax-mp syl6
     mpi syl adantl imim2i a4s sylbi com13 syl6 com3r r19.23ai syl6bi com24 syl
     imp com13 syl6 com23 r19.23aiv syl8 com4r imp com12 syl6bi sylbi com3r
     sylbi r19.23aiv 3impd syl8 com23 imp com3l 3expd adantl sylbi 3imp com13
     mpcom 19.23aiv com12 syld vx vo wel vo cv cA vx cv csn cdif cin c0 wne vx
     vo cX cJ negcmpprcal1 syl5ib sylbid pm2.01bd $.
     $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Connectedness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The closed sets of the topology ` { (/) } ` . $)
  clsingemp $p |- ( Clsd ` { (/) } ) = { (/) } $=
    c0 cpw c0 csn wceq c0 csn ccld cfv c0 csn wceq pw0 c0 csn ccld cfv c0 csn
    wceq c0 csn c0 cpw c0 csn c0 cpw wceq c0 cpw ccld cfv c0 cpw c0 csn ccld
    cfv c0 csn c0 cpw c0 cpw ccld cfv c0 0ex dtopcl eqcomi c0 csn c0 cpw ccld
    fveq2 c0 csn c0 cpw wceq id 3eqtr4a eqcoms ax-mp $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)


  ${ $d A x $.
    clindistop.1 $e |- A e. B $.
    $( The closed sets of an indiscrete topology. $)
    clindistop $p |- ( Clsd ` { (/) , A } ) = { (/) , A } $=
      c0 cA cpr ctop wcel c0 cA cpr ccld cfv c0 cA cpr wceq cA indistop c0 cA
      cpr ctop wcel c0 cA cpr ccld cfv vx cv cA wss cA vx cv cdif c0 cA cpr
      wcel wa vx cab c0 cA cpr vx c0 cA cpr cA c0 cA cpr cuni c0 cA cun cA c0
      cun cA c0 cA 0ex cA cB clindistop.1 elisseti unipr cA c0 uncom cA un0
      3eqtr2ri cldval vx cv cA wss cA vx cv cdif c0 cA cpr wcel wa vx cab vx cv
      c0 wceq vx cv cA wceq wo vx cab c0 cA cpr vx cv cA wss cA vx cv cdif c0
      cA cpr wcel wa vx cv c0 wceq vx cv cA wceq wo vx vx cv cA wss cA vx cv
      cdif c0 cA cpr wcel wa vx cv c0 wceq vx cv cA wceq wo cA vx cv cdif c0 cA
      cpr wcel vx cv cA wss vx cv c0 wceq vx cv cA wceq wo cA vx cv cdif c0 cA
      cpr wcel cA vx cv cdif c0 wceq cA vx cv cdif cA wceq wo vx cv cA wss vx
      cv c0 wceq vx cv cA wceq wo wi cA vx cv cdif c0 cA cA cB wcel cA vx cv
      cdif cvv wcel clindistop.1 cA vx cv cB difexg ax-mp elpr cA vx cv cdif c0
      wceq vx cv cA wss vx cv c0 wceq vx cv cA wceq wo wi cA vx cv cdif cA wceq
      cA vx cv cdif c0 wceq cA vx cv wss vx cv cA wss vx cv c0 wceq vx cv cA
      wceq wo wi cA vx cv ssdif0 vx cv cA wss cA vx cv wss vx cv c0 wceq vx cv
      cA wceq wo vx cv cA wss cA vx cv wss wa vx cv cA wceq vx cv c0 wceq vx cv
      cA wceq vx cv cA wss cA vx cv wss wa vx cv cA eqss biimpri olcd expcom
      sylbir vx cv cA wss vx cv c0 wceq vx cv cA wceq wo wi cA cA vx cv cdif cA
      cA vx cv cdif wceq cA vx cv cin c0 wceq vx cv cA wss vx cv c0 wceq vx cv
      cA wceq wo wi cA vx cv disj3 cA vx cv cin vx cv cA cin wceq cA vx cv cin
      c0 wceq vx cv cA wss vx cv c0 wceq vx cv cA wceq wo wi wi cA vx cv incom
      cA vx cv cin c0 wceq vx cv cA wss vx cv c0 wceq vx cv cA wceq wo wi wi vx
      cv cA cin cA vx cv cin vx cv cA cin cA vx cv cin wceq cA vx cv cin c0
      wceq vx cv cA wss vx cv c0 wceq vx cv cA wceq wo wi vx cv cA wss vx cv cA
      cin c0 wceq vx cv c0 wceq vx cv cA wceq wo vx cv cA cin cA vx cv cin wceq
      cA vx cv cin c0 wceq wa vx cv cA wss vx cv cA cin c0 wceq vx cv cA cA
      cdif wss vx cv c0 wceq vx cv cA wceq wo vx cv cA cA reldisj vx cv cA cA
      cdif wss vx cv c0 wceq vx cv cA wceq vx cv cA cA cdif wss vx cv c0 wss vx
      cv c0 wceq cA cA cdif c0 vx cv cA difid sseq2i vx cv ss0 sylbi orcd
      syl6bi vx cv cA cin cA vx cv cin c0 eqtr syl5com ex eqcoms ax-mp sylbir
      eqcoms jaoi sylbi impcom vx cv c0 wceq vx cv cA wss cA vx cv cdif c0 cA
      cpr wcel wa vx cv cA wceq vx cv c0 wceq vx cv cA wss cA vx cv cdif c0 cA
      cpr wcel wa c0 cA wss cA c0 cdif c0 cA cpr wcel wa c0 cA wss cA c0 cdif
      c0 cA cpr wcel cA 0ss cA c0 cdif cA c0 cA cpr cA dif0 c0 cA cA cB
      clindistop.1 elisseti prid2 eqeltri pm3.2i vx cv c0 wceq vx cv cA wss c0
      cA wss cA vx cv cdif c0 cA cpr wcel cA c0 cdif c0 cA cpr wcel vx cv c0 cA
      sseq1 vx cv c0 wceq cA vx cv cdif cA c0 cdif c0 cA cpr vx cv c0 cA difeq2
      eleq1d anbi12d mpbiri vx cv cA wceq vx cv cA wss cA vx cv cdif c0 cA cpr
      wcel wa cA cA wss cA cA cdif c0 cA cpr wcel wa cA cA wss cA cA cdif c0 cA
      cpr wcel cA ssid cA cA cdif c0 c0 cA cpr cA difid c0 cA 0ex prid1 eqeltri
      pm3.2i vx cv cA wceq vx cv cA wss cA cA wss cA vx cv cdif c0 cA cpr wcel
      cA cA cdif c0 cA cpr wcel vx cv cA cA sseq1 vx cv cA wceq cA vx cv cdif
      cA cA cdif c0 cA cpr vx cv cA cA difeq2 eleq1d anbi12d mpbiri jaoi impbii
      abbii vx c0 cA dfpr2 eqtr4i syl6eq ax-mp $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  $( The closed sets of an indiscrete topology. $)
  clindistop2 $p |- ( A e. B -> ( Clsd ` { (/) , A } ) = { (/) , A } ) $=
    cA cB wcel cA cvv wcel c0 cA cpr ccld cfv c0 cA cpr wceq cA cB elisset cA
    cvv wcel c0 cA cpr ccld cfv c0 cA cpr wceq c0 cA cvv wcel cA c0 cif cpr
    ccld cfv c0 cA cvv wcel cA c0 cif cpr wceq cA c0 cA cA cvv wcel cA c0 cif
    wceq c0 cA cpr ccld cfv c0 cA cvv wcel cA c0 cif cpr ccld cfv c0 cA cpr c0
    cA cvv wcel cA c0 cif cpr cA cA cvv wcel cA c0 cif wceq c0 cA cpr c0 cA cvv
    wcel cA c0 cif cpr ccld cA cA cvv wcel cA c0 cif c0 preq2 fveq2d cA cA cvv
    wcel cA c0 cif c0 preq2 eqeq12d cA cvv wcel cA c0 cif cvv cA c0 cvv 0ex
    elimel clindistop dedth syl $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)

  ${
    intopcon.1 $e |- A e. B $.
    $( The indiscrete topology is connected. $)
    intopcon $p |- { (/) , A } e. Con $=
      c0 cA cpr ccon wcel c0 cA cpr ctop wcel c0 cA cpr c0 cA cpr ccld cfv cin
      c0 c0 cA cpr cuni cpr wceq c0 cA cpr iscon2 cA indistop c0 cA cpr c0 cA
      cpr ccld cfv cin c0 cA cpr c0 cA cpr cin c0 cA cpr c0 c0 cA cpr cuni cpr
      c0 cA cpr ccld cfv c0 cA cpr c0 cA cpr cA cB intopcon.1 clindistop ineq2i
      c0 cA cpr inidm cA c0 cA cpr cuni wceq c0 cA cpr c0 c0 cA cpr cuni cpr
      wceq c0 cA cpr cuni c0 cA cun cA c0 cun cA c0 cA 0ex cA cB intopcon.1
      elisseti unipr cA c0 uncom cA un0 3eqtr2ri cA c0 cA cpr cuni c0 preq2
      ax-mp 3eqtri mpbir2an $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  $( The singleton of the empty set is a connected topology. $)
  singempcon $p |- { (/) } e. Con $=
    c0 csn ccon wcel c0 csn c0 csn ccld cfv cin c0 c0 csn cuni cpr wceq c0 csn
    c0 csn ccld cfv cin c0 csn c0 csn cin c0 csn c0 c0 csn cuni cpr c0 csn ccld
    cfv c0 csn c0 csn vx cv c0 wss c0 vx cv cdif c0 csn wcel wa vx cab vx cv c0
    wceq vx cab c0 csn ccld cfv c0 csn vx cv c0 wss c0 vx cv cdif c0 csn wcel
    wa vx cv c0 wceq vx vx cv c0 wss c0 vx cv cdif c0 csn wcel wa vx cv c0 wceq
    vx cv c0 wss vx cv c0 wceq c0 vx cv cdif c0 csn wcel vx cv ss0 adantr vx cv
    c0 wceq vx cv c0 wss c0 vx cv cdif c0 csn wcel vx cv c0 eqimss vx cv c0
    wceq c0 vx cv cdif c0 c0 cdif c0 csn vx cv c0 c0 difeq2 c0 c0 cdif c0 c0
    csn c0 difid c0 0ex snid eqeltri syl6eqel jca impbii abbii c0 csn ctop wcel
    c0 csn ccld cfv vx cv c0 wss c0 vx cv cdif c0 csn wcel wa vx cab wceq
    sn0top vx c0 csn c0 c0 csn cuni c0 c0 0ex unisn eqcomi cldval ax-mp vx c0
    df-sn 3eqtr4i ineq2i c0 csn inidm c0 csn c0 c0 cpr c0 c0 csn cuni cpr c0
    dfsn2 c0 c0 csn cuni wceq c0 c0 cpr c0 c0 csn cuni cpr wceq c0 csn cuni c0
    c0 0ex unisn eqcomi c0 c0 csn cuni c0 preq2 ax-mp eqtri 3eqtri c0 csn ctop
    wcel c0 csn ccon wcel c0 csn c0 csn ccld cfv cin c0 c0 csn cuni cpr wceq wb
    sn0top c0 csn iscon ax-mp mpbir $.
    $( [22-Dec-2008] $) $( [22-Dec-2008] $)

  $( ` (/) ` is a connected part of any connected topology. $)
  empcon $p |- ( J e. Con -> ( subSp ` <. (/) , J >. ) e. Con ) $=
    cJ ccon wcel c0 cJ cop csubsp cfv c0 csn ccon cJ ccon wcel cJ ctop wcel c0
    cJ cop csubsp cfv c0 csn wceq ccon ctop cJ contop sseli cJ subspemp2 syl
    singempcon syl6eqel $.
    $( [22-Dec-2008] $) $( [22-Dec-2008] $)

  ${
    topsinind.1 $e |- A e. B $.
    $( The only topology on a singleton is the indiscrete topology. $)
    topsinind $p |- ( J e. Top -> ( U. J = { A } <->
      J = { (/) , { A } } ) ) $=
      cJ ctop wcel c0 cJ cuni cpr cJ wss cJ cJ cuni cpw wss wa cJ cuni cA csn
      wceq cJ c0 cA csn cpr wceq wb cJ topindis c0 cJ cuni cpr cJ wss cJ cJ
      cuni cpw wss wa cJ cuni cA csn wceq cJ c0 cA csn cpr wceq c0 cJ cuni cpr
      cJ wss cJ cJ cuni cpw wss cJ cuni cA csn wceq cJ c0 cA csn cpr wceq wi cJ
      cuni cA csn wceq cJ cJ cuni cpw wss c0 cJ cuni cpr cJ wss cJ c0 cA csn
      cpr wceq cJ cuni cA csn wceq cJ cJ cuni cpw wss c0 cJ cuni cpr cJ wss cJ
      c0 cA csn cpr wceq cJ cuni cA csn wceq cJ cJ cuni cpw wss c0 cJ cuni cpr
      cJ wss wa cJ cA csn cpw wss c0 cA csn cpr cJ wss wa cJ c0 cA csn cpr wceq
      cJ cuni cA csn wceq cJ cJ cuni cpw wss cJ cA csn cpw wss c0 cJ cuni cpr
      cJ wss c0 cA csn cpr cJ wss cJ cuni cA csn wceq cJ cuni cpw cA csn cpw cJ
      cJ cuni cA csn pweq sseq2d cJ cuni cA csn wceq c0 cJ cuni cpr c0 cA csn
      cpr cJ cJ cuni cA csn c0 preq2 sseq1d anbi12d cA csn cpw c0 cA csn cpr
      wceq cJ cA csn cpw wss c0 cA csn cpr cJ wss wa cJ c0 cA csn cpr wceq wi
      cA pwsn cA csn cpw c0 cA csn cpr wceq cJ cA csn cpw wss c0 cA csn cpr cJ
      wss wa cJ c0 cA csn cpr wss c0 cA csn cpr cJ wss wa cJ c0 cA csn cpr wceq
      cA csn cpw c0 cA csn cpr wceq cJ cA csn cpw wss cJ c0 cA csn cpr wss c0
      cA csn cpr cJ wss cA csn cpw c0 cA csn cpr cJ sseq2 anbi1d cJ c0 cA csn
      cpr wceq cJ c0 cA csn cpr wss c0 cA csn cpr cJ wss wa cJ c0 cA csn cpr
      eqss biimpri syl6bi ax-mp syl6bi exp3a com13 imp cJ c0 cA csn cpr wceq cJ
      cuni c0 cA csn cpr cuni cA csn cJ c0 cA csn cpr unieq c0 cA csn cpr cuni
      c0 cA csn cun cA csn c0 cun cA csn c0 cA csn 0ex cA snex unipr cA csn c0
      uncom cA csn un0 3eqtr2i syl6eq impbid1 syl $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${
    singcon.1 $e |- X = U. J $.
    $( A singleton is a connected part of any topology. $)
    singcon $p |- ( ( J e. Top /\ A e. X ) ->
      ( subSp ` <. { A } , J >. ) e. Con ) $=
      cJ ctop wcel cA cX wcel wa cA csn cJ cop csubsp cfv ccon wcel cA csn cJ
      cop csubsp cfv cA csn cJ cop csubsp cfv ccld cfv cin c0 cA csn cJ cop
      csubsp cfv cuni cpr wceq cJ ctop wcel cA cX wcel wa cA csn cJ cop csubsp
      cfv cA csn cJ cop csubsp cfv ccld cfv cin c0 cA csn cJ cop csubsp cfv
      cuni cpr c0 cA csn cJ cop csubsp cfv cuni cpr cin c0 cA csn cJ cop csubsp
      cfv cuni cpr cJ ctop wcel cA cX wcel wa cA csn cJ cop csubsp cfv c0 cA
      csn cJ cop csubsp cfv cuni cpr cA csn cJ cop csubsp cfv ccld cfv c0 cA
      csn cJ cop csubsp cfv cuni cpr cJ ctop wcel cA cX wcel wa cA csn cJ cop
      csubsp cfv c0 cA csn cpr c0 cA csn cJ cop csubsp cfv cuni cpr cA cJ cX
      singcon.1 subtopsin2 cJ ctop wcel cA cX wcel wa cA csn cA csn cJ cop
      csubsp cfv cuni wceq c0 cA csn cpr c0 cA csn cJ cop csubsp cfv cuni cpr
      wceq cJ ctop wcel cA csn cJ cuni wss cA csn cA csn cJ cop csubsp cfv cuni
      wceq cA cX wcel cJ ctop wcel cA csn cJ cuni wss wa cA csn cJ cop csubsp
      cfv cuni cA csn cA csn cJ stoig2 eqcomd cA cX wcel cA csn cJ cuni wss cA
      cX wcel cA cJ cuni wcel cA csn cJ cuni wss cA cX wcel cA cJ cuni cX snssg
      cX cJ cuni cA singcon.1 eleq2i syl5bb ibi sylan2 cA csn cA csn cJ cop
      csubsp cfv cuni c0 preq2 syl eqtrd cJ ctop wcel cA cX wcel wa cA csn cJ
      cop csubsp cfv ccld cfv c0 cA csn cpr ccld cfv c0 cA csn cpr c0 cA csn cJ
      cop csubsp cfv cuni cpr cJ ctop wcel cA cX wcel wa cA csn cJ cop csubsp
      cfv c0 cA csn cpr ccld cA cJ cX singcon.1 subtopsin2 fveq2d c0 cA csn cpr
      ccld cfv c0 cA csn cpr wceq cJ ctop wcel cA cX wcel wa cA csn cvv cA snex
      clindistop a1i cJ ctop wcel cA cX wcel wa cA csn cA csn cJ cop csubsp cfv
      cuni wceq c0 cA csn cpr c0 cA csn cJ cop csubsp cfv cuni cpr wceq cJ ctop
      wcel cA cX wcel wa cA csn cJ cop csubsp cfv cuni cA csn cJ ctop wcel cA
      csn cJ cuni wss cA csn cJ cop csubsp cfv cuni cA csn wceq cA cX wcel cA
      csn cJ stoig2 cA cX wcel cA csn cJ cuni wss cA cX wcel cA cJ cuni wcel cA
      csn cJ cuni wss cA cX wcel cA cJ cuni cX snssg cX cJ cuni cA singcon.1
      eleq2i syl5bb ibi sylan2 eqcomd cA csn cA csn cJ cop csubsp cfv cuni c0
      preq2 syl 3eqtrd ineq12d c0 cA csn cJ cop csubsp cfv cuni cpr inidm
      syl6eq cJ ctop wcel cA cX wcel wa cA csn cJ cop csubsp cfv ctop wcel cA
      csn cJ cop csubsp cfv ccon wcel cA csn cJ cop csubsp cfv cA csn cJ cop
      csubsp cfv ccld cfv cin c0 cA csn cJ cop csubsp cfv cuni cpr wceq wb cJ
      ctop wcel cA csn cJ cuni wss cA csn cJ cop csubsp cfv ctop wcel cA cX
      wcel cA csn cJ stoig3 cA cX wcel cA csn cJ cuni wss cA cX wcel cA cJ cuni
      wcel cA csn cJ cuni wss cA cX wcel cA cJ cuni cX snssg cX cJ cuni cA
      singcon.1 eleq2i syl5bb ibi sylan2 cA csn cJ cop csubsp cfv iscon syl
      mpbird $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Topological groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c TopGrp $.

  $( Extend class notation with the class of all topological groups. $)
  ctopgrp $a class TopGrp $.

  ${
    $d g j $.
    $( Define the class of all topological groups.  A topological group
       is  a group  whose operation and inverse function are
       continuous.  Experimental. $)
    df-topgrp $a |- TopGrp = { <. g , j >. | ( ( g e. Grp /\ j e. Top ) /\
         g e. ( ( j tX j ) Cn j ) /\ ( inv ` g ) e. ( j Cn j ) ) } $.
  $}

  ${
    $d G g j $. $d J g j $. $d x y $.
    $( The predicate "is a topological group". Bourbaki TG III.1 $)
    istopgrp $p |- ( J e. A -> ( <. G , J >. e. TopGrp <->
      ( ( G e. Grp /\ J e. Top ) /\ G e. ( ( J tX J ) Cn J )
        /\ ( inv ` G ) e. ( J Cn J ) ) ) ) $=
      cJ cA wcel cG cJ cop ctopgrp wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ
      ctx co cJ ccn co wcel cG cgn cfv cJ cJ ccn co wcel w3a cG cvv wcel cJ cA
      wcel wa cJ cA wcel cG cJ cop ctopgrp wcel wa cG cvv wcel cJ cA wcel cG cJ
      cop ctopgrp wcel cG cvv wcel cJ cA wcel cG cJ cop ctopgrp wcel cG cJ
      ctopgrp wbr cG cvv wcel cG cJ ctopgrp df-br cG cJ ctopgrp ctopgrp wrel vx
      cv cgr wcel vy cv ctop wcel wa vx cv vy cv vy cv ctx co vy cv ccn co wcel
      vx cv cgn cfv vy cv vy cv ccn co wcel w3a vx vy copab wrel vx cv cgr wcel
      vy cv ctop wcel wa vx cv vy cv vy cv ctx co vy cv ccn co wcel vx cv cgn
      cfv vy cv vy cv ccn co wcel w3a vx vy relopab ctopgrp vx cv cgr wcel vy
      cv ctop wcel wa vx cv vy cv vy cv ctx co vy cv ccn co wcel vx cv cgn cfv
      vy cv vy cv ccn co wcel w3a vx vy copab vx vy df-topgrp releqi mpbir
      brrelexi sylbir adantl cJ cA wcel cG cJ cop ctopgrp wcel pm3.26 jca cJ cA
      wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn co wcel cG cgn
      cfv cJ cJ ccn co wcel w3a wa cG cvv wcel cJ cA wcel cG cgr wcel cJ ctop
      wcel wa cG cJ cJ ctx co cJ ccn co wcel cG cgn cfv cJ cJ ccn co wcel w3a
      cG cvv wcel cJ cA wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn
      co wcel cG cvv wcel cG cgn cfv cJ cJ ccn co wcel cG cgr wcel cG cvv wcel
      cJ ctop wcel cG cgr elisset adantr 3ad2ant1 adantl cJ cA wcel cG cgr wcel
      cJ ctop wcel wa cG cJ cJ ctx co cJ ccn co wcel cG cgn cfv cJ cJ ccn co
      wcel w3a pm3.26 jca cG cvv wcel cJ cA wcel wa cG cJ cop vg cv cgr wcel vj
      cv ctop wcel wa vg cv vj cv vj cv ctx co vj cv ccn co wcel vg cv cgn cfv
      vj cv vj cv ccn co wcel w3a vg vj copab wcel cG cgr wcel cJ ctop wcel wa
      cG cJ cJ ctx co cJ ccn co wcel cG cgn cfv cJ cJ ccn co wcel w3a cG cJ cop
      ctopgrp wcel vg cv cgr wcel vj cv ctop wcel wa vg cv vj cv vj cv ctx co
      vj cv ccn co wcel vg cv cgn cfv vj cv vj cv ccn co wcel w3a cG cgr wcel
      vj cv ctop wcel wa cG vj cv vj cv ctx co vj cv ccn co wcel cG cgn cfv vj
      cv vj cv ccn co wcel w3a cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ
      ccn co wcel cG cgn cfv cJ cJ ccn co wcel w3a vg vj cG cJ cvv cA vg cv cG
      wceq vg cv cgr wcel vj cv ctop wcel wa cG cgr wcel vj cv ctop wcel wa vg
      cv vj cv vj cv ctx co vj cv ccn co wcel cG vj cv vj cv ctx co vj cv ccn
      co wcel vg cv cgn cfv vj cv vj cv ccn co wcel cG cgn cfv vj cv vj cv ccn
      co wcel vg cv cG wceq vg cv cgr wcel cG cgr wcel vj cv ctop wcel vg cv cG
      cgr eleq1 anbi1d vg cv cG vj cv vj cv ctx co vj cv ccn co eleq1 vg cv cG
      wceq vg cv cgn cfv cG cgn cfv vj cv vj cv ccn co vg cv cG cgn fveq2
      eleq1d 3anbi123d vj cv cJ wceq cG cgr wcel vj cv ctop wcel wa cG cgr wcel
      cJ ctop wcel wa cG vj cv vj cv ctx co vj cv ccn co wcel cG cJ cJ ctx co
      cJ ccn co wcel cG cgn cfv vj cv vj cv ccn co wcel cG cgn cfv cJ cJ ccn co
      wcel vj cv cJ wceq vj cv ctop wcel cJ ctop wcel cG cgr wcel vj cv cJ ctop
      eleq1 anbi2d vj cv cJ wceq vj cv vj cv ctx co vj cv ccn co cJ cJ ctx co
      cJ ccn co cG vj cv cJ wceq vj cv vj cv ctx co cJ cJ ctx co vj cv cJ ccn
      vj cv cJ wceq vj cv cJ vj cv cJ ctx vj cv cJ wceq id vj cv cJ wceq id
      opreq12d vj cv cJ wceq id opreq12d eleq2d vj cv cJ wceq vj cv vj cv ccn
      co cJ cJ ccn co cG cgn cfv vj cv cJ wceq vj cv cJ vj cv cJ ccn vj cv cJ
      wceq id vj cv cJ wceq id opreq12d eleq2d 3anbi123d opelopabg ctopgrp vg
      cv cgr wcel vj cv ctop wcel wa vg cv vj cv vj cv ctx co vj cv ccn co wcel
      vg cv cgn cfv vj cv vj cv ccn co wcel w3a vg vj copab cG cJ cop vg vj
      df-topgrp eleq2i syl5bb pm5.21nd $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
    topgrpi.1 $e |- G = ( 1st ` K ) $.
    ${
      topgrpi.2 $e |- J = ( 2nd ` K ) $.
      ${
        $d G g j $. $d J g j $. $d K g j $. $d N g j $.
        topgrpi.3 $e |- N = ( inv ` G ) $.
        $( "Axioms" of a topological group. $)
        topgrpi $p |- ( K e. TopGrp -> ( ( G e. Grp /\ J e. Top ) /\
          G e. ( ( J tX J ) Cn J ) /\ N e. ( J Cn J ) ) )  $=
          cK ctopgrp wcel cK vg cv cgr wcel vj cv ctop wcel wa vg cv vj cv vj
          cv ctx co vj cv ccn co wcel vg cv cgn cfv vj cv vj cv ccn co wcel w3a
          vg vj copab wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn
          co wcel cN cJ cJ ccn co wcel w3a ctopgrp vg cv cgr wcel vj cv ctop
          wcel wa vg cv vj cv vj cv ctx co vj cv ccn co wcel vg cv cgn cfv vj
          cv vj cv ccn co wcel w3a vg vj copab cK vg vj df-topgrp eleq2i vg cv
          cgr wcel vj cv ctop wcel wa vg cv vj cv vj cv ctx co vj cv ccn co
          wcel vg cv cgn cfv vj cv vj cv ccn co wcel w3a cG cgr wcel vj cv ctop
          wcel wa cG vj cv vj cv ctx co vj cv ccn co wcel cN vj cv vj cv ccn co
          wcel w3a cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn co wcel
          cN cJ cJ ccn co wcel w3a vg vj cK cG cK c1st cfv wceq vg cv cK c1st
          cfv wceq vg cv cgr wcel vj cv ctop wcel wa vg cv vj cv vj cv ctx co
          vj cv ccn co wcel vg cv cgn cfv vj cv vj cv ccn co wcel w3a cG cgr
          wcel vj cv ctop wcel wa cG vj cv vj cv ctx co vj cv ccn co wcel cN vj
          cv vj cv ccn co wcel w3a wb topgrpi.1 cG cK c1st cfv wceq vg cv cK
          c1st cfv wceq wa vg cv cG wceq vg cv cgr wcel vj cv ctop wcel wa vg
          cv vj cv vj cv ctx co vj cv ccn co wcel vg cv cgn cfv vj cv vj cv ccn
          co wcel w3a cG cgr wcel vj cv ctop wcel wa cG vj cv vj cv ctx co vj
          cv ccn co wcel cN vj cv vj cv ccn co wcel w3a wb cG cK c1st cfv wceq
          vg cv cK c1st cfv wceq wa cG vg cv cG vg cv cK c1st cfv eqtr3 eqcomd
          vg cv cG wceq vg cv cgr wcel vj cv ctop wcel wa cG cgr wcel vj cv
          ctop wcel wa vg cv vj cv vj cv ctx co vj cv ccn co wcel cG vj cv vj
          cv ctx co vj cv ccn co wcel vg cv cgn cfv vj cv vj cv ccn co wcel cN
          vj cv vj cv ccn co wcel vg cv cG wceq vg cv cgr wcel cG cgr wcel vj
          cv ctop wcel vg cv cG cgr eleq1 anbi1d vg cv cG vj cv vj cv ctx co vj
          cv ccn co eleq1 vg cv cG wceq vg cv cgn cfv cN vj cv vj cv ccn co vg
          cv cG wceq vg cv cgn cfv cG cgn cfv cN vg cv cG cgn fveq2 topgrpi.3
          syl6eqr eleq1d 3anbi123d syl mpan cJ cK c2nd cfv wceq vj cv cK c2nd
          cfv wceq cG cgr wcel vj cv ctop wcel wa cG vj cv vj cv ctx co vj cv
          ccn co wcel cN vj cv vj cv ccn co wcel w3a cG cgr wcel cJ ctop wcel
          wa cG cJ cJ ctx co cJ ccn co wcel cN cJ cJ ccn co wcel w3a wb
          topgrpi.2 cJ cK c2nd cfv wceq vj cv cK c2nd cfv wceq wa vj cv cJ wceq
          cG cgr wcel vj cv ctop wcel wa cG vj cv vj cv ctx co vj cv ccn co
          wcel cN vj cv vj cv ccn co wcel w3a cG cgr wcel cJ ctop wcel wa cG cJ
          cJ ctx co cJ ccn co wcel cN cJ cJ ccn co wcel w3a wb cJ cK c2nd cfv
          wceq vj cv cK c2nd cfv wceq wa cJ vj cv cJ vj cv cK c2nd cfv eqtr3
          eqcomd vj cv cJ wceq cG cgr wcel vj cv ctop wcel wa cG cgr wcel cJ
          ctop wcel wa cG vj cv vj cv ctx co vj cv ccn co wcel cG cJ cJ ctx co
          cJ ccn co wcel cN vj cv vj cv ccn co wcel cN cJ cJ ccn co wcel vj cv
          cJ wceq vj cv ctop wcel cJ ctop wcel cG cgr wcel vj cv cJ ctop eleq1
          anbi2d vj cv cJ wceq vj cv vj cv ctx co vj cv ccn co cJ cJ ctx co cJ
          ccn co cG vj cv vj cv ctx co cJ cJ ctx co wceq vj cv cJ wceq vj cv vj
          cv ctx co vj cv ccn co cJ cJ ctx co cJ ccn co wceq vj cv cJ wceq vj
          cv vj cv ctx co cJ cJ ctx co wceq vj cv cJ vj cv cJ ctx opreq12
          anidms vj cv vj cv ctx co cJ cJ ctx co vj cv cJ ccn opreq12 mpancom
          eleq2d vj cv cJ wceq vj cv vj cv ccn co cJ cJ ccn co cN vj cv cJ wceq
          vj cv vj cv ccn co cJ cJ ccn co wceq vj cv cJ vj cv cJ ccn opreq12
          anidms eleq2d 3anbi123d syl mpan elopabi sylbi $.
          $( [18-Apr-2010] $) $( [18-Apr-2010] $)

        $( In a topological group, the inverse function is continuous. $)
        topgrpinv $p |- ( K e. TopGrp -> N e. ( J Cn J ) ) $=
          cK ctopgrp wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn co
          wcel cN cJ cJ ccn co wcel cG cJ cK cN topgrpi.1 topgrpi.2 topgrpi.3
          topgrpi 3simp3d $.
          $( [21-Jun-2010] $) $( [21-Jun-2010] $)
      $}

      $( In a topological group, the base set of the topology and the base
         set of the group are equal. $)
      topgrpbs $p |- ( K e. TopGrp -> ran G = U. J ) $=
        cK ctopgrp wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn co
        wcel cG cgn cfv cJ cJ ccn co wcel w3a cG crn cJ cuni wceq cG cJ cK cG
        cgn cfv topgrpi.1 topgrpi.2 cG cgn cfv eqid topgrpi cG cgr wcel cJ ctop
        wcel wa cG cgn cfv cJ cJ ccn co wcel cG crn cJ cuni wceq cG cJ cJ ctx
        co cJ ccn co wcel cG cgr wcel cJ ctop wcel cG cgn cfv cJ cJ ccn co wcel
        cG crn cJ cuni wceq cG cgr wcel cG crn cG crn cG cgn cfv wf1o cJ ctop
        wcel cG cgn cfv cJ cJ ccn co wcel cG crn cJ cuni wceq wi wi cG cG cgn
        cfv cG crn cG crn eqid cG cgn cfv eqid grpinvf cJ ctop wcel cG cgn cfv
        cJ cJ ccn co wcel cG crn cG crn cG cgn cfv wf1o cG crn cJ cuni wceq cJ
        ctop wcel cG cgn cfv cJ cJ ccn co wcel cG crn cG crn cG cgn cfv wf1o cG
        crn cJ cuni wceq wi wi cJ ctop wcel cJ ctop wcel cG cgn cfv cJ cJ ccn
        co wcel cG crn cG crn cG cgn cfv wf1o cG crn cJ cuni wceq wi cG crn cG
        crn cG cgn cfv wf1o cJ cuni cJ cuni cG cgn cfv wf cG crn cJ cuni wceq
        cJ ctop wcel cJ ctop wcel cG cgn cfv cJ cJ ccn co wcel w3a cG crn cG
        crn cG cgn cfv wf1o cG crn cG crn cG cgn cfv wf cJ cuni cJ cuni cG cgn
        cfv wf cG crn cJ cuni wceq wi cG crn cG crn cG cgn cfv f1of cG crn cG
        crn cG cgn cfv wf cG cgn cfv cdm cG crn wceq cJ cuni cJ cuni cG cgn cfv
        wf cG crn cJ cuni wceq wi cG crn cG crn cG cgn cfv fdm cG cgn cfv cdm
        cG crn wceq cG cgn cfv cdm cJ cuni wceq cG crn cJ cuni wceq cJ cuni cJ
        cuni cG cgn cfv wf cG cgn cfv cdm cG crn wceq cG cgn cfv cdm cJ cuni
        wceq cG crn cJ cuni wceq cG cgn cfv cdm cG crn cJ cuni eqtr2 ex cJ cuni
        cJ cuni cG cgn cfv fdm syl5 syl syl cG cgn cfv cJ cJ cJ cuni cJ cuni cJ
        cuni eqid cJ cuni eqid cnf syl5com 3exp pm2.43i com3r syl imp31 3adant2
        syl $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)

      $( In a topological group, the operation ` G ` is continuous. $)
      topgrpcn $p |- ( K e. TopGrp -> G e. ( ( J tX J ) Cn J ) ) $=
        cK ctopgrp wcel cG cgr wcel cJ ctop wcel wa cG cJ cJ ctx co cJ ccn co
        wcel cG cgn cfv cJ cJ ccn co wcel cG cJ cK cG cgn cfv topgrpi.1
        topgrpi.2 cG cgn cfv eqid topgrpi 3simp2d $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    $( In a topological group, the operation ` G ` is a group. $)
    topgrpgrp $p |- ( K e. TopGrp -> G e. Grp ) $=
      cK ctopgrp wcel cG cgr wcel cK c2nd cfv ctop wcel cK ctopgrp wcel cG cgr
      wcel cK c2nd cfv ctop wcel wa cG cK c2nd cfv cK c2nd cfv ctx co cK c2nd
      cfv ccn co wcel cG cgn cfv cK c2nd cfv cK c2nd cfv ccn co wcel cG cK c2nd
      cfv cK cG cgn cfv topgrpi.1 cK c2nd cfv eqid cG cgn cfv eqid topgrpi
      3simp1d pm3.26d $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${
    topgrptop.1 $e |- J = ( 2nd ` K ) $.
    $( In a topological group, ` J ` is a topology. $)
    topgrptop $p |- ( K e. TopGrp -> J e. Top ) $=
      cK ctopgrp wcel cK c1st cfv cgr wcel cJ ctop wcel cK ctopgrp wcel cK c1st
      cfv cgr wcel cJ ctop wcel wa cK c1st cfv cJ cJ ctx co cJ ccn co wcel cK
      c1st cfv cgn cfv cJ cJ ccn co wcel cK c1st cfv cJ cK cK c1st cfv cgn cfv
      cK c1st cfv eqid topgrptop.1 cK c1st cfv cgn cfv eqid topgrpi 3simp1d
      pm3.27d $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${
    extopgrp.1 $e |- A e. B $.
    ${
      $d A x y $.
      $( The identity element of the trivial group. $)
      idtrgrp $p |- ( Id ` { <. <. A , A >. , A >. } ) = A $=
        cA cA cop cA cop csn cgi cfv vx cv vy cv cA cA cop cA cop csn co vy cv
        wceq vy cA csn wral vx cA csn crab cuni cA vy vx cA cA cop cA cop csn
        cgi cfv cA cA cop cA cop csn cA csn cA cA cop cA cop csn crn cA csn cA
        cA cop cA cA cA opex cA cB extopgrp.1 elisseti rnsnop eqcomi cA cA cop
        cA cop csn cgi cfv eqid cA cA cB extopgrp.1 elisseti grpsn grpidvallem
        vx cv vy cv cA cA cop cA cop csn co vy cv wceq vy cA csn wral vx cA csn
        crab cuni cA csn cuni cA vx cv vy cv cA cA cop cA cop csn co vy cv wceq
        vy cA csn wral vx cA csn crab cA csn vx cv cA csn wcel vx cv vy cv cA
        cA cop cA cop csn co vy cv wceq vy cA csn wral wa vx cab vx cv cA wceq
        vx cab vx cv vy cv cA cA cop cA cop csn co vy cv wceq vy cA csn wral vx
        cA csn crab cA csn vx cv cA csn wcel vx cv vy cv cA cA cop cA cop csn
        co vy cv wceq vy cA csn wral wa vx cv cA wceq vx vx cv cA csn wcel vx
        cv vy cv cA cA cop cA cop csn co vy cv wceq vy cA csn wral wa vx cv cA
        wceq vx cv cA csn wcel vx cv cA wceq vx cv vy cv cA cA cop cA cop csn
        co vy cv wceq vy cA csn wral vx cv cA elsni adantr vx cv cA wceq vx cv
        cA csn wcel vx cv vy cv cA cA cop cA cop csn co vy cv wceq vy cA csn
        wral vx cv cA csn wcel vx cv cA wceq vx cA elsn biimpri vx cv cA wceq
        vx cv vy cv cA cA cop cA cop csn co vy cv wceq vy cA csn wral cA vy cv
        cA cA cop cA cop csn co vy cv wceq vy cA csn wral cA vy cv cA cA cop cA
        cop csn co vy cv wceq vy cA csn vy cv cA csn wcel vy cv cA wceq cA vy
        cv cA cA cop cA cop csn co vy cv wceq vy cv cA elsni vy cv cA wceq cA
        cA cA cA cop cA cop csn co cA cA vy cv cA cA cop cA cop csn co vy cv cA
        cA cA cA cop cA cop csn co cA cA vx cv cA cA cop csn wcel vy cv cA wceq
        wa vx vy copab co cA cA cop vx cv cA cA cop csn wcel vy cv cA wceq wa
        vx vy copab cfv cA cA cA cop cA cop csn vx cv cA cA cop csn wcel vy cv
        cA wceq wa vx vy copab cA cA vx vy cA cA cop cA cA cA opex cA cB
        extopgrp.1 elisseti fopabsn opreqi cA cA vx cv cA cA cop csn wcel vy cv
        cA wceq wa vx vy copab df-opr cA cA cop cA cA cop csn wcel cA cA cop vx
        cv cA cA cop csn wcel vy cv cA wceq wa vx vy copab cfv cA wceq cA cA
        cop cA cA opex snid vx vy cA cA cop cA cA cA cA cop csn vx cv cA cA cop
        csn wcel vy cv cA wceq wa vx vy copab vx cv cA cA cop wceq cA eqidd vx
        cv cA cA cop csn wcel vy cv cA wceq wa vx vy copab eqid cA cB
        extopgrp.1 elisseti fvopab4 ax-mp 3eqtri vy cv cA cA cA cA cop cA cop
        csn opreq2 vy cv cA wceq id 3eqtr4a syl rgen vx cv cA wceq vx cv vy cv
        cA cA cop cA cop csn co vy cv wceq cA vy cv cA cA cop cA cop csn co vy
        cv wceq vy cA csn vx cv cA wceq vx cv vy cv cA cA cop cA cop csn co cA
        vy cv cA cA cop cA cop csn co vy cv vx cv cA vy cv cA cA cop cA cop csn
        opreq1 eqeq1d ralbidv mpbiri jca impbii abbii vx cv vy cv cA cA cop cA
        cop csn co vy cv wceq vy cA csn wral vx cA csn df-rab vx cA df-sn
        3eqtr4i unieqi cA cA cB extopgrp.1 elisseti unisn eqtri eqtri $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d A x y z $.
      $( The inverse function of the trivial group. $)
      invtrgrp $p |- ( inv ` { <. <. A , A >. , A >. } ) = ( _I |` { A } ) $=
        cA cA cop cA cop csn cgn cfv vx cv cA csn wcel vy cv vz cv vx cv cA cA
        cop cA cop csn co cA wceq vz cA csn crab cuni wceq wa vx vy copab cid
        cA csn cres cA cA cop cA cop csn cgr wcel cA cA cop cA cop csn cgn cfv
        vx cv cA csn wcel vy cv vz cv vx cv cA cA cop cA cop csn co cA wceq vz
        cA csn crab cuni wceq wa vx vy copab wceq cA cA cB extopgrp.1 elisseti
        grpsn vx vz cA vy cA cA cop cA cop csn cA cA cop cA cop csn cgn cfv cA
        csn cA cA cop cA cop csn crn cA csn cA cA cop cA cA cA opex cA cB
        extopgrp.1 elisseti rnsnop eqcomi cA cA cop cA cop csn cgi cfv cA cA cB
        extopgrp.1 idtrgrp eqcomi cA cA cop cA cop csn cgn cfv eqid grpinvfval
        ax-mp cid cA csn cres cA csn cA csn cxp vx cv cA csn wcel vy cv cA wceq
        wa vx vy copab vx cv cA csn wcel vy cv vz cv vx cv cA cA cop cA cop csn
        co cA wceq vz cA csn crab cuni wceq wa vx vy copab cA restidsing vx vy
        cA csn cA fconstopab vx cv cA csn wcel vy cv cA wceq wa vx cv cA csn
        wcel vy cv vz cv vx cv cA cA cop cA cop csn co cA wceq vz cA csn crab
        cuni wceq wa vx vy vx cv cA csn wcel vy cv cA wceq vy cv vz cv vx cv cA
        cA cop cA cop csn co cA wceq vz cA csn crab cuni wceq vx cv cA csn wcel
        cA vz cv vx cv cA cA cop cA cop csn co cA wceq vz cA csn crab cuni vy
        cv vx cv cA csn wcel vx cv cA wceq cA vz cv vx cv cA cA cop cA cop csn
        co cA wceq vz cA csn crab cuni wceq vx cA elsn vx cv cA wceq vz cv vx
        cv cA cA cop cA cop csn co cA wceq vz cA csn crab cuni vz cv cA cA cA
        cop cA cop csn co cA wceq vz cA csn crab cuni cA vx cv cA wceq vz cv vx
        cv cA cA cop cA cop csn co cA wceq vz cA csn crab vz cv cA cA cA cop cA
        cop csn co cA wceq vz cA csn crab vx cv cA wceq vz cv vx cv cA cA cop
        cA cop csn co cA wceq vz cv cA cA cA cop cA cop csn co cA wceq vz cA
        csn vx cv cA wceq vz cv cA csn wcel wa vz cv vx cv cA cA cop cA cop csn
        co vz cv cA cA cA cop cA cop csn co cA vx cv cA wceq vz cv cA csn wcel
        wa vx cv cA vz cv cA cA cop cA cop csn vx cv cA wceq vz cv cA csn wcel
        pm3.26 opreq2d eqeq1d rabbidv unieqd vz cv cA cA cA cop cA cop csn co
        cA wceq vz cA csn crab cuni cA wceq cA cA cA cA cop cA cop csn co cA
        wceq cA cA cA cA cop cA cop csn co cA cA cop cA cA cop cA cop csn cfv
        cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA opex cA cB
        extopgrp.1 elisseti fvsn eqtri cA cA csn wcel vz cv cA cA cA cop cA cop
        csn co cA wceq vz cA csn wreu vz cv cA cA cA cop cA cop csn co cA wceq
        vz cA csn crab cuni cA wceq cA cA cA cA cop cA cop csn co cA wceq wb cA
        cA cB extopgrp.1 elisseti snid vz cv cA cA cA cop cA cop csn co cA wceq
        vz cA csn wreu vz cv cA csn wcel vz cv cA cA cA cop cA cop csn co cA
        wceq wa vz weu vz cv cA csn wcel vz cv cA cA cA cop cA cop csn co cA
        wceq wa vz weu vz cv cA csn wcel vz cv cA cA cA cop cA cop csn co cA
        wceq wa vz vy weq wb vz wal vy wex cA cB wcel vz cv cA csn wcel vz cv
        cA cA cA cop cA cop csn co cA wceq wa vz cv cA wceq wb vz wal vz cv cA
        csn wcel vz cv cA cA cA cop cA cop csn co cA wceq wa vz vy weq wb vz
        wal vy wex extopgrp.1 vz cv cA csn wcel vz cv cA cA cA cop cA cop csn
        co cA wceq wa vz cv cA wceq wb vz vz cv cA csn wcel vz cv cA cA cA cop
        cA cop csn co cA wceq wa vz cv cA wceq vz cv cA csn wcel vz cv cA wceq
        vz cv cA cA cA cop cA cop csn co cA wceq vz cv cA elsni adantr vz cv cA
        wceq vz cv cA csn wcel vz cv cA cA cA cop cA cop csn co cA wceq vz cv
        cA csn wcel vz cv cA wceq vz cA elsn biimpri vz cv cA wceq vz cv cA cA
        cA cop cA cop csn co cA cA cA cA cop cA cop csn co cA vz cv cA cA cA cA
        cop cA cop csn opreq1 cA cA cA cA cop cA cop csn co cA cA cop cA cA cop
        cA cop csn cfv cA cA cA cA cA cop cA cop csn df-opr cA cA cop cA cA cA
        opex cA cB extopgrp.1 elisseti fvsn eqtri syl6eq jca impbii ax-gen vz
        cv cA csn wcel vz cv cA cA cA cop cA cop csn co cA wceq wa vz vy weq wb
        vz wal vz cv cA csn wcel vz cv cA cA cA cop cA cop csn co cA wceq wa vz
        cv cA wceq wb vz wal vy cA cB vy cv cA wceq vz cv cA csn wcel vz cv cA
        cA cA cop cA cop csn co cA wceq wa vz vy weq wb vz cv cA csn wcel vz cv
        cA cA cA cop cA cop csn co cA wceq wa vz cv cA wceq wb vz vy cv cA wceq
        vz vy weq vz cv cA wceq vz cv cA csn wcel vz cv cA cA cA cop cA cop csn
        co cA wceq wa vy cv cA vz cv eqeq2 bibi2d albidv cla4egv mp2 vz cv cA
        csn wcel vz cv cA cA cA cop cA cop csn co cA wceq wa vz vy df-eu mpbir
        vz cv cA cA cA cop cA cop csn co cA wceq vz cA csn df-reu mpbir cA cA
        csn wcel vz cv cA cA cA cop cA cop csn co cA wceq vz cA csn wreu wa cA
        cA cA cA cop cA cop csn co cA wceq vz cv cA cA cA cop cA cop csn co cA
        wceq vz cA csn crab cuni cA wceq vz cv cA cA cA cop cA cop csn co cA
        wceq cA cA cA cA cop cA cop csn co cA wceq vz cA csn cA vz cv cA wceq
        vz cv cA cA cA cop cA cop csn co cA cA cA cA cop cA cop csn co cA vz cv
        cA cA cA cA cop cA cop csn opreq1 eqeq1d reuuni2 bicomd mp2an mpbir
        syl6req sylbi eqeq2d pm5.32i opabbii 3eqtrri eqtri $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    $( The trivial  topological group. $)
    extopgrp $p |- <. { <. <. A , A >. , A >. } , { (/) , { A } } >.
       e. TopGrp $=
      cA cA cop cA cop csn c0 cA csn cpr cop ctopgrp wcel cA cA cop cA cop csn
      cgr wcel c0 cA csn cpr ctop wcel wa cA cA cop cA cop csn c0 cA csn cpr c0
      cA csn cpr ctx co c0 cA csn cpr ccn co wcel cA cA cop cA cop csn cgn cfv
      c0 cA csn cpr c0 cA csn cpr ccn co wcel w3a cA cA cop cA cop csn cgr wcel
      c0 cA csn cpr ctop wcel wa cA cA cop cA cop csn c0 cA csn cpr c0 cA csn
      cpr ctx co c0 cA csn cpr ccn co wcel cA cA cop cA cop csn cgn cfv c0 cA
      csn cpr c0 cA csn cpr ccn co wcel cA cA cop cA cop csn cgr wcel c0 cA csn
      cpr ctop wcel cA cA cB extopgrp.1 elisseti grpsn cA csn indistop pm3.2i
      c0 cA csn cpr c0 cA csn cpr ctx co ctop wcel cA csn cA csn cxp cA csn cA
      cA cop cA cop csn wf cA cA cop cA cop csn c0 cA csn cpr c0 cA csn cpr ctx
      co c0 cA csn cpr ccn co wcel c0 cA csn cpr ctop wcel c0 cA csn cpr ctop
      wcel c0 cA csn cpr c0 cA csn cpr ctx co ctop wcel cA csn indistop cA csn
      indistop c0 cA csn cpr c0 cA csn cpr c0 cA csn cpr c0 cA csn cpr ctx co
      c0 cA csn cpr c0 cA csn cpr ctx co eqid txtop mp2an cA cA cop cA cop csn
      cgr wcel cA csn cA csn cxp cA csn cA cA cop cA cop csn wf cA cA cB
      extopgrp.1 elisseti grpsn cA cA cop cA cop csn cgr wcel cA csn cA csn cxp
      cA csn cA cA cop cA cop csn wfo cA csn cA csn cxp cA csn cA cA cop cA cop
      csn wf cA cA cop cA cop csn cA csn cA cA cop cA cop csn crn cA csn cA cA
      cop cA cA cA opex cA cB extopgrp.1 elisseti rnsnop eqcomi grpfo cA csn cA
      csn cxp cA csn cA cA cop cA cop csn fof syl ax-mp cA csn cA csn cxp cA
      csn cA cA cop cA cop csn c0 cA csn cpr c0 cA csn cpr ctx co c0 cA csn cpr
      c0 cA csn cpr ctx co cuni cA csn cA csn cxp c0 cA csn cpr ctop wcel c0 cA
      csn cpr ctop wcel c0 cA csn cpr c0 cA csn cpr ctx co cuni cA csn cA csn
      cxp wceq cA csn indistop cA csn indistop c0 cA csn cpr c0 cA csn cpr c0
      cA csn cpr c0 cA csn cpr ctx co cA csn cA csn c0 cA csn cpr c0 cA csn cpr
      ctx co eqid c0 cA csn cpr cuni c0 cA csn cun cA csn c0 cun cA csn c0 cA
      csn 0ex cA snex unipr c0 cA csn uncom cA csn un0 3eqtrri c0 cA csn cpr
      cuni c0 cA csn cun cA csn c0 cun cA csn c0 cA csn 0ex cA snex unipr c0 cA
      csn uncom cA csn un0 3eqtrri txuni mp2an eqcomi cA snex mapudiscn mp2an
      cA cA cop cA cop csn cgn cfv cid cA csn cres c0 cA csn cpr c0 cA csn cpr
      ccn co cA cB extopgrp.1 invtrgrp c0 cA csn cpr ctop wcel cid cA csn cres
      c0 cA csn cpr c0 cA csn cpr ccn co wcel cA csn indistop c0 cA csn cpr cA
      csn c0 cA csn cpr cuni c0 cA csn cun cA csn c0 cun cA csn c0 cA csn 0ex
      cA snex unipr c0 cA csn uncom cA csn un0 3eqtrri idcn ax-mp eqeltri
      3pm3.2i c0 cA csn cpr cvv wcel cA cA cop cA cop csn c0 cA csn cpr cop
      ctopgrp wcel cA cA cop cA cop csn cgr wcel c0 cA csn cpr ctop wcel wa cA
      cA cop cA cop csn c0 cA csn cpr c0 cA csn cpr ctx co c0 cA csn cpr ccn co
      wcel cA cA cop cA cop csn cgn cfv c0 cA csn cpr c0 cA csn cpr ccn co wcel
      w3a wb c0 cA csn prex cvv cA cA cop cA cop csn c0 cA csn cpr istopgrp
      ax-mp mpbir $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${
    topgrpsubcn.1 $e |- G = ( 1st ` K ) $.
    topgrpsubcn.2 $e |- J = ( 2nd ` K ) $.
    topgrpsubcn.3 $e |- D = ( /g ` G ) $.
    ${
      $d G u x y z $. $d J u x y $.
      topgrpsubcn.4 $e |- K e. TopGrp $.
      $( Lemma for ~ topgrpsubcn . $)
      topgrpsubcnlem $p |- D e. ( ( J tX J ) Cn J ) $=
        cD vx cv cG crn wcel vy cv cG crn wcel wa vz cv vx cv vy cv cG cgn cfv
        cfv cG co wceq wa vx vy vz copab2 cJ cJ ctx co cJ ccn co cK ctopgrp
        wcel cD vx cv cG crn wcel vy cv cG crn wcel wa vz cv vx cv vy cv cG cgn
        cfv cfv cG co wceq wa vx vy vz copab2 wceq topgrpsubcn.4 cK ctopgrp
        wcel cG cgr wcel cD vx cv cG crn wcel vy cv cG crn wcel wa vz cv vx cv
        vy cv cG cgn cfv cfv cG co wceq wa vx vy vz copab2 wceq cG cK
        topgrpsubcn.1 topgrpgrp vx vy vz cD cG cG cgn cfv cG crn cG crn eqid cG
        cgn cfv eqid topgrpsubcn.3 grpdivfval syl ax-mp vx cv cG crn wcel vy cv
        cG crn wcel wa vz cv vx cv vy cv cG cgn cfv cfv cG co wceq wa vx vy vz
        copab2 cG vx cv cG crn wcel vy cv cG crn wcel wa vu cv vx cv vy cv cG
        cgn cfv cfv cop wceq wa vx vy vu copab2 ccom cJ cJ ctx co cJ ccn co cK
        ctopgrp wcel vx cv cG crn wcel vy cv cG crn wcel wa vz cv vx cv vy cv
        cG cgn cfv cfv cG co wceq wa vx vy vz copab2 cG vx cv cG crn wcel vy cv
        cG crn wcel wa vu cv vx cv vy cv cG cgn cfv cfv cop wceq wa vx vy vu
        copab2 ccom wceq topgrpsubcn.4 cK ctopgrp wcel cG cG crn cG crn cxp wfn
        vx cv cG crn wcel vy cv cG crn wcel wa vz cv vx cv vy cv cG cgn cfv cfv
        cG co wceq wa vx vy vz copab2 cG vx cv cG crn wcel vy cv cG crn wcel wa
        vu cv vx cv vy cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 ccom wceq
        cK ctopgrp wcel cG cgr wcel cG crn cG crn cxp cG crn cG wfo cG cG crn
        cG crn cxp wfn cG cK topgrpsubcn.1 topgrpgrp cG cG crn cG crn eqid
        grpfo cG crn cG crn cxp cG crn cG fofn 3syl vx vy vu vz cG crn cG crn
        vx cv vy cv cG cgn cfv cfv cG crn cG crn vx cv cG crn wcel vy cv cG crn
        wcel wa vu cv vx cv vy cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 vx
        cv cG crn wcel vy cv cG crn wcel wa vz cv vx cv vy cv cG cgn cfv cfv cG
        co wceq wa vx vy vz copab2 cG vx cv cG crn wcel vy cv cG crn wcel
        pm3.26 vy cv cG crn wcel vy cv cG cgn cfv cfv cG crn wcel vx cv cG crn
        wcel cK ctopgrp wcel vy cv cG crn wcel vy cv cG cgn cfv cfv cG crn wcel
        wi topgrpsubcn.4 cK ctopgrp wcel cG cgr wcel vy cv cG crn wcel vy cv cG
        cgn cfv cfv cG crn wcel wi cG cK topgrpsubcn.1 topgrpgrp cG cgr wcel vy
        cv cG crn wcel vy cv cG cgn cfv cfv cG crn wcel vy cv cG cG cgn cfv cG
        crn cG crn eqid cG cgn cfv eqid grpinvcl ex syl ax-mp adantl vx cv cG
        crn wcel vy cv cG crn wcel wa vu cv vx cv vy cv cG cgn cfv cfv cop wceq
        wa vx vy vu copab2 eqid vx cv cG crn wcel vy cv cG crn wcel wa vz cv vx
        cv vy cv cG cgn cfv cfv cG co wceq wa vx vy vz copab2 eqid oprab2co syl
        ax-mp cJ cJ ctx co ctop wcel cJ cJ ctx co ctop wcel cJ ctop wcel w3a vx
        cv cG crn wcel vy cv cG crn wcel wa vu cv vx cv vy cv cG cgn cfv cfv
        cop wceq wa vx vy vu copab2 cJ cJ ctx co cJ cJ ctx co ccn co wcel cG cJ
        cJ ctx co cJ ccn co wcel wa wa cG vx cv cG crn wcel vy cv cG crn wcel
        wa vu cv vx cv vy cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 ccom cJ
        cJ ctx co cJ ccn co wcel cK ctopgrp wcel cJ cJ ctx co ctop wcel cJ cJ
        ctx co ctop wcel cJ ctop wcel w3a vx cv cG crn wcel vy cv cG crn wcel
        wa vu cv vx cv vy cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 cJ cJ
        ctx co cJ cJ ctx co ccn co wcel cG cJ cJ ctx co cJ ccn co wcel wa wa
        topgrpsubcn.4 cK ctopgrp wcel cJ cJ ctx co ctop wcel cJ cJ ctx co ctop
        wcel cJ ctop wcel w3a vx cv cG crn wcel vy cv cG crn wcel wa vu cv vx
        cv vy cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 cJ cJ ctx co cJ cJ
        ctx co ccn co wcel cG cJ cJ ctx co cJ ccn co wcel cK ctopgrp wcel cJ cJ
        ctx co ctop wcel cJ cJ ctx co ctop wcel cJ ctop wcel cJ ctop wcel cJ
        ctop wcel cJ cJ ctx co ctop wcel cK ctopgrp wcel cJ cJ cJ cJ ctx co cJ
        cJ ctx co eqid txtop cJ cK topgrpsubcn.2 topgrptop cJ cK topgrpsubcn.2
        topgrptop sylanc cJ ctop wcel cJ ctop wcel cJ cJ ctx co ctop wcel cK
        ctopgrp wcel cJ cJ cJ cJ ctx co cJ cJ ctx co eqid txtop cJ cK
        topgrpsubcn.2 topgrptop cJ cK topgrpsubcn.2 topgrptop sylanc cJ cK
        topgrpsubcn.2 topgrptop 3jca cK ctopgrp wcel vx cv cG crn wcel vy cv cG
        crn wcel wa vu cv vx cv cid cG crn cres cfv vy cv cG cgn cfv cfv cop
        wceq wa vx vy vu copab2 cJ cJ ctx co cJ cJ ctx co ccn co vx cv cG crn
        wcel vy cv cG crn wcel wa vu cv vx cv vy cv cG cgn cfv cfv cop wceq wa
        vx vy vu copab2 cJ ctop wcel cJ ctop wcel wa cJ ctop wcel cJ ctop wcel
        wa cid cG crn cres cJ cJ ccn co wcel cG cgn cfv cJ cJ ccn co wcel wa vx
        cv cG crn wcel vy cv cG crn wcel wa vu cv vx cv cid cG crn cres cfv vy
        cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 cJ cJ ctx co cJ cJ ctx co
        ccn co wcel cK ctopgrp wcel vx vy vu cJ cJ cJ cJ ctx co cid cG crn cres
        cG cgn cfv vx cv cG crn wcel vy cv cG crn wcel wa vu cv vx cv cid cG
        crn cres cfv vy cv cG cgn cfv cfv cop wceq wa vx vy vu copab2 cJ cJ cJ
        cJ ctx co cG crn cG crn cJ cJ ctx co eqid cJ cJ ctx co eqid cK ctopgrp
        wcel cG crn cJ cuni wceq topgrpsubcn.4 cG cJ cK topgrpsubcn.1
        topgrpsubcn.2 topgrpbs ax-mp cK ctopgrp wcel cG crn cJ cuni wceq
        topgrpsubcn.4 cG cJ cK topgrpsubcn.1 topgrpsubcn.2 topgrpbs ax-mp vx cv
        cG crn wcel vy cv cG crn wcel wa vu cv vx cv cid cG crn cres cfv vy cv
        cG cgn cfv cfv cop wceq wa vx vy vu copab2 eqid 2txcn cK ctopgrp wcel
        cJ ctop wcel cJ ctop wcel cJ cK topgrpsubcn.2 topgrptop cJ cK
        topgrpsubcn.2 topgrptop jca cK ctopgrp wcel cJ ctop wcel cJ ctop wcel
        cJ cK topgrpsubcn.2 topgrptop cJ cK topgrpsubcn.2 topgrptop jca cK
        ctopgrp wcel cid cG crn cres cJ cJ ccn co wcel cG cgn cfv cJ cJ ccn co
        wcel cK ctopgrp wcel cJ ctop wcel cid cG crn cres cJ cJ ccn co wcel cJ
        cK topgrpsubcn.2 topgrptop cJ cG crn cK ctopgrp wcel cG crn cJ cuni
        wceq topgrpsubcn.4 cG cJ cK topgrpsubcn.1 topgrpsubcn.2 topgrpbs ax-mp
        idcn syl cG cJ cK cG cgn cfv topgrpsubcn.1 topgrpsubcn.2 cG cgn cfv
        eqid topgrpinv jca syl3anc vx cv cG crn wcel vy cv cG crn wcel wa vu cv
        vx cv vy cv cG cgn cfv cfv cop wceq wa vx cv cG crn wcel vy cv cG crn
        wcel wa vu cv vx cv cid cG crn cres cfv vy cv cG cgn cfv cfv cop wceq
        wa vx vy vu vx cv cG crn wcel vy cv cG crn wcel wa vu cv vx cv vy cv cG
        cgn cfv cfv cop wceq vu cv vx cv cid cG crn cres cfv vy cv cG cgn cfv
        cfv cop wceq vx cv cG crn wcel vy cv cG crn wcel wa vx cv vy cv cG cgn
        cfv cfv cop vx cv cid cG crn cres cfv vy cv cG cgn cfv cfv cop vu cv vx
        cv cG crn wcel vy cv cG crn wcel wa vx cv vx cv cid cG crn cres cfv vy
        cv cG cgn cfv cfv vx cv cG crn wcel vy cv cG crn wcel wa vx cv cid cG
        crn cres cfv vx cv vx cv cG crn wcel vx cv cid cG crn cres cfv vx cv
        wceq vy cv cG crn wcel cG crn vx cv fvresi adantr eqcomd opeq1d eqeq2d
        pm5.32i oprabbii syl5eqel cG cJ cK topgrpsubcn.1 topgrpsubcn.2 topgrpcn
        jca32 ax-mp vx cv cG crn wcel vy cv cG crn wcel wa vu cv vx cv vy cv cG
        cgn cfv cfv cop wceq wa vx vy vu copab2 cG cJ cJ ctx co cJ cJ ctx co cJ
        cnco ax-mp eqeltri eqeltri $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    $( In a topological group, the "substraction" (or "division")
       is continuous. Bourbaki TG III.1 axiom GT' $)
    topgrpsubcn $p |- ( K e. TopGrp -> D e. ( ( J tX J ) Cn J ) ) $=
      cK ctopgrp wcel cK c1st cfv cgs cfv cJ cJ ctx co cJ ccn co cD cK ctopgrp
      wcel cK c1st cfv cgs cfv cK c2nd cfv cK c2nd cfv ctx co cK c2nd cfv ccn
      co cJ cJ ctx co cJ ccn co cK ctopgrp wcel cK c1st cfv cgs cfv cK c2nd cfv
      cK c2nd cfv ctx co cK c2nd cfv ccn co wcel cK ctopgrp wcel cK c0 c0 cop
      c0 cop csn c0 c0 csn cpr cop cif c1st cfv cgs cfv cK ctopgrp wcel cK c0
      c0 cop c0 cop csn c0 c0 csn cpr cop cif c2nd cfv cK ctopgrp wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cif c2nd cfv ctx co cK ctopgrp wcel cK
      c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif c2nd cfv ccn co wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cK cK ctopgrp wcel cK c0 c0 cop c0 cop
      csn c0 c0 csn cpr cop cif wceq cK c1st cfv cgs cfv cK ctopgrp wcel cK c0
      c0 cop c0 cop csn c0 c0 csn cpr cop cif c1st cfv cgs cfv cK c2nd cfv cK
      c2nd cfv ctx co cK c2nd cfv ccn co cK ctopgrp wcel cK c0 c0 cop c0 cop
      csn c0 c0 csn cpr cop cif c2nd cfv cK ctopgrp wcel cK c0 c0 cop c0 cop
      csn c0 c0 csn cpr cop cif c2nd cfv ctx co cK ctopgrp wcel cK c0 c0 cop c0
      cop csn c0 c0 csn cpr cop cif c2nd cfv ccn co cK cK ctopgrp wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cif wceq cK c1st cfv cK ctopgrp wcel cK
      c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif c1st cfv cgs cK cK ctopgrp
      wcel cK c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif c1st fveq2 fveq2d cK
      cK ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif wceq cK
      c2nd cfv cK c2nd cfv ctx co cK ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0
      csn cpr cop cif c2nd cfv cK ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0
      csn cpr cop cif c2nd cfv ctx co cK c2nd cfv cK ctopgrp wcel cK c0 c0 cop
      c0 cop csn c0 c0 csn cpr cop cif c2nd cfv ccn cK cK ctopgrp wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cif wceq cK c2nd cfv cK ctopgrp wcel cK
      c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif c2nd cfv cK c2nd cfv cK
      ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif c2nd cfv ctx
      cK cK ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif c2nd
      fveq2 cK cK ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0 csn cpr cop cif
      c2nd fveq2 opreq12d cK cK ctopgrp wcel cK c0 c0 cop c0 cop csn c0 c0 csn
      cpr cop cif c2nd fveq2 opreq12d eleq12d cK ctopgrp wcel cK c0 c0 cop c0
      cop csn c0 c0 csn cpr cop cif c1st cfv cgs cfv cK ctopgrp wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cif c1st cfv cK ctopgrp wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cif c2nd cfv cK ctopgrp wcel cK c0 c0
      cop c0 cop csn c0 c0 csn cpr cop cif cK ctopgrp wcel cK c0 c0 cop c0 cop
      csn c0 c0 csn cpr cop cif c1st cfv eqid cK ctopgrp wcel cK c0 c0 cop c0
      cop csn c0 c0 csn cpr cop cif c2nd cfv eqid cK ctopgrp wcel cK c0 c0 cop
      c0 cop csn c0 c0 csn cpr cop cif c1st cfv cgs cfv eqid cK c0 c0 cop c0
      cop csn c0 c0 csn cpr cop ctopgrp c0 cvv 0ex extopgrp elimel
      topgrpsubcnlem dedth cJ cJ ctx co cK c2nd cfv cK c2nd cfv ctx co cJ cK
      c2nd cfv ccn cJ cK c2nd cfv cJ cK c2nd cfv ctx topgrpsubcn.2
      topgrpsubcn.2 opreq12i topgrpsubcn.2 opreq12i syl6eleqr cD cG cgs cfv cK
      c1st cfv cgs cfv topgrpsubcn.3 cG cK c1st cfv cgs topgrpsubcn.1 fveq2i
      eqtri syl5eqel $.
      $( [21-Jun-2010] $) $( [21-Jun-2010] $)
  $}

  ${
    trhom.1 $e |- X = ran G $.
    trhom.2 $e |- F = ( x e. X |-> ( x G A ) ) $.
    trhom.3 $e |- G = ( 1st ` K ) $.
    trhom.4 $e |- J = ( 2nd ` K ) $.
    ${
      $d A x y $. $d G x y $. $d K x y $. $d X x y $.
        $( In a topological group a right translation is a
           homeomorphism. Bourbaki TG III.2 $)
      trhom $p |- ( ( K e. TopGrp /\ A e. X ) -> F e. ( J Homeo J ) ) $=
        cK ctopgrp wcel cA cX wcel wa cF cJ cJ chomeosm co wcel cJ cuni cJ cuni
        cF wf1o cF cJ cJ ccn co wcel cF ccnv cJ cJ ccn co wcel w3a cK ctopgrp
        wcel cA cX wcel wa cJ cuni cJ cuni cF wf1o cF cJ cJ ccn co wcel cF ccnv
        cJ cJ ccn co wcel cK ctopgrp wcel cA cX wcel cJ cuni cJ cuni cF wf1o cG
        crn cJ cuni wceq cK ctopgrp wcel cA cX wcel cJ cuni cJ cuni cF wf1o wi
        cG cJ cK trhom.3 trhom.4 topgrpbs cG crn cJ cuni wceq cA cX wcel cJ
        cuni cJ cuni cF wf1o wi cA cX wcel cX cX cF wf1o wi cK ctopgrp wcel cX
        cG crn wceq cG crn cJ cuni wceq cA cX wcel cJ cuni cJ cuni cF wf1o wi
        cA cX wcel cX cX cF wf1o wi wb trhom.1 cX cG crn wceq cG crn cJ cuni
        wceq wa cX cJ cuni wceq cA cX wcel cJ cuni cJ cuni cF wf1o wi cA cX
        wcel cX cX cF wf1o wi wb cX cG crn cJ cuni eqtr cX cJ cuni wceq cJ cuni
        cJ cuni cF wf1o cX cX cF wf1o cA cX wcel cJ cuni cJ cuni cF wf1o cX cX
        cF wf1o wb cJ cuni cX cJ cuni cX wceq cJ cuni cJ cuni cF wf1o cX cJ
        cuni cF wf1o cX cX cF wf1o cJ cuni cX cJ cuni cF f1oeq2 cJ cuni cX cX
        cF f1oeq3 bitrd eqcoms imbi2d syl mpan cK ctopgrp wcel cG cgr wcel cA
        cX wcel cX cX cF wf1o wi cG cK trhom.3 topgrpgrp cG cgr wcel cA cX wcel
        cX cX cF wf1o vx cA cF cG cX trhom.2 trhom.1 trooo ex syl syl5bir mpcom
        imp cJ cK c2nd cfv wceq cK ctopgrp wcel cA cX wcel wa cF cJ cJ ccn co
        wcel wi trhom.4 cJ cK c2nd cfv wceq cF cJ cJ ccn co wcel cF cK c2nd cfv
        cK c2nd cfv ccn co wcel cK ctopgrp wcel cA cX wcel wa cJ cK c2nd cfv
        wceq cJ cJ ccn co cK c2nd cfv cK c2nd cfv ccn co cF cJ cK c2nd cfv wceq
        cJ cJ ccn co cK c2nd cfv cK c2nd cfv ccn co wceq cJ cK c2nd cfv cJ cK
        c2nd cfv ccn opreq12 anidms eleq2d cK ctopgrp wcel cA cX wcel wa cF cG
        vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab ccom cK c2nd cfv
        cK c2nd cfv ccn co vx cv cA cop cX cX cxp wcel vx cX wral cG cX cX cxp
        wfn cF cG vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab ccom
        wceq cK ctopgrp wcel cA cX wcel wa vx vy cX vx cv cA cop cX cX cxp vx
        cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab cF cG vx cv cX wcel
        vy cv vx cv cA cop wceq wa vx vy copab eqid cF vx cX vx cv cA cG co
        cmpt vx cv cX wcel vy cv vx cv cA cG co wceq wa vx vy copab vx cv cX
        wcel vy cv vx cv cA cop cG cfv wceq wa vx vy copab trhom.2 vx vy cX vx
        cv cA cG co df-mpt vx cv cX wcel vy cv vx cv cA cG co wceq wa vx cv cX
        wcel vy cv vx cv cA cop cG cfv wceq wa vx vy vy cv vx cv cA cG co wceq
        vy cv vx cv cA cop cG cfv wceq vx cv cX wcel vx cv cA cG co vx cv cA
        cop cG cfv vy cv vx cv cA cG df-opr eqeq2i anbi2i opabbii 3eqtri
        fnopabco2b cA cX wcel vx cv cA cop cX cX cxp wcel vx cX wral cK ctopgrp
        wcel cA cX wcel vx cv cA cop cX cX cxp wcel vx cX vx cv cX wcel cA cX
        wcel vx cv cA cop cX cX cxp wcel vx cv cA cX cX opelxpi ancoms
        r19.21aiva adantl cK ctopgrp wcel cG cX cX cxp wfn cA cX wcel cK
        ctopgrp wcel cG cgr wcel cX cX cxp cX cG wfo cG cX cX cxp wfn cG cK
        trhom.3 topgrpgrp cG cX trhom.1 grpfo cX cX cxp cX cG fofn 3syl adantr
        sylanc cK c2nd cfv ctop wcel cK c2nd cfv cK c2nd cfv ctx co ctop wcel
        cK c2nd cfv ctop wcel w3a vx cv cX wcel vy cv vx cv cA cop wceq wa vx
        vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel cG cK
        c2nd cfv cK c2nd cfv ctx co cK c2nd cfv ccn co wcel cG vx cv cX wcel vy
        cv vx cv cA cop wceq wa vx vy copab ccom cK c2nd cfv cK c2nd cfv ccn co
        wcel cK ctopgrp wcel cA cX wcel wa cK ctopgrp wcel cK c2nd cfv ctop
        wcel cK c2nd cfv cK c2nd cfv ctx co ctop wcel cK c2nd cfv ctop wcel w3a
        cA cX wcel cK ctopgrp wcel cK c2nd cfv ctop wcel cK c2nd cfv cK c2nd
        cfv ctx co ctop wcel cK c2nd cfv ctop wcel cK c2nd cfv cK cK c2nd cfv
        eqid topgrptop cK c2nd cfv ctop wcel cK c2nd cfv ctop wcel cK c2nd cfv
        cK c2nd cfv ctx co ctop wcel cK ctopgrp wcel cK c2nd cfv cK c2nd cfv cK
        c2nd cfv cK c2nd cfv ctx co cK c2nd cfv cK c2nd cfv ctx co eqid txtop
        cK c2nd cfv cK cK c2nd cfv eqid topgrptop cK c2nd cfv cK cK c2nd cfv
        eqid topgrptop sylanc cK c2nd cfv cK cK c2nd cfv eqid topgrptop 3jca
        adantr cK ctopgrp wcel cA cX wcel vx cv cX wcel vy cv vx cv cA cop wceq
        wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel
        cK ctopgrp wcel cG crn cJ cuni wceq cX cK c2nd cfv cuni wceq cK ctopgrp
        wcel cA cX wcel wa vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab
        cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel wi cG cJ cK
        trhom.3 trhom.4 topgrpbs cG crn cJ cuni wceq cX cK c2nd cfv cuni wceq
        cG crn cX cJ cuni cK c2nd cfv cuni cX cG crn trhom.1 eqcomi cJ cK c2nd
        cfv trhom.4 unieqi eqeq12i biimpi cX cK c2nd cfv cuni wceq cK ctopgrp
        wcel cA cX wcel wa vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab
        cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel wi cK ctopgrp
        wcel cA cK c2nd cfv cuni wcel wa vx cv cK c2nd cfv cuni wcel vy cv vx
        cv cA cop wceq wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx
        co ccn co wcel wi cK c2nd cfv ctop wcel cA cK c2nd cfv cuni wcel vx cv
        cK c2nd cfv cuni wcel vy cv vx cv cA cop wceq wa vx vy copab cK c2nd
        cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel cK ctopgrp wcel vx vy cA
        vx cv cK c2nd cfv cuni wcel vy cv vx cv cA cop wceq wa vx vy copab cK
        c2nd cfv cK c2nd cfv cuni cK c2nd cfv cuni eqid vx cv cK c2nd cfv cuni
        wcel vy cv vx cv cA cop wceq wa vx vy copab eqid ttcn cK c2nd cfv cK cK
        c2nd cfv eqid topgrptop sylan cX cK c2nd cfv cuni wceq cK ctopgrp wcel
        cA cX wcel wa cK ctopgrp wcel cA cK c2nd cfv cuni wcel wa vx cv cX wcel
        vy cv vx cv cA cop wceq wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd
        cfv ctx co ccn co wcel vx cv cK c2nd cfv cuni wcel vy cv vx cv cA cop
        wceq wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co
        wcel cX cK c2nd cfv cuni wceq cA cX wcel cA cK c2nd cfv cuni wcel cK
        ctopgrp wcel cX cK c2nd cfv cuni cA eleq2 anbi2d cX cK c2nd cfv cuni
        wceq vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab vx cv cK c2nd
        cfv cuni wcel vy cv vx cv cA cop wceq wa vx vy copab cK c2nd cfv cK
        c2nd cfv cK c2nd cfv ctx co ccn co cX cK c2nd cfv cuni wceq vx cv cX
        wcel vy cv vx cv cA cop wceq wa vx cv cK c2nd cfv cuni wcel vy cv vx cv
        cA cop wceq wa vx vy cX cK c2nd cfv cuni wceq vx ax-17 cX cK c2nd cfv
        cuni wceq vy ax-17 cX cK c2nd cfv cuni wceq vx cv cX wcel vx cv cK c2nd
        cfv cuni wcel vy cv vx cv cA cop wceq cX cK c2nd cfv cuni vx cv eleq2
        anbi1d opabbid eleq1d imbi12d mpbiri 3syl anabsi5 cK ctopgrp wcel cG cK
        c2nd cfv cK c2nd cfv ctx co cK c2nd cfv ccn co wcel cA cX wcel cG cK
        c2nd cfv cK trhom.3 cK c2nd cfv eqid topgrpcn adantr vx cv cX wcel vy
        cv vx cv cA cop wceq wa vx vy copab cG cK c2nd cfv cK c2nd cfv cK c2nd
        cfv ctx co cK c2nd cfv cnco sylan32c eqeltrd syl5bir ax-mp cK ctopgrp
        wcel cA cX wcel wa cF ccnv vx cX vx cv cA cG cgs cfv co cmpt cJ cJ ccn
        co cG cgr wcel cA cX wcel cF ccnv vx cX vx cv cA cG cgs cfv co cmpt
        wceq cK ctopgrp wcel vx cA cG cgs cfv cF cG cX trhom.2 trhom.1 cG cgs
        cfv eqid trinv cG cK trhom.3 topgrpgrp sylan cJ cK c2nd cfv wceq cK
        ctopgrp wcel cA cX wcel wa vx cX vx cv cA cG cgs cfv co cmpt cJ cJ ccn
        co wcel wi trhom.4 cJ cK c2nd cfv wceq vx cX vx cv cA cG cgs cfv co
        cmpt cJ cJ ccn co wcel vx cX vx cv cA cG cgs cfv co cmpt cK c2nd cfv cK
        c2nd cfv ccn co wcel cK ctopgrp wcel cA cX wcel wa cJ cK c2nd cfv wceq
        cJ cJ ccn co cK c2nd cfv cK c2nd cfv ccn co vx cX vx cv cA cG cgs cfv
        co cmpt cJ cK c2nd cfv wceq cJ cJ ccn co cK c2nd cfv cK c2nd cfv ccn co
        wceq cJ cK c2nd cfv cJ cK c2nd cfv ccn opreq12 anidms eleq2d cK ctopgrp
        wcel cA cX wcel wa vx cX vx cv cA cG cgs cfv co cmpt cG cgs cfv vx cv
        cX wcel vy cv vx cv cA cop wceq wa vx vy copab ccom cK c2nd cfv cK c2nd
        cfv ccn co vx cv cA cop cX cX cxp wcel vx cX wral cG cgs cfv cX cX cxp
        wfn vx cX vx cv cA cG cgs cfv co cmpt cG cgs cfv vx cv cX wcel vy cv vx
        cv cA cop wceq wa vx vy copab ccom wceq cK ctopgrp wcel cA cX wcel wa
        vx vy cX vx cv cA cop cX cX cxp vx cv cX wcel vy cv vx cv cA cop wceq
        wa vx vy copab vx cX vx cv cA cG cgs cfv co cmpt cG cgs cfv vx cv cX
        wcel vy cv vx cv cA cop wceq wa vx vy copab eqid vx cX vx cv cA cG cgs
        cfv co cmpt vx cv cX wcel vy cv vx cv cA cG cgs cfv co wceq wa vx vy
        copab vx cv cX wcel vy cv vx cv cA cop cG cgs cfv cfv wceq wa vx vy
        copab vx vy cX vx cv cA cG cgs cfv co df-mpt vx cv cX wcel vy cv vx cv
        cA cG cgs cfv co wceq wa vx cv cX wcel vy cv vx cv cA cop cG cgs cfv
        cfv wceq wa vx vy vy cv vx cv cA cG cgs cfv co wceq vy cv vx cv cA cop
        cG cgs cfv cfv wceq vx cv cX wcel vx cv cA cG cgs cfv co vx cv cA cop
        cG cgs cfv cfv vy cv vx cv cA cG cgs cfv df-opr eqeq2i anbi2i opabbii
        eqtri fnopabco2b cA cX wcel vx cv cA cop cX cX cxp wcel vx cX wral cK
        ctopgrp wcel cA cX wcel vx cv cA cop cX cX cxp wcel vx cX vx cv cX wcel
        cA cX wcel vx cv cA cop cX cX cxp wcel vx cv cA cX cX opelxpi ancoms
        r19.21aiva adantl cK ctopgrp wcel cG cgs cfv cX cX cxp wfn cA cX wcel
        cK ctopgrp wcel cG cgr wcel cX cX cxp cX cG cgs cfv wfo cG cgs cfv cX
        cX cxp wfn cG cK trhom.3 topgrpgrp cG cgs cfv cG cX trhom.1 cG cgs cfv
        eqid grpdivfo cX cX cxp cX cG cgs cfv fofn 3syl adantr sylanc cK c2nd
        cfv ctop wcel cK c2nd cfv cK c2nd cfv ctx co ctop wcel cK c2nd cfv ctop
        wcel w3a vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab cK c2nd
        cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel cG cgs cfv cK c2nd cfv
        cK c2nd cfv ctx co cK c2nd cfv ccn co wcel cG cgs cfv vx cv cX wcel vy
        cv vx cv cA cop wceq wa vx vy copab ccom cK c2nd cfv cK c2nd cfv ccn co
        wcel cK ctopgrp wcel cA cX wcel wa cK ctopgrp wcel cK c2nd cfv ctop
        wcel cK c2nd cfv cK c2nd cfv ctx co ctop wcel cK c2nd cfv ctop wcel w3a
        cA cX wcel cK ctopgrp wcel cK c2nd cfv ctop wcel cK c2nd cfv cK c2nd
        cfv ctx co ctop wcel cK c2nd cfv ctop wcel cK c2nd cfv cK cK c2nd cfv
        eqid topgrptop cK c2nd cfv ctop wcel cK c2nd cfv ctop wcel cK c2nd cfv
        cK c2nd cfv ctx co ctop wcel cK ctopgrp wcel cK c2nd cfv cK c2nd cfv cK
        c2nd cfv cK c2nd cfv ctx co cK c2nd cfv cK c2nd cfv ctx co eqid txtop
        cK c2nd cfv cK cK c2nd cfv eqid topgrptop cK c2nd cfv cK cK c2nd cfv
        eqid topgrptop sylanc cK c2nd cfv cK cK c2nd cfv eqid topgrptop 3jca
        adantr cK ctopgrp wcel cA cX wcel vx cv cX wcel vy cv vx cv cA cop wceq
        wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel
        cK ctopgrp wcel cG crn cJ cuni wceq cX cK c2nd cfv cuni wceq cK ctopgrp
        wcel cA cX wcel wa vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab
        cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel wi cG cJ cK
        trhom.3 trhom.4 topgrpbs cG crn cJ cuni wceq cX cK c2nd cfv cuni wceq
        cG crn cX cJ cuni cK c2nd cfv cuni cX cG crn trhom.1 eqcomi cJ cK c2nd
        cfv trhom.4 unieqi eqeq12i biimpi cX cK c2nd cfv cuni wceq cK ctopgrp
        wcel cA cX wcel wa vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab
        cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel wi cK ctopgrp
        wcel cA cK c2nd cfv cuni wcel wa vx cv cK c2nd cfv cuni wcel vy cv vx
        cv cA cop wceq wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx
        co ccn co wcel wi cK c2nd cfv ctop wcel cA cK c2nd cfv cuni wcel vx cv
        cK c2nd cfv cuni wcel vy cv vx cv cA cop wceq wa vx vy copab cK c2nd
        cfv cK c2nd cfv cK c2nd cfv ctx co ccn co wcel cK ctopgrp wcel vx vy cA
        vx cv cK c2nd cfv cuni wcel vy cv vx cv cA cop wceq wa vx vy copab cK
        c2nd cfv cK c2nd cfv cuni cK c2nd cfv cuni eqid vx cv cK c2nd cfv cuni
        wcel vy cv vx cv cA cop wceq wa vx vy copab eqid ttcn cK c2nd cfv cK cK
        c2nd cfv eqid topgrptop sylan cX cK c2nd cfv cuni wceq cK ctopgrp wcel
        cA cX wcel wa cK ctopgrp wcel cA cK c2nd cfv cuni wcel wa vx cv cX wcel
        vy cv vx cv cA cop wceq wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd
        cfv ctx co ccn co wcel vx cv cK c2nd cfv cuni wcel vy cv vx cv cA cop
        wceq wa vx vy copab cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co ccn co
        wcel cX cK c2nd cfv cuni wceq cA cX wcel cA cK c2nd cfv cuni wcel cK
        ctopgrp wcel cX cK c2nd cfv cuni cA eleq2 anbi2d cX cK c2nd cfv cuni
        wceq vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy copab vx cv cK c2nd
        cfv cuni wcel vy cv vx cv cA cop wceq wa vx vy copab cK c2nd cfv cK
        c2nd cfv cK c2nd cfv ctx co ccn co cX cK c2nd cfv cuni wceq vx cv cX
        wcel vy cv vx cv cA cop wceq wa vx cv cK c2nd cfv cuni wcel vy cv vx cv
        cA cop wceq wa vx vy cX cK c2nd cfv cuni wceq vx ax-17 cX cK c2nd cfv
        cuni wceq vy ax-17 cX cK c2nd cfv cuni wceq vx cv cX wcel vx cv cK c2nd
        cfv cuni wcel vy cv vx cv cA cop wceq cX cK c2nd cfv cuni vx cv eleq2
        anbi1d opabbid eleq1d imbi12d mpbiri 3syl anabsi5 cK ctopgrp wcel cG
        cgs cfv cK c2nd cfv cK c2nd cfv ctx co cK c2nd cfv ccn co wcel cA cX
        wcel cG cgs cfv cG cK c2nd cfv cK trhom.3 cK c2nd cfv eqid cG cgs cfv
        eqid topgrpsubcn adantr vx cv cX wcel vy cv vx cv cA cop wceq wa vx vy
        copab cG cgs cfv cK c2nd cfv cK c2nd cfv cK c2nd cfv ctx co cK c2nd cfv
        cnco sylan32c eqeltrd syl5bir ax-mp eqeltrd 3jca cJ ctop wcel cJ ctop
        wcel cF cvv wcel cF cJ cJ chomeosm co wcel cJ cuni cJ cuni cF wf1o cF
        cJ cJ ccn co wcel cF ccnv cJ cJ ccn co wcel w3a wb cK ctopgrp wcel cA
        cX wcel wa cvv cF cJ cJ cJ cuni cJ cuni cJ cuni eqid cJ cuni eqid
        hmeobc cK ctopgrp wcel cJ ctop wcel cA cX wcel cJ cK trhom.4 topgrptop
        adantr cK ctopgrp wcel cJ ctop wcel cA cX wcel cJ cK trhom.4 topgrptop
        adantr cX cvv cF wf cX cvv wcel cF cvv wcel cK ctopgrp wcel cA cX wcel
        wa cX cvv cvv cF fex vx cv cA cG co cvv wcel vx cX wral cX cvv cF wf vx
        cv cA cG co cvv wcel vx cX vx cv cA cG co cvv wcel vx cv cX wcel vx cv
        cA cG oprex a1i rgen vx cX cvv vx cv cA cG co cF trhom.2 fopab2a mpbi
        cX cvv wcel cK ctopgrp wcel cA cX wcel wa cX cG crn cvv trhom.1 cG cG
        cK c1st cfv cvv trhom.3 cK c1st fvex eqeltri rnex eqeltri a1i sylancr
        syl3anc mpbird $.
        $( [21-Jun-2010] $) $( [21-Jun-2010] $)
    $}

    ${
      $d A x $. $d G x $. $d K x $. $d X x $.
      $( In a topological group, a converse of a right translation
         is a homeomorphism. Bourbaki TG III.2 $)
      cnvtrhom $p |- ( ( K e. TopGrp /\ A e. X )
        -> `' F e. ( J Homeo J ) ) $=
        cJ ctop wcel cJ ctop wcel wa cF cJ cJ chomeosm co wcel cF ccnv cJ cJ
        chomeosm co wcel cK ctopgrp wcel cA cX wcel wa cF cJ cJ cnvhmpha cK
        ctopgrp wcel cJ ctop wcel cJ ctop wcel wa cA cX wcel cK ctopgrp wcel cJ
        ctop wcel cJ ctop wcel cJ cK trhom.4 topgrptop cJ cK trhom.4 topgrptop
        jca adantr vx cA cF cG cJ cK cX trhom.1 trhom.2 trhom.3 trhom.4 trhom
        sylc $.
        $( [30-Dec-2010] $) $( [30-Dec-2010] $)
    $}

    ${
      $d A x $. $d F y $. $d G x $. $d J y $. $d K x $. $d O y $.
      $d X x $.
      $( In a topological group the image of an open set by a right
         translation is an open set. Bourbaki TG III.2 $)
      trhom2 $p |- ( ( K e. TopGrp /\ A e. X /\ O e. J )
       -> ( F " O ) e. J ) $=
        cK ctopgrp wcel cA cX wcel cO cJ wcel cF cO cima cJ wcel cF cJ cJ
        chomeosm co wcel cK ctopgrp wcel cA cX wcel wa cO cJ wcel cF cO cima cJ
        wcel wi vx cA cF cG cJ cK cX trhom.1 trhom.2 trhom.3 trhom.4 trhom cK
        ctopgrp wcel cA cX wcel wa cF cJ cJ chomeosm co wcel cF vy cv cima cJ
        wcel vy cJ wral cO cJ wcel cF cO cima cJ wcel wi cK ctopgrp wcel cA cX
        wcel wa cJ ctop wcel cJ ctop wcel wa cF cJ cJ chomeosm co wcel cF vy cv
        cima cJ wcel vy cJ wral wi cK ctopgrp wcel cJ ctop wcel cJ ctop wcel wa
        cA cX wcel cK ctopgrp wcel cJ ctop wcel cJ ctop wcel cJ cK trhom.4
        topgrptop cJ cK trhom.4 topgrptop jca adantr vy cF cJ cJ hmeocnb syl cF
        vy cv cima cJ wcel cF cO cima cJ wcel vy cO cJ vy cv cO wceq cF vy cv
        cima cF cO cima cJ vy cv cO cF imaeq2 eleq1d rcla4cv syl6com mpcom
        3impia $.
        $( [1-Jan-2011] $) $( [30-Dec-2010] $)
    $}

    ${
      $d A x $. $d G x $. $d K x $. $d X x $. $d O x $.
      tpgprop1.1 $e |- dot_t = ( cset ` G ) $.
      $( In a topological group, the product of an open set by an element
         is open . $)
      tpgprop1 $p |- ( ( K e. TopGrp /\ A e. X /\ O e. J )
        -> ( O dot_t { A } ) e. J ) $=
        cK ctopgrp wcel cA cX wcel cO cJ wcel w3a cO cA csn cmus co cF cO cima
        cJ cG cgr wcel cA cX wcel cO cX cpw wcel cO cA csn cmus co cF cO cima
        wceq cK ctopgrp wcel cA cX wcel cO cJ wcel w3a vx cA cO cF cG cmus cX
        trhom.2 trhom.1 tpgprop1.1 prsubrtr2 cK ctopgrp wcel cA cX wcel cG cgr
        wcel cO cJ wcel cG cK trhom.3 topgrpgrp 3ad2ant1 cK ctopgrp wcel cA cX
        wcel cO cJ wcel 3simp2 cK ctopgrp wcel cA cX wcel cO cJ wcel cO cX cpw
        wcel cK ctopgrp wcel cO cJ wcel cO cX cpw wcel wi cA cX wcel cK ctopgrp
        wcel cJ cX cpw cO cK ctopgrp wcel cG crn cJ cuni wceq cJ cX cpw wss cG
        cJ cK trhom.3 trhom.4 topgrpbs cX cG crn wceq cG crn cJ cuni wceq cJ cX
        cpw wss wi trhom.1 cX cG crn wceq cG crn cJ cuni wceq cX cJ cuni wceq
        cJ cX cpw wss cX cG crn wceq cG crn cJ cuni wceq cX cJ cuni wceq cX cG
        crn cJ cuni eqtr ex cX cJ cuni wceq cJ cX cpw wss cJ cJ cuni cpw wss cJ
        pwuni cX cJ cuni wceq cX cpw cJ cuni cpw cJ cX cJ cuni pweq sseq2d
        mpbiri syl6 ax-mp syl sseld a1d 3imp syl3anc vx cA cF cG cJ cK cO cX
        trhom.1 trhom.2 trhom.3 trhom.4 trhom2 eqeltrd $.
        $( [1-Jan-2011] $) $( [30-Dec-2010] $)
    $}

    ${
      $d A y $. $d G x y $. $d J y $. $d K x y $. $d O x y $. $d X x y $.
      tpgprop2.1 $e |- dot_t = ( cset ` G ) $.
      $( In a topological group, the product of an open set by another set
         is open . $)
      tpgprop2 $p |- ( ( K e. TopGrp /\ A e. ~P X /\ O e. J )
        -> ( O dot_t A ) e. J ) $=
        cK ctopgrp wcel cA cX cpw wcel cO cJ wcel w3a cO cA cmus co vy cA cO vy
        cv csn cmus co ciun cJ cG cgr wcel cO cG cdm cdm cpw wcel cA cG cdm cdm
        cpw wcel cO cA cmus co vy cA cO vy cv csn cmus co ciun wceq cK ctopgrp
        wcel cA cX cpw wcel cO cJ wcel w3a vy cO cA cG cmus cgr cG cdm cdm cG
        cdm cdm eqid tpgprop2.1 iscst4 cK ctopgrp wcel cA cX cpw wcel cG cgr
        wcel cO cJ wcel cG cK trhom.3 topgrpgrp 3ad2ant1 cK ctopgrp wcel cO cJ
        wcel cO cG cdm cdm cpw wcel cA cX cpw wcel cG cdm cdm cX wceq cK
        ctopgrp wcel cO cJ wcel wa cO cG cdm cdm cpw wcel cK ctopgrp wcel cG
        cdm cdm cX wceq cO cJ wcel cK ctopgrp wcel cG cgr wcel cG cdm cdm cX
        wceq cG cK trhom.3 topgrpgrp cG cgr wcel cG crn cG cdm cdm cX cG
        grprndm trhom.1 syl5req syl adantr cG cdm cdm cX wceq cO cG cdm cdm cpw
        wcel cO cX cpw wcel cK ctopgrp wcel cO cJ wcel wa cG cdm cdm cX wceq cG
        cdm cdm cpw cX cpw cO cG cdm cdm cX pweq eleq2d cK ctopgrp wcel cO cJ
        wcel cO cX cpw wcel cK ctopgrp wcel cJ cX cpw cO cG crn cJ cuni wceq cK
        ctopgrp wcel cJ cX cpw wss cG cJ cK trhom.3 trhom.4 topgrpbs cX cG crn
        wceq cG crn cJ cuni wceq cK ctopgrp wcel cJ cX cpw wss wi trhom.1 cX cG
        crn wceq cG crn cJ cuni wceq wa cX cJ cuni wceq cK ctopgrp wcel cJ cX
        cpw wss wi cX cG crn cJ cuni eqtr cX cJ cuni wceq cJ cX cpw wss cJ cJ
        cuni cpw wss cK ctopgrp wcel cX cJ cuni wceq cX cpw cJ cuni cpw cJ cX
        cJ cuni pweq sseq2d cK ctopgrp wcel cJ ctop wcel cJ cJ cuni cpw wss cJ
        cK trhom.4 topgrptop cJ cJ cuni cJ cuni eqid topge syl syl5bir syl mpan
        mpcom sseld imp syl5bir mpcom 3adant2 cK ctopgrp wcel cA cX cpw wcel cA
        cG cdm cdm cpw wcel cO cJ wcel cK ctopgrp wcel cA cX cpw wcel cA cG cdm
        cdm cpw wcel cK ctopgrp wcel cX cpw cG cdm cdm cpw cA cK ctopgrp wcel
        cX cG cdm cdm wceq cX cpw cG cdm cdm cpw wceq cK ctopgrp wcel cG crn cG
        cdm cdm cX cK ctopgrp wcel cG cgr wcel cG crn cG cdm cdm wceq cG cK
        trhom.3 topgrpgrp cG grprndm syl trhom.1 syl5eq cX cG cdm cdm pweq syl
        eleq2d biimpa 3adant3 syl3anc cJ ctop wcel cO vy cv csn cmus co cJ wcel
        vy cA wral vy cA cO vy cv csn cmus co ciun cJ wcel cK ctopgrp wcel cA
        cX cpw wcel cO cJ wcel w3a vy cA cO vy cv csn cmus co cJ iunopn cK
        ctopgrp wcel cA cX cpw wcel cJ ctop wcel cO cJ wcel cJ cK trhom.4
        topgrptop 3ad2ant1 cK ctopgrp wcel cA cX cpw wcel cO cJ wcel w3a cO vy
        cv csn cmus co cJ wcel vy cA cK ctopgrp wcel vy cv cX wcel cO cJ wcel
        cO vy cv csn cmus co cJ wcel cK ctopgrp wcel cA cX cpw wcel cO cJ wcel
        w3a vy cv cA wcel wa vx vy cv vx cX vx cv vy cv cG co cmpt cG cJ cK cO
        cX cmus trhom.1 vx cX vx cv vy cv cG co cmpt eqid trhom.3 trhom.4
        tpgprop2.1 tpgprop1 cK ctopgrp wcel cA cX cpw wcel cO cJ wcel vy cv cA
        wcel 3simpl1 cK ctopgrp wcel cA cX cpw wcel cO cJ wcel w3a vy cv cA
        wcel vy cv cX wcel cA cX cpw wcel cK ctopgrp wcel vy cv cA wcel vy cv
        cX wcel wi cO cJ wcel vy cv cA wcel cA cX cpw wcel vy cv cX wcel vy cv
        cA cX bepart expcom 3ad2ant2 imp cK ctopgrp wcel cA cX cpw wcel cO cJ
        wcel vy cv cA wcel 3simpl3 syl3anc r19.21aiva sylanc eqeltrd $.
        $( [1-Jan-2011] $) $( [1-Jan-2011] $)
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Standard topology on RR
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${ $d A x y $. $d w z $.
  $( An open interval has two extended reals bounds. $)
    bsi2 $p |- ( E. x e. RR* E. y e. RR* A = ( x (,) y )
       -> A e. ran (,) ) $=
      cA vx cv vy cv cioo co wceq cA cioo crn wcel vx vy cxr cxr cxr cxr cxp cr
      cpw cioo wf vx cv cxr wcel vy cv cxr wcel wa cA vx cv vy cv cioo co wceq
      cA cioo crn wcel wi wi ioof cxr cxr cxp cr cpw cioo wf cioo cxr cxr cxp
      wfn vz cv vw cv cioo co cr cpw wcel vw cxr wral vz cxr wral wa vx cv cxr
      wcel vy cv cxr wcel wa cA vx cv vy cv cioo co wceq cA cioo crn wcel wi wi
      vz vw cxr cxr cr cpw cioo ffnoprv cioo cxr cxr cxp wfn vx cv cxr wcel vy
      cv cxr wcel wa cA vx cv vy cv cioo co wceq cA cioo crn wcel wi wi vz cv
      vw cv cioo co cr cpw wcel vw cxr wral vz cxr wral cioo cxr cxr cxp wfn vx
      cv cxr wcel vy cv cxr wcel cA vx cv vy cv cioo co wceq cA cioo crn wcel
      wi cA vx cv vy cv cioo co wceq vx cv vy cv cioo co cioo crn wcel cA cioo
      crn wcel cioo cxr cxr cxp wfn vx cv cxr wcel vy cv cxr wcel w3a cA vx cv
      vy cv cioo co wceq vx cv vy cv cioo co cA cioo crn cA vx cv vy cv cioo co
      wceq vx cv vy cv cioo co cA wceq cA vx cv vy cv cioo co eqcom biimpi
      eleq1d cxr cxr vx cv vy cv cioo fnoprvrn syl5cbi 3expib adantr sylbi
      ax-mp r19.23aivv $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${ $d A x y $.
    $( An open interval has two extended reals bounds. $)
    bsi3 $p |- ( A e. ran (,) <->
      E. x e. RR* E. y e. RR* A = ( x (,) y ) ) $=
      cA cioo crn wcel cA vx cv vy cv cioo co wceq vy cxr wrex vx cxr wrex vx
      vy cA bsi vx vy cA bsi2 impbii $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  $( Condition for an interval to belong to the range of ` (,) ` $)
  intrn $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) e. ran (,) ) $=
    cxr cxr cxp cr cpw cioo wf cA cxr wcel cB cxr wcel wa cA cB cioo co cioo
    crn wcel wi ioof cxr cxr cxp cr cpw cioo wf cioo cxr cxr cxp wfn cA cxr
    wcel cB cxr wcel wa cA cB cioo co cioo crn wcel wi cxr cxr cxp cr cpw cioo
    ffn cioo cxr cxr cxp wfn cA cxr wcel cB cxr wcel cA cB cioo co cioo crn
    wcel cxr cxr cA cB cioo fnoprvrn 3expib syl ax-mp $.
    $( [28-Jan-2009] $) $( [5-Jan-2009] $)


  ${ $d A y z $.
    $( Lemma for ~ altretop . $)
    altretoplem1 $p |- ( A e. ( topGen ` ran (,) ) <->  ( A C_ RR
              /\   A. y e. A E. z e. ran (,)
                    ( y e. z /\ z C_ A ) ) ) $=
      cioo crn ctb wcel cA cioo crn ctg cfv wcel cA cr wss vy cv vz cv wcel vz
      cv cA wss wa vz cioo crn wrex vy cA wral wa wb retopbas cioo crn ctb wcel
      cA cioo crn ctg cfv wcel cA cioo crn cuni wss vy cv vz cv wcel vz cv cA
      wss wa vz cioo crn wrex vy cA wral wa cA cr wss vy cv vz cv wcel vz cv cA
      wss wa vz cioo crn wrex vy cA wral wa vy vz cA cioo crn eltg2 cA cioo crn
      cuni wss cA cr wss vy cv vz cv wcel vz cv cA wss wa vz cioo crn wrex vy
      cA wral cioo crn cuni cr cA unirnioo sseq2i anbi1i syl6bb ax-mp $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}


  ${ $d A a b y z $.
    $( Lemma for ~ altretop . $)
    altretoplem2 $p |- ( A e. ( topGen ` ran (,) ) <->  ( A C_ RR
              /\   A. y e. A E. a e. RR* E. b e. RR*
        ( y e. ( a (,) b ) /\ ( a (,) b ) C_ A ) ) ) $=
      cA cioo crn ctg cfv wcel cA cr wss vy cv vz cv wcel vz cv cA wss wa vz
      cioo crn wrex vy cA wral wa cA cr wss vy cv va cv vb cv cioo co wcel va
      cv vb cv cioo co cA wss wa vb cxr wrex va cxr wrex vy cA wral wa vy vz cA
      altretoplem1 vy cv vz cv wcel vz cv cA wss wa vz cioo crn wrex vy cA wral
      vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cxr wrex
      va cxr wrex vy cA wral cA cr wss vy cv vz cv wcel vz cv cA wss wa vz cioo
      crn wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb
      cxr wrex va cxr wrex vy cA vy cv vz cv wcel vz cv cA wss wa vz cioo crn
      wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cxr
      wrex va cxr wrex vy cv vz cv wcel vz cv cA wss wa vy cv va cv vb cv cioo
      co wcel va cv vb cv cioo co cA wss wa vb cxr wrex va cxr wrex vz cioo crn
      vy cv vz cv wcel vz cv cA wss wa vz cv va cv vb cv cioo co wceq vb cxr
      wrex va cxr wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA
      wss wa vb cxr wrex va cxr wrex vz cv cioo crn wcel vy cv vz cv wcel vz cv
      cA wss wa vz cv va cv vb cv cioo co wceq vb cxr wrex vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cxr wrex va cxr vy cv vz cv
      wcel vz cv cA wss wa vz cv va cv vb cv cioo co wceq vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cxr vz cv va cv vb cv cioo
      co wceq vy cv vz cv wcel vz cv cA wss wa vy cv va cv vb cv cioo co wcel
      va cv vb cv cioo co cA wss wa vz cv va cv vb cv cioo co wceq vy cv vz cv
      wcel vy cv va cv vb cv cioo co wcel vz cv cA wss va cv vb cv cioo co cA
      wss vz cv va cv vb cv cioo co vy cv eleq2 vz cv va cv vb cv cioo co cA
      sseq1 anbi12d biimpcd r19.22sdv r19.22sdv va vb vz cv bsi syl5com
      r19.23aiv vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vy
      cv vz cv wcel vz cv cA wss wa vz cioo crn wrex va vb cxr cxr va cv cxr
      wcel vb cv cxr wcel wa va cv vb cv cioo co cioo crn wcel vy cv va cv vb
      cv cioo co wcel va cv vb cv cioo co cA wss wa vy cv vz cv wcel vz cv cA
      wss wa vz cioo crn wrex wi va cv vb cv intrn va cv vb cv cioo co cioo crn
      wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vy cv
      vz cv wcel vz cv cA wss wa vz cioo crn wrex vy cv vz cv wcel vz cv cA wss
      wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vz va cv
      vb cv cioo co cioo crn vz cv va cv vb cv cioo co wceq vy cv vz cv wcel vy
      cv va cv vb cv cioo co wcel vz cv cA wss va cv vb cv cioo co cA wss vz cv
      va cv vb cv cioo co vy cv eleq2 vz cv va cv vb cv cioo co cA sseq1
      anbi12d rcla4ev ex syl r19.23aivv impbii ralbii anbi2i bitri $.
      $( [28-Jan-2009] $) $( [5-Jan-2009] $)
  $}

  ${ $d A a b u v y $.
    $( Alternate definition of the standard topology of the reals.
       (Morris. Def. 2.1.1 p. 34). Morris calls the standard topology
       of the reals the euclidean topology. $)
    altretop $p |- ( A e. ( topGen ` ran (,) ) <->  ( A C_ RR
              /\   A. y e. A E. a e. RR E. b e. RR
            ( y e. ( a (,) b ) /\ ( a (,) b ) C_ A ) ) ) $=
      cA cioo crn ctg cfv wcel cA cr wss vy cv vu cv vv cv cioo co wcel vu cv
      vv cv cioo co cA wss wa vv cxr wrex vu cxr wrex vy cA wral wa cA cr wss
      vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex
      va cr wrex vy cA wral wa vy cA vu vv altretoplem2 vy cv vu cv vv cv cioo
      co wcel vu cv vv cv cioo co cA wss wa vv cxr wrex vu cxr wrex vy cA wral
      vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex
      va cr wrex vy cA wral cA cr wss vy cv vu cv vv cv cioo co wcel vu cv vv
      cv cioo co cA wss wa vv cxr wrex vu cxr wrex vy cv va cv vb cv cioo co
      wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cA vy cv vu
      cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vv cxr wrex vu cxr
      wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss
      wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex vu vv cxr cxr vu cv cxr wcel vv cv cxr wcel vy cv vu cv
      vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo
      co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv cxr
      wcel vu cv cr wcel vu cv cpnf wceq vu cv cmnf wceq w3o vv cv cxr wcel vy
      cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb
      cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi wi
      vu cv elxr vv cv cxr wcel vu cv cr wcel vu cv cpnf wceq vu cv cmnf wceq
      w3o vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va
      cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex
      wi vv cv cxr wcel vv cv cr wcel vv cv cpnf wceq vv cv cmnf wceq w3o vu cv
      cr wcel vu cv cpnf wceq vu cv cmnf wceq w3o vy cv vu cv vv cv cioo co
      wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vb cr wrex va cr wrex wi wi vv cv elxr vv cv cr
      wcel vv cv cpnf wceq vv cv cmnf wceq w3o vu cv cr wcel vu cv cpnf wceq vu
      cv cmnf wceq w3o vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA
      wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex wi vv cv cr wcel vv cv cpnf wceq vv cv cmnf wceq w3o vu
      cv cr wcel vu cv cpnf wceq vu cv cmnf wceq w3o wa vv cv cr wcel vu cv cr
      wcel wa vv cv cr wcel vu cv cpnf wceq wa vv cv cr wcel vu cv cmnf wceq wa
      w3o vv cv cpnf wceq vu cv cr wcel wa vv cv cpnf wceq vu cv cpnf wceq wa
      vv cv cpnf wceq vu cv cmnf wceq wa w3o vv cv cmnf wceq vu cv cr wcel wa
      vv cv cmnf wceq vu cv cpnf wceq wa vv cv cmnf wceq vu cv cmnf wceq wa w3o
      w3o vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va
      cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex
      wi vv cv cr wcel vv cv cpnf wceq vv cv cmnf wceq vu cv cr wcel vu cv cpnf
      wceq vu cv cmnf wceq anddi2 vv cv cr wcel vu cv cr wcel wa vv cv cr wcel
      vu cv cpnf wceq wa vv cv cr wcel vu cv cmnf wceq wa w3o vy cv vu cv vv cv
      cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel
      va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vv cv cpnf wceq vu
      cv cr wcel wa vv cv cpnf wceq vu cv cpnf wceq wa vv cv cpnf wceq vu cv
      cmnf wceq wa w3o vv cv cmnf wceq vu cv cr wcel wa vv cv cmnf wceq vu cv
      cpnf wceq wa vv cv cmnf wceq vu cv cmnf wceq wa w3o vv cv cr wcel vu cv
      cr wcel wa vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa
      vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex
      va cr wrex wi vv cv cr wcel vu cv cpnf wceq wa vv cv cr wcel vu cv cmnf
      wceq wa vu cv cr wcel vv cv cr wcel vy cv vu cv vv cv cioo co wcel vu cv
      vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo
      co cA wss wa vb cr wrex va cr wrex wi vu cv cr wcel vv cv cr wcel vy cv
      vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv va
      cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vy cv vu cv vv cv
      cioo co wcel vu cv vv cv cioo co cA wss wa vy cv vu cv vb cv cioo co wcel
      vu cv vb cv cioo co cA wss wa va vb vu cv vv cv cr cr va cv vu cv wceq vy
      cv va cv vb cv cioo co wcel vy cv vu cv vb cv cioo co wcel va cv vb cv
      cioo co cA wss vu cv vb cv cioo co cA wss va cv vu cv wceq va cv vb cv
      cioo co vu cv vb cv cioo co vy cv va cv vu cv vb cv cioo opreq1 eleq2d va
      cv vu cv wceq va cv vb cv cioo co vu cv vb cv cioo co cA va cv vu cv vb
      cv cioo opreq1 sseq1d anbi12d vb cv vv cv wceq vy cv vu cv vb cv cioo co
      wcel vy cv vu cv vv cv cioo co wcel vu cv vb cv cioo co cA wss vu cv vv
      cv cioo co cA wss vb cv vv cv wceq vu cv vb cv cioo co vu cv vv cv cioo
      co vy cv vb cv vv cv vu cv cioo opreq2 eleq2d vb cv vv cv wceq vu cv vb
      cv cioo co vu cv vv cv cioo co cA vb cv vv cv vu cv cioo opreq2 sseq1d
      anbi12d rcla42ev 3expia ancoms vu cv cpnf wceq vy cv vu cv vv cv cioo co
      wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vv cv cr wcel vy cv vu
      cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vu cv cpnf wceq vy cv
      va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr
      wrex vy cv vu cv vv cv cioo co wcel vu cv cpnf wceq vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv
      vv cv cioo co cA wss vu cv cpnf wceq vy cv vu cv vv cv cioo co wcel vy cv
      cpnf vv cv cioo co wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo
      co cA wss wa vb cr wrex va cr wrex vu cv cpnf wceq vy cv vu cv vv cv cioo
      co wcel vy cv cpnf vv cv cioo co wcel vu cv cpnf wceq vu cv vv cv cioo co
      cpnf vv cv cioo co vy cv vu cv cpnf vv cv cioo opreq1 eleq2d biimpd vy cv
      cpnf vv cv cioo co wcel vy cv c0 wcel vy cv va cv vb cv cioo co wcel va
      cv vb cv cioo co cA wss wa vb cr wrex va cr wrex cpnf vv cv cioo co c0 vy
      cv vv cv oisbmj eleq2i vy cv c0 wcel vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv noel pm2.21i sylbi
      syl6com adantr com12 adantl vv cv cr wcel vu cv cmnf wceq wa vy cv vu cv
      vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv cmnf vv cv cioo co
      wcel cmnf vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv vb
      cv cioo co cA wss wa vb cr wrex va cr wrex vu cv cmnf wceq vy cv vu cv vv
      cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv cmnf vv cv cioo co
      wcel cmnf vv cv cioo co cA wss wa wb vv cv cr wcel vu cv cmnf wceq vy cv
      vu cv vv cv cioo co wcel vy cv cmnf vv cv cioo co wcel vu cv vv cv cioo
      co cA wss cmnf vv cv cioo co cA wss vu cv cmnf wceq vu cv vv cv cioo co
      cmnf vv cv cioo co vy cv vu cv cmnf vv cv cioo opreq1 eleq2d vu cv cmnf
      wceq vu cv vv cv cioo co cmnf vv cv cioo co cA vu cv cmnf vv cv cioo
      opreq1 sseq1d anbi12d adantl vv cv cr wcel vy cv cmnf vv cv cioo co wcel
      cmnf vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv
      cioo co cA wss wa vb cr wrex va cr wrex wi vu cv cmnf wceq vy cv cmnf vv
      cv cioo co wcel cmnf vv cv cioo co cA wss wa vv cv cr wcel vy cv va cv vb
      cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv
      cmnf vv cv cioo co wcel cmnf vv cv cioo co cA wss wa vv cv cr wcel vy cv
      va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa va cr wrex vb cr
      wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex vv cv cr wcel vy cv va cv vv cv cioo co wcel va cv vv cv
      cioo co cA wss wa va cr wrex vy cv va cv vb cv cioo co wcel va cv vb cv
      cioo co cA wss wa va cr wrex vb cr wrex vy cv cmnf vv cv cioo co wcel
      cmnf vv cv cioo co cA wss wa vv cv cr wcel vy cv va cv vv cv cioo co wcel
      va cv vv cv cioo co cA wss wa va cr wrex vy cv va cv vb cv cioo co wcel
      va cv vb cv cioo co cA wss wa va cr wrex vb cr wrex vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa va cr wrex vy cv va cv vv cv
      cioo co wcel va cv vv cv cioo co cA wss wa va cr wrex vb vv cv cr vb cv
      vv cv wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa
      vy cv va cv vv cv cioo co wcel va cv vv cv cioo co cA wss wa va cr vb cv
      vv cv wceq vy cv va cv vb cv cioo co wcel vy cv va cv vv cv cioo co wcel
      va cv vb cv cioo co cA wss va cv vv cv cioo co cA wss vb cv vv cv wceq va
      cv vb cv cioo co va cv vv cv cioo co vy cv vb cv vv cv va cv cioo opreq2
      eleq2d vb cv vv cv wceq va cv vb cv cioo co va cv vv cv cioo co cA vb cv
      vv cv va cv cioo opreq2 sseq1d anbi12d rexbidv rcla4ev ex vy cv c1 cmin
      co cr wcel vy cv vy cv c1 cmin co vv cv cioo co wcel vy cv c1 cmin co vv
      cv cioo co cA wss wa vy cv va cv vv cv cioo co wcel va cv vv cv cioo co
      cA wss wa va cr wrex vy cv cmnf vv cv cioo co wcel cmnf vv cv cioo co cA
      wss wa vy cv va cv vv cv cioo co wcel va cv vv cv cioo co cA wss wa vy cv
      vy cv c1 cmin co vv cv cioo co wcel vy cv c1 cmin co vv cv cioo co cA wss
      wa va vy cv c1 cmin co cr va cv vy cv c1 cmin co wceq vy cv va cv vv cv
      cioo co wcel vy cv vy cv c1 cmin co vv cv cioo co wcel va cv vv cv cioo
      co cA wss vy cv c1 cmin co vv cv cioo co cA wss va cv vy cv c1 cmin co
      wceq va cv vv cv cioo co vy cv c1 cmin co vv cv cioo co vy cv va cv vy cv
      c1 cmin co vv cv cioo opreq1 eleq2d va cv vy cv c1 cmin co wceq va cv vv
      cv cioo co vy cv c1 cmin co vv cv cioo co cA va cv vy cv c1 cmin co vv cv
      cioo opreq1 sseq1d anbi12d rcla4ev vy cv cmnf vv cv cioo co wcel vy cv c1
      cmin co cr wcel cmnf vv cv cioo co cA wss vy cv cmnf vv cv cioo co wcel
      vy cv cr wcel c1 cr wcel wa vy cv c1 cmin co cr wcel vy cv cmnf vv cv
      cioo co wcel vy cv cr wcel c1 cr wcel vy cv cmnf vv cv elioore 1re jctir
      vy cv c1 resubcl syl adantr vy cv cmnf vv cv cioo co wcel vy cv vy cv c1
      cmin co vv cv cioo co wcel cmnf vv cv cioo co cA wss vy cv c1 cmin co vv
      cv cioo co cA wss vy cv cmnf vv cv cioo co wcel cmnf cxr wcel vv cv cxr
      wcel vy cv cr wcel w3a cmnf vy cv clt wbr vy cv vv cv clt wbr wa wa vy cv
      vy cv c1 cmin co vv cv cioo co wcel vv cv cvv wcel vy cv cmnf vv cv cioo
      co wcel cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a cmnf vy cv clt wbr
      vy cv vv cv clt wbr wa wa wb vv visset cmnf vv cv vy cv cvv elioo4g ax-mp
      cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a cmnf vy cv clt wbr vy cv
      vv cv clt wbr wa wa vy cv vy cv c1 cmin co vv cv cioo co wcel vy cv c1
      cmin co cxr wcel vv cv cxr wcel vy cv cr wcel w3a vy cv c1 cmin co vy cv
      clt wbr vy cv vv cv clt wbr wa wa cmnf cxr wcel vv cv cxr wcel vy cv cr
      wcel w3a cmnf vy cv clt wbr vy cv vv cv clt wbr wa wa vy cv c1 cmin co
      cxr wcel vv cv cxr wcel vy cv cr wcel w3a vy cv c1 cmin co vy cv clt wbr
      vy cv vv cv clt wbr wa cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a
      cmnf vy cv clt wbr vy cv vv cv clt wbr wa wa vy cv c1 cmin co cxr wcel vv
      cv cxr wcel vy cv cr wcel cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a
      vy cv c1 cmin co cxr wcel cmnf vy cv clt wbr vy cv vv cv clt wbr wa vy cv
      cr wcel cmnf cxr wcel vy cv c1 cmin co cxr wcel vv cv cxr wcel vy cv cr
      wcel vy cv c1 cmin co cr wcel vy cv c1 cmin co cxr wcel vy cv peano2rem
      vy cv c1 cmin co rexr syl 3ad2ant3 adantr cmnf cxr wcel vv cv cxr wcel vy
      cv cr wcel w3a vv cv cxr wcel cmnf vy cv clt wbr vy cv vv cv clt wbr wa
      cmnf cxr wcel vv cv cxr wcel vy cv cr wcel 3simp2 adantr cmnf cxr wcel vv
      cv cxr wcel vy cv cr wcel w3a vy cv cr wcel cmnf vy cv clt wbr vy cv vv
      cv clt wbr wa cmnf cxr wcel vv cv cxr wcel vy cv cr wcel 3simp3 adantr
      3jca cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a cmnf vy cv clt wbr vy
      cv vv cv clt wbr wa wa vy cv c1 cmin co vy cv clt wbr vy cv vv cv clt wbr
      cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a vy cv c1 cmin co vy cv clt
      wbr cmnf vy cv clt wbr vy cv vv cv clt wbr wa vy cv cr wcel cmnf cxr wcel
      vy cv c1 cmin co vy cv clt wbr vv cv cxr wcel vy cv ltm1 3ad2ant3 adantr
      cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a cmnf vy cv clt wbr vy cv
      vv cv clt wbr simprr jca jca cmnf cxr wcel vv cv cxr wcel vy cv cr wcel
      w3a cmnf vy cv clt wbr vy cv vv cv clt wbr wa wa vv cv cvv wcel vy cv vy
      cv c1 cmin co vv cv cioo co wcel vy cv c1 cmin co cxr wcel vv cv cxr wcel
      vy cv cr wcel w3a vy cv c1 cmin co vy cv clt wbr vy cv vv cv clt wbr wa
      wa wb vv cv cvv wcel cmnf cxr wcel vv cv cxr wcel vy cv cr wcel w3a cmnf
      vy cv clt wbr vy cv vv cv clt wbr wa wa vv visset a1i vy cv c1 cmin co vv
      cv vy cv cvv elioo4g syl mpbird sylbi vy cv c1 cmin co vv cv cioo co cmnf
      vv cv cioo co wss cmnf vv cv cioo co cA wss vy cv c1 cmin co vv cv cioo
      co cA wss vy cv c1 cmin co vv cv oibbi2 vy cv c1 cmin co vv cv cioo co
      cmnf vv cv cioo co cA sstr mpan anim12i sylanc syl5com vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb va cr cr rexcom syl6ib
      com12 adantr sylbid 3jaoi vv cv cpnf wceq vu cv cr wcel wa vy cv vu cv vv
      cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co
      wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vv cv cpnf
      wceq vu cv cpnf wceq wa vv cv cpnf wceq vu cv cmnf wceq wa vv cv cpnf
      wceq vu cv cr wcel wa vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co
      cA wss wa vy cv vu cv cpnf cioo co wcel vu cv cpnf cioo co cA wss wa vy
      cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va
      cr wrex vv cv cpnf wceq vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo
      co cA wss wa vy cv vu cv cpnf cioo co wcel vu cv cpnf cioo co cA wss wa
      wb vu cv cr wcel vv cv cpnf wceq vy cv vu cv vv cv cioo co wcel vy cv vu
      cv cpnf cioo co wcel vu cv vv cv cioo co cA wss vu cv cpnf cioo co cA wss
      vv cv cpnf wceq vu cv vv cv cioo co vu cv cpnf cioo co vy cv vv cv cpnf
      vu cv cioo opreq2 eleq2d vv cv cpnf wceq vu cv vv cv cioo co vu cv cpnf
      cioo co cA vv cv cpnf vu cv cioo opreq2 sseq1d anbi12d adantr vu cv cr
      wcel vy cv vu cv cpnf cioo co wcel vu cv cpnf cioo co cA wss wa vy cv va
      cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex
      wi vv cv cpnf wceq vy cv vu cv cpnf cioo co wcel vu cv cpnf cioo co cA
      wss wa vu cv cr wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo co
      cA wss wa vb cr wrex va cr wrex vy cv vu cv cpnf cioo co wcel vu cv cpnf
      cioo co cA wss vu cv cr wcel vy cv va cv vb cv cioo co wcel va cv vb cv
      cioo co cA wss wa vb cr wrex va cr wrex wi vy cv vu cv cpnf cioo co wcel
      vy cv cr wcel vu cv cpnf cioo co cA wss vu cv cr wcel vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi wi vy
      cv vu cv cpnf elioore vu cv cr wcel vy cv cr wcel vu cv cpnf cioo co cA
      wss vy cv vu cv cpnf cioo co wcel vy cv va cv vb cv cioo co wcel va cv vb
      cv cioo co cA wss wa vb cr wrex va cr wrex vu cv cr wcel vy cv cr wcel vu
      cv cpnf cioo co cA wss vy cv vu cv cpnf cioo co wcel vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi wi wi
      vu cv cr wcel vu cv cpnf cioo co cA wss vy cv cr wcel vu cv cr wcel vy cv
      vu cv cpnf cioo co wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo
      co cA wss wa vb cr wrex va cr wrex wi vu cv cr wcel vu cv cpnf cioo co cA
      wss vy cv cr wcel vu cv cr wcel vy cv vu cv cpnf cioo co wcel vy cv va cv
      vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi
      wi wi vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv cr wcel vy cv vu
      cv cpnf cioo co wcel vu cv cr wcel vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vb cr wrex va cr wrex vu cv cr wcel vu cv cpnf
      cioo co cA wss wa vy cv cr wcel vy cv vu cv cpnf cioo co wcel vy cv vu cv
      vb cv cioo co wcel vu cv vb cv cioo co cA wss wa vb cr wrex vu cv cr wcel
      vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex
      va cr wrex wi vy cv cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy
      cv vu cv cpnf cioo co wcel vy cv vu cv vb cv cioo co wcel vu cv vb cv
      cioo co cA wss wa vb cr wrex wi vy cv c1 caddc co cr wcel vy cv c1 caddc
      co cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf
      cioo co wcel vy cv vu cv vb cv cioo co wcel vu cv vb cv cioo co cA wss wa
      vb cr wrex wi wi vy cv cr wcel vy cv c1 caddc co cr wcel vy cv c1 caddc
      co cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf
      cioo co wcel vy cv vu cv vb cv cioo co wcel vu cv vb cv cioo co cA wss wa
      vb cr wrex vy cv c1 caddc co cr wcel vy cv vu cv vy cv c1 caddc co cioo
      co wcel vu cv vy cv c1 caddc co cioo co cA wss wa vy cv vu cv vb cv cioo
      co wcel vu cv vb cv cioo co cA wss wa vb cr wrex vy cv c1 caddc co cr
      wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf cioo co
      wcel w3a vy cv c1 caddc co cr wcel vy cv vu cv vy cv c1 caddc co cioo co
      wcel vu cv vy cv c1 caddc co cioo co cA wss wa vy cv vu cv vb cv cioo co
      wcel vu cv vb cv cioo co cA wss wa vb cr wrex vy cv vu cv vb cv cioo co
      wcel vu cv vb cv cioo co cA wss wa vy cv vu cv vy cv c1 caddc co cioo co
      wcel vu cv vy cv c1 caddc co cioo co cA wss wa vb vy cv c1 caddc co cr vb
      cv vy cv c1 caddc co wceq vy cv vu cv vb cv cioo co wcel vy cv vu cv vy
      cv c1 caddc co cioo co wcel vu cv vb cv cioo co cA wss vu cv vy cv c1
      caddc co cioo co cA wss vb cv vy cv c1 caddc co wceq vu cv vb cv cioo co
      vu cv vy cv c1 caddc co cioo co vy cv vb cv vy cv c1 caddc co vu cv cioo
      opreq2 eleq2d vb cv vy cv c1 caddc co wceq vu cv vb cv cioo co vu cv vy
      cv c1 caddc co cioo co cA vb cv vy cv c1 caddc co vu cv cioo opreq2
      sseq1d anbi12d rcla4ev ex vy cv c1 caddc co cr wcel vu cv cr wcel vu cv
      cpnf cioo co cA wss wa vy cv vu cv cpnf cioo co wcel w3a vy cv vu cv vy
      cv c1 caddc co cioo co wcel vu cv vy cv c1 caddc co cioo co cA wss vy cv
      c1 caddc co cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu
      cv cpnf cioo co wcel w3a vy cv vu cv vy cv c1 caddc co cioo co wcel vu cv
      vy cv clt wbr vy cv vy cv c1 caddc co clt wbr wa vy cv c1 caddc co cr
      wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf cioo co
      wcel w3a vu cv vy cv clt wbr vy cv vy cv c1 caddc co clt wbr vy cv vu cv
      cpnf cioo co wcel vy cv c1 caddc co cr wcel vu cv vy cv clt wbr vu cv cr
      wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf cioo co wcel vu cv vy
      cv clt wbr vy cv cpnf clt wbr vy cv vu cv cpnf elioooord pm3.26d 3ad2ant3
      vy cv vu cv cpnf cioo co wcel vy cv c1 caddc co cr wcel vy cv vy cv c1
      caddc co clt wbr vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv
      cpnf cioo co wcel vy cv cr wcel vy cv vy cv c1 caddc co clt wbr vy cv vu
      cv cpnf elioore vy cv ltp1 syl 3ad2ant3 jca vu cv cxr wcel vy cv c1 caddc
      co cxr wcel vy cv cxr wcel vy cv vu cv vy cv c1 caddc co cioo co wcel vu
      cv vy cv clt wbr vy cv vy cv c1 caddc co clt wbr wa wb vy cv c1 caddc co
      cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf cioo
      co wcel w3a vu cv vy cv c1 caddc co vy cv elioo5 vu cv cr wcel vu cv cpnf
      cioo co cA wss wa vy cv c1 caddc co cr wcel vu cv cxr wcel vy cv vu cv
      cpnf cioo co wcel vu cv cr wcel vu cv cxr wcel vu cv cpnf cioo co cA wss
      vu cv rexr adantr 3ad2ant2 vy cv c1 caddc co cr wcel vu cv cr wcel vu cv
      cpnf cioo co cA wss wa vy cv c1 caddc co cxr wcel vy cv vu cv cpnf cioo
      co wcel vy cv c1 caddc co rexr 3ad2ant1 vy cv vu cv cpnf cioo co wcel vy
      cv c1 caddc co cr wcel vy cv cxr wcel vu cv cr wcel vu cv cpnf cioo co cA
      wss wa vy cv vu cv cpnf cioo co wcel vy cv cr wcel vy cv cxr wcel vy cv
      vu cv cpnf elioore vy cv rexr syl 3ad2ant3 syl3anc mpbird vy cv c1 caddc
      co cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv cpnf
      cioo co wcel w3a vu cv vy cv c1 caddc co cioo co vu cv cpnf cioo co cA vu
      cv cxr wcel vy cv c1 caddc co cxr wcel cpnf cxr wcel w3a vy cv c1 caddc
      co cpnf cle wbr vu cv vy cv c1 caddc co cioo co vu cv cpnf cioo co wss vy
      cv c1 caddc co cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv
      vu cv cpnf cioo co wcel w3a vu cv vy cv c1 caddc co cpnf iooss2 vy cv c1
      caddc co cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv vu cv
      cpnf cioo co wcel w3a vu cv cxr wcel vy cv c1 caddc co cxr wcel cpnf cxr
      wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv c1 caddc co cr wcel
      vu cv cxr wcel vy cv vu cv cpnf cioo co wcel vu cv cr wcel vu cv cxr wcel
      vu cv cpnf cioo co cA wss vu cv rexr adantr 3ad2ant2 vy cv c1 caddc co cr
      wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv c1 caddc co cxr
      wcel vy cv vu cv cpnf cioo co wcel vy cv c1 caddc co rexr 3ad2ant1 cpnf
      cxr wcel vy cv c1 caddc co cr wcel vu cv cr wcel vu cv cpnf cioo co cA
      wss wa vy cv vu cv cpnf cioo co wcel w3a pnfxr a1i 3jca vy cv c1 caddc co
      cr wcel vu cv cr wcel vu cv cpnf cioo co cA wss wa vy cv c1 caddc co cpnf
      cle wbr vy cv vu cv cpnf cioo co wcel vy cv c1 caddc co cr wcel vy cv c1
      caddc co cxr wcel vy cv c1 caddc co cpnf cle wbr vy cv c1 caddc co rexr
      vy cv c1 caddc co pnfge syl 3ad2ant1 sylanc vu cv cr wcel vu cv cpnf cioo
      co cA wss wa vy cv c1 caddc co cr wcel vu cv cpnf cioo co cA wss vy cv vu
      cv cpnf cioo co wcel vu cv cr wcel vu cv cpnf cioo co cA wss pm3.27
      3ad2ant2 sstrd jca syl5 3expd vy cv peano2re vy cv peano2re sylc com12 vu
      cv cr wcel vy cv vu cv vb cv cioo co wcel vu cv vb cv cioo co cA wss wa
      vb cr wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa
      vb cr wrex va cr wrex vy cv va cv vb cv cioo co wcel va cv vb cv cioo co
      cA wss wa vb cr wrex vy cv vu cv vb cv cioo co wcel vu cv vb cv cioo co
      cA wss wa vb cr wrex va vu cv cr va cv vu cv wceq vy cv va cv vb cv cioo
      co wcel va cv vb cv cioo co cA wss wa vy cv vu cv vb cv cioo co wcel vu
      cv vb cv cioo co cA wss wa vb cr va cv vu cv wceq vy cv va cv vb cv cioo
      co wcel vy cv vu cv vb cv cioo co wcel va cv vb cv cioo co cA wss vu cv
      vb cv cioo co cA wss va cv vu cv wceq va cv vb cv cioo co vu cv vb cv
      cioo co vy cv va cv vu cv vb cv cioo opreq1 eleq2d va cv vu cv wceq va cv
      vb cv cioo co vu cv vb cv cioo co cA va cv vu cv vb cv cioo opreq1 sseq1d
      anbi12d rexbidv rcla4ev expcom syl8 com34 ex com24 pm2.43i com14 mpd imp
      com12 adantl sylbid vv cv cpnf wceq vu cv cpnf wceq wa vu cv vv cv cioo
      co cpnf vv cv cioo co wceq vy cv vu cv vv cv cioo co wcel vu cv vv cv
      cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA
      wss wa vb cr wrex va cr wrex wi vu cv cpnf wceq vu cv vv cv cioo co cpnf
      vv cv cioo co wceq vv cv cpnf wceq vu cv cpnf vv cv cioo opreq1 adantl vu
      cv vv cv cioo co cpnf vv cv cioo co wceq cpnf vv cv cioo co c0 wceq vy cv
      vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vv cv
      oisbmj vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vu cv
      vv cv cioo co c0 wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo co
      cA wss wa vb cr wrex va cr wrex vu cv vv cv cioo co cpnf vv cv cioo co
      wceq cpnf vv cv cioo co c0 wceq wa vy cv vu cv vv cv cioo co wcel vu cv
      vv cv cioo co c0 wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo co
      cA wss wa vb cr wrex va cr wrex wi vu cv vv cv cioo co cA wss vu cv vv cv
      cioo co c0 wceq vy cv vu cv vv cv cioo co wcel vy cv c0 wcel vy cv va cv
      vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vu
      cv vv cv cioo co c0 wceq vy cv vu cv vv cv cioo co wcel vy cv c0 wcel vu
      cv vv cv cioo co c0 vy cv eleq2 biimpd vy cv c0 wcel vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv
      noel pm2.21i syl6com adantr vu cv vv cv cioo co cpnf vv cv cioo co c0
      eqtr syl5com mpan2 syl vu cv cmnf wceq vv cv cpnf wceq vy cv vu cv vv cv
      cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel
      va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv cmnf wceq vv
      cv cpnf wceq wa vu cv vv cv cioo co cmnf cpnf cioo co wceq vy cv vu cv vv
      cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co
      wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv cmnf vv
      cv cpnf cioo opreq12 vu cv vv cv cioo co cmnf cpnf cioo co wceq vy cv vu
      cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv cr wcel cr cA
      wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex vu cv vv cv cioo co cmnf cpnf cioo co wceq vu cv vv cv
      cioo co cr wceq vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss
      wa vy cv cr wcel cr cA wss wa wi cmnf cpnf cioo co cr vu cv vv cv cioo co
      ioomax eqeq2i vu cv vv cv cioo co cr wceq vy cv vu cv vv cv cioo co wcel
      vu cv vv cv cioo co cA wss wa vy cv cr wcel cr cA wss wa vu cv vv cv cioo
      co cr wceq vy cv vu cv vv cv cioo co wcel vy cv cr wcel vu cv vv cv cioo
      co cA wss cr cA wss vu cv vv cv cioo co cr vy cv eleq2 vu cv vv cv cioo
      co cr cA sseq1 anbi12d biimpd sylbi vy cv c1 cmin co cr wcel vy cv c1
      caddc co cr wcel vy cv vy cv c1 cmin co vy cv c1 caddc co cioo co wcel vy
      cv c1 cmin co vy cv c1 caddc co cioo co cA wss wa vy cv va cv vb cv cioo
      co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv cr wcel
      cr cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa
      vy cv vy cv c1 cmin co vy cv c1 caddc co cioo co wcel vy cv c1 cmin co vy
      cv c1 caddc co cioo co cA wss wa vy cv vy cv c1 cmin co vb cv cioo co
      wcel vy cv c1 cmin co vb cv cioo co cA wss wa va vb vy cv c1 cmin co vy
      cv c1 caddc co cr cr va cv vy cv c1 cmin co wceq vy cv va cv vb cv cioo
      co wcel vy cv vy cv c1 cmin co vb cv cioo co wcel va cv vb cv cioo co cA
      wss vy cv c1 cmin co vb cv cioo co cA wss va cv vy cv c1 cmin co wceq va
      cv vb cv cioo co vy cv c1 cmin co vb cv cioo co vy cv va cv vy cv c1 cmin
      co vb cv cioo opreq1 eleq2d va cv vy cv c1 cmin co wceq va cv vb cv cioo
      co vy cv c1 cmin co vb cv cioo co cA va cv vy cv c1 cmin co vb cv cioo
      opreq1 sseq1d anbi12d vb cv vy cv c1 caddc co wceq vy cv vy cv c1 cmin co
      vb cv cioo co wcel vy cv vy cv c1 cmin co vy cv c1 caddc co cioo co wcel
      vy cv c1 cmin co vb cv cioo co cA wss vy cv c1 cmin co vy cv c1 caddc co
      cioo co cA wss vb cv vy cv c1 caddc co wceq vy cv c1 cmin co vb cv cioo
      co vy cv c1 cmin co vy cv c1 caddc co cioo co vy cv vb cv vy cv c1 caddc
      co vy cv c1 cmin co cioo opreq2 eleq2d vb cv vy cv c1 caddc co wceq vy cv
      c1 cmin co vb cv cioo co vy cv c1 cmin co vy cv c1 caddc co cioo co cA vb
      cv vy cv c1 caddc co vy cv c1 cmin co cioo opreq2 sseq1d anbi12d rcla42ev
      vy cv cr wcel vy cv c1 cmin co cr wcel cr cA wss vy cv peano2rem adantr
      vy cv cr wcel vy cv c1 caddc co cr wcel cr cA wss vy cv peano2re adantr
      vy cv cr wcel vy cv vy cv c1 cmin co vy cv c1 caddc co cioo co wcel cr cA
      wss vy cv c1 cmin co vy cv c1 caddc co cioo co cA wss vy cv cr wcel c1
      crp wcel vy cv vy cv c1 cmin co vy cv c1 caddc co cioo co wcel 1rp vy cv
      c1 cbci mpan2 vy cv c1 cmin co vy cv c1 caddc co cioo co cr wss cr cA wss
      vy cv c1 cmin co vy cv c1 caddc co cioo co cA wss vy cv c1 cmin co vy cv
      c1 caddc co ioossre vy cv c1 cmin co vy cv c1 caddc co cioo co cr cA sstr
      mpan anim12i syl3anc syl6 syl ancoms 3jaoi vv cv cmnf wceq vu cv cr wcel
      wa vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va
      cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex
      wi vv cv cmnf wceq vu cv cpnf wceq wa vv cv cmnf wceq vu cv cmnf wceq wa
      vv cv cmnf wceq vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss
      wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex wi vu cv cr wcel vv cv cmnf wceq vu cv vv cv cioo co vu
      cv cmnf cioo co wceq vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co
      cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb
      cr wrex va cr wrex wi vv cv cmnf vu cv cioo opreq2 vu cv vv cv cioo co vu
      cv cmnf cioo co wceq vu cv cmnf cioo co c0 wceq vy cv vu cv vv cv cioo co
      wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv oisbmi vy cv vu cv
      vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vu cv vv cv cioo co c0
      wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex vu cv vv cv cioo co vu cv cmnf cioo co wceq vu cv cmnf
      cioo co c0 wceq wa vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co c0
      wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr
      wrex va cr wrex wi vu cv vv cv cioo co cA wss vu cv vv cv cioo co c0 wceq
      vy cv vu cv vv cv cioo co wcel vy cv c0 wcel vy cv va cv vb cv cioo co
      wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vu cv vv cv cioo
      co c0 wceq vy cv vu cv vv cv cioo co wcel vy cv c0 wcel vu cv vv cv cioo
      co c0 vy cv eleq2 biimpd vy cv c0 wcel vy cv va cv vb cv cioo co wcel va
      cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv noel pm2.21i
      syl6com adantr vu cv vv cv cioo co vu cv cmnf cioo co c0 eqtr syl5com
      mpan2 syl adantr vv cv cmnf wceq vy cv vu cv vv cv cioo co wcel vu cv vv
      cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv cioo co
      cA wss wa vb cr wrex va cr wrex wi vu cv cpnf wceq vv cv cmnf wceq vu cv
      vv cv cioo co vu cv cmnf cioo co wceq vy cv vu cv vv cv cioo co wcel vu
      cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv vb cv
      cioo co cA wss wa vb cr wrex va cr wrex wi vv cv cmnf vu cv cioo opreq2
      vu cv vv cv cioo co vu cv cmnf cioo co wceq vu cv cmnf cioo co c0 wceq vy
      cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb
      cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu
      cv oisbmi vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vu
      cv vv cv cioo co c0 wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo
      co cA wss wa vb cr wrex va cr wrex vu cv vv cv cioo co vu cv cmnf cioo co
      wceq vu cv cmnf cioo co c0 wceq wa vy cv vu cv vv cv cioo co wcel vu cv
      vv cv cioo co c0 wceq vy cv va cv vb cv cioo co wcel va cv vb cv cioo co
      cA wss wa vb cr wrex va cr wrex wi vu cv vv cv cioo co cA wss vu cv vv cv
      cioo co c0 wceq vy cv vu cv vv cv cioo co wcel vy cv c0 wcel vy cv va cv
      vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vu
      cv vv cv cioo co c0 wceq vy cv vu cv vv cv cioo co wcel vy cv c0 wcel vu
      cv vv cv cioo co c0 vy cv eleq2 biimpd vy cv c0 wcel vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vy cv
      noel pm2.21i syl6com adantr vu cv vv cv cioo co vu cv cmnf cioo co c0
      eqtr syl5com mpan2 syl adantr vv cv cmnf wceq vy cv vu cv vv cv cioo co
      wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv cmnf wceq vv cv
      cmnf wceq vu cv vv cv cioo co vu cv cmnf cioo co wceq vy cv vu cv vv cv
      cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv cioo co wcel
      va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vv cv cmnf vu cv
      cioo opreq2 vu cv vv cv cioo co vu cv cmnf cioo co wceq vu cv cmnf cioo
      co c0 wceq vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa
      vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vb cr wrex
      va cr wrex wi vu cv oisbmi vy cv vu cv vv cv cioo co wcel vu cv vv cv
      cioo co cA wss wa vu cv vv cv cioo co c0 wceq vy cv va cv vb cv cioo co
      wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex vu cv vv cv cioo
      co vu cv cmnf cioo co wceq vu cv cmnf cioo co c0 wceq wa vy cv vu cv vv
      cv cioo co wcel vu cv vv cv cioo co c0 wceq vy cv va cv vb cv cioo co
      wcel va cv vb cv cioo co cA wss wa vb cr wrex va cr wrex wi vu cv vv cv
      cioo co cA wss vu cv vv cv cioo co c0 wceq vy cv vu cv vv cv cioo co wcel
      vy cv c0 wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss
      wa vb cr wrex va cr wrex vu cv vv cv cioo co c0 wceq vy cv vu cv vv cv
      cioo co wcel vy cv c0 wcel vu cv vv cv cioo co c0 vy cv eleq2 biimpd vy
      cv c0 wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa
      vb cr wrex va cr wrex vy cv noel pm2.21i syl6com adantr vu cv vv cv cioo
      co vu cv cmnf cioo co c0 eqtr syl5com mpan2 syl adantr 3jaoi 3jaoi sylbi
      ex sylbi com12 sylbi imp r19.23aivv vy cv va cv vb cv cioo co wcel va cv
      vb cv cioo co cA wss wa vy cv vu cv vv cv cioo co wcel vu cv vv cv cioo
      co cA wss wa vv cxr wrex vu cxr wrex va vb cr cr va cv cxr wcel vb cv cxr
      wcel vy cv va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vy cv
      vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vv cxr wrex vu cxr
      wrex wi va cv cr wcel vb cv cr wcel va cv cxr wcel vb cv cxr wcel vy cv
      va cv vb cv cioo co wcel va cv vb cv cioo co cA wss wa vy cv vu cv vv cv
      cioo co wcel vu cv vv cv cioo co cA wss wa vv cxr wrex vu cxr wrex vy cv
      vu cv vv cv cioo co wcel vu cv vv cv cioo co cA wss wa vy cv va cv vb cv
      cioo co wcel va cv vb cv cioo co cA wss wa vy cv va cv vv cv cioo co wcel
      va cv vv cv cioo co cA wss wa vu vv va cv vb cv cxr cxr vu cv va cv wceq
      vy cv vu cv vv cv cioo co wcel vy cv va cv vv cv cioo co wcel vu cv vv cv
      cioo co cA wss va cv vv cv cioo co cA wss vu cv va cv wceq vu cv vv cv
      cioo co va cv vv cv cioo co vy cv vu cv va cv vv cv cioo opreq1 eleq2d vu
      cv va cv wceq vu cv vv cv cioo co va cv vv cv cioo co cA vu cv va cv vv
      cv cioo opreq1 sseq1d anbi12d vv cv vb cv wceq vy cv va cv vv cv cioo co
      wcel vy cv va cv vb cv cioo co wcel va cv vv cv cioo co cA wss va cv vb
      cv cioo co cA wss vv cv vb cv wceq va cv vv cv cioo co va cv vb cv cioo
      co vy cv vv cv vb cv va cv cioo opreq2 eleq2d vv cv vb cv wceq va cv vv
      cv cioo co va cv vb cv cioo co cA vv cv vb cv va cv cioo opreq2 sseq1d
      anbi12d rcla42ev 3expia va cv rexr vb cv rexr syl2an r19.23aivv impbii
      ralbii anbi2i bitri $.
      $( [28-Jan-2009] $) $( [26-Jan-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Standard topology of intervals of RR
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${ $d A x y $.  $d B x y $.
    $( The underlying set of the standard topology on an open interval is the
       open interval itself. $)
    stoi $p |- <. ( A (,) B ) , ( subSp ` <. ( A (,) B ) ,
      ( topGen ` ran (,) ) >. ) >. e. TopSp $=
      cA cB cioo co cA cB cioo co cioo crn ctg cfv cop csubsp cfv cop ctps wcel
      cA cB cioo co cioo crn ctg cfv cop csubsp cfv ctop wcel cA cB cioo co cA
      cB cioo co cioo crn ctg cfv cop csubsp cfv cuni wceq cA cB cioo co cA cB
      cioo co cioo crn ctg cfv cop csubsp cfv istps cA cB cioo co cioo crn ctg
      cfv cop csubsp cfv vy cv vx cv cA cB cioo co cin wceq vx cioo crn ctg cfv
      wrex vy cab ctop vx vy cA cB cioo co cioo crn ctg cfv retop cA cB cioo
      oprex subsp cioo crn ctg cfv ctop wcel vy cv vx cv cA cB cioo co cin wceq
      vx cioo crn ctg cfv wrex vy cab ctop wcel retop vy vx cioo crn ctg cfv cA
      cB cioo co subtop ax-mp eqeltri cA cB cioo co vy cv vx cv cA cB cioo co
      cin wceq vx cioo crn ctg cfv wrex vy cab cuni cA cB cioo co cioo crn ctg
      cfv cop csubsp cfv cuni cA cB cioo co cA cB cioo co cioo crn ctg cfv cuni
      cin cioo crn ctg cfv cuni cA cB cioo co cin vy cv vx cv cA cB cioo co cin
      wceq vx cioo crn ctg cfv wrex vy cab cuni cA cB cioo co cioo crn ctg cfv
      cuni wss cA cB cioo co cA cB cioo co cioo crn ctg cfv cuni cin wceq cA cB
      cioo co cr cioo crn ctg cfv cuni cA cB ioossre uniretop sseqtr4i cA cB
      cioo co cioo crn ctg cfv cuni dfss mpbi cA cB cioo co cioo crn ctg cfv
      cuni incom vy vx cioo crn ctg cfv cA cB cioo co ntunte 3eqtri cA cB cioo
      co cioo crn ctg cfv cop csubsp cfv vy cv vx cv cA cB cioo co cin wceq vx
      cioo crn ctg cfv wrex vy cab vx vy cA cB cioo co cioo crn ctg cfv retop
      cA cB cioo oprex subsp unieqi eqtr4i mpbir2an $.
      $( [14-Sep-2007] $) $( [31-May-2007] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Cantor's set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

 ${
    $d C x $. $d a f k l x y $. $d f k l u x y $.
   cntrsetlem.1 $e |- C = { x | E. f e. ( { 0 , 2 } ^m NN )
          x = sum_ k e. NN ( ( f ` k ) / ( 3 ^ k ) ) } $.
   $( Lemma for ~ cntrset . $)
   cntrsetlem $p |- C C_ ( 0 [,] 1 ) $=
     cC cc0 c1 cicc co wss vx cv cC wcel vx cv cc0 c1 cicc co wcel wi vx vx cC
     cc0 c1 cicc co dfss2 vx cv vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv
     co vk csu wceq vf cc0 c2 cpr cn cm co wrex vx cab wcel vx cv cxr wcel cc0
     vx cv cle wbr vx cv c1 cle wbr w3a vx cv cC wcel vx cv cc0 c1 cicc co wcel
     vx cv vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu wceq vf cc0
     c2 cpr cn cm co wrex vx cab wcel vx cv cn vk cv vf cv cfv c3 vk cv cexp co
     cdiv co vk csu wceq vf cc0 c2 cpr cn cm co wrex vx cv cxr wcel cc0 vx cv
     cle wbr vx cv c1 cle wbr w3a vx cv cn vk cv vf cv cfv c3 vk cv cexp co
     cdiv co vk csu wceq vf cc0 c2 cpr cn cm co wrex vx abid vx cv cn vk cv vf
     cv cfv c3 vk cv cexp co cdiv co vk csu wceq vx cv cxr wcel cc0 vx cv cle
     wbr vx cv c1 cle wbr w3a vf cc0 c2 cpr cn cm co vx cv cn vk cv vf cv cfv
     c3 vk cv cexp co cdiv co vk csu wceq vx cv cxr wcel cc0 vx cv cle wbr vx
     cv c1 cle wbr w3a cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cxr
     wcel cc0 cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cle wbr cn vk
     cv vf cv cfv c3 vk cv cexp co cdiv co vk csu c1 cle wbr w3a vf cv cc0 c2
     cpr cn cm co wcel vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu
     wceq vx cv cxr wcel cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cxr
     wcel cc0 vx cv cle wbr cc0 cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk
     csu cle wbr vx cv c1 cle wbr cn vk cv vf cv cfv c3 vk cv cexp co cdiv co
     vk csu c1 cle wbr vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu
     cxr eleq1 vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cc0 cle
     breq2 vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu c1 cle
     breq1 3anbi123d vf cv cc0 c2 cpr cn cm co wcel cn vk cv vf cv cfv c3 vk cv
     cexp co cdiv co vk csu cxr wcel cc0 cn vk cv vf cv cfv c3 vk cv cexp co
     cdiv co vk csu cle wbr cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu
     c1 cle wbr vf cv cc0 c2 cpr cn cm co wcel c1 cz wcel vk cv vx cv c1 cuz
     cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy
     copab cfv cr wcel vk c1 cuz cfv wral c1 caddc cop vx cv c1 cuz cfv wcel vy
     cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cseqz co
     va cv cli wbr va wex w3a cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk
     csu cr wcel cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cxr wcel vf
     cv cc0 c2 cpr cn cm co wcel c1 cz wcel vk cv vx cv c1 cuz cfv wcel vy cv
     vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cr wcel
     vk c1 cuz cfv wral c1 caddc cop vx cv c1 cuz cfv wcel vy cv vx cv vf cv
     cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cseqz co va cv cli wbr va
     wex c1 cz wcel vf cv cc0 c2 cpr cn cm co wcel 1z a1i vf cv cc0 c2 cpr cn
     cm co wcel vk cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp
     co cdiv co wceq wa vx vy copab cfv cr wcel vk c1 cuz cfv vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel vk cv vx cv c1 cuz cfv wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cr wcel vf
     cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv vx cv c1 cuz
     cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy
     copab cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co cr vk cv c1 cuz cfv
     wcel vk cv vf cv cfv c3 vk cv cexp co cdiv co cr wcel vk cv vx cv c1 cuz
     cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy
     copab cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co wceq vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel wa vx vy vk cv vx cv vf cv cfv c3 vx
     cv cexp co cdiv co vk cv vf cv cfv c3 vk cv cexp co cdiv co c1 cuz cfv cr
     vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq
     wa vx vy copab vx vk weq vx cv vf cv cfv vk cv vf cv cfv c3 vx cv cexp co
     c3 vk cv cexp co cdiv vx cv vk cv vf cv fveq2 vx cv vk cv c3 cexp opreq2
     opreq12d vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv
     co wceq wa vx vy copab eqid fvopab4g vf cv cc0 c2 cpr cn cm co wcel vk cv
     c1 cuz cfv wcel pm3.27 vk cv vf cv cfv cr wcel c3 vk cv cexp co cr wcel c3
     vk cv cexp co cc0 wne vk cv vf cv cfv c3 vk cv cexp co cdiv co cr wcel vf
     cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv vf cv cfv c3 vk
     cv cexp co redivcl vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa
     vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel
     wa vk cv vf cv cfv cr wcel vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv
     wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv
     wcel wa vf cv cc0 c2 cpr cn cm co wcel cn cc0 c2 cpr vf cv wf vk cv c1 cuz
     cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz
     cfv wcel wa wi cc0 c2 cpr cn vf cv cc0 c2 prex nnex elmap vk cv c1 cuz cfv
     wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2
     wceq wo vk cv c1 cuz cfv wcel wa vk cv c1 cuz cfv wcel cn cc0 c2 cpr vf cv
     wf vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv
     wcel vk cv cn wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0 wceq vk cv
     vf cv cfv c2 wceq wo wi c1 cuz cfv cn vk cv cn c1 cuz cfv nnuz eqcomi
     eleq2i cn cc0 c2 cpr vf cv wf vk cv cn wcel vk cv vf cv cfv cc0 wceq vk cv
     vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf vk cv cn wcel wa vk cv vf cv
     cfv cc0 c2 cpr wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo cn
     cc0 c2 cpr vk cv vf cv ffvelrn vk cv vf cv cfv cc0 c2 vk cv vf cv fvex
     elpr sylib expcom sylbi anc2ri com12 sylbi imp vk cv vf cv cfv cc0 wceq vk
     cv vf cv cfv c2 wceq wo vk cv vf cv cfv cr wcel vk cv c1 cuz cfv wcel vk
     cv vf cv cfv cc0 wceq vk cv vf cv cfv cr wcel vk cv vf cv cfv c2 wceq vk
     cv vf cv cfv cc0 wceq vk cv vf cv cfv cr wcel cc0 cr wcel 0re vk cv vf cv
     cfv cc0 cr eleq1 mpbiri vk cv vf cv cfv c2 wceq vk cv vf cv cfv cr wcel c2
     cr wcel 2re vk cv vf cv cfv c2 cr eleq1 mpbiri jaoi adantr syl vk cv c1
     cuz cfv wcel c3 vk cv cexp co cr wcel vf cv cc0 c2 cpr cn cm co wcel c3 cr
     wcel vk cv cn0 wcel c3 vk cv cexp co cr wcel vk cv c1 cuz cfv wcel c3 vk
     cv reexpcl 3re vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv
     elnnuz vk cv nnnn0 sylbir sylancr adantl vk cv c1 cuz cfv wcel c3 vk cv
     cexp co cc0 wne vf cv cc0 c2 cpr cn cm co wcel c3 cc wcel c3 cc0 wne vk cv
     cn0 wcel c3 vk cv cexp co cc0 wne vk cv c1 cuz cfv wcel c3 vk cv expne0i
     c3 cc wcel vk cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne vk cv c1 cuz cfv wcel
     3ne0 a1i vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz
     vk cv nnnn0 sylbir syl3anc adantl syl3anc sylanc vk cv vf cv cfv cr wcel
     c3 vk cv cexp co cr wcel c3 vk cv cexp co cc0 wne vk cv vf cv cfv c3 vk cv
     cexp co cdiv co cr wcel vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv
     wcel wa vk cv vf cv cfv c3 vk cv cexp co redivcl vf cv cc0 c2 cpr cn cm co
     wcel vk cv c1 cuz cfv wcel wa vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2
     wceq wo vk cv c1 cuz cfv wcel wa vk cv vf cv cfv cr wcel vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv
     cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vf cv cc0 c2 cpr cn cm co wcel cn
     cc0 c2 cpr vf cv wf vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv
     vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa wi cc0 c2 cpr cn vf cv cc0
     c2 prex nnex elmap vk cv c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv vf
     cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vk cv
     c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0 wceq vk cv vf
     cv cfv c2 wceq wo vk cv c1 cuz cfv wcel vk cv cn wcel cn cc0 c2 cpr vf cv
     wf vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo wi c1 cuz cfv cn vk
     cv cn c1 cuz cfv nnuz eqcomi eleq2i cn cc0 c2 cpr vf cv wf vk cv cn wcel
     vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf
     vk cv cn wcel wa vk cv vf cv cfv cc0 c2 cpr wcel vk cv vf cv cfv cc0 wceq
     vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vk cv vf cv ffvelrn vk cv vf cv
     cfv cc0 c2 vk cv vf cv fvex elpr sylib expcom sylbi anc2ri com12 sylbi imp
     vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv vf cv cfv cr
     wcel vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr
     wcel vk cv vf cv cfv c2 wceq vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr
     wcel cc0 cr wcel 0re vk cv vf cv cfv cc0 cr eleq1 mpbiri vk cv vf cv cfv
     c2 wceq vk cv vf cv cfv cr wcel c2 cr wcel 2re vk cv vf cv cfv c2 cr eleq1
     mpbiri jaoi adantr syl vk cv c1 cuz cfv wcel c3 vk cv cexp co cr wcel vf
     cv cc0 c2 cpr cn cm co wcel c3 cr wcel vk cv cn0 wcel c3 vk cv cexp co cr
     wcel vk cv c1 cuz cfv wcel c3 vk cv reexpcl 3re vk cv c1 cuz cfv wcel vk
     cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir sylancr adantl
     vk cv c1 cuz cfv wcel c3 vk cv cexp co cc0 wne vf cv cc0 c2 cpr cn cm co
     wcel c3 cc wcel c3 cc0 wne vk cv cn0 wcel c3 vk cv cexp co cc0 wne vk cv
     c1 cuz cfv wcel c3 vk cv expne0i c3 cc wcel vk cv c1 cuz cfv wcel 3cn a1i
     c3 cc0 wne vk cv c1 cuz cfv wcel 3ne0 a1i vk cv c1 cuz cfv wcel vk cv cn
     wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir syl3anc adantl syl3anc
     eqeltrd ex r19.21aiv vf cv cc0 c2 cpr cn cm co wcel caddc vx cv c1 cuz cfv
     wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab
     cseq1 co va cv cli wbr va wex c1 caddc cop vx cv c1 cuz cfv wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cseqz co va cv
     cli wbr va wex c1 cn wcel cn cr vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vx cv cexp co wceq wa vx vy copab wf cc0 vl cv vx cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cle wbr vl cn wral wa
     caddc vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx
     vy copab cseq1 co c1 c2 cdiv co cli wbr wa c2 cr wcel cc0 c2 cle wbr wa cn
     cc vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co
     wceq wa vx vy copab wf c1 vl cv clt wbr vl cv vx cv c1 cuz cfv wcel vy cv
     vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cabs cfv
     c2 vl cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa
     vx vy copab cfv cmul co cle wbr wi vl cn wral wa wa wa caddc vx cv c1 cuz
     cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy
     copab cseq1 co va cv cli wbr va wex vf cv cc0 c2 cpr cn cm co wcel vl va
     c1 c2 cdiv co c1 c2 vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp
     co wceq wa vx vy copab vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx
     cv cexp co cdiv co wceq wa vx vy copab c1 c2 cdiv oprex cvgcmp3ce 1nn vf
     cv cc0 c2 cpr cn cm co wcel cn cr vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv
     co vx cv cexp co wceq wa vx vy copab wf cc0 vl cv vx cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cle wbr vl cn wral
     wa caddc vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa
     vx vy copab cseq1 co c1 c2 cdiv co cli wbr c2 cr wcel cc0 c2 cle wbr wa cn
     cc vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co
     wceq wa vx vy copab wf c1 vl cv clt wbr vl cv vx cv c1 cuz cfv wcel vy cv
     vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cabs cfv
     c2 vl cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa
     vx vy copab cfv cmul co cle wbr wi vl cn wral wa wa vf cv cc0 c2 cpr cn cm
     co wcel cc0 vl cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co
     wceq wa vx vy copab cfv cle wbr vl cn wral cn cr vx cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab wf cc0 vl cv vx cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cle
     wbr vl cn wral vf cv cc0 c2 cpr cn cm co wcel cc0 vl cv vx cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cle wbr vl
     cn vl cv cn wcel c1 c3 cdiv co vl cv cexp co cvv wcel cc0 vl cv vx cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cle
     wbr c1 c3 cdiv co vl cv cexp oprex vl cv cn wcel vl cv c1 cuz cfv wcel c1
     c3 cdiv co vl cv cexp co cvv wcel cc0 vl cv vx cv c1 cuz cfv wcel vy cv c1
     c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cle wbr wi vl cv elnnuz
     vl cv c1 cuz cfv wcel c1 c3 cdiv co vl cv cexp co cvv wcel cc0 vl cv vx cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv
     cle wbr vl cv c1 cuz cfv wcel c1 c3 cdiv co vl cv cexp co cvv wcel wa cc0
     c1 c3 cdiv co vl cv cexp co vl cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv
     co vx cv cexp co wceq wa vx vy copab cfv cle c1 c3 cdiv co cr wcel vl cv
     cn0 wcel cc0 c1 c3 cdiv co cle wbr cc0 c1 c3 cdiv co vl cv cexp co cle wbr
     vl cv c1 cuz cfv wcel c1 c3 cdiv co vl cv cexp co cvv wcel wa c1 c3 cdiv
     co vl cv expge0 c1 c3 cdiv co cr wcel vl cv c1 cuz cfv wcel c1 c3 cdiv co
     vl cv cexp co cvv wcel wa c3 3re 3ne0 rereccli a1i vl cv c1 cuz cfv wcel
     vl cv cn0 wcel c1 c3 cdiv co vl cv cexp co cvv wcel vl cv c1 cuz cfv wcel
     vl cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir adantr cc0 c1
     c3 cdiv co cle wbr vl cv c1 cuz cfv wcel c1 c3 cdiv co vl cv cexp co cvv
     wcel wa c1 cr wcel cc0 c1 cle wbr wa c3 cr wcel cc0 c3 clt wbr wa cc0 c1
     c3 cdiv co cle wbr c1 cr wcel cc0 c1 cle wbr 1re cc0 c1 0re 1re lt01
     ltleii pm3.2i c3 cr wcel cc0 c3 clt wbr 3re 3pos pm3.2i c1 c3 divge0 mp2an
     a1i syl3anc vx vy vl cv c1 c3 cdiv co vx cv cexp co c1 c3 cdiv co vl cv
     cexp co c1 cuz cfv cvv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv
     cexp co wceq wa vx vy copab vx cv vl cv c1 c3 cdiv co cexp opreq2 vx cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab eqid
     fvopab4g breqtrrd ex sylbi mpi rgen a1i cn cr vx cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab wf cn cr vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf cn cr vl cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf
     c1 cuz cfv cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq
     wa vl vy copab wf c1 c3 cdiv co vl cv cexp co cr wcel vl c1 cuz cfv wral
     c1 cuz cfv cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq
     wa vl vy copab wf c1 c3 cdiv co vl cv cexp co cr wcel vl c1 cuz cfv c1 c3
     cdiv co cr wcel vl cv cn0 wcel c1 c3 cdiv co vl cv cexp co cr wcel vl cv
     c1 cuz cfv wcel c1 c3 cdiv co vl cv reexpcl c3 3re 3ne0 rereccli vl cv c1
     cuz cfv wcel vl cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir
     sylancr rgen vl vy c1 cuz cfv cr c1 c3 cdiv co vl cv cexp co vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab eqid
     fopab2 mpbi cn c1 cuz cfv wceq cn cr vl cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vl cv cexp co wceq wa vl vy copab wf c1 cuz cfv cr vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf wb nnuz
     cn c1 cuz cfv cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab feq2 ax-mp mpbir vx cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vx cv cexp co wceq wa vx vy copab vl cv c1 cuz cfv wcel vy cv c1
     c3 cdiv co vl cv cexp co wceq wa vl vy copab wceq cn cr vx cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab wf cn cr vl cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf
     wb vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vl cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vx vy vl vx vl
     weq vx cv c1 cuz cfv wcel vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv
     cexp co wceq vy cv c1 c3 cdiv co vl cv cexp co wceq vx cv vl cv c1 cuz cfv
     eleq1 vx vl weq c1 c3 cdiv co vx cv cexp co c1 c3 cdiv co vl cv cexp co vy
     cv vx cv vl cv c1 c3 cdiv co cexp opreq2 eqeq2d anbi12d cbvopab1v cn cr vx
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab
     vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy
     copab feq1 ax-mp mpbir jctil caddc vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv
     co vx cv cexp co wceq wa vx vy copab cseq1 co c1 c2 cdiv co cli wbr vf cv
     cc0 c2 cpr cn cm co wcel caddc vl cv cn wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab cseq1 co c1 c3 cdiv co c1 c1 c3 cdiv co cmin
     co cdiv co caddc vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co
     wceq wa vx vy copab cseq1 co c1 c2 cdiv co cli vy c1 c3 cdiv co vl vl cv
     cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv cn
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab eqid c3 3cn
     3ne0 reccli c1 c3 cdiv co cabs cfv c1 clt wbr c1 cneg c1 c3 cdiv co clt
     wbr c1 c3 cdiv co c1 clt wbr c1 c3 cdiv co c1 c3 3re 3ne0 rereccli 1re
     abslti c1 cneg cr wcel cc0 cr wcel c1 c3 cdiv co cr wcel w3a c1 cneg cc0
     clt wbr cc0 c1 c3 cdiv co clt wbr wa c1 cneg c1 c3 cdiv co clt wbr c1 cneg
     cr wcel cc0 cr wcel c1 c3 cdiv co cr wcel c1 1re renegcli 0re c3 3re 3ne0
     rereccli 3pm3.2i c1 cneg cc0 clt wbr cc0 c1 c3 cdiv co clt wbr c1 cneg cc0
     clt wbr cc0 c1 clt wbr lt01 c1 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr
     wb 1re c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr c1 lt0neg2 bicomd
     ax-mp mpbir c3 3re 3pos recgt0ii pm3.2i c1 cneg cc0 c1 c3 cdiv co axlttrn
     mp2 c1 c3 cdiv co c1 clt wbr c1 c3 clt wbr 1lt3 c3 cr wcel cc0 c3 clt wbr
     c1 c3 cdiv co c1 clt wbr c1 c3 clt wbr wb 3re 3pos c3 cr wcel cc0 c3 clt
     wbr wa c1 c3 clt wbr c1 c3 cdiv co c1 clt wbr c3 recgt1 bicomd mp2an mpbir
     mpbir2an geolim1i vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co
     wceq wa vx vy copab vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq
     wa vl vy copab caddc cseq1 vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv
     cexp co wceq wa vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vx
     vy vl vx vl weq vx cv c1 cuz cfv wcel vl cv cn wcel vy cv c1 c3 cdiv co vx
     cv cexp co wceq vy cv c1 c3 cdiv co vl cv cexp co wceq vx vl weq vx cv vl
     cv c1 cuz cfv cn vx vl weq id c1 cuz cfv cn wceq vx vl weq cn c1 cuz cfv
     nnuz eqcomi a1i eleq12d vx vl weq c1 c3 cdiv co vx cv cexp co c1 c3 cdiv
     co vl cv cexp co vy cv vx cv vl cv c1 c3 cdiv co cexp opreq2 eqeq2d
     anbi12d cbvopab1v opreq2i c1 c2 cdiv co c1 c3 cdiv co c2 c3 cdiv co cdiv
     co c1 c3 cdiv co c1 c1 c3 cdiv co cmin co cdiv co c1 c3 cdiv co c2 c3 cdiv
     co cdiv co c1 c3 cmul co c3 c2 cmul co cdiv co c3 c1 cmul co c3 c2 cmul co
     cdiv co c1 c2 cdiv co c1 c3 c2 c3 ax1cn 3cn 2cn 3cn 3ne0 3ne0 2ne0
     divdivdivi c1 c3 cmul co c3 c1 cmul co c3 c2 cmul co cdiv c1 c3 ax1cn 3cn
     mulcomi opreq1i c1 cc wcel c2 cc wcel c2 cc0 wne wa c3 cc wcel c3 cc0 wne
     wa c3 c1 cmul co c3 c2 cmul co cdiv co c1 c2 cdiv co wceq ax1cn c2 cc wcel
     c2 cc0 wne 2cn 2ne0 pm3.2i c3 cc wcel c3 cc0 wne 3cn 3ne0 pm3.2i c1 c2 c3
     divcan5 mp3an 3eqtrri c2 c3 cdiv co c1 c1 c3 cdiv co cmin co c1 c3 cdiv co
     cdiv c2 c3 cdiv co c3 c1 cmin co c3 cdiv co c3 c3 cdiv co c1 c3 cdiv co
     cmin co c1 c1 c3 cdiv co cmin co c2 c3 c1 cmin co c3 cdiv 2eq3m1 opreq1i
     c3 cc wcel c1 cc wcel c3 cc wcel c3 cc0 wne wa c3 c1 cmin co c3 cdiv co c3
     c3 cdiv co c1 c3 cdiv co cmin co wceq 3cn ax1cn c3 cc wcel c3 cc0 wne 3cn
     3ne0 pm3.2i c3 c1 c3 divsubdir mp3an c3 c3 cdiv co c1 c1 c3 cdiv co cmin
     c3 3cn 3ne0 dividi opreq1i 3eqtri opreq2i eqtri 3brtr4i a1i vf cv cc0 c2
     cpr cn cm co wcel c2 cr wcel cc0 c2 cle wbr wa cn cc vx cv c1 cuz cfv wcel
     vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab wf c1
     vl cv clt wbr vl cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq wa vx vy copab cfv cabs cfv c2 vl cv vx cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cmul co cle
     wbr wi vl cn wral c2 cr wcel cc0 c2 cle wbr wa vf cv cc0 c2 cpr cn cm co
     wcel c2 cr wcel cc0 c2 cle wbr 2re c2 cn wcel cc0 c2 cle wbr 2nn c2 cn
     wcel c2 crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl ax-mp pm3.2i a1i vf
     cv cc0 c2 cpr cn cm co wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cc
     wcel vx cn wral cn cc vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq wa vx vy copab wf vf cv cc0 c2 cpr cn cm co wcel vl
     cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel vl cn wral vx cv vf cv cfv
     c3 vx cv cexp co cdiv co cc wcel vx cn wral vf cv cc0 c2 cpr cn cm co wcel
     vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel vl cn vf cv cc0 c2 cpr cn
     cm co wcel cn cc0 c2 cpr vf cv wf vl cv cn wcel vl cv vf cv cfv c3 vl cv
     cexp co cdiv co cc wcel wi cc0 c2 cpr cn vf cv cc0 c2 prex nnex elmap cn
     cc0 c2 cpr vf cv wf vl cv cn wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co
     cc wcel vl cv vf cv cfv cc0 c2 cpr wcel cn cc0 c2 cpr vf cv wf vl cv cn
     wcel wa vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel cn cc0 c2 cpr vl
     cv vf cv ffvelrn cn cc0 c2 cpr vf cv wf vl cv cn wcel wa vl cv vf cv cfv
     cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel vl cv vf cv cfv
     cc0 c2 cpr wcel vl cv cn wcel vl cv vf cv cfv cc wcel vl cv vf cv cfv c3
     vl cv cexp co cdiv co cc wcel wi cn cc0 c2 cpr vf cv wf vl cv cn wcel vl
     cv vf cv cfv cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel vl
     cv vf cv cfv cc wcel c3 vl cv cexp co cc wcel c3 vl cv cexp co cc0 wne vl
     cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel vl cv cn wcel vl cv vf cv
     cfv cc wcel wa vl cv vf cv cfv c3 vl cv cexp co divcl vl cv cn wcel vl cv
     vf cv cfv cc wcel pm3.27 vl cv cn wcel c3 vl cv cexp co cc wcel vl cv vf
     cv cfv cc wcel c3 cc wcel vl cv cn0 wcel c3 vl cv cexp co cc wcel vl cv cn
     wcel c3 vl cv expcl 3cn vl cv nnnn0 sylancr adantr vl cv cn wcel c3 vl cv
     cexp co cc0 wne vl cv vf cv cfv cc wcel vl cv cn wcel c3 vl cv cexp co cc0
     wne c3 cc0 wceq wn c3 cc0 wne c3 cc0 wceq wn 3ne0 c3 cc0 df-ne mpbi vl cv
     cn wcel c3 cc0 wceq c3 vl cv cexp co cc0 c3 cc wcel vl cv cn wcel c3 vl cv
     cexp co cc0 wceq c3 cc0 wceq wb 3cn c3 vl cv expeq0 mpan necon3abid mpbiri
     adantr syl3anc ex adantl vl cv vf cv cfv cc0 c2 cpr wcel vl cv vf cv cfv
     cc0 wceq vl cv vf cv cfv c2 wceq wo vl cv vf cv cfv cc wcel vl cv vf cv
     cfv cc0 c2 vl cv vf cv fvex elpr vl cv vf cv cfv cc0 wceq vl cv vf cv cfv
     cc wcel vl cv vf cv cfv c2 wceq vl cv vf cv cfv cc0 wceq vl cv vf cv cfv
     cc wcel cc0 cc wcel 0cn vl cv vf cv cfv cc0 cc eleq1 mpbiri vl cv vf cv
     cfv c2 wceq vl cv vf cv cfv cc wcel c2 cc wcel 2cn vl cv vf cv cfv c2 cc
     eleq1 mpbiri jaoi sylbi syl5com mpcom ex sylbi r19.21aiv vx cv vf cv cfv
     c3 vx cv cexp co cdiv co cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co
     cc wcel vx vl cn vx vl weq vx cv vf cv cfv c3 vx cv cexp co cdiv co vl cv
     vf cv cfv c3 vl cv cexp co cdiv co cc vx vl weq vx cv vf cv cfv vl cv vf
     cv cfv c3 vx cv cexp co c3 vl cv cexp co cdiv vx cv vl cv vf cv fveq2 vx
     cv vl cv c3 cexp opreq2 opreq12d eleq1d cbvralv sylibr vx vy cn cc vx cv
     vf cv cfv c3 vx cv cexp co cdiv co vx cv c1 cuz cfv wcel vy cv vx cv vf cv
     cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab vx cv c1 cuz cfv wcel vy
     cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx cv cn wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy vx cv c1 cuz cfv wcel
     vx cv cn wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq c1 cuz
     cfv cn vx cv cn c1 cuz cfv nnuz eqcomi eleq2i anbi1i opabbii fopab2 sylib
     vf cv cc0 c2 cpr cn cm co wcel c1 vx cv clt wbr vx cv vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv cmul co cle wbr wi vx cn wral c1 vl cv clt wbr
     vl cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co
     wceq wa vx vy copab cfv cabs cfv c2 vl cv vx cv c1 cuz cfv wcel vy cv c1
     c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cmul co cle wbr wi vl cn
     wral vf cv cc0 c2 cpr cn cm co wcel c1 vx cv clt wbr vx cv vl cv c1 cuz
     cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl
     cv cexp co wceq wa vl vy copab cfv cmul co cle wbr wi vx cn vf cv cc0 c2
     cpr cn cm co wcel vx cv cn wcel vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv
     vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy
     copab cfv cmul co cle wbr c1 vx cv clt wbr vf cv cc0 c2 cpr cn cm co wcel
     vx cv cn wcel vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv cmul co cle
     wbr vf cv cc0 c2 cpr cn cm co wcel vx cv cn wcel wa vx cv vf cv cfv c3 vx
     cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co vx cv
     vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq
     wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vl cv cexp co wceq wa vl vy copab cfv cmul co cle cn cc0 c2 cpr vf
     cv wf vx cv cn wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2
     c1 c3 cdiv co vx cv cexp co cmul co cle wbr vf cv cc0 c2 cpr cn cm co wcel
     vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf
     vx cv cn wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c1
     c3 cdiv co vx cv cexp co cmul co cle wbr cn cc0 c2 cpr vf cv wf vx cv cn
     wcel wa vx cv vf cv cfv cc0 c2 cpr wcel vx cv vf cv cfv cc0 wceq vx cv vf
     cv cfv c2 wceq wo cn cc0 c2 cpr vx cv vf cv ffvelrn vx cv vf cv cfv cc0 c2
     vx cv vf cv fvex elpr sylib cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv
     vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2
     c1 c3 cdiv co vx cv cexp co cmul co cle wbr vx cv vf cv cfv cc0 wceq vx cv
     vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv
     cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp co cdiv co c2 c3 vx cv cexp
     co cdiv co cle wbr vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c1
     c3 cdiv co vx cv cexp co cmul co cle wbr vx cv vf cv cfv cr wcel c2 cr
     wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt wbr wa vx cv vf cv
     cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp co cdiv co c2 c3 vx cv cexp
     co cdiv co cle wbr wi cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv
     cfv cr wcel c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt
     wbr wa w3a vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp co
     cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv c2 c3 vx cv
     cexp co lediv1 biimpd cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv
     cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv cfv cr wcel cn cc0 c2
     cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2 cpr wcel vx cv vf cv
     cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vx cv vf cv ffvelrn
     vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib vx cv vf cv cfv cc0
     wceq vx cv vf cv cfv cr wcel vx cv vf cv cfv c2 wceq vx cv vf cv cfv cc0
     wceq vx cv vf cv cfv cr wcel cc0 cr wcel 0re vx cv vf cv cfv cc0 cr eleq1
     mpbiri vx cv vf cv cfv c2 wceq vx cv vf cv cfv cr wcel c2 cr wcel 2re vx
     cv vf cv cfv c2 cr eleq1 mpbiri jaoi syl c2 cr wcel cn cc0 c2 cpr vf cv wf
     vx cv cn wcel wa 2re a1i vx cv cn wcel c3 vx cv cexp co cr wcel cc0 c3 vx
     cv cexp co clt wbr wa cn cc0 c2 cpr vf cv wf vx cv cn wcel c3 vx cv cexp
     co cr wcel cc0 c3 vx cv cexp co clt wbr c3 cr wcel vx cv cn0 wcel c3 vx cv
     cexp co cr wcel vx cv cn wcel c3 vx cv reexpcl 3re vx cv nnnn0 sylancr vx
     cv cn wcel c3 cn wcel vx cv cn0 wcel wa c3 vx cv cexp co cn wcel cc0 c3 vx
     cv cexp co clt wbr vx cv cn wcel vx cv cn0 wcel c3 cn wcel vx cv nnnn0 3nn
     jctil c3 vx cv nnexpcl c3 vx cv cexp co nngt0 3syl jca adantl syl3anc cn
     cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv
     co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv c3 vx
     cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr
     cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv cexp co
     cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv c3 vx cv cexp
     co cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co cle wbr cn cc0 c2 cpr vf
     cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co vx cv vf
     cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co cle
     cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cabs cfv vx cv vf cv cfv c3 vx cv cexp co cdiv co cn cc0 c2 cpr vf
     cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel
     cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wa vx cv vf cv cfv c3
     vx cv cexp co cdiv co cabs cfv vx cv vf cv cfv c3 vx cv cexp co cdiv co
     wceq cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 wceq vx
     cv vf cv cfv c2 wceq wo vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel
     cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wa cn cc0 c2 cpr vf
     cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2 cpr wcel vx cv vf cv cfv cc0
     wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vx cv vf cv ffvelrn vx cv vf
     cv cfv cc0 c2 vx cv vf cv fvex elpr sylib vx cv cn wcel vx cv vf cv cfv
     cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv cfv c3 vx cv cexp co cdiv
     co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wa wi cn
     cc0 c2 cpr vf cv wf vx cv cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv
     c2 wceq wo vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel cc0 vx cv vf
     cv cfv c3 vx cv cexp co cdiv co cle wbr wa vx cv cn wcel vx cv vf cv cfv
     cc0 wceq vx cv vf cv cfv c2 wceq wo wa vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv
     vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv cn wcel vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel vx cv vf cv cfv cc0 wceq vx cv cn
     wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel wi vx cv vf cv cfv
     c2 wceq vx cv vf cv cfv cc0 wceq vx cv cn wcel vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cr wcel vx cv vf cv cfv cc0 wceq vx cv cn wcel wa vx cv vf
     cv cfv c3 vx cv cexp co cdiv co cr wcel cc0 c3 vx cv cexp co cdiv co cr
     wcel vx cv vf cv cfv cc0 wceq vx cv cn wcel wa cc0 cr wcel c3 vx cv cexp
     co cr wcel c3 vx cv cexp co cc0 wne w3a cc0 c3 vx cv cexp co cdiv co cr
     wcel vx cv cn wcel cc0 cr wcel c3 vx cv cexp co cr wcel c3 vx cv cexp co
     cc0 wne w3a vx cv vf cv cfv cc0 wceq c3 cr wcel vx cv cn0 wcel cc0 cr wcel
     c3 vx cv cexp co cr wcel c3 vx cv cexp co cc0 wne w3a vx cv cn wcel c3 cr
     wcel vx cv cn0 wcel wa cc0 cr wcel c3 vx cv cexp co cr wcel c3 vx cv cexp
     co cc0 wne cc0 cr wcel c3 cr wcel vx cv cn0 wcel wa 0re a1i c3 vx cv
     reexpcl c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp co cc0 wne c3
     cr wcel vx cv cn0 wcel wa c3 vx cv expne0i c3 cr wcel c3 cc wcel vx cv cn0
     wcel c3 recn adantr c3 cc0 wne c3 cr wcel vx cv cn0 wcel wa 3ne0 a1i c3 cr
     wcel vx cv cn0 wcel pm3.27 syl3anc 3jca 3re vx cv nnnn0 sylancr adantl cc0
     c3 vx cv cexp co redivcl syl vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c3
     vx cv cexp co cdiv co cr wcel cc0 c3 vx cv cexp co cdiv co cr wcel wb vx
     cv cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c3 vx cv cexp co cdiv
     co cc0 c3 vx cv cexp co cdiv co cr vx cv vf cv cfv cc0 c3 vx cv cexp co
     cdiv opreq1 eleq1d adantr mpbird ex vx cv vf cv cfv c2 wceq vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel c2 c3 vx cv cexp co cdiv co cr wcel
     vx cv cn wcel vx cv vf cv cfv c2 wceq vx cv vf cv cfv c3 vx cv cexp co
     cdiv co c2 c3 vx cv cexp co cdiv co cr vx cv vf cv cfv c2 c3 vx cv cexp co
     cdiv opreq1 eleq1d c2 cr wcel c3 vx cv cexp co cr wcel c3 vx cv cexp co
     cc0 wne c2 c3 vx cv cexp co cdiv co cr wcel vx cv cn wcel c2 c3 vx cv cexp
     co redivcl c2 cr wcel vx cv cn wcel 2re a1i c3 cr wcel vx cv cn0 wcel c3
     vx cv cexp co cr wcel vx cv cn wcel c3 vx cv reexpcl 3re vx cv nnnn0
     sylancr c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp co cc0 wne vx
     cv cn wcel c3 vx cv expne0i c3 cc wcel vx cv cn wcel 3cn a1i c3 cc0 wne vx
     cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc syl3anc syl5bir jaoi impcom vx cv
     vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv cn wcel cc0 vx cv vf
     cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv cc0 wceq vx cv cn
     wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wi vx cv vf cv
     cfv c2 wceq vx cv vf cv cfv cc0 wceq cc0 vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cle wbr cc0 cc0 c3 vx cv cexp co cdiv co cle wbr vx cv cn wcel vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv c3 vx cv cexp co cdiv co cc0 c3 vx
     cv cexp co cdiv co cc0 cle vx cv vf cv cfv cc0 c3 vx cv cexp co cdiv
     opreq1 breq2d vx cv cn wcel cc0 cc0 cle wbr cc0 cc0 c3 vx cv cexp co cdiv
     co cle wbr cc0 0re leidi cc0 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv
     cexp co clt wbr cc0 cc0 cle wbr cc0 cc0 c3 vx cv cexp co cdiv co cle wbr
     wb vx cv cn wcel cc0 c3 vx cv cexp co ge0div cc0 cr wcel vx cv cn wcel 0re
     a1i c3 cr wcel vx cv cn0 wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx
     cv reexpcl 3re vx cv nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel
     wa c3 vx cv cexp co cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx
     cv cn0 wcel c3 cn wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv
     cexp co nngt0 3syl syl3anc mpbii syl5bir vx cv vf cv cfv c2 wceq vx cv cn
     wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv
     c2 wceq vx cv cn wcel wa cc0 c2 c3 vx cv cexp co cdiv co vx cv vf cv cfv
     c3 vx cv cexp co cdiv co cle vx cv cn wcel cc0 c2 c3 vx cv cexp co cdiv co
     cle wbr vx cv vf cv cfv c2 wceq c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3
     vx cv cexp co clt wbr cc0 c2 c3 vx cv cexp co cdiv co cle wbr vx cv cn
     wcel c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt wbr w3a
     cc0 c2 cle wbr cc0 c2 c3 vx cv cexp co cdiv co cle wbr c2 cn wcel cc0 c2
     cle wbr 2nn c2 cn wcel c2 crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl
     ax-mp c2 c3 vx cv cexp co ge0div mpbii c2 cr wcel vx cv cn wcel 2re a1i c3
     cr wcel vx cv cn0 wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv
     reexpcl 3re vx cv nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel wa
     c3 vx cv cexp co cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx cv
     cn0 wcel c3 cn wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv cexp
     co nngt0 3syl syl3anc adantl vx cv vf cv cfv c2 wceq vx cv cn wcel wa vx
     cv vf cv cfv c2 c3 vx cv cexp co cdiv vx cv vf cv cfv c2 wceq vx cv cn
     wcel pm3.26 opreq1d breqtrrd ex jaoi impcom jca ex adantl mpd vx cv vf cv
     cfv c3 vx cv cexp co cdiv co absid syl eqcomd breq1d biimpd cn cc0 c2 cpr
     vf cv wf vx cv cn wcel wa c2 c3 vx cv cexp co cdiv co c2 c1 c3 cdiv co vx
     cv cexp co cmul co vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv cle
     vx cv cn wcel c2 c3 vx cv cexp co cdiv co c2 c1 c3 cdiv co vx cv cexp co
     cmul co wceq cn cc0 c2 cpr vf cv wf vx cv cn wcel c2 c3 vx cv cexp co cdiv
     co c2 c1 c3 vx cv cexp co cdiv co cmul co c2 c1 c3 cdiv co vx cv cexp co
     cmul co c2 cc wcel c3 vx cv cexp co cc wcel c3 vx cv cexp co cc0 wne c2 c3
     vx cv cexp co cdiv co c2 c1 c3 vx cv cexp co cdiv co cmul co wceq vx cv cn
     wcel c2 c3 vx cv cexp co divrec c2 cc wcel vx cv cn wcel 2cn a1i c3 cc
     wcel vx cv cn0 wcel c3 vx cv cexp co cc wcel vx cv cn wcel c3 vx cv expcl
     3cn vx cv nnnn0 sylancr c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp
     co cc0 wne vx cv cn wcel c3 vx cv expne0i c3 cc wcel vx cv cn wcel 3cn a1i
     c3 cc0 wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc syl3anc vx cv cn
     wcel c1 c3 vx cv cexp co cdiv co c1 c3 cdiv co vx cv cexp co c2 cmul vx cv
     cn wcel c1 c3 cdiv co vx cv cexp co c1 c3 vx cv cexp co cdiv co c3 cc wcel
     c3 cc0 wne vx cv cn0 wcel c1 c3 cdiv co vx cv cexp co c1 c3 vx cv cexp co
     cdiv co wceq vx cv cn wcel c3 vx cv exprec c3 cc wcel vx cv cn wcel 3cn
     a1i c3 cc0 wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc eqcomd opreq2d
     eqtrd adantl breq2d sylibd syld vx cv vf cv cfv cc0 wceq vx cv vf cv cfv
     c2 cle wbr vx cv vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq vx cv vf cv
     cfv c2 cle wbr cc0 c2 cle wbr c2 cn wcel cc0 c2 cle wbr 2nn c2 cn wcel c2
     crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl ax-mp vx cv vf cv cfv cc0 c2
     cle breq1 mpbiri vx cv vf cv cfv c2 wceq vx cv vf cv cfv c2 cle wbr c2 c2
     cle wbr c2 2re leidi vx cv vf cv cfv c2 c2 cle breq1 mpbiri jaoi syl5com
     mpcom cc0 c2 cpr cn vf cv cc0 c2 prex nnex elmap sylanb vf cv cc0 c2 cpr
     cn cm co wcel vx cv cn wcel wa vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vx cv vf cv cfv c3
     vx cv cexp co cdiv co cabs vx cv c1 cuz cfv wcel vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cvv wcel vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq vf cv cc0 c2 cpr cn cm co wcel vx cv cn wcel wa vl vy
     vx cv vl cv vf cv cfv c3 vl cv cexp co cdiv co vx cv vf cv cfv c3 vx cv
     cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vx weq vl cv vf cv cfv vx
     cv vf cv cfv c3 vl cv cexp co c3 vx cv cexp co cdiv vl cv vx cv vf cv
     fveq2 vl cv vx cv c3 cexp opreq2 opreq12d vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid fvopab4g vx
     cv cn wcel vx cv c1 cuz cfv wcel vf cv cc0 c2 cpr cn cm co wcel vx cv cn
     wcel vx cv c1 cuz cfv wcel vx cv elnnuz biimpi adantl vx cv vf cv cfv c3
     vx cv cexp co cdiv oprex sylancl fveq2d vf cv cc0 c2 cpr cn cm co wcel vx
     cv cn wcel wa vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv cexp co c2 cmul vx cv cn
     wcel vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa
     vl vy copab cfv c1 c3 cdiv co vx cv cexp co wceq vf cv cc0 c2 cpr cn cm co
     wcel vx cv cn wcel vx cv c1 cuz cfv wcel vx cv vl cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv
     cexp co wceq c1 cuz cfv cn vx cv cn c1 cuz cfv nnuz eqcomi eleq2i vx cv c1
     cuz cfv wcel c1 c3 cdiv co vx cv cexp co cvv wcel vx cv vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv
     co vx cv cexp co wceq c1 c3 cdiv co vx cv cexp oprex vl vy vx cv c1 c3
     cdiv co vl cv cexp co c1 c3 cdiv co vx cv cexp co c1 cuz cfv cvv vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv
     vx cv c1 c3 cdiv co cexp opreq2 vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab eqid fvopab4g mpan2 sylbir adantl
     opreq2d 3brtr4d ex a1dd r19.21aiv c1 vl cv clt wbr vl cv vx cv c1 cuz cfv
     wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab
     cfv cabs cfv c2 vl cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp
     co wceq wa vx vy copab cfv cmul co cle wbr wi c1 vx cv clt wbr vx cv vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab cfv cmul co cle wbr wi vl vx cn c1 vl cv
     clt wbr vl cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co wceq wa vx vy copab cfv cabs cfv c2 vl cv vx cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cmul co cle wbr vx
     c1 vl cv clt wbr vx ax-17 vx vu vl cv vx cv c1 cuz cfv wcel vy cv vx cv vf
     cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cabs cfv c2 vl cv
     vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy
     copab cfv cmul co cle vx vu vl cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv
     cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cabs vu cv cabs wcel
     vx ax-17 vx vu vl cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq wa vx vy copab vx cv c1 cuz cfv wcel vy cv vx cv vf
     cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy vu hbopab1 vu vl wel vx
     ax-17 hbfv hbfv vu cv cle wcel vx ax-17 vx vu c2 vl cv vx cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cmul vu cv
     c2 wcel vx ax-17 vu cv cmul wcel vx ax-17 vx vu vl cv vx cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab vx cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy vu hbopab1 vu vl
     wel vx ax-17 hbfv hbopr hbbr hbim c1 vx cv clt wbr vx cv vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv cmul co cle wbr vl c1 vx cv clt wbr vl ax-17 vl
     vu vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv
     co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv cmul co cle vl vu vx
     cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv cabs vu cv cabs wcel vl ax-17 vl vu vx cv vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy vu hbopab1 vu vx wel vl ax-17 hbfv hbfv vu cv cle wcel vl
     ax-17 vl vu c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv cmul vu cv c2 wcel vl ax-17 vu cv cmul wcel vl
     ax-17 vl vu vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy vu hbopab1 vu vx wel vl ax-17 hbfv hbopr hbbr hbim vl vx
     weq c1 vl cv clt wbr c1 vx cv clt wbr vl cv vx cv c1 cuz cfv wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv cabs cfv c2
     vl cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx
     vy copab cfv cmul co cle wbr vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     cfv cmul co cle wbr vl cv vx cv c1 clt breq2 vl vx weq vl cv vx cv c1 cuz
     cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy
     copab cfv cabs cfv vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vl cv vx cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq wa vx vy copab cfv cmul co
     c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa
     vl vy copab cfv cmul co cle vl vx weq vl cv vx cv c1 cuz cfv wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cfv vx cv vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab cfv cabs vl vx weq vl cv vx cv vx cv c1 cuz cfv wcel vy cv vx cv
     vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab vx
     cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa
     vx vy copab vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab wceq vl vx weq vx cv c1 cuz cfv wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vl cv c1 cuz cfv wcel vy cv
     vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vx vy vl vx vl weq vx cv
     c1 cuz cfv wcel vl cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp
     co cdiv co wceq vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq vx cv
     vl cv c1 cuz cfv eleq1 vx vl weq vx cv vf cv cfv c3 vx cv cexp co cdiv co
     vl cv vf cv cfv c3 vl cv cexp co cdiv co vy cv vx vl weq vx cv vf cv cfv
     vl cv vf cv cfv c3 vx cv cexp co c3 vl cv cexp co cdiv vx cv vl cv vf cv
     fveq2 vx cv vl cv c3 cexp opreq2 opreq12d eqeq2d anbi12d cbvopab1v a1i vl
     vx weq id fveq12d fveq2d vl vx weq vl cv vx cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vx cv cexp co wceq wa vx vy copab cfv vx cv vl cv c1 cuz cfv wcel
     vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c2 cmul vl vx
     weq vl cv vx cv vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co
     wceq wa vx vy copab vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab vx cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vx cv
     cexp co wceq wa vx vy copab vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl
     cv cexp co wceq wa vl vy copab wceq vl vx weq vx cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vx cv cexp co wceq wa vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv
     co vl cv cexp co wceq wa vx vy vl vx vl weq vx cv c1 cuz cfv wcel vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vx cv cexp co wceq vy cv c1 c3 cdiv co vl
     cv cexp co wceq vx cv vl cv c1 cuz cfv eleq1 vx vl weq c1 c3 cdiv co vx cv
     cexp co c1 c3 cdiv co vl cv cexp co vy cv vx cv vl cv c1 c3 cdiv co cexp
     opreq2 eqeq2d anbi12d cbvopab1v a1i vl vx weq id fveq12d opreq2d breq12d
     imbi12d cbvral sylibr jca32 jca31 sylancr c1 caddc cop vx cv c1 cuz cfv
     wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab
     cseqz co va cv cli wbr caddc vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv
     c3 vx cv cexp co cdiv co wceq wa vx vy copab cseq1 co va cv cli wbr va c1
     caddc cop vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co wceq wa vx vy copab cseqz co caddc vx cv c1 cuz cfv wcel vy cv vx
     cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cseq1 co va cv
     cli caddc vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co wceq wa vx vy copab cseq1 co c1 caddc cop vx cv c1 cuz cfv wcel vy
     cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy copab cseqz co
     caddc vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co
     wceq wa vx vy copab addex vx vy c1 cuz cfv vx cv vf cv cfv c3 vx cv cexp
     co cdiv co c1 cuz fvex opabex2 seq1seqz eqcomi breq1i exbii sylibr 3jca c1
     cz wcel vk cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co wceq wa vx vy copab cfv cr wcel vk c1 cuz cfv wral c1 caddc cop vx
     cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa
     vx vy copab cseqz co va cv cli wbr va wex w3a c1 cuz cfv vk cv vx cv c1
     cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx vy
     copab cfv vk csu cr cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu va
     vk vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co
     wceq wa vx vy copab c1 vx vy c1 cuz cfv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co c1 cuz fvex opabex2 isumrecl cn c1 cuz cfv vk cv vf cv cfv c3 vk
     cv cexp co cdiv co vk cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx
     cv cexp co cdiv co wceq wa vx vy copab cfv vk nnuz vk cv c1 cuz cfv wcel
     vk cv vf cv cfv c3 vk cv cexp co cdiv co cvv wcel vk cv vf cv cfv c3 vk cv
     cexp co cdiv co vk cv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq wa vx vy copab cfv wceq vk cv cn wcel vk cv c1 cuz
     cfv wcel vk cv vf cv cfv c3 vk cv cexp co cdiv co cvv wcel wa vk cv vx cv
     c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp co cdiv co wceq wa vx
     vy copab cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co vx vy vk cv vx cv vf
     cv cfv c3 vx cv cexp co cdiv co vk cv vf cv cfv c3 vk cv cexp co cdiv co
     c1 cuz cfv cvv vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx cv cexp
     co cdiv co wceq wa vx vy copab vx vk weq vx cv vf cv cfv vk cv vf cv cfv
     c3 vx cv cexp co c3 vk cv cexp co cdiv vx cv vk cv vf cv fveq2 vx cv vk cv
     c3 cexp opreq2 opreq12d vx cv c1 cuz cfv wcel vy cv vx cv vf cv cfv c3 vx
     cv cexp co cdiv co wceq wa vx vy copab eqid fvopab4g eqcomd vk cv cn wcel
     vk cv c1 cuz cfv wcel vk cv elnnuz biimpi vk cv vf cv cfv c3 vk cv cexp co
     cdiv oprex sylancl sumeq12i syl5eqel cn vk cv vf cv cfv c3 vk cv cexp co
     cdiv co vk csu rexr 3syl c1 cz wcel c1 caddc cop vl cv c1 cuz cfv wcel vy
     cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co
     cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cli wbr vk cv vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cr wcel cc0 vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cle wbr wa vk c1 cuz cfv
     wral cc0 cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cle wbr vf cv
     cc0 c2 cpr cn cm co wcel cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk
     csu vk vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv
     co wceq wa vl vy copab c1 cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk
     sumex vl vy c1 cuz cfv vl cv vf cv cfv c3 vl cv cexp co cdiv co c1 cuz
     fvex opabex2 iserzcmp0 c1 cz wcel vf cv cc0 c2 cpr cn cm co wcel 1z a1i c1
     cz wcel c1 caddc cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cseqz co va cv cli wbr va wex c1 caddc
     cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cseqz co cn vk cv vf cv cfv c3 vk cv cexp co cdiv co
     vk csu cli wbr vf cv cc0 c2 cpr cn cm co wcel c1 cz wcel c1 caddc cop vl
     cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cseqz co va cv cli wbr va wex wa c1 caddc cop vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cseqz co c1 cuz cfv vl cv vf cv cfv c3 vl cv cexp co cdiv co vl csu cn vk
     cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cli va vy vl cv vf cv cfv c3
     vl cv cexp co cdiv co vl vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab c1 vl cv vf cv cfv c3 vl cv cexp co
     cdiv oprex vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab eqid isumclim3 cn vk cv vf cv cfv c3 vk cv
     cexp co cdiv co vk csu cn vl cv vf cv cfv c3 vl cv cexp co cdiv co vl csu
     c1 cuz cfv vl cv vf cv cfv c3 vl cv cexp co cdiv co vl csu vu cn vk cv vf
     cv cfv c3 vk cv cexp co cdiv co vl cv vf cv cfv c3 vl cv cexp co cdiv co
     vk vl vu cv vk cv vf cv cfv c3 vk cv cexp co cdiv co wcel vl ax-17 vu cv
     vl cv vf cv cfv c3 vl cv cexp co cdiv co wcel vk ax-17 vk vl weq vk cv vf
     cv cfv vl cv vf cv cfv c3 vk cv cexp co c3 vl cv cexp co cdiv vk cv vl cv
     vf cv fveq2 vk cv vl cv c3 cexp opreq2 opreq12d cbvsumi cn c1 cuz cfv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co vl nnuz sumeq1i eqtri syl6breqr 1z
     vf cv cc0 c2 cpr cn cm co wcel c1 caddc cop vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co va cv
     cli wbr va wex caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cseq1 co va cv cli wbr va wex c1 cn
     wcel cn cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa
     vl vy copab wf cc0 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab cfv cle wbr vx cn wral wa caddc vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cseq1 co c1
     c2 cdiv co cli wbr wa c2 cr wcel cc0 c2 cle wbr wa cn cc vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab wf
     c1 vx cv clt wbr vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv cmul co
     cle wbr wi vx cn wral wa wa caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co va cv cli wbr va
     wex vf cv cc0 c2 cpr cn cm co wcel c1 cn wcel vf cv cc0 c2 cpr cn cm co
     wcel 1nn a1i cn cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab wf cc0 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab cfv cle wbr vx cn wral wa caddc vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cseq1
     co c1 c2 cdiv co cli wbr wa vf cv cc0 c2 cpr cn cm co wcel cn cr vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf cc0
     vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl
     vy copab cfv cle wbr vx cn wral wa caddc vl cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vl cv cexp co wceq wa vl vy copab cseq1 co c1 c2 cdiv co cli wbr
     cn cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl
     vy copab wf cc0 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv cle wbr vx cn wral cn cr vl cv c1 cuz cfv wcel
     vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf c1 cuz cfv cr vl
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     wf c1 c3 cdiv co vl cv cexp co cr wcel vl c1 cuz cfv wral c1 cuz cfv cr vl
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     wf c1 c3 cdiv co vl cv cexp co cr wcel vl c1 cuz cfv c1 c3 cdiv co cr wcel
     vl cv cn0 wcel c1 c3 cdiv co vl cv cexp co cr wcel vl cv c1 cuz cfv wcel
     c1 c3 cdiv co vl cv reexpcl c3 3re 3ne0 rereccli vl cv c1 cuz cfv wcel vl
     cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir sylancr rgen vl
     vy c1 cuz cfv cr c1 c3 cdiv co vl cv cexp co vl cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab eqid fopab2 mpbi cn c1
     cuz cfv wceq cn cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab wf c1 cuz cfv cr vl cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vl cv cexp co wceq wa vl vy copab wf wb nnuz cn c1 cuz cfv cr vl
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     feq2 ax-mp mpbir cc0 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab cfv cle wbr vx cn vx cv cn wcel cc0 c1 c3 cdiv
     co vx cv cexp co vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab cfv cle c1 c3 cdiv co cr wcel vx cv cn0 wcel
     cc0 c1 c3 cdiv co cle wbr cc0 c1 c3 cdiv co vx cv cexp co cle wbr vx cv cn
     wcel c1 c3 cdiv co vx cv expge0 c1 c3 cdiv co cr wcel vx cv cn wcel c3 3re
     3ne0 rereccli a1i vx cv nnnn0 cc0 c1 c3 cdiv co cle wbr vx cv cn wcel c1
     cr wcel cc0 c1 cle wbr wa c3 cr wcel cc0 c3 clt wbr wa cc0 c1 c3 cdiv co
     cle wbr c1 cr wcel cc0 c1 cle wbr 1re cc0 c1 0re 1re lt01 ltleii pm3.2i c3
     cr wcel cc0 c3 clt wbr 3re 3pos pm3.2i c1 c3 divge0 mp2an a1i syl3anc vx
     cv cn wcel vx cv c1 cuz cfv wcel vx cv vl cv c1 cuz cfv wcel vy cv c1 c3
     cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv cexp co
     wceq c1 cuz cfv cn vx cv cn c1 cuz cfv nnuz eqcomi eleq2i vx cv c1 cuz cfv
     wcel c1 c3 cdiv co vx cv cexp co cvv wcel vx cv vl cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv
     cexp co wceq c1 c3 cdiv co vx cv cexp oprex vl vy vx cv c1 c3 cdiv co vl
     cv cexp co c1 c3 cdiv co vx cv cexp co c1 cuz cfv cvv vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv vx cv c1
     c3 cdiv co cexp opreq2 vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab eqid fvopab4g mpan2 sylbir breqtrrd rgen
     pm3.2i caddc vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy
     copab cseq1 co c1 c3 cdiv co c1 c1 c3 cdiv co cmin co cdiv co caddc vl cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     cseq1 co c1 c2 cdiv co cli vy c1 c3 cdiv co vl vl cv cn wcel vy cv c1 c3
     cdiv co vl cv cexp co wceq wa vl vy copab vl cv cn wcel vy cv c1 c3 cdiv
     co vl cv cexp co wceq wa vl vy copab eqid c3 3cn 3ne0 reccli c1 c3 cdiv co
     cabs cfv c1 clt wbr c1 cneg c1 c3 cdiv co clt wbr c1 c3 cdiv co c1 clt wbr
     c1 c3 cdiv co c1 c3 3re 3ne0 rereccli 1re abslti c1 cneg cr wcel cc0 cr
     wcel c1 c3 cdiv co cr wcel w3a c1 cneg cc0 clt wbr cc0 c1 c3 cdiv co clt
     wbr wa c1 cneg c1 c3 cdiv co clt wbr c1 cneg cr wcel cc0 cr wcel c1 c3
     cdiv co cr wcel c1 1re renegcli 0re c3 3re 3ne0 rereccli 3pm3.2i c1 cneg
     cc0 clt wbr cc0 c1 c3 cdiv co clt wbr c1 cneg cc0 clt wbr cc0 c1 clt wbr
     lt01 c1 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr wb 1re c1 cr wcel cc0
     c1 clt wbr c1 cneg cc0 clt wbr c1 lt0neg2 bicomd ax-mp mpbir c3 3re 3pos
     recgt0ii pm3.2i c1 cneg cc0 c1 c3 cdiv co axlttrn mp2 c1 c3 cdiv co c1 clt
     wbr c1 c3 clt wbr 1lt3 c3 cr wcel cc0 c3 clt wbr c1 c3 cdiv co c1 clt wbr
     c1 c3 clt wbr wb 3re 3pos c3 cr wcel cc0 c3 clt wbr wa c1 c3 clt wbr c1 c3
     cdiv co c1 clt wbr c3 recgt1 bicomd mp2an mpbir mpbir2an geolim1i vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv
     cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab caddc cseq1
     vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl cv cn
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy vl cv c1 cuz cfv wcel
     vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq vl cv cn wcel vl cv
     c1 cuz cfv wcel vl cv elnnuz bicomi anbi1i opabbii opreq2i c1 c2 cdiv co
     c1 c3 cdiv co c2 c3 cdiv co cdiv co c1 c3 cdiv co c1 c1 c3 cdiv co cmin co
     cdiv co c1 c3 cdiv co c2 c3 cdiv co cdiv co c1 c3 cmul co c3 c2 cmul co
     cdiv co c3 c1 cmul co c3 c2 cmul co cdiv co c1 c2 cdiv co c1 c3 c2 c3
     ax1cn 3cn 2cn 3cn 3ne0 3ne0 2ne0 divdivdivi c1 c3 cmul co c3 c1 cmul co c3
     c2 cmul co cdiv c1 c3 ax1cn 3cn mulcomi opreq1i c1 cc wcel c2 cc wcel c2
     cc0 wne wa c3 cc wcel c3 cc0 wne wa c3 c1 cmul co c3 c2 cmul co cdiv co c1
     c2 cdiv co wceq ax1cn c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i c3 cc wcel c3
     cc0 wne 3cn 3ne0 pm3.2i c1 c2 c3 divcan5 mp3an 3eqtrri c2 c3 cdiv co c1 c1
     c3 cdiv co cmin co c1 c3 cdiv co cdiv c2 c3 cdiv co c3 c1 cmin co c3 cdiv
     co c3 c3 cdiv co c1 c3 cdiv co cmin co c1 c1 c3 cdiv co cmin co c2 c3 c1
     cmin co c3 cdiv 2eq3m1 opreq1i c3 cc wcel c1 cc wcel c3 cc wcel c3 cc0 wne
     wa c3 c1 cmin co c3 cdiv co c3 c3 cdiv co c1 c3 cdiv co cmin co wceq 3cn
     ax1cn c3 cc wcel c3 cc0 wne 3cn 3ne0 pm3.2i c3 c1 c3 divsubdir mp3an c3 c3
     cdiv co c1 c1 c3 cdiv co cmin c3 3cn 3ne0 dividi opreq1i 3eqtri opreq2i
     eqtri 3brtr4i pm3.2i a1i vf cv cc0 c2 cpr cn cm co wcel c2 cr wcel cc0 c2
     cle wbr wa cn cc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp
     co cdiv co wceq wa vl vy copab wf c1 vx cv clt wbr vx cv vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv cmul co cle wbr wi vx cn wral c2 cr wcel cc0 c2
     cle wbr wa vf cv cc0 c2 cpr cn cm co wcel c2 cr wcel cc0 c2 cle wbr 2re c2
     cn wcel cc0 c2 cle wbr 2nn c2 cn wcel c2 crp wcel cc0 c2 cle wbr c2 nnrp
     c2 rpge0 syl ax-mp pm3.2i a1i vf cv cc0 c2 cpr cn cm co wcel vl cv vf cv
     cfv c3 vl cv cexp co cdiv co cc wcel vl cn wral cn cc vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab wf
     vf cv cc0 c2 cpr cn cm co wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc
     wcel vl cn vf cv cc0 c2 cpr cn cm co wcel cn cc0 c2 cpr vf cv wf vl cv cn
     wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel wi cc0 c2 cpr cn vf
     cv cc0 c2 prex nnex elmap cn cc0 c2 cpr vf cv wf vl cv cn wcel vl cv vf cv
     cfv c3 vl cv cexp co cdiv co cc wcel vl cv vf cv cfv cc0 c2 cpr wcel cn
     cc0 c2 cpr vf cv wf vl cv cn wcel wa vl cv vf cv cfv c3 vl cv cexp co cdiv
     co cc wcel cn cc0 c2 cpr vl cv vf cv ffvelrn cn cc0 c2 cpr vf cv wf vl cv
     cn wcel wa vl cv vf cv cfv cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv
     co cc wcel vl cv vf cv cfv cc0 c2 cpr wcel vl cv cn wcel vl cv vf cv cfv
     cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel wi cn cc0 c2 cpr
     vf cv wf vl cv cn wcel vl cv vf cv cfv cc wcel vl cv vf cv cfv c3 vl cv
     cexp co cdiv co cc wcel vl cv vf cv cfv cc wcel c3 vl cv cexp co cc wcel
     c3 vl cv cexp co cc0 wne vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel
     vl cv cn wcel vl cv vf cv cfv cc wcel wa vl cv vf cv cfv c3 vl cv cexp co
     divcl vl cv cn wcel vl cv vf cv cfv cc wcel pm3.27 vl cv cn wcel c3 vl cv
     cexp co cc wcel vl cv vf cv cfv cc wcel c3 cc wcel vl cv cn0 wcel c3 vl cv
     cexp co cc wcel vl cv cn wcel c3 vl cv expcl 3cn vl cv nnnn0 sylancr
     adantr vl cv cn wcel c3 vl cv cexp co cc0 wne vl cv vf cv cfv cc wcel vl
     cv cn wcel c3 vl cv cexp co cc0 wne c3 cc0 wceq wn c3 cc0 wne c3 cc0 wceq
     wn 3ne0 c3 cc0 df-ne mpbi vl cv cn wcel c3 cc0 wceq c3 vl cv cexp co cc0
     c3 cc wcel vl cv cn wcel c3 vl cv cexp co cc0 wceq c3 cc0 wceq wb 3cn c3
     vl cv expeq0 mpan necon3abid mpbiri adantr syl3anc ex adantl vl cv vf cv
     cfv cc0 c2 cpr wcel vl cv vf cv cfv cc0 wceq vl cv vf cv cfv c2 wceq wo vl
     cv vf cv cfv cc wcel vl cv vf cv cfv cc0 c2 vl cv vf cv fvex elpr vl cv vf
     cv cfv cc0 wceq vl cv vf cv cfv cc wcel vl cv vf cv cfv c2 wceq vl cv vf
     cv cfv cc0 wceq vl cv vf cv cfv cc wcel cc0 cc wcel 0cn vl cv vf cv cfv
     cc0 cc eleq1 mpbiri vl cv vf cv cfv c2 wceq vl cv vf cv cfv cc wcel c2 cc
     wcel 2cn vl cv vf cv cfv c2 cc eleq1 mpbiri jaoi sylbi syl5com mpcom ex
     sylbi r19.21aiv vl vy cn cc vl cv vf cv cfv c3 vl cv cexp co cdiv co vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv
     co wceq wa vl cv cn wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy vl cv c1 cuz cfv wcel vl cv cn wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq vl cv cn wcel vl cv c1 cuz cfv wcel vl cv
     elnnuz bicomi anbi1i opabbii fopab2 sylib vf cv cc0 c2 cpr cn cm co wcel
     c1 vx cv clt wbr vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv cmul co
     cle wbr wi vx cn vf cv cc0 c2 cpr cn cm co wcel vx cv cn wcel vx cv vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab cfv cmul co cle wbr c1 vx cv clt wbr vf
     cv cc0 c2 cpr cn cm co wcel vx cv cn wcel vx cv vl cv c1 cuz cfv wcel vy
     cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cabs
     cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq
     wa vl vy copab cfv cmul co cle wbr vf cv cc0 c2 cpr cn cm co wcel vx cv cn
     wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co
     vx cv cexp co cmul co vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv
     cmul co cle cn cc0 c2 cpr vf cv wf vx cv cn wcel vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr vf
     cv cc0 c2 cpr cn cm co wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2
     wceq wo cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr cn
     cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2 cpr wcel vx cv
     vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vx cv vf cv
     ffvelrn vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib cn cc0 c2 cpr
     vf cv wf vx cv cn wcel wa vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx
     cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr
     vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf
     vx cv cn wcel wa vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp
     co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr vx
     cv vf cv cfv cr wcel c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp
     co clt wbr wa vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp co
     cdiv co c2 c3 vx cv cexp co cdiv co cle wbr wi cn cc0 c2 cpr vf cv wf vx
     cv cn wcel wa vx cv vf cv cfv cr wcel c2 cr wcel c3 vx cv cexp co cr wcel
     cc0 c3 vx cv cexp co clt wbr wa w3a vx cv vf cv cfv c2 cle wbr vx cv vf cv
     cfv c3 vx cv cexp co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf
     cv cfv c2 c3 vx cv cexp co lediv1 biimpd cn cc0 c2 cpr vf cv wf vx cv cn
     wcel wa vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv
     cfv cr wcel cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2
     cpr wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr
     vx cv vf cv ffvelrn vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv cr wcel vx cv vf cv cfv c2 wceq vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv cr wcel cc0 cr wcel 0re vx cv vf cv
     cfv cc0 cr eleq1 mpbiri vx cv vf cv cfv c2 wceq vx cv vf cv cfv cr wcel c2
     cr wcel 2re vx cv vf cv cfv c2 cr eleq1 mpbiri jaoi syl c2 cr wcel cn cc0
     c2 cpr vf cv wf vx cv cn wcel wa 2re a1i vx cv cn wcel c3 vx cv cexp co cr
     wcel cc0 c3 vx cv cexp co clt wbr wa cn cc0 c2 cpr vf cv wf vx cv cn wcel
     c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt wbr c3 cr wcel vx cv cn0
     wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv reexpcl 3re vx cv
     nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel wa c3 vx cv cexp co
     cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx cv cn0 wcel c3 cn
     wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv cexp co nngt0 3syl
     jca adantl syl3anc cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv
     c3 vx cv cexp co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co cle wbr
     vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv
     cexp co cmul co cle wbr cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf
     cv cfv c3 vx cv cexp co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv
     vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co
     cle wbr cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv
     cexp co cdiv co vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx
     cv cexp co cdiv co cle cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cabs cfv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle
     wbr wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv vx cv vf cv cfv
     c3 vx cv cexp co cdiv co wceq cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle
     wbr wa cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2 cpr
     wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vx
     cv vf cv ffvelrn vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib vx cv
     cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cle wbr wa wi cn cc0 c2 cpr vf cv wf vx cv cn wcel vx cv vf cv cfv
     cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv cfv c3 vx cv cexp co cdiv
     co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wa vx cv
     cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo wa vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cle wbr vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv
     cn wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel vx cv vf cv cfv
     cc0 wceq vx cv cn wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel wi
     vx cv vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq vx cv cn wcel vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel vx cv vf cv cfv cc0 wceq vx cv cn
     wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel cc0 c3 vx cv cexp
     co cdiv co cr wcel vx cv vf cv cfv cc0 wceq vx cv cn wcel wa cc0 cr wcel
     c3 vx cv cexp co cr wcel c3 vx cv cexp co cc0 wne w3a cc0 c3 vx cv cexp co
     cdiv co cr wcel vx cv cn wcel cc0 cr wcel c3 vx cv cexp co cr wcel c3 vx
     cv cexp co cc0 wne w3a vx cv vf cv cfv cc0 wceq c3 cr wcel vx cv cn0 wcel
     cc0 cr wcel c3 vx cv cexp co cr wcel c3 vx cv cexp co cc0 wne w3a vx cv cn
     wcel c3 cr wcel vx cv cn0 wcel wa cc0 cr wcel c3 vx cv cexp co cr wcel c3
     vx cv cexp co cc0 wne cc0 cr wcel c3 cr wcel vx cv cn0 wcel wa 0re a1i c3
     vx cv reexpcl c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp co cc0
     wne c3 cr wcel vx cv cn0 wcel wa c3 vx cv expne0i c3 cr wcel c3 cc wcel vx
     cv cn0 wcel c3 recn adantr c3 cc0 wne c3 cr wcel vx cv cn0 wcel wa 3ne0
     a1i c3 cr wcel vx cv cn0 wcel pm3.27 syl3anc 3jca 3re vx cv nnnn0 sylancr
     adantl cc0 c3 vx cv cexp co redivcl syl vx cv vf cv cfv cc0 wceq vx cv vf
     cv cfv c3 vx cv cexp co cdiv co cr wcel cc0 c3 vx cv cexp co cdiv co cr
     wcel wb vx cv cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cc0 c3 vx cv cexp co cdiv co cr vx cv vf cv cfv cc0 c3 vx
     cv cexp co cdiv opreq1 eleq1d adantr mpbird ex vx cv vf cv cfv c2 wceq vx
     cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel c2 c3 vx cv cexp co cdiv co
     cr wcel vx cv cn wcel vx cv vf cv cfv c2 wceq vx cv vf cv cfv c3 vx cv
     cexp co cdiv co c2 c3 vx cv cexp co cdiv co cr vx cv vf cv cfv c2 c3 vx cv
     cexp co cdiv opreq1 eleq1d c2 cr wcel c3 vx cv cexp co cr wcel c3 vx cv
     cexp co cc0 wne c2 c3 vx cv cexp co cdiv co cr wcel vx cv cn wcel c2 c3 vx
     cv cexp co redivcl c2 cr wcel vx cv cn wcel 2re a1i c3 cr wcel vx cv cn0
     wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv reexpcl 3re vx cv
     nnnn0 sylancr c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp co cc0
     wne vx cv cn wcel c3 vx cv expne0i c3 cc wcel vx cv cn wcel 3cn a1i c3 cc0
     wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc syl3anc syl5bir jaoi impcom
     vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv cn wcel cc0 vx
     cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv cc0 wceq vx
     cv cn wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wi vx cv
     vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq cc0 vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cle wbr cc0 cc0 c3 vx cv cexp co cdiv co cle wbr vx cv cn
     wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c3 vx cv cexp co cdiv co cc0
     c3 vx cv cexp co cdiv co cc0 cle vx cv vf cv cfv cc0 c3 vx cv cexp co cdiv
     opreq1 breq2d vx cv cn wcel cc0 cc0 cle wbr cc0 cc0 c3 vx cv cexp co cdiv
     co cle wbr cc0 0re leidi cc0 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv
     cexp co clt wbr cc0 cc0 cle wbr cc0 cc0 c3 vx cv cexp co cdiv co cle wbr
     wb vx cv cn wcel cc0 c3 vx cv cexp co ge0div cc0 cr wcel vx cv cn wcel 0re
     a1i c3 cr wcel vx cv cn0 wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx
     cv reexpcl 3re vx cv nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel
     wa c3 vx cv cexp co cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx
     cv cn0 wcel c3 cn wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv
     cexp co nngt0 3syl syl3anc mpbii syl5bir vx cv vf cv cfv c2 wceq vx cv cn
     wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv
     c2 wceq vx cv cn wcel wa cc0 c2 c3 vx cv cexp co cdiv co vx cv vf cv cfv
     c3 vx cv cexp co cdiv co cle vx cv cn wcel cc0 c2 c3 vx cv cexp co cdiv co
     cle wbr vx cv vf cv cfv c2 wceq c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3
     vx cv cexp co clt wbr cc0 c2 c3 vx cv cexp co cdiv co cle wbr vx cv cn
     wcel c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt wbr w3a
     cc0 c2 cle wbr cc0 c2 c3 vx cv cexp co cdiv co cle wbr c2 cn wcel cc0 c2
     cle wbr 2nn c2 cn wcel c2 crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl
     ax-mp c2 c3 vx cv cexp co ge0div mpbii c2 cr wcel vx cv cn wcel 2re a1i c3
     cr wcel vx cv cn0 wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv
     reexpcl 3re vx cv nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel wa
     c3 vx cv cexp co cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx cv
     cn0 wcel c3 cn wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv cexp
     co nngt0 3syl syl3anc adantl vx cv vf cv cfv c2 wceq vx cv cn wcel wa vx
     cv vf cv cfv c2 c3 vx cv cexp co cdiv vx cv vf cv cfv c2 wceq vx cv cn
     wcel pm3.26 opreq1d breqtrrd ex jaoi impcom jca ex adantl mpd vx cv vf cv
     cfv c3 vx cv cexp co cdiv co absid syl eqcomd breq1d biimpd cn cc0 c2 cpr
     vf cv wf vx cv cn wcel wa c2 c3 vx cv cexp co cdiv co c2 c1 c3 cdiv co vx
     cv cexp co cmul co vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv cle
     vx cv cn wcel c2 c3 vx cv cexp co cdiv co c2 c1 c3 cdiv co vx cv cexp co
     cmul co wceq cn cc0 c2 cpr vf cv wf vx cv cn wcel c2 c3 vx cv cexp co cdiv
     co c2 c1 c3 vx cv cexp co cdiv co cmul co c2 c1 c3 cdiv co vx cv cexp co
     cmul co c2 cc wcel c3 vx cv cexp co cc wcel c3 vx cv cexp co cc0 wne c2 c3
     vx cv cexp co cdiv co c2 c1 c3 vx cv cexp co cdiv co cmul co wceq vx cv cn
     wcel c2 c3 vx cv cexp co divrec c2 cc wcel vx cv cn wcel 2cn a1i c3 cc
     wcel vx cv cn0 wcel c3 vx cv cexp co cc wcel vx cv cn wcel c3 vx cv expcl
     3cn vx cv nnnn0 sylancr c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp
     co cc0 wne vx cv cn wcel c3 vx cv expne0i c3 cc wcel vx cv cn wcel 3cn a1i
     c3 cc0 wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc syl3anc vx cv cn
     wcel c1 c3 vx cv cexp co cdiv co c1 c3 cdiv co vx cv cexp co c2 cmul vx cv
     cn wcel c1 c3 cdiv co vx cv cexp co c1 c3 vx cv cexp co cdiv co c3 cc wcel
     c3 cc0 wne vx cv cn0 wcel c1 c3 cdiv co vx cv cexp co c1 c3 vx cv cexp co
     cdiv co wceq vx cv cn wcel c3 vx cv exprec c3 cc wcel vx cv cn wcel 3cn
     a1i c3 cc0 wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc eqcomd opreq2d
     eqtrd adantl breq2d sylibd syld vx cv vf cv cfv cc0 wceq vx cv vf cv cfv
     c2 cle wbr vx cv vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq vx cv vf cv
     cfv c2 cle wbr cc0 c2 cle wbr c2 cn wcel cc0 c2 cle wbr 2nn c2 cn wcel c2
     crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl ax-mp vx cv vf cv cfv cc0 c2
     cle breq1 mpbiri vx cv vf cv cfv c2 wceq vx cv vf cv cfv c2 cle wbr c2 c2
     cle wbr c2 2re leidi vx cv vf cv cfv c2 c2 cle breq1 mpbiri jaoi syl5com
     mpcom cc0 c2 cpr cn vf cv cc0 c2 prex nnex elmap sylanb vf cv cc0 c2 cpr
     cn cm co wcel vx cv cn wcel wa vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vx cv vf cv cfv c3
     vx cv cexp co cdiv co cabs vx cv c1 cuz cfv wcel vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cvv wcel vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq vf cv cc0 c2 cpr cn cm co wcel vx cv cn wcel wa vl vy
     vx cv vl cv vf cv cfv c3 vl cv cexp co cdiv co vx cv vf cv cfv c3 vx cv
     cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vx weq vl cv vf cv cfv vx
     cv vf cv cfv c3 vl cv cexp co c3 vx cv cexp co cdiv vl cv vx cv vf cv
     fveq2 vl cv vx cv c3 cexp opreq2 opreq12d vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid fvopab4g vx
     cv cn wcel vx cv c1 cuz cfv wcel vf cv cc0 c2 cpr cn cm co wcel vx cv cn
     wcel vx cv c1 cuz cfv wcel vx cv elnnuz biimpi adantl vx cv vf cv cfv c3
     vx cv cexp co cdiv oprex sylancl fveq2d vf cv cc0 c2 cpr cn cm co wcel vx
     cv cn wcel wa vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv cexp co c2 cmul vx cv cn
     wcel vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa
     vl vy copab cfv c1 c3 cdiv co vx cv cexp co wceq vf cv cc0 c2 cpr cn cm co
     wcel vx cv cn wcel vx cv c1 cuz cfv wcel vx cv vl cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv
     cexp co wceq c1 cuz cfv cn vx cv cn c1 cuz cfv nnuz eqcomi eleq2i vx cv c1
     cuz cfv wcel c1 c3 cdiv co vx cv cexp co cvv wcel vx cv vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv
     co vx cv cexp co wceq c1 c3 cdiv co vx cv cexp oprex vl vy vx cv c1 c3
     cdiv co vl cv cexp co c1 c3 cdiv co vx cv cexp co c1 cuz cfv cvv vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv
     vx cv c1 c3 cdiv co cexp opreq2 vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab eqid fvopab4g mpan2 sylbir adantl
     opreq2d 3brtr4d ex a1dd r19.21aiv jca32 vx va c1 c2 cdiv co c1 c2 vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab c1 c2 cdiv oprex cvgcmp3ce sylan32c vf cv cc0 c2 cpr cn cm co
     wcel c1 caddc cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cseqz co va cv cli wbr caddc vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseq1 co va cv cli wbr va vf cv cc0 c2 cpr cn cm co wcel c1 caddc
     cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cseqz co caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co va cv cli c1
     caddc cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cseqz co caddc vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co wceq vf
     cv cc0 c2 cpr cn cm co wcel caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co c1 caddc cop vl
     cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cseqz co caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab addex vl vy c1 cuz cfv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co c1 cuz fvex opabex2 seq1seqz eqcomi a1i
     breq1d exbidv mpbird sylancr vf cv cc0 c2 cpr cn cm co wcel vk cv vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cr wcel cc0 vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cle wbr wa vk c1 cuz cfv vf
     cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv vl cv c1 cuz
     cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cr wcel cc0 vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cle wbr vf cv cc0 c2 cpr cn
     cm co wcel vk cv c1 cuz cfv wcel wa vk cv vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vf cv
     cfv c3 vk cv cexp co cdiv co cr vk cv c1 cuz cfv wcel vk cv vf cv cfv c3
     vk cv cexp co cdiv co cvv wcel vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vf cv cfv c3
     vk cv cexp co cdiv co wceq vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv
     wcel wa vl vy vk cv vl cv vf cv cfv c3 vl cv cexp co cdiv co vk cv vf cv
     cfv c3 vk cv cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vk weq vl cv
     vf cv cfv vk cv vf cv cfv c3 vl cv cexp co c3 vk cv cexp co cdiv vl cv vk
     cv vf cv fveq2 vl cv vk cv c3 cexp opreq2 opreq12d vl cv c1 cuz cfv wcel
     vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid
     fvopab4g vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel pm3.27 vk cv
     vf cv cfv c3 vk cv cexp co cdiv oprex sylancl vk cv vf cv cfv cr wcel c3
     vk cv cexp co cr wcel c3 vk cv cexp co cc0 wne vk cv vf cv cfv c3 vk cv
     cexp co cdiv co cr wcel vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv
     wcel wa vk cv vf cv cfv c3 vk cv cexp co redivcl vf cv cc0 c2 cpr cn cm co
     wcel vk cv c1 cuz cfv wcel wa vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2
     wceq wo vk cv c1 cuz cfv wcel wa vk cv vf cv cfv cr wcel vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv
     cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vf cv cc0 c2 cpr cn cm co wcel cn
     cc0 c2 cpr vf cv wf vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv
     vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa wi cc0 c2 cpr cn vf cv cc0
     c2 prex nnex elmap vk cv c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv vf
     cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vk cv
     c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0 wceq vk cv vf
     cv cfv c2 wceq wo vk cv c1 cuz cfv wcel vk cv cn wcel cn cc0 c2 cpr vf cv
     wf vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo wi c1 cuz cfv cn vk
     cv cn c1 cuz cfv nnuz eqcomi eleq2i cn cc0 c2 cpr vf cv wf vk cv cn wcel
     vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf
     vk cv cn wcel wa vk cv vf cv cfv cc0 c2 cpr wcel vk cv vf cv cfv cc0 wceq
     vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vk cv vf cv ffvelrn vk cv vf cv
     cfv cc0 c2 vk cv vf cv fvex elpr sylib expcom sylbi anc2ri com12 sylbi imp
     vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv vf cv cfv cr
     wcel vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr
     wcel vk cv vf cv cfv c2 wceq vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr
     wcel cc0 cr wcel 0re vk cv vf cv cfv cc0 cr eleq1 mpbiri vk cv vf cv cfv
     c2 wceq vk cv vf cv cfv cr wcel c2 cr wcel 2re vk cv vf cv cfv c2 cr eleq1
     mpbiri jaoi adantr syl vk cv c1 cuz cfv wcel c3 vk cv cexp co cr wcel vf
     cv cc0 c2 cpr cn cm co wcel c3 cr wcel vk cv cn0 wcel c3 vk cv cexp co cr
     wcel vk cv c1 cuz cfv wcel c3 vk cv reexpcl 3re vk cv c1 cuz cfv wcel vk
     cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir sylancr adantl
     vk cv c1 cuz cfv wcel c3 vk cv cexp co cc0 wne vf cv cc0 c2 cpr cn cm co
     wcel c3 cc wcel c3 cc0 wne vk cv cn0 wcel c3 vk cv cexp co cc0 wne vk cv
     c1 cuz cfv wcel c3 vk cv expne0i c3 cc wcel vk cv c1 cuz cfv wcel 3cn a1i
     c3 cc0 wne vk cv c1 cuz cfv wcel 3ne0 a1i vk cv c1 cuz cfv wcel vk cv cn
     wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir syl3anc adantl syl3anc
     eqeltrd vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa cc0 vk cv
     vf cv cfv c3 vk cv cexp co cdiv co vk cv vl cv c1 cuz cfv wcel vy cv vl cv
     vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cle cn cc0 c2
     cpr vf cv wf vk cv c1 cuz cfv wcel cc0 vk cv vf cv cfv c3 vk cv cexp co
     cdiv co cle wbr vf cv cc0 c2 cpr cn cm co wcel cn cc0 c2 cpr vf cv wf vk
     cv c1 cuz cfv wcel wa cc0 vk cv vf cv cfv c3 vk cv cexp co cdiv co cle wbr
     cn cc0 c2 cpr vf cv wf vk cv c1 cuz cfv wcel wa cn cc0 c2 cpr vf cv wf vk
     cv cn wcel wa vk cv vf cv cfv cc0 c2 cpr wcel cn cc0 c2 cpr vf cv wf vk cv
     c1 cuz cfv wcel wa cc0 vk cv vf cv cfv c3 vk cv cexp co cdiv co cle wbr wi
     vk cv c1 cuz cfv wcel vk cv cn wcel cn cc0 c2 cpr vf cv wf vk cv c1 cuz
     cfv wcel vk cv cn wcel c1 cuz cfv cn vk cv cn c1 cuz cfv nnuz eqcomi
     eleq2i biimpi anim2i cn cc0 c2 cpr vk cv vf cv ffvelrn vk cv vf cv cfv cc0
     c2 cpr wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo cn cc0 c2
     cpr vf cv wf vk cv c1 cuz cfv wcel wa cc0 vk cv vf cv cfv c3 vk cv cexp co
     cdiv co cle wbr wi vk cv vf cv cfv cc0 c2 vk cv vf cv fvex elpr vk cv vf
     cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel cc0 vk cv
     vf cv cfv c3 vk cv cexp co cdiv co cle wbr cn cc0 c2 cpr vf cv wf vk cv vf
     cv cfv cc0 wceq vk cv c1 cuz cfv wcel cc0 vk cv vf cv cfv c3 vk cv cexp co
     cdiv co cle wbr wi vk cv vf cv cfv c2 wceq vk cv vf cv cfv cc0 wceq vk cv
     c1 cuz cfv wcel vk cv vf cv cfv cr wcel cc0 vk cv vf cv cfv cle wbr wa c3
     vk cv cexp co cr wcel cc0 c3 vk cv cexp co clt wbr wa wa cc0 vk cv vf cv
     cfv c3 vk cv cexp co cdiv co cle wbr vk cv vf cv cfv cc0 wceq vk cv c1 cuz
     cfv wcel vk cv vf cv cfv cr wcel cc0 vk cv vf cv cfv cle wbr wa c3 vk cv
     cexp co cr wcel cc0 c3 vk cv cexp co clt wbr wa wa vk cv vf cv cfv cc0
     wceq vk cv vf cv cfv cr wcel cc0 vk cv vf cv cfv cle wbr wa vk cv c1 cuz
     cfv wcel c3 vk cv cexp co cr wcel cc0 c3 vk cv cexp co clt wbr wa vk cv vf
     cv cfv cc0 wceq vk cv vf cv cfv cr wcel cc0 vk cv vf cv cfv cle wbr wa cc0
     cr wcel cc0 cc0 cle wbr wa cc0 cr wcel cc0 cc0 cle wbr 0re cc0 0re leidi
     pm3.2i vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr wcel cc0 cr wcel cc0 vk
     cv vf cv cfv cle wbr cc0 cc0 cle wbr vk cv vf cv cfv cc0 cr eleq1 vk cv vf
     cv cfv cc0 cc0 cle breq2 anbi12d mpbiri vk cv c1 cuz cfv wcel c3 vk cv
     cexp co cr wcel cc0 c3 vk cv cexp co clt wbr c3 cr wcel vk cv cn0 wcel c3
     vk cv cexp co cr wcel vk cv c1 cuz cfv wcel c3 vk cv reexpcl 3re vk cv c1
     cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir
     sylancr c3 cr wcel vk cv cn0 wcel cc0 c3 clt wbr cc0 c3 vk cv cexp co clt
     wbr vk cv c1 cuz cfv wcel c3 vk cv expgt0 c3 cr wcel vk cv c1 cuz cfv wcel
     3re a1i vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk
     cv nnnn0 sylbir cc0 c3 clt wbr vk cv c1 cuz cfv wcel 3pos a1i syl3anc jca
     anim12i ex vk cv vf cv cfv c3 vk cv cexp co divge0 syl6 vk cv vf cv cfv c2
     wceq vk cv c1 cuz cfv wcel vk cv vf cv cfv cr wcel cc0 vk cv vf cv cfv cle
     wbr wa c3 vk cv cexp co cr wcel cc0 c3 vk cv cexp co clt wbr wa wa cc0 vk
     cv vf cv cfv c3 vk cv cexp co cdiv co cle wbr vk cv vf cv cfv c2 wceq vk
     cv c1 cuz cfv wcel vk cv vf cv cfv cr wcel cc0 vk cv vf cv cfv cle wbr wa
     c3 vk cv cexp co cr wcel cc0 c3 vk cv cexp co clt wbr wa wa vk cv vf cv
     cfv c2 wceq vk cv c1 cuz cfv wcel wa vk cv vf cv cfv cr wcel cc0 vk cv vf
     cv cfv cle wbr c3 vk cv cexp co cr wcel cc0 c3 vk cv cexp co clt wbr wa vk
     cv vf cv cfv c2 wceq vk cv vf cv cfv cr wcel vk cv c1 cuz cfv wcel vk cv
     vf cv cfv c2 wceq vk cv vf cv cfv cr wcel c2 cr wcel 2re vk cv vf cv cfv
     c2 cr eleq1 mpbiri adantr vk cv vf cv cfv c2 wceq cc0 vk cv vf cv cfv cle
     wbr vk cv c1 cuz cfv wcel vk cv vf cv cfv c2 wceq cc0 vk cv vf cv cfv cle
     wbr cc0 c2 cle wbr c2 cn wcel cc0 c2 cle wbr 2nn c2 cn wcel c2 crp wcel
     cc0 c2 cle wbr c2 nnrp c2 rpge0 syl ax-mp vk cv vf cv cfv c2 cc0 cle breq2
     mpbiri adantr vk cv c1 cuz cfv wcel c3 vk cv cexp co cr wcel cc0 c3 vk cv
     cexp co clt wbr wa vk cv vf cv cfv c2 wceq vk cv c1 cuz cfv wcel c3 vk cv
     cexp co cr wcel cc0 c3 vk cv cexp co clt wbr c3 cr wcel vk cv cn0 wcel c3
     vk cv cexp co cr wcel vk cv c1 cuz cfv wcel c3 vk cv reexpcl 3re vk cv c1
     cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir
     sylancr c3 cr wcel vk cv cn0 wcel cc0 c3 clt wbr cc0 c3 vk cv cexp co clt
     wbr vk cv c1 cuz cfv wcel c3 vk cv expgt0 c3 cr wcel vk cv c1 cuz cfv wcel
     3re a1i vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk
     cv nnnn0 sylbir cc0 c3 clt wbr vk cv c1 cuz cfv wcel 3pos a1i syl3anc jca
     adantl jca31 ex vk cv vf cv cfv c3 vk cv cexp co divge0 syl6 jaoi adantld
     sylbi 3syl pm2.43i cc0 c2 cpr cn vf cv cc0 c2 prex nnex elmap sylanb vk cv
     c1 cuz cfv wcel vk cv vf cv cfv c3 vk cv cexp co cdiv co cvv wcel vk cv vl
     cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co wceq vf cv cc0 c2
     cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vl vy vk cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co vk cv vf cv cfv c3 vk cv cexp co cdiv co c1 cuz cfv
     cvv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab vl vk weq vl cv vf cv cfv vk cv vf cv cfv c3 vl cv
     cexp co c3 vk cv cexp co cdiv vl cv vk cv vf cv fveq2 vl cv vk cv c3 cexp
     opreq2 opreq12d vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp
     co cdiv co wceq wa vl vy copab eqid fvopab4g vf cv cc0 c2 cpr cn cm co
     wcel vk cv c1 cuz cfv wcel pm3.27 vk cv vf cv cfv c3 vk cv cexp co cdiv
     oprex sylancl breqtrrd jca r19.21aiva syl3anc vf cv cc0 c2 cpr cn cm co
     wcel cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cn c2 c3 vk cv
     cexp co cdiv co vk csu c1 cle vf cv cc0 c2 cpr cn cm co wcel c1 cuz cfv vk
     cv vf cv cfv c3 vk cv cexp co cdiv co vk csu c1 cuz cfv c2 c3 vk cv cexp
     co cdiv co vk csu cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cn c2
     c3 vk cv cexp co cdiv co vk csu cle c1 caddc cop vl cv c1 cuz cfv wcel vy
     cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co
     c1 cuz cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu cli wbr c1
     caddc cop vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cseqz co c1 cuz cfv c2 c3 vk cv cexp co cdiv co vk csu cli wbr
     c1 cz wcel vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp
     co cdiv co wceq wa vl vy copab cfv cr wcel vk cv vl cv c1 cuz cfv wcel vy
     cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cr wcel vk cv vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab cfv vk cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv cle wbr w3a vk c1 cuz cfv wral wa c1 cuz cfv vk cv
     vf cv cfv c3 vk cv cexp co cdiv co vk csu c1 cuz cfv c2 c3 vk cv cexp co
     cdiv co vk csu cle wbr vf cv cc0 c2 cpr cn cm co wcel c1 cz wcel c1 caddc
     cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cseqz co va cv cli wbr va wex c1 caddc cop vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseqz co c1 cuz cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu
     cli wbr vf cv cc0 c2 cpr cn cm co wcel va vy vk cv vf cv cfv c3 vk cv cexp
     co cdiv co vk vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab c1 vk cv vf cv cfv c3 vk cv cexp co cdiv oprex
     vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq
     wa vk cv c1 cuz cfv wcel vy cv vk cv vf cv cfv c3 vk cv cexp co cdiv co
     wceq wa vl vy vk vl vk weq vl cv c1 cuz cfv wcel vk cv c1 cuz cfv wcel vy
     cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq vy cv vk cv vf cv cfv c3
     vk cv cexp co cdiv co wceq vl cv vk cv c1 cuz cfv eleq1 vl vk weq vl cv vf
     cv cfv c3 vl cv cexp co cdiv co vk cv vf cv cfv c3 vk cv cexp co cdiv co
     vy cv vl vk weq vl cv vf cv cfv vk cv vf cv cfv c3 vl cv cexp co c3 vk cv
     cexp co cdiv vl cv vk cv vf cv fveq2 vl cv vk cv c3 cexp opreq2 opreq12d
     eqeq2d anbi12d cbvopab1v isumclim3 1z vf cv cc0 c2 cpr cn cm co wcel c1
     caddc cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cseqz co va cv cli wbr va wex caddc vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseq1 co va cv cli wbr va wex c1 cn wcel cn cr vl cv c1 cuz cfv wcel
     vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf cc0 vx cv vl cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv
     cle wbr vx cn wral wa caddc vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl
     cv cexp co wceq wa vl vy copab cseq1 co c1 c2 cdiv co cli wbr wa c2 cr
     wcel cc0 c2 cle wbr wa cn cc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab wf c1 vx cv clt wbr vx cv vl
     cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv
     co vl cv cexp co wceq wa vl vy copab cfv cmul co cle wbr wi vx cn wral wa
     wa caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv
     co wceq wa vl vy copab cseq1 co va cv cli wbr va wex vf cv cc0 c2 cpr cn
     cm co wcel c1 cn wcel vf cv cc0 c2 cpr cn cm co wcel 1nn a1i cn cr vl cv
     c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf
     cc0 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa
     vl vy copab cfv cle wbr vx cn wral wa caddc vl cv c1 cuz cfv wcel vy cv c1
     c3 cdiv co vl cv cexp co wceq wa vl vy copab cseq1 co c1 c2 cdiv co cli
     wbr wa vf cv cc0 c2 cpr cn cm co wcel cn cr vl cv c1 cuz cfv wcel vy cv c1
     c3 cdiv co vl cv cexp co wceq wa vl vy copab wf cc0 vx cv vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv cle wbr vx
     cn wral wa caddc vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab cseq1 co c1 c2 cdiv co cli wbr cn cr vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf cc0 vx cv vl
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     cfv cle wbr vx cn wral cn cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl
     cv cexp co wceq wa vl vy copab wf c1 cuz cfv cr vl cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf c1 c3 cdiv co vl cv
     cexp co cr wcel vl c1 cuz cfv wral c1 cuz cfv cr vl cv c1 cuz cfv wcel vy
     cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab wf c1 c3 cdiv co vl cv
     cexp co cr wcel vl c1 cuz cfv c1 c3 cdiv co cr wcel vl cv cn0 wcel c1 c3
     cdiv co vl cv cexp co cr wcel vl cv c1 cuz cfv wcel c1 c3 cdiv co vl cv
     reexpcl c3 3re 3ne0 rereccli vl cv c1 cuz cfv wcel vl cv cn wcel vl cv cn0
     wcel vl cv elnnuz vl cv nnnn0 sylbir sylancr rgen vl vy c1 cuz cfv cr c1
     c3 cdiv co vl cv cexp co vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl
     cv cexp co wceq wa vl vy copab eqid fopab2 mpbi cn c1 cuz cfv wceq cn cr
     vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy
     copab wf c1 cuz cfv cr vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab wf wb nnuz cn c1 cuz cfv cr vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab feq2 ax-mp
     mpbir cc0 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab cfv cle wbr vx cn vx cv cn wcel cc0 c1 c3 cdiv co vx
     cv cexp co vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy copab cfv cle c1 c3 cdiv co cr wcel vx cv cn0 wcel cc0 c1 c3
     cdiv co cle wbr cc0 c1 c3 cdiv co vx cv cexp co cle wbr vx cv cn wcel c1
     c3 cdiv co vx cv expge0 c1 c3 cdiv co cr wcel vx cv cn wcel c3 3re 3ne0
     rereccli a1i vx cv nnnn0 cc0 c1 c3 cdiv co cle wbr vx cv cn wcel c1 cr
     wcel cc0 c1 cle wbr wa c3 cr wcel cc0 c3 clt wbr wa cc0 c1 c3 cdiv co cle
     wbr c1 cr wcel cc0 c1 cle wbr 1re cc0 c1 0re 1re lt01 ltleii pm3.2i c3 cr
     wcel cc0 c3 clt wbr 3re 3pos pm3.2i c1 c3 divge0 mp2an a1i syl3anc vx cv
     cn wcel vx cv c1 cuz cfv wcel vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv
     co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv cexp co wceq
     c1 cuz cfv cn vx cv cn c1 cuz cfv nnuz eqcomi eleq2i vx cv c1 cuz cfv wcel
     c1 c3 cdiv co vx cv cexp co cvv wcel vx cv vl cv c1 cuz cfv wcel vy cv c1
     c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv cexp
     co wceq c1 c3 cdiv co vx cv cexp oprex vl vy vx cv c1 c3 cdiv co vl cv
     cexp co c1 c3 cdiv co vx cv cexp co c1 cuz cfv cvv vl cv c1 cuz cfv wcel
     vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv vx cv c1 c3
     cdiv co cexp opreq2 vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab eqid fvopab4g mpan2 sylbir breqtrrd rgen pm3.2i
     caddc vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     cseq1 co c1 c3 cdiv co c1 c1 c3 cdiv co cmin co cdiv co caddc vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cseq1 co c1
     c2 cdiv co cli vy c1 c3 cdiv co vl vl cv cn wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab eqid c3 3cn 3ne0 reccli c1 c3 cdiv co cabs cfv c1
     clt wbr c1 cneg c1 c3 cdiv co clt wbr c1 c3 cdiv co c1 clt wbr c1 c3 cdiv
     co c1 c3 3re 3ne0 rereccli 1re abslti c1 cneg cr wcel cc0 cr wcel c1 c3
     cdiv co cr wcel w3a c1 cneg cc0 clt wbr cc0 c1 c3 cdiv co clt wbr wa c1
     cneg c1 c3 cdiv co clt wbr c1 cneg cr wcel cc0 cr wcel c1 c3 cdiv co cr
     wcel c1 1re renegcli 0re c3 3re 3ne0 rereccli 3pm3.2i c1 cneg cc0 clt wbr
     cc0 c1 c3 cdiv co clt wbr c1 cneg cc0 clt wbr cc0 c1 clt wbr lt01 c1 cr
     wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr wb 1re c1 cr wcel cc0 c1 clt wbr
     c1 cneg cc0 clt wbr c1 lt0neg2 bicomd ax-mp mpbir c3 3re 3pos recgt0ii
     pm3.2i c1 cneg cc0 c1 c3 cdiv co axlttrn mp2 c1 c3 cdiv co c1 clt wbr c1
     c3 clt wbr 1lt3 c3 cr wcel cc0 c3 clt wbr c1 c3 cdiv co c1 clt wbr c1 c3
     clt wbr wb 3re 3pos c3 cr wcel cc0 c3 clt wbr wa c1 c3 clt wbr c1 c3 cdiv
     co c1 clt wbr c3 recgt1 bicomd mp2an mpbir mpbir2an geolim1i vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv cn
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab caddc cseq1 vl
     cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl cv cn wcel
     vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy vl cv c1 cuz cfv wcel vl
     cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq vl cv cn wcel vl cv c1
     cuz cfv wcel vl cv elnnuz bicomi anbi1i opabbii opreq2i c1 c2 cdiv co c1
     c3 cdiv co c2 c3 cdiv co cdiv co c1 c3 cdiv co c1 c1 c3 cdiv co cmin co
     cdiv co c1 c3 cdiv co c2 c3 cdiv co cdiv co c1 c3 cmul co c3 c2 cmul co
     cdiv co c3 c1 cmul co c3 c2 cmul co cdiv co c1 c2 cdiv co c1 c3 c2 c3
     ax1cn 3cn 2cn 3cn 3ne0 3ne0 2ne0 divdivdivi c1 c3 cmul co c3 c1 cmul co c3
     c2 cmul co cdiv c1 c3 ax1cn 3cn mulcomi opreq1i c1 cc wcel c2 cc wcel c2
     cc0 wne wa c3 cc wcel c3 cc0 wne wa c3 c1 cmul co c3 c2 cmul co cdiv co c1
     c2 cdiv co wceq ax1cn c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i c3 cc wcel c3
     cc0 wne 3cn 3ne0 pm3.2i c1 c2 c3 divcan5 mp3an 3eqtrri c2 c3 cdiv co c1 c1
     c3 cdiv co cmin co c1 c3 cdiv co cdiv c2 c3 cdiv co c3 c1 cmin co c3 cdiv
     co c3 c3 cdiv co c1 c3 cdiv co cmin co c1 c1 c3 cdiv co cmin co c2 c3 c1
     cmin co c3 cdiv 2eq3m1 opreq1i c3 cc wcel c1 cc wcel c3 cc wcel c3 cc0 wne
     wa c3 c1 cmin co c3 cdiv co c3 c3 cdiv co c1 c3 cdiv co cmin co wceq 3cn
     ax1cn c3 cc wcel c3 cc0 wne 3cn 3ne0 pm3.2i c3 c1 c3 divsubdir mp3an c3 c3
     cdiv co c1 c1 c3 cdiv co cmin c3 3cn 3ne0 dividi opreq1i 3eqtri opreq2i
     eqtri 3brtr4i pm3.2i a1i vf cv cc0 c2 cpr cn cm co wcel c2 cr wcel cc0 c2
     cle wbr wa cn cc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp
     co cdiv co wceq wa vl vy copab wf c1 vx cv clt wbr vx cv vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv cmul co cle wbr wi vx cn wral c2 cr wcel cc0 c2
     cle wbr wa vf cv cc0 c2 cpr cn cm co wcel c2 cr wcel cc0 c2 cle wbr 2re c2
     cn wcel cc0 c2 cle wbr 2nn c2 cn wcel c2 crp wcel cc0 c2 cle wbr c2 nnrp
     c2 rpge0 syl ax-mp pm3.2i a1i vf cv cc0 c2 cpr cn cm co wcel vl cv vf cv
     cfv c3 vl cv cexp co cdiv co cc wcel vl cn wral cn cc vl cv c1 cuz cfv
     wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab wf
     vf cv cc0 c2 cpr cn cm co wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc
     wcel vl cn vf cv cc0 c2 cpr cn cm co wcel cn cc0 c2 cpr vf cv wf vl cv cn
     wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel wi cc0 c2 cpr cn vf
     cv cc0 c2 prex nnex elmap cn cc0 c2 cpr vf cv wf vl cv cn wcel vl cv vf cv
     cfv c3 vl cv cexp co cdiv co cc wcel vl cv vf cv cfv cc0 c2 cpr wcel cn
     cc0 c2 cpr vf cv wf vl cv cn wcel wa vl cv vf cv cfv c3 vl cv cexp co cdiv
     co cc wcel cn cc0 c2 cpr vl cv vf cv ffvelrn cn cc0 c2 cpr vf cv wf vl cv
     cn wcel wa vl cv vf cv cfv cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv
     co cc wcel vl cv vf cv cfv cc0 c2 cpr wcel vl cv cn wcel vl cv vf cv cfv
     cc wcel vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel wi cn cc0 c2 cpr
     vf cv wf vl cv cn wcel vl cv vf cv cfv cc wcel vl cv vf cv cfv c3 vl cv
     cexp co cdiv co cc wcel vl cv vf cv cfv cc wcel c3 vl cv cexp co cc wcel
     c3 vl cv cexp co cc0 wne vl cv vf cv cfv c3 vl cv cexp co cdiv co cc wcel
     vl cv cn wcel vl cv vf cv cfv cc wcel wa vl cv vf cv cfv c3 vl cv cexp co
     divcl vl cv cn wcel vl cv vf cv cfv cc wcel pm3.27 vl cv cn wcel c3 vl cv
     cexp co cc wcel vl cv vf cv cfv cc wcel c3 cc wcel vl cv cn0 wcel c3 vl cv
     cexp co cc wcel vl cv cn wcel c3 vl cv expcl 3cn vl cv nnnn0 sylancr
     adantr vl cv cn wcel c3 vl cv cexp co cc0 wne vl cv vf cv cfv cc wcel vl
     cv cn wcel c3 vl cv cexp co cc0 wne c3 cc0 wceq wn c3 cc0 wne c3 cc0 wceq
     wn 3ne0 c3 cc0 df-ne mpbi vl cv cn wcel c3 cc0 wceq c3 vl cv cexp co cc0
     c3 cc wcel vl cv cn wcel c3 vl cv cexp co cc0 wceq c3 cc0 wceq wb 3cn c3
     vl cv expeq0 mpan necon3abid mpbiri adantr syl3anc ex adantl vl cv vf cv
     cfv cc0 c2 cpr wcel vl cv vf cv cfv cc0 wceq vl cv vf cv cfv c2 wceq wo vl
     cv vf cv cfv cc wcel vl cv vf cv cfv cc0 c2 vl cv vf cv fvex elpr vl cv vf
     cv cfv cc0 wceq vl cv vf cv cfv cc wcel vl cv vf cv cfv c2 wceq vl cv vf
     cv cfv cc0 wceq vl cv vf cv cfv cc wcel cc0 cc wcel 0cn vl cv vf cv cfv
     cc0 cc eleq1 mpbiri vl cv vf cv cfv c2 wceq vl cv vf cv cfv cc wcel c2 cc
     wcel 2cn vl cv vf cv cfv c2 cc eleq1 mpbiri jaoi sylbi syl5com mpcom ex
     sylbi r19.21aiv vl vy cn cc vl cv vf cv cfv c3 vl cv cexp co cdiv co vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv
     co wceq wa vl cv cn wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy vl cv c1 cuz cfv wcel vl cv cn wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq vl cv cn wcel vl cv c1 cuz cfv wcel vl cv
     elnnuz bicomi anbi1i opabbii fopab2 sylib vf cv cc0 c2 cpr cn cm co wcel
     c1 vx cv clt wbr vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz
     cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv cmul co
     cle wbr wi vx cn vf cv cc0 c2 cpr cn cm co wcel vx cv cn wcel vx cv vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab cfv cabs cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab cfv cmul co cle wbr c1 vx cv clt wbr vf
     cv cc0 c2 cpr cn cm co wcel vx cv cn wcel vx cv vl cv c1 cuz cfv wcel vy
     cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cabs
     cfv c2 vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq
     wa vl vy copab cfv cmul co cle wbr vf cv cc0 c2 cpr cn cm co wcel vx cv cn
     wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co
     vx cv cexp co cmul co vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cabs cfv c2 vx cv vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv
     cmul co cle cn cc0 c2 cpr vf cv wf vx cv cn wcel vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr vf
     cv cc0 c2 cpr cn cm co wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2
     wceq wo cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr cn
     cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2 cpr wcel vx cv
     vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vx cv vf cv
     ffvelrn vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib cn cc0 c2 cpr
     vf cv wf vx cv cn wcel wa vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx
     cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr
     vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf
     vx cv cn wcel wa vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp
     co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv cexp co cmul co cle wbr vx
     cv vf cv cfv cr wcel c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp
     co clt wbr wa vx cv vf cv cfv c2 cle wbr vx cv vf cv cfv c3 vx cv cexp co
     cdiv co c2 c3 vx cv cexp co cdiv co cle wbr wi cn cc0 c2 cpr vf cv wf vx
     cv cn wcel wa vx cv vf cv cfv cr wcel c2 cr wcel c3 vx cv cexp co cr wcel
     cc0 c3 vx cv cexp co clt wbr wa w3a vx cv vf cv cfv c2 cle wbr vx cv vf cv
     cfv c3 vx cv cexp co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf
     cv cfv c2 c3 vx cv cexp co lediv1 biimpd cn cc0 c2 cpr vf cv wf vx cv cn
     wcel wa vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv
     cfv cr wcel cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2
     cpr wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr
     vx cv vf cv ffvelrn vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv cr wcel vx cv vf cv cfv c2 wceq vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv cr wcel cc0 cr wcel 0re vx cv vf cv
     cfv cc0 cr eleq1 mpbiri vx cv vf cv cfv c2 wceq vx cv vf cv cfv cr wcel c2
     cr wcel 2re vx cv vf cv cfv c2 cr eleq1 mpbiri jaoi syl c2 cr wcel cn cc0
     c2 cpr vf cv wf vx cv cn wcel wa 2re a1i vx cv cn wcel c3 vx cv cexp co cr
     wcel cc0 c3 vx cv cexp co clt wbr wa cn cc0 c2 cpr vf cv wf vx cv cn wcel
     c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt wbr c3 cr wcel vx cv cn0
     wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv reexpcl 3re vx cv
     nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel wa c3 vx cv cexp co
     cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx cv cn0 wcel c3 cn
     wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv cexp co nngt0 3syl
     jca adantl syl3anc cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv
     c3 vx cv cexp co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co cle wbr
     vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c1 c3 cdiv co vx cv
     cexp co cmul co cle wbr cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf
     cv cfv c3 vx cv cexp co cdiv co c2 c3 vx cv cexp co cdiv co cle wbr vx cv
     vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx cv cexp co cdiv co
     cle wbr cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv
     cexp co cdiv co vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv c2 c3 vx
     cv cexp co cdiv co cle cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cabs cfv vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle
     wbr wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv vx cv vf cv cfv
     c3 vx cv cexp co cdiv co wceq cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx
     cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle
     wbr wa cn cc0 c2 cpr vf cv wf vx cv cn wcel wa vx cv vf cv cfv cc0 c2 cpr
     wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vx
     cv vf cv ffvelrn vx cv vf cv cfv cc0 c2 vx cv vf cv fvex elpr sylib vx cv
     cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cle wbr wa wi cn cc0 c2 cpr vf cv wf vx cv cn wcel vx cv vf cv cfv
     cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv vf cv cfv c3 vx cv cexp co cdiv
     co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wa vx cv
     cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo wa vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel cc0 vx cv vf cv cfv c3 vx cv cexp co
     cdiv co cle wbr vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv
     cn wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel vx cv vf cv cfv
     cc0 wceq vx cv cn wcel vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel wi
     vx cv vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq vx cv cn wcel vx cv vf cv
     cfv c3 vx cv cexp co cdiv co cr wcel vx cv vf cv cfv cc0 wceq vx cv cn
     wcel wa vx cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel cc0 c3 vx cv cexp
     co cdiv co cr wcel vx cv vf cv cfv cc0 wceq vx cv cn wcel wa cc0 cr wcel
     c3 vx cv cexp co cr wcel c3 vx cv cexp co cc0 wne w3a cc0 c3 vx cv cexp co
     cdiv co cr wcel vx cv cn wcel cc0 cr wcel c3 vx cv cexp co cr wcel c3 vx
     cv cexp co cc0 wne w3a vx cv vf cv cfv cc0 wceq c3 cr wcel vx cv cn0 wcel
     cc0 cr wcel c3 vx cv cexp co cr wcel c3 vx cv cexp co cc0 wne w3a vx cv cn
     wcel c3 cr wcel vx cv cn0 wcel wa cc0 cr wcel c3 vx cv cexp co cr wcel c3
     vx cv cexp co cc0 wne cc0 cr wcel c3 cr wcel vx cv cn0 wcel wa 0re a1i c3
     vx cv reexpcl c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp co cc0
     wne c3 cr wcel vx cv cn0 wcel wa c3 vx cv expne0i c3 cr wcel c3 cc wcel vx
     cv cn0 wcel c3 recn adantr c3 cc0 wne c3 cr wcel vx cv cn0 wcel wa 3ne0
     a1i c3 cr wcel vx cv cn0 wcel pm3.27 syl3anc 3jca 3re vx cv nnnn0 sylancr
     adantl cc0 c3 vx cv cexp co redivcl syl vx cv vf cv cfv cc0 wceq vx cv vf
     cv cfv c3 vx cv cexp co cdiv co cr wcel cc0 c3 vx cv cexp co cdiv co cr
     wcel wb vx cv cn wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cc0 c3 vx cv cexp co cdiv co cr vx cv vf cv cfv cc0 c3 vx
     cv cexp co cdiv opreq1 eleq1d adantr mpbird ex vx cv vf cv cfv c2 wceq vx
     cv vf cv cfv c3 vx cv cexp co cdiv co cr wcel c2 c3 vx cv cexp co cdiv co
     cr wcel vx cv cn wcel vx cv vf cv cfv c2 wceq vx cv vf cv cfv c3 vx cv
     cexp co cdiv co c2 c3 vx cv cexp co cdiv co cr vx cv vf cv cfv c2 c3 vx cv
     cexp co cdiv opreq1 eleq1d c2 cr wcel c3 vx cv cexp co cr wcel c3 vx cv
     cexp co cc0 wne c2 c3 vx cv cexp co cdiv co cr wcel vx cv cn wcel c2 c3 vx
     cv cexp co redivcl c2 cr wcel vx cv cn wcel 2re a1i c3 cr wcel vx cv cn0
     wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv reexpcl 3re vx cv
     nnnn0 sylancr c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp co cc0
     wne vx cv cn wcel c3 vx cv expne0i c3 cc wcel vx cv cn wcel 3cn a1i c3 cc0
     wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc syl3anc syl5bir jaoi impcom
     vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c2 wceq wo vx cv cn wcel cc0 vx
     cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv cc0 wceq vx
     cv cn wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr wi vx cv
     vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq cc0 vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cle wbr cc0 cc0 c3 vx cv cexp co cdiv co cle wbr vx cv cn
     wcel vx cv vf cv cfv cc0 wceq vx cv vf cv cfv c3 vx cv cexp co cdiv co cc0
     c3 vx cv cexp co cdiv co cc0 cle vx cv vf cv cfv cc0 c3 vx cv cexp co cdiv
     opreq1 breq2d vx cv cn wcel cc0 cc0 cle wbr cc0 cc0 c3 vx cv cexp co cdiv
     co cle wbr cc0 0re leidi cc0 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv
     cexp co clt wbr cc0 cc0 cle wbr cc0 cc0 c3 vx cv cexp co cdiv co cle wbr
     wb vx cv cn wcel cc0 c3 vx cv cexp co ge0div cc0 cr wcel vx cv cn wcel 0re
     a1i c3 cr wcel vx cv cn0 wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx
     cv reexpcl 3re vx cv nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel
     wa c3 vx cv cexp co cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx
     cv cn0 wcel c3 cn wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv
     cexp co nngt0 3syl syl3anc mpbii syl5bir vx cv vf cv cfv c2 wceq vx cv cn
     wcel cc0 vx cv vf cv cfv c3 vx cv cexp co cdiv co cle wbr vx cv vf cv cfv
     c2 wceq vx cv cn wcel wa cc0 c2 c3 vx cv cexp co cdiv co vx cv vf cv cfv
     c3 vx cv cexp co cdiv co cle vx cv cn wcel cc0 c2 c3 vx cv cexp co cdiv co
     cle wbr vx cv vf cv cfv c2 wceq c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3
     vx cv cexp co clt wbr cc0 c2 c3 vx cv cexp co cdiv co cle wbr vx cv cn
     wcel c2 cr wcel c3 vx cv cexp co cr wcel cc0 c3 vx cv cexp co clt wbr w3a
     cc0 c2 cle wbr cc0 c2 c3 vx cv cexp co cdiv co cle wbr c2 cn wcel cc0 c2
     cle wbr 2nn c2 cn wcel c2 crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl
     ax-mp c2 c3 vx cv cexp co ge0div mpbii c2 cr wcel vx cv cn wcel 2re a1i c3
     cr wcel vx cv cn0 wcel c3 vx cv cexp co cr wcel vx cv cn wcel c3 vx cv
     reexpcl 3re vx cv nnnn0 sylancr vx cv cn wcel c3 cn wcel vx cv cn0 wcel wa
     c3 vx cv cexp co cn wcel cc0 c3 vx cv cexp co clt wbr vx cv cn wcel vx cv
     cn0 wcel c3 cn wcel vx cv nnnn0 3nn jctil c3 vx cv nnexpcl c3 vx cv cexp
     co nngt0 3syl syl3anc adantl vx cv vf cv cfv c2 wceq vx cv cn wcel wa vx
     cv vf cv cfv c2 c3 vx cv cexp co cdiv vx cv vf cv cfv c2 wceq vx cv cn
     wcel pm3.26 opreq1d breqtrrd ex jaoi impcom jca ex adantl mpd vx cv vf cv
     cfv c3 vx cv cexp co cdiv co absid syl eqcomd breq1d biimpd cn cc0 c2 cpr
     vf cv wf vx cv cn wcel wa c2 c3 vx cv cexp co cdiv co c2 c1 c3 cdiv co vx
     cv cexp co cmul co vx cv vf cv cfv c3 vx cv cexp co cdiv co cabs cfv cle
     vx cv cn wcel c2 c3 vx cv cexp co cdiv co c2 c1 c3 cdiv co vx cv cexp co
     cmul co wceq cn cc0 c2 cpr vf cv wf vx cv cn wcel c2 c3 vx cv cexp co cdiv
     co c2 c1 c3 vx cv cexp co cdiv co cmul co c2 c1 c3 cdiv co vx cv cexp co
     cmul co c2 cc wcel c3 vx cv cexp co cc wcel c3 vx cv cexp co cc0 wne c2 c3
     vx cv cexp co cdiv co c2 c1 c3 vx cv cexp co cdiv co cmul co wceq vx cv cn
     wcel c2 c3 vx cv cexp co divrec c2 cc wcel vx cv cn wcel 2cn a1i c3 cc
     wcel vx cv cn0 wcel c3 vx cv cexp co cc wcel vx cv cn wcel c3 vx cv expcl
     3cn vx cv nnnn0 sylancr c3 cc wcel c3 cc0 wne vx cv cn0 wcel c3 vx cv cexp
     co cc0 wne vx cv cn wcel c3 vx cv expne0i c3 cc wcel vx cv cn wcel 3cn a1i
     c3 cc0 wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc syl3anc vx cv cn
     wcel c1 c3 vx cv cexp co cdiv co c1 c3 cdiv co vx cv cexp co c2 cmul vx cv
     cn wcel c1 c3 cdiv co vx cv cexp co c1 c3 vx cv cexp co cdiv co c3 cc wcel
     c3 cc0 wne vx cv cn0 wcel c1 c3 cdiv co vx cv cexp co c1 c3 vx cv cexp co
     cdiv co wceq vx cv cn wcel c3 vx cv exprec c3 cc wcel vx cv cn wcel 3cn
     a1i c3 cc0 wne vx cv cn wcel 3ne0 a1i vx cv nnnn0 syl3anc eqcomd opreq2d
     eqtrd adantl breq2d sylibd syld vx cv vf cv cfv cc0 wceq vx cv vf cv cfv
     c2 cle wbr vx cv vf cv cfv c2 wceq vx cv vf cv cfv cc0 wceq vx cv vf cv
     cfv c2 cle wbr cc0 c2 cle wbr c2 cn wcel cc0 c2 cle wbr 2nn c2 cn wcel c2
     crp wcel cc0 c2 cle wbr c2 nnrp c2 rpge0 syl ax-mp vx cv vf cv cfv cc0 c2
     cle breq1 mpbiri vx cv vf cv cfv c2 wceq vx cv vf cv cfv c2 cle wbr c2 c2
     cle wbr c2 2re leidi vx cv vf cv cfv c2 c2 cle breq1 mpbiri jaoi syl5com
     mpcom cc0 c2 cpr cn vf cv cc0 c2 prex nnex elmap sylanb vf cv cc0 c2 cpr
     cn cm co wcel vx cv cn wcel wa vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vx cv vf cv cfv c3
     vx cv cexp co cdiv co cabs vx cv c1 cuz cfv wcel vx cv vf cv cfv c3 vx cv
     cexp co cdiv co cvv wcel vx cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vx cv vf cv cfv c3 vx cv
     cexp co cdiv co wceq vf cv cc0 c2 cpr cn cm co wcel vx cv cn wcel wa vl vy
     vx cv vl cv vf cv cfv c3 vl cv cexp co cdiv co vx cv vf cv cfv c3 vx cv
     cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vx weq vl cv vf cv cfv vx
     cv vf cv cfv c3 vl cv cexp co c3 vx cv cexp co cdiv vl cv vx cv vf cv
     fveq2 vl cv vx cv c3 cexp opreq2 opreq12d vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid fvopab4g vx
     cv cn wcel vx cv c1 cuz cfv wcel vf cv cc0 c2 cpr cn cm co wcel vx cv cn
     wcel vx cv c1 cuz cfv wcel vx cv elnnuz biimpi adantl vx cv vf cv cfv c3
     vx cv cexp co cdiv oprex sylancl fveq2d vf cv cc0 c2 cpr cn cm co wcel vx
     cv cn wcel wa vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp
     co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv cexp co c2 cmul vx cv cn
     wcel vx cv vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa
     vl vy copab cfv c1 c3 cdiv co vx cv cexp co wceq vf cv cc0 c2 cpr cn cm co
     wcel vx cv cn wcel vx cv c1 cuz cfv wcel vx cv vl cv c1 cuz cfv wcel vy cv
     c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv co vx cv
     cexp co wceq c1 cuz cfv cn vx cv cn c1 cuz cfv nnuz eqcomi eleq2i vx cv c1
     cuz cfv wcel c1 c3 cdiv co vx cv cexp co cvv wcel vx cv vl cv c1 cuz cfv
     wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cfv c1 c3 cdiv
     co vx cv cexp co wceq c1 c3 cdiv co vx cv cexp oprex vl vy vx cv c1 c3
     cdiv co vl cv cexp co c1 c3 cdiv co vx cv cexp co c1 cuz cfv cvv vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv
     vx cv c1 c3 cdiv co cexp opreq2 vl cv c1 cuz cfv wcel vy cv c1 c3 cdiv co
     vl cv cexp co wceq wa vl vy copab eqid fvopab4g mpan2 sylbir adantl
     opreq2d 3brtr4d ex a1dd r19.21aiv jca32 vx va c1 c2 cdiv co c1 c2 vl cv c1
     cuz cfv wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab c1 c2 cdiv oprex cvgcmp3ce sylan32c vf cv cc0 c2 cpr cn cm co
     wcel c1 caddc cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cseqz co va cv cli wbr caddc vl cv c1
     cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseq1 co va cv cli wbr va vf cv cc0 c2 cpr cn cm co wcel c1 caddc
     cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cseqz co caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co va cv cli c1
     caddc cop vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cseqz co caddc vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co wceq vf
     cv cc0 c2 cpr cn cm co wcel caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co c1 caddc cop vl
     cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cseqz co caddc vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab addex vl vy c1 cuz cfv vl cv vf
     cv cfv c3 vl cv cexp co cdiv co c1 cuz fvex opabex2 seq1seqz eqcomi a1i
     breq1d exbidv mpbird sylancr c1 cz wcel c1 caddc cop vl cv c1 cuz cfv wcel
     vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co va cv cli
     wbr va wex c1 caddc cop vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cseqz co c1 cuz cfv c2 c3 vk cv cexp co cdiv
     co vk csu cli wbr vf cv cc0 c2 cpr cn cm co wcel va vy c2 c3 vk cv cexp co
     cdiv co vk vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa
     vl vy copab c1 c2 c3 vk cv cexp co cdiv oprex vl cv c1 cuz cfv wcel vy cv
     c2 c3 vl cv cexp co cdiv co wceq wa vk cv c1 cuz cfv wcel vy cv c2 c3 vk
     cv cexp co cdiv co wceq wa vl vy vk vl vk weq vl cv c1 cuz cfv wcel vk cv
     c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq vy cv c2 c3 vk cv
     cexp co cdiv co wceq vl cv vk cv c1 cuz cfv eleq1 vl vk weq c2 c3 vl cv
     cexp co cdiv co c2 c3 vk cv cexp co cdiv co vy cv vl vk weq c3 vl cv cexp
     co c3 vk cv cexp co c2 cdiv vl cv vk cv c3 cexp opreq2 opreq2d eqeq2d
     anbi12d cbvopab1v isumclim3 1z c1 caddc cop vl cv c1 cuz cfv wcel vy cv c2
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co va cv cli wbr va wex
     vf cv cc0 c2 cpr cn cm co wcel c1 caddc cop vl cv c1 cuz cfv wcel vy cv c2
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co c1 cli wbr c1 caddc
     cop vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseqz co va cv cli wbr va wex c1 cz wcel c2 cc wcel vl cv vl cv c1
     cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cc
     wcel vl cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cfv c2 vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cfv cmul co wceq wa vl c1 cuz cfv wral w3a c1
     caddc cop vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cseqz co c1 c2 cdiv co cli wbr c1 caddc cop vl cv c1 cuz cfv
     wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co c1 cli
     wbr c1 cz wcel c2 cc wcel vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cfv cc wcel vl cv vl cv c1 cuz cfv
     wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv c2 vl cv vl
     cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv cmul co wceq wa vl c1 cuz cfv wral 1z 2cn vl cv vl cv c1 cuz cfv wcel
     vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cc wcel vl cv vl
     cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv c2 vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq
     wa vl vy copab cfv cmul co wceq wa vl c1 cuz cfv vl cv c1 cuz cfv wcel vl
     cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cc wcel vl cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cfv c2 vl cv vl cv c1 cuz cfv wcel vy cv c1 c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cmul co wceq vl cv c1 cuz
     cfv wcel vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv cc wcel c1 c3 vl cv cexp co cdiv co cc wcel c1 cc
     wcel c3 vl cv cexp co cc wcel c3 vl cv cexp co cc0 wne c1 c3 vl cv cexp co
     cdiv co cc wcel vl cv c1 cuz cfv wcel c1 c3 vl cv cexp co divcl c1 cc wcel
     vl cv c1 cuz cfv wcel ax1cn a1i c3 cc wcel vl cv cn0 wcel c3 vl cv cexp co
     cc wcel vl cv c1 cuz cfv wcel c3 vl cv expcl 3cn vl cv c1 cuz cfv wcel vl
     cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir sylancr c3 cc
     wcel c3 cc0 wne vl cv cn0 wcel c3 vl cv cexp co cc0 wne vl cv c1 cuz cfv
     wcel c3 vl cv expne0i c3 cc wcel vl cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne
     vl cv c1 cuz cfv wcel 3ne0 a1i vl cv c1 cuz cfv wcel vl cv cn wcel vl cv
     cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir syl3anc syl3anc vl cv c1 cuz cfv
     wcel c1 c3 vl cv cexp co cdiv co cc wcel vl cv vl cv c1 cuz cfv wcel vy cv
     c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cc wcel c1 c3 vl cv
     cexp co cdiv co cc wcel wb c1 cc wcel c3 vl cv cexp co cc wcel c3 vl cv
     cexp co cc0 wne c1 c3 vl cv cexp co cdiv co cc wcel vl cv c1 cuz cfv wcel
     c1 c3 vl cv cexp co divcl c1 cc wcel vl cv c1 cuz cfv wcel ax1cn a1i c3 cc
     wcel vl cv cn0 wcel c3 vl cv cexp co cc wcel vl cv c1 cuz cfv wcel c3 vl
     cv expcl 3cn vl cv c1 cuz cfv wcel vl cv cn wcel vl cv cn0 wcel vl cv
     elnnuz vl cv nnnn0 sylbir sylancr c3 cc wcel c3 cc0 wne vl cv cn0 wcel c3
     vl cv cexp co cc0 wne vl cv c1 cuz cfv wcel c3 vl cv expne0i c3 cc wcel vl
     cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne vl cv c1 cuz cfv wcel 3ne0 a1i vl cv
     c1 cuz cfv wcel vl cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0
     sylbir syl3anc syl3anc vl cv c1 cuz cfv wcel c1 c3 vl cv cexp co cdiv co
     cc wcel wa vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv c1 c3 vl cv cexp co cdiv co cc vl vy c1 cuz cfv c1
     c3 vl cv cexp co cdiv co cc fvopab2 eleq1d mpdan mpbird vl cv c1 cuz cfv
     wcel c2 c3 vl cv cexp co cdiv co cc wcel vl cv vl cv c1 cuz cfv wcel vy cv
     c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv c2 vl cv vl cv c1 cuz
     cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cmul co
     wceq c2 cc wcel c3 vl cv cexp co cc wcel c3 vl cv cexp co cc0 wne c2 c3 vl
     cv cexp co cdiv co cc wcel vl cv c1 cuz cfv wcel c2 c3 vl cv cexp co divcl
     c2 cc wcel vl cv c1 cuz cfv wcel 2cn a1i c3 cc wcel vl cv cn0 wcel c3 vl
     cv cexp co cc wcel vl cv c1 cuz cfv wcel c3 vl cv expcl 3cn vl cv c1 cuz
     cfv wcel vl cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir
     sylancr c3 cc wcel c3 cc0 wne vl cv cn0 wcel c3 vl cv cexp co cc0 wne vl
     cv c1 cuz cfv wcel c3 vl cv expne0i c3 cc wcel vl cv c1 cuz cfv wcel 3cn
     a1i c3 cc0 wne vl cv c1 cuz cfv wcel 3ne0 a1i vl cv c1 cuz cfv wcel vl cv
     cn wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir syl3anc syl3anc vl
     cv c1 cuz cfv wcel c2 c3 vl cv cexp co cdiv co cc wcel wa vl cv vl cv c1
     cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv c2
     c3 vl cv cexp co cdiv co c2 c1 c3 vl cv cexp co cdiv co cmul co c2 vl cv
     vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cmul co vl vy c1 cuz cfv c2 c3 vl cv cexp co cdiv co cc fvopab2
     vl cv c1 cuz cfv wcel c2 c3 vl cv cexp co cdiv co cc wcel wa c2 cc wcel c3
     vl cv cexp co cc wcel c3 vl cv cexp co cc0 wne w3a c2 c3 vl cv cexp co
     cdiv co c2 c1 c3 vl cv cexp co cdiv co cmul co wceq vl cv c1 cuz cfv wcel
     c2 cc wcel c3 vl cv cexp co cc wcel c3 vl cv cexp co cc0 wne w3a c2 c3 vl
     cv cexp co cdiv co cc wcel vl cv c1 cuz cfv wcel c2 cc wcel c3 vl cv cexp
     co cc wcel c3 vl cv cexp co cc0 wne c2 cc wcel vl cv c1 cuz cfv wcel 2cn
     a1i c3 cc wcel vl cv cn0 wcel c3 vl cv cexp co cc wcel vl cv c1 cuz cfv
     wcel c3 vl cv expcl 3cn vl cv c1 cuz cfv wcel vl cv cn wcel vl cv cn0 wcel
     vl cv elnnuz vl cv nnnn0 sylbir sylancr c3 cc wcel c3 cc0 wne vl cv cn0
     wcel c3 vl cv cexp co cc0 wne vl cv c1 cuz cfv wcel c3 vl cv expne0i c3 cc
     wcel vl cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne vl cv c1 cuz cfv wcel 3ne0
     a1i vl cv c1 cuz cfv wcel vl cv cn wcel vl cv cn0 wcel vl cv elnnuz vl cv
     nnnn0 sylbir syl3anc 3jca adantr c2 c3 vl cv cexp co divrec syl vl cv c1
     cuz cfv wcel c2 c1 c3 vl cv cexp co cdiv co cmul co c2 vl cv vl cv c1 cuz
     cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cmul co
     wceq c2 c3 vl cv cexp co cdiv co cc wcel vl cv c1 cuz cfv wcel c1 c3 vl cv
     cexp co cdiv co vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv
     co wceq wa vl vy copab cfv c2 cmul vl cv c1 cuz cfv wcel vl cv vl cv c1
     cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv c1
     c3 vl cv cexp co cdiv co vl cv c1 cuz cfv wcel c1 c3 vl cv cexp co cdiv co
     cc wcel vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq
     wa vl vy copab cfv c1 c3 vl cv cexp co cdiv co wceq c1 cc wcel c3 vl cv
     cexp co cc wcel c3 vl cv cexp co cc0 wne c1 c3 vl cv cexp co cdiv co cc
     wcel vl cv c1 cuz cfv wcel c1 c3 vl cv cexp co divcl c1 cc wcel vl cv c1
     cuz cfv wcel ax1cn a1i c3 cc wcel vl cv cn0 wcel c3 vl cv cexp co cc wcel
     vl cv c1 cuz cfv wcel c3 vl cv expcl 3cn vl cv c1 cuz cfv wcel vl cv cn
     wcel vl cv cn0 wcel vl cv elnnuz vl cv nnnn0 sylbir sylancr c3 cc wcel c3
     cc0 wne vl cv cn0 wcel c3 vl cv cexp co cc0 wne vl cv c1 cuz cfv wcel c3
     vl cv expne0i c3 cc wcel vl cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne vl cv c1
     cuz cfv wcel 3ne0 a1i vl cv c1 cuz cfv wcel vl cv cn wcel vl cv cn0 wcel
     vl cv elnnuz vl cv nnnn0 sylbir syl3anc syl3anc vl vy c1 cuz cfv c1 c3 vl
     cv cexp co cdiv co cc fvopab2 mpdan eqcomd opreq2d adantr 3eqtrd mpdan jca
     rgen 3pm3.2i c1 caddc cop vl cv cn wcel vy cv c1 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cseqz co c1 c3 cdiv co c1 c1 c3 cdiv co cmin co cdiv
     co c1 caddc cop vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cseqz co c1 c2 cdiv co cli caddc vl cv cn wcel vy cv
     c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co c1 caddc cop vl
     cv cn wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co
     c1 c3 cdiv co c1 c1 c3 cdiv co cmin co cdiv co cli caddc vl cv cn wcel vy
     cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab addex vl vy cn c1 c3 vl
     cv cexp co cdiv co nnex opabex2 seq1seqz caddc vl cv cn wcel vy cv c1 c3
     vl cv cexp co cdiv co wceq wa vl vy copab cseq1 co caddc vl cv cn wcel vy
     cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab cseq1 co c1 c3 cdiv co
     c1 c1 c3 cdiv co cmin co cdiv co cli vl cv cn wcel vy cv c1 c3 vl cv cexp
     co cdiv co wceq wa vl vy copab vl cv cn wcel vy cv c1 c3 cdiv co vl cv
     cexp co wceq wa vl vy copab caddc cseq1 vl cv cn wcel vy cv c1 c3 vl cv
     cexp co cdiv co wceq wa vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co
     wceq wa vl vy vl cv cn wcel vy cv c1 c3 vl cv cexp co cdiv co wceq vy cv
     c1 c3 cdiv co vl cv cexp co wceq vl cv cn wcel c1 c3 vl cv cexp co cdiv co
     c1 c3 cdiv co vl cv cexp co vy cv vl cv cn wcel c1 c3 cdiv co vl cv cexp
     co c1 c3 vl cv cexp co cdiv co c3 cc wcel c3 cc0 wne vl cv cn0 wcel c1 c3
     cdiv co vl cv cexp co c1 c3 vl cv cexp co cdiv co wceq vl cv cn wcel c3 vl
     cv exprec c3 cc wcel vl cv cn wcel 3cn a1i c3 cc0 wne vl cv cn wcel 3ne0
     a1i vl cv nnnn0 syl3anc eqcomd eqeq2d pm5.32i opabbii opreq2i vy c1 c3
     cdiv co vl vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy
     copab vl cv cn wcel vy cv c1 c3 cdiv co vl cv cexp co wceq wa vl vy copab
     eqid c3 3cn 3ne0 reccli c1 cc wcel c3 cc wcel c3 cc0 wne c1 c3 cdiv co
     cabs cfv c1 clt wbr ax1cn 3cn 3ne0 c1 cc wcel c3 cc wcel c3 cc0 wne w3a c1
     c3 cdiv co cabs cfv c1 cabs cfv c3 cabs cfv cdiv co c1 clt c1 c3 absdiv c1
     cc wcel c3 cc wcel c3 cc0 wne w3a c1 cabs cfv c3 cabs cfv cdiv co c1 c3
     cdiv co c1 clt c1 cc wcel c3 cc wcel c3 cc0 wne w3a c1 cabs cfv c1 c3 cabs
     cfv c3 cdiv c1 cabs cfv c1 wceq c1 cc wcel c3 cc wcel c3 cc0 wne w3a c1 cr
     wcel cc0 c1 cle wbr c1 cabs cfv c1 wceq 1re cc0 c1 0re 1re lt01 ltleii c1
     absid mp2an a1i c3 cabs cfv c3 wceq c1 cc wcel c3 cc wcel c3 cc0 wne w3a
     c3 cr wcel cc0 c3 cle wbr c3 cabs cfv c3 wceq 3re cc0 c3 0re 3re 3pos
     ltleii c3 absid mp2an a1i opreq12d c1 cc wcel c3 cc wcel c3 cc0 wne w3a c3
     cr wcel c1 c3 clt wbr wa c1 c3 cdiv co c1 clt wbr c3 cr wcel c1 c3 clt wbr
     wa c1 cc wcel c3 cc wcel c3 cc0 wne w3a c3 cr wcel c1 c3 clt wbr 3re 1lt3
     pm3.2i a1i c3 cr wcel c1 c3 clt wbr wa cc0 c1 c3 cdiv co clt wbr c1 c3
     cdiv co c1 clt wbr c3 recgt1i pm3.27d syl eqbrtrd eqbrtrd mp3an geolim1i
     eqbrtri eqbrtrri vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab vl cv cn wcel vy cv c1 c3 vl cv cexp co cdiv co wceq
     wa vl vy copab c1 caddc cop cseqz vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv
     cexp co cdiv co wceq wa vl cv cn wcel vy cv c1 c3 vl cv cexp co cdiv co
     wceq wa vl vy vl cv c1 cuz cfv wcel vl cv cn wcel vy cv c1 c3 vl cv cexp
     co cdiv co wceq vl cv cn wcel vl cv c1 cuz cfv wcel vl cv elnnuz bicomi
     anbi1i opabbii opreq2i c1 c2 cdiv co c1 c3 cdiv co c2 c3 cdiv co cdiv co
     c1 c3 cdiv co c1 c1 c3 cdiv co cmin co cdiv co c1 c3 cdiv co c2 c3 cdiv co
     cdiv co c1 c3 cmul co c3 c2 cmul co cdiv co c3 c1 cmul co c3 c2 cmul co
     cdiv co c1 c2 cdiv co c1 c3 c2 c3 ax1cn 3cn 2cn 3cn 3ne0 3ne0 2ne0
     divdivdivi c1 c3 cmul co c3 c1 cmul co c3 c2 cmul co cdiv c1 c3 ax1cn 3cn
     mulcomi opreq1i c1 cc wcel c2 cc wcel c2 cc0 wne wa c3 cc wcel c3 cc0 wne
     wa c3 c1 cmul co c3 c2 cmul co cdiv co c1 c2 cdiv co wceq ax1cn c2 cc wcel
     c2 cc0 wne 2cn 2ne0 pm3.2i c3 cc wcel c3 cc0 wne 3cn 3ne0 pm3.2i c1 c2 c3
     divcan5 mp3an 3eqtrri c2 c3 cdiv co c1 c1 c3 cdiv co cmin co c1 c3 cdiv co
     cdiv c2 c3 cdiv co c3 c1 cmin co c3 cdiv co c3 c3 cdiv co c1 c3 cdiv co
     cmin co c1 c1 c3 cdiv co cmin co c2 c3 c1 cmin co c3 cdiv 2eq3m1 opreq1i
     c3 cc wcel c1 cc wcel c3 cc wcel c3 cc0 wne wa c3 c1 cmin co c3 cdiv co c3
     c3 cdiv co c1 c3 cdiv co cmin co wceq 3cn ax1cn c3 cc wcel c3 cc0 wne 3cn
     3ne0 pm3.2i c3 c1 c3 divsubdir mp3an c3 c3 cdiv co c1 c1 c3 cdiv co cmin
     c3 3cn 3ne0 dividi opreq1i 3eqtri opreq2i eqtri 3brtr4i c1 cz wcel c2 cc
     wcel vl cv vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cfv cc wcel vl cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp
     co cdiv co wceq wa vl vy copab cfv c2 vl cv vl cv c1 cuz cfv wcel vy cv c1
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cmul co wceq wa vl c1 cuz
     cfv wral w3a c1 caddc cop vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cseqz co c1 c2 cdiv co cli wbr wa c1 caddc cop
     vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseqz co c2 c1 c2 cdiv co cmul co c1 cli c1 cz wcel c2 cc wcel vl cv
     vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cfv cc wcel vl cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cfv c2 vl cv vl cv c1 cuz cfv wcel vy cv c1 c3
     vl cv cexp co cdiv co wceq wa vl vy copab cfv cmul co wceq wa vl c1 cuz
     cfv wral w3a c1 caddc cop vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cseqz co c1 c2 cdiv co cli wbr c1 caddc cop vl
     cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cseqz co c2 c1 c2 cdiv co cmul co cli wbr vu c1 c2 cdiv co c2 vl vl cv c1
     cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy copab vl cv
     c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab c1
     c1 c2 cdiv oprex vl vy c1 cuz cfv c1 c3 vl cv cexp co cdiv co c1 cuz fvex
     opabex2 vl vy c1 cuz cfv c2 c3 vl cv cexp co cdiv co c1 cuz fvex opabex2
     vl cv c1 cuz cfv wcel vy cv c1 c3 vl cv cexp co cdiv co wceq wa vl vy vu
     hbopab1 vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl
     vy vu hbopab1 iserzmulc1b imp c2 2cn 2ne0 recidi syl6breq mp2an c1 caddc
     cop vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy
     copab cseqz co va cv cli wbr c1 caddc cop vl cv c1 cuz cfv wcel vy cv c2
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cseqz co c1 cli wbr va c1 c1
     cc ax1cn elisseti va cv c1 c1 caddc cop vl cv c1 cuz cfv wcel vy cv c2 c3
     vl cv cexp co cdiv co wceq wa vl vy copab cseqz co cli breq2 cla4ev ax-mp
     a1i sylancr vf cv cc0 c2 cpr cn cm co wcel vk cv vl cv c1 cuz cfv wcel vy
     cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cr
     wcel vk cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa
     vl vy copab cfv cr wcel vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vl cv c1 cuz cfv
     wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cle wbr w3a
     vk c1 cuz cfv wral c1 cz wcel vf cv cc0 c2 cpr cn cm co wcel vk cv vl cv
     c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl
     vy copab cfv cr wcel vk cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cfv cr wcel vk cv vl cv c1 cuz cfv wcel vy cv
     vl cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vl
     cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab
     cfv cle wbr w3a vk c1 cuz cfv vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz
     cfv wcel wa vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv
     cexp co cdiv co wceq wa vl vy copab cfv cr wcel vk cv vl cv c1 cuz cfv
     wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv cr wcel vk
     cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv vk cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp
     co cdiv co wceq wa vl vy copab cfv cle wbr vf cv cc0 c2 cpr cn cm co wcel
     vk cv c1 cuz cfv wcel wa vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vf cv cfv c3 vk cv
     cexp co cdiv co cr vk cv c1 cuz cfv wcel vk cv vf cv cfv c3 vk cv cexp co
     cdiv co cvv wcel vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vf cv cfv c3 vk cv cexp
     co cdiv co wceq vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vl
     vy vk cv vl cv vf cv cfv c3 vl cv cexp co cdiv co vk cv vf cv cfv c3 vk cv
     cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv
     c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vk weq vl cv vf cv cfv vk
     cv vf cv cfv c3 vl cv cexp co c3 vk cv cexp co cdiv vl cv vk cv vf cv
     fveq2 vl cv vk cv c3 cexp opreq2 opreq12d vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid fvopab4g vf
     cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel pm3.27 vk cv vf cv cfv
     c3 vk cv cexp co cdiv oprex sylancl vk cv vf cv cfv cr wcel c3 vk cv cexp
     co cr wcel c3 vk cv cexp co cc0 wne vk cv vf cv cfv c3 vk cv cexp co cdiv
     co cr wcel vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv
     vf cv cfv c3 vk cv cexp co redivcl vf cv cc0 c2 cpr cn cm co wcel vk cv c1
     cuz cfv wcel wa vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv
     c1 cuz cfv wcel wa vk cv vf cv cfv cr wcel vf cv cc0 c2 cpr cn cm co wcel
     vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo
     vk cv c1 cuz cfv wcel wa vf cv cc0 c2 cpr cn cm co wcel cn cc0 c2 cpr vf
     cv wf vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2
     wceq wo vk cv c1 cuz cfv wcel wa wi cc0 c2 cpr cn vf cv cc0 c2 prex nnex
     elmap vk cv c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0
     wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vk cv c1 cuz cfv
     wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2
     wceq wo vk cv c1 cuz cfv wcel vk cv cn wcel cn cc0 c2 cpr vf cv wf vk cv
     vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo wi c1 cuz cfv cn vk cv cn c1
     cuz cfv nnuz eqcomi eleq2i cn cc0 c2 cpr vf cv wf vk cv cn wcel vk cv vf
     cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf cv wf vk cv cn
     wcel wa vk cv vf cv cfv cc0 c2 cpr wcel vk cv vf cv cfv cc0 wceq vk cv vf
     cv cfv c2 wceq wo cn cc0 c2 cpr vk cv vf cv ffvelrn vk cv vf cv cfv cc0 c2
     vk cv vf cv fvex elpr sylib expcom sylbi anc2ri com12 sylbi imp vk cv vf
     cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv vf cv cfv cr wcel vk cv
     c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr wcel vk cv vf
     cv cfv c2 wceq vk cv vf cv cfv cc0 wceq vk cv vf cv cfv cr wcel cc0 cr
     wcel 0re vk cv vf cv cfv cc0 cr eleq1 mpbiri vk cv vf cv cfv c2 wceq vk cv
     vf cv cfv cr wcel c2 cr wcel 2re vk cv vf cv cfv c2 cr eleq1 mpbiri jaoi
     adantr syl vk cv c1 cuz cfv wcel c3 vk cv cexp co cr wcel vf cv cc0 c2 cpr
     cn cm co wcel c3 cr wcel vk cv cn0 wcel c3 vk cv cexp co cr wcel vk cv c1
     cuz cfv wcel c3 vk cv reexpcl 3re vk cv c1 cuz cfv wcel vk cv cn wcel vk
     cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir sylancr adantl vk cv c1 cuz
     cfv wcel c3 vk cv cexp co cc0 wne vf cv cc0 c2 cpr cn cm co wcel c3 cc
     wcel c3 cc0 wne vk cv cn0 wcel c3 vk cv cexp co cc0 wne vk cv c1 cuz cfv
     wcel c3 vk cv expne0i c3 cc wcel vk cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne
     vk cv c1 cuz cfv wcel 3ne0 a1i vk cv c1 cuz cfv wcel vk cv cn wcel vk cv
     cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir syl3anc adantl syl3anc eqeltrd vf
     cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv vl cv c1 cuz
     cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv c2 c3
     vk cv cexp co cdiv co cr vk cv c1 cuz cfv wcel c2 c3 vk cv cexp co cdiv co
     cvv wcel vk cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv c2 c3 vk cv cexp co cdiv co wceq vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel wa vl vy vk cv c2 c3 vl cv cexp co
     cdiv co c2 c3 vk cv cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel
     vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vk weq c3 vl cv
     cexp co c3 vk cv cexp co c2 cdiv vl cv vk cv c3 cexp opreq2 opreq2d vl cv
     c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid
     fvopab4g vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel pm3.27 c2 c3
     vk cv cexp co cdiv oprex sylancl vk cv c1 cuz cfv wcel c2 c3 vk cv cexp co
     cdiv co cr wcel vf cv cc0 c2 cpr cn cm co wcel c2 cr wcel c3 vk cv cexp co
     cr wcel c3 vk cv cexp co cc0 wne c2 c3 vk cv cexp co cdiv co cr wcel vk cv
     c1 cuz cfv wcel c2 c3 vk cv cexp co redivcl c2 cr wcel vk cv c1 cuz cfv
     wcel 2re a1i c3 cr wcel vk cv cn0 wcel c3 vk cv cexp co cr wcel vk cv c1
     cuz cfv wcel c3 vk cv reexpcl 3re vk cv c1 cuz cfv wcel vk cv cn wcel vk
     cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir sylancr c3 cc wcel c3 cc0 wne
     vk cv cn0 wcel c3 vk cv cexp co cc0 wne vk cv c1 cuz cfv wcel c3 vk cv
     expne0i c3 cc wcel vk cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne vk cv c1 cuz
     cfv wcel 3ne0 a1i vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv
     elnnuz vk cv nnnn0 sylbir syl3anc syl3anc adantl eqeltrd vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv vf cv cfv c3 vk cv cexp co
     cdiv co c2 c3 vk cv cexp co cdiv co vk cv vl cv c1 cuz cfv wcel vy cv vl
     cv vf cv cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv vk cv vl cv
     c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab cfv
     cle vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vk cv vf cv
     cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vk cv vf
     cv cfv c3 vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv co cle wbr vf cv
     cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq vk
     cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vf cv cc0 c2 cpr cn cm co
     wcel cn cc0 c2 cpr vf cv wf vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0 wceq
     vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa wi cc0 c2 cpr cn vf cv
     cc0 c2 prex nnex elmap vk cv c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv
     vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel wa vk
     cv c1 cuz cfv wcel cn cc0 c2 cpr vf cv wf vk cv vf cv cfv cc0 wceq vk cv
     vf cv cfv c2 wceq wo vk cv c1 cuz cfv wcel vk cv cn wcel cn cc0 c2 cpr vf
     cv wf vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo wi c1 cuz cfv cn
     vk cv cn c1 cuz cfv nnuz eqcomi eleq2i cn cc0 c2 cpr vf cv wf vk cv cn
     wcel vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vf
     cv wf vk cv cn wcel wa vk cv vf cv cfv cc0 c2 cpr wcel vk cv vf cv cfv cc0
     wceq vk cv vf cv cfv c2 wceq wo cn cc0 c2 cpr vk cv vf cv ffvelrn vk cv vf
     cv cfv cc0 c2 vk cv vf cv fvex elpr sylib expcom sylbi anc2ri com12 sylbi
     imp vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c2 wceq wo vk cv c1 cuz cfv
     wcel vk cv vf cv cfv c3 vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv co
     cle wbr vk cv vf cv cfv cc0 wceq vk cv c1 cuz cfv wcel vk cv vf cv cfv c3
     vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv co cle wbr wi vk cv vf cv
     cfv c2 wceq vk cv vf cv cfv cc0 wceq vk cv vf cv cfv c3 vk cv cexp co cdiv
     co c2 c3 vk cv cexp co cdiv co cle wbr cc0 c3 vk cv cexp co cdiv co c2 c3
     vk cv cexp co cdiv co cle wbr vk cv c1 cuz cfv wcel vk cv vf cv cfv cc0
     wceq vk cv vf cv cfv c3 vk cv cexp co cdiv co cc0 c3 vk cv cexp co cdiv co
     c2 c3 vk cv cexp co cdiv co cle vk cv vf cv cfv cc0 c3 vk cv cexp co cdiv
     opreq1 breq1d vk cv c1 cuz cfv wcel cc0 c2 cle wbr cc0 c3 vk cv cexp co
     cdiv co c2 c3 vk cv cexp co cdiv co cle wbr cc0 c2 0re 2re 2pos ltleii cc0
     cr wcel c2 cr wcel c3 vk cv cexp co cr wcel cc0 c3 vk cv cexp co clt wbr
     wa cc0 c2 cle wbr cc0 c3 vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv co
     cle wbr wb vk cv c1 cuz cfv wcel cc0 c2 c3 vk cv cexp co lediv1 cc0 cr
     wcel vk cv c1 cuz cfv wcel 0re a1i c2 cr wcel vk cv c1 cuz cfv wcel 2re
     a1i vk cv c1 cuz cfv wcel c3 vk cv cexp co cr wcel cc0 c3 vk cv cexp co
     clt wbr c3 cr wcel vk cv cn0 wcel c3 vk cv cexp co cr wcel vk cv c1 cuz
     cfv wcel c3 vk cv reexpcl 3re vk cv c1 cuz cfv wcel vk cv cn wcel vk cv
     cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir sylancr c3 cr wcel vk cv cn0 wcel
     cc0 c3 clt wbr cc0 c3 vk cv cexp co clt wbr vk cv c1 cuz cfv wcel c3 vk cv
     expgt0 c3 cr wcel vk cv c1 cuz cfv wcel 3re a1i vk cv c1 cuz cfv wcel vk
     cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0 sylbir cc0 c3 clt wbr
     vk cv c1 cuz cfv wcel 3pos a1i syl3anc jca syl3anc mpbii syl5bir vk cv vf
     cv cfv c2 wceq vk cv vf cv cfv c3 vk cv cexp co cdiv co c2 c3 vk cv cexp
     co cdiv co cle wbr c2 c3 vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv co
     cle wbr vk cv c1 cuz cfv wcel vk cv vf cv cfv c2 wceq vk cv vf cv cfv c3
     vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv co c2 c3 vk cv cexp co cdiv
     co cle vk cv vf cv cfv c2 c3 vk cv cexp co cdiv opreq1 breq1d vk cv c1 cuz
     cfv wcel c2 c3 vk cv cexp co cdiv co cr wcel c2 c3 vk cv cexp co cdiv co
     c2 c3 vk cv cexp co cdiv co cle wbr c2 cr wcel c3 vk cv cexp co cr wcel c3
     vk cv cexp co cc0 wne c2 c3 vk cv cexp co cdiv co cr wcel vk cv c1 cuz cfv
     wcel c2 c3 vk cv cexp co redivcl c2 cr wcel vk cv c1 cuz cfv wcel 2re a1i
     c3 cr wcel vk cv cn0 wcel c3 vk cv cexp co cr wcel vk cv c1 cuz cfv wcel
     c3 vk cv reexpcl 3re vk cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk
     cv elnnuz vk cv nnnn0 sylbir sylancr c3 cc wcel c3 cc0 wne vk cv cn0 wcel
     c3 vk cv cexp co cc0 wne vk cv c1 cuz cfv wcel c3 vk cv expne0i c3 cc wcel
     vk cv c1 cuz cfv wcel 3cn a1i c3 cc0 wne vk cv c1 cuz cfv wcel 3ne0 a1i vk
     cv c1 cuz cfv wcel vk cv cn wcel vk cv cn0 wcel vk cv elnnuz vk cv nnnn0
     sylbir syl3anc syl3anc c2 c3 vk cv cexp co cdiv co leid syl syl5bir jaoi
     imp syl vk cv c1 cuz cfv wcel vk cv vf cv cfv c3 vk cv cexp co cdiv co cvv
     wcel vk cv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl cv cexp co
     cdiv co wceq wa vl vy copab cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co
     wceq vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel wa vl vy vk cv
     vl cv vf cv cfv c3 vl cv cexp co cdiv co vk cv vf cv cfv c3 vk cv cexp co
     cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3 vl
     cv cexp co cdiv co wceq wa vl vy copab vl vk weq vl cv vf cv cfv vk cv vf
     cv cfv c3 vl cv cexp co c3 vk cv cexp co cdiv vl cv vk cv vf cv fveq2 vl
     cv vk cv c3 cexp opreq2 opreq12d vl cv c1 cuz cfv wcel vy cv vl cv vf cv
     cfv c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid fvopab4g vf cv cc0
     c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel pm3.27 vk cv vf cv cfv c3 vk cv
     cexp co cdiv oprex sylancl vk cv c1 cuz cfv wcel c2 c3 vk cv cexp co cdiv
     co cvv wcel vk cv vl cv c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co
     wceq wa vl vy copab cfv c2 c3 vk cv cexp co cdiv co wceq vf cv cc0 c2 cpr
     cn cm co wcel vk cv c1 cuz cfv wcel wa vl vy vk cv c2 c3 vl cv cexp co
     cdiv co c2 c3 vk cv cexp co cdiv co c1 cuz cfv cvv vl cv c1 cuz cfv wcel
     vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab vl vk weq c3 vl cv
     cexp co c3 vk cv cexp co c2 cdiv vl cv vk cv c3 cexp opreq2 opreq2d vl cv
     c1 cuz cfv wcel vy cv c2 c3 vl cv cexp co cdiv co wceq wa vl vy copab eqid
     fvopab4g vf cv cc0 c2 cpr cn cm co wcel vk cv c1 cuz cfv wcel pm3.27 c2 c3
     vk cv cexp co cdiv oprex sylancl 3brtr4d 3jca r19.21aiva 1z jctil c1 cuz
     cfv vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu c1 cuz cfv c2 c3 vk cv
     cexp co cdiv co vk csu vk vl cv c1 cuz cfv wcel vy cv vl cv vf cv cfv c3
     vl cv cexp co cdiv co wceq wa vl vy copab vl cv c1 cuz cfv wcel vy cv c2
     c3 vl cv cexp co cdiv co wceq wa vl vy copab c1 c1 cuz cfv vk cv vf cv cfv
     c3 vk cv cexp co cdiv co vk sumex c1 cuz cfv c2 c3 vk cv cexp co cdiv co
     vk sumex vl vy c1 cuz cfv vl cv vf cv cfv c3 vl cv cexp co cdiv co c1 cuz
     fvex opabex2 vl vy c1 cuz cfv c2 c3 vl cv cexp co cdiv co c1 cuz fvex
     opabex2 iserzcmp sylan31c cn c1 cuz cfv vk cv vf cv cfv c3 vk cv cexp co
     cdiv co vk nnuz sumeq1i cn c1 cuz cfv c2 c3 vk cv cexp co cdiv co vk nnuz
     sumeq1i 3brtr4g vf cv cc0 c2 cpr cn cm co wcel cn c2 c3 vk cv cexp co cdiv
     co vk csu cn c2 c1 c3 cdiv co vk cv cexp co cmul co vk csu c2 c1 c3 cdiv
     co cmul co c1 c1 c3 cdiv co cmin co cdiv co c1 cn c2 c3 vk cv cexp co cdiv
     co vk csu cn c2 c1 c3 cdiv co vk cv cexp co cmul co vk csu wceq vf cv cc0
     c2 cpr cn cm co wcel cn c2 c3 vk cv cexp co cdiv co c2 c1 c3 cdiv co vk cv
     cexp co cmul co vk vk cv cn wcel c2 c3 vk cv cexp co cdiv co c2 c1 c3 vk
     cv cexp co cdiv co cmul co c2 c1 c3 cdiv co vk cv cexp co cmul co c2 cc
     wcel c3 vk cv cexp co cc wcel c3 vk cv cexp co cc0 wne c2 c3 vk cv cexp co
     cdiv co c2 c1 c3 vk cv cexp co cdiv co cmul co wceq vk cv cn wcel c2 c3 vk
     cv cexp co divrec c2 cc wcel vk cv cn wcel 2cn a1i c3 cc wcel vk cv cn0
     wcel c3 vk cv cexp co cc wcel vk cv cn wcel c3 vk cv expcl 3cn vk cv nnnn0
     sylancr c3 cc wcel c3 cc0 wne vk cv cn0 wcel c3 vk cv cexp co cc0 wne vk
     cv cn wcel c3 vk cv expne0i c3 cc wcel vk cv cn wcel 3cn a1i c3 cc0 wne vk
     cv cn wcel 3ne0 a1i vk cv nnnn0 syl3anc syl3anc vk cv cn wcel c1 c3 vk cv
     cexp co cdiv co c1 c3 cdiv co vk cv cexp co c2 cmul c3 cc wcel c3 cc0 wne
     vk cv cn0 wcel c1 c3 vk cv cexp co cdiv co c1 c3 cdiv co vk cv cexp co
     wceq vk cv cn wcel c3 cc wcel c3 cc0 wne vk cv cn0 wcel w3a c1 c3 cdiv co
     vk cv cexp co c1 c3 vk cv cexp co cdiv co c3 vk cv exprec eqcomd c3 cc
     wcel vk cv cn wcel 3cn a1i c3 cc0 wne vk cv cn wcel 3ne0 a1i vk cv nnnn0
     syl3anc opreq2d eqtrd sumeq2i a1i vf cv cc0 c2 cpr cn cm co wcel c2 cc
     wcel c1 c3 cdiv co cc wcel c1 c3 cdiv co cabs cfv c1 clt wbr w3a cn c2 c1
     c3 cdiv co vk cv cexp co cmul co vk csu c2 c1 c3 cdiv co cmul co c1 c1 c3
     cdiv co cmin co cdiv co wceq c2 cc wcel c1 c3 cdiv co cc wcel c1 c3 cdiv
     co cabs cfv c1 clt wbr w3a vf cv cc0 c2 cpr cn cm co wcel c2 cc wcel c1 c3
     cdiv co cc wcel c1 c3 cdiv co cabs cfv c1 clt wbr 2cn c3 3cn 3ne0 reccli
     c1 c3 cdiv co cabs cfv c1 clt wbr c1 cneg c1 c3 cdiv co clt wbr c1 c3 cdiv
     co c1 clt wbr c1 c3 cdiv co c1 c3 3re 3ne0 rereccli 1re abslti c1 cneg cr
     wcel cc0 cr wcel c1 c3 cdiv co cr wcel w3a c1 cneg cc0 clt wbr cc0 c1 c3
     cdiv co clt wbr wa c1 cneg c1 c3 cdiv co clt wbr c1 cneg cr wcel cc0 cr
     wcel c1 c3 cdiv co cr wcel c1 1re renegcli 0re c3 3re 3ne0 rereccli
     3pm3.2i c1 cneg cc0 clt wbr cc0 c1 c3 cdiv co clt wbr c1 cneg cc0 clt wbr
     cc0 c1 clt wbr lt01 c1 cr wcel c1 cneg cc0 clt wbr cc0 c1 clt wbr wb 1re
     c1 cr wcel cc0 c1 clt wbr c1 cneg cc0 clt wbr c1 lt0neg2 bicomd ax-mp
     mpbir c3 3re 3pos recgt0ii pm3.2i c1 cneg cc0 c1 c3 cdiv co axlttrn mp2 c1
     c3 cdiv co c1 clt wbr c1 c3 clt wbr 1lt3 c3 cr wcel cc0 c3 clt wbr c1 c3
     cdiv co c1 clt wbr c1 c3 clt wbr wb 3re 3pos c3 cr wcel cc0 c3 clt wbr wa
     c1 c3 clt wbr c1 c3 cdiv co c1 clt wbr c3 recgt1 bicomd mp2an mpbir
     mpbir2an 3pm3.2i a1i c2 c1 c3 cdiv co vk geoisum1c syl c2 c1 c3 cdiv co
     cmul co c1 c1 c3 cdiv co cmin co cdiv co c1 wceq vf cv cc0 c2 cpr cn cm co
     wcel c2 c1 c3 cdiv co cmul co c1 c1 c3 cdiv co cmin co cdiv co c2 c1 c3
     cdiv co cmul co c2 c1 c3 cdiv co cmul co cdiv co c1 c1 c1 c3 cdiv co cmin
     co c2 c1 c3 cdiv co cmul co c2 c1 c3 cdiv co cmul co cdiv c1 c1 c3 cdiv co
     cmin co c1 c3 cdiv co c1 c3 cdiv co caddc co c2 c1 c3 cdiv co cmul co c1
     c1 c3 cdiv co c1 c3 cdiv co c1 c3 cdiv co caddc co ax1cn c3 3cn 3ne0
     reccli c1 c3 cdiv co c1 c3 cdiv co c3 3cn 3ne0 reccli c3 3cn 3ne0 reccli
     addcli c3 c1 c3 cdiv co cmul co c1 c3 cdiv co c1 c3 cdiv co c1 c3 cdiv co
     caddc co caddc co c1 c1 c3 cdiv co c3 3cn 3ne0 reccli 3timesi c3 3cn 3ne0
     recidi eqtr3i subaddrii c1 c3 cdiv co c3 3cn 3ne0 reccli 2timesi eqtr4i
     opreq2i c2 c1 c3 cdiv co cmul co c2 c1 c3 cdiv co 2cn c3 3cn 3ne0 reccli
     mulcli c2 c1 c3 cdiv co 2cn c3 3cn 3ne0 reccli 2ne0 c3 cc0 wne c1 c3 cdiv
     co cc0 wne 3ne0 c3 3cn recne0zi ax-mp muln0i dividi eqtri a1i 3eqtrd
     breqtrd 3jca syl5cbir r19.23aiv sylbi cC vx cv cn vk cv vf cv cfv c3 vk cv
     cexp co cdiv co vk csu wceq vf cc0 c2 cpr cn cm co wrex vx cab vx cv
     cntrsetlem.1 eleq2i cc0 cxr wcel c1 cxr wcel vx cv cc0 c1 cicc co wcel vx
     cv cxr wcel cc0 vx cv cle wbr vx cv c1 cle wbr w3a wb cc0 cr wcel cc0 cxr
     wcel 0re cc0 rexr ax-mp c1 cr wcel c1 cxr wcel 1re c1 rexr ax-mp cc0 c1 vx
     cv elicc1 mp2an 3imtr4i mpgbir $.
     $( [17-Oct-2010] $) $( [17-Oct-2010] $)
  $}

  ${

    cntrset.1 $e |- C = { x | E. f e. ( { 0 , 2 } ^m NN )
          x = sum_ k e. NN ( ( f ` k ) / ( 3 ^ k ) ) } $.
    ${
      $d C y $. $d f k x y $.
      $( Cantor's set is between  ` 0 ` and  ` 1 ` . Viro p. 15. $)
      cntrset $p |- C C_ ( 0 [,] 1 ) $=
        vy cC vf vk cC vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu
        wceq vf cc0 c2 cpr cn cm co wrex vx cab vy cv cn vk cv vf cv cfv c3 vk
        cv cexp co cdiv co vk csu wceq vf cc0 c2 cpr cn cm co wrex vy cab
        cntrset.1 vx cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu wceq
        vf cc0 c2 cpr cn cm co wrex vy cv cn vk cv vf cv cfv c3 vk cv cexp co
        cdiv co vk csu wceq vf cc0 c2 cpr cn cm co wrex vx vy vx vy weq vx cv
        cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu wceq vy cv cn vk cv
        vf cv cfv c3 vk cv cexp co cdiv co vk csu wceq vf cc0 c2 cpr cn cm co
        vx cv vy cv cn vk cv vf cv cfv c3 vk cv cexp co cdiv co vk csu eqeq1
        rexbidv cbvabv eqtri cntrsetlem $.
        $( [30-Dec-2010] $) $( [19-Oct-2010] $)
    $}

  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Pre-calculus and Cartesian geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Distance between the middle of a segment and one of its extremities is a
     positive real. $)
  dmse1 $p |- ( ( A e. RR /\ B e. RR /\ A =/= B ) ->
    ( ( abs ` ( A - B ) ) / 2 ) e. RR+ ) $=
    cA cr wcel cB cr wcel cA cB wne w3a cA cB cmin co cabs cfv crp wcel c2 crp
    wcel wa cA cB cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel cB cr wcel cA
    cB wne w3a cA cB cmin co cabs cfv crp wcel c2 crp wcel cA cB cmin co cc
    wcel cA cB cmin co cc0 wne cA cB cmin co cabs cfv crp wcel cA cr wcel cB cr
    wcel cA cB wne w3a cA cB cmin co absrpcl cA cr wcel cB cr wcel cA cB cmin
    co cc wcel cA cB wne cA cr wcel cB cr wcel wa cA cB cmin co cA cB resubcl
    recnd 3adant3 cA cr wcel cB cr wcel cA cB wne w3a cA cB cmin co cc0 wceq wn
    cA cB cmin co cc0 wne cA cr wcel cB cr wcel cA cB wne cA cB cmin co cc0
    wceq wn cA cr wcel cB cr wcel wa cA cB cmin co cc0 wceq cA cB cA cr wcel cB
    cr wcel wa cA cB cmin co cc0 wceq cA cB wceq cA cc wcel cB cc wcel cA cB
    cmin co cc0 wceq cA cB wceq wb cA cr wcel cB cr wcel cA cB subeq0 cA recn
    cB recn syl2an biimpd necon3ad 3impia cA cB cmin co cc0 df-ne sylibr sylanc
    c2 2re 2pos elrpii jctir cA cB cmin co cabs cfv c2 rpdivcl syl $.
    $( [3-Jan-2008] $) $( [27-Dec-2007] $)

  $( Distance between the middle of a segment and one of its extremities is a
     positive real. $)
  dmse2 $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
    ( ( abs ` ( A - B ) ) / 2 ) e. RR+ ) $=
    cA cr wcel cB cr wcel cA cB wne cA cB cmin co cabs cfv c2 cdiv co crp wcel
    cA cB clt wbr cA cB dmse1 cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA cA
    cB ltne necomd syld3an3 $.
    $( [3-Jan-2008] $) $( [27-Dec-2007] $)

  $( The midpoint of a segment AB of the real line is a real. $)
  msr3 $p |- ( ( A e. RR /\ B e. RR ) ->
   ( B - ( ( abs ` ( A - B ) ) / 2 ) ) e. RR ) $=
    cB cr wcel cA cB cmin co cabs cfv c2 cdiv co cr wcel cB cA cB cmin co cabs
    cfv c2 cdiv co cmin co cr wcel cA cr wcel cB cr wcel wa cB cA cB cmin co
    cabs cfv c2 cdiv co resubcl cA cr wcel cB cr wcel pm3.27 cA cB cmin co cabs
    cfv cr wcel c2 cr wcel c2 cc0 wne cA cB cmin co cabs cfv c2 cdiv co cr wcel
    cA cr wcel cB cr wcel wa cA cB cmin co cabs cfv c2 redivcl cA cr wcel cB cr
    wcel wa cA cB cmin co cc wcel cA cB cmin co cabs cfv cr wcel cA cr wcel cB
    cr wcel wa cA cB cmin co cA cB resubcl recnd cA cB cmin co abscl syl c2 cr
    wcel cA cr wcel cB cr wcel wa 2re a1i c2 cc0 wne cA cr wcel cB cr wcel wa
    2ne0 a1i syl3anc sylanc $.
    $( [3-Jan-2008] $) $( [27-Dec-2007] $)

  $( The midpoint of a segment AB of the real line is a real.  (To FL:  This
     proof was shortened.  Also, it is too specialized, and set.mm size will
     be reduced if it is placed directly in the proof using it. -NM) $)
  msr4 $p |- ( ( A e. RR /\ B e. RR ) ->
    ( A + ( ( abs ` ( B - A ) ) / 2 ) ) e. RR ) $=
    cA cr wcel cB cr wcel cB cA cmin co cabs cfv c2 cdiv co cr wcel cA cB cA
    cmin co cabs cfv c2 cdiv co caddc co cr wcel cA cr wcel cB cr wcel wa cB cA
    cmin co cc wcel cB cA cmin co cabs cfv cr wcel cB cA cmin co cabs cfv c2
    cdiv co cr wcel cB cr wcel cA cr wcel cB cA cmin co cc wcel cB cr wcel cA
    cr wcel wa cB cA cmin co cB cA resubcl recnd ancoms cB cA cmin co abscl cB
    cA cmin co cabs cfv rehalfcl 3syl cA cB cA cmin co cabs cfv c2 cdiv co
    readdcl syldan $.
    $( [3-Jan-2008] $) $( [27-Dec-2007] $)

  $( Translation and inequality on the real line. $)
  ltsubpostb $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A - B ) < A ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cA cB cmin co cA clt wbr cB crp
    wcel cA cr wcel cB cr wcel cc0 cB clt wbr cA cB cmin co cA clt wbr cB cr
    wcel cA cr wcel cc0 cB clt wbr cA cB cmin co cA clt wbr wi cB cr wcel cA cr
    wcel wa cc0 cB clt wbr cA cB cmin co cA clt wbr cB cA ltsubpos biimpd
    expcom imp32 cB elrp sylan2b $.
    $( [3-Jan-2008] $) $( [27-Dec-2007] $)

  $( Translation and inequality on the real line. $)
  ltaddpos2tb $p |- ( ( A e. RR /\ B e. RR+ ) -> A < ( A + B ) ) $=
    cA cr wcel cB cr wcel cc0 cB clt wbr wa cA cA cB caddc co clt wbr cB crp
    wcel cA cr wcel cB cr wcel cc0 cB clt wbr cA cA cB caddc co clt wbr cB cr
    wcel cA cr wcel cc0 cB clt wbr cA cA cB caddc co clt wbr wi cB cr wcel cA
    cr wcel wa cc0 cB clt wbr cA cA cB caddc co clt wbr cB cA ltaddpos biimpd
    expcom imp32 cB elrp sylan2b $.
    $( [3-Jan-2008] $) $( [27-Dec-2007] $)

  $( The midpoint of a segment AB of the real line is on the "left" of
     ` B ` . $)
  mslb1 $p |- ( ( A e. RR /\ B e. RR /\ A < B  ) ->
     ( A + ( ( abs ` ( B - A ) ) / 2 ) ) < B ) $=
    cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cB cA cmin co caddc
    co c2 cdiv co cA cB cA cmin co cabs cfv c2 cdiv co caddc co cB clt cA cr
    wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cB cA cmin co caddc co c2
    cdiv co cA cB cA cmin co cabs cfv c2 cdiv co caddc co wceq c2 cA cB cA cmin
    co cabs cfv c2 cdiv co caddc co cmul co c2 cA cmul co cB cA cmin co caddc
    co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB cA cmin co cabs
    cfv c2 cdiv co caddc co cmul co c2 cA cmul co c2 cB cA cmin co cabs cfv c2
    cdiv co cmul co caddc co c2 cA cmul co cB cA cmin co caddc co c2 cc wcel cA
    cc wcel cB cA cmin co cabs cfv c2 cdiv co cc wcel c2 cA cB cA cmin co cabs
    cfv c2 cdiv co caddc co cmul co c2 cA cmul co c2 cB cA cmin co cabs cfv c2
    cdiv co cmul co caddc co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA
    cB cA cmin co cabs cfv c2 cdiv co adddi c2 cc wcel cA cr wcel cB cr wcel cA
    cB clt wbr w3a 2cn a1i cA cr wcel cB cr wcel cA cc wcel cA cB clt wbr cA
    recn 3ad2ant1 cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA cmin co cabs
    cfv c2 cdiv co crp wcel cB cA cmin co cabs cfv c2 cdiv co cr wcel cB cA
    cmin co cabs cfv c2 cdiv co cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a
    cB cA cmin co cabs cfv c2 cdiv co cA cB cmin co cabs cfv c2 cdiv co crp cA
    cr wcel cB cr wcel cA cB clt wbr w3a cB cA cmin co cabs cfv cA cB cmin co
    cabs cfv c2 cdiv cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr
    wcel wa cB cc wcel cA cc wcel wa cB cA cmin co cabs cfv cA cB cmin co cabs
    cfv wceq cA cr wcel cB cr wcel cA cB clt wbr 3simpa cB cr wcel cA cr wcel
    cB cc wcel cA cc wcel wa cB cr wcel cB cc wcel cA cr wcel cA cc wcel cB
    recn cA recn anim12i ancoms cB cA abssub 3syl opreq1d cA cB dmse2 eqeltrd
    cB cA cmin co cabs cfv c2 cdiv co rpre cB cA cmin co cabs cfv c2 cdiv co
    recn 3syl syl3anc cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cB cA cmin co
    cabs cfv c2 cdiv co cmul co cB cA cmin co c2 cA cmul co caddc cA cr wcel cB
    cr wcel cA cB clt wbr w3a c2 cB cA cmin co cabs cfv c2 cdiv co cmul co cB
    cA cmin co cabs cfv cB cA cmin co cB cA cmin co cabs cfv cc wcel c2 cc wcel
    c2 cc0 wne c2 cB cA cmin co cabs cfv c2 cdiv co cmul co cB cA cmin co cabs
    cfv wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA cmin co cabs cfv c2
    divcan2 cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA cmin co cc wcel cB cA
    cmin co cabs cfv cr wcel cB cA cmin co cabs cfv cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cB cc wcel cA cc wcel wa cB
    cA cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cB cr wcel cA
    cr wcel cB cc wcel cA cc wcel wa cB cr wcel cB cc wcel cA cr wcel cA cc
    wcel cB recn cA recn anim12i ancoms cB cA subcl 3syl cB cA cmin co abscl cB
    cA cmin co cabs cfv recn 3syl c2 cc wcel cA cr wcel cB cr wcel cA cB clt
    wbr w3a 2cn a1i c2 cc0 wne cA cr wcel cB cr wcel cA cB clt wbr w3a 2ne0 a1i
    syl3anc cB cA cmin co cr wcel cc0 cB cA cmin co cle wbr cB cA cmin co cabs
    cfv cB cA cmin co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA cmin
    co absid cA cr wcel cB cr wcel cB cA cmin co cr wcel cA cB clt wbr cB cr
    wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms 3adant3 cA cr
    wcel cB cr wcel cA cB clt wbr w3a cc0 cB cA cmin co cle wbr cA cB cle wbr
    cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cA cB ltle 3impia cA cr
    wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cB cr wcel cA cr
    wcel wa cc0 cB cA cmin co cle wbr cA cB cle wbr wb cA cr wcel cB cr wcel cA
    cB clt wbr 3simpa cA cr wcel cB cr wcel pm3.22 cB cA subge0 3syl mpbird
    sylanc eqtrd opreq2d eqtrd cA cr wcel cB cr wcel c2 cA cmul co cB cA cmin
    co caddc co c2 cdiv co cA cB cA cmin co cabs cfv c2 cdiv co caddc co wceq
    c2 cA cB cA cmin co cabs cfv c2 cdiv co caddc co cmul co c2 cA cmul co cB
    cA cmin co caddc co wceq wb cA cB clt wbr c2 cA cmul co cB cA cmin co caddc
    co cc wcel cA cB cA cmin co cabs cfv c2 cdiv co caddc co cc wcel c2 cA cmul
    co cB cA cmin co caddc co c2 cdiv co cA cB cA cmin co cabs cfv c2 cdiv co
    caddc co wceq c2 cA cB cA cmin co cabs cfv c2 cdiv co caddc co cmul co c2
    cA cmul co cB cA cmin co caddc co wceq wb cA cr wcel cB cr wcel wa c2 cA
    cmul co cB cA cmin co caddc co cc wcel cA cB cA cmin co cabs cfv c2 cdiv co
    caddc co cc wcel c2 cc wcel c2 cc0 wne wa c2 cA cmul co cB cA cmin co caddc
    co c2 cdiv co cA cB cA cmin co cabs cfv c2 cdiv co caddc co wceq c2 cA cB
    cA cmin co cabs cfv c2 cdiv co caddc co cmul co c2 cA cmul co cB cA cmin co
    caddc co wceq wb c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i c2 cA cmul co cB cA
    cmin co caddc co cA cB cA cmin co cabs cfv c2 cdiv co caddc co c2 divmul
    mp3an3 cA cr wcel cB cr wcel wa c2 cA cmul co cB cA cmin co caddc co c2 cA
    cmul co cr wcel cB cA cmin co cr wcel c2 cA cmul co cB cA cmin co caddc co
    cr wcel cA cr wcel cB cr wcel wa c2 cA cmul co cB cA cmin co readdcl cA cr
    wcel c2 cA cmul co cr wcel cB cr wcel c2 cr wcel cA cr wcel c2 cA cmul co
    cr wcel 2re c2 cA remulcl mpan adantr cB cr wcel cA cr wcel cB cA cmin co
    cr wcel cB cA resubcl ancoms sylanc recnd cA cr wcel cB cr wcel wa cA cB cA
    cmin co cabs cfv c2 cdiv co caddc co cA cr wcel cB cr wcel cB cA cmin co
    cabs cfv c2 cdiv co cr wcel cA cB cA cmin co cabs cfv c2 cdiv co caddc co
    cr wcel cA cr wcel cB cr wcel wa cB cA cmin co cc wcel cB cA cmin co cabs
    cfv cr wcel cB cA cmin co cabs cfv c2 cdiv co cr wcel cB cr wcel cA cr wcel
    cB cA cmin co cc wcel cB cr wcel cA cr wcel wa cB cA cmin co cB cA resubcl
    recnd ancoms cB cA cmin co abscl cB cA cmin co cabs cfv rehalfcl 3syl cA cB
    cA cmin co cabs cfv c2 cdiv co readdcl syldan recnd sylanc 3adant3 mpbird
    cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cB cA cmin co caddc
    co c2 cdiv co cB clt wbr c2 cA cmul co cB cA cmin co caddc co c2 cB cmul co
    clt wbr cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cA cmin co c2
    cB cmul co cB cmin co clt wbr c2 cA cmul co cB cA cmin co caddc co c2 cB
    cmul co clt wbr cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB clt wbr c2 cA
    cmul co cA cmin co c2 cB cmul co cB cmin co clt wbr cA cr wcel cB cr wcel
    cA cB clt wbr 3simp3 cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB clt wbr
    wa c2 cA cmul co cA cmin co cA cA caddc co cA cmin co c2 cB cmul co cB cmin
    co clt cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB clt wbr wa c2 cA cmul
    co cA cA caddc co cA cmin cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA
    cmul co cA cA caddc co wceq cA cB clt wbr cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA cr wcel cA cc wcel c2 cA cmul co cA cA caddc co wceq cA cr wcel
    cB cr wcel cA cB clt wbr 3simp1 cA recn cA 2times 3syl adantr opreq1d cA cr
    wcel cB cr wcel cA cB clt wbr w3a cA cB clt wbr wa cA cB cB caddc co cB
    cmin co cA cA caddc co cA cmin co c2 cB cmul co cB cmin co clt cA cr wcel
    cB cr wcel cA cB clt wbr w3a cA cB clt wbr wa cA cB cB cB caddc co cB cmin
    co clt cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB clt wbr pm3.27 cA cr
    wcel cB cr wcel cA cB clt wbr w3a cA cB clt wbr wa cB cc wcel cB cc wcel wa
    cB cB caddc co cB cmin co cB wceq cA cr wcel cB cr wcel cA cB clt wbr w3a
    cB cc wcel cB cc wcel wa cA cB clt wbr cB cr wcel cA cr wcel cB cc wcel cB
    cc wcel wa cA cB clt wbr cB cr wcel cB cc wcel cB cc wcel cB recn cB recn
    jca 3ad2ant2 adantr cB cB pncan syl breqtrrd cA cr wcel cB cr wcel cA cB
    clt wbr w3a cA cB clt wbr wa cA cc wcel cA cc wcel wa cA cA caddc co cA
    cmin co cA wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cc wcel cA cc
    wcel wa cA cB clt wbr cA cr wcel cB cr wcel cA cc wcel cA cc wcel wa cA cB
    clt wbr cA cr wcel cA cc wcel cA cc wcel cA recn cA recn jca 3ad2ant1
    adantr cA cA pncan syl cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB clt
    wbr wa c2 cB cmul co cB cB caddc co cB cmin cA cr wcel cB cr wcel cA cB clt
    wbr w3a c2 cB cmul co cB cB caddc co wceq cA cB clt wbr cA cr wcel cB cr
    wcel cA cB clt wbr w3a cB cr wcel cB cc wcel c2 cB cmul co cB cB caddc co
    wceq cA cr wcel cB cr wcel cA cB clt wbr 3simp2 cB recn cB 2times 3syl
    adantr opreq1d 3brtr4d eqbrtrd mpdan cA cr wcel cB cr wcel cA cB clt wbr
    w3a c2 cA cmul co cA cmin co c2 cB cmul co cB cmin co clt wbr wa c2 cA cmul
    co cB cA cmin co caddc co c2 cB cmul co clt wbr c2 cA cmul co cB cA cmin co
    caddc co cB cmin co c2 cB cmul co cB cmin co clt wbr cA cr wcel cB cr wcel
    cA cB clt wbr w3a c2 cA cmul co cA cmin co c2 cB cmul co cB cmin co clt wbr
    c2 cA cmul co cB cA cmin co caddc co cB cmin co c2 cB cmul co cB cmin co
    clt wbr cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cA cmin co c2
    cA cmul co cB cA cmin co caddc co cB cmin co c2 cB cmul co cB cmin co clt
    cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cA cneg caddc co c2
    cA cmul co cB cA cmin co caddc co cB cneg caddc co c2 cA cmul co cA cmin co
    c2 cA cmul co cB cA cmin co caddc co cB cmin co cA cr wcel cB cr wcel cA cB
    clt wbr w3a c2 cA cmul co cA cneg caddc co c2 cA cmul co cB cA cmin co cB
    cneg caddc co caddc co c2 cA cmul co cB cA cmin co caddc co cB cneg caddc
    co cA cr wcel cB cr wcel cA cB clt wbr w3a cA cneg cB cA cmin co cB cneg
    caddc co c2 cA cmul co caddc cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA
    cmin co cB cneg caddc co cB cA cmin co cB cmin co cB cB cmin co cA cmin co
    cA cneg cB cA cmin co cc wcel cB cc wcel cB cA cmin co cB cneg caddc co cB
    cA cmin co cB cmin co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cB cA
    cmin co cB negsub cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr
    wcel wa cA cc wcel cB cc wcel wa cB cA cmin co cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel cB cc wcel cA
    recn cB recn anim12i cB cc wcel cA cc wcel cB cA cmin co cc wcel cB cA
    subcl ancoms 3syl cB cr wcel cA cr wcel cB cc wcel cA cB clt wbr cB recn
    3ad2ant2 sylanc cB cc wcel cB cc wcel cA cc wcel cB cB cmin co cA cmin co
    cB cA cmin co cB cmin co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cB cB
    cA sub23 cB cr wcel cA cr wcel cB cc wcel cA cB clt wbr cB recn 3ad2ant2 cB
    cr wcel cA cr wcel cB cc wcel cA cB clt wbr cB recn 3ad2ant2 cA cr wcel cB
    cr wcel cA cc wcel cA cB clt wbr cA recn 3ad2ant1 syl3anc cA cr wcel cB cr
    wcel cA cB clt wbr w3a cB cB cmin co cA cmin co cA cneg wceq cA cA cneg
    caddc co cB cB cmin co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cA
    cneg caddc co cc0 cB cB cmin co cA cr wcel cB cr wcel cA cB clt wbr w3a cA
    cr wcel cA cc wcel cA cA cneg caddc co cc0 wceq cA cr wcel cB cr wcel cA cB
    clt wbr 3simp1 cA recn cA negid 3syl cB cr wcel cA cr wcel cc0 cB cB cmin
    co wceq cA cB clt wbr cB cr wcel cB cB cmin co cc0 cB cr wcel cB cc wcel cB
    cB cmin co cc0 wceq cB recn cB subid syl eqcomd 3ad2ant2 eqtrd cB cB cmin
    co cc wcel cA cc wcel cA cneg cc wcel cB cB cmin co cA cmin co cA cneg wceq
    cA cA cneg caddc co cB cB cmin co wceq wb cA cr wcel cB cr wcel cA cB clt
    wbr w3a cB cB cmin co cA cA cneg subadd cA cr wcel cB cr wcel cA cB clt wbr
    w3a cA cr wcel cB cr wcel wa cA cc wcel cB cc wcel wa cB cB cmin co cc wcel
    cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel
    cB cc wcel cA recn cB recn anim12i cB cc wcel cB cB cmin co cc wcel cA cc
    wcel cB cc wcel cB cB cmin co cc wcel cB cB subcl anidms adantl 3syl cA cr
    wcel cB cr wcel cA cc wcel cA cB clt wbr cA recn 3ad2ant1 cA cr wcel cB cr
    wcel cA cB clt wbr w3a cA cr wcel cA cc wcel cA cneg cc wcel cA cr wcel cB
    cr wcel cA cB clt wbr 3simp1 cA recn cA negcl 3syl syl3anc mpbird 3eqtr2rd
    opreq2d cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cc wcel cB cA
    cmin co cc wcel cB cneg cc wcel w3a c2 cA cmul co cB cA cmin co caddc co cB
    cneg caddc co c2 cA cmul co cB cA cmin co cB cneg caddc co caddc co wceq cA
    cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB
    cc wcel wa c2 cA cmul co cc wcel cB cA cmin co cc wcel cB cneg cc wcel w3a
    cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel
    cB cc wcel cA recn cB recn anim12i cA cc wcel cB cc wcel wa c2 cA cmul co
    cc wcel cB cA cmin co cc wcel cB cneg cc wcel cA cc wcel c2 cA cmul co cc
    wcel cB cc wcel c2 cc wcel cA cc wcel c2 cA cmul co cc wcel 2cn c2 cA mulcl
    mpan adantr cB cc wcel cA cc wcel cB cA cmin co cc wcel cB cA subcl ancoms
    cB cc wcel cB cneg cc wcel cA cc wcel cB negcl adantl 3jca 3syl c2 cA cmul
    co cB cA cmin co cB cneg addass syl eqtr4d c2 cA cmul co cc wcel cA cc wcel
    c2 cA cmul co cA cneg caddc co c2 cA cmul co cA cmin co wceq cA cr wcel cB
    cr wcel cA cB clt wbr w3a c2 cA cmul co cA negsub cA cr wcel cB cr wcel cA
    cB clt wbr w3a cA cr wcel cA cc wcel c2 cA cmul co cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr 3simp1 cA recn c2 cc wcel cA cc wcel c2 cA cmul co cc
    wcel 2cn c2 cA mulcl mpan 3syl cA cr wcel cB cr wcel cA cc wcel cA cB clt
    wbr cA recn 3ad2ant1 sylanc cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA
    cmul co cB cA cmin co caddc co cc wcel cB cc wcel wa c2 cA cmul co cB cA
    cmin co caddc co cB cneg caddc co c2 cA cmul co cB cA cmin co caddc co cB
    cmin co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel
    wa cA cc wcel cB cc wcel wa c2 cA cmul co cB cA cmin co caddc co cc wcel cB
    cc wcel wa cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel
    cB cr wcel cB cc wcel cA recn cB recn anim12i cA cc wcel cB cc wcel wa c2
    cA cmul co cB cA cmin co caddc co cc wcel cB cc wcel c2 cA cmul co cc wcel
    cB cA cmin co cc wcel c2 cA cmul co cB cA cmin co caddc co cc wcel cA cc
    wcel cB cc wcel wa c2 cA cmul co cB cA cmin co addcl cA cc wcel c2 cA cmul
    co cc wcel cB cc wcel c2 cc wcel cA cc wcel c2 cA cmul co cc wcel 2cn c2 cA
    mulcl mpan adantr cB cc wcel cA cc wcel cB cA cmin co cc wcel cB cA subcl
    ancoms sylanc cA cc wcel cB cc wcel pm3.27 jca 3syl c2 cA cmul co cB cA
    cmin co caddc co cB negsub syl 3eqtr3d breq1d biimpa cA cr wcel cB cr wcel
    cA cB clt wbr w3a c2 cA cmul co cA cmin co c2 cB cmul co cB cmin co clt wbr
    wa c2 cA cmul co cB cA cmin co caddc co cr wcel c2 cB cmul co cr wcel cB cr
    wcel w3a c2 cA cmul co cB cA cmin co caddc co c2 cB cmul co clt wbr c2 cA
    cmul co cB cA cmin co caddc co cB cmin co c2 cB cmul co cB cmin co clt wbr
    wb cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cB cA cmin co
    caddc co cr wcel c2 cB cmul co cr wcel cB cr wcel w3a c2 cA cmul co cA cmin
    co c2 cB cmul co cB cmin co clt wbr cA cr wcel cB cr wcel cA cB clt wbr w3a
    c2 cA cmul co cB cA cmin co caddc co cr wcel c2 cB cmul co cr wcel cB cr
    wcel c2 cA cmul co cr wcel cB cA cmin co cr wcel c2 cA cmul co cB cA cmin
    co caddc co cr wcel cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co
    cB cA cmin co readdcl cA cr wcel cB cr wcel c2 cA cmul co cr wcel cA cB clt
    wbr c2 cr wcel cA cr wcel c2 cA cmul co cr wcel 2re c2 cA remulcl mpan
    3ad2ant1 cA cr wcel cB cr wcel cB cA cmin co cr wcel cA cB clt wbr cB cr
    wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms 3adant3 sylanc
    cB cr wcel cA cr wcel c2 cB cmul co cr wcel cA cB clt wbr c2 cr wcel cB cr
    wcel c2 cB cmul co cr wcel 2re c2 cB remulcl mpan 3ad2ant2 cA cr wcel cB cr
    wcel cA cB clt wbr 3simp2 3jca adantr c2 cA cmul co cB cA cmin co caddc co
    c2 cB cmul co cB ltsub1 syl mpbird mpdan c2 cA cmul co cB cA cmin co caddc
    co cr wcel cB cr wcel c2 cA cmul co cB cA cmin co caddc co c2 cdiv co cB
    clt wbr c2 cA cmul co cB cA cmin co caddc co c2 cB cmul co clt wbr wb cA cr
    wcel cB cr wcel cA cB clt wbr w3a c2 cA cmul co cB cA cmin co caddc co cr
    wcel cB cr wcel c2 cr wcel cc0 c2 clt wbr wa c2 cA cmul co cB cA cmin co
    caddc co c2 cdiv co cB clt wbr c2 cA cmul co cB cA cmin co caddc co c2 cB
    cmul co clt wbr wb c2 cr wcel cc0 c2 clt wbr 2re 2pos pm3.2i c2 cA cmul co
    cB cA cmin co caddc co cB c2 ltdivmul mp3an3 c2 cA cmul co cr wcel cB cA
    cmin co cr wcel c2 cA cmul co cB cA cmin co caddc co cr wcel cA cr wcel cB
    cr wcel cA cB clt wbr w3a c2 cA cmul co cB cA cmin co readdcl cA cr wcel cB
    cr wcel c2 cA cmul co cr wcel cA cB clt wbr c2 cr wcel cA cr wcel c2 cA
    cmul co cr wcel 2re c2 cA remulcl mpan 3ad2ant1 cA cr wcel cB cr wcel cB cA
    cmin co cr wcel cA cB clt wbr cB cr wcel cA cr wcel cB cA cmin co cr wcel
    cB cA resubcl ancoms 3adant3 sylanc cA cr wcel cB cr wcel cA cB clt wbr
    3simp2 sylanc mpbird eqbrtrrd $.
    $( [3-Jan-2008] $) $( [2-Jan-2008] $)

  $( Two ways to state the midpoint of a segment. $)
  2wsms $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
    ( ( A + B ) / 2 ) = ( B - ( ( abs ` ( A - B ) ) / 2 ) ) ) $=
    cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB caddc co c2 cdiv co cmul
    co c2 cB cA cB cmin co cabs cfv c2 cdiv co cmin co cmul co wceq cA cB caddc
    co c2 cdiv co cB cA cB cmin co cabs cfv c2 cdiv co cmin co wceq cA cr wcel
    cB cr wcel cA cB clt wbr w3a c2 cB cmul co c2 cA cB cmin co cabs cfv c2
    cdiv co cmul co cmin co cA cB caddc co c2 cB cA cB cmin co cabs cfv c2 cdiv
    co cmin co cmul co c2 cA cB caddc co c2 cdiv co cmul co cA cr wcel cB cr
    wcel cA cB clt wbr w3a c2 cB cmul co c2 cA cB cmin co cabs cfv c2 cdiv co
    cmul co cmin co cA cB caddc co wceq c2 cA cB cmin co cabs cfv c2 cdiv co
    cmul co cA cB caddc co caddc co c2 cB cmul co wceq cA cr wcel cB cr wcel cA
    cB clt wbr w3a c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB caddc co
    caddc co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co cB caddc
    co cB c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co caddc co c2
    cB cmul co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cc wcel cA cc wcel
    cB cc wcel c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB caddc co
    caddc co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co cB caddc
    co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB cmin co cabs cfv
    c2 cdiv co cmul co cc wcel cA cc wcel cB cc wcel w3a c2 cA cB cmin co cabs
    cfv c2 cdiv co cmul co cA caddc co cB caddc co c2 cA cB cmin co cabs cfv c2
    cdiv co cmul co cA cB caddc co caddc co c2 cA cB cmin co cabs cfv c2 cdiv
    co cmul co cA cB addass eqcomd cA cr wcel cB cr wcel cA cB clt wbr w3a c2
    cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB cmin co cabs cfv cc cA cB
    cmin co cabs cfv cc wcel c2 cc wcel c2 cc0 wne c2 cA cB cmin co cabs cfv c2
    cdiv co cmul co cA cB cmin co cabs cfv wceq cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA cB cmin co cabs cfv c2 divcan2 cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA cB cmin co cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co
    cabs cfv cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr
    wcel wa cA cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel cB cc wcel cA
    recn cB recn anim12i cA cB subcl 3syl cA cB cmin co abscl cA cB cmin co
    cabs cfv recn 3syl c2 cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn
    a1i c2 cc0 wne cA cr wcel cB cr wcel cA cB clt wbr w3a 2ne0 a1i syl3anc cA
    cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co cc wcel cA cB cmin co
    cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA cr wcel cB cr wcel cA cB
    clt wbr w3a cA cr wcel cB cr wcel wa cA cB cmin co cr wcel cA cB cmin co cc
    wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cB resubcl cA cB cmin co
    recn 3syl cA cB cmin co abscl cA cB cmin co cabs cfv recn 3syl eqeltrd cA
    cr wcel cB cr wcel cA cc wcel cA cB clt wbr cA recn 3ad2ant1 cB cr wcel cA
    cr wcel cB cc wcel cA cB clt wbr cB recn 3ad2ant2 syl3anc c2 cA cB cmin co
    cabs cfv c2 cdiv co cmul co cA caddc co cc wcel cB cc wcel c2 cA cB cmin co
    cabs cfv c2 cdiv co cmul co cA caddc co cB caddc co cB c2 cA cB cmin co
    cabs cfv c2 cdiv co cmul co cA caddc co caddc co wceq cA cr wcel cB cr wcel
    cA cB clt wbr w3a c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co
    cB addcom c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cc wcel cA cc wcel
    c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co cc wcel cA cr wcel
    cB cr wcel cA cB clt wbr w3a c2 cA cB cmin co cabs cfv c2 cdiv co cmul co
    cA addcl cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB cmin co cabs cfv
    c2 cdiv co cmul co cA cB cmin co cabs cfv cc cA cB cmin co cabs cfv cc wcel
    c2 cc wcel c2 cc0 wne c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB
    cmin co cabs cfv wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co
    cabs cfv c2 divcan2 cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co
    cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA cr
    wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB cc
    wcel wa cA cB cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA
    cr wcel cA cc wcel cB cr wcel cB cc wcel cA recn cB recn anim12i cA cB
    subcl 3syl cA cB cmin co abscl cA cB cmin co cabs cfv recn 3syl c2 cc wcel
    cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn a1i c2 cc0 wne cA cr wcel cB cr
    wcel cA cB clt wbr w3a 2ne0 a1i syl3anc cA cr wcel cB cr wcel cA cB clt wbr
    w3a cA cB cmin co cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co cabs
    cfv cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel
    wa cA cB cmin co cr wcel cA cB cmin co cc wcel cA cr wcel cB cr wcel cA cB
    clt wbr 3simpa cA cB resubcl cA cB cmin co recn 3syl cA cB cmin co abscl cA
    cB cmin co cabs cfv recn 3syl eqeltrd cA cr wcel cB cr wcel cA cc wcel cA
    cB clt wbr cA recn 3ad2ant1 sylanc cB cr wcel cA cr wcel cB cc wcel cA cB
    clt wbr cB recn 3ad2ant2 sylanc cA cr wcel cB cr wcel cA cB clt wbr w3a c2
    cB cmul co cB cmin co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc
    co wceq cB c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co caddc
    co c2 cB cmul co wceq cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cB cmul co
    cB cmin co cB cB caddc co cB cmin co cB c2 cA cB cmin co cabs cfv c2 cdiv
    co cmul co cA caddc co cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cB cmul
    co cB cB caddc co cB cmin cA cr wcel cB cr wcel cA cB clt wbr w3a cB cr
    wcel cB cc wcel c2 cB cmul co cB cB caddc co wceq cA cr wcel cB cr wcel cA
    cB clt wbr 3simp2 cB recn cB 2times 3syl opreq1d cA cr wcel cB cr wcel cA
    cB clt wbr w3a cB cr wcel cB cc wcel cB cc wcel wa cB cB caddc co cB cmin
    co cB wceq cA cr wcel cB cr wcel cA cB clt wbr 3simp2 cB cr wcel cB cc wcel
    cB cc wcel cB recn cB recn jca cB cB pncan 3syl cA cr wcel cB cr wcel cA cB
    clt wbr w3a cA c2 cA cB cmin co cabs cfv c2 cdiv co cmul co caddc co cB c2
    cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co cA cr wcel cB cr wcel
    cA cB clt wbr w3a cB cA cmin co c2 cA cB cmin co cabs cfv c2 cdiv co cmul
    co wceq cA c2 cA cB cmin co cabs cfv c2 cdiv co cmul co caddc co cB wceq cA
    cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB cmin co cabs cfv c2 cdiv co
    cmul co cA cB cmin co cabs cfv cB cA cmin co cA cB cmin co cabs cfv cc wcel
    c2 cc wcel c2 cc0 wne c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB
    cmin co cabs cfv wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co
    cabs cfv c2 divcan2 cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co
    cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA cr
    wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB cc
    wcel wa cA cB cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA
    cr wcel cA cc wcel cB cr wcel cB cc wcel cA recn cB recn anim12i cA cB
    subcl 3syl cA cB cmin co abscl cA cB cmin co cabs cfv recn 3syl c2 cc wcel
    cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn a1i c2 cc0 wne cA cr wcel cB cr
    wcel cA cB clt wbr w3a 2ne0 a1i syl3anc cA cr wcel cB cr wcel cA cB cle wbr
    cA cB cmin co cabs cfv cB cA cmin co wceq cA cB clt wbr cA cB abssuble0 cA
    cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cA cB ltle 3impia syld3an3
    eqtr2d cB cc wcel cA cc wcel c2 cA cB cmin co cabs cfv c2 cdiv co cmul co
    cc wcel cB cA cmin co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co wceq cA
    c2 cA cB cmin co cabs cfv c2 cdiv co cmul co caddc co cB wceq wb cA cr wcel
    cB cr wcel cA cB clt wbr w3a cB cA c2 cA cB cmin co cabs cfv c2 cdiv co
    cmul co subadd cB cr wcel cA cr wcel cB cc wcel cA cB clt wbr cB recn
    3ad2ant2 cA cr wcel cB cr wcel cA cc wcel cA cB clt wbr cA recn 3ad2ant1 cA
    cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB cmin co cabs cfv c2 cdiv co
    cmul co cA cB cmin co cabs cfv cc cA cB cmin co cabs cfv cc wcel c2 cc wcel
    c2 cc0 wne c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB cmin co cabs
    cfv wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co cabs cfv c2
    divcan2 cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co cc wcel cA cB
    cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB cc wcel wa cA
    cB cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA
    cc wcel cB cr wcel cB cc wcel cA recn cB recn anim12i cA cB subcl 3syl cA
    cB cmin co abscl cA cB cmin co cabs cfv recn 3syl c2 cc wcel cA cr wcel cB
    cr wcel cA cB clt wbr w3a 2cn a1i c2 cc0 wne cA cr wcel cB cr wcel cA cB
    clt wbr w3a 2ne0 a1i syl3anc cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB
    cmin co cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cc
    wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cB
    cmin co cr wcel cA cB cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr
    3simpa cA cB resubcl cA cB cmin co recn 3syl cA cB cmin co abscl cA cB cmin
    co cabs cfv recn 3syl eqeltrd syl3anc mpbid cA cc wcel c2 cA cB cmin co
    cabs cfv c2 cdiv co cmul co cc wcel cA c2 cA cB cmin co cabs cfv c2 cdiv co
    cmul co caddc co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co
    wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA c2 cA cB cmin co cabs cfv
    c2 cdiv co cmul co addcom cA cr wcel cB cr wcel cA cc wcel cA cB clt wbr cA
    recn 3ad2ant1 cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cA cB cmin co cabs
    cfv c2 cdiv co cmul co cA cB cmin co cabs cfv cc cA cB cmin co cabs cfv cc
    wcel c2 cc wcel c2 cc0 wne c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA
    cB cmin co cabs cfv wceq cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin
    co cabs cfv c2 divcan2 cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin
    co cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA
    cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB
    cc wcel wa cA cB cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa
    cA cr wcel cA cc wcel cB cr wcel cB cc wcel cA recn cB recn anim12i cA cB
    subcl 3syl cA cB cmin co abscl cA cB cmin co cabs cfv recn 3syl c2 cc wcel
    cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn a1i c2 cc0 wne cA cr wcel cB cr
    wcel cA cB clt wbr w3a 2ne0 a1i syl3anc cA cr wcel cB cr wcel cA cB clt wbr
    w3a cA cB cmin co cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co cabs
    cfv cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel
    wa cA cB cmin co cr wcel cA cB cmin co cc wcel cA cr wcel cB cr wcel cA cB
    clt wbr 3simpa cA cB resubcl cA cB cmin co recn 3syl cA cB cmin co abscl cA
    cB cmin co cabs cfv recn 3syl eqeltrd sylanc eqtr3d 3eqtrd c2 cB cmul co cc
    wcel cB cc wcel c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co cc
    wcel c2 cB cmul co cB cmin co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co
    cA caddc co wceq cB c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc
    co caddc co c2 cB cmul co wceq wb cA cr wcel cB cr wcel cA cB clt wbr w3a
    c2 cB cmul co cB c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA caddc co
    subadd cA cr wcel cB cr wcel cA cB clt wbr w3a cB cr wcel cB cc wcel c2 cB
    cmul co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simp2 cB recn c2 cc
    wcel cB cc wcel c2 cB cmul co cc wcel 2cn c2 cB mulcl mpan 3syl cB cr wcel
    cA cr wcel cB cc wcel cA cB clt wbr cB recn 3ad2ant2 c2 cA cB cmin co cabs
    cfv c2 cdiv co cmul co cc wcel cA cc wcel c2 cA cB cmin co cabs cfv c2 cdiv
    co cmul co cA caddc co cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a c2
    cA cB cmin co cabs cfv c2 cdiv co cmul co cA addcl cA cr wcel cB cr wcel cA
    cB clt wbr w3a c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB cmin co
    cabs cfv cc cA cB cmin co cabs cfv cc wcel c2 cc wcel c2 cc0 wne c2 cA cB
    cmin co cabs cfv c2 cdiv co cmul co cA cB cmin co cabs cfv wceq cA cr wcel
    cB cr wcel cA cB clt wbr w3a cA cB cmin co cabs cfv c2 divcan2 cA cr wcel
    cB cr wcel cA cB clt wbr w3a cA cB cmin co cc wcel cA cB cmin co cabs cfv
    cr wcel cA cB cmin co cabs cfv cc wcel cA cr wcel cB cr wcel cA cB clt wbr
    w3a cA cr wcel cB cr wcel wa cA cc wcel cB cc wcel wa cA cB cmin co cc wcel
    cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel
    cB cc wcel cA recn cB recn anim12i cA cB subcl 3syl cA cB cmin co abscl cA
    cB cmin co cabs cfv recn 3syl c2 cc wcel cA cr wcel cB cr wcel cA cB clt
    wbr w3a 2cn a1i c2 cc0 wne cA cr wcel cB cr wcel cA cB clt wbr w3a 2ne0 a1i
    syl3anc cA cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co cc wcel cA cB
    cmin co cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cB cmin co cr wcel cA cB
    cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cB resubcl cA
    cB cmin co recn 3syl cA cB cmin co abscl cA cB cmin co cabs cfv recn 3syl
    eqeltrd cA cr wcel cB cr wcel cA cc wcel cA cB clt wbr cA recn 3ad2ant1
    sylanc syl3anc mpbid 3eqtrd c2 cB cmul co cc wcel c2 cA cB cmin co cabs cfv
    c2 cdiv co cmul co cc wcel cA cB caddc co cc wcel c2 cB cmul co c2 cA cB
    cmin co cabs cfv c2 cdiv co cmul co cmin co cA cB caddc co wceq c2 cA cB
    cmin co cabs cfv c2 cdiv co cmul co cA cB caddc co caddc co c2 cB cmul co
    wceq wb cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cB cmul co c2 cA cB cmin
    co cabs cfv c2 cdiv co cmul co cA cB caddc co subadd cA cr wcel cB cr wcel
    cA cB clt wbr w3a cB cr wcel cB cc wcel c2 cB cmul co cc wcel cA cr wcel cB
    cr wcel cA cB clt wbr 3simp2 cB recn c2 cc wcel cB cc wcel c2 cB cmul co cc
    wcel 2cn c2 cB mulcl mpan 3syl cA cr wcel cB cr wcel cA cB clt wbr w3a c2
    cA cB cmin co cabs cfv c2 cdiv co cmul co cA cB cmin co cabs cfv cc cA cB
    cmin co cabs cfv cc wcel c2 cc wcel c2 cc0 wne c2 cA cB cmin co cabs cfv c2
    cdiv co cmul co cA cB cmin co cabs cfv wceq cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA cB cmin co cabs cfv c2 divcan2 cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA cB cmin co cc wcel cA cB cmin co cabs cfv cr wcel cA cB cmin co
    cabs cfv cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr
    wcel wa cA cc wcel cB cc wcel wa cA cB cmin co cc wcel cA cr wcel cB cr
    wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel cB cc wcel cA
    recn cB recn anim12i cA cB subcl 3syl cA cB cmin co abscl cA cB cmin co
    cabs cfv recn 3syl c2 cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn
    a1i c2 cc0 wne cA cr wcel cB cr wcel cA cB clt wbr w3a 2ne0 a1i syl3anc cA
    cr wcel cB cr wcel cA cB clt wbr w3a cA cB cmin co cc wcel cA cB cmin co
    cabs cfv cr wcel cA cB cmin co cabs cfv cc wcel cA cr wcel cB cr wcel cA cB
    clt wbr w3a cA cr wcel cB cr wcel wa cA cB cmin co cr wcel cA cB cmin co cc
    wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cB resubcl cA cB cmin co
    recn 3syl cA cB cmin co abscl cA cB cmin co cabs cfv recn 3syl eqeltrd cA
    cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB
    cc wcel wa cA cB caddc co cc wcel cA cr wcel cB cr wcel cA cB clt wbr
    3simpa cA cr wcel cA cc wcel cB cr wcel cB cc wcel cA recn cB recn anim12i
    cA cB addcl 3syl syl3anc mpbird c2 cc wcel cB cc wcel cA cB cmin co cabs
    cfv c2 cdiv co cc wcel c2 cB cA cB cmin co cabs cfv c2 cdiv co cmin co cmul
    co c2 cB cmul co c2 cA cB cmin co cabs cfv c2 cdiv co cmul co cmin co wceq
    cA cr wcel cB cr wcel cA cB clt wbr w3a c2 cB cA cB cmin co cabs cfv c2
    cdiv co subdi c2 cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn a1i cB
    cr wcel cA cr wcel cB cc wcel cA cB clt wbr cB recn 3ad2ant2 cA cr wcel cB
    cr wcel cA cB clt wbr w3a cA cB cmin co cabs cfv c2 cdiv co crp wcel cA cB
    cmin co cabs cfv c2 cdiv co cr wcel cA cB cmin co cabs cfv c2 cdiv co cc
    wcel cA cB dmse2 cA cB cmin co cabs cfv c2 cdiv co rpre cA cB cmin co cabs
    cfv c2 cdiv co recn 3syl syl3anc cA cB caddc co cc wcel c2 cc wcel c2 cc0
    wne c2 cA cB caddc co c2 cdiv co cmul co cA cB caddc co wceq cA cr wcel cB
    cr wcel cA cB clt wbr w3a cA cB caddc co c2 divcan2 cA cr wcel cB cr wcel
    cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cB cc wcel wa cA cB
    caddc co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA
    cc wcel cB cr wcel cB cc wcel cA recn cB recn anim12i cA cB addcl 3syl c2
    cc wcel cA cr wcel cB cr wcel cA cB clt wbr w3a 2cn a1i c2 cc0 wne cA cr
    wcel cB cr wcel cA cB clt wbr w3a 2ne0 a1i syl3anc 3eqtr4rd cA cB caddc co
    c2 cdiv co cc wcel cB cA cB cmin co cabs cfv c2 cdiv co cmin co cc wcel c2
    cc wcel c2 cA cB caddc co c2 cdiv co cmul co c2 cB cA cB cmin co cabs cfv
    c2 cdiv co cmin co cmul co wceq cA cB caddc co c2 cdiv co cB cA cB cmin co
    cabs cfv c2 cdiv co cmin co wceq wb cA cr wcel cB cr wcel cA cB clt wbr w3a
    cA cB caddc co c2 cdiv co cB cA cB cmin co cabs cfv c2 cdiv co cmin co c2
    2ne0 mulcant2i cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr
    wcel wa cA cc wcel cB cc wcel wa cA cB caddc co c2 cdiv co cc wcel cA cr
    wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cB cr wcel cB cc
    wcel cA recn cB recn anim12i cA cc wcel cB cc wcel wa cA cB caddc co c2
    cdiv co cc wcel cA cB cmin co c2 cdiv co cc wcel cA cB halfaddsubcl pm3.26d
    3syl cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cB cA
    cB cmin co cabs cfv c2 cdiv co cmin co cr wcel cB cA cB cmin co cabs cfv c2
    cdiv co cmin co cc wcel cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cB
    msr3 cB cA cB cmin co cabs cfv c2 cdiv co cmin co recn 3syl c2 cc wcel cA
    cr wcel cB cr wcel cA cB clt wbr w3a 2cn a1i syl3anc mpbid $.
    $( [3-Jan-2008] $) $( [3-Jan-2008] $)

  $( The midpoint of a segment AB of the real line is on the "right" of
     ` A ` . $)
  msra3 $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
    A < ( B - ( ( abs ` ( A - B ) ) / 2 ) ) ) $=
    cA cr wcel cB cr wcel cA cB clt wbr w3a cA cA cB caddc co c2 cdiv co cB cA
    cB cmin co cabs cfv c2 cdiv co cmin co clt cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA c2 cmul co cA cB caddc co clt wbr cA cA cB caddc co c2 cdiv co
    clt wbr cA cr wcel cB cr wcel cA cB clt wbr w3a cA c2 cmul co cA cA caddc
    co cA cB caddc co clt cA cr wcel cB cr wcel cA cB clt wbr w3a cA c2 cmul co
    c2 cA cmul co cA cA caddc co cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr
    wcel cB cr wcel wa cA cc wcel c2 cc wcel wa cA c2 cmul co c2 cA cmul co
    wceq cA cr wcel cB cr wcel cA cB clt wbr 3simpa cA cr wcel cB cr wcel wa cA
    cc wcel c2 cc wcel cA cr wcel cA cc wcel cB cr wcel cA recn adantr 2cn
    jctir cA c2 mulcom 3syl cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel
    cA cc wcel c2 cA cmul co cA cA caddc co wceq cA cr wcel cB cr wcel cA cB
    clt wbr 3simp1 cA recn cA 2times 3syl eqtrd cA cr wcel cB cr wcel cA cB clt
    wbr w3a cA cA caddc co cA cmin co cB clt wbr cA cA caddc co cA cB caddc co
    clt wbr cA cr wcel cB cr wcel cA cB clt wbr w3a cA cA caddc co cA cmin co
    cB clt wbr cA cB clt wbr cA cr wcel cB cr wcel cA cB clt wbr 3simp3 cA cr
    wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cB cr wcel wa cA cc wcel cA cc
    wcel wa cA cA caddc co cA cmin co cB clt wbr cA cB clt wbr wb cA cr wcel cB
    cr wcel cA cB clt wbr 3simpa cA cr wcel cA cc wcel cA cc wcel wa cB cr wcel
    cA cr wcel cA cc wcel cA cc wcel cA recn cA recn jca adantr cA cc wcel cA
    cc wcel wa cA cA caddc co cA cmin co cA cB clt cA cA pncan breq1d 3syl
    mpbird cA cA caddc co cr wcel cA cr wcel cB cr wcel cA cA caddc co cA cmin
    co cB clt wbr cA cA caddc co cA cB caddc co clt wbr wb cA cr wcel cB cr
    wcel cA cB clt wbr w3a cA cA caddc co cA cB ltsubadd2 cA cr wcel cA cr wcel
    cA cA caddc co cr wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cA cA
    readdcl cA cr wcel cB cr wcel cA cB clt wbr 3simp1 cA cr wcel cB cr wcel cA
    cB clt wbr 3simp1 sylanc cA cr wcel cB cr wcel cA cB clt wbr 3simp1 cA cr
    wcel cB cr wcel cA cB clt wbr 3simp2 syl3anc mpbid eqbrtrd cA cr wcel cA cB
    caddc co cr wcel cA c2 cmul co cA cB caddc co clt wbr cA cA cB caddc co c2
    cdiv co clt wbr wb cA cr wcel cB cr wcel cA cB clt wbr w3a cA cr wcel cA cB
    caddc co cr wcel c2 cr wcel cc0 c2 clt wbr wa cA c2 cmul co cA cB caddc co
    clt wbr cA cA cB caddc co c2 cdiv co clt wbr wb c2 cr wcel cc0 c2 clt wbr
    2re 2pos pm3.2i cA cA cB caddc co c2 ltmuldiv mp3an3 cA cr wcel cB cr wcel
    cA cB clt wbr 3simp1 cA cr wcel cB cr wcel cA cB caddc co cr wcel cA cB clt
    wbr cA cB readdcl 3adant3 sylanc mpbid cA cB 2wsms breqtrd $.
    $( [3-Jan-2008] $) $( [3-Jan-2008] $)

  ${ $d A x  $.  $d x y $.
    $( Lemma for ~ iint . $)
    iintlem1 $p |- ( ( A e. RR
                          /\ y e. |^|_ x e. RR+ ( ( A - x ) (,) ( A + x ) ) )
                       -> ( y e. RR -> y = A ) ) $=
      cA cr wcel vy cv vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin
      wcel vy cv cr wcel vy cv cA wceq wi cA cr wcel vy cv cr wcel vy cv vx crp
      cA vx cv cmin co cA vx cv caddc co cioo co ciin wcel vy cv cA wceq cA cr
      wcel vy cv cr wcel vy cv vx crp cA vx cv cmin co cA vx cv caddc co cioo
      co ciin wcel vy cv cA wceq wi vy cv vx crp cA vx cv cmin co cA vx cv
      caddc co cioo co ciin wcel cA cr wcel vy cv cr wcel wa vy cv cA wceq vy
      cv vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin wcel cA cr wcel
      vy cv cr wcel wa vy cv cA wceq wi vy cv vx crp cA vx cv cmin co cA vx cv
      caddc co cioo co ciin wcel vy cv vx crp cA vx cv cmin co cA vx cv caddc
      co cioo co ciin wcel vy cv cA vx cv cmin co cA vx cv caddc co cioo co
      wcel vx crp wral cA cr wcel vy cv cr wcel wa vy cv cA wceq wi vx vy cv
      crp cA vx cv cmin co cA vx cv caddc co cioo co vx crp cA vx cv cmin co cA
      vx cv caddc co cioo co ciin eliin cA cr wcel vy cv cr wcel wa vy cv cA vx
      cv cmin co cA vx cv caddc co cioo co wcel vx crp wral vy cv cA wceq cA cr
      wcel vy cv cr wcel wa vy cv cA wceq vy cv cA vx cv cmin co cA vx cv caddc
      co cioo co wcel vx crp wral cA cr wcel vy cv cr wcel wa vy cv cA wceq wn
      vy cv cA vx cv cmin co cA vx cv caddc co cioo co wcel wn vx crp wrex vy
      cv cA vx cv cmin co cA vx cv caddc co cioo co wcel vx crp wral wn cA cr
      wcel vy cv cr wcel wa vy cv cA wceq wn vy cv cA cmin co cabs cfv c2 cdiv
      co crp wcel vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA vy
      cv cA cmin co cabs cfv c2 cdiv co caddc co cioo co wcel wn wa vy cv cA vx
      cv cmin co cA vx cv caddc co cioo co wcel wn vx crp wrex cA cr wcel vy cv
      cr wcel wa vy cv cA wceq wn vy cv cA cmin co cabs cfv c2 cdiv co crp wcel
      vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co cioo co wcel wn wa cA cr wcel vy cv cr wcel
      wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel vy
      cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co cioo co wcel wn cA cr wcel vy cv cr wcel wa
      vy cv cA wceq wn wa vy cv cA cmin co cabs cfv crp wcel c2 crp wcel wa vy
      cv cA cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel vy cv cr wcel wa vy
      cv cA wceq wn wa vy cv cA cmin co cabs cfv crp wcel c2 crp wcel vy cv cA
      cmin co cc wcel vy cv cA cmin co cc0 wne vy cv cA cmin co cabs cfv crp
      wcel cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co
      absrpcl cA cr wcel vy cv cr wcel wa vy cv cA cmin co cc wcel vy cv cA
      wceq wn cA cr wcel vy cv cr wcel wa vy cv cA cmin co vy cv cr wcel cA cr
      wcel vy cv cA cmin co cr wcel vy cv cA resubcl ancoms recnd adantr cA cr
      wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cc0 wceq wn vy
      cv cA cmin co cc0 wne cA cr wcel vy cv cr wcel wa vy cv cA wceq wn vy cv
      cA cmin co cc0 wceq wn cA cr wcel vy cv cr wcel wa vy cv cA cmin co cc0
      wceq vy cv cA wceq cA cr wcel vy cv cr wcel wa vy cv cA cmin co cc0 wceq
      vy cv cA wceq cA cr wcel vy cv cr wcel wa vy cv cc wcel cA cc wcel wa vy
      cv cA cmin co cc0 wceq vy cv cA wceq wb vy cv cr wcel cA cr wcel vy cv cc
      wcel cA cc wcel wa vy cv cr wcel vy cv cc wcel cA cr wcel cA cc wcel vy
      cv recn cA recn anim12i ancoms vy cv cA subeq0 syl biimpd con3d imp vy cv
      cA cmin co cc0 df-ne sylibr sylanc c2 2re 2pos elrpii jctir vy cv cA cmin
      co cabs cfv c2 rpdivcl syl cA cr wcel vy cv cr wcel wa vy cv cA wceq wn
      wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel vy cv cA vy cv cA cmin
      co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co cabs cfv c2 cdiv co
      caddc co cioo co wcel wn cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa
      vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa vy cv cA vy cv cA cmin
      co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co cabs cfv c2 cdiv co
      caddc co cioo co wcel vy cv cxr wcel cA vy cv cA cmin co cabs cfv c2 cdiv
      co cmin co vy cv clt wbr vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co
      caddc co clt wbr w3a vy cv cA cmin co cc0 clt wbr cA cr wcel vy cv cr
      wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel
      wa vy cv cxr wcel cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co vy cv
      clt wbr vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co clt wbr
      w3a wn vy cv cA cmin co cc0 clt wbr cA cr wcel vy cv cr wcel wa vy cv cA
      wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa wa cA vy cv
      cA cmin co cabs cfv c2 cdiv co cmin co vy cv clt wbr vy cv cxr wcel vy cv
      cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co clt wbr vy cv cA cmin co
      cc0 clt wbr cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin
      co cabs cfv c2 cdiv co crp wcel wa wa vy cv cA vy cv cA cmin co cabs cfv
      c2 cdiv co cmin co cle wbr cA vy cv cA cmin co cabs cfv c2 cdiv co cmin
      co vy cv clt wbr wn vy cv cA cmin co cc0 clt wbr cA cr wcel vy cv cr wcel
      wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa
      wa vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cle wbr vy cv cA
      vy cv cA cmin co cabs cfv c2 cdiv co cmin co clt wbr vy cv cA vy cv cA
      cmin co cabs cfv c2 cdiv co cmin co wceq wo vy cv cA cmin co cc0 clt wbr
      cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv
      c2 cdiv co crp wcel wa wa vy cv cr wcel cA cr wcel vy cv cA clt wbr w3a
      vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co clt wbr vy cv cA vy
      cv cA cmin co cabs cfv c2 cdiv co cmin co clt wbr vy cv cA vy cv cA cmin
      co cabs cfv c2 cdiv co cmin co wceq wo vy cv cA cmin co cc0 clt wbr cA cr
      wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2
      cdiv co crp wcel wa wa vy cv cr wcel cA cr wcel vy cv cA clt wbr cA cr
      wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cr wcel vy cv cA cmin co
      cc0 clt wbr vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel vy
      cv cr wcel vy cv cA wceq wn simplr ad2antrl cA cr wcel vy cv cr wcel wa
      vy cv cA wceq wn wa cA cr wcel vy cv cA cmin co cc0 clt wbr vy cv cA cmin
      co cabs cfv c2 cdiv co crp wcel cA cr wcel vy cv cr wcel vy cv cA wceq wn
      simpll ad2antrl cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA
      cmin co cabs cfv c2 cdiv co crp wcel wa vy cv cA cmin co cc0 clt wbr vy
      cv cA clt wbr cA cr wcel vy cv cr wcel wa vy cv cA cmin co cc0 clt wbr vy
      cv cA clt wbr wi vy cv cA wceq wn vy cv cA cmin co cabs cfv c2 cdiv co
      crp wcel cA cr wcel vy cv cr wcel vy cv cA cmin co cc0 clt wbr vy cv cA
      clt wbr wi cc0 cr wcel cA cr wcel vy cv cr wcel vy cv cA cmin co cc0 clt
      wbr vy cv cA clt wbr wi wi wi 0re vy cv cr wcel cA cr wcel cc0 cr wcel vy
      cv cA cmin co cc0 clt wbr vy cv cA clt wbr wi vy cv cr wcel cA cr wcel
      cc0 cr wcel vy cv cA cmin co cc0 clt wbr vy cv cA clt wbr wi vy cv cr
      wcel cA cr wcel cc0 cr wcel w3a vy cv cA cmin co cc0 clt wbr vy cv cA clt
      wbr vy cv cr wcel cA cr wcel cc0 cr wcel w3a vy cv cA cmin co cc0 clt wbr
      vy cv cA cc0 caddc co clt wbr vy cv cA clt wbr vy cv cA cc0 ltsubadd2 vy
      cv cr wcel cA cr wcel cc0 cr wcel w3a cA cc0 caddc co cA vy cv clt vy cv
      cr wcel cA cr wcel cc0 cr wcel w3a cA cr wcel cA cc wcel cA cc0 caddc co
      cA wceq vy cv cr wcel cA cr wcel cc0 cr wcel 3simp2 cA recn cA addid1
      3syl breq2d bitrd biimpd 3exp com13 ax-mp imp ad2antrr impcom 3jca vy cv
      cA msra3 vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co clt wbr vy
      cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co wceq orc 3syl vy cv cr
      wcel cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cr wcel vy cv cA vy
      cv cA cmin co cabs cfv c2 cdiv co cmin co cle wbr vy cv cA vy cv cA cmin
      co cabs cfv c2 cdiv co cmin co clt wbr vy cv cA vy cv cA cmin co cabs cfv
      c2 cdiv co cmin co wceq wo wb vy cv cA cmin co cc0 clt wbr cA cr wcel vy
      cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co
      crp wcel wa wa vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co
      leloe cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cr wcel vy cv
      cA cmin co cc0 clt wbr vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA
      cr wcel vy cv cr wcel vy cv cA wceq wn simplr ad2antrl vy cv cA cmin co
      cc0 clt wbr cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin
      co cabs cfv c2 cdiv co crp wcel wa wa vy cv cr wcel cA cr wcel wa cA vy
      cv cA cmin co cabs cfv c2 cdiv co cmin co cr wcel cA cr wcel vy cv cr
      wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel
      wa vy cv cr wcel cA cr wcel wa vy cv cA cmin co cc0 clt wbr cA cr wcel vy
      cv cr wcel wa vy cv cr wcel cA cr wcel wa vy cv cA wceq wn vy cv cA cmin
      co cabs cfv c2 cdiv co crp wcel cA cr wcel vy cv cr wcel pm3.22 ad2antrr
      adantl vy cv cA msr3 syl sylanc mpbird vy cv cxr wcel cA vy cv cA cmin co
      cabs cfv c2 cdiv co cmin co cxr wcel vy cv cA vy cv cA cmin co cabs cfv
      c2 cdiv co cmin co cle wbr cA vy cv cA cmin co cabs cfv c2 cdiv co cmin
      co vy cv clt wbr wn wb vy cv cA cmin co cc0 clt wbr cA cr wcel vy cv cr
      wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel
      wa wa vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co xrlenlt cA cr
      wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2
      cdiv co crp wcel wa vy cv cxr wcel vy cv cA cmin co cc0 clt wbr cA cr
      wcel vy cv cr wcel wa vy cv cxr wcel vy cv cA wceq wn vy cv cA cmin co
      cabs cfv c2 cdiv co crp wcel vy cv cr wcel vy cv cxr wcel cA cr wcel vy
      cv rexr adantl ad2antrr adantl cA cr wcel vy cv cr wcel wa vy cv cA wceq
      wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa cA vy cv cA cmin
      co cabs cfv c2 cdiv co cmin co cxr wcel vy cv cA cmin co cc0 clt wbr cA
      cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2
      cdiv co crp wcel wa vy cv cr wcel cA cr wcel wa cA vy cv cA cmin co cabs
      cfv c2 cdiv co cmin co cr wcel cA vy cv cA cmin co cabs cfv c2 cdiv co
      cmin co cxr wcel cA cr wcel vy cv cr wcel wa vy cv cr wcel cA cr wcel wa
      vy cv cA wceq wn vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel
      vy cv cr wcel pm3.22 ad2antrr vy cv cA msr3 cA vy cv cA cmin co cabs cfv
      c2 cdiv co cmin co rexr 3syl adantl sylanc mpbid intn3an2d vy cv cA cmin
      co cc0 clt wbr wn cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv
      cA cmin co cabs cfv c2 cdiv co crp wcel wa wa vy cv cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co clt wbr vy cv cxr wcel cA vy cv cA cmin co
      cabs cfv c2 cdiv co cmin co vy cv clt wbr vy cv cA cmin co cc0 clt wbr wn
      cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv
      c2 cdiv co crp wcel wa wa cA vy cv cA cmin co cabs cfv c2 cdiv co caddc
      co vy cv cle wbr vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co
      clt wbr wn vy cv cA cmin co cc0 clt wbr wn cA cr wcel vy cv cr wcel wa vy
      cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa wa cA
      vy cv cA cmin co cabs cfv c2 cdiv co caddc co vy cv cle wbr cA vy cv cA
      cmin co cabs cfv c2 cdiv co caddc co vy cv clt wbr cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co vy cv wceq wo vy cv cA cmin co cc0 clt wbr
      wn cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs
      cfv c2 cdiv co crp wcel wa wa cA cr wcel vy cv cr wcel cA vy cv clt wbr
      w3a cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co vy cv clt wbr cA vy
      cv cA cmin co cabs cfv c2 cdiv co caddc co vy cv clt wbr cA vy cv cA cmin
      co cabs cfv c2 cdiv co caddc co vy cv wceq wo vy cv cA cmin co cc0 clt
      wbr wn cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co
      cabs cfv c2 cdiv co crp wcel wa wa cA cr wcel vy cv cr wcel cA vy cv clt
      wbr cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa cA cr wcel vy cv cA
      cmin co cc0 clt wbr wn vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA
      cr wcel vy cv cr wcel vy cv cA wceq wn simpll ad2antrl cA cr wcel vy cv
      cr wcel wa vy cv cA wceq wn wa vy cv cr wcel vy cv cA cmin co cc0 clt wbr
      wn vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel vy cv cr wcel
      vy cv cA wceq wn simplr ad2antrl cA cr wcel vy cv cr wcel wa vy cv cA
      wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa vy cv cA cmin
      co cc0 clt wbr wn cA vy cv clt wbr cA cr wcel vy cv cr wcel wa vy cv cA
      wceq wn wa vy cv cA cmin co cc0 clt wbr wn cA vy cv clt wbr wi vy cv cA
      cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel vy cv cr wcel wa vy cv cA
      wceq wn wa vy cv cA cmin co cc0 clt wbr wn cc0 vy cv cA cmin co cle wbr
      cA vy cv clt wbr cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa cc0 cxr
      wcel vy cv cA cmin co cxr wcel wa cc0 vy cv cA cmin co cle wbr vy cv cA
      cmin co cc0 clt wbr wn wb cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa
      vy cv cA cmin co cxr wcel cc0 cxr wcel cA cr wcel vy cv cr wcel wa vy cv
      cA cmin co cxr wcel vy cv cA wceq wn vy cv cr wcel cA cr wcel vy cv cA
      cmin co cxr wcel vy cv cr wcel cA cr wcel wa vy cv cA cmin co cr wcel vy
      cv cA cmin co cxr wcel vy cv cA resubcl vy cv cA cmin co rexr syl ancoms
      adantr cc0 cr wcel cc0 cxr wcel 0re cc0 rexr ax-mp jctil cc0 vy cv cA
      cmin co xrlenlt syl cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa cc0
      vy cv cA cmin co cle wbr cA vy cv cle wbr cA vy cv clt wbr cA cr wcel vy
      cv cr wcel wa cc0 vy cv cA cmin co cle wbr cA vy cv cle wbr wb vy cv cA
      wceq wn vy cv cr wcel cA cr wcel cc0 vy cv cA cmin co cle wbr cA vy cv
      cle wbr wb vy cv cA subge0 ancoms adantr cA cr wcel vy cv cr wcel wa vy
      cv cA wceq wn cA vy cv cle wbr cA vy cv clt wbr wi cA cr wcel vy cv cr
      wcel wa vy cv cA wne cA vy cv cle wbr cA vy cv clt wbr wi vy cv cA wceq
      wn cA cr wcel vy cv cr wcel wa vy cv cA wne cA vy cv cle wbr cA vy cv clt
      wbr vy cv cA wne cA vy cv cle wbr wa cA cr wcel vy cv cr wcel wa cA vy cv
      clt wbr cA vy cv cle wbr vy cv cA wne cA cr wcel vy cv cr wcel wa cA vy
      cv clt wbr wi cA cr wcel vy cv cr wcel wa cA vy cv clt wbr cA vy cv cle
      wbr vy cv cA wne wa cA vy cv ltlen biimprcd ancoms com12 exp3a vy cv cA
      df-ne syl5ibr imp sylbid sylbird adantr impcom 3jca cA vy cv mslb1 cA vy
      cv cA cmin co cabs cfv c2 cdiv co caddc co vy cv clt wbr cA vy cv cA cmin
      co cabs cfv c2 cdiv co caddc co vy cv wceq orc 3syl cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co cr wcel vy cv cr wcel cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co vy cv cle wbr cA vy cv cA cmin co cabs cfv
      c2 cdiv co caddc co vy cv clt wbr cA vy cv cA cmin co cabs cfv c2 cdiv co
      caddc co vy cv wceq wo wb vy cv cA cmin co cc0 clt wbr wn cA cr wcel vy
      cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co
      crp wcel wa wa cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co vy cv
      leloe vy cv cA cmin co cc0 clt wbr wn cA cr wcel vy cv cr wcel wa vy cv
      cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa wa cA cr
      wcel vy cv cr wcel wa cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co cr
      wcel cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co
      cabs cfv c2 cdiv co crp wcel wa cA cr wcel vy cv cr wcel wa vy cv cA cmin
      co cc0 clt wbr wn cA cr wcel vy cv cr wcel wa vy cv cA wceq wn vy cv cA
      cmin co cabs cfv c2 cdiv co crp wcel simpll adantl cA vy cv msr4 syl cA
      cr wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cr wcel vy cv cA cmin
      co cc0 clt wbr wn vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA cr
      wcel vy cv cr wcel vy cv cA wceq wn simplr ad2antrl sylanc mpbird vy cv
      cA cmin co cc0 clt wbr wn cA cr wcel vy cv cr wcel wa vy cv cA wceq wn wa
      vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa wa cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co cxr wcel vy cv cxr wcel wa cA vy cv cA cmin
      co cabs cfv c2 cdiv co caddc co vy cv cle wbr vy cv cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co clt wbr wn wb cA cr wcel vy cv cr wcel wa vy
      cv cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa cA vy
      cv cA cmin co cabs cfv c2 cdiv co caddc co cxr wcel vy cv cxr wcel wa vy
      cv cA cmin co cc0 clt wbr wn cA cr wcel vy cv cr wcel wa vy cv cA cmin co
      cabs cfv c2 cdiv co crp wcel cA vy cv cA cmin co cabs cfv c2 cdiv co
      caddc co cxr wcel vy cv cxr wcel wa vy cv cA wceq wn cA cr wcel vy cv cr
      wcel wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa cA vy cv cA cmin
      co cabs cfv c2 cdiv co caddc co cxr wcel vy cv cxr wcel cA cr wcel vy cv
      cr wcel wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA vy cv cA cmin
      co cabs cfv c2 cdiv co caddc co cxr wcel cA cr wcel vy cv cA cmin co cabs
      cfv c2 cdiv co crp wcel cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co
      cxr wcel wi vy cv cr wcel cA cr wcel vy cv cA cmin co cabs cfv c2 cdiv co
      cr wcel cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co cxr wcel vy cv
      cA cmin co cabs cfv c2 cdiv co crp wcel cA cr wcel vy cv cA cmin co cabs
      cfv c2 cdiv co cr wcel cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co
      cxr wcel cA cr wcel vy cv cA cmin co cabs cfv c2 cdiv co cr wcel wa cA vy
      cv cA cmin co cabs cfv c2 cdiv co caddc co cr wcel cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co cxr wcel cA vy cv cA cmin co cabs cfv c2
      cdiv co readdcl cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co rexr syl
      ex vy cv cA cmin co cabs cfv c2 cdiv co rpre syl5 adantr imp vy cv cr
      wcel vy cv cxr wcel cA cr wcel vy cv cA cmin co cabs cfv c2 cdiv co crp
      wcel vy cv rexr ad2antlr jca adantlr adantl cA vy cv cA cmin co cabs cfv
      c2 cdiv co caddc co vy cv xrlenlt syl mpbid intn3an3d pm2.61ian cA cr
      wcel vy cv cr wcel wa vy cv cA wceq wn wa vy cv cA cmin co cabs cfv c2
      cdiv co crp wcel wa cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cxr
      wcel cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co cxr wcel wa vy cv
      cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co cabs
      cfv c2 cdiv co caddc co cioo co wcel vy cv cxr wcel cA vy cv cA cmin co
      cabs cfv c2 cdiv co cmin co vy cv clt wbr vy cv cA vy cv cA cmin co cabs
      cfv c2 cdiv co caddc co clt wbr w3a wb cA cr wcel vy cv cr wcel wa vy cv
      cA wceq wn wa vy cv cA cmin co cabs cfv c2 cdiv co crp wcel cA vy cv cA
      cmin co cabs cfv c2 cdiv co cmin co cxr wcel cA vy cv cA cmin co cabs cfv
      c2 cdiv co caddc co cxr wcel wa cA cr wcel vy cv cA cmin co cabs cfv c2
      cdiv co crp wcel cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cxr wcel
      cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co cxr wcel wa wi vy cv cr
      wcel vy cv cA wceq wn cA cr wcel vy cv cA cmin co cabs cfv c2 cdiv co crp
      wcel cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cxr wcel cA vy cv cA
      cmin co cabs cfv c2 cdiv co caddc co cxr wcel wa cA cr wcel vy cv cA cmin
      co cabs cfv c2 cdiv co crp wcel wa cA vy cv cA cmin co cabs cfv c2 cdiv
      co cmin co cxr wcel cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co cxr
      wcel cA cr wcel vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa cA cr
      wcel vy cv cA cmin co cabs cfv c2 cdiv co cr wcel wa cA vy cv cA cmin co
      cabs cfv c2 cdiv co cmin co cr wcel cA vy cv cA cmin co cabs cfv c2 cdiv
      co cmin co cxr wcel vy cv cA cmin co cabs cfv c2 cdiv co crp wcel vy cv
      cA cmin co cabs cfv c2 cdiv co cr wcel cA cr wcel vy cv cA cmin co cabs
      cfv c2 cdiv co rpre anim2i cA vy cv cA cmin co cabs cfv c2 cdiv co
      resubcl cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co rexr 3syl cA cr
      wcel vy cv cA cmin co cabs cfv c2 cdiv co crp wcel wa cA cr wcel vy cv cA
      cmin co cabs cfv c2 cdiv co cr wcel wa cA vy cv cA cmin co cabs cfv c2
      cdiv co caddc co cr wcel cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co
      cxr wcel vy cv cA cmin co cabs cfv c2 cdiv co crp wcel vy cv cA cmin co
      cabs cfv c2 cdiv co cr wcel cA cr wcel vy cv cA cmin co cabs cfv c2 cdiv
      co rpre anim2i cA vy cv cA cmin co cabs cfv c2 cdiv co readdcl cA vy cv
      cA cmin co cabs cfv c2 cdiv co caddc co rexr 3syl jca ex ad2antrr imp cA
      vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co cabs cfv
      c2 cdiv co caddc co vy cv elioo1 syl mtbird ex jcai ex vy cv cA vx cv
      cmin co cA vx cv caddc co cioo co wcel wn vy cv cA vy cv cA cmin co cabs
      cfv c2 cdiv co cmin co cA vy cv cA cmin co cabs cfv c2 cdiv co caddc co
      cioo co wcel wn vx vy cv cA cmin co cabs cfv c2 cdiv co crp vx cv vy cv
      cA cmin co cabs cfv c2 cdiv co wceq vy cv cA vx cv cmin co cA vx cv caddc
      co cioo co wcel vy cv cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA
      vy cv cA cmin co cabs cfv c2 cdiv co caddc co cioo co wcel vx cv vy cv cA
      cmin co cabs cfv c2 cdiv co wceq cA vx cv cmin co cA vx cv caddc co cioo
      co cA vy cv cA cmin co cabs cfv c2 cdiv co cmin co cA vy cv cA cmin co
      cabs cfv c2 cdiv co caddc co cioo co vy cv vx cv vy cv cA cmin co cabs
      cfv c2 cdiv co wceq cA vx cv cmin co cA vy cv cA cmin co cabs cfv c2 cdiv
      co cmin co cA vx cv caddc co cA vy cv cA cmin co cabs cfv c2 cdiv co
      caddc co cioo vx cv vy cv cA cmin co cabs cfv c2 cdiv co cA cmin opreq2
      vx cv vy cv cA cmin co cabs cfv c2 cdiv co cA caddc opreq2 opreq12d
      eleq2d notbid rcla4ev syl6 vy cv cA vx cv cmin co cA vx cv caddc co cioo
      co wcel vx crp rexnal syl6ib con4d com12 syl6bi pm2.43i com12 ex com23
      imp $.
      $( [3-Jan-2008] $) $( [27-Dec-2007] $)
  $}

  ${ $d A x $.
    $( Lemma for ~ iint . $)
    iintlem2 $p |- (  y e. |^|_ x e. RR+ ( ( A - x ) (,) ( A + x ) )
                    -> y e. RR ) $=
      vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin cr vy cv cA vx cv
      cmin co cA vx cv caddc co cioo co cr wss vx crp wrex vx crp cA vx cv cmin
      co cA vx cv caddc co cioo co ciin cr wss c1 crp wcel cA c1 cmin co cA c1
      caddc co cioo co cr wss cA vx cv cmin co cA vx cv caddc co cioo co cr wss
      vx crp wrex 1rp cA c1 cmin co cA c1 caddc co ioossre cA vx cv cmin co cA
      vx cv caddc co cioo co cr wss cA c1 cmin co cA c1 caddc co cioo co cr wss
      vx c1 crp vx cv c1 wceq cA vx cv cmin co cA vx cv caddc co cioo co cA c1
      cmin co cA c1 caddc co cioo co cr vx cv c1 wceq cA vx cv cmin co cA c1
      cmin co cA vx cv caddc co cA c1 caddc co cioo vx cv c1 cA cmin opreq2 vx
      cv c1 cA caddc opreq2 opreq12d sseq1d rcla4ev mp2an vx crp cA vx cv cmin
      co cA vx cv caddc co cioo co cr iinss ax-mp sseli $.
      $( [3-Jan-2008] $) $( [23-Dec-2007] $)
  $}


  ${ $d A x y $.
    $( Indexed intersection of a set of open intervals centered on ` A ` .
       This theorem is a rough justification for taking finite intersections
       in the definition of a topology. If we consider we are in the
       standard topology of ` RR ` this theorem means a non finite
       intersection of open sets can result in a closed set. $)
    iint $p |- ( A e. RR -> |^|_ x e. RR+ ( ( A - x ) (,) ( A + x ) ) = { A } )
         $=
      cA cr wcel vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin vx cv
      cA wceq vx cr crab cA csn cA cr wcel vy vx crp cA vx cv cmin co cA vx cv
      caddc co cioo co ciin vx cv cA wceq vx cr crab cA cr wcel vy cv vx crp cA
      vx cv cmin co cA vx cv caddc co cioo co ciin wcel vy cv cr wcel vy cv cA
      wceq wa vy cv vx cv cA wceq vx cr crab wcel cA cr wcel vy cv vx crp cA vx
      cv cmin co cA vx cv caddc co cioo co ciin wcel vy cv cr wcel vy cv cA
      wceq wa cA cr wcel vy cv vx crp cA vx cv cmin co cA vx cv caddc co cioo
      co ciin wcel vy cv cr wcel vy cv cA wceq wa cA cr wcel vy cv vx crp cA vx
      cv cmin co cA vx cv caddc co cioo co ciin wcel wa vy cv cr wcel vy cv cA
      wceq vy cv vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin wcel vy
      cv cr wcel cA cr wcel vx vy cA iintlem2 adantl vx vy cA iintlem1 jcai ex
      vy cv cr wcel vy cv cA wceq wa cA cr wcel vy cv vx crp cA vx cv cmin co
      cA vx cv caddc co cioo co ciin wcel vy cv cA wceq cA cr wcel vy cv vx crp
      cA vx cv cmin co cA vx cv caddc co cioo co ciin wcel wi vy cv cr wcel vy
      cv cA wceq vy cv vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin
      wcel cA vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin wcel cA cr
      wcel vy cv cA vx crp cA vx cv cmin co cA vx cv caddc co cioo co ciin
      eleq1 cA cr wcel cA vx crp cA vx cv cmin co cA vx cv caddc co cioo co
      ciin wcel cA cA vx cv cmin co cA vx cv caddc co cioo co wcel vx crp wral
      cA cr wcel cA cA vx cv cmin co cA vx cv caddc co cioo co wcel vx crp cA
      cr wcel vx cv crp wcel wa cA cA vx cv cmin co cA vx cv caddc co cioo co
      wcel cA vx cv cmin co cxr wcel cA vx cv caddc co cxr wcel cA cxr wcel w3a
      cA vx cv cmin co cA clt wbr cA cA vx cv caddc co clt wbr wa wa cA cr wcel
      vx cv crp wcel wa cA vx cv cmin co cxr wcel cA vx cv caddc co cxr wcel cA
      cxr wcel w3a cA vx cv cmin co cA clt wbr cA cA vx cv caddc co clt wbr wa
      cA cr wcel vx cv crp wcel wa cA vx cv cmin co cxr wcel cA vx cv caddc co
      cxr wcel cA cxr wcel cA cr wcel vx cv crp wcel wa cA vx cv cmin co cr
      wcel cA vx cv cmin co cxr wcel cA cr wcel vx cv cr wcel cA vx cv cmin co
      cr wcel vx cv crp wcel cA vx cv resubcl vx cv rpre sylan2 cA vx cv cmin
      co rexr syl cA cr wcel vx cv crp wcel wa cA vx cv caddc co cr wcel cA vx
      cv caddc co cxr wcel cA cr wcel vx cv cr wcel cA vx cv caddc co cr wcel
      vx cv crp wcel cA vx cv readdcl vx cv rpre sylan2 cA vx cv caddc co rexr
      syl cA cr wcel cA cxr wcel vx cv crp wcel cA rexr adantr 3jca cA cr wcel
      vx cv crp wcel wa cA vx cv cmin co cA clt wbr cA cA vx cv caddc co clt
      wbr cA vx cv ltsubpostb cA vx cv ltaddpos2tb jca jca cA cr wcel vx cv crp
      wcel wa cA vx cv caddc co cr wcel cA cA vx cv cmin co cA vx cv caddc co
      cioo co wcel cA vx cv cmin co cxr wcel cA vx cv caddc co cxr wcel cA cxr
      wcel w3a cA vx cv cmin co cA clt wbr cA cA vx cv caddc co clt wbr wa wa
      wb cA cr wcel vx cv cr wcel cA vx cv caddc co cr wcel vx cv crp wcel cA
      vx cv readdcl vx cv rpre sylan2 cA vx cv cmin co cA vx cv caddc co cA cr
      elioo3g syl mpbird r19.21aiva vx cA crp cA vx cv cmin co cA vx cv caddc
      co cioo co cr eliin mpbird syl5bir adantl com12 impbid vx cv cA wceq vy
      cv cA wceq vx vy cv cr vx cv vy cv cA eqeq1 elrab syl6bbr eqrdv vx cr cA
      rabsn eqtrd $.
      $( [3-Jan-2008] $) $( [27-Dec-2007] $)
  $}

  ${ $d A x $.
    trdom.1 $e |- F = ( x e. RR |-> ( x + A ) ) $.
    $( Domain of a translation. $)
    trdom $p |- ( A e. RR -> dom F = RR ) $=
      cA cr wcel vx cv cA caddc co cvv wcel vx cr wral cF cdm cr wceq cA cr
      wcel vx cv cA caddc co cvv wcel vx cr vx cv cr wcel cA cr wcel vx cv cA
      caddc co cvv wcel vx cv cr wcel cA cr wcel wa vx cv cA caddc co cr wcel
      vx cv cA caddc co cvv wcel vx cv cA readdcl vx cv cA caddc co cr elisset
      syl ancoms r19.21aiva vx cr vx cv cA caddc co cF trdom.1 cmpdom sylib $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${ $d A x y $.
    trran.1 $e |- F = ( x e. RR |-> ( x + A ) ) $.
    $( Range of a translation. $)
    trran $p |- ( A e. RR -> ran F = RR ) $=
      cA cr wcel vy cv vx cv cA caddc co wceq vx cr wrex vy cab cr cF crn cA cr
      wcel vy cv vx cv cA caddc co wceq vx cr wrex vy cr cA cr wcel vy cv vx cv
      cA caddc co wceq vx cr wrex vy cv cr wcel cA cr wcel vy cv vx cv cA caddc
      co wceq vy cv cr wcel vx cr vx cv cr wcel cA cr wcel vy cv vx cv cA caddc
      co wceq vy cv cr wcel wi vy cv vx cv cA caddc co wceq vy cv cr wcel vx cv
      cA caddc co cr wcel vx cv cr wcel cA cr wcel wa vy cv vx cv cA caddc co
      cr eleq1 vx cv cA readdcl syl5cbir expcom r19.23adv vy cv cr wcel cA cr
      wcel vy cv vx cv cA caddc co wceq vx cr wrex vy cv cA cmin co cr wcel vy
      cv vy cv cA cmin co cA caddc co wceq vy cv vx cv cA caddc co wceq vx cr
      wrex vy cv cr wcel cA cr wcel wa vy cv vx cv cA caddc co wceq vy cv vy cv
      cA cmin co cA caddc co wceq vx vy cv cA cmin co cr vx cv vy cv cA cmin co
      wceq vx cv cA caddc co vy cv cA cmin co cA caddc co vy cv vx cv vy cv cA
      cmin co cA caddc opreq1 eqeq2d rcla4ev vy cv cA resubcl vy cv cr wcel cA
      cr wcel wa vy cv cA cmin co cA caddc co vy cv vy cv cc wcel cA cc wcel vy
      cv cA cmin co cA caddc co vy cv wceq vy cv cr wcel cA cr wcel vy cv cA
      npcan vy cv recn cA recn syl2an eqcomd sylanc expcom impbid abbi1dv vx vy
      cr vx cv cA caddc co cF trran.1 cmpran syl5eq $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}



  ${ $d A u v x y $.  $d F x y $.
    trnij.1 $e |- F = ( x e. RR |-> ( x + A ) ) $.
    $( A translation is 1-1-onto. $)
    trnij $p |- ( A e. RR -> F : RR -1-1-onto-> RR ) $=
      cA cr wcel cr cr cF wf1 cr cr cF wfo wa cr cr cF wf1o cA cr wcel cr cr cF
      wf1 cr cr cF wfo cA cr wcel cr cr cF wf vx cv cF cfv vy cv cF cfv wceq vx
      vy weq wi vy cr wral vx cr wral wa cr cr cF wf1 cA cr wcel cr cr cF wf vx
      cv cF cfv vy cv cF cfv wceq vx vy weq wi vy cr wral vx cr wral cA cr wcel
      cF cr wfn cF crn cr wss wa cr cr cF wf cF cr wfn cF crn cr wceq cF cr wfn
      cF crn cr wss wa cA cr wcel cF crn cr wceq cF crn cr wss cF cr wfn cF crn
      cr eqimss anim2i cA cr wcel cF wfun cF cdm cr wceq wa cF cr wfn cA cr
      wcel cF cdm cr wceq cF wfun vx cA cF trnij.1 trdom vx cr vx cv cA caddc
      co cF trnij.1 cmpfun jctil cF cr df-fn sylibr vx cA cF trnij.1 trran
      sylanc cr cr cF df-f sylibr cA cr wcel vx cv cF cfv vy cv cF cfv wceq vx
      vy weq wi vx vy cr cr cA cr wcel vx cv cr wcel vy cv cr wcel wa vx cv cF
      cfv vy cv cF cfv wceq vx vy weq wi cA cr wcel vx cv cr wcel vy cv cr wcel
      wa wa vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel wa vx cv cF cfv
      vy cv cF cfv wceq vx vy weq wi cA cr wcel vx cv cr wcel vy cv cr wcel wa
      vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel wa cA cr wcel vx cv
      cr wcel vx cv cA caddc co cr wcel vy cv cr wcel vy cv cA caddc co cr wcel
      vx cv cr wcel cA cr wcel vx cv cA caddc co cr wcel vx cv cA readdcl
      expcom vy cv cr wcel cA cr wcel vy cv cA caddc co cr wcel vy cv cA
      readdcl expcom anim12d imp cA cr wcel vx cv cr wcel vy cv cr wcel wa wa
      vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel wa vx cv cF cfv vy cv
      cF cfv wceq vx vy weq cA cr wcel vx cv cr wcel vy cv cr wcel wa wa vx cv
      cA caddc co cr wcel vy cv cA caddc co cr wcel wa wa vx cv cF cfv vy cv cF
      cfv wceq wa vx cv cA caddc co vy cv cA caddc co wceq vx vy weq cA cr wcel
      vx cv cr wcel vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy cv cA
      caddc co cr wcel wa wa vx cv cF cfv vy cv cF cfv wceq wa vx cv vx cr vx
      cv cA caddc co cmpt cfv vy cv vy cr vy cv cA caddc co cmpt cfv vx cv cA
      caddc co vy cv cA caddc co cA cr wcel vx cv cr wcel vy cv cr wcel wa wa
      vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel wa wa vx cv cF cfv vy
      cv cF cfv wceq wa vx cv cF cfv vy cv cF cfv vx cv vx cr vx cv cA caddc co
      cmpt cfv vy cv vy cr vy cv cA caddc co cmpt cfv cA cr wcel vx cv cr wcel
      vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel
      wa wa vx cv cF cfv vy cv cF cfv wceq pm3.27 vx cv cF vx cr vx cv cA caddc
      co cmpt trnij.1 fveq1i vy cv cF vy cr vy cv cA caddc co cmpt cF vy cv cr
      wcel vv cv vy cv cA caddc co wceq wa vy vv copab vy cr vy cv cA caddc co
      cmpt cF vx cr vx cv cA caddc co cmpt vx cv cr wcel vu cv vx cv cA caddc
      co wceq wa vx vu copab vy cv cr wcel vv cv vy cv cA caddc co wceq wa vy
      vv copab trnij.1 vx vu cr vx cv cA caddc co df-mpt vx cv cr wcel vu cv vx
      cv cA caddc co wceq wa vy cv cr wcel vv cv vy cv cA caddc co wceq wa vx
      vu vy vv vx vy weq vu vv weq wa vx cv cr wcel vy cv cr wcel vu cv vx cv
      cA caddc co wceq vv cv vy cv cA caddc co wceq vx vy weq vx cv cr wcel vy
      cv cr wcel wb vu vv weq vx cv vy cv cr eleq1 adantr vu vv weq vu cv vx cv
      cA caddc co wceq vv cv vx cv cA caddc co wceq vx vy weq vv cv vy cv cA
      caddc co wceq vu cv vv cv vx cv cA caddc co eqeq1 vx vy weq vx cv cA
      caddc co vy cv cA caddc co vv cv vx cv vy cv cA caddc opreq1 eqeq2d
      sylan9bbr anbi12d cbvopabv 3eqtri vy vv cr vy cv cA caddc co df-mpt
      eqtr4i fveq1i 3eqtr3g vx cv cr wcel vx cv cA caddc co cr wcel vx cv vx cr
      vx cv cA caddc co cmpt cfv vx cv cA caddc co wceq cA cr wcel vx cv cr
      wcel vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy cv cA caddc co cr
      wcel wa wa vx cv cF cfv vy cv cF cfv wceq wa vx cr vx cv cA caddc co cr
      vx cr vx cv cA caddc co cmpt vx cr vx cv cA caddc co cmpt eqid fvopab2b
      cA cr wcel vx cv cr wcel vy cv cr wcel wa wa vx cv cr wcel vx cv cA caddc
      co cr wcel vy cv cA caddc co cr wcel wa vx cv cF cfv vy cv cF cfv wceq cA
      cr wcel vx cv cr wcel vy cv cr wcel simprl ad2antrr cA cr wcel vx cv cr
      wcel vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy cv cA caddc co cr
      wcel vx cv cF cfv vy cv cF cfv wceq simplrl sylanc cA cr wcel vx cv cr
      wcel vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy cv cA caddc co cr
      wcel wa wa vx cv cF cfv vy cv cF cfv wceq wa vy cv cr wcel vy cv cA caddc
      co cr wcel wa vy cv vy cr vy cv cA caddc co cmpt cfv vy cv cA caddc co
      wceq cA cr wcel vx cv cr wcel vy cv cr wcel wa wa vx cv cA caddc co cr
      wcel vy cv cA caddc co cr wcel wa wa vy cv cr wcel vy cv cA caddc co cr
      wcel wa vx cv cF cfv vy cv cF cfv wceq cA cr wcel vx cv cr wcel vy cv cr
      wcel wa wa vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel wa wa vy
      cv cr wcel vy cv cA caddc co cr wcel cA cr wcel vx cv cr wcel vy cv cr
      wcel vx cv cA caddc co cr wcel vy cv cA caddc co cr wcel wa simplrr cA cr
      wcel vx cv cr wcel vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy cv cA
      caddc co cr wcel simprr jca adantr vy cr vy cv cA caddc co cr vy cr vy cv
      cA caddc co cmpt vy cr vy cv cA caddc co cmpt eqid fvopab2b syl 3eqtr3d
      cA cr wcel vx cv cr wcel vy cv cr wcel wa wa vx cv cA caddc co cr wcel vy
      cv cA caddc co cr wcel wa wa vx cv cF cfv vy cv cF cfv wceq wa vx cv cc
      wcel vy cv cc wcel cA cc wcel w3a vx cv cA caddc co vy cv cA caddc co
      wceq vx vy weq wb cA cr wcel vx cv cr wcel vy cv cr wcel wa wa vx cv cc
      wcel vy cv cc wcel cA cc wcel w3a vx cv cA caddc co cr wcel vy cv cA
      caddc co cr wcel wa vx cv cF cfv vy cv cF cfv wceq cA cr wcel vx cv cr
      wcel vy cv cr wcel wa wa vx cv cc wcel vy cv cc wcel cA cc wcel vx cv cr
      wcel vx cv cc wcel cA cr wcel vy cv cr wcel vx cv recn ad2antrl vy cv cr
      wcel vy cv cc wcel cA cr wcel vx cv cr wcel vy cv recn ad2antll cA cr
      wcel cA cc wcel vx cv cr wcel vy cv cr wcel wa cA recn adantr 3jca
      ad2antrr vx cv vy cv cA addcan2 syl mpbid exp31 mpd ex r19.21aivv jca vx
      vy cr cr cF dff13 sylibr cA cr wcel cF cr wfn cF crn cr wceq wa cr cr cF
      wfo cA cr wcel cF cr wfn cF crn cr wceq cA cr wcel cF wfun cF cdm cr wceq
      wa cF cr wfn cA cr wcel cF cdm cr wceq cF wfun vx cA cF trnij.1 trdom vx
      cr vx cv cA caddc co cF trnij.1 cmpfun jctil cF cr df-fn sylibr vx cA cF
      trnij.1 trran jca cr cr cF df-fo sylibr jca cr cr cF df-f1o sylibr $.
      $( [17-Feb-2008] $) $( [17-Feb-2008] $)
  $}

  ${ $d A u v x y $. $d A w x y z $.
    $( Converse of a translation. $)
    cnvtr $p |- ( A e. RR -> `' ( x e. RR |-> ( x + A ) ) =
      ( x e. RR |-> ( x - A ) ) ) $=
      cA cr wcel vx cr vx cv cA caddc co cmpt ccnv vx cr vx cv cA cmin co cmpt
      wceq cr cr wceq vx cv vx cr vx cv cA caddc co cmpt ccnv cfv vx cv vx cr
      vx cv cA cmin co cmpt cfv wceq vx cr wral wa cA cr wcel vx cv vx cr vx cv
      cA caddc co cmpt ccnv cfv vx cv vx cr vx cv cA cmin co cmpt cfv wceq vx
      cr wral cr cr wceq cA cr wcel vx cv vx cr vx cv cA caddc co cmpt ccnv cfv
      vx cv vx cr vx cv cA cmin co cmpt cfv wceq vx cr cA cr wcel vx cv cr wcel
      wa vx cv vx cr vx cv cA caddc co cmpt ccnv cfv vx cv cA cmin co vx cv vx
      cr vx cv cA cmin co cmpt cfv cr cr vx cr vx cv cA caddc co cmpt wf1o vx
      cv cA cmin co cr wcel wa vx cv cA cmin co vx cr vx cv cA caddc co cmpt
      cfv vx cv wceq vx cv vx cr vx cv cA caddc co cmpt ccnv cfv vx cv cA cmin
      co wceq cA cr wcel vx cv cr wcel wa cr cr vx cv cA cmin co vx cv vx cr vx
      cv cA caddc co cmpt f1ocnvfv cA cr wcel vx cv cr wcel wa cr cr vx cr vx
      cv cA caddc co cmpt wf1o vx cv cA cmin co cr wcel cA cr wcel cr cr vx cr
      vx cv cA caddc co cmpt wf1o vx cv cr wcel vu cA vx cr vx cv cA caddc co
      cmpt vx cv cr wcel vy cv vx cv cA caddc co wceq wa vx vy copab vu cv cr
      wcel vv cv vu cv cA caddc co wceq wa vu vv copab vx cr vx cv cA caddc co
      cmpt vu cr vu cv cA caddc co cmpt vx cv cr wcel vy cv vx cv cA caddc co
      wceq wa vu cv cr wcel vv cv vu cv cA caddc co wceq wa vx vy vu vv vx cv
      cr wcel vy cv vx cv cA caddc co wceq wa vu ax-17 vx cv cr wcel vy cv vx
      cv cA caddc co wceq wa vv ax-17 vu cv cr wcel vv cv vu cv cA caddc co
      wceq wa vx ax-17 vu cv cr wcel vv cv vu cv cA caddc co wceq wa vy ax-17
      vx vu weq vy vv weq wa vx cv cr wcel vu cv cr wcel vy cv vx cv cA caddc
      co wceq vv cv vu cv cA caddc co wceq vx vu weq vx cv cr wcel vu cv cr
      wcel wb vy vv weq vx cv vu cv cr eleq1 adantr vy vv weq vy cv vx cv cA
      caddc co wceq vv cv vx cv cA caddc co wceq vx vu weq vv cv vu cv cA caddc
      co wceq vy cv vv cv vx cv cA caddc co eqeq1 vx vu weq vx cv cA caddc co
      vu cv cA caddc co vv cv vx cv vu cv cA caddc opreq1 eqeq2d sylan9bbr
      anbi12d cbvopab vx vy cr vx cv cA caddc co df-mpt vu vv cr vu cv cA caddc
      co df-mpt 3eqtr4i trnij adantr vx cv cr wcel cA cr wcel vx cv cA cmin co
      cr wcel vx cv cA resubcl ancoms jca cA cr wcel vx cv cr wcel wa vx cv cA
      cmin co vx cr vx cv cA caddc co cmpt cfv vx cv cA cmin co vy cr vy cv cA
      caddc co cmpt cfv vx cv cA cr wcel vx cv cr wcel wa vx cv cA cmin co vx
      cr vx cv cA caddc co cmpt vy cr vy cv cA caddc co cmpt vx cr vx cv cA
      caddc co cmpt vy cr vy cv cA caddc co cmpt wceq cA cr wcel vx cv cr wcel
      wa vy cv cr wcel vz cv vy cv cA caddc co wceq wa vy vz copab vx cv cr
      wcel vw cv vx cv cA caddc co wceq wa vx vw copab vy cr vy cv cA caddc co
      cmpt vx cr vx cv cA caddc co cmpt vy cv cr wcel vz cv vy cv cA caddc co
      wceq wa vx cv cr wcel vw cv vx cv cA caddc co wceq wa vy vz vx vw vy vx
      weq vz vw weq wa vy cv cr wcel vx cv cr wcel vz cv vy cv cA caddc co wceq
      vw cv vx cv cA caddc co wceq vy vx weq vy cv cr wcel vx cv cr wcel wb vz
      vw weq vy cv vx cv cr eleq1 adantr vz vw weq vz cv vy cv cA caddc co wceq
      vw cv vy cv cA caddc co wceq vy vx weq vw cv vx cv cA caddc co wceq vz cv
      vw cv vy cv cA caddc co eqeq1 vy vx weq vy cv cA caddc co vx cv cA caddc
      co vw cv vy cv vx cv cA caddc opreq1 eqeq2d sylan9bbr anbi12d cbvopabv vy
      vz cr vy cv cA caddc co df-mpt vx vw cr vx cv cA caddc co df-mpt 3eqtr4ri
      a1i fveq1d cA cr wcel vx cv cr wcel wa vx cv cA cmin co cr wcel vx cv cA
      cmin co cA caddc co cr wcel wa vx cv cA cmin co vy cr vy cv cA caddc co
      cmpt cfv vx cv wceq vx cv cr wcel cA cr wcel vx cv cA cmin co cr wcel vx
      cv cA cmin co cA caddc co cr wcel wa vx cv cr wcel cA cr wcel wa vx cv cA
      cmin co cr wcel vx cv cA cmin co cA caddc co cr wcel vx cv cA resubcl vx
      cv cr wcel cA cr wcel vx cv cA cmin co cr wcel vx cv cA cmin co cA caddc
      co cr wcel vx cv cA resubcl vx cv cA cmin co cA readdcl sylancom jca
      ancoms vx cv cA cmin co cr wcel vx cv cA cmin co cA caddc co cr wcel wa
      cA cr wcel vx cv cr wcel wa vx cv cA cmin co vy cr vy cv cA caddc co cmpt
      cfv vx cv cA cmin co cA caddc co vx cv vy vz vx cv cA cmin co vy cv cA
      caddc co vx cv cA cmin co cA caddc co cr cr vy cr vy cv cA caddc co cmpt
      vy cv vx cv cA cmin co cA caddc opreq1 vy vz cr vy cv cA caddc co df-mpt
      fvopab4g vx cv cr wcel cA cr wcel vx cv cA cmin co cA caddc co vx cv wceq
      vx cv cc wcel cA cc wcel vx cv cA cmin co cA caddc co vx cv wceq vx cv cr
      wcel cA cr wcel vx cv cA npcan vx cv recn cA recn syl2an ancoms sylan9eqr
      mpdan eqtrd sylc vx cv cr wcel vx cv cA cmin co cr wcel vx cv vx cr vx cv
      cA cmin co cmpt cfv vx cv cA cmin co wceq cA cr wcel vx cv cr wcel wa vx
      cr vx cv cA cmin co cr vx cr vx cv cA cmin co cmpt vx cr vx cv cA cmin co
      cmpt eqid fvopab2b cA cr wcel vx cv cr wcel pm3.27 vx cv cr wcel cA cr
      wcel vx cv cA cmin co cr wcel vx cv cA resubcl ancoms sylanc eqtr4d
      r19.21aiva cr eqid jctil vx cr vx cv cA caddc co cmpt ccnv cr wfn vx cr
      vx cv cA cmin co cmpt cr wfn vx cr vx cv cA caddc co cmpt ccnv vx cr vx
      cv cA cmin co cmpt wceq cr cr wceq vx cv vx cr vx cv cA caddc co cmpt
      ccnv cfv vx cv vx cr vx cv cA cmin co cmpt cfv wceq vx cr wral wa wb cA
      cr wcel vx cr vx cv cA caddc co cmpt ccnv cr wfn vx cr vx cv cA cmin co
      cmpt cr wfn wa vx cr vx cv cA caddc co cmpt ccnv vx cr vx cv cA cmin co
      cmpt wceq cr cr wceq vx cv vx cr vx cv cA caddc co cmpt ccnv cfv vx cv vx
      cr vx cv cA cmin co cmpt cfv wceq vx cr wral wa vx cr vx cv cA caddc co
      cmpt ccnv cr wfn vx cr vx cv cA cmin co cmpt cr wfn wa vx cr vx cv cA
      caddc co cmpt ccnv vx cr vx cv cA cmin co cmpt wceq cr cr wceq vx cv vx
      cr vx cv cA caddc co cmpt ccnv cfv vx cv vx cr vx cv cA cmin co cmpt cfv
      wceq vx cr wral wa vx cr vx cv cA caddc co cmpt ccnv cr wfn vx cr vx cv
      cA cmin co cmpt cr wfn wa vx cr vx cv cA caddc co cmpt ccnv vx cr vx cv
      cA cmin co cmpt wceq wa cr cr wceq vx cv vx cr vx cv cA caddc co cmpt
      ccnv cfv vx cv vx cr vx cv cA cmin co cmpt cfv wceq vx cr wral vx cr vx
      cv cA caddc co cmpt ccnv cr wfn vx cr vx cv cA cmin co cmpt cr wfn wa vx
      cr vx cv cA caddc co cmpt ccnv vx cr vx cv cA cmin co cmpt wceq wa cr
      eqidd vx cr vx cv cA caddc co cmpt ccnv cr wfn vx cr vx cv cA cmin co
      cmpt cr wfn wa vx cr vx cv cA caddc co cmpt ccnv vx cr vx cv cA cmin co
      cmpt wceq vx cv vx cr vx cv cA caddc co cmpt ccnv cfv vx cv vx cr vx cv
      cA cmin co cmpt cfv wceq vx cr wral vx vw cr vx cr vx cv cA caddc co cmpt
      ccnv vx cr vx cv cA cmin co cmpt vx vw vx cr vx cv cA caddc co cmpt vx vw
      cr vx cv cA caddc co hbcmpt hbcnv vx vw cr vx cv cA cmin co hbcmpt
      eqfnfvf2 biimpa jca ex cr cr wceq vx cv vx cr vx cv cA caddc co cmpt ccnv
      cfv vx cv vx cr vx cv cA cmin co cmpt cfv wceq vx cr wral wa vx cr vx cv
      cA caddc co cmpt ccnv cr wfn vx cr vx cv cA cmin co cmpt cr wfn wa vx cr
      vx cv cA caddc co cmpt ccnv vx cr vx cv cA cmin co cmpt wceq vx cv vx cr
      vx cv cA caddc co cmpt ccnv cfv vx cv vx cr vx cv cA cmin co cmpt cfv
      wceq vx cr wral vx cr vx cv cA caddc co cmpt ccnv cr wfn vx cr vx cv cA
      cmin co cmpt cr wfn wa vx cr vx cv cA caddc co cmpt ccnv vx cr vx cv cA
      cmin co cmpt wceq wi cr cr wceq vx cr vx cv cA caddc co cmpt ccnv cr wfn
      vx cr vx cv cA cmin co cmpt cr wfn wa vx cr vx cv cA caddc co cmpt ccnv
      vx cr vx cv cA cmin co cmpt wceq vx cv vx cr vx cv cA caddc co cmpt ccnv
      cfv vx cv vx cr vx cv cA cmin co cmpt cfv wceq vx cr wral vx vw cr vx cr
      vx cv cA caddc co cmpt ccnv vx cr vx cv cA cmin co cmpt vx vw vx cr vx cv
      cA caddc co cmpt vx vw cr vx cv cA caddc co hbcmpt hbcnv vx vw cr vx cv
      cA cmin co hbcmpt eqfnfvf2 biimprcd adantl com12 impbid cA cr wcel vx cr
      vx cv cA caddc co cmpt cr wfn vx cr vx cv cA caddc co cmpt ccnv cr wfn cA
      cr wcel cr cr vx cr vx cv cA caddc co cmpt wf1o vx cr vx cv cA caddc co
      cmpt cr wfn vx cr vx cv cA caddc co cmpt ccnv cr wfn wa vu cA vx cr vx cv
      cA caddc co cmpt vx cv cr wcel vy cv vx cv cA caddc co wceq wa vx vy
      copab vu cv cr wcel vv cv vu cv cA caddc co wceq wa vu vv copab vx cr vx
      cv cA caddc co cmpt vu cr vu cv cA caddc co cmpt vx cv cr wcel vy cv vx
      cv cA caddc co wceq wa vu cv cr wcel vv cv vu cv cA caddc co wceq wa vx
      vy vu vv vx cv cr wcel vy cv vx cv cA caddc co wceq wa vu ax-17 vx cv cr
      wcel vy cv vx cv cA caddc co wceq wa vv ax-17 vu cv cr wcel vv cv vu cv
      cA caddc co wceq wa vx ax-17 vu cv cr wcel vv cv vu cv cA caddc co wceq
      wa vy ax-17 vx vu weq vy vv weq wa vx cv cr wcel vu cv cr wcel vy cv vx
      cv cA caddc co wceq vv cv vu cv cA caddc co wceq vx vu weq vx cv cr wcel
      vu cv cr wcel wb vy vv weq vx cv vu cv cr eleq1 adantr vy vv weq vy cv vx
      cv cA caddc co wceq vv cv vx cv cA caddc co wceq vx vu weq vv cv vu cv cA
      caddc co wceq vy cv vv cv vx cv cA caddc co eqeq1 vx vu weq vx cv cA
      caddc co vu cv cA caddc co vv cv vx cv vu cv cA caddc opreq1 eqeq2d
      sylan9bbr anbi12d cbvopab vx vy cr vx cv cA caddc co df-mpt vu vv cr vu
      cv cA caddc co df-mpt 3eqtr4i trnij cr cr vx cr vx cv cA caddc co cmpt
      dff1o4 sylib pm3.27d cA cr wcel vx cv cA cmin co cvv wcel vx cr wral vx
      cr vx cv cA cmin co cmpt cr wfn cA cr wcel vx cv cA cmin co cvv wcel vx
      cr vx cv cr wcel cA cr wcel vx cv cA cmin co cvv wcel vx cv cr wcel cA cr
      wcel wa vx cv cA cmin co cr wcel vx cv cA cmin co cvv wcel vx cv cA
      resubcl vx cv cA cmin co cr elisset syl ancoms r19.21aiva vx cr vx cv cA
      cmin co vx cr vx cv cA cmin co cmpt vx cr vx cv cA cmin co cmpt eqid
      fopab2ga sylib sylanc mpbird $.
      $( [3-Aug-2009] $) $( [3-Aug-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    nolimf.1 $e |- Y = U. L $.
    nolimf.2 $e |- J = ( topGen ` ran (,) ) $.
    ${
    $d F x $. $d J x $. $d L x $. $d Y x $.
    $( A numerical function has at most one limit value. $)
    nolimf $p |- ( ( L e. Fil /\ F : Y --> RR )
       -> E* x  x e. ( ( J fLimf L ) ` F ) ) $=
      cL cfil wcel cJ cha wcel cY cr cF wf vx cv cF cJ cL cflimf co cfv wcel vx
      wmo cJ cioo crn ctg cfv cha nolimf.2 rehaus eqeltri vx cF cJ cL cr cY
      nolimf.1 cJ cuni cioo crn ctg cfv cuni cioo crn cuni cr cJ cioo crn ctg
      cfv nolimf.2 unieqi cioo crn ctb wcel cioo crn ctg cfv cuni cioo crn cuni
      wceq retopbas cioo crn unitg ax-mp unirnioo 3eqtrri holimf mp3an2 $.
      $( [6-Dec-2010] $) $( [14-Nov-2010] $)
    $}

    ${
      $d F x $. $d J x $. $d L x $. $d Y x $.
      $( A numerical convergent function has one limit value. $)
    nolimf2 $p |- ( ( L e. Fil /\ F : Y --> RR /\
       ( ( J fLimf L ) ` F ) =/= (/) )
         -> E! x  x e. ( ( J fLimf L ) ` F ) ) $=
      cL cfil wcel cY cr cF wf cF cJ cL cflimf co cfv c0 wne w3a vx cv cF cJ cL
      cflimf co cfv wcel vx wmo vx cv cF cJ cL cflimf co cfv wcel vx weu cL
      cfil wcel cY cr cF wf vx cv cF cJ cL cflimf co cfv wcel vx wmo cF cJ cL
      cflimf co cfv c0 wne vx cF cJ cL cY nolimf.1 nolimf.2 nolimf 3adant3 cF
      cJ cL cflimf co cfv c0 wne cL cfil wcel vx cv cF cJ cL cflimf co cfv wcel
      vx wmo vx cv cF cJ cL cflimf co cfv wcel vx weu wb cY cr cF wf vx cF cJ
      cL cflimf co cfv equnamo 3ad2ant3 mpbid $.
      $( [6-Dec-2010] $) $( [14-Nov-2010] $)
    $}

  $}

  ${

    flimfnein.2 $e |- Y = U. L $.
    flimfnein.3 $e |- A = U. ( ( J fLimf L ) ` F ) $.
    flimfnein.4 $e |- J = ( topGen ` ran (,) ) $.

    ${
      $d F s $. $d L s $. $d N s $. $d Y s $.
      $( A neighborhood of the limit value ` A ` of a convergent numerical
         function  ` F ` contains the image of a filter element. $)
      flimfnein $p |- ( ( ( L e. Fil /\ F : Y --> RR )
         /\ ( ( J fLimf L ) ` F ) =/= (/)
         /\ N e. ( ( nei ` J ) ` { A } ) ) -> E. s e. L ( F " s ) C_ N  ) $=
        cJ cha wcel cL cfil wcel cY cr cF wf w3a cF cJ cL cflimf co cfv c0 wne
        cN cA csn cJ cnei cfv cfv wcel cF vs cv cima cN wss vs cL wrex cL cfil
        wcel cY cr cF wf wa cA cF cJ cL cN cr cY vs cJ cioo crn ctg cfv wceq cr
        cJ cuni wceq flimfnein.4 cJ cioo crn ctg cfv wceq cJ cuni cioo crn ctg
        cfv cuni cr cJ cioo crn ctg cfv unieq uniretop syl6req ax-mp
        flimfnein.2 flimfnein.3 flimfneih cL cfil wcel cY cr cF wf wa cJ cha
        wcel cL cfil wcel cY cr cF wf cJ cha wcel cL cfil wcel cY cr cF wf wa
        cJ cioo crn ctg cfv cha flimfnein.4 rehaus eqeltri a1i cL cfil wcel cY
        cr cF wf pm3.26 cL cfil wcel cY cr cF wf pm3.27 3jca syl3an1 $.
        $( [6-Dec-2010] $) $( [18-Nov-2010] $)
    $}

    ${
      $( The limit of a numerical convergent function belongs to ` RR ` . $)
      limnumrr $p |- ( ( L e. Fil /\ F : Y --> RR /\
       ( ( J fLimf L ) ` F ) =/= (/) )
         -> A e. RR ) $=
        cJ ctop wcel cL cfil wcel cY cr cF wf w3a cA cF cJ cL cflimf co cfv
        wcel cA cr wcel cL cfil wcel cY cr cF wf cF cJ cL cflimf co cfv c0 wne
        w3a cA cF cJ cL cr cY cJ cioo crn ctg cfv wceq cr cJ cuni wceq
        flimfnein.4 cJ cioo crn ctg cfv wceq cJ cuni cioo crn ctg cfv cuni cr
        cJ cioo crn ctg cfv unieq uniretop syl6req ax-mp flimfnein.2 flimfelbas
        cL cfil wcel cY cr cF wf cF cJ cL cflimf co cfv c0 wne w3a cJ ctop wcel
        cL cfil wcel cY cr cF wf cJ ctop wcel cL cfil wcel cY cr cF wf cF cJ cL
        cflimf co cfv c0 wne w3a cJ cioo crn ctg cfv ctop flimfnein.4 retop
        eqeltri a1i cL cfil wcel cY cr cF wf cF cJ cL cflimf co cfv c0 wne
        3simp1 cL cfil wcel cY cr cF wf cF cJ cL cflimf co cfv c0 wne 3simp2
        3jca cJ cha wcel cL cfil wcel cY cr cF wf w3a cF cJ cL cflimf co cfv c0
        wne cA cF cJ cL cflimf co cfv wcel cL cfil wcel cY cr cF wf cF cJ cL
        cflimf co cfv c0 wne w3a cA cF cJ cL cr cY cJ cioo crn ctg cfv wceq cr
        cJ cuni wceq flimfnein.4 cJ cioo crn ctg cfv wceq cJ cuni cioo crn ctg
        cfv cuni cr cJ cioo crn ctg cfv unieq uniretop syl6req ax-mp
        flimfnein.2 flimfnein.3 limvinlv cL cfil wcel cY cr cF wf cF cJ cL
        cflimf co cfv c0 wne w3a cJ cha wcel cL cfil wcel cY cr cF wf cJ cha
        wcel cL cfil wcel cY cr cF wf cF cJ cL cflimf co cfv c0 wne w3a cJ cioo
        crn ctg cfv cha flimfnein.4 rehaus eqeltri a1i cL cfil wcel cY cr cF wf
        cF cJ cL cflimf co cfv c0 wne 3simp1 cL cfil wcel cY cr cF wf cF cJ cL
        cflimf co cfv c0 wne 3simp2 3jca cL cfil wcel cY cr cF wf cF cJ cL
        cflimf co cfv c0 wne 3simp3 sylanc sylanc $.
        $( [6-Dec-2010] $) $( [22-Nov-2010] $)
    $}

  $}

  ${
    cinei.1 $e |- J = ( topGen ` ran (,) ) $.
    $( A centered interval is a neighborhood of its center. $)
    cinei $p |- ( ( A e. RR /\ B e. RR+ )
      -> ( ( A - B ) (,) ( A + B ) ) e. ( ( nei ` J ) ` { A } ) ) $=
      cJ ctop wcel cA cB cmin co cA cB caddc co cioo co cJ wcel cA cA cB cmin
      co cA cB caddc co cioo co wcel cA cB cmin co cA cB caddc co cioo co cA
      csn cJ cnei cfv cfv wcel cA cr wcel cB crp wcel wa cA cJ cA cB cmin co cA
      cB caddc co cioo co opnneip cJ ctop wcel cA cr wcel cB crp wcel wa cJ
      cioo crn ctg cfv ctop cinei.1 retop eqeltri a1i cA cB cmin co cA cB caddc
      co cioo co cJ wcel cA cr wcel cB crp wcel wa cA cB cmin co cA cB caddc co
      cioo co cioo crn ctg cfv cJ cA cB cmin co cA cB caddc co iooretop cinei.1
      eleqtrri a1i cA cB cbci syl3anc $.
      $( [6-Dec-2010] $) $( [18-Nov-2010] $)
  $}

  ${
    flimfneic.1 $e |- X = U. J $.
    flimfneic.2 $e |- Y = U. L $.
    flimfneic.3 $e |- A = U. ( ( J fLimf L ) ` F ) $.
    flimfneic.4 $e |- J = ( topGen ` ran (,) ) $.
    flimfneic.5 $e |- N = ( ( A - B ) (,) ( A + B ) ) $.
    $( A centered interval of the limit value ` A ` of a convergent numerical
       function  ` F ` contains the image of a filter element. $)
    flimfneic $p |- ( ( ( L e. Fil /\ F : Y --> X )
       /\ ( ( J fLimf L ) ` F ) =/= (/)
       /\ B e. RR+ ) -> A e. ( ( J fLimf L ) ` F )  ) $=
      cJ cha wcel cL cfil wcel cY cioo crn ctg cfv cuni cF wf w3a cF cJ cL
      cflimf co cfv c0 wne cA cF cJ cL cflimf co cfv wcel cL cfil wcel cY cX cF
      wf wa cF cJ cL cflimf co cfv c0 wne cB crp wcel w3a cA cF cJ cL cioo crn
      ctg cfv cuni cY cJ cuni cioo crn ctg cfv cuni cJ cioo crn ctg cfv
      flimfneic.4 unieqi eqcomi flimfneic.2 flimfneic.3 limvinlv cL cfil wcel
      cY cX cF wf wa cF cJ cL cflimf co cfv c0 wne cB crp wcel w3a cJ cha wcel
      cL cfil wcel cY cioo crn ctg cfv cuni cF wf cJ cha wcel cL cfil wcel cY
      cX cF wf wa cF cJ cL cflimf co cfv c0 wne cB crp wcel w3a cJ cioo crn ctg
      cfv cha flimfneic.4 rehaus eqeltri a1i cL cfil wcel cY cX cF wf wa cF cJ
      cL cflimf co cfv c0 wne cL cfil wcel cB crp wcel cL cfil wcel cY cX cF wf
      pm3.26 3ad2ant1 cL cfil wcel cY cX cF wf wa cF cJ cL cflimf co cfv c0 wne
      cY cioo crn ctg cfv cuni cF wf cB crp wcel cY cX cF wf cY cioo crn ctg
      cfv cuni cF wf cL cfil wcel cY cX cF wf cY cioo crn ctg cfv cuni cF wf cX
      cioo crn ctg cfv cuni wceq cY cX cF wf cY cioo crn ctg cfv cuni cF wf wb
      cX cJ cuni cioo crn ctg cfv cuni flimfneic.1 cJ cioo crn ctg cfv
      flimfneic.4 unieqi eqtri cX cioo crn ctg cfv cuni cY cF feq3 ax-mp biimpi
      adantl 3ad2ant1 3jca cL cfil wcel cY cX cF wf wa cF cJ cL cflimf co cfv
      c0 wne cB crp wcel 3simp2 sylanc $.
      $( [6-Dec-2010] $) $( [18-Nov-2010] $)
  $}

  ${
    $d F s $. $d L s $. $d N s $. $d Y s $.
    flimfneicn.2 $e |- Y = U. L $.
    flimfneicn.3 $e |- A = U. ( ( J fLimf L ) ` F ) $.
    flimfneicn.4 $e |- J = ( topGen ` ran (,) ) $.
    flimfneicn.5 $e |- N = ( ( A - B ) (,) ( A + B ) ) $.
    $( A centered interval of the limit value ` A ` of a convergent numerical
       function  ` F ` contains the image of a filter element. $)
    flimfneicn $p |- ( ( ( L e. Fil /\ F : Y --> RR )
       /\ ( ( J fLimf L ) ` F ) =/= (/)
       /\ B e. RR+ ) -> E. s e. L ( F " s ) C_ N  ) $=
      cL cfil wcel cY cr cF wf wa cF cJ cL cflimf co cfv c0 wne cN cA csn cJ
      cnei cfv cfv wcel cF vs cv cima cN wss vs cL wrex cB crp wcel cA cF cJ cL
      cN cY vs flimfneicn.2 flimfneicn.3 flimfneicn.4 flimfnein cL cfil wcel cY
      cr cF wf wa cF cJ cL cflimf co cfv c0 wne cB crp wcel cN cA csn cJ cnei
      cfv cfv wcel cL cfil wcel cY cr cF wf wa cF cJ cL cflimf co cfv c0 wne cA
      cr wcel cB crp wcel cN cA csn cJ cnei cfv cfv wcel wi cL cfil wcel cY cr
      cF wf wa cF cJ cL cflimf co cfv c0 wne cA cr wcel cJ ctop wcel cL cfil
      wcel cY cr cF wf w3a cA cF cJ cL cflimf co cfv wcel cA cr wcel cL cfil
      wcel cY cr cF wf wa cF cJ cL cflimf co cfv c0 wne wa cA cF cJ cL cr cY cJ
      cuni cioo crn ctg cfv cuni cr cJ cioo crn ctg cfv flimfneicn.4 unieqi
      uniretop eqtr2i flimfneicn.2 flimfelbas cL cfil wcel cY cr cF wf wa cF cJ
      cL cflimf co cfv c0 wne wa cJ ctop wcel cL cfil wcel cY cr cF wf cJ ctop
      wcel cL cfil wcel cY cr cF wf wa cF cJ cL cflimf co cfv c0 wne wa cJ cioo
      crn ctg cfv ctop flimfneicn.4 retop eqeltri a1i cL cfil wcel cY cr cF wf
      cF cJ cL cflimf co cfv c0 wne simpll cL cfil wcel cY cr cF wf cF cJ cL
      cflimf co cfv c0 wne simplr 3jca cJ cha wcel cL cfil wcel cY cr cF wf cF
      cJ cL cflimf co cfv c0 wne cA cF cJ cL cflimf co cfv wcel cJ cioo crn ctg
      cfv cha flimfneicn.4 rehaus eqeltri cA cF cJ cL cr cY cJ cuni cioo crn
      ctg cfv cuni cr cJ cioo crn ctg cfv flimfneicn.4 unieqi uniretop eqtr2i
      flimfneicn.2 flimfneicn.3 limvinlv mp3anl1 sylanc ex cA cr wcel cB crp
      wcel cN cA csn cJ cnei cfv cfv wcel cA cr wcel cB crp wcel wa cA cB cmin
      co cA cB caddc co cioo co cA csn cJ cnei cfv cfv cN cA cB cJ flimfneicn.4
      cinei flimfneicn.5 syl5eqel ex syl6 3imp syld3an3 $.
      $( [6-Dec-2010] $) $( [18-Nov-2010] $)
  $}

  ${
    lvsovso.1 $e |- Y = U. F $.
    lvsovso.2 $e |- L1 = U. ( ( J fLimf F ) ` F1 ) $.
    lvsovso.3 $e |- L2 = U. ( ( J fLimf F ) ` F2 ) $.
    lvsovso.4 $e |- J = ( topGen ` ran (,) ) $.

    ${
      $d F a r s x $. $d F1 a r s x $. $d F2 a r s x $. $d J r s x $.
      $d L1 r s x $. $d L2 r s x $. $d Y r s x $.
      $( If the limit values of two convergent numerical functions
         are strictly ordered, the values of the functions are strictly ordered
         for some element of the filter.
         Bourbaki TG IV.18 prop. 2. $)
      lvsovso $p |- ( ( ( F e. Fil /\ F1 : Y --> RR /\ F2 : Y --> RR ) /\
           ( ( ( J fLimf F ) ` F1 ) =/= (/) /\
             ( ( J fLimf F ) ` F2 ) =/= (/) /\
             L1 <  L2 ) )
         -> E. a e. F A. x e. a ( F1 ` x ) < ( F2 ` x ) ) $=
        cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss vr cF wrex cF2 vs
        cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss vs cF wrex wa cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv vx cv
        cF2 cfv clt wbr vx va cv wral va cF wrex cF cfil wcel cY cr cF1 wf wa
        cF1 cJ cF cflimf co cfv c0 wne cL2 cL1 cmin co cabs cfv c2 cdiv co crp
        wcel w3a cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne
        cL2 cL1 cmin co cabs cfv c2 cdiv co crp wcel w3a cF1 vr cv cima cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss vr cF wrex cF2 vs cv cima cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss vs cF wrex wa cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a wa cF cfil wcel cY cr cF1 wf wa cF1 cJ cF cflimf co
        cfv c0 wne cL2 cL1 cmin co cabs cfv c2 cdiv co crp wcel w3a cF1 vr cv
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss vr cF wrex cF cfil wcel cY
        cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne cL2 cL1 cmin co cabs cfv c2
        cdiv co crp wcel w3a cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss vs cF wrex cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cF1 cJ cF cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cioo co cY vr lvsovso.1 lvsovso.2 lvsovso.4 cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cioo co eqid flimfneicn cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cF2 cJ cF cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co cY vs
        lvsovso.1 lvsovso.3 lvsovso.4 cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co eqid
        flimfneicn anim12i cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cF cfil wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL2 cL1
        cmin co cabs cfv c2 cdiv co crp wcel cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa cF cfil wcel cY cr cF1 wf cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a 3simpl1 cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a 3simpl2 jca cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr 3simpr1 cL2 cL1 cmin co cabs cfv c2 cdiv co crp wcel cL2
        cL1 cmin co cabs cfv c2 cdiv co cr wcel cc0 cL2 cL1 cmin co cabs cfv c2
        cdiv co clt wbr cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 cmin co cabs cfv c2 cdiv co elrp cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv
        c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co cabs cfv cr wcel cL2 cL1
        cmin co cabs cfv c2 cdiv co cr wcel cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cabs cfv
        cr wcel cL2 cc wcel cL1 cc wcel cL2 cL1 cmin co cc wcel cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 subcl cF cfil wcel
        cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cc wcel cF cfil wcel cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a cL2 cc wcel wi cY cr cF1 wf cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel
        cY cr cF2 wf wa cL2 cc wcel cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cY cr cF2 wf wa cL2 cc wcel wi cL1
        cL2 clt wbr cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne
        cL2 cc wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        cL2 cc wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        w3a cL2 cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr recnd
        3expia com12 3ad2ant2 com12 3adant2 imp cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL1 cc wcel wi cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF1 wf wa
        cL1 cc wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cF cfil wcel cY cr cF1 wf wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil
        wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL1 cc wcel cF cfil
        wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cL1 cc wcel cF cfil
        wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF
        cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1
        com12 3adant3 imp sylanc cL2 cL1 cmin co abscl syl cL2 cL1 cmin co cabs
        cfv rehalfcl syl cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cc0 cL2 cL1 cmin co cabs cfv clt wbr cc0 cL2 cL1 cmin co cabs cfv c2
        cdiv co clt wbr cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 cmin co cc0 wne cc0 cL2 cL1 cmin co cabs cfv clt wbr cL2 cL1
        cmin co cr wcel cc0 cL2 cL1 cmin co clt wbr cL2 cL1 cmin co cc0 wne cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co
        gt0ne0 cL2 cr wcel cL1 cr wcel cL2 cL1 cmin co cr wcel cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 resubcl cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr wcel cF cfil wcel
        cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL2 cr wcel wi cY cr cF1 wf cF1 cJ cF cflimf co
        cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil
        wcel cY cr cF2 wf wa cL2 cr wcel cF2 cJ cF cflimf co cfv c0 wne cF1 cJ
        cF cflimf co cfv c0 wne cF cfil wcel cY cr cF2 wf wa cL2 cr wcel wi cL1
        cL2 clt wbr cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne
        cL2 cr wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        cL2 cr wcel cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr
        3expia com12 3ad2ant2 com12 3adant2 imp cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL1 cr wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL1 cr wcel wi cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF1 wf wa
        cL1 cr wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cF cfil wcel cY cr cF1 wf wa cL1 cr wcel wi cL1 cL2 clt wbr cF cfil
        wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL1 cr wcel cF cfil
        wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cL1 cr wcel cL1 cF1 cJ
        cF cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr 3expia com12 3ad2ant1
        com12 3adant3 imp sylanc cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa cL1 cL2 clt wbr cc0 cL2 cL1 cmin co clt wbr cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr 3simpr3 cL1 cr wcel cL2 cr wcel
        cL1 cL2 clt wbr cc0 cL2 cL1 cmin co clt wbr wb cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a wa cL1 cL2 posdif cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a cL1 cr wcel cF cfil wcel cY cr cF1 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cL1 cr wcel wi cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr
        cF1 wf wa cL1 cr wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf
        co cfv c0 wne cF cfil wcel cY cr cF1 wf wa cL1 cr wcel wi cL1 cL2 clt
        wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL1 cr
        wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cL1 cr
        wcel cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr 3expia
        com12 3ad2ant1 com12 3adant3 imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr w3a cL2 cr wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr
        wcel wi cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa cL2 cr wcel
        cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cF cfil
        wcel cY cr cF2 wf wa cL2 cr wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr
        cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne cL2 cr wcel cF cfil wcel cY cr
        cF2 wf cF2 cJ cF cflimf co cfv c0 wne cL2 cr wcel cL2 cF2 cJ cF cY
        lvsovso.1 lvsovso.3 lvsovso.4 limnumrr 3expia com12 3ad2ant2 com12
        3adant2 imp sylanc mpbid sylanc cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr w3a wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cc0 wne cc0
        cL2 cL1 cmin co cabs cfv clt wbr wb cL2 cc wcel cL1 cc wcel cL2 cL1
        cmin co cc wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 subcl cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL2 cc wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cc wcel wi cY cr
        cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa cL2 cc wcel cF2 cJ cF
        cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr
        cF2 wf wa cL2 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF2 wf wa
        cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne w3a cL2 cL2 cF2 cJ cF cY lvsovso.1
        lvsovso.3 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant2 com12 3adant2
        imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel
        cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel wi cY cr cF2 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cF cfil wcel cY cr cF1 wf wa cL1 cc wcel cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ
        cF cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2
        lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1 com12 3adant3 imp sylanc
        cL2 cL1 cmin co absgt0 syl mpbid cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr w3a wa cL2 cL1 cmin co cabs cfv cr wcel cc0 cL2 cL1 cmin co
        cabs cfv clt wbr cc0 cL2 cL1 cmin co cabs cfv c2 cdiv co clt wbr wb cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co
        cc wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cc wcel cL1 cc wcel cL2
        cL1 cmin co cc wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ
        cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr
        w3a wa cL2 cL1 subcl cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ
        cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr
        w3a cL2 cc wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cc wcel wi
        cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa cL2 cc wcel cF2 cJ
        cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cF cfil wcel cY
        cr cF2 wf wa cL2 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF2 wf
        wa cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne w3a cL2 cL2 cF2 cJ cF cY lvsovso.1
        lvsovso.3 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant2 com12 3adant2
        imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel
        cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel wi cY cr cF2 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cF cfil wcel cY cr cF1 wf wa cL1 cc wcel cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ
        cF cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2
        lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1 com12 3adant3 imp sylanc
        cL2 cL1 cmin co abscl syl cL2 cL1 cmin co cabs cfv halfpos2 syl mpbid
        sylanbrc 3jca cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne cL2 cL1
        cmin co cabs cfv c2 cdiv co crp wcel cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa cF cfil wcel cY cr cF2 wf cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a 3simpl1 cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a 3simpl3 jca cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr 3simpr2 cL2 cL1 cmin co cabs cfv c2 cdiv co crp wcel cL2
        cL1 cmin co cabs cfv c2 cdiv co cr wcel cc0 cL2 cL1 cmin co cabs cfv c2
        cdiv co clt wbr cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 cmin co cabs cfv c2 cdiv co elrp cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv
        c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co cabs cfv cr wcel cL2 cL1
        cmin co cabs cfv c2 cdiv co cr wcel cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cabs cfv
        cr wcel cL2 cc wcel cL1 cc wcel cL2 cL1 cmin co cc wcel cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 subcl cF cfil wcel
        cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cc wcel cF cfil wcel cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a cL2 cc wcel wi cY cr cF1 wf cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel
        cY cr cF2 wf wa cL2 cc wcel cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cY cr cF2 wf wa cL2 cc wcel wi cL1
        cL2 clt wbr cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne
        cL2 cc wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        cL2 cc wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        w3a cL2 cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr recnd
        3expia com12 3ad2ant2 com12 3adant2 imp cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL1 cc wcel wi cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF1 wf wa
        cL1 cc wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cF cfil wcel cY cr cF1 wf wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil
        wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL1 cc wcel cF cfil
        wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cL1 cc wcel cF cfil
        wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF
        cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1
        com12 3adant3 imp sylanc cL2 cL1 cmin co abscl syl cL2 cL1 cmin co cabs
        cfv rehalfcl syl cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cc0 cL2 cL1 cmin co cabs cfv clt wbr cc0 cL2 cL1 cmin co cabs cfv c2
        cdiv co clt wbr cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 cmin co cc0 wne cc0 cL2 cL1 cmin co cabs cfv clt wbr cL2 cL1
        cmin co cr wcel cc0 cL2 cL1 cmin co clt wbr cL2 cL1 cmin co cc0 wne cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co
        gt0ne0 cL2 cr wcel cL1 cr wcel cL2 cL1 cmin co cr wcel cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 resubcl cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr wcel cF cfil wcel
        cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL2 cr wcel wi cY cr cF1 wf cF1 cJ cF cflimf co
        cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil
        wcel cY cr cF2 wf wa cL2 cr wcel cF2 cJ cF cflimf co cfv c0 wne cF1 cJ
        cF cflimf co cfv c0 wne cF cfil wcel cY cr cF2 wf wa cL2 cr wcel wi cL1
        cL2 clt wbr cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne
        cL2 cr wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        cL2 cr wcel cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr
        3expia com12 3ad2ant2 com12 3adant2 imp cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL1 cr wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL1 cr wcel wi cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF1 wf wa
        cL1 cr wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cF cfil wcel cY cr cF1 wf wa cL1 cr wcel wi cL1 cL2 clt wbr cF cfil
        wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL1 cr wcel cF cfil
        wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cL1 cr wcel cL1 cF1 cJ
        cF cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr 3expia com12 3ad2ant1
        com12 3adant3 imp sylanc cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa cL1 cL2 clt wbr cc0 cL2 cL1 cmin co clt wbr cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr 3simpr3 cL1 cr wcel cL2 cr wcel
        cL1 cL2 clt wbr cc0 cL2 cL1 cmin co clt wbr wb cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a wa cL1 cL2 posdif cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a cL1 cr wcel cF cfil wcel cY cr cF1 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cL1 cr wcel wi cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr
        cF1 wf wa cL1 cr wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf
        co cfv c0 wne cF cfil wcel cY cr cF1 wf wa cL1 cr wcel wi cL1 cL2 clt
        wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ cF cflimf co cfv c0 wne cL1 cr
        wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cL1 cr
        wcel cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr 3expia
        com12 3ad2ant1 com12 3adant3 imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr w3a cL2 cr wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr
        wcel wi cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa cL2 cr wcel
        cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cF cfil
        wcel cY cr cF2 wf wa cL2 cr wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr
        cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne cL2 cr wcel cF cfil wcel cY cr
        cF2 wf cF2 cJ cF cflimf co cfv c0 wne cL2 cr wcel cL2 cF2 cJ cF cY
        lvsovso.1 lvsovso.3 lvsovso.4 limnumrr 3expia com12 3ad2ant2 com12
        3adant2 imp sylanc mpbid sylanc cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr w3a wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cc0 wne cc0
        cL2 cL1 cmin co cabs cfv clt wbr wb cL2 cc wcel cL1 cc wcel cL2 cL1
        cmin co cc wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 subcl cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL2 cc wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cc wcel wi cY cr
        cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa cL2 cc wcel cF2 cJ cF
        cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr
        cF2 wf wa cL2 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF2 wf wa
        cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne w3a cL2 cL2 cF2 cJ cF cY lvsovso.1
        lvsovso.3 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant2 com12 3adant2
        imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel
        cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel wi cY cr cF2 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cF cfil wcel cY cr cF1 wf wa cL1 cc wcel cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ
        cF cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2
        lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1 com12 3adant3 imp sylanc
        cL2 cL1 cmin co absgt0 syl mpbid cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1
        cL2 clt wbr w3a wa cL2 cL1 cmin co cabs cfv cr wcel cc0 cL2 cL1 cmin co
        cabs cfv clt wbr cc0 cL2 cL1 cmin co cabs cfv c2 cdiv co clt wbr wb cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co
        cc wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cc wcel cL1 cc wcel cL2
        cL1 cmin co cc wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ
        cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr
        w3a wa cL2 cL1 subcl cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ
        cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr
        w3a cL2 cc wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cc wcel wi
        cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa cL2 cc wcel cF2 cJ
        cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cF cfil wcel cY
        cr cF2 wf wa cL2 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF2 wf
        wa cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil wcel cY cr cF2 wf
        cF2 cJ cF cflimf co cfv c0 wne w3a cL2 cL2 cF2 cJ cF cY lvsovso.1
        lvsovso.3 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant2 com12 3adant2
        imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel
        cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel wi cY cr cF2 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cF cfil wcel cY cr cF1 wf wa cL1 cc wcel cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ
        cF cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2
        lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1 com12 3adant3 imp sylanc
        cL2 cL1 cmin co abscl syl cL2 cL1 cmin co cabs cfv halfpos2 syl mpbid
        sylanbrc 3jca sylanc cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss vr cF wrex cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        vs cF wrex cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx
        cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF wrex wi cF1 vr cv
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs cv cima cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss vs cF wrex cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv
        wral va cF wrex wi wi vr cF cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv
        c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss vs cF wrex vr cv cF wcel cF1 vr cv cima cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF wrex
        wi cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss vr cv cF wcel
        cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv
        clt wbr vx va cv wral va cF wrex wi wi vs cF vr cv cF wcel cF1 vr cv
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss wa vs cv cF wcel cF2 vs cv
        cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss wa cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv clt wbr
        vx va cv wral va cF wrex wi vr cv cF wcel vs cv cF wcel cF1 vr cv cima
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs cv cima cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF
        wrex wi vr cv cF wcel vs cv cF wcel wa cF1 vr cv cima cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx
        cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF wrex wi cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vr cv cF wcel vs cv
        cF wcel wa cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs
        cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv vx cv
        cF2 cfv clt wbr vx va cv wral va cF wrex cF cfil wcel cY cr cF1 wf cY
        cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a vr cv cF wcel vs cv cF wcel wa cF1 vr cv cima
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs cv cima cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx
        va cv wral va cF wrex wi wi cF cfil wcel cY cr cF1 wf cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vr cv cF wcel vs cv cF wcel
        wa cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs cv cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv vx cv cF2 cfv
        clt wbr vx va cv wral va cF wrex wi wi wi cY cr cF2 wf cF cfil wcel vr
        cv cF wcel vs cv cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a wa cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv
        vx cv cF2 cfv clt wbr vx va cv wral va cF wrex wi cF cfil wcel vr cv cF
        wcel vs cv cF wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs cv cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv vx cv cF2 cfv
        clt wbr vx va cv wral va cF wrex wi wi cF cfil wcel vr cv cF wcel vs cv
        cF wcel w3a vr cv vs cv cin cF wcel cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a wa cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv
        cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF wrex wi wi vr cv vs
        cv cF filint vr cv vs cv cin cF wcel cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF
        wrex cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vs cv cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cF1 vr cv vs cv
        cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin
        cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv vx cv cF2
        cfv clt wbr vx va cv wral va cF wrex wi wi cF1 vr cv vs cv cin cima cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vr cv vs cv cin cF wcel vx
        cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF wrex cF1 vr cv vs
        cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin
        cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel
        cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vr cv vs cv
        cin cF wcel vx cv cF1 cfv vx cv cF2 cfv clt wbr vx va cv wral va cF
        wrex wi wi cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa
        vr cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx vr cv vs cv cin
        wral vr cv vs cv cin cF wcel vx cv cF1 cfv vx cv cF2 cfv clt wbr vx va
        cv wral va cF wrex wi cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss wa vr cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx vr cv
        vs cv cin wral cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa
        vr cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a wa wa vx cv cF1 cfv vx cv cF2 cfv clt wbr vx vr cv vs cv
        cin cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr
        cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa wa vx cv vr cv vs cv cin wcel vx cv cF1 cfv cr wcel cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co cmin co cr wcel vx cv cF2 cfv cr wcel
        w3a vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co clt
        wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt
        wbr wa wa vx cv cF1 cfv vx cv cF2 cfv clt wbr cF1 vr cv vs cv cin cima
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel wa cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx cv vr cv vs
        cv cin wcel vx cv cF1 cfv cr wcel cL2 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cr wcel vx cv cF2 cfv cr wcel w3a vx cv cF1 cfv cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co cmin co clt wbr cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co vx cv cF2 cfv clt wbr wa wa cF1 vr cv vs cv cin
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel wa
        cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx cv vr
        cv vs cv cin wcel wa vx cv cF1 cfv cr wcel cL2 cL2 cL1 cmin co cabs cfv
        c2 cdiv co cmin co cr wcel vx cv cF2 cfv cr wcel w3a vx cv cF1 cfv cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co clt wbr cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt wbr wa cF1 vr cv vs cv
        cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin
        cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel
        wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx cv
        vr cv vs cv cin wcel wa vx cv cF1 cfv cr wcel cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cr wcel vx cv cF2 cfv cr wcel cY cr cF1 wf vx cv
        cY wcel vx cv cF1 cfv cr wcel cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss wa vr cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY
        cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa wa vx cv vr cv vs cv cin wcel wa cY cr vx cv
        cF1 ffvelrn cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cY
        cr cF1 wf cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr
        cv vs cv cin cF wcel wa vx cv vr cv vs cv cin wcel cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a 3simpl2 ad2antlr cF1 vr cv vs cv cin
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel wa
        cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx cv vr
        cv vs cv cin wcel vx cv cY wcel vr cv vs cv cin cF wcel vx cv vr cv vs
        cv cin wcel vx cv cY wcel wi cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa vx cv vr cv vs cv cin wcel vr cv vs cv cin cF wcel vx cv cY wcel vx
        cv vr cv vs cv cin wcel vr cv vs cv cin cF wcel wa vx cv cF cuni cY vx
        cv vr cv vs cv cin cF elunii lvsovso.1 syl6eleqr expcom ad2antlr imp
        sylanc cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr
        cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa wa cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cr wcel
        vx cv vr cv vs cv cin wcel cL2 cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv
        co cr wcel cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cr wcel cF1
        vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv
        vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin
        cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co resubcl cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cr wcel cF1 vr cv vs cv cin cima
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel wa cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr wcel cF cfil
        wcel cY cr cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr wcel wi cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cF cfil wcel cY cr cF2 wf wa cL2 cr wcel cF2 cJ cF cflimf co cfv c0 wne
        cF1 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF2 wf wa cL2 cr wcel
        wi cL1 cL2 clt wbr cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv
        c0 wne cL2 cr wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0
        wne cL2 cr wcel cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr
        3expia com12 3ad2ant2 com12 3adant2 imp adantl cF cfil wcel cY cr cF1
        wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cL1 cL2 clt wbr w3a wa cL2 cL1 cmin co cabs cfv c2 cdiv co
        cr wcel cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr
        cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa cL2 cL1 cmin co cabs cfv cr wcel cL2 cL1 cmin co cabs cfv c2
        cdiv co cr wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cc wcel
        cL1 cc wcel cL2 cL1 cmin co cc wcel cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a wa cL2 cL1 subcl cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a cL2 cc wcel cF cfil wcel cY cr cF2 wf cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL2 cc wcel wi cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF2 wf wa
        cL2 cc wcel cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0
        wne cF cfil wcel cY cr cF2 wf wa cL2 cc wcel wi cL1 cL2 clt wbr cF cfil
        wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil
        wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne cL2 cc wcel cF cfil
        wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne w3a cL2 cL2 cF2 cJ cF
        cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant2
        com12 3adant2 imp cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        cL1 cc wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cc wcel wi cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a cF cfil wcel cY cr cF1 wf wa cL1 cc wcel cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr
        cF1 wf wa cL1 cc wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF1 wf wa
        cF1 cJ cF cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf
        cF1 cJ cF cflimf co cfv c0 wne cL1 cc wcel cF cfil wcel cY cr cF1 wf
        cF1 cJ cF cflimf co cfv c0 wne w3a cL1 cL1 cF1 cJ cF cY lvsovso.1
        lvsovso.2 lvsovso.4 limnumrr recnd 3expia com12 3ad2ant1 com12 3adant3
        imp sylanc cL2 cL1 cmin co abscl syl cL2 cL1 cmin co cabs cfv rehalfcl
        syl adantl sylanc adantr cY cr cF2 wf vx cv cY wcel vx cv cF2 cfv cr
        wcel cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr
        cv vs cv cin cF wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa wa vx cv vr cv vs cv cin wcel wa cY cr vx cv cF2 ffvelrn cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa cY cr cF2 wf cF1
        vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv
        vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin
        cF wcel wa vx cv vr cv vs cv cin wcel cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a 3simpl3 ad2antlr cF1 vr cv vs cv cin cima cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss wa vr cv vs cv cin cF wcel wa cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf
        co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx cv vr cv vs cv cin wcel vx
        cv cY wcel vr cv vs cv cin cF wcel vx cv vr cv vs cv cin wcel vx cv cY
        wcel wi cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss
        cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv vr cv vs cv
        cin wcel vr cv vs cv cin cF wcel vx cv cY wcel vx cv vr cv vs cv cin
        wcel vr cv vs cv cin cF wcel wa vx cv cF cuni cY vx cv vr cv vs cv cin
        cF elunii lvsovso.1 syl6eleqr expcom ad2antlr imp sylanc 3jca cF1 vr cv
        vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv
        cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF
        wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co
        cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx
        cv vr cv vs cv cin wcel wa vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel
        vx cv cF2 cfv cF2 vr cv vs cv cin cima wcel wa vx cv cF1 cfv cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co cmin co clt wbr cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt wbr wa cF1 vr cv vs cv
        cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin
        cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel
        wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv vr
        cv vs cv cin wcel vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2
        cfv cF2 vr cv vs cv cin cima wcel wa vr cv vs cv cin cF wcel cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv vr cv vs cv cin
        wcel vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr
        cv vs cv cin cima wcel wa wi wi cF1 vr cv vs cv cin cima cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a wa vr cv vs cv cin cF wcel vx cv vr cv vs cv cin wcel vx cv cF1
        cfv cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv cin
        cima wcel wa wi cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a vr cv vs cv
        cin cF wcel vx cv vr cv vs cv cin wcel vx cv cF1 cfv cF1 vr cv vs cv
        cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima wcel wa wi wi cF1
        cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt
        wbr w3a cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a vr cv vs cv cin cF
        wcel vx cv vr cv vs cv cin wcel vx cv cF1 cfv cF1 vr cv vs cv cin cima
        wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima wcel wa cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf w3a vr cv vs cv cin cF wcel vx cv vr cv vs cv cin
        wcel w3a vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2
        vr cv vs cv cin cima wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a vr
        cv vs cv cin cF wcel vx cv vr cv vs cv cin wcel vx cv cF1 cfv cF1 vr cv
        vs cv cin cima wcel cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a vr cv vs
        cv cin cF wcel cF1 wfun vr cv vs cv cin cF1 cdm wss wa vx cv vr cv vs
        cv cin wcel vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel wi cF cfil wcel
        cY cr cF1 wf vr cv vs cv cin cF wcel cF1 wfun vr cv vs cv cin cF1 cdm
        wss wa wi cY cr cF2 wf cY cr cF1 wf cF cfil wcel vr cv vs cv cin cF
        wcel cF1 wfun vr cv vs cv cin cF1 cdm wss wa wi cY cr cF1 wf cF cfil
        wcel vr cv vs cv cin cF wcel cF1 wfun vr cv vs cv cin cF1 cdm wss wa cY
        cr cF1 wf cF cfil wcel vr cv vs cv cin cF wcel w3a cF1 wfun vr cv vs cv
        cin cF1 cdm wss cY cr cF1 wf cF cfil wcel cF1 wfun vr cv vs cv cin cF
        wcel cY cr cF1 ffun 3ad2ant1 cY cr cF1 wf vr cv vs cv cin cF wcel vr cv
        vs cv cin cF1 cdm wss cF cfil wcel vr cv vs cv cin cF wcel cY cr cF1 wf
        vr cv vs cv cin cF1 cdm wss vr cv vs cv cin cF wcel vr cv vs cv cin cF
        cuni wss vr cv vs cv cin cY wss cY cr cF1 wf vr cv vs cv cin cF1 cdm
        wss wi vr cv vs cv cin cF elssuni cY cF cuni wceq vr cv vs cv cin cF
        cuni wss vr cv vs cv cin cY wss wi lvsovso.1 vr cv vs cv cin cF cuni
        wss vr cv vs cv cin cY wss wi cF cuni cY cF cuni cY wceq vr cv vs cv
        cin cF cuni wss vr cv vs cv cin cY wss cF cuni cY vr cv vs cv cin sseq2
        biimpd eqcoms ax-mp cY cr cF1 wf vr cv vs cv cin cY wss vr cv vs cv cin
        cF1 cdm wss cY cr cF1 wf cY cF1 cdm vr cv vs cv cin cY cr cF1 wf cF1
        cdm cY cY cr cF1 fdm eqcomd sseq2d biimpcd 3syl impcom 3adant2 jca 3exp
        impcom 3adant3 vr cv vs cv cin vx cv cF1 funfvima2 syl6 3imp cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a vr cv vs cv cin cF wcel vx cv vr cv
        vs cv cin wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima wcel cF2 wfun vr
        cv vs cv cin cF2 cdm wss vx cv vr cv vs cv cin wcel vx cv cF2 cfv cF2
        vr cv vs cv cin cima wcel wi cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        vr cv vs cv cin cF wcel wa vr cv vs cv cin vx cv cF2 funfvima2 cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cF2 wfun vr cv vs cv cin cF wcel cY
        cr cF2 wf cF cfil wcel cF2 wfun cY cr cF1 wf cY cr cF2 ffun 3ad2ant3
        adantr cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a vr cv vs cv cin cF
        wcel vr cv vs cv cin cF2 cdm wss cY cr cF2 wf cF cfil wcel vr cv vs cv
        cin cF wcel vr cv vs cv cin cF2 cdm wss wi cY cr cF1 wf vr cv vs cv cin
        cF wcel cY cr cF2 wf vr cv vs cv cin cF2 cdm wss vr cv vs cv cin cF
        wcel vr cv vs cv cin cF cuni wss vr cv vs cv cin cY wss cY cr cF2 wf vr
        cv vs cv cin cF2 cdm wss wi vr cv vs cv cin cF elssuni cY cF cuni wceq
        vr cv vs cv cin cF cuni wss vr cv vs cv cin cY wss wi lvsovso.1 vr cv
        vs cv cin cF cuni wss vr cv vs cv cin cY wss wi cF cuni cY cF cuni cY
        wceq vr cv vs cv cin cF cuni wss vr cv vs cv cin cY wss cF cuni cY vr
        cv vs cv cin sseq2 biimpd eqcoms ax-mp cY cr cF2 wf vr cv vs cv cin cY
        wss vr cv vs cv cin cF2 cdm wss cY cr cF2 wf cY cF2 cdm vr cv vs cv cin
        cY cr cF2 wf cF2 cdm cY cY cr cF2 fdm eqcomd sseq2d biimpcd 3syl com12
        3ad2ant3 imp sylanc 3impia jca 3exp adantr com12 adantl imp31 cF1 vr cv
        vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv
        cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF
        wcel wa cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co
        cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa wa vx
        cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv
        cin cima wcel wa vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co clt wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv
        cF2 cfv clt wbr wa wi vx cv vr cv vs cv cin wcel cF1 vr cv vs cv cin
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa vr cv vs cv cin cF wcel wa
        cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv
        cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima
        wcel wa vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        clt wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv
        clt wbr wa wi cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa
        cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a wa vx cv cF1 cfv
        cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima
        wcel wa vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        clt wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv
        clt wbr wa wi wi vr cv vs cv cin cF wcel cF cfil wcel cY cr cF1 wf cY
        cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr w3a wa cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss wa vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2
        cfv cF2 vr cv vs cv cin cima wcel wa vx cv cF1 cfv cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co clt wbr cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co vx cv cF2 cfv clt wbr wa wi cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv
        c0 wne cL1 cL2 clt wbr w3a wa cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co wceq cF1 vr cv
        vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv
        cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv cF1
        vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima wcel
        wa vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co clt
        wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt
        wbr wa wi wi cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co wceq cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a
        wa cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        wceq cL2 cL1 cmin co cabs cfv c2 cdiv co cL1 cL2 cL1 cmin co cabs cfv
        c2 cdiv co caddc co caddc co cL2 wceq cL1 cr wcel cL2 cr wcel cL1 cL2
        clt wbr w3a cL2 cL1 cmin co cabs cfv c2 cdiv co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co caddc co cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co caddc co cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co cc wcel cL1 cc wcel cL2 cL1 cmin co
        cabs cfv c2 cdiv co cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co caddc co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co caddc
        co wceq cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a cL2 cL1 cmin co
        cabs cfv c2 cdiv co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co add12 cL1
        cr wcel cL2 cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc wcel cL1 cL2
        clt wbr cL1 cr wcel cL2 cr wcel wa cL2 cL1 cmin co cabs cfv cr wcel cL2
        cL1 cmin co cabs cfv cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc
        wcel cL1 cr wcel cL2 cr wcel wa cL2 cc wcel cL1 cc wcel wa cL2 cL1 cmin
        co cc wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cr wcel cL1 cr wcel cL2
        cc wcel cL1 cc wcel wa cL2 cr wcel cL2 cc wcel cL1 cr wcel cL1 cc wcel
        cL2 recn cL1 recn anim12i ancoms cL2 cL1 subcl cL2 cL1 cmin co abscl
        3syl cL2 cL1 cmin co cabs cfv recn cL2 cL1 cmin co cabs cfv halfcl 3syl
        3adant3 cL1 cr wcel cL2 cr wcel cL1 cc wcel cL1 cL2 clt wbr cL1 recn
        3ad2ant1 cL1 cr wcel cL2 cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc
        wcel cL1 cL2 clt wbr cL1 cr wcel cL2 cr wcel wa cL2 cL1 cmin co cabs
        cfv cr wcel cL2 cL1 cmin co cabs cfv cc wcel cL2 cL1 cmin co cabs cfv
        c2 cdiv co cc wcel cL1 cr wcel cL2 cr wcel wa cL2 cc wcel cL1 cc wcel
        wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cr wcel
        cL1 cr wcel cL2 cc wcel cL1 cc wcel wa cL2 cr wcel cL2 cc wcel cL1 cr
        wcel cL1 cc wcel cL2 recn cL1 recn anim12i ancoms cL2 cL1 subcl cL2 cL1
        cmin co abscl 3syl cL2 cL1 cmin co cabs cfv recn cL2 cL1 cmin co cabs
        cfv halfcl 3syl 3adant3 syl3anc cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr
        w3a cL2 cL1 cmin co cL2 cL1 cmin co cabs cfv c2 cdiv co cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co wceq cL1 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co caddc co cL2 wceq cL1
        cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a cL2 cL1 cmin co cabs cfv c2
        cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cL2 cL1 cmin co
        cabs cfv cL2 cL1 cmin co cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a
        cL2 cL1 cmin co cabs cfv cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cL2 cL1 cmin co cabs cfv
        wceq cL1 cr wcel cL2 cr wcel cL2 cL1 cmin co cabs cfv cc wcel cL1 cL2
        clt wbr cL1 cr wcel cL2 cr wcel wa cL2 cL1 cmin co cc wcel cL2 cL1 cmin
        co cabs cfv cr wcel cL2 cL1 cmin co cabs cfv cc wcel cL1 cr wcel cL2 cr
        wcel wa cL2 cc wcel cL1 cc wcel wa cL2 cL1 cmin co cc wcel cL2 cr wcel
        cL1 cr wcel cL2 cc wcel cL1 cc wcel wa cL2 cr wcel cL2 cc wcel cL1 cr
        wcel cL1 cc wcel cL2 recn cL1 recn anim12i ancoms cL2 cL1 subcl syl cL2
        cL1 cmin co abscl cL2 cL1 cmin co cabs cfv recn 3syl 3adant3 cL2 cL1
        cmin co cabs cfv 2halves syl cL2 cL1 cmin co cr wcel cc0 cL2 cL1 cmin
        co cle wbr cL2 cL1 cmin co cabs cfv cL2 cL1 cmin co wceq cL1 cr wcel
        cL2 cr wcel cL1 cL2 clt wbr w3a cL2 cL1 cmin co absid cL1 cr wcel cL2
        cr wcel cL2 cL1 cmin co cr wcel cL1 cL2 clt wbr cL2 cr wcel cL1 cr wcel
        cL2 cL1 cmin co cr wcel cL2 cL1 resubcl ancoms 3adant3 cc0 cr wcel cL2
        cL1 cmin co cr wcel wa cc0 cL2 cL1 cmin co clt wbr cc0 cL2 cL1 cmin co
        cle wbr cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a cc0 cL2 cL1 cmin co
        ltle cL1 cr wcel cL2 cr wcel cc0 cr wcel cL2 cL1 cmin co cr wcel wa cL1
        cL2 clt wbr cL1 cr wcel cL2 cr wcel wa cL2 cL1 cmin co cr wcel cc0 cr
        wcel cL2 cr wcel cL1 cr wcel cL2 cL1 cmin co cr wcel cL2 cL1 resubcl
        ancoms 0re jctil 3adant3 cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr cc0
        cL2 cL1 cmin co clt wbr cL1 cL2 posdif biimp3a sylc sylanc eqtr2d cL1
        cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a cL2 cc wcel cL1 cc wcel cL2 cL1
        cmin co cabs cfv c2 cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc
        co cc wcel w3a cL2 cL1 cmin co cL2 cL1 cmin co cabs cfv c2 cdiv co cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co wceq cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co caddc co
        cL2 wceq wb cL1 cr wcel cL2 cr wcel cL2 cc wcel cL1 cc wcel cL2 cL1
        cmin co cabs cfv c2 cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc
        co cc wcel w3a cL1 cL2 clt wbr cL1 cr wcel cL2 cr wcel wa cL2 cc wcel
        cL1 cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cc wcel cL2 cr wcel cL2 cc wcel cL1 cr wcel cL2
        recn adantl cL1 cr wcel cL1 cc wcel cL2 cr wcel cL1 recn adantr cL1 cr
        wcel cL2 cr wcel wa cL2 cL1 cmin co cabs cfv c2 cdiv co cr wcel cL2 cL1
        cmin co cabs cfv c2 cdiv co cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co
        cc wcel wa cL2 cL1 cmin co cabs cfv c2 cdiv co cL2 cL1 cmin co cabs cfv
        c2 cdiv co caddc co cc wcel cL1 cr wcel cL2 cr wcel wa cL2 cL1 cmin co
        cc wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cL1 cmin co cabs cfv c2
        cdiv co cr wcel cL1 cr wcel cL2 cr wcel wa cL2 cc wcel cL1 cc wcel wa
        cL2 cL1 cmin co cc wcel cL2 cr wcel cL1 cr wcel cL2 cc wcel cL1 cc wcel
        wa cL2 cr wcel cL2 cc wcel cL1 cr wcel cL1 cc wcel cL2 recn cL1 recn
        anim12i ancoms cL2 cL1 subcl syl cL2 cL1 cmin co abscl cL2 cL1 cmin co
        cabs cfv rehalfcl 3syl cL2 cL1 cmin co cabs cfv c2 cdiv co cr wcel cL2
        cL1 cmin co cabs cfv c2 cdiv co cc wcel cL2 cL1 cmin co cabs cfv c2
        cdiv co cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co recn cL2 cL1 cmin
        co cabs cfv c2 cdiv co recn jca cL2 cL1 cmin co cabs cfv c2 cdiv co cL2
        cL1 cmin co cabs cfv c2 cdiv co addcl 3syl 3jca 3adant3 cL2 cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co cL2 cL1 cmin co cabs cfv c2 cdiv co caddc
        co subadd syl mpbid eqtrd cL1 cr wcel cL2 cr wcel cL1 cL2 clt wbr w3a
        cL2 cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc wcel cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cc wcel w3a cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co wceq cL2 cL1 cmin co cabs cfv c2 cdiv co cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co caddc co cL2 wceq wb cL1 cr wcel cL2 cr
        wcel cL2 cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc wcel cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cc wcel w3a cL1 cL2 clt wbr
        cL1 cr wcel cL2 cr wcel wa cL2 cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv
        co cc wcel cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cc wcel cL2
        cr wcel cL2 cc wcel cL1 cr wcel cL2 recn adantl cL1 cr wcel cL2 cr wcel
        wa cL2 cL1 cmin co cabs cfv cr wcel cL2 cL1 cmin co cabs cfv cc wcel
        cL2 cL1 cmin co cabs cfv c2 cdiv co cc wcel cL1 cr wcel cL2 cr wcel wa
        cL2 cL1 cmin co cr wcel cL2 cL1 cmin co cc wcel cL2 cL1 cmin co cabs
        cfv cr wcel cL2 cr wcel cL1 cr wcel cL2 cL1 cmin co cr wcel cL2 cL1
        resubcl ancoms cL2 cL1 cmin co recn cL2 cL1 cmin co abscl 3syl cL2 cL1
        cmin co cabs cfv recn cL2 cL1 cmin co cabs cfv halfcl 3syl cL1 cr wcel
        cL2 cr wcel wa cL1 cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cr wcel
        wa cL1 cc wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc wcel wa cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cc wcel cL1 cr wcel cL2 cr
        wcel wa cL1 cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cr wcel cL1 cr
        wcel cL2 cr wcel pm3.26 cL1 cr wcel cL2 cr wcel wa cL2 cL1 cmin co cc
        wcel cL2 cL1 cmin co cabs cfv cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv
        co cr wcel cL1 cr wcel cL2 cr wcel wa cL2 cc wcel cL1 cc wcel wa cL2
        cL1 cmin co cc wcel cL2 cr wcel cL1 cr wcel cL2 cc wcel cL1 cc wcel wa
        cL2 cr wcel cL2 cc wcel cL1 cr wcel cL1 cc wcel cL2 recn cL1 recn
        anim12i ancoms cL2 cL1 subcl syl cL2 cL1 cmin co abscl cL2 cL1 cmin co
        cabs cfv rehalfcl 3syl jca cL1 cr wcel cL1 cc wcel cL2 cL1 cmin co cabs
        cfv c2 cdiv co cr wcel cL2 cL1 cmin co cabs cfv c2 cdiv co cc wcel cL1
        recn cL2 cL1 cmin co cabs cfv c2 cdiv co recn anim12i cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co addcl 3syl 3jca 3adant3 cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co subadd
        syl mpbird cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cr
        wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL1 cr wcel wi cY cr cF2 wf
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2
        clt wbr w3a cF cfil wcel cY cr cF1 wf wa cL1 cr wcel cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        wa cL1 cr wcel wi cL1 cL2 clt wbr cF cfil wcel cY cr cF1 wf wa cF1 cJ
        cF cflimf co cfv c0 wne cL1 cr wcel cF cfil wcel cY cr cF1 wf cF1 cJ cF
        cflimf co cfv c0 wne cL1 cr wcel cL1 cF1 cJ cF cY lvsovso.1 lvsovso.2
        lvsovso.4 limnumrr 3expia com12 3ad2ant1 com12 3adant3 imp cF cfil wcel
        cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cL2 cr wcel cF cfil wcel cY cr
        cF2 wf cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cL1 cL2 clt wbr w3a cL2 cr wcel wi cY cr cF1 wf cF1 cJ cF cflimf co cfv
        c0 wne cF2 cJ cF cflimf co cfv c0 wne cL1 cL2 clt wbr w3a cF cfil wcel
        cY cr cF2 wf wa cL2 cr wcel cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cY cr cF2 wf wa cL2 cr wcel wi cL1
        cL2 clt wbr cF cfil wcel cY cr cF2 wf wa cF2 cJ cF cflimf co cfv c0 wne
        cL2 cr wcel cF cfil wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne
        cL2 cr wcel cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr
        3expia com12 3ad2ant2 com12 3adant2 imp cF cfil wcel cY cr cF1 wf cY cr
        cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cL1 cL2 clt wbr 3simpr3 syl3anc cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co wceq
        vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs
        cv cin cima wcel wa vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co clt wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx
        cv cF2 cfv clt wbr wa wi vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx
        cv cF2 cfv cF2 vr cv vs cv cin cima wcel wa vx cv cF1 cfv cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co clt wbr cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co vx cv cF2 cfv clt wbr wa wi cF1 vr cv vs cv cin
        cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin
        co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv cin cima
        cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co
        cabs cfv c2 cdiv co caddc co cioo co wss wa cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        wceq vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co clt
        wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt
        wbr wa vx cv cF1 cfv cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        clt wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv
        clt wbr wa vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel vx cv cF2 cfv
        cF2 vr cv vs cv cin cima wcel wa cL2 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co wceq vx cv
        cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co clt wbr vx cv
        cF1 cfv cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co clt wbr cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt wbr cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co vx cv cF1 cfv clt breq2 anbi1d imbi2d cF1 vr cv
        vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv
        cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa vx cv cF1 cfv cF1
        vr cv vs cv cin cima wcel vx cv cF2 cfv cF2 vr cv vs cv cin cima wcel
        wa vx cv cF1 cfv cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co clt
        wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv clt
        wbr wa cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss vx
        cv cF1 cfv cF1 vr cv vs cv cin cima wcel cF2 vr cv vs cv cin cima cL2
        cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co caddc co cioo co wss vx cv cF2 cfv cF2 vr cv vs cv cin
        cima wcel vx cv cF1 cfv cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc
        co clt wbr cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2
        cfv clt wbr wa cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel wa vx cv cF1 cfv cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co clt wbr cF2 vr cv vs cv
        cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss vx cv cF2 cfv cF2 vr
        cv vs cv cin cima wcel wa cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co vx cv cF2 cfv clt wbr cF1 vr cv vs cv cin cima cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co wss vx cv cF1 cfv cF1 vr cv vs cv cin cima wcel wa vx
        cv cF1 cfv cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wcel cL1 cL2 cL1 cmin co
        cabs cfv c2 cdiv co cmin co vx cv cF1 cfv clt wbr vx cv cF1 cfv cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co clt wbr wa vx cv cF1 cfv cL1
        cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co clt wbr cF1 vr cv vs cv
        cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co vx cv cF1 cfv ssel2 vx cv
        cF1 cfv cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co elioooord cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co vx cv cF1 cfv clt wbr vx cv cF1 cfv cL1 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co clt wbr pm3.27 3syl cF2 vr cv vs
        cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co caddc co cioo co wss vx cv cF2 cfv cF2 vr
        cv vs cv cin cima wcel wa vx cv cF2 cfv cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wcel cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv
        clt wbr vx cv cF2 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        clt wbr wa cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2
        cfv clt wbr cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co vx cv cF2 cfv ssel2 vx cv cF2 cfv cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        elioooord cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co vx cv cF2 cfv
        clt wbr vx cv cF2 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        clt wbr pm3.26 3syl anim12i an4s ex syl5bir syl com12 adantr imp adantr
        mpd jca ex vx cv cF1 cfv cr wcel cL2 cL2 cL1 cmin co cabs cfv c2 cdiv
        co cmin co cr wcel vx cv cF2 cfv cr wcel w3a vx cv cF1 cfv cL2 cL2 cL1
        cmin co cabs cfv c2 cdiv co cmin co clt wbr cL2 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co vx cv cF2 cfv clt wbr wa vx cv cF1 cfv vx cv cF2
        cfv clt wbr vx cv cF1 cfv cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co vx cv cF2 cfv axlttrn imp syl6 r19.21aiv ex vr cv vs cv cin cF wcel
        vx cv cF1 cfv vx cv cF2 cfv clt wbr vx vr cv vs cv cin wral vx cv cF1
        cfv vx cv cF2 cfv clt wbr vx va cv wral va cF wrex vx cv cF1 cfv vx cv
        cF2 cfv clt wbr vx va cv wral vx cv cF1 cfv vx cv cF2 cfv clt wbr vx vr
        cv vs cv cin wral va vr cv vs cv cin cF vx cv cF1 cfv vx cv cF2 cfv clt
        wbr vx va cv vr cv vs cv cin raleq1 rcla4ev expcom syl6 ex com14
        pm2.43i cF1 vr cv vs cv cin cima cF1 vr cv cima wss cF2 vr cv vs cv cin
        cima cF2 vs cv cima wss wa cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv
        c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin
        co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa cF1
        vr cv vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv
        vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL2 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss wa wi vr cv vs cv
        cin vr cv wss vr cv vs cv cin vs cv wss cF1 vr cv vs cv cin cima cF1 vr
        cv cima wss cF2 vr cv vs cv cin cima cF2 vs cv cima wss wa vr cv vs cv
        inss1 vr cv vs cv inss2 vr cv vs cv cin vr cv wss cF1 vr cv vs cv cin
        cima cF1 vr cv cima wss vr cv vs cv cin vs cv wss cF2 vr cv vs cv cin
        cima cF2 vs cv cima wss vr cv vs cv cin vr cv cF1 imass2 vr cv vs cv
        cin vs cv cF2 imass2 anim12i mp2an cF1 vr cv vs cv cin cima cF1 vr cv
        cima wss cF1 vr cv cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co
        cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF1 vr cv
        vs cv cin cima cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co cmin co cL1 cL2
        cL1 cmin co cabs cfv c2 cdiv co caddc co cioo co wss cF2 vr cv vs cv
        cin cima cF2 vs cv cima wss cF2 vs cv cima cL2 cL2 cL1 cmin co cabs cfv
        c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co wss cF2 vr cv vs cv cin cima cL2 cL2 cL1 cmin co cabs cfv c2
        cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co cioo
        co wss cF1 vr cv vs cv cin cima cF1 vr cv cima cL1 cL2 cL1 cmin co cabs
        cfv c2 cdiv co cmin co cL1 cL2 cL1 cmin co cabs cfv c2 cdiv co caddc co
        cioo co sstr2 cF2 vr cv vs cv cin cima cF2 vs cv cima cL2 cL2 cL1 cmin
        co cabs cfv c2 cdiv co cmin co cL2 cL2 cL1 cmin co cabs cfv c2 cdiv co
        caddc co cioo co sstr2 im2anan9 ax-mp syl7 syl 3expib com23 3ad2ant1
        anabsi5 com3l imp an4s expcom r19.23aiva com12 r19.23aiva imp mpcom $.
        $( [6-Dec-2010] $) $( [6-Dec-2010] $)
    $}

    ${
      $d F a x $. $d F1 a x $. $d F2 a x $. $d J a x $. $d L1 x $.
      $d L2 x $. $d Y a x $.
      $( Condition on the elements of the filter so that the limits
         are weakly ordered. Bourbaki TG IV.18 prop. 1. $)
      lvsovso2 $p |- ( ( ( F e. Fil /\ F1 : Y --> RR /\ F2 : Y --> RR ) /\
           ( ( ( J fLimf F ) ` F1 ) =/= (/) /\
             ( ( J fLimf F ) ` F2 ) =/= (/) /\
             A. a e. F E. x e. a ( F1 ` x ) <_ ( F2 ` x )  ) )
         ->  L1 <_  L2 ) $=
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne vx cv cF1
        cfv vx cv cF2 cfv cle wbr vx va cv wrex va cF wral w3a cF cfil wcel cY
        cr cF1 wf cY cr cF2 wf w3a cL1 cL2 cle wbr cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne vx cv cF1 cfv vx cv cF2 cfv cle wbr
        vx va cv wrex va cF wral cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cL1
        cL2 cle wbr wi cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv
        c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a vx cv cF1 cfv vx cv
        cF2 cfv cle wbr vx va cv wrex va cF wral cL1 cL2 cle wbr cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf w3a vx cv cF1 cfv vx cv cF2 cfv cle wbr vx va cv
        wrex va cF wral cL1 cL2 cle wbr wi cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        w3a cL1 cL2 cle wbr vx cv cF1 cfv vx cv cF2 cfv cle wbr vx va cv wrex
        va cF wral cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0
        wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a cL2 cL1 clt wbr vx
        cv cF2 cfv vx cv cF1 cfv clt wbr vx va cv wral va cF wrex cL1 cL2 cle
        wbr wn vx cv cF1 cfv vx cv cF2 cfv cle wbr vx va cv wrex va cF wral wn
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a cL2 cL1 clt wbr vx cv cF2 cfv vx cv
        cF1 cfv clt wbr vx va cv wral va cF wrex wi cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf w3a cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv
        c0 wne cL2 cL1 clt wbr vx cv cF2 cfv vx cv cF1 cfv clt wbr vx va cv
        wral va cF wrex wi cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF2 cJ cF
        cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne cL2 cL1 clt wbr vx
        cv cF2 cfv vx cv cF1 cfv clt wbr vx va cv wral va cF wrex cF cfil wcel
        cY cr cF2 wf cY cr cF1 wf cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF
        cflimf co cfv c0 wne cL2 cL1 clt wbr w3a vx cv cF2 cfv vx cv cF1 cfv
        clt wbr vx va cv wral va cF wrex wi cF cfil wcel cY cr cF2 wf cY cr cF1
        wf w3a cF2 cJ cF cflimf co cfv c0 wne cF1 cJ cF cflimf co cfv c0 wne
        cL2 cL1 clt wbr w3a vx cv cF2 cfv vx cv cF1 cfv clt wbr vx va cv wral
        va cF wrex vx cF cJ cY va cF2 cF1 cL2 cL1 lvsovso.1 lvsovso.3 lvsovso.2
        lvsovso.4 lvsovso ex 3com23 3expd com13 3imp cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a w3a cL2 cL1 clt wbr cL1 cL2 cle wbr wn cL2 cxr wcel cL1 cxr wcel
        cL2 cL1 clt wbr cL1 cL2 cle wbr wn wb cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a w3a cL2 cL1 xrltnle cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf
        co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a cF cfil
        wcel cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne w3a cL2 cr wcel cL2
        cxr wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne
        cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a cF cfil wcel cY cr cF2
        wf cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a cF1 cJ cF cflimf co cfv c0 wne cF cfil wcel cF2 cJ cF cflimf co
        cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf 3simp1 3ad2ant3 cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf 3simp3 3ad2ant3 cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a 3simp2
        3jca cL2 cF2 cJ cF cY lvsovso.1 lvsovso.3 lvsovso.4 limnumrr cL2 rexr
        3syl cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a cF cfil wcel cY cr cF1 wf
        cF1 cJ cF cflimf co cfv c0 wne w3a cL1 cr wcel cL1 cxr wcel cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf w3a w3a cF cfil wcel cY cr cF1 wf cF1 cJ cF cflimf
        co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cF2 cJ cF cflimf co cfv c0 wne cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf 3simp1 3ad2ant3 cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cY cr cF1 wf cF2
        cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        3simp2 3ad2ant3 cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv
        c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a 3simp1 3jca cL1 cF1
        cJ cF cY lvsovso.1 lvsovso.2 lvsovso.4 limnumrr cL1 rexr 3syl sylanc
        bicomd cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a vx cv cF1 cfv vx cv cF2 cfv
        cle wbr vx va cv wrex wn va cF wrex vx cv cF2 cfv vx cv cF1 cfv clt wbr
        vx va cv wral va cF wrex vx cv cF1 cfv vx cv cF2 cfv cle wbr vx va cv
        wrex va cF wral wn cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a vx cv cF1 cfv
        vx cv cF2 cfv cle wbr vx va cv wrex wn vx cv cF2 cfv vx cv cF1 cfv clt
        wbr vx va cv wral va cF cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf
        co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va cv cF
        wcel wa vx cv cF1 cfv vx cv cF2 cfv cle wbr wn vx va cv wral vx cv cF2
        cfv vx cv cF1 cfv clt wbr vx va cv wral vx cv cF1 cfv vx cv cF2 cfv cle
        wbr vx va cv wrex wn cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co
        cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va cv cF wcel
        wa vx cv cF1 cfv vx cv cF2 cfv cle wbr wn vx cv cF2 cfv vx cv cF1 cfv
        clt wbr vx va cv cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv
        c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va cv cF wcel wa
        vx va wel wa vx cv cF2 cfv vx cv cF1 cfv clt wbr vx cv cF1 cfv vx cv
        cF2 cfv cle wbr wn vx cv cF2 cfv cxr wcel vx cv cF1 cfv cxr wcel vx cv
        cF2 cfv vx cv cF1 cfv clt wbr vx cv cF1 cfv vx cv cF2 cfv cle wbr wn wb
        cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil
        wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va cv cF wcel wa vx va wel wa vx
        cv cF2 cfv vx cv cF1 cfv xrltnle cF1 cJ cF cflimf co cfv c0 wne cF2 cJ
        cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a
        va cv cF wcel wa vx va wel wa cY cr cF2 wf vx cv cY wcel wa vx cv cF2
        cfv cr wcel vx cv cF2 cfv cxr wcel cF1 cJ cF cflimf co cfv c0 wne cF2
        cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a
        w3a va cv cF wcel wa vx va wel wa cY cr cF2 wf vx cv cY wcel cF1 cJ cF
        cflimf co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr
        cF1 wf cY cr cF2 wf w3a w3a cY cr cF2 wf va cv cF wcel vx va wel cF
        cfil wcel cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne
        cY cr cF2 wf cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf 3simp3 3ad2ant3 ad2antrr cF1 cJ cF cflimf co cfv c0 wne
        cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf
        w3a w3a va cv cF wcel wa vx va wel wa vx cv cF cuni cY cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf w3a w3a va cv cF wcel vx va wel vx cv cF cuni wcel va cv
        cF wcel vx va wel vx cv cF cuni wcel wi wi cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a w3a vx va wel va cv cF wcel vx cv cF cuni wcel vx cv va cv cF
        elunii expcom a1i imp31 lvsovso.1 syl6eleqr jca cY cr vx cv cF2 ffvelrn
        vx cv cF2 cfv rexr 3syl cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF cflimf
        co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va cv cF
        wcel wa vx va wel wa cY cr cF1 wf vx cv cY wcel wa vx cv cF1 cfv cr
        wcel vx cv cF1 cfv cxr wcel cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va
        cv cF wcel wa vx va wel wa cY cr cF1 wf vx cv cY wcel cF1 cJ cF cflimf
        co cfv c0 wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf
        cY cr cF2 wf w3a w3a cY cr cF1 wf va cv cF wcel vx va wel cF cfil wcel
        cY cr cF1 wf cY cr cF2 wf w3a cF1 cJ cF cflimf co cfv c0 wne cY cr cF1
        wf cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2
        wf 3simp2 3ad2ant3 ad2antrr cF1 cJ cF cflimf co cfv c0 wne cF2 cJ cF
        cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a va
        cv cF wcel wa vx va wel wa vx cv cF cuni cY cF1 cJ cF cflimf co cfv c0
        wne cF2 cJ cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2
        wf w3a w3a va cv cF wcel vx va wel vx cv cF cuni wcel va cv cF wcel vx
        va wel vx cv cF cuni wcel wi wi cF1 cJ cF cflimf co cfv c0 wne cF2 cJ
        cF cflimf co cfv c0 wne cF cfil wcel cY cr cF1 wf cY cr cF2 wf w3a w3a
        vx va wel va cv cF wcel vx cv cF cuni wcel vx cv va cv cF elunii expcom
        a1i imp31 lvsovso.1 syl6eleqr jca cY cr vx cv cF1 ffvelrn vx cv cF1 cfv
        rexr 3syl sylanc bicomd ralbidva vx cv cF1 cfv vx cv cF2 cfv cle wbr vx
        va cv ralnex syl5bbr rexbidva vx cv cF1 cfv vx cv cF2 cfv cle wbr vx va
        cv wrex va cF rexnal syl5bbr 3imtr4d con4d 3exp com34 3imp impcom $.
        $( [30-Dec-2010] $) $( [30-Dec-2010] $)
    $}

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Directed multi graphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Dgra $. $( The class of all directed multi graphs. $)

  $( Extend class notation with the class of directed multi graphs. $)
  cmgra $a class Dgra $.

  ${
    $d d c u $.
    $( Definition of a directed multi graph. Loops are allowed and there may
       be more than one edge between the same pair of vertices. Isolated
       points are allowed. $)
    df-mgra $a |- Dgra = { <. <. d , c >. , u >. |
      ( d : dom d --> u /\ c : dom d --> u ) } $.
  $}

  ${ $d C c d u $.  $d D c d u $.  $d U c d u $.
    $( The predicate "is a directed multi graph". $)
    ismgra $p |- ( ( D e. A /\ C e. B /\ U e. F ) ->
    ( <. <. D , C >. , U >. e. Dgra <->
    ( D : dom D --> U /\ C : dom D --> U ) ) ) $=
      cD cA wcel cC cB wcel cU cF wcel w3a cD cC cop cU cop vd cv cdm vu cv vd
      cv wf vd cv cdm vu cv vc cv wf wa vd vc vu copab2 wcel cD cdm cU cD wf cD
      cdm cU cC wf wa cD cC cop cU cop cmgra wcel vd cv cdm vu cv vd cv wf vd
      cv cdm vu cv vc cv wf wa cD cdm vu cv cD wf cD cdm vu cv vc cv wf wa cD
      cdm vu cv cD wf cD cdm vu cv cC wf wa cD cdm cU cD wf cD cdm cU cC wf wa
      vd vc vu cD cC cU cA cB cF vd cv cD wceq vd cv cdm vu cv vd cv wf cD cdm
      vu cv cD wf vd cv cdm vu cv vc cv wf cD cdm vu cv vc cv wf vd cv cD wceq
      vd cv cdm vu cv vd cv wf vd cv cdm vu cv cD wf cD cdm vu cv cD wf vd cv
      cdm vu cv vd cv cD feq1 vd cv cD wceq vd cv cdm cD cdm wceq vd cv cdm vu
      cv cD wf cD cdm vu cv cD wf wb vd cv cD dmeq vd cv cdm cD cdm vu cv cD
      feq2 syl bitrd vd cv cD wceq vd cv cdm cD cdm wceq vd cv cdm vu cv vc cv
      wf cD cdm vu cv vc cv wf wb vd cv cD dmeq vd cv cdm cD cdm vu cv vc cv
      feq2 syl anbi12d vc cv cC wceq cD cdm vu cv vc cv wf cD cdm vu cv cC wf
      cD cdm vu cv cD wf cD cdm vu cv vc cv cC feq1 anbi2d vu cv cU wceq cD cdm
      vu cv cD wf cD cdm cU cD wf cD cdm vu cv cC wf cD cdm cU cC wf vu cv cU
      cD cdm cD feq3 vu cv cU cD cdm cC feq3 anbi12d eloprabg cmgra vd cv cdm
      vu cv vd cv wf vd cv cdm vu cv vc cv wf wa vd vc vu copab2 cD cC cop cU
      cop vu vc vd df-mgra eleq2i syl5bb $.
      $( [10-Jan-2008] $) $( [10-Jan-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Category and deductive system underlying "structure"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Alg $. $( The class of all the "structures" used by ` Ded `
               and ` Cat ` . $)

  $c dom_ $. $( Function returning the function domain of a category. Despite
  its name the domain of a category is not the same concept as the domain of
  a relation. $)

  $c cod_ $. $( Function returning the function codomain of a category. $)

  $c id_ $. $( Function returning the function identity of a category. $)

  $c o_ $. $( Function returning the composition of morphisms of a category. $)


  $( Extend class notation with the class of structures used by
     ` Cat ` and ` Ded ` . $)
  calg $a class Alg $.

  $( Extend class notation with the function returning the function domain of a
     category. $)
  cdom_ $a class dom_ $.

  $( Extend class notation with the function returning the function
     codomain of a category. $)
  ccod_ $a class cod_ $.

  $( Extend class notation with the function returning the function
     identity of a category. $)
  cid_ $a class id_ $.

  $( Extend class notation with the function returning the composition of
     morphisms of a category. $)
  co_ $a class o_ $.

  ${ $d x d c j r $.
    $( ` Ded ` and ` Cat ` structure. Metamath for internal reasons
       doesn't like too large definitions. Then ` Cat ` has been split giving
       birth to ` Ded ` and ` Alg ` . If ` Ded ` has a real mathematical use,
       ` Alg ` is only here to give relief  to Metamath. $)
    df-alg $a |- Alg = { x | E. d E. c E. j E. r
      ( x = <. <. d , c >. , <. j , r >. >. /\
      ( d : dom d --> dom j /\ c : dom d --> dom j /\ j : dom j --> dom d ) /\
      ( Fun r /\ dom r C_ ( dom d X. dom d ) /\ ran r C_ dom d ) ) } $.
  $}

  $( Definition of ` dom_ ` . $)
  df-doma $a |- dom_ = ( 1st o. 1st ) $.

  $( Definition of ` cod_ ` . $)
  df-coda $a |- cod_ = ( 2nd o. 1st ) $.

  $( Definition of ` id_ ` . $)
  df-ida $a |- id_ = ( 1st o. 2nd ) $.

  $( Definition of ` o_ ` . $)
  df-cmpa $a |- o_ = ( 2nd o. 2nd ) $.

  ${ $d C c d j r $.  $d D c d j r $.  $d J c d j r $.  $d M c d j r $.
    $d O c d j r $.  $d R c d j r $.  $d c d j r x $.
    isalg.1 $e |- M = dom D $.
    isalg.2 $e |- O = dom J $.
    $( The predicate "has the structure required by ` Ded ` and ` Cat ` ." $)
    isalg $p |- (  ( ( D e. A /\ C e. B /\ J e. F ) /\ R e. G )
                -> (   <. <. D , C >. , <. J , R >. >. e. Alg
                  <-> (  ( D : M --> O /\ C : M --> O /\ J : O --> M )
                    /\ ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) ) ) $=
      cD cA wcel cC cB wcel cJ cF wcel w3a cR cG wcel wa cD cC cop cJ cR cop
      cop vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd
      cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv
      wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a
      w3a vr wex vj wex vc wex vd wex vx cab wcel cM cO cD wf cM cO cC wf cO cM
      cJ wf w3a cR wfun cR cdm cM cM cxp wss cR crn cM wss w3a wa cD cC cop cJ
      cR cop cop calg wcel cD cA wcel cC cB wcel cJ cF wcel w3a cR cG wcel wa
      cD cC cop cJ cR cop cop vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd
      cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv
      cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv
      crn vd cv cdm wss w3a wa wa vr wex vj wex vc wex vd wex vx cab wcel cM cO
      cD wf cM cO cC wf cO cM cJ wf w3a cR wfun cR cdm cM cM cxp wss cR crn cM
      wss w3a wa cD cC cop cJ cR cop cop vx cv vd cv vc cv cop vj cv vr cv cop
      cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv
      cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp
      wss vr cv crn vd cv cdm wss w3a w3a vr wex vj wex vc wex vd wex vx cab
      wcel vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm
      vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss
      vr cv crn vd cv cdm wss w3a wa cM vj cv cdm cD wf cM vj cv cdm vc cv wf
      vj cv cdm cM vj cv wf w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM
      wss w3a wa cM vj cv cdm cD wf cM vj cv cdm cC wf vj cv cdm cM vj cv wf
      w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss w3a wa cM cO cD
      wf cM cO cC wf cO cM cJ wf w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv
      crn cM wss w3a wa cM cO cD wf cM cO cC wf cO cM cJ wf w3a cR wfun cR cdm
      cM cM cxp wss cR crn cM wss w3a wa vx vd vc vr vj cD cC cJ cR cA cB cF cG
      vd cv cD wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf
      vj cv cdm vd cv cdm vj cv wf w3a cM vj cv cdm cD wf cM vj cv cdm vc cv wf
      vj cv cdm cM vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp
      wss vr cv crn vd cv cdm wss w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv
      crn cM wss w3a vd cv cD wceq vd cv cdm vj cv cdm vd cv wf cM vj cv cdm cD
      wf vd cv cdm vj cv cdm vc cv wf cM vj cv cdm vc cv wf vj cv cdm vd cv cdm
      vj cv wf vj cv cdm cM vj cv wf vd cv cD wceq vd cv cdm vj cv cdm vd cv wf
      vd cv cdm vj cv cdm cD wf cM vj cv cdm cD wf vd cv cdm vj cv cdm vd cv cD
      feq1 vd cv cD wceq vd cv cdm cD cdm wceq vd cv cdm cM wceq vd cv cdm vj
      cv cdm cD wf cM vj cv cdm cD wf wb vd cv cD dmeq vd cv cdm cD cdm wceq vd
      cv cdm cM wceq cD cdm cM vd cv cdm cM cD cdm isalg.1 eqcomi eqeq2i biimpi
      vd cv cdm cM vj cv cdm cD feq2 3syl bitrd vd cv cD wceq vd cv cdm cD cdm
      wceq vd cv cdm cM wceq vd cv cdm vj cv cdm vc cv wf cM vj cv cdm vc cv wf
      wb vd cv cD dmeq vd cv cdm cD cdm wceq vd cv cdm cM wceq cD cdm cM vd cv
      cdm cM cD cdm isalg.1 eqcomi eqeq2i biimpi vd cv cdm cM vj cv cdm vc cv
      feq2 3syl vd cv cD wceq vd cv cdm cD cdm wceq vd cv cdm cM wceq vj cv cdm
      vd cv cdm vj cv wf vj cv cdm cM vj cv wf wb vd cv cD dmeq vd cv cdm cD
      cdm wceq vd cv cdm cM wceq cD cdm cM vd cv cdm cM cD cdm isalg.1 eqcomi
      eqeq2i biimpi vd cv cdm cM vj cv cdm vj cv feq3 3syl 3anbi123d vd cv cD
      wceq vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv cdm cM cM cxp wss vr cv
      crn vd cv cdm wss vr cv crn cM wss vr cv wfun vd cv cD wceq vd cv cdm cM
      wceq vd cv cdm vd cv cdm cxp cM cM cxp wceq vr cv cdm vd cv cdm vd cv cdm
      cxp wss vr cv cdm cM cM cxp wss wb vd cv cD wceq vd cv cdm cD cdm cM vd
      cv cD dmeq isalg.1 syl6eqr vd cv cdm vd cv cdm cxp cM cM cxp wceq vd cv
      cdm cM wceq vd cv cdm cM xpid11 biimpri vd cv cdm vd cv cdm cxp cM cM cxp
      vr cv cdm sseq2 3syl vd cv cD wceq vd cv cdm cD cdm wceq vd cv cdm cM
      wceq vr cv crn vd cv cdm wss vr cv crn cM wss wb vd cv cD dmeq vd cv cdm
      cD cdm wceq vd cv cdm cM wceq cD cdm cM vd cv cdm cM cD cdm isalg.1
      eqcomi eqeq2i biimpi vd cv cdm cM vr cv crn sseq2 3syl 3anbi23d anbi12d
      vc cv cC wceq cM vj cv cdm cD wf cM vj cv cdm vc cv wf vj cv cdm cM vj cv
      wf w3a cM vj cv cdm cD wf cM vj cv cdm cC wf vj cv cdm cM vj cv wf w3a vr
      cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss w3a vc cv cC wceq cM vj
      cv cdm vc cv wf cM vj cv cdm cC wf cM vj cv cdm cD wf vj cv cdm cM vj cv
      wf cM vj cv cdm vc cv cC feq1 3anbi2d anbi1d vj cv cJ wceq cM vj cv cdm
      cD wf cM vj cv cdm cC wf vj cv cdm cM vj cv wf w3a cM cO cD wf cM cO cC
      wf cO cM cJ wf w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss
      w3a vj cv cJ wceq cM vj cv cdm cD wf cM cO cD wf cM vj cv cdm cC wf cM cO
      cC wf vj cv cdm cM vj cv wf cO cM cJ wf vj cv cJ wceq vj cv cdm cJ cdm
      wceq vj cv cdm cO wceq cM vj cv cdm cD wf cM cO cD wf wb vj cv cJ dmeq vj
      cv cdm cJ cdm wceq vj cv cdm cO wceq cJ cdm cO vj cv cdm cO cJ cdm
      isalg.2 eqcomi eqeq2i biimpi vj cv cdm cO cM cD feq3 3syl vj cv cJ wceq
      vj cv cdm cJ cdm wceq vj cv cdm cO wceq cM vj cv cdm cC wf cM cO cC wf wb
      vj cv cJ dmeq vj cv cdm cJ cdm wceq vj cv cdm cO wceq cJ cdm cO vj cv cdm
      cO cJ cdm isalg.2 eqcomi eqeq2i biimpi vj cv cdm cO cM cC feq3 3syl vj cv
      cJ wceq vj cv cdm cM vj cv wf vj cv cdm cM cJ wf cO cM cJ wf vj cv cdm cM
      vj cv cJ feq1 vj cv cJ wceq vj cv cdm cJ cdm wceq vj cv cdm cO wceq vj cv
      cdm cM cJ wf cO cM cJ wf wb vj cv cJ dmeq vj cv cdm cJ cdm wceq vj cv cdm
      cO wceq cJ cdm cO vj cv cdm cO cJ cdm isalg.2 eqcomi eqeq2i biimpi vj cv
      cdm cO cM cJ feq2 3syl bitrd 3anbi123d anbi1d vr cv cR wceq vr cv wfun vr
      cv cdm cM cM cxp wss vr cv crn cM wss w3a cR wfun cR cdm cM cM cxp wss cR
      crn cM wss w3a cM cO cD wf cM cO cC wf cO cM cJ wf w3a vr cv cR wceq vr
      cv wfun cR wfun vr cv cdm cM cM cxp wss cR cdm cM cM cxp wss vr cv crn cM
      wss cR crn cM wss vr cv cR funeq vr cv cR wceq vr cv cdm cR cdm cM cM cxp
      vr cv cR dmeq sseq1d vr cv cR wceq vr cv crn cR crn cM vr cv cR rneq
      sseq1d 3anbi123d anbi2d elo vx cv vd cv vc cv cop vj cv vr cv cop cop
      wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm
      vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss
      vr cv crn vd cv cdm wss w3a w3a vr wex vj wex vc wex vd wex vx cab vx cv
      vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd
      cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr
      cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr
      wex vj wex vc wex vd wex vx cab cD cC cop cJ cR cop cop vx cv vd cv vc cv
      cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv
      cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv
      cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a w3a vr wex vj wex vc
      wex vd wex vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv
      cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf
      w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm
      wss w3a wa wa vr wex vj wex vc wex vd wex vx vx cv vd cv vc cv cop vj cv
      vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv
      wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv
      cdm cxp wss vr cv crn vd cv cdm wss w3a w3a vr wex vx cv vd cv vc cv cop
      vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm
      vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm
      vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr wex vd vc vj vx cv
      vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd
      cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr
      cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a w3a vx cv
      vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd
      cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr
      cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr
      vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv
      wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv
      wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a
      3anass exbii 3exbii abbii eleq2i syl5bb calg vx cv vd cv vc cv cop vj cv
      vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv
      wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv
      cdm cxp wss vr cv crn vd cv cdm wss w3a w3a vr wex vj wex vc wex vd wex
      vx cab cD cC cop cJ cR cop cop vx vj vr vc vd df-alg eleq2i syl5bb $.
      $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  ${
    1alg.1 $e |- A e. _V $.
    $( Category ` 1 ` has the structure required by ` Ded ` and ` Cat ` . $)
    1alg $p |- <. <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >. ,
      <. { <. A , <. A , A >. >. } , { <. <. <. A , A >. , <. A , A >. >. ,
      <. A , A >. >. } >. >. e. Alg $=
      cA cA cop cA cop csn cA cA cop cA cop csn cop cA cA cA cop cop csn cA cA
      cop cA cA cop cop cA cA cop cop csn cop cop calg wcel cA cA cop csn cA
      csn cA cA cop cA cop csn wf cA cA cop csn cA csn cA cA cop cA cop csn wf
      cA csn cA cA cop csn cA cA cA cop cop csn wf w3a cA cA cop cA cA cop cop
      cA cA cop cop csn wfun cA cA cop cA cA cop cop cA cA cop cop csn cdm cA
      cA cop csn cA cA cop csn cxp wss cA cA cop cA cA cop cop cA cA cop cop
      csn crn cA cA cop csn wss w3a cA cA cop cA cop csn cvv wcel cA cA cop cA
      cop csn cvv wcel cA cA cA cop cop csn cvv wcel w3a cA cA cop cA cA cop
      cop cA cA cop cop csn cvv wcel cA cA cop cA cop csn cA cA cop cA cop csn
      cop cA cA cA cop cop csn cA cA cop cA cA cop cop cA cA cop cop csn cop
      cop calg wcel cA cA cop csn cA csn cA cA cop cA cop csn wf cA cA cop csn
      cA csn cA cA cop cA cop csn wf cA csn cA cA cop csn cA cA cA cop cop csn
      wf w3a cA cA cop cA cA cop cop cA cA cop cop csn wfun cA cA cop cA cA cop
      cop cA cA cop cop csn cdm cA cA cop csn cA cA cop csn cxp wss cA cA cop
      cA cA cop cop cA cA cop cop csn crn cA cA cop csn wss w3a wa wb cA cA cop
      cA cop csn cvv wcel cA cA cop cA cop csn cvv wcel cA cA cA cop cop csn
      cvv wcel cA cA cop cA cop snex cA cA cop cA cop snex cA cA cA cop cop
      snex 3pm3.2i cA cA cop cA cA cop cop cA cA cop cop snex cvv cvv cA cA cop
      cA cop csn cA cA cop cA cop csn cA cA cop cA cA cop cop cA cA cop cop csn
      cvv cvv cA cA cA cop cop csn cA cA cop csn cA csn cA cA cop cA cop csn
      cdm cA cA cop csn cA cA cop cA dmsnop eqcomi cA cA cA cop cop csn cdm cA
      csn cA cA cA cop dmsnop eqcomi isalg mp2an cA cA cop csn cA csn cA cA cop
      cA cop csn wf cA cA cop csn cA csn cA cA cop cA cop csn wf cA csn cA cA
      cop csn cA cA cA cop cop csn wf cA cA cop csn cA csn cA cA cop cA cop csn
      wf1o cA cA cop csn cA csn cA cA cop cA cop csn wf cA cA cop cA cA cA opex
      1alg.1 f1osn cA cA cop csn cA csn cA cA cop cA cop csn f1of ax-mp cA cA
      cop csn cA csn cA cA cop cA cop csn wf1o cA cA cop csn cA csn cA cA cop
      cA cop csn wf cA cA cop cA cA cA opex 1alg.1 f1osn cA cA cop csn cA csn
      cA cA cop cA cop csn f1of ax-mp cA csn cA cA cop csn cA cA cA cop cop csn
      wf1o cA csn cA cA cop csn cA cA cA cop cop csn wf cA cA cA cop 1alg.1 cA
      cA opex f1osn cA csn cA cA cop csn cA cA cA cop cop csn f1of ax-mp
      3pm3.2i cA cA cop cA cA cop cop cA cA cop cop csn wfun cA cA cop cA cA
      cop cop cA cA cop cop csn cdm cA cA cop csn cA cA cop csn cxp wss cA cA
      cop cA cA cop cop cA cA cop cop csn crn cA cA cop csn wss cA cA cop cA cA
      cop cop cA cA cop cA cA cop cA cA cop opex cA cA opex funsn cA cA cop cA
      cA cop cop cA cA cop cop csn cdm cA cA cop cA cA cop cop csn cA cA cop
      csn cA cA cop csn cxp cA cA cop cA cA cop cop cA cA cop dmsnop cA cA cop
      csn cA cA cop csn cA cA cop cA cA cop cop csn wf cA cA cop cA cA cop cop
      csn cA cA cop csn cA cA cop csn cxp wss cA cA cop csn cA cA cop csn cA cA
      cop cA cA cop cop csn wf1o cA cA cop csn cA cA cop csn cA cA cop cA cA
      cop cop csn wf cA cA cop cA cA cop cA cA opex cA cA opex f1osn cA cA cop
      csn cA cA cop csn cA cA cop cA cA cop cop csn f1of ax-mp cA cA cop csn cA
      cA cop csn cA cA cop cA cA cop cop csn fssxp ax-mp eqsstri cA cA cop cA
      cA cop cop cA cA cop cop csn crn cA cA cop csn cA cA cop cA cA cop cop cA
      cA cop cA cA cop cA cA cop opex cA cA opex rnsnop eqimssi 3pm3.2i
      mpbir2an $.
      $( [31-Oct-2007] $) $( [30-Oct-2007] $)
  $}

  ${
    domval.1 $e |- D = ( dom_ ` T ) $.
    $( Value of the domain function expressed with the ` 1st ` function. $)
    domval $p |- D = ( 1st ` ( 1st ` T ) ) $=
      cD cT cdom_ cfv cT c1st cfv c1st cfv domval.1 cT cvv wcel cT cdom_ cfv cT
      c1st cfv c1st cfv wceq cT cvv wcel cT c1st c1st ccom cfv cT c1st cfv c1st
      cfv cT cdom_ cfv c1st wfun cvv cvv c1st wf cT cvv wcel cT c1st c1st ccom
      cfv cT c1st cfv c1st cfv wceq cvv cvv c1st wfo c1st wfun fo1st cvv cvv
      c1st fofun ax-mp cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof
      ax-mp cvv cvv cT c1st c1st fvco3 mp3an12 cT cdom_ c1st c1st ccom df-doma
      fveq1i syl5eq cT cvv wcel wn cT cdom_ cfv c0 cT c1st cfv c1st cfv cT
      cdom_ fvprc cT cvv wcel wn cT c1st cfv c1st cfv c0 c1st cfv c0 cT cvv
      wcel wn cT c1st cfv c0 c1st cT c1st fvprc fveq2d 1st0 syl6req eqtrd
      pm2.61i eqtri $.
      $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  ${
    codval.1 $e |- C = ( cod_ ` T ) $.
    $( Value of the function codomain expressed with the ` 1st ` and ` 2nd `
       functions. $)
    codval $p |- C = ( 2nd ` ( 1st ` T ) ) $=
      cC cT ccod_ cfv cT c1st cfv c2nd cfv codval.1 cT cvv wcel cT ccod_ cfv cT
      c1st cfv c2nd cfv wceq cT cvv wcel cT c2nd c1st ccom cfv cT c1st cfv c2nd
      cfv cT ccod_ cfv c2nd wfun cvv cvv c1st wf cT cvv wcel cT c2nd c1st ccom
      cfv cT c1st cfv c2nd cfv wceq cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv
      c2nd fofun ax-mp cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof
      ax-mp cvv cvv cT c2nd c1st fvco3 mp3an12 cT ccod_ c2nd c1st ccom df-coda
      fveq1i syl5eq cT cvv wcel wn cT ccod_ cfv c0 cT c1st cfv c2nd cfv cT
      ccod_ fvprc cT cvv wcel wn cT c1st cfv c2nd cfv c0 c2nd cfv c0 cT cvv
      wcel wn cT c1st cfv c0 c2nd cT c1st fvprc fveq2d 2nd0 syl6req eqtrd
      pm2.61i eqtri $.
      $( [28-Oct-2007] $) $( [26-Oct-2007] $)
  $}

  ${
    idval.1 $e |- J = ( id_ ` T ) $.
    $( Value of the identity function expressed with the ` 1st ` and ` 2nd `
       functions. $)
    idval $p |- J = ( 1st ` ( 2nd ` T ) ) $=
      cJ cT cid_ cfv cT c2nd cfv c1st cfv idval.1 cT cvv wcel cT cid_ cfv cT
      c2nd cfv c1st cfv wceq cT cvv wcel cT c1st c2nd ccom cfv cT c2nd cfv c1st
      cfv cT cid_ cfv c1st wfun cvv cvv c2nd wf cT cvv wcel cT c1st c2nd ccom
      cfv cT c2nd cfv c1st cfv wceq cvv cvv c1st wfo c1st wfun fo1st cvv cvv
      c1st fofun ax-mp cvv cvv c2nd wfo cvv cvv c2nd wf fo2nd cvv cvv c2nd fof
      ax-mp cvv cvv cT c1st c2nd fvco3 mp3an12 cT cid_ c1st c2nd ccom df-ida
      fveq1i syl5eq cT cvv wcel wn cT cid_ cfv c0 cT c2nd cfv c1st cfv cT cid_
      fvprc cT cvv wcel wn cT c2nd cfv c1st cfv c0 c1st cfv c0 cT cvv wcel wn
      cT c2nd cfv c0 c1st cT c2nd fvprc fveq2d 1st0 syl6req eqtrd pm2.61i eqtri
      $.
      $( [28-Oct-2007] $) $( [26-Oct-2007] $)
  $}

  ${
    cmpval.1 $e |- G = ( o_ ` T ) $.
    $( Value of the identity function expressed with the ` 2nd `functions. $)
    cmpval $p |- G = ( 2nd ` ( 2nd ` T ) ) $=
      cG cT co_ cfv cT c2nd cfv c2nd cfv cmpval.1 cT cvv wcel cT co_ cfv cT
      c2nd cfv c2nd cfv wceq cT cvv wcel cT c2nd c2nd ccom cfv cT c2nd cfv c2nd
      cfv cT co_ cfv c2nd wfun cvv cvv c2nd wf cT cvv wcel cT c2nd c2nd ccom
      cfv cT c2nd cfv c2nd cfv wceq cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv
      c2nd fofun ax-mp cvv cvv c2nd wfo cvv cvv c2nd wf fo2nd cvv cvv c2nd fof
      ax-mp cvv cvv cT c2nd c2nd fvco3 mp3an12 cT co_ c2nd c2nd ccom df-cmpa
      fveq1i syl5eq cT cvv wcel wn cT co_ cfv c0 cT c2nd cfv c2nd cfv cT co_
      fvprc cT cvv wcel wn cT c2nd cfv c2nd cfv c0 c2nd cfv c0 cT cvv wcel wn
      cT c2nd cfv c0 c2nd cT c2nd fvprc fveq2d 2nd0 syl6req eqtrd pm2.61i eqtri
      $.
      $( [28-Oct-2007] $) $( [26-Oct-2007] $)
  $}

  ${ $d C c d j r $.  $d D c d j r $.  $d J c d j r $.  $d M c d j r $.
  $d O c d j r $.  $d R c d j r $.  $d T c d j r x $.
     algi.1 $e |- D = ( dom_ ` T ) $.
     algi.2 $e |- C = ( cod_ ` T ) $.
     algi.3 $e |- J = ( id_ ` T ) $.
     algi.4 $e |- R = ( o_ ` T ) $.
     algi.5 $e |- M = dom D $.
     algi.6 $e |- O = dom J $.
     $( "Axiomatic" properties of ` Alg ` . $)
     algi $p |- ( T e. Alg
         -> (  ( D : M --> O /\ C : M --> O /\ J : O --> M )
               /\ ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) ) $=
       cT calg wcel cT vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm
       vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj
       cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd
       cv cdm wss w3a w3a vr wex vj wex vc wex vd wex vx cab wcel cM cO cD wf
       cM cO cC wf cO cM cJ wf w3a cR wfun cR cdm cM cM cxp wss cR crn cM wss
       w3a wa calg vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj
       cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv
       wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv
       cdm wss w3a w3a vr wex vj wex vc wex vd wex vx cab cT vx vj vr vc vd
       df-alg eleq2i cT vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv
       cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm
       vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn
       vd cv cdm wss w3a w3a vr wex vj wex vc wex vd wex vx cab wcel cT vx cv
       vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd
       cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr
       cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr
       wex vj wex vc wex vd wex vx cab wcel cM cO cD wf cM cO cC wf cO cM cJ wf
       w3a cR wfun cR cdm cM cM cxp wss cR crn cM wss w3a wa vx cv vd cv vc cv
       cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj
       cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd
       cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr wex vj wex
       vc wex vd wex vx cab vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd
       cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv
       cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv
       crn vd cv cdm wss w3a w3a vr wex vj wex vc wex vd wex vx cab cT vx cv vd
       cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv
       cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv
       cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr wex
       vj wex vc wex vd wex vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd
       cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv
       cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv
       crn vd cv cdm wss w3a w3a vr wex vj wex vc wex vd wex vx vx cv vd cv vc
       cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm
       vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm
       vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa wa vr wex vx
       cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj cv cdm vd cv wf
       vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun
       vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a w3a vr
       wex vd vc vj vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv cdm vj
       cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv
       wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn vd cv
       cdm wss w3a wa wa vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv
       cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv cdm
       vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn
       vd cv cdm wss w3a w3a vr vx cv vd cv vc cv cop vj cv vr cv cop cop wceq
       vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd
       cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr
       cv crn vd cv cdm wss w3a w3a vx cv vd cv vc cv cop vj cv vr cv cop cop
       wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm
       vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss
       vr cv crn vd cv cdm wss w3a wa wa vx cv vd cv vc cv cop vj cv vr cv cop
       cop wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv
       cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp
       wss vr cv crn vd cv cdm wss w3a 3anass bicomi exbii 3exbii abbii eleq2i
       vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd
       cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr
       cv crn vd cv cdm wss w3a wa cM vj cv cdm cD wf cM vj cv cdm vc cv wf vj
       cv cdm cM vj cv wf w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM
       wss w3a wa cM vj cv cdm cD wf cM vj cv cdm cC wf vj cv cdm cM vj cv wf
       w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss w3a wa cM cO cD
       wf cM cO cC wf cO cM cJ wf w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv
       crn cM wss w3a wa cM cO cD wf cM cO cC wf cO cM cJ wf w3a cR wfun cR cdm
       cM cM cxp wss cR crn cM wss w3a wa vx vd vc vr vj cT vd cv cT c1st cfv
       c1st cfv wceq vd cv cD wceq vd cv cdm vj cv cdm vd cv wf vd cv cdm vj cv
       cdm vc cv wf vj cv cdm vd cv cdm vj cv wf w3a vr cv wfun vr cv cdm vd cv
       cdm vd cv cdm cxp wss vr cv crn vd cv cdm wss w3a wa cM vj cv cdm cD wf
       cM vj cv cdm vc cv wf vj cv cdm cM vj cv wf w3a vr cv wfun vr cv cdm cM
       cM cxp wss vr cv crn cM wss w3a wa wb cT c1st cfv c1st cfv cD vd cv cD
       cT c1st cfv c1st cfv cD cT algi.1 domval eqcomi eqeq2i vd cv cD wceq vd
       cv cdm vj cv cdm vd cv wf vd cv cdm vj cv cdm vc cv wf vj cv cdm vd cv
       cdm vj cv wf w3a cM vj cv cdm cD wf cM vj cv cdm vc cv wf vj cv cdm cM
       vj cv wf w3a vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv crn
       vd cv cdm wss w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss
       w3a vd cv cD wceq vd cv cdm vj cv cdm vd cv wf cM vj cv cdm cD wf vd cv
       cdm vj cv cdm vc cv wf cM vj cv cdm vc cv wf vj cv cdm vd cv cdm vj cv
       wf vj cv cdm cM vj cv wf vd cv cD wceq vd cv cdm vj cv cdm vd cv wf vd
       cv cdm vj cv cdm cD wf cM vj cv cdm cD wf vd cv cdm vj cv cdm vd cv cD
       feq1 vd cv cD wceq vd cv cdm vj cv cdm cD wf cD cdm vj cv cdm cD wf cM
       vj cv cdm cD wf vd cv cD wceq vd cv cdm cD cdm wceq vd cv cdm vj cv cdm
       cD wf cD cdm vj cv cdm cD wf wb vd cv cD dmeq vd cv cdm cD cdm vj cv cdm
       cD feq2 syl cM cD cdm wceq cM vj cv cdm cD wf cD cdm vj cv cdm cD wf wb
       algi.5 cM cD cdm vj cv cdm cD feq2 ax-mp syl6bbr bitrd vd cv cD wceq vd
       cv cdm cD cdm wceq vd cv cdm vj cv cdm vc cv wf cM vj cv cdm vc cv wf wb
       vd cv cD dmeq vd cv cdm cD cdm wceq vd cv cdm vj cv cdm vc cv wf cD cdm
       vj cv cdm vc cv wf cM vj cv cdm vc cv wf vd cv cdm cD cdm vj cv cdm vc
       cv feq2 cM cD cdm wceq cM vj cv cdm vc cv wf cD cdm vj cv cdm vc cv wf
       wb algi.5 cM cD cdm vj cv cdm vc cv feq2 ax-mp syl6bbr syl vd cv cD wceq
       vd cv cdm cD cdm wceq vd cv cdm cM wceq vj cv cdm vd cv cdm vj cv wf vj
       cv cdm cM vj cv wf wb vd cv cD dmeq vd cv cdm cD cdm wceq vd cv cdm cM
       wceq cD cdm cM vd cv cdm cM cD cdm algi.5 eqcomi eqeq2i biimpi vd cv cdm
       cM vj cv cdm vj cv feq3 3syl 3anbi123d vd cv cD wceq vd cv cdm cD cdm
       wceq vd cv cdm cM wceq vr cv wfun vr cv cdm vd cv cdm vd cv cdm cxp wss
       vr cv crn vd cv cdm wss w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn
       cM wss w3a wb vd cv cD dmeq vd cv cdm cD cdm wceq vd cv cdm cM wceq cD
       cdm cM vd cv cdm cM cD cdm algi.5 eqcomi eqeq2i biimpi vd cv cdm cM wceq
       vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv cdm cM cM cxp wss vr cv crn
       vd cv cdm wss vr cv crn cM wss vr cv wfun vd cv cdm cM wceq vd cv cdm vd
       cv cdm cxp cM cM cxp wceq vr cv cdm vd cv cdm vd cv cdm cxp wss vr cv
       cdm cM cM cxp wss wb vd cv cdm cM xpid11 vd cv cdm vd cv cdm cxp cM cM
       cxp vr cv cdm sseq2 sylbir vd cv cdm cM vr cv crn sseq2 3anbi23d 3syl
       anbi12d sylbi vc cv cT c1st cfv c2nd cfv wceq vc cv cC wceq cM vj cv cdm
       cD wf cM vj cv cdm vc cv wf vj cv cdm cM vj cv wf w3a vr cv wfun vr cv
       cdm cM cM cxp wss vr cv crn cM wss w3a wa cM vj cv cdm cD wf cM vj cv
       cdm cC wf vj cv cdm cM vj cv wf w3a vr cv wfun vr cv cdm cM cM cxp wss
       vr cv crn cM wss w3a wa wb cT c1st cfv c2nd cfv cC vc cv cC cT c1st cfv
       c2nd cfv cC cT algi.2 codval eqcomi eqeq2i vc cv cC wceq cM vj cv cdm cD
       wf cM vj cv cdm vc cv wf vj cv cdm cM vj cv wf w3a cM vj cv cdm cD wf cM
       vj cv cdm cC wf vj cv cdm cM vj cv wf w3a vr cv wfun vr cv cdm cM cM cxp
       wss vr cv crn cM wss w3a vc cv cC wceq cM vj cv cdm vc cv wf cM vj cv
       cdm cC wf cM vj cv cdm cD wf vj cv cdm cM vj cv wf cM vj cv cdm vc cv cC
       feq1 3anbi2d anbi1d sylbi vj cv cT c2nd cfv c1st cfv wceq vj cv cJ wceq
       cM vj cv cdm cD wf cM vj cv cdm cC wf vj cv cdm cM vj cv wf w3a vr cv
       wfun vr cv cdm cM cM cxp wss vr cv crn cM wss w3a wa cM cO cD wf cM cO
       cC wf cO cM cJ wf w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM
       wss w3a wa wb cT c2nd cfv c1st cfv cJ vj cv cJ cT c2nd cfv c1st cfv cT
       cJ algi.3 idval eqcomi eqeq2i vj cv cJ wceq cM vj cv cdm cD wf cM vj cv
       cdm cC wf vj cv cdm cM vj cv wf w3a cM cO cD wf cM cO cC wf cO cM cJ wf
       w3a vr cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss w3a vj cv cJ
       wceq cM vj cv cdm cD wf cM cO cD wf cM vj cv cdm cC wf cM cO cC wf vj cv
       cdm cM vj cv wf cO cM cJ wf vj cv cJ wceq vj cv cdm cJ cdm wceq vj cv
       cdm cO wceq cM vj cv cdm cD wf cM cO cD wf wb vj cv cJ dmeq vj cv cdm cJ
       cdm wceq vj cv cdm cO wceq cJ cdm cO vj cv cdm cO cJ cdm algi.6 eqcomi
       eqeq2i biimpi vj cv cdm cO cM cD feq3 3syl vj cv cJ wceq vj cv cdm cJ
       cdm wceq vj cv cdm cO wceq cM vj cv cdm cC wf cM cO cC wf wb vj cv cJ
       dmeq vj cv cdm cJ cdm wceq vj cv cdm cO wceq cJ cdm cO vj cv cdm cO cJ
       cdm algi.6 eqcomi eqeq2i biimpi vj cv cdm cO cM cC feq3 3syl vj cv cJ
       wceq vj cv cdm cM vj cv wf vj cv cdm cM cJ wf cO cM cJ wf vj cv cdm cM
       vj cv cJ feq1 vj cv cJ wceq vj cv cdm cJ cdm wceq vj cv cdm cO wceq vj
       cv cdm cM cJ wf cO cM cJ wf wb vj cv cJ dmeq vj cv cdm cJ cdm wceq vj cv
       cdm cO wceq cJ cdm cO vj cv cdm cO cJ cdm algi.6 eqcomi eqeq2i biimpi vj
       cv cdm cO cM cJ feq2 3syl bitrd 3anbi123d anbi1d sylbi vr cv cT c2nd cfv
       c2nd cfv wceq vr cv cR wceq cM cO cD wf cM cO cC wf cO cM cJ wf w3a vr
       cv wfun vr cv cdm cM cM cxp wss vr cv crn cM wss w3a wa cM cO cD wf cM
       cO cC wf cO cM cJ wf w3a cR wfun cR cdm cM cM cxp wss cR crn cM wss w3a
       wa wb cT c2nd cfv c2nd cfv cR vr cv cR cT c2nd cfv c2nd cfv cT cR algi.4
       cmpval eqcomi eqeq2i vr cv cR wceq vr cv wfun vr cv cdm cM cM cxp wss vr
       cv crn cM wss w3a cR wfun cR cdm cM cM cxp wss cR crn cM wss w3a cM cO
       cD wf cM cO cC wf cO cM cJ wf w3a vr cv cR wceq vr cv wfun cR wfun vr cv
       cdm cM cM cxp wss cR cdm cM cM cxp wss vr cv crn cM wss cR crn cM wss vr
       cv cR funeq vr cv cR wceq vr cv cdm cR cdm cM cM cxp vr cv cR dmeq
       sseq1d vr cv cR wceq vr cv crn cR crn cM vr cv cR rneq sseq1d 3anbi123d
       anbi2d sylbi eloi sylbir sylbi $.
       $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  ${

    alg.1 $e |- M = dom D $.
    alg.3 $e |- D = ( dom_ ` T ) $.
    ${
      alg.2 $e |- O = dom J $.
      alg.5 $e |- J = ( id_ ` T ) $.

      ${
        $( ` ( dom_ `` T ) ` is a mapping from the morphisms of ` T ` to
           the objects of ` T ` . $)
        doma $p |- ( T e. Alg -> D : M --> O ) $=
          cT calg wcel cM cO cD wf cM cO cT ccod_ cfv wf cO cM cJ wf cT calg
          wcel cM cO cD wf cM cO cT ccod_ cfv wf cO cM cJ wf w3a cT co_ cfv
          wfun cT co_ cfv cdm cM cM cxp wss cT co_ cfv crn cM wss w3a cT ccod_
          cfv cD cT co_ cfv cT cJ cM cO alg.3 cT ccod_ cfv eqid alg.5 cT co_
          cfv eqid alg.1 alg.2 algi pm3.26d 3simp1d $.
          $( [28-Oct-2007] $) $( [24-Oct-2007] $)
      $}

      ${
        alg.4 $e |- C = ( cod_ ` T ) $.
        $( ` ( cod_ `` T ) ` is a mapping from the morphisms of
           ` T ` to  the objects of ` T ` . $)
        coda $p |- ( T e. Alg -> C : M --> O ) $=
          cT calg wcel cM cO cD wf cM cO cC wf cO cM cJ wf cT calg wcel cM cO
          cD wf cM cO cC wf cO cM cJ wf w3a cT co_ cfv wfun cT co_ cfv cdm cM
          cM cxp wss cT co_ cfv crn cM wss w3a cC cD cT co_ cfv cT cJ cM cO
          alg.3 alg.4 alg.5 cT co_ cfv eqid alg.1 alg.2 algi pm3.26d 3simp2d $.
          $( [28-Oct-2007] $) $( [26-Oct-2007] $)

      $}

      ${
        $( ` ( id_ ``  A ) ` is a mapping from the objects of
           ` T ` to  the morphisms of ` T ` . $)
        ida $p |- ( T e. Alg -> J : O --> M ) $=
          cT calg wcel cM cO cD wf cM cO cT ccod_ cfv wf cO cM cJ wf cT calg
          wcel cM cO cD wf cM cO cT ccod_ cfv wf cO cM cJ wf w3a cT co_ cfv
          wfun cT co_ cfv cdm cM cM cxp wss cT co_ cfv crn cM wss w3a cT ccod_
          cfv cD cT co_ cfv cT cJ cM cO alg.3 cT ccod_ cfv eqid alg.5 cT co_
          cfv eqid alg.1 alg.2 algi pm3.26d 3simp3d $.
          $( [28-Oct-2007] $) $( [26-Oct-2007] $)

        $( An identity is a morphism. $)
        idmoa $p |- ( ( T e. Alg /\ A e. O ) -> ( J ` A ) e. M ) $=
          cO cM cJ wf cA cO wcel cA cJ cfv cM wcel cT calg wcel cO cM cA cJ
          ffvelrn cD cT cJ cM cO alg.1 alg.3 alg.2 alg.5 ida sylan $.
          $( [10-Jan-2008] $) $( [10-Jan-2008] $)
      $} $}

      ${
        alg.6 $e |- R = ( o_ ` T ) $.
        $( ` ( o_ `` T )  ` is a partial operation on the morphisms of
           ` T ` . $)
        cmppfa $p |- ( T e. Alg ->
        ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) $=
          cT calg wcel cM cT cid_ cfv cdm cD wf cM cT cid_ cfv cdm cT ccod_ cfv
          wf cT cid_ cfv cdm cM cT cid_ cfv wf w3a cR wfun cR cdm cM cM cxp wss
          cR crn cM wss w3a cT ccod_ cfv cD cR cT cT cid_ cfv cM cT cid_ cfv
          cdm alg.3 cT ccod_ cfv eqid cT cid_ cfv eqid alg.6 alg.1 cT cid_ cfv
          cdm eqid algi pm3.27d $.
          $( [28-Oct-2007] $) $( [26-Oct-2007] $)
    $}
  $}

  ${
    dcsda.1 $e |- D = ( dom_ ` T ) $.
    dcsda.2 $e |- C = ( cod_ ` T ) $.
    $( ` ( dom_ `` T ) ` and ` ( cod_ `` T ) ` have the same domain. $)
    dcsda $p |- ( T e. Alg -> dom D = dom C ) $=
      cT calg wcel cD cdm cT cid_ cfv cdm cC wf cD cdm cC cdm wceq cC cD cT cT
      cid_ cfv cD cdm cT cid_ cfv cdm cD cdm eqid dcsda.1 cT cid_ cfv cdm eqid
      cT cid_ cfv eqid dcsda.2 coda cD cdm cT cid_ cfv cdm cC wf cC cdm cD cdm
      cD cdm cT cid_ cfv cdm cC fdm eqcomd syl $.
      $( [10-Jan-2008] $) $( [10-Jan-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Deductive systems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ded $. $( The class of all deductive systems. $)

  $( Extend class notation with the class of deductive systems. $)
  cded $a class Ded $.

  ${ $d x d c j r a f g $.
  $( Definition of a deductive system. Lambeck and Scott. Introduction
     to higher order categorical logic. p. 47. 1986. Unformally we can say
     a deductive system is a directed multi
     graph where for each object a specific morphism called identity of the
     object exists and where for some pairs of morphisms the composite exists.
     Deductive system are named so because morphisms may be interpreted as
     logical deductions, objects as sets of formulas and compositions as
     inferences. $)
  df-ded $a |- Ded = { x | E. d E. c E. j E. r
    ( x = <. <. d , c >. , <. j , r >. >. /\ ( (
      <. <. d , c >. , <. j , r >. >. e. Alg /\
      A. a e. dom j
         ( ( d ` ( j ` a ) ) = a /\ ( c ` ( j ` a ) ) = a ) /\

      A. f e. dom d A. g e. dom d ( <. g , f >. e. dom r
        <-> ( d ` g ) = ( c ` f ) ) ) /\ (

      A. f e. dom d A. g e. dom d
         ( ( d ` g ) = ( c ` f ) -> ( d ` ( g r f ) ) = ( d ` f ) ) /\

      A. f e. dom d A. g e. dom d
         ( ( d ` g ) = ( c ` f ) -> ( c ` ( g r f ) ) = ( c ` g ) ) ) ) ) } $.
  $}

  ${ $d C a c d f g j r $.  $d D a c d f g j r $.  $d J a c d j r $.
     $d M c d j r $.  $d O c d j r $.  $d R c d f g j r $.
     $d a c d f g j r x $.
    isded.1 $e |- M = dom D $.
    isded.2 $e |- O = dom J $.
    $( The predicate "is a deductive system". $)
    isded $p |- ( ( ( D e. A /\ C e. B /\ J e. F ) /\ R e. G )
      -> ( <. <. D , C >. , <. J , R >. >. e. Ded
        <-> ( ( <. <. D , C >. , <. J , R >. >. e. Alg /\
      A. a e. O
         ( ( D ` ( J ` a ) ) = a /\ ( C ` ( J ` a ) ) = a ) /\

      A. f e. M A. g e. M ( <. g , f >. e. dom R
        <-> ( D ` g ) = ( C ` f ) ) ) /\ (

      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( D ` ( g R f ) ) = ( D ` f ) ) /\

      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( C ` ( g R f ) ) = ( C ` g ) ) ) ) ) ) $=
      cD cA wcel cC cB wcel cJ cF wcel w3a cR cG wcel wa cD cC cop cJ cR cop
      cop vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv vc cv cop vj cv
      vr cv cop cop calg wcel va cv vj cv cfv vd cv cfv va cv wceq va cv vj cv
      cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm
      wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral vf vd cv
      cdm wral w3a vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd
      cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral vg cv
      vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv
      cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral wa wa wa vr wex vj wex vc
      wex vd wex vx cab wcel cD cC cop cJ cR cop cop calg wcel va cv cJ cfv cD
      cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg cv vf cv
      cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral
      w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv
      wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv
      cR co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa cD cC cop
      cJ cR cop cop cded wcel vd cv vc cv cop vj cv vr cv cop cop calg wcel va
      cv vj cv cfv vd cv cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa
      va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc
      cv cfv wceq wb vg vd cv cdm wral vf vd cv cdm wral w3a vg cv vd cv cfv vf
      cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi
      vg vd cv cdm wral vf vd cv cdm wral vg cv vd cv cfv vf cv vc cv cfv wceq
      vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral
      vf vd cv cdm wral wa wa cD vc cv cop vj cv vr cv cop cop calg wcel va cv
      vj cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
      cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv
      wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv vc cv cfv wceq vg cv
      vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD
      cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv
      wceq wi vg cM wral vf cM wral wa wa cD cC cop vj cv vr cv cop cop calg
      wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq
      wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC
      cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg
      cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv
      cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi
      vg cM wral vf cM wral wa wa cD cC cop cJ vr cv cop cop calg wcel va cv cJ
      cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg cv
      vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf
      cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf
      cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg
      cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa
      cD cC cop cJ cR cop cop calg wcel va cv cJ cfv cD cfv va cv wceq va cv cJ
      cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop cR cdm wcel vg cv cD
      cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC
      cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM
      wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv
      wceq wi vg cM wral vf cM wral wa wa vx vd vc vr vj cD cC cJ cR cA cB cF
      cG vd cv cD wceq vd cv vc cv cop vj cv vr cv cop cop calg wcel va cv vj
      cv cfv vd cv cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
      cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv
      cfv wceq wb vg vd cv cdm wral vf vd cv cdm wral w3a cD vc cv cop vj cv vr
      cv cop cop calg wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv vc
      cv cfv va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg
      cv cD cfv vf cv vc cv cfv wceq wb vg cM wral vf cM wral w3a vg cv vd cv
      cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv
      wceq wi vg vd cv cdm wral vf vd cv cdm wral vg cv vd cv cfv vf cv vc cv
      cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg vd cv
      cdm wral vf vd cv cdm wral wa vg cv cD cfv vf cv vc cv cfv wceq vg cv vf
      cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD
      cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv
      wceq wi vg cM wral vf cM wral wa vd cv cD wceq vd cv vc cv cop vj cv vr
      cv cop cop calg wcel cD vc cv cop vj cv vr cv cop cop calg wcel va cv vj
      cv cfv vd cv cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
      cv cdm wral va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv
      va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv vd
      cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral vf vd cv cdm wral vg cv
      vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM wral
      vf cM wral vd cv cD wceq vd cv vc cv cop vj cv vr cv cop cop cD vc cv cop
      vj cv vr cv cop cop calg vd cv cD wceq vd cv vc cv cop cD vc cv cop vj cv
      vr cv cop vd cv cD vc cv opeq1 opeq1d eleq1d vd cv cD wceq va cv vj cv
      cfv vd cv cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va cv vj
      cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv
      cdm vd cv cD wceq va cv vj cv cfv vd cv cfv va cv wceq va cv vj cv cfv cD
      cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq vd cv cD wceq va cv
      vj cv cfv vd cv cfv va cv vj cv cfv cD cfv va cv va cv vj cv cfv vd cv cD
      fveq1 eqeq1d anbi1d ralbidv vd cv cD wceq vg cv vf cv cop vr cv cdm wcel
      vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral vg cv vf cv cop
      vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM wral vf vd cv
      cdm cM vd cv cD wceq vf cv vd cv cdm wcel vf cv cM wcel vg cv vf cv cop
      vr cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral
      vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM
      wral vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv cdm cD cdm cM
      vd cv cD dmeq isded.1 syl6eqr eleq2d vd cv cD wceq vg cv vf cv cop vr cv
      cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg cv vf cv cop vr cv
      cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg vd cv cdm cM vd cv cD
      wceq vg cv vd cv cdm wcel vg cv cM wcel vg cv vf cv cop vr cv cdm wcel vg
      cv vd cv cfv vf cv vc cv cfv wceq wb vg cv vf cv cop vr cv cdm wcel vg cv
      cD cfv vf cv vc cv cfv wceq wb vd cv cD wceq vd cv cdm cM vg cv vd cv cD
      wceq vd cv cdm cD cdm cM vd cv cD dmeq isded.1 syl6eqr eleq2d vd cv cD
      wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv
      wceq vg cv vf cv cop vr cv cdm wcel vd cv cD wceq vg cv vd cv cfv vg cv
      cD cfv vf cv vc cv cfv vg cv vd cv cD fveq1 eqeq1d bibi2d imbi12d
      ralbidv2 imbi12d ralbidv2 3anbi123d vd cv cD wceq vg cv vd cv cfv vf cv
      vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg
      vd cv cdm wral vf vd cv cdm wral vg cv cD cfv vf cv vc cv cfv wceq vg cv
      vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv vd
      cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv
      cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral vg cv cD cfv vf cv vc cv
      cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM
      wral vf cM wral vd cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv
      vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral vg cv
      cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq
      wi vg cM wral vf vd cv cdm cM vd cv cD wceq vf cv vd cv cdm wcel vf cv cM
      wcel vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv
      vf cv vd cv cfv wceq wi vg vd cv cdm wral vg cv cD cfv vf cv vc cv cfv
      wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vd cv cD
      wceq vd cv cdm cM vf cv vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq
      isded.1 syl6eqr eleq2d vd cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq
      vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg cv cD cfv vf cv
      vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg vd cv
      cdm cM vd cv cD wceq vg cv vd cv cdm wcel vg cv cM wcel vg cv vd cv cfv
      vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq
      wi vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD
      cfv wceq wi vd cv cD wceq vd cv cdm cM vg cv vd cv cD wceq vd cv cdm cD
      cdm cM vd cv cD dmeq isded.1 syl6eqr eleq2d vd cv cD wceq vg cv vd cv cfv
      vf cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv
      co vd cv cfv vf cv vd cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD
      cfv wceq vd cv cD wceq vg cv vd cv cfv vg cv cD cfv vf cv vc cv cfv vg cv
      vd cv cD fveq1 eqeq1d vd cv cD wceq vg cv vf cv vr cv co vd cv cfv vg cv
      vf cv vr cv co cD cfv vf cv vd cv cfv vf cv cD cfv vg cv vf cv vr cv co
      vd cv cD fveq1 vf cv vd cv cD fveq1 eqeq12d imbi12d imbi12d ralbidv2
      imbi12d ralbidv2 vd cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv
      vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vg cv
      cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv
      cfv wceq wi vg cM wral vf vd cv cdm cM vd cv cD wceq vf cv vd cv cdm wcel
      vf cv cM wcel vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co
      vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vg cv cD cfv vf cv vc
      cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM
      wral vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv cdm cD cdm cM
      vd cv cD dmeq isded.1 syl6eqr eleq2d vd cv cD wceq vg cv vd cv cfv vf cv
      vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg
      cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv
      cfv wceq wi vg vd cv cdm cM vd cv cD wceq vg cv vd cv cdm wcel vg cv cM
      wcel vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv
      vg cv vc cv cfv wceq wi vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr
      cv co vc cv cfv vg cv vc cv cfv wceq wi vd cv cD wceq vd cv cdm cM vg cv
      vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq isded.1 syl6eqr eleq2d vd
      cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv vc cv
      cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq vd cv cD
      wceq vg cv vd cv cfv vg cv cD cfv vf cv vc cv cfv vg cv vd cv cD fveq1
      eqeq1d imbi1d imbi12d ralbidv2 imbi12d ralbidv2 anbi12d anbi12d vc cv cC
      wceq cD vc cv cop vj cv vr cv cop cop calg wcel va cv vj cv cfv cD cfv va
      cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv
      vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM wral
      vf cM wral w3a cD cC cop vj cv vr cv cop cop calg wcel va cv vj cv cfv cD
      cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq wa va vj cv cdm wral vg
      cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral
      vf cM wral w3a vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD
      cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv vc cv
      cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM
      wral vf cM wral wa vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD
      cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv
      wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM
      wral wa vc cv cC wceq cD vc cv cop vj cv vr cv cop cop calg wcel cD cC
      cop vj cv vr cv cop cop calg wcel va cv vj cv cfv cD cfv va cv wceq va cv
      vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral va cv vj cv cfv cD
      cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq wa va vj cv cdm wral vg
      cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM
      wral vf cM wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv
      wceq wb vg cM wral vf cM wral vc cv cC wceq cD vc cv cop vj cv vr cv cop
      cop cD cC cop vj cv vr cv cop cop calg vc cv cC wceq cD vc cv cop cD cC
      cop vj cv vr cv cop vc cv cC cD opeq2 opeq1d eleq1d vc cv cC wceq va cv
      vj cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va cv
      vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq wa va vj cv
      cdm vc cv cC wceq va cv vj cv cfv vc cv cfv va cv wceq va cv vj cv cfv cC
      cfv va cv wceq va cv vj cv cfv cD cfv va cv wceq vc cv cC wceq va cv vj
      cv cfv vc cv cfv va cv vj cv cfv cC cfv va cv va cv vj cv cfv vc cv cC
      fveq1 eqeq1d anbi2d ralbidv vc cv cC wceq vg cv vf cv cop vr cv cdm wcel
      vg cv cD cfv vf cv vc cv cfv wceq wb vg cv vf cv cop vr cv cdm wcel vg cv
      cD cfv vf cv cC cfv wceq wb vf vg cM cM vc cv cC wceq vg cv cD cfv vf cv
      vc cv cfv wceq vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cop vr cv cdm
      wcel vc cv cC wceq vf cv vc cv cfv vf cv cC cfv vg cv cD cfv vf cv vc cv
      cC fveq1 eqeq2d bibi2d 2ralbidv 3anbi123d vc cv cC wceq vg cv cD cfv vf
      cv vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM
      wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD
      cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv vc cv
      cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM
      wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC
      cfv vg cv cC cfv wceq wi vg cM wral vf cM wral vc cv cC wceq vg cv cD cfv
      vf cv vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg
      cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq
      wi vf vg cM cM vc cv cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv cD
      cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq vc cv
      cC wceq vf cv vc cv cfv vf cv cC cfv vg cv cD cfv vf cv vc cv cC fveq1
      eqeq2d imbi1d 2ralbidv vc cv cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg
      cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cv cD cfv vf cv cC
      cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vf vg cM cM vc
      cv cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv cC cfv
      wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq vg cv vf cv vr
      cv co cC cfv vg cv cC cfv wceq vc cv cC wceq vf cv vc cv cfv vf cv cC cfv
      vg cv cD cfv vf cv vc cv cC fveq1 eqeq2d vc cv cC wceq vg cv vf cv vr cv
      co vc cv cfv vg cv vf cv vr cv co cC cfv vg cv vc cv cfv vg cv cC cfv vg
      cv vf cv vr cv co vc cv cC fveq1 vg cv vc cv cC fveq1 eqeq12d imbi12d
      2ralbidv anbi12d anbi12d vj cv cJ wceq cD cC cop vj cv vr cv cop cop calg
      wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq
      wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC
      cfv wceq wb vg cM wral vf cM wral w3a cD cC cop cJ vr cv cop cop calg
      wcel va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va
      cO wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb
      vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr
      cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf
      cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM
      wral vf cM wral wa vj cv cJ wceq cD cC cop vj cv vr cv cop cop calg wcel
      cD cC cop cJ vr cv cop cop calg wcel va cv vj cv cfv cD cfv va cv wceq va
      cv vj cv cfv cC cfv va cv wceq wa va vj cv cdm wral va cv cJ cfv cD cfv
      va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop
      vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral vj
      cv cJ wceq cD cC cop vj cv vr cv cop cop cD cC cop cJ vr cv cop cop calg
      vj cv cJ wceq vj cv vr cv cop cJ vr cv cop cD cC cop vj cv cJ vr cv opeq1
      opeq2d eleq1d vj cv cJ wceq va cv vj cv cfv cD cfv va cv wceq va cv vj cv
      cfv cC cfv va cv wceq wa va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC
      cfv va cv wceq wa va vj cv cdm cO vj cv cJ wceq va cv vj cv cdm wcel va
      cv cO wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv
      wceq wa va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa
      vj cv cJ wceq vj cv cdm cO va cv vj cv cJ wceq vj cv cdm cJ cdm cO vj cv
      cJ dmeq isded.2 syl6eqr eleq2d vj cv cJ wceq va cv vj cv cfv cD cfv va cv
      wceq va cv cJ cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq va
      cv cJ cfv cC cfv va cv wceq vj cv cJ wceq va cv vj cv cfv cD cfv va cv cJ
      cfv cD cfv va cv vj cv cJ wceq va cv vj cv cfv va cv cJ cfv cD va cv vj
      cv cJ fveq1 fveq2d eqeq1d vj cv cJ wceq va cv vj cv cfv cC cfv va cv cJ
      cfv cC cfv va cv vj cv cJ wceq va cv vj cv cfv va cv cJ cfv cC va cv vj
      cv cJ fveq1 fveq2d eqeq1d anbi12d imbi12d ralbidv2 3anbi12d anbi1d vr cv
      cR wceq cD cC cop cJ vr cv cop cop calg wcel va cv cJ cfv cD cfv va cv
      wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop vr cv
      cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a cD
      cC cop cJ cR cop cop calg wcel va cv cJ cfv cD cfv va cv wceq va cv cJ
      cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop cR cdm wcel vg cv cD
      cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC
      cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf
      cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv
      cC cfv wceq wi vg cM wral vf cM wral wa vg cv cD cfv vf cv cC cfv wceq vg
      cv vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD
      cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg cM
      wral vf cM wral wa vr cv cR wceq cD cC cop cJ vr cv cop cop calg wcel cD
      cC cop cJ cR cop cop calg wcel vg cv vf cv cop vr cv cdm wcel vg cv cD
      cfv vf cv cC cfv wceq wb vg cM wral vf cM wral vg cv vf cv cop cR cdm
      wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral va cv cJ cfv
      cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vr cv cR
      wceq cD cC cop cJ vr cv cop cop cD cC cop cJ cR cop cop calg vr cv cR
      wceq cJ vr cv cop cJ cR cop cD cC cop vr cv cR cJ opeq2 opeq2d eleq1d vr
      cv cR wceq vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq
      wb vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vf vg cM
      cM vr cv cR wceq vg cv vf cv cop vr cv cdm wcel vg cv vf cv cop cR cdm
      wcel vg cv cD cfv vf cv cC cfv wceq vr cv cR wceq vr cv cdm cR cdm vg cv
      vf cv cop vr cv cR dmeq eleq2d bibi1d 2ralbidv 3anbi13d vr cv cR wceq vg
      cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq
      wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co
      cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC
      cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf
      cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC
      cfv wceq wi vg cM wral vf cM wral vr cv cR wceq vg cv cD cfv vf cv cC cfv
      wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cv cD cfv vf cv
      cC cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv wceq wi vf vg cM cM vr
      cv cR wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq vg cv vf cv cR
      co cD cfv vf cv cD cfv wceq vg cv cD cfv vf cv cC cfv wceq vr cv cR wceq
      vg cv vf cv vr cv co cD cfv vg cv vf cv cR co cD cfv vf cv cD cfv vr cv
      cR wceq vg cv vf cv vr cv co vg cv vf cv cR co cD vg cv vf cv vr cv cR
      opreq fveq2d eqeq1d imbi2d 2ralbidv vr cv cR wceq vg cv cD cfv vf cv cC
      cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cv cD cfv vf
      cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vf vg cM cM
      vr cv cR wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq vg cv vf cv
      cR co cC cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vr cv cR
      wceq vg cv vf cv vr cv co cC cfv vg cv vf cv cR co cC cfv vg cv cC cfv vr
      cv cR wceq vg cv vf cv vr cv co vg cv vf cv cR co cC vg cv vf cv vr cv cR
      opreq fveq2d eqeq1d imbi2d 2ralbidv anbi12d anbi12d elo cded vx cv vd cv
      vc cv cop vj cv vr cv cop cop wceq vd cv vc cv cop vj cv vr cv cop cop
      calg wcel va cv vj cv cfv vd cv cfv va cv wceq va cv vj cv cfv vc cv cfv
      va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv vd
      cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral vf vd cv cdm wral w3a vg
      cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd
      cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral vg cv vd cv cfv vf cv
      vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg
      vd cv cdm wral vf vd cv cdm wral wa wa wa vr wex vj wex vc wex vd wex vx
      cab cD cC cop cJ cR cop cop vx vf vg vj vr va vc vd df-ded eleq2i syl5bb
      $.
      $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  ${ $d C a c d f g j r $.  $d D a c d f g j r $.  $d J a c d j r $.
     $d M c d j r $.  $d O c d j r $.  $d R c d f g j r $.
     $d T c d j r x $.  $d a c d f g j r x $.
     dedi.1 $e |- D = ( dom_ ` T ) $.
     dedi.2 $e |- C = ( cod_ ` T ) $.
     dedi.3 $e |- J = ( id_ ` T ) $.
     dedi.4 $e |- R = ( o_ ` T ) $.
     dedi.5 $e |- M = dom D $.
     dedi.6 $e |- O = dom J $.
     $( Properties of a deductive system. $)
     dedi $p |- ( T e. Ded
        -> ( ( <. <. D , C >. , <. J , R >. >.  e. Alg /\
      A. a e. O
         ( ( D ` ( J ` a ) ) = a /\ ( C ` ( J ` a ) ) = a ) /\

      A. f e. M A. g e. M ( <. g , f >. e. dom R
        <-> ( D ` g ) = ( C ` f ) ) ) /\ (

      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( D ` ( g R f ) ) = ( D ` f ) ) /\

      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( C ` ( g R f ) ) = ( C ` g ) ) ) ) ) $=
       cT cded wcel cT vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv vc
       cv cop vj cv vr cv cop cop calg wcel va cv vj cv cfv vd cv cfv va cv
       wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv vf
       cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv
       cdm wral vf vd cv cdm wral w3a vg cv vd cv cfv vf cv vc cv cfv wceq vg
       cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral vf
       vd cv cdm wral vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co
       vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral wa
       wa wa vr wex vj wex vc wex vd wex vx cab wcel cD cC cop cJ cR cop cop
       calg wcel va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq
       wa va cO wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq
       wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv
       cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf
       cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg cM wral
       vf cM wral wa wa cded vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd
       cv vc cv cop vj cv vr cv cop cop calg wcel va cv vj cv cfv vd cv cfv va
       cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv
       vf cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd
       cv cdm wral vf vd cv cdm wral w3a vg cv vd cv cfv vf cv vc cv cfv wceq
       vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral
       vf vd cv cdm wral vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv
       co vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral
       wa wa wa vr wex vj wex vc wex vd wex vx cab cT vx vf vg vj vr va vc vd
       df-ded eleq2i vd cv vc cv cop vj cv vr cv cop cop calg wcel va cv vj cv
       cfv vd cv cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
       cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv
       cfv wceq wb vg vd cv cdm wral vf vd cv cdm wral w3a vg cv vd cv cfv vf
       cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi
       vg vd cv cdm wral vf vd cv cdm wral vg cv vd cv cfv vf cv vc cv cfv wceq
       vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral
       vf vd cv cdm wral wa wa cD vc cv cop vj cv vr cv cop cop calg wcel va cv
       vj cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va
       vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv
       cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv vc cv cfv wceq
       vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral
       vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv
       vc cv cfv wceq wi vg cM wral vf cM wral wa wa cD cC cop vj cv vr cv cop
       cop calg wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv
       va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD
       cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC
       cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf
       cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv
       cC cfv wceq wi vg cM wral vf cM wral wa wa cD cC cop cJ vr cv cop cop
       calg wcel va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq
       wa va cO wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv
       wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv
       vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv
       cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq
       wi vg cM wral vf cM wral wa wa cD cC cop cJ cR cop cop calg wcel va cv
       cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg
       cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf
       cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf
       cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq
       vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa
       wa vx vd vc vr vj cT vd cv cT c1st cfv c1st cfv wceq vd cv cD wceq vd cv
       vc cv cop vj cv vr cv cop cop calg wcel va cv vj cv cfv vd cv cfv va cv
       wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv vf
       cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv
       cdm wral vf vd cv cdm wral w3a vg cv vd cv cfv vf cv vc cv cfv wceq vg
       cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral vf
       vd cv cdm wral vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co
       vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral wa
       wa cD vc cv cop vj cv vr cv cop cop calg wcel va cv vj cv cfv cD cfv va
       cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv
       vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM wral
       vf cM wral w3a vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD
       cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv vc cv
       cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM
       wral vf cM wral wa wa wb cT c1st cfv c1st cfv cD vd cv cD cT c1st cfv
       c1st cfv cD cT dedi.1 domval eqcomi eqeq2i vd cv cD wceq vd cv vc cv cop
       vj cv vr cv cop cop calg wcel va cv vj cv cfv vd cv cfv va cv wceq va cv
       vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr
       cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral vf
       vd cv cdm wral w3a cD vc cv cop vj cv vr cv cop cop calg wcel va cv vj
       cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
       cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv
       wceq wb vg cM wral vf cM wral w3a vg cv vd cv cfv vf cv vc cv cfv wceq
       vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral
       vf vd cv cdm wral vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv
       co vc cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral
       wa vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv
       cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv vc cv cfv wceq
       vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM wral vf cM
       wral wa vd cv cD wceq vd cv vc cv cop vj cv vr cv cop cop calg wcel cD
       vc cv cop vj cv vr cv cop cop calg wcel va cv vj cv cfv vd cv cfv va cv
       wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm wral va cv vj
       cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
       cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv
       cfv wceq wb vg vd cv cdm wral vf vd cv cdm wral vg cv vf cv cop vr cv
       cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM wral vf cM wral vd
       cv cD wceq vd cv vc cv cop vj cv vr cv cop cop cD vc cv cop vj cv vr cv
       cop cop calg vd cv cD wceq vd cv vc cv cop cD vc cv cop vj cv vr cv cop
       vd cv cD vc cv opeq1 opeq1d eleq1d vd cv cD wceq va cv vj cv cfv vd cv
       cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va cv vj cv cfv
       cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv cdm
       vd cv cD wceq va cv vj cv cfv vd cv cfv va cv wceq va cv vj cv cfv cD
       cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq vd cv cD wceq va cv
       vj cv cfv vd cv cfv va cv vj cv cfv cD cfv va cv va cv vj cv cfv vd cv
       cD fveq1 eqeq1d anbi1d ralbidv vd cv cD wceq vg cv vf cv cop vr cv cdm
       wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv cdm wral vg cv vf
       cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg cM wral vf
       vd cv cdm cM vd cv cD wceq vf cv vd cv cdm wcel vf cv cM wcel vg cv vf
       cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg vd cv
       cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv
       wceq wb vg cM wral vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv
       cdm cD cdm cM vd cv cD dmeq dedi.5 syl6eqr eleq2d vd cv cD wceq vg cv vf
       cv cop vr cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg cv vf
       cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vg vd cv cdm
       cM vd cv cD wceq vg cv vd cv cdm wcel vg cv cM wcel vg cv vf cv cop vr
       cv cdm wcel vg cv vd cv cfv vf cv vc cv cfv wceq wb vg cv vf cv cop vr
       cv cdm wcel vg cv cD cfv vf cv vc cv cfv wceq wb vd cv cD wceq vd cv cdm
       cM vg cv vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq dedi.5 syl6eqr
       eleq2d vd cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv cD cfv
       vf cv vc cv cfv wceq vg cv vf cv cop vr cv cdm wcel vd cv cD wceq vg cv
       vd cv cfv vg cv cD cfv vf cv vc cv cfv vg cv vd cv cD fveq1 eqeq1d
       bibi2d imbi12d ralbidv2 imbi12d ralbidv2 3anbi123d vd cv cD wceq vg cv
       vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd
       cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral vg cv cD cfv vf cv vc
       cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral
       vf cM wral vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc
       cv cfv vg cv vc cv cfv wceq wi vg vd cv cdm wral vf vd cv cdm wral vg cv
       cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv
       cfv wceq wi vg cM wral vf cM wral vd cv cD wceq vg cv vd cv cfv vf cv vc
       cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd
       cv cdm wral vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD
       cfv vf cv cD cfv wceq wi vg cM wral vf vd cv cdm cM vd cv cD wceq vf cv
       vd cv cdm wcel vf cv cM wcel vg cv vd cv cfv vf cv vc cv cfv wceq vg cv
       vf cv vr cv co vd cv cfv vf cv vd cv cfv wceq wi vg vd cv cdm wral vg cv
       cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv
       wceq wi vg cM wral vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv
       cdm cD cdm cM vd cv cD dmeq dedi.5 syl6eqr eleq2d vd cv cD wceq vg cv vd
       cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv
       cfv wceq wi vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co cD
       cfv vf cv cD cfv wceq wi vg vd cv cdm cM vd cv cD wceq vg cv vd cv cdm
       wcel vg cv cM wcel vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr
       cv co vd cv cfv vf cv vd cv cfv wceq wi vg cv cD cfv vf cv vc cv cfv
       wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vd cv cD wceq vd
       cv cdm cM vg cv vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq dedi.5
       syl6eqr eleq2d vd cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv
       cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vd cv cfv vf cv vd cv
       cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq vd cv cD wceq vg
       cv vd cv cfv vg cv cD cfv vf cv vc cv cfv vg cv vd cv cD fveq1 eqeq1d vd
       cv cD wceq vg cv vf cv vr cv co vd cv cfv vg cv vf cv vr cv co cD cfv vf
       cv vd cv cfv vf cv cD cfv vg cv vf cv vr cv co vd cv cD fveq1 vf cv vd
       cv cD fveq1 eqeq12d imbi12d imbi12d ralbidv2 imbi12d ralbidv2 vd cv cD
       wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv
       vg cv vc cv cfv wceq wi vg vd cv cdm wral vg cv cD cfv vf cv vc cv cfv
       wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM wral
       vf vd cv cdm cM vd cv cD wceq vf cv vd cv cdm wcel vf cv cM wcel vg cv
       vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc
       cv cfv wceq wi vg vd cv cdm wral vg cv cD cfv vf cv vc cv cfv wceq vg cv
       vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM wral vd cv cD
       wceq vd cv cdm cM vf cv vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq
       dedi.5 syl6eqr eleq2d vd cv cD wceq vg cv vd cv cfv vf cv vc cv cfv wceq
       vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cv cD cfv vf
       cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi
       vg vd cv cdm cM vd cv cD wceq vg cv vd cv cdm wcel vg cv cM wcel vg cv
       vd cv cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg cv vc
       cv cfv wceq wi vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc
       cv cfv vg cv vc cv cfv wceq wi vd cv cD wceq vd cv cdm cM vg cv vd cv cD
       wceq vd cv cdm cD cdm cM vd cv cD dmeq dedi.5 syl6eqr eleq2d vd cv cD
       wceq vg cv vd cv cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv
       wceq vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq vd cv cD wceq
       vg cv vd cv cfv vg cv cD cfv vf cv vc cv cfv vg cv vd cv cD fveq1 eqeq1d
       imbi1d imbi12d ralbidv2 imbi12d ralbidv2 anbi12d anbi12d sylbi vc cv cT
       c1st cfv c2nd cfv wceq vc cv cC wceq cD vc cv cop vj cv vr cv cop cop
       calg wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va
       cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv
       vf cv vc cv cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv vc
       cv cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral
       vf cM wral vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv
       cfv vg cv vc cv cfv wceq wi vg cM wral vf cM wral wa wa cD cC cop vj cv
       vr cv cop cop calg wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv
       cfv cC cfv va cv wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm
       wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv
       cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq
       wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr
       cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa wb cT c1st
       cfv c2nd cfv cC vc cv cC cT c1st cfv c2nd cfv cC cT dedi.2 codval eqcomi
       eqeq2i vc cv cC wceq cD vc cv cop vj cv vr cv cop cop calg wcel va cv vj
       cv cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj
       cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv cfv
       wceq wb vg cM wral vf cM wral w3a cD cC cop vj cv vr cv cop cop calg
       wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq
       wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv
       cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv vc cv cfv
       wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM
       wral vg cv cD cfv vf cv vc cv cfv wceq vg cv vf cv vr cv co vc cv cfv vg
       cv vc cv cfv wceq wi vg cM wral vf cM wral wa vg cv cD cfv vf cv cC cfv
       wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM
       wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC
       cfv wceq wi vg cM wral vf cM wral wa vc cv cC wceq cD vc cv cop vj cv vr
       cv cop cop calg wcel cD cC cop vj cv vr cv cop cop calg wcel va cv vj cv
       cfv cD cfv va cv wceq va cv vj cv cfv vc cv cfv va cv wceq wa va vj cv
       cdm wral va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv
       wceq wa va vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf
       cv vc cv cfv wceq wb vg cM wral vf cM wral vg cv vf cv cop vr cv cdm
       wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral vc cv cC
       wceq cD vc cv cop vj cv vr cv cop cop cD cC cop vj cv vr cv cop cop calg
       vc cv cC wceq cD vc cv cop cD cC cop vj cv vr cv cop vc cv cC cD opeq2
       opeq1d eleq1d vc cv cC wceq va cv vj cv cfv cD cfv va cv wceq va cv vj
       cv cfv vc cv cfv va cv wceq wa va cv vj cv cfv cD cfv va cv wceq va cv
       vj cv cfv cC cfv va cv wceq wa va vj cv cdm vc cv cC wceq va cv vj cv
       cfv vc cv cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq va cv vj cv
       cfv cD cfv va cv wceq vc cv cC wceq va cv vj cv cfv vc cv cfv va cv vj
       cv cfv cC cfv va cv va cv vj cv cfv vc cv cC fveq1 eqeq1d anbi2d ralbidv
       vc cv cC wceq vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv vc cv
       cfv wceq wb vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv
       wceq wb vf vg cM cM vc cv cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg
       cv cD cfv vf cv cC cfv wceq vg cv vf cv cop vr cv cdm wcel vc cv cC wceq
       vf cv vc cv cfv vf cv cC cfv vg cv cD cfv vf cv vc cv cC fveq1 eqeq2d
       bibi2d 2ralbidv 3anbi123d vc cv cC wceq vg cv cD cfv vf cv vc cv cfv
       wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM
       wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD
       cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv vc cv cfv wceq vg
       cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cM wral vf cM
       wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC
       cfv wceq wi vg cM wral vf cM wral vc cv cC wceq vg cv cD cfv vf cv vc cv
       cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cv cD cfv
       vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vf vg
       cM cM vc cv cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv
       cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq vc cv cC wceq
       vf cv vc cv cfv vf cv cC cfv vg cv cD cfv vf cv vc cv cC fveq1 eqeq2d
       imbi1d 2ralbidv vc cv cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv vf
       cv vr cv co vc cv cfv vg cv vc cv cfv wceq wi vg cv cD cfv vf cv cC cfv
       wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vf vg cM cM vc cv
       cC wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv cC cfv wceq
       vg cv vf cv vr cv co vc cv cfv vg cv vc cv cfv wceq vg cv vf cv vr cv co
       cC cfv vg cv cC cfv wceq vc cv cC wceq vf cv vc cv cfv vf cv cC cfv vg
       cv cD cfv vf cv vc cv cC fveq1 eqeq2d vc cv cC wceq vg cv vf cv vr cv co
       vc cv cfv vg cv vf cv vr cv co cC cfv vg cv vc cv cfv vg cv cC cfv vg cv
       vf cv vr cv co vc cv cC fveq1 vg cv vc cv cC fveq1 eqeq12d imbi12d
       2ralbidv anbi12d anbi12d sylbi vj cv cT c2nd cfv c1st cfv wceq vj cv cJ
       wceq cD cC cop vj cv vr cv cop cop calg wcel va cv vj cv cfv cD cfv va
       cv wceq va cv vj cv cfv cC cfv va cv wceq wa va vj cv cdm wral vg cv vf
       cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM
       wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf
       cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq
       vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral
       wa wa cD cC cop cJ vr cv cop cop calg wcel va cv cJ cfv cD cfv va cv
       wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop vr cv
       cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg
       cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv
       wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv
       vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa wb cT
       c2nd cfv c1st cfv cJ vj cv cJ cT c2nd cfv c1st cfv cT cJ dedi.3 idval
       eqcomi eqeq2i vj cv cJ wceq cD cC cop vj cv vr cv cop cop calg wcel va
       cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv cC cfv va cv wceq wa va
       vj cv cdm wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv
       wceq wb vg cM wral vf cM wral w3a cD cC cop cJ vr cv cop cop calg wcel
       va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO
       wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg
       cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv
       co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv
       cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral
       vf cM wral wa vj cv cJ wceq cD cC cop vj cv vr cv cop cop calg wcel cD
       cC cop cJ vr cv cop cop calg wcel va cv vj cv cfv cD cfv va cv wceq va
       cv vj cv cfv cC cfv va cv wceq wa va vj cv cdm wral va cv cJ cfv cD cfv
       va cv wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop
       vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral
       vj cv cJ wceq cD cC cop vj cv vr cv cop cop cD cC cop cJ vr cv cop cop
       calg vj cv cJ wceq vj cv vr cv cop cJ vr cv cop cD cC cop vj cv cJ vr cv
       opeq1 opeq2d eleq1d vj cv cJ wceq va cv vj cv cfv cD cfv va cv wceq va
       cv vj cv cfv cC cfv va cv wceq wa va cv cJ cfv cD cfv va cv wceq va cv
       cJ cfv cC cfv va cv wceq wa va vj cv cdm cO vj cv cJ wceq va cv vj cv
       cdm wcel va cv cO wcel va cv vj cv cfv cD cfv va cv wceq va cv vj cv cfv
       cC cfv va cv wceq wa va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv
       va cv wceq wa vj cv cJ wceq vj cv cdm cO va cv vj cv cJ wceq vj cv cdm
       cJ cdm cO vj cv cJ dmeq dedi.6 syl6eqr eleq2d vj cv cJ wceq va cv vj cv
       cfv cD cfv va cv wceq va cv cJ cfv cD cfv va cv wceq va cv vj cv cfv cC
       cfv va cv wceq va cv cJ cfv cC cfv va cv wceq vj cv cJ wceq va cv vj cv
       cfv cD cfv va cv cJ cfv cD cfv va cv vj cv cJ wceq va cv vj cv cfv va cv
       cJ cfv cD va cv vj cv cJ fveq1 fveq2d eqeq1d vj cv cJ wceq va cv vj cv
       cfv cC cfv va cv cJ cfv cC cfv va cv vj cv cJ wceq va cv vj cv cfv va cv
       cJ cfv cC va cv vj cv cJ fveq1 fveq2d eqeq1d anbi12d imbi12d ralbidv2
       3anbi12d anbi1d sylbi vr cv cT c2nd cfv c2nd cfv wceq vr cv cR wceq cD
       cC cop cJ vr cv cop cop calg wcel va cv cJ cfv cD cfv va cv wceq va cv
       cJ cfv cC cfv va cv wceq wa va cO wral vg cv vf cv cop vr cv cdm wcel vg
       cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf
       cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM
       wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv co cC
       cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa cD cC cop cJ cR cop
       cop calg wcel va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv
       wceq wa va cO wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv
       wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv
       vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD
       cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg
       cM wral vf cM wral wa wa wb cT c2nd cfv c2nd cfv cR vr cv cR cT c2nd cfv
       c2nd cfv cT cR dedi.4 cmpval eqcomi eqeq2i vr cv cR wceq cD cC cop cJ vr
       cv cop cop calg wcel va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv
       va cv wceq wa va cO wral vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf
       cv cC cfv wceq wb vg cM wral vf cM wral w3a cD cC cop cJ cR cop cop calg
       wcel va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq wa va
       cO wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg
       cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf cv vr cv
       co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv
       cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral
       vf cM wral wa vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf
       cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv wceq
       vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral wa
       vr cv cR wceq cD cC cop cJ vr cv cop cop calg wcel cD cC cop cJ cR cop
       cop calg wcel vg cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv
       wceq wb vg cM wral vf cM wral vg cv vf cv cop cR cdm wcel vg cv cD cfv
       vf cv cC cfv wceq wb vg cM wral vf cM wral va cv cJ cfv cD cfv va cv
       wceq va cv cJ cfv cC cfv va cv wceq wa va cO wral vr cv cR wceq cD cC
       cop cJ vr cv cop cop cD cC cop cJ cR cop cop calg vr cv cR wceq cJ vr cv
       cop cJ cR cop cD cC cop vr cv cR cJ opeq2 opeq2d eleq1d vr cv cR wceq vg
       cv vf cv cop vr cv cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cv vf
       cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vf vg cM cM vr cv
       cR wceq vg cv vf cv cop vr cv cdm wcel vg cv vf cv cop cR cdm wcel vg cv
       cD cfv vf cv cC cfv wceq vr cv cR wceq vr cv cdm cR cdm vg cv vf cv cop
       vr cv cR dmeq eleq2d bibi1d 2ralbidv 3anbi13d vr cv cR wceq vg cv cD cfv
       vf cv cC cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cM
       wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cD cfv
       vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv cC cfv
       wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM
       wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC
       cfv wceq wi vg cM wral vf cM wral vr cv cR wceq vg cv cD cfv vf cv cC
       cfv wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq wi vg cv cD cfv
       vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv wceq wi vf vg cM
       cM vr cv cR wceq vg cv vf cv vr cv co cD cfv vf cv cD cfv wceq vg cv vf
       cv cR co cD cfv vf cv cD cfv wceq vg cv cD cfv vf cv cC cfv wceq vr cv
       cR wceq vg cv vf cv vr cv co cD cfv vg cv vf cv cR co cD cfv vf cv cD
       cfv vr cv cR wceq vg cv vf cv vr cv co vg cv vf cv cR co cD vg cv vf cv
       vr cv cR opreq fveq2d eqeq1d imbi2d 2ralbidv vr cv cR wceq vg cv cD cfv
       vf cv cC cfv wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq wi vg cv
       cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi
       vf vg cM cM vr cv cR wceq vg cv vf cv vr cv co cC cfv vg cv cC cfv wceq
       vg cv vf cv cR co cC cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv
       wceq vr cv cR wceq vg cv vf cv vr cv co cC cfv vg cv vf cv cR co cC cfv
       vg cv cC cfv vr cv cR wceq vg cv vf cv vr cv co vg cv vf cv cR co cC vg
       cv vf cv vr cv cR opreq fveq2d eqeq1d imbi2d 2ralbidv anbi12d anbi12d
       sylbi eloi sylbi $.
       $( [28-Oct-2007] $) $( [24-Oct-2007] $)
   $}

  ${ $d A x y z $.
    1ded.1 $e |- A e. _V $.
    $( Category ` 1 ` is a deductive system. We can think of the morphism of
       Category ` 1 ` as corresponding to ` ph |- ph ` . $)
    1ded $p |- <. <. { <. <. A , A >. , A >. } ,
      { <. <. A , A >. , A >. } >. , <. { <. A , <. A , A >. >. } ,
      { <. <. <. A , A >. , <. A , A >. >. , <. A , A >. >. } >. >. e. Ded $=
      cA cA cop cA cop csn cA cA cop cA cop csn cop cA cA cA cop cop csn cA cA
      cop cA cA cop cop cA cA cop cop csn cop cop cded wcel cA cA cop cA cop
      csn cA cA cop cA cop csn cop cA cA cA cop cop csn cA cA cop cA cA cop cop
      cA cA cop cop csn cop cop calg wcel vz cv cA cA cA cop cop csn cfv cA cA
      cop cA cop csn cfv vz cv wceq vz cv cA cA cA cop cop csn cfv cA cA cop cA
      cop csn cfv vz cv wceq wa vz cA csn wral vy cv vx cv cop cA cA cop cA cA
      cop cop cA cA cop cop csn cdm wcel vy cv cA cA cop cA cop csn cfv vx cv
      cA cA cop cA cop csn cfv wceq wb vy cA cA cop csn wral vx cA cA cop csn
      wral w3a vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv
      wceq vy cv vx cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop
      cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq wi vy cA cA cop csn
      wral vx cA cA cop csn wral vy cv cA cA cop cA cop csn cfv vx cv cA cA cop
      cA cop csn cfv wceq vy cv vx cv cA cA cop cA cA cop cop cA cA cop cop csn
      co cA cA cop cA cop csn cfv vy cv cA cA cop cA cop csn cfv wceq wi vy cA
      cA cop csn wral vx cA cA cop csn wral wa cA cA cop cA cop csn cvv wcel cA
      cA cop cA cop csn cvv wcel cA cA cA cop cop csn cvv wcel w3a cA cA cop cA
      cA cop cop cA cA cop cop csn cvv wcel cA cA cop cA cop csn cA cA cop cA
      cop csn cop cA cA cA cop cop csn cA cA cop cA cA cop cop cA cA cop cop
      csn cop cop cded wcel cA cA cop cA cop csn cA cA cop cA cop csn cop cA cA
      cA cop cop csn cA cA cop cA cA cop cop cA cA cop cop csn cop cop calg
      wcel vz cv cA cA cA cop cop csn cfv cA cA cop cA cop csn cfv vz cv wceq
      vz cv cA cA cA cop cop csn cfv cA cA cop cA cop csn cfv vz cv wceq wa vz
      cA csn wral vy cv vx cv cop cA cA cop cA cA cop cop cA cA cop cop csn cdm
      wcel vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq
      wb vy cA cA cop csn wral vx cA cA cop csn wral w3a vy cv cA cA cop cA cop
      csn cfv vx cv cA cA cop cA cop csn cfv wceq vy cv vx cv cA cA cop cA cA
      cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv vx cv cA cA cop cA
      cop csn cfv wceq wi vy cA cA cop csn wral vx cA cA cop csn wral vy cv cA
      cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq vy cv vx cv cA
      cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv vy cv
      cA cA cop cA cop csn cfv wceq wi vy cA cA cop csn wral vx cA cA cop csn
      wral wa wa wb cA cA cop cA cop csn cvv wcel cA cA cop cA cop csn cvv wcel
      cA cA cA cop cop csn cvv wcel cA cA cop cA cop snex cA cA cop cA cop snex
      cA cA cA cop cop snex 3pm3.2i cA cA cop cA cA cop cop cA cA cop cop snex
      cvv cvv cA cA cop cA cop csn cA cA cop cA cop csn cA cA cop cA cA cop cop
      cA cA cop cop csn vx vy cvv cvv cA cA cA cop cop csn cA cA cop csn cA csn
      vz cA cA cop cA cop csn cdm cA cA cop csn cA cA cop cA dmsnop eqcomi cA
      cA cA cop cop csn cdm cA csn cA cA cA cop dmsnop eqcomi isded mp2an cA cA
      cop cA cop csn cA cA cop cA cop csn cop cA cA cA cop cop csn cA cA cop cA
      cA cop cop cA cA cop cop csn cop cop calg wcel vz cv cA cA cA cop cop csn
      cfv cA cA cop cA cop csn cfv vz cv wceq vz cv cA cA cA cop cop csn cfv cA
      cA cop cA cop csn cfv vz cv wceq wa vz cA csn wral vy cv vx cv cop cA cA
      cop cA cA cop cop cA cA cop cop csn cdm wcel vy cv cA cA cop cA cop csn
      cfv vx cv cA cA cop cA cop csn cfv wceq wb vy cA cA cop csn wral vx cA cA
      cop csn wral cA 1ded.1 1alg vz cv cA cA cA cop cop csn cfv cA cA cop cA
      cop csn cfv vz cv wceq vz cv cA cA cA cop cop csn cfv cA cA cop cA cop
      csn cfv vz cv wceq wa vz cA csn vz cv cA csn wcel vz cv cA cA cA cop cop
      csn cfv cA cA cop cA cop csn cfv vz cv wceq vz cv cA cA cA cop cop csn
      cfv cA cA cop cA cop csn cfv vz cv wceq wa wi vz cv cA csn wcel vz cv cA
      cA cA cop cop csn cfv cA cA cop cA cop csn cfv vz cv wceq wi vz cv cA csn
      wcel vz cv cA wceq vz cv cA cA cA cop cop csn cfv cA cA cop cA cop csn
      cfv vz cv wceq vz cv cA elsni vz cv cA wceq cA cA cA cA cop cop csn cfv
      cA cA cop cA cop csn cfv cA vz cv cA cA cA cop cop csn cfv cA cA cop cA
      cop csn cfv vz cv cA cA cA cA cop cop csn cfv cA cA cop cA cop csn cfv cA
      cA cop cA cA cop cA cop csn cfv cA cA cA cA cA cop cop csn cfv cA cA cop
      cA cA cop cA cop csn cA cA cA cop 1ded.1 cA cA opex fvsn fveq2i cA cA cop
      cA cA cA opex 1ded.1 fvsn eqtri vz cv cA wceq vz cv cA cA cA cop cop csn
      cfv cA cA cA cA cop cop csn cfv cA cA cop cA cop csn vz cv cA cA cA cA
      cop cop csn fveq2 fveq2d vz cv cA wceq id 3eqtr4a syl vz cv cA csn wcel
      vz cv cA cA cA cop cop csn cfv cA cA cop cA cop csn cfv vz cv wceq
      anidmdbi mpbir rgen vy cv vx cv cop cA cA cop cA cA cop cop cA cA cop cop
      csn cdm wcel vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn
      cfv wceq wb vx vy cA cA cop csn vx cv cA cA cop wceq vy cv cA cA cop wceq
      vy cv vx cv cop cA cA cop cA cA cop cop cA cA cop cop csn cdm wcel vy cv
      cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq wb vx cv cA
      cA cop csn wcel vy cv cA cA cop csn wcel vx cv cA cA cop wceq vy cv cA cA
      cop wceq wa cA cA cop cA cA cop cop cA cA cop cA cA cop cop cA cA cop cop
      csn cdm wcel cA cA cop cA cA cop cA cop csn cfv cA cA cop cA cA cop cA
      cop csn cfv wceq vy cv vx cv cop cA cA cop cA cA cop cop cA cA cop cop
      csn cdm wcel vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn
      cfv wceq cA cA cop cA cA cop cop cA cA cop cA cA cop cop cA cA cop cop
      csn cdm wcel cA cA cop cA cA cop cA cop csn cfv cA cA cop cA cA cop cA
      cop csn cfv wceq wb vx cv cA cA cop wceq vy cv cA cA cop wceq wa cA cA
      cop cA cA cop cop cA cA cop cA cA cop cop cA cA cop cop csn cdm wcel cA
      cA cop cA cA cop cA cop csn cfv cA cA cop cA cA cop cA cop csn cfv wceq
      cA cA cop cA cA cop cop cA cA cop cA cA cop cop csn cA cA cop cA cA cop
      cop cA cA cop cop csn cdm cA cA cop cA cA cop cop cA cA cop cA cA cop
      opex snid cA cA cop cA cA cop cop cA cA cop dmsnop eleqtrri cA cA cop cA
      cA cop cA cop csn cfv eqid 2th a1i vx cv cA cA cop wceq vy cv cA cA cop
      wceq wa cA cA cop cA cA cop cop vy cv vx cv cop cA cA cop cA cA cop cop
      cA cA cop cop csn cdm vy cv cA cA cop wceq vx cv cA cA cop wceq cA cA cop
      cA cA cop cop vy cv vx cv cop wceq vy cv cA cA cop wceq vx cv cA cA cop
      wceq wa vy cv vx cv cop cA cA cop cA cA cop cop vy cv vx cv cA cA cop cA
      cA cop opeq12 eqcomd ancoms eleq1d vx cv cA cA cop wceq vy cv cA cA cop
      wceq wa cA cA cop cA cA cop cA cop csn cfv vy cv cA cA cop cA cop csn cfv
      cA cA cop cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv vx cv
      cA cA cop wceq vy cv cA cA cop wceq wa cA cA cop vy cv cA cA cop cA cop
      csn vy cv cA cA cop wceq cA cA cop vy cv wceq vx cv cA cA cop wceq vy cv
      cA cA cop wceq vy cv cA cA cop vy cv cA cA cop wceq id eqcomd adantl
      fveq2d vx cv cA cA cop wceq cA cA cop cA cA cop cA cop csn cfv vx cv cA
      cA cop cA cop csn cfv wceq vy cv cA cA cop wceq vx cv cA cA cop wceq cA
      cA cop vx cv cA cA cop cA cop csn vx cv cA cA cop wceq vx cv cA cA cop vx
      cv cA cA cop wceq id eqcomd fveq2d adantr eqeq12d 3bitr3d vx cv cA cA cop
      elsni vy cv cA cA cop elsni syl2an rgen2a 3pm3.2i vy cv cA cA cop cA cop
      csn cfv vx cv cA cA cop cA cop csn cfv wceq vy cv vx cv cA cA cop cA cA
      cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv vx cv cA cA cop cA
      cop csn cfv wceq wi vy cA cA cop csn wral vx cA cA cop csn wral vy cv cA
      cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq vy cv vx cv cA
      cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv vy cv
      cA cA cop cA cop csn cfv wceq wi vy cA cA cop csn wral vx cA cA cop csn
      wral vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq
      vy cv vx cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop
      csn cfv vx cv cA cA cop cA cop csn cfv wceq wi vx vy cA cA cop csn vx cv
      cA cA cop wceq vy cv cA cA cop wceq vy cv cA cA cop cA cop csn cfv vx cv
      cA cA cop cA cop csn cfv wceq vy cv vx cv cA cA cop cA cA cop cop cA cA
      cop cop csn co cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv
      wceq wi vx cv cA cA cop csn wcel vy cv cA cA cop csn wcel vx cv cA cA cop
      wceq vy cv cA cA cop wceq wa cA cA cop cA cA cop cA cA cop cA cA cop cop
      cA cA cop cop csn co cA cA cop cA cop csn cfv cA cA cop cA cA cop cA cop
      csn cfv wceq vy cv vx cv cA cA cop cA cA cop cop cA cA cop cop csn co cA
      cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq vy cv cA cA cop
      cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq vx cv cA cA cop wceq
      vy cv cA cA cop wceq wa cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA
      cop cop csn co cA cA cop cA cop csn cfv vy cv vx cv cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cop csn cfv cA cA cop cA cA cop cA
      cop csn cfv vx cv cA cA cop cA cop csn cfv vx cv cA cA cop wceq vy cv cA
      cA cop wceq cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn
      co cA cA cop cA cop csn cfv cA cA cop vx cv cA cA cop cA cA cop cop cA cA
      cop cop csn co cA cA cop cA cop csn cfv vy cv vx cv cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cop csn cfv vx cv cA cA cop wceq cA
      cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop
      vx cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop csn
      vx cv cA cA cop wceq cA cA cop vx cv cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn
      co vx cv cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn
      opreq2 eqcomd fveq2d vy cv cA cA cop wceq cA cA cop vx cv cA cA cop cA cA
      cop cop cA cA cop cop csn co vy cv vx cv cA cA cop cA cA cop cop cA cA
      cop cop csn co cA cA cop cA cop csn vy cv cA cA cop wceq vy cv vx cv cA
      cA cop cA cA cop cop cA cA cop cop csn co cA cA cop vx cv cA cA cop cA cA
      cop cop cA cA cop cop csn co vy cv cA cA cop vx cv cA cA cop cA cA cop
      cop cA cA cop cop csn opreq1 eqcomd fveq2d sylan9eq vx cv cA cA cop wceq
      cA cA cop cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq vy
      cv cA cA cop wceq vx cv cA cA cop wceq vx cv cA cA cop cA cop csn cfv cA
      cA cop cA cA cop cA cop csn cfv vx cv cA cA cop cA cA cop cA cop csn
      fveq2 eqcomd adantr eqeq12d cA cA cop cA cA cop cA cA cop cA cA cop cop
      cA cA cop cop csn co cA cA cop cA cop csn cfv cA cA cop cA cA cop cA cop
      csn cfv wceq vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn
      cfv wceq cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co
      cA cA cop cA cA cop cA cop csn cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA cop cA cA cop cop
      cA cA cop cop csn cfv cA cA cop cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn df-opr cA cA cop cA cA cop cop cA cA cop cA cA cop
      cA cA cop opex cA cA opex fvsn eqtri fveq2i a1i syl5bi vx cv cA cA cop
      elsni vy cv cA cA cop elsni syl2an rgen2a vy cv cA cA cop cA cop csn cfv
      vx cv cA cA cop cA cop csn cfv wceq vy cv vx cv cA cA cop cA cA cop cop
      cA cA cop cop csn co cA cA cop cA cop csn cfv vy cv cA cA cop cA cop csn
      cfv wceq wi vx vy cA cA cop csn vx cv cA cA cop wceq vy cv cA cA cop wceq
      vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop csn cfv wceq vy cv
      vx cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop csn
      cfv vy cv cA cA cop cA cop csn cfv wceq wi vx cv cA cA cop csn wcel vy cv
      cA cA cop csn wcel vx cv cA cA cop wceq vy cv cA cA cop wceq wa cA cA cop
      cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop
      csn cfv cA cA cop cA cA cop cA cop csn cfv wceq vy cv vx cv cA cA cop cA
      cA cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv vy cv cA cA cop
      cA cop csn cfv wceq vy cv cA cA cop cA cop csn cfv vx cv cA cA cop cA cop
      csn cfv wceq vx cv cA cA cop wceq vy cv cA cA cop wceq wa cA cA cop cA cA
      cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv
      vy cv vx cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop
      csn cfv cA cA cop cA cA cop cA cop csn cfv vy cv cA cA cop cA cop csn cfv
      vx cv cA cA cop wceq vy cv cA cA cop wceq wa cA cA cop cA cA cop cA cA
      cop cA cA cop cop cA cA cop cop csn co vy cv vx cv cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cop csn vy cv cA cA cop wceq vx cv
      cA cA cop wceq cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop
      csn co vy cv cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co vy cv
      vx cv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv cA cA cop wceq
      vy cv cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA
      cA cop cA cA cop cA cA cop cop cA cA cop cop csn co vy cv cA cA cop cA cA
      cop cA cA cop cA cA cop cop cA cA cop cop csn opreq1 eqcomd vx cv cA cA
      cop wceq vy cv vx cv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv
      cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co vx cv cA cA cop vy
      cv cA cA cop cA cA cop cop cA cA cop cop csn opreq2 eqcomd sylan9eqr
      fveq2d vy cv cA cA cop wceq cA cA cop cA cA cop cA cop csn cfv vy cv cA
      cA cop cA cop csn cfv wceq vx cv cA cA cop wceq vy cv cA cA cop wceq vy
      cv cA cA cop cA cop csn cfv cA cA cop cA cA cop cA cop csn cfv vy cv cA
      cA cop cA cA cop cA cop csn fveq2 eqcomd adantl eqeq12d cA cA cop cA cA
      cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cop csn cfv
      cA cA cop cA cA cop cA cop csn cfv wceq vy cv cA cA cop cA cop csn cfv vx
      cv cA cA cop cA cop csn cfv wceq cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cop csn cfv cA cA cop cA cA cop cop
      cA cA cop cA cA cop cop cA cA cop cop csn cfv cA cA cop cA cop csn cfv cA
      cA cop cA cA cop cA cop csn cfv cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA cop cA cA cop cop
      cA cA cop cop csn cfv cA cA cop cA cop csn cA cA cop cA cA cop cA cA cop
      cA cA cop cop cA cA cop cop csn df-opr fveq2i cA cA cop cA cA cop cop cA
      cA cop cA cA cop cop cA cA cop cop csn cfv cA cA cop cA cA cop cA cop csn
      cA cA cop cA cA cop cop cA cA cop cA cA cop cA cA cop opex cA cA opex
      fvsn fveq2i eqtri a1i syl5bi vx cv cA cA cop elsni vy cv cA cA cop elsni
      syl2an rgen2a pm3.2i mpbir2an $.
      $( [31-Oct-2007] $) $( [30-Oct-2007] $)
  $}


  ${ $d f t u v w x y z $.
  $( Structure of a deductive system. $)
  strded $p |- Ded C_ ( ( _V X. _V ) X. ( _V X. _V ) ) $=
    cded vx cv vf cv vt cv cop vw cv vv cv cop cop wceq vf cv vt cv cop vw cv
    vv cv cop cop calg wcel vu cv vw cv cfv vf cv cfv vu cv wceq vu cv vw cv
    cfv vt cv cfv vu cv wceq wa vu vw cv cdm wral vz cv vy cv cop vv cv cdm
    wcel vz cv vf cv cfv vy cv vt cv cfv wceq wb vz vf cv cdm wral vy vf cv cdm
    wral w3a vz cv vf cv cfv vy cv vt cv cfv wceq vz cv vy cv vv cv co vf cv
    cfv vy cv vf cv cfv wceq wi vz vf cv cdm wral vy vf cv cdm wral vz cv vf cv
    cfv vy cv vt cv cfv wceq vz cv vy cv vv cv co vt cv cfv vz cv vt cv cfv
    wceq wi vz vf cv cdm wral vy vf cv cdm wral wa wa wa vv wex vw wex vt wex
    vf wex vx cab cvv cvv cxp cvv cvv cxp cxp vx vy vz vw vv vu vt vf df-ded vf
    cv vt cv cop vw cv vv cv cop cop calg wcel vu cv vw cv cfv vf cv cfv vu cv
    wceq vu cv vw cv cfv vt cv cfv vu cv wceq wa vu vw cv cdm wral vz cv vy cv
    cop vv cv cdm wcel vz cv vf cv cfv vy cv vt cv cfv wceq wb vz vf cv cdm
    wral vy vf cv cdm wral w3a vz cv vf cv cfv vy cv vt cv cfv wceq vz cv vy cv
    vv cv co vf cv cfv vy cv vf cv cfv wceq wi vz vf cv cdm wral vy vf cv cdm
    wral vz cv vf cv cfv vy cv vt cv cfv wceq vz cv vy cv vv cv co vt cv cfv vz
    cv vt cv cfv wceq wi vz vf cv cdm wral vy vf cv cdm wral wa wa vx vf vt vv
    vw stcat eqsstri $.
    $( [30-Oct-2007] $) $( [28-Oct-2007] $)
  $}

  $( A deductive system is a relation. $)
  relded $p |- Rel Ded $=
    cded wrel cded cvv cvv cxp wss cded cvv cvv cxp cvv cvv cxp cxp cvv cvv cxp
    strded cvv cvv cxp cvv cvv cxp xpss sstri cded df-rel mpbir $.
    $( [30-Oct-2007] $) $( [28-Oct-2007] $)

  $( The domain of a deductive system is a relation. $)
  reldded $p |- Rel dom Ded $=
    cded cdm wrel cded cdm cvv cvv cxp wss cded cdm cvv cvv cxp cvv cvv cxp cxp
    cdm cvv cvv cxp cded cvv cvv cxp cvv cvv cxp cxp wss cded cdm cvv cvv cxp
    cvv cvv cxp cxp cdm wss strded cded cvv cvv cxp cvv cvv cxp cxp dmss ax-mp
    cvv cvv cxp dmxpid sseqtri cded cdm df-rel mpbir $.
    $( [30-Oct-2007] $) $( [28-Oct-2007] $)

  $( The range of a deductive system is a relation. $)
  relrded $p |- Rel ran Ded $=
    cded crn wrel cded crn cvv cvv cxp wss cded crn cvv cvv cxp cvv cvv cxp cxp
    crn cvv cvv cxp cded cvv cvv cxp cvv cvv cxp cxp wss cded crn cvv cvv cxp
    cvv cvv cxp cxp crn wss strded cded cvv cvv cxp cvv cvv cxp cxp rnss ax-mp
    cvv cvv cxp c0 wne cvv cvv cxp cvv cvv cxp cxp crn cvv cvv cxp wceq cvv c0
    wne cvv c0 wne wa cvv cvv cxp c0 wne cvv c0 wne cvv c0 wne vn0 vn0 pm3.2i
    cvv cvv xpnz mpbi cvv cvv cxp cvv cvv cxp rnxp ax-mp sseqtri cded crn
    df-rel mpbir $.
    $( [30-Oct-2007] $) $( [28-Oct-2007] $)

  ${
    $d T x y z $.
    $( A deductive system is an "algebra". $)
    dedalg $p |- ( T e. Ded -> T e. Alg ) $=
      cT cded wcel cT cT cdom_ cfv cT ccod_ cfv cop cT cid_ cfv cT co_ cfv cop
      cop calg cT cded wcel cT cT c1st cfv c1st cfv cT c1st cfv c2nd cfv cop cT
      c2nd cfv c1st cfv cT c2nd cfv c2nd cfv cop cop cT cdom_ cfv cT ccod_ cfv
      cop cT cid_ cfv cT co_ cfv cop cop cded wrel cded cdm wrel cded crn wrel
      w3a cT cded wcel cT cT c1st cfv c1st cfv cT c1st cfv c2nd cfv cop cT c2nd
      cfv c1st cfv cT c2nd cfv c2nd cfv cop cop wceq cded wrel cded cdm wrel
      cded crn wrel relded reldded relrded 3pm3.2i cT cded 11st22nd mpan cT
      cdom_ cfv cT ccod_ cfv cop cT c1st cfv c1st cfv cT c1st cfv c2nd cfv cop
      cT cid_ cfv cT co_ cfv cop cT c2nd cfv c1st cfv cT c2nd cfv c2nd cfv cop
      cT cdom_ cfv cT c1st cfv c1st cfv cT ccod_ cfv cT c1st cfv c2nd cfv cT
      cdom_ cfv cT cT cdom_ cfv eqid domval cT ccod_ cfv cT cT ccod_ cfv eqid
      codval opeq12i cT cid_ cfv cT c2nd cfv c1st cfv cT co_ cfv cT c2nd cfv
      c2nd cfv cT cT cid_ cfv cT cid_ cfv eqid idval cT cT co_ cfv cT co_ cfv
      eqid cmpval opeq12i opeq12i syl6eqr cT cded wcel cT cdom_ cfv cT ccod_
      cfv cop cT cid_ cfv cT co_ cfv cop cop calg wcel vz cv cT cid_ cfv cfv cT
      cdom_ cfv cfv vz cv wceq vz cv cT cid_ cfv cfv cT ccod_ cfv cfv vz cv
      wceq wa vz cT cid_ cfv cdm wral vy cv vx cv cop cT co_ cfv cdm wcel vy cv
      cT cdom_ cfv cfv vx cv cT ccod_ cfv cfv wceq wb vy cT cdom_ cfv cdm wral
      vx cT cdom_ cfv cdm wral cT cded wcel cT cdom_ cfv cT ccod_ cfv cop cT
      cid_ cfv cT co_ cfv cop cop calg wcel vz cv cT cid_ cfv cfv cT cdom_ cfv
      cfv vz cv wceq vz cv cT cid_ cfv cfv cT ccod_ cfv cfv vz cv wceq wa vz cT
      cid_ cfv cdm wral vy cv vx cv cop cT co_ cfv cdm wcel vy cv cT cdom_ cfv
      cfv vx cv cT ccod_ cfv cfv wceq wb vy cT cdom_ cfv cdm wral vx cT cdom_
      cfv cdm wral w3a vy cv cT cdom_ cfv cfv vx cv cT ccod_ cfv cfv wceq vy cv
      vx cv cT co_ cfv co cT cdom_ cfv cfv vx cv cT cdom_ cfv cfv wceq wi vy cT
      cdom_ cfv cdm wral vx cT cdom_ cfv cdm wral vy cv cT cdom_ cfv cfv vx cv
      cT ccod_ cfv cfv wceq vy cv vx cv cT co_ cfv co cT ccod_ cfv cfv vy cv cT
      ccod_ cfv cfv wceq wi vy cT cdom_ cfv cdm wral vx cT cdom_ cfv cdm wral
      wa cT ccod_ cfv cT cdom_ cfv cT co_ cfv cT vx vy cT cid_ cfv cT cdom_ cfv
      cdm cT cid_ cfv cdm vz cT cdom_ cfv eqid cT ccod_ cfv eqid cT cid_ cfv
      eqid cT co_ cfv eqid cT cdom_ cfv cdm eqid cT cid_ cfv cdm eqid dedi
      pm3.26d 3simp1d eqeltrd $.
      $( [30-Oct-2007] $) $( [28-Oct-2007] $)
  $}

  ${ $d A x $.  $d C x y z $.  $d D x y z $.  $d J x $.
    $d O x $.  $d T y z $.
    idosd.1 $e |- O = dom J $.
    idosd.2 $e |- D = ( dom_ ` T ) $.
    idosd.3 $e |- J = ( id_ ` T ) $.
    idosd.4 $e |- C = ( cod_ ` T ) $.
    $( The identity is a morphism which has the same object as its domain
       and its codomain. $)
    idosd $p |- ( ( T e. Ded /\ A e. O ) ->  ( ( D ` ( J ` A ) ) = A /\
        ( C ` ( J ` A ) ) = A ) ) $=
      cT cded wcel cA cO wcel cA cJ cfv cD cfv cA wceq cA cJ cfv cC cfv cA wceq
      wa cT cded wcel cD cC cop cJ cT co_ cfv cop cop calg wcel vx cv cJ cfv cD
      cfv vx cv wceq vx cv cJ cfv cC cfv vx cv wceq wa vx cO wral vz cv vy cv
      cop cT co_ cfv cdm wcel vz cv cD cfv vy cv cC cfv wceq wb vz cD cdm wral
      vy cD cdm wral w3a vz cv cD cfv vy cv cC cfv wceq vz cv vy cv cT co_ cfv
      co cD cfv vy cv cD cfv wceq wi vz cD cdm wral vy cD cdm wral vz cv cD cfv
      vy cv cC cfv wceq vz cv vy cv cT co_ cfv co cC cfv vz cv cC cfv wceq wi
      vz cD cdm wral vy cD cdm wral wa wa cA cO wcel cA cJ cfv cD cfv cA wceq
      cA cJ cfv cC cfv cA wceq wa wi cC cD cT co_ cfv cT vy vz cJ cD cdm cO vx
      idosd.2 idosd.4 idosd.3 cT co_ cfv eqid cD cdm eqid idosd.1 dedi cD cC
      cop cJ cT co_ cfv cop cop calg wcel vx cv cJ cfv cD cfv vx cv wceq vx cv
      cJ cfv cC cfv vx cv wceq wa vx cO wral vz cv vy cv cop cT co_ cfv cdm
      wcel vz cv cD cfv vy cv cC cfv wceq wb vz cD cdm wral vy cD cdm wral w3a
      cA cO wcel cA cJ cfv cD cfv cA wceq cA cJ cfv cC cfv cA wceq wa wi vz cv
      cD cfv vy cv cC cfv wceq vz cv vy cv cT co_ cfv co cD cfv vy cv cD cfv
      wceq wi vz cD cdm wral vy cD cdm wral vz cv cD cfv vy cv cC cfv wceq vz
      cv vy cv cT co_ cfv co cC cfv vz cv cC cfv wceq wi vz cD cdm wral vy cD
      cdm wral wa vx cv cJ cfv cD cfv vx cv wceq vx cv cJ cfv cC cfv vx cv wceq
      wa vx cO wral cD cC cop cJ cT co_ cfv cop cop calg wcel cA cO wcel cA cJ
      cfv cD cfv cA wceq cA cJ cfv cC cfv cA wceq wa wi vz cv vy cv cop cT co_
      cfv cdm wcel vz cv cD cfv vy cv cC cfv wceq wb vz cD cdm wral vy cD cdm
      wral vx cv cJ cfv cD cfv vx cv wceq vx cv cJ cfv cC cfv vx cv wceq wa cA
      cJ cfv cD cfv cA wceq cA cJ cfv cC cfv cA wceq wa vx cA cO vx cv cA wceq
      vx cv cJ cfv cD cfv vx cv wceq cA cJ cfv cD cfv cA wceq vx cv cJ cfv cC
      cfv vx cv wceq cA cJ cfv cC cfv cA wceq vx cv cA wceq vx cv cJ cfv cD cfv
      cA cJ cfv cD cfv vx cv cA vx cv cA wceq vx cv cJ cfv cA cJ cfv cD vx cv
      cA cJ fveq2 fveq2d vx cv cA wceq id eqeq12d vx cv cA wceq vx cv cJ cfv cC
      cfv cA cJ cfv cC cfv vx cv cA vx cv cA wceq vx cv cJ cfv cA cJ cfv cC vx
      cv cA cJ fveq2 fveq2d vx cv cA wceq id eqeq12d anbi12d rcla4cv 3ad2ant2
      adantr syl imp $.
      $( [30-Oct-2007] $) $( [28-Oct-2007] $)
  $}

  ${ $d C f g x $.  $d D f g x $.  $d F f g $.  $d G g $.  $d M f g $.
     $d R f g $.  $d T x $.
    ded.1 $e |- M = dom D $.
    ded.2 $e |- D = ( dom_ ` T ) $.
    ded.3 $e |- C = ( cod_ ` T ) $.
    ded.4 $e |- R = ( o_ ` T ) $.
    $( ` ( G ( o_ `` T ) F )  ` is only defined when the domain of ` G ` is the
      codomain of ` F ` . $)
    cmppfd $p |- ( ( T e. Ded /\ F e. M /\ G e. M ) ->
          ( <. G , F >. e. dom R <-> ( D ` G ) = ( C ` F ) ) ) $=
      cT cded wcel cF cM wcel cG cM wcel cG cF cop cR cdm wcel cG cD cfv cF cC
      cfv wceq wb cT cded wcel cD cC cop cT cid_ cfv cR cop cop calg wcel vx cv
      cT cid_ cfv cfv cD cfv vx cv wceq vx cv cT cid_ cfv cfv cC cfv vx cv wceq
      wa vx cT cid_ cfv cdm wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv
      cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq
      vg cv vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv
      cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg
      cM wral vf cM wral wa wa cF cM wcel cG cM wcel wa cG cF cop cR cdm wcel
      cG cD cfv cF cC cfv wceq wb wi cC cD cR cT vf vg cT cid_ cfv cM cT cid_
      cfv cdm vx ded.2 ded.3 cT cid_ cfv eqid ded.4 ded.1 cT cid_ cfv cdm eqid
      dedi cD cC cop cT cid_ cfv cR cop cop calg wcel vx cv cT cid_ cfv cfv cD
      cfv vx cv wceq vx cv cT cid_ cfv cfv cC cfv vx cv wceq wa vx cT cid_ cfv
      cdm wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg
      cM wral vf cM wral w3a cF cM wcel cG cM wcel wa cG cF cop cR cdm wcel cG
      cD cfv cF cC cfv wceq wb wi vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR
      co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral vg cv cD cfv vf cv
      cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg cM wral vf
      cM wral wa vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb
      vg cM wral vf cM wral cD cC cop cT cid_ cfv cR cop cop calg wcel cF cM
      wcel cG cM wcel wa cG cF cop cR cdm wcel cG cD cfv cF cC cfv wceq wb wi
      vx cv cT cid_ cfv cfv cD cfv vx cv wceq vx cv cT cid_ cfv cfv cC cfv vx
      cv wceq wa vx cT cid_ cfv cdm wral cF cM wcel cG cM wcel wa vg cv vf cv
      cop cR cdm wcel vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral
      cG cF cop cR cdm wcel cG cD cfv cF cC cfv wceq wb vg cv vf cv cop cR cdm
      wcel vg cv cD cfv vf cv cC cfv wceq wb cG cF cop cR cdm wcel cG cD cfv cF
      cC cfv wceq wb vg cv cF cop cR cdm wcel vg cv cD cfv cF cC cfv wceq wb vf
      vg cF cG cM cM vf cv cF wceq vg cv vf cv cop cR cdm wcel vg cv cF cop cR
      cdm wcel vg cv cD cfv vf cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vf cv
      cF wceq vg cv vf cv cop vg cv cF cop cR cdm vf cv cF vg cv opeq2 eleq1d
      vf cv cF wceq vf cv cC cfv cF cC cfv vg cv cD cfv vf cv cF cC fveq2
      eqeq2d bibi12d vg cv cG wceq vg cv cF cop cR cdm wcel cG cF cop cR cdm
      wcel vg cv cD cfv cF cC cfv wceq cG cD cfv cF cC cfv wceq vg cv cG wceq
      vg cv cF cop cG cF cop cR cdm vg cv cG cF opeq1 eleq1d vg cv cG wceq vg
      cv cD cfv cG cD cfv cF cC cfv vg cv cG cD fveq2 eqeq1d bibi12d rcla42v
      com12 3ad2ant3 adantr syl 3impib $.
      $( [30-Oct-2007] $) $( [29-Oct-2007] $)


    $( When ` ( G ( o_ `` T ) F ) ` is defined its domain is the domain of
       ` F ` . $)
    domcmpd $p |- ( ( T e. Ded /\ F e. M /\ G e. M ) ->
            ( ( D ` G ) = ( C ` F ) -> ( D ` ( G R F ) ) = ( D ` F ) ) ) $=
      cT cded wcel cF cM wcel cG cM wcel cG cD cfv cF cC cfv wceq cG cF cR co
      cD cfv cF cD cfv wceq wi cT cded wcel cD cC cop cT cid_ cfv cR cop cop
      calg wcel vx cv cT cid_ cfv cfv cD cfv vx cv wceq vx cv cT cid_ cfv cfv
      cC cfv vx cv wceq wa vx cT cid_ cfv cdm wral vg cv vf cv cop cR cdm wcel
      vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv
      vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM
      wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv
      vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa cF cM wcel cG cM wcel wa
      cG cD cfv cF cC cfv wceq cG cF cR co cD cfv cF cD cfv wceq wi wi cC cD cR
      cT vf vg cT cid_ cfv cM cT cid_ cfv cdm vx ded.2 ded.3 cT cid_ cfv eqid
      ded.4 ded.1 cT cid_ cfv cdm eqid dedi vg cv cD cfv vf cv cC cfv wceq vg
      cv vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral cF cM
      wcel cG cM wcel wa cG cD cfv cF cC cfv wceq cG cF cR co cD cfv cF cD cfv
      wceq wi wi cD cC cop cT cid_ cfv cR cop cop calg wcel vx cv cT cid_ cfv
      cfv cD cfv vx cv wceq vx cv cT cid_ cfv cfv cC cfv vx cv wceq wa vx cT
      cid_ cfv cdm wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv
      wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf
      cv cR co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral cF cM wcel cG
      cM wcel wa vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf cv
      cD cfv wceq wi vg cM wral vf cM wral cG cD cfv cF cC cfv wceq cG cF cR co
      cD cfv cF cD cfv wceq wi vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co
      cD cfv vf cv cD cfv wceq wi cG cD cfv cF cC cfv wceq cG cF cR co cD cfv
      cF cD cfv wceq wi vg cv cD cfv cF cC cfv wceq vg cv cF cR co cD cfv cF cD
      cfv wceq wi vf vg cF cG cM cM vf cv cF wceq vg cv cD cfv vf cv cC cfv
      wceq vg cv cD cfv cF cC cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv
      wceq vg cv cF cR co cD cfv cF cD cfv wceq vf cv cF wceq vf cv cC cfv cF
      cC cfv vg cv cD cfv vf cv cF cC fveq2 eqeq2d vf cv cF wceq vg cv vf cv cR
      co cD cfv vg cv cF cR co cD cfv vf cv cD cfv cF cD cfv vf cv cF wceq vg
      cv vf cv cR co vg cv cF cR co cD vf cv cF vg cv cR opreq2 fveq2d vf cv cF
      cD fveq2 eqeq12d imbi12d vg cv cG wceq vg cv cD cfv cF cC cfv wceq cG cD
      cfv cF cC cfv wceq vg cv cF cR co cD cfv cF cD cfv wceq cG cF cR co cD
      cfv cF cD cfv wceq vg cv cG wceq vg cv cD cfv cG cD cfv cF cC cfv vg cv
      cG cD fveq2 eqeq1d vg cv cG wceq vg cv cF cR co cD cfv cG cF cR co cD cfv
      cF cD cfv vg cv cG wceq vg cv cF cR co cG cF cR co cD vg cv cG cF cR
      opreq1 fveq2d eqeq1d imbi12d rcla42v com12 ad2antrl syl 3impib $.
      $( [30-Oct-2007] $) $( [29-Oct-2007] $)


    $( When ` ( G ( o_ `` T ) F ) ` is defined its codomain is the codomain
       of ` G ` . $)
    codcmpd $p |- ( ( T e. Ded /\ F e. M /\ G e. M ) ->
             ( ( D ` G ) = ( C ` F )
             -> ( C ` ( G R F ) ) = ( C ` G ) ) ) $=
      cT cded wcel cF cM wcel cG cM wcel cG cD cfv cF cC cfv wceq cG cF cR co
      cC cfv cG cC cfv wceq wi cT cded wcel cD cC cop cT cid_ cfv cR cop cop
      calg wcel vx cv cT cid_ cfv cfv cD cfv vx cv wceq vx cv cT cid_ cfv cfv
      cC cfv vx cv wceq wa vx cT cid_ cfv cdm wral vg cv vf cv cop cR cdm wcel
      vg cv cD cfv vf cv cC cfv wceq wb vg cM wral vf cM wral w3a vg cv cD cfv
      vf cv cC cfv wceq vg cv vf cv cR co cD cfv vf cv cD cfv wceq wi vg cM
      wral vf cM wral vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv
      vg cv cC cfv wceq wi vg cM wral vf cM wral wa wa cF cM wcel cG cM wcel wa
      cG cD cfv cF cC cfv wceq cG cF cR co cC cfv cG cC cfv wceq wi wi cC cD cR
      cT vf vg cT cid_ cfv cM cT cid_ cfv cdm vx ded.2 ded.3 cT cid_ cfv eqid
      ded.4 ded.1 cT cid_ cfv cdm eqid dedi vg cv cD cfv vf cv cC cfv wceq vg
      cv vf cv cR co cC cfv vg cv cC cfv wceq wi vg cM wral vf cM wral cF cM
      wcel cG cM wcel wa cG cD cfv cF cC cfv wceq cG cF cR co cC cfv cG cC cfv
      wceq wi wi cD cC cop cT cid_ cfv cR cop cop calg wcel vx cv cT cid_ cfv
      cfv cD cfv vx cv wceq vx cv cT cid_ cfv cfv cC cfv vx cv wceq wa vx cT
      cid_ cfv cdm wral vg cv vf cv cop cR cdm wcel vg cv cD cfv vf cv cC cfv
      wceq wb vg cM wral vf cM wral w3a vg cv cD cfv vf cv cC cfv wceq vg cv vf
      cv cR co cD cfv vf cv cD cfv wceq wi vg cM wral vf cM wral cF cM wcel cG
      cM wcel wa vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co cC cfv vg cv
      cC cfv wceq wi vg cM wral vf cM wral cG cD cfv cF cC cfv wceq cG cF cR co
      cC cfv cG cC cfv wceq wi vg cv cD cfv vf cv cC cfv wceq vg cv vf cv cR co
      cC cfv vg cv cC cfv wceq wi cG cD cfv cF cC cfv wceq cG cF cR co cC cfv
      cG cC cfv wceq wi vg cv cD cfv cF cC cfv wceq vg cv cF cR co cC cfv vg cv
      cC cfv wceq wi vf vg cF cG cM cM vf cv cF wceq vg cv cD cfv vf cv cC cfv
      wceq vg cv cD cfv cF cC cfv wceq vg cv vf cv cR co cC cfv vg cv cC cfv
      wceq vg cv cF cR co cC cfv vg cv cC cfv wceq vf cv cF wceq vf cv cC cfv
      cF cC cfv vg cv cD cfv vf cv cF cC fveq2 eqeq2d vf cv cF wceq vg cv vf cv
      cR co cC cfv vg cv cF cR co cC cfv vg cv cC cfv vf cv cF wceq vg cv vf cv
      cR co vg cv cF cR co cC vf cv cF vg cv cR opreq2 fveq2d eqeq1d imbi12d vg
      cv cG wceq vg cv cD cfv cF cC cfv wceq cG cD cfv cF cC cfv wceq vg cv cF
      cR co cC cfv vg cv cC cfv wceq cG cF cR co cC cfv cG cC cfv wceq vg cv cG
      wceq vg cv cD cfv cG cD cfv cF cC cfv vg cv cG cD fveq2 eqeq1d vg cv cG
      wceq vg cv cF cR co cC cfv cG cF cR co cC cfv vg cv cC cfv cG cC cfv vg
      cv cG wceq vg cv cF cR co cG cF cR co cC vg cv cG cF cR opreq1 fveq2d vg
      cv cG cC fveq2 eqeq12d imbi12d rcla42v com12 ad2antll syl 3impib $.
      $( [30-Oct-2007] $) $( [29-Oct-2007] $)
  $}

  ${ $d D a $.  $d O a $.  $d T a $.
    rdmob.1 $e |- O = dom ( id_ ` T ) $.
    rdmob.2 $e |- D = ( dom_ ` T ) $.
    $( The range of ` ( dom_ `` T ) ` is the class of the objects. $)
    rdmob $p |- ( T e. Ded -> ran D = O ) $=
      cT cded wcel cD crn cO cT cded wcel cT calg wcel cD cdm cO cD wf cD crn
      cO wss cT dedalg cD cT cT cid_ cfv cD cdm cO cD cdm eqid rdmob.2 rdmob.1
      cT cid_ cfv eqid doma cD cdm cO cD frn 3syl cT cded wcel va cO cD crn cT
      cded wcel va cv cO wcel va cv cD crn wcel va cv cT cid_ cfv cfv cD cfv va
      cv wceq va cv cT cid_ cfv cfv cT ccod_ cfv cfv va cv wceq wa va cv cT
      cid_ cfv cfv cD cfv cT cdom_ cfv crn wcel va cv cD crn wcel cT cded wcel
      va cv cO wcel wa va cv cT cid_ cfv cfv cD cfv va cv wceq va cv cT cid_
      cfv cfv cD cfv cT cdom_ cfv crn wcel va cv cD crn wcel wi va cv cT cid_
      cfv cfv cT ccod_ cfv cfv va cv wceq va cv cT cid_ cfv cfv cD cfv va cv
      wceq va cv cT cid_ cfv cfv cD cfv cT cdom_ cfv crn wcel va cv cD crn wcel
      va cv cT cid_ cfv cfv cD cfv va cv wceq va cv cT cid_ cfv cfv cD cfv cT
      cdom_ cfv crn wcel va cv cT cdom_ cfv crn wcel va cv cD crn wcel va cv cT
      cid_ cfv cfv cD cfv va cv cT cdom_ cfv crn eleq1 cD crn cT cdom_ cfv crn
      va cv cD cT cdom_ cfv rdmob.2 rneqi eleq2i syl6bbr biimpd adantr va cv cT
      ccod_ cfv cD cT cT cid_ cfv cO rdmob.1 rdmob.2 cT cid_ cfv eqid cT ccod_
      cfv eqid idosd cT cded wcel va cv cO wcel va cv cT cid_ cfv cfv cD cfv cT
      cdom_ cfv crn wcel cT cded wcel va cv cO wcel va cv cT cid_ cfv cfv cT
      cdom_ cfv cdm wcel va cv cT cid_ cfv cfv cD cfv cT cdom_ cfv crn wcel cT
      cded wcel cT calg wcel cO cT cdom_ cfv cdm cT cid_ cfv wf va cv cO wcel
      va cv cT cid_ cfv cfv cT cdom_ cfv cdm wcel wi cT dedalg cT cdom_ cfv cT
      cT cid_ cfv cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid cT cdom_ cfv eqid
      rdmob.1 cT cid_ cfv eqid ida cO cT cdom_ cfv cdm cT cid_ cfv wf va cv cO
      wcel va cv cT cid_ cfv cfv cT cdom_ cfv cdm wcel cO cT cdom_ cfv cdm va
      cv cT cid_ cfv ffvelrn ex 3syl cT cded wcel cT calg wcel cT cdom_ cfv cdm
      cT cid_ cfv cdm cT cdom_ cfv wf va cv cT cid_ cfv cfv cT cdom_ cfv cdm
      wcel va cv cT cid_ cfv cfv cD cfv cT cdom_ cfv crn wcel wi cT dedalg cT
      cdom_ cfv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv
      cdm eqid cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid doma cT
      cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv wf va cv cT cid_ cfv cfv cT
      cdom_ cfv cdm wcel va cv cT cid_ cfv cfv cT cdom_ cfv cfv cT cdom_ cfv
      crn wcel va cv cT cid_ cfv cfv cD cfv cT cdom_ cfv crn wcel cT cdom_ cfv
      cdm cT cid_ cfv cdm cT cdom_ cfv wf cT cdom_ cfv wfun va cv cT cid_ cfv
      cfv cT cdom_ cfv cdm wcel va cv cT cid_ cfv cfv cT cdom_ cfv cfv cT cdom_
      cfv crn wcel wi cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv ffun cT
      cdom_ cfv wfun va cv cT cid_ cfv cfv cT cdom_ cfv cdm wcel va cv cT cid_
      cfv cfv cT cdom_ cfv cfv cT cdom_ cfv crn wcel va cv cT cid_ cfv cfv cT
      cdom_ cfv fvelrn ex syl va cv cT cid_ cfv cfv cD cfv va cv cT cid_ cfv
      cfv cT cdom_ cfv cfv cT cdom_ cfv crn va cv cT cid_ cfv cfv cD cT cdom_
      cfv rdmob.2 fveq1i eleq1i syl6ibr 3syl syld imp sylc ex ssrdv eqssd $.
      $( [10-Jan-2008] $) $( [10-Jan-2008] $)

  $}

  ${ $d C a $.  $d O a $.  $d T a $.
    rcmob.1 $e |- O = dom ( id_ ` T ) $.
    rcmob.2 $e |- C = ( cod_ ` T ) $.
    $( The range of ` ( cod_ `` T ) ` is the class of the objects. $)
    rcmob $p |- ( T e. Ded -> ran C = O ) $=
      cT cded wcel cC crn cO cT cded wcel cT calg wcel cT cdom_ cfv cdm cO cC
      wf cC crn cO wss cT dedalg cC cT cdom_ cfv cT cT cid_ cfv cT cdom_ cfv
      cdm cO cT cdom_ cfv cdm eqid cT cdom_ cfv eqid rcmob.1 cT cid_ cfv eqid
      rcmob.2 coda cT cdom_ cfv cdm cO cC frn 3syl cT cded wcel va cO cC crn cT
      cded wcel va cv cO wcel va cv cC crn wcel cT cded wcel va cv cO wcel wa
      va cv cT cid_ cfv cfv cC cfv va cv cC crn cT cded wcel va cv cO wcel wa
      va cv cT cid_ cfv cfv cT cdom_ cfv cfv va cv wceq va cv cT cid_ cfv cfv
      cC cfv va cv wceq va cv cC cT cdom_ cfv cT cT cid_ cfv cO rcmob.1 cT
      cdom_ cfv eqid cT cid_ cfv eqid rcmob.2 idosd pm3.27d cC wfun va cv cT
      cid_ cfv cfv cC cdm wcel va cv cT cid_ cfv cfv cC cfv cC crn wcel cT cded
      wcel va cv cO wcel wa va cv cT cid_ cfv cfv cC fvelrn cT cded wcel cC
      wfun va cv cO wcel cT cded wcel cT calg wcel cT cdom_ cfv cdm cO cC wf cC
      wfun cT dedalg cC cT cdom_ cfv cT cT cid_ cfv cT cdom_ cfv cdm cO cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid rcmob.1 cT cid_ cfv eqid rcmob.2
      coda cT cdom_ cfv cdm cO cC ffun 3syl adantr cT calg wcel va cv cO wcel
      va cv cT cid_ cfv cfv cC cdm wcel cT cded wcel cT calg wcel va cv cO wcel
      wa va cv cT cid_ cfv cfv cT cdom_ cfv cdm cC cdm va cv cT cdom_ cfv cT cT
      cid_ cfv cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid cT cdom_ cfv eqid
      rcmob.1 cT cid_ cfv eqid idmoa cT calg wcel cC cdm cT cdom_ cfv cdm wceq
      va cv cO wcel cT calg wcel cT cdom_ cfv cdm cC cdm cC cT cdom_ cfv cT cT
      cdom_ cfv eqid rcmob.2 dcsda eqcomd adantr eleqtrrd cT dedalg sylan
      sylanc eqeltrrd ex ssrdv eqssd $.
      $( [10-Jan-2008] $) $( [10-Jan-2008] $)
  $}

  ${
    aidm2.1 $e |- D = ( dom_ ` T ) $.
    aidm2.2 $e |- C = ( cod_ ` T ) $.
    $( The underlying directed multi graph of a deductive system. $)
    aidm2 $p |- ( T e. Ded -> <. <. D , C >. , ran D >. e. Dgra ) $=
      cT cded wcel cD cC cop cD crn cop cmgra wcel cD cdm cD crn cD wf cD cdm
      cD crn cC wf wa cT cded wcel cD cdm cD crn cD wf cD cdm cD crn cC wf cT
      cded wcel cD cdm cD crn cD wf cD cdm cT cid_ cfv cdm cD wf cT cded wcel
      cT calg wcel cD cdm cT cid_ cfv cdm cD wf cT dedalg cD cT cT cid_ cfv cD
      cdm cT cid_ cfv cdm cD cdm eqid aidm2.1 cT cid_ cfv cdm eqid cT cid_ cfv
      eqid doma syl cT cded wcel cD crn cT cid_ cfv cdm wceq cD cdm cD crn cD
      wf cD cdm cT cid_ cfv cdm cD wf wb cD cT cT cid_ cfv cdm cT cid_ cfv cdm
      eqid aidm2.1 rdmob cD crn cT cid_ cfv cdm cD cdm cD feq3 syl mpbird cT
      cded wcel cD cdm cD crn cC wf cD cdm cT cid_ cfv cdm cC wf cT cded wcel
      cT calg wcel cD cdm cT cid_ cfv cdm cC wf cT dedalg cC cT cdom_ cfv cT cT
      cid_ cfv cD cdm cT cid_ cfv cdm cD cT cdom_ cfv aidm2.1 dmeqi cT cdom_
      cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid aidm2.2 coda syl cT cded
      wcel cD crn cT cid_ cfv cdm wceq cD cdm cD crn cC wf cD cdm cT cid_ cfv
      cdm cC wf wb cD cT cT cid_ cfv cdm cT cid_ cfv cdm eqid aidm2.1 rdmob cD
      crn cT cid_ cfv cdm cD cdm cC feq3 syl mpbird jca cD cvv wcel cC cvv wcel
      cD crn cvv wcel cD cC cop cD crn cop cmgra wcel cD cdm cD crn cD wf cD
      cdm cD crn cC wf wa wb cT cded wcel cvv cvv cC cD cD crn cvv ismgra cT
      cded wcel cD cT cdom_ cfv cvv cD cT cdom_ cfv wceq cT cded wcel aidm2.1
      a1i cT cdom_ fvex syl6eqel cT cded wcel cC cT ccod_ cfv cvv cC cT ccod_
      cfv wceq cT cded wcel aidm2.2 a1i cT ccod_ fvex syl6eqel cT cded wcel cD
      crn cT cdom_ cfv crn cvv cT cded wcel cD cT cdom_ cfv cD cT cdom_ cfv
      wceq cT cded wcel aidm2.1 a1i rneqd cT cded wcel cT cdom_ cfv cvv wcel cT
      cdom_ cfv crn cvv wcel cT cdom_ cfv cvv wcel cT cded wcel cT cdom_ fvex
      a1i cT cdom_ cfv cvv rnexg syl eqeltrd syl3anc mpbird $.
      $( [6-Oct-2009] $) $( [20-Sep-2009] $)
  $}

  ${ $d M x $. $d R a x $. $d T a x $.
  dmrngcmp.1 $e |- R = ( o_ ` T ) $.
  dmrngcmp.2 $e |- M = dom ( dom_ ` T ) $.
  $( Domain and range of the domain of the composition. $)
  dmrngcmp $p |- ( T e. Ded ->
    ( dom dom R = M /\ ran dom R = M ) ) $=
    cT cded wcel cR cdm cdm cM wceq cR cdm crn cM wceq cT cded wcel vx cR cdm
    cdm cM cT cded wcel vx cv cR cdm cdm wcel vx cv cM wcel cT cded wcel cT
    calg wcel vx cv cR cdm cdm wcel vx cv cM wcel wi cT dedalg cT calg wcel cT
    co_ cfv wfun cT co_ cfv cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp wss cT
    co_ cfv crn cT cdom_ cfv cdm wss w3a vx cv cR cdm cdm wcel vx cv cM wcel wi
    cT cdom_ cfv cT co_ cfv cT cT cdom_ cfv cdm cT cdom_ cfv cdm eqid cT cdom_
    cfv eqid cT co_ cfv eqid cmppfa cT co_ cfv wfun cT co_ cfv cdm cT cdom_ cfv
    cdm cT cdom_ cfv cdm cxp wss cT co_ cfv crn cT cdom_ cfv cdm wss w3a cR cdm
    cdm cM vx cv cT co_ cfv cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp wss cT
    co_ cfv wfun cR cdm cdm cM wss cT co_ cfv crn cT cdom_ cfv cdm wss cT co_
    cfv cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp wss cT co_ cfv cdm cdm cT
    cdom_ cfv cdm cT cdom_ cfv cdm cxp cdm wss cR cdm cdm cM wss cT co_ cfv cdm
    cT cdom_ cfv cdm cT cdom_ cfv cdm cxp dmss cT co_ cfv cdm cdm cT cdom_ cfv
    cdm cT cdom_ cfv cdm cxp cdm wss cT cdom_ cfv cdm cT cdom_ cfv cdm cxp cdm
    cT cdom_ cfv cdm wss cR cdm cdm cM wss cT cdom_ cfv cdm cT cdom_ cfv cdm
    dmxpss cT co_ cfv cdm cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp cdm wss cT
    cdom_ cfv cdm cT cdom_ cfv cdm cxp cdm cT cdom_ cfv cdm wss wa cT co_ cfv
    cdm cdm cT cdom_ cfv cdm cR cdm cdm cM cT co_ cfv cdm cdm cT cdom_ cfv cdm
    cT cdom_ cfv cdm cxp cdm cT cdom_ cfv cdm sstr cT co_ cfv cdm cR cdm cT co_
    cfv cR cR cT co_ cfv dmrngcmp.1 eqcomi dmeqi dmeqi cM cT cdom_ cfv cdm
    dmrngcmp.2 eqcomi 3sstr3g mpan2 syl 3ad2ant2 sseld syl syl cT cded wcel vx
    cv cM wcel vx cv cR cdm cdm wcel cT cded wcel vx cv cM wcel wa vx cv va cv
    cop cR cdm wcel va wex vx cv cR cdm cdm wcel cT cded wcel vx cv cM wcel wa
    vx cv vx cv cT cdom_ cfv cfv cT cid_ cfv cfv cop cR cdm wcel vx cv va cv
    cop cR cdm wcel va wex cT cded wcel vx cv cM wcel wa vx cv vx cv cT cdom_
    cfv cfv cT cid_ cfv cfv cop cR cdm wcel vx cv cT cdom_ cfv cfv vx cv cT
    cdom_ cfv cfv cT cid_ cfv cfv cT ccod_ cfv cfv wceq cT cded wcel vx cv cM
    wcel wa vx cv cT cdom_ cfv cfv cT cid_ cfv cfv cT ccod_ cfv cfv vx cv cT
    cdom_ cfv cfv cT cded wcel vx cv cM wcel wa vx cv cT cdom_ cfv cfv cT cid_
    cfv cfv cT cdom_ cfv cfv vx cv cT cdom_ cfv cfv wceq vx cv cT cdom_ cfv cfv
    cT cid_ cfv cfv cT ccod_ cfv cfv vx cv cT cdom_ cfv cfv wceq cT cded wcel
    vx cv cM wcel vx cv cT cdom_ cfv cfv cT cid_ cfv cdm wcel vx cv cT cdom_
    cfv cfv cT cid_ cfv cfv cT cdom_ cfv cfv vx cv cT cdom_ cfv cfv wceq vx cv
    cT cdom_ cfv cfv cT cid_ cfv cfv cT ccod_ cfv cfv vx cv cT cdom_ cfv cfv
    wceq wa cM cT cid_ cfv cdm cT cdom_ cfv wf vx cv cM wcel vx cv cT cdom_ cfv
    cfv cT cid_ cfv cdm wcel cT cded wcel cM cT cid_ cfv cdm vx cv cT cdom_ cfv
    ffvelrn cT cded wcel cT calg wcel cM cT cid_ cfv cdm cT cdom_ cfv wf cT
    dedalg cT cdom_ cfv cT cT cid_ cfv cM cT cid_ cfv cdm dmrngcmp.2 cT cdom_
    cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid doma syl sylan vx cv cT
    cdom_ cfv cfv cT ccod_ cfv cT cdom_ cfv cT cT cid_ cfv cT cid_ cfv cdm cT
    cid_ cfv cdm eqid cT cdom_ cfv eqid cT cid_ cfv eqid cT ccod_ cfv eqid
    idosd syldan pm3.27d eqcomd cT cded wcel vx cv cT cdom_ cfv cfv cT cid_ cfv
    cfv cT cdom_ cfv cdm wcel vx cv cT cdom_ cfv cdm wcel vx cv vx cv cT cdom_
    cfv cfv cT cid_ cfv cfv cop cR cdm wcel vx cv cT cdom_ cfv cfv vx cv cT
    cdom_ cfv cfv cT cid_ cfv cfv cT ccod_ cfv cfv wceq wb cT cded wcel vx cv
    cM wcel wa cT ccod_ cfv cT cdom_ cfv cR cT vx cv cT cdom_ cfv cfv cT cid_
    cfv cfv vx cv cT cdom_ cfv cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT
    ccod_ cfv eqid dmrngcmp.1 cmppfd cT cded wcel vx cv cM wcel pm3.26 cT calg
    wcel vx cv cM wcel vx cv cT cdom_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cdm
    wcel cT cded wcel cT calg wcel vx cv cM wcel vx cv cT cdom_ cfv cfv cT cid_
    cfv cdm wcel vx cv cT cdom_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cdm wcel
    cM cT cid_ cfv cdm cT cdom_ cfv wf vx cv cM wcel vx cv cT cdom_ cfv cfv cT
    cid_ cfv cdm wcel cT calg wcel cM cT cid_ cfv cdm vx cv cT cdom_ cfv
    ffvelrn cT cdom_ cfv cT cT cid_ cfv cM cT cid_ cfv cdm dmrngcmp.2 cT cdom_
    cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid doma sylan vx cv cT cdom_
    cfv cfv cT cdom_ cfv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm cT
    cdom_ cfv cdm eqid cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid
    idmoa syldan cT dedalg sylan vx cv cM wcel vx cv cT cdom_ cfv cdm wcel cT
    cded wcel vx cv cM wcel vx cv cT cdom_ cfv cdm wcel cM cT cdom_ cfv cdm vx
    cv dmrngcmp.2 eleq2i biimpi adantl syl3anc mpbird vx cv va cv cop cR cdm
    wcel vx cv vx cv cT cdom_ cfv cfv cT cid_ cfv cfv cop cR cdm wcel va vx cv
    cT cdom_ cfv cfv cT cid_ cfv cfv vx cv cT cdom_ cfv cfv cT cid_ cfv fvex va
    cv vx cv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vx cv va cv cop vx cv vx cv
    cT cdom_ cfv cfv cT cid_ cfv cfv cop cR cdm va cv vx cv cT cdom_ cfv cfv cT
    cid_ cfv cfv vx cv opeq2 eleq1d cla4ev syl va vx cv cR cdm vx visset eldm2
    sylibr ex impbid eqrdv cT cded wcel vx cR cdm crn cM cT cded wcel vx cv cR
    cdm crn wcel vx cv cM wcel cT cded wcel cT calg wcel vx cv cR cdm crn wcel
    vx cv cM wcel wi cT dedalg cT calg wcel cT co_ cfv wfun cT co_ cfv cdm cT
    cdom_ cfv cdm cT cdom_ cfv cdm cxp wss cT co_ cfv crn cT cdom_ cfv cdm wss
    w3a vx cv cR cdm crn wcel vx cv cM wcel wi cT cdom_ cfv cT co_ cfv cT cT
    cdom_ cfv cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT co_ cfv eqid
    cmppfa cT co_ cfv wfun cT co_ cfv cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp
    wss cT co_ cfv crn cT cdom_ cfv cdm wss w3a cR cdm crn cM vx cv cT co_ cfv
    cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp wss cT co_ cfv wfun cR cdm crn cM
    wss cT co_ cfv crn cT cdom_ cfv cdm wss cT co_ cfv cdm cT cdom_ cfv cdm cT
    cdom_ cfv cdm cxp wss cT co_ cfv cdm crn cT cdom_ cfv cdm cT cdom_ cfv cdm
    cxp crn wss cR cdm crn cM wss cT co_ cfv cdm cT cdom_ cfv cdm cT cdom_ cfv
    cdm cxp rnss cT co_ cfv cdm crn cT cdom_ cfv cdm cT cdom_ cfv cdm cxp crn
    wss cT cdom_ cfv cdm cT cdom_ cfv cdm cxp crn cT cdom_ cfv cdm wss cR cdm
    crn cM wss cT cdom_ cfv cdm cT cdom_ cfv cdm rnxpss cT co_ cfv cdm crn cT
    cdom_ cfv cdm cT cdom_ cfv cdm cxp crn wss cT cdom_ cfv cdm cT cdom_ cfv
    cdm cxp crn cT cdom_ cfv cdm wss wa cT co_ cfv cdm crn cT cdom_ cfv cdm cR
    cdm crn cM cT co_ cfv cdm crn cT cdom_ cfv cdm cT cdom_ cfv cdm cxp crn cT
    cdom_ cfv cdm sstr cT co_ cfv cdm cR cdm cT co_ cfv cR cR cT co_ cfv
    dmrngcmp.1 eqcomi dmeqi rneqi cM cT cdom_ cfv cdm dmrngcmp.2 eqcomi 3sstr3g
    mpan2 syl 3ad2ant2 sseld syl syl cT cded wcel vx cv cM wcel vx cv cR cdm
    crn wcel cT cded wcel vx cv cM wcel wa va cv vx cv cop cR cdm wcel va wex
    vx cv cR cdm crn wcel cT cded wcel vx cv cM wcel wa vx cv cT ccod_ cfv cfv
    cT cid_ cfv cfv vx cv cop cR cdm wcel va cv vx cv cop cR cdm wcel va wex cT
    cded wcel vx cv cM wcel wa vx cv cT ccod_ cfv cfv cT cid_ cfv cfv vx cv cop
    cR cdm wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cfv vx cv
    cT ccod_ cfv cfv wceq cT cded wcel vx cv cM wcel vx cv cT ccod_ cfv cfv cT
    cid_ cfv cdm wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cfv
    vx cv cT ccod_ cfv cfv wceq cM cT cid_ cfv cdm cT ccod_ cfv wf vx cv cM
    wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cdm wcel cT cded wcel cM cT cid_
    cfv cdm vx cv cT ccod_ cfv ffvelrn cT cded wcel cT calg wcel cM cT cid_ cfv
    cdm cT ccod_ cfv wf cT dedalg cT ccod_ cfv cT cdom_ cfv cT cT cid_ cfv cM
    cT cid_ cfv cdm dmrngcmp.2 cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_
    cfv eqid cT ccod_ cfv eqid coda syl sylan cT cded wcel vx cv cT ccod_ cfv
    cfv cT cid_ cfv cdm wcel wa vx cv cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_
    cfv cfv vx cv cT ccod_ cfv cfv wceq vx cv cT ccod_ cfv cfv cT cid_ cfv cfv
    cT ccod_ cfv cfv vx cv cT ccod_ cfv cfv wceq vx cv cT ccod_ cfv cfv cT
    ccod_ cfv cT cdom_ cfv cT cT cid_ cfv cT cid_ cfv cdm cT cid_ cfv cdm eqid
    cT cdom_ cfv eqid cT cid_ cfv eqid cT ccod_ cfv eqid idosd pm3.26d syldan
    cT cded wcel vx cv cT cdom_ cfv cdm wcel vx cv cT ccod_ cfv cfv cT cid_ cfv
    cfv cT cdom_ cfv cdm wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cfv vx cv cop
    cR cdm wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cfv vx cv
    cT ccod_ cfv cfv wceq wb cT cded wcel vx cv cM wcel wa cT ccod_ cfv cT
    cdom_ cfv cR cT vx cv vx cv cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv
    cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid dmrngcmp.1
    cmppfd cT cded wcel vx cv cM wcel pm3.26 vx cv cM wcel vx cv cT cdom_ cfv
    cdm wcel cT cded wcel vx cv cM wcel vx cv cT cdom_ cfv cdm wcel cM cT cdom_
    cfv cdm vx cv dmrngcmp.2 eleq2i biimpi adantl cT calg wcel vx cv cM wcel vx
    cv cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cdm wcel cT cded wcel cT
    calg wcel vx cv cM wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cdm wcel vx cv
    cT ccod_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cdm wcel cM cT cid_ cfv cdm
    cT ccod_ cfv wf vx cv cM wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cdm wcel
    cT calg wcel cM cT cid_ cfv cdm vx cv cT ccod_ cfv ffvelrn cT ccod_ cfv cT
    cdom_ cfv cT cT cid_ cfv cM cT cid_ cfv cdm dmrngcmp.2 cT cdom_ cfv eqid cT
    cid_ cfv cdm eqid cT cid_ cfv eqid cT ccod_ cfv eqid coda sylan vx cv cT
    ccod_ cfv cfv cT cdom_ cfv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm
    cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv
    eqid idmoa syldan cT dedalg sylan syl3anc mpbird va cv vx cv cop cR cdm
    wcel vx cv cT ccod_ cfv cfv cT cid_ cfv cfv vx cv cop cR cdm wcel va vx cv
    cT ccod_ cfv cfv cT cid_ cfv cfv vx cv cT ccod_ cfv cfv cT cid_ cfv fvex va
    cv vx cv cT ccod_ cfv cfv cT cid_ cfv cfv wceq va cv vx cv cop vx cv cT
    ccod_ cfv cfv cT cid_ cfv cfv vx cv cop cR cdm va cv vx cv cT ccod_ cfv cfv
    cT cid_ cfv cfv vx cv opeq1 eleq1d cla4ev syl va vx cv cR cdm vx visset
    elrn2 sylibr ex impbid eqrdv jca $.
    $( [6-Oct-2009] $) $( [5-Oct-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Categories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Cat $. $( The class of all categories. $)

  $( Extend class notation with the class of categories. $)
  ccat $a class Cat $.

  ${
    $d x d c j r f g h a $.
    $( A category is a deductive system where the composition is associative,
       and identities are neutral elements. $)
    df-cat $a |- Cat = { x | E. d E. c E. j E. r
    ( x = <. <. d , c >. , <. j , r >. >. /\
           ( ( <. <. d , c >. , <. j , r >. >. e. Ded /\
           A. f e. dom d A. g e. dom d A. h e. dom d
              (
                ( ( d ` h ) = ( c ` g ) /\ ( d ` g ) = ( c ` f ) )
              ->
                ( h r ( g r f ) ) = ( ( h r g ) r f )
               ) ) /\

          ( A. a e. dom j A. f e. dom d ( ( c ` f ) = a ->
             ( ( j ` a ) r f ) = f ) /\

          A. a e. dom j A. f e. dom d ( ( d ` f ) = a ->
             ( f r ( j ` a ) ) = f ) ) ) ) } $.
  $}

  ${ $d C a c d f g h j r $.  $d D a c d f g h j r $.  $d J a c d f j r $.
     $d M c d j r f $.  $d O c d j r $.  $d R a c d f g h j r $.
     $d a c d f g h j r x $.
    iscat.1 $e |- M = dom D $.
    iscat.2 $e |- O = dom J $.
    $( The predicate "is a category". $)
    iscat $p |-  ( ( ( D e. A /\ C e. B /\ J e. F ) /\ R e. G )
      -> ( <. <. D , C >. , <. J , R >. >. e. Cat
        <-> ( ( <. <. D , C >. , <. J , R >. >. e. Ded /\
           A. f e. M A. g e. M A. h e. M
              (
                ( ( D ` h ) = ( C ` g ) /\ ( D ` g ) = ( C ` f ) )
              ->
                ( h R ( g R f ) ) = ( ( h R g ) R f )
               ) ) /\

          ( A. a e. O A. f e. M ( ( C ` f ) = a ->
             ( ( J ` a ) R f ) = f ) /\

          A. a e. O A. f e. M ( ( D ` f ) = a ->
             ( f R ( J ` a ) ) = f ) ) ) ) ) $=
      cD cA wcel cC cB wcel cJ cF wcel w3a cR cG wcel wa cD cC cop cJ cR cop
      cop vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv vc cv cop vj cv
      vr cv cop cop cded wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv
      cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg
      cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral vf
      vd cv cdm wral wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv
      co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv vd cv cfv va
      cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral va
      vj cv cdm wral wa wa wa vr wex vj wex vc wex vd wex vx cab wcel cD cC cop
      cJ cR cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv
      cC cfv wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR
      co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq va
      cv cJ cfv vf cv cR co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va
      cv wceq vf cv va cv cJ cfv cR co vf cv wceq wi vf cM wral va cO wral wa
      wa cD cC cop cJ cR cop cop ccat wcel vd cv vc cv cop vj cv vr cv cop cop
      cded wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc
      cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co
      vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv cdm
      wral wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv
      wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv vd cv cfv va cv wceq vf
      cv va cv vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm
      wral wa wa cD vc cv cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv
      vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr
      cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg
      cM wral vf cM wral wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr
      cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq
      vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral
      wa wa cD cC cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv
      wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv
      co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf
      cM wral wa vf cv cC cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv
      wceq wi vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv
      vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa wa cD cC
      cop cJ vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD
      cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv
      vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv
      cC cfv va cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va
      cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi
      vf cM wral va cO wral wa wa cD cC cop cJ cR cop cop cded wcel vh cv cD
      cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv
      cR co cR co vh cv vg cv cR co vf cv cR co wceq wi vh cM wral vg cM wral
      vf cM wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq
      wi vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co
      vf cv wceq wi vf cM wral va cO wral wa wa vx vd vc vr vj cD cC cJ cR cA
      cB cF cG vd cv cD wceq vd cv vc cv cop vj cv vr cv cop cop cded wcel vh
      cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa
      vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co
      wceq wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv cdm wral wa cD vc cv
      cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv vc cv cfv wceq vg cv
      cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
      vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa
      vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi
      vf vd cv cdm wral va vj cv cdm wral vf cv vd cv cfv va cv wceq vf cv va
      cv vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral
      wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq
      wi vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv
      cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa vd cv cD wceq
      vd cv vc cv cop vj cv vr cv cop cop cded wcel cD vc cv cop vj cv vr cv
      cop cop cded wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf
      cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr
      cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv
      cdm wral vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv
      wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr
      cv co wceq wi vh cM wral vg cM wral vf cM wral vd cv cD wceq vd cv vc cv
      cop vj cv vr cv cop cop cD vc cv cop vj cv vr cv cop cop cded vd cv cD
      wceq vd cv vc cv cop cD vc cv cop vj cv vr cv cop vd cv cD vc cv opeq1
      opeq1d eleq1d vd cv cD wceq vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd
      cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
      vg cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral
      vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh
      cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq
      wi vh cM wral vg cM wral vf vd cv cdm cM vd cv cD wceq vf cv vd cv cdm
      wcel vf cv cM wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv
      vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv
      vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral vh cv
      cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg
      cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh
      cM wral vg cM wral vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv
      cdm cD cdm cM vd cv cD dmeq iscat.1 syl6eqr eleq2d vd cv cD wceq vh cv vd
      cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv
      vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi
      vh vd cv cdm wral vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc
      cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co
      vf cv vr cv co wceq wi vh cM wral vg vd cv cdm cM vd cv cD wceq vg cv vd
      cv cdm wcel vg cv cM wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd
      cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
      vg cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vh cv cD cfv vg
      cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv
      vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral
      vd cv cD wceq vd cv cdm cM vg cv vd cv cD wceq vd cv cdm cD cdm cM vd cv
      cD dmeq iscat.1 syl6eqr eleq2d vd cv cD wceq vh cv vd cv cfv vg cv vc cv
      cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv
      co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cv cD cfv vg
      cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv
      vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh vd cv
      cdm cM vd cv cD wceq vh cv vd cv cdm wcel vh cv cM wcel vh cv vd cv cfv
      vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv vg cv
      vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cv
      cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg
      cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vd
      cv cD wceq vd cv cdm cM vh cv vd cv cD wceq vd cv cdm cD cdm cM vd cv cD
      dmeq iscat.1 syl6eqr eleq2d vd cv cD wceq vh cv vd cv cfv vg cv vc cv cfv
      wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv cD cfv vg cv vc cv cfv
      wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr
      cv co vh cv vg cv vr cv co vf cv vr cv co wceq vd cv cD wceq vh cv vd cv
      cfv vg cv vc cv cfv wceq vh cv cD cfv vg cv vc cv cfv wceq vg cv vd cv
      cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq vd cv cD wceq
      vh cv vd cv cfv vh cv cD cfv vg cv vc cv cfv vh cv vd cv cD fveq1 eqeq1d
      vd cv cD wceq vg cv vd cv cfv vg cv cD cfv vf cv vc cv cfv vg cv vd cv cD
      fveq1 eqeq1d anbi12d imbi1d imbi12d ralbidv2 imbi12d ralbidv2 imbi12d
      ralbidv2 anbi12d vd cv cD wceq vf cv vc cv cfv va cv wceq va cv vj cv cfv
      vf cv vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv vc
      cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral
      va vj cv cdm wral vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv
      co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv cD cfv va cv
      wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm
      wral vd cv cD wceq vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv
      co vf cv wceq wi vf vd cv cdm wral vf cv vc cv cfv va cv wceq va cv vj cv
      cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm vd cv cD wceq vf
      cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf
      vd cv cdm cM vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq iscat.1
      syl6eqr raleq1d ralbidv vd cv cD wceq vf cv vd cv cfv va cv wceq vf cv va
      cv vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral vf cv cD cfv va cv
      wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm
      vd cv cD wceq vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv co
      vf cv wceq wi vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf
      cv wceq wi vf vd cv cdm cM vd cv cD wceq vf cv vd cv cdm wcel vf cv cM
      wcel vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq
      wi vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi
      vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv cdm cD cdm cM vd cv
      cD dmeq iscat.1 syl6eqr eleq2d vd cv cD wceq vf cv vd cv cfv va cv wceq
      vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq vd cv
      cD wceq vf cv vd cv cfv vf cv cD cfv va cv vf cv vd cv cD fveq1 eqeq1d
      imbi1d imbi12d ralbidv2 ralbidv anbi12d anbi12d vc cv cC wceq cD vc cv
      cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv vc cv cfv wceq vg cv
      cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
      vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa
      cD cC cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg
      cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
      vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa
      vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi
      vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv
      cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa vf cv cC cfv
      va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj
      cv cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
      wceq wi vf cM wral va vj cv cdm wral wa vc cv cC wceq cD vc cv cop vj cv
      vr cv cop cop cded wcel cD cC cop vj cv vr cv cop cop cded wcel vh cv cD
      cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv
      vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM
      wral vg cM wral vf cM wral vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf
      cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv
      co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral vc cv cC wceq
      cD vc cv cop vj cv vr cv cop cop cD cC cop vj cv vr cv cop cop cded vc cv
      cC wceq cD vc cv cop cD cC cop vj cv vr cv cop vc cv cC cD opeq2 opeq1d
      eleq1d vc cv cC wceq vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv
      vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv
      co vf cv vr cv co wceq wi vh cM wral vh cv cD cfv vg cv cC cfv wceq vg cv
      cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg
      cv vr cv co vf cv vr cv co wceq wi vh cM wral vf vg cM cM vc cv cC wceq
      vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh
      cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq
      wi vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv
      vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi
      vh cM vc cv cC wceq vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv
      vc cv cfv wceq wa vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC
      cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf
      cv vr cv co wceq vc cv cC wceq vh cv cD cfv vg cv vc cv cfv wceq vh cv cD
      cfv vg cv cC cfv wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv cD cfv vf
      cv cC cfv wceq vc cv cC wceq vg cv vc cv cfv vg cv cC cfv vh cv cD cfv vg
      cv vc cv cC fveq1 eqeq2d vc cv cC wceq vf cv vc cv cfv vf cv cC cfv vg cv
      cD cfv vf cv vc cv cC fveq1 eqeq2d anbi12d imbi1d ralbidv 2ralbidv
      anbi12d vc cv cC wceq vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr
      cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv cC cfv va cv wceq
      va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral
      vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf
      cM wral va vj cv cdm wral vc cv cC wceq vf cv vc cv cfv va cv wceq va cv
      vj cv cfv vf cv vr cv co vf cv wceq wi vf cv cC cfv va cv wceq va cv vj
      cv cfv vf cv vr cv co vf cv wceq wi va vf vj cv cdm cM vc cv cC wceq vf
      cv vc cv cfv va cv wceq vf cv cC cfv va cv wceq va cv vj cv cfv vf cv vr
      cv co vf cv wceq vc cv cC wceq vf cv vc cv cfv vf cv cC cfv va cv vf cv
      vc cv cC fveq1 eqeq1d imbi1d 2ralbidv anbi1d anbi12d vj cv cJ wceq cD cC
      cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD
      cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv
      vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa cD cC
      cop cJ vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD
      cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv
      vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv
      cC cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral
      va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co
      vf cv wceq wi vf cM wral va vj cv cdm wral wa vf cv cC cfv va cv wceq va
      cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv
      va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi vf cM wral va cO
      wral wa vj cv cJ wceq cD cC cop vj cv vr cv cop cop cded wcel cD cC cop
      cJ vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf
      cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv
      co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral vj cv cJ wceq
      cD cC cop vj cv vr cv cop cop cD cC cop cJ vr cv cop cop cded vj cv cJ
      wceq vj cv vr cv cop cJ vr cv cop cD cC cop vj cv cJ vr cv opeq1 opeq2d
      eleq1d anbi1d vj cv cJ wceq vf cv cC cfv va cv wceq va cv vj cv cfv vf cv
      vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv cC cfv va cv
      wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf
      cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM
      wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv
      co vf cv wceq wi vf cM wral va cO wral vj cv cJ wceq vf cv cC cfv va cv
      wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral vf cv cC cfv
      va cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv
      cdm cO vj cv cJ wceq va cv vj cv cdm wcel va cv cO wcel vf cv cC cfv va
      cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral vf cv cC
      cfv va cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral vj cv
      cJ wceq vj cv cdm cO va cv vj cv cJ wceq vj cv cdm cJ cdm cO vj cv cJ
      dmeq iscat.2 syl6eqr eleq2d vj cv cJ wceq vf cv cC cfv va cv wceq va cv
      vj cv cfv vf cv vr cv co vf cv wceq wi vf cv cC cfv va cv wceq va cv cJ
      cfv vf cv vr cv co vf cv wceq wi vf cM vj cv cJ wceq va cv vj cv cfv vf
      cv vr cv co vf cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq vf cv cC
      cfv va cv wceq vj cv cJ wceq va cv vj cv cfv vf cv vr cv co va cv cJ cfv
      vf cv vr cv co vf cv vj cv cJ wceq va cv vj cv cfv va cv cJ cfv vf cv vr
      cv va cv vj cv cJ fveq1 opreq1d eqeq1d imbi2d ralbidv imbi12d ralbidv2 vj
      cv cJ wceq vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
      wceq wi vf cM wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf
      cv wceq wi vf cM wral va vj cv cdm cO vj cv cJ wceq va cv vj cv cdm wcel
      va cv cO wcel vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf
      cv wceq wi vf cM wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co
      vf cv wceq wi vf cM wral vj cv cJ wceq vj cv cdm cO va cv vj cv cJ wceq
      vj cv cdm cJ cdm cO vj cv cJ dmeq iscat.2 syl6eqr eleq2d vj cv cJ wceq vf
      cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cv
      cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi vf cM vj cv
      cJ wceq vf cv va cv vj cv cfv vr cv co vf cv wceq vf cv va cv cJ cfv vr
      cv co vf cv wceq vf cv cD cfv va cv wceq vj cv cJ wceq vf cv va cv vj cv
      cfv vr cv co vf cv va cv cJ cfv vr cv co vf cv vj cv cJ wceq va cv vj cv
      cfv va cv cJ cfv vf cv vr cv va cv vj cv cJ fveq1 opreq2d eqeq1d imbi2d
      ralbidv imbi12d ralbidv2 anbi12d anbi12d vr cv cR wceq cD cC cop cJ vr cv
      cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC
      cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf
      cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa cD cC cop cJ cR
      cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC
      cfv wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co
      wceq wi vh cM wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq va cv
      cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va
      cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi vf cM wral va cO wral
      wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi vf cM
      wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co vf cv
      wceq wi vf cM wral va cO wral wa vr cv cR wceq cD cC cop cJ vr cv cop cop
      cded wcel cD cC cop cJ cR cop cop cded wcel vh cv cD cfv vg cv cC cfv
      wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv
      co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf
      cM wral vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa
      vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq wi vh cM
      wral vg cM wral vf cM wral vr cv cR wceq cD cC cop cJ vr cv cop cop cD cC
      cop cJ cR cop cop cded vr cv cR wceq cJ vr cv cop cJ cR cop cD cC cop vr
      cv cR cJ opeq2 opeq2d eleq1d vr cv cR wceq vh cv cD cfv vg cv cC cfv wceq
      vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh
      cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vh cv cD cfv vg cv cC
      cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co cR co
      vh cv vg cv cR co vf cv cR co wceq wi vh cM wral vf vg cM cM vr cv cR
      wceq vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh
      cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq
      wi vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv
      vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq wi vh cM vr cv
      cR wceq vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr
      cv co wceq vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co
      wceq vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vr
      cv cR wceq vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vf cv cR co cR
      co vh cv vg cv vr cv co vf cv vr cv co vh cv vg cv cR co vf cv cR co vr
      cv cR wceq vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vf cv cR co vr
      cv co vh cv vg cv vf cv cR co cR co vr cv cR wceq vg cv vf cv vr cv co vg
      cv vf cv cR co vh cv vr cv vg cv vf cv vr cv cR opreq opreq2d vh cv vg cv
      vf cv cR co vr cv cR opreq eqtrd vr cv cR wceq vh cv vg cv vr cv co vf cv
      vr cv co vh cv vg cv vr cv co vf cv cR co vh cv vg cv cR co vf cv cR co
      vh cv vg cv vr cv co vf cv vr cv cR opreq vr cv cR wceq vh cv vg cv vr cv
      co vh cv vg cv cR co vf cv cR vh cv vg cv vr cv cR opreq opreq1d eqtrd
      eqeq12d imbi2d ralbidv 2ralbidv anbi12d vr cv cR wceq vf cv cC cfv va cv
      wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf
      cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi vf cM wral va
      cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi
      vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co vf
      cv wceq wi vf cM wral va cO wral vr cv cR wceq vf cv cC cfv va cv wceq va
      cv cJ cfv vf cv vr cv co vf cv wceq wi vf cv cC cfv va cv wceq va cv cJ
      cfv vf cv cR co vf cv wceq wi va vf cO cM vr cv cR wceq va cv cJ cfv vf
      cv vr cv co vf cv wceq va cv cJ cfv vf cv cR co vf cv wceq vf cv cC cfv
      va cv wceq vr cv cR wceq va cv cJ cfv vf cv vr cv co va cv cJ cfv vf cv
      cR co vf cv va cv cJ cfv vf cv vr cv cR opreq eqeq1d imbi2d 2ralbidv vr
      cv cR wceq vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq
      wi vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co vf cv wceq wi va vf
      cO cM vr cv cR wceq vf cv va cv cJ cfv vr cv co vf cv wceq vf cv va cv cJ
      cfv cR co vf cv wceq vf cv cD cfv va cv wceq vr cv cR wceq vf cv va cv cJ
      cfv vr cv co vf cv va cv cJ cfv cR co vf cv vf cv va cv cJ cfv vr cv cR
      opreq eqeq1d imbi2d 2ralbidv anbi12d anbi12d elo ccat vx cv vd cv vc cv
      cop vj cv vr cv cop cop wceq vd cv vc cv cop vj cv vr cv cop cop cded
      wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv
      wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr
      cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv cdm wral wa vf
      cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf
      vd cv cdm wral va vj cv cdm wral vf cv vd cv cfv va cv wceq vf cv va cv
      vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral wa
      wa wa vr wex vj wex vc wex vd wex vx cab cD cC cop cJ cR cop cop vx vf vg
      vh vj vr va vc vd df-cat eleq2i syl5bb $.
      $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  ${ $d C a c d f g h j r $.  $d D a c d f g h j r $.  $d J a c d f j r $.
     $d M c d j r f $.  $d O c d j r $.  $d R a c d f g h j r $.
     $d T c d j r x $.  $d a c d f g h j r x $.
     cati.1 $e |- D = ( dom_ ` T ) $.
     cati.2 $e |- C = ( cod_ ` T ) $.
     cati.3 $e |- J = ( id_ ` T ) $.
     cati.4 $e |- R = ( o_ ` T ) $.
     cati.5 $e |- M = dom D $.
     cati.6 $e |- O = dom J $.
     $( Definitional properties of a category. $)
     cati $p |- ( T e. Cat
       -> ( ( <. <. D , C >. , <. J , R >. >. e. Ded /\
           A. f e. M A. g e. M A. h e. M
              (
                ( ( D ` h ) = ( C ` g ) /\ ( D ` g ) = ( C ` f ) )
              ->
                ( h R ( g R f ) ) = ( ( h R g ) R f )
               ) ) /\

          ( A. a e. O A. f e. M ( ( C ` f ) = a ->
             ( ( J ` a ) R f ) = f ) /\

          A. a e. O A. f e. M ( ( D ` f ) = a ->
             ( f R ( J ` a ) ) = f ) ) ) ) $=
       cT ccat wcel cT vx cv vd cv vc cv cop vj cv vr cv cop cop wceq vd cv vc
       cv cop vj cv vr cv cop cop cded wcel vh cv vd cv cfv vg cv vc cv cfv
       wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co
       vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral
       vg vd cv cdm wral vf vd cv cdm wral wa vf cv vc cv cfv va cv wceq va cv
       vj cv cfv vf cv vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm
       wral vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq wi vf vd cv cdm wral va vj cv cdm wral wa wa wa vr wex vj wex vc
       wex vd wex vx cab wcel cD cC cop cJ cR cop cop cded wcel vh cv cD cfv vg
       cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co
       cR co vh cv vg cv cR co vf cv cR co wceq wi vh cM wral vg cM wral vf cM
       wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi
       vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co
       vf cv wceq wi vf cM wral va cO wral wa wa ccat vx cv vd cv vc cv cop vj
       cv vr cv cop cop wceq vd cv vc cv cop vj cv vr cv cop cop cded wcel vh
       cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq
       wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv
       co wceq wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv cdm wral wa vf
       cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf
       vd cv cdm wral va vj cv cdm wral vf cv vd cv cfv va cv wceq vf cv va cv
       vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral wa
       wa wa vr wex vj wex vc wex vd wex vx cab cT vx vf vg vh vj vr va vc vd
       df-cat eleq2i vd cv vc cv cop vj cv vr cv cop cop cded wcel vh cv vd cv
       cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv
       vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq
       wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv cdm wral wa vf cv vc cv
       cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf vd cv cdm
       wral va vj cv cdm wral vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv
       vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral wa wa cD vc
       cv cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv vc cv cfv wceq
       vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co
       vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM
       wral wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv
       wceq wi vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv
       vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa wa cD
       cC cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg
       cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
       vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral
       wa vf cv cC cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi
       vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv
       cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa wa cD cC cop
       cJ vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv
       vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr
       cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv
       cC cfv va cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral
       va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv
       wceq wi vf cM wral va cO wral wa wa cD cC cop cJ cR cop cop cded wcel vh
       cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg
       cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq wi vh cM wral vg
       cM wral vf cM wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co
       vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv va cv
       cJ cfv cR co vf cv wceq wi vf cM wral va cO wral wa wa vx vd vc vr vj cT
       vd cv cT c1st cfv c1st cfv wceq vd cv cD wceq vd cv vc cv cop vj cv vr
       cv cop cop cded wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv
       cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg
       cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral
       vf vd cv cdm wral wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr
       cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv vd cv cfv
       va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm
       wral va vj cv cdm wral wa wa cD vc cv cop vj cv vr cv cop cop cded wcel
       vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa
       vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co
       wceq wi vh cM wral vg cM wral vf cM wral wa vf cv vc cv cfv va cv wceq
       va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm
       wral vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq
       wi vf cM wral va vj cv cdm wral wa wa wb cT c1st cfv c1st cfv cD vd cv
       cD cT c1st cfv c1st cfv cD cT cati.1 domval eqcomi eqeq2i vd cv cD wceq
       vd cv vc cv cop vj cv vr cv cop cop cded wcel vh cv vd cv cfv vg cv vc
       cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr
       cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm
       wral vg vd cv cdm wral vf vd cv cdm wral wa cD vc cv cop vj cv vr cv cop
       cop cded wcel vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv
       cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf
       cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv vc cv cfv
       va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf vd cv cdm
       wral va vj cv cdm wral vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv
       vr cv co vf cv wceq wi vf vd cv cdm wral va vj cv cdm wral wa vf cv vc
       cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM
       wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr
       cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa vd cv cD wceq vd cv
       vc cv cop vj cv vr cv cop cop cded wcel cD vc cv cop vj cv vr cv cop cop
       cded wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc
       cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co
       vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm wral vf vd cv cdm
       wral vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq
       wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv
       co wceq wi vh cM wral vg cM wral vf cM wral vd cv cD wceq vd cv vc cv
       cop vj cv vr cv cop cop cD vc cv cop vj cv vr cv cop cop cded vd cv cD
       wceq vd cv vc cv cop cD vc cv cop vj cv vr cv cop vd cv cD vc cv opeq1
       opeq1d eleq1d vd cv cD wceq vh cv vd cv cfv vg cv vc cv cfv wceq vg cv
       vd cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh
       cv vg cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm
       wral vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq
       wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv
       co wceq wi vh cM wral vg cM wral vf vd cv cdm cM vd cv cD wceq vf cv vd
       cv cdm wcel vf cv cM wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd
       cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
       vg cv vr cv co vf cv vr cv co wceq wi vh vd cv cdm wral vg vd cv cdm
       wral vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq
       wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv
       co wceq wi vh cM wral vg cM wral vd cv cD wceq vd cv cdm cM vf cv vd cv
       cD wceq vd cv cdm cD cdm cM vd cv cD dmeq cati.5 syl6eqr eleq2d vd cv cD
       wceq vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv
       cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf
       cv vr cv co wceq wi vh vd cv cdm wral vh cv cD cfv vg cv vc cv cfv wceq
       vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co
       vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg vd cv cdm cM
       vd cv cD wceq vg cv vd cv cdm wcel vg cv cM wcel vh cv vd cv cfv vg cv
       vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv
       vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh vd cv
       cdm wral vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv
       wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv
       vr cv co wceq wi vh cM wral vd cv cD wceq vd cv cdm cM vg cv vd cv cD
       wceq vd cv cdm cD cdm cM vd cv cD dmeq cati.5 syl6eqr eleq2d vd cv cD
       wceq vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv
       cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf
       cv vr cv co wceq wi vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv
       vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv
       co vf cv vr cv co wceq wi vh vd cv cdm cM vd cv cD wceq vh cv vd cv cdm
       wcel vh cv cM wcel vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv
       vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv
       vr cv co vf cv vr cv co wceq wi vh cv cD cfv vg cv vc cv cfv wceq vg cv
       cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
       vg cv vr cv co vf cv vr cv co wceq wi vd cv cD wceq vd cv cdm cM vh cv
       vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq cati.5 syl6eqr eleq2d vd
       cv cD wceq vh cv vd cv cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc
       cv cfv wceq wa vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc
       cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co
       vf cv vr cv co wceq vd cv cD wceq vh cv vd cv cfv vg cv vc cv cfv wceq
       vh cv cD cfv vg cv vc cv cfv wceq vg cv vd cv cfv vf cv vc cv cfv wceq
       vg cv cD cfv vf cv vc cv cfv wceq vd cv cD wceq vh cv vd cv cfv vh cv cD
       cfv vg cv vc cv cfv vh cv vd cv cD fveq1 eqeq1d vd cv cD wceq vg cv vd
       cv cfv vg cv cD cfv vf cv vc cv cfv vg cv vd cv cD fveq1 eqeq1d anbi12d
       imbi1d imbi12d ralbidv2 imbi12d ralbidv2 imbi12d ralbidv2 anbi12d vd cv
       cD wceq vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv
       wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv vc cv cfv va cv wceq
       va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm
       wral vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq wi vf vd cv cdm wral va vj cv cdm wral vf cv cD cfv va cv wceq vf
       cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral
       vd cv cD wceq vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co
       vf cv wceq wi vf vd cv cdm wral vf cv vc cv cfv va cv wceq va cv vj cv
       cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm vd cv cD wceq
       vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi
       vf vd cv cdm cM vd cv cD wceq vd cv cdm cD cdm cM vd cv cD dmeq cati.5
       syl6eqr raleq1d ralbidv vd cv cD wceq vf cv vd cv cfv va cv wceq vf cv
       va cv vj cv cfv vr cv co vf cv wceq wi vf vd cv cdm wral vf cv cD cfv va
       cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv
       cdm vd cv cD wceq vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv
       co vf cv wceq wi vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co
       vf cv wceq wi vf vd cv cdm cM vd cv cD wceq vf cv vd cv cdm wcel vf cv
       cM wcel vf cv vd cv cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq wi vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq wi vd cv cD wceq vd cv cdm cM vf cv vd cv cD wceq vd cv cdm cD cdm
       cM vd cv cD dmeq cati.5 syl6eqr eleq2d vd cv cD wceq vf cv vd cv cfv va
       cv wceq vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq vd cv cD wceq vf cv vd cv cfv vf cv cD cfv va cv vf cv vd cv cD
       fveq1 eqeq1d imbi1d imbi12d ralbidv2 ralbidv anbi12d anbi12d sylbi vc cv
       cT c1st cfv c2nd cfv wceq vc cv cC wceq cD vc cv cop vj cv vr cv cop cop
       cded wcel vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv
       wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv
       vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv vc cv cfv va
       cv wceq va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv
       cdm wral vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq wi vf cM wral va vj cv cdm wral wa wa cD cC cop vj cv vr cv cop cop
       cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq
       wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv
       co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq
       va cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm
       wral vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq
       wi vf cM wral va vj cv cdm wral wa wa wb cT c1st cfv c2nd cfv cC vc cv
       cC cT c1st cfv c2nd cfv cC cT cati.2 codval eqcomi eqeq2i vc cv cC wceq
       cD vc cv cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv vc cv cfv
       wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr
       cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral
       vf cM wral wa cD cC cop vj cv vr cv cop cop cded wcel vh cv cD cfv vg cv
       cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co
       vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM
       wral vf cM wral wa vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr
       cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq
       vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm
       wral wa vf cv cC cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv
       wceq wi vf cM wral va vj cv cdm wral vf cv cD cfv va cv wceq vf cv va cv
       vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral wa vc cv
       cC wceq cD vc cv cop vj cv vr cv cop cop cded wcel cD cC cop vj cv vr cv
       cop cop cded wcel vh cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv
       vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv
       co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral vh cv cD cfv
       vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr
       cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral vg
       cM wral vf cM wral vc cv cC wceq cD vc cv cop vj cv vr cv cop cop cD cC
       cop vj cv vr cv cop cop cded vc cv cC wceq cD vc cv cop cD cC cop vj cv
       vr cv cop vc cv cC cD opeq2 opeq1d eleq1d vc cv cC wceq vh cv cD cfv vg
       cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv
       vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM wral
       vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv
       vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq
       wi vh cM wral vf vg cM cM vc cv cC wceq vh cv cD cfv vg cv vc cv cfv
       wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh cv vg cv vf cv vr cv co vr
       cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cv cD cfv vg cv cC
       cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr
       cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM vc cv cC wceq vh
       cv cD cfv vg cv vc cv cfv wceq vg cv cD cfv vf cv vc cv cfv wceq wa vh
       cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg
       cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq vc
       cv cC wceq vh cv cD cfv vg cv vc cv cfv wceq vh cv cD cfv vg cv cC cfv
       wceq vg cv cD cfv vf cv vc cv cfv wceq vg cv cD cfv vf cv cC cfv wceq vc
       cv cC wceq vg cv vc cv cfv vg cv cC cfv vh cv cD cfv vg cv vc cv cC
       fveq1 eqeq2d vc cv cC wceq vf cv vc cv cfv vf cv cC cfv vg cv cD cfv vf
       cv vc cv cC fveq1 eqeq2d anbi12d imbi1d ralbidv 2ralbidv anbi12d vc cv
       cC wceq vf cv vc cv cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf cv
       wceq wi vf cM wral va vj cv cdm wral vf cv cC cfv va cv wceq va cv vj cv
       cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv cD
       cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral
       va vj cv cdm wral vc cv cC wceq vf cv vc cv cfv va cv wceq va cv vj cv
       cfv vf cv vr cv co vf cv wceq wi vf cv cC cfv va cv wceq va cv vj cv cfv
       vf cv vr cv co vf cv wceq wi va vf vj cv cdm cM vc cv cC wceq vf cv vc
       cv cfv va cv wceq vf cv cC cfv va cv wceq va cv vj cv cfv vf cv vr cv co
       vf cv wceq vc cv cC wceq vf cv vc cv cfv vf cv cC cfv va cv vf cv vc cv
       cC fveq1 eqeq1d imbi1d 2ralbidv anbi1d anbi12d sylbi vj cv cT c2nd cfv
       c1st cfv wceq vj cv cJ wceq cD cC cop vj cv vr cv cop cop cded wcel vh
       cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg
       cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi
       vh cM wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq va cv vj cv
       cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv cD
       cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral
       va vj cv cdm wral wa wa cD cC cop cJ vr cv cop cop cded wcel vh cv cD
       cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf
       cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi vh cM
       wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv
       vr cv co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va cv wceq vf
       cv va cv cJ cfv vr cv co vf cv wceq wi vf cM wral va cO wral wa wa wb cT
       c2nd cfv c1st cfv cJ vj cv cJ cT c2nd cfv c1st cfv cT cJ cati.3 idval
       eqcomi eqeq2i vj cv cJ wceq cD cC cop vj cv vr cv cop cop cded wcel vh
       cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg
       cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi
       vh cM wral vg cM wral vf cM wral wa cD cC cop cJ vr cv cop cop cded wcel
       vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv
       vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq
       wi vh cM wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq va cv vj
       cv cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm wral vf cv
       cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM
       wral va vj cv cdm wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv vr
       cv co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv
       va cv cJ cfv vr cv co vf cv wceq wi vf cM wral va cO wral wa vj cv cJ
       wceq cD cC cop vj cv vr cv cop cop cded wcel cD cC cop cJ vr cv cop cop
       cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq
       wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv
       co wceq wi vh cM wral vg cM wral vf cM wral vj cv cJ wceq cD cC cop vj
       cv vr cv cop cop cD cC cop cJ vr cv cop cop cded vj cv cJ wceq vj cv vr
       cv cop cJ vr cv cop cD cC cop vj cv cJ vr cv opeq1 opeq2d eleq1d anbi1d
       vj cv cJ wceq vf cv cC cfv va cv wceq va cv vj cv cfv vf cv vr cv co vf
       cv wceq wi vf cM wral va vj cv cdm wral vf cv cC cfv va cv wceq va cv cJ
       cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va
       cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq wi vf cM wral va vj cv
       cdm wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq
       wi vf cM wral va cO wral vj cv cJ wceq vf cv cC cfv va cv wceq va cv vj
       cv cfv vf cv vr cv co vf cv wceq wi vf cM wral vf cv cC cfv va cv wceq
       va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va vj cv cdm cO vj
       cv cJ wceq va cv vj cv cdm wcel va cv cO wcel vf cv cC cfv va cv wceq va
       cv vj cv cfv vf cv vr cv co vf cv wceq wi vf cM wral vf cv cC cfv va cv
       wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral vj cv cJ wceq
       vj cv cdm cO va cv vj cv cJ wceq vj cv cdm cJ cdm cO vj cv cJ dmeq
       cati.6 syl6eqr eleq2d vj cv cJ wceq vf cv cC cfv va cv wceq va cv vj cv
       cfv vf cv vr cv co vf cv wceq wi vf cv cC cfv va cv wceq va cv cJ cfv vf
       cv vr cv co vf cv wceq wi vf cM vj cv cJ wceq va cv vj cv cfv vf cv vr
       cv co vf cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq vf cv cC cfv va
       cv wceq vj cv cJ wceq va cv vj cv cfv vf cv vr cv co va cv cJ cfv vf cv
       vr cv co vf cv vj cv cJ wceq va cv vj cv cfv va cv cJ cfv vf cv vr cv va
       cv vj cv cJ fveq1 opreq1d eqeq1d imbi2d ralbidv imbi12d ralbidv2 vj cv
       cJ wceq vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv
       wceq wi vf cM wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co
       vf cv wceq wi vf cM wral va vj cv cdm cO vj cv cJ wceq va cv vj cv cdm
       wcel va cv cO wcel vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv
       co vf cv wceq wi vf cM wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv
       vr cv co vf cv wceq wi vf cM wral vj cv cJ wceq vj cv cdm cO va cv vj cv
       cJ wceq vj cv cdm cJ cdm cO vj cv cJ dmeq cati.6 syl6eqr eleq2d vj cv cJ
       wceq vf cv cD cfv va cv wceq vf cv va cv vj cv cfv vr cv co vf cv wceq
       wi vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi vf
       cM vj cv cJ wceq vf cv va cv vj cv cfv vr cv co vf cv wceq vf cv va cv
       cJ cfv vr cv co vf cv wceq vf cv cD cfv va cv wceq vj cv cJ wceq vf cv
       va cv vj cv cfv vr cv co vf cv va cv cJ cfv vr cv co vf cv vj cv cJ wceq
       va cv vj cv cfv va cv cJ cfv vf cv vr cv va cv vj cv cJ fveq1 opreq2d
       eqeq1d imbi2d ralbidv imbi12d ralbidv2 anbi12d anbi12d sylbi vr cv cT
       c2nd cfv c2nd cfv wceq vr cv cR wceq cD cC cop cJ vr cv cop cop cded
       wcel vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh
       cv vg cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co
       wceq wi vh cM wral vg cM wral vf cM wral wa vf cv cC cfv va cv wceq va
       cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf cv cD
       cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi vf cM wral va
       cO wral wa wa cD cC cop cJ cR cop cop cded wcel vh cv cD cfv vg cv cC
       cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co cR co
       vh cv vg cv cR co vf cv cR co wceq wi vh cM wral vg cM wral vf cM wral
       wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi vf cM
       wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co vf cv
       wceq wi vf cM wral va cO wral wa wa wb cT c2nd cfv c2nd cfv cR vr cv cR
       cT c2nd cfv c2nd cfv cT cR cati.4 cmpval eqcomi eqeq2i vr cv cR wceq cD
       cC cop cJ vr cv cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv
       cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv vg
       cv vr cv co vf cv vr cv co wceq wi vh cM wral vg cM wral vf cM wral wa
       cD cC cop cJ cR cop cop cded wcel vh cv cD cfv vg cv cC cfv wceq vg cv
       cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR
       co vf cv cR co wceq wi vh cM wral vg cM wral vf cM wral wa vf cv cC cfv
       va cv wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO
       wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi
       vf cM wral va cO wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR
       co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv va
       cv cJ cfv cR co vf cv wceq wi vf cM wral va cO wral wa vr cv cR wceq cD
       cC cop cJ vr cv cop cop cded wcel cD cC cop cJ cR cop cop cded wcel vh
       cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg
       cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi
       vh cM wral vg cM wral vf cM wral vh cv cD cfv vg cv cC cfv wceq vg cv cD
       cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR co
       vf cv cR co wceq wi vh cM wral vg cM wral vf cM wral vr cv cR wceq cD cC
       cop cJ vr cv cop cop cD cC cop cJ cR cop cop cded vr cv cR wceq cJ vr cv
       cop cJ cR cop cD cC cop vr cv cR cJ opeq2 opeq2d eleq1d vr cv cR wceq vh
       cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg
       cv vf cv vr cv co vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq wi
       vh cM wral vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq
       wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq wi
       vh cM wral vf vg cM cM vr cv cR wceq vh cv cD cfv vg cv cC cfv wceq vg
       cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv vr cv co vr cv co vh cv
       vg cv vr cv co vf cv vr cv co wceq wi vh cv cD cfv vg cv cC cfv wceq vg
       cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv
       cR co vf cv cR co wceq wi vh cM vr cv cR wceq vh cv vg cv vf cv vr cv co
       vr cv co vh cv vg cv vr cv co vf cv vr cv co wceq vh cv vg cv vf cv cR
       co cR co vh cv vg cv cR co vf cv cR co wceq vh cv cD cfv vg cv cC cfv
       wceq vg cv cD cfv vf cv cC cfv wceq wa vr cv cR wceq vh cv vg cv vf cv
       vr cv co vr cv co vh cv vg cv vf cv cR co cR co vh cv vg cv vr cv co vf
       cv vr cv co vh cv vg cv cR co vf cv cR co vr cv cR wceq vh cv vg cv vf
       cv vr cv co vr cv co vh cv vg cv vf cv cR co vr cv co vh cv vg cv vf cv
       cR co cR co vr cv cR wceq vg cv vf cv vr cv co vg cv vf cv cR co vh cv
       vr cv vg cv vf cv vr cv cR opreq opreq2d vh cv vg cv vf cv cR co vr cv
       cR opreq eqtrd vr cv cR wceq vh cv vg cv vr cv co vf cv vr cv co vh cv
       vg cv cR co vf cv vr cv co vh cv vg cv cR co vf cv cR co vr cv cR wceq
       vh cv vg cv vr cv co vh cv vg cv cR co vf cv vr cv vh cv vg cv vr cv cR
       opreq opreq1d vh cv vg cv cR co vf cv vr cv cR opreq eqtrd eqeq12d
       imbi2d ralbidv 2ralbidv anbi12d vr cv cR wceq vf cv cC cfv va cv wceq va
       cv cJ cfv vf cv vr cv co vf cv wceq wi vf cM wral va cO wral vf cv cC
       cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi vf cM wral va cO
       wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv co vf cv wceq wi
       vf cM wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co
       vf cv wceq wi vf cM wral va cO wral vr cv cR wceq vf cv cC cfv va cv
       wceq va cv cJ cfv vf cv vr cv co vf cv wceq wi vf cv cC cfv va cv wceq
       va cv cJ cfv vf cv cR co vf cv wceq wi va vf cO cM vr cv cR wceq va cv
       cJ cfv vf cv vr cv co vf cv wceq va cv cJ cfv vf cv cR co vf cv wceq vf
       cv cC cfv va cv wceq vr cv cR wceq va cv cJ cfv vf cv vr cv co va cv cJ
       cfv vf cv cR co vf cv va cv cJ cfv vf cv vr cv cR opreq eqeq1d imbi2d
       2ralbidv vr cv cR wceq vf cv cD cfv va cv wceq vf cv va cv cJ cfv vr cv
       co vf cv wceq wi vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co vf cv
       wceq wi va vf cO cM vr cv cR wceq vf cv va cv cJ cfv vr cv co vf cv wceq
       vf cv va cv cJ cfv cR co vf cv wceq vf cv cD cfv va cv wceq vr cv cR
       wceq vf cv va cv cJ cfv vr cv co vf cv va cv cJ cfv cR co vf cv vf cv va
       cv cJ cfv vr cv cR opreq eqeq1d imbi2d 2ralbidv anbi12d anbi12d sylbi
       eloi sylbi $.
       $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  $( Lemma for ~ 0ded . $)
  0alg $p |- <. <. (/) , (/) >. , <. (/) , (/) >. >. e. Alg $=
    c0 c0 cop c0 c0 cop cop calg wcel c0 c0 c0 wf c0 c0 c0 wf c0 c0 c0 wf w3a
    c0 wfun c0 cdm c0 c0 cxp wss c0 crn c0 wss w3a c0 cvv wcel c0 cvv wcel c0
    cvv wcel w3a c0 cvv wcel c0 c0 cop c0 c0 cop cop calg wcel c0 c0 c0 wf c0
    c0 c0 wf c0 c0 c0 wf w3a c0 wfun c0 cdm c0 c0 cxp wss c0 crn c0 wss w3a wa
    wb c0 cvv wcel c0 cvv wcel c0 cvv wcel 0ex 0ex 0ex 3pm3.2i 0ex cvv cvv c0
    c0 c0 cvv cvv c0 c0 c0 c0 cdm c0 dm0 eqcomi c0 cdm c0 dm0 eqcomi isalg
    mp2an c0 c0 c0 wf c0 c0 c0 wf c0 c0 c0 wf c0 f0 c0 f0 c0 f0 3pm3.2i c0 wfun
    c0 cdm c0 c0 cxp wss c0 crn c0 wss fun0 c0 c0 c0 cdm c0 c0 cxp c0 ssid dm0
    c0 xp0r 3sstr4i c0 crn c0 rn0 eqimssi 3pm3.2i mpbir2an $.
    $( [10-Jan-2008] $) $( [10-Jan-2008] $)


  ${ $d a f g $.
  $( A deductive system with no object and no morphism. $)
  0ded $p |- <. <. (/) , (/) >. , <. (/) , (/) >. >. e. Ded $=
    c0 c0 cop c0 c0 cop cop cded wcel c0 c0 cop c0 c0 cop cop calg wcel va cv
    c0 cfv c0 cfv va cv wceq va cv c0 cfv c0 cfv va cv wceq wa va c0 cdm wral
    vg cv vf cv cop c0 cdm wcel vg cv c0 cfv vf cv c0 cfv wceq wb vg c0 cdm
    wral vf c0 cdm wral w3a vg cv c0 cfv vf cv c0 cfv wceq vg cv vf cv c0 co c0
    cfv vf cv c0 cfv wceq wi vg c0 cdm wral vf c0 cdm wral vg cv c0 cfv vf cv
    c0 cfv wceq vg cv vf cv c0 co c0 cfv vg cv c0 cfv wceq wi vg c0 cdm wral vf
    c0 cdm wral wa c0 cvv wcel c0 cvv wcel c0 cvv wcel w3a c0 cvv wcel c0 c0
    cop c0 c0 cop cop cded wcel c0 c0 cop c0 c0 cop cop calg wcel va cv c0 cfv
    c0 cfv va cv wceq va cv c0 cfv c0 cfv va cv wceq wa va c0 cdm wral vg cv vf
    cv cop c0 cdm wcel vg cv c0 cfv vf cv c0 cfv wceq wb vg c0 cdm wral vf c0
    cdm wral w3a vg cv c0 cfv vf cv c0 cfv wceq vg cv vf cv c0 co c0 cfv vf cv
    c0 cfv wceq wi vg c0 cdm wral vf c0 cdm wral vg cv c0 cfv vf cv c0 cfv wceq
    vg cv vf cv c0 co c0 cfv vg cv c0 cfv wceq wi vg c0 cdm wral vf c0 cdm wral
    wa wa wb c0 cvv wcel c0 cvv wcel c0 cvv wcel 0ex 0ex 0ex 3pm3.2i 0ex cvv
    cvv c0 c0 c0 vf vg cvv cvv c0 c0 cdm c0 cdm va c0 cdm eqid c0 cdm eqid
    isded mp2an c0 c0 cop c0 c0 cop cop calg wcel va cv c0 cfv c0 cfv va cv
    wceq va cv c0 cfv c0 cfv va cv wceq wa va c0 cdm wral vg cv vf cv cop c0
    cdm wcel vg cv c0 cfv vf cv c0 cfv wceq wb vg c0 cdm wral vf c0 cdm wral
    0alg va cv c0 cfv c0 cfv va cv wceq va cv c0 cfv c0 cfv va cv wceq wa va c0
    cdm va cv c0 cdm wcel va cv c0 wcel va cv c0 cfv c0 cfv va cv wceq va cv c0
    cfv c0 cfv va cv wceq wa c0 cdm c0 va cv dm0 eleq2i va cv c0 wcel va cv c0
    cfv c0 cfv va cv wceq va cv c0 cfv c0 cfv va cv wceq wa va cv noel pm2.21i
    sylbi rgen vg cv vf cv cop c0 cdm wcel vg cv c0 cfv vf cv c0 cfv wceq wb vg
    c0 cdm wral vf c0 cdm vf cv c0 cdm wcel vf cv c0 wcel vg cv vf cv cop c0
    cdm wcel vg cv c0 cfv vf cv c0 cfv wceq wb vg c0 cdm wral c0 cdm c0 vf cv
    dm0 eleq2i vf cv c0 wcel vg cv vf cv cop c0 cdm wcel vg cv c0 cfv vf cv c0
    cfv wceq wb vg c0 cdm wral vf cv noel pm2.21i sylbi rgen 3pm3.2i vg cv c0
    cfv vf cv c0 cfv wceq vg cv vf cv c0 co c0 cfv vf cv c0 cfv wceq wi vg c0
    cdm wral vf c0 cdm wral vg cv c0 cfv vf cv c0 cfv wceq vg cv vf cv c0 co c0
    cfv vg cv c0 cfv wceq wi vg c0 cdm wral vf c0 cdm wral vg cv c0 cfv vf cv
    c0 cfv wceq vg cv vf cv c0 co c0 cfv vf cv c0 cfv wceq wi vg c0 cdm wral vf
    c0 cdm vf cv c0 cdm wcel vf cv c0 wcel vg cv c0 cfv vf cv c0 cfv wceq vg cv
    vf cv c0 co c0 cfv vf cv c0 cfv wceq wi vg c0 cdm wral c0 cdm c0 vf cv dm0
    eleq2i vf cv c0 wcel vg cv c0 cfv vf cv c0 cfv wceq vg cv vf cv c0 co c0
    cfv vf cv c0 cfv wceq wi vg c0 cdm wral vf cv noel pm2.21i sylbi rgen vg cv
    c0 cfv vf cv c0 cfv wceq vg cv vf cv c0 co c0 cfv vg cv c0 cfv wceq wi vg
    c0 cdm wral vf c0 cdm vf cv c0 cdm wcel vf cv c0 wcel vg cv c0 cfv vf cv c0
    cfv wceq vg cv vf cv c0 co c0 cfv vg cv c0 cfv wceq wi vg c0 cdm wral c0
    cdm c0 vf cv dm0 eleq2i vf cv c0 wcel vg cv c0 cfv vf cv c0 cfv wceq vg cv
    vf cv c0 co c0 cfv vg cv c0 cfv wceq wi vg c0 cdm wral vf cv noel pm2.21i
    sylbi rgen pm3.2i mpbir2an $.
    $( [10-Jan-2008] $) $( [10-Jan-2008] $)
  $}

  ${ $d a f g h $.
  $( Category ` 0 ` has no object and no morphism. $)
  0cat $p |- <. <. (/) , (/) >. , <. (/) , (/) >. >. e. Cat $=
    c0 c0 cop c0 c0 cop cop ccat wcel c0 c0 cop c0 c0 cop cop cded wcel vh cv
    c0 cfv vg cv c0 cfv wceq vg cv c0 cfv vf cv c0 cfv wceq wa vh cv vg cv vf
    cv c0 co c0 co vh cv vg cv c0 co vf cv c0 co wceq wi vh c0 cdm wral vg c0
    cdm wral vf c0 cdm wral wa vf cv c0 cfv va cv wceq va cv c0 cfv vf cv c0 co
    vf cv wceq wi vf c0 cdm wral va c0 cdm wral vf cv c0 cfv va cv wceq vf cv
    va cv c0 cfv c0 co vf cv wceq wi vf c0 cdm wral va c0 cdm wral wa c0 cvv
    wcel c0 cvv wcel c0 cvv wcel w3a c0 cvv wcel c0 c0 cop c0 c0 cop cop ccat
    wcel c0 c0 cop c0 c0 cop cop cded wcel vh cv c0 cfv vg cv c0 cfv wceq vg cv
    c0 cfv vf cv c0 cfv wceq wa vh cv vg cv vf cv c0 co c0 co vh cv vg cv c0 co
    vf cv c0 co wceq wi vh c0 cdm wral vg c0 cdm wral vf c0 cdm wral wa vf cv
    c0 cfv va cv wceq va cv c0 cfv vf cv c0 co vf cv wceq wi vf c0 cdm wral va
    c0 cdm wral vf cv c0 cfv va cv wceq vf cv va cv c0 cfv c0 co vf cv wceq wi
    vf c0 cdm wral va c0 cdm wral wa wa wb c0 cvv wcel c0 cvv wcel c0 cvv wcel
    0ex 0ex 0ex 3pm3.2i 0ex cvv cvv c0 c0 c0 vf vg vh cvv cvv c0 c0 cdm c0 cdm
    va c0 cdm eqid c0 cdm eqid iscat mp2an c0 c0 cop c0 c0 cop cop cded wcel vh
    cv c0 cfv vg cv c0 cfv wceq vg cv c0 cfv vf cv c0 cfv wceq wa vh cv vg cv
    vf cv c0 co c0 co vh cv vg cv c0 co vf cv c0 co wceq wi vh c0 cdm wral vg
    c0 cdm wral vf c0 cdm wral 0ded vh cv c0 cfv vg cv c0 cfv wceq vg cv c0 cfv
    vf cv c0 cfv wceq wa vh cv vg cv vf cv c0 co c0 co vh cv vg cv c0 co vf cv
    c0 co wceq wi vh c0 cdm wral vg c0 cdm wral vf c0 cdm vf cv c0 cdm wcel vf
    cv c0 wcel vh cv c0 cfv vg cv c0 cfv wceq vg cv c0 cfv vf cv c0 cfv wceq wa
    vh cv vg cv vf cv c0 co c0 co vh cv vg cv c0 co vf cv c0 co wceq wi vh c0
    cdm wral vg c0 cdm wral c0 cdm c0 vf cv dm0 eleq2i vf cv c0 wcel vh cv c0
    cfv vg cv c0 cfv wceq vg cv c0 cfv vf cv c0 cfv wceq wa vh cv vg cv vf cv
    c0 co c0 co vh cv vg cv c0 co vf cv c0 co wceq wi vh c0 cdm wral vg c0 cdm
    wral vf cv noel pm2.21i sylbi rgen pm3.2i vf cv c0 cfv va cv wceq va cv c0
    cfv vf cv c0 co vf cv wceq wi vf c0 cdm wral va c0 cdm wral vf cv c0 cfv va
    cv wceq vf cv va cv c0 cfv c0 co vf cv wceq wi vf c0 cdm wral va c0 cdm
    wral vf cv c0 cfv va cv wceq va cv c0 cfv vf cv c0 co vf cv wceq wi vf c0
    cdm wral va c0 cdm va cv c0 cdm wcel va cv c0 wcel vf cv c0 cfv va cv wceq
    va cv c0 cfv vf cv c0 co vf cv wceq wi vf c0 cdm wral c0 cdm c0 va cv dm0
    eleq2i va cv c0 wcel vf cv c0 cfv va cv wceq va cv c0 cfv vf cv c0 co vf cv
    wceq wi vf c0 cdm wral va cv noel pm2.21i sylbi rgen vf cv c0 cfv va cv
    wceq vf cv va cv c0 cfv c0 co vf cv wceq wi vf c0 cdm wral va c0 cdm va cv
    c0 cdm wcel va cv c0 wcel vf cv c0 cfv va cv wceq vf cv va cv c0 cfv c0 co
    vf cv wceq wi vf c0 cdm wral c0 cdm c0 va cv dm0 eleq2i va cv c0 wcel vf cv
    c0 cfv va cv wceq vf cv va cv c0 cfv c0 co vf cv wceq wi vf c0 cdm wral va
    cv noel pm2.21i sylbi rgen pm3.2i mpbir2an $.
    $( [10-Jan-2008] $) $( [10-Jan-2008] $)
  $}


  ${ $d A u x y z $.
    1cat.1 $e |- A e. _V $.
    $( Category ` 1 ` has one object and one morphism. $)
    1cat $p |- <. <. { <. <. A , A >. , A >. } ,
     { <. <. A , A >. , A >. } >. ,  <. { <. A , <. A , A >. >. } ,
     { <. <. <. A , A >. , <. A , A >. >. , <. A , A >. >. } >. >.
     e. Cat $=
      cA cA cop cA cop csn cA cA cop cA cop csn cop cA cA cA cop cop csn cA cA
      cop cA cA cop cop cA cA cop cop csn cop cop ccat wcel cA cA cop cA cop
      csn cA cA cop cA cop csn cop cA cA cA cop cop csn cA cA cop cA cA cop cop
      cA cA cop cop csn cop cop cded wcel vu cv cA cA cop cA cop csn cfv vz cv
      cA cA cop cA cop csn cfv wceq vz cv cA cA cop cA cop csn cfv vy cv cA cA
      cop cA cop csn cfv wceq wa vu cv vz cv vy cv cA cA cop cA cA cop cop cA
      cA cop cop csn co cA cA cop cA cA cop cop cA cA cop cop csn co vu cv vz
      cv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv cA cA cop cA cA cop
      cop cA cA cop cop csn co wceq wi vu cA cA cop csn wral vz cA cA cop csn
      wral vy cA cA cop csn wral wa vy cv cA cA cop cA cop csn cfv vx cv wceq
      vx cv cA cA cA cop cop csn cfv vy cv cA cA cop cA cA cop cop cA cA cop
      cop csn co vy cv wceq wi vy cA cA cop csn wral vx cA csn wral vy cv cA cA
      cop cA cop csn cfv vx cv wceq vy cv vx cv cA cA cA cop cop csn cfv cA cA
      cop cA cA cop cop cA cA cop cop csn co vy cv wceq wi vy cA cA cop csn
      wral vx cA csn wral wa cA cA cop cA cop csn cvv wcel cA cA cop cA cop csn
      cvv wcel cA cA cA cop cop csn cvv wcel w3a cA cA cop cA cA cop cop cA cA
      cop cop csn cvv wcel cA cA cop cA cop csn cA cA cop cA cop csn cop cA cA
      cA cop cop csn cA cA cop cA cA cop cop cA cA cop cop csn cop cop ccat
      wcel cA cA cop cA cop csn cA cA cop cA cop csn cop cA cA cA cop cop csn
      cA cA cop cA cA cop cop cA cA cop cop csn cop cop cded wcel vu cv cA cA
      cop cA cop csn cfv vz cv cA cA cop cA cop csn cfv wceq vz cv cA cA cop cA
      cop csn cfv vy cv cA cA cop cA cop csn cfv wceq wa vu cv vz cv vy cv cA
      cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA
      cop cop csn co vu cv vz cv cA cA cop cA cA cop cop cA cA cop cop csn co
      vy cv cA cA cop cA cA cop cop cA cA cop cop csn co wceq wi vu cA cA cop
      csn wral vz cA cA cop csn wral vy cA cA cop csn wral wa vy cv cA cA cop
      cA cop csn cfv vx cv wceq vx cv cA cA cA cop cop csn cfv vy cv cA cA cop
      cA cA cop cop cA cA cop cop csn co vy cv wceq wi vy cA cA cop csn wral vx
      cA csn wral vy cv cA cA cop cA cop csn cfv vx cv wceq vy cv vx cv cA cA
      cA cop cop csn cfv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv
      wceq wi vy cA cA cop csn wral vx cA csn wral wa wa wb cA cA cop cA cop
      csn cvv wcel cA cA cop cA cop csn cvv wcel cA cA cA cop cop csn cvv wcel
      cA cA cop cA cop snex cA cA cop cA cop snex cA cA cA cop cop snex 3pm3.2i
      cA cA cop cA cA cop cop cA cA cop cop snex cvv cvv cA cA cop cA cop csn
      cA cA cop cA cop csn cA cA cop cA cA cop cop cA cA cop cop csn vy vz vu
      cvv cvv cA cA cA cop cop csn cA cA cop csn cA csn vx cA cA cop cA cop csn
      cdm cA cA cop csn cA cA cop cA dmsnop eqcomi cA cA cA cop cop csn cdm cA
      csn cA cA cA cop dmsnop eqcomi iscat mp2an cA cA cop cA cop csn cA cA cop
      cA cop csn cop cA cA cA cop cop csn cA cA cop cA cA cop cop cA cA cop cop
      csn cop cop cded wcel vu cv cA cA cop cA cop csn cfv vz cv cA cA cop cA
      cop csn cfv wceq vz cv cA cA cop cA cop csn cfv vy cv cA cA cop cA cop
      csn cfv wceq wa vu cv vz cv vy cv cA cA cop cA cA cop cop cA cA cop cop
      csn co cA cA cop cA cA cop cop cA cA cop cop csn co vu cv vz cv cA cA cop
      cA cA cop cop cA cA cop cop csn co vy cv cA cA cop cA cA cop cop cA cA
      cop cop csn co wceq wi vu cA cA cop csn wral vz cA cA cop csn wral vy cA
      cA cop csn wral cA 1cat.1 1ded vu cv cA cA cop cA cop csn cfv vz cv cA cA
      cop cA cop csn cfv wceq vz cv cA cA cop cA cop csn cfv vy cv cA cA cop cA
      cop csn cfv wceq wa vu cv vz cv vy cv cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cop cA cA cop cop csn co vu cv vz cv cA cA
      cop cA cA cop cop cA cA cop cop csn co vy cv cA cA cop cA cA cop cop cA
      cA cop cop csn co wceq wi vy vz vu cA cA cop csn cA cA cop csn cA cA cop
      csn vy cv cA cA cop wceq vz cv cA cA cop wceq vu cv cA cA cop wceq vu cv
      cA cA cop cA cop csn cfv vz cv cA cA cop cA cop csn cfv wceq vz cv cA cA
      cop cA cop csn cfv vy cv cA cA cop cA cop csn cfv wceq wa vu cv vz cv vy
      cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cop
      cA cA cop cop csn co vu cv vz cv cA cA cop cA cA cop cop cA cA cop cop
      csn co vy cv cA cA cop cA cA cop cop cA cA cop cop csn co wceq wi vy cv
      cA cA cop csn wcel vz cv cA cA cop csn wcel vu cv cA cA cop csn wcel vy
      cv cA cA cop wceq vz cv cA cA cop wceq vu cv cA cA cop wceq w3a cA cA cop
      cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA
      cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cA cA cop cA
      cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cA cA cop cop cA cA
      cop cop csn co wceq vu cv vz cv vy cv cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cop cA cA cop cop csn co vu cv vz cv cA cA
      cop cA cA cop cop cA cA cop cop csn co vy cv cA cA cop cA cA cop cop cA
      cA cop cop csn co wceq vu cv cA cA cop cA cop csn cfv vz cv cA cA cop cA
      cop csn cfv wceq vz cv cA cA cop cA cop csn cfv vy cv cA cA cop cA cop
      csn cfv wceq wa vy cv cA cA cop wceq vz cv cA cA cop wceq vu cv cA cA cop
      wceq w3a cA cA cop cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cop cA cA cop cop csn co vu cv vz cv vy cv
      cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cop cA
      cA cop cop csn co cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co vu cv
      vz cv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv cA cA cop cA cA
      cop cop cA cA cop cop csn co vy cv cA cA cop wceq vz cv cA cA cop wceq vu
      cv cA cA cop wceq w3a cA cA cop vu cv cA cA cop cA cA cop cA cA cop cA cA
      cop cop cA cA cop cop csn co vz cv vy cv cA cA cop cA cA cop cop cA cA
      cop cop csn co cA cA cop cA cA cop cop cA cA cop cop csn vu cv cA cA cop
      wceq vy cv cA cA cop wceq cA cA cop vu cv wceq vz cv cA cA cop wceq vu cv
      cA cA cop wceq vu cv cA cA cop vu cv cA cA cop wceq id eqcomd 3ad2ant3 vy
      cv cA cA cop wceq vz cv cA cA cop wceq vu cv cA cA cop wceq w3a cA cA cop
      vz cv cA cA cop vy cv cA cA cop cA cA cop cop cA cA cop cop csn vz cv cA
      cA cop wceq vy cv cA cA cop wceq cA cA cop vz cv wceq vu cv cA cA cop
      wceq vz cv cA cA cop wceq vz cv cA cA cop vz cv cA cA cop wceq id eqcomd
      3ad2ant2 vy cv cA cA cop wceq vz cv cA cA cop wceq cA cA cop vy cv wceq
      vu cv cA cA cop wceq vy cv cA cA cop wceq vy cv cA cA cop vy cv cA cA cop
      wceq id eqcomd 3ad2ant1 opreq12d opreq12d vy cv cA cA cop wceq vz cv cA
      cA cop wceq vu cv cA cA cop wceq w3a cA cA cop cA cA cop cA cA cop cA cA
      cop cop cA cA cop cop csn co cA cA cop cA cA cop cA cA cop cop cA cA cop
      cop csn co vu cv cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co
      cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co vu cv vz cv cA cA
      cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cA cA cop cop
      cA cA cop cop csn co vu cv vz cv cA cA cop cA cA cop cop cA cA cop cop
      csn co vy cv cA cA cop cA cA cop cop cA cA cop cop csn co vu cv cA cA cop
      wceq vy cv cA cA cop wceq cA cA cop cA cA cop cA cA cop cA cA cop cop cA
      cA cop cop csn co cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co
      vu cv cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA
      cA cop cA cA cop cop cA cA cop cop csn co wceq vz cv cA cA cop wceq vu cv
      cA cA cop wceq cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop
      csn co vu cv cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA
      cop cA cA cop cA cA cop cop cA cA cop cop csn vu cv cA cA cop wceq cA cA
      cop vu cv cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn vu cv cA cA
      cop wceq vu cv cA cA cop vu cv cA cA cop wceq id eqcomd opreq1d opreq1d
      3ad2ant3 vz cv cA cA cop wceq vy cv cA cA cop wceq vu cv cA cA cop cA cA
      cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cA cA cop cop
      cA cA cop cop csn co vu cv vz cv cA cA cop cA cA cop cop cA cA cop cop
      csn co cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co wceq vu cv
      cA cA cop wceq vz cv cA cA cop wceq vu cv cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn co vu cv vz cv cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn vz cv cA
      cA cop wceq cA cA cop vz cv vu cv cA cA cop cA cA cop cop cA cA cop cop
      csn vz cv cA cA cop wceq vz cv cA cA cop vz cv cA cA cop wceq id eqcomd
      opreq2d opreq1d 3ad2ant2 vy cv cA cA cop wceq vz cv cA cA cop wceq vu cv
      vz cv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cA
      cA cop cop cA cA cop cop csn co vu cv vz cv cA cA cop cA cA cop cop cA cA
      cop cop csn co vy cv cA cA cop cA cA cop cop cA cA cop cop csn co wceq vu
      cv cA cA cop wceq vy cv cA cA cop wceq cA cA cop vy cv vu cv vz cv cA cA
      cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA cop
      cop csn vy cv cA cA cop wceq vy cv cA cA cop vy cv cA cA cop wceq id
      eqcomd opreq2d 3ad2ant1 3eqtrd eqeq12d cA cA cop cA cA cop cA cA cop cA
      cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA
      cop cop csn co cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop
      csn co cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co wceq vu cv
      cA cA cop cA cop csn cfv vz cv cA cA cop cA cop csn cfv wceq vz cv cA cA
      cop cA cop csn cfv vy cv cA cA cop cA cop csn cfv wceq wa cA cA cop cA cA
      cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA
      cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop
      cA cA cop cop cA cA cop cop csn cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA cop cA cA cop cop
      cA cA cop cop csn cfv cA cA cop cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn df-opr cA cA cop cA cA cop cop cA cA cop cA cA cop
      cA cA cop opex cA cA opex fvsn eqtr2i cA cA cop cA cA cop cA cA cop cA cA
      cop cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA cop cA cA cop
      cop cA cA cop cop csn cfv cA cA cop cA cA cop cA cA cop cA cA cop cA cA
      cop cop cA cA cop cop csn df-opr cA cA cop cA cA cop cop cA cA cop cA cA
      cop cA cA cop opex cA cA opex fvsn eqtri opreq12i a1i syl5bi vy cv cA cA
      cop elsni vz cv cA cA cop elsni vu cv cA cA cop elsni syl3an rgen3 pm3.2i
      vy cv cA cA cop cA cop csn cfv vx cv wceq vx cv cA cA cA cop cop csn cfv
      vy cv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv wceq wi vy cA cA
      cop csn wral vx cA csn wral vy cv cA cA cop cA cop csn cfv vx cv wceq vy
      cv vx cv cA cA cA cop cop csn cfv cA cA cop cA cA cop cop cA cA cop cop
      csn co vy cv wceq wi vy cA cA cop csn wral vx cA csn wral vy cv cA cA cop
      cA cop csn cfv vx cv wceq vx cv cA cA cA cop cop csn cfv vy cv cA cA cop
      cA cA cop cop cA cA cop cop csn co vy cv wceq wi vx vy cA csn cA cA cop
      csn vx cv cA wceq vy cv cA cA cop wceq vy cv cA cA cop cA cop csn cfv vx
      cv wceq vx cv cA cA cA cop cop csn cfv vy cv cA cA cop cA cA cop cop cA
      cA cop cop csn co vy cv wceq wi vx cv cA csn wcel vy cv cA cA cop csn
      wcel vx cv cA wceq vy cv cA cA cop wceq wa cA cA cA cA cop cop csn cfv cA
      cA cop cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop wceq vx cv
      cA cA cA cop cop csn cfv vy cv cA cA cop cA cA cop cop cA cA cop cop csn
      co vy cv wceq vy cv cA cA cop cA cop csn cfv vx cv wceq vx cv cA wceq vy
      cv cA cA cop wceq wa cA cA cA cA cop cop csn cfv cA cA cop cA cA cop cA
      cA cop cop cA cA cop cop csn co vx cv cA cA cA cop cop csn cfv vy cv cA
      cA cop cA cA cop cop cA cA cop cop csn co cA cA cop vy cv vx cv cA wceq
      vy cv cA cA cop wceq wa cA cA cA cA cop cop csn cfv vx cv cA cA cA cop
      cop csn cfv cA cA cop vy cv cA cA cop cA cA cop cop cA cA cop cop csn vx
      cv cA wceq vy cv cA cA cop wceq wa cA vx cv cA cA cA cop cop csn vx cv cA
      wceq cA vx cv wceq vy cv cA cA cop wceq vx cv cA wceq vx cv cA vx cv cA
      wceq id eqcomd adantr fveq2d vy cv cA cA cop wceq cA cA cop vy cv wceq vx
      cv cA wceq vy cv cA cA cop wceq vy cv cA cA cop vy cv cA cA cop wceq id
      eqcomd adantl opreq12d vy cv cA cA cop wceq cA cA cop vy cv wceq vx cv cA
      wceq vy cv cA cA cop wceq vy cv cA cA cop vy cv cA cA cop wceq id eqcomd
      adantl eqeq12d cA cA cA cA cop cop csn cfv cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn co cA cA cop wceq vy cv cA cA cop cA cop csn cfv vx
      cv wceq cA cA cA cA cop cop csn cfv cA cA cop cA cA cop cA cA cop cop cA
      cA cop cop csn co cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop
      cop csn co cA cA cop cA cA cop cop cA cA cop cA cA cop cop cA cA cop cop
      csn cfv cA cA cop cA cA cA cA cop cop csn cfv cA cA cop cA cA cop cA cA
      cop cA cA cop cop cA cA cop cop csn cA cA cA cop 1cat.1 cA cA opex fvsn
      opreq1i cA cA cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn
      df-opr cA cA cop cA cA cop cop cA cA cop cA cA cop cA cA cop opex cA cA
      opex fvsn 3eqtri a1i syl5bi vx cv cA elsni vy cv cA cA cop elsni syl2an
      rgen2 vy cv cA cA cop cA cop csn cfv vx cv wceq vy cv vx cv cA cA cA cop
      cop csn cfv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv wceq wi vx
      vy cA csn cA cA cop csn vx cv cA wceq vy cv cA cA cop wceq vy cv cA cA
      cop cA cop csn cfv vx cv wceq vy cv vx cv cA cA cA cop cop csn cfv cA cA
      cop cA cA cop cop cA cA cop cop csn co vy cv wceq wi vx cv cA csn wcel vy
      cv cA cA cop csn wcel vx cv cA wceq vy cv cA cA cop wceq wa cA cA cop cA
      cA cA cA cop cop csn cfv cA cA cop cA cA cop cop cA cA cop cop csn co cA
      cA cop wceq vy cv vx cv cA cA cA cop cop csn cfv cA cA cop cA cA cop cop
      cA cA cop cop csn co vy cv wceq vy cv cA cA cop cA cop csn cfv vx cv wceq
      vx cv cA wceq vy cv cA cA cop wceq wa cA cA cop cA cA cA cA cop cop csn
      cfv cA cA cop cA cA cop cop cA cA cop cop csn co vy cv vx cv cA cA cA cop
      cop csn cfv cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop vy cv
      vx cv cA wceq vy cv cA cA cop wceq wa cA cA cop vy cv cA cA cA cA cop cop
      csn cfv vx cv cA cA cA cop cop csn cfv cA cA cop cA cA cop cop cA cA cop
      cop csn vy cv cA cA cop wceq cA cA cop vy cv wceq vx cv cA wceq vy cv cA
      cA cop wceq vy cv cA cA cop vy cv cA cA cop wceq id eqcomd adantl vx cv
      cA wceq vy cv cA cA cop wceq wa cA vx cv cA cA cA cop cop csn vx cv cA
      wceq cA vx cv wceq vy cv cA cA cop wceq vx cv cA wceq vx cv cA vx cv cA
      wceq id eqcomd adantr fveq2d opreq12d vy cv cA cA cop wceq cA cA cop vy
      cv wceq vx cv cA wceq vy cv cA cA cop wceq vy cv cA cA cop vy cv cA cA
      cop wceq id eqcomd adantl eqeq12d cA cA cop cA cA cA cA cop cop csn cfv
      cA cA cop cA cA cop cop cA cA cop cop csn co cA cA cop wceq vy cv cA cA
      cop cA cop csn cfv vx cv wceq cA cA cop cA cA cA cA cop cop csn cfv cA cA
      cop cA cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cA cA cop cA
      cA cop cop cA cA cop cop csn co cA cA cop cA cA cop cop cA cA cop cA cA
      cop cop cA cA cop cop csn cfv cA cA cop cA cA cA cA cop cop csn cfv cA cA
      cop cA cA cop cA cA cop cA cA cop cop cA cA cop cop csn cA cA cA cop
      1cat.1 cA cA opex fvsn opreq2i cA cA cop cA cA cop cA cA cop cA cA cop
      cop cA cA cop cop csn df-opr cA cA cop cA cA cop cop cA cA cop cA cA cop
      cA cA cop opex cA cA opex fvsn 3eqtri a1i syl5bi vx cv cA elsni vy cv cA
      cA cop elsni syl2an rgen2 pm3.2i mpbir2an $.
      $( [31-Oct-2007] $) $( [30-Oct-2007] $)
  $}

  ${
  $d f g t u v w x y z $.
  $( Structure of a category. $)
  strcat $p |- Cat C_ ( ( _V X. _V ) X. ( _V X. _V ) ) $=
    ccat vx cv vg cv vf cv cop vv cv vu cv cop cop wceq vg cv vf cv cop vv cv
    vu cv cop cop cded wcel vw cv vg cv cfv vz cv vf cv cfv wceq vz cv vg cv
    cfv vy cv vf cv cfv wceq wa vw cv vz cv vy cv vu cv co vu cv co vw cv vz cv
    vu cv co vy cv vu cv co wceq wi vw vg cv cdm wral vz vg cv cdm wral vy vg
    cv cdm wral wa vy cv vf cv cfv vt cv wceq vt cv vv cv cfv vy cv vu cv co vy
    cv wceq wi vy vg cv cdm wral vt vv cv cdm wral vy cv vg cv cfv vt cv wceq
    vy cv vt cv vv cv cfv vu cv co vy cv wceq wi vy vg cv cdm wral vt vv cv cdm
    wral wa wa wa vu wex vv wex vf wex vg wex vx cab cvv cvv cxp cvv cvv cxp
    cxp vx vy vz vw vv vu vt vf vg df-cat vg cv vf cv cop vv cv vu cv cop cop
    cded wcel vw cv vg cv cfv vz cv vf cv cfv wceq vz cv vg cv cfv vy cv vf cv
    cfv wceq wa vw cv vz cv vy cv vu cv co vu cv co vw cv vz cv vu cv co vy cv
    vu cv co wceq wi vw vg cv cdm wral vz vg cv cdm wral vy vg cv cdm wral wa
    vy cv vf cv cfv vt cv wceq vt cv vv cv cfv vy cv vu cv co vy cv wceq wi vy
    vg cv cdm wral vt vv cv cdm wral vy cv vg cv cfv vt cv wceq vy cv vt cv vv
    cv cfv vu cv co vy cv wceq wi vy vg cv cdm wral vt vv cv cdm wral wa wa vx
    vg vf vu vv stcat eqsstri $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)
  $}

  $( A category is a relation. $)
  relcat $p |- Rel Cat $=
    ccat wrel ccat cvv cvv cxp wss ccat cvv cvv cxp cvv cvv cxp cxp cvv cvv cxp
    strcat cvv cvv cxp cvv cvv cxp xpss sstri ccat df-rel mpbir $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)

  $( The domain of a category is a relation. $)
  reldcat $p |- Rel dom Cat $=
    ccat cdm wrel ccat cdm cvv cvv cxp wss ccat cdm cvv cvv cxp cvv cvv cxp cxp
    cdm cvv cvv cxp ccat cvv cvv cxp cvv cvv cxp cxp wss ccat cdm cvv cvv cxp
    cvv cvv cxp cxp cdm wss strcat ccat cvv cvv cxp cvv cvv cxp cxp dmss ax-mp
    cvv cvv cxp dmxpid sseqtri ccat cdm df-rel mpbir $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)

  $( The range of a category is a relation. $)
  relrcat $p |- Rel ran Cat $=
    ccat crn wrel ccat crn cvv cvv cxp wss ccat crn cvv cvv cxp cvv cvv cxp cxp
    crn cvv cvv cxp ccat cvv cvv cxp cvv cvv cxp cxp wss ccat crn cvv cvv cxp
    cvv cvv cxp cxp crn wss strcat ccat cvv cvv cxp cvv cvv cxp cxp rnss ax-mp
    cvv cvv cxp c0 wne cvv cvv cxp cvv cvv cxp cxp crn cvv cvv cxp wceq cvv c0
    wne cvv c0 wne wa cvv cvv cxp c0 wne cvv c0 wne cvv c0 wne vn0 vn0 pm3.2i
    cvv cvv xpnz mpbi cvv cvv cxp cvv cvv cxp rnxp ax-mp sseqtri ccat crn
    df-rel mpbir $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)

  ${
  $d T w x y z $.
  $( A category is a deductive system. $)
  catded $p |- ( T e. Cat -> T e. Ded ) $=
    cT ccat wcel cT cT cdom_ cfv cT ccod_ cfv cop cT cid_ cfv cT co_ cfv cop
    cop cded cT ccat wcel cT cT c1st cfv c1st cfv cT c1st cfv c2nd cfv cop cT
    c2nd cfv c1st cfv cT c2nd cfv c2nd cfv cop cop cT cdom_ cfv cT ccod_ cfv
    cop cT cid_ cfv cT co_ cfv cop cop ccat wrel ccat cdm wrel ccat crn wrel
    w3a cT ccat wcel cT cT c1st cfv c1st cfv cT c1st cfv c2nd cfv cop cT c2nd
    cfv c1st cfv cT c2nd cfv c2nd cfv cop cop wceq ccat wrel ccat cdm wrel ccat
    crn wrel relcat reldcat relrcat 3pm3.2i cT ccat 11st22nd mpan cT cdom_ cfv
    cT ccod_ cfv cop cT c1st cfv c1st cfv cT c1st cfv c2nd cfv cop cT cid_ cfv
    cT co_ cfv cop cT c2nd cfv c1st cfv cT c2nd cfv c2nd cfv cop cT cdom_ cfv
    cT c1st cfv c1st cfv cT ccod_ cfv cT c1st cfv c2nd cfv cT cdom_ cfv cT cT
    cdom_ cfv eqid domval cT ccod_ cfv cT cT ccod_ cfv eqid codval opeq12i cT
    cid_ cfv cT c2nd cfv c1st cfv cT co_ cfv cT c2nd cfv c2nd cfv cT cT cid_
    cfv cT cid_ cfv eqid idval cT cT co_ cfv cT co_ cfv eqid cmpval opeq12i
    opeq12i syl6eqr cT ccat wcel cT cdom_ cfv cT ccod_ cfv cop cT cid_ cfv cT
    co_ cfv cop cop cded wcel vz cv cT cdom_ cfv cfv vy cv cT ccod_ cfv cfv
    wceq vy cv cT cdom_ cfv cfv vx cv cT ccod_ cfv cfv wceq wa vz cv vy cv vx
    cv cT co_ cfv co cT co_ cfv co vz cv vy cv cT co_ cfv co vx cv cT co_ cfv
    co wceq wi vz cT cdom_ cfv cdm wral vy cT cdom_ cfv cdm wral vx cT cdom_
    cfv cdm wral cT ccat wcel cT cdom_ cfv cT ccod_ cfv cop cT cid_ cfv cT co_
    cfv cop cop cded wcel vz cv cT cdom_ cfv cfv vy cv cT ccod_ cfv cfv wceq vy
    cv cT cdom_ cfv cfv vx cv cT ccod_ cfv cfv wceq wa vz cv vy cv vx cv cT co_
    cfv co cT co_ cfv co vz cv vy cv cT co_ cfv co vx cv cT co_ cfv co wceq wi
    vz cT cdom_ cfv cdm wral vy cT cdom_ cfv cdm wral vx cT cdom_ cfv cdm wral
    wa vx cv cT ccod_ cfv cfv vw cv wceq vw cv cT cid_ cfv cfv vx cv cT co_ cfv
    co vx cv wceq wi vx cT cdom_ cfv cdm wral vw cT cid_ cfv cdm wral vx cv cT
    cdom_ cfv cfv vw cv wceq vx cv vw cv cT cid_ cfv cfv cT co_ cfv co vx cv
    wceq wi vx cT cdom_ cfv cdm wral vw cT cid_ cfv cdm wral wa cT ccod_ cfv cT
    cdom_ cfv cT co_ cfv cT vx vy vz cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv
    cdm vw cT cdom_ cfv eqid cT ccod_ cfv eqid cT cid_ cfv eqid cT co_ cfv eqid
    cT cdom_ cfv cdm eqid cT cid_ cfv cdm eqid cati pm3.26d pm3.26d eqeltrd $.
    $( [28-Oct-2007] $) $( [26-Oct-2007] $)
  $}

  ${
    cat.1 $e |- M = dom D $.
    cat.3 $e |- D = ( dom_ ` T ) $.
    ${
      cat.2 $e |- O = dom J $.
      cat.5 $e |- J = ( id_ ` T ) $.
      ${
        $( The 1st "axiom" of a category: ` ( dom_ `` T ) ` is a mapping
           from the morphisms of ` T ` to the objects of ` T ` . $)
        domc $p |- ( T e. Cat -> D : M --> O ) $=
          cT ccat wcel cT cded wcel cT calg wcel cM cO cD wf cT catded cT
          dedalg cD cT cJ cM cO cat.1 cat.3 cat.2 cat.5 doma 3syl $.
          $( [3-Jan-2008] $) $( [2-Jan-2008] $)
      $}

      ${
        cat.4 $e |- C = ( cod_ ` T ) $.
        $( The 2nd "axiom" of a category ` ( cod_ `` T ) ` is a mapping
           from the morphisms of ` T ` to  the objects of ` T ` . $)
        codc $p |- ( T e. Cat -> C : M --> O ) $=
          cT ccat wcel cT cded wcel cT calg wcel cM cO cC wf cT catded cT
          dedalg cC cD cT cJ cM cO cat.1 cat.3 cat.2 cat.5 cat.4 coda 3syl $.
          $( [3-Jan-2008] $) $( [2-Jan-2008] $)
      $}

      ${
        $( The 3rd "axiom" of a category ` ( id_ `` T ) ` is a mapping from the
           objects of ` T ` to  the morphisms of ` T ` . $)
        idc $p |- ( T e. Cat -> J : O --> M ) $=
          cT ccat wcel cT cded wcel cT calg wcel cO cM cJ wf cT catded cT
          dedalg cD cT cJ cM cO cat.1 cat.3 cat.2 cat.5 ida 3syl $.
          $( [5-Dec-2007] $) $( [5-Dec-2007] $)
      $}
   $}
   ${
        cat.6 $e |- R = ( o_ ` T ) $.
        $( The 4th "axiom" of a category: ` ( o_ `` T )  ` is a partial
           operation from the morphisms of ` T ` to the morphisms of ` T ` . $)
        cmppfc $p |- ( T e. Cat ->
        ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) $=
          cT ccat wcel cT cded wcel cT calg wcel cR wfun cR cdm cM cM cxp wss
          cR crn cM wss w3a cT catded cT dedalg cD cR cT cM cat.1 cat.3 cat.6
          cmppfa 3syl $.
          $( [10-Mar-2008] $) $( [10-Mar-2008] $)
       $}
   $}

  ${
    idosc.1 $e |- O = dom J $.
    idosc.2 $e |- D = ( dom_ ` T ) $.
    idosc.3 $e |- J = ( id_ ` T ) $.
    idosc.4 $e |- C = ( cod_ ` T ) $.
    $( The 5th "axiom" of a category: identities are morphisms whose
       domains and codomains are equal. $)
    idosc $p |- ( ( T e. Cat /\ A e. O ) ->  ( ( D ` ( J ` A ) ) = A /\
        ( C ` ( J ` A ) ) = A ) ) $=
      cT cded wcel cA cO wcel cA cJ cfv cD cfv cA wceq cA cJ cfv cC cfv cA wceq
      wa cT ccat wcel cA cC cD cT cJ cO idosc.1 idosc.2 idosc.3 idosc.4 idosd
      cT catded sylan $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    cmppfcd.1 $e |- M = dom D $.
    cmppfcd.2 $e |- D = ( dom_ ` T ) $.
    cmppfcd.3 $e |- C = ( cod_ ` T ) $.
    cmppfcd.4 $e |- R = ( o_ ` T ) $.
    $( The 6th "axiom" of a category: ` ( G ( o_ `` T ) F )  ` is only
       defined when the domain of ` F ` equals the codomain of ` G ` . $)
    cmppfcd $p |- ( ( T e. Cat /\ F e. M /\ G e. M ) ->
           ( <. G , F >. e. dom R <-> ( D ` G ) = ( C ` F ) ) ) $=
      cT cded wcel cF cM wcel cG cM wcel cG cF cop cR cdm wcel cG cD cfv cF cC
      cfv wceq wb cT ccat wcel cC cD cR cT cF cG cM cmppfcd.1 cmppfcd.2
      cmppfcd.3 cmppfcd.4 cmppfd cT catded syl3an1 $.
      $( [10-Mar-2008] $) $( [10-Mar-2008] $)


    $( The 7th "axiom" of a category: when ` ( G ( o_ `` T ) F ) ` is defined
       its domain is the domain of ` F ` . $)
    domcmpc $p |- ( ( T e. Cat /\ F e. M /\ G e. M ) ->
        ( ( D ` G ) = ( C ` F ) -> ( D ` ( G R F ) ) = ( D ` F ) ) ) $=
      cT cded wcel cF cM wcel cG cM wcel cG cD cfv cF cC cfv wceq cG cF cR co
      cD cfv cF cD cfv wceq wi cT ccat wcel cC cD cR cT cF cG cM cmppfcd.1
      cmppfcd.2 cmppfcd.3 cmppfcd.4 domcmpd cT catded syl3an1 $.
      $( [10-Mar-2008] $) $( [10-Mar-2008] $)


    $( The 8th "axiom" of a category: when ` ( G ( o_ `` T ) F ) ` is defined
       its codomain is the codomain of ` G ` . $)
    codcmpc $p |- ( ( T e. Cat /\ F e. M /\ G e. M ) ->
              ( ( D ` G ) = ( C ` F )
              -> ( C ` ( G R F ) ) = ( C ` G ) ) ) $=
      cT cded wcel cF cM wcel cG cM wcel cG cD cfv cF cC cfv wceq cG cF cR co
      cC cfv cG cC cfv wceq wi cT ccat wcel cC cD cR cT cF cG cM cmppfcd.1
      cmppfcd.2 cmppfcd.3 cmppfcd.4 codcmpd cT catded syl3an1 $.
      $( [10-Jan-2008] $) $( [10-Jan-2008] $)
  $}


  ${ $d C f g h x $.  $d D f g h x $.  $d F f g h $.
     $d G g h $.  $d H h $.  $d M f g h $.  $d R f g h x $.
     $d T f x $.
    cmpasso.1 $e |- M = dom D $.
    cmpasso.2 $e |- D = ( dom_ ` T ) $.
    cmpasso.5 $e |- C = ( cod_ ` T ) $.
    cmpasso.6 $e |- R = ( o_ ` T ) $.
    $( The 9th "axiom" of a category: ` ( o_ `` T ) ` is associative. $)
    cmpasso $p |-  ( ( T e. Cat /\ ( F e. M /\ G e. M /\ H e. M ) ) ->
              (
                ( ( D ` H ) = ( C ` G ) /\
                ( D ` G ) = ( C ` F ) )
              ->
                ( H R ( G R F ) ) =
                  ( ( H R G ) R F )
               ) ) $=
      cT ccat wcel cF cM wcel cG cM wcel cH cM wcel w3a cH cD cfv cG cC cfv
      wceq cG cD cfv cF cC cfv wceq wa cH cG cF cR co cR co cH cG cR co cF cR
      co wceq wi cT ccat wcel cD cC cop cT cid_ cfv cR cop cop cded wcel vh cv
      cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq wa vh cv vg cv vf
      cv cR co cR co vh cv vg cv cR co vf cv cR co wceq wi vh cM wral vg cM
      wral vf cM wral wa vf cv cC cfv vx cv wceq vx cv cT cid_ cfv cfv vf cv cR
      co vf cv wceq wi vf cM wral vx cT cid_ cfv cdm wral vf cv cD cfv vx cv
      wceq vf cv vx cv cT cid_ cfv cfv cR co vf cv wceq wi vf cM wral vx cT
      cid_ cfv cdm wral wa wa cF cM wcel cG cM wcel cH cM wcel w3a cH cD cfv cG
      cC cfv wceq cG cD cfv cF cC cfv wceq wa cH cG cF cR co cR co cH cG cR co
      cF cR co wceq wi wi cC cD cR cT vf vg vh cT cid_ cfv cM cT cid_ cfv cdm
      vx cmpasso.2 cmpasso.5 cT cid_ cfv eqid cmpasso.6 cmpasso.1 cT cid_ cfv
      cdm eqid cati vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv
      wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq
      wi vh cM wral vg cM wral vf cM wral cF cM wcel cG cM wcel cH cM wcel w3a
      cH cD cfv cG cC cfv wceq cG cD cfv cF cC cfv wceq wa cH cG cF cR co cR co
      cH cG cR co cF cR co wceq wi wi cD cC cop cT cid_ cfv cR cop cop cded
      wcel vf cv cC cfv vx cv wceq vx cv cT cid_ cfv cfv vf cv cR co vf cv wceq
      wi vf cM wral vx cT cid_ cfv cdm wral vf cv cD cfv vx cv wceq vf cv vx cv
      cT cid_ cfv cfv cR co vf cv wceq wi vf cM wral vx cT cid_ cfv cdm wral wa
      cF cM wcel cG cM wcel cH cM wcel w3a vh cv cD cfv vg cv cC cfv wceq vg cv
      cD cfv vf cv cC cfv wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR
      co vf cv cR co wceq wi vh cM wral vg cM wral vf cM wral cH cD cfv cG cC
      cfv wceq cG cD cfv cF cC cfv wceq wa cH cG cF cR co cR co cH cG cR co cF
      cR co wceq wi vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv
      wceq wa vh cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq
      wi cH cD cfv cG cC cfv wceq cG cD cfv cF cC cfv wceq wa cH cG cF cR co cR
      co cH cG cR co cF cR co wceq wi vh cv cD cfv vg cv cC cfv wceq vg cv cD
      cfv cF cC cfv wceq wa vh cv vg cv cF cR co cR co vh cv vg cv cR co cF cR
      co wceq wi vh cv cD cfv cG cC cfv wceq cG cD cfv cF cC cfv wceq wa vh cv
      cG cF cR co cR co vh cv cG cR co cF cR co wceq wi vf vg vh cF cG cH cM cM
      cM vf cv cF wceq vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv vf cv cC cfv
      wceq wa vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv cF cC cfv wceq wa vh
      cv vg cv vf cv cR co cR co vh cv vg cv cR co vf cv cR co wceq vh cv vg cv
      cF cR co cR co vh cv vg cv cR co cF cR co wceq vf cv cF wceq vg cv cD cfv
      vf cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vh cv cD cfv vg cv cC cfv
      wceq vf cv cF wceq vf cv cC cfv cF cC cfv vg cv cD cfv vf cv cF cC fveq2
      eqeq2d anbi2d vf cv cF wceq vh cv vg cv vf cv cR co cR co vh cv vg cv cF
      cR co cR co vh cv vg cv cR co vf cv cR co vh cv vg cv cR co cF cR co vf
      cv cF wceq vg cv vf cv cR co vg cv cF cR co vh cv cR vf cv cF vg cv cR
      opreq2 opreq2d vf cv cF vh cv vg cv cR co cR opreq2 eqeq12d imbi12d vg cv
      cG wceq vh cv cD cfv vg cv cC cfv wceq vg cv cD cfv cF cC cfv wceq wa vh
      cv cD cfv cG cC cfv wceq cG cD cfv cF cC cfv wceq wa vh cv vg cv cF cR co
      cR co vh cv vg cv cR co cF cR co wceq vh cv cG cF cR co cR co vh cv cG cR
      co cF cR co wceq vg cv cG wceq vh cv cD cfv vg cv cC cfv wceq vh cv cD
      cfv cG cC cfv wceq vg cv cD cfv cF cC cfv wceq cG cD cfv cF cC cfv wceq
      vg cv cG wceq vg cv cC cfv cG cC cfv vh cv cD cfv vg cv cG cC fveq2
      eqeq2d vg cv cG wceq vg cv cD cfv cG cD cfv cF cC cfv vg cv cG cD fveq2
      eqeq1d anbi12d vg cv cG wceq vh cv vg cv cF cR co cR co vh cv cG cF cR co
      cR co vh cv vg cv cR co cF cR co vh cv cG cR co cF cR co vg cv cG wceq vg
      cv cF cR co cG cF cR co vh cv cR vg cv cG cF cR opreq1 opreq2d vg cv cG
      wceq vh cv vg cv cR co vh cv cG cR co cF cR vg cv cG vh cv cR opreq2
      opreq1d eqeq12d imbi12d vh cv cH wceq vh cv cD cfv cG cC cfv wceq cG cD
      cfv cF cC cfv wceq wa cH cD cfv cG cC cfv wceq cG cD cfv cF cC cfv wceq
      wa vh cv cG cF cR co cR co vh cv cG cR co cF cR co wceq cH cG cF cR co cR
      co cH cG cR co cF cR co wceq vh cv cH wceq vh cv cD cfv cG cC cfv wceq cH
      cD cfv cG cC cfv wceq cG cD cfv cF cC cfv wceq vh cv cH wceq vh cv cD cfv
      cH cD cfv cG cC cfv vh cv cH cD fveq2 eqeq1d anbi1d vh cv cH wceq vh cv
      cG cF cR co cR co cH cG cF cR co cR co vh cv cG cR co cF cR co cH cG cR
      co cF cR co vh cv cH cG cF cR co cR opreq1 vh cv cH wceq vh cv cG cR co
      cH cG cR co cF cR vh cv cH cG cR opreq1 opreq1d eqeq12d imbi12d rcla43v
      com12 ad2antlr syl imp $.
      $( [30-Oct-2007] $) $( [29-Oct-2007] $)
  $}

  ${ $d A a f $.  $d C a f x y $.  $d D a f x y $.  $d F f $.
     $d J a f $.  $d M a f $.  $d O a $.  $d R a f x y $.
    cmpida.1 $e |- M = dom D $.
    cmpida.2 $e |- D = ( dom_ ` T ) $.
    cmpida.3 $e |- O = dom  J $.
    cmpida.4 $e |- J = ( id_ ` T ) $.
    cmpida.5 $e |- R = ( o_ ` T ) $.
    cmpida.6 $e |- C = ( cod_ ` T ) $.
    $( The 10th "axiom" of a category: ` ( J `` A ) ` is a left neutral
       element. $)
    cmpida $p |- ( ( T e. Cat /\ A e. O /\ F e. M ) -> ( ( C ` F ) = A
         -> ( ( J ` A ) R F ) = F ) ) $=
      cT ccat wcel cA cO wcel cF cM wcel cF cC cfv cA wceq cA cJ cfv cF cR co
      cF wceq wi cT ccat wcel cD cC cop cJ cR cop cop cded wcel vy cv cD cfv vx
      cv cC cfv wceq vx cv cD cfv vf cv cC cfv wceq wa vy cv vx cv vf cv cR co
      cR co vy cv vx cv cR co vf cv cR co wceq wi vy cM wral vx cM wral vf cM
      wral wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi vf
      cM wral va cO wral vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co vf cv
      wceq wi vf cM wral va cO wral wa wa cA cO wcel cF cM wcel wa cF cC cfv cA
      wceq cA cJ cfv cF cR co cF wceq wi wi cC cD cR cT vf vx vy cJ cM cO va
      cmpida.2 cmpida.6 cmpida.4 cmpida.5 cmpida.1 cmpida.3 cati vf cv cC cfv
      va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi vf cM wral va cO wral
      cA cO wcel cF cM wcel wa cF cC cfv cA wceq cA cJ cfv cF cR co cF wceq wi
      wi cD cC cop cJ cR cop cop cded wcel vy cv cD cfv vx cv cC cfv wceq vx cv
      cD cfv vf cv cC cfv wceq wa vy cv vx cv vf cv cR co cR co vy cv vx cv cR
      co vf cv cR co wceq wi vy cM wral vx cM wral vf cM wral wa vf cv cD cfv
      va cv wceq vf cv va cv cJ cfv cR co vf cv wceq wi vf cM wral va cO wral
      cA cO wcel cF cM wcel wa vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co
      vf cv wceq wi vf cM wral va cO wral cF cC cfv cA wceq cA cJ cfv cF cR co
      cF wceq wi vf cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi
      cF cC cfv cA wceq cA cJ cfv cF cR co cF wceq wi vf cv cC cfv cA wceq cA
      cJ cfv vf cv cR co vf cv wceq wi va vf cA cF cO cM va cv cA wceq vf cv cC
      cfv va cv wceq vf cv cC cfv cA wceq va cv cJ cfv vf cv cR co vf cv wceq
      cA cJ cfv vf cv cR co vf cv wceq va cv cA vf cv cC cfv eqeq2 va cv cA
      wceq va cv cJ cfv vf cv cR co cA cJ cfv vf cv cR co vf cv va cv cA wceq
      va cv cJ cfv cA cJ cfv vf cv cR va cv cA cJ fveq2 opreq1d eqeq1d imbi12d
      vf cv cF wceq vf cv cC cfv cA wceq cF cC cfv cA wceq cA cJ cfv vf cv cR
      co vf cv wceq cA cJ cfv cF cR co cF wceq vf cv cF wceq vf cv cC cfv cF cC
      cfv cA vf cv cF cC fveq2 eqeq1d vf cv cF wceq cA cJ cfv vf cv cR co cA cJ
      cfv cF cR co vf cv cF vf cv cF cA cJ cfv cR opreq2 vf cv cF wceq id
      eqeq12d imbi12d rcla42v com12 ad2antrl syl 3impib $.
      $( [30-Oct-2007] $) $( [29-Oct-2007] $)
  $}

  ${ $d A a f $.  $d D a f x y $.  $d F f $.  $d J a f $.
     $d M a f $.  $d O a $.  $d R a f x y $.  $d T a f x y $.
    cmpidb.1 $e |- M = dom D $.
    cmpidb.2 $e |- D = ( dom_ ` T ) $.
    cmpidb.3 $e |- O = dom  J $.
    cmpidb.4 $e |- J = ( id_ ` T ) $.
    cmpidb.5 $e |- R = ( o_ ` T ) $.
    $( The 11th "axiom" of a category: ` ( J `` A ) ` is a right neutral
       element. $)
    cmpidb $p |- ( ( T e. Cat /\ A e. O /\ F e. M ) -> ( ( D ` F ) = A
         -> ( F R ( J ` A ) ) = F ) ) $=
      cT ccat wcel cA cO wcel cF cM wcel cF cD cfv cA wceq cF cA cJ cfv cR co
      cF wceq wi cT ccat wcel cD cT ccod_ cfv cop cJ cR cop cop cded wcel vy cv
      cD cfv vx cv cT ccod_ cfv cfv wceq vx cv cD cfv vf cv cT ccod_ cfv cfv
      wceq wa vy cv vx cv vf cv cR co cR co vy cv vx cv cR co vf cv cR co wceq
      wi vy cM wral vx cM wral vf cM wral wa vf cv cT ccod_ cfv cfv va cv wceq
      va cv cJ cfv vf cv cR co vf cv wceq wi vf cM wral va cO wral vf cv cD cfv
      va cv wceq vf cv va cv cJ cfv cR co vf cv wceq wi vf cM wral va cO wral
      wa wa cA cO wcel cF cM wcel wa cF cD cfv cA wceq cF cA cJ cfv cR co cF
      wceq wi wi cT ccod_ cfv cD cR cT vf vx vy cJ cM cO va cmpidb.2 cT ccod_
      cfv eqid cmpidb.4 cmpidb.5 cmpidb.1 cmpidb.3 cati vf cv cD cfv va cv wceq
      vf cv va cv cJ cfv cR co vf cv wceq wi vf cM wral va cO wral cA cO wcel
      cF cM wcel wa cF cD cfv cA wceq cF cA cJ cfv cR co cF wceq wi wi cD cT
      ccod_ cfv cop cJ cR cop cop cded wcel vy cv cD cfv vx cv cT ccod_ cfv cfv
      wceq vx cv cD cfv vf cv cT ccod_ cfv cfv wceq wa vy cv vx cv vf cv cR co
      cR co vy cv vx cv cR co vf cv cR co wceq wi vy cM wral vx cM wral vf cM
      wral wa vf cv cT ccod_ cfv cfv va cv wceq va cv cJ cfv vf cv cR co vf cv
      wceq wi vf cM wral va cO wral cA cO wcel cF cM wcel wa vf cv cD cfv va cv
      wceq vf cv va cv cJ cfv cR co vf cv wceq wi vf cM wral va cO wral cF cD
      cfv cA wceq cF cA cJ cfv cR co cF wceq wi vf cv cD cfv va cv wceq vf cv
      va cv cJ cfv cR co vf cv wceq wi cF cD cfv cA wceq cF cA cJ cfv cR co cF
      wceq wi vf cv cD cfv cA wceq vf cv cA cJ cfv cR co vf cv wceq wi va vf cA
      cF cO cM va cv cA wceq vf cv cD cfv va cv wceq vf cv cD cfv cA wceq vf cv
      va cv cJ cfv cR co vf cv wceq vf cv cA cJ cfv cR co vf cv wceq va cv cA
      vf cv cD cfv eqeq2 va cv cA wceq vf cv va cv cJ cfv cR co vf cv cA cJ cfv
      cR co vf cv va cv cA wceq va cv cJ cfv cA cJ cfv vf cv cR va cv cA cJ
      fveq2 opreq2d eqeq1d imbi12d vf cv cF wceq vf cv cD cfv cA wceq cF cD cfv
      cA wceq vf cv cA cJ cfv cR co vf cv wceq cF cA cJ cfv cR co cF wceq vf cv
      cF wceq vf cv cD cfv cF cD cfv cA vf cv cF cD fveq2 eqeq1d vf cv cF wceq
      vf cv cA cJ cfv cR co cF cA cJ cfv cR co vf cv cF vf cv cF cA cJ cfv cR
      opreq1 vf cv cF wceq id eqeq12d imbi12d rcla42v com12 ad2antll syl 3impib
      $.
      $( [28-Oct-2007] $) $( [24-Oct-2007] $)
  $}

  ${
    dmo.1 $e |- M = dom ( dom_ ` T ) $.
    dmo.3 $e |- O = dom ( id_ ` T ) $.

    ${
      dmo.2 $e |- D = ( dom_ ` T ) $.
      $( The domain of a morphism is an object. $)
      dmo $p |- ( ( T e. Cat /\ F e. M ) -> ( D ` F ) e. O ) $=
        cM cO cD wf cF cM wcel cF cD cfv cO wcel cT ccat wcel cM cO cF cD
        ffvelrn cD cT cT cid_ cfv cM cO cM cT cdom_ cfv cdm cD cdm dmo.1 cT
        cdom_ cfv cD cD cT cdom_ cfv dmo.2 eqcomi dmeqi eqtri dmo.2 dmo.3 cT
        cid_ cfv eqid domc sylan $.
        $( [3-Jan-2008] $) $( [2-Jan-2008] $)

    $}

    ${
      cdmo.2 $e |- C = ( cod_ ` T ) $.
      $( The codomain of a morphism is an object. $)
      cdmo $p |- ( ( T e. Cat /\ F e. M ) -> ( C ` F ) e. O ) $=
        cM cO cC wf cF cM wcel cF cC cfv cO wcel cT ccat wcel cM cO cF cC
        ffvelrn cC cT cdom_ cfv cT cT cid_ cfv cM cO dmo.1 cT cdom_ cfv eqid
        dmo.3 cT cid_ cfv eqid cdmo.2 codc sylan $.
        $( [3-Jan-2008] $) $( [2-Jan-2008] $)
    $}

    ${
      jdmo.2 $e |- J = ( id_ ` T ) $.
      $( An identity is a morphism. $)
      jdmo $p |- ( ( T e. Cat /\ A e. O ) -> ( J ` A ) e. M ) $=
        cO cM cJ wf cA cO wcel cA cJ cfv cM wcel cT ccat wcel cO cM cA cJ
        ffvelrn cT cdom_ cfv cT cJ cM cO dmo.1 cT cdom_ cfv eqid cO cT cid_ cfv
        cdm cJ cdm dmo.3 cJ cT cid_ cfv jdmo.2 dmeqi eqtr4i jdmo.2 idc sylan $.
        $( [10-Jan-2008] $) $( [10-Jan-2008] $)
    $}

  $}

  ${
    cmpmorp.1 $e |- M = dom ( dom_ ` T ) $.
    cmpmorp.2 $e |- D = ( dom_ ` T ) $.
    cmpmorp.3 $e |- C = ( cod_ ` T ) $.
    cmpmorp.4 $e |- R = ( o_ ` T ) $.
    $( Conditions for a composite to be a morphism. $)
    cmpmorp $p |- ( ( T e. Cat /\ F e. M /\ G e. M ) ->
      ( ( D ` G ) = ( C ` F ) -> ( G R F ) e. M ) ) $=
      cT ccat wcel cF cM wcel cG cM wcel w3a cG cD cfv cF cC cfv wceq cG cF cR
      co cR crn wcel cG cF cR co cM wcel cT ccat wcel cF cM wcel cG cM wcel w3a
      cG cD cfv cF cC cfv wceq cR wfun cG cF cop cR cdm wcel wa cG cF cR co cR
      crn wcel cT ccat wcel cF cM wcel cG cM wcel w3a cG cD cfv cF cC cfv wceq
      cR wfun cG cF cop cR cdm wcel wa cT ccat wcel cF cM wcel cG cM wcel w3a
      cG cD cfv cF cC cfv wceq wa cR wfun cG cF cop cR cdm wcel cT ccat wcel cF
      cM wcel cG cM wcel w3a cR wfun cG cD cfv cF cC cfv wceq cT ccat wcel cF
      cM wcel cG cM wcel w3a cR wfun cR cdm cM cM cxp wss cR crn cM wss cT ccat
      wcel cF cM wcel cR wfun cR cdm cM cM cxp wss cR crn cM wss w3a cG cM wcel
      cT cdom_ cfv cR cT cM cmpmorp.1 cT cdom_ cfv eqid cmpmorp.4 cmppfc
      3ad2ant1 3simp1d adantr cT ccat wcel cF cM wcel cG cM wcel w3a cG cF cop
      cR cdm wcel cG cD cfv cF cC cfv wceq cC cD cR cT cF cG cM cM cT cdom_ cfv
      cdm cD cdm cmpmorp.1 cT cdom_ cfv cD cD cT cdom_ cfv cmpmorp.2 eqcomi
      dmeqi eqtri cmpmorp.2 cmpmorp.3 cmpmorp.4 cmppfcd biimpar jca ex cG cF cR
      fnoprvrn2 syl6 cT ccat wcel cF cM wcel cG cM wcel w3a cR wfun cR cdm cM
      cM cxp wss cR crn cM wss w3a cR crn cM wss cG cF cR co cR crn wcel cG cF
      cR co cM wcel wi cT ccat wcel cF cM wcel cR wfun cR cdm cM cM cxp wss cR
      crn cM wss w3a cG cM wcel cT cdom_ cfv cR cT cM cmpmorp.1 cT cdom_ cfv
      eqid cmpmorp.4 cmppfc 3ad2ant1 cR wfun cR cdm cM cM cxp wss cR crn cM wss
      3simp3 cR crn cM cG cF cR co ssel 3syl syld $.
      $( [10-Mar-2008] $) $( [10-Mar-2008] $)
  $}

  $( Two ways to define the set of the morphisms of a category. $)
  morcat $p |- ( T e. Cat -> dom ( dom_ ` T ) = dom ( cod_ ` T ) ) $=
    cT ccat wcel cT cdom_ cfv cdm cT cid_ cfv cdm cT ccod_ cfv wf cT cdom_ cfv
    cdm cT ccod_ cfv cdm wceq cT ccod_ cfv cT cdom_ cfv cT cT cid_ cfv cT cdom_
    cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT cid_ cfv
    cdm eqid cT cid_ cfv eqid cT ccod_ cfv eqid codc cT cdom_ cfv cdm cT cid_
    cfv cdm cT ccod_ cfv wf cT ccod_ cfv cdm cT cdom_ cfv cdm cT cdom_ cfv cdm
    cT cid_ cfv cdm cT ccod_ cfv fdm eqcomd syl $.
    $( [6-Oct-2009] $) $( [19-Sep-2009] $)

  ${
    cmppfc1.1 $e |- R = ( o_ ` T ) $.
    $( Composition is a function. $)
    cmppfc1 $p |- ( T e. Cat -> Fun R ) $=
      cT ccat wcel cR wfun cR cdm cT cdom_ cfv cdm cT cdom_ cfv cdm cxp wss cR
      crn cT cdom_ cfv cdm wss cT cdom_ cfv cR cT cT cdom_ cfv cdm cT cdom_ cfv
      cdm eqid cT cdom_ cfv eqid cmppfc1.1 cmppfc 3simp1d $.
      $( [6-Oct-2009] $) $( [5-Oct-2009] $)

  $}

  ${
    $d D x y z $. $d F x y z $. $d G x y z $. $d R x y z $. $d T x y z $.
    dualcat2lem.1 $e |- D = ( dom_ ` T ) $.
    dualcat2lem.2 $e |- C = ( cod_ ` T ) $.
    dualcat2lem.3 $e |- R = ( o_ ` T ) $.
    $( Lemma for ~ dualcat2 . $)
    dualcat2lem $p |- (
       (  T e. Cat /\ ( F e. dom D /\ G e. dom D ) /\ ( D ` G ) = ( C ` F ) )
            ->   ( F { <. <. x ,  y >. ,  z >.
            |  ( <. y , x >. e. dom R /\ z = ( y R x ) ) } G )
            = ( G R F ) ) $=
      cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF
      cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 co cG cF cR co wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT ccat wcel cF cD cdm
      wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF cR co
      wceq wi wi cT ccat wcel vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz cT ccat wcel vy cv vx cv cop cR cdm wcel vy cv vx cv cop
      cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq cT ccat wcel cR cdm
      cD cdm cD cdm cxp vy cv vx cv cop cT ccat wcel cR wfun cR cdm cD cdm cD
      cdm cxp wss cR crn cD cdm wss cD cR cT cD cdm cD cdm eqid dualcat2lem.1
      dualcat2lem.3 cmppfc 3simp2d sseld anim1d ssoprab2g vy cv vx cv cop cD
      cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv
      vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 wceq vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wceq vy cv vx cv cop cR cdm
      wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cop cD
      cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss
      cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF
      cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 co cG cF cR co wceq wi wi wi wi vy cv vx cv cop cD cdm cD cdm cxp
      wcel vz cv vy cv vx cv cR co wceq wa vx cv vy cv cop cD cdm cD cdm cxp
      wcel vz cv vy cv vx cv cR co wceq wa vx vy vz vy cv vx cv cop cD cdm cD
      cdm cxp wcel vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR
      co wceq vy cv vx cv cop cD cdm cD cdm cxp wcel vy cv vx cv cop cD cdm cD
      cdm cxp ccnv wcel vx cv vy cv cop cD cdm cD cdm cxp wcel cD cdm cD cdm
      cxp cD cdm cD cdm cxp ccnv vy cv vx cv cop cD cdm cD cdm cxp ccnv cD cdm
      cD cdm cxp cD cdm cD cdm cnvxp eqcomi eleq2i vy cv vx cv cD cdm cD cdm
      cxp vy visset vx visset opelcnv bitri anbi1i oprabbii vz cv vy cv vx cv
      cR co wceq vx vy vz cD cdm cD cdm twsvbdop vy cv vx cv cop cD cdm cD cdm
      cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv vy cv cop
      cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wceq vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq
      wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 wceq wa vy cv vx cv cop cD cdm cD cdm
      cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa
      cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 co cG cF cR co wceq wi wi wi wi vy cv vx
      cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy
      cv vx cv cR co wceq wa vx vy vz copab2 eqtr vy cv vx cv cop cD cdm cD cdm
      cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT ccat wcel cF cD cdm
      wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF cR co
      wceq wi wi wi vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 sseq2 cT ccat wcel cF cD cdm
      wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wss cG cD cfv cF cC cfv wceq cF
      cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 co cG cF cR co wceq wi cT ccat wcel cF cD cdm wcel cG cD cdm wcel
      wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss cG cD cfv cF cC cfv wceq cF cG vy cv vx cv
      cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF
      cR co wceq cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop
      cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wss w3a cG cD cfv cF cC cfv wceq wa cF cG vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel
      vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
      wceq cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 co cG cF cR co wceq vx cv cD cdm wcel vy cv cD cdm wcel wa
      vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wfun vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wss cF cG cop vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 cdm wcel cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel vy cv cD cdm
      wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co wceq cT ccat
      wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm
      wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv
      cF cC cfv wceq wa vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 wfun vy cv vx cv cop cR cdm wcel vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm
      wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cF cG cop vy
      cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      cdm wcel w3a cF cG vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 co cF cG vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel
      vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy
      cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      oprssoprvg eqcomd vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 wfun cT ccat wcel cF cD cdm wcel cG cD
      cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF cC cfv wceq wa vx cv
      cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 cD cdm cD cdm cxp wfn vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wfun vx vy vz cD cdm cD cdm vy
      cv vx cv cR co vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 vy cv vx cv cR oprex vx cv cD cdm wcel vy
      cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 eqid
      fnoprab2 cD cdm cD cdm cxp vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 fnfun ax-mp a1i cT ccat wcel cF
      cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa
      vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cG cD cfv cF cC cfv
      wceq 3simpl3 cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv
      cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD
      cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 wss w3a cG cD cfv cF cC cfv wceq wa cF cG cop vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm wcel cF cG
      cop cR cdm ccnv wcel cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wss w3a cG cD cfv cF cC cfv wceq wa cF cG cop cR cdm ccnv wcel
      cG cF cop cR cdm wcel cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wss cG cD cfv cF cC cfv wceq cG cF cop cR cdm wcel cT ccat wcel
      cF cD cdm wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cG cF cop cR
      cdm wcel wi vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 wss cT ccat wcel cF cD cdm wcel cG cD cdm
      wcel cG cD cfv cF cC cfv wceq cG cF cop cR cdm wcel wi cT ccat wcel cF cD
      cdm wcel cG cD cdm wcel w3a cG cF cop cR cdm wcel cG cD cfv cF cC cfv
      wceq cC cD cR cT cF cG cD cdm cD cdm eqid dualcat2lem.1 dualcat2lem.2
      dualcat2lem.3 cmppfcd biimprd 3expib a1dd 3imp1 cT ccat wcel cF cD cdm
      wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF cC cfv
      wceq wa cF cvv wcel cG cvv wcel wa cF cG cop cR cdm ccnv wcel cG cF cop
      cR cdm wcel wb cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv
      cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD
      cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 wss w3a cF cvv wcel cG cvv wcel wa cG cD cfv cF cC cfv wceq cF cD
      cdm wcel cG cD cdm wcel wa cT ccat wcel cF cvv wcel cG cvv wcel wa vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wss cF cD cdm wcel cF cvv wcel cG cD cdm wcel cG cvv wcel cF cD
      cdm elisset cG cD cdm elisset anim12i 3ad2ant2 adantr cF cG cvv cvv cR
      cdm opelcnvg syl mpbird cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa vy
      cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 wss w3a cF cG cop vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 cdm wcel cF cG cop cR cdm ccnv wcel wb
      cG cD cfv cF cC cfv wceq cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa cF
      cG cop vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 cdm wcel cF cG cop cR cdm ccnv wcel wb vy cv vx cv cop cR cdm
      wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy
      cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT
      ccat wcel cF cD cdm wcel cG cD cdm wcel wa wa vy cv vx cv cop cR cdm wcel
      vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv cF cG cop
      cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa wa vx cv vy cv cop cR cdm
      ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv
      vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 cdm cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa wa cR cdm ccnv
      wrel vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 cdm cR cdm ccnv wceq cR cdm ccnv wrel cT ccat wcel cF cD cdm
      wcel cG cD cdm wcel wa wa cR cdm relcnv a1i vx vy vz cR cdm ccnv vy cv vx
      cv cR co cvv vy cv vx cv cR oprex dmoprabss6 syl vy cv vx cv cop cR cdm
      wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv vy cv cop cR
      cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv
      cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx cv vy cv cop cR cdm
      ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz vy cv vx cv cop cR cdm
      wcel vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq vx cv
      vy cv cop cR cdm ccnv wcel vy cv vx cv cop cR cdm wcel vx cv vy cv cR cdm
      vx visset vy visset opelcnv bicomi anbi1i oprabbii dmeqi syl5eq eleq2d
      3adant3 adantr mpbird syl3anc cT ccat wcel cF cD cdm wcel cG cD cdm wcel
      wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss w3a cF cG vy cv vx cv cop cR cdm wcel vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel vy
      cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co wceq
      cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 co cG cF cR co wceq wi cG cD cfv cF cC cfv wceq cT ccat wcel cF
      cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa
      vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cF cG vy cv vx cv cop
      cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 co wceq cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 co cG cF cR co wceq wi cT ccat wcel cF cD cdm
      wcel cG cD cdm wcel wa cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel vy cv cD cdm
      wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co wceq cF cG vy
      cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      co cG cF cR co wceq wi vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT ccat wcel cF cD cdm wcel
      cG cD cdm wcel wa cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel vy cv cD cdm wcel
      wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co wceq cF cG vy cv vx
      cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG
      cF cR co wceq cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa wa cF cG vy
      cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      co cF cG vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 co wceq wa cF cG vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel
      vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
      cG cF cR co cT ccat wcel cF cD cdm wcel cG cD cdm wcel wa wa cF cG vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
      cF cG vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq
      wa vx vy vz copab2 co wceq pm3.27 cF cD cdm wcel cG cD cdm wcel wa cF cG
      vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 co cG cF cR co wceq cT ccat wcel cF cG vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx cv
      cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 co wceq vx vy vz cF cG cD cdm cD cdm vy cv vx cv cR co cG cF cR co
      vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 vy cv cF cR co cG cF cR oprex vx cv cF vy cv cR opreq2 vy cv
      cG cF cR opreq1 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 eqid oprabval2 ad2antlr eqtrd exp31 a1dd
      3imp adantr mpd 3exp1 com3r syl6bi syl mp2an mpcom 3imp $.
      $( [18-Apr-2010] $) $( [27-Mar-2010] $)
  $}

  ${
    $d D x y z $. $d F x y z $. $d G x y z $. $d R x y z $. $d T x y z $.
    dualded2lem.1 $e |- D = ( dom_ ` T ) $.
    dualded2lem.2 $e |- C = ( cod_ ` T ) $.
    dualded2lem.3 $e |- R = ( o_ ` T ) $.
    $( Lemma for ~ dualded . $)
    dualded2lem $p |- (
       (  T e. Ded /\ ( F e. dom D /\ G e. dom D ) /\ ( D ` G ) = ( C ` F ) )
          ->   ( F { <. <. x ,  y >. ,  z >.
          |  ( <. y , x >. e. dom R /\ z = ( y R x ) ) } G ) = ( G R F ) ) $=
      cT cded wcel cF cD cdm wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF
      cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 co cG cF cR co wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT cded wcel cF cD cdm
      wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF cR co
      wceq wi wi cT cded wcel vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz cT cded wcel vy cv vx cv cop cR cdm wcel vy cv vx cv cop
      cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq cT cded wcel cR cdm
      cD cdm cD cdm cxp vy cv vx cv cop cT cded wcel cR wfun cR cdm cD cdm cD
      cdm cxp wss cR crn cD cdm wss cT cded wcel cT calg wcel cR wfun cR cdm cD
      cdm cD cdm cxp wss cR crn cD cdm wss w3a cT dedalg cD cR cT cD cdm cD cdm
      eqid dualded2lem.1 dualded2lem.3 cmppfa syl 3simp2d sseld anim1d
      ssoprab2g vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy
      cv vx cv cR co wceq wa vx vy vz copab2 wceq vx cv vy cv cop cD cdm cD cdm
      cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss cT cded wcel cF cD cdm wcel cG cD cdm wcel wa
      cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 co cG cF cR co wceq wi wi wi wi vy cv vx
      cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx cv vy cv
      cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz vy cv
      vx cv cop cD cdm cD cdm cxp wcel vx cv vy cv cop cD cdm cD cdm cxp wcel
      vz cv vy cv vx cv cR co wceq vy cv vx cv cop cD cdm cD cdm cxp wcel vy cv
      vx cv cop cD cdm cD cdm cxp ccnv wcel vx cv vy cv cop cD cdm cD cdm cxp
      wcel cD cdm cD cdm cxp cD cdm cD cdm cxp ccnv vy cv vx cv cop cD cdm cD
      cdm cxp ccnv cD cdm cD cdm cxp cD cdm cD cdm cnvxp eqcomi eleq2i vy cv vx
      cv cD cdm cD cdm cxp vy visset vx visset opelcnv bitri anbi1i oprabbii vz
      cv vy cv vx cv cR co wceq vx vy vz cD cdm cD cdm twsvbdop vy cv vx cv cop
      cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wceq vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 wceq wa vy cv vx cv cop cD
      cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv
      cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 wss cT cded wcel cF cD cdm wcel cG cD cdm
      wcel wa cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR cdm wcel vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF cR co wceq wi wi wi wi
      vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 eqtr vy cv vx cv cop cD cdm cD
      cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wceq vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT cded wcel cF cD cdm
      wcel cG cD cdm wcel wa cG cD cfv cF cC cfv wceq cF cG vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF cR co
      wceq wi wi wi vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 sseq2 cT cded wcel cF cD cdm
      wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wss cG cD cfv cF cC cfv wceq cF
      cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 co cG cF cR co wceq wi cT cded wcel cF cD cdm wcel cG cD cdm wcel
      wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss cG cD cfv cF cC cfv wceq cF cG vy cv vx cv
      cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF
      cR co wceq cT cded wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop
      cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm
      wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      wss w3a cG cD cfv cF cC cfv wceq wa cF cG vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel
      vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
      cG cF cR co vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 wfun vy cv vx cv cop cR cdm wcel vz cv vy cv
      vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel
      wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cF cG cop vy cv vx
      cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm
      wcel cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 co cF cG vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv
      vx cv cR co wceq wa vx vy vz copab2 co wceq cT cded wcel cF cD cdm wcel
      cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy
      cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF cC cfv wceq
      wa vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 wfun vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy
      cv vx cv cR co wceq wa vx vy vz copab2 wss cF cG cop vy cv vx cv cop cR
      cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm wcel w3a cF
      cG vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 co cF cG vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 co cF cG vx cv cD cdm wcel vy cv cD cdm wcel
      wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cop cR cdm
      wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 oprssoprvg eqcomd vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wfun cT cded wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv
      cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD
      cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 wss w3a cG cD cfv cF cC cfv wceq wa vx cv cD cdm wcel vy cv cD cdm
      wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cD cdm cD cdm cxp
      wfn vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq
      wa vx vy vz copab2 wfun vx vy vz cD cdm cD cdm vy cv vx cv cR co vx cv cD
      cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vy cv vx cv cR oprex vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 eqid fnoprab2 cD cdm cD cdm cxp
      vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 fnfun ax-mp a1i cT cded wcel cF cD cdm wcel cG cD cdm wcel
      wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 wss cG cD cfv cF cC cfv wceq 3simpl3 cT cded wcel
      cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv
      vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel
      wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF
      cC cfv wceq wa cF cG cop cR cdm ccnv vy cv vx cv cop cR cdm wcel vz cv vy
      cv vx cv cR co wceq wa vx vy vz copab2 cdm cT cded wcel cF cD cdm wcel cG
      cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq
      wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF cC cfv wceq wa cF
      cG cop cR cdm ccnv wcel cG cF cop cR cdm wcel cT cded wcel cF cD cdm wcel
      cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy
      cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cF cop cR cdm wcel cG
      cD cfv cF cC cfv wceq cT cded wcel cF cD cdm wcel cG cD cdm wcel wa cG cF
      cop cR cdm wcel cG cD cfv cF cC cfv wceq wb vy cv vx cv cop cR cdm wcel
      vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv
      cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss cT
      cded wcel cF cD cdm wcel cG cD cdm wcel cG cF cop cR cdm wcel cG cD cfv
      cF cC cfv wceq wb cC cD cR cT cF cG cD cdm cD cdm eqid dualded2lem.1
      dualded2lem.2 dualded2lem.3 cmppfd 3expb 3adant3 biimpar cT cded wcel cF
      cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx
      cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa
      vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF cC
      cfv wceq wa cF cvv wcel cG cvv wcel wa cF cG cop cR cdm ccnv wcel cG cF
      cop cR cdm wcel wb cT cded wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx
      cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv
      cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 wss w3a cF cvv wcel cG cvv wcel wa cG cD cfv cF cC cfv wceq cF cD
      cdm wcel cG cD cdm wcel wa cT cded wcel cF cvv wcel cG cvv wcel wa vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wss cF cD cdm wcel cF cvv wcel cG cD cdm wcel cG cvv wcel cF cD
      cdm elisset cG cD cdm elisset anim12i 3ad2ant2 adantr cF cG cvv cvv cR
      cdm opelcnvg syl mpbird cT cded wcel cF cD cdm wcel cG cD cdm wcel wa vy
      cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx
      vy vz copab2 wss w3a vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 cdm cR cdm ccnv wceq cG cD cfv cF cC cfv wceq cT
      cded wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv wceq vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wss cT cded wcel cF cD cdm wcel cG cD cdm wcel wa wa vx cv vy
      cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
      cdm cR cdm ccnv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq
      wa vx vy vz copab2 cdm cT cded wcel cF cD cdm wcel cG cD cdm wcel wa wa
      cR cdm ccnv wrel vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 cdm cR cdm ccnv wceq cR cdm ccnv wrel cT cded
      wcel cF cD cdm wcel cG cD cdm wcel wa wa cR cdm relcnv a1i vx vy vz cR
      cdm ccnv vy cv vx cv cR co cvv vy cv vx cv cR oprex dmoprabss6 syl vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
      copab2 vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx cv
      vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz vy cv
      vx cv cop cR cdm wcel vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv
      cR co wceq vx cv vy cv cop cR cdm ccnv wcel vy cv vx cv cop cR cdm wcel
      vx cv vy cv cR cdm vx visset vy visset opelcnv bicomi anbi1i oprabbii
      dmeqi syl5eq 3adant3 adantr eleqtrrd syl3anc cF cD cdm wcel cG cD cdm
      wcel cG cF cR co cvv wcel cF cG vx cv cD cdm wcel vy cv cD cdm wcel wa vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cG cF cR co wceq cT cded
      wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm
      wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv
      cF cC cfv wceq wa vx vy vz cF cG cD cdm cD cdm vy cv vx cv cR co cG cF cR
      co vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 vy cv cF cR co cvv vx cv cF vy cv cR opreq2 vy cv cG cF
      cR opreq1 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co
      wceq wa vx vy vz copab2 eqid oprabval2g cT cded wcel cF cD cdm wcel cG cD
      cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
      vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv
      cR co wceq wa vx vy vz copab2 wss w3a cF cD cdm wcel cG cD cfv cF cC cfv
      wceq cF cD cdm wcel cG cD cdm wcel wa cT cded wcel cF cD cdm wcel vy cv
      vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx
      cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy
      vz copab2 wss cF cD cdm wcel cG cD cdm wcel pm3.26 3ad2ant2 adantr cT
      cded wcel cF cD cdm wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz
      cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD
      cdm wcel wa vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD
      cdm wcel cG cD cfv cF cC cfv wceq cF cD cdm wcel cG cD cdm wcel wa cT
      cded wcel cG cD cdm wcel vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wss cF cD cdm wcel cG cD cdm
      wcel pm3.27 3ad2ant2 adantr cG cF cR co cvv wcel cT cded wcel cF cD cdm
      wcel cG cD cdm wcel wa vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
      co wceq wa vx vy vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv
      vy cv vx cv cR co wceq wa vx vy vz copab2 wss w3a cG cD cfv cF cC cfv
      wceq wa cG cF cR oprex a1i syl3anc eqtrd 3exp1 com3r syl6bi syl mp2an
      mpcom 3imp $.
      $( [18-Apr-2010] $) $( [18-Apr-2010] $)
  $}

  ${
    dualcat2.1 $e |- D = ( dom_ ` T ) $.
    dualcat2.2 $e |- C = ( cod_ ` T ) $.
    dualcat2.3 $e |- J = ( id_ ` T ) $.
    dualcat2.4 $e |- R = ( o_ ` T ) $.
    ${
      $d C w x y z $. $d R w x y z $. $d T x y z $.
      $( The dual of a ` Alg `  is a ` Alg ` . $)
      dualalg $p |- (  T e. Alg ->
        <. <. C , D >. ,  <. J ,  { <. <. x ,  y >. ,  z >. |
          ( <. y , x >. e. dom R /\ z = ( y R x ) ) } >. >. e. Alg ) $=
        cT calg wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 cop cop cC cD cop cJ vx cv vy cv cop cR
        cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cop cop
        calg cT calg wcel cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 cop cJ vx cv vy cv cop cR cdm ccnv wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 cop cC cD cop cT calg wcel
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 cJ cT calg wcel vy cv vx cv cop cR cdm wcel vz cv vy cv
        vx cv cR co wceq wa vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz cT calg wcel vy cv vx cv cop cR cdm wcel vx cv
        vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq vy cv vx cv cop
        cR cdm wcel vx cv vy cv cop cR cdm ccnv wcel wb cT calg wcel vx cv cvv
        wcel vy cv cvv wcel vy cv vx cv cop cR cdm wcel vx cv vy cv cop cR cdm
        ccnv wcel wb vx visset vy visset vx cv cvv wcel vy cv cvv wcel wa vx cv
        vy cv cop cR cdm ccnv wcel vy cv vx cv cop cR cdm wcel vx cv vy cv cvv
        cvv cR cdm opelcnvg bicomd mp2an a1i anbi1d oprabbidv opeq2d opeq2d cT
        calg wcel cC cD cop cJ vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 cop cop calg wcel cC cdm cJ cdm cC wf
        cC cdm cJ cdm cD wf cJ cdm cC cdm cJ wf w3a vx cv vy cv cop cR cdm ccnv
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wfun vx cv vy cv
        cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cdm cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 crn cC cdm wss w3a wa cD cdm cC cdm
        wceq cD cdm cJ cdm cD wf cD cdm cJ cdm cC wf cJ cdm cD cdm cJ wf w3a cR
        wfun cR cdm cD cdm cD cdm cxp wss cR crn cD cdm wss w3a wa cC cdm cJ
        cdm cC wf cC cdm cJ cdm cD wf cJ cdm cC cdm cJ wf w3a vx cv vy cv cop
        cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wfun
        vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 cdm cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 crn cC cdm wss w3a wa cT
        calg wcel cD cdm cC cdm wceq cD cdm cJ cdm cD wf cD cdm cJ cdm cC wf cJ
        cdm cD cdm cJ wf w3a cR wfun cR cdm cD cdm cD cdm cxp wss cR crn cD cdm
        wss w3a wa cC cdm cJ cdm cD wf cC cdm cJ cdm cC wf cJ cdm cC cdm cJ wf
        w3a cR wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a wa cC
        cdm cJ cdm cC wf cC cdm cJ cdm cD wf cJ cdm cC cdm cJ wf w3a vx cv vy
        cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        wfun vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 cdm cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 crn cC cdm wss w3a
        wa cD cdm cC cdm wceq cD cdm cJ cdm cD wf cD cdm cJ cdm cC wf cJ cdm cD
        cdm cJ wf w3a cC cdm cJ cdm cD wf cC cdm cJ cdm cC wf cJ cdm cC cdm cJ
        wf w3a cR wfun cR cdm cD cdm cD cdm cxp wss cR crn cD cdm wss w3a cR
        wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a cD cdm cC cdm
        wceq cD cdm cJ cdm cD wf cC cdm cJ cdm cD wf cD cdm cJ cdm cC wf cC cdm
        cJ cdm cC wf cJ cdm cD cdm cJ wf cJ cdm cC cdm cJ wf cD cdm cC cdm wceq
        cD cdm cJ cdm cD wf cC cdm cJ cdm cD wf cD cdm cC cdm cJ cdm cD feq2
        biimpd cD cdm cC cdm wceq cD cdm cJ cdm cC wf cC cdm cJ cdm cC wf cD
        cdm cC cdm cJ cdm cC feq2 biimpd cD cdm cC cdm wceq cJ cdm cD cdm cJ wf
        cJ cdm cC cdm cJ wf cD cdm cC cdm cJ cdm cJ feq3 biimpd 3anim123d cD
        cdm cC cdm wceq cR wfun cR wfun cR cdm cD cdm cD cdm cxp wss cR cdm cC
        cdm cC cdm cxp wss cR crn cD cdm wss cR crn cC cdm wss cD cdm cC cdm
        wceq cR wfun idd cD cdm cC cdm wceq cD cdm cD cdm cxp cC cdm cC cdm cxp
        wceq cR cdm cD cdm cD cdm cxp wss cR cdm cC cdm cC cdm cxp wss wi cD
        cdm cC cdm wceq cD cdm cD cdm cxp cC cdm cC cdm cxp wceq cD cdm cC cdm
        cD cdm cC cdm xpeq12 anidms cD cdm cD cdm cxp cC cdm cC cdm cxp wceq cR
        cdm cD cdm cD cdm cxp wss cR cdm cC cdm cC cdm cxp wss cD cdm cD cdm
        cxp cC cdm cC cdm cxp cR cdm sseq2 biimpd syl cD cdm cC cdm wceq cR crn
        cD cdm wss cR crn cC cdm wss cD cdm cC cdm cR crn sseq2 biimpd
        3anim123d anim12d cC cdm cJ cdm cD wf cC cdm cJ cdm cC wf cJ cdm cC cdm
        cJ wf w3a cC cdm cJ cdm cC wf cC cdm cJ cdm cD wf cJ cdm cC cdm cJ wf
        w3a cR wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a vx cv vy
        cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        wfun vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 cdm cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 crn cC cdm wss w3a
        cC cdm cJ cdm cD wf cC cdm cJ cdm cC wf cJ cdm cC cdm cJ wf w3a cC cdm
        cJ cdm cC wf cC cdm cJ cdm cD wf cJ cdm cC cdm cJ wf cC cdm cJ cdm cD
        wf cC cdm cJ cdm cC wf cJ cdm cC cdm cJ wf 3simp2 cC cdm cJ cdm cD wf
        cC cdm cJ cdm cC wf cJ cdm cC cdm cJ wf 3simp1 cC cdm cJ cdm cD wf cC
        cdm cJ cdm cC wf cJ cdm cC cdm cJ wf 3simp3 3jca cR wfun cR cdm cC cdm
        cC cdm cxp wss cR crn cC cdm wss w3a vx cv vy cv cop cR cdm ccnv wcel
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wfun vx cv vy cv cop cR
        cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC
        cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 crn cC cdm wss vx cv vy cv cop cR cdm
        ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv vy cv
        cop cC cdm cC cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 wss vx cv vy cv cop cC cdm cC cdm cxp wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 wfun vx cv vy cv cop cR cdm ccnv wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 wfun cR wfun cR cdm cC cdm cC
        cdm cxp wss cR crn cC cdm wss w3a vx cv vy cv cop cR cdm ccnv wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv vy cv cop cC cdm cC
        cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 funss cR
        wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a vx cv vy cv cop
        cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx cv vy cv cop cC cdm
        cC cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz cR wfun cR cdm
        cC cdm cC cdm cxp wss cR crn cC cdm wss w3a vx cv vy cv cop cR cdm ccnv
        wcel vx cv vy cv cop cC cdm cC cdm cxp wcel vz cv vy cv vx cv cR co
        wceq cR cdm cC cdm cC cdm cxp wss cR wfun vx cv vy cv cop cR cdm ccnv
        wcel vx cv vy cv cop cC cdm cC cdm cxp wcel wi cR crn cC cdm wss cR cdm
        cC cdm cC cdm cxp wss cR cdm ccnv cC cdm cC cdm cxp ccnv wss vx cv vy
        cv cop cR cdm ccnv wcel vx cv vy cv cop cC cdm cC cdm cxp wcel wi cR
        cdm cC cdm cC cdm cxp cnvss cR cdm ccnv cC cdm cC cdm cxp ccnv wss cC
        cdm cC cdm cxp ccnv cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv
        wcel vx cv vy cv cop cC cdm cC cdm cxp wcel wi cC cdm sqpsym cR cdm
        ccnv cC cdm cC cdm cxp ccnv wss cC cdm cC cdm cxp ccnv cC cdm cC cdm
        cxp wss cR cdm ccnv cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv
        wcel vx cv vy cv cop cC cdm cC cdm cxp wcel wi cR cdm ccnv cC cdm cC
        cdm cxp ccnv cC cdm cC cdm cxp sstr2 cR cdm ccnv cC cdm cC cdm cxp vx
        cv vy cv cop ssel syl6 mpi syl 3ad2ant2 anim1d ssoprab2g vx cv vy cv
        cop cC cdm cC cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 wfun cR wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a
        vx cv vy cv cop cC cdm cC cdm cxp wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 cC cdm cC cdm cxp wfn vx cv vy cv cop cC cdm cC cdm cxp
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wfun vx vy vz cC
        cdm cC cdm vy cv vx cv cR co vx cv vy cv cop cC cdm cC cdm cxp wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cR oprex vz cv
        vy cv vx cv cR co wceq vx vy vz cC cdm cC cdm twsvbdop fnoprab2 cC cdm
        cC cdm cxp vx cv vy cv cop cC cdm cC cdm cxp wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 fnfun ax-mp a1i sylc cR cdm ccnv wrel cR
        wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a vx cv vy cv cop
        cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC
        cdm cC cdm cxp wss wi cR cdm relcnv cR wfun cR cdm cC cdm cC cdm cxp
        wss cR crn cC cdm wss w3a vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv wceq vx cv vy cv
        cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cdm cC cdm cC cdm cxp wss cR cdm ccnv wrel cR cdm cC cdm cC cdm cxp wss
        cR wfun vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq
        wa vx vy vz copab2 cdm cR cdm ccnv wceq vx cv vy cv cop cR cdm ccnv
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC cdm cC cdm
        cxp wss wi cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss cR cdm ccnv
        cC cdm cC cdm cxp ccnv wss vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv wceq vx cv vy cv
        cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cdm cC cdm cC cdm cxp wss wi cR cdm cC cdm cC cdm cxp cnvss cC cdm cC
        cdm cxp ccnv cC cdm cC cdm cxp wceq cR cdm ccnv cC cdm cC cdm cxp ccnv
        wss vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 cdm cR cdm ccnv wceq vx cv vy cv cop cR cdm ccnv wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC cdm cC cdm cxp wss
        wi wi cC cdm cC cdm cnvxp cC cdm cC cdm cxp ccnv cC cdm cC cdm cxp wceq
        cR cdm ccnv cC cdm cC cdm cxp ccnv wss cR cdm ccnv cC cdm cC cdm cxp
        wss vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 cdm cR cdm ccnv wceq vx cv vy cv cop cR cdm ccnv wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC cdm cC cdm cxp wss
        wi cC cdm cC cdm cxp ccnv cC cdm cC cdm cxp cR cdm ccnv sseq2 vx cv vy
        cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cdm cR cdm ccnv wceq cR cdm ccnv cC cdm cC cdm cxp wss vx cv vy cv cop
        cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC
        cdm cC cdm cxp wss cR cdm ccnv cC cdm cC cdm cxp wss vx cv vy cv cop cR
        cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC
        cdm cC cdm cxp wss wi cR cdm ccnv vx cv vy cv cop cR cdm ccnv wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv vx cv vy
        cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cdm wceq cR cdm ccnv cC cdm cC cdm cxp wss vx cv vy cv cop cR cdm ccnv
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC cdm cC cdm
        cxp wss cR cdm ccnv vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 cdm cC cdm cC cdm cxp sseq1 biimpd eqcoms
        com12 syl6bi ax-mp syl 3ad2ant2 vx vy vz cR cdm ccnv vy cv vx cv cR co
        cvv vy cv vx cv cR oprex dmoprabss6 syl5com ax-mp cR wfun cR cdm cC cdm
        cC cdm cxp wss cR crn cC cdm wss w3a vw cv cR cdm ccnv wcel vz cv vw cv
        csn ccnv cuni cR cfv wceq wa vw vz copab crn cC cdm vx cv vy cv cop cR
        cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 crn cR
        wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a vw cv cR cdm
        ccnv wcel vz cv vw cv csn ccnv cuni cR cfv wceq wa vw vz copab crn cR
        crn cC cdm cR wfun cR cdm cC cdm cC cdm cxp wss cR crn cC cdm wss w3a
        cR cdm ccnv cR crn vw cv cR cdm ccnv wcel vz cv vw cv csn ccnv cuni cR
        cfv wceq wa vw vz copab wf vw cv cR cdm ccnv wcel vz cv vw cv csn ccnv
        cuni cR cfv wceq wa vw vz copab crn cR crn wss cR wfun cR cdm cC cdm cC
        cdm cxp wss cR crn cC cdm wss w3a vw cv csn ccnv cuni cR cfv cR crn
        wcel vw cR cdm ccnv wral cR cdm ccnv cR crn vw cv cR cdm ccnv wcel vz
        cv vw cv csn ccnv cuni cR cfv wceq wa vw vz copab wf cR wfun cR cdm cC
        cdm cC cdm cxp wss cR crn cC cdm wss w3a vw cv csn ccnv cuni cR cfv cR
        crn wcel vw cR cdm ccnv cR wfun cR cdm cC cdm cC cdm cxp wss cR crn cC
        cdm wss vw cv cR cdm ccnv wcel vw cv csn ccnv cuni cR cfv cR crn wcel
        wi cR cdm cC cdm cC cdm cxp wss cR wfun cR crn cC cdm wss vw cv cR cdm
        ccnv wcel vw cv csn ccnv cuni cR cfv cR crn wcel wi wi cR cdm ccnv wrel
        cR cdm cC cdm cC cdm cxp wss cR wfun cR crn cC cdm wss vw cv cR cdm
        ccnv wcel vw cv csn ccnv cuni cR cfv cR crn wcel wi wi wi wi cR cdm
        relcnv cR cdm ccnv wrel vw cv cR cdm ccnv wcel cR wfun cR crn cC cdm
        wss cR cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni cR cfv cR crn wcel
        cR cdm ccnv wrel vw cv cR cdm ccnv wcel cR wfun cR crn cC cdm wss cR
        cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni cR cfv cR crn wcel wi wi
        wi cR cdm ccnv wrel vw cv cR cdm ccnv wcel vw cv cR cdm ccnv wcel cR
        wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni
        cR cfv cR crn wcel wi wi wi wi cR cdm ccnv wrel vw cv cR cdm ccnv wcel
        wa vw cv vx cv vy cv cop wceq vy wex vx wex vw cv cR cdm ccnv wcel cR
        wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni
        cR cfv cR crn wcel wi wi wi wi vx vy vw cv cR cdm ccnv elrel vw cv vx
        cv vy cv cop wceq vw cv cR cdm ccnv wcel cR wfun cR crn cC cdm wss cR
        cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni cR cfv cR crn wcel wi wi
        wi wi vx vy vw cv vx cv vy cv cop wceq vx cv vy cv cop cR cdm ccnv wcel
        cR wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vx cv vy cv cop
        csn ccnv cuni cR cfv cR crn wcel wi wi wi vw cv cR cdm ccnv wcel cR
        wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni
        cR cfv cR crn wcel wi wi wi vx cv vy cv cop cR cdm ccnv wcel vw cv vx
        cv vy cv cop wceq cR wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp
        wss vx cv vy cv cop csn ccnv cuni cR cfv cR crn wcel wi wi wi vx cv vy
        cv cop cR cdm ccnv wcel vy cv vx cv cop cR cdm wcel vw cv vx cv vy cv
        cop wceq cR wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vx cv
        vy cv cop csn ccnv cuni cR cfv cR crn wcel wi wi wi wi vx cv vy cv cR
        cdm vx visset vy visset opelcnv vy cv vx cv cop cR cdm wcel cR wfun cR
        crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vx cv vy cv cop csn ccnv
        cuni cR cfv cR crn wcel wi wi wi vw cv vx cv vy cv cop wceq vx cv vy cv
        cop csn ccnv cuni vy cv vx cv cop wceq vy cv vx cv cop cR cdm wcel cR
        wfun cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vx cv vy cv cop csn
        ccnv cuni cR cfv cR crn wcel wi wi wi wi vx cv vy cv vx visset vy
        visset opswap cR crn cC cdm wss vy cv vx cv cop cR cdm wcel cR wfun vx
        cv vy cv cop csn ccnv cuni vy cv vx cv cop wceq cR cdm cC cdm cC cdm
        cxp wss vx cv vy cv cop csn ccnv cuni cR cfv cR crn wcel wi vy cv vx cv
        cop cR cdm wcel cR wfun vx cv vy cv cop csn ccnv cuni vy cv vx cv cop
        wceq cR cdm cC cdm cC cdm cxp wss vx cv vy cv cop csn ccnv cuni cR cfv
        cR crn wcel wi wi wi wi cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss
        cR wfun vx cv vy cv cop csn ccnv cuni vy cv vx cv cop wceq vy cv vx cv
        cop cR cdm wcel vx cv vy cv cop csn ccnv cuni cR cfv cR crn wcel cR
        wfun vx cv vy cv cop csn ccnv cuni vy cv vx cv cop wceq vy cv vx cv cop
        cR cdm wcel vx cv vy cv cop csn ccnv cuni cR cfv cR crn wcel wi wi wi
        cR cdm cC cdm cC cdm cxp wss cR wfun vx cv vy cv cop csn ccnv cuni vy
        cv vx cv cop wceq vy cv vx cv cop cR cdm wcel vx cv vy cv cop csn ccnv
        cuni cR cfv cR crn wcel cR wfun vx cv vy cv cop csn ccnv cuni cR cdm
        wcel vx cv vy cv cop csn ccnv cuni cR cfv cR crn wcel cR wfun vx cv vy
        cv cop csn ccnv cuni vy cv vx cv cop wceq vy cv vx cv cop cR cdm wcel
        w3a vx cv vy cv cop csn ccnv cuni cR fvelrn cR wfun vx cv vy cv cop csn
        ccnv cuni vy cv vx cv cop wceq vy cv vx cv cop cR cdm wcel 3simp1 vx cv
        vy cv cop csn ccnv cuni vy cv vx cv cop wceq vy cv vx cv cop cR cdm
        wcel vx cv vy cv cop csn ccnv cuni cR cdm wcel cR wfun vx cv vy cv cop
        csn ccnv cuni vy cv vx cv cop wceq vy cv vx cv cop cR cdm wcel vx cv vy
        cv cop csn ccnv cuni cR cdm wcel vy cv vx cv cop cR cdm wcel vx cv vy
        cv cop csn ccnv cuni cR cdm wcel wi vy cv vx cv cop vx cv vy cv cop csn
        ccnv cuni vy cv vx cv cop vx cv vy cv cop csn ccnv cuni wceq vy cv vx
        cv cop cR cdm wcel vx cv vy cv cop csn ccnv cuni cR cdm wcel vy cv vx
        cv cop vx cv vy cv cop csn ccnv cuni cR cdm eleq1 biimpd eqcoms imp
        3adant1 sylanc 3exp a1i com14 a1i com14 ax-mp a1d sylbi com12 vw cv vx
        cv vy cv cop cR cdm ccnv eleq1 vw cv vx cv vy cv cop wceq cR crn cC cdm
        wss cR cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni cR cfv cR crn wcel
        wi wi cR crn cC cdm wss cR cdm cC cdm cC cdm cxp wss vx cv vy cv cop
        csn ccnv cuni cR cfv cR crn wcel wi wi cR wfun vw cv vx cv vy cv cop
        wceq cR cdm cC cdm cC cdm cxp wss vw cv csn ccnv cuni cR cfv cR crn
        wcel wi cR cdm cC cdm cC cdm cxp wss vx cv vy cv cop csn ccnv cuni cR
        cfv cR crn wcel wi cR crn cC cdm wss vw cv vx cv vy cv cop wceq vw cv
        csn ccnv cuni cR cfv cR crn wcel vx cv vy cv cop csn ccnv cuni cR cfv
        cR crn wcel cR cdm cC cdm cC cdm cxp wss vw cv vx cv vy cv cop wceq vw
        cv csn ccnv cuni cR cfv vx cv vy cv cop csn ccnv cuni cR cfv cR crn vw
        cv vx cv vy cv cop wceq vw cv csn ccnv cuni vx cv vy cv cop csn ccnv
        cuni cR vw cv vx cv vy cv cop wceq vw cv csn ccnv vx cv vy cv cop csn
        ccnv vw cv vx cv vy cv cop wceq vw cv csn vx cv vy cv cop csn wceq vw
        cv csn ccnv vx cv vy cv cop csn ccnv wceq vw cv vx cv vy cv cop sneq vw
        cv csn vx cv vy cv cop csn cnveq syl unieqd fveq2d eleq1d imbi2d imbi2d
        imbi2d 3imtr4d 19.23aivv syl ex pm2.43d com25 ax-mp com12 3imp
        r19.21aiv vw vz cR cdm ccnv cR crn vw cv csn ccnv cuni cR cfv vw cv cR
        cdm ccnv wcel vz cv vw cv csn ccnv cuni cR cfv wceq wa vw vz copab vw
        cv cR cdm ccnv wcel vz cv vw cv csn ccnv cuni cR cfv wceq wa vw vz
        copab eqid fopab2 sylib cR cdm ccnv cR crn vw cv cR cdm ccnv wcel vz cv
        vw cv csn ccnv cuni cR cfv wceq wa vw vz copab frn syl cR wfun cR cdm
        cC cdm cC cdm cxp wss cR crn cC cdm wss 3simp3 sstrd vx cv vy cv cop cR
        cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vw cv cR
        cdm ccnv wcel vz cv vw cv csn ccnv cuni cR cfv wceq wa vw vz copab cR
        cdm ccnv wrel vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 vw cv cR cdm ccnv wcel vz cv vw cv csn ccnv
        cuni cR cfv wceq wa vw vz copab wceq cR cdm relcnv vz cv vy cv vx cv cR
        co wceq vz cv vw cv csn ccnv cuni cR cfv wceq vx vy vz vw cR cdm ccnv
        vx cv vy cv cop vw cv wceq vz cv vy cv vx cv cop cR cfv wceq vz cv vw
        cv csn ccnv cuni cR cfv wceq vz cv vy cv vx cv cR co wceq vx cv vy cv
        cop vw cv wceq vy cv vx cv cop cR cfv vw cv csn ccnv cuni cR cfv vz cv
        vx cv vy cv cop vw cv wceq vx cv vy cv cop csn ccnv cuni cR cfv vw cv
        csn ccnv cuni cR cfv vy cv vx cv cop cR cfv vx cv vy cv cop vw cv wceq
        vx cv vy cv cop csn ccnv cuni vw cv csn ccnv cuni cR vx cv vy cv cop vw
        cv wceq vx cv vy cv cop csn ccnv vw cv csn ccnv vx cv vy cv cop vw cv
        wceq vx cv vy cv cop csn vw cv csn wceq vx cv vy cv cop csn ccnv vw cv
        csn ccnv wceq vx cv vy cv cop vw cv sneq vx cv vy cv cop csn vw cv csn
        cnveq syl unieqd fveq2d vy cv vx cv cop vx cv vy cv cop csn ccnv cuni
        cR vx cv vy cv cop csn ccnv cuni vy cv vx cv cop vx cv vy cv vx visset
        vy visset opswap eqcomi fveq2i syl5eq eqeq2d vy cv vx cv cR co vy cv vx
        cv cop cR cfv vz cv vy cv vx cv cR df-opr eqeq2i syl5bb dfoprab4spop
        ax-mp rneqi syl5ss 3jca anim12i syl6 cC cD cT dualcat2.1 dualcat2.2
        dcsda cC cD cR cT cJ cD cdm cJ cdm dualcat2.1 dualcat2.2 dualcat2.3
        dualcat2.4 cD cdm eqid cJ cdm eqid algi sylc cT calg wcel cC cvv wcel
        cD cvv wcel cJ cvv wcel w3a vx cv vy cv cop cR cdm ccnv wcel vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 cvv wcel wa cC cD cop cJ vx cv
        vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cop cop calg wcel cC cdm cJ cdm cC wf cC cdm cJ cdm cD wf cJ cdm
        cC cdm cJ wf w3a vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 wfun vx cv vy cv cop cR cdm ccnv wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cC cdm cC cdm cxp wss vx
        cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 crn cC cdm wss w3a wa wb cC cvv wcel cD cvv wcel cJ cvv wcel w3a
        vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 cvv wcel wa cT calg wcel cC cvv wcel cD cvv wcel cJ cvv wcel
        w3a vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 cvv wcel cC cvv wcel cD cvv wcel cJ cvv wcel cC cT ccod_
        cfv cvv dualcat2.2 cT ccod_ fvex eqeltri cD cT cdom_ cfv cvv dualcat2.1
        cT cdom_ fvex eqeltri cJ cT cid_ cfv cvv dualcat2.3 cT cid_ fvex
        eqeltri 3pm3.2i cR cdm ccnv cvv wcel cR cdm ccnv wrel vx cv vy cv cop
        cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv
        wcel cR cdm cR cR cT co_ cfv cvv dualcat2.4 cT co_ fvex eqeltri dmex
        cnvex cR cdm relcnv vx vy vz vy cv vx cv cR co cvv cR cdm ccnv
        oprabex2gpop mp2an pm3.2i a1i cvv cvv cD cC vx cv vy cv cop cR cdm ccnv
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv cvv cJ cC cdm
        cJ cdm cC cdm eqid cJ cdm eqid isalg syl mpbird eqeltrd $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}

    ${
      $d C a f g $. $d C f g x y z $. $d D a f g $. $d D f g x y z $. $d J a $.
      $d R f g x y z $. $d T a f g $. $d T f g x y z $.
      $( The dual of a deductive system is a deductive system. $)
      dualded $p |- (  T e. Ded ->
        <. <. C , D >. ,  <. J ,  { <. <. x ,  y >. ,  z >. |
        ( <. y , x >. e. dom R /\ z = ( y R x ) ) } >. >. e. Ded ) $=
        cT cded wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 cop cop cded wcel cC cD cop cJ vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cop
        cop calg wcel va cv cJ cfv cC cfv va cv wceq va cv cJ cfv cD cfv va cv
        wceq wa va cJ cdm wral vg cv vf cv cop vy cv vx cv cop cR cdm wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm wcel vg cv cC cfv vf
        cv cD cfv wceq wb vg cC cdm wral vf cC cdm wral w3a vg cv cC cfv vf cv
        cD cfv wceq vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 co cC cfv vf cv cC cfv wceq wi vg cC cdm
        wral vf cC cdm wral vg cv cC cfv vf cv cD cfv wceq vg cv vf cv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        cD cfv vg cv cD cfv wceq wi vg cC cdm wral vf cC cdm wral wa wa cT cded
        wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 cop cop calg wcel va cv cJ cfv cC cfv va cv
        wceq va cv cJ cfv cD cfv va cv wceq wa va cJ cdm wral vg cv vf cv cop
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cdm wcel vg cv cC cfv vf cv cD cfv wceq wb vg cC cdm wral vf cC
        cdm wral w3a vg cv cC cfv vf cv cD cfv wceq vg cv vf cv vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cC cfv
        vf cv cC cfv wceq wi vg cC cdm wral vf cC cdm wral vg cv cC cfv vf cv
        cD cfv wceq vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 co cD cfv vg cv cD cfv wceq wi vg cC cdm
        wral vf cC cdm wral cT cded wcel cC cD cop cJ vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cop cop calg wcel
        va cv cJ cfv cC cfv va cv wceq va cv cJ cfv cD cfv va cv wceq wa va cJ
        cdm wral vg cv vf cv cop vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 cdm wcel vg cv cC cfv vf cv cD cfv wceq
        wb vg cC cdm wral vf cC cdm wral cT cded wcel cT calg wcel cC cD cop cJ
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cop cop calg wcel cT dedalg vx vy vz cC cD cR cT cJ dualcat2.1
        dualcat2.2 dualcat2.3 dualcat2.4 dualalg syl cT cded wcel va cv cJ cfv
        cC cfv va cv wceq va cv cJ cfv cD cfv va cv wceq wa va cJ cdm cT cded
        wcel va cv cJ cdm wcel wa va cv cJ cfv cD cfv va cv wceq va cv cJ cfv
        cC cfv va cv wceq va cv cC cD cT cJ cJ cdm cJ cdm eqid dualcat2.1
        dualcat2.3 dualcat2.2 idosd ancomd r19.21aiva cT cded wcel vg cv vf cv
        cop vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 cdm wcel vg cv cC cfv vf cv cD cfv wceq wb vf vg cC cdm cC
        cdm cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vg cv vf cv cop
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cdm wcel vg cv cC cfv vf cv cD cfv wceq wb cT cded wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa wa vg cv vf cv cop vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm wcel vg cv vf
        cv cop cR cdm ccnv wcel vg cv cC cfv vf cv cD cfv wceq cT cded wcel vf
        cv cC cdm wcel vg cv cC cdm wcel wa wa vy cv vx cv cop cR cdm wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv vg cv vf
        cv cop cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vx cv vy
        cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cdm cR cdm ccnv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 cdm vx cv vy cv cop cR cdm ccnv wcel vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 cdm cR cdm ccnv wceq cT cded
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa cR cdm ccnv wrel vx cv
        vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cdm cR cdm ccnv wceq cR cdm relcnv vx vy vz cR cdm ccnv vy cv vx
        cv cR co cvv vy cv vx cv cR oprex dmoprabss6 ax-mp a1i vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv vy cv
        cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx cv vy cv
        cop cR cdm ccnv wcel vz cv vy cv vx cv cR co wceq wa vx vy vz vy cv vx
        cv cop cR cdm wcel vx cv vy cv cop cR cdm ccnv wcel vz cv vy cv vx cv
        cR co wceq vx cv vy cv cop cR cdm ccnv wcel vy cv vx cv cop cR cdm wcel
        vx cv vy cv cR cdm vx visset vy visset opelcnv bicomi anbi1i oprabbii
        dmeqi syl5eq eleq2d cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa
        wa vg cv vf cv cop cR cdm ccnv wcel vf cv vg cv cop cR cdm wcel vf cv
        cD cfv vg cv cC cfv wceq vg cv cC cfv vf cv cD cfv wceq vg cv vf cv cop
        cR cdm ccnv wcel vf cv vg cv cop cR cdm wcel wb cT cded wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa wa vg cv vf cv cR cdm vg visset vf visset
        opelcnv a1i vf cv cC cdm wcel vg cv cC cdm wcel wa cT cded wcel vf cv
        vg cv cop cR cdm wcel vf cv cD cfv vg cv cC cfv wceq wb vg cv cC cdm
        wcel vf cv cC cdm wcel cT cded wcel vf cv vg cv cop cR cdm wcel vf cv
        cD cfv vg cv cC cfv wceq wb wi cT cded wcel vg cv cC cdm wcel vf cv cC
        cdm wcel wa vf cv vg cv cop cR cdm wcel vf cv cD cfv vg cv cC cfv wceq
        wb cT cded wcel vg cv cC cdm wcel vf cv cC cdm wcel wa vf cv vg cv cop
        cR cdm wcel vf cv cD cfv vg cv cC cfv wceq wb wi cT cded wcel cT calg
        wcel cD cdm cC cdm wceq cT cded wcel vg cv cC cdm wcel vf cv cC cdm
        wcel wa vf cv vg cv cop cR cdm wcel vf cv cD cfv vg cv cC cfv wceq wb
        wi wi cT dedalg cC cD cT dualcat2.1 dualcat2.2 dcsda cT cded wcel vg cv
        cC cdm wcel vf cv cC cdm wcel wa vf cv vg cv cop cR cdm wcel vf cv cD
        cfv vg cv cC cfv wceq wb wi wi cC cdm cD cdm cC cdm cD cdm wceq vg cv
        cC cdm wcel vf cv cC cdm wcel wa vf cv vg cv cop cR cdm wcel vf cv cD
        cfv vg cv cC cfv wceq wb wi vg cv cD cdm wcel vf cv cD cdm wcel wa vf
        cv vg cv cop cR cdm wcel vf cv cD cfv vg cv cC cfv wceq wb wi cT cded
        wcel cC cdm cD cdm wceq vg cv cC cdm wcel vf cv cC cdm wcel wa vg cv cD
        cdm wcel vf cv cD cdm wcel wa vf cv vg cv cop cR cdm wcel vf cv cD cfv
        vg cv cC cfv wceq wb cC cdm cD cdm wceq vg cv cC cdm wcel vg cv cD cdm
        wcel vf cv cC cdm wcel vf cv cD cdm wcel cC cdm cD cdm vg cv eleq2 cC
        cdm cD cdm vf cv eleq2 anbi12d imbi1d cT cded wcel vg cv cD cdm wcel vf
        cv cD cdm wcel vf cv vg cv cop cR cdm wcel vf cv cD cfv vg cv cC cfv
        wceq wb cC cD cR cT vg cv vf cv cD cdm cD cdm eqid dualcat2.1
        dualcat2.2 dualcat2.4 cmppfd 3expib syl5bir eqcoms 3syl pm2.43i com12
        ancoms impcom vf cv cD cfv vg cv cC cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wb cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv cD
        cfv vg cv cC cfv eqcom a1i 3bitrd bitrd ex r19.21aivv 3jca cT cded wcel
        vg cv cC cfv vf cv cD cfv wceq vg cv vf cv vy cv vx cv cop cR cdm wcel
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cC cfv vf cv cC cfv
        wceq wi vf vg cC cdm cC cdm cT cded wcel vf cv cC cdm wcel vg cv cC cdm
        wcel wa vg cv cC cfv vf cv cD cfv wceq vg cv vf cv vy cv vx cv cop cR
        cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cC cfv vf
        cv cC cfv wceq cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa
        vg cv cC cfv vf cv cD cfv wceq wa vg cv vf cv vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cC cfv vf cv vg
        cv cR co cC cfv vf cv cC cfv cT cded wcel vg cv cD cdm wcel vf cv cD
        cdm wcel wa vf cv cD cfv vg cv cC cfv wceq vg cv vf cv vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cC cfv
        vf cv vg cv cR co cC cfv wceq cT cded wcel vf cv cC cdm wcel vg cv cC
        cdm wcel wa wa vg cv cC cfv vf cv cD cfv wceq wa cT cded wcel vg cv cD
        cdm wcel vf cv cD cdm wcel wa vf cv cD cfv vg cv cC cfv wceq w3a vg cv
        vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 co vf cv vg cv cR co cC vx vy vz cC cD cR cT vg cv vf cv
        dualcat2.1 dualcat2.2 dualcat2.4 dualded2lem fveq2d cT cded wcel vf cv
        cC cdm wcel vg cv cC cdm wcel wa vg cv cC cfv vf cv cD cfv wceq simpll
        cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vg cv cD cdm
        wcel vf cv cD cdm wcel wa vg cv cC cfv vf cv cD cfv wceq cT cded wcel
        vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv cD cdm wcel vg cv cD
        cdm wcel cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vf cv cD
        cdm wcel vg cv cD cdm wcel wa cT cded wcel cT calg wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa vf cv cD cdm wcel vg cv cD cdm wcel wa wb cT
        dedalg cT calg wcel vf cv cC cdm wcel vf cv cD cdm wcel vg cv cC cdm
        wcel vg cv cD cdm wcel cT calg wcel cC cdm cD cdm vf cv cT calg wcel cD
        cdm cC cdm cC cD cT dualcat2.1 dualcat2.2 dcsda eqcomd eleq2d cT calg
        wcel cC cdm cD cdm vg cv cT calg wcel cD cdm cC cdm cC cD cT dualcat2.1
        dualcat2.2 dcsda eqcomd eleq2d anbi12d syl biimpa ancomd adantr vg cv
        cC cfv vf cv cD cfv wceq vf cv cD cfv vg cv cC cfv wceq cT cded wcel vf
        cv cC cdm wcel vg cv cC cdm wcel wa wa vg cv cC cfv vf cv cD cfv wceq
        vf cv cD cfv vg cv cC cfv wceq vg cv cC cfv vf cv cD cfv eqcom biimpi
        adantl syl3anc vg cv cC cfv vf cv cD cfv wceq cT cded wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa wa vf cv vg cv cR co cC cfv vf cv cC cfv wceq
        cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv vg cv cR
        co cC cfv vf cv cC cfv wceq wi vf cv cD cfv vg cv cC cfv cT cded wcel
        vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv cD cfv vg cv cC cfv
        wceq vf cv vg cv cR co cC cfv vf cv cC cfv wceq vf cv cC cdm wcel vg cv
        cC cdm wcel wa cT cded wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv
        cR co cC cfv vf cv cC cfv wceq wi vg cv cC cdm wcel vf cv cC cdm wcel
        cT cded wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf
        cv cC cfv wceq wi wi cT cded wcel vg cv cC cdm wcel vf cv cC cdm wcel
        vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv cC cfv
        wceq wi cT cded wcel vg cv cC cdm wcel vf cv cC cdm wcel vf cv cD cfv
        vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv cC cfv wceq wi wi wi
        cT cded wcel cT calg wcel cD cdm cC cdm wceq cT cded wcel vg cv cC cdm
        wcel vf cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co
        cC cfv vf cv cC cfv wceq wi wi wi wi cT dedalg cC cD cT dualcat2.1
        dualcat2.2 dcsda cD cdm cC cdm wceq cT cded wcel vg cv cC cdm wcel vf
        cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv
        vf cv cC cfv wceq wi wi wi wi cT cded wcel vg cv cD cdm wcel vf cv cD
        cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv
        cC cfv wceq wi wi wi wi cT cded wcel vg cv cD cdm wcel vf cv cD cdm
        wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv cC
        cfv wceq wi cC cD cR cT vg cv vf cv cD cdm cD cdm eqid dualcat2.1
        dualcat2.2 dualcat2.4 codcmpd 3exp cT cded wcel vg cv cC cdm wcel vf cv
        cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf
        cv cC cfv wceq wi wi wi wi cT cded wcel vg cv cD cdm wcel vf cv cD cdm
        wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv cC
        cfv wceq wi wi wi wi wb cC cdm cD cdm cC cdm cD cdm wceq vg cv cC cdm
        wcel vf cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co
        cC cfv vf cv cC cfv wceq wi wi wi vg cv cD cdm wcel vf cv cD cdm wcel
        vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv cC cfv
        wceq wi wi wi cT cded wcel cC cdm cD cdm wceq vg cv cC cdm wcel vg cv
        cD cdm wcel vf cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg
        cv cR co cC cfv vf cv cC cfv wceq wi wi vf cv cD cdm wcel vf cv cD cfv
        vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv cC cfv wceq wi wi cC
        cdm cD cdm vg cv eleq2 cC cdm cD cdm wceq vf cv cC cdm wcel vf cv cD
        cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cC cfv vf cv
        cC cfv wceq wi cC cdm cD cdm vf cv eleq2 imbi1d imbi12d imbi2d eqcoms
        mpbiri 3syl pm2.43i com3l impcom impcom com12 eqcoms impcom eqtrd exp31
        r19.21aivv cT cded wcel vg cv cC cfv vf cv cD cfv wceq vg cv vf cv vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co cD cfv vg cv cD cfv wceq wi vf vg cC cdm cC cdm cT cded wcel
        vf cv cC cdm wcel vg cv cC cdm wcel wa vg cv cC cfv vf cv cD cfv wceq
        vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 co cD cfv vg cv cD cfv wceq cT cded wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa wa vg cv cC cfv vf cv cD cfv wceq wa vg cv vf
        cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co cD cfv vf cv vg cv cR co cD cfv vg cv cD cfv cT cded wcel vg
        cv cD cdm wcel vf cv cD cdm wcel wa vf cv cD cfv vg cv cC cfv wceq vg
        cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 co cD cfv vf cv vg cv cR co cD cfv wceq cT cded wcel vf cv
        cC cdm wcel vg cv cC cdm wcel wa wa vg cv cC cfv vf cv cD cfv wceq wa
        cT cded wcel vg cv cD cdm wcel vf cv cD cdm wcel wa vf cv cD cfv vg cv
        cC cfv wceq w3a vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 co vf cv vg cv cR co cD vx vy vz cC cD
        cR cT vg cv vf cv dualcat2.1 dualcat2.2 dualcat2.4 dualded2lem fveq2d
        cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vg cv cC cfv vf cv
        cD cfv wceq simpll cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa
        wa vg cv cD cdm wcel vf cv cD cdm wcel wa vg cv cC cfv vf cv cD cfv
        wceq cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv cD
        cdm wcel vg cv cD cdm wcel cT cded wcel vf cv cC cdm wcel vg cv cC cdm
        wcel wa vf cv cD cdm wcel vg cv cD cdm wcel wa cT cded wcel cT calg
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vf cv cD cdm wcel vg cv cD
        cdm wcel wa wb cT dedalg cT calg wcel vf cv cC cdm wcel vf cv cD cdm
        wcel vg cv cC cdm wcel vg cv cD cdm wcel cT calg wcel cC cdm cD cdm vf
        cv cT calg wcel cD cdm cC cdm cC cD cT dualcat2.1 dualcat2.2 dcsda
        eqcomd eleq2d cT calg wcel cC cdm cD cdm vg cv cT calg wcel cD cdm cC
        cdm cC cD cT dualcat2.1 dualcat2.2 dcsda eqcomd eleq2d anbi12d syl
        biimpa ancomd adantr vg cv cC cfv vf cv cD cfv wceq vf cv cD cfv vg cv
        cC cfv wceq cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vg
        cv cC cfv vf cv cD cfv wceq vf cv cD cfv vg cv cC cfv wceq vg cv cC cfv
        vf cv cD cfv eqcom biimpi adantl syl3anc vg cv cC cfv vf cv cD cfv wceq
        cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv vg cv cR
        co cD cfv vg cv cD cfv wceq cT cded wcel vf cv cC cdm wcel vg cv cC cdm
        wcel wa wa vf cv vg cv cR co cD cfv vg cv cD cfv wceq wi vf cv cD cfv
        vg cv cC cfv cT cded wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf
        cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cD cfv vg cv cD cfv wceq
        vf cv cC cdm wcel vg cv cC cdm wcel wa cT cded wcel vf cv cD cfv vg cv
        cC cfv wceq vf cv vg cv cR co cD cfv vg cv cD cfv wceq wi vg cv cC cdm
        wcel vf cv cC cdm wcel cT cded wcel vf cv cD cfv vg cv cC cfv wceq vf
        cv vg cv cR co cD cfv vg cv cD cfv wceq wi wi cT cded wcel vg cv cC cdm
        wcel vf cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co
        cD cfv vg cv cD cfv wceq wi cT cded wcel vg cv cC cdm wcel vf cv cC cdm
        wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cD cfv vg cv cD
        cfv wceq wi wi wi cT cded wcel cT calg wcel cD cdm cC cdm wceq cT cded
        wcel vg cv cC cdm wcel vf cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq
        vf cv vg cv cR co cD cfv vg cv cD cfv wceq wi wi wi wi cT dedalg cC cD
        cT dualcat2.1 dualcat2.2 dcsda cD cdm cC cdm wceq vg cv cC cdm wcel vf
        cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cD cfv
        vg cv cD cfv wceq wi wi wi vg cv cD cdm wcel vf cv cD cdm wcel vf cv cD
        cfv vg cv cC cfv wceq vf cv vg cv cR co cD cfv vg cv cD cfv wceq wi wi
        wi cT cded wcel cD cdm cC cdm wceq vg cv cC cdm wcel vg cv cD cdm wcel
        vf cv cC cdm wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cD
        cfv vg cv cD cfv wceq wi wi vf cv cD cdm wcel vf cv cD cfv vg cv cC cfv
        wceq vf cv vg cv cR co cD cfv vg cv cD cfv wceq wi wi cD cdm cC cdm
        wceq cC cdm cD cdm vg cv cC cdm cD cdm wceq cC cdm cD cdm cC cdm cD cdm
        wceq id eqcoms eleq2d cD cdm cC cdm wceq vf cv cC cdm wcel vf cv cD cdm
        wcel vf cv cD cfv vg cv cC cfv wceq vf cv vg cv cR co cD cfv vg cv cD
        cfv wceq wi cD cdm cC cdm wceq cC cdm cD cdm vf cv cC cdm cD cdm wceq
        cC cdm cD cdm cC cdm cD cdm wceq id eqcoms eleq2d imbi1d imbi12d cT
        cded wcel vg cv cD cdm wcel vf cv cD cdm wcel vf cv cD cfv vg cv cC cfv
        wceq vf cv vg cv cR co cD cfv vg cv cD cfv wceq wi cC cD cR cT vg cv vf
        cv cD cdm cD cdm eqid dualcat2.1 dualcat2.2 dualcat2.4 domcmpd 3exp
        syl5bir 3syl pm2.43i com3l impcom impcom com12 eqcoms impcom eqtrd
        exp31 r19.21aivv jca32 cC cvv wcel cD cvv wcel cJ cvv wcel w3a vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv
        wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 cop cop cded wcel cC cD cop cJ vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cop cop
        calg wcel va cv cJ cfv cC cfv va cv wceq va cv cJ cfv cD cfv va cv wceq
        wa va cJ cdm wral vg cv vf cv cop vy cv vx cv cop cR cdm wcel vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 cdm wcel vg cv cC cfv vf cv cD
        cfv wceq wb vg cC cdm wral vf cC cdm wral w3a vg cv cC cfv vf cv cD cfv
        wceq vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 co cC cfv vf cv cC cfv wceq wi vg cC cdm wral
        vf cC cdm wral vg cv cC cfv vf cv cD cfv wceq vg cv vf cv vy cv vx cv
        cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co cD
        cfv vg cv cD cfv wceq wi vg cC cdm wral vf cC cdm wral wa wa wb cT cded
        wcel cvv cvv cD cC vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 vf vg cvv cvv cJ cC cdm cJ cdm va cC cdm eqid
        cJ cdm eqid isded cC cvv wcel cD cvv wcel cJ cvv wcel w3a cT ccod_ cfv
        cvv wcel cT cdom_ cfv cvv wcel cT cid_ cfv cvv wcel w3a cT ccod_ cfv
        cvv wcel cT cdom_ cfv cvv wcel cT cid_ cfv cvv wcel cT ccod_ fvex cT
        cdom_ fvex cT cid_ fvex 3pm3.2i cC cvv wcel cT ccod_ cfv cvv wcel cD
        cvv wcel cT cdom_ cfv cvv wcel cJ cvv wcel cT cid_ cfv cvv wcel cC cT
        ccod_ cfv cvv dualcat2.2 eleq1i cD cT cdom_ cfv cvv dualcat2.1 eleq1i
        cJ cT cid_ cfv cvv dualcat2.3 eleq1i 3anbi123i mpbir vy cv vx cv cop cR
        cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv
        cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 wss vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 cvv wcel vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 cvv wcel cT cded wcel vy cv
        vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 cvv ssexg cT cded wcel vy cv vx cv cop cR cdm wcel vz
        cv vy cv vx cv cR co wceq wa vy cv vx cv cop cD cdm cD cdm cxp wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz cT cded wcel vy cv vx cv cop cR
        cdm wcel vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
        wceq cT cded wcel cR cdm cD cdm cD cdm cxp vy cv vx cv cop cT cded wcel
        cR wfun cR cdm cD cdm cD cdm cxp wss cR crn cD cdm wss cT cded wcel cT
        calg wcel cR wfun cR cdm cD cdm cD cdm cxp wss cR crn cD cdm wss w3a cT
        dedalg cD cR cT cD cdm cD cdm eqid dualcat2.1 dualcat2.4 cmppfa syl
        3simp2d sseld anim1d ssoprab2g vy cv vx cv cop cD cdm cD cdm cxp wcel
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vx cv vy cv cop cD cdm
        cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv vy
        cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx
        cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz vy cv vx cv cop cD cdm cD cdm cxp wcel vx cv vy cv cop cD cdm cD
        cdm cxp wcel vz cv vy cv vx cv cR co wceq vy cv vx cv cop cD cdm cD cdm
        cxp wcel vx cv vy cv cop cD cdm cD cdm cxp ccnv wcel vx cv vy cv cop cD
        cdm cD cdm cxp wcel vx cv vy cv cD cdm cD cdm cxp vx visset vy visset
        opelcnv cD cdm cD cdm cxp ccnv cD cdm cD cdm cxp vx cv vy cv cop cD cdm
        cD cdm cnvxp eleq2i bitr3i anbi1i oprabbii cD cdm cD cdm cxp cvv wcel
        cD cdm cD cdm cxp wrel vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 cvv wcel cD cdm cD cdm cD cD cT
        cdom_ cfv cvv dualcat2.1 cT cdom_ fvex eqeltri dmex cD cD cT cdom_ cfv
        cvv dualcat2.1 cT cdom_ fvex eqeltri dmex xpex cD cdm cD cdm relxp vx
        vy vz vy cv vx cv cR co cvv cD cdm cD cdm cxp oprabex2gpop mp2an
        eqeltri sylancl sylancr mpbird $.
        $( [18-Apr-2010] $) $( [18-Apr-2010] $)
    $}

    ${
      $d C a f g h x y z $. $d D a f g h x y z $. $d J a f x y z $.
      $d R a f g h x y z $. $d T a f g h x y z $.
      $( The dual of a category is a category. Joy of cats 3.5 $)
      dualcat2 $p |- ( T e. Cat ->
      <. <. C , D >. , <. J , { <. <. x , y >. , z >. |
          ( <. y , x >. e. dom R  /\ z = ( y R x ) ) }  >. >. e. Cat ) $=
        cT ccat wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 cop cop ccat wcel cC cD cop cJ vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cop
        cop cded wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR cdm wcel vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vg cv vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co wceq wi vh cC cdm wral vg cC cdm wral vf cC cdm wral wa vf cv
        cD cfv va cv wceq va cv cJ cfv vf cv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv wceq wi vf cC cdm
        wral va cJ cdm wral vf cv cC cfv va cv wceq vf cv va cv cJ cfv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        vf cv wceq wi vf cC cdm wral va cJ cdm wral wa wa cT ccat wcel cC cD
        cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 cop cop cded wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC
        cfv vf cv cD cfv wceq wa vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR
        cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vg cv
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 co wceq wi vh cC cdm wral vg cC cdm wral vf cC
        cdm wral vf cv cD cfv va cv wceq va cv cJ cfv vf cv vy cv vx cv cop cR
        cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv wceq
        wi vf cC cdm wral va cJ cdm wral vf cv cC cfv va cv wceq vf cv va cv cJ
        cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 co vf cv wceq wi vf cC cdm wral va cJ cdm wral wa cT ccat
        wcel cT cded wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 cop cop cded wcel cT catded vx vy
        vz cC cD cR cT cJ dualcat2.1 dualcat2.2 dualcat2.3 dualcat2.4 dualded
        syl cT ccat wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD
        cfv wceq wa vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR cdm wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vg cv vy cv vx cv
        cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf
        cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co wceq wi vh cC cdm wral vf vg cC cdm cC cdm cT ccat wcel vf cv
        cC cdm wcel vg cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv
        cC cfv vf cv cD cfv wceq wa vh cv vg cv vf cv vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vg
        cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 co wceq wi vh cC cdm wral cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa wa vh cv cC cfv vg cv cD cfv wceq vg cv
        cC cfv vf cv cD cfv wceq wa vh cv vg cv vf cv vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vg
        cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 co wceq wi vh cC cdm cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel vh cv cC cfv vg cv cD
        cfv wceq vg cv cC cfv vf cv cD cfv wceq wa vh cv vg cv vf cv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vh cv vg cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 co vf cv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vh cv cC cfv vg
        cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa wa vf cv vg cv vh cv
        cR co cR co vf cv vg cv cR co vh cv cR co vh cv vg cv vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel vh cv cC cfv vg cv cD
        cfv wceq vg cv cC cfv vf cv cD cfv wceq wa vf cv vg cv vh cv cR co cR
        co vf cv vg cv cR co vh cv cR co wceq cT ccat wcel vf cv cC cdm wcel vg
        cv cC cdm wcel vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv
        cC cfv vf cv cD cfv wceq wa vf cv vg cv vh cv cR co cR co vf cv vg cv
        cR co vh cv cR co wceq wi wi cT ccat wcel vh cv cC cdm wcel vg cv cC
        cdm wcel vf cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv
        vf cv cD cfv wceq wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh
        cv cR co wceq wi cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel vf cv
        cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co
        wceq wi vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq
        wa cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel vf cv cC cdm wcel
        w3a wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co wceq
        vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq cT ccat
        wcel vh cv cC cdm wcel vg cv cC cdm wcel vf cv cC cdm wcel w3a wa vf cv
        vg cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co wceq wi vg cv cC
        cfv vf cv cD cfv wceq cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel
        vf cv cC cdm wcel w3a wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR
        co vh cv cR co wceq wi wi vg cv cD cfv vh cv cC cfv vg cv cC cfv vf cv
        cD cfv wceq vg cv cD cfv vh cv cC cfv wceq cT ccat wcel vh cv cC cdm
        wcel vg cv cC cdm wcel vf cv cC cdm wcel w3a wa vf cv vg cv vh cv cR co
        cR co vf cv vg cv cR co vh cv cR co wceq wi vg cv cD cfv vh cv cC cfv
        wceq cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel vf cv cC cdm wcel
        w3a wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co wceq
        wi wi vf cv cD cfv vg cv cC cfv vf cv cD cfv vg cv cC cfv wceq vg cv cD
        cfv vh cv cC cfv wceq cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel
        vf cv cC cdm wcel w3a wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR
        co vh cv cR co wceq wi cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel
        vf cv cC cdm wcel w3a wa vf cv cD cfv vg cv cC cfv wceq vg cv cD cfv vh
        cv cC cfv wceq wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh cv
        cR co wceq cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel vf cv cC
        cdm wcel w3a vf cv cD cfv vg cv cC cfv wceq vg cv cD cfv vh cv cC cfv
        wceq wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co
        wceq wi cT ccat wcel vh cv cC cdm wcel vg cv cC cdm wcel vf cv cC cdm
        wcel w3a vf cv cD cfv vg cv cC cfv wceq vg cv cD cfv vh cv cC cfv wceq
        wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co wceq wi
        wi cT ccat wcel cT cded wcel cT calg wcel cT ccat wcel vh cv cC cdm
        wcel vg cv cC cdm wcel vf cv cC cdm wcel w3a vf cv cD cfv vg cv cC cfv
        wceq vg cv cD cfv vh cv cC cfv wceq wa vf cv vg cv vh cv cR co cR co vf
        cv vg cv cR co vh cv cR co wceq wi wi wi cT catded cT dedalg cT calg
        wcel cD cdm cC cdm wceq cT ccat wcel vh cv cC cdm wcel vg cv cC cdm
        wcel vf cv cC cdm wcel w3a vf cv cD cfv vg cv cC cfv wceq vg cv cD cfv
        vh cv cC cfv wceq wa vf cv vg cv vh cv cR co cR co vf cv vg cv cR co vh
        cv cR co wceq wi wi wi cC cD cT dualcat2.1 dualcat2.2 dcsda cD cdm cC
        cdm wceq vh cv cC cdm wcel vg cv cC cdm wcel vf cv cC cdm wcel w3a vh
        cv cD cdm wcel vg cv cD cdm wcel vf cv cD cdm wcel w3a cT ccat wcel vf
        cv cD cfv vg cv cC cfv wceq vg cv cD cfv vh cv cC cfv wceq wa vf cv vg
        cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co wceq wi cD cdm cC
        cdm wceq vh cv cD cdm wcel vg cv cD cdm wcel vf cv cD cdm wcel w3a vh
        cv cC cdm wcel vg cv cC cdm wcel vf cv cC cdm wcel w3a cD cdm cC cdm
        wceq vh cv cD cdm wcel vh cv cC cdm wcel vg cv cD cdm wcel vg cv cC cdm
        wcel vf cv cD cdm wcel vf cv cC cdm wcel cD cdm cC cdm vh cv eleq2 cD
        cdm cC cdm vg cv eleq2 cD cdm cC cdm vf cv eleq2 3anbi123d biimprd cT
        ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel vf cv cD cdm wcel w3a vf
        cv cD cfv vg cv cC cfv wceq vg cv cD cfv vh cv cC cfv wceq wa vf cv vg
        cv vh cv cR co cR co vf cv vg cv cR co vh cv cR co wceq wi cC cD cR cT
        vh cv vg cv vf cv cD cdm cD cdm eqid dualcat2.1 dualcat2.2 dualcat2.4
        cmpasso ex syl9 syl 3syl pm2.43i imp com12 ex eqcoms com12 eqcoms imp
        com12 3exp2 com24 imp32 imp31 cT ccat wcel vf cv cC cdm wcel vg cv cC
        cdm wcel wa wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg
        cv cC cfv vf cv cD cfv wceq wa wa vh cv vg cv vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vg cv vh cv cR
        co wceq vh cv vg cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 co vf cv vy cv vx cv cop cR cdm wcel vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vg cv vh cv cR co cR co
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC
        cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa wa cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv cD
        cfv vh cv cC cfv wceq w3a vh cv vg cv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vg cv vh cv cR co wceq cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel vh
        cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cT ccat
        wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv cD cfv vh cv cC cfv
        wceq w3a cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC
        cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq
        wa cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv cD cfv vh
        cv cC cfv wceq w3a wi wi wi cT ccat wcel cT cded wcel cT calg wcel cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel vh
        cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cT ccat
        wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv cD cfv vh cv cC cfv
        wceq w3a wi wi wi wi cT catded cT dedalg cT calg wcel cD cdm cC cdm
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm
        wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa
        cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv cD cfv vh cv
        cC cfv wceq w3a wi wi wi wi cC cD cT dualcat2.1 dualcat2.2 dcsda cD cdm
        cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv
        cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv cD
        cfv vh cv cC cfv wceq w3a wi wi cD cdm cC cdm wceq cT ccat wcel vf cv
        cC cdm wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vh cv cC cfv vg
        cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cT ccat wcel vh cv cD
        cdm wcel vg cv cD cdm wcel wa vg cv cD cfv vh cv cC cfv wceq w3a cD cdm
        cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh
        cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa w3a cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vg cv
        cD cfv vh cv cC cfv wceq cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel cT ccat wcel vh cv cC
        cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cD cdm cC cdm
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa 3simp2
        3ad2ant1 cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm
        wcel wa w3a vh cv cC cdm wcel vh cv cD cdm wcel vg cv cD cdm wcel wa vh
        cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cD cdm cC
        cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh cv
        cC cdm wcel vh cv cD cdm wcel vg cv cD cdm wcel wa cD cdm cC cdm wceq
        vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel vh cv cD cdm
        wcel vg cv cD cdm wcel wa wi cT ccat wcel vf cv cC cdm wcel vg cv cC
        cdm wcel wa cD cdm cC cdm wceq vh cv cC cdm wcel vh cv cD cdm wcel vg
        cv cD cdm wcel wa wi vg cv cC cdm wcel cD cdm cC cdm wceq vh cv cC cdm
        wcel vh cv cD cdm wcel vg cv cD cdm wcel wa wi wi vf cv cC cdm wcel vh
        cv cC cdm wcel vg cv cC cdm wcel cD cdm cC cdm wceq vh cv cD cdm wcel
        vg cv cD cdm wcel wa vh cv cC cdm wcel vg cv cC cdm wcel cD cdm cC cdm
        wceq vh cv cD cdm wcel vg cv cD cdm wcel wa wi cD cdm cC cdm wceq vh cv
        cC cdm wcel vg cv cC cdm wcel wa vh cv cD cdm wcel vg cv cD cdm wcel wa
        vh cv cC cdm wcel vg cv cC cdm wcel wa vh cv cD cdm wcel vg cv cD cdm
        wcel wa wb cC cdm cD cdm cC cdm cD cdm wceq vh cv cC cdm wcel vh cv cD
        cdm wcel vg cv cC cdm wcel vg cv cD cdm wcel cC cdm cD cdm vh cv eleq2
        cC cdm cD cdm vg cv eleq2 anbi12d eqcoms biimpcd ex com3l adantl impcom
        3adant2 imp 3adant3 vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv
        cD cfv wceq wa cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv
        cC cdm wcel wa w3a vg cv cD cfv vh cv cC cfv wceq vh cv cC cdm wcel vh
        cv cC cfv vg cv cD cfv wceq vg cv cD cfv vh cv cC cfv wceq vg cv cC cfv
        vf cv cD cfv wceq vh cv cC cfv vg cv cD cfv wceq vg cv cD cfv vh cv cC
        cfv wceq vh cv cC cfv vg cv cD cfv eqcom biimpi adantr 3ad2ant3 3jca
        3exp 3exp syl 3syl pm2.43i imp41 vx vy vz cC cD cR cT vh cv vg cv
        dualcat2.1 dualcat2.2 dualcat2.4 dualcat2lem syl vh cv vg cv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        vg cv vh cv cR co wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel
        wa wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv
        vf cv cD cfv wceq wa wa vh cv vg cv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vy cv vx cv cop cR
        cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vg cv vh cv
        cR co vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 co vf cv vg cv vh cv cR co cR co vh cv vg cv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        vg cv vh cv cR co vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 opreq1 cT ccat wcel vg cv vh cv cR co cD
        cdm wcel vf cv cD cdm wcel wa vf cv cD cfv vg cv vh cv cR co cC cfv
        wceq vg cv vh cv cR co vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 co vf cv vg cv vh cv cR co cR co wceq
        cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm
        wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq
        wa wa vx vy vz cC cD cR cT vg cv vh cv cR co vf cv dualcat2.1
        dualcat2.2 dualcat2.4 dualcat2lem cT ccat wcel vf cv cC cdm wcel vg cv
        cC cdm wcel wa vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv
        cC cfv vf cv cD cfv wceq wa simplll cT ccat wcel vf cv cC cdm wcel vg
        cv cC cdm wcel wa vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg
        cv cC cfv vf cv cD cfv wceq wa vg cv vh cv cR co cD cdm wcel vf cv cD
        cdm wcel wa cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv
        cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa vg cv vh cv cR co cD cdm wcel vf cv cD cdm wcel wa wi wi wi cT
        ccat wcel cT cded wcel cT calg wcel cT ccat wcel vf cv cC cdm wcel vg
        cv cC cdm wcel wa vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg
        cv cC cfv vf cv cD cfv wceq wa vg cv vh cv cR co cD cdm wcel vf cv cD
        cdm wcel wa wi wi wi wi cT catded cT dedalg cT calg wcel cD cdm cC cdm
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm
        wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa
        vg cv vh cv cR co cD cdm wcel vf cv cD cdm wcel wa wi wi wi wi cC cD cT
        dualcat2.1 dualcat2.2 dcsda cD cdm cC cdm wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel vh cv cC cfv vg cv cD
        cfv wceq vg cv cC cfv vf cv cD cfv wceq wa vg cv vh cv cR co cD cdm
        wcel vf cv cD cdm wcel wa wi wi cD cdm cC cdm wceq cT ccat wcel vf cv
        cC cdm wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vh cv cC cfv vg
        cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa vg cv vh cv cR co cD
        cdm wcel vf cv cD cdm wcel wa cD cdm cC cdm wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vh cv cC cfv vg cv
        cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa w3a vg cv vh cv cR co cD
        cdm wcel vf cv cD cdm wcel cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vh cv cC cfv vg cv cD
        cfv wceq vg cv cC cfv vf cv cD cfv wceq wa vg cv vh cv cR co cD cdm
        wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa
        vh cv cC cdm wcel cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg
        cv cC cdm wcel wa w3a vg cv vh cv cR co cD cdm wcel vh cv cC cfv vg cv
        cD cfv wceq vh cv cC cdm wcel cD cdm cC cdm wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa w3a vg cv vh cv cR co cD cdm wcel wi wi
        vg cv cC cfv vf cv cD cfv wceq vh cv cC cdm wcel cD cdm cC cdm wceq cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vg cv vh cv cR co
        cD cdm wcel wi wi vg cv cD cfv vh cv cC cfv cD cdm cC cdm wceq cT ccat
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vg cv
        cD cfv vh cv cC cfv wceq vg cv vh cv cR co cD cdm wcel cD cdm cC cdm
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh cv cC
        cdm wcel cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel w3a vg cv cD
        cfv vh cv cC cfv wceq vg cv vh cv cR co cD cdm wcel wi cD cdm cC cdm
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh cv cC
        cdm wcel cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel w3a cD cdm cC
        cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh cv
        cC cdm wcel wa cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel cD cdm
        cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv
        cC cdm wcel 3simpl2 cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm wcel
        vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vh cv cD cdm wcel cD cdm cC
        cdm wceq cT ccat wcel vh cv cC cdm wcel vh cv cD cdm wcel wi vf cv cC
        cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel vh cv cD cdm wcel wi cC
        cdm cD cdm cC cdm cD cdm wceq vh cv cC cdm wcel vh cv cD cdm wcel cC
        cdm cD cdm vh cv eleq2 biimpd eqcoms 3ad2ant1 imp cD cdm cC cdm wceq cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vg cv cD cdm wcel
        vh cv cC cdm wcel cD cdm cC cdm wceq vf cv cC cdm wcel vg cv cC cdm
        wcel wa vg cv cD cdm wcel cT ccat wcel vf cv cC cdm wcel vg cv cC cdm
        wcel wa cD cdm cC cdm wceq vg cv cD cdm wcel vg cv cC cdm wcel cD cdm
        cC cdm wceq vg cv cD cdm wcel wi vf cv cC cdm wcel cD cdm cC cdm wceq
        vg cv cC cdm wcel vg cv cD cdm wcel vg cv cC cdm wcel vg cv cD cdm wcel
        wi cC cdm cD cdm cC cdm cD cdm wceq vg cv cC cdm wcel vg cv cD cdm wcel
        cC cdm cD cdm vg cv eleq2 biimpd eqcoms com12 adantl impcom 3adant2
        adantr 3jca ex cC cD cR cT vh cv vg cv cD cdm cD cT cdom_ cfv
        dualcat2.1 dmeqi dualcat2.1 dualcat2.2 dualcat2.4 cmpmorp syl6 com13
        eqcoms adantr com13 3imp cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel vf cv cD cdm wcel vh cv
        cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cD cdm cC
        cdm wceq vf cv cC cdm wcel vg cv cC cdm wcel wa vf cv cD cdm wcel cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa cD cdm cC cdm wceq vf
        cv cD cdm wcel vf cv cC cdm wcel cD cdm cC cdm wceq vf cv cD cdm wcel
        wi vg cv cC cdm wcel cD cdm cC cdm wceq vf cv cC cdm wcel vf cv cD cdm
        wcel vf cv cC cdm wcel vf cv cD cdm wcel wi cC cdm cD cdm cC cdm cD cdm
        wceq vf cv cC cdm wcel vf cv cD cdm wcel cC cdm cD cdm vf cv eleq2
        biimpd eqcoms com12 adantr impcom 3adant2 3ad2ant1 jca 3exp 3exp syl
        3syl pm2.43i imp41 cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa
        wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf
        cv cD cfv wceq wa wa vf cv cD cfv vg cv cC cfv vg cv vh cv cR co cC cfv
        vg cv cC cfv vf cv cD cfv wceq vf cv cD cfv vg cv cC cfv wceq cT ccat
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vh
        cv cC cfv vg cv cD cfv wceq vf cv cD cfv vg cv cC cfv wceq vf cv cD cfv
        vg cv cC cfv vf cv cD cfv vg cv cC cfv wceq id eqcoms ad2antll vh cv cC
        cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cT ccat wcel vf
        cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vg cv vh cv
        cR co cC cfv vg cv cC cfv wceq vh cv cC cfv vg cv cD cfv wceq cT ccat
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vg
        cv vh cv cR co cC cfv vg cv cC cfv wceq wi vg cv cC cfv vf cv cD cfv
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC
        cdm wcel wa vg cv vh cv cR co cC cfv vg cv cC cfv wceq wi vg cv cD cfv
        vh cv cC cfv cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh
        cv cC cdm wcel wa vg cv cD cfv vh cv cC cfv wceq vg cv vh cv cR co cC
        cfv vg cv cC cfv wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel
        wa wa vh cv cC cdm wcel wa cT ccat wcel vh cv cD cdm wcel vg cv cD cdm
        wcel w3a vg cv cD cfv vh cv cC cfv wceq vg cv vh cv cR co cC cfv vg cv
        cC cfv wceq wi cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh
        cv cC cdm wcel cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel w3a cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel cT
        ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel w3a wi wi cT ccat wcel cT
        cded wcel cT calg wcel cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel
        wa vh cv cC cdm wcel cT ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel
        w3a wi wi wi cT catded cT dedalg cT calg wcel cD cdm cC cdm wceq cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel cT
        ccat wcel vh cv cD cdm wcel vg cv cD cdm wcel w3a wi wi wi cC cD cT
        dualcat2.1 dualcat2.2 dcsda cD cdm cC cdm wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel cT ccat wcel vh cv cD
        cdm wcel vg cv cD cdm wcel w3a cD cdm cC cdm wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa w3a vh cv cC cdm wcel wa cT ccat wcel vh
        cv cD cdm wcel vg cv cD cdm wcel cD cdm cC cdm wceq cT ccat wcel vf cv
        cC cdm wcel vg cv cC cdm wcel wa vh cv cC cdm wcel 3simpl2 cD cdm cC
        cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa w3a vh cv
        cC cdm wcel vh cv cD cdm wcel cD cdm cC cdm wceq cT ccat wcel vh cv cC
        cdm wcel vh cv cD cdm wcel wb vf cv cC cdm wcel vg cv cC cdm wcel wa vh
        cv cC cdm wcel vh cv cD cdm wcel wb cC cdm cD cdm cC cdm cD cdm vh cv
        eleq2 eqcoms 3ad2ant1 biimpa cD cdm cC cdm wceq cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa w3a vg cv cD cdm wcel vh cv cC cdm wcel
        cD cdm cC cdm wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa
        vg cv cD cdm wcel cD cdm cC cdm wceq vf cv cC cdm wcel vg cv cC cdm
        wcel wa vg cv cD cdm wcel wi cT ccat wcel cD cdm cC cdm wceq vg cv cC
        cdm wcel vg cv cD cdm wcel vf cv cC cdm wcel vg cv cC cdm wcel vg cv cD
        cdm wcel wi cC cdm cD cdm cC cdm cD cdm wceq vg cv cC cdm wcel vg cv cD
        cdm wcel cC cdm cD cdm vg cv eleq2 biimpd eqcoms adantld a1d 3imp
        adantr 3jca 3exp1 syl 3syl pm2.43i imp31 cC cD cR cT vh cv vg cv cD cdm
        cD cdm eqid dualcat2.1 dualcat2.2 dualcat2.4 codcmpc syl com12 eqcoms
        adantr impcom eqtr4d syl3anc sylan9eqr mpdan cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD
        cfv wceq vg cv cC cfv vf cv cD cfv wceq wa wa vg cv vf cv vy cv vx cv
        cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf
        cv vg cv cR co wceq vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vg cv cR
        co vh cv cR co wceq cT ccat wcel vg cv cD cdm wcel vf cv cD cdm wcel wa
        vf cv cD cfv vg cv cC cfv wceq vg cv vf cv vy cv vx cv cop cR cdm wcel
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vg cv cR co
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC
        cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa wa vx vy vz cC cD cR cT vg cv vf cv dualcat2.1 dualcat2.2
        dualcat2.4 dualcat2lem cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel
        wa vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv
        cD cfv wceq wa simplll cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel
        wa wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv
        vf cv cD cfv wceq wa wa vg cv cD cdm wcel vf cv cD cdm wcel cT ccat
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vg cv cD cdm wcel vh cv
        cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa vf cv cC cdm wcel vg cv cC cdm wcel wa cT ccat wcel vg cv cD
        cdm wcel vg cv cC cdm wcel cT ccat wcel vg cv cD cdm wcel wi vf cv cC
        cdm wcel cT ccat wcel vg cv cC cdm wcel vg cv cD cdm wcel cT ccat wcel
        cT cded wcel cT calg wcel vg cv cC cdm wcel vg cv cD cdm wcel wb cT
        catded cT dedalg cT calg wcel cC cdm cD cdm vg cv cT calg wcel cD cdm
        cC cdm cC cD cT dualcat2.1 dualcat2.2 dcsda eqcomd eleq2d 3syl biimpcd
        adantl impcom ad2antrr cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel
        wa wa vf cv cD cdm wcel vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv
        wceq vg cv cC cfv vf cv cD cfv wceq wa vf cv cC cdm wcel vg cv cC cdm
        wcel wa cT ccat wcel vf cv cD cdm wcel vf cv cC cdm wcel cT ccat wcel
        vf cv cD cdm wcel wi vg cv cC cdm wcel cT ccat wcel vf cv cC cdm wcel
        vf cv cD cdm wcel cT ccat wcel cC cdm cD cdm vf cv cT ccat wcel cT cded
        wcel cT calg wcel cC cdm cD cdm wceq cT catded cT dedalg cT calg wcel
        cD cdm cC cdm cC cD cT dualcat2.1 dualcat2.2 dcsda eqcomd 3syl eleq2d
        biimpcd adantr impcom ad2antrr jca vg cv cC cfv vf cv cD cfv wceq vf cv
        cD cfv vg cv cC cfv wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm
        wcel wa wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC
        cfv vf cv cD cfv wceq vf cv cD cfv vg cv cC cfv wceq vg cv cC cfv vf cv
        cD cfv eqcom biimpi ad2antll syl3anc vg cv vf cv vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vg cv cR
        co wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC
        cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa wa vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vf cv vg cv cR co vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vf cv vg cv cR co vh cv cR co vg cv vf cv vy cv vx cv cop cR
        cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv vg cv
        cR co vh cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 opreq2 cT ccat wcel vh cv cD cdm wcel vf cv vg cv cR co
        cD cdm wcel wa vf cv vg cv cR co cD cfv vh cv cC cfv wceq vh cv vf cv
        vg cv cR co vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 co vf cv vg cv cR co vh cv cR co wceq cT ccat wcel vf
        cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vh cv cC
        cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq wa wa vx vy vz cC
        cD cR cT vh cv vf cv vg cv cR co dualcat2.1 dualcat2.2 dualcat2.4
        dualcat2lem cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa vh cv
        cC cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv
        wceq wa simplll cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa
        vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv
        cD cfv wceq wa wa vh cv cD cdm wcel vf cv vg cv cR co cD cdm wcel cT
        ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel
        wa vh cv cD cdm wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv
        cD cfv wceq wa cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa
        vh cv cC cdm wcel vh cv cD cdm wcel cT ccat wcel vh cv cC cdm wcel vh
        cv cD cdm wcel wi vf cv cC cdm wcel vg cv cC cdm wcel wa cT ccat wcel
        vh cv cC cdm wcel vh cv cD cdm wcel cT ccat wcel cC cdm cD cdm vh cv cT
        ccat wcel cT cded wcel cT calg wcel cC cdm cD cdm wceq cT catded cT
        dedalg cT calg wcel cD cdm cC cdm cC cD cT dualcat2.1 dualcat2.2 dcsda
        eqcomd 3syl eleq2d biimpd adantr imp adantr cT ccat wcel vg cv cD cdm
        wcel vf cv cD cdm wcel w3a vf cv cD cfv vg cv cC cfv wceq vf cv vg cv
        cR co cD cdm wcel cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa
        wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf
        cv cD cfv wceq wa wa cC cD cR cT vg cv vf cv cD cdm cD cT cdom_ cfv
        dualcat2.1 dmeqi dualcat2.1 dualcat2.2 dualcat2.4 cmpmorp cT ccat wcel
        vf cv cC cdm wcel vg cv cC cdm wcel wa wa cT ccat wcel vg cv cD cdm
        wcel vf cv cD cdm wcel w3a vh cv cC cdm wcel vh cv cC cfv vg cv cD cfv
        wceq vg cv cC cfv vf cv cD cfv wceq wa cT ccat wcel vf cv cC cdm wcel
        vg cv cC cdm wcel wa wa cT ccat wcel vg cv cD cdm wcel vf cv cD cdm
        wcel cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa pm3.26 vf cv
        cC cdm wcel vg cv cC cdm wcel wa cT ccat wcel vg cv cD cdm wcel vg cv
        cC cdm wcel cT ccat wcel vg cv cD cdm wcel wi vf cv cC cdm wcel cT ccat
        wcel vg cv cC cdm wcel vg cv cD cdm wcel cT ccat wcel cT cded wcel cT
        calg wcel vg cv cC cdm wcel vg cv cD cdm wcel wb cT catded cT dedalg cT
        calg wcel cC cdm cD cdm vg cv cT calg wcel cD cdm cC cdm cC cD cT
        dualcat2.1 dualcat2.2 dcsda eqcomd eleq2d 3syl biimpcd adantl impcom vf
        cv cC cdm wcel vg cv cC cdm wcel wa cT ccat wcel vf cv cD cdm wcel vf
        cv cC cdm wcel cT ccat wcel vf cv cD cdm wcel wi vg cv cC cdm wcel cT
        ccat wcel vf cv cC cdm wcel vf cv cD cdm wcel cT ccat wcel cC cdm cD
        cdm vf cv cT ccat wcel cT cded wcel cT calg wcel cC cdm cD cdm wceq cT
        catded cT dedalg cT calg wcel cD cdm cC cdm cC cD cT dualcat2.1
        dualcat2.2 dcsda eqcomd 3syl eleq2d biimpcd adantr impcom 3jca ad2antrr
        vg cv cC cfv vf cv cD cfv wceq vf cv cD cfv vg cv cC cfv wceq cT ccat
        wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vh
        cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vf cv cD cfv
        vg cv cC cfv wceq vg cv cC cfv vf cv cD cfv eqcom biimpi ad2antll sylc
        jca cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm
        wcel wa vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq
        wa wa vf cv vg cv cR co cD cfv vg cv cD cfv vh cv cC cfv cT ccat wcel
        vg cv cD cdm wcel vf cv cD cdm wcel w3a vf cv cD cfv vg cv cC cfv wceq
        vf cv vg cv cR co cD cfv vg cv cD cfv wceq cT ccat wcel vf cv cC cdm
        wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa vh cv cC cfv vg cv cD
        cfv wceq vg cv cC cfv vf cv cD cfv wceq wa cT ccat wcel vg cv cD cdm
        wcel vf cv cD cdm wcel w3a vf cv cD cfv vg cv cC cfv wceq vf cv vg cv
        cR co cD cfv vg cv cD cfv wceq cC cD cR cT vg cv vf cv cD cdm cD cdm
        eqid dualcat2.1 dualcat2.2 dualcat2.4 domcmpc imp cT ccat wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa wa vh cv cC cdm wcel wa cT ccat wcel vg
        cv cD cdm wcel vf cv cD cdm wcel cT ccat wcel vf cv cC cdm wcel vg cv
        cC cdm wcel wa vh cv cC cdm wcel simpll cT ccat wcel vf cv cC cdm wcel
        vg cv cC cdm wcel wa wa vg cv cD cdm wcel vh cv cC cdm wcel vf cv cC
        cdm wcel vg cv cC cdm wcel wa cT ccat wcel vg cv cD cdm wcel vg cv cC
        cdm wcel cT ccat wcel vg cv cD cdm wcel wi vf cv cC cdm wcel cT ccat
        wcel vg cv cC cdm wcel vg cv cD cdm wcel cT ccat wcel cT cded wcel cT
        calg wcel vg cv cC cdm wcel vg cv cD cdm wcel wb cT catded cT dedalg cT
        calg wcel cC cdm cD cdm vg cv cT calg wcel cD cdm cC cdm cC cD cT
        dualcat2.1 dualcat2.2 dcsda eqcomd eleq2d 3syl biimpcd adantl impcom
        adantr cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vf cv cD
        cdm wcel vh cv cC cdm wcel vf cv cC cdm wcel vg cv cC cdm wcel wa cT
        ccat wcel vf cv cD cdm wcel vf cv cC cdm wcel cT ccat wcel vf cv cD cdm
        wcel wi vg cv cC cdm wcel cT ccat wcel vf cv cC cdm wcel vf cv cD cdm
        wcel cT ccat wcel cC cdm cD cdm vf cv cT ccat wcel cT cded wcel cT calg
        wcel cC cdm cD cdm wceq cT catded cT dedalg cT calg wcel cD cdm cC cdm
        cC cD cT dualcat2.1 dualcat2.2 dcsda eqcomd 3syl eleq2d biimpcd adantr
        impcom adantr 3jca vg cv cC cfv vf cv cD cfv wceq vf cv cD cfv vg cv cC
        cfv wceq vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq
        vf cv cD cfv vg cv cC cfv wceq vg cv cC cfv vf cv cD cfv eqcom biimpi
        adantl syl2an vh cv cC cfv vg cv cD cfv wceq vg cv cD cfv vh cv cC cfv
        wceq cT ccat wcel vf cv cC cdm wcel vg cv cC cdm wcel wa wa vh cv cC
        cdm wcel wa vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vg cv cD cfv
        wceq vg cv cD cfv vh cv cC cfv wceq vh cv cC cfv vg cv cD cfv eqcom
        biimpi ad2antrl eqtrd syl3anc sylan9eqr mpdan 3eqtr4rd exp31 r19.21aiv
        ex r19.21aivv cT ccat wcel vf cv cD cfv va cv wceq va cv cJ cfv vf cv
        vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vf cv wceq wi vf cC cdm wral va cJ cdm wral vf cv cC cfv va
        cv wceq vf cv va cv cJ cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 co vf cv wceq wi vf cC cdm wral va cJ
        cdm wral cT ccat wcel vf cv cD cfv va cv wceq va cv cJ cfv vf cv vy cv
        vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        co vf cv wceq wi va vf cJ cdm cC cdm cT ccat wcel va cv cJ cdm wcel vf
        cv cC cdm wcel wa vf cv cD cfv va cv wceq va cv cJ cfv vf cv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        vf cv wceq cT ccat wcel va cv cJ cdm wcel vf cv cC cdm wcel wa wa vf cv
        cD cfv va cv wceq wa va cv cJ cfv vf cv vy cv vx cv cop cR cdm wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv va cv cJ cfv cR
        co vf cv cT ccat wcel va cv cJ cfv cD cdm wcel vf cv cD cdm wcel wa vf
        cv cD cfv va cv cJ cfv cC cfv wceq va cv cJ cfv vf cv vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv va
        cv cJ cfv cR co wceq cT ccat wcel va cv cJ cdm wcel vf cv cC cdm wcel
        wa wa vf cv cD cfv va cv wceq wa vx vy vz cC cD cR cT va cv cJ cfv vf
        cv dualcat2.1 dualcat2.2 dualcat2.4 dualcat2lem cT ccat wcel va cv cJ
        cdm wcel vf cv cC cdm wcel wa vf cv cD cfv va cv wceq simpll cT ccat
        wcel va cv cJ cdm wcel vf cv cC cdm wcel wa wa vf cv cD cfv va cv wceq
        wa va cv cJ cfv cD cdm wcel vf cv cD cdm wcel cT ccat wcel va cv cJ cdm
        wcel vf cv cC cdm wcel wa wa va cv cJ cfv cD cdm wcel vf cv cD cfv va
        cv wceq cT ccat wcel va cv cJ cdm wcel va cv cJ cfv cD cdm wcel vf cv
        cC cdm wcel va cv cT cJ cD cdm cJ cdm cD cT cdom_ cfv dualcat2.1 dmeqi
        cJ cT cid_ cfv dualcat2.3 dmeqi dualcat2.3 jdmo adantrr adantr cT ccat
        wcel va cv cJ cdm wcel vf cv cC cdm wcel wa wa vf cv cD cdm wcel vf cv
        cD cfv va cv wceq va cv cJ cdm wcel vf cv cC cdm wcel wa cT ccat wcel
        vf cv cD cdm wcel vf cv cC cdm wcel cT ccat wcel vf cv cD cdm wcel wi
        va cv cJ cdm wcel cT ccat wcel vf cv cC cdm wcel vf cv cD cdm wcel cT
        ccat wcel cC cdm cD cdm vf cv cT ccat wcel cT cded wcel cT calg wcel cC
        cdm cD cdm wceq cT catded cT dedalg cT calg wcel cD cdm cC cdm cC cD cT
        dualcat2.1 dualcat2.2 dcsda eqcomd 3syl eleq2d biimpcd adantl impcom
        adantr jca cT ccat wcel va cv cJ cdm wcel vf cv cC cdm wcel wa wa vf cv
        cD cfv va cv wceq wa vf cv cD cfv va cv va cv cJ cfv cC cfv cT ccat
        wcel va cv cJ cdm wcel vf cv cC cdm wcel wa wa vf cv cD cfv va cv wceq
        pm3.27 cT ccat wcel va cv cJ cdm wcel vf cv cC cdm wcel wa wa vf cv cD
        cfv va cv wceq wa va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va
        cv wceq cT ccat wcel va cv cJ cdm wcel va cv cJ cfv cD cfv va cv wceq
        va cv cJ cfv cC cfv va cv wceq wa cT ccat wcel va cv cJ cdm wcel vf cv
        cC cdm wcel wa wa vf cv cD cfv va cv wceq wa va cv cC cD cT cJ cJ cdm
        cJ cdm eqid dualcat2.1 dualcat2.3 dualcat2.2 idosc cT ccat wcel va cv
        cJ cdm wcel vf cv cC cdm wcel wa vf cv cD cfv va cv wceq simpll cT ccat
        wcel va cv cJ cdm wcel vf cv cC cdm wcel vf cv cD cfv va cv wceq
        simplrl sylanc pm3.27d eqtr4d syl3anc cT ccat wcel va cv cJ cdm wcel vf
        cv cC cdm wcel wa wa vf cv cD cfv va cv wceq vf cv va cv cJ cfv cR co
        vf cv wceq cT ccat wcel va cv cJ cdm wcel vf cv cD cdm wcel vf cv cD
        cfv va cv wceq vf cv va cv cJ cfv cR co vf cv wceq wi cT ccat wcel va
        cv cJ cdm wcel vf cv cC cdm wcel wa wa va cv cD cR cT vf cv cJ cD cdm
        cJ cdm cD cdm eqid dualcat2.1 cJ cdm eqid dualcat2.3 dualcat2.4 cmpidb
        cT ccat wcel va cv cJ cdm wcel vf cv cC cdm wcel wa pm3.26 cT ccat wcel
        va cv cJ cdm wcel vf cv cC cdm wcel simprl va cv cJ cdm wcel vf cv cC
        cdm wcel wa cT ccat wcel vf cv cD cdm wcel vf cv cC cdm wcel cT ccat
        wcel vf cv cD cdm wcel wi va cv cJ cdm wcel cT ccat wcel vf cv cC cdm
        wcel vf cv cD cdm wcel cT ccat wcel cC cdm cD cdm vf cv cT ccat wcel cD
        cdm cC cdm cT ccat wcel cT calg wcel cD cdm cC cdm wceq cT ccat wcel cT
        cded wcel cT calg wcel cT catded cT dedalg syl cC cD cT dualcat2.1
        dualcat2.2 dcsda syl eqcomd eleq2d biimpcd adantl impcom syl3anc imp
        eqtrd exp31 r19.21aivv cT ccat wcel vf cv cC cfv va cv wceq vf cv va cv
        cJ cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 co vf cv wceq wi va vf cJ cdm cC cdm cT ccat wcel va cv cJ
        cdm wcel vf cv cC cdm wcel wa vf cv cC cfv va cv wceq vf cv va cv cJ
        cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 co vf cv wceq wi wi va cv cJ cdm wcel vf cv cD cdm wcel wa vf
        cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi wi cT ccat
        wcel va cv cJ cdm wcel vf cv cD cdm wcel vf cv cC cfv va cv wceq va cv
        cJ cfv vf cv cR co vf cv wceq wi va cv cC cD cR cT vf cv cJ cD cdm cJ
        cdm cD cdm eqid dualcat2.1 cJ cdm eqid dualcat2.3 dualcat2.4 dualcat2.2
        cmpida 3expib cT ccat wcel va cv cJ cdm wcel vf cv cC cdm wcel wa vf cv
        cC cfv va cv wceq vf cv va cv cJ cfv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv wceq wi wi va cv cJ
        cdm wcel vf cv cD cdm wcel wa vf cv cC cfv va cv wceq vf cv va cv cJ
        cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 co vf cv wceq wi wi va cv cJ cdm wcel vf cv cD cdm wcel wa vf
        cv cC cfv va cv wceq va cv cJ cfv vf cv cR co vf cv wceq wi wi cT ccat
        wcel va cv cJ cdm wcel vf cv cC cdm wcel wa va cv cJ cdm wcel vf cv cD
        cdm wcel wa vf cv cC cfv va cv wceq vf cv va cv cJ cfv vy cv vx cv cop
        cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv
        wceq wi cT ccat wcel vf cv cC cdm wcel vf cv cD cdm wcel va cv cJ cdm
        wcel cT ccat wcel cC cdm cD cdm vf cv cT ccat wcel cT cded wcel cT calg
        wcel cC cdm cD cdm wceq cT catded cT dedalg cT calg wcel cD cdm cC cdm
        cC cD cT dualcat2.1 dualcat2.2 dcsda eqcomd 3syl eleq2d anbi2d imbi1d
        cT ccat wcel va cv cJ cdm wcel vf cv cD cdm wcel wa vf cv cC cfv va cv
        wceq vf cv va cv cJ cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv
        cR co wceq wa vx vy vz copab2 co vf cv wceq wi vf cv cC cfv va cv wceq
        va cv cJ cfv vf cv cR co vf cv wceq wi cT ccat wcel va cv cJ cdm wcel
        vf cv cD cdm wcel wa wa vf cv cC cfv va cv wceq vf cv va cv cJ cfv vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co vf cv wceq va cv cJ cfv vf cv cR co vf cv wceq cT ccat wcel
        va cv cJ cdm wcel vf cv cD cdm wcel wa wa vf cv cC cfv va cv wceq wa vf
        cv va cv cJ cfv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 co va cv cJ cfv vf cv cR co vf cv cT ccat wcel
        vf cv cD cdm wcel va cv cJ cfv cD cdm wcel wa va cv cJ cfv cD cfv vf cv
        cC cfv wceq vf cv va cv cJ cfv vy cv vx cv cop cR cdm wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 co va cv cJ cfv vf cv cR co wceq cT
        ccat wcel va cv cJ cdm wcel vf cv cD cdm wcel wa wa vf cv cC cfv va cv
        wceq wa vx vy vz cC cD cR cT vf cv va cv cJ cfv dualcat2.1 dualcat2.2
        dualcat2.4 dualcat2lem cT ccat wcel va cv cJ cdm wcel vf cv cD cdm wcel
        wa vf cv cC cfv va cv wceq simpll cT ccat wcel va cv cJ cdm wcel vf cv
        cD cdm wcel wa wa vf cv cC cfv va cv wceq wa vf cv cD cdm wcel va cv cJ
        cfv cD cdm wcel cT ccat wcel va cv cJ cdm wcel vf cv cD cdm wcel vf cv
        cC cfv va cv wceq simplrr cT ccat wcel va cv cJ cdm wcel vf cv cD cdm
        wcel wa wa va cv cJ cfv cD cdm wcel vf cv cC cfv va cv wceq cT ccat
        wcel va cv cJ cdm wcel va cv cJ cfv cD cdm wcel vf cv cD cdm wcel va cv
        cT cJ cD cdm cJ cdm cD cT cdom_ cfv dualcat2.1 dmeqi cJ cT cid_ cfv
        dualcat2.3 dmeqi dualcat2.3 jdmo adantrr adantr jca va cv cJ cfv cD cfv
        va cv wceq vf cv cC cfv va cv wceq va cv cJ cfv cD cfv vf cv cC cfv
        wceq cT ccat wcel va cv cJ cdm wcel vf cv cD cdm wcel wa wa va cv cJ
        cfv cD cfv vf cv cC cfv va cv eqtr3 cT ccat wcel va cv cJ cdm wcel va
        cv cJ cfv cD cfv va cv wceq vf cv cD cdm wcel cT ccat wcel va cv cJ cdm
        wcel wa va cv cJ cfv cD cfv va cv wceq va cv cJ cfv cC cfv va cv wceq
        va cv cC cD cT cJ cJ cdm cJ cdm eqid dualcat2.1 dualcat2.3 dualcat2.2
        idosc pm3.26d adantrr sylan syl3anc eqeq1d pm5.74da pm5.74da bitrd
        mpbird r19.21aivv jca jca31 cC cvv wcel cD cvv wcel cJ cvv wcel w3a vy
        cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cvv wcel cC cD cop cJ vy cv vx cv cop cR cdm wcel vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 cop cop ccat wcel cC cD cop cJ vy cv
        vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2
        cop cop cded wcel vh cv cC cfv vg cv cD cfv wceq vg cv cC cfv vf cv cD
        cfv wceq wa vh cv vg cv vf cv vy cv vx cv cop cR cdm wcel vz cv vy cv
        vx cv cR co wceq wa vx vy vz copab2 co vy cv vx cv cop cR cdm wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vh cv vg cv vy cv vx cv
        cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co vf
        cv vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 co wceq wi vh cC cdm wral vg cC cdm wral vf cC cdm wral wa vf cv
        cD cfv va cv wceq va cv cJ cfv vf cv vy cv vx cv cop cR cdm wcel vz cv
        vy cv vx cv cR co wceq wa vx vy vz copab2 co vf cv wceq wi vf cC cdm
        wral va cJ cdm wral vf cv cC cfv va cv wceq vf cv va cv cJ cfv vy cv vx
        cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 co
        vf cv wceq wi vf cC cdm wral va cJ cdm wral wa wa wb cT ccat wcel cvv
        cvv cD cC vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co wceq wa
        vx vy vz copab2 vf vg vh cvv cvv cJ cC cdm cJ cdm va cC cdm eqid cJ cdm
        eqid iscat cC cvv wcel cD cvv wcel cJ cvv wcel w3a cT ccod_ cfv cvv
        wcel cT cdom_ cfv cvv wcel cT cid_ cfv cvv wcel w3a cT ccod_ cfv cvv
        wcel cT cdom_ cfv cvv wcel cT cid_ cfv cvv wcel cT ccod_ fvex cT cdom_
        fvex cT cid_ fvex 3pm3.2i cC cvv wcel cT ccod_ cfv cvv wcel cD cvv wcel
        cT cdom_ cfv cvv wcel cJ cvv wcel cT cid_ cfv cvv wcel cC cT ccod_ cfv
        cvv dualcat2.2 eleq1i cD cT cdom_ cfv cvv dualcat2.1 eleq1i cJ cT cid_
        cfv cvv dualcat2.3 eleq1i 3anbi123i mpbir vy cv vx cv cop cR cdm wcel
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cop cD cdm
        cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 wss vy
        cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx
        vy vz copab2 cvv wcel vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 cvv wcel cT ccat wcel vy cv vx cv cop cR cdm
        wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 vy cv vx cv cop cD
        cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv
        ssexg cT ccat wcel vy cv vx cv cop cR cdm wcel vz cv vy cv vx cv cR co
        wceq wa vy cv vx cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz cT ccat wcel vy cv vx cv cop cR cdm wcel vy cv vx cv
        cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq cT ccat wcel cR
        cdm cD cdm cD cdm cxp vy cv vx cv cop cT ccat wcel cR wfun cR cdm cD
        cdm cD cdm cxp wss cR crn cD cdm wss cD cR cT cD cdm cD cdm eqid
        dualcat2.1 dualcat2.4 cmppfc 3simp2d sseld anim1d ssoprab2g vy cv vx cv
        cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 cvv wcel vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx
        cv cR co wceq wa vx vy vz copab2 cvv wcel vx vy vz cD cdm cD cdm vy cv
        vx cv cR co vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 cD cdm cT cdom_ cfv cdm cvv cD cT cdom_ cfv
        dualcat2.1 dmeqi cT cdom_ cfv cT cdom_ fvex dmex eqeltri cD cdm cT
        cdom_ cfv cdm cvv cD cT cdom_ cfv dualcat2.1 dmeqi cT cdom_ cfv cT
        cdom_ fvex dmex eqeltri vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy
        cv vx cv cR co wceq wa vx vy vz copab2 eqid oprabex2 vy cv vx cv cop cD
        cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv
        wcel vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 cvv wcel vx cv cD cdm wcel vy cv cD cdm wcel wa
        vz cv vy cv vx cv cR co wceq wa vx vy vz copab2 cvv wcel vy cv vx cv
        cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy vz
        copab2 vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
        wceq wa vx vy vz copab2 cvv vy cv vx cv cop cD cdm cD cdm cxp wcel vz
        cv vy cv vx cv cR co wceq wa vx cv vy cv cop cD cdm cD cdm cxp wcel vz
        cv vy cv vx cv cR co wceq wa vx vy vz vy cv vx cv cop cD cdm cD cdm cxp
        wcel vx cv vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co
        wceq vy cv vx cv cop cD cdm cD cdm cxp wcel vy cv vx cv cop cD cdm cD
        cdm cxp ccnv wcel vx cv vy cv cop cD cdm cD cdm cxp wcel cD cdm cD cdm
        cxp cD cdm cD cdm cxp ccnv vy cv vx cv cop cD cdm cD cdm cxp ccnv cD
        cdm cD cdm cxp cD cdm cD cdm cnvxp eqcomi eleq2i vy cv vx cv cD cdm cD
        cdm cxp vy visset vx visset opelcnv bitri anbi1i oprabbii eleq1i vx cv
        vy cv cop cD cdm cD cdm cxp wcel vz cv vy cv vx cv cR co wceq wa vx vy
        vz copab2 vx cv cD cdm wcel vy cv cD cdm wcel wa vz cv vy cv vx cv cR
        co wceq wa vx vy vz copab2 cvv vz cv vy cv vx cv cR co wceq vx vy vz cD
        cdm cD cdm twsvbdop eleq1i bitri mpbir sylancl sylancr mpbird $.
        $( [18-Apr-2010] $) $( [4-Apr-2010] $)
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Homsets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c hom $.

  $( Extend class notation with the function returning all the morphisms
     between two objects. $)
  chom $a class hom $.

  ${
    $d x y a b c f $.
    $( ` ( hom `` x ) ` is a function which returns for each pair of objects `
       <. a , b >. ` the morphisms whose domain is ` a ` and codomain ` b ` .
       JFM CAT_1 def. 6 $)
    df-hom $a |- hom = { <. x , y >. | ( x e. Cat /\
     y = { <. <. a , b >. , c >. | ( a e. dom ( id_ ` x ) /\
       b e. dom ( id_ ` x ) /\
       c = { f | ( f e. dom ( dom_ ` x ) /\ ( ( dom_ ` x ) ` f ) = a /\
                   ( ( cod_ ` x ) ` f ) = b ) } ) } ) } $.
  $}

  ${ $d C c x y $.  $d D c x y $.  $d M c x y $.
     $d O x y $.  $d T a b c f x y $.
    ishoma.1 $e |- O = dom ( id_ ` T ) $.
    ishoma.2 $e |- M = dom ( dom_ ` T ) $.
    ishoma.3 $e |- D = ( dom_ ` T ) $.
    ishoma.4 $e |- C = ( cod_ ` T ) $.
    $( Definition of ` ( hom `` T ) ` . $)
    ishoma $p |- ( T e. Cat ->  ( hom ` T ) = { <. <. a , b >. , c >. |
      ( a e. O /\ b e. O /\ c = { f | ( f e. M /\ ( D ` f ) = a /\
      ( C ` f ) = b ) } ) } ) $=
      vx vy cT va cv vx cv cid_ cfv cdm wcel vb cv vx cv cid_ cfv cdm wcel vc
      cv vf cv vx cv cdom_ cfv cdm wcel vf cv vx cv cdom_ cfv cfv va cv wceq vf
      cv vx cv ccod_ cfv cfv vb cv wceq w3a vf cab wceq w3a va vb vc copab2 va
      cv cO wcel vb cv cO wcel vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf
      cv cC cfv vb cv wceq w3a vf cab wceq w3a va vb vc copab2 ccat chom vx cv
      cT wceq va cv vx cv cid_ cfv cdm wcel vb cv vx cv cid_ cfv cdm wcel vc cv
      vf cv vx cv cdom_ cfv cdm wcel vf cv vx cv cdom_ cfv cfv va cv wceq vf cv
      vx cv ccod_ cfv cfv vb cv wceq w3a vf cab wceq w3a va cv cO wcel vb cv cO
      wcel vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf cv cC cfv vb cv wceq
      w3a vf cab wceq w3a va vb vc vx cv cT wceq va cv vx cv cid_ cfv cdm wcel
      va cv cO wcel vb cv vx cv cid_ cfv cdm wcel vb cv cO wcel vc cv vf cv vx
      cv cdom_ cfv cdm wcel vf cv vx cv cdom_ cfv cfv va cv wceq vf cv vx cv
      ccod_ cfv cfv vb cv wceq w3a vf cab wceq vc cv vf cv cM wcel vf cv cD cfv
      va cv wceq vf cv cC cfv vb cv wceq w3a vf cab wceq vx cv cT wceq vx cv
      cid_ cfv cdm cO va cv vx cv cT wceq vx cv cid_ cfv cdm cT cid_ cfv cdm cO
      vx cv cT wceq vx cv cid_ cfv cT cid_ cfv vx cv cT cid_ fveq2 dmeqd
      ishoma.1 syl6eqr eleq2d vx cv cT wceq vx cv cid_ cfv cdm cO vb cv vx cv
      cT wceq vx cv cid_ cfv cdm cT cid_ cfv cdm cO vx cv cT wceq vx cv cid_
      cfv cT cid_ cfv vx cv cT cid_ fveq2 dmeqd ishoma.1 syl6eqr eleq2d vx cv
      cT wceq vf cv vx cv cdom_ cfv cdm wcel vf cv vx cv cdom_ cfv cfv va cv
      wceq vf cv vx cv ccod_ cfv cfv vb cv wceq w3a vf cab vf cv cM wcel vf cv
      cD cfv va cv wceq vf cv cC cfv vb cv wceq w3a vf cab vc cv vx cv cT wceq
      vf cv vx cv cdom_ cfv cdm wcel vf cv vx cv cdom_ cfv cfv va cv wceq vf cv
      vx cv ccod_ cfv cfv vb cv wceq w3a vf cv cM wcel vf cv cD cfv va cv wceq
      vf cv cC cfv vb cv wceq w3a vf vx cv cT wceq vf cv vx cv cdom_ cfv cdm
      wcel vf cv cM wcel vf cv vx cv cdom_ cfv cfv va cv wceq vf cv cD cfv va
      cv wceq vf cv vx cv ccod_ cfv cfv vb cv wceq vf cv cC cfv vb cv wceq vx
      cv cT wceq vx cv cdom_ cfv cdm cM vf cv vx cv cT wceq vx cv cdom_ cfv cdm
      cT cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT
      cdom_ fveq2 dmeqd ishoma.2 syl6eqr eleq2d vx cv cT wceq vf cv vx cv cdom_
      cfv cfv vf cv cD cfv va cv vx cv cT wceq vf cv vx cv cdom_ cfv cD vx cv
      cT wceq vx cv cdom_ cfv cT cdom_ cfv cD vx cv cT cdom_ fveq2 ishoma.3
      syl6eqr fveq1d eqeq1d vx cv cT wceq vf cv vx cv ccod_ cfv cfv vf cv cC
      cfv vb cv vx cv cT wceq vf cv vx cv ccod_ cfv cC vx cv cT wceq vx cv
      ccod_ cfv cT ccod_ cfv cC vx cv cT ccod_ fveq2 ishoma.4 syl6eqr fveq1d
      eqeq1d 3anbi123d abbidv eqeq2d 3anbi123d oprabbidv vx vy vf va vb vc
      df-hom va vb vc cT cid_ cfv cdm cT cid_ cfv cdm vf cv cM wcel vf cv cD
      cfv va cv wceq vf cv cC cfv vb cv wceq w3a vf cab va cv cO wcel vb cv cO
      wcel vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf cv cC cfv vb cv wceq
      w3a vf cab wceq w3a va vb vc copab2 cT cid_ cfv cT cid_ fvex dmex cT cid_
      cfv cT cid_ fvex dmex va cv cO wcel vb cv cO wcel vc cv vf cv cM wcel vf
      cv cD cfv va cv wceq vf cv cC cfv vb cv wceq w3a vf cab wceq w3a va cv cT
      cid_ cfv cdm wcel vb cv cT cid_ cfv cdm wcel wa vc cv vf cv cM wcel vf cv
      cD cfv va cv wceq vf cv cC cfv vb cv wceq w3a vf cab wceq wa va vb vc va
      cv cO wcel vb cv cO wcel vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf
      cv cC cfv vb cv wceq w3a vf cab wceq w3a va cv cT cid_ cfv cdm wcel vb cv
      cT cid_ cfv cdm wcel vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf cv cC
      cfv vb cv wceq w3a vf cab wceq w3a va cv cT cid_ cfv cdm wcel vb cv cT
      cid_ cfv cdm wcel wa vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf cv cC
      cfv vb cv wceq w3a vf cab wceq wa va cv cO wcel va cv cT cid_ cfv cdm
      wcel vb cv cO wcel vb cv cT cid_ cfv cdm wcel vc cv vf cv cM wcel vf cv
      cD cfv va cv wceq vf cv cC cfv vb cv wceq w3a vf cab wceq vc cv vf cv cM
      wcel vf cv cD cfv va cv wceq vf cv cC cfv vb cv wceq w3a vf cab wceq cO
      cT cid_ cfv cdm va cv ishoma.1 eleq2i cO cT cid_ cfv cdm vb cv ishoma.1
      eleq2i vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf cv cC cfv vb cv
      wceq w3a vf cab wceq biid 3anbi123i va cv cT cid_ cfv cdm wcel vb cv cT
      cid_ cfv cdm wcel vc cv vf cv cM wcel vf cv cD cfv va cv wceq vf cv cC
      cfv vb cv wceq w3a vf cab wceq df-3an bitri oprabbii oprabex2 fvopab4 $.
      $( [19-May-2007] $) $( [6-May-2007] $)
  $}

  ${ $d A f x y z $.  $d B f x y z $.  $d C x y z $.
     $d D x y z $.  $d M f x y z $.  $d O x y z $.
     $d T f x y z $.
    ishomb.1 $e |- O = dom ( id_ ` T ) $.
    ishomb.2 $e |- M = dom ( dom_ ` T ) $.
    ishomb.3 $e |- D = ( dom_ ` T ) $.
    ishomb.4 $e |- C = ( cod_ ` T ) $.
    ishomb.5 $e |- H = ( hom ` T ) $.
    ishomb.6 $e |- T e. Cat $.
    $( The homset ` ( ( hom `` T ) `` <. A , B >. ) ` . $)
    ishomb $p |- ( ( A e. O /\ B e. O ) ->
      ( H ` <. A , B >. ) = { f | ( f e. M /\ ( D ` f ) = A /\
      ( C ` f ) = B ) } ) $=
      cA cO wcel cB cO wcel wa cA cB cH co vf cv cM wcel vf cv cD cfv cA wceq
      vf cv cC cfv cB wceq w3a vf cab cA cB cop cH cfv vx vy vz cA cB cO cO vf
      cv cM wcel vf cv cD cfv vx cv wceq vf cv cC cfv vy cv wceq w3a vf cab vf
      cv cM wcel vf cv cD cfv cA wceq vf cv cC cfv cB wceq w3a vf cab cH vf cv
      cM wcel vf cv cD cfv cA wceq vf cv cC cfv vy cv wceq w3a vf cab vf cv cM
      wcel vf cv cD cfv cA wceq vf cv cC cfv cB wceq w3a vf cab vf cv cM wcel
      vf cv cD cfv cA wceq vf cv cC cfv cB wceq wa wa vf cab cvv vf cv cM wcel
      vf cv cD cfv cA wceq vf cv cC cfv cB wceq w3a vf cv cM wcel vf cv cD cfv
      cA wceq vf cv cC cfv cB wceq wa wa vf vf cv cM wcel vf cv cD cfv cA wceq
      vf cv cC cfv cB wceq 3anass abbii vf cv cD cfv cA wceq vf cv cC cfv cB
      wceq wa vf cM cM cT cdom_ cfv cdm cvv ishomb.2 cT cdom_ cfv cT cdom_ fvex
      dmex eqeltri zfausab eqeltri vx cv cA wceq vf cv cM wcel vf cv cD cfv vx
      cv wceq vf cv cC cfv vy cv wceq w3a vf cv cM wcel vf cv cD cfv cA wceq vf
      cv cC cfv vy cv wceq w3a vf vx cv cA wceq vf cv cD cfv vx cv wceq vf cv
      cD cfv cA wceq vf cv cM wcel vf cv cC cfv vy cv wceq vx cv cA vf cv cD
      cfv eqeq2 3anbi2d abbidv vy cv cB wceq vf cv cM wcel vf cv cD cfv cA wceq
      vf cv cC cfv vy cv wceq w3a vf cv cM wcel vf cv cD cfv cA wceq vf cv cC
      cfv cB wceq w3a vf vy cv cB wceq vf cv cC cfv vy cv wceq vf cv cC cfv cB
      wceq vf cv cM wcel vf cv cD cfv cA wceq vy cv cB vf cv cC cfv eqeq2
      3anbi3d abbidv cH cT chom cfv vx cv cO wcel vy cv cO wcel wa vz cv vf cv
      cM wcel vf cv cD cfv vx cv wceq vf cv cC cfv vy cv wceq w3a vf cab wceq
      wa vx vy vz copab2 ishomb.5 cT ccat wcel cT chom cfv vx cv cO wcel vy cv
      cO wcel wa vz cv vf cv cM wcel vf cv cD cfv vx cv wceq vf cv cC cfv vy cv
      wceq w3a vf cab wceq wa vx vy vz copab2 wceq ishomb.6 cT ccat wcel cT
      chom cfv vx cv cO wcel vy cv cO wcel vz cv vf cv cM wcel vf cv cD cfv vx
      cv wceq vf cv cC cfv vy cv wceq w3a vf cab wceq w3a vx vy vz copab2 vx cv
      cO wcel vy cv cO wcel wa vz cv vf cv cM wcel vf cv cD cfv vx cv wceq vf
      cv cC cfv vy cv wceq w3a vf cab wceq wa vx vy vz copab2 cC cD cT vf cM cO
      vx vy vz ishomb.1 ishomb.2 ishomb.3 ishomb.4 ishoma cT ccat wcel vx cv cO
      wcel vy cv cO wcel vz cv vf cv cM wcel vf cv cD cfv vx cv wceq vf cv cC
      cfv vy cv wceq w3a vf cab wceq w3a vx cv cO wcel vy cv cO wcel wa vz cv
      vf cv cM wcel vf cv cD cfv vx cv wceq vf cv cC cfv vy cv wceq w3a vf cab
      wceq wa vx vy vz vx cv cO wcel vy cv cO wcel vz cv vf cv cM wcel vf cv cD
      cfv vx cv wceq vf cv cC cfv vy cv wceq w3a vf cab wceq w3a vx cv cO wcel
      vy cv cO wcel wa vz cv vf cv cM wcel vf cv cD cfv vx cv wceq vf cv cC cfv
      vy cv wceq w3a vf cab wceq wa wb cT ccat wcel vx cv cO wcel vy cv cO wcel
      vz cv vf cv cM wcel vf cv cD cfv vx cv wceq vf cv cC cfv vy cv wceq w3a
      vf cab wceq df-3an a1i oprabbidv eqtrd ax-mp eqtri oprabval2 cA cB cH
      df-opr syl5eqr $.
      $( [19-May-2007] $) $( [18-May-2007] $)
  $}

  ${
    $d A x $.  $d B x $.  $d M x $.  $d D x $.  $d C x $.  $d T x $.  $d F x $.
    ishomc.1 $e |- O = dom ( id_ ` T ) $.
    ishomc.2 $e |- M = dom ( dom_  ` T ) $.
    ishomc.3 $e |- D = ( dom_ ` T ) $.
    ishomc.4 $e |- C = ( cod_ ` T ) $.
    ishomc.5 $e |- H = ( hom ` T ) $.
    ishomc.6 $e |- T e. Cat $.
    $( The predicate ` F e. ( ( hom `` T ) `` <. A , B >. ) ` JFM vol. 1.2
       p. 411 th. 18. $)
    ishomc $p |- ( ( A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) <->
        ( F e. M /\ ( D ` F ) = A /\ ( C ` F ) = B ) ) ) $=
      cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel cF vx cv cM wcel vx cv
      cD cfv cA wceq vx cv cC cfv cB wceq w3a vx cab wcel cF cM wcel cF cD cfv
      cA wceq cF cC cfv cB wceq w3a cA cO wcel cB cO wcel wa cA cB cop cH cfv
      vx cv cM wcel vx cv cD cfv cA wceq vx cv cC cfv cB wceq w3a vx cab cF cA
      cB cC cD cT vx cH cM cO ishomc.1 ishomc.2 ishomc.3 ishomc.4 ishomc.5
      ishomc.6 ishomb eleq2d cF cM wcel cF cD cfv cA wceq cF cC cfv cB wceq w3a
      cF cM wcel wi cF vx cv cM wcel vx cv cD cfv cA wceq vx cv cC cfv cB wceq
      w3a vx cab wcel cF cM wcel cF cD cfv cA wceq cF cC cfv cB wceq w3a wb cF
      cM wcel cF cD cfv cA wceq cF cC cfv cB wceq 3simp1 vx cv cM wcel vx cv cD
      cfv cA wceq vx cv cC cfv cB wceq w3a cF cM wcel cF cD cfv cA wceq cF cC
      cfv cB wceq w3a vx cF cM vx cv cF wceq vx cv cM wcel cF cM wcel vx cv cD
      cfv cA wceq cF cD cfv cA wceq vx cv cC cfv cB wceq cF cC cfv cB wceq vx
      cv cF cM eleq1 vx cv cF wceq vx cv cD cfv cF cD cfv cA vx cv cF cD fveq2
      eqeq1d vx cv cF wceq vx cv cC cfv cF cC cfv cB vx cv cF cC fveq2 eqeq1d
      3anbi123d elab3g ax-mp syl6bb $.
      $( [5-Dec-2007] $) $( [30-Nov-2007] $)
  $}

  ${
    ishomd.1 $e |- O = dom ( id_ ` T ) $.
    ishomd.2 $e |- M = dom ( dom_ ` T ) $.
    ishomd.3 $e |- D = ( dom_ ` T ) $.
    ishomd.4 $e |- C = ( cod_ ` T ) $.
    ishomd.5 $e |- H = ( hom ` T ) $.
    $( The predicate ` F e. ( ( hom `` T ) `` <. A , B >. ) ` JFM vol. 1.2
       p. 411 th. 18. $)
    ishomd $p |- ( ( T e. Cat /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) <->
        ( F e. M /\ ( D ` F ) = A /\ ( C ` F ) = B ) ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel cF cA cB cop cH cfv wcel cF cM wcel cF
      cD cfv cA wceq cF cC cfv cB wceq w3a wb cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel cF cM wcel cF cD cfv cA wceq cF cC cfv
      cB wceq w3a wb wi cA cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv
      vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop
      vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cid_ cfv cdm wcel
      cB cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
      cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop
      cop vx cv vx cv cop cop csn cop cop cif cid_ cfv cdm wcel wa cF cA cB cop
      cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop
      csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop
      vx cv vx cv cop cop csn cop cop cif chom cfv cfv wcel cF cT ccat wcel cT
      vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx
      cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop
      cop csn cop cop cif cdom_ cfv cdm wcel cF cT ccat wcel cT vx cv vx cv cop
      vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop
      csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop
      cif cdom_ cfv cfv cA wceq cF cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif ccod_
      cfv cfv cB wceq w3a wb wi cT vx cv vx cv cop vx cv cop csn vx cv vx cv
      cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv
      vx cv cop cop vx cv vx cv cop cop csn cop cop cT cT ccat wcel cT vx cv vx
      cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv
      cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn
      cop cop cif wceq cA cO wcel cB cO wcel wa cA cT ccat wcel cT vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop
      cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop
      cop cif cid_ cfv cdm wcel cB cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cid_
      cfv cdm wcel wa cF cA cB cop cH cfv wcel cF cM wcel cF cD cfv cA wceq cF
      cC cfv cB wceq w3a wb cF cA cB cop cT ccat wcel cT vx cv vx cv cop vx cv
      cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn
      vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif
      chom cfv cfv wcel cF cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv
      vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop
      vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cdm
      wcel cF cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
      cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv
      cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cfv cA wceq cF cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif ccod_ cfv cfv cB wceq w3a wb cT cT ccat
      wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv
      vx cv cop cop csn cop cop cif wceq cA cO wcel cA cT ccat wcel cT vx cv vx
      cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv
      cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn
      cop cop cif cid_ cfv cdm wcel cB cO wcel cB cT ccat wcel cT vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop
      cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop
      cop cif cid_ cfv cdm wcel cT cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cO
      cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop
      csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop
      vx cv vx cv cop cop csn cop cop cif cid_ cfv cdm cA cT cT ccat wcel cT vx
      cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv
      vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop
      csn cop cop cif wceq cT cid_ cfv cdm cT ccat wcel cT vx cv vx cv cop vx
      cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop
      csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop
      cif cid_ cfv cdm cO cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx
      cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv
      cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cT cid_
      cfv cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
      cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop
      cop vx cv vx cv cop cop csn cop cop cif cid_ cfv cT cT ccat wcel cT vx cv
      vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx
      cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop
      csn cop cop cif cid_ fveq2 dmeqd ishomd.1 syl5eq eleq2d cT cT ccat wcel
      cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv
      vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv
      cop cop csn cop cop cif wceq cO cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cid_
      cfv cdm cB cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv
      cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv
      vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cT cid_ cfv cdm cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif cid_ cfv cdm cO cT cT ccat wcel cT vx cv
      vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx
      cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop
      csn cop cop cif wceq cT cid_ cfv cT ccat wcel cT vx cv vx cv cop vx cv
      cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn
      vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif
      cid_ cfv cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop
      vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx
      cv cop cop vx cv vx cv cop cop csn cop cop cif cid_ fveq2 dmeqd ishomd.1
      syl5eq eleq2d anbi12d cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx
      cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv
      cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cF cA cB
      cop cH cfv wcel cF cA cB cop cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif chom
      cfv cfv wcel cF cM wcel cF cD cfv cA wceq cF cC cfv cB wceq w3a cF cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif cdom_ cfv cdm wcel cF cT ccat wcel cT vx
      cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv
      vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop
      csn cop cop cif cdom_ cfv cfv cA wceq cF cT ccat wcel cT vx cv vx cv cop
      vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop
      csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop
      cif ccod_ cfv cfv cB wceq w3a cT cT ccat wcel cT vx cv vx cv cop vx cv
      cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn
      vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif
      wceq cA cB cop cH cfv cA cB cop cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif chom
      cfv cfv cF cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv
      cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv
      vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cA cB cop cH cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif chom cfv cT cT ccat wcel cT vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop
      cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop
      cop cif wceq cT chom cfv cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx
      cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv
      cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif chom cfv cH
      cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
      cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop
      cop vx cv vx cv cop cop csn cop cop cif chom fveq2 ishomd.5 syl5eq fveq1d
      eleq2d cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop
      vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx
      cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cF cM wcel cF cT ccat
      wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv
      vx cv cop cop csn cop cop cif cdom_ cfv cdm wcel cF cD cfv cA wceq cF cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif cdom_ cfv cfv cA wceq cF cC cfv cB wceq
      cF cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
      cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop
      cop vx cv vx cv cop cop csn cop cop cif ccod_ cfv cfv cB wceq cT cT ccat
      wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv
      vx cv cop cop csn cop cop cif wceq cM cT ccat wcel cT vx cv vx cv cop vx
      cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop
      csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop
      cif cdom_ cfv cdm cF cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx
      cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv
      cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cT cdom_
      cfv cdm cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
      cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv
      cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cdm cM cT cT ccat
      wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv
      vx cv cop cop csn cop cop cif wceq cT cdom_ cfv cT ccat wcel cT vx cv vx
      cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv
      cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn
      cop cop cif cdom_ cfv cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx
      cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv
      cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cdom_ fveq2
      dmeqd ishomd.2 syl5eq eleq2d cT cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cF
      cD cfv cF cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop
      vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx
      cv cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cfv cA cT cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif wceq cF cD cT ccat wcel cT vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop
      cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop
      cop cif cdom_ cfv cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv
      vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop
      vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cT cdom_ cfv
      cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop
      csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop
      vx cv vx cv cop cop csn cop cop cif cdom_ cfv cD cT cT ccat wcel cT vx cv
      vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx
      cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop
      csn cop cop cif cdom_ fveq2 ishomd.3 syl5eq fveq1d eqeq1d cT cT ccat wcel
      cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv
      vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv
      cop cop csn cop cop cif wceq cF cC cfv cF cT ccat wcel cT vx cv vx cv cop
      vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop
      csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop
      cif ccod_ cfv cfv cB cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx
      cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv
      cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif wceq cF cC cT
      ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop cif ccod_ cfv cT cT ccat wcel cT vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop
      cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop
      cop cif wceq cT ccod_ cfv cT ccat wcel cT vx cv vx cv cop vx cv cop csn
      vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx
      cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif ccod_ cfv
      cC cT cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv
      cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop
      cop vx cv vx cv cop cop csn cop cop cif ccod_ fveq2 ishomd.4 syl5eq
      fveq1d eqeq1d 3anbi123d bibi12d imbi12d cA cB cT ccat wcel cT vx cv vx cv
      cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop
      cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop
      cop cif ccod_ cfv cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx
      cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx
      cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cT ccat
      wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop
      vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv
      vx cv cop cop csn cop cop cif cF cT ccat wcel cT vx cv vx cv cop vx cv
      cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn
      vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif
      chom cfv cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx
      cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv
      cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cdm cT ccat wcel cT
      vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx
      cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop
      cop csn cop cop cif cid_ cfv cdm cT ccat wcel cT vx cv vx cv cop vx cv
      cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn
      vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif
      cid_ cfv cdm eqid cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx
      cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx
      cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif cdom_ cfv cdm eqid
      cT ccat wcel cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop
      csn cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop
      vx cv vx cv cop cop csn cop cop cif cdom_ cfv eqid cT ccat wcel cT vx cv
      vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx
      cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop
      csn cop cop cif ccod_ cfv eqid cT ccat wcel cT vx cv vx cv cop vx cv cop
      csn vx cv vx cv cop vx cv cop csn cop vx cv vx cv vx cv cop cop csn vx cv
      vx cv cop vx cv vx cv cop cop vx cv vx cv cop cop csn cop cop cif chom
      cfv eqid cT vx cv vx cv cop vx cv cop csn vx cv vx cv cop vx cv cop csn
      cop vx cv vx cv vx cv cop cop csn vx cv vx cv cop vx cv vx cv cop cop vx
      cv vx cv cop cop csn cop cop ccat vx cv vx visset 1cat elimel ishomc
      dedth 3impib $.
      $( [5-Dec-2007] $) $( [30-Nov-2007] $)
  $}

  ${
    ehm.1 $e |- O = dom ( id_ ` T ) $.
    ehm.2 $e |- M = dom ( dom_ ` T ) $.
    ehm.5 $e |- H = ( hom ` T ) $.
    $( The elements of a homset are morphisms.  JFM CAT_1 th. 21. $)
    ehm $p |- ( ( T e. Cat /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> F e. M ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cM
      wcel cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel wa
      cF cM wcel cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv cfv cB wceq cT
      ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cM wcel
      cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv cfv cB wceq w3a cA cB cT
      ccod_ cfv cT cdom_ cfv cT cF cH cM cO ehm.1 ehm.2 cT cdom_ cfv eqid cT
      ccod_ cfv eqid ehm.5 ishomd biimpa 3simp1d ex $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    dehm.1 $e |- O = dom ( id_ ` T ) $.
    dehm.2 $e |- D = ( dom_ ` T ) $.
    dehm.5 $e |- H = ( hom ` T ) $.
    $( Domain of an element of a homset.  JFM CAT_1 th. 23. $)
    dehm $p |- ( ( T e. Cat /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( D ` F ) = A ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cD cfv
      cA wceq cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel
      wa cF cT cdom_ cfv cdm wcel cF cD cfv cA wceq cF cT ccod_ cfv cfv cB wceq
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cT
      cdom_ cfv cdm wcel cF cD cfv cA wceq cF cT ccod_ cfv cfv cB wceq w3a cA
      cB cT ccod_ cfv cD cT cF cH cT cdom_ cfv cdm cO dehm.1 cT cdom_ cfv cdm
      eqid dehm.2 cT ccod_ cfv eqid dehm.5 ishomd biimpa 3simp2d ex $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    cehm.1 $e |- O = dom ( id_ ` T ) $.
    cehm.2 $e |- C = ( cod_ ` T ) $.
    cehm.5 $e |- H = ( hom ` T ) $.
    $( Codomain of an element of a homset.  JFM CAT_1 th. 23. $)
    cehm $p |- ( ( T e. Cat /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( C ` F ) = B ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cC cfv
      cB wceq cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel
      wa cF cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cC cfv cB wceq
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cT
      cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cC cfv cB wceq w3a cA
      cB cC cT cdom_ cfv cT cF cH cT cdom_ cfv cdm cO cehm.1 cT cdom_ cfv cdm
      eqid cT cdom_ cfv eqid cehm.2 cehm.5 ishomd biimpa 3simp3d ex $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}


  ${
    mrdmcd.1 $e |- M = dom ( dom_ ` T ) $.
    mrdmcd.2 $e |- H = ( hom ` T ) $.
    mrdmcd.3 $e |- D = ( dom_ ` T ) $.
    mrdmcd.4 $e |- C = ( cod_ ` T ) $.
    $( A morphism belongs to the homset between its domain and its
       codomain.  JFM CAT_1 th. 22. $)
    mrdmcd $p |- ( T e. Cat -> ( F e. M ->
      F e. ( H ` <. ( D ` F ) , ( C ` F ) >. ) ) ) $=
      cT ccat wcel cF cM wcel cF cD cfv cT cid_ cfv cdm wcel cF cC cfv cT cid_
      cfv cdm wcel wa cF cF cD cfv cF cC cfv cop cH cfv wcel cT ccat wcel cF cM
      wcel cF cD cfv cT cid_ cfv cdm wcel cF cC cfv cT cid_ cfv cdm wcel cT
      ccat wcel cT cded wcel cT calg wcel cF cM wcel cF cD cfv cT cid_ cfv cdm
      wcel wi cT catded cT dedalg cT calg wcel cM cT cid_ cfv cdm cD wf cF cM
      wcel cF cD cfv cT cid_ cfv cdm wcel wi cD cT cT cid_ cfv cM cT cid_ cfv
      cdm cM cT cdom_ cfv cdm cD cdm mrdmcd.1 cT cdom_ cfv cD cD cT cdom_ cfv
      mrdmcd.3 eqcomi dmeqi eqtri mrdmcd.3 cT cid_ cfv cdm eqid cT cid_ cfv
      eqid doma cM cT cid_ cfv cdm cD wf cF cM wcel cF cD cfv cT cid_ cfv cdm
      wcel cM cT cid_ cfv cdm cF cD ffvelrn ex syl 3syl cT ccat wcel cT cded
      wcel cT calg wcel cF cM wcel cF cC cfv cT cid_ cfv cdm wcel wi cT catded
      cT dedalg cT calg wcel cM cT cid_ cfv cdm cC wf cF cM wcel cF cC cfv cT
      cid_ cfv cdm wcel wi cC cD cT cT cid_ cfv cM cT cid_ cfv cdm cM cT cdom_
      cfv cdm cD cdm mrdmcd.1 cT cdom_ cfv cD cD cT cdom_ cfv mrdmcd.3 eqcomi
      dmeqi eqtri mrdmcd.3 cT cid_ cfv cdm eqid cT cid_ cfv eqid mrdmcd.4 coda
      cM cT cid_ cfv cdm cC wf cF cM wcel cF cC cfv cT cid_ cfv cdm wcel cM cT
      cid_ cfv cdm cF cC ffvelrn ex syl 3syl jcad cT ccat wcel cF cD cfv cT
      cid_ cfv cdm wcel cF cC cfv cT cid_ cfv cdm wcel wa cF cM wcel cF cF cD
      cfv cF cC cfv cop cH cfv wcel cT ccat wcel cF cD cfv cT cid_ cfv cdm wcel
      cF cC cfv cT cid_ cfv cdm wcel cF cM wcel cF cF cD cfv cF cC cfv cop cH
      cfv wcel wi cF cD cfv cF cD cfv wceq cF cC cfv cF cC cfv wceq cT ccat
      wcel cF cD cfv cT cid_ cfv cdm wcel cF cC cfv cT cid_ cfv cdm wcel w3a cF
      cM wcel cF cF cD cfv cF cC cfv cop cH cfv wcel wi wi cF cD cfv eqid cF cC
      cfv eqid cF cM wcel cF cD cfv cF cD cfv wceq cF cC cfv cF cC cfv wceq wa
      cT ccat wcel cF cD cfv cT cid_ cfv cdm wcel cF cC cfv cT cid_ cfv cdm
      wcel w3a cF cF cD cfv cF cC cfv cop cH cfv wcel cF cM wcel cF cD cfv cF
      cD cfv wceq cF cC cfv cF cC cfv wceq cT ccat wcel cF cD cfv cT cid_ cfv
      cdm wcel cF cC cfv cT cid_ cfv cdm wcel w3a cF cF cD cfv cF cC cfv cop cH
      cfv wcel wi cT ccat wcel cF cD cfv cT cid_ cfv cdm wcel cF cC cfv cT cid_
      cfv cdm wcel w3a cF cF cD cfv cF cC cfv cop cH cfv wcel cF cM wcel cF cD
      cfv cF cD cfv wceq cF cC cfv cF cC cfv wceq w3a cF cD cfv cF cC cfv cC cD
      cT cF cH cM cT cid_ cfv cdm cT cid_ cfv cdm eqid mrdmcd.1 mrdmcd.3
      mrdmcd.4 mrdmcd.2 ishomd biimprcd 3expib com3l mp2an 3expib com23 mpdd $.
      $( [30-Nov-2007] $) $( [1-Nov-2007] $)
  $}

  $( JFM CAT_1 th. 44.  Not included. use idosd instead $)

  ${
    eqidob.1 $e |- O = dom J $.
    eqidob.2 $e |- J = ( id_ ` C ) $.
    $( When the identities are equal, the objects are equal.  JFM
       CAT_1 th. 45. $)
    eqidob $p |- ( ( C e. Cat /\ A e. O /\ B e. O ) -> ( ( J ` A ) =
    ( J ` B ) -> A = B ) ) $=
      cC ccat wcel cA cO wcel cB cO wcel w3a cA cJ cfv cC cdom_ cfv cfv cB cJ
      cfv cC cdom_ cfv cfv wceq cA cB wceq cA cJ cfv cB cJ cfv wceq cC ccat
      wcel cA cO wcel cB cO wcel w3a cC cded wcel cA cO wcel cB cO wcel w3a cA
      cJ cfv cC cdom_ cfv cfv cA wceq cA cJ cfv cC ccod_ cfv cfv cA wceq wa cB
      cJ cfv cC cdom_ cfv cfv cB wceq cB cJ cfv cC ccod_ cfv cfv cB wceq wa wa
      cA cJ cfv cC cdom_ cfv cfv cB cJ cfv cC cdom_ cfv cfv wceq cA cB wceq wi
      cC ccat wcel cC cded wcel cA cO wcel cA cO wcel cB cO wcel cB cO wcel cC
      catded cA cO wcel id cB cO wcel id 3anim123i cC cded wcel cA cO wcel cB
      cO wcel w3a cA cJ cfv cC cdom_ cfv cfv cA wceq cA cJ cfv cC ccod_ cfv cfv
      cA wceq wa cB cJ cfv cC cdom_ cfv cfv cB wceq cB cJ cfv cC ccod_ cfv cfv
      cB wceq wa cC cded wcel cA cO wcel cA cJ cfv cC cdom_ cfv cfv cA wceq cA
      cJ cfv cC ccod_ cfv cfv cA wceq wa cB cO wcel cA cC ccod_ cfv cC cdom_
      cfv cC cJ cO eqidob.1 cC cdom_ cfv eqid eqidob.2 cC ccod_ cfv eqid idosd
      3adant3 cC cded wcel cB cO wcel cB cJ cfv cC cdom_ cfv cfv cB wceq cB cJ
      cfv cC ccod_ cfv cfv cB wceq wa cA cO wcel cB cC ccod_ cfv cC cdom_ cfv
      cC cJ cO eqidob.1 cC cdom_ cfv eqid eqidob.2 cC ccod_ cfv eqid idosd
      3adant2 jca cA cJ cfv cC cdom_ cfv cfv cA wceq cB cJ cfv cC cdom_ cfv cfv
      cB wceq cA cJ cfv cC cdom_ cfv cfv cB cJ cfv cC cdom_ cfv cfv wceq cA cB
      wceq wi cA cJ cfv cC ccod_ cfv cfv cA wceq cB cJ cfv cC ccod_ cfv cfv cB
      wceq cA cJ cfv cC cdom_ cfv cfv cA wceq cB cJ cfv cC cdom_ cfv cfv cB
      wceq wa cA cJ cfv cC cdom_ cfv cfv cB cJ cfv cC cdom_ cfv cfv wceq cA cB
      wceq cA cJ cfv cC cdom_ cfv cfv cA cB cJ cfv cC cdom_ cfv cfv cB eqeq12
      biimpd ad2ant2r 3syl cA cJ cfv cB cJ cfv cC cdom_ cfv fveq2 syl5 $.
      $( [30-Nov-2007] $) $( [24-Apr-2007] $)
  $}

  ${
    homib.1 $e |- O = dom ( id_ ` T ) $.
    homib.2 $e |- J = ( id_ ` T ) $.
    homib.3 $e |- H = ( hom ` T ) $.
    $( The homset which ` ( ( id_ `` T ) `` A ) ` belongs to.
       JFM CAT_1 th. 55. $)
    homib $p |- ( ( T e. Cat /\ A e. O ) -> ( J ` A ) e.
      ( H ` <. A , A >. ) ) $=
      cT ccat wcel cA cO wcel wa cA cJ cfv cA cJ cfv cT cdom_ cfv cfv cA cJ cfv
      cT ccod_ cfv cfv cop cH cfv cA cA cop cH cfv cT ccat wcel cA cO wcel wa
      cA cJ cfv cT cdom_ cfv cdm wcel cA cJ cfv cA cJ cfv cT cdom_ cfv cfv cA
      cJ cfv cT ccod_ cfv cfv cop cH cfv wcel cA cT cJ cT cdom_ cfv cdm cO cT
      cdom_ cfv cdm eqid homib.1 homib.2 jdmo cT ccat wcel cA cJ cfv cT cdom_
      cfv cdm wcel cA cJ cfv cA cJ cfv cT cdom_ cfv cfv cA cJ cfv cT ccod_ cfv
      cfv cop cH cfv wcel wi cA cO wcel cT ccod_ cfv cT cdom_ cfv cT cA cJ cfv
      cH cT cdom_ cfv cdm cT cdom_ cfv cdm eqid homib.3 cT cdom_ cfv eqid cT
      ccod_ cfv eqid mrdmcd adantr mpd cT ccat wcel cA cO wcel wa cA cJ cfv cT
      cdom_ cfv cfv cA cJ cfv cT ccod_ cfv cfv cop cA cA cop cH cT ccat wcel cA
      cO wcel wa cA cJ cfv cT cdom_ cfv cfv cA cA cJ cfv cT ccod_ cfv cfv cA cT
      ccat wcel cA cO wcel wa cA cT cid_ cfv cfv cT cdom_ cfv cfv cA wceq cA cT
      cid_ cfv cfv cT ccod_ cfv cfv cA wceq wa cA cJ cfv cT cdom_ cfv cfv cA
      wceq cA cT ccod_ cfv cT cdom_ cfv cT cT cid_ cfv cO homib.1 cT cdom_ cfv
      eqid cT cid_ cfv eqid cT ccod_ cfv eqid idosc cA cT cid_ cfv cfv cT cdom_
      cfv cfv cA wceq cA cJ cfv cT cdom_ cfv cfv cA wceq cA cT cid_ cfv cfv cT
      ccod_ cfv cfv cA wceq cA cT cid_ cfv cfv cT cdom_ cfv cfv cA wceq cA cJ
      cfv cT cdom_ cfv cfv cA wceq cA cT cid_ cfv cfv cT cdom_ cfv cfv cA cJ
      cfv cT cdom_ cfv cfv cA cA cT cid_ cfv cfv cA cJ cfv cT cdom_ cfv cA cT
      cid_ cfv cJ cJ cT cid_ cfv homib.2 eqcomi fveq1i fveq2i eqeq1i biimpi
      adantr syl cT ccat wcel cA cO wcel wa cT cded wcel cA cO wcel wa cA cJ
      cfv cT ccod_ cfv cfv cA wceq cA cJ cfv cT cdom_ cfv cfv cA wceq wa cA cJ
      cfv cT ccod_ cfv cfv cA wceq cT ccat wcel cT cded wcel cA cO wcel cT
      catded anim1i cT cded wcel cA cO wcel wa cA cJ cfv cT cdom_ cfv cfv cA
      wceq cA cJ cfv cT ccod_ cfv cfv cA wceq wa cA cJ cfv cT ccod_ cfv cfv cA
      wceq cA cJ cfv cT cdom_ cfv cfv cA wceq wa cA cT ccod_ cfv cT cdom_ cfv
      cT cJ cO cO cT cid_ cfv cdm cJ cdm homib.1 cT cid_ cfv cJ cJ cT cid_ cfv
      homib.2 eqcomi dmeqi eqtri cT cdom_ cfv eqid homib.2 cT ccod_ cfv eqid
      idosd cA cJ cfv cT cdom_ cfv cfv cA wceq cA cJ cfv cT ccod_ cfv cfv cA
      wceq ancom sylib cA cJ cfv cT ccod_ cfv cfv cA wceq cA cJ cfv cT cdom_
      cfv cfv cA wceq pm3.26 3syl opeq12d fveq2d eleqtrd $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    hine.1 $e |- O = dom ( id_ ` T ) $.
    hine.2 $e |- H = ( hom ` T ) $.
    $( Obvious.  Only here to have the complete set of Mizar theorems. $)
    $( The homset ` ( H `` <. A , A >. ) ` is not empty.  JFM CAT_1
       th. 56. $)
    hine $p |- ( ( T e. Cat /\ A e. O ) ->
      ( H ` <. A , A >. ) =/= (/) ) $=
      cT ccat wcel cA cO wcel wa cA cT cid_ cfv cfv cA cA cop cH cfv wcel cA cA
      cop cH cfv c0 wne cA cT cH cT cid_ cfv cO hine.1 cT cid_ cfv eqid hine.2
      homib cA cA cop cH cfv cA cT cid_ cfv cfv ne0i syl $.
      $( [3-Jan-2008] $) $( [3-Jan-2008] $)
  $}

  ${
    cmphmia.1 $e |- O = dom ( id_ ` T ) $.
    cmphmia.2 $e |- H = ( hom ` T ) $.
    cmphmia.3 $e |- J = ( id_ ` T ) $.
    cmphmia.4 $e |- R = ( o_ ` T ) $.
    $( Composite of the member of a homset with the identity.  JFM CAT_1
       th. 57 $)
    cmphmia $p |- ( ( T e. Cat /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( ( J ` B ) R F ) = F ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cT
      cdom_ cfv cdm wcel cF cT ccod_ cfv cfv cB wceq wa cB cJ cfv cF cR co cF
      wceq cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF
      cT cdom_ cfv cdm wcel cF cT ccod_ cfv cfv cB wceq cA cB cT cF cH cT cdom_
      cfv cdm cO cmphmia.1 cT cdom_ cfv cdm eqid cmphmia.2 ehm cA cB cT ccod_
      cfv cT cF cH cO cmphmia.1 cT ccod_ cfv eqid cmphmia.2 cehm jcad cT ccat
      wcel cB cO wcel cF cT cdom_ cfv cdm wcel cF cT ccod_ cfv cfv cB wceq wa
      cB cJ cfv cF cR co cF wceq wi cA cO wcel cT ccat wcel cB cO wcel cF cT
      cdom_ cfv cdm wcel cF cT ccod_ cfv cfv cB wceq cB cJ cfv cF cR co cF wceq
      cT ccat wcel cB cO wcel cF cT cdom_ cfv cdm wcel cF cT ccod_ cfv cfv cB
      wceq cB cJ cfv cF cR co cF wceq wi cB cT ccod_ cfv cT cdom_ cfv cR cT cF
      cJ cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cO cT cid_
      cfv cdm cJ cdm cmphmia.1 cT cid_ cfv cJ cJ cT cid_ cfv cmphmia.3 eqcomi
      dmeqi eqtri cmphmia.3 cmphmia.4 cT ccod_ cfv eqid cmpida 3exp imp4b
      3adant2 syld $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    cmphmib.1 $e |- O = dom ( id_ ` T ) $.
    cmphmib.2 $e |- H = ( hom ` T ) $.
    cmphmib.3 $e |- J = ( id_ ` T ) $.
    cmphmib.4 $e |- R = ( o_ ` T ) $.
    $( Composite of a member of a homset with the identity.  JFM CAT_1
       th. 58 $)
    cmphmib $p |- ( ( T e. Cat /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( F R ( J ` A ) ) = F ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cT
      cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq wa cF cA cJ cfv cR co cF
      wceq cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF
      cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cA cB cT cF cH cT cdom_
      cfv cdm cO cmphmib.1 cT cdom_ cfv cdm eqid cmphmib.2 ehm cA cB cT cdom_
      cfv cT cF cH cO cmphmib.1 cT cdom_ cfv eqid cmphmib.2 dehm jcad cT ccat
      wcel cA cO wcel cF cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq wa
      cF cA cJ cfv cR co cF wceq wi cB cO wcel cT ccat wcel cA cO wcel cF cT
      cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cA cJ cfv cR co cF wceq
      cT ccat wcel cA cO wcel cF cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA
      wceq cF cA cJ cfv cR co cF wceq wi cA cT cdom_ cfv cR cT cF cJ cT cdom_
      cfv cdm cO cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cO cT cid_ cfv cdm cJ
      cdm cmphmib.1 cT cid_ cfv cJ cJ cT cid_ cfv cmphmib.3 eqcomi dmeqi eqtri
      cmphmib.3 cmphmib.4 cmpidb 3exp imp4b 3adant3 syld $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    iri.1 $e |- O = dom ( id_ ` T ) $.
    iri.2 $e |- J = ( id_ ` T ) $.
    iri.3 $e |- R = ( o_ ` T ) $.
    $( Composite of an identity with itself.  JFM CAT_1 th. 59 $)
    iri $p |- ( ( T e. Cat /\ A e. O ) ->
      ( ( J ` A ) R ( J ` A ) ) = ( J ` A ) ) $=
      cT ccat wcel cA cO wcel wa cA cJ cfv cT cdom_ cfv cdm wcel cA cJ cfv cT
      ccod_ cfv cfv cA wceq cA cJ cfv cA cJ cfv cR co cA cJ cfv wceq cA cT cJ
      cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid iri.1 iri.2 jdmo cT ccat wcel
      cA cO wcel wa cA cJ cfv cT cdom_ cfv cfv cA wceq cA cJ cfv cT ccod_ cfv
      cfv cA wceq cA cT ccod_ cfv cT cdom_ cfv cT cJ cO cO cT cid_ cfv cdm cJ
      cdm iri.1 cT cid_ cfv cJ cJ cT cid_ cfv iri.2 eqcomi dmeqi eqtri cT cdom_
      cfv eqid iri.2 cT ccod_ cfv eqid idosc pm3.27d cT ccat wcel cA cO wcel cA
      cJ cfv cT cdom_ cfv cdm wcel cA cJ cfv cT ccod_ cfv cfv cA wceq cA cJ cfv
      cA cJ cfv cR co cA cJ cfv wceq cT ccat wcel cA cO wcel cA cJ cfv cT cdom_
      cfv cdm wcel cA cJ cfv cT ccod_ cfv cfv cA wceq cA cJ cfv cA cJ cfv cR co
      cA cJ cfv wceq wi cA cT ccod_ cfv cT cdom_ cfv cR cT cA cJ cfv cJ cT
      cdom_ cfv cdm cO cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cO cT cid_ cfv
      cdm cJ cdm iri.1 cT cid_ cfv cJ cJ cT cid_ cfv iri.2 eqcomi dmeqi eqtri
      iri.2 iri.3 cT ccod_ cfv eqid cmpida 3exp imp4b mp2and $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${
    cmpassoh.1 $e |- O = dom ( id_ ` T ) $.
    cmpassoh.2 $e |- H = ( hom ` T ) $.
    cmpassoh.3 $e |- R = ( o_ ` T ) $.
    $( ` o_ ` is associative. Homset-based version of ~ cmpasso . $)
    cmpassoh $p |-  ( ( T e. Cat /\ ( A e. O /\ B e. O ) /\
      ( C e. O /\ D e. O ) ) -> ( ( L e. ( H ` <. A , B >. ) /\
         M e. ( H ` <. B , C >. ) /\ N e. ( H ` <. C , D >. ) )
           -> ( N R ( M R L ) ) = ( ( N R M ) R L ) ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a cL cA
      cB cop cH cfv wcel cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel w3a
      cN cM cL cR co cR co cN cM cR co cL cR co wceq cT ccat wcel cL cT cdom_
      cfv cdm wcel cM cT cdom_ cfv cdm wcel cN cT cdom_ cfv cdm wcel w3a wa cN
      cT cdom_ cfv cfv cM cT ccod_ cfv cfv wceq cM cT cdom_ cfv cfv cL cT ccod_
      cfv cfv wceq wa cN cM cL cR co cR co cN cM cR co cL cR co wceq cT ccat
      wcel cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a cL cA cB cop
      cH cfv wcel cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel w3a wa cT
      ccod_ cfv cT cdom_ cfv cR cT cL cM cN cT cdom_ cfv cdm cT cdom_ cfv cdm
      eqid cT cdom_ cfv eqid cT ccod_ cfv eqid cmpassoh.3 cmpasso cT ccat wcel
      cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a cL cA cB cop cH cfv
      wcel cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel w3a wa cT ccat
      wcel cL cT cdom_ cfv cdm wcel cM cT cdom_ cfv cdm wcel cN cT cdom_ cfv
      cdm wcel w3a cT ccat wcel cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel
      wa w3a cT ccat wcel cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel cN
      cC cD cop cH cfv wcel w3a cT ccat wcel cA cO wcel cB cO wcel wa cC cO
      wcel cD cO wcel wa 3simp1 adantr cT ccat wcel cA cO wcel cB cO wcel wa cC
      cO wcel cD cO wcel wa w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv
      wcel cN cC cD cop cH cfv wcel w3a cL cT cdom_ cfv cdm wcel cM cT cdom_
      cfv cdm wcel cN cT cdom_ cfv cdm wcel w3a cT ccat wcel cA cO wcel cB cO
      wcel wa cC cO wcel cD cO wcel wa w3a cL cA cB cop cH cfv wcel cL cT cdom_
      cfv cdm wcel cM cB cC cop cH cfv wcel cM cT cdom_ cfv cdm wcel cN cC cD
      cop cH cfv wcel cN cT cdom_ cfv cdm wcel cT ccat wcel cA cO wcel cB cO
      wcel wa cC cO wcel cD cO wcel wa cL cA cB cop cH cfv wcel cL cT cdom_ cfv
      cdm wcel wi cT ccat wcel cA cO wcel cB cO wcel wa cL cA cB cop cH cfv
      wcel cL cT cdom_ cfv cdm wcel wi cC cO wcel cD cO wcel wa cT ccat wcel cA
      cO wcel cB cO wcel cL cA cB cop cH cfv wcel cL cT cdom_ cfv cdm wcel wi
      cA cB cT cL cH cT cdom_ cfv cdm cO cmpassoh.1 cT cdom_ cfv cdm eqid
      cmpassoh.2 ehm 3expib a1dd 3imp cT ccat wcel cA cO wcel cB cO wcel wa cC
      cO wcel cD cO wcel wa cM cB cC cop cH cfv wcel cM cT cdom_ cfv cdm wcel
      wi cA cO wcel cB cO wcel wa cT ccat wcel cC cO wcel cD cO wcel wa cM cB
      cC cop cH cfv wcel cM cT cdom_ cfv cdm wcel wi wi cB cO wcel cT ccat wcel
      cC cO wcel cD cO wcel wa cM cB cC cop cH cfv wcel cM cT cdom_ cfv cdm
      wcel wi wi wi cA cO wcel cC cO wcel cD cO wcel wa cB cO wcel cT ccat wcel
      cM cB cC cop cH cfv wcel cM cT cdom_ cfv cdm wcel wi cC cO wcel cB cO
      wcel cT ccat wcel cM cB cC cop cH cfv wcel cM cT cdom_ cfv cdm wcel wi wi
      wi cD cO wcel cT ccat wcel cB cO wcel cC cO wcel cM cB cC cop cH cfv wcel
      cM cT cdom_ cfv cdm wcel wi cT ccat wcel cB cO wcel cC cO wcel cM cB cC
      cop cH cfv wcel cM cT cdom_ cfv cdm wcel wi cB cC cT cM cH cT cdom_ cfv
      cdm cO cmpassoh.1 cT cdom_ cfv cdm eqid cmpassoh.2 ehm 3exp com13 adantr
      com3l adantl com12 3imp cT ccat wcel cA cO wcel cB cO wcel wa cC cO wcel
      cD cO wcel wa cN cC cD cop cH cfv wcel cN cT cdom_ cfv cdm wcel wi cT
      ccat wcel cC cO wcel cD cO wcel wa cN cC cD cop cH cfv wcel cN cT cdom_
      cfv cdm wcel wi wi cA cO wcel cB cO wcel wa cT ccat wcel cC cO wcel cD cO
      wcel cN cC cD cop cH cfv wcel cN cT cdom_ cfv cdm wcel wi cC cD cT cN cH
      cT cdom_ cfv cdm cO cmpassoh.1 cT cdom_ cfv cdm eqid cmpassoh.2 ehm
      3expib a1d 3imp 3anim123d imp jca cT ccat wcel cA cO wcel cB cO wcel wa
      cC cO wcel cD cO wcel wa w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv
      wcel cN cC cD cop cH cfv wcel w3a wa cN cT cdom_ cfv cfv cM cT ccod_ cfv
      cfv wceq cM cT cdom_ cfv cfv cL cT ccod_ cfv cfv wceq cT ccat wcel cA cO
      wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a cL cA cB cop cH cfv wcel
      cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel w3a wa cN cT cdom_ cfv
      cfv cC cM cT ccod_ cfv cfv cT ccat wcel cA cO wcel cB cO wcel wa cC cO
      wcel cD cO wcel wa w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel
      cN cC cD cop cH cfv wcel w3a cN cT cdom_ cfv cfv cC wceq cT ccat wcel cA
      cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a cN cC cD cop cH cfv
      wcel cN cT cdom_ cfv cfv cC wceq cL cA cB cop cH cfv wcel cM cB cC cop cH
      cfv wcel cN cC cD cop cH cfv wcel w3a cT ccat wcel cA cO wcel cB cO wcel
      wa cC cO wcel cD cO wcel wa cN cC cD cop cH cfv wcel cN cT cdom_ cfv cfv
      cC wceq wi cT ccat wcel cC cO wcel cD cO wcel wa cN cC cD cop cH cfv wcel
      cN cT cdom_ cfv cfv cC wceq wi wi cA cO wcel cB cO wcel wa cT ccat wcel
      cC cO wcel cD cO wcel cN cC cD cop cH cfv wcel cN cT cdom_ cfv cfv cC
      wceq wi cC cD cT cdom_ cfv cT cN cH cO cmpassoh.1 cT cdom_ cfv eqid
      cmpassoh.2 dehm 3expib a1d 3imp cL cA cB cop cH cfv wcel cM cB cC cop cH
      cfv wcel cN cC cD cop cH cfv wcel 3simp3 syl5 imp cT ccat wcel cA cO wcel
      cB cO wcel wa cC cO wcel cD cO wcel wa w3a cL cA cB cop cH cfv wcel cM cB
      cC cop cH cfv wcel cN cC cD cop cH cfv wcel w3a cM cT ccod_ cfv cfv cC
      wceq cT ccat wcel cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a
      cM cB cC cop cH cfv wcel cM cT ccod_ cfv cfv cC wceq cL cA cB cop cH cfv
      wcel cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel w3a cT ccat wcel
      cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa cM cB cC cop cH cfv
      wcel cM cT ccod_ cfv cfv cC wceq wi cA cO wcel cB cO wcel wa cT ccat wcel
      cC cO wcel cD cO wcel wa cM cB cC cop cH cfv wcel cM cT ccod_ cfv cfv cC
      wceq wi wi cB cO wcel cT ccat wcel cC cO wcel cD cO wcel wa cM cB cC cop
      cH cfv wcel cM cT ccod_ cfv cfv cC wceq wi wi wi cA cO wcel cC cO wcel cD
      cO wcel wa cB cO wcel cT ccat wcel cM cB cC cop cH cfv wcel cM cT ccod_
      cfv cfv cC wceq wi cC cO wcel cB cO wcel cT ccat wcel cM cB cC cop cH cfv
      wcel cM cT ccod_ cfv cfv cC wceq wi wi wi cD cO wcel cT ccat wcel cB cO
      wcel cC cO wcel cM cB cC cop cH cfv wcel cM cT ccod_ cfv cfv cC wceq wi
      cT ccat wcel cB cO wcel cC cO wcel cM cB cC cop cH cfv wcel cM cT ccod_
      cfv cfv cC wceq wi cB cC cT ccod_ cfv cT cM cH cO cmpassoh.1 cT ccod_ cfv
      eqid cmpassoh.2 cehm 3exp com13 adantr com3l adantl com12 3imp cL cA cB
      cop cH cfv wcel cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel 3simp2
      syl5 imp eqtr4d cT ccat wcel cA cO wcel cB cO wcel wa cC cO wcel cD cO
      wcel wa w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel cN cC cD
      cop cH cfv wcel w3a cM cT cdom_ cfv cfv cL cT ccod_ cfv cfv wceq cT ccat
      wcel cA cO wcel cB cO wcel wa cC cO wcel cD cO wcel wa w3a cL cA cB cop
      cH cfv wcel cM cB cC cop cH cfv wcel wa cM cT cdom_ cfv cfv cL cT ccod_
      cfv cfv wceq cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel cN cC cD
      cop cH cfv wcel w3a cT ccat wcel cA cO wcel cB cO wcel wa cC cO wcel cD
      cO wcel wa cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel wa cM cT
      cdom_ cfv cfv cL cT ccod_ cfv cfv wceq wi cC cO wcel cD cO wcel wa cA cO
      wcel cB cO wcel wa cT ccat wcel cL cA cB cop cH cfv wcel cM cB cC cop cH
      cfv wcel wa cM cT cdom_ cfv cfv cL cT ccod_ cfv cfv wceq wi cC cO wcel cA
      cO wcel cB cO wcel wa cT ccat wcel cL cA cB cop cH cfv wcel cM cB cC cop
      cH cfv wcel wa cM cT cdom_ cfv cfv cL cT ccod_ cfv cfv wceq wi wi wi cD
      cO wcel cA cO wcel cB cO wcel wa cC cO wcel cT ccat wcel cL cA cB cop cH
      cfv wcel cM cB cC cop cH cfv wcel wa cM cT cdom_ cfv cfv cL cT ccod_ cfv
      cfv wceq wi wi cA cO wcel cB cO wcel cC cO wcel cT ccat wcel cL cA cB cop
      cH cfv wcel cM cB cC cop cH cfv wcel wa cM cT cdom_ cfv cfv cL cT ccod_
      cfv cfv wceq wi wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cL
      cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel wa cM cT cdom_ cfv cfv cL
      cT ccod_ cfv cfv wceq wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
      w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel wa cM cT cdom_ cfv
      cfv cL cT ccod_ cfv cfv wceq cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel wa w3a cM cT
      cdom_ cfv cfv cB cL cT ccod_ cfv cfv cT ccat wcel cA cO wcel cB cO wcel
      cC cO wcel w3a cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel wa cM cT
      cdom_ cfv cfv cB wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
      wa cM cB cC cop cH cfv wcel cM cT cdom_ cfv cfv cB wceq cL cA cB cop cH
      cfv wcel cT ccat wcel cB cO wcel cC cO wcel cM cB cC cop cH cfv wcel cM
      cT cdom_ cfv cfv cB wceq wi cA cO wcel cB cC cT cdom_ cfv cT cM cH cO
      cmpassoh.1 cT cdom_ cfv eqid cmpassoh.2 dehm 3adant3r1 adantld 3impia cT
      ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cL cA cB cop cH cfv wcel
      cM cB cC cop cH cfv wcel wa cB cL cT ccod_ cfv cfv wceq cA cO wcel cB cO
      wcel cC cO wcel w3a cT ccat wcel cL cA cB cop cH cfv wcel cM cB cC cop cH
      cfv wcel wa cB cL cT ccod_ cfv cfv wceq wi cA cO wcel cB cO wcel cT ccat
      wcel cL cA cB cop cH cfv wcel cM cB cC cop cH cfv wcel wa cB cL cT ccod_
      cfv cfv wceq wi wi cC cO wcel cL cA cB cop cH cfv wcel cM cB cC cop cH
      cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel wa cB cL cT ccod_ cfv cfv
      wceq cL cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel wa cB cL
      cT ccod_ cfv cfv wceq wi wi cM cB cC cop cH cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel wa cL cA cB cop cH cfv wcel cB cL cT ccod_ cfv cfv wceq
      cT ccat wcel cA cO wcel cB cO wcel cL cA cB cop cH cfv wcel cB cL cT
      ccod_ cfv cfv wceq wi cT ccat wcel cA cO wcel cB cO wcel w3a cL cA cB cop
      cH cfv wcel cB cL cT ccod_ cfv cfv wceq cT ccat wcel cA cO wcel cB cO
      wcel w3a cL cA cB cop cH cfv wcel wa cL cT ccod_ cfv cfv cB cT ccat wcel
      cA cO wcel cB cO wcel w3a cL cA cB cop cH cfv wcel cL cT ccod_ cfv cfv cB
      wceq cA cB cT ccod_ cfv cT cL cH cO cmpassoh.1 cT ccod_ cfv eqid
      cmpassoh.2 cehm imp eqcomd ex 3expib com3r adantr com13 3adant3 com12
      3imp eqtrd 3exp com12 3expia com12 adantr com13 3imp cL cA cB cop cH cfv
      wcel cM cB cC cop cH cfv wcel cN cC cD cop cH cfv wcel 3simpa syl5 imp
      jca sylc ex $.
      $( [10-Mar-2008] $) $( [10-Mar-2008] $)
  $}


 ${
   homgrf.1 $e |- O = dom ( id_ ` T ) $.
   homgrf.2 $e |- H = ( hom ` T ) $.
   homgrf.3 $e |- R = ( o_ ` T ) $.
   $( Homset of a composite.  JFM CAT_1 th. 51 $)
   homgrf $p |- ( ( T e. Cat /\ ( A e. O /\ B e. O /\ C e. O ) ) ->
   ( ( F e. ( H ` <. A , B >. ) /\ G e. ( H ` <. B , C >. ) )  ->
     ( G R F ) e. ( H ` <. A , C >. ) ) ) $=
     cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop cH cfv
     wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cdom_ cfv cdm wcel cG cF
     cR co cT cdom_ cfv cfv cA wceq cG cF cR co cT ccod_ cfv cfv cC wceq w3a cG
     cF cR co cA cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO
     wcel w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR
     co cT cdom_ cfv cdm wcel cG cF cR co cT cdom_ cfv cfv cA wceq cG cF cR co
     cT ccod_ cfv cfv cC wceq w3a cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
     w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa wa cG cF cR co
     cT cdom_ cfv cdm wcel cG cF cR co cT cdom_ cfv cfv cA wceq cG cF cR co cT
     ccod_ cfv cfv cC wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa
     cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cdom_
     cfv cdm wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB
     cop cH cfv wcel cG cB cC cop cH cfv wcel wa cF cT cdom_ cfv cdm wcel cG cT
     cdom_ cfv cdm wcel cG cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a cG cF
     cR co cT cdom_ cfv cdm wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
     w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cF cT cdom_
     cfv cdm wcel cG cT cdom_ cfv cdm wcel cG cT cdom_ cfv cfv cF cT ccod_ cfv
     cfv wceq w3a cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB
     cop cH cfv wcel cG cB cC cop cH cfv wcel wa wa cF cT cdom_ cfv cdm wcel cG
     cT cdom_ cfv cdm wcel cG cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq cF cA
     cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat wcel cA cO wcel cB
     cO wcel cC cO wcel w3a wa cF cT cdom_ cfv cdm wcel cF cA cB cop cH cfv
     wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cT cdom_ cfv
     cdm wcel wi cG cB cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC
     cO wcel w3a wa cF cA cB cop cH cfv wcel cF cT cdom_ cfv cdm wcel cT ccat
     wcel cA cO wcel cB cO wcel cF cA cB cop cH cfv wcel cF cT cdom_ cfv cdm
     wcel wi cC cO wcel cA cB cT cF cH cT cdom_ cfv cdm cO homgrf.1 cT cdom_
     cfv cdm eqid homgrf.2 ehm 3adant3r3 com12 adantr impcom cF cA cB cop cH
     cfv wcel cG cB cC cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel cC
     cO wcel w3a wa cG cT cdom_ cfv cdm wcel cG cB cC cop cH cfv wcel cT ccat
     wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG cT cdom_ cfv cdm wcel wi
     cF cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
     wa cG cB cC cop cH cfv wcel cG cT cdom_ cfv cdm wcel cT ccat wcel cB cO
     wcel cC cO wcel cG cB cC cop cH cfv wcel cG cT cdom_ cfv cdm wcel wi cA cO
     wcel cB cC cT cG cH cT cdom_ cfv cdm cO homgrf.1 cT cdom_ cfv cdm eqid
     homgrf.2 ehm 3adant3r1 com12 adantl impcom cT ccat wcel cA cO wcel cB cO
     wcel cC cO wcel w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
     wa wa cG cT cdom_ cfv cfv cB cF cT ccod_ cfv cfv cF cA cB cop cH cfv wcel
     cG cB cC cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
     w3a wa cG cT cdom_ cfv cfv cB wceq cG cB cC cop cH cfv wcel cT ccat wcel
     cA cO wcel cB cO wcel cC cO wcel w3a wa cG cT cdom_ cfv cfv cB wceq wi cF
     cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa
     cG cB cC cop cH cfv wcel cG cT cdom_ cfv cfv cB wceq cT ccat wcel cB cO
     wcel cC cO wcel cG cB cC cop cH cfv wcel cG cT cdom_ cfv cfv cB wceq wi cA
     cO wcel cB cC cT cdom_ cfv cT cG cH cO homgrf.1 cT cdom_ cfv eqid homgrf.2
     dehm 3adant3r1 com12 adantl impcom cF cA cB cop cH cfv wcel cG cB cC cop
     cH cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cB cF
     cT ccod_ cfv cfv wceq cF cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB
     cO wcel cC cO wcel w3a wa cB cF cT ccod_ cfv cfv wceq wi cG cB cC cop cH
     cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop
     cH cfv wcel cB cF cT ccod_ cfv cfv wceq cT ccat wcel cA cO wcel cB cO wcel
     cF cA cB cop cH cfv wcel cB cF cT ccod_ cfv cfv wceq wi cC cO wcel cT ccat
     wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cB cF cT ccod_ cfv
     cfv wceq cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel
     wa cF cT ccod_ cfv cfv cB cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB
     cop cH cfv wcel cF cT ccod_ cfv cfv cB wceq cA cB cT ccod_ cfv cT cF cH cO
     homgrf.1 cT ccod_ cfv eqid homgrf.2 cehm imp eqcomd ex 3adant3r3 com12
     adantr impcom eqtrd 3jca ex cT ccat wcel cF cT cdom_ cfv cdm wcel cG cT
     cdom_ cfv cdm wcel cG cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a cG cF
     cR co cT cdom_ cfv cdm wcel wi cA cO wcel cB cO wcel cC cO wcel w3a cT
     ccat wcel cF cT cdom_ cfv cdm wcel cG cT cdom_ cfv cdm wcel cG cT cdom_
     cfv cfv cF cT ccod_ cfv cfv wceq cG cF cR co cT cdom_ cfv cdm wcel cT ccat
     wcel cF cT cdom_ cfv cdm wcel cG cT cdom_ cfv cdm wcel cG cT cdom_ cfv cfv
     cF cT ccod_ cfv cfv wceq cG cF cR co cT cdom_ cfv cdm wcel wi cT ccod_ cfv
     cT cdom_ cfv cR cT cF cG cT cdom_ cfv cdm cT cdom_ cfv cdm eqid cT cdom_
     cfv eqid cT ccod_ cfv eqid homgrf.3 cmpmorp 3exp 3impd adantr syld imp cT
     ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop cH cfv wcel
     cG cB cC cop cH cfv wcel wa wa cG cF cR co cT cdom_ cfv cfv cF cT cdom_
     cfv cfv cA cT cded wcel cF cT cdom_ cfv cdm wcel cG cT cdom_ cfv cdm wcel
     w3a cG cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq cG cF cR co cT cdom_ cfv
     cfv cF cT cdom_ cfv cfv wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
     w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa wa cT ccod_
     cfv cT cdom_ cfv cR cT cF cG cT cdom_ cfv cdm cT cdom_ cfv cdm eqid cT
     cdom_ cfv eqid cT ccod_ cfv eqid homgrf.3 domcmpd cT ccat wcel cA cO wcel
     cB cO wcel cC cO wcel w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
     wcel wa wa cT cded wcel cF cT cdom_ cfv cdm wcel cG cT cdom_ cfv cdm wcel
     cT ccat wcel cT cded wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB
     cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT catded ad2antrr cF cA cB
     cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO
     wcel cC cO wcel w3a wa cF cT cdom_ cfv cdm wcel cF cA cB cop cH cfv wcel
     cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cT cdom_ cfv cdm
     wcel wi cG cB cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO
     wcel w3a wa cF cA cB cop cH cfv wcel cF cT cdom_ cfv cdm wcel cT ccat wcel
     cA cO wcel cB cO wcel cF cA cB cop cH cfv wcel cF cT cdom_ cfv cdm wcel wi
     cC cO wcel cA cB cT cF cH cT cdom_ cfv cdm cO homgrf.1 cT cdom_ cfv cdm
     eqid homgrf.2 ehm 3adant3r3 com12 adantr impcom cF cA cB cop cH cfv wcel
     cG cB cC cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
     w3a wa cG cT cdom_ cfv cdm wcel cG cB cC cop cH cfv wcel cT ccat wcel cA
     cO wcel cB cO wcel cC cO wcel w3a wa cG cT cdom_ cfv cdm wcel wi cF cA cB
     cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG cB
     cC cop cH cfv wcel cG cT cdom_ cfv cdm wcel cT ccat wcel cB cO wcel cC cO
     wcel cG cB cC cop cH cfv wcel cG cT cdom_ cfv cdm wcel wi cA cO wcel cB cC
     cT cG cH cT cdom_ cfv cdm cO homgrf.1 cT cdom_ cfv cdm eqid homgrf.2 ehm
     3adant3r1 com12 adantl impcom 3jca cT ccat wcel cA cO wcel cB cO wcel cC
     cO wcel w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa wa cG
     cT cdom_ cfv cfv cB cF cT ccod_ cfv cfv cF cA cB cop cH cfv wcel cG cB cC
     cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG
     cT cdom_ cfv cfv cB wceq cG cB cC cop cH cfv wcel cT ccat wcel cA cO wcel
     cB cO wcel cC cO wcel w3a wa cG cT cdom_ cfv cfv cB wceq wi cF cA cB cop
     cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG cB cC
     cop cH cfv wcel cG cT cdom_ cfv cfv cB wceq cT ccat wcel cB cO wcel cC cO
     wcel cG cB cC cop cH cfv wcel cG cT cdom_ cfv cfv cB wceq wi cA cO wcel cB
     cC cT cdom_ cfv cT cG cH cO homgrf.1 cT cdom_ cfv eqid homgrf.2 dehm
     3adant3r1 com12 adantl impcom cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
     wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cT ccod_
     cfv cfv cB wceq cF cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO
     wcel cC cO wcel w3a wa cF cT ccod_ cfv cfv cB wceq wi cG cB cC cop cH cfv
     wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop cH
     cfv wcel cF cT ccod_ cfv cfv cB wceq cT ccat wcel cA cO wcel cB cO wcel cF
     cA cB cop cH cfv wcel cF cT ccod_ cfv cfv cB wceq wi cC cO wcel cA cB cT
     ccod_ cfv cT cF cH cO homgrf.1 cT ccod_ cfv eqid homgrf.2 cehm 3adant3r3
     com12 adantr impcom eqtr4d sylc cF cA cB cop cH cfv wcel cG cB cC cop cH
     cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cT
     cdom_ cfv cfv cA wceq cF cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB
     cO wcel cC cO wcel w3a wa cF cT cdom_ cfv cfv cA wceq wi cG cB cC cop cH
     cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop
     cH cfv wcel cF cT cdom_ cfv cfv cA wceq cT ccat wcel cA cO wcel cB cO wcel
     cF cA cB cop cH cfv wcel cF cT cdom_ cfv cfv cA wceq wi cC cO wcel cA cB
     cT cdom_ cfv cT cF cH cO homgrf.1 cT cdom_ cfv eqid homgrf.2 dehm
     3adant3r3 com12 adantr impcom eqtrd cT ccat wcel cA cO wcel cB cO wcel cC
     cO wcel w3a wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa wa cG
     cF cR co cT ccod_ cfv cfv cG cT ccod_ cfv cfv cC cT cded wcel cF cT cdom_
     cfv cdm wcel cG cT cdom_ cfv cdm wcel w3a cG cT cdom_ cfv cfv cF cT ccod_
     cfv cfv wceq cG cF cR co cT ccod_ cfv cfv cG cT ccod_ cfv cfv wceq cT ccat
     wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop cH cfv wcel cG
     cB cC cop cH cfv wcel wa wa cT ccod_ cfv cT cdom_ cfv cR cT cF cG cT cdom_
     cfv cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid homgrf.3
     codcmpd cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop
     cH cfv wcel cG cB cC cop cH cfv wcel wa wa cT cded wcel cF cT cdom_ cfv
     cdm wcel cG cT cdom_ cfv cdm wcel cT ccat wcel cT cded wcel cA cO wcel cB
     cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
     wa cT catded ad2antrr cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa
     cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cT cdom_ cfv cdm
     wcel cF cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO
     wcel w3a wa cF cT cdom_ cfv cdm wcel wi cG cB cC cop cH cfv wcel cT ccat
     wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop cH cfv wcel cF
     cT cdom_ cfv cdm wcel cT ccat wcel cA cO wcel cB cO wcel cF cA cB cop cH
     cfv wcel cF cT cdom_ cfv cdm wcel wi cC cO wcel cA cB cT cF cH cT cdom_
     cfv cdm cO homgrf.1 cT cdom_ cfv cdm eqid homgrf.2 ehm 3adant3r3 com12
     adantr impcom cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat
     wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG cT cdom_ cfv cdm wcel cG
     cB cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa
     cG cT cdom_ cfv cdm wcel wi cF cA cB cop cH cfv wcel cT ccat wcel cA cO
     wcel cB cO wcel cC cO wcel w3a wa cG cB cC cop cH cfv wcel cG cT cdom_ cfv
     cdm wcel cT ccat wcel cB cO wcel cC cO wcel cG cB cC cop cH cfv wcel cG cT
     cdom_ cfv cdm wcel wi cA cO wcel cB cC cT cG cH cT cdom_ cfv cdm cO
     homgrf.1 cT cdom_ cfv cdm eqid homgrf.2 ehm 3adant3r1 com12 adantl impcom
     3jca cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cA cB cop cH
     cfv wcel cG cB cC cop cH cfv wcel wa wa cG cT cdom_ cfv cfv cB cF cT ccod_
     cfv cfv cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat wcel
     cA cO wcel cB cO wcel cC cO wcel w3a wa cG cT cdom_ cfv cfv cB wceq cG cB
     cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG
     cT cdom_ cfv cfv cB wceq wi cF cA cB cop cH cfv wcel cT ccat wcel cA cO
     wcel cB cO wcel cC cO wcel w3a wa cG cB cC cop cH cfv wcel cG cT cdom_ cfv
     cfv cB wceq cT ccat wcel cB cO wcel cC cO wcel cG cB cC cop cH cfv wcel cG
     cT cdom_ cfv cfv cB wceq wi cA cO wcel cB cC cT cdom_ cfv cT cG cH cO
     homgrf.1 cT cdom_ cfv eqid homgrf.2 dehm 3adant3r1 com12 adantl impcom cF
     cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat wcel cA cO wcel
     cB cO wcel cC cO wcel w3a wa cF cT ccod_ cfv cfv cB wceq cF cA cB cop cH
     cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cF cT ccod_
     cfv cfv cB wceq wi cG cB cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO
     wcel cC cO wcel w3a wa cF cA cB cop cH cfv wcel cF cT ccod_ cfv cfv cB
     wceq cT ccat wcel cA cO wcel cB cO wcel cF cA cB cop cH cfv wcel cF cT
     ccod_ cfv cfv cB wceq wi cC cO wcel cA cB cT ccod_ cfv cT cF cH cO
     homgrf.1 cT ccod_ cfv eqid homgrf.2 cehm 3adant3r3 com12 adantr impcom
     eqtr4d sylc cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat
     wcel cA cO wcel cB cO wcel cC cO wcel w3a wa cG cT ccod_ cfv cfv cC wceq
     cG cB cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
     wa cG cT ccod_ cfv cfv cC wceq wi cF cA cB cop cH cfv wcel cT ccat wcel cA
     cO wcel cB cO wcel cC cO wcel w3a wa cG cB cC cop cH cfv wcel cG cT ccod_
     cfv cfv cC wceq cT ccat wcel cB cO wcel cC cO wcel cG cB cC cop cH cfv
     wcel cG cT ccod_ cfv cfv cC wceq wi cA cO wcel cB cC cT ccod_ cfv cT cG cH
     cO homgrf.1 cT ccod_ cfv eqid homgrf.2 cehm 3adant3r1 com12 adantl impcom
     eqtrd 3jca ex cT ccat wcel cA cO wcel cC cO wcel cG cF cR co cA cC cop cH
     cfv wcel cG cF cR co cT cdom_ cfv cdm wcel cG cF cR co cT cdom_ cfv cfv cA
     wceq cG cF cR co cT ccod_ cfv cfv cC wceq w3a wb cB cO wcel cA cC cT ccod_
     cfv cT cdom_ cfv cT cG cF cR co cH cT cdom_ cfv cdm cO homgrf.1 cT cdom_
     cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid homgrf.2 ishomd 3adant3r2
     sylibrd $.
     $( [10-Mar-2008] $) $( [10-Mar-2008] $)
 $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Monomorphisms, Epimorphisms, Isomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Epi $. $( The class of all epimorphisms. $)
  $c Monic $. $( The class of all monomorphisms. $)
  $c Iso $. $( The class of all isomorphisms. $)

  $( Extend class notation with the class of all epimorphisms. $)
  cepi $a class Epi $.

  $( Extend class notation with the class of all monomorphisms. $)
  cmon $a class Monic $.

  $( Extend class notation with the class of all isomorphisms. $)
  ciso $a class Iso $.

  ${ $d x y f g h $.
    $( Function returning the monomorphisms of the category ` x ` .
       JFM CAT_1 def. 10. $)
    df-mon $a |- Monic = { <. x , y >. |
    ( x e. Cat /\ y = { f | ( f e. dom ( dom_ ` x ) /\
      A. g e. dom ( dom_ ` x ) A. h e. dom ( dom_ ` x )
        ( ( ( ( dom_ ` x ) ` g ) = ( ( dom_ ` x ) ` h ) /\
            ( ( cod_ ` x ) ` g ) = ( ( dom_ ` x ) ` f ) /\
            ( ( cod_ ` x ) ` h ) = ( ( dom_ ` x ) ` f ) ) ->
              ( ( f ( o_ ` x ) g ) = ( f ( o_ ` x ) h ) -> g = h ) ) ) } ) } $.
  $}

  ${ $d x y f g h $.
    $( Function returning the epimorphisms of the category ` x ` .
       JFM CAT_1 def. 11. $)
    df-epi $a |- Epi = { <. x , y >. |
    ( x e. Cat /\ y = { f | ( f e. dom ( dom_ ` x ) /\
      A. g e. dom ( dom_ ` x ) A. h e. dom ( dom_ ` x )
        ( ( ( ( cod_ ` x ) ` g ) = ( ( cod_ ` x ) ` h ) /\
            ( ( dom_ ` x ) ` g ) = ( ( cod_ ` x ) ` f ) /\
            ( ( dom_ ` x ) ` h ) = ( ( cod_ ` x ) ` f ) ) ->
              ( ( g ( o_ ` x ) f ) = ( h ( o_ ` x ) f ) -> g = h ) ) ) } ) } $.
  $}

  ${ $d x y f g $.
    $( Function returning the isomorphisms of the category ` x ` . $)
    df-isoc $a |- Iso = { <. x , y >. | ( x e. Cat /\
    y = { f e. dom ( dom_ ` x ) | E. g e. dom ( dom_ ` x ) (
     ( dom_ ` g ) = ( cod_ ` f ) /\ ( cod_ ` g ) = ( dom_ ` f ) /\
     ( ( f ( o_ ` x ) g ) = ( ( id_ ` x ) ` ( ( dom_ ` x ) ` g ) ) /\
     ( g ( o_ ` x ) f ) = ( ( id_ ` x ) ` ( ( dom_ ` x ) ` f ) ) ) ) } ) } $.
  $}


  ${ $d C x y $.  $d D x y $.  $d M f g h x y $.  $d R x y $.
     $d T f g h x y $.
    ismona.1 $e |- M = dom ( dom_ ` T ) $.
    ismona.2 $e |- D = ( dom_ ` T ) $.
    ismona.3 $e |- C = ( cod_ ` T ) $.
    ismona.4 $e |- R = ( o_ ` T ) $.
    $( Monomorphisms of a category. $)
    ismona $p |- ( T e. Cat -> ( Monic ` T ) = { f | ( f e. M /\
      A. g e. M A. h e. M
        ( ( ( D ` g ) = ( D ` h ) /\
            ( C ` g ) = ( D ` f ) /\
            ( C ` h ) = ( D ` f ) ) ->
              ( ( f R g ) = ( f R h ) -> g = h ) ) ) } ) $=
      vx vy cT vf cv vx cv cdom_ cfv cdm wcel vg cv vx cv cdom_ cfv cfv vh cv
      vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv
      cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vf
      cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vg cv vh cv
      wceq wi wi vh vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm wral wa vf
      cab vf cv cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD
      cfv wceq vh cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv
      cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa vf cab ccat
      cmon vx cv cT wceq vf cv vx cv cdom_ cfv cdm wcel vg cv vx cv cdom_ cfv
      cfv vh cv vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv
      cdom_ cfv cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv
      wceq w3a vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq
      vg cv vh cv wceq wi wi vh vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm
      wral wa vf cv cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv
      cD cfv wceq vh cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh
      cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa vf vx cv cT
      wceq vf cv vx cv cdom_ cfv cdm wcel vf cv cM wcel vg cv vx cv cdom_ cfv
      cfv vh cv vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv
      cdom_ cfv cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv
      wceq w3a vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq
      vg cv vh cv wceq wi wi vh vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm
      wral vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv
      cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co wceq vg
      cv vh cv wceq wi wi vh cM wral vg cM wral vx cv cT wceq vx cv cdom_ cfv
      cdm cM vf cv vx cv cT wceq vx cv cdom_ cfv cdm cT cdom_ cfv cdm cM vx cv
      cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT cdom_ fveq2 dmeqd ismona.1
      syl6eqr eleq2d vx cv cT wceq vg cv vx cv cdom_ cfv cfv vh cv vx cv cdom_
      cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq vh
      cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vf cv vg cv vx
      cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vg cv vh cv wceq wi wi vh
      vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm wral vg cv vx cv cdom_
      cfv cfv vh cv vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx
      cv cdom_ cfv cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv
      wceq w3a vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq
      vg cv vh cv wceq wi wi vh cM wral vg vx cv cdom_ cfv cdm wral vg cv vx cv
      cdom_ cfv cfv vh cv vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf
      cv vx cv cdom_ cfv cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_
      cfv cfv wceq w3a vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv
      co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral vg cv cD cfv vh cv
      cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf cv cD cfv wceq
      w3a vf cv vg cv cR co vf cv vh cv cR co wceq vg cv vh cv wceq wi wi vh cM
      wral vg cM wral vx cv cT wceq vg cv vx cv cdom_ cfv cfv vh cv vx cv cdom_
      cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq vh
      cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vf cv vg cv vx
      cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vg cv vh cv wceq wi wi vh
      vx cv cdom_ cfv cdm wral vg cv vx cv cdom_ cfv cfv vh cv vx cv cdom_ cfv
      cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq vh cv
      vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vf cv vg cv vx cv
      co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vg cv vh cv wceq wi wi vh cM
      wral vg vx cv cdom_ cfv cdm vx cv cT wceq vg cv vx cv cdom_ cfv cfv vh cv
      vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv
      cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vf
      cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vg cv vh cv
      wceq wi wi vh vx cv cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_ cfv cdm cT
      cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT
      cdom_ fveq2 dmeqd ismona.1 syl6eqr raleq1d ralbidv vx cv cT wceq vg cv vx
      cv cdom_ cfv cfv vh cv vx cv cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv
      vf cv vx cv cdom_ cfv cfv wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv
      cdom_ cfv cfv wceq w3a vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_
      cfv co wceq vg cv vh cv wceq wi wi vh cM wral vg vx cv cdom_ cfv cdm cM
      vx cv cT wceq vx cv cdom_ cfv cdm cT cdom_ cfv cdm cM vx cv cT wceq vx cv
      cdom_ cfv cT cdom_ cfv vx cv cT cdom_ fveq2 dmeqd ismona.1 syl6eqr
      raleq1d vx cv cT wceq vg cv vx cv cdom_ cfv cfv vh cv vx cv cdom_ cfv cfv
      wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq vh cv vx cv
      ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vf cv vg cv vx cv co_
      cfv co vf cv vh cv vx cv co_ cfv co wceq vg cv vh cv wceq wi wi vg cv cD
      cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf cv
      cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co wceq vg cv vh cv wceq
      wi wi vg vh cM cM vx cv cT wceq vg cv vx cv cdom_ cfv cfv vh cv vx cv
      cdom_ cfv cfv wceq vg cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv
      wceq vh cv vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq w3a vg cv
      cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf
      cv cD cfv wceq w3a vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv
      co wceq vg cv vh cv wceq wi vf cv vg cv cR co vf cv vh cv cR co wceq vg
      cv vh cv wceq wi vx cv cT wceq vg cv vx cv cdom_ cfv cfv vh cv vx cv
      cdom_ cfv cfv wceq vg cv cD cfv vh cv cD cfv wceq vg cv vx cv ccod_ cfv
      cfv vf cv vx cv cdom_ cfv cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv
      vx cv ccod_ cfv cfv vf cv vx cv cdom_ cfv cfv wceq vh cv cC cfv vf cv cD
      cfv wceq vx cv cT wceq vg cv vx cv cdom_ cfv cfv vg cv cD cfv vh cv vx cv
      cdom_ cfv cfv vh cv cD cfv vx cv cT wceq vg cv vx cv cdom_ cfv cfv vg cv
      cT cdom_ cfv cfv vg cv cD cfv vx cv cT wceq vg cv vx cv cdom_ cfv cT
      cdom_ cfv vx cv cT cdom_ fveq2 fveq1d vg cv cT cdom_ cfv cD cD cT cdom_
      cfv ismona.2 eqcomi fveq1i syl6eq vx cv cT wceq vh cv vx cv cdom_ cfv cfv
      vh cv cT cdom_ cfv cfv vh cv cD cfv vx cv cT wceq vh cv vx cv cdom_ cfv
      cT cdom_ cfv vx cv cT cdom_ fveq2 fveq1d vh cv cT cdom_ cfv cD cD cT
      cdom_ cfv ismona.2 eqcomi fveq1i syl6eq eqeq12d vx cv cT wceq vg cv vx cv
      ccod_ cfv cfv vg cv cC cfv vf cv vx cv cdom_ cfv cfv vf cv cD cfv vx cv
      cT wceq vg cv vx cv ccod_ cfv cfv vg cv cT ccod_ cfv cfv vg cv cC cfv vx
      cv cT wceq vg cv vx cv ccod_ cfv cT ccod_ cfv vx cv cT ccod_ fveq2 fveq1d
      vg cv cT ccod_ cfv cC cC cT ccod_ cfv ismona.3 eqcomi fveq1i syl6eq vx cv
      cT wceq vf cv vx cv cdom_ cfv cfv vf cv cT cdom_ cfv cfv vf cv cD cfv vx
      cv cT wceq vf cv vx cv cdom_ cfv cT cdom_ cfv vx cv cT cdom_ fveq2 fveq1d
      vf cv cT cdom_ cfv cD cD cT cdom_ cfv ismona.2 eqcomi fveq1i syl6eq
      eqeq12d vx cv cT wceq vh cv vx cv ccod_ cfv cfv vh cv cC cfv vf cv vx cv
      cdom_ cfv cfv vf cv cD cfv vx cv cT wceq vh cv vx cv ccod_ cfv cfv vh cv
      cT ccod_ cfv cfv vh cv cC cfv vx cv cT wceq vh cv vx cv ccod_ cfv cT
      ccod_ cfv vx cv cT ccod_ fveq2 fveq1d vh cv cT ccod_ cfv cC cC cT ccod_
      cfv ismona.3 eqcomi fveq1i syl6eq vx cv cT wceq vf cv vx cv cdom_ cfv cfv
      vf cv cT cdom_ cfv cfv vf cv cD cfv vx cv cT wceq vf cv vx cv cdom_ cfv
      cT cdom_ cfv vx cv cT cdom_ fveq2 fveq1d vf cv cT cdom_ cfv cD cD cT
      cdom_ cfv ismona.2 eqcomi fveq1i syl6eq eqeq12d 3anbi123d vx cv cT wceq
      vf cv vg cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vf cv vg
      cv cR co vf cv vh cv cR co wceq vg cv vh cv wceq vx cv cT wceq vf cv vg
      cv vx cv co_ cfv co vf cv vh cv vx cv co_ cfv co wceq vf cv vg cv cT co_
      cfv co vf cv vh cv cT co_ cfv co wceq vf cv vg cv cR co vf cv vh cv cR co
      wceq vx cv cT wceq vf cv vg cv vx cv co_ cfv co vf cv vg cv cT co_ cfv co
      vf cv vh cv vx cv co_ cfv co vf cv vh cv cT co_ cfv co vx cv cT wceq vx
      cv co_ cfv cT co_ cfv vf cv vg cv vx cv cT co_ fveq2 opreqd vx cv cT wceq
      vx cv co_ cfv cT co_ cfv vf cv vh cv vx cv cT co_ fveq2 opreqd eqeq12d vf
      cv vg cv cT co_ cfv co vf cv vg cv cR co vf cv vh cv cT co_ cfv co vf cv
      vh cv cR co cR cT co_ cfv wceq vf cv vg cv cT co_ cfv co vf cv vg cv cR
      co wceq ismona.4 vf cv vg cv cT co_ cfv co vf cv vg cv cR co wceq cT co_
      cfv cR vf cv vg cv cT co_ cfv cR opreq eqcoms ax-mp cR cT co_ cfv wceq vf
      cv vh cv cT co_ cfv co vf cv vh cv cR co wceq ismona.4 vf cv vh cv cT co_
      cfv co vf cv vh cv cR co wceq cT co_ cfv cR vf cv vh cv cT co_ cfv cR
      opreq eqcoms ax-mp eqeq12i syl6bb imbi1d imbi12d 2ralbidv 3bitrd anbi12d
      abbidv vx vy vf vg vh df-mon vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv
      vf cv cD cfv wceq vh cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf
      cv vh cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral vf cM cM
      cT cdom_ cfv cdm cvv ismona.1 cT cdom_ cfv cT cdom_ fvex dmex eqeltri
      zfausab fvopab4 $.
      $( [5-Dec-2007] $) $( [5-Dec-2007] $)
  $}

  ${ $d C f $.  $d D f $.  $d F f g h $.  $d M f g h $.
     $d R f $.  $d T f g h $.
    ismonb.1 $e |- M = dom ( dom_ ` T ) $.
    ismonb.2 $e |- D = ( dom_ ` T ) $.
    ismonb.3 $e |- C = ( cod_ ` T ) $.
    ismonb.4 $e |- R = ( o_ ` T ) $.
    $( The predicate "is a monomorphism". $)
    ismonb $p |- ( ( T e. Cat /\ F e. A ) -> ( F e. ( Monic ` T )
      <-> ( F e. M /\ A. g e. M A. h e. M
        ( ( ( D ` g ) = ( D ` h ) /\
            ( C ` g ) = ( D ` F ) /\
            ( C ` h ) = ( D ` F ) ) ->
              ( ( F R g ) = ( F R h ) -> g = h ) ) ) ) ) $=
      cT ccat wcel cF cA wcel wa cF cT cmon cfv wcel cF vf cv cM wcel vg cv cD
      cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf cv
      cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co wceq vg cv vh cv wceq
      wi wi vh cM wral vg cM wral wa vf cab wcel cF cM wcel vg cv cD cfv vh cv
      cD cfv wceq vg cv cC cfv cF cD cfv wceq vh cv cC cfv cF cD cfv wceq w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg
      cM wral wa cT ccat wcel cF cA wcel wa cT cmon cfv vf cv cM wcel vg cv cD
      cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf cv
      cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co wceq vg cv vh cv wceq
      wi wi vh cM wral vg cM wral wa vf cab cF cT ccat wcel cT cmon cfv vf cv
      cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh
      cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co wceq
      vg cv vh cv wceq wi wi vh cM wral vg cM wral wa vf cab wceq cF cA wcel cC
      cD cR cT vf vg vh cM ismonb.1 ismonb.2 ismonb.3 ismonb.4 ismona adantr
      eleq2d cF cA wcel cF vf cv cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv
      cC cfv vf cv cD cfv wceq vh cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv
      cR co vf cv vh cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral
      wa vf cab wcel cF cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv cF
      cD cfv wceq vh cv cC cfv cF cD cfv wceq w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa wb cT ccat wcel vf
      cv cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq
      vh cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co
      wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa cF cM wcel vg cv cD
      cfv vh cv cD cfv wceq vg cv cC cfv cF cD cfv wceq vh cv cC cfv cF cD cfv
      wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cM
      wral vg cM wral wa vf cF cA vf cv cF wceq vf cv cM wcel cF cM wcel vg cv
      cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf
      cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co wceq vg cv vh cv
      wceq wi wi vh cM wral vg cM wral vg cv cD cfv vh cv cD cfv wceq vg cv cC
      cfv cF cD cfv wceq vh cv cC cfv cF cD cfv wceq w3a cF vg cv cR co cF vh
      cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral vf cv cF cM
      eleq1 vf cv cF wceq vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD
      cfv wceq vh cv cC cfv vf cv cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv
      cR co wceq vg cv vh cv wceq wi wi vg cv cD cfv vh cv cD cfv wceq vg cv cC
      cfv cF cD cfv wceq vh cv cC cfv cF cD cfv wceq w3a cF vg cv cR co cF vh
      cv cR co wceq vg cv vh cv wceq wi wi vg vh cM cM vf cv cF wceq vg cv cD
      cfv vh cv cD cfv wceq vg cv cC cfv vf cv cD cfv wceq vh cv cC cfv vf cv
      cD cfv wceq w3a vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv cF cD cfv
      wceq vh cv cC cfv cF cD cfv wceq w3a vf cv vg cv cR co vf cv vh cv cR co
      wceq vg cv vh cv wceq wi cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vf cv cF wceq vg cv cC cfv vf cv cD cfv wceq vg cv cC cfv cF cD
      cfv wceq vh cv cC cfv vf cv cD cfv wceq vh cv cC cfv cF cD cfv wceq vg cv
      cD cfv vh cv cD cfv wceq vf cv cF wceq vf cv cD cfv cF cD cfv vg cv cC
      cfv vf cv cF cD fveq2 eqeq2d vf cv cF wceq vf cv cD cfv cF cD cfv vh cv
      cC cfv vf cv cF cD fveq2 eqeq2d 3anbi23d vf cv cF wceq vf cv vg cv cR co
      vf cv vh cv cR co wceq cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq vf cv cF wceq vf cv vg cv cR co cF vg cv cR co vf cv vh cv cR co cF
      vh cv cR co vf cv cF vg cv cR opreq1 vf cv cF vh cv cR opreq1 eqeq12d
      imbi1d imbi12d 2ralbidv anbi12d elabg adantl bitrd $.
      $( [3-Jan-2008] $) $( [2-Jan-2008] $)

    $( The predicate "is a monomorphism". $)
    ismonb1 $p |- ( ( T e. Cat /\ F e. M ) -> ( F e. ( Monic ` T ) <->
      A. g e. M A. h e. M
        ( ( ( D ` g ) = ( D ` h ) /\
            ( C ` g ) = ( D ` F ) /\
            ( C ` h ) = ( D ` F ) ) ->
              ( ( F R g ) = ( F R h ) -> g = h ) ) ) )  $=
      cT ccat wcel cF cM wcel wa cF cT cmon cfv wcel cF cM wcel vg cv cD cfv vh
      cv cD cfv wceq vg cv cC cfv cF cD cfv wceq vh cv cC cfv cF cD cfv wceq
      w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cM wral
      vg cM wral wa vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv cF cD cfv wceq
      vh cv cC cfv cF cD cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi vh cM wral vg cM wral cM cC cD cR cT vg vh cF cM
      ismonb.1 ismonb.2 ismonb.3 ismonb.4 ismonb cF cM wcel vg cv cD cfv vh cv
      cD cfv wceq vg cv cC cfv cF cD cfv wceq vh cv cC cfv cF cD cfv wceq w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg
      cM wral cF cM wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv cF cD cfv
      wceq vh cv cC cfv cF cD cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi wi vh cM wral vg cM wral wa wb cT ccat wcel cF cM
      wcel vg cv cD cfv vh cv cD cfv wceq vg cv cC cfv cF cD cfv wceq vh cv cC
      cfv cF cD cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi wi vh cM wral vg cM wral ibar adantl bitr4d $.
      $( [3-Jan-2008] $) $( [2-Jan-2008] $)
  $}

  ${ $d C g j $.  $d D g j $.  $d F g j $.  $d G g j $.
     $d J j $.  $d M g j $.  $d R g j $.  $d T g j $.
    ismonb2.1 $e |- M = dom ( dom_ ` T ) $.
    ismonb2.2 $e |- D = ( dom_ ` T ) $.
    ismonb2.3 $e |- C = ( cod_ ` T ) $.
    ismonb2.4 $e |- R = ( o_ ` T ) $.
    $( A monomorphism is a left-cancelable morphism. $)
    ismonb2 $p |- ( ( T e. Cat /\ ( F e. M /\ G e. M /\ J e. M ) ) ->
      ( F e. ( Monic ` T ) ->
        ( ( ( D ` G ) = ( D ` J ) /\
            ( C ` G ) = ( D ` F ) /\
            ( C ` J ) = ( D ` F ) ) ->
              ( ( F R G ) = ( F R J ) -> G = J ) ) ) )  $=
      cT ccat wcel cF cM wcel cG cM wcel cJ cM wcel w3a wa cF cT cmon cfv wcel
      vg cv cD cfv vj cv cD cfv wceq vg cv cC cfv cF cD cfv wceq vj cv cC cfv
      cF cD cfv wceq w3a cF vg cv cR co cF vj cv cR co wceq vg cv vj cv wceq wi
      wi vj cM wral vg cM wral cG cD cfv cJ cD cfv wceq cG cC cfv cF cD cfv
      wceq cJ cC cfv cF cD cfv wceq w3a cF cG cR co cF cJ cR co wceq cG cJ wceq
      wi wi cT ccat wcel cG cM wcel cF cM wcel cF cT cmon cfv wcel vg cv cD cfv
      vj cv cD cfv wceq vg cv cC cfv cF cD cfv wceq vj cv cC cfv cF cD cfv wceq
      w3a cF vg cv cR co cF vj cv cR co wceq vg cv vj cv wceq wi wi vj cM wral
      vg cM wral wb cJ cM wcel cC cD cR cT vg vj cF cM ismonb2.1 ismonb2.2
      ismonb2.3 ismonb2.4 ismonb1 3ad2antr1 cT ccat wcel cF cM wcel cG cM wcel
      cJ cM wcel w3a wa cG cM wcel cJ cM wcel wa vg cv cD cfv vj cv cD cfv wceq
      vg cv cC cfv cF cD cfv wceq vj cv cC cfv cF cD cfv wceq w3a cF vg cv cR
      co cF vj cv cR co wceq vg cv vj cv wceq wi wi vj cM wral vg cM wral cG cD
      cfv cJ cD cfv wceq cG cC cfv cF cD cfv wceq cJ cC cfv cF cD cfv wceq w3a
      cF cG cR co cF cJ cR co wceq cG cJ wceq wi wi wi cF cM wcel cG cM wcel cJ
      cM wcel w3a cG cM wcel cJ cM wcel wa cT ccat wcel cF cM wcel cG cM wcel
      cJ cM wcel 3simpc adantl vg cv cD cfv vj cv cD cfv wceq vg cv cC cfv cF
      cD cfv wceq vj cv cC cfv cF cD cfv wceq w3a cF vg cv cR co cF vj cv cR co
      wceq vg cv vj cv wceq wi wi cG cD cfv cJ cD cfv wceq cG cC cfv cF cD cfv
      wceq cJ cC cfv cF cD cfv wceq w3a cF cG cR co cF cJ cR co wceq cG cJ wceq
      wi wi cG cD cfv vj cv cD cfv wceq cG cC cfv cF cD cfv wceq vj cv cC cfv
      cF cD cfv wceq w3a cF cG cR co cF vj cv cR co wceq cG vj cv wceq wi wi vg
      vj cG cJ cM cM vg cv cG wceq vg cv cD cfv vj cv cD cfv wceq vg cv cC cfv
      cF cD cfv wceq vj cv cC cfv cF cD cfv wceq w3a cG cD cfv vj cv cD cfv
      wceq cG cC cfv cF cD cfv wceq vj cv cC cfv cF cD cfv wceq w3a cF vg cv cR
      co cF vj cv cR co wceq vg cv vj cv wceq wi cF cG cR co cF vj cv cR co
      wceq cG vj cv wceq wi vg cv cG wceq vg cv cD cfv vj cv cD cfv wceq cG cD
      cfv vj cv cD cfv wceq vg cv cC cfv cF cD cfv wceq cG cC cfv cF cD cfv
      wceq vj cv cC cfv cF cD cfv wceq vg cv cG wceq vg cv cD cfv cG cD cfv vj
      cv cD cfv vg cv cG cD fveq2 eqeq1d vg cv cG wceq vg cv cC cfv cG cC cfv
      cF cD cfv vg cv cG cC fveq2 eqeq1d 3anbi12d vg cv cG wceq cF vg cv cR co
      cF vj cv cR co wceq cF cG cR co cF vj cv cR co wceq vg cv vj cv wceq cG
      vj cv wceq vg cv cG wceq cF vg cv cR co cF cG cR co cF vj cv cR co vg cv
      cG cF cR opreq2 eqeq1d vg cv cG vj cv eqeq1 imbi12d imbi12d vj cv cJ wceq
      cG cD cfv vj cv cD cfv wceq cG cC cfv cF cD cfv wceq vj cv cC cfv cF cD
      cfv wceq w3a cG cD cfv cJ cD cfv wceq cG cC cfv cF cD cfv wceq cJ cC cfv
      cF cD cfv wceq w3a cF cG cR co cF vj cv cR co wceq cG vj cv wceq wi cF cG
      cR co cF cJ cR co wceq cG cJ wceq wi vj cv cJ wceq cG cD cfv vj cv cD cfv
      wceq cG cD cfv cJ cD cfv wceq vj cv cC cfv cF cD cfv wceq cJ cC cfv cF cD
      cfv wceq cG cC cfv cF cD cfv wceq vj cv cJ wceq vj cv cD cfv cJ cD cfv cG
      cD cfv vj cv cJ cD fveq2 eqeq2d vj cv cJ wceq vj cv cC cfv cJ cC cfv cF
      cD cfv vj cv cJ cC fveq2 eqeq1d 3anbi13d vj cv cJ wceq cF cG cR co cF vj
      cv cR co wceq cF cG cR co cF cJ cR co wceq cG vj cv wceq cG cJ wceq vj cv
      cJ wceq cF vj cv cR co cF cJ cR co cF cG cR co vj cv cJ cF cR opreq2
      eqeq2d vj cv cJ cG eqeq2 imbi12d imbi12d rcla42v syl sylbid $.
      $( [3-Jan-2008] $) $( [2-Jan-2008] $)
  $}

  ${ $d B a g h $.  $d C a g h $.  $d F a g h $.
     $d H a g h $.  $d O a g h $.  $d R a $.  $d T a g h $.
    imonclem.1 $e |- O = dom ( id_ ` T ) $.
    imonclem.2 $e |- H = ( hom ` T ) $.
    imonclem.3 $e |- R = ( o_ ` T ) $.
    $( Lemma for ~ ismonc . $)
    imonclem $p |- (  (  T e. Cat
                         /\ ( B e. O /\ C e. O )
                         /\ F e. ( H ` <. B , C >. ) )
                      -> (  A. a
                            e. O
                               A. g
                               e. ( H ` <. a , B >. )
                                  A. h
                                  e. ( H ` <. a , B >. )
                                     ( ( F R g ) = ( F R h ) -> g = h )
                         -> (  F e. dom ( dom_ ` T )
                            /\ A. g
                               e. dom ( dom_ ` T )
                                  A. h
                                  e. dom ( dom_ ` T )
                                     (  (    ( ( dom_ ` T ) ` g )
                                           = ( ( dom_ ` T ) ` h )
                                        /\   ( ( cod_ ` T ) ` g )
                                           = ( ( dom_ ` T ) ` F )
                                        /\   ( ( cod_ ` T ) ` h )
                                           = ( ( dom_ ` T ) ` F ) )
                                     -> ( ( F R g ) = ( F R h ) -> g = h ) ) )
                         ) ) $=
      cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cF vg
      cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv
      wral vg va cv cB cop cH cfv wral va cO wral cF cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm wral wa cT ccat wcel cB cO wcel cC cO wcel
      wa cF cB cC cop cH cfv wcel w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va
      cO wral wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm
      wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a
      cF cT cdom_ cfv cdm wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va cO
      wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel cF cT
      cdom_ cfv cdm wcel cT ccat wcel cB cO wcel cC cO wcel cF cB cC cop cH cfv
      wcel cF cT cdom_ cfv cdm wcel wi cB cC cT cF cH cT cdom_ cfv cdm cO
      imonclem.1 cT cdom_ cfv cdm eqid imonclem.2 ehm 3expib 3imp adantr cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cF vg cv
      cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral
      vg va cv cB cop cH cfv wral va cO wral wa vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi wi vh wal vg wal vg cv cT cdom_ cfv cfv vh cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm
      wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH
      cfv wral vg va cv cB cop cH cfv wral va cO wral wa vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi wi vh wal vg cT ccat wcel cB cO wcel cC cO
      wcel wa cF cB cC cop cH cfv wcel w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv
      wral va cO wral vg cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a vg ax-17 cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq
      wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral vg va cO va cv
      cO wcel vg ax-17 cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv hbra1 hbral hban cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cF vg cv
      cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral
      vg va cv cB cop cH cfv wral va cO wral wa vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi wi vh cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop
      cH cfv wcel w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va cO wral vh cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a vh ax-17
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH
      cfv wral vg va cv cB cop cH cfv wral vh va cO va cv cO wcel vh ax-17 cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH
      cfv wral vh vg va cv cB cop cH cfv vg cv va cv cB cop cH cfv wcel vh
      ax-17 cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB
      cop cH cfv hbra1 hbral hbral hban cT ccat wcel cB cO wcel cC cO wcel wa
      cF cB cC cop cH cfv wcel w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va cO
      wral vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT
      cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi wi cT ccat wcel cB
      cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa cF vg cv cR co cF vh cv cR co wceq vg
      cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral
      va cO wral vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a vg
      cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv
      cB cop cH cfv wral va cO wral vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv
      cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi wi wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC
      cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa vg cv cT cdom_ cfv cfv cO wcel cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH
      cfv wral va cO wral vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg
      cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi wi wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv
      wcel w3a cT ccat wcel vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa vg cv cT cdom_ cfv cfv cO wcel cT ccat wcel cB cO wcel cC cO wcel
      wa cF cB cC cop cH cfv wcel 3simp1 vg cv cT cdom_ cfv cdm wcel cT ccat
      wcel vg cv cT cdom_ cfv cfv cO wcel wi vh cv cT cdom_ cfv cdm wcel cT
      ccat wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cO wcel cT
      cdom_ cfv cT vg cv cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid imonclem.1
      cT cdom_ cfv eqid dmo expcom adantr mpan9 cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH
      cfv wral va cO wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa
      wa vg cv cT cdom_ cfv cfv cO wcel wa vg cv cT cdom_ cfv cfv vh cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR
      co wceq vg cv vh cv wceq wi wi cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va
      cO wral vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh wal vg wal
      va cO wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel
      w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg cv
      cT cdom_ cfv cfv cO wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi wi cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq
      wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral vg cv va cv cB
      cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv
      cR co wceq vg cv vh cv wceq wi wi vh wal vg wal va cO cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi vg vh va cv cB cop cH cfv va cv cB
      cop cH cfv r2al ralbii cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop
      cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel
      wa wa vg cv cT cdom_ cfv cfv cO wcel wa vg cv va cv cB cop cH cfv wcel vh
      cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi va cO wral vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv
      wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh wal
      vg wal va cO wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa
      wa vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg
      cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vg cv cT cdom_ cfv
      cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi wi va vg cv cT cdom_ cfv cfv
      cO cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a vg
      cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa va cv vg cv cT
      cdom_ cfv cfv wceq wa vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop
      cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi
      vg cv vg cv cT cdom_ cfv cfv cB cop cH cfv wcel vh cv vg cv cT cdom_ cfv
      cfv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi wi vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cB wceq w3a wa cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi wi vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi va cv vg cv cT cdom_ cfv cfv wceq vg cv va cv cB cop cH cfv wcel vh cv
      va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi wi vg cv vg cv cT cdom_ cfv cfv cB cop cH cfv wcel vh cv vg cv
      cT cdom_ cfv cfv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi wi wb cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC
      cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa va cv vg cv cT cdom_ cfv cfv wceq vg cv va cv cB cop cH cfv
      wcel vh cv va cv cB cop cH cfv wcel wa vg cv vg cv cT cdom_ cfv cfv cB
      cop cH cfv wcel vh cv vg cv cT cdom_ cfv cfv cB cop cH cfv wcel wa cF vg
      cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi va cv vg cv cT cdom_ cfv
      cfv wceq vg cv va cv cB cop cH cfv wcel vg cv vg cv cT cdom_ cfv cfv cB
      cop cH cfv wcel vh cv va cv cB cop cH cfv wcel vh cv vg cv cT cdom_ cfv
      cfv cB cop cH cfv wcel va cv vg cv cT cdom_ cfv cfv wceq va cv cB cop cH
      cfv vg cv cT cdom_ cfv cfv cB cop cH cfv vg cv va cv vg cv cT cdom_ cfv
      cfv wceq va cv cB cop vg cv cT cdom_ cfv cfv cB cop cH va cv vg cv cT
      cdom_ cfv cfv cB opeq1 fveq2d eleq2d va cv vg cv cT cdom_ cfv cfv wceq va
      cv cB cop cH cfv vg cv cT cdom_ cfv cfv cB cop cH cfv vh cv va cv vg cv
      cT cdom_ cfv cfv wceq va cv cB cop vg cv cT cdom_ cfv cfv cB cop cH va cv
      vg cv cT cdom_ cfv cfv cB opeq1 fveq2d eleq2d anbi12d imbi1d adantl cT
      ccat wcel vg cv cT cdom_ cfv cfv cO wcel cB cO wcel vg cv vg cv cT cdom_
      cfv cfv cB cop cH cfv wcel vh cv vg cv cT cdom_ cfv cfv cB cop cH cfv
      wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vg cv
      cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi wb cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a vg cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa va cv vg cv cT cdom_
      cfv cfv wceq wa cT ccat wcel vg cv cT cdom_ cfv cfv cO wcel cB cO wcel
      w3a vg cv vg cv cT cdom_ cfv cfv cB cop cH cfv wcel vh cv vg cv cT cdom_
      cfv cfv cB cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv vg cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh
      cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv
      wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi cT ccat wcel vg cv cT cdom_ cfv cfv cO wcel cB
      cO wcel w3a vg cv vg cv cT cdom_ cfv cfv cB cop cH cfv wcel vg cv cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vg
      cv cT ccod_ cfv cfv cB wceq w3a vh cv vg cv cT cdom_ cfv cfv cB cop cH
      cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq w3a vg cv cT cdom_ cfv
      cfv cB cT ccod_ cfv cT cdom_ cfv cT vg cv cH cT cdom_ cfv cdm cO
      imonclem.1 cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid
      imonclem.2 ishomd vg cv cT cdom_ cfv cfv cB cT ccod_ cfv cT cdom_ cfv cT
      vh cv cH cT cdom_ cfv cdm cO imonclem.1 cT cdom_ cfv cdm eqid cT cdom_
      cfv eqid cT ccod_ cfv eqid imonclem.2 ishomd anbi12d imbi1d cT ccat wcel
      cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cT ccat wcel vg cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa va cv vg cv cT cdom_
      cfv cfv wceq cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv
      wcel 3simp1 ad2antrr cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop
      cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel
      wa wa vg cv cT cdom_ cfv cfv cO wcel va cv vg cv cT cdom_ cfv cfv wceq cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cT ccat
      wcel vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT
      cdom_ cfv cfv cO wcel cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop
      cH cfv wcel 3simp1 vg cv cT cdom_ cfv cdm wcel cT ccat wcel vg cv cT
      cdom_ cfv cfv cO wcel wi vh cv cT cdom_ cfv cdm wcel cT ccat wcel vg cv
      cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cO wcel cT cdom_ cfv cT vg
      cv cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid imonclem.1 cT cdom_ cfv eqid
      dmo expcom adantr mpan9 adantr cT ccat wcel cB cO wcel cC cO wcel wa cF
      cB cC cop cH cfv wcel w3a cB cO wcel vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa va cv vg cv cT cdom_ cfv cfv wceq cT ccat wcel cB
      cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cB cO wcel cC cO wcel
      cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel 3simp2
      pm3.26d ad2antrr syl3anc cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC
      cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa va cv vg cv cT cdom_ cfv cfv wceq wa vg cv cT cdom_ cfv cdm
      wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv vg
      cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa vg cv cT
      cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi cF cT cdom_ cfv cfv
      cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv
      cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a wb cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv
      wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa va
      cv vg cv cT cdom_ cfv cfv wceq wa cF cT cdom_ cfv cfv cB wceq vg cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg cv cT cdom_ cfv
      cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cdm wcel wa wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg
      cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh
      cv cT ccod_ cfv cfv cB wceq w3a wa wa vg cv cT cdom_ cfv cfv vh cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB
      wceq w3a vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq cF cT cdom_
      cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel
      wa wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_
      cfv cfv cB wceq w3a vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv vh cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vh cv cT ccod_ cfv cfv cB wceq 3simp2 eqcomd ad2antll cF cT cdom_ cfv cfv
      cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg
      cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB
      wceq w3a wa vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq cF cT cdom_
      cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv
      cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_
      cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cB wceq w3a wa vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv
      wceq wi vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv
      cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa cF cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a cF cT cdom_ cfv cfv
      cB wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq wi vh cv cT cdom_
      cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cB wceq w3a vg cv cT ccod_ cfv cfv cB wceq vg cv cT cdom_
      cfv cdm wcel cF cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq wi vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cB wceq cF cT cdom_ cfv cfv cB wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv cB eqtr3 ex 3ad2ant3 adantr com12 adantr imp cF cT cdom_ cfv cfv cB
      wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg cv
      cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq cF cT cdom_ cfv
      cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cB wceq w3a wa vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv
      wceq wi vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv
      cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa cF cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv vg cv cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq w3a cF cT cdom_ cfv cfv
      cB wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq wi vg cv cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cB wceq w3a vh cv cT ccod_ cfv cfv cB wceq vh cv cT cdom_
      cfv cdm wcel cF cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq wi vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq
      vh cv cT ccod_ cfv cfv cB wceq cF cT cdom_ cfv cfv cB wceq vh cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv cB eqtr3 ex 3ad2ant3 adantl com12 adantr imp 3jca cF cT cdom_ cfv cfv
      cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vg cv cT cdom_ cfv
      cfv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel
      vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv
      cB wceq w3a cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cdm wcel wa wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a wa vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cB wceq
      cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cdm wcel wa wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh
      cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq
      vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF cT cdom_ cfv cfv
      cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel simprl
      adantr cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a wa vg cv cT cdom_ cfv cfv eqidd cF cT
      cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq w3a vg cv cT ccod_ cfv cfv cB wceq cF cT cdom_ cfv cfv cB
      wceq vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a vg cv cT ccod_ cfv cfv cB wceq wi vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF cT cdom_ cfv cfv cB wceq vg
      cv cT ccod_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq cF cT cdom_ cfv
      cfv cB wceq vg cv cT ccod_ cfv cfv cB wceq wi vh cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq cF
      cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv cB wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv cB eqtr ex 3ad2ant2 com12 adantr imp 3jca cF
      cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cdm wcel wa wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq w3a wa vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cfv vg cv cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cB wceq cF cT
      cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa vh cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF cT cdom_ cfv cfv cB wceq
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel simprr adantr vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv wceq cF cT cdom_ cfv cfv cB
      wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg cv
      cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv vg cv cT cdom_ cfv cfv vh cv
      cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh
      cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq 3simp1 eqcomd adantl cF cT
      cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq w3a vh cv cT ccod_ cfv cfv cB wceq cF cT cdom_ cfv cfv cB
      wceq vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a vh cv cT ccod_ cfv cfv cB wceq wi vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF cT cdom_ cfv cfv cB wceq vh
      cv cT ccod_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq cF cT cdom_ cfv
      cfv cB wceq vh cv cT ccod_ cfv cfv cB wceq wi vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq cF
      cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv cB wceq vh cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv cB eqtr ex 3ad2ant3 com12 adantr imp 3jca jca
      impbida cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel
      w3a cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa va cv vg cv cT cdom_ cfv cfv wceq cT ccat wcel cB
      cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel cF cT cdom_ cfv cfv cB
      wceq cT ccat wcel cB cO wcel cC cO wcel cF cB cC cop cH cfv wcel cF cT
      cdom_ cfv cfv cB wceq wi cB cC cT cdom_ cfv cT cF cH cO imonclem.1 cT
      cdom_ cfv eqid imonclem.2 dehm 3expib 3imp ad2antrr cT ccat wcel cB cO
      wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa va cv vg cv cT cdom_ cfv cfv wceq
      simplr sylanc imbi1d 3bitrd rcla4dv vg cv va cv cB cop cH cfv wcel vh cv
      va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi wi vh wal vg wal vg cv va cv cB cop cH cfv wcel vh cv va cv cB
      cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi va cO vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh wal vg cv va
      cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi wi vg vg cv va cv cB cop cH cfv wcel
      vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg
      cv vh cv wceq wi wi vh ax-4 a4s r19.20si syl5com sylbi com12 mpdan ex
      com23 imp 19.21ai 19.21ai vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi vg vh cT cdom_ cfv cdm cT cdom_ cfv cdm r2al sylibr jca
      ex $.
      $( [3-Jan-2008] $) $( [1-Jan-2008] $)
  $}

  ${ $d B a g h $.  $d C a g h $.  $d F a g h $.
     $d H a g h $.  $d O a g h $.  $d R a $.  $d T a g h $.
    ismonc.1 $e |- O = dom ( id_ ` T ) $.
    ismonc.2 $e |- H = ( hom ` T ) $.
    ismonc.3 $e |- R = ( o_ ` T ) $.
    $( The predicate "is a monomorphism" when the morphism belongs to a
       homset. $)
    ismonc $p |- ( ( T e. Cat /\ ( B e. O /\ C e. O ) /\
      F e. ( H ` <. B , C >. ) ) -> ( F e. ( Monic ` T ) <->
        A. a e. O A. g e. ( H ` <. a , B >. ) A. h e. ( H ` <. a , B >. )
        ( ( F R g ) = ( F R h ) -> g = h ) ) ) $=
      cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cF cT
      cmon cfv wcel cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR
      co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv
      cdm wral wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va
      cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va cO wral cT ccat wcel
      cF cB cC cop cH cfv wcel cF cT cmon cfv wcel cF cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm wral wa wb cB cO wcel cC cO wcel wa cB cC
      cop cH cfv cT ccod_ cfv cT cdom_ cfv cR cT vg vh cF cT cdom_ cfv cdm cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid ismonc.3 ismonb
      3adant2 cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel
      w3a cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv
      cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral
      wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop
      cH cfv wral vg va cv cB cop cH cfv wral va cO wral cT ccat wcel cB cO
      wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a cF cT cdom_ cfv cdm wcel
      vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv
      cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq
      w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_
      cfv cdm wral vg cT cdom_ cfv cdm wral wa cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH
      cfv wral va cO wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR
      co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv
      cdm wral wa wa va cv cO wcel vg cv va cv cB cop cH cfv wcel vh cv va cv
      cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq
      wi wi vh wal vg wal wi va wal cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop cH cfv wral va cO
      wral cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a
      cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral wa wa
      va cv cO wcel vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv
      wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh wal
      vg wal wi va cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv
      wcel w3a cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_
      cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm
      wral wa va cv cO wcel vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop
      cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi
      vh wal vg wal wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a va cv cO wcel cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg
      cT cdom_ cfv cdm wral wa vg cv va cv cB cop cH cfv wcel vh cv va cv cB
      cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi vh wal vg wal cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a va cv cO wcel cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg
      cT cdom_ cfv cdm wral wa vg cv va cv cB cop cH cfv wcel vh cv va cv cB
      cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi vh wal vg wal cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a va cv cO wcel wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg
      cT cdom_ cfv cdm wral wa wa vg cv va cv cB cop cH cfv wcel vh cv va cv cB
      cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi vh wal vg cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv
      wcel w3a va cv cO wcel wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv
      vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv
      wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co
      cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT
      cdom_ cfv cdm wral wa vg cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC
      cop cH cfv wcel w3a va cv cO wcel wa vg ax-17 cF cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm wral vg cF cT cdom_ cfv cdm wcel vg ax-17 vg
      cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm hbra1 hban hban cT ccat wcel cB cO wcel cC
      cO wcel wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa cF cT cdom_ cfv
      cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral wa wa vg cv va cv cB
      cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv
      cR co wceq vg cv vh cv wceq wi wi vh cT ccat wcel cB cO wcel cC cO wcel
      wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa cF cT cdom_ cfv cdm wcel
      vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv
      cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq
      w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh cT cdom_
      cfv cdm wral vg cT cdom_ cfv cdm wral wa vh cT ccat wcel cB cO wcel cC cO
      wcel wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa vh ax-17 cF cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg
      cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral vh cF cT
      cdom_ cfv cdm wcel vh ax-17 vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi vh cT cdom_ cfv cdm wral vh vg cT cdom_ cfv cdm vg cv cT
      cdom_ cfv cdm wcel vh ax-17 vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi wi vh cT cdom_ cfv cdm hbra1 hbral hban hban cF cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral wa cT ccat wcel cB
      cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa vg cv
      va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co
      cF vh cv cR co wceq vg cv vh cv wceq wi wi vg cv cT cdom_ cfv cfv vh cv
      cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh
      cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv
      cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_
      cfv cdm wral cF cT cdom_ cfv cdm wcel cT ccat wcel cB cO wcel cC cO wcel
      wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa vg cv va cv cB cop cH
      cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi wi vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv
      cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_
      cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv
      cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi wi vg cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT
      cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a wa cF vg cv cR co cF vh cv
      cR co wceq vg cv vh cv wceq wi wi cF cT cdom_ cfv cdm wcel cT ccat wcel
      cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa vg
      cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi wi wi wi vg cv cT cdom_ cfv
      cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi wi vg vh cT cdom_ cfv cdm cT
      cdom_ cfv cdm ra42 vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      pm3.31 cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a
      va cv cO wcel wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq w3a wa cF vg cv cR co cF vh cv cR co wceq vg
      cv vh cv wceq wi wi vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH
      cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a va cv cO
      wcel wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq
      vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq w3a wa cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi wi vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv
      wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi wi cT
      ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a va cv cO
      wcel wa cF cT cdom_ cfv cdm wcel wa vg cv va cv cB cop cH cfv wcel vh cv
      va cv cB cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cdm wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv
      cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq w3a wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel
      w3a va cv cO wcel wa cF cT cdom_ cfv cdm wcel wa vg cv va cv cB cop cH
      cfv wcel vh cv va cv cB cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_
      cfv cfv cB wceq w3a wa vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a wa cT ccat wcel va cv cO wcel cB cO wcel vg cv va cv cB cop
      cH cfv wcel vh cv va cv cB cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel
      vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh
      cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_
      cfv cfv cB wceq w3a wa wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC
      cop cH cfv wcel w3a va cv cO wcel wa cF cT cdom_ cfv cdm wcel wa cT ccat
      wcel va cv cO wcel cB cO wcel w3a vg cv va cv cB cop cH cfv wcel vg cv cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv
      cfv cB wceq w3a vh cv va cv cB cop cH cfv wcel vh cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a
      cT ccat wcel va cv cO wcel cB cO wcel w3a vg cv va cv cB cop cH cfv wcel
      vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT
      ccod_ cfv cfv cB wceq w3a va cv cB cT ccod_ cfv cT cdom_ cfv cT vg cv cH
      cT cdom_ cfv cdm cO ismonc.1 cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT
      ccod_ cfv eqid ismonc.2 ishomd biimpd cT ccat wcel va cv cO wcel cB cO
      wcel w3a vh cv va cv cB cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a va cv cB
      cT ccod_ cfv cT cdom_ cfv cT vh cv cH cT cdom_ cfv cdm cO ismonc.1 cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid ismonc.2 ishomd
      biimpd anim12d cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv
      wcel w3a cT ccat wcel va cv cO wcel cF cT cdom_ cfv cdm wcel cT ccat wcel
      cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel 3simp1 ad2antrr cT ccat
      wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a va cv cO wcel
      cF cT cdom_ cfv cdm wcel simplr cT ccat wcel cB cO wcel cC cO wcel wa cF
      cB cC cop cH cfv wcel w3a cB cO wcel va cv cO wcel cF cT cdom_ cfv cdm
      wcel cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH cfv wcel w3a
      cB cO wcel cC cO wcel cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop
      cH cfv wcel 3simp2 pm3.26d ad2antrr syl3anc cT ccat wcel cB cO wcel cC cO
      wcel wa cF cB cC cop cH cfv wcel w3a va cv cO wcel wa cF cT cdom_ cfv cdm
      wcel wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg
      cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa vg cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cfv
      vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv
      wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a vg cv cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB
      wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh
      cv cT ccod_ cfv cfv cB wceq w3a wa vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa wi cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC
      cop cH cfv wcel w3a va cv cO wcel wa cF cT cdom_ cfv cdm wcel wa vg cv cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv
      cfv cB wceq w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel
      vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a vh
      cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq 3simp1 vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq
      3simp1 anim12i a1i cT ccat wcel cB cO wcel cC cO wcel wa cF cB cC cop cH
      cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv
      wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa vg cv
      cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a wi
      va cv cO wcel cF cT cdom_ cfv cdm wcel cT ccat wcel cB cO wcel cC cO wcel
      wa cF cB cC cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a wi cT ccat wcel cB cO wcel cC cO wcel cF cB cC cop cH cfv
      wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv
      cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa vg cv cT cdom_
      cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a wi wi cT
      ccat wcel cB cO wcel cC cO wcel w3a cF cB cC cop cH cfv wcel cF cT cdom_
      cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv
      wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa vg cv
      cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT
      cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq w3a wi
      cB cC cT cdom_ cfv cT cF cH cO ismonc.1 cT cdom_ cfv eqid ismonc.2 dehm
      cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT ccod_
      cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv
      cfv wceq w3a cF cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_
      cfv cfv cB wceq w3a wa wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv cF cT cdom_ cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq
      w3a wa vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq cF cT cdom_ cfv
      cfv cB wceq vg cv cT cdom_ cfv cfv va cv wceq vh cv cT cdom_ cfv cfv va
      cv wceq vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv cfv wceq vg cv cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB
      wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh
      cv cT ccod_ cfv cfv cB wceq w3a vg cv cT cdom_ cfv cfv vh cv cT cdom_ cfv
      cfv va cv eqtr3 vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv
      wceq vg cv cT ccod_ cfv cfv cB wceq 3simp2 vh cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq 3simp2
      syl2an adantl vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv
      wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a wa cF cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vg
      cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_
      cfv cfv cB wceq w3a cF cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv cF
      cT cdom_ cfv cfv wceq wi vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a vg cv cT ccod_ cfv cfv
      cB wceq vg cv cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cB wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq wi vg cv cT cdom_ cfv cfv va cv
      wceq vg cv cT ccod_ cfv cfv cB wceq cF cT cdom_ cfv cfv cB wceq vg cv cT
      ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vg cv cT ccod_ cfv cfv cF cT cdom_
      cfv cfv cB eqtr3 ex 3ad2ant3 adantr impcom vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB wceq w3a vh cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_
      cfv cfv cB wceq w3a wa cF cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv
      cF cT cdom_ cfv cfv wceq vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq w3a cF cT cdom_ cfv cfv cB
      wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq wi vg cv cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv va cv wceq vg cv cT ccod_ cfv cfv cB
      wceq w3a vh cv cT ccod_ cfv cfv cB wceq vh cv cT cdom_ cfv cdm wcel cF cT
      cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq wi
      vh cv cT cdom_ cfv cfv va cv wceq vh cv cT ccod_ cfv cfv cB wceq cF cT
      cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv wceq vh
      cv cT ccod_ cfv cfv cF cT cdom_ cfv cfv cB eqtr3 ex 3ad2ant3 adantl
      impcom 3jca ex syl6 3expib 3imp ad2antrr jcad syld imim1d ex com13 3syl
      impcom impcom 19.21ai 19.21ai exp31 com23 imp 19.21aiv cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv
      cB cop cH cfv wral va cO wral vg cv va cv cB cop cH cfv wcel vh cv va cv
      cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq
      wi wi vh wal vg wal va cO wral va cv cO wcel vg cv va cv cB cop cH cfv
      wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi wi vh wal vg wal wi va wal cF vg cv cR co cF vh cv cR
      co wceq vg cv vh cv wceq wi vh va cv cB cop cH cfv wral vg va cv cB cop
      cH cfv wral vg cv va cv cB cop cH cfv wcel vh cv va cv cB cop cH cfv wcel
      wa cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh wal vg
      wal va cO cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vg vh va
      cv cB cop cH cfv va cv cB cop cH cfv r2al ralbii vg cv va cv cB cop cH
      cfv wcel vh cv va cv cB cop cH cfv wcel wa cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi vh wal vg wal va cO df-ral bitri sylibr ex cB
      cC cR cT vg vh cF cH cO va ismonc.1 ismonc.2 ismonc.3 imonclem impbid
      bitrd $.
      $( [3-Jan-2008] $) $( [2-Jan-2008] $)
  $}


  ${ $d A a g h $.  $d B a g h k l $.  $d C a g h k l $.  $d F a g h k l $.
    $d G a g h k l $.  $d H a g h k l $.  $d O a g h k l $.
    $d R a g h k l $.  $d T a g h k l $.
    cmpmon.1 $e |- O = dom ( id_ ` T ) $.
    cmpmon.2 $e |- H = ( hom ` T ) $.
    cmpmon.3 $e |- R = ( o_ ` T ) $.
    $( The composite of two monomorphisms is a monomorphism.
       JFM CAT_1 th. 61 $)
    cmpmon $p |- ( ( T e. Cat /\ ( ( A e. O /\ B e. O /\ C e. O ) /\
         ( F e. ( H ` <. A , B >. ) /\ G e. ( H ` <. B , C >. ) )
           /\ ( F e. ( Monic ` T ) /\ G e. ( Monic ` T ) ) ) ) ->
              ( G R F ) e. ( Monic ` T ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa cF cT cmon cfv wcel cG cT cmon cfv wcel
      wa cG cF cR co cT cmon cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cF cT cmon
      cfv wcel cG cT cmon cfv wcel wa cG cF cR co cT cmon cfv wcel wi cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral cG cF cR co cT
      cmon cfv wcel cF cT cmon cfv wcel cG cT cmon cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa cG cF cR co vg cv cR co cG cF
      cR co vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg
      va cv cA cop cH cfv wral va cO wral cG cF cR co cT cmon cfv wcel cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa cG cF cR co vg
      cv cR co cG cF cR co vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop
      cH cfv wral vg va cv cA cop cH cfv wral va cO wral cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa wa cG cF cR co vg cv cR co cG
      cF cR co vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral
      vg va cv cA cop cH cfv wral va cO cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv
      cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral wa va cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va
      ax-17 cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA
      cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG
      vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv
      cB cop cH cfv wral va cO wral va cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va
      cO hbra1 cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv
      cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO hbra1 hban hban cT
      ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel
      cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va
      cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv
      cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO
      wcel cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO
      wcel wa cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv cT ccat wcel
      cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC
      cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO
      wcel vg cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH
      cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      vg cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a vg ax-17 cF vg cv cR co cF vh cv cR
      co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop
      cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv
      wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO
      wral vg cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv
      cA cop cH cfv wral vg va cv cA cop cH cfv wral vg va cO va cv cO wcel vg
      ax-17 cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA
      cop cH cfv wral vg va cv cA cop cH cfv hbra1 hbral cG vk cv cR co cG vl
      cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral vg ax-17 hban hban va cv cO wcel vg ax-17 hban
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv
      wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl
      va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va
      cv cO wcel wa vg cv va cv cA cop cH cfv wcel cG cF cR co vg cv cR co cG
      cF cR co vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv
      wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl
      va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va
      cv cO wcel wa vg cv va cv cA cop cH cfv wcel wa cG cF cR co vg cv cR co
      cG cF cR co vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv
      wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl
      va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va
      cv cO wcel wa vg cv va cv cA cop cH cfv wcel vh cT ccat wcel cA cO wcel
      cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va
      cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR
      co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk
      va cv cB cop cH cfv wral va cO wral wa wa va cv cO wcel vh cT ccat wcel
      cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC
      cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa vh cT ccat wcel
      cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC
      cop cH cfv wcel wa w3a vh ax-17 cF vg cv cR co cF vh cv cR co wceq vg cv
      vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va
      cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv
      cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral vh cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg
      va cv cA cop cH cfv wral vh va cO va cv cO wcel vh ax-17 cF vg cv cR co
      cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vh vg
      va cv cA cop cH cfv vg cv va cv cA cop cH cfv wcel vh ax-17 cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv hbra1
      hbral hbral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va
      cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral vh ax-17
      hban hban va cv cO wcel vh ax-17 hban vg cv va cv cA cop cH cfv wcel vh
      ax-17 hban cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      wa va cv cO wcel wa vg cv va cv cA cop cH cfv wcel wa vh cv va cv cA cop
      cH cfv wcel cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq vg cv vh
      cv wceq wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      wa va cv cO wcel wa vg cv va cv cA cop cH cfv wcel wa vh cv va cv cA cop
      cH cfv wcel wa cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq cG cF
      vg cv cR co cR co cG cF vh cv cR co cR co wceq vg cv vh cv wceq cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO
      wcel wa vg cv va cv cA cop cH cfv wcel wa vh cv va cv cA cop cH cfv wcel
      wa cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq cG cF vg cv cR co
      cR co cG cF vh cv cR co cR co wceq cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv
      cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv cA cop cH
      cfv wcel wa vh cv va cv cA cop cH cfv wcel wa cG cF cR co vg cv cR co cG
      cF cR co vh cv cR co wceq wa cG cF vg cv cR co cR co cG cF cR co vg cv cR
      co cG cF cR co vh cv cR co cG cF vh cv cR co cR co cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv
      cA cop cH cfv wcel wa cG cF vg cv cR co cR co cG cF cR co vg cv cR co
      wceq vh cv va cv cA cop cH cfv wcel cG cF cR co vg cv cR co cG cF cR co
      vh cv cR co wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA
      cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh
      cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA
      cop cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv
      wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO
      wral wa wa va cv cO wcel vg cv va cv cA cop cH cfv wcel cG cF vg cv cR co
      cR co cG cF cR co vg cv cR co wceq cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va
      cv cO wcel vg cv va cv cA cop cH cfv wcel cG cF vg cv cR co cR co cG cF
      cR co vg cv cR co wceq wi wi cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa cT ccat wcel cA
      cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop
      cH cfv wcel wa va cv cO wcel vg cv va cv cA cop cH cfv wcel cG cF vg cv
      cR co cR co cG cF cR co vg cv cR co wceq wi wi cT ccat wcel cA cO wcel cB
      cO wcel cC cO wcel w3a va cv cO wcel cF cA cB cop cH cfv wcel cG cB cC
      cop cH cfv wcel wa vg cv va cv cA cop cH cfv wcel cG cF vg cv cR co cR co
      cG cF cR co vg cv cR co wceq wi va cv cO wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cT ccat wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      wa vg cv va cv cA cop cH cfv wcel cG cF vg cv cR co cR co cG cF cR co vg
      cv cR co wceq wi wi va cv cO wcel cA cO wcel cB cO wcel cC cO wcel cT
      ccat wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa vg cv va
      cv cA cop cH cfv wcel cG cF vg cv cR co cR co cG cF cR co vg cv cR co
      wceq wi wi wi va cv cO wcel cA cO wcel cB cO wcel cC cO wcel cT ccat wcel
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa vg cv va cv cA cop
      cH cfv wcel cG cF vg cv cR co cR co cG cF cR co vg cv cR co wceq wi wi wi
      vg cv va cv cA cop cH cfv wcel cT ccat wcel cF cA cB cop cH cfv wcel cG
      cB cC cop cH cfv wcel wa va cv cO wcel cA cO wcel wa cB cO wcel cC cO
      wcel wa wa cG cF vg cv cR co cR co cG cF cR co vg cv cR co wceq vg cv va
      cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      wa cT ccat wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa wa
      cG cF vg cv cR co cR co cG cF cR co vg cv cR co wceq wi vg cv va cv cA
      cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel cT ccat
      wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa wa cG cF vg cv
      cR co cR co cG cF cR co vg cv cR co wceq wi wi cT ccat wcel va cv cO wcel
      cA cO wcel wa cB cO wcel cC cO wcel wa wa vg cv va cv cA cop cH cfv wcel
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF vg cv cR co
      cR co cG cF cR co vg cv cR co wceq cT ccat wcel va cv cO wcel cA cO wcel
      wa cB cO wcel cC cO wcel wa vg cv va cv cA cop cH cfv wcel cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF vg cv cR co cR co cG cF cR
      co vg cv cR co wceq wi va cv cA cB cC cR cT cH vg cv cF cG cO cmpmon.1
      cmpmon.2 cmpmon.3 cmpassoh 3expib com3r 3expib com23 com14 exp43 3impd
      com13 com34 3imp adantr imp31 ad2antrr cG cF cR co vg cv cR co cG cF cR
      co vh cv cR co wceq cG cF cR co vh cv cR co cG cF cR co vg cv cR co wceq
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv
      wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl
      va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va
      cv cO wcel wa vg cv va cv cA cop cH cfv wcel wa vh cv va cv cA cop cH cfv
      wcel wa cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq cG cF cR co
      vh cv cR co cG cF cR co vg cv cR co wceq cG cF cR co vg cv cR co cG cF cR
      co vh cv cR co eqcom biimpi adantl cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv
      cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv cA cop cH
      cfv wcel wa vh cv va cv cA cop cH cfv wcel wa cG cF cR co vh cv cR co cG
      cF vh cv cR co cR co wceq cG cF cR co vg cv cR co cG cF cR co vh cv cR co
      wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH
      cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      wa va cv cO wcel wa vg cv va cv cA cop cH cfv wcel wa vh cv va cv cA cop
      cH cfv wcel cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB
      cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO
      wcel wa vh cv va cv cA cop cH cfv wcel cG cF cR co vh cv cR co cG cF vh
      cv cR co cR co wceq wi vg cv va cv cA cop cH cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO wcel vh cv va cv cA
      cop cH cfv wcel cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq wi
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a va cv cO wcel vh cv va cv cA cop cH
      cfv wcel cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq wi wi cF vg
      cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv
      wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co
      wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH
      cfv wral va cO wral wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa va cv cO wcel vh cv
      va cv cA cop cH cfv wcel cG cF cR co vh cv cR co cG cF vh cv cR co cR co
      wceq wi wi vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa va cv cO wcel cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a wa cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq vh cv
      va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel va cv cO wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa
      cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq wi wi cT ccat wcel
      cA cO wcel cB cO wcel cC cO wcel w3a wa va cv cO wcel vh cv va cv cA cop
      cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF
      cR co vh cv cR co cG cF vh cv cR co cR co wceq cA cO wcel cB cO wcel cC
      cO wcel w3a cT ccat wcel va cv cO wcel vh cv va cv cA cop cH cfv wcel cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vh cv cR
      co cG cF vh cv cR co cR co wceq wi wi cA cO wcel cB cO wcel cC cO wcel cT
      ccat wcel va cv cO wcel vh cv va cv cA cop cH cfv wcel cF cA cB cop cH
      cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vh cv cR co cG cF vh cv
      cR co cR co wceq wi wi wi cB cO wcel cC cO wcel cT ccat wcel cA cO wcel
      va cv cO wcel vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG
      cB cC cop cH cfv wcel w3a cG cF cR co vh cv cR co cG cF vh cv cR co cR co
      wceq wi wi cB cO wcel cC cO wcel cT ccat wcel cA cO wcel va cv cO wcel vh
      cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel w3a cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq wi wi wi wi
      cT ccat wcel cB cO wcel cC cO wcel wa cA cO wcel va cv cO wcel vh cv va
      cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      w3a cG cF cR co vh cv cR co cG cF vh cv cR co cR co wceq wi wi wi va cv
      cO wcel cB cO wcel cC cO wcel wa cA cO wcel cT ccat wcel vh cv va cv cA
      cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG
      cF cR co vh cv cR co cG cF vh cv cR co cR co wceq wi va cv cO wcel cA cO
      wcel cB cO wcel cC cO wcel wa cT ccat wcel vh cv va cv cA cop cH cfv wcel
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vh cv
      cR co cG cF vh cv cR co cR co wceq wi wi va cv cO wcel cA cO wcel cB cO
      wcel cC cO wcel wa cT ccat wcel vh cv va cv cA cop cH cfv wcel cF cA cB
      cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vh cv cR co cG
      cF vh cv cR co cR co wceq wi wi wi cT ccat wcel va cv cO wcel cA cO wcel
      wa cB cO wcel cC cO wcel wa vh cv va cv cA cop cH cfv wcel cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vh cv cR co cG cF vh
      cv cR co cR co wceq wi cT ccat wcel va cv cO wcel cA cO wcel wa cB cO
      wcel cC cO wcel wa vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vh cv cR co cG cF vh cv cR
      co cR co wceq cT ccat wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO
      wcel wa w3a vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel w3a wa cG cF vh cv cR co cR co cG cF cR co vh cv cR co
      cT ccat wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa w3a vh
      cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel w3a cG cF vh cv cR co cR co cG cF cR co vh cv cR co wceq va cv cA cB
      cC cR cT cH vh cv cF cG cO cmpmon.1 cmpmon.2 cmpmon.3 cmpassoh imp eqcomd
      3exp1 com3l ex com23 com14 com12 ex com4r 3imp impcom com13 3expib com14
      3impia adantr imp adantr imp adantr 3eqtr2d ex cT ccat wcel cA cO wcel cB
      cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA
      cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG
      vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv
      cB cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv cA cop
      cH cfv wcel wa vh cv va cv cA cop cH cfv wcel wa cG cF vg cv cR co cR co
      cG cF vh cv cR co cR co wceq cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq cF vg cv cR co va cv cB cop cH cfv wcel cF vh cv cR co va cv cB
      cop cH cfv wcel wa cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi
      vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral cG cF vg cv cR co
      cR co cG cF vh cv cR co cR co wceq cF vg cv cR co cF vh cv cR co wceq wi
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq
      vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv
      wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl
      va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa wa va
      cv cO wcel wa vg cv va cv cA cop cH cfv wcel wa vh cv va cv cA cop cH cfv
      wcel wa cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq wi cG cF vg
      cv cR co cR co cG cF vh cv cR co cR co wceq cF vg cv cR co cF vh cv cR co
      wceq wi cG cF vg cv cR co cR co cG vl cv cR co wceq cF vg cv cR co vl cv
      wceq wi vk vl cF vg cv cR co cF vh cv cR co va cv cB cop cH cfv va cv cB
      cop cH cfv vk cv cF vg cv cR co wceq cG vk cv cR co cG vl cv cR co wceq
      cG cF vg cv cR co cR co cG vl cv cR co wceq vk cv vl cv wceq cF vg cv cR
      co vl cv wceq vk cv cF vg cv cR co wceq cG vk cv cR co cG cF vg cv cR co
      cR co cG vl cv cR co vk cv cF vg cv cR co cG cR opreq2 eqeq1d vk cv cF vg
      cv cR co vl cv eqeq1 imbi12d vl cv cF vh cv cR co wceq cG cF vg cv cR co
      cR co cG vl cv cR co wceq cG cF vg cv cR co cR co cG cF vh cv cR co cR co
      wceq cF vg cv cR co vl cv wceq cF vg cv cR co cF vh cv cR co wceq vl cv
      cF vh cv cR co wceq cG vl cv cR co cG cF vh cv cR co cR co cG cF vg cv cR
      co cR co vl cv cF vh cv cR co cG cR opreq2 eqeq2d vl cv cF vh cv cR co cF
      vg cv cR co eqeq2 imbi12d rcla42v cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv
      cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv cA cop cH
      cfv wcel wa vh cv va cv cA cop cH cfv wcel wa cF vg cv cR co va cv cB cop
      cH cfv wcel cF vh cv cR co va cv cB cop cH cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv
      cA cop cH cfv wcel wa cF vg cv cR co va cv cB cop cH cfv wcel vh cv va cv
      cA cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv
      cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl
      cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO
      wral wa wa va cv cO wcel vg cv va cv cA cop cH cfv wcel cF vg cv cR co va
      cv cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va cv cO wcel vg
      cv va cv cA cop cH cfv wcel cF vg cv cR co va cv cB cop cH cfv wcel wi wi
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv
      cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral wa cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa va cv cO
      wcel vg cv va cv cA cop cH cfv wcel cF vg cv cR co va cv cB cop cH cfv
      wcel wi wi cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cA cO
      wcel cB cO wcel cC cO wcel w3a cT ccat wcel va cv cO wcel vg cv va cv cA
      cop cH cfv wcel cF vg cv cR co va cv cB cop cH cfv wcel wi wi cF cA cB
      cop cH cfv wcel cA cO wcel cB cO wcel cC cO wcel w3a cT ccat wcel va cv
      cO wcel vg cv va cv cA cop cH cfv wcel cF vg cv cR co va cv cB cop cH cfv
      wcel wi wi wi wi cG cB cC cop cH cfv wcel cF cA cB cop cH cfv wcel cA cO
      wcel cB cO wcel wa cT ccat wcel va cv cO wcel vg cv va cv cA cop cH cfv
      wcel cF vg cv cR co va cv cB cop cH cfv wcel wi wi wi cA cO wcel cB cO
      wcel cC cO wcel w3a va cv cO wcel cA cO wcel cB cO wcel wa cT ccat wcel
      cF cA cB cop cH cfv wcel vg cv va cv cA cop cH cfv wcel cF vg cv cR co va
      cv cB cop cH cfv wcel wi va cv cO wcel cA cO wcel cB cO wcel cT ccat wcel
      cF cA cB cop cH cfv wcel vg cv va cv cA cop cH cfv wcel cF vg cv cR co va
      cv cB cop cH cfv wcel wi wi wi vg cv va cv cA cop cH cfv wcel cT ccat
      wcel cF cA cB cop cH cfv wcel va cv cO wcel cA cO wcel cB cO wcel w3a cF
      vg cv cR co va cv cB cop cH cfv wcel vg cv va cv cA cop cH cfv wcel cF cA
      cB cop cH cfv wcel cT ccat wcel va cv cO wcel cA cO wcel cB cO wcel w3a
      cF vg cv cR co va cv cB cop cH cfv wcel wi vg cv va cv cA cop cH cfv wcel
      cF cA cB cop cH cfv wcel cT ccat wcel va cv cO wcel cA cO wcel cB cO wcel
      w3a cF vg cv cR co va cv cB cop cH cfv wcel wi wi cT ccat wcel va cv cO
      wcel cA cO wcel cB cO wcel w3a vg cv va cv cA cop cH cfv wcel cF cA cB
      cop cH cfv wcel wa cF vg cv cR co va cv cB cop cH cfv wcel cT ccat wcel
      va cv cO wcel cA cO wcel cB cO wcel w3a vg cv va cv cA cop cH cfv wcel cF
      cA cB cop cH cfv wcel wa cF vg cv cR co va cv cB cop cH cfv wcel wi va cv
      cA cB cR cT vg cv cF cH cO cmpmon.1 cmpmon.2 cmpmon.3 homgrf ex com3r ex
      com23 com14 3expib com14 cA cO wcel cB cO wcel cC cO wcel 3simpa syl5
      adantr com13 3imp adantr imp31 adantr cT ccat wcel cA cO wcel cB cO wcel
      cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv
      cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral va cO wral wa wa va cv cO wcel wa vg cv va cv cA cop cH
      cfv wcel wa vh cv va cv cA cop cH cfv wcel cF vh cv cR co va cv cB cop cH
      cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      wa va cv cO wcel wa vh cv va cv cA cop cH cfv wcel cF vh cv cR co va cv
      cB cop cH cfv wcel wi vg cv va cv cA cop cH cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO wcel vh cv va cv cA
      cop cH cfv wcel cF vh cv cR co va cv cB cop cH cfv wcel wi cT ccat wcel
      cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC
      cop cH cfv wcel wa w3a va cv cO wcel vh cv va cv cA cop cH cfv wcel cF vh
      cv cR co va cv cB cop cH cfv wcel wi wi cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa va cv cO wcel vh cv va cv cA cop cH cfv
      wcel cF vh cv cR co va cv cB cop cH cfv wcel wi wi cA cO wcel cB cO wcel
      cC cO wcel w3a cT ccat wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel wa va cv cO wcel vh cv va cv cA cop cH cfv wcel cF vh cv cR co va cv
      cB cop cH cfv wcel wi wi wi cA cO wcel cB cO wcel cT ccat wcel cF cA cB
      cop cH cfv wcel cG cB cC cop cH cfv wcel wa va cv cO wcel vh cv va cv cA
      cop cH cfv wcel cF vh cv cR co va cv cB cop cH cfv wcel wi wi wi wi cC cO
      wcel cA cO wcel cB cO wcel wa va cv cO wcel cF cA cB cop cH cfv wcel cG
      cB cC cop cH cfv wcel wa cT ccat wcel vh cv va cv cA cop cH cfv wcel cF
      vh cv cR co va cv cB cop cH cfv wcel wi va cv cO wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat wcel
      vh cv va cv cA cop cH cfv wcel cF vh cv cR co va cv cB cop cH cfv wcel wi
      wi wi va cv cO wcel cA cO wcel cB cO wcel cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa cT ccat wcel vh cv va cv cA cop cH cfv wcel cF vh
      cv cR co va cv cB cop cH cfv wcel wi wi wi va cv cO wcel cA cO wcel cB cO
      wcel w3a cF cA cB cop cH cfv wcel cT ccat wcel vh cv va cv cA cop cH cfv
      wcel cF vh cv cR co va cv cB cop cH cfv wcel wi wi cG cB cC cop cH cfv
      wcel vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cT ccat wcel
      va cv cO wcel cA cO wcel cB cO wcel w3a cF vh cv cR co va cv cB cop cH
      cfv wcel vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cT ccat
      wcel va cv cO wcel cA cO wcel cB cO wcel w3a cF vh cv cR co va cv cB cop
      cH cfv wcel wi wi cT ccat wcel va cv cO wcel cA cO wcel cB cO wcel w3a vh
      cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel wa cF vh cv cR co va
      cv cB cop cH cfv wcel cT ccat wcel va cv cO wcel cA cO wcel cB cO wcel
      w3a vh cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel wa cF vh cv
      cR co va cv cB cop cH cfv wcel wi va cv cA cB cR cT vh cv cF cH cO
      cmpmon.1 cmpmon.2 cmpmon.3 homgrf ex com3r ex com14 adantrd 3expib com12
      com24 3adant3 com12 3imp adantr imp adantr imp jca cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral wa wa va cv cO wcel wa cG vk cv cR
      co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk
      va cv cB cop cH cfv wral vg cv va cv cA cop cH cfv wcel vh cv va cv cA
      cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA
      cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh
      cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA
      cop cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv
      wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO
      wral wa wa va cv cO wcel cG vk cv cR co cG vl cv cR co wceq vk cv vl cv
      wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral cG vk cv
      cR co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral
      vk va cv cB cop cH cfv wral va cO wral va cv cO wcel cG vk cv cR co cG vl
      cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB
      cop cH cfv wral wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv
      cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl
      cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO
      ra4 ad2antll imp ad2antrr sylc cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg
      cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv
      wral vg va cv cA cop cH cfv wral va cO wral cG vk cv cR co cG vl cv cR co
      wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH
      cfv wral va cO wral wa wa va cv cO wcel vg cv va cv cA cop cH cfv wcel vh
      cv va cv cA cop cH cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH
      cfv wral va cO wral cG vk cv cR co cG vl cv cR co wceq vk cv vl cv wceq
      wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral va cO wral wa
      wa va cv cO wcel vg cv va cv cA cop cH cfv wcel vh cv va cv cA cop cH cfv
      wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH cfv wral vg
      va cv cA cop cH cfv wral va cO wral va cv cO wcel vg cv va cv cA cop cH
      cfv wcel vh cv va cv cA cop cH cfv wcel w3a cF vg cv cR co cF vh cv cR co
      wceq vg cv vh cv wceq wi wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
      w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cG vk cv cR
      co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk
      va cv cB cop cH cfv wral va cO wral cF vg cv cR co cF vh cv cR co wceq vg
      cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral
      va cO wral va cv cO wcel vg cv va cv cA cop cH cfv wcel vh cv va cv cA
      cop cH cfv wcel w3a cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq
      wi wi vg vh cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va
      cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral va cv cO
      wcel vg cv va cv cA cop cH cfv wcel vh cv va cv cA cop cH cfv wcel w3a cF
      vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi wi vh wal vg wal va
      cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv cA cop cH
      cfv wral vg va cv cA cop cH cfv wral va cO wral va cv cO wcel vg cv va cv
      cA cop cH cfv wcel vh cv va cv cA cop cH cfv wcel w3a cF vg cv cR co cF
      vh cv cR co wceq vg cv vh cv wceq wi wi vh wal vg wal va wal cF vg cv cR
      co cF vh cv cR co wceq vg cv vh cv wceq wi va vg vh cO va cv cA cop cH
      cfv va cv cA cop cH cfv r3al biimpi 19.21bi 19.21bbi ad2antrl 3expd imp41
      syld syld ex r19.21ai ex r19.21ai ex r19.21ai ex cT ccat wcel cA cO wcel
      cC cO wcel wa cG cF cR co cA cC cop cH cfv wcel cG cF cR co cT cmon cfv
      wcel cG cF cR co vg cv cR co cG cF cR co vh cv cR co wceq vg cv vh cv
      wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral wb cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH
      cfv wcel cG cB cC cop cH cfv wcel wa w3a cA cC cR cT vg vh cG cF cR co cH
      cO va cmpmon.1 cmpmon.2 cmpmon.3 ismonc cT ccat wcel cA cO wcel cB cO
      wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa
      3simp1 cA cO wcel cB cO wcel cC cO wcel w3a cT ccat wcel cA cO wcel cC cO
      wcel wa cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cA cO wcel
      cB cO wcel cC cO wcel 3simpb 3ad2ant2 cT ccat wcel cA cO wcel cB cO wcel
      cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF
      cR co cA cC cop cH cfv wcel cA cB cC cR cT cF cG cH cO cmpmon.1 cmpmon.2
      cmpmon.3 homgrf 3impia syl3anc sylibrd cT ccat wcel cA cO wcel cB cO wcel
      cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cF cT
      cmon cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral wi cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel cG cB cC cop
      cH cfv wcel wa cF cT cmon cfv wcel cF vg cv cR co cF vh cv cR co wceq vg
      cv vh cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral
      va cO wral wi wi cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa cA cO wcel cB cO wcel wa cT ccat wcel cF
      cT cmon cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral wi cF
      cA cB cop cH cfv wcel cA cO wcel cB cO wcel wa cT ccat wcel cF cT cmon
      cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh va cv
      cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral wi wi wi cG cB
      cC cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH
      cfv wcel cF cT cmon cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh
      cv wceq wi vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO
      wral wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel cF
      cT cmon cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi
      vh va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral wi cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a cF cT
      cmon cfv wcel cF vg cv cR co cF vh cv cR co wceq vg cv vh cv wceq wi vh
      va cv cA cop cH cfv wral vg va cv cA cop cH cfv wral va cO wral cA cB cR
      cT vg vh cF cH cO va cmpmon.1 cmpmon.2 cmpmon.3 ismonc biimpd 3exp com13
      adantr com13 cA cO wcel cB cO wcel cC cO wcel 3simpa syl5 3imp cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa cG cT cmon cfv wcel cG vk cv cR co cG vl cv cR co
      wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH
      cfv wral va cO wral wi cT ccat wcel cB cO wcel cC cO wcel wa cF cA cB cop
      cH cfv wcel cG cB cC cop cH cfv wcel wa cG cT cmon cfv wcel cG vk cv cR
      co cG vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk
      va cv cB cop cH cfv wral va cO wral wi wi cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cB cO wcel
      cC cO wcel wa cT ccat wcel cG cT cmon cfv wcel cG vk cv cR co cG vl cv cR
      co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop
      cH cfv wral va cO wral wi cG cB cC cop cH cfv wcel cB cO wcel cC cO wcel
      wa cT ccat wcel cG cT cmon cfv wcel cG vk cv cR co cG vl cv cR co wceq vk
      cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral
      va cO wral wi wi wi cF cA cB cop cH cfv wcel cT ccat wcel cB cO wcel cC
      cO wcel wa cG cB cC cop cH cfv wcel cG cT cmon cfv wcel cG vk cv cR co cG
      vl cv cR co wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv
      cB cop cH cfv wral va cO wral wi cT ccat wcel cB cO wcel cC cO wcel wa cG
      cB cC cop cH cfv wcel cG cT cmon cfv wcel cG vk cv cR co cG vl cv cR co
      wceq vk cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH
      cfv wral va cO wral wi cT ccat wcel cB cO wcel cC cO wcel wa cG cB cC cop
      cH cfv wcel w3a cG cT cmon cfv wcel cG vk cv cR co cG vl cv cR co wceq vk
      cv vl cv wceq wi vl va cv cB cop cH cfv wral vk va cv cB cop cH cfv wral
      va cO wral cB cC cR cT vk vl cG cH cO va cmpmon.1 cmpmon.2 cmpmon.3
      ismonc biimpd 3exp com13 adantl com13 cA cO wcel cB cO wcel cC cO wcel
      3simpc syl5 3imp syl2and 3exp 3imp2 $.
      $( [10-Mar-2008] $) $( [10-Mar-2008] $)
  $}

  ${ $d A a m n $.  $d B a m n $.  $d C a m n $.  $d F a m n $.  $d G a m n $.
    $d H a m n $.  $d O a m n $.  $d R a m n $.  $d T a m n $.
    icmpmon.1 $e |- O = dom ( id_ ` T ) $.
    icmpmon.2 $e |- H = ( hom ` T ) $.
    icmpmon.3 $e |- R = ( o_ ` T ) $.
    $( If  ` ( G R F ) ` is a monomorphism then ` F ` is a monomorphism.
       JFM CAT_1 th. 62 $)
    icmpmon $p |- ( ( T e. Cat /\ ( ( A e. O /\ B e. O /\ C e. O ) /\
         ( F e. ( H ` <. A , B >. ) /\ G e. ( H ` <. B , C >. ) )
           /\ ( G R F ) e. ( Monic ` T ) ) ) ->
              F e. ( Monic ` T ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cmon cfv wcel w3a wa cF
      cT cmon cfv wcel cF vm cv cR co cF vn cv cR co wceq vm cv vn cv wceq wi
      vn va cv cA cop cH cfv wral vm va cv cA cop cH cfv wral va cO wral cT
      ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel
      cG cB cC cop cH cfv wcel wa cG cF cR co cT cmon cfv wcel cF vm cv cR co
      cF vn cv cR co wceq vm cv vn cv wceq wi vn va cv cA cop cH cfv wral vm va
      cv cA cop cH cfv wral va cO wral cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR co
      cT cmon cfv wcel cF vm cv cR co cF vn cv cR co wceq vm cv vn cv wceq wi
      vn va cv cA cop cH cfv wral vm va cv cA cop cH cfv wral va cO wral wi cT
      ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel
      cG cB cC cop cH cfv wcel wa w3a cG cF cR co cT cmon cfv wcel cG cF cR co
      vm cv cR co cG cF cR co vn cv cR co wceq vm cv vn cv wceq wi vn va cv cA
      cop cH cfv wral vm va cv cA cop cH cfv wral va cO wral cF vm cv cR co cF
      vn cv cR co wceq vm cv vn cv wceq wi vn va cv cA cop cH cfv wral vm va cv
      cA cop cH cfv wral va cO wral cT ccat wcel cA cO wcel cC cO wcel wa cG cF
      cR co cA cC cop cH cfv wcel cG cF cR co cT cmon cfv wcel cG cF cR co vm
      cv cR co cG cF cR co vn cv cR co wceq vm cv vn cv wceq wi vn va cv cA cop
      cH cfv wral vm va cv cA cop cH cfv wral va cO wral wb cT ccat wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH
      cfv wcel wa w3a cA cC cR cT vm vn cG cF cR co cH cO va icmpmon.1
      icmpmon.2 icmpmon.3 ismonc cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
      w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa 3simp1 cA cO
      wcel cB cO wcel cC cO wcel w3a cT ccat wcel cA cO wcel cC cO wcel wa cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cA cO wcel cB cO wcel
      cC cO wcel 3simpb 3ad2ant2 cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
      w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR co cA
      cC cop cH cfv wcel cA cB cC cR cT cF cG cH cO icmpmon.1 icmpmon.2
      icmpmon.3 homgrf 3impia syl3anc cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a cG cF
      cR co vm cv cR co cG cF cR co vn cv cR co wceq vm cv vn cv wceq wi vn va
      cv cA cop cH cfv wral vm va cv cA cop cH cfv wral cF vm cv cR co cF vn cv
      cR co wceq vm cv vn cv wceq wi vn va cv cA cop cH cfv wral vm va cv cA
      cop cH cfv wral va cO cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va cv cO wcel wa
      cG cF cR co vm cv cR co cG cF cR co vn cv cR co wceq vm cv vn cv wceq wi
      vn va cv cA cop cH cfv wral cF vm cv cR co cF vn cv cR co wceq vm cv vn
      cv wceq wi vn va cv cA cop cH cfv wral vm va cv cA cop cH cfv cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a va cv cO wcel wa vm cv va cv cA cop cH cfv wcel
      wa cG cF cR co vm cv cR co cG cF cR co vn cv cR co wceq vm cv vn cv wceq
      wi cF vm cv cR co cF vn cv cR co wceq vm cv vn cv wceq wi vn va cv cA cop
      cH cfv cG cF cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR co
      vn cv cR co cG cF vn cv cR co cR co wceq cG cF cR co vm cv cR co cG cF cR
      co vn cv cR co wceq vm cv vn cv wceq wi cF vm cv cR co cF vn cv cR co
      wceq vm cv vn cv wceq wi wi cT ccat wcel cA cO wcel cB cO wcel cC cO wcel
      w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va cv cO
      wcel wa vm cv va cv cA cop cH cfv wcel wa vn cv va cv cA cop cH cfv wcel
      wa cG cF cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR co vn cv
      cR co cG cF vn cv cR co cR co wceq wa cG cF cR co vm cv cR co cG cF cR co
      vn cv cR co wceq vm cv vn cv wceq wi cG cF vm cv cR co cR co cG cF vn cv
      cR co cR co wceq vm cv vn cv wceq cF vm cv cR co cF vn cv cR co wceq cG
      cF cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR co vn cv cR co
      cG cF vn cv cR co cR co wceq wa cG cF vm cv cR co cR co cG cF vn cv cR co
      cR co wceq cG cF cR co vm cv cR co cG cF cR co vn cv cR co wceq vm cv vn
      cv wceq cG cF cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR co
      vn cv cR co cG cF vn cv cR co cR co wceq wa cG cF vm cv cR co cR co cG cF
      vn cv cR co cR co wceq cG cF cR co vm cv cR co cG cF cR co vn cv cR co
      wceq cG cF cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR co vn
      cv cR co cG cF vn cv cR co cR co wceq wa cG cF vm cv cR co cR co cG cF vn
      cv cR co cR co wceq wa cG cF vm cv cR co cR co cG cF vn cv cR co cR co cG
      cF cR co vm cv cR co cG cF cR co vn cv cR co cG cF cR co vm cv cR co cG
      cF vm cv cR co cR co wceq cG cF cR co vn cv cR co cG cF vn cv cR co cR co
      wceq wa cG cF vm cv cR co cR co cG cF vn cv cR co cR co wceq pm3.27 cG cF
      cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR co vn cv cR co cG
      cF vn cv cR co cR co wceq cG cF vm cv cR co cR co cG cF vn cv cR co cR co
      wceq simpll cG cF cR co vm cv cR co cG cF vm cv cR co cR co wceq cG cF cR
      co vn cv cR co cG cF vn cv cR co cR co wceq cG cF vm cv cR co cR co cG cF
      vn cv cR co cR co wceq simplr 3eqtr4d ex imim1d cF vm cv cR co cF vn cv
      cR co cG cR opreq2 syl7 cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a
      cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va cv cO wcel wa
      vm cv va cv cA cop cH cfv wcel wa cG cF cR co vm cv cR co cG cF vm cv cR
      co cR co wceq vn cv va cv cA cop cH cfv wcel cT ccat wcel cA cO wcel cB
      cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      wa w3a va cv cO wcel wa vm cv va cv cA cop cH cfv wcel wa cG cF vm cv cR
      co cR co cG cF cR co vm cv cR co cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va cv
      cO wcel vm cv va cv cA cop cH cfv wcel cG cF vm cv cR co cR co cG cF cR
      co vm cv cR co wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa va cv cO wcel vm cv va
      cv cA cop cH cfv wcel cG cF vm cv cR co cR co cG cF cR co vm cv cR co
      wceq wi wi vm cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa va cv cO wcel cT ccat wcel cA cO wcel cB cO wcel cC
      cO wcel w3a wa cG cF vm cv cR co cR co cG cF cR co vm cv cR co wceq vm cv
      va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel va cv cO wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a wa
      cG cF vm cv cR co cR co cG cF cR co vm cv cR co wceq wi wi cT ccat wcel
      cA cO wcel cB cO wcel cC cO wcel w3a wa va cv cO wcel vm cv va cv cA cop
      cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF
      vm cv cR co cR co cG cF cR co vm cv cR co wceq cT ccat wcel cA cO wcel cB
      cO wcel cC cO wcel w3a va cv cO wcel vm cv va cv cA cop cH cfv wcel cF cA
      cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF vm cv cR co cR co
      cG cF cR co vm cv cR co wceq wi wi va cv cO wcel cA cO wcel cB cO wcel cC
      cO wcel w3a cT ccat wcel vm cv va cv cA cop cH cfv wcel cF cA cB cop cH
      cfv wcel cG cB cC cop cH cfv wcel w3a cG cF vm cv cR co cR co cG cF cR co
      vm cv cR co wceq wi va cv cO wcel cA cO wcel cB cO wcel cC cO wcel cT
      ccat wcel vm cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel w3a cG cF vm cv cR co cR co cG cF cR co vm cv cR co
      wceq wi wi va cv cO wcel cA cO wcel cB cO wcel cC cO wcel cT ccat wcel vm
      cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel w3a cG cF vm cv cR co cR co cG cF cR co vm cv cR co wceq wi wi cT
      ccat wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa vm cv va
      cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      w3a cG cF vm cv cR co cR co cG cF cR co vm cv cR co wceq wi cT ccat wcel
      va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa vm cv va cv cA cop
      cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF
      vm cv cR co cR co cG cF cR co vm cv cR co wceq wi va cv cA cB cC cR cT cH
      vm cv cF cG cO icmpmon.1 icmpmon.2 icmpmon.3 cmpassoh 3exp com3l exp4b
      3impd com13 imp com13 3expib com14 3impia imp31 eqcomd adantr cT ccat
      wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel wa w3a va cv cO wcel wa vm cv va cv cA cop cH cfv wcel
      wa vn cv va cv cA cop cH cfv wcel cG cF cR co vn cv cR co cG cF vn cv cR
      co cR co wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB
      cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a va cv cO wcel wa vn cv va
      cv cA cop cH cfv wcel cG cF cR co vn cv cR co cG cF vn cv cR co cR co
      wceq wi vm cv va cv cA cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel
      cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a
      va cv cO wcel vn cv va cv cA cop cH cfv wcel cG cF cR co vn cv cR co cG
      cF vn cv cR co cR co wceq wi cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa w3a vn cv
      va cv cA cop cH cfv wcel va cv cO wcel cG cF cR co vn cv cR co cG cF vn
      cv cR co cR co wceq cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa vn cv va cv cA cop cH
      cfv wcel va cv cO wcel cG cF cR co vn cv cR co cG cF vn cv cR co cR co
      wceq wi wi vn cv va cv cA cop cH cfv wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cT ccat
      wcel va cv cO wcel cG cF cR co vn cv cR co cG cF vn cv cR co cR co wceq
      wi vn cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop
      cH cfv wcel wa cA cO wcel cB cO wcel cC cO wcel w3a cT ccat wcel va cv cO
      wcel cG cF cR co vn cv cR co cG cF vn cv cR co cR co wceq wi wi vn cv va
      cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      cA cO wcel cB cO wcel cC cO wcel w3a cT ccat wcel va cv cO wcel cG cF cR
      co vn cv cR co cG cF vn cv cR co cR co wceq wi wi wi va cv cO wcel cA cO
      wcel cB cO wcel cC cO wcel w3a cT ccat wcel vn cv va cv cA cop cH cfv
      wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vn
      cv cR co cG cF vn cv cR co cR co wceq va cv cO wcel cA cO wcel cB cO wcel
      cC cO wcel cT ccat wcel vn cv va cv cA cop cH cfv wcel cF cA cB cop cH
      cfv wcel cG cB cC cop cH cfv wcel w3a cG cF cR co vn cv cR co cG cF vn cv
      cR co cR co wceq wi wi va cv cO wcel cA cO wcel cB cO wcel cC cO wcel cT
      ccat wcel vn cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB
      cC cop cH cfv wcel w3a cG cF cR co vn cv cR co cG cF vn cv cR co cR co
      wceq wi wi cT ccat wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel
      wa vn cv va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop
      cH cfv wcel w3a cG cF cR co vn cv cR co cG cF vn cv cR co cR co wceq wi
      cT ccat wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa vn cv
      va cv cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv
      wcel w3a cG cF cR co vn cv cR co cG cF vn cv cR co cR co wceq cT ccat
      wcel va cv cO wcel cA cO wcel wa cB cO wcel cC cO wcel wa w3a vn cv va cv
      cA cop cH cfv wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a
      wa cG cF vn cv cR co cR co cG cF cR co vn cv cR co cT ccat wcel va cv cO
      wcel cA cO wcel wa cB cO wcel cC cO wcel wa w3a vn cv va cv cA cop cH cfv
      wcel cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel w3a cG cF vn cv cR
      co cR co cG cF cR co vn cv cR co wceq va cv cA cB cC cR cT cH vn cv cF cG
      cO icmpmon.1 icmpmon.2 icmpmon.3 cmpassoh imp eqcomd 3exp1 com3l exp4b
      3impd com14 3expib com23 com14 3imp com23 imp adantr imp sylanc r19.20dva
      r19.20dva r19.20dva sylbid 3exp 3imp2 cT ccat wcel cA cO wcel cB cO wcel
      wa cF cA cB cop cH cfv wcel cF cT cmon cfv wcel cF vm cv cR co cF vn cv
      cR co wceq vm cv vn cv wceq wi vn va cv cA cop cH cfv wral vm va cv cA
      cop cH cfv wral va cO wral wb cT ccat wcel cA cO wcel cB cO wcel cC cO
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR co
      cT cmon cfv wcel w3a wa cA cB cR cT vm vn cF cH cO va icmpmon.1 icmpmon.2
      icmpmon.3 ismonc cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF cA
      cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cmon cfv
      wcel w3a pm3.26 cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cmon cfv wcel w3a cA cO
      wcel cB cO wcel wa cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cA cO wcel cB cO wcel
      wa cG cF cR co cT cmon cfv wcel cA cO wcel cB cO wcel cC cO wcel 3simpa
      3ad2ant1 adantl cA cO wcel cB cO wcel cC cO wcel w3a cF cA cB cop cH cfv
      wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cmon cfv wcel w3a cF cA
      cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel cC cO wcel w3a cF
      cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel wa cG cF cR co cT cmon cfv
      wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel cA cO wcel cB
      cO wcel cC cO wcel w3a cF cA cB cop cH cfv wcel cG cB cC cop cH cfv wcel
      wa cG cF cR co cT cmon cfv wcel 3simp2 pm3.26d adantl syl3anc mpbird $.
      $( [27-Apr-2008] $) $( [17-Mar-2008] $)
  $}

  ${ $d A c f g $.  $d B c f g $.  $d F c f g $.  $d G c f g $.  $d H c f g $.
     $d J c f g $.  $d O c f g $.  $d R c f g $.  $d T c f g $.
    idmon.1 $e |- O = dom ( id_ ` T ) $.
    idmon.2 $e |- H = ( hom ` T ) $.
    idmon.3 $e |- R = ( o_ ` T ) $.
    idmon.4 $e |- J = ( id_ ` T ) $.
    $( If there exists ` G ` such as ` ( G R F ) = ( J `` B ) ` then F is
       a monomorphism.  JFM CAT_1 th. 63. $)
    idmon $p |- ( ( T e. Cat /\ ( A e. O /\ B e. O ) /\
      ( G e. ( H ` <. A , B >. ) /\ F e. ( H ` <. B , A >. ) ) ) ->
      ( ( G R F ) = ( J ` B ) -> F e. ( Monic ` T ) ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA
      cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq cF cT cmon cfv wcel cT
      ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cF cT cmon cfv wcel cF
      vf cv cR co cF vg cv cR co wceq vf cv vg cv wceq wi vg vc cv cB cop cH
      cfv wral vf vc cv cB cop cH cfv wral vc cO wral cT ccat wcel cA cO wcel
      cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG
      cF cR co cB cJ cfv wceq wa cF vf cv cR co cF vg cv cR co wceq vf cv vg cv
      wceq wi vg vc cv cB cop cH cfv wral vc vf cO vc cv cB cop cH cfv cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv
      cB cop cH cfv wcel wa cF vf cv cR co cF vg cv cR co wceq vf cv vg cv wceq
      wi vg vc cv cB cop cH cfv wral cT ccat wcel cA cO wcel cB cO wcel wa cG
      cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ
      cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa cF vf cv
      cR co cF vg cv cR co wceq vf cv vg cv wceq wi vg vc cv cB cop cH cfv cT
      ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc
      cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cG cF vf cv
      cR co cR co cG cF vg cv cR co cR co wceq vf cv vg cv wceq cF vf cv cR co
      cF vg cv cR co wceq cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc
      cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv
      wcel wa cG cF vf cv cR co cR co cG cF vg cv cR co cR co wceq cG cF cR co
      vf cv cR co cG cF cR co vg cv cR co wceq vf cv vg cv wceq cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH
      cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cG cF vf cv cR co cR co
      cG cF cR co vf cv cR co cG cF vg cv cR co cR co cG cF cR co vg cv cR co
      cT ccat wcel vc cv cO wcel cB cO wcel wa cA cO wcel cB cO wcel wa w3a vf
      cv vc cv cB cop cH cfv wcel cF cB cA cop cH cfv wcel cG cA cB cop cH cfv
      wcel w3a cG cF vf cv cR co cR co cG cF cR co vf cv cR co wceq cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv
      cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa vc cv cB cA cB
      cR cT cH vf cv cF cG cO idmon.1 idmon.2 idmon.3 cmpassoh cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH
      cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cT ccat wcel vc cv cO
      wcel cB cO wcel wa cA cO wcel cB cO wcel wa cT ccat wcel cA cO wcel cB cO
      wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR
      co cB cJ cfv wceq wa cT ccat wcel vc cv cO wcel vf cv vc cv cB cop cH cfv
      wcel wa vg cv vc cv cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel
      wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cT ccat wcel
      cG cF cR co cB cJ cfv wceq cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB
      cop cH cfv wcel cF cB cA cop cH cfv wcel wa 3simp1 adantr ad2antrr cT
      ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc
      cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa vc cv cO
      wcel cB cO wcel cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vc cv cO wcel vg cv vc cv cB
      cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel simprl adantr cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cG cF cR co cB cJ cfv wceq wa cB cO wcel vc cv cO wcel vf cv vc cv cB
      cop cH cfv wcel wa vg cv vc cv cB cop cH cfv wcel cA cO wcel cB cO wcel
      wa cT ccat wcel cG cF cR co cB cJ cfv wceq cB cO wcel cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa cA cO wcel cB cO wcel cG cF cR co cB cJ
      cfv wceq simplr 3ad2antl2 ad2antrr jca cT ccat wcel cA cO wcel cB cO wcel
      wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co
      cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg
      cv vc cv cB cop cH cfv wcel wa cA cO wcel cB cO wcel cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cG cF cR co cB cJ cfv wceq wa cA cO wcel vc cv cO wcel vf cv vc cv cB
      cop cH cfv wcel wa vg cv vc cv cB cop cH cfv wcel cA cO wcel cB cO wcel
      wa cT ccat wcel cG cF cR co cB cJ cfv wceq cA cO wcel cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa cA cO wcel cB cO wcel cG cF cR co cB cJ
      cfv wceq simpll 3ad2antl2 ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa
      cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB
      cJ cfv wceq wa cB cO wcel vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa
      vg cv vc cv cB cop cH cfv wcel cA cO wcel cB cO wcel wa cT ccat wcel cG
      cF cR co cB cJ cfv wceq cB cO wcel cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa cA cO wcel cB cO wcel cG cF cR co cB cJ cfv wceq simplr
      3ad2antl2 ad2antrr jca 3jca cT ccat wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB
      cop cH cfv wcel wa vf cv vc cv cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel cG cA cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vf cv vc cv cB
      cop cH cfv wcel vg cv vc cv cB cop cH cfv wcel cT ccat wcel cA cO wcel cB
      cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF
      cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel
      simprr adantr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cF cB
      cA cop cH cfv wcel vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa vg cv
      vc cv cB cop cH cfv wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel wa cT ccat wcel cG cF cR co cB cJ cfv wceq cF cB cA cop cH cfv wcel
      cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel cG cF cR co cB cJ cfv wceq simplr 3ad2antl3 ad2antrr cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa w3a cG cF cR co cB cJ cfv wceq wa cG cA cB cop cH cfv wcel vc cv cO
      wcel vf cv vc cv cB cop cH cfv wcel wa vg cv vc cv cB cop cH cfv wcel cG
      cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cT ccat wcel cG cF cR
      co cB cJ cfv wceq cG cA cB cop cH cfv wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel cG cF cR co cB cJ cfv wceq
      simpll 3ad2antl3 ad2antrr 3jca sylc cT ccat wcel vc cv cO wcel cB cO wcel
      wa cA cO wcel cB cO wcel wa w3a vg cv vc cv cB cop cH cfv wcel cF cB cA
      cop cH cfv wcel cG cA cB cop cH cfv wcel w3a cG cF vg cv cR co cR co cG
      cF cR co vg cv cR co wceq cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB
      cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB
      cop cH cfv wcel wa vc cv cB cA cB cR cT cH vg cv cF cG cO idmon.1 idmon.2
      idmon.3 cmpassoh cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc
      cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv
      wcel wa cT ccat wcel vc cv cO wcel cB cO wcel wa cA cO wcel cB cO wcel wa
      cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA
      cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cT ccat wcel vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel wa vg cv vc cv cB cop cH cfv wcel
      cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA
      cop cH cfv wcel wa w3a cT ccat wcel cG cF cR co cB cJ cfv wceq cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa 3simp1 adantr ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa
      cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB
      cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv
      vc cv cB cop cH cfv wcel wa vc cv cO wcel cB cO wcel cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv
      wcel wa wa vc cv cO wcel vg cv vc cv cB cop cH cfv wcel cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH
      cfv wcel simprl adantr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop
      cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa
      cB cO wcel vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa vg cv vc cv cB
      cop cH cfv wcel cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR co cB cJ
      cfv wceq cB cO wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      cA cO wcel cB cO wcel cG cF cR co cB cJ cfv wceq simplr 3ad2antl2
      ad2antrr jca cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv
      wcel wa cA cO wcel cB cO wcel cT ccat wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa cA cO wcel vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa vg cv
      vc cv cB cop cH cfv wcel cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR
      co cB cJ cfv wceq cA cO wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel wa cA cO wcel cB cO wcel cG cF cR co cB cJ cfv wceq simpll 3ad2antl2
      ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel
      cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cB cO wcel
      vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa vg cv vc cv cB cop cH cfv
      wcel cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR co cB cJ cfv wceq cB
      cO wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cA cO wcel
      cB cO wcel cG cF cR co cB cJ cfv wceq simplr 3ad2antl2 ad2antrr jca 3jca
      cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA
      cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv
      vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa vg cv vc
      cv cB cop cH cfv wcel cF cB cA cop cH cfv wcel cG cA cB cop cH cfv wcel
      cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA
      cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv
      vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel pm3.27 cT
      ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cF cB cA cop cH cfv wcel
      vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa vg cv vc cv cB cop cH cfv
      wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cT ccat wcel cG
      cF cR co cB cJ cfv wceq cF cB cA cop cH cfv wcel cA cO wcel cB cO wcel wa
      cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel cG cF cR co cB cJ cfv
      wceq simplr 3ad2antl3 ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa cG
      cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ
      cfv wceq wa cG cA cB cop cH cfv wcel vc cv cO wcel vf cv vc cv cB cop cH
      cfv wcel wa vg cv vc cv cB cop cH cfv wcel cG cA cB cop cH cfv wcel cF cB
      cA cop cH cfv wcel wa cT ccat wcel cG cF cR co cB cJ cfv wceq cG cA cB
      cop cH cfv wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB
      cA cop cH cfv wcel cG cF cR co cB cJ cfv wceq simpll 3ad2antl3 ad2antrr
      3jca sylc eqeq12d cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc
      cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv
      wcel wa cG cF cR co vf cv cR co cG cF cR co vg cv cR co wceq cB cJ cfv vf
      cv cR co cB cJ cfv vg cv cR co wceq vf cv vg cv wceq cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv
      wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cG cF cR co vf cv cR co cG
      cF cR co vg cv cR co wceq cB cJ cfv vf cv cR co cB cJ cfv vg cv cR co
      wceq cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB
      cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf
      cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cG cF
      cR co vf cv cR co cB cJ cfv vf cv cR co cG cF cR co vg cv cR co cB cJ cfv
      vg cv cR co cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv
      wcel wa cG cF cR co cB cJ cfv vf cv cR cT ccat wcel cA cO wcel cB cO wcel
      wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co
      cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa cG
      cF cR co cB cJ cfv wceq vg cv vc cv cB cop cH cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cG cF cR co cB cJ cfv wceq vc cv cO wcel vf cv vc cv cB cop cH cfv
      wcel wa simplr adantr opreq1d cT ccat wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB
      cop cH cfv wcel wa cG cF cR co cB cJ cfv vg cv cR cT ccat wcel cA cO wcel
      cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG
      cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel
      wa wa cG cF cR co cB cJ cfv wceq vg cv vc cv cB cop cH cfv wcel cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cG cF cR co cB cJ cfv wceq vc cv cO wcel vf cv vc cv cB
      cop cH cfv wcel wa simplr adantr opreq1d eqeq12d biimpd cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH
      cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cB cJ cfv vf cv cR co vf
      cv cB cJ cfv vg cv cR co vg cv cT ccat wcel cA cO wcel cB cO wcel wa cG
      cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ
      cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa cB cJ cfv
      vf cv cR co vf cv wceq vg cv vc cv cB cop cH cfv wcel cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv
      wcel cB cJ cfv vf cv cR co vf cv wceq cT ccat wcel cA cO wcel cB cO wcel
      wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co
      cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel cB cJ cfv
      vf cv cR co vf cv wceq wi cT ccat wcel vc cv cO wcel cB cO wcel vf cv vc
      cv cB cop cH cfv wcel cB cJ cfv vf cv cR co vf cv wceq wi cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel wa vc cv cB cR cT vf
      cv cH cJ cO idmon.1 idmon.2 idmon.4 idmon.3 cmphmia cT ccat wcel cA cO
      wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa
      w3a cT ccat wcel cG cF cR co cB cJ cfv wceq vc cv cO wcel cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa 3simp1 ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc
      cv cO wcel pm3.27 cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cB
      cO wcel vc cv cO wcel cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR co
      cB cJ cfv wceq cB cO wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel wa cA cO wcel cB cO wcel cG cF cR co cB cJ cfv wceq simplr 3ad2antl2
      adantr syl3anc ex imp32 adantr cT ccat wcel cB cJ cdm wcel vg cv cT cdom_
      cfv cdm wcel w3a vg cv cT ccod_ cfv cfv cB wceq cB cJ cfv vg cv cR co vg
      cv wceq cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF
      cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel
      vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel wa cB
      cT ccod_ cfv cT cdom_ cfv cR cT vg cv cJ cT cdom_ cfv cdm cJ cdm cT cdom_
      cfv cdm eqid cT cdom_ cfv eqid cJ cdm eqid idmon.4 idmon.3 cT ccod_ cfv
      eqid cmpida cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv
      wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv
      wcel wa cT ccat wcel cB cJ cdm wcel vg cv cT cdom_ cfv cdm wcel cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa cT ccat wcel vc cv cO wcel
      vf cv vc cv cB cop cH cfv wcel wa vg cv vc cv cB cop cH cfv wcel cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cT ccat wcel cG cF cR co cB cJ cfv wceq cT ccat wcel cA
      cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel
      wa 3simp1 adantr ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB
      cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa cB cJ cdm wcel vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa vg
      cv vc cv cB cop cH cfv wcel cT ccat wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cB cJ cdm wcel cG cF
      cR co cB cJ cfv wceq cA cO wcel cB cO wcel wa cT ccat wcel cB cJ cdm wcel
      cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cB cO wcel cB cJ cdm
      wcel cA cO wcel cB cO wcel cB cJ cdm wcel cO cJ cdm cB cO cT cid_ cfv cdm
      cJ cdm idmon.1 cT cid_ cfv cJ cJ cT cid_ cfv idmon.4 eqcomi dmeqi eqtri
      eleq2i biimpi adantl 3ad2ant2 adantr ad2antrr cT ccat wcel cA cO wcel cB
      cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF
      cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa
      wa vg cv vc cv cB cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel cT ccat
      wcel vc cv cO wcel cB cO wcel vg cv vc cv cB cop cH cfv wcel vg cv cT
      cdom_ cfv cdm wcel wi cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop
      cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa
      vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa wa vc cv cB cT vg cv cH
      cT cdom_ cfv cdm cO idmon.1 cT cdom_ cfv cdm eqid idmon.2 ehm cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cT ccat wcel cG cF cR co cB cJ cfv wceq vc cv cO wcel vf
      cv vc cv cB cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO wcel wa cG
      cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa 3simp1 ad2antrr cT ccat
      wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH
      cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv
      cB cop cH cfv wcel simprl cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB
      cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa cB cO wcel vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa cA cO
      wcel cB cO wcel wa cT ccat wcel cG cF cR co cB cJ cfv wceq cB cO wcel cG
      cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cA cO wcel cB cO wcel
      cG cF cR co cB cJ cfv wceq simplr 3ad2antl2 adantr syl3anc imp 3jca cT
      ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc
      cv cB cop cH cfv wcel wa wa vg cv vc cv cB cop cH cfv wcel vg cv cT ccod_
      cfv cfv cB wceq cT ccat wcel vc cv cO wcel cB cO wcel vg cv vc cv cB cop
      cH cfv wcel vg cv cT ccod_ cfv cfv cB wceq wi cT ccat wcel cA cO wcel cB
      cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF
      cR co cB cJ cfv wceq wa vc cv cO wcel vf cv vc cv cB cop cH cfv wcel wa
      wa vc cv cB cT ccod_ cfv cT vg cv cH cO idmon.1 cT ccod_ cfv eqid idmon.2
      cehm cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB
      cA cop cH cfv wcel wa w3a cT ccat wcel cG cF cR co cB cJ cfv wceq vc cv
      cO wcel vf cv vc cv cB cop cH cfv wcel wa cT ccat wcel cA cO wcel cB cO
      wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa 3simp1
      ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel
      cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa vc cv cO
      wcel vf cv vc cv cB cop cH cfv wcel simprl cT ccat wcel cA cO wcel cB cO
      wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR
      co cB cJ cfv wceq wa cB cO wcel vc cv cO wcel vf cv vc cv cB cop cH cfv
      wcel wa cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR co cB cJ cfv wceq
      cB cO wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cA cO
      wcel cB cO wcel cG cF cR co cB cJ cfv wceq simplr 3ad2antl2 adantr
      syl3anc imp sylc eqeq12d sylibd sylbid cF vf cv cR co cF vg cv cR co cG
      cR opreq2 syl5 r19.21aiva ex r19.21aivv cT ccat wcel cB cO wcel cA cO
      wcel wa cF cB cA cop cH cfv wcel cF cT cmon cfv wcel cF vf cv cR co cF vg
      cv cR co wceq vf cv vg cv wceq wi vg vc cv cB cop cH cfv wral vf vc cv cB
      cop cH cfv wral vc cO wral wb cT ccat wcel cA cO wcel cB cO wcel wa cG cA
      cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv
      wceq wa cB cA cR cT vf vg cF cH cO vc idmon.1 idmon.2 idmon.3 ismonc cT
      ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop
      cH cfv wcel wa w3a cT ccat wcel cG cF cR co cB cJ cfv wceq cT ccat wcel
      cA cO wcel cB cO wcel wa cG cA cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel wa 3simp1 adantr cT ccat wcel cA cO wcel cB cO wcel wa cG cA cB cop
      cH cfv wcel cF cB cA cop cH cfv wcel wa w3a cG cF cR co cB cJ cfv wceq wa
      cB cO wcel cA cO wcel cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR co
      cB cJ cfv wceq cB cO wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv
      wcel wa cA cO wcel cB cO wcel cG cF cR co cB cJ cfv wceq simplr 3ad2antl2
      cA cO wcel cB cO wcel wa cT ccat wcel cG cF cR co cB cJ cfv wceq cA cO
      wcel cG cA cB cop cH cfv wcel cF cB cA cop cH cfv wcel wa cA cO wcel cB
      cO wcel cG cF cR co cB cJ cfv wceq simpll 3ad2antl2 jca cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel wa cT ccat wcel cG cF cR co cB cJ cfv
      wceq cF cB cA cop cH cfv wcel cA cO wcel cB cO wcel wa cG cA cB cop cH
      cfv wcel cF cB cA cop cH cfv wcel cG cF cR co cB cJ cfv wceq simplr
      3ad2antl3 syl3anc mpbird ex $.
      $( [1-Jun-2008] $) $( [5-May-2008] $)
  $}

  ${
    immon.1 $e |- O = dom ( id_ ` T ) $.
    immon.2 $e |- J = ( id_ ` T ) $.
    $( A  morphism identity is a monomorphism.  JFM CAT_1 th. 64. $)
    immon $p |- ( ( T e. Cat /\ A e. O ) -> ( J ` A ) e. ( Monic ` T ) ) $=
      cT ccat wcel cA cO wcel cA cO wcel wa cA cJ cfv cA cA cop cT chom cfv cfv
      wcel cA cJ cfv cA cA cop cT chom cfv cfv wcel wa w3a cA cJ cfv cA cJ cfv
      cT co_ cfv co cA cJ cfv wceq cA cJ cfv cT cmon cfv wcel cT ccat wcel cA
      cO wcel wa cA cA cT co_ cfv cT cA cJ cfv cA cJ cfv cT chom cfv cJ cO
      immon.1 cT chom cfv eqid cT co_ cfv eqid immon.2 idmon cT ccat wcel cA cO
      wcel wa cT ccat wcel cA cO wcel cA cO wcel wa cA cJ cfv cA cA cop cT chom
      cfv cfv wcel cA cJ cfv cA cA cop cT chom cfv cfv wcel wa cT ccat wcel cA
      cO wcel pm3.26 cT ccat wcel cA cO wcel wa cA cO wcel cA cO wcel cT ccat
      wcel cA cO wcel pm3.27 cT ccat wcel cA cO wcel pm3.27 jca cT ccat wcel cA
      cO wcel wa cA cJ cfv cA cA cop cT chom cfv cfv wcel cA cJ cfv cA cA cop
      cT chom cfv cfv wcel cA cT cT chom cfv cJ cO immon.1 immon.2 cT chom cfv
      eqid homib cA cT cT chom cfv cJ cO immon.1 immon.2 cT chom cfv eqid homib
      jca 3jca cA cT co_ cfv cT cJ cO immon.1 immon.2 cT co_ cfv eqid iri sylc
      $.
      $( [1-Jun-2008] $) $( [5-May-2008] $)
  $}

  ${ $d C x y $.  $d D x y $.  $d M f g h x y $.  $d R x y $.
    $d T f g h x y $.
    isepia.1 $e |- M = dom ( dom_ ` T ) $.
    isepia.2 $e |- D = ( dom_ ` T ) $.
    isepia.3 $e |- C = ( cod_ ` T ) $.
    isepia.4 $e |- R = ( o_ ` T ) $.
    $( Epimorphisms of a category ` T ` . $)
    isepia $p |- ( T e. Cat -> ( Epi ` T ) = { f | ( f e. M /\
      A. g e. M A. h e. M
        ( ( ( C ` g ) = ( C ` h ) /\
            ( D ` g ) = ( C ` f ) /\
            ( D ` h ) = ( C ` f ) ) ->
              ( ( g R f ) = ( h R f ) -> g = h ) ) ) } ) $=
      vx vy cT vf cv vx cv cdom_ cfv cdm wcel vg cv vx cv ccod_ cfv cfv vh cv
      vx cv ccod_ cfv cfv wceq vg cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv
      cfv wceq vh cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv wceq w3a vg
      cv vf cv vx cv co_ cfv co vh cv vf cv vx cv co_ cfv co wceq vg cv vh cv
      wceq wi wi vh vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm wral wa vf
      cab vf cv cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC
      cfv wceq vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv
      cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa vf cab ccat
      cepi vx cv cT wceq vf cv vx cv cdom_ cfv cdm wcel vg cv vx cv ccod_ cfv
      cfv vh cv vx cv ccod_ cfv cfv wceq vg cv vx cv cdom_ cfv cfv vf cv vx cv
      ccod_ cfv cfv wceq vh cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv
      wceq w3a vg cv vf cv vx cv co_ cfv co vh cv vf cv vx cv co_ cfv co wceq
      vg cv vh cv wceq wi wi vh vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm
      wral wa vf cv cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv
      cC cfv wceq vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf
      cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa vf vx cv cT
      wceq vf cv vx cv cdom_ cfv cdm wcel vf cv cM wcel vg cv vx cv ccod_ cfv
      cfv vh cv vx cv ccod_ cfv cfv wceq vg cv vx cv cdom_ cfv cfv vf cv vx cv
      ccod_ cfv cfv wceq vh cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv
      wceq w3a vg cv vf cv vx cv co_ cfv co vh cv vf cv vx cv co_ cfv co wceq
      vg cv vh cv wceq wi wi vh vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm
      wral vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv
      cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg
      cv vh cv wceq wi wi vh cM wral vg cM wral vx cv cT wceq vx cv cdom_ cfv
      cdm cM vf cv vx cv cT wceq vx cv cdom_ cfv cdm cT cdom_ cfv cdm cM vx cv
      cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT cdom_ fveq2 dmeqd isepia.1
      syl6eqr eleq2d vx cv cT wceq vg cv vx cv ccod_ cfv cfv vh cv vx cv ccod_
      cfv cfv wceq vg cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv wceq vh
      cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv wceq w3a vg cv vf cv vx
      cv co_ cfv co vh cv vf cv vx cv co_ cfv co wceq vg cv vh cv wceq wi wi vh
      vx cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm wral vg cv cC cfv vh cv
      cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq
      w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vh vx
      cv cdom_ cfv cdm wral vg vx cv cdom_ cfv cdm wral vg cv cC cfv vh cv cC
      cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq
      w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vh cM
      wral vg vx cv cdom_ cfv cdm wral vg cv cC cfv vh cv cC cfv wceq vg cv cD
      cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR
      co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral vx
      cv cT wceq vg cv vx cv ccod_ cfv cfv vh cv vx cv ccod_ cfv cfv wceq vg cv
      vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv wceq vh cv vx cv cdom_ cfv
      cfv vf cv vx cv ccod_ cfv cfv wceq w3a vg cv vf cv vx cv co_ cfv co vh cv
      vf cv vx cv co_ cfv co wceq vg cv vh cv wceq wi wi vg cv cC cfv vh cv cC
      cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq
      w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vg vh
      vx cv cdom_ cfv cdm vx cv cdom_ cfv cdm vx cv cT wceq vg cv vx cv ccod_
      cfv cfv vh cv vx cv ccod_ cfv cfv wceq vg cv vx cv cdom_ cfv cfv vf cv vx
      cv ccod_ cfv cfv wceq vh cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv
      wceq w3a vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh
      cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv vx cv co_ cfv co vh cv vf cv
      vx cv co_ cfv co wceq vg cv vh cv wceq wi vg cv vf cv cR co vh cv vf cv
      cR co wceq vg cv vh cv wceq wi vx cv cT wceq vg cv vx cv ccod_ cfv cfv vh
      cv vx cv ccod_ cfv cfv wceq vg cv cC cfv vh cv cC cfv wceq vg cv vx cv
      cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv wceq vg cv cD cfv vf cv cC cfv
      wceq vh cv vx cv cdom_ cfv cfv vf cv vx cv ccod_ cfv cfv wceq vh cv cD
      cfv vf cv cC cfv wceq vx cv cT wceq vg cv vx cv ccod_ cfv cfv vg cv cC
      cfv vh cv vx cv ccod_ cfv cfv vh cv cC cfv vx cv cT wceq vg cv vx cv
      ccod_ cfv cfv vg cv cT ccod_ cfv cfv vg cv cC cfv vx cv cT wceq vg cv vx
      cv ccod_ cfv cT ccod_ cfv vx cv cT ccod_ fveq2 fveq1d vx cv cT wceq vg cv
      cT ccod_ cfv cC cT ccod_ cfv cC wceq vx cv cT wceq cC cT ccod_ cfv
      isepia.3 eqcomi a1i fveq1d eqtrd vx cv cT wceq vh cv vx cv ccod_ cfv cC
      vx cv cT wceq vx cv ccod_ cfv cT ccod_ cfv cC vx cv cT ccod_ fveq2
      isepia.3 syl6eqr fveq1d eqeq12d vx cv cT wceq vg cv vx cv cdom_ cfv cfv
      vg cv cD cfv vf cv vx cv ccod_ cfv cfv vf cv cC cfv vx cv cT wceq vg cv
      vx cv cdom_ cfv cD vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv cD vx cv cT
      cdom_ fveq2 isepia.2 syl6eqr fveq1d vx cv cT wceq vf cv vx cv ccod_ cfv
      cfv vf cv cT ccod_ cfv cfv vf cv cC cfv vx cv cT wceq vf cv vx cv ccod_
      cfv cT ccod_ cfv vx cv cT ccod_ fveq2 fveq1d vx cv cT wceq vf cv cT ccod_
      cfv cC cT ccod_ cfv cC wceq vx cv cT wceq cC cT ccod_ cfv isepia.3 eqcomi
      a1i fveq1d eqtrd eqeq12d vx cv cT wceq vh cv vx cv cdom_ cfv cfv vh cv cD
      cfv vf cv vx cv ccod_ cfv cfv vf cv cC cfv vx cv cT wceq vh cv vx cv
      cdom_ cfv cD vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv cD vx cv cT cdom_
      fveq2 isepia.2 syl6eqr fveq1d vx cv cT wceq vf cv vx cv ccod_ cfv cfv vf
      cv cT ccod_ cfv cfv vf cv cC cfv vx cv cT wceq vf cv vx cv ccod_ cfv cT
      ccod_ cfv vx cv cT ccod_ fveq2 fveq1d vx cv cT wceq vf cv cT ccod_ cfv cC
      cT ccod_ cfv cC wceq vx cv cT wceq cC cT ccod_ cfv isepia.3 eqcomi a1i
      fveq1d eqtrd eqeq12d 3anbi123d vx cv cT wceq vg cv vf cv vx cv co_ cfv co
      vh cv vf cv vx cv co_ cfv co wceq vg cv vf cv cR co vh cv vf cv cR co
      wceq vg cv vh cv wceq vx cv cT wceq vg cv vf cv vx cv co_ cfv co vg cv vf
      cv cR co vh cv vf cv vx cv co_ cfv co vh cv vf cv cR co vx cv cT wceq vg
      cv vf cv vx cv co_ cfv co vg cv vf cv cT co_ cfv co vg cv vf cv cR co vx
      cv cT wceq vx cv co_ cfv cT co_ cfv vg cv vf cv vx cv cT co_ fveq2 opreqd
      vx cv cT wceq cT co_ cfv cR vg cv vf cv cT co_ cfv cR wceq vx cv cT wceq
      cR cT co_ cfv isepia.4 eqcomi a1i opreqd eqtrd vx cv cT wceq vh cv vf cv
      vx cv co_ cfv co vh cv vf cv cT co_ cfv co vh cv vf cv cR co vx cv cT
      wceq vx cv co_ cfv cT co_ cfv vh cv vf cv vx cv cT co_ fveq2 opreqd vx cv
      cT wceq cT co_ cfv cR vh cv vf cv cT co_ cfv cR wceq vx cv cT wceq cR cT
      co_ cfv isepia.4 eqcomi a1i opreqd eqtrd eqeq12d imbi1d imbi12d 2ralbidv
      vx cv cT wceq vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv
      wceq vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR
      co wceq vg cv vh cv wceq wi wi vh vx cv cdom_ cfv cdm wral vg cv cC cfv
      vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC
      cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi
      wi vh cM wral vg vx cv cdom_ cfv cdm vx cv cT wceq vg cv cC cfv vh cv cC
      cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq
      w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vh vx
      cv cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_ cfv cdm cT cdom_ cfv cdm cM
      vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT cdom_ fveq2 dmeqd
      isepia.1 syl6eqr raleq1d ralbidv vx cv cT wceq vg cv cC cfv vh cv cC cfv
      wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq w3a vg
      cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vh cM wral
      vg vx cv cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_ cfv cdm cT cdom_ cfv
      cdm cM vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT cdom_ fveq2
      dmeqd isepia.1 syl6eqr raleq1d 3bitrd anbi12d abbidv vx vy vf vg vh
      df-epi vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh
      cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq
      vg cv vh cv wceq wi wi vh cM wral vg cM wral vf cM cM cT cdom_ cfv cdm
      cvv isepia.1 cT cdom_ cfv cT cdom_ fvex dmex eqeltri zfausab fvopab4 $.
      $( [1-Sep-2008] $) $( [8-Aug-2008] $)
  $}

  ${ $d C f $.  $d D f $.  $d F f g h $.  $d M f g h $.  $d R f $.
    $d T f g h $.
    isepib.1 $e |- M = dom ( dom_ ` T ) $.
    isepib.2 $e |- D = ( dom_ ` T ) $.
    isepib.3 $e |- C = ( cod_ ` T ) $.
    isepib.4 $e |- R = ( o_ ` T ) $.
    $( The predicate "is an epimorphism". $)
    isepib $p |- ( ( T e. Cat /\ F e. A ) -> ( F e. ( Epi ` T )
      <-> ( F e. M /\ A. g e. M A. h e. M
        ( ( ( C ` g ) = ( C ` h ) /\
            ( D ` g ) = ( C ` F ) /\
            ( D ` h ) = ( C ` F ) ) ->
              ( ( g R F ) = ( h R F ) -> g = h ) ) ) ) ) $=
      cT ccat wcel cF cA wcel wa cF cT cepi cfv wcel cF vf cv cM wcel vg cv cC
      cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv
      cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq
      wi wi vh cM wral vg cM wral wa vf cab wcel cF cM wcel vg cv cC cfv vh cv
      cC cfv wceq vg cv cD cfv cF cC cfv wceq vh cv cD cfv cF cC cfv wceq w3a
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cM wral vg
      cM wral wa cT ccat wcel cF cA wcel wa cT cepi cfv vf cv cM wcel vg cv cC
      cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv
      cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv wceq
      wi wi vh cM wral vg cM wral wa vf cab cF cT ccat wcel cT cepi cfv vf cv
      cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh
      cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq
      vg cv vh cv wceq wi wi vh cM wral vg cM wral wa vf cab wceq cF cA wcel cC
      cD cR cT vf vg vh cM isepib.1 isepib.2 isepib.3 isepib.4 isepia adantr
      eleq2d cF cA wcel cF vf cv cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv
      cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv
      cR co vh cv vf cv cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral
      wa vf cab wcel cF cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv cF
      cC cfv wceq vh cv cD cfv cF cC cfv wceq w3a vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa wb cT ccat wcel vf
      cv cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq
      vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co
      wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa cF cM wcel vg cv cC
      cfv vh cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vh cv cD cfv cF cC cfv
      wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cM
      wral vg cM wral wa vf cF cA vf cv cF wceq vf cv cM wcel cF cM wcel vg cv
      cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf
      cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co wceq vg cv vh cv
      wceq wi wi vh cM wral vg cM wral vg cv cC cfv vh cv cC cfv wceq vg cv cD
      cfv cF cC cfv wceq vh cv cD cfv cF cC cfv wceq w3a vg cv cF cR co vh cv
      cF cR co wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral vf cv cF cM
      eleq1 vf cv cF wceq vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC
      cfv wceq vh cv cD cfv vf cv cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv
      cR co wceq vg cv vh cv wceq wi wi vg cv cC cfv vh cv cC cfv wceq vg cv cD
      cfv cF cC cfv wceq vh cv cD cfv cF cC cfv wceq w3a vg cv cF cR co vh cv
      cF cR co wceq vg cv vh cv wceq wi wi vg vh cM cM vf cv cF wceq vg cv cC
      cfv vh cv cC cfv wceq vg cv cD cfv vf cv cC cfv wceq vh cv cD cfv vf cv
      cC cfv wceq w3a vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv cF cC cfv
      wceq vh cv cD cfv cF cC cfv wceq w3a vg cv vf cv cR co vh cv vf cv cR co
      wceq vg cv vh cv wceq wi vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq wi vf cv cF wceq vg cv cD cfv vf cv cC cfv wceq vg cv cD cfv cF cC
      cfv wceq vh cv cD cfv vf cv cC cfv wceq vh cv cD cfv cF cC cfv wceq vg cv
      cC cfv vh cv cC cfv wceq vf cv cF wceq vf cv cC cfv cF cC cfv vg cv cD
      cfv vf cv cF cC fveq2 eqeq2d vf cv cF wceq vf cv cC cfv cF cC cfv vh cv
      cD cfv vf cv cF cC fveq2 eqeq2d 3anbi23d vf cv cF wceq vg cv vf cv cR co
      vh cv vf cv cR co wceq vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq vf cv cF wceq vg cv vf cv cR co vg cv cF cR co vh cv vf cv cR co vh
      cv cF cR co vf cv cF vg cv cR opreq2 vf cv cF vh cv cR opreq2 eqeq12d
      imbi1d imbi12d 2ralbidv anbi12d elabg adantl bitrd $.
      $( [1-Sep-2008] $) $( [8-Aug-2008] $)
  $}

  ${ $d F g h $.  $d M g h $.  $d T g h $.
    isepib1.1 $e |- M = dom ( dom_ ` T ) $.
    isepib1.2 $e |- D = ( dom_ ` T ) $.
    isepib1.3 $e |- C = ( cod_ ` T ) $.
    isepib1.4 $e |- R = ( o_ ` T ) $.
    $( The predicate "is an epimorphism". $)
    isepib1 $p |- ( ( T e. Cat /\ F e. M ) -> ( F e. ( Epi ` T ) <->
      A. g e. M A. h e. M
        ( ( ( C ` g ) = ( C ` h ) /\
            ( D ` g ) = ( C ` F ) /\
            ( D ` h ) = ( C ` F ) ) ->
              ( ( g R F ) = ( h R F ) -> g = h ) ) ) )  $=
      cT ccat wcel cF cM wcel wa cF cT cepi cfv wcel cF cM wcel vg cv cC cfv vh
      cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vh cv cD cfv cF cC cfv wceq
      w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cM wral
      vg cM wral wa vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv cF cC cfv wceq
      vh cv cD cfv cF cC cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi wi vh cM wral vg cM wral cM cC cD cR cT vg vh cF cM
      isepib1.1 isepib1.2 isepib1.3 isepib1.4 isepib cF cM wcel vg cv cC cfv vh
      cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vh cv cD cfv cF cC cfv wceq
      w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cM wral
      vg cM wral cF cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv cF cC
      cfv wceq vh cv cD cfv cF cC cfv wceq w3a vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi vh cM wral vg cM wral wa wb cT ccat wcel cF
      cM wcel vg cv cC cfv vh cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vh cv
      cD cfv cF cC cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq wi wi vh cM wral vg cM wral ibar adantl bitr4d $.
      $( [1-Sep-2008] $) $( [10-Aug-2008] $)
  $}

  ${ $d C g j $.  $d D g j $.  $d F g j $.  $d G g j $.  $d J j $.  $d M g j $.
     $d R g j $.  $d T g j $.
    isepib2.1 $e |- M = dom ( dom_ ` T ) $.
    isepib2.2 $e |- D = ( dom_ ` T ) $.
    isepib2.3 $e |- C = ( cod_ ` T ) $.
    isepib2.4 $e |- R = ( o_ ` T ) $.
    $( An epimorphism is a right-cancelable morphism. $)
    isepib2 $p |- ( ( T e. Cat /\ ( F e. M /\ G e. M /\ J e. M ) ) ->
      ( F e. ( Epi ` T ) ->
        ( ( ( C ` G ) = ( C ` J ) /\
            ( D ` G ) = ( C ` F ) /\
            ( D ` J ) = ( C ` F ) ) ->
              ( ( G R F ) = ( J R F ) -> G = J ) ) ) )  $=
      cT ccat wcel cF cM wcel cG cM wcel cJ cM wcel w3a wa cF cT cepi cfv wcel
      vg cv cC cfv vj cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vj cv cD cfv
      cF cC cfv wceq w3a vg cv cF cR co vj cv cF cR co wceq vg cv vj cv wceq wi
      wi vj cM wral vg cM wral cG cC cfv cJ cC cfv wceq cG cD cfv cF cC cfv
      wceq cJ cD cfv cF cC cfv wceq w3a cG cF cR co cJ cF cR co wceq cG cJ wceq
      wi wi cT ccat wcel cG cM wcel cF cM wcel cF cT cepi cfv wcel vg cv cC cfv
      vj cv cC cfv wceq vg cv cD cfv cF cC cfv wceq vj cv cD cfv cF cC cfv wceq
      w3a vg cv cF cR co vj cv cF cR co wceq vg cv vj cv wceq wi wi vj cM wral
      vg cM wral wb cJ cM wcel cC cD cR cT vg vj cF cM isepib2.1 isepib2.2
      isepib2.3 isepib2.4 isepib1 3ad2antr1 cT ccat wcel cF cM wcel cG cM wcel
      cJ cM wcel w3a wa cG cM wcel cJ cM wcel wa vg cv cC cfv vj cv cC cfv wceq
      vg cv cD cfv cF cC cfv wceq vj cv cD cfv cF cC cfv wceq w3a vg cv cF cR
      co vj cv cF cR co wceq vg cv vj cv wceq wi wi vj cM wral vg cM wral cG cC
      cfv cJ cC cfv wceq cG cD cfv cF cC cfv wceq cJ cD cfv cF cC cfv wceq w3a
      cG cF cR co cJ cF cR co wceq cG cJ wceq wi wi wi cF cM wcel cG cM wcel cJ
      cM wcel w3a cG cM wcel cJ cM wcel wa cT ccat wcel cF cM wcel cG cM wcel
      cJ cM wcel 3simpc adantl vg cv cC cfv vj cv cC cfv wceq vg cv cD cfv cF
      cC cfv wceq vj cv cD cfv cF cC cfv wceq w3a vg cv cF cR co vj cv cF cR co
      wceq vg cv vj cv wceq wi wi cG cC cfv cJ cC cfv wceq cG cD cfv cF cC cfv
      wceq cJ cD cfv cF cC cfv wceq w3a cG cF cR co cJ cF cR co wceq cG cJ wceq
      wi wi cG cC cfv vj cv cC cfv wceq cG cD cfv cF cC cfv wceq vj cv cD cfv
      cF cC cfv wceq w3a cG cF cR co vj cv cF cR co wceq cG vj cv wceq wi wi vg
      vj cG cJ cM cM vg cv cG wceq vg cv cC cfv vj cv cC cfv wceq vg cv cD cfv
      cF cC cfv wceq vj cv cD cfv cF cC cfv wceq w3a cG cC cfv vj cv cC cfv
      wceq cG cD cfv cF cC cfv wceq vj cv cD cfv cF cC cfv wceq w3a vg cv cF cR
      co vj cv cF cR co wceq vg cv vj cv wceq wi cG cF cR co vj cv cF cR co
      wceq cG vj cv wceq wi vg cv cG wceq vg cv cC cfv vj cv cC cfv wceq cG cC
      cfv vj cv cC cfv wceq vg cv cD cfv cF cC cfv wceq cG cD cfv cF cC cfv
      wceq vj cv cD cfv cF cC cfv wceq vg cv cG wceq vg cv cC cfv cG cC cfv vj
      cv cC cfv vg cv cG cC fveq2 eqeq1d vg cv cG wceq vg cv cD cfv cG cD cfv
      cF cC cfv vg cv cG cD fveq2 eqeq1d 3anbi12d vg cv cG wceq vg cv cF cR co
      vj cv cF cR co wceq cG cF cR co vj cv cF cR co wceq vg cv vj cv wceq cG
      vj cv wceq vg cv cG wceq vg cv cF cR co cG cF cR co vj cv cF cR co vg cv
      cG cF cR opreq1 eqeq1d vg cv cG vj cv eqeq1 imbi12d imbi12d vj cv cJ wceq
      cG cC cfv vj cv cC cfv wceq cG cD cfv cF cC cfv wceq vj cv cD cfv cF cC
      cfv wceq w3a cG cC cfv cJ cC cfv wceq cG cD cfv cF cC cfv wceq cJ cD cfv
      cF cC cfv wceq w3a cG cF cR co vj cv cF cR co wceq cG vj cv wceq wi cG cF
      cR co cJ cF cR co wceq cG cJ wceq wi vj cv cJ wceq cG cC cfv vj cv cC cfv
      wceq cG cC cfv cJ cC cfv wceq vj cv cD cfv cF cC cfv wceq cJ cD cfv cF cC
      cfv wceq cG cD cfv cF cC cfv wceq vj cv cJ wceq vj cv cC cfv cJ cC cfv cG
      cC cfv vj cv cJ cC fveq2 eqeq2d vj cv cJ wceq vj cv cD cfv cJ cD cfv cF
      cC cfv vj cv cJ cD fveq2 eqeq1d 3anbi13d vj cv cJ wceq cG cF cR co vj cv
      cF cR co wceq cG cF cR co cJ cF cR co wceq cG vj cv wceq cG cJ wceq vj cv
      cJ wceq vj cv cF cR co cJ cF cR co cG cF cR co vj cv cJ cF cR opreq1
      eqeq2d vj cv cJ cG eqeq2 imbi12d imbi12d rcla42v syl sylbid $.
      $( [1-Sep-2008] $) $( [10-Aug-2008] $)
  $}

  ${ $d A c g h $. $d B c g h $. $d F c g h $. $d H c g h $.
     $d O c g h $. $d R c $. $d T c g h $.
    iepiclem.1 $e    |- O = dom ( id_ ` T ) $.
    iepiclem.2 $e    |- H = ( hom ` T ) $.
    iepiclem.3 $e    |- R = ( o_ ` T ) $.
    $( Lemma for ~ isepic . $)
    iepiclem $p      |- (  (  T e. Cat
                         /\ ( A e. O /\ B e. O )
                         /\ F e. ( H ` <. A , B >. ) )
                      -> (  A. c
                            e. O
                               A. g
                               e. ( H ` <. B , c >. )
                                  A. h
                                  e. ( H ` <. B , c >. )
                                     ( ( g R F ) = ( h R F ) -> g = h )
                         -> (  F e. dom ( dom_ ` T )
                            /\ A. g
                               e. dom ( dom_ ` T )
                                  A. h
                                  e. dom ( dom_ ` T )
                                     (  (    ( ( cod_ ` T ) ` g )
                                           = ( ( cod_ ` T ) ` h )
                                        /\   ( ( dom_ ` T ) ` g )
                                           = ( ( cod_ ` T ) ` F )
                                        /\   ( ( dom_ ` T ) ` h )
                                           = ( ( cod_ ` T ) ` F ) )
                                     -> ( ( g R F ) = ( h R F ) -> g = h ) ) )
                         ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv
      cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv
      wral vg cB vc cv cop cH cfv wral vc cO wral cF cT cdom_ cfv cdm wcel vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm wral wa cT ccat wcel cA cO wcel cB cO wcel
      wa cF cA cB cop cH cfv wcel w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vc
      cO wral wa cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm
      wral cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a
      cF cT cdom_ cfv cdm wcel vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vc cO
      wral cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel cF cT
      cdom_ cfv cdm wcel cT ccat wcel cA cO wcel cB cO wcel cF cA cB cop cH cfv
      wcel cF cT cdom_ cfv cdm wcel wi cA cB cT cF cH cT cdom_ cfv cdm cO
      iepiclem.1 cT cdom_ cfv cdm eqid iepiclem.2 ehm 3expib 3imp adantr cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cF
      cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral
      vg cB vc cv cop cH cfv wral vc cO wral wa vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi wi wi vh wal vg wal vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm
      wral cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH
      cfv wral vg cB vc cv cop cH cfv wral vc cO wral wa vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi wi vh wal vg cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel w3a vg cv cF cR co vh cv cF cR co wceq
      vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv
      wral vc cO wral vg cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH
      cfv wcel w3a vg ax-17 vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq
      wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vg vc cO vc cv
      cO wcel vg ax-17 vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv hbra1 hbral hban cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cF
      cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral
      vg cB vc cv cop cH cfv wral vc cO wral wa vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi wi wi vh cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop
      cH cfv wcel w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh
      cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vc cO wral vh cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vh ax-17
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH
      cfv wral vg cB vc cv cop cH cfv wral vh vc cO vc cv cO wcel vh ax-17 vg
      cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH
      cfv wral vh vg cB vc cv cop cH cfv vg cv cB vc cv cop cH cfv wcel vh
      ax-17 vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv
      cop cH cfv hbra1 hbral hbral hban cT ccat wcel cA cO wcel cB cO wcel wa
      cF cA cB cop cH cfv wcel w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh
      cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vc cO
      wral vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT
      ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg
      cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi wi cT ccat wcel cA
      cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cF cR co vh cv cF cR co wceq vg
      cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral
      vc cO wral vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg
      cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cF cR co vh
      cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc
      cv cop cH cfv wral vc cO wral vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv
      cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq
      vg cv vh cv wceq wi wi wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB
      cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa wa vg cv cT ccod_ cfv cfv cO wcel vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH
      cfv wral vc cO wral vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq wi wi wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv
      wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv
      cT ccod_ cfv cfv cO wcel cT ccat wcel cA cO wcel cB cO wcel wa vg cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv
      cO wcel wi cF cA cB cop cH cfv wcel cT ccat wcel vg cv cT cdom_ cfv cdm
      wcel vg cv cT ccod_ cfv cfv cO wcel vh cv cT cdom_ cfv cdm wcel cT ccat
      wcel vg cv cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv cO wcel cT ccod_
      cfv cT vg cv cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid iepiclem.1 cT
      ccod_ cfv eqid cdmo ex adantrd 3ad2ant1 imp cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa wa vg cv cT ccod_ cfv cfv cO wcel wa vg cv cB vc cv
      cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co vh cv cF
      cR co wceq vg cv vh cv wceq wi wi vc cO wral vg cv cT ccod_ cfv cfv vh cv
      cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF
      cR co wceq vg cv vh cv wceq wi wi vg cv cF cR co vh cv cF cR co wceq vg
      cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral
      vc cO wral cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel
      w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg cv
      cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co
      vh cv cF cR co wceq vg cv vh cv wceq wi wi vg cv cT ccod_ cfv cfv vh cv
      cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF
      cR co wceq vg cv vh cv wceq wi wi vc vg cv cT ccod_ cfv cfv cO cT ccat
      wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_
      cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vc cv vg cv cT ccod_ cfv
      cfv wceq wa vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel
      wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vc cv vg
      cv cT ccod_ cfv cfv wceq vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv
      cop cH cfv wcel wa vg cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv
      cB vg cv cT ccod_ cfv cfv cop cH cfv wcel wa cT ccat wcel cA cO wcel cB
      cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cdm wcel wa wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vc cv vg cv cT ccod_ cfv cfv wceq vg cv
      cB vc cv cop cH cfv wcel vg cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel
      vh cv cB vc cv cop cH cfv wcel vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv
      wcel vc cv vg cv cT ccod_ cfv cfv wceq cB vc cv cop cH cfv cB vg cv cT
      ccod_ cfv cfv cop cH cfv vg cv vc cv vg cv cT ccod_ cfv cfv wceq cB vc cv
      cop cB vg cv cT ccod_ cfv cfv cop cH vc cv vg cv cT ccod_ cfv cfv cB
      opeq2 fveq2d eleq2d vc cv vg cv cT ccod_ cfv cfv wceq cB vc cv cop cH cfv
      cB vg cv cT ccod_ cfv cfv cop cH cfv vh cv vc cv vg cv cT ccod_ cfv cfv
      wceq cB vc cv cop cB vg cv cT ccod_ cfv cfv cop cH vc cv vg cv cT ccod_
      cfv cfv cB opeq2 fveq2d eleq2d anbi12d cT ccat wcel cA cO wcel cB cO wcel
      wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa vg cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh
      cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel wa vg cv cT ccod_ cfv cfv vh
      cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq
      vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wb cT ccat wcel cA cO
      wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv cO wcel vh cv
      cT ccod_ cfv cfv cO wcel wa vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cdm wcel wa wa vg cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv
      cB vg cv cT ccod_ cfv cfv cop cH cfv wcel wa vg cv cT ccod_ cfv cfv vh cv
      cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wb cT ccat wcel cA cO
      wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv cO wcel vh cv
      cT ccod_ cfv cfv cO wcel wa cT ccat wcel cA cO wcel cB cO wcel wa vg cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv
      cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa wi cF cA cB cop cH cfv wcel
      cT ccat wcel vg cv cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv cO wcel
      vh cv cT cdom_ cfv cdm wcel vh cv cT ccod_ cfv cfv cO wcel cT ccat wcel
      vg cv cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv cO wcel cT ccod_ cfv
      cT vg cv cT cdom_ cfv cdm cO cT cdom_ cfv cdm eqid iepiclem.1 cT ccod_
      cfv eqid cdmo ex cT ccat wcel vh cv cT cdom_ cfv cdm wcel vh cv cT ccod_
      cfv cfv cO wcel cT ccod_ cfv cT vh cv cT cdom_ cfv cdm cO cT cdom_ cfv
      cdm eqid iepiclem.1 cT ccod_ cfv eqid cdmo ex anim12d 3ad2ant1 ancrd cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT
      ccod_ cfv cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa vg cv cT cdom_
      cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa vg cv cB vg cv cT ccod_
      cfv cfv cop cH cfv wcel vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel
      wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq w3a wb cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv
      wcel w3a vg cv cT ccod_ cfv cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa wa wa vg cv cB
      vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cB vg cv cT ccod_ cfv cfv
      cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB
      wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv
      vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT ccod_ cfv cfv cO wcel vh cv
      cT ccod_ cfv cfv cO wcel wa vg cv cB vg cv cT ccod_ cfv cfv cop cH cfv
      wcel vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel wa vg cv cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv
      cT ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa wb
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa cT ccat wcel
      cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT ccod_ cfv
      cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa wa vg cv cB vg cv cT ccod_
      cfv cfv cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv
      cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq w3a vg cv cT ccod_ cfv cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa
      cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv
      cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq w3a wb vg cv cT ccod_ cfv cfv cO wcel cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel w3a vg cv cB vg cv cT ccod_ cfv cfv cop
      cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg
      cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb wi vh cv cT ccod_
      cfv cfv cO wcel cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv
      wcel w3a vg cv cT ccod_ cfv cfv cO wcel vg cv cB vg cv cT ccod_ cfv cfv
      cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB
      wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb cT ccat
      wcel cA cO wcel cB cO wcel wa vg cv cT ccod_ cfv cfv cO wcel vg cv cB vg
      cv cT ccod_ cfv cfv cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq
      w3a wb wi cF cA cB cop cH cfv wcel cA cO wcel cB cO wcel wa cT ccat wcel
      vg cv cT ccod_ cfv cfv cO wcel vg cv cB vg cv cT ccod_ cfv cfv cop cH cfv
      wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT
      ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb wi cB cO wcel cT ccat
      wcel vg cv cT ccod_ cfv cfv cO wcel vg cv cB vg cv cT ccod_ cfv cfv cop
      cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg
      cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb wi wi cA cO wcel
      cT ccat wcel cB cO wcel vg cv cT ccod_ cfv cfv cO wcel vg cv cB vg cv cT
      ccod_ cfv cfv cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb
      wi cT ccat wcel cB cO wcel vg cv cT ccod_ cfv cfv cO wcel vg cv cB vg cv
      cT ccod_ cfv cfv cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq
      w3a wb cB vg cv cT ccod_ cfv cfv cT ccod_ cfv cT cdom_ cfv cT vg cv cH cT
      cdom_ cfv cdm cO iepiclem.1 cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT
      ccod_ cfv eqid iepiclem.2 ishomd 3exp com12 adantl impcom 3adant3 com12
      adantr impcom vg cv cT ccod_ cfv cfv cO wcel vh cv cT ccod_ cfv cfv cO
      wcel wa cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel
      w3a vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq w3a wb vg cv cT ccod_ cfv cfv cO wcel cT ccat wcel cA
      cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vh cv cB vg cv cT
      ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb
      wi vh cv cT ccod_ cfv cfv cO wcel cT ccat wcel cA cO wcel cB cO wcel wa
      cF cA cB cop cH cfv wcel w3a vg cv cT ccod_ cfv cfv cO wcel vh cv cB vg
      cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq
      w3a wb cT ccat wcel cA cO wcel cB cO wcel wa vg cv cT ccod_ cfv cfv cO
      wcel vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq w3a wb wi cF cA cB cop cH cfv wcel cA cO wcel cB cO
      wcel wa cT ccat wcel vg cv cT ccod_ cfv cfv cO wcel vh cv cB vg cv cT
      ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wb
      wi cB cO wcel cT ccat wcel vg cv cT ccod_ cfv cfv cO wcel vh cv cB vg cv
      cT ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq
      w3a wb wi wi cA cO wcel cT ccat wcel cB cO wcel vg cv cT ccod_ cfv cfv cO
      wcel vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq w3a wb wi cT ccat wcel cB cO wcel vg cv cT ccod_ cfv
      cfv cO wcel vh cv cB vg cv cT ccod_ cfv cfv cop cH cfv wcel vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv
      vg cv cT ccod_ cfv cfv wceq w3a wb cB vg cv cT ccod_ cfv cfv cT ccod_ cfv
      cT cdom_ cfv cT vh cv cH cT cdom_ cfv cdm cO iepiclem.1 cT cdom_ cfv cdm
      eqid cT cdom_ cfv eqid cT ccod_ cfv eqid iepiclem.2 ishomd 3exp com12
      adantl impcom 3adant3 com12 adantr impcom anbi12d adantrr vg cv cT ccod_
      cfv cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa wa cT ccat wcel cA cO wcel cB cO wcel
      wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq
      w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT
      ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT ccod_ cfv cfv
      vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wb vg cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa cT ccat wcel cA cO wcel
      cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv
      cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wb wi vg cv
      cT ccod_ cfv cfv cO wcel vh cv cT ccod_ cfv cfv cO wcel wa cT ccat wcel
      cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vg cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cdm wcel vg cv
      cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv
      cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wb cT ccat
      wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a cF cT cdom_
      cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv cfv cB wceq w3a
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_
      cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv
      cT ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      wb wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel cF
      cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv cfv cB
      wceq w3a cT ccat wcel cA cO wcel cB cO wcel cF cA cB cop cH cfv wcel cF
      cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv cfv cB
      wceq w3a wi cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv
      wcel cF cT cdom_ cfv cdm wcel cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv
      cfv cB wceq w3a cA cB cT ccod_ cfv cT cdom_ cfv cT cF cH cT cdom_ cfv cdm
      cO iepiclem.1 cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid
      iepiclem.2 ishomd biimpd 3expib 3imp cF cT ccod_ cfv cfv cB wceq cF cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv
      cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_
      cfv cfv wceq w3a wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq w3a wb wi cF cT cdom_ cfv cfv cA wceq cF cT ccod_ cfv
      cfv cB wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg
      cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_
      cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq w3a wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq w3a wb cF cT ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm
      wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_
      cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB
      wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv
      cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv
      cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a cF cT ccod_ cfv cfv cB wceq vg cv cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv
      vg cv cT ccod_ cfv cfv wceq w3a vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv
      cB wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a cF cT ccod_ cfv cfv cB
      wceq vg cv cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cfv
      cF cT ccod_ cfv cfv wceq wb cB cF cT ccod_ cfv cfv cB cF cT ccod_ cfv cfv
      vg cv cT cdom_ cfv cfv eqeq2 eqcoms 3anbi2d cF cT ccod_ cfv cfv cB wceq
      vh cv cT cdom_ cfv cfv cB wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq vh cv cT cdom_ cfv cdm wcel vh cv cT ccod_ cfv cfv vg cv cT ccod_
      cfv cfv wceq vh cv cT cdom_ cfv cfv cB wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq wb cB cF cT ccod_ cfv cfv cB cF cT ccod_ cfv cfv vh cv
      cT cdom_ cfv cfv eqeq2 eqcoms 3anbi2d anbi12d vg cv cT cdom_ cfv cdm wcel
      vh cv cT cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_
      cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a
      wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq w3a vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh
      cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a wa vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_
      cfv cdm wcel vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vg cv cT ccod_ cfv cfv vh
      cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv
      cfv wceq w3a vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vh
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv
      cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq
      vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv eqcom biimpi 3ad2ant3
      adantl vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq w3a vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv
      cF cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq 3simp2 adantr vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq
      w3a vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv
      cdm wcel vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT ccod_
      cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq 3simp2 adantl 3jca vg cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vg cv cT
      ccod_ cfv cfv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv
      cF cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      wceq w3a wa vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq vg cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv
      cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq w3a vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wa vg cv cT cdom_ cfv cdm wcel
      vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vg
      cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv
      cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq w3a simpll vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv
      cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq 3simp2
      adantl vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv
      cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wa
      vg cv cT ccod_ cfv cfv eqidd 3jca vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq
      vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq w3a wa vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vg cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      simplr vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq w3a vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv
      vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq 3simp3 adantl vg cv
      cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vh
      cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vh
      cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vh
      cv cT ccod_ cfv cfv eqcom biimpi 3ad2ant1 adantl 3jca jca ex impbid2
      sylan9bb ex 3ad2ant3 syl com12 adantl impcom bitrd ex syld imp sylan9bbr
      imbi1d rcla4dv vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh
      cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vg cv cB vc cv cop
      cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co vh cv cF cR
      co wceq vg cv vh cv wceq wi wi vc cO vg cv cF cR co vh cv cF cR co wceq
      vg cv vh cv wceq wi vg vh cB vc cv cop cH cfv cB vc cv cop cH cfv ra42
      r19.20si syl5 mpdan ex com23 imp 19.21ai 19.21ai vg cv cT ccod_ cfv cfv
      vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co
      vh cv cF cR co wceq vg cv vh cv wceq wi wi vg vh cT cdom_ cfv cdm cT
      cdom_ cfv cdm r2al sylibr jca ex $.
      $( [7-Oct-2008] $) $( [6-Oct-2008] $)
  $}

  ${ $d A c g h $. $d B c g h $. $d F c g h $. $d H c g h $. $d O c g h $.
     $d R c $. $d T c g h $.
    isepic.1 $e |- O = dom ( id_ ` T ) $.
    isepic.2 $e |- H = ( hom ` T ) $.
    isepic.3 $e |- R = ( o_ ` T ) $.
    $( The predicate "is an epimorphism" when the morphism belongs to a
       homset. $)
    isepic $p |- ( ( T e. Cat /\ ( A e. O /\ B e. O ) /\
      F e. ( H ` <. A , B >. ) ) -> ( F e. ( Epi ` T ) <->
        A. c e. O A. g e. ( H ` <. B , c >. ) A. h e. ( H ` <. B , c >. )
        ( ( g R F ) = ( h R F ) -> g = h ) ) ) $=
      cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a cF cT
      cepi cfv wcel cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT
      ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv
      cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR
      co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv
      cdm wral wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB
      vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vc cO wral cT ccat wcel
      cF cA cB cop cH cfv wcel cF cT cepi cfv wcel cF cT cdom_ cfv cdm wcel vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm wral wa wb cA cO wcel cB cO wcel wa cA cB
      cop cH cfv cT ccod_ cfv cT cdom_ cfv cR cT vg vh cF cT cdom_ cfv cdm cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid isepic.3 isepib
      3adant2 cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel
      w3a cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv
      cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq
      vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral
      wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vh cB vc cv cop
      cH cfv wral vg cB vc cv cop cH cfv wral vc cO wral cT ccat wcel cA cO
      wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a cF cT cdom_ cfv cdm wcel
      vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv
      cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq
      w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_
      cfv cdm wral vg cT cdom_ cfv cdm wral wa vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH
      cfv wral vc cO wral cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH
      cfv wcel w3a cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT
      ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv
      cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR
      co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv
      cdm wral wa wa vc cv cO wcel vg cv cB vc cv cop cH cfv wcel vh cv cB vc
      cv cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq
      wi wi vh wal vg wal wi vc wal vg cv cF cR co vh cv cF cR co wceq vg cv vh
      cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv wral vc cO
      wral cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a
      cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral wa wa
      vc cv cO wcel vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv
      wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh wal
      vg wal wi vc cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv
      wcel w3a cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm
      wral wa vc cv cO wcel vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop
      cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi
      vh wal vg wal wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH
      cfv wcel w3a vc cv cO wcel cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR
      co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg
      cT cdom_ cfv cdm wral wa vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv
      cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      wi vh wal vg wal cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH
      cfv wcel w3a vc cv cO wcel cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR
      co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg
      cT cdom_ cfv cdm wral wa vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv
      cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      wi vh wal vg wal cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH
      cfv wcel w3a vc cv cO wcel wa cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR
      co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg
      cT cdom_ cfv cdm wral wa wa vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv
      cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      wi vh wal vg cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv
      wcel w3a vc cv cO wcel wa cF cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv
      vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv
      wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co
      vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT
      cdom_ cfv cdm wral wa vg cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB
      cop cH cfv wcel w3a vc cv cO wcel wa vg ax-17 cF cT cdom_ cfv cdm wcel vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm wral vg cF cT cdom_ cfv cdm wcel vg ax-17 vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv
      cdm wral vg cT cdom_ cfv cdm hbra1 hban hban cT ccat wcel cA cO wcel cB
      cO wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa cF cT cdom_ cfv
      cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral wa wa vg cv cB vc cv
      cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co vh cv cF
      cR co wceq vg cv vh cv wceq wi wi vh cT ccat wcel cA cO wcel cB cO wcel
      wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa cF cT cdom_ cfv cdm wcel
      vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv
      cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq
      w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh cT cdom_
      cfv cdm wral vg cT cdom_ cfv cdm wral wa vh cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa vh ax-17 cF cT
      cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral vh cF cT
      cdom_ cfv cdm wcel vh ax-17 vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi wi vh cT cdom_ cfv cdm wral vh vg cT cdom_ cfv cdm vg cv cT
      cdom_ cfv cdm wcel vh ax-17 vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv
      vh cv wceq wi wi vh cT cdom_ cfv cdm hbra1 hbral hban hban cF cT cdom_
      cfv cdm wcel vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral wa cT ccat wcel cA
      cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa vg cv
      cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co
      vh cv cF cR co wceq vg cv vh cv wceq wi wi vg cv cT ccod_ cfv cfv vh cv
      cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF
      cR co wceq vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_
      cfv cdm wral cF cT cdom_ cfv cdm wcel cT ccat wcel cA cO wcel cB cO wcel
      wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa vg cv cB vc cv cop cH
      cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi wi wi vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv
      cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq
      vg cv vh cv wceq wi wi vh cT cdom_ cfv cdm wral vg cT cdom_ cfv cdm wral
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_
      cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF
      cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi wi vg cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT
      ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv
      cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wa vg cv cF cR co vh cv cF
      cR co wceq vg cv vh cv wceq wi wi cF cT cdom_ cfv cdm wcel cT ccat wcel
      cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa vg
      cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR
      co vh cv cF cR co wceq vg cv vh cv wceq wi wi wi wi vg cv cT ccod_ cfv
      cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cF cR
      co vh cv cF cR co wceq vg cv vh cv wceq wi wi vg vh cT cdom_ cfv cdm cT
      cdom_ cfv cdm ra42 vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq w3a vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi
      pm3.31 cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a
      vc cv cO wcel wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv
      wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cF cT ccod_ cfv cfv wceq w3a wa vg cv cF cR co vh cv cF cR co wceq vg
      cv vh cv wceq wi wi vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH
      cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO
      wcel wa cF cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq
      vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq w3a wa vg cv cF cR co vh cv cF cR co wceq vg cv vh
      cv wceq wi wi vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv
      wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi wi cT
      ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO
      wcel wa cF cT cdom_ cfv cdm wcel wa vg cv cB vc cv cop cH cfv wcel vh cv
      cB vc cv cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_
      cfv cdm wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv
      cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq w3a wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv
      wceq wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel
      w3a vc cv cO wcel wa cF cT cdom_ cfv cdm wcel wa vg cv cB vc cv cop cH
      cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv
      cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv
      cfv vc cv wceq w3a wa vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq w3a wa cT ccat wcel cB cO wcel vc cv cO wcel vg cv cB vc cv cop
      cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg cv cT cdom_ cfv cdm wcel
      vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh
      cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_
      cfv cfv vc cv wceq w3a wa wi cT ccat wcel cA cO wcel cB cO wcel wa cF cA
      cB cop cH cfv wcel w3a vc cv cO wcel wa cF cT cdom_ cfv cdm wcel wa cT
      ccat wcel cB cO wcel vc cv cO wcel w3a vg cv cB vc cv cop cH cfv wcel vg
      cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_
      cfv cfv vc cv wceq w3a vh cv cB vc cv cop cH cfv wcel vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq
      w3a cT ccat wcel cB cO wcel vc cv cO wcel w3a vg cv cB vc cv cop cH cfv
      wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT
      ccod_ cfv cfv vc cv wceq w3a cB vc cv cT ccod_ cfv cT cdom_ cfv cT vg cv
      cH cT cdom_ cfv cdm cO isepic.1 cT cdom_ cfv cdm eqid cT cdom_ cfv eqid
      cT ccod_ cfv eqid isepic.2 ishomd biimpd cT ccat wcel cB cO wcel vc cv cO
      wcel w3a vh cv cB vc cv cop cH cfv wcel vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a cB vc cv
      cT ccod_ cfv cT cdom_ cfv cT vh cv cH cT cdom_ cfv cdm cO isepic.1 cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid isepic.2 ishomd
      biimpd anim12d cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv
      wcel w3a cT ccat wcel vc cv cO wcel cF cT cdom_ cfv cdm wcel cT ccat wcel
      cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel 3simp1 ad2antrr cT ccat
      wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a cB cO wcel vc
      cv cO wcel cF cT cdom_ cfv cdm wcel cA cO wcel cB cO wcel wa cT ccat wcel
      cB cO wcel cF cA cB cop cH cfv wcel cA cO wcel cB cO wcel pm3.27 3ad2ant2
      ad2antrr cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel
      w3a vc cv cO wcel cF cT cdom_ cfv cdm wcel simplr syl3anc cT ccat wcel cA
      cO wcel cB cO wcel wa cF cA cB cop cH cfv wcel w3a vc cv cO wcel wa cF cT
      cdom_ cfv cdm wcel wa vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv
      cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT cdom_ cfv cdm wcel
      vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a wa
      vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel wa vg cv cT ccod_
      cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a vg cv cT
      cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv
      vc cv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq
      vh cv cT ccod_ cfv cfv vc cv wceq w3a wa vg cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cdm wcel wa wi cT ccat wcel cA cO wcel cB cO wcel wa cF
      cA cB cop cH cfv wcel w3a vc cv cO wcel wa cF cT cdom_ cfv cdm wcel wa vg
      cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_
      cfv cfv vc cv wceq w3a vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a
      vh cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq 3simp1 vh cv cT cdom_
      cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv
      wceq 3simp1 anim12i a1i cT ccat wcel cA cO wcel cB cO wcel wa cF cA cB
      cop cH cfv wcel w3a vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB
      wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT cdom_ cfv cdm wcel vh
      cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a wa vg
      cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF
      cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a
      wi vc cv cO wcel cF cT cdom_ cfv cdm wcel cT ccat wcel cA cO wcel cB cO
      wcel wa cF cA cB cop cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv
      vc cv wceq w3a wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq w3a wi cT ccat wcel cA cO wcel cB cO wcel cF cA cB cop
      cH cfv wcel vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg
      cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT cdom_ cfv cdm wcel vh cv cT
      cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a wa vg cv cT
      ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq w3a wi
      wi cT ccat wcel cA cO wcel cB cO wcel w3a cF cA cB cop cH cfv wcel cF cT
      ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv cfv
      cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT cdom_ cfv cdm wcel
      vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a wa
      vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv
      cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq
      w3a wi cA cB cT ccod_ cfv cT cF cH cO isepic.1 cT ccod_ cfv eqid isepic.2
      cehm cF cT ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv
      vc cv wceq w3a wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg
      cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq w3a cF cT ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm
      wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a
      vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_
      cfv cfv vc cv wceq w3a wa wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv
      cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_
      cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vg cv cT
      cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT
      cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv
      vc cv wceq w3a wa vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq cF
      cT ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_ cfv
      cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT cdom_ cfv cdm
      wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a
      vg cv cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv
      vc cv wceq vg cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cdm wcel vh cv
      cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq w3a vg cv cT
      ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq wi vg cv cT cdom_ cfv cfv cB
      wceq vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT
      ccod_ cfv cfv vc cv wceq w3a vg cv cT ccod_ cfv cfv vc cv wceq vg cv cT
      ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq vh cv cT ccod_ cfv cfv vc cv
      wceq vh cv cT cdom_ cfv cdm wcel vg cv cT ccod_ cfv cfv vc cv wceq vg cv
      cT ccod_ cfv cfv vh cv cT ccod_ cfv cfv wceq wi vh cv cT cdom_ cfv cfv cB
      wceq vg cv cT ccod_ cfv cfv vc cv wceq vg cv cT ccod_ cfv cfv vh cv cT
      ccod_ cfv cfv wceq wi vc cv vh cv cT ccod_ cfv cfv vg cv cT ccod_ cfv cfv
      vc cv wceq vc cv vh cv cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vh cv
      cT ccod_ cfv cfv wceq vg cv cT ccod_ cfv cfv vc cv vh cv cT ccod_ cfv cfv
      eqtr expcom eqcoms 3ad2ant3 com12 3ad2ant3 imp adantl vg cv cT cdom_ cfv
      cdm wcel vg cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq
      w3a vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT
      ccod_ cfv cfv vc cv wceq w3a wa cF cT ccod_ cfv cfv cB wceq vg cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cdm wcel vg cv
      cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a cF cT
      ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq wi
      vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_
      cfv cfv vc cv wceq w3a vg cv cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv
      cdm wcel cF cT ccod_ cfv cfv cB wceq vg cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq wi vg cv cT ccod_ cfv cfv vc cv wceq cF cT ccod_ cfv cfv cB
      wceq vg cv cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cfv cF cT ccod_
      cfv cfv wceq vg cv cT cdom_ cfv cfv cB wceq vg cv cT cdom_ cfv cfv cF cT
      ccod_ cfv cfv wceq wi cB cF cT ccod_ cfv cfv vg cv cT cdom_ cfv cfv cB
      wceq cB cF cT ccod_ cfv cfv wceq vg cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vg cv cT cdom_ cfv cfv cB cF cT ccod_ cfv cfv eqtr expcom eqcoms
      com12 3ad2ant2 adantr impcom vg cv cT cdom_ cfv cdm wcel vg cv cT cdom_
      cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv cT cdom_ cfv
      cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv cT ccod_ cfv cfv vc cv wceq
      w3a wa cF cT ccod_ cfv cfv cB wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv
      cfv wceq vh cv cT cdom_ cfv cdm wcel vh cv cT cdom_ cfv cfv cB wceq vh cv
      cT ccod_ cfv cfv vc cv wceq w3a cF cT ccod_ cfv cfv cB wceq vh cv cT
      cdom_ cfv cfv cF cT ccod_ cfv cfv wceq wi vg cv cT cdom_ cfv cdm wcel vg
      cv cT cdom_ cfv cfv cB wceq vg cv cT ccod_ cfv cfv vc cv wceq w3a vh cv
      cT cdom_ cfv cfv cB wceq vh cv cT cdom_ cfv cdm wcel cF cT ccod_ cfv cfv
      cB wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq wi vh cv cT ccod_
      cfv cfv vc cv wceq cF cT ccod_ cfv cfv cB wceq vh cv cT cdom_ cfv cfv cB
      wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv
      cfv cB wceq vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq wi cB cF cT
      ccod_ cfv cfv vh cv cT cdom_ cfv cfv cB wceq cB cF cT ccod_ cfv cfv wceq
      vh cv cT cdom_ cfv cfv cF cT ccod_ cfv cfv wceq vh cv cT cdom_ cfv cfv cB
      cF cT ccod_ cfv cfv eqtr expcom eqcoms com12 3ad2ant2 adantl impcom 3jca
      ex syl6 3expib 3imp ad2antrr jcad syld imim1d ex com13 3syl impcom impcom
      19.21ai 19.21ai exp31 com23 imp 19.21aiv vg cv cF cR co vh cv cF cR co
      wceq vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH
      cfv wral vc cO wral vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH
      cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh
      wal vg wal vc cO wral vc cv cO wcel vg cv cB vc cv cop cH cfv wcel vh cv
      cB vc cv cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg cv vh
      cv wceq wi wi vh wal vg wal wi vc wal vg cv cF cR co vh cv cF cR co wceq
      vg cv vh cv wceq wi vh cB vc cv cop cH cfv wral vg cB vc cv cop cH cfv
      wral vg cv cB vc cv cop cH cfv wcel vh cv cB vc cv cop cH cfv wcel wa vg
      cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi wi vh wal vg wal vc
      cO vg cv cF cR co vh cv cF cR co wceq vg cv vh cv wceq wi vg vh cB vc cv
      cop cH cfv cB vc cv cop cH cfv r2al ralbii vg cv cB vc cv cop cH cfv wcel
      vh cv cB vc cv cop cH cfv wcel wa vg cv cF cR co vh cv cF cR co wceq vg
      cv vh cv wceq wi wi vh wal vg wal vc cO df-ral bitri sylibr ex cA cB cR
      cT vg vh cF cH cO vc isepic.1 isepic.2 isepic.3 iepiclem impbid bitrd $.
      $( [17-Nov-2008] $) $( [27-Oct-2008] $)
  $}

  $c cinv $.
  $( Extend class notation to include a function that returns the inverses
     of a morphism. $)
  ccinv $a class cinv $.

  ${ $d x y f z g $.
    $( Function ( indexed by the category ` x ` ) returning the inverses of a
       morphism ` f ` . $)
    df-cinv $a |- cinv = { <. x , y >. | ( x e. Cat /\
      y = { <. f , z >. | ( f e. dom ( dom_ ` x ) /\
      z = { g e. dom ( dom_ ` x ) | ( ( f ( o_ ` x ) g ) =
      ( ( id_ ` x ) ` ( ( cod_ ` x ) ` f ) ) /\
     ( g ( o_ ` x ) f ) = ( ( id_ ` x ) ` ( ( dom_ ` x ) ` f ) ) ) } ) } ) } $.
  $}

  ${ $d C x y z $. $d D x y z $. $d J x y z $. $d M f g x y z $.
  $d R x y z $. $d T f g x y z $.
    cinvlem1.1 $e |- M = dom ( dom_ ` T ) $.
    cinvlem1.2 $e |- D = ( dom_ ` T ) $.
    cinvlem1.3 $e |- C = ( cod_ ` T ) $.
    cinvlem1.4 $e |- R = ( o_ ` T ) $.
    cinvlem1.5 $e |- J = ( id_ ` T ) $.
    $( The set of the inverses of all the morphisms  . $)
    cinvlem1 $p |- ( T e. Cat -> ( cinv ` T ) = { <. f , z >. | ( f e. M /\
      z = { g e. M | ( ( f R g ) = ( J ` ( C ` f ) )
      /\ ( g R f ) = ( J ` ( D ` f ) ) ) } ) } ) $=
      vx vy cT vf cv vx cv cdom_ cfv cdm wcel vz cv vf cv vg cv vx cv co_ cfv
      co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg cv vf cv vx cv
      co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv wceq wa vg vx cv
      cdom_ cfv cdm crab wceq wa vf vz copab vf cv cM wcel vz cv vf cv vg cv cR
      co vf cv cC cfv cJ cfv wceq vg cv vf cv cR co vf cv cD cfv cJ cfv wceq wa
      vg cM crab wceq wa vf vz copab ccat ccinv vx cv cT wceq vf cv vx cv cdom_
      cfv cdm wcel vz cv vf cv vg cv vx cv co_ cfv co vf cv vx cv ccod_ cfv cfv
      vx cv cid_ cfv cfv wceq vg cv vf cv vx cv co_ cfv co vf cv vx cv cdom_
      cfv cfv vx cv cid_ cfv cfv wceq wa vg vx cv cdom_ cfv cdm crab wceq wa vf
      cv cM wcel vz cv vf cv vg cv cR co vf cv cC cfv cJ cfv wceq vg cv vf cv
      cR co vf cv cD cfv cJ cfv wceq wa vg cM crab wceq wa vf vz vx cv cT wceq
      vf cv vx cv cdom_ cfv cdm wcel vf cv cM wcel vz cv vf cv vg cv vx cv co_
      cfv co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg cv vf cv vx
      cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv wceq wa vg vx
      cv cdom_ cfv cdm crab wceq vz cv vf cv vg cv cR co vf cv cC cfv cJ cfv
      wceq vg cv vf cv cR co vf cv cD cfv cJ cfv wceq wa vg cM crab wceq vx cv
      cT wceq vx cv cdom_ cfv cdm cM vf cv vx cv cT wceq vx cv cdom_ cfv cdm cT
      cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_ cfv cT cdom_ cfv vx cv cT
      cdom_ fveq2 dmeqd cinvlem1.1 syl6eqr eleq2d vx cv cT wceq vf cv vg cv vx
      cv co_ cfv co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg cv vf
      cv vx cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv wceq wa
      vg vx cv cdom_ cfv cdm crab vf cv vg cv cR co vf cv cC cfv cJ cfv wceq vg
      cv vf cv cR co vf cv cD cfv cJ cfv wceq wa vg cM crab vz cv vx cv cT wceq
      vf cv vg cv vx cv co_ cfv co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv
      wceq vg cv vf cv vx cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_
      cfv cfv wceq wa vg vx cv cdom_ cfv cdm crab vf cv vg cv vx cv co_ cfv co
      vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg cv vf cv vx cv co_
      cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv wceq wa vg cM crab vf
      cv vg cv cR co vf cv cC cfv cJ cfv wceq vg cv vf cv cR co vf cv cD cfv cJ
      cfv wceq wa vg cM crab vx cv cT wceq vx cv cdom_ cfv cdm cM wceq vf cv vg
      cv vx cv co_ cfv co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg
      cv vf cv vx cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv
      wceq wa vg vx cv cdom_ cfv cdm crab vf cv vg cv vx cv co_ cfv co vf cv vx
      cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg cv vf cv vx cv co_ cfv co vf
      cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv wceq wa vg cM crab wceq vx cv
      cT wceq vx cv cdom_ cfv cdm cT cdom_ cfv cdm cM vx cv cT wceq vx cv cdom_
      cfv cT cdom_ cfv vx cv cT cdom_ fveq2 dmeqd cinvlem1.1 syl6eqr vf cv vg
      cv vx cv co_ cfv co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg
      cv vf cv vx cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv
      wceq wa vg vx cv cdom_ cfv cdm cM rabeq syl vx cv cT wceq vf cv vg cv vx
      cv co_ cfv co vf cv vx cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vg cv vf
      cv vx cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv wceq wa
      vf cv vg cv cR co vf cv cC cfv cJ cfv wceq vg cv vf cv cR co vf cv cD cfv
      cJ cfv wceq wa vg cM vx cv cT wceq vf cv vg cv vx cv co_ cfv co vf cv vx
      cv ccod_ cfv cfv vx cv cid_ cfv cfv wceq vf cv vg cv cR co vf cv cC cfv
      cJ cfv wceq vg cv vf cv vx cv co_ cfv co vf cv vx cv cdom_ cfv cfv vx cv
      cid_ cfv cfv wceq vg cv vf cv cR co vf cv cD cfv cJ cfv wceq vx cv cT
      wceq vf cv vg cv vx cv co_ cfv co vf cv vg cv cR co vf cv vx cv ccod_ cfv
      cfv vx cv cid_ cfv cfv vf cv cC cfv cJ cfv vx cv cT wceq vx cv co_ cfv cR
      vf cv vg cv vx cv cT wceq vx cv co_ cfv cT co_ cfv cR vx cv cT co_ fveq2
      cinvlem1.4 syl6eqr opreqd vx cv cT wceq vf cv vx cv ccod_ cfv cfv vf cv
      cC cfv vx cv cid_ cfv cJ vx cv cT wceq vx cv cid_ cfv cT cid_ cfv cJ vx
      cv cT cid_ fveq2 cinvlem1.5 syl6eqr vx cv cT wceq vf cv vx cv ccod_ cfv
      cC vx cv cT wceq vx cv ccod_ cfv cT ccod_ cfv cC vx cv cT ccod_ fveq2
      cinvlem1.3 syl6eqr fveq1d fveq12d eqeq12d vx cv cT wceq vg cv vf cv vx cv
      co_ cfv co vg cv vf cv cR co vf cv vx cv cdom_ cfv cfv vx cv cid_ cfv cfv
      vf cv cD cfv cJ cfv vx cv cT wceq vx cv co_ cfv cR vg cv vf cv vx cv cT
      wceq vx cv co_ cfv cT co_ cfv cR vx cv cT co_ fveq2 cinvlem1.4 syl6eqr
      opreqd vx cv cT wceq vf cv vx cv cdom_ cfv cfv vf cv cD cfv vx cv cid_
      cfv cJ vx cv cT wceq vx cv cid_ cfv cT cid_ cfv cJ vx cv cT cid_ fveq2
      cinvlem1.5 syl6eqr vx cv cT wceq vf cv vx cv cdom_ cfv cD vx cv cT wceq
      vx cv cdom_ cfv cT cdom_ cfv cD vx cv cT cdom_ fveq2 cinvlem1.2 syl6eqr
      fveq1d fveq12d eqeq12d anbi12d rabbisdv eqtrd eqeq2d anbi12d opabbidv vx
      vy vz vf vg df-cinv vf vz cM vf cv vg cv cR co vf cv cC cfv cJ cfv wceq
      vg cv vf cv cR co vf cv cD cfv cJ cfv wceq wa vg cM crab cM cT cdom_ cfv
      cdm cvv cinvlem1.1 cT cdom_ cfv cT cdom_ fvex dmex eqeltri opabex2
      fvopab4 $.
      $( [22-Dec-2008] $) $( [22-Dec-2008] $)
  $}

  ${ $d C f z $. $d D f z $. $d F f g z $. $d J f z $.
  $d M f g z $. $d R f z $. $d T f g z $.
    cinvlem2.1 $e |- M = dom ( dom_ ` T ) $.
    cinvlem2.2 $e |- D = ( dom_ ` T ) $.
    cinvlem2.3 $e |- C = ( cod_ ` T ) $.
    cinvlem2.4 $e |- R = ( o_ ` T ) $.
    cinvlem2.5 $e |- J = ( id_ ` T ) $.
    cinvlem2.6 $e |- T e. Cat $.
    $( The set of the inverses of the morphism ` F ` . $)
    cinvlem2 $p |- ( F e. M  -> ( ( cinv ` T ) ` F ) =
      { g e. M | ( ( F R g ) = ( J ` ( C ` F ) )
      /\ ( g R F ) = ( J ` ( D ` F ) ) ) } ) $=
      vf vz cF vf cv vg cv cT co_ cfv co vf cv cC cfv cJ cfv wceq vg cv vf cv
      cT co_ cfv co vf cv cD cfv cJ cfv wceq wa vg cM crab cF vg cv cR co cF cC
      cfv cJ cfv wceq vg cv cF cR co cF cD cfv cJ cfv wceq wa vg cM crab cM cT
      ccinv cfv vf cv cF wceq vf cv vg cv cT co_ cfv co vf cv cC cfv cJ cfv
      wceq vg cv vf cv cT co_ cfv co vf cv cD cfv cJ cfv wceq wa cF vg cv cR co
      cF cC cfv cJ cfv wceq vg cv cF cR co cF cD cfv cJ cfv wceq wa vg cM vf cv
      cF wceq vf cv vg cv cT co_ cfv co vf cv cC cfv cJ cfv wceq cF vg cv cR co
      cF cC cfv cJ cfv wceq vg cv vf cv cT co_ cfv co vf cv cD cfv cJ cfv wceq
      vg cv cF cR co cF cD cfv cJ cfv wceq vf cv cF wceq vf cv vg cv cT co_ cfv
      co cF vg cv cR co vf cv cC cfv cJ cfv cF cC cfv cJ cfv vf cv cF wceq vf
      cv cF vg cv vg cv cT co_ cfv cR cT co_ cfv cR wceq vf cv cF wceq cR cT
      co_ cfv cinvlem2.4 eqcomi a1i vf cv cF wceq id vf cv cF wceq vg cv eqidd
      opreq123d vf cv cF wceq vf cv cC cfv cF cC cfv cJ vf cv cF cC fveq2
      fveq2d eqeq12d vf cv cF wceq vg cv vf cv cT co_ cfv co vg cv cF cR co vf
      cv cD cfv cJ cfv cF cD cfv cJ cfv vf cv cF wceq vg cv vg cv vf cv cF cT
      co_ cfv cR cT co_ cfv cR wceq vf cv cF wceq cR cT co_ cfv cinvlem2.4
      eqcomi a1i vf cv cF wceq vg cv eqidd vf cv cF wceq id opreq123d vf cv cF
      wceq vf cv cD cfv cF cD cfv cJ vf cv cF cD fveq2 fveq2d eqeq12d anbi12d
      rabbisdv cT ccat wcel cT ccinv cfv vf cv cM wcel vz cv vf cv vg cv cT co_
      cfv co vf cv cC cfv cJ cfv wceq vg cv vf cv cT co_ cfv co vf cv cD cfv cJ
      cfv wceq wa vg cM crab wceq wa vf vz copab wceq cinvlem2.6 vz cC cD cT
      co_ cfv cT vf vg cJ cM cinvlem2.1 cinvlem2.2 cinvlem2.3 cT co_ cfv eqid
      cinvlem2.5 cinvlem1 ax-mp cF vg cv cR co cF cC cfv cJ cfv wceq vg cv cF
      cR co cF cD cfv cJ cfv wceq wa vg cM cM cT cdom_ cfv cdm cvv cinvlem2.1
      cT cdom_ cfv cT cdom_ fvex dmex eqeltri rabex fvopab4 $.
      $( [22-Dec-2008] $) $( [22-Dec-2008] $)
  $}

  ${ $d C g $. $d D g $. $d F g $. $d G g $.
  $d J g $. $d M g $. $d R g $. $d T g $.
    cinvlem3.1 $e |- M = dom ( dom_ ` T ) $.
    cinvlem3.2 $e |- D = ( dom_ ` T ) $.
    cinvlem3.3 $e |- C = ( cod_ ` T ) $.
    cinvlem3.4 $e |- R = ( o_ ` T ) $.
    cinvlem3.5 $e |- J = ( id_ ` T ) $.
    cinvlem3.6 $e |- T e. Cat $.
    cinvlem3.7 $e |- F e. M $.
    $( The set of the inverses of the morphism ` F ` . $)
    cinvlem3 $p |-
      ( G e. ( ( cinv ` T ) ` F ) <->
      ( G e. M /\ ( F R G ) = ( J ` ( C ` F ) )
      /\ ( G R F ) = ( J ` ( D ` F ) ) ) ) $=
      cG cF vg cv cR co cF cC cfv cJ cfv wceq vg cv cF cR co cF cD cfv cJ cfv
      wceq wa vg cM crab wcel cG cM wcel cF cG cR co cF cC cfv cJ cfv wceq cG
      cF cR co cF cD cfv cJ cfv wceq wa wa cG cF cT ccinv cfv cfv wcel cG cM
      wcel cF cG cR co cF cC cfv cJ cfv wceq cG cF cR co cF cD cfv cJ cfv wceq
      w3a cF vg cv cR co cF cC cfv cJ cfv wceq vg cv cF cR co cF cD cfv cJ cfv
      wceq wa cF cG cR co cF cC cfv cJ cfv wceq cG cF cR co cF cD cfv cJ cfv
      wceq wa vg cG cM vg cv cG wceq cF vg cv cR co cF cC cfv cJ cfv wceq cF cG
      cR co cF cC cfv cJ cfv wceq vg cv cF cR co cF cD cfv cJ cfv wceq cG cF cR
      co cF cD cfv cJ cfv wceq vg cv cG wceq cF vg cv cR co cF cG cR co cF cC
      cfv cJ cfv vg cv cG cF cR opreq2 eqeq1d vg cv cG wceq vg cv cF cR co cG
      cF cR co cF cD cfv cJ cfv vg cv cG cF cR opreq1 eqeq1d anbi12d elrab cF
      cT ccinv cfv cfv cF vg cv cR co cF cC cfv cJ cfv wceq vg cv cF cR co cF
      cD cfv cJ cfv wceq wa vg cM crab cG cF cM wcel cF cT ccinv cfv cfv cF vg
      cv cR co cF cC cfv cJ cfv wceq vg cv cF cR co cF cD cfv cJ cfv wceq wa vg
      cM crab wceq cinvlem3.7 cC cD cR cT vg cF cJ cM cinvlem3.1 cinvlem3.2
      cinvlem3.3 cinvlem3.4 cinvlem3.5 cinvlem3.6 cinvlem2 ax-mp eleq2i cG cM
      wcel cF cG cR co cF cC cfv cJ cfv wceq cG cF cR co cF cD cfv cJ cfv wceq
      3anass 3bitr4i $.
      $( [22-Dec-2008] $) $( [22-Dec-2008] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Functors
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( The class of all functors. $)
  $c Func $.

  $( The class of all isomorphisms. $)
  $c Isofunc $.

  $( Extend class notation with the class of all  functors. $)
  cfunc $a class Func $.

  $( Extend class notation with the class of all isomorphisms. $)
  cifunc $a class Isofunc $.


  ${ $d  t u v f o p m n $.
    $( Function returning all the functors from a category ` t ` to a category
       ` u ` .  Intuitively a functor associates any morphism of ` t ` to a
       morphism of ` u ` , any object of ` t ` to an object of ` u ` , and
       respects the identity, the composition, the domain and the codomain.
       Here to capture the idea that a functor associates any object of
       ` t ` to an object of ` u ` we write it associates any identity of
       ` t ` to an identity of ` u ` which simplifies the definition. $)
    df-func $a |- Func = { <. <. t , u >. , v >. |
      ( ( t e. Cat /\ u e. Cat ) /\
      v = { f | ( f : dom ( dom_ ` t ) --> dom ( dom_ ` u ) /\
      ( A. o e. dom ( id_ ` t )
      E. p e. dom ( id_ ` u ) ( f ` ( ( id_ ` t ) ` o ) ) =
           ( ( id_ ` u ) ` p ) /\
      ( A. m e. dom ( dom_ ` t )
        ( f ` ( ( id_ ` t ) ` ( ( dom_ ` t ) ` m ) ) ) =
           ( ( id_ ` u ) ` ( ( dom_ ` u ) ` ( f ` m ) ) ) /\
       A. m e. dom ( dom_ ` t )
        ( f ` ( ( id_ ` t ) ` ( ( cod_ ` t ) ` m ) ) ) =
           ( ( id_ ` u ) ` ( ( cod_ ` u ) ` ( f ` m ) ) ) ) /\
       A. m e. dom ( dom_ ` t ) A. n e. dom ( dom_ ` t )
        ( ( ( cod_ ` t ) ` n ) = ( ( dom_ ` t ) ` m ) ->
          ( f ` ( m ( o_ ` t ) n ) ) =
           ( ( f ` m ) ( o_ ` u ) ( f ` n ) ) ) ) ) } ) } $.
  $}

  ${ $d C1 u v $.  $d C2 u v $.  $d D1 u v $.  $d D2 u v $.  $d I1 u v $.
     $d I2 u v $.  $d M1 f m t u v $.  $d M1 x $.  $d M2 f u v $.
     $d M2 x $.  $d O1 o u v $.  $d O2 p u v $.  $d Ro1 u v $.  $d Ro2 u v $.
     $d T f m n o p t u v $.  $d U f m n o p t u v $.
    isfuna.1 $e |- O1 = dom ( id_ ` T ) $.
    isfuna.2 $e |- M1 = dom ( dom_ ` T ) $.
    isfuna.3 $e |- D1 = ( dom_ ` T ) $.
    isfuna.4 $e |- C1 = ( cod_ ` T ) $.
    isfuna.5 $e |- I1 = ( id_ ` T ) $.
    isfuna.6 $e |- Ro1 = ( o_ ` T ) $.
    isfuna.7 $e |- O2 = dom ( id_ ` U ) $.
    isfuna.8 $e |- M2 = dom ( dom_ ` U ) $.
    isfuna.9 $e |- D2 = ( dom_ ` U ) $.
    isfuna.10 $e |- C2 = ( cod_ ` U ) $.
    isfuna.11 $e |- I2 = ( id_ ` U ) $.
    isfuna.12 $e |- Ro2 = ( o_ ` U ) $.
    $( The class of functors between the categories ` T ` and ` U ` . $)
    isfuna $p |- ( ( T e. Cat /\ U e. Cat ) -> ( Func ` <. T , U >. ) =
      { f | ( f : M1 --> M2 /\
       ( A. o e. O1 E. p e. O2 ( f ` ( I1 ` o ) ) = ( I2 ` p ) /\
        ( A. m e. M1 ( f ` ( I1  ` ( D1 ` m ) ) ) =
            ( I2 ` ( D2 ` ( f ` m ) ) ) /\
          A. m e. M1 ( f ` ( I1 ` ( C1 ` m ) ) ) =
            ( I2 ` ( C2 ` ( f ` m ) ) ) ) /\
          A. m e. M1 A. n e. M1 ( ( C1 ` n ) = ( D1 ` m ) ->
            ( f ` ( m Ro1 n ) ) = ( ( f ` m ) Ro2 ( f ` n ) ) ) ) ) } ) $=
      cT ccat wcel cU ccat wcel cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv
      ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm
      cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv
      cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm
      cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab cvv wcel cT cU
      cop cfunc cfv cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq
      vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv
      cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf
      cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv
      wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2
      co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab wceq cT ccat wcel cU
      ccat wcel wa vf cv cm2 cm1 cm co wcel vo cv ci1 cfv vf cv cfv vp cv ci2
      cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf
      cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv
      vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv
      cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab cm1 cm2 vf cv
      wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm
      cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1
      wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq
      vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv
      cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1
      wral w3a wa vf cab cvv cT ccat wcel cU ccat wcel wa vf cv cm2 cm1 cm co
      wcel vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral
      vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm
      cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv
      wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co
      vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm
      cm1 wral w3a wa cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv
      wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv
      cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm
      cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1
      cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv
      cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cT ccat wcel cU ccat
      wcel wa vf cv cm2 cm1 cm co wcel cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv
      vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv
      cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1
      cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv
      cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv
      vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a cT ccat wcel
      cU ccat wcel wa cm2 cvv wcel cm1 cvv wcel wa vf cv cm2 cm1 cm co wcel cm1
      cm2 vf cv wf wb cm2 cvv wcel cm1 cvv wcel wa cT ccat wcel cU ccat wcel wa
      cm2 cvv wcel cm1 cvv wcel cm2 cU cdom_ cfv cdm cvv isfuna.8 cU cdom_ cfv
      cU cdom_ fvex dmex eqeltri cm1 cT cdom_ cfv cdm cvv isfuna.2 cT cdom_ cfv
      cT cdom_ fvex dmex eqeltri pm3.2i a1i cm2 cm1 vf cv cvv cvv elmapg syl
      anbi1d abbidv cT ccat wcel cU ccat wcel wa vo cv ci1 cfv vf cv cfv vp cv
      ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm
      cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv
      cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm
      cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a vf cm2 cm1 cm co crab cvv
      vf cv cm2 cm1 cm co wcel vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp
      co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2
      cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv
      cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq
      vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co
      wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab cT ccat wcel cU ccat wcel
      wa cm2 cm1 cm co cvv wcel vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp
      co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2
      cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv
      cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq
      vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co
      wceq wi vn cm1 wral vm cm1 wral w3a vf cm2 cm1 cm co crab cvv wcel cT
      ccat wcel cU ccat wcel wa cm2 cm1 cm co cm1 cm2 vx cv wf vx cab cvv cU
      ccat wcel cT ccat wcel cm2 cm1 cm co cm1 cm2 vx cv wf vx cab wceq cU ccat
      wcel cT ccat wcel wa cm2 cvv wcel cm1 cvv wcel wa cm2 cm1 cm co cm1 cm2
      vx cv wf vx cab wceq cm2 cvv wcel cm1 cvv wcel wa cU ccat wcel cT ccat
      wcel wa cm2 cvv wcel cm1 cvv wcel cm2 cU cdom_ cfv cdm cvv isfuna.8 cU
      cdom_ cfv cU cdom_ fvex dmex eqeltri cm1 cT cdom_ cfv cdm cvv isfuna.2 cT
      cdom_ cfv cT cdom_ fvex dmex eqeltri pm3.2i a1i cm2 cm1 cvv cvv vx
      mapvalg syl ancoms cT ccat wcel cU ccat wcel wa cm1 cvv wcel cm2 cvv wcel
      wa cm1 cm2 vx cv wf vx cab cvv wcel cm1 cvv wcel cm2 cvv wcel wa cT ccat
      wcel cU ccat wcel wa cm1 cvv wcel cm2 cvv wcel cm1 cT cdom_ cfv cdm cvv
      isfuna.2 cT cdom_ cfv cT cdom_ fvex dmex eqeltri cm2 cU cdom_ cfv cdm cvv
      isfuna.8 cU cdom_ cfv cU cdom_ fvex dmex eqeltri pm3.2i a1i cm1 cm2 cvv
      cvv vx mapex syl eqeltrd vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp
      co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2
      cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv
      cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq
      vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co
      wceq wi vn cm1 wral vm cm1 wral w3a vf cm2 cm1 cm co cvv rabexg syl vo cv
      ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1
      cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm
      cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1
      wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm
      cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a
      vf cm2 cm1 cm co df-rab syl5eqelr eqeltrrd cT ccat wcel cU ccat wcel cm1
      cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo
      co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv
      wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv
      ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv
      cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cm1
      wral vm cm1 wral w3a wa vf cab cvv wcel w3a cT cU cfunc co cm1 cm2 vf cv
      wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm
      cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1
      wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq
      vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv
      cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1
      wral w3a wa vf cab cT cU cop cfunc cfv vt vu vv cT cU ccat ccat vt cv
      cdom_ cfv cdm vu cv cdom_ cfv cdm vf cv wf vo cv vt cv cid_ cfv cfv vf cv
      cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo vt cv
      cid_ cfv cdm wral vm cv vt cv cdom_ cfv cfv vt cv cid_ cfv cfv vf cv cfv
      vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv
      cdom_ cfv cdm wral vm cv vt cv ccod_ cfv cfv vt cv cid_ cfv cfv vf cv cfv
      vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv
      cdom_ cfv cdm wral wa vn cv vt cv ccod_ cfv cfv vm cv vt cv cdom_ cfv cfv
      wceq vm cv vn cv vt cv co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv vu cv co_ cfv co wceq wi vn vt cv cdom_ cfv cdm wral vm vt cv cdom_
      cfv cdm wral w3a wa vf cab cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv
      ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm
      cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv
      cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm
      cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab cfunc cm1 vu cv
      cdom_ cfv cdm vf cv wf vo cv cT cid_ cfv cfv vf cv cfv vp cv vu cv cid_
      cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo cT cid_ cfv cdm wral vm cv cT
      cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv
      cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv
      cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv
      cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT ccod_ cfv cfv vm
      cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf cv
      cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vm
      cT cdom_ cfv cdm wral w3a wa vf cab cvv vt cv cT wceq vt cv cdom_ cfv cdm
      vu cv cdom_ cfv cdm vf cv wf vo cv vt cv cid_ cfv cfv vf cv cfv vp cv vu
      cv cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo vt cv cid_ cfv cdm
      wral vm cv vt cv cdom_ cfv cfv vt cv cid_ cfv cfv vf cv cfv vm cv vf cv
      cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv cdom_ cfv cdm
      wral vm cv vt cv ccod_ cfv cfv vt cv cid_ cfv cfv vf cv cfv vm cv vf cv
      cfv vu cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv cdom_ cfv cdm
      wral wa vn cv vt cv ccod_ cfv cfv vm cv vt cv cdom_ cfv cfv wceq vm cv vn
      cv vt cv co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_
      cfv co wceq wi vn vt cv cdom_ cfv cdm wral vm vt cv cdom_ cfv cdm wral
      w3a wa cm1 vu cv cdom_ cfv cdm vf cv wf vo cv cT cid_ cfv cfv vf cv cfv
      vp cv vu cv cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo cT cid_ cfv
      cdm wral vm cv cT cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv
      vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm
      cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_
      cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT
      ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv
      cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn cT cdom_
      cfv cdm wral vm cT cdom_ cfv cdm wral w3a wa vf vt cv cT wceq vt cv cdom_
      cfv cdm vu cv cdom_ cfv cdm vf cv wf cm1 vu cv cdom_ cfv cdm vf cv wf vo
      cv vt cv cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv
      cid_ cfv cdm wrex vo vt cv cid_ cfv cdm wral vm cv vt cv cdom_ cfv cfv vt
      cv cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_
      cfv cfv wceq vm vt cv cdom_ cfv cdm wral vm cv vt cv ccod_ cfv cfv vt cv
      cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_ cfv
      cfv wceq vm vt cv cdom_ cfv cdm wral wa vn cv vt cv ccod_ cfv cfv vm cv
      vt cv cdom_ cfv cfv wceq vm cv vn cv vt cv co_ cfv co vf cv cfv vm cv vf
      cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn vt cv cdom_ cfv cdm
      wral vm vt cv cdom_ cfv cdm wral w3a vo cv cT cid_ cfv cfv vf cv cfv vp
      cv vu cv cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo cT cid_ cfv cdm
      wral vm cv cT cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu
      cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm cv
      cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_
      cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT
      ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv
      cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn cT cdom_
      cfv cdm wral vm cT cdom_ cfv cdm wral w3a vt cv cT wceq vt cv cdom_ cfv
      cdm cm1 wceq vt cv cdom_ cfv cdm vu cv cdom_ cfv cdm vf cv wf cm1 vu cv
      cdom_ cfv cdm vf cv wf wb vt cv cT wceq vt cv cdom_ cfv cdm cT cdom_ cfv
      cdm cm1 vt cv cT wceq vt cv cdom_ cfv cT cdom_ cfv vt cv cT cdom_ fveq2
      dmeqd isfuna.2 syl6eqr vt cv cdom_ cfv cdm cm1 vu cv cdom_ cfv cdm vf cv
      feq2 syl vt cv cT wceq vo cv vt cv cid_ cfv cfv vf cv cfv vp cv vu cv
      cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo vt cv cid_ cfv cdm wral
      vo cv cT cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv
      cid_ cfv cdm wrex vo cT cid_ cfv cdm wral vm cv vt cv cdom_ cfv cfv vt cv
      cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv
      cfv wceq vm vt cv cdom_ cfv cdm wral vm cv vt cv ccod_ cfv cfv vt cv cid_
      cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_ cfv cfv
      wceq vm vt cv cdom_ cfv cdm wral wa vm cv cT cdom_ cfv cfv cT cid_ cfv
      cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq
      vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv
      vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_
      cfv cdm wral wa vn cv vt cv ccod_ cfv cfv vm cv vt cv cdom_ cfv cfv wceq
      vm cv vn cv vt cv co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu
      cv co_ cfv co wceq wi vn vt cv cdom_ cfv cdm wral vm vt cv cdom_ cfv cdm
      wral vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT
      co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co
      wceq wi vn cT cdom_ cfv cdm wral vm cT cdom_ cfv cdm wral vt cv cT wceq
      vo cv vt cv cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv
      cid_ cfv cdm wrex vo cv cT cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv
      cfv wceq vp vu cv cid_ cfv cdm wrex vo vt cv cid_ cfv cdm cT cid_ cfv cdm
      vt cv cT wceq vt cv cid_ cfv cT cid_ cfv vt cv cT cid_ fveq2 dmeqd vt cv
      cT wceq vo cv vt cv cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq
      vo cv cT cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv
      cid_ cfv cdm vt cv cT wceq vo cv vt cv cid_ cfv cfv vf cv cfv vo cv cT
      cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv vt cv cT wceq vo cv vt cv
      cid_ cfv cfv vo cv cT cid_ cfv cfv vf cv vt cv cT wceq vo cv vt cv cid_
      cfv cT cid_ cfv vt cv cT cid_ fveq2 fveq1d fveq2d eqeq1d rexbidv raleq12d
      vt cv cT wceq vm cv vt cv cdom_ cfv cfv vt cv cid_ cfv cfv vf cv cfv vm
      cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv cdom_
      cfv cdm wral vm cv cT cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv
      cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral
      vm cv vt cv ccod_ cfv cfv vt cv cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu
      cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv cdom_ cfv cdm wral vm
      cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_
      cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vt cv cT wceq vm
      cv vt cv cdom_ cfv cfv vt cv cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv
      cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm cv cT cdom_ cfv cfv cT cid_ cfv
      cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq
      vm vt cv cdom_ cfv cdm cT cdom_ cfv cdm vt cv cT wceq vt cv cdom_ cfv cT
      cdom_ cfv vt cv cT cdom_ fveq2 dmeqd vt cv cT wceq vm cv vt cv cdom_ cfv
      cfv vt cv cid_ cfv cfv vf cv cfv vm cv cT cdom_ cfv cfv cT cid_ cfv cfv
      vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv vt cv cT
      wceq vm cv vt cv cdom_ cfv cfv vt cv cid_ cfv cfv vm cv cT cdom_ cfv cfv
      cT cid_ cfv cfv vf cv vt cv cT wceq vm cv vt cv cdom_ cfv cfv vm cv cT
      cdom_ cfv cfv vt cv cid_ cfv cT cid_ cfv vt cv cT cid_ fveq2 vt cv cT
      wceq vm cv vt cv cdom_ cfv cT cdom_ cfv vt cv cT cdom_ fveq2 fveq1d
      fveq12d fveq2d eqeq1d raleq12d vt cv cT wceq vm cv vt cv ccod_ cfv cfv vt
      cv cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_
      cfv cfv wceq vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv
      cfv vu cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm vt cv cdom_ cfv cdm cT
      cdom_ cfv cdm vt cv cT wceq vt cv cdom_ cfv cT cdom_ cfv vt cv cT cdom_
      fveq2 dmeqd vt cv cT wceq vm cv vt cv ccod_ cfv cfv vt cv cid_ cfv cfv vf
      cv cfv vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv
      vu cv ccod_ cfv cfv vu cv cid_ cfv cfv vt cv cT wceq vm cv vt cv ccod_
      cfv cfv vt cv cid_ cfv cfv vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv
      vt cv cT wceq vm cv vt cv ccod_ cfv cfv vm cv cT ccod_ cfv cfv vt cv cid_
      cfv cT cid_ cfv vt cv cT cid_ fveq2 vt cv cT wceq vm cv vt cv ccod_ cfv
      cT ccod_ cfv vt cv cT ccod_ fveq2 fveq1d fveq12d fveq2d eqeq1d raleq12d
      anbi12d vt cv cT wceq vn cv vt cv ccod_ cfv cfv vm cv vt cv cdom_ cfv cfv
      wceq vm cv vn cv vt cv co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv vu cv co_ cfv co wceq wi vn vt cv cdom_ cfv cdm wral vn cv cT ccod_
      cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv cfv
      vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn cT cdom_ cfv
      cdm wral vm vt cv cdom_ cfv cdm cT cdom_ cfv cdm vt cv cT wceq vt cv
      cdom_ cfv cT cdom_ cfv vt cv cT cdom_ fveq2 dmeqd vt cv cT wceq vn cv vt
      cv ccod_ cfv cfv vm cv vt cv cdom_ cfv cfv wceq vm cv vn cv vt cv co_ cfv
      co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn
      cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co
      vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn vt
      cv cdom_ cfv cdm cT cdom_ cfv cdm vt cv cT wceq vt cv cdom_ cfv cT cdom_
      cfv vt cv cT cdom_ fveq2 dmeqd vt cv cT wceq vn cv vt cv ccod_ cfv cfv vm
      cv vt cv cdom_ cfv cfv wceq vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv
      wceq vm cv vn cv vt cv co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv vu cv co_ cfv co wceq vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf cv
      cfv vn cv vf cv cfv vu cv co_ cfv co wceq vt cv cT wceq vn cv vt cv ccod_
      cfv cfv vn cv cT ccod_ cfv cfv vm cv vt cv cdom_ cfv cfv vm cv cT cdom_
      cfv cfv vt cv cT wceq vn cv vt cv ccod_ cfv cT ccod_ cfv vt cv cT ccod_
      fveq2 fveq1d vt cv cT wceq vm cv vt cv cdom_ cfv cT cdom_ cfv vt cv cT
      cdom_ fveq2 fveq1d eqeq12d vt cv cT wceq vm cv vn cv vt cv co_ cfv co vf
      cv cfv vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv vu cv co_ cfv co vt cv cT wceq vm cv vn cv vt cv co_ cfv co vm cv vn
      cv cT co_ cfv co vf cv vt cv cT wceq vt cv co_ cfv cT co_ cfv vm cv vn cv
      vt cv cT co_ fveq2 opreqd fveq2d eqeq1d imbi12d raleq12d raleq12d
      3anbi123d anbi12d abbidv vu cv cU wceq cm1 vu cv cdom_ cfv cdm vf cv wf
      vo cv cT cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv
      cid_ cfv cdm wrex vo cT cid_ cfv cdm wral vm cv cT cdom_ cfv cfv cT cid_
      cfv cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cfv
      wceq vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vf
      cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm cT
      cdom_ cfv cdm wral wa vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq
      vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv
      co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vm cT cdom_ cfv cdm wral w3a
      wa cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2
      wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv
      ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv
      cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm
      cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co wceq
      wi vn cm1 wral vm cm1 wral w3a wa vf vu cv cU wceq cm1 vu cv cdom_ cfv
      cdm vf cv wf cm1 cm2 vf cv wf vo cv cT cid_ cfv cfv vf cv cfv vp cv vu cv
      cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo cT cid_ cfv cdm wral vm
      cv cT cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv cdom_
      cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm cv cT ccod_
      cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu
      cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT ccod_ cfv cfv
      vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf
      cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn cT cdom_ cfv cdm wral
      vm cT cdom_ cfv cdm wral w3a vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq
      vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv
      cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf
      cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv
      wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2
      co wceq wi vn cm1 wral vm cm1 wral w3a vu cv cU wceq vu cv cdom_ cfv cdm
      cm2 wceq cm1 vu cv cdom_ cfv cdm vf cv wf cm1 cm2 vf cv wf wb vu cv cU
      wceq vu cv cdom_ cfv cdm cU cdom_ cfv cdm cm2 vu cv cU wceq vu cv cdom_
      cfv cU cdom_ cfv vu cv cU cdom_ fveq2 dmeqd isfuna.8 syl6eqr vu cv cdom_
      cfv cdm cm2 cm1 vf cv feq3 syl vu cv cU wceq vo cv cT cid_ cfv cfv vf cv
      cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv cid_ cfv cdm wrex vo cT cid_
      cfv cdm wral vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo
      co1 wral vm cv cT cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv
      vu cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm
      cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_
      cfv cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vm cv cd1 cfv
      ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv
      cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1
      wral wa vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT
      co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co
      wceq wi vn cT cdom_ cfv cdm wral vm cT cdom_ cfv cdm wral vn cv cc1 cfv
      vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf
      cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral vu cv cU wceq vo cv cT
      cid_ cfv cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vp vu cv cid_ cfv
      cdm wrex vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo cT
      cid_ cfv cdm co1 vu cv cU wceq co1 cT cid_ cfv cdm co1 cT cid_ cfv cdm
      wceq vu cv cU wceq isfuna.1 a1i eqcomd vu cv cU wceq vo cv cT cid_ cfv
      cfv vf cv cfv vp cv vu cv cid_ cfv cfv wceq vo cv ci1 cfv vf cv cfv vp cv
      ci2 cfv wceq vp vu cv cid_ cfv cdm co2 vu cv cU wceq vu cv cid_ cfv cdm
      cU cid_ cfv cdm co2 vu cv cU wceq vu cv cid_ cfv cU cid_ cfv vu cv cU
      cid_ fveq2 dmeqd isfuna.7 syl6eqr vu cv cU wceq vo cv cT cid_ cfv cfv vf
      cv cfv vo cv ci1 cfv vf cv cfv vp cv vu cv cid_ cfv cfv vp cv ci2 cfv vu
      cv cU wceq vo cv cT cid_ cfv cfv vo cv ci1 cfv vf cv vu cv cU wceq vo cv
      cT cid_ cfv ci1 vu cv cU wceq ci1 cT cid_ cfv ci1 cT cid_ cfv wceq vu cv
      cU wceq isfuna.5 a1i eqcomd fveq1d fveq2d vu cv cU wceq vp cv vu cv cid_
      cfv ci2 vu cv cU wceq vu cv cid_ cfv cU cid_ cfv ci2 vu cv cU cid_ fveq2
      isfuna.11 syl6eqr fveq1d eqeq12d rexeq12d raleq12d vu cv cU wceq vm cv cT
      cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv
      cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm cv cd1 cfv ci1
      cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cT
      ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv
      cfv vu cv cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm cv cc1 cfv ci1
      cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral vu cv cU
      wceq vm cv cT cdom_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu
      cv cdom_ cfv cfv vu cv cid_ cfv cfv wceq vm cv cd1 cfv ci1 cfv vf cv cfv
      vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cT cdom_ cfv cdm cm1 vu cv cU
      wceq cm1 cT cdom_ cfv cdm cm1 cT cdom_ cfv cdm wceq vu cv cU wceq
      isfuna.2 a1i eqcomd vu cv cU wceq vm cv cT cdom_ cfv cfv cT cid_ cfv cfv
      vf cv cfv vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv vu cv cdom_ cfv
      cfv vu cv cid_ cfv cfv vm cv vf cv cfv cd2 cfv ci2 cfv vu cv cU wceq vm
      cv cT cdom_ cfv cfv cT cid_ cfv cfv vm cv cd1 cfv ci1 cfv vf cv vu cv cU
      wceq vm cv cT cdom_ cfv cfv vm cv cd1 cfv cT cid_ cfv ci1 vu cv cU wceq
      ci1 cT cid_ cfv ci1 cT cid_ cfv wceq vu cv cU wceq isfuna.5 a1i eqcomd vu
      cv cU wceq vm cv cd1 cfv vm cv cT cdom_ cfv cfv vu cv cU wceq vm cv cd1
      cT cdom_ cfv cd1 cT cdom_ cfv wceq vu cv cU wceq isfuna.3 a1i fveq1d
      eqcomd fveq12d fveq2d vu cv cU wceq vm cv vf cv cfv vu cv cdom_ cfv cfv
      vu cv cid_ cfv cfv vm cv vf cv cfv vu cv cdom_ cfv cfv cU cid_ cfv cfv vm
      cv vf cv cfv cU cdom_ cfv cfv cU cid_ cfv cfv vm cv vf cv cfv cd2 cfv ci2
      cfv vu cv cU wceq vm cv vf cv cfv vu cv cdom_ cfv cfv vu cv cid_ cfv cU
      cid_ cfv vu cv cU cid_ fveq2 fveq1d vu cv cU wceq vm cv vf cv cfv vu cv
      cdom_ cfv cfv vm cv vf cv cfv cU cdom_ cfv cfv cU cid_ cfv vu cv cU wceq
      vm cv vf cv cfv vu cv cdom_ cfv cU cdom_ cfv vu cv cU cdom_ fveq2 fveq1d
      fveq2d vu cv cU wceq vm cv vf cv cfv cU cdom_ cfv cfv vm cv vf cv cfv cd2
      cfv cU cid_ cfv ci2 vu cv cU wceq ci2 cU cid_ cfv ci2 cU cid_ cfv wceq vu
      cv cU wceq isfuna.11 a1i eqcomd vu cv cU wceq vm cv vf cv cfv cU cdom_
      cfv cd2 vu cv cU wceq cd2 cU cdom_ cfv cd2 cU cdom_ cfv wceq vu cv cU
      wceq isfuna.9 a1i eqcomd fveq1d fveq12d 3eqtrd eqeq12d raleq12d vu cv cU
      wceq vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu
      cv ccod_ cfv cfv vu cv cid_ cfv cfv wceq vm cv cc1 cfv ci1 cfv vf cv cfv
      vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cT cdom_ cfv cdm cm1 vu cv cU
      wceq vm cv cT cdom_ cfv cdm wcel vm cv cm1 wcel vm cv cT ccod_ cfv cfv cT
      cid_ cfv cfv vf cv cfv vm cv vf cv cfv vu cv ccod_ cfv cfv vu cv cid_ cfv
      cfv wceq vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv
      wceq vu cv cU wceq vm cv cm1 wcel vm cv cT cdom_ cfv cdm wcel vu cv cU
      wceq cm1 cT cdom_ cfv cdm vm cv cm1 cT cdom_ cfv cdm wceq vu cv cU wceq
      isfuna.2 a1i eleq2d bicomd vu cv cU wceq vm cv cT ccod_ cfv cfv cT cid_
      cfv cfv vf cv cfv vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv vu cv
      ccod_ cfv cfv vu cv cid_ cfv cfv vm cv vf cv cfv cc2 cfv ci2 cfv vu cv cU
      wceq vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vm cv cc1 cfv ci1 cfv vf cv
      vu cv cU wceq vm cv cT ccod_ cfv cfv vm cv cc1 cfv cT cid_ cfv ci1 vu cv
      cU wceq ci1 cT cid_ cfv ci1 cT cid_ cfv wceq vu cv cU wceq isfuna.5 a1i
      eqcomd vu cv cU wceq vm cv cT ccod_ cfv cc1 vu cv cU wceq cc1 cT ccod_
      cfv cc1 cT ccod_ cfv wceq vu cv cU wceq isfuna.4 a1i eqcomd fveq1d
      fveq12d fveq2d vu cv cU wceq vm cv vf cv cfv vu cv ccod_ cfv cfv vm cv vf
      cv cfv cc2 cfv vu cv cid_ cfv ci2 vu cv cU wceq vu cv cid_ cfv cU cid_
      cfv ci2 vu cv cU cid_ fveq2 isfuna.11 syl6eqr vu cv cU wceq vm cv vf cv
      cfv vu cv ccod_ cfv cc2 vu cv cU wceq vu cv ccod_ cfv cU ccod_ cfv cc2 vu
      cv cU ccod_ fveq2 isfuna.10 syl6eqr fveq1d fveq12d eqeq12d imbi12d
      ralbidv2 anbi12d vu cv cU wceq vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv
      cfv wceq vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv vu cv co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vn cv cc1 cfv vm cv
      cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vn cm1 wral vm cT cdom_ cfv cdm cm1 vu cv cU wceq vm
      cv cT cdom_ cfv cdm wcel vm cv cm1 wcel vn cv cT ccod_ cfv cfv vm cv cT
      cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv cfv vm cv vf cv cfv vn
      cv vf cv cfv vu cv co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vn cv cc1
      cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn
      cv vf cv cfv cro2 co wceq wi vn cm1 wral vu cv cU wceq vm cv cm1 wcel vm
      cv cT cdom_ cfv cdm wcel vm cv cm1 wcel vm cv cT cdom_ cfv cdm wcel wb vu
      cv cU wceq cm1 cT cdom_ cfv cdm vm cv isfuna.2 eleq2i a1i bicomd vu cv cU
      wceq vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT
      co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv co
      wceq wi vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm
      cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cT cdom_ cfv cdm cm1 vu
      cv cU wceq vn cv cT cdom_ cfv cdm wcel vn cv cm1 wcel vn cv cT ccod_ cfv
      cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co vf cv cfv vm cv
      vf cv cfv vn cv vf cv cfv vu cv co_ cfv co wceq wi vn cv cc1 cfv vm cv
      cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vu cv cU wceq vn cv cm1 wcel vn cv cT cdom_ cfv cdm
      wcel vu cv cU wceq cm1 cT cdom_ cfv cdm vn cv cm1 cT cdom_ cfv cdm wceq
      vu cv cU wceq isfuna.2 a1i eleq2d bicomd vu cv cU wceq vn cv cT ccod_ cfv
      cfv vm cv cT cdom_ cfv cfv wceq vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn
      cv cT co_ cfv co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv vu cv co_ cfv
      co wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv
      cro2 co wceq vu cv cU wceq vn cv cT ccod_ cfv cfv vn cv cc1 cfv vm cv cT
      cdom_ cfv cfv vm cv cd1 cfv vu cv cU wceq vn cv cc1 cfv vn cv cT ccod_
      cfv cfv vu cv cU wceq vn cv cc1 cT ccod_ cfv cc1 cT ccod_ cfv wceq vu cv
      cU wceq isfuna.4 a1i fveq1d eqcomd vu cv cU wceq vm cv cd1 cfv vm cv cT
      cdom_ cfv cfv vu cv cU wceq vm cv cd1 cT cdom_ cfv cd1 cT cdom_ cfv wceq
      vu cv cU wceq isfuna.3 a1i fveq1d eqcomd eqeq12d vu cv cU wceq vm cv vn
      cv cT co_ cfv co vf cv cfv vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv
      vn cv vf cv cfv vu cv co_ cfv co vm cv vf cv cfv vn cv vf cv cfv cro2 co
      vu cv cU wceq vm cv vn cv cT co_ cfv co vm cv vn cv cro1 co vf cv vu cv
      cU wceq cT co_ cfv cro1 vm cv vn cv vu cv cU wceq cro1 cT co_ cfv cro1 cT
      co_ cfv wceq vu cv cU wceq isfuna.6 a1i eqcomd opreqd fveq2d vu cv cU
      wceq vu cv co_ cfv cro2 vm cv vf cv cfv vn cv vf cv cfv vu cv cU wceq vu
      cv co_ cfv cU co_ cfv cro2 vu cv cU co_ fveq2 isfuna.12 syl6eqr opreqd
      eqeq12d imbi12d imbi12d ralbidv2 imbi12d ralbidv2 3anbi123d anbi12d
      abbidv vv vu vt vf vm vn vo vp df-func oprabval2g cT cU cfunc df-opr
      syl5eqr mpd3an3 $.
      $( [11-Feb-2008] $) $( [10-Feb-2008] $)
  $}


  ${ $d C1 f $.  $d C2 f $.  $d D1 f $.  $d D2 f $.  $d F f m n o p $.
    $d I1 f $.  $d I2 f $.  $d M1 f m $.  $d M2 f $.  $d O1 f o $.
    $d O2 f p $.  $d Ro1 f $.  $d Ro2 f $.  $d T f m n o p $.
    $d U f m n o p $.
    isfunb.1 $e |- O1 = dom ( id_ ` T ) $.
    isfunb.2 $e |- M1 = dom ( dom_ ` T ) $.
    isfunb.3 $e |- D1 = ( dom_ ` T ) $.
    isfunb.4 $e |- C1 = ( cod_ ` T ) $.
    isfunb.5 $e |- I1 = ( id_ ` T ) $.
    isfunb.6 $e |- Ro1 = ( o_ ` T ) $.
    isfunb.7 $e |- O2 = dom ( id_ ` U ) $.
    isfunb.8 $e |- M2 = dom ( dom_ ` U ) $.
    isfunb.9 $e |- D2 = ( dom_ ` U ) $.
    isfunb.10 $e |- C2 = ( cod_ ` U ) $.
    isfunb.11 $e |- I2 = ( id_ ` U ) $.
    isfunb.12 $e |- Ro2 = ( o_ ` U ) $.
    $( The predicate "is a functor" . $)
    isfunb $p |- ( ( T e. Cat /\ U e. Cat /\ F e. A ) ->
       ( F e. ( Func ` <. T , U >. ) <->
       ( F : M1 --> M2 /\ ( A. o e. O1
        E. p e. O2 ( F ` ( I1 ` o ) ) = ( I2 ` p ) /\
      ( A. m e. M1
       ( F ` ( I1  ` ( D1 ` m ) ) ) =
          ( I2 ` ( D2 ` ( F ` m ) ) ) /\
      A. m e. M1
       ( F ` ( I1 ` ( C1 ` m ) ) ) =
          ( I2 ` ( C2 ` ( F ` m ) ) ) ) /\
      A. m e. M1 A. n e. M1
       ( ( C1 ` n ) = ( D1 ` m ) ->
         ( F ` ( m Ro1 n ) ) =
          ( ( F ` m ) Ro2 ( F ` n ) ) ) ) ) ) ) $=
      cT ccat wcel cU ccat wcel cF cA wcel w3a cF cT cU cop cfunc cfv wcel cF
      cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex
      vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2
      cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2
      cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn
      cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn
      cm1 wral vm cm1 wral w3a wa vf cab wcel cm1 cm2 cF wf vo cv ci1 cfv cF
      cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv cF
      cfv vm cv cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv
      cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm
      cv cd1 cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2
      co wceq wi vn cm1 wral vm cm1 wral w3a wa cT ccat wcel cU ccat wcel cF cA
      wcel w3a cT cU cop cfunc cfv cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp
      cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv
      vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf
      cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv
      vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf
      cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab cF cT ccat
      wcel cU ccat wcel cT cU cop cfunc cfv cm1 cm2 vf cv wf vo cv ci1 cfv vf
      cv cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv
      vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv
      ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn
      cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv
      cfv vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab
      wceq cF cA wcel cT cU vf vm vn vo vp co1 cm1 co2 cm2 ci1 cd1 cc1 cro1 ci2
      cd2 cc2 cro2 isfunb.1 isfunb.2 isfunb.3 isfunb.4 isfunb.5 isfunb.6
      isfunb.7 isfunb.8 isfunb.9 isfunb.10 isfunb.11 isfunb.12 isfuna 3adant3
      eleq2d cF cA wcel cT ccat wcel cF cm1 cm2 vf cv wf vo cv ci1 cfv vf cv
      cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf
      cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1
      cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv
      cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv
      vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cab
      wcel cm1 cm2 cF wf vo cv ci1 cfv cF cfv vp cv ci2 cfv wceq vp co2 wrex vo
      co1 wral vm cv cd1 cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv wceq
      vm cm1 wral vm cv cc1 cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv
      wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co
      cF cfv vm cv cF cfv vn cv cF cfv cro2 co wceq wi vn cm1 wral vm cm1 wral
      w3a wa wb cU ccat wcel cm1 cm2 vf cv wf vo cv ci1 cfv vf cv cfv vp cv ci2
      cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf
      cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv
      vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv
      cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv
      cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa cm1 cm2 cF wf vo cv
      ci1 cfv cF cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv
      ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1
      cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv
      cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv
      cF cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa vf cF cA vf cv cF
      wceq cm1 cm2 vf cv wf cm1 cm2 cF wf vo cv ci1 cfv vf cv cfv vp cv ci2 cfv
      wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv
      cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv vf cv cfv vm
      cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1
      cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv
      cro2 co wceq wi vn cm1 wral vm cm1 wral w3a vo cv ci1 cfv cF cfv vp cv
      ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv cF cfv vm cv
      cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv cF cfv vm
      cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv
      wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2 co wceq wi
      vn cm1 wral vm cm1 wral w3a cm1 cm2 vf cv cF feq1 vf cv cF wceq vo cv ci1
      cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vo cv ci1 cfv cF
      cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cd1 cfv ci1 cfv vf
      cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1
      cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vm cv
      cd1 cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm
      cv cc1 cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral
      wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv
      vf cv cfv vn cv vf cv cfv cro2 co wceq wi vn cm1 wral vm cm1 wral vn cv
      cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv
      cF cfv cro2 co wceq wi vn cm1 wral vm cm1 wral vf cv cF wceq vo cv ci1
      cfv vf cv cfv vp cv ci2 cfv wceq vp co2 wrex vo cv ci1 cfv cF cfv vp cv
      ci2 cfv wceq vp co2 wrex vo co1 vf cv cF wceq vo cv ci1 cfv vf cv cfv vp
      cv ci2 cfv wceq vo cv ci1 cfv cF cfv vp cv ci2 cfv wceq vp co2 vf cv cF
      wceq vo cv ci1 cfv vf cv cfv vo cv ci1 cfv cF cfv vp cv ci2 cfv vo cv ci1
      cfv vf cv cF fveq1 eqeq1d rexbidv ralbidv vf cv cF wceq vm cv cd1 cfv ci1
      cfv vf cv cfv vm cv vf cv cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cd1
      cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv
      cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq vm cm1
      wral vm cv cc1 cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm
      cm1 wral vf cv cF wceq vm cv cd1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv
      cd2 cfv ci2 cfv wceq vm cv cd1 cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv
      ci2 cfv wceq vm cm1 vf cv cF wceq vm cv cd1 cfv ci1 cfv vf cv cfv vm cv
      cd1 cfv ci1 cfv cF cfv vm cv vf cv cfv cd2 cfv ci2 cfv vm cv cF cfv cd2
      cfv ci2 cfv vm cv cd1 cfv ci1 cfv vf cv cF fveq1 vf cv cF wceq vm cv vf
      cv cfv cd2 cfv vm cv cF cfv cd2 cfv ci2 vf cv cF wceq vm cv vf cv cfv vm
      cv cF cfv cd2 vm cv vf cv cF fveq1 fveq2d fveq2d eqeq12d ralbidv vf cv cF
      wceq vm cv cc1 cfv ci1 cfv vf cv cfv vm cv vf cv cfv cc2 cfv ci2 cfv wceq
      vm cv cc1 cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 vf
      cv cF wceq vm cv cc1 cfv ci1 cfv vf cv cfv vm cv cc1 cfv ci1 cfv cF cfv
      vm cv vf cv cfv cc2 cfv ci2 cfv vm cv cF cfv cc2 cfv ci2 cfv vm cv cc1
      cfv ci1 cfv vf cv cF fveq1 vf cv cF wceq vm cv vf cv cfv cc2 cfv vm cv cF
      cfv cc2 cfv ci2 vf cv cF wceq vm cv vf cv cfv vm cv cF cfv cc2 vm cv vf
      cv cF fveq1 fveq2d fveq2d eqeq12d ralbidv anbi12d vf cv cF wceq vn cv cc1
      cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn
      cv vf cv cfv cro2 co wceq wi vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv
      cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2 co wceq wi vm vn cm1 cm1 vf
      cv cF wceq vm cv vn cv cro1 co vf cv cfv vm cv vf cv cfv vn cv vf cv cfv
      cro2 co wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2 co
      wceq vn cv cc1 cfv vm cv cd1 cfv wceq vf cv cF wceq vm cv vn cv cro1 co
      vf cv cfv vm cv vn cv cro1 co cF cfv vm cv vf cv cfv vn cv vf cv cfv cro2
      co vm cv cF cfv vn cv cF cfv cro2 co vm cv vn cv cro1 co vf cv cF fveq1
      vf cv cF wceq vm cv vf cv cfv vm cv cF cfv vn cv vf cv cfv vn cv cF cfv
      cro2 vm cv vf cv cF fveq1 vn cv vf cv cF fveq1 opreq12d eqeq12d imbi2d
      2ralbidv 3anbi123d anbi12d elabg 3ad2ant3 bitrd $.
      $( [11-Feb-2008] $) $( [10-Feb-2008] $)
  $}

  ${ $d F w x y z $.  $d M1 x $.  $d T w x y z $.  $d U w x y z $.
    fmamo.1 $e |- M1 = dom ( dom_ ` T ) $.
    fmamo.2 $e |- M2 = dom ( dom_ ` U ) $.
    $( A functor is a mapping between morphisms. $)
    fmamo $p |- ( ( T e. Cat /\ U e. Cat ) ->
      ( F e. ( Func ` <. T , U >. ) -> F : M1 --> M2 ) ) $=
      cT ccat wcel cU ccat wcel wa cF cT cU cop cfunc cfv wcel cm1 cm2 cF wf cT
      ccat wcel cU ccat wcel cF cT cU cop cfunc cfv wcel cF cT cU cop cfunc cfv
      wcel cm1 cm2 cF wf wi cT ccat wcel cU ccat wcel cF cT cU cop cfunc cfv
      wcel w3a cF cT cU cop cfunc cfv wcel cm1 cm2 cF wf cT ccat wcel cU ccat
      wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel cm1 cm2
      cF wf vz cv cT cid_ cfv cfv cF cfv vw cv cU cid_ cfv cfv wceq vw cU cid_
      cfv cdm wrex vz cT cid_ cfv cdm wral vx cv cT cdom_ cfv cfv cT cid_ cfv
      cfv cF cfv vx cv cF cfv cU cdom_ cfv cfv cU cid_ cfv cfv wceq vx cm1 wral
      vx cv cT ccod_ cfv cfv cT cid_ cfv cfv cF cfv vx cv cF cfv cU ccod_ cfv
      cfv cU cid_ cfv cfv wceq vx cm1 wral wa vy cv cT ccod_ cfv cfv vx cv cT
      cdom_ cfv cfv wceq vx cv vy cv cT co_ cfv co cF cfv vx cv cF cfv vy cv cF
      cfv cU co_ cfv co wceq wi vy cm1 wral vx cm1 wral w3a cT cU cop cfunc cfv
      cT cU vx vy vz cF vw cT cid_ cfv cdm cm1 cU cid_ cfv cdm cm2 cT cid_ cfv
      cT cdom_ cfv cT ccod_ cfv cT co_ cfv cU cid_ cfv cU cdom_ cfv cU ccod_
      cfv cU co_ cfv cT cid_ cfv cdm eqid fmamo.1 cT cdom_ cfv eqid cT ccod_
      cfv eqid cT cid_ cfv eqid cT co_ cfv eqid cU cid_ cfv cdm eqid fmamo.2 cU
      cdom_ cfv eqid cU ccod_ cfv eqid cU cid_ cfv eqid cU co_ cfv eqid isfunb
      pm3.26bda ex 3expia pm2.43d $.
      $( [11-Feb-2008] $) $( [10-Feb-2008] $)
  $}

  ${ $d F m n o p $.  $d O1 o $.  $d O2 p $.  $d T m n o p $.  $d U m n o p $.
    vidfunid.1 $e |- O1 = dom ( id_ ` T ) $.
    vidfunid.2 $e |- I1 = ( id_ ` T ) $.
    vidfunid.3 $e |- O2 = dom ( id_ ` U ) $.
    vidfunid.4 $e |- I2 = ( id_ ` U ) $.
    $( The functor ` F ` associates every object of ` T ` to an object
       in ` U ` . For the identification of objects with the identities
       see ~ df-func . JFM CAT_1 th. 97. $)
    vidfunid $p |- ( ( T e. Cat /\ U e. Cat ) ->
       ( F e. ( Func ` <. T , U >. ) ->
         A. o e. O1
        E. p e. O2 ( F ` ( I1 ` o ) ) = ( I2 ` p ) ) ) $=
      cT ccat wcel cU ccat wcel wa cF cT cU cop cfunc cfv wcel vo cv ci1 cfv cF
      cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral cT ccat wcel cU ccat wcel
      cF cT cU cop cfunc cfv wcel cF cT cU cop cfunc cfv wcel vo cv ci1 cfv cF
      cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral wi cT ccat wcel cU ccat
      wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel vo cv
      ci1 cfv cF cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral cT ccat wcel cU
      ccat wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel wa
      vo cv ci1 cfv cF cfv vp cv ci2 cfv wceq vp co2 wrex vo co1 wral vm cv cT
      cdom_ cfv cfv ci1 cfv cF cfv vm cv cF cfv cU cdom_ cfv cfv ci2 cfv wceq
      vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv ci1 cfv cF cfv vm cv cF
      cfv cU ccod_ cfv cfv ci2 cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT
      ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cF
      cfv vm cv cF cfv vn cv cF cfv cU co_ cfv co wceq wi vn cT cdom_ cfv cdm
      wral vm cT cdom_ cfv cdm wral cT ccat wcel cU ccat wcel cF cT cU cop
      cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel cT cdom_ cfv cdm cU cdom_
      cfv cdm cF wf vo cv ci1 cfv cF cfv vp cv ci2 cfv wceq vp co2 wrex vo co1
      wral vm cv cT cdom_ cfv cfv ci1 cfv cF cfv vm cv cF cfv cU cdom_ cfv cfv
      ci2 cfv wceq vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv ci1 cfv cF
      cfv vm cv cF cfv cU ccod_ cfv cfv ci2 cfv wceq vm cT cdom_ cfv cdm wral
      wa vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_
      cfv co cF cfv vm cv cF cfv vn cv cF cfv cU co_ cfv co wceq wi vn cT cdom_
      cfv cdm wral vm cT cdom_ cfv cdm wral w3a cT cU cop cfunc cfv cT cU vm vn
      vo cF vp co1 cT cdom_ cfv cdm co2 cU cdom_ cfv cdm ci1 cT cdom_ cfv cT
      ccod_ cfv cT co_ cfv ci2 cU cdom_ cfv cU ccod_ cfv cU co_ cfv vidfunid.1
      cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid vidfunid.2 cT
      co_ cfv eqid vidfunid.3 cU cdom_ cfv cdm eqid cU cdom_ cfv eqid cU ccod_
      cfv eqid vidfunid.4 cU co_ cfv eqid isfunb pm3.27bda 3simp1d ex 3expia
      pm2.43d $.
      $( [11-Feb-2008] $) $( [10-Feb-2008] $)
  $}

  ${ $d F a b m n $.  $d M1 m $.  $d T a b m n $.  $d U a b m n $.
    iddvvidd.1 $e |- M1 = dom ( dom_ ` T ) $.
    iddvvidd.2 $e |- D1 = ( dom_ ` T ) $.
    iddvvidd.3 $e |- I1 = ( id_ ` T ) $.
    iddvvidd.4 $e |- I2 = ( id_ ` U ) $.
    iddvvidd.5 $e |- D2 = ( dom_ ` U ) $.
    $( Functors preserve domains.  JFM CAT_1 th. 98. $)
    iddvvidd $p |- ( ( T e. Cat /\ U e. Cat ) ->
      ( F e. ( Func ` <. T , U >. ) ->
         A. m e. M1 ( F ` ( I1  ` ( D1 ` m ) ) ) =
           ( I2 ` ( D2 ` ( F ` m ) ) ) ) ) $=
      cT ccat wcel cU ccat wcel wa cF cT cU cop cfunc cfv wcel vm cv cd1 cfv
      ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral cT ccat wcel
      cU ccat wcel cF cT cU cop cfunc cfv wcel cF cT cU cop cfunc cfv wcel vm
      cv cd1 cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv wceq vm cm1 wral
      wi cT ccat wcel cU ccat wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop
      cfunc cfv wcel vm cv cd1 cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2 cfv
      wceq vm cm1 wral cT ccat wcel cU ccat wcel cF cT cU cop cfunc cfv wcel
      w3a cF cT cU cop cfunc cfv wcel wa vm cv cd1 cfv ci1 cfv cF cfv vm cv cF
      cfv cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cT ccod_ cfv cfv ci1 cfv cF
      cfv vm cv cF cfv cU ccod_ cfv cfv ci2 cfv wceq vm cm1 wral cT ccat wcel
      cU ccat wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel
      wa va cv ci1 cfv cF cfv vb cv ci2 cfv wceq vb cU cid_ cfv cdm wrex va cT
      cid_ cfv cdm wral vm cv cd1 cfv ci1 cfv cF cfv vm cv cF cfv cd2 cfv ci2
      cfv wceq vm cm1 wral vm cv cT ccod_ cfv cfv ci1 cfv cF cfv vm cv cF cfv
      cU ccod_ cfv cfv ci2 cfv wceq vm cm1 wral wa vn cv cT ccod_ cfv cfv vm cv
      cd1 cfv wceq vm cv vn cv cT co_ cfv co cF cfv vm cv cF cfv vn cv cF cfv
      cU co_ cfv co wceq wi vn cm1 wral vm cm1 wral cT ccat wcel cU ccat wcel
      cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel cm1 cU cdom_
      cfv cdm cF wf va cv ci1 cfv cF cfv vb cv ci2 cfv wceq vb cU cid_ cfv cdm
      wrex va cT cid_ cfv cdm wral vm cv cd1 cfv ci1 cfv cF cfv vm cv cF cfv
      cd2 cfv ci2 cfv wceq vm cm1 wral vm cv cT ccod_ cfv cfv ci1 cfv cF cfv vm
      cv cF cfv cU ccod_ cfv cfv ci2 cfv wceq vm cm1 wral wa vn cv cT ccod_ cfv
      cfv vm cv cd1 cfv wceq vm cv vn cv cT co_ cfv co cF cfv vm cv cF cfv vn
      cv cF cfv cU co_ cfv co wceq wi vn cm1 wral vm cm1 wral w3a cT cU cop
      cfunc cfv cT cU vm vn va cF vb cT cid_ cfv cdm cm1 cU cid_ cfv cdm cU
      cdom_ cfv cdm ci1 cd1 cT ccod_ cfv cT co_ cfv ci2 cd2 cU ccod_ cfv cU co_
      cfv cT cid_ cfv cdm eqid iddvvidd.1 iddvvidd.2 cT ccod_ cfv eqid
      iddvvidd.3 cT co_ cfv eqid cU cid_ cfv cdm eqid cU cdom_ cfv cdm eqid
      iddvvidd.5 cU ccod_ cfv eqid iddvvidd.4 cU co_ cfv eqid isfunb pm3.27bda
      3simp2d pm3.26d ex 3expia pm2.43d $.
      $( [1-Jun-2008] $) $( [5-May-2008] $)
  $}

  ${ $d F a b m n $.  $d M1 m $.  $d T a b m n $.  $d U a b m n $.
    idcvvidc.1 $e |- M1 = dom ( dom_ ` T ) $.
    idcvvidc.2 $e |- C1 = ( cod_ ` T ) $.
    idcvvidc.3 $e |- I1 = ( id_ ` T ) $.
    idcvvidc.4 $e |- I2 = ( id_ ` U ) $.
    idcvvidc.5 $e |- C2 = ( cod_ ` U ) $.
    $( Functors preserve codomains.  JFM CAT_1 th. 98. $)
    idcvvidc $p |- ( ( T e. Cat /\ U e. Cat ) ->
      ( F e. ( Func ` <. T , U >. ) ->
         A. m e. M1 ( F ` ( I1  ` ( C1 ` m ) ) ) =
           ( I2 ` ( C2 ` ( F ` m ) ) ) ) ) $=
      cT ccat wcel cU ccat wcel wa cF cT cU cop cfunc cfv wcel vm cv cc1 cfv
      ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral cT ccat wcel
      cU ccat wcel cF cT cU cop cfunc cfv wcel cF cT cU cop cfunc cfv wcel vm
      cv cc1 cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral
      wi cT ccat wcel cU ccat wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop
      cfunc cfv wcel vm cv cc1 cfv ci1 cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv
      wceq vm cm1 wral cT ccat wcel cU ccat wcel cF cT cU cop cfunc cfv wcel
      w3a cF cT cU cop cfunc cfv wcel wa vm cv cT cdom_ cfv cfv ci1 cfv cF cfv
      vm cv cF cfv cU cdom_ cfv cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1
      cfv cF cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral cT ccat wcel cU
      ccat wcel cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel wa
      va cv ci1 cfv cF cfv vb cv ci2 cfv wceq vb cU cid_ cfv cdm wrex va cT
      cid_ cfv cdm wral vm cv cT cdom_ cfv cfv ci1 cfv cF cfv vm cv cF cfv cU
      cdom_ cfv cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv cF cfv vm cv
      cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cT cdom_
      cfv cfv wceq vm cv vn cv cT co_ cfv co cF cfv vm cv cF cfv vn cv cF cfv
      cU co_ cfv co wceq wi vn cm1 wral vm cm1 wral cT ccat wcel cU ccat wcel
      cF cT cU cop cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel cm1 cU cdom_
      cfv cdm cF wf va cv ci1 cfv cF cfv vb cv ci2 cfv wceq vb cU cid_ cfv cdm
      wrex va cT cid_ cfv cdm wral vm cv cT cdom_ cfv cfv ci1 cfv cF cfv vm cv
      cF cfv cU cdom_ cfv cfv ci2 cfv wceq vm cm1 wral vm cv cc1 cfv ci1 cfv cF
      cfv vm cv cF cfv cc2 cfv ci2 cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv
      cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cF cfv vm cv cF cfv vn cv
      cF cfv cU co_ cfv co wceq wi vn cm1 wral vm cm1 wral w3a cT cU cop cfunc
      cfv cT cU vm vn va cF vb cT cid_ cfv cdm cm1 cU cid_ cfv cdm cU cdom_ cfv
      cdm ci1 cT cdom_ cfv cc1 cT co_ cfv ci2 cU cdom_ cfv cc2 cU co_ cfv cT
      cid_ cfv cdm eqid idcvvidc.1 cT cdom_ cfv eqid idcvvidc.2 idcvvidc.3 cT
      co_ cfv eqid cU cid_ cfv cdm eqid cU cdom_ cfv cdm eqid cU cdom_ cfv eqid
      idcvvidc.5 idcvvidc.4 cU co_ cfv eqid isfunb pm3.27bda 3simp2d pm3.27d ex
      3expia pm2.43d $.
      $( [1-Jun-2008] $) $( [5-May-2008] $)
  $}

  ${ $d F m n x y $. $d M1 m $. $d T m n x y $. $d U m n x y $.
    fmp.1 $e |- M1 = dom ( dom_ ` T ) $.
    fmp.2 $e |- C1 = ( cod_ ` T ) $.
    fmp.3 $e |- D1 = ( dom_ ` T ) $.
    fmp.6 $e |- Ro1 = ( o_ ` T ) $.
    fmp.7 $e |- Ro2 = ( o_ ` U ) $.
    $( Functors preserve morphisms composition.  JFM CAT_1 th. 99. $)
    fmp $p |- ( ( T e. Cat /\ U e. Cat ) ->
      ( F e. ( Func ` <. T , U >. ) ->
         A. m e. M1 A. n e. M1 ( ( C1 ` n ) = ( D1 ` m )
            -> ( F ` ( m Ro1 n  ) ) = ( ( F ` m ) Ro2 ( F ` n ) ) ) ) ) $=
      cT ccat wcel cU ccat wcel wa cF cT cU cop cfunc cfv wcel vn cv cc1 cfv vm
      cv cd1 cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2
      co wceq wi vn cm1 wral vm cm1 wral cT ccat wcel cU ccat wcel wa cF cT cU
      cop cfunc cfv wcel wa vx cv cT cid_ cfv cfv cF cfv vy cv cU cid_ cfv cfv
      wceq vy cU cid_ cfv cdm wrex vx cT cid_ cfv cdm wral vm cv cd1 cfv cT
      cid_ cfv cfv cF cfv vm cv cF cfv cU cdom_ cfv cfv cU cid_ cfv cfv wceq vm
      cm1 wral vm cv cc1 cfv cT cid_ cfv cfv cF cfv vm cv cF cfv cU ccod_ cfv
      cfv cU cid_ cfv cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq
      vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2 co wceq wi vn
      cm1 wral vm cm1 wral cT ccat wcel cU ccat wcel wa cF cT cU cop cfunc cfv
      wcel wa cm1 cU cdom_ cfv cdm cF wf vx cv cT cid_ cfv cfv cF cfv vy cv cU
      cid_ cfv cfv wceq vy cU cid_ cfv cdm wrex vx cT cid_ cfv cdm wral vm cv
      cd1 cfv cT cid_ cfv cfv cF cfv vm cv cF cfv cU cdom_ cfv cfv cU cid_ cfv
      cfv wceq vm cm1 wral vm cv cc1 cfv cT cid_ cfv cfv cF cfv vm cv cF cfv cU
      ccod_ cfv cfv cU cid_ cfv cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1
      cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2 co
      wceq wi vn cm1 wral vm cm1 wral w3a cT ccat wcel cU ccat wcel wa cF cT cU
      cop cfunc cfv wcel cm1 cU cdom_ cfv cdm cF wf vx cv cT cid_ cfv cfv cF
      cfv vy cv cU cid_ cfv cfv wceq vy cU cid_ cfv cdm wrex vx cT cid_ cfv cdm
      wral vm cv cd1 cfv cT cid_ cfv cfv cF cfv vm cv cF cfv cU cdom_ cfv cfv
      cU cid_ cfv cfv wceq vm cm1 wral vm cv cc1 cfv cT cid_ cfv cfv cF cfv vm
      cv cF cfv cU ccod_ cfv cfv cU cid_ cfv cfv wceq vm cm1 wral wa vn cv cc1
      cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF
      cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa cT ccat wcel cU ccat
      wcel wa cF cT cU cop cfunc cfv wcel cm1 cU cdom_ cfv cdm cF wf vx cv cT
      cid_ cfv cfv cF cfv vy cv cU cid_ cfv cfv wceq vy cU cid_ cfv cdm wrex vx
      cT cid_ cfv cdm wral vm cv cd1 cfv cT cid_ cfv cfv cF cfv vm cv cF cfv cU
      cdom_ cfv cfv cU cid_ cfv cfv wceq vm cm1 wral vm cv cc1 cfv cT cid_ cfv
      cfv cF cfv vm cv cF cfv cU ccod_ cfv cfv cU cid_ cfv cfv wceq vm cm1 wral
      wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co cF cfv vm cv cF
      cfv vn cv cF cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a wa cT ccat
      wcel cU ccat wcel cF cT cU cop cfunc cfv wcel cF cT cU cop cfunc cfv wcel
      cm1 cU cdom_ cfv cdm cF wf vx cv cT cid_ cfv cfv cF cfv vy cv cU cid_ cfv
      cfv wceq vy cU cid_ cfv cdm wrex vx cT cid_ cfv cdm wral vm cv cd1 cfv cT
      cid_ cfv cfv cF cfv vm cv cF cfv cU cdom_ cfv cfv cU cid_ cfv cfv wceq vm
      cm1 wral vm cv cc1 cfv cT cid_ cfv cfv cF cfv vm cv cF cfv cU ccod_ cfv
      cfv cU cid_ cfv cfv wceq vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq
      vm cv vn cv cro1 co cF cfv vm cv cF cfv vn cv cF cfv cro2 co wceq wi vn
      cm1 wral vm cm1 wral w3a wa wi cT ccat wcel cU ccat wcel cF cT cU cop
      cfunc cfv wcel w3a cF cT cU cop cfunc cfv wcel cm1 cU cdom_ cfv cdm cF wf
      vx cv cT cid_ cfv cfv cF cfv vy cv cU cid_ cfv cfv wceq vy cU cid_ cfv
      cdm wrex vx cT cid_ cfv cdm wral vm cv cd1 cfv cT cid_ cfv cfv cF cfv vm
      cv cF cfv cU cdom_ cfv cfv cU cid_ cfv cfv wceq vm cm1 wral vm cv cc1 cfv
      cT cid_ cfv cfv cF cfv vm cv cF cfv cU ccod_ cfv cfv cU cid_ cfv cfv wceq
      vm cm1 wral wa vn cv cc1 cfv vm cv cd1 cfv wceq vm cv vn cv cro1 co cF
      cfv vm cv cF cfv vn cv cF cfv cro2 co wceq wi vn cm1 wral vm cm1 wral w3a
      wa cT cU cop cfunc cfv cT cU vm vn vx cF vy cT cid_ cfv cdm cm1 cU cid_
      cfv cdm cU cdom_ cfv cdm cT cid_ cfv cd1 cc1 cro1 cU cid_ cfv cU cdom_
      cfv cU ccod_ cfv cro2 cT cid_ cfv cdm eqid fmp.1 fmp.3 fmp.2 cT cid_ cfv
      eqid fmp.6 cU cid_ cfv cdm eqid cU cdom_ cfv cdm eqid cU cdom_ cfv eqid
      cU ccod_ cfv eqid cU cid_ cfv eqid fmp.7 isfunb biimpd 3expia pm2.43d imp
      pm3.27d 3simp3d ex $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${ $d T a b m n $.
    $( The identity functor is a functor. $)
    idfisf $p |- ( T e. Cat ->
      ( _I |` dom ( dom_ ` T ) ) e. ( Func ` <. T , T >. ) ) $=
      cT ccat wcel cid cT cdom_ cfv cdm cres cT cT cop cfunc cfv wcel cT ccat
      wcel cT ccat wcel cid cT cdom_ cfv cdm cres cvv wcel cid cT cdom_ cfv cdm
      cres cT cT cop cfunc cfv wcel cT cdom_ cfv cdm cvv wcel cid cT cdom_ cfv
      cdm cres cvv wcel cT cdom_ cfv cT cdom_ fvex dmex cT cdom_ cfv cdm cvv
      resiexg ax-mp cT ccat wcel cT ccat wcel cid cT cdom_ cfv cdm cres cvv
      wcel cid cT cdom_ cfv cdm cres cT cT cop cfunc cfv wcel cT ccat wcel cT
      ccat wcel cid cT cdom_ cfv cdm cres cvv wcel w3a cid cT cdom_ cfv cdm
      cres cT cT cop cfunc cfv wcel cT cdom_ cfv cdm cT cdom_ cfv cdm cid cT
      cdom_ cfv cdm cres wf va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv
      vb cv cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex va cT cid_ cfv cdm
      wral vm cv cT cdom_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv
      vm cv cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq
      vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT
      cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv
      cfv cT cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT ccod_ cfv
      cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cid cT cdom_
      cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_
      cfv cdm cres cfv cT co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vm cT
      cdom_ cfv cdm wral w3a wa cT ccat wcel cT ccat wcel cT cdom_ cfv cdm cT
      cdom_ cfv cdm cid cT cdom_ cfv cdm cres wf va cv cT cid_ cfv cfv cid cT
      cdom_ cfv cdm cres cfv vb cv cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex
      va cT cid_ cfv cdm wral vm cv cT cdom_ cfv cfv cT cid_ cfv cfv cid cT
      cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv
      cfv cT cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv
      cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm
      cres cfv cT ccod_ cfv cfv cT cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral
      wa vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_
      cfv co cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv
      vn cv cid cT cdom_ cfv cdm cres cfv cT co_ cfv co wceq wi vn cT cdom_ cfv
      cdm wral vm cT cdom_ cfv cdm wral w3a wa cid cT cdom_ cfv cdm cres cvv
      wcel cT ccat wcel va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vb
      cv cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex va cT cid_ cfv cdm wral
      vm cv cT cdom_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm
      cv cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm
      cT cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT cdom_
      cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv cfv cT
      cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT ccod_ cfv cfv vm
      cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cid cT cdom_ cfv cdm
      cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_ cfv cdm
      cres cfv cT co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vm cT cdom_ cfv
      cdm wral w3a cT cdom_ cfv cdm cT cdom_ cfv cdm cid cT cdom_ cfv cdm cres
      wf cT ccat wcel va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vb cv
      cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex va cT cid_ cfv cdm wral vm
      cv cT cdom_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv
      cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cT
      cdom_ cfv cdm wral vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT cdom_
      cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv cfv cT
      cid_ cfv cfv wceq vm cT cdom_ cfv cdm wral wa vn cv cT ccod_ cfv cfv vm
      cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cid cT cdom_ cfv cdm
      cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_ cfv cdm
      cres cfv cT co_ cfv co wceq wi vn cT cdom_ cfv cdm wral vm cT cdom_ cfv
      cdm wral cT ccat wcel va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv
      vb cv cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex va cT cid_ cfv cdm cT
      ccat wcel va cv cT cid_ cfv cdm wcel va cv cT cid_ cfv cfv cid cT cdom_
      cfv cdm cres cfv vb cv cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex cT
      ccat wcel va cv cT cid_ cfv cdm wcel wa va cv cT cid_ cfv cfv cid cT
      cdom_ cfv cdm cres cfv va cv cT cid_ cfv cfv wceq va cv cT cid_ cfv cfv
      cid cT cdom_ cfv cdm cres cfv vb cv cT cid_ cfv cfv wceq vb cT cid_ cfv
      cdm wrex cT ccat wcel va cv cT cid_ cfv cdm wcel wa va cv cT cid_ cfv cfv
      cT cdom_ cfv cdm wcel va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv
      va cv cT cid_ cfv cfv wceq va cv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_
      cfv cdm cT cdom_ cfv cdm eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid jdmo
      cT cdom_ cfv cdm va cv cT cid_ cfv cfv fvresi syl va cv cT cid_ cfv cdm
      wcel va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv va cv cT cid_
      cfv cfv wceq va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vb cv cT
      cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex wi cT ccat wcel va cv cT cid_
      cfv cdm wcel va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv va cv cT
      cid_ cfv cfv wceq va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vb
      cv cT cid_ cfv cfv wceq vb cT cid_ cfv cdm wrex va cv cT cid_ cfv cfv cid
      cT cdom_ cfv cdm cres cfv vb cv cT cid_ cfv cfv wceq va cv cT cid_ cfv
      cfv cid cT cdom_ cfv cdm cres cfv va cv cT cid_ cfv cfv wceq vb va cv cT
      cid_ cfv cdm vb cv va cv wceq vb cv cT cid_ cfv cfv va cv cT cid_ cfv cfv
      va cv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vb cv va cv cT cid_
      cfv fveq2 eqeq2d rcla4ev ex adantl mpd ex r19.21aiv cT ccat wcel vm cv cT
      cdom_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv cid cT
      cdom_ cfv cdm cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cT cdom_
      cfv cdm wral vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm
      cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv cfv cT cid_ cfv
      cfv wceq vm cT cdom_ cfv cdm wral cT ccat wcel vm cv cT cdom_ cfv cfv cT
      cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm
      cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cT cdom_ cfv cdm cT
      ccat wcel vm cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cfv cT cid_ cfv
      cfv cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT
      cdom_ cfv cfv cT cid_ cfv cfv wceq cT ccat wcel vm cv cT cdom_ cfv cdm
      wcel wa vm cv cT cdom_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres
      cfv vm cv cT cdom_ cfv cfv cT cid_ cfv cfv vm cv cid cT cdom_ cfv cdm
      cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv cT ccat wcel vm cv cT cdom_ cfv
      cdm wcel wa cT ccat wcel vm cv cT cdom_ cfv cfv cT cid_ cfv cdm wcel wa
      vm cv cT cdom_ cfv cfv cT cid_ cfv cfv cT cdom_ cfv cdm wcel vm cv cT
      cdom_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv cT
      cdom_ cfv cfv cT cid_ cfv cfv wceq cT ccat wcel vm cv cT cdom_ cfv cdm
      wcel wa cT ccat wcel vm cv cT cdom_ cfv cfv cT cid_ cfv cdm wcel cT ccat
      wcel vm cv cT cdom_ cfv cdm wcel pm3.26 cT cdom_ cfv cT vm cv cT cdom_
      cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid cT cid_ cfv cdm eqid cT
      cdom_ cfv eqid dmo jca vm cv cT cdom_ cfv cfv cT cT cid_ cfv cT cdom_ cfv
      cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid cT cid_ cfv cdm eqid cT cid_
      cfv eqid jdmo cT cdom_ cfv cdm vm cv cT cdom_ cfv cfv cT cid_ cfv cfv
      fvresi 3syl vm cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cfv cT cid_
      cfv cfv vm cv cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv cfv cT cid_ cfv
      cfv wceq cT ccat wcel vm cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cfv
      vm cv cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv cfv cT cid_ cfv vm cv cT
      cdom_ cfv cdm wcel vm cv vm cv cid cT cdom_ cfv cdm cres cfv cT cdom_ cfv
      vm cv cT cdom_ cfv cdm wcel vm cv cid cT cdom_ cfv cdm cres cfv vm cv cT
      cdom_ cfv cdm vm cv fvresi eqcomd fveq2d fveq2d adantl eqtrd ex r19.21aiv
      cT ccat wcel vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm
      cres cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv cfv cT cid_ cfv
      cfv wceq vm cT cdom_ cfv cdm cT ccat wcel vm cv cT cdom_ cfv cdm wcel vm
      cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv
      cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv cfv cT cid_ cfv cfv wceq cT
      ccat wcel vm cv cT cdom_ cfv cdm wcel wa vm cv cT ccod_ cfv cfv cT cid_
      cfv cfv cid cT cdom_ cfv cdm cres cfv vm cv cT ccod_ cfv cfv cT cid_ cfv
      cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_ cfv cfv cT cid_ cfv cfv
      cT ccat wcel vm cv cT cdom_ cfv cdm wcel wa cT ccat wcel vm cv cT ccod_
      cfv cfv cT cid_ cfv cdm wcel wa vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cT
      cdom_ cfv cdm wcel vm cv cT ccod_ cfv cfv cT cid_ cfv cfv cid cT cdom_
      cfv cdm cres cfv vm cv cT ccod_ cfv cfv cT cid_ cfv cfv wceq cT ccat wcel
      vm cv cT cdom_ cfv cdm wcel wa cT ccat wcel vm cv cT ccod_ cfv cfv cT
      cid_ cfv cdm wcel cT ccat wcel vm cv cT cdom_ cfv cdm wcel pm3.26 cT
      ccod_ cfv cT vm cv cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid
      cT cid_ cfv cdm eqid cT ccod_ cfv eqid cdmo jca vm cv cT ccod_ cfv cfv cT
      cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid cT
      cid_ cfv cdm eqid cT cid_ cfv eqid jdmo cT cdom_ cfv cdm vm cv cT ccod_
      cfv cfv cT cid_ cfv cfv fvresi 3syl vm cv cT cdom_ cfv cdm wcel vm cv cT
      ccod_ cfv cfv cT cid_ cfv cfv vm cv cid cT cdom_ cfv cdm cres cfv cT
      ccod_ cfv cfv cT cid_ cfv cfv wceq cT ccat wcel vm cv cT cdom_ cfv cdm
      wcel vm cv cT ccod_ cfv cfv vm cv cid cT cdom_ cfv cdm cres cfv cT ccod_
      cfv cfv cT cid_ cfv vm cv cT cdom_ cfv cdm wcel vm cv vm cv cid cT cdom_
      cfv cdm cres cfv cT ccod_ cfv vm cv cT cdom_ cfv cdm wcel vm cv cid cT
      cdom_ cfv cdm cres cfv vm cv cT cdom_ cfv cdm vm cv fvresi eqcomd fveq2d
      fveq2d adantl eqtrd ex r19.21aiv jca cT ccat wcel vn cv cT ccod_ cfv cfv
      vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cid cT cdom_ cfv
      cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_ cfv
      cdm cres cfv cT co_ cfv co wceq wi vm vn cT cdom_ cfv cdm cT cdom_ cfv
      cdm cT ccat wcel vm cv cT cdom_ cfv cdm wcel vn cv cT cdom_ cfv cdm wcel
      vn cv cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv
      co cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn
      cv cid cT cdom_ cfv cdm cres cfv cT co_ cfv co wceq wi cT ccat wcel vn cv
      cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cdm wcel vn cv cT ccod_ cfv cfv
      vm cv cT cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cid cT cdom_ cfv
      cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_ cfv
      cdm cres cfv cT co_ cfv co wceq wi cT ccat wcel vn cv cT cdom_ cfv cdm
      wcel vm cv cT cdom_ cfv cdm wcel w3a vn cv cT ccod_ cfv cfv vm cv cT
      cdom_ cfv cfv wceq vm cv vn cv cT co_ cfv co cT cdom_ cfv cdm wcel vm cv
      vn cv cT co_ cfv co cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv
      cdm cres cfv vn cv cid cT cdom_ cfv cdm cres cfv cT co_ cfv co wceq vn cv
      cT ccod_ cfv cfv vm cv cT cdom_ cfv cfv wceq cT ccat wcel vn cv cT cdom_
      cfv cdm wcel vm cv cT cdom_ cfv cdm wcel w3a vm cv vn cv cT co_ cfv co cT
      cdom_ cfv cdm wcel cT ccat wcel vn cv cT cdom_ cfv cdm wcel vm cv cT
      cdom_ cfv cdm wcel w3a vm cv vn cv cT co_ cfv co cT cdom_ cfv cdm wcel wi
      vm cv cT cdom_ cfv cfv vn cv cT ccod_ cfv cfv cT ccat wcel vn cv cT cdom_
      cfv cdm wcel vm cv cT cdom_ cfv cdm wcel w3a vm cv cT cdom_ cfv cfv vn cv
      cT ccod_ cfv cfv wceq vm cv vn cv cT co_ cfv co cT cdom_ cfv cdm wcel cT
      ccod_ cfv cT cdom_ cfv cT co_ cfv cT vn cv vm cv cT cdom_ cfv cdm cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid
      cmpmorp com12 eqcoms com12 vn cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv
      cdm wcel vm cv vn cv cT co_ cfv co cT cdom_ cfv cdm wcel vm cv vn cv cT
      co_ cfv co cid cT cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres
      cfv vn cv cid cT cdom_ cfv cdm cres cfv cT co_ cfv co wceq wi cT ccat
      wcel vn cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cdm wcel wa vm cv vn
      cv cT co_ cfv co cT cdom_ cfv cdm wcel vm cv vn cv cT co_ cfv co cid cT
      cdom_ cfv cdm cres cfv vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT
      cdom_ cfv cdm cres cfv cT co_ cfv co wceq vm cv vn cv cT co_ cfv co cT
      cdom_ cfv cdm wcel vn cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cdm
      wcel wa vm cv vn cv cT co_ cfv co cid cT cdom_ cfv cdm cres cfv vm cv vn
      cv cT co_ cfv co vm cv cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_
      cfv cdm cres cfv cT co_ cfv co cT cdom_ cfv cdm vm cv vn cv cT co_ cfv co
      fvresi vn cv cT cdom_ cfv cdm wcel vm cv cT cdom_ cfv cdm wcel wa vm cv
      cid cT cdom_ cfv cdm cres cfv vn cv cid cT cdom_ cfv cdm cres cfv cT co_
      cfv co vm cv vn cv cT co_ cfv co vm cv cT cdom_ cfv cdm wcel vn cv cT
      cdom_ cfv cdm wcel vm cv cid cT cdom_ cfv cdm cres cfv vm cv vn cv cid cT
      cdom_ cfv cdm cres cfv vn cv cT co_ cfv cT cdom_ cfv cdm vm cv fvresi cT
      cdom_ cfv cdm vn cv fvresi opreqan12rd eqcomd sylan9eqr ex 3adant1 syld
      3com23 3expib r19.21aivv 3jca cT cdom_ cfv cdm cT cdom_ cfv cdm cid cT
      cdom_ cfv cdm cres wf1o cT cdom_ cfv cdm cT cdom_ cfv cdm cid cT cdom_
      cfv cdm cres wf cT cdom_ cfv cdm f1oi cT cdom_ cfv cdm cT cdom_ cfv cdm
      cid cT cdom_ cfv cdm cres f1of ax-mp jctil 3ad2ant1 cvv cT cT vm vn va
      cid cT cdom_ cfv cdm cres vb cT cid_ cfv cdm cT cdom_ cfv cdm cT cid_ cfv
      cdm cT cdom_ cfv cdm cT cid_ cfv cT cdom_ cfv cT ccod_ cfv cT co_ cfv cT
      cid_ cfv cT cdom_ cfv cT ccod_ cfv cT co_ cfv cT cid_ cfv cdm eqid cT
      cdom_ cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid cT cid_ cfv eqid
      cT co_ cfv eqid cT cid_ cfv cdm eqid cT cdom_ cfv cdm eqid cT cdom_ cfv
      eqid cT ccod_ cfv eqid cT cid_ cfv eqid cT co_ cfv eqid isfunb mpbird
      3exp mpii pm2.43i $.
      $( [22-Jul-2008] $) $( [15-Jul-2008] $)
  $}

  ${ $d t u v f g $.
    $( Class of isomorphisms. $)
    df-isof $a |- Isofunc = { <. <. t , u >. , v >. |
      ( ( t e. Cat /\ u e. Cat ) /\
      v = { f  e. ( Func ` <. u , v >. ) | E. g e. ( Func ` <. v , u >. )
      ( ( f o. g ) = ( _I |` dom ( dom_ ` v ) ) /\
        ( g o. f ) = ( _I |` dom ( dom_ ` u ) ) ) } ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Subcategories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $c SubCat $.
  $( Extend class notation with a function returning all the subcategories of
     a given category. $)
  csubc $a class SubCat $.

  ${ $d x y a $.
    $( ` ( SubCat `` x ) ` is the set of all the subcategories of the category
       ` x ` . All the objects and all the morphisms of the subcategory belong
       to the supercategory.  The identity of an object, the domain and the
       codomain of a morphism are the same in the subcategory and the
       supercategory.  The composition of the subcategory is a restriction of
       the composition of the supercategory.  $)
  df-subc $a |- SubCat = { <. x , y >. | ( x e. Cat /\ y = { a e. Cat | (
    ( id_ ` a ) C_ ( id_ ` x ) /\ ( ( dom_ ` a ) C_ ( dom_ ` x )
    /\ ( cod_ ` a ) C_ ( cod_ ` x ) ) /\  ( o_ ` a ) C_ ( o_ ` x ) ) } ) }  $.
  $}

  ${ $d C a u $. $d C a x y $. $d D a u $. $d D a x y $. $d J a u $.
     $d J a x y $. $d R a u $. $d R a x y $. $d T a x y $.
  issubcat.2 $e |- D = ( dom_ ` T ) $.
  issubcat.3 $e |- C = ( cod_ ` T ) $.
  issubcat.4 $e |- R = ( o_ ` T ) $.
  issubcat.5 $e |- J = ( id_ ` T ) $.
  $( The set of all the subcategories of ` T ` . $)
  issubcat $p |- ( T e. Cat -> ( SubCat ` T ) = { a e. Cat | (
    ( id_ ` a ) C_ J /\ ( ( dom_ ` a ) C_ D
    /\ ( cod_ ` a ) C_ C ) /\  ( o_ ` a ) C_ R ) } )  $=
    vx vy cT va cv cid_ cfv vx cv cid_ cfv wss va cv cdom_ cfv vx cv cdom_ cfv
    wss va cv ccod_ cfv vx cv ccod_ cfv wss wa va cv co_ cfv vx cv co_ cfv wss
    w3a va ccat crab va cv cid_ cfv cJ wss va cv cdom_ cfv cD wss va cv ccod_
    cfv cC wss wa va cv co_ cfv cR wss w3a va ccat crab ccat csubc vx cv cT
    wceq va cv cid_ cfv vx cv cid_ cfv wss va cv cdom_ cfv vx cv cdom_ cfv wss
    va cv ccod_ cfv vx cv ccod_ cfv wss wa va cv co_ cfv vx cv co_ cfv wss w3a
    va cv cid_ cfv cJ wss va cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va
    cv co_ cfv cR wss w3a va ccat vx cv cT wceq va cv cid_ cfv vx cv cid_ cfv
    wss va cv cid_ cfv cJ wss va cv cdom_ cfv vx cv cdom_ cfv wss va cv ccod_
    cfv vx cv ccod_ cfv wss wa va cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa
    va cv co_ cfv vx cv co_ cfv wss va cv co_ cfv cR wss vx cv cT wceq vx cv
    cid_ cfv cJ va cv cid_ cfv vx cv cT wceq vx cv cid_ cfv cT cid_ cfv cJ vx
    cv cT cid_ fveq2 issubcat.5 syl6eqr sseq2d vx cv cT wceq va cv cdom_ cfv vx
    cv cdom_ cfv wss va cv cdom_ cfv cD wss va cv ccod_ cfv vx cv ccod_ cfv wss
    va cv ccod_ cfv cC wss vx cv cT wceq vx cv cdom_ cfv cD va cv cdom_ cfv vx
    cv cT wceq vx cv cdom_ cfv cT cdom_ cfv cD vx cv cT cdom_ fveq2 issubcat.2
    syl6eqr sseq2d vx cv cT wceq vx cv ccod_ cfv cC va cv ccod_ cfv vx cv cT
    wceq vx cv ccod_ cfv cT ccod_ cfv cC vx cv cT ccod_ fveq2 issubcat.3
    syl6eqr sseq2d anbi12d vx cv cT wceq vx cv co_ cfv cR va cv co_ cfv vx cv
    cT wceq vx cv co_ cfv cT co_ cfv cR vx cv cT co_ fveq2 issubcat.4 syl6eqr
    sseq2d 3anbi123d rabbisdv vx vy va df-subc va cv cid_ cfv cJ wss va cv
    cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a va ccat
    crab cD cpw cC cpw cxp cJ cpw cR cpw cxp cxp cD cpw cC cpw cxp cJ cpw cR
    cpw cxp cD cpw cC cpw cD cD cT cdom_ cfv cvv issubcat.2 cT cdom_ fvex
    eqeltri pwex cC cC cT ccod_ cfv cvv issubcat.3 cT ccod_ fvex eqeltri pwex
    xpex cJ cpw cR cpw cJ cJ cT cid_ cfv cvv issubcat.5 cT cid_ fvex eqeltri
    pwex cR cR cT co_ cfv cvv issubcat.4 cT co_ fvex eqeltri pwex xpex xpex vu
    va cv cid_ cfv cJ wss va cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va
    cv co_ cfv cR wss w3a va ccat crab cD cpw cC cpw cxp cJ cpw cR cpw cxp cxp
    vu cv ccat wcel vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_
    cfv cC wss wa vu cv co_ cfv cR wss w3a wa vu cv vu cv c1st cfv vu cv c2nd
    cfv cop wceq vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv
    cop wceq vu cv c1st cfv c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw
    wcel wa wa vu cv c2nd cfv cJ cpw cR cpw cxp wcel wa wa vu cv va cv cid_ cfv
    cJ wss va cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR
    wss w3a va ccat crab wcel vu cv cD cpw cC cpw cxp cJ cpw cR cpw cxp cxp
    wcel vu cv ccat wcel vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv
    ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a wa vu cv vu cv c1st cfv vu cv
    c2nd cfv cop wceq vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv
    c2nd cfv cop wceq vu cv c1st cfv c1st cfv cD cpw wcel vu cv c1st cfv c2nd
    cfv cC cpw wcel wa wa vu cv c2nd cfv cJ cpw cR cpw cxp wcel wa vu cv ccat
    wcel vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv cid_ cfv cJ wss vu
    cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a ccat
    wrel vu cv ccat wcel vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq relcat vu
    cv ccat 1st2nd mpan adantr vu cv ccat wcel vu cv cid_ cfv cJ wss vu cv
    cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a wa vu
    cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq vu cv
    c1st cfv c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw wcel wa wa vu
    cv c2nd cfv cJ cpw cR cpw cxp wcel vu cv ccat wcel vu cv cid_ cfv cJ wss vu
    cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a wa
    vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq vu
    cv c1st cfv c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw wcel wa vu
    cv ccat wcel vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv
    cop wceq vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC
    wss wa vu cv co_ cfv cR wss w3a ccat cdm wrel vu cv ccat wcel vu cv c1st
    cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq reldcat ccat
    cdm wrel vu cv c1st cfv ccat cdm wcel vu cv c1st cfv vu cv c1st cfv c1st
    cfv vu cv c1st cfv c2nd cfv cop wceq vu cv ccat wcel vu cv c1st cfv ccat
    cdm 1st2nd ccat wrel vu cv ccat wcel vu cv c1st cfv ccat cdm wcel relcat vu
    cv ccat 1stdm mpan sylan2 mpan adantr vu cv ccat wcel vu cv cid_ cfv cJ wss
    vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a
    wa vu cv c1st cfv c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw wcel
    vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu
    cv co_ cfv cR wss w3a vu cv ccat wcel vu cv c1st cfv c1st cfv cD cpw wcel
    vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu
    cv co_ cfv cR wss vu cv ccat wcel vu cv c1st cfv c1st cfv cD cpw wcel wi vu
    cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss vu cv
    ccat wcel vu cv c1st cfv c1st cfv cD cpw wcel wi wi wi vu cv cid_ cfv cJ
    wss vu cv cdom_ cfv cD wss vu cv co_ cfv cR wss vu cv ccat wcel vu cv c1st
    cfv c1st cfv cD cpw wcel wi wi vu cv ccod_ cfv cC wss vu cv cdom_ cfv cD
    wss vu cv ccat wcel vu cv c1st cfv c1st cfv cD cpw wcel wi vu cv co_ cfv cR
    wss vu cv cdom_ cfv cD wss vu cv cdom_ cfv cD cpw wcel vu cv ccat wcel vu
    cv c1st cfv c1st cfv cD cpw wcel wi vu cv cdom_ cfv cD vu cv cdom_ fvex
    elpw vu cv cdom_ cfv cD cpw wcel vu cv c1st cfv c1st cfv cD cpw wcel vu cv
    ccat wcel vu cv c1st cfv c1st cfv cD cpw wcel wi vu cv cdom_ cfv vu cv c1st
    cfv c1st cfv cD cpw vu cv cdom_ cfv vu cv c1st c1st ccom cfv vu cv c1st cfv
    c1st cfv vu cv cdom_ c1st c1st ccom df-doma fveq1i c1st wfun c1st wfun vu
    cv c1st cdm wcel vu cv c1st c1st ccom cfv vu cv c1st cfv c1st cfv wceq cvv
    cvv c1st wfo c1st wfun fo1st cvv cvv c1st fofun ax-mp cvv cvv c1st wfo c1st
    wfun fo1st cvv cvv c1st fofun ax-mp vu cv cvv c1st cdm vu visset cvv cvv
    c1st cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof ax-mp fdmi
    eleqtrri vu cv c1st c1st fvco mp3an eqtri eleq1i vu cv c1st cfv c1st cfv cD
    cpw wcel vu cv ccat wcel ax-1 sylbi sylbir a1d adantr a1i 3imp impcom vu cv
    cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_
    cfv cR wss w3a vu cv ccat wcel vu cv c1st cfv c2nd cfv cC cpw wcel vu cv
    cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv cid_ cfv cJ wss vu cv ccat
    wcel vu cv c1st cfv c2nd cfv cC cpw wcel wi vu cv co_ cfv cR wss vu cv
    ccod_ cfv cC wss vu cv ccat wcel vu cv c1st cfv c2nd cfv cC cpw wcel wi vu
    cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss vu cv ccod_ cfv cC cpw wcel vu
    cv ccat wcel vu cv c1st cfv c2nd cfv cC cpw wcel wi vu cv ccod_ cfv cC vu
    cv ccod_ fvex elpw vu cv ccod_ cfv cC cpw wcel vu cv c1st cfv c2nd cfv cC
    cpw wcel vu cv ccat wcel vu cv c1st cfv c2nd cfv cC cpw wcel wi vu cv ccod_
    cfv vu cv c1st cfv c2nd cfv cC cpw vu cv ccod_ cfv vu cv c2nd c1st ccom cfv
    vu cv c1st cfv c2nd cfv vu cv ccod_ c2nd c1st ccom df-coda fveq1i c2nd wfun
    c1st wfun vu cv c1st cdm wcel vu cv c2nd c1st ccom cfv vu cv c1st cfv c2nd
    cfv wceq cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv c2nd fofun ax-mp cvv cvv
    c1st wfo c1st wfun fo1st cvv cvv c1st fofun ax-mp vu cv cvv c1st cdm vu
    visset cvv cvv c1st cvv cvv c1st wfo cvv cvv c1st wf fo1st cvv cvv c1st fof
    ax-mp fdmi eleqtrri vu cv c2nd c1st fvco mp3an eqtri eleq1i vu cv c1st cfv
    c2nd cfv cC cpw wcel vu cv ccat wcel ax-1 sylbi sylbir adantl 3ad2ant2
    impcom jca jca vu cv ccat wcel vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss
    vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a wa vu cv c2nd cfv vu cv
    c2nd cfv c1st cfv vu cv c2nd cfv c2nd cfv cop wceq vu cv c2nd cfv c1st cfv
    cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wa wa vu cv c2nd cfv cJ cpw
    cR cpw cxp wcel vu cv ccat wcel vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD
    wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss w3a wa vu cv c2nd cfv vu
    cv c2nd cfv c1st cfv vu cv c2nd cfv c2nd cfv cop wceq vu cv c2nd cfv c1st
    cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wa vu cv ccat wcel vu
    cv c2nd cfv vu cv c2nd cfv c1st cfv vu cv c2nd cfv c2nd cfv cop wceq vu cv
    cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_
    cfv cR wss w3a ccat crn wrel vu cv ccat wcel vu cv c2nd cfv vu cv c2nd cfv
    c1st cfv vu cv c2nd cfv c2nd cfv cop wceq relrcat ccat crn wrel vu cv c2nd
    cfv ccat crn wcel vu cv c2nd cfv vu cv c2nd cfv c1st cfv vu cv c2nd cfv
    c2nd cfv cop wceq vu cv ccat wcel vu cv c2nd cfv ccat crn 1st2nd ccat wrel
    vu cv ccat wcel vu cv c2nd cfv ccat crn wcel relcat vu cv ccat 2ndrn mpan
    sylan2 mpan adantr vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_
    cfv cC wss wa vu cv co_ cfv cR wss w3a vu cv ccat wcel vu cv c2nd cfv c1st
    cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wa vu cv cid_ cfv cJ
    wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv co_ cfv cR wss
    vu cv ccat wcel vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv
    cR cpw wcel wa wi vu cv cid_ cfv cJ wss vu cv co_ cfv cR wss vu cv ccat
    wcel vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw
    wcel wa wi wi vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa vu cv cid_
    cfv cJ wss vu cv cid_ cfv cJ cpw wcel vu cv co_ cfv cR wss vu cv ccat wcel
    vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wa
    wi wi vu cv cid_ cfv cJ vu cv cid_ fvex elpw vu cv cid_ cfv cJ cpw wcel vu
    cv c2nd cfv c1st cfv cJ cpw wcel vu cv co_ cfv cR wss vu cv ccat wcel vu cv
    c2nd cfv c1st cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wa wi wi
    vu cv cid_ cfv vu cv c2nd cfv c1st cfv cJ cpw vu cv cid_ cfv vu cv c1st
    c2nd ccom cfv vu cv c2nd cfv c1st cfv vu cv cid_ c1st c2nd ccom df-ida
    fveq1i c1st wfun c2nd wfun vu cv c2nd cdm wcel vu cv c1st c2nd ccom cfv vu
    cv c2nd cfv c1st cfv wceq cvv cvv c1st wfo c1st wfun fo1st cvv cvv c1st
    fofun ax-mp cvv cvv c2nd wfo c2nd wfun fo2nd cvv cvv c2nd fofun ax-mp vu cv
    cvv c2nd cdm vu visset cvv cvv c2nd cvv cvv c2nd wfo cvv cvv c2nd wf fo2nd
    cvv cvv c2nd fof ax-mp fdmi eleqtrri vu cv c1st c2nd fvco mp3an eqtri
    eleq1i vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv co_ cfv cR wss vu cv ccat
    wcel vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw
    wcel wa vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv co_ cfv cR wss vu cv ccat
    wcel w3a vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv c2nd cfv c2nd cfv cR cpw
    wcel vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv co_ cfv cR wss vu cv ccat
    wcel 3simp1 vu cv c2nd cfv c1st cfv cJ cpw wcel vu cv co_ cfv cR wss vu cv
    ccat wcel vu cv c2nd cfv c2nd cfv cR cpw wcel vu cv co_ cfv cR wss vu cv
    ccat wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wi wi vu cv c2nd cfv c1st cfv
    cJ cpw wcel vu cv co_ cfv cR wss vu cv co_ cfv cR cpw wcel vu cv ccat wcel
    vu cv c2nd cfv c2nd cfv cR cpw wcel wi vu cv co_ cfv cR vu cv co_ fvex elpw
    vu cv co_ cfv cR cpw wcel vu cv c2nd cfv c2nd cfv cR cpw wcel vu cv ccat
    wcel vu cv c2nd cfv c2nd cfv cR cpw wcel wi vu cv co_ cfv vu cv c2nd cfv
    c2nd cfv cR cpw vu cv co_ cfv vu cv c2nd c2nd ccom cfv vu cv c2nd cfv c2nd
    cfv vu cv co_ c2nd c2nd ccom df-cmpa fveq1i c2nd wfun c2nd wfun vu cv c2nd
    cdm wcel vu cv c2nd c2nd ccom cfv vu cv c2nd cfv c2nd cfv wceq cvv cvv c2nd
    wfo c2nd wfun fo2nd cvv cvv c2nd fofun ax-mp cvv cvv c2nd wfo c2nd wfun
    fo2nd cvv cvv c2nd fofun ax-mp vu cv cvv c2nd cdm vu visset cvv cvv c2nd
    cvv cvv c2nd wfo cvv cvv c2nd wf fo2nd cvv cvv c2nd fof ax-mp fdmi eleqtrri
    vu cv c2nd c2nd fvco mp3an eqtri eleq1i vu cv c2nd cfv c2nd cfv cR cpw wcel
    vu cv ccat wcel ax-1 sylbi sylbir a1i 3imp jca 3exp sylbi sylbir a1d 3imp
    impcom jca vu cv c2nd cfv cJ cpw cR cpw elxp6 sylibr jca jca va cv cid_ cfv
    cJ wss va cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR
    wss w3a vu cv cid_ cfv cJ wss vu cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss
    wa vu cv co_ cfv cR wss w3a va vu cv ccat va vu weq va cv cid_ cfv cJ wss
    vu cv cid_ cfv cJ wss va cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa vu
    cv cdom_ cfv cD wss vu cv ccod_ cfv cC wss wa va cv co_ cfv cR wss vu cv
    co_ cfv cR wss va vu weq va cv cid_ cfv vu cv cid_ cfv cJ va cv vu cv cid_
    fveq2 sseq1d va vu weq va cv cdom_ cfv cD wss vu cv cdom_ cfv cD wss va cv
    ccod_ cfv cC wss vu cv ccod_ cfv cC wss va vu weq va cv cdom_ cfv vu cv
    cdom_ cfv cD va cv vu cv cdom_ fveq2 sseq1d va vu weq va cv ccod_ cfv vu cv
    ccod_ cfv cC va cv vu cv ccod_ fveq2 sseq1d anbi12d va vu weq va cv co_ cfv
    vu cv co_ cfv cR va cv vu cv co_ fveq2 sseq1d 3anbi123d elrab vu cv cD cpw
    cC cpw cxp cJ cpw cR cpw cxp cxp wcel vu cv vu cv c1st cfv vu cv c2nd cfv
    cop wceq vu cv c1st cfv cD cpw cC cpw cxp wcel vu cv c2nd cfv cJ cpw cR cpw
    cxp wcel wa wa vu cv vu cv c1st cfv vu cv c2nd cfv cop wceq vu cv c1st cfv
    vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq vu cv c1st cfv
    c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw wcel wa wa vu cv c2nd
    cfv cJ cpw cR cpw cxp wcel wa wa vu cv cD cpw cC cpw cxp cJ cpw cR cpw cxp
    elxp6 vu cv c1st cfv cD cpw cC cpw cxp wcel vu cv c2nd cfv cJ cpw cR cpw
    cxp wcel wa vu cv c1st cfv vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv
    cop wceq vu cv c1st cfv c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw
    wcel wa wa vu cv c2nd cfv cJ cpw cR cpw cxp wcel wa vu cv vu cv c1st cfv vu
    cv c2nd cfv cop wceq vu cv c1st cfv cD cpw cC cpw cxp wcel vu cv c1st cfv
    vu cv c1st cfv c1st cfv vu cv c1st cfv c2nd cfv cop wceq vu cv c1st cfv
    c1st cfv cD cpw wcel vu cv c1st cfv c2nd cfv cC cpw wcel wa wa vu cv c2nd
    cfv cJ cpw cR cpw cxp wcel vu cv c1st cfv cD cpw cC cpw elxp6 anbi1i anbi2i
    bitri 3imtr4i ssriv ssexi fvopab4 $.
    $( [6-Oct-2009] $) $( [17-Sep-2009] $)
  $}

  ${ $d C a $. $d D a $. $d J a $. $d R a $. $d T a $. $d U a $.
  issubcata.2 $e |- D = ( dom_ ` T ) $.
  issubcata.3 $e |- C = ( cod_ ` T ) $.
  issubcata.4 $e |- R = ( o_ ` T ) $.
  issubcata.5 $e |- J = ( id_ ` T ) $.
  $( The predicate "is a subcategory of" ` T ` . $)
  issubcata $p |- ( T e. Cat -> ( U e. ( SubCat ` T ) <-> (
    U e. Cat /\ ( ( id_ ` U ) C_ J /\ ( ( dom_ ` U ) C_ D
    /\ ( cod_ ` U ) C_ C ) /\  ( o_ ` U ) C_ R ) ) ) ) $=
    cT ccat wcel cU cT csubc cfv wcel cU va cv cid_ cfv cJ wss va cv cdom_ cfv
    cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a va ccat crab wcel
    cU ccat wcel cU cid_ cfv cJ wss cU cdom_ cfv cD wss cU ccod_ cfv cC wss wa
    cU co_ cfv cR wss w3a wa cT ccat wcel cT csubc cfv va cv cid_ cfv cJ wss va
    cv cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a va
    ccat crab cU cC cD cR cT cJ va issubcata.2 issubcata.3 issubcata.4
    issubcata.5 issubcat eleq2d cU va cv cid_ cfv cJ wss va cv cdom_ cfv cD wss
    va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a va ccat crab wcel cU
    ccat wcel cU cid_ cfv cJ wss cU cdom_ cfv cD wss cU ccod_ cfv cC wss wa cU
    co_ cfv cR wss w3a wa wb cT ccat wcel va cv cid_ cfv cJ wss va cv cdom_ cfv
    cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a cU cid_ cfv cJ
    wss cU cdom_ cfv cD wss cU ccod_ cfv cC wss wa cU co_ cfv cR wss w3a va cU
    ccat va cv cU wceq va cv cid_ cfv cJ wss cU cid_ cfv cJ wss va cv cdom_ cfv
    cD wss va cv ccod_ cfv cC wss wa cU cdom_ cfv cD wss cU ccod_ cfv cC wss wa
    va cv co_ cfv cR wss cU co_ cfv cR wss va cv cU wceq va cv cid_ cfv cU cid_
    cfv cJ va cv cU cid_ fveq2 sseq1d va cv cU wceq va cv cdom_ cfv cD wss cU
    cdom_ cfv cD wss va cv ccod_ cfv cC wss cU ccod_ cfv cC wss va cv cU wceq
    va cv cdom_ cfv cU cdom_ cfv cD va cv cU cdom_ fveq2 sseq1d va cv cU wceq
    va cv ccod_ cfv cU ccod_ cfv cC va cv cU ccod_ fveq2 sseq1d anbi12d va cv
    cU wceq va cv co_ cfv cU co_ cfv cR va cv cU co_ fveq2 sseq1d 3anbi123d
    elrab a1i bitrd $.
    $( [6-Oct-2009] $) $( [17-Sep-2009] $)
  $}

  ${ $d C a $. $d D a $. $d J a $. $d R a $. $d T a $. $d U a $.
  issubcatb.2 $e |- D = ( dom_ ` T ) $.
  issubcatb.3 $e |- C = ( cod_ ` T ) $.
  issubcatb.4 $e |- R = ( o_ ` T ) $.
  issubcatb.5 $e |- J = ( id_ ` T ) $.
  $( Todo: to be removed. $)
  $( The predicate "is a subcategory of" ` T ` . $)
  issubcatb $p |- ( ( T e. Cat /\ U e. Cat ) -> ( U e. ( SubCat ` T ) <-> (
    ( id_ ` U ) C_ J /\ ( ( dom_ ` U ) C_ D
    /\ ( cod_ ` U ) C_ C ) /\  ( o_ ` U ) C_ R ) ) ) $=
    cT ccat wcel cU cT csubc cfv wcel cU va cv cid_ cfv cJ wss va cv cdom_ cfv
    cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a va ccat crab wcel
    cU ccat wcel cU cid_ cfv cJ wss cU cdom_ cfv cD wss cU ccod_ cfv cC wss wa
    cU co_ cfv cR wss w3a cT ccat wcel cT csubc cfv va cv cid_ cfv cJ wss va cv
    cdom_ cfv cD wss va cv ccod_ cfv cC wss wa va cv co_ cfv cR wss w3a va ccat
    crab cU cC cD cR cT cJ va issubcatb.2 issubcatb.3 issubcatb.4 issubcatb.5
    issubcat eleq2d va cv cid_ cfv cJ wss va cv cdom_ cfv cD wss va cv ccod_
    cfv cC wss wa va cv co_ cfv cR wss w3a cU cid_ cfv cJ wss cU cdom_ cfv cD
    wss cU ccod_ cfv cC wss wa cU co_ cfv cR wss w3a va cU ccat va cv cU wceq
    va cv cid_ cfv cJ wss cU cid_ cfv cJ wss va cv cdom_ cfv cD wss va cv ccod_
    cfv cC wss wa cU cdom_ cfv cD wss cU ccod_ cfv cC wss wa va cv co_ cfv cR
    wss cU co_ cfv cR wss va cv cU wceq va cv cid_ cfv cU cid_ cfv cJ va cv cU
    cid_ fveq2 sseq1d va cv cU wceq va cv cdom_ cfv cD wss cU cdom_ cfv cD wss
    va cv ccod_ cfv cC wss cU ccod_ cfv cC wss va cv cU wceq va cv cdom_ cfv cU
    cdom_ cfv cD va cv cU cdom_ fveq2 sseq1d va cv cU wceq va cv ccod_ cfv cU
    ccod_ cfv cC va cv cU ccod_ fveq2 sseq1d anbi12d va cv cU wceq va cv co_
    cfv cU co_ cfv cR va cv cU co_ fveq2 sseq1d 3anbi123d elrab3 sylan9bb $.
    $( [6-Oct-2009] $) $( [17-Sep-2009] $)
  $}

  ${ $d a x y $.
  $( Lemma to simplify some subcategories related theorems . $)
  besubbeca $p |- ( U e. ( SubCat ` T ) -> T e. Cat ) $=
    cU cT csubc cfv wcel cT csubc cdm wcel cT ccat wcel cU cT csubc elfvdm cT
    csubc cdm wcel cT vx cv ccat wcel vy cv va cv cid_ cfv vx cv cid_ cfv wss
    va cv cdom_ cfv vx cv cdom_ cfv wss va cv ccod_ cfv vx cv ccod_ cfv wss wa
    va cv co_ cfv vx cv co_ cfv wss w3a va ccat crab wceq wa vx vy copab cdm
    wcel cT ccat wcel csubc cdm vx cv ccat wcel vy cv va cv cid_ cfv vx cv cid_
    cfv wss va cv cdom_ cfv vx cv cdom_ cfv wss va cv ccod_ cfv vx cv ccod_ cfv
    wss wa va cv co_ cfv vx cv co_ cfv wss w3a va ccat crab wceq wa vx vy copab
    cdm cT csubc vx cv ccat wcel vy cv va cv cid_ cfv vx cv cid_ cfv wss va cv
    cdom_ cfv vx cv cdom_ cfv wss va cv ccod_ cfv vx cv ccod_ cfv wss wa va cv
    co_ cfv vx cv co_ cfv wss w3a va ccat crab wceq wa vx vy copab vx vy va
    df-subc dmeqi eleq2i vx cv ccat wcel vy cv va cv cid_ cfv vx cv cid_ cfv
    wss va cv cdom_ cfv vx cv cdom_ cfv wss va cv ccod_ cfv vx cv ccod_ cfv wss
    wa va cv co_ cfv vx cv co_ cfv wss w3a va ccat crab wceq wa vx vy copab cdm
    ccat cT vy cv va cv cid_ cfv vx cv cid_ cfv wss va cv cdom_ cfv vx cv cdom_
    cfv wss va cv ccod_ cfv vx cv ccod_ cfv wss wa va cv co_ cfv vx cv co_ cfv
    wss w3a va ccat crab wceq vx vy ccat dmopabss sseli sylbi syl $.
    $( [6-Oct-2009] $) $( [17-Sep-2009] $)
  $}

  $( A category belongs to the set of its subcategories. $)
  catsbc $p |- ( T e. Cat -> T e. ( SubCat ` T ) ) $=
    cT ccat wcel cT cT csubc cfv wcel cT cid_ cfv cT cid_ cfv wss cT cdom_ cfv
    cT cdom_ cfv wss cT ccod_ cfv cT ccod_ cfv wss wa cT co_ cfv cT co_ cfv wss
    w3a cT cid_ cfv cT cid_ cfv wss cT cdom_ cfv cT cdom_ cfv wss cT ccod_ cfv
    cT ccod_ cfv wss wa cT co_ cfv cT co_ cfv wss cT cid_ cfv ssid cT cdom_ cfv
    cT cdom_ cfv wss cT ccod_ cfv cT ccod_ cfv wss cT cdom_ cfv ssid cT ccod_
    cfv ssid pm3.2i cT co_ cfv ssid 3pm3.2i cT ccat wcel cT cT csubc cfv wcel
    cT cid_ cfv cT cid_ cfv wss cT cdom_ cfv cT cdom_ cfv wss cT ccod_ cfv cT
    ccod_ cfv wss wa cT co_ cfv cT co_ cfv wss w3a wb cT ccod_ cfv cT cdom_ cfv
    cT co_ cfv cT cT cT cid_ cfv cT cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv
    eqid cT cid_ cfv eqid issubcatb anidms mpbiri $.
    $( [6-Oct-2009] $) $( [17-Sep-2009] $)

  ${
    obsubc2.1 $e |- O1 = dom ( id_ ` T ) $.
    obsubc2.2 $e |- O2 = dom ( id_ ` U ) $.
    $( The objects of a subcategory are a subset of those of the
       supercategory. JFM CAT_2 th. 11 . $)
    obsubc2 $p |- ( U e. ( SubCat ` T ) -> O2 C_ O1 ) $=
      cT ccat wcel cU cT csubc cfv wcel co2 co1 wss cT cU besubbeca cT ccat
      wcel cU cT csubc cfv wcel wa cU cid_ cfv cdm cT cid_ cfv cdm co2 co1 cT
      ccat wcel cU cT csubc cfv wcel cU cid_ cfv cdm cT cid_ cfv cdm wss cT
      ccat wcel cU cT csubc cfv wcel cU ccat wcel cU cid_ cfv cT cid_ cfv wss
      cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv
      cT co_ cfv wss w3a wa cU cid_ cfv cdm cT cid_ cfv cdm wss cT ccod_ cfv cT
      cdom_ cfv cT co_ cfv cT cU cT cid_ cfv cT cdom_ cfv eqid cT ccod_ cfv
      eqid cT co_ cfv eqid cT cid_ cfv eqid issubcata cU cid_ cfv cT cid_ cfv
      wss cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_
      cfv cT co_ cfv wss w3a cU cid_ cfv cdm cT cid_ cfv cdm wss cU ccat wcel
      cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT
      ccod_ cfv wss wa cU cid_ cfv cdm cT cid_ cfv cdm wss cU co_ cfv cT co_
      cfv wss cU cid_ cfv cT cid_ cfv dmss 3ad2ant1 adantl syl6bi imp obsubc2.2
      obsubc2.1 3sstr4g mpancom $.
      $( [6-Oct-2009] $) $( [17-Sep-2009] $)
  $}

  ${
    idsubc.1 $e |- I1 = ( id_ ` T ) $.
    idsubc.2 $e |- I2 = ( id_ ` U ) $.
    $( The identity function of a subcategory is a subset of the
       identity function of the supercategory. $)
    idsubc $p |- ( U e. ( SubCat ` T ) -> I2 C_ I1 ) $=
      cT ccat wcel cU cT csubc cfv wcel ci2 ci1 wss cT cU besubbeca cT ccat
      wcel cU cT csubc cfv wcel wa cU cid_ cfv cT cid_ cfv ci2 ci1 cT ccat wcel
      cU cT csubc cfv wcel cU cid_ cfv cT cid_ cfv wss cT ccat wcel cU cT csubc
      cfv wcel cU ccat wcel cU cid_ cfv ci1 wss cU cdom_ cfv cT cdom_ cfv wss
      cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a wa cU cid_
      cfv cT cid_ cfv wss cT ccod_ cfv cT cdom_ cfv cT co_ cfv cT cU ci1 cT
      cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid idsubc.1 issubcata cU
      cid_ cfv ci1 wss cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv
      wss wa cU co_ cfv cT co_ cfv wss w3a cU cid_ cfv cT cid_ cfv wss cU ccat
      wcel cU cid_ cfv ci1 wss cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT
      ccod_ cfv wss wa cU cid_ cfv cT cid_ cfv wss cU co_ cfv cT co_ cfv wss cU
      cid_ cfv ci1 wss cU cid_ cfv cT cid_ cfv wss ci1 cT cid_ cfv cU cid_ cfv
      idsubc.1 sseq2i biimpi 3ad2ant1 adantl syl6bi imp idsubc.2 idsubc.1
      3sstr4g mpancom $.
      $( [6-Oct-2009] $) $( [17-Sep-2009] $)
  $}

  ${
    domsubc.1 $e |- D1 = ( dom_ ` T ) $.
    domsubc.2 $e |- D2 = ( dom_ ` U ) $.
    $( The domain function of a subcategory is a subset of the
       domain function of the supercategory. $)
    domsubc $p |- ( U e. ( SubCat ` T ) -> D2 C_ D1 ) $=
      cT ccat wcel cU cT csubc cfv wcel cd2 cd1 wss cT cU besubbeca cT ccat
      wcel cU cT csubc cfv wcel wa cU cdom_ cfv cT cdom_ cfv cd2 cd1 cT ccat
      wcel cU cT csubc cfv wcel cU cdom_ cfv cT cdom_ cfv wss cT ccat wcel cU
      cT csubc cfv wcel cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv
      cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv
      wss w3a wa cU cdom_ cfv cT cdom_ cfv wss cT ccod_ cfv cT cdom_ cfv cT co_
      cfv cT cU cT cid_ cfv cT cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid
      cT cid_ cfv eqid issubcata cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU
      cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU cdom_ cfv
      cT cdom_ cfv wss cU co_ cfv cT co_ cfv wss cU ccat wcel cU cdom_ cfv cT
      cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss simprl 3ad2antr2 syl6bi imp
      domsubc.2 domsubc.1 3sstr4g mpancom $.
      $( [6-Oct-2009] $) $( [19-Sep-2009] $)
  $}

  ${
    codsubc.1 $e |- C1 = ( cod_ ` T ) $.
    codsubc.2 $e |- C2 = ( cod_ ` U ) $.
    $( The codomain function of a subcategory is a subset of the
       codomain function of the supercategory. $)
    codsubc $p |- ( U e. ( SubCat ` T ) -> C2 C_ C1 ) $=
      cT ccat wcel cU cT csubc cfv wcel cc2 cc1 wss cT cU besubbeca cT ccat
      wcel cU cT csubc cfv wcel wa cU ccod_ cfv cT ccod_ cfv cc2 cc1 cT ccat
      wcel cU cT csubc cfv wcel cU ccod_ cfv cT ccod_ cfv wss cT ccat wcel cU
      cT csubc cfv wcel cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv
      cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv
      wss w3a wa cU ccod_ cfv cT ccod_ cfv wss cT ccod_ cfv cT cdom_ cfv cT co_
      cfv cT cU cT cid_ cfv cT cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid
      cT cid_ cfv eqid issubcata cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU
      cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU ccod_ cfv
      cT ccod_ cfv wss cU co_ cfv cT co_ cfv wss cU ccat wcel cU cdom_ cfv cT
      cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss simprr 3ad2antr2 syl6bi imp
      codsubc.2 codsubc.1 3sstr4g mpancom $.
      $( [6-Oct-2009] $) $( [19-Sep-2009] $)
  $}


  $( A subcategory is a category. $)
  subctct $p |- ( U e. ( SubCat ` T ) -> U e. Cat ) $=
    cT ccat wcel cU cT csubc cfv wcel cU ccat wcel cT cU besubbeca cT ccat wcel
    cU cT csubc cfv wcel cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv
    cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss
    w3a wa cU ccat wcel cT ccod_ cfv cT cdom_ cfv cT co_ cfv cT cU cT cid_ cfv
    cT cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid cT cid_ cfv eqid
    issubcata cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_
    cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a
    pm3.26 syl6bi mpcom $.
    $( [6-Oct-2009] $) $( [17-Sep-2009] $)

  ${
    morsubc.1 $e |- M1 = dom ( dom_ ` T ) $.
    morsubc.2 $e |- M2 = dom ( dom_ ` U ) $.
    $( The morphisms of a subcategory are a subset of those of the
    supercategory. $)


    morsubc $p |- ( U e. ( SubCat ` T ) -> M2 C_ M1 ) $=
      cU cT csubc cfv wcel cm2 cm1 wss cU cT csubc cfv wcel cU cT csubc cfv
      wcel cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_ cfv
      wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a wa cm2
      cm1 wss cU cT csubc cfv wcel cT ccat wcel cU cT csubc cfv wcel cU ccat
      wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_ cfv wss cU ccod_
      cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a wa wb cT cU
      besubbeca cT ccod_ cfv cT cdom_ cfv cT co_ cfv cT cU cT cid_ cfv cT cdom_
      cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid cT cid_ cfv eqid issubcata syl
      cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT
      ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a cm2 cm1 wss cU ccat wcel
      cU cdom_ cfv cT cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU cid_
      cfv cT cid_ cfv wss cm2 cm1 wss cU co_ cfv cT co_ cfv wss cU cdom_ cfv cT
      cdom_ cfv wss cm2 cm1 wss cU ccod_ cfv cT ccod_ cfv wss cU cdom_ cfv cT
      cdom_ cfv wss cU cdom_ cfv cdm cT cdom_ cfv cdm cm2 cm1 cU cdom_ cfv cT
      cdom_ cfv dmss morsubc.2 morsubc.1 3sstr4g adantr 3ad2ant2 adantl syl6bi
      pm2.43i $.
      $( [6-Oct-2009] $) $( [18-Sep-2009] $)
  $}

  ${
    cmpsubc.1 $e |- Ro1 = ( o_ ` T ) $.
    cmpsubc.2 $e |- Ro2 = ( o_ ` U ) $.
    $( The composition law of a subcategory is a subset of the composition
       law of the supercategory. $)
    cmpsubc $p |- ( U e. ( SubCat ` T ) -> Ro2 C_ Ro1 ) $=
      cT ccat wcel cU cT csubc cfv wcel cro2 cro1 wss cT cU besubbeca cT ccat
      wcel cU cT csubc cfv wcel wa cU co_ cfv cT co_ cfv cro2 cro1 cT ccat wcel
      cU cT csubc cfv wcel cU co_ cfv cT co_ cfv wss cT ccat wcel cU cT csubc
      cfv wcel cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_
      cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a wa
      cU co_ cfv cT co_ cfv wss cT ccod_ cfv cT cdom_ cfv cT co_ cfv cT cU cT
      cid_ cfv cT cdom_ cfv eqid cT ccod_ cfv eqid cT co_ cfv eqid cT cid_ cfv
      eqid issubcata cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT cdom_ cfv wss
      cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss w3a cU co_ cfv
      cT co_ cfv wss cU ccat wcel cU cid_ cfv cT cid_ cfv wss cU cdom_ cfv cT
      cdom_ cfv wss cU ccod_ cfv cT ccod_ cfv wss wa cU co_ cfv cT co_ cfv wss
      3simp3 adantl syl6bi imp cmpsubc.2 cmpsubc.1 3sstr4g mpancom $.
      $( [6-Oct-2009] $) $( [20-Sep-2009] $)
  $}

  ${ $d T x $. $d U x $.
    idsubidsup.1 $e |- I1 = ( id_ ` T ) $.
    idsubidsup.2 $e |- I2 = ( id_ ` U ) $.
    idsubidsup.3 $e |- O2 = dom ( id_ ` U ) $.
    $( The identity of an an objet of the subcategory equals
       the identity of the object in the supercategory. $)
    idsubidsup $p |- ( U e. ( SubCat ` T ) ->
      A. x e. O2 ( I2 ` x ) = ( I1 ` x ) ) $=
      cU cT csubc cfv wcel vx cv ci2 cfv vx cv ci1 cfv wceq vx co2 ci1 wfun ci2
      ci1 wss vx cv ci2 cdm wcel vx cv ci2 cfv vx cv ci1 cfv wceq cU cT csubc
      cfv wcel vx cv co2 wcel wa ci1 wfun ci2 ci1 wss vx cv ci2 cdm wcel w3a vx
      cv ci1 cfv vx cv ci2 cfv vx cv ci1 ci2 funssfv eqcomd cU cT csubc cfv
      wcel ci1 wfun vx cv co2 wcel cU cT csubc cfv wcel cT ccat wcel cT calg
      wcel ci1 wfun cT cU besubbeca cT ccat wcel cT cded wcel cT calg wcel cT
      catded cT dedalg syl cT calg wcel ci1 cdm cT cdom_ cfv cdm ci1 wf ci1
      wfun cT cdom_ cfv cT ci1 cT cdom_ cfv cdm ci1 cdm cT cdom_ cfv cdm eqid
      cT cdom_ cfv eqid ci1 cdm eqid idsubidsup.1 ida ci1 cdm cT cdom_ cfv cdm
      ci1 ffun syl 3syl adantr cU cT csubc cfv wcel ci2 ci1 wss vx cv co2 wcel
      cT cU ci1 ci2 idsubidsup.1 idsubidsup.2 idsubc adantr vx cv co2 wcel vx
      cv ci2 cdm wcel cU cT csubc cfv wcel vx cv co2 wcel vx cv ci2 cdm wcel
      co2 ci2 cdm vx cv co2 cU cid_ cfv cdm ci2 cdm idsubidsup.3 cU cid_ cfv
      ci2 ci2 cU cid_ cfv idsubidsup.2 eqcomi dmeqi eqtri eleq2i biimpi adantl
      syl3anc r19.21aiva $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

  ${ $d M m n o p $. $d T m n o p $. $d U m n o p $.
    idsubfun.1 $e |- M = dom ( dom_ ` U ) $.
    $( The identity restricted to the morphism of a subcategory ` U ` is
       a functor from the subcategory to the supercategory. It is called the
       inclusion functor. JFM CAT_2 th. 19. $)
    idsubfun $p |- ( U e. ( SubCat ` T ) ->
      ( _I |` M ) e. ( Func ` <. U , T >. ) ) $=
      cU cT csubc cfv wcel cT ccat wcel cU ccat wcel cid cM cres cU cT cop
      cfunc cfv wcel cT cU besubbeca cT cU subctct cU cT csubc cfv wcel cid cM
      cres cvv wcel cT ccat wcel cU ccat wcel wa cid cM cres cU cT cop cfunc
      cfv wcel wi cU cT csubc cfv wcel cM cvv wcel cid cM cres cvv wcel cU cT
      csubc cfv wcel cU cdom_ cfv cdm cvv cM cU cT csubc cfv wcel cU cdom_ cfv
      cvv wcel cU cdom_ cfv cdm cvv wcel cU cdom_ cfv cvv wcel cU cT csubc cfv
      wcel cU cdom_ fvex a1i cU cdom_ cfv cvv dmexg syl idsubfun.1 syl5eqel cM
      cvv resiexg syl cT ccat wcel cU ccat wcel wa cid cM cres cvv wcel cU cT
      csubc cfv wcel cid cM cres cU cT cop cfunc cfv wcel cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel cU cT csubc cfv wcel cid cM cres cU cT cop
      cfunc cfv wcel wi wi cU ccat wcel cT ccat wcel cid cM cres cvv wcel cU cT
      csubc cfv wcel cid cM cres cU cT cop cfunc cfv wcel cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa cid cM cres cU cT
      cop cfunc cfv wcel cM cT cdom_ cfv cdm cid cM cres wf vo cv cU cid_ cfv
      cfv cid cM cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex vo
      cU cid_ cfv cdm wral vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cM cres
      cfv vm cv cid cM cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cM
      wral vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM
      cres cfv cT ccod_ cfv cfv cT cid_ cfv cfv wceq vm cM wral wa vn cv cU
      ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq vm cv vn cv cU co_ cfv co cid
      cM cres cfv vm cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co
      wceq wi vn cM wral vm cM wral w3a wa cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa cM cT cdom_ cfv cdm cid cM cres
      wf vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv wceq vp cT
      cid_ cfv cdm wrex vo cU cid_ cfv cdm wral vm cv cU cdom_ cfv cfv cU cid_
      cfv cfv cid cM cres cfv vm cv cid cM cres cfv cT cdom_ cfv cfv cT cid_
      cfv cfv wceq vm cM wral vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cid cM
      cres cfv vm cv cid cM cres cfv cT ccod_ cfv cfv cT cid_ cfv cfv wceq vm
      cM wral wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq vm cv vn cv
      cU co_ cfv co cid cM cres cfv vm cv cid cM cres cfv vn cv cid cM cres cfv
      cT co_ cfv co wceq wi vn cM wral vm cM wral w3a cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa cM cM cid cM cres wf cM
      cT cdom_ cfv cdm wss wa cM cT cdom_ cfv cdm cid cM cres wf cU ccat wcel
      cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa cM cT cdom_
      cfv cdm wss cM cM cid cM cres wf cU cT csubc cfv wcel cM cT cdom_ cfv cdm
      wss cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cT cU cT cdom_ cfv
      cdm cM cT cdom_ cfv cdm eqid idsubfun.1 morsubc adantl cM cM cid cM cres
      wf1o cM cM cid cM cres wf cM f1oi cM cM cid cM cres f1of ax-mp jctil cM
      cM cT cdom_ cfv cdm cid cM cres fss syl cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa vo cv cU cid_ cfv cfv cid cM
      cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex vo cU cid_
      cfv cdm wral vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv
      cid cM cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cM wral vm cv cU
      ccod_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM cres cfv cT
      ccod_ cfv cfv cT cid_ cfv cfv wceq vm cM wral wa vn cv cU ccod_ cfv cfv
      vm cv cU cdom_ cfv cfv wceq vm cv vn cv cU co_ cfv co cid cM cres cfv vm
      cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co wceq wi vn cM wral
      vm cM wral cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc
      cfv wcel wa vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv
      wceq vp cT cid_ cfv cdm wrex vo cU cid_ cfv cdm cU cT csubc cfv wcel cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv cU cid_ cfv cdm
      wcel vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv wceq vp
      cT cid_ cfv cdm wrex wi cU cid_ cfv cdm cT cid_ cfv cdm wss cU cT csubc
      cfv wcel cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv cU cid_
      cfv cdm wcel vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv
      wceq vp cT cid_ cfv cdm wrex wi wi cT cU cT cid_ cfv cdm cU cid_ cfv cdm
      cT cid_ cfv cdm eqid cU cid_ cfv cdm eqid obsubc2 vo cv cU cid_ cfv cdm
      wcel cU cid_ cfv cdm cT cid_ cfv cdm wss cU cT csubc cfv wcel cU ccat
      wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv cU cid_ cfv cfv cid cM
      cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex vo cv cU cid_
      cfv cdm wcel cU cid_ cfv cdm cT cid_ cfv cdm wss cU cT csubc cfv wcel cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv cU cid_ cfv cfv cid
      cM cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex wi wi wi
      cU cid_ cfv cdm cT cid_ cfv cdm wss vo cv cU cid_ cfv cdm wcel vo cv cU
      cid_ cfv cdm wcel cU cT csubc cfv wcel cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv
      cfv wceq vp cT cid_ cfv cdm wrex wi wi cU cid_ cfv cdm cT cid_ cfv cdm
      wss vo cv cU cid_ cfv cdm wcel vo cv cT cid_ cfv cdm wcel vo cv cU cid_
      cfv cdm wcel cU cT csubc cfv wcel cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv
      wceq vp cT cid_ cfv cdm wrex wi wi wi cU cid_ cfv cdm cT cid_ cfv cdm vo
      cv ssel cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv cU cid_
      cfv cdm wcel cU cT csubc cfv wcel vo cv cT cid_ cfv cdm wcel vo cv cU
      cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv
      cdm wrex cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv cU cid_
      cfv cdm wcel cU cT csubc cfv wcel vo cv cT cid_ cfv cdm wcel vo cv cU
      cid_ cfv cfv cid cM cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv
      cdm wrex wi vo cv cT cid_ cfv cdm wcel vo cv cU cid_ cfv cfv cid cM cres
      cfv vo cv cT cid_ cfv cfv wceq vo cv cU cid_ cfv cfv cid cM cres cfv vp
      cv cT cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a vo cv cU cid_ cfv cdm wcel cU cT csubc cfv wcel
      w3a vo cv cT cid_ cfv cdm wcel vo cv cU cid_ cfv cfv cid cM cres cfv vo
      cv cT cid_ cfv cfv wceq vo cv cU cid_ cfv cfv cid cM cres cfv vp cv cT
      cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex vo cv cU cid_ cfv cfv cid cM
      cres cfv vp cv cT cid_ cfv cfv wceq vo cv cU cid_ cfv cfv cid cM cres cfv
      vo cv cT cid_ cfv cfv wceq vp vo cv cT cid_ cfv cdm vp vo weq vp cv cT
      cid_ cfv cfv vo cv cT cid_ cfv cfv vo cv cU cid_ cfv cfv cid cM cres cfv
      vp cv vo cv cT cid_ cfv fveq2 eqeq2d rcla4ev ex cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a vo cv cU cid_ cfv cdm wcel cU cT csubc cfv wcel
      w3a vo cv cU cid_ cfv cfv cid cfv vo cv cU cid_ cfv cfv vo cv cU cid_ cfv
      cfv cid cM cres cfv vo cv cT cid_ cfv cfv vo cv cU cid_ cfv cfv cvv wcel
      vo cv cU cid_ cfv cfv cid cfv vo cv cU cid_ cfv cfv wceq vo cv cU cid_
      cfv fvex vo cv cU cid_ cfv cfv cvv fvi ax-mp cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a vo cv cU cid_ cfv cdm wcel cU cT csubc cfv wcel
      w3a vo cv cU cid_ cfv cfv cM wcel vo cv cU cid_ cfv cfv cid cM cres cfv
      vo cv cU cid_ cfv cfv cid cfv wceq cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a vo cv cU cid_ cfv cdm wcel cU cT csubc cfv wcel vo cv cU
      cid_ cfv cfv cM wcel cU ccat wcel cT ccat wcel vo cv cU cid_ cfv cdm wcel
      cU cT csubc cfv wcel vo cv cU cid_ cfv cfv cM wcel wi wi cid cM cres cvv
      wcel cU ccat wcel vo cv cU cid_ cfv cdm wcel vo cv cU cid_ cfv cfv cM
      wcel cU cT csubc cfv wcel cU ccat wcel vo cv cU cid_ cfv cdm wcel vo cv
      cU cid_ cfv cfv cM wcel vo cv cU cU cid_ cfv cM cU cid_ cfv cdm
      idsubfun.1 cU cid_ cfv cdm eqid cU cid_ cfv eqid jdmo ex a1dd 3ad2ant1
      3imp vo cv cU cid_ cfv cfv cM cid fvres syl cT cid_ cfv wfun cU cid_ cfv
      cT cid_ cfv wss vo cv cU cid_ cfv cdm wcel vo cv cT cid_ cfv cfv vo cv cU
      cid_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo
      cv cU cid_ cfv cdm wcel cU cT csubc cfv wcel w3a vo cv cT cid_ cfv cU
      cid_ cfv funssfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vo cv
      cU cid_ cfv cdm wcel cT cid_ cfv wfun cU cT csubc cfv wcel cT ccat wcel
      cU ccat wcel cT cid_ cfv wfun cid cM cres cvv wcel cT ccat wcel cT cid_
      cfv cdm cT cdom_ cfv cdm cT cid_ cfv wf cT cid_ cfv wfun cT cdom_ cfv cT
      cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid cT
      cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid idc cT cid_ cfv cdm
      cT cdom_ cfv cdm cT cid_ cfv ffun syl 3ad2ant2 3ad2ant1 cU cT csubc cfv
      wcel cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cid_ cfv cT
      cid_ cfv wss vo cv cU cid_ cfv cdm wcel cT cU cT cid_ cfv cU cid_ cfv cT
      cid_ cfv eqid cU cid_ cfv eqid idsubc 3ad2ant3 cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a vo cv cU cid_ cfv cdm wcel cU cT csubc cfv wcel
      3simp2 syl3anc 3eqtr4a syl5com 3exp com14 syl6 com13 pm2.43i com4l mpcom
      impcom r19.21aiv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cM cres cfv
      vm cv cid cM cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cM wral vm
      cv cU ccod_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM cres cfv
      cT ccod_ cfv cfv cT cid_ cfv cfv wceq vm cM wral cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cU cdom_ cfv
      cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM cres cfv cT cdom_ cfv
      cfv cT cid_ cfv cfv wceq vm cM cU ccat wcel cT ccat wcel cid cM cres cvv
      wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vm cv cU cdom_ cfv cfv cU
      cid_ cfv cfv cid cM cres cfv vm cv cid cM cres cfv cT cdom_ cfv cfv cT
      cid_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU
      cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv cfv cU cid_ cfv
      cfv cid cM cres cfv vm cv cU cdom_ cfv cfv cU cid_ cfv cfv vm cv cT cdom_
      cfv cfv cT cid_ cfv cfv vm cv cid cM cres cfv cT cdom_ cfv cfv cT cid_
      cfv cfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc
      cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid
      cM cres cfv vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cfv vm cv cU cdom_
      cfv cfv cU cid_ cfv cfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel
      w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv cfv cU
      cid_ cfv cfv cM wcel vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cM cres
      cfv vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cfv wceq cU ccat wcel vm
      cv cU cdom_ cfv cfv cU cid_ cfv cdm wcel vm cv cU cdom_ cfv cfv cU cid_
      cfv cfv cM wcel cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv cfv cU cU cid_ cfv
      cM cU cid_ cfv cdm idsubfun.1 cU cid_ cfv cdm eqid cU cid_ cfv eqid jdmo
      cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU ccat wcel cU cT
      csubc cfv wcel vm cv cM wcel cU ccat wcel cT ccat wcel cid cM cres cvv
      wcel 3simp1 ad2antrr cU ccat wcel vm cv cU cdom_ cfv cdm wcel vm cv cU
      cdom_ cfv cfv cU cid_ cfv cdm wcel cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel cU cdom_ cfv cU vm cv
      cU cdom_ cfv cdm cU cid_ cfv cdm cU cdom_ cfv cdm eqid cU cid_ cfv cdm
      eqid cU cdom_ cfv eqid dmo cU ccat wcel cT ccat wcel cid cM cres cvv wcel
      w3a cU ccat wcel cU cT csubc cfv wcel cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel 3simp1 adantr vm cv cM wcel vm cv cU cdom_ cfv cdm wcel cM
      cU cdom_ cfv cdm vm cv idsubfun.1 eleq2i biimpi syl2an sylanc vm cv cU
      cdom_ cfv cfv cU cid_ cfv cfv cM cid fvres syl cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv
      cU cdom_ cfv cfv cU cid_ cfv cfv cvv wcel vm cv cU cdom_ cfv cfv cU cid_
      cfv cfv cid cfv vm cv cU cdom_ cfv cfv cU cid_ cfv cfv wceq vm cv cU
      cdom_ cfv cfv cU cid_ cfv cfv cvv wcel cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU cdom_
      cfv cfv cU cid_ cfv fvex a1i vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cvv
      fvi syl eqtrd cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv cfv cT cid_ cfv cfv
      vm cv cU cdom_ cfv cfv cU cid_ cfv cfv vm cv cT cdom_ cfv cfv cT cid_ cfv
      cfv cT cid_ cfv wfun cU cid_ cfv cT cid_ cfv wss vm cv cU cdom_ cfv cfv
      cU cid_ cfv cdm wcel vm cv cU cdom_ cfv cfv cT cid_ cfv cfv vm cv cU
      cdom_ cfv cfv cU cid_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv
      cfv cT cid_ cfv cU cid_ cfv funssfv cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cT cid_ cfv wfun cU cT csubc cfv wcel vm cv cM wcel cT ccat
      wcel cU ccat wcel cT cid_ cfv wfun cid cM cres cvv wcel cT ccat wcel cT
      cid_ cfv cdm cT cdom_ cfv cdm cT cid_ cfv wf cT cid_ cfv wfun cT cdom_
      cfv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid
      cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid idc cT cid_ cfv
      cdm cT cdom_ cfv cdm cT cid_ cfv ffun syl 3ad2ant2 ad2antrr cU cT csubc
      cfv wcel cU cid_ cfv cT cid_ cfv wss cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a vm cv cM wcel cT cU cT cid_ cfv cU cid_ cfv cT cid_ cfv
      eqid cU cid_ cfv eqid idsubc ad2antlr cU ccat wcel vm cv cU cdom_ cfv cdm
      wcel vm cv cU cdom_ cfv cfv cU cid_ cfv cdm wcel cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel cU
      cdom_ cfv cU vm cv cU cdom_ cfv cdm cU cid_ cfv cdm cU cdom_ cfv cdm eqid
      cU cid_ cfv cdm eqid cU cdom_ cfv eqid dmo cU ccat wcel cT ccat wcel cid
      cM cres cvv wcel w3a cU ccat wcel cU cT csubc cfv wcel cU ccat wcel cT
      ccat wcel cid cM cres cvv wcel 3simp1 adantr vm cv cM wcel vm cv cU cdom_
      cfv cdm wcel cM cU cdom_ cfv cdm vm cv idsubfun.1 eleq2i biimpi syl2an
      syl3anc cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc
      cfv wcel wa vm cv cM wcel wa vm cv cU cdom_ cfv cfv vm cv cT cdom_ cfv
      cfv cT cid_ cfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM wcel wa vm cv cT cdom_ cfv cfv vm cv cU cdom_
      cfv cfv cT cdom_ cfv wfun cU cdom_ cfv cT cdom_ cfv wss vm cv cU cdom_
      cfv cdm wcel vm cv cT cdom_ cfv cfv vm cv cU cdom_ cfv cfv wceq cU ccat
      wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv
      cM wcel wa vm cv cT cdom_ cfv cU cdom_ cfv funssfv cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cT cdom_ cfv wfun cU cT csubc cfv wcel vm
      cv cM wcel cT ccat wcel cU ccat wcel cT cdom_ cfv wfun cid cM cres cvv
      wcel cT ccat wcel cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv wf cT
      cdom_ cfv wfun cT cdom_ cfv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_ cfv
      cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT cid_
      cfv eqid domc cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv ffun syl
      3ad2ant2 ad2antrr cU cT csubc cfv wcel cU cdom_ cfv cT cdom_ cfv wss cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vm cv cM wcel cT cU cT
      cdom_ cfv cU cdom_ cfv cT cdom_ cfv eqid cU cdom_ cfv eqid domsubc
      ad2antlr vm cv cM wcel vm cv cU cdom_ cfv cdm wcel cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vm cv
      cU cdom_ cfv cdm wcel cM cU cdom_ cfv cdm vm cv idsubfun.1 eleq2i biimpi
      adantl syl3anc eqcomd fveq2d eqtr3d cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cT cdom_ cfv
      cfv vm cv cid cM cres cfv cT cdom_ cfv cfv cT cid_ cfv cU ccat wcel cT
      ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel
      wa vm cv vm cv cid cM cres cfv cT cdom_ cfv cU ccat wcel cT ccat wcel cid
      cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cid
      cM cres cfv vm cv cid cfv vm cv vm cv cM wcel vm cv cid cM cres cfv vm cv
      cid cfv wceq cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM cid fvres adantl vm cv cM wcel vm cv cid cfv
      vm cv wceq cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc
      cfv wcel wa vm cv cM fvi adantl eqtr2d fveq2d fveq2d 3eqtrd ex r19.21aiv
      cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel
      wa vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM
      cres cfv cT ccod_ cfv cfv cT cid_ cfv cfv wceq vm cM cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vm cv
      cU ccod_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM cres cfv cT
      ccod_ cfv cfv cT cid_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU ccod_ cfv
      cfv cU cid_ cfv cfv cid cM cres cfv vm cv cU ccod_ cfv cfv cU cid_ cfv
      cfv vm cv cT ccod_ cfv cfv cT cid_ cfv cfv vm cv cid cM cres cfv cT ccod_
      cfv cfv cT cid_ cfv cfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel
      w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU ccod_ cfv cfv cU
      cid_ cfv cfv cid cM cres cfv vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cid
      cfv vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cU ccat wcel cT ccat wcel cid
      cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU
      ccod_ cfv cfv cU cid_ cfv cfv cM wcel vm cv cU ccod_ cfv cfv cU cid_ cfv
      cfv cid cM cres cfv vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cid cfv wceq
      cU ccat wcel vm cv cU ccod_ cfv cfv cU cid_ cfv cdm wcel vm cv cU ccod_
      cfv cfv cU cid_ cfv cfv cM wcel cU ccat wcel cT ccat wcel cid cM cres cvv
      wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU ccod_ cfv cfv
      cU cU cid_ cfv cM cU cid_ cfv cdm idsubfun.1 cU cid_ cfv cdm eqid cU cid_
      cfv eqid jdmo cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU ccat
      wcel cU cT csubc cfv wcel vm cv cM wcel cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel 3simp1 ad2antrr cU ccat wcel vm cv cM wcel vm cv cU ccod_
      cfv cfv cU cid_ cfv cdm wcel cU ccat wcel cT ccat wcel cid cM cres cvv
      wcel w3a cU cT csubc cfv wcel wa cU ccod_ cfv cU vm cv cM cU cid_ cfv cdm
      idsubfun.1 cU cid_ cfv cdm eqid cU ccod_ cfv eqid cdmo cU ccat wcel cT
      ccat wcel cid cM cres cvv wcel w3a cU ccat wcel cU cT csubc cfv wcel cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel 3simp1 adantr sylan sylanc vm
      cv cU ccod_ cfv cfv cU cid_ cfv cfv cM cid fvres syl cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm
      cv cU ccod_ cfv cfv cU cid_ cfv cfv cvv wcel vm cv cU ccod_ cfv cfv cU
      cid_ cfv cfv cid cfv vm cv cU ccod_ cfv cfv cU cid_ cfv cfv wceq vm cv cU
      ccod_ cfv cfv cU cid_ cfv cfv cvv wcel cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU ccod_
      cfv cfv cU cid_ cfv fvex a1i vm cv cU ccod_ cfv cfv cU cid_ cfv cfv cvv
      fvi syl eqtrd cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM wcel wa vm cv cU ccod_ cfv cfv cU cid_ cfv cfv
      vm cv cU ccod_ cfv cfv cT cid_ cfv cfv vm cv cT ccod_ cfv cfv cT cid_ cfv
      cfv cT cid_ cfv wfun cU cid_ cfv cT cid_ cfv wss vm cv cU ccod_ cfv cfv
      cU cid_ cfv cdm wcel vm cv cU ccod_ cfv cfv cU cid_ cfv cfv vm cv cU
      ccod_ cfv cfv cT cid_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa cT cid_ cfv wfun cU
      cid_ cfv cT cid_ cfv wss vm cv cU ccod_ cfv cfv cU cid_ cfv cdm wcel w3a
      vm cv cU ccod_ cfv cfv cT cid_ cfv cfv vm cv cU ccod_ cfv cfv cU cid_ cfv
      cfv vm cv cU ccod_ cfv cfv cT cid_ cfv cU cid_ cfv funssfv eqcomd cU ccat
      wcel cT ccat wcel cid cM cres cvv wcel w3a cT cid_ cfv wfun cU cT csubc
      cfv wcel vm cv cM wcel cT ccat wcel cU ccat wcel cT cid_ cfv wfun cid cM
      cres cvv wcel cT ccat wcel cT cid_ cfv cdm cT cdom_ cfv cdm cT cid_ cfv
      wf cT cid_ cfv wfun cT cdom_ cfv cT cT cid_ cfv cT cdom_ cfv cdm cT cid_
      cfv cdm cT cdom_ cfv cdm eqid cT cdom_ cfv eqid cT cid_ cfv cdm eqid cT
      cid_ cfv eqid idc cT cid_ cfv cdm cT cdom_ cfv cdm cT cid_ cfv ffun syl
      3ad2ant2 ad2antrr cU cT csubc cfv wcel cU cid_ cfv cT cid_ cfv wss cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a vm cv cM wcel cT cU cT
      cid_ cfv cU cid_ cfv cT cid_ cfv eqid cU cid_ cfv eqid idsubc ad2antlr cU
      ccat wcel vm cv cM wcel vm cv cU ccod_ cfv cfv cU cid_ cfv cdm wcel cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa
      cU ccod_ cfv cU vm cv cM cU cid_ cfv cdm idsubfun.1 cU cid_ cfv cdm eqid
      cU ccod_ cfv eqid cdmo cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a
      cU ccat wcel cU cT csubc cfv wcel cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel 3simp1 adantr sylan syl3anc cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cU ccod_
      cfv cfv vm cv cT ccod_ cfv cfv cT cid_ cfv cU ccat wcel cT ccat wcel cid
      cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv cT
      ccod_ cfv cfv vm cv cU ccod_ cfv cfv cT ccod_ cfv wfun cU ccod_ cfv cT
      ccod_ cfv wss vm cv cU ccod_ cfv cdm wcel vm cv cT ccod_ cfv cfv vm cv cU
      ccod_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU
      cT csubc cfv wcel wa vm cv cM wcel wa vm cv cT ccod_ cfv cU ccod_ cfv
      funssfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cT ccod_ cfv
      wfun cU cT csubc cfv wcel vm cv cM wcel cT ccat wcel cU ccat wcel cT
      ccod_ cfv wfun cid cM cres cvv wcel cT ccat wcel cT cdom_ cfv cdm cT cid_
      cfv cdm cT ccod_ cfv wf cT ccod_ cfv wfun cT ccod_ cfv cT cdom_ cfv cT cT
      cid_ cfv cT cdom_ cfv cdm cT cid_ cfv cdm cT cdom_ cfv cdm eqid cT cdom_
      cfv eqid cT cid_ cfv cdm eqid cT cid_ cfv eqid cT ccod_ cfv eqid codc cT
      cdom_ cfv cdm cT cid_ cfv cdm cT ccod_ cfv ffun syl 3ad2ant2 ad2antrr cU
      cT csubc cfv wcel cU ccod_ cfv cT ccod_ cfv wss cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a vm cv cM wcel cT cU cT ccod_ cfv cU ccod_ cfv cT
      ccod_ cfv eqid cU ccod_ cfv eqid codsubc ad2antlr cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vm cv
      cU ccod_ cfv cdm wcel cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a
      cU cT csubc cfv wcel wa cM cU ccod_ cfv cdm vm cv cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cM cU ccod_ cfv cdm wceq cU cT csubc cfv
      wcel cU ccat wcel cT ccat wcel cM cU ccod_ cfv cdm wceq cid cM cres cvv
      wcel cU ccat wcel cU cdom_ cfv cdm cU ccod_ cfv cdm cM cU morcat
      idsubfun.1 syl5eq 3ad2ant1 adantr eleq2d biimpa syl3anc eqcomd fveq2d
      eqtrd cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv
      wcel wa vm cv cM wcel wa vm cv cT ccod_ cfv cfv vm cv cid cM cres cfv cT
      ccod_ cfv cfv cT cid_ cfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel
      w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vm cv vm cv cid cM cres cfv
      cT ccod_ cfv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM wcel wa vm cv cid cM cres cfv vm cv cid cfv vm
      cv vm cv cM wcel vm cv cid cM cres cfv vm cv cid cfv wceq cU ccat wcel cT
      ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM cid
      fvres adantl vm cv cM wcel vm cv cid cfv vm cv wceq cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM fvi adantl
      eqtr2d fveq2d fveq2d 3eqtrd ex r19.21aiv jca cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vn cv cU ccod_ cfv cfv
      vm cv cU cdom_ cfv cfv wceq vm cv vn cv cU co_ cfv co cid cM cres cfv vm
      cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co wceq wi vn cM wral
      vm cM cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv
      wcel wa vm cv cM wcel vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq
      vm cv vn cv cU co_ cfv co cid cM cres cfv vm cv cid cM cres cfv vn cv cid
      cM cres cfv cT co_ cfv co wceq wi vn cM wral cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv
      cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq vm cv vn cv cU co_ cfv co
      cid cM cres cfv vm cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co
      wceq wi vn cM cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT
      csubc cfv wcel wa vm cv cM wcel wa vn cv cM wcel vn cv cU ccod_ cfv cfv
      vm cv cU cdom_ cfv cfv wceq vm cv vn cv cU co_ cfv co cid cM cres cfv vm
      cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co wceq cU ccat wcel
      cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM
      wcel wa vn cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv
      wceq wa vm cv vn cv cU co_ cfv co cid cM cres cfv vm cv vn cv cU co_ cfv
      co cid cfv vm cv vn cv cU co_ cfv co vm cv cid cM cres cfv vn cv cid cM
      cres cfv cT co_ cfv co cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a
      cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv cM wcel wa vn cv cU ccod_
      cfv cfv vm cv cU cdom_ cfv cfv wceq wa vm cv vn cv cU co_ cfv co cM wcel
      vm cv vn cv cU co_ cfv co cid cM cres cfv vm cv vn cv cU co_ cfv co cid
      cfv wceq cU ccat wcel vn cv cM wcel vm cv cM wcel w3a vm cv cU cdom_ cfv
      cfv vn cv cU ccod_ cfv cfv wceq vm cv vn cv cU co_ cfv co cM wcel cU ccat
      wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv
      cM wcel wa vn cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv
      wceq wa cU ccod_ cfv cU cdom_ cfv cU co_ cfv cU vn cv vm cv cM idsubfun.1
      cU cdom_ cfv eqid cU ccod_ cfv eqid cU co_ cfv eqid cmpmorp cU ccat wcel
      cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM
      wcel wa vn cv cM wcel wa cU ccat wcel vn cv cM wcel vm cv cM wcel w3a vn
      cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vn cv cM
      wcel cU ccat wcel vn cv cM wcel vm cv cM wcel w3a cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a vm cv cM wcel vn cv cM wcel cU ccat wcel vn
      cv cM wcel vm cv cM wcel w3a wi wi cU cT csubc cfv wcel cU ccat wcel cT
      ccat wcel vm cv cM wcel vn cv cM wcel cU ccat wcel vn cv cM wcel vm cv cM
      wcel w3a wi wi cid cM cres cvv wcel cU ccat wcel vn cv cM wcel vm cv cM
      wcel cU ccat wcel vn cv cM wcel vm cv cM wcel w3a cU ccat wcel vn cv cM
      wcel vm cv cM wcel cU ccat wcel vn cv cM wcel vm cv cM wcel w3a cU ccat
      wcel vn cv cM wcel vm cv cM wcel w3a id 3exp com23 3ad2ant1 adantr imp31
      adantr vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq vm cv cU cdom_
      cfv cfv vn cv cU ccod_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv cM wcel wa vn
      cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq vn cv cU ccod_ cfv cfv vm
      cv cU cdom_ cfv cfv vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq id
      eqcomd adantl sylc vm cv vn cv cU co_ cfv co cM cid fvres syl vm cv vn cv
      cU co_ cfv co cid cfv vm cv vn cv cU co_ cfv co wceq cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn
      cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq wa vm cv
      vn cv cU co_ cfv co cvv wcel vm cv vn cv cU co_ cfv co cid cfv vm cv vn
      cv cU co_ cfv co wceq vm cv vn cv cU co_ cfv oprex vm cv vn cv cU co_ cfv
      co cvv fvi ax-mp a1i cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a
      cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv cM wcel wa vn cv cU ccod_
      cfv cfv vm cv cU cdom_ cfv cfv wceq wa vm cv vn cv cU co_ cfv co vm cv
      cid cM cres cfv vn cv cid cM cres cfv cU co_ cfv co vm cv cid cM cres cfv
      vn cv cid cM cres cfv cT co_ cfv co cU ccat wcel cT ccat wcel cid cM cres
      cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv cM wcel wa vn
      cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq wa vm cv vm cv cid cM
      cres cfv wceq vn cv vn cv cid cM cres cfv wceq wa vm cv vn cv cU co_ cfv
      co vm cv cid cM cres cfv vn cv cid cM cres cfv cU co_ cfv co wceq cU ccat
      wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv
      cM wcel wa vn cv cM wcel wa vm cv vm cv cid cM cres cfv wceq vn cv vn cv
      cid cM cres cfv wceq wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv
      wceq vm cv cM wcel vn cv cM wcel vm cv vm cv cid cM cres cfv wceq vn cv
      vn cv cid cM cres cfv wceq wa cU ccat wcel cT ccat wcel cid cM cres cvv
      wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vn cv cM wcel wa vm cv vm
      cv cid cM cres cfv wceq vn cv vn cv cid cM cres cfv wceq vm cv cM wcel vn
      cv cM wcel wa vm cv cid cM cres cfv vm cv vm cv cM wcel vm cv cid cM cres
      cfv vm cv wceq vn cv cM wcel cM vm cv fvresi adantr eqcomd vm cv cM wcel
      vn cv cM wcel wa vn cv cid cM cres cfv vn cv cid cfv vn cv vn cv cM wcel
      vn cv cid cM cres cfv vn cv cid cfv wceq vm cv cM wcel vn cv cM cid fvres
      adantl vn cv cM wcel vn cv cid cfv vn cv wceq vm cv cM wcel vn cv cM fvi
      adantl eqtr2d jca adantll adantr vm cv vm cv cid cM cres cfv vn cv vn cv
      cid cM cres cfv cU co_ cfv opreq12 syl cT co_ cfv wfun cU co_ cfv cT co_
      cfv wss vm cv cid cM cres cfv vn cv cid cM cres cfv cop cU co_ cfv cdm
      wcel vm cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co vm cv cid
      cM cres cfv vn cv cid cM cres cfv cU co_ cfv co wceq cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn
      cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq wa vm cv
      cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv cU co_ cfv oprssoprvg cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa
      vm cv cM wcel wa cT co_ cfv wfun vn cv cM wcel vn cv cU ccod_ cfv cfv vm
      cv cU cdom_ cfv cfv wceq cU ccat wcel cT ccat wcel cid cM cres cvv wcel
      w3a cT co_ cfv wfun cU cT csubc cfv wcel vm cv cM wcel cT ccat wcel cU
      ccat wcel cT co_ cfv wfun cid cM cres cvv wcel cT co_ cfv cT cT co_ cfv
      eqid cmppfc1 3ad2ant2 ad2antrr ad2antrr cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa cU co_ cfv cT
      co_ cfv wss vn cv cM wcel vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv
      wceq cU cT csubc cfv wcel cU co_ cfv cT co_ cfv wss cU ccat wcel cT ccat
      wcel cid cM cres cvv wcel w3a vm cv cM wcel cT cU cT co_ cfv cU co_ cfv
      cT co_ cfv eqid cU co_ cfv eqid cmpsubc ad2antlr ad2antrr cU ccat wcel cT
      ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel
      wa vn cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq wa
      vm cv cid cM cres cfv vn cv cid cM cres cfv cop vm cv vn cv cop cU co_
      cfv cdm cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc
      cfv wcel wa vm cv cM wcel wa vn cv cM wcel wa vn cv cU ccod_ cfv cfv vm
      cv cU cdom_ cfv cfv wceq wa vm cv cid cM cres cfv vm cv vn cv cid cM cres
      cfv vn cv cU ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc
      cfv wcel wa vm cv cM wcel wa vm cv cid cM cres cfv vm cv wceq vn cv cM
      wcel vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq vm cv cM wcel vm
      cv cid cM cres cfv vm cv wceq cU ccat wcel cT ccat wcel cid cM cres cvv
      wcel w3a cU cT csubc cfv wcel wa cM vm cv fvresi adantl ad2antrr vn cv cM
      wcel vn cv cid cM cres cfv vn cv wceq cU ccat wcel cT ccat wcel cid cM
      cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv cU ccod_
      cfv cfv vm cv cU cdom_ cfv cfv wceq cM vn cv fvresi ad2antlr opeq12d cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa
      vm cv cM wcel wa vn cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_
      cfv cfv wceq wa vm cv vn cv cop cU co_ cfv cdm wcel vm cv cU cdom_ cfv
      cfv vn cv cU ccod_ cfv cfv wceq vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv
      cfv wceq vm cv cU cdom_ cfv cfv vn cv cU ccod_ cfv cfv wceq cU ccat wcel
      cT ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM
      wcel wa vn cv cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv
      wceq vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv vn cv cU ccod_ cfv cfv
      vm cv cU cdom_ cfv cfv wceq id eqcomd adantl cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel wa vn cv
      cM wcel wa vn cv cU ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq wa cU ccat
      wcel vn cv cM wcel vm cv cM wcel w3a vm cv vn cv cop cU co_ cfv cdm wcel
      vm cv cU cdom_ cfv cfv vn cv cU ccod_ cfv cfv wceq wb cU ccat wcel cT
      ccat wcel cid cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel
      wa vn cv cM wcel wa cU ccat wcel vn cv cM wcel vm cv cM wcel w3a vn cv cU
      ccod_ cfv cfv vm cv cU cdom_ cfv cfv wceq cU ccat wcel cT ccat wcel cid
      cM cres cvv wcel w3a cU cT csubc cfv wcel wa vm cv cM wcel vn cv cM wcel
      cU ccat wcel vn cv cM wcel vm cv cM wcel w3a cU ccat wcel cT ccat wcel
      cid cM cres cvv wcel w3a vm cv cM wcel vn cv cM wcel cU ccat wcel vn cv
      cM wcel vm cv cM wcel w3a wi wi cU cT csubc cfv wcel cU ccat wcel cT ccat
      wcel vm cv cM wcel vn cv cM wcel cU ccat wcel vn cv cM wcel vm cv cM wcel
      w3a wi wi cid cM cres cvv wcel cU ccat wcel vn cv cM wcel vm cv cM wcel
      cU ccat wcel vn cv cM wcel vm cv cM wcel w3a cU ccat wcel vn cv cM wcel
      vm cv cM wcel cU ccat wcel vn cv cM wcel vm cv cM wcel w3a cU ccat wcel
      vn cv cM wcel vm cv cM wcel w3a id 3exp com23 3ad2ant1 adantr imp31
      adantr cU ccod_ cfv cU cdom_ cfv cU co_ cfv cU vn cv vm cv cM idsubfun.1
      cU cdom_ cfv eqid cU ccod_ cfv eqid cU co_ cfv eqid cmppfcd syl mpbird
      eqeltrd syl3anc eqtr4d 3eqtrd exp31 r19.21aiv ex r19.21aiv 3jca jca cU
      ccat wcel cT ccat wcel cid cM cres cvv wcel w3a cid cM cres cU cT cop
      cfunc cfv wcel cM cT cdom_ cfv cdm cid cM cres wf vo cv cU cid_ cfv cfv
      cid cM cres cfv vp cv cT cid_ cfv cfv wceq vp cT cid_ cfv cdm wrex vo cU
      cid_ cfv cdm wral vm cv cU cdom_ cfv cfv cU cid_ cfv cfv cid cM cres cfv
      vm cv cid cM cres cfv cT cdom_ cfv cfv cT cid_ cfv cfv wceq vm cM wral vm
      cv cU ccod_ cfv cfv cU cid_ cfv cfv cid cM cres cfv vm cv cid cM cres cfv
      cT ccod_ cfv cfv cT cid_ cfv cfv wceq vm cM wral wa vn cv cU ccod_ cfv
      cfv vm cv cU cdom_ cfv cfv wceq vm cv vn cv cU co_ cfv co cid cM cres cfv
      vm cv cid cM cres cfv vn cv cid cM cres cfv cT co_ cfv co wceq wi vn cM
      wral vm cM wral w3a wa wb cU cT csubc cfv wcel cvv cU cT vm vn vo cid cM
      cres vp cU cid_ cfv cdm cM cT cid_ cfv cdm cT cdom_ cfv cdm cU cid_ cfv
      cU cdom_ cfv cU ccod_ cfv cU co_ cfv cT cid_ cfv cT cdom_ cfv cT ccod_
      cfv cT co_ cfv cU cid_ cfv cdm eqid idsubfun.1 cU cdom_ cfv eqid cU ccod_
      cfv eqid cU cid_ cfv eqid cU co_ cfv eqid cT cid_ cfv cdm eqid cT cdom_
      cfv cdm eqid cT cdom_ cfv eqid cT ccod_ cfv eqid cT cid_ cfv eqid cT co_
      cfv eqid isfunb adantr mpbird 3exp1 impcom com13 mpd mp2and $.
      $( [6-Oct-2009] $) $( [5-Oct-2009] $)
  $}

  ${ $d M1 x $. $d M2 x $.
    infemb.1 $e |- M1 = dom ( dom_ ` T ) $.
    infemb.2 $e |- M2 = dom ( dom_ ` U ) $.
    $( The inclusion functor is an embedding. $)
    infemb $p |- ( U e. ( SubCat ` T ) -> ( _I |` M2 ) : M2 -1-1-> M1 ) $=
      cU cT csubc cfv wcel cm2 vx cv cid cm2 cres wf1o vx cv cm1 wss wa vx wex
      cm2 cm1 cid cm2 cres wf1 cU cT csubc cfv wcel cm2 cm2 cid cm2 cres wf1o
      cm2 cm1 wss wa cm2 vx cv cid cm2 cres wf1o vx cv cm1 wss wa vx wex cU cT
      csubc cfv wcel cm2 cm1 wss cm2 cm2 cid cm2 cres wf1o cT cU cm1 cm2
      infemb.1 infemb.2 morsubc cm2 f1oi jctil cm2 vx cv cid cm2 cres wf1o vx
      cv cm1 wss wa cm2 cm2 cid cm2 cres wf1o cm2 cm1 wss wa vx cm2 cm2 cU
      cdom_ cfv cdm cvv infemb.2 cU cdom_ cfv cU cdom_ fvex dmex eqeltri vx cv
      cm2 wceq cm2 vx cv cid cm2 cres wf1o cm2 cm2 cid cm2 cres wf1o vx cv cm1
      wss cm2 cm1 wss vx cv cm2 cm2 cid cm2 cres f1oeq3 vx cv cm2 cm1 sseq1
      anbi12d cla4ev syl vx cm2 cm1 cid cm2 cres cm2 cvv wcel cid cm2 cres cvv
      wcel cm2 cU cdom_ cfv cdm cvv infemb.2 cU cdom_ cfv cU cdom_ fvex dmex
      eqeltri cm2 cvv resiexg ax-mp f11o sylibr $.
      $( [3-Nov-2009] $) $( [2-Nov-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Tarski's classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Subcl $. $( The class of subset-closed classes $)
  $c Tarski $. $( The class of tarski classes $)
  $c tarskiMap $. $( The class of tarski classes $)


  $( The class of subset-closed classes. $)
  csubcl $a class Subcl $.

  $( The class of Tarski classes. $)
  ctarski $a class Tarski $.

  $( The class of Tarski map. $)
  ctarskim $a class tarskiMap $.

  ${
    $d y z w $.
    $( The class of all inaccessible cardinals. $)
    df-tsk $a |- Tarski = { y |  ( A. z e. y ( ~P z C_ y
      /\ E. w e. y ~P z C_ w ) /\ A. z e. ~P y ( z ~~ y \/ z e. y ) ) } $.
  $}

  ${
    $d w y z $.
    $( Alternate definition of inaccessible cardinals. $)
    taralt $p |- Tarski = { y |  ( A. z e. y ( ~P z C_ y
      /\  ~P z e. y ) /\ A. z e. ~P y ( z ~~ y \/ z e. y ) ) } $=
      ctarski vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv
      wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa vy cab vz cv
      cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv vy cv cen wbr
      vz vy wel wo vz vy cv cpw wral wa vy cab vy vz vw df-tsk vz cv cpw vy cv
      wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen
      wbr vz vy wel wo vz vy cv cpw wral wa vz cv cpw vy cv wss vz cv cpw vy cv
      wcel wa vz vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral
      wa vy vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv
      wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa vz cv cpw vy
      cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv vy cv cen wbr vz vy
      wel wo vz vy cv cpw wral wa vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy
      cv wrex wa vz vy cv wral vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz
      vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral vz cv cpw
      vy cv wss vz vy cv wral vz cv cpw vw cv wss vw vy cv wrex vz vy cv wral
      wa vz cv cpw vy cv wss vz vy cv wral vz cv cpw vy cv wcel vz vy cv wral
      wa vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral
      vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv cpw vy cv
      wss vz vy cv wral vz cv cpw vw cv wss vw vy cv wrex vz vy cv wral vz cv
      cpw vy cv wcel vz vy cv wral vz cv cpw vy cv wss vz vy cv wral vz cv cpw
      vw cv wss vw vy cv wrex vz cv cpw vy cv wcel vz vy cv vz cv cpw vy cv wss
      vz vy cv hbra1 vz cv cpw vy cv wss vz vy cv wral vz cv cpw vw cv wss vw
      vy cv wrex vz cv cpw vy cv wcel wi vz vy wel vz cv cpw vy cv wss vz vy cv
      wral vw cv cpw vy cv wss vw vy cv wral vz cv cpw vw cv wss vw vy cv wrex
      vz cv cpw vy cv wcel wi vz cv cpw vy cv wss vw cv cpw vy cv wss vz vw vy
      cv vz vw weq vz cv cpw vw cv cpw vy cv vz cv vw cv pweq sseq1d cbvralv vw
      cv cpw vy cv wss vw vy cv wral vz cv cpw vw cv wss vw vy cv wrex vz cv
      cpw vy cv wcel vw cv cpw vy cv wss vw vy cv wral vz cv cpw vw cv wss vw
      vy cv wrex wa vw cv cpw vy cv wss vz cv cpw vw cv wss wa vw vy cv wrex vz
      cv cpw vy cv wcel vw cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv r19.29
      vw cv cpw vy cv wss vz cv cpw vw cv wss wa vz cv cpw vy cv wcel vw vy cv
      vw cv cpw vy cv wss vz cv cpw vw cv wss wa vz cv cpw vy cv wcel vw vy wel
      vw cv cpw vy cv wss vz cv cpw vw cv wss vz cv cpw vy cv wcel vw cv cpw vy
      cv wss vz cv cpw vw cv cpw wcel vz cv cpw vy cv wcel vz cv cpw vw cv wss
      vw cv cpw vy cv vz cv cpw ssel vz cv cpw vw cv vz cv vz visset pwex elpw
      syl5ibr imp adantl r19.23aiva syl ex sylbi adantr r19.20da imdistani vz
      cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex vz vy cv r19.26 vz cv
      cpw vy cv wss vz cv cpw vy cv wcel vz vy cv r19.26 3imtr4i anim1i vz cv
      cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv cpw vy cv wss
      vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz
      vy wel wo vz vy cv cpw wral vz cv cpw vy cv wss vz cv cpw vy cv wcel wa
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv vz vy
      wel vz cv cpw vy cv wss vz cv cpw vy cv wcel wa wa vz cv cpw vy cv wss vz
      cv cpw vw cv wss vw vy cv wrex vz vy wel vz cv cpw vy cv wss vz cv cpw vy
      cv wcel simprl vz cv cpw vy cv wcel vz cv cpw vw cv wss vw vy cv wrex vz
      vy wel vz cv cpw vy cv wss vz cv cpw vy cv wcel vz cv cpw vz cv cpw wss
      vz cv cpw vw cv wss vw vy cv wrex vz cv cpw ssid vz cv cpw vw cv wss vz
      cv cpw vz cv cpw wss vw vz cv cpw vy cv vw cv vz cv cpw vz cv cpw sseq2
      rcla4ev mpan2 ad2antll jca r19.20ia anim1i impbii abbii eqtri $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${ $d T w y z $.
    tarval.1 $e |- T e. _V $.
    $( Properties of an inaccessible cardinal. $)
    tarval $p |- ( T e. Tarski <-> ( A. z e. T ( ~P z C_ T
      /\ E. w e. T ~P z C_ w ) /\ A. z e. ~P T ( z ~~ T \/ z e. T ) ) )
     $=
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz
      cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa vz cv cpw cT wss vz cv
      cpw vw cv wss vw cT wrex wa vz cT wral vz cv cT cen wbr vz cv cT wcel wo
      vz cT cpw wral wa vy cT ctarski tarval.1 vy cv cT wceq vz cv cpw vy cv
      wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv cpw cT wss
      vz cv cpw vw cv wss vw cT wrex wa vz cT wral vz cv vy cv cen wbr vz vy
      wel wo vz vy cv cpw wral vz cv cT cen wbr vz cv cT wcel wo vz cT cpw wral
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz cv cpw cT wss
      vz cv cpw vw cv wss vw cT wrex wa vz vy cv cT vy cv cT wceq vz cv cpw vy
      cv wss vz cv cpw cT wss vz cv cpw vw cv wss vw vy cv wrex vz cv cpw vw cv
      wss vw cT wrex vy cv cT vz cv cpw sseq2 vz cv cpw vw cv wss vw vy cv cT
      rexeq1 anbi12d raleqd vy cv cT wceq vz cv vy cv cen wbr vz vy wel wo vz
      cv cT cen wbr vz cv cT wcel wo vz vy cv cpw cT cpw vy cv cT pweq vy cv cT
      wceq vz cv vy cv cen wbr vz cv cT cen wbr vz vy wel vz cv cT wcel vy cv
      cT vz cv cen breq2 vy cv cT vz cv eleq2 orbi12d raleq12d anbi12d vy vz vw
      df-tsk elab2 $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d T w y z $.
    $( Properties of an inaccessible cardinal. $)
    tarvalg $p |- ( T e. A -> ( T e. Tarski <-> ( A. z e. T ( ~P z C_ T
      /\ E. w e. T ~P z C_ w ) /\ A. z e. ~P T ( z ~~ T \/ z e. T ) ) ) )
     $=
      vy cv ctarski wcel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex
      wa vz vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa wb
      cT ctarski wcel vz cv cpw cT wss vz cv cpw vw cv wss vw cT wrex wa vz cT
      wral vz cv cT cen wbr vz cv cT wcel wo vz cT cpw wral wa wb vy cT cA vy
      cv cT wceq vy cv ctarski wcel cT ctarski wcel vz cv cpw vy cv wss vz cv
      cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz vy
      wel wo vz vy cv cpw wral wa vz cv cpw cT wss vz cv cpw vw cv wss vw cT
      wrex wa vz cT wral vz cv cT cen wbr vz cv cT wcel wo vz cT cpw wral wa vy
      cv cT ctarski eleq1 vy cv cT wceq vz cv cpw vy cv wss vz cv cpw vw cv wss
      vw vy cv wrex wa vz vy cv wral vz cv cpw cT wss vz cv cpw vw cv wss vw cT
      wrex wa vz cT wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral vz
      cv cT cen wbr vz cv cT wcel wo vz cT cpw wral vy cv cT wceq vz cv cpw vy
      cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz cv cpw cT wss vz cv cpw vw
      cv wss vw cT wrex wa vz vy cv cT vy cv cT wceq vz vy wel vz cv cT wcel vz
      cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz cv cpw cT wss vz
      cv cpw vw cv wss vw cT wrex wa vy cv cT vz cv eleq2 vy cv cT wceq vz cv
      cpw vy cv wss vz cv cpw cT wss vz cv cpw vw cv wss vw vy cv wrex vz cv
      cpw vw cv wss vw cT wrex vy cv cT vz cv cpw sseq2 vz cv cpw vw cv wss vw
      vy cv cT rexeq1 anbi12d imbi12d ralbidv2 vy cv cT wceq vz cv vy cv cen
      wbr vz vy wel wo vz cv cT cen wbr vz cv cT wcel wo vz vy cv cpw cT cpw vy
      cv cT wceq vz cv vy cv cpw wcel vz cv cT cpw wcel vz cv vy cv cen wbr vz
      vy wel wo vz cv cT cen wbr vz cv cT wcel wo vy cv cT wceq vy cv cpw cT
      cpw vz cv vy cv cT pweq eleq2d vy cv cT wceq vz cv vy cv cen wbr vz cv cT
      cen wbr vz vy wel vz cv cT wcel vy cv cT vz cv cen breq2 vy cv cT vz cv
      eleq2 orbi12d imbi12d ralbidv2 anbi12d bibi12d vz vw vy cv vy visset
      tarval vtoclg $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d T y z $.
    tarval1.1 $e |- T e. _V $.
    $( Properties of an inaccessible cardinal. $)
    tarval1 $p |- ( T e. Tarski <-> ( A. z e. T ( ~P z C_ T
      /\  ~P z e. T ) /\ A. z e. ~P T ( z ~~ T \/ z e. T ) ) ) $=
      cT ctarski wcel cT vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv
      wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa vy cab wcel vz
      cv cpw cT wss vz cv cpw cT wcel wa vz cT wral vz cv cT cen wbr vz cv cT
      wcel wo vz cT cpw wral wa ctarski vz cv cpw vy cv wss vz cv cpw vy cv
      wcel wa vz vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral
      wa vy cab cT vy vz taralt eleq2i vz cv cpw vy cv wss vz cv cpw vy cv wcel
      wa vz vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa vz
      cv cpw cT wss vz cv cpw cT wcel wa vz cT wral vz cv cT cen wbr vz cv cT
      wcel wo vz cT cpw wral wa vy cT vz cv cpw cT wss vz cv cpw cT wcel wa vz
      cT wral vz cv cT cen wbr vz cv cT wcel wo vz cT cpw wral wa vy ax-17
      tarval1.1 vy cv cT wceq vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy
      cv wral vz cv cpw cT wss vz cv cpw cT wcel wa vz cT wral vz cv vy cv cen
      wbr vz vy wel wo vz vy cv cpw wral vz cv cT cen wbr vz cv cT wcel wo vz
      cT cpw wral vy cv cT wceq vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz
      cv cpw cT wss vz cv cpw cT wcel wa vz vy cv cT vy cv cT wceq vz vy wel vz
      cv cT wcel vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz cv cpw cT wss
      vz cv cpw cT wcel wa vy cv cT vz cv eleq2 vy cv cT wceq vz cv cpw vy cv
      wss vz cv cpw cT wss vz cv cpw vy cv wcel vz cv cpw cT wcel vy cv cT vz
      cv cpw sseq2 vy cv cT vz cv cpw eleq2 anbi12d imbi12d ralbidv2 vy cv cT
      wceq vz cv vy cv cen wbr vz vy wel wo vz cv cT cen wbr vz cv cT wcel wo
      vz vy cv cpw cT cpw vy cv cT wceq vz cv vy cv cpw wcel vz cv cT cpw wcel
      vz cv vy cv cen wbr vz vy wel wo vz cv cT cen wbr vz cv cT wcel wo vy cv
      cT wceq vy cv cpw cT cpw vz cv vy cv cT pweq eleq2d vy cv cT wceq vz cv
      vy cv cen wbr vz cv cT cen wbr vz vy wel vz cv cT wcel vy cv cT vz cv cen
      breq2 vy cv cT vz cv eleq2 orbi12d imbi12d ralbidv2 anbi12d elabf bitri
      $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d T y z $.
    $( Properties of an inaccessible cardinal. $)
    tarval1g $p |- ( T e. A -> ( T e. Tarski <-> ( A. z e. T ( ~P z C_ T
      /\  ~P z e. T ) /\ A. z e. ~P T ( z ~~ T \/ z e. T ) ) ) ) $=
      vy cv ctarski wcel vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv
      wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa cT ctarski
      wcel vz cv cpw cT wss vz cv cpw cT wcel wa vz cT wral vz cv cT cen wbr vz
      cv cT wcel wo vz cT cpw wral wa vy cT cA vy cv cT ctarski eleq1 vy cv cT
      wceq vz cv cpw vy cv wss vz cv cpw vy cv wcel wa vz vy cv wral vz cv cpw
      cT wss vz cv cpw cT wcel wa vz cT wral vz cv vy cv cen wbr vz vy wel wo
      vz vy cv cpw wral vz cv cT cen wbr vz cv cT wcel wo vz cT cpw wral vz cv
      cpw vy cv wss vz cv cpw vy cv wcel wa vz cv cpw cT wss vz cv cpw cT wcel
      wa vz vy cv cT vy cv cT wceq vz cv cpw vy cv wss vz cv cpw cT wss vz cv
      cpw vy cv wcel vz cv cpw cT wcel vy cv cT vz cv cpw sseq2 vy cv cT vz cv
      cpw eleq2 anbi12d raleqd vy cv cT wceq vz cv vy cv cen wbr vz vy wel wo
      vz cv cT cen wbr vz cv cT wcel wo vz vy cv cpw cT cpw vy cv cT pweq vy cv
      cT wceq vz cv vy cv cen wbr vz cv cT cen wbr vz vy wel vz cv cT wcel vy
      cv cT vz cv cen breq2 vy cv cT vz cv eleq2 orbi12d raleq12d anbi12d vz vy
      cv vy visset tarval1 vtoclbg $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d A x $. $d T x y $.
    $( 1st axiom of a an inaccessible cardinal. The subsets of an
       element of an inaccesible cardinal belong to the cardinal.  $)
    tarax1 $p |- ( ( T e. Tarski /\ A e. T ) -> ~P A C_ T ) $=
      cA cT wcel cT ctarski wcel cA cpw cT wss cT ctarski wcel vx cv cpw cT wss
      wi cT ctarski wcel cA cpw cT wss wi vx cA cT vx cv cA wceq vx cv cpw cT
      wss cA cpw cT wss cT ctarski wcel vx cv cA wceq vx cv cpw cA cpw cT vx cv
      cA pweq sseq1d imbi2d cT ctarski wcel vx cv cpw cT wss vx cT cT ctarski
      wcel vx cv cpw cT wss vx cT wral cT ctarski wcel cT ctarski wcel vx cv
      cpw cT wss vx cv cpw vy cv wss vy cT wrex wa vx cT wral vx cv cT cen wbr
      vx cv cT wcel wo vx cT cpw wral wa vx cv cpw cT wss vx cT wral vx vy
      ctarski cT tarvalg vx cv cpw cT wss vx cv cpw vy cv wss vy cT wrex wa vx
      cT wral vx cv cpw cT wss vx cT wral vx cv cT cen wbr vx cv cT wcel wo vx
      cT cpw wral vx cv cpw cT wss vx cv cpw vy cv wss vy cT wrex wa vx cv cpw
      cT wss vx cT vx cv cpw cT wss vx cv cpw vy cv wss vy cT wrex pm3.26
      r19.20si adantr syl6bi pm2.43i r19.21be vtoclri impcom $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d A x $. $d T x $.
    $( 2nd axiom of a an inaccessible cardinal. The powerset of an
       element of an inaccesible cardinal belong to the cardinal. $)
    tarax2 $p |- ( ( T e. Tarski /\ A e. T ) -> ~P A e. T ) $=
      cA cT wcel cT ctarski wcel cA cpw cT wcel cT ctarski wcel vx cv cpw cT
      wcel wi cT ctarski wcel cA cpw cT wcel wi vx cA cT vx cv cA wceq vx cv
      cpw cT wcel cA cpw cT wcel cT ctarski wcel vx cv cA wceq vx cv cpw cA cpw
      cT vx cv cA pweq eleq1d imbi2d cT ctarski wcel vx cv cpw cT wcel vx cT cT
      ctarski wcel vx cv cpw cT wcel vx cT wral cT ctarski wcel cT ctarski wcel
      vx cv cpw cT wss vx cv cpw cT wcel wa vx cT wral vx cv cT cen wbr vx cv
      cT wcel wo vx cT cpw wral wa vx cv cpw cT wcel vx cT wral vx ctarski cT
      tarval1g vx cv cpw cT wss vx cv cpw cT wcel wa vx cT wral vx cv cpw cT
      wcel vx cT wral vx cv cT cen wbr vx cv cT wcel wo vx cT cpw wral vx cv
      cpw cT wss vx cv cpw cT wcel wa vx cv cpw cT wcel vx cT vx cv cpw cT wss
      vx cv cpw cT wcel pm3.27 r19.20si adantr syl6bi pm2.43i r19.21be vtoclri
      impcom $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d A x $. $d T x y $.
    $( 3rd axiom of a an inaccessible cardinal. A subset of an
       is either equipotent to the cardinal or an element of the
       cardinal. $)
    tarax3 $p |- ( ( T e. Tarski /\ A e. ~P T ) ->
      ( A ~~ T \/ A e. T ) ) $=
      cA cT cpw wcel cT ctarski wcel cA cT cen wbr cA cT wcel wo cT ctarski
      wcel vx cv cT cen wbr vx cv cT wcel wo wi cT ctarski wcel cA cT cen wbr
      cA cT wcel wo wi vx cA cT cpw vx cv cA wceq vx cv cT cen wbr vx cv cT
      wcel wo cA cT cen wbr cA cT wcel wo cT ctarski wcel vx cv cA wceq vx cv
      cT cen wbr cA cT cen wbr vx cv cT wcel cA cT wcel vx cv cA cT cen breq1
      vx cv cA cT eleq1 orbi12d imbi2d cT ctarski wcel vx cv cT cen wbr vx cv
      cT wcel wo vx cT cpw cT ctarski wcel vx cv cT cen wbr vx cv cT wcel wo vx
      cT cpw wral cT ctarski wcel cT ctarski wcel vx cv cpw cT wss vx cv cpw vy
      cv wss vy cT wrex wa vx cT wral vx cv cT cen wbr vx cv cT wcel wo vx cT
      cpw wral wa vx cv cT cen wbr vx cv cT wcel wo vx cT cpw wral vx vy
      ctarski cT tarvalg vx cv cpw cT wss vx cv cpw vy cv wss vy cT wrex wa vx
      cT wral vx cv cT cen wbr vx cv cT wcel wo vx cT cpw wral pm3.27 syl6bi
      pm2.43i r19.21be vtoclri impcom $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  $( The empty set is an inaccessible ardinal. $)
  empistar $p |- (/) e. Tarski $=
    c0 cvv wcel c0 ctarski wcel 0ex c0 cvv wcel c0 ctarski wcel vx cv cpw c0
    wss vx cv cpw c0 wcel wa vx c0 wral vx cv c0 cen wbr vx cv c0 wcel wo vx c0
    cpw wral wa c0 cvv wcel vx cv c0 cen wbr vx cv c0 wcel wo vx c0 cpw wral vx
    cv cpw c0 wss vx cv cpw c0 wcel wa vx c0 wral vx cv c0 cen wbr vx cv c0
    wcel wo vx c0 cpw wral c0 cvv wcel vx cv c0 cen wbr vx cv c0 wcel wo vx c0
    cpw vx cv c0 cpw wcel vx cv c0 csn wcel vx cv c0 cen wbr vx cv c0 wcel wo
    c0 cpw c0 csn vx cv pw0 eleq2i vx cv c0 csn wcel vx cv c0 wceq vx cv c0 cen
    wbr vx cv c0 wcel wo vx cv c0 elsni vx cv c0 wceq vx cv c0 cen wbr vx cv c0
    wcel vx cv c0 wceq vx cv c0 cen wbr c0 c0 cen wbr c0 0ex enref vx cv c0 c0
    cen breq1 mpbiri orcd syl sylbi rgen a1i vx cv cpw c0 wss vx cv cpw c0 wcel
    wa vx ral0 jctil vx cvv c0 tarval1g mpbird ax-mp $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  $( The parts of an inaccessible cardinals are inaccessible
     cardinals. $)
  elincin $p |- ( ( T e. Tarski /\ A e. T /\ B C_ A ) -> B e. T ) $=
    cB cvv wcel cT ctarski wcel cA cT wcel cB cA wss w3a cB cT wcel cA cT wcel
    cB cA wss cB cvv wcel cT ctarski wcel cB cA wss cA cT wcel cB cvv wcel cB
    cA cT ssexg ancoms 3adant1 cB cvv wcel cT ctarski wcel cA cT wcel cB cA wss
    w3a cB cT wcel wi cT ctarski wcel cA cT wcel cB cA wss w3a cB cvv wcel cB
    cvv wcel cB cT wcel cT ctarski wcel cA cT wcel cB cA wss w3a cB cvv wcel cB
    cA cpw wcel cB cvv wcel cB cT wcel wi cB cA wss cT ctarski wcel cB cvv wcel
    cB cA cpw wcel wi cA cT wcel cB cvv wcel cB cA cpw wcel cB cA wss cB cA cvv
    elpwg biimprcd 3ad2ant3 cT ctarski wcel cA cT wcel cB cA cpw wcel cB cvv
    wcel cB cT wcel wi wi cB cA wss cT ctarski wcel cA cT wcel wa cA cpw cT wss
    cB cA cpw wcel cB cvv wcel cB cT wcel wi wi cA cT tarax1 cA cpw cT wss cB
    cA cpw wcel cB cvv wcel cB cT wcel wi cA cpw cT wss cB cA cpw wcel wa cB cT
    wcel cB cvv wcel cA cpw cT cB ssel2 a1d ex syl 3adant3 syld com13 pm2.43i
    mpcom $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  $( The intersection of two elements of an inaccessible cardinals
     belongs to the cardinal. $)
  inacint $p |- ( ( T e. Tarski /\ A e. T /\ B e. T ) -> ( A i^i B ) e. T )
      $=
    cT ctarski wcel cA cT wcel cB cT wcel w3a cA cpw cT cA cB cin cT ctarski
    wcel cA cT wcel cA cpw cT wss cB cT wcel cA cT tarax1 3adant3 cT ctarski
    wcel cA cT wcel cB cT wcel w3a cA cA cpw wcel cA cB cin cA cpw wcel cA cT
    wcel cT ctarski wcel cA cA cpw wcel cB cT wcel cA cT wcel cA cA cpw wcel cA
    cA wss cA ssid cA cA cT elpwg mpbiri 3ad2ant2 cA cB cA inpws1 syl sseldd $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)


  ${
    $d T x $.
    $( A non empty inaccessible cardinal contains the empty set. $)
    emptar $p |- ( ( T e. Tarski /\ T =/= (/) ) -> (/) e. T ) $=
      vx cv cT wcel vx wex cT ctarski wcel cT c0 wne wa c0 cT wcel cT c0 wne vx
      cv cT wcel vx wex cT ctarski wcel cT c0 wne vx cv cT wcel vx wex vx cT n0
      biimpi adantl vx cv cT wcel cT ctarski wcel cT c0 wne wa c0 cT wcel wi vx
      cT ctarski wcel cT c0 wne wa vx cv cT wcel c0 cT wcel cT ctarski wcel vx
      cv cT wcel c0 cT wcel wi cT c0 wne cT ctarski wcel vx cv cT wcel c0 cT
      wcel cT ctarski wcel vx cv cT wcel wa vx cv cpw cT wss c0 cT wcel vx cv
      cT tarax1 vx cv cpw cT wss c0 vx cv cpw wcel c0 cT wcel vx cv 0elpw vx cv
      cpw cT c0 ssel mpi syl ex adantr com12 19.23aiv mpcom $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  $( An element of a transitive inaccessible cardinal is a part
     of the cardinal. CLASSES2 th. 48 $)
  elcartr $p |- ( ( T e. Tarski /\ Tr T /\ A e. T ) -> A C_ T ) $=
    cT wtr cA cT wcel cA cT wss cT ctarski wcel cT wtr cA cT wcel cA cT wss cT
    cA trss imp 3adant1 $.
    $( [30-Dec-2010] $) $( [30-Dec-2010] $)

  ${
    $d a b y $.
    $( A function that maps a set ` a ` to the smallest class of inaccessible
       cardinals that contains the set. $)
    df-tskmp $a |- tarskiMap = { <. a , b >. | b = |^| { y | ( a e. y /\
      y e. Tarski ) } } $.
  $}

  ${
    $d A a y $. $d A x y $. $d a b y $. $d w x y z $.
    tarval2.1 $e |- A e. _V $.
    $( Value of our tarski map. $)
    tarval2 $p |- ( tarskiMap ` A ) = |^| { y | ( A e. y /\
      y e. Tarski ) } $=
      cA ctarskim cfv cA vb cv va vy wel vy cv ctarski wcel wa vy cab cint wceq
      va vb copab cfv cA vy cv wcel vy cv ctarski wcel wa vy cab cint cA
      ctarskim vb cv va vy wel vy cv ctarski wcel wa vy cab cint wceq va vb
      copab vy va vb df-tskmp fveq1i va vb cA va vy wel vy cv ctarski wcel wa
      vy cab cint cA vy cv wcel vy cv ctarski wcel wa vy cab cint tarval2.1 cA
      vy cv wcel vy cv ctarski wcel wa vy cab c0 wne cA vy cv wcel vy cv
      ctarski wcel wa vy cab cint cvv wcel cA vy cv wcel vy cv ctarski wcel wa
      vy cab c0 wne cA vy cv wcel vy cv ctarski wcel wa vy wex vx vy wel vy cv
      ctarski wcel wa vy wex cA vy cv wcel vy cv ctarski wcel wa vy wex vx cA
      cA vy cv wcel vy cv ctarski wcel wa vy wex vx ax-17 tarval2.1 vx cv cA
      wceq vx vy wel vy cv ctarski wcel wa cA vy cv wcel vy cv ctarski wcel wa
      vy vx cv cA wceq vx vy wel cA vy cv wcel vy cv ctarski wcel vx cv cA vy
      cv eleq1 anbi1d exbidv vx vy wel vy cv ctarski wcel wa vy wex vx vy wel
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz
      cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa wa vy wex vx vy wel vz
      cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv
      vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa wa vy wex vx vy wel vz cv
      cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy
      cv cen wbr vz vy wel wo vz vy cv cpw wral w3a vy wex vx vy vz vw axgroth5
      vx vy wel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy
      cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral wa wa vx vy
      wel vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv
      wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral w3a vy vx vy wel
      vz cv cpw vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz
      cv vy cv cen wbr vz vy wel wo vz vy cv cpw wral w3a vx vy wel vz cv cpw
      vy cv wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv
      cen wbr vz vy wel wo vz vy cv cpw wral wa wa vx vy wel vz cv cpw vy cv
      wss vz cv cpw vw cv wss vw vy cv wrex wa vz vy cv wral vz cv vy cv cen
      wbr vz vy wel wo vz vy cv cpw wral 3anass bicomi exbii mpbir vx vy wel vy
      cv ctarski wcel wa vx vy wel vz cv cpw vy cv wss vz cv cpw vw cv wss vw
      vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv cpw
      wral wa wa vy vy cv ctarski wcel vz cv cpw vy cv wss vz cv cpw vw cv wss
      vw vy cv wrex wa vz vy cv wral vz cv vy cv cen wbr vz vy wel wo vz vy cv
      cpw wral wa vx vy wel vz vw vy cv vy visset tarval anbi2i exbii mpbir
      vtoclf cA vy cv wcel vy cv ctarski wcel wa vy abn0 mpbir cA vy cv wcel vy
      cv ctarski wcel wa vy cab intex mpbi va cv cA wceq va vy wel vy cv
      ctarski wcel wa vy cab cA vy cv wcel vy cv ctarski wcel wa vy cab va cv
      cA wceq va vy wel vy cv ctarski wcel wa cA vy cv wcel vy cv ctarski wcel
      wa vy va cv cA wceq vy ax-17 va cv cA wceq va vy wel cA vy cv wcel vy cv
      ctarski wcel va cv cA vy cv eleq1 anbi1d abbid inteqd fvopab eqtri $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${ $d A x y $.
    $( Value of our tarski map. $)
    tarval2g $p |- ( A e. B -> ( tarskiMap ` A ) = |^| { y | ( A e. y /\
      y e. Tarski ) } ) $=
      vx cv ctarskim cfv vx vy wel vy cv ctarski wcel wa vy cab cint wceq cA
      ctarskim cfv cA vy cv wcel vy cv ctarski wcel wa vy cab cint wceq vx cA
      cB vx cv cA wceq vx cv ctarskim cfv cA ctarskim cfv vx vy wel vy cv
      ctarski wcel wa vy cab cint cA vy cv wcel vy cv ctarski wcel wa vy cab
      cint vx cv cA ctarskim fveq2 vx cv cA wceq vx vy wel vy cv ctarski wcel
      wa vy cab cA vy cv wcel vy cv ctarski wcel wa vy cab vx cv cA wceq vx vy
      wel vy cv ctarski wcel wa cA vy cv wcel vy cv ctarski wcel wa vy vx cv cA
      wceq vx vy wel cA vy cv wcel vy cv ctarski wcel vx cv cA vy cv eleq1
      anbi1d abbidv inteqd eqeq12d vy vx cv vx visset tarval2 vtoclg $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${
    $d A y $.
    $( The set ` A ` is an element of the smallest inaccessible cardinal
       that contains ` A ` . $)
    elttar $p |- ( A e. B -> A e. ( tarskiMap ` A ) ) $=
      cA cB wcel cA cA vy cv wcel vy cv ctarski wcel wa vy cab cint cA ctarskim
      cfv cA cB wcel cA cA vy cv wcel vy cv ctarski wcel wa vy cab cint wcel cA
      vy cv wcel vy cv ctarski wcel wa cA vy cv wcel wi vy wal cA vy cv wcel vy
      cv ctarski wcel wa cA vy cv wcel wi vy cA vy cv wcel vy cv ctarski wcel
      pm3.26 ax-gen cA vy cv wcel vy cv ctarski wcel wa vy cA cB elintabg
      mpbiri vy cA cB tarval2g eleqtrrd $.
      $( [30-Dec-2010] $) $( [30-Dec-2010] $)
  $}

  ${ $d x y z $.
   $( Define the class of all the subset-closed sets.  $)
   df-subcl $a |- Subcl = { x | A. y A. z ( ( y e. x /\ z C_ y ) ->
     z e. x ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Grothendieck's universes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Uni $.

  $( Extend class notation to include the class of all the universes of
     Grothendieck. $)
  cgruni $a class Uni $.

  ${ $d u x y f k $.
    $( A universe of Grothendieck is  a set that is closed with respect
       to  all the
       operations that  are common  in set theory:  pairs, powerset...
       SGA 4 Expose I p. 185 $)
    ungr $a |- Uni = { u | ( ( A. x e. u A. y e. x y e. u /\
               A. x e. u A. y e. u { x , y } e. u /\
               A. x e. u ~P x e. u ) /\
               A. i e. u A. f e. ( u ^m i ) U_ k e. i ( f ` k ) e. u  ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Planar incidence geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${ $d L a b l x $. $d P a b x $.
    efp.1 $e |- P = U. L $.
    $( Euclid's first postulate. There is a unique line passing through two
       distinct points. $)
    efp $p |- ( L e. Plig -> A. a e. P A. b e. P ( a =/= b
        -> E! l e. L ( a e. l /\ b e. l ) ) ) $=
      cL cplig wcel va cv vb cv wne va vl wel vb vl wel wa vl cL wreu wi vb cP
      wral va cP wral va cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va cP
      wrex vl cL wral va vl wel vb vl wel vx vl wel w3a wn vl cL wral vx cP
      wrex vb cP wrex va cP wrex cL cplig wcel va cv vb cv wne va vl wel vb vl
      wel wa vl cL wreu wi vb cP wral va cP wral va cv vb cv wne va vl wel vb
      vl wel w3a vb cP wrex va cP wrex vl cL wral va vl wel vb vl wel vx vl wel
      w3a wn vl cL wral vx cP wrex vb cP wrex va cP wrex w3a cplig cP cL va vb
      vx vl efp.1 isplig ibi 3simp1d $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)

  $}

  ${ $d A a b l $. $d B b l $. $d L a b l $. $d P a b $.
    efp2.1 $e |- P = U. L $.
    $( Euclid's first postulate. There is a unique line passing through two
       distinct points. $)
    efp2 $p |- ( ( L e. Plig /\ A e. P /\ B e. P ) -> ( A =/= B
        -> E! l e. L ( A e. l /\ B e. l ) ) ) $=
      cL cplig wcel cA cP wcel cB cP wcel cA cB wne cA vl cv wcel cB vl cv wcel
      wa vl cL wreu wi cL cplig wcel va cv vb cv wne va vl wel vb vl wel wa vl
      cL wreu wi vb cP wral va cP wral cA cP wcel cB cP wcel cA cB wne cA vl cv
      wcel cB vl cv wcel wa vl cL wreu wi wi wi cP cL va vb vl efp2.1 efp cA cP
      wcel cB cP wcel va cv vb cv wne va vl wel vb vl wel wa vl cL wreu wi vb
      cP wral va cP wral cA cB wne cA vl cv wcel cB vl cv wcel wa vl cL wreu wi
      cA cP wcel cB cP wcel va cv vb cv wne va vl wel vb vl wel wa vl cL wreu
      wi vb cP wral va cP wral cA cB wne cA vl cv wcel cB vl cv wcel wa vl cL
      wreu wi wi va cv vb cv wne va vl wel vb vl wel wa vl cL wreu wi cA cB wne
      cA vl cv wcel cB vl cv wcel wa vl cL wreu wi cA vb cv wne cA vl cv wcel
      vb vl wel wa vl cL wreu wi va vb cA cB cP cP va cv cA wceq va cv vb cv
      wne cA vb cv wne va vl wel vb vl wel wa vl cL wreu cA vl cv wcel vb vl
      wel wa vl cL wreu va cv cA vb cv neeq1 va cv cA wceq va vl wel vb vl wel
      wa cA vl cv wcel vb vl wel wa vl cL va cv cA wceq va vl wel cA vl cv wcel
      vb vl wel va cv cA vl cv eleq1 anbi1d reubidv imbi12d vb cv cB wceq cA vb
      cv wne cA cB wne cA vl cv wcel vb vl wel wa vl cL wreu cA vl cv wcel cB
      vl cv wcel wa vl cL wreu vb cv cB cA neeq2 vb cv cB wceq cA vl cv wcel vb
      vl wel wa cA vl cv wcel cB vl cv wcel wa vl cL vb cv cB wceq vb vl wel cB
      vl cv wcel cA vl cv wcel vb cv cB vl cv eleq1 anbi2d reubidv imbi12d
      rcla42v ex com3r syl 3imp $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

  ${ $d L a b l x $. $d P a b x $.
    l2p.1 $e |- P = U. L $.
    $( Any line has at least two distinct points. $)
    l2p $p |- ( L e. Plig -> A. l e. L E. a e. P E. b e. P
       ( a =/= b /\  a e. l /\ b e. l ) ) $=
      cL cplig wcel va cv vb cv wne va vl wel vb vl wel wa vl cL wreu wi vb cP
      wral va cP wral va cv vb cv wne va vl wel vb vl wel w3a vb cP wrex va cP
      wrex vl cL wral va vl wel vb vl wel vx vl wel w3a wn vl cL wral vx cP
      wrex vb cP wrex va cP wrex cL cplig wcel va cv vb cv wne va vl wel vb vl
      wel wa vl cL wreu wi vb cP wral va cP wral va cv vb cv wne va vl wel vb
      vl wel w3a vb cP wrex va cP wrex vl cL wral va vl wel vb vl wel vx vl wel
      w3a wn vl cL wral vx cP wrex vb cP wrex va cP wrex w3a cplig cP cL va vb
      vx vl l2p.1 isplig ibi 3simp2d $.
      $( [3-Aug-2009] $) $( [2-Aug-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Planar incidence betweenness geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Plibg $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg $a class Plibg $.

  $c Plibg0 $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg0 $a class Plibg0 $.

  $c Plibg1 $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg1 $a class Plibg1 $.

  $c Plibg2 $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg2 $a class Plibg2 $.

  $c Plibg3 $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg3 $a class Plibg3 $.

  $c Plibg4a $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg4a $a class Plibg4a $.

  $c Plibg4b $.

  $( Extend class notation with the class of all planar incidence betweenness
     geometries. $)
  cplibg4b $a class Plibg4b $.


  ${ $d x y $.
    $( Planar incidence betweenness geometry is a set equipped with an
       incidence relation and a betweenness relation. The betweenness
       relation is a relation between three points of the plane.
       Aitken's axiom B-0. $)
    df-plibg0 $a |- Plibg0 = { <. x , y >. | ( ( x e. Plig /\
         Rel y /\ Rel dom y ) /\ ( dom dom y = U. x /\ ran dom y = U. x /\
         ran y = U. x ) ) } $.
  $}

  ${ $d x y p q r l $.
    $( The betweenness relation is only defined for distinct points.
       If ` q ` is between ` p ` and ` r ` then the three points are
       colinear and ` q ` is between ` r ` and ` p `. Aitken's axiom B-1. $)
    df-plibg1 $a |- Plibg1 = { <. x , y >. |
        A. p e. U. x A. q e. U. x A. r e. U. x
           ( <. <. p , q >. , r >. e. y ->
               ( <. <. r , q >. , p >. e. y
                 /\ E. l e. x ( p e. l /\ q e. l /\ r e. l )
                 /\ ( p =/= q /\ p =/= r /\ q =/= r ) ) ) } $.
  $}

  ${ $d x y a b c d e $.
    $( For any two  distinct points ` b ` and `  d ` then there exists
       three points ` a `, ` c `, ` e ` such that ` b ` is between ` a
       ` and ` d `. ` c ` is between ` b ` and ` d `, ` d ` is between
       ` b ` and ` e `. Aitken's axiom B-2. $)
    df-plibg2 $a |- Plibg2 = { <. x , y >. |
      A. b e. U. x A. d e. U. x ( b =/= d ->
      E. a e. U. x E. c e. U. x E. e e. U. x
             ( <. <. a , b >. , d >. e. y
               /\ <. <. b , c >. , d >. e. y
               /\ <. <. b , d >. , e >. e. y ) ) } $.
  $}

  ${ $d x y l p q r $.
    $( For any  three distinct colinear points ` p  ` , ` q `  , ` r `
       then ` p ` is between ` q ` and ` r ` or ` q ` is between ` p `
       and ` r ` or  ` r ` is between ` p ` and  ` q `. Aitken's axiom
       B-3. $)
    df-plibg3 $a |- Plibg3 = { <. x , y >. |
        A. l e. x A. p e. U. x A. q e. U. x A. r e. U. x
           ( ( ( p e. l /\ q e. l /\ r e. l ) /\
             ( p =/= q /\ q =/= r /\ p =/= r ) ) ->
             ( (    <. <. q , p >. , r >. e. y /\
                 -. <. <. p , q >. , r >. e. y /\
                 -. <. <. p , r >. , q >. e. y ) \/
               ( -. <. <. q , p >. , r >. e. y /\
                    <. <. p , q >. , r >. e. y /\
                 -. <. <. p , r >. , q >. e. y ) \/
               ( -. <. <. q , p >. , r >. e. y /\
                 -. <. <. p , q >. , r >. e. y /\
                    <. <. p , r >. , q >. e. y ) ) ) } $.
  $}

  ${ $d x y l p q r a $.
    $( If the segment ` p ` ` q ` doesn't intersect the line ` l ` and
       the segment ` q  ` ` r ` doesn't intersect the  line ` l ` then
       the segment  ` p `  ` r `  doesn't intersect the  line ` l  ` .
       Aitken's axiom B-4 1st part. $)
    df-plibg4a $a |- Plibg4a = { <. x , y >. |
      A. l e. x A. p e. U. x A. q e. U. x A. r e. U. x
       ( ( ( -. p e. l /\ -. q e. l /\ -. r e. l ) /\
           ( { a e. U. x | ( <. <. p , a >. , q >. e. y \/ a = p \/ a = q ) }
                i^i l ) = (/) /\
           ( { a e. U. x | ( <. <. q , a >. , r >. e. y \/ a = q \/ a = r ) }
                 i^i l ) = (/) )
       -> ( { a e. U. x | ( <. <. p , a >. , r >. e. y \/ a = p \/ a = r ) }
                 i^i l ) = (/) ) } $.
  $}

  ${ $d x y l p q r a $.
    $( Aitken's axiom B-4 2nd part. $)
    df-plibg4b $a |- Plibg4b = { <. x , y >. |
      A. l e. x A. p e. U. x A. q e. U. x A. r e. U. x
       ( ( ( -. p e. l /\ -. q e. l /\ -. r e. l ) /\
         ( ( { a e. U. x | <. <. p , a >. , q >. e. y } i^i l ) =/= (/) /\
         ( { a e. U. x | <. <. q , a >. , r >. e. y } i^i l ) =/= (/) ) )
       -> ( { a e. U. x | <. <. q , a >. , r >. e. y } i^i l ) = (/) ) } $.
  $}

  df-plibg $a |- Plibg = ( Plibg0 i^i ( Plibg1 i^i ( Plibg2 i^i ( Plibg3
                           i^i ( Plibg4a i^i Plibg4b ) ) ) ) ) $.

$( (End of FL's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Jeff Hankins
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                              Miscellany
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    a1i13.1 $e |- ( ps -> th ) $.
    $( Add two antecedents to a wff. $)
    a1i13 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      wps wch wth wi wi wph wps wth wch a1i13.1 a1d a1i $.
      $( [30-Aug-2009] $) $( [4-Aug-2009] $)
  $}

  ${
    a1i4.1 $e |- ( ph -> ( ps -> ( ch -> ta ) ) ) $.
    $( Add an antecedent to a wff. $)
    a1i4 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wch wta wth wta wi a1i4.1 wta wth ax-1 syl8 $.
      $( [27-Nov-2009] $) $( [4-Aug-2009] $)
  $}

  ${
    a1i14.1 $e |- ( ps -> ( ch -> ta ) ) $.
    $( Add two antecedents to a wff. $)
    a1i14 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wps wch wth wta wi wi wi wph wps wch wta wth a1i14.1 a1dd a1i $.
      $( [4-Aug-2009] $) $( [4-Aug-2009] $)
  $}

  ${
    a1i24.1 $e |- ( ph -> ( ch -> ta ) ) $.
    $( Add two antecedents to a wff. $)
    a1i24 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wch wth wta wi wi wps wph wch wta wth a1i24.1 a1dd a1d $.
      $( [5-Aug-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    a1i34.1 $e |- ( ph -> ( ps -> ta ) ) $.
    $( Add two antecedents to a wff. $)
    a1i34 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      wph wps wth wta wi wch wph wps wta wth a1i34.1 a1dd a1dd $.
      $( [22-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    impbid3.1 $e |- ( ph -> ( ps -> ch ) ) $.
    impbid3.2 $e |- ( ph -> ( -. ps -> -. ch ) ) $.
    $( A variation on ~ impbid . $)
    impbid3 $p |- ( ph -> ( ps <-> ch ) ) $=
      wph wps wch impbid3.1 wph wps wch impbid3.2 con4d impbid $.
      $( [3-Jul-2009] $) $( [3-Jul-2009] $)
  $}

  ${
    $v et $.
    imp5.et $f wff et $.
    imp5.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( An importation inference. $)
    imp5a $p |- ( ph -> ( ps -> ( ch -> ( ( th /\ ta ) -> et ) ) ) ) $=
      wth wta wa wph wps wch imp5.et wth wta wph wps wch imp5.et wi wi wi wph
      wps wch wth wta imp5.et imp5.1 com52r imp com4l $.
      $( [7-Jul-2009] $) $( [7-Jul-2009] $)

    $( An importation inference. $)
    imp5g $p |- ( ( ph /\ ps ) -> ( ( ( ch /\ th ) /\ ta ) -> et ) ) $=
      wph wps wa wch wth wta imp5.et wph wps wch wth wta imp5.et wi wi wi
      imp5.1 imp imp4c $.
      $( [19-Aug-2009] $) $( [7-Jul-2009] $)

    $( An importation inference. $)
    imp55 $p |- ( ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) /\ ta ) -> et ) $=
      wph wps wch wth wa wta imp5.et wph wps wch wth wta imp5.et wi imp5.1
      imp4a imp42 $.
      $( [7-Jul-2009] $) $( [7-Jul-2009] $)

    $( An importation inference. $)
    imp511 $p |- ( ( ph /\ ( ( ps /\ ( ch /\ th ) ) /\ ta ) ) -> et ) $=
      wph wps wch wth wa wta imp5.et wph wps wch wth wta imp5.et wi imp5.1
      imp4a imp44 $.
      $( [22-Sep-2009] $) $( [7-Jul-2009] $)
  $}

  ${
    $v et $.
    exp5.et $f wff et $.
    ${
      exp5c.1 $e |- ( ph -> ( ( ps /\ ch ) -> ( ( th /\ ta ) -> et ) ) ) $.
      $( An exportation inference. $)
      exp5c $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wi wi wph wps wch wa wth wta exp5.et
        exp5c.1 exp4a exp3a $.
        $( [22-Sep-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp5d.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> ( ( th /\ ta ) -> et ) ) $.
      $( An exportation inference. $)
      exp5d $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wi wi wph wps wa wch wa wth wta exp5.et
        exp5d.1 exp3a exp31 $.
        $( [3-Dec-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp5g.1 $e |- ( ( ph /\ ps ) -> ( ( ( ch /\ th ) /\ ta ) -> et ) ) $.
      $( An exportation inference. $)
      exp5g $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wi wi wi wph wps wa wch wth wta exp5.et
        exp5g.1 exp4c ex $.
        $( [22-Sep-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp5j.1 $e |- ( ph -> ( ( ( ( ps /\ ch ) /\ th ) /\ ta ) -> et ) ) $.
      $( An exportation inference. $)
      exp5j $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wi wph wps wch wa wth wa wta exp5.et
        exp5j.1 exp3a exp4c $.
        $( [22-Sep-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp5k.1 $e |- ( ph -> ( ( ( ps /\ ( ch /\ th ) ) /\ ta ) -> et ) ) $.
      $( An exportation inference. $)
      exp5k $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wi wph wps wch wth wa wa wta exp5.et
        exp5k.1 exp3a exp4d $.
        $( [7-Jul-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp5l.1 $e |- ( ph -> ( ( ( ps /\ ch ) /\ ( th /\ ta ) ) -> et ) ) $.
      $( An exportation inference. $)
      exp5l $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wph wps wch wa wth wta wa exp5.et exp5l.1
        exp3a exp5c $.
        $( [27-Jan-2010] $) $( [7-Jul-2009] $)
    $}

    ${
      exp56.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ ( th /\ ta ) ) -> et ) $.
      $( An exportation inference. $)
      exp56 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wph wps wa wch wa wth wta wa exp5.et
        exp56.1 ex exp5d $.
        $( [3-Dec-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp58.1 $e |- ( ( ( ph /\ ps ) /\ ( ( ch /\ th ) /\ ta ) ) -> et ) $.
      $( An exportation inference. $)
      exp58 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wph wps wa wch wth wa wta wa exp5.et
        exp58.1 ex exp5g $.
        $( [22-Sep-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp510.1 $e |- ( ( ph /\ ( ( ( ps /\ ch ) /\ th ) /\ ta ) ) -> et ) $.
      $( An exportation inference. $)
      exp510 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wph wps wch wa wth wa wta wa exp5.et
        exp510.1 ex exp5j $.
        $( [22-Sep-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp511.1 $e |- ( ( ph /\ ( ( ps /\ ( ch /\ th ) ) /\ ta ) ) -> et ) $.
      $( An exportation inference. $)
      exp511 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wph wps wch wth wa wa wta wa exp5.et
        exp511.1 ex exp5k $.
        $( [7-Jul-2009] $) $( [7-Jul-2009] $)
    $}

    ${
      exp512.1 $e |- ( ( ph /\ ( ( ps /\ ch ) /\ ( th /\ ta ) ) ) -> et ) $.
      $( An exportation inference. $)
      exp512 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
        wph wps wch wth wta exp5.et wph wps wch wa wth wta wa wa exp5.et
        exp512.1 ex exp5l $.
        $( [27-Jan-2010] $) $( [7-Jul-2009] $)
    $}
  $}

  ${
    expl.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Export a wff from a left conjunct. $)
    expl $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      wph wps wch wth wph wps wch wth expl.1 exp31 imp3a $.
      $( [22-Sep-2009] $) $( [28-Aug-2009] $)
  $}


  ${
    mtord.1 $e |- ( ph -> -. ch ) $.
    mtord.2 $e |- ( ph -> -. th ) $.
    mtord.3 $e |- ( ph -> ( ps -> ( ch \/ th ) ) ) $.
    $( A modus tollens deduction involving disjunction. $)
    mtord $p |- ( ph -> -. ps ) $=
      wph wps wth mtord.2 wph wps wch wn wth mtord.1 wph wps wch wth wo wch wn
      wth wi mtord.3 wch wth df-or syl6ib mpid mtod $.
      $( [19-Aug-2009] $) $( [15-Jul-2009] $)
  $}

  ${
    3com12d.1 $e |- ( ph -> ( ps /\ ch /\ th ) ) $.
    $( Commutation in consequent. Swap 1st and 2nd. $)
    3com12d $p |- ( ph -> ( ch /\ ps /\ th ) ) $=
      wph wps wch wth w3a wch wps wth w3a 3com12d.1 wch wps wth wch wps wth w3a
      wch wps wth w3a id 3com12 syl $.
      $( [17-Nov-2009] $) $( [17-Nov-2009] $)
  $}

  ${
    $v et $.
    3imp5.et $f wff et $.
    3imp5.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( A triple importation inference. $)
    imp5p $p |- ( ph -> ( ps -> ( ( ch /\ th /\ ta ) -> et ) ) ) $=
      wch wth wta w3a wph wps 3imp5.et wch wth wta wph wps 3imp5.et wi wi wph
      wps wch wth wta 3imp5.et 3imp5.1 com52l 3imp com3l $.
      $( [3-Dec-2009] $) $( [8-Jul-2009] $)

    $( A triple importation inference. $)
    imp5q $p |- ( ( ph /\ ps ) -> ( ( ch /\ th /\ ta ) -> et ) ) $=
      wph wps wa wch wth wta 3imp5.et wph wps wch wth wta 3imp5.et wi wi wi
      3imp5.1 imp 3impd $.
      $( [30-Aug-2009] $) $( [8-Jul-2009] $)
  $}


  ${
    ecase13d.1 $e |- ( ph -> -. ch ) $.
    ecase13d.2 $e |- ( ph -> -. th ) $.
    ecase13d.3 $e |- ( ph -> ( ch \/ ps \/ th ) ) $.
    $( Deduction for elimination by cases. $)
    ecase13d $p |- ( ph -> ps ) $=
      wph wth wn wps ecase13d.2 wph wps wth wo wth wn wps wi wph wch wn wps wth
      wo ecase13d.1 wph wch wps wth w3o wch wn wps wth wo wi ecase13d.3 wch wps
      wth w3o wch wps wth wo wo wch wn wps wth wo wi wch wps wth 3orass wch wps
      wth wo df-or bitri sylib mpd wps wth wo wth wps wo wth wn wps wi wps wth
      orcom wth wps df-or bitri sylib mpd $.
      $( [30-Aug-2009] $) $( [18-Aug-2009] $)
  $}

  ${
    $d x A $.
    $( A response to the notion that the condition ` A =/= (/) ` can be removed
    in ~ r19.2z . Interestingly enough, ` ph ` does not figure in the left-hand
    side. $)
    r19.2zb $p |- ( A =/= (/) <-> ( A. x e. A ph -> E. x e. A ph ) ) $=
      cA c0 wne wph vx cA wral wph vx cA wrex wi cA c0 wne wph vx cA wral wph
      vx cA wrex wph vx cA r19.2z ex wph vx cA wral wph vx cA wrex cA c0 wne
      wph vx cA wral cA c0 cA c0 wceq wph vx cA wral wph vx c0 wral wph vx c0
      vx cv c0 wcel wph vx cv noel pm2.21i rgen wph vx cA c0 raleq1 mpbiri
      necon3bi vx cv cA wcel wph wa vx wex vx cv cA wcel vx wex wph vx cA wrex
      cA c0 wne vx cv cA wcel wph wa vx cv cA wcel vx vx cv cA wcel wph pm3.26
      19.22i wph vx cA df-rex vx cA n0 3imtr4i ja impbii $.
      $( [30-Aug-2009] $) $( [24-Aug-2009] $)
  $}

  ${
    $d y ph $. $d x y ps $. $d x y A $.
    eqeu.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A condition which implies existential uniqueness. $)
    eqeu $p |- ( ( A e. B /\ ps /\ A. x ( ph -> x = A ) ) -> E! x ph ) $=
      cA cB wcel wps wph vx cv cA wceq wi vx wal w3a wph vx wex wph vx cv vy cv
      wceq wi vx wal vy wex wa wph vx weu cA cB wcel wps wph vx cv cA wceq wi
      vx wal w3a wph vx wex wph vx cv vy cv wceq wi vx wal vy wex cA cB wcel
      wps wph vx wex wph vx cv cA wceq wi vx wal cA cB wcel wps wph vx wex wph
      wps vx cA cB eqeu.1 cla4egv imp 3adant3 cA cB wcel wph vx cv cA wceq wi
      vx wal wph vx cv vy cv wceq wi vx wal vy wex wps cA cB wcel wph vx cv cA
      wceq wi vx wal wph vx cv vy cv wceq wi vx wal vy wex wph vx cv vy cv wceq
      wi vx wal wph vx cv cA wceq wi vx wal vy cA cB vy cv cA wceq wph vx cv vy
      cv wceq wi wph vx cv cA wceq wi vx vy cv cA wceq vx cv vy cv wceq vx cv
      cA wceq wph vy cv cA vx cv eqeq2 imbi2d albidv cla4egv imp 3adant2 jca
      wph vx vy wph vy ax-17 eu3 sylibr $.
      $( [22-Sep-2009] $) $( [8-Sep-2009] $)
  $}

  ${
    $d z w ph $. $d z w ps $. $d z w ch $. $d y z w A $. $d y z w B $. $d y z w
    X $. $d y z w Y $. $d y z w Z $. $d x y z w $.
    subtr.1 $e |- ( y e. A -> A. x y e. A ) $.
    subtr.2 $e |- ( y e. B -> A. x y e. B ) $.
    ${
    subtr.3 $e |- ( y e. Y -> A. x y e. Y ) $.
    subtr.4 $e |- ( y e. Z -> A. x y e. Z ) $.
    subtr.5 $e |- ( x = A -> X = Y ) $.
    subtr.6 $e |- ( x = B -> X = Z ) $.
    $( Transitivity of implicit substitution. $)
    subtr $p |- ( ( A e. C /\ B e. D ) -> ( A = B -> Y = Z ) ) $=
      vz cv vw cv wceq vx vz cv cX csb vx vw cv cX csb wceq wi cA vw cv wceq cY
      vx vw cv cX csb wceq wi cA cB wceq cY cZ wceq wi vz vw cA cB cC cD vz cv
      cA wceq vz cv vw cv wceq cA vw cv wceq vx vz cv cX csb vx vw cv cX csb
      wceq cY vx vw cv cX csb wceq vz cv cA vw cv eqeq1 vz cv cA wceq vx vz cv
      cX csb cY vx vw cv cX csb vx cv vz cv wceq vx wex vz cv cA wceq vx vz cv
      cX csb cY wceq wi vx vz a9e vx cv vz cv wceq vz cv cA wceq vx vz cv cX
      csb cY wceq wi vx vz cv cA wceq vx vz cv cX csb cY wceq vx vx vy vy vz cv
      cA vy cv vz cv wcel vx ax-17 subtr.1 hbeq vx vy vy vx vz cv cX csb cY vx
      vy vz cv cX vz visset vy cv vz cv wcel vx ax-17 hbcsb1 subtr.3 hbeq hbim
      vx cv vz cv wceq vz cv cA wceq vx cv cA wceq vx vz cv cX csb cY wceq vx
      cv vz cv cA eqeq1 vx cv vz cv wceq vx cv cA wceq vx vz cv cX csb cY wceq
      vx cv vz cv wceq vx cv cA wceq vx vz cv cX csb cX cY vx vz cv cX csbeq1a
      subtr.5 sylan9req ex sylbird 19.23ai ax-mp eqeq1d imbi12d vw cv cB wceq
      cA vw cv wceq cA cB wceq cY vx vw cv cX csb wceq cY cZ wceq vw cv cB cA
      eqeq2 vw cv cB wceq vx vw cv cX csb cZ cY vx cv vw cv wceq vx wex vw cv
      cB wceq vx vw cv cX csb cZ wceq wi vx vw a9e vx cv vw cv wceq vw cv cB
      wceq vx vw cv cX csb cZ wceq wi vx vw cv cB wceq vx vw cv cX csb cZ wceq
      vx vx vy vy vw cv cB vy cv vw cv wcel vx ax-17 subtr.2 hbeq vx vy vy vx
      vw cv cX csb cZ vx vy vw cv cX vw visset vy cv vw cv wcel vx ax-17 hbcsb1
      subtr.4 hbeq hbim vx cv vw cv wceq vw cv cB wceq vx cv cB wceq vx vw cv
      cX csb cZ wceq vx cv vw cv cB eqeq1 vx cv vw cv wceq vx cv cB wceq vx vw
      cv cX csb cZ wceq vx cv vw cv wceq vx cv cB wceq vx vw cv cX csb cX cZ vx
      vw cv cX csbeq1a subtr.6 sylan9req ex sylbird 19.23ai ax-mp eqeq2d
      imbi12d vx vz cv vw cv cX csbeq1 vtocl2g $.
      $( [22-Sep-2009] $) $( [13-Sep-2009] $)
    $}

    ${
      subtr2.3 $e |- ( ps -> A. x ps ) $.
      subtr2.4 $e |- ( ch -> A. x ch ) $.
      subtr2.5 $e |- ( x = A -> ( ph <-> ps ) ) $.
      subtr2.6 $e |- ( x = B -> ( ph <-> ch ) ) $.
      $( Transitivity of implicit substitution into a wff. $)
      subtr2 $p |- ( ( A e. C /\ B e. D ) -> ( A = B -> ( ps <-> ch ) ) ) $=
        vz cv vw cv wceq wph vx vz cv wsbc wph vx vw cv wsbc wb wi cA vw cv
        wceq wps wph vx vw cv wsbc wb wi cA cB wceq wps wch wb wi vz vw cA cB
        cC cD vz cv cA wceq vz cv vw cv wceq cA vw cv wceq wph vx vz cv wsbc
        wph vx vw cv wsbc wb wps wph vx vw cv wsbc wb vz cv cA vw cv eqeq1 vz
        cv cA wceq wph vx vz cv wsbc wps wph vx vw cv wsbc vx cv vz cv wceq vx
        wex vz cv cA wceq wph vx vz cv wsbc wps wb wi vx vz a9e vx cv vz cv
        wceq vz cv cA wceq wph vx vz cv wsbc wps wb wi vx vz cv cA wceq wph vx
        vz cv wsbc wps wb vx vx vy vy vz cv cA vy cv vz cv wcel vx ax-17
        subtr.1 hbeq wph vx vz cv wsbc wps vx wph vx vz cv vz visset hbsbc1v
        subtr2.3 hbbi hbim vx cv vz cv wceq vz cv cA wceq vx cv cA wceq wph vx
        vz cv wsbc wps wb vx cv vz cv cA eqeq1 vx cv vz cv wceq vx cv cA wceq
        wph vx vz cv wsbc wps wb vx cv vz cv wceq wph vx vz cv wsbc wph vx cv
        cA wceq wps vx cv vz cv wceq wph wph vx vz cv wsbc wph vx vz cv sbceq1a
        bicomd subtr2.5 sylan9bb ex sylbird 19.23ai ax-mp bibi1d imbi12d vw cv
        cB wceq cA vw cv wceq cA cB wceq wps wph vx vw cv wsbc wb wps wch wb vw
        cv cB cA eqeq2 vw cv cB wceq wph vx vw cv wsbc wch wps vx cv vw cv wceq
        vx wex vw cv cB wceq wph vx vw cv wsbc wch wb wi vx vw a9e vx cv vw cv
        wceq vw cv cB wceq wph vx vw cv wsbc wch wb wi vx vw cv cB wceq wph vx
        vw cv wsbc wch wb vx vx vy vy vw cv cB vy cv vw cv wcel vx ax-17
        subtr.2 hbeq wph vx vw cv wsbc wch vx wph vx vw cv vw visset hbsbc1v
        subtr2.4 hbbi hbim vx cv vw cv wceq vw cv cB wceq vx cv cB wceq wph vx
        vw cv wsbc wch wb vx cv vw cv cB eqeq1 vx cv vw cv wceq vx cv cB wceq
        wph vx vw cv wsbc wch wb vx cv vw cv wceq wph vx vw cv wsbc wph vx cv
        cB wceq wch vx cv vw cv wceq wph wph vx vw cv wsbc wph vx vw cv sbceq1a
        bicomd subtr2.6 sylan9bb ex sylbird 19.23ai ax-mp bibi2d imbi12d wph vx
        vz cv vw cv dfsbcq vtocl2g $.
        $( [22-Sep-2009] $) $( [19-Sep-2009] $)
    $}
  $}

  ${
    $d w A $. $d z w C $. $d z w D $. $d z w x y $.
    cbvcsb.1 $e |- ( z e. C -> A. y z e. C ) $.
    cbvcsb.2 $e |- ( z e. D -> A. x z e. D ) $.
    cbvcsb.3 $e |- ( x = y -> C = D ) $.
    $( Change bound variables in a class substitution. Interestingly, this does
    not require any bound variable conditions on ` A ` . $)
    cbvcsb $p |- ( A e. B -> [_ A / x ]_ C = [_ A / y ]_ D ) $=
      vx vw cv cC csb vy vw cv cD csb wceq vx cA cC csb vy cA cD csb wceq vw cA
      cB vw cv cA wceq vx vw cv cC csb vx cA cC csb vy vw cv cD csb vy cA cD
      csb vx vw cv cA cC csbeq1 vy vw cv cA cD csbeq1 eqeq12d vx vz vw cv cC vy
      vw cv cD csb vw visset vw cv cvv wcel vz cv vy vw cv cD csb wcel vz cv vy
      vw cv cD csb wcel vx wal wi vw visset vx vy vz vw cv cD cvv vz cv vw cv
      wcel vx ax-17 cbvcsb.2 hbcsbg ax-mp vx cv cvv wcel vw cv cvv wcel vx cv
      vw cv wceq cC vy vw cv cD csb wceq wi vx visset vw visset vy vz vx cv vw
      cv cvv cvv cD cC vy vw cv cD csb vz cv vx cv wcel vy ax-17 vz cv vw cv
      wcel vy ax-17 cbvcsb.1 vy vz vw cv cD vw visset vz cv vw cv wcel vy ax-17
      hbcsb1 cD cC wceq vx cv vy cv vx cv vy cv wceq cC cD cbvcsb.3 eqcomd
      eqcoms vy vw cv cD csbeq1a subtr mp2an csbief vtoclg $.
      $( [22-Sep-2009] $) $( [13-Sep-2009] $)
  $}

  ${
    $d z w ph $. $d z w ps $. $d z w A $. $d z w B $. $d z w x y $.
    cbvsbc.1 $e |- ( ph -> A. y ph ) $.
    cbvsbc.2 $e |- ( ps -> A. x ps ) $.
    cbvsbc.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variables in a wff substitution. $)
    cbvsbc $p |- ( A e. B -> ( [ A / x ] ph <-> [ A / y ] ps ) ) $=
      wph vx vz cv wsbc wps vy vz cv wsbc wb wph vx cA wsbc wps vy cA wsbc wb
      vz cA cB vz cv cA wceq wph vx vz cv wsbc wph vx cA wsbc wps vy vz cv wsbc
      wps vy cA wsbc wph vx vz cv cA dfsbcq wps vy vz cv cA dfsbcq bibi12d vz
      cv cvv wcel wph vx vz cv wsbc wps vy vz cv wsbc wb vz visset wph wps vy
      vz cv wsbc vx vz cv cvv wps vx vy vw vz cv cvv vw cv vz cv wcel vx ax-17
      cbvsbc.2 hbsbcg vx cv cvv wcel vz cv cvv wcel vx cv vz cv wceq wph wps vy
      vz cv wsbc wb wi vx visset vz visset wps wph wps vy vz cv wsbc vy vw vx
      cv vz cv cvv cvv vw cv vx cv wcel vy ax-17 vw cv vz cv wcel vy ax-17
      cbvsbc.1 wps vy vz cv vz visset hbsbc1v wps wph wb vx cv vy cv vx cv vy
      cv wceq wph wps cbvsbc.3 bicomd eqcoms wps vy vz cv sbceq1a subtr2 mp2an
      sbciegf ax-mp vtoclg $.
      $( [22-Sep-2009] $) $( [19-Sep-2009] $)
  $}

  ${
    $d y z w A $. $d y z w B $. $d w C $. $d w x y z $.
    $( Alternate definition of indexed intersection when ` B ` is a set. $)
    dfiin2g $p |- ( A. x e. A B e. C -> |^|_ x e. A B = |^| { y | E. x e. A y =
    B } ) $=
      cB cC wcel vx cA wral vw cv cB wcel vx cA wral vw cab vz cv vy cv cB wceq
      vx cA wrex vy cab wcel vw cv vz cv wcel wi vz wal vw cab vx cA cB ciin vy
      cv cB wceq vx cA wrex vy cab cint cB cC wcel vx cA wral vw cv cB wcel vx
      cA wral vz cv vy cv cB wceq vx cA wrex vy cab wcel vw cv vz cv wcel wi vz
      wal vw cB cC wcel vx cA wral vx cv cA wcel vw cv cB wcel wi vx wal vz cv
      vy cv cB wceq vx cA wrex vy cab wcel vw cv vz cv wcel wi vz wal vw cv cB
      wcel vx cA wral cB cC wcel vx cA wral vx cv cA wcel vw cv cB wcel wi vx
      wal vx cv cA wcel vz cv cB wceq vw cv vz cv wcel wi vz wal wi vx wal vz
      cv vy cv cB wceq vx cA wrex vy cab wcel vw cv vz cv wcel wi vz wal cB cC
      wcel vx cA wral vx cv cA wcel cB cC wcel wi vx wal vx cv cA wcel vw cv cB
      wcel wi vx wal vx cv cA wcel vz cv cB wceq vw cv vz cv wcel wi vz wal wi
      vx wal wb cB cC wcel vx cA df-ral vx cv cA wcel cB cC wcel wi vx wal vx
      cv cA wcel vw cv cB wcel wi vx cv cA wcel vz cv cB wceq vw cv vz cv wcel
      wi vz wal wi wb vx wal vx cv cA wcel vw cv cB wcel wi vx wal vx cv cA
      wcel vz cv cB wceq vw cv vz cv wcel wi vz wal wi vx wal wb vx cv cA wcel
      cB cC wcel wi vx cv cA wcel vw cv cB wcel wi vx cv cA wcel vz cv cB wceq
      vw cv vz cv wcel wi vz wal wi wb vx vx cv cA wcel cB cC wcel wi vx cv cA
      wcel vw cv cB wcel vz cv cB wceq vw cv vz cv wcel wi vz wal cB cC wcel vw
      cv cB wcel vz cv cB wceq vw cv vz cv wcel wi vz wal wb vx cv cA wcel cB
      cC wcel vw cv cB wcel vz cv cB wceq vw cv vz cv wcel wi vz wal vw cv cB
      wcel vz cv cB wceq vw cv vz cv wcel wi vz vz cv cB wceq vw cv vz cv wcel
      vw cv cB wcel vz cv cB vw cv eleq2 biimprcd 19.21aiv cB cC wcel vz cv cB
      wceq vw cv vz cv wcel wi vz wal cB cB wceq vw cv cB wcel cB eqid vz cv cB
      wceq vw cv vz cv wcel wi cB cB wceq vw cv cB wcel wi vz cB cC vz cv cB
      wceq vz cv cB wceq cB cB wceq vw cv vz cv wcel vw cv cB wcel vz cv cB cB
      eqeq1 vz cv cB vw cv eleq2 imbi12d cla4gv mpii impbid2 imim2i pm5.74d
      19.20i vx cv cA wcel vw cv cB wcel wi vx cv cA wcel vz cv cB wceq vw cv
      vz cv wcel wi vz wal wi vx 19.15 syl sylbi vx cv cA wcel vz cv cB wceq vw
      cv vz cv wcel wi vz wal wi vx wal vz cv cB wceq vw cv vz cv wcel wi vx cA
      wral vz wal vz cv vy cv cB wceq vx cA wrex vy cab wcel vw cv vz cv wcel
      wi vz wal vz cv cB wceq vw cv vz cv wcel wi vx cA wral vz wal vx cv cA
      wcel vz cv cB wceq vw cv vz cv wcel wi wi vx wal vz wal vx cv cA wcel vz
      cv cB wceq vw cv vz cv wcel wi wi vz wal vx wal vx cv cA wcel vz cv cB
      wceq vw cv vz cv wcel wi vz wal wi vx wal vz cv cB wceq vw cv vz cv wcel
      wi vx cA wral vx cv cA wcel vz cv cB wceq vw cv vz cv wcel wi wi vx wal
      vz vz cv cB wceq vw cv vz cv wcel wi vx cA df-ral albii vx cv cA wcel vz
      cv cB wceq vw cv vz cv wcel wi wi vx vz alcom vx cv cA wcel vz cv cB wceq
      vw cv vz cv wcel wi wi vz wal vx cv cA wcel vz cv cB wceq vw cv vz cv
      wcel wi vz wal wi vx vx cv cA wcel vz cv cB wceq vw cv vz cv wcel wi vz
      19.21v albii 3bitr2ri vz cv cB wceq vw cv vz cv wcel wi vx cA wral vz cv
      vy cv cB wceq vx cA wrex vy cab wcel vw cv vz cv wcel wi vz vz cv cB wceq
      vw cv vz cv wcel wi vx cA wral vz cv cB wceq vx cA wrex vw cv vz cv wcel
      wi vz cv vy cv cB wceq vx cA wrex vy cab wcel vw cv vz cv wcel wi vz cv
      cB wceq vw cv vz cv wcel vx cA r19.23v vz cv vy cv cB wceq vx cA wrex vy
      cab wcel vz cv cB wceq vx cA wrex vw cv vz cv wcel vy cv cB wceq vx cA
      wrex vz cv cB wceq vx cA wrex vy vz cv vz visset vy cv vz cv wceq vy cv
      cB wceq vz cv cB wceq vx cA vy cv vz cv cB eqeq1 rexbidv elab imbi1i
      bitr4i albii bitri syl6bb vw cv cB wcel vx cA df-ral syl5bb abbidv vx vw
      cA cB df-iin vw vz vy cv cB wceq vx cA wrex vy cab df-int 3eqtr4g $.
      $( [30-Aug-2009] $) $( [27-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d z B $. $d z C $.
    cbviin.1 $e |- ( z e. B -> A. y z e. B ) $.
    cbviin.2 $e |- ( z e. C -> A. x z e. C ) $.
    cbviin.3 $e |- ( x = y -> B = C ) $.
    $( Change bound variables in an indexed intersection. $)
    cbviin $p |- |^|_ x e. A B = |^|_ y e. A C $=
      vz cv cB wcel vx cA wral vz cab vz cv cC wcel vy cA wral vz cab vx cA cB
      ciin vy cA cC ciin vz cv cB wcel vx cA wral vz cv cC wcel vy cA wral vz
      vz cv cB wcel vz cv cC wcel vx vy cA cbviin.1 cbviin.2 vx cv vy cv wceq
      cB cC vz cv cbviin.3 eleq2d cbvral abbii vx vz cA cB df-iin vy vz cA cC
      df-iin 3eqtr4i $.
      $( [30-Aug-2009] $) $( [26-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d y z B $. $d x z C $.
    cbviinv.1 $e |- ( x = y -> B = C ) $.
    $( Change bound variables in an indexed intersection. $)
    cbviinv $p |- |^|_ x e. A B = |^|_ y e. A C $=
      vx vy vz cA cB cC vz cv cB wcel vy ax-17 vz cv cC wcel vx ax-17 cbviinv.1
      cbviin $.
      $( [30-Aug-2009] $) $( [26-Aug-2009] $)
  $}

  ${
    $d s t A $. $d s t B $. $d s t F $.
    $( An image under the converse of a restriction. $)
    cnvresima $p |- ( `' ( F |` A ) " B ) = ( ( `' F " B ) i^i A ) $=
      vt cF cA cres ccnv cB cima cF ccnv cB cima cA cin vt cv cF cA cres ccnv
      cB cima wcel vs cv cB wcel vs cv vt cv cop cF cA cres ccnv wcel wa vs wex
      vs cv cB wcel vs cv vt cv cop cF ccnv wcel wa vs wex vt cv cA wcel wa vt
      cv cF ccnv cB cima cA cin wcel vs vt cv cF cA cres ccnv cB vt visset
      elima3 vs cv cB wcel vs cv vt cv cop cF cA cres ccnv wcel wa vs wex vs cv
      cB wcel vs cv vt cv cop cF ccnv wcel wa vt cv cA wcel wa vs wex vs cv cB
      wcel vs cv vt cv cop cF ccnv wcel wa vs wex vt cv cA wcel wa vs cv cB
      wcel vs cv vt cv cop cF cA cres ccnv wcel wa vs cv cB wcel vs cv vt cv
      cop cF ccnv wcel wa vt cv cA wcel wa vs vs cv cB wcel vs cv vt cv cop cF
      cA cres ccnv wcel wa vs cv cB wcel vs cv vt cv cop cF ccnv wcel vt cv cA
      wcel wa wa vs cv cB wcel vs cv vt cv cop cF ccnv wcel wa vt cv cA wcel wa
      vs cv vt cv cop cF cA cres ccnv wcel vs cv vt cv cop cF ccnv wcel vt cv
      cA wcel wa vs cv cB wcel vt cv vs cv cop cF cA cres wcel vt cv vs cv cop
      cF wcel vt cv cA wcel wa vs cv vt cv cop cF cA cres ccnv wcel vs cv vt cv
      cop cF ccnv wcel vt cv cA wcel wa vt cv vs cv cF cA vs visset opelres vs
      cv vt cv cF cA cres vs visset vt visset opelcnv vs cv vt cv cop cF ccnv
      wcel vt cv vs cv cop cF wcel vt cv cA wcel vs cv vt cv cF vs visset vt
      visset opelcnv anbi1i 3bitr4i anbi2i vs cv cB wcel vs cv vt cv cop cF
      ccnv wcel vt cv cA wcel anass bitr4i exbii vs cv cB wcel vs cv vt cv cop
      cF ccnv wcel wa vt cv cA wcel vs 19.41v bitri vt cv cF ccnv cB cima cA
      cin wcel vt cv cF ccnv cB cima wcel vt cv cA wcel wa vs cv cB wcel vs cv
      vt cv cop cF ccnv wcel wa vs wex vt cv cA wcel wa vt cv cF ccnv cB cima
      cA elin vt cv cF ccnv cB cima wcel vs cv cB wcel vs cv vt cv cop cF ccnv
      wcel wa vs wex vt cv cA wcel vs vt cv cF ccnv cB vt visset elima3 anbi1i
      bitr2i 3bitri eqriv $.
      $( [15-Jul-2009] $) $( [12-Jul-2009] $)
  $}

  $( Dominance is trichotomous in the restricted case of ordinal numbers. $)
  dmsdtriord $p |- ( ( A e. On /\ B e. On ) -> ( A ~<_ B <-> -. B ~< A ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB cdom wbr cB cA csdm wbr wn cA con0 wcel
    cB con0 wcel wa cA cB cdom wbr cB cA cdom wbr cB cA cen wbr wi cB cA csdm
    wbr wn cA cB cdom wbr cB cA cdom wbr cB cA cen wbr wi wi cA con0 wcel cB
    con0 wcel wa cB cA cdom wbr cA cB cdom wbr cB cA cen wbr cB cA sbth expcom
    a1i cB cA cdom wbr cB cA cen wbr wi cB cA cdom wbr cB cA cen wbr wn wa wn
    cB cA csdm wbr wn cB cA cdom wbr cB cA cen wbr iman cB cA csdm wbr wn cB cA
    cdom wbr cB cA cen wbr wn wa wn cB cA csdm wbr cB cA cdom wbr cB cA cen wbr
    wn wa cB cA brsdom notbii bicomi bitri syl6ib cA con0 wcel cB con0 wcel wa
    cA cB cdom wbr cB cA csdm wbr cA con0 wcel cB con0 wcel wa cA cB cdom wbr
    wn cB cA cdom wbr cB cA cen wbr wn wa cB cA csdm wbr cA con0 wcel cB con0
    wcel wa cA cB cdom wbr wn cB cA cdom wbr cB cA cen wbr wn cA con0 wcel cB
    con0 wcel wa cA cB cdom wbr wn cB cA wss cB cA cdom wbr cA con0 wcel cB
    con0 wcel wa cA cB cdom wbr wn cA cB wcel wn cB cA wss cA con0 wcel cB con0
    wcel wa cA cB wcel cA cB cdom wbr cB con0 wcel cA cB wcel cA cB wss cA con0
    wcel cA cB cdom wbr cB cA onelss cA cB con0 ssdomg sylan9r con3d cB con0
    wcel cA con0 wcel cB cA wss cA cB wcel wn wb cB word cA word cB cA wss cA
    cB wcel wn wb cB con0 wcel cA con0 wcel cB cA ordtri1 cB eloni cA eloni
    syl2an ancoms sylibrd cB con0 wcel cB cA wss cB cA cdom wbr wi cA con0 wcel
    cB cA con0 ssdomg adantl syld cA con0 wcel cB con0 wcel wa cB cA cen wbr cA
    cB cdom wbr cA con0 wcel cB con0 wcel wa cB cA cen wbr cA cB cen wbr cA cB
    cdom wbr cA con0 wcel cB cA cen wbr cA cB cen wbr wi cB con0 wcel cB cA
    con0 ensymg adantr cA cB endom syl6 con3d jcad cB cA brsdom syl6ibr con1d
    impbid $.
    $( [24-Oct-2009] $) $( [24-Oct-2009] $)

  ${
  $d a b c r s t R $.
  $( A relation intersected with its converse is an equivalence relation if the
     relation is transitive. $)
  trer $p |- ( A. a A. b A. c ( ( a R b /\ b R c ) -> a R c ) -> Er ( R i^i `'
  R ) ) $=
    va cv vb cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb
    wal va wal vr cv vs cv cR cR ccnv cin wbr vs cv vr cv cR cR ccnv cin wbr wi
    vr cv vs cv cR cR ccnv cin wbr vs cv vt cv cR cR ccnv cin wbr wa vr cv vt
    cv cR cR ccnv cin wbr wi wa vt wal vs wal vr wal cR cR ccnv cin wer va cv
    vb cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb wal va
    wal vr cv vs cv cR cR ccnv cin wbr vs cv vr cv cR cR ccnv cin wbr wi vr cv
    vs cv cR cR ccnv cin wbr vs cv vt cv cR cR ccnv cin wbr wa vr cv vt cv cR
    cR ccnv cin wbr wi wa vt wal vr vs va cv vb cv cR wbr vb cv vc cv cR wbr wa
    va cv vc cv cR wbr wi vc wal vb wal va wal vr cv vs cv cR cR ccnv cin wbr
    vs cv vr cv cR cR ccnv cin wbr wi vr cv vs cv cR cR ccnv cin wbr vs cv vt
    cv cR cR ccnv cin wbr wa vr cv vt cv cR cR ccnv cin wbr wi wa vt va cv vb
    cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb wal va wal
    vr cv vs cv cR cR ccnv cin wbr vs cv vt cv cR cR ccnv cin wbr wa vr cv vt
    cv cR cR ccnv cin wbr wi vr cv vs cv cR cR ccnv cin wbr vs cv vr cv cR cR
    ccnv cin wbr wi va cv vb cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr
    wi vc wal vb wal va wal vr cv vs cv cR wbr vs cv vr cv cR wbr wa vs cv vt
    cv cR wbr vt cv vs cv cR wbr wa wa vr cv vt cv cR cR ccnv cin wbr vr cv vs
    cv cR cR ccnv cin wbr vs cv vt cv cR cR ccnv cin wbr wa va cv vb cv cR wbr
    vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb wal va wal vr cv vs
    cv cR wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv cR wbr wa wa
    vr cv vt cv cR wbr vt cv vr cv cR wbr wa vr cv vt cv cR cR ccnv cin wbr va
    cv vb cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb wal
    va wal vr cv vs cv cR wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs
    cv cR wbr wa wa vr cv vt cv cR wbr vt cv vr cv cR wbr va cv vb cv cR wbr vb
    cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb wal va wal vr cv vb cv
    cR wbr vb cv vc cv cR wbr wa vr cv vc cv cR wbr wi vc wal vb wal vr cv vs
    cv cR wbr vs cv vc cv cR wbr wa vr cv vc cv cR wbr wi vc wal vr cv vs cv cR
    wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv cR wbr wa wa vr cv
    vt cv cR wbr wi va cv vb cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr
    wi vc wal vb wal vr cv vb cv cR wbr vb cv vc cv cR wbr wa vr cv vc cv cR
    wbr wi vc wal vb wal va vr va cv vr cv wceq va cv vb cv cR wbr vb cv vc cv
    cR wbr wa va cv vc cv cR wbr wi vr cv vb cv cR wbr vb cv vc cv cR wbr wa vr
    cv vc cv cR wbr wi vb vc va cv vr cv wceq va cv vb cv cR wbr vb cv vc cv cR
    wbr wa vr cv vb cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr vr cv vc
    cv cR wbr va cv vr cv wceq va cv vb cv cR wbr vr cv vb cv cR wbr vb cv vc
    cv cR wbr va cv vr cv vb cv cR breq1 anbi1d va cv vr cv vc cv cR breq1
    imbi12d 2albidv a4v vr cv vb cv cR wbr vb cv vc cv cR wbr wa vr cv vc cv cR
    wbr wi vc wal vr cv vs cv cR wbr vs cv vc cv cR wbr wa vr cv vc cv cR wbr
    wi vc wal vb vs vb cv vs cv wceq vr cv vb cv cR wbr vb cv vc cv cR wbr wa
    vr cv vc cv cR wbr wi vr cv vs cv cR wbr vs cv vc cv cR wbr wa vr cv vc cv
    cR wbr wi vc vb cv vs cv wceq vr cv vb cv cR wbr vb cv vc cv cR wbr wa vr
    cv vs cv cR wbr vs cv vc cv cR wbr wa vr cv vc cv cR wbr vb cv vs cv wceq
    vr cv vb cv cR wbr vr cv vs cv cR wbr vb cv vc cv cR wbr vs cv vc cv cR wbr
    vb cv vs cv vr cv cR breq2 vb cv vs cv vc cv cR breq1 anbi12d imbi1d albidv
    a4v vr cv vs cv cR wbr vs cv vc cv cR wbr wa vr cv vc cv cR wbr wi vc wal
    vr cv vs cv cR wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vr cv vs cv
    cR wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv cR wbr wa wa vr
    cv vt cv cR wbr wi vr cv vs cv cR wbr vs cv vc cv cR wbr wa vr cv vc cv cR
    wbr wi vr cv vs cv cR wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vc vt
    vc cv vt cv wceq vr cv vs cv cR wbr vs cv vc cv cR wbr wa vr cv vs cv cR
    wbr vs cv vt cv cR wbr wa vr cv vc cv cR wbr vr cv vt cv cR wbr vc cv vt cv
    wceq vs cv vc cv cR wbr vs cv vt cv cR wbr vr cv vs cv cR wbr vc cv vt cv
    vs cv cR breq2 anbi2d vc cv vt cv vr cv cR breq2 imbi12d a4v vr cv vs cv cR
    wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vr cv vs cv cR wbr vs cv vr
    cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv cR wbr wa vr cv vt cv cR wbr vr
    cv vs cv cR wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vr cv vs cv cR
    wbr vs cv vt cv cR wbr vt cv vs cv cR wbr wa vr cv vt cv cR wbr wi vs cv vr
    cv cR wbr vr cv vs cv cR wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vs
    cv vt cv cR wbr vt cv vs cv cR wbr wa vr cv vs cv cR wbr vr cv vt cv cR wbr
    vr cv vs cv cR wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vs cv vt cv
    cR wbr vr cv vs cv cR wbr vr cv vt cv cR wbr wi vt cv vs cv cR wbr vr cv vs
    cv cR wbr vs cv vt cv cR wbr wa vr cv vt cv cR wbr wi vr cv vs cv cR wbr vs
    cv vt cv cR wbr vr cv vt cv cR wbr vr cv vs cv cR wbr vs cv vt cv cR wbr vr
    cv vt cv cR wbr pm3.3 com23 adantrd com23 adantrd imp3a syl 3syl va cv vb
    cv cR wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vc wal vb wal va wal
    vt cv vb cv cR wbr vb cv vc cv cR wbr wa vt cv vc cv cR wbr wi vc wal vb
    wal vt cv vs cv cR wbr vs cv vc cv cR wbr wa vt cv vc cv cR wbr wi vc wal
    vr cv vs cv cR wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv cR
    wbr wa wa vt cv vr cv cR wbr wi va cv vb cv cR wbr vb cv vc cv cR wbr wa va
    cv vc cv cR wbr wi vc wal vb wal vt cv vb cv cR wbr vb cv vc cv cR wbr wa
    vt cv vc cv cR wbr wi vc wal vb wal va vt va cv vt cv wceq va cv vb cv cR
    wbr vb cv vc cv cR wbr wa va cv vc cv cR wbr wi vt cv vb cv cR wbr vb cv vc
    cv cR wbr wa vt cv vc cv cR wbr wi vb vc va cv vt cv wceq va cv vb cv cR
    wbr vb cv vc cv cR wbr wa vt cv vb cv cR wbr vb cv vc cv cR wbr wa va cv vc
    cv cR wbr vt cv vc cv cR wbr va cv vt cv wceq va cv vb cv cR wbr vt cv vb
    cv cR wbr vb cv vc cv cR wbr va cv vt cv vb cv cR breq1 anbi1d va cv vt cv
    vc cv cR breq1 imbi12d 2albidv a4v vt cv vb cv cR wbr vb cv vc cv cR wbr wa
    vt cv vc cv cR wbr wi vc wal vt cv vs cv cR wbr vs cv vc cv cR wbr wa vt cv
    vc cv cR wbr wi vc wal vb vs vb cv vs cv wceq vt cv vb cv cR wbr vb cv vc
    cv cR wbr wa vt cv vc cv cR wbr wi vt cv vs cv cR wbr vs cv vc cv cR wbr wa
    vt cv vc cv cR wbr wi vc vb cv vs cv wceq vt cv vb cv cR wbr vb cv vc cv cR
    wbr wa vt cv vs cv cR wbr vs cv vc cv cR wbr wa vt cv vc cv cR wbr vb cv vs
    cv wceq vt cv vb cv cR wbr vt cv vs cv cR wbr vb cv vc cv cR wbr vs cv vc
    cv cR wbr vb cv vs cv vt cv cR breq2 vb cv vs cv vc cv cR breq1 anbi12d
    imbi1d albidv a4v vt cv vs cv cR wbr vs cv vc cv cR wbr wa vt cv vc cv cR
    wbr wi vc wal vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv vr cv cR wbr
    wi vr cv vs cv cR wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv
    cR wbr wa wa vt cv vr cv cR wbr wi vt cv vs cv cR wbr vs cv vc cv cR wbr wa
    vt cv vc cv cR wbr wi vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv vr cv
    cR wbr wi vc vr vc cv vr cv wceq vt cv vs cv cR wbr vs cv vc cv cR wbr wa
    vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv vc cv cR wbr vt cv vr cv cR
    wbr vc cv vr cv wceq vs cv vc cv cR wbr vs cv vr cv cR wbr vt cv vs cv cR
    wbr vc cv vr cv vs cv cR breq2 anbi2d vc cv vr cv vt cv cR breq2 imbi12d
    a4v vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv vr cv cR wbr wi vr cv vs
    cv cR wbr vs cv vr cv cR wbr wa vs cv vt cv cR wbr vt cv vs cv cR wbr wa vt
    cv vr cv cR wbr vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv vr cv cR wbr
    wi vs cv vr cv cR wbr vs cv vt cv cR wbr vt cv vs cv cR wbr wa vt cv vr cv
    cR wbr wi vr cv vs cv cR wbr vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv
    vr cv cR wbr wi vs cv vt cv cR wbr vt cv vs cv cR wbr wa vs cv vr cv cR wbr
    vt cv vr cv cR wbr vt cv vs cv cR wbr vs cv vr cv cR wbr wa vt cv vr cv cR
    wbr wi vt cv vs cv cR wbr vs cv vr cv cR wbr vt cv vr cv cR wbr wi vs cv vt
    cv cR wbr vt cv vs cv cR wbr vs cv vr cv cR wbr vt cv vr cv cR wbr pm3.3
    adantld com23 adantld imp3a syl 3syl jcad vr cv vt cv cR cR ccnv cin wbr vr
    cv vt cv cR wbr vr cv vt cv cR ccnv wbr wa vr cv vt cv cR wbr vt cv vr cv
    cR wbr wa vr cv vt cv cR cR ccnv int2rel vr cv vt cv cR ccnv wbr vt cv vr
    cv cR wbr vr cv vt cv cR wbr vr cv vt cv cR vr visset vt visset brcnv
    anbi2i bitr2i syl6ib vr cv vs cv cR cR ccnv cin wbr vr cv vs cv cR wbr vs
    cv vr cv cR wbr wa vs cv vt cv cR cR ccnv cin wbr vs cv vt cv cR wbr vt cv
    vs cv cR wbr wa vr cv vs cv cR cR ccnv cin wbr vr cv vs cv cR wbr vr cv vs
    cv cR ccnv wbr wa vr cv vs cv cR wbr vs cv vr cv cR wbr wa vr cv vs cv cR
    cR ccnv int2rel vr cv vs cv cR ccnv wbr vs cv vr cv cR wbr vr cv vs cv cR
    wbr vr cv vs cv cR vr visset vs visset brcnv anbi2i bitri vs cv vt cv cR cR
    ccnv cin wbr vs cv vt cv cR wbr vs cv vt cv cR ccnv wbr wa vs cv vt cv cR
    wbr vt cv vs cv cR wbr wa vs cv vt cv cR cR ccnv int2rel vs cv vt cv cR
    ccnv wbr vt cv vs cv cR wbr vs cv vt cv cR wbr vs cv vt cv cR vs visset vt
    visset brcnv anbi2i bitri anbi12i syl5ib vr cv vs cv cR cR ccnv cin wbr vs
    cv vr cv cR cR ccnv cin wbr vr cv vs cv cR wbr vr cv vs cv cR ccnv wbr wa
    vs cv vr cv cR wbr vs cv vr cv cR ccnv wbr wa vr cv vs cv cR cR ccnv cin
    wbr vs cv vr cv cR cR ccnv cin wbr vr cv vs cv cR wbr vr cv vs cv cR ccnv
    wbr wa vr cv vs cv cR ccnv wbr vr cv vs cv cR wbr wa vs cv vr cv cR wbr vs
    cv vr cv cR ccnv wbr wa vr cv vs cv cR wbr vr cv vs cv cR ccnv wbr ancom vr
    cv vs cv cR ccnv wbr vs cv vr cv cR wbr vr cv vs cv cR wbr vs cv vr cv cR
    ccnv wbr vr cv vs cv cR vr visset vs visset brcnv vs cv vr cv cR ccnv wbr
    vr cv vs cv cR wbr vs cv vr cv cR vs visset vr visset brcnv bicomi anbi12i
    bitri vr cv vs cv cR cR ccnv int2rel vs cv vr cv cR cR ccnv int2rel 3bitr4i
    biimpi jctil 19.21aiv 19.21aivv vr vs vt cR cR ccnv cin dfer2 sylibr $.
    $( [6-Oct-2009] $) $( [6-Oct-2009] $)
  $}

  $( An equivalent membership condition for closed intervals. $)
  elicc3 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A [,] B ) <-> ( C e. RR*
  /\ A <_ B /\ ( C = A \/ ( A < C /\ C < B ) \/ C = B ) ) ) ) $=
    cA cxr wcel cB cxr wcel wa cC cA cB cicc co wcel cC cxr wcel cA cC cle wbr
    cC cB cle wbr w3a cC cxr wcel cA cB cle wbr cC cA wceq cA cC clt wbr cC cB
    clt wbr wa cC cB wceq w3o w3a cA cB cC elicc1 cA cxr wcel cB cxr wcel wa cC
    cxr wcel cA cC cle wbr cC cB cle wbr w3a cC cxr wcel cA cB cle wbr cC cA
    wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o w3a cA cxr wcel cB cxr
    wcel wa cC cxr wcel cA cC cle wbr cC cB cle wbr w3a cC cxr wcel cA cB cle
    wbr cC cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o cC cxr wcel cA
    cC cle wbr cC cB cle wbr w3a cC cxr wcel wi cA cxr wcel cB cxr wcel wa cC
    cxr wcel cA cC cle wbr cC cB cle wbr 3simp1 a1i cA cxr wcel cB cxr wcel cC
    cxr wcel cA cC cle wbr cC cB cle wbr cA cB cle wbr cA cxr wcel cC cxr wcel
    cB cxr wcel cA cC cle wbr cC cB cle wbr cA cB cle wbr wi wi cA cxr wcel cC
    cxr wcel cB cxr wcel cA cC cle wbr cC cB cle wbr cA cB cle wbr cA cC cB
    xrletr exp5o com23 imp5q cA cxr wcel cB cxr wcel wa cC cxr wcel cA cC cle
    wbr cC cB cle wbr w3a cC cA wceq wn cC cB wceq wn wa cA cC clt wbr cC cB
    clt wbr wa wi cC cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o cA
    cxr wcel cB cxr wcel wa cC cxr wcel cA cC cle wbr cC cB cle wbr w3a cC cA
    wceq wn cC cB wceq wn wa cA cC clt wbr cC cB clt wbr wa wi cA cxr wcel cB
    cxr wcel wa cC cxr wcel cA cC cle wbr cC cB cle wbr w3a wa cC cA wceq wn cA
    cC clt wbr cC cB wceq wn cC cB clt wbr cA cxr wcel cC cxr wcel cA cC cle
    wbr cC cB cle wbr w3a cC cA wceq wn cA cC clt wbr wi cB cxr wcel cA cxr
    wcel cC cxr wcel cA cC cle wbr cC cA wceq wn cA cC clt wbr wi cC cB cle wbr
    cA cxr wcel cC cxr wcel cA cC cle wbr w3a cC cA wne cA cC clt wbr cC cA
    wceq wn cA cxr wcel cC cxr wcel cA cC cle wbr w3a cA cC clt wbr cC cA wne
    cA cC xrleltne biimprd cC cA df-ne syl5ibr 3adant3r3 adantlr cB cxr wcel cC
    cxr wcel cA cC cle wbr cC cB cle wbr w3a cC cB wceq wn cC cB clt wbr wi cA
    cxr wcel cB cxr wcel cC cxr wcel cC cB cle wbr cC cB wceq wn cC cB clt wbr
    wi cA cC cle wbr cB cxr wcel cC cxr wcel cC cB cle wbr cC cB wceq wn cC cB
    clt wbr wi cC cxr wcel cB cxr wcel cC cB cle wbr cC cB wceq wn cC cB clt
    wbr wi wi cC cxr wcel cB cxr wcel cC cB cle wbr cC cB wceq wn cC cB clt wbr
    wi cC cxr wcel cB cxr wcel cC cB cle wbr w3a cB cC wne cC cB clt wbr cC cB
    wceq wn cC cxr wcel cB cxr wcel cC cB cle wbr w3a cC cB clt wbr cB cC wne
    cC cB xrleltne biimprd cC cB wceq cB cC cC cB eqcom necon3bbii syl5ib 3exp
    com12 imp32 3adantr2 adantll anim12d ex cC cA wceq cA cC clt wbr cC cB clt
    wbr wa cC cB wceq wo wo cC cA wceq wn cA cC clt wbr cC cB clt wbr wa cC cB
    wceq wo wi cC cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o cC cA
    wceq wn cC cB wceq wn wa cA cC clt wbr cC cB clt wbr wa wi cC cA wceq cA cC
    clt wbr cC cB clt wbr wa cC cB wceq wo df-or cC cA wceq cA cC clt wbr cC cB
    clt wbr wa cC cB wceq 3orass cC cA wceq wn cC cB wceq wn wa cA cC clt wbr
    cC cB clt wbr wa wi cC cA wceq wn cC cB wceq wn cA cC clt wbr cC cB clt wbr
    wa wi wi cC cA wceq wn cC cB wceq cA cC clt wbr cC cB clt wbr wa wo wi cC
    cA wceq wn cA cC clt wbr cC cB clt wbr wa cC cB wceq wo wi cC cA wceq wn cC
    cB wceq wn cA cC clt wbr cC cB clt wbr wa impexp cC cB wceq cA cC clt wbr
    cC cB clt wbr wa wo cC cB wceq wn cA cC clt wbr cC cB clt wbr wa wi cC cA
    wceq wn cC cB wceq cA cC clt wbr cC cB clt wbr wa df-or imbi2i cC cB wceq
    cA cC clt wbr cC cB clt wbr wa wo cA cC clt wbr cC cB clt wbr wa cC cB wceq
    wo cC cA wceq wn cC cB wceq cA cC clt wbr cC cB clt wbr wa orcom imbi2i
    3bitr2i 3bitr4ri syl6ib 3jcad cA cxr wcel cB cxr wcel wa cC cxr wcel cA cB
    cle wbr cC cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o w3a cC cxr
    wcel cA cC cle wbr cC cB cle wbr cC cxr wcel cA cB cle wbr cC cA wceq cA cC
    clt wbr cC cB clt wbr wa cC cB wceq w3o w3a cC cxr wcel wi cA cxr wcel cB
    cxr wcel wa cC cxr wcel cA cB cle wbr cC cA wceq cA cC clt wbr cC cB clt
    wbr wa cC cB wceq w3o 3simp1 a1i cA cxr wcel cB cxr wcel wa cC cxr wcel cA
    cB cle wbr cC cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o cA cC
    cle wbr cA cxr wcel cB cxr wcel wa cC cxr wcel cA cB cle wbr cC cA wceq cA
    cC clt wbr cC cB clt wbr wa cC cB wceq w3o cA cC cle wbr wi cA cxr wcel cB
    cxr wcel wa cC cxr wcel wa cA cB cle wbr wa cC cA wceq cA cC cle wbr cA cC
    clt wbr cC cB clt wbr wa cC cB wceq cC cA wceq cA cC cle wbr cA cA cle wbr
    cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA cB cle wbr wa cC cA cA cle
    breq2 cA cxr wcel cB cxr wcel wa cA cA cle wbr cC cxr wcel cA cB cle wbr cA
    cxr wcel cA cA cle wbr cB cxr wcel cA xrleid adantr ad2antrr syl5cbir cA
    cxr wcel cB cxr wcel wa cC cxr wcel wa cA cB cle wbr wa cA cC clt wbr cA cC
    cle wbr cC cB clt wbr cA cxr wcel cC cxr wcel cA cB cle wbr cA cC clt wbr
    cA cC cle wbr wi cB cxr wcel cA cxr wcel cC cxr wcel wa cA cC clt wbr cA cC
    cle wbr wi cA cB cle wbr cA cC xrltle adantr adantllr adantrd cC cB wceq cA
    cC cle wbr cA cB cle wbr cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA cB
    cle wbr wa cC cB cA cle breq2 cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA
    cB cle wbr pm3.27 syl5cbir 3jaod exp31 3impd cA cxr wcel cB cxr wcel wa cC
    cxr wcel cA cB cle wbr cC cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq
    w3o cC cB cle wbr cA cxr wcel cB cxr wcel wa cC cxr wcel cA cB cle wbr cC
    cA wceq cA cC clt wbr cC cB clt wbr wa cC cB wceq w3o cC cB cle wbr wi cA
    cxr wcel cB cxr wcel wa cC cxr wcel wa cA cB cle wbr wa cC cA wceq cC cB
    cle wbr cA cC clt wbr cC cB clt wbr wa cC cB wceq cC cA wceq cC cB cle wbr
    cA cB cle wbr cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA cB cle wbr wa cC
    cA cB cle breq1 cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA cB cle wbr
    pm3.27 syl5cbir cA cxr wcel cB cxr wcel wa cC cxr wcel wa cA cC clt wbr cC
    cB clt wbr wa cC cB cle wbr wi cA cB cle wbr cB cxr wcel cC cxr wcel cA cC
    clt wbr cC cB clt wbr wa cC cB cle wbr wi cA cxr wcel cB cxr wcel cC cxr
    wcel wa cC cB clt wbr cC cB cle wbr cA cC clt wbr cC cxr wcel cB cxr wcel
    cC cB clt wbr cC cB cle wbr wi cC cB xrltle ancoms adantld adantll adantr
    cC cB wceq cC cB cle wbr cB cB cle wbr cA cxr wcel cB cxr wcel wa cC cxr
    wcel wa cA cB cle wbr wa cC cB cB cle breq1 cA cxr wcel cB cxr wcel wa cC
    cxr wcel wa cB cB cle wbr cA cB cle wbr cB cxr wcel cB cB cle wbr cA cxr
    wcel cC cxr wcel cB xrleid ad2antlr adantr syl5cbir 3jaod exp31 3impd 3jcad
    impbid bitrd $.
    $( [30-Aug-2009] $) $( [14-Jul-2009] $)

  $( An element of a closed interval is less than or equal to its upper
     bound. $)
  iccleub $p |- ( ( A e. RR* /\ B e. RR* /\ C e. ( A [,] B ) ) -> C <_ B ) $=
    cA cxr wcel cB cxr wcel cC cA cB cicc co wcel cC cB cle wbr cA cxr wcel cB
    cxr wcel wa cC cA cB cicc co wcel cC cxr wcel cA cC cle wbr cC cB cle wbr
    w3a cC cB cle wbr cA cB cC elicc1 cC cxr wcel cA cC cle wbr cC cB cle wbr
    3simp3 syl6bi 3impia $.
    $( [19-Aug-2009] $) $( [14-Jul-2009] $)

  ${
    $d x A $.
    $( A closed interval with identical lower and upper bounds is a
       singleton. $)
    ccid $p |- ( A e. RR* -> ( A [,] A ) = { A } ) $=
      cA cxr wcel vx cA cA cicc co cA csn cA cxr wcel vx cv cA cA cicc co wcel
      vx cv cxr wcel cA vx cv cle wbr vx cv cA cle wbr w3a vx cv cA csn wcel cA
      cxr wcel vx cv cA cA cicc co wcel vx cv cxr wcel cA vx cv cle wbr vx cv
      cA cle wbr w3a wb cA cA vx cv elicc1 anidms cA cxr wcel vx cv cxr wcel cA
      vx cv cle wbr vx cv cA cle wbr w3a vx cv cA wceq vx cv cA csn wcel cA cxr
      wcel vx cv cxr wcel cA vx cv cle wbr vx cv cA cle wbr w3a vx cv cA wceq
      cA cxr wcel vx cv cxr wcel cA vx cv cle wbr vx cv cA cle wbr vx cv cA
      wceq cA cxr wcel vx cv cxr wcel cA vx cv cle wbr vx cv cA cle wbr vx cv
      cA wceq wi wi cA cxr wcel vx cv cxr wcel wa cA vx cv cle wbr vx cv cA clt
      wbr wn vx cv cA cle wbr vx cv cA wceq wi cA vx cv xrlenlt cA cxr wcel vx
      cv cxr wcel wa vx cv cA cle wbr vx cv cA clt wbr wn vx cv cA wceq cA cxr
      wcel vx cv cxr wcel wa vx cv cA cle wbr cA vx cv clt wbr wn vx cv cA clt
      wbr wn vx cv cA wceq wi vx cv cxr wcel cA cxr wcel vx cv cA cle wbr cA vx
      cv clt wbr wn wb vx cv cA xrlenlt ancoms cA cxr wcel vx cv cxr wcel wa vx
      cv cA clt wbr wn cA vx cv clt wbr wn vx cv cA wceq cA cxr wcel vx cv cxr
      wcel wa vx cv cA clt wbr wn cA vx cv clt wbr wn vx cv cA wceq vx cv cxr
      wcel cA cxr wcel vx cv cA clt wbr wn cA vx cv clt wbr wn wa vx cv cA wceq
      wi vx cv cxr wcel cA cxr wcel wa vx cv cA wceq vx cv cA clt wbr wn cA vx
      cv clt wbr wn wa vx cv cA xrlttri3 biimprd ancoms exp3a com23 sylbid
      com23 sylbid ex 3impd cA cxr wcel vx cv cA wceq vx cv cxr wcel cA vx cv
      cle wbr vx cv cA cle wbr cA cxr vx cv eleq1a vx cv cA wceq cA vx cv cle
      wbr cA cA cle wbr cA cxr wcel vx cv cA cA cle breq2 cA xrleid syl5cbir vx
      cv cA wceq vx cv cA cle wbr cA cA cle wbr cA cxr wcel vx cv cA cA cle
      breq1 cA xrleid syl5cbir 3jcad impbid vx cA elsn syl6bbr bitrd eqrdv $.
      $( [19-Aug-2009] $) $( [13-Jul-2009] $)
  $}

  ${
    $d x A $. $d x B $. $d x C $. $d x D $.
    $( If the upper bound of one open interval is less than or equal to the
     lower bound of the other, the intervals are disjoint. $)
    ioodisj $p |- ( ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) )
     /\ B <_ C ) -> ( ( A (,) B ) i^i ( C (,) D ) ) = (/) ) $=
      cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel wa wa cB cC cle wbr wa
      vx cv cA cB cioo co cC cD cioo co cin wcel vx wex wn cA cB cioo co cC cD
      cioo co cin c0 wceq cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel wa
      wa cB cC cle wbr wa vx cv cA cB cioo co cC cD cioo co cin wcel vx wex cB
      cC cle wbr cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel wa wa cB cC
      cle wbr pm3.27 cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel wa wa
      cB cC cle wbr wa vx cv cA cB cioo co cC cD cioo co cin wcel cB cC cle wbr
      wn vx cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel wa wa cB cC cle
      wbr wa vx cv cA cB cioo co wcel vx cv cC cD cioo co wcel wa cB cC cle wbr
      wn vx cv cA cB cioo co cC cD cioo co cin wcel cA cxr wcel cB cxr wcel wa
      cC cxr wcel cD cxr wcel wa wa cB cC cle wbr wa vx cv cxr wcel vx cv cB
      clt wbr wa cC vx cv clt wbr cB cC cle wbr wn vx cv cA cB cioo co wcel vx
      cv cC cD cioo co wcel cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr wcel
      wa wa vx cv cxr wcel vx cv cB clt wbr wa cC vx cv clt wbr wa cB cC cle
      wbr wn wi cB cC cle wbr cB cxr wcel cC cxr wcel vx cv cxr wcel vx cv cB
      clt wbr wa cC vx cv clt wbr wa cB cC cle wbr wn wi cA cxr wcel cD cxr
      wcel cB cxr wcel cC cxr wcel vx cv cxr wcel vx cv cB clt wbr cC vx cv clt
      wbr cB cC cle wbr wn cC cxr wcel vx cv cxr wcel cB cxr wcel vx cv cB clt
      wbr cC vx cv clt wbr cB cC cle wbr wn wi wi cC cxr wcel vx cv cxr wcel cB
      cxr wcel vx cv cB clt wbr cC vx cv clt wbr cB cC cle wbr wn wi wi cC cxr
      wcel vx cv cxr wcel cB cxr wcel w3a cC vx cv clt wbr vx cv cB clt wbr cB
      cC cle wbr wn cC cxr wcel vx cv cxr wcel cB cxr wcel w3a cC vx cv clt wbr
      vx cv cB clt wbr cB cC cle wbr wn cC cxr wcel vx cv cxr wcel cB cxr wcel
      w3a cC vx cv clt wbr vx cv cB clt wbr wa cC cB clt wbr cB cC cle wbr wn
      cC vx cv cB xrlttr cC cxr wcel cB cxr wcel cC cB clt wbr cB cC cle wbr wn
      wb vx cv cxr wcel cC cB xrltnle 3adant2 sylibd exp3a com23 3exp com3r
      imp5g ad2ant2lr adantr cA cxr wcel cB cxr wcel wa vx cv cA cB cioo co
      wcel vx cv cxr wcel vx cv cB clt wbr wa wi cC cxr wcel cD cxr wcel wa cB
      cC cle wbr cA cxr wcel cB cxr wcel wa vx cv cA cB cioo co wcel vx cv cxr
      wcel cA vx cv clt wbr vx cv cB clt wbr w3a vx cv cxr wcel vx cv cB clt
      wbr wa cA cB vx cv elioo1 vx cv cxr wcel cA vx cv clt wbr vx cv cB clt
      wbr 3simpb syl6bi ad2antrr cA cxr wcel cB cxr wcel wa cC cxr wcel cD cxr
      wcel wa wa cB cC cle wbr wa vx cv cC cD cioo co wcel vx cv cxr wcel cC vx
      cv clt wbr vx cv cD clt wbr w3a cC vx cv clt wbr cC cxr wcel cD cxr wcel
      wa vx cv cC cD cioo co wcel vx cv cxr wcel cC vx cv clt wbr vx cv cD clt
      wbr w3a wb cA cxr wcel cB cxr wcel wa cB cC cle wbr cC cD vx cv elioo1
      ad2antlr vx cv cxr wcel cC vx cv clt wbr vx cv cD clt wbr 3simp2 syl6bi
      syl2and vx cv cA cB cioo co cC cD cioo co elin syl5ib 19.23adv mt2d cA cB
      cioo co cC cD cioo co cin c0 wceq vx cv cA cB cioo co cC cD cioo co cin
      wcel wn vx wal vx cv cA cB cioo co cC cD cioo co cin wcel vx wex wn vx cA
      cB cioo co cC cD cioo co cin eq0 vx cv cA cB cioo co cC cD cioo co cin
      wcel vx alnex bitr2i sylib $.
      $( [19-Aug-2009] $) $( [13-Jul-2009] $)
  $}

  $( Euler's constant ` _e ` is greater than 0. $)
  epos $p |- 0 < _e $=
    cc0 c2 clt wbr c2 ceu clt wbr cc0 ceu clt wbr 2pos egt2OLD cc0 c2 ceu 0re
    2re ere lttri mp2an $.
    $( [23-Nov-2008] $) $( [22-Nov-2008] $)

  $( Euler's constant ` _e ` is a positive real. $)
  epr $p |- _e e. RR+ $=
    ceu ere epos elrpii $.
    $( [23-Nov-2008] $) $( [22-Nov-2008] $)

  ${
    $d a k m n y ph $. $d a k m n x ps $. $d x y $.
    finminlem.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful lemma about finite sets. If a property holds for a finite set,
       it holds for a minimal set. $)
    finminlem $p |- ( E. x e. Fin ph -> E. x ( ph /\ A. y ( ( y C_ x /\ ps ) ->
    x = y ) ) ) $=
      wph vx cfn wrex vx cv vn cv cen wbr wph wa vx wex vn com crab c0 wne vx
      cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0 wceq vm vx cv vn
      cv cen wbr wph wa vx wex vn com crab wrex wph vy cv vx cv wss wps wa vx
      cv vy cv wceq wi vy wal wa vx wex wph vx cv vn cv cen wbr wph wa vx wex
      vn com crab c0 wne vx cfn vx va vx cv vn cv cen wbr wph wa vx wex vn com
      crab c0 vx cv vn cv cen wbr wph wa vx wex vx vn va com vx cv vn cv cen
      wbr wph wa vx hbe1 va cv com wcel vx ax-17 hbrab va cv c0 wcel vx ax-17
      hbne vx cv cfn wcel vx cv vm cv cen wbr vm com wrex wph vx cv vn cv cen
      wbr wph wa vx wex vn com crab c0 wne wi vm vx cv isfi vx cv vm cv cen wbr
      wph vx cv vn cv cen wbr wph wa vx wex vn com crab c0 wne wi vm com vm cv
      com wcel vx cv vm cv cen wbr wph vx cv vn cv cen wbr wph wa vx wex vn com
      crab c0 wne vm cv com wcel vx cv vm cv cen wbr wph w3a vm cv vx cv vn cv
      cen wbr wph wa vx wex vn com crab wcel vx cv vn cv cen wbr wph wa vx wex
      vn com crab c0 wne vm cv com wcel vx cv vm cv cen wbr wph w3a vm cv com
      wcel vx cv vm cv cen wbr wph wa vx wex wa vm cv vx cv vn cv cen wbr wph
      wa vx wex vn com crab wcel vm cv com wcel vx cv vm cv cen wbr wph vm cv
      com wcel vx cv vm cv cen wbr wph wa vx wex wa vx cv vm cv cen wbr wph wa
      vx cv vm cv cen wbr wph wa vx wex vm cv com wcel vx cv vm cv cen wbr wph
      wa vx 19.8a anim2i 3impb vx cv vn cv cen wbr wph wa vx wex vx cv vm cv
      cen wbr wph wa vx wex vn vm cv com vn cv vm cv wceq vx cv vn cv cen wbr
      wph wa vx cv vm cv cen wbr wph wa vx vn cv vm cv wceq vx cv vn cv cen wbr
      vx cv vm cv cen wbr wph vn cv vm cv vx cv cen breq2 anbi1d exbidv elrab
      sylibr vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv ne0i syl 3exp
      r19.23aiv sylbi r19.23ai con0 cep wwe vx cv vn cv cen wbr wph wa vx wex
      vn com crab con0 wss vx cv vn cv cen wbr wph wa vx wex vn com crab c0 wne
      vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0 wceq vm vx cv
      vn cv cen wbr wph wa vx wex vn com crab wrex epweon vx cv vn cv cen wbr
      wph wa vx wex vn com crab com con0 vx cv vn cv cen wbr wph wa vx wex vn
      com ssrab2 omsson sstri vm con0 vx cv vn cv cen wbr wph wa vx wex vn com
      crab wefrc mp3an12 vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv
      cin c0 wceq wph vy cv vx cv wss wps wa vx cv vy cv wceq wi vy wal wa vx
      wex vm vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv vx cv vn cv
      cen wbr wph wa vx wex vn com crab wcel vm cv com wcel vx cv vm cv cen wbr
      wph wa vx wex wa vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin
      c0 wceq wph vy cv vx cv wss wps wa vx cv vy cv wceq wi vy wal wa vx wex
      wi vx cv vn cv cen wbr wph wa vx wex vx cv vm cv cen wbr wph wa vx wex vn
      vm cv com vn cv vm cv wceq vx cv vn cv cen wbr wph wa vx cv vm cv cen wbr
      wph wa vx vn cv vm cv wceq vx cv vn cv cen wbr vx cv vm cv cen wbr wph vn
      cv vm cv vx cv cen breq2 anbi1d exbidv elrab vm cv com wcel vx cv vm cv
      cen wbr wph wa vx wex vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv
      cin c0 wceq wph vy cv vx cv wss wps wa vx cv vy cv wceq wi vy wal wa vx
      wex wi vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv
      cin c0 wceq vx cv vm cv cen wbr wph wa vx wex wph vy cv vx cv wss wps wa
      vx cv vy cv wceq wi vy wal wa vx wex vm cv com wcel vx cv vn cv cen wbr
      wph wa vx wex vn com crab vm cv cin c0 wceq vx cv vm cv cen wbr wph wa vx
      wex wph vy cv vx cv wss wps wa vx cv vy cv wceq wi vy wal wa vx wex wi vm
      cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0
      wceq wa vx cv vm cv cen wbr wph wa wph vy cv vx cv wss wps wa vx cv vy cv
      wceq wi vy wal wa vx vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn
      com crab vm cv cin c0 wceq vx vm cv com wcel vx ax-17 vx va va vx cv vn
      cv cen wbr wph wa vx wex vn com crab vm cv cin c0 vx va vx cv vn cv cen
      wbr wph wa vx wex vn com crab vm cv vx cv vn cv cen wbr wph wa vx wex vx
      vn va com vx cv vn cv cen wbr wph wa vx hbe1 va cv com wcel vx ax-17
      hbrab va cv vm cv wcel vx ax-17 hbin va cv c0 wcel vx ax-17 hbeq hban vm
      cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0
      wceq wa vx cv vm cv cen wbr wph wa wph vy cv vx cv wss wps wa vx cv vy cv
      wceq wi vy wal wa vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com
      crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wa wph vy cv vx cv
      wss wps wa vx cv vy cv wceq wi vy wal vm cv com wcel vx cv vn cv cen wbr
      wph wa vx wex vn com crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph
      simprr vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv
      cin c0 wceq wa vx cv vm cv cen wbr wph wa wa vy cv vx cv wss wps wa vx cv
      vy cv wceq wi vy vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com
      crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wa vy cv vx cv wss
      wps vx cv vy cv wceq vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn
      com crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wa wps vy cv vx
      cv wss vx cv vy cv wceq vm cv com wcel vx cv vn cv cen wbr wph wa vx wex
      vn com crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wps vy cv vx
      cv wss vx cv vy cv wceq wi vm cv com wcel vx cv vn cv cen wbr wph wa vx
      wex vn com crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wps wa wa
      vy cv vx cv wpss vy cv vx cv wceq wo vx cv vy cv wceq vy cv vx cv wss vm
      cv com wcel vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0
      wceq wa vx cv vm cv cen wbr wph wa wps wa wa vy cv vx cv wpss vx cv vy cv
      wceq vy cv vx cv wceq vm cv com wcel vx cv vn cv cen wbr wph wa vx wex vn
      com crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wps wa wa vy cv
      vx cv wpss vx cv vy cv wceq vm cv com wcel vx cv vn cv cen wbr wph wa vx
      wex vn com crab vm cv cin c0 wceq vx cv vm cv cen wbr wph wa wps wa vy cv
      vx cv wpss wn vm cv com wcel vx cv vm cv cen wbr wph wa wps wa vx cv vn
      cv cen wbr wph wa vx wex vn com crab vm cv cin c0 wceq vy cv vx cv wpss
      wn vm cv com wcel vx cv vm cv cen wbr wph wa wps wa vx cv vn cv cen wbr
      wph wa vx wex vn com crab vm cv cin c0 wceq vy cv vx cv wpss wn wi vm cv
      com wcel vx cv vm cv cen wbr wph wa wps wa wa vy cv vx cv wpss vx cv vn
      cv cen wbr wph wa vx wex vn com crab vm cv cin c0 vm cv com wcel vx cv vm
      cv cen wbr wph wa wps wa wa vy cv vx cv wpss vy cv cfn wcel vx cv vn cv
      cen wbr wph wa vx wex vn com crab vm cv cin c0 wne vm cv com wcel vx cv
      vm cv cen wbr wph wa vy cv vx cv wpss vy cv cfn wcel wi wps vm cv com
      wcel vx cv vm cv cen wbr vy cv vx cv wpss vy cv cfn wcel wi wph vm cv com
      wcel vx cv vm cv cen wbr wa vx cv vm cv cen wbr vm com wrex vy cv vx cv
      wpss vy cv cfn wcel wi vx cv vm cv cen wbr vm com ra4e vx cv vm cv cen
      wbr vm com wrex vx cv cfn wcel vy cv vx cv wpss vy cv cfn wcel wi vm vx
      cv isfi vx cv cfn wcel vy cv vx cv wpss vy cv cfn wcel vx cv cfn wcel vy
      cv vx cv wss vy cv cfn wcel vy cv vx cv wpss vx cv vy cv ssfi vy cv vx cv
      pssss sylan2 ex sylbir syl adantrr adantrr vm cv com wcel vx cv vm cv cen
      wbr wph wa wps wa wa vy cv cfn wcel vy cv vx cv wpss vx cv vn cv cen wbr
      wph wa vx wex vn com crab vm cv cin c0 wne vm cv com wcel vx cv vm cv cen
      wbr wph wa wps wa wa vy cv vk cv cen wbr vk com wrex vy cv vx cv wpss vx
      cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0 wne wi vy cv cfn
      wcel vm cv com wcel vx cv vm cv cen wbr wph wa wps wa wa vy cv vk cv cen
      wbr vy cv vx cv wpss vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv
      cin c0 wne wi vk com vm cv com wcel vx cv vm cv cen wbr wph wa wps wa wa
      vk cv com wcel vy cv vk cv cen wbr vy cv vx cv wpss vx cv vn cv cen wbr
      wph wa vx wex vn com crab vm cv cin c0 wne vm cv com wcel vx cv vm cv cen
      wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen wbr wa vy cv vx cv
      wpss wa wa vk cv vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin
      wcel vx cv vn cv cen wbr wph wa vx wex vn com crab vm cv cin c0 wne vm cv
      com wcel vx cv vm cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv
      cen wbr wa vy cv vx cv wpss wa wa vk cv com wcel vx cv vk cv cen wbr wph
      wa vx wex wa vk cv vm cv wcel wa vk cv vx cv vn cv cen wbr wph wa vx wex
      vn com crab vm cv cin wcel vm cv com wcel vx cv vm cv cen wbr wph wa wps
      wa wa vk cv com wcel vy cv vk cv cen wbr wa vy cv vx cv wpss wa wa vk cv
      com wcel vx cv vk cv cen wbr wph wa vx wex vk cv vm cv wcel vm cv com
      wcel vx cv vm cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen
      wbr vy cv vx cv wpss simprll vy cv vk cv cen wbr wps vx cv vk cv cen wbr
      wph wa vx wex vm cv com wcel vx cv vm cv cen wbr wph wa wps wa wa vk cv
      com wcel vy cv vk cv cen wbr wa vy cv vx cv wpss wa wa vx cv vk cv cen
      wbr wph wa vy cv vk cv cen wbr wps wa vx vy cv vy visset vx cv vy cv wceq
      vx cv vk cv cen wbr vy cv vk cv cen wbr wph wps vx cv vy cv vk cv cen
      breq1 finminlem.1 anbi12d cla4ev vm cv com wcel vx cv vm cv cen wbr wph
      wa wps wa wa vk cv com wcel vy cv vk cv cen wbr vy cv vx cv wpss simprlr
      vm cv com wcel vx cv vm cv cen wbr wph wa wps vk cv com wcel vy cv vk cv
      cen wbr wa vy cv vx cv wpss wa simplrr sylanc vm cv com wcel vx cv vm cv
      cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen wbr wa vy cv vx
      cv wpss wa wa vk cv vm cv wcel vm cv vk cv wss wn vm cv com wcel vx cv vm
      cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen wbr wa vy cv
      vx cv wpss vm cv vk cv wss wn vm cv com wcel vx cv vm cv cen wbr wph wa
      wps wa wa vk cv com wcel vy cv vk cv cen wbr wa wa vy cv vx cv wpss vy cv
      vx cv csdm wbr vm cv vk cv wss wn vm cv com wcel vx cv vm cv cen wbr wph
      wa wps wa wa vk cv com wcel vy cv vk cv cen wbr wa wa vx cv cfn wcel vy
      cv vx cv wpss vy cv vx cv csdm wbr wi vm cv com wcel vx cv vm cv cen wbr
      wph wa wps wa wa vx cv cfn wcel vk cv com wcel vy cv vk cv cen wbr wa vm
      cv com wcel vx cv vm cv cen wbr wph wa vx cv cfn wcel wps vm cv com wcel
      vx cv vm cv cen wbr vx cv cfn wcel wph vm cv com wcel vx cv vm cv cen wbr
      wa vx cv vm cv cen wbr vm com wrex vx cv cfn wcel vx cv vm cv cen wbr vm
      com ra4e vm vx cv isfi sylibr adantrr adantrr adantr vx cv cfn wcel vy cv
      vx cv wpss vy cv vx cv csdm wbr vx cv vy cv php3 ex syl vm cv com wcel vx
      cv vm cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen wbr wa
      wa vm cv vk cv wss vx cv vy cv cdom wbr vy cv vx cv csdm wbr vm cv com
      wcel vx cv vm cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen
      wbr wa wa vm cv vk cv cdom wbr vx cv vy cv cdom wbr vm cv vk cv wss vm cv
      com wcel vx cv vm cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv
      cen wbr wa wa vm cv vk cv cdom wbr vx cv vk cv cdom wbr vx cv vy cv cdom
      wbr vx cv vm cv cen wbr wph wa wps wa vm cv vk cv cdom wbr vx cv vk cv
      cdom wbr wi vm cv com wcel vk cv com wcel vy cv vk cv cen wbr wa vx cv vm
      cv cen wbr vm cv vk cv cdom wbr vx cv vk cv cdom wbr wi wph wps vx cv vm
      cv cen wbr vm cv vk cv cdom wbr vx cv vk cv cdom wbr vx cv vm cv vk cv
      endomtr ex ad2antrr ad2antlr vy cv vk cv cen wbr vx cv vk cv cdom wbr vx
      cv vy cv cdom wbr wi vm cv com wcel vx cv vm cv cen wbr wph wa wps wa wa
      vk cv com wcel vx cv vk cv cdom wbr vy cv vk cv cen wbr vx cv vy cv cdom
      wbr vx cv vk cv cdom wbr vk cv vy cv cen wbr vx cv vy cv cdom wbr vy cv
      vk cv cen wbr vx cv vk cv vy cv domentr vy cv vk cv vk visset ensym
      sylan2 expcom ad2antll syld vm cv cvv wcel vm cv vk cv wss vm cv vk cv
      cdom wbr wi vm visset vm cv vk cv cvv ssdomg ax-mp syl5 vx cv vy cv cdom
      wbr vy cv vx cv csdm wbr vx cv vy cv domnsym con2i nsyli syld impr vm cv
      word vk cv word vk cv vm cv wcel vm cv vk cv wss wn wb vm cv com wcel vx
      cv vm cv cen wbr wph wa wps wa wa vk cv com wcel vy cv vk cv cen wbr wa
      vy cv vx cv wpss wa wa vm cv word vk cv word wa vm cv vk cv wss vk cv vm
      cv wcel vm cv vk cv ordtri1 con2bid vm cv com wcel vm cv word vx cv vm cv
      cen wbr wph wa wps wa vk cv com wcel vy cv vk cv cen wbr wa vy cv vx cv
      wpss wa vm cv nnord ad2antrr vk cv com wcel vy cv vk cv cen wbr wa vk cv
      word vm cv com wcel vx cv vm cv cen wbr wph wa wps wa wa vy cv vx cv wpss
      vk cv com wcel vk cv word vy cv vk cv cen wbr vk cv nnord adantr ad2antrl
      sylanc mpbird jca31 vk cv vx cv vn cv cen wbr wph wa vx wex vn com crab
      vm cv cin wcel vk cv vx cv vn cv cen wbr wph wa vx wex vn com crab wcel
      vk cv vm cv wcel wa vk cv com wcel vx cv vk cv cen wbr wph wa vx wex wa
      vk cv vm cv wcel wa vk cv vx cv vn cv cen wbr wph wa vx wex vn com crab
      vm cv elin vk cv vx cv vn cv cen wbr wph wa vx wex vn com crab wcel vk cv
      com wcel vx cv vk cv cen wbr wph wa vx wex wa vk cv vm cv wcel vx cv vn
      cv cen wbr wph wa vx wex vx cv vk cv cen wbr wph wa vx wex vn vk cv com
      vn cv vk cv wceq vx cv vn cv cen wbr wph wa vx cv vk cv cen wbr wph wa vx
      vn cv vk cv wceq vx cv vn cv cen wbr vx cv vk cv cen wbr wph vn cv vk cv
      vx cv cen breq2 anbi1d exbidv elrab anbi1i bitri sylibr vx cv vn cv cen
      wbr wph wa vx wex vn com crab vm cv cin vk cv ne0i syl exp44 r19.23adv vk
      vy cv isfi syl5ib com23 mpdd necon2bd ex com23 imp31 pm2.21d vy cv vx cv
      wceq vx cv vy cv wceq wi vm cv com wcel vx cv vn cv cen wbr wph wa vx wex
      vn com crab vm cv cin c0 wceq wa vx cv vm cv cen wbr wph wa wps wa wa vy
      cv vx cv wceq vx cv vy cv wceq vy cv vx cv eqcom biimpi a1i jaod vy cv vx
      cv sspss syl5ib expr com23 imp3a 19.21aiv jca ex 19.22d ex com23 imp
      sylbi r19.23aiv 3syl $.
      $( [5-Dec-2009] $) $( [4-Dec-2009] $)
  $}

  ${
    $d x y A $. $d x y B $. $d x y C $.
    $( Subset relationship for function ` fi ` . $)
    fiss $p |- ( ( B e. C /\ A C_ B ) -> ( fi ` A ) C_ ( fi ` B ) ) $=
      cB cC wcel cA cB wss wa vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq
      w3a vy wex vx cab vy cv cB wss vy cv cfn wcel vx cv vy cv cint wceq w3a
      vy wex vx cab cA cfi cfv cB cfi cfv cB cC wcel cA cB wss wa vy cv cA wss
      vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vy cv cB wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex wi vx wal vy cv cA wss vy cv cfn
      wcel vx cv vy cv cint wceq w3a vy wex vx cab vy cv cB wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wss cB cC wcel cA cB wss wa vy cv
      cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vy cv cB wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy wex wi vx cB cC wcel cA cB wss wa
      vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy cv cB wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy cB cC wcel cA cB wss wa vy cv cA
      wss vy cv cB wss vy cv cfn wcel vy cv cfn wcel vx cv vy cv cint wceq vx
      cv vy cv cint wceq cA cB wss vy cv cA wss vy cv cB wss wi cB cC wcel vy
      cv cA wss cA cB wss vy cv cB wss vy cv cA cB sstr2 com12 adantl cB cC
      wcel cA cB wss wa vy cv cfn wcel idd cB cC wcel cA cB wss wa vx cv vy cv
      cint wceq idd 3anim123d 19.22dv 19.21aiv vy cv cA wss vy cv cfn wcel vx
      cv vy cv cint wceq w3a vy wex vy cv cB wss vy cv cfn wcel vx cv vy cv
      cint wceq w3a vy wex vx ss2ab sylibr cB cC wcel cA cB wss wa cA cvv wcel
      cA cfi cfv vy cv cA wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex
      vx cab wceq cA cB wss cB cC wcel cA cvv wcel cA cB cC ssexg ancoms vy vx
      cA cvv fiv syl cB cC wcel cB cfi cfv vy cv cB wss vy cv cfn wcel vx cv vy
      cv cint wceq w3a vy wex vx cab wceq cA cB wss vy vx cB cC fiv adantr
      3sstr4d $.
      $( [7-Oct-2009] $) $( [7-Oct-2009] $)
  $}


  ${
    $d x y z u v A $. $d x y z u v B $. $d x y z u v C $. $d x y z u v D $. $d
    x y z u v K $.
    $( A finite intersection of elements taken from a union of collections. $)
    elfiun $p |- ( ( B e. D /\ C e. K ) -> ( A e. ( fi ` ( B u. C ) ) <-> ( A
    e. ( fi ` B ) \/ A e. ( fi ` C ) \/ E. x e. ( fi ` B ) E. y e. ( fi ` C ) A
    = ( x i^i y ) ) ) ) $=
      cB cD wcel cC cK wcel wa cA cB cC cun cfi cfv wcel cA cB cfi cfv wcel cA
      cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex w3o cA cvv wcel cB cD wcel cC cK wcel w3a cB cD wcel cC cK wcel wa
      cA cB cC cun cfi cfv wcel wa cA cvv wcel cB cD wcel cC cK wcel cA cB cC
      cun cfi cfv wcel cA cvv wcel cB cD wcel cC cK wcel wa cA cB cC cun cfi
      cfv elisset adantl cB cD wcel cC cK wcel cA cB cC cun cfi cfv wcel simpll
      cB cD wcel cC cK wcel cA cB cC cun cfi cfv wcel simplr 3jca cA cB cfi cfv
      wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB
      cfi cfv wrex w3o cB cD wcel cC cK wcel wa cA cvv wcel cB cD wcel cC cK
      wcel w3a cA cB cfi cfv wcel cB cD wcel cC cK wcel wa cA cvv wcel cB cD
      wcel cC cK wcel w3a wi cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC
      cfi cfv wrex vx cB cfi cfv wrex cA cB cfi cfv wcel cB cD wcel cC cK wcel
      cA cvv wcel cB cD wcel cC cK wcel w3a cA cB cfi cfv wcel cA cvv wcel cB
      cD wcel cC cK wcel cA cB cfi cfv elisset 3anim1i 3expib cA cC cfi cfv
      wcel cB cD wcel cC cK wcel cA cvv wcel cB cD wcel cC cK wcel w3a cA cC
      cfi cfv wcel cA cvv wcel cB cD wcel cC cK wcel cA cC cfi cfv elisset
      3anim1i 3expib cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex cB cD wcel cC cK wcel cA cvv wcel cB cD wcel cC cK wcel w3a cA vx cv
      vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex cA cvv wcel cB cD
      wcel cC cK wcel cA vx cv vy cv cin wceq cA cvv wcel vx vy cB cfi cfv cC
      cfi cfv cA vx cv vy cv cin wceq cA cvv wcel wi vx cv cB cfi cfv wcel vy
      cv cC cfi cfv wcel wa cA vx cv vy cv cin wceq cA cvv wcel vx cv vy cv cin
      cvv wcel vx cv vy cv vx visset inex1 cA vx cv vy cv cin cvv eleq1 mpbiri
      a1i r19.23aivv 3anim1i 3expib 3jaoi impcom cA cvv wcel cB cD wcel cC cK
      wcel w3a cA cB cC cun cfi cfv wcel vz cv cB cC cun wss vz cv cfn wcel cA
      vz cv cint wceq w3a vz wex cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv
      vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o cA cvv wcel cB
      cD wcel cC cK wcel cA cB cC cun cfi cfv wcel vz cv cB cC cun wss vz cv
      cfn wcel cA vz cv cint wceq w3a vz wex wb cA cvv wcel cB cC cun cvv wcel
      cA cB cC cun cfi cfv wcel vz cv cB cC cun wss vz cv cfn wcel cA vz cv
      cint wceq w3a vz wex wb cB cD wcel cC cK wcel wa vz cA cvv cB cC cun cvv
      sppfi cB cC cD cK unexg sylan2 3impb cA cvv wcel cB cD wcel cC cK wcel
      w3a vz cv cB cC cun wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex cA
      cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv
      wrex vx cB cfi cfv wrex w3o cA cvv wcel cB cD wcel cC cK wcel w3a vz cv
      cB cC cun wss vz cv cfn wcel cA vz cv cint wceq w3a cA cB cfi cfv wcel cA
      cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex w3o vz cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cB cC cun wss vz
      cv cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA
      vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o cA cvv
      wcel cB cD wcel cC cK wcel w3a vz cv cB cin vz cv cC cin cun vz cv wceq
      vz cv cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel
      cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi wi
      vz cv cB cC cun wss vz cv cB cin c0 wceq vz cv cC cin c0 wceq cA cvv wcel
      cB cD wcel cC cK wcel w3a vz cv cB cin vz cv cC cin cun vz cv wceq vz cv
      cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx
      cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi wi wi wi
      vz cv cB cin c0 wceq vz cv cC cin c0 wceq wa vz cv cB cin vz cv cC cin
      cun vz cv wceq cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel cA vz
      cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin
      wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi wi vz cv cB cin c0 wceq
      vz cv cC cin c0 wceq wa vz cv cB cin vz cv cC cin cun vz cv wceq c0 vz cv
      wceq cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel cA vz cv cint
      wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC
      cfi cfv wrex vx cB cfi cfv wrex w3o wi wi wi vz cv cB cin c0 wceq vz cv
      cC cin c0 wceq wa vz cv cB cin vz cv cC cin cun c0 vz cv vz cv cB cin c0
      wceq vz cv cC cin c0 wceq wa vz cv cB cin vz cv cC cin cun c0 c0 cun c0
      vz cv cB cin c0 vz cv cC cin c0 uneq12 c0 unidm syl6eq eqeq1d vz cv cB
      cin c0 wceq vz cv cC cin c0 wceq wa c0 vz cv wceq cA cvv wcel cB cD wcel
      cC cK wcel w3a vz cv cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC
      cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex w3o wi cA cvv wcel cB cD wcel cC cK wcel w3a c0 vz cv wceq cA vz cv
      cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq
      vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi cA cvv wcel cB cD wcel c0 vz
      cv wceq cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv
      vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi wi cC cK wcel
      c0 vz cv wceq cA c0 cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx
      cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi cA vz cv
      cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq
      vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi cA cvv wcel c0 vz cv wceq cA
      c0 cint wceq cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA
      vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o c0 vz cv
      wceq c0 cint vz cv cint cA c0 vz cv inteq eqeq2d imbi1d cA cvv wcel cA c0
      cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq
      vy cC cfi cfv wrex vx cB cfi cfv wrex w3o cA cvv wcel cA c0 cint wceq c0
      cint cvv wcel c0 cint cvv wcel cvv cvv wcel vprc c0 cint cvv cvv int0
      eleq1i mtbir cA c0 cint wceq cA cvv wcel c0 cint cvv wcel cA c0 cint cvv
      eleq1 biimpcd mtoi pm2.21d syl5cbi 3ad2ant1 com12 a1i14 sylbid com23 vz
      cv cB cin c0 wceq vz cv cC cin c0 wceq wn wa vz cv cB cin vz cv cC cin
      cun vz cv wceq cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel cA vz
      cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin
      wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi wi vz cv cB cin c0 wceq
      vz cv cC cin c0 wceq wn wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv
      cC wss cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel cA vz cv cint
      wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC
      cfi cfv wrex vx cB cfi cfv wrex w3o wi wi wi vz cv cB cin c0 wceq vz cv
      cC cin c0 wceq wn wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cC
      cin vz cv wceq vz cv cC wss vz cv cB cin c0 wceq vz cv cC cin c0 wceq wn
      wa vz cv cB cin vz cv cC cin cun vz cv cC cin vz cv vz cv cB cin c0 wceq
      vz cv cB cin vz cv cC cin cun vz cv cC cin wceq vz cv cC cin c0 wceq wn
      vz cv cB cin c0 wceq vz cv cC cin vz cv cB cin cun vz cv cC cin c0 cun vz
      cv cB cin vz cv cC cin cun vz cv cC cin vz cv cB cin c0 vz cv cC cin
      uneq2 vz cv cC cin vz cv cB cin uncom vz cv cC cin un0 3eqtr3g adantr
      eqeq1d vz cv cC df-ss syl6bbr vz cv cC cin c0 wceq wn vz cv cC wss cA cvv
      wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel cA vz cv cint wceq cA cB
      cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv
      wrex vx cB cfi cfv wrex w3o wi wi wi wi vz cv cB cin c0 wceq vz cv cC cin
      c0 wceq wn vz cv cC wss cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn
      wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy
      cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o wi vz cv cC cin c0
      wceq wn vz cv cC wss wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn
      wcel wa wa cA vz cv cint wceq cA cC cfi cfv wcel cA cB cfi cfv wcel cA cC
      cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex w3o cA vz cv cint wceq cA cC cfi cfv wcel vz cv cint cC cfi cfv wcel
      vz cv cC cin c0 wceq wn vz cv cC wss wa cA cvv wcel cB cD wcel cC cK wcel
      w3a vz cv cfn wcel wa wa cA vz cv cint cC cfi cfv eleq1 vz cv cC cin c0
      wceq wn vz cv cC wss wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn
      wcel wa wa vz cv cint cC cfi cfv wcel vx cv cC wss vx cv cfn wcel vz cv
      cint vx cv cint wceq w3a vx wex vz cv cC wss vz cv cfn wcel vz cv cint vz
      cv cint wceq vx cv cC wss vx cv cfn wcel vz cv cint vx cv cint wceq w3a
      vx wex vz cv cC cin c0 wceq wn vz cv cC wss wa cA cvv wcel cB cD wcel cC
      cK wcel w3a vz cv cfn wcel wa wa vx cv cC wss vx cv cfn wcel vz cv cint
      vx cv cint wceq w3a vz cv cC wss vz cv cfn wcel vz cv cint vz cv cint
      wceq w3a vx vz cv vz visset vx cv vz cv wceq vx cv cC wss vz cv cC wss vx
      cv cfn wcel vz cv cfn wcel vz cv cint vx cv cint wceq vz cv cint vz cv
      cint wceq vx cv vz cv cC sseq1 vx cv vz cv cfn eleq1 vx cv vz cv wceq vx
      cv cint vz cv cint vz cv cint vx cv vz cv inteq eqeq2d 3anbi123d cla4ev
      vz cv cC cin c0 wceq wn vz cv cC wss cA cvv wcel cB cD wcel cC cK wcel
      w3a vz cv cfn wcel wa simplr vz cv cC cin c0 wceq wn vz cv cC wss wa cA
      cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel simprr vz cv cC cin c0
      wceq wn vz cv cC wss wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn
      wcel wa wa vz cv cint eqidd syl3anc vz cv cint cvv wcel cC cK wcel vz cv
      cint cC cfi cfv wcel vx cv cC wss vx cv cfn wcel vz cv cint vx cv cint
      wceq w3a vx wex wb vz cv cC cin c0 wceq wn vz cv cC wss wa cA cvv wcel cB
      cD wcel cC cK wcel w3a vz cv cfn wcel wa wa vx vz cv cint cvv cC cK sppfi
      vz cv cC cin c0 wceq wn vz cv cC wss wa cA cvv wcel cB cD wcel cC cK wcel
      w3a vz cv cfn wcel wa wa vz cv c0 wne vz cv cint cvv wcel vz cv cC cin c0
      wceq wn vz cv c0 wne vz cv cC wss cA cvv wcel cB cD wcel cC cK wcel w3a
      vz cv cfn wcel wa vz cv cC cin c0 wceq wn vz cv cC cin c0 wne vz cv c0
      wne vz cv cC cin c0 df-ne vz cv cC cin vz cv wss vz cv cC cin c0 wne vz
      cv c0 wne vz cv cC inss1 vz cv cC cin vz cv ssn0 mpan sylbir ad2antrr vz
      cv intex sylib cA cvv wcel cB cD wcel cC cK wcel w3a cC cK wcel vz cv cC
      cin c0 wceq wn vz cv cC wss wa vz cv cfn wcel cA cvv wcel cB cD wcel cC
      cK wcel 3simp3 ad2antrl sylanc mpbird syl5cbir cA cC cfi cfv wcel cA cB
      cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex 3mix2 syl6 exp43 adantl sylbid com23 vz cv cB cin c0 wceq wn vz cv
      cC cin c0 wceq wa vz cv cB cin vz cv cC cin cun vz cv wceq cA cvv wcel cB
      cD wcel cC cK wcel w3a vz cv cfn wcel cA vz cv cint wceq cA cB cfi cfv
      wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB
      cfi cfv wrex w3o wi wi vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wa vz
      cv cB cin vz cv cC cin cun vz cv wceq vz cv cB wss cA cvv wcel cB cD wcel
      cC cK wcel w3a vz cv cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC
      cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv
      wrex w3o wi wi wi vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wa vz cv
      cB cin vz cv cC cin cun vz cv wceq vz cv cB cin vz cv wceq vz cv cB wss
      vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wa vz cv cB cin vz cv cC cin
      cun vz cv cB cin vz cv vz cv cC cin c0 wceq vz cv cB cin vz cv cC cin cun
      vz cv cB cin wceq vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq vz cv cB
      cin vz cv cC cin cun vz cv cB cin c0 cun vz cv cB cin vz cv cC cin c0 vz
      cv cB cin uneq2 vz cv cB cin un0 syl6eq adantl eqeq1d vz cv cB df-ss
      syl6bbr vz cv cB cin c0 wceq wn vz cv cB wss cA cvv wcel cB cD wcel cC cK
      wcel w3a vz cv cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi
      cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex
      w3o wi wi wi wi vz cv cC cin c0 wceq vz cv cB cin c0 wceq wn vz cv cB wss
      cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel cA vz cv cint wceq
      cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy cv cin wceq vy cC cfi
      cfv wrex vx cB cfi cfv wrex w3o wi vz cv cB cin c0 wceq wn vz cv cB wss
      wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel wa wa cA vz cv
      cint wceq cA cB cfi cfv wcel cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx
      cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o cA vz cv cint
      wceq cA cB cfi cfv wcel vz cv cint cB cfi cfv wcel vz cv cB cin c0 wceq
      wn vz cv cB wss wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel
      wa wa cA vz cv cint cB cfi cfv eleq1 vz cv cB cin c0 wceq wn vz cv cB wss
      wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel wa wa vz cv cint
      cB cfi cfv wcel vx cv cB wss vx cv cfn wcel vz cv cint vx cv cint wceq
      w3a vx wex vz cv cB wss vz cv cfn wcel vz cv cint vz cv cint wceq vx cv
      cB wss vx cv cfn wcel vz cv cint vx cv cint wceq w3a vx wex vz cv cB cin
      c0 wceq wn vz cv cB wss wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv
      cfn wcel wa wa vx cv cB wss vx cv cfn wcel vz cv cint vx cv cint wceq w3a
      vz cv cB wss vz cv cfn wcel vz cv cint vz cv cint wceq w3a vx vz cv vz
      visset vx cv vz cv wceq vx cv cB wss vz cv cB wss vx cv cfn wcel vz cv
      cfn wcel vz cv cint vx cv cint wceq vz cv cint vz cv cint wceq vx cv vz
      cv cB sseq1 vx cv vz cv cfn eleq1 vx cv vz cv wceq vx cv cint vz cv cint
      vz cv cint vx cv vz cv inteq eqeq2d 3anbi123d cla4ev vz cv cB cin c0 wceq
      wn vz cv cB wss cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel wa
      simplr vz cv cB cin c0 wceq wn vz cv cB wss wa cA cvv wcel cB cD wcel cC
      cK wcel w3a vz cv cfn wcel simprr vz cv cB cin c0 wceq wn vz cv cB wss wa
      cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel wa wa vz cv cint
      eqidd syl3anc vz cv cint cvv wcel cB cD wcel vz cv cint cB cfi cfv wcel
      vx cv cB wss vx cv cfn wcel vz cv cint vx cv cint wceq w3a vx wex wb vz
      cv cB cin c0 wceq wn vz cv cB wss wa cA cvv wcel cB cD wcel cC cK wcel
      w3a vz cv cfn wcel wa wa vx vz cv cint cvv cB cD sppfi vz cv cB cin c0
      wceq wn vz cv cB wss wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn
      wcel wa wa vz cv c0 wne vz cv cint cvv wcel vz cv cB cin c0 wceq wn vz cv
      c0 wne vz cv cB wss cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cfn wcel
      wa vz cv cB cin c0 wceq wn vz cv cB cin c0 wne vz cv c0 wne vz cv cB cin
      c0 df-ne vz cv cB cin vz cv wss vz cv cB cin c0 wne vz cv c0 wne vz cv cB
      inss1 vz cv cB cin vz cv ssn0 mpan sylbir ad2antrr vz cv intex sylib cA
      cvv wcel cB cD wcel cC cK wcel w3a cB cD wcel vz cv cB cin c0 wceq wn vz
      cv cB wss wa vz cv cfn wcel cA cvv wcel cB cD wcel cC cK wcel 3simp2
      ad2antrl sylanc mpbird syl5cbir cA cB cfi cfv wcel cA cC cfi cfv wcel cA
      vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex 3mix1 syl6
      exp43 adantr sylbid com23 vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn
      wa cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cB cin vz cv cC cin cun vz
      cv wceq vz cv cfn wcel cA vz cv cint wceq cA cB cfi cfv wcel cA cC cfi
      cfv wcel cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex
      w3o wi vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB
      cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv
      cfn wcel wa wa cA vz cv cint wceq cA vx cv vy cv cin wceq vy cC cfi cfv
      wrex vx cB cfi cfv wrex cA cB cfi cfv wcel cA cC cfi cfv wcel cA vx cv vy
      cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex w3o vz cv cB cin c0
      wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a
      wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa wa cA vz cv
      cint wceq cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex
      vz cv cB cin cint cB cfi cfv wcel vz cv cC cin cint cC cfi cfv wcel cA vz
      cv cB cin cint vz cv cC cin cint cin wceq cA vx cv vy cv cin wceq vy cC
      cfi cfv wrex vx cB cfi cfv wrex vz cv cB cin c0 wceq wn vz cv cC cin c0
      wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC
      cin cun vz cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa cA vx cv vy
      cv cin wceq cA vz cv cB cin cint vz cv cC cin cint cin wceq cA vz cv cB
      cin cint vy cv cin wceq vx vy vz cv cB cin cint vz cv cC cin cint cB cfi
      cfv cC cfi cfv vx cv vz cv cB cin cint wceq vx cv vy cv cin vz cv cB cin
      cint vy cv cin cA vx cv vz cv cB cin cint vy cv ineq1 eqeq2d vy cv vz cv
      cC cin cint wceq vz cv cB cin cint vy cv cin vz cv cB cin cint vz cv cC
      cin cint cin cA vy cv vz cv cC cin cint vz cv cB cin cint ineq2 eqeq2d
      rcla42ev vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel
      cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz
      cv cfn wcel wa wa cA vz cv cint wceq wa vz cv cB cin cint cB cfi cfv wcel
      vx cv cB wss vx cv cfn wcel vz cv cB cin cint vx cv cint wceq w3a vx wex
      vz cv cB cin cB wss vz cv cB cin cfn wcel vz cv cB cin cint vz cv cB cin
      cint wceq vx cv cB wss vx cv cfn wcel vz cv cB cin cint vx cv cint wceq
      w3a vx wex vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel
      cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz
      cv cfn wcel wa wa cA vz cv cint wceq wa vx cv cB wss vx cv cfn wcel vz cv
      cB cin cint vx cv cint wceq w3a vz cv cB cin cB wss vz cv cB cin cfn wcel
      vz cv cB cin cint vz cv cB cin cint wceq w3a vx vz cv cB cin vz cv cB vz
      visset inex1 vx cv vz cv cB cin wceq vx cv cB wss vz cv cB cin cB wss vx
      cv cfn wcel vz cv cB cin cfn wcel vz cv cB cin cint vx cv cint wceq vz cv
      cB cin cint vz cv cB cin cint wceq vx cv vz cv cB cin cB sseq1 vx cv vz
      cv cB cin cfn eleq1 vx cv vz cv cB cin wceq vx cv cint vz cv cB cin cint
      vz cv cB cin cint vx cv vz cv cB cin inteq eqeq2d 3anbi123d cla4ev vz cv
      cB cin cB wss vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv
      wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv
      wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vz cv cB inss2 a1i vz cv
      cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK
      wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa wa
      vz cv cB cin cfn wcel cA vz cv cint wceq vz cv cfn wcel vz cv cB cin vz
      cv wss vz cv cB cin cfn wcel vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq
      wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin
      cun vz cv wceq vz cv cfn wcel wa wa vz cv vz cv cB cin ssfi vz cv cB cin
      c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel
      w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel simprr vz
      cv cB cin vz cv wss vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA
      cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv
      wceq vz cv cfn wcel wa wa vz cv cB inss1 a1i sylanc adantr vz cv cB cin
      c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel
      w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa wa cA
      vz cv cint wceq wa vz cv cB cin cint eqidd syl3anc vz cv cB cin cint cvv
      wcel cB cD wcel vz cv cB cin cint cB cfi cfv wcel vx cv cB wss vx cv cfn
      wcel vz cv cB cin cint vx cv cint wceq w3a vx wex wb vz cv cB cin c0 wceq
      wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz
      cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa wa cA vz cv cint
      wceq wa vx vz cv cB cin cint cvv cB cD sppfi vz cv cB cin c0 wceq wn vz
      cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB
      cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq
      wa vz cv cB cin c0 wne vz cv cB cin cint cvv wcel vz cv cB cin c0 wceq wn
      vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv
      cB cin c0 wne vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa
      cA vz cv cint wceq vz cv cB cin c0 wceq wn vz cv cB cin c0 wne vz cv cC
      cin c0 wceq wn cA cvv wcel cB cD wcel cC cK wcel w3a vz cv cB cin c0 wne
      vz cv cB cin c0 wceq wn vz cv cB cin c0 df-ne biimpri ad2antrr ad2antrr
      vz cv cB cin intex sylib vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn
      wa cA cvv wcel cB cD wcel cC cK wcel w3a wa cB cD wcel vz cv cB cin vz cv
      cC cin cun vz cv wceq vz cv cfn wcel wa cA vz cv cint wceq cA cvv wcel cB
      cD wcel cC cK wcel w3a cB cD wcel vz cv cB cin c0 wceq wn vz cv cC cin c0
      wceq wn wa cA cvv wcel cB cD wcel cC cK wcel 3simp2 adantl ad2antrr
      sylanc mpbird vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv
      wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv
      wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vz cv cC cin cint cC cfi
      cfv wcel vx cv cC wss vx cv cfn wcel vz cv cC cin cint vx cv cint wceq
      w3a vx wex vz cv cC cin cC wss vz cv cC cin cfn wcel vz cv cC cin cint vz
      cv cC cin cint wceq vx cv cC wss vx cv cfn wcel vz cv cC cin cint vx cv
      cint wceq w3a vx wex vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa
      cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz
      cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vx cv cC wss vx cv cfn
      wcel vz cv cC cin cint vx cv cint wceq w3a vz cv cC cin cC wss vz cv cC
      cin cfn wcel vz cv cC cin cint vz cv cC cin cint wceq w3a vx vz cv cC cin
      vz cv cC vz visset inex1 vx cv vz cv cC cin wceq vx cv cC wss vz cv cC
      cin cC wss vx cv cfn wcel vz cv cC cin cfn wcel vz cv cC cin cint vx cv
      cint wceq vz cv cC cin cint vz cv cC cin cint wceq vx cv vz cv cC cin cC
      sseq1 vx cv vz cv cC cin cfn eleq1 vx cv vz cv cC cin wceq vx cv cint vz
      cv cC cin cint vz cv cC cin cint vx cv vz cv cC cin inteq eqeq2d
      3anbi123d cla4ev vz cv cC cin cC wss vz cv cB cin c0 wceq wn vz cv cC cin
      c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv
      cC cin cun vz cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vz cv cC
      inss2 a1i vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa vz
      cv cC cin cfn wcel vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA
      cvv wcel cB cD wcel cC cK wcel w3a wa cA vz cv cint wceq vz cv cfn wcel
      vz cv cC cin cfn wcel vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn
      wcel vz cv cC cin vz cv wss vz cv cC cin cfn wcel vz cv cC inss1 vz cv vz
      cv cC cin ssfi mpan2 adantl ad2antlr vz cv cB cin c0 wceq wn vz cv cC cin
      c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv
      cC cin cun vz cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vz cv cC
      cin cint eqidd syl3anc vz cv cC cin cint cvv wcel cC cK wcel vz cv cC cin
      cint cC cfi cfv wcel vx cv cC wss vx cv cfn wcel vz cv cC cin cint vx cv
      cint wceq w3a vx wex wb vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn
      wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun
      vz cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vx vz cv cC cin
      cint cvv cC cK sppfi vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa
      cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin cun vz
      cv wceq vz cv cfn wcel wa wa cA vz cv cint wceq wa vz cv cC cin c0 wne vz
      cv cC cin cint cvv wcel vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn
      wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cC cin c0 wne vz cv cB
      cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa cA vz cv cint wceq vz
      cv cC cin c0 wceq wn vz cv cC cin c0 wne vz cv cB cin c0 wceq wn cA cvv
      wcel cB cD wcel cC cK wcel w3a vz cv cC cin c0 wne vz cv cC cin c0 wceq
      wn vz cv cC cin c0 df-ne biimpri ad2antlr ad2antrr vz cv cC cin intex
      sylib vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB
      cD wcel cC cK wcel w3a wa cC cK wcel vz cv cB cin vz cv cC cin cun vz cv
      wceq vz cv cfn wcel wa cA vz cv cint wceq cA cvv wcel cB cD wcel cC cK
      wcel w3a cC cK wcel vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA
      cvv wcel cB cD wcel cC cK wcel 3simp3 adantl ad2antrr sylanc mpbird vz cv
      cB cin c0 wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK
      wcel w3a wa vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cfn wcel wa wa
      cA vz cv cint wceq wa cA vz cv cB cin vz cv cC cin cun cint vz cv cB cin
      cint vz cv cC cin cint cin vz cv cB cin c0 wceq wn vz cv cC cin c0 wceq
      wn wa cA cvv wcel cB cD wcel cC cK wcel w3a wa vz cv cB cin vz cv cC cin
      cun vz cv wceq vz cv cfn wcel wa wa cA vz cv cB cin vz cv cC cin cun cint
      wceq cA vz cv cint wceq vz cv cB cin vz cv cC cin cun vz cv wceq cA vz cv
      cB cin vz cv cC cin cun cint wceq cA vz cv cint wceq wb vz cv cB cin c0
      wceq wn vz cv cC cin c0 wceq wn wa cA cvv wcel cB cD wcel cC cK wcel w3a
      wa vz cv cfn wcel vz cv cB cin vz cv cC cin cun vz cv wceq vz cv cB cin
      vz cv cC cin cun cint vz cv cint cA vz cv cB cin vz cv cC cin cun vz cv
      inteq eqeq2d ad2antrl biimpar vz cv cB cin vz cv cC cin intun syl6eq
      syl3anc ex cA vx cv vy cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex
      cA cB cfi cfv wcel cA cC cfi cfv wcel 3mix3 syl6 exp43 4cases vz cv cB cC
      cun wss vz cv cB cC cun cin vz cv wceq vz cv cB cin vz cv cC cin cun vz
      cv wceq vz cv cB cC cun df-ss vz cv cB cC cun cin vz cv cB cin vz cv cC
      cin cun vz cv vz cv cB cC indi eqeq1i bitri syl5ib 3impd 19.23adv cA cvv
      wcel cB cD wcel cC cK wcel w3a cA cB cfi cfv wcel vz cv cB cC cun wss vz
      cv cfn wcel cA vz cv cint wceq w3a vz wex cA cC cfi cfv wcel cA vx cv vy
      cv cin wceq vy cC cfi cfv wrex vx cB cfi cfv wrex cA cvv wcel cB cD wcel
      cC cK wcel w3a cA cB cfi cfv wcel cA cB cC cun cfi cfv wcel vz cv cB cC
      cun wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex cA cvv wcel cB cD
      wcel cC cK wcel w3a cB cfi cfv cB cC cun cfi cfv cA cB cD wcel cC cK wcel
      cB cfi cfv cB cC cun cfi cfv wss cA cvv wcel cB cD wcel cC cK wcel wa cB
      cC cun cvv wcel cB cfi cfv cB cC cun cfi cfv wss cB cC cD cK unexg cB cC
      cun cvv wcel cB cB cC cun wss cB cfi cfv cB cC cun cfi cfv wss cB cC
      ssun1 cB cB cC cun cvv fiss mpan2 syl 3adant1 sseld cA cvv wcel cB cC cun
      cvv wcel cA cB cC cun cfi cfv wcel vz cv cB cC cun wss vz cv cfn wcel cA
      vz cv cint wceq w3a vz wex wb cA cvv wcel cB cD wcel cC cK wcel w3a vz cA
      cvv cB cC cun cvv sppfi cA cvv wcel cB cD wcel cC cK wcel 3simp1 cB cD
      wcel cC cK wcel cB cC cun cvv wcel cA cvv wcel cB cC cD cK unexg 3adant1
      sylanc sylibd cA cvv wcel cB cD wcel cC cK wcel w3a cA cC cfi cfv wcel cA
      cB cC cun cfi cfv wcel vz cv cB cC cun wss vz cv cfn wcel cA vz cv cint
      wceq w3a vz wex cA cvv wcel cB cD wcel cC cK wcel w3a cC cfi cfv cB cC
      cun cfi cfv cA cB cD wcel cC cK wcel cC cfi cfv cB cC cun cfi cfv wss cA
      cvv wcel cB cD wcel cC cK wcel wa cB cC cun cvv wcel cC cfi cfv cB cC cun
      cfi cfv wss cB cC cD cK unexg cB cC cun cvv wcel cC cB cC cun wss cC cfi
      cfv cB cC cun cfi cfv wss cC cB ssun2 cC cB cC cun cvv fiss mpan2 syl
      3adant1 sseld cA cvv wcel cB cD wcel cC cK wcel cA cB cC cun cfi cfv wcel
      vz cv cB cC cun wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex wb cA
      cvv wcel cB cC cun cvv wcel cA cB cC cun cfi cfv wcel vz cv cB cC cun wss
      vz cv cfn wcel cA vz cv cint wceq w3a vz wex wb cB cD wcel cC cK wcel wa
      vz cA cvv cB cC cun cvv sppfi cB cC cD cK unexg sylan2 3impb sylibd cA
      cvv wcel cB cD wcel cC cK wcel w3a cA vx cv vy cv cin wceq vz cv cB cC
      cun wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex vx vy cB cfi cfv cC
      cfi cfv cA cvv wcel cB cD wcel cC cK wcel w3a vx cv cB cfi cfv wcel vy cv
      cC cfi cfv wcel wa vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a
      vu wex vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a vv wex wa cA
      vx cv vy cv cin wceq vz cv cB cC cun wss vz cv cfn wcel cA vz cv cint
      wceq w3a vz wex wi cA cvv wcel cB cD wcel cC cK wcel w3a vx cv cB cfi cfv
      wcel vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a vu wex vy cv
      cC cfi cfv wcel vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a vv
      wex cB cD wcel cA cvv wcel vx cv cB cfi cfv wcel vu cv cB wss vu cv cfn
      wcel vx cv vu cv cint wceq w3a vu wex wb cC cK wcel vx cv cvv wcel cB cD
      wcel vx cv cB cfi cfv wcel vu cv cB wss vu cv cfn wcel vx cv vu cv cint
      wceq w3a vu wex wb vx visset vu vx cv cvv cB cD sppfi mpan 3ad2ant2 cC cK
      wcel cA cvv wcel vy cv cC cfi cfv wcel vv cv cC wss vv cv cfn wcel vy cv
      vv cv cint wceq w3a vv wex wb cB cD wcel vy cv cvv wcel cC cK wcel vy cv
      cC cfi cfv wcel vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a vv
      wex wb vy visset vv vy cv cvv cC cK sppfi mpan 3ad2ant3 anbi12d cA cvv
      wcel cB cD wcel cC cK wcel w3a vu cv cB wss vu cv cfn wcel vx cv vu cv
      cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a wa vv
      wex vu wex cA vx cv vy cv cin wceq vz cv cB cC cun wss vz cv cfn wcel cA
      vz cv cint wceq w3a vz wex wi vu cv cB wss vu cv cfn wcel vx cv vu cv
      cint wceq w3a vu wex vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq
      w3a vv wex wa cA cvv wcel cB cD wcel cC cK wcel w3a vu cv cB wss vu cv
      cfn wcel vx cv vu cv cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv vv
      cv cint wceq w3a wa cA vx cv vy cv cin wceq vz cv cB cC cun wss vz cv cfn
      wcel cA vz cv cint wceq w3a vz wex wi vu vv cA cvv wcel cB cD wcel cC cK
      wcel w3a vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a vv cv cC
      wss vv cv cfn wcel vy cv vv cv cint wceq w3a wa cA vx cv vy cv cin wceq
      vz cv cB cC cun wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex vu cv vv
      cv cun cB cC cun wss vu cv vv cv cun cfn wcel cA vu cv vv cv cun cint
      wceq vz cv cB cC cun wss vz cv cfn wcel cA vz cv cint wceq w3a vz wex cA
      cvv wcel cB cD wcel cC cK wcel w3a vu cv cB wss vu cv cfn wcel vx cv vu
      cv cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a wa
      wa cA vx cv vy cv cin wceq wa vz cv cB cC cun wss vz cv cfn wcel cA vz cv
      cint wceq w3a vu cv vv cv cun cB cC cun wss vu cv vv cv cun cfn wcel cA
      vu cv vv cv cun cint wceq w3a vz vu cv vv cv cun vu cv vv cv vu visset vv
      visset unex vz cv vu cv vv cv cun wceq vz cv cB cC cun wss vu cv vv cv
      cun cB cC cun wss vz cv cfn wcel vu cv vv cv cun cfn wcel cA vz cv cint
      wceq cA vu cv vv cv cun cint wceq vz cv vu cv vv cv cun cB cC cun sseq1
      vz cv vu cv vv cv cun cfn eleq1 vz cv vu cv vv cv cun wceq vz cv cint vu
      cv vv cv cun cint cA vz cv vu cv vv cv cun inteq eqeq2d 3anbi123d cla4ev
      vu cv cB wss vv cv cC wss vu cv vv cv cun cB cC cun wss cA cvv wcel cB cD
      wcel cC cK wcel w3a vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a
      vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a wa wa cA vx cv vy
      cv cin wceq wa vu cv cB vv cv cC unss12 vu cv cB wss vu cv cfn wcel vx cv
      vu cv cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a
      wa vu cv cB wss cA cvv wcel cB cD wcel cC cK wcel w3a cA vx cv vy cv cin
      wceq vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq vv cv cC wss vv cv
      cfn wcel vy cv vv cv cint wceq w3a 3simpl1 ad2antlr vu cv cB wss vu cv
      cfn wcel vx cv vu cv cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv vv
      cv cint wceq w3a wa vv cv cC wss cA cvv wcel cB cD wcel cC cK wcel w3a cA
      vx cv vy cv cin wceq vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq
      w3a vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq 3simpr1 ad2antlr
      sylanc vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a vv cv cC wss
      vv cv cfn wcel vy cv vv cv cint wceq w3a wa vu cv vv cv cun cfn wcel cA
      cvv wcel cB cD wcel cC cK wcel w3a cA vx cv vy cv cin wceq vu cv cfn wcel
      vu cv cB wss vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a vu cv
      vv cv cun cfn wcel vx cv vu cv cint wceq vu cv cfn wcel vv cv cC wss vv
      cv cfn wcel vu cv vv cv cun cfn wcel vy cv vv cv cint wceq vu cv vv cv
      unfi 3ad2antr2 3ad2antl2 ad2antlr cA cvv wcel cB cD wcel cC cK wcel w3a
      vu cv cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a vv cv cC wss vv cv
      cfn wcel vy cv vv cv cint wceq w3a wa wa cA vx cv vy cv cin wceq cA vu cv
      vv cv cun cint wceq cA cvv wcel cB cD wcel cC cK wcel w3a vu cv cB wss vu
      cv cfn wcel vx cv vu cv cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv
      vv cv cint wceq w3a wa wa vx cv vy cv cin vu cv vv cv cun cint cA vu cv
      cB wss vu cv cfn wcel vx cv vu cv cint wceq w3a vv cv cC wss vv cv cfn
      wcel vy cv vv cv cint wceq w3a wa vx cv vy cv cin vu cv vv cv cun cint
      wceq cA cvv wcel cB cD wcel cC cK wcel w3a vx cv vu cv cint wceq vu cv cB
      wss vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a vx cv vy cv cin
      vu cv vv cv cun cint wceq vu cv cfn wcel vx cv vu cv cint wceq vv cv cC
      wss vy cv vv cv cint wceq vx cv vy cv cin vu cv vv cv cun cint wceq vv cv
      cfn wcel vx cv vu cv cint wceq vy cv vv cv cint wceq wa vx cv vy cv cin
      vu cv cint vv cv cint cin vu cv vv cv cun cint vx cv vu cv cint vy cv vv
      cv cint ineq12 vu cv vv cv intun syl6eqr 3ad2antr3 3ad2antl3 adantl
      eqeq2d biimpa syl3anc exp31 19.23advv vu cv cB wss vu cv cfn wcel vx cv
      vu cv cint wceq w3a vv cv cC wss vv cv cfn wcel vy cv vv cv cint wceq w3a
      vu vv eeanv syl5ibr sylbid r19.23advv 3jaod impbid bitrd pm5.21nd $.
      $( [15-Nov-2009] $) $( [15-Nov-2009] $)
  $}

  ${
    $d a b c k m n r s t u v w x y z A $. $d a b c k m n r s t u v w x y z B $.
    $( Lemma for ~ fictb . $)
    fictblem $p |- ( ( ( A e. B /\ A ~<_ om ) /\ ( m e. om /\ n e. om ) ) -> (
    n C_ m -> ( ( r e. ( rec ( { <. u , v >. | v = { w | E. y e. u E. z e. u w
    = ( y i^i z ) } } , A ) ` m ) /\ s e. ( rec ( { <. u , v >. | v = { w | E.
    y e. u E. z e. u w = ( y i^i z ) } } , A ) ` n ) ) -> E. x e. om ( r i^i s
    ) e. ( rec ( { <. u , v >. | v = { w | E. y e. u E. z e. u w = ( y i^i z )
    } } , A ) ` x ) ) ) ) $=
      cA cB wcel cA com cdom wbr wa vm cv com wcel vn cv com wcel wa wa vn cv
      vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vn cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv
      vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel wa vr cv vs cv cin vx cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vx com wrex cA cB wcel cA com cdom wbr wa vm cv com wcel vn
      cv com wcel wa wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel wa vr cv vm cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa wi cA cB wcel
      cA com cdom wbr wa vm cv com wcel vn cv com wcel wa wa vn cv vm cv wss wa
      vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel vs cv vm cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wcel vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wcel cA cB wcel cA com cdom
      wbr wa vm cv com wcel vn cv com wcel wa wa vn cv vm cv wss wa vn cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vs cv vm cv com wcel vn cv
      com wcel wa vn cv vm cv wss vn cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wss cA cB wcel cA com cdom wbr wa vn cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv
      csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vm cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wss vx vk vm cv vn cv vx cv vn cv wceq vx cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vn cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv vx cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg fveq2 sseq2d vx cv vk cv wceq vx cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vn cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vx cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg fveq2 sseq2d vx cv vk cv csuc
      wceq vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv vk cv csuc vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vx cv vk cv csuc vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg fveq2
      sseq2d vx cv vm cv wceq vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vm cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vx cv vm cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      fveq2 sseq2d vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv vn cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wss vn cv com wcel vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ssid a1i vk cv com wcel
      vn cv com wcel wa vn cv vk cv wss wa vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk
      cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv
      csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wss wi vk cv com wcel vn cv com wcel wa vn
      cv vk cv wss wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vc cv vm cv vn cv cin wceq
      vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wrex vc cab vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wrex vc cab wss vk cv com wcel vn cv com
      wcel wa vn cv vk cv wss wa vt vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vc cv vm cv
      vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wrex vc cab vt cv vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vt cv
      vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wrex vt cv vc cv vm cv vn cv cin wceq vn vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab wcel
      vt cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel vt cv vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wcel vt cv vt cv vt cv cin wceq vt cv vm cv vn cv cin wceq vn vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vt cv
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel id vt cv vt cv vt cv cin wceq vt cv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vt cv vt cv cin vt cv vt cv inidm
      eqcomi a1i vt cv vm cv vn cv cin wceq vt cv vt cv vt cv cin wceq vt cv vt
      cv vn cv cin wceq vm vn vt cv vt cv vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vm cv vt cv wceq vm cv vn cv cin vt cv vn cv
      cin vt cv vm cv vt cv vn cv ineq1 eqeq2d vn cv vt cv wceq vt cv vn cv cin
      vt cv vt cv cin vt cv vn cv vt cv vt cv ineq2 eqeq2d rcla42ev mpd3an23 vc
      cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wrex vt cv vm cv vn cv cin wceq vn vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc vt cv vt
      visset vc cv vt cv wceq vc cv vm cv vn cv cin wceq vt cv vm cv vn cv cin
      wceq vm vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vc cv vt cv vm cv vn cv cin eqeq1 2rexbidv elab sylibr ssriv a1i vk cv
      com wcel vn cv com wcel wa vn cv vk cv wss wa vk cv csuc vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv vc cv vm cv vn cv
      cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vc cab vk cv com wcel vk cv csuc vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cfv wceq vn cv com wcel vn cv
      vk cv wss vk cv com wcel vk cv con0 wcel vk cv csuc vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv wceq vk cv nnon cA vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab rdgsuc syl ad2antrr vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv vs cv vc cv vm cv vn cv cin
      wceq vn vr cv wrex vm vr cv wrex vc cab wceq vr vs copab cfv vc cv vm cv
      vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wrex vc cab vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab vs cv
      vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex vc cab wceq vr vs
      copab vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab vs cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv
      wrex vw cab wceq vr vs copab vs cv vc cv vm cv vn cv cin wceq vn vr cv
      wrex vm vr cv wrex vc cab wceq vr vs copab vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vs cv vw cv vy cv vz cv cin
      wceq vz vr cv wrex vy vr cv wrex vw cab wceq vu vv vr vs vu cv vr cv wceq
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vv cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw cab wceq
      vv cv vs cv wceq vs cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv
      wrex vw cab wceq vu cv vr cv wceq vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr
      cv wrex vw cab vv cv vu cv vr cv wceq vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex
      vw vw cv vy cv vz cv cin wceq vz vu cv wrex vw cv vy cv vz cv cin wceq vz
      vr cv wrex vy vu cv vr cv vw cv vy cv vz cv cin wceq vz vu cv vr cv
      rexeq1 rexeqd abbidv eqeq2d vv cv vs cv vw cv vy cv vz cv cin wceq vz vr
      cv wrex vy vr cv wrex vw cab eqeq1 sylan9bb cbvopabv vs cv vw cv vy cv vz
      cv cin wceq vz vr cv wrex vy vr cv wrex vw cab wceq vs cv vc cv vm cv vn
      cv cin wceq vn vr cv wrex vm vr cv wrex vc cab wceq vr vs vw cv vy cv vz
      cv cin wceq vz vr cv wrex vy vr cv wrex vw cab vc cv vm cv vn cv cin wceq
      vn vr cv wrex vm vr cv wrex vc cab vs cv vw cv vy cv vz cv cin wceq vz vr
      cv wrex vy vr cv wrex vw cab vc cv vy cv vz cv cin wceq vz vr cv wrex vy
      vr cv wrex vc cab vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex
      vc cab vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vc cv vy cv
      vz cv cin wceq vz vr cv wrex vy vr cv wrex vw vc vw cv vc cv wceq vw cv
      vy cv vz cv cin wceq vc cv vy cv vz cv cin wceq vy vz vr cv vr cv vw cv
      vc cv vy cv vz cv cin eqeq1 2rexbidv cbvabv vc cv vy cv vz cv cin wceq vz
      vr cv wrex vy vr cv wrex vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr
      cv wrex vc vc cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vc cv
      vm cv vz cv cin wceq vz vr cv wrex vm vr cv wrex vc cv vm cv vn cv cin
      wceq vn vr cv wrex vm vr cv wrex vc cv vy cv vz cv cin wceq vz vr cv wrex
      vc cv vm cv vz cv cin wceq vz vr cv wrex vy vm vr cv vy cv vm cv wceq vc
      cv vy cv vz cv cin wceq vc cv vm cv vz cv cin wceq vz vr cv vy cv vm cv
      wceq vy cv vz cv cin vm cv vz cv cin vc cv vy cv vm cv vz cv ineq1 eqeq2d
      rexbidv cbvrexv vc cv vm cv vz cv cin wceq vz vr cv wrex vc cv vm cv vn
      cv cin wceq vn vr cv wrex vm vr cv vc cv vm cv vz cv cin wceq vc cv vm cv
      vn cv cin wceq vz vn vr cv vz cv vn cv wceq vm cv vz cv cin vm cv vn cv
      cin vc cv vz cv vn cv vm cv ineq2 eqeq2d cbvrexv rexbii bitri abbii eqtri
      eqeq2i opabbii eqtri fveq1i vr vs vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vc cv vm
      cv vn cv cin wceq vn vr cv wrex vm vr cv wrex vc cab vc cv vm cv vn cv
      cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vc cab vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg fvex vc cv vm cv vn cv cin
      wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vc vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg fvex vn vc vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vm cv vn cv cin vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg fvex abrexex abrexex2
      vr cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wceq vc cv vm cv vn cv cin wceq vn vr
      cv wrex vm vr cv wrex vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc vc cv vm cv vn cv
      cin wceq vn vr cv wrex vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vm vr cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vc cv vm cv vn cv
      cin wceq vn vr cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv rexeq1 rexeqd abbidv
      fvopab eqtri syl6req sseqtrd vn cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wss vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv csuc vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv csuc vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wss vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv sstr expcom syl findsg
      adantll sseld anim2d ex cA cB wcel cA com cdom wbr wa vm cv com wcel vn
      cv com wcel wa wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel wa vr cv vs cv cin vx cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel vx com wrex vm cv csuc com wcel vr cv vs cv cin vm
      cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel vr cv vs cv cin vx cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel vx com wrex cA cB wcel cA com cdom wbr wa vm cv com wcel
      vn cv com wcel wa wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa wa wa vr cv vs cv cin vx
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vr cv vs cv cin vm cv csuc vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel vx vm cv csuc com vx cv vm cv csuc wceq vx cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vm cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vr cv vs cv cin vx
      cv vm cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg fveq2 eleq2d rcla4ev vm cv com wcel
      vn cv com wcel wa vm cv csuc com wcel cA cB wcel cA com cdom wbr wa vn cv
      vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa wa vm cv com wcel vm cv csuc com wcel vn cv com
      wcel vm cv peano2 adantr ad2antlr cA cB wcel cA com cdom wbr wa vm cv com
      wcel vn cv com wcel wa wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa wa wa vr cv vs
      cv cin vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv vm cv csuc vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv cA cB wcel cA com cdom wbr wa vm cv com wcel vn cv com
      wcel wa wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs
      cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel wa wa wa vr cv vs cv cin vc cv va
      cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex va vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vc cab vm cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cfv cA cB wcel cA com cdom wbr wa vm cv com wcel vn cv com wcel wa wa vn
      cv vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vm cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa wa wa vr cv vs cv cin va cv vb cv cin wceq vb
      vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wrex va vm cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex
      vr cv vs cv cin vc cv va cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wrex va vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab wcel vr cv vm cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wcel vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vr
      cv vs cv cin va cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex
      va vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wrex cA cB wcel cA com cdom wbr wa vm cv
      com wcel vn cv com wcel wa wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vr cv vs cv cin vr
      cv vs cv cin wceq vr cv vs cv cin va cv vb cv cin wceq vb vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex va vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vr cv vs cv
      cin eqid vr cv vs cv cin va cv vb cv cin wceq vr cv vs cv cin vr cv vs cv
      cin wceq vr cv vs cv cin vr cv vb cv cin wceq va vb vr cv vs cv vm cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv va cv vr cv wceq va cv
      vb cv cin vr cv vb cv cin vr cv vs cv cin va cv vr cv vb cv ineq1 eqeq2d
      vb cv vs cv wceq vr cv vb cv cin vr cv vs cv cin vr cv vs cv cin vb cv vs
      cv vr cv ineq2 eqeq2d rcla42ev mp3an3 ad2antll vc cv va cv vb cv cin wceq
      vb vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wrex va vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wrex vr cv vs cv cin va cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wrex va vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vc vr cv vs cv cin vr cv vs
      cv vr visset inex1 vc cv vr cv vs cv cin wceq vc cv va cv vb cv cin wceq
      vr cv vs cv cin va cv vb cv cin wceq va vb vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vc cv vr cv vs cv cin va cv vb cv cin eqeq1
      2rexbidv elab sylibr vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vt cv vc cv va cv vb cv
      cin wceq vb vk cv wrex va vk cv wrex vc cab wceq vk vt copab cfv vc cv va
      cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex va vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vc cab vm cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cfv vk vt vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vc cv va cv vb cv cin wceq vb vk
      cv wrex va vk cv wrex vc cab vc cv va cv vb cv cin wceq vb vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex va vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab vm cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg fvex vc cv va cv vb cv cin wceq vb vm cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wrex va vc vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vm cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg fvex vb vc vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv va cv vb cv cin vm cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg fvex abrexex abrexex2 vk cv vm cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wceq vc cv va cv vb cv cin wceq vb vk cv wrex va vk cv wrex vc
      cv va cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex va vm cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wrex vc vc cv va cv vb cv cin wceq vb vk cv wrex
      vc cv va cv vb cv cin wceq vb vm cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex va vk
      cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv vc cv va cv vb cv cin wceq vb vk cv vm
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv rexeq1 rexeqd abbidv fvopab vm cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vt cv vc cv va cv vb cv cin wceq vb vk cv wrex va vk cv
      wrex vc cab wceq vk vt copab vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab vt cv vc cv va cv vb cv cin
      wceq vb vk cv wrex va vk cv wrex vc cab wceq vk vt copab vt cv vw cv vy
      cv vz cv cin wceq vz vk cv wrex vy vk cv wrex vw cab wceq vk vt copab vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab vt cv vc cv va cv vb cv cin wceq vb vk cv wrex va vk cv wrex vc
      cab wceq vt cv vw cv vy cv vz cv cin wceq vz vk cv wrex vy vk cv wrex vw
      cab wceq vk vt vc cv va cv vb cv cin wceq vb vk cv wrex va vk cv wrex vc
      cab vw cv vy cv vz cv cin wceq vz vk cv wrex vy vk cv wrex vw cab vt cv
      vc cv va cv vb cv cin wceq vb vk cv wrex va vk cv wrex vc cab vc cv vy cv
      vz cv cin wceq vz vk cv wrex vy vk cv wrex vc cab vw cv vy cv vz cv cin
      wceq vz vk cv wrex vy vk cv wrex vw cab vc cv va cv vb cv cin wceq vb vk
      cv wrex va vk cv wrex vc cv vy cv vz cv cin wceq vz vk cv wrex vy vk cv
      wrex vc vc cv va cv vb cv cin wceq vb vk cv wrex va vk cv wrex vc cv va
      cv vz cv cin wceq vz vk cv wrex va vk cv wrex vc cv vy cv vz cv cin wceq
      vz vk cv wrex vy vk cv wrex vc cv va cv vb cv cin wceq vb vk cv wrex vc
      cv va cv vz cv cin wceq vz vk cv wrex va vk cv vc cv va cv vb cv cin wceq
      vc cv va cv vz cv cin wceq vb vz vk cv vb cv vz cv wceq va cv vb cv cin
      va cv vz cv cin vc cv vb cv vz cv va cv ineq2 eqeq2d cbvrexv rexbii vc cv
      va cv vz cv cin wceq vz vk cv wrex vc cv vy cv vz cv cin wceq vz vk cv
      wrex va vy vk cv va cv vy cv wceq vc cv va cv vz cv cin wceq vc cv vy cv
      vz cv cin wceq vz vk cv va cv vy cv wceq va cv vz cv cin vy cv vz cv cin
      vc cv va cv vy cv vz cv ineq1 eqeq2d rexbidv cbvrexv bitri abbii vc cv vy
      cv vz cv cin wceq vz vk cv wrex vy vk cv wrex vw cv vy cv vz cv cin wceq
      vz vk cv wrex vy vk cv wrex vc vw vc cv vw cv wceq vc cv vy cv vz cv cin
      wceq vw cv vy cv vz cv cin wceq vy vz vk cv vk cv vc cv vw cv vy cv vz cv
      cin eqeq1 2rexbidv cbvabv eqtri eqeq2i opabbii vt cv vw cv vy cv vz cv
      cin wceq vz vk cv wrex vy vk cv wrex vw cab wceq vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vk vt vu vv vk cv vu cv
      wceq vt cv vw cv vy cv vz cv cin wceq vz vk cv wrex vy vk cv wrex vw cab
      wceq vt cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vt cv vv cv wceq vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vk cv vu cv wceq vw cv vy cv vz cv cin wceq vz vk
      cv wrex vy vk cv wrex vw cab vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab vt cv vk cv vu cv wceq vw cv vy cv vz cv cin wceq vz vk
      cv wrex vy vk cv wrex vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw vw cv vy cv vz cv cin wceq vz vk cv wrex vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vk cv vu cv vw cv vy cv vz cv cin wceq vz vk cv vu
      cv rexeq1 rexeqd abbidv eqeq2d vt cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab eqeq1 sylan9bb cbvopabv eqtri fveq1i
      eqtr3i syl6eleq vm cv com wcel vn cv com wcel wa vm cv csuc vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv wceq cA cB wcel
      cA com cdom wbr wa vn cv vm cv wss vr cv vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vs cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa wa vm cv com wcel vm cv
      csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv
      wceq vn cv com wcel vm cv com wcel vm cv con0 wcel vm cv csuc vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv wceq vm cv nnon
      cA vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab rdgsuc syl adantr ad2antlr eleqtrrd sylanc exp32
      syldd $.
      $( [25-Aug-2009] $) $( [25-Aug-2009] $)

    $( A set is countable iff its collection of finite intersections is
       countable. $)
    fictb $p |- ( A e. B -> ( A ~<_ om <-> ( fi ` A ) ~<_ om ) ) $=
      cA cB wcel cA com cdom wbr cA cfi cfv com cdom wbr cA cB wcel cA com cdom
      wbr cA cfi cfv com cdom wbr cA cfi cfv vx com vx cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv ciun cdom wbr vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun com cdom wbr
      cA cfi cfv com cdom wbr cA cB wcel cA com cdom wbr wa cA cfi cfv vx com
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv ciun com domtr cA cB wcel cA com cdom wbr wa
      cA cfi cfv cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv
      wral wa vt cab cint vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun cdom cA cB
      wcel cA cfi cfv cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr
      vt cv wral wa vt cab cint wceq cA com cdom wbr cA cB wcel cA cfi cfv vr
      cv cA wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr wex vt cab cA vt cv
      wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt cab cint
      vr vt cA cB fiv vc cv vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral
      vr vt cv wral wa vt cab cint vr cv vc cv wss vr cv cfn wcel vt cv vr cv
      cint wceq w3a vr wex vt cab wceq cA vt cv wss vr cv vs cv cin vt cv wcel
      vs vt cv wral vr vt cv wral wa vt cab cint vr cv cA wss vr cv cfn wcel vt
      cv vr cv cint wceq w3a vr wex vt cab wceq vc cA cB vc cv cA wceq vc cv vt
      cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt cab
      cint cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral
      wa vt cab cint vr cv vc cv wss vr cv cfn wcel vt cv vr cv cint wceq w3a
      vr wex vt cab vr cv cA wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr
      wex vt cab vc cv cA wceq vc cv vt cv wss vr cv vs cv cin vt cv wcel vs vt
      cv wral vr vt cv wral wa vt cab cA vt cv wss vr cv vs cv cin vt cv wcel
      vs vt cv wral vr vt cv wral wa vt cab vc cv cA wceq vc cv vt cv wss vr cv
      vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa cA vt cv wss vr cv vs
      cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt vc cv cA wceq vc cv
      vt cv wss cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv
      wral vc cv cA vt cv sseq1 anbi1d abbidv inteqd vc cv cA wceq vr cv vc cv
      wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr wex vr cv cA wss vr cv
      cfn wcel vt cv vr cv cint wceq w3a vr wex vt vc cv cA wceq vr cv vc cv
      wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr cv cA wss vr cv cfn wcel
      vt cv vr cv cint wceq w3a vr vc cv cA wceq vr cv vc cv wss vr cv cA wss
      vr cv cfn wcel vt cv vr cv cint wceq vc cv cA vr cv sseq2 3anbi1d exbidv
      abbidv eqeq12d vt vr vs vc cv vc visset abfii5 vtoclg eqtr4d adantr cA vt
      cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt cab
      cint cvv wcel cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt
      cv wral wa vt cab cint vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wss cA
      vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt
      cab cint vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun cdom wbr cA cB wcel
      cA com cdom wbr wa cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral
      vr vt cv wral wa vt cab cint vx com vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun
      cvv ssdomg cA cB wcel cA com cdom wbr wa cA vt cv wss vr cv vs cv cin vt
      cv wcel vs vt cv wral vr vt cv wral wa vt cab cint cA cfi cfv cvv cA cB
      wcel cA cfi cfv cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr
      vt cv wral wa vt cab cint wceq cA com cdom wbr cA cB wcel cA cfi cfv vr
      cv cA wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr wex vt cab cA vt cv
      wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt cab cint
      vr vt cA cB fiv vc cv vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral
      vr vt cv wral wa vt cab cint vr cv vc cv wss vr cv cfn wcel vt cv vr cv
      cint wceq w3a vr wex vt cab wceq cA vt cv wss vr cv vs cv cin vt cv wcel
      vs vt cv wral vr vt cv wral wa vt cab cint vr cv cA wss vr cv cfn wcel vt
      cv vr cv cint wceq w3a vr wex vt cab wceq vc cA cB vc cv cA wceq vc cv vt
      cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt cab
      cint cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral
      wa vt cab cint vr cv vc cv wss vr cv cfn wcel vt cv vr cv cint wceq w3a
      vr wex vt cab vr cv cA wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr
      wex vt cab vc cv cA wceq vc cv vt cv wss vr cv vs cv cin vt cv wcel vs vt
      cv wral vr vt cv wral wa vt cab cA vt cv wss vr cv vs cv cin vt cv wcel
      vs vt cv wral vr vt cv wral wa vt cab vc cv cA wceq vc cv vt cv wss vr cv
      vs cv cin vt cv wcel vs vt cv wral vr vt cv wral wa cA vt cv wss vr cv vs
      cv cin vt cv wcel vs vt cv wral vr vt cv wral wa vt vc cv cA wceq vc cv
      vt cv wss cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv
      wral vc cv cA vt cv sseq1 anbi1d abbidv inteqd vc cv cA wceq vr cv vc cv
      wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr wex vr cv cA wss vr cv
      cfn wcel vt cv vr cv cint wceq w3a vr wex vt vc cv cA wceq vr cv vc cv
      wss vr cv cfn wcel vt cv vr cv cint wceq w3a vr cv cA wss vr cv cfn wcel
      vt cv vr cv cint wceq w3a vr vc cv cA wceq vr cv vc cv wss vr cv cA wss
      vr cv cfn wcel vt cv vr cv cint wceq vc cv cA vr cv sseq2 3anbi1d exbidv
      abbidv eqeq12d vt vr vs vc cv vc visset abfii5 vtoclg eqtr4d adantr cA
      cfi fvex syl6eqelr cA cB wcel cA com cdom wbr wa vx com vx cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv ciun cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr
      vt cv wral wa vt cab wcel cA vt cv wss vr cv vs cv cin vt cv wcel vs vt
      cv wral vr vt cv wral wa vt cab cint vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun wss cA cB wcel cA com cdom wbr wa cA vx com vx cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv ciun wss vr cv vs cv cin vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun wcel vs vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wral vr vx com vx
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv ciun wral wa vx com vx cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv ciun cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt
      cv wral wa vt cab wcel cA cB wcel cA com cdom wbr wa cA vx com vx cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv ciun wss vr cv vs cv cin vx com vx cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv ciun wcel vs vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wral vr vx
      com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv ciun wral cA cB wcel cA com cdom wbr wa
      cA c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vx com vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun
      cA cB wcel c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv cA wceq cA com cdom wbr cA cB vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab rdg0g adantr c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vx com vx cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv ciun wss cA cB wcel cA com cdom wbr wa c0 com wcel c0
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wss
      peano1 vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv c0 c0 vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vx cv c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg fveq2 ssiun2s ax-mp a1i eqsstr3d cA cB wcel
      cA com cdom wbr wa vr cv vs cv cin vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun wcel vr vs vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun vx com vx cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv ciun cA cB wcel cA com cdom wbr wa vr cv vx cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wcel vx com wrex vs cv vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vx com wrex wa vr cv vs cv cin vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vx com wrex vr cv vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wcel vs cv vx
      com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv ciun wcel wa vr cv vs cv cin vx com vx
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv ciun wcel cA cB wcel cA com cdom wbr wa vr
      cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel vm com wrex vs cv vn cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel vn com wrex wa vr cv vs cv cin vx cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vx com wrex vr cv vx cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vx com
      wrex vs cv vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel vx com wrex wa cA cB wcel
      cA com cdom wbr wa vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vn cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wcel wa vn com wrex vm com wrex vr cv vs cv cin
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vx com wrex vr cv vm cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vm com wrex vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vn com
      wrex wa cA cB wcel cA com cdom wbr wa vr cv vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vr cv vs cv cin vx cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wcel vx com wrex vm vn com com cA cB wcel cA com
      cdom wbr wa vm cv com wcel vn cv com wcel wa vr cv vm cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vr cv vs cv cin
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vx com wrex wi cA cB wcel cA com cdom
      wbr wa vm cv com wcel vn cv com wcel wa wa vm cv vn cv wss vn cv vm cv
      wss wo vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vn cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel wa vr cv vs cv cin vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vx com wrex wi vm cv com wcel vn cv com wcel wa vm cv vn cv wss vn cv vm
      cv wss wo cA cB wcel cA com cdom wbr wa vm cv word vn cv word vm cv vn cv
      wss vn cv vm cv wss wo vm cv com wcel vn cv com wcel vm cv vn cv
      ordtri2or2 vm cv nnord vn cv nnord syl2an adantl cA cB wcel cA com cdom
      wbr wa vm cv com wcel vn cv com wcel wa wa vm cv vn cv wss vr cv vm cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wcel vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vr
      cv vs cv cin vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vx com wrex wi vn cv vm
      cv wss cA cB wcel cA com cdom wbr wa vn cv com wcel vm cv com wcel vm cv
      vn cv wss vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vn cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa vr cv vs cv cin vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vx com wrex wi wi cA cB wcel cA com cdom wbr wa vn cv com wcel vm cv
      com wcel wa wa vm cv vn cv wss vs cv vn cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel wa vr cv vs cv cin vx cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel vx com wrex vr cv vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa cA cB wcel cA com cdom
      wbr wa vn cv com wcel vm cv com wcel wa wa vm cv vn cv wss vs cv vn cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wcel vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vs
      cv vr cv cin vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vx com wrex vr cv vs cv
      cin vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel vx com wrex vx vy vz vw vv vu cA cB
      vn vm vr vs fictblem vs cv vr cv cin vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vr cv vs cv cin vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vx com vs cv vr cv
      cin vr cv vs cv cin vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vs cv vr cv incom
      eleq1i rexbii syl8ib vr cv vm cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vn
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel ancom syl7ib ancom2s vx vy vz vw vv vu
      cA cB vm vn vs vr fictblem jaod mpd ex r19.23advv vr cv vm cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vm vn com com
      reeanv syl5ibr vr cv vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vx com wrex vr cv
      vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vm com wrex vs cv vx cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vx com wrex vs cv vn cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vn com
      wrex vr cv vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel vr cv vm cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vx vm com vx cv vm cv wceq vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vm cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vr cv vx cv vm cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      fveq2 eleq2d cbvrexv vs cv vx cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vs cv vn
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vx vn com vx cv vn cv wceq vx cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vn cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vs cv vx cv vn cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg fveq2 eleq2d cbvrexv anbi12i syl5ib vr cv vx com vx cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv ciun wcel vr cv vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vx com wrex vs cv vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wcel vs cv vx
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vx com wrex vx vr cv com vx cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv eliun vx vs cv com vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      eliun anbi12i vx vr cv vs cv cin com vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      eliun 3imtr4g r19.21aivv jca cA vt cv wss vr cv vs cv cin vt cv wcel vs
      vt cv wral vr vt cv wral wa cA vx com vx cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun
      wss vr cv vs cv cin vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wcel vs vx
      com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv ciun wral vr vx com vx cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv ciun wral wa vt vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun vx com
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv omex vx cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg fvex iunex vt
      cv vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv ciun wceq cA vt cv wss cA vx com
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv ciun wss vr cv vs cv cin vt cv wcel vs vt cv
      wral vr vt cv wral vr cv vs cv cin vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun wcel vs vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wral vr vx com vx
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv ciun wral vt cv vx com vx cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv ciun cA sseq2 vr cv vs cv cin vt cv wcel vs vt cv wral vr cv vs
      cv cin vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv ciun wcel vs vx com vx cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv ciun wral vr vt cv vx com vx cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv ciun vr cv vs cv cin vt cv wcel vr cv vs cv cin vx com vx cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv ciun wcel vs vt cv vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun vt cv vx com vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv ciun vr cv vs cv cin eleq2
      raleqd raleqd anbi12d elab sylibr vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun cA vt cv wss vr cv vs cv cin vt cv wcel vs vt cv wral vr vt cv wral
      wa vt cab intss1 syl sylc eqbrtrd com com cdom wbr vx cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv com cdom wbr vx com wral vx com vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      ciun com cdom wbr cA cB wcel cA com cdom wbr wa vx com vx cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv omex vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg fvex iunctb com com cdom wbr
      cA cB wcel cA com cdom wbr wa com cvv wcel com com cdom wbr omex com cvv
      domrefg ax-mp a1i cA cB wcel cA com cdom wbr wa vx cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv com cdom wbr vx com vx cv com wcel cA cB wcel cA com cdom wbr wa
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv com cdom wbr cA cB wcel cA com cdom wbr wa
      vt cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv com cdom wbr wi cA cB wcel cA com cdom wbr
      wa c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv com cdom wbr wi cA cB wcel cA com cdom wbr
      wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv com cdom wbr wi cA cB wcel cA com cdom
      wbr wa vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wi cA cB wcel cA
      com cdom wbr wa vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wi vt vk vx
      cv vt cv c0 wceq vt cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr c0 vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv com cdom wbr cA cB wcel cA com cdom wbr wa vt cv c0
      wceq vt cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv c0 vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom
      vt cv c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg fveq2 breq1d imbi2d vt cv vk cv wceq vt cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv com cdom wbr vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com
      cdom wbr cA cB wcel cA com cdom wbr wa vt cv vk cv wceq vt cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv com cdom vt cv vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg fveq2 breq1d imbi2d vt cv vk cv csuc wceq vt cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv com cdom wbr vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr cA
      cB wcel cA com cdom wbr wa vt cv vk cv csuc wceq vt cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom vt cv vk cv csuc vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg fveq2 breq1d imbi2d vt cv vx cv wceq vt cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv com cdom wbr vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr cA cB
      wcel cA com cdom wbr wa vt cv vx cv wceq vt cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vx cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv com cdom vt cv vx cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      fveq2 breq1d imbi2d cA cB wcel cA com cdom wbr wa c0 vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv cA com cdom cA cB wcel c0 vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv cA wceq cA com
      cdom wbr cA cB vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab rdg0g adantr cA cB wcel cA com cdom wbr
      pm3.27 eqbrtrd vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv com cdom wbr vk cv csuc vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com
      cdom wbr vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv com cdom wbr vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr
      vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv com cdom wbr wa wa vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vc cv vm cv vn
      cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vc cab com cdom vk cv com wcel cA cB wcel cA com cdom wbr
      wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv com cdom wbr wa wa vk cv csuc vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv vc cv vm
      cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vc cab vk cv com wcel vk cv csuc vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv wceq cA cB wcel
      cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa vk cv
      com wcel vk cv con0 wcel vk cv csuc vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cfv wceq vk cv nnon cA vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      rdgsuc syl adantr vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cfv vk cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv vs cv vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr
      cv wrex vc cab wceq vr vs copab cfv vc cv vm cv vn cv cin wceq vn vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab vs cv vc cv vm cv vn cv cin
      wceq vn vr cv wrex vm vr cv wrex vc cab wceq vr vs copab vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab vs
      cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw cab wceq vr
      vs copab vs cv vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex vc
      cab wceq vr vs copab vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vs cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr
      cv wrex vw cab wceq vu vv vr vs vu cv vr cv wceq vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vv cv vw cv vy cv vz cv
      cin wceq vz vr cv wrex vy vr cv wrex vw cab wceq vv cv vs cv wceq vs cv
      vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw cab wceq vu cv
      vr cv wceq vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw cab vv cv vu cv
      vr cv wceq vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cv
      vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw vw cv vy cv vz cv cin
      wceq vz vu cv wrex vw cv vy cv vz cv cin wceq vz vr cv wrex vy vu cv vr
      cv vw cv vy cv vz cv cin wceq vz vu cv vr cv rexeq1 rexeqd abbidv eqeq2d
      vv cv vs cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw cab
      eqeq1 sylan9bb cbvopabv vs cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy
      vr cv wrex vw cab wceq vs cv vc cv vm cv vn cv cin wceq vn vr cv wrex vm
      vr cv wrex vc cab wceq vr vs vw cv vy cv vz cv cin wceq vz vr cv wrex vy
      vr cv wrex vw cab vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex
      vc cab vs cv vw cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vw
      cab vc cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vc cab vc cv
      vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex vc cab vw cv vy cv vz cv
      cin wceq vz vr cv wrex vy vr cv wrex vc cv vy cv vz cv cin wceq vz vr cv
      wrex vy vr cv wrex vw vc vw cv vc cv wceq vw cv vy cv vz cv cin wceq vc
      cv vy cv vz cv cin wceq vy vz vr cv vr cv vw cv vc cv vy cv vz cv cin
      eqeq1 2rexbidv cbvabv vc cv vy cv vz cv cin wceq vz vr cv wrex vy vr cv
      wrex vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex vc vc cv vy
      cv vz cv cin wceq vz vr cv wrex vy vr cv wrex vc cv vm cv vz cv cin wceq
      vz vr cv wrex vm vr cv wrex vc cv vm cv vn cv cin wceq vn vr cv wrex vm
      vr cv wrex vc cv vy cv vz cv cin wceq vz vr cv wrex vc cv vm cv vz cv cin
      wceq vz vr cv wrex vy vm vr cv vy cv vm cv wceq vc cv vy cv vz cv cin
      wceq vc cv vm cv vz cv cin wceq vz vr cv vy cv vm cv wceq vy cv vz cv cin
      vm cv vz cv cin vc cv vy cv vm cv vz cv ineq1 eqeq2d rexbidv cbvrexv vc
      cv vm cv vz cv cin wceq vz vr cv wrex vc cv vm cv vn cv cin wceq vn vr cv
      wrex vm vr cv vc cv vm cv vz cv cin wceq vc cv vm cv vn cv cin wceq vz vn
      vr cv vz cv vn cv wceq vm cv vz cv cin vm cv vn cv cin vc cv vz cv vn cv
      vm cv ineq2 eqeq2d cbvrexv rexbii bitri abbii eqtri eqeq2i opabbii eqtri
      fveq1i vr vs vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv vc cv vm cv vn cv cin wceq vn
      vr cv wrex vm vr cv wrex vc cab vc cv vm cv vn cv cin wceq vn vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg fvex vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wrex vm vc vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg fvex vn vc vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vm cv vn cv cin vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg fvex abrexex abrexex2 vr cv vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wceq vc cv vm cv vn cv cin wceq vn vr cv wrex vm vr cv wrex vc
      cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wrex vc vc cv vm cv vn cv cin wceq vn vr cv wrex
      vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vr
      cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv vc cv vm cv vn cv cin wceq vn vr cv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv rexeq1 rexeqd abbidv fvopab eqtri syl6eq vc
      cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wrex vc cab vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv cxp cdom wbr vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv cxp com cdom wbr vc cv vm cv vn cv cin wceq
      vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wrex vc cab com cdom wbr vk cv com wcel cA cB wcel cA com cdom wbr wa vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv com cdom wbr wa wa vc cv vm cv vn cv cin
      wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vc cab vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv cxp com domtr vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv com cdom wbr wa wa vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv cxp vc cv vm cv vn cv cin wceq vn vk cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab va
      cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel wa vt cv va cv vb cv cin wceq wa va vb vt copab2 wfo vc cv vm cv vn
      cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vc cab vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv cxp cdom wbr vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv com cdom wbr wa wa va cv vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb
      cv cin wceq wa va vb vt copab2 vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv cxp wfn va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb
      vt copab2 crn vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab wceq wa vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv cxp vc cv vm cv vn cv cin
      wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vc cab va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb
      vt copab2 wfo vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv com cdom wbr wa wa va cv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin
      wceq wa va vb vt copab2 crn vc cv vm cv vn cv cin wceq vn vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cab wceq
      va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wcel wa vt cv va cv vb cv cin wceq wa va vb vt copab2 vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv cxp wfn vk cv com wcel cA
      cB wcel cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa
      wa vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wrex vc va cv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin
      wceq wa va vb vt copab2 crn vk cv com wcel cA cB wcel cA com cdom wbr wa
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv com cdom wbr wa wa vm cv vn cv va cv vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa
      vt cv va cv vb cv cin wceq wa va vb vt copab2 co vc cv wceq vn vk cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vc cv vm
      cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vc cv va cv vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb
      cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va
      vb vt copab2 crn wcel vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv com cdom wbr wa wa vm cv vn cv va cv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv
      va cv vb cv cin wceq wa va vb vt copab2 co vc cv wceq vn vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wrex vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv com wcel cA cB wcel
      cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa wa vm
      cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wcel wa vm cv vn cv va cv vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv
      va cv vb cv cin wceq wa va vb vt copab2 co vc cv wceq vc cv vm cv vn cv
      cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vk cv com wcel cA cB wcel cA com
      cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa wa vm cv vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wcel wa vn cv vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      wa vm cv vn cv va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb vt copab2
      co vc cv wceq vm cv vn cv cin vc cv wceq vc cv vm cv vn cv cin wceq vk cv
      com wcel cA cB wcel cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com
      cdom wbr wa wa vm cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vn cv vk cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv wcel wa vm cv vn cv va cv vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin
      wceq wa va vb vt copab2 co vm cv vn cv cin vc cv vm cv vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel vn cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vm cv vn cv
      cin cvv wcel vm cv vn cv va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb
      vt copab2 co vm cv vn cv cin wceq vk cv com wcel cA cB wcel cA com cdom
      wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa wa vm cv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa vn cv vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa va
      vb vt vm cv vn cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv va cv vb cv cin vm cv vn cv cin va cv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin
      wceq wa va vb vt copab2 vm cv vb cv cin cvv va cv vm cv vb cv ineq1 vb cv
      vn cv vm cv ineq2 va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb vt
      copab2 eqid oprabval2g vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv com cdom wbr wa wa vm cv vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vn cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel simplr vk cv com
      wcel cA cB wcel cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom
      wbr wa wa vm cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vn cv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel pm3.27 vm cv vn cv cin cvv wcel vk cv com wcel cA
      cB wcel cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu
      cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa
      wa vm cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vn cv vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv wcel wa vm cv vn cv vm visset inex1 a1i syl3anc eqeq1d vm cv
      vn cv cin vc cv eqcom syl6bb rexbidva rexbidva va cv vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb
      cv cin wceq wa va vb vt copab2 vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv cxp wfn vc cv va cv vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa
      va vb vt copab2 crn wcel vm cv vn cv va cv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin
      wceq wa va vb vt copab2 co vc cv wceq vn vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wrex vm vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wrex wb va vb vt vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv va cv vb cv cin va cv vk
      cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      wa vt cv va cv vb cv cin wceq wa va vb vt copab2 va cv vb cv va visset
      inex1 va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb vt copab2 eqid
      fnoprab2 vm vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      vc cv va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb vt copab2 oprvelrn
      ax-mp syl5bb abbi2dv va vb vt vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv
      vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv va cv vb cv cin va cv vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel
      vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa
      va vb vt copab2 va cv vb cv va visset inex1 va cv vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex
      vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb
      cv cin wceq wa va vb vt copab2 eqid fnoprab2 jctil vk cv vv cv vw cv vy
      cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv cxp vc cv vm cv vn cv cin wceq
      vn vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv wrex vm vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      wrex vc cab va cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy
      vu cv wrex vw cab wceq vu vv copab cA crdg cfv wcel vb cv vk cv vv cv vw
      cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv
      copab cA crdg cfv wcel wa vt cv va cv vb cv cin wceq wa va vb vt copab2
      df-fo sylibr vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      cxp vc cv vm cv vn cv cin wceq vn vk cv vv cv vw cv vy cv vz cv cin wceq
      vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv wrex vm
      vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab
      wceq vu vv copab cA crdg cfv wrex vc cab va cv vk cv vv cv vw cv vy cv vz
      cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg
      cfv wcel vb cv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv wcel wa vt cv va cv vb cv cin
      wceq wa va vb vt copab2 vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg fvex vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg fvex
      xpex fodom syl vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu
      cv wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      cxp com com cxp cdom wbr com com cxp com cen wbr vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv cxp com cdom wbr vk cv com wcel
      cA cB wcel cA com cdom wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz
      vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr
      wa wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv cxp
      com com cxp com domentr vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv cxp com com cxp
      cdom wbr vk cv com wcel cA cB wcel cA com cdom wbr wa vk cv vv cv vw cv
      vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab
      cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv cxp com vk cv vv cv vw cv vy cv
      vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA
      crdg cfv cxp cdom wbr com vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv cxp com com cxp
      cdom wbr vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv
      wrex vw cab wceq vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      cxp com com cxp cdom wbr vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv com cdom wbr vk cv
      vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq
      vu vv copab cA crdg cfv vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv
      wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv cxp com vk cv vv
      cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu
      vv copab cA crdg cfv cxp com com cxp domtr vk cv vv cv vw cv vy cv vz cv
      cin wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg cfv
      com vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex vw
      cab wceq vu vv copab cA crdg cfv omex vk cv vv cv vw cv vy cv vz cv cin
      wceq vz vu cv wrex vy vu cv wrex vw cab wceq vu vv copab cA crdg fvex
      xpdom1 vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv com com omex omex xpdom2 sylanc
      ad2antll com com cxp com cen wbr vk cv com wcel cA cB wcel cA com cdom
      wbr wa vk cv vv cv vw cv vy cv vz cv cin wceq vz vu cv wrex vy vu cv wrex
      vw cab wceq vu vv copab cA crdg cfv com cdom wbr wa wa xpomen a1i sylanc
      sylanc eqbrtrd exp32 a2d finds com12 r19.21aiv sylanc sylanc ex cA cB
      wcel cA cA cfi cfv cdom wbr cA cfi cfv com cdom wbr cA com cdom wbr wi cA
      cB wcel cA cA cfi cfv wss cA cA cfi cfv cdom wbr cA cB abfi2 cA cA cfi
      cfv cB ssdomg mpd cA cA cfi cfv cdom wbr cA cfi cfv com cdom wbr cA com
      cdom wbr cA cA cfi cfv com domtr ex syl impbid $.
      $( [24-Aug-2009] $) $( [24-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $.
    $( Alternate form of ~ inficl for use with Jeff Hankins's mathbox. $)
    inficlALT $p |- ( A e. B -> ( A. x e. A A. y e. A ( x i^i y ) e. A <-> ( fi
    ` A ) = A ) ) $=
      cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA
      wcel wi vx wal cA cfi cfv cA wceq vx cv vy cv cin cA wcel vy cA wral vx
      cA wral cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv
      cint cA wcel wi vx wal vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq
      w3a vx wex vy cab cA wceq cA cfi cfv cA wceq cA cB wcel vx cv cA wss vx
      cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv cA wss vx
      cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cv cA wcel wb vy wal vx
      cv cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cab cA wceq
      cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA
      wcel wi vx wal vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx
      wex vy cv cA wcel wb vy wal cA cB wcel vx cv cA wss vx cv c0 wne vx cv
      cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv cA wss vx cv cfn wcel vy
      cv vx cv cint wceq w3a vx wex vy cv cA wcel wb vy cA cB wcel vx cv cA wss
      vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv cA wss
      vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cv cA wcel wb cA cB
      wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi
      vx wal wa vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy
      cv cA wcel cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv
      cint cA wcel wi vx wal wa vx cv cA wss vx cv cfn wcel vy cv vx cv cint
      wceq w3a vy cv cA wcel vx cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn
      wcel w3a vx cv cint cA wcel wi vx wal vx cA cB wcel vx ax-17 vx cv cA wss
      vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx hba1 hban vy cv
      cA wcel vx ax-17 cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a
      vx cv cint cA wcel wi vx wal wa vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx cv c0 wne vy cv cA wcel vy cv vx cv cint wceq vx cv cA
      wss vx cv c0 wne vx cv cfn wcel vy cv vx cv cint wceq vy cv vx cv cint
      wceq vy wex vx cv c0 wne vy cv vx cv cint wceq vy 19.8a vx cv c0 wne vx
      cv cint cvv wcel vy cv vx cv cint wceq vy wex vx cv intex vy vx cv cint
      isset bitr2i sylib 3ad2ant3 cA cB wcel vx cv cA wss vx cv c0 wne vx cv
      cfn wcel w3a vx cv cint cA wcel wi vx wal wa vx cv cA wss vx cv cfn wcel
      vy cv vx cv cint wceq w3a vx cv c0 wne vy cv cA wcel cA cB wcel vx cv cA
      wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal wa vx cv
      cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx cv c0 wne wa wa vy cv
      vx cv cint cA vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vy cv
      vx cv cint wceq cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a
      vx cv cint cA wcel wi vx wal wa vx cv c0 wne vx cv cA wss vx cv cfn wcel
      vy cv vx cv cint wceq 3simp3 ad2antrl vx cv cA wss vx cv c0 wne vx cv cfn
      wcel w3a vx cv cint cA wcel wi vx wal vx cv cA wss vx cv cfn wcel vy cv
      vx cv cint wceq w3a vx cv c0 wne wa vx cv cint cA wcel cA cB wcel vx cv
      cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx cv c0 wne wa vx cv cA
      wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv
      cint cA wcel vx cv cA wss vx cv cfn wcel vx cv c0 wne vx cv cA wss vx cv
      c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv cint cA wcel
      wi vy cv vx cv cint wceq vx cv cA wss vx cv cfn wcel vx cv c0 wne vx cv
      cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv
      cint cA wcel wi vx cv cA wss vx cv c0 wne vx cv cfn wcel vx cv cA wss vx
      cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx wal vx cv cint cA
      wcel wi vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel
      wi vx wal vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel
      vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx
      ax-4 com12 3com23 3expa 3adantl3 impcom adantll eqeltrd exp32 mpdi
      19.23ad cA cB wcel vy cv cA wcel vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx wex wi vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx
      cv cint cA wcel wi vx wal cA cB wcel vy cv cA wcel vx cv cA wss vx cv cfn
      wcel vy cv vx cv cint wceq w3a vx wex cA cB wcel vy cv cA wcel wa vy cv
      csn cA wss vy cv csn cfn wcel vy cv vy cv csn cint wceq w3a vx cv cA wss
      vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cv cA wcel vy cv csn
      cA wss vy cv csn cfn wcel vy cv vy cv csn cint wceq w3a cA cB wcel vy cv
      cA wcel vy cv csn cA wss vy cv csn cfn wcel vy cv vy cv csn cint wceq vy
      cv cA snssi vy cv csn cfn wcel vy cv cA wcel vy cv snfi a1i vy cv vy cv
      csn cint wceq vy cv cA wcel vy cv csn cint vy cv vy cv vy visset intsn
      eqcomi a1i 3jca adantl vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq
      w3a vy cv csn cA wss vy cv csn cfn wcel vy cv vy cv csn cint wceq w3a vx
      vy cv csn vy cv snex vx cv vy cv csn wceq vx cv cA wss vy cv csn cA wss
      vx cv cfn wcel vy cv csn cfn wcel vy cv vx cv cint wceq vy cv vy cv csn
      cint wceq vx cv vy cv csn cA sseq1 vx cv vy cv csn cfn eleq1 vx cv vy cv
      csn wceq vx cv cint vy cv csn cint vy cv vx cv vy cv csn inteq eqeq2d
      3anbi123d cla4ev syl ex adantr impbid ex 19.21adv cA cB wcel vx cv cA wss
      vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cv cA wcel wb vy wal
      vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cint cA wcel wi vx cA
      cB wcel vx ax-17 vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx
      wex vy cv cA wcel wb vx vy vx cv cA wss vx cv cfn wcel vy cv vx cv cint
      wceq w3a vx wex vy cv cA wcel vx vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx hbe1 vy cv cA wcel vx ax-17 hbbi hbal cA cB wcel vx cv
      cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cA wss vx cv cfn wcel vy cv
      vx cv cint wceq w3a vx wex vy cv cA wcel wb vy wal vx cv cint cA wcel cA
      cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cA wss vx cv
      cfn wcel vy cv vx cv cint wceq w3a vx wex vy cv cA wcel wb vy wal vx cv
      cint cA wcel wi cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a
      wa vz cv cA wss vz cv cfn wcel vy cv vz cv cint wceq w3a vz wex vy cv cA
      wcel wb vy wal vx cv cint cA wcel vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx wex vy cv cA wcel wb vy wal cA cB wcel vx cv cA wss vx
      cv c0 wne vx cv cfn wcel w3a wa vz cv cA wss vz cv cfn wcel vy cv vz cv
      cint wceq w3a vz wex vy cv cA wcel wb vy wal vz cv cA wss vz cv cfn wcel
      vx cv cint vz cv cint wceq w3a vz wex vx cv cint cA wcel wb vx cv cint cA
      wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vz cv cA wss vz cv cfn
      wcel vy cv vz cv cint wceq w3a vz wex vy cv cA wcel wb vy wal vz cv cA
      wss vz cv cfn wcel vx cv cint vz cv cint wceq w3a vz wex vx cv cint cA
      wcel wb wi cA cB wcel vx cv c0 wne vx cv cA wss vz cv cA wss vz cv cfn
      wcel vy cv vz cv cint wceq w3a vz wex vy cv cA wcel wb vy wal vz cv cA
      wss vz cv cfn wcel vx cv cint vz cv cint wceq w3a vz wex vx cv cint cA
      wcel wb wi vx cv cfn wcel vx cv c0 wne vx cv cint cvv wcel vz cv cA wss
      vz cv cfn wcel vy cv vz cv cint wceq w3a vz wex vy cv cA wcel wb vy wal
      vz cv cA wss vz cv cfn wcel vx cv cint vz cv cint wceq w3a vz wex vx cv
      cint cA wcel wb wi vx cv intex vz cv cA wss vz cv cfn wcel vy cv vz cv
      cint wceq w3a vz wex vy cv cA wcel wb vz cv cA wss vz cv cfn wcel vx cv
      cint vz cv cint wceq w3a vz wex vx cv cint cA wcel wb vy vx cv cint cvv
      vy cv vx cv cint wceq vz cv cA wss vz cv cfn wcel vy cv vz cv cint wceq
      w3a vz wex vz cv cA wss vz cv cfn wcel vx cv cint vz cv cint wceq w3a vz
      wex vy cv cA wcel vx cv cint cA wcel vy cv vx cv cint wceq vz cv cA wss
      vz cv cfn wcel vy cv vz cv cint wceq w3a vz cv cA wss vz cv cfn wcel vx
      cv cint vz cv cint wceq w3a vz vy cv vx cv cint wceq vy cv vz cv cint
      wceq vx cv cint vz cv cint wceq vz cv cA wss vz cv cfn wcel vy cv vx cv
      cint vz cv cint eqeq1 3anbi3d exbidv vy cv vx cv cint cA eleq1 bibi12d
      cla4gv sylbi 3ad2ant2 adantl cA cB wcel vx cv cA wss vx cv c0 wne vx cv
      cfn wcel w3a wa vz cv cA wss vz cv cfn wcel vx cv cint vz cv cint wceq
      w3a vz wex vx cv cint cA wcel wi vx cv cint cA wcel vz cv cA wss vz cv
      cfn wcel vx cv cint vz cv cint wceq w3a vz wex vx cv cint cA wcel wb cA
      cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a wa vx cv cA wss vx
      cv cfn wcel vx cv cint vx cv cint wceq w3a vz cv cA wss vz cv cfn wcel vx
      cv cint vz cv cint wceq w3a vz wex vz cv cA wss vz cv cfn wcel vx cv cint
      vz cv cint wceq w3a vz wex vx cv cint cA wcel wi vx cv cint cA wcel wi cA
      cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a wa vx cv cA wss vx
      cv cfn wcel vx cv cint vx cv cint wceq vx cv cA wss vx cv c0 wne vx cv
      cfn wcel w3a vx cv cA wss cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn
      wcel 3simp1 adantl vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a vx cv cfn
      wcel cA cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel 3simp3 adantl cA
      cB wcel vx cv cA wss vx cv c0 wne vx cv cfn wcel w3a wa vx cv cint eqidd
      3jca vz cv cA wss vz cv cfn wcel vx cv cint vz cv cint wceq w3a vx cv cA
      wss vx cv cfn wcel vx cv cint vx cv cint wceq w3a vz vx cv vx visset vz
      cv vx cv wceq vz cv cA wss vx cv cA wss vz cv cfn wcel vx cv cfn wcel vx
      cv cint vz cv cint wceq vx cv cint vx cv cint wceq vz cv vx cv cA sseq1
      vz cv vx cv cfn eleq1 vz cv vx cv wceq vz cv cint vx cv cint vx cv cint
      vz cv vx cv inteq eqeq2d 3anbi123d cla4ev vz cv cA wss vz cv cfn wcel vx
      cv cint vz cv cint wceq w3a vz wex vx cv cint cA wcel pm2.27 3syl vz cv
      cA wss vz cv cfn wcel vx cv cint vz cv cint wceq w3a vz wex vx cv cint cA
      wcel bi1 syl5 syld vx cv cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a
      vx wex vy cv cA wcel wb vz cv cA wss vz cv cfn wcel vy cv vz cv cint wceq
      w3a vz wex vy cv cA wcel wb vy vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx wex vz cv cA wss vz cv cfn wcel vy cv vz cv cint wceq
      w3a vz wex vy cv cA wcel vx cv cA wss vx cv cfn wcel vy cv vx cv cint
      wceq w3a vz cv cA wss vz cv cfn wcel vy cv vz cv cint wceq w3a vx vz vx
      cv vz cv wceq vx cv cA wss vz cv cA wss vx cv cfn wcel vz cv cfn wcel vy
      cv vx cv cint wceq vy cv vz cv cint wceq vx cv vz cv cA sseq1 vx cv vz cv
      cfn eleq1 vx cv vz cv wceq vx cv cint vz cv cint vy cv vx cv vz cv inteq
      eqeq2d 3anbi123d cbvexv bibi1i albii syl5ib ex com23 19.21ad impbid vx cv
      cA wss vx cv cfn wcel vy cv vx cv cint wceq w3a vx wex vy cA abeq1
      syl6bbr cA cB wcel cA cfi cfv vx cv cA wss vx cv cfn wcel vy cv vx cv
      cint wceq w3a vx wex vy cab cA vx vy cA cB fiv eqeq1d bitr4d vx vy cA
      fiint syl5bb $.
      $( [6-Oct-2009] $) $( [6-Oct-2009] $)
  $}

  ${
    $d b c f j k n t w x y z A $. $d b c f j k n t w x y z B $.
    $( A finite subset of the union of a superset chain is a subset of some
       element of the chain. A useful preliminary result for ~ alexsub and
       others. $)
    finsschain $p |- ( ( ( A =/= (/) /\ A. x e. A A. y e. A ( x C_ y \/ y C_ x
    ) ) /\ ( B e. Fin /\ B C_ U. A ) ) -> E. z e. A B C_ z ) $=
      cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa cB
      cfn wcel cB cA cuni wss cB vz cv wss vz cA wrex cB cfn wcel cA c0 wne vx
      cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa cB cA cuni wss
      cB vz cv wss vz cA wrex wi cA c0 wne vx cv vy cv wss vy cv vx cv wss wo
      vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi
      wi cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa
      cB cA cuni wss cB vz cv wss vz cA wrex wi wi vb cB cfn vb cv cB wceq vb
      cv cA cuni wss vb cv vz cv wss vz cA wrex wi cB cA cuni wss cB vz cv wss
      vz cA wrex wi cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral wa vb cv cB wceq vb cv cA cuni wss cB cA cuni wss vb cv vz cv wss
      vz cA wrex cB vz cv wss vz cA wrex vb cv cB cA cuni sseq1 vb cv cB wceq
      vb cv vz cv wss cB vz cv wss vz cA vb cv cB vz cv sseq1 rexbidv imbi12d
      imbi2d vb cv cfn wcel vb cv vk cv cen wbr vk com wrex cA c0 wne vx cv vy
      cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni wss vb
      cv vz cv wss vz cA wrex wi wi vk vb cv isfi vb cv vk cv cen wbr cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni
      wss vb cv vz cv wss vz cA wrex wi wi vk com vk cv com wcel vb cv vk cv
      cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb vb cv vn
      cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb wal vb
      cv c0 cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb wal
      vb cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA
      wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi
      vb wal vb cv vj cv csuc cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex
      wi wi wi vb wal vb cv vk cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA
      wrex wi wi wi vb wal vn vj vk cv vn cv c0 wceq vb cv vn cv cen wbr cA c0
      wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA
      cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb cv c0 cen wbr cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni
      wss vb cv vz cv wss vz cA wrex wi wi wi vb vn cv c0 wceq vb cv vn cv cen
      wbr vb cv c0 cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA
      wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi vn
      cv c0 vb cv cen breq2 imbi1d albidv vn cv vj cv wceq vb cv vn cv cen wbr
      cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb
      cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb cv vj cv cen wbr cA
      c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv
      cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb vn cv vj cv wceq vb cv
      vn cv cen wbr vb cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA
      wrex wi wi vn cv vj cv vb cv cen breq2 imbi1d albidv vn cv vj cv csuc
      wceq vb cv vn cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy
      cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi
      wi vb cv vj cv csuc cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo
      vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi
      wi wi vb vn cv vj cv csuc wceq vb cv vn cv cen wbr vb cv vj cv csuc cen
      wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa
      vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi vn cv vj cv csuc vb cv
      cen breq2 imbi1d albidv vn cv vk cv wceq vb cv vn cv cen wbr cA c0 wne vx
      cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni
      wss vb cv vz cv wss vz cA wrex wi wi wi vb cv vk cv cen wbr cA c0 wne vx
      cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni
      wss vb cv vz cv wss vz cA wrex wi wi wi vb vn cv vk cv wceq vb cv vn cv
      cen wbr vb cv vk cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo
      vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi
      wi vn cv vk cv vb cv cen breq2 imbi1d albidv vb cv c0 cen wbr cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni
      wss vb cv vz cv wss vz cA wrex wi wi wi vb vb cv c0 cen wbr vb cv c0 wceq
      cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb
      cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi vb cv en0 vb cv c0 wceq
      cA c0 wne vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi vx cv vy cv wss
      vy cv vx cv wss wo vy cA wral vx cA wral vb cv c0 wceq cA c0 wne vb cv vz
      cv wss vz cA wrex vb cv cA cuni wss vb cv c0 wceq vx cv cA wcel vx wex vb
      cv vz cv wss vz cA wrex cA c0 wne vb cv c0 wceq vx cv cA wcel vb cv vz cv
      wss vz cA wrex vx vb cv c0 wceq vb cv vz cv wss vz cA wrex c0 vz cv wss
      vz cA wrex vx cv cA wcel vb cv c0 wceq vb cv vz cv wss c0 vz cv wss vz cA
      vb cv c0 vz cv sseq1 rexbidv vx cv cA wcel c0 vx cv wss c0 vz cv wss vz
      cA wrex vx cv 0ss c0 vz cv wss c0 vx cv wss vz vx cv cA vz cv vx cv c0
      sseq2 rcla4ev mpan2 syl5bir 19.23adv vx cA n0 syl5ib a1dd adantrd sylbi
      ax-gen vj cv com wcel vc cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv
      vx cv wss wo vy cA wral vx cA wral wa vc cv cA cuni wss vc cv vz cv wss
      vz cA wrex wi wi wi vc wal vb cv vj cv csuc cen wbr cA c0 wne vx cv vy cv
      wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni wss vb cv
      vz cv wss vz cA wrex wi wi wi vb wal vb cv vj cv cen wbr cA c0 wne vx cv
      vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni wss
      vb cv vz cv wss vz cA wrex wi wi wi vb wal vj cv com wcel vc cv vj cv cen
      wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa
      vc cv cA cuni wss vc cv vz cv wss vz cA wrex wi wi wi vc wal vb cv vj cv
      csuc cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi wi vb vj cv
      com wcel vb cv cA cuni wss vb cv vj cv csuc cen wbr cA c0 wne vx cv vy cv
      wss vy cv vx cv wss wo vy cA wral vx cA wral wa vc cv vj cv cen wbr cA c0
      wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vc cv cA
      cuni wss vc cv vz cv wss vz cA wrex wi wi wi vc wal vb cv vz cv wss vz cA
      wrex vj cv com wcel vb cv vj cv csuc cen wbr vb cv cA cuni wss cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vc cv vj cv
      cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa vc cv cA cuni wss vc cv vz cv wss vz cA wrex wi wi wi vc wal vb
      cv vz cv wss vz cA wrex wi wi vj cv com wcel vb cv vj cv csuc vf cv wf1o
      vf wex vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy
      cA wral vx cA wral wa vc cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv
      vx cv wss wo vy cA wral vx cA wral wa vc cv cA cuni wss vc cv vz cv wss
      vz cA wrex wi wi wi vc wal vb cv vz cv wss vz cA wrex wi wi wi vb cv vj
      cv csuc cen wbr vj cv com wcel vb cv vj cv csuc vf cv wf1o vb cv cA cuni
      wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa
      vc cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA
      wral vx cA wral wa vc cv cA cuni wss vc cv vz cv wss vz cA wrex wi wi wi
      vc wal vb cv vz cv wss vz cA wrex wi wi wi vf vj cv com wcel vj cv csuc
      vb cv vf cv ccnv wf1o vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv
      vx cv wss wo vy cA wral vx cA wral wa vc cv vj cv cen wbr cA c0 wne vx cv
      vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vc cv cA cuni wss
      vc cv vz cv wss vz cA wrex wi wi wi vc wal vb cv vz cv wss vz cA wrex wi
      wi wi vb cv vj cv csuc vf cv wf1o vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo
      vy cA wral vx cA wral wa vc cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa vc cv cA cuni wss vc cv vz cv
      wss vz cA wrex wi wi wi vc wal vb cv vz cv wss vz cA wrex wi vj cv com
      wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx
      cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa vf cv ccnv
      vj cv cima vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy
      cA wral vx cA wral wa vf cv ccnv vj cv cima cA cuni wss vf cv ccnv vj cv
      cima vz cv wss vz cA wrex wi wi wi vb cv vz cv wss vz cA wrex vc cv vj cv
      cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa vc cv cA cuni wss vc cv vz cv wss vz cA wrex wi wi wi vc wal vj
      cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0
      wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa vf
      cv ccnv vj cv cima vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa vf cv ccnv vj cv cima cA cuni wss vf cv
      ccnv vj cv cima vz cv wss vz cA wrex wi wi wi vf cv ccnv vj cv cima vj cv
      cen wbr vb cv vz cv wss vz cA wrex vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa wa wa vj cv vf cv ccnv vj cv cima vf cv ccnv
      vj cv cres wf1o vj cv vf cv ccnv vj cv cima cen wbr vf cv ccnv vj cv cima
      vj cv cen wbr vj cv csuc vb cv vf cv ccnv wf1o vj cv vf cv ccnv vj cv
      cima vf cv ccnv vj cv cres wf1o vj cv com wcel vb cv cA cuni wss cA c0
      wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa vj cv
      csuc vb cv vf cv ccnv wf1o vj cv csuc vb cv vf cv ccnv wf1 vj cv vf cv
      ccnv vj cv cima vf cv ccnv vj cv cres wf1o vj cv csuc vb cv vf cv ccnv
      f1of1 vj cv csuc vb cv vf cv ccnv wf1 vj cv vj cv csuc wss vj cv vf cv
      ccnv vj cv cima vf cv ccnv vj cv cres wf1o vj cv sssucid vj cv csuc vb cv
      vj cv vf cv ccnv f1ores mpan2 syl ad2antlr vj cv vf cv ccnv vj cv cima vf
      cv ccnv vj cv cres vj visset f1oen vj cv vf cv ccnv vj cv cima vf cv ccnv
      cvv wcel vf cv ccnv vj cv cima cvv wcel vf cv vf visset cnvex vf cv ccnv
      vj cv cvv imaexg ax-mp ensym 3syl vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa wa wa cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa vf cv ccnv vj cv cima cA cuni wss vf cv
      ccnv vj cv cima vz cv wss vz cA wrex wi wi vb cv vz cv wss vz cA wrex vf
      cv ccnv vj cv cima vj cv cen wbr vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa wa wa cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa vf cv ccnv vj cv cima cA cuni wss vf cv
      ccnv vj cv cima vz cv wss vz cA wrex wi wi cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa vb cv vz cv wss vz cA wrex vj cv
      com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa simprr vj cv
      com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa vf cv
      ccnv vj cv cima cA cuni wss vf cv ccnv vj cv cima vz cv wss vz cA wrex wi
      vb cv vz cv wss vz cA wrex cA c0 wne vx cv vy cv wss vy cv vx cv wss wo
      vy cA wral vx cA wral wa vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o
      wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA
      wral vx cA wral wa wa wa vf cv ccnv vj cv cima cA cuni wss vf cv ccnv vj
      cv cima vz cv wss vz cA wrex wi vf cv ccnv vj cv cima cA cuni wss vb cv
      vz cv wss vz cA wrex vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa
      vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral
      vx cA wral wa wa wa vf cv ccnv vj cv cima vb cv cA cuni vj cv csuc vb cv
      vf cv ccnv wf1o vf cv ccnv vj cv cima vb cv wss vj cv com wcel vb cv cA
      cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa wa vj cv csuc vb cv vf cv ccnv wf1o vf cv ccnv vj cv cima vf cv
      ccnv crn vb cv vf cv ccnv vj cv cima vf cv ccnv crn wss vj cv csuc vb cv
      vf cv ccnv wf1o vf cv ccnv vj cv imassrn a1i vj cv csuc vb cv vf cv ccnv
      wf1o vj cv csuc vb cv vf cv ccnv wfo vf cv ccnv crn vb cv wceq vj cv csuc
      vb cv vf cv ccnv f1ofo vj cv csuc vb cv vf cv ccnv forn syl sseqtrd
      ad2antlr vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni
      wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa
      simprl sstrd vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA
      cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa wa wa vf cv ccnv vj cv cima vz cv wss vz cA wrex vb cv vz cv wss
      vz cA wrex vf cv ccnv vj cv cima cA cuni wss vj cv com wcel vj cv csuc vb
      cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv
      vx cv wss wo vy cA wral vx cA wral wa wa wa vf cv ccnv vj cv cima vw cv
      wss vw cA wrex vb cv vz cv wss vz cA wrex vf cv ccnv vj cv cima vz cv wss
      vz cA wrex vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA
      cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa wa wa vf cv ccnv vj cv cima vw cv wss vb cv vz cv wss vz cA wrex
      vw cA vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni
      wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa
      wa wa vj cv vf cv ccnv cfv csn vt cv wss vt cA wrex vw cv cA wcel vf cv
      ccnv vj cv cima vw cv wss vb cv vz cv wss vz cA wrex wi wi vj cv com wcel
      vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy
      cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa vj cv vf cv ccnv
      cfv vt cv wcel vt cA wrex vj cv vf cv ccnv cfv csn vt cv wss vt cA wrex
      vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA
      c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa
      vj cv vf cv ccnv cfv cA cuni wcel vj cv vf cv ccnv cfv vt cv wcel vt cA
      wrex vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss
      cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa
      wa vb cv cA cuni vj cv vf cv ccnv cfv vj cv com wcel vj cv csuc vb cv vf
      cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa simprl vj cv csuc vb cv vf cv ccnv wf1o
      vj cv vf cv ccnv cfv vb cv wcel vj cv com wcel vb cv cA cuni wss cA c0
      wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa vj cv
      csuc vb cv vf cv ccnv wf1o vj cv csuc vb cv vf cv ccnv wf vj cv vf cv
      ccnv cfv vb cv wcel vj cv csuc vb cv vf cv ccnv f1of vj cv csuc vb cv vf
      cv ccnv wf vj cv vj cv csuc wcel vj cv vf cv ccnv cfv vb cv wcel vj cv vj
      visset sucid vj cv csuc vb cv vj cv vf cv ccnv ffvelrn mpan2 syl ad2antlr
      sseldd vt vj cv vf cv ccnv cfv cA eluni2 sylib vj cv vf cv ccnv cfv vt cv
      wcel vj cv vf cv ccnv cfv csn vt cv wss vt cA vj cv vf cv ccnv cfv vt cv
      snssi r19.22si syl vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb
      cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral wa wa wa vj cv vf cv ccnv cfv csn vt cv wss vw cv cA wcel vf cv
      ccnv vj cv cima vw cv wss vb cv vz cv wss vz cA wrex wi wi vt cA vj cv
      com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa vt cv
      cA wcel vj cv vf cv ccnv cfv csn vt cv wss vw cv cA wcel vf cv ccnv vj cv
      cima vw cv wss vb cv vz cv wss vz cA wrex vj cv com wcel vj cv csuc vb cv
      vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx
      cv wss wo vy cA wral vx cA wral wa wa wa vt cv cA wcel vj cv vf cv ccnv
      cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa
      wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vz cA
      wrex vb cv vz cv wss vz cA wrex vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv
      wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vf cv ccnv vj
      cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vz cA wrex vt cv cA wcel
      vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima
      vw cv wss wa wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv
      wss wo vy cA wral vx cA wral wa vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss
      vz cA wrex vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA
      wcel vf cv ccnv vj cv cima vw cv wss wa wa cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni wss vj cv com wcel
      vj cv csuc vb cv vf cv ccnv wf1o wa vf cv ccnv vj cv cima vj cv vf cv
      ccnv cfv csn cun vz cv wss vz cA wrex wi vt cv cA wcel vj cv vf cv ccnv
      cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa
      cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral vb cv
      cA cuni wss vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vf cv ccnv
      vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vz cA wrex wi wi vt cv
      cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj
      cv cima vw cv wss wa wa vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral cA c0 wne vb cv cA cuni wss vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss
      vz cA wrex wi wi vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw
      cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vx cv vy cv wss vy cv vx
      cv wss wo vy cA wral vx cA wral vt cv vw cv wss vw cv vt cv wss wo cA c0
      wne vb cv cA cuni wss vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa
      vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vz cA wrex
      wi wi wi vt cv cA wcel vw cv cA wcel vx cv vy cv wss vy cv vx cv wss wo
      vy cA wral vx cA wral vt cv vw cv wss vw cv vt cv wss wo wi vj cv vf cv
      ccnv cfv csn vt cv wss vf cv ccnv vj cv cima vw cv wss vx cv vy cv wss vy
      cv vx cv wss wo vt cv vw cv wss vw cv vt cv wss wo vt cv vy cv wss vy cv
      vt cv wss wo vx vy vt cv vw cv cA cA vx cv vt cv wceq vx cv vy cv wss vt
      cv vy cv wss vy cv vx cv wss vy cv vt cv wss vx cv vt cv vy cv sseq1 vx
      cv vt cv vy cv sseq2 orbi12d vy cv vw cv wceq vt cv vy cv wss vt cv vw cv
      wss vy cv vt cv wss vw cv vt cv wss vy cv vw cv vt cv sseq2 vy cv vw cv
      vt cv sseq1 orbi12d rcla42v ad2ant2r vt cv cA wcel vj cv vf cv ccnv cfv
      csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vt
      cv vw cv wss cA c0 wne vb cv cA cuni wss vj cv com wcel vj cv csuc vb cv
      vf cv ccnv wf1o wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz
      cv wss vz cA wrex wi wi wi vw cv vt cv wss vt cv cA wcel vj cv vf cv ccnv
      cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa
      vt cv vw cv wss cA c0 wne vb cv cA cuni wss vj cv com wcel vj cv csuc vb
      cv vf cv ccnv wf1o wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun
      vz cv wss vz cA wrex vw cv cA wcel vf cv ccnv vj cv cima vj cv vf cv ccnv
      cfv csn cun vw cv wss vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun
      vz cv wss vz cA wrex vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa
      vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vt cv vw cv wss wa cA
      c0 wne vb cv cA cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv
      wf1o wa wa wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv
      wss vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vw cv wss vz vw cv
      cA vz cv vw cv vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun sseq2
      rcla4ev vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel
      vf cv ccnv vj cv cima vw cv wss wa wa vw cv cA wcel vt cv vw cv wss cA c0
      wne vb cv cA cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o
      wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel
      vf cv ccnv vj cv cima vw cv wss simprl ad2antrr vt cv cA wcel vj cv vf cv
      ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss
      wa wa vt cv vw cv wss wa cA c0 wne vb cv cA cuni wss wa vj cv com wcel vj
      cv csuc vb cv vf cv ccnv wf1o wa wa wa vf cv ccnv vj cv cima vw cv wss vj
      cv vf cv ccnv cfv csn vw cv wss wa vf cv ccnv vj cv cima vj cv vf cv ccnv
      cfv csn cun vw cv wss vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa
      vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vt cv vw cv wss wa cA
      c0 wne vb cv cA cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv
      wf1o wa wa wa vf cv ccnv vj cv cima vw cv wss vj cv vf cv ccnv cfv csn vw
      cv wss vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel
      vf cv ccnv vj cv cima vw cv wss wa wa vf cv ccnv vj cv cima vw cv wss vt
      cv vw cv wss cA c0 wne vb cv cA cuni wss wa vj cv com wcel vj cv csuc vb
      cv vf cv ccnv wf1o wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss
      wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss simprr ad2antrr vt cv cA
      wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv
      cima vw cv wss wa wa vt cv vw cv wss wa cA c0 wne vb cv cA cuni wss wa vj
      cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa wa wa vj cv vf cv ccnv
      cfv csn vt cv vw cv vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa
      vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vj cv vf cv ccnv cfv
      csn vt cv wss vt cv vw cv wss cA c0 wne vb cv cA cuni wss wa vj cv com
      wcel vj cv csuc vb cv vf cv ccnv wf1o wa wa vt cv cA wcel vj cv vf cv
      ccnv cfv csn vt cv wss vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa
      simplr ad2antrr vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv
      cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vt cv vw cv wss cA c0 wne
      vb cv cA cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa
      wa simplr sstrd jca vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn vw cv
      unss sylib sylanc exp58 vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss
      wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vw cv vt cv wss cA
      c0 wne vb cv cA cuni wss vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o
      wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vz cA
      wrex vt cv cA wcel vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vt
      cv wss vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vz cA
      wrex vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf
      cv ccnv vj cv cima vw cv wss wa wa vw cv vt cv wss wa cA c0 wne vb cv cA
      cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa wa wa vf
      cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss vf cv ccnv vj
      cv cima vj cv vf cv ccnv cfv csn cun vt cv wss vz vt cv cA vz cv vt cv vf
      cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun sseq2 rcla4ev vt cv cA
      wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv
      cima vw cv wss wa wa vt cv cA wcel vw cv vt cv wss cA c0 wne vb cv cA
      cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa wa vt cv
      cA wcel vj cv vf cv ccnv cfv csn vt cv wss vw cv cA wcel vf cv ccnv vj cv
      cima vw cv wss wa simpll ad2antrr vt cv cA wcel vj cv vf cv ccnv cfv csn
      vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vw cv vt
      cv wss wa cA c0 wne vb cv cA cuni wss wa vj cv com wcel vj cv csuc vb cv
      vf cv ccnv wf1o wa wa wa vf cv ccnv vj cv cima vt cv wss vj cv vf cv ccnv
      cfv csn vt cv wss wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun
      vt cv wss vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA
      wcel vf cv ccnv vj cv cima vw cv wss wa wa vw cv vt cv wss wa vf cv ccnv
      vj cv cima vt cv wss vj cv vf cv ccnv cfv csn vt cv wss wa cA c0 wne vb
      cv cA cuni wss wa vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa wa
      vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv
      ccnv vj cv cima vw cv wss wa wa vw cv vt cv wss wa vf cv ccnv vj cv cima
      vt cv wss vj cv vf cv ccnv cfv csn vt cv wss vt cv cA wcel vj cv vf cv
      ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss
      wa wa vw cv vt cv wss wa vf cv ccnv vj cv cima vw cv vt cv vt cv cA wcel
      vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima
      vw cv wss vw cv vt cv wss simplrr vt cv cA wcel vj cv vf cv ccnv cfv csn
      vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa vw cv vt
      cv wss pm3.27 sstrd vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss vw
      cv cA wcel vf cv ccnv vj cv cima vw cv wss wa vw cv vt cv wss simpllr jca
      adantr vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn vt cv unss sylib
      sylanc exp58 jaod syld com23 imp3a com23 com14 imp42 vj cv com wcel vj cv
      csuc vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss
      vy cv vx cv wss wo vy cA wral vx cA wral wa wa wa vt cv cA wcel vj cv vf
      cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv
      wss wa wa wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vz cv wss
      vb cv vz cv wss vz cA vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa
      vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral
      vx cA wral wa wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa
      vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa wa vf cv ccnv vj cv
      cima vj cv vf cv ccnv cfv csn cun vb cv vz cv vj cv com wcel vj cv csuc
      vb cv vf cv ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa wa wa vt cv cA wcel vj cv vf cv
      ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss
      wa wa wa vf cv ccnv vj cv cima vj cv vf cv ccnv cfv csn cun vf cv ccnv vj
      cv csuc cima vb cv vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb
      cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral wa wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw
      cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa wa vf cv ccnv vj cv cima
      vj cv vf cv ccnv cfv csn cun vf cv ccnv vj cv cima vf cv ccnv vj cv csn
      cima cun vf cv ccnv vj cv csuc cima vj cv com wcel vj cv csuc vb cv vf cv
      ccnv wf1o wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn
      vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa wa vj cv
      vf cv ccnv cfv csn vf cv ccnv vj cv csn cima vf cv ccnv vj cv cima vf cv
      ccnv vj cv csuc wfn vj cv vj cv csuc wcel vj cv vf cv ccnv cfv csn vf cv
      ccnv vj cv csn cima wceq vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o
      wa vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA
      wral vx cA wral wa wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss
      wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss wa wa wa vj cv csuc vj
      cv vf cv ccnv fnsnfv vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa
      vf cv ccnv vj cv csuc wfn vb cv cA cuni wss cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa wa vt cv cA wcel vj cv vf cv
      ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv cima vw cv wss
      wa wa vj cv csuc vb cv vf cv ccnv wf1o vf cv ccnv vj cv csuc wfn vj cv
      com wcel vj cv csuc vb cv vf cv ccnv f1ofn adantl ad2antrr vj cv vj cv
      csuc wcel vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o wa vb cv cA
      cuni wss cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA
      wral wa wa wa vt cv cA wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv
      cA wcel vf cv ccnv vj cv cima vw cv wss wa wa wa vj cv vj visset sucid
      a1i sylanc uneq2d vf cv ccnv vj cv csuc cima vf cv ccnv vj cv vj cv csn
      cun cima vf cv ccnv vj cv cima vf cv ccnv vj cv csn cima cun vj cv csuc
      vj cv vj cv csn cun vf cv ccnv vj cv df-suc imaeq2i vf cv ccnv vj cv vj
      cv csn imaundi eqtr2i syl6eq vj cv com wcel vj cv csuc vb cv vf cv ccnv
      wf1o wa vf cv ccnv vj cv csuc cima vb cv wceq vb cv cA cuni wss cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa wa vt cv cA
      wcel vj cv vf cv ccnv cfv csn vt cv wss wa vw cv cA wcel vf cv ccnv vj cv
      cima vw cv wss wa wa vj cv csuc vb cv vf cv ccnv wf1o vf cv ccnv vj cv
      csuc cima vb cv wceq vj cv com wcel vj cv csuc vb cv vf cv ccnv wf1o vj
      cv csuc vb cv vf cv ccnv wfo vf cv ccnv vj cv csuc cima vb cv wceq vj cv
      csuc vb cv vf cv ccnv f1ofo vj cv csuc vb cv vf cv ccnv foima syl adantl
      ad2antrr eqtrd sseq1d rexbidv mpbid exp512 r19.23adv mpd r19.23adv vf cv
      ccnv vj cv cima vz cv wss vf cv ccnv vj cv cima vw cv wss vz vw cA vz cv
      vw cv vf cv ccnv vj cv cima sseq2 cbvrexv syl5ib imim2d mpid imim2d mpid
      imim2d mpid vc cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa vc cv cA cuni wss vc cv vz cv wss vz cA wrex
      wi wi wi vf cv ccnv vj cv cima vj cv cen wbr cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa vf cv ccnv vj cv cima cA cuni
      wss vf cv ccnv vj cv cima vz cv wss vz cA wrex wi wi wi vc vf cv ccnv vj
      cv cima vf cv ccnv cvv wcel vf cv ccnv vj cv cima cvv wcel vf cv vf
      visset cnvex vf cv ccnv vj cv cvv imaexg ax-mp vc cv vf cv ccnv vj cv
      cima wceq vc cv vj cv cen wbr vf cv ccnv vj cv cima vj cv cen wbr cA c0
      wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vc cv cA
      cuni wss vc cv vz cv wss vz cA wrex wi wi cA c0 wne vx cv vy cv wss vy cv
      vx cv wss wo vy cA wral vx cA wral wa vf cv ccnv vj cv cima cA cuni wss
      vf cv ccnv vj cv cima vz cv wss vz cA wrex wi wi vc cv vf cv ccnv vj cv
      cima vj cv cen breq1 vc cv vf cv ccnv vj cv cima wceq vc cv cA cuni wss
      vc cv vz cv wss vz cA wrex wi vf cv ccnv vj cv cima cA cuni wss vf cv
      ccnv vj cv cima vz cv wss vz cA wrex wi cA c0 wne vx cv vy cv wss vy cv
      vx cv wss wo vy cA wral vx cA wral wa vc cv vf cv ccnv vj cv cima wceq vc
      cv cA cuni wss vf cv ccnv vj cv cima cA cuni wss vc cv vz cv wss vz cA
      wrex vf cv ccnv vj cv cima vz cv wss vz cA wrex vc cv vf cv ccnv vj cv
      cima cA cuni sseq1 vc cv vf cv ccnv vj cv cima wceq vc cv vz cv wss vf cv
      ccnv vj cv cima vz cv wss vz cA vc cv vf cv ccnv vj cv cima vz cv sseq1
      rexbidv imbi12d imbi2d imbi12d cla4v syl5 exp43 vb cv vj cv csuc vf cv
      f1ocnv syl5 19.23adv vb cv vj cv csuc vf vj cv vj visset sucex bren
      syl5ib com23 com25 19.21adv vb cv vj cv cen wbr cA c0 wne vx cv vy cv wss
      vy cv vx cv wss wo vy cA wral vx cA wral wa vb cv cA cuni wss vb cv vz cv
      wss vz cA wrex wi wi wi vc cv vj cv cen wbr cA c0 wne vx cv vy cv wss vy
      cv vx cv wss wo vy cA wral vx cA wral wa vc cv cA cuni wss vc cv vz cv
      wss vz cA wrex wi wi wi vb vc vb cv vc cv wceq vb cv vj cv cen wbr vc cv
      vj cv cen wbr cA c0 wne vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx
      cA wral wa vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi wi cA c0 wne
      vx cv vy cv wss vy cv vx cv wss wo vy cA wral vx cA wral wa vc cv cA cuni
      wss vc cv vz cv wss vz cA wrex wi wi vb cv vc cv vj cv cen breq1 vb cv vc
      cv wceq vb cv cA cuni wss vb cv vz cv wss vz cA wrex wi vc cv cA cuni wss
      vc cv vz cv wss vz cA wrex wi cA c0 wne vx cv vy cv wss vy cv vx cv wss
      wo vy cA wral vx cA wral wa vb cv vc cv wceq vb cv cA cuni wss vc cv cA
      cuni wss vb cv vz cv wss vz cA wrex vc cv vz cv wss vz cA wrex vb cv vc
      cv cA cuni sseq1 vb cv vc cv wceq vb cv vz cv wss vc cv vz cv wss vz cA
      vb cv vc cv vz cv sseq1 rexbidv imbi12d imbi2d imbi12d cbvalv syl5ib
      finds 19.21bi r19.23aiv sylbi vtoclga com12 imp32 $.
      $( [25-Jan-2010] $) $( [25-Jan-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Ordinal isomorphism, Hartog's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f w x y z A $. $d f w x y z B $.
    $( Order-isomorphic ordinal numbers are equal. $)
    ordiso $p |- ( ( A e. On /\ B e. On ) -> ( A = B
                <-> E. f f Isom _E , _E ( A , B ) ) ) $=
      cA con0 wcel cB con0 wcel wa cA cB wceq cA cB cep cep vf cv wiso vf wex
      cA con0 wcel cB con0 wcel cA cB wceq cA cB cep cep vf cv wiso vf wex cid
      cA cres cvv wcel cA cB cep cep cid cA cres wiso cA cB cep cep vf cv wiso
      vf wex cA con0 wcel cB con0 wcel cA cB wceq w3a cA cB cep cep vf cv wiso
      cA cB cep cep cid cA cres wiso vf cid cA cres cvv cA cB cep cep cid cA
      cres vf cv isoeq1 cla4egv cA con0 wcel cB con0 wcel cid cA cres cvv wcel
      cA cB wceq cA con0 resiexg 3ad2ant1 cA con0 wcel cB con0 wcel cA cB wceq
      w3a cA cB cid cA cres wf1o vx cv vy cv cep wbr vx cv cid cA cres cfv vy
      cv cid cA cres cfv cep wbr wb vy cA wral vx cA wral wa cA cB cep cep cid
      cA cres wiso cA con0 wcel cB con0 wcel cA cB wceq w3a cA cB cid cA cres
      wf1o vx cv vy cv cep wbr vx cv cid cA cres cfv vy cv cid cA cres cfv cep
      wbr wb vy cA wral vx cA wral cA con0 wcel cB con0 wcel cA cB wceq w3a cA
      cA cid cA cres wf1o cA cB cid cA cres wf1o cA f1oi cA cB wceq cA con0
      wcel cA cA cid cA cres wf1o cA cB cid cA cres wf1o wb cB con0 wcel cA cB
      cA cid cA cres f1oeq3 3ad2ant3 mpbii cA con0 wcel cB con0 wcel cA cB wceq
      w3a vx cv vy cv cep wbr vx cv cid cA cres cfv vy cv cid cA cres cfv cep
      wbr wb vx vy cA cA cA con0 wcel cB con0 wcel cA cB wceq w3a vx cv cA wcel
      vy cv cA wcel wa vx cv vy cv cep wbr vx cv cid cA cres cfv vy cv cid cA
      cres cfv cep wbr wb cA con0 wcel cB con0 wcel cA cB wceq w3a vx cv cA
      wcel vy cv cA wcel wa wa vx cv cid cA cres cfv vy cv cid cA cres cfv cep
      wbr vx cv vy cv cep wbr cA con0 wcel cB con0 wcel cA cB wceq w3a vx cv cA
      wcel vy cv cA wcel wa wa vx cv cid cA cres cfv vx cv vy cv cid cA cres
      cfv vy cv cep vx cv cA wcel vx cv cid cA cres cfv vx cv wceq cA con0 wcel
      cB con0 wcel cA cB wceq w3a vy cv cA wcel cA vx cv fvresi ad2antrl vy cv
      cA wcel vy cv cid cA cres cfv vy cv wceq cA con0 wcel cB con0 wcel cA cB
      wceq w3a vx cv cA wcel cA vy cv fvresi ad2antll breq12d bicomd ex
      r19.21aivv jca vx vy cA cB cep cep cid cA cres df-iso sylibr sylc 3expia
      cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso cA cB wceq vf cA
      con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso cA cB wceq cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv vf cv cfv vx cv
      wceq vx cA wral cA cB wceq cA con0 wcel cB con0 wcel wa cA cB cep cep vf
      cv wiso wa vx cv vf cv cfv vx cv wceq vx cA wral vx cv cA wcel vx cv vf
      cv cfv vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn
      vy vx cv wral wa vx con0 wrex cA con0 wcel cB con0 wcel wa cA cB cep cep
      vf cv wiso wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral
      vx cv cA wcel vx cv vf cv cfv vx cv wceq wi wi vx con0 wral vx cv cA wcel
      vx cv vf cv cfv vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv vy cv wceq
      wn wa wn vy vx cv wral wa vx con0 wrex wn cA con0 wcel cB con0 wcel wa cA
      cB cep cep vf cv wiso wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy
      vx cv wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wi wi vx con0 cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel vy cv cA
      wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel vx cv vf
      cv cfv vx cv wceq cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso
      wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx
      cv wral vx cv cA wcel wa wa vz vx cv vf cv cfv vx cv cA con0 wcel cB con0
      wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy
      cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv
      vf cv cfv wcel vz cv vx cv wcel cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel vz
      cv vx cv wcel cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx
      cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral
      vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel wa vw cv vf cv cfv vz cv
      wceq vw cA wrex vz cv vx cv wcel cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel wa
      vz cv vf cv crn wcel vw cv vf cv cfv vz cv wceq vw cA wrex cA con0 wcel
      cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA
      wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz
      cv vx cv vf cv cfv wcel wa vz cv cB vf cv crn cB con0 wcel vz cv vx cv vf
      cv cfv wcel vx cv vf cv cfv cB wcel wa vz cv cB wcel cA con0 wcel cB con0
      wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy
      cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv
      vf cv cfv wcel wa vz cv vx cv vf cv cfv cB ontr1 cA con0 wcel cB con0
      wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa cB con0 wcel vy cv
      cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa vz
      cv vx cv vf cv cfv wcel cA con0 wcel cB con0 wcel cA cB cep cep vf cv
      wiso vx cv con0 wcel simpllr ad2antrr cA con0 wcel cB con0 wcel wa cA cB
      cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy
      cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel
      wa vz cv vx cv vf cv cfv wcel vx cv vf cv cfv cB wcel cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx
      cv vf cv cfv wcel pm3.27 cA cB vf cv wf vx cv cA wcel vx cv vf cv cfv cB
      wcel cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0
      wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv
      cA wcel wa wa vz cv vx cv vf cv cfv wcel wa cA cB vx cv vf cv ffvelrn cA
      con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa
      cA cB vf cv wf vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral
      vx cv cA wcel wa vz cv vx cv vf cv cfv wcel cA cB cep cep vf cv wiso cA
      cB vf cv wf cA con0 wcel cB con0 wcel wa vx cv con0 wcel cA cB cep cep vf
      cv wiso cA cB vf cv wf1o cA cB vf cv wf cA cB cep cep vf cv isof1o cA cB
      vf cv f1of syl ad2antlr ad2antrr cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel vz cv vx cv vf cv cfv wcel simplrr
      sylanc jca sylc cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa
      vx cv con0 wcel wa vf cv crn cB wceq vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv vf cv cfv wcel cA cB
      cep cep vf cv wiso vf cv crn cB wceq cA con0 wcel cB con0 wcel wa vx cv
      con0 wcel cA cB cep cep vf cv wiso cA cB vf cv wf1o cA cB vf cv wfo vf cv
      crn cB wceq cA cB cep cep vf cv isof1o cA cB vf cv f1ofo cA cB vf cv forn
      3syl ad2antlr ad2antrr eleqtrrd cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv con0 wcel wa vz cv vf cv crn wcel vw cv vf cv cfv
      vz cv wceq vw cA wrex wb vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy
      vx cv wral vx cv cA wcel wa vz cv vx cv vf cv cfv wcel cA cB cep cep vf
      cv wiso vz cv vf cv crn wcel vw cv vf cv cfv vz cv wceq vw cA wrex wb cA
      con0 wcel cB con0 wcel wa vx cv con0 wcel cA cB cep cep vf cv wiso cA cB
      vf cv wf1o vf cv cA wfn vz cv vf cv crn wcel vw cv vf cv cfv vz cv wceq
      vw cA wrex wb cA cB cep cep vf cv isof1o cA cB vf cv f1ofn vw cA vz cv vf
      cv fvelrnb 3syl ad2antlr ad2antrr mpbid cA con0 wcel cB con0 wcel wa cA
      cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv
      vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv
      wcel wa vw cv vf cv cfv vz cv wceq vz cv vx cv wcel vw cA cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx
      cv vf cv cfv wcel wa vw cv cA wcel vw cv vf cv cfv vz cv wceq vz cv vx cv
      wcel cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0
      wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv
      cA wcel wa wa vz cv vx cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz
      cv wceq wa vz cv vx cv wcel cA con0 wcel cB con0 wcel wa cA cB cep cep vf
      cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi
      vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel vw cv cA
      wcel vw cv vf cv cfv vz cv wceq wa wa wa vw cv vx cv wcel vz cv vx cv
      wcel cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0
      wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv
      cA wcel wa wa vz cv vx cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz
      cv wceq wa wa wa vw cv vx cv cep wbr vw cv vx cv wcel cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx
      cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa wa vw cv
      vx cv cep wbr vw cv vf cv cfv vx cv vf cv cfv cep wbr cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx
      cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa wa vw cv
      vf cv cfv vx cv vf cv cfv wcel vw cv vf cv cfv vx cv vf cv cfv cep wbr cA
      con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa
      vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel
      wa wa vz cv vx cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq
      wa wa wa vw cv vf cv cfv vz cv vx cv vf cv cfv cA con0 wcel cB con0 wcel
      wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf
      cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv
      cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq simprrr cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx
      cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa simprl
      eqeltrd vw cv vf cv cfv vx cv vf cv cfv vw cv vf cv fvex vx cv vf cv fvex
      epelc sylibr cA cB cep cep vf cv wiso vw cv cA wcel vx cv cA wcel vw cv
      vx cv cep wbr vw cv vf cv cfv vx cv vf cv cfv cep wbr wb cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx
      cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa wa cA
      con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa
      cA cB cep cep vf cv wiso vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy
      vx cv wral vx cv cA wcel wa vz cv vx cv vf cv cfv wcel vw cv cA wcel vw
      cv vf cv cfv vz cv wceq wa wa cA con0 wcel cB con0 wcel wa cA cB cep cep
      vf cv wiso vx cv con0 wcel simplr ad2antrr cA con0 wcel cB con0 wcel wa
      cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv
      cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv
      wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq simprrl cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel
      vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel vz cv vx cv vf
      cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa simplrr cA cB
      vw cv vx cv cep cep vf cv isorel sylan32c mpbird vw vx epel sylib cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv
      cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa
      vz cv vx cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa
      vw cv vx cv wcel vz cv vx cv wcel cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel vw
      cv cA wcel vw cv vf cv cfv vz cv wceq wa wa vw cv vx cv wcel wa wa vz cv
      vw cv vx cv cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx
      cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral
      vx cv cA wcel wa wa vz cv vx cv vf cv cfv wcel vw cv cA wcel vw cv vf cv
      cfv vz cv wceq wa wa vw cv vx cv wcel wa wa vw cv vf cv cfv vz cv vw cv
      vz cv vx cv vf cv cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa
      vw cv vf cv cfv vz cv wceq cA con0 wcel cB con0 wcel wa cA cB cep cep vf
      cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi
      vy vx cv wral vx cv cA wcel wa wa vw cv vx cv wcel vz cv vx cv vf cv cfv
      wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq simprr ad2antrl cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv
      cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa
      vw cv vx cv wcel vw cv vf cv cfv vw cv wceq vz cv vx cv vf cv cfv wcel vw
      cv cA wcel vw cv vf cv cfv vz cv wceq wa wa cA con0 wcel cB con0 wcel wa
      cA cB cep cep vf cv wiso wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi
      vy vx cv wral vx cv cA wcel wa vw cv vx cv wcel vw cv vf cv cfv vw cv
      wceq vx cv con0 wcel cA con0 wcel cB con0 wcel wa vy cv cA wcel vy cv vf
      cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa vw cv vx cv wcel vw
      cv vf cv cfv vw cv wceq cA cB cep cep vf cv wiso cA con0 wcel vy cv cA
      wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa vw cv
      vx cv wcel vw cv vf cv cfv vw cv wceq cB con0 wcel cA con0 wcel vy cv cA
      wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel vw cv vx
      cv wcel vw cv vf cv cfv vw cv wceq vw cv vx cv wcel vy cv cA wcel vy cv
      vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel cA con0 wcel vw cv vf
      cv cfv vw cv wceq vw cv vx cv wcel vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vw cv cA wcel vw cv vf cv cfv vw cv wceq wi vx cv
      cA wcel cA con0 wcel vw cv vf cv cfv vw cv wceq wi wi vy cv cA wcel vy cv
      vf cv cfv vy cv wceq wi vw cv cA wcel vw cv vf cv cfv vw cv wceq wi vy vw
      cv vx cv vy cv vw cv wceq vy cv cA wcel vw cv cA wcel vy cv vf cv cfv vy
      cv wceq vw cv vf cv cfv vw cv wceq vy cv vw cv cA eleq1 vy cv vw cv wceq
      vy cv vf cv cfv vw cv vf cv cfv vy cv vw cv vy cv vw cv vf cv fveq2 vy cv
      vw cv wceq id eqeq12d imbi12d rcla4v vw cv vx cv wcel cA con0 wcel vx cv
      cA wcel vw cv cA wcel vw cv vf cv cfv vw cv wceq wi vw cv vf cv cfv vw cv
      wceq vw cv vx cv wcel cA con0 wcel vx cv cA wcel vw cv cA wcel vw cv cA
      wcel vw cv vf cv cfv vw cv wceq wi vw cv vf cv cfv vw cv wceq wi cA con0
      wcel vw cv vx cv wcel vx cv cA wcel vw cv cA wcel wi cA con0 wcel vw cv
      vx cv wcel vx cv cA wcel vw cv cA wcel vw cv vx cv cA ontr1 exp3a com12
      vw cv cA wcel vw cv vf cv cfv vw cv wceq pm2.27 syl8 com24 syld com14
      imp42 adantllr adantllr adantllr adantrl eqtr3d cA con0 wcel cB con0 wcel
      wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf
      cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa wa vz cv vx cv vf cv
      cfv wcel vw cv cA wcel vw cv vf cv cfv vz cv wceq wa wa vw cv vx cv wcel
      simprr eqeltrd expr mpd expr exp3a r19.23adv mpd ex cA con0 wcel cB con0
      wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy
      cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv
      wcel vz cv vx cv vf cv cfv wcel cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv wcel wa wa vz cv vf cv
      cfv vz cv vx cv vf cv cfv cA con0 wcel cB con0 wcel wa cA cB cep cep vf
      cv wiso wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx
      cv cA wcel wa vz cv vx cv wcel wa vz cv vf cv cfv vz cv wceq vx cv con0
      wcel cA con0 wcel cB con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv wcel wa vz cv vf cv
      cfv vz cv wceq cA cB cep cep vf cv wiso cA con0 wcel vy cv cA wcel vy cv
      vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv wcel
      wa vz cv vf cv cfv vz cv wceq cB con0 wcel cA con0 wcel vy cv cA wcel vy
      cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel vz cv vx cv wcel
      vz cv vf cv cfv vz cv wceq vz cv vx cv wcel vy cv cA wcel vy cv vf cv cfv
      vy cv wceq wi vy vx cv wral vx cv cA wcel cA con0 wcel vz cv vf cv cfv vz
      cv wceq vz cv vx cv wcel vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy
      vx cv wral vz cv cA wcel vz cv vf cv cfv vz cv wceq wi vx cv cA wcel cA
      con0 wcel vz cv vf cv cfv vz cv wceq wi wi vy cv cA wcel vy cv vf cv cfv
      vy cv wceq wi vz cv cA wcel vz cv vf cv cfv vz cv wceq wi vy vz cv vx cv
      vy cv vz cv wceq vy cv cA wcel vz cv cA wcel vy cv vf cv cfv vy cv wceq
      vz cv vf cv cfv vz cv wceq vy cv vz cv cA eleq1 vy cv vz cv wceq vy cv vf
      cv cfv vz cv vf cv cfv vy cv vz cv vy cv vz cv vf cv fveq2 vy cv vz cv
      wceq id eqeq12d imbi12d rcla4v vz cv vx cv wcel cA con0 wcel vx cv cA
      wcel vz cv cA wcel vz cv vf cv cfv vz cv wceq wi vz cv vf cv cfv vz cv
      wceq vz cv vx cv wcel cA con0 wcel vx cv cA wcel vz cv cA wcel vz cv cA
      wcel vz cv vf cv cfv vz cv wceq wi vz cv vf cv cfv vz cv wceq wi cA con0
      wcel vz cv vx cv wcel vx cv cA wcel vz cv cA wcel wi cA con0 wcel vz cv
      vx cv wcel vx cv cA wcel vz cv cA wcel vz cv vx cv cA ontr1 exp3a com12
      vz cv cA wcel vz cv vf cv cfv vz cv wceq pm2.27 syl8 com24 syld com14
      imp44 adantlr adantlr adantlr cA con0 wcel cB con0 wcel wa cA cB cep cep
      vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq
      wi vy vx cv wral vx cv cA wcel wa vz cv vx cv wcel wa wa vz cv vf cv cfv
      vx cv vf cv cfv cep wbr vz cv vf cv cfv vx cv vf cv cfv wcel cA con0 wcel
      cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA
      wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel wa vz cv
      vx cv wcel wa wa vz cv vx cv cep wbr vz cv vf cv cfv vx cv vf cv cfv cep
      wbr vz cv vx cv wcel vz cv vx cv cep wbr cA con0 wcel cB con0 wcel wa cA
      cB cep cep vf cv wiso wa vx cv con0 wcel wa vy cv cA wcel vy cv vf cv cfv
      vy cv wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv cep wbr vz cv vx
      cv wcel vz vx epel biimpri ad2antll cA cB cep cep vf cv wiso vz cv cA
      wcel vx cv cA wcel vz cv vx cv cep wbr vz cv vf cv cfv vx cv vf cv cfv
      cep wbr wb cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv
      con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx
      cv cA wcel wa vz cv vx cv wcel wa wa cA con0 wcel cB con0 wcel wa cA cB
      cep cep vf cv wiso vx cv con0 wcel vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wi vy vx cv wral vx cv cA wcel wa vz cv vx cv wcel wa simpllr cA
      con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv con0 wcel wa
      vx cv cA wcel vz cv vx cv wcel vz cv cA wcel vy cv cA wcel vy cv vf cv
      cfv vy cv wceq wi vy vx cv wral cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso wa vx cv cA wcel vz cv vx cv wcel wa vz cv cA wcel vx cv
      con0 wcel cA con0 wcel cB con0 wcel wa vx cv cA wcel vz cv vx cv wcel wa
      vz cv cA wcel cA cB cep cep vf cv wiso cA con0 wcel vx cv cA wcel vz cv
      vx cv wcel wa vz cv cA wcel cB con0 wcel cA con0 wcel vx cv cA wcel vz cv
      vx cv wcel wa vz cv cA wcel cA con0 wcel vz cv vx cv wcel vx cv cA wcel
      vz cv cA wcel vz cv vx cv cA ontr1 ancomsd imp adantlr adantlr adantlr
      adantrll cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv
      con0 wcel wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx
      cv cA wcel vz cv vx cv wcel simprlr cA cB vz cv vx cv cep cep vf cv
      isorel sylan32c mpbid vz cv vf cv cfv vx cv vf cv cfv vz cv vf cv fvex vx
      cv vf cv fvex epelc sylib eqeltrrd expr impbid eqrdv exp43 r19.21aiv vy
      cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx cv cA wcel vx
      cv vf cv cfv vx cv wceq wi wi vx con0 wral vx cv cA wcel vx cv vf cv cfv
      vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx
      cv wral wa wn vx con0 wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa
      vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx cv wral wa vx
      con0 wrex wn vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx cv wral vx
      cv cA wcel vx cv vf cv cfv vx cv wceq wi wi vx cv cA wcel vx cv vf cv cfv
      vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx
      cv wral wa wn vx con0 vy cv cA wcel vy cv vf cv cfv vy cv wceq wi vy vx
      cv wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wi wi vy cv cA wcel vy
      cv vf cv cfv vy cv wceq wn wa wn vy vx cv wral vx cv cA wcel vx cv vf cv
      cfv vx cv wceq wn wa wn wi vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa
      wn vy vx cv wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa wa wn vx
      cv cA wcel vx cv vf cv cfv vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv
      vy cv wceq wn wa wn vy vx cv wral wa wn vy cv cA wcel vy cv vf cv cfv vy
      cv wceq wi vy vx cv wral vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa
      wn vy vx cv wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wi vx cv cA
      wcel vx cv vf cv cfv vx cv wceq wn wa wn vy cv cA wcel vy cv vf cv cfv vy
      cv wceq wi vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx cv vy
      cv cA wcel vy cv vf cv cfv vy cv wceq iman ralbii vx cv cA wcel vx cv vf
      cv cfv vx cv wceq iman imbi12i vy cv cA wcel vy cv vf cv cfv vy cv wceq
      wn wa wn vy vx cv wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa
      imnan vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx cv wral vx
      cv cA wcel vx cv vf cv cfv vx cv wceq wn wa wa vx cv cA wcel vx cv vf cv
      cfv vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy
      vx cv wral wa vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx cv
      wral vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa ancom notbii 3bitri
      ralbii vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa vy cv cA wcel vy cv
      vf cv cfv vy cv wceq wn wa wn vy vx cv wral wa vx con0 ralnex bitri sylib
      cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vx cv vf cv cfv
      vx cv wceq wn vx cA wrex vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa
      vy cv cA wcel vy cv vf cv cfv vy cv wceq wn wa wn vy vx cv wral wa vx
      con0 wrex vx cv vf cv cfv vx cv wceq vx cA wral wn cA con0 wcel cB con0
      wcel wa cA cB cep cep vf cv wiso wa vx cv vf cv cfv vx cv wceq wn vx cA
      wrex vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa vx con0 wrex vx cv cA
      wcel vx cv vf cv cfv vx cv wceq wn wa vy cv cA wcel vy cv vf cv cfv vy cv
      wceq wn wa wn vy vx cv wral wa vx con0 wrex cA con0 wcel cB con0 wcel wa
      cA cB cep cep vf cv wiso wa vx cv vf cv cfv vx cv wceq wn vx cv cA wcel
      vx cv vf cv cfv vx cv wceq wn wa vx cA con0 cA con0 wcel cB con0 wcel wa
      cA cB cep cep vf cv wiso wa vx cv cA wcel vx cv vf cv cfv vx cv wceq wn
      wa vx cv con0 wcel cA con0 wcel vx cv cA wcel vx cv vf cv cfv vx cv wceq
      wn wa vx cv con0 wcel wi cB con0 wcel cA cB cep cep vf cv wiso cA con0
      wcel vx cv cA wcel vx cv con0 wcel vx cv vf cv cfv vx cv wceq wn cA con0
      wcel vx cv cA wcel vx cv con0 wcel cA vx cv onelon ex adantrd ad2antrr
      ancrd r19.22dv2 vx cv cA wcel vx cv vf cv cfv vx cv wceq wn wa vy cv cA
      wcel vy cv vf cv cfv vy cv wceq wn wa vx vy vx cv vy cv wceq vx cv cA
      wcel vy cv cA wcel vx cv vf cv cfv vx cv wceq wn vy cv vf cv cfv vy cv
      wceq wn vx cv vy cv cA eleq1 vx cv vy cv wceq vx cv vf cv cfv vx cv wceq
      vy cv vf cv cfv vy cv wceq vx cv vy cv wceq vx cv vf cv cfv vy cv vf cv
      cfv vx cv vy cv vx cv vy cv vf cv fveq2 vx cv vy cv wceq id eqeq12d
      notbid anbi12d onminex syl6 vx cv vf cv cfv vx cv wceq vx cA rexnal
      syl5ibr mt3d cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso vx cv
      vf cv cfv vx cv wceq vx cA wral cA cB wceq cA con0 wcel cB con0 wcel wa
      cA cB cep cep vf cv wiso vx cv vf cv cfv vx cv wceq vx cA wral wa wa vz
      cA cB cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso vx cv vf cv
      cfv vx cv wceq vx cA wral wa wa vz cv cA wcel vz cv cB wcel cA con0 wcel
      cB con0 wcel wa cA cB cep cep vf cv wiso vx cv vf cv cfv vx cv wceq vx cA
      wral wa wa vz cv cA wcel vz cv cB wcel cA con0 wcel cB con0 wcel wa cA cB
      cep cep vf cv wiso vx cv vf cv cfv vx cv wceq vx cA wral wa wa vz cv cA
      wcel wa vz cv vf cv cfv vz cv cB cA cB cep cep vf cv wiso vx cv vf cv cfv
      vx cv wceq vx cA wral wa vz cv cA wcel vz cv vf cv cfv vz cv wceq cA con0
      wcel cB con0 wcel wa vx cv vf cv cfv vx cv wceq vx cA wral vz cv cA wcel
      vz cv vf cv cfv vz cv wceq cA cB cep cep vf cv wiso vx cv vf cv cfv vx cv
      wceq vz cv vf cv cfv vz cv wceq vx vz cv cA vx cv vz cv wceq vx cv vf cv
      cfv vz cv vf cv cfv vx cv vz cv vx cv vz cv vf cv fveq2 vx cv vz cv wceq
      id eqeq12d rcla4cva adantll adantll cA con0 wcel cB con0 wcel wa cA cB
      cep cep vf cv wiso vz cv cA wcel vz cv vf cv cfv cB wcel vx cv vf cv cfv
      vx cv wceq vx cA wral cA cB cep cep vf cv wiso vz cv cA wcel vz cv vf cv
      cfv cB wcel cA con0 wcel cB con0 wcel wa cA cB vf cv wf vz cv cA wcel vz
      cv vf cv cfv cB wcel cA cB cep cep vf cv wiso cA cB vz cv vf cv ffvelrn
      cA cB cep cep vf cv wiso cA cB vf cv wf1o cA cB vf cv wf cA cB cep cep vf
      cv isof1o cA cB vf cv f1of syl sylan adantll adantlrr eqeltrrd ex cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso vx cv vf cv cfv vx cv wceq
      vx cA wral wa wa vz cv cB wcel vw cv vf cv cfv vz cv wceq vw cA wrex vz
      cv cA wcel cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso vx cv vf
      cv cfv vx cv wceq vx cA wral wa wa vz cv vf cv crn wcel vz cv cB wcel vw
      cv vf cv cfv vz cv wceq vw cA wrex cA con0 wcel cB con0 wcel wa cA cB cep
      cep vf cv wiso vx cv vf cv cfv vx cv wceq vx cA wral wa wa vf cv crn cB
      vz cv cA cB cep cep vf cv wiso vf cv crn cB wceq cA con0 wcel cB con0
      wcel wa vx cv vf cv cfv vx cv wceq vx cA wral cA cB cep cep vf cv wiso cA
      cB vf cv wf1o cA cB vf cv wfo vf cv crn cB wceq cA cB cep cep vf cv
      isof1o cA cB vf cv f1ofo cA cB vf cv forn 3syl ad2antrl eleq2d cA cB cep
      cep vf cv wiso vz cv vf cv crn wcel vw cv vf cv cfv vz cv wceq vw cA wrex
      wb cA con0 wcel cB con0 wcel wa vx cv vf cv cfv vx cv wceq vx cA wral cA
      cB cep cep vf cv wiso cA cB vf cv wf1o vf cv cA wfn vz cv vf cv crn wcel
      vw cv vf cv cfv vz cv wceq vw cA wrex wb cA cB cep cep vf cv isof1o cA cB
      vf cv f1ofn vw cA vz cv vf cv fvelrnb 3syl ad2antrl bitr3d cA con0 wcel
      cB con0 wcel wa cA cB cep cep vf cv wiso vx cv vf cv cfv vx cv wceq vx cA
      wral wa wa vw cv vf cv cfv vz cv wceq vz cv cA wcel vw cA cA con0 wcel cB
      con0 wcel wa cA cB cep cep vf cv wiso vx cv vf cv cfv vx cv wceq vx cA
      wral vw cv cA wcel vw cv vf cv cfv vz cv wceq vz cv cA wcel wi wi cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vw cv cA wcel vx cv vf
      cv cfv vx cv wceq vx cA wral vw cv vf cv cfv vz cv wceq vz cv cA wcel wi
      cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vw cv cA wcel vx
      cv vf cv cfv vx cv wceq vx cA wral vw cv vf cv cfv vw cv wceq vw cv vf cv
      cfv vz cv wceq vz cv cA wcel wi vw cv cA wcel vx cv vf cv cfv vx cv wceq
      vx cA wral vw cv vf cv cfv vw cv wceq wi wi cA con0 wcel cB con0 wcel wa
      cA cB cep cep vf cv wiso wa vx cv vf cv cfv vx cv wceq vw cv vf cv cfv vw
      cv wceq vx vw cv cA vx cv vw cv wceq vx cv vf cv cfv vw cv vf cv cfv vx
      cv vw cv vx cv vw cv vf cv fveq2 vx cv vw cv wceq id eqeq12d rcla4v a1i
      cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vw cv cA wcel vw
      cv vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq vz cv cA wcel cA con0
      wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vw cv cA wcel wa vw cv
      vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq wa wa vz cv vw cv cA vw
      cv vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq wa vz cv vw cv wceq cA
      con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vw cv cA wcel wa vw
      cv vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq wa vw cv vf cv cfv vz
      cv vw cv vw cv vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq pm3.27 vw
      cv vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq pm3.26 eqtr3d adantl
      cA con0 wcel cB con0 wcel wa cA cB cep cep vf cv wiso wa vw cv cA wcel vw
      cv vf cv cfv vw cv wceq vw cv vf cv cfv vz cv wceq wa simplr eqeltrd
      exp43 syldd com23 impr r19.23adv sylbid impbid eqrdv expr mpd ex 19.23adv
      impbid $.
      $( [16-Oct-2009] $) $( [16-Oct-2009] $)
  $}

  ${
    $d a b c f g h j k m n o p q r s t u v w x y z A $. $d a b c f h m n o p q
    x y z B $. $d c m n o p q u C $. $d h j m n o p q r u v w y z D $. $d b c h
    j m n o p q r s u v w x y z F $. $d b c h m n o p q G $. $d a f g h j m n o
    p q r s u v w x z H $. $d a b c f g h j k m n o p q r s t u v w x y z R $.
    ${
      ordtypelem.1 $e |- A e. _V $.
      ordtypelem.2 $e |- B = { h | E. b e. On ( h Fn b /\ A. c e. b ( h ` c ) =
      ( G ` ( h |` c ) ) ) } $.
      ordtypelem.3 $e |- F = U. B $.
      ordtypelem.4 $e |- C = { w e. A | A. j e. ran h j R w } $.
      ordtypelem.5 $e |- D = { w e. A | A. j e. ( F " x ) j R w } $.
      ordtypelem.6 $e |- G = { <. h , c >. | c = U. { v e. C | A. u e. C -. u R
      v } } $.
      ordtypelem.7 $e |- H = { w e. A | A. j e. ( F " y ) j R w } $.
      $( Lemma for ~ ordtype . $)
      ordtypelem1 $p |- ( ( x e. On /\ R We A /\ D =/= (/) ) -> ( F ` x ) e. D
      ) $=
        vx cv con0 wcel cA cR wwe cD c0 wne vx cv cF cfv cD wcel vx cv con0
        wcel vx cv cF cfv cD wcel vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cD wcel cA cR wwe cD c0 wne wa vx cv con0 wcel vx cv cF cfv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni cD vx cv con0 wcel vx cv cF
        cfv cF vx cv cres cG cfv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni vb vc vx cB vh cF cG ordtypelem.2 ordtypelem.3 tfr2 cF vx cv cres
        cG cfv cF vx cv cres vc cv vu cv vv cv cR wbr wn vu cC wral vv cC crab
        cuni wceq vh vc copab cfv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cF vx cv cres cG vc cv vu cv vv cv cR wbr wn vu cC wral vv cC crab
        cuni wceq vh vc copab ordtypelem.6 fveq1i vh vc cF vx cv cres vu cv vv
        cv cR wbr wn vu cC wral vv cC crab cuni vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cF wfun vx cv cvv wcel cF vx cv cres cvv wcel vb
        vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfrlem7 vx visset cF vx cv cvv
        resfunexg mp2an vu cv vv cv cR wbr wn vu cD wral vv cD crab vu cv vv cv
        cR wbr wn vu cD wral vv cD cD cA ordtypelem.1 cD vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA crab cA ordtypelem.5 vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA ssrab2 eqsstri ssexi rabex uniex vh cv cF vx cv
        cres wceq vu cv vv cv cR wbr wn vu cC wral vv cC crab vu cv vv cv cR
        wbr wn vu cD wral vv cD crab vh cv cF vx cv cres wceq vv cv cC wcel vu
        cv vv cv cR wbr wn vu cC wral wa vv cab vv cv cD wcel vu cv vv cv cR
        wbr wn vu cD wral wa vv cab vu cv vv cv cR wbr wn vu cC wral vv cC crab
        vu cv vv cv cR wbr wn vu cD wral vv cD crab vh cv cF vx cv cres wceq vv
        cv cC wcel vu cv vv cv cR wbr wn vu cC wral wa vv cv cD wcel vu cv vv
        cv cR wbr wn vu cD wral wa vv vh cv cF vx cv cres wceq vv cv cC wcel vv
        cv cD wcel vu cv vv cv cR wbr wn vu cC wral vu cv vv cv cR wbr wn vu cD
        wral vh cv cF vx cv cres wceq cC cD vv cv vh cv cF vx cv cres wceq vj
        cv vw cv cR wbr vj vh cv crn wral vw cA crab vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA crab cC cD vh cv cF vx cv cres wceq vj cv vw cv
        cR wbr vj vh cv crn wral vj cv vw cv cR wbr vj cF vx cv cima wral vw cA
        vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn cF vx cv cima
        vh cv cF vx cv cres wceq vh cv crn cF vx cv cres crn cF vx cv cima vh
        cv cF vx cv cres rneq cF vx cv df-ima syl6eqr raleq1d rabbisdv
        ordtypelem.4 ordtypelem.5 3eqtr4g eleq2d vh cv cF vx cv cres wceq vu cv
        vv cv cR wbr wn vu cC cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj
        vh cv crn wral vw cA crab vj cv vw cv cR wbr vj cF vx cv cima wral vw
        cA crab cC cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn
        wral vj cv vw cv cR wbr vj cF vx cv cima wral vw cA vh cv cF vx cv cres
        wceq vj cv vw cv cR wbr vj vh cv crn cF vx cv cima vh cv cF vx cv cres
        wceq vh cv crn cF vx cv cres crn cF vx cv cima vh cv cF vx cv cres rneq
        cF vx cv df-ima syl6eqr raleq1d rabbisdv ordtypelem.4 ordtypelem.5
        3eqtr4g raleq1d anbi12d abbidv vu cv vv cv cR wbr wn vu cC wral vv cC
        df-rab vu cv vv cv cR wbr wn vu cD wral vv cD df-rab 3eqtr4g unieqd
        fvopab eqtri syl6eq eleq1d cA cR wwe cD cA wss cD c0 wne vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cD wcel cD vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA crab cA ordtypelem.5 vj cv vw cv cR wbr vj cF vx
        cv cima wral vw cA ssrab2 eqsstri vv vu cA cD cR cD cA ordtypelem.1 cD
        vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cA ordtypelem.5 vj
        cv vw cv cR wbr vj cF vx cv cima wral vw cA ssrab2 eqsstri ssexi
        wereucl mp3an2 syl5bir 3impib $.
        $( [17-Oct-2009] $) $( [17-Oct-2009] $)

      $( Lemma for ~ ordtype . $)
      ordtypelem2 $p |- ( ( x e. On /\ R We A /\ D =/= (/) ) -> ( y e. x -> ( F
      ` y ) R ( F ` x ) ) ) $=
        vx cv con0 wcel cA cR wwe cD c0 wne w3a vy cv vx cv wcel vy cv cF cfv
        cF vx cv cima wcel vy cv cF cfv vx cv cF cfv cR wbr vx cv con0 wcel cA
        cR wwe vy cv vx cv wcel vy cv cF cfv cF vx cv cima wcel wi cD c0 wne vx
        cv con0 wcel vx cv cF cdm wss vy cv vx cv wcel vy cv cF cfv cF vx cv
        cima wcel wi vx cv con0 wcel vx cv con0 cF cdm vx cv onss cF con0 wfn
        cF cdm con0 wceq vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfr1 con0
        cF fndm ax-mp syl6ssr cF wfun vx cv cF cdm wss vy cv vx cv wcel vy cv
        cF cfv cF vx cv cima wcel wi vb vc cB vh cF cG ordtypelem.2
        ordtypelem.3 tfrlem7 vx cv vy cv cF funfvima2 mpan syl 3ad2ant1 vx cv
        con0 wcel cA cR wwe cD c0 wne w3a vx cv cF cfv cD wcel vj cv vx cv cF
        cfv cR wbr vj cF vx cv cima wral vy cv cF cfv cF vx cv cima wcel vy cv
        cF cfv vx cv cF cfv cR wbr wi vx vy vw vv vu cA cB cC cD cR vh vj cF cG
        cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4
        ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem1 vx cv cF cfv cD wcel
        vx cv cF cfv cA wcel vj cv vx cv cF cfv cR wbr vj cF vx cv cima wral vj
        cv vw cv cR wbr vj cF vx cv cima wral vj cv vx cv cF cfv cR wbr vj cF
        vx cv cima wral vw vx cv cF cfv cA cD vw cv vx cv cF cfv wceq vj cv vw
        cv cR wbr vj cv vx cv cF cfv cR wbr vj cF vx cv cima vw cv vx cv cF cfv
        vj cv cR breq2 ralbidv ordtypelem.5 elrab2 pm3.27bi vj cv vx cv cF cfv
        cR wbr vy cv cF cfv vx cv cF cfv cR wbr vj vy cv cF cfv cF vx cv cima
        vj cv vy cv cF cfv vx cv cF cfv cR breq1 rcla4cv 3syl syld $.
        $( [17-Oct-2009] $) $( [17-Oct-2009] $)

      $( Lemma for ~ ordtype . $)
      ordtypelem3 $p |- ( ( x e. On /\ R We A /\ D =/= (/) ) -> ( y e. x -> -.
      ( F ` x ) = ( F ` y ) ) ) $=
        vx cv con0 wcel cA cR wwe cD c0 wne w3a vy cv vx cv wcel vy cv cF cfv
        vx cv cF cfv cR wbr vx cv cF cfv vy cv cF cfv wceq wn vx vy vw vv vu cA
        cB cC cD cR vh vj cF cG cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3
        ordtypelem.4 ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem2 cA cR
        wpo vx cv cF cfv cA wcel vy cv cF cfv vx cv cF cfv cR wbr vx cv cF cfv
        vy cv cF cfv wceq wn wi vx cv con0 wcel cA cR wwe cD c0 wne w3a vy cv
        cF cfv vx cv cF cfv cR wbr cA cR wpo vx cv cF cfv cA wcel wa vx cv cF
        cfv vy cv cF cfv wceq wn vy cv cF cfv vx cv cF cfv cR wbr vx cv cF cfv
        vy cv cF cfv wceq vx cv cF cfv vx cv cF cfv cR wbr cA cR wpo vx cv cF
        cfv cA wcel wa vx cv cF cfv vy cv cF cfv wceq vx cv cF cfv vx cv cF cfv
        cR wbr vy cv cF cfv vx cv cF cfv cR wbr vx cv cF cfv vy cv cF cfv vx cv
        cF cfv cR breq1 biimprcd cA vx cv cF cfv cR poirr nsyli com12 cA cR wwe
        vx cv con0 wcel cA cR wpo cD c0 wne cA cR wwe cA cR wor cA cR wpo cA cR
        weso cA cR sopo syl 3ad2ant2 vx cv con0 wcel cA cR wwe cD c0 wne w3a vx
        cv cF cfv cD wcel vx cv cF cfv cA wcel vx vy vw vv vu cA cB cC cD cR vh
        vj cF cG cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4
        ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem1 cD cA vx cv cF cfv
        cD vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cA ordtypelem.5
        vj cv vw cv cR wbr vj cF vx cv cima wral vw cA ssrab2 eqsstri sseli syl
        sylanc syld $.
        $( [17-Oct-2009] $) $( [17-Oct-2009] $)

      $( Lemma for ~ ordtype . There is a smallest ordinal number whose image
         has no upper bounds in ` A ` . $)
      ordtypelem4 $p |- ( R We A -> E. x e. On ( D = (/) /\ A. y e. x H =/= (/)
      ) ) $=
        cA cR wwe cD c0 wceq vx con0 wrex cD c0 wceq cH c0 wne vy vx cv wral wa
        vx con0 wrex cA cR wwe cD c0 wceq vx con0 wrex cF crn cvv wcel cF crn
        cvv wcel wn wa cF crn cvv wcel pm3.24 cA cR wwe vx cv con0 wcel cD c0
        wne wi vx wal cF crn cvv wcel cF crn cvv wcel wn wa cD c0 wceq vx con0
        wrex wn cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal cF crn cvv wcel
        cF crn cvv wcel wn cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal cF crn
        cvv wcel cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal wa cF crn cA wss
        cF crn cvv wcel cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal wa vr cF
        crn cA cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal wa vx cv cF cfv vr
        cv wceq vx con0 wrex vr cv cA wcel vr cv cF crn wcel cA cR wwe vx cv
        con0 wcel cD c0 wne wi vx wal wa vx cv cF cfv vr cv wceq vr cv cA wcel
        vx con0 cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal vx cA cR wwe vx
        ax-17 vx cv con0 wcel cD c0 wne wi vx hba1 hban vr cv cA wcel vx ax-17
        cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal vx cv con0 wcel vx cv cF
        cfv vr cv wceq vr cv cA wcel wi wi cA cR wwe vx cv con0 wcel cD c0 wne
        wi vx cv con0 wcel vx cv cF cfv vr cv wceq vr cv cA wcel wi wi vx cA cR
        wwe vx cv con0 wcel cD c0 wne vx cv cF cfv vr cv wceq vr cv cA wcel wi
        vx cv con0 wcel cA cR wwe cD c0 wne vx cv cF cfv vr cv wceq vr cv cA
        wcel wi wi vx cv con0 wcel cA cR wwe cD c0 wne vx cv cF cfv vr cv wceq
        vr cv cA wcel wi vx cv cF cfv vr cv wceq vx cv cF cfv cA wcel vr cv cA
        wcel vx cv con0 wcel cA cR wwe cD c0 wne wa wa vx cv cF cfv vr cv cA
        eleq1 vx cv con0 wcel cA cR wwe cD c0 wne wa wa vx cv cF cfv cD wcel vx
        cv cF cfv cA wcel vx cv con0 wcel cA cR wwe cD c0 wne vx cv cF cfv cD
        wcel vx vy vw vv vu cA cB cC cD cR vh vj cF cG cH vb vc ordtypelem.1
        ordtypelem.2 ordtypelem.3 ordtypelem.4 ordtypelem.5 ordtypelem.6
        ordtypelem.7 ordtypelem1 3expb cD cA vx cv cF cfv cD vj cv vw cv cR wbr
        vj cF vx cv cima wral vw cA crab cA ordtypelem.5 vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA ssrab2 eqsstri sseli syl syl5cbi exp32 com12
        a2d a4sd imp r19.23ad cF con0 wfn vr cv cF crn wcel vx cv cF cfv vr cv
        wceq vx con0 wrex wb vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfr1
        vx con0 vr cv cF fvelrnb ax-mp syl5ib ssrdv cF crn cA ordtypelem.1 ssex
        syl ex cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal cF ccnv wfun cF
        crn cvv wcel wn cA cR wwe vx cv con0 wcel cD c0 wne wi vx wal vx cv cF
        cfv vy cv cF cfv wceq wn vy vx cv wral vx con0 wral cF ccnv wfun cA cR
        wwe vx cv con0 wcel cD c0 wne wi vx wal vx cv con0 wcel vy cv vx cv
        wcel wa vx cv cF cfv vy cv cF cfv wceq wn wi vy wal vx wal vx cv cF cfv
        vy cv cF cfv wceq wn vy vx cv wral vx con0 wral cA cR wwe vx cv con0
        wcel cD c0 wne wi vx cv con0 wcel vy cv vx cv wcel wa vx cv cF cfv vy
        cv cF cfv wceq wn wi vy wal vx cA cR wwe vx cv con0 wcel cD c0 wne wi
        vx cv con0 wcel vy cv vx cv wcel wa vx cv cF cfv vy cv cF cfv wceq wn
        wi vy cA cR wwe vx cv con0 wcel cD c0 wne wi vx cv con0 wcel vy cv vx
        cv wcel vx cv cF cfv vy cv cF cfv wceq wn cA cR wwe vx cv con0 wcel cD
        c0 wne vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi cA cR wwe
        vx cv con0 wcel cD c0 wne vy cv vx cv wcel vx cv cF cfv vy cv cF cfv
        wceq wn wi vx cv con0 wcel cA cR wwe cD c0 wne vy cv vx cv wcel vx cv
        cF cfv vy cv cF cfv wceq wn wi vx vy vw vv vu cA cB cC cD cR vh vj cF
        cG cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4
        ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem3 3com12 3exp a2d
        imp4a 19.21adv 19.20dv vx cv cF cfv vy cv cF cfv wceq wn vx vy con0 vx
        cv r2al syl6ibr vx cv cF cfv vy cv cF cfv wceq wn vy vx cv wral vx con0
        wral cF con0 cres ccnv wfun cF ccnv wfun con0 con0 wss vx cv cF cfv vy
        cv cF cfv wceq wn vy vx cv wral vx con0 wral cF con0 cres ccnv wfun
        con0 ssid vx vy con0 cF vb vc cB vh cF cG ordtypelem.2 ordtypelem.3
        tfr1 tz7.48lem mpan cF con0 cres ccnv cF ccnv wceq cF con0 cres ccnv
        wfun cF ccnv wfun wb cF con0 cres cF cF wrel cF cdm con0 wss cF con0
        cres cF wceq vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfrlem6 cF cdm
        con0 cF con0 wfn cF cdm con0 wceq vb vc cB vh cF cG ordtypelem.2
        ordtypelem.3 tfr1 con0 cF fndm ax-mp eqimssi cF con0 relssres mp2an
        cnveqi cF con0 cres ccnv cF ccnv funeq ax-mp sylib syl6 cF ccnv wfun cF
        crn cvv wcel con0 cvv wcel onprc cF ccnv wfun cF ccnv cdm cvv wcel cF
        ccnv crn cvv wcel cF crn cvv wcel con0 cvv wcel cF ccnv cdm cvv wcel cF
        ccnv wfun cF ccnv crn cvv wcel cvv cF ccnv funrnex com12 cF crn cF ccnv
        cdm cvv cF df-rn eleq1i con0 cF ccnv crn cvv cF cdm con0 cF ccnv crn cF
        con0 wfn cF cdm con0 wceq vb vc cB vh cF cG ordtypelem.2 ordtypelem.3
        tfr1 con0 cF fndm ax-mp cF dfdm4 eqtr3i eleq1i 3imtr4g mtoi syl6 jcad
        cD c0 wne vx con0 wral cD c0 wceq wn vx con0 wral vx cv con0 wcel cD c0
        wne wi vx wal cD c0 wceq vx con0 wrex wn cD c0 wne cD c0 wceq wn vx
        con0 cD c0 df-ne ralbii cD c0 wne vx con0 df-ral cD c0 wceq vx con0
        ralnex 3bitr3i syl5ibr mt3i cD c0 wceq vx con0 wrex cD c0 wceq cH c0
        wceq wn vy vx cv wral wa vx con0 wrex cD c0 wceq cH c0 wne vy vx cv
        wral wa vx con0 wrex cD c0 wceq cH c0 wceq vx vy vx cv vy cv wceq cD cH
        c0 vx cv vy cv wceq vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab
        vj cv vw cv cR wbr vj cF vy cv cima wral vw cA crab cD cH vx cv vy cv
        wceq vj cv vw cv cR wbr vj cF vx cv cima wral vj cv vw cv cR wbr vj cF
        vy cv cima wral vw cA vx cv vy cv wceq vj cv vw cv cR wbr vj cF vx cv
        cima cF vy cv cima vx cv vy cv cF imaeq2 raleq1d rabbisdv ordtypelem.5
        ordtypelem.7 3eqtr4g eqeq1d onminex cD c0 wceq cH c0 wne vy vx cv wral
        wa cD c0 wceq cH c0 wceq wn vy vx cv wral wa vx con0 cH c0 wne vy vx cv
        wral cH c0 wceq wn vy vx cv wral cD c0 wceq cH c0 wne cH c0 wceq wn vy
        vx cv cH c0 df-ne ralbii anbi2i rexbii sylibr syl $.
        $( [20-Oct-2009] $) $( [20-Oct-2009] $)

      $( Lemma for ~ ordtype . Establish injectivity of ` F ` when restricted
         to the ordinal number of ~ ordtypelem4 . $)
      ordtypelem5 $p |- ( ( ( R We A /\ x e. On ) /\ ( D = (/) /\ A. y e. x H
      =/= (/) ) ) -> Fun `' ( F |` x ) ) $=
        vx cv con0 wss vz cv cF cfv vr cv cF cfv wceq wn vr vz cv wral vz vx cv
        wral cF vx cv cres ccnv wfun cA cR wwe vx cv con0 wcel wa cD c0 wceq cH
        c0 wne vy vx cv wral wa wa vz vr vx cv cF vb vc cB vh cF cG
        ordtypelem.2 ordtypelem.3 tfr1 tz7.48lem vx cv con0 wcel vx cv con0 wss
        cA cR wwe cD c0 wceq cH c0 wne vy vx cv wral wa vx cv onss ad2antlr cA
        cR wwe vx cv con0 wcel wa cD c0 wceq cH c0 wne vy vx cv wral wa wa vz
        cv cF cfv vr cv cF cfv wceq wn vz vr vx cv vz cv cA cR wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral vz cv vx cv wcel vr cv vz cv wcel wa vz
        cv cF cfv vr cv cF cfv wceq wn wi cD c0 wceq cA cR wwe vx cv con0 wcel
        wa cH c0 wne vy vx cv wral vz cv vx cv wcel vr cv vz cv wcel vz cv cF
        cfv vr cv cF cfv wceq wn vz cv vx cv wcel cH c0 wne vy vx cv wral cA cR
        wwe vx cv con0 wcel wa vr cv vz cv wcel vz cv cF cfv vr cv cF cfv wceq
        wn wi vz cv vx cv wcel cH c0 wne vy vx cv wral vy vz cv cH csb c0 wne
        cA cR wwe vx cv con0 wcel wa vr cv vz cv wcel vz cv cF cfv vr cv cF cfv
        wceq wn wi wi cH c0 wne vy vz cv cH csb c0 wne vy vz cv vx cv vy vm vy
        vz cv cH csb c0 vy vm vz cv cH vz visset vm cv vz cv wcel vy ax-17
        hbcsb1 vm cv c0 wcel vy ax-17 hbne vy cv vz cv wceq cH vy vz cv cH csb
        c0 vy vz cv cH csbeq1a neeq1d rcla4 vz cv vx cv wcel vx vz cv cD csb c0
        wne cA cR wwe vx cv con0 wcel wa vr cv vz cv wcel vz cv cF cfv vr cv cF
        cfv wceq wn wi wi vy vz cv cH csb c0 wne cA cR wwe vx cv con0 wcel wa
        vz cv vx cv wcel vx vz cv cD csb c0 wne vr cv vz cv wcel vz cv cF cfv
        vr cv cF cfv wceq wn wi cA cR wwe vx cv con0 wcel vz cv vx cv wcel vx
        vz cv cD csb c0 wne vr cv vz cv wcel vz cv cF cfv vr cv cF cfv wceq wn
        wi wi cA cR wwe vz cv con0 wcel vx vz cv cD csb c0 wne vr cv vz cv wcel
        vz cv cF cfv vr cv cF cfv wceq wn wi wi vx cv con0 wcel vz cv vx cv
        wcel wa vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne vr cv vz cv
        wcel vz cv cF cfv vr cv cF cfv wceq wn wi wi vz cv con0 wcel cA cR wwe
        vx vz cv cD csb c0 wne vr cv vz cv wcel vz cv cF cfv vr cv cF cfv wceq
        wn wi vx cv con0 wcel cA cR wwe cD c0 wne w3a vy cv vx cv wcel vx cv cF
        cfv vy cv cF cfv wceq wn wi wi vy wal vx wal vz cv con0 wcel cA cR wwe
        vx vz cv cD csb c0 wne w3a vr cv vz cv wcel vz cv cF cfv vr cv cF cfv
        wceq wn wi wi vx cv con0 wcel cA cR wwe cD c0 wne w3a vy cv vx cv wcel
        vx cv cF cfv vy cv cF cfv wceq wn wi wi vx vy vx vy vw vv vu cA cB cC
        cD cR vh vj cF cG cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3
        ordtypelem.4 ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem3 gen2 vx
        cv con0 wcel cA cR wwe cD c0 wne w3a vy cv vx cv wcel vx cv cF cfv vy
        cv cF cfv wceq wn wi wi vy wal vx wal vz cv con0 wcel cA cR wwe vx vz
        cv cD csb c0 wne w3a vy cv vz cv wcel vz cv cF cfv vy cv cF cfv wceq wn
        wi wi vy wal vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne w3a vr cv
        vz cv wcel vz cv cF cfv vr cv cF cfv wceq wn wi wi vz cv cvv wcel vx cv
        con0 wcel cA cR wwe cD c0 wne w3a vy cv vx cv wcel vx cv cF cfv vy cv
        cF cfv wceq wn wi wi vy wal vx wal vz cv con0 wcel cA cR wwe vx vz cv
        cD csb c0 wne w3a vy cv vz cv wcel vz cv cF cfv vy cv cF cfv wceq wn wi
        wi vy wal wi vz visset vx cv con0 wcel cA cR wwe cD c0 wne w3a vy cv vx
        cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wi vy wal vz cv con0 wcel
        cA cR wwe vx vz cv cD csb c0 wne w3a vy cv vz cv wcel vz cv cF cfv vy
        cv cF cfv wceq wn wi wi vy wal vx vm vz cv cvv vm cv vz cv wcel vx
        ax-17 vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne w3a vy cv vz cv
        wcel vz cv cF cfv vy cv cF cfv wceq wn wi wi vx vy vz cv con0 wcel cA
        cR wwe vx vz cv cD csb c0 wne w3a vy cv vz cv wcel vz cv cF cfv vy cv
        cF cfv wceq wn wi vx vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne
        vx vz cv con0 wcel vx ax-17 cA cR wwe vx ax-17 vx vm vx vz cv cD csb c0
        vx vm vz cv cD vz visset vm cv vz cv wcel vx ax-17 hbcsb1 vm cv c0 wcel
        vx ax-17 hbne hb3an vy cv vz cv wcel vz cv cF cfv vy cv cF cfv wceq wn
        wi vx ax-17 hbim hbal vx cv vz cv wceq vx cv con0 wcel cA cR wwe cD c0
        wne w3a vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi wi vz cv
        con0 wcel cA cR wwe vx vz cv cD csb c0 wne w3a vy cv vz cv wcel vz cv
        cF cfv vy cv cF cfv wceq wn wi wi vy vx cv vz cv wceq vx cv con0 wcel
        cA cR wwe cD c0 wne w3a vz cv con0 wcel cA cR wwe vx vz cv cD csb c0
        wne w3a vy cv vx cv wcel vx cv cF cfv vy cv cF cfv wceq wn wi vy cv vz
        cv wcel vz cv cF cfv vy cv cF cfv wceq wn wi vx cv vz cv wceq vx cv
        con0 wcel vz cv con0 wcel cD c0 wne vx vz cv cD csb c0 wne cA cR wwe vx
        cv vz cv con0 eleq1 vx cv vz cv wceq cD vx vz cv cD csb c0 vx vz cv cD
        csbeq1a neeq1d 3anbi13d vx cv vz cv wceq vy cv vx cv wcel vy cv vz cv
        wcel vx cv cF cfv vy cv cF cfv wceq wn vz cv cF cfv vy cv cF cfv wceq
        wn vx cv vz cv vy cv eleq2 vx cv vz cv wceq vx cv cF cfv vy cv cF cfv
        wceq vz cv cF cfv vy cv cF cfv wceq vx cv vz cv wceq vx cv cF cfv vz cv
        cF cfv vy cv cF cfv vx cv vz cv cF fveq2 eqeq1d notbid imbi12d imbi12d
        albidv cla4gf ax-mp vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne
        w3a vy cv vz cv wcel vz cv cF cfv vy cv cF cfv wceq wn wi wi vz cv con0
        wcel cA cR wwe vx vz cv cD csb c0 wne w3a vr cv vz cv wcel vz cv cF cfv
        vr cv cF cfv wceq wn wi wi vy vr vy cv vr cv wceq vy cv vz cv wcel vz
        cv cF cfv vy cv cF cfv wceq wn wi vr cv vz cv wcel vz cv cF cfv vr cv
        cF cfv wceq wn wi vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne w3a
        vy cv vr cv wceq vy cv vz cv wcel vr cv vz cv wcel vz cv cF cfv vy cv
        cF cfv wceq wn vz cv cF cfv vr cv cF cfv wceq wn vy cv vr cv vz cv
        eleq1 vy cv vr cv wceq vz cv cF cfv vy cv cF cfv wceq vz cv cF cfv vr
        cv cF cfv wceq vy cv vr cv wceq vy cv cF cfv vr cv cF cfv vz cv cF cfv
        vy cv vr cv cF fveq2 eqeq2d notbid imbi12d imbi2d a4v syl ax-mp 3expia
        ancoms vx cv vz cv onelon sylan2 expr com3l vy vz cv cH csb vx vz cv cD
        csb c0 vz cv cvv wcel vy vz cv cH csb vx vz cv cD csb wceq vz visset vy
        vx vz cv cH cD cvv vy cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima
        wral vw cA crab vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cH
        cD vy cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima wral vj cv vw
        cv cR wbr vj cF vx cv cima wral vw cA vy cv vx cv wceq vj cv vw cv cR
        wbr vj cF vy cv cima cF vx cv cima vy cv vx cv cF imaeq2 raleq1d
        rabbisdv ordtypelem.7 ordtypelem.5 3eqtr4g cbvcsbv ax-mp neeq1i syl5ib
        syld com13 imp4b adantrl r19.21aivv sylanc $.
        $( [20-Oct-2009] $) $( [20-Oct-2009] $)

      $( Lemma for ~ ordtype . If ` z ` is not in ` ( F " x ) ` , ` m ` is in
         ` ( F " x ) ` , and every element of ` ( F " x ) ` which is less than
         ` m ` is also less than ` z ` , ` m ` is also less than ` z ` . $)
      ordtypelem6 $p |- ( ( ( ( R We A /\ x e. On ) /\ ( ( F " x ) C_ A /\ A. y
      e. x H =/= (/) ) ) /\ ( ( z e. A /\ -. z e. ( F " x ) ) /\ m e. ( F " x )
      ) ) -> ( A. n ( n R m -> ( n e. ( F " x ) -> n R z ) ) -> m R z ) ) $=
        cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv
        wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa vm cv cF vr cv
        cima wcel wa wa vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn cv vz cv
        cR wbr wi wi vn wal vm cv vz cv cR wbr wi wi cA cR wwe vx cv con0 wcel
        wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz
        cv cF vx cv cima wcel wn wa vm cv cF vx cv cima wcel wa wa vn cv vm cv
        cR wbr vn cv cF vx cv cima wcel vn cv vz cv cR wbr wi wi vn wal vm cv
        vz cv cR wbr wi wi vr cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss
        cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn
        wa vm cv cF vr cv cima wcel wa wa vn cv vm cv cR wbr vn cv cF vr cv
        cima wcel vn cv vz cv cR wbr wi wi vn wal vm cv vz cv cR wbr wi wi cA
        cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral
        wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vm cv cF vx cv cima
        wcel wa wa vn cv vm cv cR wbr vn cv cF vx cv cima wcel vn cv vz cv cR
        wbr wi wi vn wal vm cv vz cv cR wbr wi wi vr vx vr cv vx cv wceq cA cR
        wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa
        wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa vm cv cF vr cv cima
        wcel wa wa cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne
        vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vm cv
        cF vx cv cima wcel wa wa vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn
        cv vz cv cR wbr wi wi vn wal vm cv vz cv cR wbr wi vn cv vm cv cR wbr
        vn cv cF vx cv cima wcel vn cv vz cv cR wbr wi wi vn wal vm cv vz cv cR
        wbr wi vr cv vx cv wceq cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa cA cR wwe vx cv con0 wcel wa cF vx cv
        cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vr cv
        cima wcel wn wa vm cv cF vr cv cima wcel wa vz cv cA wcel vz cv cF vx
        cv cima wcel wn wa vm cv cF vx cv cima wcel wa vr cv vx cv wceq cA cR
        wwe vr cv con0 wcel wa cA cR wwe vx cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa cF vx cv cima cA wss cH c0 wne vy vx cv
        wral wa vr cv vx cv wceq vr cv con0 wcel vx cv con0 wcel cA cR wwe vr
        cv vx cv con0 eleq1 anbi2d vr cv vx cv wceq cF vr cv cima cA wss cF vx
        cv cima cA wss cH c0 wne vy vr cv wral cH c0 wne vy vx cv wral vr cv vx
        cv wceq cF vr cv cima cF vx cv cima cA vr cv vx cv cF imaeq2 sseq1d cH
        c0 wne vy vr cv vx cv raleq1 anbi12d anbi12d vr cv vx cv wceq vz cv cA
        wcel vz cv cF vr cv cima wcel wn wa vz cv cA wcel vz cv cF vx cv cima
        wcel wn wa vm cv cF vr cv cima wcel vm cv cF vx cv cima wcel vr cv vx
        cv wceq vz cv cF vr cv cima wcel wn vz cv cF vx cv cima wcel wn vz cv
        cA wcel vr cv vx cv wceq vz cv cF vr cv cima wcel vz cv cF vx cv cima
        wcel vr cv vx cv wceq cF vr cv cima cF vx cv cima vz cv vr cv vx cv cF
        imaeq2 eleq2d notbid anbi2d vr cv vx cv wceq cF vr cv cima cF vx cv
        cima vm cv vr cv vx cv cF imaeq2 eleq2d anbi12d anbi12d vr cv vx cv
        wceq vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi
        wi vn wal vn cv vm cv cR wbr vn cv cF vx cv cima wcel vn cv vz cv cR
        wbr wi wi vn wal vm cv vz cv cR wbr vr cv vx cv wceq vn cv vm cv cR wbr
        vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn cv vm cv cR wbr vn
        cv cF vx cv cima wcel vn cv vz cv cR wbr wi wi vn vr cv vx cv wceq vn
        cv cF vr cv cima wcel vn cv vz cv cR wbr wi vn cv cF vx cv cima wcel vn
        cv vz cv cR wbr wi vn cv vm cv cR wbr vr cv vx cv wceq vn cv cF vr cv
        cima wcel vn cv cF vx cv cima wcel vn cv vz cv cR wbr vr cv vx cv wceq
        cF vr cv cima cF vx cv cima vn cv vr cv vx cv cF imaeq2 eleq2d imbi1d
        imbi2d albidv imbi1d imbi12d a4v cA cR wwe vr cv con0 wcel wa cF vr cv
        cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv
        cima wcel wn wa vm cv cF vr cv cima wcel vn cv vm cv cR wbr vn cv cF vr
        cv cima wcel vn cv vz cv cR wbr wi wi vn wal vm cv vz cv cR wbr wi cA
        cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral
        wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv cF cfv vm
        cv wceq vx vr cv wrex vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn cv
        vz cv cR wbr wi wi vn wal vm cv vz cv cR wbr wi vm cv cF vr cv cima
        wcel cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr
        cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv cF
        cfv vm cv wceq vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn cv vz cv
        cR wbr wi wi vn wal vm cv vz cv cR wbr wi vx vr cv cA cR wwe vr cv con0
        wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA
        wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel vx cv cF cfv vm
        cv wceq vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr
        wi wi vn wal vm cv vz cv cR wbr wi wi cA cR wwe vr cv con0 wcel wa cF
        vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF
        vr cv cima wcel wn wa wa vx cv vr cv wcel wa vx cv cF cfv vm cv wceq vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm cv wceq vn cv vm cv cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vm cv vz
        cv cR wbr wi cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vx cv cF cfv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni vm cv cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vx cv cF cfv cF vx cv cres cG cfv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cA cR wwe vr cv con0 wcel wa cF vr cv
        cima cA wss cH c0 wne vy vr cv wral wa wa vx cv vr cv wcel vx cv cF cfv
        cF vx cv cres cG cfv wceq vz cv cA wcel vz cv cF vr cv cima wcel wn wa
        cA cR wwe vr cv con0 wcel wa vx cv vr cv wcel vx cv cF cfv cF vx cv
        cres cG cfv wceq cF vr cv cima cA wss cH c0 wne vy vr cv wral wa vr cv
        con0 wcel vx cv vr cv wcel vx cv cF cfv cF vx cv cres cG cfv wceq cA cR
        wwe vr cv con0 wcel vx cv vr cv wcel wa vx cv con0 wcel vx cv cF cfv cF
        vx cv cres cG cfv wceq vr cv vx cv onelon vb vc vx cB vh cF cG
        ordtypelem.2 ordtypelem.3 tfr2 syl adantll adantlr adantlr cF vx cv
        cres cG cfv cF vx cv cres vc cv vu cv vv cv cR wbr wn vu cC wral vv cC
        crab cuni wceq vh vc copab cfv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cF vx cv cres cG vc cv vu cv vv cv cR wbr wn vu cC wral vv cC
        crab cuni wceq vh vc copab ordtypelem.6 fveq1i vh vc cF vx cv cres vu
        cv vv cv cR wbr wn vu cC wral vv cC crab cuni vu cv vv cv cR wbr wn vu
        cD wral vv cD crab cuni cF wfun vx cv cvv wcel cF vx cv cres cvv wcel
        vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfrlem7 vx visset cF vx cv
        cvv resfunexg mp2an vu cv vv cv cR wbr wn vu cD wral vv cD crab vu cv
        vv cv cR wbr wn vu cD wral vv cD cD vj cv vw cv cR wbr vj cF vx cv cima
        wral vw cA crab cvv ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv cima
        wral vw cA ordtypelem.1 rabex eqeltri rabex uniex vh cv cF vx cv cres
        wceq vu cv vv cv cR wbr wn vu cC wral vv cC crab vu cv vv cv cR wbr wn
        vu cD wral vv cD crab vh cv cF vx cv cres wceq vv cv cC wcel vu cv vv
        cv cR wbr wn vu cC wral wa vv cab vv cv cD wcel vu cv vv cv cR wbr wn
        vu cD wral wa vv cab vu cv vv cv cR wbr wn vu cC wral vv cC crab vu cv
        vv cv cR wbr wn vu cD wral vv cD crab vh cv cF vx cv cres wceq vv cv cC
        wcel vu cv vv cv cR wbr wn vu cC wral wa vv cv cD wcel vu cv vv cv cR
        wbr wn vu cD wral wa vv vh cv cF vx cv cres wceq vv cv cC wcel vv cv cD
        wcel vu cv vv cv cR wbr wn vu cC wral vu cv vv cv cR wbr wn vu cD wral
        vh cv cF vx cv cres wceq cC cD vv cv vh cv cF vx cv cres wceq vj cv vw
        cv cR wbr vj vh cv crn wral vw cA crab vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA crab cC cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr
        vj vh cv crn wral vj cv vw cv cR wbr vj cF vx cv cima wral vw cA vh cv
        cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn cF vx cv cima vh cv
        cF vx cv cres wceq vh cv crn cF vx cv cres crn cF vx cv cima vh cv cF
        vx cv cres rneq cF vx cv df-ima syl6eqr raleq1d rabbisdv ordtypelem.4
        ordtypelem.5 3eqtr4g eleq2d vh cv cF vx cv cres wceq vu cv vv cv cR wbr
        wn vu cC cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn
        wral vw cA crab vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cC
        cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn wral vj cv
        vw cv cR wbr vj cF vx cv cima wral vw cA vh cv cF vx cv cres wceq vj cv
        vw cv cR wbr vj vh cv crn cF vx cv cima vh cv cF vx cv cres wceq vh cv
        crn cF vx cv cres crn cF vx cv cima vh cv cF vx cv cres rneq cF vx cv
        df-ima syl6eqr raleq1d rabbisdv ordtypelem.4 ordtypelem.5 3eqtr4g
        raleq1d anbi12d abbidv vu cv vv cv cR wbr wn vu cC wral vv cC df-rab vu
        cv vv cv cR wbr wn vu cD wral vv cD df-rab 3eqtr4g unieqd fvopab eqtri
        syl6eq eqeq1d vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm cv
        wceq vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn
        cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni vz cv cR wbr wi vn cv vm cv cR wbr vn
        cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vm cv vz cv cR
        wbr wi cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy
        vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv
        vr cv wcel wa vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm cv
        wceq vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn
        cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vn cv vm cv cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vu cv vv
        cv cR wbr wn vu cD wral vv cD crab cuni vz cv cR wbr vm cv vz cv cR wbr
        vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm cv wceq vn cv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima
        wcel vn cv vz cv cR wbr wi wi vn cv vm cv cR wbr vn cv cF vr cv cima
        wcel vn cv vz cv cR wbr wi wi vn vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni vm cv wceq vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vn cv vm cv cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR
        wbr wi vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm cv vn cv cR
        breq2 imbi1d albidv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm
        cv vz cv cR breq1 imbi12d cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vu cv vv cv cR wbr wn vu cD wral vv
        vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni wsbc vn cv vu cv vv cv
        cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn
        cv vz cv cR wbr wi wi vn wal vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni vz cv cR wbr wi cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vu cv vv cv cR wbr wn vu cD wral vv
        cD wreu vu cv vv cv cR wbr wn vu cD wral vv vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni wsbc cA cR wwe cD cA wss cD c0 wne vu cv vv cv cR
        wbr wn vu cD wral vv cD wreu cA cR wwe vr cv con0 wcel wa cF vr cv cima
        cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vv vu cA cD cR cD vj cv vw cv cR wbr
        vj cF vx cv cima wral vw cA crab cvv ordtypelem.5 vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA ordtypelem.1 rabex eqeltri wereu cA cR wwe vr
        cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa cA
        cR wwe vz cv cA wcel vz cv cF vr cv cima wcel wn wa vx cv vr cv wcel cA
        cR wwe vr cv con0 wcel cF vr cv cima cA wss cH c0 wne vy vr cv wral wa
        simpll ad2antrr cD cA wss cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa cD vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA crab cA ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA ssrab2 eqsstri a1i cA cR wwe vr cv con0 wcel wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa wa vx cv vr cv wcel cD c0 wne cF vr cv cima cA wss
        cH c0 wne vy vr cv wral wa vx cv vr cv wcel cD c0 wne wi cA cR wwe vr
        cv con0 wcel wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa cH c0 wne
        vy vr cv wral vx cv vr cv wcel cD c0 wne wi cF vr cv cima cA wss cH c0
        wne cD c0 wne vy vx cv vr cv vy cv vx cv wceq cH cD c0 vy cv vx cv wceq
        vj cv vw cv cR wbr vj cF vy cv cima wral vw cA crab vj cv vw cv cR wbr
        vj cF vx cv cima wral vw cA crab cH cD vy cv vx cv wceq vj cv vw cv cR
        wbr vj cF vy cv cima wral vj cv vw cv cR wbr vj cF vx cv cima wral vw
        cA vy cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima cF vx cv cima
        vy cv vx cv cF imaeq2 raleq1d rabbisdv ordtypelem.7 ordtypelem.5
        3eqtr4g neeq1d rcla4cv adantl ad2antlr imp syl3anc vu cv vv cv cR wbr
        wn vu cD wral vv cD reuuni4 syl cA cR wwe vr cv con0 wcel wa cF vr cv
        cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv
        cima wcel wn wa wa vx cv vr cv wcel wa vu cv vu cv vv cv cR wbr wn vu
        cD wral vv cD crab cuni cR wbr wn vu cD wral vn cv vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz
        cv cR wbr wi wi vn wal vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni
        vz cv cR wbr wi vu cv vv cv cR wbr wn vu cD wral vv vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni wsbc cA cR wwe vr cv con0 wcel wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn
        vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv
        cR wbr wi wi vn wal vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr wn vu cD wral vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni vz cv cR wbr cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH
        c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa
        wa vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn
        wal vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn vu
        cD wral vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv cR wbr
        wi cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv
        wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv
        wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr
        vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa vu cv cD
        wcel vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn
        wi vu wal vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv cR wbr
        vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn vu cD
        wral cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr
        cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr
        cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa vu cv
        cD wcel vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr
        wn wi vu wal vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr wn vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv cR wbr vu
        cv cD wcel vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr wn wi vu wal vz cv cD wcel vz cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr wn cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr
        wi wi vn wal wa vz cv cvv wcel vu cv cD wcel vu cv vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni cR wbr wn wi vu wal vz cv cD wcel vz cv
        vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn wi wi vz
        visset vu cv cD wcel vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr wn wi vz cv cD wcel vz cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr wn wi vu vm vz cv cvv vm cv vz cv wcel vu ax-17
        vz cv cD wcel vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr wn vu vz cv cD wcel vu ax-17 vz cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr vu vu vm vz cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR vm cv vz cv wcel vu ax-17 vm cv cR wcel vu ax-17 vu
        vm vu cv vv cv cR wbr wn vu cD wral vv cD crab vu cv vv cv cR wbr wn vu
        cD wral vu vv vm cD vu cv vv cv cR wbr wn vu cD hbra1 vm cv cD wcel vu
        ax-17 hbrab hbuni hbbr hbn hbim vu cv vz cv wceq vu cv cD wcel vz cv cD
        wcel vu cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn
        vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn vu cv
        vz cv cD eleq1 vu cv vz cv wceq vu cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr vz cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cR wbr vu cv vz cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cR breq1 notbid imbi12d cla4gf ax-mp cA cR wwe vr cv con0
        wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA
        wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima
        wcel vn cv vz cv cR wbr wi wi vn wal wa vz cv cA wcel vj cv vz cv cR
        wbr vj cF vx cv cima wral wa vz cv cD wcel cA cR wwe vr cv con0 wcel wa
        cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv
        cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv
        vz cv cR wbr wi wi vn wal wa vz cv cA wcel vj cv vz cv cR wbr vj cF vx
        cv cima wral cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vz cv cA wcel vx cv vr cv wcel vn cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi
        wi vn wal cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne
        vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn simprl
        ad2antrr cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy
        vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv
        vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa vj cv
        vz cv cR wbr vj cF vx cv cima cA cR wwe vr cv con0 wcel wa cF vr cv
        cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv
        cima wcel wn wa wa vx cv vr cv wcel wa vj cv vu cv vv cv cR wbr wn vu
        cD wral vv cD crab cuni cR wbr vj cv cF vr cv cima wcel vj cv vz cv cR
        wbr wi wi vj cv cF vx cv cima wcel vj cv vz cv cR wbr wi vn cv vu cv vv
        cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel
        vn cv vz cv cR wbr wi wi vn wal cA cR wwe vr cv con0 wcel wa cF vr cv
        cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv
        cima wcel wn wa wa vx cv vr cv wcel wa vj cv vu cv vv cv cR wbr wn vu
        cD wral vv cD crab cuni cR wbr vj cv cF vr cv cima wcel vj cv vz cv cR
        wbr wi wi vj cv cF vx cv cima wcel vj cv vz cv cR wbr wi cA cR wwe vr
        cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz
        cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vj cv
        cF vx cv cima wcel vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vj cv cF vr cv cima wcel vj cv vz cv cR wbr wi wi vj cv vz
        cv cR wbr cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne
        vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx
        cv vr cv wcel wa vj cv cF vx cv cima wcel vj cv vu cv vv cv cR wbr wn
        vu cD wral vv cD crab cuni cR wbr vj cv cF vr cv cima wcel vj cv vz cv
        cR wbr wi wi vj cv vz cv cR wbr wi cA cR wwe vr cv con0 wcel wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa wa vx cv vr cv wcel wa vj cv cF vx cv cima wcel wa
        vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vj cv cF
        vr cv cima wcel vj cv vz cv cR wbr wi wi vj cv vu cv vv cv cR wbr wn vu
        cD wral vv cD crab cuni cR wbr vj cv vz cv cR wbr cA cR wwe vr cv con0
        wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA
        wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vj cv cF vx
        cv cima wcel wa vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cD
        wcel vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr cA
        cR wwe cD cA wss cD c0 wne vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cD wcel cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vj cv cF vx cv cima wcel wa vv vu cA cD cR cD vj cv
        vw cv cR wbr vj cF vx cv cima wral vw cA crab cvv ordtypelem.5 vj cv vw
        cv cR wbr vj cF vx cv cima wral vw cA ordtypelem.1 rabex eqeltri
        wereucl cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy
        vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa cA cR
        wwe vx cv vr cv wcel vj cv cF vx cv cima wcel cA cR wwe vr cv con0 wcel
        cF vr cv cima cA wss cH c0 wne vy vr cv wral wa vz cv cA wcel vz cv cF
        vr cv cima wcel wn wa simplll ad2antrr cD cA wss cA cR wwe vr cv con0
        wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA
        wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vj cv cF vx
        cv cima wcel wa cD vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab
        cA ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv cima wral vw cA ssrab2
        eqsstri a1i cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne
        vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx
        cv vr cv wcel wa cD c0 wne vj cv cF vx cv cima wcel cA cR wwe vr cv
        con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vx cv
        vr cv wcel cD c0 wne vz cv cA wcel vz cv cF vr cv cima wcel wn wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa vx cv vr cv wcel cD c0 wne cA
        cR wwe vr cv con0 wcel wa cH c0 wne vy vr cv wral vx cv vr cv wcel cD
        c0 wne cF vr cv cima cA wss cH c0 wne vy vr cv wral vx cv vr cv wcel cD
        c0 wne cH c0 wne cD c0 wne vy vx cv vr cv vy cv vx cv wceq cH cD c0 vy
        cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima wral vw cA crab vj cv
        vw cv cR wbr vj cF vx cv cima wral vw cA crab cH cD vy cv vx cv wceq vj
        cv vw cv cR wbr vj cF vy cv cima wral vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA vy cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima cF
        vx cv cima vy cv vx cv cF imaeq2 raleq1d rabbisdv ordtypelem.7
        ordtypelem.5 3eqtr4g neeq1d rcla4cv imp adantll adantll adantlr adantr
        syl3anc cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy
        vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv
        vr cv wcel wa vj cv cF vx cv cima wcel wa vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cA wcel vj cv vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cR wbr vj cF vx cv cima wral wa vj cv vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni cR wbr vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cD wcel cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vj cv cF vx cv cima wcel wa vj cv vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vj cF vx cv cima
        wral vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni cA wcel vj cv cF vx cv
        cima wcel vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr
        vj cF vx cv cima wral vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr wi cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vj cF vx cv cima wral vj cv cF vx cv cima wcel vj cv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vj cv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cR wbr vj cF vx cv cima ra4 com12
        adantl adantld vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cD wcel
        vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA crab wcel vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cA wcel vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vj cF vx cv cima wral wa cD vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA crab vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni
        ordtypelem.5 eleq2i vj cv vw cv cR wbr vj cF vx cv cima wral vj cv vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vj cF vx cv cima
        wral vw vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cA vw cv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni wceq vj cv vw cv cR wbr vj
        cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vj cF vx cv
        cima vw cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vj cv cR
        breq2 ralbidv elrab bitri syl5ib mpd cA cR wwe vr cv con0 wcel wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa wa vx cv vr cv wcel wa vj cv cF vx cv cima wcel wa
        vj cv cF vr cv cima wcel vj cv vz cv cR wbr wi vj cv vz cv cR wbr vj cv
        vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr cA cR wwe vr cv
        con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv
        cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vj cv cF
        vx cv cima wcel wa vj cv cF vr cv cima wcel vj cv vz cv cR wbr wi vj cv
        cF vr cv cima wcel vj cv vz cv cR wbr vx cv vr cv wss vj cv cF vx cv
        cima wcel vj cv cF vr cv cima wcel cA cR wwe vr cv con0 wcel wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa wa vx cv vr cv wcel wa vx cv vr cv wss vj cv cF vx
        cv cima wcel vj cv cF vr cv cima wcel vx cv vr cv wss cF vx cv cima cF
        vr cv cima vj cv vx cv vr cv cF imass2 sseld imp vr cv con0 wcel vx cv
        vr cv wcel vx cv vr cv wss cA cR wwe vr cv con0 wcel wa cF vr cv cima
        cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vr cv con0 wcel vx cv vr cv wcel vx cv vr cv wss vr cv vx
        cv onelss imp cA cR wwe vr cv con0 wcel cF vr cv cima cA wss cH c0 wne
        vy vr cv wral wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa simpllr
        sylan sylan cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne
        vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx
        cv vr cv wcel wa vj cv cF vx cv cima wcel wa vj cv cF vr cv cima wcel
        vj cv vz cv cR wbr wi idd mpid imim2d mpid ex com23 imp vn cv vu cv vv
        cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel
        vn cv vz cv cR wbr wi wi vj cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cR wbr vj cv cF vr cv cima wcel vj cv vz cv cR wbr wi wi vn
        vj vn cv vj cv wceq vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vj cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi vj cv cF vr cv cima
        wcel vj cv vz cv cR wbr wi vn cv vj cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR breq1 vn cv vj cv wceq vn cv cF vr cv cima wcel vj
        cv cF vr cv cima wcel vn cv vz cv cR wbr vj cv vz cv cR wbr vn cv vj cv
        cF vr cv cima eleq1 vn cv vj cv vz cv cR breq1 imbi12d imbi12d a4v
        sylan2 r19.21aiv jca vz cv cD wcel vz cv vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA crab wcel vz cv cA wcel vj cv vz cv cR wbr vj cF vx cv
        cima wral wa cD vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab vz
        cv ordtypelem.5 eleq2i vj cv vw cv cR wbr vj cF vx cv cima wral vj cv
        vz cv cR wbr vj cF vx cv cima wral vw vz cv cA vw cv vz cv wceq vj cv
        vw cv cR wbr vj cv vz cv cR wbr vj cF vx cv cima vw cv vz cv vj cv cR
        breq2 ralbidv elrab bitr2i sylib syl5com cA cR wwe vr cv con0 wcel wa
        cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv
        cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv
        vz cv cR wbr wi wi vn wal wa vz cv vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cR wbr wn vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni
        vz cv cR wbr cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa
        vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn wa vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv cR wbr vu cv vv cv
        cR wbr wn vu cD wral vv cD crab cuni vz cv wceq vz cv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cR wbr wo wn cA cR wwe vr cv con0
        wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA
        wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima
        wcel vn cv vz cv cR wbr wi wi vn wal wa vz cv vu cv vv cv cR wbr wn vu
        cD wral vv cD crab cuni cR wbr wn wa vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni vz cv wceq wn vz cv vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cR wbr wn wa vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni vz cv wceq vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni
        cR wbr wo wn cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa
        vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn wa vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv wceq wn vz cv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn cA cR wwe vr cv
        con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv
        cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv
        cima wcel vn cv vz cv cR wbr wi wi vn wal wa vz cv vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni cR wbr wn wa vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni vz cv wceq vz cv cF vr cv cima wcel cA cR wwe vr
        cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz
        cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vz cv
        cF vr cv cima wcel wn vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vz
        cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn cA cR wwe
        vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa
        vz cv cA wcel vz cv cF vr cv cima wcel wn vx cv vr cv wcel simplrr
        ad2antrr cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy
        vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv
        vr cv wcel wa vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv
        wceq vz cv cF vr cv cima wcel wi vn cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi
        wi vn wal vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr
        wn vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz cv wceq vu cv vv
        cv cR wbr wn vu cD wral vv cD crab cuni cF vr cv cima wcel vz cv cF vr
        cv cima wcel cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni vz
        cv cF vr cv cima eleq1 cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni vx cv cF cfv cF vr cv cima cA cR wwe vr cv con0 wcel wa cF
        vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF
        vr cv cima wcel wn wa wa vx cv vr cv wcel wa vx cv cF cfv cF vx cv cres
        cG cfv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cA cR wwe vr cv
        con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vx cv
        vr cv wcel vx cv cF cfv cF vx cv cres cG cfv wceq vz cv cA wcel vz cv
        cF vr cv cima wcel wn wa cA cR wwe vr cv con0 wcel wa vx cv vr cv wcel
        vx cv cF cfv cF vx cv cres cG cfv wceq cF vr cv cima cA wss cH c0 wne
        vy vr cv wral wa vr cv con0 wcel vx cv vr cv wcel vx cv cF cfv cF vx cv
        cres cG cfv wceq cA cR wwe vr cv con0 wcel vx cv vr cv wcel wa vx cv
        con0 wcel vx cv cF cfv cF vx cv cres cG cfv wceq vr cv vx cv onelon vb
        vc vx cB vh cF cG ordtypelem.2 ordtypelem.3 tfr2 syl adantll adantlr
        adantlr cF vx cv cres cG cfv cF vx cv cres vc cv vu cv vv cv cR wbr wn
        vu cC wral vv cC crab cuni wceq vh vc copab cfv vu cv vv cv cR wbr wn
        vu cD wral vv cD crab cuni cF vx cv cres cG vc cv vu cv vv cv cR wbr wn
        vu cC wral vv cC crab cuni wceq vh vc copab ordtypelem.6 fveq1i vh vc
        cF vx cv cres vu cv vv cv cR wbr wn vu cC wral vv cC crab cuni vu cv vv
        cv cR wbr wn vu cD wral vv cD crab cuni cF wfun vx cv cvv wcel cF vx cv
        cres cvv wcel vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfrlem7 vx
        visset cF vx cv cvv resfunexg mp2an vu cv vv cv cR wbr wn vu cD wral vv
        cD crab vu cv vv cv cR wbr wn vu cD wral vv cD cD vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA crab cvv ordtypelem.5 vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA ordtypelem.1 rabex eqeltri rabex uniex vh cv cF
        vx cv cres wceq vu cv vv cv cR wbr wn vu cC wral vv cC crab vu cv vv cv
        cR wbr wn vu cD wral vv cD crab vh cv cF vx cv cres wceq vv cv cC wcel
        vu cv vv cv cR wbr wn vu cC wral wa vv cab vv cv cD wcel vu cv vv cv cR
        wbr wn vu cD wral wa vv cab vu cv vv cv cR wbr wn vu cC wral vv cC crab
        vu cv vv cv cR wbr wn vu cD wral vv cD crab vh cv cF vx cv cres wceq vv
        cv cC wcel vu cv vv cv cR wbr wn vu cC wral wa vv cv cD wcel vu cv vv
        cv cR wbr wn vu cD wral wa vv vh cv cF vx cv cres wceq vv cv cC wcel vv
        cv cD wcel vu cv vv cv cR wbr wn vu cC wral vu cv vv cv cR wbr wn vu cD
        wral vh cv cF vx cv cres wceq cC cD vv cv vh cv cF vx cv cres wceq vj
        cv vw cv cR wbr vj vh cv crn wral vw cA crab vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA crab cC cD vh cv cF vx cv cres wceq vj cv vw cv
        cR wbr vj vh cv crn wral vj cv vw cv cR wbr vj cF vx cv cima wral vw cA
        vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn cF vx cv cima
        vh cv cF vx cv cres wceq vh cv crn cF vx cv cres crn cF vx cv cima vh
        cv cF vx cv cres rneq cF vx cv df-ima syl6eqr raleq1d rabbisdv
        ordtypelem.4 ordtypelem.5 3eqtr4g eleq2d vh cv cF vx cv cres wceq vu cv
        vv cv cR wbr wn vu cC cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj
        vh cv crn wral vw cA crab vj cv vw cv cR wbr vj cF vx cv cima wral vw
        cA crab cC cD vh cv cF vx cv cres wceq vj cv vw cv cR wbr vj vh cv crn
        wral vj cv vw cv cR wbr vj cF vx cv cima wral vw cA vh cv cF vx cv cres
        wceq vj cv vw cv cR wbr vj vh cv crn cF vx cv cima vh cv cF vx cv cres
        wceq vh cv crn cF vx cv cres crn cF vx cv cima vh cv cF vx cv cres rneq
        cF vx cv df-ima syl6eqr raleq1d rabbisdv ordtypelem.4 ordtypelem.5
        3eqtr4g raleq1d anbi12d abbidv vu cv vv cv cR wbr wn vu cC wral vv cC
        df-rab vu cv vv cv cR wbr wn vu cD wral vv cD df-rab 3eqtr4g unieqd
        fvopab eqtri syl6req cF wfun vx cv cF cdm wcel wa vx cv vr cv wcel vx
        cv cF cfv cF vr cv cima wcel cA cR wwe vr cv con0 wcel wa cF vr cv cima
        cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vr cv vx cv cF funfvima cA cR wwe vr
        cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz
        cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vx cv
        cF cdm wcel cF wfun cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss
        cH c0 wne vy vr cv wral wa wa vx cv vr cv wcel vx cv cF cdm wcel vz cv
        cA wcel vz cv cF vr cv cima wcel wn wa cA cR wwe vr cv con0 wcel wa vx
        cv vr cv wcel vx cv cF cdm wcel cF vr cv cima cA wss cH c0 wne vy vr cv
        wral wa vr cv con0 wcel vx cv vr cv wcel vx cv cF cdm wcel cA cR wwe vr
        cv con0 wcel vx cv vr cv wcel wa vx cv con0 cF cdm vr cv vx cv onelon
        cF con0 wfn cF cdm con0 wceq vb vc cB vh cF cG ordtypelem.2
        ordtypelem.3 tfr1 con0 cF fndm ax-mp syl6eleqr adantll adantlr adantlr
        vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfrlem7 jctil cA cR wwe vr
        cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz
        cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel pm3.27
        sylc eqeltrd syl5cbi ad2antrr mtod cA cR wwe vr cv con0 wcel wa cF vr
        cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn
        vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv
        cR wbr wi wi vn wal wa vz cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cR wbr wn pm3.27 jca vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni vz cv wceq vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr ioran sylibr cA cR wor vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cA wcel vz cv cA wcel vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni vz cv cR wbr vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni vz cv wceq vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni
        cR wbr wo wn wb cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa
        vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn wa cA
        cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral
        wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel
        wa cA cR wor vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vz cv vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn cA cR wwe vr cv
        con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa cA cR
        wor vz cv cA wcel vz cv cF vr cv cima wcel wn wa vx cv vr cv wcel cA cR
        wwe cA cR wor vr cv con0 wcel cF vr cv cima cA wss cH c0 wne vy vr cv
        wral wa cA cR weso ad2antrr ad2antrr ad2antrr cA cR wwe vr cv con0 wcel
        wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz
        cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv
        vz cv cR wbr wi wi vn wal wa vz cv vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cR wbr wn wa cD cA vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cD cA wss cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss
        cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn
        wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn
        wal wa vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn
        wa cD vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cA
        ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv cima wral vw cA ssrab2
        eqsstri a1i cA cR wwe cD cA wss cD c0 wne vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cD wcel cA cR wwe vr cv con0 wcel wa cF vr cv cima
        cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima
        wcel wn wa wa vx cv vr cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr
        wi wi vn wal wa vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni
        cR wbr wn wa vv vu cA cD cR cD vj cv vw cv cR wbr vj cF vx cv cima wral
        vw cA crab cvv ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv cima wral vw
        cA ordtypelem.1 rabex eqeltri wereucl cA cR wwe vr cv con0 wcel wa cF
        vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz cv cF
        vr cv cima wcel wn wa wa vx cv vr cv wcel wa cA cR wwe vn cv vu cv vv
        cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel
        vn cv vz cv cR wbr wi wi vn wal vz cv vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cR wbr wn cA cR wwe vr cv con0 wcel wa cF vr cv cima cA
        wss cH c0 wne vy vr cv wral wa wa cA cR wwe vz cv cA wcel vz cv cF vr
        cv cima wcel wn wa vx cv vr cv wcel cA cR wwe vr cv con0 wcel cF vr cv
        cima cA wss cH c0 wne vy vr cv wral wa simpll ad2antrr ad2antrr cD cA
        wss cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr
        cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr
        cv wcel wa vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal wa vz cv
        vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr wn wa cD vj cv
        vw cv cR wbr vj cF vx cv cima wral vw cA crab cA ordtypelem.5 vj cv vw
        cv cR wbr vj cF vx cv cima wral vw cA ssrab2 eqsstri a1i cA cR wwe vr
        cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz
        cv cA wcel vz cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel wa cD c0
        wne vn cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR wbr vn cv
        cF vr cv cima wcel vn cv vz cv cR wbr wi wi vn wal vz cv vu cv vv cv cR
        wbr wn vu cD wral vv cD crab cuni cR wbr wn cA cR wwe vr cv con0 wcel
        wa cF vr cv cima cA wss cH c0 wne vy vr cv wral wa wa vz cv cA wcel vz
        cv cF vr cv cima wcel wn wa wa vx cv vr cv wcel cD c0 wne cF vr cv cima
        cA wss cH c0 wne vy vr cv wral wa vx cv vr cv wcel cD c0 wne wi cA cR
        wwe vr cv con0 wcel wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa cH
        c0 wne vy vr cv wral vx cv vr cv wcel cD c0 wne wi cF vr cv cima cA wss
        cH c0 wne cD c0 wne vy vx cv vr cv vy cv vx cv wceq cH cD c0 vy cv vx
        cv wceq vj cv vw cv cR wbr vj cF vy cv cima wral vw cA crab vj cv vw cv
        cR wbr vj cF vx cv cima wral vw cA crab cH cD vy cv vx cv wceq vj cv vw
        cv cR wbr vj cF vy cv cima wral vj cv vw cv cR wbr vj cF vx cv cima
        wral vw cA vy cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima cF vx
        cv cima vy cv vx cv cF imaeq2 raleq1d rabbisdv ordtypelem.7
        ordtypelem.5 3eqtr4g neeq1d rcla4cv adantl ad2antlr imp ad2antrr
        syl3anc sseldd cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0
        wne vy vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn wa wa
        vx cv vr cv wcel wa vz cv cA wcel vn cv vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cR wbr vn cv cF vr cv cima wcel vn cv vz cv cR wbr
        wi wi vn wal vz cv vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni cR
        wbr wn cA cR wwe vr cv con0 wcel wa cF vr cv cima cA wss cH c0 wne vy
        vr cv wral wa wa vz cv cA wcel vz cv cF vr cv cima wcel wn vx cv vr cv
        wcel simplrl ad2antrr cA vu cv vv cv cR wbr wn vu cD wral vv cD crab
        cuni vz cv cR sotric sylan32c mpbird ex syld vu cv vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni cR wbr wn vu cD df-ral syl5ib ex com23 vu
        cv vv cv cR wbr wn vu cD wral vv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni wsbc vu cv vw cv cR wbr wn vu cD wral vw vu cv vv cv cR wbr
        wn vu cD wral vv cD crab cuni wsbc vu cv vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cR wbr wn vu cD wral vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cvv wcel vu cv vv cv cR wbr wn vu cD wral vv vu cv
        vv cv cR wbr wn vu cD wral vv cD crab cuni wsbc vu cv vw cv cR wbr wn
        vu cD wral vw vu cv vv cv cR wbr wn vu cD wral vv cD crab cuni wsbc wb
        vu cv vv cv cR wbr wn vu cD wral vv cD crab vu cv vv cv cR wbr wn vu cD
        wral vv cD cD vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cvv
        ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv cima wral vw cA
        ordtypelem.1 rabex eqeltri rabex uniex vu cv vv cv cR wbr wn vu cD wral
        vu cv vw cv cR wbr wn vu cD wral vv vw vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni cvv vu cv vv cv cR wbr wn vu cD wral vw ax-17 vu cv vw
        cv cR wbr wn vu cD wral vv ax-17 vv cv vw cv wceq vu cv vv cv cR wbr wn
        vu cv vw cv cR wbr wn vu cD vv cv vw cv wceq vu cv vv cv cR wbr vu cv
        vw cv cR wbr vv cv vw cv vu cv cR breq2 notbid ralbidv cbvsbc ax-mp vu
        cv vw cv cR wbr wn vu cD wral vu cv vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni cR wbr wn vu cD wral vw vu cv vv cv cR wbr wn vu cD wral
        vv cD crab cuni vu cv vv cv cR wbr wn vu cD wral vv cD crab vu cv vv cv
        cR wbr wn vu cD wral vv cD cD vj cv vw cv cR wbr vj cF vx cv cima wral
        vw cA crab cvv ordtypelem.5 vj cv vw cv cR wbr vj cF vx cv cima wral vw
        cA ordtypelem.1 rabex eqeltri rabex uniex vw cv vu cv vv cv cR wbr wn
        vu cD wral vv cD crab cuni wceq vu cv vw cv cR wbr wn vu cv vu cv vv cv
        cR wbr wn vu cD wral vv cD crab cuni cR wbr wn vu cD vu vm vm vw cv vu
        cv vv cv cR wbr wn vu cD wral vv cD crab cuni vm cv vw cv wcel vu ax-17
        vu vm vu cv vv cv cR wbr wn vu cD wral vv cD crab vu cv vv cv cR wbr wn
        vu cD wral vu vv vm cD vu cv vv cv cR wbr wn vu cD hbra1 vm cv cD wcel
        vu ax-17 hbrab hbuni hbeq vw cv vu cv vv cv cR wbr wn vu cD wral vv cD
        crab cuni wceq vu cv vw cv cR wbr vu cv vu cv vv cv cR wbr wn vu cD
        wral vv cD crab cuni cR wbr vw cv vu cv vv cv cR wbr wn vu cD wral vv
        cD crab cuni vu cv cR breq2 notbid ralbid sbcie bitri syl5ib mpd
        syl5cbi sylbid ex r19.23adv cF wfun vm cv cF vr cv cima wcel vx cv cF
        cfv vm cv wceq vx vr cv wrex vb vc cB vh cF cG ordtypelem.2
        ordtypelem.3 tfrlem7 vx vm cv vr cv cF fvelima mpan syl5 impr mpg $.
        $( [20-Oct-2009] $) $( [20-Oct-2009] $)

      $( Lemma for ~ ordtype . ` F ` maps some ordinal isomorphically onto
         ` A ` . $)
      ordtypelem7 $p |- ( R We A -> E. x e. On ( F |` x ) Isom _E , R ( x , A )
      )
      $=
        cA cR wwe cD c0 wceq cH c0 wne vy vx cv wral wa vx con0 wrex vx cv cA
        cep cR cF vx cv cres wiso vx con0 wrex vx vy vw vv vu cA cB cC cD cR vh
        vj cF cG cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4
        ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem4 cA cR wwe cD c0 wceq
        cH c0 wne vy vx cv wral wa vx cv cA cep cR cF vx cv cres wiso vx con0
        cA cR wwe vx cv con0 wcel cD c0 wceq cH c0 wne vy vx cv wral wa vx cv
        cA cep cR cF vx cv cres wiso cA cR wwe vx cv con0 wcel wa cD c0 wceq cH
        c0 wne vy vx cv wral wa wa vx cv cA cF vx cv cres wf1o vy cv vz cv cep
        wbr vy cv cF vx cv cres cfv vz cv cF vx cv cres cfv cR wbr wb vz vx cv
        wral vy vx cv wral wa vx cv cA cep cR cF vx cv cres wiso cA cR wwe vx
        cv con0 wcel wa cD c0 wceq cH c0 wne vy vx cv wral wa wa vx cv cA cF vx
        cv cres wf1o vy cv vz cv cep wbr vy cv cF vx cv cres cfv vz cv cF vx cv
        cres cfv cR wbr wb vz vx cv wral vy vx cv wral cA cR wwe vx cv con0
        wcel wa cD c0 wceq cH c0 wne vy vx cv wral wa wa cF vx cv cres vx cv
        wfn cF vx cv cres ccnv wfun cF vx cv cres crn cA wceq w3a vx cv cA cF
        vx cv cres wf1o cA cR wwe vx cv con0 wcel wa cD c0 wceq cH c0 wne vy vx
        cv wral wa wa cF vx cv cres vx cv wfn cF vx cv cres ccnv wfun cF vx cv
        cres crn cA wceq vx cv con0 wcel cF vx cv cres vx cv wfn cA cR wwe cD
        c0 wceq cH c0 wne vy vx cv wral wa vx cv con0 wcel vx cv con0 wss cF vx
        cv cres vx cv wfn vx cv onss cF con0 wfn vx cv con0 wss cF vx cv cres
        vx cv wfn vb vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfr1 con0 vx cv
        cF fnssres mpan syl ad2antlr vx vy vw vv vu cA cB cC cD cR vh vj cF cG
        cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4
        ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem5 cA cR wwe vx cv con0
        wcel wa cD c0 wceq cH c0 wne vy vx cv wral wa wa cF vx cv cima cA cF vx
        cv cres crn cA cR wwe vx cv con0 wcel wa cD c0 wceq cH c0 wne vy vx cv
        wral wa wa cF vx cv cima cA wss cA cF vx cv cima wss wa cF vx cv cima
        cA wceq cA cR wwe vx cv con0 wcel wa cD c0 wceq cH c0 wne vy vx cv wral
        wa wa cF vx cv cima cA wss cA cF vx cv cima wss cA cR wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral cF vx cv cima cA wss cD c0 wceq cA cR
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vs cF vx cv cima cA
        cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vy cv cF cfv vs
        cv wceq vy vx cv wrex vs cv cA wcel vs cv cF vx cv cima wcel cA cR wwe
        vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vy cv cF cfv vs cv wceq
        vs cv cA wcel vy vx cv cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv
        wral vy cA cR wwe vx cv con0 wcel wa vy ax-17 cH c0 wne vy vx cv hbra1
        hban vs cv cA wcel vy ax-17 cA cR wwe vx cv con0 wcel wa cH c0 wne vy
        vx cv wral vy cv vx cv wcel vy cv cF cfv vs cv wceq vs cv cA wcel wi wi
        cA cR wwe vx cv con0 wcel wa vy cv vx cv wcel cH c0 wne wi vy cv vx cv
        wcel vy cv cF cfv vs cv wceq vs cv cA wcel wi wi cH c0 wne vy vx cv
        wral cA cR wwe vx cv con0 wcel wa vy cv vx cv wcel cH c0 wne vy cv cF
        cfv vs cv wceq vs cv cA wcel wi cA cR wwe vx cv con0 wcel vy cv vx cv
        wcel cH c0 wne vy cv cF cfv vs cv wceq vs cv cA wcel wi wi wi vx cv
        con0 wcel vy cv vx cv wcel cA cR wwe cH c0 wne vy cv cF cfv vs cv wceq
        vs cv cA wcel wi wi vx cv con0 wcel vy cv vx cv wcel cA cR wwe cH c0
        wne vy cv cF cfv vs cv wceq vs cv cA wcel wi vy cv cF cfv vs cv wceq vx
        cv con0 wcel vy cv vx cv wcel wa cA cR wwe cH c0 wne wa wa vs cv cA
        wcel vy cv cF cfv vs cv wceq vy cv con0 wcel cA cR wwe cH c0 wne wa vs
        cv cA wcel vx cv con0 wcel vy cv vx cv wcel wa vy cv cF cfv vs cv wceq
        vy cv cF cfv cA wcel vs cv cA wcel vy cv con0 wcel cA cR wwe cH c0 wne
        wa wa vy cv cF cfv vs cv cA eleq1 vy cv con0 wcel cA cR wwe cH c0 wne
        wa wa vy cv cF cfv cH wcel vy cv cF cfv cA wcel vy cv con0 wcel cA cR
        wwe cH c0 wne vy cv cF cfv cH wcel vy vx vw vv vu cA cB cC cH cR vh vj
        cF cG cD vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4
        ordtypelem.7 ordtypelem.6 ordtypelem.5 ordtypelem1 3expb cH cA vy cv cF
        cfv cH vj cv vw cv cR wbr vj cF vy cv cima wral vw cA crab cA
        ordtypelem.7 vj cv vw cv cR wbr vj cF vy cv cima wral vw cA ssrab2
        eqsstri sseli syl syl5bi vx cv vy cv onelon sylani com12 exp43 com3r
        imp a2d cH c0 wne vy vx cv ra4 syl5 imp r19.23ad cF wfun vs cv cF vx cv
        cima wcel vy cv cF cfv vs cv wceq vy vx cv wrex vb vc cB vh cF cG
        ordtypelem.2 ordtypelem.3 tfrlem7 vy vs cv vx cv cF fvelima mpan syl5
        ssrdv adantrl cA cR wwe vx cv con0 wcel wa cD c0 wceq cH c0 wne vy vx
        cv wral wa cF vx cv cima cA wss cA cF vx cv cima wss wi cA cR wwe vx cv
        con0 wcel wa cF vx cv cima cA wss cD c0 wceq cH c0 wne vy vx cv wral wa
        cA cF vx cv cima wss cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss
        cD c0 wceq cH c0 wne vy vx cv wral wa cA cF vx cv cima wss wi cA cR wwe
        vx cv con0 wcel wa cF vx cv cima cA wss wa cD c0 wceq cH c0 wne vy vx
        cv wral cA cF vx cv cima wss cA cR wwe vx cv con0 wcel wa cF vx cv cima
        cA wss wa cH c0 wne vy vx cv wral cD c0 wceq cA cF vx cv cima wss cA cR
        wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral cD
        c0 wceq cA cF vx cv cima wss wi cA cR wwe vx cv con0 wcel wa cF vx cv
        cima cA wss cH c0 wne vy vx cv wral wa wa cA cF vx cv cima wss cD c0
        wceq cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx
        cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vz wex cD c0
        wceq wn cA cF vx cv cima wss wn cA cR wwe vx cv con0 wcel wa cF vx cv
        cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv
        cima wcel wn wa vz wex vn cv vm cv cR wbr wn vn vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA crab wral vm vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA crab crab cuni cD wcel cD c0 wceq wn cA cR wwe vx cv
        con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa vz cv cA
        wcel vz cv cF vx cv cima wcel wn wa vz wex vn cv vm cv cR wbr wn vn vj
        cv vw cv cR wbr vj cF vx cv cima wral vw cA crab wral vm vj cv vw cv cR
        wbr vj cF vx cv cima wral vw cA crab crab cuni cD wcel cA cR wwe vx cv
        con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa vz cv cA
        wcel vz cv cF vx cv cima wcel wn wa vz wex wa wa vn cv vm cv cR wbr wn
        vn vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab wral vm vj cv vw
        cv cR wbr vj cF vx cv cima wral vw cA crab crab cuni vj cv vw cv cR wbr
        vj cF vx cv cima wral vw cA crab cD cA cR wwe vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA crab cA wss vj cv vw cv cR wbr vj cF vx cv cima
        wral vw cA crab c0 wne vn cv vm cv cR wbr wn vn vj cv vw cv cR wbr vj
        cF vx cv cima wral vw cA crab wral vm vj cv vw cv cR wbr vj cF vx cv
        cima wral vw cA crab crab cuni vj cv vw cv cR wbr vj cF vx cv cima wral
        vw cA crab wcel cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0
        wne vy vx cv wral wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vz
        wex wa wa vm vn cA vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab
        cR vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab cA ordtypelem.1
        vj cv vw cv cR wbr vj cF vx cv cima wral vw cA ssrab2 ssexi wereucl cA
        cR wwe vx cv con0 wcel cF vx cv cima cA wss cH c0 wne vy vx cv wral wa
        vz cv cA wcel vz cv cF vx cv cima wcel wn wa vz wex wa simpll vj cv vw
        cv cR wbr vj cF vx cv cima wral vw cA crab cA wss cA cR wwe vx cv con0
        wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa vz cv cA wcel
        vz cv cF vx cv cima wcel wn wa vz wex wa wa vj cv vw cv cR wbr vj cF vx
        cv cima wral vw cA ssrab2 a1i cA cR wwe vx cv con0 wcel wa cF vx cv
        cima cA wss cH c0 wne vy vx cv wral wa vz cv cA wcel vz cv cF vx cv
        cima wcel wn wa vz wex vj cv vw cv cR wbr vj cF vx cv cima wral vw cA
        crab c0 wne cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne
        vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vj cv
        vw cv cR wbr vj cF vx cv cima wral vw cA crab c0 wne vz cA cR wwe vx cv
        con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv
        cA wcel vz cv cF vx cv cima wcel wn wa vz cv vj cv vw cv cR wbr vj cF
        vx cv cima wral vw cA crab wcel vj cv vw cv cR wbr vj cF vx cv cima
        wral vw cA crab c0 wne cA cR wwe vx cv con0 wcel wa cF vx cv cima cA
        wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima
        wcel wn wa vz cv cA wcel vj cv vz cv cR wbr vj cF vx cv cima wral wa vz
        cv vj cv vw cv cR wbr vj cF vx cv cima wral vw cA crab wcel cA cR wwe
        vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa
        vz cv cA wcel vz cv cF vx cv cima wcel wn wa vz cv cA wcel vj cv vz cv
        cR wbr vj cF vx cv cima wral vz cv cA wcel vz cv cF vx cv cima wcel wn
        wa vz cv cA wcel wi cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss
        cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn
        pm3.26 a1i cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne
        vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vj cv
        vz cv cR wbr vj cF vx cv cima wral cA cR wwe vx cv con0 wcel wa cF vx
        cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx
        cv cima wcel wn wa wa vj cv vz cv cR wbr vj cF vx cv cima wral vn cv vm
        cv cR wbr wn vn vj cv vz cv cR wbr wn vj cF vx cv cima crab wral vm vj
        cv vz cv cR wbr wn vj cF vx cv cima crab wrex cA cR wwe vx cv con0 wcel
        wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz
        cv cF vx cv cima wcel wn wa wa vn cv vm cv cR wbr vn cv vj cv vz cv cR
        wbr wn vj cF vx cv cima crab wcel wn wi vn wal wn vm vj cv vz cv cR wbr
        wn vj cF vx cv cima crab wral vn cv vm cv cR wbr wn vn vj cv vz cv cR
        wbr wn vj cF vx cv cima crab wral vm vj cv vz cv cR wbr wn vj cF vx cv
        cima crab wrex wn cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH
        c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa
        wa vn cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn vj cF vx cv cima crab
        wcel wn wi vn wal wn vm vj cv vz cv cR wbr wn vj cF vx cv cima crab cA
        cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral
        wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa wa vm cv cF vx cv
        cima wcel vm cv vz cv cR wbr wn wa vn cv vm cv cR wbr vn cv vj cv vz cv
        cR wbr wn vj cF vx cv cima crab wcel wn wi vn wal wn vm cv vj cv vz cv
        cR wbr wn vj cF vx cv cima crab wcel cA cR wwe vx cv con0 wcel wa cF vx
        cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx
        cv cima wcel wn wa wa vm cv cF vx cv cima wcel vm cv vz cv cR wbr wn vn
        cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn vj cF vx cv cima crab wcel
        wn wi vn wal wn cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0
        wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vm
        cv cF vx cv cima wcel vm cv vz cv cR wbr wn vn cv vm cv cR wbr vn cv vj
        cv vz cv cR wbr wn vj cF vx cv cima crab wcel wn wi vn wal wn wi cA cR
        wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa
        wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa vm cv cF vx cv cima
        wcel wa wa vn cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn vj cF vx cv
        cima crab wcel wn wi vn wal vm cv vz cv cR wbr cA cR wwe vx cv con0
        wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA
        wcel vz cv cF vx cv cima wcel wn wa vm cv cF vx cv cima wcel wa wa vn
        cv vm cv cR wbr vn cv cF vx cv cima wcel vn cv vz cv cR wbr wi wi vn
        wal vm cv vz cv cR wbr vn cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn
        vj cF vx cv cima crab wcel wn wi vn wal vx vy vz vw vv vu cA cB cC cD
        cR vh vj vm vn cF cG cH vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3
        ordtypelem.4 ordtypelem.5 ordtypelem.6 ordtypelem.7 ordtypelem6 vn cv
        vm cv cR wbr vn cv vj cv vz cv cR wbr wn vj cF vx cv cima crab wcel wn
        wi vn cv vm cv cR wbr vn cv cF vx cv cima wcel vn cv vz cv cR wbr wi wi
        vn vn cv vj cv vz cv cR wbr wn vj cF vx cv cima crab wcel wn vn cv cF
        vx cv cima wcel vn cv vz cv cR wbr wi vn cv vm cv cR wbr vn cv vj cv vz
        cv cR wbr wn vj cF vx cv cima crab wcel wn vn cv cF vx cv cima wcel vn
        cv vz cv cR wbr wn wa wn vn cv cF vx cv cima wcel vn cv vz cv cR wbr wi
        vn cv vj cv vz cv cR wbr wn vj cF vx cv cima crab wcel vn cv cF vx cv
        cima wcel vn cv vz cv cR wbr wn wa vj cv vz cv cR wbr wn vn cv vz cv cR
        wbr wn vj vn cv cF vx cv cima vj cv vn cv wceq vj cv vz cv cR wbr vn cv
        vz cv cR wbr vj cv vn cv vz cv cR breq1 notbid elrab notbii vn cv cF vx
        cv cima wcel vn cv vz cv cR wbr iman bitr4i imbi2i albii syl5ib con3d
        expr imp3a vj cv vz cv cR wbr wn vm cv vz cv cR wbr wn vj vm cv cF vx
        cv cima vj cv vm cv wceq vj cv vz cv cR wbr vm cv vz cv cR wbr vj cv vm
        cv vz cv cR breq1 notbid elrab syl5ib r19.21aiv vn cv vm cv cR wbr vn
        cv vj cv vz cv cR wbr wn vj cF vx cv cima crab wcel wn wi vn wal wn vm
        vj cv vz cv cR wbr wn vj cF vx cv cima crab wral vn cv vm cv cR wbr wn
        vn vj cv vz cv cR wbr wn vj cF vx cv cima crab wral wn vm vj cv vz cv
        cR wbr wn vj cF vx cv cima crab wral vn cv vm cv cR wbr wn vn vj cv vz
        cv cR wbr wn vj cF vx cv cima crab wral vm vj cv vz cv cR wbr wn vj cF
        vx cv cima crab wrex wn vn cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn
        vj cF vx cv cima crab wcel wn wi vn wal wn vn cv vm cv cR wbr wn vn vj
        cv vz cv cR wbr wn vj cF vx cv cima crab wral wn vm vj cv vz cv cR wbr
        wn vj cF vx cv cima crab vn cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn
        vj cF vx cv cima crab wcel wn wi vn wal vn cv vm cv cR wbr wn vn vj cv
        vz cv cR wbr wn vj cF vx cv cima crab wral vn cv vm cv cR wbr vn cv vj
        cv vz cv cR wbr wn vj cF vx cv cima crab wcel wn wi vn wal vn cv vj cv
        vz cv cR wbr wn vj cF vx cv cima crab wcel vn cv vm cv cR wbr wn wi vn
        wal vn cv vm cv cR wbr wn vn vj cv vz cv cR wbr wn vj cF vx cv cima
        crab wral vn cv vm cv cR wbr vn cv vj cv vz cv cR wbr wn vj cF vx cv
        cima crab wcel wn wi vn cv vj cv vz cv cR wbr wn vj cF vx cv cima crab
        wcel vn cv vm cv cR wbr wn wi vn vn cv vm cv cR wbr vn cv vj cv vz cv
        cR wbr wn vj cF vx cv cima crab wcel con2b albii vn cv vm cv cR wbr wn
        vn vj cv vz cv cR wbr wn vj cF vx cv cima crab df-ral bitr4i notbii
        ralbii vn cv vm cv cR wbr wn vn vj cv vz cv cR wbr wn vj cF vx cv cima
        crab wral vm vj cv vz cv cR wbr wn vj cF vx cv cima crab ralnex bitri
        sylib cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx
        cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa wa vj cv vz
        cv cR wbr wn vj cF vx cv cima wrex vn cv vm cv cR wbr wn vn vj cv vz cv
        cR wbr wn vj cF vx cv cima crab wral vm vj cv vz cv cR wbr wn vj cF vx
        cv cima crab wrex vj cv vz cv cR wbr vj cF vx cv cima wral wn cA cR wwe
        vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa
        vz cv cA wcel vz cv cF vx cv cima wcel wn wa wa vj cv vz cv cR wbr wn
        vj cF vx cv cima wrex vn cv vm cv cR wbr wn vn vj cv vz cv cR wbr wn vj
        cF vx cv cima crab wral vm vj cv vz cv cR wbr wn vj cF vx cv cima crab
        wrex cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx
        cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa wa vj cv vz
        cv cR wbr wn vj cF vx cv cima wrex wa vn cv vm cv cR wbr wn vn vj cv vz
        cv cR wbr wn vj cF vx cv cima crab wral vm vj cv vz cv cR wbr wn vj cF
        vx cv cima crab wreu vn cv vm cv cR wbr wn vn vj cv vz cv cR wbr wn vj
        cF vx cv cima crab wral vm vj cv vz cv cR wbr wn vj cF vx cv cima crab
        wrex cA cR wwe vj cv vz cv cR wbr wn vj cF vx cv cima crab cA wss vj cv
        vz cv cR wbr wn vj cF vx cv cima crab c0 wne vn cv vm cv cR wbr wn vn
        vj cv vz cv cR wbr wn vj cF vx cv cima crab wral vm vj cv vz cv cR wbr
        wn vj cF vx cv cima crab wreu cA cR wwe vx cv con0 wcel wa cF vx cv
        cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz cv cF vx cv
        cima wcel wn wa wa vj cv vz cv cR wbr wn vj cF vx cv cima wrex wa vm vn
        cA vj cv vz cv cR wbr wn vj cF vx cv cima crab cR vj cv vz cv cR wbr wn
        vj cF vx cv cima crab cF vx cv cima cF wfun cF vx cv cima cvv wcel vb
        vc cB vh cF cG ordtypelem.2 ordtypelem.3 tfrlem7 cF vx cv vx visset
        funimaex ax-mp vj cv vz cv cR wbr wn vj cF vx cv cima ssrab2 ssexi
        wereu cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx
        cv wral wa wa cA cR wwe vz cv cA wcel vz cv cF vx cv cima wcel wn wa vj
        cv vz cv cR wbr wn vj cF vx cv cima wrex cA cR wwe vx cv con0 wcel cF
        vx cv cima cA wss cH c0 wne vy vx cv wral wa simpll ad2antrr cA cR wwe
        vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa
        vz cv cA wcel vz cv cF vx cv cima wcel wn wa wa vj cv vz cv cR wbr wn
        vj cF vx cv cima wrex wa vj cv vz cv cR wbr wn vj cF vx cv cima crab cF
        vx cv cima cA vj cv vz cv cR wbr wn vj cF vx cv cima crab cF vx cv cima
        wss cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx
        cv wral wa wa vz cv cA wcel vz cv cF vx cv cima wcel wn wa wa vj cv vz
        cv cR wbr wn vj cF vx cv cima wrex wa vj cv vz cv cR wbr wn vj cF vx cv
        cima ssrab2 a1i cA cR wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0
        wne vy vx cv wral wa wa cF vx cv cima cA wss vz cv cA wcel vz cv cF vx
        cv cima wcel wn wa vj cv vz cv cR wbr wn vj cF vx cv cima wrex cA cR
        wwe vx cv con0 wcel wa cF vx cv cima cA wss cH c0 wne vy vx cv wral
        simprl ad2antrr sstrd vj cv vz cv cR wbr wn vj cF vx cv cima wrex vj cv
        vz cv cR wbr wn vj cF vx cv cima crab c0 wne cA cR wwe vx cv con0 wcel
        wa cF vx cv cima cA wss cH c0 wne vy vx cv wral wa wa vz cv cA wcel vz
        cv cF vx cv cima wcel wn wa wa vj cv vz cv cR wbr wn vj cv vz cv cR wbr
        wn vj cF vx cv cima crab c0 wne vj cF vx cv cima vj vm vj cv vz cv cR
        wbr wn vj cF vx cv cima crab c0 vj cv vz cv cR wbr wn vj vm cF vx cv
        cima hbrab1 vm cv c0 wcel vj ax-17 hbne vj cv cF vx cv cima wcel vj cv
        vz cv cR wbr wn vj cv vz cv cR wbr wn vj cF vx cv cima crab c0 wne vj
        cv cF vx cv cima wcel vj cv vz cv cR wbr wn wa vj cv vj cv vz cv cR wbr
        wn vj cF vx cv cima crab wcel vj cv vz cv cR wbr wn vj cF vx cv cima
        crab c0 wne vj cv vz cv cR wbr wn vj cF vx cv cima rabid vj cv vz cv cR
        wbr wn vj cF vx cv cima crab vj cv ne0i sylbir ex r19.23ai adantl
        syl3anc vn cv vm cv cR wbr wn vn vj cv vz cv cR wbr wn vj cF vx cv cima
        crab wral vm vj cv vz cv cR wbr wn vj cF vx cv cima crab reurex syl ex
        vj cv vz cv cR wbr vj cF vx cv cima rexnal syl5ibr mt3d ex jcad vj cv
        vw cv cR wbr vj cF vx cv cima wral vj cv vz cv cR wbr vj cF vx cv cima
        wral vw vz cv cA vw cv vz cv wceq vj cv vw cv cR wbr vj cv vz cv cR wbr
        vj cF vx cv cima vw cv vz cv vj cv cR breq2 ralbidv elrab syl6ibr vj cv
        vw cv cR wbr vj cF vx cv cima wral vw cA crab vz cv ne0i syl6 19.23adv
        impr syl3anc ordtypelem.5 syl6eleqr expr cD vn cv vm cv cR wbr wn vn vj
        cv vw cv cR wbr vj cF vx cv cima wral vw cA crab wral vm vj cv vw cv cR
        wbr vj cF vx cv cima wral vw cA crab crab cuni n0i syl6 vz cA cF vx cv
        cima nss syl5ib con4d expr com23 imp3a ex com23 imp jcai cF vx cv cima
        cA eqss sylibr cF vx cv df-ima syl5eqr 3jca vx cv cA cF vx cv cres
        dff1o2 sylibr cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral vy
        cv vz cv cep wbr vy cv cF vx cv cres cfv vz cv cF vx cv cres cfv cR wbr
        wb vz vx cv wral vy vx cv wral cD c0 wceq cA cR wwe vx cv con0 wcel wa
        cH c0 wne vy vx cv wral wa vy cv vz cv cep wbr vy cv cF vx cv cres cfv
        vz cv cF vx cv cres cfv cR wbr wb vz vx cv wral vy vx cv cA cR wwe vx
        cv con0 wcel wa cH c0 wne vy vx cv wral vy cA cR wwe vx cv con0 wcel wa
        vy ax-17 cH c0 wne vy vx cv hbra1 hban cA cR wwe vx cv con0 wcel wa cH
        c0 wne vy vx cv wral wa vy cv vx cv wcel vy cv vz cv cep wbr vy cv cF
        vx cv cres cfv vz cv cF vx cv cres cfv cR wbr wb vz vx cv cA cR wwe vx
        cv con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy cv vx cv
        wcel vy cv vz cv cep wbr vy cv cF vx cv cres cfv vz cv cF vx cv cres
        cfv cR wbr wb cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa
        vz cv vx cv wcel vy cv vx cv wcel wa wa vy cv vz cv wcel vy cv cF cfv
        vz cv cF cfv cR wbr vy cv vz cv cep wbr vy cv cF vx cv cres cfv vz cv
        cF vx cv cres cfv cR wbr cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx
        cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vy cv vz cv wcel vy
        cv cF cfv vz cv cF cfv cR wbr vz cv con0 wcel cA cR wwe vy vz cv cH csb
        c0 wne vy cv vz cv wcel vy cv cF cfv vz cv cF cfv cR wbr wi cA cR wwe
        vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy cv vx
        cv wcel wa wa vz cv con0 wcel cA cR wwe vx vz cv cD csb c0 wne vy cv vz
        cv wcel vy cv cF cfv vz cv cF cfv cR wbr wi vy vz cv cH csb c0 wne vz
        vy vw vv vu cA cB cC vx vz cv cD csb cR vh vj cF cG cH vb vc
        ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4 vx cv vz cv wceq cD
        vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab wceq wi vx vz cv cD
        csb vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab wceq vx vx vm
        vz cv cD vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab vz visset
        vm cv vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab wcel vx ax-17
        csbieb vx cv vz cv wceq vj cv vw cv cR wbr vj cF vx cv cima wral vw cA
        crab vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab cD vx cv vz cv
        wceq vj cv vw cv cR wbr vj cF vx cv cima wral vj cv vw cv cR wbr vj cF
        vz cv cima wral vw cA vx cv vz cv wceq vj cv vw cv cR wbr vj cF vx cv
        cima cF vz cv cima vx cv vz cv cF imaeq2 raleq1d rabbisdv ordtypelem.5
        syl5eq mpgbi ordtypelem.6 ordtypelem.7 ordtypelem2 vy vz cv cH csb vx
        vz cv cD csb c0 vz cv cvv wcel vy vz cv cH csb vx vz cv cD csb wceq vz
        visset vy vx vz cv cH cD cvv vy cv vx cv wceq vj cv vw cv cR wbr vj cF
        vy cv cima wral vw cA crab vj cv vw cv cR wbr vj cF vx cv cima wral vw
        cA crab cH cD vy cv vx cv wceq vj cv vw cv cR wbr vj cF vy cv cima wral
        vj cv vw cv cR wbr vj cF vx cv cima wral vw cA vy cv vx cv wceq vj cv
        vw cv cR wbr vj cF vy cv cima cF vx cv cima vy cv vx cv cF imaeq2
        raleq1d rabbisdv ordtypelem.7 ordtypelem.5 3eqtr4g cbvcsbv ax-mp neeq1i
        syl3an3b cA cR wwe vx cv con0 wcel wa vz cv vx cv wcel vz cv con0 wcel
        cH c0 wne vy vx cv wral vy cv vx cv wcel vx cv con0 wcel vz cv vx cv
        wcel vz cv con0 wcel cA cR wwe vx cv vz cv onelon adantll ad2ant2r cA
        cR wwe vx cv con0 wcel cH c0 wne vy vx cv wral vz cv vx cv wcel vy cv
        vx cv wcel wa simplll cH c0 wne vy vx cv wral vz cv vx cv wcel vy vz cv
        cH csb c0 wne cA cR wwe vx cv con0 wcel wa vy cv vx cv wcel vz cv vx cv
        wcel cH c0 wne vy vx cv wral vy vz cv cH csb c0 wne cH c0 wne vy vz cv
        cH csb c0 wne vy vz cv vx cv vy vm vy vz cv cH csb c0 vy vm vz cv cH vz
        visset vm cv vz cv wcel vy ax-17 hbcsb1 vm cv c0 wcel vy ax-17 hbne vy
        cv vz cv wceq cH vy vz cv cH csb c0 vy vz cv cH csbeq1a neeq1d rcla4
        impcom ad2ant2lr syl3anc cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx
        cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vy cv vz cv wceq vz
        cv vy cv wcel wo vy cv cF cfv vz cv cF cfv wceq vz cv cF cfv vy cv cF
        cfv cR wbr wo vy cv vz cv wcel wn vy cv cF cfv vz cv cF cfv cR wbr wn
        cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv
        wcel vy cv vx cv wcel wa wa vy cv vz cv wceq vy cv cF cfv vz cv cF cfv
        wceq vz cv vy cv wcel vz cv cF cfv vy cv cF cfv cR wbr vy cv vz cv wceq
        vy cv cF cfv vz cv cF cfv wceq wi cA cR wwe vx cv con0 wcel wa cH c0
        wne vy vx cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vy cv vz
        cv cF fveq2 a1i vy cv con0 wcel cA cR wwe cH c0 wne vz cv vy cv wcel vz
        cv cF cfv vy cv cF cfv cR wbr wi cA cR wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vy vz vw vv vu
        cA cB cC cH cR vh vj cF cG vx vz cv cD csb vb vc ordtypelem.1
        ordtypelem.2 ordtypelem.3 ordtypelem.4 ordtypelem.7 ordtypelem.6 vx cv
        vz cv wceq cD vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab wceq
        wi vx vz cv cD csb vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab
        wceq vx vx vm vz cv cD vj cv vw cv cR wbr vj cF vz cv cima wral vw cA
        crab vz visset vm cv vj cv vw cv cR wbr vj cF vz cv cima wral vw cA
        crab wcel vx ax-17 csbieb vx cv vz cv wceq vj cv vw cv cR wbr vj cF vx
        cv cima wral vw cA crab vj cv vw cv cR wbr vj cF vz cv cima wral vw cA
        crab cD vx cv vz cv wceq vj cv vw cv cR wbr vj cF vx cv cima wral vj cv
        vw cv cR wbr vj cF vz cv cima wral vw cA vx cv vz cv wceq vj cv vw cv
        cR wbr vj cF vx cv cima cF vz cv cima vx cv vz cv cF imaeq2 raleq1d
        rabbisdv ordtypelem.5 syl5eq mpgbi ordtypelem2 cA cR wwe vx cv con0
        wcel wa vy cv vx cv wcel vy cv con0 wcel cH c0 wne vy vx cv wral vz cv
        vx cv wcel vx cv con0 wcel vy cv vx cv wcel vy cv con0 wcel cA cR wwe
        vx cv vy cv onelon adantll ad2ant2rl cA cR wwe vx cv con0 wcel cH c0
        wne vy vx cv wral vz cv vx cv wcel vy cv vx cv wcel wa simplll cH c0
        wne vy vx cv wral vy cv vx cv wcel cH c0 wne cA cR wwe vx cv con0 wcel
        wa vz cv vx cv wcel cH c0 wne vy vx cv wral vy cv vx cv wcel cH c0 wne
        cH c0 wne vy vx cv ra4 imp ad2ant2l syl3anc orim12d vy cv word vz cv
        word vy cv vz cv wceq vz cv vy cv wcel wo vy cv vz cv wcel wn wb cA cR
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy
        cv vx cv wcel wa wa vy cv word vz cv word wa vy cv vz cv wcel vy cv vz
        cv wceq vz cv vy cv wcel wo vy cv vz cv ordtri2 con2bid cA cR wwe vx cv
        con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy cv vx cv
        wcel wa wa vy cv con0 wcel vy cv word cA cR wwe vx cv con0 wcel wa vy
        cv vx cv wcel vy cv con0 wcel cH c0 wne vy vx cv wral vz cv vx cv wcel
        vx cv con0 wcel vy cv vx cv wcel vy cv con0 wcel cA cR wwe vx cv vy cv
        onelon adantll ad2ant2rl vy cv eloni syl cA cR wwe vx cv con0 wcel wa
        cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vz
        cv con0 wcel vz cv word cA cR wwe vx cv con0 wcel wa vz cv vx cv wcel
        vz cv con0 wcel cH c0 wne vy vx cv wral vy cv vx cv wcel vx cv con0
        wcel vz cv vx cv wcel vz cv con0 wcel cA cR wwe vx cv vz cv onelon
        adantll ad2ant2r vz cv eloni syl sylanc cA cR wor vy cv cF cfv cA wcel
        vz cv cF cfv cA wcel vy cv cF cfv vz cv cF cfv wceq vz cv cF cfv vy cv
        cF cfv cR wbr wo vy cv cF cfv vz cv cF cfv cR wbr wn wb cA cR wwe vx cv
        con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy cv vx cv
        wcel wa wa cA cR wwe vx cv con0 wcel wa cA cR wor cH c0 wne vy vx cv
        wral vz cv vx cv wcel vy cv vx cv wcel wa cA cR wwe cA cR wor vx cv
        con0 wcel cA cR weso adantr ad2antrr cA cR wwe vx cv con0 wcel wa cH c0
        wne vy vx cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa cH cA vy
        cv cF cfv cH cA wss cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv
        wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa cH vj cv vw cv cR wbr
        vj cF vy cv cima wral vw cA crab cA ordtypelem.7 vj cv vw cv cR wbr vj
        cF vy cv cima wral vw cA ssrab2 eqsstri a1i vy cv con0 wcel cA cR wwe
        cH c0 wne vy cv cF cfv cH wcel cA cR wwe vx cv con0 wcel wa cH c0 wne
        vy vx cv wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vy vx vw vv vu
        cA cB cC cH cR vh vj cF cG cD vb vc ordtypelem.1 ordtypelem.2
        ordtypelem.3 ordtypelem.4 ordtypelem.7 ordtypelem.6 ordtypelem.5
        ordtypelem1 cA cR wwe vx cv con0 wcel wa vy cv vx cv wcel vy cv con0
        wcel cH c0 wne vy vx cv wral vz cv vx cv wcel vx cv con0 wcel vy cv vx
        cv wcel vy cv con0 wcel cA cR wwe vx cv vy cv onelon adantll ad2ant2rl
        cA cR wwe vx cv con0 wcel cH c0 wne vy vx cv wral vz cv vx cv wcel vy
        cv vx cv wcel wa simplll cH c0 wne vy vx cv wral vy cv vx cv wcel cH c0
        wne cA cR wwe vx cv con0 wcel wa vz cv vx cv wcel cH c0 wne vy vx cv
        wral vy cv vx cv wcel cH c0 wne cH c0 wne vy vx cv ra4 imp ad2ant2l
        syl3anc sseldd cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa
        vz cv vx cv wcel vy cv vx cv wcel wa wa vy vz cv cH csb cA vz cv cF cfv
        vy vz cv cH csb cA wss cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv
        wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa cH cA wss vy vz cv cH
        csb cA wss vy vz vy vm vy vz cv cH csb cA vy vm vz cv cH vz visset vm
        cv vz cv wcel vy ax-17 hbcsb1 vm cv cA wcel vy ax-17 hbss vy cv vz cv
        wceq cH vy vz cv cH csb cA vy vz cv cH csbeq1a sseq1d cH vj cv vw cv cR
        wbr vj cF vy cv cima wral vw cA crab cA ordtypelem.7 vj cv vw cv cR wbr
        vj cF vy cv cima wral vw cA ssrab2 eqsstri chvar a1i vz cv con0 wcel cA
        cR wwe vy vz cv cH csb c0 wne vz cv cF cfv vy vz cv cH csb wcel cA cR
        wwe vx cv con0 wcel wa cH c0 wne vy vx cv wral wa vz cv vx cv wcel vy
        cv vx cv wcel wa wa vz vx vw vv vu cA cB cC vy vz cv cH csb cR vh vj cF
        cG cD vb vc ordtypelem.1 ordtypelem.2 ordtypelem.3 ordtypelem.4 vy cv
        vz cv wceq cH vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab wceq
        wi vy vz cv cH csb vj cv vw cv cR wbr vj cF vz cv cima wral vw cA crab
        wceq vy vy vm vz cv cH vj cv vw cv cR wbr vj cF vz cv cima wral vw cA
        crab vz visset vm cv vj cv vw cv cR wbr vj cF vz cv cima wral vw cA
        crab wcel vy ax-17 csbieb vy cv vz cv wceq vj cv vw cv cR wbr vj cF vy
        cv cima wral vw cA crab vj cv vw cv cR wbr vj cF vz cv cima wral vw cA
        crab cH vy cv vz cv wceq vj cv vw cv cR wbr vj cF vy cv cima wral vj cv
        vw cv cR wbr vj cF vz cv cima wral vw cA vy cv vz cv wceq vj cv vw cv
        cR wbr vj cF vy cv cima cF vz cv cima vy cv vz cv cF imaeq2 raleq1d
        rabbisdv ordtypelem.7 syl5eq mpgbi ordtypelem.6 ordtypelem.5
        ordtypelem1 cA cR wwe vx cv con0 wcel wa vz cv vx cv wcel vz cv con0
        wcel cH c0 wne vy vx cv wral vy cv vx cv wcel vx cv con0 wcel vz cv vx
        cv wcel vz cv con0 wcel cA cR wwe vx cv vz cv onelon adantll ad2ant2r
        cA cR wwe vx cv con0 wcel cH c0 wne vy vx cv wral vz cv vx cv wcel vy
        cv vx cv wcel wa simplll cH c0 wne vy vx cv wral vz cv vx cv wcel vy vz
        cv cH csb c0 wne cA cR wwe vx cv con0 wcel wa vy cv vx cv wcel vz cv vx
        cv wcel cH c0 wne vy vx cv wral vy vz cv cH csb c0 wne cH c0 wne vy vz
        cv cH csb c0 wne vy vz cv vx cv vy vm vy vz cv cH csb c0 vy vm vz cv cH
        vz visset vm cv vz cv wcel vy ax-17 hbcsb1 vm cv c0 wcel vy ax-17 hbne
        vy cv vz cv wceq cH vy vz cv cH csb c0 vy vz cv cH csbeq1a neeq1d rcla4
        impcom ad2ant2lr syl3anc sseldd cA cR wor vy cv cF cfv cA wcel vz cv cF
        cfv cA wcel wa wa vy cv cF cfv vz cv cF cfv cR wbr vy cv cF cfv vz cv
        cF cfv wceq vz cv cF cfv vy cv cF cfv cR wbr wo cA vy cv cF cfv vz cv
        cF cfv cR sotric con2bid sylan32c 3imtr3d impbid3 vy cv vz cv cep wbr
        vy cv vz cv wcel wb cA cR wwe vx cv con0 wcel wa cH c0 wne vy vx cv
        wral wa vz cv vx cv wcel vy cv vx cv wcel wa wa vy vz epel a1i vz cv vx
        cv wcel vy cv vx cv wcel wa vy cv cF vx cv cres cfv vz cv cF vx cv cres
        cfv cR wbr vy cv cF cfv vz cv cF cfv cR wbr wb cA cR wwe vx cv con0
        wcel wa cH c0 wne vy vx cv wral wa vy cv vx cv wcel vz cv vx cv wcel vy
        cv cF vx cv cres cfv vy cv cF cfv vz cv cF vx cv cres cfv vz cv cF cfv
        cR vy cv vx cv cF fvres vz cv vx cv cF fvres breqan12rd adantl 3bitr4d
        expr r19.21adva r19.21ai adantrl jca vy vz vx cv cA cep cR cF vx cv
        cres df-iso sylibr exp31 r19.22dv mpd $.
        $( [20-Oct-2009] $) $( [17-Oct-2009] $)
    $}

    $( For any well-ordered set, there is an isomorphic ordinal number called
       its order type. $)
    ordtype $p |- ( ( A e. B /\ R We A ) -> E! x e. On E. f f Isom _E , R ( x
    , A ) ) $=
      cA cB wcel cA cR wwe wa vx cv cA cep cR vf cv wiso vf wex vx con0 wrex vx
      cv cA cep cR vf cv wiso vf wex vy cv cA cep cR vf cv wiso vf wex wa vx cv
      vy cv wceq wi vy con0 wral vx con0 wral wa vx cv cA cep cR vf cv wiso vf
      wex vx con0 wreu cA cB wcel cA cR wwe wa vx cv cA cep cR vf cv wiso vf
      wex vx con0 wrex vx cv cA cep cR vf cv wiso vf wex vy cv cA cep cR vf cv
      wiso vf wex wa vx cv vy cv wceq wi vy con0 wral vx con0 wral cA cB wcel
      cA cR wwe vx cv cA cep cR vf cv wiso vf wex vx con0 wrex va cv cR wwe vx
      cv va cv cep cR vf cv wiso vf wex vx con0 wrex wi cA cR wwe vx cv cA cep
      cR vf cv wiso vf wex vx con0 wrex wi va cA cB va cv cA wceq va cv cR wwe
      cA cR wwe vx cv va cv cep cR vf cv wiso vf wex vx con0 wrex vx cv cA cep
      cR vf cv wiso vf wex vx con0 wrex va cv cA cR weeq2 va cv cA wceq vx cv
      va cv cep cR vf cv wiso vf wex vx cv cA cep cR vf cv wiso vf wex vx con0
      va cv cA wceq vx cv va cv cep cR vf cv wiso vx cv cA cep cR vf cv wiso vf
      vx cv va cv cA cep cR vf cv isoeq5 exbidv rexbidv imbi12d va cv cR wwe vx
      cv va cv cep cR vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm
      cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq
      vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vx cv cres
      wiso vx con0 wrex vx cv va cv cep cR vf cv wiso vf wex vx con0 wrex vx vy
      vw vv vu va cv vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm
      cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq
      vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab vk cv vz cv cR
      wbr vk vh cv crn wral vz va cv crab vb cv vp cv cR wbr vb vg cv vr cv wfn
      vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz
      cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk
      vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vx cv cima wral vp va cv crab cR vh vj
      vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr
      wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz
      cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv
      wceq vs vr cv wral wa vr con0 wrex vg cab cuni vo cv vm cv vn cv cR wbr
      wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz
      cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab vb
      cv vp cv cR wbr vb vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv
      vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni
      wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vy cv
      cima wral vp va cv crab vb vc va visset vr vs vb vc vg vh vo cv vm cv vn
      cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral
      vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq
      vo copab rdglem1 vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv
      vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni
      wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni eqid
      vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab vj cv vz cv cR wbr vj
      vh cv crn wral vz va cv crab vj cv vw cv cR wbr vj vh cv crn wral vw va
      cv crab vk cv vz cv cR wbr vk vh cv crn wral vj cv vz cv cR wbr vj vh cv
      crn wral vz va cv vk cv vz cv cR wbr vk vh cv crn wral vj cv vz cv cR wbr
      vj vh cv crn wral wb vz cv va cv wcel vk cv vz cv cR wbr vj cv vz cv cR
      wbr vk vj vh cv crn vk cv vj cv vz cv cR breq1 cbvralv a1i rabbii vj cv
      vz cv cR wbr vj vh cv crn wral vj cv vw cv cR wbr vj vh cv crn wral vz vw
      va cv vz cv vw cv wceq vj cv vz cv cR wbr vj cv vw cv cR wbr vj vh cv crn
      vz cv vw cv vj cv cR breq2 ralbidv cbvrabv eqtri vb cv vp cv cR wbr vb vg
      cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn
      vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv
      wceq vs vr cv wral wa vr con0 wrex vg cab cuni vx cv cima wral vp va cv
      crab vj cv vp cv cR wbr vj vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv
      cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral
      vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab
      cuni vx cv cima wral vp va cv crab vj cv vw cv cR wbr vj vg cv vr cv wfn
      vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz
      cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk
      vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vx cv cima wral vw va cv crab vb cv vp
      cv cR wbr vb vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv
      vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq
      vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vx cv cima
      wral vj cv vp cv cR wbr vj vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv
      cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral
      vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab
      cuni vx cv cima wral vp va cv vb cv vp cv cR wbr vb vg cv vr cv wfn vs cv
      vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR
      wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral
      wa vr con0 wrex vg cab cuni vx cv cima wral vj cv vp cv cR wbr vj vg cv
      vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm
      vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR
      wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq
      vs vr cv wral wa vr con0 wrex vg cab cuni vx cv cima wral wb vp cv va cv
      wcel vb cv vp cv cR wbr vj cv vp cv cR wbr vb vj vg cv vr cv wfn vs cv vg
      cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa
      vr con0 wrex vg cab cuni vx cv cima vb cv vj cv vp cv cR breq1 cbvralv
      a1i rabbii vj cv vp cv cR wbr vj vg cv vr cv wfn vs cv vg cv cfv vg cv vs
      cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg
      cab cuni vx cv cima wral vj cv vw cv cR wbr vj vg cv vr cv wfn vs cv vg
      cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa
      vr con0 wrex vg cab cuni vx cv cima wral vp vw va cv vp cv vw cv wceq vj
      cv vp cv cR wbr vj cv vw cv cR wbr vj vg cv vr cv wfn vs cv vg cv cfv vg
      cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex
      vg cab cuni vx cv cima vp cv vw cv vj cv cR breq2 ralbidv cbvrabv eqtri
      vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab
      cuni wceq vq vo copab vo cv vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab crab cuni wceq vq vo copab vc cv vu cv vv cv cR wbr wn
      vu vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab wral vv vk cv vz cv
      cR wbr vk vh cv crn wral vz va cv crab crab cuni wceq vh vc copab vo cv
      vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni
      wceq vo cv vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral
      vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      crab cuni wceq vq vo vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab crab cuni vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab crab cuni vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz
      va cv crab crab vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab crab vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral
      vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      crab vu cv vn cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab
      vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab vm
      cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vu cv vn cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab vm cv
      vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vu cv vn cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab wral wb vn cv vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wcel vm cv vn cv cR wbr wn vu cv vn cv cR wbr wn vm vu vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab vm cv vu cv wceq vm cv vn cv cR wbr vu cv
      vn cv cR wbr vm cv vu cv vn cv cR breq1 notbid cbvralv a1i rabbii vu cv
      vn cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab wral vn vv vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab vn
      cv vv cv wceq vu cv vn cv cR wbr wn vu cv vv cv cR wbr wn vu vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab vn cv vv cv wceq vu cv vn cv cR
      wbr vu cv vv cv cR wbr vn cv vv cv vu cv cR breq2 notbid ralbidv cbvrabv
      eqtri unieqi eqeq2i opabbii vo cv vu cv vv cv cR wbr wn vu vk cv vz cv cR
      wbr vk vq cv crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab crab cuni wceq vc cv vu cv vv cv cR wbr wn vu vk
      cv vz cv cR wbr vk vh cv crn wral vz va cv crab wral vv vk cv vz cv cR
      wbr vk vh cv crn wral vz va cv crab crab cuni wceq vq vo vh vc vq cv vh
      cv wceq vo cv vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab crab cuni wceq vo cv vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk
      vh cv crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vh cv crn wral
      vz va cv crab crab cuni wceq vo cv vc cv wceq vc cv vu cv vv cv cR wbr wn
      vu vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab wral vv vk cv vz cv
      cR wbr vk vh cv crn wral vz va cv crab crab cuni wceq vq cv vh cv wceq vu
      cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni vu
      cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab
      wral vv vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab crab cuni vo
      cv vq cv vh cv wceq vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab crab vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vh cv crn
      wral vz va cv crab wral vv vk cv vz cv cR wbr vk vh cv crn wral vz va cv
      crab crab vq cv vh cv wceq vv cv vk cv vz cv cR wbr vk vq cv crn wral vz
      va cv crab wcel vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab wral wa vv cab vv cv vk cv vz cv cR wbr vk vh cv crn
      wral vz va cv crab wcel vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vh
      cv crn wral vz va cv crab wral wa vv cab vu cv vv cv cR wbr wn vu vk cv
      vz cv cR wbr vk vq cv crn wral vz va cv crab wral vv vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab crab vu cv vv cv cR wbr wn vu vk cv vz cv
      cR wbr vk vh cv crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vh
      cv crn wral vz va cv crab crab vq cv vh cv wceq vv cv vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab wcel vu cv vv cv cR wbr wn vu vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab wral wa vv cv vk cv vz cv cR wbr
      vk vh cv crn wral vz va cv crab wcel vu cv vv cv cR wbr wn vu vk cv vz cv
      cR wbr vk vh cv crn wral vz va cv crab wral wa vv vq cv vh cv wceq vv cv
      vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wcel vv cv vk cv vz cv
      cR wbr vk vh cv crn wral vz va cv crab wcel vu cv vv cv cR wbr wn vu vk
      cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vu cv vv cv cR wbr
      wn vu vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab wral vq cv vh cv
      wceq vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab vk cv vz cv cR
      wbr vk vh cv crn wral vz va cv crab vv cv vq cv vh cv wceq vk cv vz cv cR
      wbr vk vq cv crn wral vk cv vz cv cR wbr vk vh cv crn wral vz va cv vq cv
      vh cv wceq vk cv vz cv cR wbr vk vq cv crn vh cv crn vq cv vh cv rneq
      raleq1d rabbisdv eleq2d vq cv vh cv wceq vu cv vv cv cR wbr wn vu vk cv
      vz cv cR wbr vk vq cv crn wral vz va cv crab vk cv vz cv cR wbr vk vh cv
      crn wral vz va cv crab vq cv vh cv wceq vk cv vz cv cR wbr vk vq cv crn
      wral vk cv vz cv cR wbr vk vh cv crn wral vz va cv vq cv vh cv wceq vk cv
      vz cv cR wbr vk vq cv crn vh cv crn vq cv vh cv rneq raleq1d rabbisdv
      raleq1d anbi12d abbidv vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vq cv crn wral vz
      va cv crab df-rab vu cv vv cv cR wbr wn vu vk cv vz cv cR wbr vk vh cv
      crn wral vz va cv crab wral vv vk cv vz cv cR wbr vk vh cv crn wral vz va
      cv crab df-rab 3eqtr4g unieqd eqeq2d vo cv vc cv vu cv vv cv cR wbr wn vu
      vk cv vz cv cR wbr vk vh cv crn wral vz va cv crab wral vv vk cv vz cv cR
      wbr vk vh cv crn wral vz va cv crab crab cuni eqeq1 sylan9bb cbvopabv
      eqtri vb cv vp cv cR wbr vb vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv
      cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral
      vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab
      cuni vy cv cima wral vp va cv crab vj cv vp cv cR wbr vj vg cv vr cv wfn
      vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz
      cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk
      vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vy cv cima wral vp va cv crab vj cv vw
      cv cR wbr vj vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv
      vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq
      vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vy cv cima
      wral vw va cv crab vb cv vp cv cR wbr vb vg cv vr cv wfn vs cv vg cv cfv
      vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz
      va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0
      wrex vg cab cuni vy cv cima wral vj cv vp cv cR wbr vj vg cv vr cv wfn vs
      cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vy cv cima wral vp va cv vb cv vp cv cR
      wbr vb vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv
      cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn
      vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo
      copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vy cv cima wral
      vj cv vp cv cR wbr vj vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo
      cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni
      wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vy cv
      cima wral wb vp cv va cv wcel vb cv vp cv cR wbr vj cv vp cv cR wbr vb vj
      vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr
      wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz
      cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv
      wceq vs vr cv wral wa vr con0 wrex vg cab cuni vy cv cima vb cv vj cv vp
      cv cR breq1 cbvralv a1i rabbii vj cv vp cv cR wbr vj vg cv vr cv wfn vs
      cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vy cv cima wral vj cv vw cv cR wbr vj vg
      cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn
      vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv
      wceq vs vr cv wral wa vr con0 wrex vg cab cuni vy cv cima wral vp vw va
      cv vp cv vw cv wceq vj cv vp cv cR wbr vj cv vw cv cR wbr vj vg cv vr cv
      wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv
      vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr
      cv wral wa vr con0 wrex vg cab cuni vy cv cima vp cv vw cv vj cv cR breq2
      ralbidv cbvrabv eqtri ordtypelem7 vx cv va cv cep cR vg cv vr cv wfn vs
      cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vx cv cres wiso vx cv va cv cep cR vf cv
      wiso vf wex vx con0 vx cv va cv cep cR vf cv wiso vx cv va cv cep cR vg
      cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn
      vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv
      wceq vs vr cv wral wa vr con0 wrex vg cab cuni vx cv cres wiso vf vg cv
      vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm
      vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR
      wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq
      vs vr cv wral wa vr con0 wrex vg cab cuni vx cv cres vg cv vr cv wfn vs
      cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni wfun vx cv cvv wcel vg cv vr cv wfn vs
      cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv
      cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq
      cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv
      wral wa vr con0 wrex vg cab cuni vx cv cres cvv wcel vb vc vg cv vr cv
      wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv
      vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk cv vz cv cR wbr
      vk vq cv crn wral vz va cv crab crab cuni wceq vq vo copab cfv wceq vs vr
      cv wral wa vr con0 wrex vg cab vh vg cv vr cv wfn vs cv vg cv cfv vg cv
      vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg
      cab cuni vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn
      wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab crab cuni wceq vq vo copab vr vs vb vc vg vh vo cv vm cv vn cv cR
      wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab wral vn vk
      cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq vq vo
      copab rdglem1 vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv vm
      cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab
      wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni wceq
      vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni eqid
      tfrlem7 vx visset vg cv vr cv wfn vs cv vg cv cfv vg cv vs cv cres vo cv
      vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv crn wral vz va cv
      crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va cv crab crab cuni
      wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex vg cab cuni vx cv
      cvv resfunexg mp2an vx cv va cv cep cR vg cv vr cv wfn vs cv vg cv cfv vg
      cv vs cv cres vo cv vm cv vn cv cR wbr wn vm vk cv vz cv cR wbr vk vq cv
      crn wral vz va cv crab wral vn vk cv vz cv cR wbr vk vq cv crn wral vz va
      cv crab crab cuni wceq vq vo copab cfv wceq vs vr cv wral wa vr con0 wrex
      vg cab cuni vx cv cres vf cv isoeq1 cla4ev r19.22si syl vtoclg imp vx cv
      cA cep cR vf cv wiso vf wex vy cv cA cep cR vf cv wiso vf wex wa vx cv vy
      cv wceq wi vx vy con0 vx cv cA cep cR vf cv wiso vf wex vy cv cA cep cR
      vf cv wiso vf wex wa vx cv con0 wcel vy cv con0 wcel wa vx cv vy cv wceq
      vx cv cA cep cR vf cv wiso vf wex vy cv cA cep cR vf cv wiso vf wex vx cv
      con0 wcel vy cv con0 wcel wa vx cv vy cv wceq wi vx cv cA cep cR vf cv
      wiso vy cv cA cep cR vf cv wiso vf wex vx cv con0 wcel vy cv con0 wcel wa
      vx cv vy cv wceq wi wi vf vy cv cA cep cR vf cv wiso vf wex vx cv con0
      wcel vy cv con0 wcel wa vx cv vy cv wceq wi vf vy cv cA cep cR vf cv wiso
      vf hbe1 vx cv con0 wcel vy cv con0 wcel wa vx cv vy cv wceq wi vf ax-17
      hbim vx cv cA cep cR vf cv wiso vy cv cA cep cR vg cv wiso vg wex vx cv
      con0 wcel vy cv con0 wcel wa vx cv vy cv wceq wi vy cv cA cep cR vf cv
      wiso vf wex vx cv cA cep cR vf cv wiso vy cv cA cep cR vg cv wiso vx cv
      con0 wcel vy cv con0 wcel wa vx cv vy cv wceq wi vg vx cv cA cep cR vf cv
      wiso cA vy cv cR cep vg cv ccnv wiso vx cv con0 wcel vy cv con0 wcel wa
      vx cv vy cv wceq wi vy cv cA cep cR vg cv wiso vx cv cA cep cR vf cv wiso
      cA vy cv cR cep vg cv ccnv wiso vx cv con0 wcel vy cv con0 wcel wa vx cv
      vy cv wceq wi vx cv con0 wcel vy cv con0 wcel wa vx cv vy cv cep cep vg
      cv ccnv vf cv ccom wiso vx cv vy cv wceq vx cv cA cep cR vf cv wiso cA vy
      cv cR cep vg cv ccnv wiso wa vx cv con0 wcel vy cv con0 wcel wa vx cv vy
      cv wceq vx cv vy cv cep cep vh cv wiso vh wex vx cv vy cv cep cep vg cv
      ccnv vf cv ccom wiso vx cv vy cv vh ordiso vx cv vy cv cep cep vh cv wiso
      vx cv vy cv cep cep vg cv ccnv vf cv ccom wiso vh vg cv ccnv vf cv ccom
      vg cv ccnv vf cv vg cv vg visset cnvex vf visset coex vx cv vy cv cep cep
      vg cv ccnv vf cv ccom vh cv isoeq1 cla4ev syl5bir vx cv cA vy cv cep cR
      cep vg cv ccnv vf cv isotr syl5com ex vy cv cA cep cR vg cv isocnv syl5
      19.23adv vy cv cA cep cR vf cv wiso vy cv cA cep cR vg cv wiso vf vg vy
      cv cA cep cR vg cv vf cv isoeq1 cbvexv syl5ib 19.23ai imp com12 rgen2a
      jctir vx cv cA cep cR vf cv wiso vf wex vy cv cA cep cR vf cv wiso vf wex
      vx vy con0 vx cv vy cv wceq vx cv cA cep cR vf cv wiso vy cv cA cep cR vf
      cv wiso vf vx cv cA vy cv cep cR vf cv isoeq4 exbidv reu4 sylibr $.
      $( [20-Oct-2009] $) $( [16-Oct-2009] $)
  $}

  ${
    $d a b c d f g k m n o p r s t w x y z A $. $d a b c d f g k m n o p r s t
    w y z B $. $d a b c d f g k m n o p r s t w y z H $.
    hartog.1 $e |- H = { x e. On | x ~<_ A } $.
    ${
      $d r s R $.
      hartoglem.2 $e |- R = { <. a , b >. | E. c e. t E. d e. t ( a = ( g ` c )
      /\ b = ( g ` d ) /\ c e. d ) } $.
      $( Lemma for ~ hartog . $)
      hartoglem $p |- ( ( ( A e. B /\ g : t -1-1-> A ) /\ t e. On )
          -> g Isom _E , R ( t , ( g " t ) ) ) $=
        cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vt cv vg cv vt cv
        cima vg cv wf1o vr cv vs cv cep wbr vr cv vg cv cfv vs cv vg cv cfv cR
        wbr wb vs vt cv wral vr vt cv wral wa vt cv vg cv vt cv cima cep cR vg
        cv wiso cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vt cv vg cv
        vt cv cima vg cv wf1o vr cv vs cv cep wbr vr cv vg cv cfv vs cv vg cv
        cfv cR wbr wb vs vt cv wral vr vt cv wral vt cv cA vg cv wf1 vt cv vg
        cv vt cv cima vg cv wf1o cA cB wcel vt cv con0 wcel vt cv cA vg cv wf1
        vt cv vg cv vt cv cima vg cv wf1 vt cv vg cv vt cv cima vg cv wfo wa vt
        cv vg cv vt cv cima vg cv wf1o vt cv cA vg cv wf1 vt cv vg cv vt cv
        cima vg cv wf1 vt cv vg cv vt cv cima vg cv wfo vt cv cA vg cv wf1 vt
        cv vg cv vt cv cima vg cv wf vg cv ccnv wfun wa vt cv vg cv vt cv cima
        vg cv wf1 vt cv cA vg cv wf1 vt cv vg cv vt cv cima vg cv wf vg cv ccnv
        wfun vt cv cA vg cv wf1 vt cv vg cv vt cv cima vg cv wf vt cv vg cv crn
        vg cv wf vt cv cA vg cv wf1 vt cv cA vg cv wf vg cv vt cv wfn vt cv vg
        cv crn vg cv wf vt cv cA vg cv f1f vt cv cA vg cv ffn vg cv vt cv wfn
        vt cv vg cv crn vg cv wfo vt cv vg cv crn vg cv wf vt cv vg cv dffn4 vt
        cv vg cv crn vg cv fof sylbi 3syl vt cv cA vg cv wf1 vg cv vt cv cima
        vg cv crn wceq vt cv vg cv vt cv cima vg cv wf vt cv vg cv crn vg cv wf
        wb vt cv cA vg cv wf1 vt cv cA vg cv wf vg cv vt cv wfn vg cv vt cv
        cima vg cv crn wceq vt cv cA vg cv f1f vt cv cA vg cv ffn vt cv vg cv
        fnima 3syl vg cv vt cv cima vg cv crn vt cv vg cv feq3 syl mpbird vt cv
        cA vg cv wf1 vt cv cA vg cv wf vg cv ccnv wfun vt cv cA vg cv df-f1
        pm3.27bi jca vt cv vg cv vt cv cima vg cv df-f1 sylibr vt cv cA vg cv
        wf1 vg cv vt cv wfn vg cv crn vg cv vt cv cima wceq wa vt cv vg cv vt
        cv cima vg cv wfo vt cv cA vg cv wf1 vg cv vt cv wfn vg cv crn vg cv vt
        cv cima wceq vt cv cA vg cv wf1 vt cv cA vg cv wf vg cv vt cv wfn vt cv
        cA vg cv f1f vt cv cA vg cv ffn syl vt cv cA vg cv wf1 vg cv vt cv cima
        vg cv crn vt cv cA vg cv wf1 vt cv cA vg cv wf vg cv vt cv wfn vg cv vt
        cv cima vg cv crn wceq vt cv cA vg cv f1f vt cv cA vg cv ffn vt cv vg
        cv fnima 3syl eqcomd jca vt cv vg cv vt cv cima vg cv df-fo sylibr jca
        vt cv vg cv vt cv cima vg cv df-f1o sylibr ad2antlr cA cB wcel vt cv cA
        vg cv wf1 wa vt cv con0 wcel wa vr cv vs cv cep wbr vr cv vg cv cfv vs
        cv vg cv cfv cR wbr wb vr vs vt cv vt cv cA cB wcel vt cv cA vg cv wf1
        wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel wa vr cv vs cv
        cep wbr vr cv vg cv cfv vs cv vg cv cfv cR wbr wb cA cB wcel vt cv cA
        vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel wa wa
        vr cv vs cv wcel vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv
        vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
        vr cv vs cv cep wbr vr cv vg cv cfv vs cv vg cv cfv cR wbr cA cB wcel
        vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv
        wcel wa wa vr cv vs cv wcel vr cv vg cv cfv vc cv vg cv cfv wceq vs cv
        vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
        cv wrex cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv
        wcel vs cv vt cv wcel wa vr cv vs cv wcel vr cv vg cv cfv vc cv vg cv
        cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd
        vt cv wrex vc vt cv wrex vr cv vt cv wcel vs cv vt cv wcel vr cv vg cv
        cfv vr cv vg cv cfv wceq vs cv vg cv cfv vs cv vg cv cfv wceq vr cv vs
        cv wcel w3a vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv
        vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex cA cB
        wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt
        cv wcel wa vr cv vs cv wcel wa wa vr cv vg cv cfv vc cv vg cv cfv wceq
        vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vr cv vg cv
        cfv vr cv vg cv cfv wceq vs cv vg cv cfv vs cv vg cv cfv wceq vr cv vs
        cv wcel w3a vr cv vg cv cfv vr cv vg cv cfv wceq vs cv vg cv cfv vd cv
        vg cv cfv wceq vr cv vd cv wcel w3a vc vd vr cv vs cv vt cv vt cv vc cv
        vr cv wceq vr cv vg cv cfv vc cv vg cv cfv wceq vr cv vg cv cfv vr cv
        vg cv cfv wceq vc cv vd cv wcel vr cv vd cv wcel vs cv vg cv cfv vd cv
        vg cv cfv wceq vc cv vr cv wceq vc cv vg cv cfv vr cv vg cv cfv vr cv
        vg cv cfv vc cv vr cv vg cv fveq2 eqeq2d vc cv vr cv vd cv eleq1
        3anbi13d vd cv vs cv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vs cv vg
        cv cfv vs cv vg cv cfv wceq vr cv vd cv wcel vr cv vs cv wcel vr cv vg
        cv cfv vr cv vg cv cfv wceq vd cv vs cv wceq vd cv vg cv cfv vs cv vg
        cv cfv vs cv vg cv cfv vd cv vs cv vg cv fveq2 eqeq2d vd cv vs cv vr cv
        eleq2 3anbi23d rcla42ev cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
        wcel wa vr cv vt cv wcel vs cv vt cv wcel vr cv vs cv wcel simprll cA
        cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv
        vt cv wcel vr cv vs cv wcel simprlr cA cB wcel vt cv cA vg cv wf1 wa vt
        cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel wa vr cv vs cv wcel
        wa wa vr cv vg cv cfv vr cv vg cv cfv wceq vs cv vg cv cfv vs cv vg cv
        cfv wceq vr cv vs cv wcel cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
        wcel wa vr cv vt cv wcel vs cv vt cv wcel wa vr cv vs cv wcel wa wa vr
        cv vg cv cfv eqidd cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa
        vr cv vt cv wcel vs cv vt cv wcel wa vr cv vs cv wcel wa wa vs cv vg cv
        cfv eqidd cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt
        cv wcel vs cv vt cv wcel wa vr cv vs cv wcel simprr 3jca syl3anc expr
        cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs
        cv vt cv wcel wa wa vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv
        cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vr cv vs cv wcel vc vd vt
        cv vt cv cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt
        cv wcel vs cv vt cv wcel wa wa vc cv vt cv wcel vd cv vt cv wcel wa vr
        cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq
        vc cv vd cv wcel w3a vr cv vs cv wcel cA cB wcel vt cv cA vg cv wf1 wa
        vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel wa wa vc cv vt cv
        wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg
        cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a wa wa vr cv vs cv wcel
        vc cv vd cv wcel vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv
        vd cv vg cv cfv wceq vc cv vd cv wcel w3a vc cv vd cv wcel cA cB wcel
        vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv
        wcel wa wa vc cv vt cv wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv
        vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel
        3simp3 ad2antll cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr
        cv vt cv wcel vs cv vt cv wcel wa wa vc cv vt cv wcel vd cv vt cv wcel
        wa vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv
        wceq vc cv vd cv wcel w3a wa wa vr cv vc cv vs cv vd cv cA cB wcel vt
        cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel
        wa wa vc cv vt cv wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv vg cv
        cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a wa
        wa vr cv vg cv cfv vc cv vg cv cfv wceq vr cv vc cv wceq vr cv vg cv
        cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd
        cv wcel w3a vr cv vg cv cfv vc cv vg cv cfv wceq cA cB wcel vt cv cA vg
        cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel wa wa vc
        cv vt cv wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv vg cv cfv wceq
        vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel 3simp1 ad2antll
        vt cv cA vg cv wf1 vr cv vt cv wcel vc cv vt cv wcel vr cv vg cv cfv vc
        cv vg cv cfv wceq vr cv vc cv wceq wb cA cB wcel vt cv cA vg cv wf1 wa
        vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel wa wa vc cv vt cv
        wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg
        cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a wa wa cA cB wcel vt cv
        cA vg cv wf1 wa vt cv con0 wcel wa vt cv cA vg cv wf1 vr cv vt cv wcel
        vs cv vt cv wcel wa vc cv vt cv wcel vd cv vt cv wcel wa vr cv vg cv
        cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd
        cv wcel w3a wa cA cB wcel vt cv cA vg cv wf1 vt cv con0 wcel simplr
        ad2antrr cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt
        cv wcel vs cv vt cv wcel vc cv vt cv wcel vd cv vt cv wcel wa vr cv vg
        cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv
        vd cv wcel w3a wa simplrl cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
        wcel wa vr cv vt cv wcel vs cv vt cv wcel wa wa vc cv vt cv wcel vd cv
        vt cv wcel vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv
        vg cv cfv wceq vc cv vd cv wcel w3a simprll vt cv cA vr cv vc cv vg cv
        f1fveq sylan32c mpbid cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel
        wa vr cv vt cv wcel vs cv vt cv wcel wa wa vc cv vt cv wcel vd cv vt cv
        wcel wa vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg
        cv cfv wceq vc cv vd cv wcel w3a wa wa vs cv vg cv cfv vd cv vg cv cfv
        wceq vs cv vd cv wceq vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv
        cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vs cv vg cv cfv vd cv vg
        cv cfv wceq cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv
        vt cv wcel vs cv vt cv wcel wa wa vc cv vt cv wcel vd cv vt cv wcel wa
        vr cv vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv
        wceq vc cv vd cv wcel 3simp2 ad2antll vt cv cA vg cv wf1 vs cv vt cv
        wcel vd cv vt cv wcel vs cv vg cv cfv vd cv vg cv cfv wceq vs cv vd cv
        wceq wb cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv
        wcel vs cv vt cv wcel wa wa vc cv vt cv wcel vd cv vt cv wcel wa vr cv
        vg cv cfv vc cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc
        cv vd cv wcel w3a wa wa cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
        wcel wa vt cv cA vg cv wf1 vr cv vt cv wcel vs cv vt cv wcel wa vc cv
        vt cv wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv vg cv cfv wceq vs
        cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a wa cA cB wcel vt
        cv cA vg cv wf1 vt cv con0 wcel simplr ad2antrr cA cB wcel vt cv cA vg
        cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt cv wcel vc cv vt
        cv wcel vd cv vt cv wcel wa vr cv vg cv cfv vc cv vg cv cfv wceq vs cv
        vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a wa simplrr cA cB
        wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vr cv vt cv wcel vs cv vt
        cv wcel wa wa vc cv vt cv wcel vd cv vt cv wcel vr cv vg cv cfv vc cv
        vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel
        w3a simprlr vt cv cA vs cv vd cv vg cv f1fveq sylan32c mpbid eleq12d
        mpbird exp32 r19.23advv impbid vr vs epel va cv vc cv vg cv cfv wceq vb
        cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv
        wrex vr cv vg cv cfv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
        cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex vr cv vg cv cfv vc cv vg
        cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
        vd vt cv wrex vc vt cv wrex va vb vr cv vg cv cfv vs cv vg cv cfv cR vr
        cv vg cv fvex vs cv vg cv fvex va cv vr cv vg cv cfv wceq va cv vc cv
        vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vr cv vg
        cv cfv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
        w3a vc vd vt cv vt cv va cv vr cv vg cv cfv wceq va cv vc cv vg cv cfv
        wceq vr cv vg cv cfv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
        cv vd cv wcel va cv vr cv vg cv cfv vc cv vg cv cfv eqeq1 3anbi1d
        2rexbidv vb cv vs cv vg cv cfv wceq vr cv vg cv cfv vc cv vg cv cfv
        wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vr cv vg cv cfv vc
        cv vg cv cfv wceq vs cv vg cv cfv vd cv vg cv cfv wceq vc cv vd cv wcel
        w3a vc vd vt cv vt cv vb cv vs cv vg cv cfv wceq vb cv vd cv vg cv cfv
        wceq vs cv vg cv cfv vd cv vg cv cfv wceq vr cv vg cv cfv vc cv vg cv
        cfv wceq vc cv vd cv wcel vb cv vs cv vg cv cfv vd cv vg cv cfv eqeq1
        3anbi2d 2rexbidv hartoglem.2 brab 3bitr4g ex r19.21aivv jca vr vs vt cv
        vg cv vt cv cima cep cR vg cv df-iso sylibr $.
        $( [22-Oct-2009] $) $( [22-Oct-2009] $)
    $}

    $( Associate every set with an ordinal number known as its Hartog number.
       Apparently, this theorem has some sort of topological significance. I
       guess you would have to ask someone like Jeff Madsen or Dr. James
       Conant. Notice the similarity of this theorem to ~ ondomon . $)
    hartog $p |- ( A e. B -> H e. On ) $=
      cA cB wcel cH con0 wcel cH word cH wtr cH con0 wss con0 word cH word cH
      wtr vy cv vz cv wcel vz cv vx cv cA cdom wbr vx con0 crab wcel wa vy cv
      vx cv cA cdom wbr vx con0 crab wcel wi vz wal vy wal vy cv vz cv wcel vz
      cv vx cv cA cdom wbr vx con0 crab wcel wa vy cv vx cv cA cdom wbr vx con0
      crab wcel wi vy vz vy cv vz cv wcel vz cv con0 wcel vz cv cA cdom wbr wa
      vy cv vx cv cA cdom wbr vx con0 crab wcel vz cv vx cv cA cdom wbr vx con0
      crab wcel vy cv vz cv wcel vz cv con0 wcel vz cv cA cdom wbr wa wa vy cv
      con0 wcel vy cv cA cdom wbr wa vy cv vx cv cA cdom wbr vx con0 crab wcel
      vy cv vz cv wcel vz cv con0 wcel vz cv cA cdom wbr wa wa vy cv con0 wcel
      vy cv cA cdom wbr vy cv vz cv wcel vz cv con0 wcel vy cv con0 wcel vz cv
      cA cdom wbr vz cv con0 wcel vy cv vz cv wcel vy cv con0 wcel vz cv vy cv
      onelon ancoms adantrr vy cv vz cv wcel vz cv con0 wcel vz cv cA cdom wbr
      vy cv cA cdom wbr vy cv vz cv cdom wbr vz cv cA cdom wbr vy cv cA cdom
      wbr vy cv vz cv wcel vz cv con0 wcel wa vy cv vz cv cA domtr vy cv vz cv
      wcel vz cv con0 wcel wa vy cv vz cv wss vy cv vz cv cdom wbr vz cv con0
      wcel vy cv vz cv wcel vy cv vz cv wss vz cv vy cv onelss impcom vy cv cvv
      wcel vy cv vz cv wss vy cv vz cv cdom wbr wi vy visset vy cv vz cv cvv
      ssdomg ax-mp syl sylan anasss jca vx cv cA cdom wbr vy cv cA cdom wbr vx
      vy cv con0 vx cv vy cv cA cdom breq1 elrab sylibr vx cv cA cdom wbr vz cv
      cA cdom wbr vx vz cv con0 vx cv vz cv cA cdom breq1 elrab sylan2b gen2 cH
      wtr vx cv cA cdom wbr vx con0 crab wtr vy cv vz cv wcel vz cv vx cv cA
      cdom wbr vx con0 crab wcel wa vy cv vx cv cA cdom wbr vx con0 crab wcel
      wi vz wal vy wal cH vx cv cA cdom wbr vx con0 crab wceq cH wtr vx cv cA
      cdom wbr vx con0 crab wtr wb hartog.1 cH vx cv cA cdom wbr vx con0 crab
      treq ax-mp vy vz vx cv cA cdom wbr vx con0 crab dftr2 bitri mpbir cH vx
      cv cA cdom wbr vx con0 crab con0 hartog.1 vx cv cA cdom wbr vx con0
      ssrab2 eqsstri ordon cH con0 trssord mp3an cA cB wcel cH cvv wcel cH con0
      wcel cH word wb cA cB wcel vx cv cA cdom wbr vx con0 crab cvv cH vx cv cA
      cdom wbr vx con0 crab vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe
      w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq
      wa vy vw vz copab2 crn wss vy cv cA wss vw cv cA cA cxp wss vy cv vw cv
      wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni
      wceq wa vy vw vz copab2 crn cvv wcel vx cv cA cdom wbr vx con0 crab cvv
      wcel cA cB wcel vx cv cA cdom wbr vx con0 crab vy cv cA wss vw cv cA cA
      cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex
      vo con0 crab cuni wceq wa vy vw vz copab2 crn cvv ssexg cA cB wcel vt vx
      cv cA cdom wbr vx con0 crab vy cv cA wss vw cv cA cA cxp wss vy cv vw cv
      wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni
      wceq wa vy vw vz copab2 crn cA cB wcel vt cv con0 wcel vt cv cA cdom wbr
      wa vp cv vt cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa
      vy vw vz copab2 wcel vp wex vt cv vx cv cA cdom wbr vx con0 crab wcel vt
      cv vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv
      cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 crn
      wcel cA cB wcel vt cv con0 wcel vt cv cA cdom wbr vp cv vt cv cop vy cv
      cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw
      cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 wcel vp
      wex cA cB wcel vt cv cA cdom wbr vt cv con0 wcel vp cv vt cv cop vy cv cA
      wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv
      vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 wcel vp wex
      cA cB wcel vt cv cA cdom wbr vt cv cA vg cv wf1 vg wex vt cv con0 wcel vp
      cv vt cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv
      vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw
      vz copab2 wcel vp wex wi vt cv cA cB vg brdomg cA cB wcel vt cv cA vg cv
      wf1 vt cv con0 wcel vp cv vt cv cop vy cv cA wss vw cv cA cA cxp wss vy
      cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0
      crab cuni wceq wa vy vw vz copab2 wcel vp wex wi vg cA cB wcel vt cv cA
      vg cv wf1 vt cv con0 wcel vp cv vt cv cop vy cv cA wss vw cv cA cA cxp
      wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo
      con0 crab cuni wceq wa vy vw vz copab2 wcel vp wex cA cB wcel vt cv cA vg
      cv wf1 wa vt cv con0 wcel wa vg cv vt cv cima va cv vc cv vg cv cfv wceq
      vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv
      wrex va vb copab cop vt cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw
      cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab
      cuni wceq wa vy vw vz copab2 wcel vp cv vt cv cop vy cv cA wss vw cv cA
      cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf
      wex vo con0 crab cuni wceq wa vy vw vz copab2 wcel vp wex cA cB wcel vt
      cv cA vg cv wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab wwe w3a vt cv vo cv vg cv vt cv cima cep
      va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0
      crab cuni wceq wa vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab cop vt cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa
      vy vw vz copab2 wcel cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa
      vg cv vt cv cima cA wss va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cA cA
      cxp wss vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wwe w3a
      vt cv vo cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab vf cv wiso vf wex vo con0 crab cuni wceq cA cB wcel vt cv cA vg cv
      wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab wwe vt cv cA vg cv wf1 vg cv vt cv cima cA wss cA cB
      wcel vt cv con0 wcel vt cv cA vg cv wf1 vg cv vt cv cima vg cv crn cA vg
      cv vt cv cima vg cv crn wss vt cv cA vg cv wf1 vg cv vt cv imassrn a1i vt
      cv cA vg cv wf1 vt cv cA vg cv wf vg cv crn cA wss vt cv cA vg cv f1f vt
      cv cA vg cv frn syl sstrd ad2antlr cA cB wcel vt cv cA vg cv wf1 wa vt cv
      con0 wcel wa vm va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cA cA cxp cA cB
      wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vm cv va cv vb cv cop wceq
      va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex wa vb wex va wex vm cv cA cA cxp wcel vm
      cv va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab wcel cA cB wcel vt cv cA vg
      cv wf1 wa vt cv con0 wcel wa vm cv va cv vb cv cop wceq va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex wa vm cv cA cA cxp wcel va vb cA cB wcel vt cv cA vg cv wf1 wa
      vt cv con0 wcel wa vm cv va cv vb cv cop wceq va cv vc cv vg cv cfv wceq
      vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv
      wrex wa vm cv cA cA cxp wcel cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
      wcel wa vm cv va cv vb cv cop wceq va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex wa wa vm
      cv va cv vb cv cop cA cA cxp cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
      wcel wa vm cv va cv vb cv cop wceq va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex simprl cA
      cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va cv vb cv cop cA cA cxp wcel vm cv va cv vb cv cop wceq cA cB
      wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa va cv vc cv vg cv cfv wceq
      vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv
      wrex va cv vb cv cop cA cA cxp wcel cA cB wcel vt cv cA vg cv wf1 wa vt
      cv con0 wcel wa va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a va cv vb cv cop cA cA cxp wcel vc vd vt cv vt cv cA cB
      wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vc cv vt cv wcel vd cv vt
      cv wcel wa va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd
      cv wcel w3a va cv vb cv cop cA cA cxp wcel va cv cA wcel vb cv cA wcel va
      cv vb cv cop cA cA cxp wcel cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
      wcel wa vc cv vt cv wcel vd cv vt cv wcel wa va cv vc cv vg cv cfv wceq
      vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a wa wa va cv vb cv cA cA
      opelxpi cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vc cv vt cv
      wcel vd cv vt cv wcel wa va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a wa wa va cv vc cv vg cv cfv cA va cv vc cv vg
      cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a va cv vc cv
      vg cv cfv wceq cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vc cv
      vt cv wcel vd cv vt cv wcel wa va cv vc cv vg cv cfv wceq vb cv vd cv vg
      cv cfv wceq vc cv vd cv wcel 3simp1 ad2antll cA cB wcel vt cv cA vg cv
      wf1 wa vt cv con0 wcel wa vc cv vt cv wcel vd cv vt cv wcel wa vc cv vg
      cv cfv cA wcel va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a vt cv cA vg cv wf vc cv vt cv wcel vc cv vg cv cfv cA
      wcel cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vc cv vt cv wcel
      vd cv vt cv wcel wa wa vt cv cA vc cv vg cv ffvelrn cA cB wcel vt cv cA
      vg cv wf1 wa vt cv cA vg cv wf vt cv con0 wcel vc cv vt cv wcel vd cv vt
      cv wcel wa vt cv cA vg cv wf1 vt cv cA vg cv wf cA cB wcel vt cv cA vg cv
      f1f adantl ad2antrr cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa
      vc cv vt cv wcel vd cv vt cv wcel simprl sylanc adantrr eqeltrd cA cB
      wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vc cv vt cv wcel vd cv vt
      cv wcel wa va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd
      cv wcel w3a wa wa vb cv vd cv vg cv cfv cA va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vb cv vd cv vg cv cfv wceq
      cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vc cv vt cv wcel vd
      cv vt cv wcel wa va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel 3simp2 ad2antll cA cB wcel vt cv cA vg cv wf1 wa vt cv con0
      wcel wa vc cv vt cv wcel vd cv vt cv wcel wa vd cv vg cv cfv cA wcel va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      cA cB wcel vt cv cA vg cv wf1 wa vd cv vt cv wcel vd cv vg cv cfv cA wcel
      vt cv con0 wcel vc cv vt cv wcel vt cv cA vg cv wf1 vd cv vt cv wcel vd
      cv vg cv cfv cA wcel cA cB wcel vt cv cA vg cv wf vd cv vt cv wcel vd cv
      vg cv cfv cA wcel vt cv cA vg cv wf1 vt cv cA vd cv vg cv ffvelrn vt cv
      cA vg cv f1f sylan adantll ad2ant2rl adantrr eqeltrd sylanc exp32
      r19.23advv imp adantrl eqeltrd ex 19.23advv va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb vm cv elopab syl5ib ssrdv cA cB wcel vt cv cA vg cv wf1 wa vt cv
      con0 wcel wa vt cv cep wwe vg cv vt cv cima va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb copab wwe vt cv con0 wcel vt cv cep wwe cA cB wcel vt cv cA vg cv
      wf1 wa vt cv con0 wcel vt cv word vt cv cep wwe vt cv eloni vt cv ordwe
      syl adantl cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vt cv vg
      cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq
      vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vg cv wiso
      vt cv cep wwe vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg
      cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab
      wwe wb vx vt cA cB va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq
      vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vg cH va vb
      vc vd hartog.1 va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab eqid hartoglem
      vt cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv
      cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vg
      cv isowe syl mpbid 3jca cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel
      wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv wceq vb cv vd cv vg cv
      cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cA
      cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv
      cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wwe
      w3a vt cv vo cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd
      cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab vf cv wiso vf wex vo con0 crab cuni wceq cA cB wcel vt cv cA vg cv
      wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab wwe w3a wa vo cv vg cv vt cv cima cep va cv vc cv vg
      cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex
      vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 crab cuni vt cv cA cB
      wcel vt cv cA vg cv wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      vd vt cv wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      vd vt cv wrex vc vt cv wrex va vb copab wwe w3a wa vt cv vg cv vt cv cima
      cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo cv
      vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv
      wiso vf wex vo con0 crab cuni vt cv wceq cA cB wcel vt cv cA vg cv wf1 wa
      vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb copab wwe w3a wa vt cv vg cv vt cv cima cep va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab vg cv wiso vt cv vg cv vt cv cima cep va cv vc cv vg
      cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex
      vc vt cv wrex va vb copab vf cv wiso vf wex cA cB wcel vt cv cA vg cv wf1
      wa vt cv con0 wcel wa vt cv vg cv vt cv cima cep va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab vg cv wiso vg cv vt cv cima cA wss va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab wwe w3a vx vt cA cB va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb copab vg cH va vb vc vd hartog.1 va cv vc cv vg cv cfv wceq vb cv
      vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va
      vb copab eqid hartoglem adantr vt cv vg cv vt cv cima cep va cv vc cv vg
      cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex
      vc vt cv wrex va vb copab vf cv wiso vt cv vg cv vt cv cima cep va cv vc
      cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt
      cv wrex vc vt cv wrex va vb copab vg cv wiso vf vg cv vg visset vt cv vg
      cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq
      vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vg cv vf cv
      isoeq1 cla4ev syl vt cv con0 wcel vo cv vg cv vt cv cima cep va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 wreu vt cv vg cv
      vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf
      wex vo cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg
      cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab
      vf cv wiso vf wex vo con0 crab cuni vt cv wceq wb cA cB wcel vt cv cA vg
      cv wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab wwe w3a wa vo cv vg cv vt cv cima cep va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab vf cv wiso vf wex vt cv vg cv vt cv cima
      cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo
      con0 vt cv vo cv vt cv wceq vo cv vg cv vt cv cima cep va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab vf cv wiso vt cv vg cv vt cv cima cep va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab vf cv wiso vf vo cv vg cv vt cv cima vt cv
      cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv isoeq4 exbidv
      reuuni2 cA cB wcel vt cv cA vg cv wf1 wa vt cv con0 wcel vg cv vt cv cima
      cA wss va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt
      cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wwe w3a simplr vg cv vt
      cv cima cvv wcel vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab wwe vo cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd
      cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab vf cv wiso vf wex vo con0 wreu cA cB wcel vt cv cA vg cv wf1 wa vt
      cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv wceq vb cv
      vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va
      vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv
      vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va
      vb copab wwe w3a wa vo vg cv vt cv cima cvv va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb copab vf ordtype vg cv vt cv cima cvv wcel cA cB wcel vt cv cA vg
      cv wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc
      vt cv wrex va vb copab wwe w3a wa vg cv cvv wcel vg cv vt cv cima cvv
      wcel vg visset vg cv vt cv cvv imaexg ax-mp a1i vg cv vt cv cima cA wss
      va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt cv
      cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wwe w3a vg cv vt cv cima
      va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab wwe cA cB wcel vt cv cA vg cv
      wf1 wa vt cv con0 wcel wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab wwe 3simp3 adantl sylanc sylanc mpbid eqcomd ex jcai
      vg cv vt cv cima cvv wcel va cv vc cv vg cv cfv wceq vb cv vd cv vg cv
      cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cvv
      wcel vt cv cvv wcel vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd
      cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab cop vt cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa
      vy vw vz copab2 wcel vg cv vt cv cima cA wss va cv vc cv vg cv cfv wceq
      vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv
      wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab wwe w3a vt cv vo cv vg cv vt cv cima cep va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 crab cuni wceq
      wa wb vg cv cvv wcel vg cv vt cv cima cvv wcel vg visset vg cv vt cv cvv
      imaexg ax-mp va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv
      vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vm cv vc cv vg cv
      cfv vd cv vg cv cfv cop wceq vd vt cv wrex vc vt cv wrex vm cab vm cv vc
      cv vg cv cfv vd cv vg cv cfv cop wceq vd vt cv wrex vc vm vt cv vt visset
      vd vm vt cv vc cv vg cv cfv vd cv vg cv cfv cop vt visset abrexex
      abrexex2 va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd
      cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vm cv vc cv vg cv cfv
      vd cv vg cv cfv cop wceq vd vt cv wrex vc vt cv wrex vm cab wss vm cv va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      vd vt cv wrex vc vt cv wrex va vb copab wcel vm cv vc cv vg cv cfv vd cv
      vg cv cfv cop wceq vd vt cv wrex vc vt cv wrex wi vm vm cv vc cv vg cv
      cfv vd cv vg cv cfv cop wceq vd vt cv wrex vc vt cv wrex vm va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab ssab vm cv va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      va vb copab wcel vm cv va cv vb cv cop wceq va cv vc cv vg cv cfv wceq vb
      cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex
      wa vb wex va wex vm cv vc cv vg cv cfv vd cv vg cv cfv cop wceq vd vt cv
      wrex vc vt cv wrex va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq
      vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb vm cv elopab vm cv
      va cv vb cv cop wceq va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex wa vm cv vc cv vg
      cv cfv vd cv vg cv cfv cop wceq vd vt cv wrex vc vt cv wrex va vb vm cv
      va cv vb cv cop wceq va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex vm cv vc cv vg cv
      cfv vd cv vg cv cfv cop wceq vd vt cv wrex vc vt cv wrex vm cv va cv vb
      cv cop wceq va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv
      vd cv wcel w3a vd vt cv wrex vm cv vc cv vg cv cfv vd cv vg cv cfv cop
      wceq vd vt cv wrex vc vt cv vm cv va cv vb cv cop wceq va cv vc cv vg cv
      cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vm cv vc cv vg
      cv cfv vd cv vg cv cfv cop wceq vd vt cv vm cv va cv vb cv cop wceq vm cv
      vc cv vg cv cfv vd cv vg cv cfv cop wceq va cv vb cv cop vc cv vg cv cfv
      vd cv vg cv cfv cop wceq va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vm cv va cv vb cv cop vc cv vg cv cfv vd cv vg
      cv cfv cop eqeq1 va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq va
      cv vb cv cop vc cv vg cv cfv vd cv vg cv cfv cop wceq vc cv vd cv wcel va
      cv vb cv vc cv vg cv cfv vd cv vg cv cfv opeq12 3adant3 syl5bir r19.22sdv
      r19.22sdv imp 19.23aivv sylbi mpgbir ssexi vt visset vy cv cA wss vw cv
      cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso
      vf wex vo con0 crab cuni wceq wa vg cv vt cv cima cA wss vw cv cA cA cxp
      wss vg cv vt cv cima vw cv wwe w3a vz cv vo cv vg cv vt cv cima cep vw cv
      vf cv wiso vf wex vo con0 crab cuni wceq wa vg cv vt cv cima cA wss va cv
      vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd
      vt cv wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv
      vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd
      vt cv wrex vc vt cv wrex va vb copab wwe w3a vz cv vo cv vg cv vt cv cima
      cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo
      con0 crab cuni wceq wa vg cv vt cv cima cA wss va cv vc cv vg cv cfv wceq
      vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv
      wrex va vb copab cA cA cxp wss vg cv vt cv cima va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab wwe w3a vt cv vo cv vg cv vt cv cima cep va cv vc cv
      vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv
      wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 crab cuni wceq
      wa vy vw vz vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv
      cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vt
      cv cvv cvv cvv vy cv vg cv vt cv cima wceq vy cv cA wss vw cv cA cA cxp
      wss vy cv vw cv wwe w3a vg cv vt cv cima cA wss vw cv cA cA cxp wss vg cv
      vt cv cima vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo
      con0 crab cuni wceq vz cv vo cv vg cv vt cv cima cep vw cv vf cv wiso vf
      wex vo con0 crab cuni wceq vy cv vg cv vt cv cima wceq vy cv cA wss vg cv
      vt cv cima cA wss vy cv vw cv wwe vg cv vt cv cima vw cv wwe vw cv cA cA
      cxp wss vy cv vg cv vt cv cima cA sseq1 vy cv vg cv vt cv cima vw cv
      weeq2 3anbi13d vy cv vg cv vt cv cima wceq vo cv vy cv cep vw cv vf cv
      wiso vf wex vo con0 crab cuni vo cv vg cv vt cv cima cep vw cv vf cv wiso
      vf wex vo con0 crab cuni vz cv vy cv vg cv vt cv cima wceq vo cv vy cv
      cep vw cv vf cv wiso vf wex vo con0 crab vo cv vg cv vt cv cima cep vw cv
      vf cv wiso vf wex vo con0 crab vy cv vg cv vt cv cima wceq vo cv vy cv
      cep vw cv vf cv wiso vf wex vo cv vg cv vt cv cima cep vw cv vf cv wiso
      vf wex vo con0 vy cv vg cv vt cv cima wceq vo cv vy cv cep vw cv vf cv
      wiso vo cv vg cv vt cv cima cep vw cv vf cv wiso vf vo cv vy cv vg cv vt
      cv cima cep vw cv vf cv isoeq5 exbidv rabbisdv unieqd eqeq2d anbi12d vw
      cv va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab wceq vg cv vt cv cima cA wss
      vw cv cA cA cxp wss vg cv vt cv cima vw cv wwe w3a vg cv vt cv cima cA
      wss va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt
      cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wwe w3a vz cv vo cv vg
      cv vt cv cima cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq vz cv vo
      cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv
      wiso vf wex vo con0 crab cuni wceq vw cv va cv vc cv vg cv cfv wceq vb cv
      vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va
      vb copab wceq vw cv cA cA cxp wss va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab cA cA cxp wss vg cv vt cv cima vw cv wwe vg cv vt cv cima va cv vc
      cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt
      cv wrex vc vt cv wrex va vb copab wwe vg cv vt cv cima cA wss vw cv va cv
      vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd
      vt cv wrex vc vt cv wrex va vb copab cA cA cxp sseq1 vg cv vt cv cima vw
      cv va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab weeq1 3anbi23d vw cv va cv vc
      cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt
      cv wrex vc vt cv wrex va vb copab wceq vo cv vg cv vt cv cima cep vw cv
      vf cv wiso vf wex vo con0 crab cuni vo cv vg cv vt cv cima cep va cv vc
      cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt
      cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 crab cuni vz
      cv vw cv va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd
      cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wceq vo cv vg cv vt
      cv cima cep vw cv vf cv wiso vf wex vo con0 crab vo cv vg cv vt cv cima
      cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv
      wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo
      con0 crab vw cv va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab wceq vo cv vg
      cv vt cv cima cep vw cv vf cv wiso vf wex vo cv vg cv vt cv cima cep va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 vw cv
      va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel
      w3a vd vt cv wrex vc vt cv wrex va vb copab wceq vo cv vg cv vt cv cima
      cep vw cv vf cv wiso vo cv vg cv vt cv cima cep va cv vc cv vg cv cfv
      wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt
      cv wrex va vb copab vf cv wiso vf vo cv vg cv vt cv cima cep vw cv va cv
      vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd
      vt cv wrex vc vt cv wrex va vb copab vf cv isoeq3 exbidv rabbisdv unieqd
      eqeq2d anbi12d vz cv vt cv wceq vz cv vo cv vg cv vt cv cima cep va cv vc
      cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt
      cv wrex vc vt cv wrex va vb copab vf cv wiso vf wex vo con0 crab cuni
      wceq vt cv vo cv vg cv vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd
      cv vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab vf cv wiso vf wex vo con0 crab cuni wceq vg cv vt cv cima cA wss va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      vd vt cv wrex vc vt cv wrex va vb copab cA cA cxp wss vg cv vt cv cima va
      cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc cv vd cv wcel w3a
      vd vt cv wrex vc vt cv wrex va vb copab wwe w3a vz cv vt cv vo cv vg cv
      vt cv cima cep va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq vc
      cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab vf cv wiso vf
      wex vo con0 crab cuni eqeq1 anbi2d eloprabg mp3an sylibr vp cv vt cv cop
      vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv
      cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2
      wcel vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cop vt
      cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv
      vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz
      copab2 wcel vp vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg
      cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab
      cop vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv
      wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab opex vp
      cv vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg cv cfv wceq
      vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab cop wceq vp
      cv vt cv cop vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv vg
      cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb copab
      cop vt cv cop vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv
      vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw
      vz copab2 vp cv vg cv vt cv cima va cv vc cv vg cv cfv wceq vb cv vd cv
      vg cv cfv wceq vc cv vd cv wcel w3a vd vt cv wrex vc vt cv wrex va vb
      copab cop vt cv opeq1 eleq1d cla4ev syl exp31 19.23adv sylbid com23 imp3a
      vx cv cA cdom wbr vt cv cA cdom wbr vx vt cv con0 vx cv vt cv cA cdom
      breq1 elrab vp vt cv vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa
      vy vw vz copab2 vt visset elrn2 3imtr4g ssrdv cA cB wcel vy cv cA wss vw
      cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv
      wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 cdm cvv wcel vy cv
      cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw
      cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 crn cvv
      wcel cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz
      cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy
      vw vz copab2 cdm vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vy
      vw copab cvv cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe
      w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq
      vz weu wi vw wal vy wal vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe
      w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq
      wa vy vw vz copab2 vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vy vw copab wfn vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz
      cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy
      vw vz copab2 cdm vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vy
      vw copab wceq cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe
      w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq
      vz weu wi vy vw cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv
      wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni
      wceq vz weu cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe
      w3a wa vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni cvv wcel
      vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq vz
      weu cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a wa vo
      cv vy cv cep vw cv vf cv wiso vf wex vo con0 wreu vo cv vy cv cep vw cv
      vf cv wiso vf wex vo con0 crab cuni con0 wcel vo cv vy cv cep vw cv vf cv
      wiso vf wex vo con0 crab cuni cvv wcel vy cv cA wss vw cv cA cA cxp wss
      vy cv vw cv wwe w3a vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 wreu
      cA cB wcel vy cv vw cv wwe vy cv cA wss vo cv vy cv cep vw cv vf cv wiso
      vf wex vo con0 wreu vw cv cA cA cxp wss vy cv cvv wcel vy cv vw cv wwe vo
      cv vy cv cep vw cv vf cv wiso vf wex vo con0 wreu vy visset vo vy cv cvv
      vw cv vf ordtype mpan 3ad2ant3 adantl vo cv vy cv cep vw cv vf cv wiso vf
      wex vo con0 reucl vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab
      cuni con0 elisset 3syl vz vo cv vy cv cep vw cv vf cv wiso vf wex vo con0
      crab cuni eueq sylib ex 19.21aivv vy cv cA wss vw cv cA cA cxp wss vy cv
      vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab
      cuni wceq vy vw vz fnoprabg vy cv cA wss vw cv cA cA cxp wss vy cv vw cv
      wwe w3a vy vw copab vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vz cv vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa
      vy vw vz copab2 fndm 3syl vy cv cA wss vw cv cA cA cxp wss vy cv vw cv
      wwe w3a vy vw copab cA cpw cA cA cxp cpw cxp wss cA cpw cA cA cxp cpw cxp
      cvv wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vy vw copab
      cvv wcel cA cB wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vy vw copab cA cpw cA cA cxp cpw cxp cvv ssexg vy cv cA wss vw cv cA cA
      cxp wss vy cv vw cv wwe w3a vy vw copab cA cpw cA cA cxp cpw cxp wss cA
      cB wcel vt vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vy vw
      copab cA cpw cA cA cxp cpw cxp vt cv vy cv cA wss vw cv cA cA cxp wss vy
      cv vw cv wwe w3a vy vw copab wcel vt cv vy cv vw cv cop wceq vy cv cA wss
      vw cv cA cA cxp wss vy cv vw cv wwe w3a wa vw wex vy wex vt cv cA cpw cA
      cA cxp cpw cxp wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a
      vy vw vt cv elopab vt cv vy cv vw cv cop wceq vy cv cA wss vw cv cA cA
      cxp wss vy cv vw cv wwe w3a wa vt cv cA cpw cA cA cxp cpw cxp wcel vy vw
      vt cv vy cv vw cv cop wceq vy cv cA wss vw cv cA cA cxp wss vy cv vw cv
      wwe w3a wa vt cv vy cv vw cv cop cA cpw cA cA cxp cpw cxp vt cv vy cv vw
      cv cop wceq vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a pm3.26
      vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vy cv vw cv cop cA
      cpw cA cA cxp cpw cxp wcel vt cv vy cv vw cv cop wceq vy cv cA wss vw cv
      cA cA cxp wss vy cv vw cv cop cA cpw cA cA cxp cpw cxp wcel vy cv vw cv
      wwe vy cv cA cpw wcel vw cv cA cA cxp cpw wcel vy cv vw cv cop cA cpw cA
      cA cxp cpw cxp wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv cA cpw
      cA cA cxp cpw opelxpi vy cv cA vy visset elpw vw cv cA cA cxp vw visset
      elpw syl2anbr 3adant3 adantl eqeltrd 19.23aivv sylbi ssriv a1i cA cpw cvv
      wcel cA cA cxp cpw cvv wcel cA cpw cA cA cxp cpw cxp cvv wcel cA cB wcel
      cA cpw cA cA cxp cpw cvv cvv xpexg cA cB pwexg cA cB wcel cA cA cxp cvv
      wcel cA cA cxp cpw cvv wcel cA cB wcel cA cA cxp cvv wcel cA cA cB cB
      xpexg anidms cA cA cxp cvv pwexg syl sylanc sylanc eqeltrd vy cv cA wss
      vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv
      wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 cdm cvv wcel vy cv
      cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw
      cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 wfun vy cv
      cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw
      cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 crn cvv
      wcel vy cv cA wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy
      cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq wa vy vw vz vz cv
      vo cv vy cv cep vw cv vf cv wiso vf wex vo con0 crab cuni wceq vy cv cA
      wss vw cv cA cA cxp wss vy cv vw cv wwe w3a vz vz vo cv vy cv cep vw cv
      vf cv wiso vf wex vo con0 crab cuni moeq moani funoprab cvv vy cv cA wss
      vw cv cA cA cxp wss vy cv vw cv wwe w3a vz cv vo cv vy cv cep vw cv vf cv
      wiso vf wex vo con0 crab cuni wceq wa vy vw vz copab2 funrnex mpi syl
      sylanc hartog.1 syl5eqel cH cvv elong syl mpbiri $.
      $( [22-Oct-2009] $) $( [15-Oct-2009] $)
  $}

  ${
    $d x y z A $.
    $( Any ordinal number is strictly dominated by some other ordinal
       number. $)
    onsdom $p |- ( A e. On -> E. x e. On A ~< x ) $=
      vy cv cA cdom wbr vy con0 crab con0 wcel cA vy cv cA cdom wbr vy con0
      crab csdm wbr cA vx cv csdm wbr vx con0 wrex cA con0 wcel cA vx cv csdm
      wbr cA vy cv cA cdom wbr vy con0 crab csdm wbr vx vy cv cA cdom wbr vy
      con0 crab con0 vx cv vy cv cA cdom wbr vy con0 crab cA csdm breq2 rcla4ev
      vy cA con0 vy cv cA cdom wbr vy con0 crab vy cv cA cdom wbr vy con0 crab
      eqid hartog cA con0 wcel cA vy cv cA cdom wbr vy con0 crab cdom wbr cA vy
      cv cA cdom wbr vy con0 crab cen wbr wn wa cA vy cv cA cdom wbr vy con0
      crab csdm wbr cA con0 wcel cA vy cv cA cdom wbr vy con0 crab cdom wbr cA
      vy cv cA cdom wbr vy con0 crab cen wbr wn cA con0 wcel cA vy cv cA cdom
      wbr vy con0 crab wss cA vy cv cA cdom wbr vy con0 crab cdom wbr cA con0
      wcel vz cA vy cv cA cdom wbr vy con0 crab cA con0 wcel vz cv cA wcel vz
      cv con0 wcel vz cv cA cdom wbr wa vz cv vy cv cA cdom wbr vy con0 crab
      wcel cA con0 wcel vz cv cA wcel vz cv con0 wcel vz cv cA cdom wbr cA con0
      wcel vz cv cA wcel vz cv con0 wcel cA vz cv onelon ex cA con0 wcel vz cv
      cA wcel vz cv cA wss vz cv cA cdom wbr cA vz cv onelss vz cv cvv wcel vz
      cv cA wss vz cv cA cdom wbr wi vz visset vz cv cA cvv ssdomg ax-mp syl6
      jcad vy cv cA cdom wbr vz cv cA cdom wbr vy vz cv con0 vy cv vz cv cA
      cdom breq1 elrab syl6ibr ssrdv cA vy cv cA cdom wbr vy con0 crab con0
      ssdomg mpd cA con0 wcel cA vy cv cA cdom wbr vy con0 crab cen wbr vy cv
      cA cdom wbr vy con0 crab cA cdom wbr cA con0 wcel vy cv cA cdom wbr vy
      con0 crab cA cdom wbr vy cv cA cdom wbr vy con0 crab vy cv cA cdom wbr vy
      con0 crab wcel cA con0 wcel vy cv cA cdom wbr vy con0 crab con0 wcel vy
      cv cA cdom wbr vy con0 crab word vy cv cA cdom wbr vy con0 crab vy cv cA
      cdom wbr vy con0 crab wcel wn vy cA con0 vy cv cA cdom wbr vy con0 crab
      vy cv cA cdom wbr vy con0 crab eqid hartog vy cv cA cdom wbr vy con0 crab
      eloni vy cv cA cdom wbr vy con0 crab ordirr 3syl cA con0 wcel vy cv cA
      cdom wbr vy con0 crab cA cdom wbr vy cv cA cdom wbr vy con0 crab con0
      wcel vy cv cA cdom wbr vy con0 crab cA cdom wbr wa vy cv cA cdom wbr vy
      con0 crab vy cv cA cdom wbr vy con0 crab wcel cA con0 wcel vy cv cA cdom
      wbr vy con0 crab cA cdom wbr vy cv cA cdom wbr vy con0 crab con0 wcel cA
      con0 wcel vy cv cA cdom wbr vy con0 crab con0 wcel vy cv cA cdom wbr vy
      con0 crab cA cdom wbr vy cA con0 vy cv cA cdom wbr vy con0 crab vy cv cA
      cdom wbr vy con0 crab eqid hartog a1d ancrd vy cv cA cdom wbr vy con0
      crab con0 wcel vy cv cA cdom wbr vy con0 crab cA cdom wbr wa vy cv cA
      cdom wbr vy con0 crab vz cv cA cdom wbr vz con0 crab wcel vy cv cA cdom
      wbr vy con0 crab vy cv cA cdom wbr vy con0 crab wcel vz cv cA cdom wbr vy
      cv cA cdom wbr vy con0 crab cA cdom wbr vz vy cv cA cdom wbr vy con0 crab
      con0 vz cv vy cv cA cdom wbr vy con0 crab cA cdom breq1 elrab vz cv cA
      cdom wbr vz con0 crab vy cv cA cdom wbr vy con0 crab vy cv cA cdom wbr vy
      con0 crab vz cv cA cdom wbr vy cv cA cdom wbr vz vy con0 vz cv vy cv cA
      cdom breq1 cbvrabv eleq2i bitr3i syl6ib mtod cA con0 wcel cA vy cv cA
      cdom wbr vy con0 crab cen wbr vy cv cA cdom wbr vy con0 crab cA cen wbr
      vy cv cA cdom wbr vy con0 crab cA cdom wbr cA con0 wcel vy cv cA cdom wbr
      vy con0 crab con0 wcel cA vy cv cA cdom wbr vy con0 crab cen wbr vy cv cA
      cdom wbr vy con0 crab cA cen wbr wi vy cA con0 vy cv cA cdom wbr vy con0
      crab vy cv cA cdom wbr vy con0 crab eqid hartog cA vy cv cA cdom wbr vy
      con0 crab con0 ensymg syl vy cv cA cdom wbr vy con0 crab cA endom syl6
      mtod jca cA vy cv cA cdom wbr vy con0 crab brsdom sylibr sylanc $.
      $( [22-Oct-2009] $) $( [22-Oct-2009] $)
  $}

  ${
    $d w x y z A $.
    $( The initial ordinal of a successor index is the smallest ordinal
       strictly larger than the previous initial ordinal. $)
    omsubsuc $p |- ( A e. On -> ( aleph ` suc A ) = |^| { x e. On | ( aleph ` A
    ) ~< x } ) $=
      cA con0 wcel cA csuc vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy
      vz copab com crdg cfv cA cale cfv vx cv csdm wbr vx con0 crab cint cA
      csuc cale cfv cA con0 wcel cA csuc vz cv vy cv vw cv csdm wbr vw con0
      crab cint wceq vy vz copab com crdg cfv cA vz cv vy cv vw cv csdm wbr vw
      con0 crab cint wceq vy vz copab com crdg cfv vz cv vy cv vw cv csdm wbr
      vw con0 crab cint wceq vy vz copab cfv cA cale cfv vx cv csdm wbr vx con0
      crab cint com cA vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz
      copab rdgsuc cA con0 wcel cA cale cfv vz cv vy cv vw cv csdm wbr vw con0
      crab cint wceq vy vz copab cfv cA cale cfv vx cv csdm wbr vx con0 crab
      cint cA vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab com
      crdg cfv vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab
      cfv vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab wfun cA
      cale cfv cA cale cfv vx cv csdm wbr vx con0 crab cint cop vz cv vy cv vw
      cv csdm wbr vw con0 crab cint wceq vy vz copab wcel cA cale cfv vz cv vy
      cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab cfv cA cale cfv vx
      cv csdm wbr vx con0 crab cint wceq cA con0 wcel cA cale cfv cA cale cfv
      vx cv csdm wbr vx con0 crab cint vz cv vy cv vw cv csdm wbr vw con0 crab
      cint wceq vy vz copab cA cale cfv vx cv csdm wbr vx con0 wrex cA cale cfv
      vx cv csdm wbr vx con0 crab cint cvv wcel cA cale cfv con0 wcel cA cale
      cfv vx cv csdm wbr vx con0 wrex cA alephon vx cA cale cfv onsdom ax-mp cA
      cale cfv vx cv csdm wbr vx con0 intexrab mpbi funopfv vz cv vy cv vw cv
      csdm wbr vw con0 crab cint wceq vy vz copab wfun cA con0 wcel vy vz vy cv
      vw cv csdm wbr vw con0 crab cint funopabeq a1i cA con0 wcel cA cale cfv
      vx cv csdm wbr vx con0 crab cint cA cale cfv vw cv csdm wbr vw con0 crab
      cint wceq cA cale cfv cA cale cfv vx cv csdm wbr vx con0 crab cint cop vz
      cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab wcel cA cale
      cfv vx cv csdm wbr vx con0 crab cint cA cale cfv vw cv csdm wbr vw con0
      crab cint wceq cA con0 wcel cA cale cfv vx cv csdm wbr vx con0 crab cA
      cale cfv vw cv csdm wbr vw con0 crab cA cale cfv vx cv csdm wbr cA cale
      cfv vw cv csdm wbr vx vw con0 vx cv vw cv cA cale cfv csdm breq2 cbvrabv
      inteqi a1i vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vz cv cA
      cale cfv vw cv csdm wbr vw con0 crab cint wceq cA cale cfv vx cv csdm wbr
      vx con0 crab cint cA cale cfv vw cv csdm wbr vw con0 crab cint wceq vy vz
      cA cale cfv cA cale cfv vx cv csdm wbr vx con0 crab cint cA cale fvex cA
      cale cfv vx cv csdm wbr vx con0 wrex cA cale cfv vx cv csdm wbr vx con0
      crab cint cvv wcel cA cale cfv con0 wcel cA cale cfv vx cv csdm wbr vx
      con0 wrex cA alephon vx cA cale cfv onsdom ax-mp cA cale cfv vx cv csdm
      wbr vx con0 intexrab mpbi vy cv cA cale cfv wceq vy cv vw cv csdm wbr vw
      con0 crab cint cA cale cfv vw cv csdm wbr vw con0 crab cint vz cv vy cv
      cA cale cfv wceq vy cv vw cv csdm wbr vw con0 crab cA cale cfv vw cv csdm
      wbr vw con0 crab vy cv cA cale cfv wceq vy cv vw cv csdm wbr cA cale cfv
      vw cv csdm wbr vw con0 vy cv cA cale cfv vw cv csdm breq1 rabbisdv inteqd
      eqeq2d vz cv cA cale cfv vx cv csdm wbr vx con0 crab cint cA cale cfv vw
      cv csdm wbr vw con0 crab cint eqeq1 opelopab sylibr sylc cA cale cfv vz
      cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab cfv cA vz cv
      vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab com crdg cfv vz
      cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab cfv cA cale
      cfv cA vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab com
      crdg cfv vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab cA
      cale vz cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab com
      crdg vy vz vw df-aleph fveq1i fveq2i eqcomi syl5eq eqtrd cA csuc cale vz
      cv vy cv vw cv csdm wbr vw con0 crab cint wceq vy vz copab com crdg vy vz
      vw df-aleph fveq1i syl5eq $.
      $( [23-Oct-2009] $) $( [23-Oct-2009] $)
  $}

  ${
    $d x y z A $.
    $( An initial ordinal with successor index. $)
    omsubsuc2 $p |- ( A e. On -> ( aleph ` suc A ) = { x e. On | x ~<_ ( aleph
    ` A ) } ) $=
      cA con0 wcel cA csuc cale cfv cA cale cfv vx cv csdm wbr vx con0 crab
      cint vx cv cA cale cfv cdom wbr vx con0 crab vx cA omsubsuc cA con0 wcel
      vy cA cale cfv vx cv csdm wbr vx con0 crab cint vx cv cA cale cfv cdom
      wbr vx con0 crab cA con0 wcel vy cv cA cale cfv vx cv csdm wbr vx con0
      crab cint wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr wa vy cv vx cv
      cA cale cfv cdom wbr vx con0 crab wcel cA con0 wcel vy cv cA cale cfv vx
      cv csdm wbr vx con0 crab cint wcel vy cv con0 wcel vy cv cA cale cfv cdom
      wbr wa cA con0 wcel vy cv cA cale cfv vx cv csdm wbr vx con0 crab cint
      wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr wa cA con0 wcel vy cv cA
      cale cfv vx cv csdm wbr vx con0 crab cint wcel wa vy cv con0 wcel vy cv
      cA cale cfv cdom wbr cA con0 wcel vy cv cA cale cfv vx cv csdm wbr vx
      con0 crab cint wcel cA cale cfv vx cv csdm wbr vx con0 crab cint con0
      wcel vy cv con0 wcel cA cale cfv vx cv csdm wbr vx con0 crab cint con0
      wcel cA con0 wcel vy cv cA cale cfv vx cv csdm wbr vx con0 crab cint wcel
      wa cA cale cfv vx cv csdm wbr vx con0 wrex cA cale cfv vx cv csdm wbr vx
      con0 crab cint con0 wcel cA cale cfv con0 wcel cA cale cfv vx cv csdm wbr
      vx con0 wrex cA alephon vx cA cale cfv onsdom ax-mp cA cale cfv vx cv
      csdm wbr vx onintrab2 mpbi a1i cA cale cfv vx cv csdm wbr vx con0 crab
      cint vy cv onelon sylancom cA con0 wcel vy cv cA cale cfv vx cv csdm wbr
      vx con0 crab cint wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr wi cA
      con0 wcel vy cv con0 wcel vy cv cA cale cfv vx cv csdm wbr vx con0 crab
      cint wcel vy cv cA cale cfv cdom wbr cA con0 wcel vy cv con0 wcel vy cv
      cA cale cfv vx cv csdm wbr vx con0 crab cint wcel vy cv cA cale cfv cdom
      wbr wi cA con0 wcel vy cv con0 wcel wa vy cv cA cale cfv vx cv csdm wbr
      vx con0 crab cint wcel cA cale cfv vy cv csdm wbr wn vy cv cA cale cfv
      cdom wbr vy cv con0 wcel vy cv cA cale cfv vx cv csdm wbr vx con0 crab
      cint wcel cA cale cfv vy cv csdm wbr wn wi cA con0 wcel cA cale cfv vx cv
      csdm wbr cA cale cfv vy cv csdm wbr vx vy cv vx cv vy cv cA cale cfv csdm
      breq2 onnminsb adantl vy cv con0 wcel vy cv cA cale cfv cdom wbr cA cale
      cfv vy cv csdm wbr wn wb cA con0 wcel vy cv con0 wcel cA cale cfv con0
      wcel vy cv cA cale cfv cdom wbr cA cale cfv vy cv csdm wbr wn wb cA
      alephon vy cv cA cale cfv dmsdtriord mpan2 adantl sylibrd ex com23 imp
      jcai ex cA con0 wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr wa vz cv
      cA cale cfv vx cv csdm wbr vx con0 crab wcel vy cv vz cv wcel wi vz wal
      vy cv cA cale cfv vx cv csdm wbr vx con0 crab cint wcel cA con0 wcel vy
      cv con0 wcel vy cv cA cale cfv cdom wbr wa vz cv cA cale cfv vx cv csdm
      wbr vx con0 crab wcel vy cv vz cv wcel wi vz cA con0 wcel vy cv con0 wcel
      vy cv cA cale cfv cdom wbr wa vz cv con0 wcel cA cale cfv vz cv csdm wbr
      wa vy cv vz cv wcel vz cv cA cale cfv vx cv csdm wbr vx con0 crab wcel cA
      con0 wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr wa vz cv con0 wcel
      cA cale cfv vz cv csdm wbr wa vy cv vz cv wcel cA con0 wcel vy cv con0
      wcel vy cv cA cale cfv cdom wbr wa wa vz cv con0 wcel cA cale cfv vz cv
      csdm wbr wa wa vy cv vz cv wcel vz cv vy cv wss wn cA con0 wcel vy cv
      con0 wcel vy cv cA cale cfv cdom wbr wa wa vz cv con0 wcel cA cale cfv vz
      cv csdm wbr wa wa vz cv vy cv wss cA cale cfv cA cale cfv csdm wbr cA
      cale cfv sdomirr cA con0 wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr
      wa wa vz cv con0 wcel cA cale cfv vz cv csdm wbr wa vz cv vy cv wss cA
      cale cfv cA cale cfv csdm wbr cA cale cfv vz cv csdm wbr vz cv cA cale
      cfv cdom wbr cA cale cfv cA cale cfv csdm wbr cA con0 wcel vy cv con0
      wcel vy cv cA cale cfv cdom wbr wa wa vz cv con0 wcel cA cale cfv vz cv
      csdm wbr wa vz cv vy cv wss wa wa cA cale cfv cvv wcel cA cale cfv vz cv
      csdm wbr vz cv cA cale cfv cdom wbr wa cA cale cfv cA cale cfv csdm wbr
      wi cA cale fvex cA cale cfv vz cv cA cale cfv cvv sdomdomtr ax-mp cA con0
      wcel vy cv con0 wcel vy cv cA cale cfv cdom wbr wa wa vz cv con0 wcel cA
      cale cfv vz cv csdm wbr vz cv vy cv wss simprlr vz cv vy cv cdom wbr vy
      cv cA cale cfv cdom wbr vz cv cA cale cfv cdom wbr cA con0 wcel vy cv
      con0 wcel vy cv cA cale cfv cdom wbr wa wa vz cv con0 wcel cA cale cfv vz
      cv csdm wbr wa vz cv vy cv wss wa wa vz cv vy cv cA cale cfv domtr vz cv
      vy cv wss vz cv vy cv cdom wbr cA con0 wcel vy cv con0 wcel vy cv cA cale
      cfv cdom wbr wa wa vz cv con0 wcel cA cale cfv vz cv csdm wbr wa vz cv
      cvv wcel vz cv vy cv wss vz cv vy cv cdom wbr wi vz visset vz cv vy cv
      cvv ssdomg ax-mp ad2antll cA con0 wcel vy cv con0 wcel vy cv cA cale cfv
      cdom wbr vz cv con0 wcel cA cale cfv vz cv csdm wbr wa vz cv vy cv wss wa
      simplrr sylanc sylanc expr mtoi vy cv con0 wcel vy cv cA cale cfv cdom
      wbr wa vz cv con0 wcel vy cv vz cv wcel vz cv vy cv wss wn wb cA con0
      wcel cA cale cfv vz cv csdm wbr vy cv con0 wcel vz cv con0 wcel vy cv vz
      cv wcel vz cv vy cv wss wn wb vy cv cA cale cfv cdom wbr vy cv con0 wcel
      vz cv con0 wcel wa vz cv vy cv wss vy cv vz cv wcel vz cv con0 wcel vy cv
      con0 wcel vz cv vy cv wss vy cv vz cv wcel wn wb vz cv word vy cv word vz
      cv vy cv wss vy cv vz cv wcel wn wb vz cv con0 wcel vy cv con0 wcel vz cv
      vy cv ordtri1 vz cv eloni vy cv eloni syl2an ancoms con2bid adantlr
      ad2ant2lr mpbird exp31 cA cale cfv vx cv csdm wbr cA cale cfv vz cv csdm
      wbr vx vz cv con0 vx cv vz cv cA cale cfv csdm breq2 elrab syl7ib
      19.21adv vz vy cv cA cale cfv vx cv csdm wbr vx con0 crab vy visset elint
      syl6ibr impbid vx cv cA cale cfv cdom wbr vy cv cA cale cfv cdom wbr vx
      vy cv con0 vx cv vy cv cA cale cfv cdom breq1 elrab syl6bbr eqrdv eqtrd
      $.
      $( [26-Oct-2009] $) $( [26-Oct-2009] $)
  $}

  ${
    $d j k m x y z A $. $d j k m x y z B $.
    $( Lemma for ~ omsubsdom . $)
    omsubsdomlem1 $p |- ( A e. On -> ( aleph ` A ) ~< ( aleph ` suc A ) ) $=
      cA con0 wcel cA cale cfv cA cale cfv vz cv csdm wbr vz con0 crab cint cA
      csuc cale cfv csdm cA con0 wcel cA cale cfv vz cv csdm wbr vz con0 wrex
      cA cale cfv cA cale cfv vz cv csdm wbr vz con0 crab cint csdm wbr cA cale
      cfv vz cv csdm wbr vz con0 wrex cA con0 wcel cA cale cfv con0 wcel cA
      cale cfv vz cv csdm wbr vz con0 wrex cA alephon vz cA cale cfv onsdom
      ax-mp a1i cA cale cfv vz cv csdm wbr cA cale cfv cA cale cfv vz cv csdm
      wbr vz con0 crab cint csdm wbr vz vz vm cA cale cfv cA cale cfv vz cv
      csdm wbr vz con0 crab cint csdm vm cv cA cale cfv wcel vz ax-17 vm cv
      csdm wcel vz ax-17 vz vm cA cale cfv vz cv csdm wbr vz con0 crab cA cale
      cfv vz cv csdm wbr vz vm con0 hbrab1 hbint hbbr vz cv cA cale cfv vz cv
      csdm wbr vz con0 crab cint cA cale cfv csdm breq2 onminsb syl vz cA
      omsubsuc breqtrrd $.
      $( [23-Oct-2009] $) $( [23-Oct-2009] $)

  $( Lemma for ~ omsubsdom . $)
  omsubsdomlem2 $p |- ( ( A e. On /\ B e. On ) -> ( A e. B -> ( aleph ` A ) ~<
  ( aleph ` B ) ) ) $=
    cB con0 wcel cA cB wcel cA cale cfv cB cale cfv csdm wbr wi cA con0 wcel cB
    con0 wcel cA cB wcel cA cale cfv cB cale cfv csdm wbr cA cale cfv vk cv
    cale cfv csdm wbr cA cale cfv cA csuc cale cfv csdm wbr cA cale cfv vj cv
    cale cfv csdm wbr cA cale cfv vj cv csuc cale cfv csdm wbr cA cale cfv cB
    cale cfv csdm wbr vk vj cB cA vk cv cA csuc wceq vk cv cale cfv cA csuc
    cale cfv cA cale cfv csdm vk cv cA csuc cale fveq2 breq2d vk cv vj cv wceq
    vk cv cale cfv vj cv cale cfv cA cale cfv csdm vk cv vj cv cale fveq2
    breq2d vk cv vj cv csuc wceq vk cv cale cfv vj cv csuc cale cfv cA cale cfv
    csdm vk cv vj cv csuc cale fveq2 breq2d vk cv cB wceq vk cv cale cfv cB
    cale cfv cA cale cfv csdm vk cv cB cale fveq2 breq2d cA omsubsdomlem1 cA
    cale cfv vj cv cale cfv csdm wbr vj cv con0 wcel cA vj cv wcel wa cA cale
    cfv vj cv csuc cale cfv csdm wbr cA cale cfv vj cv cale cfv csdm wbr vj cv
    cale cfv vj cv csuc cale cfv csdm wbr cA cale cfv vj cv csuc cale cfv csdm
    wbr vj cv con0 wcel cA vj cv wcel wa cA cale cfv vj cv cale cfv vj cv csuc
    cale cfv sdomtr vj cv con0 wcel vj cv cale cfv vj cv csuc cale cfv csdm wbr
    cA vj cv wcel vj cv omsubsdomlem1 adantr sylan2 expcom vk cv wlim cA vk cv
    wcel wa cA vj cv wcel cA cale cfv vj cv cale cfv csdm wbr wi vj vk cv wral
    cA cale cfv vk cv cale cfv csdm wbr vk cv wlim cA vk cv wcel wa cA vj cv
    wcel cA cale cfv vj cv cale cfv csdm wbr wi vj vk cv wral wa cA cale cfv vj
    vk cv vj cv cale cfv ciun vk cv cale cfv csdm cA vj cv wcel vj cv vk cv
    wcel wa vj wex cA vj cv wcel cA cale cfv vj cv cale cfv csdm wbr wi vj vk
    cv wral cA cale cfv vj vk cv vj cv cale cfv ciun csdm wbr vk cv wlim cA vk
    cv wcel wa cA vj cv wcel vj cv vk cv wcel wa vj wex cA vj cv wcel cA cale
    cfv vj cv cale cfv csdm wbr wi vj vk cv wral cA cale cfv vj vk cv vj cv
    cale cfv ciun csdm wbr cA vj cv wcel vj cv vk cv wcel wa cA vj cv wcel cA
    cale cfv vj cv cale cfv csdm wbr wi vj vk cv wral cA cale cfv vj vk cv vj
    cv cale cfv ciun csdm wbr wi vj cA vj cv wcel cA cale cfv vj cv cale cfv
    csdm wbr wi vj vk cv wral cA cale cfv vj vk cv vj cv cale cfv ciun csdm wbr
    vj cA vj cv wcel cA cale cfv vj cv cale cfv csdm wbr wi vj vk cv hbra1 vj
    vm cA cale cfv vj vk cv vj cv cale cfv ciun csdm vm cv cA cale cfv wcel vj
    ax-17 vm cv csdm wcel vj ax-17 vj vm vk cv vj cv cale cfv hbiu1 hbbr hbim
    cA vj cv wcel vj cv vk cv wcel wa cA vj cv wcel cA cale cfv vj cv cale cfv
    csdm wbr wi vj vk cv wral cA vj cv wcel cA cale cfv vj cv cale cfv csdm wbr
    wi cA cale cfv vj vk cv vj cv cale cfv ciun csdm wbr vj cv vk cv wcel cA vj
    cv wcel cA cale cfv vj cv cale cfv csdm wbr wi vj vk cv wral cA vj cv wcel
    cA cale cfv vj cv cale cfv csdm wbr wi wi cA vj cv wcel cA vj cv wcel cA
    cale cfv vj cv cale cfv csdm wbr wi vj vk cv wral vj cv vk cv wcel cA vj cv
    wcel cA cale cfv vj cv cale cfv csdm wbr wi cA vj cv wcel cA cale cfv vj cv
    cale cfv csdm wbr wi vj vk cv ra4 com12 adantl vj cv vk cv wcel cA vj cv
    wcel cA vj cv wcel cA cale cfv vj cv cale cfv csdm wbr wi cA cale cfv vj vk
    cv vj cv cale cfv ciun csdm wbr wi vj cv vk cv wcel cA vj cv wcel cA cale
    cfv vj cv cale cfv csdm wbr wi cA vj cv wcel cA cale cfv vj vk cv vj cv
    cale cfv ciun csdm wbr vj cv vk cv wcel cA cale cfv vj cv cale cfv csdm wbr
    cA cale cfv vj vk cv vj cv cale cfv ciun csdm wbr cA vj cv wcel cA cale cfv
    vj cv cale cfv csdm wbr vj cv vk cv wcel cA cale cfv vj vk cv vj cv cale
    cfv ciun csdm wbr cA cale cfv vj cv cale cfv csdm wbr vj cv cale cfv vj vk
    cv vj cv cale cfv ciun cdom wbr cA cale cfv vj vk cv vj cv cale cfv ciun
    csdm wbr vj cv vk cv wcel vj vk cv vj cv cale cfv ciun cvv wcel cA cale cfv
    vj cv cale cfv csdm wbr vj cv cale cfv vj vk cv vj cv cale cfv ciun cdom
    wbr wa cA cale cfv vj vk cv vj cv cale cfv ciun csdm wbr wi vj vk cv vj cv
    cale cfv vk visset vj cv cale fvex iunex cA cale cfv vj cv cale cfv vj vk
    cv vj cv cale cfv ciun cvv sdomdomtr ax-mp vj cv cale cfv cvv wcel vj cv
    cale cfv vj vk cv vj cv cale cfv ciun wss vj cv cale cfv vj vk cv vj cv
    cale cfv ciun cdom wbr vj cv vk cv wcel vj cv cale cfv vj vk cv vj cv cale
    cfv ciun cvv ssdomg vj cv cale cfv cvv wcel vj cv vk cv wcel vj cv cale
    fvex a1i vj vk cv vj cv cale cfv ssiun2 sylc sylan2 expcom imim2d com23
    impcom syld 19.23ai imp vk cv wlim cA vk cv wcel wa cA vk cv cuni wcel cA
    vj cv wcel vj cv vk cv wcel wa vj wex vk cv wlim cA vk cv wcel cA vk cv
    cuni wcel vk cv wlim vk cv vk cv cuni cA vk cv limuni eleq2d biimpa vj cA
    vk cv eluni sylib sylan vk cv wlim cA vk cv wcel wa cA vj cv wcel cA cale
    cfv vj cv cale cfv csdm wbr wi vj vk cv wral wa vk cv cale cfv vj vk cv vj
    cv cale cfv ciun vk cv wlim vk cv cale cfv vj vk cv vj cv cale cfv ciun
    wceq cA vk cv wcel cA vj cv wcel cA cale cfv vj cv cale cfv csdm wbr wi vj
    vk cv wral vk cv cvv wcel vk cv wlim vk cv cale cfv vj vk cv vj cv cale cfv
    ciun wceq vk visset vj vk cv cvv alephlim mpan ad2antrr eqcomd breqtrd ex
    tfindsg2 ex adantl $.
    $( [23-Oct-2009] $) $( [23-Oct-2009] $)

    $( Relationship between ordering on ordinal numbers and strict dominance of
       infinite initial ordinal numbers, which are frequently denoted by omega
       with an ordinal number subscript. The ` aleph ` notation is being
       recycled for this purpose, although the aleph function does not have the
       same meaning if Choice is not assumed. (Closure is given by ~ alephon ,
       which does not use Choice.) $)
    omsubsdom $p |- ( ( A e. On /\ B e. On ) -> ( A e. B <-> ( aleph ` A ) ~< (
    aleph ` B ) ) ) $=
      cA con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale cfv csdm wbr
      cA cB omsubsdomlem2 cA con0 wcel cB con0 wcel wa cA cB wcel wn cA cB wceq
      cB cA wcel wo cA cale cfv cB cale cfv csdm wbr wn cA con0 wcel cB con0
      wcel wa cA cB wceq cB cA wcel wo cA cB wcel wn cA con0 wcel cB con0 wcel
      wa cA cB wcel cA cB wceq cB cA wcel wo cA word cB word cA cB wcel cA cB
      wceq cB cA wcel wo wn wb cA con0 wcel cB con0 wcel cA cB ordtri2 cA eloni
      cB eloni syl2an con2bid bicomd cA con0 wcel cB con0 wcel wa cA cB wceq cA
      cale cfv cB cale cfv csdm wbr wn cB cA wcel cA con0 wcel cB con0 wcel wa
      cA cB wceq cA cale cfv cB cale cfv csdm wbr wn cA con0 wcel cB con0 wcel
      wa cA cB wceq wa cA cale cfv cB cale cfv csdm wbr cA cale cfv cB cale cfv
      cen wbr cA cale cfv cvv wcel cA cale cfv cB cale cfv wceq cA cale cfv cB
      cale cfv cen wbr cA con0 wcel cB con0 wcel wa cA cB wceq wa cA cale cfv
      cB cale cfv cvv eqeng cA cale cfv cvv wcel cA con0 wcel cB con0 wcel wa
      cA cB wceq wa cA cale fvex a1i cA cB wceq cA cale cfv cB cale cfv wceq cA
      con0 wcel cB con0 wcel wa cA cB cale fveq2 adantl sylc cA cale cfv cB
      cale cfv csdm wbr cA cale cfv cB cale cfv cen wbr wn wi cA con0 wcel cB
      con0 wcel wa cA cB wceq wa cA cale cfv cB cale cfv csdm wbr cA cale cfv
      cB cale cfv cdom wbr cA cale cfv cB cale cfv cen wbr wn cA cale cfv cB
      cale cfv brsdom pm3.27bi a1i mt2d ex cA con0 wcel cB con0 wcel wa cB cA
      wcel cA cale cfv cB cale cfv csdm wbr wn cA con0 wcel cB con0 wcel wa cB
      cA wcel wa cA cale cfv cB cale cfv csdm wbr cA cale cfv cB cale cfv cen
      wbr cA cale cfv cB cale cfv csdm wbr cA con0 wcel cB con0 wcel wa cB cA
      wcel wa cA cale cfv cB cale cfv cen wbr cA cale cfv cB cale cfv cdom wbr
      cB cale cfv cA cale cfv cdom wbr cA cale cfv cB cale cfv cen wbr cA cale
      cfv cB cale cfv csdm wbr cA con0 wcel cB con0 wcel wa cB cA wcel wa cA
      cale cfv cB cale cfv sbth cA cale cfv cB cale cfv sdomdom cA con0 wcel cB
      con0 wcel wa cB cA wcel cB cale cfv cA cale cfv cdom wbr cB con0 wcel cA
      con0 wcel cB cA wcel cB cale cfv cA cale cfv cdom wbr wi cB con0 wcel cA
      con0 wcel wa cB cA wcel cB cale cfv cA cale cfv csdm wbr cB cale cfv cA
      cale cfv cdom wbr cB cA omsubsdomlem2 cB cale cfv cA cale cfv sdomdom
      syl6 ancoms imp syl2an expcom cA cale cfv cB cale cfv csdm wbr cA cale
      cfv cB cale cfv cen wbr wn wi cA con0 wcel cB con0 wcel wa cB cA wcel wa
      cA cale cfv cB cale cfv sdomnen a1i pm2.65d ex jaod sylbid impbid3 $.
      $( [23-Oct-2009] $) $( [23-Oct-2009] $)
  $}

  ${
    $( Relationship between inclusion of ordinal numbers and dominance of
       infinite initial ordinals. $)
    omsubdom $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B <-> ( aleph ` A ) ~<_ (
    aleph ` B ) ) ) $=
      cA con0 wcel cB con0 wcel wa cA cB wss cA cale cfv cB cale cfv cdom wbr
      cA con0 wcel cB con0 wcel wa cA cB wss cA cB wcel cA cB wceq wo cA cale
      cfv cB cale cfv cdom wbr cA word cB word cA cB wss cA cB wcel cA cB wceq
      wo wb cA con0 wcel cB con0 wcel cA cB ordsseleq cA eloni cB eloni syl2an
      cA con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale cfv cdom wbr
      cA cB wceq cA con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale
      cfv csdm wbr cA cale cfv cB cale cfv cdom wbr cA cB omsubsdom cA cale cfv
      cB cale cfv sdomdom syl6bi cA con0 wcel cB con0 wcel wa cA cB wceq cA
      cale cfv cB cale cfv cen wbr cA cale cfv cB cale cfv cdom wbr cA cB wceq
      cA cale cfv cB cale cfv cen wbr wi cA con0 wcel cB con0 wcel wa cA cB
      wceq cA cale cfv cB cale cfv wceq cA cale cfv cB cale cfv cen wbr cA cB
      cale fveq2 cA cale cfv cvv wcel cA cale cfv cB cale cfv wceq cA cale cfv
      cB cale cfv cen wbr wi cA cale fvex cA cale cfv cB cale cfv cvv eqeng
      ax-mp syl a1i cA cale cfv cB cale cfv endom syl6 jaod sylbid cA con0 wcel
      cB con0 wcel wa cA cB wss wn cB cA wcel cA cale cfv cB cale cfv cdom wbr
      wn cA con0 wcel cB con0 wcel wa cB cA wcel cA cB wss cA con0 wcel cB con0
      wcel wa cB cA wcel cA cB wss cB con0 wcel cA con0 wcel cB cA wcel cA cB
      wss wo cB word cA word cB cA wcel cA cB wss wo cB con0 wcel cA con0 wcel
      cB cA ordtri2or cB eloni cA eloni syl2an ancoms ord con1d cA con0 wcel cB
      con0 wcel wa cB cA wcel cB cale cfv cA cale cfv csdm wbr cA cale cfv cB
      cale cfv cdom wbr wn cB con0 wcel cA con0 wcel cB cA wcel cB cale cfv cA
      cale cfv csdm wbr wb cB cA omsubsdom ancoms cB cale cfv cA cale cfv csdm
      wbr cA cale cfv cB cale cfv cdom wbr cB cale cfv cA cale cfv cen wbr cB
      cale cfv cA cale cfv sdomnen cB cale cfv cA cale cfv csdm wbr cB cale cfv
      cA cale cfv cdom wbr cA cale cfv cB cale cfv cdom wbr cB cale cfv cA cale
      cfv cen wbr wi cB cale cfv cA cale cfv sdomdom cB cale cfv cA cale cfv
      cdom wbr cA cale cfv cB cale cfv cdom wbr cB cale cfv cA cale cfv cen wbr
      cB cale cfv cA cale cfv sbth ex syl mtod syl6bi syld impbid3 $.
      $( [23-Oct-2009] $) $( [23-Oct-2009] $)
  $}

  $( Relationship between ordering of ordinal numbers and ordering of
     infinite initial ordinals. $)
  omsubel $p |- ( ( A e. On /\ B e. On ) -> ( A e. B <-> ( aleph ` A ) e.
  ( aleph ` B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale cfv wcel cA
    con0 wcel cB con0 wcel wa cA cB wcel cA cale cfv cB cale cfv csdm wbr cA
    cale cfv cB cale cfv wcel cA cB omsubsdom cA con0 wcel cB con0 wcel wa cA
    cale cfv cB cale cfv wcel cA cale cfv cB cale cfv csdm wbr cA con0 wcel cB
    con0 wcel wa cB cale cfv cA cale cfv wss cA cale cfv cB cale cfv csdm wbr
    wn cA cale cfv cB cale cfv wcel wn cA con0 wcel cB con0 wcel wa cB cale cfv
    cA cale cfv wss cA cale cfv cB cale cfv csdm wbr wn cA con0 wcel cB con0
    wcel wa cB cale cfv cA cale cfv wss wa cA cale cfv cB cale cfv csdm wbr cA
    cale cfv cB cale cfv cen wbr cA con0 wcel cB con0 wcel wa cB cale cfv cA
    cale cfv wss wa cA cale cfv cB cale cfv cdom wbr cA cale cfv cB cale cfv
    cen wbr cA cale cfv cB cale cfv csdm wbr cB cale cfv cA cale cfv wss cA
    cale cfv cB cale cfv cdom wbr cA cale cfv cB cale cfv cen wbr wi cA con0
    wcel cB con0 wcel wa cA cale cfv cB cale cfv cdom wbr cB cale cfv cA cale
    cfv wss cA cale cfv cB cale cfv cen wbr cA cale cfv cB cale cfv cdom wbr cB
    cale cfv cA cale cfv cdom wbr cA cale cfv cB cale cfv cen wbr cB cale cfv
    cA cale cfv wss cA cale cfv cB cale cfv sbth cB cale cfv cvv wcel cB cale
    cfv cA cale cfv wss cB cale cfv cA cale cfv cdom wbr wi cB cale fvex cB
    cale cfv cA cale cfv cvv ssdomg ax-mp sylan2 expcom adantl cA cale cfv cB
    cale cfv sdomdom syl5 cA cale cfv cB cale cfv csdm wbr cA cale cfv cB cale
    cfv cen wbr wn wi cA con0 wcel cB con0 wcel wa cB cale cfv cA cale cfv wss
    wa cA cale cfv cB cale cfv sdomnen a1i pm2.65d ex cA cale cfv cB cale cfv
    wcel cB cale cfv cA cale cfv wss cA cale cfv word cB cale cfv word cA cale
    cfv cB cale cfv wcel cB cale cfv cA cale cfv wss wo cA cale cfv con0 wcel
    cA cale cfv word cA alephon cA cale cfv eloni ax-mp cB cale cfv con0 wcel
    cB cale cfv word cB alephon cB cale cfv eloni ax-mp cA cale cfv cB cale cfv
    ordtri2or mp2an ori syl5 con4d sylbid cA con0 wcel cB con0 wcel wa cA cale
    cfv cB cale cfv wcel cA cB wcel cA con0 wcel cB con0 wcel wa cA cale cfv cB
    cale cfv wcel wa cA cB wss cA cB wcel cA con0 wcel cB con0 wcel wa cA cale
    cfv cB cale cfv wcel wa cA cB wss cA cale cfv cB cale cfv cdom wbr cA cale
    cfv cB cale cfv wcel cA cale cfv cB cale cfv cdom wbr cA con0 wcel cB con0
    wcel wa cA cale cfv cB cale cfv wcel cA cale cfv cB cale cfv wss cA cale
    cfv cB cale cfv cdom wbr cB cale cfv con0 wcel cA cale cfv cB cale cfv wcel
    cA cale cfv cB cale cfv wss wi cB alephon cB cale cfv cA cale cfv onelss
    ax-mp cA cale cfv con0 wcel cA cale cfv cB cale cfv wss cA cale cfv cB cale
    cfv cdom wbr wi cA alephon cA cale cfv cB cale cfv con0 ssdomg ax-mp syl
    adantl cA con0 wcel cB con0 wcel wa cA cB wss cA cale cfv cB cale cfv cdom
    wbr wb cA cale cfv cB cale cfv wcel cA cB omsubdom adantr mpbird cA con0
    wcel cB con0 wcel wa cA cale cfv cB cale cfv wcel wa cA cB wss cA cB wcel
    cA cB wceq wo cA cB wcel cA con0 wcel cB con0 wcel wa cA cB wss cA cB wcel
    cA cB wceq wo wb cA cale cfv cB cale cfv wcel cA word cB word cA cB wss cA
    cB wcel cA cB wceq wo wb cA con0 wcel cB con0 wcel cA cB ordsseleq cA eloni
    cB eloni syl2an adantr cA con0 wcel cB con0 wcel wa cA cale cfv cB cale cfv
    wcel wa cA cB wcel cA cB wcel cA cB wceq cA con0 wcel cB con0 wcel wa cA
    cale cfv cB cale cfv wcel wa cA cB wcel idd cA con0 wcel cB con0 wcel wa cA
    cale cfv cB cale cfv wcel wa cA cB wceq cA cB wcel cA con0 wcel cB con0
    wcel wa cA cale cfv cB cale cfv wcel cA cB wceq wn cA con0 wcel cB con0
    wcel wa cA cB wceq cA cale cfv cB cale cfv wcel cA cB wceq cA cale cfv cB
    cale cfv wcel wn wi cA con0 wcel cB con0 wcel wa cA cB wceq cA cale cfv cA
    cale cfv wcel cA cale cfv cB cale cfv wcel cA cale cfv word cA cale cfv cA
    cale cfv wcel wn cA cale cfv con0 wcel cA cale cfv word cA alephon cA cale
    cfv eloni ax-mp cA cale cfv ordirr ax-mp cA cB wceq cA cale cfv cB cale cfv
    cA cale cfv cA cB cale fveq2 eleq2d mtbii a1i con2d imp pm2.21d jaod sylbid
    mpd ex impbid $.
    $( [23-Oct-2009] $) $( [23-Oct-2009] $)

  $( Relationship between inclusion of ordinal numbers and inclusion of
     infinite initial ordinals. $)
  omsubss $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B <-> ( aleph ` A ) C_ (
  aleph ` B ) ) ) $=
    cA con0 wcel cB con0 wcel wa cB cA wcel wn cB cale cfv cA cale cfv wcel wn
    cA cB wss cA cale cfv cB cale cfv wss cA con0 wcel cB con0 wcel wa cB cA
    wcel cB cale cfv cA cale cfv wcel cB con0 wcel cA con0 wcel cB cA wcel cB
    cale cfv cA cale cfv wcel wb cB cA omsubel ancoms notbid cA word cB word cA
    cB wss cB cA wcel wn wb cA con0 wcel cB con0 wcel cA cB ordtri1 cA eloni cB
    eloni syl2an cA cale cfv cB cale cfv wss cB cale cfv cA cale cfv wcel wn wb
    cA con0 wcel cB con0 wcel wa cA cale cfv word cB cale cfv word cA cale cfv
    cB cale cfv wss cB cale cfv cA cale cfv wcel wn wb cA cale cfv con0 wcel cA
    cale cfv word cA alephon cA cale cfv eloni ax-mp cB cale cfv con0 wcel cB
    cale cfv word cB alephon cB cale cfv eloni ax-mp cA cale cfv cB cale cfv
    ordtri1 mp2an a1i 3bitr4d $.
    $( [23-Oct-2009] $) $( [23-Oct-2009] $)

  ${
    $d j k x y A $. $d j k x y B $.
    $( If an ordinal is smaller than an initial ordinal, it is strictly
       dominated by it. $)
    elomsubsd $p |- ( ( A e. On /\ B e. On ) -> ( A e. ( aleph ` B ) <-> A ~< (
    aleph ` B ) ) ) $=
      cA con0 wcel cB con0 wcel wa cA cB cale cfv wcel cA cB cale cfv csdm wbr
      cB con0 wcel cA con0 wcel cA cB cale cfv wcel cA cB cale cfv csdm wbr wi
      cA con0 wcel cA vk cv cale cfv wcel cA vk cv cale cfv csdm wbr wi wi cA
      con0 wcel cA c0 cale cfv wcel cA c0 cale cfv csdm wbr wi wi cA con0 wcel
      cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi cA con0 wcel cA
      vj cv csuc cale cfv wcel cA vj cv csuc cale cfv csdm wbr wi wi cA con0
      wcel cA cB cale cfv wcel cA cB cale cfv csdm wbr wi wi vk vj cB vk cv c0
      wceq cA vk cv cale cfv wcel cA vk cv cale cfv csdm wbr wi cA c0 cale cfv
      wcel cA c0 cale cfv csdm wbr wi cA con0 wcel vk cv c0 wceq cA vk cv cale
      cfv wcel cA c0 cale cfv wcel cA vk cv cale cfv csdm wbr cA c0 cale cfv
      csdm wbr vk cv c0 wceq vk cv cale cfv c0 cale cfv cA vk cv c0 cale fveq2
      eleq2d vk cv c0 wceq vk cv cale cfv c0 cale cfv cA csdm vk cv c0 cale
      fveq2 breq2d imbi12d imbi2d vk cv vj cv wceq cA vk cv cale cfv wcel cA vk
      cv cale cfv csdm wbr wi cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr
      wi cA con0 wcel vk cv vj cv wceq cA vk cv cale cfv wcel cA vj cv cale cfv
      wcel cA vk cv cale cfv csdm wbr cA vj cv cale cfv csdm wbr vk cv vj cv
      wceq vk cv cale cfv vj cv cale cfv cA vk cv vj cv cale fveq2 eleq2d vk cv
      vj cv wceq vk cv cale cfv vj cv cale cfv cA csdm vk cv vj cv cale fveq2
      breq2d imbi12d imbi2d vk cv vj cv csuc wceq cA vk cv cale cfv wcel cA vk
      cv cale cfv csdm wbr wi cA vj cv csuc cale cfv wcel cA vj cv csuc cale
      cfv csdm wbr wi cA con0 wcel vk cv vj cv csuc wceq cA vk cv cale cfv wcel
      cA vj cv csuc cale cfv wcel cA vk cv cale cfv csdm wbr cA vj cv csuc cale
      cfv csdm wbr vk cv vj cv csuc wceq vk cv cale cfv vj cv csuc cale cfv cA
      vk cv vj cv csuc cale fveq2 eleq2d vk cv vj cv csuc wceq vk cv cale cfv
      vj cv csuc cale cfv cA csdm vk cv vj cv csuc cale fveq2 breq2d imbi12d
      imbi2d vk cv cB wceq cA vk cv cale cfv wcel cA vk cv cale cfv csdm wbr wi
      cA cB cale cfv wcel cA cB cale cfv csdm wbr wi cA con0 wcel vk cv cB wceq
      cA vk cv cale cfv wcel cA cB cale cfv wcel cA vk cv cale cfv csdm wbr cA
      cB cale cfv csdm wbr vk cv cB wceq vk cv cale cfv cB cale cfv cA vk cv cB
      cale fveq2 eleq2d vk cv cB wceq vk cv cale cfv cB cale cfv cA csdm vk cv
      cB cale fveq2 breq2d imbi12d imbi2d cA c0 cale cfv wcel cA c0 cale cfv
      csdm wbr wi cA con0 wcel cA com wcel cA com csdm wbr cA c0 cale cfv wcel
      cA c0 cale cfv csdm wbr cA nnsdom c0 cale cfv com cA aleph0 eleq2i c0
      cale cfv com cA csdm aleph0 breq2i 3imtr4i a1i vj cv con0 wcel cA con0
      wcel cA vj cv csuc cale cfv wcel cA vj cv csuc cale cfv csdm wbr wi wi cA
      con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj cv
      con0 wcel cA con0 wcel cA vj cv csuc cale cfv wcel cA vj cv csuc cale cfv
      csdm wbr wi vj cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint wcel cA vj cv cale cfv vx cv csdm wbr vx con0 crab
      cint csdm wbr cA vj cv csuc cale cfv wcel cA vj cv csuc cale cfv csdm wbr
      vj cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0
      crab cint wcel cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint csdm
      wbr vj cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx
      con0 crab cint wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      cdom wbr cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr wn wa
      cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint csdm wbr vj cv con0
      wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cdom wbr cA vj
      cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr wn cA con0 wcel cA
      vj cv cale cfv vx cv csdm wbr vx con0 crab cint wss cA vj cv cale cfv vx
      cv csdm wbr vx con0 crab cint cdom wbr vj cv con0 wcel cA con0 wcel wa cA
      vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel wa cA vj cv cale cfv
      vx cv csdm wbr vx con0 crab cint con0 ssdomg vj cv con0 wcel cA con0 wcel
      cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel simplr cA vj cv
      cale cfv vx cv csdm wbr vx con0 crab cint wcel cA vj cv cale cfv vx cv
      csdm wbr vx con0 crab cint wss vj cv con0 wcel cA con0 wcel wa vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint con0 wcel cA vj cv cale cfv vx cv
      csdm wbr vx con0 crab cint wcel cA vj cv cale cfv vx cv csdm wbr vx con0
      crab cint wss wi vj cv cale cfv vx cv csdm wbr vx con0 wrex vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint con0 wcel vj cv cale cfv con0 wcel
      vj cv cale cfv vx cv csdm wbr vx con0 wrex vj cv alephon vx vj cv cale
      cfv onsdom ax-mp vj cv cale cfv vx cv csdm wbr vx onintrab2 mpbi vj cv
      cale cfv vx cv csdm wbr vx con0 crab cint cA onelss ax-mp adantl sylc vj
      cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0
      crab cint wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cen
      wbr vj cv cale cfv vx cv csdm wbr vx con0 crab cint cA wss vj cv con0
      wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      wcel vj cv cale cfv vx cv csdm wbr vx con0 crab cint cA wss wn vj cv con0
      wcel cA con0 wcel wa vj cv cale cfv vx cv csdm wbr vx con0 crab cint cA
      wss cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel cA con0 wcel
      vj cv cale cfv vx cv csdm wbr vx con0 crab cint cA wss cA vj cv cale cfv
      vx cv csdm wbr vx con0 crab cint wcel wn wb vj cv con0 wcel cA con0 wcel
      cA word vj cv cale cfv vx cv csdm wbr vx con0 crab cint cA wss cA vj cv
      cale cfv vx cv csdm wbr vx con0 crab cint wcel wn wb cA eloni vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint word cA word vj cv cale cfv vx cv
      csdm wbr vx con0 crab cint cA wss cA vj cv cale cfv vx cv csdm wbr vx
      con0 crab cint wcel wn wb vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      con0 wcel vj cv cale cfv vx cv csdm wbr vx con0 crab cint word vj cv cale
      cfv vx cv csdm wbr vx con0 wrex vj cv cale cfv vx cv csdm wbr vx con0
      crab cint con0 wcel vj cv cale cfv con0 wcel vj cv cale cfv vx cv csdm
      wbr vx con0 wrex vj cv alephon vx vj cv cale cfv onsdom ax-mp vj cv cale
      cfv vx cv csdm wbr vx onintrab2 mpbi vj cv cale cfv vx cv csdm wbr vx
      con0 crab cint eloni ax-mp vj cv cale cfv vx cv csdm wbr vx con0 crab
      cint cA ordtri1 mpan syl adantl con2bid biimpa vj cv con0 wcel cA con0
      wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel wa cA vj
      cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr cA vj cv cale cfv vx
      cv csdm wbr vx con0 crab wcel vj cv cale cfv vx cv csdm wbr vx con0 crab
      cint cA wss vj cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0
      crab cint cen wbr cA con0 wcel vj cv cale cfv cA csdm wbr wa cA vj cv
      cale cfv vx cv csdm wbr vx con0 crab wcel vj cv con0 wcel cA con0 wcel wa
      cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel wa cA vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint cen wbr cA con0 wcel vj cv cale cfv
      cA csdm wbr vj cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint wcel wa cA con0 wcel cA vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint cen wbr vj cv con0 wcel cA con0 wcel cA vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint wcel simplr a1d vj cv con0 wcel cA
      con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel wa
      cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr vj cv cale cfv
      cA csdm wbr cA con0 wcel vj cv cale cfv vj cv cale cfv vx cv csdm wbr vx
      con0 crab cint csdm wbr vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      cA cen wbr wa vj cv cale cfv cA csdm wbr vj cv con0 wcel cA con0 wcel wa
      cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel wa cA vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint cen wbr wa vj cv cale cfv vj cv cale
      cfv vx cv csdm wbr vx con0 crab cint cA con0 sdomentr vj cv con0 wcel cA
      con0 wcel cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel cA vj
      cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr simpllr vj cv con0
      wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr wa vj
      cv cale cfv vx cv csdm wbr vx con0 crab cint cA cen wbr vj cv cale cfv vj
      cv cale cfv vx cv csdm wbr vx con0 crab cint csdm wbr vj cv cale cfv vx
      cv csdm wbr vx con0 crab cint con0 wcel cA vj cv cale cfv vx cv csdm wbr
      vx con0 crab cint cen wbr vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      cA cen wbr vj cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0
      crab cint cen wbr wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      con0 ensymg vj cv cale cfv vx cv csdm wbr vx con0 crab cint con0 wcel vj
      cv con0 wcel cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0
      crab cint wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cen
      wbr wa vj cv cale cfv vx cv csdm wbr vx con0 wrex vj cv cale cfv vx cv
      csdm wbr vx con0 crab cint con0 wcel vj cv cale cfv con0 wcel vj cv cale
      cfv vx cv csdm wbr vx con0 wrex vj cv alephon vx vj cv cale cfv onsdom
      ax-mp vj cv cale cfv vx cv csdm wbr vx onintrab2 mpbi a1i vj cv con0 wcel
      cA con0 wcel wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint wcel
      wa cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint cen wbr pm3.27 sylc
      vj cv cale cfv con0 wcel vj cv cale cfv vj cv cale cfv vx cv csdm wbr vx
      con0 crab cint csdm wbr vj cv alephon vj cv cale cfv con0 wcel vj cv cale
      cfv vx cv csdm wbr vx con0 wrex vj cv cale cfv vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint csdm wbr vx vj cv cale cfv onsdom vj cv cale cfv vx
      cv csdm wbr vj cv cale cfv vj cv cale cfv vx cv csdm wbr vx con0 crab
      cint csdm wbr vx vx vy vj cv cale cfv vj cv cale cfv vx cv csdm wbr vx
      con0 crab cint csdm vy cv vj cv cale cfv wcel vx ax-17 vy cv csdm wcel vx
      ax-17 vx vy vj cv cale cfv vx cv csdm wbr vx con0 crab vj cv cale cfv vx
      cv csdm wbr vx vy con0 hbrab1 hbint hbbr vx cv vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint vj cv cale cfv csdm breq2 onminsb syl ax-mp jctil
      sylc ex jcad vj cv cale cfv vx cv csdm wbr vj cv cale cfv cA csdm wbr vx
      cA con0 vx cv cA vj cv cale cfv csdm breq2 elrab syl6ibr cA vj cv cale
      cfv vx cv csdm wbr vx con0 crab intss1 syl6 mtod jca cA vj cv cale cfv vx
      cv csdm wbr vx con0 crab cint brsdom sylibr ex vj cv con0 wcel cA vj cv
      csuc cale cfv wcel cA vj cv cale cfv vx cv csdm wbr vx con0 crab cint
      wcel wb cA con0 wcel vj cv con0 wcel vj cv csuc cale cfv vj cv cale cfv
      vx cv csdm wbr vx con0 crab cint cA vx vj cv omsubsuc eleq2d adantr vj cv
      con0 wcel cA vj cv csuc cale cfv csdm wbr cA vj cv cale cfv vx cv csdm
      wbr vx con0 crab cint csdm wbr wb cA con0 wcel vj cv con0 wcel vj cv csuc
      cale cfv vj cv cale cfv vx cv csdm wbr vx con0 crab cint cA csdm vx vj cv
      omsubsuc breq2d adantr 3imtr4d ex a1d vk cv wlim cA con0 wcel cA vj cv
      cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv wral cA con0 wcel
      cA vk cv cale cfv wcel cA vk cv cale cfv csdm wbr wi vk cv wlim cA con0
      wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv
      wral cA con0 wcel w3a cA vj vk cv vj cv cale cfv ciun wcel cA vj vk cv vj
      cv cale cfv ciun csdm wbr cA vk cv cale cfv wcel cA vk cv cale cfv csdm
      wbr cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi
      vj vk cv wral cA con0 wcel cA vj vk cv vj cv cale cfv ciun wcel cA vj vk
      cv vj cv cale cfv ciun csdm wbr wi vk cv wlim cA con0 wcel cA vj cv cale
      cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv wral cA con0 wcel wa
      cA vj cv cale cfv wcel vj vk cv wrex cA vj vk cv vj cv cale cfv ciun csdm
      wbr cA vj vk cv vj cv cale cfv ciun wcel cA con0 wcel cA vj cv cale cfv
      wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv wral cA con0 wcel wa cA vj
      cv cale cfv wcel cA vj vk cv vj cv cale cfv ciun csdm wbr vj vk cv cA
      con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk
      cv wral cA con0 wcel vj cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale
      cfv csdm wbr wi wi vj vk cv hbra1 cA con0 wcel vj ax-17 hban vj vy cA vj
      vk cv vj cv cale cfv ciun csdm vy cv cA wcel vj ax-17 vy cv csdm wcel vj
      ax-17 vj vy vk cv vj cv cale cfv hbiu1 hbbr vj cv vk cv wcel cA con0 wcel
      cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv wral cA
      con0 wcel wa cA vj cv cale cfv wcel cA vj vk cv vj cv cale cfv ciun csdm
      wbr wi vj cv vk cv wcel cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale
      cfv csdm wbr wi wi vj vk cv wral cA con0 wcel cA vj cv cale cfv wcel cA
      vj vk cv vj cv cale cfv ciun csdm wbr wi vj cv vk cv wcel cA con0 wcel cA
      vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv wral cA
      con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi cA vj cv
      cale cfv wcel cA vj vk cv vj cv cale cfv ciun csdm wbr wi cA con0 wcel cA
      vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi wi vj vk cv wral vj cv
      vk cv wcel cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr
      wi wi cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv csdm wbr wi
      wi vj vk cv ra4 com12 vj cv vk cv wcel cA vj cv cale cfv csdm wbr cA vj
      vk cv vj cv cale cfv ciun csdm wbr cA vj cv cale cfv wcel cA vj cv cale
      cfv csdm wbr vj cv vk cv wcel cA vj vk cv vj cv cale cfv ciun csdm wbr cA
      vj cv cale cfv csdm wbr vj cv cale cfv vj vk cv vj cv cale cfv ciun cdom
      wbr cA vj vk cv vj cv cale cfv ciun csdm wbr vj cv vk cv wcel vj vk cv vj
      cv cale cfv ciun cvv wcel cA vj cv cale cfv csdm wbr vj cv cale cfv vj vk
      cv vj cv cale cfv ciun cdom wbr wa cA vj vk cv vj cv cale cfv ciun csdm
      wbr wi vj vk cv vj cv cale cfv vk visset vj cv cale fvex iunex cA vj cv
      cale cfv vj vk cv vj cv cale cfv ciun cvv sdomdomtr ax-mp vj cv vk cv
      wcel vj cv cale cfv vj vk cv vj cv cale cfv ciun wss vj cv cale cfv vj vk
      cv vj cv cale cfv ciun cdom wbr vj vk cv vj cv cale cfv ssiun2 vj cv cale
      cfv cvv wcel vj cv cale cfv vj vk cv vj cv cale cfv ciun wss vj cv cale
      cfv vj vk cv vj cv cale cfv ciun cdom wbr wi vj cv cale fvex vj cv cale
      cfv vj vk cv vj cv cale cfv ciun cvv ssdomg ax-mp syl sylan2 expcom
      imim2d syl6d imp3a com12 r19.23ad vj cA vk cv vj cv cale cfv eliun syl5ib
      3adant1 vk cv wlim cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv
      csdm wbr wi wi vj vk cv wral cA vk cv cale cfv wcel cA vj vk cv vj cv
      cale cfv ciun wcel wb cA con0 wcel vk cv wlim vk cv cale cfv vj vk cv vj
      cv cale cfv ciun cA vk cv cvv wcel vk cv wlim vk cv cale cfv vj vk cv vj
      cv cale cfv ciun wceq vk visset vj vk cv cvv alephlim mpan eleq2d
      3ad2ant1 vk cv wlim cA con0 wcel cA vj cv cale cfv wcel cA vj cv cale cfv
      csdm wbr wi wi vj vk cv wral cA vk cv cale cfv csdm wbr cA vj vk cv vj cv
      cale cfv ciun csdm wbr wb cA con0 wcel vk cv wlim vk cv cale cfv vj vk cv
      vj cv cale cfv ciun cA csdm vk cv cvv wcel vk cv wlim vk cv cale cfv vj
      vk cv vj cv cale cfv ciun wceq vk visset vj vk cv cvv alephlim mpan
      breq2d 3ad2ant1 3imtr4d 3exp tfinds impcom cA con0 wcel cB con0 wcel wa
      cA cB cale cfv wcel cA cB cale cfv csdm wbr cA con0 wcel cB con0 wcel wa
      cB cale cfv cA wss cB cale cfv cA cdom wbr cA cB cale cfv wcel wn cA cB
      cale cfv csdm wbr wn cB cale cfv cA wss cB cale cfv cA cdom wbr wi cA
      con0 wcel cB con0 wcel wa cB cale cfv cvv wcel cB cale cfv cA wss cB cale
      cfv cA cdom wbr wi cB cale fvex cB cale cfv cA cvv ssdomg ax-mp a1i cA
      con0 wcel cB cale cfv cA wss cA cB cale cfv wcel wn wb cB con0 wcel cA
      con0 wcel cA word cB cale cfv cA wss cA cB cale cfv wcel wn wb cA eloni
      cB cale cfv word cA word cB cale cfv cA wss cA cB cale cfv wcel wn wb cB
      cale cfv con0 wcel cB cale cfv word cB alephon cB cale cfv eloni ax-mp cB
      cale cfv cA ordtri1 mpan syl adantr cA con0 wcel cB cale cfv cA cdom wbr
      cA cB cale cfv csdm wbr wn wb cB con0 wcel cB cale cfv con0 wcel cA con0
      wcel cB cale cfv cA cdom wbr cA cB cale cfv csdm wbr wn wb cB alephon cB
      cale cfv cA dmsdtriord mpan adantr 3imtr3d con4d impbid $.
      $( [24-Oct-2009] $) $( [24-Oct-2009] $)

  $( A dominated initial ordinal is included. $)
  omsubdmss $p |- ( ( A e. On /\ B e. On ) -> ( ( aleph ` A ) C_ B <-> ( aleph
  ` A ) ~<_ B ) ) $=
    cA con0 wcel cB con0 wcel wa cB cA cale cfv wcel wn cB cA cale cfv csdm wbr
    wn cA cale cfv cB wss cA cale cfv cB cdom wbr cA con0 wcel cB con0 wcel wa
    cB cA cale cfv wcel cB cA cale cfv csdm wbr cB con0 wcel cA con0 wcel cB cA
    cale cfv wcel cB cA cale cfv csdm wbr wb cB cA elomsubsd ancoms notbid cB
    con0 wcel cA cale cfv cB wss cB cA cale cfv wcel wn wb cA con0 wcel cB con0
    wcel cB word cA cale cfv cB wss cB cA cale cfv wcel wn wb cB eloni cA cale
    cfv word cB word cA cale cfv cB wss cB cA cale cfv wcel wn wb cA cale cfv
    con0 wcel cA cale cfv word cA alephon cA cale cfv eloni ax-mp cA cale cfv
    cB ordtri1 mpan syl adantl cB con0 wcel cA cale cfv cB cdom wbr cB cA cale
    cfv csdm wbr wn wb cA con0 wcel cA cale cfv con0 wcel cB con0 wcel cA cale
    cfv cB cdom wbr cB cA cale cfv csdm wbr wn wb cA alephon cA cale cfv cB
    dmsdtriord mpan adantl 3bitr4d $.
    $( [24-Oct-2009] $) $( [24-Oct-2009] $)
  $}

  ${
    $d t w x y z A $.
  $( An infinite initial ordinal is a limit ordinal. $)
  omsublim $p |- ( A e. On -> Lim ( aleph ` A ) ) $=
    vx cv cale cfv wlim c0 cale cfv wlim vy cv cale cfv wlim vy cv csuc cale
    cfv wlim cA cale cfv wlim vx vy cA vx cv c0 wceq vx cv cale cfv c0 cale cfv
    wceq vx cv cale cfv wlim c0 cale cfv wlim wb vx cv c0 cale fveq2 vx cv cale
    cfv c0 cale cfv limeq syl vx cv vy cv wceq vx cv cale cfv vy cv cale cfv
    wceq vx cv cale cfv wlim vy cv cale cfv wlim wb vx cv vy cv cale fveq2 vx
    cv cale cfv vy cv cale cfv limeq syl vx cv vy cv csuc wceq vx cv cale cfv
    vy cv csuc cale cfv wceq vx cv cale cfv wlim vy cv csuc cale cfv wlim wb vx
    cv vy cv csuc cale fveq2 vx cv cale cfv vy cv csuc cale cfv limeq syl vx cv
    cA wceq vx cv cale cfv cA cale cfv wceq vx cv cale cfv wlim cA cale cfv
    wlim wb vx cv cA cale fveq2 vx cv cale cfv cA cale cfv limeq syl c0 cale
    cfv wlim com wlim limom c0 cale cfv com wceq c0 cale cfv wlim com wlim wb
    aleph0 c0 cale cfv com limeq ax-mp mpbir vy cv con0 wcel vy cv csuc cale
    cfv wlim vy cv cale cfv wlim vy cv con0 wcel vy cv csuc cale cfv word c0 vy
    cv csuc cale cfv wcel vx cv csuc vy cv csuc cale cfv wcel vx vy cv csuc
    cale cfv wral w3a vy cv csuc cale cfv wlim vy cv con0 wcel vy cv csuc cale
    cfv word c0 vy cv csuc cale cfv wcel vx cv csuc vy cv csuc cale cfv wcel vx
    vy cv csuc cale cfv wral vy cv csuc cale cfv word vy cv con0 wcel vy cv
    csuc cale cfv con0 wcel vy cv csuc cale cfv word vy cv csuc alephon vy cv
    csuc cale cfv eloni ax-mp a1i vy cv con0 wcel c0 con0 wcel c0 vy cv cale
    cfv cdom wbr wa c0 vy cv csuc cale cfv wcel c0 con0 wcel c0 vy cv cale cfv
    cdom wbr 0elon c0 cvv wcel c0 vy cv cale cfv wss c0 vy cv cale cfv cdom wbr
    0ex vy cv cale cfv 0ss c0 vy cv cale cfv cvv ssdomg mp2 pm3.2i vy cv con0
    wcel c0 vy cv csuc cale cfv wcel c0 vx cv vy cv cale cfv cdom wbr vx con0
    crab wcel c0 con0 wcel c0 vy cv cale cfv cdom wbr wa vy cv con0 wcel vy cv
    csuc cale cfv vx cv vy cv cale cfv cdom wbr vx con0 crab c0 vx vy cv
    omsubsuc2 eleq2d vx cv vy cv cale cfv cdom wbr c0 vy cv cale cfv cdom wbr
    vx c0 con0 vx cv c0 vy cv cale cfv cdom breq1 elrab syl6rbb mpbii vy cv
    con0 wcel vx cv csuc vy cv csuc cale cfv wcel vx vy cv csuc cale cfv vy cv
    con0 wcel vx cv con0 wcel vx cv vy cv cale cfv cdom wbr wa vx cv csuc con0
    wcel vx cv csuc vy cv cale cfv cdom wbr wa vx cv vy cv csuc cale cfv wcel
    vx cv csuc vy cv csuc cale cfv wcel vy cv con0 wcel vx cv con0 wcel vx cv
    vy cv cale cfv cdom wbr wa vx cv csuc con0 wcel vx cv csuc vy cv cale cfv
    cdom wbr vx cv con0 wcel vx cv vy cv cale cfv cdom wbr wa vx cv csuc con0
    wcel wi vy cv con0 wcel vx cv con0 wcel vx cv csuc con0 wcel vx cv vy cv
    cale cfv cdom wbr vx cv suceloni adantr a1i vy cv con0 wcel vx cv con0 wcel
    vx cv vy cv cale cfv cdom wbr vx cv csuc vy cv cale cfv cdom wbr vy cv con0
    wcel vx cv con0 wcel vx cv vy cv cale cfv cdom wbr vx cv csuc vy cv cale
    cfv cdom wbr wi vy cv con0 wcel vx cv con0 wcel wa vx cv com wcel com vx cv
    wss wo vx cv vy cv cale cfv cdom wbr vx cv csuc vy cv cale cfv cdom wbr wi
    vx cv con0 wcel vx cv com wcel com vx cv wss wo vy cv con0 wcel vx cv con0
    wcel vx cv word vx cv com wcel com vx cv wss wo vx cv eloni vx cv word com
    word vx cv com wcel com vx cv wss wo ordom vx cv com ordtri2or mpan2 syl
    adantl vy cv con0 wcel vx cv con0 wcel wa vx cv com wcel vx cv vy cv cale
    cfv cdom wbr vx cv csuc vy cv cale cfv cdom wbr wi com vx cv wss vy cv con0
    wcel vx cv com wcel vx cv vy cv cale cfv cdom wbr vx cv csuc vy cv cale cfv
    cdom wbr wi wi vx cv con0 wcel vy cv con0 wcel vx cv com wcel vx cv csuc vy
    cv cale cfv cdom wbr vx cv vy cv cale cfv cdom wbr vy cv con0 wcel vx cv
    com wcel vx cv csuc vy cv cale cfv cdom wbr vx cv csuc com wcel vx cv csuc
    vy cv cale cfv wss vx cv csuc vy cv cale cfv cdom wbr vy cv con0 wcel vx cv
    com wcel wa vx cv csuc vy cv cale cfv com ssdomg vx cv com wcel vx cv csuc
    com wcel vy cv con0 wcel vx cv peano2 adantl vx cv com wcel vy cv con0 wcel
    vx cv csuc com vy cv cale cfv vx cv com wcel vx cv csuc com wcel vx cv csuc
    com wss vx cv peano2 com con0 wcel vx cv csuc com wcel vx cv csuc com wss
    wi omelon com vx cv csuc onelss ax-mp syl vy cv con0 wcel c0 cale cfv vy cv
    cale cfv com vy cv con0 wcel c0 vy cv wss c0 cale cfv vy cv cale cfv wss vy
    cv 0ss c0 con0 wcel vy cv con0 wcel c0 vy cv wss c0 cale cfv vy cv cale cfv
    wss wb 0elon c0 vy cv omsubss mpan mpbii aleph0 syl5ssr sylan9ssr sylc ex
    a1dd adantr vy cv con0 wcel vx cv con0 wcel wa com vx cv wss vx cv vy cv
    cale cfv cdom wbr vx cv csuc vy cv cale cfv cdom wbr vx cv csuc vx cv cen
    wbr vx cv vy cv cale cfv cdom wbr vx cv csuc vy cv cale cfv cdom wbr vy cv
    con0 wcel vx cv con0 wcel wa com vx cv wss vx cv vy cv cale cfv cdom wbr wa
    wa vx cv csuc vx cv vy cv cale cfv endomtr vy cv con0 wcel vx cv con0 wcel
    wa com vx cv wss vx cv vy cv cale cfv cdom wbr wa wa vx cv vx cv csuc cen
    wbr vx cv csuc vx cv cen wbr vx cv con0 wcel com vx cv wss vx cv vx cv csuc
    cen wbr vy cv con0 wcel vx cv vy cv cale cfv cdom wbr vx cv infensuc
    ad2ant2lr vx cv csuc cvv wcel vx cv vx cv csuc cen wbr vx cv csuc vx cv cen
    wbr wi vx cv vx visset sucex vx cv vx cv csuc cvv ensymg ax-mp syl vy cv
    con0 wcel vx cv con0 wcel wa com vx cv wss vx cv vy cv cale cfv cdom wbr
    simprr sylanc exp32 jaod mpd ex imp3a jcad vy cv con0 wcel vx cv vy cv csuc
    cale cfv wcel vx cv vz cv vy cv cale cfv cdom wbr vz con0 crab wcel vx cv
    con0 wcel vx cv vy cv cale cfv cdom wbr wa vy cv con0 wcel vy cv csuc cale
    cfv vz cv vy cv cale cfv cdom wbr vz con0 crab vx cv vz vy cv omsubsuc2
    eleq2d vz cv vy cv cale cfv cdom wbr vx cv vy cv cale cfv cdom wbr vz vx cv
    con0 vz cv vx cv vy cv cale cfv cdom breq1 elrab syl6bb vy cv con0 wcel vx
    cv csuc vy cv csuc cale cfv wcel vx cv csuc vz cv vy cv cale cfv cdom wbr
    vz con0 crab wcel vx cv csuc con0 wcel vx cv csuc vy cv cale cfv cdom wbr
    wa vy cv con0 wcel vy cv csuc cale cfv vz cv vy cv cale cfv cdom wbr vz
    con0 crab vx cv csuc vz vy cv omsubsuc2 eleq2d vz cv vy cv cale cfv cdom
    wbr vx cv csuc vy cv cale cfv cdom wbr vz vx cv csuc con0 vz cv vx cv csuc
    vy cv cale cfv cdom breq1 elrab syl6bb 3imtr4d r19.21aiv 3jca vx vy cv csuc
    cale cfv dflim4 sylibr a1d vx cv wlim vy cv cale cfv wlim vy vx cv wral vx
    cv cale cfv wlim vx cv wlim vy cv cale cfv wlim vy vx cv wral wa vx cv cale
    cfv wlim vw cv vz cv cale cfv wceq vz vx cv wrex vw cab cuni wlim vw cv vz
    cv cale cfv wceq vz vx cv wrex vw cab c0 wne vt cv wlim vt vw cv vz cv cale
    cfv wceq vz vx cv wrex vw cab wral vw cv vz cv cale cfv wceq vz vx cv wrex
    vw cab cuni wlim vx cv wlim vy cv cale cfv wlim vy vx cv wral wa vt vw cv
    vz cv cale cfv wceq vz vx cv wrex vw cab limuni3 vx cv wlim vy cv cale cfv
    wlim vy vx cv wral wa c0 cale cfv vw cv vz cv cale cfv wceq vz vx cv wrex
    vw cab wcel vw cv vz cv cale cfv wceq vz vx cv wrex vw cab c0 wne vx cv
    wlim vy cv cale cfv wlim vy vx cv wral wa c0 cale cfv vz cv cale cfv wceq
    vz vx cv wrex c0 cale cfv vw cv vz cv cale cfv wceq vz vx cv wrex vw cab
    wcel vx cv wlim c0 cale cfv vz cv cale cfv wceq vz vx cv wrex vy cv cale
    cfv wlim vy vx cv wral vx cv wlim c0 vx cv wcel c0 cale cfv vz cv cale cfv
    wceq vz vx cv wrex vx cv 0ellim c0 vx cv wcel c0 cale cfv c0 cale cfv wceq
    c0 cale cfv vz cv cale cfv wceq vz vx cv wrex c0 cale cfv eqid c0 cale cfv
    vz cv cale cfv wceq c0 cale cfv c0 cale cfv wceq vz c0 vx cv vz cv c0 wceq
    vz cv cale cfv c0 cale cfv c0 cale cfv vz cv c0 cale fveq2 eqeq2d rcla4ev
    mpan2 syl adantr vw cv vz cv cale cfv wceq vz vx cv wrex c0 cale cfv vz cv
    cale cfv wceq vz vx cv wrex vw c0 cale cfv c0 cale fvex vw cv c0 cale cfv
    wceq vw cv vz cv cale cfv wceq c0 cale cfv vz cv cale cfv wceq vz vx cv vw
    cv c0 cale cfv vz cv cale cfv eqeq1 rexbidv elab sylibr vw cv vz cv cale
    cfv wceq vz vx cv wrex vw cab c0 cale cfv ne0i syl vx cv wlim vy cv cale
    cfv wlim vy vx cv wral wa vt cv wlim vt vw cv vz cv cale cfv wceq vz vx cv
    wrex vw cab vx cv wlim vy cv cale cfv wlim vy vx cv wral wa vt cv vz cv
    cale cfv wceq vz vx cv wrex vt cv wlim vt cv vw cv vz cv cale cfv wceq vz
    vx cv wrex vw cab wcel vx cv wlim vy cv cale cfv wlim vy vx cv wral wa vt
    cv vz cv cale cfv wceq vt cv wlim vz vx cv vy cv cale cfv wlim vy vx cv
    wral vz cv vx cv wcel vz cv cale cfv wlim vx cv wlim vt cv vz cv cale cfv
    wceq vt cv wlim wi vy cv cale cfv wlim vz cv cale cfv wlim vy vz cv vx cv
    vy cv vz cv wceq vy cv cale cfv vz cv cale cfv wceq vy cv cale cfv wlim vz
    cv cale cfv wlim wb vy cv vz cv cale fveq2 vy cv cale cfv vz cv cale cfv
    limeq syl rcla4cv vz cv cale cfv wlim vt cv vz cv cale cfv wceq vt cv wlim
    wi wi vx cv wlim vt cv vz cv cale cfv wceq vt cv wlim vz cv cale cfv wlim
    vt cv vz cv cale cfv limeq biimprcd a1i sylan9r r19.23adv vw cv vz cv cale
    cfv wceq vz vx cv wrex vt cv vz cv cale cfv wceq vz vx cv wrex vw vt cv vt
    visset vw cv vt cv wceq vw cv vz cv cale cfv wceq vt cv vz cv cale cfv wceq
    vz vx cv vw cv vt cv vz cv cale cfv eqeq1 rexbidv elab syl5ib r19.21aiv
    sylanc vx cv wlim vx cv cale cfv wlim vw cv vz cv cale cfv wceq vz vx cv
    wrex vw cab cuni wlim wb vy cv cale cfv wlim vy vx cv wral vx cv wlim vx cv
    cale cfv vw cv vz cv cale cfv wceq vz vx cv wrex vw cab cuni wceq vx cv
    cale cfv wlim vw cv vz cv cale cfv wceq vz vx cv wrex vw cab cuni wlim wb
    vx cv wlim vx cv cale cfv vz vx cv vz cv cale cfv ciun vw cv vz cv cale cfv
    wceq vz vx cv wrex vw cab cuni vx cv cvv wcel vx cv wlim vx cv cale cfv vz
    vx cv vz cv cale cfv ciun wceq vx visset vz vx cv cvv alephlim mpan vz vw
    vx cv vz cv cale cfv vz cv cale fvex dfiun2 syl6eq vx cv cale cfv vw cv vz
    cv cale cfv wceq vz vx cv wrex vw cab cuni limeq syl adantr mpbird ex
    tfinds $.
    $( [29-Oct-2009] $) $( [29-Oct-2009] $)
  $}

  ${
    $d x y z A $.
    $( An initial ordinal includes its index. $)
    omsubindss $p |- ( A e. On -> A C_ ( aleph ` A ) ) $=
      vx cv vx cv cale cfv wss vy cv vy cv cale cfv wss cA cA cale cfv wss vx
      vy cA vx cv vy cv wceq vx cv vy cv vx cv cale cfv vy cv cale cfv vx cv vy
      cv wceq id vx cv vy cv cale fveq2 sseq12d vx cv cA wceq vx cv cA vx cv
      cale cfv cA cale cfv vx cv cA wceq id vx cv cA cale fveq2 sseq12d vx cv
      con0 wcel vy cv vy cv cale cfv wss vy vx cv wral vx cv vx cv cale cfv wss
      vx cv con0 wcel vy cv vy cv cale cfv wss vy vx cv wral wa vz vx cv vx cv
      cale cfv vx cv con0 wcel vy cv vy cv cale cfv wss vy vx cv wral vz cv vx
      cv wcel vz cv vx cv cale cfv wcel wi vz cv vx cv wcel vy cv vy cv cale
      cfv wss vy vx cv wral vx cv con0 wcel vz cv vx cv cale cfv wcel vz cv vx
      cv wcel vy cv vy cv cale cfv wss vy vx cv wral vz cv vz cv cale cfv wss
      vx cv con0 wcel vz cv vx cv cale cfv wcel wi vy cv vy cv cale cfv wss vz
      cv vz cv cale cfv wss vy vz cv vx cv vy cv vz cv wceq vy cv vz cv vy cv
      cale cfv vz cv cale cfv vy cv vz cv wceq id vy cv vz cv cale fveq2
      sseq12d rcla4v vx cv con0 wcel vz cv vx cv wcel vz cv vz cv cale cfv wss
      vz cv vx cv cale cfv wcel vx cv con0 wcel vz cv vx cv wcel vz cv vz cv
      cale cfv wss vz cv vx cv cale cfv wcel vz cv con0 wcel vx cv cale cfv
      con0 wcel wa vz cv vz cv cale cfv wss vz cv cale cfv vx cv cale cfv wcel
      wa vz cv vx cv cale cfv wcel vx cv con0 wcel vz cv vx cv wcel vz cv vz cv
      cale cfv wss w3a vz cv vz cv cale cfv vx cv cale cfv ontr2 vx cv con0
      wcel vz cv vx cv wcel vz cv vz cv cale cfv wss w3a vz cv con0 wcel vx cv
      cale cfv con0 wcel vx cv con0 wcel vz cv vx cv wcel vz cv con0 wcel vz cv
      vz cv cale cfv wss vx cv vz cv onelon 3adant3 vx cv alephon jctir vx cv
      con0 wcel vz cv vx cv wcel vz cv vz cv cale cfv wss w3a vz cv vz cv cale
      cfv wss vz cv cale cfv vx cv cale cfv wcel vx cv con0 wcel vz cv vx cv
      wcel vz cv vz cv cale cfv wss 3simp3 vx cv con0 wcel vz cv vx cv wcel vz
      cv vz cv cale cfv wss w3a vz cv vx cv wcel vz cv cale cfv vx cv cale cfv
      wcel vx cv con0 wcel vz cv vx cv wcel vz cv vz cv cale cfv wss 3simp2 vx
      cv con0 wcel vz cv vx cv wcel vz cv vx cv wcel vz cv cale cfv vx cv cale
      cfv wcel wb vz cv vz cv cale cfv wss vx cv con0 wcel vz cv vx cv wcel vz
      cv con0 wcel vz cv vx cv wcel vz cv cale cfv vx cv cale cfv wcel wb vx cv
      vz cv onelon vz cv con0 wcel vx cv con0 wcel vz cv vx cv wcel vz cv cale
      cfv vx cv cale cfv wcel wb vz cv vx cv omsubel ancoms syldan 3adant3
      mpbid jca sylc 3exp com3l syld com13 imp ssrdv ex tfis3 $.
      $( [26-Oct-2009] $) $( [26-Oct-2009] $)
  $}

  ${
    $d j k t u v w x y z A $.
    $( An infinite ordinal is equinumerous to an infinite initial ordinal. $)
    infenomsub $p |- ( ( A e. On /\ om C_ A ) -> E. x e. ran aleph x ~~ A ) $=
      cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cale crn wcel cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cen wbr vx cv cA cen
      wbr vx cale crn wrex cA con0 wcel com cA wss wa vx cv cA cen wbr cA vy cv
      cale cfv cdom wbr vy con0 crab cint cale cfv cA cen wbr vx cA vy cv cale
      cfv cdom wbr vy con0 crab cint cale cfv cale crn vx cv cA vy cv cale cfv
      cdom wbr vy con0 crab cint cale cfv cA cen breq1 rcla4ev cale con0 wfn cA
      vy cv cale cfv cdom wbr vy con0 crab cint con0 wcel cA vy cv cale cfv
      cdom wbr vy con0 crab cint cale cfv cale crn wcel cA con0 wcel com cA wss
      wa con0 cA vy cv cale cfv cdom wbr vy con0 crab cint cale fnfvelrn cale
      con0 wfn cA con0 wcel com cA wss wa alephfnon a1i cA con0 wcel com cA wss
      wa cA vy cv cale cfv cdom wbr vy con0 wrex cA vy cv cale cfv cdom wbr vy
      con0 crab cint con0 wcel cA con0 wcel cA vy cv cale cfv cdom wbr vy con0
      wrex com cA wss cA con0 wcel cA cA cale cfv cdom wbr cA vy cv cale cfv
      cdom wbr vy con0 wrex cA con0 wcel cA cA cale cfv wss cA cA cale cfv cdom
      wbr cA omsubindss cA cA cale cfv con0 ssdomg mpd cA vy cv cale cfv cdom
      wbr cA cA cale cfv cdom wbr vy cA con0 vy cv cA wceq vy cv cale cfv cA
      cale cfv cA cdom vy cv cA cale fveq2 breq2d rcla4ev mpdan adantr cA vy cv
      cale cfv cdom wbr vy onintrab2 sylib sylanc cA con0 wcel com cA wss wa cA
      vy cv cale cfv cdom wbr vy con0 crab cint c0 wceq cA vy cv cale cfv cdom
      wbr vy con0 crab cint vz cv csuc wceq vz con0 wrex cA vy cv cale cfv cdom
      wbr vy con0 crab cint wlim wo wo cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale cfv cA cen wbr cA con0 wcel com cA wss wa cA vy cv cale cfv
      cdom wbr vy con0 crab cint con0 wcel cA vy cv cale cfv cdom wbr vy con0
      crab cint c0 wceq cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc
      wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wo wo
      cA con0 wcel com cA wss wa cA vy cv cale cfv cdom wbr vy con0 wrex cA vy
      cv cale cfv cdom wbr vy con0 crab cint con0 wcel cA con0 wcel cA vy cv
      cale cfv cdom wbr vy con0 wrex com cA wss cA con0 wcel cA cA cale cfv
      cdom wbr cA vy cv cale cfv cdom wbr vy con0 wrex cA con0 wcel cA cA cale
      cfv wss cA cA cale cfv cdom wbr cA omsubindss cA cA cale cfv con0 ssdomg
      mpd cA vy cv cale cfv cdom wbr cA cA cale cfv cdom wbr vy cA con0 vy cv
      cA wceq vy cv cale cfv cA cale cfv cA cdom vy cv cA cale fveq2 breq2d
      rcla4ev mpdan adantr cA vy cv cale cfv cdom wbr vy onintrab2 sylib cA vy
      cv cale cfv cdom wbr vy con0 crab cint con0 wcel cA vy cv cale cfv cdom
      wbr vy con0 crab cint word cA vy cv cale cfv cdom wbr vy con0 crab cint
      c0 wceq cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq vz
      con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wo wo cA vy
      cv cale cfv cdom wbr vy con0 crab cint eloni cA vy cv cale cfv cdom wbr
      vy con0 crab cint word cA vy cv cale cfv cdom wbr vy con0 crab cint c0
      wceq cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq vz con0
      wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim w3o cA vy cv cale
      cfv cdom wbr vy con0 crab cint c0 wceq cA vy cv cale cfv cdom wbr vy con0
      crab cint vz cv csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0
      crab cint wlim wo wo vz cA vy cv cale cfv cdom wbr vy con0 crab cint
      ordzsl cA vy cv cale cfv cdom wbr vy con0 crab cint c0 wceq cA vy cv cale
      cfv cdom wbr vy con0 crab cint vz cv csuc wceq vz con0 wrex cA vy cv cale
      cfv cdom wbr vy con0 crab cint wlim 3orass bitri sylib syl cA con0 wcel
      com cA wss wa cA vy cv cale cfv cdom wbr vy con0 crab cint c0 wceq cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cen wbr cA vy cv cale
      cfv cdom wbr vy con0 crab cint vz cv csuc wceq vz con0 wrex cA vy cv cale
      cfv cdom wbr vy con0 crab cint wlim wo cA con0 wcel com cA wss wa cA vy
      cv cale cfv cdom wbr vy con0 crab cint c0 wceq cA vy cv cale cfv cdom wbr
      vy con0 crab cint cale cfv cA cdom wbr cA cA vy cv cale cfv cdom wbr vy
      con0 crab cint cale cfv cdom wbr wa cA vy cv cale cfv cdom wbr vy con0
      crab cint cale cfv cA cen wbr com cA wss cA con0 wcel cA vy cv cale cfv
      cdom wbr vy con0 crab cint c0 wceq cA vy cv cale cfv cdom wbr vy con0
      crab cint cale cfv cA cdom wbr cA cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale cfv cdom wbr wa wi cA vy cv cale cfv cdom wbr vy con0 crab cint
      c0 wceq com cA wss cA con0 wcel wa cA vy cv cale cfv cdom wbr vy con0
      crab cint cale cfv cA cdom wbr cA cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale cfv cdom wbr wa cA vy cv cale cfv cdom wbr vy con0 crab cint c0
      wceq com cA wss cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cA
      cdom wbr cA con0 wcel cA cA vy cv cale cfv cdom wbr vy con0 crab cint
      cale cfv cdom wbr cA vy cv cale cfv cdom wbr vy con0 crab cint c0 wceq cA
      vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cdom wbr c0 cale
      cfv cA cdom wbr com cA wss cA vy cv cale cfv cdom wbr vy con0 crab cint
      c0 wceq cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv c0 cale cfv
      cA cdom cA vy cv cale cfv cdom wbr vy con0 crab cint c0 cale fveq2 breq1d
      com cA wss c0 cale cfv cA wss c0 cale cfv cA cdom wbr c0 cale cfv com cA
      aleph0 sseq1i c0 cale cfv cvv wcel c0 cale cfv cA wss c0 cale cfv cA cdom
      wbr wi c0 cale fvex c0 cale cfv cA cvv ssdomg ax-mp sylbir syl5bir cA
      con0 wcel cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cdom
      wbr wi cA vy cv cale cfv cdom wbr vy con0 crab cint c0 wceq cA con0 wcel
      cA vy cv cale cfv cdom wbr vy con0 wrex cA cA vy cv cale cfv cdom wbr vy
      con0 crab cint cale cfv cdom wbr cA con0 wcel cA cA cale cfv cdom wbr cA
      vy cv cale cfv cdom wbr vy con0 wrex cA con0 wcel cA cA cale cfv wss cA
      cA cale cfv cdom wbr cA omsubindss cA cA cale cfv con0 ssdomg mpd cA vy
      cv cale cfv cdom wbr cA cA cale cfv cdom wbr vy cA con0 vy cv cA wceq vy
      cv cale cfv cA cale cfv cA cdom vy cv cA cale fveq2 breq2d rcla4ev mpdan
      cA vy cv cale cfv cdom wbr cA cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale cfv cdom wbr vy vy vx cA cA vy cv cale cfv cdom wbr vy con0
      crab cint cale cfv cdom vx cv cA wcel vy ax-17 vx cv cdom wcel vy ax-17
      vy vx cA vy cv cale cfv cdom wbr vy con0 crab cint cale vx cv cale wcel
      vy ax-17 vy vx cA vy cv cale cfv cdom wbr vy con0 crab cA vy cv cale cfv
      cdom wbr vy vx con0 hbrab1 hbint hbfv hbbr vy cv cA vy cv cale cfv cdom
      wbr vy con0 crab cint wceq vy cv cale cfv cA vy cv cale cfv cdom wbr vy
      con0 crab cint cale cfv cA cdom vy cv cA vy cv cale cfv cdom wbr vy con0
      crab cint cale fveq2 breq2d onminsb syl a1i anim12d com12 ancoms cA con0
      wcel cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cdom wbr cA
      cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cdom wbr wa cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cen wbr wb com cA wss
      cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cA con0 sbthbg
      adantr sylibd cA con0 wcel com cA wss wa cA vy cv cale cfv cdom wbr vy
      con0 crab cint vz cv csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy
      con0 crab cint wlim wo cA vy cv cale cfv cdom wbr vy con0 crab cint cale
      cfv cA cen wbr cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cvv
      wcel cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cen wbr cA
      vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cen wbr cA con0
      wcel com cA wss wa cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv
      csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim
      wo wa cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cvv ensymg
      cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cvv wcel cA con0
      wcel com cA wss wa cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv
      csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim
      wo wa cA vy cv cale cfv cdom wbr vy con0 crab cint cale fvex a1i cA con0
      wcel com cA wss wa cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv
      csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim
      wo wa cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cdom wbr
      cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv csdm wbr wn wa
      cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cen wbr cA con0
      wcel com cA wss wa cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv
      csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim
      wo wa cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv cdom wbr
      cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv csdm wbr wn cA
      con0 wcel com cA wss wa cA cA vy cv cale cfv cdom wbr vy con0 crab cint
      cale cfv cdom wbr cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc
      wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wo cA
      con0 wcel com cA wss wa cA vy cv cale cfv cdom wbr vy con0 wrex cA cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv cdom wbr cA con0 wcel cA
      vy cv cale cfv cdom wbr vy con0 wrex com cA wss cA con0 wcel cA cA cale
      cfv cdom wbr cA vy cv cale cfv cdom wbr vy con0 wrex cA con0 wcel cA cA
      cale cfv wss cA cA cale cfv cdom wbr cA omsubindss cA cA cale cfv con0
      ssdomg mpd cA vy cv cale cfv cdom wbr cA cA cale cfv cdom wbr vy cA con0
      vy cv cA wceq vy cv cale cfv cA cale cfv cA cdom vy cv cA cale fveq2
      breq2d rcla4ev mpdan adantr cA vy cv cale cfv cdom wbr cA cA vy cv cale
      cfv cdom wbr vy con0 crab cint cale cfv cdom wbr vy vy vx cA cA vy cv
      cale cfv cdom wbr vy con0 crab cint cale cfv cdom vx cv cA wcel vy ax-17
      vx cv cdom wcel vy ax-17 vy vx cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale vx cv cale wcel vy ax-17 vy vx cA vy cv cale cfv cdom wbr vy
      con0 crab cA vy cv cale cfv cdom wbr vy vx con0 hbrab1 hbint hbfv hbbr vy
      cv cA vy cv cale cfv cdom wbr vy con0 crab cint wceq vy cv cale cfv cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv cA cdom vy cv cA vy cv
      cale cfv cdom wbr vy con0 crab cint cale fveq2 breq2d onminsb syl adantr
      cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq
      vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wo cA cA
      vy cv cale cfv cdom wbr vy con0 crab cint cale cfv csdm wbr wn com cA wss
      cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq
      vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wo wa cA
      cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv wcel cA cA vy cv
      cale cfv cdom wbr vy con0 crab cint cale cfv csdm wbr cA con0 wcel cA vy
      cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq vz con0 wrex cA vy
      cv cale cfv cdom wbr vy con0 crab cint wlim wo cA cA vy cv cale cfv cdom
      wbr vy con0 crab cint cale cfv wcel wn cA con0 wcel cA vy cv cale cfv
      cdom wbr vy con0 crab cint vz cv csuc wceq vz con0 wrex cA cA vy cv cale
      cfv cdom wbr vy con0 crab cint cale cfv wcel wn cA vy cv cale cfv cdom
      wbr vy con0 crab cint wlim cA con0 wcel cA vy cv cale cfv cdom wbr vy
      con0 crab cint vz cv csuc wceq cA cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale cfv wcel wn vz con0 cA con0 wcel vz cv con0 wcel cA vy cv cale
      cfv cdom wbr vy con0 crab cint vz cv csuc wceq cA cA vy cv cale cfv cdom
      wbr vy con0 crab cint cale cfv wcel wn cA con0 wcel vz cv con0 wcel wa cA
      vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq wa cA cA vy cv
      cale cfv cdom wbr vy con0 crab cint cale cfv wcel cA vz cv cale cfv cdom
      wbr vz cv con0 wcel vz cv cA vy cv cale cfv cdom wbr vy con0 crab cint
      wcel cA vz cv cale cfv cdom wbr wn cA con0 wcel vz cv con0 wcel wa cA vy
      cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq wa cA vy cv cale
      cfv cdom wbr cA vz cv cale cfv cdom wbr vy vz cv vy cv vz cv wceq vy cv
      cale cfv vz cv cale cfv cA cdom vy cv vz cv cale fveq2 breq2d onnminsb cA
      con0 wcel vz cv con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint vz
      cv csuc wceq simplr cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv
      csuc wceq vz cv cA vy cv cale cfv cdom wbr vy con0 crab cint wcel cA con0
      wcel vz cv con0 wcel wa cA vy cv cale cfv cdom wbr vy con0 crab cint vz
      cv csuc wceq vz cv cA vy cv cale cfv cdom wbr vy con0 crab cint wcel vz
      cv vz cv csuc wcel vz cv vz visset sucid cA vy cv cale cfv cdom wbr vy
      con0 crab cint vz cv csuc vz cv eleq2 mpbiri adantl sylc cA con0 wcel vz
      cv con0 wcel wa cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc
      wceq wa cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv wcel cA
      vy cv vz cv cale cfv cdom wbr vy con0 crab wcel cA vz cv cale cfv cdom
      wbr cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq cA cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv wcel cA vz cv csuc cale
      cfv wcel cA con0 wcel vz cv con0 wcel wa cA vy cv vz cv cale cfv cdom wbr
      vy con0 crab wcel cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc
      wceq cA vy cv cale cfv cdom wbr vy con0 crab cint cale cfv vz cv csuc
      cale cfv cA cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv csuc cale
      fveq2 eleq2d vz cv con0 wcel cA vz cv csuc cale cfv wcel cA vy cv vz cv
      cale cfv cdom wbr vy con0 crab wcel wb cA con0 wcel vz cv con0 wcel vz cv
      csuc cale cfv vy cv vz cv cale cfv cdom wbr vy con0 crab cA vy vz cv
      omsubsuc2 eleq2d adantl sylan9bbr cA vy cv vz cv cale cfv cdom wbr vy
      con0 crab wcel cA con0 wcel cA vz cv cale cfv cdom wbr vy cv vz cv cale
      cfv cdom wbr cA vz cv cale cfv cdom wbr vy cA con0 vy cv cA vz cv cale
      cfv cdom breq1 elrab pm3.27bi syl6bi mtod exp31 r19.23adv cA con0 wcel cA
      vy cv cale cfv cdom wbr vy con0 crab cint wlim cA cA vy cv cale cfv cdom
      wbr vy con0 crab cint cale cfv wcel wn cA con0 wcel cA vy cv cale cfv
      cdom wbr vy con0 crab cint wlim wa cA cA vy cv cale cfv cdom wbr vy con0
      crab cint cale cfv wcel cA vz cv cale cfv cdom wbr vz cA vy cv cale cfv
      cdom wbr vy con0 crab cint wrex cA con0 wcel cA vy cv cale cfv cdom wbr
      vy con0 crab cint wlim wa cA vz cv cale cfv cdom wbr wn vz cA vy cv cale
      cfv cdom wbr vy con0 crab cint wral cA vz cv cale cfv cdom wbr vz cA vy
      cv cale cfv cdom wbr vy con0 crab cint wrex wn cA con0 wcel cA vy cv cale
      cfv cdom wbr vy con0 crab cint wlim wa cA vz cv cale cfv cdom wbr wn vz
      cA vy cv cale cfv cdom wbr vy con0 crab cint cA con0 wcel vz cv cA vy cv
      cale cfv cdom wbr vy con0 crab cint wcel cA vz cv cale cfv cdom wbr wn wi
      cA vy cv cale cfv cdom wbr vy con0 crab cint wlim vz cv cA vy cv cale cfv
      cdom wbr vy con0 crab cint wcel cA con0 wcel vz cv con0 wcel cA vz cv
      cale cfv cdom wbr wn cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab
      cint con0 wcel vz cv cA vy cv cale cfv cdom wbr vy con0 crab cint wcel vz
      cv con0 wcel wi cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 wrex cA
      vy cv cale cfv cdom wbr vy con0 crab cint con0 wcel cA con0 wcel cA cA
      cale cfv cdom wbr cA vy cv cale cfv cdom wbr vy con0 wrex cA con0 wcel cA
      cA cale cfv wss cA cA cale cfv cdom wbr cA omsubindss cA cA cale cfv con0
      ssdomg mpd cA vy cv cale cfv cdom wbr cA cA cale cfv cdom wbr vy cA con0
      vy cv cA wceq vy cv cale cfv cA cale cfv cA cdom vy cv cA cale fveq2
      breq2d rcla4ev mpdan cA vy cv cale cfv cdom wbr vy onintrab2 sylib cA vy
      cv cale cfv cdom wbr vy con0 crab cint con0 wcel vz cv cA vy cv cale cfv
      cdom wbr vy con0 crab cint wcel vz cv con0 wcel cA vy cv cale cfv cdom
      wbr vy con0 crab cint vz cv onelon ex syl cA vy cv cale cfv cdom wbr cA
      vz cv cale cfv cdom wbr vy vz cv vy cv vz cv wceq vy cv cale cfv vz cv
      cale cfv cA cdom vy cv vz cv cale fveq2 breq2d onnminsb syli adantr
      r19.21aiv cA vz cv cale cfv cdom wbr vz cA vy cv cale cfv cdom wbr vy
      con0 crab cint ralnex sylib cA con0 wcel cA vy cv cale cfv cdom wbr vy
      con0 crab cint wlim wa cA cA vy cv cale cfv cdom wbr vy con0 crab cint
      cale cfv wcel cA vz cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv
      cale cfv ciun wcel cA vz cv cale cfv cdom wbr vz cA vy cv cale cfv cdom
      wbr vy con0 crab cint wrex cA vy cv cale cfv cdom wbr vy con0 crab cint
      con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint wlim cA cA vy cv
      cale cfv cdom wbr vy con0 crab cint cale cfv wcel cA vz cA vy cv cale cfv
      cdom wbr vy con0 crab cint vz cv cale cfv ciun wcel wb cA con0 wcel cA vy
      cv cale cfv cdom wbr vy con0 crab cint con0 wcel cA vy cv cale cfv cdom
      wbr vy con0 crab cint wlim wa cA vy cv cale cfv cdom wbr vy con0 crab
      cint cale cfv vz cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv cale
      cfv ciun cA vz cA vy cv cale cfv cdom wbr vy con0 crab cint con0 alephlim
      eleq2d cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 wrex cA vy cv cale
      cfv cdom wbr vy con0 crab cint con0 wcel cA con0 wcel cA cA cale cfv cdom
      wbr cA vy cv cale cfv cdom wbr vy con0 wrex cA con0 wcel cA cA cale cfv
      wss cA cA cale cfv cdom wbr cA omsubindss cA cA cale cfv con0 ssdomg mpd
      cA vy cv cale cfv cdom wbr cA cA cale cfv cdom wbr vy cA con0 vy cv cA
      wceq vy cv cale cfv cA cale cfv cA cdom vy cv cA cale fveq2 breq2d
      rcla4ev mpdan cA vy cv cale cfv cdom wbr vy onintrab2 sylib sylan cA con0
      wcel cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wa cA vz cv cale
      cfv wcel vz cA vy cv cale cfv cdom wbr vy con0 crab cint wrex cA vz cv
      cale cfv cdom wbr vz cA vy cv cale cfv cdom wbr vy con0 crab cint wrex cA
      vz cA vy cv cale cfv cdom wbr vy con0 crab cint vz cv cale cfv ciun wcel
      cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint wlim wa cA vz
      cv cale cfv wcel cA vz cv cale cfv cdom wbr vz cA vy cv cale cfv cdom wbr
      vy con0 crab cint cA con0 wcel vz cv cA vy cv cale cfv cdom wbr vy con0
      crab cint wcel cA vz cv cale cfv wcel cA vz cv cale cfv cdom wbr wi wi cA
      vy cv cale cfv cdom wbr vy con0 crab cint wlim cA con0 wcel vz cv cA vy
      cv cale cfv cdom wbr vy con0 crab cint wcel cA vz cv cale cfv wcel cA vz
      cv cale cfv cdom wbr wi cA con0 wcel vz cv cA vy cv cale cfv cdom wbr vy
      con0 crab cint wcel wa cA vz cv cale cfv wss cA vz cv cale cfv cdom wbr
      cA vz cv cale cfv wcel cA con0 wcel cA vz cv cale cfv wss cA vz cv cale
      cfv cdom wbr wi vz cv cA vy cv cale cfv cdom wbr vy con0 crab cint wcel
      cA vz cv cale cfv con0 ssdomg adantr vz cv cale cfv con0 wcel cA vz cv
      cale cfv wcel cA vz cv cale cfv wss wi vz cv alephon vz cv cale cfv cA
      onelss ax-mp syl5 ex adantr r19.22dv vz cA cA vy cv cale cfv cdom wbr vy
      con0 crab cint vz cv cale cfv eliun syl5ib sylbid mtod ex jaod imp cA
      con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint con0 wcel cA cA vy
      cv cale cfv cdom wbr vy con0 crab cint cale cfv wcel cA cA vy cv cale cfv
      cdom wbr vy con0 crab cint cale cfv csdm wbr wb cA con0 wcel cA vy cv
      cale cfv cdom wbr vy con0 crab cint vz cv csuc wceq vz con0 wrex cA vy cv
      cale cfv cdom wbr vy con0 crab cint wlim wo wa cA cA vy cv cale cfv cdom
      wbr vy con0 crab cint elomsubsd cA con0 wcel cA vy cv cale cfv cdom wbr
      vy con0 crab cint vz cv csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr
      vy con0 crab cint wlim wo pm3.26 cA con0 wcel cA vy cv cale cfv cdom wbr
      vy con0 crab cint con0 wcel cA vy cv cale cfv cdom wbr vy con0 crab cint
      vz cv csuc wceq vz con0 wrex cA vy cv cale cfv cdom wbr vy con0 crab cint
      wlim wo cA con0 wcel cA vy cv cale cfv cdom wbr vy con0 wrex cA vy cv
      cale cfv cdom wbr vy con0 crab cint con0 wcel cA con0 wcel cA cA cale cfv
      cdom wbr cA vy cv cale cfv cdom wbr vy con0 wrex cA con0 wcel cA cA cale
      cfv wss cA cA cale cfv cdom wbr cA omsubindss cA cA cale cfv con0 ssdomg
      mpd cA vy cv cale cfv cdom wbr cA cA cale cfv cdom wbr vy cA con0 vy cv
      cA wceq vy cv cale cfv cA cale cfv cA cdom vy cv cA cale fveq2 breq2d
      rcla4ev mpdan cA vy cv cale cfv cdom wbr vy onintrab2 sylib adantr sylanc
      mtbid adantlr jca cA cA vy cv cale cfv cdom wbr vy con0 crab cint cale
      cfv bren2 sylibr sylc ex jaod mpd sylanc $.
      $( [23-Oct-2009] $) $( [23-Oct-2009] $)
  $}

  ${
    $d w x y z A $.
    $( An infinite initial ordinal is characterized by the property of being
       initial - that is, it is a subset of any dominating ordinal. $)
    omsubinit $p |- ( ( A e. On /\ om C_ A ) -> ( A e. ran aleph <-> A. x e. On
    ( A ~<_ x -> A C_ x ) ) ) $=
      cA con0 wcel com cA wss wa vy cv cale cfv cA wceq vy con0 wrex cA vx cv
      cdom wbr cA vx cv wss wi vx con0 wral cA cale crn wcel cA con0 wcel com
      cA wss wa vy cv cale cfv cA wceq vy con0 wrex cA vx cv cdom wbr cA vx cv
      wss wi vx con0 wral cA con0 wcel com cA wss wa vy cv cale cfv cA wceq cA
      vx cv cdom wbr cA vx cv wss wi vx con0 wral vy con0 cA con0 wcel com cA
      wss wa vy cv con0 wcel vy cv cale cfv cA wceq cA vx cv cdom wbr cA vx cv
      wss wi vx con0 wral cA con0 wcel com cA wss wa vy cv con0 wcel vy cv cale
      cfv cA wceq wa wa cA vx cv cdom wbr cA vx cv wss wi vx con0 cA con0 wcel
      com cA wss wa vy cv con0 wcel vy cv cale cfv cA wceq vx cv con0 wcel cA
      vx cv cdom wbr cA vx cv wss wi wi cA con0 wcel com cA wss wa vy cv con0
      wcel wa vx cv con0 wcel vy cv cale cfv cA wceq cA vx cv cdom wbr cA vx cv
      wss wi cA con0 wcel com cA wss wa vy cv con0 wcel vx cv con0 wcel vy cv
      cale cfv cA wceq cA vx cv cdom wbr cA vx cv wss wi wi vy cv con0 wcel vx
      cv con0 wcel wa vy cv cale cfv cA wceq cA vx cv cdom wbr cA vx cv wss wi
      wi cA con0 wcel com cA wss wa vy cv cale cfv cA wceq vy cv cale cfv vx cv
      cdom wbr vy cv cale cfv vx cv wss wi cA vx cv cdom wbr cA vx cv wss wi vy
      cv con0 wcel vx cv con0 wcel wa vy cv cale cfv cA wceq vy cv cale cfv vx
      cv cdom wbr cA vx cv cdom wbr vy cv cale cfv vx cv wss cA vx cv wss vy cv
      cale cfv cA vx cv cdom breq1 vy cv cale cfv cA vx cv sseq1 imbi12d vy cv
      con0 wcel vx cv con0 wcel wa vy cv cale cfv vx cv wss vy cv cale cfv vx
      cv cdom wbr vy cv vx cv omsubdmss biimprd syl5cbi adantl expr com23 impr
      r19.21aiv exp32 r19.23adv cA con0 wcel com cA wss wa vz cv cA cen wbr vz
      cale crn wrex cA vx cv cdom wbr cA vx cv wss wi vx con0 wral vy cv cale
      cfv cA wceq vy con0 wrex wi vz cA infenomsub cA con0 wcel com cA wss wa
      vz cv cA cen wbr cA vx cv cdom wbr cA vx cv wss wi vx con0 wral vy cv
      cale cfv cA wceq vy con0 wrex wi vz cale crn cA con0 wcel com cA wss wa
      vw cv cale cfv vz cv wceq vw con0 wrex vz cv cA cen wbr cA vx cv cdom wbr
      cA vx cv wss wi vx con0 wral vy cv cale cfv cA wceq vy con0 wrex wi wi vz
      cv cale crn wcel cA con0 wcel com cA wss wa vw cv cale cfv vz cv wceq vz
      cv cA cen wbr cA vx cv cdom wbr cA vx cv wss wi vx con0 wral vy cv cale
      cfv cA wceq vy con0 wrex wi wi vw con0 cA con0 wcel com cA wss wa vw cv
      con0 wcel vw cv cale cfv vz cv wceq vz cv cA cen wbr cA vx cv cdom wbr cA
      vx cv wss wi vx con0 wral vy cv cale cfv cA wceq vy con0 wrex wi wi wi vw
      cv cale cfv vz cv wceq vw cv cale cfv cA cen wbr cA vx cv cdom wbr cA vx
      cv wss wi vx con0 wral vy cv cale cfv cA wceq vy con0 wrex wi wi vz cv cA
      cen wbr cA vx cv cdom wbr cA vx cv wss wi vx con0 wral vy cv cale cfv cA
      wceq vy con0 wrex wi wi cA con0 wcel com cA wss wa vw cv con0 wcel wa vw
      cv cale cfv vz cv wceq vw cv cale cfv cA cen wbr vz cv cA cen wbr cA vx
      cv cdom wbr cA vx cv wss wi vx con0 wral vy cv cale cfv cA wceq vy con0
      wrex wi vw cv cale cfv vz cv cA cen breq1 imbi1d cA con0 wcel com cA wss
      wa vw cv con0 wcel vw cv cale cfv cA cen wbr cA vx cv cdom wbr cA vx cv
      wss wi vx con0 wral vy cv cale cfv cA wceq vy con0 wrex wi cA con0 wcel
      com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr wa wa cA vw cv
      cale cfv cdom wbr cA vw cv cale cfv wss wi vy cv cale cfv cA wceq vy con0
      wrex cA vx cv cdom wbr cA vx cv wss wi vx con0 wral cA con0 wcel com cA
      wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr wa wa cA vw cv cale cfv
      cdom wbr cA vw cv cale cfv wss wi cA vw cv cale cfv cdom wbr vy cv cale
      cfv cA wceq vy con0 wrex cA con0 wcel com cA wss wa vw cv con0 wcel vw cv
      cale cfv cA cen wbr wa wa cA vw cv cale cfv cen wbr cA vw cv cale cfv
      cdom wbr cA con0 wcel vw cv cale cfv cA cen wbr cA vw cv cale cfv cen wbr
      cA con0 wcel com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr wa
      wa vw cv cale cfv cA con0 ensymg cA con0 wcel com cA wss vw cv con0 wcel
      vw cv cale cfv cA cen wbr wa simpll cA con0 wcel com cA wss wa vw cv con0
      wcel vw cv cale cfv cA cen wbr simprr sylc cA vw cv cale cfv endom syl cA
      con0 wcel com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr wa wa
      cA vw cv cale cfv wss vy cv cale cfv cA wceq vy con0 wrex cA vw cv cale
      cfv cdom wbr cA con0 wcel com cA wss wa vw cv con0 wcel vw cv cale cfv cA
      cen wbr wa wa cA vw cv cale cfv wss vy cv cale cfv cA wceq vy con0 wrex
      vw cv con0 wcel vw cv cale cfv cA wceq vy cv cale cfv cA wceq vy con0
      wrex cA con0 wcel com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr
      wa wa cA vw cv cale cfv wss wa vy cv cale cfv cA wceq vw cv cale cfv cA
      wceq vy vw cv con0 vy cv vw cv wceq vy cv cale cfv vw cv cale cfv cA vy
      cv vw cv cale fveq2 eqeq1d rcla4ev cA con0 wcel com cA wss wa vw cv con0
      wcel vw cv cale cfv cA cen wbr cA vw cv cale cfv wss simplrl cA con0 wcel
      com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr wa wa cA vw cv
      cale cfv wss wa vw cv cale cfv cA cA con0 wcel com cA wss wa vw cv con0
      wcel vw cv cale cfv cA cen wbr wa wa vw cv cale cfv cA wss cA vw cv cale
      cfv wss cA con0 wcel com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen
      wbr vw cv cale cfv cA wss cA con0 wcel com cA wss wa vw cv con0 wcel wa
      vw cv cale cfv cA cdom wbr vw cv cale cfv cA wss vw cv cale cfv cA cen
      wbr cA con0 wcel com cA wss wa vw cv con0 wcel wa vw cv cale cfv cA wss
      vw cv cale cfv cA cdom wbr cA con0 wcel vw cv con0 wcel vw cv cale cfv cA
      wss vw cv cale cfv cA cdom wbr wb com cA wss vw cv con0 wcel cA con0 wcel
      vw cv cale cfv cA wss vw cv cale cfv cA cdom wbr wb vw cv cA omsubdmss
      ancoms adantlr biimprd vw cv cale cfv cA endom syl5 impr adantr cA con0
      wcel com cA wss wa vw cv con0 wcel vw cv cale cfv cA cen wbr wa wa cA vw
      cv cale cfv wss pm3.27 eqssd sylanc ex imim2d mpid vw cv cale cfv con0
      wcel cA vx cv cdom wbr cA vx cv wss wi vx con0 wral cA vw cv cale cfv
      cdom wbr cA vw cv cale cfv wss wi wi vw cv alephon cA vx cv cdom wbr cA
      vx cv wss wi cA vw cv cale cfv cdom wbr cA vw cv cale cfv wss wi vx vw cv
      cale cfv con0 vx cv vw cv cale cfv wceq cA vx cv cdom wbr cA vw cv cale
      cfv cdom wbr cA vx cv wss cA vw cv cale cfv wss vx cv vw cv cale cfv cA
      cdom breq2 vx cv vw cv cale cfv cA sseq2 imbi12d rcla4v ax-mp syl5 expr
      syl5cbi ex r19.23adv cale con0 wfn vz cv cale crn wcel vw cv cale cfv vz
      cv wceq vw con0 wrex wb alephfnon vw con0 vz cv cale fvelrnb ax-mp syl5ib
      r19.23adv mpd impbid cale con0 wfn cA cale crn wcel vy cv cale cfv cA
      wceq vy con0 wrex wb alephfnon vy con0 cA cale fvelrnb ax-mp syl5bb $.
      $( [29-Oct-2009] $) $( [29-Oct-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Basic topological facts
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t A $. $d t x y $.
    $( A collection of finite intersections is a basis. The initial set is a
       subbasis for the topology. Compare ~ subbas . $)
    fibas $p |- ( A e. B -> ( fi ` A ) e. Bases ) $=
      vt cv cfi cfv ctb wcel cA cfi cfv ctb wcel vt cA cB vt cv cA wceq vt cv
      cfi cfv cA cfi cfv ctb vt cv cA cfi fveq2 eleq1d vx vy vt cv vt cv cfi
      cfv vt visset vt cv cvv wcel vt cv cfi cfv vy cv vt cv wss vy cv cfn wcel
      vx cv vy cv cint wceq w3a vy wex vx cab wceq vt visset vy vx vt cv cvv
      fiv ax-mp subbas vtoclg $.
      $( [25-Aug-2009] $) $( [25-Aug-2009] $)
  $}

  ${
    $d x y J $.
    $( A topology is closed under finite intersections. $)
    fitop $p |- ( J e. Top -> ( fi ` J ) = J ) $=
      cJ ctop wcel vx cv vy cv cin cJ wcel vy cJ wral vx cJ wral cJ cfi cfv cJ
      wceq cJ ctop wcel vx cv vy cv cin cJ wcel vx vy cJ cJ cJ ctop wcel vx cv
      cJ wcel vy cv cJ wcel vx cv vy cv cin cJ wcel vx cv vy cv cJ inopn 3expib
      r19.21aivv vx vy cJ ctop inficlALT mpbid $.
      $( [7-Oct-2009] $) $( [7-Oct-2009] $)
  $}

  ${
    $d u v A $. $d u v B $. $d x y z F $. $d u v x y z J $. $d u v x y z X $.
    opncldf.1 $e |- X = U. J $.
    opncldf.2 $e |- F = { <. u , v >. | ( u e. J /\ v = ( X \ u ) ) } $.
    $( A bijection useful for converting statements about open sets to
       statements about closed sets and vice versa. $)
    opncldf1 $p |- ( J e. Top -> F : J -1-1-onto-> ( Clsd ` J ) ) $=
      cJ ctop wcel cF cJ wfn cF ccnv cJ ccld cfv wfn wa cJ cJ ccld cfv cF wf1o
      cJ ctop wcel cF cJ wfn cF ccnv cJ ccld cfv wfn cJ ctop wcel cX vu cv cdif
      cvv wcel vu cJ wral cF cJ wfn cJ ctop wcel cX vu cv cdif cvv wcel vu cJ
      cX cvv wcel vu cv cX wss cX vu cv cdif cvv wcel cJ ctop wcel vu cv cJ
      wcel cX cvv wcel cX vu cv cdif cvv wcel vu cv cX wss cX vu cv cvv difexg
      adantr cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg opncldf.1 syl5eqel vu
      cv cJ wcel vu cv cJ cuni cX vu cv cJ elssuni opncldf.1 syl6ssr syl2an
      r19.21aiva vu vv cJ cX vu cv cdif cF opncldf.2 fnopab2g sylib cJ ctop
      wcel cF ccnv wfun cF ccnv cdm cJ ccld cfv wceq wa cF ccnv cJ ccld cfv wfn
      cJ ctop wcel cF ccnv wfun cF ccnv cdm cJ ccld cfv wceq cJ ctop wcel cF
      ccnv wrel vx cv vy cv cF ccnv wbr vx cv vz cv cF ccnv wbr wa vy cv vz cv
      wceq wi vz wal vy wal vx wal wa cF ccnv wfun cJ ctop wcel vx cv vy cv cF
      ccnv wbr vx cv vz cv cF ccnv wbr wa vy cv vz cv wceq wi vz wal vy wal vx
      wal cF ccnv wrel cJ ctop wcel vx cv vy cv cF ccnv wbr vx cv vz cv cF ccnv
      wbr wa vy cv vz cv wceq wi vz wal vx vy cJ ctop wcel vx cv vy cv cF ccnv
      wbr vx cv vz cv cF ccnv wbr wa vy cv vz cv wceq wi vz cJ ctop wcel vy cv
      vx cv cop cF wcel vz cv vx cv cop cF wcel wa vy cv vz cv wceq vx cv vy cv
      cF ccnv wbr vx cv vz cv cF ccnv wbr wa cJ ctop wcel vy cv vx cv cop cF
      wcel vz cv vx cv cop cF wcel vy cv vz cv wceq cJ ctop wcel vy cv cJ wcel
      vx cv cX vy cv cdif wceq wa vz cv vx cv cop cF wcel vy cv vz cv wceq wi
      vy cv vx cv cop cF wcel cJ ctop wcel vz cv vx cv cop cF wcel vy cv cJ
      wcel vx cv cX vy cv cdif wceq wa vy cv vz cv wceq cJ ctop wcel vz cv cJ
      wcel vx cv cX vz cv cdif wceq wa vy cv cJ wcel vx cv cX vy cv cdif wceq
      wa vy cv vz cv wceq wi vz cv vx cv cop cF wcel cJ ctop wcel vz cv cJ wcel
      vx cv cX vz cv cdif wceq vy cv cJ wcel vx cv cX vy cv cdif wceq wa vy cv
      vz cv wceq wi vx cv cX vz cv cdif wceq vy cv cJ wcel vx cv cX vy cv cdif
      wceq wa cJ ctop wcel vz cv cJ wcel vy cv vz cv wceq vx cv cX vz cv cdif
      wceq vy cv cJ wcel vx cv cX vy cv cdif wceq cJ ctop wcel vz cv cJ wcel vy
      cv vz cv wceq wi wi vx cv cX vz cv cdif wceq vx cv cX vy cv cdif wceq vy
      cv cJ wcel cJ ctop wcel vz cv cJ wcel vy cv vz cv wceq wi wi vx cv cX vz
      cv cdif wceq vx cv cX vy cv cdif wceq cX vy cv cdif cX vz cv cdif wceq vy
      cv cJ wcel cJ ctop wcel vz cv cJ wcel vy cv vz cv wceq wi wi wi vx cv cX
      vz cv cdif wceq cX vy cv cdif vx cv wceq cX vy cv cdif cX vz cv cdif wceq
      vx cv cX vy cv cdif wceq cX vy cv cdif vx cv wceq vx cv cX vz cv cdif
      wceq cX vy cv cdif cX vz cv cdif wceq cX vy cv cdif vx cv cX vz cv cdif
      eqtr expcom vx cv cX vy cv cdif eqcom syl5ib cX vy cv cdif cX vz cv cdif
      wceq cX cX vy cv cdif cdif cX cX vz cv cdif cdif wceq vy cv cJ wcel cJ
      ctop wcel vz cv cJ wcel vy cv vz cv wceq wi wi wi cX vy cv cdif cX vz cv
      cdif cX difeq2 cJ ctop wcel vy cv cJ wcel cX cX vy cv cdif cdif cX cX vz
      cv cdif cdif wceq vz cv cJ wcel vy cv vz cv wceq wi cJ ctop wcel vy cv cJ
      wcel vy cv cX wss cX cX vy cv cdif cdif cX cX vz cv cdif cdif wceq vz cv
      cJ wcel vy cv vz cv wceq wi wi cJ ctop wcel vy cv cJ wcel vy cv cX wss vy
      cv cJ cX opncldf.1 eltopss ex cJ ctop wcel cX cX vy cv cdif cdif vy cv
      wceq cX cX vy cv cdif cdif cX cX vz cv cdif cdif wceq vz cv cJ wcel vy cv
      vz cv wceq wi wi vy cv cX wss cX cX vy cv cdif cdif vy cv wceq cX cX vy
      cv cdif cdif cX cX vz cv cdif cdif wceq cJ ctop wcel vz cv cJ wcel vy cv
      vz cv wceq wi cX cX vy cv cdif cdif cX cX vz cv cdif cdif wceq cJ ctop
      wcel vz cv cJ wcel vy cv vz cv wceq wi wi wi vy cv cX cX vy cv cdif cdif
      vy cv cX cX vy cv cdif cdif wceq cX cX vy cv cdif cdif cX cX vz cv cdif
      cdif wceq cJ ctop wcel vz cv cJ wcel vy cv vz cv wceq wi wi vy cv cX cX
      vy cv cdif cdif wceq cX cX vy cv cdif cdif cX cX vz cv cdif cdif wceq wa
      vy cv cX cX vz cv cdif cdif wceq cJ ctop wcel vz cv cJ wcel vy cv vz cv
      wceq wi wi vy cv cX cX vy cv cdif cdif cX cX vz cv cdif cdif eqtr cJ ctop
      wcel vz cv cJ wcel vy cv cX cX vz cv cdif cdif wceq vy cv vz cv wceq cJ
      ctop wcel vz cv cJ wcel vz cv cX wss vy cv cX cX vz cv cdif cdif wceq vy
      cv vz cv wceq wi cJ ctop wcel vz cv cJ wcel vz cv cX wss vz cv cJ cX
      opncldf.1 eltopss ex vz cv cX wss cX cX vz cv cdif cdif vz cv wceq vy cv
      cX cX vz cv cdif cdif wceq vy cv vz cv wceq wi vz cv cX dfss4 vy cv cX cX
      vz cv cdif cdif wceq cX cX vz cv cdif cdif vz cv wceq vy cv vz cv wceq vy
      cv cX cX vz cv cdif cdif vz cv eqtr expcom sylbi syl6 com3r syl ex eqcoms
      com3r vy cv cX dfss4 syl5ib syld com13 syl syl6 com23 imp3a com4t imp3a
      vz cv vx cv cop cF wcel vz cv vx cv cop vu cv cJ wcel vv cv cX vu cv cdif
      wceq wa vu vv copab wcel vz cv cJ wcel vx cv cX vz cv cdif wceq wa cF vu
      cv cJ wcel vv cv cX vu cv cdif wceq wa vu vv copab vz cv vx cv cop
      opncldf.2 eleq2i vu cv cJ wcel vv cv cX vu cv cdif wceq wa vz cv cJ wcel
      vv cv cX vz cv cdif wceq wa vz cv cJ wcel vx cv cX vz cv cdif wceq wa vu
      vv vz cv vx cv vz visset vx visset vu cv vz cv wceq vu cv cJ wcel vz cv
      cJ wcel vv cv cX vu cv cdif wceq vv cv cX vz cv cdif wceq vu cv vz cv cJ
      eleq1 vu cv vz cv wceq cX vu cv cdif cX vz cv cdif vv cv vu cv vz cv cX
      difeq2 eqeq2d anbi12d vv cv vx cv wceq vv cv cX vz cv cdif wceq vx cv cX
      vz cv cdif wceq vz cv cJ wcel vv cv vx cv cX vz cv cdif eqeq1 anbi2d
      opelopab bitri syl5ib com23 vy cv vx cv cop cF wcel vy cv vx cv cop vu cv
      cJ wcel vv cv cX vu cv cdif wceq wa vu vv copab wcel vy cv cJ wcel vx cv
      cX vy cv cdif wceq wa cF vu cv cJ wcel vv cv cX vu cv cdif wceq wa vu vv
      copab vy cv vx cv cop opncldf.2 eleq2i vu cv cJ wcel vv cv cX vu cv cdif
      wceq wa vy cv cJ wcel vv cv cX vy cv cdif wceq wa vy cv cJ wcel vx cv cX
      vy cv cdif wceq wa vu vv vy cv vx cv vy visset vx visset vu cv vy cv wceq
      vu cv cJ wcel vy cv cJ wcel vv cv cX vu cv cdif wceq vv cv cX vy cv cdif
      wceq vu cv vy cv cJ eleq1 vu cv vy cv wceq cX vu cv cdif cX vy cv cdif vv
      cv vu cv vy cv cX difeq2 eqeq2d anbi12d vv cv vx cv wceq vv cv cX vy cv
      cdif wceq vx cv cX vy cv cdif wceq vy cv cJ wcel vv cv vx cv cX vy cv
      cdif eqeq1 anbi2d opelopab bitri syl5ib imp3a vx cv vy cv cF ccnv wbr vy
      cv vx cv cop cF wcel vx cv vz cv cF ccnv wbr vz cv vx cv cop cF wcel vx
      cv vy cv cF ccnv wbr vy cv vx cv cF wbr vy cv vx cv cop cF wcel vx cv vy
      cv cF vx visset vy visset brcnv vy cv vx cv cF df-br bitri vx cv vz cv cF
      ccnv wbr vz cv vx cv cF wbr vz cv vx cv cop cF wcel vx cv vz cv cF vx
      visset vz visset brcnv vz cv vx cv cF df-br bitri anbi12i syl5ib 19.21aiv
      19.21aivv cF relcnv jctil vx vy vz cF ccnv dffun2 sylibr cJ ctop wcel cF
      crn cJ ccld cfv cF ccnv cdm cJ ctop wcel vx cF crn cJ ccld cfv cJ ctop
      wcel vx cv cX vy cv cdif wceq vy cJ wrex vx cv cJ ccld cfv wcel vx cv cF
      crn wcel cJ ctop wcel vx cv cX vy cv cdif wceq vy cJ wrex vx cv cJ ccld
      cfv wcel cJ ctop wcel vx cv cX vy cv cdif wceq vx cv cJ ccld cfv wcel vy
      cJ vx cv cX vy cv cdif wceq vx cv cJ ccld cfv wcel cX vy cv cdif cJ ccld
      cfv wcel cJ ctop wcel vy cv cJ wcel wa vx cv cX vy cv cdif cJ ccld cfv
      eleq1 vy cv cJ cX opncldf.1 opncld syl5cbir r19.23adva cJ ctop wcel vx cv
      cJ ccld cfv wcel vx cv cX vy cv cdif wceq vy cJ wrex cX vx cv cdif cJ
      wcel vx cv cX cX vx cv cdif cdif wceq vx cv cX vy cv cdif wceq vy cJ wrex
      cJ ctop wcel vx cv cJ ccld cfv wcel wa vx cv cX vy cv cdif wceq vx cv cX
      cX vx cv cdif cdif wceq vy cX vx cv cdif cJ vy cv cX vx cv cdif wceq cX
      vy cv cdif cX cX vx cv cdif cdif vx cv vy cv cX vx cv cdif cX difeq2
      eqeq2d rcla4ev vx cv cJ cX opncldf.1 cldopn cJ ctop wcel vx cv cJ ccld
      cfv wcel wa cX cX vx cv cdif cdif vx cv cJ ctop wcel vx cv cJ ccld cfv
      wcel wa vx cv cX wss cX cX vx cv cdif cdif vx cv wceq vx cv cJ cX
      opncldf.1 cldss vx cv cX dfss4 sylib eqcomd sylanc ex impbid vy cv vx cv
      cop cF wcel vy wex vy cv cJ wcel vx cv cX vy cv cdif wceq wa vy wex vx cv
      cF crn wcel vx cv cX vy cv cdif wceq vy cJ wrex vy cv vx cv cop cF wcel
      vy cv cJ wcel vx cv cX vy cv cdif wceq wa vy vy cv vx cv cop cF wcel vy
      cv vx cv cop vu cv cJ wcel vv cv cX vu cv cdif wceq wa vu vv copab wcel
      vy cv cJ wcel vx cv cX vy cv cdif wceq wa cF vu cv cJ wcel vv cv cX vu cv
      cdif wceq wa vu vv copab vy cv vx cv cop opncldf.2 eleq2i vu cv cJ wcel
      vv cv cX vu cv cdif wceq wa vy cv cJ wcel vv cv cX vy cv cdif wceq wa vy
      cv cJ wcel vx cv cX vy cv cdif wceq wa vu vv vy cv vx cv vy visset vx
      visset vu cv vy cv wceq vu cv cJ wcel vy cv cJ wcel vv cv cX vu cv cdif
      wceq vv cv cX vy cv cdif wceq vu cv vy cv cJ eleq1 vu cv vy cv wceq cX vu
      cv cdif cX vy cv cdif vv cv vu cv vy cv cX difeq2 eqeq2d anbi12d vv cv vx
      cv wceq vv cv cX vy cv cdif wceq vx cv cX vy cv cdif wceq vy cv cJ wcel
      vv cv vx cv cX vy cv cdif eqeq1 anbi2d opelopab bitri exbii vy vx cv cF
      vx visset elrn2 vx cv cX vy cv cdif wceq vy cJ df-rex 3bitr4i syl5bb
      eqrdv cF df-rn syl5eqr jca cF ccnv cJ ccld cfv df-fn sylibr jca cJ cJ
      ccld cfv cF dff1o4 sylibr $.
      $( [27-Aug-2009] $) $( [27-Aug-2009] $)

    $( The values of the open-closed bijection. $)
    opncldf2 $p |- ( ( J e. Top /\ A e. J ) -> ( F ` A ) = ( X \ A ) ) $=
      cX cA cdif cJ ccld cfv wcel cF wfun wa cA cX cA cdif cop cF wcel cA cF
      cfv cX cA cdif wceq cJ ctop wcel cA cJ wcel wa cA cX cA cdif cJ ccld cfv
      cF funopfvg cJ ctop wcel cA cJ wcel wa cX cA cdif cJ ccld cfv wcel cF
      wfun cA cJ cX opncldf.1 opncld cJ ctop wcel cF wfun cA cJ wcel cJ ctop
      wcel cJ cJ ccld cfv cF wf1o cF wfun vv vu cF cJ cX opncldf.1 opncldf.2
      opncldf1 cJ cJ ccld cfv cF f1ofun syl adantr jca cJ ctop wcel cA cJ wcel
      wa cA cX cA cdif cop cF wcel cA cJ wcel cX cA cdif cX cA cdif wceq wa cJ
      ctop wcel cA cJ wcel wa cA cJ wcel cX cA cdif cX cA cdif wceq cJ ctop
      wcel cA cJ wcel pm3.27 cX cA cdif eqid jctir cA cJ wcel cX cA cdif cJ
      ccld cfv wcel cA cX cA cdif cop cF wcel cA cJ wcel cX cA cdif cX cA cdif
      wceq wa wb cJ ctop wcel cA cJ wcel wa cA cJ wcel cX cA cdif cJ ccld cfv
      wcel wa cA cX cA cdif cop vu cv cJ wcel vv cv cX vu cv cdif wceq wa vu vv
      copab wcel cA cJ wcel cX cA cdif cX cA cdif wceq wa cA cX cA cdif cop cF
      wcel vu cv cJ wcel vv cv cX vu cv cdif wceq wa cA cJ wcel vv cv cX cA
      cdif wceq wa cA cJ wcel cX cA cdif cX cA cdif wceq wa vu vv cA cX cA cdif
      cJ cJ ccld cfv vu cv cA wceq vu cv cJ wcel cA cJ wcel vv cv cX vu cv cdif
      wceq vv cv cX cA cdif wceq vu cv cA cJ eleq1 vu cv cA wceq cX vu cv cdif
      cX cA cdif vv cv vu cv cA cX difeq2 eqeq2d anbi12d vv cv cX cA cdif wceq
      vv cv cX cA cdif wceq cX cA cdif cX cA cdif wceq cA cJ wcel vv cv cX cA
      cdif cX cA cdif eqeq1 anbi2d opelopabg cF vu cv cJ wcel vv cv cX vu cv
      cdif wceq wa vu vv copab cA cX cA cdif cop opncldf.2 eleq2i syl5bb cJ
      ctop wcel cA cJ wcel pm3.27 cA cJ cX opncldf.1 opncld sylanc mpbird sylc
      $.
      $( [27-Aug-2009] $) $( [27-Aug-2009] $)

    $( The values of the converse/inverse of the open-closed bijection. $)
    opncldf3 $p |- ( ( J e. Top /\ B e. ( Clsd ` J ) ) -> ( `' F ` B ) = ( X \
    B ) ) $=
      cX cB cdif cJ wcel cF ccnv wfun wa cB cX cB cdif cop cF ccnv wcel cB cF
      ccnv cfv cX cB cdif wceq cJ ctop wcel cB cJ ccld cfv wcel wa cB cX cB
      cdif cJ cF ccnv funopfvg cJ ctop wcel cB cJ ccld cfv wcel wa cX cB cdif
      cJ wcel cF ccnv wfun cB cJ cX opncldf.1 cldopn cJ ctop wcel cF ccnv wfun
      cB cJ ccld cfv wcel cJ ctop wcel cJ cJ ccld cfv cF wf1o cJ ccld cfv cJ cF
      ccnv wf1o cF ccnv wfun vv vu cF cJ cX opncldf.1 opncldf.2 opncldf1 cJ cJ
      ccld cfv cF f1ocnv cJ ccld cfv cJ cF ccnv f1ofun 3syl adantr jca cJ ctop
      wcel cB cJ ccld cfv wcel wa cB cX cB cdif cop cF ccnv wcel cX cB cdif cB
      cop cF wcel cJ ctop wcel cB cJ ccld cfv wcel wa cX cB cdif cB cop cF wcel
      cX cB cdif cJ wcel cB cX cX cB cdif cdif wceq wa cJ ctop wcel cB cJ ccld
      cfv wcel wa cX cB cdif cJ wcel cB cX cX cB cdif cdif wceq cB cJ cX
      opncldf.1 cldopn cJ ctop wcel cB cJ ccld cfv wcel wa cB cX wss cB cX cX
      cB cdif cdif wceq cB cJ cX opncldf.1 cldss cB cX wss cX cX cB cdif cdif
      cB wceq cB cX cX cB cdif cdif wceq cB cX dfss4 cX cX cB cdif cdif cB
      eqcom bitri sylib jca cJ ctop wcel cB cJ ccld cfv wcel wa cX cB cdif cB
      cop vu cv cJ wcel vv cv cX vu cv cdif wceq wa vu vv copab wcel cX cB cdif
      cJ wcel cB cX cX cB cdif cdif wceq wa cX cB cdif cB cop cF wcel cJ ctop
      wcel cB cJ ccld cfv wcel cX cB cdif cJ wcel cX cB cdif cB cop vu cv cJ
      wcel vv cv cX vu cv cdif wceq wa vu vv copab wcel cX cB cdif cJ wcel cB
      cX cX cB cdif cdif wceq wa wb cB cJ cX opncldf.1 cldopn vu cv cJ wcel vv
      cv cX vu cv cdif wceq wa cX cB cdif cJ wcel vv cv cX cX cB cdif cdif wceq
      wa cX cB cdif cJ wcel cB cX cX cB cdif cdif wceq wa vu vv cX cB cdif cB
      cJ cJ ccld cfv vu cv cX cB cdif wceq vu cv cJ wcel cX cB cdif cJ wcel vv
      cv cX vu cv cdif wceq vv cv cX cX cB cdif cdif wceq vu cv cX cB cdif cJ
      eleq1 vu cv cX cB cdif wceq cX vu cv cdif cX cX cB cdif cdif vv cv vu cv
      cX cB cdif cX difeq2 eqeq2d anbi12d vv cv cB wceq vv cv cX cX cB cdif
      cdif wceq cB cX cX cB cdif cdif wceq cX cB cdif cJ wcel vv cv cB cX cX cB
      cdif cdif eqeq1 anbi2d opelopabg sylancom cF vu cv cJ wcel vv cv cX vu cv
      cdif wceq wa vu vv copab cX cB cdif cB cop opncldf.2 eleq2i syl5bb mpbird
      cB cJ ccld cfv wcel cX cB cdif cJ wcel cB cX cB cdif cop cF ccnv wcel cX
      cB cdif cB cop cF wcel wb cJ ctop wcel cB cJ ccld cfv wcel wa cB cX cB
      cdif cJ ccld cfv cJ cF opelcnvg cJ ctop wcel cB cJ ccld cfv wcel pm3.27
      cB cJ cX opncldf.1 cldopn sylanc mpbird sylc $.
      $( [27-Aug-2009] $) $( [27-Aug-2009] $)
  $}

  ${
    $d o J $. $d o O $. $d o S $. $d o X $.
    ssntr.1 $e |- X = U. J $.
    $( An open subset of a set is a subset of the set's interior. $)
    ssntr $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( O e. J /\ O C_ S ) ) -> O C_ (
    ( int ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss wa cO cJ wcel cO cS wss wa wa cO vo cv cS wss vo
      cJ crab cuni cS cJ cnt cfv cfv cO cJ wcel cO cS wss wa cO vo cv cS wss vo
      cJ crab cuni wss cJ ctop wcel cS cX wss wa cO cJ wcel cO cS wss wa cO vo
      cv cS wss vo cJ crab wcel cO vo cv cS wss vo cJ crab cuni wss vo cv cS
      wss cO cS wss vo cO cJ vo cv cO cS sseq1 elrab cO vo cv cS wss vo cJ crab
      elssuni sylbir adantl cJ ctop wcel cS cX wss wa cS cJ cnt cfv cfv vo cv
      cS wss vo cJ crab cuni wceq cO cJ wcel cO cS wss wa vo cS cJ cX ssntr.1
      ntrval adantr sseqtr4d $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    ntrcmp.1 $e |- X = U. J $.
    $( An interior of a complement is the complement of the closure. This set
       is also known as the exterior of ` A ` . $)
    ntrcmp $p |- ( ( J e. Top /\ A C_ X ) -> ( ( int ` J ) ` ( X \ A ) ) = ( X
    \ ( ( cls ` J ) ` A ) ) ) $=
      cJ ctop wcel cA cX wss wa cX cA cdif cJ cnt cfv cfv cX cX cX cA cdif cdif
      cJ ccl cfv cfv cdif cX cA cJ ccl cfv cfv cdif cJ ctop wcel cX cA cdif cJ
      cnt cfv cfv cX cX cX cA cdif cdif cJ ccl cfv cfv cdif wceq cA cX wss cJ
      ctop wcel cX cA cdif cX wss cX cA cdif cJ cnt cfv cfv cX cX cX cA cdif
      cdif cJ ccl cfv cfv cdif wceq cX cA difss cX cA cdif cJ cX ntrcmp.1
      ntrval2 mpan2 adantr cJ ctop wcel cA cX wss wa cX cX cA cdif cdif cJ ccl
      cfv cfv cA cJ ccl cfv cfv cX cJ ctop wcel cA cX wss wa cX cX cA cdif cdif
      cA cJ ccl cfv cJ ctop wcel cA cX wss wa cA cX wss cX cX cA cdif cdif cA
      wceq cJ ctop wcel cA cX wss pm3.27 cA cX dfss4 sylib fveq2d difeq2d eqtrd
      $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    clscmp.1 $e |- X = U. J $.
    $( A closure of a complement is the complement of the interior. $)
    clscmp $p |- ( ( J e. Top /\ A C_ X ) -> ( ( cls ` J ) ` ( X \ A ) ) = ( X
    \ ( ( int ` J ) ` A ) ) ) $=
      cJ ctop wcel cA cX wss wa cX cA cdif cJ ccl cfv cfv cX cX cX cA cdif cdif
      cJ cnt cfv cfv cdif cX cA cJ cnt cfv cfv cdif cJ ctop wcel cX cA cdif cJ
      ccl cfv cfv cX cX cX cA cdif cdif cJ cnt cfv cfv cdif wceq cA cX wss cJ
      ctop wcel cX cA cdif cX wss cX cA cdif cJ ccl cfv cfv cX cX cX cA cdif
      cdif cJ cnt cfv cfv cdif wceq cX cA difss cX cA cdif cJ cX clscmp.1
      clsval2 mpan2 adantr cJ ctop wcel cA cX wss wa cX cX cA cdif cdif cJ cnt
      cfv cfv cA cJ cnt cfv cfv cX cJ ctop wcel cA cX wss wa cX cX cA cdif cdif
      cA cJ cnt cfv cJ ctop wcel cA cX wss wa cA cX wss cX cX cA cdif cdif cA
      wceq cJ ctop wcel cA cX wss pm3.27 cA cX dfss4 sylib fveq2d difeq2d eqtrd
      $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    topbnd.1 $e |- X = U. J $.
    $( Two equivalent expressions for the boundary of a topology. $)
    topbnd $p |- ( ( J e. Top /\ A C_ X ) -> ( ( ( cls ` J ) ` A ) i^i ( ( cls
    ` J ) ` ( X \ A ) ) ) = ( ( ( cls ` J ) ` A ) \ ( ( int ` J ) ` A ) ) ) $=
      cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin
      cA cJ ccl cfv cfv cX cin cA cJ cnt cfv cfv cdif cA cJ ccl cfv cfv cA cJ
      cnt cfv cfv cdif cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cA cdif
      cJ ccl cfv cfv cin cA cJ ccl cfv cfv cX cA cJ cnt cfv cfv cdif cin cA cJ
      ccl cfv cfv cX cin cA cJ cnt cfv cfv cdif cJ ctop wcel cA cX wss wa cX cA
      cdif cJ ccl cfv cfv cX cA cJ cnt cfv cfv cdif cA cJ ccl cfv cfv cA cJ cX
      topbnd.1 clscmp ineq2d cA cJ ccl cfv cfv cX cA cJ cnt cfv cfv indif2
      syl6eq cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cin cA cJ ccl cfv
      cfv cA cJ cnt cfv cfv cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX wss
      cA cJ ccl cfv cfv cX cin cA cJ ccl cfv cfv wceq cA cJ cX topbnd.1 clsss3
      cA cJ ccl cfv cfv cX df-ss sylib difeq1d eqtrd $.
      $( [23-Sep-2009] $) $( [23-Sep-2009] $)
  $}

  ${
    opnbnd.1 $e |- X = U. J $.
    $( A set is open iff it is disjoint from its boundary. $)
    opnbnd $p |- ( ( J e. Top /\ A C_ X ) -> ( A e. J <-> ( A i^i ( ( ( cls ` J
    ) ` A ) i^i ( ( cls ` J ) ` ( X \ A ) ) ) ) = (/) ) ) $=
      cJ ctop wcel cA cX wss wa cA cJ cnt cfv cfv cA wceq cA cA cJ ccl cfv cfv
      cA cJ cnt cfv cfv cdif cin c0 wceq cA cJ wcel cA cA cJ ccl cfv cfv cX cA
      cdif cJ ccl cfv cfv cin cin c0 wceq cJ ctop wcel cA cX wss wa cA cJ cnt
      cfv cfv cA wceq cA cA cJ ccl cfv cfv cA cJ cnt cfv cfv cdif cin c0 wceq
      cA cJ cnt cfv cfv cA wceq cA cJ cnt cfv cfv cA cJ ccl cfv cfv cA cJ cnt
      cfv cfv cdif cin c0 wceq cA cA cJ ccl cfv cfv cA cJ cnt cfv cfv cdif cin
      c0 wceq cJ ctop wcel cA cX wss wa cA cJ cnt cfv cfv cA wceq cA cJ cnt cfv
      cfv cA cJ ccl cfv cfv cA cJ cnt cfv cfv cdif cin cA cA cJ ccl cfv cfv cA
      cJ cnt cfv cfv cdif cin c0 cA cJ cnt cfv cfv cA cA cJ ccl cfv cfv cA cJ
      cnt cfv cfv cdif ineq1 eqeq1d cA cJ cnt cfv cfv cA cJ ccl cfv cfv cA cJ
      cnt cfv cfv cdif cin c0 wceq cJ ctop wcel cA cX wss wa cA cJ cnt cfv cfv
      cA cJ ccl cfv cfv difdisj a1i syl5cbi cJ ctop wcel cA cX wss wa cA cA cJ
      ccl cfv cfv cA cJ cnt cfv cfv cdif cin c0 wceq cA cJ cnt cfv cfv cA wceq
      cJ ctop wcel cA cX wss wa cA cA cJ ccl cfv cfv cA cJ cnt cfv cfv cdif cin
      c0 wceq wa cA cJ cnt cfv cfv cA cJ ctop wcel cA cX wss wa cA cJ cnt cfv
      cfv cA wss cA cA cJ ccl cfv cfv cA cJ cnt cfv cfv cdif cin c0 wceq cA cJ
      cX opnbnd.1 ntrss2 adantr cJ ctop wcel cA cX wss wa cA cA cJ ccl cfv cfv
      cin cA cJ cnt cfv cfv wss cA cA cJ cnt cfv cfv wss cA cA cJ ccl cfv cfv
      cA cJ cnt cfv cfv cdif cin c0 wceq cA cA cA cJ ccl cfv cfv cin wss cA cA
      cJ ccl cfv cfv cin cA cJ cnt cfv cfv wss cA cA cJ cnt cfv cfv wss cJ ctop
      wcel cA cX wss wa cA cA cA cJ ccl cfv cfv cin cA cJ cnt cfv cfv sstr cJ
      ctop wcel cA cX wss wa cA cA cA cJ ccl cfv cfv cin wceq cA cA cA cJ ccl
      cfv cfv cin wss cJ ctop wcel cA cX wss wa cA cA cJ ccl cfv cfv cin cA cJ
      ctop wcel cA cX wss wa cA cA cJ ccl cfv cfv wss cA cA cJ ccl cfv cfv cin
      cA wceq cA cJ cX opnbnd.1 sscls cA cA cJ ccl cfv cfv df-ss sylib eqcomd
      cA cA cA cJ ccl cfv cfv cin eqimss syl sylan cA cA cJ ccl cfv cfv cA cJ
      cnt cfv cfv inssdif0 sylan2br eqssd ex impbid cA cJ cX opnbnd.1 isopn3 cJ
      ctop wcel cA cX wss wa cA cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin
      cin cA cA cJ ccl cfv cfv cA cJ cnt cfv cfv cdif cin c0 cJ ctop wcel cA cX
      wss wa cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin cA cJ ccl cfv cfv
      cA cJ cnt cfv cfv cdif cA cA cJ cX opnbnd.1 topbnd ineq2d eqeq1d 3bitr4d
      $.
      $( [23-Sep-2009] $) $( [23-Sep-2009] $)

    $( A set is closed iff it contains its boundary. $)
    cldbnd $p |- ( ( J e. Top /\ A C_ X ) -> ( A e. ( Clsd ` J ) <-> ( ( ( cls
    ` J ) ` A ) i^i ( ( cls ` J ) ` ( X \ A ) ) ) C_ A ) ) $=
      cJ ctop wcel cA cX wss wa cA cJ ccld cfv wcel cA cJ ccl cfv cfv cX cA
      cdif cJ ccl cfv cfv cin cA wss cJ ctop wcel cA cX wss wa cA cJ ccld cfv
      wcel cA cJ ccl cfv cfv cA wss cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv
      cin cA wss cJ ctop wcel cA cX wss wa cA cJ ccld cfv wcel cA cJ ccl cfv
      cfv cA wceq cA cJ ccl cfv cfv cA wss cA cJ cX opnbnd.1 iscld3 cA cJ ccl
      cfv cfv cA eqimss syl6bi cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cA
      ssinss1 syl6 cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cA cdif cJ
      ccl cfv cfv cin cA wss cX cA cdif cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv
      cfv cin cin c0 wceq cA cJ ccld cfv wcel cJ ctop wcel cA cX wss wa cA cJ
      ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin cA wss cX cA cdif cA cJ ccl cfv
      cfv cX cA cdif cJ ccl cfv cfv cin cin c0 wceq cX cA cdif cA cJ ccl cfv
      cfv cX cA cdif cJ ccl cfv cfv cin cin cX cA cdif cA cin wss cX cA cdif cA
      cin c0 wceq cX cA cdif cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin
      cin c0 wceq cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cA cdif cJ ccl
      cfv cfv cin cA wss wa cX cA cdif cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv
      cfv cin cin cX cA cdif cA cin sseq0 cA cJ ccl cfv cfv cX cA cdif cJ ccl
      cfv cfv cin cA wss cX cA cdif cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv
      cin cin cX cA cdif cA cin wss cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv
      cX cA cdif cJ ccl cfv cfv cin cA cX cA cdif sslin adantl cX cA cdif cA
      cin c0 wceq cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cA cdif cJ ccl
      cfv cfv cin cA wss wa cX cA cdif cA cin cA cX cA cdif cin c0 cX cA cdif
      cA incom cA cX difdisj eqtri a1i sylanc ex cJ ctop wcel cA cX wss wa cX
      cA cdif cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin cin c0 wceq cX cA
      cdif cJ wcel cA cJ ccld cfv wcel cJ ctop wcel cA cX wss wa cX cA cdif cA
      cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin cin c0 wceq cX cA cdif cX cA
      cdif cJ ccl cfv cfv cX cX cA cdif cdif cJ ccl cfv cfv cin cin c0 wceq cX
      cA cdif cJ wcel cJ ctop wcel cA cX wss wa cX cA cdif cA cJ ccl cfv cfv cX
      cA cdif cJ ccl cfv cfv cin cin cX cA cdif cX cA cdif cJ ccl cfv cfv cX cX
      cA cdif cdif cJ ccl cfv cfv cin cin c0 cJ ctop wcel cA cX wss wa cA cJ
      ccl cfv cfv cX cA cdif cJ ccl cfv cfv cin cX cA cdif cJ ccl cfv cfv cX cX
      cA cdif cdif cJ ccl cfv cfv cin cX cA cdif cJ ctop wcel cA cX wss wa cX
      cA cdif cJ ccl cfv cfv cA cJ ccl cfv cfv cin cX cA cdif cJ ccl cfv cfv cX
      cX cA cdif cdif cJ ccl cfv cfv cin cA cJ ccl cfv cfv cX cA cdif cJ ccl
      cfv cfv cin cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cX cX cA cdif
      cdif cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv cA cX wss cA cJ ccl cfv cfv
      cX cX cA cdif cdif cJ ccl cfv cfv wceq cJ ctop wcel cA cX wss cX cX cA
      cdif cdif cA wceq cA cJ ccl cfv cfv cX cX cA cdif cdif cJ ccl cfv cfv
      wceq cA cX dfss4 cX cX cA cdif cdif cA wceq cX cX cA cdif cdif cJ ccl cfv
      cfv cA cJ ccl cfv cfv cX cX cA cdif cdif cA cJ ccl cfv fveq2 eqcomd sylbi
      adantl ineq2d cA cJ ccl cfv cfv cX cA cdif cJ ccl cfv cfv incom syl5eq
      ineq2d eqeq1d cJ ctop wcel cX cA cdif cJ wcel cX cA cdif cX cA cdif cJ
      ccl cfv cfv cX cX cA cdif cdif cJ ccl cfv cfv cin cin c0 wceq wb cA cX
      wss cJ ctop wcel cX cA cdif cX wss cX cA cdif cJ wcel cX cA cdif cX cA
      cdif cJ ccl cfv cfv cX cX cA cdif cdif cJ ccl cfv cfv cin cin c0 wceq wb
      cX cA difss cX cA cdif cJ cX opnbnd.1 opnbnd mpan2 adantr bitr4d cJ ctop
      wcel cA cX wss wa cX cA cdif cJ wcel cX cX cA cdif cdif cJ ccld cfv wcel
      cA cJ ccld cfv wcel cJ ctop wcel cX cA cdif cJ wcel cX cX cA cdif cdif cJ
      ccld cfv wcel wi cA cX wss cJ ctop wcel cX cA cdif cJ wcel cX cX cA cdif
      cdif cJ ccld cfv wcel cX cA cdif cJ cX opnbnd.1 opncld ex adantr cA cX
      wss cX cX cA cdif cdif cJ ccld cfv wcel cA cJ ccld cfv wcel wb cJ ctop
      wcel cA cX wss cX cX cA cdif cdif cA wceq cX cX cA cdif cdif cJ ccld cfv
      wcel cA cJ ccld cfv wcel wb cA cX dfss4 cX cX cA cdif cdif cA cJ ccld cfv
      eleq1 sylbi adantl sylibd sylbid syld impbid $.
      $( [1-Oct-2009] $) $( [1-Oct-2009] $)
  $}

  ${
    ntrin.1 $e |- X = U. J $.
    $( A pairwise intersection of interiors is the interior of the
       intersection. This does not always hold for arbitrary intersections. $)
    ntrin $p |- ( ( J e. Top /\ A C_ X /\ B C_ X ) -> ( ( int ` J ) ` ( A i^i B
    ) ) = ( ( ( int ` J ) ` A ) i^i ( ( int ` J ) ` B ) ) ) $=
      cJ ctop wcel cA cX wss cB cX wss w3a cA cB cin cJ cnt cfv cfv cA cJ cnt
      cfv cfv cB cJ cnt cfv cfv cin cJ ctop wcel cA cX wss cB cX wss w3a cA cB
      cin cJ cnt cfv cfv cA cJ cnt cfv cfv wss cA cB cin cJ cnt cfv cfv cB cJ
      cnt cfv cfv wss wa cA cB cin cJ cnt cfv cfv cA cJ cnt cfv cfv cB cJ cnt
      cfv cfv cin wss cJ ctop wcel cA cX wss cB cX wss w3a cA cB cin cJ cnt cfv
      cfv cA cJ cnt cfv cfv wss cA cB cin cJ cnt cfv cfv cB cJ cnt cfv cfv wss
      cJ ctop wcel cA cX wss cA cB cin cJ cnt cfv cfv cA cJ cnt cfv cfv wss cB
      cX wss cJ ctop wcel cA cX wss cA cB cin cA wss cA cB cin cJ cnt cfv cfv
      cA cJ cnt cfv cfv wss cA cB inss1 cA cA cB cin cJ cX ntrin.1 ntrss mp3an3
      3adant3 cJ ctop wcel cB cX wss cA cB cin cJ cnt cfv cfv cB cJ cnt cfv cfv
      wss cA cX wss cJ ctop wcel cB cX wss cA cB cin cB wss cA cB cin cJ cnt
      cfv cfv cB cJ cnt cfv cfv wss cA cB inss2 cB cA cB cin cJ cX ntrin.1
      ntrss mp3an3 3adant2 jca cA cB cin cJ cnt cfv cfv cA cJ cnt cfv cfv cB cJ
      cnt cfv cfv ssin sylib cJ ctop wcel cA cB cin cX wss cA cJ cnt cfv cfv cB
      cJ cnt cfv cfv cin cJ wcel cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin cA cB
      cin wss cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin cA cB cin cJ cnt cfv cfv
      wss cJ ctop wcel cA cX wss cB cX wss w3a cA cB cin cJ cA cJ cnt cfv cfv
      cB cJ cnt cfv cfv cin cX ntrin.1 ssntr cJ ctop wcel cA cX wss cB cX wss
      3simp1 cA cX wss cJ ctop wcel cA cB cin cX wss cB cX wss cA cB cX ssinss1
      3ad2ant2 cJ ctop wcel cA cJ cnt cfv cfv cJ wcel cB cJ cnt cfv cfv cJ wcel
      cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin cJ wcel cJ ctop wcel cA cX wss cB
      cX wss w3a cA cJ cnt cfv cfv cB cJ cnt cfv cfv cJ inopn cJ ctop wcel cA
      cX wss cB cX wss 3simp1 cJ ctop wcel cA cX wss cA cJ cnt cfv cfv cJ wcel
      cB cX wss cA cJ cX ntrin.1 ntropn 3adant3 cJ ctop wcel cB cX wss cB cJ
      cnt cfv cfv cJ wcel cA cX wss cB cJ cX ntrin.1 ntropn 3adant2 syl3anc cJ
      ctop wcel cA cX wss cB cX wss w3a cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin
      cA wss cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin cB wss wa cA cJ cnt cfv
      cfv cB cJ cnt cfv cfv cin cA cB cin wss cJ ctop wcel cA cX wss cB cX wss
      w3a cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin cA wss cA cJ cnt cfv cfv cB
      cJ cnt cfv cfv cin cB wss cJ ctop wcel cA cX wss cB cX wss w3a cA cJ cnt
      cfv cfv cB cJ cnt cfv cfv cin cA cJ cnt cfv cfv cA cA cJ cnt cfv cfv cB
      cJ cnt cfv cfv cin cA cJ cnt cfv cfv wss cJ ctop wcel cA cX wss cB cX wss
      w3a cA cJ cnt cfv cfv cB cJ cnt cfv cfv inss1 a1i cJ ctop wcel cA cX wss
      cA cJ cnt cfv cfv cA wss cB cX wss cA cJ cX ntrin.1 ntrss2 3adant3 sstrd
      cJ ctop wcel cA cX wss cB cX wss w3a cA cJ cnt cfv cfv cB cJ cnt cfv cfv
      cin cB cJ cnt cfv cfv cB cA cJ cnt cfv cfv cB cJ cnt cfv cfv cin cB cJ
      cnt cfv cfv wss cJ ctop wcel cA cX wss cB cX wss w3a cA cJ cnt cfv cfv cB
      cJ cnt cfv cfv inss2 a1i cJ ctop wcel cB cX wss cB cJ cnt cfv cfv cB wss
      cA cX wss cB cJ cX ntrin.1 ntrss2 3adant2 sstrd jca cA cJ cnt cfv cfv cB
      cJ cnt cfv cfv cin cA cB ssin sylib syl2anc eqssd $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    $d o J $. $d o O $. $d o X $.
    ntruni.1 $e |- X = U. J $.
    $( A union of interiors is a subset of the interior of the union. The
       reverse inclusion may not hold. $)
    ntruni $p |- ( ( J e. Top /\ O C_ ~P X ) -> U_ o e. O ( ( int ` J ) ` o
    ) C_ ( ( int ` J ) ` U. O ) ) $=
      cJ ctop wcel cO cX cpw wss wa vo cv cJ cnt cfv cfv cO cuni cJ cnt cfv cfv
      wss vo cO wral vo cO vo cv cJ cnt cfv cfv ciun cO cuni cJ cnt cfv cfv wss
      cJ ctop wcel cO cX cpw wss wa vo cv cJ cnt cfv cfv cO cuni cJ cnt cfv cfv
      wss vo cO cJ ctop wcel cO cX cpw wss wa vo cv cO cuni wss vo cv cJ cnt
      cfv cfv cO cuni cJ cnt cfv cfv wss vo cv cO wcel cJ ctop wcel cO cuni cX
      wss vo cv cO cuni wss vo cv cJ cnt cfv cfv cO cuni cJ cnt cfv cfv wss wi
      cO cX cpw wss cJ ctop wcel cO cuni cX wss vo cv cO cuni wss vo cv cJ cnt
      cfv cfv cO cuni cJ cnt cfv cfv wss cO cuni vo cv cJ cX ntruni.1 ntrss
      3expia cO cX sspwuni sylan2b vo cv cO elssuni syl5 r19.21aiv vo cO vo cv
      cJ cnt cfv cfv cO cuni cJ cnt cfv cfv iunss sylibr $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    clsun.1 $e |- X = U. J $.
    $( A pairwise union of closures is the closure of the union. $)
    clsun $p |- ( ( J e. Top /\ A C_ X /\ B C_ X ) -> ( ( cls ` J ) ` ( A u. B
    ) ) = ( ( ( cls ` J ) ` A ) u. ( ( cls ` J ) ` B ) ) ) $=
      cJ ctop wcel cA cX wss cB cX wss w3a cX cX cA cB cun cJ ccl cfv cfv cdif
      cdif cX cX cA cJ ccl cfv cfv cB cJ ccl cfv cfv cun cdif cdif cA cB cun cJ
      ccl cfv cfv cA cJ ccl cfv cfv cB cJ ccl cfv cfv cun cJ ctop wcel cA cX
      wss cB cX wss w3a cX cA cB cun cJ ccl cfv cfv cdif cX cA cJ ccl cfv cfv
      cB cJ ccl cfv cfv cun cdif cX cJ ctop wcel cA cX wss cB cX wss w3a cX cA
      cB cun cdif cJ cnt cfv cfv cX cA cdif cJ cnt cfv cfv cX cB cdif cJ cnt
      cfv cfv cin cX cA cB cun cJ ccl cfv cfv cdif cX cA cJ ccl cfv cfv cB cJ
      ccl cfv cfv cun cdif cJ ctop wcel cA cX wss cB cX wss w3a cX cA cdif cX
      cB cdif cin cJ cnt cfv cfv cX cA cdif cJ cnt cfv cfv cX cB cdif cJ cnt
      cfv cfv cin cX cA cB cun cdif cJ cnt cfv cfv cJ ctop wcel cA cX wss cX cA
      cdif cX cB cdif cin cJ cnt cfv cfv cX cA cdif cJ cnt cfv cfv cX cB cdif
      cJ cnt cfv cfv cin wceq cB cX wss cJ ctop wcel cX cA cdif cX wss cX cB
      cdif cX wss cX cA cdif cX cB cdif cin cJ cnt cfv cfv cX cA cdif cJ cnt
      cfv cfv cX cB cdif cJ cnt cfv cfv cin wceq cX cA difss cX cB difss cX cA
      cdif cX cB cdif cJ cX clsun.1 ntrin mp3an23 3ad2ant1 cX cA cB cun cdif cX
      cA cdif cX cB cdif cin cJ cnt cfv cX cA cB difundi fveq2i syl5eq cJ ctop
      wcel cA cB cun cX wss cX cA cB cun cdif cJ cnt cfv cfv cX cA cB cun cJ
      ccl cfv cfv cdif wceq cJ ctop wcel cA cX wss cB cX wss w3a cA cB cun cJ
      cX clsun.1 ntrcmp cJ ctop wcel cA cX wss cB cX wss 3simp1 cA cX wss cB cX
      wss cA cB cun cX wss cJ ctop wcel cA cX wss cB cX wss wa cA cB cun cX wss
      cA cB cX unss biimpi 3adant1 sylanc cJ ctop wcel cA cX wss cB cX wss w3a
      cX cA cdif cJ cnt cfv cfv cX cB cdif cJ cnt cfv cfv cin cX cA cJ ccl cfv
      cfv cdif cX cB cJ ccl cfv cfv cdif cin cX cA cJ ccl cfv cfv cB cJ ccl cfv
      cfv cun cdif cJ ctop wcel cA cX wss cB cX wss w3a cX cA cdif cJ cnt cfv
      cfv cX cA cJ ccl cfv cfv cdif cX cB cdif cJ cnt cfv cfv cX cB cJ ccl cfv
      cfv cdif cJ ctop wcel cA cX wss cX cA cdif cJ cnt cfv cfv cX cA cJ ccl
      cfv cfv cdif wceq cB cX wss cA cJ cX clsun.1 ntrcmp 3adant3 cJ ctop wcel
      cB cX wss cX cB cdif cJ cnt cfv cfv cX cB cJ ccl cfv cfv cdif wceq cA cX
      wss cB cJ cX clsun.1 ntrcmp 3adant2 ineq12d cX cA cJ ccl cfv cfv cB cJ
      ccl cfv cfv difundi syl6eqr 3eqtr3d difeq2d cJ ctop wcel cA cX wss cB cX
      wss w3a cA cB cun cJ ccl cfv cfv cX wss cX cX cA cB cun cJ ccl cfv cfv
      cdif cdif cA cB cun cJ ccl cfv cfv wceq cJ ctop wcel cA cB cun cJ ccl cfv
      cfv cJ ccld cfv wcel cA cB cun cJ ccl cfv cfv cX wss cJ ctop wcel cA cX
      wss cB cX wss w3a cA cB cun cJ ccl cfv cfv cJ cX clsun.1 cldss cJ ctop
      wcel cA cX wss cB cX wss 3simp1 cJ ctop wcel cA cB cun cX wss cA cB cun
      cJ ccl cfv cfv cJ ccld cfv wcel cJ ctop wcel cA cX wss cB cX wss w3a cA
      cB cun cJ cX clsun.1 clscld cJ ctop wcel cA cX wss cB cX wss 3simp1 cA cX
      wss cB cX wss cA cB cun cX wss cJ ctop wcel cA cX wss cB cX wss wa cA cB
      cun cX wss cA cB cX unss biimpi 3adant1 sylanc sylanc cA cB cun cJ ccl
      cfv cfv cX dfss4 sylib cJ ctop wcel cA cX wss cB cX wss w3a cA cJ ccl cfv
      cfv cX wss cB cJ ccl cfv cfv cX wss wa cX cX cA cJ ccl cfv cfv cB cJ ccl
      cfv cfv cun cdif cdif cA cJ ccl cfv cfv cB cJ ccl cfv cfv cun wceq cJ
      ctop wcel cA cX wss cB cX wss w3a cA cJ ccl cfv cfv cX wss cB cJ ccl cfv
      cfv cX wss cJ ctop wcel cA cX wss cA cJ ccl cfv cfv cX wss cB cX wss cA
      cJ cX clsun.1 clsss3 3adant3 cJ ctop wcel cB cX wss cB cJ ccl cfv cfv cX
      wss cA cX wss cB cJ cX clsun.1 clsss3 3adant2 jca cA cJ ccl cfv cfv cX
      wss cB cJ ccl cfv cfv cX wss wa cA cJ ccl cfv cfv cB cJ ccl cfv cfv cun
      cX wss cX cX cA cJ ccl cfv cfv cB cJ ccl cfv cfv cun cdif cdif cA cJ ccl
      cfv cfv cB cJ ccl cfv cfv cun wceq cA cJ ccl cfv cfv cB cJ ccl cfv cfv cX
      unss cA cJ ccl cfv cfv cB cJ ccl cfv cfv cun cX dfss4 bitri sylib 3eqtr3d
      $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    $d c C $. $d c J $. $d c X $.
    clsint2.1 $e |- X = U. J $.
    $( The closure of an intersection is a subset of the intersection of the
       closures. $)
    clsint2 $p |- ( ( J e. Top /\ C C_ ~P X ) -> ( ( cls ` J ) ` |^| C ) C_
    |^|_ c e. C ( ( cls ` J ) ` c ) ) $=
      cJ ctop wcel cC cX cpw wss wa cC cint cJ ccl cfv cfv vc cv cJ ccl cfv cfv
      wss vc cC wral cC cint cJ ccl cfv cfv vc cC vc cv cJ ccl cfv cfv ciin wss
      cJ ctop wcel cC cX cpw wss wa cC cint cJ ccl cfv cfv vc cv cJ ccl cfv cfv
      wss vc cC cJ ctop wcel cC cuni cX wss vc cv cC wcel cC cint cJ ccl cfv
      cfv vc cv cJ ccl cfv cfv wss wi cC cX cpw wss cJ ctop wcel cC cuni cX wss
      vc cv cC wcel cC cint cJ ccl cfv cfv vc cv cJ ccl cfv cfv wss wi cJ ctop
      wcel vc cv cC wcel cC cuni cX wss cC cint cJ ccl cfv cfv vc cv cJ ccl cfv
      cfv wss cJ ctop wcel vc cv cC wcel cC cuni cX wss cC cint cJ ccl cfv cfv
      vc cv cJ ccl cfv cfv wss wi cJ ctop wcel vc cv cC wcel wa cC cuni cX wss
      vc cv cX wss cC cint cJ ccl cfv cfv vc cv cJ ccl cfv cfv wss vc cv cC
      wcel cC cuni cX wss vc cv cX wss wi cJ ctop wcel vc cv cC wcel vc cv cC
      cuni wss cC cuni cX wss vc cv cX wss wi vc cv cC elssuni vc cv cC cuni cX
      sstr2 syl adantl cJ ctop wcel vc cv cC wcel vc cv cX wss cC cint cJ ccl
      cfv cfv vc cv cJ ccl cfv cfv wss cJ ctop wcel vc cv cX wss vc cv cC wcel
      cC cint cJ ccl cfv cfv vc cv cJ ccl cfv cfv wss cJ ctop wcel vc cv cX wss
      cC cint vc cv wss cC cint cJ ccl cfv cfv vc cv cJ ccl cfv cfv wss vc cv
      cC wcel vc cv cC cint cJ cX clsint2.1 clsss vc cv cC intss1 syl3an3
      3com23 3expia syld ex com23 imp cC cX sspwuni sylan2b r19.21aiv vc cC vc
      cv cJ ccl cfv cfv cC cint cJ ccl cfv cfv ssiin sylibr $.
      $( [31-Aug-2009] $) $( [31-Aug-2009] $)
  $}

  ${
    $d c o A $. $d c o J $. $d c o X $.
    opnregcld.1 $e |- X = U. J $.
    $( A set is regularly closed iff it is the closure of some open set. $)
    opnregcld $p |- ( ( J e. Top /\ A C_ X ) -> ( ( ( cls ` J ) ` ( ( int ` J )
    ` A ) ) = A <-> E. o e. J A = ( ( cls ` J ) ` o ) ) ) $=
      cJ ctop wcel cA cX wss wa cA cJ cnt cfv cfv cJ ccl cfv cfv cA wceq cA vo
      cv cJ ccl cfv cfv wceq vo cJ wrex cJ ctop wcel cA cX wss wa cA cJ cnt cfv
      cfv cJ ccl cfv cfv cA wceq cA vo cv cJ ccl cfv cfv wceq vo cJ wrex cA cJ
      cnt cfv cfv cJ wcel cA cA cJ cnt cfv cfv cJ ccl cfv cfv wceq cA vo cv cJ
      ccl cfv cfv wceq vo cJ wrex cJ ctop wcel cA cX wss wa cA cJ cnt cfv cfv
      cJ ccl cfv cfv cA wceq cA vo cv cJ ccl cfv cfv wceq cA cA cJ cnt cfv cfv
      cJ ccl cfv cfv wceq vo cA cJ cnt cfv cfv cJ vo cv cA cJ cnt cfv cfv wceq
      vo cv cJ ccl cfv cfv cA cJ cnt cfv cfv cJ ccl cfv cfv cA vo cv cA cJ cnt
      cfv cfv cJ ccl cfv fveq2 eqeq2d rcla4ev cA cJ cX opnregcld.1 ntropn cA cJ
      cnt cfv cfv cJ ccl cfv cfv cA wceq cA cA cJ cnt cfv cfv cJ ccl cfv cfv
      wceq cA cJ cnt cfv cfv cJ ccl cfv cfv cA eqcom biimpi syl2an ex cJ ctop
      wcel cA cX wss wa cA vo cv cJ ccl cfv cfv wceq cA cJ cnt cfv cfv cJ ccl
      cfv cfv cA wceq vo cJ cA vo cv cJ ccl cfv cfv wceq cA cJ cnt cfv cfv cJ
      ccl cfv cfv cA wceq vo cv cJ ccl cfv cfv cJ cnt cfv cfv cJ ccl cfv cfv vo
      cv cJ ccl cfv cfv wceq cJ ctop wcel cA cX wss wa vo cv cJ wcel wa cA vo
      cv cJ ccl cfv cfv wceq cA cJ cnt cfv cfv cJ ccl cfv cfv vo cv cJ ccl cfv
      cfv cJ cnt cfv cfv cJ ccl cfv cfv cA vo cv cJ ccl cfv cfv cA vo cv cJ ccl
      cfv cfv wceq cA cJ cnt cfv cfv vo cv cJ ccl cfv cfv cJ cnt cfv cfv cJ ccl
      cfv cA vo cv cJ ccl cfv cfv cJ cnt cfv fveq2 fveq2d cA vo cv cJ ccl cfv
      cfv wceq id eqeq12d cJ ctop wcel vo cv cJ wcel vo cv cJ ccl cfv cfv cJ
      cnt cfv cfv cJ ccl cfv cfv vo cv cJ ccl cfv cfv wceq cA cX wss cJ ctop
      wcel vo cv cJ wcel wa vo cv cJ ccl cfv cfv cJ cnt cfv cfv cJ ccl cfv cfv
      vo cv cJ ccl cfv cfv cJ ctop wcel vo cv cJ wcel wa vo cv cJ ccl cfv cfv
      cJ cnt cfv cfv cJ ccl cfv cfv vo cv cJ ccl cfv cfv cJ ccl cfv cfv vo cv
      cJ ccl cfv cfv cJ ctop wcel vo cv cJ ccl cfv cfv cX wss vo cv cJ ccl cfv
      cfv cJ cnt cfv cfv vo cv cJ ccl cfv cfv wss vo cv cJ ccl cfv cfv cJ cnt
      cfv cfv cJ ccl cfv cfv vo cv cJ ccl cfv cfv cJ ccl cfv cfv wss cJ ctop
      wcel vo cv cJ wcel wa vo cv cJ ccl cfv cfv vo cv cJ ccl cfv cfv cJ cnt
      cfv cfv cJ cX opnregcld.1 clsss cJ ctop wcel vo cv cJ wcel pm3.26 cJ ctop
      wcel vo cv cJ wcel vo cv cX wss vo cv cJ ccl cfv cfv cX wss vo cv cJ cX
      opnregcld.1 eltopss vo cv cJ cX opnregcld.1 clsss3 syldan cJ ctop wcel vo
      cv cJ wcel vo cv cJ ccl cfv cfv cX wss vo cv cJ ccl cfv cfv cJ cnt cfv
      cfv vo cv cJ ccl cfv cfv wss cJ ctop wcel vo cv cJ wcel vo cv cX wss vo
      cv cJ ccl cfv cfv cX wss vo cv cJ cX opnregcld.1 eltopss vo cv cJ cX
      opnregcld.1 clsss3 syldan vo cv cJ ccl cfv cfv cJ cX opnregcld.1 ntrss2
      syldan syl3anc cJ ctop wcel vo cv cJ wcel vo cv cX wss vo cv cJ ccl cfv
      cfv cJ ccl cfv cfv vo cv cJ ccl cfv cfv wceq vo cv cJ cX opnregcld.1
      eltopss vo cv cJ cX opnregcld.1 clsidm syldan sseqtrd cJ ctop wcel vo cv
      cJ ccl cfv cfv cJ cnt cfv cfv cX wss vo cv vo cv cJ ccl cfv cfv cJ cnt
      cfv cfv wss vo cv cJ ccl cfv cfv vo cv cJ ccl cfv cfv cJ cnt cfv cfv cJ
      ccl cfv cfv wss cJ ctop wcel vo cv cJ wcel wa vo cv cJ ccl cfv cfv cJ cnt
      cfv cfv vo cv cJ cX opnregcld.1 clsss cJ ctop wcel vo cv cJ wcel pm3.26
      cJ ctop wcel vo cv cJ wcel vo cv cJ ccl cfv cfv cX wss vo cv cJ ccl cfv
      cfv cJ cnt cfv cfv cX wss cJ ctop wcel vo cv cJ wcel vo cv cX wss vo cv
      cJ ccl cfv cfv cX wss vo cv cJ cX opnregcld.1 eltopss vo cv cJ cX
      opnregcld.1 clsss3 syldan vo cv cJ ccl cfv cfv cJ cX opnregcld.1 ntrss3
      syldan cJ ctop wcel vo cv cJ ccl cfv cfv cX wss vo cv cJ wcel vo cv vo cv
      cJ ccl cfv cfv wss vo cv vo cv cJ ccl cfv cfv cJ cnt cfv cfv wss cJ ctop
      wcel vo cv cJ wcel wa vo cv cJ ccl cfv cfv cJ vo cv cX opnregcld.1 ssntr
      cJ ctop wcel vo cv cJ wcel pm3.26 cJ ctop wcel vo cv cJ wcel vo cv cX wss
      vo cv cJ ccl cfv cfv cX wss vo cv cJ cX opnregcld.1 eltopss vo cv cJ cX
      opnregcld.1 clsss3 syldan cJ ctop wcel vo cv cJ wcel pm3.27 cJ ctop wcel
      vo cv cJ wcel vo cv cX wss vo cv vo cv cJ ccl cfv cfv wss vo cv cJ cX
      opnregcld.1 eltopss vo cv cJ cX opnregcld.1 sscls syldan syl2anc syl3anc
      eqssd adantlr syl5cbir r19.23adva impbid $.
      $( [27-Sep-2009] $) $( [27-Sep-2009] $)

    $( A set if regularly open iff it is the interior of some closed set. $)
    cldregopn $p |- ( ( J e. Top /\ A C_ X ) -> ( ( ( int ` J ) ` ( ( cls ` J )
    ` A ) ) = A <-> E. c e. ( Clsd ` J ) A = ( ( int ` J ) ` c ) ) ) $=
      cJ ctop wcel cA cX wss wa cA cJ ccl cfv cfv cJ cnt cfv cfv cA wceq cA vc
      cv cJ cnt cfv cfv wceq vc cJ ccld cfv wrex cJ ctop wcel cA cX wss wa cA
      cJ ccl cfv cfv cJ cnt cfv cfv cA wceq cA vc cv cJ cnt cfv cfv wceq vc cJ
      ccld cfv wrex cA cJ ccl cfv cfv cJ ccld cfv wcel cA cA cJ ccl cfv cfv cJ
      cnt cfv cfv wceq cA vc cv cJ cnt cfv cfv wceq vc cJ ccld cfv wrex cJ ctop
      wcel cA cX wss wa cA cJ ccl cfv cfv cJ cnt cfv cfv cA wceq cA vc cv cJ
      cnt cfv cfv wceq cA cA cJ ccl cfv cfv cJ cnt cfv cfv wceq vc cA cJ ccl
      cfv cfv cJ ccld cfv vc cv cA cJ ccl cfv cfv wceq vc cv cJ cnt cfv cfv cA
      cJ ccl cfv cfv cJ cnt cfv cfv cA vc cv cA cJ ccl cfv cfv cJ cnt cfv fveq2
      eqeq2d rcla4ev cA cJ cX opnregcld.1 clscld cA cJ ccl cfv cfv cJ cnt cfv
      cfv cA wceq cA cA cJ ccl cfv cfv cJ cnt cfv cfv wceq cA cJ ccl cfv cfv cJ
      cnt cfv cfv cA eqcom biimpi syl2an ex cJ ctop wcel cA cX wss wa cA vc cv
      cJ cnt cfv cfv wceq cA cJ ccl cfv cfv cJ cnt cfv cfv cA wceq vc cJ ccld
      cfv cA vc cv cJ cnt cfv cfv wceq cA cJ ccl cfv cfv cJ cnt cfv cfv cA wceq
      vc cv cJ cnt cfv cfv cJ ccl cfv cfv cJ cnt cfv cfv vc cv cJ cnt cfv cfv
      wceq cJ ctop wcel cA cX wss wa vc cv cJ ccld cfv wcel wa cA vc cv cJ cnt
      cfv cfv wceq cA cJ ccl cfv cfv cJ cnt cfv cfv vc cv cJ cnt cfv cfv cJ ccl
      cfv cfv cJ cnt cfv cfv cA vc cv cJ cnt cfv cfv cA vc cv cJ cnt cfv cfv
      wceq cA cJ ccl cfv cfv vc cv cJ cnt cfv cfv cJ ccl cfv cfv cJ cnt cfv cA
      vc cv cJ cnt cfv cfv cJ ccl cfv fveq2 fveq2d cA vc cv cJ cnt cfv cfv wceq
      id eqeq12d cJ ctop wcel vc cv cJ ccld cfv wcel vc cv cJ cnt cfv cfv cJ
      ccl cfv cfv cJ cnt cfv cfv vc cv cJ cnt cfv cfv wceq cA cX wss cJ ctop
      wcel vc cv cJ ccld cfv wcel wa vc cv cJ cnt cfv cfv cJ ccl cfv cfv cJ cnt
      cfv cfv vc cv cJ cnt cfv cfv cJ ctop wcel vc cv cX wss vc cv cJ cnt cfv
      cfv cJ ccl cfv cfv vc cv wss vc cv cJ cnt cfv cfv cJ ccl cfv cfv cJ cnt
      cfv cfv vc cv cJ cnt cfv cfv wss cJ ctop wcel vc cv cJ ccld cfv wcel wa
      vc cv vc cv cJ cnt cfv cfv cJ ccl cfv cfv cJ cX opnregcld.1 ntrss cJ ctop
      wcel vc cv cJ ccld cfv wcel pm3.26 vc cv cJ cX opnregcld.1 cldss cJ ctop
      wcel vc cv cJ ccld cfv wcel vc cv cJ cnt cfv cfv vc cv wss vc cv cJ cnt
      cfv cfv cJ ccl cfv cfv vc cv wss cJ ctop wcel vc cv cJ ccld cfv wcel vc
      cv cX wss vc cv cJ cnt cfv cfv vc cv wss vc cv cJ cX opnregcld.1 cldss vc
      cv cJ cX opnregcld.1 ntrss2 syldan vc cv vc cv cJ cnt cfv cfv cJ cX
      opnregcld.1 clsss2 mpd3an3 syl3anc cJ ctop wcel vc cv cJ ccld cfv wcel wa
      vc cv cJ cnt cfv cfv vc cv cJ cnt cfv cfv cJ cnt cfv cfv vc cv cJ cnt cfv
      cfv cJ ccl cfv cfv cJ cnt cfv cfv cJ ctop wcel vc cv cJ ccld cfv wcel vc
      cv cX wss vc cv cJ cnt cfv cfv cJ cnt cfv cfv vc cv cJ cnt cfv cfv wceq
      vc cv cJ cX opnregcld.1 cldss vc cv cJ cX opnregcld.1 ntridm syldan cJ
      ctop wcel vc cv cJ cnt cfv cfv cJ ccl cfv cfv cX wss vc cv cJ cnt cfv cfv
      vc cv cJ cnt cfv cfv cJ ccl cfv cfv wss vc cv cJ cnt cfv cfv cJ cnt cfv
      cfv vc cv cJ cnt cfv cfv cJ ccl cfv cfv cJ cnt cfv cfv wss cJ ctop wcel
      vc cv cJ ccld cfv wcel wa vc cv cJ cnt cfv cfv cJ ccl cfv cfv vc cv cJ
      cnt cfv cfv cJ cX opnregcld.1 ntrss cJ ctop wcel vc cv cJ ccld cfv wcel
      pm3.26 cJ ctop wcel vc cv cJ ccld cfv wcel vc cv cJ cnt cfv cfv cX wss vc
      cv cJ cnt cfv cfv cJ ccl cfv cfv cX wss cJ ctop wcel vc cv cJ ccld cfv
      wcel vc cv cX wss vc cv cJ cnt cfv cfv cX wss vc cv cJ cX opnregcld.1
      cldss vc cv cJ cX opnregcld.1 ntrss3 syldan vc cv cJ cnt cfv cfv cJ cX
      opnregcld.1 clsss3 syldan cJ ctop wcel vc cv cJ ccld cfv wcel vc cv cJ
      cnt cfv cfv cX wss vc cv cJ cnt cfv cfv vc cv cJ cnt cfv cfv cJ ccl cfv
      cfv wss cJ ctop wcel vc cv cJ ccld cfv wcel vc cv cX wss vc cv cJ cnt cfv
      cfv cX wss vc cv cJ cX opnregcld.1 cldss vc cv cJ cX opnregcld.1 ntrss3
      syldan vc cv cJ cnt cfv cfv cJ cX opnregcld.1 sscls syldan syl3anc
      eqsstr3d eqssd adantlr syl5cbir r19.23adva impbid $.
      $( [27-Sep-2009] $) $( [27-Sep-2009] $)
  $}

  ${
    $d x J $. $d x S $.
  $( A set is open iff it is a neighborhood of all its points. $)
  opnnei $p |- ( J e. Top -> ( S e. J <-> A. x e. S S e. ( (
    nei ` J ) ` { x } ) ) ) $=
    cJ ctop wcel cS c0 wceq cS cJ wcel cS vx cv csn cJ cnei cfv cfv wcel vx cS
    wral wb cS cJ wcel cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cS cJ wcel
    cS vx cv csn cJ cnei cfv cfv wcel vx cS wral wb cJ ctop wcel cS c0 wceq wa
    cS cJ wcel cS vx cv csn cJ cnei cfv cfv wcel vx cS wral pm5.1 cJ ctop wcel
    cS c0 wceq wa cS cJ wcel c0 cJ wcel cJ ctop wcel c0 cJ wcel cS c0 wceq cJ
    0opn adantr cS c0 wceq cS cJ wcel c0 cJ wcel wb cJ ctop wcel cS c0 cJ eleq1
    adantl mpbird cS c0 wceq cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cJ
    ctop wcel cS vx cv csn cJ cnei cfv cfv wcel vx cS rzal adantl sylanc cJ
    ctop wcel cS c0 wceq wn wa cS cJ wcel cS vx cv csn cJ cnei cfv cfv wcel vx
    cS wral cJ ctop wcel cS cJ wcel cS vx cv csn cJ cnei cfv cfv wcel vx cS
    wral wi cS c0 wceq wn cJ ctop wcel cS cJ wcel cS vx cv csn cJ cnei cfv cfv
    wcel vx cS wral cJ ctop wcel cS cJ wcel wa cS vx cv csn cJ cnei cfv cfv
    wcel vx cS cJ ctop wcel cS cJ wcel vx cv cS wcel cS vx cv csn cJ cnei cfv
    cfv wcel vx cv cJ cS opnneip 3expia r19.21aiv ex adantr cJ ctop wcel cS c0
    wceq wn wa cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cS cJ cuni wss cS
    cJ wcel cS c0 wceq wn cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cS vx cv
    csn cJ cnei cfv cfv wcel vx cS wrex cJ ctop wcel cS cJ cuni wss cS c0 wceq
    wn cS c0 wne cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cS vx cv csn cJ
    cnei cfv cfv wcel vx cS wrex wi cS c0 df-ne cS c0 wne cS vx cv csn cJ cnei
    cfv cfv wcel vx cS wral cS vx cv csn cJ cnei cfv cfv wcel vx cS wrex cS vx
    cv csn cJ cnei cfv cfv wcel vx cS r19.2z ex sylbir cJ ctop wcel cS vx cv
    csn cJ cnei cfv cfv wcel cS cJ cuni wss vx cS cJ ctop wcel cS vx cv csn cJ
    cnei cfv cfv wcel cS cJ cuni wss wi vx cv cS wcel cJ ctop wcel cS vx cv csn
    cJ cnei cfv cfv wcel cS cJ cuni wss vx cv csn cJ cS cJ cuni cJ cuni eqid
    neii1 ex a1d r19.23adv sylan9r cJ ctop wcel cS vx cv csn cJ cnei cfv cfv
    wcel vx cS wral cS cJ cuni wss cS cJ wcel wi wi cS c0 wceq wn cJ ctop wcel
    cS cJ cuni wss cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cS cJ wcel cJ
    ctop wcel cS cJ cuni wss cS vx cv csn cJ cnei cfv cfv wcel vx cS wral cS cJ
    wcel wi cJ ctop wcel cS cJ cuni wss wa vx cv csn cS cJ cnt cfv cfv wss vx
    cS wral cS cJ cnt cfv cfv cS wceq cS vx cv csn cJ cnei cfv cfv wcel vx cS
    wral cS cJ wcel cJ ctop wcel cS cJ cuni wss wa vx cv csn cS cJ cnt cfv cfv
    wss vx cS wral cS cJ cnt cfv cfv cS wceq cJ ctop wcel cS cJ cuni wss wa vx
    cv csn cS cJ cnt cfv cfv wss vx cS wral wa cS cJ cnt cfv cfv cS cJ ctop
    wcel cS cJ cuni wss wa cS cJ cnt cfv cfv cS wss vx cv csn cS cJ cnt cfv cfv
    wss vx cS wral cS cJ cJ cuni cJ cuni eqid ntrss2 adantr cJ ctop wcel cS cJ
    cuni wss wa vx cv cS cJ cnt cfv cfv wcel vx cS wral cS cS cJ cnt cfv cfv
    wss vx cv csn cS cJ cnt cfv cfv wss vx cS wral vx cv cS cJ cnt cfv cfv wcel
    vx cS wral cS cS cJ cnt cfv cfv wss cJ ctop wcel cS cJ cuni wss wa cS cS cJ
    cnt cfv cfv wss vx cv cS cJ cnt cfv cfv wcel vx cS wral vx cS cS cJ cnt cfv
    cfv dfss3 biimpri adantl vx cv cS cJ cnt cfv cfv wcel vx cv csn cS cJ cnt
    cfv cfv wss vx cS vx cv cS cJ cnt cfv cfv vx visset snss ralbii sylan2br
    eqssd ex cJ ctop wcel cS cJ cuni wss wa cS vx cv csn cJ cnei cfv cfv wcel
    vx cv csn cS cJ cnt cfv cfv wss vx cS cJ ctop wcel cS cJ cuni wss wa vx cv
    cS wcel vx cv csn cJ cuni wss cS vx cv csn cJ cnei cfv cfv wcel vx cv csn
    cS cJ cnt cfv cfv wss wb cJ ctop wcel cS cJ cuni wss wa vx cv cS wcel vx cv
    csn cJ cuni wss cJ ctop wcel cS cJ cuni wss wa vx cv csn cS wss vx cv csn
    cJ cuni wss vx cv cS wcel cS cJ cuni wss vx cv csn cS wss vx cv csn cJ cuni
    wss wi cJ ctop wcel vx cv csn cS wss cS cJ cuni wss vx cv csn cJ cuni wss
    vx cv csn cS cJ cuni sstr2 com12 adantl vx cv cS vx visset snss syl5ib imp
    cJ ctop wcel cS cJ cuni wss vx cv csn cJ cuni wss cS vx cv csn cJ cnei cfv
    cfv wcel vx cv csn cS cJ cnt cfv cfv wss wb cJ ctop wcel vx cv csn cJ cuni
    wss cS cJ cuni wss cS vx cv csn cJ cnei cfv cfv wcel vx cv csn cS cJ cnt
    cfv cfv wss wb vx cv csn cJ cS cJ cuni cJ cuni eqid neiint 3com23 3expa
    syldan ralbidva cS cJ cJ cuni cJ cuni eqid isopn3 3imtr4d ex com23 adantr
    mpdd impbid pm2.61dan $.
    $( [16-Sep-2009] $) $( [16-Sep-2009] $)
  $}

  $( Two neighborhoods intersect to form a neighborhood of the intersection. $)
  neiin $p |- ( ( J e. Top /\ M e. ( ( nei ` J ) ` A ) /\ N e. ( ( nei ` J ) `
  B ) ) -> ( M i^i N ) e. ( ( nei ` J ) ` ( A i^i B ) ) ) $=
    cJ ctop wcel cM cA cJ cnei cfv cfv wcel cN cB cJ cnei cfv cfv wcel w3a cM
    cN cin cA cB cin cJ cnei cfv cfv wcel cA cB cin cM cN cin cJ cnt cfv cfv
    wss cJ ctop wcel cM cA cJ cnei cfv cfv wcel cN cB cJ cnei cfv cfv wcel w3a
    cA cB cin cM cJ cnt cfv cfv cN cJ cnt cfv cfv cin cM cN cin cJ cnt cfv cfv
    cJ ctop wcel cM cA cJ cnei cfv cfv wcel cN cB cJ cnei cfv cfv wcel w3a cA
    cB cin cM cJ cnt cfv cfv wss cA cB cin cN cJ cnt cfv cfv wss wa cA cB cin
    cM cJ cnt cfv cfv cN cJ cnt cfv cfv cin wss cJ ctop wcel cM cA cJ cnei cfv
    cfv wcel cN cB cJ cnei cfv cfv wcel w3a cA cB cin cM cJ cnt cfv cfv wss cA
    cB cin cN cJ cnt cfv cfv wss cJ ctop wcel cM cA cJ cnei cfv cfv wcel cA cB
    cin cM cJ cnt cfv cfv wss cN cB cJ cnei cfv cfv wcel cJ ctop wcel cM cA cJ
    cnei cfv cfv wcel wa cA cM cJ cnt cfv cfv wss cA cB cin cM cJ cnt cfv cfv
    wss cJ ctop wcel cM cA cJ cnei cfv cfv wcel wa cM cA cJ cnei cfv cfv wcel
    cA cM cJ cnt cfv cfv wss cJ ctop wcel cM cA cJ cnei cfv cfv wcel pm3.27 cJ
    ctop wcel cA cJ cuni wss cM cJ cuni wss cM cA cJ cnei cfv cfv wcel cA cM cJ
    cnt cfv cfv wss wb cJ ctop wcel cM cA cJ cnei cfv cfv wcel wa cA cJ cM cJ
    cuni cJ cuni eqid neiint cJ ctop wcel cM cA cJ cnei cfv cfv wcel pm3.26 cA
    cJ cM cJ cuni cJ cuni eqid neiss2 cA cJ cM cJ cuni cJ cuni eqid neii1
    syl3anc mpbid cA cB cM cJ cnt cfv cfv ssinss1 syl 3adant3 cJ ctop wcel cM
    cA cJ cnei cfv cfv wcel cN cB cJ cnei cfv cfv wcel w3a cB cN cJ cnt cfv cfv
    wss cA cB cin cN cJ cnt cfv cfv wss cJ ctop wcel cN cB cJ cnei cfv cfv wcel
    cB cN cJ cnt cfv cfv wss cM cA cJ cnei cfv cfv wcel cJ ctop wcel cN cB cJ
    cnei cfv cfv wcel wa cN cB cJ cnei cfv cfv wcel cB cN cJ cnt cfv cfv wss cJ
    ctop wcel cN cB cJ cnei cfv cfv wcel pm3.27 cJ ctop wcel cB cJ cuni wss cN
    cJ cuni wss cN cB cJ cnei cfv cfv wcel cB cN cJ cnt cfv cfv wss wb cJ ctop
    wcel cN cB cJ cnei cfv cfv wcel wa cB cJ cN cJ cuni cJ cuni eqid neiint cJ
    ctop wcel cN cB cJ cnei cfv cfv wcel pm3.26 cB cJ cN cJ cuni cJ cuni eqid
    neiss2 cB cJ cN cJ cuni cJ cuni eqid neii1 syl3anc mpbid 3adant2 cA cB cin
    cB wss cB cN cJ cnt cfv cfv wss cA cB cin cN cJ cnt cfv cfv wss cA cB inss2
    cA cB cin cB cN cJ cnt cfv cfv sstr mpan syl jca cA cB cin cM cJ cnt cfv
    cfv cN cJ cnt cfv cfv ssin sylib cJ ctop wcel cM cJ cuni wss cN cJ cuni wss
    cM cN cin cJ cnt cfv cfv cM cJ cnt cfv cfv cN cJ cnt cfv cfv cin wceq cJ
    ctop wcel cM cA cJ cnei cfv cfv wcel cN cB cJ cnei cfv cfv wcel w3a cM cN
    cJ cJ cuni cJ cuni eqid ntrin cJ ctop wcel cM cA cJ cnei cfv cfv wcel cN cB
    cJ cnei cfv cfv wcel 3simp1 cJ ctop wcel cM cA cJ cnei cfv cfv wcel cM cJ
    cuni wss cN cB cJ cnei cfv cfv wcel cA cJ cM cJ cuni cJ cuni eqid neii1
    3adant3 cJ ctop wcel cN cB cJ cnei cfv cfv wcel cN cJ cuni wss cM cA cJ
    cnei cfv cfv wcel cB cJ cN cJ cuni cJ cuni eqid neii1 3adant2 syl3anc
    sseqtr4d cJ ctop wcel cM cA cJ cnei cfv cfv wcel cM cN cin cA cB cin cJ
    cnei cfv cfv wcel cA cB cin cM cN cin cJ cnt cfv cfv wss wb cN cB cJ cnei
    cfv cfv wcel cJ ctop wcel cA cB cin cJ cuni wss cM cN cin cJ cuni wss cM cN
    cin cA cB cin cJ cnei cfv cfv wcel cA cB cin cM cN cin cJ cnt cfv cfv wss
    wb cJ ctop wcel cM cA cJ cnei cfv cfv wcel wa cA cB cin cJ cM cN cin cJ
    cuni cJ cuni eqid neiint cJ ctop wcel cM cA cJ cnei cfv cfv wcel pm3.26 cJ
    ctop wcel cM cA cJ cnei cfv cfv wcel wa cA cJ cuni wss cA cB cin cJ cuni
    wss cA cJ cM cJ cuni cJ cuni eqid neiss2 cA cB cJ cuni ssinss1 syl cJ ctop
    wcel cM cA cJ cnei cfv cfv wcel wa cM cJ cuni wss cM cN cin cJ cuni wss cA
    cJ cM cJ cuni cJ cuni eqid neii1 cM cN cJ cuni ssinss1 syl syl3anc 3adant3
    mpbird $.
    $( [31-Aug-2009] $) $( [31-Aug-2009] $)

  ${
    $d g o y A $. $d g o y F $. $d g o y J $. $d g o y K $. $d g o y X $. $d g
    o y Y $.
    cnpnei.1 $e |- X = U. J $.
    cnpnei.2 $e |- Y = U. K $.
    $( A condition for continuity at a point in terms of neighborhoods. $)
    cnpnei $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X ) -> (
    F e. ( ( J CnP K ) ` A ) <-> A. y e. ( ( nei ` K ) ` { ( F ` A ) } ) ( `' F
    " y ) e. ( ( nei ` J ) ` { A } ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp
      co cfv wcel cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv
      csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cF cA cJ cK ccnp co cfv wcel cF ccnv vy cv cima cA csn cJ cnei
      cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF
      cfv csn cK cnei cfv cfv wcel cF ccnv vy cv cima cA csn cJ cnei cfv cfv
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK
      ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa wa cF ccnv
      vy cv cima cA csn cJ cnei cfv cfv wcel cF ccnv vy cv cima cX wss cA vo cv
      wcel vo cv cF ccnv vy cv cima wss wa vo cJ wrex wa cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA
      cF cfv csn cK cnei cfv cfv wcel wa wa cF ccnv vy cv cima cX wss cA vo cv
      wcel vo cv cF ccnv vy cv cima wss wa vo cJ wrex cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cF ccnv vy cv cima cX wss cA cX wcel cF cA cJ cK ccnp co
      cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa cX cY cF wf cJ ctop
      wcel cF ccnv vy cv cima cX wss cK ctop wcel cX cY cF wf cF cdm cX wceq cF
      ccnv vy cv cima cX wss cX cY cF fdm cF cdm cX wceq cF ccnv vy cv cima cF
      cdm wss cF ccnv vy cv cima cX wss cF vy cv cnvimass cF cdm cX cF ccnv vy
      cv cima sseq2 mpbii syl 3ad2ant3 ad2antrr cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn
      cK cnei cfv cfv wcel wa wa cA cF cfv csn vg cv wss vg cv vy cv wss wa vg
      cK wrex cA vo cv wcel vo cv cF ccnv vy cv cima wss wa vo cJ wrex cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a vy cv cA cF cfv csn cK cnei cfv cfv
      wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa vg cK wrex cA cX wcel cF
      cA cJ cK ccnp co cfv wcel cK ctop wcel cJ ctop wcel vy cv cA cF cfv csn
      cK cnei cfv cfv wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa vg cK
      wrex cX cY cF wf cA cF cfv csn vg cK vy cv neii2 3ad2antl2 ad2ant2rl cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co
      cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa wa cA cF cfv csn vg
      cv wss vg cv vy cv wss wa cA vo cv wcel vo cv cF ccnv vy cv cima wss wa
      vo cJ wrex vg cK cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa
      wa vg cv cK wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa cA vo cv wcel
      vo cv cF ccnv vy cv cima wss wa vo cJ wrex cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv
      csn cK cnei cfv cfv wcel wa wa vg cv cK wcel cA cF cfv csn vg cv wss vg
      cv vy cv wss wa wa wa cA vo cv wcel cF vo cv cima vg cv wss wa vo cJ wrex
      cA vo cv wcel vo cv cF ccnv vy cv cima wss wa vo cJ wrex cJ ctop wcel cK
      ctop wcel cA cX wcel w3a cF cA cJ cK ccnp co cfv wcel vg cv cK wcel cA cF
      cfv vg cv wcel w3a cA vo cv wcel cF vo cv cima vg cv wss wa vo cJ wrex cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co
      cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa wa vg cv cK wcel cA
      cF cfv csn vg cv wss vg cv vy cv wss wa wa wa vo vg cv cA cF cJ cK cX
      cnpnei.1 cnpimaex cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cJ ctop wcel cK ctop wcel cA cX wcel w3a cF cA cJ cK ccnp co cfv wcel vy
      cv cA cF cfv csn cK cnei cfv cfv wcel wa vg cv cK wcel cA cF cfv csn vg
      cv wss vg cv vy cv wss wa wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa cJ ctop wcel cK ctop wcel cA cX wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cJ ctop wcel cA cX wcel cJ ctop wcel cK ctop wcel cX cY
      cF wf 3simp1 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cK ctop
      wcel cA cX wcel cJ ctop wcel cK ctop wcel cX cY cF wf 3simp2 adantr cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel pm3.27 3jca ad2antrr cF
      cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa vg
      cv cK wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa wa cF cA cJ cK ccnp
      co cfv wcel vg cv cK wcel cA cF cfv vg cv wcel w3a cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA
      cF cfv csn cK cnei cfv cfv wcel wa vg cv cK wcel cA cF cfv csn vg cv wss
      vg cv vy cv wss wa wa wa cF cA cJ cK ccnp co cfv wcel vg cv cK wcel cA cF
      cfv vg cv wcel cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei
      cfv cfv wcel vg cv cK wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa wa
      simpll cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv
      wcel wa vg cv cK wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa simprl
      cA cF cfv csn vg cv wss vg cv vy cv wss wa cA cF cfv vg cv wcel cF cA cJ
      cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa vg cv cK
      wcel cA cF cfv csn vg cv wss cA cF cfv vg cv wcel vg cv vy cv wss cA cF
      cfv vg cv wcel cA cF cfv csn vg cv wss cA cF cfv vg cv cA cF fvex snss
      biimpri adantr ad2antll 3jca adantll sylanc cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv
      csn cK cnei cfv cfv wcel wa wa vg cv cK wcel cA cF cfv csn vg cv wss vg
      cv vy cv wss wa wa wa cA vo cv wcel cF vo cv cima vg cv wss wa cA vo cv
      wcel vo cv cF ccnv vy cv cima wss wa vo cJ cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv
      csn cK cnei cfv cfv wcel wa wa vg cv cK wcel cA cF cfv csn vg cv wss vg
      cv vy cv wss wa wa wa vo cv cJ wcel wa cF vo cv cima vg cv wss vo cv cF
      ccnv vy cv cima wss cA vo cv wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK
      cnei cfv cfv wcel wa wa vg cv cK wcel cA cF cfv csn vg cv wss vg cv vy cv
      wss wa wa wa vo cv cJ wcel wa cF vo cv cima vg cv wss cF vo cv cima vy cv
      wss vo cv cF ccnv vy cv cima wss vg cv cK wcel cA cF cfv csn vg cv wss vg
      cv vy cv wss wa wa cF vo cv cima vg cv wss cF vo cv cima vy cv wss wi cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp co
      cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa wa vo cv cJ wcel vg
      cv vy cv wss cF vo cv cima vg cv wss cF vo cv cima vy cv wss wi vg cv cK
      wcel cA cF cfv csn vg cv wss cF vo cv cima vg cv wss vg cv vy cv wss cF
      vo cv cima vy cv wss cF vo cv cima vg cv vy cv sstr2 com12 ad2antll
      ad2antlr cF wfun vo cv cF cdm wss cF vo cv cima vy cv wss vo cv cF ccnv
      vy cv cima wss wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa
      wa vg cv cK wcel cA cF cfv csn vg cv wss vg cv vy cv wss wa wa wa vo cv
      cJ wcel wa vo cv vy cv cF funimass3 cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK
      cnei cfv cfv wcel wa wa cF wfun vg cv cK wcel cA cF cfv csn vg cv wss vg
      cv vy cv wss wa wa vo cv cJ wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cF wfun cA cX wcel cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn
      cK cnei cfv cfv wcel wa cX cY cF wf cJ ctop wcel cF wfun cK ctop wcel cX
      cY cF ffun 3ad2ant3 ad2antrr ad2antrr cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK
      cnei cfv cfv wcel wa wa vo cv cJ wcel vo cv cF cdm wss vg cv cK wcel cA
      cF cfv csn vg cv wss vg cv vy cv wss wa wa cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vo cv cJ wcel vo cv cF cdm wss cF cA cJ cK
      ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel wa cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a vo cv cJ wcel vo cv cF cdm wss cA cX wcel cJ
      ctop wcel cX cY cF wf vo cv cJ wcel vo cv cF cdm wss cK ctop wcel cJ ctop
      wcel cX cY cF wf wa vo cv cJ wcel wa vo cv cF cdm wss vo cv cX wss cJ
      ctop wcel vo cv cJ wcel vo cv cX wss cX cY cF wf vo cv cJ cX cnpnei.1
      eltopss adantlr cX cY cF wf vo cv cF cdm wss vo cv cX wss wb cJ ctop wcel
      vo cv cJ wcel cX cY cF wf cF cdm cX vo cv cX cY cF fdm sseq2d ad2antlr
      mpbird 3adantl2 adantlr adantlr adantlr sylanc sylibd anim2d r19.22dva
      mpd exp32 r19.23adv mpd jca cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel cF ccnv vy cv
      cima cX wss cA vo cv wcel vo cv cF ccnv vy cv cima wss wa vo cJ wrex wa
      wb cF cA cJ cK ccnp co cfv wcel vy cv cA cF cfv csn cK cnei cfv cfv wcel
      wa cJ ctop wcel cK ctop wcel cA cX wcel cF ccnv vy cv cima cA csn cJ cnei
      cfv cfv wcel cF ccnv vy cv cima cX wss cA vo cv wcel vo cv cF ccnv vy cv
      cima wss wa vo cJ wrex wa wb cX cY cF wf cA vo cJ cF ccnv vy cv cima cX
      cnpnei.1 isneip 3ad2antl1 adantr mpbird exp32 r19.21adv cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vy cv cima cA csn cJ cnei
      cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral cF cA cJ cK ccnp co
      cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv
      vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv
      wral wa cF cA cJ cK ccnp co cfv wcel cX cY cF wf cA cF cfv vo cv wcel cA
      vg cv wcel cF vg cv cima vo cv wss wa vg cJ wrex wi vo cK wral wa cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vy cv cima cA csn
      cJ cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral wa cX cY cF wf
      cA cF cfv vo cv wcel cA vg cv wcel cF vg cv cima vo cv wss wa vg cJ wrex
      wi vo cK wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX cY cF wf cA cX
      wcel cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK
      cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf 3simp3 ad2antrr
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vy cv
      cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral wa
      cA cF cfv vo cv wcel cA vg cv wcel cF vg cv cima vo cv wss wa vg cJ wrex
      wi vo cK cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv
      vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv
      wral vo cv cK wcel cA cF cfv vo cv wcel cA vg cv wcel cF vg cv cima vo cv
      wss wa vg cJ wrex wi wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cA cF cfv vo cv wcel vo cv cK wcel cF ccnv vy cv cima cA csn cJ
      cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral cA vg cv wcel cF
      vg cv cima vo cv wss wa vg cJ wrex cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cA cF cfv vo cv wcel vo cv cK wcel cF ccnv vy cv cima
      cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral cA vg
      cv wcel cF vg cv cima vo cv wss wa vg cJ wrex wi cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vo cv wcel vo cv cK wcel wa
      wa cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK
      cnei cfv cfv wral cF ccnv vo cv cima cA csn cJ cnei cfv cfv wcel cA csn
      vg cv wss vg cv cF ccnv vo cv cima wss wa vg cJ wrex cA vg cv wcel cF vg
      cv cima vo cv wss wa vg cJ wrex cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cF cfv vo cv wcel vo cv cK wcel wa cF ccnv vy cv cima cA csn cJ cnei
      cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral cF ccnv vo cv cima cA
      csn cJ cnei cfv cfv wcel wi cA cX wcel cK ctop wcel cJ ctop wcel cA cF
      cfv vo cv wcel vo cv cK wcel wa cF ccnv vy cv cima cA csn cJ cnei cfv cfv
      wcel vy cA cF cfv csn cK cnei cfv cfv wral cF ccnv vo cv cima cA csn cJ
      cnei cfv cfv wcel wi cX cY cF wf cK ctop wcel cA cF cfv vo cv wcel vo cv
      cK wcel cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn
      cK cnei cfv cfv wral cF ccnv vo cv cima cA csn cJ cnei cfv cfv wcel wi cK
      ctop wcel vo cv cK wcel cA cF cfv vo cv wcel cF ccnv vy cv cima cA csn cJ
      cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral cF ccnv vo cv
      cima cA csn cJ cnei cfv cfv wcel wi cK ctop wcel vo cv cK wcel cA cF cfv
      vo cv wcel w3a vo cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vy cv
      cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK cnei cfv cfv wral cF
      ccnv vo cv cima cA csn cJ cnei cfv cfv wcel wi cA cF cfv cK vo cv opnneip
      cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel cF ccnv vo cv cima cA csn
      cJ cnei cfv cfv wcel vy vo cv cA cF cfv csn cK cnei cfv cfv vy cv vo cv
      wceq cF ccnv vy cv cima cF ccnv vo cv cima cA csn cJ cnei cfv cfv vy cv
      vo cv cF ccnv imaeq2 eleq1d rcla4v syl 3com23 3expb 3ad2antl2 adantlr cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv vo cv cima cA csn cJ cnei
      cfv cfv wcel cA csn vg cv wss vg cv cF ccnv vo cv cima wss wa vg cJ wrex
      wi cA cX wcel cA cF cfv vo cv wcel vo cv cK wcel wa cJ ctop wcel cK ctop
      wcel cF ccnv vo cv cima cA csn cJ cnei cfv cfv wcel cA csn vg cv wss vg
      cv cF ccnv vo cv cima wss wa vg cJ wrex wi cX cY cF wf cJ ctop wcel cF
      ccnv vo cv cima cA csn cJ cnei cfv cfv wcel cA csn vg cv wss vg cv cF
      ccnv vo cv cima wss wa vg cJ wrex cA csn vg cJ cF ccnv vo cv cima neii2
      ex 3ad2ant1 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA cF cfv vo cv wcel vo cv cK wcel wa wa cA csn vg cv wss vg cv cF
      ccnv vo cv cima wss wa cA vg cv wcel cF vg cv cima vo cv wss wa vg cJ cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vo cv wcel
      vo cv cK wcel wa wa vg cv cJ wcel wa cA vg cv wcel cF vg cv cima vo cv
      wss wa cA csn vg cv wss vg cv cF ccnv vo cv cima wss wa cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vo cv wcel vo cv cK
      wcel wa wa vg cv cJ wcel wa cA vg cv wcel cA csn vg cv wss cF vg cv cima
      vo cv wss vg cv cF ccnv vo cv cima wss cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cA vg cv wcel cA csn vg cv wss wb cA cF cfv vo cv
      wcel vo cv cK wcel wa vg cv cJ wcel cA cX wcel cA vg cv wcel cA csn vg cv
      wss wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA vg cv cX snssg adantl
      ad2antrr cF wfun vg cv cF cdm wss cF vg cv cima vo cv wss vg cv cF ccnv
      vo cv cima wss wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cA cF cfv vo cv wcel vo cv cK wcel wa wa vg cv cJ wcel wa vg cv vo cv cF
      funimass3 cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF wfun
      cA cF cfv vo cv wcel vo cv cK wcel wa vg cv cJ wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cF wfun cA cX wcel cX cY cF wf cJ ctop wcel cF wfun
      cK ctop wcel cX cY cF ffun 3ad2ant3 adantr ad2antrr cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vg cv cJ wcel vg cv cF cdm wss cA cF
      cfv vo cv wcel vo cv cK wcel wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      vg cv cJ wcel vg cv cF cdm wss cA cX wcel cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a vg cv cJ wcel vg cv cX wss vg cv cF cdm wss cJ ctop wcel cK
      ctop wcel vg cv cJ wcel vg cv cX wss cX cY cF wf vg cv cJ cX cnpnei.1
      eltopss 3ad2antl1 cJ ctop wcel cK ctop wcel cX cY cF wf w3a vg cv cF cdm
      wss vg cv cX wss cX cY cF wf cJ ctop wcel vg cv cF cdm wss vg cv cX wss
      wb cK ctop wcel cX cY cF wf cF cdm cX vg cv cX cY cF fdm sseq2d 3ad2ant3
      biimpar syldan adantlr adantlr sylanc anbi12d biimprd r19.22dva 3syld
      exp32 com24 imp r19.21aiv jca cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cF cA cJ cK ccnp co cfv wcel cX cY cF wf cA cF cfv vo cv
      wcel cA vg cv wcel cF vg cv cima vo cv wss wa vg cJ wrex wi vo cK wral wa
      wb cF ccnv vy cv cima cA csn cJ cnei cfv cfv wcel vy cA cF cfv csn cK
      cnei cfv cfv wral cJ ctop wcel cK ctop wcel cA cX wcel cF cA cJ cK ccnp
      co cfv wcel cX cY cF wf cA cF cfv vo cv wcel cA vg cv wcel cF vg cv cima
      vo cv wss wa vg cJ wrex wi vo cK wral wa wb cX cY cF wf cJ ctop wcel cK
      ctop wcel cA cX wcel cF cA cJ cK ccnp co cfv wcel cX cY cF wf cA cF cfv
      vo cv wcel cA vg cv wcel cF vg cv cima vo cv wss wa vg cJ wrex wi vo cK
      wral wa wb vg vo cA cF cJ cK cX cY cnpnei.1 cnpnei.2 iscnp 3expa 3adantl3
      adantr mpbird ex impbid $.
      $( [7-Sep-2009] $) $( [7-Sep-2009] $)
  $}

  ${
    $d c o x y F $. $d c o x y J $. $d c o x y K $. $d c o x y X $. $d c o x y
    Y $.
    cncls.1 $e |- X = U. J $.
    cncls.2 $e |- Y = U. K $.
    $( Continuity in terms of closure. $)
    cncls $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) -> ( F e. ( J Cn K )
    <-> A. x ( x C_ X -> ( F " ( ( cls ` J ) ` x ) ) C_ ( ( cls ` K ) ` ( F " x
    ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cX cY cF
      wf cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral wa cF ccnv vc
      cv cima cJ ccld cfv wcel vc cK ccld cfv wral vx cv cX wss cF vx cv cJ ccl
      cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal cJ ctop wcel cK
      ctop wcel cF cJ cK ccn co wcel cX cY cF wf cF ccnv vc cv cima cJ ccld cfv
      wcel vc cK ccld cfv wral wa wb cX cY cF wf vc cF cJ cK cX cY cncls.1
      cncls.2 iscncl 3adant3 cX cY cF wf cJ ctop wcel cF ccnv vc cv cima cJ
      ccld cfv wcel vc cK ccld cfv wral cX cY cF wf cF ccnv vc cv cima cJ ccld
      cfv wcel vc cK ccld cfv wral wa wb cK ctop wcel cX cY cF wf cF ccnv vc cv
      cima cJ ccld cfv wcel vc cK ccld cfv wral ibar 3ad2ant3 cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld
      cfv wral vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima cK ccl
      cfv cfv wss wi vx wal cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv
      vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral vx cv cX wss cF vx cv cJ
      ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vx cv cX wss cF ccnv vc cv cima cJ ccld cfv
      wcel vc cK ccld cfv wral cF vx cv cJ ccl cfv cfv cima cF vx cv cima cK
      ccl cfv cfv wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a vx cv cX wss cF
      ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral cF vx cv cJ ccl cfv
      cfv cima cF vx cv cima cK ccl cfv cfv wss cF wfun vx cv cJ ccl cfv cfv cF
      ccnv cF vx cv cima cK ccl cfv cfv cima wss cF vx cv cJ ccl cfv cfv cima
      cF vx cv cima cK ccl cfv cfv wss cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a vx cv cX wss wa cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv
      wral wa vx cv cJ ccl cfv cfv cF vx cv cima cK ccl cfv cfv cF funimass2 cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cF wfun vx cv cX wss cF ccnv vc cv
      cima cJ ccld cfv wcel vc cK ccld cfv wral cX cY cF wf cJ ctop wcel cF
      wfun cK ctop wcel cX cY cF ffun 3ad2ant3 ad2antrr cJ ctop wcel cF ccnv cF
      vx cv cima cK ccl cfv cfv cima cJ ccld cfv wcel vx cv cF ccnv cF vx cv
      cima cK ccl cfv cfv cima wss vx cv cJ ccl cfv cfv cF ccnv cF vx cv cima
      cK ccl cfv cfv cima wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a vx cv
      cX wss wa cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral wa cF
      ccnv cF vx cv cima cK ccl cfv cfv cima vx cv cJ cX cncls.1 clsss2 cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cJ ctop wcel vx cv cX wss cF ccnv vc cv
      cima cJ ccld cfv wcel vc cK ccld cfv wral cJ ctop wcel cK ctop wcel cX cY
      cF wf 3simp1 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a vx cv cX
      wss wa cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral cF ccnv cF
      vx cv cima cK ccl cfv cfv cima cJ ccld cfv wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a vx cv cX wss wa cF vx cv cima cK ccl cfv cfv cK ccld cfv
      wcel cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral cF ccnv cF
      vx cv cima cK ccl cfv cfv cima cJ ccld cfv wcel wi cK ctop wcel cF vx cv
      cima cY wss cF vx cv cima cK ccl cfv cfv cK ccld cfv wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vx cv cX wss wa cF vx cv cima cK cY cncls.2
      clscld cJ ctop wcel cK ctop wcel cX cY cF wf w3a cK ctop wcel vx cv cX
      wss cJ ctop wcel cK ctop wcel cX cY cF wf 3simp2 adantr cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cF vx cv cima cY wss vx cv cX wss cX cY cF wf
      cJ ctop wcel cF vx cv cima cY wss cK ctop wcel cX cY cF wf cF vx cv cima
      cF crn cY cF vx cv cima cF crn wss cX cY cF wf cF vx cv imassrn a1i cX cY
      cF frn sstrd 3ad2ant3 adantr sylanc cF ccnv vc cv cima cJ ccld cfv wcel
      cF ccnv cF vx cv cima cK ccl cfv cfv cima cJ ccld cfv wcel vc cF vx cv
      cima cK ccl cfv cfv cK ccld cfv vc cv cF vx cv cima cK ccl cfv cfv wceq
      cF ccnv vc cv cima cF ccnv cF vx cv cima cK ccl cfv cfv cima cJ ccld cfv
      vc cv cF vx cv cima cK ccl cfv cfv cF ccnv imaeq2 eleq1d rcla4v syl imp
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a vx cv cX wss wa cF ccnv vc cv
      cima cJ ccld cfv wcel vc cK ccld cfv wral wa cF vx cv cima cF vx cv cima
      cK ccl cfv cfv wss vx cv cF ccnv cF vx cv cima cK ccl cfv cfv cima wss cK
      ctop wcel cF vx cv cima cY wss cF vx cv cima cF vx cv cima cK ccl cfv cfv
      wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a vx cv cX wss wa cF ccnv vc
      cv cima cJ ccld cfv wcel vc cK ccld cfv wral wa cF vx cv cima cK cY
      cncls.2 sscls cJ ctop wcel cK ctop wcel cX cY cF wf w3a cK ctop wcel vx
      cv cX wss cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral cJ ctop
      wcel cK ctop wcel cX cY cF wf 3simp2 ad2antrr cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cF vx cv cima cY wss vx cv cX wss cF ccnv vc cv cima cJ
      ccld cfv wcel vc cK ccld cfv wral cX cY cF wf cJ ctop wcel cF vx cv cima
      cY wss cK ctop wcel cX cY cF wf cF vx cv cima cF crn cY cF vx cv cima cF
      crn wss cX cY cF wf cF vx cv imassrn a1i cX cY cF frn sstrd 3ad2ant3
      ad2antrr sylanc cF wfun vx cv cF cdm wss cF vx cv cima cF vx cv cima cK
      ccl cfv cfv wss vx cv cF ccnv cF vx cv cima cK ccl cfv cfv cima wss wb cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a vx cv cX wss wa cF ccnv vc cv cima
      cJ ccld cfv wcel vc cK ccld cfv wral wa vx cv cF vx cv cima cK ccl cfv
      cfv cF funimass3 cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF wfun vx cv
      cX wss cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral cX cY cF
      wf cJ ctop wcel cF wfun cK ctop wcel cX cY cF ffun 3ad2ant3 ad2antrr cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a vx cv cX wss wa vx cv cF cdm wss
      cF ccnv vc cv cima cJ ccld cfv wcel vc cK ccld cfv wral cX cY cF wf cJ
      ctop wcel vx cv cX wss vx cv cF cdm wss cK ctop wcel cF cdm cX wceq vx cv
      cX wss vx cv cF cdm wss cX cY cF wf cF cdm cX wceq vx cv cF cdm wss vx cv
      cX wss cF cdm cX vx cv sseq2 biimpar cX cY cF fdm sylan 3ad2antl3 adantr
      sylanc mpbid syl3anc sylanc exp31 com23 19.21adv cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv
      cima cK ccl cfv cfv wss wi vx wal cF ccnv vc cv cima cJ ccld cfv wcel vc
      cK ccld cfv cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK ccld cfv
      wcel vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv
      cfv wss wi vx wal cF ccnv vc cv cima cJ ccld cfv wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vc cv cK ccld cfv wcel vx cv cX wss cF vx cv cJ
      ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal cF ccnv vc cv
      cima cJ ccld cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK
      ccld cfv wcel wa vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima
      cK ccl cfv cfv wss wi vx wal wa cF ccnv vc cv cima cJ ccld cfv wcel cF
      ccnv vc cv cima cJ ccl cfv cfv cF ccnv vc cv cima wss cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vc cv cK ccld cfv wcel wa vx cv cX wss cF vx cv
      cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal wa cF cF
      ccnv vc cv cima cJ ccl cfv cfv cima vc cv wss cF ccnv vc cv cima cJ ccl
      cfv cfv cF ccnv vc cv cima wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      vc cv cK ccld cfv wcel wa vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx
      cv cima cK ccl cfv cfv wss wi vx wal wa cF cF ccnv vc cv cima cJ ccl cfv
      cfv cima cF cF ccnv vc cv cima cima cK ccl cfv cfv vc cv cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vc cv cK ccld cfv wcel wa vx cv cX wss cF vx cv
      cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal cF cF ccnv
      vc cv cima cJ ccl cfv cfv cima cF cF ccnv vc cv cima cima cK ccl cfv cfv
      wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK ccld cfv wcel wa
      vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv
      wss wi vx wal cF ccnv vc cv cima cX wss cF cF ccnv vc cv cima cJ ccl cfv
      cfv cima cF cF ccnv vc cv cima cima cK ccl cfv cfv wss cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cF ccnv vc cv cima cX wss vc cv cK ccld cfv
      wcel cX cY cF wf cJ ctop wcel cF ccnv vc cv cima cX wss cK ctop wcel cX
      cY cF wf cF cX wfn cF cdm cX wceq cF ccnv vc cv cima cX wss cX cY cF ffn
      cX cF fndm cF cdm cX wceq cF ccnv vc cv cima cF cdm wss cF ccnv vc cv
      cima cX wss cF vc cv cnvimass cF cdm cX cF ccnv vc cv cima sseq2 mpbii
      3syl 3ad2ant3 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK
      ccld cfv wcel wa cF ccnv vc cv cima cvv wcel vx cv cX wss cF vx cv cJ ccl
      cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal cF ccnv vc cv
      cima cX wss cF cF ccnv vc cv cima cJ ccl cfv cfv cima cF cF ccnv vc cv
      cima cima cK ccl cfv cfv wss wi wi cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cF ccnv vc cv cima cvv wcel vc cv cK ccld cfv wcel cJ ctop wcel cX cY
      cF wf cF ccnv vc cv cima cvv wcel cK ctop wcel cX cvv wcel cX cY cF wf cF
      ccnv vc cv cima cvv wcel cJ ctop wcel cF ccnv vc cv cima cX wss cX cvv
      wcel cF ccnv vc cv cima cvv wcel cX cvv wcel cX cY cF wf wa cF ccnv vc cv
      cima cX cvv ssexg cX cvv wcel cX cY cF wf wa cF ccnv vc cv cima cF cdm
      wss cF ccnv vc cv cima cX wss cF vc cv cnvimass cX cY cF wf cF ccnv vc cv
      cima cF cdm wss cF ccnv vc cv cima cX wss wb cX cvv wcel cX cY cF wf cF
      cX wfn cF cdm cX wceq cF ccnv vc cv cima cF cdm wss cF ccnv vc cv cima cX
      wss wb cX cY cF ffn cX cF fndm cF cdm cX cF ccnv vc cv cima sseq2 3syl
      adantl mpbii cX cvv wcel cX cY cF wf pm3.26 sylanc cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg cncls.1 syl5eqel sylan 3adant2 adantr vx cv cX wss
      cF vx cv cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi cF ccnv
      vc cv cima cX wss cF cF ccnv vc cv cima cJ ccl cfv cfv cima cF cF ccnv vc
      cv cima cima cK ccl cfv cfv wss wi vx cF ccnv vc cv cima cvv vx cv cF
      ccnv vc cv cima wceq vx cv cX wss cF ccnv vc cv cima cX wss cF vx cv cJ
      ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss cF cF ccnv vc cv cima
      cJ ccl cfv cfv cima cF cF ccnv vc cv cima cima cK ccl cfv cfv wss vx cv
      cF ccnv vc cv cima cX sseq1 vx cv cF ccnv vc cv cima wceq cF vx cv cJ ccl
      cfv cfv cima cF cF ccnv vc cv cima cJ ccl cfv cfv cima cF vx cv cima cK
      ccl cfv cfv cF cF ccnv vc cv cima cima cK ccl cfv cfv vx cv cF ccnv vc cv
      cima wceq vx cv cJ ccl cfv cfv cF ccnv vc cv cima cJ ccl cfv cfv cF vx cv
      cF ccnv vc cv cima cJ ccl cfv fveq2 imaeq2d vx cv cF ccnv vc cv cima wceq
      cF vx cv cima cF cF ccnv vc cv cima cima cK ccl cfv vx cv cF ccnv vc cv
      cima cF imaeq2 fveq2d sseq12d imbi12d cla4gv syl mpid imp cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vc cv cK ccld cfv wcel wa cF cF ccnv vc cv cima
      cima cK ccl cfv cfv vc cv wss vx cv cX wss cF vx cv cJ ccl cfv cfv cima
      cF vx cv cima cK ccl cfv cfv wss wi vx wal cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a vc cv cK ccld cfv wcel wa cF cF ccnv vc cv cima cima cK ccl
      cfv cfv vc cv cK ccl cfv cfv vc cv cK ctop wcel vc cv cY wss cF cF ccnv
      vc cv cima cima vc cv wss cF cF ccnv vc cv cima cima cK ccl cfv cfv vc cv
      cK ccl cfv cfv wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK
      ccld cfv wcel wa vc cv cF cF ccnv vc cv cima cima cK cY cncls.2 clsss cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cK ctop wcel vc cv cK ccld cfv
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf 3simp2 adantr cK ctop wcel cJ
      ctop wcel vc cv cK ccld cfv wcel vc cv cY wss cX cY cF wf vc cv cK cY
      cncls.2 cldss 3ad2antl2 cF wfun cF ccnv vc cv cima cF ccnv vc cv cima wss
      cF cF ccnv vc cv cima cima vc cv wss cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a vc cv cK ccld cfv wcel wa cF ccnv vc cv cima vc cv cF funimass2 cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cF wfun vc cv cK ccld cfv wcel cX
      cY cF wf cJ ctop wcel cF wfun cK ctop wcel cX cY cF ffun 3ad2ant3 adantr
      cF ccnv vc cv cima cF ccnv vc cv cima wss cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a vc cv cK ccld cfv wcel wa cF ccnv vc cv cima ssid a1i sylanc
      syl3anc cK ctop wcel vc cv cK ccld cfv wcel vc cv vc cv wss vc cv cK ccl
      cfv cfv vc cv wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK ccld
      cfv wcel wa vc cv vc cv cK cY cncls.2 clsss2 cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cK ctop wcel vc cv cK ccld cfv wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf 3simp2 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      vc cv cK ccld cfv wcel pm3.27 vc cv vc cv wss cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a vc cv cK ccld cfv wcel wa vc cv ssid a1i syl3anc sstrd
      adantr sstrd cF wfun cF ccnv vc cv cima cJ ccl cfv cfv cF cdm wss cF cF
      ccnv vc cv cima cJ ccl cfv cfv cima vc cv wss cF ccnv vc cv cima cJ ccl
      cfv cfv cF ccnv vc cv cima wss wb cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a vc cv cK ccld cfv wcel wa vx cv cX wss cF vx cv cJ ccl cfv cfv cima
      cF vx cv cima cK ccl cfv cfv wss wi vx wal wa cF ccnv vc cv cima cJ ccl
      cfv cfv vc cv cF funimass3 cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF
      wfun vc cv cK ccld cfv wcel vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF
      vx cv cima cK ccl cfv cfv wss wi vx wal cX cY cF wf cJ ctop wcel cF wfun
      cK ctop wcel cX cY cF ffun 3ad2ant3 ad2antrr cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a vc cv cK ccld cfv wcel wa vx cv cX wss cF vx cv cJ ccl cfv
      cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal wa cF ccnv vc cv cima
      cJ ccl cfv cfv cX cF cdm cJ ctop wcel cF ccnv vc cv cima cX wss cF ccnv
      vc cv cima cJ ccl cfv cfv cX wss cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a vc cv cK ccld cfv wcel wa vx cv cX wss cF vx cv cJ ccl cfv cfv cima
      cF vx cv cima cK ccl cfv cfv wss wi vx wal wa cF ccnv vc cv cima cJ cX
      cncls.1 clsss3 cJ ctop wcel cK ctop wcel cX cY cF wf w3a cJ ctop wcel vc
      cv cK ccld cfv wcel vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv
      cima cK ccl cfv cfv wss wi vx wal cJ ctop wcel cK ctop wcel cX cY cF wf
      3simp1 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv vc cv
      cima cX wss vc cv cK ccld cfv wcel vx cv cX wss cF vx cv cJ ccl cfv cfv
      cima cF vx cv cima cK ccl cfv cfv wss wi vx wal cX cY cF wf cJ ctop wcel
      cF ccnv vc cv cima cX wss cK ctop wcel cX cY cF wf cF ccnv vc cv cima cF
      cdm cX cF ccnv vc cv cima cF cdm wss cX cY cF wf cF vc cv cnvimass a1i cX
      cY cF fdm sseqtrd 3ad2ant3 ad2antrr sylanc cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cF cdm cX wceq vc cv cK ccld cfv wcel vx cv cX wss cF vx cv
      cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv cfv wss wi vx wal cX cY cF
      wf cJ ctop wcel cF cdm cX wceq cK ctop wcel cX cY cF fdm 3ad2ant3
      ad2antrr sseqtr4d sylanc mpbid cJ ctop wcel cF ccnv vc cv cima cX wss cF
      ccnv vc cv cima cJ ccld cfv wcel cF ccnv vc cv cima cJ ccl cfv cfv cF
      ccnv vc cv cima wss wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a vc cv cK
      ccld cfv wcel wa vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima
      cK ccl cfv cfv wss wi vx wal wa cF ccnv vc cv cima cJ cX cncls.1 iscld4
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cJ ctop wcel vc cv cK ccld cfv
      wcel vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima cK ccl cfv
      cfv wss wi vx wal cJ ctop wcel cK ctop wcel cX cY cF wf 3simp1 ad2antrr
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv vc cv cima cX wss vc cv
      cK ccld cfv wcel vx cv cX wss cF vx cv cJ ccl cfv cfv cima cF vx cv cima
      cK ccl cfv cfv wss wi vx wal cX cY cF wf cJ ctop wcel cF ccnv vc cv cima
      cX wss cK ctop wcel cX cY cF wf cF cX wfn cF cdm cX wceq cF ccnv vc cv
      cima cX wss cX cY cF ffn cX cF fndm cF cdm cX wceq cF ccnv vc cv cima cF
      cdm wss cF ccnv vc cv cima cX wss cF vc cv cnvimass cF cdm cX cF ccnv vc
      cv cima sseq2 mpbii 3syl 3ad2ant3 ad2antrr sylanc mpbird exp31 com23
      r19.21adv impbid 3bitr2d $.
      $( [1-Oct-2009] $) $( [1-Oct-2009] $)

      $( Continuity in terms of interior. $)
      cnntr $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y )
       -> ( F e. ( J Cn K ) <-> A. y ( y C_ Y -> ( `' F " ( ( int ` K ) ` y ) )
            C_ ( ( int ` J ) ` ( `' F " y ) ) ) ) ) $=
        cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cX cY cF
        wf cF ccnv vo cv cima cJ wcel vo cK wral wa cF ccnv vo cv cima cJ wcel
        vo cK wral vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv
        cima cJ cnt cfv cfv wss wi vy wal cJ ctop wcel cK ctop wcel cF cJ cK
        ccn co wcel cX cY cF wf cF ccnv vo cv cima cJ wcel vo cK wral wa wb cX
        cY cF wf vo cF cJ cK cX cY cncls.1 cncls.2 iscn 3adant3 cX cY cF wf cJ
        ctop wcel cF ccnv vo cv cima cJ wcel vo cK wral cX cY cF wf cF ccnv vo
        cv cima cJ wcel vo cK wral wa wb cK ctop wcel cX cY cF wf cF ccnv vo cv
        cima cJ wcel vo cK wral ibar 3ad2ant3 cJ ctop wcel cK ctop wcel cX cY
        cF wf w3a cF ccnv vo cv cima cJ wcel vo cK wral vy cv cY wss cF ccnv vy
        cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal
        cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv vo cv cima cJ wcel vo
        cK wral vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv
        cima cJ cnt cfv cfv wss wi vy cJ ctop wcel cK ctop wcel cX cY cF wf w3a
        cF ccnv vo cv cima cJ wcel vo cK wral vy cv cY wss cF ccnv vy cv cK cnt
        cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss cJ ctop wcel cF ccnv
        vy cv cima cX wss cF ccnv vy cv cK cnt cfv cfv cima cJ wcel cF ccnv vy
        cv cK cnt cfv cfv cima cF ccnv vy cv cima wss cF ccnv vy cv cK cnt cfv
        cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss cJ ctop wcel cK ctop
        wcel cX cY cF wf w3a cF ccnv vo cv cima cJ wcel vo cK wral vy cv cY wss
        wa wa cF ccnv vy cv cima cJ cF ccnv vy cv cK cnt cfv cfv cima cX
        cncls.1 ssntr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cJ ctop wcel cF
        ccnv vo cv cima cJ wcel vo cK wral vy cv cY wss wa cJ ctop wcel cK ctop
        wcel cX cY cF wf 3simp1 adantr cJ ctop wcel cK ctop wcel cX cY cF wf
        w3a cF ccnv vy cv cima cX wss cF ccnv vo cv cima cJ wcel vo cK wral vy
        cv cY wss wa cX cY cF wf cJ ctop wcel cF ccnv vy cv cima cX wss cK ctop
        wcel cX cY cF wf cF cX wfn cF cdm cX wceq cF ccnv vy cv cima cX wss cX
        cY cF ffn cX cF fndm cF cdm cX wceq cF ccnv vy cv cima cF cdm wss cF
        ccnv vy cv cima cX wss cF vy cv cnvimass cF cdm cX cF ccnv vy cv cima
        sseq2 mpbii 3syl 3ad2ant3 adantr cJ ctop wcel cK ctop wcel cX cY cF wf
        w3a cF ccnv vo cv cima cJ wcel vo cK wral vy cv cY wss cF ccnv vy cv cK
        cnt cfv cfv cima cJ wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy
        cv cY wss cF ccnv vo cv cima cJ wcel vo cK wral cF ccnv vy cv cK cnt
        cfv cfv cima cJ wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cY
        wss cF ccnv vo cv cima cJ wcel vo cK wral cF ccnv vy cv cK cnt cfv cfv
        cima cJ wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cY wss
        wa vy cv cK cnt cfv cfv cK wcel cF ccnv vo cv cima cJ wcel vo cK wral
        cF ccnv vy cv cK cnt cfv cfv cima cJ wcel wi cK ctop wcel cJ ctop wcel
        vy cv cY wss vy cv cK cnt cfv cfv cK wcel cX cY cF wf vy cv cK cY
        cncls.2 ntropn 3ad2antl2 cF ccnv vo cv cima cJ wcel cF ccnv vy cv cK
        cnt cfv cfv cima cJ wcel vo vy cv cK cnt cfv cfv cK vo cv vy cv cK cnt
        cfv cfv wceq cF ccnv vo cv cima cF ccnv vy cv cK cnt cfv cfv cima cJ vo
        cv vy cv cK cnt cfv cfv cF ccnv imaeq2 eleq1d rcla4v syl ex com23 imp32
        cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv vo cv cima cJ wcel vo
        cK wral vy cv cY wss wa wa vy cv cK cnt cfv cfv vy cv wss cF ccnv vy cv
        cK cnt cfv cfv cima cF ccnv vy cv cima wss cJ ctop wcel cK ctop wcel cX
        cY cF wf w3a vy cv cY wss vy cv cK cnt cfv cfv vy cv wss cF ccnv vo cv
        cima cJ wcel vo cK wral cK ctop wcel cJ ctop wcel vy cv cY wss vy cv cK
        cnt cfv cfv vy cv wss cX cY cF wf vy cv cK cY cncls.2 ntrss2 3ad2antl2
        adantrl vy cv cK cnt cfv cfv vy cv cF ccnv imass2 syl syl2anc exp32
        19.21adv cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv
        vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy
        wal cF ccnv vo cv cima cJ wcel vo cK cJ ctop wcel cK ctop wcel cX cY cF
        wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv
        cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel cF ccnv vo cv cima cJ
        wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy
        cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal
        vo cv cK wcel wa wa cF ccnv vo cv cima cJ wcel cF ccnv vo cv cima cJ
        cnt cfv cfv cF ccnv vo cv cima wceq cJ ctop wcel cK ctop wcel cX cY cF
        wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv
        cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel wa wa cF ccnv vo cv
        cima cJ cnt cfv cfv cF ccnv vo cv cima cJ ctop wcel cF ccnv vo cv cima
        cX wss cF ccnv vo cv cima cJ cnt cfv cfv cF ccnv vo cv cima wss cJ ctop
        wcel cK ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv
        cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel
        wa wa cF ccnv vo cv cima cJ cX cncls.1 ntrss2 cJ ctop wcel cK ctop wcel
        cX cY cF wf w3a cJ ctop wcel vy cv cY wss cF ccnv vy cv cK cnt cfv cfv
        cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel wa
        cJ ctop wcel cK ctop wcel cX cY cF wf 3simp1 adantr cJ ctop wcel cK
        ctop wcel cX cY cF wf w3a cF ccnv vo cv cima cX wss vy cv cY wss cF
        ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi
        vy wal vo cv cK wcel wa cX cY cF wf cJ ctop wcel cF ccnv vo cv cima cX
        wss cK ctop wcel cX cY cF wf cF ccnv vo cv cima cF cdm cX cF ccnv vo cv
        cima cF cdm wss cX cY cF wf cF vo cv cnvimass a1i cX cY cF fdm sseqtrd
        3ad2ant3 adantr sylanc cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv
        cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv
        cfv wss wi vy wal vo cv cK wcel wa wa cF ccnv vo cv cima cF ccnv vo cv
        cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv cfv cJ ctop wcel cK
        ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv cfv
        cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel wa
        wa vo cv cK cnt cfv cfv vo cv cF ccnv cJ ctop wcel cK ctop wcel cX cY
        cF wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv
        cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel wa wa vo cv cK wcel vo
        cv cK cnt cfv cfv vo cv wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a
        vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ
        cnt cfv cfv wss wi vy wal vo cv cK wcel simprr cK ctop wcel vo cv cY
        wss vo cv cK wcel vo cv cK cnt cfv cfv vo cv wceq wb cJ ctop wcel cK
        ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv cfv
        cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel wa
        wa vo cv cK cY cncls.2 isopn3 cJ ctop wcel cK ctop wcel cX cY cF wf w3a
        cK ctop wcel vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy
        cv cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel wa cJ ctop wcel cK
        ctop wcel cX cY cF wf 3simp2 adantr cJ ctop wcel cK ctop wcel cX cY cF
        wf w3a vo cv cK wcel vo cv cY wss vy cv cY wss cF ccnv vy cv cK cnt cfv
        cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal cK ctop wcel
        cJ ctop wcel vo cv cK wcel vo cv cY wss cX cY cF wf vo cv cK cY cncls.2
        eltopss 3ad2antl2 adantrl sylanc mpbid imaeq2d cJ ctop wcel cK ctop
        wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF
        ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv cK wcel cF ccnv vo
        cv cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv cfv wss cJ ctop
        wcel cK ctop wcel cX cY cF wf w3a vo cv cK wcel vy cv cY wss cF ccnv vy
        cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal
        cF ccnv vo cv cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv cfv wss
        cJ ctop wcel cK ctop wcel cX cY cF wf w3a vo cv cK wcel vy cv cY wss cF
        ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi
        vy wal cF ccnv vo cv cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv
        cfv wss wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a vo cv cK wcel wa
        vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ
        cnt cfv cfv wss wi vy wal vo cv cY wss cF ccnv vo cv cK cnt cfv cfv
        cima cF ccnv vo cv cima cJ cnt cfv cfv wss cK ctop wcel cJ ctop wcel vo
        cv cK wcel vo cv cY wss cX cY cF wf vo cv cK cY cncls.2 eltopss
        3ad2antl2 vo cv cK wcel vy cv cY wss cF ccnv vy cv cK cnt cfv cfv cima
        cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv cY wss cF ccnv vo
        cv cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv cfv wss wi wi cJ
        ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy cv cK
        cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vo cv cY wss
        cF ccnv vo cv cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv cfv wss
        wi vy vo cv cK vy cv vo cv wceq vy cv cY wss vo cv cY wss cF ccnv vy cv
        cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss cF ccnv vo cv
        cK cnt cfv cfv cima cF ccnv vo cv cima cJ cnt cfv cfv wss vy cv vo cv
        cY sseq1 vy cv vo cv wceq cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vo
        cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv cF ccnv vo cv
        cima cJ cnt cfv cfv vy cv vo cv wceq vy cv cK cnt cfv cfv vo cv cK cnt
        cfv cfv cF ccnv vy cv vo cv cK cnt cfv fveq2 imaeq2d vy cv vo cv wceq
        cF ccnv vy cv cima cF ccnv vo cv cima cJ cnt cfv vy cv vo cv cF ccnv
        imaeq2 fveq2d sseq12d imbi12d cla4gv adantl mpid ex com23 imp32
        eqsstr3d eqssd cJ ctop wcel cF ccnv vo cv cima cX wss cF ccnv vo cv
        cima cJ wcel cF ccnv vo cv cima cJ cnt cfv cfv cF ccnv vo cv cima wceq
        wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cY wss cF ccnv vy cv
        cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo
        cv cK wcel wa wa cF ccnv vo cv cima cJ cX cncls.1 isopn3 cJ ctop wcel
        cK ctop wcel cX cY cF wf w3a cJ ctop wcel vy cv cY wss cF ccnv vy cv cK
        cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv wss wi vy wal vo cv
        cK wcel wa cJ ctop wcel cK ctop wcel cX cY cF wf 3simp1 adantr cJ ctop
        wcel cK ctop wcel cX cY cF wf w3a cF ccnv vo cv cima cX wss vy cv cY
        wss cF ccnv vy cv cK cnt cfv cfv cima cF ccnv vy cv cima cJ cnt cfv cfv
        wss wi vy wal vo cv cK wcel wa cX cY cF wf cJ ctop wcel cF ccnv vo cv
        cima cX wss cK ctop wcel cX cY cF wf cF ccnv vo cv cima cF cdm cX cF
        ccnv vo cv cima cF cdm wss cX cY cF wf cF vo cv cnvimass a1i cX cY cF
        fdm sseqtrd 3ad2ant3 adantr sylanc mpbird exp32 r19.21adv impbid
        3bitr2d $.
        $( [2-Oct-2009] $) $( [2-Oct-2009] $)
  $}

  $( Homeomorphisms preserve closedness. $)
  hmeoclda $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Homeo K ) ) /\ S e. (
  Clsd ` J ) ) -> ( F " S ) e. ( Clsd ` K ) ) $=
    cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel w3a cS cJ ccld cfv wcel
    wa cF ccnv ccnv cS cima cK ccld cfv cF cS cima cK ctop wcel cJ ctop wcel cF
    ccnv cK cJ ccn co wcel w3a cS cJ ccld cfv wcel cF ccnv ccnv cS cima cK ccld
    cfv wcel cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel w3a cS cF ccnv
    cK cJ cnclima cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel w3a cK
    ctop wcel cJ ctop wcel cF ccnv cK cJ ccn co wcel cJ ctop wcel cK ctop wcel
    cF cJ cK chomeosm co wcel 3simp2 cJ ctop wcel cK ctop wcel cF cJ cK
    chomeosm co wcel 3simp1 cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel
    cF ccnv cK cJ ccn co wcel cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
    wcel cJ cuni cK cuni cF wf1o cF cJ cK ccn co wcel cF ccnv cK cJ ccn co wcel
    w3a cF ccnv cK cJ ccn co wcel cJ ctop wcel cK ctop wcel wa cF cJ cK
    chomeosm co wcel cJ cuni cK cuni cF wf1o cF cJ cK ccn co wcel cF ccnv cK cJ
    ccn co wcel w3a cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF cJ
    cK chomeosm co wcel cJ cuni cK cuni cF wf1o cF cJ cK ccn co wcel cF ccnv cK
    cJ ccn co wcel w3a wb cJ cK chomeosm co cF cJ cK cJ cuni cK cuni cJ cuni
    eqid cK cuni eqid hmeobc 3expia ibd cJ cuni cK cuni cF wf1o cF cJ cK ccn co
    wcel cF ccnv cK cJ ccn co wcel 3simp3 syl6 3impia 3jca sylan cF cS
    imacnvcnv syl5eqelr $.
    $( [3-Jul-2009] $) $( [3-Jul-2009] $)

  $( Homeomorphisms preserve closedness. $)
  hmeocldb $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Homeo K ) ) /\ S e. (
  Clsd ` K ) ) -> ( `' F " S ) e. ( Clsd ` J ) ) $=
    cK ctop wcel cJ ctop wcel cF ccnv cK cJ chomeosm co wcel w3a cS cK ccld cfv
    wcel cF ccnv cS cima cJ ccld cfv wcel cJ ctop wcel cK ctop wcel cF cJ cK
    chomeosm co wcel w3a cS cF ccnv cK cJ hmeoclda cJ ctop wcel cK ctop wcel cF
    cJ cK chomeosm co wcel w3a cK ctop wcel cJ ctop wcel cF ccnv cK cJ chomeosm
    co wcel cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel 3simp2 cJ ctop
    wcel cK ctop wcel cF cJ cK chomeosm co wcel 3simp1 cJ ctop wcel cK ctop
    wcel cF cJ cK chomeosm co wcel cF ccnv cK cJ chomeosm co wcel cF cJ cK
    cnvhmpha 3impia 3jca sylan $.
    $( [3-Jul-2009] $) $( [3-Jul-2009] $)

  ${
    $d o r s t u J $. $d o r s t u S $. $d o r s t u T $. $d o r s t u X $.
    subsubtop.1 $e |- X = U. J $.
    $( Equivalence of being a subspace of a subspace and being a subspace of
       the original. $)
    subsubtop $p |- ( ( J e. Top /\ S C_ T /\ T C_ X ) -> ( subSp ` <. S , (
    subSp ` <. T , J >. ) >. ) = ( subSp ` <. S , J >. ) ) $=
      cJ ctop wcel cS cT wss cT cX wss w3a vo cS cT cJ cop csubsp cfv cop
      csubsp cfv cS cJ cop csubsp cfv cJ ctop wcel cS cT wss cT cX wss w3a vo
      cv vs cv cS cin wceq vs cT cJ cop csubsp cfv wrex vo cv vt cv cS cin wceq
      vt cJ wrex vo cv cS cT cJ cop csubsp cfv cop csubsp cfv wcel vo cv cS cJ
      cop csubsp cfv wcel cJ ctop wcel cS cT wss cT cX wss w3a vo cv vs cv cS
      cin wceq vs cT cJ cop csubsp cfv wrex vo cv vt cv cS cin wceq vt cJ wrex
      cJ ctop wcel cS cT wss cT cX wss w3a vo cv vs cv cS cin wceq vo cv vt cv
      cS cin wceq vt cJ wrex vs cT cJ cop csubsp cfv cJ ctop wcel cS cT wss cT
      cX wss w3a vs cv cT cJ cop csubsp cfv wcel vs cv vr cv cT cin wceq vr cJ
      wrex vo cv vs cv cS cin wceq vo cv vt cv cS cin wceq vt cJ wrex wi cJ
      ctop wcel cT cvv wcel vs cv cT cJ cop csubsp cfv wcel vs cv vr cv cT cin
      wceq vr cJ wrex wb cJ ctop wcel cS cT wss cT cX wss w3a cJ ctop wcel vs
      cv cvv wcel cT cvv wcel vs cv cT cJ cop csubsp cfv wcel vs cv vr cv cT
      cin wceq vr cJ wrex wb vs visset vr vs cv cT cvv cJ issubspt mp3an2 cJ
      ctop wcel cS cT wss cT cX wss 3simp1 cJ ctop wcel cT cX wss cT cvv wcel
      cS cT wss cJ cuni cvv wcel cT cJ cuni wss cT cvv wcel cJ ctop wcel cT cX
      wss cT cJ cuni wss cJ cuni cvv wcel cT cvv wcel cT cJ cuni cvv ssexg
      ancoms cJ ctop uniexg cT cX wss cT cJ cuni wss cX cJ cuni cT subsubtop.1
      sseq2i biimpi syl2an 3adant2 sylanc cJ ctop wcel cS cT wss cT cX wss w3a
      vs cv vr cv cT cin wceq vo cv vs cv cS cin wceq vo cv vt cv cS cin wceq
      vt cJ wrex wi vr cJ cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel wa
      vs cv vr cv cT cin wceq vo cv vs cv cS cin wceq vo cv vt cv cS cin wceq
      vt cJ wrex vr cv cJ wcel vo cv vr cv cS cin wceq vo cv vt cv cS cin wceq
      vt cJ wrex cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel wa vs cv vr
      cv cT cin wceq wa vo cv vs cv cS cin wceq wa vo cv vt cv cS cin wceq vo
      cv vr cv cS cin wceq vt vr cv cJ vt cv vr cv wceq vt cv cS cin vr cv cS
      cin vo cv vt cv vr cv cS ineq1 eqeq2d rcla4ev cJ ctop wcel cS cT wss cT
      cX wss w3a vr cv cJ wcel wa vr cv cJ wcel vs cv vr cv cT cin wceq vo cv
      vs cv cS cin wceq cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel
      pm3.27 ad2antrr cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel wa vs
      cv vr cv cT cin wceq wa vo cv vs cv cS cin wceq wa vo cv vr cv cT cin cS
      cin vr cv cS cin vs cv vr cv cT cin wceq vo cv vs cv cS cin wceq vo cv vr
      cv cT cin cS cin wceq cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel
      wa vs cv cS cin vr cv cT cin cS cin wceq vo cv vs cv cS cin wceq vo cv vr
      cv cT cin cS cin wceq vs cv vr cv cT cin wceq vo cv vs cv cS cin wceq vs
      cv cS cin vr cv cT cin cS cin wceq vo cv vr cv cT cin cS cin wceq vo cv
      vs cv cS cin vr cv cT cin cS cin eqtr ancoms vs cv vr cv cT cin cS ineq1
      sylan adantll cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel wa vs cv
      vr cv cT cin wceq wa vo cv vs cv cS cin wceq wa vr cv cT cS cin cin vr cv
      cS cin vr cv cT cin cS cin cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ
      wcel wa vs cv vr cv cT cin wceq wa vo cv vs cv cS cin wceq wa cT cS cin
      cS vr cv cJ ctop wcel cS cT wss cT cX wss w3a vr cv cJ wcel wa cT cS cin
      cS wceq vs cv vr cv cT cin wceq vo cv vs cv cS cin wceq cJ ctop wcel cS
      cT wss cT cX wss w3a cT cS cin cS wceq vr cv cJ wcel cS cT wss cJ ctop
      wcel cT cS cin cS wceq cT cX wss cS cT wss cS cT cin cS cT cS cin cS cT
      wss cS cT cin cS wceq cS cT df-ss biimpi cT cS incom syl5eq 3ad2ant2
      adantr ad2antrr ineq2d vr cv cT cS inass syl5eq eqtrd sylanc exp31
      r19.23adva sylbid r19.23adv cJ ctop wcel cS cT wss cT cX wss w3a vo cv vt
      cv cS cin wceq vo cv vs cv cS cin wceq vs cT cJ cop csubsp cfv wrex vt cJ
      cJ ctop wcel cS cT wss cT cX wss w3a vt cv cJ wcel wa vo cv vt cv cS cin
      wceq vo cv vs cv cS cin wceq vs cT cJ cop csubsp cfv wrex vt cv cT cin cT
      cJ cop csubsp cfv wcel vo cv vt cv cT cin cS cin wceq vo cv vs cv cS cin
      wceq vs cT cJ cop csubsp cfv wrex cJ ctop wcel cS cT wss cT cX wss w3a vt
      cv cJ wcel wa vo cv vt cv cS cin wceq wa vo cv vs cv cS cin wceq vo cv vt
      cv cT cin cS cin wceq vs vt cv cT cin cT cJ cop csubsp cfv vs cv vt cv cT
      cin wceq vs cv cS cin vt cv cT cin cS cin vo cv vs cv vt cv cT cin cS
      ineq1 eqeq2d rcla4ev cJ ctop wcel cS cT wss cT cX wss w3a vt cv cJ wcel
      wa vt cv cT cin cT cJ cop csubsp cfv wcel vo cv vt cv cS cin wceq cJ ctop
      wcel cT cX wss vt cv cJ wcel vt cv cT cin cT cJ cop csubsp cfv wcel cS cT
      wss cJ ctop wcel cT cX wss wa vt cv cJ wcel vt cv cT cin vt cv cT cin
      wceq vt cv cT cin cT cJ cop csubsp cfv wcel vt cv cT cin eqid vt cv vt cv
      cT cin cT cJ cX subsubtop.1 elsubsp mpanr2 3adantl2 adantr cJ ctop wcel
      cS cT wss cT cX wss w3a vt cv cJ wcel wa vo cv vt cv cS cin wceq wa vo cv
      vt cv cT cS cin cin vt cv cT cin cS cin cJ ctop wcel cS cT wss cT cX wss
      w3a vt cv cJ wcel wa vo cv vt cv cT cS cin cin wceq vo cv vt cv cS cin
      wceq cJ ctop wcel cS cT wss cT cX wss w3a vt cv cJ wcel wa vt cv cT cS
      cin cin vt cv cS cin vo cv cJ ctop wcel cS cT wss cT cX wss w3a vt cv cT
      cS cin cin vt cv cS cin wceq vt cv cJ wcel cJ ctop wcel cS cT wss cT cX
      wss w3a cT cS cin cS vt cv cS cT wss cJ ctop wcel cT cS cin cS wceq cT cX
      wss cS cT wss cS cT cin cS cT cS cin cS cT wss cS cT cin cS wceq cS cT
      df-ss biimpi cT cS incom syl5eq 3ad2ant2 ineq2d adantr eqeq2d biimpar vt
      cv cT cS inass syl6eqr sylanc ex r19.23adva impbid cT cJ cop csubsp cfv
      ctop wcel cS cvv wcel vo cv cS cT cJ cop csubsp cfv cop csubsp cfv wcel
      vo cv vs cv cS cin wceq vs cT cJ cop csubsp cfv wrex wb cJ ctop wcel cS
      cT wss cT cX wss w3a cT cJ cop csubsp cfv ctop wcel vo cv cvv wcel cS cvv
      wcel vo cv cS cT cJ cop csubsp cfv cop csubsp cfv wcel vo cv vs cv cS cin
      wceq vs cT cJ cop csubsp cfv wrex wb vo visset vs vo cv cS cvv cT cJ cop
      csubsp cfv issubspt mp3an2 cJ ctop wcel cT cX wss cT cJ cop csubsp cfv
      ctop wcel cS cT wss cJ ctop wcel cT cJ cuni wss cT cJ cop csubsp cfv ctop
      wcel cT cX wss cT cJ stoig3 cX cJ cuni cT subsubtop.1 sseq2i sylan2b
      3adant2 cJ ctop wcel cS cT wss cT cX wss cS cvv wcel cJ cuni cvv wcel cS
      cJ cuni wss cS cvv wcel cJ ctop wcel cS cT wss cT cX wss wa cS cJ cuni
      wss cJ cuni cvv wcel cS cvv wcel cS cJ cuni cvv ssexg ancoms cJ ctop
      uniexg cS cT wss cT cX wss wa cS cX cJ cuni cS cT cX sstr subsubtop.1
      syl6ss syl2an 3impb sylanc cJ ctop wcel cS cvv wcel vo cv cS cJ cop
      csubsp cfv wcel vo cv vt cv cS cin wceq vt cJ wrex wb cJ ctop wcel cS cT
      wss cT cX wss w3a cJ ctop wcel vo cv cvv wcel cS cvv wcel vo cv cS cJ cop
      csubsp cfv wcel vo cv vt cv cS cin wceq vt cJ wrex wb vo visset vt vo cv
      cS cvv cJ issubspt mp3an2 cJ ctop wcel cS cT wss cT cX wss 3simp1 cJ ctop
      wcel cS cT wss cT cX wss cS cvv wcel cJ cuni cvv wcel cS cJ cuni wss cS
      cvv wcel cJ ctop wcel cS cT wss cT cX wss wa cS cJ cuni wss cJ cuni cvv
      wcel cS cvv wcel cS cJ cuni cvv ssexg ancoms cJ ctop uniexg cS cT wss cT
      cX wss wa cS cX cJ cuni cS cT cX sstr subsubtop.1 syl6ss syl2an 3impb
      sylanc 3bitr4d eqrdv $.
      $( [11-Jul-2009] $) $( [11-Jul-2009] $)
  $}

  ${
    $d x J $. $d x K $. $d x S $. $d x X $. $d x Y $.
    subcls.1 $e |- X = U. J $.
    subcls.2 $e |- K = ( subSp ` <. Y , J >. ) $.
    $( A closure in a subspace topology. $)
    subcls $p |- ( ( J e. Top /\ Y C_ X /\ S C_ Y ) -> ( ( cls ` K ) ` S ) = (
    ( ( cls ` J ) ` S ) i^i Y ) ) $=
      cJ ctop wcel cY cX wss cS cY wss w3a cS cK ccl cfv cfv cS cJ ccl cfv cfv
      cY cin cK ctop wcel cS cJ ccl cfv cfv cY cin cK ccld cfv wcel cS cS cJ
      ccl cfv cfv cY cin wss cS cK ccl cfv cfv cS cJ ccl cfv cfv cY cin wss cJ
      ctop wcel cY cX wss cS cY wss w3a cS cJ ccl cfv cfv cY cin cS cK cK cuni
      cK cuni eqid clsss2 cJ ctop wcel cY cX wss cK ctop wcel cS cY wss cJ ctop
      wcel cY cX wss wa cY cJ cop csubsp cfv ctop cK cJ ctop wcel cY cJ cuni
      wss cY cJ cop csubsp cfv ctop wcel cY cX wss cY cJ stoig3 cX cJ cuni cY
      subcls.1 sseq2i sylan2b subcls.2 syl5eqel 3adant3 cJ ctop wcel cY cX wss
      cS cY wss w3a cS cJ ccl cfv cfv cY cin cK ccld cfv wcel cS cJ ccl cfv cfv
      cY cin vx cv cY cin wceq vx cJ ccld cfv wrex cJ ctop wcel cY cX wss cS cY
      wss w3a cS cJ ccl cfv cfv cJ ccld cfv wcel cS cJ ccl cfv cfv cY cin vx cv
      cY cin wceq vx cJ ccld cfv wrex cJ ctop wcel cS cX wss cS cJ ccl cfv cfv
      cJ ccld cfv wcel cJ ctop wcel cY cX wss cS cY wss w3a cS cJ cX subcls.1
      clscld cJ ctop wcel cY cX wss cS cY wss 3simp1 cY cX wss cS cY wss cS cX
      wss cJ ctop wcel cS cY wss cY cX wss cS cX wss cS cY cX sstr ancoms
      3adant1 sylanc cS cJ ccl cfv cfv cJ ccld cfv wcel cS cJ ccl cfv cfv cY
      cin cS cJ ccl cfv cfv cY cin wceq cS cJ ccl cfv cfv cY cin vx cv cY cin
      wceq vx cJ ccld cfv wrex cS cJ ccl cfv cfv cY cin eqid cS cJ ccl cfv cfv
      cY cin vx cv cY cin wceq cS cJ ccl cfv cfv cY cin cS cJ ccl cfv cfv cY
      cin wceq vx cS cJ ccl cfv cfv cJ ccld cfv vx cv cS cJ ccl cfv cfv wceq vx
      cv cY cin cS cJ ccl cfv cfv cY cin cS cJ ccl cfv cfv cY cin vx cv cS cJ
      ccl cfv cfv cY ineq1 eqeq2d rcla4ev mpan2 syl cJ ctop wcel cY cX wss cS
      cY wss w3a cS cJ ccl cfv cfv cY cin cY cJ cop csubsp cfv ccld cfv wcel cS
      cJ ccl cfv cfv cY cin vx cv cY cin wceq vx cJ ccld cfv wrex cS cJ ccl cfv
      cfv cY cin cK ccld cfv wcel cJ ctop wcel cY cX wss cS cJ ccl cfv cfv cY
      cin cY cJ cop csubsp cfv ccld cfv wcel cS cJ ccl cfv cfv cY cin vx cv cY
      cin wceq vx cJ ccld cfv wrex wb cS cY wss vx cS cJ ccl cfv cfv cY cin cY
      cJ cX subcls.1 subcld 3adant3 cK ccld cfv cY cJ cop csubsp cfv ccld cfv
      cS cJ ccl cfv cfv cY cin cK cY cJ cop csubsp cfv ccld subcls.2 fveq2i
      eleq2i syl5bb mpbird cJ ctop wcel cY cX wss cS cY wss w3a cS cS cJ ccl
      cfv cfv wss cS cY wss wa cS cS cJ ccl cfv cfv cY cin wss cJ ctop wcel cY
      cX wss cS cY wss w3a cS cS cJ ccl cfv cfv wss cS cY wss cJ ctop wcel cS
      cX wss cS cS cJ ccl cfv cfv wss cJ ctop wcel cY cX wss cS cY wss w3a cS
      cJ cX subcls.1 sscls cJ ctop wcel cY cX wss cS cY wss 3simp1 cY cX wss cS
      cY wss cS cX wss cJ ctop wcel cS cY wss cY cX wss cS cX wss cS cY cX sstr
      ancoms 3adant1 sylanc cJ ctop wcel cY cX wss cS cY wss 3simp3 jca cS cS
      cJ ccl cfv cfv cY ssin sylib syl3anc cJ ctop wcel cY cX wss cS cY wss w3a
      cS cK ccl cfv cfv vx cv cY cin wceq vx cJ ccld cfv wrex cS cJ ccl cfv cfv
      cY cin cS cK ccl cfv cfv wss cJ ctop wcel cY cX wss cS cY wss w3a cS cK
      ccl cfv cfv cY cJ cop csubsp cfv ccld cfv wcel cS cK ccl cfv cfv vx cv cY
      cin wceq vx cJ ccld cfv wrex cJ ctop wcel cY cX wss cS cY wss w3a cS cY
      cJ cop csubsp cfv ccl cfv cfv cY cJ cop csubsp cfv ccld cfv cS cK ccl cfv
      cfv cY cJ cop csubsp cfv ctop wcel cS cY cJ cop csubsp cfv cuni wss cS cY
      cJ cop csubsp cfv ccl cfv cfv cY cJ cop csubsp cfv ccld cfv wcel cJ ctop
      wcel cY cX wss cS cY wss w3a cS cY cJ cop csubsp cfv cY cJ cop csubsp cfv
      cuni cY cJ cop csubsp cfv cuni eqid clscld cJ ctop wcel cY cX wss cY cJ
      cop csubsp cfv ctop wcel cS cY wss cJ ctop wcel cY cJ cuni wss cY cJ cop
      csubsp cfv ctop wcel cY cX wss cY cJ stoig3 cX cJ cuni cY subcls.1 sseq2i
      sylan2b 3adant3 cJ ctop wcel cY cX wss cS cY wss w3a cS cY cY cJ cop
      csubsp cfv cuni cJ ctop wcel cY cX wss cS cY wss 3simp3 cJ ctop wcel cY
      cX wss cY cJ cop csubsp cfv cuni cY wceq cS cY wss cJ ctop wcel cY cJ
      cuni wss cY cJ cop csubsp cfv cuni cY wceq cY cX wss cY cJ stoig2 cX cJ
      cuni cY subcls.1 sseq2i sylan2b 3adant3 sseqtr4d sylanc cS cK ccl cfv cY
      cJ cop csubsp cfv ccl cfv cK cY cJ cop csubsp cfv ccl subcls.2 fveq2i
      fveq1i syl5eqel cJ ctop wcel cY cX wss cS cK ccl cfv cfv cY cJ cop csubsp
      cfv ccld cfv wcel cS cK ccl cfv cfv vx cv cY cin wceq vx cJ ccld cfv wrex
      wb cS cY wss vx cS cK ccl cfv cfv cY cJ cX subcls.1 subcld 3adant3 mpbid
      cJ ctop wcel cY cX wss cS cY wss w3a cS cK ccl cfv cfv vx cv cY cin wceq
      cS cJ ccl cfv cfv cY cin cS cK ccl cfv cfv wss vx cJ ccld cfv cJ ctop
      wcel cY cX wss cS cY wss w3a vx cv cJ ccld cfv wcel cS cK ccl cfv cfv vx
      cv cY cin wceq cS cJ ccl cfv cfv cY cin cS cK ccl cfv cfv wss cJ ctop
      wcel cY cX wss cS cY wss w3a vx cv cJ ccld cfv wcel cS cK ccl cfv cfv vx
      cv cY cin wceq wa wa cS vx cv wss cS cJ ccl cfv cfv cY cin cS cK ccl cfv
      cfv wss cJ ctop wcel cY cX wss cS cY wss w3a vx cv cJ ccld cfv wcel cS cK
      ccl cfv cfv vx cv cY cin wceq wa wa cS cS cK ccl cfv cfv vx cv cJ ctop
      wcel cY cX wss cS cY wss w3a cS cS cK ccl cfv cfv wss vx cv cJ ccld cfv
      wcel cS cK ccl cfv cfv vx cv cY cin wceq wa cK ctop wcel cS cY cJ cop
      csubsp cfv cuni wss cS cS cK ccl cfv cfv wss cJ ctop wcel cY cX wss cS cY
      wss w3a cS cK cY cJ cop csubsp cfv cuni cK cuni cY cJ cop csubsp cfv cuni
      cK cY cJ cop csubsp cfv subcls.2 unieqi eqcomi sscls cJ ctop wcel cY cX
      wss cK ctop wcel cS cY wss cJ ctop wcel cY cX wss wa cY cJ cop csubsp cfv
      ctop cK cJ ctop wcel cY cJ cuni wss cY cJ cop csubsp cfv ctop wcel cY cX
      wss cY cJ stoig3 cX cJ cuni cY subcls.1 sseq2i sylan2b subcls.2 syl5eqel
      3adant3 cJ ctop wcel cY cX wss cS cY wss w3a cS cY cY cJ cop csubsp cfv
      cuni cJ ctop wcel cY cX wss cS cY wss 3simp3 cJ ctop wcel cY cX wss cY cJ
      cop csubsp cfv cuni cY wceq cS cY wss cJ ctop wcel cY cJ cuni wss cY cJ
      cop csubsp cfv cuni cY wceq cY cX wss cY cJ stoig2 cX cJ cuni cY subcls.1
      sseq2i sylan2b 3adant3 sseqtr4d sylanc adantr cS cK ccl cfv cfv vx cv cY
      cin wceq cS cK ccl cfv cfv vx cv wss cJ ctop wcel cY cX wss cS cY wss w3a
      vx cv cJ ccld cfv wcel cS cK ccl cfv cfv vx cv cY cin wceq cS cK ccl cfv
      cfv vx cv wss vx cv cY cin vx cv wss vx cv cY inss1 cS cK ccl cfv cfv vx
      cv cY cin vx cv sseq1 mpbiri ad2antll sstrd cJ ctop wcel cY cX wss cS cY
      wss w3a vx cv cJ ccld cfv wcel cS cK ccl cfv cfv vx cv cY cin wceq cS vx
      cv wss cS cJ ccl cfv cfv cY cin cS cK ccl cfv cfv wss wi cJ ctop wcel cY
      cX wss cS cY wss w3a vx cv cJ ccld cfv wcel wa cS vx cv wss cS cK ccl cfv
      cfv vx cv cY cin wceq cS cJ ccl cfv cfv cY cin cS cK ccl cfv cfv wss cJ
      ctop wcel cY cX wss cS cY wss w3a vx cv cJ ccld cfv wcel cS vx cv wss cS
      cK ccl cfv cfv vx cv cY cin wceq cS cJ ccl cfv cfv cY cin cS cK ccl cfv
      cfv wss wi cS cK ccl cfv cfv vx cv cY cin wceq cS cJ ccl cfv cfv cY cin
      cS cK ccl cfv cfv wss cS cJ ccl cfv cfv cY cin vx cv cY cin wss cJ ctop
      wcel cY cX wss cS cY wss w3a vx cv cJ ccld cfv wcel cS vx cv wss wa wa cS
      cK ccl cfv cfv vx cv cY cin cS cJ ccl cfv cfv cY cin sseq2 cJ ctop wcel
      cY cX wss cS cY wss w3a vx cv cJ ccld cfv wcel cS vx cv wss wa wa cS cJ
      ccl cfv cfv vx cv wss cS cJ ccl cfv cfv cY cin vx cv cY cin wss cJ ctop
      wcel cY cX wss vx cv cJ ccld cfv wcel cS vx cv wss wa cS cJ ccl cfv cfv
      vx cv wss cS cY wss cJ ctop wcel vx cv cJ ccld cfv wcel cS vx cv wss cS
      cJ ccl cfv cfv vx cv wss vx cv cS cJ cX subcls.1 clsss2 3expb 3ad2antl1
      cS cJ ccl cfv cfv vx cv cY ssrin syl syl5cbir expr com23 impr mpd exp32
      r19.23adv mpd eqssd $.
      $( [22-Jan-2010] $) $( [22-Jan-2010] $)
  $}

  ${
    $d o x J $. $d o x K $. $d o x S $. $d o x X $. $d o x Y $.
    subntr.1 $e |- X = U. J $.
    subntr.2 $e |- K = ( subSp ` <. Y , J >. ) $.
    $( An interior in a subspace topology. Willard in _General Topology_ says
       that there is no analog of ~ subcls for interiors. In some sense, that
       is true. $)
    subntr $p |- ( ( J e. Top /\ Y C_ X /\ S C_ Y ) -> ( ( int ` K ) ` S ) = (
    ( ( int ` J ) ` ( S u. ( X \ Y ) ) ) i^i Y ) ) $=
      cJ ctop wcel cY cX wss cS cY wss w3a cS cK cnt cfv cfv cS cX cY cdif cun
      cJ cnt cfv cfv cY cin cJ ctop wcel cY cX wss cS cY wss w3a cS cK cnt cfv
      cfv vo cv cY cin wceq vo cJ wrex cS cK cnt cfv cfv cS cX cY cdif cun cJ
      cnt cfv cfv cY cin wss cJ ctop wcel cY cX wss cS cY wss w3a cS cK cnt cfv
      cfv cY cJ cop csubsp cfv wcel cS cK cnt cfv cfv vo cv cY cin wceq vo cJ
      wrex cJ ctop wcel cY cX wss cS cY wss w3a cS cY cJ cop csubsp cfv cnt cfv
      cfv cY cJ cop csubsp cfv cS cK cnt cfv cfv cY cJ cop csubsp cfv ctop wcel
      cS cY cJ cop csubsp cfv cuni wss cS cY cJ cop csubsp cfv cnt cfv cfv cY
      cJ cop csubsp cfv wcel cJ ctop wcel cY cX wss cS cY wss w3a cS cY cJ cop
      csubsp cfv cY cJ cop csubsp cfv cuni cY cJ cop csubsp cfv cuni eqid
      ntropn cJ ctop wcel cY cX wss cY cJ cop csubsp cfv ctop wcel cS cY wss cJ
      ctop wcel cY cJ cuni wss cY cJ cop csubsp cfv ctop wcel cY cX wss cY cJ
      stoig3 cX cJ cuni cY subntr.1 sseq2i sylan2b 3adant3 cJ ctop wcel cY cX
      wss cS cY cJ cop csubsp cfv cuni wss cS cY wss cJ ctop wcel cY cX wss wa
      cY cJ cop csubsp cfv cuni cY cS cJ ctop wcel cY cJ cuni wss cY cJ cop
      csubsp cfv cuni cY wceq cY cX wss cY cJ stoig2 cX cJ cuni cY subntr.1
      sseq2i sylan2b sseq2d biimp3ar sylanc cS cK cnt cfv cY cJ cop csubsp cfv
      cnt cfv cK cY cJ cop csubsp cfv cnt subntr.2 fveq2i fveq1i syl5eqel cJ
      ctop wcel cS cK cnt cfv cfv cvv wcel cY cvv wcel cS cK cnt cfv cfv cY cJ
      cop csubsp cfv wcel cS cK cnt cfv cfv vo cv cY cin wceq vo cJ wrex wb cJ
      ctop wcel cY cX wss cS cY wss w3a vo cS cK cnt cfv cfv cY cvv cJ issubspt
      cJ ctop wcel cY cX wss cS cY wss 3simp1 cS cK cnt cfv cfv cvv wcel cJ
      ctop wcel cY cX wss cS cY wss w3a cS cK cnt cfv fvex a1i cJ ctop wcel cY
      cX wss cY cvv wcel cS cY wss cY cX wss cJ ctop wcel cY cvv wcel cY cX wss
      cX cvv wcel cY cvv wcel cJ ctop wcel cY cX cvv ssexg cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg subntr.1 syl5eqel sylan2 ancoms 3adant3 syl3anc
      mpbid cJ ctop wcel cY cX wss cS cY wss w3a cS cK cnt cfv cfv vo cv cY cin
      wceq cS cK cnt cfv cfv cS cX cY cdif cun cJ cnt cfv cfv cY cin wss vo cJ
      cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv cfv vo
      cv cY cin wceq cS cK cnt cfv cfv cS cX cY cdif cun cJ cnt cfv cfv cY cin
      wss cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv cfv
      vo cv cY cin wceq wa wa vo cv cS cX cY cdif cun wss cS cK cnt cfv cfv cS
      cX cY cdif cun cJ cnt cfv cfv cY cin wss cJ ctop wcel cY cX wss cS cY wss
      w3a vo cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa vo cv cS cK
      cnt cfv cfv cX cY cdif cun cS cX cY cdif cun cJ ctop wcel cY cX wss cS cY
      wss w3a vo cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa vx vo cv
      cS cK cnt cfv cfv cX cY cdif cun cJ ctop wcel cY cX wss cS cY wss w3a vo
      cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa vx cv vo cv wcel vx
      cv cY wcel vx cv cX cY cdif wcel wo vx cv cS cK cnt cfv cfv cX cY cdif
      cun wcel cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv
      cfv vo cv cY cin wceq wa wa vx cv vo cv wcel vx cv cX wcel vx cv cY wcel
      vx cv cX cY cdif wcel wo cJ ctop wcel cY cX wss vo cv cJ wcel cS cK cnt
      cfv cfv vo cv cY cin wceq wa vx cv vo cv wcel vx cv cX wcel wi cS cY wss
      cJ ctop wcel vo cv cJ wcel vx cv vo cv wcel vx cv cX wcel wi cS cK cnt
      cfv cfv vo cv cY cin wceq cJ ctop wcel vo cv cJ wcel wa vo cv cX vx cv vo
      cv cJ cX subntr.1 eltopss sseld adantrr 3ad2antl1 vx cv cX wcel vx cv cY
      wcel vx cv cX cY cdif wcel vx cv cX wcel vx cv cY wcel wn vx cv cX cY
      cdif wcel vx cv cX cY cdif wcel vx cv cX wcel vx cv cY wcel wn wa vx cv
      cX cY eldif biimpri ex orrd syl6 cJ ctop wcel cY cX wss cS cY wss w3a vo
      cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa vx cv vo cv wcel vx
      cv cY wcel vx cv cX cY cdif wcel wo vx cv cS cK cnt cfv cfv cX cY cdif
      cun wcel wi cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt
      cfv cfv vo cv cY cin wceq wa wa vx cv vo cv wcel wa vx cv cY wcel vx cv
      cS cK cnt cfv cfv cX cY cdif cun wcel vx cv cX cY cdif wcel cJ ctop wcel
      cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq
      wa wa vx cv vo cv wcel vx cv cY wcel vx cv cS cK cnt cfv cfv cX cY cdif
      cun wcel cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv
      cfv vo cv cY cin wceq wa wa vx cv vo cv cY cin wcel vx cv cS cK cnt cfv
      cfv cX cY cdif cun wcel vx cv vo cv wcel vx cv cY wcel wa cS cK cnt cfv
      cfv vo cv cY cin wceq vx cv vo cv cY cin wcel vx cv cS cK cnt cfv cfv cX
      cY cdif cun wcel wi cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS
      cK cnt cfv cfv vo cv cY cin wceq vx cv vo cv cY cin wcel vx cv cS cK cnt
      cfv cfv wcel vx cv cS cK cnt cfv cfv cX cY cdif cun wcel cS cK cnt cfv
      cfv vo cv cY cin vx cv eleq2 vx cv cS cK cnt cfv cfv cX cY cdif elun1
      syl6bir ad2antll vx cv vo cv cY elin syl5ibr expdimp vx cv cX cY cdif
      wcel vx cv cS cK cnt cfv cfv cX cY cdif cun wcel wi cJ ctop wcel cY cX
      wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa
      vx cv vo cv wcel wa vx cv cX cY cdif cS cK cnt cfv cfv elun2 a1i jaod ex
      mpdd ssrdv cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt
      cfv cfv vo cv cY cin wceq wa wa cS cK cnt cfv cfv cS wss cS cK cnt cfv
      cfv cX cY cdif cun cS cX cY cdif cun wss cK ctop wcel cS cY cJ cop csubsp
      cfv cuni wss cS cK cnt cfv cfv cS wss cJ ctop wcel cY cX wss cS cY wss
      w3a vo cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa cS cK cY cJ
      cop csubsp cfv cuni cK cuni cY cJ cop csubsp cfv cuni cK cY cJ cop csubsp
      cfv subntr.2 unieqi eqcomi ntrss2 cJ ctop wcel cY cX wss cS cY wss w3a vo
      cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa wa cY cJ cop csubsp cfv
      ctop cK cJ ctop wcel cY cX wss cS cY wss w3a cY cJ cop csubsp cfv ctop
      wcel vo cv cJ wcel cS cK cnt cfv cfv vo cv cY cin wceq wa cJ ctop wcel cY
      cX wss cY cJ cop csubsp cfv ctop wcel cS cY wss cJ ctop wcel cY cJ cuni
      wss cY cJ cop csubsp cfv ctop wcel cY cX wss cY cJ stoig3 cX cJ cuni cY
      subntr.1 sseq2i sylan2b 3adant3 adantr subntr.2 syl5eqel cJ ctop wcel cY
      cX wss cS cY wss w3a cS cY cJ cop csubsp cfv cuni wss vo cv cJ wcel cS cK
      cnt cfv cfv vo cv cY cin wceq wa cJ ctop wcel cY cX wss cS cY cJ cop
      csubsp cfv cuni wss cS cY wss cJ ctop wcel cY cX wss wa cY cJ cop csubsp
      cfv cuni cY cS cJ ctop wcel cY cJ cuni wss cY cJ cop csubsp cfv cuni cY
      wceq cY cX wss cY cJ stoig2 cX cJ cuni cY subntr.1 sseq2i sylan2b sseq2d
      biimp3ar adantr sylanc cS cK cnt cfv cfv cS cX cY cdif unss1 syl sstrd cJ
      ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel cS cK cnt cfv cfv vo cv
      cY cin wceq vo cv cS cX cY cdif cun wss cS cK cnt cfv cfv cS cX cY cdif
      cun cJ cnt cfv cfv cY cin wss wi cJ ctop wcel cY cX wss cS cY wss w3a vo
      cv cJ wcel wa vo cv cS cX cY cdif cun wss cS cK cnt cfv cfv vo cv cY cin
      wceq cS cK cnt cfv cfv cS cX cY cdif cun cJ cnt cfv cfv cY cin wss cJ
      ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel vo cv cS cX cY cdif cun
      wss cS cK cnt cfv cfv vo cv cY cin wceq cS cK cnt cfv cfv cS cX cY cdif
      cun cJ cnt cfv cfv cY cin wss wi cS cK cnt cfv cfv vo cv cY cin wceq cS
      cK cnt cfv cfv cS cX cY cdif cun cJ cnt cfv cfv cY cin wss vo cv cY cin
      cS cX cY cdif cun cJ cnt cfv cfv cY cin wss cJ ctop wcel cY cX wss cS cY
      wss w3a vo cv cJ wcel vo cv cS cX cY cdif cun wss wa wa cS cK cnt cfv cfv
      vo cv cY cin cS cX cY cdif cun cJ cnt cfv cfv cY cin sseq1 cJ ctop wcel
      cY cX wss cS cY wss w3a vo cv cJ wcel vo cv cS cX cY cdif cun wss wa wa
      vo cv cS cX cY cdif cun cJ cnt cfv cfv wss vo cv cY cin cS cX cY cdif cun
      cJ cnt cfv cfv cY cin wss cJ ctop wcel cS cX cY cdif cun cX wss vo cv cJ
      wcel vo cv cS cX cY cdif cun wss vo cv cS cX cY cdif cun cJ cnt cfv cfv
      wss cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel vo cv cS cX cY
      cdif cun wss wa wa cS cX cY cdif cun cJ vo cv cX subntr.1 ssntr cJ ctop
      wcel cY cX wss cS cY wss vo cv cJ wcel vo cv cS cX cY cdif cun wss wa
      3simpl1 cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel vo cv cS cX cY
      cdif cun wss wa wa cS cX wss cX cY cdif cX wss wa cS cX cY cdif cun cX
      wss cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel vo cv cS cX cY
      cdif cun wss wa wa cS cX wss cX cY cdif cX wss cJ ctop wcel cY cX wss cS
      cY wss w3a cS cX wss vo cv cJ wcel vo cv cS cX cY cdif cun wss wa cY cX
      wss cS cY wss cS cX wss cJ ctop wcel cS cY wss cY cX wss cS cX wss cS cY
      cX sstr ancoms 3adant1 adantr cX cY difss jctir cS cX cY cdif cX unss
      sylib cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel vo cv cS cX cY
      cdif cun wss simprl cJ ctop wcel cY cX wss cS cY wss w3a vo cv cJ wcel vo
      cv cS cX cY cdif cun wss simprr syl2anc vo cv cS cX cY cdif cun cJ cnt
      cfv cfv cY ssrin syl syl5cbir expr com23 impr mpd exp32 r19.23adv mpd cK
      ctop wcel cS cY cJ cop csubsp cfv cuni wss cS cX cY cdif cun cJ cnt cfv
      cfv cY cin cK wcel cS cX cY cdif cun cJ cnt cfv cfv cY cin cS wss cS cX
      cY cdif cun cJ cnt cfv cfv cY cin cS cK cnt cfv cfv wss cJ ctop wcel cY
      cX wss cS cY wss w3a cS cK cS cX cY cdif cun cJ cnt cfv cfv cY cin cY cJ
      cop csubsp cfv cuni cK cuni cY cJ cop csubsp cfv cuni cK cY cJ cop csubsp
      cfv subntr.2 unieqi eqcomi ssntr cJ ctop wcel cY cX wss cS cY wss w3a cY
      cJ cop csubsp cfv ctop cK cJ ctop wcel cY cX wss cY cJ cop csubsp cfv
      ctop wcel cS cY wss cJ ctop wcel cY cJ cuni wss cY cJ cop csubsp cfv ctop
      wcel cY cX wss cY cJ stoig3 cX cJ cuni cY subntr.1 sseq2i sylan2b 3adant3
      subntr.2 syl5eqel cJ ctop wcel cY cX wss cS cY cJ cop csubsp cfv cuni wss
      cS cY wss cJ ctop wcel cY cX wss wa cY cJ cop csubsp cfv cuni cY cS cJ
      ctop wcel cY cJ cuni wss cY cJ cop csubsp cfv cuni cY wceq cY cX wss cY
      cJ stoig2 cX cJ cuni cY subntr.1 sseq2i sylan2b sseq2d biimp3ar cJ ctop
      wcel cY cX wss cS cY wss w3a cS cX cY cdif cun cJ cnt cfv cfv cY cin cY
      cJ cop csubsp cfv cK cJ ctop wcel cY cX wss cS cX cY cdif cun cJ cnt cfv
      cfv cJ wcel cS cX cY cdif cun cJ cnt cfv cfv cY cin cS cX cY cdif cun cJ
      cnt cfv cfv cY cin wceq cS cX cY cdif cun cJ cnt cfv cfv cY cin cY cJ cop
      csubsp cfv wcel cJ ctop wcel cY cX wss cS cY wss w3a cS cX cY cdif cun cJ
      cnt cfv cfv cS cX cY cdif cun cJ cnt cfv cfv cY cin cY cJ cX subntr.1
      elsubsp cJ ctop wcel cY cX wss cS cY wss 3simp1 cJ ctop wcel cY cX wss cS
      cY wss 3simp2 cJ ctop wcel cS cX cY cdif cun cX wss cS cX cY cdif cun cJ
      cnt cfv cfv cJ wcel cJ ctop wcel cY cX wss cS cY wss w3a cS cX cY cdif
      cun cJ cX subntr.1 ntropn cJ ctop wcel cY cX wss cS cY wss 3simp1 cJ ctop
      wcel cY cX wss cS cY wss w3a cS cX wss cX cY cdif cX wss wa cS cX cY cdif
      cun cX wss cJ ctop wcel cY cX wss cS cY wss w3a cS cX wss cX cY cdif cX
      wss cY cX wss cS cY wss cS cX wss cJ ctop wcel cS cY wss cY cX wss cS cX
      wss cS cY cX sstr ancoms 3adant1 cX cY difss jctir cS cX cY cdif cX unss
      sylib sylanc cJ ctop wcel cY cX wss cS cY wss w3a cS cX cY cdif cun cJ
      cnt cfv cfv cY cin eqidd syl2anc subntr.2 syl6eleqr cJ ctop wcel cY cX
      wss cS cY wss w3a cS cX cY cdif cun cJ cnt cfv cfv cY cin cS cX cY cdif
      cun cY cin cS cJ ctop wcel cY cX wss cS cY wss w3a cS cX cY cdif cun cJ
      cnt cfv cfv cS cX cY cdif cun wss cS cX cY cdif cun cJ cnt cfv cfv cY cin
      cS cX cY cdif cun cY cin wss cJ ctop wcel cS cX cY cdif cun cX wss cS cX
      cY cdif cun cJ cnt cfv cfv cS cX cY cdif cun wss cJ ctop wcel cY cX wss
      cS cY wss w3a cS cX cY cdif cun cJ cX subntr.1 ntrss2 cJ ctop wcel cY cX
      wss cS cY wss 3simp1 cJ ctop wcel cY cX wss cS cY wss w3a cS cX wss cX cY
      cdif cX wss wa cS cX cY cdif cun cX wss cJ ctop wcel cY cX wss cS cY wss
      w3a cS cX wss cX cY cdif cX wss cY cX wss cS cY wss cS cX wss cJ ctop
      wcel cS cY wss cY cX wss cS cX wss cS cY cX sstr ancoms 3adant1 cX cY
      difss jctir cS cX cY cdif cX unss sylib sylanc cS cX cY cdif cun cJ cnt
      cfv cfv cS cX cY cdif cun cY ssrin syl cJ ctop wcel cY cX wss cS cY wss
      w3a vx cS cX cY cdif cun cY cin cS cJ ctop wcel cY cX wss cS cY wss w3a
      vx cv cX cY cdif wcel wn vx cv cS wcel wi vx cv cY wcel wa vx cv cS wcel
      vx cv cS cX cY cdif cun cY cin wcel vx cv cX cY cdif wcel wn vx cv cS
      wcel wi vx cv cY wcel wa vx cv cS wcel wi cJ ctop wcel cY cX wss cS cY
      wss w3a vx cv cY wcel vx cv cX cY cdif wcel wn vx cv cS wcel wi vx cv cS
      wcel vx cv cY wcel vx cv cX cY cdif wcel wn vx cv cX cY cdif wcel wn vx
      cv cS wcel wi vx cv cS wcel wi vx cv cY cX elndif vx cv cX cY cdif wcel
      wn vx cv cS wcel pm2.27 syl impcom a1i vx cv cS cX cY cdif cun cY cin
      wcel vx cv cS cX cY cdif cun wcel vx cv cY wcel wa vx cv cX cY cdif wcel
      wn vx cv cS wcel wi vx cv cY wcel wa vx cv cS cX cY cdif cun cY elin vx
      cv cS cX cY cdif cun wcel vx cv cX cY cdif wcel wn vx cv cS wcel wi vx cv
      cY wcel vx cv cS cX cY cdif cun wcel vx cv cS wcel vx cv cX cY cdif wcel
      wo vx cv cX cY cdif wcel vx cv cS wcel wo vx cv cX cY cdif wcel wn vx cv
      cS wcel wi vx cv cS cX cY cdif elun vx cv cS wcel vx cv cX cY cdif wcel
      orcom vx cv cX cY cdif wcel vx cv cS wcel df-or 3bitri anbi1i bitri
      syl5ib ssrdv sstrd syl2anc eqssd $.
      $( [23-Jan-2010] $) $( [23-Jan-2010] $)
  $}

  ${
    $d o s t A $. $d o s t F $. $d o s t J $. $d o s t K $. $d o s t X $.
    cnsubsp.1 $e |- X = U. J $.
    $( Continuity of a restriction from a subspace. $)
    cnsubsp $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( A C_ X /\ F e. ( J Cn K ) )
    ) -> ( F |` A ) e. ( ( subSp ` <. A , J >. ) Cn K ) ) $=
      cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co wcel wa wa cF cA
      cres cA cJ cop csubsp cfv cK ccn co wcel cA cJ cop csubsp cfv cuni cK
      cuni cF cA cres wf cF cA cres ccnv vo cv cima cA cJ cop csubsp cfv wcel
      vo cK wral wa cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co wcel
      wa wa cA cJ cop csubsp cfv cuni cK cuni cF cA cres wf cF cA cres ccnv vo
      cv cima cA cJ cop csubsp cfv wcel vo cK wral cJ ctop wcel cK ctop wcel wa
      cA cX wss cF cJ cK ccn co wcel wa wa cA cJ cop csubsp cfv cuni cK cuni cF
      cA cres wf cA cK cuni cF cA cres wf cJ ctop wcel cK ctop wcel wa cA cX
      wss cF cJ cK ccn co wcel wa wa cF cA cres wfun cF cA cres cdm cA wceq wa
      cF cA cres crn cK cuni wss wa cA cK cuni cF cA cres wf cJ ctop wcel cK
      ctop wcel wa cA cX wss cF cJ cK ccn co wcel wa wa cF cA cres wfun cF cA
      cres cdm cA wceq wa cF cA cres crn cK cuni wss cJ ctop wcel cK ctop wcel
      wa cA cX wss cF cJ cK ccn co wcel wa wa cF cA cres wfun cF cA cres cdm cA
      wceq cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cF cA cres wfun cA
      cX wss cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cF cA cres wfun cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cX cK cuni cF wf cF wfun
      cF cA cres wfun cF cJ cK cX cK cuni cnsubsp.1 cK cuni eqid cnf cX cK cuni
      cF ffun cA cF funres 3syl 3expa adantrl cJ ctop wcel cK ctop wcel wa cA
      cX wss cF cJ cK ccn co wcel wa wa cA cF cdm wss cF cA cres cdm cA wceq cJ
      ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co wcel wa wa cA cX cF
      cdm cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co wcel simprl cJ
      ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cF cdm cX wceq cA cX wss
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel wa cX cK cuni cF wf cF
      cdm cX wceq cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cX cK cuni cF
      wf cF cJ cK cX cK cuni cnsubsp.1 cK cuni eqid cnf 3expa cX cK cuni cF fdm
      syl adantrl sseqtr4d cA cF ssdmres sylib jca cJ ctop wcel cK ctop wcel wa
      cA cX wss cF cJ cK ccn co wcel wa wa cF cA cres crn cF crn cK cuni cF cA
      cres crn cF crn wss cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn
      co wcel wa wa cF cA cres cF wss cF cA cres crn cF crn wss cF cA resss cF
      cA cres cF rnss ax-mp a1i cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co
      wcel cF crn cK cuni wss cA cX wss cJ ctop wcel cK ctop wcel cF cJ cK ccn
      co wcel cF crn cK cuni wss cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel
      w3a cX cK cuni cF wf cF crn cK cuni wss cF cJ cK cX cK cuni cnsubsp.1 cK
      cuni eqid cnf cX cK cuni cF frn syl 3expa adantrl sstrd jca cA cK cuni cF
      cA cres wf cF cA cres cA wfn cF cA cres crn cK cuni wss wa cF cA cres
      wfun cF cA cres cdm cA wceq wa cF cA cres crn cK cuni wss wa cA cK cuni
      cF cA cres df-f cF cA cres cA wfn cF cA cres wfun cF cA cres cdm cA wceq
      wa cF cA cres crn cK cuni wss cF cA cres cA df-fn anbi1i bitri sylibr cJ
      ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co wcel wa wa cA cJ cop
      csubsp cfv cuni cA wceq cA cJ cop csubsp cfv cuni cK cuni cF cA cres wf
      cA cK cuni cF cA cres wf wb cJ ctop wcel cA cJ cuni wss cA cJ cop csubsp
      cfv cuni cA wceq cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co
      wcel wa wa cA cJ stoig2 cJ ctop wcel cK ctop wcel cA cX wss cF cJ cK ccn
      co wcel wa simpll cA cX wss cA cJ cuni wss cJ ctop wcel cK ctop wcel wa
      cF cJ cK ccn co wcel cA cX wss cA cJ cuni wss cX cJ cuni cA cnsubsp.1
      sseq2i biimpi ad2antrl sylanc cA cJ cop csubsp cfv cuni cA cK cuni cF cA
      cres feq2 syl mpbird cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn
      co wcel wa wa cF cA cres ccnv vo cv cima cA cJ cop csubsp cfv wcel vo cK
      cJ ctop wcel cA cX wss cF ccnv vo cv cima cJ wcel cF cA cres ccnv vo cv
      cima cF ccnv vo cv cima cA cin wceq cF cA cres ccnv vo cv cima cA cJ cop
      csubsp cfv wcel cJ ctop wcel cK ctop wcel wa cA cX wss cF cJ cK ccn co
      wcel wa wa vo cv cK wcel wa cF ccnv vo cv cima cF cA cres ccnv vo cv cima
      cA cJ cX cnsubsp.1 elsubsp cJ ctop wcel cK ctop wcel wa cJ ctop wcel cA
      cX wss cF cJ cK ccn co wcel wa vo cv cK wcel cJ ctop wcel cK ctop wcel
      pm3.26 ad2antrr cA cX wss cF cJ cK ccn co wcel wa cA cX wss cJ ctop wcel
      cK ctop wcel wa vo cv cK wcel cA cX wss cF cJ cK ccn co wcel pm3.26
      ad2antlr cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel vo cv cK wcel
      cF ccnv vo cv cima cJ wcel cA cX wss cJ ctop wcel cK ctop wcel wa cF cJ
      cK ccn co wcel wa vo cv cK wcel cF ccnv vo cv cima cJ wcel cJ ctop wcel
      cK ctop wcel cF cJ cK ccn co wcel vo cv cK wcel cF ccnv vo cv cima cJ
      wcel wi cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a vo cv cK wcel
      cF ccnv vo cv cima cJ wcel vo cv cF cJ cK cnima ex 3expa imp adantlrl cF
      cA cres ccnv vo cv cima cF ccnv vo cv cima cA cin wceq cJ ctop wcel cK
      ctop wcel wa cA cX wss cF cJ cK ccn co wcel wa wa vo cv cK wcel wa cA vo
      cv cF cnvresima a1i syl2anc r19.21aiva jca cA cJ cop csubsp cfv ctop wcel
      cK ctop wcel cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cA cJ cop
      csubsp cfv cuni cK cuni cF cA cres wf cF cA cres ccnv vo cv cima cA cJ
      cop csubsp cfv wcel vo cK wral wa wb cJ ctop wcel cK ctop wcel wa cA cX
      wss cF cJ cK ccn co wcel wa wa vo cF cA cres cA cJ cop csubsp cfv cK cA
      cJ cop csubsp cfv cuni cK cuni cA cJ cop csubsp cfv cuni eqid cK cuni
      eqid iscn cJ ctop wcel cA cX wss cA cJ cop csubsp cfv ctop wcel cK ctop
      wcel cF cJ cK ccn co wcel cJ ctop wcel cA cJ cuni wss cA cJ cop csubsp
      cfv ctop wcel cA cX wss cA cJ stoig3 cX cJ cuni cA cnsubsp.1 sseq2i
      sylan2b ad2ant2r cJ ctop wcel cK ctop wcel cA cX wss cF cJ cK ccn co wcel
      wa simplr sylanc mpbird $.
      $( [11-Jul-2009] $) $( [11-Jul-2009] $)
  $}

  ${
    $d o s t B $. $d o s t F $. $d o s t J $. $d o s t K $. $d o s t Y $.
    cnsubsp2.1 $e |- Y = U. K $.
    $( Equivalence of continuity in the parent topology and continuity in a
       subspace. $)
    cnsubsp2 $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( ran F C_ B /\ B C_ Y ) )
    -> ( F e. ( J Cn K ) <-> F e. ( J Cn ( subSp ` <. B , K >. ) ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cJ cuni cY cF
      wf cF ccnv vo cv cima cJ wcel vo cK wral wa cJ cuni cB cK cop csubsp cfv
      cuni cF wf cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral wa cF
      cJ cK ccn co wcel cF cJ cB cK cop csubsp cfv ccn co wcel cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cB cY wss wa wa cJ cuni cY cF wf cF ccnv vo cv
      cima cJ wcel vo cK wral wa cJ cuni cB cF wf cF ccnv vs cv cima cJ wcel vs
      cB cK cop csubsp cfv wral wa cJ cuni cB cK cop csubsp cfv cuni cF wf cF
      ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral wa cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cB cY wss wa wa cJ cuni cY cF wf cF ccnv vo cv
      cima cJ wcel vo cK wral wa cJ cuni cB cF wf cF ccnv vs cv cima cJ wcel vs
      cB cK cop csubsp cfv wral wa cJ ctop wcel cK ctop wcel wa cF crn cB wss
      cB cY wss wa wa cJ cuni cY cF wf cF ccnv vo cv cima cJ wcel vo cK wral wa
      cJ cuni cB cF wf cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral
      cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cJ cuni cY cF
      wf cJ cuni cB cF wf cF ccnv vo cv cima cJ wcel vo cK wral cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cJ cuni cY cF wf cJ cuni cB cF wf wi cB cY wss
      cJ ctop wcel cK ctop wcel wa cF crn cB wss wa cF cJ cuni wfn cJ cuni cB
      cF wf cJ cuni cY cF wf cJ ctop wcel cK ctop wcel wa cF crn cB wss cF cJ
      cuni wfn cJ cuni cB cF wf wi cJ ctop wcel cK ctop wcel wa cF cJ cuni wfn
      cF crn cB wss cJ cuni cB cF wf cJ ctop wcel cK ctop wcel wa cF cJ cuni
      wfn cF crn cB wss cJ cuni cB cF wf cJ ctop wcel cK ctop wcel wa cF cJ
      cuni wfn wa cF crn cB wss wa cF cJ cuni wfn cF crn cB wss wa cJ cuni cB
      cF wf cJ ctop wcel cK ctop wcel wa cF cJ cuni wfn wa cF cJ cuni wfn cF
      crn cB wss cJ ctop wcel cK ctop wcel wa cF cJ cuni wfn pm3.27 anim1i cJ
      cuni cB cF df-f sylibr exp31 com23 imp cJ cuni cY cF ffn syl5 adantrr
      adantrd cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF
      wfun cF ccnv vo cv cima cJ wcel vo cK wral cF ccnv vs cv cima cJ wcel vs
      cB cK cop csubsp cfv wral cJ cuni cY cF wf cJ ctop wcel cK ctop wcel wa
      cF crn cB wss cB cY wss wa wa cF wfun cF ccnv vo cv cima cJ wcel vo cK
      wral wa cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv cJ ctop wcel
      cK ctop wcel wa cF crn cB wss cB cY wss wa wa vs cv cB cK cop csubsp cfv
      wcel cF wfun cF ccnv vo cv cima cJ wcel vo cK wral wa cF ccnv vs cv cima
      cJ wcel cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vs cv
      cB cK cop csubsp cfv wcel vs cv vt cv cB cin wceq vt cK wrex cF wfun cF
      ccnv vo cv cima cJ wcel vo cK wral wa cF ccnv vs cv cima cJ wcel wi cK
      ctop wcel cB cY wss vs cv cB cK cop csubsp cfv wcel vs cv vt cv cB cin
      wceq vt cK wrex wb cJ ctop wcel cF crn cB wss cK ctop wcel cB cY wss cB
      cvv wcel vs cv cB cK cop csubsp cfv wcel vs cv vt cv cB cin wceq vt cK
      wrex wb cB cK cuni wss cK cuni cvv wcel cB cvv wcel cK ctop wcel cB cY
      wss wa cB cK cuni cvv ssexg cB cY wss cB cK cuni wss cK ctop wcel cB cY
      wss cB cK cuni wss cY cK cuni cB cnsubsp2.1 sseq2i biimpi adantl cK ctop
      wcel cK cuni cvv wcel cB cY wss cK ctop uniexg adantr sylanc cK ctop wcel
      vs cv cvv wcel cB cvv wcel vs cv cB cK cop csubsp cfv wcel vs cv vt cv cB
      cin wceq vt cK wrex wb vs visset vt vs cv cB cvv cK issubspt mp3an2
      syldan ad2ant2l cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa
      wa vs cv vt cv cB cin wceq cF wfun cF ccnv vo cv cima cJ wcel vo cK wral
      wa cF ccnv vs cv cima cJ wcel wi vt cK cJ ctop wcel cK ctop wcel wa cF
      crn cB wss cB cY wss wa wa vt cv cK wcel vs cv vt cv cB cin wceq cF wfun
      cF ccnv vo cv cima cJ wcel vo cK wral wa cF ccnv vs cv cima cJ wcel cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vt cv cK wcel wa
      vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo cv cima cJ wcel vo cK wral
      wa wa cF ccnv vs cv cima cF ccnv vt cv cima cF ccnv cB cima cin cJ cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vt cv cK wcel wa
      vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo cv cima cJ wcel vo cK wral
      wa wa cF ccnv vs cv cima cF ccnv vt cv cB cin cima cF ccnv vt cv cima cF
      ccnv cB cima cin vs cv vt cv cB cin wceq cF ccnv vs cv cima cF ccnv vt cv
      cB cin cima wceq cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa
      wa vt cv cK wcel wa cF wfun cF ccnv vo cv cima cJ wcel vo cK wral wa vs
      cv vt cv cB cin cF ccnv imaeq2 ad2antlr cJ ctop wcel cK ctop wcel wa cF
      crn cB wss cB cY wss wa wa vt cv cK wcel wa vs cv vt cv cB cin wceq wa cF
      wfun cF ccnv vo cv cima cJ wcel vo cK wral wa wa cF ccnv ccnv wfun cF
      ccnv vt cv cB cin cima cF ccnv vt cv cima cF ccnv cB cima cin wceq cF
      wfun cF ccnv ccnv wfun cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY
      wss wa wa vt cv cK wcel wa vs cv vt cv cB cin wceq wa cF ccnv vo cv cima
      cJ wcel vo cK wral cF funcnvcnv ad2antrl vt cv cB cF ccnv imain syl eqtrd
      cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vt cv cK wcel
      wa vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo cv cima cJ wcel vo cK
      wral wa wa cF ccnv vt cv cima cF ccnv cB cima cin cF ccnv vt cv cima cJ
      cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vt cv cK wcel
      wa vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo cv cima cJ wcel vo cK
      wral wa wa cF ccnv vt cv cima cF ccnv cB cima cin cF ccnv vt cv cima cF
      cdm cin cF ccnv vt cv cima cJ ctop wcel cK ctop wcel wa cF crn cB wss cB
      cY wss wa wa vt cv cK wcel wa vs cv vt cv cB cin wceq wa cF wfun cF ccnv
      vo cv cima cJ wcel vo cK wral wa wa cF ccnv cB cima cF cdm cF ccnv vt cv
      cima cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vt cv cK
      wcel wa vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo cv cima cJ wcel vo
      cK wral wa wa cF ccnv cB cima cF cdm wss cF cdm cF ccnv cB cima wss wa cF
      ccnv cB cima cF cdm wceq cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY
      wss wa wa vt cv cK wcel wa vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo
      cv cima cJ wcel vo cK wral wa wa cF cdm cF ccnv cB cima wss cF ccnv cB
      cima cF cdm wss cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa
      wa vt cv cK wcel wa vs cv vt cv cB cin wceq wa cF wfun cF ccnv vo cv cima
      cJ wcel vo cK wral wa wa cF ccnv cF crn cima cF ccnv cB cima cF cdm cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vt cv cK wcel wa
      cF ccnv cF crn cima cF ccnv cB cima wss vs cv vt cv cB cin wceq cF wfun
      cF ccnv vo cv cima cJ wcel vo cK wral wa cF crn cB wss cB cY wss wa cF
      ccnv cF crn cima cF ccnv cB cima wss cJ ctop wcel cK ctop wcel wa vt cv
      cK wcel cF crn cB wss cF ccnv cF crn cima cF ccnv cB cima wss cB cY wss
      cF crn cB cF ccnv imass2 adantr ad2antlr ad2antrr cF ccnv cF crn cima cF
      cdm cF cvimarndm eqcomi syl5ss cF cB cnvimass jctil cF ccnv cB cima cF
      cdm eqss sylibr ineq2d cF ccnv vt cv cima cF cdm wss cF ccnv vt cv cima
      cF cdm cin cF ccnv vt cv cima wceq cF vt cv cnvimass cF ccnv vt cv cima
      cF cdm df-ss mpbi syl6eq cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY
      wss wa wa vt cv cK wcel wa cF ccnv vo cv cima cJ wcel vo cK wral cF ccnv
      vt cv cima cJ wcel vs cv vt cv cB cin wceq cF wfun cJ ctop wcel cK ctop
      wcel wa cF crn cB wss cB cY wss wa wa vt cv cK wcel wa cF ccnv vo cv cima
      cJ wcel vo cK wral cF ccnv vt cv cima cJ wcel vt cv cK wcel cF ccnv vo cv
      cima cJ wcel vo cK wral cF ccnv vt cv cima cJ wcel wi cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cB cY wss wa wa cF ccnv vo cv cima cJ wcel cF
      ccnv vt cv cima cJ wcel vo vt cv cK vo cv vt cv wceq cF ccnv vo cv cima
      cF ccnv vt cv cima cJ vo cv vt cv cF ccnv imaeq2 eleq1d rcla4v adantl imp
      ad2ant2rl eqeltrd eqeltrd exp41 r19.23adv sylbid com23 r19.21adv cJ cuni
      cY cF ffun sylani jcad cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY
      wss wa wa cJ cuni cB cF wf cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp
      cfv wral wa cJ cuni cY cF wf cF ccnv vo cv cima cJ wcel vo cK wral cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cJ cuni cB cF wf
      cJ cuni cY cF wf cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral
      cB cY wss cJ cuni cB cF wf cJ cuni cY cF wf wi cJ ctop wcel cK ctop wcel
      wa cF crn cB wss cJ cuni cB cF wf cB cY wss cJ cuni cY cF wf cJ cuni cB
      cY cF fss expcom ad2antll adantrd cJ ctop wcel cK ctop wcel wa cF crn cB
      wss cB cY wss wa wa cF wfun cF ccnv vs cv cima cJ wcel vs cB cK cop
      csubsp cfv wral cF ccnv vo cv cima cJ wcel vo cK wral cJ cuni cB cF wf cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun cF ccnv
      vs cv cima cJ wcel vs cB cK cop csubsp cfv wral wa cF ccnv vo cv cima cJ
      wcel vo cK cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF
      wfun cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral vo cv cK
      wcel cF ccnv vo cv cima cJ wcel wi cJ ctop wcel cK ctop wcel wa cF crn cB
      wss cB cY wss wa wa cF wfun wa vo cv cK wcel cF ccnv vs cv cima cJ wcel
      vs cB cK cop csubsp cfv wral cF ccnv vo cv cima cJ wcel cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK wcel cF
      ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral cF ccnv vo cv cima
      cJ wcel wi cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF
      wfun wa vo cv cK wcel wa cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp
      cfv wral cF ccnv vo cv cB cin cima cJ wcel cF ccnv vo cv cima cJ wcel cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv
      cK wcel wa vo cv cB cin cB cK cop csubsp cfv wcel cF ccnv vs cv cima cJ
      wcel vs cB cK cop csubsp cfv wral cF ccnv vo cv cB cin cima cJ wcel wi cK
      ctop wcel cB cY wss vo cv cK wcel vo cv cB cin vo cv cB cin wceq vo cv cB
      cin cB cK cop csubsp cfv wcel cJ ctop wcel cK ctop wcel wa cF crn cB wss
      cB cY wss wa wa cF wfun wa vo cv cK wcel wa vo cv vo cv cB cin cB cK cY
      cnsubsp2.1 elsubsp cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss
      wa wa cK ctop wcel cF wfun vo cv cK wcel cJ ctop wcel cK ctop wcel cF crn
      cB wss cB cY wss wa simplr ad2antrr cJ ctop wcel cK ctop wcel wa cF crn
      cB wss cB cY wss wa wa cB cY wss cF wfun vo cv cK wcel cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cB cY wss simprr ad2antrr cJ ctop wcel cK ctop
      wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK wcel pm3.27 cJ
      ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv
      cK wcel wa vo cv cB cin eqidd syl2anc cF ccnv vs cv cima cJ wcel cF ccnv
      vo cv cB cin cima cJ wcel vs vo cv cB cin cB cK cop csubsp cfv vs cv vo
      cv cB cin wceq cF ccnv vs cv cima cF ccnv vo cv cB cin cima cJ vs cv vo
      cv cB cin cF ccnv imaeq2 eleq1d rcla4v syl cJ ctop wcel cK ctop wcel wa
      cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK wcel wa cF ccnv vo cv
      cB cin cima cF ccnv vo cv cima cJ cJ ctop wcel cK ctop wcel wa cF crn cB
      wss cB cY wss wa wa cF wfun wa vo cv cK wcel wa cF ccnv vo cv cB cin cima
      cF ccnv vo cv cima cF ccnv cB cima cin cF ccnv vo cv cima cF cdm cin cF
      ccnv vo cv cima cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa
      wa cF wfun wa vo cv cK wcel wa cF ccnv ccnv wfun cF ccnv vo cv cB cin
      cima cF ccnv vo cv cima cF ccnv cB cima cin wceq cF wfun cF ccnv ccnv
      wfun cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa vo cv cK
      wcel cF funcnvcnv ad2antlr vo cv cB cF ccnv imain syl cJ ctop wcel cK
      ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK wcel wa cF
      ccnv cB cima cF cdm cF ccnv vo cv cima cJ ctop wcel cK ctop wcel wa cF
      crn cB wss cB cY wss wa wa cF wfun wa vo cv cK wcel wa cF ccnv cB cima cF
      cdm wss cF cdm cF ccnv cB cima wss wa cF ccnv cB cima cF cdm wceq cJ ctop
      wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK
      wcel wa cF cdm cF ccnv cB cima wss cF ccnv cB cima cF cdm wss cJ ctop
      wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK
      wcel wa cF ccnv cF crn cima cF ccnv cB cima cF cdm cJ ctop wcel cK ctop
      wcel wa cF crn cB wss cB cY wss wa wa cF ccnv cF crn cima cF ccnv cB cima
      wss cF wfun vo cv cK wcel cF crn cB wss cF ccnv cF crn cima cF ccnv cB
      cima wss cJ ctop wcel cK ctop wcel wa cB cY wss cF crn cB cF ccnv imass2
      ad2antrl ad2antrr cF ccnv cF crn cima cF cdm cF cvimarndm eqcomi syl5ss
      cF cB cnvimass jctil cF ccnv cB cima cF cdm eqss sylibr ineq2d cF ccnv vo
      cv cima cF cdm cin cF ccnv vo cv cima wceq cJ ctop wcel cK ctop wcel wa
      cF crn cB wss cB cY wss wa wa cF wfun wa vo cv cK wcel wa cF ccnv vo cv
      cima cF cdm wss cF ccnv vo cv cima cF cdm cin cF ccnv vo cv cima wceq cF
      vo cv cnvimass cF ccnv vo cv cima cF cdm df-ss mpbi a1i 3eqtrd eleq1d
      sylibd ex com23 expimpd r19.21adv cJ cuni cB cF ffun sylani jcad impbid
      cJ ctop wcel cK ctop wcel wa cF crn cB wss cB cY wss wa wa cJ cuni cB cK
      cop csubsp cfv cuni cF wf cJ cuni cB cF wf cF ccnv vs cv cima cJ wcel vs
      cB cK cop csubsp cfv wral cJ ctop wcel cK ctop wcel wa cF crn cB wss cB
      cY wss wa wa cB cK cop csubsp cfv cuni cB wceq cJ cuni cB cK cop csubsp
      cfv cuni cF wf cJ cuni cB cF wf wb cK ctop wcel cB cY wss cB cK cop
      csubsp cfv cuni cB wceq cJ ctop wcel cF crn cB wss cK ctop wcel cB cK
      cuni wss cB cK cop csubsp cfv cuni cB wceq cB cY wss cB cK stoig2 cY cK
      cuni cB cnsubsp2.1 sseq2i sylan2b ad2ant2l cB cK cop csubsp cfv cuni cB
      cJ cuni cF feq3 syl anbi1d bitr4d cJ ctop wcel cK ctop wcel wa cF cJ cK
      ccn co wcel cJ cuni cY cF wf cF ccnv vo cv cima cJ wcel vo cK wral wa wb
      cF crn cB wss cB cY wss wa vo cF cJ cK cJ cuni cY cJ cuni eqid cnsubsp2.1
      iscn adantr cJ ctop wcel cK ctop wcel wa cB cY wss cF cJ cB cK cop csubsp
      cfv ccn co wcel cJ cuni cB cK cop csubsp cfv cuni cF wf cF ccnv vs cv
      cima cJ wcel vs cB cK cop csubsp cfv wral wa wb cF crn cB wss cJ ctop
      wcel cK ctop wcel cB cY wss cF cJ cB cK cop csubsp cfv ccn co wcel cJ
      cuni cB cK cop csubsp cfv cuni cF wf cF ccnv vs cv cima cJ wcel vs cB cK
      cop csubsp cfv wral wa wb cJ ctop wcel cB cK cop csubsp cfv ctop wcel cF
      cJ cB cK cop csubsp cfv ccn co wcel cJ cuni cB cK cop csubsp cfv cuni cF
      wf cF ccnv vs cv cima cJ wcel vs cB cK cop csubsp cfv wral wa wb cK ctop
      wcel cB cY wss wa vs cF cJ cB cK cop csubsp cfv cJ cuni cB cK cop csubsp
      cfv cuni cJ cuni eqid cB cK cop csubsp cfv cuni eqid iscn cK ctop wcel cB
      cK cuni wss cB cK cop csubsp cfv ctop wcel cB cY wss cB cK stoig3 cY cK
      cuni cB cnsubsp2.1 sseq2i sylan2b sylan2 anassrs adantrl 3bitr4d $.
      $( [10-Jul-2009] $) $( [10-Jul-2009] $)
  $}

  ${ $d r s J $.
    $( A compact topology is a topology. $)
  comptop $p |- ( J e. Comp -> J e. Top ) $=
    cJ ccomp wcel cJ ctop wcel cJ cuni vr cv cuni wceq cJ cuni vs cv cuni wceq
    vs vr cv cpw cfn cin wrex wi vr cJ cpw wral vr vs cJ iscomp pm3.26bi $.
    $( [29-Jun-2009] $) $( [29-Jun-2009] $)
  $}

  ${
    $d r s J $. $d r s S $.
    compcov.1 $e |- X = U. J $.
    $( An open cover of a compact topology has a finite subcover. $)
    compcov $p |- ( ( J e. Comp /\ S C_ J /\ X = U. S ) -> E. s e. ( ~P S i^i
    Fin ) X = U. s ) $=
      cJ ccomp wcel cS cJ wss cX cS cuni wceq cX vs cv cuni wceq vs cS cpw cfn
      cin wrex cJ ccomp wcel cS cJ wss wa cJ cuni cS cuni wceq cJ cuni vs cv
      cuni wceq vs cS cpw cfn cin wrex cX cS cuni wceq cX vs cv cuni wceq vs cS
      cpw cfn cin wrex cS cJ cpw wcel cJ cuni vr cv cuni wceq cJ cuni vs cv
      cuni wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cJ cuni cS cuni
      wceq cJ cuni vs cv cuni wceq vs cS cpw cfn cin wrex wi cJ ccomp wcel cS
      cJ wss wa cJ cuni vr cv cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw
      cfn cin wrex wi cJ cuni cS cuni wceq cJ cuni vs cv cuni wceq vs cS cpw
      cfn cin wrex wi vr cS cJ cpw vr cv cS wceq cJ cuni vr cv cuni wceq cJ
      cuni cS cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex cJ
      cuni vs cv cuni wceq vs cS cpw cfn cin wrex vr cv cS wceq vr cv cuni cS
      cuni cJ cuni vr cv cS unieq eqeq2d vr cv cS wceq cJ cuni vs cv cuni wceq
      vs vr cv cpw cfn cin cS cpw cfn cin vr cv cS wceq vr cv cpw cS cpw cfn vr
      cv cS pweq ineq1d rexeq1d imbi12d rcla4v cJ ccomp wcel cS cJ wss wa cS cJ
      cpw wcel cS cJ wss cJ ccomp wcel cS cJ wss pm3.27 cJ ccomp wcel cS cJ wss
      wa cS cvv wcel cS cJ cpw wcel cS cJ wss wb cS cJ wss cJ ccomp wcel cS cvv
      wcel cS cJ ccomp ssexg ancoms cS cJ cvv elpwg syl mpbird cJ ccomp wcel cJ
      cuni vr cv cuni wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi
      vr cJ cpw wral cS cJ wss cJ ccomp wcel cJ ctop wcel cJ cuni vr cv cuni
      wceq cJ cuni vs cv cuni wceq vs vr cv cpw cfn cin wrex wi vr cJ cpw wral
      vr vs cJ iscomp pm3.27bi adantr sylc cX cJ cuni cS cuni compcov.1 eqeq1i
      cX vs cv cuni wceq cJ cuni vs cv cuni wceq vs cS cpw cfn cin cX cJ cuni
      vs cv cuni compcov.1 eqeq1i rexbii 3imtr4g 3impia $.
      $( [29-Jun-2009] $) $( [29-Jun-2009] $)
  $}

  ${
    $d c d f s t u v w x y z J $. $d c d f s t u v w x y z S $. $d c d f s t u
    v w x y z X $.
    compsub.1 $e |- X = U. J $.
    $( Lemma for ~ compsub . $)
    compsublem $p |- ( ( J e. Top /\ S C_ X ) -> ( A. c e. ~P J ( S C_ U. c ->
    E. d e. ( ~P c i^i Fin ) S C_ U. d ) -> A. s e. ~P ( subSp ` <. S , J >. )
    ( U. ( subSp ` <. S , J >. ) = U. s -> E. t e. ( ~P s i^i Fin ) U. ( subSp
    ` <. S , J >. ) = U. t ) ) ) $=
      cJ ctop wcel cS cX wss wa cS vc cv cuni wss cS vd cv cuni wss vd vc cv
      cpw cfn cin wrex wi vc cJ cpw wral cS cJ cop csubsp cfv cuni vs cv cuni
      wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex
      wi vs cS cJ cop csubsp cfv cpw cJ ctop wcel cS cX wss wa vs cv cS cJ cop
      csubsp cfv cpw wcel wa cS vc cv cuni wss cS vd cv cuni wss vd vc cv cpw
      cfn cin wrex wi vc cJ cpw wral cS vy cv cS cin vs cv wcel vy cJ crab cuni
      wss cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn cin
      wrex wi cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv
      cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex wi cJ ctop wcel cS cX wss
      wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vc cv cuni wss cS vd cv cuni
      wss vd vc cv cpw cfn cin wrex wi vc cJ cpw wral cS vy cv cS cin vs cv
      wcel vy cJ crab cuni wss cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy
      cJ crab cpw cfn cin wrex wi vy cv cS cin vs cv wcel vy cJ crab cJ cpw
      wcel cS vc cv cuni wss cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi vc
      cJ cpw wral cS vy cv cS cin vs cv wcel vy cJ crab cuni wss cS vd cv cuni
      wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn cin wrex wi cJ ctop
      wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vc cv cuni
      wss cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi cS vy cv cS cin vs cv
      wcel vy cJ crab cuni wss cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy
      cJ crab cpw cfn cin wrex wi vc vy cv cS cin vs cv wcel vy cJ crab cJ cpw
      vc cv vy cv cS cin vs cv wcel vy cJ crab wceq cS vc cv cuni wss cS vy cv
      cS cin vs cv wcel vy cJ crab cuni wss cS vd cv cuni wss vd vc cv cpw cfn
      cin wrex cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn
      cin wrex vc cv vy cv cS cin vs cv wcel vy cJ crab wceq vc cv cuni vy cv
      cS cin vs cv wcel vy cJ crab cuni cS vc cv vy cv cS cin vs cv wcel vy cJ
      crab unieq sseq2d vc cv vy cv cS cin vs cv wcel vy cJ crab wceq cS vd cv
      cuni wss vd vc cv cpw cfn cin vy cv cS cin vs cv wcel vy cJ crab cpw cfn
      cin vc cv vy cv cS cin vs cv wcel vy cJ crab wceq vc cv cpw vy cv cS cin
      vs cv wcel vy cJ crab cpw cfn vc cv vy cv cS cin vs cv wcel vy cJ crab
      pweq ineq1d rexeq1d imbi12d rcla4va cJ ctop wcel cS cX wss wa vs cv cS cJ
      cop csubsp cfv cpw wcel wa vy cv cS cin vs cv wcel vy cJ crab cvv wcel vy
      cv cS cin vs cv wcel vy cJ crab cJ cpw wcel cJ ctop wcel vy cv cS cin vs
      cv wcel vy cJ crab cvv wcel cS cX wss vs cv cS cJ cop csubsp cfv cpw wcel
      vy cv cS cin vs cv wcel vy cJ ctop rabexg ad2antrr vy cv cS cin vs cv
      wcel vy cJ crab cvv wcel vy cv cS cin vs cv wcel vy cJ crab cJ cpw wcel
      vy cv cS cin vs cv wcel vy cJ crab cJ wss vy cv cS cin vs cv wcel vy cJ
      ssrab2 vy cv cS cin vs cv wcel vy cJ crab cJ cvv elpwg mpbiri syl sylan
      ex cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS cJ
      cop csubsp cfv cuni vs cv cuni wceq cS vy cv cS cin vs cv wcel vy cJ crab
      cuni wss cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn
      cin wrex wi cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn
      cin wrex cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa
      cS cJ cop csubsp cfv cuni vs cv cuni wceq cS vs cv cuni wceq cS vy cv cS
      cin vs cv wcel vy cJ crab cuni wss cS vd cv cuni wss vd vy cv cS cin vs
      cv wcel vy cJ crab cpw cfn cin wrex wi cS cJ cop csubsp cfv cuni vt cv
      cuni wceq vt vs cv cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa vs cv cS
      cJ cop csubsp cfv cpw wcel wa cS cJ cop csubsp cfv cuni cS vs cv cuni cJ
      ctop wcel cS cX wss wa cS cJ cop csubsp cfv cuni cS wceq vs cv cS cJ cop
      csubsp cfv cpw wcel cJ ctop wcel cS cJ cuni wss cS cJ cop csubsp cfv cuni
      cS wceq cS cX wss cS cJ stoig2 cX cJ cuni cS compsub.1 sseq2i sylan2b
      adantr eqeq1d cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw
      wcel wa cS vs cv cuni wceq cS vy cv cS cin vs cv wcel vy cJ crab cuni wss
      cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn cin wrex
      wi cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex wi
      cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv
      cuni wceq wa cS vy cv cS cin vs cv wcel vy cJ crab cuni wss cS vy cv cS
      cin vs cv wcel vy cJ crab cuni wss cS vd cv cuni wss vd vy cv cS cin vs
      cv wcel vy cJ crab cpw cfn cin wrex wi cS cJ cop csubsp cfv cuni vt cv
      cuni wceq vt vs cv cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa vs cv cS
      cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa vt cS vy cv cS cin vs
      cv wcel vy cJ crab cuni cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp
      cfv cpw wcel wa cS vs cv cuni wceq wa vt cv cS wcel vt cv vv cv wcel vv
      cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex vt cv vy cv cS cin
      vs cv wcel vy cJ crab cuni wcel cJ ctop wcel cS cX wss wa vs cv cS cJ cop
      csubsp cfv cpw wcel wa cS vs cv cuni wceq vt cv cS wcel vt cv vv cv wcel
      vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex wi cJ ctop wcel
      cS cX wss wa vs cv cS cJ cop csubsp cfv wss cS vs cv cuni wceq vt cv cS
      wcel vt cv vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv
      wex wi wi vs cv cS cJ cop csubsp cfv cpw wcel cJ ctop wcel cS cX wss wa
      vs cv cS cJ cop csubsp cfv wss wa cS vs cv cuni wceq vt cv cS wcel vt cv
      vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex wi cJ
      ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv wss wa cS vs cv cuni
      wceq wa vt cv cS wcel vt cv vu cv wcel vu cv vs cv wcel wa vu wex vt cv
      vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex cS vs
      cv cuni wceq vt cv cS wcel vt cv vu cv wcel vu cv vs cv wcel wa vu wex wb
      cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv wss wa cS vs cv cuni
      wceq vt cv cS wcel vt cv vs cv cuni wcel vt cv vu cv wcel vu cv vs cv
      wcel wa vu wex cS vs cv cuni vt cv eleq2 vu vt cv vs cv eluni syl6bb
      adantl cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv wss wa vt cv
      vu cv wcel vu cv vs cv wcel wa vu wex vt cv vv cv wcel vv cv vy cv cS cin
      vs cv wcel vy cJ crab wcel wa vv wex wi cS vs cv cuni wceq cJ ctop wcel
      cS cX wss wa vs cv cS cJ cop csubsp cfv wss wa vt cv vu cv wcel vu cv vs
      cv wcel wa vt cv vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel
      wa vv wex vu cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv wss wa
      vt cv vu cv wcel vu cv vs cv wcel vt cv vv cv wcel vv cv vy cv cS cin vs
      cv wcel vy cJ crab wcel wa vv wex vs cv cS cJ cop csubsp cfv wss cJ ctop
      wcel cS cX wss wa vt cv vu cv wcel vu cv vs cv wcel vt cv vv cv wcel vv
      cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex wi wi vs cv cS cJ
      cop csubsp cfv wss vu cv vs cv wcel vt cv vu cv wcel cJ ctop wcel cS cX
      wss wa vt cv vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa
      vv wex vs cv cS cJ cop csubsp cfv wss vu cv vs cv wcel vu cv cS cJ cop
      csubsp cfv wcel vt cv vu cv wcel cJ ctop wcel cS cX wss wa vt cv vv cv
      wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex wi wi vs cv
      cS cJ cop csubsp cfv vu cv ssel cJ ctop wcel cS cX wss wa vu cv vs cv
      wcel vu cv cS cJ cop csubsp cfv wcel vt cv vu cv wcel vt cv vv cv wcel vv
      cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex cJ ctop wcel cS cX
      wss wa vu cv cS cJ cop csubsp cfv wcel vu cv vs cv wcel vt cv vu cv wcel
      vt cv vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex
      wi cJ ctop wcel cS cX wss wa vu cv cS cJ cop csubsp cfv wcel vu cv vw cv
      cS cin wceq vw cJ wrex vu cv vs cv wcel vt cv vu cv wcel vt cv vv cv wcel
      vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex wi wi cJ ctop
      wcel vu cv cvv wcel cS cvv wcel vu cv cS cJ cop csubsp cfv wcel vu cv vw
      cv cS cin wceq vw cJ wrex wb cJ ctop wcel cS cX wss wa vw vu cv cS cvv cJ
      issubspt cJ ctop wcel cS cX wss pm3.26 vu cv cvv wcel cJ ctop wcel cS cX
      wss wa vu visset a1i cJ ctop wcel cS cJ cuni wss cS cvv wcel cS cX wss cJ
      cuni cvv wcel cS cJ cuni wss cS cvv wcel cJ ctop wcel cS cJ cuni wss cJ
      cuni cvv wcel cS cvv wcel cS cJ cuni cvv ssexg ancoms cJ ctop uniexg
      sylan cX cJ cuni cS compsub.1 sseq2i sylan2b syl3anc cJ ctop wcel cS cX
      wss wa vu cv vw cv cS cin wceq vu cv vs cv wcel vt cv vu cv wcel vt cv vv
      cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex wi wi vw
      cJ cJ ctop wcel cS cX wss wa vw cv cJ wcel vu cv vw cv cS cin wceq vu cv
      vs cv wcel vt cv vu cv wcel vt cv vv cv wcel vv cv vy cv cS cin vs cv
      wcel vy cJ crab wcel wa vv wex wi wi cJ ctop wcel cS cX wss wa vw cv cJ
      wcel vu cv vw cv cS cin wceq w3a vu cv vs cv wcel vt cv vu cv wcel vt cv
      vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex vt cv
      vw cv wcel vw cv vy cv cS cin vs cv wcel vy cJ crab wcel vt cv vv cv wcel
      vv cv vy cv cS cin vs cv wcel vy cJ crab wcel wa vv wex cJ ctop wcel cS
      cX wss wa vw cv cJ wcel vu cv vw cv cS cin wceq w3a vu cv vs cv wcel vt
      cv vu cv wcel w3a vt cv vv cv wcel vv cv vy cv cS cin vs cv wcel vy cJ
      crab wcel wa vt cv vw cv wcel vw cv vy cv cS cin vs cv wcel vy cJ crab
      wcel wa vv vw cv vw visset vv cv vw cv wceq vt cv vv cv wcel vt cv vw cv
      wcel vv cv vy cv cS cin vs cv wcel vy cJ crab wcel vw cv vy cv cS cin vs
      cv wcel vy cJ crab wcel vv cv vw cv vt cv eleq2 vv cv vw cv vy cv cS cin
      vs cv wcel vy cJ crab eleq1 anbi12d cla4ev cJ ctop wcel cS cX wss wa vw
      cv cJ wcel vu cv vw cv cS cin wceq w3a vt cv vu cv wcel vt cv vw cv wcel
      vu cv vs cv wcel vu cv vw cv cS cin wceq cJ ctop wcel cS cX wss wa vt cv
      vu cv wcel vt cv vw cv wcel vw cv cJ wcel vu cv vw cv wss vt cv vu cv
      wcel vt cv vw cv wcel vu cv vw cv cS cin wceq vu cv vw cv vt cv ssel2 vu
      cv vw cv cS cin wceq vu cv vw cv wss vw cv cS cin vw cv wss vw cv cS
      inss1 vu cv vw cv cS cin vw cv sseq1 mpbiri sylan 3ad2antl3 3adant2 cJ
      ctop wcel cS cX wss wa vw cv cJ wcel vu cv vw cv cS cin wceq w3a vu cv vs
      cv wcel vt cv vu cv wcel w3a vw cv cJ wcel vw cv cS cin vs cv wcel wa vw
      cv vy cv cS cin vs cv wcel vy cJ crab wcel cJ ctop wcel cS cX wss wa vw
      cv cJ wcel vu cv vw cv cS cin wceq w3a vu cv vs cv wcel vt cv vu cv wcel
      w3a vw cv cJ wcel vw cv cS cin vs cv wcel cJ ctop wcel cS cX wss wa vw cv
      cJ wcel vu cv vw cv cS cin wceq w3a vu cv vs cv wcel vw cv cJ wcel vt cv
      vu cv wcel cJ ctop wcel cS cX wss wa vw cv cJ wcel vu cv vw cv cS cin
      wceq 3simp2 3ad2ant1 cJ ctop wcel cS cX wss wa vw cv cJ wcel vu cv vw cv
      cS cin wceq w3a vu cv vs cv wcel vw cv cS cin vs cv wcel vt cv vu cv wcel
      vu cv vw cv cS cin wceq cJ ctop wcel cS cX wss wa vu cv vs cv wcel vw cv
      cS cin vs cv wcel vw cv cJ wcel vu cv vw cv cS cin wceq vu cv vs cv wcel
      vw cv cS cin vs cv wcel vu cv vw cv cS cin vs cv eleq1 biimpa 3ad2antl3
      3adant3 jca vy cv cS cin vs cv wcel vw cv cS cin vs cv wcel vy vw cv cJ
      vy cv vw cv wceq vy cv cS cin vw cv cS cin vs cv vy cv vw cv cS ineq1
      eleq1d elrab sylibr sylanc 3exp 3exp r19.23adv sylbid com23 com4l sylcom
      com24 impcom imp3a 19.23adv adantr sylbid ex vs cv cS cJ cop csubsp cfv
      vs visset elpw sylan2b imp vv vt cv vy cv cS cin vs cv wcel vy cJ crab
      eluni syl6ibr ssrdv cS vy cv cS cin vs cv wcel vy cJ crab cuni wss cS vy
      cv cS cin vs cv wcel vy cJ crab cuni wss cS vd cv cuni wss vd vy cv cS
      cin vs cv wcel vy cJ crab cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa
      vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa cS cJ cop
      csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex cS vy cv cS cin
      vs cv wcel vy cJ crab cuni wss cS vy cv cS cin vs cv wcel vy cJ crab cuni
      wss cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn cin
      wrex wi cS vd cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn
      cin wrex cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa
      cS vs cv cuni wceq wa cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv
      cpw cfn cin wrex wi cS vy cv cS cin vs cv wcel vy cJ crab cuni wss cS vd
      cv cuni wss vd vy cv cS cin vs cv wcel vy cJ crab cpw cfn cin wrex pm2.27
      cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv
      cpw wcel wa cS vs cv cuni wceq wa cS cJ cop csubsp cfv cuni vt cv cuni
      wceq vt vs cv cpw cfn cin wrex wi vd vy cv cS cin vs cv wcel vy cJ crab
      cpw cfn cin vd cv vy cv cS cin vs cv wcel vy cJ crab cpw cfn cin wcel vd
      cv vy cv cS cin vs cv wcel vy cJ crab cpw wcel vd cv cfn wcel wa cS vd cv
      cuni wss cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa
      cS vs cv cuni wceq wa cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv
      cpw cfn cin wrex wi wi vd cv vy cv cS cin vs cv wcel vy cJ crab cpw cfn
      elin vd cv vy cv cS cin vs cv wcel vy cJ crab cpw wcel vd cv cfn wcel wa
      cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv
      cpw wcel wa cS vs cv cuni wceq wa cS cJ cop csubsp cfv cuni vt cv cuni
      wceq vt vs cv cpw cfn cin wrex vx cv vz cv cS cin wceq vz vd cv wrex vx
      cab vs cv cpw cfn cin wcel cS cJ cop csubsp cfv cuni vx cv vz cv cS cin
      wceq vz vd cv wrex vx cab cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni
      wceq vt vs cv cpw cfn cin wrex vd cv vy cv cS cin vs cv wcel vy cJ crab
      cpw wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs
      cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a cS cJ cop
      csubsp cfv cuni vt cv cuni wceq cS cJ cop csubsp cfv cuni vx cv vz cv cS
      cin wceq vz vd cv wrex vx cab cuni wceq vt vx cv vz cv cS cin wceq vz vd
      cv wrex vx cab vs cv cpw cfn cin vt cv vx cv vz cv cS cin wceq vz vd cv
      wrex vx cab wceq vt cv cuni vx cv vz cv cS cin wceq vz vd cv wrex vx cab
      cuni cS cJ cop csubsp cfv cuni vt cv vx cv vz cv cS cin wceq vz vd cv
      wrex vx cab unieq eqeq2d rcla4ev vd cv vy cv cS cin vs cv wcel vy cJ crab
      cpw wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs
      cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a vx cv vz cv
      cS cin wceq vz vd cv wrex vx cab vs cv cpw wcel vx cv vz cv cS cin wceq
      vz vd cv wrex vx cab cfn wcel wa vx cv vz cv cS cin wceq vz vd cv wrex vx
      cab vs cv cpw cfn cin wcel vd cv vy cv cS cin vs cv wcel vy cJ crab cpw
      wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs cv
      cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a vx cv vz cv cS
      cin wceq vz vd cv wrex vx cab vs cv cpw wcel vx cv vz cv cS cin wceq vz
      vd cv wrex vx cab cfn wcel vd cv vy cv cS cin vs cv wcel vy cJ crab cpw
      wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs cv
      cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a vx cv vz cv cS
      cin wceq vz vd cv wrex vx cab vs cv wss vx cv vz cv cS cin wceq vz vd cv
      wrex vx cab vs cv cpw wcel vd cv vy cv cS cin vs cv wcel vy cJ crab cpw
      wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX wss wa vs cv
      cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a vt vx cv vz cv
      cS cin wceq vz vd cv wrex vx cab vs cv vd cv vy cv cS cin vs cv wcel vy
      cJ crab cpw wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX
      wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a
      vt cv vz cv cS cin wceq vz vd cv wrex vt cv vs cv wcel vt cv vx cv vz cv
      cS cin wceq vz vd cv wrex vx cab wcel vd cv vy cv cS cin vs cv wcel vy cJ
      crab cpw wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS cX wss
      wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa w3a vt cv
      vz cv cS cin wceq vt cv vs cv wcel vz vd cv vd cv vy cv cS cin vs cv wcel
      vy cJ crab cpw wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS
      cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa vz
      cv vd cv wcel vt cv vz cv cS cin wceq vt cv vs cv wcel wi wi vd cv vy cv
      cS cin vs cv wcel vy cJ crab wss vd cv cfn wcel cS vd cv cuni wss cJ ctop
      wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni
      wceq wa vz cv vd cv wcel vt cv vz cv cS cin wceq vt cv vs cv wcel wi wi
      wi wi vd cv vy cv cS cin vs cv wcel vy cJ crab cpw wcel vd cv vy cv cS
      cin vs cv wcel vy cJ crab wss cS vd cv cuni wss cJ ctop wcel cS cX wss wa
      vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa vz cv vd cv
      wcel vt cv vz cv cS cin wceq vt cv vs cv wcel wi wi wi wi vd cv cfn wcel
      vd cv vy cv cS cin vs cv wcel vy cJ crab wss cJ ctop wcel cS cX wss wa vs
      cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa vz cv vd cv
      wcel vt cv vz cv cS cin wceq vt cv vs cv wcel wi wi wi cS vd cv cuni wss
      vd cv vy cv cS cin vs cv wcel vy cJ crab wss vz cv vd cv wcel vt cv vz cv
      cS cin wceq vt cv vs cv wcel wi wi cJ ctop wcel cS cX wss wa vs cv cS cJ
      cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa vd cv vy cv cS cin vs cv
      wcel vy cJ crab wss vz cv vd cv wcel vz cv vy cv cS cin vs cv wcel vy cJ
      crab wcel vt cv vz cv cS cin wceq vt cv vs cv wcel wi vd cv vy cv cS cin
      vs cv wcel vy cJ crab vz cv ssel vz cv vy cv cS cin vs cv wcel vy cJ crab
      wcel vz cv cJ wcel vz cv cS cin vs cv wcel wa vt cv vz cv cS cin wceq vt
      cv vs cv wcel wi vy cv cS cin vs cv wcel vz cv cS cin vs cv wcel vy vz cv
      cJ vy cv vz cv wceq vy cv cS cin vz cv cS cin vs cv vy cv vz cv cS ineq1
      eleq1d elrab vz cv cS cin vs cv wcel vt cv vz cv cS cin wceq vt cv vs cv
      wcel wi vz cv cJ wcel vz cv cS cin vs cv vt cv eleq1a adantl sylbi syl6
      a1d a1d adantr vd cv vy cv cS cin vs cv wcel vy cJ crab vd visset elpw
      sylanb 3imp r19.23adv vx cv vz cv cS cin wceq vz vd cv wrex vt cv vz cv
      cS cin wceq vz vd cv wrex vx vt cv vt visset vx cv vt cv wceq vx cv vz cv
      cS cin wceq vt cv vz cv cS cin wceq vz vd cv vx cv vt cv vz cv cS cin
      eqeq1 rexbidv elab syl5ib ssrdv vx cv vz cv cS cin wceq vz vd cv wrex vx
      cab vs cv vz vx vd cv vz cv cS cin vd visset abrexex elpw sylibr vd cv vy
      cv cS cin vs cv wcel vy cJ crab cpw wcel vd cv cfn wcel wa cS vd cv cuni
      wss vx cv vz cv cS cin wceq vz vd cv wrex vx cab cfn wcel cJ ctop wcel cS
      cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa vd
      cv cfn wcel vx cv vz cv cS cin wceq vz vd cv wrex vx cab cfn wcel vd cv
      vy cv cS cin vs cv wcel vy cJ crab cpw wcel cS vd cv cuni wss vd cv cfn
      wcel vz cv vd cv wcel vx cv vz cv cS cin wceq wa vz vx copab crn cfn vx
      cv vz cv cS cin wceq vz vd cv wrex vx cab vd cv cfn wcel vz cv vd cv wcel
      vx cv vz cv cS cin wceq wa vz vx copab crn vd cv cdom wbr vz cv vd cv
      wcel vx cv vz cv cS cin wceq wa vz vx copab crn cfn wcel vd cv cfn wcel
      vd cv vz cv vd cv wcel vx cv vz cv cS cin wceq wa vz vx copab crn vz cv
      vd cv wcel vx cv vz cv cS cin wceq wa vz vx copab wfo vz cv vd cv wcel vx
      cv vz cv cS cin wceq wa vz vx copab crn vd cv cdom wbr vz cv vd cv wcel
      vx cv vz cv cS cin wceq wa vz vx copab vd cv wfn vd cv vz cv vd cv wcel
      vx cv vz cv cS cin wceq wa vz vx copab crn vz cv vd cv wcel vx cv vz cv
      cS cin wceq wa vz vx copab wfo vz vx vd cv vz cv cS cin vz cv vd cv wcel
      vx cv vz cv cS cin wceq wa vz vx copab vz cv cS vz visset inex1 vz cv vd
      cv wcel vx cv vz cv cS cin wceq wa vz vx copab eqid fnopab2 vd cv vz cv
      vd cv wcel vx cv vz cv cS cin wceq wa vz vx copab dffn4 mpbi vd cv vz cv
      vd cv wcel vx cv vz cv cS cin wceq wa vz vx copab crn vz cv vd cv wcel vx
      cv vz cv cS cin wceq wa vz vx copab fodomfi mpan2 vd cv vz cv vd cv wcel
      vx cv vz cv cS cin wceq wa vz vx copab crn domfi mpdan vz vx vd cv vz cv
      cS cin rnopab2 syl5eqelr ad2antlr 3adant3 jca vx cv vz cv cS cin wceq vz
      vd cv wrex vx cab vs cv cpw cfn elin sylibr vd cv vy cv cS cin vs cv wcel
      vy cJ crab cpw wcel vd cv cfn wcel wa cS vd cv cuni wss cJ ctop wcel cS
      cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa
      w3a cS cJ cop csubsp cfv cuni cS vz vd cv vz cv cS cin ciun vx cv vz cv
      cS cin wceq vz vd cv wrex vx cab cuni cS vd cv cuni wss cJ ctop wcel cS
      cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa cS vs cv cuni wceq wa cS
      cJ cop csubsp cfv cuni cS wceq vd cv vy cv cS cin vs cv wcel vy cJ crab
      cpw wcel vd cv cfn wcel wa cJ ctop wcel cS cX wss wa vs cv cS cJ cop
      csubsp cfv cpw wcel wa cS cJ cop csubsp cfv cuni cS wceq cS vd cv cuni
      wss cS vs cv cuni wceq cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv
      cuni cS wceq vs cv cS cJ cop csubsp cfv cpw wcel cJ ctop wcel cS cJ cuni
      wss cS cJ cop csubsp cfv cuni cS wceq cS cX wss cS cJ stoig2 cX cJ cuni
      cS compsub.1 sseq2i sylan2b adantr ad2antrl 3adant1 cS vd cv cuni wss vd
      cv vy cv cS cin vs cv wcel vy cJ crab cpw wcel vd cv cfn wcel wa cS vz vd
      cv vz cv cS cin ciun wceq cJ ctop wcel cS cX wss wa vs cv cS cJ cop
      csubsp cfv cpw wcel wa cS vs cv cuni wceq wa cS vd cv cuni wss cS cS vd
      cv cuni cin vz vd cv vz cv cS cin ciun cS vd cv cuni wss cS cS vd cv cuni
      cin wceq cS vd cv cuni dfss biimpi cS vd cv cuni cin cS vz vd cv vz cv
      ciun cin vz vd cv cS vz cv cin ciun vz vd cv vz cv cS cin ciun vd cv cuni
      vz vd cv vz cv ciun cS vz vd cv uniiun ineq2i vz vd cv cS vz cv iunin2 vz
      vd cv cS vz cv cin vz cv cS cin cS vz cv cin vz cv cS cin wceq vz cv vd
      cv wcel cS vz cv incom a1i iuneq2i 3eqtr2i syl6eq 3ad2ant2 vz vd cv vz cv
      cS cin ciun vx cv vz cv cS cin wceq vz vd cv wrex vx cab cuni wceq vd cv
      vy cv cS cin vs cv wcel vy cJ crab cpw wcel vd cv cfn wcel wa cS vd cv
      cuni wss cJ ctop wcel cS cX wss wa vs cv cS cJ cop csubsp cfv cpw wcel wa
      cS vs cv cuni wceq wa w3a vz vx vd cv vz cv cS cin vz cv cS vz visset
      inex1 dfiun2 a1i 3eqtrd sylanc 3exp sylbi r19.23aiv syl6 com3r mpd ex
      sylbid com23 syld r19.21adva $.
      $( [28-Jun-2009] $) $( [28-Jun-2009] $)

    $( Two equivalent ways of describing a compact subset of a topological
       space. Inspired by Sue E. Goodman's _Beginning Topology_. $)
    compsub $p |- ( ( J e. Top /\ S C_ X ) -> ( ( subSp ` <. S , J >. ) e. Comp
    <-> A. c e. ~P J ( S C_ U. c -> E. d e. ( ~P c i^i Fin ) S C_ U. d ) ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv ccomp wcel cS cJ cop
      csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq
      vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral cS vc cv
      cuni wss cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi vc cJ cpw wral cJ
      ctop wcel cS cX wss wa cS cJ cop csubsp cfv ctop wcel cS cJ cop csubsp
      cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs
      cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral wa cS cJ cop
      csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq
      vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral cS cJ cop
      csubsp cfv ccomp wcel cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv ctop
      wcel cS cJ cop csubsp cfv ctop wcel cS cJ cop csubsp cfv cuni vs cv cuni
      wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex
      wi vs cS cJ cop csubsp cfv cpw wral wa cS cJ cop csubsp cfv cuni vs cv
      cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin
      wrex wi vs cS cJ cop csubsp cfv cpw wral wb cJ ctop wcel cS cJ cuni wss
      cS cJ cop csubsp cfv ctop wcel cS cX wss cS cJ stoig3 cX cJ cuni cS
      compsub.1 sseq2i sylan2b cS cJ cop csubsp cfv ctop wcel cS cJ cop csubsp
      cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs
      cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral cS cJ cop csubsp
      cfv ctop wcel cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp
      cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp
      cfv cpw wral wa cS cJ cop csubsp cfv ctop wcel cS cJ cop csubsp cfv cuni
      vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw
      cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral ibar bicomd syl vs vt cS
      cJ cop csubsp cfv iscomp syl5bb cJ ctop wcel cS cX wss wa cS cJ cop
      csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq
      vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral cS vc cv
      cuni wss cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi vc cJ cpw wral cJ
      ctop wcel cS cX wss wa cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ
      cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex wi vs cS cJ
      cop csubsp cfv cpw wral cS vc cv cuni wss cS vd cv cuni wss vd vc cv cpw
      cfn cin wrex wi vc cJ cpw cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa
      cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv
      cuni wceq vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral
      cS cJ cop csubsp cfv cuni vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vx cv vy cv cS cin
      wceq vy vc cv wrex vx cab cpw cfn cin wrex wi cS vc cv cuni wss cS vd cv
      cuni wss vd vc cv cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa vc cv cJ
      cpw wcel wa cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp
      cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp
      cfv cpw wral cS cJ cop csubsp cfv cuni vx cv vy cv cS cin wceq vy vc cv
      wrex vx cab cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vx cv
      vy cv cS cin wceq vy vc cv wrex vx cab cpw cfn cin wrex wi vx cv vy cv cS
      cin wceq vy vc cv wrex vx cab cS cJ cop csubsp cfv cpw wcel cS cJ cop
      csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq
      vt vs cv cpw cfn cin wrex wi vs cS cJ cop csubsp cfv cpw wral cS cJ cop
      csubsp cfv cuni vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni wceq cS
      cJ cop csubsp cfv cuni vt cv cuni wceq vt vx cv vy cv cS cin wceq vy vc
      cv wrex vx cab cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa vc cv cJ cpw
      wcel wa cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp cfv
      cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex wi cS cJ cop csubsp cfv
      cuni vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni wceq cS cJ cop
      csubsp cfv cuni vt cv cuni wceq vt vx cv vy cv cS cin wceq vy vc cv wrex
      vx cab cpw cfn cin wrex wi vs vx cv vy cv cS cin wceq vy vc cv wrex vx
      cab cS cJ cop csubsp cfv cpw vs cv vx cv vy cv cS cin wceq vy vc cv wrex
      vx cab wceq cS cJ cop csubsp cfv cuni vs cv cuni wceq cS cJ cop csubsp
      cfv cuni vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni wceq cS cJ cop
      csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin wrex cS cJ cop
      csubsp cfv cuni vt cv cuni wceq vt vx cv vy cv cS cin wceq vy vc cv wrex
      vx cab cpw cfn cin wrex vs cv vx cv vy cv cS cin wceq vy vc cv wrex vx
      cab wceq vs cv cuni vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni cS
      cJ cop csubsp cfv cuni vs cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      unieq eqeq2d vs cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab wceq cS
      cJ cop csubsp cfv cuni vt cv cuni wceq vt vs cv cpw cfn cin vx cv vy cv
      cS cin wceq vy vc cv wrex vx cab cpw cfn cin vs cv vx cv vy cv cS cin
      wceq vy vc cv wrex vx cab wceq vs cv cpw vx cv vy cv cS cin wceq vy vc cv
      wrex vx cab cpw cfn vs cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      pweq ineq1d rexeq1d imbi12d rcla4va cJ ctop wcel cS cX wss wa vc cv cJ
      cpw wcel wa vx cv vy cv cS cin wceq vy vc cv wrex vx cab cS cJ cop csubsp
      cfv wss vx cv vy cv cS cin wceq vy vc cv wrex vx cab cS cJ cop csubsp cfv
      cpw wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa vt vx cv vy cv cS
      cin wceq vy vc cv wrex vx cab cS cJ cop csubsp cfv cJ ctop wcel cS cX wss
      wa vc cv cJ cpw wcel wa vt cv vy cv cS cin wceq vy vc cv wrex vt cv cS cJ
      cop csubsp cfv wcel vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa vt cv vy cv cS cin
      wceq vy vc cv wrex vt cv vd cv cS cin wceq vd cJ wrex vt cv cS cJ cop
      csubsp cfv wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa vt cv vy
      cv cS cin wceq vt cv vd cv cS cin wceq vd cJ wrex vy vc cv vc cv cJ cpw
      wcel vy cv vc cv wcel vt cv vy cv cS cin wceq vt cv vd cv cS cin wceq vd
      cJ wrex wi wi cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel vc cv cJ wss vy
      cv vc cv wcel vt cv vy cv cS cin wceq vt cv vd cv cS cin wceq vd cJ wrex
      wi wi vc cv cJ vc visset elpw vc cv cJ wss vy cv vc cv wcel vt cv vy cv
      cS cin wceq vt cv vd cv cS cin wceq vd cJ wrex wi vc cv cJ wss vy cv vc
      cv wcel wa vy cv cJ wcel vt cv vy cv cS cin wceq vt cv vd cv cS cin wceq
      vd cJ wrex wi vc cv cJ vy cv ssel2 vy cv cJ wcel vt cv vy cv cS cin wceq
      vt cv vd cv cS cin wceq vd cJ wrex vt cv vd cv cS cin wceq vt cv vy cv cS
      cin wceq vd vy cv cJ vd cv vy cv wceq vd cv cS cin vy cv cS cin vt cv vd
      cv vy cv cS ineq1 eqeq2d rcla4ev ex syl ex sylbi adantl r19.23adv cJ ctop
      wcel vt cv cvv wcel cS cvv wcel vt cv cS cJ cop csubsp cfv wcel vt cv vd
      cv cS cin wceq vd cJ wrex wb cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel
      wa vd vt cv cS cvv cJ issubspt cJ ctop wcel cS cX wss vc cv cJ cpw wcel
      simpll vt cv cvv wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa vt
      visset a1i cJ ctop wcel cS cX wss wa cS cvv wcel vc cv cJ cpw wcel cJ
      ctop wcel cS cJ cuni wss cS cvv wcel cS cX wss cS cJ cuni wss cJ ctop
      wcel cS cvv wcel cS cJ cuni wss cJ cuni cvv wcel cS cvv wcel cJ ctop wcel
      cS cJ cuni cvv ssexg cJ ctop uniexg sylan2 ancoms cX cJ cuni cS compsub.1
      sseq2i sylan2b adantr syl3anc sylibrd vx cv vy cv cS cin wceq vy vc cv
      wrex vt cv vy cv cS cin wceq vy vc cv wrex vx vt cv vt visset vx cv vt cv
      wceq vx cv vy cv cS cin wceq vt cv vy cv cS cin wceq vy vc cv vx cv vt cv
      vy cv cS cin eqeq1 rexbidv elab syl5ib ssrdv vx cv vy cv cS cin wceq vy
      vc cv wrex vx cab cS cJ cop csubsp cfv vy vx vc cv vy cv cS cin vc visset
      abrexex elpw sylibr sylan ex cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel
      wa cS vc cv cuni wss cS cJ cop csubsp cfv cuni vx cv vy cv cS cin wceq vy
      vc cv wrex vx cab cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt
      vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw cfn cin wrex wi cS vd cv
      cuni wss vd vc cv cpw cfn cin wrex cJ ctop wcel cS cX wss wa vc cv cJ cpw
      wcel wa cS vc cv cuni wss cS cJ cop csubsp cfv cuni vx cv vy cv cS cin
      wceq vy vc cv wrex vx cab cuni wceq cS cJ cop csubsp cfv cuni vt cv cuni
      wceq vt vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw cfn cin wrex wi
      cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa
      vc cv cJ cpw wcel wa cS vc cv cuni wss wa cS cJ cop csubsp cfv cuni vx cv
      vy cv cS cin wceq vy vc cv wrex vx cab cuni wceq cS cJ cop csubsp cfv
      cuni vt cv cuni wceq vt vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw
      cfn cin wrex wi cS cS wceq cS vt cv cuni wceq vt vx cv vy cv cS cin wceq
      vy vc cv wrex vx cab cpw cfn cin wrex wi cS vd cv cuni wss vd vc cv cpw
      cfn cin wrex cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni
      wss wa cS cJ cop csubsp cfv cuni vx cv vy cv cS cin wceq vy vc cv wrex vx
      cab cuni wceq cS cS wceq cS cJ cop csubsp cfv cuni vt cv cuni wceq vt vx
      cv vy cv cS cin wceq vy vc cv wrex vx cab cpw cfn cin wrex cS vt cv cuni
      wceq vt vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw cfn cin wrex cJ
      ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa cS cJ
      cop csubsp cfv cuni cS vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni
      cS cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv cuni cS wceq vc cv cJ
      cpw wcel cS vc cv cuni wss cJ ctop wcel cS cJ cuni wss cS cJ cop csubsp
      cfv cuni cS wceq cS cX wss cS cJ stoig2 cX cJ cuni cS compsub.1 sseq2i
      sylan2b ad2antrr cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv
      cuni wss wa vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni vy vc cv vy
      cv cS cin ciun vy vc cv cS vy cv cin ciun cS vx cv vy cv cS cin wceq vy
      vc cv wrex vx cab cuni vy vc cv vy cv cS cin ciun wceq cJ ctop wcel cS cX
      wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vy vc cv vy cv cS cin
      ciun vx cv vy cv cS cin wceq vy vc cv wrex vx cab cuni vy vx vc cv vy cv
      cS cin vy cv cS vy visset inex1 dfiun2 eqcomi a1i cJ ctop wcel cS cX wss
      wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vy vc cv vy cv cS cin cS vy
      cv cin vy cv cS cin cS vy cv cin wceq cJ ctop wcel cS cX wss wa vc cv cJ
      cpw wcel wa cS vc cv cuni wss wa vy cv vc cv wcel wa vy cv cS incom a1i
      iuneq2dv cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss
      wa vy vc cv cS vy cv cin ciun cS vy vc cv vy cv ciun cin cS vc cv cuni
      cin cS vy vc cv cS vy cv cin ciun cS vy vc cv vy cv ciun cin wceq cJ ctop
      wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vy vc cv cS
      vy cv iunin2 a1i cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv
      cuni wss wa vy vc cv vy cv ciun vc cv cuni cS vy vc cv vy cv ciun vc cv
      cuni wceq cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni
      wss wa vc cv cuni vy vc cv vy cv ciun vy vc cv uniiun eqcomi a1i ineq2d
      cS vc cv cuni wss cS vc cv cuni cin cS wceq cJ ctop wcel cS cX wss wa vc
      cv cJ cpw wcel wa cS vc cv cuni wss vc cv cuni cS cin cS cS vc cv cuni
      cin cS vc cv cuni wss vc cv cuni cS cin cS wceq cS vc cv cuni sseqin2
      biimpi cS vc cv cuni incom syl5eq adantl 3eqtrd 3eqtrd eqeq12d cJ ctop
      wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa cS cJ cop
      csubsp cfv cuni vt cv cuni wceq cS vt cv cuni wceq vt vx cv vy cv cS cin
      wceq vy vc cv wrex vx cab cpw cfn cin cJ ctop wcel cS cX wss wa vc cv cJ
      cpw wcel wa cS vc cv cuni wss wa cS cJ cop csubsp cfv cuni cS vt cv cuni
      cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv cuni cS wceq vc cv cJ cpw
      wcel cS vc cv cuni wss cJ ctop wcel cS cJ cuni wss cS cJ cop csubsp cfv
      cuni cS wceq cS cX wss cS cJ stoig2 cX cJ cuni cS compsub.1 sseq2i
      sylan2b ad2antrr eqeq1d rexbidv imbi12d cJ ctop wcel cS cX wss wa vc cv
      cJ cpw wcel wa cS vc cv cuni wss wa cS vt cv cuni wceq vt vx cv vy cv cS
      cin wceq vy vc cv wrex vx cab cpw cfn cin wrex cS vd cv cuni wss vd vc cv
      cpw cfn cin wrex cS cS wceq cS vt cv cuni wceq vt vx cv vy cv cS cin wceq
      vy vc cv wrex vx cab cpw cfn cin wrex wi cJ ctop wcel cS cX wss wa vc cv
      cJ cpw wcel wa cS vc cv cuni wss wa cS vt cv cuni wceq cS vd cv cuni wss
      vd vc cv cpw cfn cin wrex vt vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      cpw cfn cin cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni
      wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel
      wa cS vt cv cuni wceq cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi vt
      cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw cfn cin wcel cJ ctop
      wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv vy cv
      cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa vt cv vc cv
      vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vf wex cS vt
      cv cuni wceq cS vd cv cuni wss vd vc cv cpw cfn cin wrex wi vs cv vy cv
      cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa vt cv vc cv vf
      cv wf vs cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vf wex cJ ctop
      wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vt cv cfn
      wcel vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv vc cv vf
      cv wf vs cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vf wex vs cv vy
      cv cS cin wceq vs cv vs cv vf cv cfv cS cin wceq vs vy vt cv vc cv vf vy
      cv vs cv vf cv cfv wceq vy cv cS cin vs cv vf cv cfv cS cin vs cv vy cv
      vs cv vf cv cfv cS ineq1 eqeq2d ac6sfi ancoms adantl cJ ctop wcel cS cX
      wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq
      vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa vt cv vc cv vf cv wf vs
      cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vf wex cS vt cv cuni wceq
      vf cv crn vc cv cpw cfn cin wcel cS vf cv crn cuni wss wa vf wex cS vd cv
      cuni wss vd vc cv cpw cfn cin wrex cJ ctop wcel cS cX wss wa vc cv cJ cpw
      wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt
      cv wral vt cv cfn wcel wa wa cS vt cv cuni wceq vt cv vc cv vf cv wf vs
      cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vf wex vf cv crn vc cv
      cpw cfn cin wcel cS vf cv crn cuni wss wa vf wex cJ ctop wcel cS cX wss
      wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy
      vc cv wrex vs vt cv wral vt cv cfn wcel wa wa cS vt cv cuni wceq vt cv vc
      cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vf wex vf
      cv crn vc cv cpw cfn cin wcel cS vf cv crn cuni wss wa vf wex wi cJ ctop
      wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv vy cv
      cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa cS vt cv
      cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs vt
      cv wral wa vf cv crn vc cv cpw cfn cin wcel cS vf cv crn cuni wss wa vf
      cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv
      vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa cS vt
      cv cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs
      vt cv wral wa vf cv crn vc cv cpw cfn cin wcel cS vf cv crn cuni wss wa
      cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv
      vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa cS vt
      cv cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs
      vt cv wral wa wa vf cv crn vc cv cpw cfn cin wcel cS vf cv crn cuni wss
      cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv
      vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa cS vt
      cv cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs
      vt cv wral wa wa vf cv crn vc cv cpw wcel vf cv crn cfn wcel wa vf cv crn
      vc cv cpw cfn cin wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS
      vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt
      cv cfn wcel wa wa cS vt cv cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv
      vf cv cfv cS cin wceq vs vt cv wral wa wa vf cv crn vc cv cpw wcel vf cv
      crn cfn wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni
      wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel
      wa wa cS vt cv cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS
      cin wceq vs vt cv wral wa wa vf cv crn vc cv wss vf cv crn vc cv cpw wcel
      vt cv vc cv vf cv wf vf cv crn vc cv wss cJ ctop wcel cS cX wss wa vc cv
      cJ cpw wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex
      vs vt cv wral vt cv cfn wcel wa wa cS vt cv cuni wceq wa vs cv vs cv vf
      cv cfv cS cin wceq vs vt cv wral vt cv vc cv vf cv frn ad2antrl vf cv crn
      vc cv vf cv vf visset rnex elpw sylibr vt cv cfn wcel vf cv crn vt cv
      cdom wbr vf cv crn cfn wcel cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel
      wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv
      wral vt cv cfn wcel wa wa cS vt cv cuni wceq wa vt cv vc cv vf cv wf vs
      cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa wa vt cv vf cv crn domfi
      cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv
      vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa wa vt cv
      cfn wcel cS vt cv cuni wceq vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS
      cin wceq vs vt cv wral wa cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa
      cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral
      vt cv cfn wcel simprr ad2antrr cJ ctop wcel cS cX wss wa vc cv cJ cpw
      wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt
      cv wral vt cv cfn wcel wa wa vt cv vc cv vf cv wf vf cv crn vt cv cdom
      wbr cS vt cv cuni wceq vs cv vs cv vf cv cfv cS cin wceq vs vt cv wral vs
      cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel wa vt cv
      vc cv vf cv wf vf cv crn vt cv cdom wbr cJ ctop wcel cS cX wss wa vc cv
      cJ cpw wcel wa cS vc cv cuni wss wa vt cv cfn wcel vt cv vc cv vf cv wf
      vf cv crn vt cv cdom wbr vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv
      wral vt cv cfn wcel vt cv vf cv crn vf cv wfo vf cv crn vt cv cdom wbr vt
      cv vc cv vf cv wf vt cv vf cv crn vf cv fodomfi vt cv vc cv vf cv wf vf
      cv vt cv wfn vt cv vf cv crn vf cv wfo vt cv vc cv vf cv ffn vt cv vf cv
      dffn4 sylib sylan2 adantll adantll ad2ant2r sylanc jca vf cv crn vc cv
      cpw cfn elin sylibr cJ ctop wcel cS cX wss wa vc cv cJ cpw wcel wa cS vc
      cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv
      cfn wcel wa wa cS vt cv cuni wceq wa vt cv vc cv vf cv wf vs cv vs cv vf
      cv cfv cS cin wceq vs vt cv wral wa wa cS vf cv crn cuni wss vt cv cuni
      vf cv crn cuni wss vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq
      vs vt cv wral wa vt cv cuni vf cv crn cuni wss cJ ctop wcel cS cX wss wa
      vc cv cJ cpw wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc
      cv wrex vs vt cv wral vt cv cfn wcel wa wa cS vt cv cuni wceq wa vt cv vc
      cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq vs vt cv wral wa vw vt cv
      cuni vf cv crn cuni vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin
      wceq vs vt cv wral wa vw cv vu cv wcel vu cv vt cv wcel wa vu wex vw cv
      vv cv wcel vv cv vf cv crn wcel wa vv wex vw cv vt cv cuni wcel vw cv vf
      cv crn cuni wcel vt cv vc cv vf cv wf vs cv vs cv vf cv cfv cS cin wceq
      vs vt cv wral wa vw cv vu cv wcel vu cv vt cv wcel wa vw cv vv cv wcel vv
      cv vf cv crn wcel wa vv wex vu vt cv vc cv vf cv wf vs cv vs cv vf cv cfv
      cS cin wceq vs vt cv wral wa vw cv vu cv wcel vu cv vt cv wcel wa vw cv
      vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa vw cv vv cv wcel
      vv cv vf cv crn wcel wa vv wex vt cv vc cv vf cv wf vu cv vt cv wcel vu
      cv vu cv vf cv cfv cS cin wceq wi vw cv vu cv wcel vu cv vt cv wcel wa vw
      cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa wi vs cv vs cv
      vf cv cfv cS cin wceq vs vt cv wral vu cv vt cv wcel vu cv vu cv vf cv
      cfv cS cin wceq wi vt cv vc cv vf cv wf vw cv vu cv wcel vu cv vt cv wcel
      wa vw cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa wi vw cv
      vu cv wcel vu cv vt cv wcel wa vu cv vt cv wcel vu cv vu cv vf cv cfv cS
      cin wceq wi vt cv vc cv vf cv wf vw cv vu cv vf cv cfv wcel vu cv vf cv
      cfv vf cv crn wcel wa vw cv vu cv wcel vu cv vt cv wcel vu cv vt cv wcel
      vu cv vu cv vf cv cfv cS cin wceq wi vt cv vc cv vf cv wf vw cv vu cv vf
      cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa wi wi vu cv vt cv wcel vu
      cv vt cv wcel vu cv vu cv vf cv cfv cS cin wceq wi vw cv vu cv wcel vt cv
      vc cv vf cv wf vw cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel
      wa wi vu cv vt cv wcel vu cv vt cv wcel vu cv vu cv vf cv cfv cS cin wceq
      wi vu cv vu cv vf cv cfv cS cin wceq vw cv vu cv wcel vt cv vc cv vf cv
      wf vw cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa wi wi vu
      cv vt cv wcel vu cv vu cv vf cv cfv cS cin wceq pm2.27 vu cv vt cv wcel
      vu cv vu cv vf cv cfv cS cin wceq vw cv vu cv wcel vt cv vc cv vf cv wf
      vw cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa wi vu cv vt
      cv wcel vu cv vu cv vf cv cfv cS cin wceq vw cv vu cv wcel w3a vt cv vc
      cv vf cv wf vw cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel vu
      cv vt cv wcel vu cv vu cv vf cv cfv cS cin wceq vw cv vu cv wcel vt cv vc
      cv vf cv wf vw cv vu cv vf cv cfv wcel wi vu cv vu cv vf cv cfv cS cin
      wceq vw cv vu cv wcel vt cv vc cv vf cv wf vw cv vu cv vf cv cfv wcel wi
      wi wi vu cv vt cv wcel vu cv vu cv vf cv cfv cS cin wceq vu cv vu cv vf
      cv cfv wss vw cv vu cv wcel vt cv vc cv vf cv wf vw cv vu cv vf cv cfv
      wcel wi wi vu cv vu cv vf cv cfv cS cin wceq vu cv vu cv vf cv cfv wss vu
      cv vf cv cfv cS cin vu cv vf cv cfv wss vu cv vf cv cfv cS inss1 vu cv vu
      cv vf cv cfv cS cin vu cv vf cv cfv sseq1 mpbiri vu cv vu cv vf cv cfv
      wss vw cv vu cv wcel vw cv vu cv vf cv cfv wcel vt cv vc cv vf cv wf vu
      cv vu cv vf cv cfv vw cv ssel a1dd syl a1i 3imp vu cv vt cv wcel vu cv vu
      cv vf cv cfv cS cin wceq vw cv vu cv wcel w3a vf cv vt cv wfn vu cv vf cv
      cfv vf cv crn wcel vt cv vc cv vf cv wf vu cv vt cv wcel vu cv vu cv vf
      cv cfv cS cin wceq vf cv vt cv wfn vu cv vf cv cfv vf cv crn wcel wi vw
      cv vu cv wcel vf cv vt cv wfn vu cv vt cv wcel vu cv vf cv cfv vf cv crn
      wcel vt cv vu cv vf cv fnfvelrn expcom 3ad2ant1 vt cv vc cv vf cv ffn
      syl5 jcad 3exp syld com3r imp com3l impcom vs cv vs cv vf cv cfv cS cin
      wceq vu cv vu cv vf cv cfv cS cin wceq vs vu cv vt cv vs cv vu cv wceq vs
      cv vu cv vs cv vf cv cfv cS cin vu cv vf cv cfv cS cin vs cv vu cv wceq
      id vs cv vu cv wceq vs cv vf cv cfv vu cv vf cv cfv cS vs cv vu cv vf cv
      fveq2 ineq1d eqeq12d rcla4cv sylan2 vw cv vv cv wcel vv cv vf cv crn wcel
      wa vw cv vu cv vf cv cfv wcel vu cv vf cv cfv vf cv crn wcel wa vv vu cv
      vf cv cfv vu cv vf cv fvex vv cv vu cv vf cv cfv wceq vw cv vv cv wcel vw
      cv vu cv vf cv cfv wcel vv cv vf cv crn wcel vu cv vf cv cfv vf cv crn
      wcel vv cv vu cv vf cv cfv vw cv eleq2 vv cv vu cv vf cv cfv vf cv crn
      eleq1 anbi12d cla4ev syl6 19.23adv vu vw cv vt cv eluni vv vw cv vf cv
      crn eluni 3imtr4g ssrdv adantl cS vt cv cuni wceq cS vf cv crn cuni wss
      vt cv cuni vf cv crn cuni wss wb cJ ctop wcel cS cX wss wa vc cv cJ cpw
      wcel wa cS vc cv cuni wss wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt
      cv wral vt cv cfn wcel wa wa vt cv vc cv vf cv wf vs cv vs cv vf cv cfv
      cS cin wceq vs vt cv wral wa cS vt cv cuni vf cv crn cuni sseq1 ad2antlr
      mpbird jca ex 19.22dv ex com23 vf cv crn vc cv cpw cfn cin wcel cS vf cv
      crn cuni wss wa cS vd cv cuni wss vd vc cv cpw cfn cin wrex vf cS vd cv
      cuni wss cS vf cv crn cuni wss vd vf cv crn vc cv cpw cfn cin vd cv vf cv
      crn wceq vd cv cuni vf cv crn cuni cS vd cv vf cv crn unieq sseq2d
      rcla4ev 19.23aiv syl8 mpd vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx
      cab cpw cfn cin wcel vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      cpw wcel vt cv cfn wcel wa vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv
      wral vt cv cfn wcel wa vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab
      cpw cfn elin vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw wcel
      vs cv vy cv cS cin wceq vy vc cv wrex vs vt cv wral vt cv cfn wcel vt cv
      vx cv vy cv cS cin wceq vy vc cv wrex vx cab cpw wcel vt cv vx cv vy cv
      cS cin wceq vy vc cv wrex vx cab wss vs cv vx cv vy cv cS cin wceq vy vc
      cv wrex vx cab wcel vs vt cv wral vs cv vy cv cS cin wceq vy vc cv wrex
      vs vt cv wral vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab vt
      visset elpw vs vt cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab dfss3
      vs cv vx cv vy cv cS cin wceq vy vc cv wrex vx cab wcel vs cv vy cv cS
      cin wceq vy vc cv wrex vs vt cv vx cv vy cv cS cin wceq vy vc cv wrex vs
      cv vy cv cS cin wceq vy vc cv wrex vx vs cv vs visset vx cv vs cv wceq vx
      cv vy cv cS cin wceq vs cv vy cv cS cin wceq vy vc cv vx cv vs cv vy cv
      cS cin eqeq1 rexbidv elab ralbii 3bitri anbi1i bitri sylan2b r19.23adva
      cS cS wceq cS vt cv cuni wceq vt vx cv vy cv cS cin wceq vy vc cv wrex vx
      cab cpw cfn cin wrex cS eqid a1bi syl5ibr sylbid ex com23 syld r19.21adva
      vt cS cJ cX vs vc vd compsub.1 compsublem impbid bitrd $.
      $( [28-Jun-2009] $) $( [22-Jun-2009] $)
  $}

  ${
    $d s t u v w J $. $d s t u v w S $.
    $( A closed subset of a compact space is compact. $)
  cptclsscpt $p |- ( ( J e. Comp /\ S e. ( Clsd ` J ) ) -> ( subSp ` <. S , J
  >. ) e. Comp ) $=
    cJ ccomp wcel cS cJ ccld cfv wcel wa cS cJ cop csubsp cfv ccomp wcel cS vs
    cv cuni wss cS vt cv cuni wss vt vs cv cpw cfn cin wrex wi vs cJ cpw wral
    cJ ccomp wcel cS cJ ccld cfv wcel wa cS vs cv cuni wss cS vt cv cuni wss vt
    vs cv cpw cfn cin wrex wi vs cJ cpw cJ ccomp wcel cS cJ ccld cfv wcel wa vs
    cv cJ wss cS vs cv cuni wss cS vt cv cuni wss vt vs cv cpw cfn cin wrex wi
    vs cv cJ cpw wcel cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs
    cv cuni wss cS vt cv cuni wss vt vs cv cpw cfn cin wrex cJ ccomp wcel cS cJ
    ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni vu cv cuni wceq
    vu vs cv cJ cuni cS cdif csn cun cpw cfn cin wrex cS vt cv cuni wss vt vs
    cv cpw cfn cin wrex cJ ccomp wcel vs cv cJ cuni cS cdif csn cun cJ wss cJ
    cuni vs cv cJ cuni cS cdif csn cun cuni wceq cJ cuni vu cv cuni wceq vu vs
    cv cJ cuni cS cdif csn cun cpw cfn cin wrex cJ ccomp wcel cS cJ ccld cfv
    wcel wa vs cv cJ wss cS vs cv cuni wss w3a vs cv cJ cuni cS cdif csn cun cJ
    cJ cuni vu cJ cuni eqid compcov cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv
    cJ wss cJ ccomp wcel cS vs cv cuni wss cJ ccomp wcel cS cJ ccld cfv wcel vs
    cv cJ wss simpll 3adant3 cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss
    cS vs cv cuni wss w3a vs cv cJ wss cJ cuni cS cdif csn cJ wss wa vs cv cJ
    cuni cS cdif csn cun cJ wss cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ
    wss cS vs cv cuni wss w3a vs cv cJ wss cJ cuni cS cdif csn cJ wss cJ ccomp
    wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss 3simp2 cJ ccomp
    wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni cS
    cdif cJ wcel cJ cuni cS cdif csn cJ wss cJ ccomp wcel cS cJ ccld cfv wcel
    wa vs cv cJ wss cJ cuni cS cdif cJ wcel cS vs cv cuni wss cJ ctop wcel cS
    cJ ccld cfv wcel cJ cuni cS cdif cJ wcel cJ ccomp wcel cS cJ cJ cuni cJ
    cuni eqid cldopn cJ comptop sylan 3ad2ant1 cJ cuni cS cdif cJ snssi syl jca
    vs cv cJ cuni cS cdif csn cJ unss sylib cJ ccomp wcel cS cJ ccld cfv wcel
    wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni vs cv cuni cJ cuni cS cdif
    csn cuni cun vs cv cJ cuni cS cdif csn cun cuni cJ ccomp wcel cS cJ ccld
    cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni vs cv cuni cJ cuni
    cS cdif cun vs cv cuni cJ cuni cS cdif csn cuni cun cJ ccomp wcel cS cJ
    ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni vs cv cuni cJ
    cuni cS cdif cun cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv
    cuni wss w3a cJ cuni cS cJ cuni cS cdif cun vs cv cuni cJ cuni cS cdif cun
    cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cS
    cJ cuni wss cS cJ cuni cS cdif cun cJ cuni wceq cJ ccomp wcel cS cJ ccld
    cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cS vs cv cuni cJ cuni cJ
    ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss 3simp3 vs
    cv cJ wss cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cuni cJ cuni wss cS vs
    cv cuni wss vs cv cJ uniss 3ad2ant2 sstrd cS cJ cuni undif sylib cS vs cv
    cuni wss cJ ccomp wcel cS cJ ccld cfv wcel wa cS cJ cuni cS cdif cun vs cv
    cuni cJ cuni cS cdif cun wss vs cv cJ wss cS vs cv cuni cJ cuni cS cdif
    unss1 3ad2ant3 eqsstr3d cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss
    cS vs cv cuni wss w3a vs cv cuni cJ cuni wss cJ cuni cS cdif cJ cuni wss wa
    vs cv cuni cJ cuni cS cdif cun cJ cuni wss cJ ccomp wcel cS cJ ccld cfv
    wcel wa vs cv cJ wss cS vs cv cuni wss w3a vs cv cuni cJ cuni wss cJ cuni
    cS cdif cJ cuni wss vs cv cJ wss cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv
    cuni cJ cuni wss cS vs cv cuni wss vs cv cJ uniss 3ad2ant2 cJ cuni cS difss
    jctir vs cv cuni cJ cuni cS cdif cJ cuni unss sylib eqssd cJ ccomp wcel cS
    cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni cS cdif csn
    cuni cJ cuni cS cdif vs cv cuni cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv
    cJ wss cS vs cv cuni wss w3a cJ cuni cvv wcel cJ cuni cS cdif cvv wcel cJ
    cuni cS cdif csn cuni cJ cuni cS cdif wceq cJ ccomp wcel cS cJ ccld cfv
    wcel wa vs cv cJ wss cJ cuni cvv wcel cS vs cv cuni wss cJ ccomp wcel cJ
    cuni cvv wcel cS cJ ccld cfv wcel vs cv cJ wss cJ ccomp uniexg ad2antrr
    3adant3 cJ cuni cS cvv difexg cJ cuni cS cdif cvv unisng 3syl uneq2d eqtr4d
    vs cv cJ cuni cS cdif csn uniun syl6eqr syl3anc cJ ccomp wcel cS cJ ccld
    cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a cJ cuni vu cv cuni wceq cS
    vt cv cuni wss vt vs cv cpw cfn cin wrex vu vs cv cJ cuni cS cdif csn cun
    cpw cfn cin cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni
    wss w3a vu cv vs cv cJ cuni cS cdif csn cun cpw cfn cin wcel cJ cuni vu cv
    cuni wceq cS vt cv cuni wss vt vs cv cpw cfn cin wrex cJ ccomp wcel cS cJ
    ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS
    cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq cS vt cv cuni
    wss vt vs cv cpw cfn cin wrex vu cv vs cv cJ cuni cS cdif csn cun cpw cfn
    cin wcel vu cv cJ cuni cS cdif csn cdif vs cv cpw cfn cin wcel cS vu cv cJ
    cuni cS cdif csn cdif cuni wss cS vt cv cuni wss vt vs cv cpw cfn cin wrex
    cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu
    cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni
    wceq w3a cS vt cv cuni wss cS vu cv cJ cuni cS cdif csn cdif cuni wss vt vu
    cv cJ cuni cS cdif csn cdif vs cv cpw cfn cin vt cv vu cv cJ cuni cS cdif
    csn cdif wceq vt cv cuni vu cv cJ cuni cS cdif csn cdif cuni cS vt cv vu cv
    cJ cuni cS cdif csn cdif unieq sseq2d rcla4ev cJ ccomp wcel cS cJ ccld cfv
    wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn
    cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vu cv cJ cuni cS cdif
    csn cdif vs cv wss vu cv cJ cuni cS cdif csn cdif cfn wcel wa vu cv cJ cuni
    cS cdif csn cdif vs cv cpw cfn cin wcel cJ ccomp wcel cS cJ ccld cfv wcel
    wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun
    wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vu cv cJ cuni cS cdif csn
    cdif vs cv wss vu cv cJ cuni cS cdif csn cdif cfn wcel cJ ccomp wcel cS cJ
    ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS
    cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vu cv cJ
    cuni cS cdif csn vs cv cun wss vu cv cJ cuni cS cdif csn cdif vs cv wss cJ
    ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv
    vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq
    w3a vu cv vs cv cJ cuni cS cdif csn cun cJ cuni cS cdif csn vs cv cun cJ
    ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv
    vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa vu cv vs cv cJ cuni cS
    cdif csn cun wss cJ cuni vu cv cuni wceq cJ ccomp wcel cS cJ ccld cfv wcel
    wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun
    wss vu cv cfn wcel simprl 3adant3 vs cv cJ cuni cS cdif csn uncom syl6ss vu
    cv cJ cuni cS cdif csn vs cv ssundif sylib cJ ccomp wcel cS cJ ccld cfv
    wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn
    cun wss vu cv cfn wcel wa vu cv cJ cuni cS cdif csn cdif cfn wcel cJ cuni
    vu cv cuni wceq vu cv cfn wcel vu cv cJ cuni cS cdif csn cdif cfn wcel cJ
    ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv
    vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel vu cv cJ cuni cS cdif csn
    cdif vu cv wss vu cv cJ cuni cS cdif csn cdif cfn wcel vu cv cJ cuni cS
    cdif csn difss vu cv vu cv cJ cuni cS cdif csn cdif ssfi mpan2 ad2antll
    3adant3 jca vu cv cJ cuni cS cdif csn cdif vs cv cpw cfn cin wcel vu cv cJ
    cuni cS cdif csn cdif vs cv cpw wcel vu cv cJ cuni cS cdif csn cdif cfn
    wcel wa vu cv cJ cuni cS cdif csn cdif vs cv wss vu cv cJ cuni cS cdif csn
    cdif cfn wcel wa vu cv cJ cuni cS cdif csn cdif vs cv cpw cfn elin vu cv cJ
    cuni cS cdif csn cdif vs cv cpw wcel vu cv cJ cuni cS cdif csn cdif vs cv
    wss vu cv cJ cuni cS cdif csn cdif cfn wcel vu cv cJ cuni cS cdif csn cdif
    vs cv vu cv cJ cuni cS cdif csn cdif vu cv vu visset vu cv cJ cuni cS cdif
    csn difss ssexi elpw anbi1i bitri sylibr cJ ccomp wcel cS cJ ccld cfv wcel
    wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun
    wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vv cS vu cv cJ cuni cS
    cdif csn cdif cuni cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs
    cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa
    cJ cuni vu cv cuni wceq w3a vv cv cS wcel vv cv vw cv wcel vw cv vu cv cJ
    cuni cS cdif csn cdif wcel wa vw wex vv cv vu cv cJ cuni cS cdif csn cdif
    cuni wcel cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni
    wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni
    vu cv cuni wceq w3a vv cv cS wcel vv cv vw cv wcel vw cv vu cv cJ cuni cS
    cdif csn cdif wcel wa vw wex cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ
    wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn
    wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS wcel wa vv cv vw cv wcel vw cv
    vu cv wcel wa vw wex vv cv vw cv wcel vw cv vu cv cJ cuni cS cdif csn cdif
    wcel wa vw wex cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv
    cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ
    cuni vu cv cuni wceq w3a vv cv cS wcel wa vv cv vu cv cuni wcel vv cv vw cv
    wcel vw cv vu cv wcel wa vw wex cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv
    cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv
    cfn wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS wcel vv cv vu cv cuni wcel
    cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu
    cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni
    wceq w3a cS vu cv cuni vv cv cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ
    wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn
    wcel wa cJ cuni vu cv cuni wceq w3a cS vs cv cuni vu cv cuni cJ ccomp wcel
    cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ
    cuni cS cdif csn cun wss vu cv cfn wcel wa cS vs cv cuni wss cJ cuni vu cv
    cuni wceq cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni
    wss 3simp3 3ad2ant1 cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs
    cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa
    cJ cuni vu cv cuni wceq w3a vs cv cuni cJ cuni vu cv cuni cJ ccomp wcel cS
    cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni
    cS cdif csn cun wss vu cv cfn wcel wa vs cv cuni cJ cuni wss cJ cuni vu cv
    cuni wceq vs cv cJ wss cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cuni cJ
    cuni wss cS vs cv cuni wss vs cv cJ uniss 3ad2ant2 3ad2ant1 cJ ccomp wcel
    cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ
    cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq 3simp3
    sseqtrd sstrd sseld imp vw vv cv vu cv eluni sylib cJ ccomp wcel cS cJ ccld
    cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif
    csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS wcel wa
    vv cv vw cv wcel vw cv vu cv wcel wa vv cv vw cv wcel vw cv vu cv cJ cuni
    cS cdif csn cdif wcel wa vw cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ
    wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn
    wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS wcel wa vv cv vw cv wcel vw cv
    vu cv wcel wa vv cv vw cv wcel vw cv vu cv cJ cuni cS cdif csn cdif wcel vv
    cv vw cv wcel vw cv vu cv wcel wa vv cv vw cv wcel wi cJ ccomp wcel cS cJ
    ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS
    cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS
    wcel wa vv cv vw cv wcel vw cv vu cv wcel pm3.26 a1i cJ ccomp wcel cS cJ
    ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS
    cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS
    wcel wa vv cv vw cv wcel vw cv vu cv wcel wa vw cv vu cv wcel vw cv cJ cuni
    cS cdif csn wcel wn wa vw cv vu cv cJ cuni cS cdif csn cdif wcel cJ ccomp
    wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv
    cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a
    vv cv cS wcel wa vv cv vw cv wcel vw cv vu cv wcel wa vw cv vu cv wcel vw
    cv cJ cuni cS cdif csn wcel wn vv cv vw cv wcel vw cv vu cv wcel wa vw cv
    vu cv wcel wi cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv
    cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ
    cuni vu cv cuni wceq w3a vv cv cS wcel wa vv cv vw cv wcel vw cv vu cv wcel
    pm3.27 a1i cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni
    wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni
    vu cv cuni wceq w3a vv cv cS wcel wa vv cv vw cv wcel vw cv vu cv wcel wa
    vw cv cJ cuni cS cdif wceq wn vw cv cJ cuni cS cdif csn wcel wn cJ ccomp
    wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv
    cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a
    vv cv cS wcel wa vv cv vw cv wcel vw cv cJ cuni cS cdif wceq wn vw cv vu cv
    wcel cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss
    w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv
    cuni wceq w3a vv cv cS wcel wa vv cv vw cv wcel vw cv cJ cuni cS cdif wceq
    wn cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a
    vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv
    cuni wceq w3a vv cv cS wcel wa vv cv vw cv wcel wa vw cv cJ cuni cS cdif
    wceq vv cv cJ cuni cS cdif wcel vv cv cS wcel vv cv cJ cuni cS cdif wcel wn
    cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu
    cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni
    wceq w3a vv cv vw cv wcel vv cv cS cJ cuni elndif ad2antlr cJ ccomp wcel cS
    cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni
    cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS
    wcel wa vv cv vw cv wcel vw cv cJ cuni cS cdif wceq vv cv cJ cuni cS cdif
    wcel wi cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ wss cS vs cv cuni wss
    w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn wcel wa cJ cuni vu cv
    cuni wceq w3a vv cv cS wcel wa vw cv cJ cuni cS cdif wceq vv cv vw cv wcel
    vv cv cJ cuni cS cdif wcel vw cv cJ cuni cS cdif wceq vv cv vw cv wcel vv
    cv cJ cuni cS cdif wcel wi wi cJ ccomp wcel cS cJ ccld cfv wcel wa vs cv cJ
    wss cS vs cv cuni wss w3a vu cv vs cv cJ cuni cS cdif csn cun wss vu cv cfn
    wcel wa cJ cuni vu cv cuni wceq w3a vv cv cS wcel wa vw cv cJ cuni cS cdif
    wceq vv cv vw cv wcel vv cv cJ cuni cS cdif wcel vw cv cJ cuni cS cdif vv
    cv eleq2 biimpd a1i com23 imp mtod ex adantrd vw cv cJ cuni cS cdif csn
    wcel vw cv cJ cuni cS cdif wceq vw cJ cuni cS cdif elsn notbii syl6ibr jcad
    vw cv vu cv cJ cuni cS cdif csn eldif syl6ibr jcad 19.22dv mpd ex vw vv cv
    vu cv cJ cuni cS cdif csn cdif eluni syl6ibr ssrdv sylanc vu cv vs cv cJ
    cuni cS cdif csn cun cpw cfn cin wcel vu cv vs cv cJ cuni cS cdif csn cun
    cpw wcel vu cv cfn wcel wa vu cv vs cv cJ cuni cS cdif csn cun wss vu cv
    cfn wcel wa vu cv vs cv cJ cuni cS cdif csn cun cpw cfn elin vu cv vs cv cJ
    cuni cS cdif csn cun cpw wcel vu cv vs cv cJ cuni cS cdif csn cun wss vu cv
    cfn wcel vu cv vs cv cJ cuni cS cdif csn cun vu visset elpw anbi1i bitri
    syl3an2b 3exp r19.23adv mpd 3exp vs cv cJ vs visset elpw syl5ib r19.21aiv
    cJ ctop wcel cS cJ ccld cfv wcel cS cJ cop csubsp cfv ccomp wcel cS vs cv
    cuni wss cS vt cv cuni wss vt vs cv cpw cfn cin wrex wi vs cJ cpw wral wb
    cJ ccomp wcel cJ ctop wcel cS cJ ccld cfv wcel cS cJ cuni wss cS cJ cop
    csubsp cfv ccomp wcel cS vs cv cuni wss cS vt cv cuni wss vt vs cv cpw cfn
    cin wrex wi vs cJ cpw wral wb cS cJ cJ cuni cJ cuni eqid cldss cS cJ cJ
    cuni vs vt cJ cuni eqid compsub syldan cJ comptop sylan mpbird $.
    $( [29-Jun-2009] $) $( [29-Jun-2009] $)
  $}

  ${
    $d c d m n r s J $. $d c d m n r s S $. $d c d m n r s T $. $d c d m n r s
    X $.
    uncomp.1 $e |- X = U. J $.
    $( The union of two compact sets is compact. $)
    uncomp $p |- ( ( ( J e. Top /\ X = ( S u. T ) ) /\ ( ( subSp ` <. S , J >.
    ) e. Comp /\ ( subSp ` <. T , J >. ) e. Comp ) ) -> J e. Comp ) $=
      cJ ctop wcel cX cS cT cun wceq wa cS cJ cop csubsp cfv ccomp wcel cT cJ
      cop csubsp cfv ccomp wcel wa wa cJ ctop wcel cJ cuni vc cv cuni wceq cJ
      cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc cJ cpw wral wa cJ
      ccomp wcel cJ ctop wcel cX cS cT cun wceq wa cS cJ cop csubsp cfv ccomp
      wcel cT cJ cop csubsp cfv ccomp wcel wa wa cJ ctop wcel cJ cuni vc cv
      cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc cJ cpw
      wral cJ ctop wcel cX cS cT cun wceq cS cJ cop csubsp cfv ccomp wcel cT cJ
      cop csubsp cfv ccomp wcel wa simpll cJ ctop wcel cX cS cT cun wceq wa cS
      cJ cop csubsp cfv ccomp wcel cT cJ cop csubsp cfv ccomp wcel wa wa cJ
      cuni vc cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc cJ cpw cJ ctop wcel cX cS cT cun wceq wa cS cJ cop csubsp cfv ccomp
      wcel cT cJ cop csubsp cfv ccomp wcel wa wa vc cv cJ cpw wcel cJ cuni vc
      cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex cJ ctop
      wcel cX cS cT cun wceq wa cS cJ cop csubsp cfv ccomp wcel cT cJ cop
      csubsp cfv ccomp wcel wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa cJ
      cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi cJ ctop wcel cX cS cT
      cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa cS cJ cop csubsp
      cfv ccomp wcel cT cJ cop csubsp cfv ccomp wcel wa cJ cuni vd cv cuni wceq
      vd vc cv cpw cfn cin wrex cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw
      wcel cJ cuni vc cv cuni wceq wa cS cJ cop csubsp cfv ccomp wcel cT cJ cop
      csubsp cfv ccomp wcel wa cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv
      cuni wceq wa wa cS vn cv cuni wss vn vc cv cpw cfn cin wrex cT vs cv cuni
      wss vs vc cv cpw cfn cin wrex cJ cuni vd cv cuni wceq vd vc cv cpw cfn
      cin wrex cS cJ cop csubsp cfv ccomp wcel cT cJ cop csubsp cfv ccomp wcel
      cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni
      wceq wa wa cS vn cv cuni wss cT vs cv cuni wss wa vs vc cv cpw cfn cin
      wrex vn vc cv cpw cfn cin wrex cJ cuni vd cv cuni wceq vd vc cv cpw cfn
      cin wrex cS vn cv cuni wss vn vc cv cpw cfn cin wrex cT vs cv cuni wss vs
      vc cv cpw cfn cin wrex wa cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw
      wcel cJ cuni vc cv cuni wceq wa wa cS vn cv cuni wss cT vs cv cuni wss wa
      cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex vn vs vc cv cpw cfn cin
      vc cv cpw cfn cin cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ
      cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv vc cv cpw
      cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa cJ cuni vd cv cuni
      wceq vd vc cv cpw cfn cin wrex vn cv vs cv cun vc cv cpw cfn cin wcel cJ
      cuni vn cv vs cv cun cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn
      cin wrex cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc
      cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv vc cv cpw cfn cin
      wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa wa cJ cuni vd cv cuni
      wceq cJ cuni vn cv vs cv cun cuni wceq vd vn cv vs cv cun vc cv cpw cfn
      cin vd cv vn cv vs cv cun wceq vd cv cuni vn cv vs cv cun cuni cJ cuni vd
      cv vn cv vs cv cun unieq eqeq2d rcla4ev cJ ctop wcel cX cS cT cun wceq wa
      vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin
      wcel vs cv vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss
      wa wa wa vn cv vs cv cun vc cv wss vn cv vs cv cun cfn wcel wa vn cv vs
      cv cun vc cv cpw cfn cin wcel cJ ctop wcel cX cS cT cun wceq wa vc cv cJ
      cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv
      vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa wa vn
      cv vs cv cun vc cv wss vn cv vs cv cun cfn wcel cJ ctop wcel cX cS cT cun
      wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw
      cfn cin wcel vs cv vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv
      cuni wss wa wa wa vn cv vc cv wss vs cv vc cv wss wa vn cv vs cv cun vc
      cv wss vn cv vc cv cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa vn cv
      vc cv wss vs cv vc cv wss wa cJ ctop wcel cX cS cT cun wceq wa vc cv cJ
      cpw wcel cJ cuni vc cv cuni wceq wa wa cS vn cv cuni wss cT vs cv cuni
      wss wa vn cv vc cv cpw cfn cin wcel vn cv vc cv wss vs cv vc cv cpw cfn
      cin wcel vs cv vc cv wss vn cv vc cv cpw cfn cin wcel vn cv vc cv cpw
      wcel vn cv vc cv wss vn cv vc cv cpw cfn cin wcel vn cv vc cv cpw wcel vn
      cv cfn wcel vn cv vc cv cpw cfn elin pm3.26bi vn cv vc cv elpwi syl vs cv
      vc cv cpw cfn cin wcel vs cv vc cv cpw wcel vs cv vc cv wss vs cv vc cv
      cpw cfn cin wcel vs cv vc cv cpw wcel vs cv cfn wcel vs cv vc cv cpw cfn
      elin pm3.26bi vs cv vc cv elpwi syl anim12i ad2antrl vn cv vs cv vc cv
      unss sylib vn cv vc cv cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa
      vn cv vs cv cun cfn wcel cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw
      wcel cJ cuni vc cv cuni wceq wa wa cS vn cv cuni wss cT vs cv cuni wss wa
      vn cv cfn wcel vs cv cfn wcel vn cv vs cv cun cfn wcel vn cv vc cv cpw
      cfn cin wcel vs cv vc cv cpw cfn cin wcel vn cv vs cv unfi vn cv vc cv
      cpw cfn cin wcel vn cv vc cv cpw wcel vn cv cfn wcel vn cv vc cv cpw cfn
      elin pm3.27bi vs cv vc cv cpw cfn cin wcel vs cv vc cv cpw wcel vs cv cfn
      wcel vs cv vc cv cpw cfn elin pm3.27bi syl2an ad2antrl jca vn cv vs cv
      cun vc cv cpw cfn cin wcel vn cv vs cv cun vc cv cpw wcel vn cv vs cv cun
      cfn wcel wa vn cv vs cv cun vc cv wss vn cv vs cv cun cfn wcel wa vn cv
      vs cv cun vc cv cpw cfn elin vn cv vs cv cun vc cv cpw wcel vn cv vs cv
      cun vc cv wss vn cv vs cv cun cfn wcel vn cv vs cv cun vc cv vc visset
      elpw2 anbi1i bitr2i sylib cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw
      wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv vc
      cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa wa cJ
      cuni vn cv vs cv cun cuni cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw
      wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv vc
      cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa wa cX vn
      cv cuni vs cv cuni cun cJ cuni vn cv vs cv cun cuni cJ ctop wcel cX cS cT
      cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv
      cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs
      cv cuni wss wa wa wa cX cS cT cun vn cv cuni vs cv cuni cun cJ ctop wcel
      cX cS cT cun wceq vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa vn cv vc
      cv cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT
      vs cv cuni wss wa wa simpllr cJ ctop wcel cX cS cT cun wceq wa vc cv cJ
      cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv
      vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa wa cS
      vn cv cuni vs cv cuni cun wss cT vn cv cuni vs cv cuni cun wss wa cS cT
      cun vn cv cuni vs cv cuni cun wss cS vn cv cuni wss cT vs cv cuni wss wa
      cS vn cv cuni vs cv cuni cun wss cT vn cv cuni vs cv cuni cun wss wa cJ
      ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq
      wa wa vn cv vc cv cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa cS vn
      cv cuni wss cS vn cv cuni vs cv cuni cun wss cT vs cv cuni wss cT vn cv
      cuni vs cv cuni cun wss cS vn cv cuni vs cv cuni ssun3 cT vs cv cuni vn
      cv cuni ssun4 anim12i ad2antll cS cT vn cv cuni vs cv cuni cun unss sylib
      eqsstrd uncomp.1 vn cv vs cv cun cuni vn cv cuni vs cv cuni cun vn cv vs
      cv uniun eqcomi 3sstr3g cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw
      wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw cfn cin wcel vs cv vc
      cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa wa vn cv
      vs cv cun cJ wss vn cv vs cv cun cuni cJ cuni wss cJ ctop wcel cX cS cT
      cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv
      cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs
      cv cuni wss wa wa wa vn cv vs cv cun vc cv cJ cJ ctop wcel cX cS cT cun
      wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa vn cv vc cv cpw
      cfn cin wcel vs cv vc cv cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv
      cuni wss wa wa wa vn cv vc cv wss vs cv vc cv wss wa vn cv vs cv cun vc
      cv wss vn cv vc cv cpw cfn cin wcel vs cv vc cv cpw cfn cin wcel wa vn cv
      vc cv wss vs cv vc cv wss wa cJ ctop wcel cX cS cT cun wceq wa vc cv cJ
      cpw wcel cJ cuni vc cv cuni wceq wa wa cS vn cv cuni wss cT vs cv cuni
      wss wa vn cv vc cv cpw cfn cin wcel vn cv vc cv wss vs cv vc cv cpw cfn
      cin wcel vs cv vc cv wss vn cv vc cv cpw cfn cin wcel vn cv vc cv cpw
      wcel vn cv vc cv wss vn cv vc cv cpw cfn cin wcel vn cv vc cv cpw wcel vn
      cv cfn wcel vn cv vc cv cpw cfn elin pm3.26bi vn cv vc cv elpwi syl vs cv
      vc cv cpw cfn cin wcel vs cv vc cv cpw wcel vs cv vc cv wss vs cv vc cv
      cpw cfn cin wcel vs cv vc cv cpw wcel vs cv cfn wcel vs cv vc cv cpw cfn
      elin pm3.26bi vs cv vc cv elpwi syl anim12i ad2antrl vn cv vs cv vc cv
      unss sylib vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa vc cv cJ wss cJ
      ctop wcel cX cS cT cun wceq wa vn cv vc cv cpw cfn cin wcel vs cv vc cv
      cpw cfn cin wcel wa cS vn cv cuni wss cT vs cv cuni wss wa wa vc cv cJ
      cpw wcel vc cv cJ wss cJ cuni vc cv cuni wceq vc cv cJ elpwi adantr
      ad2antlr sstrd vn cv vs cv cun cJ uniss syl eqssd sylanc exp32 r19.23advv
      cS vn cv cuni wss cT vs cv cuni wss vn vs vc cv cpw cfn cin vc cv cpw cfn
      cin reeanv syl5ibr cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ
      cuni vc cv cuni wceq wa wa cS cJ cop csubsp cfv ccomp wcel cS vm cv cuni
      wss cS vn cv cuni wss vn vm cv cpw cfn cin wrex wi vm cJ cpw wral cS vn
      cv cuni wss vn vc cv cpw cfn cin wrex cJ ctop wcel cS cX wss cS cJ cop
      csubsp cfv ccomp wcel cS vm cv cuni wss cS vn cv cuni wss vn vm cv cpw
      cfn cin wrex wi vm cJ cpw wral wb cJ ctop wcel cX cS cT cun wceq wa vc cv
      cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cS cJ cX vm vn uncomp.1 compsub
      cJ ctop wcel cX cS cT cun wceq vc cv cJ cpw wcel cJ cuni vc cv cuni wceq
      wa simpll cX cS cT cun wceq cS cX wss cJ ctop wcel vc cv cJ cpw wcel cJ
      cuni vc cv cuni wceq wa cX cS cT cun wceq cS cX wss cS cS cT cun wss cS
      cT ssun1 cX cS cT cun cS sseq2 mpbiri ad2antlr sylanc cJ ctop wcel cX cS
      cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cS vm cv
      cuni wss cS vn cv cuni wss vn vm cv cpw cfn cin wrex wi vm cJ cpw wral cS
      vc cv cuni wss cS vn cv cuni wss vn vc cv cpw cfn cin wrex cJ ctop wcel
      cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cS
      cX vc cv cuni cX cS cT cun wceq cS cX wss cJ ctop wcel vc cv cJ cpw wcel
      cJ cuni vc cv cuni wceq wa cX cS cT cun wceq cS cX wss cS cS cT cun wss
      cS cT ssun1 cX cS cT cun cS sseq2 mpbiri ad2antlr cJ ctop wcel cX cS cT
      cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cJ cuni vc cv
      cuni cX cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv
      cuni wceq simprr uncomp.1 syl5eq sseqtrd vc cv cJ cpw wcel cS vm cv cuni
      wss cS vn cv cuni wss vn vm cv cpw cfn cin wrex wi vm cJ cpw wral cS vc
      cv cuni wss cS vn cv cuni wss vn vc cv cpw cfn cin wrex wi wi cJ ctop
      wcel cX cS cT cun wceq wa cJ cuni vc cv cuni wceq cS vm cv cuni wss cS vn
      cv cuni wss vn vm cv cpw cfn cin wrex wi cS vc cv cuni wss cS vn cv cuni
      wss vn vc cv cpw cfn cin wrex wi vm vc cv cJ cpw vm cv vc cv wceq cS vm
      cv cuni wss cS vc cv cuni wss cS vn cv cuni wss vn vm cv cpw cfn cin wrex
      cS vn cv cuni wss vn vc cv cpw cfn cin wrex vm cv vc cv wceq vm cv cuni
      vc cv cuni cS vm cv vc cv unieq sseq2d vm cv vc cv wceq cS vn cv cuni wss
      vn vm cv cpw cfn cin vc cv cpw cfn cin vm cv vc cv wceq vm cv cpw vc cv
      cpw cfn vm cv vc cv pweq ineq1d rexeq1d imbi12d rcla4v ad2antrl mpid
      sylbid cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv
      cuni wceq wa wa cT cJ cop csubsp cfv ccomp wcel cT vr cv cuni wss cT vs
      cv cuni wss vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cT vs cv cuni wss
      vs vc cv cpw cfn cin wrex cJ ctop wcel cT cX wss cT cJ cop csubsp cfv
      ccomp wcel cT vr cv cuni wss cT vs cv cuni wss vs vr cv cpw cfn cin wrex
      wi vr cJ cpw wral wb cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel
      cJ cuni vc cv cuni wceq wa wa cT cJ cX vr vs uncomp.1 compsub cJ ctop
      wcel cX cS cT cun wceq vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa
      simpll cX cS cT cun wceq cT cX wss cJ ctop wcel vc cv cJ cpw wcel cJ cuni
      vc cv cuni wceq wa cX cS cT cun wceq cT cX wss cT cS cT cun wss cT cS
      ssun2 cX cS cT cun cT sseq2 mpbiri ad2antlr sylanc cJ ctop wcel cX cS cT
      cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cT vr cv cuni
      wss cT vs cv cuni wss vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cT vc
      cv cuni wss cT vs cv cuni wss vs vc cv cpw cfn cin wrex cJ ctop wcel cX
      cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cT cX
      vc cv cuni cX cS cT cun wceq cT cX wss cJ ctop wcel vc cv cJ cpw wcel cJ
      cuni vc cv cuni wceq wa cX cS cT cun wceq cT cX wss cT cS cT cun wss cT
      cS ssun2 cX cS cT cun cT sseq2 mpbiri ad2antlr cJ ctop wcel cX cS cT cun
      wceq wa vc cv cJ cpw wcel cJ cuni vc cv cuni wceq wa wa cJ cuni vc cv
      cuni cX cJ ctop wcel cX cS cT cun wceq wa vc cv cJ cpw wcel cJ cuni vc cv
      cuni wceq simprr uncomp.1 syl5eq sseqtrd vc cv cJ cpw wcel cT vr cv cuni
      wss cT vs cv cuni wss vs vr cv cpw cfn cin wrex wi vr cJ cpw wral cT vc
      cv cuni wss cT vs cv cuni wss vs vc cv cpw cfn cin wrex wi wi cJ ctop
      wcel cX cS cT cun wceq wa cJ cuni vc cv cuni wceq cT vr cv cuni wss cT vs
      cv cuni wss vs vr cv cpw cfn cin wrex wi cT vc cv cuni wss cT vs cv cuni
      wss vs vc cv cpw cfn cin wrex wi vr vc cv cJ cpw vr cv vc cv wceq cT vr
      cv cuni wss cT vc cv cuni wss cT vs cv cuni wss vs vr cv cpw cfn cin wrex
      cT vs cv cuni wss vs vc cv cpw cfn cin wrex vr cv vc cv wceq vr cv cuni
      vc cv cuni cT vr cv vc cv unieq sseq2d vr cv vc cv wceq cT vs cv cuni wss
      vs vr cv cpw cfn cin vc cv cpw cfn cin vr cv vc cv wceq vr cv cpw vc cv
      cpw cfn vr cv vc cv pweq ineq1d rexeq1d imbi12d rcla4v ad2antrl mpid
      sylbid syl2and ex com23 imp exp3a r19.21aiv jca vc vd cJ iscomp sylibr $.
      $( [30-Jan-2010] $) $( [30-Jan-2010] $)
  $}

  ${
    $d c f o p q s x y z J $. $d c f o p q s x y z S $. $d c f o p q s x y z X
    $.
    hscptsscld.1 $e |- X = U. J $.
    $( A compact subspace of a T2 space is closed. $)
    hscptsscld $p |- ( ( J e. Haus /\ S C_ X /\ ( subSp ` <. S , J >. ) e. Comp
    ) -> S e. ( Clsd ` J ) ) $=
      cJ cha wcel cS cX wss cS cJ cop csubsp cfv ccomp wcel w3a cS cJ ccld cfv
      wcel cS cX wss cX cS cdif cJ wcel wa cJ cha wcel cS cX wss cS cJ cop
      csubsp cfv ccomp wcel w3a cS cX wss cX cS cdif cJ wcel cJ cha wcel cS cX
      wss cS cJ cop csubsp cfv ccomp wcel 3simp2 cJ cha wcel cS cX wss cS cJ
      cop csubsp cfv ccomp wcel w3a cX cS cdif cJ wcel cX cS cdif cJ cuni wss
      vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex vx cX cS cdif wral wa
      cJ cha wcel cS cX wss cS cJ cop csubsp cfv ccomp wcel w3a vx cv vo cv
      wcel vo cv cX cS cdif wss wa vo cJ wrex vx cX cS cdif wral cX cS cdif cJ
      cuni wss cJ cha wcel cS cX wss cS cJ cop csubsp cfv ccomp wcel w3a vx cv
      vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex vx cX cS cdif cJ cha wcel
      cS cX wss cS cJ cop csubsp cfv ccomp wcel vx cv cX cS cdif wcel vx cv vo
      cv wcel vo cv cX cS cdif wss wa vo cJ wrex wi cJ cha wcel cS cX wss wa cS
      cJ cop csubsp cfv ccomp wcel cS vs cv cuni wss cS vc cv cuni wss vc vs cv
      cpw cfn cin wrex wi vs cJ cpw wral vx cv cX cS cdif wcel vx cv vo cv wcel
      vo cv cX cS cdif wss wa vo cJ wrex wi cJ ctop wcel cS cX wss cS cJ cop
      csubsp cfv ccomp wcel cS vs cv cuni wss cS vc cv cuni wss vc vs cv cpw
      cfn cin wrex wi vs cJ cpw wral wb cJ cha wcel cS cJ cX vs vc hscptsscld.1
      compsub cJ haustop sylan cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel
      cS vs cv cuni wss cS vc cv cuni wss vc vs cv cpw cfn cin wrex wi vs cJ
      cpw wral vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel cS vs cv cuni wss cS vc cv cuni wss vc vs
      cv cpw cfn cin wrex wi vs cJ cpw wral vx cv vo cv wcel vo cv cX cS cdif
      wss wa vo cJ wrex wi cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS
      vs cv cuni wss cS vc cv cuni wss vc vs cv cpw cfn cin wrex wi vs cJ cpw
      wral cS vc cv cuni wss vc cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp
      cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw cfn cin wrex vx cv vo cv
      wcel vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vs cv cuni wss cS vc cv cuni wss vc vs cv cpw cfn cin
      wrex wi vs cJ cpw wral cS cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp
      cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cuni wss cS vc cv cuni wss vc
      cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ
      wrex wa vp cJ crab cpw cfn cin wrex cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a vy cS cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin
      c0 wceq wa vo cJ wrex wa vp cJ crab cuni cJ cha wcel cS cX wss vx cv cX
      cS cdif wcel w3a vy cv cS wcel vy cv vp cv wcel cS vp cv cin c0 wne vx cv
      vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa wa vp cJ wrex vy cv
      cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ
      wrex wa vp cJ crab cuni wcel cJ cha wcel cS cX wss vx cv cX cS cdif wcel
      vy cv cS wcel vy cv vp cv wcel cS vp cv cin c0 wne vx cv vo cv wcel vo cv
      vp cv cin c0 wceq wa vo cJ wrex wa wa vp cJ wrex wi cJ cha wcel cS cX wss
      wa vx cv cX cS cdif wcel vy cv cS wcel vy cv vp cv wcel cS vp cv cin c0
      wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa wa vp cJ
      wrex cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS wcel wa wa
      vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex
      vo cJ wrex vy cv vp cv wcel cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp
      cv cin c0 wceq wa vo cJ wrex wa wa vp cJ wrex cJ cha wcel vx cv cX wcel
      vy cv cX wcel vx cv vy cv wne w3a vx cv vo cv wcel vy cv vp cv wcel vo cv
      vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex cJ cha wcel cS cX wss wa vx
      cv cX cS cdif wcel vy cv cS wcel wa wa vx cv vy cv vp vo cJ cX
      hscptsscld.1 hausnei cJ cha wcel cS cX wss vx cv cX cS cdif wcel vy cv cS
      wcel wa simpll cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS
      wcel wa wa vx cv cX wcel vy cv cX wcel vx cv vy cv wne vx cv cX cS cdif
      wcel vx cv cX wcel cJ cha wcel cS cX wss wa vy cv cS wcel vx cv cX cS
      eldifi ad2antrl cS cX wss vy cv cS wcel vy cv cX wcel cJ cha wcel vx cv
      cX cS cdif wcel cS cX vy cv ssel2 ad2ant2l vx cv cX cS cdif wcel vy cv cS
      wcel wa vx cv vy cv wne cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy
      cv cS wcel vx cv vy cv wne vx cv cX cS cdif wcel vy cv cS wcel vx cv vy
      cv vx cv vy cv wceq vx cv cS wcel wn vy cv cS wcel wn vx cv cX cS cdif
      wcel vx cv vy cv wceq vx cv cS wcel vy cv cS wcel vx cv vy cv cS eleq1
      notbid vx cv cX cS eldifn syl5cbi necon2ad imp adantl 3jca sylanc cJ cha
      wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS wcel wa wa vx cv vo cv
      wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo cJ wrex vp cJ wrex
      vy cv vp cv wcel cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0
      wceq wa vo cJ wrex wa wa vp cJ wrex vx cv vo cv wcel vy cv vp cv wcel vo
      cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex cJ cha wcel cS cX wss wa
      vx cv cX cS cdif wcel vy cv cS wcel wa wa vx cv vo cv wcel vy cv vp cv
      wcel vo cv vp cv cin c0 wceq w3a vo cJ wrex vy cv vp cv wcel cS vp cv cin
      c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa wa vp cJ
      cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS wcel wa wa vp cv
      cJ wcel vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo
      cJ wrex vy cv vp cv wcel cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa wa wi cJ cha wcel cS cX wss wa vx cv cX cS
      cdif wcel vy cv cS wcel wa wa vp cv cJ wcel wa vx cv vo cv wcel vy cv vp
      cv wcel vo cv vp cv cin c0 wceq w3a vo cJ wrex vy cv vp cv wcel cS vp cv
      cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vx
      cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo cJ wrex vy
      cv vp cv wcel wi cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS
      wcel wa wa vp cv cJ wcel wa vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv
      cin c0 wceq w3a vy cv vp cv wcel vo cJ vx cv vo cv wcel vy cv vp cv wcel
      vo cv vp cv cin c0 wceq w3a vy cv vp cv wcel wi vo cv cJ wcel vx cv vo cv
      wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq 3simp2 a1i r19.23aiv a1i cJ
      cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS wcel wa wa vp cv cJ
      wcel wa vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo
      cJ wrex cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa
      vo cJ wrex cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS wcel
      wa wa vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo cJ
      wrex cS vp cv cin c0 wne wi vp cv cJ wcel vy cv cS wcel vx cv vo cv wcel
      vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo cJ wrex cS vp cv cin c0
      wne wi cJ cha wcel cS cX wss wa vx cv cX cS cdif wcel vy cv cS wcel vx cv
      vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a cS vp cv cin c0
      wne vo cJ vy cv cS wcel vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin
      c0 wceq w3a cS vp cv cin c0 wne wi vo cv cJ wcel vx cv vo cv wcel vy cv
      vp cv wcel vo cv vp cv cin c0 wceq w3a vy cv cS wcel cS vp cv cin c0 wne
      vy cv vp cv wcel vx cv vo cv wcel vy cv cS wcel cS vp cv cin c0 wne wi vo
      cv vp cv cin c0 wceq vy cv cS wcel vy cv vp cv wcel cS vp cv cin c0 wne
      vy cv cS vp cv inelcm expcom 3ad2ant2 com12 a1d r19.23adv ad2antll adantr
      vx cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo cJ wrex
      vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wi cJ cha wcel cS
      cX wss wa vx cv cX cS cdif wcel vy cv cS wcel wa wa vp cv cJ wcel wa vx
      cv vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vx cv vo cv
      wcel vo cv vp cv cin c0 wceq wa vo cJ vx cv vo cv wcel vy cv vp cv wcel
      vo cv vp cv cin c0 wceq 3simpb r19.22si a1i jcad jcad ex r19.22dv vx cv
      vo cv wcel vy cv vp cv wcel vo cv vp cv cin c0 wceq w3a vo vp cJ cJ
      rexcom syl5ib mpd exp32 3impia cS vp cv cin c0 wne vx cv vo cv wcel vo cv
      vp cv cin c0 wceq wa vo cJ wrex wa vp vy cv cJ elunirab syl6ibr ssrdv cJ
      cha wcel cS cX wss cS vs cv cuni wss cS vc cv cuni wss vc vs cv cpw cfn
      cin wrex wi vs cJ cpw wral cS cS vp cv cin c0 wne vx cv vo cv wcel vo cv
      vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cuni wss cS vc cv cuni wss
      vc cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ
      wrex wa vp cJ crab cpw cfn cin wrex wi wi vx cv cX cS cdif wcel cJ cha
      wcel cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo
      cJ wrex wa vp cJ crab cJ cpw wcel cS vs cv cuni wss cS vc cv cuni wss vc
      vs cv cpw cfn cin wrex wi vs cJ cpw wral cS cS vp cv cin c0 wne vx cv vo
      cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cuni wss cS
      vc cv cuni wss vc cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0
      wceq wa vo cJ wrex wa vp cJ crab cpw cfn cin wrex wi wi cJ cha wcel cS vp
      cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa
      vp cJ crab cJ cpw wcel cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa vp cJ crab cJ wss cS vp cv cin c0 wne vx cv
      vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ ssrab2 cS vp cv
      cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp
      cJ crab cJ cha elpw2g mpbiri cS vs cv cuni wss cS vc cv cuni wss vc vs cv
      cpw cfn cin wrex wi cS cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa vp cJ crab cuni wss cS vc cv cuni wss vc cS
      vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex
      wa vp cJ crab cpw cfn cin wrex wi vs cS vp cv cin c0 wne vx cv vo cv wcel
      vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cJ cpw vs cv cS vp cv
      cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp
      cJ crab wceq cS vs cv cuni wss cS cS vp cv cin c0 wne vx cv vo cv wcel vo
      cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cuni wss cS vc cv cuni
      wss vc vs cv cpw cfn cin wrex cS vc cv cuni wss vc cS vp cv cin c0 wne vx
      cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw cfn
      cin wrex vs cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0
      wceq wa vo cJ wrex wa vp cJ crab wceq vs cv cuni cS vp cv cin c0 wne vx
      cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cuni cS
      vs cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo
      cJ wrex wa vp cJ crab unieq sseq2d vs cv cS vp cv cin c0 wne vx cv vo cv
      wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wceq cS vc cv
      cuni wss vc vs cv cpw cfn cin cS vp cv cin c0 wne vx cv vo cv wcel vo cv
      vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw cfn cin vs cv cS vp cv
      cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp
      cJ crab wceq vs cv cpw cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw cfn vs cv cS vp cv cin c0 wne
      vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab pweq
      ineq1d rexeq1d imbi12d rcla4v syl 3ad2ant1 mpid cJ cha wcel cS cX wss vx
      cv cX cS cdif wcel w3a cS vc cv cuni wss vx cv vo cv wcel vo cv cX cS
      cdif wss wa vo cJ wrex vc cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp
      cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw cfn cin cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a vc cv cS vp cv cin c0 wne vx cv vo cv wcel
      vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss vc cv cfn wcel wa
      cS vc cv cuni wss vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex wi
      vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo
      cJ wrex wa vp cJ crab cpw cfn cin wcel cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vc cv cuni wss vc cv cS vp cv cin c0 wne vx cv vo cv
      wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss vc cv cfn
      wcel wa vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cS vp cv cin
      c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ
      crab wss vc cv cfn wcel wa vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ
      wrex wi cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss
      wa vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa
      vo cJ wrex wa vp cJ crab wss vc cv cfn wcel vx cv vo cv wcel vo cv cX cS
      cdif wss wa vo cJ wrex cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS
      vc cv cuni wss wa vc cv cfn wcel vc cv cS vp cv cin c0 wne vx cv vo cv
      wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss vx cv vo cv
      wcel vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel vc cv cS vp cv cin c0 wne
      vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss
      vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex wi cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc
      cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ
      wrex wa vp cJ crab wss vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv
      vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vf wex vx cv vo cv wcel
      vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cS vp cv cin c0 wne
      vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss
      vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vf wex vc cv cfn wcel vx cv vo cv wcel vo cv vq
      cv cin c0 wceq wa vo cJ wrex vq vc cv wral vc cv cJ vf cv wf vx cv vq cv
      vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vf
      wex cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc
      cv cfn wcel wa wa vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa vp cJ crab wss wa vx cv vo cv wcel vo cv vq
      cv cin c0 wceq wa vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vo vc cv cJ vf vo cv vq cv vf cv cfv wceq vx cv vo cv wcel vx
      cv vq cv vf cv cfv wcel vo cv vq cv cin c0 wceq vq cv vf cv cfv vq cv cin
      c0 wceq vo cv vq cv vf cv cfv vx cv eleq2 vo cv vq cv vf cv cfv wceq vo
      cv vq cv cin vq cv vf cv cfv vq cv cin c0 vo cv vq cv vf cv cfv vq cv
      ineq1 eqeq1d anbi12d ac6sfi cJ cha wcel cS cX wss vx cv cX cS cdif wcel
      w3a cS vc cv cuni wss vc cv cfn wcel vc cv cS vp cv cin c0 wne vx cv vo
      cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss simplrr
      cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv
      cfn wcel wa wa vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin
      c0 wceq wa vo cJ wrex wa vp cJ crab wss wa vx cv vo cv wcel vo cv vq cv
      cin c0 wceq wa vo cJ wrex vq vc cv cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cS vp cv cin c0 wne
      vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss
      vq cv vc cv wcel vx cv vo cv wcel vo cv vq cv cin c0 wceq wa vo cJ wrex
      cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv
      cfn wcel wa wa vq cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin
      c0 wceq wa vo cJ wrex wa vp cJ crab wcel vx cv vo cv wcel vo cv vq cv cin
      c0 wceq wa vo cJ wrex vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp
      cv cin c0 wceq wa vo cJ wrex wa vp cJ crab wss vq cv vc cv wcel wa cJ cha
      wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel
      wa wa vq cv cJ wcel cS vq cv cin c0 wne vx cv vo cv wcel vo cv vq cv cin
      c0 wceq wa vo cJ wrex wa wa vx cv vo cv wcel vo cv vq cv cin c0 wceq wa
      vo cJ wrex vq cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0
      wceq wa vo cJ wrex wa vp cJ crab wcel cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vq cv cJ wcel cS vq
      cv cin c0 wne vx cv vo cv wcel vo cv vq cv cin c0 wceq wa vo cJ wrex
      simprrr cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa
      vo cJ wrex wa cS vq cv cin c0 wne vx cv vo cv wcel vo cv vq cv cin c0
      wceq wa vo cJ wrex wa vp vq cv cJ vp cv vq cv wceq cS vp cv cin c0 wne cS
      vq cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex
      vx cv vo cv wcel vo cv vq cv cin c0 wceq wa vo cJ wrex vp cv vq cv wceq
      cS vp cv cin cS vq cv cin c0 vp cv vq cv cS ineq2 neeq1d vp cv vq cv wceq
      vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vx cv vo cv wcel vo cv vq cv
      cin c0 wceq wa vo cJ vp cv vq cv wceq vo cv vp cv cin c0 wceq vo cv vq cv
      cin c0 wceq vx cv vo cv wcel vp cv vq cv wceq vo cv vp cv cin vo cv vq cv
      cin c0 vp cv vq cv vo cv ineq2 eqeq1d anbi2d rexbidv anbi12d elrab
      sylan2b vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0
      wceq wa vo cJ wrex wa vp cJ crab vq cv ssel2 sylan2 expr r19.21aiv sylanc
      ex cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc
      cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf
      cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vx cv vo cv wcel vo cv cX cS
      cdif wss wa vo cJ wrex vf cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a
      cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf
      cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vx cv
      vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel cS cX wss vx cv
      cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv
      wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc
      cv wral wa wa vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex vc cv
      c0 cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc
      cv cfn wcel wa wa vc cv c0 wceq vx cv vo cv wcel vo cv cX cS cdif wss wa
      vo cJ wrex wi vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv
      cfv vq cv cin c0 wceq wa vq vc cv wral wa cJ cha wcel cS cX wss vx cv cX
      cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv c0 wceq vx
      cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex cX cJ wcel vx cv cX wcel
      cX cX cS cdif wss vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex cJ
      cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn
      wcel wa wa vc cv c0 wceq wa cJ cha wcel cS cX wss vx cv cX cS cdif wcel
      w3a cX cJ wcel cS vc cv cuni wss vc cv cfn wcel wa vc cv c0 wceq cJ cha
      wcel cS cX wss cX cJ wcel vx cv cX cS cdif wcel cJ cha wcel cJ ctop wcel
      cX cJ wcel cJ haustop cJ cX hscptsscld.1 topopn syl 3ad2ant1 ad2antrr cJ
      cha wcel cS cX wss vx cv cX cS cdif wcel w3a vx cv cX wcel cS vc cv cuni
      wss vc cv cfn wcel wa vc cv c0 wceq vx cv cX cS cdif wcel cJ cha wcel vx
      cv cX wcel cS cX wss vx cv cX cS eldifi 3ad2ant3 ad2antrr cS vc cv cuni
      wss vc cv cfn wcel wa vc cv c0 wceq cX cX cS cdif wss cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv c0 wceq cX cX cS
      cdif wss vc cv cfn wcel cS vc cv cuni wss vc cv c0 wceq wa cS c0 wss cS
      c0 wceq cX cX cS cdif wss vc cv c0 wceq cS vc cv cuni wss cS c0 wss vc cv
      c0 wceq vc cv cuni c0 wceq cS vc cv cuni wss cS c0 wss wi vc cv c0 wceq
      vc cv cuni c0 cuni c0 vc cv c0 unieq uni0 syl6eq vc cv cuni c0 wceq cS vc
      cv cuni wss cS c0 wss vc cv cuni c0 cS sseq2 biimpd syl impcom cS ss0 cS
      c0 wceq cX cX cS cdif wss cX cX wss cX ssid cS c0 wceq cX cS cdif cX cX
      cS c0 wceq cX cS cdif cX c0 cdif cX cS c0 cX difeq2 cX dif0 syl6eq sseq2d
      mpbiri 3syl adantlr adantll vx cv vo cv wcel vo cv cX cS cdif wss wa vx
      cv cX wcel cX cX cS cdif wss wa vo cX cJ vo cv cX wceq vx cv vo cv wcel
      vx cv cX wcel vo cv cX cS cdif wss cX cX cS cdif wss vo cv cX vx cv eleq2
      vo cv cX cX cS cdif sseq1 anbi12d rcla4ev sylan32c ex adantr cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa
      wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin
      c0 wceq wa vq vc cv wral wa vc cv c0 wne vx cv vo cv wcel vo cv cX cS
      cdif wss wa vo cJ wrex vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab
      cint cJ wcel vx cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint
      wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint cX cS cdif wss
      vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex cJ cha wcel cS cX wss
      vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ
      vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa
      vq vc cv wral wa vc cv c0 wne wa wa cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx
      cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv
      wral wa vc cv c0 wne wa wa vs cv vq cv vf cv cfv wceq vq vc cv wrex vs
      cab cint cJ cfi cfv cJ cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS
      vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv
      cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0
      wne wa wa vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint cJ cfi cfv
      wcel vz cv cJ wss vz cv cfn wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs cab cint vz cv cint wceq w3a vz wex vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab cJ wss vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cfn
      wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab cint wceq vz cv cJ wss vz cv cfn wcel vs
      cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint vz cv cint wceq w3a vz
      wex cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc
      cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf
      cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa wa vz cv cJ
      wss vz cv cfn wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint
      vz cv cint wceq w3a vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cJ
      wss vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cfn wcel vs cv vq cv
      vf cv cfv wceq vq vc cv wrex vs cab cint vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab cint wceq w3a vz vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs cab vq vs vc cv vq cv vf cv cfv vc visset abrexex vz cv vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab wceq vz cv cJ wss vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cJ wss vz cv cfn wcel vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cfn wcel vs cv vq cv vf cv cfv wceq vq vc cv
      wrex vs cab cint vz cv cint wceq vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs cab cint vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint wceq vz
      cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cJ sseq1 vz cv vs cv
      vq cv vf cv cfv wceq vq vc cv wrex vs cab cfn eleq1 vz cv vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab wceq vz cv cint vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cint vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs cab cint vz cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab inteq
      eqeq2d 3anbi123d cla4ev vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq
      cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cJ wss cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv c0 wne vc cv cJ vf
      cv wf vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cJ wss vx cv vq cv
      vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral vc cv
      cJ vf cv wf vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cv cJ wcel wi vs
      wal vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cJ wss vc cv cJ vf cv
      wf vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cv cJ wcel wi vs vc cv cJ
      vf cv wf vs cv vq cv vf cv cfv wceq vs cv cJ wcel vq vc cv vc cv cJ vf cv
      wf vq cv vc cv wcel vs cv vq cv vf cv cfv wceq vs cv cJ wcel wi vs cv vq
      cv vf cv cfv wceq vs cv cJ wcel vq cv vf cv cfv cJ wcel vc cv cJ vf cv wf
      vq cv vc cv wcel wa vs cv vq cv vf cv cfv cJ eleq1 vc cv cJ vq cv vf cv
      ffvelrn syl5cbir ex r19.23adv 19.21aiv vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cJ abss sylibr adantr ad2antrl vc cv cfn wcel vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab vc cv cdom wbr vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cfn wcel cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral
      wa vc cv c0 wne wa wa vc cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs
      cab domfi cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni
      wss vc cv cfn wcel vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf
      cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa simplrr vc
      cv cfn wcel vc cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab vf cv
      wfo vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab vc cv cdom wbr cJ cha
      wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel
      wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv
      cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa wa vc cv vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab vf cv fodomfi cJ cha wcel cS cX wss vx
      cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel vc cv cJ vf cv wf
      vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv
      wral wa vc cv c0 wne wa simplrr cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral
      wa vc cv c0 wne wa wa vf cv vc cv wfn vf cv crn vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab wceq wa vc cv vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab vf cv wfo cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a
      cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf
      cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv
      c0 wne wa wa vf cv vc cv wfn vf cv crn vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab wceq vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf
      cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vf cv vc cv wfn cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa
      wa vc cv c0 wne vc cv cJ vf cv wf vf cv vc cv wfn vx cv vq cv vf cv cfv
      wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral vc cv cJ vf cv
      ffn adantr ad2antrl cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc
      cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv
      wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne
      wa wa vy vf cv crn vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cJ cha
      wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel
      wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv
      cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa wa vy cv vf cv crn wcel
      vq cv vf cv cfv vy cv wceq vq vc cv wrex vy cv vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vs cab wcel vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq
      cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vy cv vf cv crn wcel
      vq cv vf cv cfv vy cv wceq vq vc cv wrex wb cJ cha wcel cS cX wss vx cv
      cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv c0 wne
      vc cv cJ vf cv wf vy cv vf cv crn wcel vq cv vf cv cfv vy cv wceq vq vc
      cv wrex wb vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq
      wa vq vc cv wral vc cv cJ vf cv wf vf cv vc cv wfn vy cv vf cv crn wcel
      vq cv vf cv cfv vy cv wceq vq vc cv wrex wb vc cv cJ vf cv ffn vq vc cv
      vy cv vf cv fvelrnb syl adantr ad2antrl cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx
      cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv
      wral wa vc cv c0 wne wa wa vq cv vf cv cfv vy cv wceq vq vc cv wrex vy cv
      vq cv vf cv cfv wceq vq vc cv wrex vy cv vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab wcel vq cv vf cv cfv vy cv wceq vq vc cv wrex vy cv vq cv
      vf cv cfv wceq vq vc cv wrex wb cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral
      wa vc cv c0 wne wa wa vq cv vf cv cfv vy cv wceq vy cv vq cv vf cv cfv
      wceq vq vc cv vq cv vf cv cfv vy cv eqcom rexbii a1i vs cv vq cv vf cv
      cfv wceq vq vc cv wrex vy cv vq cv vf cv cfv wceq vq vc cv wrex vs vy cv
      vy visset vs cv vy cv wceq vs cv vq cv vf cv cfv wceq vy cv vq cv vf cv
      cfv wceq vq vc cv vs cv vy cv vq cv vf cv cfv eqeq1 rexbidv elab syl6bbr
      bitrd eqrdv jca vc cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab vf
      cv df-fo sylibr sylanc sylanc cJ cha wcel cS cX wss vx cv cX cS cdif wcel
      w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv
      vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc
      cv c0 wne wa wa vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint
      eqidd syl3anc cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a vc cv c0
      wne vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint cJ cfi cfv wcel
      vz cv cJ wss vz cv cfn wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex vs
      cab cint vz cv cint wceq w3a vz wex wb cS vc cv cuni wss vc cv cfn wcel
      wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin
      c0 wceq wa vq vc cv wral wa vs cv vq cv vf cv cfv wceq vq vc cv wrex vs
      cab cint cvv wcel cJ cha wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex vs
      cab cint cJ cfi cfv wcel vz cv cJ wss vz cv cfn wcel vs cv vq cv vf cv
      cfv wceq vq vc cv wrex vs cab cint vz cv cint wceq w3a vz wex wb cJ cha
      wcel cS cX wss vx cv cX cS cdif wcel w3a vc cv c0 wne wa vz vs cv vq cv
      vf cv cfv wceq vq vc cv wrex vs cab cint cvv cJ cha sppfi cJ cha wcel cS
      cX wss vx cv cX cS cdif wcel w3a vc cv c0 wne wa vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab c0 wne vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs cab cint cvv wcel vc cv c0 wne vs cv vq cv vf cv cfv wceq vq vc cv
      wrex vs cab c0 wne cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a vc cv
      c0 wne vp cv vc cv wcel vp wex vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs cab c0 wne vp vc cv n0 vp cv vc cv wcel vs cv vq cv vf cv cfv wceq vq
      vc cv wrex vs cab c0 wne vp vp cv vc cv wcel vp cv vf cv cfv vs cv vq cv
      vf cv cfv wceq vq vc cv wrex vs cab wcel vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab c0 wne vp cv vc cv wcel vp cv vf cv cfv vq cv vf cv cfv
      wceq vq vc cv wrex vp cv vf cv cfv vs cv vq cv vf cv cfv wceq vq vc cv
      wrex vs cab wcel vp cv vc cv wcel vp cv vf cv cfv vp cv vf cv cfv wceq vp
      cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vp cv vf cv cfv eqid vp
      cv vf cv cfv vq cv vf cv cfv wceq vp cv vf cv cfv vp cv vf cv cfv wceq vq
      vp cv vc cv vq cv vp cv wceq vq cv vf cv cfv vp cv vf cv cfv vp cv vf cv
      cfv vq cv vp cv vf cv fveq2 eqeq2d rcla4ev mpan2 vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vs
      vp cv vf cv cfv vp cv vf cv fvex vs cv vp cv vf cv cfv wceq vs cv vq cv
      vf cv cfv wceq vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv vs cv vp cv
      vf cv cfv vq cv vf cv cfv eqeq1 rexbidv elab sylibr vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab vp cv vf cv cfv ne0i syl 19.23aiv sylbi adantl
      vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab intex sylib cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel vc cv c0 wne 3simpl1 sylanc ad2ant2rl
      mpbird cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cJ cfi cfv cJ wceq
      cS vc cv cuni wss vc cv cfn wcel wa vc cv cJ vf cv wf vx cv vq cv vf cv
      cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0
      wne wa cJ cha wcel cS cX wss cJ cfi cfv cJ wceq vx cv cX cS cdif wcel cJ
      cha wcel cJ ctop wcel cJ cfi cfv cJ wceq cJ haustop cJ fitop syl 3ad2ant1
      ad2antrr eleqtrd cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv
      cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv
      wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne
      wa wa vs cv vq cv vf cv cfv wceq vq vc cv wrex vx cv vs cv wcel wi vs wal
      vx cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint wcel cJ cha
      wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel
      wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv
      cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa wa vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vx cv vs cv wcel wi vs vc cv cJ vf cv wf vx cv vq cv
      vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vs
      cv vq cv vf cv cfv wceq vq vc cv wrex vx cv vs cv wcel wi cJ cha wcel cS
      cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa
      vc cv c0 wne vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq
      wa vq vc cv wral vs cv vq cv vf cv cfv wceq vq vc cv wrex vx cv vs cv
      wcel wi vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq
      cv cin c0 wceq wa vq vc cv wral vs cv vq cv vf cv cfv wceq vx cv vs cv
      wcel vq vc cv vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv hbra1 vx cv vs cv wcel vq ax-17 vx cv vq cv vf cv cfv
      wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral vq cv vc cv wcel
      vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vs cv vq
      cv vf cv cfv wceq vx cv vs cv wcel wi vx cv vq cv vf cv cfv wcel vq cv vf
      cv cfv vq cv cin c0 wceq wa vq vc cv ra4 vx cv vq cv vf cv cfv wcel vs cv
      vq cv vf cv cfv wceq vx cv vs cv wcel wi vq cv vf cv cfv vq cv cin c0
      wceq vs cv vq cv vf cv cfv wceq vx cv vs cv wcel vx cv vq cv vf cv cfv
      wcel vs cv vq cv vf cv cfv vx cv eleq2 biimprcd adantr syl6 r19.23ad
      adantl ad2antrl 19.21aiv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs vx
      cv vx visset elintab sylibr cJ cha wcel cS cX wss vx cv cX cS cdif wcel
      w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv
      vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc
      cv c0 wne wa wa vy vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint
      cX cS cdif cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni
      wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq
      cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa wa vy
      cv vs cv vq cv vf cv cfv wceq vq vc cv wrex vs cab cint wcel vy cv cX
      wcel vy cv cS wcel wn wa vy cv cX cS cdif wcel cJ cha wcel cS cX wss vx
      cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf
      cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq
      vc cv wral wa vc cv c0 wne wa wa vy cv vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab cint wcel vy cv cX wcel vy cv cS wcel wn cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc
      cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vc cv c0 wne wa wa vs cv vq cv vf cv cfv wceq vq
      vc cv wrex vy cv vs cv wcel wi vs wal vy cv cX wcel vy cv vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab cint wcel cJ cha wcel cS cX wss vx cv cX
      cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf
      vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv
      wral wa vc cv c0 wne vs cv vq cv vf cv cfv wceq vq vc cv wrex vy cv vs cv
      wcel wi vs wal vy cv cX wcel wi cJ cha wcel cS cX wss vx cv cX cS cdif
      wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral
      wa wa vp cv vc cv wcel vp wex vs cv vq cv vf cv cfv wceq vq vc cv wrex vy
      cv vs cv wcel wi vs wal vy cv cX wcel wi vc cv c0 wne cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc
      cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa wa vp cv vc cv wcel vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vs cv wcel wi vs wal vy cv cX wcel wi vp cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa
      wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin
      c0 wceq wa vq vc cv wral wa vp cv vc cv wcel vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vs cv wcel wi vs wal vy cv cX wcel wi cJ cha wcel cS
      cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa
      vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vp cv vc cv wcel wa wa vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vy cv vs cv wcel wi vs wal vy cv vp cv vf cv cfv wcel
      vy cv cX wcel cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv
      cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv
      wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vp cv vc cv
      wcel wa wa vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vy cv vp cv
      vf cv cfv wcel wi vy cv vp cv vf cv cfv wcel vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vs cv wcel wi vs wal vp cv vc cv wcel vp cv vf cv cfv
      vq cv vf cv cfv wceq vq vc cv wrex vy cv vp cv vf cv cfv wcel wi vy cv vp
      cv vf cv cfv wcel wi cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a cS
      vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf cv wf vx cv vq cv vf cv
      cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vp cv vc
      cv wcel vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vp cv vf cv
      cfv vq cv vf cv cfv wceq vq vc cv wrex vy cv vp cv vf cv cfv wcel wi vy
      cv vp cv vf cv cfv wcel wi vp cv vc cv wcel vp cv vf cv cfv vp cv vf cv
      cfv wceq vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vp cv vf cv
      cfv eqid vp cv vf cv cfv vq cv vf cv cfv wceq vp cv vf cv cfv vp cv vf cv
      cfv wceq vq vp cv vc cv vq cv vp cv wceq vq cv vf cv cfv vp cv vf cv cfv
      vp cv vf cv cfv vq cv vp cv vf cv fveq2 eqeq2d rcla4ev mpan2 vp cv vf cv
      cfv vq cv vf cv cfv wceq vq vc cv wrex vy cv vp cv vf cv cfv wcel pm2.27
      syl ad2antll vs cv vq cv vf cv cfv wceq vq vc cv wrex vy cv vs cv wcel wi
      vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vy cv vp cv vf cv cfv
      wcel wi vs vp cv vf cv cfv vp cv vf cv fvex vs cv vp cv vf cv cfv wceq vs
      cv vq cv vf cv cfv wceq vq vc cv wrex vp cv vf cv cfv vq cv vf cv cfv
      wceq vq vc cv wrex vy cv vs cv wcel vy cv vp cv vf cv cfv wcel vs cv vp
      cv vf cv cfv wceq vs cv vq cv vf cv cfv wceq vp cv vf cv cfv vq cv vf cv
      cfv wceq vq vc cv vs cv vp cv vf cv cfv vq cv vf cv cfv eqeq1 rexbidv vs
      cv vp cv vf cv cfv vy cv eleq2 imbi12d cla4v syl5 vc cv cJ vf cv wf vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral
      wa vp cv vc cv wcel wa vy cv vp cv vf cv cfv wcel vy cv cX wcel wi cJ cha
      wcel cS cX wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel
      wa wa vc cv cJ vf cv wf vp cv vc cv wcel vy cv vp cv vf cv cfv wcel vy cv
      cX wcel wi vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq
      wa vq vc cv wral vc cv cJ vf cv wf vp cv vc cv wcel wa vp cv vf cv cfv cJ
      wcel vy cv vp cv vf cv cfv wcel vy cv cX wcel wi vc cv cJ vp cv vf cv
      ffvelrn vy cv vp cv vf cv cfv wcel vp cv vf cv cfv cJ wcel vy cv cX wcel
      vy cv vp cv vf cv cfv wcel vp cv vf cv cfv cJ wcel wa vy cv cJ cuni cX vy
      cv vp cv vf cv cfv cJ elunii hscptsscld.1 syl6eleqr expcom syl adantlr
      adantl syld expr 19.23adv vp vc cv n0 syl5ib impr vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs vy cv vy visset elintab syl5ib cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc
      cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vc cv c0 wne wa wa vy cv cS wcel vy cv vs cv vq
      cv vf cv cfv wceq vq vc cv wrex vs cab cint wcel cJ cha wcel cS cX wss vx
      cv cX cS cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa wa vc cv cJ vf
      cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq
      vc cv wral wa vc cv c0 wne wa wa vy cv cS wcel vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vs cv wcel wn wa vs wex vy cv vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cint wcel wn cJ cha wcel cS cX wss vx cv cX cS
      cdif wcel w3a cS vc cv cuni wss vc cv cfn wcel wa vc cv cJ vf cv wf vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral
      wa vc cv c0 wne wa vy cv cS wcel vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vy cv vs cv wcel wn wa vs wex wi vy cv cS wcel cS vc cv cuni wss vc cv
      cfn wcel wa vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv
      vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa cJ cha wcel cS cX
      wss vx cv cX cS cdif wcel w3a vs cv vq cv vf cv cfv wceq vq vc cv wrex vy
      cv vs cv wcel wn wa vs wex vy cv cS wcel cS vc cv cuni wss vc cv cfn wcel
      vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vc cv c0 wne wa cJ cha wcel cS cX wss vx cv cX
      cS cdif wcel w3a vs cv vq cv vf cv cfv wceq vq vc cv wrex vy cv vs cv
      wcel wn wa vs wex wi wi cS vc cv cuni wss vy cv cS wcel vy cv vc cv cuni
      wcel vc cv cfn wcel vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf
      cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel w3a vs cv vq cv vf cv cfv wceq vq vc cv
      wrex vy cv vs cv wcel wn wa vs wex wi wi wi cS vc cv cuni vy cv ssel vy
      cv vc cv cuni wcel vy cv vp cv wcel vp cv vc cv wcel wa vp wex vc cv cfn
      wcel vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv
      cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa cJ cha wcel cS cX wss vx
      cv cX cS cdif wcel w3a vs cv vq cv vf cv cfv wceq vq vc cv wrex vy cv vs
      cv wcel wn wa vs wex wi wi wi vp vy cv vc cv eluni vy cv vp cv wcel vp cv
      vc cv wcel wa vc cv cfn wcel vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel
      vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0 wne wa cJ
      cha wcel cS cX wss vx cv cX cS cdif wcel w3a vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vs cv wcel wn wa vs wex wi wi wi vp vy cv vp cv wcel
      vp cv vc cv wcel wa vc cv cfn wcel vc cv cJ vf cv wf vx cv vq cv vf cv
      cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc cv c0
      wne wa cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a vs cv vq cv vf cv
      cfv wceq vq vc cv wrex vy cv vs cv wcel wn wa vs wex vp cv vf cv cfv vq
      cv vf cv cfv wceq vq vc cv wrex vy cv vp cv vf cv cfv wcel wn vs cv vq cv
      vf cv cfv wceq vq vc cv wrex vy cv vs cv wcel wn wa vs wex vy cv vp cv
      wcel vp cv vc cv wcel wa vc cv cfn wcel wa vc cv cJ vf cv wf vx cv vq cv
      vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa vc
      cv c0 wne wa cJ cha wcel cS cX wss vx cv cX cS cdif wcel w3a wa wa vs cv
      vq cv vf cv cfv wceq vq vc cv wrex vy cv vs cv wcel wn wa vp cv vf cv cfv
      vq cv vf cv cfv wceq vq vc cv wrex vy cv vp cv vf cv cfv wcel wn wa vs vp
      cv vf cv cfv vp cv vf cv fvex vs cv vp cv vf cv cfv wceq vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv
      wrex vy cv vs cv wcel wn vy cv vp cv vf cv cfv wcel wn vs cv vp cv vf cv
      cfv wceq vs cv vq cv vf cv cfv wceq vp cv vf cv cfv vq cv vf cv cfv wceq
      vq vc cv vs cv vp cv vf cv cfv vq cv vf cv cfv eqeq1 rexbidv vs cv vp cv
      vf cv cfv wceq vy cv vs cv wcel vy cv vp cv vf cv cfv wcel vs cv vp cv vf
      cv cfv vy cv eleq2 notbid anbi12d cla4ev vy cv vp cv wcel vp cv vc cv
      wcel wa vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vc cv cfn wcel
      vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vc cv c0 wne wa cJ cha wcel cS cX wss vx cv cX
      cS cdif wcel w3a wa vp cv vc cv wcel vp cv vf cv cfv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vp cv wcel vp cv vc cv wcel vp cv vf cv cfv vp cv vf
      cv cfv wceq vp cv vf cv cfv vq cv vf cv cfv wceq vq vc cv wrex vp cv vf
      cv cfv eqid vp cv vf cv cfv vq cv vf cv cfv wceq vp cv vf cv cfv vp cv vf
      cv cfv wceq vq vp cv vc cv vq cv vp cv wceq vq cv vf cv cfv vp cv vf cv
      cfv vp cv vf cv cfv vq cv vp cv vf cv fveq2 eqeq2d rcla4ev mpan2 adantl
      ad2antrr vy cv vp cv wcel vp cv vc cv wcel wa vc cv cJ vf cv wf vx cv vq
      cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral wa
      vc cv c0 wne wa vy cv vp cv vf cv cfv wcel wn vc cv cfn wcel cJ cha wcel
      cS cX wss vx cv cX cS cdif wcel w3a vy cv vp cv wcel vp cv vc cv wcel wa
      vc cv cJ vf cv wf vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0
      wceq wa vq vc cv wral wa vy cv vp cv vf cv cfv wcel wn vc cv c0 wne vy cv
      vp cv wcel vp cv vc cv wcel wa vx cv vq cv vf cv cfv wcel vq cv vf cv cfv
      vq cv cin c0 wceq wa vq vc cv wral vy cv vp cv vf cv cfv wcel wn vc cv cJ
      vf cv wf vy cv vp cv wcel vp cv vc cv wcel vx cv vq cv vf cv cfv wcel vq
      cv vf cv cfv vq cv cin c0 wceq wa vq vc cv wral vy cv vp cv vf cv cfv
      wcel wn vp cv vc cv wcel vx cv vq cv vf cv cfv wcel vq cv vf cv cfv vq cv
      cin c0 wceq wa vq vc cv wral vx cv vp cv vf cv cfv wcel vp cv vf cv cfv
      vp cv cin c0 wceq wa vy cv vp cv wcel vy cv vp cv vf cv cfv wcel wn vx cv
      vq cv vf cv cfv wcel vq cv vf cv cfv vq cv cin c0 wceq wa vx cv vp cv vf
      cv cfv wcel vp cv vf cv cfv vp cv cin c0 wceq wa vq vp cv vc cv vq cv vp
      cv wceq vx cv vq cv vf cv cfv wcel vx cv vp cv vf cv cfv wcel vq cv vf cv
      cfv vq cv cin c0 wceq vp cv vf cv cfv vp cv cin c0 wceq vq cv vp cv wceq
      vq cv vf cv cfv vp cv vf cv cfv vx cv vq cv vp cv vf cv fveq2 eleq2d vq
      cv vp cv wceq vq cv vf cv cfv vq cv cin vp cv vf cv cfv vp cv cin c0 vq
      cv vp cv wceq vq cv vf cv cfv vp cv vf cv cfv vq cv vp cv vq cv vp cv vf
      cv fveq2 vq cv vp cv wceq id ineq12d eqeq1d anbi12d rcla4v vy cv vp cv
      wcel vp cv vf cv cfv vp cv cin c0 wceq vy cv vp cv vf cv cfv wcel wn vx
      cv vp cv vf cv cfv wcel vy cv vp cv wcel vy cv vp cv vf cv cfv wcel vp cv
      vf cv cfv vp cv cin c0 wceq vy cv vp cv vf cv cfv wcel vy cv vp cv wcel
      vp cv vf cv cfv vp cv cin c0 wceq wn vy cv vp cv vf cv cfv wcel vy cv vp
      cv wcel wa vy cv vp cv vf cv cfv vp cv cin wcel vp cv vf cv cfv vp cv cin
      c0 wceq wn vy cv vp cv vf cv cfv vp cv elin vp cv vf cv cfv vp cv cin vy
      cv n0i sylbir expcom con2d adantld syl9r imp31 adantrl adantrr ad2ant2r
      sylanc exp43 19.23aiv sylbi syl6com imp3a com14 imp31 vs cv vq cv vf cv
      cfv wceq vq vc cv wrex vy cv vs cv wcel wn wa vs wex vs cv vq cv vf cv
      cfv wceq vq vc cv wrex vy cv vs cv wcel wi vs wal wn vy cv vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab cint wcel wn vs cv vq cv vf cv cfv wceq
      vq vc cv wrex vy cv vs cv wcel vs exanali vy cv vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cint wcel vs cv vq cv vf cv cfv wceq vq vc cv
      wrex vy cv vs cv wcel wi vs wal vs cv vq cv vf cv cfv wceq vq vc cv wrex
      vs vy cv vy visset elintab notbii bitr4i syl6ib con2d jcad vy cv cX cS
      eldif syl6ibr ssrdv vx cv vo cv wcel vo cv cX cS cdif wss wa vx cv vs cv
      vq cv vf cv cfv wceq vq vc cv wrex vs cab cint wcel vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cint cX cS cdif wss wa vo vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cint cJ vo cv vs cv vq cv vf cv cfv wceq vq vc
      cv wrex vs cab cint wceq vx cv vo cv wcel vx cv vs cv vq cv vf cv cfv
      wceq vq vc cv wrex vs cab cint wcel vo cv cX cS cdif wss vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab cint cX cS cdif wss vo cv vs cv vq cv vf
      cv cfv wceq vq vc cv wrex vs cab cint vx cv eleq2 vo cv vs cv vq cv vf cv
      cfv wceq vq vc cv wrex vs cab cint cX cS cdif sseq1 anbi12d rcla4ev
      sylan32c expr pm2.61dne ex 19.23adv syld expr com23 imp3a ex com23 vc cv
      cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ
      wrex wa vp cJ crab cpw cfn cin wcel vc cv cS vp cv cin c0 wne vx cv vo cv
      wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw wcel vc cv
      cfn wcel wa vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv cin c0
      wceq wa vo cJ wrex wa vp cJ crab wss vc cv cfn wcel wa vc cv cS vp cv cin
      c0 wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ
      crab cpw cfn elin vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa vp cJ crab cpw wcel vc cv cS vp cv cin c0
      wne vx cv vo cv wcel vo cv vp cv cin c0 wceq wa vo cJ wrex wa vp cJ crab
      wss vc cv cfn wcel vc cv cS vp cv cin c0 wne vx cv vo cv wcel vo cv vp cv
      cin c0 wceq wa vo cJ wrex wa vp cJ crab vc visset elpw anbi1i bitri
      syl5ib r19.23adv syld 3expia com23 sylbid 3impia r19.21aiv cX cS cdif cX
      cJ cuni cX cS difss hscptsscld.1 sseqtri jctil cJ cha wcel cS cX wss cX
      cS cdif cJ wcel cX cS cdif cJ cuni wss vx cv vo cv wcel vo cv cX cS cdif
      wss wa vo cJ wrex vx cX cS cdif wral wa wb cS cJ cop csubsp cfv ccomp
      wcel cJ cha wcel cJ ctop wcel cX cS cdif cJ wcel cX cS cdif cJ cuni wss
      vx cv vo cv wcel vo cv cX cS cdif wss wa vo cJ wrex vx cX cS cdif wral wa
      wb cJ haustop vx vo cX cS cdif cJ eltop2 syl 3ad2ant1 mpbird jca cJ cha
      wcel cS cX wss cS cJ ccld cfv wcel cS cX wss cX cS cdif cJ wcel wa wb cS
      cJ cop csubsp cfv ccomp wcel cJ cha wcel cJ ctop wcel cS cJ ccld cfv wcel
      cS cX wss cX cS cdif cJ wcel wa wb cJ haustop cS cJ cX hscptsscld.1 iscld
      syl 3ad2ant1 mpbird $.
      $( [17-Jan-2010] $) $( [16-Jan-2010] $)
  $}

  ${
    $d c r s u v w x y z J $.
    $( Lemma for ~ compfipin0 . $)
    compfipin0lem $p |- ( J e. Top -> ( A. x e. ~P ( Clsd ` J ) ( A. w e. ( ~P
    x i^i Fin ) -. (/) = |^| w -> -. (/) = |^| x ) -> A. y e. ~P J ( A. z e. (
    ~P y i^i Fin ) -. U. J = U. z -> -. U. J = U. y ) ) ) $=
      cJ ctop wcel c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv
      cint wceq wn wi vx cJ ccld cfv cpw wral cJ cuni vz cv cuni wceq wn vz vy
      cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi vy cJ cpw cJ ctop wcel
      vy cv cJ cpw wcel wa c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0
      vx cv cint wceq wn wi vx cJ ccld cfv cpw wral c0 vw cv cint wceq wn vw vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cpw
      cfn cin wral c0 vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima cint wceq wn wi cJ cuni vz cv cuni wceq wn vz vy cv cpw
      cfn cin wral cJ cuni vy cv cuni wceq wn wi cJ ctop wcel vy cv cJ cpw wcel
      wa vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      cJ ccld cfv cpw wcel c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0
      vx cv cint wceq wn wi vx cJ ccld cfv cpw wral c0 vw cv cint wceq wn vw vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cpw
      cfn cin wral c0 vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima cint wceq wn wi wi cJ ctop wcel vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima cJ ccld cfv cpw wcel vy cv
      cJ cpw wcel cJ ctop wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima cJ ccld cfv wss vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vy cv cima cJ ccld cfv cpw wcel cJ ctop wcel vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab crn wss vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cJ ccld cfv
      wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      imassrn cJ ctop wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab crn cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab vy cv cima cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab wf1o cJ cJ ccld cfv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab wfo vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab crn cJ ccld cfv wceq vs vr vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ
      cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      f1ofo cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab forn 3syl sseq2d mpbii vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab vy cv cima cJ ccld cfv cJ ccld fvex elpw2 sylibr adantr c0
      vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv cint wceq wn wi c0
      vw cv cint wceq wn vw vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab vy cv cima cpw cfn cin wral c0 vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vy cv cima cint wceq wn wi vx vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cJ ccld cfv cpw vx
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      wceq c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vw cv cint wceq
      wn vw vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima cpw cfn cin wral c0 vx cv cint wceq wn c0 vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima cint wceq wn vx cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wceq c0
      vw cv cint wceq wn vw vx cv cpw cfn cin vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vy cv cima cpw cfn cin vx cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wceq vx cv cpw vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cpw cfn vx
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      pweq ineq1d raleq1d vx cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima wceq c0 vx cv cint wceq c0 vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima cint wceq vx cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wceq vx cv
      cint vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima cint c0 vx cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima inteq eqeq2d notbid imbi12d rcla4v syl cJ ctop wcel vy
      cv cJ cpw wcel wa cJ cuni c0 wceq c0 vw cv cint wceq wn vw vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cpw cfn cin wral
      c0 vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      cint wceq wn wi cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral cJ
      cuni vy cv cuni wceq wn wi wi cJ ctop wcel vy cv cJ cpw wcel wa cJ cuni
      c0 wceq c0 vw cv cint wceq wn vw vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima cpw cfn cin wral c0 vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima cint wceq wn wi cJ cuni vz
      cv cuni wceq wn vz vy cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi
      cJ cuni c0 wceq cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral cJ
      cuni vy cv cuni wceq wn cJ cuni c0 wceq cJ cuni vz cv cuni wceq vz vy cv
      cpw cfn cin wrex cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral wn
      cJ cuni c0 wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex c0 vz
      cv cuni wceq vz vy cv cpw cfn cin wrex c0 vy cv cpw cfn cin wcel c0 c0
      cuni wceq c0 vz cv cuni wceq vz vy cv cpw cfn cin wrex c0 vy cv cpw cfn
      cin wcel c0 vy cv cpw wcel c0 cfn wcel c0 vy cv cpw cfn elin vy cv 0elpw
      emfin mpbir2an c0 cuni c0 uni0 eqcomi c0 vz cv cuni wceq c0 c0 cuni wceq
      vz c0 vy cv cpw cfn cin vz cv c0 wceq vz cv cuni c0 cuni c0 vz cv c0
      unieq eqeq2d rcla4ev mp2an cJ cuni c0 wceq cJ cuni vz cv cuni wceq c0 vz
      cv cuni wceq vz vy cv cpw cfn cin cJ cuni c0 vz cv cuni eqeq1 rexbidv
      mpbiri cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin dfrex2 sylib pm2.21d
      a1i13 cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn c0 vw cv cint
      wceq wn vw vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy
      cv cima cpw cfn cin wral c0 vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab vy cv cima cint wceq wn wi cJ cuni vz cv cuni wceq wn vz
      vy cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi wi cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vz cv cuni wceq wn vz vy cv
      cpw cfn cin wral c0 vw cv cint wceq wn vw vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab vy cv cima cpw cfn cin wral c0 vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cint wceq wn cJ
      cuni vy cv cuni wceq wn cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn
      w3a cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral c0 vw cv cint
      wceq wn vw vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy
      cv cima cpw cfn cin cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a
      vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima cpw cfn cin wcel cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin
      wral c0 vw cv cint wceq wn cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq
      wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima wss vw cv cfn wcel wa cJ cuni vz cv cuni wceq wn vz vy cv cpw
      cfn cin wral c0 vw cv cint wceq wn wi vw cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima cpw cfn cin wcel cJ ctop wcel
      vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa cJ
      cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral c0 vw cv cint wceq wn
      wi cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv
      cfn wcel wa wa cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral cJ
      cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw
      cv cima cuni wceq c0 vw cv cint wceq cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima wss vw cv cfn wcel wa wa vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vy cv cpw cfn cin
      wcel cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral cJ cuni vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cuni
      wceq wn wi cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw
      cv cfn wcel wa wa vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vw cv cima vy cv cpw wcel vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vw cv cima cfn wcel wa vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vy cv cpw cfn cin
      wcel cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv
      cfn wcel wa wa vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vw cv cima vy cv cpw wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv vw cv cima cfn wcel cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa wa vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vy cv cpw wcel
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv
      cima vy cv wss cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv
      cima vy cv wss vw cv cfn wcel cJ ctop wcel vy cv cJ cpw wcel vw cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vy
      cv wss cJ cuni c0 wceq wn cJ ctop wcel vy cv cJ cpw wcel wa vw cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss wa vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cima vy cv
      vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      vw cv cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima cima wss cJ ctop wcel vy cv cJ cpw wcel wa vw cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv imass2 adantl cJ ctop wcel vy cv
      cJ cpw wcel wa vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima cima vy cv wceq vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima wss cJ ctop wcel vy cv cJ wss vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima cima vy cv wceq vy cv cJ cpw
      wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab wf1 vy cv cJ wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab ccnv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima cima vy cv wceq cJ ctop wcel cJ cJ ccld cfv vy cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1imacnv cJ ctop wcel
      cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      wf1o cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab wf1 vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab f1of1 syl sylan vy cv cJ vy visset elpw
      sylan2b adantr sseqtrd 3adantl3 adantrr cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima wss vw cv cfn wcel wa wa vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cvv wcel vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vy cv
      cpw wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      vw cv cima vy cv wss wb cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn
      w3a vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv
      cima cvv wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vw cv cfn wcel wa cJ ctop wcel vy cv cJ cpw wcel vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima
      cvv wcel cJ cuni c0 wceq wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab wf1o cJ ccld cfv cJ vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wf1o vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cvv wcel vs
      vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ cuni
      cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab f1ocnv cJ ccld cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv wf1o vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv wfun vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab ccnv vw cv cima cvv wcel cJ ccld cfv cJ vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv f1ofun vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv vw visset funimaex syl
      3syl 3ad2ant1 adantr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vw cv cima vy cv cvv elpwg syl mpbird cJ ctop wcel vy cv cJ
      cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa wa vw cv cfn
      wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw
      cv cima cfn wcel cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      wss vw cv cfn wcel simprr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv vw cv cima cvv wcel vw cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vw cv cima cen wbr vw cv cfn wcel vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cfn
      wcel wb cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv
      cfn wcel wa wa vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vw cv cima cvv enfi cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0
      wceq wn w3a vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vw cv cima cvv wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa cJ ctop wcel vy cv
      cJ cpw wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vw cv cima cvv wcel cJ cuni c0 wceq wn cJ ctop wcel cJ cJ ccld cfv
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wf1o cJ ccld
      cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      wf1o vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw
      cv cima cvv wcel vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab f1ocnv cJ ccld cfv cJ vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wf1o vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wfun vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cvv wcel cJ ccld
      cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      f1ofun vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw
      cv vw visset funimaex syl 3syl 3ad2ant1 adantr cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa wa vw cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cres wf1o
      vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw
      cv cima cen wbr cJ ccld cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv wf1 vw cv cJ ccld cfv wss vw cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cres wf1o cJ ctop
      wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa
      wa cJ ccld cfv cJ vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab ccnv f1ores cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn
      w3a cJ ccld cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv wf1 vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vw cv cfn wcel wa cJ ctop wcel vy cv cJ cpw wcel cJ
      ccld cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv wf1 cJ cuni c0 wceq wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab wf1o cJ ccld cfv cJ vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wf1o cJ ccld cfv
      cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wf1 vs
      vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ cuni
      cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab f1ocnv cJ ccld cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv f1of1 3syl 3ad2ant1 adantr cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cJ ccld cfv wss vw cv
      cfn wcel cJ ctop wcel vy cv cJ cpw wcel vw cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cJ ccld cfv wss cJ
      cuni c0 wceq wn cJ ctop wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab crn wss vw cv cJ ccld cfv wss vw cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss cJ ctop wcel vw
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab crn wss vw
      cv cJ ccld cfv wss cJ ctop wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab crn cJ ccld cfv vw cv cJ ctop wcel cJ cJ ccld cfv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wf1o cJ cJ ccld
      cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wfo vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab crn cJ ccld cfv wceq
      vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ
      cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab f1ofo cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab forn 3syl sseq2d biimpa vw cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab crn wss vw cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab crn wss vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv imassrn vw cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab crn sstr mpan2 sylan2 3ad2antl1
      adantrr sylanc vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vw cv cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab ccnv vw cv cres vw visset f1oen syl sylanc mpbid jca vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vy cv
      cpw cfn elin sylibr cJ cuni vz cv cuni wceq wn cJ cuni vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cuni wceq wn vz
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv
      cima vy cv cpw cfn cin vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab ccnv vw cv cima wceq cJ cuni vz cv cuni wceq cJ cuni vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cuni
      wceq vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vw cv cima wceq vz cv cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv vw cv cima cuni cJ cuni vz cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima unieq eqeq2d
      notbid rcla4v syl cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a
      vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima wss vw cv cfn wcel wa c0 vw cv cint wceq cJ cuni vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cuni wceq cJ ctop
      wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa
      c0 vw cv cint wceq wa wa cJ cuni vv vw cv cJ cuni vv cv cdif ciun vu cv
      cJ cuni vv cv cdif wceq vv vw cv wrex vu cab cuni vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima cuni cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv
      cint wceq wa wa cJ cuni c0 cdif cJ cuni vw cv cint cdif cJ cuni vv vw cv
      cJ cuni vv cv cdif ciun c0 vw cv cint wceq cJ cuni c0 cdif cJ cuni vw cv
      cint cdif wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima
      wss vw cv cfn wcel wa c0 vw cv cint cJ cuni difeq2 ad2antll cJ cuni dif0
      cJ cuni vw cv cint cdif cJ cuni vv vw cv vv cv ciin cdif vv vw cv cJ cuni
      vv cv cdif ciun vw cv cint vv vw cv vv cv ciin cJ cuni vv vw cv intiin
      difeq2i vv vw cv cJ cuni vv cv iundif2 eqtr4i 3eqtr3g cJ ctop wcel vy cv
      cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv
      cint wceq wa wa cJ cuni vv cv cdif cvv wcel vv vw cv wral vv vw cv cJ
      cuni vv cv cdif ciun vu cv cJ cuni vv cv cdif wceq vv vw cv wrex vu cab
      cuni wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw
      cv cfn wcel wa c0 vw cv cint wceq wa wa cJ cuni vv cv cdif cvv wcel vv vw
      cv cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv
      cfn wcel wa c0 vw cv cint wceq wa wa cJ cuni vv cv cdif cvv wcel vv cv vw
      cv wcel cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vv
      cv cdif cvv wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa cJ ctop
      wcel vy cv cJ cpw wcel cJ cuni vv cv cdif cvv wcel cJ cuni c0 wceq wn cJ
      ctop wcel cJ cuni cvv wcel cJ cuni vv cv cdif cvv wcel cJ ctop uniexg cJ
      cuni vv cv cvv difexg syl 3ad2ant1 adantr a1d r19.21aiv vv vu vw cv cJ
      cuni vv cv cdif cvv dfiun2g syl cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0
      wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa wa vu cv cJ
      cuni vv cv cdif wceq vv vw cv wrex vu cab vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vw cv cima cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq
      wa wa vu cv cJ cuni vv cv cdif wceq vv vw cv wrex vu cab vv cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv vu cv wceq vv
      vw cv wrex vu cab vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vw cv cima cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn
      w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy
      cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa wa vu cv cJ cuni vv
      cv cdif wceq vv vw cv wrex vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv cfv vu cv wceq vv vw cv wrex vu cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv
      cint wceq wa wa vu cv cJ cuni vv cv cdif wceq vv cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv vu cv wceq vv vw cv vw cv
      cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn
      wcel wa c0 vw cv cint wceq wa wa vv cv vw cv wcel vu cv cJ cuni vv cv
      cdif wceq vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv cfv vu cv wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq
      wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa vv cv vw cv wcel
      vu cv cJ cuni vv cv cdif wceq vv cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv cfv vu cv wceq wb cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq
      wa vv cv vw cv wcel wa wa cJ cuni vv cv cdif vu cv wceq vv cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv vu cv wceq vu
      cv cJ cuni vv cv cdif wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq
      wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa vv cv vw cv wcel
      wa wa cJ cuni vv cv cdif vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv cfv vu cv cJ ctop wcel vy cv cJ cpw wcel cJ cuni
      c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa vv cv vw cv
      wcel wa wa vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv cfv cJ cuni vv cv cdif cJ ctop wcel vv cv cJ ccld cfv wcel vv
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv cJ
      cuni vv cv cdif wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn
      w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy
      cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa vv cv vw cv wcel wa
      wa vs vr vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab eqid opncldf3 cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn
      w3a cJ ctop wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa vv cv vw
      cv wcel wa cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn 3simp1
      adantr cJ ctop wcel vy cv cJ cpw wcel vw cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa c0 vw cv
      cint wceq wa vv cv vw cv wcel wa vv cv cJ ccld cfv wcel cJ cuni c0 wceq
      wn cJ ctop wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab vy cv cima wss vw cv cfn wcel wa vv cv vw cv wcel vv cv cJ ccld
      cfv wcel c0 vw cv cint wceq cJ ctop wcel vw cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vv cv vw cv wcel vv cv
      cJ ccld cfv wcel vw cv cfn wcel cJ ctop wcel vw cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vv cv vw cv wcel vv cv
      cJ ccld cfv wcel cJ ctop wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vy cv cima wss wa vw cv cJ ccld cfv vv cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cJ ccld
      cfv wss vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima wss vw cv cJ ccld cfv wss cJ ctop wcel vw cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cJ ccld cfv wss vw
      cv cJ ccld cfv wss vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima cJ ccld cfv sstr ancoms cJ ctop wcel vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab crn cJ ccld cfv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab crn wss cJ ctop wcel vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv imassrn a1i cJ
      ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab wf1o cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab wfo vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab crn cJ ccld cfv wceq vs vr vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofo cJ cJ ccld cfv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab forn 3syl sseqtrd
      sylan sseld impr adantrlr adantrlr 3ad2antl1 sylanc eqcomd eqeq1d vu cv
      cJ cuni vv cv cdif eqcom syl5bb expr pm5.32d rexbidv2 abbidv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wfun vw cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cdm wss vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vw cv cima vv
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv vu
      cv wceq vv vw cv wrex vu cab wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni
      c0 wceq wn w3a vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vw cv cfn wcel wa c0 vw cv cint wceq wa wa vv vu vw
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      dfimafn cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wfun vw cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv
      cfn wcel wa c0 vw cv cint wceq wa cJ ctop wcel vy cv cJ cpw wcel vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wfun cJ cuni c0
      wceq wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab wf1o cJ ccld cfv cJ vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab ccnv wf1o vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv wfun vs vr vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ocnv cJ ccld
      cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      f1ofun 3syl 3ad2ant1 adantr vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima wss vw cv cfn wcel wa vw cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cdm wss cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a c0 vw cv cint wceq vw cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cdm wss vw
      cv cfn wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab crn vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv cdm vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab crn wss vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab crn wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv imassrn vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vy cv cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab crn sstr mpan2 vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab df-rn syl6ss adantr ad2antrl sylanc eqtr4d unieqd 3eqtrd expr nsyld
      ex vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv
      cima cpw cfn cin wcel vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab vy cv cima cpw wcel vw cv cfn wcel wa vw cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn
      wcel wa vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima cpw cfn elin vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab vy cv cima cpw wcel vw cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab vy cv cima wss vw cv cfn wcel vw cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima vw visset
      elpw anbi1i bitri syl5ib com23 r19.21adv cJ ctop wcel vy cv cJ cpw wcel
      cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq c0 vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vy cv cima cint wceq cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq c0 vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vy cv cima cint wceq cJ
      ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni
      wceq wa c0 vv vy cv cJ cuni vv cv cdif ciin vu cv cJ cuni vv cv cdif wceq
      vv vy cv wrex vu cab cint vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab vy cv cima cint cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0
      wceq wn w3a cJ cuni vy cv cuni wceq wa c0 cJ cuni vv vy cv vv cv ciun
      cdif vv vy cv cJ cuni vv cv cdif ciin cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa cJ cuni cJ cuni cdif cJ
      cuni vy cv cuni cdif c0 cJ cuni vv vy cv vv cv ciun cdif cJ cuni vy cv
      cuni wceq cJ cuni cJ cuni cdif cJ cuni vy cv cuni cdif wceq cJ ctop wcel
      vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni cJ cuni
      difeq2 adantl cJ cuni difid vy cv cuni vv vy cv vv cv ciun cJ cuni vv vy
      cv uniiun difeq2i 3eqtr3g cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq
      wn w3a cJ cuni vy cv cuni wceq wa vy cv c0 wne vv vy cv cJ cuni vv cv
      cdif ciin cJ cuni vv vy cv vv cv ciun cdif wceq cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa vy cv c0 wceq wn
      vy cv c0 wne cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ
      cuni vy cv cuni wceq vy cv c0 wceq wn cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn cJ cuni vy cv cuni wceq vy cv c0 wceq wn wi cJ ctop wcel
      vy cv cJ cpw wcel wa cJ cuni vy cv cuni wceq cJ cuni c0 wceq wn vy cv c0
      wceq wn cJ ctop wcel vy cv cJ cpw wcel wa cJ cuni vy cv cuni wceq cJ cuni
      c0 wceq wn vy cv c0 wceq wn wi cJ ctop wcel vy cv cJ cpw wcel wa cJ cuni
      vy cv cuni wceq wa vy cv c0 wceq cJ cuni c0 wceq cJ ctop wcel vy cv cJ
      cpw wcel wa cJ cuni vy cv cuni wceq wa vy cv cuni c0 wceq cJ cuni c0 wceq
      vy cv c0 wceq cJ cuni vy cv cuni wceq vy cv cuni c0 wceq cJ cuni c0 wceq
      wi cJ ctop wcel vy cv cJ cpw wcel wa cJ cuni vy cv cuni wceq vy cv cuni
      c0 wceq cJ cuni c0 wceq cJ cuni vy cv cuni c0 eqtr ex adantl vy cv c0
      wceq vy cv cuni c0 cuni c0 vy cv c0 unieq uni0 syl6eq syl5 con3d ex com23
      3impia imp vy cv c0 df-ne sylibr vv vy cv cJ cuni vv cv iindif2 syl
      eqtr4d cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vy
      cv cuni wceq wa cJ cuni vv cv cdif cvv wcel vv vy cv wral vv vy cv cJ
      cuni vv cv cdif ciin vu cv cJ cuni vv cv cdif wceq vv vy cv wrex vu cab
      cint wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni
      vy cv cuni wceq wa cJ cuni vv cv cdif cvv wcel vv vy cv cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa cJ cuni
      vv cv cdif cvv wcel vv cv vy cv wcel cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a cJ cuni vv cv cdif cvv wcel cJ cuni vy cv cuni wceq
      cJ ctop wcel vy cv cJ cpw wcel cJ cuni vv cv cdif cvv wcel cJ cuni c0
      wceq wn cJ ctop wcel cJ cuni cvv wcel cJ cuni vv cv cdif cvv wcel cJ ctop
      uniexg cJ cuni vv cv cvv difexg syl 3ad2ant1 adantr a1d r19.21aiv vv vu
      vy cv cJ cuni vv cv cdif cvv dfiin2g syl cJ ctop wcel vy cv cJ cpw wcel
      cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa vu cv cJ cuni vv cv
      cdif wceq vv vy cv wrex vu cab vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vy cv cima cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0
      wceq wn w3a cJ cuni vy cv cuni wceq wa vu cv cJ cuni vv cv cdif wceq vv
      vy cv wrex vu cab vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab cfv vu cv wceq vv vy cv wrex vu cab vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vy cv cima cJ ctop wcel vy cv cJ cpw wcel
      cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa vu cv cJ cuni vv cv
      cdif wceq vv vy cv wrex vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab cfv vu cv wceq vv vy cv wrex vu cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa vu cv cJ cuni vv
      cv cdif wceq vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cfv vu cv wceq vv vy cv vy cv cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa vv cv vy cv wcel vu cv cJ
      cuni vv cv cdif wceq vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab cfv vu cv wceq cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq
      wn w3a cJ cuni vy cv cuni wceq vv cv vy cv wcel vu cv cJ cuni vv cv cdif
      wceq vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cfv
      vu cv wceq wb cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a cJ
      cuni vy cv cuni wceq vv cv vy cv wcel wa wa cJ cuni vv cv cdif vu cv wceq
      vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cfv vu
      cv wceq vu cv cJ cuni vv cv cdif wceq cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq vv cv vy cv wcel wa wa cJ
      cuni vv cv cdif vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab cfv vu cv cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a
      cJ cuni vy cv cuni wceq vv cv vy cv wcel wa wa vv cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab cfv cJ cuni vv cv cdif cJ ctop
      wcel vv cv cJ wcel vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab cfv cJ cuni vv cv cdif wceq cJ ctop wcel vy cv cJ cpw wcel cJ
      cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq vv cv vy cv wcel wa wa vs vr
      vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ
      cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab eqid opncldf2 cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a
      cJ ctop wcel cJ cuni vy cv cuni wceq vv cv vy cv wcel wa cJ ctop wcel vy
      cv cJ cpw wcel cJ cuni c0 wceq wn 3simp1 adantr cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a vv cv vy cv wcel vv cv cJ wcel cJ cuni vy cv
      cuni wceq vy cv cJ cpw wcel cJ ctop wcel vv cv vy cv wcel vv cv cJ wcel
      cJ cuni c0 wceq wn vy cv cJ wss vv cv vy cv wcel vv cv cJ wcel vy cv cJ
      cpw wcel vy cv cJ vv cv ssel2 vy cv cJ vy visset elpw sylanb 3ad2antl2
      adantrl sylanc eqcomd eqeq1d vu cv cJ cuni vv cv cdif eqcom syl5bb expr
      pm5.32d rexbidv2 abbidv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab wfun vy cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cdm wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vy cv cima vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cfv vu cv wceq vv vy cv wrex vu cab wceq cJ ctop wcel vy cv cJ cpw
      wcel cJ cuni c0 wceq wn w3a cJ cuni vy cv cuni wceq wa vv vu vy cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab dfimafn cJ ctop wcel
      vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab wfun cJ cuni vy cv cuni wceq cJ ctop wcel vy
      cv cJ cpw wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      wfun cJ cuni c0 wceq wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab wfun vs vr vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofun syl 3ad2ant1
      adantr cJ ctop wcel vy cv cJ cpw wcel cJ cuni c0 wceq wn w3a vy cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss cJ cuni vy
      cv cuni wceq cJ ctop wcel vy cv cJ cpw wcel vy cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab cdm wss cJ cuni c0 wceq wn cJ ctop
      wcel vy cv cJ wss vy cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab cdm wss vy cv cJ cpw wcel cJ ctop wcel vy cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab cdm wss vy cv cJ wss cJ ctop wcel
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm cJ vy cv
      cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cJ wfn vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      cdm cJ wceq vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab f1ofn cJ vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab fndm 3syl sseq2d biimpar vy cv cJ vy visset elpw
      sylan2b 3adant3 adantr sylanc eqtr4d inteqd 3eqtrd ex con3d imim12d
      3expia pm2.61d syld r19.21adva $.
      $( [28-Aug-2009] $) $( [28-Aug-2009] $)

    $( If a topology is compact and a collection of closed sets has the finite
       intersection property, its intersection is nonempty. $)
    compfipin0 $p |- ( J e. Top -> ( J e. Comp <-> A. x e. ~P ( Clsd ` J ) (
    (/) e/ ( fi ` x ) -> |^| x =/= (/) ) ) ) $=
      cJ ctop wcel cJ ccomp wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni
      wceq vz vy cv cpw cfn cin wrex wi vy cJ cpw wral cJ cuni vz cv cuni wceq
      vz vy cv cpw cfn cin wrex wn cJ cuni vy cv cuni wceq wn wi vy cJ cpw wral
      c0 vx cv cfi cfv wnel vx cv cint c0 wne wi vx cJ ccld cfv cpw wral cJ
      ccomp wcel cJ ctop wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq
      vz vy cv cpw cfn cin wrex wi vy cJ cpw wral vy vz cJ iscomp baib cJ cuni
      vy cv cuni wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wi vy
      cJ cpw wral cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wn cJ cuni
      vy cv cuni wceq wn wi vy cJ cpw wral wb cJ ctop wcel cJ cuni vy cv cuni
      wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wi cJ cuni vz cv
      cuni wceq vz vy cv cpw cfn cin wrex wn cJ cuni vy cv cuni wceq wn wi vy
      cJ cpw cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn
      cin wrex con34b ralbii a1i cJ ctop wcel cJ cuni vz cv cuni wceq wn vz vy
      cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi vy cJ cpw wral c0 vw cv
      cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv cint wceq wn wi vx cJ
      ccld cfv cpw wral cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wn cJ
      cuni vy cv cuni wceq wn wi vy cJ cpw wral c0 vx cv cfi cfv wnel vx cv
      cint c0 wne wi vx cJ ccld cfv cpw wral cJ ctop wcel cJ cuni vz cv cuni
      wceq wn vz vy cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi vy cJ cpw
      wral c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv cint wceq
      wn wi vx cJ ccld cfv cpw wral cJ ctop wcel cJ cuni vz cv cuni wceq wn vz
      vy cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi vy cJ cpw wral c0 vw
      cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv cint wceq wn wi vx cJ
      ccld cfv cpw cJ ctop wcel vx cv cJ ccld cfv cpw wcel wa cJ cuni vz cv
      cuni wceq wn vz vy cv cpw cfn cin wral cJ cuni vy cv cuni wceq wn wi vy
      cJ cpw wral cJ cuni vz cv cuni wceq wn vz vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vx cv cima cpw cfn cin wral cJ cuni vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima
      cuni wceq wn wi c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv
      cint wceq wn wi cJ ctop wcel vx cv cJ ccld cfv cpw wcel wa vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cJ cpw wcel
      cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin wral cJ cuni vy cv cuni
      wceq wn wi vy cJ cpw wral cJ cuni vz cv cuni wceq wn vz vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cpw cfn cin
      wral cJ cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vx cv cima cuni wceq wn wi wi cJ ctop wcel vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cJ cpw wcel vx cv cJ
      ccld cfv cpw wcel cJ ctop wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv vx cv cima cJ cpw wcel vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cJ wss cJ ctop wcel
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima cJ wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vx
      cv cnvimass cJ ctop wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab cdm cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab cJ wfn vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab cdm cJ wceq vs vr vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofn cJ vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab fndm 3syl sseq2d mpbii vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cJ
      ctop elpw2g mpbird adantr cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin
      wral cJ cuni vy cv cuni wceq wn wi cJ cuni vz cv cuni wceq wn vz vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cpw cfn
      cin wral cJ cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima cuni wceq wn wi vy vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vx cv cima cJ cpw vy cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wceq cJ cuni vz
      cv cuni wceq wn vz vy cv cpw cfn cin wral cJ cuni vz cv cuni wceq wn vz
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima cpw cfn cin wral cJ cuni vy cv cuni wceq wn cJ cuni vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cuni wceq wn vy
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima wceq cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn cin vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cpw cfn cin
      vy cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima wceq vy cv cpw vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab ccnv vx cv cima cpw cfn vy cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima pweq ineq1d raleq1d vy cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wceq
      cJ cuni vy cv cuni wceq cJ cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv vx cv cima cuni wceq vy cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wceq vy cv cuni vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima
      cuni cJ cuni vy cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima unieq eqeq2d notbid imbi12d rcla4v syl cJ ctop wcel
      vx cv cJ ccld cfv cpw wcel wa cJ cuni c0 wceq cJ cuni vz cv cuni wceq wn
      vz vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima cpw cfn cin wral cJ cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab ccnv vx cv cima cuni wceq wn wi c0 vw cv cint wceq wn vw
      vx cv cpw cfn cin wral c0 vx cv cint wceq wn wi wi cJ ctop wcel vx cv cJ
      ccld cfv cpw wcel wa cJ cuni c0 wceq c0 vw cv cint wceq wn vw vx cv cpw
      cfn cin wral c0 vx cv cint wceq wn wi cJ cuni vz cv cuni wceq wn vz vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cpw
      cfn cin wral cJ cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima cuni wceq wn wi cJ ctop wcel vx cv cJ ccld cfv wss
      cJ cuni c0 wceq c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv
      cint wceq wn wi wi vx cv cJ ccld cfv cpw wcel cJ ctop wcel vx cv cJ ccld
      cfv wss wa cJ cuni c0 wceq c0 vw cv cint wceq wn vw vx cv cpw cfn cin
      wral wn c0 vx cv cint wceq wn wo c0 vw cv cint wceq wn vw vx cv cpw cfn
      cin wral c0 vx cv cint wceq wn wi cJ ctop wcel vx cv cJ ccld cfv wss wa
      cJ cuni c0 wceq vx cv c0 wceq wn vx cv c0 wceq wo c0 vw cv cint wceq wn
      vw vx cv cpw cfn cin wral wn c0 vx cv cint wceq wn wo vx cv c0 wceq pm2.1
      cJ ctop wcel vx cv cJ ccld cfv wss wa cJ cuni c0 wceq vx cv c0 wceq wn vx
      cv c0 wceq wo c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral wn c0 vx cv
      cint wceq wn wo wi cJ ctop wcel vx cv cJ ccld cfv wss wa cJ cuni c0 wceq
      wa vx cv c0 wceq wn c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral wn vx
      cv c0 wceq c0 vx cv cint wceq wn vx cv c0 wceq wn cJ ctop wcel vx cv cJ
      ccld cfv wss wa cJ cuni c0 wceq wa c0 vw cv cint wceq wn vw vx cv cpw cfn
      cin wral wn vx cv c0 wceq wn vc cv vx cv wcel vc wex cJ ctop wcel vx cv
      cJ ccld cfv wss wa cJ cuni c0 wceq wa c0 vw cv cint wceq wn vw vx cv cpw
      cfn cin wral wn wi vc vx cv neq0 vc cv vx cv wcel cJ ctop wcel vx cv cJ
      ccld cfv wss wa cJ cuni c0 wceq wa c0 vw cv cint wceq wn vw vx cv cpw cfn
      cin wral wn wi vc vc cv vx cv wcel cJ ctop wcel vx cv cJ ccld cfv wss cJ
      cuni c0 wceq c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral wn vx cv cJ
      ccld cfv wss vc cv vx cv wcel cJ ctop wcel cJ cuni c0 wceq c0 vw cv cint
      wceq wn vw vx cv cpw cfn cin wral wn wi vx cv cJ ccld cfv wss vc cv vx cv
      wcel vc cv cJ ccld cfv wcel cJ ctop wcel cJ cuni c0 wceq c0 vw cv cint
      wceq wn vw vx cv cpw cfn cin wral wn wi wi vx cv cJ ccld cfv vc cv ssel
      cJ ctop wcel vc cv cJ ccld cfv wcel vc cv vx cv wcel cJ cuni c0 wceq c0
      vw cv cint wceq wn vw vx cv cpw cfn cin wral wn wi cJ ctop wcel vc cv cJ
      ccld cfv wcel vc cv vx cv wcel cJ cuni c0 wceq c0 vw cv cint wceq wn vw
      vx cv cpw cfn cin wral wn wi wi cJ ctop wcel vc cv cJ ccld cfv wcel wa vc
      cv cJ cuni wss vc cv vx cv wcel cJ cuni c0 wceq c0 vw cv cint wceq wn vw
      vx cv cpw cfn cin wral wn wi wi vc cv cJ cJ cuni cJ cuni eqid cldss vc cv
      cJ cuni wss cJ cuni c0 wceq vc cv vx cv wcel c0 vw cv cint wceq wn vw vx
      cv cpw cfn cin wral wn cJ cuni c0 wceq vc cv cJ cuni wss vc cv c0 wss vc
      cv vx cv wcel c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral wn wi cJ
      cuni c0 wceq vc cv cJ cuni wss vc cv c0 wss cJ cuni c0 vc cv sseq2 biimpd
      vc cv c0 wss vc cv c0 wceq vc cv vx cv wcel c0 vw cv cint wceq wn vw vx
      cv cpw cfn cin wral wn wi vc cv ss0 vc cv c0 wceq vc cv vx cv wcel c0 vw
      cv cint wceq wn vw vx cv cpw cfn cin wral wn vc cv c0 wceq vc cv vx cv
      wcel wa c0 vw cv cint wceq vw vx cv cpw cfn cin wrex c0 vw cv cint wceq
      wn vw vx cv cpw cfn cin wral wn vc cv c0 wceq vc cv vx cv wcel wa c0 vx
      cv wcel c0 vw cv cint wceq vw vx cv cpw cfn cin wrex vc cv c0 wceq vc cv
      vx cv wcel c0 vx cv wcel vc cv c0 vx cv eleq1 biimpa c0 csn vx cv cpw cfn
      cin wcel c0 c0 csn cint wceq c0 vw cv cint wceq vw vx cv cpw cfn cin wrex
      c0 vx cv wcel c0 vw cv cint wceq c0 c0 csn cint wceq vw c0 csn vx cv cpw
      cfn cin vw cv c0 csn wceq vw cv cint c0 csn cint c0 vw cv c0 csn inteq
      eqeq2d rcla4ev c0 vx cv wcel c0 csn vx cv cpw wcel c0 csn cfn wcel wa c0
      csn vx cv cpw cfn cin wcel c0 vx cv wcel c0 csn vx cv cpw wcel c0 csn cfn
      wcel c0 vx cv wcel c0 csn vx cv wss c0 csn vx cv cpw wcel c0 vx cv snssi
      c0 csn vx cv p0ex elpw sylibr c0 snfi jctir c0 csn vx cv cpw cfn elin
      sylibr c0 c0 csn cint wceq c0 vx cv wcel c0 csn cint c0 c0 0ex intsn
      eqcomi a1i sylanc syl c0 vw cv cint wceq vw vx cv cpw cfn cin dfrex2
      sylib ex syl syl6com com23 syl ex com13 sylcom com3l imp4c 19.23aiv sylbi
      com12 vx cv c0 wceq c0 vx cv cint wceq wn wi cJ ctop wcel vx cv cJ ccld
      cfv wss wa cJ cuni c0 wceq wa vx cv c0 wceq c0 vx cv cint wceq c0 c0 cint
      wceq c0 c0 cint wceq cvv c0 wceq cvv c0 wne cvv c0 wceq wn vn0 cvv c0
      df-ne mpbi cvv c0 wceq c0 cint c0 c0 cint c0 wceq cvv c0 wceq c0 cint cvv
      c0 int0 eqeq1i biimpi eqcoms mto vx cv c0 wceq vx cv cint c0 cint c0 vx
      cv c0 inteq eqeq2d mtbiri a1i orim12d ex mpii c0 vw cv cint wceq wn vw vx
      cv cpw cfn cin wral c0 vx cv cint wceq pm4.62 syl6ibr vx cv cJ ccld cfv
      vx visset elpw sylan2b a1dd cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ
      cuni c0 wceq wn cJ cuni vz cv cuni wceq wn vz vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab ccnv vx cv cima cpw cfn cin wral cJ cuni
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima cuni wceq wn wi c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0
      vx cv cint wceq wn wi wi cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni
      c0 wceq wn w3a c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral cJ cuni vz
      cv cuni wceq wn vz vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima cpw cfn cin wral cJ cuni vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cuni wceq wn c0 vx cv
      cint wceq wn cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn
      w3a c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral cJ cuni vz cv cuni
      wceq wn vz vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vx cv cima cpw cfn cin cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ
      cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv vx cv cima cpw cfn cin wcel c0 vw cv cint wceq wn vw vx
      cv cpw cfn cin wral cJ cuni vz cv cuni wceq wn cJ ctop wcel vx cv cJ ccld
      cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa c0 vw
      cv cint wceq wn vw vx cv cpw cfn cin wral cJ cuni vz cv cuni wceq wn wi
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima cpw cfn cin wcel cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni
      c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa c0 vw cv cint wceq wn vw vx
      cv cpw cfn cin wral cJ cuni vz cv cuni wceq wn wi cJ ctop wcel vx cv cJ
      ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa
      wa c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cint wceq cJ cuni vz cv
      cuni wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima wss vz cv cfn wcel wa wa vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vz cv cima vx cv cpw cfn cin wcel c0 vw cv cint wceq
      wn vw vx cv cpw cfn cin wral c0 vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vz cv cima cint wceq wn wi cJ ctop wcel vx cv cJ ccld
      cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa wa vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv
      cpw wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv
      cima cfn wcel wa vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cima vx cv cpw cfn cin wcel cJ ctop wcel vx cv cJ ccld cfv
      cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa wa vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv cpw
      wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv
      cima cfn wcel cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn
      w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv
      vx cv cima wss vz cv cfn wcel wa wa vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vz cv cima vx cv cpw wcel vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv wss cJ ctop wcel vx
      cv cJ ccld cfv cpw wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv wss cJ cuni c0
      wceq wn cJ ctop wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv vx cv cima wss vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vz cv cima vx cv wss vz cv cfn wcel vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab wfun vz cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv wss cJ ctop
      wcel vz cv vx cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab funimass2 cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab wfun vs vr vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofun syl sylan
      adantrr 3ad2antl1 cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq
      wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vx cv cima wss vz cv cfn wcel wa wa vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab vz cv cima cvv wcel vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv cpw wcel vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima vx cv wss wb
      cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cvv wcel vz
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima wss vz cv cfn wcel wa cJ ctop wcel vx cv cJ ccld cfv cpw wcel vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cvv wcel
      cJ cuni c0 wceq wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab wfun vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab vz cv cima cvv wcel vs vr vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofun vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv vz visset
      funimaex 3syl 3ad2ant1 adantr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab vz cv cima vx cv cvv elpwg syl mpbird cJ ctop wcel vx cv
      cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa
      wa vz cv cfn wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cima cfn wcel cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni
      c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel simprr vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cima cvv wcel vz cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cen wbr vz
      cv cfn wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz
      cv cima cfn wcel wb cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0
      wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa wa vz cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cvv enfi cJ ctop wcel
      vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cima cvv wcel vz cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz
      cv cfn wcel wa cJ ctop wcel vx cv cJ ccld cfv cpw wcel vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cvv wcel cJ cuni c0
      wceq wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab wfun vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cima cvv wcel vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofun vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab vz cv vz visset funimaex 3syl
      3ad2ant1 adantr cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq
      wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vx cv cima wss vz cv cfn wcel wa wa vz cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cima vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cres wf1o vz cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cen wbr cJ cJ
      ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wf1
      vz cv cJ wss vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cres wf1o cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0
      wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa wa cJ cJ ccld cfv vz cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ores cJ ctop wcel
      vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a cJ cJ ccld cfv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wf1 vz cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv
      cfn wcel wa cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cJ ccld cfv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wf1 cJ cuni c0 wceq
      wn cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab wf1o cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab wf1 vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1of1 syl 3ad2ant1 adantr cJ
      ctop wcel vx cv cJ ccld cfv cpw wcel vz cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa vz cv
      cJ wss cJ cuni c0 wceq wn cJ ctop wcel vz cv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cJ wss vz cv cfn
      wcel cJ ctop wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab cdm wss vz cv cJ wss vz cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima wss cJ ctop wcel vz cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss vz cv cJ wss cJ
      ctop wcel vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm
      cJ vz cv cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab cJ wfn vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab cdm cJ wceq vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab f1ofn cJ vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab fndm 3syl sseq2d biimpa vz cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vx cv cnvimass
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm
      sstr mpan2 sylan2 adantrr 3ad2antl1 sylanc vz cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cima vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab vz cv cres vz visset f1oen syl sylanc
      mpbid jca vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz
      cv cima vx cv cpw cfn elin sylibr c0 vw cv cint wceq wn c0 vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cint wceq wn vw
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima vx
      cv cpw cfn cin vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cima wceq c0 vw cv cint wceq c0 vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab vz cv cima cint wceq vw cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima wceq vw cv cint
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima
      cint c0 vw cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vz cv cima inteq eqeq2d notbid rcla4v syl cJ ctop wcel vx cv cJ ccld cfv
      cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz
      cv cuni wceq c0 vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab vz cv cima cint wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ
      cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq
      wa wa c0 vu cv cJ cuni vv cv cdif wceq vv vz cv wrex vu cab cint vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cint cJ ctop
      wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz
      cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa c0 cJ cuni vv vz cv vv cv
      ciun cdif vv vz cv cJ cuni vv cv cdif ciin vu cv cJ cuni vv cv cdif wceq
      vv vz cv wrex vu cab cint cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni
      c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa
      cJ cuni cJ cuni cdif cJ cuni vz cv cuni cdif c0 cJ cuni vv vz cv vv cv
      ciun cdif cJ cuni vz cv cuni wceq cJ cuni cJ cuni cdif cJ cuni vz cv cuni
      cdif wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni cJ cuni difeq2 ad2antll
      cJ cuni difid vz cv cuni vv vz cv vv cv ciun cJ cuni vv vz cv uniiun
      difeq2i 3eqtr3g cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq
      wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vz cv
      c0 wne vv vz cv cJ cuni vv cv cdif ciin cJ cuni vv vz cv vv cv ciun cdif
      wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vz cv c0 wceq wn
      vz cv c0 wne cJ cuni c0 wceq wn cJ ctop wcel vz cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa
      cJ cuni vz cv cuni wceq wa vz cv c0 wceq wn vx cv cJ ccld cfv cpw wcel cJ
      cuni c0 wceq wn cJ cuni vz cv cuni wceq vz cv c0 wceq wn vz cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz
      cv cfn wcel wa cJ cuni c0 wceq wn cJ cuni vz cv cuni wceq wa vz cv c0
      wceq cJ cuni vz cv cuni wceq cJ cuni c0 wceq wn cJ cuni vz cv cuni wceq
      pm3.27 cJ cuni c0 wceq wn vz cv c0 wceq cJ cuni vz cv cuni wceq wn wi cJ
      cuni vz cv cuni wceq vz cv c0 wceq cJ cuni c0 wceq wn cJ cuni vz cv cuni
      wceq wn vz cv c0 wceq cJ cuni vz cv cuni wceq cJ cuni c0 wceq vz cv c0
      wceq vz cv cuni c0 wceq cJ cuni vz cv cuni wceq cJ cuni c0 wceq wi vz cv
      c0 wceq vz cv cuni c0 cuni c0 vz cv c0 unieq uni0 syl6eq cJ cuni vz cv
      cuni wceq vz cv cuni c0 wceq cJ cuni c0 wceq cJ cuni vz cv cuni c0 eqtr
      expcom syl con3d com12 adantr mt2d adantrl 3ad2antl3 vz cv c0 df-ne
      sylibr vv vz cv cJ cuni vv cv iindif2 syl cJ ctop wcel vx cv cJ ccld cfv
      cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz
      cv cuni wceq wa wa cJ cuni vv cv cdif cvv wcel vv vz cv wral vv vz cv cJ
      cuni vv cv cdif ciin vu cv cJ cuni vv cv cdif wceq vv vz cv wrex vu cab
      cint wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa cJ cuni vv cv
      cdif cvv wcel vv vz cv cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0
      wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa
      cJ cuni vv cv cdif cvv wcel vv cv vz cv wcel cJ ctop wcel vx cv cJ ccld
      cfv cpw wcel cJ cuni c0 wceq wn w3a cJ cuni vv cv cdif cvv wcel vz cv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima
      wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa cJ ctop wcel vx cv cJ
      ccld cfv cpw wcel cJ cuni vv cv cdif cvv wcel cJ cuni c0 wceq wn cJ ctop
      wcel cJ cuni cvv wcel cJ cuni vv cv cdif cvv wcel cJ ctop uniexg cJ cuni
      vv cv cvv difexg syl 3ad2ant1 adantr a1d r19.21aiv vv vu vz cv cJ cuni vv
      cv cdif cvv dfiin2g syl 3eqtr2d cJ ctop wcel vx cv cJ ccld cfv cpw wcel
      cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni
      wceq wa wa vu cv cJ cuni vv cv cdif wceq vv vz cv wrex vu cab vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vz cv cima cJ ctop wcel
      vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn
      wcel wa cJ cuni vz cv cuni wceq wa wa vu cv cJ cuni vv cv cdif wceq vv vz
      cv wrex vu cab vv cv vu cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab wbr vv vz cv wrex vu cab vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab vz cv cima cJ ctop wcel vx cv cJ ccld cfv cpw
      wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv
      cuni wceq wa wa vu cv cJ cuni vv cv cdif wceq vv vz cv wrex vv cv vu cv
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wbr vv vz cv
      wrex vu cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vu cv cJ cuni vv
      cv cdif wceq vv cv vu cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab wbr vv vz cv vz cv cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ
      cuni c0 wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq
      wa wa vv cv vz cv wcel vu cv cJ cuni vv cv cdif wceq wa vv cv vz cv wcel
      vv cv cJ wcel vu cv cJ cuni vv cv cdif wceq wa wa vv cv vz cv wcel vv cv
      vu cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wbr wa
      cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima
      wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vv cv vz cv wcel vu
      cv cJ cuni vv cv cdif wceq wa vv cv vz cv wcel vv cv cJ wcel wa vu cv cJ
      cuni vv cv cdif wceq wa vv cv vz cv wcel vv cv cJ wcel vu cv cJ cuni vv
      cv cdif wceq wa wa cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0
      wceq wn w3a vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa
      vv cv vz cv wcel vv cv vz cv wcel vv cv cJ wcel wa vu cv cJ cuni vv cv
      cdif wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima wss vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vv cv vz cv
      wcel vv cv vz cv cJ cin wcel vv cv vz cv wcel vv cv cJ wcel wa cJ ctop
      wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz
      cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vz cv vz cv cJ cin vv cv cJ
      ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss
      vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vz cv cJ cin vz cv cJ
      ctop wcel vx cv cJ ccld cfv cpw wcel cJ cuni c0 wceq wn w3a vz cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss
      vz cv cfn wcel wa cJ cuni vz cv cuni wceq wa wa vz cv cJ wss vz cv cJ cin
      vz cv wceq cJ ctop wcel vx cv cJ ccld cfv cpw wcel vz cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn
      wcel wa cJ cuni vz cv cuni wceq wa vz cv cJ wss cJ cuni c0 wceq wn cJ
      ctop wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv vx cv cima wss vz cv cfn wcel wa vz cv cJ wss cJ cuni vz cv
      cuni wceq cJ ctop wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab ccnv vx cv cima wss vz cv cJ wss vz cv cfn wcel cJ ctop
      wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm
      wss vz cv cJ wss vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab ccnv vx cv cima wss cJ ctop wcel vz cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab cdm wss vz cv cJ wss cJ ctop wcel vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm cJ vz cv cJ
      ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab wf1o vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cJ wfn vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      cdm cJ wceq vs vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni
      vr cv cdif wceq wa vr vs copab f1ofn cJ vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab fndm 3syl sseq2d biimpa vz cv vr cv cJ wcel vs
      cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima wss vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss vz cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm wss vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab vx cv cnvimass vz cv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cdm sstr mpan2
      sylan2 adantrr adantrr 3ad2antl1 vz cv cJ df-ss sylib eqcomd eleq2d vv cv
      vz cv cJ elin syl6bb anbi1d vv cv vz cv wcel vv cv cJ wcel vu cv cJ cuni
      vv cv cdif wceq anass syl6bb vv cv cJ wcel vu cv cJ cuni vv cv cdif wceq
      wa vv cv vu cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      wbr vv cv vz cv wcel vv cv vu cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab wbr vv cv vu cv cop vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab wcel vv cv cJ wcel vu cv cJ cuni vv cv cdif wceq
      wa vv cv vu cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      df-br vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vv cv cJ wcel vs cv
      cJ cuni vv cv cdif wceq wa vv cv cJ wcel vu cv cJ cuni vv cv cdif wceq wa
      vr vs vv cv vu cv vv visset vu visset vr cv vv cv wceq vr cv cJ wcel vv
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq vs cv cJ cuni vv cv cdif wceq vr
      cv vv cv cJ eleq1 vr cv vv cv wceq cJ cuni vr cv cdif cJ cuni vv cv cdif
      vs cv vr cv vv cv cJ cuni difeq2 eqeq2d anbi12d vs cv vu cv wceq vs cv cJ
      cuni vv cv cdif wceq vu cv cJ cuni vv cv cdif wceq vv cv cJ wcel vs cv vu
      cv cJ cuni vv cv cdif eqeq1 anbi2d opelopab bitr2i anbi2i syl6bb rexbidv2
      abbidv vv vu vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      vz cv dfima2 syl6eqr inteqd eqtrd expr nsyld ex vz cv vr cv cJ wcel vs cv
      cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cpw cfn cin wcel
      vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx
      cv cima cpw wcel vz cv cfn wcel wa vz cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel wa vz cv
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima cpw cfn elin vz cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab ccnv vx cv cima cpw wcel vz cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima wss vz cv cfn wcel vz cv vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima vz
      visset elpw anbi1i bitri syl5ib com23 r19.21adv cJ ctop wcel vx cv cJ
      ccld cfv cpw wcel cJ cuni c0 wceq wn w3a c0 vx cv cint wceq cJ cuni vr cv
      cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cuni
      wceq cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn c0 vx cv cint
      wceq cJ cuni vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv vx cv cima cuni wceq wi vx cv cJ ccld cfv cpw wcel cJ ctop wcel vx
      cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq cJ cuni vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima
      cuni wceq cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx
      cv cint wceq wa cJ cuni vv vx cv cJ cuni vv cv cdif ciun vu cv cJ cuni vv
      cv cdif wceq vv vx cv wrex vu cab cuni vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv vx cv cima cuni cJ ctop wcel vx cv cJ ccld
      cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa cJ cuni c0 cdif cJ
      cuni vx cv cint cdif cJ cuni vv vx cv cJ cuni vv cv cdif ciun c0 vx cv
      cint wceq cJ cuni c0 cdif cJ cuni vx cv cint cdif wceq cJ ctop wcel vx cv
      cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint cJ cuni difeq2
      adantl cJ cuni dif0 cJ cuni vx cv cint cdif cJ cuni vv vx cv vv cv ciin
      cdif vv vx cv cJ cuni vv cv cdif ciun vx cv cint vv vx cv vv cv ciin cJ
      cuni vv vx cv intiin difeq2i vv vx cv cJ cuni vv cv iundif2 eqtr4i
      3eqtr3g cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx
      cv cint wceq wa cJ cuni vv cv cdif cvv wcel vv vx cv wral vv vx cv cJ
      cuni vv cv cdif ciun vu cv cJ cuni vv cv cdif wceq vv vx cv wrex vu cab
      cuni wceq cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx
      cv cint wceq wa cJ cuni vv cv cdif cvv wcel vv vx cv cJ ctop wcel vx cv
      cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa cJ cuni vv
      cv cdif cvv wcel vv cv vx cv wcel cJ ctop wcel vx cv cJ ccld cfv wss cJ
      cuni c0 wceq wn w3a cJ cuni vv cv cdif cvv wcel c0 vx cv cint wceq cJ
      ctop wcel vx cv cJ ccld cfv wss cJ cuni vv cv cdif cvv wcel cJ cuni c0
      wceq wn cJ ctop wcel cJ cuni cvv wcel cJ cuni vv cv cdif cvv wcel cJ ctop
      uniexg cJ cuni vv cv cvv difexg syl 3ad2ant1 adantr a1d r19.21aiv vv vu
      vx cv cJ cuni vv cv cdif cvv dfiun2g syl cJ ctop wcel vx cv cJ ccld cfv
      wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa vu cv cJ cuni vv cv cdif
      wceq vv vx cv wrex vu cab vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv vx cv cima cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0
      wceq wn w3a c0 vx cv cint wceq wa vu cv cJ cuni vv cv cdif wceq vv vx cv
      wrex vu cab vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv cfv vu cv wceq vv vx cv wrex vu cab vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv vx cv cima cJ ctop wcel vx cv cJ
      ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa vu cv cJ cuni
      vv cv cdif wceq vv vx cv wrex vv cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv cfv vu cv wceq vv vx cv wrex vu cJ ctop
      wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa
      vu cv cJ cuni vv cv cdif wceq vv cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv cfv vu cv wceq vv vx cv vx cv cJ ctop wcel
      vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa vv cv
      vx cv wcel vu cv cJ cuni vv cv cdif wceq vv cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv cfv vu cv wceq cJ ctop wcel vx
      cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq vv cv vx cv
      wcel vu cv cJ cuni vv cv cdif wceq vv cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv cfv vu cv wceq wb cJ ctop wcel vx cv cJ
      ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq vv cv vx cv wcel
      wa wa cJ cuni vv cv cdif vu cv wceq vv cv vr cv cJ wcel vs cv cJ cuni vr
      cv cdif wceq wa vr vs copab ccnv cfv vu cv wceq vu cv cJ cuni vv cv cdif
      wceq cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv
      cint wceq vv cv vx cv wcel wa wa cJ cuni vv cv cdif vv cv vr cv cJ wcel
      vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv vu cv cJ ctop wcel
      vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq vv cv vx
      cv wcel wa wa vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv cfv cJ cuni vv cv cdif cJ ctop wcel vv cv cJ ccld cfv wcel vv
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cfv cJ
      cuni vv cv cdif wceq cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq
      wn w3a c0 vx cv cint wceq vv cv vx cv wcel wa wa vs vr vv cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab eqid opncldf3
      cJ ctop wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a cJ ctop wcel c0
      vx cv cint wceq vv cv vx cv wcel wa cJ ctop wcel vx cv cJ ccld cfv wss cJ
      cuni c0 wceq wn 3simp1 adantr vx cv cJ ccld cfv wss cJ ctop wcel c0 vx cv
      cint wceq vv cv vx cv wcel wa vv cv cJ ccld cfv wcel cJ cuni c0 wceq wn
      vx cv cJ ccld cfv wss vv cv vx cv wcel vv cv cJ ccld cfv wcel c0 vx cv
      cint wceq vx cv cJ ccld cfv vv cv ssel2 adantrl 3ad2antl2 sylanc eqcomd
      eqeq1d vu cv cJ cuni vv cv cdif eqcom syl5bb expr pm5.32d rexbidv2 abbidv
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wfun vx
      cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv cdm
      wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv vx cv
      cima vv cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      ccnv cfv vu cv wceq vv vx cv wrex vu cab wceq cJ ctop wcel vx cv cJ ccld
      cfv wss cJ cuni c0 wceq wn w3a c0 vx cv cint wceq wa vv vu vx cv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv dfimafn cJ ctop
      wcel vx cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv wfun c0 vx cv cint wceq cJ ctop
      wcel vx cv cJ ccld cfv wss vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa
      vr vs copab ccnv wfun cJ cuni c0 wceq wn cJ ctop wcel cJ cJ ccld cfv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab wf1o cJ ccld cfv
      cJ vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wf1o
      vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab ccnv wfun vs
      vr vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab cJ cJ cuni
      cJ cuni eqid vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab
      eqid opncldf1 cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab f1ocnv cJ ccld cfv cJ vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv f1ofun 3syl 3ad2ant1 adantr cJ ctop wcel vx
      cv cJ ccld cfv wss cJ cuni c0 wceq wn w3a vx cv vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab ccnv cdm wss c0 vx cv cint wceq cJ
      ctop wcel vx cv cJ ccld cfv wss vx cv vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab ccnv cdm wss cJ cuni c0 wceq wn cJ ctop wcel vx
      cv cJ ccld cfv wss wa vx cv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab crn vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs
      copab ccnv cdm cJ ctop wcel vx cv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab crn wss vx cv cJ ccld cfv wss cJ ctop wcel vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab crn cJ ccld cfv vx cv
      cJ ctop wcel cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq
      wa vr vs copab wf1o cJ cJ ccld cfv vr cv cJ wcel vs cv cJ cuni vr cv cdif
      wceq wa vr vs copab wfo vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr
      vs copab crn cJ ccld cfv wceq vs vr vr cv cJ wcel vs cv cJ cuni vr cv
      cdif wceq wa vr vs copab cJ cJ cuni cJ cuni eqid vr cv cJ wcel vs cv cJ
      cuni vr cv cdif wceq wa vr vs copab eqid opncldf1 cJ cJ ccld cfv vr cv cJ
      wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab f1ofo cJ cJ ccld cfv vr
      cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab forn 3syl sseq2d
      biimpar vr cv cJ wcel vs cv cJ cuni vr cv cdif wceq wa vr vs copab df-rn
      syl6ss 3adant3 adantr sylanc eqtr4d unieqd 3eqtrd ex vx cv cJ ccld cfv vx
      visset elpw syl3an2b con3d imim12d 3expia pm2.61d syld r19.21adva vx vy
      vz vw cJ compfipin0lem impbid cJ cuni vz cv cuni wceq wn vz vy cv cpw cfn
      cin wral cJ cuni vy cv cuni wceq wn wi cJ cuni vz cv cuni wceq vz vy cv
      cpw cfn cin wrex wn cJ cuni vy cv cuni wceq wn wi vy cJ cpw cJ cuni vz cv
      cuni wceq wn vz vy cv cpw cfn cin wral cJ cuni vz cv cuni wceq vz vy cv
      cpw cfn cin wrex wn cJ cuni vy cv cuni wceq wn cJ cuni vz cv cuni wceq vz
      vy cv cpw cfn cin ralnex imbi1i ralbii c0 vw cv cint wceq wn vw vx cv cpw
      cfn cin wral c0 vx cv cint wceq wn wi c0 vx cv cfi cfv wnel vx cv cint c0
      wne wi vx cJ ccld cfv cpw c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral
      c0 vx cv cfi cfv wnel c0 vx cv cint wceq wn vx cv cint c0 wne vw cv vx cv
      wss vw cv cfn wcel c0 vw cv cint wceq w3a vw wex wn c0 vx cv cfi cfv wcel
      wn c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vx cv cfi cfv wnel
      vw cv vx cv wss vw cv cfn wcel c0 vw cv cint wceq w3a vw wex c0 vx cv cfi
      cfv wcel c0 vx cv cfi cfv wcel c0 vw cv vx cv wss vw cv cfn wcel vz cv vw
      cv cint wceq w3a vw wex vz cab wcel vw cv vx cv wss vw cv cfn wcel c0 vw
      cv cint wceq w3a vw wex vx cv cfi cfv vw cv vx cv wss vw cv cfn wcel vz
      cv vw cv cint wceq w3a vw wex vz cab c0 vx cv cvv wcel vx cv cfi cfv vw
      cv vx cv wss vw cv cfn wcel vz cv vw cv cint wceq w3a vw wex vz cab wceq
      vx visset vw vz vx cv cvv fiv ax-mp eleq2i vw cv vx cv wss vw cv cfn wcel
      vz cv vw cv cint wceq w3a vw wex vw cv vx cv wss vw cv cfn wcel c0 vw cv
      cint wceq w3a vw wex vz c0 0ex vz cv c0 wceq vw cv vx cv wss vw cv cfn
      wcel vz cv vw cv cint wceq w3a vw cv vx cv wss vw cv cfn wcel c0 vw cv
      cint wceq w3a vw vz cv c0 wceq vz cv vw cv cint wceq c0 vw cv cint wceq
      vw cv vx cv wss vw cv cfn wcel vz cv c0 vw cv cint eqeq1 3anbi3d exbidv
      elab bitr2i notbii c0 vw cv cint wceq wn vw vx cv cpw cfn cin wral c0 vw
      cv cint wceq vw vx cv cpw cfn cin wrex wn vw cv vx cv cpw cfn cin wcel c0
      vw cv cint wceq wa vw wex wn vw cv vx cv wss vw cv cfn wcel c0 vw cv cint
      wceq w3a vw wex wn c0 vw cv cint wceq vw vx cv cpw cfn cin ralnex c0 vw
      cv cint wceq vw vx cv cpw cfn cin wrex vw cv vx cv cpw cfn cin wcel c0 vw
      cv cint wceq wa vw wex c0 vw cv cint wceq vw vx cv cpw cfn cin df-rex
      notbii vw cv vx cv cpw cfn cin wcel c0 vw cv cint wceq wa vw wex vw cv vx
      cv wss vw cv cfn wcel c0 vw cv cint wceq w3a vw wex vw cv vx cv cpw cfn
      cin wcel c0 vw cv cint wceq wa vw cv vx cv wss vw cv cfn wcel c0 vw cv
      cint wceq w3a vw vw cv vx cv cpw cfn cin wcel c0 vw cv cint wceq wa vw cv
      vx cv cpw wcel vw cv cfn wcel wa c0 vw cv cint wceq wa vw cv vx cv cpw
      wcel vw cv cfn wcel c0 vw cv cint wceq w3a vw cv vx cv wss vw cv cfn wcel
      c0 vw cv cint wceq w3a vw cv vx cv cpw cfn cin wcel vw cv vx cv cpw wcel
      vw cv cfn wcel wa c0 vw cv cint wceq vw cv vx cv cpw cfn elin anbi1i vw
      cv vx cv cpw wcel vw cv cfn wcel c0 vw cv cint wceq df-3an vw cv vx cv
      cpw wcel vw cv vx cv wss vw cv cfn wcel c0 vw cv cint wceq vw cv vx cv vw
      visset elpw 3anbi1i 3bitr2i exbii notbii 3bitri c0 vx cv cfi cfv df-nel
      3bitr4i c0 vx cv cint wceq vx cv cint c0 c0 vx cv cint eqcom necon3bbii
      imbi12i ralbii 3bitr3g 3bitrd $.
      $( [28-Aug-2009] $) $( [25-Aug-2009] $)
  $}

  ${
    $d a b c d f j k m n s t u v w x y z J $. $d a b c d f j k m n s t u v w x
    y z X $.
    alexsub.1 $e |- X = U. J $.
    $( Lemma for ~ alexsub . A compact space has a subbase such that every
       cover taken from it has a finite subcover. $)
    alexsublem1 $p |- ( J e. Comp -> E. x ( J = ( topGen ` ( fi ` x ) ) /\ A. c
    e. ~P x ( X = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) ) ) $=
      cJ ccomp wcel cJ cJ cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc cJ cpw wral cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral wa vx wex cJ ccomp wcel cJ ctop wcel cJ cJ cfi cfv ctg
      cfv wceq cJ comptop cJ ctop wcel cJ cfi cfv ctg cfv cJ ctg cfv cJ cJ ctop
      wcel cJ cfi cfv cJ ctg cJ fitop fveq2d cJ tgtop eqtr2d syl cJ ccomp wcel
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc cJ
      cpw cJ ccomp wcel vc cv cJ wss cX vc cv cuni wceq cX vd cv cuni wceq vd
      vc cv cpw cfn cin wrex wi vc cv cJ cpw wcel cJ ccomp wcel vc cv cJ wss cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex vc cv cJ cX
      vd alexsub.1 compcov 3exp vc cv cJ vc visset elpw syl5ib r19.21aiv cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral wa cJ cJ cfi cfv ctg cfv wceq cX vc
      cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc cJ cpw
      wral wa vx cJ ccomp vx cv cJ wceq cJ vx cv cfi cfv ctg cfv wceq cJ cJ cfi
      cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn
      cin wrex wi vc vx cv cpw wral cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc cJ cpw wral vx cv cJ wceq vx cv cfi cfv ctg cfv
      cJ cfi cfv ctg cfv cJ vx cv cJ wceq vx cv cfi cfv cJ cfi cfv ctg vx cv cJ
      cfi fveq2 fveq2d eqeq2d vx cv cJ wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw cJ cpw vx cv cJ pweq
      raleq1d anbi12d cla4egv mp2and $.
      $( [27-Jan-2010] $) $( [27-Jan-2010] $)

    $( Lemma for ~ alexsub . Every subset of a base which has no finite
       subcover is a subset of a maximal such collection. $)
    alexsublem2 $p |- ( ( ( J = ( topGen ` ( fi ` x ) ) /\ A. c e. ~P x ( X =
    U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) /\ a e. ~P ( fi ` x ) ) /\ A. b
    e. ( ~P a i^i Fin ) -. X = U. b ) -> E. u e. ( { z e. ~P ( fi ` x ) | ( a
    C_ z /\ A. b e. ( ~P z i^i Fin ) -. X = U. b ) } u. { (/) } ) A. v e. ( { z
    e. ~P ( fi ` x ) | ( a C_ z /\ A. b e. ( ~P z i^i Fin ) -. X = U. b ) } u.
    { (/) } ) -. u C. v ) $=
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw
      crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu
      vy cv wral wa vy cv cuni va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wcel wi vy wal
      vu cv vv cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral vu va cv vz cv
      wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv
      cpw crab c0 csn cun wrex cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin
      wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu
      cv wss wo vv vy cv wral vu vy cv wral wa vy cv cuni va cv vz cv wss cX vb
      cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wcel wi vy cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa
      vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa
      vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss
      wo vv vy cv wral vu vy cv wral wa vy cv cuni va cv vz cv wss cX vb cv
      cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv
      va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx
      cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv
      vy cv wral vu vy cv wral wa wa vy cv cuni c0 wceq wn vy cv cuni vx cv cfi
      cfv cpw wcel va cv vy cv cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw
      cfn cin wral wa wa wi vy cv cuni va cv vz cv wss cX vb cv cuni wceq wn vb
      vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wcel cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX
      vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv
      wral wa wa vy cv cuni c0 wceq wn vy cv cuni vx cv cfi cfv cpw wcel va cv
      vy cv cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin wral wa wa
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw
      crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu
      vy cv wral wa wa vy cv cuni c0 wceq wn wa vy cv cuni vx cv cfi cfv cpw
      wcel va cv vy cv cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin
      wral cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv
      vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv
      wral vu vy cv wral wa wa vy cv cuni c0 wceq wn wa vy cv cuni vx cv cfi
      cfv wss vy cv cuni vx cv cfi cfv cpw wcel vy cv va cv vz cv wss cX vb cv
      cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv
      wral wa vy cv cuni vx cv cfi cfv wss cJ vx cv cfi cfv ctg cfv wceq cX vc
      cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw
      cfn cin wral wa vy cv cuni c0 wceq wn vy cv va cv vz cv wss cX vb cv cuni
      wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun
      wss vy cv cuni vx cv cfi cfv wss vu cv vv cv wss vv cv vu cv wss wo vv vy
      cv wral vu vy cv wral vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz
      cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vw cv vx
      cv cfi cfv wss vw vy cv wral vy cv cuni vx cv cfi cfv wss vy cv va cv vz
      cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wss vw cv vx cv cfi cfv wss vw vy cv vy cv va cv
      vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wss vw cv vy cv wcel vw cv va cv vz cv wss cX vb
      cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wcel vw cv vx cv cfi cfv wss vy cv va cv vz cv wss cX vb cv cuni
      wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun
      vw cv ssel vw cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wcel vw cv vx cv cfi cfv
      cpw wcel va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral
      wa wa vw cv c0 wceq wo vw cv vx cv cfi cfv wss vw cv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      c0 csn cun wcel vw cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab wcel vw cv c0 csn wcel wo vw cv
      vx cv cfi cfv cpw wcel va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw
      cfn cin wral wa wa vw cv c0 wceq wo vw cv va cv vz cv wss cX vb cv cuni
      wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn
      elun vw cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab wcel vw cv vx cv cfi cfv cpw wcel va cv
      vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa vw cv c0
      csn wcel vw cv c0 wceq va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn
      cin wral wa vz vw cv vx cv cfi cfv cpw vz cv vw cv wceq va cv vz cv wss
      va cv vw cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral cX vb cv
      cuni wceq wn vb vw cv cpw cfn cin wral vz cv vw cv va cv sseq2 vz cv vw
      cv wceq cX vb cv cuni wceq wn vb vz cv cpw cfn cin vw cv cpw cfn cin vz
      cv vw cv wceq vz cv cpw vw cv cpw cfn vz cv vw cv pweq ineq1d raleq1d
      anbi12d elrab vw c0 elsn orbi12i bitri vw cv vx cv cfi cfv cpw wcel va cv
      vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa vw cv vx
      cv cfi cfv wss vw cv c0 wceq vw cv vx cv cfi cfv cpw wcel vw cv vx cv cfi
      cfv wss va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral
      wa vw cv vx cv cfi cfv elpwi adantr vw cv c0 wceq vw cv vx cv cfi cfv wss
      c0 vx cv cfi cfv wss vx cv cfi cfv 0ss vw cv c0 vx cv cfi cfv sseq1
      mpbiri jaoi sylbi syl6 r19.21aiv vw vy cv vx cv cfi cfv unissb sylibr
      adantr ad2antlr vy cv cuni vx cv cfi cfv vy cv vy visset uniex elpw
      sylibr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy
      cv wral vu vy cv wral wa wa vy cv cuni c0 wceq wn va cv vy cv cuni wss cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX
      vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv
      wral wa wa vy cv c0 csn wss wn va cv vy cv cuni wss vy cv cuni c0 wceq wn
      vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa
      vz vx cv cfi cfv cpw crab c0 csn cun wss vy cv c0 csn wss wn va cv vy cv
      cuni wss wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vu cv
      vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral vy cv va cv vz
      cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wss vy cv c0 csn wss wn vy cv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      cin c0 wne va cv vy cv cuni wss vy cv va cv vz cv wss cX vb cv cuni wceq
      wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss
      vy cv c0 csn wss vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab cin c0 vy cv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      cin c0 wceq vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vy cv c0 csn wss vy
      cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw crab c0 csn disjssun biimpcd necon3bd vy cv va cv vz cv
      wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv
      cpw crab cin c0 wne vw cv vy cv va cv vz cv wss cX vb cv cuni wceq wn vb
      vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab cin wcel vw wex va cv
      vy cv cuni wss vw vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab cin n0 vw cv vy cv va cv vz
      cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab cin wcel va cv vy cv cuni wss vw vw cv vy cv va cv vz cv wss
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw
      crab cin wcel vw cv vy cv wcel vw cv vx cv cfi cfv cpw wcel va cv vw cv
      wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa wa va cv vy cv
      cuni wss vw cv vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab cin wcel vw cv vy cv wcel vw cv
      va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx
      cv cfi cfv cpw crab wcel wa vw cv vy cv wcel vw cv vx cv cfi cfv cpw wcel
      va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa wa
      vw cv vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab elin vw cv va cv vz cv wss cX vb cv
      cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab wcel
      vw cv vx cv cfi cfv cpw wcel va cv vw cv wss cX vb cv cuni wceq wn vb vw
      cv cpw cfn cin wral wa wa vw cv vy cv wcel va cv vz cv wss cX vb cv cuni
      wceq wn vb vz cv cpw cfn cin wral wa va cv vw cv wss cX vb cv cuni wceq
      wn vb vw cv cpw cfn cin wral wa vz vw cv vx cv cfi cfv cpw vz cv vw cv
      wceq va cv vz cv wss va cv vw cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral vz cv vw cv
      va cv sseq2 vz cv vw cv wceq cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      vw cv cpw cfn cin vz cv vw cv wceq vz cv cpw vw cv cpw cfn vz cv vw cv
      pweq ineq1d raleq1d anbi12d elrab anbi2i bitri va cv vw cv wss vw cv vy
      cv wcel va cv vy cv cuni wss vw cv vy cv wcel vw cv vx cv cfi cfv cpw
      wcel va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa
      wa wa va cv vw cv vy cv ssuni vw cv vy cv wcel vw cv vx cv cfi cfv cpw
      wcel va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral
      simprrl vw cv vy cv wcel vw cv vx cv cfi cfv cpw wcel va cv vw cv wss cX
      vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa pm3.26 sylanc sylbi
      19.23aiv sylbi syl6 ad2antrl vy cv cuni c0 wceq vy cv c0 csn wss vy cv
      uni0b notbii syl5ib imp cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin
      wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu
      cv wss wo vv vy cv wral vu vy cv wral wa wa vy cv cuni c0 wceq wn wa cX
      vn cv cuni wceq wn vn vy cv cuni cpw cfn cin wral cX vb cv cuni wceq wn
      vb vy cv cuni cpw cfn cin wral cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw
      cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss
      vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vy cv cuni c0 wceq
      wn wa cX vn cv cuni wceq wn vn vy cv cuni cpw cfn cin cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni
      wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni
      wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun
      wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa
      vy cv cuni c0 wceq wn wa vn cv vy cv cuni wss vn cv cfn wcel wa cX vn cv
      cuni wceq wn vn cv vy cv cuni cpw cfn cin wcel cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn
      vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn
      vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu
      cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vy cv
      cuni c0 wceq wn wa vn cv vy cv cuni wss vn cv cfn wcel cX vn cv cuni wceq
      wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd
      vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel
      w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv
      wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv
      cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral
      vu vy cv wral wa wa vy cv cuni c0 wceq wn wa vn cv cfn wcel vn cv vy cv
      cuni wss cX vn cv cuni wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw
      cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss
      vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vy cv cuni c0 wceq
      wn vn cv cfn wcel vn cv vy cv cuni wss cX vn cv cuni wceq wn wi cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb
      cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX vb
      cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv
      wral wa wa vy cv cuni c0 wceq wn vn cv cfn wcel wa wa vn cv vy cv cuni
      wss vn cv vw cv wss vw vy cv wrex cX vn cv cuni wceq wn cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni
      wceq wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni
      wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun
      wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa
      vy cv cuni c0 wceq wn vn cv cfn wcel wa vn cv vy cv cuni wss vn cv vw cv
      wss vw vy cv wrex vy cv c0 wne vu cv vv cv wss vv cv vu cv wss wo vv vy
      cv wral vu vy cv wral vn cv cfn wcel vn cv vy cv cuni wss vn cv vw cv wss
      vw vy cv wrex cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv
      va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx
      cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv
      vy cv wral vu vy cv wral wa wa vy cv cuni c0 wceq wn vn cv cfn wcel wa vn
      cv vy cv cuni wss wa wa vu vv vw vy cv vn cv finsschain vy cv cuni c0
      wceq wn vn cv cfn wcel wa vy cv c0 wne cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv
      cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv
      wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vn cv vy cv cuni
      wss vy cv cuni c0 wceq wn vy cv c0 wne vn cv cfn wcel vy cv cuni c0 wceq
      vy cv c0 vy cv c0 wceq vy cv cuni c0 cuni c0 vy cv c0 unieq uni0 syl6eq
      necon3bi adantr ad2antrl cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin
      wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu
      cv wss wo vv vy cv wral vu vy cv wral vy cv cuni c0 wceq wn vn cv cfn
      wcel wa vn cv vy cv cuni wss wa simplrr cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv
      cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv
      wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vy cv cuni c0
      wceq wn vn cv cfn wcel vn cv vy cv cuni wss simprlr cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq
      wn vb va cv cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq
      wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss
      vu cv vv cv wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vy
      cv cuni c0 wceq wn vn cv cfn wcel wa vn cv vy cv cuni wss simprr syl2anc
      expr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va cv
      vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy cv
      wral vu vy cv wral wa wa vy cv cuni c0 wceq wn vn cv cfn wcel wa wa vn cv
      vw cv wss cX vn cv cuni wceq wn vw vy cv cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv
      cpw cfn cin wral wa vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vu cv vv cv
      wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral wa wa vn cv cfn wcel
      vw cv vy cv wcel vn cv vw cv wss cX vn cv cuni wceq wn wi wi vy cv cuni
      c0 wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vy cv va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wss vu cv vv cv wss vv cv vu cv wss wo vv vy
      cv wral vu vy cv wral wa wa vn cv cfn wcel vw cv vy cv wcel vn cv vw cv
      wss cX vn cv cuni wceq wn wi wi cX vb cv cuni wceq wn vb va cv cpw cfn
      cin wral vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vn cv cfn wcel vw cv vy
      cv wcel vn cv vw cv wss cX vn cv cuni wceq wn wi wi wi cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vv cv
      wss vv cv vu cv wss wo vv vy cv wral vu vy cv wral cX c0 cuni wceq wn vy
      cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw crab c0 csn cun wss vn cv cfn wcel vw cv vy cv wcel vn
      cv vw cv wss cX vn cv cuni wceq wn wi wi wi cX vb cv cuni wceq wn vb va
      cv cpw cfn cin wral cX c0 cuni wceq wn vy cv va cv vz cv wss cX vb cv
      cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wss wa vw cv vy cv wcel vn cv cfn wcel vn cv vw cv wss cX vn cv
      cuni wceq wn wi vy cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wss vw cv vy cv wcel
      vw cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa
      vz vx cv cfi cfv cpw crab c0 csn cun wcel cX c0 cuni wceq wn vn cv cfn
      wcel vn cv vw cv wss cX vn cv cuni wceq wn wi wi vy cv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      c0 csn cun vw cv ssel cX c0 cuni wceq wn vw cv vx cv cfi cfv cpw wcel va
      cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa vw cv
      c0 wceq wo vn cv cfn wcel vn cv vw cv wss cX vn cv cuni wceq wn wi wi vw
      cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw crab c0 csn cun wcel cX c0 cuni wceq wn vw cv vx cv cfi
      cfv cpw wcel va cv vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin
      wral wa wa vn cv cfn wcel vn cv vw cv wss cX vn cv cuni wceq wn wi wi vw
      cv c0 wceq vw cv vx cv cfi cfv cpw wcel va cv vw cv wss cX vb cv cuni
      wceq wn vb vw cv cpw cfn cin wral wa wa vn cv cfn wcel vn cv vw cv wss cX
      vn cv cuni wceq wn wi wi wi cX c0 cuni wceq wn cX vb cv cuni wceq wn vb
      vw cv cpw cfn cin wral vn cv cfn wcel vn cv vw cv wss cX vn cv cuni wceq
      wn wi wi vw cv vx cv cfi cfv cpw wcel va cv vw cv wss cX vb cv cuni wceq
      wn vb vw cv cpw cfn cin wral vn cv vw cv wss vn cv cfn wcel cX vn cv cuni
      wceq wn cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral vn cv vw cv cpw
      wcel vn cv cfn wcel cX vn cv cuni wceq wn wi vn cv vw cv wss cX vb cv
      cuni wceq wn vb vw cv cpw cfn cin wral vn cv vw cv cpw wcel vn cv cfn
      wcel cX vn cv cuni wceq wn cX vb cv cuni wceq wn vb vw cv cpw cfn cin
      wral vn cv vw cv cpw cfn cin wcel cX vn cv cuni wceq wn vn cv vw cv cpw
      wcel vn cv cfn wcel wa cX vb cv cuni wceq wn cX vn cv cuni wceq wn vb vn
      cv vw cv cpw cfn cin vb cv vn cv wceq cX vb cv cuni wceq cX vn cv cuni
      wceq vb cv vn cv wceq vb cv cuni vn cv cuni cX vb cv vn cv unieq eqeq2d
      notbid rcla4cv vn cv vw cv cpw cfn elin syl5ibr exp3a vn cv vw cv vn
      visset elpw syl5ibr com23 ad2antll a1i cX c0 cuni wceq wn vw cv c0 wceq
      vn cv vw cv wss vn cv cfn wcel cX vn cv cuni wceq wn vw cv c0 wceq vn cv
      vw cv wss vn cv c0 wceq cX c0 cuni wceq wn vn cv cfn wcel cX vn cv cuni
      wceq wn wi vw cv c0 wceq vn cv vw cv wss vn cv c0 wss vn cv c0 wceq vw cv
      c0 vn cv sseq2 vn cv ss0 syl6bi cX c0 cuni wceq wn vn cv c0 wceq cX vn cv
      cuni wceq wn vn cv cfn wcel vn cv c0 wceq cX vn cv cuni wceq wn cX c0
      cuni wceq wn vn cv c0 wceq cX vn cv cuni wceq cX c0 cuni wceq vn cv c0
      wceq vn cv cuni c0 cuni cX vn cv c0 unieq eqeq2d notbid biimprcd a1dd
      syl9r com34 jaod vw cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wcel vw cv va cv vz
      cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab wcel vw cv c0 csn wcel wo vw cv vx cv cfi cfv cpw wcel va cv
      vw cv wss cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa wa vw cv c0
      wceq wo vw cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn elun vw cv va cv vz cv wss cX vb
      cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      wcel vw cv vx cv cfi cfv cpw wcel va cv vw cv wss cX vb cv cuni wceq wn
      vb vw cv cpw cfn cin wral wa wa vw cv c0 csn wcel vw cv c0 wceq va cv vz
      cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa va cv vw cv wss
      cX vb cv cuni wceq wn vb vw cv cpw cfn cin wral wa vz vw cv vx cv cfi cfv
      cpw vz cv vw cv wceq va cv vz cv wss va cv vw cv wss cX vb cv cuni wceq
      wn vb vz cv cpw cfn cin wral cX vb cv cuni wceq wn vb vw cv cpw cfn cin
      wral vz cv vw cv va cv sseq2 vz cv vw cv wceq cX vb cv cuni wceq wn vb vz
      cv cpw cfn cin vw cv cpw cfn cin vz cv vw cv wceq vz cv cpw vw cv cpw cfn
      vz cv vw cv pweq ineq1d raleq1d anbi12d elrab vw c0 elsn orbi12i bitri
      syl5ib sylan9r com23 cX vb cv cuni wceq wn vb va cv cpw cfn cin wral c0
      va cv cpw cfn cin wcel cX c0 cuni wceq wn c0 va cv cpw cfn cin wcel c0 va
      cv cpw wcel c0 cfn wcel c0 va cv cpw cfn elin va cv 0elpw emfin mpbir2an
      cX vb cv cuni wceq wn cX c0 cuni wceq wn vb c0 va cv cpw cfn cin vb cv c0
      wceq cX vb cv cuni wceq cX c0 cuni wceq vb cv c0 wceq vb cv cuni c0 cuni
      cX vb cv c0 unieq eqeq2d notbid rcla4cv mpi sylan ad2ant2lr imp adantrl
      r19.23adv syld expr com23 imp3a vn cv vy cv cuni cpw cfn cin wcel vn cv
      vy cv cuni cpw wcel vn cv cfn wcel wa vn cv vy cv cuni wss vn cv cfn wcel
      wa vn cv vy cv cuni cpw cfn elin vn cv vy cv cuni cpw wcel vn cv vy cv
      cuni wss vn cv cfn wcel vn cv vy cv cuni vn visset elpw anbi1i bitri
      syl5ib r19.21aiv cX vn cv cuni wceq wn cX vb cv cuni wceq wn vn vb vy cv
      cuni cpw cfn cin vn cv vb cv wceq cX vn cv cuni wceq cX vb cv cuni wceq
      vn cv vb cv wceq vn cv cuni vb cv cuni cX vn cv vb cv unieq eqeq2d notbid
      cbvralv sylib jca32 ex vy cv cuni c0 csn wcel vy cv cuni va cv vz cv wss
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw
      crab wcel wo vy cv cuni va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab wcel vy cv cuni c0 csn wcel
      wo vy cv cuni c0 wceq wn vy cv cuni vx cv cfi cfv cpw wcel va cv vy cv
      cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin wral wa wa wi vy
      cv cuni va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral
      wa vz vx cv cfi cfv cpw crab c0 csn cun wcel vy cv cuni c0 csn wcel vy cv
      cuni va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa
      vz vx cv cfi cfv cpw crab wcel orcom vy cv cuni c0 csn wcel vy cv cuni va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab wcel wo vy cv cuni c0 wceq vy cv cuni vx cv cfi cfv cpw
      wcel va cv vy cv cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin
      wral wa wa wo vy cv cuni c0 wceq wn vy cv cuni vx cv cfi cfv cpw wcel va
      cv vy cv cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin wral wa
      wa wi vy cv cuni c0 csn wcel vy cv cuni c0 wceq vy cv cuni va cv vz cv
      wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv
      cpw crab wcel vy cv cuni vx cv cfi cfv cpw wcel va cv vy cv cuni wss cX
      vb cv cuni wceq wn vb vy cv cuni cpw cfn cin wral wa wa vy cv cuni c0 vy
      cv vy visset uniex elsnc va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa va cv vy cv cuni wss cX vb cv cuni wceq wn vb vy cv
      cuni cpw cfn cin wral wa vz vy cv cuni vx cv cfi cfv cpw vz cv vy cv cuni
      wceq va cv vz cv wss va cv vy cv cuni wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin wral vz
      cv vy cv cuni va cv sseq2 vz cv vy cv cuni wceq cX vb cv cuni wceq wn vb
      vz cv cpw cfn cin vy cv cuni cpw cfn cin vz cv vy cv cuni wceq vz cv cpw
      vy cv cuni cpw cfn vz cv vy cv cuni pweq ineq1d raleq1d anbi12d elrab
      orbi12i vy cv cuni c0 wceq vy cv cuni vx cv cfi cfv cpw wcel va cv vy cv
      cuni wss cX vb cv cuni wceq wn vb vy cv cuni cpw cfn cin wral wa wa df-or
      bitr2i vy cv cuni va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn elun 3bitr4i sylib ex
      19.21aiv vu vv vy va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun va cv vz cv wss cX vb cv
      cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw vx cv cfi cfv vx cv cfi fvex pwex rabex p0ex unex zorn
      syl $.
      $( [27-Jan-2010] $) $( [27-Jan-2010] $)

    $( Lemma for ~ alexsub . If a point is covered by a collection taken from
       the base with no finite subcover, a set from the subbase can be added
       that covers the point so that the resulting collection has no finite
       subcover. $)
    alexsublem3 $p |- ( ( ( ( ( J = ( topGen ` ( fi ` x ) ) /\ A. c e. ~P x ( X
    = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) /\ a e. ~P ( fi ` x ) ) /\ (
    u e. ~P ( fi ` x ) /\ ( a C_ u /\ A. b e. ( ~P u i^i Fin ) -. X = U. b )
    ) ) /\ w e. u ) /\ ( ( t C_ x /\ t e. Fin /\ w = |^| t ) /\ ( y e. w /\ -.
    y e. U. ( x i^i u ) ) ) ) -> E. s e. t A. n e. ( ~P ( u u. { s } ) i^i Fin
    ) -. X = U. n ) $=
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu
      cv cpw cfn cin wral wa wa wa vw cv vu cv wcel vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn
      cin wral vs vt cv wrex cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral vw cv vu cv wcel vt cv vx
      cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx
      cv vu cv cin cuni wcel wn wa wa cX vn cv cuni wceq wn vn vu cv vs cv csn
      cun cpw cfn cin wral vs vt cv wrex wi wi cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral vw cv vu cv
      wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn wa wa cX vn cv cuni wceq wn vn vu
      cv vs cv csn cun cpw cfn cin wral vs vt cv wrex wi wi wi cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv
      cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw
      cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel
      wn wa wa vw cv vu cv wcel cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vs vt cv
      wrex cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv
      wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv
      vu cv cin cuni wcel wn wa wa vw cv vu cv wcel cX vb cv cuni wceq wn vb vu
      cv cpw cfn cin wral cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn
      cin wral vs vt cv wrex wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni
      wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va
      cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv
      wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv
      vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa
      wa cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vs vt cv
      wrex cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      vw cv vu cv wcel wa wa cX vn cv cuni wceq vn vu cv vs cv csn cun cpw cfn
      cin wrex vs vt cv wral cX vb cv cuni wceq vb vu cv cpw cfn cin wrex cX vn
      cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vs vt cv wrex wn
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wn cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      vw cv vu cv wcel wa wa cX vn cv cuni wceq vn vu cv vs cv csn cun cpw cfn
      cin wrex vs vt cv wral cX vm cv cuni vs cv cun wceq vm vu cv cpw cfn cin
      wrex vs vt cv wral vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv
      cuni vs cv cun wceq vs vt cv wral wa vf wex cX vb cv cuni wceq vb vu cv
      cpw cfn cin wrex cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa
      vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel
      vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa cX vn cv
      cuni wceq vn vu cv vs cv csn cun cpw cfn cin wrex cX vm cv cuni vs cv cun
      wceq vm vu cv cpw cfn cin wrex vs vt cv cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel wa cX vn cv cuni wceq cX vm cv cuni vs cv cun
      wceq vm vu cv cpw cfn cin wrex vn vu cv vs cv csn cun cpw cfn cin cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel wa vn cv vu cv
      vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq cX vm cv cuni vs cv cun
      wceq vm vu cv cpw cfn cin wrex cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX
      vn cv cuni wceq wa cX vm cv cuni vs cv cun wceq vm vu cv cpw cfn cin wrex
      vn cv vs cv csn cdif vu cv cpw cfn cin wcel cX vn cv vs cv csn cdif cuni
      vs cv cun wceq cX vm cv cuni vs cv cun wceq vm vu cv cpw cfn cin wrex cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs
      cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa cX vm cv cuni vs
      cv cun wceq cX vn cv vs cv csn cdif cuni vs cv cun wceq vm vn cv vs cv
      csn cdif vu cv cpw cfn cin vm cv vn cv vs cv csn cdif wceq vm cv cuni vs
      cv cun vn cv vs cv csn cdif cuni vs cv cun cX vm cv vn cv vs cv csn cdif
      wceq vm cv cuni vn cv vs cv csn cdif cuni vs cv vm cv vn cv vs cv csn
      cdif unieq uneq1d eqeq2d rcla4ev cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX
      vn cv cuni wceq wa wa wa vn cv vs cv csn cdif vu cv wss vn cv vs cv csn
      cdif cfn wcel wa vn cv vs cv csn cdif vu cv cpw cfn cin wcel vn cv vu cv
      vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa vn cv vs cv csn cdif
      vu cv wss vn cv vs cv csn cdif cfn wcel wa cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint
      wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv
      vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin
      wcel vn cv vs cv csn cdif vu cv wss vn cv vs cv csn cdif cfn wcel wa cX
      vn cv cuni wceq vn cv vu cv vs cv csn cun cpw cfn cin wcel vn cv vu cv vs
      cv csn cun cpw wcel vn cv cfn wcel wa vn cv vs cv csn cdif vu cv wss vn
      cv vs cv csn cdif cfn wcel wa vn cv vu cv vs cv csn cun cpw cfn elin vn
      cv vu cv vs cv csn cun cpw wcel vn cv cfn wcel wa vn cv vs cv csn cdif vu
      cv wss vn cv vs cv csn cdif cfn wcel vn cv vu cv vs cv csn cun cpw wcel
      vn cv cfn wcel wa vn cv vs cv csn vu cv cun wss vn cv vs cv csn cdif vu
      cv wss vn cv vu cv vs cv csn cun cpw wcel vn cv cfn wcel wa vn cv vu cv
      vs cv csn cun vs cv csn vu cv cun vn cv vu cv vs cv csn cun cpw wcel vn
      cv vu cv vs cv csn cun wss vn cv cfn wcel vn cv vu cv vs cv csn cun elpwi
      adantr vu cv vs cv csn uncom syl6ss vn cv vs cv csn vu cv ssundif sylib
      vn cv cfn wcel vn cv vs cv csn cdif cfn wcel vn cv vu cv vs cv csn cun
      cpw wcel vn cv vs cv csn finfin adantl jca sylbi adantr ad2antll vn cv vs
      cv csn cdif vu cv cpw cfn cin wcel vn cv vs cv csn cdif vu cv cpw wcel vn
      cv vs cv csn cdif cfn wcel wa vn cv vs cv csn cdif vu cv wss vn cv vs cv
      csn cdif cfn wcel wa vn cv vs cv csn cdif vu cv cpw cfn elin vn cv vs cv
      csn cdif vu cv cpw wcel vn cv vs cv csn cdif vu cv wss vn cv vs cv csn
      cdif cfn wcel vn cv vs cv csn cdif vu cv vu visset elpw2 anbi1i bitr2i
      sylib cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv
      wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv
      vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn
      cv vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa cX vn
      cv vs cv csn cdif cuni vs cv cun cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX
      vn cv cuni wceq wa wa wa cX vn cv cuni vn cv vs cv csn cdif cuni vs cv
      cun cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv
      wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv
      vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn
      cv vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq simprrr cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs
      cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa vn cv cuni vn cv
      vs cv csn cdif vs cv csn cun cuni vn cv vs cv csn cdif cuni vs cv cun vn
      cv cuni vn cv vs cv csn cdif vs cv csn cun cuni wss cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn
      cin wcel cX vn cv cuni wceq wa wa wa vn cv vn cv vs cv csn cdif vs cv csn
      cun wss vn cv cuni vn cv vs cv csn cdif vs cv csn cun cuni wss vx vn cv
      vn cv vs cv csn cdif vs cv csn cun vx cv vn cv wcel vx cv vs cv csn wcel
      wn vx cv vn cv vs cv csn cdif wcel wi vx cv vn cv vs cv csn cdif vs cv
      csn cun wcel vx cv vn cv wcel vx cv vs cv csn wcel wn vx cv vn cv vs cv
      csn cdif wcel vx cv vn cv vs cv csn cdif wcel vx cv vn cv wcel vx cv vs
      cv csn wcel wn wa vx cv vn cv vs cv csn eldif biimpri ex vx cv vn cv vs
      cv csn cdif vs cv csn cun wcel vx cv vn cv vs cv csn cdif wcel vx cv vs
      cv csn wcel wo vx cv vs cv csn wcel vx cv vn cv vs cv csn cdif wcel wo vx
      cv vs cv csn wcel wn vx cv vn cv vs cv csn cdif wcel wi vx cv vn cv vs cv
      csn cdif vs cv csn elun vx cv vs cv csn wcel vx cv vn cv vs cv csn cdif
      wcel orcom vx cv vs cv csn wcel vx cv vn cv vs cv csn cdif wcel df-or
      3bitr2ri sylib ssriv vn cv vn cv vs cv csn cdif vs cv csn cun uniss ax-mp
      a1i vn cv vs cv csn cdif vs cv csn cun cuni vn cv vs cv csn cdif cuni vs
      cv csn cuni cun vn cv vs cv csn cdif cuni vs cv cun vn cv vs cv csn cdif
      vs cv csn uniun vs cv csn cuni vs cv vn cv vs cv csn cdif cuni vs cv vs
      visset unisn uneq2i eqtri syl6ss eqsstrd cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX
      vn cv cuni wceq wa wa wa vn cv vs cv csn cdif cuni cX wss vs cv cX wss wa
      vn cv vs cv csn cdif cuni vs cv cun cX wss cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint
      wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv
      vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin
      wcel cX vn cv cuni wceq wa wa wa vn cv vs cv csn cdif cuni cX wss vs cv
      cX wss vn cv vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa
      vn cv vs cv csn cdif cuni cX wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel cX vn cv cuni wceq vn cv vs cv csn cdif cuni
      cX wss vn cv vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq vn
      cv vs cv csn cdif cuni cX wss vn cv vs cv csn cdif cuni vn cv cuni wss vn
      cv vs cv csn cdif vn cv wss vn cv vs cv csn cdif cuni vn cv cuni wss vn
      cv vs cv csn difss vn cv vs cv csn cdif vn cv uniss ax-mp cX vn cv cuni
      vn cv vs cv csn cdif cuni sseq2 mpbiri adantl ad2antll cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv
      cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw
      cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel
      wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn
      cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa vs cv vx cv cuni cX cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs
      cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa vs cv vx cv wcel
      vs cv vx cv cuni wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa
      wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vs
      cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni
      wceq wa wa wa vt cv vx cv vs cv vt cv vx cv wss vt cv cfn wcel vw cv vt
      cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa
      wa vw cv vu cv wcel wa vt cv vx cv wss cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin
      wcel cX vn cv cuni wceq wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vt cv vx cv wss vy cv vw cv wcel vy cv vx cv vu cv cin cuni
      wcel wn wa vw cv vu cv wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq 3simp1 ad2antrr ad2antlr cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX
      vn cv cuni wceq wa simprl sseldd vs cv vx cv elssuni syl cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv
      cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw
      cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel
      wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs cv csn
      cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa vx cv cuni cJ cuni cX cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs
      cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa vx cv cfi cfv ctg
      cfv cuni vx cv cfi cfv cuni cJ cuni vx cv cuni vx cv cfi cfv ctg cfv cuni
      vx cv cfi cfv cuni wceq cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw
      cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa
      vs cv vt cv wcel vn cv vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni
      wceq wa wa wa vx cv cfi cfv ctb wcel vx cv cfi cfv ctg cfv cuni vx cv cfi
      cfv cuni wceq vx cv cvv wcel vx cv cfi cfv ctb wcel vx visset vx cv cvv
      fibas ax-mp vx cv cfi cfv unitg ax-mp a1i cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss wa wa cJ cuni vx cv cfi cfv ctg cfv cuni wceq vt cv vx cv
      wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv
      vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa vs cv vt cv wcel vn cv
      vu cv vs cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cJ
      cuni vx cv cfi cfv ctg cfv cuni wceq vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral cJ cuni vx cv
      cfi cfv ctg cfv cuni wceq va cv vx cv cfi cfv cpw wcel cJ vx cv cfi cfv
      ctg cfv unieq 3ad2ant1 adantr ad2antrr vx cv cuni vx cv cfi cfv cuni wceq
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv
      cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vs cv vt cv wcel vn cv vu cv vs
      cv csn cun cpw cfn cin wcel cX vn cv cuni wceq wa wa wa vx cv cvv wcel vx
      cv cuni vx cv cfi cfv cuni wceq vx visset vx cv cvv fiuni ax-mp a1i
      3eqtr4rd alexsub.1 syl6eqr sseqtrd jca vn cv vs cv csn cdif cuni vs cv cX
      unss sylib eqssd sylanc expr exp3a r19.23adv r19.20dva vt cv vx cv wss vt
      cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv
      cin cuni wcel wn wa wa cX vm cv cuni vs cv cun wceq vm vu cv cpw cfn cin
      wrex vs vt cv wral vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv
      cuni vs cv cun wceq vs vt cv wral wa vf wex wi cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vw cv vu cv wcel vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a cX vm cv cuni vs cv cun wceq vm vu cv cpw
      cfn cin wrex vs vt cv wral vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf
      cv cfv cuni vs cv cun wceq vs vt cv wral wa vf wex wi vy cv vw cv wcel vy
      cv vx cv vu cv cin cuni wcel wn wa vt cv cfn wcel vt cv vx cv wss cX vm
      cv cuni vs cv cun wceq vm vu cv cpw cfn cin wrex vs vt cv wral vt cv vu
      cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv
      wral wa vf wex wi vw cv vt cv cint wceq vt cv cfn wcel cX vm cv cuni vs
      cv cun wceq vm vu cv cpw cfn cin wrex vs vt cv wral vt cv vu cv cpw cfn
      cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa vf
      wex cX vm cv cuni vs cv cun wceq cX vs cv vf cv cfv cuni vs cv cun wceq
      vs vm vt cv vu cv cpw cfn cin vf vm cv vs cv vf cv cfv wceq vm cv cuni vs
      cv cun vs cv vf cv cfv cuni vs cv cun cX vm cv vs cv vf cv cfv wceq vm cv
      cuni vs cv vf cv cfv cuni vs cv vm cv vs cv vf cv cfv unieq uneq1d eqeq2d
      ac6sfi ex 3ad2ant2 adantr ad2antrl cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv
      cun wceq vs vt cv wral wa cX vb cv cuni wceq vb vu cv cpw cfn cin wrex vf
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv
      cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv
      wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa cX vb cv cuni
      wceq vb vu cv cpw cfn cin wrex vs vt cv vs cv vf cv cfv ciun vw cv csn
      cun vu cv cpw cfn cin wcel cX vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      cuni wceq cX vb cv cuni wceq vb vu cv cpw cfn cin wrex cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv
      cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw
      cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel
      wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv
      vf cv cfv cuni vs cv cun wceq vs vt cv wral wa wa cX vb cv cuni wceq cX
      vs vt cv vs cv vf cv cfv ciun vw cv csn cun cuni wceq vb vs vt cv vs cv
      vf cv cfv ciun vw cv csn cun vu cv cpw cfn cin vb cv vs vt cv vs cv vf cv
      cfv ciun vw cv csn cun wceq vb cv cuni vs vt cv vs cv vf cv cfv ciun vw
      cv csn cun cuni cX vb cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      unieq eqeq2d rcla4ev cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa
      wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vt
      cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs
      vt cv wral wa wa vs vt cv vs cv vf cv cfv ciun vw cv csn cun vu cv wss vs
      vt cv vs cv vf cv cfv ciun vw cv csn cun cfn wcel wa vs vt cv vs cv vf cv
      cfv ciun vw cv csn cun vu cv cpw cfn cin wcel cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv
      cfv cuni vs cv cun wceq vs vt cv wral wa wa vs vt cv vs cv vf cv cfv ciun
      vw cv csn cun vu cv wss vs vt cv vs cv vf cv cfv ciun vw cv csn cun cfn
      wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv
      wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv
      vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn
      cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa wa
      vs vt cv vs cv vf cv cfv ciun vu cv wss vw cv csn vu cv wss wa vs vt cv
      vs cv vf cv cfv ciun vw cv csn cun vu cv wss cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv
      cfv cuni vs cv cun wceq vs vt cv wral wa wa vs vt cv vs cv vf cv cfv ciun
      vu cv wss vw cv csn vu cv wss vt cv vu cv cpw cfn cin vf cv wf vs vt cv
      vs cv vf cv cfv ciun vu cv wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral vt cv vu
      cv cpw cfn cin vf cv wf vs cv vf cv cfv vu cv wss vs vt cv wral vs vt cv
      vs cv vf cv cfv ciun vu cv wss vt cv vu cv cpw cfn cin vf cv wf vs cv vf
      cv cfv vu cv wss vs vt cv vt cv vu cv cpw cfn cin vf cv wf vs cv vt cv
      wcel vs cv vf cv cfv vu cv wss vt cv vu cv cpw cfn cin vf cv wf vs cv vt
      cv wcel wa vs cv vf cv cfv vu cv cpw cfn cin wcel vs cv vf cv cfv vu cv
      wss vt cv vu cv cpw cfn cin vs cv vf cv ffvelrn vs cv vf cv cfv vu cv cpw
      cfn cin wcel vs cv vf cv cfv vu cv cpw wcel vs cv vf cv cfv cfn wcel wa
      vs cv vf cv cfv vu cv wss vs cv vf cv cfv vu cv cpw cfn elin vs cv vf cv
      cfv vu cv cpw wcel vs cv vf cv cfv vu cv wss vs cv vf cv cfv cfn wcel vs
      cv vf cv cfv vu cv elpwi adantr sylbi syl ex r19.21aiv vs vt cv vs cv vf
      cv cfv vu cv iunss sylibr ad2antrl cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv
      cun wceq vs vt cv wral wa wa vw cv vu cv wcel vw cv csn vu cv wss cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel vt cv vu cv cpw cfn cin vf cv wf cX
      vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa simplrr vw cv vu cv
      snssi syl jca vs vt cv vs cv vf cv cfv ciun vw cv csn vu cv unss sylib cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv
      wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa wa vs vt cv vs
      cv vf cv cfv ciun cfn wcel vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      cfn wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv
      vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa
      vt cv vu cv cpw cfn cin vf cv wf vs vt cv vs cv vf cv cfv ciun cfn wcel
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa cX vs cv vf cv cfv
      cuni vs cv cun wceq vs vt cv wral vt cv vx cv wss vt cv cfn wcel vw cv vt
      cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa
      wa vt cv vu cv cpw cfn cin vf cv wf vs vt cv vs cv vf cv cfv ciun cfn
      wcel vw cv vu cv wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint
      wceq w3a vt cv vu cv cpw cfn cin vf cv wf vs vt cv vs cv vf cv cfv ciun
      cfn wcel vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa vt cv cfn
      wcel vt cv vx cv wss vt cv vu cv cpw cfn cin vf cv wf vs vt cv vs cv vf
      cv cfv ciun cfn wcel vw cv vt cv cint wceq vt cv cfn wcel vs cv vf cv cfv
      cfn wcel vs vt cv wral vs vt cv vs cv vf cv cfv ciun cfn wcel vt cv vu cv
      cpw cfn cin vf cv wf vs vt cv vs cv vf cv cfv iunfi vt cv vu cv cpw cfn
      cin vf cv wf vs cv vf cv cfv cfn wcel vs vt cv vt cv vu cv cpw cfn cin vf
      cv wf vs cv vt cv wcel vs cv vf cv cfv cfn wcel vt cv vu cv cpw cfn cin
      vf cv wf vs cv vt cv wcel wa vu cv cpw cfn cin cfn vs cv vf cv cfv vu cv
      cpw cfn cin cfn wss vt cv vu cv cpw cfn cin vf cv wf vs cv vt cv wcel wa
      vu cv cpw cfn inss2 a1i vt cv vu cv cpw cfn cin vs cv vf cv ffvelrn
      sseldd ex r19.21aiv sylan2 3ad2antl2 adantlr adantlr ad2ant2lr vs vt cv
      vs cv vf cv cfv ciun cfn wcel vw cv csn cfn wcel vs vt cv vs cv vf cv cfv
      ciun vw cv csn cun cfn wcel vw cv snfi vs vt cv vs cv vf cv cfv ciun vw
      cv csn unfi mpan2 syl jca vs vt cv vs cv vf cv cfv ciun vw cv csn cun vu
      cv cpw cfn cin wcel vs vt cv vs cv vf cv cfv ciun vw cv csn cun vu cv cpw
      wcel vs vt cv vs cv vf cv cfv ciun vw cv csn cun cfn wcel wa vs vt cv vs
      cv vf cv cfv ciun vw cv csn cun vu cv wss vs vt cv vs cv vf cv cfv ciun
      vw cv csn cun cfn wcel wa vs vt cv vs cv vf cv cfv ciun vw cv csn cun vu
      cv cpw cfn elin vs vt cv vs cv vf cv cfv ciun vw cv csn cun vu cv cpw
      wcel vs vt cv vs cv vf cv cfv ciun vw cv csn cun vu cv wss vs vt cv vs cv
      vf cv cfv ciun vw cv csn cun cfn wcel vs vt cv vs cv vf cv cfv ciun vw cv
      csn cun vu cv vu visset elpw2 anbi1i bitr2i sylib cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv
      cfv cuni vs cv cun wceq vs vt cv wral wa wa cX vs vt cv vs cv vf cv cfv
      ciun vw cv csn cun cuni cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw
      cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa
      vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq
      vs vt cv wral wa wa vv cX vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      cuni vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa cX vs
      cv vf cv cfv cuni vs cv cun wceq vs vt cv wral vv cv cX wcel vv cv vs vt
      cv vs cv vf cv cfv ciun vw cv csn cun cuni wcel wi cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vt cv vu cv cpw cfn cin vf cv wf vt cv vx
      cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx
      cv vu cv cin cuni wcel wn wa wa cX vs cv vf cv cfv cuni vs cv cun wceq vs
      vt cv wral vv cv cX wcel vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn
      cun cuni wcel wi vw cv vu cv wcel vt cv vx cv wss vt cv cfn wcel vw cv vt
      cv cint wceq w3a cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral vv
      cv cX wcel vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun cuni wcel wi
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa vw cv vt cv cint
      wceq vt cv vx cv wss cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral
      vv cv cX wcel vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun cuni wcel
      wi vt cv cfn wcel vw cv vt cv cint wceq cX vs cv vf cv cfv cuni vs cv cun
      wceq vs vt cv wral wa vv cv cX wcel vv cv vy cv wcel vy cv vs cv vf cv
      cfv wcel vs vt cv wrex wa vy wex vv cv vw cv wcel wo vv cv vs vt cv vs cv
      vf cv cfv ciun vw cv csn cun cuni wcel vw cv vt cv cint wceq cX vs cv vf
      cv cfv cuni vs cv cun wceq vs vt cv wral wa vv cv cX wcel vv cv vy cv
      wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex wa vy wex vv cv vw cv wcel
      wo vw cv vt cv cint wceq cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv
      wral wa vv cv cX wcel wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs
      vt cv wrex wa vy wex vv cv vw cv wcel vw cv vt cv cint wceq cX vs cv vf
      cv cfv cuni vs cv cun wceq vs vt cv wral wa vv cv cX wcel wa vv cv vy cv
      wcel vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy wal vv cv vw cv
      wcel vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex wa vy wex
      wn vw cv vt cv cint wceq cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv
      wral wa vv cv cX wcel wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn
      vs vt cv wral wi vy wal vv cv vt cv cint wcel vv cv vw cv wcel vw cv vt
      cv cint wceq cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa vv
      cv cX wcel wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv
      wral wi vy wal vv cv vz cv wcel vz vt cv wral vv cv vt cv cint wcel vw cv
      vt cv cint wceq cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa
      vv cv cX wcel wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv
      wral wi vy wal vv cv vz cv wcel vz vt cv vw cv vt cv cint wceq cX vs cv
      vf cv cfv cuni vs cv cun wceq vs vt cv wral wa vv cv cX wcel wa vz cv vt
      cv wcel vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi
      vy wal vv cv vz cv wcel vw cv vt cv cint wceq cX vs cv vf cv cfv cuni vs
      cv cun wceq vs vt cv wral vv cv cX wcel vz cv vt cv wcel vv cv vy cv wcel
      vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy wal vv cv vz cv wcel wi
      wi vz cv vt cv wcel cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral
      vv cv cX wcel vw cv vt cv cint wceq vv cv vy cv wcel vy cv vs cv vf cv
      cfv wcel wn vs vt cv wral wi vy wal vv cv vz cv wcel wi vz cv vt cv wcel
      cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral cX vz cv vf cv cfv
      cuni vz cv cun wceq vv cv cX wcel vw cv vt cv cint wceq vv cv vy cv wcel
      vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy wal vv cv vz cv wcel wi
      wi wi cX vs cv vf cv cfv cuni vs cv cun wceq cX vz cv vf cv cfv cuni vz
      cv cun wceq vs vz cv vt cv vs cv vz cv wceq vs cv vf cv cfv cuni vs cv
      cun vz cv vf cv cfv cuni vz cv cun cX vs cv vz cv wceq vs cv vf cv cfv
      cuni vz cv vf cv cfv cuni vs cv vz cv vs cv vz cv wceq vs cv vf cv cfv vz
      cv vf cv cfv vs cv vz cv vf cv fveq2 unieqd vs cv vz cv wceq id uneq12d
      eqeq2d rcla4v cX vz cv vf cv cfv cuni vz cv cun wceq vv cv cX wcel vv cv
      vz cv vf cv cfv cuni vz cv cun wcel vz cv vt cv wcel vw cv vt cv cint
      wceq vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy
      wal vv cv vz cv wcel wi wi cX vz cv vf cv cfv cuni vz cv cun wceq vv cv
      cX wcel vv cv vz cv vf cv cfv cuni vz cv cun wcel cX vz cv vf cv cfv cuni
      vz cv cun vv cv eleq2 biimpd vz cv vt cv wcel vv cv vz cv vf cv cfv cuni
      vz cv cun wcel vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv
      wral wi vy wal vv cv vz cv wcel wi vw cv vt cv cint wceq vz cv vt cv wcel
      vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wn wi vw wal vv cv vz cv wcel
      wi vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy wal
      vv cv vz cv wcel wi vv cv vz cv vf cv cfv cuni vz cv cun wcel vz cv vt cv
      wcel vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy
      wal vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wn wi vw wal vv cv vz cv
      wcel vz cv vt cv wcel vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs
      vt cv wral wi vy wal vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wn wi vw
      vv cv vy cv wcel vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy wal vv
      cv vw cv wcel vw cv vs cv vf cv cfv wcel wn vs vt cv wral vz cv vt cv
      wcel vw cv vz cv vf cv cfv wcel wn vv cv vy cv wcel vy cv vs cv vf cv cfv
      wcel wn vs vt cv wral wi vv cv vw cv wcel vw cv vs cv vf cv cfv wcel wn
      vs vt cv wral wi vy vw vy cv vw cv wceq vv cv vy cv wcel vv cv vw cv wcel
      vy cv vs cv vf cv cfv wcel wn vs vt cv wral vw cv vs cv vf cv cfv wcel wn
      vs vt cv wral vy cv vw cv vv cv eleq2 vy cv vw cv wceq vy cv vs cv vf cv
      cfv wcel wn vw cv vs cv vf cv cfv wcel wn vs vt cv vy cv vw cv wceq vy cv
      vs cv vf cv cfv wcel vw cv vs cv vf cv cfv wcel vy cv vw cv vs cv vf cv
      cfv eleq1 notbid ralbidv imbi12d a4v vw cv vs cv vf cv cfv wcel wn vw cv
      vz cv vf cv cfv wcel wn vs vz cv vt cv vs cv vz cv wceq vw cv vs cv vf cv
      cfv wcel vw cv vz cv vf cv cfv wcel vs cv vz cv wceq vs cv vf cv cfv vz
      cv vf cv cfv vw cv vs cv vz cv vf cv fveq2 eleq2d notbid rcla4v syl9r
      19.21adv imim1d vv cv vz cv vf cv cfv cuni vz cv cun wcel vv cv vz cv vf
      cv cfv cuni wcel vv cv vz cv wcel wo vv cv vw cv wcel vw cv vz cv vf cv
      cfv wcel wa vw wex vv cv vz cv wcel wo vv cv vw cv wcel vw cv vz cv vf cv
      cfv wcel wn wi vw wal vv cv vz cv wcel wi vv cv vz cv vf cv cfv cuni vz
      cv elun vv cv vz cv vf cv cfv cuni wcel vv cv vw cv wcel vw cv vz cv vf
      cv cfv wcel wa vw wex vv cv vz cv wcel vw vv cv vz cv vf cv cfv eluni
      orbi1i vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wa vw wex vv cv vz cv
      wcel wo vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wa vw wex wn vv cv vz
      cv wcel wi vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wn wi vw wal vv cv
      vz cv wcel wi vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wa vw wex vv cv
      vz cv wcel df-or vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wn wi vw wal
      vv cv vw cv wcel vw cv vz cv vf cv cfv wcel wa vw wex wn vv cv vz cv wcel
      vv cv vw cv wcel vw cv vz cv vf cv cfv wcel vw alinexa imbi1i bitr4i
      3bitri syl5ib a1dd syl9r syld com14 imp31 com23 r19.21adv vz vv cv vt cv
      vv visset elint2 syl6ibr vw cv vt cv cint wceq vv cv vw cv wcel vv cv vt
      cv cint wcel wb cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral vv
      cv cX wcel vw cv vt cv cint vv cv eleq2 ad2antrr sylibrd vv cv vy cv wcel
      vy cv vs cv vf cv cfv wcel wn vs vt cv wral wi vy wal vv cv vy cv wcel vy
      cv vs cv vf cv cfv wcel vs vt cv wrex wn wi vy wal vv cv vy cv wcel vy cv
      vs cv vf cv cfv wcel vs vt cv wrex wa vy wex wn vv cv vy cv wcel vy cv vs
      cv vf cv cfv wcel wn vs vt cv wral wi vv cv vy cv wcel vy cv vs cv vf cv
      cfv wcel vs vt cv wrex wn wi vy vy cv vs cv vf cv cfv wcel wn vs vt cv
      wral vy cv vs cv vf cv cfv wcel vs vt cv wrex wn vv cv vy cv wcel vy cv
      vs cv vf cv cfv wcel vs vt cv ralnex imbi2i albii vv cv vy cv wcel vy cv
      vs cv vf cv cfv wcel vs vt cv wrex vy alinexa bitr2i syl5ib orrd ex vv cv
      vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex wa vy wex vv cv vw cv
      wcel wo vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv
      vw cv wceq wo wa vy wex vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      cuni wcel vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex wa vy
      wex vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv vw cv
      wceq wo wa vy wex vv cv vw cv wcel vv cv vy cv wcel vy cv vs cv vf cv cfv
      wcel vs vt cv wrex wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt
      cv wrex vy cv vw cv wceq wo wa vy vy cv vs cv vf cv cfv wcel vs vt cv
      wrex vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv vw cv wceq wo vv cv
      vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv vw cv wceq orc
      anim2i 19.22i vv cv vw cv wcel vv cv vy cv wcel vy cv vw cv wceq wa vy
      wex vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv vw cv
      wceq wo wa vy wex vv cv vw cv wcel vw cv vw cv wceq vv cv vy cv wcel vy
      cv vw cv wceq wa vy wex vw cv eqid vv cv vy cv wcel vy cv vw cv wceq wa
      vv cv vw cv wcel vw cv vw cv wceq wa vy vw cv vw visset vy cv vw cv wceq
      vv cv vy cv wcel vv cv vw cv wcel vy cv vw cv wceq vw cv vw cv wceq vy cv
      vw cv vv cv eleq2 vy cv vw cv vw cv eqeq1 anbi12d cla4ev mpan2 vv cv vy
      cv wcel vy cv vw cv wceq wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel
      vs vt cv wrex vy cv vw cv wceq wo wa vy vy cv vw cv wceq vy cv vs cv vf
      cv cfv wcel vs vt cv wrex vy cv vw cv wceq wo vv cv vy cv wcel vy cv vw
      cv wceq vy cv vs cv vf cv cfv wcel vs vt cv wrex olc anim2i 19.22i syl
      jaoi vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun cuni wcel vv cv vy
      cv wcel vy cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun wcel wa vy wex
      vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv vw cv
      wceq wo wa vy wex vy vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      eluni vv cv vy cv wcel vy cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      wcel wa vv cv vy cv wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv
      vw cv wceq wo wa vy vy cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun
      wcel vy cv vs cv vf cv cfv wcel vs vt cv wrex vy cv vw cv wceq wo vv cv
      vy cv wcel vy cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun wcel vy cv
      vs vt cv vs cv vf cv cfv ciun wcel vy cv vw cv csn wcel wo vy cv vs cv vf
      cv cfv wcel vs vt cv wrex vy cv vw cv wceq wo vy cv vs vt cv vs cv vf cv
      cfv ciun vw cv csn elun vy cv vs vt cv vs cv vf cv cfv ciun wcel vy cv vs
      cv vf cv cfv wcel vs vt cv wrex vy cv vw cv csn wcel vy cv vw cv wceq vs
      vy cv vt cv vs cv vf cv cfv eliun vy vw cv elsn orbi12i bitri anbi2i
      exbii bitr2i sylib syl6 3ad2antl3 adantlr adantlr ad2ant2l ssrdv cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv
      vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv
      wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa wa vv cv cX
      wss vv vs vt cv vs cv vf cv cfv ciun vw cv csn cun wral vs vt cv vs cv vf
      cv cfv ciun vw cv csn cun cuni cX wss cJ vx cv cfi cfv ctg cfv wceq cX vc
      cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv
      cun wceq vs vt cv wral wa wa vv cv cX wss vv vs vt cv vs cv vf cv cfv
      ciun vw cv csn cun cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa
      vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel
      vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu
      cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv
      wral wa wa vv cv vs cv vf cv cfv wcel vs vt cv wrex vv cv vw cv wceq wo
      vv cv cX wss vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun wcel cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv
      wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa wa vv cv vs cv
      vf cv cfv wcel vs vt cv wrex vv cv cX wss vv cv vw cv wceq cX vs cv vf cv
      cfv cuni vs cv cun wceq vs vt cv wral vv cv vs cv vf cv cfv wcel vs vt cv
      wrex vv cv cX wss wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa
      wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vt
      cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs
      vt cv wral vv cv vs cv vf cv cfv wcel vv cv cX wss vs vt cv cX vs cv vf
      cv cfv cuni vs cv cun wceq vs vt cv hbra1 vv cv cX wss vs ax-17 cX vs cv
      vf cv cfv cuni vs cv cun wceq vs vt cv wral vs cv vt cv wcel cX vs cv vf
      cv cfv cuni vs cv cun wceq vv cv vs cv vf cv cfv wcel vv cv cX wss wi cX
      vs cv vf cv cfv cuni vs cv cun wceq vs vt cv ra4 cX vs cv vf cv cfv cuni
      vs cv cun wceq vs cv vf cv cfv cuni vs cv cun cX wss vv cv vs cv vf cv
      cfv wcel vv cv cX wss wi vs cv vf cv cfv cuni vs cv cun cX eqimss2 vs cv
      vf cv cfv cuni vs cv cun cX wss vv cv vs cv vf cv cfv cuni vs cv cun wss
      vv cv cX wss vv cv vs cv vf cv cfv wcel vv cv vs cv vf cv cfv cuni vs cv
      cun wss vs cv vf cv cfv cuni vs cv cun cX wss vv cv cX wss vv cv vs cv vf
      cv cfv cuni vs cv cun cX sstr expcom vv cv vs cv vf cv cfv wcel vv cv vs
      cv vf cv cfv cuni wss vv cv vs cv vf cv cfv cuni vs cv cun wss vv cv vs
      cv vf cv cfv elssuni vv cv vs cv vf cv cfv cuni vs cv ssun3 syl syl5 syl
      syl6 r19.23ad ad2antll vv cv vw cv wceq vv cv cX wss vw cv cX wss cJ vx
      cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw cfn cin vf cv
      wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa wa vv cv vw cv
      cX sseq1 cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx
      cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx
      cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw
      cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa
      wa vw cv vx cv cfi cfv cuni cX cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss wa wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv
      wcel wa wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv
      cun wceq vs vt cv wral wa wa vw cv vx cv cfi cfv wcel vw cv vx cv cfi cfv
      cuni wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa vt cv vx
      cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx
      cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel wa wa vt cv vu cv cpw
      cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa
      wa vu cv vx cv cfi cfv vw cv cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni
      wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va
      cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv
      wss wa wa vu cv vx cv cfi cfv wss vt cv vx cv wss vt cv cfn wcel vw cv vt
      cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa
      wa vw cv vu cv wcel wa vt cv vu cv cpw cfn cin vf cv wf cX vs cv vf cv
      cfv cuni vs cv cun wceq vs vt cv wral wa vu cv vx cv cfi cfv cpw wcel vu
      cv vx cv cfi cfv wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a va cv vu cv wss vu cv vx cv cfi cfv elpwi
      ad2antrl ad2antrr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa wa
      vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel
      vy cv vx cv vu cv cin cuni wcel wn wa wa vw cv vu cv wcel vt cv vu cv cpw
      cfn cin vf cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa
      simplrr sseldd vw cv vx cv cfi cfv elssuni syl cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss wa wa vx cv cfi cfv cuni cX wceq vt cv vx cv wss
      vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu
      cv cin cuni wcel wn wa wa vw cv vu cv wcel wa vt cv vu cv cpw cfn cin vf
      cv wf cX vs cv vf cv cfv cuni vs cv cun wceq vs vt cv wral wa cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vx cv
      cfi cfv cuni cX wceq vu cv vx cv cfi cfv cpw wcel va cv vu cv wss wa cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral vx cv cfi cfv cuni cX wceq va cv vx
      cv cfi cfv cpw wcel cJ vx cv cfi cfv ctg cfv wceq vx cv cfi cfv cuni cJ
      cuni cX cJ vx cv cfi cfv ctg cfv wceq cJ cuni vx cv cfi cfv ctg cfv cuni
      vx cv cfi cfv cuni cJ vx cv cfi cfv ctg cfv unieq vx cv cfi cfv ctb wcel
      vx cv cfi cfv ctg cfv cuni vx cv cfi cfv cuni wceq vx cv cvv wcel vx cv
      cfi cfv ctb wcel vx visset vx cv cvv fibas ax-mp vx cv cfi cfv unitg
      ax-mp syl6req alexsub.1 syl6eqr 3ad2ant1 adantr ad2antrr sseqtrd syl5cbir
      jaod vv cv vs vt cv vs cv vf cv cfv ciun vw cv csn cun wcel vv cv vs vt
      cv vs cv vf cv cfv ciun wcel vv cv vw cv csn wcel wo vv cv vs cv vf cv
      cfv wcel vs vt cv wrex vv cv vw cv wceq wo vv cv vs vt cv vs cv vf cv cfv
      ciun vw cv csn elun vv cv vs vt cv vs cv vf cv cfv ciun wcel vv cv vs cv
      vf cv cfv wcel vs vt cv wrex vv cv vw cv csn wcel vv cv vw cv wceq vs vv
      cv vt cv vs cv vf cv cfv eliun vv vw cv elsn orbi12i bitri syl5ib
      r19.21aiv vv vs vt cv vs cv vf cv cfv ciun vw cv csn cun cX unissb sylibr
      eqssd sylanc ex 19.23adv 3syld cX vn cv cuni wceq vn vu cv vs cv csn cun
      cpw cfn cin wrex vs vt cv wral cX vn cv cuni wceq wn vn vu cv vs cv csn
      cun cpw cfn cin wral wn vs vt cv wral cX vn cv cuni wceq wn vn vu cv vs
      cv csn cun cpw cfn cin wral vs vt cv wrex wn cX vn cv cuni wceq vn vu cv
      vs cv csn cun cpw cfn cin wrex cX vn cv cuni wceq wn vn vu cv vs cv csn
      cun cpw cfn cin wral wn vs vt cv cX vn cv cuni wceq vn vu cv vs cv csn
      cun cpw cfn cin dfrex2 ralbii cX vn cv cuni wceq wn vn vu cv vs cv csn
      cun cpw cfn cin wral vs vt cv ralnex bitr2i cX vb cv cuni wceq vb vu cv
      cpw cfn cin wrex cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wn cX vb
      cv cuni wceq vb vu cv cpw cfn cin dfrex2 bicomi 3imtr4g con4d exp32 com24
      exp32 imp45 imp31 $.
      $( [28-Jan-2010] $) $( [28-Jan-2010] $)

    $( Lemma for ~ alexsub . If any cover taken from a subbase has a finite
       subcover, any cover taken from the corresponding base has a finite
       subcover. $)
    alexsublem4 $p |- ( J = ( topGen ` ( fi ` x ) ) -> ( A. c e. ~P x ( X = U.
    c -> E. d e. ( ~P c i^i Fin ) X = U. d ) -> A. a e. ~P ( fi ` x ) ( X = U.
    a -> E. b e. ( ~P a i^i Fin ) X = U. b ) ) ) $=
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral cX va cv cuni wceq cX vb cv cuni
      wceq vb va cv cpw cfn cin wrex wi va vx cv cfi cfv cpw cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel cX va cv cuni wceq
      cX vb cv cuni wceq vb va cv cpw cfn cin wrex wi cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq vb
      va cv cpw cfn cin wrex cX va cv cuni wceq cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va
      cv cpw cfn cin wral cX va cv cuni wceq wn cX vb cv cuni wceq vb va cv cpw
      cfn cin wrex wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral cX va cv
      cuni wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vu cv
      vv cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral vu va cv vz cv wss
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw
      crab c0 csn cun wrex cX va cv cuni wceq wn vx vz vv vu cJ cX va vb vc vd
      alexsub.1 alexsublem2 cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral
      wa vu cv vv cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral cX va cv
      cuni wceq wn vu va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn
      vb va cv cpw cfn cin wral wa vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv c0 wceq wo vu
      cv vv cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral cX va cv cuni
      wceq wn wi vu cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wcel cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni
      wceq wn vb va cv cpw cfn cin wral wa vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv vv
      cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral cX va cv cuni wceq wn
      wi vu cv c0 wceq cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv vv cv wpss wn vv va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wral cX va cv cuni wceq wn wi wi cX vb cv
      cuni wceq wn vb va cv cpw cfn cin wral cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv
      vv cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral cX va cv cuni wceq
      wn wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq
      wn vb vu cv cpw cfn cin wral wa wa wa vu cv vv cv wpss wn vv va cv vz cv
      wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv
      cpw crab c0 csn cun wral vu cv cuni vx cv vu cv cin cuni wceq cX va cv
      cuni wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vu cv cuni vx cv vu cv
      cin cuni wceq vu cv vv cv wpss wn vv va cv vz cv wss cX vb cv cuni wceq
      wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu
      cv cpw cfn cin wral wa wa wa vu cv cuni vx cv vu cv cin cuni wceq wn vu
      cv vv cv wpss vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn
      cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wrex vu cv vv cv wpss wn
      vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw crab c0 csn cun wral wn cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa
      vy cv vx cv vu cv cin cuni wcel wn vy vu cv cuni wrex vu cv vv cv wpss vv
      va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx
      cv cfi cfv cpw crab c0 csn cun wrex vu cv cuni vx cv vu cv cin cuni wceq
      wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd
      vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel
      w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb
      vu cv cpw cfn cin wral wa wa wa vy cv vx cv vu cv cin cuni wcel wn vu cv
      vv cv wpss vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wrex vy vu cv cuni cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv
      vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa wa vy cv vw cv wcel vw vu cv wrex vy cv vx cv vu cv
      cin cuni wcel wn vu cv vv cv wpss vv va cv vz cv wss cX vb cv cuni wceq
      wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wrex
      wi vy cv vu cv cuni wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vy cv vw cv wcel
      vy cv vx cv vu cv cin cuni wcel wn vu cv vv cv wpss vv va cv vz cv wss cX
      vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab
      c0 csn cun wrex wi vw vu cv cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni
      wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va
      cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv
      wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv
      wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vt wex vy
      cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn vu cv vv cv wpss vv va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wrex wi wi cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw
      cv vu cv wcel vw cv vx cv cfi cfv wcel vt cv vx cv wss vt cv cfn wcel vw
      cv vt cv cint wceq w3a vt wex vu cv vx cv cfi cfv cpw wcel vw cv vu cv
      wcel vw cv vx cv cfi cfv wcel wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a va cv vu cv wss cX vb cv cuni wceq
      wn vb vu cv cpw cfn cin wral wa vu cv vx cv cfi cfv cpw wcel vu cv vx cv
      cfi cfv vw cv vu cv vx cv cfi cfv elpwi sseld ad2antrl vw cv cvv wcel vx
      cv cvv wcel vw cv vx cv cfi cfv wcel vt cv vx cv wss vt cv cfn wcel vw cv
      vt cv cint wceq w3a vt wex wb vw visset vx visset vt vw cv cvv vx cv cvv
      sppfi mp2an syl6ib cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vt wex vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn vu cv vv cv wpss vv va cv vz cv
      wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv
      cpw crab c0 csn cun wrex wi wi wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv
      vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy
      cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn vu cv vv cv wpss vv va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wrex wi wi vt cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa
      vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn vu cv vv cv wpss
      vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw crab c0 csn cun wrex cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw
      cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa cX vn cv
      cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vs vt cv wrex vu cv
      vv cv wpss vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wrex vx vy vw vu vt vn cJ cX
      vs va vb vc vd alexsub.1 alexsublem3 cJ vx cv cfi cfv ctg cfv wceq cX vc
      cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv
      vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy
      cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa cX vn cv cuni
      wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vu cv vv cv wpss vv va cv
      vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wrex vs vt cv cJ vx cv cfi cfv ctg cfv wceq cX vc
      cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv
      vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy
      cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv
      wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vu cv
      vv cv wpss vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wrex vu cv vs cv csn cun va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wcel vu cv vu cv vs cv csn cun wpss vu cv vv
      cv wpss vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wrex cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn
      cin wral wa wa vu cv vv cv wpss vu cv vu cv vs cv csn cun wpss vv vu cv
      vs cv csn cun va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun vv cv vu cv vs cv csn cun vu
      cv psseq2 rcla4ev cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt
      cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy
      cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni
      wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vu cv vs cv csn cun
      va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx
      cv cfi cfv cpw crab wcel vu cv vs cv csn cun va cv vz cv wss cX vb cv
      cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0
      csn cun wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv
      vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq
      wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vu cv vs cv csn cun vx
      cv cfi cfv cpw wcel va cv vu cv vs cv csn cun wss cX vb cv cuni wceq wn
      vb vu cv vs cv csn cun cpw cfn cin wral wa wa vu cv vs cv csn cun va cv
      vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt
      cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy
      cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni
      wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vu cv vs cv csn cun
      vx cv cfi cfv cpw wcel va cv vu cv vs cv csn cun wss cX vb cv cuni wceq
      wn vb vu cv vs cv csn cun cpw cfn cin wral cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa
      vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt
      cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa
      wa vu cv vs cv csn cun vx cv cfi cfv wss vu cv vs cv csn cun vx cv cfi
      cfv cpw wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv
      vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq
      wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vu cv vx cv cfi cfv wss
      vs cv csn vx cv cfi cfv wss wa vu cv vs cv csn cun vx cv cfi cfv wss cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv
      cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn
      wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin
      cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs
      cv csn cun cpw cfn cin wral wa wa vu cv vx cv cfi cfv wss vs cv csn vx cv
      cfi cfv wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vu cv
      vx cv cfi cfv wss vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa vs cv vt cv
      wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa vu
      cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv
      cpw cfn cin wral wa wa vu cv vx cv cfi cfv wss cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vw cv vu cv wcel vu cv
      vx cv cfi cfv cpw wcel vu cv vx cv cfi cfv wss va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa vu cv vx cv cfi cfv elpwi
      adantr ad2antlr ad2antrr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel
      wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv
      wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn
      cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vs cv vx cv
      cfi cfv wcel vs cv csn vx cv cfi cfv wss cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw
      cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv
      wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa
      vx cv vx cv cfi cfv vs cv vx cv vx cv cfi cfv wss cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn
      cin wral wa wa vx cv cvv wcel vx cv vx cv cfi cfv wss vx visset vx cv cvv
      abfi2 ax-mp a1i cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv
      vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq
      wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vt cv vx cv vs cv vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv
      vx cv vu cv cin cuni wcel wn wa wa vt cv vx cv wss cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa wa vw cv vu cv wcel wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu
      cv vs cv csn cun cpw cfn cin wral wa vt cv vx cv wss vt cv cfn wcel vw cv
      vt cv cint wceq vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa
      3simpl1 ad2antlr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt
      cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy
      cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni
      wceq wn vn vu cv vs cv csn cun cpw cfn cin wral simprl sseldd sseldd vs
      cv vx cv cfi cfv snssi syl jca vu cv vs cv csn vx cv cfi cfv unss sylib
      vu cv vs cv csn cun vx cv cfi cfv vx cv cfi fvex elpw2 sylibr cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv
      vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel
      vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni
      wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv
      csn cun cpw cfn cin wral wa wa va cv vu cv vu cv vs cv csn cun cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv
      vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa wa vw cv vu cv wcel wa va cv vu cv wss vt cv vx cv wss
      vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu
      cv cin cuni wcel wn wa wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv
      vs cv csn cun cpw cfn cin wral wa vu cv vx cv cfi cfv cpw wcel va cv vu
      cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa va cv vu cv
      wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vw cv vu cv wcel vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX
      vb cv cuni wceq wn vb vu cv cpw cfn cin wral simprl ad2antlr ad2antrr vu
      cv vu cv vs cv csn cun wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni
      wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va
      cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv
      wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv
      wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw
      cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX
      vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vu cv vs
      cv csn ssun1 a1i sstrd cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw
      cfn cin wral cX vb cv cuni wceq wn vb vu cv vs cv csn cun cpw cfn cin
      wral cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq
      wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss
      vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu
      cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu
      cv vs cv csn cun cpw cfn cin wral cX vb cv cuni wceq wn vb vu cv vs cv
      csn cun cpw cfn cin wral cX vn cv cuni wceq wn cX vb cv cuni wceq wn vn
      vb vu cv vs cv csn cun cpw cfn cin vn cv vb cv wceq cX vn cv cuni wceq cX
      vb cv cuni wceq vn cv vb cv wceq vn cv cuni vb cv cuni cX vn cv vb cv
      unieq eqeq2d notbid cbvralv biimpi ad2antll jca32 va cv vz cv wss cX vb
      cv cuni wceq wn vb vz cv cpw cfn cin wral wa va cv vu cv vs cv csn cun
      wss cX vb cv cuni wceq wn vb vu cv vs cv csn cun cpw cfn cin wral wa vz
      vu cv vs cv csn cun vx cv cfi cfv cpw vz cv vu cv vs cv csn cun wceq va
      cv vz cv wss va cv vu cv vs cv csn cun wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral cX vb cv cuni wceq wn vb vu cv vs cv csn cun cpw cfn cin
      wral vz cv vu cv vs cv csn cun va cv sseq2 vz cv vu cv vs cv csn cun wceq
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin vu cv vs cv csn cun cpw cfn
      cin vz cv vu cv vs cv csn cun wceq vz cv cpw vu cv vs cv csn cun cpw cfn
      vz cv vu cv vs cv csn cun pweq ineq1d raleq1d anbi12d elrab sylibr vu cv
      vs cv csn cun va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn elun1 syl cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa
      wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn
      cin wral wa wa vu cv vu cv vs cv csn cun wss vu cv vu cv vs cv csn cun
      wne wa vu cv vu cv vs cv csn cun wpss cJ vx cv cfi cfv ctg cfv wceq cX vc
      cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv
      vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy
      cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv
      wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa
      vu cv vu cv vs cv csn cun wne vu cv vu cv vs cv csn cun wss cJ vx cv cfi
      cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn
      cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx
      cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel
      vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx cv vu cv cin cuni
      wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv
      csn cun cpw cfn cin wral wa wa vu cv vs cv csn cun vu cv wss wn vu cv vu
      cv vs cv csn cun wne cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX
      vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa
      vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel
      vy cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv
      cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vv cv vu cv vs
      cv csn cun wcel vv cv vu cv wcel wn wa vv wex vu cv vs cv csn cun vu cv
      wss wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni
      wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx
      cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx
      cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni wceq wn
      vn vu cv vs cv csn cun cpw cfn cin wral wa wa vs cv vu cv vs cv csn cun
      wcel vs cv vu cv wcel wn wa vv cv vu cv vs cv csn cun wcel vv cv vu cv
      wcel wn wa vv wex cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt
      cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy
      cv vx cv vu cv cin cuni wcel wn wa wa wa vs cv vt cv wcel cX vn cv cuni
      wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa vs cv vu cv wcel wn
      vs cv vu cv vs cv csn cun wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv
      vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv
      vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy
      cv vw cv wcel vy cv vx cv vu cv cin cuni wcel wn vs cv vt cv wcel cX vn
      cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa vs cv vu cv
      wcel wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni
      wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx
      cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel vy cv vx
      cv vu cv cin cuni wcel wn vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv
      vs cv csn cun cpw cfn cin wral wa vs cv vu cv wcel wn wi wi cJ vx cv cfi
      cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn
      cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx
      cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel
      vw cv vt cv cint wceq w3a vy cv vw cv wcel wa wa vs cv vt cv wcel cX vn
      cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa vy cv vx cv vu
      cv cin cuni wcel wn vs cv vu cv wcel wn cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw
      cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a
      vy cv vw cv wcel wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv
      csn cun cpw cfn cin wral wa vy cv vx cv vu cv cin cuni wcel wn vs cv vu
      cv wcel wn wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel wa vs
      cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin
      wral wa wa wa vs cv vu cv wcel vy cv vx cv vu cv cin cuni wcel vy cv vs
      cv wcel vs cv vx cv wcel vs cv vu cv wcel vy cv vx cv vu cv cin cuni wcel
      wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd
      vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel
      w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb
      vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv
      cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel wa vs cv vt cv wcel
      cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa wa vy
      cv vs cv wcel vs cv vx cv wcel vs cv vu cv wcel vy cv vx cv vu cv cin
      cuni wcel vy cv vs cv wcel vs cv vx cv vu cv cin wcel vy cv vx cv vu cv
      cin cuni wcel vs cv vx cv wcel vs cv vu cv wcel wa vy cv vs cv wcel vs cv
      vx cv vu cv cin wcel vy cv vx cv vu cv cin cuni wcel vy cv vs cv vx cv vu
      cv cin elunii ex vs cv vx cv vu cv elin syl5ibr exp3a cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv
      cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn
      cin wral wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw
      cv vt cv cint wceq w3a vy cv vw cv wcel wa vs cv vt cv wcel cX vn cv cuni
      wceq wn vn vu cv vs cv csn cun cpw cfn cin wral wa wa wa vw cv vs cv vy
      cv vw cv vu cv wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel wa vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv
      vs cv csn cun cpw cfn cin wral wa wa vw cv vs cv wss cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa wa vw cv vu cv wcel vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint
      wceq w3a vy cv vw cv wcel wa vs cv vt cv wcel vw cv vs cv wss cX vn cv
      cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral vt cv vx cv wss vt
      cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel wa vs cv vt cv
      wcel wa vw cv vs cv wss vw cv vu cv wcel vt cv vx cv wss vt cv cfn wcel
      vw cv vt cv cint wceq w3a vs cv vt cv wcel vw cv vs cv wss vy cv vw cv
      wcel vw cv vt cv cint wceq vt cv vx cv wss vs cv vt cv wcel vw cv vs cv
      wss vt cv cfn wcel vs cv vt cv wcel vw cv vt cv cint wceq vw cv vs cv wss
      vw cv vt cv cint wceq vw cv vs cv wss vt cv cint vs cv wss vs cv vt cv
      wcel vw cv vt cv cint vs cv sseq1 vs cv vt cv intss1 syl5cbir impcom
      3ad2antl3 adantlr adantl adantrrr adantll cJ vx cv cfi cfv ctg cfv wceq
      cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx
      cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel
      va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa
      vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq
      w3a vy cv vw cv wcel vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs
      cv csn cun cpw cfn cin wral wa simprlr sseldd cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa wa vw cv vu cv wcel wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv
      cint wceq w3a vy cv vw cv wcel wa vs cv vt cv wcel cX vn cv cuni wceq wn
      vn vu cv vs cv csn cun cpw cfn cin wral wa wa wa vt cv vx cv vs cv vt cv
      vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel wa vt
      cv vx cv wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv
      cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vs cv
      vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin wral
      wa vt cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq vy cv vw cv wcel
      3simpl1 ad2antrl cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb
      cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa wa vw cv vu cv wcel wa vt
      cv vx cv wss vt cv cfn wcel vw cv vt cv cint wceq w3a vy cv vw cv wcel wa
      vs cv vt cv wcel cX vn cv cuni wceq wn vn vu cv vs cv csn cun cpw cfn cin
      wral simprrl sseldd sylc con3d expr com23 exp32 imp55 vs cv vs cv csn
      wcel vs cv vu cv vs cv csn cun wcel vs cv vs visset snid vs cv vs cv csn
      vu cv elun2 ax-mp jctil vv cv vu cv vs cv csn cun wcel vv cv vu cv wcel
      wn wa vs cv vu cv vs cv csn cun wcel vs cv vu cv wcel wn wa vv vs cv vs
      visset vv cv vs cv wceq vv cv vu cv vs cv csn cun wcel vs cv vu cv vs cv
      csn cun wcel vv cv vu cv wcel wn vs cv vu cv wcel wn vv cv vs cv vu cv vs
      cv csn cun eleq1 vv cv vs cv wceq vv cv vu cv wcel vs cv vu cv wcel vv vs
      vu elequ1 notbid anbi12d cla4ev syl vv vu cv vs cv csn cun vu cv nss
      sylibr vu cv vs cv csn cun vu cv wss vu cv vu cv vs cv csn cun vu cv vs
      cv csn cun vu cv eqimss2 necon3bi syl vu cv vs cv csn ssun1 jctil vu cv
      vu cv vs cv csn cun df-pss sylibr sylanc exp32 r19.23adv mpd exp45
      19.23adv ex mpdd r19.23adv vw vy cv vu cv eluni2 syl5ib r19.23adv vu cv
      cuni vx cv vu cv cin cuni wceq wn vu cv cuni vx cv vu cv cin cuni wss wn
      vy cv vx cv vu cv cin cuni wcel wn vy vu cv cuni wrex vu cv cuni vx cv vu
      cv cin cuni wceq wn vx cv vu cv cin cuni vu cv cuni wss vu cv cuni vx cv
      vu cv cin cuni wss wn wi vu cv cuni vx cv vu cv cin cuni wss wn vu cv
      cuni vx cv vu cv cin cuni wceq wn vu cv cuni vx cv vu cv cin cuni wss vx
      cv vu cv cin cuni vu cv cuni wss wa wn vu cv cuni vx cv vu cv cin cuni
      wss wn vx cv vu cv cin cuni vu cv cuni wss wn wo vx cv vu cv cin cuni vu
      cv cuni wss vu cv cuni vx cv vu cv cin cuni wss wn wi vu cv cuni vx cv vu
      cv cin cuni wceq vu cv cuni vx cv vu cv cin cuni wss vx cv vu cv cin cuni
      vu cv cuni wss wa vu cv cuni vx cv vu cv cin cuni eqss notbii vu cv cuni
      vx cv vu cv cin cuni wss vx cv vu cv cin cuni vu cv cuni wss ianor vx cv
      vu cv cin cuni vu cv cuni wss wn vu cv cuni vx cv vu cv cin cuni wss wn
      wo vx cv vu cv cin cuni vu cv cuni wss wn wn vu cv cuni vx cv vu cv cin
      cuni wss wn wi vu cv cuni vx cv vu cv cin cuni wss wn vx cv vu cv cin
      cuni vu cv cuni wss wn wo vx cv vu cv cin cuni vu cv cuni wss vu cv cuni
      vx cv vu cv cin cuni wss wn wi vx cv vu cv cin cuni vu cv cuni wss wn vu
      cv cuni vx cv vu cv cin cuni wss wn df-or vu cv cuni vx cv vu cv cin cuni
      wss wn vx cv vu cv cin cuni vu cv cuni wss wn orcom vx cv vu cv cin cuni
      vu cv cuni wss vx cv vu cv cin cuni vu cv cuni wss wn wn vu cv cuni vx cv
      vu cv cin cuni wss wn vx cv vu cv cin cuni vu cv cuni wss notnot imbi1i
      3bitr4i 3bitri vx cv vu cv cin cuni vu cv cuni wss vu cv cuni vx cv vu cv
      cin cuni wss wn wi vx cv vu cv cin cuni vu cv cuni wss vu cv cuni vx cv
      vu cv cin cuni wss wn vx cv vu cv cin vu cv wss vx cv vu cv cin cuni vu
      cv cuni wss vx cv vu cv inss2 vx cv vu cv cin vu cv uniss ax-mp vx cv vu
      cv cin cuni vu cv cuni wss vu cv cuni vx cv vu cv cin cuni wss wn wi id
      mpi sylbi vu cv cuni vx cv vu cv cin cuni wss wn vy cv vu cv cuni wcel vy
      cv vx cv vu cv cin cuni wcel wn wa vy wex vy cv vx cv vu cv cin cuni wcel
      wn vy vu cv cuni wrex vy vu cv cuni vx cv vu cv cin cuni nss vy cv vx cv
      vu cv cin cuni wcel wn vy vu cv cuni df-rex bitr4i sylib syl5 vu cv vv cv
      wpss vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral
      wa vz vx cv cfi cfv cpw crab c0 csn cun dfrex2 syl6ib con4d cJ vx cv cfi
      cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn
      cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx
      cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa vu cv cuni vx cv vu cv cin cuni wceq cX va cv cuni
      wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv
      cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni
      wceq wn vb vu cv cpw cfn cin wral wa wa vu cv cuni vx cv vu cv cin cuni
      wceq wa wa cX va cv cuni wceq cX vu cv cuni wss cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa vu cv cuni vx cv vu cv cin cuni wceq wa wa cX vu cv cuni wss cX vx
      cv vu cv cin cuni wceq cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa cX vx cv vu cv cin
      cuni wceq wn vu cv cuni vx cv vu cv cin cuni wceq cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa cX vx cv vu cv cin cuni wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel wa va
      cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral cX vx cv vu
      cv cin cuni wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a va cv vu cv wss cX vb cv cuni wceq wn vb vu cv
      cpw cfn cin wral cX vx cv vu cv cin cuni wceq wn wi wi vu cv vx cv cfi
      cfv cpw wcel cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral cJ vx cv cfi cfv ctg cfv wceq va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral cX vx cv vu cv cin cuni
      wceq wn wi wi va cv vx cv cfi cfv cpw wcel cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral cX vb cv cuni
      wceq wn vb vu cv cpw cfn cin wral cX vx cv vu cv cin cuni wceq wn wi va
      cv vu cv wss cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral cX vx cv vu cv cin cuni wceq cX vb cv cuni wceq
      wn vb vu cv cpw cfn cin wral cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral cX vx cv vu cv cin cuni wceq cX
      vb cv cuni wceq vb vu cv cpw cfn cin wrex cX vb cv cuni wceq wn vb vu cv
      cpw cfn cin wral wn cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral cX vx cv vu cv cin cuni wceq cX vd cv
      cuni wceq vd vu cv cpw cfn cin wrex cX vb cv cuni wceq vb vu cv cpw cfn
      cin wrex cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral cX vx cv vu cv cin cuni wceq cX vd cv cuni wceq vd
      vx cv vu cv cin cpw cfn cin wrex cX vd cv cuni wceq vd vu cv cpw cfn cin
      wrex cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral vx cv vu cv cin vx cv cpw wcel cX vx cv vu cv cin cuni
      wceq cX vd cv cuni wceq vd vx cv vu cv cin cpw cfn cin wrex wi vx cv vu
      cv cin vx cv cpw wcel vx cv vu cv cin vx cv wss vx cv vu cv inss1 vx cv
      vu cv cin vx cv vx visset elpw2 mpbir cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi cX vx cv vu cv cin cuni wceq cX vd cv
      cuni wceq vd vx cv vu cv cin cpw cfn cin wrex wi vc vx cv vu cv cin vx cv
      cpw vc cv vx cv vu cv cin wceq cX vc cv cuni wceq cX vx cv vu cv cin cuni
      wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex cX vd cv cuni wceq vd
      vx cv vu cv cin cpw cfn cin wrex vc cv vx cv vu cv cin wceq vc cv cuni vx
      cv vu cv cin cuni cX vc cv vx cv vu cv cin unieq eqeq2d vc cv vx cv vu cv
      cin wceq cX vd cv cuni wceq vd vc cv cpw cfn cin vx cv vu cv cin cpw cfn
      cin vc cv vx cv vu cv cin wceq vc cv cpw vx cv vu cv cin cpw cfn vc cv vx
      cv vu cv cin pweq ineq1d rexeq1d imbi12d rcla4cv mpi cX vd cv cuni wceq
      cX vd cv cuni wceq vd vx cv vu cv cin cpw cfn cin vu cv cpw cfn cin vd cv
      vx cv vu cv cin cpw cfn cin wcel vd cv vu cv cpw cfn cin wcel cX vd cv
      cuni wceq vd cv vx cv vu cv cin wss vd cv cfn wcel wa vd cv vu cv wss vd
      cv cfn wcel wa vd cv vx cv vu cv cin cpw cfn cin wcel vd cv vu cv cpw cfn
      cin wcel vd cv vx cv vu cv cin wss vd cv vu cv wss vd cv cfn wcel vd cv
      vx cv vu cv cin wss vx cv vu cv cin vu cv wss vd cv vu cv wss vx cv vu cv
      inss2 vd cv vx cv vu cv cin vu cv sstr mpan2 anim1i vd cv vx cv vu cv cin
      cpw cfn cin wcel vd cv vx cv vu cv cin cpw wcel vd cv cfn wcel wa vd cv
      vx cv vu cv cin wss vd cv cfn wcel wa vd cv vx cv vu cv cin cpw cfn elin
      vd cv vx cv vu cv cin cpw wcel vd cv vx cv vu cv cin wss vd cv cfn wcel
      vd cv vx cv vu cv cin vd visset elpw anbi1i bitri vd cv vu cv cpw cfn cin
      wcel vd cv vu cv cpw wcel vd cv cfn wcel wa vd cv vu cv wss vd cv cfn
      wcel wa vd cv vu cv cpw cfn elin vd cv vu cv cpw wcel vd cv vu cv wss vd
      cv cfn wcel vd cv vu cv vd visset elpw anbi1i bitri 3imtr4i anim1i
      r19.22i2 syl6 cX vd cv cuni wceq cX vb cv cuni wceq vd vb vu cv cpw cfn
      cin vd cv vb cv wceq vd cv cuni vb cv cuni cX vd cv vb cv unieq eqeq2d
      cbvrexv syl6ib cX vb cv cuni wceq vb vu cv cpw cfn cin dfrex2 syl6ib
      con2d a1d 3ad2ant2 adantr imp3a impr adantrr cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa vu cv cuni vx cv vu cv cin cuni wceq wa cX vu cv cuni wss cX vx cv
      vu cv cin cuni wceq cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX
      vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx
      cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX
      vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv cuni vx cv vu cv
      cin cuni wceq wa cX vu cv cuni wss wa wa cX vx cv vu cv cin cuni cJ vx cv
      cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv
      vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw
      cfn cin wral wa wa vu cv cuni vx cv vu cv cin cuni wceq wa cX vu cv cuni
      wss cX vx cv vu cv cin cuni wss vu cv cuni vx cv vu cv cin cuni wceq cX
      vu cv cuni wss cX vx cv vu cv cin cuni wss wi cJ vx cv cfi cfv ctg cfv
      wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv
      cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral
      wa wa vu cv cuni vx cv vu cv cin cuni wceq cX vu cv cuni wss cX vx cv vu
      cv cin cuni wss vu cv cuni vx cv vu cv cin cuni cX sseq2 biimpd ad2antll
      impr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq
      wn vb vu cv cpw cfn cin wral wa wa vu cv cuni vx cv vu cv cin cuni wceq
      wa cX vu cv cuni wss wa wa vx cv vu cv cin cuni vx cv cuni cX vx cv vu cv
      cin cuni vx cv cuni wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv wss
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv cuni vx cv vu
      cv cin cuni wceq wa cX vu cv cuni wss wa wa vx cv vu cv cin vx cv wss vx
      cv vu cv cin cuni vx cv cuni wss vx cv vu cv inss1 vx cv vu cv cin vx cv
      uniss ax-mp a1i cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a vx cv cuni cX wceq vu cv vx cv cfi cfv cpw wcel va cv vu
      cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv cuni
      vx cv vu cv cin cuni wceq wa cX vu cv cuni wss wa cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral vx cv cuni cX wceq va cv vx cv cfi cfv cpw wcel cJ
      vx cv cfi cfv ctg cfv wceq vx cv cuni cJ cuni cX cJ vx cv cfi cfv ctg cfv
      wceq cJ cuni vx cv cfi cfv ctg cfv cuni vx cv cuni cJ vx cv cfi cfv ctg
      cfv unieq vx cv cuni vx cv cfi cfv cuni vx cv cfi cfv ctg cfv cuni vx cv
      cvv wcel vx cv cuni vx cv cfi cfv cuni wceq vx visset vx cv cvv fiuni
      ax-mp vx cv cfi cfv ctb wcel vx cv cfi cfv ctg cfv cuni vx cv cfi cfv
      cuni wceq vx cv cvv wcel vx cv cfi cfv ctb wcel vx visset vx cv cvv fibas
      ax-mp vx cv cfi cfv unitg ax-mp eqtr4i syl6reqr alexsub.1 syl6eqr
      3ad2ant1 adantr sseqtrd eqssd expr mtod cX va cv cuni wceq cX vu cv cuni
      wss va cv cuni vu cv cuni wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni
      wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va
      cv vx cv cfi cfv cpw wcel w3a vu cv vx cv cfi cfv cpw wcel va cv vu cv
      wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa wa vu cv cuni vx
      cv vu cv cin cuni wceq wa wa cX va cv cuni vu cv cuni sseq1 vu cv vx cv
      cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn
      cin wral wa wa va cv cuni vu cv cuni wss cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a vu cv cuni vx cv vu cv cin cuni
      wceq va cv vu cv wss va cv cuni vu cv cuni wss vu cv vx cv cfi cfv cpw
      wcel cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral va cv vu cv uniss
      ad2antrl ad2antrl syl5cbir mtod expr syld ex adantr cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq
      wn vb va cv cpw cfn cin wral wa vu cv c0 wceq vu cv vv cv wpss wn vv va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wral cX va cv cuni wceq wn wi cJ vx cv cfi
      cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn
      cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv
      cuni wceq wn vb va cv cpw cfn cin wral wa vu cv c0 wceq wa vu cv vv cv
      wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral vu cv va cv wpss wn cX
      va cv cuni wceq wn cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd
      cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv
      cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa
      vu cv c0 wceq wa va cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn cun wcel vu cv vv cv
      wpss wn vv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun wral vu cv va cv wpss wn wi
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vu cv c0 wceq wa va cv
      vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin
      wral wa vz vx cv cfi cfv cpw crab c0 csn cun va cv va cv vz cv wss cX vb
      cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab va
      cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv
      cfi cfv cpw crab c0 csn cun wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw
      cfn cin wral wa vu cv c0 wceq wa va cv vz cv wss cX vb cv cuni wceq wn vb
      vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab c0 csn ssun1 a1i cJ
      vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX
      vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vu cv c0 wceq wa va cv vx
      cv cfi cfv cpw wcel va cv va cv wss cX vb cv cuni wceq wn vb va cv cpw
      cfn cin wral wa wa va cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv
      cpw cfn cin wral wa vz vx cv cfi cfv cpw crab wcel cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq
      wn vb va cv cpw cfn cin wral wa vu cv c0 wceq wa va cv vx cv cfi cfv cpw
      wcel va cv va cv wss cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa
      cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a
      cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa va cv vx cv cfi cfv
      cpw wcel vu cv c0 wceq cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv
      vx cv cfi cfv cpw wcel cX vb cv cuni wceq wn vb va cv cpw cfn cin wral
      3simpl3 adantr cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral wa vu cv
      c0 wceq wa cX vb cv cuni wceq wn vb va cv cpw cfn cin wral va cv va cv
      wss cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq
      vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw
      wcel w3a cX vb cv cuni wceq wn vb va cv cpw cfn cin wral vu cv c0 wceq
      simplr va cv ssid jctil jca va cv vz cv wss cX vb cv cuni wceq wn vb vz
      cv cpw cfn cin wral wa va cv va cv wss cX vb cv cuni wceq wn vb va cv cpw
      cfn cin wral wa vz va cv vx cv cfi cfv cpw vz cv va cv wceq va cv vz cv
      wss va cv va cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral cX vb
      cv cuni wceq wn vb va cv cpw cfn cin wral vz cv va cv va cv sseq2 vz cv
      va cv wceq cX vb cv cuni wceq wn vb vz cv cpw cfn cin va cv cpw cfn cin
      vz cv va cv wceq vz cv cpw va cv cpw cfn vz cv va cv pweq ineq1d raleq1d
      anbi12d elrab sylibr sseldd vu cv vv cv wpss wn vu cv va cv wpss wn vv va
      cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz
      vx cv cfi cfv cpw crab c0 csn cun vv cv va cv wceq vu cv vv cv wpss vu cv
      va cv wpss vv cv va cv vu cv psseq2 notbid rcla4v syl cJ vx cv cfi cfv
      ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin
      wrex wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni
      wceq wn vb va cv cpw cfn cin wral wa vu cv c0 wceq vu cv va cv wpss wn cX
      va cv cuni wceq wn wi vu cv c0 wceq vu cv va cv wpss wn cX va cv cuni
      wceq wn wi c0 va cv wpss wn cX va cv cuni wceq wn wi cJ vx cv cfi cfv ctg
      cfv wceq cX vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc vx cv cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq
      wn vb va cv cpw cfn cin wral wa vu cv c0 wceq vu cv va cv wpss wn c0 va
      cv wpss wn cX va cv cuni wceq wn vu cv c0 wceq vu cv va cv wpss c0 va cv
      wpss vu cv c0 va cv psseq1 notbid imbi1d cJ vx cv cfi cfv ctg cfv wceq cX
      vc cv cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv
      cpw wral va cv vx cv cfi cfv cpw wcel w3a cX vb cv cuni wceq wn vb va cv
      cpw cfn cin wral wa va cv c0 wceq cX va cv cuni wceq wn c0 va cv wpss wn
      cX vb cv cuni wceq wn vb va cv cpw cfn cin wral va cv c0 wceq cX va cv
      cuni wceq wn wi cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral va cv vx cv cfi
      cfv cpw wcel w3a va cv c0 wceq cX va cv cuni wceq wn cX c0 cuni wceq wn
      cX vb cv cuni wceq wn vb va cv cpw cfn cin wral va cv c0 wceq cX va cv
      cuni wceq cX c0 cuni wceq va cv c0 wceq va cv cuni c0 cuni cX va cv c0
      unieq eqeq2d notbid cX vb cv cuni wceq wn vb va cv cpw cfn cin wral c0 va
      cv cpw cfn cin wcel cX c0 cuni wceq wn c0 va cv cpw cfn cin wcel c0 va cv
      cpw wcel c0 cfn wcel c0 va cv cpw cfn elin va cv 0elpw emfin mpbir2an cX
      vb cv cuni wceq wn cX c0 cuni wceq wn vb c0 va cv cpw cfn cin vb cv c0
      wceq cX vb cv cuni wceq cX c0 cuni wceq vb cv c0 wceq vb cv cuni c0 cuni
      cX vb cv c0 unieq eqeq2d notbid rcla4cv mpi syl5cbir adantl c0 va cv wpss
      wn va cv c0 wne wn va cv c0 wceq c0 va cv wpss va cv c0 wne va cv 0pss
      notbii va cv c0 nne bitri syl5ib syl5cbir imp syld ex jaod vu cv va cv vz
      cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi
      cfv cpw crab c0 csn cun wcel vu cv va cv vz cv wss cX vb cv cuni wceq wn
      vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw crab wcel vu cv c0 csn
      wcel wo vu cv vx cv cfi cfv cpw wcel va cv vu cv wss cX vb cv cuni wceq
      wn vb vu cv cpw cfn cin wral wa wa vu cv c0 wceq wo vu cv va cv vz cv wss
      cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral wa vz vx cv cfi cfv cpw
      crab c0 csn elun vu cv va cv vz cv wss cX vb cv cuni wceq wn vb vz cv cpw
      cfn cin wral wa vz vx cv cfi cfv cpw crab wcel vu cv vx cv cfi cfv cpw
      wcel va cv vu cv wss cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral wa
      wa vu cv c0 csn wcel vu cv c0 wceq va cv vz cv wss cX vb cv cuni wceq wn
      vb vz cv cpw cfn cin wral wa va cv vu cv wss cX vb cv cuni wceq wn vb vu
      cv cpw cfn cin wral wa vz vu cv vx cv cfi cfv cpw vz cv vu cv wceq va cv
      vz cv wss va cv vu cv wss cX vb cv cuni wceq wn vb vz cv cpw cfn cin wral
      cX vb cv cuni wceq wn vb vu cv cpw cfn cin wral vz cv vu cv va cv sseq2
      vz cv vu cv wceq cX vb cv cuni wceq wn vb vz cv cpw cfn cin vu cv cpw cfn
      cin vz cv vu cv wceq vz cv cpw vu cv cpw cfn vz cv vu cv pweq ineq1d
      raleq1d anbi12d elrab vu c0 elsn orbi12i bitri syl5ib r19.23adv mpd ex cX
      vb cv cuni wceq vb va cv cpw cfn cin ralnex syl5ibr con4d 3exp r19.21adv
      $.
      $( [28-Jan-2010] $) $( [28-Jan-2010] $)

    $( The Alexander Subbase Theorem: a space is compact iff it has a subbase
       such that any cover taken from the subbase has a finite subcover. $)
    alexsub $p |- ( J e. Comp <-> E. x ( J = ( topGen ` ( fi ` x ) ) /\ A. c e.
    ~P x ( X = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) ) ) $=
      cJ ccomp wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv
      cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral wa vx wex vx cJ
      cX vc vd alexsub.1 alexsublem1 cJ vx cv cfi cfv ctg cfv wceq cX vc cv
      cuni wceq cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw
      wral wa cJ ccomp wcel vx cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq
      cX vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral cJ
      ccomp wcel cJ vx cv cfi cfv ctg cfv wceq cX vc cv cuni wceq cX vd cv cuni
      wceq vd vc cv cpw cfn cin wrex wi vc vx cv cpw wral cX va cv cuni wceq cX
      vb cv cuni wceq vb va cv cpw cfn cin wrex wi va vx cv cfi cfv cpw wral cJ
      ccomp wcel vx cJ cX va vb vc vd alexsub.1 alexsublem4 cJ vx cv cfi cfv
      ctg cfv wceq cX va cv cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin
      wrex wi va vx cv cfi cfv cpw wral cJ ctop wcel cJ cuni vc cv cuni wceq cJ
      cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc cJ cpw wral wa cJ
      ccomp wcel cJ vx cv cfi cfv ctg cfv wceq cX va cv cuni wceq cX vb cv cuni
      wceq vb va cv cpw cfn cin wrex wi va vx cv cfi cfv cpw wral cJ cuni vc cv
      cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vc cJ cpw
      wral cJ ctop wcel cJ vx cv cfi cfv ctg cfv wceq cX va cv cuni wceq cX vb
      cv cuni wceq vb va cv cpw cfn cin wrex wi va vx cv cfi cfv cpw wral cJ
      cuni vc cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      vc cJ cpw cJ vx cv cfi cfv ctg cfv wceq cX va cv cuni wceq cX vb cv cuni
      wceq vb va cv cpw cfn cin wrex wi va vx cv cfi cfv cpw wral vc cv cJ wss
      cJ cuni vc cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex
      wi vc cv cJ cpw wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cX va cv
      cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin wrex wi va vx cv cfi
      cfv cpw wral cJ cuni vc cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv
      cuni wceq cX va cv cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin wrex
      wi va vx cv cfi cfv cpw wral cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin
      wrex cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq
      cX va cv cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin wrex wi va vx
      cv cfi cfv cpw wral cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi
      cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a cX
      va cv cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin wrex wi va vx cv
      cfi cfv cpw wral cX vb cv cuni wceq vb vy cv vz cv wss vz vc cv wrex vy
      vx cv cfi cfv crab cpw cfn cin wrex cJ cuni vd cv cuni wceq vd vc cv cpw
      cfn cin wrex cX va cv cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin
      wrex wi va vx cv cfi cfv cpw wral cX vy cv vz cv wss vz vc cv wrex vy vx
      cv cfi cfv crab cuni wceq cX vb cv cuni wceq vb vy cv vz cv wss vz vc cv
      wrex vy vx cv cfi cfv crab cpw cfn cin wrex cJ vx cv cfi cfv ctg cfv wceq
      vc cv cJ wss cJ cuni vc cv cuni wceq w3a vy cv vz cv wss vz vc cv wrex vy
      vx cv cfi cfv crab vx cv cfi cfv cpw wcel cX va cv cuni wceq cX vb cv
      cuni wceq vb va cv cpw cfn cin wrex wi va vx cv cfi cfv cpw wral cX vy cv
      vz cv wss vz vc cv wrex vy vx cv cfi cfv crab cuni wceq cX vb cv cuni
      wceq vb vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab cpw cfn cin
      wrex wi wi vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab vx cv cfi
      cfv cpw wcel vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab vx cv
      cfi cfv wss vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv ssrab2 vy cv
      vz cv wss vz vc cv wrex vy vx cv cfi cfv crab vx cv cfi cfv vx cv cfi
      fvex elpw2 mpbir cX va cv cuni wceq cX vb cv cuni wceq vb va cv cpw cfn
      cin wrex wi cX vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab cuni
      wceq cX vb cv cuni wceq vb vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv
      crab cpw cfn cin wrex wi va vy cv vz cv wss vz vc cv wrex vy vx cv cfi
      cfv crab vx cv cfi cfv cpw va cv vy cv vz cv wss vz vc cv wrex vy vx cv
      cfi cfv crab wceq cX va cv cuni wceq cX vy cv vz cv wss vz vc cv wrex vy
      vx cv cfi cfv crab cuni wceq cX vb cv cuni wceq vb va cv cpw cfn cin wrex
      cX vb cv cuni wceq vb vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab
      cpw cfn cin wrex va cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv
      crab wceq va cv cuni vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab
      cuni cX va cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab unieq
      eqeq2d va cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab wceq cX
      vb cv cuni wceq vb va cv cpw cfn cin vy cv vz cv wss vz vc cv wrex vy vx
      cv cfi cfv crab cpw cfn cin va cv vy cv vz cv wss vz vc cv wrex vy vx cv
      cfi cfv crab wceq va cv cpw vy cv vz cv wss vz vc cv wrex vy vx cv cfi
      cfv crab cpw cfn va cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv
      crab pweq ineq1d rexeq1d imbi12d rcla4v ax-mp cJ vx cv cfi cfv ctg cfv
      wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vt cX vy cv vz cv wss vz vc
      cv wrex vy vx cv cfi cfv crab cuni cJ vx cv cfi cfv ctg cfv wceq vc cv cJ
      wss cJ cuni vc cv cuni wceq w3a vt cv cX wcel vt cv vy cv wcel vy cv vz
      cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex vt cv vy cv vz cv wss vz vc
      cv wrex vy vx cv cfi cfv crab cuni wcel cJ vx cv cfi cfv ctg cfv wceq vc
      cv cJ wss cJ cuni vc cv cuni wceq w3a vt cv cX wcel vt cv vy cv wcel vy
      cv vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex cJ vx cv cfi cfv ctg
      cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vt cv cJ cuni wcel vt
      cv vy cv wcel vy cv vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex vt
      cv cX wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni
      wceq w3a vt cv cJ cuni wcel vt cv vc cv cuni wcel vt cv vy cv wcel vy cv
      vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex cJ cuni vc cv cuni wceq
      cJ vx cv cfi cfv ctg cfv wceq vt cv cJ cuni wcel vt cv vc cv cuni wcel wb
      vc cv cJ wss cJ cuni vc cv cuni vt cv eleq2 3ad2ant3 cJ vx cv cfi cfv ctg
      cfv wceq vc cv cJ wss vt cv vc cv cuni wcel vt cv vy cv wcel vy cv vz cv
      wss vz vc cv wrex wa vy vx cv cfi cfv wrex wi cJ cuni vc cv cuni wceq cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss wa vt cv vw cv wcel vw cv vc cv
      wcel wa vw wex vt cv vy cv wcel vy cv vz cv wss vz vc cv wrex wa vy vx cv
      cfi cfv wrex vt cv vc cv cuni wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ
      wss wa vt cv vw cv wcel vw cv vc cv wcel wa vt cv vy cv wcel vy cv vz cv
      wss vz vc cv wrex wa vy vx cv cfi cfv wrex vw cJ vx cv cfi cfv ctg cfv
      wceq vc cv cJ wss wa vt cv vw cv wcel vw cv vc cv wcel vt cv vy cv wcel
      vy cv vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex cJ vx cv cfi cfv
      ctg cfv wceq vc cv cJ wss wa vw cv vc cv wcel vt cv vw cv wcel vt cv vy
      cv wcel vy cv vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex cJ vx cv
      cfi cfv ctg cfv wceq vc cv cJ wss vw cv vc cv wcel vt cv vw cv wcel vt cv
      vy cv wcel vy cv vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex wi cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss vw cv vc cv wcel w3a vt cv vw cv
      wcel vt cv vy cv wcel vy cv vw cv wss wa vy vx cv cfi cfv wrex vt cv vy
      cv wcel vy cv vz cv wss vz vc cv wrex wa vy vx cv cfi cfv wrex cJ vx cv
      cfi cfv ctg cfv wceq vc cv cJ wss vw cv vc cv wcel vt cv vw cv wcel vt cv
      vy cv wcel vy cv vw cv wss wa vy vx cv cfi cfv wrex wi vc cv cJ wss vw cv
      vc cv wcel vw cv cJ wcel cJ vx cv cfi cfv ctg cfv wceq vt cv vw cv wcel
      vt cv vy cv wcel vy cv vw cv wss wa vy vx cv cfi cfv wrex wi vc cv cJ vw
      cv ssel cJ vx cv cfi cfv ctg cfv wceq vw cv cJ wcel vw cv vx cv cfi cfv
      ctg cfv wcel vt cv vw cv wcel vt cv vy cv wcel vy cv vw cv wss wa vy vx
      cv cfi cfv wrex wi cJ vx cv cfi cfv ctg cfv vw cv eleq2 vx cv cfi cfv ctb
      wcel vw cv vx cv cfi cfv ctg cfv wcel vt cv vw cv wcel vt cv vy cv wcel
      vy cv vw cv wss wa vy vx cv cfi cfv wrex wi vx cv cvv wcel vx cv cfi cfv
      ctb wcel vx visset vx cv cvv fibas ax-mp vx cv cfi cfv ctb wcel vw cv vx
      cv cfi cfv ctg cfv wcel vt cv vw cv wcel vt cv vy cv wcel vy cv vw cv wss
      wa vy vx cv cfi cfv wrex vy vw cv vx cv cfi cfv vt cv tg2 3expia mpan
      syl6bi sylan9r 3impia cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss vw cv vc
      cv wcel w3a vt cv vy cv wcel vy cv vw cv wss wa vt cv vy cv wcel vy cv vz
      cv wss vz vc cv wrex wa vy vx cv cfi cfv cJ vx cv cfi cfv ctg cfv wceq vc
      cv cJ wss vw cv vc cv wcel w3a vy cv vw cv wss vy cv vz cv wss vz vc cv
      wrex vt cv vy cv wcel vw cv vc cv wcel cJ vx cv cfi cfv ctg cfv wceq vy
      cv vw cv wss vy cv vz cv wss vz vc cv wrex wi vc cv cJ wss vw cv vc cv
      wcel vy cv vw cv wss vy cv vz cv wss vz vc cv wrex vy cv vz cv wss vy cv
      vw cv wss vz vw cv vc cv vz cv vw cv vy cv sseq2 rcla4ev ex 3ad2ant3
      anim2d r19.22sdv syld 3expia com23 imp3a 19.23adv vw vt cv vc cv eluni
      syl5ib 3adant3 sylbid cX cJ cuni vt cv alexsub.1 eleq2i syl5ib cJ vx cv
      cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vt cv vy cv
      wcel vy cv vz cv wss vz vc cv wrex wa vt cv cX wcel vy vx cv cfi cfv cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vt cv
      vy cv wcel vy cv vz cv wss vz vc cv wrex wa vt cv cX wcel wi vy cv vx cv
      cfi cfv wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv
      cuni wceq w3a vt cv vy cv wcel vy cv vz cv wss vz vc cv wrex vt cv cX
      wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq
      w3a vy cv vz cv wss vz vc cv wrex vt cv vy cv wcel vt cv cX wcel cJ vx cv
      cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vy cv vz cv
      wss vt cv vy cv wcel vt cv cX wcel wi vz vc cv cJ vx cv cfi cfv ctg cfv
      wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vz cv vc cv wcel vy cv vz
      cv wss vt cv vy cv wcel vt cv cX wcel wi wi vy cv vz cv wss vt cv vy cv
      wcel vt cv vz cv wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni
      vc cv cuni wceq w3a vz cv vc cv wcel wa vt cv cX wcel vy cv vz cv vt cv
      ssel vz cv vc cv wcel vt cv vz cv wcel vt cv vc cv cuni wcel cJ vx cv cfi
      cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vt cv cX wcel
      vt cv vz cv wcel vz cv vc cv wcel vt cv vc cv cuni wcel vt cv vz cv vc cv
      elunii expcom cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv
      cuni wceq w3a vt cv vc cv cuni wcel vt cv cX wcel cJ vx cv cfi cfv ctg
      cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vt cv cJ cuni wcel vt
      cv vc cv cuni wcel vt cv cX wcel cJ cuni vc cv cuni wceq cJ vx cv cfi cfv
      ctg cfv wceq vt cv cJ cuni wcel vt cv vc cv cuni wcel wb vc cv cJ wss cJ
      cuni vc cv cuni vt cv eleq2 3ad2ant3 cX cJ cuni vt cv alexsub.1 eleq2i
      syl5rbb biimpd sylan9r syl9r ex r19.23adv com23 imp3a a1d r19.23adv
      impbid vy cv vz cv wss vz vc cv wrex vy vt cv vx cv cfi cfv elunirab
      syl6bbr eqrdv syl5com cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni
      vc cv cuni wceq w3a cX vb cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv
      cpw cfn cin wrex vb vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab
      cpw cfn cin cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni
      wceq w3a vb cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab wss vb
      cv cfn wcel wa cX vb cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw
      cfn cin wrex wi vb cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab
      cpw cfn cin wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv
      cuni wceq w3a vb cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab
      wss vb cv cfn wcel cX vb cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc
      cv cuni wceq w3a vb cv cfn wcel vb cv vy cv vz cv wss vz vc cv wrex vy vx
      cv cfi cfv crab wss cX vb cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc
      cv cuni wceq w3a vb cv cfn wcel vb cv vy cv vz cv wss vz vc cv wrex vy vx
      cv cfi cfv crab wss cX vb cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv
      cpw cfn cin wrex wi wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni
      vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vy cv vz cv wss vz vc cv wrex
      vy vx cv cfi cfv crab wss vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss
      vt vb cv wral wa vf wex cX vb cv cuni wceq cJ cuni vd cv cuni wceq vd vc
      cv cpw cfn cin wrex wi vb cv cfn wcel vb cv vy cv vz cv wss vz vc cv wrex
      vy vx cv cfi cfv crab wss vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss
      vt vb cv wral wa vf wex wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ
      cuni vc cv cuni wceq w3a vb cv cfn wcel vt cv vz cv wss vz vc cv wrex vt
      vb cv wral vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral
      wa vf wex vb cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab wss
      vb cv cfn wcel vt cv vz cv wss vz vc cv wrex vt vb cv wral vb cv vc cv vf
      cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa vf wex vt cv vz cv wss
      vt cv vt cv vf cv cfv wss vt vz vb cv vc cv vf vz cv vt cv vf cv cfv vt
      cv sseq2 ac6sfi ex vb cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv
      crab wss vt cv vz cv wss vz vc cv wrex vt vb cv vb cv vy cv vz cv wss vz
      vc cv wrex vy vx cv cfi cfv crab wss vt cv vb cv wcel vt cv vy cv vz cv
      wss vz vc cv wrex vy vx cv cfi cfv crab wcel vt cv vz cv wss vz vc cv
      wrex vb cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab vt cv ssel
      vt cv vy cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab wcel vt cv vx
      cv cfi cfv wcel vt cv vz cv wss vz vc cv wrex vy cv vz cv wss vz vc cv
      wrex vt cv vz cv wss vz vc cv wrex vy vt cv vx cv cfi cfv vy cv vt cv
      wceq vy cv vz cv wss vt cv vz cv wss vz vc cv vy cv vt cv vz cv sseq1
      rexbidv elrab pm3.27bi syl6 r19.21aiv syl5 adantl cJ vx cv cfi cfv ctg
      cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa vb cv
      vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa cX vb cv cuni
      wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex wi vf cJ vx cv cfi
      cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel
      wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa cX vb
      cv cuni wceq cJ cuni vd cv cuni wceq vd vc cv cpw cfn cin wrex vf cv crn
      vc cv cpw cfn cin wcel cJ cuni vf cv crn cuni wceq cJ cuni vd cv cuni
      wceq vd vc cv cpw cfn cin wrex cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss
      cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv
      vt cv vf cv cfv wss vt vb cv wral wa cX vb cv cuni wceq wa wa cJ cuni vd
      cv cuni wceq cJ cuni vf cv crn cuni wceq vd vf cv crn vc cv cpw cfn cin
      vd cv vf cv crn wceq vd cv cuni vf cv crn cuni cJ cuni vd cv vf cv crn
      unieq eqeq2d rcla4ev cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni
      vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf
      cv cfv wss vt vb cv wral wa cX vb cv cuni wceq wa wa vf cv crn vc cv wss
      vf cv crn cfn wcel wa vf cv crn vc cv cpw cfn cin wcel cJ vx cv cfi cfv
      ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa
      vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa cX vb cv
      cuni wceq wa wa vf cv crn vc cv wss vf cv crn cfn wcel vb cv vc cv vf cv
      wf vt cv vt cv vf cv cfv wss vt vb cv wral wa vf cv crn vc cv wss cJ vx
      cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      cfn wcel wa cX vb cv cuni wceq vb cv vc cv vf cv wf vf cv crn vc cv wss
      vt cv vt cv vf cv cfv wss vt vb cv wral vb cv vc cv vf cv frn adantr
      ad2antrl vb cv cfn wcel vf cv crn vb cv cdom wbr vf cv crn cfn wcel cJ vx
      cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral
      wa cX vb cv cuni wceq wa wa vb cv vf cv crn domfi cJ vx cv cfi cfv ctg
      cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel vb cv vc
      cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa cX vb cv cuni wceq
      wa simplr vb cv cfn wcel vb cv vf cv crn vf cv wfo vf cv crn vb cv cdom
      wbr cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq
      w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt
      vb cv wral wa cX vb cv cuni wceq wa wa vb cv vf cv crn vf cv fodomfi cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      cfn wcel vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa
      cX vb cv cuni wceq wa simplr vb cv vc cv vf cv wf vt cv vt cv vf cv cfv
      wss vt vb cv wral wa vb cv vf cv crn vf cv wfo cJ vx cv cfi cfv ctg cfv
      wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa cX vb cv
      cuni wceq vb cv vc cv vf cv wf vb cv vf cv crn vf cv wfo vt cv vt cv vf
      cv cfv wss vt vb cv wral vb cv vc cv vf cv wf vf cv vb cv wfn vb cv vf cv
      crn vf cv wfo vb cv vc cv vf cv ffn vb cv vf cv dffn4 sylib adantr
      ad2antrl sylanc sylanc jca vf cv crn vc cv cpw cfn cin wcel vf cv crn vc
      cv cpw wcel vf cv crn cfn wcel wa vf cv crn vc cv wss vf cv crn cfn wcel
      wa vf cv crn vc cv cpw cfn elin vf cv crn vc cv cpw wcel vf cv crn vc cv
      wss vf cv crn cfn wcel vf cv crn vc cv vc visset elpw2 anbi1i bitr2i
      sylib cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq
      w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt
      vb cv wral wa cX vb cv cuni wceq wa wa vy cJ cuni vf cv crn cuni cJ vx cv
      cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn
      wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa
      cX vb cv cuni wceq wa wa vy cv cJ cuni wcel vy cv vf cv crn cuni wcel cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral
      wa cX vb cv cuni wceq wa wa vy cv cJ cuni wcel vy cv vb cv cuni wcel vy
      cv vf cv crn cuni wcel cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni
      vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf
      cv cfv wss vt vb cv wral wa cX vb cv cuni wceq wa wa vy cv cX wcel vy cv
      vb cv cuni wcel vy cv cJ cuni wcel cX vb cv cuni wceq vy cv cX wcel vy cv
      vb cv cuni wcel wb cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc
      cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv
      cfv wss vt vb cv wral wa cX vb cv cuni vy cv eleq2 ad2antll cX cJ cuni vy
      cv alexsub.1 eleq2i syl5bbr cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ
      cuni vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt
      cv vf cv cfv wss vt vb cv wral wa cX vb cv cuni wceq wa wa vy cv vw cv
      wcel vw vb cv wrex vy cv vf cv crn cuni wcel vy cv vb cv cuni wcel cJ vx
      cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral
      wa cX vb cv cuni wceq wa wa vy cv vw cv wcel vy cv vf cv crn cuni wcel vw
      vb cv cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq
      w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt
      vb cv wral cX vb cv cuni wceq vw cv vb cv wcel vy cv vw cv wcel vy cv vf
      cv crn cuni wcel wi wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni
      vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv vt cv vf
      cv cfv wss vt vb cv wral cX vb cv cuni wceq vw cv vb cv wcel vy cv vw cv
      wcel vy cv vf cv crn cuni wcel wi wi cJ vx cv cfi cfv ctg cfv wceq vc cv
      cJ wss cJ cuni vc cv cuni wceq w3a vb cv vc cv vf cv wf vt cv vt cv vf cv
      cfv wss vt vb cv wral vw cv vb cv wcel vy cv vw cv wcel vy cv vf cv crn
      cuni wcel wi wi wi wi vb cv cfn wcel cJ vx cv cfi cfv ctg cfv wceq vc cv
      cJ wss cJ cuni vc cv cuni wceq w3a vb cv vc cv vf cv wf vt cv vt cv vf cv
      cfv wss vt vb cv wral vw cv vb cv wcel vy cv vw cv wcel vy cv vf cv crn
      cuni wcel wi wi wi cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc
      cv cuni wceq w3a vb cv vc cv vf cv wf wa vw cv vb cv wcel vt cv vt cv vf
      cv cfv wss vt vb cv wral vy cv vw cv wcel vy cv vf cv crn cuni wcel wi cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      vc cv vf cv wf vw cv vb cv wcel vt cv vt cv vf cv cfv wss vt vb cv wral
      vy cv vw cv wcel vy cv vf cv crn cuni wcel wi wi cJ vx cv cfi cfv ctg cfv
      wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv vc cv vf cv wf vw cv
      vb cv wcel wa wa vt cv vt cv vf cv cfv wss vt vb cv wral vw cv vw cv vf
      cv cfv wss vy cv vw cv wcel vy cv vf cv crn cuni wcel wi vw cv vb cv wcel
      vt cv vt cv vf cv cfv wss vt vb cv wral vw cv vw cv vf cv cfv wss wi cJ
      vx cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      vc cv vf cv wf vt cv vt cv vf cv cfv wss vw cv vw cv vf cv cfv wss vt vw
      cv vb cv vt cv vw cv wceq vt cv vw cv vt cv vf cv cfv vw cv vf cv cfv vt
      cv vw cv wceq id vt cv vw cv vf cv fveq2 sseq12d rcla4v ad2antll vw cv vw
      cv vf cv cfv wss vy cv vw cv wcel vy cv vw cv vf cv cfv wcel cJ vx cv cfi
      cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv vc cv vf
      cv wf vw cv vb cv wcel wa wa vy cv vf cv crn cuni wcel vw cv vw cv vf cv
      cfv vy cv ssel vb cv vc cv vf cv wf vw cv vb cv wcel wa vy cv vw cv vf cv
      cfv wcel vy cv vf cv crn cuni wcel wi cJ vx cv cfi cfv ctg cfv wceq vc cv
      cJ wss cJ cuni vc cv cuni wceq w3a vy cv vw cv vf cv cfv wcel vb cv vc cv
      vf cv wf vw cv vb cv wcel wa vy cv vf cv crn cuni wcel vy cv vw cv vf cv
      cfv wcel vw cv vf cv cfv vf cv crn wcel vy cv vf cv crn cuni wcel vb cv
      vc cv vf cv wf vw cv vb cv wcel wa vy cv vw cv vf cv cfv vf cv crn elunii
      vf cv vb cv wfn vw cv vb cv wcel vw cv vf cv cfv vf cv crn wcel vb cv vc
      cv vf cv wf vb cv vw cv vf cv fnfvelrn vb cv vc cv vf cv ffn sylan sylan2
      expcom adantl syl9r syld expr com23 ex adantr a1i4 imp44 r19.23adv vw vy
      cv vb cv eluni2 syl5ib sylbid cJ vx cv cfi cfv ctg cfv wceq vc cv cJ wss
      cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc cv vf cv wf vt cv
      vt cv vf cv cfv wss vt vb cv wral wa cX vb cv cuni wceq wa wa vy cv vf cv
      crn cuni wcel vy cv vc cv cuni wcel vy cv cJ cuni wcel cJ vx cv cfi cfv
      ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa
      vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa cX vb cv
      cuni wceq wa wa vf cv crn cuni vc cv cuni vy cv cJ vx cv cfi cfv ctg cfv
      wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv cfn wcel wa vb cv vc
      cv vf cv wf vt cv vt cv vf cv cfv wss vt vb cv wral wa cX vb cv cuni wceq
      wa wa vf cv crn vc cv wss vf cv crn cuni vc cv cuni wss vb cv vc cv vf cv
      wf vt cv vt cv vf cv cfv wss vt vb cv wral wa vf cv crn vc cv wss cJ vx
      cv cfi cfv ctg cfv wceq vc cv cJ wss cJ cuni vc cv cuni wceq w3a vb cv
      cfn wcel wa cX vb cv cuni wceq vb cv vc cv vf cv wf vf cv crn vc cv wss
      vt cv vt cv vf cv cfv wss vt vb cv wral vb cv vc cv vf cv frn adantr
      ad2antrl vf cv crn vc cv uniss syl sseld cJ vx cv cfi cfv ctg cfv wceq vc
      cv cJ wss cJ cuni vc cv cuni wceq w3a vy cv cJ cuni wcel vy cv vc cv cuni
      wcel wb vb cv cfn wcel vb cv vc cv vf cv wf vt cv vt cv vf cv cfv wss vt
      vb cv wral wa cX vb cv cuni wceq wa cJ cuni vc cv cuni wceq cJ vx cv cfi
      cfv ctg cfv wceq vy cv cJ cuni wcel vy cv vc cv cuni wcel wb vc cv cJ wss
      cJ cuni vc cv cuni vy cv eleq2 3ad2ant3 ad2antrr sylibrd impbid eqrdv
      sylanc exp32 19.23adv syld ex com23 imp3a vb cv vy cv vz cv wss vz vc cv
      wrex vy vx cv cfi cfv crab cpw cfn cin wcel vb cv vy cv vz cv wss vz vc
      cv wrex vy vx cv cfi cfv crab cpw wcel vb cv cfn wcel wa vb cv vy cv vz
      cv wss vz vc cv wrex vy vx cv cfi cfv crab wss vb cv cfn wcel wa vb cv vy
      cv vz cv wss vz vc cv wrex vy vx cv cfi cfv crab cpw cfn elin vb cv vy cv
      vz cv wss vz vc cv wrex vy vx cv cfi cfv crab cpw wcel vb cv vy cv vz cv
      wss vz vc cv wrex vy vx cv cfi cfv crab wss vb cv cfn wcel vb cv vy cv vz
      cv wss vz vc cv wrex vy vx cv cfi cfv crab vb visset elpw anbi1i bitri
      syl5ib r19.23adv syld 3exp com34 com23 vc cv cJ vc visset elpw syl7ib
      r19.21adv cJ vx cv cfi cfv ctg cfv wceq cJ ctop wcel vx cv cfi cfv ctg
      cfv ctop wcel vx cv cfi cfv ctb wcel vx cv cfi cfv ctg cfv ctop wcel vx
      cv cvv wcel vx cv cfi cfv ctb wcel vx visset vx cv cvv fibas ax-mp vx cv
      cfi cfv tgcl ax-mp cJ vx cv cfi cfv ctg cfv ctop eleq1 mpbiri jctild vc
      vd cJ iscomp syl6ibr syld imp 19.23aiv impbii $.
      $( [28-Jan-2010] $) $( [24-Jan-2010] $)
  $}

  ${
    $d o x y J $. $d o x y X $.
    dfcon2.1 $e |- X = U. J $.
    $( An alternate definition of connectedness. $)
    dfcon2 $p |- ( J e. Top -> ( J e. Con <-> A. x e. J A. y e. J ( ( x =/= (/)
    /\ y =/= (/) /\ ( x i^i y ) = (/) ) -> X =/= ( x u. y ) ) ) ) $=
      cJ ctop wcel cJ ccon wcel vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0
      wceq w3a cX vx cv vy cv cun wne wi vy cJ wral vx cJ wral vx vy cJ cX
      dfcon2.1 usinuniop cJ ctop wcel vx cv c0 wne vy cv c0 wne vx cv vy cv cin
      c0 wceq w3a cX vx cv vy cv cun wne wi vy cJ wral vx cJ wral cJ cJ ccld
      cfv cin c0 cJ cuni cpr wceq cJ ccon wcel cJ ctop wcel vx cv c0 wne vy cv
      c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv cun wne wi vy cJ wral
      vx cJ wral cJ cJ ccld cfv cin c0 cJ cuni cpr wceq cJ ctop wcel vx cv c0
      wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv cun wne wi vy
      cJ wral vx cJ wral wa vo cJ cJ ccld cfv cin c0 cJ cuni cpr cJ ctop wcel
      vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv cun
      wne wi vy cJ wral vx cJ wral wa vo cv cJ wcel vo cv cJ ccld cfv wcel wa
      vo cv c0 wceq vo cv cJ cuni wceq wo vo cv cJ cJ ccld cfv cin wcel vo cv
      c0 cJ cuni cpr wcel cJ ctop wcel vx cv c0 wne vy cv c0 wne vx cv vy cv
      cin c0 wceq w3a cX vx cv vy cv cun wne wi vy cJ wral vx cJ wral wa vo cv
      cJ wcel vo cv cJ ccld cfv wcel wa vo cv c0 wceq vo cv cJ cuni wceq wo cJ
      ctop wcel vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv
      vy cv cun wne wi vy cJ wral vx cJ wral vo cv cJ wcel vo cv cJ ccld cfv
      wcel wa vo cv c0 wceq vo cv cJ cuni wceq wo wi cJ ctop wcel vo cv cJ wcel
      vo cv cJ ccld cfv wcel wa vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0
      wceq w3a cX vx cv vy cv cun wne wi vy cJ wral vx cJ wral vo cv c0 wceq vo
      cv cJ cuni wceq wo cJ ctop wcel vo cv cJ wcel vo cv cJ ccld cfv wcel wa
      vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv cun
      wne wi vy cJ wral vx cJ wral vo cv c0 wceq vo cv cJ cuni wceq wo wi cJ
      ctop wcel vo cv cJ wcel vo cv cJ ccld cfv wcel wa wa vx cv c0 wne vy cv
      c0 wne vx cv vy cv cin c0 wceq w3a cX vx cv vy cv cun wne wi vy cJ wral
      vx cJ wral vo cv c0 wne cX vo cv cdif c0 wne vo cv cX vo cv cdif cin c0
      wceq w3a cX vo cv cX vo cv cdif cun wne wi vo cv c0 wceq vo cv cJ cuni
      wceq wo vo cv cJ wcel cX vo cv cdif cJ wcel vx cv c0 wne vy cv c0 wne vx
      cv vy cv cin c0 wceq w3a cX vx cv vy cv cun wne wi vy cJ wral vx cJ wral
      vo cv c0 wne cX vo cv cdif c0 wne vo cv cX vo cv cdif cin c0 wceq w3a cX
      vo cv cX vo cv cdif cun wne wi wi cJ ctop wcel vo cv cJ wcel vo cv cJ
      ccld cfv wcel wa wa vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a
      cX vx cv vy cv cun wne wi vo cv c0 wne cX vo cv cdif c0 wne vo cv cX vo
      cv cdif cin c0 wceq w3a cX vo cv cX vo cv cdif cun wne wi vo cv c0 wne vy
      cv c0 wne vo cv vy cv cin c0 wceq w3a cX vo cv vy cv cun wne wi vx vy vo
      cv cX vo cv cdif cJ cJ vx cv vo cv wceq vx cv c0 wne vy cv c0 wne vx cv
      vy cv cin c0 wceq w3a vo cv c0 wne vy cv c0 wne vo cv vy cv cin c0 wceq
      w3a cX vx cv vy cv cun wne cX vo cv vy cv cun wne vx cv vo cv wceq vx cv
      c0 wne vo cv c0 wne vx cv vy cv cin c0 wceq vo cv vy cv cin c0 wceq vy cv
      c0 wne vx cv vo cv c0 neeq1 vx cv vo cv wceq vx cv vy cv cin vo cv vy cv
      cin c0 vx cv vo cv vy cv ineq1 eqeq1d 3anbi13d vx cv vo cv wceq vx cv vy
      cv cun vo cv vy cv cun cX vx cv vo cv vy cv uneq1 neeq2d imbi12d vy cv cX
      vo cv cdif wceq vo cv c0 wne vy cv c0 wne vo cv vy cv cin c0 wceq w3a vo
      cv c0 wne cX vo cv cdif c0 wne vo cv cX vo cv cdif cin c0 wceq w3a cX vo
      cv vy cv cun wne cX vo cv cX vo cv cdif cun wne vy cv cX vo cv cdif wceq
      vy cv c0 wne cX vo cv cdif c0 wne vo cv vy cv cin c0 wceq vo cv cX vo cv
      cdif cin c0 wceq vo cv c0 wne vy cv cX vo cv cdif c0 neeq1 vy cv cX vo cv
      cdif wceq vo cv vy cv cin vo cv cX vo cv cdif cin c0 vy cv cX vo cv cdif
      vo cv ineq2 eqeq1d 3anbi23d vy cv cX vo cv cdif wceq vo cv vy cv cun vo
      cv cX vo cv cdif cun cX vy cv cX vo cv cdif vo cv uneq2 neeq2d imbi12d
      rcla42v cJ ctop wcel vo cv cJ wcel vo cv cJ ccld cfv wcel simprl cJ ctop
      wcel vo cv cJ ccld cfv wcel cX vo cv cdif cJ wcel vo cv cJ wcel vo cv cJ
      cX dfcon2.1 cldopn adantrl sylanc cJ ctop wcel vo cv cJ wcel vo cv cJ
      ccld cfv wcel wa wa vo cv c0 wne cX vo cv cdif c0 wne wa cX vo cv cX vo
      cv cdif cun wne wi vo cv c0 wceq vo cv cJ cuni wceq wo vo cv c0 wne cX vo
      cv cdif c0 wne vo cv cX vo cv cdif cin c0 wceq w3a cX vo cv cX vo cv cdif
      cun wne wi cJ ctop wcel vo cv cJ wcel vo cv cJ ccld cfv wcel wa wa cX vo
      cv cX vo cv cdif cun wceq vo cv c0 wne cX vo cv cdif c0 wne wa wn wi vo
      cv c0 wceq vo cv cJ cuni wceq wo vo cv c0 wne cX vo cv cdif c0 wne wa cX
      vo cv cX vo cv cdif cun wne wi cJ ctop wcel vo cv cJ wcel cX vo cv cX vo
      cv cdif cun wceq vo cv c0 wne cX vo cv cdif c0 wne wa wn wi vo cv c0 wceq
      vo cv cJ cuni wceq wo wi vo cv cJ ccld cfv wcel cJ ctop wcel vo cv cJ
      wcel vo cv cX wss cX vo cv cX vo cv cdif cun wceq vo cv c0 wne cX vo cv
      cdif c0 wne wa wn wi vo cv c0 wceq vo cv cJ cuni wceq wo wi vo cv cJ cX
      dfcon2.1 eltopss cJ ctop wcel vo cv cX wss wa cX vo cv cX vo cv cdif cun
      wceq cX vo cv cX vo cv cdif cun wceq vo cv c0 wne cX vo cv cdif c0 wne wa
      wn wi vo cv c0 wceq vo cv cJ cuni wceq wo wi vo cv cX wss cX vo cv cX vo
      cv cdif cun wceq cJ ctop wcel vo cv cX wss vo cv cX vo cv cdif cun cX vo
      cv cX wss vo cv cX vo cv cdif cun cX wceq vo cv cX undif biimpi eqcomd
      adantl cX vo cv cX vo cv cdif cun wceq cX vo cv cX vo cv cdif cun wceq vo
      cv c0 wne cX vo cv cdif c0 wne wa wn wi cJ ctop wcel vo cv cX wss wa vo
      cv c0 wceq vo cv cJ cuni wceq wo cX vo cv cX vo cv cdif cun wceq cX vo cv
      cX vo cv cdif cun wceq vo cv c0 wne cX vo cv cdif c0 wne wa wn wi vo cv
      c0 wne cX vo cv cdif c0 wne wa wn cJ ctop wcel vo cv cX wss wa vo cv c0
      wceq vo cv cJ cuni wceq wo wi cX vo cv cX vo cv cdif cun wceq vo cv c0
      wne cX vo cv cdif c0 wne wa wn pm2.27 vo cv c0 wne cX vo cv cdif c0 wne
      wa wn vo cv c0 wceq cX vo cv cdif c0 wceq wo cJ ctop wcel vo cv cX wss wa
      vo cv c0 wceq vo cv cJ cuni wceq wo wi vo cv c0 wne cX vo cv cdif c0 wne
      wa wn vo cv c0 wceq wn cX vo cv cdif c0 wceq wn wa wn vo cv c0 wceq cX vo
      cv cdif c0 wceq wo vo cv c0 wne cX vo cv cdif c0 wne wa vo cv c0 wceq wn
      cX vo cv cdif c0 wceq wn wa vo cv c0 wne vo cv c0 wceq wn cX vo cv cdif
      c0 wne cX vo cv cdif c0 wceq wn vo cv c0 df-ne cX vo cv cdif c0 df-ne
      anbi12i notbii vo cv c0 wceq cX vo cv cdif c0 wceq oran bitr4i cJ ctop
      wcel vo cv cX wss wa vo cv c0 wceq cX vo cv cdif c0 wceq wo vo cv c0 wceq
      vo cv cJ cuni wceq wo cJ ctop wcel vo cv cX wss wa cX vo cv cdif c0 wceq
      vo cv cJ cuni wceq vo cv c0 wceq cJ ctop wcel vo cv cX wss wa cX vo cv
      wss vo cv cX wceq cX vo cv cdif c0 wceq vo cv cJ cuni wceq vo cv cX wss
      cX vo cv wss vo cv cX wceq wi cJ ctop wcel vo cv cX wss cX vo cv wss vo
      cv cX wceq vo cv cX wceq vo cv cX wss cX vo cv wss wa vo cv cX eqss
      biimpri ex adantl cX vo cv ssdif0 cX cJ cuni vo cv dfcon2.1 eqeq2i
      3imtr3g orim2d com12 sylbi syl6 com3r mpd syldan adantrr vo cv c0 wne cX
      vo cv cdif c0 wne wa cX vo cv cX vo cv cdif cun wne wi vo cv c0 wne cX vo
      cv cdif c0 wne wa cX vo cv cX vo cv cdif cun vo cv c0 wne cX vo cv cdif
      c0 wne wa cX vo cv cX vo cv cdif cun wne wi id necon2bd syl5 vo cv c0 wne
      cX vo cv cdif c0 wne wa vo cv c0 wne cX vo cv cdif c0 wne vo cv cX vo cv
      cdif cin c0 wceq w3a cX vo cv cX vo cv cdif cun wne vo cv c0 wne cX vo cv
      cdif c0 wne wa vo cv c0 wne cX vo cv cdif c0 wne wa vo cv cX vo cv cdif
      cin c0 wceq wa vo cv c0 wne cX vo cv cdif c0 wne vo cv cX vo cv cdif cin
      c0 wceq w3a vo cv c0 wne cX vo cv cdif c0 wne wa vo cv cX vo cv cdif cin
      c0 wceq vo cv cX difdisj jctr vo cv c0 wne cX vo cv cdif c0 wne vo cv cX
      vo cv cdif cin c0 wceq df-3an sylibr imim1i syl5 syld ex com23 imp cJ
      ctop wcel vo cv c0 wceq vo cv cJ cuni wceq wo vo cv cJ wcel vo cv cJ ccld
      cfv wcel wa wi vx cv c0 wne vy cv c0 wne vx cv vy cv cin c0 wceq w3a cX
      vx cv vy cv cun wne wi vy cJ wral vx cJ wral cJ ctop wcel vo cv c0 wceq
      vo cv cJ wcel vo cv cJ ccld cfv wcel wa vo cv cJ cuni wceq cJ ctop wcel
      vo cv c0 wceq vo cv cJ wcel vo cv cJ ccld cfv wcel wa cJ ctop wcel vo cv
      c0 wceq wa vo cv cJ wcel vo cv cJ ccld cfv wcel cJ ctop wcel vo cv c0
      wceq wa vo cv cJ wcel c0 cJ wcel cJ ctop wcel c0 cJ wcel vo cv c0 wceq cJ
      0opn adantr vo cv c0 wceq vo cv cJ wcel c0 cJ wcel wb cJ ctop wcel vo cv
      c0 cJ eleq1 adantl mpbird cJ ctop wcel vo cv c0 wceq wa vo cv cJ ccld cfv
      wcel c0 cJ ccld cfv wcel cJ ctop wcel c0 cJ ccld cfv wcel vo cv c0 wceq
      cJ 0cld adantr vo cv c0 wceq vo cv cJ ccld cfv wcel c0 cJ ccld cfv wcel
      wb cJ ctop wcel vo cv c0 cJ ccld cfv eleq1 adantl mpbird jca ex cJ ctop
      wcel vo cv cJ cuni wceq vo cv cJ wcel vo cv cJ ccld cfv wcel wa cJ ctop
      wcel vo cv cJ cuni wceq wa vo cv cJ wcel vo cv cJ ccld cfv wcel cJ ctop
      wcel vo cv cJ cuni wceq wa vo cv cJ wcel cJ cuni cJ wcel cJ ctop wcel cJ
      cuni cJ wcel vo cv cJ cuni wceq cJ cJ cuni cJ cuni eqid topopn adantr vo
      cv cJ cuni wceq vo cv cJ wcel cJ cuni cJ wcel wb cJ ctop wcel vo cv cJ
      cuni cJ eleq1 adantl mpbird cJ ctop wcel vo cv cJ cuni wceq wa vo cv cJ
      ccld cfv wcel cJ cuni cJ ccld cfv wcel cJ ctop wcel cJ cuni cJ ccld cfv
      wcel vo cv cJ cuni wceq cJ cJ cuni cJ cuni eqid topcld adantr vo cv cJ
      cuni wceq vo cv cJ ccld cfv wcel cJ cuni cJ ccld cfv wcel wb cJ ctop wcel
      vo cv cJ cuni cJ ccld cfv eleq1 adantl mpbird jca ex jaod adantr impbid
      vo cv cJ cJ ccld cfv elin vo cv c0 cJ cuni vo visset elpr 3bitr4g eqrdv
      ex cJ iscon sylibrd impbid2 $.
      $( [9-Jul-2009] $) $( [9-Jul-2009] $)
  $}

  ${
    $d r s u v x y J $. $d r s u v x y S $. $d r s u v x y X $.
    connsub.1 $e |- X = U. J $.
    $( Two equivalent ways of saying that a subspace topology is connected. $)
    connsub $p |- ( ( J e. Top /\ S C_ X ) -> ( ( subSp ` <. S , J >. ) e. Con
    <-> A. x e. J A. y e. J ( ( ( x i^i S ) =/= (/) /\ ( y i^i S ) =/= (/) /\ (
    x i^i y ) C_ ( X \ S ) ) -> -. S C_ ( x u. y ) ) ) ) $=
      cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv ccon wcel vu cv c0 wne vv
      cv c0 wne vu cv vv cv cin c0 wceq w3a cS cJ cop csubsp cfv cuni vu cv vv
      cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop csubsp cfv wral
      vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun
      wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop csubsp cfv wral vx cv cS
      cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx
      cv vy cv cun wss wn wi vy cJ wral vx cJ wral cJ ctop wcel cS cX wss wa cS
      cJ cop csubsp cfv ctop wcel cS cJ cop csubsp cfv ccon wcel vu cv c0 wne
      vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS cJ cop csubsp cfv cuni vu cv
      vv cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop csubsp cfv
      wral wb cJ ctop wcel cS cJ cuni wss cS cJ cop csubsp cfv ctop wcel cS cX
      wss cS cJ stoig3 cX cJ cuni cS connsub.1 sseq2i sylan2b vu vv cS cJ cop
      csubsp cfv cS cJ cop csubsp cfv cuni cS cJ cop csubsp cfv cuni eqid
      dfcon2 syl cJ ctop wcel cS cX wss wa cS cJ cop csubsp cfv cuni cS wceq vu
      cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS cJ cop csubsp cfv
      cuni vu cv vv cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop
      csubsp cfv wral vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS
      vu cv vv cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop csubsp
      cfv wral wb cJ ctop wcel cS cJ cuni wss cS cJ cop csubsp cfv cuni cS wceq
      cS cX wss cS cJ stoig2 cX cJ cuni cS connsub.1 sseq2i sylan2b cS cJ cop
      csubsp cfv cuni cS wceq vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq
      w3a cS cJ cop csubsp cfv cuni vu cv vv cv cun wne wi vu cv c0 wne vv cv
      c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun wne wi vu vv cS cJ
      cop csubsp cfv cS cJ cop csubsp cfv cS cJ cop csubsp cfv cuni cS wceq cS
      cJ cop csubsp cfv cuni vu cv vv cv cun wne cS vu cv vv cv cun wne vu cv
      c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS cJ cop csubsp cfv cuni
      cS vu cv vv cv cun neeq1 imbi2d 2ralbidv syl cJ ctop wcel cS cX wss wa vu
      cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun wne
      wi vv cS cJ cop csubsp cfv wral vu cS cJ cop csubsp cfv wral vx cv cS cin
      c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy
      cv cun wss wn wi vy cJ wral vx cJ wral cJ ctop wcel cS cX wss wa vu cv c0
      wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun wne wi vv
      cS cJ cop csubsp cfv wral vu cS cJ cop csubsp cfv wral vx cv cS cin c0
      wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy cv
      cun wss wn wi vx vy cJ cJ cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv
      cJ wcel wa vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv
      vv cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop csubsp cfv
      wral vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif
      wss w3a cS vx cv vy cv cun wss wn wi cJ ctop wcel cS cX wss wa vx cv cJ
      wcel vy cv cJ wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv
      cin cX cS cdif wss w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq
      w3a cS vu cv vv cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ cop
      csubsp cfv wral cS vx cv vy cv cun wss wn cJ ctop wcel cS cX wss wa vx cv
      cJ wcel vy cv cJ wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy
      cv cin cX cS cdif wss w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0
      wceq w3a cS vu cv vv cv cun wne wi vv cS cJ cop csubsp cfv wral vu cS cJ
      cop csubsp cfv wral cS vx cv vy cv cun wss wn wi cJ ctop wcel cS cX wss
      wa vx cv cJ wcel vy cv cJ wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne
      vx cv vy cv cin cX cS cdif wss w3a w3a vu cv c0 wne vv cv c0 wne vu cv vv
      cv cin c0 wceq w3a cS vu cv vv cv cun wne wi vv cS cJ cop csubsp cfv wral
      vu cS cJ cop csubsp cfv wral vx cv cS cin c0 wne vy cv cS cin c0 wne vx
      cv cS cin vy cv cS cin cin c0 wceq w3a cS vx cv cS cin vy cv cS cin cun
      wne wi cS vx cv vy cv cun wss wn vx cv cS cin cS cJ cop csubsp cfv wcel
      vy cv cS cin cS cJ cop csubsp cfv wcel vu cv c0 wne vv cv c0 wne vu cv vv
      cv cin c0 wceq w3a cS vu cv vv cv cun wne wi vv cS cJ cop csubsp cfv wral
      vu cS cJ cop csubsp cfv wral vx cv cS cin c0 wne vy cv cS cin c0 wne vx
      cv cS cin vy cv cS cin cin c0 wceq w3a cS vx cv cS cin vy cv cS cin cun
      wne wi wi cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ wcel wa vx cv
      cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a w3a
      vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun
      wne wi vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv cS cin vy cv cS cin
      cin c0 wceq w3a cS vx cv cS cin vy cv cS cin cun wne wi vx cv cS cin c0
      wne vv cv c0 wne vx cv cS cin vv cv cin c0 wceq w3a cS vx cv cS cin vv cv
      cun wne wi vu vv vx cv cS cin vy cv cS cin cS cJ cop csubsp cfv cS cJ cop
      csubsp cfv vu cv vx cv cS cin wceq vu cv c0 wne vv cv c0 wne vu cv vv cv
      cin c0 wceq w3a vx cv cS cin c0 wne vv cv c0 wne vx cv cS cin vv cv cin
      c0 wceq w3a cS vu cv vv cv cun wne cS vx cv cS cin vv cv cun wne vu cv vx
      cv cS cin wceq vu cv c0 wne vx cv cS cin c0 wne vu cv vv cv cin c0 wceq
      vx cv cS cin vv cv cin c0 wceq vv cv c0 wne vu cv vx cv cS cin c0 neeq1
      vu cv vx cv cS cin wceq vu cv vv cv cin vx cv cS cin vv cv cin c0 vu cv
      vx cv cS cin vv cv ineq1 eqeq1d 3anbi13d vu cv vx cv cS cin wceq vu cv vv
      cv cun vx cv cS cin vv cv cun cS vu cv vx cv cS cin vv cv uneq1 neeq2d
      imbi12d vv cv vy cv cS cin wceq vx cv cS cin c0 wne vv cv c0 wne vx cv cS
      cin vv cv cin c0 wceq w3a vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv
      cS cin vy cv cS cin cin c0 wceq w3a cS vx cv cS cin vv cv cun wne cS vx
      cv cS cin vy cv cS cin cun wne vv cv vy cv cS cin wceq vv cv c0 wne vy cv
      cS cin c0 wne vx cv cS cin vv cv cin c0 wceq vx cv cS cin vy cv cS cin
      cin c0 wceq vx cv cS cin c0 wne vv cv vy cv cS cin c0 neeq1 vv cv vy cv
      cS cin wceq vx cv cS cin vv cv cin vx cv cS cin vy cv cS cin cin c0 vv cv
      vy cv cS cin vx cv cS cin ineq2 eqeq1d 3anbi23d vv cv vy cv cS cin wceq
      vx cv cS cin vv cv cun vx cv cS cin vy cv cS cin cun cS vv cv vy cv cS
      cin vx cv cS cin uneq2 neeq2d imbi12d rcla42v cJ ctop wcel cS cX wss vx
      cv cJ wcel vx cv cS cin vx cv cS cin wceq vx cv cS cin cS cJ cop csubsp
      cfv wcel cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ wcel wa vx cv
      cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a w3a
      vx cv vx cv cS cin cS cJ cX connsub.1 elsubsp cJ ctop wcel cS cX wss wa
      vx cv cJ wcel vy cv cJ wcel wa cJ ctop wcel vx cv cS cin c0 wne vy cv cS
      cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cJ ctop wcel cS cX wss
      pm3.26 3ad2ant1 cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ wcel wa
      cS cX wss vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS
      cdif wss w3a cJ ctop wcel cS cX wss pm3.27 3ad2ant1 vx cv cJ wcel vy cv
      cJ wcel wa cJ ctop wcel cS cX wss wa vx cv cJ wcel vx cv cS cin c0 wne vy
      cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a vx cv cJ wcel vy cv
      cJ wcel pm3.26 3ad2ant2 cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ
      wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS
      cdif wss w3a w3a vx cv cS cin eqidd syl2anc cJ ctop wcel cS cX wss vy cv
      cJ wcel vy cv cS cin vy cv cS cin wceq vy cv cS cin cS cJ cop csubsp cfv
      wcel cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ wcel wa vx cv cS
      cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a w3a vy
      cv vy cv cS cin cS cJ cX connsub.1 elsubsp cJ ctop wcel cS cX wss wa vx
      cv cJ wcel vy cv cJ wcel wa cJ ctop wcel vx cv cS cin c0 wne vy cv cS cin
      c0 wne vx cv vy cv cin cX cS cdif wss w3a cJ ctop wcel cS cX wss pm3.26
      3ad2ant1 cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ wcel wa cS cX
      wss vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif
      wss w3a cJ ctop wcel cS cX wss pm3.27 3ad2ant1 vx cv cJ wcel vy cv cJ
      wcel wa cJ ctop wcel cS cX wss wa vy cv cJ wcel vx cv cS cin c0 wne vy cv
      cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a vx cv cJ wcel vy cv cJ
      wcel pm3.27 3ad2ant2 cJ ctop wcel cS cX wss wa vx cv cJ wcel vy cv cJ
      wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS
      cdif wss w3a w3a vy cv cS cin eqidd syl2anc sylanc cJ ctop wcel cS cX wss
      wa vx cv cJ wcel vy cv cJ wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne
      vx cv vy cv cin cX cS cdif wss w3a w3a vx cv cS cin c0 wne vy cv cS cin
      c0 wne vx cv cS cin vy cv cS cin cin c0 wceq w3a vx cv cS cin c0 wne vy
      cv cS cin c0 wne vx cv cS cin vy cv cS cin cin c0 wceq w3a cS vx cv cS
      cin vy cv cS cin cun wne wi cS vx cv vy cv cun wss wn wi vx cv cS cin c0
      wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cJ ctop wcel
      cS cX wss wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv cS cin vy cv
      cS cin cin c0 wceq w3a vx cv cJ wcel vy cv cJ wcel wa vx cv cS cin c0 wne
      vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a vx cv cS cin c0
      wne vy cv cS cin c0 wne vx cv cS cin vy cv cS cin cin c0 wceq vx cv cS
      cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss 3simp1 vx
      cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss
      3simp2 vx cv vy cv cin cX cS cdif wss vx cv cS cin c0 wne vx cv cS cin vy
      cv cS cin cin c0 wceq vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss
      vx cv vy cv cin cS cin c0 vx cv cS cin vy cv cS cin cin vx cv vy cv cin
      cX cS cdif wss vx cv vy cv cin cS cin c0 wceq vx cv vy cv cin cX cS cdif
      wss vx cv vy cv cin cX wss vx cv vy cv cin cS cin c0 wceq vx cv vy cv cin
      cX cS cdif wss wb vx cv vy cv cin cX cS cdif wss cX cS cdif cX wss vx cv
      vy cv cin cX wss cX cS difss vx cv vy cv cin cX cS cdif cX sstr mpan2 vx
      cv vy cv cin cS cX reldisj syl ibir vx cv vy cv cS inindir syl5eqr
      3ad2ant3 3jca 3ad2ant3 vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv cS
      cin vy cv cS cin cin c0 wceq w3a vx cv cS cin c0 wne vy cv cS cin c0 wne
      vx cv cS cin vy cv cS cin cin c0 wceq w3a cS vx cv cS cin vy cv cS cin
      cun wne wi cS vx cv cS cin vy cv cS cin cun wne cJ ctop wcel cS cX wss wa
      vx cv cJ wcel vy cv cJ wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx
      cv vy cv cin cX cS cdif wss w3a w3a cS vx cv vy cv cun wss wn vx cv cS
      cin c0 wne vy cv cS cin c0 wne vx cv cS cin vy cv cS cin cin c0 wceq w3a
      cS vx cv cS cin vy cv cS cin cun wne pm2.27 cS vx cv cS cin vy cv cS cin
      cun wne cS vx cv vy cv cun wss wn wi cJ ctop wcel cS cX wss wa vx cv cJ
      wcel vy cv cJ wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv
      cin cX cS cdif wss w3a w3a cS vx cv vy cv cun wss cS vx cv cS cin vy cv
      cS cin cun cS vx cv vy cv cun wss cS vx cv vy cv cun cS cin vx cv cS cin
      vy cv cS cin cun cS vx cv vy cv cun wss cS vx cv vy cv cun cin cS vx cv
      vy cv cun cS cin cS vx cv vy cv cun wss cS vx cv vy cv cun cin cS wceq cS
      vx cv vy cv cun df-ss biimpi cS vx cv vy cv cun incom syl5reqr vx cv vy
      cv cS indir syl6eq necon3ai a1i syl9r mpd syld 3exp com34 com23
      r19.21advv cJ ctop wcel cS cX wss wa vx cv cS cin c0 wne vy cv cS cin c0
      wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy cv cun wss wn wi vy cJ
      wral vx cJ wral vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS
      vu cv vv cv cun wne wi vu vv cS cJ cop csubsp cfv cS cJ cop csubsp cfv cJ
      ctop wcel cS cX wss wa vu cv cS cJ cop csubsp cfv wcel vv cv cS cJ cop
      csubsp cfv wcel wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv
      cin cX cS cdif wss w3a cS vx cv vy cv cun wss wn wi vy cJ wral vx cJ wral
      vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun
      wne wi cJ ctop wcel cS cX wss wa vu cv cS cJ cop csubsp cfv wcel vv cv cS
      cJ cop csubsp cfv wcel wa vu cv vr cv cS cin wceq vr cJ wrex vv cv vs cv
      cS cin wceq vs cJ wrex wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv
      vy cv cin cX cS cdif wss w3a cS vx cv vy cv cun wss wn wi vy cJ wral vx
      cJ wral vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv
      cv cun wne wi wi cJ ctop wcel cS cX wss cS cvv wcel vu cv cS cJ cop
      csubsp cfv wcel vv cv cS cJ cop csubsp cfv wcel wa vu cv vr cv cS cin
      wceq vr cJ wrex vv cv vs cv cS cin wceq vs cJ wrex wa wb cJ cuni cvv wcel
      cS cJ cuni wss cS cvv wcel cJ ctop wcel cS cX wss cS cJ cuni wss cJ cuni
      cvv wcel cS cvv wcel cS cJ cuni cvv ssexg ancoms cJ ctop uniexg cS cX wss
      cS cJ cuni wss cX cJ cuni cS connsub.1 sseq2i biimpi syl2an cJ ctop wcel
      cS cvv wcel wa vu cv cS cJ cop csubsp cfv wcel vu cv vr cv cS cin wceq vr
      cJ wrex vv cv cS cJ cop csubsp cfv wcel vv cv vs cv cS cin wceq vs cJ
      wrex cJ ctop wcel vu cv cvv wcel cS cvv wcel vu cv cS cJ cop csubsp cfv
      wcel vu cv vr cv cS cin wceq vr cJ wrex wb vu visset vr vu cv cS cvv cJ
      issubspt mp3an2 cJ ctop wcel vv cv cvv wcel cS cvv wcel vv cv cS cJ cop
      csubsp cfv wcel vv cv vs cv cS cin wceq vs cJ wrex wb vv visset vs vv cv
      cS cvv cJ issubspt mp3an2 anbi12d syldan cJ ctop wcel cS cX wss wa vu cv
      vr cv cS cin wceq vv cv vs cv cS cin wceq wa vs cJ wrex vr cJ wrex vx cv
      cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS
      vx cv vy cv cun wss wn wi vy cJ wral vx cJ wral vu cv c0 wne vv cv c0 wne
      vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun wne wi wi vu cv vr cv cS
      cin wceq vr cJ wrex vv cv vs cv cS cin wceq vs cJ wrex wa cJ ctop wcel cS
      cX wss wa vu cv vr cv cS cin wceq vv cv vs cv cS cin wceq wa vx cv cS cin
      c0 wne vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy
      cv cun wss wn wi vy cJ wral vx cJ wral vu cv c0 wne vv cv c0 wne vu cv vv
      cv cin c0 wceq w3a cS vu cv vv cv cun wne wi wi vr vs cJ cJ cJ ctop wcel
      cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv
      vs cv cS cin wceq wa vx cv cS cin c0 wne vy cv cS cin c0 wne vx cv vy cv
      cin cX cS cdif wss w3a cS vx cv vy cv cun wss wn wi vy cJ wral vx cJ wral
      vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun
      wne wi wi cJ ctop wcel cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv
      vr cv cS cin wceq vv cv vs cv cS cin wceq wa w3a vx cv cS cin c0 wne vy
      cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy cv cun
      wss wn wi vy cJ wral vx cJ wral vr cv cS cin c0 wne vs cv cS cin c0 wne
      vr cv vs cv cin cX cS cdif wss w3a cS vr cv vs cv cun wss wn wi vu cv c0
      wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv vv cv cun wne wi vr
      cv cJ wcel vs cv cJ wcel wa cJ ctop wcel cS cX wss wa vx cv cS cin c0 wne
      vy cv cS cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy cv cun
      wss wn wi vy cJ wral vx cJ wral vr cv cS cin c0 wne vs cv cS cin c0 wne
      vr cv vs cv cin cX cS cdif wss w3a cS vr cv vs cv cun wss wn wi wi vu cv
      vr cv cS cin wceq vv cv vs cv cS cin wceq wa vx cv cS cin c0 wne vy cv cS
      cin c0 wne vx cv vy cv cin cX cS cdif wss w3a cS vx cv vy cv cun wss wn
      wi vr cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif wss
      w3a cS vr cv vs cv cun wss wn wi vr cv cS cin c0 wne vy cv cS cin c0 wne
      vr cv vy cv cin cX cS cdif wss w3a cS vr cv vy cv cun wss wn wi vx vy vr
      cv vs cv cJ cJ vx cv vr cv wceq vx cv cS cin c0 wne vy cv cS cin c0 wne
      vx cv vy cv cin cX cS cdif wss w3a vr cv cS cin c0 wne vy cv cS cin c0
      wne vr cv vy cv cin cX cS cdif wss w3a cS vx cv vy cv cun wss wn cS vr cv
      vy cv cun wss wn vx cv vr cv wceq vx cv cS cin c0 wne vr cv cS cin c0 wne
      vx cv vy cv cin cX cS cdif wss vr cv vy cv cin cX cS cdif wss vy cv cS
      cin c0 wne vx cv vr cv wceq vx cv cS cin vr cv cS cin c0 vx cv vr cv cS
      ineq1 neeq1d vx cv vr cv wceq vx cv vy cv cin vr cv vy cv cin cX cS cdif
      vx cv vr cv vy cv ineq1 sseq1d 3anbi13d vx cv vr cv wceq cS vx cv vy cv
      cun wss cS vr cv vy cv cun wss vx cv vr cv wceq vx cv vy cv cun vr cv vy
      cv cun cS vx cv vr cv vy cv uneq1 sseq2d notbid imbi12d vy cv vs cv wceq
      vr cv cS cin c0 wne vy cv cS cin c0 wne vr cv vy cv cin cX cS cdif wss
      w3a vr cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif
      wss w3a cS vr cv vy cv cun wss wn cS vr cv vs cv cun wss wn vy cv vs cv
      wceq vy cv cS cin c0 wne vs cv cS cin c0 wne vr cv vy cv cin cX cS cdif
      wss vr cv vs cv cin cX cS cdif wss vr cv cS cin c0 wne vy cv vs cv wceq
      vy cv cS cin vs cv cS cin c0 vy cv vs cv cS ineq1 neeq1d vy cv vs cv wceq
      vr cv vy cv cin vr cv vs cv cin cX cS cdif vy cv vs cv vr cv ineq2 sseq1d
      3anbi23d vy cv vs cv wceq cS vr cv vy cv cun wss cS vr cv vs cv cun wss
      vy cv vs cv wceq vr cv vy cv cun vr cv vs cv cun cS vy cv vs cv vr cv
      uneq2 sseq2d notbid imbi12d rcla42v 3ad2ant2 cJ ctop wcel cS cX wss wa vr
      cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv vs cv cS cin
      wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a vr cv
      cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif wss w3a cS
      vr cv vs cv cun wss wn wi cS vu cv vv cv cun wne cJ ctop wcel cS cX wss
      wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv vs cv cS
      cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a vr
      cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif wss w3a
      cS vr cv vs cv cun wss wn wi cS vu cv vv cv cun wne wi cJ ctop wcel cS cX
      wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv vs cv
      cS cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a
      wa vr cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif wss
      w3a vr cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif
      wss w3a cS vr cv vs cv cun wss wn wi cS vu cv vv cv cun wne wi cJ ctop
      wcel cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq
      vv cv vs cv cS cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin
      c0 wceq w3a wa vr cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX
      cS cdif wss vu cv vr cv cS cin wceq vv cv vs cv cS cin wceq wa cJ ctop
      wcel cS cX wss wa vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a
      vr cv cS cin c0 wne vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin
      wceq vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a vr cv cS cin
      c0 wne vv cv vs cv cS cin wceq vu cv vr cv cS cin wceq vv cv c0 wne vu cv
      c0 wne vr cv cS cin c0 wne vu cv vv cv cin c0 wceq vu cv vr cv cS cin
      wceq vu cv c0 wne vr cv cS cin c0 wne vu cv vr cv cS cin c0 neeq1 biimpa
      3ad2antr1 adantlr 3ad2antl3 vu cv vr cv cS cin wceq vv cv vs cv cS cin
      wceq wa cJ ctop wcel cS cX wss wa vu cv c0 wne vv cv c0 wne vu cv vv cv
      cin c0 wceq w3a vs cv cS cin c0 wne vr cv cJ wcel vs cv cJ wcel wa vv cv
      vs cv cS cin wceq vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a
      vs cv cS cin c0 wne vu cv vr cv cS cin wceq vv cv vs cv cS cin wceq vu cv
      c0 wne vv cv c0 wne vs cv cS cin c0 wne vu cv vv cv cin c0 wceq vv cv vs
      cv cS cin wceq vv cv c0 wne vs cv cS cin c0 wne vv cv vs cv cS cin c0
      neeq1 biimpa 3ad2antr2 adantll 3ad2antl3 cJ ctop wcel cS cX wss wa vr cv
      cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv vs cv cS cin wceq
      wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a wa vr cv vs
      cv cin cS cin c0 wceq vr cv vs cv cin cX cS cdif wss cJ ctop wcel cS cX
      wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv vs cv
      cS cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a
      wa vr cv cS cin vs cv cS cin cin c0 vr cv vs cv cin cS cin cJ ctop wcel
      cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv
      vs cv cS cin wceq wa w3a vu cv c0 wne vu cv vv cv cin c0 wceq vr cv cS
      cin vs cv cS cin cin c0 wceq vv cv c0 wne vu cv vr cv cS cin wceq vv cv
      vs cv cS cin wceq wa cJ ctop wcel cS cX wss wa vu cv vv cv cin c0 wceq vr
      cv cS cin vs cv cS cin cin c0 wceq vr cv cJ wcel vs cv cJ wcel wa vu cv
      vr cv cS cin wceq vv cv vs cv cS cin wceq wa vu cv vv cv cin c0 wceq vr
      cv cS cin vs cv cS cin cin c0 wceq vu cv vr cv cS cin wceq vv cv vs cv cS
      cin wceq wa vu cv vv cv cin vr cv cS cin vs cv cS cin cin c0 vu cv vr cv
      cS cin vv cv vs cv cS cin ineq12 eqeq1d biimpa 3ad2antl3 3ad2antr3 vr cv
      vs cv cS inindir syl5eq cJ ctop wcel cS cX wss wa vr cv cJ wcel vs cv cJ
      wcel wa vu cv vr cv cS cin wceq vv cv vs cv cS cin wceq wa w3a vu cv c0
      wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a wa vr cv vs cv cin cX wss vr
      cv vs cv cin cS cin c0 wceq vr cv vs cv cin cX cS cdif wss wb cJ ctop
      wcel cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq
      vv cv vs cv cS cin wceq wa w3a vr cv vs cv cin cX wss vu cv c0 wne vv cv
      c0 wne vu cv vv cv cin c0 wceq w3a cJ ctop wcel cS cX wss wa vr cv cJ
      wcel vs cv cJ wcel wa vr cv vs cv cin cX wss vu cv vr cv cS cin wceq vv
      cv vs cv cS cin wceq wa cJ ctop wcel vr cv cJ wcel vr cv vs cv cin cX wss
      cS cX wss vs cv cJ wcel cJ ctop wcel vr cv cJ wcel wa vr cv cX wss vr cv
      vs cv cin cX wss vr cv cJ cX connsub.1 eltopss vr cv vs cv cX ssinss1 syl
      ad2ant2r 3adant3 adantr vr cv vs cv cin cS cX reldisj syl mpbid 3jca vr
      cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif wss w3a
      vr cv cS cin c0 wne vs cv cS cin c0 wne vr cv vs cv cin cX cS cdif wss
      w3a cS vr cv vs cv cun wss wn wi cS vr cv vs cv cun wss wn cJ ctop wcel
      cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin wceq vv cv
      vs cv cS cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0
      wceq w3a wa cS vu cv vv cv cun wne vr cv cS cin c0 wne vs cv cS cin c0
      wne vr cv vs cv cin cX cS cdif wss w3a cS vr cv vs cv cun wss wn pm2.27
      cJ ctop wcel cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS
      cin wceq vv cv vs cv cS cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv
      vv cv cin c0 wceq w3a wa cS vr cv vs cv cun wss cS vu cv vv cv cun cJ
      ctop wcel cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv cS cin
      wceq vv cv vs cv cS cin wceq wa w3a vu cv c0 wne vv cv c0 wne vu cv vv cv
      cin c0 wceq w3a cS vu cv vv cv cun wceq cS vr cv vs cv cun wss wi cJ ctop
      wcel cS cX wss wa vr cv cJ wcel vs cv cJ wcel wa vu cv vr cv wss vv cv vs
      cv wss wa vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv
      vv cv cun wceq cS vr cv vs cv cun wss wi wi vu cv vr cv cS cin wceq vv cv
      vs cv cS cin wceq wa vu cv vr cv wss vv cv vs cv wss wa cJ ctop wcel cS
      cX wss wa vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu cv
      vv cv cun wceq cS vr cv vs cv cun wss wi wi vr cv cJ wcel vs cv cJ wcel
      wa vu cv vr cv wss vv cv vs cv wss wa cS vu cv vv cv cun wceq cS vr cv vs
      cv cun wss wi vu cv c0 wne vv cv c0 wne vu cv vv cv cin c0 wceq w3a cS vu
      cv vv cv cun wceq cS vr cv vs cv cun wss vu cv vv cv cun vr cv vs cv cun
      wss vu cv vr cv wss vv cv vs cv wss wa cS vu cv vv cv cun vr cv vs cv cun
      sseq1 vu cv vr cv vv cv vs cv unss12 syl5cbir a1d 3ad2ant3 vu cv vr cv cS
      cin wceq vu cv vr cv wss vv cv vs cv cS cin wceq vv cv vs cv wss vu cv vr
      cv cS cin wceq vu cv vr cv wss vr cv cS cin vr cv wss vr cv cS inss1 vu
      cv vr cv cS cin vr cv sseq1 mpbiri vv cv vs cv cS cin wceq vv cv vs cv
      wss vs cv cS cin vs cv wss vs cv cS inss1 vv cv vs cv cS cin vs cv sseq1
      mpbiri anim12i syl3an3 imp necon3bd syl9r mpd ex com23 syld 3exp
      r19.23advv vu cv vr cv cS cin wceq vv cv vs cv cS cin wceq vr vs cJ cJ
      reeanv syl5ibr sylbid com23 r19.21advv impbid 3bitrd $.
      $( [9-Jul-2009] $) $( [9-Jul-2009] $)
  $}

  ${
    $d f x y F $. $d f x y J $. $d f x y K $. $d f x y X $. $d f x y Y $.
    cnconn.1 $e |- X = U. J $.
    cnconn.2 $e |- Y = U. K $.
    $( Connectedness is respected by a continuous onto map. $)
    cnconn $p |- ( ( ( J e. Con /\ K e. Top ) /\ ( F : X -onto-> Y /\ F e. ( J
    Cn K ) ) ) -> K e. Con ) $=
      cJ ccon wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK
      ctop wcel cK cK ccld cfv cin c0 cK cuni cpr wceq wa cK ccon wcel cJ ccon
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cK ctop wcel
      cK cK ccld cfv cin c0 cK cuni cpr wceq cJ ccon wcel cK ctop wcel cX cY cF
      wfo cF cJ cK ccn co wcel wa simplr cJ ccon wcel cK ctop wcel cX cY cF wfo
      cF cJ cK ccn co wcel cK cK ccld cfv cin c0 cK cuni cpr wceq cK ctop wcel
      cX cY cF wfo cF cJ cK ccn co wcel cJ ccon wcel cK cK ccld cfv cin c0 cK
      cuni cpr wceq cK ctop wcel cX cY cF wfo cF cJ cK ccn co wcel cJ ccon wcel
      cK cK ccld cfv cin c0 cK cuni cpr wceq wi cK ctop wcel cX cY cF wfo wa cF
      cJ cK ccn co wcel wa cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq
      wa cK cK ccld cfv cin c0 cK cuni cpr wceq cJ ccon wcel cK ctop wcel cX cY
      cF wfo cF cJ cK ccn co wcel cJ ctop wcel cJ cJ ccld cfv cin c0 cJ cuni
      cpr wceq cK cK ccld cfv cin c0 cK cuni cpr wceq cJ ctop wcel cK ctop wcel
      cX cY cF wfo cF cJ cK ccn co wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq
      cK cK ccld cfv cin c0 cK cuni cpr wceq wi cJ ctop wcel cK ctop wcel cX cY
      cF wfo cF cJ cK ccn co wcel cJ cJ ccld cfv cin c0 cJ cuni cpr wceq cK cK
      ccld cfv cin c0 cK cuni cpr wceq wi cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa vx cv cJ cJ ccld cfv cin wcel vx cv c0 cJ
      cuni cpr wcel wb vx wal vy cv cK cK ccld cfv cin wcel vy cv c0 cK cuni
      cpr wcel wb vy wal cJ cJ ccld cfv cin c0 cJ cuni cpr wceq cK cK ccld cfv
      cin c0 cK cuni cpr wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ
      cK ccn co wcel wa wa vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0
      wceq vx cv cJ cuni wceq wo wb vx wal vy cv cK wcel vy cv cK ccld cfv wcel
      wa vy cv c0 wceq vy cv cK cuni wceq wo wb vy wal vx cv cJ cJ ccld cfv cin
      wcel vx cv c0 cJ cuni cpr wcel wb vx wal vy cv cK cK ccld cfv cin wcel vy
      cv c0 cK cuni cpr wcel wb vy wal cJ ctop wcel cK ctop wcel wa cX cY cF
      wfo cF cJ cK ccn co wcel wa wa vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx
      cv c0 wceq vx cv cJ cuni wceq wo wb vx wal vy cv cK wcel vy cv cK ccld
      cfv wcel wa vy cv c0 wceq vy cv cK cuni wceq wo wb vy cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vx cv cJ wcel vx cv
      cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni wceq wo wb vx wal vy cv
      cK wcel vy cv cK ccld cfv wcel wa vy cv c0 wceq vy cv cK cuni wceq wo wb
      cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vx
      cv cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni wceq wo
      wb vx wal wa vy cv cK wcel vy cv cK ccld cfv wcel wa vy cv c0 wceq vy cv
      cK cuni wceq wo cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ
      cuni wceq wo wb vx wal vy cv cK wcel vy cv cK ccld cfv wcel wa vy cv c0
      wceq vy cv cK cuni wceq wo wi cJ ctop wcel cK ctop wcel wa cX cY cF wfo
      cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv cK ccld cfv wcel wa vx cv
      cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni wceq wo wb
      vx wal vy cv c0 wceq vy cv cK cuni wceq wo cJ ctop wcel cK ctop wcel wa
      cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv cK ccld cfv
      wcel wa vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ
      cuni wceq wo wb vx wal vy cv c0 wceq vy cv cK cuni wceq wo wi cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK
      wcel vy cv cK ccld cfv wcel wa wa vx cv cJ wcel vx cv cJ ccld cfv wcel wa
      vx cv c0 wceq vx cv cJ cuni wceq wo wb vx wal cF ccnv vy cv cima cJ wcel
      cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy cv cima c0 wceq cF ccnv
      vy cv cima cJ cuni wceq wo wb vy cv c0 wceq vy cv cK cuni wceq wo cX cY
      cF wfo cF cJ cK ccn co wcel wa vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx
      cv c0 wceq vx cv cJ cuni wceq wo wb vx wal cF ccnv vy cv cima cJ wcel cF
      ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy cv cima c0 wceq cF ccnv vy
      cv cima cJ cuni wceq wo wb wi cJ ctop wcel cK ctop wcel wa vy cv cK wcel
      vy cv cK ccld cfv wcel wa cF cJ cK ccn co wcel vx cv cJ wcel vx cv cJ
      ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni wceq wo wb vx wal cF ccnv vy
      cv cima cJ wcel cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy cv cima
      c0 wceq cF ccnv vy cv cima cJ cuni wceq wo wb wi cX cY cF wfo cF cJ cK
      ccn co wcel cF ccnv cvv wcel cF ccnv vy cv cima cvv wcel vx cv cJ wcel vx
      cv cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni wceq wo wb vx wal cF
      ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy
      cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo wb wi cF cJ cK ccn co
      cnvexg cF ccnv vy cv cvv imaexg vx cv cJ wcel vx cv cJ ccld cfv wcel wa
      vx cv c0 wceq vx cv cJ cuni wceq wo wb cF ccnv vy cv cima cJ wcel cF ccnv
      vy cv cima cJ ccld cfv wcel wa cF ccnv vy cv cima c0 wceq cF ccnv vy cv
      cima cJ cuni wceq wo wb vx cF ccnv vy cv cima cvv vx cv cF ccnv vy cv
      cima wceq vx cv cJ wcel vx cv cJ ccld cfv wcel wa cF ccnv vy cv cima cJ
      wcel cF ccnv vy cv cima cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni
      wceq wo cF ccnv vy cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo vx
      cv cF ccnv vy cv cima wceq vx cv cJ wcel cF ccnv vy cv cima cJ wcel vx cv
      cJ ccld cfv wcel cF ccnv vy cv cima cJ ccld cfv wcel vx cv cF ccnv vy cv
      cima cJ eleq1 vx cv cF ccnv vy cv cima cJ ccld cfv eleq1 anbi12d vx cv cF
      ccnv vy cv cima wceq vx cv c0 wceq cF ccnv vy cv cima c0 wceq vx cv cJ
      cuni wceq cF ccnv vy cv cima cJ cuni wceq vx cv cF ccnv vy cv cima c0
      eqeq1 vx cv cF ccnv vy cv cima cJ cuni eqeq1 orbi12d bibi12d cla4gv 3syl
      adantl ad2antlr cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa vy cv cK wcel vy cv cK ccld cfv wcel wa wa cF ccnv vy cv cima
      cJ wcel cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy cv cima c0 wceq
      cF ccnv vy cv cima cJ cuni wceq wo wi vy cv c0 wceq vy cv cK cuni wceq wo
      cF ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv
      vy cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo wb cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv
      cK ccld cfv wcel wa wa cF ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ
      ccld cfv wcel cF ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ ccld cfv
      wcel wa cF ccnv vy cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo wi
      vy cv c0 wceq vy cv cK cuni wceq wo wi cJ ctop wcel cK ctop wcel wa cX cY
      cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel cF ccnv vy cv cima cJ
      wcel vy cv cK ccld cfv wcel cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co
      wcel vy cv cK wcel cF ccnv vy cv cima cJ wcel cX cY cF wfo cJ ctop wcel
      cK ctop wcel wa cF cJ cK ccn co wcel wa vy cv cK wcel cF ccnv vy cv cima
      cJ wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel vy cv cK wcel cF
      ccnv vy cv cima cJ wcel wi cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel
      w3a vy cv cK wcel cF ccnv vy cv cima cJ wcel vy cv cF cJ cK cnima ex
      3expa imp adantlrl adantrr cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF
      cJ cK ccn co wcel wa wa vy cv cK ccld cfv wcel cF ccnv vy cv cima cJ ccld
      cfv wcel vy cv cK wcel cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel
      vy cv cK ccld cfv wcel cF ccnv vy cv cima cJ ccld cfv wcel cX cY cF wfo
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel wa vy cv cK ccld cfv
      wcel cF ccnv vy cv cima cJ ccld cfv wcel cJ ctop wcel cK ctop wcel cF cJ
      cK ccn co wcel vy cv cK ccld cfv wcel cF ccnv vy cv cima cJ ccld cfv wcel
      wi cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a vy cv cK ccld cfv
      wcel cF ccnv vy cv cima cJ ccld cfv wcel vy cv cF cJ cK cnclima ex 3expa
      imp adantlrl adantrl cF ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ
      ccld cfv wcel wa cF ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ ccld
      cfv wcel wa cF ccnv vy cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo
      wi cF ccnv vy cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK
      wcel vy cv cK ccld cfv wcel wa wa vy cv c0 wceq vy cv cK cuni wceq wo cF
      ccnv vy cv cima cJ wcel cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy
      cv cima c0 wceq cF ccnv vy cv cima cJ cuni wceq wo pm2.27 cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv
      cK ccld cfv wcel wa wa cF ccnv vy cv cima c0 wceq vy cv c0 wceq cF ccnv
      vy cv cima cJ cuni wceq vy cv cK cuni wceq cJ ctop wcel cK ctop wcel wa
      cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv cK ccld cfv
      wcel wa wa cF ccnv vy cv cima c0 wceq vy cv c0 wceq cJ ctop wcel cK ctop
      wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv cK
      ccld cfv wcel wa wa cF ccnv vy cv cima c0 wceq vy cv cF cF ccnv vy cv
      cima cima c0 cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa vy cv cK wcel vy cv cF cF ccnv vy cv cima cima wceq vy cv cK
      ccld cfv wcel cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa vy cv cK wcel vy cv cY wss vy cv cF cF ccnv vy cv cima cima
      wceq cJ ctop wcel cK ctop wcel wa vy cv cK wcel vy cv cY wss cX cY cF wfo
      cF cJ cK ccn co wcel wa cK ctop wcel vy cv cK wcel vy cv cY wss cJ ctop
      wcel vy cv cK cY cnconn.2 eltopss adantll adantlr cX cY cF wfo cF cJ cK
      ccn co wcel wa vy cv cY wss vy cv cF cF ccnv vy cv cima cima wceq cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo vy cv cY wss vy cv cF cF ccnv vy cv
      cima cima wceq cF cJ cK ccn co wcel cX cY cF wfo vy cv cY wss wa cF cF
      ccnv vy cv cima cima vy cv cX cY vy cv cF foimacnv eqcomd adantlr adantll
      syldan adantrr cF ccnv vy cv cima c0 wceq cF cF ccnv vy cv cima cima cF
      c0 cima c0 cF ccnv vy cv cima c0 cF imaeq2 cF ima0 syl6eq sylan9eq ex cJ
      ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv
      cK wcel vy cv cK ccld cfv wcel wa wa cF ccnv vy cv cima cJ cuni wceq vy
      cv cK cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa vy cv cK wcel vy cv cK ccld cfv wcel wa wa cF ccnv vy cv cima
      cJ cuni wceq wa cF cF ccnv vy cv cima cima cF cX cima vy cv cK cuni cF
      ccnv vy cv cima cJ cuni wceq cF cF ccnv vy cv cima cima cF cX cima wceq
      cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy
      cv cK wcel vy cv cK ccld cfv wcel wa wa cF ccnv vy cv cima cJ cuni wceq
      cF ccnv vy cv cima cX wceq cF cF ccnv vy cv cima cima cF cX cima wceq cX
      cJ cuni cF ccnv vy cv cima cnconn.1 eqeq2i cF ccnv vy cv cima cX cF
      imaeq2 sylbir adantl cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK
      ccn co wcel wa wa vy cv cK wcel vy cv cK ccld cfv wcel wa wa cF cF ccnv
      vy cv cima cima vy cv wceq cF ccnv vy cv cima cJ cuni wceq cJ ctop wcel
      cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel cF
      cF ccnv vy cv cima cima vy cv wceq vy cv cK ccld cfv wcel cJ ctop wcel cK
      ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv cK wcel vy cv
      cY wss cF cF ccnv vy cv cima cima vy cv wceq cJ ctop wcel cK ctop wcel wa
      vy cv cK wcel vy cv cY wss cX cY cF wfo cF cJ cK ccn co wcel wa cK ctop
      wcel vy cv cK wcel vy cv cY wss cJ ctop wcel vy cv cK cY cnconn.2 eltopss
      adantll adantlr cX cY cF wfo cF cJ cK ccn co wcel wa vy cv cY wss cF cF
      ccnv vy cv cima cima vy cv wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo
      vy cv cY wss cF cF ccnv vy cv cima cima vy cv wceq cF cJ cK ccn co wcel
      cX cY vy cv cF foimacnv adantlr adantll syldan adantrr adantr cJ ctop
      wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa cF cX cima
      cK cuni wceq vy cv cK wcel vy cv cK ccld cfv wcel wa cF ccnv vy cv cima
      cJ cuni wceq cJ ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co
      wcel wa wa cF cX cima cY cK cuni cX cY cF wfo cF cX cima cY wceq cJ ctop
      wcel cK ctop wcel wa cF cJ cK ccn co wcel cX cY cF foima ad2antrl
      cnconn.2 syl6eq ad2antrr 3eqtr3d ex orim12d syl9r mp2and cF ccnv vy cv
      cima cJ wcel cF ccnv vy cv cima cJ ccld cfv wcel wa cF ccnv vy cv cima c0
      wceq cF ccnv vy cv cima cJ cuni wceq wo bi1 syl5 syld ex com23 imp cJ
      ctop wcel cK ctop wcel wa cX cY cF wfo cF cJ cK ccn co wcel wa wa vy cv
      c0 wceq vy cv cK cuni wceq wo vy cv cK wcel vy cv cK ccld cfv wcel wa wi
      vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0 wceq vx cv cJ cuni wceq
      wo wb vx wal cK ctop wcel vy cv c0 wceq vy cv cK cuni wceq wo vy cv cK
      wcel vy cv cK ccld cfv wcel wa wi cJ ctop wcel cX cY cF wfo cF cJ cK ccn
      co wcel wa cK ctop wcel vy cv c0 wceq vy cv cK wcel vy cv cK ccld cfv
      wcel wa vy cv cK cuni wceq cK ctop wcel vy cv c0 wceq vy cv cK wcel vy cv
      cK ccld cfv wcel vy cv c0 wceq vy cv cK wcel c0 cK wcel cK ctop wcel vy
      cv c0 cK eleq1 cK 0opn syl5cbir vy cv c0 wceq vy cv cK ccld cfv wcel c0
      cK ccld cfv wcel cK ctop wcel vy cv c0 cK ccld cfv eleq1 cK 0cld syl5cbir
      jcad cK ctop wcel vy cv cK cuni wceq vy cv cK wcel vy cv cK ccld cfv wcel
      vy cv cK cuni wceq vy cv cK wcel cK cuni cK wcel cK ctop wcel vy cv cK
      cuni cK eleq1 cK cK cuni cK cuni eqid topopn syl5cbir vy cv cK cuni wceq
      vy cv cK ccld cfv wcel cK cuni cK ccld cfv wcel cK ctop wcel vy cv cK
      cuni cK ccld cfv eleq1 cK cK cuni cK cuni eqid topcld syl5cbir jcad jaod
      ad2antlr adantr impbid ex 19.21adv vx cv cJ cJ ccld cfv cin wcel vx cv c0
      cJ cuni cpr wcel wb vx cv cJ wcel vx cv cJ ccld cfv wcel wa vx cv c0 wceq
      vx cv cJ cuni wceq wo wb vx vx cv cJ cJ ccld cfv cin wcel vx cv cJ wcel
      vx cv cJ ccld cfv wcel wa vx cv c0 cJ cuni cpr wcel vx cv c0 wceq vx cv
      cJ cuni wceq wo vx cv cJ cJ ccld cfv elin vx cv c0 cJ cuni vx visset elpr
      bibi12i albii vy cv cK cK ccld cfv cin wcel vy cv c0 cK cuni cpr wcel wb
      vy cv cK wcel vy cv cK ccld cfv wcel wa vy cv c0 wceq vy cv cK cuni wceq
      wo wb vy vy cv cK cK ccld cfv cin wcel vy cv cK wcel vy cv cK ccld cfv
      wcel wa vy cv c0 cK cuni cpr wcel vy cv c0 wceq vy cv cK cuni wceq wo vy
      cv cK cK ccld cfv elin vy cv c0 cK cuni vy visset elpr bibi12i albii
      3imtr4g vx cJ cJ ccld cfv cin c0 cJ cuni cpr dfcleq vy cK cK ccld cfv cin
      c0 cK cuni cpr dfcleq 3imtr4g exp43 com4l imp5d cJ iscon2 syl5ib exp31
      com4r imp43 jca cK iscon2 sylibr $.
      $( [12-Jul-2009] $) $( [12-Jul-2009] $)
  $}

  ${
    $d f J $. $d f K $.
    $( Connectedness is a topological property. $)
    conntoppr $p |- ( ( J e. Top /\ K e. Top /\ J ~= K ) -> ( J e. Con <-> K e.
    Con ) ) $=
      cJ ctop wcel cK ctop wcel cJ cK chomeo wbr cJ ccon wcel cK ccon wcel wb
      cJ ctop wcel cK ctop wcel wa cJ cK chomeo wbr vf cv cJ cK chomeosm co
      wcel vf wex cJ ccon wcel cK ccon wcel wb vf cJ cK hmph cJ ctop wcel cK
      ctop wcel wa vf cv cJ cK chomeosm co wcel cJ ccon wcel cK ccon wcel wb vf
      cJ ctop wcel cK ctop wcel wa vf cv cJ cK chomeosm co wcel cJ cuni cK cuni
      vf cv wf1o vf cv cJ cK ccn co wcel vf cv ccnv cK cJ ccn co wcel w3a cJ
      ccon wcel cK ccon wcel wb cJ ctop wcel cK ctop wcel vf cv cvv wcel vf cv
      cJ cK chomeosm co wcel cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel
      vf cv ccnv cK cJ ccn co wcel w3a wb vf visset cvv vf cv cJ cK cJ cuni cK
      cuni cJ cuni eqid cK cuni eqid hmeobc mp3an3 cJ ctop wcel cK ctop wcel wa
      cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel vf cv ccnv cK cJ ccn
      co wcel w3a cJ ccon wcel cK ccon wcel wb cJ ctop wcel cK ctop wcel wa cJ
      cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel vf cv ccnv cK cJ ccn co
      wcel w3a wa cJ ccon wcel cK ccon wcel cJ ctop wcel cK ctop wcel wa cJ
      cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel cJ ccon wcel cK ccon wcel
      wi vf cv ccnv cK cJ ccn co wcel cK ctop wcel cJ cuni cK cuni vf cv wf1o
      vf cv cJ cK ccn co wcel wa cJ ccon wcel cK ccon wcel wi cJ ctop wcel cK
      ctop wcel cJ cuni cK cuni vf cv wf1o vf cv cJ cK ccn co wcel cJ ccon wcel
      cK ccon wcel wi cK ctop wcel cJ cuni cK cuni vf cv wfo vf cv cJ cK ccn co
      wcel cJ ccon wcel cK ccon wcel wi wi cJ cuni cK cuni vf cv wf1o cJ ccon
      wcel cK ctop wcel cJ cuni cK cuni vf cv wfo vf cv cJ cK ccn co wcel cK
      ccon wcel cJ ccon wcel cK ctop wcel cJ cuni cK cuni vf cv wfo vf cv cJ cK
      ccn co wcel cK ccon wcel vf cv cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni
      eqid cnconn exp43 com4l cJ cuni cK cuni vf cv f1ofo syl5 imp32 adantll
      3adantr3 cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni vf cv wf1o vf cv
      ccnv cK cJ ccn co wcel cK ccon wcel cJ ccon wcel wi vf cv cJ cK ccn co
      wcel cJ ctop wcel cJ cuni cK cuni vf cv wf1o vf cv ccnv cK cJ ccn co wcel
      wa cK ccon wcel cJ ccon wcel wi cK ctop wcel cJ ctop wcel cJ cuni cK cuni
      vf cv wf1o vf cv ccnv cK cJ ccn co wcel cK ccon wcel cJ ccon wcel wi cJ
      ctop wcel cK cuni cJ cuni vf cv ccnv wfo vf cv ccnv cK cJ ccn co wcel cK
      ccon wcel cJ ccon wcel wi wi cJ cuni cK cuni vf cv wf1o cK ccon wcel cJ
      ctop wcel cK cuni cJ cuni vf cv ccnv wfo vf cv ccnv cK cJ ccn co wcel cJ
      ccon wcel cK ccon wcel cJ ctop wcel cK cuni cJ cuni vf cv ccnv wfo vf cv
      ccnv cK cJ ccn co wcel cJ ccon wcel vf cv ccnv cK cJ cK cuni cJ cuni cK
      cuni eqid cJ cuni eqid cnconn exp43 com4l cJ cuni cK cuni vf cv wf1o cK
      cuni cJ cuni vf cv ccnv wf1o cK cuni cJ cuni vf cv ccnv wfo cJ cuni cK
      cuni vf cv f1ocnv cK cuni cJ cuni vf cv ccnv f1ofo syl syl5 imp32 adantlr
      3adantr2 impbid ex sylbid 19.23adv sylbid 3impia $.
      $( [3-Jul-2009] $) $( [3-Jul-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Subspaces of metric space topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Topology of the real numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d s t x y z A $.
  $( Lemma for ~ reconn . Connectedness in the reals-easy direction. $)
  reconnlem1 $p |- ( ( A C_ RR /\ ( subSp ` <. A , ( topGen ` ran (,) ) >. ) e.
   Con ) -> A. x e. A A. y e. A ( x [,] y ) C_ A ) $=
    cA cr wss cA cioo crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc co
    cA wss vy cA wral vx cA wral cA cr wss cA cioo crn ctg cfv cop csubsp cfv
    ccon wcel vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA
    cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn ctg cfv wral vs cioo
    crn ctg cfv wral vx cv vy cv cicc co cA wss vy cA wral vx cA wral cioo crn
    ctg cfv ctop wcel cA cr wss cA cioo crn ctg cfv cop csubsp cfv ccon wcel vs
    cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA
    vs cv vt cv cun wss wn wi vt cioo crn ctg cfv wral vs cioo crn ctg cfv wral
    wb retop vs vt cA cioo crn ctg cfv cr cioo crn ctg cfv cuni cr uniretop
    eqcomi connsub mpan cA cr wss vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv
    vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn ctg
    cfv wral vs cioo crn ctg cfv wral vx cv vy cv cicc co cA wss vx vy cA cA cA
    cr wss vx cv cA wcel vy cv cA wcel wa wa vs cv cA cin c0 wne vt cv cA cin
    c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt
    cioo crn ctg cfv wral vs cioo crn ctg cfv wral vx cv vy cv cicc co cA wss
    cA cr wss vx cv cA wcel vy cv cA wcel wa wa vs cv cA cin c0 wne vt cv cA
    cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi
    vt cioo crn ctg cfv wral vs cioo crn ctg cfv wral wa vz vx cv vy cv cicc co
    cA cA cr wss vx cv cA wcel vy cv cA wcel wa wa vs cv cA cin c0 wne vt cv cA
    cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi
    vt cioo crn ctg cfv wral vs cioo crn ctg cfv wral wa vz cv vx cv vy cv cicc
    co wcel vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA
    wcel vx cv cxr wcel vy cv cxr wcel vz cv vx cv vy cv cicc co wcel vz cv cxr
    wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a wb cA cr wss vx cv cA wcel
    vy cv cA wcel wa wa vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin
    cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn ctg cfv wral vs
    cioo crn ctg cfv wral wa vx cv vy cv vz cv elicc1 cA cr wss vx cv cA wcel
    vy cv cA wcel wa wa vx cv cxr wcel vs cv cA cin c0 wne vt cv cA cin c0 wne
    vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn
    ctg cfv wral vs cioo crn ctg cfv wral cA cr wss vx cv cA wcel vx cv cxr
    wcel vy cv cA wcel cA cr wss vx cv cA wcel wa vx cv cr wcel vx cv cxr wcel
    cA cr vx cv ssel2 vx cv rexr syl adantrr adantr cA cr wss vx cv cA wcel vy
    cv cA wcel wa wa vy cv cxr wcel vs cv cA cin c0 wne vt cv cA cin c0 wne vs
    cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn
    ctg cfv wral vs cioo crn ctg cfv wral cA cr wss vy cv cA wcel vy cv cxr
    wcel vx cv cA wcel cA cr wss vy cv cA wcel wa vy cv cr wcel vy cv cxr wcel
    cA cr vy cv ssel2 vy cv rexr syl adantrl adantr sylanc cA cr wss vx cv cA
    wcel vy cv cA wcel wa wa vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt
    cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn ctg cfv
    wral vs cioo crn ctg cfv wral vz cv cxr wcel vx cv vz cv cle wbr vz cv vy
    cv cle wbr w3a vz cv cA wcel wi cA cr wss vx cv cA wcel vy cv cA wcel wa wa
    vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wi
    vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a
    cA vs cv vt cv cun wss wn wi vt cioo crn ctg cfv wral vs cioo crn ctg cfv
    wral cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv
    cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa vs cv cA cin c0 wne vt
    cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss
    wn wi vt cioo crn ctg cfv wral vs cioo crn ctg cfv wral wn vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wi wn cA cr wss
    vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv
    vy cv cle wbr w3a vz cv cA wcel wn wa vs cv cA cin c0 wne vt cv cA cin c0
    wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wa vt cioo
    crn ctg cfv wrex vs cioo crn ctg cfv wrex vs cv cA cin c0 wne vt cv cA cin
    c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt
    cioo crn ctg cfv wral vs cioo crn ctg cfv wral wn cA cr wss vx cv cA wcel
    vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr
    w3a vz cv cA wcel wn wa vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv
    cin cr cA cdif wss w3a cA vs cv vt cv cun wss wa vt cioo crn ctg cfv wrex
    vs cioo crn ctg cfv wrex cmnf vz cv cioo co cA cin c0 wne vz cv cpnf cioo
    co cA cin c0 wne cmnf vz cv cioo co vz cv cpnf cioo co cin cr cA cdif wss
    w3a cA cmnf vz cv cioo co vz cv cpnf cioo co cun wss vs cv cA cin c0 wne vt
    cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss
    wa vt cioo crn ctg cfv wrex vs cioo crn ctg cfv wrex cA cr wss vx cv cA
    wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle
    wbr w3a vz cv cA wcel wn wa wa cmnf vz cv cioo co cioo crn ctg cfv wcel vz
    cv cpnf cioo co cioo crn ctg cfv wcel cmnf vz cv cioo co cA cin c0 wne vz
    cv cpnf cioo co cA cin c0 wne cmnf vz cv cioo co vz cv cpnf cioo co cin cr
    cA cdif wss w3a cA cmnf vz cv cioo co vz cv cpnf cioo co cun wss wa vs cv
    cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs
    cv vt cv cun wss wa vt cioo crn ctg cfv wrex vs cioo crn ctg cfv wrex cmnf
    vz cv iooretop vz cv cpnf iooretop vs cv cA cin c0 wne vt cv cA cin c0 wne
    vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wa cmnf vz cv
    cioo co cA cin c0 wne vz cv cpnf cioo co cA cin c0 wne cmnf vz cv cioo co
    vz cv cpnf cioo co cin cr cA cdif wss w3a cA cmnf vz cv cioo co vz cv cpnf
    cioo co cun wss wa cmnf vz cv cioo co cA cin c0 wne vt cv cA cin c0 wne
    cmnf vz cv cioo co vt cv cin cr cA cdif wss w3a cA cmnf vz cv cioo co vt cv
    cun wss wa vs vt cmnf vz cv cioo co vz cv cpnf cioo co cioo crn ctg cfv
    cioo crn ctg cfv vs cv cmnf vz cv cioo co wceq vs cv cA cin c0 wne vt cv cA
    cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cmnf vz cv cioo co cA cin c0
    wne vt cv cA cin c0 wne cmnf vz cv cioo co vt cv cin cr cA cdif wss w3a cA
    vs cv vt cv cun wss cA cmnf vz cv cioo co vt cv cun wss vs cv cmnf vz cv
    cioo co wceq vs cv cA cin c0 wne cmnf vz cv cioo co cA cin c0 wne vs cv vt
    cv cin cr cA cdif wss cmnf vz cv cioo co vt cv cin cr cA cdif wss vt cv cA
    cin c0 wne vs cv cmnf vz cv cioo co wceq vs cv cA cin cmnf vz cv cioo co cA
    cin c0 vs cv cmnf vz cv cioo co cA ineq1 neeq1d vs cv cmnf vz cv cioo co
    wceq vs cv vt cv cin cmnf vz cv cioo co vt cv cin cr cA cdif vs cv cmnf vz
    cv cioo co vt cv ineq1 sseq1d 3anbi13d vs cv cmnf vz cv cioo co wceq vs cv
    vt cv cun cmnf vz cv cioo co vt cv cun cA vs cv cmnf vz cv cioo co vt cv
    uneq1 sseq2d anbi12d vt cv vz cv cpnf cioo co wceq cmnf vz cv cioo co cA
    cin c0 wne vt cv cA cin c0 wne cmnf vz cv cioo co vt cv cin cr cA cdif wss
    w3a cmnf vz cv cioo co cA cin c0 wne vz cv cpnf cioo co cA cin c0 wne cmnf
    vz cv cioo co vz cv cpnf cioo co cin cr cA cdif wss w3a cA cmnf vz cv cioo
    co vt cv cun wss cA cmnf vz cv cioo co vz cv cpnf cioo co cun wss vt cv vz
    cv cpnf cioo co wceq vt cv cA cin c0 wne vz cv cpnf cioo co cA cin c0 wne
    cmnf vz cv cioo co vt cv cin cr cA cdif wss cmnf vz cv cioo co vz cv cpnf
    cioo co cin cr cA cdif wss cmnf vz cv cioo co cA cin c0 wne vt cv vz cv
    cpnf cioo co wceq vt cv cA cin vz cv cpnf cioo co cA cin c0 vt cv vz cv
    cpnf cioo co cA ineq1 neeq1d vt cv vz cv cpnf cioo co wceq cmnf vz cv cioo
    co vt cv cin cmnf vz cv cioo co vz cv cpnf cioo co cin cr cA cdif vt cv vz
    cv cpnf cioo co cmnf vz cv cioo co ineq2 sseq1d 3anbi23d vt cv vz cv cpnf
    cioo co wceq cmnf vz cv cioo co vt cv cun cmnf vz cv cioo co vz cv cpnf
    cioo co cun cA vt cv vz cv cpnf cioo co cmnf vz cv cioo co uneq2 sseq2d
    anbi12d rcla42ev mp3an12 cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv
    cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa
    cmnf vz cv cioo co cA cin c0 wne vz cv cpnf cioo co cA cin c0 wne cmnf vz
    cv cioo co vz cv cpnf cioo co cin cr cA cdif wss cA cr wss vx cv cA wcel vy
    cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a
    vz cv cA wcel wn wa wa vx cv cmnf vz cv cioo co cA cin wcel cmnf vz cv cioo
    co cA cin c0 wne cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vx cv
    cmnf vz cv cioo co wcel vx cv cA wcel wa vx cv cmnf vz cv cioo co cA cin
    wcel cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv
    cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vx cv cmnf vz cv
    cioo co wcel vx cv cA wcel cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz
    cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa
    wa vx cv cmnf vz cv cioo co wcel vx cv cr wcel cmnf vx cv clt wbr vx cv vz
    cv clt wbr w3a cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vx cv cr
    wcel cmnf vx cv clt wbr vx cv vz cv clt wbr cA cr wss vx cv cA wcel vy cv
    cA wcel wa wa vx cv cr wcel vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv
    cle wbr w3a vz cv cA wcel wn wa cA cr wss vx cv cA wcel vx cv cr wcel vy cv
    cA wcel cA cr vx cv ssel2 adantrr adantr cA cr wss vx cv cA wcel vy cv cA
    wcel wa wa cmnf vx cv clt wbr vz cv cxr wcel vx cv vz cv cle wbr vz cv vy
    cv cle wbr w3a vz cv cA wcel wn wa cA cr wss vx cv cA wcel cmnf vx cv clt
    wbr vy cv cA wcel cA cr wss vx cv cA wcel wa vx cv cr wcel cmnf vx cv clt
    wbr cA cr vx cv ssel2 vx cv mnflt syl adantrr adantr cA cr wss vx cv cA
    wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle
    wbr w3a vz cv cA wcel wn wa wa vx cv vz cv clt wbr vz cv vx cv wne vx cv cA
    wcel vy cv cA wcel wa vz cv cA wcel wn vz cv vx cv wne cA cr wss vz cv cxr
    wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vx cv cA wcel vz cv cA
    wcel wn vz cv vx cv wne vy cv cA wcel vx cv cA wcel vz cv cA wcel wn wa vx
    cv vz cv wceq wn vz cv vx cv wne vx cv vz cv cA nelneq vx cv vz cv wceq vz
    cv vx cv vz cv vx cv eqcom necon3abii sylibr adantlr ad2ant2l vx cv cxr
    wcel vz cv cxr wcel vx cv vz cv cle wbr vx cv vz cv clt wbr vz cv vx cv wne
    wb cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv
    cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vx cv vz cv xrleltne
    cA cr wss vx cv cA wcel vy cv cA wcel wa wa vx cv cxr wcel vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa cA cr wss
    vx cv cA wcel vx cv cxr wcel vy cv cA wcel cA cr wss vx cv cA wcel wa vx cv
    cr wcel vx cv cxr wcel cA cr vx cv ssel2 vx cv rexr syl adantrr adantr vz
    cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cxr wcel cA
    cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv cxr wcel vx
    cv vz cv cle wbr vz cv vy cv cle wbr 3simp1 ad2antrl vz cv cxr wcel vx cv
    vz cv cle wbr vz cv vy cv cle wbr w3a vx cv vz cv cle wbr cA cr wss vx cv
    cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv cxr wcel vx cv vz cv cle
    wbr vz cv vy cv cle wbr 3simp2 ad2antrl syl3anc mpbird 3jca cA cr wss vx cv
    cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv
    cle wbr w3a vz cv cA wcel wn wa wa vz cv cxr wcel vx cv cmnf vz cv cioo co
    wcel vx cv cr wcel cmnf vx cv clt wbr vx cv vz cv clt wbr w3a wb vz cv cxr
    wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cxr wcel cA cr wss
    vx cv cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv cxr wcel vx cv vz
    cv cle wbr vz cv vy cv cle wbr 3simp1 ad2antrl cmnf cxr wcel vz cv cxr wcel
    vx cv cmnf vz cv cioo co wcel vx cv cr wcel cmnf vx cv clt wbr vx cv vz cv
    clt wbr w3a wb mnfxr cmnf vz cv vx cv elioo2 mpan syl mpbird cA cr wss vx
    cv cA wcel vy cv cA wcel vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle
    wbr w3a vz cv cA wcel wn wa simplrl jca vx cv cmnf vz cv cioo co cA elin
    sylibr cmnf vz cv cioo co cA cin vx cv ne0i syl cA cr wss vx cv cA wcel vy
    cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a
    vz cv cA wcel wn wa wa vy cv vz cv cpnf cioo co cA cin wcel vz cv cpnf cioo
    co cA cin c0 wne cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vy cv vz
    cv cpnf cioo co wcel vy cv cA wcel wa vy cv vz cv cpnf cioo co cA cin wcel
    cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle
    wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vy cv vz cv cpnf cioo co
    wcel vy cv cA wcel cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr
    wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vy
    cv vz cv cpnf cioo co wcel vy cv cr wcel vz cv vy cv clt wbr vy cv cpnf clt
    wbr w3a cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz
    cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vy cv cr wcel vz
    cv vy cv clt wbr vy cv cpnf clt wbr cA cr wss vx cv cA wcel vy cv cA wcel
    wa wa vy cv cr wcel vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr
    w3a vz cv cA wcel wn wa cA cr wss vy cv cA wcel vy cv cr wcel vx cv cA wcel
    cA cr vy cv ssel2 adantrl adantr cA cr wss vx cv cA wcel vy cv cA wcel wa
    wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel
    wn wa wa vz cv vy cv clt wbr vy cv vz cv wne vx cv cA wcel vy cv cA wcel wa
    vz cv cA wcel wn vy cv vz cv wne cA cr wss vz cv cxr wcel vx cv vz cv cle
    wbr vz cv vy cv cle wbr w3a vy cv cA wcel vz cv cA wcel wn vy cv vz cv wne
    vx cv cA wcel vy cv cA wcel vz cv cA wcel wn wa vy cv vz cv wceq wn vy cv
    vz cv wne vy cv vz cv cA nelneq vy cv vz cv df-ne sylibr adantll ad2ant2l
    vz cv cxr wcel vy cv cxr wcel vz cv vy cv cle wbr vz cv vy cv clt wbr vy cv
    vz cv wne wb cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx
    cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vz cv vy cv
    xrleltne vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv
    cxr wcel cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv
    cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr 3simp1 ad2antrl cA cr wss
    vx cv cA wcel vy cv cA wcel wa wa vy cv cxr wcel vz cv cxr wcel vx cv vz cv
    cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa cA cr wss vy cv cA wcel
    vy cv cxr wcel vx cv cA wcel cA cr wss vy cv cA wcel wa vy cv cr wcel vy cv
    cxr wcel cA cr vy cv ssel2 vy cv rexr syl adantrl adantr vz cv cxr wcel vx
    cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv vy cv cle wbr cA cr wss vx
    cv cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv cxr wcel vx cv vz cv
    cle wbr vz cv vy cv cle wbr 3simp3 ad2antrl syl3anc mpbird cA cr wss vx cv
    cA wcel vy cv cA wcel wa wa vy cv cpnf clt wbr vz cv cxr wcel vx cv vz cv
    cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa cA cr wss vy cv cA wcel
    vy cv cpnf clt wbr vx cv cA wcel cA cr wss vy cv cA wcel wa vy cv cr wcel
    vy cv cpnf clt wbr cA cr vy cv ssel2 vy cv ltpnf syl adantrl adantr 3jca cA
    cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr
    vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa vz cv cxr wcel vy cv vz cv
    cpnf cioo co wcel vy cv cr wcel vz cv vy cv clt wbr vy cv cpnf clt wbr w3a
    wb vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cxr
    wcel cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv cxr
    wcel vx cv vz cv cle wbr vz cv vy cv cle wbr 3simp1 ad2antrl vz cv cxr wcel
    cpnf cxr wcel vy cv vz cv cpnf cioo co wcel vy cv cr wcel vz cv vy cv clt
    wbr vy cv cpnf clt wbr w3a wb pnfxr vz cv cpnf vy cv elioo2 mpan2 syl
    mpbird cA cr wss vx cv cA wcel vy cv cA wcel vz cv cxr wcel vx cv vz cv cle
    wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa simplrr jca vy cv vz cv
    cpnf cioo co cA elin sylibr vz cv cpnf cioo co cA cin vy cv ne0i syl cA cr
    wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz
    cv vy cv cle wbr w3a vz cv cA wcel wn wa wa cmnf vz cv cioo co vz cv cpnf
    cioo co cin c0 cr cA cdif vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv
    cle wbr w3a cmnf vz cv cioo co vz cv cpnf cioo co cin c0 wceq cA cr wss vx
    cv cA wcel vy cv cA wcel wa wa vz cv cA wcel wn vz cv cxr wcel vx cv vz cv
    cle wbr cmnf vz cv cioo co vz cv cpnf cioo co cin c0 wceq vz cv vy cv cle
    wbr cmnf cxr wcel vz cv cxr wcel wa vz cv cxr wcel cpnf cxr wcel wa vz cv
    vz cv cle wbr cmnf vz cv cioo co vz cv cpnf cioo co cin c0 wceq vz cv cxr
    wcel vz cv cxr wcel cmnf cxr wcel mnfxr jctl vz cv cxr wcel cpnf cxr wcel
    pnfxr jctr vz cv xrleid cmnf vz cv vz cv cpnf ioodisj sylan31c 3ad2ant1
    ad2antrl c0 cr cA cdif wss cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz
    cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa
    wa cr cA cdif 0ss a1i eqsstrd 3jca cA cr wss vx cv cA wcel vy cv cA wcel wa
    wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel
    wn wa wa cA cr vz cv vz cv cicc co cdif cmnf vz cv cioo co vz cv cpnf cioo
    co cun cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz
    cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa cA vz cv vz cv
    cicc co cin c0 wceq cA cr vz cv vz cv cicc co cdif wss cA cr wss vx cv cA
    wcel vy cv cA wcel wa wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle
    wbr w3a vz cv cA wcel wn wa wa cA vz cv vz cv cicc co cin cA vz cv csn cin
    c0 vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a cA vz cv vz
    cv cicc co cin cA vz cv csn cin wceq cA cr wss vx cv cA wcel vy cv cA wcel
    wa wa vz cv cA wcel wn vz cv cxr wcel vx cv vz cv cle wbr cA vz cv vz cv
    cicc co cin cA vz cv csn cin wceq vz cv vy cv cle wbr vz cv cxr wcel vz cv
    vz cv cicc co vz cv csn cA vz cv ccid ineq2d 3ad2ant1 ad2antrl vz cv cA
    wcel wn cA vz cv csn cin c0 wceq cA cr wss vx cv cA wcel vy cv cA wcel wa
    wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a cA vz cv csn
    cin c0 wceq vz cv cA wcel wn cA vz cv disjsn biimpri ad2antll eqtrd cA cr
    wss cA vz cv vz cv cicc co cin c0 wceq cA cr vz cv vz cv cicc co cdif wss
    wb vx cv cA wcel vy cv cA wcel wa vz cv cxr wcel vx cv vz cv cle wbr vz cv
    vy cv cle wbr w3a vz cv cA wcel wn wa cA vz cv vz cv cicc co cr reldisj
    ad2antrr mpbid cA cr wss vx cv cA wcel vy cv cA wcel wa wa vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa wa cr vz cv
    vz cv cicc co cdif cmnf vz cv cioo co vz cv cpnf cioo co cpr cuni cmnf vz
    cv cioo co vz cv cpnf cioo co cun cA cr wss vx cv cA wcel vy cv cA wcel wa
    wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel
    wn wa wa vz cv cr wcel cr vz cv vz cv cicc co cdif cmnf vz cv cioo co vz cv
    cpnf cioo co cpr cuni wceq vx cv cr wcel vy cv cr wcel wa vz cv cxr wcel vx
    cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA wcel wn wa vz cv cr wcel
    cA cr wss vx cv cA wcel vy cv cA wcel wa wa vx cv cr wcel vy cv cr wcel wa
    vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cr wcel vz
    cv cA wcel wn vx cv cr wcel vy cv cr wcel wa vz cv cxr wcel vx cv vz cv cle
    wbr vz cv vy cv cle wbr w3a wa vz cv cr wcel vz cv cpnf wceq vz cv cmnf
    wceq vx cv cr wcel vy cv cr wcel wa vz cv cxr wcel vx cv vz cv cle wbr vz
    cv vy cv cle wbr w3a wa vz cv cpnf wceq vz cv cpnf clt wbr wn vx cv cr wcel
    vy cv cr wcel wa vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a
    wa vz cv cpnf clt wbr vz cv cpnf clt wbr wn wn vy cv cr wcel vz cv cxr wcel
    vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cpnf clt wbr vx cv cr
    wcel vy cv cr wcel vz cv cxr wcel vz cv vy cv cle wbr vz cv cpnf clt wbr vx
    cv vz cv cle wbr vy cv cr wcel vz cv cxr wcel vz cv vy cv cle wbr vz cv
    cpnf clt wbr vy cv cr wcel vy cv cpnf clt wbr vz cv cxr wcel vz cv vy cv
    cle wbr vz cv cpnf clt wbr wi wi vy cv ltpnf vy cv cr wcel vz cv vy cv cle
    wbr vz cv cxr wcel vy cv cpnf clt wbr vz cv cpnf clt wbr vy cv cr wcel vz
    cv cxr wcel vz cv vy cv cle wbr vy cv cpnf clt wbr vz cv cpnf clt wbr wi vy
    cv cr wcel vy cv cxr wcel vz cv cxr wcel vz cv vy cv cle wbr vy cv cpnf clt
    wbr vz cv cpnf clt wbr wi wi wi vy cv rexr vy cv cxr wcel vz cv cxr wcel vz
    cv vy cv cle wbr vy cv cpnf clt wbr vz cv cpnf clt wbr vy cv cxr wcel vz cv
    cxr wcel cpnf cxr wcel vz cv vy cv cle wbr vy cv cpnf clt wbr wa vz cv cpnf
    clt wbr wi pnfxr vz cv cxr wcel vy cv cxr wcel cpnf cxr wcel vz cv vy cv
    cle wbr vy cv cpnf clt wbr wa vz cv cpnf clt wbr wi vz cv vy cv cpnf
    xrlelttr 3com12 mp3an3 exp4b syl com23 com24 mpd imp32 3adantr2 adantll vz
    cv cpnf clt wbr notnot sylib vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv
    cle wbr w3a vz cv cpnf wceq vz cv cpnf clt wbr wn wb vx cv cr wcel vy cv cr
    wcel wa vz cv cxr wcel vx cv vz cv cle wbr vz cv cpnf wceq vz cv cpnf clt
    wbr wn wb vz cv vy cv cle wbr vz cv nltpnft 3ad2ant1 adantl mtbird vx cv cr
    wcel vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cmnf
    wceq wn vy cv cr wcel vx cv cr wcel vz cv cxr wcel vx cv vz cv cle wbr vz
    cv cmnf wceq wn vz cv vy cv cle wbr vx cv cr wcel vz cv cxr wcel vx cv vz
    cv cle wbr vz cv cmnf wceq wn vx cv cxr wcel cmnf vx cv clt wbr vz cv cxr
    wcel vx cv vz cv cle wbr vz cv cmnf wceq wn wi wi vx cv cr wcel vx cv cxr
    wcel vz cv cxr wcel cmnf vx cv clt wbr vx cv vz cv cle wbr vz cv cmnf wceq
    wn wi vx cv cxr wcel vz cv cxr wcel cmnf vx cv clt wbr vx cv vz cv cle wbr
    vz cv cmnf wceq wn vx cv cxr wcel vz cv cxr wcel wa cmnf vx cv clt wbr vx
    cv vz cv cle wbr wa cmnf vz cv clt wbr vz cv cmnf wceq wn cmnf cxr wcel vx
    cv cxr wcel vz cv cxr wcel cmnf vx cv clt wbr vx cv vz cv cle wbr wa cmnf
    vz cv clt wbr wi mnfxr cmnf vx cv vz cv xrltletr mp3an1 vz cv cxr wcel cmnf
    vz cv clt wbr vz cv cmnf wceq wn wb vx cv cxr wcel vz cv cxr wcel vz cv
    cmnf wceq cmnf vz cv clt wbr vz cv ngtmnft con2bid adantl sylibd exp4b
    com23 vx cv rexr vx cv mnflt sylc imp32 3adantr3 adantlr vz cv cxr wcel vx
    cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cr wcel vz cv cpnf wceq vz
    cv cmnf wceq w3o vx cv cr wcel vy cv cr wcel wa vz cv cxr wcel vx cv vz cv
    cle wbr vz cv cr wcel vz cv cpnf wceq vz cv cmnf wceq w3o vz cv vy cv cle
    wbr vz cv cxr wcel vz cv cr wcel vz cv cpnf wceq vz cv cmnf wceq w3o vz cv
    elxr biimpi 3ad2ant1 adantl ecase23d adantrr cA cr wss vx cv cA wcel vy cv
    cA wcel wa wa vx cv cr wcel vy cv cr wcel cA cr wss vx cv cA wcel vx cv cr
    wcel vy cv cA wcel cA cr vx cv ssel2 adantrr cA cr wss vy cv cA wcel vy cv
    cr wcel vx cv cA wcel cA cr vy cv ssel2 adantrl jca sylan vz cv cr wcel cr
    vz cv vz cv cicc co cdif cmnf vz cv cioo co vz cv cpnf cioo co cpr cuni
    wceq vz cv vz cv cdrci anidms syl cmnf vz cv cioo co vz cv cpnf cioo co
    cmnf vz cv cioo oprex vz cv cpnf cioo oprex unipr syl6eq sseqtrd sylanc ex
    vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a
    cA vs cv vt cv cun wss wa vt cioo crn ctg cfv wrex vs cioo crn ctg cfv wrex
    vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a
    cA vs cv vt cv cun wss wn wi wn vt cioo crn ctg cfv wrex vs cioo crn ctg
    cfv wrex vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif
    wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn ctg cfv wral wn vs cioo
    crn ctg cfv wrex vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr
    cA cdif wss w3a cA vs cv vt cv cun wss wn wi vt cioo crn ctg cfv wral vs
    cioo crn ctg cfv wral wn vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt
    cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss wa vs cv cA cin c0 wne vt
    cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss
    wn wi wn vs vt cioo crn ctg cfv cioo crn ctg cfv vs cv cA cin c0 wne vt cv
    cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv cun wss
    df-an 2rexbii vs cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA
    cdif wss w3a cA vs cv vt cv cun wss wn wi wn vt cioo crn ctg cfv wrex vs cv
    cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs
    cv vt cv cun wss wn wi vt cioo crn ctg cfv wral wn vs cioo crn ctg cfv vs
    cv cA cin c0 wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA
    vs cv vt cv cun wss wn wi vt cioo crn ctg cfv rexnal rexbii vs cv cA cin c0
    wne vt cv cA cin c0 wne vs cv vt cv cin cr cA cdif wss w3a cA vs cv vt cv
    cun wss wn wi vt cioo crn ctg cfv wral vs cioo crn ctg cfv rexnal 3bitri
    syl6ib vz cv cxr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cA
    wcel pm4.61 syl5ib con4d imp sylbid ssrdv ex r19.21advva sylbid imp $.
    $( [13-Jul-2009] $) $( [13-Jul-2009] $)
  $}

  ${
    reconnlem2.1 $e |- ( ph <-> ( ( ( ( b e. ( u i^i A ) /\ c e. ( v i^i A ) /\
     ( u i^i v ) C_ ( RR \ A ) ) /\ ( A C_ RR /\ ( u e. ( topGen ` ran (,) ) /\
      v e. ( topGen ` ran (,) ) ) ) ) /\ b <_ c ) /\ ( b [,] c ) C_ A ) ) $.
    $( Lemma for ~ reconn . $)
    reconnlem2 $p |- ( ph -> ( b e. RR /\ c e. RR ) ) $=
      wph vb cv cr wcel vc cv cr wcel wph vu cv cA cin cr vb cv wph cA cr wss
      vu cv cA cin cr wss wph vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa cA cr wss reconnlem2.1 vb cv vu cv cA cin wcel vc cv vv
      cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa cA cr wss vb cv vc
      cv cle wbr vb cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa simprl ad2antrr sylbi vu cv
      cA cin cA wss cA cr wss vu cv cA cin cr wss vu cv cA inss2 vu cv cA cin
      cA cr sstr mpan syl wph vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa vb cv vu cv cA cin wcel reconnlem2.1 vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vu
      cv cA cin wcel vb cv vc cv cle wbr vb cv vc cv cicc co cA wss vb cv vu cv
      cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a vb
      cv vu cv cA cin wcel cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn
      ctg cfv wcel wa wa vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss 3simp1 adantr ad2antrr sylbi sseldd wph vv cv cA
      cin cr vc cv wph cA cr wss vv cv cA cin cr wss wph vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa cA cr wss reconnlem2.1 vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa cA cr wss vb cv vc cv cle wbr vb cv vc cv cicc co cA wss vb cv vu
      cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a
      cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      simprl ad2antrr sylbi vv cv cA cin cA wss cA cr wss vv cv cA cin cr wss
      vv cv cA inss2 vv cv cA cin cA cr sstr mpan syl wph vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa vc cv vv cv cA cin wcel
      reconnlem2.1 vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vc cv vv cv cA cin wcel vb cv vc cv cle wbr vb
      cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a vc cv vv cv cA cin wcel cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss 3simp2
      adantr ad2antrr sylbi sseldd jca $.
      $( [15-Aug-2009] $) $( [15-Aug-2009] $)
  $}

  ${
    $d t w z ph $. $d t w z A $. $d b t w z $. $d c t w z $. $d t u w z $. $d t
     v w z $.
    reconnlem3.1 $e |- ( ph <-> ( ( ( ( b e. ( u i^i A ) /\ c e. ( v i^i A ) /\
     ( u i^i v ) C_ ( RR \ A ) ) /\ ( A C_ RR /\ ( u e. ( topGen ` ran (,) ) /\
      v e. ( topGen ` ran (,) ) ) ) ) /\ b <_ c ) /\ ( b [,] c ) C_ A ) ) $.
    reconnlem3.2 $e |- S = sup ( ( u i^i ( b [,] c ) ) , RR , < ) $.
    $( Lemma for ~ reconn . $)
    reconnlem3 $p |- ( ph -> S e. ( b [,] c ) ) $=
      wph cS vb cv vc cv cicc co wcel cS cr wcel vb cv cS cle wbr cS vc cv cle
      wbr w3a wph cS cr wcel vb cv cS cle wbr cS vc cv cle wbr wph vu cv vb cv
      vc cv cicc co cin cr clt csup cr cS wph vu cv vb cv vc cv cicc co cin cr
      wss vu cv vb cv vc cv cicc co cin c0 wne vw cv vt cv cle wbr vw vu cv vb
      cv vc cv cicc co cin wral vt cr wrex w3a vu cv vb cv vc cv cicc co cin cr
      clt csup cr wcel vb cv cr wcel vc cv cr wcel wa vu cv vb cv vc cv cicc co
      cin vb cv vc cv cicc co wss vb cv vu cv vb cv vc cv cicc co cin wcel vu
      cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vw
      cv vt cv cle wbr vw vu cv vb cv vc cv cicc co cin wral vt cr wrex w3a wph
      vt vw vb cv vc cv vb cv vu cv vb cv vc cv cicc co cin iccsupr wph vv vu
      cA vb vc reconnlem3.1 reconnlem2 vu cv vb cv vc cv cicc co cin vb cv vc
      cv cicc co wss wph vu cv vb cv vc cv cicc co inss2 a1i vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv
      vc cv cicc co wcel wa wph vb cv vu cv vb cv vc cv cicc co cin wcel vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv
      wcel vb cv vb cv vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vu cv wcel vb cv
      vc cv cle wbr vb cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv
      cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a vb cv vu cv wcel cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vb cv vu cv wcel vu cv vv cv
      cin cr cA cdif wss vu cv cA cin vu cv vb cv vu cv cA inss1 sseli 3ad2ant1
      adantr ad2antrr vb cv cr wcel vc cv cr wcel wa vb cv vc cv cle wbr vb cv
      vb cv vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa vb cv cr wcel vc cv cr wcel vb cv vc cv cle wbr vb cv
      vb cv vc cv cicc co wcel vb cv vc cv lbicc2 3expa vb cv vu cv cA cin wcel
      vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa vv vu cA vb vc vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb
      cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa biid reconnlem2 vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr vb cv vc cv cicc co cA wss simplr sylanc jca
      reconnlem3.1 vb cv vu cv vb cv vc cv cicc co elin 3imtr4i syl3anc vt vw
      vu cv vb cv vc cv cicc co cin suprcl syl reconnlem3.2 syl5eqel vb cv vu
      cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a
      cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa
      wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv vb cv
      vc cv cicc co cin cr clt csup cle wbr wph vb cv cS cle wbr vu cv vb cv vc
      cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vw cv vt cv
      cle wbr vw vu cv vb cv vc cv cicc co cin wral vt cr wrex w3a vb cv vu cv
      vb cv vc cv cicc co cin wcel vb cv vu cv vb cv vc cv cicc co cin cr clt
      csup cle wbr vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA
      wss wa vt vw vu cv vb cv vc cv cicc co cin vb cv suprub vb cv cr wcel vc
      cv cr wcel wa vu cv vb cv vc cv cicc co cin vb cv vc cv cicc co wss vb cv
      vu cv vb cv vc cv cicc co cin wcel vu cv vb cv vc cv cicc co cin cr wss
      vu cv vb cv vc cv cicc co cin c0 wne vw cv vt cv cle wbr vw vu cv vb cv
      vc cv cicc co cin wral vt cr wrex w3a vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss wa vt vw vb cv vc cv vb cv vu cv vb cv vc cv
      cicc co cin iccsupr vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa biid reconnlem2 vu cv vb cv vc cv cicc co cin vb cv vc
      cv cicc co wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv
      cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vu cv vb cv vc cv cicc co inss2 a1i vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv
      cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv vc
      cv cicc co wcel wa vb cv vu cv vb cv vc cv cicc co cin wcel vb cv vu cv
      cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA
      cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa
      vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb
      cv vb cv vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vu cv wcel vb cv vc cv
      cle wbr vb cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA
      cin wcel vu cv vv cv cin cr cA cdif wss w3a vb cv vu cv wcel cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vb cv vu cv wcel vu cv vv cv cin cr cA
      cdif wss vu cv cA cin vu cv vb cv vu cv cA inss1 sseli 3ad2ant1 adantr
      ad2antrr vb cv cr wcel vc cv cr wcel wa vb cv vc cv cle wbr vb cv vb cv
      vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vb cv cr wcel vc cv cr wcel vb cv vc cv cle wbr vb cv vb cv vc
      cv cicc co wcel vb cv vc cv lbicc2 3expa vb cv vu cv cA cin wcel vc cv vv
      cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr
      wa vb cv vc cv cicc co cA wss wa vv vu cA vb vc vb cv vu cv cA cin wcel
      vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa biid reconnlem2 vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb
      cv vc cv cle wbr vb cv vc cv cicc co cA wss simplr sylanc jca vb cv vu cv
      vb cv vc cv cicc co elin sylibr syl3anc vb cv vu cv cA cin wcel vc cv vv
      cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr
      wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv vc cv cicc
      co wcel wa vb cv vu cv vb cv vc cv cicc co cin wcel vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv
      vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vu cv wcel vb cv vc cv cle wbr vb cv
      vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a vb cv vu cv wcel cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vb cv vu cv wcel vu cv vv cv cin cr cA cdif wss vu
      cv cA cin vu cv vb cv vu cv cA inss1 sseli 3ad2ant1 adantr ad2antrr vb cv
      cr wcel vc cv cr wcel wa vb cv vc cv cle wbr vb cv vb cv vc cv cicc co
      wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr
      cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg
      cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb
      cv cr wcel vc cv cr wcel vb cv vc cv cle wbr vb cv vb cv vc cv cicc co
      wcel vb cv vc cv lbicc2 3expa vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc
      cv cicc co cA wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss wa biid reconnlem2 vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv
      cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr vb cv vc cv cicc co cA wss simplr sylanc jca vb cv vu cv vb cv vc
      cv cicc co elin sylibr sylanc reconnlem3.1 cS vu cv vb cv vc cv cicc co
      cin cr clt csup vb cv cle reconnlem3.2 breq2i 3imtr4i vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa vu cv vb cv vc cv cicc co cin
      cr clt csup vc cv cle wbr wph cS vc cv cle wbr vu cv vb cv vc cv cicc co
      cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vw cv vt cv cle wbr vw vu
      cv vb cv vc cv cicc co cin wral vt cr wrex w3a vc cv cr wcel vz cv vc cv
      cle wbr vz vu cv vb cv vc cv cicc co cin wral vu cv vb cv vc cv cicc co
      cin cr clt csup vc cv cle wbr vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc
      cv cicc co cA wss wa vb cv cr wcel vc cv cr wcel wa vu cv vb cv vc cv
      cicc co cin vb cv vc cv cicc co wss vb cv vu cv vb cv vc cv cicc co cin
      wcel vu cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin
      c0 wne vw cv vt cv cle wbr vw vu cv vb cv vc cv cicc co cin wral vt cr
      wrex w3a vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin
      cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn
      ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss
      wa vt vw vb cv vc cv vb cv vu cv vb cv vc cv cicc co cin iccsupr vb cv vu
      cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a
      cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa
      wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vv vu cA vb vc vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel
      wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa biid
      reconnlem2 vu cv vb cv vc cv cicc co cin vb cv vc cv cicc co wss vb cv vu
      cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a
      cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa
      wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vu cv vb cv vc cv
      cicc co inss2 a1i vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vb cv vu cv wcel vb cv vb cv vc cv cicc co wcel wa vb cv vu cv
      vb cv vc cv cicc co cin wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc
      cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv vc cv cicc co wcel vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel
      wa wa wa vb cv vu cv wcel vb cv vc cv cle wbr vb cv vc cv cicc co cA wss
      vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA
      cdif wss w3a vb cv vu cv wcel cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vb cv vu cv wcel vu cv vv cv cin cr cA cdif wss vu cv cA cin vu cv
      vb cv vu cv cA inss1 sseli 3ad2ant1 adantr ad2antrr vb cv cr wcel vc cv
      cr wcel wa vb cv vc cv cle wbr vb cv vb cv vc cv cicc co wcel vb cv vu cv
      cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA
      cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa
      vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv cr wcel vc cv
      cr wcel vb cv vc cv cle wbr vb cv vb cv vc cv cicc co wcel vb cv vc cv
      lbicc2 3expa vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA
      wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc
      co cA wss wa biid reconnlem2 vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr vb cv vc cv
      cicc co cA wss simplr sylanc jca vb cv vu cv vb cv vc cv cicc co elin
      sylibr syl3anc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv
      cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vb cv cr wcel vc cv cr wcel vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv
      cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa biid reconnlem2 pm3.27d vb cv vu
      cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a
      cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa
      wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vz cv vc cv cle
      wbr vz vu cv vb cv vc cv cicc co cin vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss wa vb cv cr wcel vc cv cr wcel wa vb cv cxr
      wcel vc cv cxr wcel wa vz cv vu cv vb cv vc cv cicc co cin wcel vz cv vc
      cv cle wbr wi vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA
      wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc
      co cA wss wa biid reconnlem2 vb cv cr wcel vb cv cxr wcel vc cv cr wcel
      vc cv cxr wcel vb cv rexr vc cv rexr anim12i vb cv cxr wcel vc cv cxr
      wcel wa vz cv vb cv vc cv cicc co wcel vz cv vc cv cle wbr vz cv vu cv vb
      cv vc cv cicc co cin wcel vb cv cxr wcel vc cv cxr wcel vz cv vb cv vc cv
      cicc co wcel vz cv vc cv cle wbr vb cv vc cv vz cv iccleub 3expia vu cv
      vb cv vc cv cicc co cin vb cv vc cv cicc co vz cv vu cv vb cv vc cv cicc
      co inss2 sseli syl5 3syl r19.21aiv vt vw vz vu cv vb cv vc cv cicc co cin
      vc cv suprleub sylan32c reconnlem3.1 cS vu cv vb cv vc cv cicc co cin cr
      clt csup vc cv cle reconnlem3.2 breq1i 3imtr4i 3jca wph vb cv cr wcel vc
      cv cr wcel wa cS vb cv vc cv cicc co wcel cS cr wcel vb cv cS cle wbr cS
      vc cv cle wbr w3a wb wph vv vu cA vb vc reconnlem3.1 reconnlem2 vb cv vc
      cv cS elicc2 syl mpbird $.
      $( [16-Aug-2009] $) $( [16-Aug-2009] $)
  $}

  ${
    $d r ph $. $d r t S $. $d b r s t $. $d c r s t $. $d r s t u $.
    reconnlem4.1 $e |- ( ph <-> ( ( ( ( b e. ( u i^i A ) /\ c e. ( v i^i A ) /\
     ( u i^i v ) C_ ( RR \ A ) ) /\ ( A C_ RR /\ ( u e. ( topGen ` ran (,) ) /\
      v e. ( topGen ` ran (,) ) ) ) ) /\ b <_ c ) /\ ( b [,] c ) C_ A ) ) $.
    reconnlem4.2 $e |- S = sup ( ( u i^i ( b [,] c ) ) , RR , < ) $.
    $( Lemma for ~ reconn . $)
    reconnlem4 $p |- ( ph -> -. S e. u ) $=
      wph cS vu cv wcel vt cv cS cle wbr vt vu cv vb cv vc cv cicc co cin wral
      wph vu cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin c0
      wne vs cv vr cv cle wbr vs vu cv vb cv vc cv cicc co cin wral vr cr wrex
      w3a vt cv cS cle wbr vt vu cv vb cv vc cv cicc co cin wral vb cv cr wcel
      vc cv cr wcel wa vu cv vb cv vc cv cicc co cin vb cv vc cv cicc co wss vb
      cv vu cv vb cv vc cv cicc co cin wcel vu cv vb cv vc cv cicc co cin cr
      wss vu cv vb cv vc cv cicc co cin c0 wne vs cv vr cv cle wbr vs vu cv vb
      cv vc cv cicc co cin wral vr cr wrex w3a wph vr vs vb cv vc cv vb cv vu
      cv vb cv vc cv cicc co cin iccsupr wph vv vu cA vb vc reconnlem4.1
      reconnlem2 vu cv vb cv vc cv cicc co cin vb cv vc cv cicc co wss wph vu
      cv vb cv vc cv cicc co inss2 a1i vb cv vu cv cA cin wcel vc cv vv cv cA
      cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg
      cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb
      cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv vc cv cicc co
      wcel wa wph vb cv vu cv vb cv vc cv cicc co cin wcel vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv
      vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vu cv wcel vb cv vc cv cle wbr vb cv
      vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a vb cv vu cv wcel cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vb cv vu cv wcel vu cv vv cv cin cr cA cdif wss vu
      cv cA cin vu cv vb cv vu cv cA inss1 sseli 3ad2ant1 adantr ad2antrr vb cv
      cr wcel vc cv cr wcel wa vb cv vc cv cle wbr vb cv vb cv vc cv cicc co
      wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr
      cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg
      cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb
      cv cr wcel vc cv cr wcel vb cv vc cv cle wbr vb cv vb cv vc cv cicc co
      wcel vb cv vc cv lbicc2 3expa vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc
      cv cicc co cA wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss wa biid reconnlem2 vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv
      cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr vb cv vc cv cicc co cA wss simplr sylanc jca reconnlem4.1 vb cv
      vu cv vb cv vc cv cicc co elin 3imtr4i syl3anc vu cv vb cv vc cv cicc co
      cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vs cv vr cv cle wbr vs vu
      cv vb cv vc cv cicc co cin wral vr cr wrex w3a vt cv cS cle wbr vt vu cv
      vb cv vc cv cicc co cin vu cv vb cv vc cv cicc co cin cr wss vu cv vb cv
      vc cv cicc co cin c0 wne vs cv vr cv cle wbr vs vu cv vb cv vc cv cicc co
      cin wral vr cr wrex w3a vt cv vu cv vb cv vc cv cicc co cin wcel wa vt cv
      vu cv vb cv vc cv cicc co cin cr clt csup cS cle vr vs vu cv vb cv vc cv
      cicc co cin vt cv suprub reconnlem4.2 syl6breqr r19.21aiva syl wph cS vu
      cv wcel vt cv cS cle wbr wn vt vu cv vb cv vc cv cicc co cin wrex vt cv
      cS cle wbr vt vu cv vb cv vc cv cicc co cin wral wn wph cS vu cv wcel vt
      cv cS cle wbr wn vt vu cv vb cv vc cv cicc co cin wrex wph cS vu cv wcel
      wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a vr cr wrex vt cv cS cle wbr
      wn vt vu cv vb cv vc cv cicc co cin wrex cabs cmin ccom cr cr cxp cres
      cme wcel vu cv cioo crn ctg cfv wcel cS vu cv wcel w3a vc cv cS cmin co
      cr wcel cc0 vc cv cS cmin co clt wbr cc0 vr cv clt wbr vr cv vc cv cS
      cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv
      wss w3a vr cr wrex wph cS vu cv wcel wa wph cS vu cv wcel wa cabs cmin
      ccom cr cr cxp cres cme wcel vu cv cioo crn ctg cfv wcel cS vu cv wcel
      cabs cmin ccom cr cr cxp cres cme wcel wph cS vu cv wcel wa cabs cmin
      ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid remet a1i wph vu
      cv cioo crn ctg cfv wcel cS vu cv wcel wph vb cv vu cv cA cin wcel vc cv
      vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr
      wa vb cv vc cv cicc co cA wss wa vu cv cioo crn ctg cfv wcel reconnlem4.1
      vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA
      cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa wa vu cv cioo crn ctg cfv wcel vb cv vc cv cle wbr vb cv vc cv
      cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv
      cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel simprrl ad2antrr sylbi adantr wph cS vu cv wcel
      pm3.27 3jca wph vc cv cS cmin co cr wcel cS vu cv wcel vc cv cr wcel cS
      cr wcel vc cv cS cmin co cr wcel wph vc cv cS resubcl wph vb cv cr wcel
      vc cv cr wcel wph vv vu cA vb vc reconnlem4.1 reconnlem2 pm3.27d wph vb
      cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv
      cicc co cr wss wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv
      iccssre syl wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3
      sseldd sylanc adantr wph cS vu cv wcel wa cS vc cv clt wbr cc0 vc cv cS
      cmin co clt wbr wph cS vu cv wcel wa cS vc cv clt wbr vc cv cS wne wph cS
      vu cv wcel wa vc cv cS wceq wn vc cv cS wne wph cS vu cv wcel wa vc cv cS
      wceq cA cr cA cdif cin c0 wceq cA cr difdisj wph cS vu cv wcel wa vc cv
      cS wceq cS cA cr cA cdif cin wcel cA cr cA cdif cin c0 wceq wn wph cS vu
      cv wcel wa vc cv cS wceq cS cA wcel cS cr cA cdif wcel wa cS cA cr cA
      cdif cin wcel wph cS vu cv wcel wa vc cv cS wceq cS cr cA cdif wcel cS cA
      wcel wph cS vu cv wcel wa vc cv cS wceq cS vu cv vv cv cin wcel cS cr cA
      cdif wcel wph cS vu cv wcel wa vc cv cS wceq cS vu cv wcel cS vv cv wcel
      wa cS vu cv vv cv cin wcel wph cS vu cv wcel wa vc cv cS wceq cS vv cv
      wcel cS vu cv wcel wph vc cv cS wceq cS vv cv wcel wi cS vu cv wcel vc cv
      cS wceq vc cv vv cv wcel cS vv cv wcel wph vc cv cS vv cv eleq1 wph vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vc cv vv cv
      wcel reconnlem4.1 vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vc cv vv cv wcel vb cv vc cv cle wbr vb cv
      vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a vc cv vv cv wcel cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vc cv vv cv cA cin wcel vb
      cv vu cv cA cin wcel vc cv vv cv wcel vu cv vv cv cin cr cA cdif wss vv
      cv cA cin vv cv vc cv vv cv cA inss1 sseli 3ad2ant2 adantr ad2antrr sylbi
      syl5cbi adantr wph cS vu cv wcel pm3.27 jctild cS vu cv vv cv elin
      syl6ibr wph cS vu cv vv cv cin wcel cS cr cA cdif wcel wi cS vu cv wcel
      wph vu cv vv cv cin cr cA cdif cS wph vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss wa vu cv vv cv cin cr cA cdif wss reconnlem4.1
      vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA
      cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa wa vu cv vv cv cin cr cA cdif wss vb cv vc cv cle wbr vb cv vc
      cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a vu cv vv cv cin cr cA cdif wss cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss 3simp3
      adantr ad2antrr sylbi sseld adantr syld wph cS cA wcel cS vu cv wcel wph
      vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA
      cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa cS cA
      wcel reconnlem4.1 vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv
      vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vb cv vc cv cicc co cA cS vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa
      vb cv vc cv cicc co cA wss pm3.27 vb cv vu cv cA cin wcel vc cv vv cv cA
      cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg
      cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb
      cv vc cv cicc co cA wss wa vv vu cA cS vb vc vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv
      cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa biid reconnlem4.2 reconnlem3
      sseldd sylbi adantr jctild cS cA cr cA cdif elin syl6ibr cA cr cA cdif
      cin cS n0i syl6 mt2i vc cv cS df-ne sylibr wph cS vc cv clt wbr vc cv cS
      wne wb cS vu cv wcel cS cr wcel vc cv cr wcel cS vc cv cle wbr cS vc cv
      clt wbr vc cv cS wne wb wph cS vc cv leltne wph vb cv vc cv cicc co cr cS
      wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu
      cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS
      vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd wph vb cv cr wcel vc cv
      cr wcel wph vv vu cA vb vc reconnlem4.1 reconnlem2 pm3.27d wph cS cr wcel
      vb cv cS cle wbr cS vc cv cle wbr wph cS vb cv vc cv cicc co wcel cS cr
      wcel vb cv cS cle wbr cS vc cv cle wbr w3a wph vv vu cA cS vb vc
      reconnlem4.1 reconnlem4.2 reconnlem3 wph vb cv cr wcel vc cv cr wcel wa
      cS vb cv vc cv cicc co wcel cS cr wcel vb cv cS cle wbr cS vc cv cle wbr
      w3a wb wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv cS elicc2
      syl mpbid 3simp3d syl3anc adantr mpbird wph cS vc cv clt wbr cc0 vc cv cS
      cmin co clt wbr wb cS vu cv wcel cS cr wcel vc cv cr wcel cS vc cv clt
      wbr cc0 vc cv cS cmin co clt wbr wb wph cS vc cv posdif wph vb cv vc cv
      cicc co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr
      wss wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl
      wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd wph vb
      cv cr wcel vc cv cr wcel wph vv vu cA vb vc reconnlem4.1 reconnlem2
      pm3.27d sylanc adantr mpbid vr vu cv cabs cmin ccom cr cr cxp cres cS vc
      cv cS cmin co cioo crn ctg cfv cabs cmin ccom cr cr cxp cres cabs cmin
      ccom cr cr cxp cres copn cfv cabs cmin ccom cr cr cxp cres eqid cabs cmin
      ccom cr cr cxp cres copn cfv eqid tgioo opni3 sylan32c wph cS vu cv wcel
      wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a vt cv cS cle wbr wn vt vu cv
      vb cv vc cv cicc co cin wrex vr cr wph cS vu cv wcel wa vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a vt cv cS cle wbr wn vt vu cv vb cv
      vc cv cicc co cin wrex cS vr cv c2 cdiv co caddc co vu cv vb cv vc cv
      cicc co cin wcel cS vr cv c2 cdiv co caddc co cS cle wbr wn vt cv cS cle
      wbr wn vt vu cv vb cv vc cv cicc co cin wrex wph cS vu cv wcel wa vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vt cv cS cle wbr
      wn cS vr cv c2 cdiv co caddc co cS cle wbr wn vt cS vr cv c2 cdiv co
      caddc co vu cv vb cv vc cv cicc co cin vt cv cS vr cv c2 cdiv co caddc co
      wceq vt cv cS cle wbr cS vr cv c2 cdiv co caddc co cS cle wbr vt cv cS vr
      cv c2 cdiv co caddc co cS cle breq1 notbid rcla4ev wph cS vu cv wcel wa
      vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv
      cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2
      cdiv co caddc co vu cv wcel cS vr cv c2 cdiv co caddc co vb cv vc cv cicc
      co wcel wa cS vr cv c2 cdiv co caddc co vu cv vb cv vc cv cicc co cin
      wcel wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS
      cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv
      wss w3a wa wa cS vr cv c2 cdiv co caddc co vu cv wcel cS vr cv c2 cdiv co
      caddc co vb cv vc cv cicc co wcel wph cS vu cv wcel wa vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv cabs cmin ccom cr cr
      cxp cres cbl cfv co vu cv cS vr cv c2 cdiv co caddc co cc0 vr cv clt wbr
      vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss 3simp3 ad2antll wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt
      wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss w3a wa wa cS vr cv c2 cdiv co caddc co cS vr cv cmin
      co cS vr cv caddc co cioo co cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a wa wa cS vr cv c2 cdiv co caddc co cS vr cv cmin co cS vr cv
      caddc co cioo co wcel cS vr cv c2 cdiv co caddc co cr wcel cS vr cv cmin
      co cS vr cv c2 cdiv co caddc co clt wbr cS vr cv c2 cdiv co caddc co cS
      vr cv caddc co clt wbr w3a wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv
      clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2 cdiv co caddc co cr wcel
      cS vr cv cmin co cS vr cv c2 cdiv co caddc co clt wbr cS vr cv c2 cdiv co
      caddc co cS vr cv caddc co clt wbr cS cr wcel vr cv c2 cdiv co cr wcel cS
      vr cv c2 cdiv co caddc co cr wcel wph cS vu cv wcel wa vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2 cdiv co readdcl
      wph cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr
      wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem4.1
      reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem4.1
      reconnlem4.2 reconnlem3 sseldd ad2antrr vr cv cr wcel vr cv c2 cdiv co cr
      wcel wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt
      wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a vr cv
      rehalfcl ad2antrl sylanc wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt
      wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss w3a wa wa cS vr cv cmin co cS cS vr cv c2 cdiv co
      caddc co cS cr wcel vr cv cr wcel cS vr cv cmin co cr wcel wph cS vu cv
      wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr
      cv resubcl wph cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr
      vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel
      vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc
      reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc
      reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr wph cS vu cv wcel wa
      vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv
      cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a simprl sylanc wph
      cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS
      cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv
      wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel
      wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem4.1 reconnlem2
      vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2
      reconnlem3 sseldd ad2antrr cS cr wcel vr cv c2 cdiv co cr wcel cS vr cv
      c2 cdiv co caddc co cr wcel wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv
      clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2 cdiv co readdcl wph cS cr
      wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co
      clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a
      wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv
      vc cv cicc co cr wss wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc
      cv iccssre syl wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3
      sseldd ad2antrr vr cv cr wcel vr cv c2 cdiv co cr wcel wph cS vu cv wcel
      wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a vr cv rehalfcl ad2antrl
      sylanc wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a wa wa cc0 vr cv clt wbr cS vr cv cmin co cS clt wbr cc0 vr cv
      clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vu cv wss w3a cc0 vr cv clt wbr wph cS vu cv wcel wa vr
      cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss 3simp1 ad2antll vr cv cr
      wcel cS cr wcel cc0 vr cv clt wbr cS vr cv cmin co cS clt wbr wb wph cS
      vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt
      wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa
      vr cv cS ltsubpos wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr
      cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a simprl wph cS cr wcel cS vu cv wcel vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc co cr cS
      wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu
      cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS
      vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr sylanc mpbid
      wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin
      co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss
      w3a wa wa cc0 vr cv c2 cdiv co clt wbr cS cS vr cv c2 cdiv co caddc co
      clt wbr vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa cc0 vr cv
      c2 cdiv co clt wbr wph cS vu cv wcel wa vr cv cr wcel vr cv vc cv cS cmin
      co clt wbr cc0 vr cv clt wbr cc0 vr cv c2 cdiv co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss vr cv cr wcel cc0 vr cv clt
      wbr cc0 vr cv c2 cdiv co clt wbr vr cv halfpos2 biimpa 3ad2antr1 adantl
      vr cv c2 cdiv co cr wcel cS cr wcel cc0 vr cv c2 cdiv co clt wbr cS cS vr
      cv c2 cdiv co caddc co clt wbr wb wph cS vu cv wcel wa vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a wa wa vr cv c2 cdiv co cS ltaddpos
      vr cv cr wcel vr cv c2 cdiv co cr wcel wph cS vu cv wcel wa cc0 vr cv clt
      wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss w3a vr cv rehalfcl ad2antrl wph cS cr wcel cS vu cv
      wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr
      cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc
      cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co
      cr wss wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl
      wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd
      ad2antrr sylanc mpbid lttrd wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv
      clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vu cv wss w3a wa wa vr cv c2 cdiv co vr cv clt wbr cS vr
      cv c2 cdiv co caddc co cS vr cv caddc co clt wbr wph cS vu cv wcel wa vr
      cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cc0 vr cv clt wbr
      vr cv c2 cdiv co vr cv clt wbr cc0 vr cv clt wbr vr cv vc cv cS cmin co
      clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a
      cc0 vr cv clt wbr wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr
      cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss 3simp1 ad2antll vr cv cr wcel cc0 vr cv clt wbr vr cv c2
      cdiv co vr cv clt wbr wb wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a vr cv halfpos ad2antrl mpbid vr cv c2 cdiv co cr wcel vr cv
      cr wcel cS cr wcel vr cv c2 cdiv co vr cv clt wbr cS vr cv c2 cdiv co
      caddc co cS vr cv caddc co clt wbr wb wph cS vu cv wcel wa vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vr cv c2 cdiv co vr cv cS
      ltadd2 vr cv cr wcel vr cv c2 cdiv co cr wcel wph cS vu cv wcel wa cc0 vr
      cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr
      cxp cres cbl cfv co vu cv wss w3a vr cv rehalfcl ad2antrl wph cS vu cv
      wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a simprl wph
      cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS
      cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv
      wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel
      wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem4.1 reconnlem2
      vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2
      reconnlem3 sseldd ad2antrr syl3anc mpbid 3jca cS vr cv cmin co cxr wcel
      cS vr cv caddc co cxr wcel cS vr cv c2 cdiv co caddc co cS vr cv cmin co
      cS vr cv caddc co cioo co wcel cS vr cv c2 cdiv co caddc co cr wcel cS vr
      cv cmin co cS vr cv c2 cdiv co caddc co clt wbr cS vr cv c2 cdiv co caddc
      co cS vr cv caddc co clt wbr w3a wb wph cS vu cv wcel wa vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv cmin co cS vr cv
      caddc co cS vr cv c2 cdiv co caddc co elioo2 wph cS vu cv wcel wa vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv cmin co
      cr wcel cS vr cv cmin co cxr wcel cS cr wcel vr cv cr wcel cS vr cv cmin
      co cr wcel wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a wa wa cS vr cv resubcl wph cS cr wcel cS vu cv wcel vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc
      co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss
      wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv
      vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr wph
      cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co
      clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a
      simprl sylanc cS vr cv cmin co rexr syl wph cS vu cv wcel wa vr cv cr
      wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv caddc co cr
      wcel cS vr cv caddc co cxr wcel cS cr wcel vr cv cr wcel cS vr cv caddc
      co cr wcel wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a wa wa cS vr cv readdcl wph cS cr wcel cS vu cv wcel vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc
      co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss
      wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv
      vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr wph
      cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co
      clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a
      simprl sylanc cS vr cv caddc co rexr syl sylanc mpbird cS cr wcel vr cv
      cr wcel cc0 vr cv clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv
      co cS vr cv cmin co cS vr cv caddc co cioo co wceq wph cS vu cv wcel wa
      vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv
      cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv
      cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid bl2ioo
      wph cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr
      wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem4.1
      reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem4.1
      reconnlem4.2 reconnlem3 sseldd ad2antrr wph cS vu cv wcel wa vr cv cr
      wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a simprl cc0 vr cv clt wbr vr
      cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a cc0 vr cv clt wbr wph cS vu cv wcel wa vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss 3simp1 ad2antll syl3anc eleqtrrd
      sseldd wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a wa wa cS vr cv c2 cdiv co caddc co vb cv vc cv cicc co wcel cS
      vr cv c2 cdiv co caddc co cr wcel vb cv cS vr cv c2 cdiv co caddc co cle
      wbr cS vr cv c2 cdiv co caddc co vc cv cle wbr w3a wph cS vu cv wcel wa
      vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv
      cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2
      cdiv co caddc co cr wcel vb cv cS vr cv c2 cdiv co caddc co cle wbr cS vr
      cv c2 cdiv co caddc co vc cv cle wbr cS cr wcel vr cv c2 cdiv co cr wcel
      cS vr cv c2 cdiv co caddc co cr wcel wph cS vu cv wcel wa vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2 cdiv co readdcl
      wph cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr
      wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem4.1
      reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem4.1
      reconnlem4.2 reconnlem3 sseldd ad2antrr vr cv cr wcel vr cv c2 cdiv co cr
      wcel wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt
      wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a vr cv
      rehalfcl ad2antrl sylanc wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt
      wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss w3a wa wa vb cv cc0 caddc co vb cv cS vr cv c2 cdiv
      co caddc co cle wph vb cv cc0 caddc co vb cv wceq cS vu cv wcel vr cv cr
      wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv cr wcel vb cv
      cc wcel vb cv cc0 caddc co vb cv wceq wph vb cv cr wcel vc cv cr wcel wph
      vv vu cA vb vc reconnlem4.1 reconnlem2 pm3.26d vb cv recn vb cv addid1
      3syl ad2antrr vb cv cr wcel cc0 cr wcel wa cS cr wcel vr cv c2 cdiv co cr
      wcel wa wa vb cv cS cle wbr cc0 vr cv c2 cdiv co cle wbr wa vb cv cc0
      caddc co cS vr cv c2 cdiv co caddc co cle wbr wph cS vu cv wcel wa vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vb cv cc0 cS vr
      cv c2 cdiv co le2add wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr
      vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a wa wa vb cv cr wcel cc0 cr wcel wa cS cr wcel vr cv
      c2 cdiv co cr wcel wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr
      vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a wa wa vb cv cr wcel cc0 cr wcel wph vb cv cr wcel cS
      vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr
      cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb
      cv cr wcel vc cv cr wcel wph vv vu cA vb vc reconnlem4.1 reconnlem2
      pm3.26d ad2antrr 0re jctir wph cS cr wcel cS vu cv wcel vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc co cr cS wph
      vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb
      vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc
      reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr vr cv cr wcel vr cv
      c2 cdiv co cr wcel wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc cv cS
      cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv
      wss w3a vr cv rehalfcl ad2antrl jca32 wph cS vu cv wcel wa vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vb cv cS cle wbr cc0 vr cv
      c2 cdiv co cle wbr wph vb cv cS cle wbr cS vu cv wcel vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a wa wph cS cr wcel vb cv cS cle wbr
      cS vc cv cle wbr wph cS vb cv vc cv cicc co wcel cS cr wcel vb cv cS cle
      wbr cS vc cv cle wbr w3a wph vv vu cA cS vb vc reconnlem4.1 reconnlem4.2
      reconnlem3 wph vb cv cr wcel vc cv cr wcel wa cS vb cv vc cv cicc co wcel
      cS cr wcel vb cv cS cle wbr cS vc cv cle wbr w3a wb wph vv vu cA vb vc
      reconnlem4.1 reconnlem2 vb cv vc cv cS elicc2 syl mpbid 3simp2d ad2antrr
      cc0 cr wcel vr cv c2 cdiv co cr wcel wa cc0 vr cv c2 cdiv co clt wbr cc0
      vr cv c2 cdiv co cle wbr wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt
      wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss w3a wa wa cc0 vr cv c2 cdiv co ltle wph cS vu cv
      wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vr cv
      c2 cdiv co cr wcel cc0 cr wcel vr cv cr wcel vr cv c2 cdiv co cr wcel wph
      cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr
      cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a vr cv rehalfcl
      ad2antrl 0re jctil vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co
      clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a
      wa cc0 vr cv c2 cdiv co clt wbr wph cS vu cv wcel wa vr cv cr wcel vr cv
      vc cv cS cmin co clt wbr cc0 vr cv clt wbr cc0 vr cv c2 cdiv co clt wbr
      cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss vr cv cr wcel
      cc0 vr cv clt wbr cc0 vr cv c2 cdiv co clt wbr vr cv halfpos2 biimpa
      3ad2antr1 adantl sylc jca sylc eqbrtrrd wph cS vu cv wcel wa vr cv cr
      wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cS vr cv c2 cdiv co
      caddc co vc cv cle wbr vr cv c2 cdiv co vc cv cS cmin co cle wbr vr cv c2
      cdiv co cr wcel vc cv cS cmin co cr wcel wa vr cv c2 cdiv co vc cv cS
      cmin co clt wbr vr cv c2 cdiv co vc cv cS cmin co cle wbr wph cS vu cv
      wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vr cv
      c2 cdiv co vc cv cS cmin co ltle wph cS vu cv wcel wa vr cv cr wcel cc0
      vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr
      cr cxp cres cbl cfv co vu cv wss w3a wa wa vr cv c2 cdiv co cr wcel vc cv
      cS cmin co cr wcel vr cv cr wcel vr cv c2 cdiv co cr wcel wph cS vu cv
      wcel wa cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a vr cv rehalfcl ad2antrl
      vc cv cr wcel cS cr wcel vc cv cS cmin co cr wcel wph cS vu cv wcel wa vr
      cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa vc cv cS resubcl
      wph vc cv cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a wa wph vb cv cr wcel vc cv cr wcel wph vv vu cA vb vc
      reconnlem4.1 reconnlem2 pm3.27d ad2antrr wph cS cr wcel cS vu cv wcel vr
      cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc
      co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss
      wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv
      vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr
      sylanc jca wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a wa wa vr cv c2 cdiv co vr cv vc cv cS cmin co vr cv cr wcel
      vr cv c2 cdiv co cr wcel wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a vr cv rehalfcl ad2antrl wph cS vu cv wcel wa vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a simprl vc cv cr wcel cS cr wcel
      vc cv cS cmin co cr wcel wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt
      wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss w3a wa wa vc cv cS resubcl wph vc cv cr wcel cS vu
      cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv
      cr wcel vc cv cr wcel wph vv vu cA vb vc reconnlem4.1 reconnlem2 pm3.27d
      ad2antrr wph cS cr wcel cS vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr
      cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a wa wph vb cv vc cv cicc co cr cS wph vb cv cr wcel
      vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc
      reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc
      reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr sylanc wph cS vu cv
      wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS
      vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cc0 vr
      cv clt wbr vr cv c2 cdiv co vr cv clt wbr cc0 vr cv clt wbr vr cv vc cv
      cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu
      cv wss w3a cc0 vr cv clt wbr wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv
      clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vu cv wss 3simp1 ad2antll vr cv cr wcel cc0 vr cv clt wbr
      vr cv c2 cdiv co vr cv clt wbr wb wph cS vu cv wcel wa cc0 vr cv clt wbr
      vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a vr cv halfpos ad2antrl mpbid cc0 vr cv clt wbr vr cv
      vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv
      co vu cv wss w3a vr cv vc cv cS cmin co clt wbr wph cS vu cv wcel wa vr
      cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss 3simp2 ad2antll lttrd sylc
      cS cr wcel vr cv c2 cdiv co cr wcel vc cv cr wcel cS vr cv c2 cdiv co
      caddc co vc cv cle wbr vr cv c2 cdiv co vc cv cS cmin co cle wbr wb wph
      cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co
      clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a
      wa wa cS vr cv c2 cdiv co vc cv leaddsub2 wph cS cr wcel cS vu cv wcel vr
      cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc
      co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss
      wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv
      vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr vr cv
      cr wcel vr cv c2 cdiv co cr wcel wph cS vu cv wcel wa cc0 vr cv clt wbr
      vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl
      cfv co vu cv wss w3a vr cv rehalfcl ad2antrl wph vc cv cr wcel cS vu cv
      wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr
      cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv cr
      wcel vc cv cr wcel wph vv vu cA vb vc reconnlem4.1 reconnlem2 pm3.27d
      ad2antrr syl3anc mpbird 3jca wph cS vr cv c2 cdiv co caddc co vb cv vc cv
      cicc co wcel cS vr cv c2 cdiv co caddc co cr wcel vb cv cS vr cv c2 cdiv
      co caddc co cle wbr cS vr cv c2 cdiv co caddc co vc cv cle wbr w3a wb cS
      vu cv wcel vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr
      cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb
      cv cr wcel vc cv cr wcel wa cS vr cv c2 cdiv co caddc co vb cv vc cv cicc
      co wcel cS vr cv c2 cdiv co caddc co cr wcel vb cv cS vr cv c2 cdiv co
      caddc co cle wbr cS vr cv c2 cdiv co caddc co vc cv cle wbr w3a wb wph vv
      vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv cS vr cv c2 cdiv co caddc
      co elicc2 syl ad2antrr mpbird jca cS vr cv c2 cdiv co caddc co vu cv vb
      cv vc cv cicc co elin sylibr wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv
      clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vu cv wss w3a wa wa cS cS vr cv c2 cdiv co caddc co clt
      wbr cS vr cv c2 cdiv co caddc co cS cle wbr wn wph cS vu cv wcel wa vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa cc0 vr cv c2 cdiv
      co clt wbr cS cS vr cv c2 cdiv co caddc co clt wbr vr cv cr wcel cc0 vr
      cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr
      cxp cres cbl cfv co vu cv wss w3a wa cc0 vr cv c2 cdiv co clt wbr wph cS
      vu cv wcel wa vr cv cr wcel vr cv vc cv cS cmin co clt wbr cc0 vr cv clt
      wbr cc0 vr cv c2 cdiv co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres
      cbl cfv co vu cv wss vr cv cr wcel cc0 vr cv clt wbr cc0 vr cv c2 cdiv co
      clt wbr vr cv halfpos2 biimpa 3ad2antr1 adantl vr cv c2 cdiv co cr wcel
      cS cr wcel cc0 vr cv c2 cdiv co clt wbr cS cS vr cv c2 cdiv co caddc co
      clt wbr wb wph cS vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a wa wa vr cv c2 cdiv co cS ltaddpos vr cv cr wcel vr cv c2
      cdiv co cr wcel wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc cv cS
      cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv
      wss w3a vr cv rehalfcl ad2antrl wph cS cr wcel cS vu cv wcel vr cv cr
      wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc co
      cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph
      vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu
      cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr sylanc
      mpbid cS cr wcel cS vr cv c2 cdiv co caddc co cr wcel cS cS vr cv c2 cdiv
      co caddc co clt wbr cS vr cv c2 cdiv co caddc co cS cle wbr wn wb wph cS
      vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt
      wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa
      cS cS vr cv c2 cdiv co caddc co ltnle wph cS cr wcel cS vu cv wcel vr cv
      cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs
      cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc
      co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss
      wph vv vu cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv
      vu cA cS vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr cS cr
      wcel vr cv c2 cdiv co cr wcel cS vr cv c2 cdiv co caddc co cr wcel wph cS
      vu cv wcel wa vr cv cr wcel cc0 vr cv clt wbr vr cv vc cv cS cmin co clt
      wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co vu cv wss w3a wa wa
      cS vr cv c2 cdiv co readdcl wph cS cr wcel cS vu cv wcel vr cv cr wcel
      cc0 vr cv clt wbr vr cv vc cv cS cmin co clt wbr cS vr cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vu cv wss w3a wa wph vb cv vc cv cicc co cr cS
      wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu
      cA vb vc reconnlem4.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS
      vb vc reconnlem4.1 reconnlem4.2 reconnlem3 sseldd ad2antrr vr cv cr wcel
      vr cv c2 cdiv co cr wcel wph cS vu cv wcel wa cc0 vr cv clt wbr vr cv vc
      cv cS cmin co clt wbr cS vr cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vu cv wss w3a vr cv rehalfcl ad2antrl sylanc sylanc mpbid sylanc exp32
      r19.23adv mpd ex vt cv cS cle wbr vt vu cv vb cv vc cv cicc co cin rexnal
      syl6ib mt2d $.
      $( [16-Aug-2009] $) $( [16-Aug-2009] $)
  $}

  ${
    $d m n r t ph $. $d m n r t S $. $d b m n r t $. $d c m n r t $. $d m n r t
     u $. $d m n r t v $.
    reconnlem5.1 $e |- ( ph <-> ( ( ( ( b e. ( u i^i A ) /\ c e. ( v i^i A ) /\
     ( u i^i v ) C_ ( RR \ A ) ) /\ ( A C_ RR /\ ( u e. ( topGen ` ran (,) ) /\
      v e. ( topGen ` ran (,) ) ) ) ) /\ b <_ c ) /\ ( b [,] c ) C_ A ) ) $.
    reconnlem5.2 $e |- S = sup ( ( u i^i ( b [,] c ) ) , RR , < ) $.
    $( Lemma for ~ reconn . $)
    reconnlem5 $p |- ( ph -> -. S e. v ) $=
      wph cS vv cv wcel cc0 vt cv clt wbr cS vt cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vv cv wss wa vt cr wrex wph cc0 vt cv clt wbr cS vt cv
      cabs cmin ccom cr cr cxp cres cbl cfv co vv cv wss wn wi vt cr wral cc0
      vt cv clt wbr cS vt cv cabs cmin ccom cr cr cxp cres cbl cfv co vv cv wss
      wa vt cr wrex wn wph cc0 vt cv clt wbr cS vt cv cabs cmin ccom cr cr cxp
      cres cbl cfv co vv cv wss wn wi vt cr wph vt cv cr wcel cc0 vt cv clt wbr
      cS vt cv cabs cmin ccom cr cr cxp cres cbl cfv co vv cv wss wn wph vt cv
      cr wcel cc0 vt cv clt wbr w3a vr cv cS vt cv cabs cmin ccom cr cr cxp
      cres cbl cfv co wcel vr cv vv cv wcel wn wa vr wex cS vt cv cabs cmin
      ccom cr cr cxp cres cbl cfv co vv cv wss wn wph vt cv cr wcel cc0 vt cv
      clt wbr w3a vr cv cS vt cv cabs cmin ccom cr cr cxp cres cbl cfv co wcel
      vr cv vv cv wcel wn wa vr wex vr cv cr wcel cS vt cv cmin co vr cv clt
      wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv wcel wn wa vr wex wph
      vt cv cr wcel cc0 vt cv clt wbr w3a cS vt cv cmin co vr cv clt wbr vr vu
      cv vb cv vc cv cicc co cin wrex vr cv cr wcel cS vt cv cmin co vr cv clt
      wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv wcel wn wa vr wex vu
      cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vn
      cv vm cv cle wbr vn vu cv vb cv vc cv cicc co cin wral vm cr wrex w3a cS
      vt cv cmin co cr wcel cS vt cv cmin co vu cv vb cv vc cv cicc co cin cr
      clt csup clt wbr cS vt cv cmin co vr cv clt wbr vr vu cv vb cv vc cv cicc
      co cin wrex wph vt cv cr wcel cc0 vt cv clt wbr w3a wph vt cv cr wcel vu
      cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vn
      cv vm cv cle wbr vn vu cv vb cv vc cv cicc co cin wral vm cr wrex w3a cc0
      vt cv clt wbr vb cv cr wcel vc cv cr wcel wa vu cv vb cv vc cv cicc co
      cin vb cv vc cv cicc co wss vb cv vu cv vb cv vc cv cicc co cin wcel vu
      cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc cv cicc co cin c0 wne vn
      cv vm cv cle wbr vn vu cv vb cv vc cv cicc co cin wral vm cr wrex w3a wph
      vm vn vb cv vc cv vb cv vu cv vb cv vc cv cicc co cin iccsupr wph vv vu
      cA vb vc reconnlem5.1 reconnlem2 vu cv vb cv vc cv cicc co cin vb cv vc
      cv cicc co wss wph vu cv vb cv vc cv cicc co inss2 a1i vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv
      vc cv cicc co wcel wa wph vb cv vu cv vb cv vc cv cicc co cin wcel vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv vu cv
      wcel vb cv vb cv vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn
      ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vu cv wcel vb cv
      vc cv cle wbr vb cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv
      cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a vb cv vu cv wcel cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vb cv vu cv wcel vu cv vv cv
      cin cr cA cdif wss vu cv cA cin vu cv vb cv vu cv cA inss1 sseli 3ad2ant1
      adantr ad2antrr vb cv cr wcel vc cv cr wcel wa vb cv vc cv cle wbr vb cv
      vb cv vc cv cicc co wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa vb cv cr wcel vc cv cr wcel vb cv vc cv cle wbr vb cv
      vb cv vc cv cicc co wcel vb cv vc cv lbicc2 3expa vb cv vu cv cA cin wcel
      vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa vv vu cA vb vc vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb
      cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa biid reconnlem2 vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr vb cv vc cv cicc co cA wss simplr sylanc jca
      reconnlem5.1 vb cv vu cv vb cv vc cv cicc co elin 3imtr4i syl3anc
      3ad2ant1 wph vt cv cr wcel cS vt cv cmin co cr wcel cc0 vt cv clt wbr cS
      cr wcel vt cv cr wcel cS vt cv cmin co cr wcel wph cS vt cv resubcl wph
      vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv
      cicc co cr wss wph vv vu cA vb vc reconnlem5.1 reconnlem2 vb cv vc cv
      iccssre syl wph vv vu cA cS vb vc reconnlem5.1 reconnlem5.2 reconnlem3
      sseldd sylan 3adant3 wph vt cv cr wcel cc0 vt cv clt wbr w3a cS vt cv
      cmin co cS vu cv vb cv vc cv cicc co cin cr clt csup clt wph vt cv cr
      wcel cc0 vt cv clt wbr cS vt cv cmin co cS clt wbr cS cr wcel vt cv cr
      wcel cc0 vt cv clt wbr cS vt cv cmin co cS clt wbr wb wph vt cv cr wcel
      cS cr wcel cc0 vt cv clt wbr cS vt cv cmin co cS clt wbr wb vt cv cS
      ltsubpos ancoms wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr
      wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem5.1
      reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem5.1
      reconnlem5.2 reconnlem3 sseldd sylan biimp3a reconnlem5.2 syl6breq vm vn
      vr vu cv vb cv vc cv cicc co cin cS vt cv cmin co suprlub sylan32c wph vt
      cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel
      cS vt cv cmin co vr cv clt wbr wa vr wex vr cv cr wcel cS vt cv cmin co
      vr cv clt wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv wcel wn wa
      vr wex cS vt cv cmin co vr cv clt wbr vr vu cv vb cv vc cv cicc co cin
      wrex wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc
      co cin wcel cS vt cv cmin co vr cv clt wbr wa vr cv cr wcel cS vt cv cmin
      co vr cv clt wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv wcel wn
      wa vr wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv
      cicc co cin wcel cS vt cv cmin co vr cv clt wbr wa vr cv cr wcel cS vt cv
      cmin co vr cv clt wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv
      wcel wn wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv
      cicc co cin wcel cS vt cv cmin co vr cv clt wbr wa vr cv cr wcel cS vt cv
      cmin co vr cv clt wbr vr cv cS vt cv caddc co clt wbr wph vt cv cr wcel
      cc0 vt cv clt wbr w3a vr cv vb cv vc cv cicc co wcel vr cv cr wcel vr cv
      vu cv vb cv vc cv cicc co cin wcel cS vt cv cmin co vr cv clt wbr wa wph
      vt cv cr wcel vr cv vb cv vc cv cicc co wcel vr cv cr wcel wi cc0 vt cv
      clt wbr wph vb cv vc cv cicc co cr vr cv wph vb cv cr wcel vc cv cr wcel
      wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem5.1 reconnlem2
      vb cv vc cv iccssre syl sseld 3ad2ant1 vr cv vu cv vb cv vc cv cicc co
      cin wcel vr cv vb cv vc cv cicc co wcel cS vt cv cmin co vr cv clt wbr vu
      cv vb cv vc cv cicc co cin vb cv vc cv cicc co vr cv vu cv vb cv vc cv
      cicc co inss2 sseli adantr syl5 vr cv vu cv vb cv vc cv cicc co cin wcel
      cS vt cv cmin co vr cv clt wbr wa cS vt cv cmin co vr cv clt wbr wi wph
      vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin
      wcel cS vt cv cmin co vr cv clt wbr pm3.27 a1i wph vt cv cr wcel cc0 vt
      cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel vr cv cS vt cv
      caddc co clt wbr cS vt cv cmin co vr cv clt wbr wph vt cv cr wcel cc0 vt
      cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel vr cv cr wcel vr
      cv cS cle wbr wa vr cv cS vt cv caddc co clt wbr wph vt cv cr wcel vr cv
      vu cv vb cv vc cv cicc co cin wcel vr cv cr wcel vr cv cS cle wbr wa wi
      cc0 vt cv clt wbr wph vr cv vu cv vb cv vc cv cicc co cin wcel vr cv cr
      wcel vr cv cS cle wbr wph vr cv vb cv vc cv cicc co wcel vr cv cr wcel vr
      cv vu cv vb cv vc cv cicc co cin wcel wph vb cv vc cv cicc co cr vr cv
      wph vb cv cr wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu
      cA vb vc reconnlem5.1 reconnlem2 vb cv vc cv iccssre syl sseld vu cv vb
      cv vc cv cicc co cin vb cv vc cv cicc co vr cv vu cv vb cv vc cv cicc co
      inss2 sseli syl5 wph vr cv vu cv vb cv vc cv cicc co cin wcel vr cv cS
      cle wbr wph vr cv vu cv vb cv vc cv cicc co cin wcel wa vr cv vu cv vb cv
      vc cv cicc co cin cr clt csup cS cle vu cv vb cv vc cv cicc co cin cr wss
      vu cv vb cv vc cv cicc co cin c0 wne vn cv vm cv cle wbr vn vu cv vb cv
      vc cv cicc co cin wral vm cr wrex w3a vr cv vu cv vb cv vc cv cicc co cin
      wcel vr cv vu cv vb cv vc cv cicc co cin cr clt csup cle wbr wph vm vn vu
      cv vb cv vc cv cicc co cin vr cv suprub vb cv cr wcel vc cv cr wcel wa vu
      cv vb cv vc cv cicc co cin vb cv vc cv cicc co wss vb cv vu cv vb cv vc
      cv cicc co cin wcel vu cv vb cv vc cv cicc co cin cr wss vu cv vb cv vc
      cv cicc co cin c0 wne vn cv vm cv cle wbr vn vu cv vb cv vc cv cicc co
      cin wral vm cr wrex w3a wph vm vn vb cv vc cv vb cv vu cv vb cv vc cv
      cicc co cin iccsupr wph vv vu cA vb vc reconnlem5.1 reconnlem2 vu cv vb
      cv vc cv cicc co cin vb cv vc cv cicc co wss wph vu cv vb cv vc cv cicc
      co inss2 a1i vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA
      wss wa vb cv vu cv wcel vb cv vb cv vc cv cicc co wcel wa wph vb cv vu cv
      vb cv vc cv cicc co cin wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc
      cv cicc co cA wss wa vb cv vu cv wcel vb cv vb cv vc cv cicc co wcel vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel
      wa wa wa vb cv vu cv wcel vb cv vc cv cle wbr vb cv vc cv cicc co cA wss
      vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA
      cdif wss w3a vb cv vu cv wcel cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vb cv vu cv wcel vu cv vv cv cin cr cA cdif wss vu cv cA cin vu cv
      vb cv vu cv cA inss1 sseli 3ad2ant1 adantr ad2antrr vb cv cr wcel vc cv
      cr wcel wa vb cv vc cv cle wbr vb cv vb cv vc cv cicc co wcel vb cv vu cv
      cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA
      cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa
      vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vb cv cr wcel vc cv
      cr wcel vb cv vc cv cle wbr vb cv vb cv vc cv cicc co wcel vb cv vc cv
      lbicc2 3expa vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA
      wss wa vv vu cA vb vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc
      co cA wss wa biid reconnlem2 vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr vb cv vc cv
      cicc co cA wss simplr sylanc jca reconnlem5.1 vb cv vu cv vb cv vc cv
      cicc co elin 3imtr4i syl3anc sylan reconnlem5.2 syl6breqr ex jcad
      3ad2ant1 wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cr wcel vr cv cS
      cle wbr wa vr cv cS vt cv caddc co clt wbr wph vt cv cr wcel cc0 vt cv
      clt wbr w3a vr cv cr wcel vr cv cS cle wbr wa wa vr cv vr cv cc0 caddc co
      cS vt cv caddc co clt vr cv cr wcel vr cv vr cv cc0 caddc co wceq wph vt
      cv cr wcel cc0 vt cv clt wbr w3a vr cv cS cle wbr vr cv cr wcel vr cv cc0
      caddc co vr cv vr cv cr wcel vr cv cc wcel vr cv cc0 caddc co vr cv wceq
      vr cv recn vr cv addid1 syl eqcomd ad2antrl vr cv cr wcel cc0 cr wcel wa
      cS cr wcel vt cv cr wcel wa wa vr cv cS cle wbr cc0 vt cv clt wbr wa vr
      cv cc0 caddc co cS vt cv caddc co clt wbr wph vt cv cr wcel cc0 vt cv clt
      wbr w3a vr cv cr wcel vr cv cS cle wbr wa wa vr cv cc0 cS vt cv leltadd
      wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cr wcel vr cv cS cle wbr wa
      wa vr cv cr wcel cc0 cr wcel wa cS cr wcel vt cv cr wcel wph vt cv cr
      wcel cc0 vt cv clt wbr w3a vr cv cr wcel vr cv cS cle wbr wa wa vr cv cr
      wcel cc0 cr wcel wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cr wcel vr
      cv cS cle wbr simprl 0re jctir wph vt cv cr wcel cc0 vt cv clt wbr w3a cS
      cr wcel vr cv cr wcel vr cv cS cle wbr wa wph vt cv cr wcel cS cr wcel
      cc0 vt cv clt wbr wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv
      cr wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem5.1
      reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem5.1
      reconnlem5.2 reconnlem3 sseldd 3ad2ant1 adantr wph vt cv cr wcel cc0 vt
      cv clt wbr w3a vt cv cr wcel vr cv cr wcel vr cv cS cle wbr wa wph vt cv
      cr wcel cc0 vt cv clt wbr 3simp2 adantr jca32 wph vt cv cr wcel cc0 vt cv
      clt wbr w3a vr cv cr wcel vr cv cS cle wbr wa wa vr cv cS cle wbr cc0 vt
      cv clt wbr wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cr wcel vr cv cS
      cle wbr simprr wph vt cv cr wcel cc0 vt cv clt wbr w3a cc0 vt cv clt wbr
      vr cv cr wcel vr cv cS cle wbr wa wph vt cv cr wcel cc0 vt cv clt wbr
      3simp3 adantr jca sylc eqbrtrd ex syld adantrd 3jcad wph vt cv cr wcel
      cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel cS vt cv
      cmin co vr cv clt wbr wa vr cv vv cv wcel wn wph vt cv cr wcel cc0 vt cv
      clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel cS vt cv cmin co vr
      cv clt wbr wa wa vr cv vv cv wcel cA cr cA cdif cin c0 wceq cA cr difdisj
      wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co
      cin wcel cS vt cv cmin co vr cv clt wbr wa wa vr cv vv cv wcel vr cv cA
      cr cA cdif cin wcel cA cr cA cdif cin c0 wceq wn wph vt cv cr wcel cc0 vt
      cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel cS vt cv cmin co
      vr cv clt wbr wa wa vr cv vv cv wcel vr cv cA wcel vr cv cr cA cdif wcel
      wa vr cv cA cr cA cdif cin wcel wph vt cv cr wcel cc0 vt cv clt wbr w3a
      vr cv vu cv vb cv vc cv cicc co cin wcel cS vt cv cmin co vr cv clt wbr
      wa wa vr cv vv cv wcel vr cv cA wcel vr cv cr cA cdif wcel wph vt cv cr
      wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel vr cv
      vv cv wcel vr cv cA wcel wi cS vt cv cmin co vr cv clt wbr wph vt cv cr
      wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co cin wcel wa vr
      cv cA wcel vr cv vv cv wcel wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv
      vb cv vc cv cicc co wcel vr cv cA wcel vr cv vu cv vb cv vc cv cicc co
      cin wcel wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vb cv vc cv cicc
      co wcel vr cv cA wcel wph vt cv cr wcel vr cv vb cv vc cv cicc co wcel vr
      cv cA wcel wi cc0 vt cv clt wbr wph vb cv vc cv cicc co cA vr cv wph vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel
      wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss reconnlem5.1
      pm3.27bi sseld 3ad2ant1 imp vu cv vb cv vc cv cicc co cin vb cv vc cv
      cicc co vr cv vu cv vb cv vc cv cicc co inss2 sseli sylan2 a1d adantrr
      wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv cicc co
      cin wcel vr cv vv cv wcel vr cv cr cA cdif wcel wi cS vt cv cmin co vr cv
      clt wbr wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vb cv vc cv
      cicc co cin wcel vr cv vv cv wcel vr cv cr cA cdif wcel wi wph vt cv cr
      wcel cc0 vt cv clt wbr w3a vr cv vu cv wcel vr cv vv cv wcel vr cv cr cA
      cdif wcel wi vr cv vu cv vb cv vc cv cicc co cin wcel wph vt cv cr wcel
      cc0 vt cv clt wbr w3a vr cv vu cv wcel vr cv vv cv wcel vr cv cr cA cdif
      wcel wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv vu cv vv cv cin wcel
      vr cv cr cA cdif wcel vr cv vu cv wcel vr cv vv cv wcel wa wph vt cv cr
      wcel vr cv vu cv vv cv cin wcel vr cv cr cA cdif wcel wi cc0 vt cv clt
      wbr wph vu cv vv cv cin cr cA cdif vr cv wph vb cv vu cv cA cin wcel vc
      cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv
      cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa vu cv vv cv cin cr cA cdif wss
      reconnlem5.1 vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vu cv vv cv cin cr cA cdif wss vb cv vc cv cle
      wbr vb cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a vu cv vv cv cin cr cA cdif wss cA
      cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss 3simp3 adantr ad2antrr sylbi sseld 3ad2ant1 vr cv vu cv vv cv elin
      syl5ibr exp3a vu cv vb cv vc cv cicc co cin vu cv vr cv vu cv vb cv vc cv
      cicc co inss1 sseli syl5 imp adantrr jcad vr cv cA cr cA cdif elin
      syl6ibr cA cr cA cdif cin vr cv n0i syl6 mt2i ex jcad 19.22dv cS vt cv
      cmin co vr cv clt wbr vr vu cv vb cv vc cv cicc co cin df-rex syl5ib mpd
      wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cS vt cv cabs cmin ccom cr
      cr cxp cres cbl cfv co wcel vr cv vv cv wcel wn wa vr cv cr wcel cS vt cv
      cmin co vr cv clt wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv
      wcel wn wa vr wph vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cS vt cv cabs
      cmin ccom cr cr cxp cres cbl cfv co wcel vr cv cr wcel cS vt cv cmin co
      vr cv clt wbr vr cv cS vt cv caddc co clt wbr w3a vr cv vv cv wcel wn wph
      vt cv cr wcel cc0 vt cv clt wbr w3a vr cv cS vt cv cabs cmin ccom cr cr
      cxp cres cbl cfv co wcel vr cv cS vt cv cmin co cS vt cv caddc co cioo co
      wcel vr cv cr wcel cS vt cv cmin co vr cv clt wbr vr cv cS vt cv caddc co
      clt wbr w3a wph vt cv cr wcel cc0 vt cv clt wbr w3a cS vt cv cabs cmin
      ccom cr cr cxp cres cbl cfv co cS vt cv cmin co cS vt cv caddc co cioo co
      vr cv cS cr wcel vt cv cr wcel cc0 vt cv clt wbr cS vt cv cabs cmin ccom
      cr cr cxp cres cbl cfv co cS vt cv cmin co cS vt cv caddc co cioo co wceq
      wph cS vt cv cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres
      eqid bl2ioo wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel
      wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem5.1 reconnlem2
      vb cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem5.1 reconnlem5.2
      reconnlem3 sseldd syl3an1 eleq2d wph vt cv cr wcel vr cv cS vt cv cmin co
      cS vt cv caddc co cioo co wcel vr cv cr wcel cS vt cv cmin co vr cv clt
      wbr vr cv cS vt cv caddc co clt wbr w3a wb cc0 vt cv clt wbr cS vt cv
      cmin co cxr wcel cS vt cv caddc co cxr wcel vr cv cS vt cv cmin co cS vt
      cv caddc co cioo co wcel vr cv cr wcel cS vt cv cmin co vr cv clt wbr vr
      cv cS vt cv caddc co clt wbr w3a wb wph vt cv cr wcel wa cS vt cv cmin co
      cS vt cv caddc co vr cv elioo2 wph vt cv cr wcel wa cS vt cv cmin co cr
      wcel cS vt cv cmin co cxr wcel cS cr wcel vt cv cr wcel cS vt cv cmin co
      cr wcel wph cS vt cv resubcl wph vb cv vc cv cicc co cr cS wph vb cv cr
      wcel vc cv cr wcel wa vb cv vc cv cicc co cr wss wph vv vu cA vb vc
      reconnlem5.1 reconnlem2 vb cv vc cv iccssre syl wph vv vu cA cS vb vc
      reconnlem5.1 reconnlem5.2 reconnlem3 sseldd sylan cS vt cv cmin co rexr
      syl wph vt cv cr wcel wa cS vt cv caddc co cr wcel cS vt cv caddc co cxr
      wcel cS cr wcel vt cv cr wcel cS vt cv caddc co cr wcel wph cS vt cv
      readdcl wph vb cv vc cv cicc co cr cS wph vb cv cr wcel vc cv cr wcel wa
      vb cv vc cv cicc co cr wss wph vv vu cA vb vc reconnlem5.1 reconnlem2 vb
      cv vc cv iccssre syl wph vv vu cA cS vb vc reconnlem5.1 reconnlem5.2
      reconnlem3 sseldd sylan cS vt cv caddc co rexr syl sylanc 3adant3 bitrd
      anbi1d exbidv mpbird vr cS vt cv cabs cmin ccom cr cr cxp cres cbl cfv co
      vv cv nss sylibr 3exp r19.21aiv cc0 vt cv clt wbr cS vt cv cabs cmin ccom
      cr cr cxp cres cbl cfv co vv cv wss vt cr ralinexa sylib cabs cmin ccom
      cr cr cxp cres cme wcel vv cv cioo crn ctg cfv wcel cS vv cv wcel cc0 vt
      cv clt wbr cS vt cv cabs cmin ccom cr cr cxp cres cbl cfv co vv cv wss wa
      vt cr wrex wph cS vv cv wcel wa vt vv cv cabs cmin ccom cr cr cxp cres cS
      cioo crn ctg cfv cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp
      cres copn cfv cabs cmin ccom cr cr cxp cres eqid cabs cmin ccom cr cr cxp
      cres copn cfv eqid tgioo opni2 cabs cmin ccom cr cr cxp cres cme wcel wph
      cS vv cv wcel wa cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp
      cres eqid remet a1i wph vv cv cioo crn ctg cfv wcel cS vv cv wcel wph vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel
      wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa vv cv cioo
      crn ctg cfv wcel reconnlem5.1 vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vv cv cioo crn ctg cfv wcel vb
      cv vc cv cle wbr vb cv vc cv cicc co cA wss vb cv vu cv cA cin wcel vc cv
      vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel simprrr ad2antrr sylbi
      adantr wph cS vv cv wcel pm3.27 syl3anc mtand $.
      $( [17-Aug-2009] $) $( [17-Aug-2009] $)
  $}

  ${
    $d b c u v x y A $.
    $( A subset of the reals is connected iff it has the interval property. $)
    reconn $p |- ( A C_ RR -> ( ( subSp ` <. A , ( topGen ` ran (,) ) >. ) e.
     Con <-> A. x e. A A. y e. A ( x [,] y ) C_ A ) ) $=
      cA cr wss cA cioo crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc
      co cA wss vy cA wral vx cA wral cA cr wss cA cioo crn ctg cfv cop csubsp
      cfv ccon wcel vx cv vy cv cicc co cA wss vy cA wral vx cA wral vx vy cA
      reconnlem1 ex cA cr wss vx cv vy cv cicc co cA wss vy cA wral vx cA wral
      vu cv cA cin c0 wne vv cv cA cin c0 wne vu cv vv cv cin cr cA cdif wss
      w3a cA vu cv vv cv cun wss wn wi vv cioo crn ctg cfv wral vu cioo crn ctg
      cfv wral cA cioo crn ctg cfv cop csubsp cfv ccon wcel cA cr wss vx cv vy
      cv cicc co cA wss vy cA wral vx cA wral vu cv cA cin c0 wne vv cv cA cin
      c0 wne vu cv vv cv cin cr cA cdif wss w3a cA vu cv vv cv cun wss wn wi vu
      vv cioo crn ctg cfv cioo crn ctg cfv vu cv cA cin c0 wne vv cv cA cin c0
      wne vu cv vv cv cin cr cA cdif wss w3a vx cv vy cv cicc co cA wss vy cA
      wral vx cA wral cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg
      cfv wcel wa wa cA vu cv vv cv cun wss wn vu cv cA cin c0 wne vv cv cA cin
      c0 wne vu cv vv cv cin cr cA cdif wss vx cv vy cv cicc co cA wss vy cA
      wral vx cA wral cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg
      cfv wcel wa wa cA vu cv vv cv cun wss wn wi wi vu cv cA cin c0 wne vb cv
      vu cv cA cin wcel vb wex vv cv cA cin c0 wne vu cv vv cv cin cr cA cdif
      wss vx cv vy cv cicc co cA wss vy cA wral vx cA wral cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa cA vu cv vv cv cun wss
      wn wi wi wi wi vb vu cv cA cin n0 vb cv vu cv cA cin wcel vv cv cA cin c0
      wne vu cv vv cv cin cr cA cdif wss vx cv vy cv cicc co cA wss vy cA wral
      vx cA wral cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa cA vu cv vv cv cun wss wn wi wi wi wi vb vv cv cA cin c0 wne
      vb cv vu cv cA cin wcel vu cv vv cv cin cr cA cdif wss vx cv vy cv cicc
      co cA wss vy cA wral vx cA wral cA cr wss vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa wa cA vu cv vv cv cun wss wn wi wi wi vv cv
      cA cin c0 wne vc cv vv cv cA cin wcel vc wex vb cv vu cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss vx cv vy cv cicc co cA wss vy cA wral vx cA
      wral cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa cA vu cv vv cv cun wss wn wi wi wi wi vc vv cv cA cin n0 vc cv vv cv
      cA cin wcel vb cv vu cv cA cin wcel vu cv vv cv cin cr cA cdif wss vx cv
      vy cv cicc co cA wss vy cA wral vx cA wral cA cr wss vu cv cioo crn ctg
      cfv wcel vv cv cioo crn ctg cfv wcel wa wa cA vu cv vv cv cun wss wn wi
      wi wi wi vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss vx cv vy cv cicc co cA wss vy cA wral vx cA wral cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa cA vu
      cv vv cv cun wss wn wi wi wi vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss vx cv vy cv cicc co cA wss vy cA wral
      vx cA wral cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa cA vu cv vv cv cun wss wn wi wi vb cv vu cv cA cin wcel vc cv
      vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vx cv vy cv cicc co cA
      wss vy cA wral vx cA wral cA vu cv vv cv cun wss wn vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vx cv vy cv
      cicc co cA wss vy cA wral vx cA wral cA vu cv vv cv cun wss wn wi vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr vc cv vb cv cle wbr wo vx cv vy cv cicc co cA
      wss vy cA wral vx cA wral cA vu cv vv cv cun wss wn wi vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vb cv vc cv cle wbr vc cv vb cv cle wbr wo vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa cA cr wss vb cv vu cv cA cin wcel vc cv vv cv
      cA cin wcel vu cv vv cv cin cr cA cdif wss w3a vb cv vc cv cle wbr vc cv
      vb cv cle wbr wo vb cv cr wcel vc cv cr wcel vb cv vc cv cle wbr vc cv vb
      cv cle wbr wo cA cr wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a wa vb cv vc cv letric cA cr wss vc cv
      vv cv cA cin wcel vb cv vu cv cA cin wcel vb cv cr wcel vu cv vv cv cin
      cr cA cdif wss cA cr wss vb cv cA wcel vb cv cr wcel vb cv vu cv cA cin
      wcel cA cr vb cv ssel2 vu cv cA cin cA vb cv vu cv cA inss2 sseli sylan2
      3ad2antr1 cA cr wss vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vc cv
      cr wcel vu cv vv cv cin cr cA cdif wss cA cr wss vc cv cA wcel vc cv cr
      wcel vc cv vv cv cA cin wcel cA cr vc cv ssel2 vv cv cA cin cA vc cv vv
      cv cA inss2 sseli sylan2 3ad2antr2 sylanc ancoms adantrr vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb
      cv vc cv cle wbr vx cv vy cv cicc co cA wss vy cA wral vx cA wral cA vu
      cv vv cv cun wss wn wi vc cv vb cv cle wbr vb cv vu cv cA cin wcel vc cv
      vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr
      vx cv vy cv cicc co cA wss vy cA wral vx cA wral cA vu cv vv cv cun wss
      wn wi vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr
      cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg
      cfv wcel wa wa wa vb cv vc cv cle wbr wa vx cv vy cv cicc co cA wss vy cA
      wral vx cA wral vb cv vc cv cicc co cA wss cA vu cv vv cv cun wss wn vb
      cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif
      wss w3a vx cv vy cv cicc co cA wss vy cA wral vx cA wral vb cv vc cv cicc
      co cA wss wi cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa vb cv vc cv cle wbr vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vx cv vy cv cicc co cA wss vy cA wral vx cA wral vb cv vc cv cicc co
      cA wss wi vu cv vv cv cin cr cA cdif wss vb cv cA wcel vc cv cA wcel vx
      cv vy cv cicc co cA wss vy cA wral vx cA wral vb cv vc cv cicc co cA wss
      wi vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vx cv vy cv cicc co cA
      wss vb cv vc cv cicc co cA wss vb cv vy cv cicc co cA wss vx vy vb cv vc
      cv cA cA vx cv vb cv wceq vx cv vy cv cicc co vb cv vy cv cicc co cA vx
      cv vb cv vy cv cicc opreq1 sseq1d vy cv vc cv wceq vb cv vy cv cicc co vb
      cv vc cv cicc co cA vy cv vc cv vb cv cicc opreq2 sseq1d rcla42v vu cv cA
      cin cA vb cv vu cv cA inss2 sseli vv cv cA cin cA vc cv vv cv cA inss2
      sseli syl2an 3adant3 ad2antrr vb cv vu cv cA cin wcel vc cv vv cv cA cin
      wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv
      wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc
      cv cicc co cA wss cA vu cv vv cv cun wss wn vb cv vu cv cA cin wcel vc cv
      vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo
      crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr
      wa vb cv vc cv cicc co cA wss wa cA vu cv vv cv cun wss vu cv vb cv vc cv
      cicc co cin cr clt csup vu cv wcel vu cv vb cv vc cv cicc co cin cr clt
      csup vv cv wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv
      cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv
      cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co
      cA wss wa vv vu cA vu cv vb cv vc cv cicc co cin cr clt csup vb vc vb cv
      vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss
      w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa
      wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa biid vu cv vb
      cv vc cv cicc co cin cr clt csup eqid reconnlem4 vb cv vu cv cA cin wcel
      vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv
      cle wbr wa vb cv vc cv cicc co cA wss wa vv vu cA vu cv vb cv vc cv cicc
      co cin cr clt csup vb vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa biid vu cv vb cv vc cv cicc co cin cr clt csup eqid
      reconnlem5 vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv
      cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo
      crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA
      wss wa cA vu cv vv cv cun wss vu cv vb cv vc cv cicc co cin cr clt csup
      vu cv vv cv cun wcel vu cv vb cv vc cv cicc co cin cr clt csup vu cv wcel
      vu cv vb cv vc cv cicc co cin cr clt csup vv cv wcel wo vb cv vu cv cA
      cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr
      wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb
      cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa cA vu cv vv cv cun wss
      vb cv vc cv cicc co vu cv vv cv cun wss vu cv vb cv vc cv cicc co cin cr
      clt csup vu cv vv cv cun wcel vb cv vc cv cicc co cA wss cA vu cv vv cv
      cun wss vb cv vc cv cicc co vu cv vv cv cun wss wi vb cv vu cv cA cin
      wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss
      vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc
      cv cle wbr wa vb cv vc cv cicc co cA vu cv vv cv cun sstr2 adantl vb cv
      vc cv cicc co vu cv vv cv cun wss vu cv vb cv vc cv cicc co cin cr clt
      csup vb cv vc cv cicc co wcel vu cv vb cv vc cv cicc co cin cr clt csup
      vu cv vv cv cun wcel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu
      cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc
      co cA wss wa vb cv vc cv cicc co vu cv vv cv cun vu cv vb cv vc cv cicc
      co cin cr clt csup ssel vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel
      vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel
      vv cv cioo crn ctg cfv wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv
      cicc co cA wss wa vv vu cA vu cv vb cv vc cv cicc co cin cr clt csup vb
      vc vb cv vu cv cA cin wcel vc cv vv cv cA cin wcel vu cv vv cv cin cr cA
      cdif wss w3a cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv
      wcel wa wa wa vb cv vc cv cle wbr wa vb cv vc cv cicc co cA wss wa biid
      vu cv vb cv vc cv cicc co cin cr clt csup eqid reconnlem3 syl5com syld vu
      cv vb cv vc cv cicc co cin cr clt csup vu cv vv cv elun syl6ib mtord ex
      syld ex vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin
      cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel vu cv cioo crn
      ctg cfv wcel wa wa vc cv vb cv cle wbr vx cv vy cv cicc co cA wss vy cA
      wral vx cA wral cA vu cv vv cv cun wss wn wi wi vb cv vu cv cA cin wcel
      vc cv vv cv cA cin wcel vu cv vv cv cin cr cA cdif wss w3a cA cr wss vu
      cv cioo crn ctg cfv wcel vv cv cioo crn ctg cfv wcel wa wa vc cv vv cv cA
      cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss w3a cA cr
      wss vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa wa wa vc
      cv vb cv cle wbr vx cv vy cv cicc co cA wss vy cA wral vx cA wral cA vu
      cv vv cv cun wss wn wi vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv
      cv vu cv cin cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel vu
      cv cioo crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa vx cv vy cv cicc
      co cA wss vy cA wral vx cA wral vc cv vb cv cicc co cA wss cA vu cv vv cv
      cun wss wn vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv
      cin cr cA cdif wss w3a vx cv vy cv cicc co cA wss vy cA wral vx cA wral
      vc cv vb cv cicc co cA wss wi cA cr wss vv cv cioo crn ctg cfv wcel vu cv
      cioo crn ctg cfv wcel wa wa vc cv vb cv cle wbr vc cv vv cv cA cin wcel
      vb cv vu cv cA cin wcel vx cv vy cv cicc co cA wss vy cA wral vx cA wral
      vc cv vb cv cicc co cA wss wi vv cv vu cv cin cr cA cdif wss vc cv cA
      wcel vb cv cA wcel vx cv vy cv cicc co cA wss vy cA wral vx cA wral vc cv
      vb cv cicc co cA wss wi vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel
      vx cv vy cv cicc co cA wss vc cv vb cv cicc co cA wss vc cv vy cv cicc co
      cA wss vx vy vc cv vb cv cA cA vx cv vc cv wceq vx cv vy cv cicc co vc cv
      vy cv cicc co cA vx cv vc cv vy cv cicc opreq1 sseq1d vy cv vb cv wceq vc
      cv vy cv cicc co vc cv vb cv cicc co cA vy cv vb cv vc cv cicc opreq2
      sseq1d rcla42v vv cv cA cin cA vc cv vv cv cA inss2 sseli vu cv cA cin cA
      vb cv vu cv cA inss2 sseli syl2an 3adant3 ad2antrr vc cv vv cv cA cin
      wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss w3a cA cr wss
      vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa wa wa vc cv vb
      cv cle wbr wa vc cv vb cv cicc co cA wss cA vu cv vv cv cun wss wn vc cv
      vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss
      w3a cA cr wss vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa
      wa wa vc cv vb cv cle wbr wa vc cv vb cv cicc co cA wss wa cA vv cv vu cv
      cun wss wn cA vu cv vv cv cun wss wn vc cv vv cv cA cin wcel vb cv vu cv
      cA cin wcel vv cv vu cv cin cr cA cdif wss w3a cA cr wss vv cv cioo crn
      ctg cfv wcel vu cv cioo crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa
      vc cv vb cv cicc co cA wss wa cA vv cv vu cv cun wss vv cv vc cv vb cv
      cicc co cin cr clt csup vv cv wcel vv cv vc cv vb cv cicc co cin cr clt
      csup vu cv wcel vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu
      cv cin cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel vu cv
      cioo crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa vc cv vb cv cicc co
      cA wss wa vu vv cA vv cv vc cv vb cv cicc co cin cr clt csup vc vb vc cv
      vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss
      w3a cA cr wss vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa
      wa wa vc cv vb cv cle wbr wa vc cv vb cv cicc co cA wss wa biid vv cv vc
      cv vb cv cicc co cin cr clt csup eqid reconnlem4 vc cv vv cv cA cin wcel
      vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss w3a cA cr wss vv
      cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa wa wa vc cv vb cv
      cle wbr wa vc cv vb cv cicc co cA wss wa vu vv cA vv cv vc cv vb cv cicc
      co cin cr clt csup vc vb vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel
      vv cv vu cv cin cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel
      vu cv cioo crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa vc cv vb cv
      cicc co cA wss wa biid vv cv vc cv vb cv cicc co cin cr clt csup eqid
      reconnlem5 vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv
      cin cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel vu cv cioo
      crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa vc cv vb cv cicc co cA
      wss wa cA vv cv vu cv cun wss vv cv vc cv vb cv cicc co cin cr clt csup
      vv cv vu cv cun wcel vv cv vc cv vb cv cicc co cin cr clt csup vv cv wcel
      vv cv vc cv vb cv cicc co cin cr clt csup vu cv wcel wo vc cv vv cv cA
      cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss w3a cA cr
      wss vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa wa wa vc
      cv vb cv cle wbr wa vc cv vb cv cicc co cA wss wa cA vv cv vu cv cun wss
      vc cv vb cv cicc co vv cv vu cv cun wss vv cv vc cv vb cv cicc co cin cr
      clt csup vv cv vu cv cun wcel vc cv vb cv cicc co cA wss cA vv cv vu cv
      cun wss vc cv vb cv cicc co vv cv vu cv cun wss wi vc cv vv cv cA cin
      wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss w3a cA cr wss
      vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv wcel wa wa wa vc cv vb
      cv cle wbr wa vc cv vb cv cicc co cA vv cv vu cv cun sstr2 adantl vc cv
      vb cv cicc co vv cv vu cv cun wss vv cv vc cv vb cv cicc co cin cr clt
      csup vc cv vb cv cicc co wcel vv cv vc cv vb cv cicc co cin cr clt csup
      vv cv vu cv cun wcel vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv
      cv vu cv cin cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel vu
      cv cioo crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa vc cv vb cv cicc
      co cA wss wa vc cv vb cv cicc co vv cv vu cv cun vv cv vc cv vb cv cicc
      co cin cr clt csup ssel vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel
      vv cv vu cv cin cr cA cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel
      vu cv cioo crn ctg cfv wcel wa wa wa vc cv vb cv cle wbr wa vc cv vb cv
      cicc co cA wss wa vu vv cA vv cv vc cv vb cv cicc co cin cr clt csup vc
      vb vc cv vv cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA
      cdif wss w3a cA cr wss vv cv cioo crn ctg cfv wcel vu cv cioo crn ctg cfv
      wcel wa wa wa vc cv vb cv cle wbr wa vc cv vb cv cicc co cA wss wa biid
      vv cv vc cv vb cv cicc co cin cr clt csup eqid reconnlem3 syl5com syld vv
      cv vc cv vb cv cicc co cin cr clt csup vv cv vu cv elun syl6ib mtord cA
      vv cv vu cv cun wss cA vu cv vv cv cun wss vv cv vu cv cun vu cv vv cv
      cun cA vv cv vu cv uncom sseq2i notbii sylib ex syld ex vc cv vv cv cA
      cin wcel vb cv vu cv cA cin wcel vu cv vv cv cin cr cA cdif wss vc cv vv
      cv cA cin wcel vb cv vu cv cA cin wcel vv cv vu cv cin cr cA cdif wss w3a
      vu cv vv cv cin cr cA cdif wss vv cv vu cv cin cr cA cdif wss vc cv vv cv
      cA cin wcel vb cv vu cv cA cin wcel vu cv vv cv cin cr cA cdif wss vv cv
      vu cv cin cr cA cdif wss vu cv vv cv cin vv cv vu cv cin cr cA cdif vu cv
      vv cv incom sseq1i biimpi 3anim3i 3com12 vu cv cioo crn ctg cfv wcel vv
      cv cioo crn ctg cfv wcel wa vv cv cioo crn ctg cfv wcel vu cv cioo crn
      ctg cfv wcel wa cA cr wss vu cv cioo crn ctg cfv wcel vv cv cioo crn ctg
      cfv wcel pm3.22 anim2i syl2an jaod mpd ex com23 3exp com12 19.23aiv sylbi
      com12 19.23aiv sylbi 3imp com13 r19.21advva cioo crn ctg cfv ctop wcel cA
      cr wss cA cioo crn ctg cfv cop csubsp cfv ccon wcel vu cv cA cin c0 wne
      vv cv cA cin c0 wne vu cv vv cv cin cr cA cdif wss w3a cA vu cv vv cv cun
      wss wn wi vv cioo crn ctg cfv wral vu cioo crn ctg cfv wral wb retop vu
      vv cA cioo crn ctg cfv cr cioo crn ctg cfv cuni cr uniretop eqcomi
      connsub mpan sylibrd impbid $.
      $( [17-Aug-2009] $) $( [15-Jul-2009] $)
  $}

  ${
    $d x y $.
    $( Corollary of ~ reconn . The set of real numbers is connected. $)
    retopcon $p |- ( topGen ` ran (,) ) e. Con $=
      cr cioo crn ctg cfv cop csubsp cfv cioo crn ctg cfv ccon cioo crn ctg cfv
      ctop wcel cr cioo crn ctg cfv cop csubsp cfv cioo crn ctg cfv wceq retop
      cioo crn ctg cfv cr cioo crn ctg cfv cuni cr uniretop eqcomi subspid
      ax-mp cr cioo crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc co cr
      wss vy cr wral vx cr wral vx cv vy cv cicc co cr wss vx vy cr vx cv vy cv
      iccssre rgen2a cr cr wss cr cioo crn ctg cfv cop csubsp cfv ccon wcel vx
      cv vy cv cicc co cr wss vy cr wral vx cr wral wb cr ssid vx vy cr reconn
      ax-mp mpbir eqeltrri $.
      $( [17-Aug-2009] $) $( [17-Aug-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $.
    $( A closed interval is connected. $)
    iccconn $p |- ( ( A e. RR /\ B e. RR ) -> ( subSp ` <. ( A [,] B ) , (
     topGen ` ran (,) ) >. ) e. Con ) $=
      cA cr wcel cB cr wcel wa cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      ccon wcel vx cv vy cv cicc co cA cB cicc co wss vy cA cB cicc co wral vx
      cA cB cicc co wral cA cr wcel cB cr wcel wa vx cv vy cv cicc co cA cB
      cicc co wss vx vy cA cB cicc co cA cB cicc co cA cr wcel cB cr wcel wa vx
      cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa vx cv vy cv cicc co cA
      cB cicc co wss cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA
      cB cicc co wcel wa wa vz vx cv vy cv cicc co cA cB cicc co cA cr wcel cB
      cr wcel wa vx cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa wa vz cv
      cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cr wcel cA vz
      cv cle wbr vz cv cB cle wbr w3a vz cv vx cv vy cv cicc co wcel vz cv cA
      cB cicc co wcel cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv
      cA cB cicc co wcel wa wa vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv
      cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr vz cv cr wcel
      vx cv vz cv cle wbr vz cv vy cv cle wbr w3a cA cr wcel cB cr wcel wa vx
      cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa wa vz cv cr wcel vz cv
      cr wcel vx cv vz cv cle wbr cA cr wcel cB cr wcel wa vx cv cA cB cicc co
      wcel vy cv cA cB cicc co wcel wa wa vz cv cr wcel wi vz cv vy cv cle wbr
      vz cv cr wcel cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA
      cB cicc co wcel wa wa ax-1 3ad2ant1 com12 cA cr wcel cB cr wcel wa vx cv
      cA cB cicc co wcel vy cv cA cB cicc co wcel wa wa vz cv cr wcel vx cv vz
      cv cle wbr vz cv vy cv cle wbr w3a cA vz cv cle wbr cA cr wcel cB cr wcel
      wa vx cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa wa vz cv cr wcel
      vx cv vz cv cle wbr vz cv vy cv cle wbr w3a wa cA vx cv vz cv cA cr wcel
      cB cr wcel vx cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa vz cv cr
      wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a simplll cA cr wcel cB cr
      wcel wa vx cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa wa vx cv cr
      wcel vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a cA cr wcel
      cB cr wcel wa vx cv cA cB cicc co wcel vx cv cr wcel vy cv cA cB cicc co
      wcel cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vx cv cr wcel cA
      cr wcel cB cr wcel wa cA cB cicc co cr vx cv cA cB iccssre sseld imp
      adantrr adantr vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a
      vz cv cr wcel cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA
      cB cicc co wcel wa wa vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle
      wbr 3simp1 adantl cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv
      cA cB cicc co wcel wa wa cA vx cv cle wbr vz cv cr wcel vx cv vz cv cle
      wbr vz cv vy cv cle wbr w3a cA cr wcel cB cr wcel wa vx cv cA cB cicc co
      wcel cA vx cv cle wbr vy cv cA cB cicc co wcel cA cr wcel cB cr wcel wa
      vx cv cA cB cicc co wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle
      wbr cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr w3a cA cB vx cv elicc2 biimpa 3simp2d adantrr
      adantr cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA cB cicc
      co wcel wa wa vz cv cr wcel vx cv vz cv cle wbr vx cv vz cv cle wbr vz cv
      vy cv cle wbr cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA
      cB cicc co wcel wa wa vx cv vz cv cle wbr pm3.27 3ad2antr2 letrd ex cA cr
      wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa
      wa vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv cB cle
      wbr cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA cB cicc co
      wcel wa wa vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a wa
      vz cv vy cv cB cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA
      cB cicc co wcel wa wa vx cv vz cv cle wbr vz cv cr wcel vz cv cr wcel vz
      cv vy cv cle wbr cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv
      cA cB cicc co wcel wa wa vz cv cr wcel pm3.27 3ad2antr1 cA cr wcel cB cr
      wcel wa vx cv cA cB cicc co wcel vy cv cA cB cicc co wcel wa wa vy cv cr
      wcel vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a cA cr wcel
      cB cr wcel wa vy cv cA cB cicc co wcel vy cv cr wcel vx cv cA cB cicc co
      wcel cA cr wcel cB cr wcel wa vy cv cA cB cicc co wcel vy cv cr wcel cA
      cr wcel cB cr wcel wa cA cB cicc co cr vy cv cA cB iccssre sseld imp
      adantrl adantr cA cr wcel cB cr wcel vx cv cA cB cicc co wcel vy cv cA cB
      cicc co wcel wa vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a
      simpllr vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle wbr w3a vz cv
      vy cv cle wbr cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv cA
      cB cicc co wcel wa wa vz cv cr wcel vx cv vz cv cle wbr vz cv vy cv cle
      wbr 3simp3 adantl cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vy cv
      cA cB cicc co wcel wa wa vy cv cB cle wbr vz cv cr wcel vx cv vz cv cle
      wbr vz cv vy cv cle wbr w3a cA cr wcel cB cr wcel wa vy cv cA cB cicc co
      wcel vy cv cB cle wbr vx cv cA cB cicc co wcel cA cxr wcel cB cxr wcel wa
      vy cv cA cB cicc co wcel vy cv cB cle wbr cA cr wcel cB cr wcel wa cA cxr
      wcel cB cxr wcel vy cv cA cB cicc co wcel vy cv cB cle wbr cA cB vy cv
      iccleub 3expa cA cr wcel cA cxr wcel cB cr wcel cB cxr wcel cA rexr cB
      rexr anim12i sylan adantrl adantr letrd ex 3jcad vx cv cr wcel vy cv cr
      wcel vz cv vx cv vy cv cicc co wcel vz cv cr wcel vx cv vz cv cle wbr vz
      cv vy cv cle wbr w3a wb cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel
      vy cv cA cB cicc co wcel wa wa vx cv vy cv vz cv elicc2 cA cr wcel cB cr
      wcel wa vx cv cA cB cicc co wcel vx cv cr wcel vy cv cA cB cicc co wcel
      cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vx cv cr wcel cA cr
      wcel cB cr wcel wa cA cB cicc co cr vx cv cA cB iccssre sseld imp adantrr
      cA cr wcel cB cr wcel wa vy cv cA cB cicc co wcel vy cv cr wcel vx cv cA
      cB cicc co wcel cA cr wcel cB cr wcel wa vy cv cA cB cicc co wcel vy cv
      cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr vy cv cA cB iccssre
      sseld imp adantrl sylanc cA cr wcel cB cr wcel wa vz cv cA cB cicc co
      wcel vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wb vx cv cA cB
      cicc co wcel vy cv cA cB cicc co wcel wa cA cB vz cv elicc2 adantr
      3imtr4d ssrdv ex r19.21aivv cA cr wcel cB cr wcel wa cA cB cicc co cr wss
      cA cB cicc co cioo crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc
      co cA cB cicc co wss vy cA cB cicc co wral vx cA cB cicc co wral wb cA cB
      iccssre vx vy cA cB cicc co reconn syl mpbird $.
      $( [17-Aug-2009] $) $( [17-Aug-2009] $)
  $}

  ${
    $d x y A $. $d x y B $. $d x y D $. $d x y F $. $d x y U $.
    $( An alternate proof of the Intermediate Value Theorem ~ isupivthi using
       topology. $)
    ivthALT $p |- ( ( ( A e. RR /\ B e. RR /\ U e. RR ) /\ A < B /\ ( ( A [,] B
    ) C_ D /\ D C_ CC /\ ( F e. ( D -cn-> CC ) /\ ( F " ( A [,] B ) ) C_ RR /\
    U e. ( ( F ` A ) (,) ( F ` B ) ) ) ) ) -> E. x e. ( A (,) B ) ( F ` x ) = U
    )
   $=
      cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cF cfv cU wceq vx cA cB cicc
      co wrex vx cv cF cfv cU wceq vx cA cB cioo co wrex cF wfun cU cF cA cB
      cicc co cima wcel vx cv cF cfv cU wceq vx cA cB cicc co wrex cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a w3a vx cU cA cB cicc co cF fvelima cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel
      w3a cF wfun cA cB clt wbr cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cF wfun cA cB cicc
      co cD wss cD cc wss cF cA cB cicc co cima cr wss cF cD cc ccncf co wcel
      cF wfun cU cA cF cfv cB cF cfv cioo co wcel cD cc wss cF cD cc ccncf co
      wcel wa cD cc cF wf cF wfun cD cc wss cc cc wss cF cD cc ccncf co wcel cD
      cc cF wf cc ssid cD cc cF cncff mp3an2 cD cc cF ffun syl 3ad2antr1
      3adant1 3ad2ant3 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cF cfv cB cF cfv
      cicc co cF cA cB cicc co cima cU cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv
      vy cv cicc co cF cA cB cicc co cima wss vy cF cA cB cicc co cima wral vx
      cF cA cB cicc co cima wral cA cF cfv cB cF cfv cicc co cF cA cB cicc co
      cima wss cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima cioo
      crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc co cF cA cB cicc co
      cima wss vy cF cA cB cicc co cima wral vx cF cA cB cicc co cima wral cA
      cB cicc co cioo crn ctg cfv cop csubsp cfv ccon wcel cF cA cB cicc co
      cima cioo crn ctg cfv cop csubsp cfv ctop wcel cA cB cicc co cioo crn ctg
      cfv cop csubsp cfv cuni cF cA cB cicc co cima cioo crn ctg cfv cop csubsp
      cfv cuni cF cA cB cicc co cres wfo cF cA cB cicc co cres cA cB cicc co
      cioo crn ctg cfv cop csubsp cfv cF cA cB cicc co cima cioo crn ctg cfv
      cop csubsp cfv ccn co wcel cF cA cB cicc co cima cioo crn ctg cfv cop
      csubsp cfv ccon wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc
      co cres cA cB cicc co cioo crn ctg cfv cop csubsp cfv cF cA cB cicc co
      cima cioo crn ctg cfv cop csubsp cfv cA cB cicc co cioo crn ctg cfv cop
      csubsp cfv cuni cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv
      cuni cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni eqid cF cA cB
      cicc co cima cioo crn ctg cfv cop csubsp cfv cuni eqid cnconn cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cioo crn ctg cfv
      cop csubsp cfv ccon wcel cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a cA cr wcel cB cr wcel cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      ccon wcel cU cr wcel cA cB iccconn 3adant3 3ad2ant1 cioo crn ctg cfv ctop
      wcel cF cA cB cicc co cima cioo crn ctg cfv cuni wss cF cA cB cicc co
      cima cioo crn ctg cfv cop csubsp cfv ctop wcel cA cr wcel cB cr wcel cU
      cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a w3a w3a cF cA cB cicc co cima cioo crn ctg cfv stoig3 cioo crn ctg
      cfv ctop wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a retop a1i cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a w3a cF cA cB cicc co cima cr cioo crn ctg cfv cuni
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr
      wcel cU cr wcel w3a cF cA cB cicc co cima cr wss cA cB clt wbr cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a cA cB cicc co cD wss cF cA cB cicc co cima cr wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel 3simp2 3ad2ant3 3ad2ant3 uniretop syl6ssr sylanc cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a w3a cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      cuni cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB
      cicc co cres wfo cA cB cicc co cF cA cB cicc co cima cF cA cB cicc co
      cres wfo cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD wss cD cc
      cF wf wa cF wfun cA cB cicc co cF cdm wss wa cA cB cicc co cF cA cB cicc
      co cima cF cA cB cicc co cres wfo cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB cicc co cD wss cD
      cc cF wf wa cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a cA cB cicc co cD wss cD cc cF wf wa cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a wa
      cD cc cF wf cA cB cicc co cD wss cD cc wss cF cA cB cicc co cima cr wss
      cF cD cc ccncf co wcel cD cc cF wf cU cA cF cfv cB cF cfv cioo co wcel cD
      cc wss cc cc wss cF cD cc ccncf co wcel cD cc cF wf cc ssid cD cc cF
      cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3 cA cB cicc co cD wss cD cc
      cF wf wa cF wfun cA cB cicc co cF cdm wss cD cc cF wf cF wfun cA cB cicc
      co cD wss cD cc cF ffun adantl cD cc cF wf cA cB cicc co cF cdm wss cA cB
      cicc co cD wss cD cc cF wf cF cdm cD cA cB cicc co cD cc cF fdm sseq2d
      biimparc jca cA cB cicc co cF fores 3syl cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      w3a cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni cF cA cB cicc co
      cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB cicc co cres wfo cA cB
      cicc co cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA
      cB cicc co cres wfo cA cB cicc co cF cA cB cicc co cima cF cA cB cicc co
      cres wfo cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cioo crn ctg
      cfv cuni wss cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni cA cB
      cicc co wceq cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni cF cA cB
      cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB cicc co cres
      wfo cA cB cicc co cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv
      cuni cF cA cB cicc co cres wfo wb cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB
      cicc co cr cioo crn ctg cfv cuni cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cr wss cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cA cB cicc co cr wss cU cr wcel cA cB
      iccssre 3adant3 3ad2ant1 uniretop syl6ssr cioo crn ctg cfv ctop wcel cA
      cB cicc co cioo crn ctg cfv cuni wss cA cB cicc co cioo crn ctg cfv cop
      csubsp cfv cuni cA cB cicc co wceq retop cA cB cicc co cioo crn ctg cfv
      stoig2 mpan cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni cA cB cicc
      co cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB
      cicc co cres foeq2 3syl cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB
      cicc co cima cioo crn ctg cfv cuni wss cF cA cB cicc co cima cioo crn ctg
      cfv cop csubsp cfv cuni cF cA cB cicc co cima wceq cA cB cicc co cF cA cB
      cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB cicc co cres
      wfo cA cB cicc co cF cA cB cicc co cima cF cA cB cicc co cres wfo wb cA
      cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima cr cioo crn ctg
      cfv cuni cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr
      wcel cB cr wcel cU cr wcel w3a cF cA cB cicc co cima cr wss cA cB clt wbr
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a cA cB cicc co cD wss cF cA cB cicc co cima cr wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel 3simp2 3ad2ant3 3ad2ant3 uniretop syl6ssr cioo crn
      ctg cfv ctop wcel cF cA cB cicc co cima cioo crn ctg cfv cuni wss cF cA
      cB cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB cicc co
      cima wceq retop cF cA cB cicc co cima cioo crn ctg cfv stoig2 mpan cF cA
      cB cicc co cima cioo crn ctg cfv cop csubsp cfv cuni cF cA cB cicc co
      cima cA cB cicc co cF cA cB cicc co cres foeq3 3syl bitrd mpbird cA cr
      wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cres cA cB cicc co cioo
      crn ctg cfv cop csubsp cfv cioo crn ctg cfv ccn co wcel cF cA cB cicc co
      cres cA cB cicc co cioo crn ctg cfv cop csubsp cfv cF cA cB cicc co cima
      cioo crn ctg cfv cop csubsp cfv ccn co wcel cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cF cA cB cicc co cres cA cB cicc co cD cabs cmin ccom copn cfv
      cop csubsp cfv cop csubsp cfv cr cabs cmin ccom copn cfv cop csubsp cfv
      ccn co cA cB cicc co cioo crn ctg cfv cop csubsp cfv cioo crn ctg cfv ccn
      co cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cres cA cB
      cicc co cD cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cabs
      cmin ccom copn cfv ccn co wcel cF cA cB cicc co cres cA cB cicc co cD
      cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cr cabs cmin ccom
      copn cfv cop csubsp cfv ccn co wcel cD cabs cmin ccom copn cfv cop csubsp
      cfv ctop wcel cabs cmin ccom copn cfv ctop wcel cA cB cicc co cD cabs
      cmin ccom copn cfv cop csubsp cfv cuni wss cF cD cabs cmin ccom copn cfv
      cop csubsp cfv cabs cmin ccom copn cfv ccn co wcel cF cA cB cicc co cres
      cA cB cicc co cD cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv
      cabs cmin ccom copn cfv ccn co wcel cA cr wcel cB cr wcel cU cr wcel w3a
      cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA
      cB cicc co cF cD cabs cmin ccom copn cfv cop csubsp cfv cabs cmin ccom
      copn cfv cD cabs cmin ccom copn cfv cop csubsp cfv cuni cD cabs cmin ccom
      copn cfv cop csubsp cfv cuni eqid cnsubsp cabs cmin ccom copn cfv ctop
      wcel cD cabs cmin ccom copn cfv cuni wss cD cabs cmin ccom copn cfv cop
      csubsp cfv ctop wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cD cabs cmin
      ccom copn cfv stoig3 cabs cmin ccom copn cfv ctop wcel cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cabs cmin ccom cme wcel cabs cmin ccom copn cfv ctop
      wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin
      ccom copn cfv cabs cmin ccom copn cfv eqid opntop ax-mp a1i cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a w3a cD cc cabs cmin ccom copn cfv cuni cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel
      w3a cD cc wss cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a 3simp2 3ad2ant3 cabs cmin ccom cme wcel cabs cmin ccom copn cfv cuni
      cc wceq cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin
      ccom copn cfv cc cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin
      ccom copn cfv eqid uniopn2 ax-mp syl6ssr sylanc cabs cmin ccom copn cfv
      ctop wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cabs cmin ccom cme wcel
      cabs cmin ccom copn cfv ctop wcel cabs cmin ccom cabs cmin ccom eqid
      cnmet cabs cmin ccom cabs cmin ccom copn cfv cabs cmin ccom copn cfv eqid
      opntop ax-mp a1i cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD cD
      cabs cmin ccom copn cfv cop csubsp cfv cuni cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB
      cicc co cD wss cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a 3simp1 3ad2ant3 cabs cmin ccom copn cfv ctop wcel cD cabs cmin
      ccom copn cfv cuni wss cD cabs cmin ccom copn cfv cop csubsp cfv cuni cD
      wceq cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cD cabs cmin ccom copn cfv
      stoig2 cabs cmin ccom copn cfv ctop wcel cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      w3a cabs cmin ccom cme wcel cabs cmin ccom copn cfv ctop wcel cabs cmin
      ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin ccom copn cfv
      cabs cmin ccom copn cfv eqid opntop ax-mp a1i cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cD cc cabs cmin ccom copn cfv cuni cA cB cicc co cD wss cD cc wss
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cD cc wss
      cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a 3simp2
      3ad2ant3 cabs cmin ccom cme wcel cabs cmin ccom copn cfv cuni cc wceq
      cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin ccom
      copn cfv cc cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom
      copn cfv eqid uniopn2 ax-mp syl6ssr sylanc sseqtr4d cA cr wcel cB cr wcel
      cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cF cD cc ccncf co cD cabs cmin ccom copn cfv cop csubsp
      cfv cabs cmin ccom copn cfv ccn co cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cF cD cc ccncf co
      wcel cA cB clt wbr cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cF cD cc ccncf
      co wcel cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel 3simp1 3ad2ant3 3ad2ant3 cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a w3a cD cc ccncf co cabs cmin ccom cD cD cxp cres copn cfv
      cabs cmin ccom copn cfv ccn co cD cabs cmin ccom copn cfv cop csubsp cfv
      cabs cmin ccom copn cfv ccn co cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cD cc ccncf co cabs
      cmin ccom cD cD cxp cres copn cfv cabs cmin ccom copn cfv ccn co wceq cA
      cB clt wbr cD cc wss cA cB cicc co cD wss cD cc ccncf co cabs cmin ccom
      cD cD cxp cres copn cfv cabs cmin ccom copn cfv ccn co wceq cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a cD cc wss cc cc wss cD cc ccncf co cabs cmin ccom cD cD cxp cres
      copn cfv cabs cmin ccom copn cfv ccn co wceq cc ssid cD cc cabs cmin ccom
      cD cD cxp cres cabs cmin ccom cabs cmin ccom cD cD cxp cres copn cfv cabs
      cmin ccom copn cfv cabs cmin ccom cD cD cxp cres eqid cabs cmin ccom cc
      cc cxp cres cabs cmin ccom cabs cmin ccom wrel cabs cmin ccom cdm cc cc
      cxp wss cabs cmin ccom cc cc cxp cres cabs cmin ccom wceq cabs cmin relco
      cabs cmin ccom cdm cc cc cxp cabs cmin ccom cme wcel cabs cmin ccom cdm
      cc cc cxp wceq cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom
      cme wcel cc cc cxp cr cabs cmin ccom wf cabs cmin ccom cdm cc cc cxp wceq
      cabs cmin ccom cc cabs cmin ccom cabs cmin ccom eqid cnmetba metf cc cc
      cxp cr cabs cmin ccom fdm syl ax-mp eqimssi cabs cmin ccom cc cc cxp
      relssres mp2an eqcomi cabs cmin ccom cD cD cxp cres copn cfv eqid cabs
      cmin ccom copn cfv eqid cncfmet mpan2 3ad2ant2 3ad2ant3 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cD cabs cmin ccom copn cfv cop csubsp cfv cabs cmin ccom
      cD cD cxp cres copn cfv cabs cmin ccom copn cfv ccn cabs cmin ccom cme
      wcel cD cc wss cD cabs cmin ccom copn cfv cop csubsp cfv cabs cmin ccom
      cD cD cxp cres copn cfv wceq cA cr wcel cB cr wcel cU cr wcel w3a cA cB
      clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cabs
      cmin ccom cabs cmin ccom cD cD cxp cres cabs cmin ccom copn cfv cabs cmin
      ccom cD cD cxp cres copn cfv cc cD cabs cmin ccom cD cD cxp cres eqid
      cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom copn cfv eqid
      cabs cmin ccom cD cD cxp cres copn cfv eqid subtopmet cabs cmin ccom cme
      wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cabs cmin ccom cabs cmin ccom
      eqid cnmet a1i cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cU cr wcel w3a cD cc wss cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a 3simp2 3ad2ant3 sylanc opreq1d
      eqtr4d eleqtrd syl2anc cA cB cicc co cD cabs cmin ccom copn cfv cop
      csubsp cfv cop csubsp cfv ctop wcel cabs cmin ccom copn cfv ctop wcel cF
      cA cB cicc co cres crn cr wss cr cc wss cF cA cB cicc co cres cA cB cicc
      co cD cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cabs cmin
      ccom copn cfv ccn co wcel cF cA cB cicc co cres cA cB cicc co cD cabs
      cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cr cabs cmin ccom copn
      cfv cop csubsp cfv ccn co wcel wb cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cr cF
      cA cB cicc co cres cA cB cicc co cD cabs cmin ccom copn cfv cop csubsp
      cfv cop csubsp cfv cabs cmin ccom copn cfv cc cabs cmin ccom copn cfv
      cuni cc cabs cmin ccom cme wcel cabs cmin ccom copn cfv cuni cc wceq cabs
      cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin ccom copn
      cfv cc cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom copn cfv
      eqid uniopn2 ax-mp eqcomi cnsubsp2 cD cabs cmin ccom copn cfv cop csubsp
      cfv ctop wcel cA cB cicc co cD cabs cmin ccom copn cfv cop csubsp cfv
      cuni wss cA cB cicc co cD cabs cmin ccom copn cfv cop csubsp cfv cop
      csubsp cfv ctop wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co
      cD cabs cmin ccom copn cfv cop csubsp cfv stoig3 cabs cmin ccom copn cfv
      ctop wcel cD cabs cmin ccom copn cfv cuni wss cD cabs cmin ccom copn cfv
      cop csubsp cfv ctop wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cD cabs
      cmin ccom copn cfv stoig3 cabs cmin ccom copn cfv ctop wcel cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a w3a cabs cmin ccom cme wcel cabs cmin ccom copn cfv ctop
      wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin
      ccom copn cfv cabs cmin ccom copn cfv eqid opntop ax-mp a1i cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a w3a cD cc cabs cmin ccom copn cfv cuni cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel
      w3a cD cc wss cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a 3simp2 3ad2ant3 cabs cmin ccom cme wcel cabs cmin ccom copn cfv cuni
      cc wceq cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin
      ccom copn cfv cc cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin
      ccom copn cfv eqid uniopn2 ax-mp syl6ssr sylanc cA cr wcel cB cr wcel cU
      cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a w3a w3a cA cB cicc co cD cD cabs cmin ccom copn cfv cop csubsp cfv
      cuni cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB cicc co cD wss cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a 3simp1 3ad2ant3 cabs cmin ccom copn
      cfv ctop wcel cD cabs cmin ccom copn cfv cuni wss cD cabs cmin ccom copn
      cfv cop csubsp cfv cuni cD wceq cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cD
      cabs cmin ccom copn cfv stoig2 cabs cmin ccom copn cfv ctop wcel cA cr
      wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a w3a cabs cmin ccom cme wcel cabs cmin ccom
      copn cfv ctop wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin
      ccom cabs cmin ccom copn cfv cabs cmin ccom copn cfv eqid opntop ax-mp
      a1i cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cD cc cabs cmin ccom copn cfv
      cuni cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB
      cr wcel cU cr wcel w3a cD cc wss cA cB clt wbr cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a 3simp2 3ad2ant3 cabs cmin ccom cme wcel cabs cmin
      ccom copn cfv cuni cc wceq cabs cmin ccom cabs cmin ccom eqid cnmet cabs
      cmin ccom cabs cmin ccom copn cfv cc cabs cmin ccom cabs cmin ccom eqid
      cnmetba cabs cmin ccom copn cfv eqid uniopn2 ax-mp syl6ssr sylanc
      sseqtr4d sylanc cabs cmin ccom copn cfv ctop wcel cA cr wcel cB cr wcel
      cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cabs cmin ccom cme wcel cabs cmin ccom copn cfv ctop
      wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin
      ccom copn cfv cabs cmin ccom copn cfv eqid opntop ax-mp a1i cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel
      w3a cF cA cB cicc co cres crn cr wss cA cB clt wbr cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA
      cB cicc co cD wss cF cA cB cicc co cres crn cr wss cD cc wss cF cA cB
      cicc co cima cr wss cF cD cc ccncf co wcel cF cA cB cicc co cres crn cr
      wss cU cA cF cfv cB cF cfv cioo co wcel cF cA cB cicc co cima cr wss cF
      cA cB cicc co cres crn cr wss cF cA cB cicc co cima cF cA cB cicc co cres
      crn cr cF cA cB cicc co df-ima sseq1i biimpi 3ad2ant2 3ad2ant3 3ad2ant3
      cr cc wss cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a axresscn a1i syl2anc
      mpbid cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD cabs cmin ccom
      copn cfv cop csubsp cfv cop csubsp cfv cr cabs cmin ccom copn cfv cop
      csubsp cfv ccn co cA cB cicc co cioo crn ctg cfv cop csubsp cfv cr cabs
      cmin ccom copn cfv cop csubsp cfv ccn co cA cB cicc co cioo crn ctg cfv
      cop csubsp cfv cioo crn ctg cfv ccn co cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      w3a cA cB cicc co cD cabs cmin ccom copn cfv cop csubsp cfv cop csubsp
      cfv cA cB cicc co cioo crn ctg cfv cop csubsp cfv cr cabs cmin ccom copn
      cfv cop csubsp cfv ccn cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co
      cD cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cA cB cicc co cr
      cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cA cB cicc co cioo
      crn ctg cfv cop csubsp cfv cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc
      co cD cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cA cB cicc co
      cabs cmin ccom copn cfv cop csubsp cfv cA cB cicc co cr cabs cmin ccom
      copn cfv cop csubsp cfv cop csubsp cfv cabs cmin ccom copn cfv ctop wcel
      cA cB cicc co cD wss cD cc wss cA cB cicc co cD cabs cmin ccom copn cfv
      cop csubsp cfv cop csubsp cfv cA cB cicc co cabs cmin ccom copn cfv cop
      csubsp cfv wceq cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD cabs
      cmin ccom copn cfv cc cabs cmin ccom copn cfv cuni cc cabs cmin ccom cme
      wcel cabs cmin ccom copn cfv cuni cc wceq cabs cmin ccom cabs cmin ccom
      eqid cnmet cabs cmin ccom cabs cmin ccom copn cfv cc cabs cmin ccom cabs
      cmin ccom eqid cnmetba cabs cmin ccom copn cfv eqid uniopn2 ax-mp eqcomi
      subsubtop cabs cmin ccom copn cfv ctop wcel cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cabs cmin ccom cme wcel cabs cmin ccom copn cfv ctop wcel cabs
      cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin ccom copn
      cfv cabs cmin ccom copn cfv eqid opntop ax-mp a1i cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB
      cicc co cD wss cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a 3simp1 3ad2ant3 cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a cA cr wcel cB cr wcel cU cr wcel w3a cD cc wss cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a 3simp2 3ad2ant3 syl3anc cabs
      cmin ccom copn cfv ctop wcel cA cB cicc co cr wss cr cc wss cA cB cicc co
      cr cabs cmin ccom copn cfv cop csubsp cfv cop csubsp cfv cA cB cicc co
      cabs cmin ccom copn cfv cop csubsp cfv wceq cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cA cB cicc co cr cabs cmin ccom copn cfv cc cabs cmin ccom copn
      cfv cuni cc cabs cmin ccom cme wcel cabs cmin ccom copn cfv cuni cc wceq
      cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cabs cmin ccom
      copn cfv cc cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom
      copn cfv eqid uniopn2 ax-mp eqcomi subsubtop cabs cmin ccom copn cfv ctop
      wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cabs cmin ccom cme wcel cabs
      cmin ccom copn cfv ctop wcel cabs cmin ccom cabs cmin ccom eqid cnmet
      cabs cmin ccom cabs cmin ccom copn cfv cabs cmin ccom copn cfv eqid
      opntop ax-mp a1i cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cr wss cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cA cB cicc co cr wss cU cr wcel cA cB iccssre 3adant3
      3ad2ant1 cr cc wss cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a axresscn a1i
      syl3anc eqtr4d cA cB cicc co cioo crn ctg cfv cop cA cB cicc co cr cabs
      cmin ccom copn cfv cop csubsp cfv cop csubsp cioo crn ctg cfv cr cabs
      cmin ccom copn cfv cop csubsp cfv cA cB cicc co cabs cmin ccom cr cr cxp
      cres cr cabs cmin ccom copn cfv cop csubsp cfv cabs cmin ccom cr cr cxp
      cres eqid cabs cmin ccom cme wcel cr cc wss cr cabs cmin ccom copn cfv
      cop csubsp cfv cabs cmin ccom cr cr cxp cres copn cfv wceq cabs cmin ccom
      cabs cmin ccom eqid cnmet axresscn cabs cmin ccom cabs cmin ccom cr cr
      cxp cres cabs cmin ccom copn cfv cabs cmin ccom cr cr cxp cres copn cfv
      cc cr cabs cmin ccom cr cr cxp cres eqid cabs cmin ccom cabs cmin ccom
      eqid cnmetba cabs cmin ccom copn cfv eqid cabs cmin ccom cr cr cxp cres
      copn cfv eqid subtopmet mp2an tgioo opeq2i fveq2i syl6eqr opreq1d cr cabs
      cmin ccom copn cfv cop csubsp cfv cioo crn ctg cfv cA cB cicc co cioo crn
      ctg cfv cop csubsp cfv ccn cr cabs cmin ccom copn cfv cop csubsp cfv cabs
      cmin ccom cr cr cxp cres copn cfv cioo crn ctg cfv cabs cmin ccom cme
      wcel cr cc wss cr cabs cmin ccom copn cfv cop csubsp cfv cabs cmin ccom
      cr cr cxp cres copn cfv wceq cabs cmin ccom cabs cmin ccom eqid cnmet
      axresscn cabs cmin ccom cabs cmin ccom cr cr cxp cres cabs cmin ccom copn
      cfv cabs cmin ccom cr cr cxp cres copn cfv cc cr cabs cmin ccom cr cr cxp
      cres eqid cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom copn
      cfv eqid cabs cmin ccom cr cr cxp cres copn cfv eqid subtopmet mp2an cabs
      cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres copn cfv cabs cmin
      ccom cr cr cxp cres eqid cabs cmin ccom cr cr cxp cres copn cfv eqid
      tgioo eqtr4i opreq2i syl6eq eleqtrd cA cB cicc co cioo crn ctg cfv cop
      csubsp cfv ctop wcel cioo crn ctg cfv ctop wcel cF cA cB cicc co cres crn
      cF cA cB cicc co cima wss cF cA cB cicc co cima cr wss cF cA cB cicc co
      cres cA cB cicc co cioo crn ctg cfv cop csubsp cfv cioo crn ctg cfv ccn
      co wcel cF cA cB cicc co cres cA cB cicc co cioo crn ctg cfv cop csubsp
      cfv cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv ccn co wcel wb
      cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima cF cA cB
      cicc co cres cA cB cicc co cioo crn ctg cfv cop csubsp cfv cioo crn ctg
      cfv cr cioo crn ctg cfv cuni cr uniretop eqcomi cnsubsp2 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cA cB cicc co cioo crn ctg cfv cuni wss cA cB cicc co
      cioo crn ctg cfv cop csubsp cfv ctop wcel cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cA cB cicc co cr cioo crn ctg cfv cuni cA cr wcel cB cr wcel cU
      cr wcel w3a cA cB clt wbr cA cB cicc co cr wss cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cA cB cicc co cr wss cU
      cr wcel cA cB iccssre 3adant3 3ad2ant1 uniretop syl6ssr cioo crn ctg cfv
      ctop wcel cA cB cicc co cioo crn ctg cfv cuni wss cA cB cicc co cioo crn
      ctg cfv cop csubsp cfv ctop wcel retop cA cB cicc co cioo crn ctg cfv
      stoig3 mpan syl cioo crn ctg cfv ctop wcel cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a retop a1i cF cA cB cicc co cres crn cF cA cB cicc co cima wss cA
      cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima cF cA cB cicc co
      cres crn cF cA cB cicc co df-ima eqimss2i a1i cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cF cA cB
      cicc co cima cr wss cA cB clt wbr cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss
      cF cA cB cicc co cima cr wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel 3simp2 3ad2ant3
      3ad2ant3 syl2anc mpbid syl2anc cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cF cA cB cicc co cima
      cioo crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc co cF cA cB
      cicc co cima wss vy cF cA cB cicc co cima wral vx cF cA cB cicc co cima
      wral wb cA cB clt wbr cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cF cA cB
      cicc co cima cioo crn ctg cfv cop csubsp cfv ccon wcel vx cv vy cv cicc
      co cF cA cB cicc co cima wss vy cF cA cB cicc co cima wral vx cF cA cB
      cicc co cima wral wb cD cc wss cF cA cB cicc co cima cr wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cioo crn ctg cfv cop csubsp cfv ccon
      wcel vx cv vy cv cicc co cF cA cB cicc co cima wss vy cF cA cB cicc co
      cima wral vx cF cA cB cicc co cima wral wb cU cA cF cfv cB cF cfv cioo co
      wcel vx vy cF cA cB cicc co cima reconn 3ad2ant2 3ad2ant3 3ad2ant3 mpbid
      cA cF cfv cF cA cB cicc co cima wcel cB cF cfv cF cA cB cicc co cima wcel
      vx cv vy cv cicc co cF cA cB cicc co cima wss vy cF cA cB cicc co cima
      wral vx cF cA cB cicc co cima wral cA cF cfv cB cF cfv cicc co cF cA cB
      cicc co cima wss wi cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv vy cv cicc
      co cF cA cB cicc co cima wss cA cF cfv cB cF cfv cicc co cF cA cB cicc co
      cima wss cA cF cfv vy cv cicc co cF cA cB cicc co cima wss vx vy cA cF
      cfv cB cF cfv cF cA cB cicc co cima cF cA cB cicc co cima vx cv cA cF cfv
      wceq vx cv vy cv cicc co cA cF cfv vy cv cicc co cF cA cB cicc co cima vx
      cv cA cF cfv vy cv cicc opreq1 sseq1d vy cv cB cF cfv wceq cA cF cfv vy
      cv cicc co cA cF cfv cB cF cfv cicc co cF cA cB cicc co cima vy cv cB cF
      cfv cA cF cfv cicc opreq2 sseq1d rcla42v cF wfun cA cB cicc co cF cdm wss
      wa cA cA cB cicc co wcel cA cF cfv cF cA cB cicc co cima wcel cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a w3a cA cB cicc co cA cF funfvima2 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cA cB cicc co cD wss cD cc cF wf wa cF wfun cA cB cicc
      co cF cdm wss wa cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cU cr wcel w3a cA cB cicc co cD wss cD cc cF wf wa cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co
      cD wss cD cc cF wf wa cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a wa cD cc cF wf cA cB
      cicc co cD wss cD cc wss cF cA cB cicc co cima cr wss cF cD cc ccncf co
      wcel cD cc cF wf cU cA cF cfv cB cF cfv cioo co wcel cD cc wss cc cc wss
      cF cD cc ccncf co wcel cD cc cF wf cc ssid cD cc cF cncff mp3an2
      3ad2antr1 anim2i 3impb 3ad2ant3 cA cB cicc co cD wss cD cc cF wf wa cF
      wfun cA cB cicc co cF cdm wss cD cc cF wf cF wfun cA cB cicc co cD wss cD
      cc cF ffun adantl cD cc cF wf cA cB cicc co cF cdm wss cA cB cicc co cD
      wss cD cc cF wf cF cdm cD cA cB cicc co cD cc cF fdm sseq2d biimparc jca
      syl cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co wcel cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a w3a cA cB lbicc2 cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cr wcel cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel 3simp1 3ad2ant1 cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cB cr wcel cA cB cicc co cD wss
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel
      3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cle wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr
      wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr wcel cA cr wcel cB cr
      wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp 3adantl3 3adant3
      syl3anc sylc cF wfun cA cB cicc co cF cdm wss wa cB cA cB cicc co wcel cB
      cF cfv cF cA cB cicc co cima wcel cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB
      cicc co cB cF funfvima2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc
      co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss wa cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB cicc co cD wss cD cc cF wf wa cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cD cc cF wf wa
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a wa cD cc cF wf cA cB cicc co cD wss cD cc
      wss cF cA cB cicc co cima cr wss cF cD cc ccncf co wcel cD cc cF wf cU cA
      cF cfv cB cF cfv cioo co wcel cD cc wss cc cc wss cF cD cc ccncf co wcel
      cD cc cF wf cc ssid cD cc cF cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3
      cA cB cicc co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss cD
      cc cF wf cF wfun cA cB cicc co cD wss cD cc cF ffun adantl cD cc cF wf cA
      cB cicc co cF cdm wss cA cB cicc co cD wss cD cc cF wf cF cdm cD cA cB
      cicc co cD cc cF fdm sseq2d biimparc jca syl cA cr wcel cB cr wcel cA cB
      cle wbr cB cA cB cicc co wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB
      clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB
      ubicc2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cr wcel cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel
      cU cr wcel 3simp1 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cB cr wcel cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cle wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr
      wcel cA cr wcel cB cr wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp
      3adantl3 3adant3 syl3anc sylc sylanc mpd cA cB cicc co cD wss cD cc wss
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cU cA cF
      cfv cB cF cfv cicc co wcel cA cB clt wbr cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co
      cD wss cU cA cF cfv cB cF cfv cicc co wcel cD cc wss cU cA cF cfv cB cF
      cfv cioo co wcel cF cD cc ccncf co wcel cU cA cF cfv cB cF cfv cicc co
      wcel cF cA cB cicc co cima cr wss cA cF cfv cB cF cfv cioo co cA cF cfv
      cB cF cfv cicc co cU cA cF cfv cB cF cfv ioossicc sseli 3ad2ant3 3ad2ant3
      3ad2ant3 sseldd sylanc cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cF cfv
      cU wceq vx cv cF cfv cU wceq vx cA cB cicc co cA cB cioo co cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a w3a vx cv cA cB cicc co wcel vx cv cF cfv cU wceq wa vx
      cv cA cB cioo co wcel vx cv cF cfv cU wceq cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a vx cv cxr wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv
      cB clt wbr wa vx cv cB wceq w3o w3a vx cv cF cfv cU wceq wa vx cv cxr
      wcel cA vx cv clt wbr vx cv cB clt wbr w3a vx cv cA cB cicc co wcel vx cv
      cF cfv cU wceq wa vx cv cA cB cioo co wcel cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a vx cv cxr wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv
      cB clt wbr wa vx cv cB wceq w3o w3a vx cv cF cfv cU wceq wa vx cv cxr
      wcel cA vx cv clt wbr vx cv cB clt wbr wa wa vx cv cxr wcel cA vx cv clt
      wbr vx cv cB clt wbr w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr
      wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx
      cv cB wceq w3o w3a vx cv cF cfv cU wceq wa vx cv cxr wcel cA vx cv clt
      wbr vx cv cB clt wbr wa vx cv cxr wcel cA cB cle wbr vx cv cA wceq cA vx
      cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a vx cv cF cfv cU wceq
      wa vx cv cxr wcel wi cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr
      wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx
      cv cB wceq w3o w3a vx cv cxr wcel vx cv cF cfv cU wceq vx cv cxr wcel cA
      cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB
      wceq w3o 3simp1 adantr a1i cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr
      wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx
      cv cB wceq w3o w3a vx cv cF cfv cU wceq wa cA vx cv clt wbr vx cv cB clt
      wbr wa cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB cle wbr
      vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a
      vx cv cF cfv cU wceq wa wa cA vx cv clt wbr vx cv cB clt wbr wa vx cv cA
      wceq vx cv cB wceq cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA
      cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB
      wceq w3o w3a vx cv cF cfv cU wceq wa wa vx cv cF cfv cA cF cfv wceq vx cv
      cA wceq cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB cle wbr
      vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a
      vx cv cF cfv cU wceq wa wa vx cv cF cfv cA cF cfv wne vx cv cF cfv cA cF
      cfv wceq wn cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB cle
      wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o
      w3a vx cv cF cfv cU wceq wa wa vx cv cF cfv cA cF cfv wne cU cA cF cfv
      wne cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cU cA cF cfv wne vx cv cxr wcel
      cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB
      wceq w3o w3a vx cv cF cfv cU wceq wa cA cF cfv cr wcel cU cr wcel cA cF
      cfv cU clt wbr cU cA cF cfv wne cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cF
      cfv cU ltne cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima cr
      cA cF cfv cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr
      wcel cB cr wcel cU cr wcel w3a cF cA cB cicc co cima cr wss cA cB clt wbr
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a cA cB cicc co cD wss cF cA cB cicc co cima cr wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel 3simp2 3ad2ant3 3ad2ant3 cF wfun cA cB cicc co cF
      cdm wss wa cA cA cB cicc co wcel cA cF cfv cF cA cB cicc co cima wcel cA
      cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cA cF funfvima2 cA cr
      wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD wss cD cc cF wf wa cF
      wfun cA cB cicc co cF cdm wss wa cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB cicc co cD wss cD
      cc cF wf wa cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a cA cB cicc co cD wss cD cc cF wf wa cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a wa
      cD cc cF wf cA cB cicc co cD wss cD cc wss cF cA cB cicc co cima cr wss
      cF cD cc ccncf co wcel cD cc cF wf cU cA cF cfv cB cF cfv cioo co wcel cD
      cc wss cc cc wss cF cD cc ccncf co wcel cD cc cF wf cc ssid cD cc cF
      cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3 cA cB cicc co cD wss cD cc
      cF wf wa cF wfun cA cB cicc co cF cdm wss cD cc cF wf cF wfun cA cB cicc
      co cD wss cD cc cF ffun adantl cD cc cF wf cA cB cicc co cF cdm wss cA cB
      cicc co cD wss cD cc cF wf cF cdm cD cA cB cicc co cD cc cF fdm sseq2d
      biimparc jca syl cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co
      wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB lbicc2 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cr wcel cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel 3simp1
      3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cB cr wcel cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel
      cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cle wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr wcel cA cr wcel
      cB cr wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp 3adantl3 3adant3
      syl3anc sylc sseldd cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cU
      cr wcel cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr
      wcel cB cr wcel cU cr wcel 3simp3 3ad2ant1 cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cU cr wcel cA cF cfv cU clt wbr cU cB cF cfv clt wbr cA cr wcel
      cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a w3a cU cA cF cfv cB cF cfv cioo co wcel cU cr wcel
      cA cF cfv cU clt wbr cU cB cF cfv clt wbr w3a cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cU cA cF
      cfv cB cF cfv cioo co wcel cA cB clt wbr cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co
      cD wss cU cA cF cfv cB cF cfv cioo co wcel cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      3simp3 3ad2ant3 3ad2ant3 cA cF cfv cxr wcel cB cF cfv cxr wcel cU cA cF
      cfv cB cF cfv cioo co wcel cU cr wcel cA cF cfv cU clt wbr cU cB cF cfv
      clt wbr w3a wb cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cF cfv cB cF cfv
      cU elioo2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cF cfv cr wcel cA cF
      cfv cxr wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima
      cr cA cF cfv cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr
      wcel cB cr wcel cU cr wcel w3a cF cA cB cicc co cima cr wss cA cB clt wbr
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a cA cB cicc co cD wss cF cA cB cicc co cima cr wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel 3simp2 3ad2ant3 3ad2ant3 cF wfun cA cB cicc co cF
      cdm wss wa cA cA cB cicc co wcel cA cF cfv cF cA cB cicc co cima wcel cA
      cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cA cF funfvima2 cA cr
      wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD wss cD cc cF wf wa cF
      wfun cA cB cicc co cF cdm wss wa cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB cicc co cD wss cD
      cc cF wf wa cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a cA cB cicc co cD wss cD cc cF wf wa cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a wa
      cD cc cF wf cA cB cicc co cD wss cD cc wss cF cA cB cicc co cima cr wss
      cF cD cc ccncf co wcel cD cc cF wf cU cA cF cfv cB cF cfv cioo co wcel cD
      cc wss cc cc wss cF cD cc ccncf co wcel cD cc cF wf cc ssid cD cc cF
      cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3 cA cB cicc co cD wss cD cc
      cF wf wa cF wfun cA cB cicc co cF cdm wss cD cc cF wf cF wfun cA cB cicc
      co cD wss cD cc cF ffun adantl cD cc cF wf cA cB cicc co cF cdm wss cA cB
      cicc co cD wss cD cc cF wf cF cdm cD cA cB cicc co cD cc cF fdm sseq2d
      biimparc jca syl cA cr wcel cB cr wcel cA cB cle wbr cA cA cB cicc co
      wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB lbicc2 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cr wcel cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel 3simp1
      3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cB cr wcel cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel
      cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cle wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr wcel cA cr wcel
      cB cr wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp 3adantl3 3adant3
      syl3anc sylc sseldd cA cF cfv rexr syl cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      w3a cB cF cfv cr wcel cB cF cfv cxr wcel cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      w3a cF cA cB cicc co cima cr cB cF cfv cA cB cicc co cD wss cD cc wss cF
      cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv
      cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cF cA cB cicc
      co cima cr wss cA cB clt wbr cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cF cA
      cB cicc co cima cr wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel 3simp2 3ad2ant3 3ad2ant3
      cF wfun cA cB cicc co cF cdm wss wa cB cA cB cicc co wcel cB cF cfv cF cA
      cB cicc co cima wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co
      cB cF funfvima2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD wss
      cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss wa cA cB cicc co cD wss
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a
      cA cB cicc co cD wss cD cc cF wf wa cA cB clt wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cD cc cF wf wa cD cc wss
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a wa cD cc cF wf cA cB cicc co cD wss cD cc wss cF cA
      cB cicc co cima cr wss cF cD cc ccncf co wcel cD cc cF wf cU cA cF cfv cB
      cF cfv cioo co wcel cD cc wss cc cc wss cF cD cc ccncf co wcel cD cc cF
      wf cc ssid cD cc cF cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3 cA cB
      cicc co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss cD cc cF
      wf cF wfun cA cB cicc co cD wss cD cc cF ffun adantl cD cc cF wf cA cB
      cicc co cF cdm wss cA cB cicc co cD wss cD cc cF wf cF cdm cD cA cB cicc
      co cD cc cF fdm sseq2d biimparc jca syl cA cr wcel cB cr wcel cA cB cle
      wbr cB cA cB cicc co wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB
      ubicc2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cr wcel cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel
      cU cr wcel 3simp1 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cB cr wcel cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cle wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr
      wcel cA cr wcel cB cr wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp
      3adantl3 3adant3 syl3anc sylc sseldd cB cF cfv rexr syl sylanc mpbid
      3simp2d syl3anc adantr cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr
      wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx
      cv cB wceq w3o w3a vx cv cF cfv cU wceq wa wa vx cv cF cfv cU cA cF cfv
      cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB cle wbr vx cv
      cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a vx cv
      cF cfv cU wceq simprr neeq1d mpbird vx cv cF cfv cA cF cfv df-ne sylib vx
      cv cA cF fveq2 nsyl cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA
      cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB
      wceq w3o w3a vx cv cF cfv cU wceq wa wa vx cv cF cfv cB cF cfv wceq vx cv
      cB wceq cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB cle wbr
      vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a
      vx cv cF cfv cU wceq wa wa vx cv cF cfv cB cF cfv wne vx cv cF cfv cB cF
      cfv wceq wn cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB cle
      wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o
      w3a vx cv cF cfv cU wceq wa wa vx cv cF cfv cB cF cfv wne cU cB cF cfv
      wne cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cU cB cF cfv wne vx cv cxr wcel
      cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB
      wceq w3o w3a vx cv cF cfv cU wceq wa cA cr wcel cB cr wcel cU cr wcel w3a
      cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cB
      cF cfv cU cU cr wcel cB cF cfv cr wcel cU cB cF cfv clt wbr cB cF cfv cU
      wne cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cU cB cF cfv ltne cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cU cr wcel cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel 3simp3
      3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cF cA cB cicc co cima cr cB
      cF cfv cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr
      wcel cB cr wcel cU cr wcel w3a cF cA cB cicc co cima cr wss cA cB clt wbr
      cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF
      cfv cioo co wcel w3a cA cB cicc co cD wss cF cA cB cicc co cima cr wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel 3simp2 3ad2ant3 3ad2ant3 cF wfun cA cB cicc co cF
      cdm wss wa cB cA cB cicc co wcel cB cF cfv cF cA cB cicc co cima wcel cA
      cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cB cF funfvima2 cA cr
      wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a w3a cA cB cicc co cD wss cD cc cF wf wa cF
      wfun cA cB cicc co cF cdm wss wa cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cA cB cicc co cD wss cD
      cc cF wf wa cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a cA cB cicc co cD wss cD cc cF wf wa cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a wa
      cD cc cF wf cA cB cicc co cD wss cD cc wss cF cA cB cicc co cima cr wss
      cF cD cc ccncf co wcel cD cc cF wf cU cA cF cfv cB cF cfv cioo co wcel cD
      cc wss cc cc wss cF cD cc ccncf co wcel cD cc cF wf cc ssid cD cc cF
      cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3 cA cB cicc co cD wss cD cc
      cF wf wa cF wfun cA cB cicc co cF cdm wss cD cc cF wf cF wfun cA cB cicc
      co cD wss cD cc cF ffun adantl cD cc cF wf cA cB cicc co cF cdm wss cA cB
      cicc co cD wss cD cc cF wf cF cdm cD cA cB cicc co cD cc cF fdm sseq2d
      biimparc jca syl cA cr wcel cB cr wcel cA cB cle wbr cB cA cB cicc co
      wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD
      wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA
      cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB ubicc2 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cr wcel cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel 3simp1
      3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cB cr wcel cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel
      cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cle wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr wcel cA cr wcel
      cB cr wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp 3adantl3 3adant3
      syl3anc sylc sseldd cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cU cr wcel cA cF
      cfv cU clt wbr cU cB cF cfv clt wbr cA cr wcel cB cr wcel cU cr wcel w3a
      cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cU
      cA cF cfv cB cF cfv cioo co wcel cU cr wcel cA cF cfv cU clt wbr cU cB cF
      cfv clt wbr w3a cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cU cr wcel w3a cU cA cF cfv cB cF cfv cioo co wcel cA
      cB clt wbr cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cU cA cF cfv cB cF
      cfv cioo co wcel cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel 3simp3 3ad2ant3 3ad2ant3 cA cF
      cfv cxr wcel cB cF cfv cxr wcel cU cA cF cfv cB cF cfv cioo co wcel cU cr
      wcel cA cF cfv cU clt wbr cU cB cF cfv clt wbr w3a wb cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cA cF cfv cB cF cfv cU elioo2 cA cr wcel cB cr wcel cU
      cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a w3a w3a cA cF cfv cr wcel cA cF cfv cxr wcel cA cr wcel cB cr wcel cU
      cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf
      co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel
      w3a w3a w3a cF cA cB cicc co cima cr cA cF cfv cA cB cicc co cD wss cD cc
      wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB
      cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a cF cA cB
      cicc co cima cr wss cA cB clt wbr cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss
      cF cA cB cicc co cima cr wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel 3simp2 3ad2ant3
      3ad2ant3 cF wfun cA cB cicc co cF cdm wss wa cA cA cB cicc co wcel cA cF
      cfv cF cA cB cicc co cima wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB
      clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB
      cicc co cA cF funfvima2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB cicc
      co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss wa cA cB cicc
      co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss
      cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB cicc co cD wss cD cc cF wf wa cA cB clt wbr cA cB cicc co
      cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cD cc cF wf wa
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a wa cD cc cF wf cA cB cicc co cD wss cD cc
      wss cF cA cB cicc co cima cr wss cF cD cc ccncf co wcel cD cc cF wf cU cA
      cF cfv cB cF cfv cioo co wcel cD cc wss cc cc wss cF cD cc ccncf co wcel
      cD cc cF wf cc ssid cD cc cF cncff mp3an2 3ad2antr1 anim2i 3impb 3ad2ant3
      cA cB cicc co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss cD
      cc cF wf cF wfun cA cB cicc co cD wss cD cc cF ffun adantl cD cc cF wf cA
      cB cicc co cF cdm wss cA cB cicc co cD wss cD cc cF wf cF cdm cD cA cB
      cicc co cD cc cF fdm sseq2d biimparc jca syl cA cr wcel cB cr wcel cA cB
      cle wbr cA cA cB cicc co wcel cA cr wcel cB cr wcel cU cr wcel w3a cA cB
      clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB
      cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA cB
      lbicc2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cr wcel cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel
      cU cr wcel 3simp1 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cB cr wcel cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cle wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a cA cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr cU cr
      wcel cA cr wcel cB cr wcel wa cA cB clt wbr cA cB cle wbr cA cB ltle imp
      3adantl3 3adant3 syl3anc sylc sseldd cA cF cfv rexr syl cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cB cF cfv cr wcel cB cF cfv cxr wcel cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc
      ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co
      wcel w3a w3a w3a cF cA cB cicc co cima cr cB cF cfv cA cB cicc co cD wss
      cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF
      cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cU cr wcel w3a
      cF cA cB cicc co cima cr wss cA cB clt wbr cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc
      co cD wss cF cA cB cicc co cima cr wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel 3simp2
      3ad2ant3 3ad2ant3 cF wfun cA cB cicc co cF cdm wss wa cB cA cB cicc co
      wcel cB cF cfv cF cA cB cicc co cima wcel cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a cA cB cicc co cB cF funfvima2 cA cr wcel cB cr wcel cU cr wcel
      w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel
      cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a
      w3a cA cB cicc co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm wss
      wa cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB cicc co cD wss cD cc cF wf wa cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a cA cB cicc co cD wss cD cc
      cF wf wa cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU
      cA cF cfv cB cF cfv cioo co wcel w3a wa cD cc cF wf cA cB cicc co cD wss
      cD cc wss cF cA cB cicc co cima cr wss cF cD cc ccncf co wcel cD cc cF wf
      cU cA cF cfv cB cF cfv cioo co wcel cD cc wss cc cc wss cF cD cc ccncf co
      wcel cD cc cF wf cc ssid cD cc cF cncff mp3an2 3ad2antr1 anim2i 3impb
      3ad2ant3 cA cB cicc co cD wss cD cc cF wf wa cF wfun cA cB cicc co cF cdm
      wss cD cc cF wf cF wfun cA cB cicc co cD wss cD cc cF ffun adantl cD cc
      cF wf cA cB cicc co cF cdm wss cA cB cicc co cD wss cD cc cF wf cF cdm cD
      cA cB cicc co cD cc cF fdm sseq2d biimparc jca syl cA cr wcel cB cr wcel
      cA cB cle wbr cB cA cB cicc co wcel cA cr wcel cB cr wcel cU cr wcel w3a
      cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA
      cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a cA
      cB ubicc2 cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cr wcel
      cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co
      cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr
      wcel cU cr wcel 3simp1 3ad2ant1 cA cr wcel cB cr wcel cU cr wcel w3a cA
      cB clt wbr cB cr wcel cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a cA cr wcel cB cr wcel cU cr wcel 3simp2 3ad2ant1 cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr cA cB cle wbr cA cB cicc co cD wss cD
      cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv
      cB cF cfv cioo co wcel w3a w3a cA cr wcel cB cr wcel cA cB clt wbr cA cB
      cle wbr cU cr wcel cA cr wcel cB cr wcel wa cA cB clt wbr cA cB cle wbr
      cA cB ltle imp 3adantl3 3adant3 syl3anc sylc sseldd cB cF cfv rexr syl
      sylanc mpbid 3simp3d syl3anc necomd adantr cA cr wcel cB cr wcel cU cr
      wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a w3a vx cv cxr wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv
      cB clt wbr wa vx cv cB wceq w3o w3a vx cv cF cfv cU wceq wa wa vx cv cF
      cfv cU cB cF cfv cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA cB
      cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima cr
      wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cxr wcel cA cB
      cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq
      w3o w3a vx cv cF cfv cU wceq simprr neeq1d mpbird vx cv cF cfv cB cF cfv
      df-ne sylib vx cv cB cF fveq2 nsyl vx cv cxr wcel cA cB cle wbr vx cv cA
      wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a vx cv cA
      wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o cA cr wcel cB
      cr wcel cU cr wcel w3a cA cB clt wbr cA cB cicc co cD wss cD cc wss cF cD
      cc ccncf co wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo
      co wcel w3a w3a w3a vx cv cF cfv cU wceq vx cv cxr wcel cA cB cle wbr vx
      cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o 3simp3
      ad2antrl ecase13d ex jcad vx cv cxr wcel cA vx cv clt wbr vx cv cB clt
      wbr 3anass syl6ibr cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt wbr cA
      cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc co cima
      cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cA cB cicc
      co wcel vx cv cxr wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv
      cB clt wbr wa vx cv cB wceq w3o w3a vx cv cF cfv cU wceq cA cr wcel cB cr
      wcel cU cr wcel w3a cA cB clt wbr vx cv cA cB cicc co wcel vx cv cxr wcel
      cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB
      wceq w3o w3a wb cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF
      cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a cA
      cr wcel cB cr wcel vx cv cA cB cicc co wcel vx cv cxr wcel cA cB cle wbr
      vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx cv cB wceq w3o w3a
      wb cU cr wcel cA cxr wcel cB cxr wcel vx cv cA cB cicc co wcel vx cv cxr
      wcel cA cB cle wbr vx cv cA wceq cA vx cv clt wbr vx cv cB clt wbr wa vx
      cv cB wceq w3o w3a wb cA cr wcel cB cr wcel cA cB vx cv elicc3 cA rexr cB
      rexr syl2an 3adant3 3ad2ant1 anbi1d cA cr wcel cB cr wcel cU cr wcel w3a
      cA cB clt wbr vx cv cA cB cioo co wcel vx cv cxr wcel cA vx cv clt wbr vx
      cv cB clt wbr w3a wb cA cB cicc co cD wss cD cc wss cF cD cc ccncf co
      wcel cF cA cB cicc co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a
      w3a cA cr wcel cB cr wcel vx cv cA cB cioo co wcel vx cv cxr wcel cA vx
      cv clt wbr vx cv cB clt wbr w3a wb cU cr wcel cA cxr wcel cB cxr wcel vx
      cv cA cB cioo co wcel vx cv cxr wcel cA vx cv clt wbr vx cv cB clt wbr
      w3a wb cA cr wcel cB cr wcel cA cB vx cv elioo1 cA rexr cB rexr syl2an
      3adant3 3ad2ant1 3imtr4d vx cv cA cB cicc co wcel vx cv cF cfv cU wceq wa
      vx cv cF cfv cU wceq wi cA cr wcel cB cr wcel cU cr wcel w3a cA cB clt
      wbr cA cB cicc co cD wss cD cc wss cF cD cc ccncf co wcel cF cA cB cicc
      co cima cr wss cU cA cF cfv cB cF cfv cioo co wcel w3a w3a w3a vx cv cA
      cB cicc co wcel vx cv cF cfv cU wceq pm3.27 a1i jcad r19.22dv2 mpd $.
      $( [17-Aug-2009] $) $( [17-Aug-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                First- and second-countability, refinements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c 1stc $.
  $( Extend class definition to include the class of all first-countable
     topologies. $)
  c1stc $a class 1stc $.

  $c 2ndc $.
  $( Extend class definition to include the class of all second-countable
     topologies. $)
  c2ndc $a class 2ndc $.

  $c Fne $.
  $( Extend class definition to include the "finer than" relation. $)
  cfne $a class Fne $.

  $c Ref $.
  $( Extend class definition to include the refinement relation. $)
  cref $a class Ref $.

  $c PtFin $.
  $( Extend class definition to include the class of point-finite covers. $)
  cptfin $a class PtFin $.

  $c LocFin $.
  $( Extend class definition to include the class of locally finite covers. $)
  clocfin $a class LocFin $.

  ${
    $d w x y z $.
    $( Define the class of all first-countable topologies. $)
    df-1stc $a |- 1stc = { x e. Top | A. y e. U. x E. z e. ~P x ( z ~<_ om /\
    A. w e. x ( y e. w -> y e. U. ( z i^i ~P w ) ) ) } $.
  $}

  ${
    $d x y $.
    $( Define the class of all second-countable topologies. $)
    df-2ndc $a |- 2ndc = { x e. Top | E. y e. Bases ( y ~<_ om /\ ( topGen ` y
    ) = x ) } $.
  $}

  ${
    $d x y z $.
    $( Define the fineness relation for covers. $)
    df-fne $a |- Fne = { <. x , y >. | ( U. x = U. y /\ A. z e. x z C_ U. ( y
    i^i ~P z ) ) } $.
  $}

  ${
    $d w x y z $.
    $( Define the refinement relation. $)
    df-ref $a |- Ref = { <. x , y >. | ( U. x = U. y /\ A. z e. y E. w e. x z
    C_ w ) } $.
  $}

  ${
    $d x y z $.
    $( Define "point-finite." $)
    df-ptfin $a |- PtFin = { x | A. y e. U. x { z e. x | y e. z } e. Fin } $.
  $}

  ${
    $d n p s x y $.
    $( Define "locally finite." $)
    df-locfin $a |- LocFin = { <. x , y >. | ( x e. Top /\ U. x = U. y /\ A. p
    e. U. x E. n e. ( ( nei ` x ) ` { p } ) { s e. y | ( s i^i n ) =/= (/) } e.
    Fin ) } $.
  $}

  ${
    $d w x y z J $. $d w x X $. $d w x y z $.
    is1stc.1 $e |- X = U. J $.
    $( The predicate "is a first-countable topology." This can be described as
       "every point has a countable local basis"-that is, every point has a
       countable collection of open sets containing it such that every open set
       containing the point has an open set from this collection as a
       subset. $)
    is1stc $p |- ( J e. 1stc <-> ( J e. Top /\ A. x e. X E. y e. ~P J ( y ~<_
    om /\ A. z e. J ( x e. z -> x e. U. ( y i^i ~P z ) ) ) ) ) $=
      vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni wcel
      wi vz vw cv wral wa vy vw cv cpw wrex vx vw cv cuni wral vy cv com cdom
      wbr vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni wcel wi vz cJ wral wa
      vy cJ cpw wrex vx cX wral vw cJ ctop c1stc vw cv cJ wceq vy cv com cdom
      wbr vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni wcel wi vz vw cv wral
      wa vy vw cv cpw wrex vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv vz
      cv cpw cin cuni wcel wi vz cJ wral wa vy cJ cpw wrex vx vw cv cuni cX vw
      cv cJ wceq vw cv cuni cJ cuni cX vw cv cJ unieq is1stc.1 syl6eqr vw cv cJ
      wceq vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni
      wcel wi vz vw cv wral wa vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv
      vz cv cpw cin cuni wcel wi vz cJ wral wa vy vw cv cpw cJ cpw vw cv cJ
      pweq vw cv cJ wceq vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni wcel
      wi vz vw cv wral vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni wcel wi
      vz cJ wral vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv vz cv cpw cin
      cuni wcel wi vz vw cv cJ raleq1 anbi2d rexeq12d raleq12d vw vx vy vz
      df-1stc elrab2 $.
      $( [22-Aug-2009] $) $( [22-Aug-2009] $)

    $( The predicate "is a first-countable topology." $)
    is1stc2 $p |- ( J e. Top -> ( J e. 1stc <-> A. x e. X E. y e. ~P J ( y ~<_
    om /\ A. z e. J ( x e. z -> x e. U. ( y i^i ~P z ) ) ) ) ) $=
      cJ c1stc wcel cJ ctop wcel vy cv com cdom wbr vx cv vz cv wcel vx cv vy
      cv vz cv cpw cin cuni wcel wi vz cJ wral wa vy cJ cpw wrex vx cX wral vx
      vy vz cJ cX is1stc.1 is1stc baib $.
      $( [22-Aug-2009] $) $( [22-Aug-2009] $)
  $}

  ${
    $d x y z J $. $d x X $. $d w x y z $.
    is1stc3.1 $e |- X = U. J $.
    $( An equivalent way of saying "is a first-countable topology." $)
    is1stc3 $p |- ( J e. Top -> ( J e. 1stc <-> A. x e. X E. y e. ~P J ( y ~<_
    om /\ A. z e. J ( x e. z -> E. w e. y ( x e. w /\ w C_ z ) ) ) ) ) $=
      cJ ctop wcel cJ c1stc wcel vy cv com cdom wbr vx cv vz cv wcel vx cv vy
      cv vz cv cpw cin cuni wcel wi vz cJ wral wa vy cJ cpw wrex vx cX wral vy
      cv com cdom wbr vx cv vz cv wcel vx cv vw cv wcel vw cv vz cv wss wa vw
      vy cv wrex wi vz cJ wral wa vy cJ cpw wrex vx cX wral vx vy vz cJ cX
      is1stc3.1 is1stc2 vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv vz cv
      cpw cin cuni wcel wi vz cJ wral wa vy cJ cpw wrex vy cv com cdom wbr vx
      cv vz cv wcel vx cv vw cv wcel vw cv vz cv wss wa vw vy cv wrex wi vz cJ
      wral wa vy cJ cpw wrex vx cX vy cv com cdom wbr vx cv vz cv wcel vx cv vy
      cv vz cv cpw cin cuni wcel wi vz cJ wral wa vy cv com cdom wbr vx cv vz
      cv wcel vx cv vw cv wcel vw cv vz cv wss wa vw vy cv wrex wi vz cJ wral
      wa vy cJ cpw vx cv vz cv wcel vx cv vy cv vz cv cpw cin cuni wcel wi vz
      cJ wral vx cv vz cv wcel vx cv vw cv wcel vw cv vz cv wss wa vw vy cv
      wrex wi vz cJ wral vy cv com cdom wbr vx cv vz cv wcel vx cv vy cv vz cv
      cpw cin cuni wcel wi vx cv vz cv wcel vx cv vw cv wcel vw cv vz cv wss wa
      vw vy cv wrex wi vz cJ vx cv vy cv vz cv cpw cin cuni wcel vx cv vw cv
      wcel vw cv vz cv wss wa vw vy cv wrex vx cv vz cv wcel vx cv vw cv wcel
      vw cv vy cv vz cv cpw cin wcel wa vw wex vw cv vy cv wcel vx cv vw cv
      wcel vw cv vz cv wss wa wa vw wex vx cv vy cv vz cv cpw cin cuni wcel vx
      cv vw cv wcel vw cv vz cv wss wa vw vy cv wrex vx cv vw cv wcel vw cv vy
      cv vz cv cpw cin wcel wa vw cv vy cv wcel vx cv vw cv wcel vw cv vz cv
      wss wa wa vw vx cv vw cv wcel vw cv vy cv vz cv cpw cin wcel wa vx cv vw
      cv wcel vw cv vy cv wcel vw cv vz cv cpw wcel wa wa vx cv vw cv wcel vw
      cv vy cv wcel wa vw cv vz cv cpw wcel wa vw cv vy cv wcel vx cv vw cv
      wcel vw cv vz cv wss wa wa vw cv vy cv vz cv cpw cin wcel vw cv vy cv
      wcel vw cv vz cv cpw wcel wa vx cv vw cv wcel vw cv vy cv vz cv cpw elin
      anbi2i vx cv vw cv wcel vw cv vy cv wcel vw cv vz cv cpw wcel anass vx cv
      vw cv wcel vw cv vy cv wcel wa vw cv vz cv cpw wcel wa vw cv vy cv wcel
      vx cv vw cv wcel wa vw cv vz cv wss wa vw cv vy cv wcel vx cv vw cv wcel
      vw cv vz cv wss wa wa vx cv vw cv wcel vw cv vy cv wcel wa vw cv vy cv
      wcel vx cv vw cv wcel wa vw cv vz cv cpw wcel vw cv vz cv wss vx cv vw cv
      wcel vw cv vy cv wcel ancom vw cv vz cv vw visset elpw anbi12i vw cv vy
      cv wcel vx cv vw cv wcel vw cv vz cv wss anass bitri 3bitr2i exbii vw vx
      cv vy cv vz cv cpw cin eluni vx cv vw cv wcel vw cv vz cv wss wa vw vy cv
      df-rex 3bitr4i imbi2i ralbii anbi2i rexbii ralbii syl6bb $.
      $( [22-Aug-2009] $) $( [22-Aug-2009] $)
  $}

  ${
    $d x y z J $.
    $( A first-countable topology is a topology. $)
    1stctop $p |- ( J e. 1stc -> J e. Top ) $=
      cJ c1stc wcel cJ ctop wcel vy cv com cdom wbr vx cv vz cv wcel vx cv vy
      cv vz cv cpw cin cuni wcel wi vz cJ wral wa vy cJ cpw wrex vx cJ cuni
      wral vx vy vz cJ cJ cuni cJ cuni eqid is1stc pm3.26bi $.
      $( [22-Aug-2009] $) $( [22-Aug-2009] $)
  $}

  ${
    $d w x y z A $. $d w x y J $. $d w X $.
    1stcclb.1 $e |- X = U. J $.
    $( A property of points in a first-countable topology. $)
    1stcclb $p |- ( ( J e. 1stc /\ A e. X ) -> E. x e. ~P J ( x ~<_ om /\ A. y
    e. J ( A e. y -> E. z e. x ( A e. z /\ z C_ y ) ) ) ) $=
      cJ c1stc wcel vx cv com cdom wbr vw cv vy cv wcel vw cv vz cv wcel vz cv
      vy cv wss wa vz vx cv wrex wi vy cJ wral wa vx cJ cpw wrex vw cX wral cA
      cX wcel vx cv com cdom wbr cA vy cv wcel cA vz cv wcel vz cv vy cv wss wa
      vz vx cv wrex wi vy cJ wral wa vx cJ cpw wrex cJ c1stc wcel cJ ctop wcel
      vx cv com cdom wbr vw cv vy cv wcel vw cv vz cv wcel vz cv vy cv wss wa
      vz vx cv wrex wi vy cJ wral wa vx cJ cpw wrex vw cX wral cJ 1stctop cJ
      ctop wcel cJ c1stc wcel vx cv com cdom wbr vw cv vy cv wcel vw cv vz cv
      wcel vz cv vy cv wss wa vz vx cv wrex wi vy cJ wral wa vx cJ cpw wrex vw
      cX wral vw vx vy vz cJ cX 1stcclb.1 is1stc3 biimpcd mpd vx cv com cdom
      wbr vw cv vy cv wcel vw cv vz cv wcel vz cv vy cv wss wa vz vx cv wrex wi
      vy cJ wral wa vx cJ cpw wrex vx cv com cdom wbr cA vy cv wcel cA vz cv
      wcel vz cv vy cv wss wa vz vx cv wrex wi vy cJ wral wa vx cJ cpw wrex vw
      cA cX vw cv cA wceq vx cv com cdom wbr vw cv vy cv wcel vw cv vz cv wcel
      vz cv vy cv wss wa vz vx cv wrex wi vy cJ wral wa vx cv com cdom wbr cA
      vy cv wcel cA vz cv wcel vz cv vy cv wss wa vz vx cv wrex wi vy cJ wral
      wa vx cJ cpw vw cv cA wceq vw cv vy cv wcel vw cv vz cv wcel vz cv vy cv
      wss wa vz vx cv wrex wi vy cJ wral cA vy cv wcel cA vz cv wcel vz cv vy
      cv wss wa vz vx cv wrex wi vy cJ wral vx cv com cdom wbr vw cv cA wceq vw
      cv vy cv wcel vw cv vz cv wcel vz cv vy cv wss wa vz vx cv wrex wi cA vy
      cv wcel cA vz cv wcel vz cv vy cv wss wa vz vx cv wrex wi vy cJ vw cv cA
      wceq vw cv vy cv wcel cA vy cv wcel vw cv vz cv wcel vz cv vy cv wss wa
      vz vx cv wrex cA vz cv wcel vz cv vy cv wss wa vz vx cv wrex vw cv cA vy
      cv eleq1 vw cv cA wceq vw cv vz cv wcel vz cv vy cv wss wa cA vz cv wcel
      vz cv vy cv wss wa vz vx cv vw cv cA wceq vw cv vz cv wcel cA vz cv wcel
      vz cv vy cv wss vw cv cA vz cv eleq1 anbi1d rexbidv imbi12d ralbidv
      anbi2d rexbidv rcla4v mpan9 $.
      $( [22-Aug-2009] $) $( [22-Aug-2009] $)
  $}

  ${
    $d x y J $.
    $( The property of being second-countable. $)
    is2ndc $p |- ( J e. 2ndc <-> ( J e. Top /\ E. x e. Bases ( x ~<_ om /\ (
    topGen ` x ) = J ) ) ) $=
      vx cv com cdom wbr vx cv ctg cfv vy cv wceq wa vx ctb wrex vx cv com cdom
      wbr vx cv ctg cfv cJ wceq wa vx ctb wrex vy cJ ctop c2ndc vy cv cJ wceq
      vx cv com cdom wbr vx cv ctg cfv vy cv wceq wa vx cv com cdom wbr vx cv
      ctg cfv cJ wceq wa vx ctb vy cv cJ wceq vx cv ctg cfv vy cv wceq vx cv
      ctg cfv cJ wceq vx cv com cdom wbr vy cv cJ vx cv ctg cfv eqeq2 anbi2d
      rexbidv vy vx df-2ndc elrab2 $.
      $( [17-Jan-2010] $) $( [17-Jan-2010] $)
  $}

  ${
    $d x J $.
    $( The property of being second-countable with the condition that ` J ` is
       a topology removed. $)
    is2ndc2 $p |- ( J e. 2ndc <-> E. x e. Bases ( x ~<_ om /\ ( topGen ` x ) =
    J ) ) $=
      cJ c2ndc wcel cJ ctop wcel vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx
      ctb wrex wa vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx ctb wrex vx cJ
      is2ndc cJ ctop wcel vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx ctb
      wrex wa vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx ctb wrex cJ ctop
      wcel vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx ctb wrex pm3.27 vx cv
      com cdom wbr vx cv ctg cfv cJ wceq wa vx ctb wrex cJ ctop wcel vx cv com
      cdom wbr vx cv ctg cfv cJ wceq wa cJ ctop wcel vx ctb vx cv ctb wcel vx
      cv ctg cfv cJ wceq cJ ctop wcel vx cv com cdom wbr vx cv ctg cfv cJ wceq
      vx cv ctg cfv ctop wcel cJ ctop wcel vx cv ctb wcel vx cv ctg cfv cJ ctop
      eleq1 vx cv tgcl syl5cbi adantld r19.23aiv ancri impbii bitri $.
      $( [17-Jan-2010] $) $( [17-Jan-2010] $)
  $}

  ${
    $d x J $.
    $( A second-countable topology is a topology. $)
    2ndctop $p |- ( J e. 2ndc -> J e. Top ) $=
      cJ c2ndc wcel cJ ctop wcel vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx
      ctb wrex vx cJ is2ndc pm3.26bi $.
      $( [17-Jan-2010] $) $( [17-Jan-2010] $)
  $}

  ${
    $d x J $.
    $( A second-countable topology has a countable base. $)
    2ndccb $p |- ( J e. 2ndc -> E. x e. Bases ( x ~<_ om /\ ( topGen ` x ) = J
    ) ) $=
      cJ c2ndc wcel cJ ctop wcel vx cv com cdom wbr vx cv ctg cfv cJ wceq wa vx
      ctb wrex vx cJ is2ndc pm3.27bi $.
      $( [17-Jan-2010] $) $( [17-Jan-2010] $)
  $}

  ${
    $d x y J $.
    $( Having a countable subbase is a sufficient condition for
       second-countability. $)
    2ndcsb $p |- ( J e. Top -> ( J e. 2ndc <-> E. x ( x ~<_ om /\ ( topGen ` (
    fi ` x ) ) = J ) ) ) $=
      cJ ctop wcel cJ c2ndc wcel vy cv com cdom wbr vy cv ctg cfv cJ wceq wa vy
      ctb wrex vx cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq wa vx wex cJ
      c2ndc wcel cJ ctop wcel vy cv com cdom wbr vy cv ctg cfv cJ wceq wa vy
      ctb wrex vy cJ is2ndc baib cJ ctop wcel vy cv com cdom wbr vy cv ctg cfv
      cJ wceq wa vy ctb wrex vx cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq
      wa vx wex cJ ctop wcel vy cv com cdom wbr vy cv ctg cfv cJ wceq wa vx cv
      com cdom wbr vx cv cfi cfv ctg cfv cJ wceq wa vx wex vy ctb cJ ctop wcel
      vy cv ctb wcel vy cv com cdom wbr vy cv ctg cfv cJ wceq wa vx cv com cdom
      wbr vx cv cfi cfv ctg cfv cJ wceq wa vx wex vy cv com cdom wbr vy cv cfi
      cfv ctg cfv cJ wceq vx cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq wa
      vx wex cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr vy cv ctg cfv cJ
      wceq wa wa vx cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq wa vy cv com
      cdom wbr vy cv cfi cfv ctg cfv cJ wceq wa vx vy cv vy visset vx cv vy cv
      wceq vx cv com cdom wbr vy cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq
      vy cv cfi cfv ctg cfv cJ wceq vx cv vy cv com cdom breq1 vx cv vy cv wceq
      vx cv cfi cfv ctg cfv vy cv cfi cfv ctg cfv cJ vx cv vy cv wceq vx cv cfi
      cfv vy cv cfi cfv ctg vx cv vy cv cfi fveq2 fveq2d eqeq1d anbi12d cla4ev
      cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr vy cv ctg cfv cJ wceq
      simprl cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr vy cv ctg cfv cJ
      wceq wa wa vy cv cfi cfv ctg cfv cJ ctg cfv cJ vy cv cfi cfv ctb wcel cJ
      ctb wcel vy cv cfi cfv cJ wss cJ vy cv cfi cfv ctg cfv wss vy cv cfi cfv
      ctg cfv cJ ctg cfv wceq cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr
      vy cv ctg cfv cJ wceq wa wa vy cv cfi cfv cJ 2basgen vy cv ctb wcel vy cv
      cfi cfv ctb wcel cJ ctop wcel vy cv com cdom wbr vy cv ctg cfv cJ wceq wa
      vy cv ctb fibas ad2antlr cJ ctop wcel cJ ctb wcel vy cv ctb wcel vy cv
      com cdom wbr vy cv ctg cfv cJ wceq wa cJ topbas ad2antrr cJ ctop wcel vy
      cv ctb wcel wa vy cv com cdom wbr vy cv ctg cfv cJ wceq wa wa vy cv cfi
      cfv cJ cfi cfv cJ cJ ctop wcel vy cv cJ wss vy cv cfi cfv cJ cfi cfv wss
      cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr vy cv ctg cfv cJ wceq
      wa wa vy cv cJ ctop fiss cJ ctop wcel vy cv ctb wcel vy cv com cdom wbr
      vy cv ctg cfv cJ wceq wa simpll cJ ctop wcel vy cv ctb wcel wa vy cv com
      cdom wbr vy cv ctg cfv cJ wceq vy cv cJ wss vy cv ctg cfv cJ wceq vy cv
      vy cv ctg cfv wss vy cv cJ wss cJ ctop wcel vy cv ctb wcel wa vy cv com
      cdom wbr wa vy cv ctg cfv cJ vy cv sseq2 vy cv ctb wcel vy cv vy cv ctg
      cfv wss cJ ctop wcel vy cv com cdom wbr vy cv bastg ad2antlr syl5cbi impr
      sylanc cJ ctop wcel cJ cfi cfv cJ wceq vy cv ctb wcel vy cv com cdom wbr
      vy cv ctg cfv cJ wceq wa cJ fitop ad2antrr sseqtrd cJ ctop wcel vy cv ctb
      wcel wa vy cv com cdom wbr vy cv ctg cfv cJ wceq cJ vy cv cfi cfv ctg cfv
      wss vy cv ctg cfv cJ wceq vy cv ctg cfv vy cv cfi cfv ctg cfv wss cJ vy
      cv cfi cfv ctg cfv wss cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr
      wa vy cv ctg cfv cJ vy cv cfi cfv ctg cfv sseq1 vy cv ctb wcel vy cv cfi
      cfv ctb wcel vy cv vy cv cfi cfv wss vy cv ctg cfv vy cv cfi cfv ctg cfv
      wss cJ ctop wcel vy cv ctb wcel wa vy cv com cdom wbr wa vy cv vy cv cfi
      cfv tgss cJ ctop wcel vy cv ctb wcel vy cv com cdom wbr simplr vy cv ctb
      wcel vy cv cfi cfv ctb wcel cJ ctop wcel vy cv com cdom wbr vy cv ctb
      fibas ad2antlr vy cv ctb wcel vy cv vy cv cfi cfv wss cJ ctop wcel vy cv
      com cdom wbr vy cv ctb abfi2 ad2antlr syl3anc syl5cbi impr syl2anc cJ
      ctop wcel cJ ctg cfv cJ wceq vy cv ctb wcel vy cv com cdom wbr vy cv ctg
      cfv cJ wceq wa cJ tgtop ad2antrr eqtrd sylanc exp31 r19.23adv cJ ctop
      wcel vx cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq wa vy cv com cdom
      wbr vy cv ctg cfv cJ wceq wa vy ctb wrex vx cJ ctop wcel vx cv com cdom
      wbr vx cv cfi cfv ctg cfv cJ wceq wa vy cv com cdom wbr vy cv ctg cfv cJ
      wceq wa vy ctb wrex vx cv cfi cfv ctb wcel vx cv cfi cfv com cdom wbr vx
      cv cfi cfv ctg cfv cJ wceq vy cv com cdom wbr vy cv ctg cfv cJ wceq wa vy
      ctb wrex cJ ctop wcel vx cv com cdom wbr vx cv cfi cfv ctg cfv cJ wceq wa
      wa vx cv cfi cfv ctb wcel cJ ctop wcel vx cv com cdom wbr vx cv cfi cfv
      ctg cfv cJ wceq wa wa vx cv cvv wcel vx cv cfi cfv ctb wcel vx visset vx
      cv cvv fibas ax-mp a1i vx cv com cdom wbr vx cv cfi cfv com cdom wbr cJ
      ctop wcel vx cv cfi cfv ctg cfv cJ wceq vx cv com cdom wbr vx cv cfi cfv
      com cdom wbr vx cv cvv wcel vx cv com cdom wbr vx cv cfi cfv com cdom wbr
      wb vx visset vx cv cvv fictb ax-mp biimpi ad2antrl cJ ctop wcel vx cv com
      cdom wbr vx cv cfi cfv ctg cfv cJ wceq simprr vy cv com cdom wbr vy cv
      ctg cfv cJ wceq wa vx cv cfi cfv com cdom wbr vx cv cfi cfv ctg cfv cJ
      wceq wa vy vx cv cfi cfv ctb vy cv vx cv cfi cfv wceq vy cv com cdom wbr
      vx cv cfi cfv com cdom wbr vy cv ctg cfv cJ wceq vx cv cfi cfv ctg cfv cJ
      wceq vy cv vx cv cfi cfv com cdom breq1 vy cv vx cv cfi cfv wceq vy cv
      ctg cfv vx cv cfi cfv ctg cfv cJ vy cv vx cv cfi cfv ctg fveq2 eqeq1d
      anbi12d rcla4ev sylan32c ex 19.23adv impbid bitrd $.
      $( [17-Jan-2010] $) $( [17-Jan-2010] $)
  $}

  ${
    $d b o p q s t x y J $.
    $( A second-countable space is first-countable. $)
    2ndc1stc $p |- ( J e. 2ndc -> J e. 1stc ) $=
      cJ c2ndc wcel cJ c1stc wcel vs cv com cdom wbr vx cv vo cv wcel vx cv vp
      cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ wral wa vs cJ cpw wrex
      vx cJ cuni wral cJ c2ndc wcel vs cv com cdom wbr vx cv vo cv wcel vx cv
      vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ wral wa vs cJ cpw
      wrex vx cJ cuni cJ c2ndc wcel vb cv com cdom wbr vb cv ctg cfv cJ wceq wa
      vb ctb wrex vx cv cJ cuni wcel vs cv com cdom wbr vx cv vo cv wcel vx cv
      vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ wral wa vs cJ cpw
      wrex wi vb cJ is2ndc2 vb cv com cdom wbr vb cv ctg cfv cJ wceq wa vx cv
      cJ cuni wcel vs cv com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv
      vo cv wss wa vp vs cv wrex wi vo cJ wral wa vs cJ cpw wrex wi vb ctb vb
      cv ctb wcel vb cv com cdom wbr vb cv ctg cfv cJ wceq vx cv cJ cuni wcel
      vs cv com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa
      vp vs cv wrex wi vo cJ wral wa vs cJ cpw wrex wi vb cv ctg cfv cJ wceq vx
      cv vb cv ctg cfv cuni wcel vs cv com cdom wbr vx cv vo cv wcel vx cv vp
      cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo vb cv ctg cfv wral wa vs
      vb cv ctg cfv cpw wrex wi vx cv cJ cuni wcel vs cv com cdom wbr vx cv vo
      cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ wral
      wa vs cJ cpw wrex wi vb cv ctb wcel vb cv com cdom wbr wa vb cv ctg cfv
      cJ wceq vx cv vb cv ctg cfv cuni wcel vx cv cJ cuni wcel vs cv com cdom
      wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi
      vo vb cv ctg cfv wral wa vs vb cv ctg cfv cpw wrex vs cv com cdom wbr vx
      cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ
      wral wa vs cJ cpw wrex vb cv ctg cfv cJ wceq vb cv ctg cfv cuni cJ cuni
      vx cv vb cv ctg cfv cJ unieq eleq2d vb cv ctg cfv cJ wceq vs cv com cdom
      wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi
      vo vb cv ctg cfv wral wa vs cv com cdom wbr vx cv vo cv wcel vx cv vp cv
      wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ wral wa vs vb cv ctg cfv
      cpw cJ cpw vb cv ctg cfv cJ pweq vb cv ctg cfv cJ wceq vx cv vo cv wcel
      vx cv vp cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo vb cv ctg cfv
      wral vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv wrex
      wi vo cJ wral vs cv com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv
      vo cv wss wa vp vs cv wrex wi vo vb cv ctg cfv cJ raleq1 anbi2d rexeq12d
      imbi12d vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel
      vs cv com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa
      vp vs cv wrex wi vo vb cv ctg cfv wral wa vs vb cv ctg cfv cpw wrex vx cv
      vq cv wcel vq vb cv crab vb cv ctg cfv cpw wcel vx cv vq cv wcel vq vb cv
      crab com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp
      vx cv vq cv wcel vq vb cv crab wrex wi vo vb cv ctg cfv wral vs cv com
      cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv
      wrex wi vo vb cv ctg cfv wral wa vs vb cv ctg cfv cpw wrex vb cv ctb wcel
      vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vb cv ctb wcel vb cv
      com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vx cv vq cv wcel vq vb cv
      crab vb cv ctg cfv wss vx cv vq cv wcel vq vb cv crab vb cv ctg cfv cpw
      wcel vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a
      vx cv vq cv wcel vq vb cv crab vb cv vb cv ctg cfv vx cv vq cv wcel vq vb
      cv crab vb cv wss vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv
      cuni wcel w3a vx cv vq cv wcel vq vb cv ssrab2 a1i vb cv ctb wcel vb cv
      com cdom wbr vb cv vb cv ctg cfv wss vx cv vb cv ctg cfv cuni wcel vb cv
      bastg 3ad2ant1 sstrd vx cv vq cv wcel vq vb cv crab vb cv ctg cfv vb cv
      ctg fvex elpw2 sylibr vx cv vq cv wcel vq vb cv crab vb cv cdom wbr vb cv
      com cdom wbr vx cv vq cv wcel vq vb cv crab com cdom wbr vb cv ctb wcel
      vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vx cv vq cv wcel vq
      vb cv crab vb cv com domtr vx cv vq cv wcel vq vb cv crab vb cv cdom wbr
      vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vx cv
      vq cv wcel vq vb cv crab cvv wcel vx cv vq cv wcel vq vb cv crab vb cv
      wss vx cv vq cv wcel vq vb cv crab vb cv cdom wbr vx cv vq cv wcel vq vb
      cv vb visset rabex vx cv vq cv wcel vq vb cv ssrab2 vx cv vq cv wcel vq
      vb cv crab vb cv cvv ssdomg mp2 a1i vb cv ctb wcel vb cv com cdom wbr vx
      cv vb cv ctg cfv cuni wcel 3simp2 sylanc vb cv ctb wcel vb cv com cdom
      wbr vx cv vb cv ctg cfv cuni wcel w3a vx cv vo cv wcel vx cv vp cv wcel
      vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab wrex wi vo vb cv ctg
      cfv vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a
      vo cv vb cv ctg cfv wcel vo cv vb cv cuni wss vy cv vt cv wcel vt cv vo
      cv wss wa vt vb cv wrex vy vo cv wral wa vx cv vo cv wcel vx cv vp cv
      wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab wrex wi vb cv
      ctb wcel vb cv com cdom wbr vo cv vb cv ctg cfv wcel vo cv vb cv cuni wss
      vy cv vt cv wcel vt cv vo cv wss wa vt vb cv wrex vy vo cv wral wa wb vx
      cv vb cv ctg cfv cuni wcel vy vt vo cv vb cv eltg2 3ad2ant1 vb cv ctb
      wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vy cv vt cv
      wcel vt cv vo cv wss wa vt vb cv wrex vy vo cv wral vx cv vo cv wcel vx
      cv vp cv wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab wrex
      wi vo cv vb cv cuni wss vy cv vt cv wcel vt cv vo cv wss wa vt vb cv wrex
      vy vo cv wral vx cv vo cv wcel vx cv vt cv wcel vt cv vo cv wss wa vt vb
      cv wrex vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel
      w3a vx cv vp cv wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab
      wrex vy cv vt cv wcel vt cv vo cv wss wa vt vb cv wrex vx cv vt cv wcel
      vt cv vo cv wss wa vt vb cv wrex vy vx cv vo cv vy cv vx cv wceq vy cv vt
      cv wcel vt cv vo cv wss wa vx cv vt cv wcel vt cv vo cv wss wa vt vb cv
      vy cv vx cv wceq vy cv vt cv wcel vx cv vt cv wcel vt cv vo cv wss vy cv
      vx cv vt cv eleq1 anbi1d rexbidv rcla4cv vb cv ctb wcel vb cv com cdom
      wbr vx cv vb cv ctg cfv cuni wcel w3a vx cv vt cv wcel vt cv vo cv wss wa
      vx cv vp cv wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab
      wrex vt vb cv vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni
      wcel w3a vt cv vb cv wcel vx cv vt cv wcel vt cv vo cv wss wa vx cv vp cv
      wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab wrex vt cv vx
      cv vq cv wcel vq vb cv crab wcel vx cv vt cv wcel vt cv vo cv wss wa vx
      cv vp cv wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv crab wrex
      vb cv ctb wcel vb cv com cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vt cv
      vb cv wcel vx cv vt cv wcel vt cv vo cv wss wa wa wa vx cv vp cv wcel vp
      cv vo cv wss wa vx cv vt cv wcel vt cv vo cv wss wa vp vt cv vx cv vq cv
      wcel vq vb cv crab vp cv vt cv wceq vx cv vp cv wcel vx cv vt cv wcel vp
      cv vo cv wss vt cv vo cv wss vp cv vt cv vx cv eleq2 vp cv vt cv vo cv
      sseq1 anbi12d rcla4ev vt cv vb cv wcel vx cv vt cv wcel vt cv vo cv wss
      wa wa vt cv vx cv vq cv wcel vq vb cv crab wcel vb cv ctb wcel vb cv com
      cdom wbr vx cv vb cv ctg cfv cuni wcel w3a vt cv vb cv wcel vx cv vt cv
      wcel vt cv vo cv wss wa wa vt cv vb cv wcel vx cv vt cv wcel wa vt cv vx
      cv vq cv wcel vq vb cv crab wcel vt cv vb cv wcel vx cv vt cv wcel vt cv
      vb cv wcel vx cv vt cv wcel wa vt cv vo cv wss vt cv vb cv wcel vx cv vt
      cv wcel wa id adantrr vx cv vq cv wcel vx cv vt cv wcel vq vt cv vb cv vq
      cv vt cv vx cv eleq2 elrab sylibr adantl vb cv ctb wcel vb cv com cdom
      wbr vx cv vb cv ctg cfv cuni wcel w3a vt cv vb cv wcel vx cv vt cv wcel
      vt cv vo cv wss wa simprr sylanc exp32 r19.23adv syl9r adantld sylbid
      r19.21aiv vs cv com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo
      cv wss wa vp vs cv wrex wi vo vb cv ctg cfv wral wa vx cv vq cv wcel vq
      vb cv crab com cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss
      wa vp vx cv vq cv wcel vq vb cv crab wrex wi vo vb cv ctg cfv wral wa vs
      vx cv vq cv wcel vq vb cv crab vb cv ctg cfv cpw vs cv vx cv vq cv wcel
      vq vb cv crab wceq vs cv com cdom wbr vx cv vq cv wcel vq vb cv crab com
      cdom wbr vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv
      wrex wi vo vb cv ctg cfv wral vx cv vo cv wcel vx cv vp cv wcel vp cv vo
      cv wss wa vp vx cv vq cv wcel vq vb cv crab wrex wi vo vb cv ctg cfv wral
      vs cv vx cv vq cv wcel vq vb cv crab com cdom breq1 vs cv vx cv vq cv
      wcel vq vb cv crab wceq vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss
      wa vp vs cv wrex wi vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa
      vp vx cv vq cv wcel vq vb cv crab wrex wi vo vb cv ctg cfv vs cv vx cv vq
      cv wcel vq vb cv crab wceq vx cv vp cv wcel vp cv vo cv wss wa vp vs cv
      wrex vx cv vp cv wcel vp cv vo cv wss wa vp vx cv vq cv wcel vq vb cv
      crab wrex vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp vs cv
      vx cv vq cv wcel vq vb cv crab rexeq1 imbi2d ralbidv anbi12d rcla4ev
      sylan32c 3expia syl5cbi expimpd r19.23aiv sylbi r19.21aiv cJ c2ndc wcel
      cJ ctop wcel cJ c1stc wcel vs cv com cdom wbr vx cv vo cv wcel vx cv vp
      cv wcel vp cv vo cv wss wa vp vs cv wrex wi vo cJ wral wa vs cJ cpw wrex
      vx cJ cuni wral wb cJ 2ndctop vx vs vo vp cJ cJ cuni cJ cuni eqid is1stc3
      syl mpbird $.
      $( [17-Jan-2010] $) $( [17-Jan-2010] $)
  $}

  ${
    $d b c d f j k m n o p q r s t u v w x y z B $. $d b c d f j k m n
    o p q r s t u v w x y z J $. $d b c d f j k m n o p q r s t u v w x y
    z X $.
    2ndcctbss.1 $e |- X = U. B $.
    2ndcctbss.2 $e |- J = ( topGen ` B ) $.
    $( If a topology is second-countable, every base has a countable subset
       which is a base. Exercise 16B2 in Willard. $)
    2ndcctbss $p |- ( ( B e. Bases /\ J e. 2ndc ) -> E. b e. Bases ( b ~<_ om
    /\ b C_ B /\ J = ( topGen ` b ) ) ) $=
      cB ctb wcel cJ c2ndc wcel wa vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      vc ctb wrex vb cv com cdom wbr vb cv cB wss cJ vb cv ctg cfv wceq w3a vb
      ctb wrex cJ c2ndc wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa vc ctb
      wrex cB ctb wcel vc cJ 2ndccb adantl cB ctb wcel cJ c2ndc wcel wa vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa vb cv com cdom wbr vb cv cB wss cJ
      vb cv ctg cfv wceq w3a vb ctb wrex vc ctb cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa vb cv com cdom
      wbr vb cv cB wss cJ vb cv ctg cfv wceq w3a vb ctb wrex cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa vf wex vb cv com cdom wbr vb cv cB wss cJ vb cv ctg cfv wceq w3a vb
      ctb wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr
      vc cv ctg cfv cJ wceq wa wa wa vx cv c1st cfv vy cv wss vy cv vx cv c2nd
      cfv wss wa vy cB wrex vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vf wex cB ctb wcel
      cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq
      wa wa wa vx cv c1st cfv vy cv wss vy cv vx cv c2nd cfv wss wa vy cB wrex
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc
      cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vx cv vu cv vv cv cop wceq
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a wa vv wex vu wex vx cv c1st cfv vy cv wss vy cv vx cv c2nd
      cfv wss wa vy cB wrex vx cv vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wcel cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vx cv vu cv vv cv cop wceq vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a wa vx cv c1st cfv vy cv wss
      vy cv vx cv c2nd cfv wss wa vy cB wrex vu vv cB ctb wcel cJ c2ndc wcel wa
      vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vx cv vu
      cv vv cv cop wceq vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vx cv c1st cfv vy cv wss vy cv vx cv c2nd cfv
      wss wa vy cB wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vx cv c1st cfv vu cv wceq vx cv
      c2nd cfv vv cv wceq wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vx cv c1st cfv vy cv wss vy cv vx cv
      c2nd cfv wss wa vy cB wrex wi vx cv vu cv vv cv cop wceq vx cv c1st cfv
      vu cv wceq vx cv c2nd cfv vv cv wceq wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vx cv c1st cfv vy cv
      wss vy cv vx cv c2nd cfv wss wa vy cB wrex wi wi cB ctb wcel cJ c2ndc
      wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vx cv c1st cfv vu cv wceq vx cv c2nd cfv vv cv wceq wa vx cv
      c1st cfv vy cv wss vy cv vx cv c2nd cfv wss wa vy cB wrex vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex vu cv vc cv wcel vx cv c1st cfv vu cv wceq
      vx cv c2nd cfv vv cv wceq wa vx cv c1st cfv vy cv wss vy cv vx cv c2nd
      cfv wss wa vy cB wrex wi vv cv vc cv wcel vx cv c1st cfv vu cv wceq vx cv
      c2nd cfv vv cv wceq wa vu cv vw cv wss vw cv vv cv wss wa vw cB wrex vx
      cv c1st cfv vy cv wss vy cv vx cv c2nd cfv wss wa vy cB wrex vx cv c1st
      cfv vu cv wceq vx cv c2nd cfv vv cv wceq wa vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex vx cv c1st cfv vw cv wss vw cv vx cv c2nd cfv wss wa vw
      cB wrex vx cv c1st cfv vy cv wss vy cv vx cv c2nd cfv wss wa vy cB wrex
      vx cv c1st cfv vu cv wceq vx cv c1st cfv vw cv wss vw cv vx cv c2nd cfv
      wss wa vw cB wrex vu cv vw cv wss vw cv vx cv c2nd cfv wss wa vw cB wrex
      vx cv c2nd cfv vv cv wceq vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      vx cv c1st cfv vu cv wceq vx cv c1st cfv vw cv wss vw cv vx cv c2nd cfv
      wss wa vu cv vw cv wss vw cv vx cv c2nd cfv wss wa vw cB vx cv c1st cfv
      vu cv wceq vx cv c1st cfv vw cv wss vu cv vw cv wss vw cv vx cv c2nd cfv
      wss vx cv c1st cfv vu cv vw cv sseq1 anbi1d rexbidv vx cv c2nd cfv vv cv
      wceq vu cv vw cv wss vw cv vx cv c2nd cfv wss wa vu cv vw cv wss vw cv vv
      cv wss wa vw cB vx cv c2nd cfv vv cv wceq vw cv vx cv c2nd cfv wss vw cv
      vv cv wss vu cv vw cv wss vx cv c2nd cfv vv cv vw cv sseq2 anbi2d rexbidv
      sylan9bb vx cv c1st cfv vw cv wss vw cv vx cv c2nd cfv wss wa vw cB wrex
      vx cv c1st cfv vy cv wss vy cv vx cv c2nd cfv wss wa vy cB wrex vx cv
      c1st cfv vw cv wss vw cv vx cv c2nd cfv wss wa vx cv c1st cfv vy cv wss
      vy cv vx cv c2nd cfv wss wa vw vy cB vw cv vy cv wceq vx cv c1st cfv vw
      cv wss vx cv c1st cfv vy cv wss vw cv vx cv c2nd cfv wss vy cv vx cv c2nd
      cfv wss vw cv vy cv vx cv c1st cfv sseq2 vw cv vy cv vx cv c2nd cfv sseq1
      anbi12d cbvrexv biimpi syl6bir com12 3ad2ant3 com12 a1i vx cv vu cv vv cv
      cop wceq vx cv c1st cfv vu cv wceq vx cv c2nd cfv vv cv wceq vx cv vu cv
      vv cv cop wceq vx cv c1st cfv vu cv vv cv cop c1st cfv vu cv vx cv vu cv
      vv cv cop c1st fveq2 vu cv vv cv vu visset op1st syl6eq vx cv vu cv vv cv
      cop wceq vx cv c2nd cfv vu cv vv cv cop c2nd cfv vv cv vx cv vu cv vv cv
      cop c2nd fveq2 vu cv vv cv vu visset vv visset op2nd syl6eq jca syl5
      imp3a 19.23advv vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vu vv vx cv elopab syl5ib r19.21aiv vx cv
      c1st cfv vy cv wss vy cv vx cv c2nd cfv wss wa vx cv c1st cfv vx cv vf cv
      cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vy vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab vc cv vc cv cxp vc cv vc cv vc visset
      vc visset xpex vr vs vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw
      cv vv cv wss wa vw cB wrex w3a vu vv copab vc cv vc cv cxp vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv relopab vr cv vs cv cop vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wcel vr cv vc cv
      wcel vs cv vc cv wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex w3a
      vr cv vs cv cop vc cv vc cv cxp wcel vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vr cv vc cv wcel vv cv vc
      cv wcel vr cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vr cv vc cv
      wcel vs cv vc cv wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex w3a
      vu vv vr cv vs cv vr visset vs visset vu cv vr cv wceq vu cv vc cv wcel
      vr cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex vr cv vw
      cv wss vw cv vv cv wss wa vw cB wrex vv cv vc cv wcel vu cv vr cv vc cv
      eleq1 vu cv vr cv wceq vu cv vw cv wss vw cv vv cv wss wa vr cv vw cv wss
      vw cv vv cv wss wa vw cB vu cv vr cv wceq vu cv vw cv wss vr cv vw cv wss
      vw cv vv cv wss vu cv vr cv vw cv sseq1 anbi1d rexbidv 3anbi13d vv cv vs
      cv wceq vv cv vc cv wcel vs cv vc cv wcel vr cv vw cv wss vw cv vv cv wss
      wa vw cB wrex vr cv vw cv wss vw cv vs cv wss wa vw cB wrex vr cv vc cv
      wcel vv cv vs cv vc cv eleq1 vv cv vs cv wceq vr cv vw cv wss vw cv vv cv
      wss wa vr cv vw cv wss vw cv vs cv wss wa vw cB vv cv vs cv wceq vw cv vv
      cv wss vw cv vs cv wss vr cv vw cv wss vv cv vs cv vw cv sseq2 anbi2d
      rexbidv 3anbi23d opelopab vr cv vc cv wcel vs cv vc cv wcel vr cv vs cv
      cop vc cv vc cv cxp wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex vr
      cv vs cv vc cv vc cv opelxpi 3adant3 sylbi relssi ssexi vy cv vx cv vf cv
      cfv wceq vx cv c1st cfv vy cv wss vx cv c1st cfv vx cv vf cv cfv wss vy
      cv vx cv c2nd cfv wss vx cv vf cv cfv vx cv c2nd cfv wss vy cv vx cv vf
      cv cfv vx cv c1st cfv sseq2 vy cv vx cv vf cv cfv vx cv c2nd cfv sseq1
      anbi12d ac6s syl cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa vb cv com cdom wbr vb cv cB wss cJ vb
      cv ctg cfv wceq w3a vb ctb wrex vf cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vb cv com cdom wbr
      vb cv cB wss cJ vb cv ctg cfv wceq w3a vb ctb wrex cB ctb wcel cJ c2ndc
      wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx
      cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa wa
      vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq wa vb cv com cdom wbr vb cv
      cB wss cJ vb cv ctg cfv wceq w3a vb ctb wrex cJ ctop wcel vf cv crn cJ
      wss vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex vt vo cv wral
      vo cJ wral vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq wa cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa wa vo vt vb vf cv crn cJ basgen2 cB ctb wcel cJ c2ndc wcel wa cJ ctop
      wcel vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa vu cv
      vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa cJ c2ndc
      wcel cJ ctop wcel cB ctb wcel cJ 2ndctop adantl ad2antrr cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa wa vf cv crn cB cJ vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vf cv crn cB
      wss cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv
      ctg cfv cJ wceq wa wa wa vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv frn ad2antrl cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa wa cB cB ctg cfv cJ
      cB ctb wcel cJ c2ndc wcel wa cB cB ctg cfv wss vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx
      cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab wral wa cB ctb wcel cB cB ctg cfv wss cJ c2ndc
      wcel cB bastg adantr ad2antrr 2ndcctbss.2 syl6ssr sstrd cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa wa vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex vo vt cJ vo
      cv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv
      ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st
      cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa vt cv vb cv
      wcel vb cv vo cv wss wa vb vf cv crn wrex cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vt cv vd cv wcel vd cv vo cv wss wa vd vc
      cv wrex vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex vc cv ctb
      wcel vo cv vc cv ctg cfv wcel vt cv vo cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa vd vc cv wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf
      cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv
      wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel
      wa wa wa vd vo cv vc cv vt cv tg2 cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa vu cv vc cv wcel vv cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab
      cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv
      wcel wa wa simplrl cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa
      wa vo cv cJ vc cv ctg cfv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc
      cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB
      vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv
      wcel simprrl vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa vc cv ctg cfv cJ wceq cB ctb wcel cJ c2ndc wcel wa vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv
      vo cv wcel wa wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq
      simprr ad2antlr eleqtrrd cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc
      cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB
      vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv
      wcel simprrr syl3anc cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf
      cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv
      wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel
      wa wa wa vt cv vd cv wcel vd cv vo cv wss wa vt cv vb cv wcel vb cv vo cv
      wss wa vb vf cv crn wrex vd vc cv cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv
      vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa
      vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv
      wcel vd cv vo cv wss wa wa wa vt cv vm cv wcel vm cv vd cv wss wa vm cB
      wrex vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex cB ctb wcel vd
      cv cB ctg cfv wcel vt cv vd cv wcel vt cv vm cv wcel vm cv vd cv wss wa
      vm cB wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr
      vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv
      c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd
      cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm vd cv cB vt cv
      tg2 cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv
      ctg cfv cJ wceq wa wa wa cB ctb wcel vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx
      cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa vd
      cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa cB ctb wcel cJ c2ndc
      wcel vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa simpll
      ad2antrr cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr
      vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv
      c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd
      cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vc cv cB ctg cfv
      vd cv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc
      cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st
      cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc
      cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vc cv vc cv ctg cfv cB
      ctg cfv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc
      cv ctg cfv cJ wceq wa wa wa vc cv vc cv ctg cfv wss vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv
      vo cv wcel wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa
      vc cv ctb wcel vc cv vc cv ctg cfv wss cB ctb wcel cJ c2ndc wcel wa vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa vc cv bastg ad2antrl ad2antrr cB
      ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv
      cJ wceq wa wa wa vc cv ctg cfv cB ctg cfv wceq vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB
      vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv
      wcel wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa vc cv ctg cfv cB ctg cfv wceq cB
      ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv ctg cfv cJ wceq vc cv ctg
      cfv cB ctg cfv wceq vc cv com cdom wbr vc cv ctg cfv cJ wceq vc cv ctg
      cfv cB ctg cfv wceq cJ cB ctg cfv vc cv ctg cfv 2ndcctbss.2 eqeq2i biimpi
      adantl ad2antll ad2antrr sseqtrd cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv
      vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa
      simprl sseldd cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom
      wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx
      cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa
      vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss simprrl syl3anc cB ctb
      wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ
      wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf
      cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt
      cv vd cv wcel vd cv vo cv wss wa wa wa vt cv vm cv wcel vm cv vd cv wss
      wa vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex vm cB cB ctb
      wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ
      wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf
      cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt
      cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm
      cv vd cv wss wa vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex cB
      ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv
      cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv
      vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt
      cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm
      cv vd cv wss wa wa wa vt cv vn cv wcel vn cv vm cv wss wa vn vc cv wrex
      vt cv vb cv wcel vb cv vo cv wss wa vb vf cv crn wrex vc cv ctb wcel vm
      cv vc cv ctg cfv wcel vt cv vm cv wcel vt cv vn cv wcel vn cv vm cv wss
      wa vn vc cv wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa
      wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn vm cv vc cv vt cv tg2
      cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg
      cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw
      cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx
      cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vc cv ctb
      wcel vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa cB ctb wcel cJ c2ndc wcel wa
      vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa simplrl ad2antrr cB ctb wcel cJ c2ndc wcel wa
      vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa
      cB vc cv ctg cfv vm cv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf
      cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv
      wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel
      wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm cv
      cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa cB cB ctg cfv vc cv ctg
      cfv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv
      ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st
      cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa cB cB ctg
      cfv wss vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa cB ctb wcel cJ c2ndc wcel wa
      cB cB ctg cfv wss vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa vo cv cJ wcel vt cv vo cv wcel wa wa cB ctb wcel cB cB ctg cfv wss cJ
      c2ndc wcel cB bastg adantr ad2antrr ad2antrr cB ctb wcel cJ c2ndc wcel wa
      vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa
      vc cv ctg cfv cJ cB ctg cfv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel
      vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab
      cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv
      wcel wa wa wa vc cv ctg cfv cJ wceq vd cv vc cv wcel vt cv vd cv wcel vd
      cv vo cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa
      vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa vc cv ctg
      cfv cJ wceq cB ctb wcel cJ c2ndc wcel wa vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf
      cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv
      wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel
      wa wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq simprr
      ad2antlr ad2antrr 2ndcctbss.2 syl6req sseqtrd cB ctb wcel cJ c2ndc wcel
      wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv
      vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa simprl
      sseldd cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc
      cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st
      cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc
      cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB wcel vt cv vm
      cv wcel vm cv vd cv wss simprrl syl3anc cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa
      vt cv vn cv wcel vn cv vm cv wss wa vt cv vb cv wcel vb cv vo cv wss wa
      vb vf cv crn wrex vn vc cv cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc
      cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB
      vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv
      wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa
      vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel
      vt cv vn cv wcel vn cv vm cv wss wa vt cv vb cv wcel vb cv vo cv wss wa
      vb vf cv crn wrex vn cv vd cv cop vf cv cfv vf cv crn wcel vt cv vn cv vd
      cv cop vf cv cfv wcel vn cv vd cv cop vf cv cfv vo cv wss wa vt cv vb cv
      wcel vb cv vo cv wss wa vb vf cv crn wrex cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa
      vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa wa wa vt cv vb cv
      wcel vb cv vo cv wss wa vt cv vn cv vd cv cop vf cv cfv wcel vn cv vd cv
      cop vf cv cfv vo cv wss wa vb vn cv vd cv cop vf cv cfv vf cv crn vb cv
      vn cv vd cv cop vf cv cfv wceq vt cv vb cv wcel vt cv vn cv vd cv cop vf
      cv cfv wcel vb cv vo cv wss vn cv vd cv cop vf cv cfv vo cv wss vb cv vn
      cv vd cv cop vf cv cfv vt cv eleq2 vb cv vn cv vd cv cop vf cv cfv vo cv
      sseq1 anbi12d rcla4ev vf cv vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wfn vn cv vd cv cop vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wcel vn cv vd cv cop vf cv cfv vf cv crn wcel cB ctb
      wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ
      wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf
      cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt
      cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm
      cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss
      wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab vn cv vd cv cop vf cv fnfvelrn cB ctb
      wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ
      wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf
      cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv
      cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt
      cv vd cv wcel vd cv vo cv wss wa wa wa vf cv vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wfn vm
      cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa vn cv vc cv wcel vt cv
      vn cv wcel vn cv vm cv wss wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv
      c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa vf cv
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab wfn cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel
      vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vd cv vc cv wcel vt cv
      vd cv wcel vd cv vo cv wss wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vf cv
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab wfn vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral vo cv cJ
      wcel vt cv vo cv wcel wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv ffn ad2antrr
      ad2antlr ad2antrr cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa
      wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn
      cv wcel vn cv vm cv wss wa wa wa vn cv vc cv wcel vd cv vc cv wcel vn cv
      vw cv wss vw cv vd cv wss wa vw cB wrex w3a vn cv vd cv cop vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab wcel cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa
      wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn
      cv wcel vn cv vm cv wss wa wa wa vn cv vc cv wcel vd cv vc cv wcel vn cv
      vw cv wss vw cv vd cv wss wa vw cB wrex cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa
      vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa simprl cB ctb wcel
      cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq
      wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv
      cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab
      wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd
      cv wcel vd cv vo cv wss wa wa wa vd cv vc cv wcel vm cv cB wcel vt cv vm
      cv wcel vm cv vd cv wss wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm
      cv wss wa wa cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom
      wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx
      cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa wa
      vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa simprl ad2antrr vm
      cv cB wcel vn cv vm cv wss vm cv vd cv wss vn cv vw cv wss vw cv vd cv
      wss wa vw cB wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel wa wa
      wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn
      cv wcel vn cv vm cv wss wa wa wa cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv
      vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa
      wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa vn cv vc cv wcel
      vt cv vn cv wcel vn cv vm cv wss wa wa simplrl cB ctb wcel cJ c2ndc wcel
      wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv
      vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ
      wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo
      cv wss wa wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa
      vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss simprrr vm cv cB wcel
      vt cv vm cv wcel vm cv vd cv wss wa wa vm cv vd cv wss cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa vo cv cJ wcel vt cv vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv
      wcel vd cv vo cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm
      cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss simprr
      ad2antlr vn cv vw cv wss vw cv vd cv wss wa vn cv vm cv wss vm cv vd cv
      wss wa vw vm cv cB vw cv vm cv wceq vn cv vw cv wss vn cv vm cv wss vw cv
      vd cv wss vm cv vd cv wss vw cv vm cv vn cv sseq2 vw cv vm cv vd cv sseq1
      anbi12d rcla4ev sylan32c 3jca vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vn cv vc cv wcel vv cv vc cv
      wcel vn cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vn cv vc cv wcel
      vd cv vc cv wcel vn cv vw cv wss vw cv vd cv wss wa vw cB wrex w3a vu vv
      vn cv vd cv vn visset vd visset vu cv vn cv wceq vu cv vc cv wcel vn cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex vn cv vw cv wss
      vw cv vv cv wss wa vw cB wrex vv cv vc cv wcel vu cv vn cv vc cv eleq1 vu
      cv vn cv wceq vu cv vw cv wss vw cv vv cv wss wa vn cv vw cv wss vw cv vv
      cv wss wa vw cB vu cv vn cv wceq vu cv vw cv wss vn cv vw cv wss vw cv vv
      cv wss vu cv vn cv vw cv sseq1 anbi1d rexbidv 3anbi13d vv cv vd cv wceq
      vv cv vc cv wcel vd cv vc cv wcel vn cv vw cv wss vw cv vv cv wss wa vw
      cB wrex vn cv vw cv wss vw cv vd cv wss wa vw cB wrex vn cv vc cv wcel vv
      cv vd cv vc cv eleq1 vv cv vd cv wceq vn cv vw cv wss vw cv vv cv wss wa
      vn cv vw cv wss vw cv vd cv wss wa vw cB vv cv vd cv wceq vw cv vv cv wss
      vw cv vd cv wss vn cv vw cv wss vv cv vd cv vw cv sseq2 anbi2d rexbidv
      3anbi23d opelopab sylibr sylanc cB ctb wcel cJ c2ndc wcel wa vc cv ctb
      wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx
      cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv
      vo cv wcel wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa
      wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa vn cv vc cv wcel
      vt cv vn cv wcel vn cv vm cv wss wa wa vt cv vn cv vd cv cop vf cv cfv
      wcel vn cv vd cv cop vf cv cfv vo cv wss wa vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf
      cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv
      wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab wral wa vo cv cJ wcel vt cv vo cv wcel
      wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa vn cv vc cv wcel vt cv vn cv
      wcel vn cv vm cv wss wa wa vt cv vn cv vd cv cop vf cv cfv wcel vn cv vd
      cv cop vf cv cfv vo cv wss wa wi wi wi cB ctb wcel cJ c2ndc wcel wa vc cv
      ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vx cv c1st cfv
      vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab wral vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa
      vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa vn cv vc cv wcel vt
      cv vn cv wcel vn cv vm cv wss wa wa vt cv vn cv vd cv cop vf cv cfv wcel
      vn cv vd cv cop vf cv cfv vo cv wss wa wi wi wi vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB
      vf cv wf vo cv cJ wcel vt cv vo cv wcel wa vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt
      cv vm cv wcel vm cv vd cv wss wa wa vn cv vc cv wcel vt cv vn cv wcel vn
      cv vm cv wss wa wa vt cv vn cv vd cv cop vf cv cfv wcel vn cv vd cv cop
      vf cv cfv vo cv wss wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss
      wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv
      wcel vt cv vn cv wcel vn cv vm cv wss wa wa wa vx cv c1st cfv vx cv vf cv
      cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab
      wral vt cv vn cv vd cv cop vf cv cfv wcel vn cv vd cv cop vf cv cfv vo cv
      wss wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB
      wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn
      cv wcel vn cv vm cv wss wa wa wa vx cv c1st cfv vx cv vf cv cfv wss vx cv
      vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral vn cv vd
      cv cop c1st cfv vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv
      vn cv vd cv cop c2nd cfv wss wa vt cv vn cv vd cv cop vf cv cfv wcel vn
      cv vd cv cop vf cv cfv vo cv wss wa vd cv vc cv wcel vt cv vd cv wcel vd
      cv vo cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa
      wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa wa wa vn cv vd cv
      cop vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wcel vx cv c1st cfv vx cv vf cv cfv wss vx cv
      vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral vn cv vd
      cv cop c1st cfv vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv
      vn cv vd cv cop c2nd cfv wss wa wi vd cv vc cv wcel vt cv vd cv wcel vd
      cv vo cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa
      wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa wa wa vn cv vc cv
      wcel vd cv vc cv wcel vn cv vw cv wss vw cv vd cv wss wa vw cB wrex w3a
      vn cv vd cv cop vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vu vv copab wcel vd cv vc cv wcel vt cv vd cv
      wcel vd cv vo cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss
      wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa wa wa vn cv
      vc cv wcel vd cv vc cv wcel vn cv vw cv wss vw cv vd cv wss wa vw cB wrex
      vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt
      cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel
      vn cv vm cv wss wa simprl vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv
      wss wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa vn cv vc cv
      wcel vt cv vn cv wcel vn cv vm cv wss wa wa simplll vm cv cB wcel vn cv
      vm cv wss vm cv vd cv wss vn cv vw cv wss vw cv vd cv wss wa vw cB wrex
      vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt
      cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel
      vn cv vm cv wss wa wa wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv
      wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa vn cv vc cv
      wcel vt cv vn cv wcel vn cv vm cv wss wa wa simplrl vd cv vc cv wcel vt
      cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv
      vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss
      simprrr vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa vm cv vd cv
      wss vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vn cv vc cv
      wcel vt cv vn cv wcel vn cv vm cv wss wa wa vm cv cB wcel vt cv vm cv
      wcel vm cv vd cv wss simprr ad2antlr vn cv vw cv wss vw cv vd cv wss wa
      vn cv vm cv wss vm cv vd cv wss wa vw vm cv cB vw cv vm cv wceq vn cv vw
      cv wss vn cv vm cv wss vw cv vd cv wss vm cv vd cv wss vw cv vm cv vn cv
      sseq2 vw cv vm cv vd cv sseq1 anbi12d rcla4ev sylan32c 3jca vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vn cv vc cv wcel vv cv vc cv wcel vn cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vn cv vc cv wcel vd cv vc cv wcel vn cv vw cv wss vw cv vd cv
      wss wa vw cB wrex w3a vu vv vn cv vd cv vn visset vd visset vu cv vn cv
      wceq vu cv vc cv wcel vn cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex vn cv vw cv wss vw cv vv cv wss wa vw cB wrex vv cv vc cv wcel
      vu cv vn cv vc cv eleq1 vu cv vn cv wceq vu cv vw cv wss vw cv vv cv wss
      wa vn cv vw cv wss vw cv vv cv wss wa vw cB vu cv vn cv wceq vu cv vw cv
      wss vn cv vw cv wss vw cv vv cv wss vu cv vn cv vw cv sseq1 anbi1d
      rexbidv 3anbi13d vv cv vd cv wceq vv cv vc cv wcel vd cv vc cv wcel vn cv
      vw cv wss vw cv vv cv wss wa vw cB wrex vn cv vw cv wss vw cv vd cv wss
      wa vw cB wrex vn cv vc cv wcel vv cv vd cv vc cv eleq1 vv cv vd cv wceq
      vn cv vw cv wss vw cv vv cv wss wa vn cv vw cv wss vw cv vd cv wss wa vw
      cB vv cv vd cv wceq vw cv vv cv wss vw cv vd cv wss vn cv vw cv wss vv cv
      vd cv vw cv sseq2 anbi2d rexbidv 3anbi23d opelopab sylibr vx cv c1st cfv
      vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vn cv vd cv cop
      c1st cfv vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv vn cv vd
      cv cop c2nd cfv wss wa vx vn cv vd cv cop vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab vx cv
      vn cv vd cv cop wceq vx cv c1st cfv vx cv vf cv cfv wss vn cv vd cv cop
      c1st cfv vn cv vd cv cop vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss
      vn cv vd cv cop vf cv cfv vn cv vd cv cop c2nd cfv wss vx cv vn cv vd cv
      cop wceq vx cv c1st cfv vn cv vd cv cop c1st cfv vx cv vf cv cfv vn cv vd
      cv cop vf cv cfv vx cv vn cv vd cv cop c1st fveq2 vx cv vn cv vd cv cop
      vf cv fveq2 sseq12d vx cv vn cv vd cv cop wceq vx cv vf cv cfv vn cv vd
      cv cop vf cv cfv vx cv c2nd cfv vn cv vd cv cop c2nd cfv vx cv vn cv vd
      cv cop vf cv fveq2 vx cv vn cv vd cv cop c2nd fveq2 sseq12d anbi12d
      rcla4v syl vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv
      cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv
      vn cv wcel vn cv vm cv wss wa wa wa vn cv vn cv vd cv cop vf cv cfv wss
      vn cv vd cv cop vf cv cfv vd cv wss wa vt cv vn cv vd cv cop vf cv cfv
      wcel vn cv vd cv cop vf cv cfv vo cv wss wa vn cv vd cv cop c1st cfv vn
      cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv vn cv vd cv cop c2nd
      cfv wss wa vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv
      cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv
      vn cv wcel vn cv vm cv wss wa wa wa vn cv vn cv vd cv cop vf cv cfv wss
      vn cv vd cv cop vf cv cfv vd cv wss wa vt cv vn cv vd cv cop vf cv cfv
      wcel vn cv vd cv cop vf cv cfv vo cv wss wa vd cv vc cv wcel vt cv vd cv
      wcel vd cv vo cv wss wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss
      wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa wa wa vn cv
      vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv vd cv wss wa wa
      vt cv vn cv vd cv cop vf cv cfv wcel vn cv vd cv cop vf cv cfv vo cv wss
      vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt
      cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel
      vn cv vm cv wss wa wa wa vn cv vn cv vd cv cop vf cv cfv wss vn cv vd cv
      cop vf cv cfv vd cv wss wa wa vn cv vn cv vd cv cop vf cv cfv vt cv vd cv
      vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt cv vm
      cv wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv
      vm cv wss wa wa wa vn cv vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf
      cv cfv vd cv wss simprl vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss
      wa wa vt cv vn cv wcel vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss
      wa wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vn cv vn cv
      vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv vd cv wss wa vn cv vc
      cv wcel vt cv vn cv wcel vn cv vm cv wss simprl ad2antlr sseldd vd cv vc
      cv wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt cv vm cv
      wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm
      cv wss wa wa wa vn cv vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv
      cfv vd cv wss wa wa vn cv vd cv cop vf cv cfv vd cv vo cv vd cv vc cv
      wcel vt cv vd cv wcel vd cv vo cv wss wa wa vm cv cB wcel vt cv vm cv
      wcel vm cv vd cv wss wa wa wa vn cv vc cv wcel vt cv vn cv wcel vn cv vm
      cv wss wa wa wa vn cv vn cv vd cv cop vf cv cfv wss vn cv vd cv cop vf cv
      cfv vd cv wss simprr vd cv vc cv wcel vt cv vd cv wcel vd cv vo cv wss wa
      wa vm cv cB wcel vt cv vm cv wcel vm cv vd cv wss wa wa wa vd cv vo cv
      wss vn cv vc cv wcel vt cv vn cv wcel vn cv vm cv wss wa wa vn cv vn cv
      vd cv cop vf cv cfv wss vn cv vd cv cop vf cv cfv vd cv wss wa vd cv vc
      cv wcel vt cv vd cv wcel vd cv vo cv wss vm cv cB wcel vt cv vm cv wcel
      vm cv vd cv wss wa wa simplrr ad2antrr sstrd jca ex vn cv vd cv cop c1st
      cfv vn cv vd cv cop vf cv cfv wss vn cv vn cv vd cv cop vf cv cfv wss vn
      cv vd cv cop vf cv cfv vn cv vd cv cop c2nd cfv wss vn cv vd cv cop vf cv
      cfv vd cv wss vn cv vd cv cop c1st cfv vn cv vn cv vd cv cop vf cv cfv vn
      cv vd cv vn visset op1st sseq1i vn cv vd cv cop c2nd cfv vd cv vn cv vd
      cv cop vf cv cfv vn cv vd cv vn visset vd visset op2nd sseq2i anbi12i
      syl5ib syld com12 exp4c ad2antlr adantl imp41 sylanc exp32 r19.23adv mpd
      exp32 r19.23adv mpd exp32 r19.23adv mpd expr r19.21aivv syl3anc vf cv crn
      ctb wcel vf cv crn com cdom wbr vf cv crn cB wss cJ vf cv crn ctg cfv
      wceq w3a vb cv com cdom wbr vb cv cB wss cJ vb cv ctg cfv wceq w3a vb ctb
      wrex cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv
      ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st
      cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab wral wa wa vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq
      wa wa vb cv com cdom wbr vb cv cB wss cJ vb cv ctg cfv wceq w3a vf cv crn
      com cdom wbr vf cv crn cB wss cJ vf cv crn ctg cfv wceq w3a vb vf cv crn
      ctb vb cv vf cv crn wceq vb cv com cdom wbr vf cv crn com cdom wbr vb cv
      cB wss vf cv crn cB wss cJ vb cv ctg cfv wceq cJ vf cv crn ctg cfv wceq
      vb cv vf cv crn com cdom breq1 vb cv vf cv crn cB sseq1 vb cv vf cv crn
      wceq vb cv ctg cfv vf cv crn ctg cfv cJ vb cv vf cv crn ctg fveq2 eqeq2d
      3anbi123d rcla4ev cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa wa vf cv crn ctb wcel vf cv crn ctg
      cfv cJ wceq simprl cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com
      cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf
      vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa
      vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab wral wa wa vf cv crn ctb wcel vf cv crn ctg
      cfv cJ wceq wa wa vf cv crn com cdom wbr vf cv crn cB wss cJ vf cv crn
      ctg cfv wceq vf cv crn vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab cdom wbr vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab com cdom wbr vf cv crn com cdom wbr cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv
      cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa wa vf cv crn
      ctb wcel vf cv crn ctg cfv cJ wceq wa wa vf cv crn vu cv vc cv wcel vv cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab
      com domtr cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr
      vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv
      c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wral wa wa vf cv crn ctb wcel vf cv crn ctg cfv cJ
      wceq wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab vf cv crn vf cv wfo vf cv crn vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cdom wbr cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc
      cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB
      vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd
      cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wral wa wa vf cv crn ctb wcel vf cv
      crn ctg cfv cJ wceq wa wa vf cv vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wfn vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab vf cv crn vf cv wfo vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv
      c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wral wa vf cv vu cv vc cv wcel vv cv vc cv wcel vu
      cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wfn cB ctb
      wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ
      wceq wa wa wa vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vf cv vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wfn vx cv c1st cfv
      vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab wral vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv ffn adantr ad2antlr vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab vf cv dffn4 sylib vu cv vc cv wcel vv cv vc cv wcel
      vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab vf cv crn
      vf cv vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab vc cv vc cv cxp vc cv vc cv vc visset vc
      visset xpex vr vs vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vu vv copab vc cv vc cv cxp vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      relopab vr cv vs cv cop vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss
      vw cv vv cv wss wa vw cB wrex w3a vu vv copab wcel vr cv vc cv wcel vs cv
      vc cv wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex w3a vr cv vs cv
      cop vc cv vc cv cxp wcel vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vr cv vc cv wcel vv cv vc cv wcel
      vr cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vr cv vc cv wcel vs cv
      vc cv wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex w3a vu vv vr cv
      vs cv vr visset vs visset vu cv vr cv wceq vu cv vc cv wcel vr cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex vr cv vw cv wss vw cv
      vv cv wss wa vw cB wrex vv cv vc cv wcel vu cv vr cv vc cv eleq1 vu cv vr
      cv wceq vu cv vw cv wss vw cv vv cv wss wa vr cv vw cv wss vw cv vv cv
      wss wa vw cB vu cv vr cv wceq vu cv vw cv wss vr cv vw cv wss vw cv vv cv
      wss vu cv vr cv vw cv sseq1 anbi1d rexbidv 3anbi13d vv cv vs cv wceq vv
      cv vc cv wcel vs cv vc cv wcel vr cv vw cv wss vw cv vv cv wss wa vw cB
      wrex vr cv vw cv wss vw cv vs cv wss wa vw cB wrex vr cv vc cv wcel vv cv
      vs cv vc cv eleq1 vv cv vs cv wceq vr cv vw cv wss vw cv vv cv wss wa vr
      cv vw cv wss vw cv vs cv wss wa vw cB vv cv vs cv wceq vw cv vv cv wss vw
      cv vs cv wss vr cv vw cv wss vv cv vs cv vw cv sseq2 anbi2d rexbidv
      3anbi23d opelopab vr cv vc cv wcel vs cv vc cv wcel vr cv vs cv cop vc cv
      vc cv cxp wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex vr cv vs cv
      vc cv vc cv opelxpi 3adant3 sylbi relssi ssexi fodom syl cB ctb wcel cJ
      c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa
      wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss
      wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv
      wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral
      wa wa vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq wa wa vc cv vc cv cxp
      com cdom wbr vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab com cdom wbr cB ctb wcel cJ c2ndc
      wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa
      vc cv vc cv cxp com cdom wbr vu cv vc cv wcel vv cv vc cv wcel vu cv vw
      cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv
      c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu
      cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB
      wrex w3a vu vv copab wral wa vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq
      wa vc cv com cdom wbr vc cv ctg cfv cJ wceq wa vc cv vc cv cxp com cdom
      wbr cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv
      vc cv cxp com cdom wbr vc cv ctg cfv cJ wceq vc cv com cdom wbr vc cv vc
      cv cxp com com cxp cdom wbr vc cv vc cv cxp com cdom wbr vc cv vc cv cxp
      com vc cv cxp cdom wbr com vc cv cxp com com cxp cdom wbr vc cv vc cv cxp
      com com cxp cdom wbr vc cv com cdom wbr vc cv vc cv cxp com vc cv cxp com
      com cxp domtr vc cv com vc cv omex vc visset xpdom1 vc cv com com omex
      omex xpdom2 sylanc vc cv vc cv cxp com com cxp cdom wbr com com cxp com
      cen wbr vc cv vc cv cxp com cdom wbr xpomen vc cv vc cv cxp com com cxp
      com domentr mpan2 syl adantr ad2antll ad2antrr vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab vc
      cv vc cv cxp cdom wbr vc cv vc cv cxp com cdom wbr vu cv vc cv wcel vv cv
      vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab
      com cdom wbr vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab cvv wcel vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab vc
      cv vc cv cxp wss vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vu vv copab vc cv vc cv cxp cdom wbr vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab vc cv vc cv cxp vc cv vc cv vc visset vc visset xpex vr
      vs vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex w3a vu vv copab vc cv vc cv cxp vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv relopab vr
      cv vs cv cop vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv copab wcel vr cv vc cv wcel vs cv vc cv
      wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex w3a vr cv vs cv cop vc
      cv vc cv cxp wcel vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv
      vv cv wss wa vw cB wrex w3a vr cv vc cv wcel vv cv vc cv wcel vr cv vw cv
      wss vw cv vv cv wss wa vw cB wrex w3a vr cv vc cv wcel vs cv vc cv wcel
      vr cv vw cv wss vw cv vs cv wss wa vw cB wrex w3a vu vv vr cv vs cv vr
      visset vs visset vu cv vr cv wceq vu cv vc cv wcel vr cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex vr cv vw cv wss vw cv vv cv wss
      wa vw cB wrex vv cv vc cv wcel vu cv vr cv vc cv eleq1 vu cv vr cv wceq
      vu cv vw cv wss vw cv vv cv wss wa vr cv vw cv wss vw cv vv cv wss wa vw
      cB vu cv vr cv wceq vu cv vw cv wss vr cv vw cv wss vw cv vv cv wss vu cv
      vr cv vw cv sseq1 anbi1d rexbidv 3anbi13d vv cv vs cv wceq vv cv vc cv
      wcel vs cv vc cv wcel vr cv vw cv wss vw cv vv cv wss wa vw cB wrex vr cv
      vw cv wss vw cv vs cv wss wa vw cB wrex vr cv vc cv wcel vv cv vs cv vc
      cv eleq1 vv cv vs cv wceq vr cv vw cv wss vw cv vv cv wss wa vr cv vw cv
      wss vw cv vs cv wss wa vw cB vv cv vs cv wceq vw cv vv cv wss vw cv vs cv
      wss vr cv vw cv wss vv cv vs cv vw cv sseq2 anbi2d rexbidv 3anbi23d
      opelopab vr cv vc cv wcel vs cv vc cv wcel vr cv vs cv cop vc cv vc cv
      cxp wcel vr cv vw cv wss vw cv vs cv wss wa vw cB wrex vr cv vs cv vc cv
      vc cv opelxpi 3adant3 sylbi relssi ssexi vr vs vu cv vc cv wcel vv cv vc
      cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab vc
      cv vc cv cxp vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv
      cv wss wa vw cB wrex w3a vu vv relopab vr cv vs cv cop vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab wcel vr cv vc cv wcel vs cv vc cv wcel vr cv vw cv wss vw cv vs cv
      wss wa vw cB wrex w3a vr cv vs cv cop vc cv vc cv cxp wcel vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vr cv vc cv wcel vv cv vc cv wcel vr cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vr cv vc cv wcel vs cv vc cv wcel vr cv vw cv wss vw cv vs cv
      wss wa vw cB wrex w3a vu vv vr cv vs cv vr visset vs visset vu cv vr cv
      wceq vu cv vc cv wcel vr cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa
      vw cB wrex vr cv vw cv wss vw cv vv cv wss wa vw cB wrex vv cv vc cv wcel
      vu cv vr cv vc cv eleq1 vu cv vr cv wceq vu cv vw cv wss vw cv vv cv wss
      wa vr cv vw cv wss vw cv vv cv wss wa vw cB vu cv vr cv wceq vu cv vw cv
      wss vr cv vw cv wss vw cv vv cv wss vu cv vr cv vw cv sseq1 anbi1d
      rexbidv 3anbi13d vv cv vs cv wceq vv cv vc cv wcel vs cv vc cv wcel vr cv
      vw cv wss vw cv vv cv wss wa vw cB wrex vr cv vw cv wss vw cv vs cv wss
      wa vw cB wrex vr cv vc cv wcel vv cv vs cv vc cv eleq1 vv cv vs cv wceq
      vr cv vw cv wss vw cv vv cv wss wa vr cv vw cv wss vw cv vs cv wss wa vw
      cB vv cv vs cv wceq vw cv vv cv wss vw cv vs cv wss vr cv vw cv wss vv cv
      vs cv vw cv sseq2 anbi2d rexbidv 3anbi23d opelopab vr cv vc cv wcel vs cv
      vc cv wcel vr cv vs cv cop vc cv vc cv cxp wcel vr cv vw cv wss vw cv vs
      cv wss wa vw cB wrex vr cv vs cv vc cv vc cv opelxpi 3adant3 sylbi relssi
      vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw
      cB wrex w3a vu vv copab vc cv vc cv cxp cvv ssdomg mp2 vu cv vc cv wcel
      vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv
      copab vc cv vc cv cxp com domtr mpan syl sylanc cB ctb wcel cJ c2ndc wcel
      wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv
      vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab cB vf cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf
      cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv
      vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab wral wa wa vf cv
      crn cB wss vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq wa vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab cB vf cv wf vf cv crn cB wss cB ctb wcel cJ c2ndc wcel wa vc
      cv ctb wcel vc cv com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vx cv c1st
      cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc
      cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex
      w3a vu vv copab wral vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw
      cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv frn ad2antrl adantr
      cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv com cdom wbr vc cv ctg
      cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw
      cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf cv wf vx cv c1st cfv vx
      cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv wss wa vx vu cv vc cv
      wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a
      vu vv copab wral wa wa vf cv crn ctb wcel vf cv crn ctg cfv cJ wceq wa wa
      vf cv crn ctg cfv cJ cB ctb wcel cJ c2ndc wcel wa vc cv ctb wcel vc cv
      com cdom wbr vc cv ctg cfv cJ wceq wa wa wa vu cv vc cv wcel vv cv vc cv
      wcel vu cv vw cv wss vw cv vv cv wss wa vw cB wrex w3a vu vv copab cB vf
      cv wf vx cv c1st cfv vx cv vf cv cfv wss vx cv vf cv cfv vx cv c2nd cfv
      wss wa vx vu cv vc cv wcel vv cv vc cv wcel vu cv vw cv wss vw cv vv cv
      wss wa vw cB wrex w3a vu vv copab wral wa wa vf cv crn ctb wcel vf cv crn
      ctg cfv cJ wceq simprr eqcomd 3jca sylanc mpdan ex 19.23adv mpd exp32
      r19.23adv mpd $.
      $( [30-Jan-2010] $) $( [28-Jan-2010] $)
  $}

  ${
    $d x y z $.
  $( Fineness is a relation. $)
  fnerel $p |- Rel Fne $=
    cfne wrel vx cv cuni vy cv cuni wceq vz cv vy cv vz cv cpw cin cuni wss vz
    vx cv wral wa vx vy copab wrel vx cv cuni vy cv cuni wceq vz cv vy cv vz cv
    cpw cin cuni wss vz vx cv wral wa vx vy relopab cfne vx cv cuni vy cv cuni
    wceq vz cv vy cv vz cv cpw cin cuni wss vz vx cv wral wa vx vy copab vx vy
    vz df-fne releqi mpbir $.
    $( [28-Sep-2009] $) $( [28-Sep-2009] $)
  $}

  ${
    $d r s t u w x y z A $. $d r s t u w x y z B $. $d t u w x y z C $. $d r s
    t u w X $. $d r s t u w Y $.
    isfne.1 $e |- X = U. A $.
    isfne.2 $e |- Y = U. B $.
    $( The predicate " ` B ` is finer than ` A ` ." This property is, in a
       sense, the opposite of refinement, as refinement requires every element
       to be a subset of an element of the original and fineness requires that
       every element of the original have a subset in the finer cover
       containing every point.  I do not know of a literature reference for
       this. $)
    isfne $p |- ( B e. C -> ( A Fne B <-> ( X = Y /\ A. x e. A x C_ U. ( B i^i
    ~P x ) ) ) ) $=
      cB cC wcel cA cB cfne wbr cX cY wceq vx cv cB vx cv cpw cin cuni wss vx
      cA wral wa cA cvv wcel cB cC wcel wa cA cB cfne wbr cB cC wcel cA cvv
      wcel cB cC wcel wa cA cB cfne wbr cA cvv wcel cB cC wcel cA cB cfne
      fnerel brrelexi anim1i ancoms cB cC wcel cX cY wceq cA cvv wcel cB cC
      wcel wa vx cv cB vx cv cpw cin cuni wss vx cA wral cB cC wcel cX cY wceq
      cA cuni cB cuni wceq cA cvv wcel cB cC wcel wa cB cC wcel cX cY wceq wa
      cX cY cA cuni cB cuni cB cC wcel cX cY wceq pm3.27 isfne.1 isfne.2
      3eqtr3g cB cC wcel cA cuni cB cuni wceq wa cA cvv wcel cB cC wcel cB cC
      wcel cA cuni cB cuni wceq wa cA cuni cvv wcel cA cvv wcel cB cC wcel cA
      cuni cB cuni wceq wa cA cuni cB cuni cvv cB cC wcel cA cuni cB cuni wceq
      pm3.27 cB cC wcel cB cuni cvv wcel cA cuni cB cuni wceq cB cC uniexg
      adantr eqeltrd cA uniexb sylibr cB cC wcel cA cuni cB cuni wceq pm3.26
      jca syldan adantrr vr cv cuni vs cv cuni wceq vx cv vs cv vx cv cpw cin
      cuni wss vx vr cv wral wa cX vs cv cuni wceq vx cv vs cv vx cv cpw cin
      cuni wss vx cA wral wa cX cY wceq vx cv cB vx cv cpw cin cuni wss vx cA
      wral wa vr vs cA cB cvv cC cfne vr cv cA wceq vr cv cuni vs cv cuni wceq
      cX vs cv cuni wceq vx cv vs cv vx cv cpw cin cuni wss vx vr cv wral vx cv
      vs cv vx cv cpw cin cuni wss vx cA wral vr cv cA wceq vr cv cuni cX vs cv
      cuni vr cv cA wceq vr cv cuni cA cuni cX vr cv cA unieq isfne.1 syl6eqr
      eqeq1d vx cv vs cv vx cv cpw cin cuni wss vx vr cv cA raleq1 anbi12d vs
      cv cB wceq cX vs cv cuni wceq cX cY wceq vx cv vs cv vx cv cpw cin cuni
      wss vx cA wral vx cv cB vx cv cpw cin cuni wss vx cA wral vs cv cB wceq
      vs cv cuni cY cX vs cv cB wceq vs cv cuni cB cuni cY vs cv cB unieq
      isfne.2 syl6eqr eqeq2d vs cv cB wceq vx cv vs cv vx cv cpw cin cuni wss
      vx cv cB vx cv cpw cin cuni wss vx cA vs cv cB wceq vs cv vx cv cpw cin
      cuni cB vx cv cpw cin cuni vx cv vs cv cB wceq vs cv vx cv cpw cin cB vx
      cv cpw cin vs cv cB vx cv cpw ineq1 unieqd sseq2d ralbidv anbi12d vr vs
      vx df-fne brabg pm5.21nd $.
      $( [28-Sep-2009] $) $( [28-Sep-2009] $)

    $( The predicate " ` B ` is finer than ` A ` ." $)
    isfne2 $p |- ( B e. C -> ( A Fne B <-> ( X = Y /\ A. x e. A A. y e. x E. z
    e. B ( y e. z /\ z C_ x ) ) ) ) $=
      cB cC wcel cA cB cfne wbr cX cY wceq vx cv cB vx cv cpw cin cuni wss vx
      cA wral wa cX cY wceq vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy
      vx cv wral vx cA wral wa vx cA cB cC cX cY isfne.1 isfne.2 isfne vx cv cB
      vx cv cpw cin cuni wss vx cA wral vy cv vz cv wcel vz cv vx cv wss wa vz
      cB wrex vy vx cv wral vx cA wral cX cY wceq vx cv cB vx cv cpw cin cuni
      wss vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cA vx
      cv cB vx cv cpw cin cuni wss vy cv cB vx cv cpw cin cuni wcel vy vx cv
      wral vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vy vx
      cv cB vx cv cpw cin cuni dfss3 vy cv cB vx cv cpw cin cuni wcel vy cv vz
      cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv vy cv vz cv wcel vz cv cB
      vx cv cpw cin wcel wa vz wex vz cv cB wcel vy cv vz cv wcel vz cv vx cv
      wss wa wa vz wex vy cv cB vx cv cpw cin cuni wcel vy cv vz cv wcel vz cv
      vx cv wss wa vz cB wrex vy cv vz cv wcel vz cv cB vx cv cpw cin wcel wa
      vz cv cB wcel vy cv vz cv wcel vz cv vx cv wss wa wa vz vy cv vz cv wcel
      vz cv cB vx cv cpw cin wcel wa vy cv vz cv wcel vz cv cB wcel vz cv vx cv
      wss wa wa vz cv cB wcel vy cv vz cv wcel vz cv vx cv wss wa wa vz cv cB
      vx cv cpw cin wcel vz cv cB wcel vz cv vx cv wss wa vy cv vz cv wcel vz
      cv cB vx cv cpw cin wcel vz cv cB wcel vz cv vx cv cpw wcel wa vz cv cB
      wcel vz cv vx cv wss wa vz cv cB vx cv cpw elin vz cv vx cv cpw wcel vz
      cv vx cv wss vz cv cB wcel vz cv vx cv vz visset elpw anbi2i bitri anbi2i
      vy cv vz cv wcel vz cv cB wcel vz cv vx cv wss an12 bitri exbii vz vy cv
      cB vx cv cpw cin eluni vy cv vz cv wcel vz cv vx cv wss wa vz cB df-rex
      3bitr4i ralbii bitri ralbii anbi2i syl6bb $.
      $( [28-Sep-2009] $) $( [28-Sep-2009] $)

    $( The predicate " ` B ` is finer than ` A ` ." $)
    isfne3 $p |- ( B e. C -> ( A Fne B <-> ( X = Y /\ A. x e. A E. y ( y C_ B
    /\ x = U. y ) ) ) ) $=
      cB cC wcel cA cB cfne wbr cX cY wceq vz cv vw cv wcel vw cv vx cv wss wa
      vw cB wrex vz vx cv wral vx cA wral wa cX cY wceq vy cv cB wss vx cv vy
      cv cuni wceq wa vy wex vx cA wral wa vx vz vw cA cB cC cX cY isfne.1
      isfne.2 isfne2 cB cC wcel vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex
      vz vx cv wral vx cA wral vy cv cB wss vx cv vy cv cuni wceq wa vy wex vx
      cA wral cX cY wceq cB cC wcel vz cv vw cv wcel vw cv vx cv wss wa vw cB
      wrex vz vx cv wral vy cv cB wss vx cv vy cv cuni wceq wa vy wex vx cA cB
      cC wcel vx cv cA wcel wa vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex
      vz vx cv wral vy cv cB wss vx cv vy cv cuni wceq wa vy wex cB cC wcel vx
      cv cA wcel wa vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex vz vx cv
      wral vy cv cB wss vx cv vy cv cuni wceq wa vy wex vw cv vx cv wss vw cB
      crab cvv wcel vw cv vx cv wss vw cB crab cB wss vx cv vw cv vx cv wss vw
      cB crab cuni wceq wa vy cv cB wss vx cv vy cv cuni wceq wa vy wex cB cC
      wcel vx cv cA wcel wa vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex vz
      vx cv wral wa vy cv cB wss vx cv vy cv cuni wceq wa vw cv vx cv wss vw cB
      crab cB wss vx cv vw cv vx cv wss vw cB crab cuni wceq wa vy vw cv vx cv
      wss vw cB crab cvv vy cv vw cv vx cv wss vw cB crab wceq vy cv cB wss vw
      cv vx cv wss vw cB crab cB wss vx cv vy cv cuni wceq vx cv vw cv vx cv
      wss vw cB crab cuni wceq vy cv vw cv vx cv wss vw cB crab cB sseq1 vy cv
      vw cv vx cv wss vw cB crab wceq vy cv cuni vw cv vx cv wss vw cB crab
      cuni vx cv vy cv vw cv vx cv wss vw cB crab unieq eqeq2d anbi12d cla4egv
      cB cC wcel vw cv vx cv wss vw cB crab cvv wcel vx cv cA wcel vz cv vw cv
      wcel vw cv vx cv wss wa vw cB wrex vz vx cv wral vw cv vx cv wss vw cB cC
      rabexg ad2antrr cB cC wcel vx cv cA wcel wa vz cv vw cv wcel vw cv vx cv
      wss wa vw cB wrex vz vx cv wral wa vx cv vw cv vx cv wss vw cB crab cuni
      wceq vw cv vx cv wss vw cB crab cB wss cB cC wcel vx cv cA wcel wa vz cv
      vw cv wcel vw cv vx cv wss wa vw cB wrex vz vx cv wral wa vt vx cv vw cv
      vx cv wss vw cB crab cuni cB cC wcel vx cv cA wcel wa vz cv vw cv wcel vw
      cv vx cv wss wa vw cB wrex vz vx cv wral wa vt cv vx cv wcel vt cv vu cv
      wcel vu cv cB wcel vu cv vx cv wss wa wa vu wex vt cv vw cv vx cv wss vw
      cB crab cuni wcel cB cC wcel vx cv cA wcel wa vz cv vw cv wcel vw cv vx
      cv wss wa vw cB wrex vz vx cv wral wa vt cv vx cv wcel vt cv vu cv wcel
      vu cv cB wcel vu cv vx cv wss wa wa vu wex vz cv vw cv wcel vw cv vx cv
      wss wa vw cB wrex vz vx cv wral vt cv vx cv wcel vt cv vw cv wcel vw cv
      vx cv wss wa vw cB wrex cB cC wcel vx cv cA wcel wa vt cv vu cv wcel vu
      cv cB wcel vu cv vx cv wss wa wa vu wex vz cv vw cv wcel vw cv vx cv wss
      wa vw cB wrex vt cv vw cv wcel vw cv vx cv wss wa vw cB wrex vz vt cv vx
      cv vz cv vt cv wceq vz cv vw cv wcel vw cv vx cv wss wa vt cv vw cv wcel
      vw cv vx cv wss wa vw cB vz cv vt cv wceq vz cv vw cv wcel vt cv vw cv
      wcel vw cv vx cv wss vz cv vt cv vw cv eleq1 anbi1d rexbidv rcla4cv cB cC
      wcel vx cv cA wcel wa vt cv vw cv wcel vw cv vx cv wss wa vt cv vu cv
      wcel vu cv cB wcel vu cv vx cv wss wa wa vu wex vw cB cB cC wcel vx cv cA
      wcel wa vw cv cB wcel vt cv vw cv wcel vw cv vx cv wss wa vt cv vu cv
      wcel vu cv cB wcel vu cv vx cv wss wa wa vu wex vt cv vw cv wcel vw cv cB
      wcel vw cv vx cv wss vt cv vu cv wcel vu cv cB wcel vu cv vx cv wss wa wa
      vu wex cB cC wcel vx cv cA wcel wa vw cv cB wcel wa vt cv vw cv wcel vw
      cv vx cv wss wa wa cB cC wcel vx cv cA wcel wa vw cv cB wcel wa vt cv vw
      cv wcel vw cv vx cv wss simprl cB cC wcel vx cv cA wcel wa vw cv cB wcel
      vt cv vw cv wcel vw cv vx cv wss wa simplr cB cC wcel vx cv cA wcel wa vw
      cv cB wcel wa vt cv vw cv wcel vw cv vx cv wss simprr vt cv vu cv wcel vu
      cv cB wcel vu cv vx cv wss wa wa vt cv vw cv wcel vw cv cB wcel vw cv vx
      cv wss wa wa vu vw cv vw visset vu cv vw cv wceq vt cv vu cv wcel vt cv
      vw cv wcel vu cv cB wcel vu cv vx cv wss wa vw cv cB wcel vw cv vx cv wss
      wa vu cv vw cv vt cv eleq2 vu cv vw cv wceq vu cv cB wcel vw cv cB wcel
      vu cv vx cv wss vw cv vx cv wss vu cv vw cv cB eleq1 vu cv vw cv vx cv
      sseq1 anbi12d anbi12d cla4ev sylan32c exp31 r19.23adv sylan9r vt cv vu cv
      wcel vu cv cB wcel vu cv vx cv wss wa wa vt cv vx cv wcel vu vt cv vu cv
      wcel vu cv vx cv wss vt cv vx cv wcel vu cv cB wcel vu cv vx cv wss vt cv
      vu cv wcel vt cv vx cv wcel vu cv vx cv vt cv ssel2 ancoms adantrl
      19.23aiv impbid1 vt cv vw cv vx cv wss vw cB crab cuni wcel vt cv vu cv
      wcel vu cv vw cv vx cv wss vw cB crab wcel wa vu wex vt cv vu cv wcel vu
      cv cB wcel vu cv vx cv wss wa wa vu wex vu vt cv vw cv vx cv wss vw cB
      crab eluni vt cv vu cv wcel vu cv vw cv vx cv wss vw cB crab wcel wa vt
      cv vu cv wcel vu cv cB wcel vu cv vx cv wss wa wa vu vu cv vw cv vx cv
      wss vw cB crab wcel vu cv cB wcel vu cv vx cv wss wa vt cv vu cv wcel vw
      cv vx cv wss vu cv vx cv wss vw vu cv cB vw cv vu cv vx cv sseq1 elrab
      anbi2i exbii bitr2i syl6bb eqrdv vw cv vx cv wss vw cB ssrab2 jctil sylc
      ex cB cC wcel vx cv cA wcel wa vy cv cB wss vx cv vy cv cuni wceq wa vz
      cv vw cv wcel vw cv vx cv wss wa vw cB wrex vz vx cv wral vy cB cC wcel
      vx cv cA wcel wa vy cv cB wss vx cv vy cv cuni wceq wa vz cv vw cv wcel
      vw cv vx cv wss wa vw cB wrex vz vx cv vy cv cB wss vx cv vy cv cuni wceq
      wa vz cv vx cv wcel vz cv vw cv wcel vw cv vx cv wss wa vw cB wrex wi wi
      cB cC wcel vx cv cA wcel wa vy cv cB wss vx cv vy cv cuni wceq wa vz cv
      vx cv wcel vz cv vy cv cuni wcel vz cv vw cv wcel vw cv vx cv wss wa vw
      cB wrex vx cv vy cv cuni wceq vz cv vx cv wcel vz cv vy cv cuni wcel wb
      vy cv cB wss vx cv vy cv cuni vz cv eleq2 adantl vy cv cB wss vx cv vy cv
      cuni wceq wa vz cv vw cv wcel vw cv vy cv wcel wa vw wex vw cv cB wcel vz
      cv vw cv wcel vw cv vx cv wss wa wa vw wex vz cv vy cv cuni wcel vz cv vw
      cv wcel vw cv vx cv wss wa vw cB wrex vy cv cB wss vx cv vy cv cuni wceq
      wa vz cv vw cv wcel vw cv vy cv wcel wa vw cv cB wcel vz cv vw cv wcel vw
      cv vx cv wss wa wa vw vy cv cB wss vx cv vy cv cuni wceq wa vz cv vw cv
      wcel vw cv vy cv wcel wa vw cv cB wcel vz cv vw cv wcel vw cv vx cv wss
      wa wa vy cv cB wss vx cv vy cv cuni wceq wa vz cv vw cv wcel vw cv vy cv
      wcel wa wa vw cv cB wcel vz cv vw cv wcel vw cv vx cv wss vy cv cB wss vw
      cv vy cv wcel vw cv cB wcel vx cv vy cv cuni wceq vz cv vw cv wcel vy cv
      cB vw cv ssel2 ad2ant2rl vy cv cB wss vx cv vy cv cuni wceq wa vz cv vw
      cv wcel vw cv vy cv wcel simprl vy cv cB wss vx cv vy cv cuni wceq wa vz
      cv vw cv wcel vw cv vy cv wcel wa wa vw cv vy cv cuni vx cv vw cv vy cv
      wcel vw cv vy cv cuni wss vy cv cB wss vx cv vy cv cuni wceq wa vz cv vw
      cv wcel vw cv vy cv elssuni ad2antll vy cv cB wss vx cv vy cv cuni wceq
      vz cv vw cv wcel vw cv vy cv wcel wa simplr sseqtr4d jca32 ex 19.22dv vw
      vz cv vy cv eluni vz cv vw cv wcel vw cv vx cv wss wa vw cB df-rex
      3imtr4g sylbid a1i r19.21adv 19.23adv impbid ralbidva anbi2d bitrd $.
      $( [11-Oct-2009] $) $( [11-Oct-2009] $)
  $}

  ${
    $d x A $. $d x B $. $d x C $. $d x X $. $d x Y $.
    fnebas.1 $e |- X = U. A $.
    fnebas.2 $e |- Y = U. B $.
    $( A finer cover covers the same set as the original. $)
    fnebas $p |- ( ( B e. C /\ A Fne B ) -> X = Y ) $=
      cB cC wcel cA cB cfne wbr cX cY wceq vx cv cB vx cv cpw cin cuni wss vx
      cA wral vx cA cB cC cX cY fnebas.1 fnebas.2 isfne pm3.26bda $.
      $( [28-Sep-2009] $) $( [28-Sep-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $. $d x y z P $. $d x y z S $.
  $( If ` B ` is finer than ` A ` and ` S ` is an element of ` A ` , every
     point in ` S ` is an element of a subset of ` S ` which is in ` B ` . $)
  fnessex $p |- ( ( ( B e. C /\ A Fne B /\ S e. A ) /\ P e. S ) -> E. x e. B (
  P e. x /\ x C_ S ) ) $=
    cB cC wcel cA cB cfne wbr cS cA wcel w3a vz cv vx cv wcel vx cv cS wss wa
    vx cB wrex vz cS wral cP cS wcel cP vx cv wcel vx cv cS wss wa vx cB wrex
    cB cC wcel cA cB cfne wbr cS cA wcel vz cv vx cv wcel vx cv cS wss wa vx cB
    wrex vz cS wral cS cA wcel vz cv vx cv wcel vx cv vy cv wss wa vx cB wrex
    vz vy cv wral vy cA wral vz cv vx cv wcel vx cv cS wss wa vx cB wrex vz cS
    wral cB cC wcel cA cB cfne wbr wa vz cv vx cv wcel vx cv vy cv wss wa vx cB
    wrex vz vy cv wral vz cv vx cv wcel vx cv cS wss wa vx cB wrex vz cS wral
    vy cS cA vz cv vx cv wcel vx cv vy cv wss wa vx cB wrex vz cv vx cv wcel vx
    cv cS wss wa vx cB wrex vz vy cv cS vy cv cS wceq vz cv vx cv wcel vx cv vy
    cv wss wa vz cv vx cv wcel vx cv cS wss wa vx cB vy cv cS wceq vx cv vy cv
    wss vx cv cS wss vz cv vx cv wcel vy cv cS vx cv sseq2 anbi2d rexbidv
    raleqd rcla4v cB cC wcel cA cB cfne wbr cA cuni cB cuni wceq vz cv vx cv
    wcel vx cv vy cv wss wa vx cB wrex vz vy cv wral vy cA wral vy vz vx cA cB
    cC cA cuni cB cuni cA cuni eqid cB cuni eqid isfne2 pm3.27bda syl5com
    3impia vz cv vx cv wcel vx cv cS wss wa vx cB wrex cP vx cv wcel vx cv cS
    wss wa vx cB wrex vz cP cS vz cv cP wceq vz cv vx cv wcel vx cv cS wss wa
    cP vx cv wcel vx cv cS wss wa vx cB vz cv cP wceq vz cv vx cv wcel cP vx cv
    wcel vx cv cS wss vz cv cP vx cv eleq1 anbi1d rexbidv rcla4v mpan9 $.
    $( [28-Sep-2009] $) $( [28-Sep-2009] $)
  $}

  ${
    $d x y A $. $d x y B $. $d x y C $. $d x y S $.
    $( If ` B ` is finer than ` A ` , every element of ` A ` is a union of
       elements of ` B ` . $)
    fneuni $p |- ( ( B e. C /\ A Fne B /\ S e. A ) -> E. x ( x C_ B /\ S = U. x
    ) ) $=
      cB cC wcel cA cB cfne wbr cS cA wcel vx cv cB wss cS vx cv cuni wceq wa
      vx wex cB cC wcel cA cB cfne wbr wa vx cv cB wss vy cv vx cv cuni wceq wa
      vx wex vy cA wral cS cA wcel vx cv cB wss cS vx cv cuni wceq wa vx wex wi
      cB cC wcel cA cB cfne wbr cA cuni cB cuni wceq vx cv cB wss vy cv vx cv
      cuni wceq wa vx wex vy cA wral vy vx cA cB cC cA cuni cB cuni cA cuni
      eqid cB cuni eqid isfne3 pm3.27bda vx cv cB wss vy cv vx cv cuni wceq wa
      vx wex vx cv cB wss cS vx cv cuni wceq wa vx wex vy cS cA vy cv cS wceq
      vx cv cB wss vy cv vx cv cuni wceq wa vx cv cB wss cS vx cv cuni wceq wa
      vx vy cv cS wceq vy cv vx cv cuni wceq cS vx cv cuni wceq vx cv cB wss vy
      cv cS vx cv cuni eqeq1 anbi2d exbidv rcla4cv syl 3impia $.
      $( [11-Oct-2009] $) $( [11-Oct-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d y z C $. $d x y z P $.
    $( If a cover is finer than another, every point can be approached more
       closely by intersections. $)
    fneint $p |- ( ( B e. C /\ A Fne B ) -> |^| { x e. B | P e. x }
    C_ |^| { x e. A | P e. x } ) $=
      cB cC wcel cA cB cfne wbr wa cP vx cv wcel vx cB crab cint vy cv wss vy
      cP vx cv wcel vx cA crab wral cP vx cv wcel vx cB crab cint cP vx cv wcel
      vx cA crab cint wss cB cC wcel cA cB cfne wbr wa cP vx cv wcel vx cB crab
      cint vy cv wss vy cP vx cv wcel vx cA crab cB cC wcel cA cB cfne wbr wa
      vy cv cA wcel cP vy cv wcel wa cP vx cv wcel vx cB crab cint vy cv wss vy
      cv cP vx cv wcel vx cA crab wcel cB cC wcel cA cB cfne wbr wa vy cv cA
      wcel cP vy cv wcel wa cP vx cv wcel vx cB crab cint vy cv wss cB cC wcel
      cA cB cfne wbr wa vy cv cA wcel cP vy cv wcel wa wa cP vz cv wcel vz cv
      vy cv wss wa vz cB wrex cP vx cv wcel vx cB crab cint vy cv wss cB cC
      wcel cA cB cfne wbr vy cv cA wcel w3a cP vy cv wcel cP vz cv wcel vz cv
      vy cv wss wa vz cB wrex cB cC wcel cA cB cfne wbr wa vy cv cA wcel cP vy
      cv wcel wa wa vz cA cB cC cP vy cv fnessex cB cC wcel cA cB cfne wbr wa
      vy cv cA wcel cB cC wcel cA cB cfne wbr vy cv cA wcel w3a cP vy cv wcel
      cB cC wcel cA cB cfne wbr vy cv cA wcel cB cC wcel cA cB cfne wbr vy cv
      cA wcel w3a cB cC wcel cA cB cfne wbr vy cv cA wcel w3a id 3expa adantrr
      cB cC wcel cA cB cfne wbr wa vy cv cA wcel cP vy cv wcel simprr sylanc cP
      vz cv wcel vz cv vy cv wss wa cP vx cv wcel vx cB crab cint vy cv wss vz
      cB vz cv cB wcel cP vz cv wcel vz cv vy cv wss cP vx cv wcel vx cB crab
      cint vy cv wss cP vx cv wcel vx cB crab cint vz cv wss vz cv vy cv wss cP
      vx cv wcel vx cB crab cint vy cv wss vz cv cB wcel cP vz cv wcel wa cP vx
      cv wcel vx cB crab cint vz cv vy cv sstr vz cv cB wcel cP vz cv wcel wa
      vz cv cP vx cv wcel vx cB crab wcel cP vx cv wcel vx cB crab cint vz cv
      wss cP vx cv wcel cP vz cv wcel vx vz cv cB vx cv vz cv cP eleq2 elrab vz
      cv cP vx cv wcel vx cB crab intss1 sylbir sylan expl r19.23aiv syl ex cP
      vx cv wcel cP vy cv wcel vx vy cv cA vx cv vy cv cP eleq2 elrab syl5ib
      r19.21aiv vy cP vx cv wcel vx cB crab cint cP vx cv wcel vx cA crab ssint
      sylibr $.
      $( [11-Oct-2009] $) $( [11-Oct-2009] $)
  $}

  ${
    $d w x y z $.
    $( Refinement is a relation. $)
    refrel $p |- Rel Ref $=
      cref wrel vx cv cuni vy cv cuni wceq vz cv vw cv wss vw vx cv wrex vz vy
      cv wral wa vx vy copab wrel vx cv cuni vy cv cuni wceq vz cv vw cv wss vw
      vx cv wrex vz vy cv wral wa vx vy relopab cref vx cv cuni vy cv cuni wceq
      vz cv vw cv wss vw vx cv wrex vz vy cv wral wa vx vy copab vx vy vz vw
      df-ref releqi mpbir $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d a b x y A $. $d a b x B $. $d a b C $. $d a b X $. $d a b Y $.
    isref.1 $e |- X = U. A $.
    isref.2 $e |- Y = U. B $.
    $( The property of being a refinement of a cover. Dr. Nyikos once commented
       in class that the term "refinement" is actually misleading and that
       people are inclined to confuse it with the notion defined in ~ isfne .
       On the other hand, the two concepts do seem to have a dual
       relationship. $)
    isref $p |- ( B e. C -> ( A Ref B <-> ( X = Y /\ A. x e. B E. y e. A x C_ y
    ) ) ) $=
      cB cC wcel cA cB cref wbr cX cY wceq vx cv vy cv wss vy cA wrex vx cB
      wral wa cA cvv wcel cB cC wcel wa cB cC wcel cA cB cref wbr wa cA cvv
      wcel cB cC wcel cA cB cref wbr cA cvv wcel cB cC wcel cA cB cref refrel
      brrelexi adantl cB cC wcel cA cB cref wbr pm3.26 jca cB cC wcel cX cY
      wceq vx cv vy cv wss vy cA wrex vx cB wral wa wa cA cvv wcel cB cC wcel
      cB cC wcel cX cY wceq cA cvv wcel vx cv vy cv wss vy cA wrex vx cB wral
      cB cC wcel cX cY wceq wa cA cuni cvv wcel cA cvv wcel cB cC wcel cX cY
      wceq wa cA cuni cB cuni cvv cB cC wcel cX cY wceq wa cX cY cA cuni cB
      cuni cB cC wcel cX cY wceq pm3.27 isref.1 isref.2 3eqtr3g cB cC wcel cB
      cuni cvv wcel cX cY wceq cB cC uniexg adantr eqeltrd cA uniexb sylibr
      adantrr cB cC wcel cX cY wceq vx cv vy cv wss vy cA wrex vx cB wral wa
      pm3.26 jca va cv cuni vb cv cuni wceq vx cv vy cv wss vy va cv wrex vx vb
      cv wral wa cX vb cv cuni wceq vx cv vy cv wss vy cA wrex vx vb cv wral wa
      cX cY wceq vx cv vy cv wss vy cA wrex vx cB wral wa va vb cA cB cvv cC
      cref va cv cA wceq va cv cuni vb cv cuni wceq cX vb cv cuni wceq vx cv vy
      cv wss vy va cv wrex vx vb cv wral vx cv vy cv wss vy cA wrex vx vb cv
      wral va cv cA wceq va cv cuni cX vb cv cuni va cv cA wceq va cv cuni cA
      cuni cX va cv cA unieq isref.1 syl6eqr eqeq1d va cv cA wceq vx cv vy cv
      wss vy va cv wrex vx cv vy cv wss vy cA wrex vx vb cv vx cv vy cv wss vy
      va cv cA rexeq1 ralbidv anbi12d vb cv cB wceq cX vb cv cuni wceq cX cY
      wceq vx cv vy cv wss vy cA wrex vx vb cv wral vx cv vy cv wss vy cA wrex
      vx cB wral vb cv cB wceq vb cv cuni cY cX vb cv cB wceq vb cv cuni cB
      cuni cY vb cv cB unieq isref.2 syl6eqr eqeq2d vx cv vy cv wss vy cA wrex
      vx vb cv cB raleq1 anbi12d va vb vx vy df-ref brabg pm5.21nd $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d x y A $. $d x y B $. $d x y X $. $d x y Y $.
    refbas.1 $e |- X = U. A $.
    refbas.2 $e |- Y = U. B $.
    $( A refinement covers the same set. $)
    refbas $p |- ( ( B e. C /\ A Ref B ) -> X = Y ) $=
      cB cC wcel cA cB cref wbr cX cY wceq vx cv vy cv wss vy cA wrex vx cB
      wral vx vy cA cB cC cX cY refbas.1 refbas.2 isref pm3.26bda $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d x y A $. $d y B $. $d y C $. $d x y S $.
    $( Every set in a refinement has a superset in the original cover. $)
    refssex $p |- ( ( B e. C /\ A Ref B /\ S e. B ) -> E. x e. A S C_ x ) $=
      cB cC wcel cA cB cref wbr cS cB wcel cS vx cv wss vx cA wrex cB cC wcel
      cA cB cref wbr wa vy cv vx cv wss vx cA wrex vy cB wral cS cB wcel cS vx
      cv wss vx cA wrex wi cB cC wcel cA cB cref wbr cA cuni cB cuni wceq vy cv
      vx cv wss vx cA wrex vy cB wral vy vx cA cB cC cA cuni cB cuni cA cuni
      eqid cB cuni eqid isref pm3.27bda vy cv vx cv wss vx cA wrex cS vx cv wss
      vx cA wrex vy cS cB vy cv cS wceq vy cv vx cv wss cS vx cv wss vx cA vy
      cv cS vx cv sseq1 rexbidv rcla4cv syl 3impia $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $.
    fness.1 $e |- X = U. A $.
    fness.2 $e |- Y = U. B $.
    $( A cover is finer than its subcovers. $)
    fness $p |- ( ( B e. C /\ A C_ B /\ X = Y ) -> A Fne B ) $=
      cB cC wcel cA cB wss cX cY wceq w3a cA cB cfne wbr cX cY wceq vy cv vz cv
      wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral vx cA wral wa cB cC wcel
      cA cB wss cX cY wceq w3a cX cY wceq vy cv vz cv wcel vz cv vx cv wss wa
      vz cB wrex vy vx cv wral vx cA wral cB cC wcel cA cB wss cX cY wceq
      3simp3 cA cB wss cB cC wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB
      wrex vy vx cv wral vx cA wral cX cY wceq cA cB wss vy cv vz cv wcel vz cv
      vx cv wss wa vz cB wrex vx vy cA vx cv cA cB wss vx cv cA wcel vy cv vx
      cv wcel vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vx cv cB wcel vy
      cv vx cv wcel vx cv vx cv wss wa vy cv vz cv wcel vz cv vx cv wss wa vz
      cB wrex cA cB wss vx cv cA wcel vy cv vx cv wcel w3a vy cv vz cv wcel vz
      cv vx cv wss wa vy cv vx cv wcel vx cv vx cv wss wa vz vx cv cB vz cv vx
      cv wceq vy cv vz cv wcel vy cv vx cv wcel vz cv vx cv wss vx cv vx cv wss
      vz cv vx cv vy cv eleq2 vz cv vx cv vx cv sseq1 anbi12d rcla4ev cA cB wss
      vx cv cA wcel vx cv cB wcel vy cv vx cv wcel cA cB vx cv ssel2 3adant3 cA
      cB wss vx cv cA wcel vy cv vx cv wcel w3a vy cv vx cv wcel vx cv vx cv
      wss cA cB wss vx cv cA wcel vy cv vx cv wcel 3simp3 vx cv ssid jctir
      sylanc 3expib r19.21aivv 3ad2ant2 jca cB cC wcel cA cB wss cA cB cfne wbr
      cX cY wceq vy cv vz cv wcel vz cv vx cv wss wa vz cB wrex vy vx cv wral
      vx cA wral wa wb cX cY wceq vx vy vz cA cB cC cX cY fness.1 fness.2
      isfne2 3ad2ant1 mpbird $.
      $( [11-Oct-2009] $) $( [11-Oct-2009] $)
  $}

  ${
    $d x y A $. $d x y B $. $d x y C $. $d x y X $. $d x y Y $.
    ssref.1 $e |- X = U. A $.
    ssref.2 $e |- Y = U. B $.
    $( A subcover is a refinement of the original cover. $)
    ssref $p |- ( ( A e. C /\ A C_ B /\ X = Y ) -> B Ref A ) $=
      cA cC wcel cA cB wss cX cY wceq w3a cB cA cref wbr cY cX wceq vx cv vy cv
      wss vy cB wrex vx cA wral wa cA cC wcel cA cB wss cX cY wceq w3a cY cX
      wceq vx cv vy cv wss vy cB wrex vx cA wral cX cY wceq cA cC wcel cY cX
      wceq cA cB wss cX cY wceq cY cX wceq cX cY eqcom biimpi 3ad2ant3 cA cC
      wcel cA cB wss cX cY wceq w3a vx cv vy cv wss vy cB wrex vx cA vx cv cB
      wcel vx cv vx cv wss vx cv vy cv wss vy cB wrex cA cC wcel cA cB wss cX
      cY wceq w3a vx cv cA wcel wa vx cv vy cv wss vx cv vx cv wss vy vx cv cB
      vy cv vx cv vx cv sseq2 rcla4ev cA cB wss cA cC wcel vx cv cA wcel vx cv
      cB wcel cX cY wceq cA cB vx cv ssel2 3ad2antl2 vx cv vx cv wss cA cC wcel
      cA cB wss cX cY wceq w3a vx cv cA wcel wa vx cv ssid a1i sylanc
      r19.21aiva jca cA cC wcel cA cB wss cB cA cref wbr cY cX wceq vx cv vy cv
      wss vy cB wrex vx cA wral wa wb cX cY wceq vx vy cB cA cC cY cX ssref.2
      ssref.1 isref 3ad2ant1 mpbird $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d x y z A $. $d x y z B $.
    $( Reflexivity of the fineness relation. $)
    fneref $p |- ( A e. B -> A Fne A ) $=
      cA cB wcel cA cA cfne wbr cA cuni cA cuni wceq vy cv vz cv wcel vz cv vx
      cv wss wa vz cA wrex vy vx cv wral vx cA wral wa cA cuni cA cuni wceq vy
      cv vz cv wcel vz cv vx cv wss wa vz cA wrex vy vx cv wral vx cA wral cA
      cuni eqid vy cv vz cv wcel vz cv vx cv wss wa vz cA wrex vx vy cA vx cv
      vx cv cA wcel vy cv vx cv wcel vx cv vx cv wss vy cv vz cv wcel vz cv vx
      cv wss wa vz cA wrex vx cv ssid vy cv vz cv wcel vz cv vx cv wss wa vy cv
      vx cv wcel vx cv vx cv wss wa vz vx cv cA vz cv vx cv wceq vy cv vz cv
      wcel vy cv vx cv wcel vz cv vx cv wss vx cv vx cv wss vz cv vx cv vy cv
      eleq2 vz cv vx cv vx cv sseq1 anbi12d rcla4ev mpanr2 rgen2 pm3.2i vx vy
      vz cA cA cB cA cuni cA cuni cA cuni eqid cA cuni eqid isfne2 mpbiri $.
      $( [12-Oct-2009] $) $( [12-Oct-2009] $)
  $}

  ${
    $d x y A $. $d x y B $.
    $( Reflexivity of refinement. $)
    refref $p |- ( A e. B -> A Ref A ) $=
      cA cB wcel cA cA cref wbr cA cuni cA cuni wceq vx cv vy cv wss vy cA wrex
      vx cA wral wa cA cuni cA cuni wceq vx cv vy cv wss vy cA wrex vx cA wral
      cA cuni eqid vx cv vy cv wss vy cA wrex vx cA vx cv cA wcel vx cv vx cv
      wss vx cv vy cv wss vy cA wrex vx cv ssid vx cv vy cv wss vx cv vx cv wss
      vy vx cv cA vy cv vx cv vx cv sseq2 rcla4ev mpan2 rgen pm3.2i vx vy cA cA
      cB cA cuni cA cuni cA cuni eqid cA cuni eqid isref mpbiri $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d u v w x A $. $d u v w x B $. $d u v w x C $. $d u v w x D $.
    $( Transitivity of the fineness relation. $)
    fnetr $p |- ( ( C e. D /\ A Fne B /\ B Fne C ) -> A Fne C ) $=
      cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a cA cC cfne wbr cA cuni cC
      cuni wceq vx cv vv cv wcel vv cv vu cv wss wa vv cC wrex vx vu cv wral vu
      cA wral wa cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a cA cuni cC cuni
      wceq vx cv vv cv wcel vv cv vu cv wss wa vv cC wrex vx vu cv wral vu cA
      wral cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a cA cuni cB cuni cC cuni
      cB cvv wcel cA cB cfne wbr cA cuni cB cuni wceq cC cD wcel cA cB cfne wbr
      cB cC cfne wbr w3a cA cB cvv cA cuni cB cuni cA cuni eqid cB cuni eqid
      fnebas cB cC cfne wbr cC cD wcel cB cvv wcel cA cB cfne wbr cB cC cfne
      fnerel brrelexi 3ad2ant3 cC cD wcel cA cB cfne wbr cB cC cfne wbr 3simp2
      sylanc cC cD wcel cB cC cfne wbr cB cuni cC cuni wceq cA cB cfne wbr cB
      cC cD cB cuni cC cuni cB cuni eqid cC cuni eqid fnebas 3adant2 eqtrd cC
      cD wcel cA cB cfne wbr cB cC cfne wbr w3a vx cv vv cv wcel vv cv vu cv
      wss wa vv cC wrex vu vx cA vu cv cC cD wcel cA cB cfne wbr cB cC cfne wbr
      w3a vu cv cA wcel vx cv vu cv wcel wa vx cv vv cv wcel vv cv vu cv wss wa
      vv cC wrex cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx
      cv vu cv wcel wa wa vx cv vw cv wcel vw cv vu cv wss wa vw cB wrex vx cv
      vv cv wcel vv cv vu cv wss wa vv cC wrex cB cvv wcel cA cB cfne wbr vu cv
      cA wcel w3a vx cv vu cv wcel vx cv vw cv wcel vw cv vu cv wss wa vw cB
      wrex cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx cv vu
      cv wcel wa wa vw cA cB cvv vx cv vu cv fnessex cC cD wcel cA cB cfne wbr
      cB cC cfne wbr w3a vu cv cA wcel vx cv vu cv wcel wa wa cB cvv wcel cA cB
      cfne wbr vu cv cA wcel cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a cB
      cvv wcel vu cv cA wcel vx cv vu cv wcel wa cB cC cfne wbr cC cD wcel cB
      cvv wcel cA cB cfne wbr cB cC cfne fnerel brrelexi 3ad2ant3 adantr cC cD
      wcel cA cB cfne wbr cB cC cfne wbr w3a cA cB cfne wbr vu cv cA wcel vx cv
      vu cv wcel wa cC cD wcel cA cB cfne wbr cB cC cfne wbr 3simp2 adantr cC
      cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx cv vu cv wcel
      simprl 3jca cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx
      cv vu cv wcel simprr sylanc cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a
      vu cv cA wcel vx cv vu cv wcel wa wa vx cv vw cv wcel vw cv vu cv wss wa
      vx cv vv cv wcel vv cv vu cv wss wa vv cC wrex vw cB cC cD wcel cA cB
      cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx cv vu cv wcel wa wa vw cv cB
      wcel vx cv vw cv wcel vw cv vu cv wss wa vx cv vv cv wcel vv cv vu cv wss
      wa vv cC wrex cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel
      vx cv vu cv wcel wa wa vw cv cB wcel vx cv vw cv wcel vw cv vu cv wss wa
      wa wa vx cv vv cv wcel vv cv vw cv wss wa vv cC wrex vx cv vv cv wcel vv
      cv vu cv wss wa vv cC wrex cC cD wcel cB cC cfne wbr vw cv cB wcel w3a vx
      cv vw cv wcel vx cv vv cv wcel vv cv vw cv wss wa vv cC wrex cC cD wcel
      cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx cv vu cv wcel wa wa vw
      cv cB wcel vx cv vw cv wcel vw cv vu cv wss wa wa wa vv cB cC cD vx cv vw
      cv fnessex cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx
      cv vu cv wcel wa wa vw cv cB wcel vx cv vw cv wcel vw cv vu cv wss wa wa
      wa cC cD wcel cB cC cfne wbr vw cv cB wcel cC cD wcel cA cB cfne wbr cB
      cC cfne wbr w3a cC cD wcel vu cv cA wcel vx cv vu cv wcel wa vw cv cB
      wcel vx cv vw cv wcel vw cv vu cv wss wa wa cC cD wcel cA cB cfne wbr cB
      cC cfne wbr 3simp1 ad2antrr cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a
      cB cC cfne wbr vu cv cA wcel vx cv vu cv wcel wa vw cv cB wcel vx cv vw
      cv wcel vw cv vu cv wss wa wa cC cD wcel cA cB cfne wbr cB cC cfne wbr
      3simp3 ad2antrr cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA
      wcel vx cv vu cv wcel wa wa vw cv cB wcel vx cv vw cv wcel vw cv vu cv
      wss wa simprl 3jca cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA
      wcel vx cv vu cv wcel wa wa vw cv cB wcel vx cv vw cv wcel vw cv vu cv
      wss simprrl sylanc cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA
      wcel vx cv vu cv wcel wa wa vw cv cB wcel vx cv vw cv wcel vw cv vu cv
      wss wa wa wa vx cv vv cv wcel vv cv vw cv wss wa vx cv vv cv wcel vv cv
      vu cv wss wa vv cC cC cD wcel cA cB cfne wbr cB cC cfne wbr w3a vu cv cA
      wcel vx cv vu cv wcel wa wa vw cv cB wcel vx cv vw cv wcel vw cv vu cv
      wss wa wa wa vv cv vw cv wss vv cv vu cv wss vx cv vv cv wcel vx cv vw cv
      wcel vw cv vu cv wss wa vv cv vw cv wss vv cv vu cv wss wi cC cD wcel cA
      cB cfne wbr cB cC cfne wbr w3a vu cv cA wcel vx cv vu cv wcel wa wa vw cv
      cB wcel vw cv vu cv wss vv cv vw cv wss vv cv vu cv wss wi vx cv vw cv
      wcel vv cv vw cv wss vw cv vu cv wss vv cv vu cv wss vv cv vw cv vu cv
      sstr2 com12 adantl ad2antll anim2d r19.22sdv mpd exp32 r19.23adv mpd ex
      r19.21aivv jca cC cD wcel cA cB cfne wbr cA cC cfne wbr cA cuni cC cuni
      wceq vx cv vv cv wcel vv cv vu cv wss wa vv cC wrex vx vu cv wral vu cA
      wral wa wb cB cC cfne wbr vu vx vv cA cC cD cA cuni cC cuni cA cuni eqid
      cC cuni eqid isfne2 3ad2ant1 mpbird $.
      $( [5-Oct-2009] $) $( [5-Oct-2009] $)
  $}

  ${
    $d x y z $.
  $( Fineness intersected with its converse is an equivalence relation. $)
  fneer $p |- Er ( Fne i^i `' Fne ) $=
    vx cv vy cv cfne wbr vy cv vz cv cfne wbr wa vx cv vz cv cfne wbr wi vz wal
    vy wal vx wal cfne cfne ccnv cin wer vx cv vy cv cfne wbr vy cv vz cv cfne
    wbr wa vx cv vz cv cfne wbr wi vz wal vx vy vx cv vy cv cfne wbr vy cv vz
    cv cfne wbr wa vx cv vz cv cfne wbr wi vz vz cv cvv wcel vx cv vy cv cfne
    wbr vy cv vz cv cfne wbr vx cv vz cv cfne wbr vz visset vx cv vy cv vz cv
    cvv fnetr mp3an1 ax-gen gen2 cfne vx vy vz trer ax-mp $.
    $( [6-Oct-2009] $) $( [6-Oct-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $. $d x y z D $.
    $( Refinement is transitive. $)
    reftr $p |- ( ( C e. D /\ A Ref B /\ B Ref C ) -> A Ref C ) $=
      cC cD wcel cA cB cref wbr cB cC cref wbr w3a cA cC cref wbr cA cuni cC
      cuni wceq vx cv vz cv wss vz cA wrex vx cC wral wa cC cD wcel cA cB cref
      wbr cB cC cref wbr w3a cA cuni cC cuni wceq vx cv vz cv wss vz cA wrex vx
      cC wral cC cD wcel cA cB cref wbr cB cC cref wbr w3a cA cuni cB cuni cC
      cuni cB cvv wcel cA cB cref wbr cA cuni cB cuni wceq cC cD wcel cA cB
      cref wbr cB cC cref wbr w3a cA cB cvv cA cuni cB cuni cA cuni eqid cB
      cuni eqid refbas cB cC cref wbr cC cD wcel cB cvv wcel cA cB cref wbr cB
      cC cref refrel brrelexi 3ad2ant3 cC cD wcel cA cB cref wbr cB cC cref wbr
      3simp2 sylanc cC cD wcel cB cC cref wbr cB cuni cC cuni wceq cA cB cref
      wbr cB cC cD cB cuni cC cuni cB cuni eqid cC cuni eqid refbas 3adant2
      eqtrd cC cD wcel cA cB cref wbr cB cC cref wbr w3a vx cv vz cv wss vz cA
      wrex vx cC cC cD wcel cA cB cref wbr cB cC cref wbr w3a vx cv cC wcel vx
      cv vy cv wss vy cB wrex vx cv vz cv wss vz cA wrex cC cD wcel cB cC cref
      wbr vx cv cC wcel vx cv vy cv wss vy cB wrex wi cA cB cref wbr cC cD wcel
      cB cC cref wbr vx cv cC wcel vx cv vy cv wss vy cB wrex vy cB cC cD vx cv
      refssex 3expia 3adant2 cC cD wcel cA cB cref wbr cB cC cref wbr w3a vx cv
      vy cv wss vx cv vz cv wss vz cA wrex vy cB cC cD wcel cA cB cref wbr cB
      cC cref wbr w3a vy cv cB wcel vx cv vy cv wss vx cv vz cv wss vz cA wrex
      cC cD wcel cA cB cref wbr cB cC cref wbr w3a vy cv cB wcel vx cv vy cv
      wss wa wa vy cv vz cv wss vz cA wrex vx cv vz cv wss vz cA wrex cB cvv
      wcel cA cB cref wbr vy cv cB wcel vy cv vz cv wss vz cA wrex cC cD wcel
      cA cB cref wbr cB cC cref wbr w3a vy cv cB wcel vx cv vy cv wss wa wa vz
      cA cB cvv vy cv refssex cC cD wcel cA cB cref wbr cB cC cref wbr w3a cB
      cvv wcel vy cv cB wcel vx cv vy cv wss wa cB cC cref wbr cC cD wcel cB
      cvv wcel cA cB cref wbr cB cC cref refrel brrelexi 3ad2ant3 adantr cC cD
      wcel cA cB cref wbr cB cC cref wbr vy cv cB wcel vx cv vy cv wss wa
      3simpl2 cC cD wcel cA cB cref wbr cB cC cref wbr w3a vy cv cB wcel vx cv
      vy cv wss simprl syl3anc vx cv vy cv wss vy cv vz cv wss vz cA wrex vx cv
      vz cv wss vz cA wrex wi cC cD wcel cA cB cref wbr cB cC cref wbr w3a vy
      cv cB wcel vx cv vy cv wss vy cv vz cv wss vx cv vz cv wss vz cA vx cv vy
      cv vz cv sstr2 r19.22sdv ad2antll mpd exp32 r19.23adv syld r19.21aiv jca
      cC cD wcel cA cB cref wbr cA cC cref wbr cA cuni cC cuni wceq vx cv vz cv
      wss vz cA wrex vx cC wral wa wb cB cC cref wbr vx vz cA cC cD cA cuni cC
      cuni cA cuni eqid cC cuni eqid isref 3ad2ant1 mpbird $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d x y R $.
    fneerdm.1 $e |- R = ( Fne i^i `' Fne ) $.
    $( The domain of the fineness equivalence relation is the universal
       class. $)
    fneerdm $p |- dom R = _V $=
      cR cdm cvv cR cdm ssv vx cvv cR cdm vx cv cR cdm wcel vx cv cvv wcel vx
      cv cR cdm wcel vx cv vy cv cR wbr vy wex vx cv vy cv cR wbr vx cv vx cv
      cR wbr vy vx vy cv vx cv vx cv cR breq2 vx cv vx cv cfne wbr vx cv vx cv
      cfne wbr wa vx cv vx cv cR wbr vx cv vx cv cfne wbr vx cv vx cv cfne wbr
      wa vx cv vx cv cfne wbr vx cv cvv wcel vx cv vx cv cfne wbr vx visset vx
      cv cvv fneref ax-mp vx cv vx cv cfne wbr anidm mpbir vx cv vx cv cR wbr
      vx cv vx cv cfne cfne ccnv cin wbr vx cv vx cv cfne wbr vx cv vx cv cfne
      ccnv wbr wa vx cv vx cv cfne wbr vx cv vx cv cfne wbr wa vx cv vx cv cR
      cfne cfne ccnv cin fneerdm.1 breqi vx cv vx cv cfne cfne ccnv int2rel vx
      cv vx cv cfne ccnv wbr vx cv vx cv cfne wbr vx cv vx cv cfne wbr vx cv vx
      cv cfne vx visset vx visset brcnv anbi2i 3bitrri mpbi a4eiv vy vx cv cR
      vx visset eldm mpbir a1i ssriv eqssi $.
      $( [12-Oct-2009] $) $( [12-Oct-2009] $)
  $}

  ${
    $d x y z B $. $d x y z C $. $d x y z X $. $d x y z Y $.
    topbasfne.1 $e |- X = U. B $.
    topbasfne.2 $e |- Y = U. C $.
    $( A condition for a topology to be finer than another. $)
    topbasfne $p |- ( ( B e. Bases /\ C e. Bases /\ X = Y ) -> ( ( topGen ` B )
    C_ ( topGen ` C ) <-> B Fne C ) ) $=
      cB ctb wcel cC ctb wcel cX cY wceq w3a cB ctg cfv cC ctg cfv wss vx cv vy
      cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx
      cB cuni wral cB cC cfne wbr cB ctb wcel cC ctb wcel cB cuni cC cuni wceq
      cB ctg cfv cC ctg cfv wss vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv
      wss wa vz cC wrex wi vy cB wral vx cB cuni wral wb cX cY wceq vx vy vz cB
      cC tgss2 cX cB cuni cY cC cuni topbasfne.1 topbasfne.2 eqeq12i syl3an3b
      cB ctb wcel cC ctb wcel cX cY wceq w3a cB cC cfne wbr vx cv vz cv wcel vz
      cv vy cv wss wa vz cC wrex vx vy cv wral vy cB wral vx cv vy cv wcel vx
      cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral
      cC ctb wcel cX cY wceq cB cC cfne wbr vx cv vz cv wcel vz cv vy cv wss wa
      vz cC wrex vx vy cv wral vy cB wral wb cB ctb wcel cC ctb wcel cB cC cfne
      wbr cX cY wceq vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex vx vy cv
      wral vy cB wral wa cX cY wceq vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex vx vy cv wral vy cB wral vy vx vz cB cC ctb cX cY topbasfne.1
      topbasfne.2 isfne2 cX cY wceq vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex vx vy cv wral vy cB wral cX cY wceq vx cv vz cv wcel vz cv vy cv wss
      wa vz cC wrex vx vy cv wral vy cB wral wa cX cY wceq vx cv vz cv wcel vz
      cv vy cv wss wa vz cC wrex vx vy cv wral vy cB wral ibar bicomd sylan9bb
      3adant1 vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex
      wi vy cB wral vx cB cuni wral vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex vx vy cv wral vy cB wral vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vx cv vz cv wcel vz cv
      vy cv wss wa vz cC wrex vx vy cv wral vy cB vx cv vy cv wcel vx cv vz cv
      wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vy vx cB cuni vx cv cB
      cuni wcel vy ax-17 vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa
      vz cC wrex wi vy cB hbra1 hbral vy cv cB wcel vx cv vy cv wcel vx cv vz
      cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vx cv
      vz cv wcel vz cv vy cv wss wa vz cC wrex vx vy cv wral vy cv cB wcel vx
      cv cB cuni wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz
      cC wrex wi vy cB wral wi vx wal vx cv vy cv wcel vx cv vz cv wcel vz cv
      vy cv wss wa vz cC wrex wi vx wal vx cv vy cv wcel vx cv vz cv wcel vz cv
      vy cv wss wa vz cC wrex wi vy cB wral vx cB cuni wral vx cv vz cv wcel vz
      cv vy cv wss wa vz cC wrex vx vy cv wral vy cv cB wcel vx cv cB cuni wcel
      vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB
      wral wi vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex
      wi vx vy cv cB wcel vx cv vy cv wcel vx cv cB cuni wcel vx cv vy cv wcel
      vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral wi vx cv vz
      cv wcel vz cv vy cv wss wa vz cC wrex vy cv cB wcel vx cv vy cv wcel vx
      cv cB cuni wcel vx cv cB cuni wcel vx cv vy cv wcel vx cv vz cv wcel vz
      cv vy cv wss wa vz cC wrex wi vy cB wral wi vx cv vz cv wcel vz cv vy cv
      wss wa vz cC wrex wi vx cv vy cv wcel vy cv cB wcel vx cv cB cuni wcel vx
      cv vy cv cB elunii expcom vx cv cB cuni wcel vx cv cB cuni wcel vx cv vy
      cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral wi
      vy cv cB wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex vx cv cB cuni wcel vx cv cB cuni wcel vx cv vy cv wcel vx cv vz cv
      wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral wi vx cv vy cv wcel vx
      cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vy cv cB wcel
      vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi wi vx
      cv cB cuni wcel vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz
      cC wrex wi vy cB wral pm2.27 vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wss wa vz cC wrex wi vy cB ra4 syl6 com4t mpdd com23 19.20dv vx cv vy
      cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx
      cB cuni df-ral vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex vx vy cv
      df-ral 3imtr4g com12 r19.21ai vx cv vz cv wcel vz cv vy cv wss wa vz cC
      wrex vx vy cv wral vy cB wral vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wss wa vz cC wrex wi vy cB wral vx cB cuni vx cv vz cv wcel vz cv vy
      cv wss wa vz cC wrex vx vy cv wral vx vy cB vy cv cB wcel vx ax-17 vx cv
      vz cv wcel vz cv vy cv wss wa vz cC wrex vx vy cv hbra1 hbral vx cv vz cv
      wcel vz cv vy cv wss wa vz cC wrex vx vy cv wral vy cB wral vx cv vy cv
      wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB wral vx cv
      cB cuni wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex vx vy cv wral
      vx cv vy cv wcel vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex wi vy cB
      vx cv vz cv wcel vz cv vy cv wss wa vz cC wrex vx vy cv ra4 r19.20si a1d
      r19.21ai impbii syl6rbbr bitrd $.
      $( [28-Sep-2009] $) $( [28-Sep-2009] $)
  $}

  ${
    topfne.1 $e |- X = U. J $.
    topfne.2 $e |- Y = U. K $.
  $( Fineness for covers corresponds precisely with fineness for topologies. $)
  topfne $p |- ( ( J e. Top /\ K e. Top /\ X = Y ) -> ( J C_ K <-> J Fne K ) )
  $=
    cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ ctg cfv cK ctg cfv wss cJ cK
    wss cJ cK cfne wbr cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ ctg cfv cJ
    cK ctg cfv cK cJ ctop wcel cK ctop wcel cJ ctg cfv cJ wceq cX cY wceq cJ
    tgtop 3ad2ant1 cK ctop wcel cJ ctop wcel cK ctg cfv cK wceq cX cY wceq cK
    tgtop 3ad2ant2 sseq12d cJ ctb wcel cK ctb wcel cX cY wceq cJ ctg cfv cK ctg
    cfv wss cJ cK cfne wbr wb cJ ctop wcel cK ctop wcel cX cY wceq cJ cK cX cY
    topfne.1 topfne.2 topbasfne cJ topbas cK topbas cX cY wceq id syl3an bitr3d
    $.
    $( [29-Sep-2009] $) $( [29-Sep-2009] $)
  $}

  ${
    $d c j o s x A $. $d c j o s x J $. $d c j o s x R $.
    topfneec.1 $e |- R = ( Fne i^i `' Fne ) $.
    $( A cover is equivalent to a topology iff it is a base for that
       topology. $)
    topfneec $p |- ( J e. Top -> ( A e. [ J ] R <-> ( A e. Bases /\ ( topGen `
    A ) = J ) ) ) $=
      cJ ctop wcel cA cJ cR cec wcel cA ctb wcel cA ctg cfv cJ wceq wa cJ ctop
      wcel cA cvv wcel wa cA cJ cR cec wcel cA cvv wcel cJ ctop wcel cA cJ cR
      cec elisset anim2i cA ctb wcel cA ctg cfv cJ wceq wa cA cvv wcel cJ ctop
      wcel cA ctb wcel cA cvv wcel cA ctg cfv cJ wceq cA ctb elisset adantr
      anim2i cJ ctop wcel cA cvv wcel wa cA cJ cR cec wcel cA cJ vc cv cR wbr
      vc cab wcel cJ cA cR wbr cA ctb wcel cA ctg cfv cJ wceq wa cJ ctop wcel
      cA cJ cR cec wcel cA cJ vc cv cR wbr vc cab wcel wb cA cvv wcel cJ ctop
      wcel cJ cR cec cJ vc cv cR wbr vc cab cA vj cv cR cec vj cv vc cv cR wbr
      vc cab wceq cJ cR cec cJ vc cv cR wbr vc cab wceq vj cJ ctop vj cv cJ
      wceq vj cv cR cec cJ cR cec vj cv vc cv cR wbr vc cab cJ vc cv cR wbr vc
      cab vj cv cJ cR eceq2 vj cv cJ wceq vj cv vc cv cR wbr cJ vc cv cR wbr vc
      vj cv cJ vc cv cR breq1 abbidv eqeq12d vc vj cv cR vj visset dfec2 vtoclg
      eleq2d adantr cA cvv wcel cA cJ vc cv cR wbr vc cab wcel cJ cA cR wbr wb
      cJ ctop wcel cJ vc cv cR wbr cJ cA cR wbr vc cA cvv vc cv cA cJ cR breq2
      elabg adantl cJ ctop wcel cA cvv wcel wa cJ cA cfne wbr cJ cA cfne ccnv
      wbr wa cA ctb wcel cA ctg cfv cJ wceq wa cJ cA cR wbr cJ ctop wcel cA cvv
      wcel wa cJ cA cfne wbr cJ cA cfne ccnv wbr wa cJ cA cfne wbr cA cJ cfne
      wbr wa cA ctb wcel cA ctg cfv cJ wceq wa cJ ctop wcel cA cvv wcel wa cJ
      cA cfne ccnv wbr cA cJ cfne wbr cJ cA cfne wbr cJ cA ctop cvv cfne brcnvg
      anbi2d cJ ctop wcel cA cvv wcel wa cJ cA cfne wbr cA cJ cfne wbr wa cA
      ctb wcel cA ctg cfv cJ wceq wa cJ ctop wcel cA cJ wss vx cv vs cv wcel vs
      cv vo cv wss wa vs cA wrex vx vo cv wral vo cJ wral cA ctb wcel cA ctg
      cfv cJ wceq wa cJ ctop wcel cA cvv wcel wa cJ cA cfne wbr cA cJ cfne wbr
      wa wa vo vx vs cA cJ basgen2 cJ ctop wcel cA cvv wcel cJ cA cfne wbr cA
      cJ cfne wbr wa simpll cJ ctop wcel cA cvv wcel wa cJ cA cfne wbr cA cJ
      cfne wbr wa wa vs cA cJ cJ ctop wcel cA cvv wcel wa cJ cA cfne wbr cA cJ
      cfne wbr wa wa vs cv cA wcel vs cv cJ wcel cJ ctop wcel cA cvv wcel wa cJ
      cA cfne wbr cA cJ cfne wbr wa wa vs cv cA wcel wa vs cv cJ wcel vs cv cJ
      cuni wss vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs cv wral wa
      cJ ctop wcel cA cvv wcel wa cA cJ cfne wbr vs cv cA wcel vs cv cJ cuni
      wss vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs cv wral wa cJ cA
      cfne wbr cJ ctop wcel cA cvv wcel wa cA cJ cfne wbr vs cv cA wcel vs cv
      cJ cuni wss vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs cv wral
      wa cJ ctop wcel cA cvv wcel wa cA cJ cfne wbr vs cv cA wcel wa wa vs cv
      cJ cuni wss vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs cv wral
      cJ ctop wcel cA cvv wcel wa cA cJ cfne wbr vs cv cA wcel wa wa vs cv cA
      cuni cJ cuni vs cv cA wcel vs cv cA cuni wss cJ ctop wcel cA cvv wcel wa
      cA cJ cfne wbr vs cv cA elssuni ad2antll cJ ctop wcel cA cJ cfne wbr cA
      cuni cJ cuni wceq cA cvv wcel vs cv cA wcel cA cJ ctop cA cuni cJ cuni cA
      cuni eqid cJ cuni eqid fnebas ad2ant2r sseqtrd cJ ctop wcel cA cJ cfne
      wbr vs cv cA wcel wa vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs
      cv wral cA cvv wcel cJ ctop wcel cA cJ cfne wbr vs cv cA wcel vx cv vo cv
      wcel vo cv vs cv wss wa vo cJ wrex vx vs cv wral cJ ctop wcel cA cJ cfne
      wbr vs cv cA wcel w3a vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx
      vs cv vo cA cJ ctop vx cv vs cv fnessex r19.21aiva 3expb adantlr jca
      anassrs adantlrl cJ ctop wcel cA cvv wcel wa vs cv cJ wcel vs cv cJ cuni
      wss vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs cv wral wa wb cJ
      cA cfne wbr cA cJ cfne wbr wa vs cv cA wcel cJ ctop wcel vs cv cJ wcel vs
      cv cJ cuni wss vx cv vo cv wcel vo cv vs cv wss wa vo cJ wrex vx vs cv
      wral wa wb cA cvv wcel vx vo vs cv cJ eltop2 adantr ad2antrr mpbird ex
      ssrdv cA cvv wcel cJ cA cfne wbr vx cv vs cv wcel vs cv vo cv wss wa vs
      cA wrex vx vo cv wral vo cJ wral cJ ctop wcel cA cJ cfne wbr cA cvv wcel
      cJ cA cfne wbr wa vx cv vs cv wcel vs cv vo cv wss wa vs cA wrex vx vo cv
      wral vo cJ cA cvv wcel cJ cA cfne wbr vo cv cJ wcel vx cv vs cv wcel vs
      cv vo cv wss wa vs cA wrex vx vo cv wral cA cvv wcel cJ cA cfne wbr vo cv
      cJ wcel w3a vx cv vs cv wcel vs cv vo cv wss wa vs cA wrex vx vo cv vs cJ
      cA cvv vx cv vo cv fnessex r19.21aiva 3expia r19.21aiv ad2ant2lr syl3anc
      cJ ctop wcel cA cvv wcel wa cA ctb wcel cA ctg cfv cJ wceq wa cA ctb wcel
      cA ctg cfv cJ ctg cfv wceq wa cJ cA cfne wbr cA cJ cfne wbr wa cJ ctop
      wcel cA cvv wcel wa cA ctb wcel cA ctg cfv cJ wceq wa cA ctb wcel cA ctg
      cfv cJ ctg cfv wceq wa cJ ctop wcel cA cvv wcel wa cA ctg cfv cJ wceq cA
      ctg cfv cJ ctg cfv wceq cA ctb wcel cJ ctop wcel cA cvv wcel wa cA ctg
      cfv cJ ctg cfv wceq cA ctg cfv cJ wceq cJ ctop wcel cA cvv wcel wa cJ ctg
      cfv cJ cA ctg cfv cJ ctop wcel cJ ctg cfv cJ wceq cA cvv wcel cJ tgtop
      adantr eqeq2d biimprd anim2d imp cJ ctop wcel cA ctb wcel cA ctg cfv cJ
      ctg cfv wceq wa cJ cA cfne wbr cA cJ cfne wbr wa cA cvv wcel cJ ctop wcel
      cA ctb wcel cA ctg cfv cJ ctg cfv wceq wa wa cA cuni cJ cuni wceq cJ cA
      cfne wbr cA cJ cfne wbr wa cJ ctop wcel cA ctb wcel cA ctg cfv cJ ctg cfv
      wceq wa wa cA ctg cfv cuni cJ ctg cfv cuni cA cuni cJ cuni cA ctg cfv cJ
      ctg cfv wceq cA ctg cfv cuni cJ ctg cfv cuni wceq cJ ctop wcel cA ctb
      wcel cA ctg cfv cJ ctg cfv unieq ad2antll cA ctb wcel cA ctg cfv cuni cA
      cuni wceq cJ ctop wcel cA ctg cfv cJ ctg cfv wceq cA unitg ad2antrl cJ
      ctop wcel cJ ctg cfv cuni cJ cuni wceq cA ctb wcel cA ctg cfv cJ ctg cfv
      wceq wa cJ ctop wcel cJ ctb wcel cJ ctg cfv cuni cJ cuni wceq cJ topbas
      cJ unitg syl adantr 3eqtr3d cJ ctop wcel cA ctb wcel cA ctg cfv cJ ctg
      cfv wceq cA cuni cJ cuni wceq cJ cA cfne wbr cA cJ cfne wbr wa wi cJ ctop
      wcel cA ctb wcel wa cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq cJ cA
      cfne wbr cA cJ cfne wbr wa cJ ctop wcel cA ctb wcel wa cA ctg cfv cJ ctg
      cfv wceq cA cuni cJ cuni wceq wa wa cJ cA cfne wbr cA cJ cfne wbr cJ ctop
      wcel cA ctb wcel wa cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq wa wa
      cJ ctg cfv cA ctg cfv wss cJ cA cfne wbr cA ctg cfv cJ ctg cfv wceq cJ
      ctg cfv cA ctg cfv wss cJ ctop wcel cA ctb wcel wa cA cuni cJ cuni wceq
      cJ ctg cfv cA ctg cfv eqimss2 ad2antrl cJ ctb wcel cA ctb wcel cJ cuni cA
      cuni wceq cJ ctg cfv cA ctg cfv wss cJ cA cfne wbr wb cJ ctop wcel cA ctb
      wcel wa cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq wa wa cJ cA cJ
      cuni cA cuni cJ cuni eqid cA cuni eqid topbasfne cJ ctop wcel cJ ctb wcel
      cA ctb wcel cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq wa cJ topbas
      ad2antrr cJ ctop wcel cA ctb wcel cA ctg cfv cJ ctg cfv wceq cA cuni cJ
      cuni wceq wa simplr cA cuni cJ cuni wceq cJ cuni cA cuni wceq cJ ctop
      wcel cA ctb wcel wa cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq cJ
      cuni cA cuni wceq cA cuni cJ cuni eqcom biimpi ad2antll syl3anc mpbid cJ
      ctop wcel cA ctb wcel wa cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq
      wa wa cA ctg cfv cJ ctg cfv wss cA cJ cfne wbr cA ctg cfv cJ ctg cfv wceq
      cA ctg cfv cJ ctg cfv wss cJ ctop wcel cA ctb wcel wa cA cuni cJ cuni
      wceq cA ctg cfv cJ ctg cfv eqimss ad2antrl cA ctb wcel cJ ctb wcel cA
      cuni cJ cuni wceq cA ctg cfv cJ ctg cfv wss cA cJ cfne wbr wb cJ ctop
      wcel cA ctb wcel wa cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq wa wa
      cA cJ cA cuni cJ cuni cA cuni eqid cJ cuni eqid topbasfne cJ ctop wcel cA
      ctb wcel cA ctg cfv cJ ctg cfv wceq cA cuni cJ cuni wceq wa simplr cJ
      ctop wcel cJ ctb wcel cA ctb wcel cA ctg cfv cJ ctg cfv wceq cA cuni cJ
      cuni wceq wa cJ topbas ad2antrr cJ ctop wcel cA ctb wcel wa cA ctg cfv cJ
      ctg cfv wceq cA cuni cJ cuni wceq simprr syl3anc mpbid jca expr anasss
      mpd adantlr syldan impbida bitrd cJ cA cR wbr cJ cA cfne cfne ccnv cin
      wbr cJ cA cfne wbr cJ cA cfne ccnv wbr wa cJ cA cR cfne cfne ccnv cin
      topfneec.1 breqi cJ cA cfne cfne ccnv int2rel bitri syl5bb 3bitrd
      pm5.21nd $.
      $( [8-Oct-2009] $) $( [8-Oct-2009] $)
  $}

  ${
    topfneec2.1 $e |- R = ( Fne i^i `' Fne ) $.
    $( A topology is precisely identified with its equivalence class. $)
    topfneec2 $p |- ( ( J e. Top /\ K e. Top ) -> ( [ J ] R = [ K ] R <-> J = K
    ) ) $=
      cJ ctop wcel cK ctop wcel wa cJ cR cec cK cR cec wceq cJ cK wceq cJ ctop
      wcel cK ctop wcel wa cJ cR cec cK cR cec wceq cJ cK cR cec wcel cJ cK
      wceq cJ cR cec cK cR cec wceq cJ cJ cR cec wcel cJ cK cR cec wcel cJ ctop
      wcel cK ctop wcel wa cJ cR cec cK cR cec cJ eleq2 cJ ctop wcel cJ cJ cR
      cec wcel cK ctop wcel cJ ctop wcel cJ cJ cR cec wcel cJ ctb wcel cJ ctg
      cfv cJ wceq wa cJ ctop wcel cJ ctb wcel cJ ctg cfv cJ wceq cJ topbas cJ
      tgtop jca cJ cR cJ topfneec2.1 topfneec mpbird adantr syl5cbi cJ ctop
      wcel cK ctop wcel wa cJ cK cR cec wcel cJ ctb wcel cJ ctg cfv cK wceq wa
      cJ cK wceq cK ctop wcel cJ cK cR cec wcel cJ ctb wcel cJ ctg cfv cK wceq
      wa wb cJ ctop wcel cJ cR cK topfneec2.1 topfneec adantl cJ ctop wcel cJ
      ctb wcel cJ ctg cfv cK wceq wa cJ cK wceq wi cK ctop wcel cJ ctop wcel cJ
      ctg cfv cK wceq cJ cK wceq cJ ctb wcel cJ ctop wcel cJ ctg cfv cK wceq cJ
      cK wceq cJ ctop wcel cJ ctg cfv cJ cK cJ tgtop eqeq1d biimpd adantld
      adantr sylbid syld cJ cK cR eceq2 impbid1 $.
      $( [12-Oct-2009] $) $( [12-Oct-2009] $)
  $}

  ${
    $d c t w x y z A $. $d c t w x y z B $. $d c t w x y z C $. $d c t w x y z
    X $. $d c t w x y z Y $.
    fnessref.1 $e |- X = U. A $.
    fnessref.2 $e |- Y = U. B $.
    $( A cover is finer iff it has a subcover which is both finer and a
       refinement. $)
    fnessref $p |- ( ( B e. C /\ X = Y ) -> ( A Fne B <-> E. c ( c C_ B /\ A (
    Fne i^i Ref ) c ) ) ) $=
      cB cC wcel cX cY wceq wa cA cB cfne wbr vc cv cB wss cA vc cv cfne cref
      cin wbr wa vc wex cB cC wcel cX cY wceq cA cB cfne wbr vc cv cB wss cA vc
      cv cfne cref cin wbr wa vc wex vx cv vy cv wss vy cA wrex vx cB crab cvv
      wcel vx cv vy cv wss vy cA wrex vx cB crab cB wss cA vx cv vy cv wss vy
      cA wrex vx cB crab cfne cref cin wbr wa vc cv cB wss cA vc cv cfne cref
      cin wbr wa vc wex cB cC wcel cX cY wceq cA cB cfne wbr w3a vc cv cB wss
      cA vc cv cfne cref cin wbr wa vx cv vy cv wss vy cA wrex vx cB crab cB
      wss cA vx cv vy cv wss vy cA wrex vx cB crab cfne cref cin wbr wa vc vx
      cv vy cv wss vy cA wrex vx cB crab cvv vc cv vx cv vy cv wss vy cA wrex
      vx cB crab wceq vc cv cB wss vx cv vy cv wss vy cA wrex vx cB crab cB wss
      cA vc cv cfne cref cin wbr cA vx cv vy cv wss vy cA wrex vx cB crab cfne
      cref cin wbr vc cv vx cv vy cv wss vy cA wrex vx cB crab cB sseq1 vc cv
      vx cv vy cv wss vy cA wrex vx cB crab cA cfne cref cin breq2 anbi12d
      cla4egv cB cC wcel cX cY wceq vx cv vy cv wss vy cA wrex vx cB crab cvv
      wcel cA cB cfne wbr vx cv vy cv wss vy cA wrex vx cB cC rabexg 3ad2ant1
      cB cC wcel cX cY wceq cA cB cfne wbr w3a cA vx cv vy cv wss vy cA wrex vx
      cB crab cfne cref cin wbr vx cv vy cv wss vy cA wrex vx cB crab cB wss cB
      cC wcel cX cY wceq cA cB cfne wbr w3a cA vx cv vy cv wss vy cA wrex vx cB
      crab cfne wbr cA vx cv vy cv wss vy cA wrex vx cB crab cref wbr wa cA vx
      cv vy cv wss vy cA wrex vx cB crab cfne cref cin wbr cB cC wcel cX cY
      wceq cA cB cfne wbr w3a cA vx cv vy cv wss vy cA wrex vx cB crab cfne wbr
      cA vx cv vy cv wss vy cA wrex vx cB crab cref wbr cB cC wcel cX cY wceq
      cA cB cfne wbr w3a cA vx cv vy cv wss vy cA wrex vx cB crab cfne wbr cX
      vx cv vy cv wss vy cA wrex vx cB crab cuni wceq vt cv vw cv wcel vw cv vz
      cv wss wa vw vx cv vy cv wss vy cA wrex vx cB crab wrex vt vz cv wral vz
      cA wral wa cB cC wcel cX cY wceq cA cB cfne wbr w3a cX vx cv vy cv wss vy
      cA wrex vx cB crab cuni wceq vt cv vw cv wcel vw cv vz cv wss wa vw vx cv
      vy cv wss vy cA wrex vx cB crab wrex vt vz cv wral vz cA wral cB cC wcel
      cX cY wceq cA cB cfne wbr w3a cX vx cv vy cv wss vy cA wrex vx cB crab
      cuni cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cX vx cv vy cv wss vy cA
      wrex vx cB crab cuni cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cv vz cv
      wcel vz cv cA wcel wa vz wex vt cv vx cv wcel vx cv vy cv wss vy cA wrex
      wa vx cB wrex vt cv cX wcel vt cv vx cv vy cv wss vy cA wrex vx cB crab
      cuni wcel cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cv vz cv wcel vz cv
      cA wcel wa vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB wrex vz
      cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cv vz cv wcel vz cv cA wcel
      vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB wrex cB cC wcel cX
      cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel vt cv vx cv
      wcel vx cv vy cv wss vy cA wrex wa vx cB wrex cB cC wcel cX cY wceq cA cB
      cfne wbr w3a vz cv cA wcel vt cv vz cv wcel vt cv vx cv wcel vx cv vy cv
      wss vy cA wrex wa vx cB wrex wi cB cC wcel cX cY wceq cA cB cfne wbr w3a
      vz cv cA wcel wa vt cv vz cv wcel vt cv vx cv wcel vx cv vz cv wss wa vx
      cB wrex vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB wrex cB cC
      wcel cA cB cfne wbr vz cv cA wcel vt cv vz cv wcel vt cv vx cv wcel vx cv
      vz cv wss wa vx cB wrex wi cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv
      cA wcel wa cB cC wcel cA cB cfne wbr vz cv cA wcel w3a vt cv vz cv wcel
      vt cv vx cv wcel vx cv vz cv wss wa vx cB wrex vx cA cB cC vt cv vz cv
      fnessex ex cB cC wcel cX cY wceq cA cB cfne wbr vz cv cA wcel 3simpl1 cB
      cC wcel cX cY wceq cA cB cfne wbr vz cv cA wcel 3simpl3 cB cC wcel cX cY
      wceq cA cB cfne wbr w3a vz cv cA wcel pm3.27 syl3anc cB cC wcel cX cY
      wceq cA cB cfne wbr w3a vz cv cA wcel wa vt cv vx cv wcel vx cv vz cv wss
      wa vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB cB cC wcel cX cY
      wceq cA cB cfne wbr w3a vz cv cA wcel wa vx cv vz cv wss vx cv vy cv wss
      vy cA wrex vt cv vx cv wcel vz cv cA wcel vx cv vz cv wss vx cv vy cv wss
      vy cA wrex wi cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vx
      cv vz cv wss vx cv vy cv wss vy cA wrex vx cv vy cv wss vx cv vz cv wss
      vy vz cv cA vy cv vz cv vx cv sseq2 rcla4ev ex adantl anim2d r19.22sdv
      syld ex com23 imp3a 19.23adv vt cv cX wcel vt cv cA cuni wcel vt cv vz cv
      wcel vz cv cA wcel wa vz wex cX cA cuni vt cv fnessref.1 eleq2i vz vt cv
      cA eluni bitri vx cv vy cv wss vy cA wrex vx vt cv cB elunirab 3imtr4g
      ssrdv cB cC wcel cX cY wceq cA cB cfne wbr w3a vx cv vy cv wss vy cA wrex
      vx cB crab cuni cB cuni cX vx cv vy cv wss vy cA wrex vx cB crab cuni cB
      cuni wss cB cC wcel cX cY wceq cA cB cfne wbr w3a vx cv vy cv wss vy cA
      wrex vx cB crab cB wss vx cv vy cv wss vy cA wrex vx cB crab cuni cB cuni
      wss vx cv vy cv wss vy cA wrex vx cB ssrab2 vx cv vy cv wss vy cA wrex vx
      cB crab cB uniss ax-mp a1i cB cC wcel cX cY wceq cA cB cfne wbr w3a cX cY
      cB cuni cB cC wcel cX cY wceq cA cB cfne wbr 3simp2 fnessref.2 syl6req
      sseqtrd eqssd cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cv vw cv wcel
      vw cv vz cv wss wa vw vx cv vy cv wss vy cA wrex vx cB crab wrex vz vt cA
      vz cv cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv
      wcel wa vt cv vw cv wcel vw cv vz cv wss wa vw vx cv vy cv wss vy cA wrex
      vx cB crab wrex cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt
      cv vz cv wcel wa wa vt cv vw cv wcel vw cv vz cv wss wa vw cB wrex vt cv
      vw cv wcel vw cv vz cv wss wa vw vx cv vy cv wss vy cA wrex vx cB crab
      wrex cB cC wcel cA cB cfne wbr vz cv cA wcel w3a vt cv vz cv wcel vt cv
      vw cv wcel vw cv vz cv wss wa vw cB wrex cB cC wcel cX cY wceq cA cB cfne
      wbr w3a vz cv cA wcel vt cv vz cv wcel wa wa vw cA cB cC vt cv vz cv
      fnessex cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz
      cv wcel wa wa cB cC wcel cA cB cfne wbr vz cv cA wcel cB cC wcel cX cY
      wceq cA cB cfne wbr vz cv cA wcel vt cv vz cv wcel wa 3simpl1 cB cC wcel
      cX cY wceq cA cB cfne wbr vz cv cA wcel vt cv vz cv wcel wa 3simpl3 cB cC
      wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel simprl
      3jca cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv
      wcel simprr sylanc cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel
      vt cv vz cv wcel wa wa vt cv vw cv wcel vw cv vz cv wss wa vt cv vw cv
      wcel vw cv vz cv wss wa vw cB vx cv vy cv wss vy cA wrex vx cB crab cB cC
      wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel wa wa
      vw cv cB wcel vt cv vw cv wcel vw cv vz cv wss wa wa vw cv vx cv vy cv
      wss vy cA wrex vx cB crab wcel vt cv vw cv wcel vw cv vz cv wss wa cB cC
      wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel wa wa
      vw cv cB wcel vt cv vw cv wcel vw cv vz cv wss wa wa vw cv cB wcel vw cv
      vy cv wss vy cA wrex wa vw cv vx cv vy cv wss vy cA wrex vx cB crab wcel
      cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel
      wa wa vw cv cB wcel vt cv vw cv wcel vw cv vz cv wss wa wa vw cv cB wcel
      vw cv vy cv wss vy cA wrex vw cv cB wcel vt cv vw cv wcel vw cv vz cv wss
      wa wa vw cv cB wcel wi cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA
      wcel vt cv vz cv wcel wa wa vw cv cB wcel vt cv vw cv wcel vw cv vz cv
      wss wa pm3.26 a1i vz cv cA wcel vw cv cB wcel vt cv vw cv wcel vw cv vz
      cv wss wa wa vw cv vy cv wss vy cA wrex wi cB cC wcel cX cY wceq cA cB
      cfne wbr w3a vt cv vz cv wcel vw cv cB wcel vt cv vw cv wcel vw cv vz cv
      wss wa wa vz cv cA wcel vw cv vy cv wss vy cA wrex vw cv vz cv wss vz cv
      cA wcel vw cv vy cv wss vy cA wrex wi vw cv cB wcel vt cv vw cv wcel vz
      cv cA wcel vw cv vz cv wss vw cv vy cv wss vy cA wrex vw cv vy cv wss vw
      cv vz cv wss vy vz cv cA vy cv vz cv vw cv sseq2 rcla4ev expcom ad2antll
      com12 ad2antrl jcad vx cv vy cv wss vy cA wrex vw cv vy cv wss vy cA wrex
      vx vw cv cB vx cv vw cv wceq vx cv vy cv wss vw cv vy cv wss vy cA vx cv
      vw cv vy cv sseq1 rexbidv elrab syl6ibr vw cv cB wcel vt cv vw cv wcel vw
      cv vz cv wss wa wa vt cv vw cv wcel vw cv vz cv wss wa wi cB cC wcel cX
      cY wceq cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel wa wa vw cv cB
      wcel vt cv vw cv wcel vw cv vz cv wss wa pm3.27 a1i jcad r19.22dv2 mpd ex
      r19.21aivv jca cB cC wcel cX cY wceq cA vx cv vy cv wss vy cA wrex vx cB
      crab cfne wbr cX vx cv vy cv wss vy cA wrex vx cB crab cuni wceq vt cv vw
      cv wcel vw cv vz cv wss wa vw vx cv vy cv wss vy cA wrex vx cB crab wrex
      vt vz cv wral vz cA wral wa wb cA cB cfne wbr cB cC wcel vx cv vy cv wss
      vy cA wrex vx cB crab cvv wcel cA vx cv vy cv wss vy cA wrex vx cB crab
      cfne wbr cX vx cv vy cv wss vy cA wrex vx cB crab cuni wceq vt cv vw cv
      wcel vw cv vz cv wss wa vw vx cv vy cv wss vy cA wrex vx cB crab wrex vt
      vz cv wral vz cA wral wa wb vx cv vy cv wss vy cA wrex vx cB cC rabexg vz
      vt vw cA vx cv vy cv wss vy cA wrex vx cB crab cvv cX vx cv vy cv wss vy
      cA wrex vx cB crab cuni fnessref.1 vx cv vy cv wss vy cA wrex vx cB crab
      cuni eqid isfne2 syl 3ad2ant1 mpbird cB cC wcel cX cY wceq cA cB cfne wbr
      w3a cA vx cv vy cv wss vy cA wrex vx cB crab cref wbr cX vx cv vy cv wss
      vy cA wrex vx cB crab cuni wceq vz cv vw cv wss vw cA wrex vz vx cv vy cv
      wss vy cA wrex vx cB crab wral wa cB cC wcel cX cY wceq cA cB cfne wbr
      w3a cX vx cv vy cv wss vy cA wrex vx cB crab cuni wceq vz cv vw cv wss vw
      cA wrex vz vx cv vy cv wss vy cA wrex vx cB crab wral cB cC wcel cX cY
      wceq cA cB cfne wbr w3a cX vx cv vy cv wss vy cA wrex vx cB crab cuni cB
      cC wcel cX cY wceq cA cB cfne wbr w3a vt cX vx cv vy cv wss vy cA wrex vx
      cB crab cuni cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cv vz cv wcel vz
      cv cA wcel wa vz wex vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB
      wrex vt cv cX wcel vt cv vx cv vy cv wss vy cA wrex vx cB crab cuni wcel
      cB cC wcel cX cY wceq cA cB cfne wbr w3a vt cv vz cv wcel vz cv cA wcel
      wa vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB wrex vz cB cC
      wcel cX cY wceq cA cB cfne wbr w3a vt cv vz cv wcel vz cv cA wcel vt cv
      vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB wrex cB cC wcel cX cY wceq
      cA cB cfne wbr w3a vz cv cA wcel vt cv vz cv wcel vt cv vx cv wcel vx cv
      vy cv wss vy cA wrex wa vx cB wrex cB cC wcel cX cY wceq cA cB cfne wbr
      w3a vz cv cA wcel vt cv vz cv wcel vt cv vx cv wcel vx cv vy cv wss vy cA
      wrex wa vx cB wrex wi cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA
      wcel wa vt cv vz cv wcel vt cv vx cv wcel vx cv vz cv wss wa vx cB wrex
      vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB wrex cB cC wcel cA
      cB cfne wbr vz cv cA wcel vt cv vz cv wcel vt cv vx cv wcel vx cv vz cv
      wss wa vx cB wrex wi cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA
      wcel wa cB cC wcel cA cB cfne wbr vz cv cA wcel w3a vt cv vz cv wcel vt
      cv vx cv wcel vx cv vz cv wss wa vx cB wrex vx cA cB cC vt cv vz cv
      fnessex ex cB cC wcel cX cY wceq cA cB cfne wbr vz cv cA wcel 3simpl1 cB
      cC wcel cX cY wceq cA cB cfne wbr vz cv cA wcel 3simpl3 cB cC wcel cX cY
      wceq cA cB cfne wbr w3a vz cv cA wcel pm3.27 syl3anc cB cC wcel cX cY
      wceq cA cB cfne wbr w3a vz cv cA wcel wa vt cv vx cv wcel vx cv vz cv wss
      wa vt cv vx cv wcel vx cv vy cv wss vy cA wrex wa vx cB cB cC wcel cX cY
      wceq cA cB cfne wbr w3a vz cv cA wcel wa vx cv vz cv wss vx cv vy cv wss
      vy cA wrex vt cv vx cv wcel vz cv cA wcel vx cv vz cv wss vx cv vy cv wss
      vy cA wrex wi cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv cA wcel vx
      cv vz cv wss vx cv vy cv wss vy cA wrex vx cv vy cv wss vx cv vz cv wss
      vy vz cv cA vy cv vz cv vx cv sseq2 rcla4ev ex adantl anim2d r19.22sdv
      syld ex com23 imp3a 19.23adv vt cv cX wcel vt cv cA cuni wcel vt cv vz cv
      wcel vz cv cA wcel wa vz wex cX cA cuni vt cv fnessref.1 eleq2i vz vt cv
      cA eluni bitri vx cv vy cv wss vy cA wrex vx vt cv cB elunirab 3imtr4g
      ssrdv cB cC wcel cX cY wceq cA cB cfne wbr w3a vx cv vy cv wss vy cA wrex
      vx cB crab cuni cB cuni cX vx cv vy cv wss vy cA wrex vx cB crab cuni cB
      cuni wss cB cC wcel cX cY wceq cA cB cfne wbr w3a vx cv vy cv wss vy cA
      wrex vx cB crab cB wss vx cv vy cv wss vy cA wrex vx cB crab cuni cB cuni
      wss vx cv vy cv wss vy cA wrex vx cB ssrab2 vx cv vy cv wss vy cA wrex vx
      cB crab cB uniss ax-mp a1i cB cC wcel cX cY wceq cA cB cfne wbr w3a cX cY
      cB cuni cB cC wcel cX cY wceq cA cB cfne wbr 3simp2 fnessref.2 syl6req
      sseqtrd eqssd cB cC wcel cX cY wceq cA cB cfne wbr w3a vz cv vw cv wss vw
      cA wrex vz vx cv vy cv wss vy cA wrex vx cB crab cB cC wcel cX cY wceq cA
      cB cfne wbr w3a vz cv cB wcel vz cv vy cv wss vy cA wrex wa vz cv vw cv
      wss vw cA wrex vz cv vx cv vy cv wss vy cA wrex vx cB crab wcel vz cv cB
      wcel vz cv vy cv wss vy cA wrex wa vz cv vw cv wss vw cA wrex wi cB cC
      wcel cX cY wceq cA cB cfne wbr w3a vz cv vy cv wss vy cA wrex vz cv vw cv
      wss vw cA wrex vz cv cB wcel vz cv vy cv wss vy cA wrex vz cv vw cv wss
      vw cA wrex vz cv vy cv wss vz cv vw cv wss vy vw cA vy cv vw cv vz cv
      sseq2 cbvrexv biimpi adantl a1i vx cv vy cv wss vy cA wrex vz cv vy cv
      wss vy cA wrex vx vz cv cB vx cv vz cv wceq vx cv vy cv wss vz cv vy cv
      wss vy cA vx cv vz cv vy cv sseq1 rexbidv elrab syl5ib r19.21aiv jca cB
      cC wcel cX cY wceq cA vx cv vy cv wss vy cA wrex vx cB crab cref wbr cX
      vx cv vy cv wss vy cA wrex vx cB crab cuni wceq vz cv vw cv wss vw cA
      wrex vz vx cv vy cv wss vy cA wrex vx cB crab wral wa wb cA cB cfne wbr
      cB cC wcel vx cv vy cv wss vy cA wrex vx cB crab cvv wcel cA vx cv vy cv
      wss vy cA wrex vx cB crab cref wbr cX vx cv vy cv wss vy cA wrex vx cB
      crab cuni wceq vz cv vw cv wss vw cA wrex vz vx cv vy cv wss vy cA wrex
      vx cB crab wral wa wb vx cv vy cv wss vy cA wrex vx cB cC rabexg vz vw cA
      vx cv vy cv wss vy cA wrex vx cB crab cvv cX vx cv vy cv wss vy cA wrex
      vx cB crab cuni fnessref.1 vx cv vy cv wss vy cA wrex vx cB crab cuni
      eqid isref syl 3ad2ant1 mpbird jca cA vx cv vy cv wss vy cA wrex vx cB
      crab cfne cref int2rel sylibr vx cv vy cv wss vy cA wrex vx cB ssrab2
      jctil sylc 3expia cB cC wcel cX cY wceq wa vc cv cB wss cA vc cv cfne
      cref cin wbr wa cA cB cfne wbr vc cB cC wcel cX cY wceq wa vc cv cB wss
      cA vc cv cfne cref cin wbr wa cA cB cfne wbr cB cC wcel cA vc cv cfne wbr
      vc cv cB cfne wbr cA cB cfne wbr cB cC wcel cX cY wceq wa vc cv cB wss cA
      vc cv cfne cref cin wbr wa wa cA vc cv cB cC fnetr cB cC wcel cX cY wceq
      vc cv cB wss cA vc cv cfne cref cin wbr wa simpll cA vc cv cfne cref cin
      wbr cA vc cv cfne wbr cB cC wcel cX cY wceq wa vc cv cB wss cfne cref cin
      cfne cA vc cv cfne cref inss1 ssbri ad2antll cB cC wcel vc cv cB wss vc
      cv cuni cY wceq vc cv cB cfne wbr cB cC wcel cX cY wceq wa vc cv cB wss
      cA vc cv cfne cref cin wbr wa wa vc cv cB cC vc cv cuni cY vc cv cuni
      eqid fnessref.2 fness cB cC wcel cX cY wceq vc cv cB wss cA vc cv cfne
      cref cin wbr wa simpll cB cC wcel cX cY wceq wa vc cv cB wss cA vc cv
      cfne cref cin wbr simprl cB cC wcel cX cY wceq wa vc cv cB wss cA vc cv
      cfne cref cin wbr wa wa cX vc cv cuni cY cA vc cv cfne cref cin wbr cX vc
      cv cuni wceq cB cC wcel cX cY wceq wa vc cv cB wss cA vc cv cfne cref cin
      wbr cA vc cv cfne wbr cX vc cv cuni wceq cfne cref cin cfne cA vc cv cfne
      cref inss1 ssbri vc cv cvv wcel cA vc cv cfne wbr cX vc cv cuni wceq vc
      visset cA vc cv cvv cX vc cv cuni fnessref.1 vc cv cuni eqid fnebas mpan
      syl ad2antll cB cC wcel cX cY wceq vc cv cB wss cA vc cv cfne cref cin
      wbr wa simplr eqtr3d syl3anc syl3anc ex 19.23adv impbid $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d c x y A $. $d c x y B $. $d c x y C $. $d c x y X $. $d c x y Y $.
    refssfne.1 $e |- X = U. A $.
    refssfne.2 $e |- Y = U. B $.
    $( A cover is a refinement iff it is a subcover of something which is both
       finer and a refinement. $)
    refssfne $p |- ( ( B e. C /\ X = Y ) -> ( A Ref B <-> E. c ( B C_ c /\ A (
    Fne i^i Ref ) c ) ) ) $=
      cB cC wcel cX cY wceq wa cA cB cref wbr cB vc cv wss cA vc cv cfne cref
      cin wbr wa vc wex cB cC wcel cX cY wceq cA cB cref wbr cB vc cv wss cA vc
      cv cfne cref cin wbr wa vc wex cA cB cun cvv wcel cB cA cB cun wss cA cA
      cB cun cfne cref cin wbr wa cB vc cv wss cA vc cv cfne cref cin wbr wa vc
      wex cB cC wcel cX cY wceq cA cB cref wbr w3a cB vc cv wss cA vc cv cfne
      cref cin wbr wa cB cA cB cun wss cA cA cB cun cfne cref cin wbr wa vc cA
      cB cun cvv vc cv cA cB cun wceq cB vc cv wss cB cA cB cun wss cA vc cv
      cfne cref cin wbr cA cA cB cun cfne cref cin wbr vc cv cA cB cun cB sseq2
      vc cv cA cB cun cA cfne cref cin breq2 anbi12d cla4egv cA cvv wcel cB cC
      wcel cA cB cun cvv wcel cB cC wcel cX cY wceq cA cB cref wbr w3a cA cB
      cvv cC unexg cA cB cref wbr cB cC wcel cA cvv wcel cX cY wceq cA cB cref
      refrel brrelexi 3ad2ant3 cB cC wcel cX cY wceq cA cB cref wbr 3simp1
      sylanc cB cC wcel cX cY wceq cA cB cref wbr w3a cA cA cB cun cfne cref
      cin wbr cB cA cB cun wss cB cC wcel cX cY wceq cA cB cref wbr w3a cA cA
      cB cun cfne wbr cA cA cB cun cref wbr wa cA cA cB cun cfne cref cin wbr
      cB cC wcel cX cY wceq cA cB cref wbr w3a cA cA cB cun cfne wbr cA cA cB
      cun cref wbr cA cB cun cvv wcel cA cA cB cun wss cX cA cuni cB cuni cun
      wceq cA cA cB cun cfne wbr cB cC wcel cX cY wceq cA cB cref wbr w3a cA cA
      cB cun cvv cX cA cuni cB cuni cun refssfne.1 cA cB cun cuni cA cuni cB
      cuni cun cA cB uniun eqcomi fness cA cvv wcel cB cC wcel cA cB cun cvv
      wcel cB cC wcel cX cY wceq cA cB cref wbr w3a cA cB cvv cC unexg cA cB
      cref wbr cB cC wcel cA cvv wcel cX cY wceq cA cB cref refrel brrelexi
      3ad2ant3 cB cC wcel cX cY wceq cA cB cref wbr 3simp1 sylanc cA cA cB cun
      wss cB cC wcel cX cY wceq cA cB cref wbr w3a cA cB ssun1 a1i cB cC wcel
      cX cY wceq cA cB cref wbr w3a cX cX cun cX cY cun cX cA cuni cB cuni cun
      cX cY wceq cB cC wcel cX cX cun cX cY cun wceq cA cB cref wbr cX cY cX
      uneq2 3ad2ant2 cX unidm cX cA cuni cY cB cuni refssfne.1 refssfne.2
      uneq12i 3eqtr3g syl3anc cB cC wcel cX cY wceq cA cB cref wbr w3a cA cA cB
      cun cref wbr cX cA cuni cB cuni cun wceq vx cv vy cv wss vy cA wrex vx cA
      cB cun wral wa cB cC wcel cX cY wceq cA cB cref wbr w3a cX cA cuni cB
      cuni cun wceq vx cv vy cv wss vy cA wrex vx cA cB cun wral cB cC wcel cX
      cY wceq cA cB cref wbr w3a cX cX cun cX cY cun cX cA cuni cB cuni cun cX
      cY wceq cB cC wcel cX cX cun cX cY cun wceq cA cB cref wbr cX cY cX uneq2
      3ad2ant2 cX unidm cX cA cuni cY cB cuni refssfne.1 refssfne.2 uneq12i
      3eqtr3g cB cC wcel cX cY wceq cA cB cref wbr w3a vx cv vy cv wss vy cA
      wrex vx cA cB cun cB cC wcel cX cY wceq cA cB cref wbr w3a vx cv cA wcel
      vx cv cB wcel wo vx cv vy cv wss vy cA wrex vx cv cA cB cun wcel cB cC
      wcel cX cY wceq cA cB cref wbr w3a vx cv cA wcel vx cv vy cv wss vy cA
      wrex vx cv cB wcel vx cv cA wcel vx cv vy cv wss vy cA wrex wi cB cC wcel
      cX cY wceq cA cB cref wbr w3a vx cv cA wcel vx cv vx cv wss vx cv vy cv
      wss vy cA wrex vx cv ssid vx cv vy cv wss vx cv vx cv wss vy vx cv cA vy
      cv vx cv vx cv sseq2 rcla4ev mpan2 a1i cB cC wcel cA cB cref wbr vx cv cB
      wcel vx cv vy cv wss vy cA wrex wi cX cY wceq cB cC wcel cA cB cref wbr
      vx cv cB wcel vx cv vy cv wss vy cA wrex vy cA cB cC vx cv refssex 3expia
      3adant2 jaod vx cv cA cB elun syl5ib r19.21aiv jca cB cC wcel cX cY wceq
      cA cB cref wbr w3a cA cB cun cvv wcel cA cA cB cun cref wbr cX cA cuni cB
      cuni cun wceq vx cv vy cv wss vy cA wrex vx cA cB cun wral wa wb cA cvv
      wcel cB cC wcel cA cB cun cvv wcel cB cC wcel cX cY wceq cA cB cref wbr
      w3a cA cB cvv cC unexg cA cB cref wbr cB cC wcel cA cvv wcel cX cY wceq
      cA cB cref refrel brrelexi 3ad2ant3 cB cC wcel cX cY wceq cA cB cref wbr
      3simp1 sylanc vx vy cA cA cB cun cvv cX cA cuni cB cuni cun refssfne.1 cA
      cB cun cuni cA cuni cB cuni cun cA cB uniun eqcomi isref syl mpbird jca
      cA cA cB cun cfne cref int2rel sylibr cB cA ssun2 jctil sylc 3expia cB cC
      wcel cX cY wceq wa cB vc cv wss cA vc cv cfne cref cin wbr wa cA cB cref
      wbr vc cB cC wcel cX cY wceq wa cB vc cv wss cA vc cv cfne cref cin wbr
      wa cA cB cref wbr cB cC wcel cA vc cv cref wbr vc cv cB cref wbr cA cB
      cref wbr cB cC wcel cX cY wceq wa cB vc cv wss cA vc cv cfne cref cin wbr
      wa wa cA vc cv cB cC reftr cB cC wcel cX cY wceq cB vc cv wss cA vc cv
      cfne cref cin wbr wa simpll cA vc cv cfne cref cin wbr cA vc cv cref wbr
      cB cC wcel cX cY wceq wa cB vc cv wss cA vc cv cfne cref cin wbr cA vc cv
      cfne wbr cA vc cv cref wbr cA vc cv cfne cref int2rel pm3.27bi ad2antll
      cB cC wcel cB vc cv wss cY vc cv cuni wceq vc cv cB cref wbr cB cC wcel
      cX cY wceq wa cB vc cv wss cA vc cv cfne cref cin wbr wa wa cB vc cv cC
      cY vc cv cuni refssfne.2 vc cv cuni eqid ssref cB cC wcel cX cY wceq cB
      vc cv wss cA vc cv cfne cref cin wbr wa simpll cB cC wcel cX cY wceq wa
      cB vc cv wss cA vc cv cfne cref cin wbr simprl cB cC wcel cX cY wceq wa
      cB vc cv wss cA vc cv cfne cref cin wbr wa wa cY cX vc cv cuni cX cY wceq
      cY cX wceq cB cC wcel cB vc cv wss cA vc cv cfne cref cin wbr wa cX cY
      wceq cY cX wceq cX cY eqcom biimpi ad2antlr cA vc cv cfne cref cin wbr cX
      vc cv cuni wceq cB cC wcel cX cY wceq wa cB vc cv wss cA vc cv cfne cref
      cin wbr cA vc cv cref wbr cX vc cv cuni wceq cA vc cv cfne cref cin wbr
      cA vc cv cfne wbr cA vc cv cref wbr cA vc cv cfne cref int2rel pm3.27bi
      vc cv cvv wcel cA vc cv cref wbr cX vc cv cuni wceq vc visset cA vc cv
      cvv cX vc cv cuni refssfne.1 vc cv cuni eqid refbas mpan syl ad2antll
      eqtrd syl3anc syl3anc ex 19.23adv impbid $.
      $( [18-Jan-2010] $) $( [18-Jan-2010] $)
  $}

  ${
    $d a x y A $. $d a B $. $d a x X $.
    isptfin.1 $e |- X = U. A $.
    $( The statement "is a point-finite cover." $)
    isptfin $p |- ( A e. B -> ( A e. PtFin <-> A. x e. X { y e. A | x e. y }
    e. Fin ) ) $=
      vx cv vy cv wcel vy va cv crab cfn wcel vx va cv cuni wral vx cv vy cv
      wcel vy cA crab cfn wcel vx cX wral va cA cptfin cB va cv cA wceq vx cv
      vy cv wcel vy va cv crab cfn wcel vx cv vy cv wcel vy cA crab cfn wcel vx
      va cv cuni cX va cv cA wceq va cv cuni cA cuni cX va cv cA unieq
      isptfin.1 syl6eqr va cv cA wceq vx cv vy cv wcel vy va cv crab vx cv vy
      cv wcel vy cA crab cfn vx cv vy cv wcel vy va cv cA rabeq eleq1d raleq12d
      va vx vy df-ptfin elab2g $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d a j n s x A $. $d a j n s x B $. $d a j n s x J $. $d a j n s x X $. $d
    a j n s x Y $.
    islocfin.1 $e |- X = U. J $.
    islocfin.2 $e |- Y = U. A $.
    $( The statement "is a locally finite cover." $)
    islocfin $p |- ( A e. B -> ( <. J , A >. e. LocFin <-> ( J e. Top /\ X = Y
    /\ A. x e. X E. n e. ( ( nei ` J ) ` { x } ) { s e. A | ( s i^i n ) =/= (/)
    } e. Fin ) ) ) $=
      cA cB wcel cJ cA cop clocfin wcel cJ ctop wcel cX cY wceq vs cv vn cv cin
      c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX wral
      w3a cJ cvv wcel cA cB wcel wa cA cB wcel cJ cA cop clocfin wcel wa cJ cvv
      wcel cA cB wcel cJ cA cop clocfin wcel cJ cvv wcel cA cB wcel cJ cA cop
      clocfin wcel cJ cA clocfin wbr cJ cvv wcel cJ cA clocfin df-br cJ cA
      clocfin clocfin wrel vj cv ctop wcel vj cv cuni va cv cuni wceq vs cv vn
      cv cin c0 wne vs va cv crab cfn wcel vn vx cv csn vj cv cnei cfv cfv wrex
      vx vj cv cuni wral w3a vj va copab wrel vj cv ctop wcel vj cv cuni va cv
      cuni wceq vs cv vn cv cin c0 wne vs va cv crab cfn wcel vn vx cv csn vj
      cv cnei cfv cfv wrex vx vj cv cuni wral w3a vj va relopab clocfin vj cv
      ctop wcel vj cv cuni va cv cuni wceq vs cv vn cv cin c0 wne vs va cv crab
      cfn wcel vn vx cv csn vj cv cnei cfv cfv wrex vx vj cv cuni wral w3a vj
      va copab vj va vn vs vx df-locfin releqi mpbir brrelexi sylbir adantl cA
      cB wcel cJ cA cop clocfin wcel pm3.26 jca cA cB wcel cJ ctop wcel cX cY
      wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv
      cfv wrex vx cX wral w3a wa cJ cvv wcel cA cB wcel cJ ctop wcel cX cY wceq
      vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv
      wrex vx cX wral w3a cJ cvv wcel cA cB wcel cJ ctop wcel cX cY wceq cJ cvv
      wcel vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv
      cfv wrex vx cX wral cJ ctop elisset 3ad2ant1 adantl cA cB wcel cJ ctop
      wcel cX cY wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn
      cJ cnei cfv cfv wrex vx cX wral w3a pm3.26 jca cJ cvv wcel cA cB wcel wa
      cJ cA cop vj cv ctop wcel vj cv cuni va cv cuni wceq vs cv vn cv cin c0
      wne vs va cv crab cfn wcel vn vx cv csn vj cv cnei cfv cfv wrex vx vj cv
      cuni wral w3a vj va copab wcel cJ ctop wcel cX cY wceq vs cv vn cv cin c0
      wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX wral w3a
      cJ cA cop clocfin wcel vj cv ctop wcel vj cv cuni va cv cuni wceq vs cv
      vn cv cin c0 wne vs va cv crab cfn wcel vn vx cv csn vj cv cnei cfv cfv
      wrex vx vj cv cuni wral w3a cJ ctop wcel cX va cv cuni wceq vs cv vn cv
      cin c0 wne vs va cv crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX
      wral w3a cJ ctop wcel cX cY wceq vs cv vn cv cin c0 wne vs cA crab cfn
      wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX wral w3a vj va cJ cA cvv cB
      vj cv cJ wceq vj cv ctop wcel cJ ctop wcel vj cv cuni va cv cuni wceq cX
      va cv cuni wceq vs cv vn cv cin c0 wne vs va cv crab cfn wcel vn vx cv
      csn vj cv cnei cfv cfv wrex vx vj cv cuni wral vs cv vn cv cin c0 wne vs
      va cv crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX wral vj cv cJ
      ctop eleq1 vj cv cJ wceq vj cv cuni cX va cv cuni vj cv cJ wceq vj cv
      cuni cJ cuni cX vj cv cJ unieq islocfin.1 syl6eqr eqeq1d vj cv cJ wceq vs
      cv vn cv cin c0 wne vs va cv crab cfn wcel vn vx cv csn vj cv cnei cfv
      cfv wrex vs cv vn cv cin c0 wne vs va cv crab cfn wcel vn vx cv csn cJ
      cnei cfv cfv wrex vx vj cv cuni cX vj cv cJ wceq vj cv cuni cJ cuni cX vj
      cv cJ unieq islocfin.1 syl6eqr vj cv cJ wceq vs cv vn cv cin c0 wne vs va
      cv crab cfn wcel vn vx cv csn vj cv cnei cfv cfv vx cv csn cJ cnei cfv
      cfv vj cv cJ wceq vx cv csn vj cv cnei cfv cJ cnei cfv vj cv cJ cnei
      fveq2 fveq1d rexeq1d raleq12d 3anbi123d va cv cA wceq cX va cv cuni wceq
      cX cY wceq vs cv vn cv cin c0 wne vs va cv crab cfn wcel vn vx cv csn cJ
      cnei cfv cfv wrex vx cX wral vs cv vn cv cin c0 wne vs cA crab cfn wcel
      vn vx cv csn cJ cnei cfv cfv wrex vx cX wral cJ ctop wcel va cv cA wceq
      va cv cuni cY cX va cv cA wceq va cv cuni cA cuni cY va cv cA unieq
      islocfin.2 syl6eqr eqeq2d va cv cA wceq vs cv vn cv cin c0 wne vs va cv
      crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vs cv vn cv cin c0 wne vs
      cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX va cv cA wceq vs
      cv vn cv cin c0 wne vs va cv crab cfn wcel vs cv vn cv cin c0 wne vs cA
      crab cfn wcel vn vx cv csn cJ cnei cfv cfv va cv cA wceq vs cv vn cv cin
      c0 wne vs va cv crab vs cv vn cv cin c0 wne vs cA crab cfn vs cv vn cv
      cin c0 wne vs va cv cA rabeq eleq1d rexbidv ralbidv 3anbi23d opelopabg
      clocfin vj cv ctop wcel vj cv cuni va cv cuni wceq vs cv vn cv cin c0 wne
      vs va cv crab cfn wcel vn vx cv csn vj cv cnei cfv cfv wrex vx vj cv cuni
      wral w3a vj va copab cJ cA cop vj va vn vs vx df-locfin eleq2i syl5bb
      pm5.21nd $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d x y A $.
    $( A finite cover is a point-finite cover. $)
    finptfin $p |- ( A e. Fin -> A e. PtFin ) $=
      cA cfn wcel cA cptfin wcel vx cv vy cv wcel vy cA crab cfn wcel vx cA
      cuni wral cA cfn wcel vx cv vy cv wcel vy cA crab cfn wcel vx cA cuni cA
      cfn wcel vx cv vy cv wcel vy cA crab cfn wcel vx cv cA cuni wcel cA cfn
      wcel vx cv vy cv wcel vy cA crab cA wss vx cv vy cv wcel vy cA crab cfn
      wcel vx cv vy cv wcel vy cA ssrab2 cA vx cv vy cv wcel vy cA crab ssfi
      mpan2 a1d r19.21aiv vx vy cA cfn cA cuni cA cuni eqid isptfin mpbird $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d p x A $. $d p x P $. $d p x X $.
    ptfinfin.1 $e |- X = U. A $.
    $( A point covered by a point-finite cover is only covered by finitely many
       elements. $)
    ptfinfin $p |- ( ( A e. PtFin /\ P e. X ) -> { x e. A | P e. x } e. Fin )
    $=
      cA cptfin wcel cP cX wcel cP vx cv wcel vx cA crab cfn wcel cA cptfin
      wcel vp cv vx cv wcel vx cA crab cfn wcel vp cX wral cP cX wcel cP vx cv
      wcel vx cA crab cfn wcel wi cA cptfin wcel vp cv vx cv wcel vx cA crab
      cfn wcel vp cX wral vp vx cA cptfin cX ptfinfin.1 isptfin ibi vp cv vx cv
      wcel vx cA crab cfn wcel cP vx cv wcel vx cA crab cfn wcel vp cP cX vp cv
      cP wceq vp cv vx cv wcel vx cA crab cP vx cv wcel vx cA crab cfn vp cv cP
      wceq vp cv vx cv wcel cP vx cv wcel vx cA vp cv cP vx cv eleq1 rabbisdv
      eleq1d rcla4cv syl imp $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d n s x A $. $d n s x J $. $d n s x X $. $d n s x Y $.
    finlocfin.1 $e |- X = U. J $.
    finlocfin.2 $e |- Y = U. A $.
    $( A finite cover of a topological space is a locally finite cover. $)
    finlocfin $p |- ( ( J e. Top /\ A e. Fin /\ X = Y ) -> <. J , A >. e.
    LocFin ) $=
      cJ ctop wcel cA cfn wcel cX cY wceq w3a cJ cA cop clocfin wcel cJ ctop
      wcel cX cY wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn
      cJ cnei cfv cfv wrex vx cX wral w3a cJ ctop wcel cA cfn wcel cX cY wceq
      w3a cJ ctop wcel cX cY wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn
      vx cv csn cJ cnei cfv cfv wrex vx cX wral cJ ctop wcel cA cfn wcel cX cY
      wceq 3simp1 cJ ctop wcel cA cfn wcel cX cY wceq 3simp3 cJ ctop wcel cA
      cfn wcel cX cY wceq w3a vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx
      cv csn cJ cnei cfv cfv wrex vx cX cJ ctop wcel cA cfn wcel cX cY wceq w3a
      vx cv cX wcel vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ
      cnei cfv cfv wrex cX vx cv csn cJ cnei cfv cfv wcel vs cv cX cin c0 wne
      vs cA crab cfn wcel vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv
      csn cJ cnei cfv cfv wrex cJ ctop wcel cA cfn wcel cX cY wceq w3a vx cv cX
      wcel wa vs cv vn cv cin c0 wne vs cA crab cfn wcel vs cv cX cin c0 wne vs
      cA crab cfn wcel vn cX vx cv csn cJ cnei cfv cfv vn cv cX wceq vs cv vn
      cv cin c0 wne vs cA crab vs cv cX cin c0 wne vs cA crab cfn vn cv cX wceq
      vs cv vn cv cin c0 wne vs cv cX cin c0 wne vs cA vn cv cX wceq vs cv vn
      cv cin vs cv cX cin c0 vn cv cX vs cv ineq2 neeq1d rabbisdv eleq1d
      rcla4ev cJ ctop wcel cA cfn wcel vx cv cX wcel cX vx cv csn cJ cnei cfv
      cfv wcel cX cY wceq cJ ctop wcel cX cJ wcel vx cv cX wcel cX vx cv csn cJ
      cnei cfv cfv wcel cJ ctop wcel vx cv cX wcel wa vx cv cJ cX opnneip cJ
      ctop wcel vx cv cX wcel pm3.26 cJ ctop wcel cX cJ wcel vx cv cX wcel cJ
      cX finlocfin.1 topopn adantr cJ ctop wcel vx cv cX wcel pm3.27 syl3anc
      3ad2antl1 cJ ctop wcel cA cfn wcel cX cY wceq w3a vs cv cX cin c0 wne vs
      cA crab cfn wcel vx cv cX wcel cA cfn wcel cJ ctop wcel vs cv cX cin c0
      wne vs cA crab cfn wcel cX cY wceq cA cfn wcel vs cv cX cin c0 wne vs cA
      crab cA wss vs cv cX cin c0 wne vs cA crab cfn wcel vs cv cX cin c0 wne
      vs cA ssrab2 cA vs cv cX cin c0 wne vs cA crab ssfi mpan2 3ad2ant2 adantr
      sylanc ex r19.21aiv 3jca cA cfn wcel cJ ctop wcel cJ cA cop clocfin wcel
      cJ ctop wcel cX cY wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx
      cv csn cJ cnei cfv cfv wrex vx cX wral w3a wb cX cY wceq vx cA cfn vn cJ
      cX cY vs finlocfin.1 finlocfin.2 islocfin 3ad2ant2 mpbird $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d n s x A $. $d n s x B $. $d n s x J $.
    $( A locally finite cover covers a topological space. $)
    locfintop $p |- ( ( A e. B /\ <. J , A >. e. LocFin ) -> J e. Top ) $=
      cA cB wcel cJ cA cop clocfin wcel wa cJ ctop wcel cJ cuni cA cuni wceq vs
      cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex
      vx cJ cuni wral cA cB wcel cJ cA cop clocfin wcel cJ ctop wcel cJ cuni cA
      cuni wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei
      cfv cfv wrex vx cJ cuni wral w3a vx cA cB vn cJ cJ cuni cA cuni vs cJ
      cuni eqid cA cuni eqid islocfin biimpa 3simp1d $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d n s x A $. $d n s x B $. $d n s x J $. $d n s x X $. $d n s x Y $.
    locfinbas.1 $e |- X = U. J $.
    locfinbas.2 $e |- Y = U. A $.
    $( A locally finite cover must cover the base set of its corresponding
       topological space. $)
    locfinbas $p |- ( ( A e. B /\ <. J , A >. e. LocFin ) -> X = Y ) $=
      cA cB wcel cJ cA cop clocfin wcel wa cJ ctop wcel cX cY wceq vs cv vn cv
      cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX
      wral cA cB wcel cJ cA cop clocfin wcel cJ ctop wcel cX cY wceq vs cv vn
      cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cX
      wral w3a vx cA cB vn cJ cX cY vs locfinbas.1 locfinbas.2 islocfin biimpa
      3simp2d $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d n p s A $. $d n p s B $. $d n p s J $. $d n p s P $. $d n p s X $.
    locfinnei.1 $e |- X = U. J $.
    $( A point covered by a locally finite cover has a neighborhood which
       intersects only finitely many elements of the cover. $)
    locfinnei $p |- ( ( A e. B /\ <. J , A >. e. LocFin /\ P e. X ) -> E. n e.
    ( ( nei ` J ) ` { P } ) { s e. A | ( s i^i n ) =/= (/) } e. Fin ) $=
      cA cB wcel cJ cA cop clocfin wcel cP cX wcel vs cv vn cv cin c0 wne vs cA
      crab cfn wcel vn cP csn cJ cnei cfv cfv wrex cA cB wcel cJ cA cop clocfin
      wcel wa vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vp cv csn cJ cnei
      cfv cfv wrex vp cX wral cP cX wcel vs cv vn cv cin c0 wne vs cA crab cfn
      wcel vn cP csn cJ cnei cfv cfv wrex wi cA cB wcel cJ cA cop clocfin wcel
      wa cJ ctop wcel cX cA cuni wceq vs cv vn cv cin c0 wne vs cA crab cfn
      wcel vn vp cv csn cJ cnei cfv cfv wrex vp cX wral cA cB wcel cJ cA cop
      clocfin wcel cJ ctop wcel cX cA cuni wceq vs cv vn cv cin c0 wne vs cA
      crab cfn wcel vn vp cv csn cJ cnei cfv cfv wrex vp cX wral w3a vp cA cB
      vn cJ cX cA cuni vs locfinnei.1 cA cuni eqid islocfin biimpa 3simp3d vs
      cv vn cv cin c0 wne vs cA crab cfn wcel vn vp cv csn cJ cnei cfv cfv wrex
      vs cv vn cv cin c0 wne vs cA crab cfn wcel vn cP csn cJ cnei cfv cfv wrex
      vp cP cX vp cv cP wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vp
      cv csn cJ cnei cfv cfv cP csn cJ cnei cfv cfv vp cv cP wceq vp cv csn cP
      csn cJ cnei cfv vp cv cP sneq fveq2d rexeq1d rcla4cv syl 3impia $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d n s x A $. $d n s x B $. $d n s x J $.
    $( A locally finite cover is point-finite. $)
    lfinpfin $p |- ( ( A e. B /\ <. J , A >. e. LocFin ) -> A e. PtFin ) $=
      cA cB wcel cJ cA cop clocfin wcel cA cptfin wcel cA cB wcel cJ ctop wcel
      cJ cuni cA cuni wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv
      csn cJ cnei cfv cfv wrex vx cJ cuni wral w3a vx cv vs cv wcel vs cA crab
      cfn wcel vx cA cuni wral cJ cA cop clocfin wcel cA cptfin wcel cA cB wcel
      cJ ctop wcel cJ cuni cA cuni wceq vs cv vn cv cin c0 wne vs cA crab cfn
      wcel vn vx cv csn cJ cnei cfv cfv wrex vx cJ cuni wral vx cv vs cv wcel
      vs cA crab cfn wcel vx cA cuni wral cA cB wcel cJ ctop wcel cJ cuni cA
      cuni wceq vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei
      cfv cfv wrex vx cJ cuni wral vx cv vs cv wcel vs cA crab cfn wcel vx cA
      cuni wral wi cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vs cv vn cv
      cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex vx cv vs
      cv wcel vs cA crab cfn wcel vx cJ cuni cA cuni cA cB wcel cJ ctop wcel cJ
      cuni cA cuni wceq w3a vx cv cA cuni wcel vx cv cJ cuni wcel vs cv vn cv
      cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex wi vx cv
      vs cv wcel vs cA crab cfn wcel cA cB wcel cJ ctop wcel cJ cuni cA cuni
      wceq w3a vx cv cA cuni wcel vx cv cJ cuni wcel vs cv vn cv cin c0 wne vs
      cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex wi vx cv vs cv wcel vs
      cA crab cfn wcel wi cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx
      cv cA cuni wcel wa vx cv cJ cuni wcel vs cv vn cv cin c0 wne vs cA crab
      cfn wcel vn vx cv csn cJ cnei cfv cfv wrex wi vx cv cJ cuni wcel vx cv vs
      cv wcel vs cA crab cfn wcel cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq
      w3a vx cv cJ cuni wcel vx cv cA cuni wcel cA cB wcel cJ ctop wcel cJ cuni
      cA cuni wceq w3a cJ cuni cA cuni vx cv cA cB wcel cJ ctop wcel cJ cuni cA
      cuni wceq 3simp3 eleq2d biimpar cA cB wcel cJ ctop wcel cJ cuni cA cuni
      wceq w3a vx cv cA cuni wcel wa vs cv vn cv cin c0 wne vs cA crab cfn wcel
      vn vx cv csn cJ cnei cfv cfv wrex vx cv vs cv wcel vs cA crab cfn wcel vx
      cv cJ cuni wcel cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx cv cA
      cuni wcel wa vs cv vn cv cin c0 wne vs cA crab cfn wcel vx cv vs cv wcel
      vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv cA cB wcel cJ ctop wcel
      cJ cuni cA cuni wceq w3a vx cv cA cuni wcel vn cv vx cv csn cJ cnei cfv
      cfv wcel vs cv vn cv cin c0 wne vs cA crab cfn wcel vx cv vs cv wcel vs
      cA crab cfn wcel wi cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx
      cv cA cuni wcel vn cv vx cv csn cJ cnei cfv cfv wcel wa wa vx cv vs cv
      wcel vs cA crab vs cv vn cv cin c0 wne vs cA crab wss vs cv vn cv cin c0
      wne vs cA crab cfn wcel vx cv vs cv wcel vs cA crab cfn wcel wi cA cB
      wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx cv cA cuni wcel vn cv vx cv
      csn cJ cnei cfv cfv wcel wa wa vx cv vs cv wcel vs cv vn cv cin c0 wne wi
      vs cA wral vx cv vs cv wcel vs cA crab vs cv vn cv cin c0 wne vs cA crab
      wss cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx cv cA cuni wcel
      vn cv vx cv csn cJ cnei cfv cfv wcel wa wa vx cv vs cv wcel vs cv vn cv
      cin c0 wne wi vs cA cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx
      cv cA cuni wcel vn cv vx cv csn cJ cnei cfv cfv wcel wa wa vs cv cA wcel
      vx cv vs cv wcel vs cv vn cv cin c0 wne cA cB wcel cJ ctop wcel cJ cuni
      cA cuni wceq w3a vx cv cA cuni wcel vn cv vx cv csn cJ cnei cfv cfv wcel
      wa wa vs cv cA wcel vx cv vs cv wcel wa wa vx cv vs cv vn cv cin wcel vs
      cv vn cv cin c0 wne cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx
      cv cA cuni wcel vn cv vx cv csn cJ cnei cfv cfv wcel wa wa vs cv cA wcel
      vx cv vs cv wcel wa wa vx cv vs cv wcel vx cv vn cv wcel wa vx cv vs cv
      vn cv cin wcel cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx cv cA
      cuni wcel vn cv vx cv csn cJ cnei cfv cfv wcel wa wa vs cv cA wcel vx cv
      vs cv wcel wa wa vx cv vs cv wcel vx cv vn cv wcel cA cB wcel cJ ctop
      wcel cJ cuni cA cuni wceq w3a vx cv cA cuni wcel vn cv vx cv csn cJ cnei
      cfv cfv wcel wa wa vs cv cA wcel vx cv vs cv wcel simprr cA cB wcel cJ
      ctop wcel cJ cuni cA cuni wceq w3a vx cv cA cuni wcel vn cv vx cv csn cJ
      cnei cfv cfv wcel wa wa vx cv vn cv wcel vs cv cA wcel vx cv vs cv wcel
      wa cJ ctop wcel vx cv cvv wcel vn cv vx cv csn cJ cnei cfv cfv wcel vx cv
      vn cv wcel cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq w3a vx cv cA cuni
      wcel vn cv vx cv csn cJ cnei cfv cfv wcel wa wa cvv vx cv cJ vn cv elnei
      cA cB wcel cJ ctop wcel cJ cuni cA cuni wceq vx cv cA cuni wcel vn cv vx
      cv csn cJ cnei cfv cfv wcel wa 3simpl2 vx cv cvv wcel cA cB wcel cJ ctop
      wcel cJ cuni cA cuni wceq w3a vx cv cA cuni wcel vn cv vx cv csn cJ cnei
      cfv cfv wcel wa wa vx visset a1i cA cB wcel cJ ctop wcel cJ cuni cA cuni
      wceq w3a vx cv cA cuni wcel vn cv vx cv csn cJ cnei cfv cfv wcel simprr
      syl3anc adantr jca vx cv vs cv vn cv elin sylibr vs cv vn cv cin vx cv
      ne0i syl exp32 r19.21aiv vx cv vs cv wcel vs cv vn cv cin c0 wne vs cA
      ss2rab sylibr vs cv vn cv cin c0 wne vs cA crab cfn wcel vx cv vs cv wcel
      vs cA crab vs cv vn cv cin c0 wne vs cA crab wss vx cv vs cv wcel vs cA
      crab cfn wcel vs cv vn cv cin c0 wne vs cA crab vx cv vs cv wcel vs cA
      crab ssfi expcom syl expr r19.23adv imim2d mpid ex com23 r19.20dv2 3exp
      3impd vx cA cB vn cJ cJ cuni cA cuni vs cJ cuni eqid cA cuni eqid
      islocfin vx vs cA cB cA cuni cA cuni eqid isptfin 3imtr4d imp $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

  ${
    $d c d n o p s x A $. $d c d n o p s x C $. $d c d n o p s x J $. $d c d n
    o p s x X $. $d c d n o p s x Y $.
    locfincomp.1 $e |- X = U. J $.
    locfincomp.2 $e |- Y = U. C $.
    $( For a compact space, the locally finite covers are precisely the finite
       covers. Sadly, this property does not properly characterize all compact
       spaces. $)
    locfincomp $p |- ( ( J e. Comp /\ C e. A ) -> ( <. J , C >. e. LocFin <-> (
    C e. Fin /\ X = Y ) ) ) $=
      cJ ccomp wcel cC cA wcel wa cJ cC cop clocfin wcel cC cfn wcel cX cY wceq
      wa cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel cC cfn wcel cX cY wceq
      wa cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a cC cfn wcel cX cY
      wceq cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a cX vc cv cuni
      wceq vc vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin
      wrex cC cfn wcel cJ ccomp wcel vs cv vo cv cin c0 wne vs cC crab cfn wcel
      vo cJ crab cJ wss cX vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cuni wceq cX vc cv cuni wceq vc vs cv vo cv cin c0 wne vs cC crab
      cfn wcel vo cJ crab cpw cfn cin wrex cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cJ
      cX vc locfincomp.1 compcov cJ ccomp wcel cC cA wcel cJ cC cop clocfin
      wcel 3simp1 vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cJ wss
      cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vs cv vo cv cin c0
      wne vs cC crab cfn wcel vo cJ ssrab2 a1i cJ ccomp wcel cC cA wcel cJ cC
      cop clocfin wcel w3a cX vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cuni cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vx cX vs cv
      vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cuni cJ ccomp wcel cC cA
      wcel cJ cC cop clocfin wcel w3a vx cv cX wcel vx cv vo cv wcel vs cv vo
      cv cin c0 wne vs cC crab cfn wcel wa vo cJ wrex vx cv vs cv vo cv cin c0
      wne vs cC crab cfn wcel vo cJ crab cuni wcel cJ ccomp wcel cC cA wcel cJ
      cC cop clocfin wcel w3a vx cv cX wcel vx cv vo cv wcel vs cv vo cv cin c0
      wne vs cC crab cfn wcel wa vo cJ wrex cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a vx cv cX wcel wa vs cv vn cv cin c0 wne vs cC crab cfn
      wcel vn vx cv csn cJ cnei cfv cfv wrex vx cv vo cv wcel vs cv vo cv cin
      c0 wne vs cC crab cfn wcel wa vo cJ wrex cC cA wcel cJ cC cop clocfin
      wcel vx cv cX wcel vs cv vn cv cin c0 wne vs cC crab cfn wcel vn vx cv
      csn cJ cnei cfv cfv wrex cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel
      w3a vx cv cX wcel wa cC cA vx cv vn cJ cX vs locfincomp.1 locfinnei cJ
      ccomp wcel cC cA wcel cJ cC cop clocfin wcel vx cv cX wcel 3simpl2 cJ
      ccomp wcel cC cA wcel cJ cC cop clocfin wcel vx cv cX wcel 3simpl3 cJ
      ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel pm3.27
      syl3anc cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel
      wa vs cv vn cv cin c0 wne vs cC crab cfn wcel vx cv vo cv wcel vs cv vo
      cv cin c0 wne vs cC crab cfn wcel wa vo cJ wrex vn vx cv csn cJ cnei cfv
      cfv cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel wa
      vn cv vx cv csn cJ cnei cfv cfv wcel vx cv csn vo cv wss vo cv vn cv wss
      wa vo cJ wrex vs cv vn cv cin c0 wne vs cC crab cfn wcel vx cv vo cv wcel
      vs cv vo cv cin c0 wne vs cC crab cfn wcel wa vo cJ wrex wi cJ ccomp wcel
      cC cA wcel cJ cC cop clocfin wcel w3a vn cv vx cv csn cJ cnei cfv cfv
      wcel vx cv csn vo cv wss vo cv vn cv wss wa vo cJ wrex wi vx cv cX wcel
      cJ ccomp wcel cC cA wcel vn cv vx cv csn cJ cnei cfv cfv wcel vx cv csn
      vo cv wss vo cv vn cv wss wa vo cJ wrex wi cJ cC cop clocfin wcel cJ
      ccomp wcel cJ ctop wcel vn cv vx cv csn cJ cnei cfv cfv wcel vx cv csn vo
      cv wss vo cv vn cv wss wa vo cJ wrex wi cJ comptop cJ ctop wcel vn cv vx
      cv csn cJ cnei cfv cfv wcel vx cv csn vo cv wss vo cv vn cv wss wa vo cJ
      wrex vx cv csn vo cJ vn cv neii2 ex syl 3ad2ant1 adantr cJ ccomp wcel cC
      cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel wa vs cv vn cv cin c0
      wne vs cC crab cfn wcel vx cv csn vo cv wss vo cv vn cv wss wa vo cJ wrex
      vx cv vo cv wcel vs cv vo cv cin c0 wne vs cC crab cfn wcel wa vo cJ wrex
      cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel vs cv
      vn cv cin c0 wne vs cC crab cfn wcel vx cv csn vo cv wss vo cv vn cv wss
      wa vo cJ wrex vx cv vo cv wcel vs cv vo cv cin c0 wne vs cC crab cfn wcel
      wa vo cJ wrex wi cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vx
      cv cX wcel vs cv vn cv cin c0 wne vs cC crab cfn wcel wa wa vx cv csn vo
      cv wss vo cv vn cv wss wa vx cv vo cv wcel vs cv vo cv cin c0 wne vs cC
      crab cfn wcel wa vo cJ cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel
      w3a vx cv cX wcel vs cv vn cv cin c0 wne vs cC crab cfn wcel wa wa vx cv
      csn vo cv wss vx cv vo cv wcel vo cv vn cv wss vs cv vo cv cin c0 wne vs
      cC crab cfn wcel vx cv csn vo cv wss vx cv vo cv wcel wi cJ ccomp wcel cC
      cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel vs cv vn cv cin c0 wne
      vs cC crab cfn wcel wa wa vx cv vo cv wcel vx cv csn vo cv wss vx cv vo
      cv vx visset snss biimpri a1i vs cv vn cv cin c0 wne vs cC crab cfn wcel
      vo cv vn cv wss vs cv vo cv cin c0 wne vs cC crab cfn wcel wi cJ ccomp
      wcel cC cA wcel cJ cC cop clocfin wcel w3a vx cv cX wcel vs cv vn cv cin
      c0 wne vs cC crab cfn wcel vs cv vo cv cin c0 wne vs cC crab vs cv vn cv
      cin c0 wne vs cC crab wss vs cv vo cv cin c0 wne vs cC crab cfn wcel vo
      cv vn cv wss vs cv vn cv cin c0 wne vs cC crab cfn wcel vs cv vo cv cin
      c0 wne vs cC crab vs cv vn cv cin c0 wne vs cC crab wss vs cv vo cv cin
      c0 wne vs cC crab cfn wcel vs cv vn cv cin c0 wne vs cC crab vs cv vo cv
      cin c0 wne vs cC crab ssfi ex vo cv vn cv wss vs cv vo cv cin c0 wne vs
      cv vn cv cin c0 wne wi vs cC wral vs cv vo cv cin c0 wne vs cC crab vs cv
      vn cv cin c0 wne vs cC crab wss vo cv vn cv wss vs cv vo cv cin c0 wne vs
      cv vn cv cin c0 wne wi vs cC vo cv vn cv wss vs cv vo cv cin c0 wne vs cv
      vn cv cin c0 wne wi vs cv cC wcel vo cv vn cv wss vs cv vo cv cin vs cv
      vn cv cin wss vs cv vo cv cin c0 wne vs cv vn cv cin c0 wne wi vo cv vn
      cv vs cv sslin vs cv vo cv cin vs cv vn cv cin wss vs cv vo cv cin c0 wne
      vs cv vn cv cin c0 wne vs cv vo cv cin vs cv vn cv cin ssn0 ex syl a1d
      r19.21aiv vs cv vo cv cin c0 wne vs cv vn cv cin c0 wne vs cC ss2rab
      sylibr syl5 ad2antll anim12d r19.22sdv expr com23 syld r19.23adv mpd ex
      vs cv vo cv cin c0 wne vs cC crab cfn wcel vo vx cv cJ elunirab syl6ibr
      ssrdv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cuni cX wss
      cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vs cv vo cv cin c0
      wne vs cC crab cfn wcel vo cJ crab cuni cJ cuni cX vs cv vo cv cin c0 wne
      vs cC crab cfn wcel vo cJ crab cJ wss vs cv vo cv cin c0 wne vs cC crab
      cfn wcel vo cJ crab cuni cJ cuni wss vs cv vo cv cin c0 wne vs cC crab
      cfn wcel vo cJ ssrab2 vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cJ uniss ax-mp locfincomp.1 sseqtr4i a1i eqssd syl3anc cJ ccomp wcel
      cC cA wcel cJ cC cop clocfin wcel w3a cX vc cv cuni wceq cC cfn wcel vc
      vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin cJ
      ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0
      wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq cC
      cfn wcel cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv
      vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv
      cuni wceq wa wa cC c0 csn cdif cfn wcel cC c0 csn cdif c0 csn cun cfn
      wcel cC cfn wcel cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc
      cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel
      cX vc cv cuni wceq wa wa cC c0 csn cdif vd vc cv vs cv vd cv cin c0 wne
      vs cC crab ciun cfn cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a
      vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin
      wcel cX vc cv cuni wceq wa wa cC c0 csn cdif vd vc cv vs cv vd cv cin c0
      wne vs cC crab ciun cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a
      vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin
      wcel cX vc cv cuni wceq wa wa vp cC c0 csn cdif vd vc cv vs cv vd cv cin
      c0 wne vs cC crab ciun cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel
      w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn
      cin wcel cX vc cv cuni wceq wa wa vp cv cC wcel vp cv c0 wceq wn wa vp cv
      vd vc cv vs cv vd cv cin c0 wne vs cC crab ciun wcel vp cv cC c0 csn cdif
      wcel cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo
      cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv
      cuni wceq wa wa vp cv cC wcel vp cv c0 wceq wn wa vp cv cC wcel vp cv vd
      cv cin c0 wne wa vd vc cv wrex vp cv vd vc cv vs cv vd cv cin c0 wne vs
      cC crab ciun wcel cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc
      cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel
      cX vc cv cuni wceq wa wa vp cv cC wcel vp cv c0 wceq wn vp cv cC wcel vp
      cv vd cv cin c0 wne wa vd vc cv wrex cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cpw cfn cin wcel cX vc cv cuni wceq wa wa vp cv c0 wceq wn vp cv cC
      wcel vp cv cC wcel vp cv vd cv cin c0 wne wa vd vc cv wrex cJ ccomp wcel
      cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC
      crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa wa vx cv
      vp cv wcel vx wex vp cv cC wcel vp cv cC wcel vp cv vd cv cin c0 wne wa
      vd vc cv wrex wi vp cv c0 wceq wn cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cpw cfn cin wcel cX vc cv cuni wceq wa wa vx cv vp cv wcel vp cv cC
      wcel vp cv cC wcel vp cv vd cv cin c0 wne wa vd vc cv wrex wi vx cJ ccomp
      wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne
      vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa vx
      cv vp cv wcel vp cv cC wcel vp cv cC wcel vp cv vd cv cin c0 wne wa vd vc
      cv wrex wi wi cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv
      vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX
      vc cv cuni wceq wa vx cv vp cv wcel vp cv cC wcel vp cv cC wcel vp cv vd
      cv cin c0 wne wa vd vc cv wrex cJ ccomp wcel cC cA wcel cJ cC cop clocfin
      wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw
      cfn cin wcel cX vc cv cuni wceq wa vx cv vp cv wcel vp cv cC wcel wa wa
      wa vx cv vd cv wcel vd vc cv wrex vp cv cC wcel vp cv vd cv cin c0 wne wa
      vd vc cv wrex cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv
      vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX
      vc cv cuni wceq wa vx cv vp cv wcel vp cv cC wcel wa wa wa vx cv vc cv
      cuni wcel vx cv vd cv wcel vd vc cv wrex cJ ccomp wcel cC cA wcel cJ cC
      cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo
      cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa vx cv vp cv wcel vp cv cC
      wcel wa wa wa vx cv cC cuni vc cv cuni vx cv vp cv wcel vp cv cC wcel wa
      vx cv cC cuni wcel cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc
      cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel
      cX vc cv cuni wceq wa vx cv vp cv cC elunii ad2antll cJ ccomp wcel cC cA
      wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab
      cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa vx cv vp cv
      wcel vp cv cC wcel wa wa wa cX cC cuni vc cv cuni cJ ccomp wcel cC cA
      wcel cJ cC cop clocfin wcel w3a cX cC cuni wceq vc cv vs cv vo cv cin c0
      wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa
      vx cv vp cv wcel vp cv cC wcel wa wa cC cA wcel cJ cC cop clocfin wcel cX
      cC cuni wceq cJ ccomp wcel cC cA cJ cX cC cuni locfincomp.1 cC cuni eqid
      locfinbas 3adant1 adantr cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel
      w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn
      cin wcel cX vc cv cuni wceq vx cv vp cv wcel vp cv cC wcel wa simprlr
      eqtr3d eleqtrd vd vx cv vc cv eluni2 sylib cJ ccomp wcel cC cA wcel cJ cC
      cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo
      cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa vx cv vp cv wcel vp cv cC
      wcel wa wa wa vx cv vd cv wcel vp cv cC wcel vp cv vd cv cin c0 wne wa vd
      vc cv cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo
      cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv
      cuni wceq wa vx cv vp cv wcel vp cv cC wcel wa wa wa vx cv vd cv wcel vp
      cv vd cv cin c0 wne vp cv cC wcel vx cv vp cv wcel vp cv cC wcel wa vx cv
      vd cv wcel vp cv vd cv cin c0 wne wi cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cpw cfn cin wcel cX vc cv cuni wceq wa vx cv vp cv wcel vx cv vd cv
      wcel vp cv vd cv cin c0 wne wi vp cv cC wcel vx cv vp cv wcel vx cv vd cv
      wcel vp cv vd cv cin c0 wne vx cv vp cv vd cv inelcm ex adantr ad2antll
      cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin
      c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq
      wa vx cv vp cv wcel vp cv cC wcel simprrr jctild r19.22sdv mpd exp45 imp
      19.23adv vx vp cv neq0 syl5ib com23 imp3a vp cv vd vc cv vs cv vd cv cin
      c0 wne vs cC crab ciun wcel vp cv vs cv vd cv cin c0 wne vs cC crab wcel
      vd vc cv wrex vp cv cC wcel vp cv vd cv cin c0 wne wa vd vc cv wrex vd vp
      cv vc cv vs cv vd cv cin c0 wne vs cC crab eliun vp cv vs cv vd cv cin c0
      wne vs cC crab wcel vp cv cC wcel vp cv vd cv cin c0 wne wa vd vc cv vs
      cv vd cv cin c0 wne vp cv vd cv cin c0 wne vs vp cv cC vs cv vp cv wceq
      vs cv vd cv cin vp cv vd cv cin c0 vs cv vp cv vd cv ineq1 neeq1d elrab
      rexbii bitr2i syl6ib vp cv cC c0 csn cdif wcel vp cv cC wcel vp cv c0 csn
      wcel wn wa vp cv cC wcel vp cv c0 wceq wn wa vp cv cC c0 csn eldif vp cv
      c0 csn wcel wn vp cv c0 wceq wn vp cv cC wcel vp cv c0 csn wcel vp cv c0
      wceq vp c0 elsn notbii anbi2i bitri syl5ib ssrdv cJ ccomp wcel cC cA wcel
      cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn
      wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa wa vd vc cv vs cv
      vd cv cin c0 wne vs cC crab ciun c0 csn cin c0 wceq vd vc cv vs cv vd cv
      cin c0 wne vs cC crab ciun cC c0 csn cdif wss cJ ccomp wcel cC cA wcel cJ
      cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel
      vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa wa c0 cC wcel c0 vd cv
      cin c0 wne wn wi vd vc cv wral vd vc cv vs cv vd cv cin c0 wne vs cC crab
      ciun c0 csn cin c0 wceq c0 cC wcel c0 vd cv cin c0 wne wn wi vd vc cv
      wral cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv vs cv vo
      cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX vc cv
      cuni wceq wa wa c0 cC wcel c0 vd cv cin c0 wne wn wi vd vc cv vd cv vc cv
      wcel c0 cC wcel c0 vd cv cin c0 wne wn c0 vd cv cin c0 wne wn c0 vd cv
      cin c0 wceq c0 vd cv cin vd cv c0 cin c0 c0 vd cv incom vd cv in0 eqtri
      c0 vd cv cin c0 nne mpbir a1i12 rgen a1i c0 cC wcel c0 vd cv cin c0 wne
      wa vd vc cv wrex wn c0 vd vc cv vs cv vd cv cin c0 wne vs cC crab ciun
      wcel wn c0 cC wcel c0 vd cv cin c0 wne wn wi vd vc cv wral vd vc cv vs cv
      vd cv cin c0 wne vs cC crab ciun c0 csn cin c0 wceq c0 cC wcel c0 vd cv
      cin c0 wne wa vd vc cv wrex c0 vd vc cv vs cv vd cv cin c0 wne vs cC crab
      ciun wcel c0 vd vc cv vs cv vd cv cin c0 wne vs cC crab ciun wcel c0 vs
      cv vd cv cin c0 wne vs cC crab wcel vd vc cv wrex c0 cC wcel c0 vd cv cin
      c0 wne wa vd vc cv wrex vd c0 vc cv vs cv vd cv cin c0 wne vs cC crab
      eliun c0 vs cv vd cv cin c0 wne vs cC crab wcel c0 cC wcel c0 vd cv cin
      c0 wne wa vd vc cv vs cv vd cv cin c0 wne c0 vd cv cin c0 wne vs c0 cC vs
      cv c0 wceq vs cv vd cv cin c0 vd cv cin c0 vs cv c0 vd cv ineq1 neeq1d
      elrab rexbii bitr2i notbii c0 cC wcel c0 vd cv cin c0 wne vd vc cv
      ralinexa vd vc cv vs cv vd cv cin c0 wne vs cC crab ciun c0 disjsn
      3bitr4i sylib cJ ccomp wcel cC cA wcel cJ cC cop clocfin wcel w3a vc cv
      vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel cX
      vc cv cuni wceq wa wa vd vc cv vs cv vd cv cin c0 wne vs cC crab ciun cC
      wss vd vc cv vs cv vd cv cin c0 wne vs cC crab ciun c0 csn cin c0 wceq vd
      vc cv vs cv vd cv cin c0 wne vs cC crab ciun cC c0 csn cdif wss wb vd vc
      cv vs cv vd cv cin c0 wne vs cC crab ciun cC wss cJ ccomp wcel cC cA wcel
      cJ cC cop clocfin wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn
      wcel vo cJ crab cpw cfn cin wcel cX vc cv cuni wceq wa wa vd vc cv vs cv
      vd cv cin c0 wne vs cC crab ciun cC wss vs cv vd cv cin c0 wne vs cC crab
      cC wss vd vc cv vd vc cv vs cv vd cv cin c0 wne vs cC crab cC iunss vs cv
      vd cv cin c0 wne vs cC crab cC wss vd cv vc cv wcel vs cv vd cv cin c0
      wne vs cC ssrab2 a1i mprgbir a1i vd vc cv vs cv vd cv cin c0 wne vs cC
      crab ciun c0 csn cC reldisj syl mpbid eqssd vc cv cfn wcel vs cv vd cv
      cin c0 wne vs cC crab cfn wcel vd vc cv wral vd vc cv vs cv vd cv cin c0
      wne vs cC crab ciun cfn wcel cJ ccomp wcel cC cA wcel cJ cC cop clocfin
      wcel w3a vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw
      cfn cin wcel cX vc cv cuni wceq wa wa vd vc cv vs cv vd cv cin c0 wne vs
      cC crab iunfi vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab
      cpw cfn cin wcel vc cv cfn wcel cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a cX vc cv cuni wceq vs cv vo cv cin c0 wne vs cC crab cfn
      wcel vo cJ crab cpw cfn cin cfn vc cv vs cv vo cv cin c0 wne vs cC crab
      cfn wcel vo cJ crab cpw cfn inss2 sseli ad2antrl vc cv vs cv vo cv cin c0
      wne vs cC crab cfn wcel vo cJ crab cpw cfn cin wcel vs cv vd cv cin c0
      wne vs cC crab cfn wcel vd vc cv wral cJ ccomp wcel cC cA wcel cJ cC cop
      clocfin wcel w3a cX vc cv cuni wceq vc cv vs cv vo cv cin c0 wne vs cC
      crab cfn wcel vo cJ crab cpw cfn cin wcel vc cv vs cv vo cv cin c0 wne vs
      cC crab cfn wcel vo cJ crab cpw wcel vs cv vd cv cin c0 wne vs cC crab
      cfn wcel vd vc cv wral vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ
      crab cpw cfn cin vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab
      cpw vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab cpw cfn
      inss1 sseli vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab
      cpw wcel vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab wss
      vs cv vd cv cin c0 wne vs cC crab cfn wcel vd vc cv wral vc cv vs cv vo
      cv cin c0 wne vs cC crab cfn wcel vo cJ crab vc visset elpw vc cv vs cv
      vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab wss vs cv vd cv cin c0
      wne vs cC crab cfn wcel vd vc cv vc cv vs cv vo cv cin c0 wne vs cC crab
      cfn wcel vo cJ crab wss vd cv vc cv wcel vd cv vs cv vo cv cin c0 wne vs
      cC crab cfn wcel vo cJ crab wcel vs cv vd cv cin c0 wne vs cC crab cfn
      wcel vc cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab vd cv
      ssel vd cv vs cv vo cv cin c0 wne vs cC crab cfn wcel vo cJ crab wcel vd
      cv cJ wcel vs cv vd cv cin c0 wne vs cC crab cfn wcel vs cv vo cv cin c0
      wne vs cC crab cfn wcel vs cv vd cv cin c0 wne vs cC crab cfn wcel vo vd
      cv cJ vo cv vd cv wceq vs cv vo cv cin c0 wne vs cC crab vs cv vd cv cin
      c0 wne vs cC crab cfn vo cv vd cv wceq vs cv vo cv cin c0 wne vs cv vd cv
      cin c0 wne vs cC vo cv vd cv wceq vs cv vo cv cin vs cv vd cv cin c0 vo
      cv vd cv vs cv ineq2 neeq1d rabbisdv eleq1d elrab pm3.27bi syl6 r19.21aiv
      sylbi syl ad2antrl sylanc eqeltrd cC c0 csn cdif cfn wcel c0 csn cfn wcel
      cC c0 csn cdif c0 csn cun cfn wcel c0 snfi cC c0 csn cdif c0 csn unfi
      mpan2 cC c0 csn cdif c0 csn cun cfn wcel cC cC c0 csn cdif c0 csn cun wss
      cC cfn wcel vd cC cC c0 csn cdif c0 csn cun vd cv cC wcel vd cv cC wcel
      vd cv c0 csn wcel wn wa wn vd cv c0 wceq wi vd cv cC c0 csn cdif c0 csn
      cun wcel vd cv cC wcel vd cv cC wcel vd cv c0 csn wcel wi vd cv c0 csn
      wcel vd cv cC wcel vd cv c0 csn wcel wn wa wn vd cv c0 wceq vd cv cC wcel
      vd cv c0 csn wcel pm2.27 vd cv cC wcel vd cv c0 csn wcel iman vd c0 elsn
      3imtr3g vd cv cC c0 csn cdif c0 csn cun wcel vd cv cC c0 csn cdif wcel vd
      cv c0 csn wcel wo vd cv cC wcel vd cv c0 csn wcel wn wa vd cv c0 wceq wo
      vd cv cC wcel vd cv c0 csn wcel wn wa wn vd cv c0 wceq wi vd cv cC c0 csn
      cdif c0 csn elun vd cv cC c0 csn cdif wcel vd cv cC wcel vd cv c0 csn
      wcel wn wa vd cv c0 csn wcel vd cv c0 wceq vd cv cC c0 csn eldif vd c0
      elsn orbi12i vd cv cC wcel vd cv c0 csn wcel wn wa vd cv c0 wceq df-or
      3bitrri sylib ssriv cC c0 csn cdif c0 csn cun cC ssfi mpan2 3syl exp32
      r19.23adv mpd cC cA wcel cJ cC cop clocfin wcel cX cY wceq cJ ccomp wcel
      cC cA cJ cX cY locfincomp.1 locfincomp.2 locfinbas 3adant1 jca 3expia cJ
      ccomp wcel cC cfn wcel cX cY wceq wa cJ cC cop clocfin wcel wi cC cA wcel
      cJ ccomp wcel cJ ctop wcel cC cfn wcel cX cY wceq wa cJ cC cop clocfin
      wcel wi cJ comptop cJ ctop wcel cC cfn wcel cX cY wceq cJ cC cop clocfin
      wcel cC cJ cX cY locfincomp.1 locfincomp.2 finlocfin 3expib syl adantr
      impbid $.
      $( [22-Jan-2010] $) $( [22-Jan-2010] $)
  $}

  ${
    $d n s x B $. $d n s x C $. $d n s x X $. $d n s x Y $.
    locfindsc.1 $e |- Y = U. C $.
    $( The locally finite covers of a discrete space are precisely the
       point-finite covers. $)
    locfindsc $p |- ( C e. B -> ( <. ~P X , C >. e. LocFin <-> (
    C e. PtFin /\ X = Y ) ) ) $=
      cC cB wcel cX cpw cC cop clocfin wcel cC cptfin wcel cX cY wceq wa cC cB
      wcel cX cpw cC cop clocfin wcel cC cptfin wcel cX cY wceq wa cC cB wcel
      cX cpw cC cop clocfin wcel wa cC cptfin wcel cX cY wceq cC cB cX cpw
      lfinpfin cC cB cX cpw cX cY cX cpw cuni cX cX unipw eqcomi locfindsc.1
      locfinbas jca ex cC cB wcel cX cpw cC cop clocfin wcel cX cpw ctop wcel
      cX cY wceq vs cv vn cv cin c0 wne vs cC crab cfn wcel vn vx cv csn cX cpw
      cnei cfv cfv wrex vx cX wral w3a cC cptfin wcel cX cY wceq wa vx cC cB vn
      cX cpw cX cY vs cX cpw cuni cX cX unipw eqcomi locfindsc.1 islocfin cC
      cptfin wcel cX cY wceq wa cX cpw ctop wcel cX cY wceq vs cv vn cv cin c0
      wne vs cC crab cfn wcel vn vx cv csn cX cpw cnei cfv cfv wrex vx cX wral
      cC cptfin wcel cX cY wceq wa cX cvv wcel cX cpw ctop wcel cY cvv wcel cX
      cY wceq cX cvv wcel cC cptfin wcel cX cY wceq cX cvv wcel cY cvv wcel cX
      cY cvv eleq1 biimparc cC cptfin wcel cC cuni cvv cY cC cptfin uniexg
      locfindsc.1 syl5eqel sylan vx cv cpw ctop wcel cX cpw ctop wcel vx cX cvv
      vx cv cX wceq vx cv cpw cX cpw ctop vx cv cX pweq eleq1d vx cv vx visset
      distop vtoclg syl cC cptfin wcel cX cY wceq pm3.27 cC cptfin wcel cX cY
      wceq wa vs cv vn cv cin c0 wne vs cC crab cfn wcel vn vx cv csn cX cpw
      cnei cfv cfv wrex vx cX cC cptfin wcel cX cY wceq vx cv cX wcel vs cv vn
      cv cin c0 wne vs cC crab cfn wcel vn vx cv csn cX cpw cnei cfv cfv wrex
      vx cv csn vx cv csn cX cpw cnei cfv cfv wcel vs cv vx cv csn cin c0 wne
      vs cC crab cfn wcel vs cv vn cv cin c0 wne vs cC crab cfn wcel vn vx cv
      csn cX cpw cnei cfv cfv wrex cC cptfin wcel cX cY wceq vx cv cX wcel w3a
      vs cv vn cv cin c0 wne vs cC crab cfn wcel vs cv vx cv csn cin c0 wne vs
      cC crab cfn wcel vn vx cv csn vx cv csn cX cpw cnei cfv cfv vn cv vx cv
      csn wceq vs cv vn cv cin c0 wne vs cC crab vs cv vx cv csn cin c0 wne vs
      cC crab cfn vn cv vx cv csn wceq vs cv vn cv cin c0 wne vs cv vx cv csn
      cin c0 wne vs cC vn cv vx cv csn wceq vs cv vn cv cin vs cv vx cv csn cin
      c0 vn cv vx cv csn vs cv ineq2 neeq1d rabbisdv eleq1d rcla4ev cX cpw ctop
      wcel vx cv csn cX cpw wcel vx cv vx cv csn wcel vx cv csn vx cv csn cX
      cpw cnei cfv cfv wcel cC cptfin wcel cX cY wceq vx cv cX wcel w3a vx cv
      cX cpw vx cv csn opnneip cC cptfin wcel cX cY wceq cX cpw ctop wcel vx cv
      cX wcel cC cptfin wcel cX cY wceq wa cX cvv wcel cX cpw ctop wcel cY cvv
      wcel cX cY wceq cX cvv wcel cC cptfin wcel cX cY wceq cX cvv wcel cY cvv
      wcel cX cY cvv eleq1 biimparc cC cptfin wcel cC cuni cvv cY cC cptfin
      uniexg locfindsc.1 syl5eqel sylan vx cv cpw ctop wcel cX cpw ctop wcel vx
      cX cvv vx cv cX wceq vx cv cpw cX cpw ctop vx cv cX pweq eleq1d vx cv vx
      visset distop vtoclg syl 3adant3 vx cv cX wcel cC cptfin wcel vx cv csn
      cX cpw wcel cX cY wceq vx cv cX wcel vx cv csn cX cpw wcel vx cv cX vx
      visset snelpw biimpi 3ad2ant3 vx cv vx cv csn wcel cC cptfin wcel cX cY
      wceq vx cv cX wcel w3a vx cv vx visset snid a1i syl3anc cC cptfin wcel cX
      cY wceq vx cv cX wcel w3a vx cv vs cv wcel vs cC crab cfn vs cv vx cv csn
      cin c0 wne vs cC crab cC cptfin wcel vx cv cY wcel vx cv vs cv wcel vs cC
      crab cfn wcel cC cptfin wcel cX cY wceq vx cv cX wcel w3a vs cC vx cv cY
      locfindsc.1 ptfinfin cC cptfin wcel cX cY wceq vx cv cX wcel 3simp1 cX cY
      wceq vx cv cX wcel vx cv cY wcel cC cptfin wcel cX cY wceq vx cv cX wcel
      vx cv cY wcel cX cY vx cv eleq2 biimpa 3adant1 sylanc vs cv vx cv csn cin
      c0 wne vx cv vs cv wcel vs cC vs cv vx cv csn cin c0 wne vx cv vs cv wcel
      wb vs cv cC wcel vx cv vs cv wcel vs cv vx cv csn cin c0 vs cv vx cv csn
      cin c0 wceq vx cv vs cv wcel wn vs cv vx cv disjsn bicomi necon1abii a1i
      rabbii syl5eqel sylanc 3expia r19.21aiv 3jca syl5bir impbid $.
      $( [22-Jan-2010] $) $( [22-Jan-2010] $)
  $}

  ${
    $d n o s x A $. $d n o s x B $. $d n o s x J $. $d n o s x K $. $d n o s x
    X $. $d n o s x Y $.
    locfincf.1 $e |- X = U. J $.
    locfincf.2 $e |- Y = U. K $.
    $( A locally finite cover in a coarser topology is locally finite in a
       finer topology. $)
    locfincf $p |- ( ( ( A e. B /\ <. J , A >. e. LocFin ) /\ ( K e. Top /\ J
    C_ K /\ X = Y ) ) -> <. K , A >. e. LocFin ) $=
      cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq
      w3a wa cK cA cop clocfin wcel cK ctop wcel cY cA cuni wceq vs cv vn cv
      cin c0 wne vs cA crab cfn wcel vn vx cv csn cK cnei cfv cfv wrex vx cY
      wral w3a cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX
      cY wceq w3a wa cK ctop wcel cY cA cuni wceq vs cv vn cv cin c0 wne vs cA
      crab cfn wcel vn vx cv csn cK cnei cfv cfv wrex vx cY wral cA cB wcel cJ
      cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq 3simpr1 cA cB
      wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa
      cX cY cA cuni cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss
      cX cY wceq 3simpr3 cA cB wcel cJ cA cop clocfin wcel wa cX cA cuni wceq
      cK ctop wcel cJ cK wss cX cY wceq w3a cA cB cJ cX cA cuni locfincf.1 cA
      cuni eqid locfinbas adantr eqtr3d cA cB wcel cJ cA cop clocfin wcel wa cK
      ctop wcel cJ cK wss cX cY wceq w3a wa vs cv vn cv cin c0 wne vs cA crab
      cfn wcel vn vx cv csn cK cnei cfv cfv wrex vx cY cA cB wcel cJ cA cop
      clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv cY wcel wa
      vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv
      wrex vs cv vn cv cin c0 wne vs cA crab cfn wcel vn vx cv csn cK cnei cfv
      cfv wrex cA cB wcel cJ cA cop clocfin wcel vx cv cX wcel vs cv vn cv cin
      c0 wne vs cA crab cfn wcel vn vx cv csn cJ cnei cfv cfv wrex cA cB wcel
      cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv
      cY wcel wa cA cB vx cv vn cJ cX vs locfincf.1 locfinnei cA cB wcel cJ cA
      cop clocfin wcel cK ctop wcel cJ cK wss cX cY wceq w3a vx cv cY wcel
      simplll cA cB wcel cJ cA cop clocfin wcel cK ctop wcel cJ cK wss cX cY
      wceq w3a vx cv cY wcel simpllr cA cB wcel cJ cA cop clocfin wcel wa cK
      ctop wcel cJ cK wss cX cY wceq w3a wa vx cv cX wcel vx cv cY wcel cA cB
      wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa
      cX cY vx cv cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss
      cX cY wceq 3simpr3 eleq2d biimpar syl3anc cA cB wcel cJ cA cop clocfin
      wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv cY wcel wa vs cv
      vn cv cin c0 wne vs cA crab cfn wcel vs cv vn cv cin c0 wne vs cA crab
      cfn wcel vn vx cv csn cJ cnei cfv cfv vx cv csn cK cnei cfv cfv cA cB
      wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa
      vx cv cY wcel wa vn cv vx cv csn cJ cnei cfv cfv wcel vn cv vx cv csn cK
      cnei cfv cfv wcel vs cv vn cv cin c0 wne vs cA crab cfn wcel cA cB wcel
      cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv
      cY wcel vn cv vx cv csn cJ cnei cfv cfv wcel vn cv vx cv csn cK cnei cfv
      cfv wcel cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX
      cY wceq w3a wa vx cv cY wcel vn cv vx cv csn cJ cnei cfv cfv wcel wa wa
      vn cv vx cv csn cK cnei cfv cfv wcel vn cv cY wss vx cv vo cv wcel vo cv
      vn cv wss wa vo cK wrex wa cA cB wcel cJ cA cop clocfin wcel wa cK ctop
      wcel cJ cK wss cX cY wceq w3a wa vx cv cY wcel vn cv vx cv csn cJ cnei
      cfv cfv wcel wa wa vn cv cY wss vx cv vo cv wcel vo cv vn cv wss wa vo cK
      wrex cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY
      wceq w3a wa vx cv cY wcel vn cv vx cv csn cJ cnei cfv cfv wcel vn cv cY
      wss cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY
      wceq w3a wa vx cv cY wcel wa vn cv vx cv csn cJ cnei cfv cfv wcel vn cv
      cX wss vn cv cY wss cA cB wcel cJ cA cop clocfin wcel wa vn cv vx cv csn
      cJ cnei cfv cfv wcel vn cv cX wss wi cK ctop wcel cJ cK wss cX cY wceq
      w3a vx cv cY wcel cA cB wcel cJ cA cop clocfin wcel wa cJ ctop wcel vn cv
      vx cv csn cJ cnei cfv cfv wcel vn cv cX wss wi cA cB cJ locfintop cJ ctop
      wcel vn cv vx cv csn cJ cnei cfv cfv wcel vn cv cX wss vx cv csn cJ vn cv
      cX locfincf.1 neii1 ex syl ad2antrr cA cB wcel cJ cA cop clocfin wcel wa
      cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv cY wcel wa cX cY vn cv cK
      ctop wcel cJ cK wss cX cY wceq w3a cX cY wceq cA cB wcel cJ cA cop
      clocfin wcel wa vx cv cY wcel cK ctop wcel cJ cK wss cX cY wceq 3simp3
      ad2antlr sseq2d sylibd impr cA cB wcel cJ cA cop clocfin wcel wa cK ctop
      wcel cJ cK wss cX cY wceq w3a wa vx cv cY wcel vn cv vx cv csn cJ cnei
      cfv cfv wcel vx cv vo cv wcel vo cv vn cv wss wa vo cK wrex cA cB wcel cJ
      cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv cY
      wcel wa vn cv vx cv csn cJ cnei cfv cfv wcel vx cv csn vo cv wss vo cv vn
      cv wss wa vo cJ wrex vx cv vo cv wcel vo cv vn cv wss wa vo cK wrex cA cB
      wcel cJ cA cop clocfin wcel wa vn cv vx cv csn cJ cnei cfv cfv wcel vx cv
      csn vo cv wss vo cv vn cv wss wa vo cJ wrex wi cK ctop wcel cJ cK wss cX
      cY wceq w3a vx cv cY wcel cA cB wcel cJ cA cop clocfin wcel wa cJ ctop
      wcel vn cv vx cv csn cJ cnei cfv cfv wcel vx cv csn vo cv wss vo cv vn cv
      wss wa vo cJ wrex wi cA cB cJ locfintop cJ ctop wcel vn cv vx cv csn cJ
      cnei cfv cfv wcel vx cv csn vo cv wss vo cv vn cv wss wa vo cJ wrex vx cv
      csn vo cJ vn cv neii2 ex syl ad2antrr cA cB wcel cJ cA cop clocfin wcel
      wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv cY wcel wa vx cv csn vo
      cv wss vo cv vn cv wss wa vx cv vo cv wcel vo cv vn cv wss wa vo cJ cK cA
      cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a
      wa vx cv cY wcel wa vo cv cJ wcel vo cv cK wcel vx cv csn vo cv wss vo cv
      vn cv wss wa vx cv vo cv wcel vo cv vn cv wss wa cK ctop wcel cJ cK wss
      cX cY wceq w3a vo cv cJ wcel vo cv cK wcel wi cA cB wcel cJ cA cop
      clocfin wcel wa vx cv cY wcel cJ cK wss cK ctop wcel vo cv cJ wcel vo cv
      cK wcel wi cX cY wceq cJ cK vo cv ssel 3ad2ant2 ad2antlr vx cv csn vo cv
      wss vo cv vn cv wss wa vx cv vo cv wcel vo cv vn cv wss wa wi cA cB wcel
      cJ cA cop clocfin wcel wa cK ctop wcel cJ cK wss cX cY wceq w3a wa vx cv
      cY wcel wa vx cv csn vo cv wss vx cv vo cv wcel vo cv vn cv wss vx cv vo
      cv wcel vx cv csn vo cv wss vx cv vo cv vx visset snss biimpri anim1i a1i
      anim12d r19.22dv2 syld impr jca cK ctop wcel vx cv cY wcel vn cv vx cv
      csn cK cnei cfv cfv wcel vn cv cY wss vx cv vo cv wcel vo cv vn cv wss wa
      vo cK wrex wa wb cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK
      wss cX cY wceq w3a wa vx cv cY wcel vn cv vx cv csn cJ cnei cfv cfv wcel
      wa wa vx cv vo cK vn cv cY locfincf.2 isneip cK ctop wcel cJ cK wss cX cY
      wceq w3a cK ctop wcel cA cB wcel cJ cA cop clocfin wcel wa vx cv cY wcel
      vn cv vx cv csn cJ cnei cfv cfv wcel wa cK ctop wcel cJ cK wss cX cY wceq
      3simp1 ad2antlr cA cB wcel cJ cA cop clocfin wcel wa cK ctop wcel cJ cK
      wss cX cY wceq w3a wa vx cv cY wcel vn cv vx cv csn cJ cnei cfv cfv wcel
      simprl sylanc mpbird expr anim1d r19.22dv2 mpd r19.21aiva 3jca cA cB wcel
      cK cA cop clocfin wcel cK ctop wcel cY cA cuni wceq vs cv vn cv cin c0
      wne vs cA crab cfn wcel vn vx cv csn cK cnei cfv cfv wrex vx cY wral w3a
      wb cJ cA cop clocfin wcel cK ctop wcel cJ cK wss cX cY wceq w3a vx cA cB
      vn cK cY cA cuni vs locfincf.2 cA cuni eqid islocfin ad2antrr mpbird $.
      $( [22-Jan-2010] $) $( [22-Jan-2010] $)
  $}

  ${
    $d a b c d f p q s t x y z J $. $d a b c f p q s t x y z X $.
    comppfsc.1 $e |- X = U. J $.
    $( A space where every open cover has a point-finite subcover is compact.
       This is significant in part because it shows half of the proposition
       that if only half the generalization in the definition of
       metacompactness (and consequently paracompactness) is performed, one
       does not obtain any more spaces.  $)
    comppfsc $p |- ( J e. Top -> ( J e. Comp <-> A. c e. ~P J ( X = U. c -> E.
    d e. PtFin ( d C_ c /\ X = U. d ) ) ) ) $=
      cJ ctop wcel cJ ccomp wcel cX vc cv cuni wceq vd cv vc cv wss cX vd cv
      cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cJ ccomp wcel cX vc cv cuni
      wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw cJ
      ccomp wcel vc cv cJ cpw wcel cX vc cv cuni wceq vd cv vc cv wss cX vd cv
      cuni wceq wa vd cptfin wrex cJ ccomp wcel vc cv cJ wss cX vc cv cuni wceq
      vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex vc cv cJ cpw wcel cJ
      ccomp wcel vc cv cJ wss cX vc cv cuni wceq w3a cX vd cv cuni wceq vd vc
      cv cpw cfn cin wrex vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex
      vc cv cJ cX vd comppfsc.1 compcov cX vd cv cuni wceq vd cv vc cv wss cX
      vd cv cuni wceq wa vd vc cv cpw cfn cin cptfin vd cv vc cv wss vd cv cfn
      wcel wa cX vd cv cuni wceq vd cv cptfin wcel vd cv vc cv wss cX vd cv
      cuni wceq wa wa vd cv vc cv cpw cfn cin wcel vd cv vc cv wss vd cv cfn
      wcel wa cX vd cv cuni wceq wa vd cv cptfin wcel vd cv vc cv wss cX vd cv
      cuni wceq vd cv cfn wcel vd cv cptfin wcel vd cv vc cv wss cX vd cv cuni
      wceq vd cv finptfin ad2antlr vd cv vc cv wss vd cv cfn wcel cX vd cv cuni
      wceq simpll vd cv vc cv wss vd cv cfn wcel wa cX vd cv cuni wceq pm3.27
      jca32 vd cv vc cv cpw cfn cin wcel vd cv vc cv cpw wcel vd cv cfn wcel wa
      vd cv vc cv wss vd cv cfn wcel wa vd cv vc cv cpw cfn elin vd cv vc cv
      cpw wcel vd cv vc cv wss vd cv cfn wcel vd cv vc cv vd visset elpw anbi1i
      bitri sylanb r19.22i2 syl vc cv cJ vc visset elpw syl3an2b 3exp r19.21aiv
      cJ ctop wcel cX vc cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq wa vd
      cptfin wrex wi vc cJ cpw wral cJ cuni va cv cuni wceq cJ cuni vb cv cuni
      wceq vb va cv cpw cfn cin wrex wi va cJ cpw wral cJ ccomp wcel cJ ctop
      wcel cX vc cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin
      wrex wi vc cJ cpw wral cJ cuni va cv cuni wceq cJ cuni vb cv cuni wceq vb
      va cv cpw cfn cin wrex wi va cJ cpw cJ ctop wcel cJ cuni va cv cuni wceq
      va cv cJ cpw wcel cX vc cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq
      wa vd cptfin wrex wi vc cJ cpw wral cJ cuni vb cv cuni wceq vb va cv cpw
      cfn cin wrex cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel cX vc
      cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc
      cJ cpw wral cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a cX vc cv cuni wceq vd
      cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cJ
      cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi cX c0 cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a cX c0 wceq cX vc cv cuni wceq
      vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cJ
      cuni vb cv cuni wceq vb va cv cpw cfn cin wrex c0 va cv cpw cfn cin wcel
      cJ cuni c0 wceq cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex cX c0
      wceq cJ cuni vb cv cuni wceq cJ cuni c0 wceq vb c0 va cv cpw cfn cin vb
      cv c0 wceq vb cv cuni c0 cJ cuni vb cv c0 wceq vb cv cuni c0 cuni c0 vb
      cv c0 unieq uni0 syl6eq eqeq2d rcla4ev c0 va cv cpw cfn cin wcel cX c0
      wceq c0 va cv cpw cfn cin wcel c0 va cv cpw wcel c0 cfn wcel c0 va cv cpw
      cfn elin va cv 0elpw emfin mpbir2an a1i cX c0 wceq cJ cuni c0 wceq cX cJ
      cuni c0 comppfsc.1 eqeq1i biimpi sylanc a1i13 cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vx cv cX wcel vx wex cX vc cv cuni wceq
      vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cJ
      cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi cX c0 wne cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vx cv cX wcel cX vc cv cuni
      wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw
      wral cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi vx cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vx cv cX wcel vx cv vs cv
      wcel vs va cv wrex cX vc cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq
      wa vd cptfin wrex wi vc cJ cpw wral cJ cuni vb cv cuni wceq vb va cv cpw
      cfn cin wrex wi cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vx cv cX wcel vx cv va cv cuni wcel vx cv vs cv wcel vs va cv wrex cJ
      cuni va cv cuni wceq cJ ctop wcel vx cv cX wcel vx cv va cv cuni wcel wi
      va cv cJ cpw wcel cJ cuni va cv cuni wceq vx cv cX wcel vx cv va cv cuni
      wcel cJ cuni va cv cuni wceq cX va cv cuni vx cv cX va cv cuni wceq cJ
      cuni va cv cuni wceq cX cJ cuni va cv cuni comppfsc.1 eqeq1i biimpri
      eleq2d biimpd 3ad2ant2 vs vx cv va cv eluni2 syl6ib cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vx cv cX wcel vx cv vs cv wcel vs
      va cv wrex cX vc cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq wa vd
      cptfin wrex wi vc cJ cpw wral cJ cuni vb cv cuni wceq vb va cv cpw cfn
      cin wrex wi wi cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a
      vx cv cX wcel wa vx cv vs cv wcel cX vc cv cuni wceq vd cv vc cv wss cX
      vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cJ cuni vb cv cuni
      wceq vb va cv cpw cfn cin wrex wi vs va cv cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel cX vc
      cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc
      cJ cpw wral cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi wi wi vx
      cv cX wcel cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs
      cv va cv wcel vx cv vs cv wcel cX vc cv cuni wceq vd cv vc cv wss cX vd
      cv cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cJ cuni vb cv cuni wceq
      vb va cv cpw cfn cin wrex wi cJ ctop wcel cJ cuni va cv cuni wceq va cv
      cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa cX vc cv cuni
      wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi vc cJ cpw
      wral vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv
      cuni wceq wa vd cptfin wrex cJ cuni vb cv cuni wceq vb va cv cpw cfn cin
      wrex cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va
      cv wcel vx cv vs cv wcel wa wa cX vc cv cuni wceq vd cv vc cv wss cX vd
      cv cuni wceq wa vd cptfin wrex wi vc cJ cpw wral cX vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab cuni wceq vd cv vt cv vs cv vp cv cun wceq vp
      va cv wrex vt cab wss cX vd cv cuni wceq wa vd cptfin wrex cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs
      cv wcel wa wa cX va cv cuni vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab cuni cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a cX va
      cv cuni wceq vs cv va cv wcel vx cv vs cv wcel wa cJ cuni va cv cuni wceq
      cJ ctop wcel cX va cv cuni wceq va cv cJ cpw wcel cX va cv cuni wceq cJ
      cuni va cv cuni wceq cX cJ cuni va cv cuni comppfsc.1 eqeq1i biimpri
      3ad2ant2 adantr cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vs cv va cv wcel vx cv vs cv wcel wa wa vy va cv cuni vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab cuni cJ ctop wcel cJ cuni va cv cuni
      wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vy cv
      vq cv wcel vq cv va cv wcel wa vq wex vy cv vt cv wcel vt cv vs cv vp cv
      cun wceq vp va cv wrex wa vt wex vy cv va cv cuni wcel vy cv vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab cuni wcel cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vy cv vq cv wcel vq cv va cv wcel wa vq wex vy cv vt cv wcel vt cv vs cv
      vp cv cun wceq vp va cv wrex wa vt wex cJ ctop wcel cJ cuni va cv cuni
      wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vy cv
      vq cv wcel vq cv va cv wcel wa vy cv vt cv wcel vt cv vs cv vp cv cun
      wceq vp va cv wrex wa vt wex vq cJ ctop wcel cJ cuni va cv cuni wceq va
      cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vy cv vq cv
      wcel vq cv va cv wcel wa vy cv vt cv wcel vt cv vs cv vp cv cun wceq vp
      va cv wrex wa vt wex vy cv vs cv vq cv cun wcel vs cv vq cv cun vs cv vp
      cv cun wceq vp va cv wrex vy cv vt cv wcel vt cv vs cv vp cv cun wceq vp
      va cv wrex wa vt wex cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw
      wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vy cv vq cv wcel vq cv
      va cv wcel wa wa vy cv vt cv wcel vt cv vs cv vp cv cun wceq vp va cv
      wrex wa vy cv vs cv vq cv cun wcel vs cv vq cv cun vs cv vp cv cun wceq
      vp va cv wrex wa vt vs cv vq cv cun vs cv vq cv vs visset vq visset unex
      vt cv vs cv vq cv cun wceq vy cv vt cv wcel vy cv vs cv vq cv cun wcel vt
      cv vs cv vp cv cun wceq vp va cv wrex vs cv vq cv cun vs cv vp cv cun
      wceq vp va cv wrex vt cv vs cv vq cv cun vy cv eleq2 vt cv vs cv vq cv
      cun wceq vt cv vs cv vp cv cun wceq vs cv vq cv cun vs cv vp cv cun wceq
      vp va cv vt cv vs cv vq cv cun vs cv vp cv cun eqeq1 rexbidv anbi12d
      cla4ev vy cv vq cv wcel vy cv vs cv vq cv cun wcel cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      wa wa vq cv va cv wcel vy cv vq cv vs cv elun2 ad2antrl vq cv va cv wcel
      vs cv vq cv cun vs cv vp cv cun wceq vp va cv wrex cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      wa wa vy cv vq cv wcel vq cv va cv wcel vs cv vq cv cun vs cv vq cv cun
      wceq vs cv vq cv cun vs cv vp cv cun wceq vp va cv wrex vs cv vq cv cun
      eqid vs cv vq cv cun vs cv vp cv cun wceq vs cv vq cv cun vs cv vq cv cun
      wceq vp vq cv va cv vp cv vq cv wceq vs cv vp cv cun vs cv vq cv cun vs
      cv vq cv cun vp cv vq cv vs cv uneq2 eqeq2d rcla4ev mpan2 ad2antll sylanc
      ex 19.23adv cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs
      cv va cv wcel vx cv vs cv wcel wa wa vy cv vt cv wcel vt cv vs cv vp cv
      cun wceq vp va cv wrex wa vy cv vq cv wcel vq cv va cv wcel wa vq wex vt
      cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vy cv vt cv wcel vt cv vs cv vp cv cun wceq
      vp va cv wrex vy cv vq cv wcel vq cv va cv wcel wa vq wex cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vt cv vs cv vp cv cun wceq vp va cv wrex vy cv vt cv wcel vy
      cv vq cv wcel vq cv va cv wcel wa vq wex cJ ctop wcel cJ cuni va cv cuni
      wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vt cv
      vs cv vp cv cun wceq vy cv vt cv wcel vy cv vq cv wcel vq cv va cv wcel
      wa vq wex wi vp va cv cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw
      wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vt cv vs cv vp cv cun
      wceq vp cv va cv wcel vy cv vt cv wcel vy cv vq cv wcel vq cv va cv wcel
      wa vq wex wi cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a
      vs cv va cv wcel vx cv vs cv wcel wa wa vt cv vs cv vp cv cun wceq vp cv
      va cv wcel vy cv vt cv wcel vy cv vq cv wcel vq cv va cv wcel wa vq wex
      wi cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vt cv vs cv vp cv cun wceq vp cv va cv wcel
      wa wa vy cv vt cv wcel vy cv vs cv wcel vy cv vp cv wcel wo vy cv vq cv
      wcel vq cv va cv wcel wa vq wex cJ ctop wcel cJ cuni va cv cuni wceq va
      cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vt cv vs cv vp
      cv cun wceq vp cv va cv wcel wa wa vy cv vt cv wcel vy cv vs cv vp cv cun
      wcel vy cv vs cv wcel vy cv vp cv wcel wo vt cv vs cv vp cv cun wceq vy
      cv vt cv wcel vy cv vs cv vp cv cun wcel wb cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vp cv va cv wcel vt cv vs cv vp cv cun vy cv eleq2 ad2antrl vy cv vs cv
      vp cv elun syl6bb cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vs cv va cv wcel vx cv vs cv wcel wa wa vp cv va cv wcel vy cv vs cv
      wcel vy cv vp cv wcel wo vy cv vq cv wcel vq cv va cv wcel wa vq wex wi
      vt cv vs cv vp cv cun wceq cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vp cv va cv wcel wa
      vy cv vs cv wcel vy cv vq cv wcel vq cv va cv wcel wa vq wex vy cv vp cv
      wcel vs cv va cv wcel vx cv vs cv wcel wa vy cv vs cv wcel vy cv vq cv
      wcel vq cv va cv wcel wa vq wex wi cJ ctop wcel cJ cuni va cv cuni wceq
      va cv cJ cpw wcel w3a vp cv va cv wcel vs cv va cv wcel vy cv vs cv wcel
      vy cv vq cv wcel vq cv va cv wcel wa vq wex wi vx cv vs cv wcel vy cv vs
      cv wcel vs cv va cv wcel vy cv vq cv wcel vq cv va cv wcel wa vq wex vy
      cv vq cv wcel vq cv va cv wcel wa vy cv vs cv wcel vs cv va cv wcel wa vq
      vs cv vs visset vq cv vs cv wceq vy cv vq cv wcel vy cv vs cv wcel vq cv
      va cv wcel vs cv va cv wcel vq cv vs cv vy cv eleq2 vq cv vs cv va cv
      eleq1 anbi12d cla4ev expcom adantr ad2antlr vp cv va cv wcel vy cv vp cv
      wcel vy cv vq cv wcel vq cv va cv wcel wa vq wex wi cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      wa wa vy cv vp cv wcel vp cv va cv wcel vy cv vq cv wcel vq cv va cv wcel
      wa vq wex vy cv vq cv wcel vq cv va cv wcel wa vy cv vp cv wcel vp cv va
      cv wcel wa vq vp cv vp visset vq cv vp cv wceq vy cv vq cv wcel vy cv vp
      cv wcel vq cv va cv wcel vp cv va cv wcel vq cv vp cv vy cv eleq2 vq cv
      vp cv va cv eleq1 anbi12d cla4ev expcom adantl jaod adantrl sylbid exp32
      com23 r19.23adv com23 imp3a 19.23adv impbid vq vy cv va cv eluni vt cv vs
      cv vp cv cun wceq vp va cv wrex vt vy cv eluniab 3bitr4g eqrdv eqtrd cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vt cv vs cv vp cv cun wceq vp va cv wrex vt cab cJ
      cpw wcel cX vc cv cuni wceq vd cv vc cv wss cX vd cv cuni wceq wa vd
      cptfin wrex wi vc cJ cpw wral cX vt cv vs cv vp cv cun wceq vp va cv wrex
      vt cab cuni wceq vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab
      wss cX vd cv cuni wceq wa vd cptfin wrex wi wi cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vt cv vs cv vp cv cun wceq vp va cv wrex vt cab cJ cpw wcel vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab cJ wss cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vt cv vs cv vp cv cun wceq vp va cv wrex vt cJ cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vt cv vs cv vp cv cun wceq vt cv cJ wcel vp va cv cJ ctop wcel cJ cuni va
      cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa
      wa vp cv va cv wcel vt cv vs cv vp cv cun wceq vt cv cJ wcel cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs
      cv wcel wa wa vp cv va cv wcel vt cv vs cv vp cv cun wceq wa wa vt cv vs
      cv vp cv cun cJ cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vs cv va cv wcel vx cv vs cv wcel wa wa vp cv va cv wcel vt cv vs cv
      vp cv cun wceq simprr cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw
      wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vp cv va cv wcel vt cv
      vs cv vp cv cun wceq wa wa vs cv vp cv cpr cuni cJ vs cv vp cv cun cJ
      ctop wcel vs cv vp cv cpr cJ wss vs cv vp cv cpr cuni cJ wcel cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv
      vs cv wcel wa wa vp cv va cv wcel vt cv vs cv vp cv cun wceq wa wa vs cv
      vp cv cpr cJ uniopn cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw
      wcel w3a cJ ctop wcel vs cv va cv wcel vx cv vs cv wcel wa vp cv va cv
      wcel vt cv vs cv vp cv cun wceq wa cJ ctop wcel cJ cuni va cv cuni wceq
      va cv cJ cpw wcel 3simp1 ad2antrr cJ ctop wcel cJ cuni va cv cuni wceq va
      cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vp cv va cv
      wcel vt cv vs cv vp cv cun wceq wa wa vs cv cJ wcel vp cv cJ wcel wa vs
      cv vp cv cpr cJ wss cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw
      wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vp cv va cv wcel vs cv
      cJ wcel vp cv cJ wcel wa vt cv vs cv vp cv cun wceq cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vp cv va cv wcel
      vs cv cJ wcel vp cv cJ wcel wa vx cv vs cv wcel cJ ctop wcel cJ cuni va
      cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vp cv va cv wcel vs
      cv cJ wcel vp cv cJ wcel wa va cv cJ cpw wcel cJ ctop wcel vs cv va cv
      wcel vp cv va cv wcel vs cv cJ wcel vp cv cJ wcel wa wi wi cJ cuni va cv
      cuni wceq va cv cJ cpw wcel va cv cJ wss vs cv va cv wcel vp cv va cv
      wcel vs cv cJ wcel vp cv cJ wcel wa wi wi va cv cJ va visset elpw va cv
      cJ wss vs cv va cv wcel vp cv va cv wcel vs cv cJ wcel vp cv cJ wcel wa
      va cv cJ wss vs cv va cv wcel vs cv cJ wcel vp cv va cv wcel vp cv cJ
      wcel va cv cJ vs cv ssel va cv cJ vp cv ssel anim12d exp3a sylbi 3ad2ant3
      imp31 adantlrr adantrr vs cv vp cv cJ vs visset vp visset prss sylib
      sylanc vs cv vp cv vs visset vp visset unipr syl5eqelr eqeltrd exp32
      r19.23adv abssdv cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vt cv vs cv vp cv cun wceq vp va cv wrex vt cab cJ cpw wcel vt cv vs
      cv vp cv cun wceq vp va cv wrex vt cab cJ wss wb vs cv va cv wcel vx cv
      vs cv wcel wa cJ ctop wcel cJ cuni va cv cuni wceq vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab cJ cpw wcel vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab cJ wss wb va cv cJ cpw wcel vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab cJ ctop elpw2g 3ad2ant1 adantr mpbird cX vc cv cuni wceq
      vd cv vc cv wss cX vd cv cuni wceq wa vd cptfin wrex wi cX vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab cuni wceq vd cv vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa vd cptfin wrex wi vc
      vt cv vs cv vp cv cun wceq vp va cv wrex vt cab cJ cpw vc cv vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab wceq cX vc cv cuni wceq cX vt cv vs
      cv vp cv cun wceq vp va cv wrex vt cab cuni wceq vd cv vc cv wss cX vd cv
      cuni wceq wa vd cptfin wrex vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss cX vd cv cuni wceq wa vd cptfin wrex vc cv vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab wceq vc cv cuni vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab cuni cX vc cv vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab unieq eqeq2d vc cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wceq vd cv vc cv wss cX vd cv cuni wceq wa vd cv vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa vd cptfin
      vc cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wceq vd cv vc cv
      wss vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv
      cuni wceq vc cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab vd cv
      sseq2 anbi1d rexbidv imbi12d rcla4v syl mpid cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni
      wceq wa cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex vd cptfin cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa vd cv cptfin wcel cJ cuni vb cv cuni wceq
      vb va cv cpw cfn cin wrex cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa vd cv cptfin
      wcel cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vd cv cptfin wcel vx cv vz cv wcel vz vd cv crab
      cfn wcel vd cv cfn wcel cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex
      cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss cX vd cv cuni wceq wa wa vx cv vd cv cuni wcel vd cv
      cptfin wcel vx cv vz cv wcel vz vd cv crab cfn wcel wi cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vx cv cJ cuni vd cv cuni cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vx cv cJ cuni wcel vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab
      wss cX vd cv cuni wceq wa vx cv vs cv wcel vs cv cJ wcel vx cv cJ cuni
      wcel cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va
      cv wcel vx cv vs cv wcel wa wa vx cv vs cv cJ elunii cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      simprr va cv cJ cpw wcel cJ ctop wcel vs cv va cv wcel vx cv vs cv wcel
      wa vs cv cJ wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel vs cv va cv
      wcel vs cv cJ wcel vx cv vs cv wcel va cv cJ wss vs cv va cv wcel vs cv
      cJ wcel va cv cJ cpw wcel va cv cJ vs cv ssel2 va cv cJ va visset elpw
      sylanb adantrr 3ad2antl3 sylanc adantr cJ ctop wcel cJ cuni va cv cuni
      wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv
      vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa
      wa cX vd cv cuni cJ cuni cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq simprr comppfsc.1
      syl5eqr eleqtrd vd cv cptfin wcel vx cv vd cv cuni wcel vx cv vz cv wcel
      vz vd cv crab cfn wcel vz vd cv vx cv vd cv cuni vd cv cuni eqid ptfinfin
      expcom syl cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs
      cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp
      va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv vx cv vz cv wcel vz
      vd cv crab wss vx cv vz cv wcel vz vd cv crab cfn wcel vd cv cfn wcel wi
      cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss cX vd cv cuni wceq wa wa vd cv vd cv wss vx cv vz cv wcel
      vz vd cv wral wa vd cv vx cv vz cv wcel vz vd cv crab wss cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vx cv vz cv wcel vz vd cv wral vd cv vd cv wss cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa wa vx cv vz cv wcel vz vd cv cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs
      cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss
      vz cv vd cv wcel vx cv vz cv wcel wi cX vd cv cuni wceq vd cv vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab wss vz cv vd cv wcel vz cv vt cv vs
      cv vp cv cun wceq vp va cv wrex vt cab wcel cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vx cv vz cv wcel vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab vz
      cv ssel cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv
      va cv wcel vx cv vs cv wcel wa wa vz cv vs cv vp cv cun wceq vp va cv
      wrex vx cv vz cv wcel vz cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wcel cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv
      va cv wcel vx cv vs cv wcel wa wa vz cv vs cv vp cv cun wceq vx cv vz cv
      wcel vp va cv cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a
      vs cv va cv wcel vx cv vs cv wcel wa wa vz cv vs cv vp cv cun wceq vx cv
      vz cv wcel wi vp cv va cv wcel vz cv vs cv vp cv cun wceq vx cv vz cv
      wcel vx cv vs cv vp cv cun wcel cJ ctop wcel cJ cuni va cv cuni wceq va
      cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vz cv vs cv vp
      cv cun vx cv eleq2 vx cv vs cv wcel vx cv vs cv vp cv cun wcel cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv
      vs cv vp cv elun1 ad2antll syl5cbir a1d r19.23adv vt cv vs cv vp cv cun
      wceq vp va cv wrex vz cv vs cv vp cv cun wceq vp va cv wrex vt vz cv vz
      visset vt cv vz cv wceq vt cv vs cv vp cv cun wceq vz cv vs cv vp cv cun
      wceq vp va cv vt cv vz cv vs cv vp cv cun eqeq1 rexbidv elab syl5ib
      sylan9r adantrr r19.21aiv vd cv ssid jctil vx cv vz cv wcel vz vd cv vd
      cv ssrab sylibr vx cv vz cv wcel vz vd cv crab cfn wcel vd cv vx cv vz cv
      wcel vz vd cv crab wss vd cv cfn wcel vx cv vz cv wcel vz vd cv crab vd
      cv ssfi expcom syl cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd
      cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa
      vf wex cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vq cv vs cv vp cv cun wceq vp va cv wrex vq vd cv
      wral vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun
      wceq vq vd cv wral wa vf wex wi vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss vq cv vs cv vp cv cun wceq vp va cv wrex vq vd cv wral cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa cX vd cv cuni wceq vd cv vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab wss vq cv vs cv vp cv cun wceq vp va cv wrex vq
      vd cv vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss vq cv vd
      cv wcel vq cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wcel vq cv
      vs cv vp cv cun wceq vp va cv wrex vd cv vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab vq cv ssel vt cv vs cv vp cv cun wceq vp va cv wrex vq cv
      vs cv vp cv cun wceq vp va cv wrex vt vq cv vq visset vt cv vq cv wceq vt
      cv vs cv vp cv cun wceq vq cv vs cv vp cv cun wceq vp va cv vt cv vq cv
      vs cv vp cv cun eqeq1 rexbidv elab syl6ib r19.21aiv ad2antrl vd cv cfn
      wcel vq cv vs cv vp cv cun wceq vp va cv wrex vq vd cv wral vd cv va cv
      vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa vf wex vq
      cv vs cv vp cv cun wceq vq cv vs cv vq cv vf cv cfv cun wceq vq vp vd cv
      va cv vf vp cv vq cv vf cv cfv wceq vs cv vp cv cun vs cv vq cv vf cv cfv
      cun vq cv vp cv vq cv vf cv cfv vs cv uneq2 eqeq2d ac6sfi expcom syl cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq
      cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa vf wex cJ cuni vb cv
      cuni wceq vb va cv cpw cfn cin wrex wi cJ ctop wcel cJ cuni va cv cuni
      wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv
      vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa
      wa vd cv cfn wcel wa vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun
      wceq vq vd cv wral wa cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex
      vf cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv
      wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa cJ cuni vb cv
      cuni wceq vb va cv cpw cfn cin wrex vf cv crn vs cv csn cun va cv cpw cfn
      cin wcel cJ cuni vf cv crn vs cv csn cun cuni wceq cJ cuni vb cv cuni
      wceq vb va cv cpw cfn cin wrex cJ ctop wcel cJ cuni va cv cuni wceq va cv
      cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv
      cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd
      cv wral wa wa wa cJ cuni vb cv cuni wceq cJ cuni vf cv crn vs cv csn cun
      cuni wceq vb vf cv crn vs cv csn cun va cv cpw cfn cin vb cv vf cv crn vs
      cv csn cun wceq vb cv cuni vf cv crn vs cv csn cun cuni cJ cuni vb cv vf
      cv crn vs cv csn cun unieq eqeq2d rcla4ev cJ ctop wcel cJ cuni va cv cuni
      wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv
      vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa
      wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun
      wceq vq vd cv wral wa wa wa vf cv crn vs cv csn cun va cv wss vf cv crn
      vs cv csn cun cfn wcel wa vf cv crn vs cv csn cun va cv cpw cfn cin wcel
      cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv
      wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vf cv crn
      vs cv csn cun va cv wss vf cv crn vs cv csn cun cfn wcel cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq
      cv vf cv cfv cun wceq vq vd cv wral wa wa wa vf cv crn va cv wss vs cv
      csn va cv wss wa vf cv crn vs cv csn cun va cv wss cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv
      cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf
      cv cfv cun wceq vq vd cv wral wa wa wa vf cv crn va cv wss vs cv csn va
      cv wss vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv
      wral wa vf cv crn va cv wss cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn
      wcel vd cv va cv vf cv wf vf cv crn va cv wss vq cv vs cv vq cv vf cv cfv
      cun wceq vq vd cv wral vd cv va cv vf cv frn adantr ad2antll cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs
      cv wcel wa wa vs cv csn va cv wss vd cv vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab wss cX vd cv cuni wceq wa vd cv cfn wcel vd cv va cv vf cv
      wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa vs cv va cv
      wcel vs cv csn va cv wss cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vx cv vs cv wcel vs cv va cv snssi ad2antrl ad2antrr jca vf
      cv crn vs cv csn va cv unss sylib cJ ctop wcel cJ cuni va cv cuni wceq va
      cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs
      cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv
      cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd
      cv wral wa wa wa vf cv crn cfn wcel vf cv crn vs cv csn cun cfn wcel vd
      cv cfn wcel vf cv crn vd cv cdom wbr vf cv crn cfn wcel cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq
      cv vf cv cfv cun wceq vq vd cv wral wa wa wa vd cv vf cv crn domfi cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq
      cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa simprl vd cv cfn wcel
      vd cv vf cv crn vf cv wfo vf cv crn vd cv cdom wbr cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv
      cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf
      cv cfv cun wceq vq vd cv wral wa wa wa vd cv vf cv crn vf cv fodomfi cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq
      cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa simprl vd cv va cv vf
      cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa vd cv vf cv
      crn vf cv wfo cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a
      vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq
      vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va
      cv vf cv wf vd cv vf cv crn vf cv wfo vq cv vs cv vq cv vf cv cfv cun
      wceq vq vd cv wral vd cv va cv vf cv wf vf cv vd cv wfn vd cv vf cv crn
      vf cv wfo vd cv va cv vf cv ffn vd cv vf cv dffn4 sylib adantr ad2antll
      sylanc sylanc vf cv crn cfn wcel vs cv csn cfn wcel vf cv crn vs cv csn
      cun cfn wcel vs cv snfi vf cv crn vs cv csn unfi mpan2 syl jca vf cv crn
      vs cv csn cun va cv cpw cfn cin wcel vf cv crn vs cv csn cun va cv cpw
      wcel vf cv crn vs cv csn cun cfn wcel wa vf cv crn vs cv csn cun va cv
      wss vf cv crn vs cv csn cun cfn wcel wa vf cv crn vs cv csn cun va cv cpw
      cfn elin vf cv crn vs cv csn cun va cv cpw wcel vf cv crn vs cv csn cun
      va cv wss vf cv crn vs cv csn cun cfn wcel vf cv crn vs cv csn cun va cv
      va visset elpw2 anbi1i bitri sylibr cJ ctop wcel cJ cuni va cv cuni wceq
      va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv
      vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd
      cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq
      vd cv wral wa wa wa cJ cuni vf cv crn vs cv csn cun cuni cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq
      cv vf cv cfv cun wceq vq vd cv wral wa wa wa cJ cuni vd cv cuni vf cv crn
      vs cv csn cun cuni cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel
      w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun
      wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd
      cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa
      wa wa cX vd cv cuni cJ cuni cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq vd cv cfn wcel vd
      cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa
      wa simplrr comppfsc.1 syl5eqr cJ ctop wcel cJ cuni va cv cuni wceq va cv
      cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv
      vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv
      cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd
      cv wral wa wa wa vy vd cv cuni vf cv crn vs cv csn cun cuni cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs
      cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss
      cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv
      vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vy cv vz cv wcel vz cv vd
      cv wcel wa vz wex vy cv vf cv crn vs cv csn cun cuni wcel vy cv vd cv
      cuni wcel cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs
      cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp
      va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv
      vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vy
      cv vz cv wcel vz cv vd cv wcel wa vy cv vf cv crn vs cv csn cun cuni wcel
      vz cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv
      wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv
      wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv
      wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vy cv vz
      cv wcel vz cv vd cv wcel vy cv vf cv crn vs cv csn cun cuni wcel cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv
      vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab
      wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs
      cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vz cv vd cv wcel vy cv
      vz cv wcel vy cv vf cv crn vs cv csn cun cuni wcel cJ ctop wcel cJ cuni
      va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel
      wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv
      cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf
      cv cfv cun wceq vq vd cv wral wa wa wa vz cv vd cv wcel vz cv vs cv vz cv
      vf cv cfv cun wceq vy cv vz cv wcel vy cv vf cv crn vs cv csn cun cuni
      wcel wi vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd
      cv wral wa vz cv vd cv wcel vz cv vs cv vz cv vf cv cfv cun wceq wi cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vq cv vs cv vq cv vf cv
      cfv cun wceq vq vd cv wral vz cv vd cv wcel vz cv vs cv vz cv vf cv cfv
      cun wceq wi vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vz
      cv vs cv vz cv vf cv cfv cun wceq vq vz cv vd cv vq cv vz cv wceq vq cv
      vz cv vs cv vq cv vf cv cfv cun vs cv vz cv vf cv cfv cun vq cv vz cv
      wceq id vq cv vz cv wceq vq cv vf cv cfv vz cv vf cv cfv vs cv vq cv vz
      cv vf cv fveq2 uneq2d eqeq12d rcla4cv adantl ad2antll cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv
      wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX
      vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq
      cv vf cv cfv cun wceq vq vd cv wral wa wa wa vz cv vd cv wcel vz cv vs cv
      vz cv vf cv cfv cun wceq vy cv vz cv wcel vy cv vf cv crn vs cv csn cun
      cuni wcel wi wi vz cv vs cv vz cv vf cv cfv cun wceq vy cv vz cv wcel vy
      cv vf cv crn vs cv csn cun cuni wcel wi vy cv vs cv vz cv vf cv cfv cun
      wcel vy cv vf cv crn vs cv csn cun cuni wcel wi cJ ctop wcel cJ cuni va
      cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa
      wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv
      cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf
      cv cfv cun wceq vq vd cv wral wa wa wa vz cv vd cv wcel wa vz cv vs cv vz
      cv vf cv cfv cun wceq vy cv vz cv wcel vy cv vs cv vz cv vf cv cfv cun
      wcel vy cv vf cv crn vs cv csn cun cuni wcel vz cv vs cv vz cv vf cv cfv
      cun vy cv eleq2 imbi1d cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw
      wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv
      cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel
      vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral
      wa wa wa vz cv vd cv wcel wa vy cv vs cv wcel vy cv vz cv vf cv cfv wcel
      wo vy cv vf cv crn vs cv csn cun cuni wcel vy cv vs cv vz cv vf cv cfv
      cun wcel cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv
      va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf
      cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vz cv
      vd cv wcel wa vy cv vs cv wcel vy cv vf cv crn vs cv csn cun cuni wcel vy
      cv vz cv vf cv cfv wcel vy cv vs cv wcel vy cv vf cv crn vs cv csn cun
      cuni wcel wi cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a
      vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq
      vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va
      cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa
      vz cv vd cv wcel wa vy cv vs cv wcel vs cv vf cv crn vs cv csn cun wcel
      vy cv vf cv crn vs cv csn cun cuni wcel vs cv vs cv csn wcel vs cv vf cv
      crn vs cv csn cun wcel vs cv vs visset snid vs cv vs cv csn vf cv crn
      elun2 ax-mp vy cv vs cv vf cv crn vs cv csn cun elunii mpan2 a1i cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv
      vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab
      wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs
      cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vz cv vd cv wcel vy cv
      vz cv vf cv cfv wcel vy cv vf cv crn vs cv csn cun cuni wcel wi vd cv va
      cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa vz cv
      vd cv wcel vy cv vz cv vf cv cfv wcel vy cv vf cv crn vs cv csn cun cuni
      wcel wi wi cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs
      cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp
      va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv
      vf cv wf vz cv vd cv wcel vy cv vz cv vf cv cfv wcel vy cv vf cv crn vs
      cv csn cun cuni wcel wi wi vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv
      wral vd cv va cv vf cv wf vf cv vd cv wfn vz cv vd cv wcel vy cv vz cv vf
      cv cfv wcel vy cv vf cv crn vs cv csn cun cuni wcel wi wi vd cv va cv vf
      cv ffn vf cv vd cv wfn vz cv vd cv wcel vz cv vf cv cfv vf cv crn wcel vy
      cv vz cv vf cv cfv wcel vy cv vf cv crn vs cv csn cun cuni wcel wi vf cv
      vd cv wfn vz cv vd cv wcel vz cv vf cv cfv vf cv crn wcel vd cv vz cv vf
      cv fnfvelrn ex vy cv vz cv vf cv cfv wcel vz cv vf cv cfv vf cv crn wcel
      vy cv vf cv crn vs cv csn cun cuni wcel vy cv vz cv vf cv cfv wcel vz cv
      vf cv cfv vf cv crn wcel wa vy cv vf cv crn cuni wcel vy cv vf cv crn vs
      cv csn cun cuni wcel vy cv vz cv vf cv cfv vf cv crn elunii vf cv crn
      cuni vf cv crn vs cv csn cun cuni vy cv vf cv crn vf cv crn vs cv csn cun
      wss vf cv crn cuni vf cv crn vs cv csn cun cuni wss vf cv crn vs cv csn
      ssun1 vf cv crn vf cv crn vs cv csn cun uniss ax-mp sseli syl expcom syl6
      syl adantr ad2antll imp jaod vy cv vs cv vz cv vf cv cfv elun syl5ib
      syl5cbir ex mpdd com23 imp3a 19.23adv vz vy cv vd cv eluni syl5ib ssrdv
      eqsstrd cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv
      va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf
      cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vf cv
      crn vs cv csn cun cJ wss vf cv crn vs cv csn cun cuni cJ cuni wss cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv
      vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab
      wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs
      cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vf cv crn cJ wss vs cv
      csn cJ wss wa vf cv crn vs cv csn cun cJ wss cJ ctop wcel cJ cuni va cv
      cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa
      vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni
      wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq cv vs cv vq cv vf cv
      cfv cun wceq vq vd cv wral wa wa wa vf cv crn cJ wss vs cv csn cJ wss cJ
      ctop wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel
      vx cv vs cv wcel wa wa vd cv vt cv vs cv vp cv cun wceq vp va cv wrex vt
      cab wss cX vd cv cuni wceq wa wa vd cv cfn wcel vd cv va cv vf cv wf vq
      cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa wa vf cv crn va cv
      cJ vd cv va cv vf cv wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv
      wral wa vf cv crn va cv wss cJ ctop wcel cJ cuni va cv cuni wceq va cv cJ
      cpw wcel w3a vs cv va cv wcel vx cv vs cv wcel wa wa vd cv vt cv vs cv vp
      cv cun wceq vp va cv wrex vt cab wss cX vd cv cuni wceq wa wa vd cv cfn
      wcel vd cv va cv vf cv wf vf cv crn va cv wss vq cv vs cv vq cv vf cv cfv
      cun wceq vq vd cv wral vd cv va cv vf cv frn adantr ad2antll cJ ctop wcel
      cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv vs
      cv wcel wa wa va cv cJ wss vd cv vt cv vs cv vp cv cun wceq vp va cv wrex
      vt cab wss cX vd cv cuni wceq wa vd cv cfn wcel vd cv va cv vf cv wf vq
      cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa cJ ctop wcel cJ
      cuni va cv cuni wceq va cv cJ cpw wcel w3a va cv cJ wss vs cv va cv wcel
      vx cv vs cv wcel wa va cv cJ cpw wcel cJ ctop wcel va cv cJ wss cJ cuni
      va cv cuni wceq va cv cJ elpwi 3ad2ant3 adantr ad2antrr sstrd cJ ctop
      wcel cJ cuni va cv cuni wceq va cv cJ cpw wcel w3a vs cv va cv wcel vx cv
      vs cv wcel wa wa vs cv csn cJ wss vd cv vt cv vs cv vp cv cun wceq vp va
      cv wrex vt cab wss cX vd cv cuni wceq wa vd cv cfn wcel vd cv va cv vf cv
      wf vq cv vs cv vq cv vf cv cfv cun wceq vq vd cv wral wa wa va cv cJ cpw
      wcel cJ ctop wcel vs cv va cv wcel vx cv vs cv wcel wa vs cv csn cJ wss
      cJ cuni va cv cuni wceq va cv cJ cpw wcel vs cv va cv wcel vs cv csn cJ
      wss vx cv vs cv wcel va cv cJ wss vs cv va cv wcel vs cv csn cJ wss va cv
      cJ cpw wcel va cv cJ wss vs cv va cv wcel wa vs cv cJ wcel vs cv csn cJ
      wss va cv cJ vs cv ssel2 vs cv cJ snssi syl va cv cJ va visset elpw
      sylanb adantrr 3ad2antl3 ad2antrr jca vf cv crn vs cv csn cJ unss sylib
      vf cv crn vs cv csn cun cJ uniss syl eqssd sylanc expr 19.23adv ex mpdd
      3syld ex com23 r19.23adv syld exp32 adantr r19.23adv ex mpdd 19.23adv vx
      cX n0 syl5ib pm2.61dne 3exp com24 r19.21adv cJ ccomp wcel cJ ctop wcel cJ
      cuni va cv cuni wceq cJ cuni vb cv cuni wceq vb va cv cpw cfn cin wrex wi
      va cJ cpw wral va vb cJ iscomp baibr sylibd impbid2 $.
      $( [21-Jan-2010] $) $( [21-Jan-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Neighborhood bases determine topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d f g h j k m n r s t u v w x y z B $.
    $d d g j k m n o r s t v F $. $d a b c d g j k m n o r s t v x z G $.
    $d a b c d g j k m n o r s u v y U $. $d a b c d g m r s t w z U $.
    $d a b c d f g h j k m n o r s t u v x y z X $.
    $d a b c d f g h j k m n o r s t u v w x z W $. $d g m n u v $. $d
    a b m s t u v w $. $d a b m o s u w $. $d v x $. $d a b m s u y $.
    neibastop1.1 $e |- ( x = y -> U = W ) $.
    $( A collection of neighborhood bases determines a topology. Part of
       Theorem 4.5 of Stephen Willard's _General Topology_. $)
    neibastop1 $p |- ( ( X e. B /\ A. x e. X ( U =/= (/) /\ A. v e. U ( ( x e.
    v /\ v C_ X ) /\ ( A. w e. U E. t e. U t C_ ( v i^i w ) /\ E. t e. U A. y
    e. t E. w e. W w C_ v ) ) ) ) -> { o | ( o C_ X /\ A. x e. o E. v e. U v C_
    o ) } e. Top ) $=
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab ctop wcel vs cv vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wss vs cv cuni vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel wi vs wal vs cv vu cv
      cin vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel
      vu vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral
      vs vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral
      wa cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral vs cv vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wss vs cv cuni vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab wcel wi vs wal vs cv vu cv cin vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel vu vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral vs vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral wa cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vv cU wral vx cX wral vs cv vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab wss vs cv cuni vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wcel wi vs wal vs cv vu cv cin vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel vu vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral vs vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral wa cU c0 wne vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vx cX vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral cU c0 wne vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vv cU vx cv vv cv wcel vv cv cX
      wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
      cW wrex vy vt cv wral vt cU wrex simprl r19.20si adantl r19.20si vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vx cX wral vs cv vu cv
      cin vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel
      vu vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral
      vs vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wral
      vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wss
      vs cv cuni vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab wcel wi vs wal vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU
      wral vx cX wral vs cv vu cv cin vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab wcel vs vu vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv
      cU wral vx cX wral vs cv cX wss vv cv vs cv wss vv cU wrex vx vs cv wral
      wa vu cv cX wss vv cv vu cv wss vv cU wrex vx vu cv wral wa wa vs cv vu
      cv cin cX wss vv cv vs cv vu cv cin wss vv cU wrex vx vs cv vu cv cin
      wral wa vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab wcel vu cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab wcel wa vs cv vu cv cin vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vv cU wral vx cX wral vs cv cX wss vv cv vs cv wss vv cU wrex vx vs cv
      wral wa vu cv cX wss vv cv vu cv wss vv cU wrex vx vu cv wral wa wa vs cv
      vu cv cin cX wss vv cv vs cv vu cv cin wss vv cU wrex vx vs cv vu cv cin
      wral vs cv cX wss vv cv vs cv wss vv cU wrex vx vs cv wral wa vu cv cX
      wss vv cv vu cv wss vv cU wrex vx vu cv wral wa wa vs cv vu cv cin cX wss
      wi vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vx cX wral
      vs cv cX wss vs cv vu cv cin cX wss vv cv vs cv wss vv cU wrex vx vs cv
      wral vu cv cX wss vv cv vu cv wss vv cU wrex vx vu cv wral wa vs cv vu cv
      cX ssinss1 ad2antrr a1i vs cv cX wss vv cv vs cv wss vv cU wrex vx vs cv
      wral wa vu cv cX wss vv cv vu cv wss vv cU wrex vx vu cv wral wa wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vx cX wral vv cv vs
      cv vu cv cin wss vv cU wrex vx vs cv vu cv cin wral vs cv cX wss vv cv vs
      cv wss vv cU wrex vx vs cv wral wa vv cv vu cv wss vv cU wrex vx vu cv
      wral vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vx cX
      wral vv cv vs cv vu cv cin wss vv cU wrex vx vs cv vu cv cin wral wi vu
      cv cX wss vs cv cX wss vv cv vs cv wss vv cU wrex vx vs cv wral wa vv cv
      vu cv wss vv cU wrex vx vu cv wral wa vx cv cX wcel vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vv cU wral wi vx wal vx cv vs cv vu cv cin wcel
      vv cv vs cv vu cv cin wss vv cU wrex wi vx wal vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vv cU wral vx cX wral vv cv vs cv vu cv cin wss vv
      cU wrex vx vs cv vu cv cin wral vs cv cX wss vv cv vs cv wss vv cU wrex
      vx vs cv wral vv cv vu cv wss vv cU wrex vx vu cv wral vx cv cX wcel vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral wi vx wal vx cv
      vs cv vu cv cin wcel vv cv vs cv vu cv cin wss vv cU wrex wi vx wal wi vs
      cv cX wss vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv wcel
      vv cv vu cv wss vv cU wrex wi wa vx wal vx cv cX wcel vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vv cU wral wi vx wal vx cv vs cv vu cv cin
      wcel vv cv vs cv vu cv cin wss vv cU wrex wi vx wal wi vv cv vs cv wss vv
      cU wrex vx vs cv wral vv cv vu cv wss vv cU wrex vx vu cv wral wa vs cv
      cX wss vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv wcel vv
      cv vu cv wss vv cU wrex wi wa vx wal vx cv cX wcel vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vv cU wral wi vx wal vx cv vs cv vu cv cin wcel
      vv cv vs cv vu cv cin wss vv cU wrex wi vx wal vs cv cX wss vx cv vs cv
      wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv wcel vv cv vu cv wss vv cU
      wrex wi wa vx cv cX wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vv cU wral wi wa vx wal vx cv vs cv vu cv cin wcel vv cv vs cv vu cv cin
      wss vv cU wrex wi vx wal vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi
      vx cv vu cv wcel vv cv vu cv wss vv cU wrex wi wa vx wal vx cv cX wcel vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral wi vx wal wa vs
      cv cX wss vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv wcel
      vv cv vu cv wss vv cU wrex wi wa vx cv cX wcel vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vv cU wral wi wa vx cv vs cv vu cv cin wcel vv cv
      vs cv vu cv cin wss vv cU wrex wi vx vx cv vs cv vu cv cin wcel vs cv cX
      wss vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv wcel vv cv
      vu cv wss vv cU wrex wi wa vx cv cX wcel vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vv cU wral wi wa vv cv vs cv vu cv cin wss vv cU wrex vx
      cv vs cv vu cv cin wcel vs cv cX wss vx cv vs cv wcel vx cv vu cv wcel vx
      cv cX wcel w3a vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv
      wcel vv cv vu cv wss vv cU wrex wi wa vx cv cX wcel vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vv cU wral wi wa vv cv vs cv vu cv cin wss vv
      cU wrex wi vx cv vs cv vu cv cin wcel vs cv cX wss vx cv vs cv wcel vx cv
      vu cv wcel vx cv cX wcel vx cv vs cv vu cv cin wcel vx cv vs cv wcel vs
      cv cX wss vs cv vu cv cin vs cv vx cv vs cv vu cv inss1 sseli a1d vx cv
      vs cv vu cv cin wcel vx cv vu cv wcel vs cv cX wss vs cv vu cv cin vu cv
      vx cv vs cv vu cv inss2 sseli a1d vs cv cX wss vx cv vs cv wcel vx cv cX
      wcel vx cv vs cv vu cv cin wcel vs cv cX vx cv ssel vs cv vu cv cin vs cv
      vx cv vs cv vu cv inss1 sseli syl5com 3jcad vx cv vs cv wcel vx cv vu cv
      wcel vx cv cX wcel w3a vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx
      cv vu cv wcel vv cv vu cv wss vv cU wrex wi vx cv cX wcel vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vv cU wral wi vv cv vs cv vu cv cin wss
      vv cU wrex vx cv vs cv wcel vx cv vu cv wcel vx cv cX wcel w3a vx cv vs
      cv wcel vv cv vs cv wss vv cU wrex wi vv cv vs cv wss vv cU wrex vx cv vu
      cv wcel vv cv vu cv wss vv cU wrex wi vx cv cX wcel vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vv cU wral wi vv cv vs cv vu cv cin wss vv cU
      wrex wi wi vx cv vs cv wcel vx cv vu cv wcel vx cv vs cv wcel vv cv vs cv
      wss vv cU wrex wi vv cv vs cv wss vv cU wrex wi vx cv cX wcel vx cv vs cv
      wcel vv cv vs cv wss vv cU wrex pm2.27 3ad2ant1 vx cv vs cv wcel vx cv vu
      cv wcel vx cv cX wcel w3a vx cv vu cv wcel vv cv vu cv wss vv cU wrex wi
      vv cv vs cv wss vv cU wrex vx cv cX wcel vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vv cU wral wi vv cv vs cv vu cv cin wss vv cU wrex wi vx
      cv vs cv wcel vx cv vu cv wcel vx cv cX wcel w3a vx cv vu cv wcel vv cv
      vu cv wss vv cU wrex wi vv cv vu cv wss vv cU wrex vv cv vs cv wss vv cU
      wrex vx cv cX wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU
      wral wi vv cv vs cv vu cv cin wss vv cU wrex wi wi vx cv vu cv wcel vx cv
      vs cv wcel vx cv vu cv wcel vv cv vu cv wss vv cU wrex wi vv cv vu cv wss
      vv cU wrex wi vx cv cX wcel vx cv vu cv wcel vv cv vu cv wss vv cU wrex
      pm2.27 3ad2ant2 vx cv vs cv wcel vx cv vu cv wcel vx cv cX wcel w3a vx cv
      cX wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral wi vv
      cv vs cv wss vv cU wrex vv cv vu cv wss vv cU wrex vv cv vs cv vu cv cin
      wss vv cU wrex vx cv vs cv wcel vx cv vu cv wcel vx cv cX wcel w3a vx cv
      cX wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral wi vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vv cv vs cv wss
      vv cU wrex vv cv vu cv wss vv cU wrex vv cv vs cv vu cv cin wss vv cU
      wrex wi wi vx cv cX wcel vx cv vs cv wcel vx cv cX wcel vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vv cU wral wi vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vv cU wral wi vx cv vu cv wcel vx cv cX wcel vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vv cU wral pm2.27 3ad2ant3 vv cv
      vs cv wss vv cU wrex vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv
      cU wral vv cv vu cv wss vv cU wrex vv cv vs cv vu cv cin wss vv cU wrex
      wi vv cv vs cv wss vv cU wrex vb cv vs cv wss vb cU wrex vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vv cU wral vv cv vu cv wss vv cU wrex vv
      cv vs cv vu cv cin wss vv cU wrex wi wi vv cv vs cv wss vb cv vs cv wss
      vv vb cU vv cv vb cv vs cv sseq1 cbvrexv vb cv vs cv wss vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vv cU wral vv cv vu cv wss vv cU wrex vv
      cv vs cv vu cv cin wss vv cU wrex wi wi vb cU vv cv vu cv wss vv cU wrex
      vb cv vs cv wss vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU
      wral vb cv cU wcel vv cv vs cv vu cv cin wss vv cU wrex vv cv vu cv wss
      vv cU wrex va cv vu cv wss va cU wrex vb cv vs cv wss vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vv cU wral vb cv cU wcel vv cv vs cv vu cv
      cin wss vv cU wrex wi wi wi vv cv vu cv wss va cv vu cv wss vv va cU vv
      cv va cv vu cv sseq1 cbvrexv va cv vu cv wss vb cv vs cv wss vt cv vv cv
      vw cv cin wss vt cU wrex vw cU wral vv cU wral vb cv cU wcel vv cv vs cv
      vu cv cin wss vv cU wrex wi wi wi va cU va cv cU wcel vb cv cU wcel vb cv
      vs cv wss vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral va
      cv vu cv wss vv cv vs cv vu cv cin wss vv cU wrex va cv cU wcel vb cv cU
      wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU wral vb cv vs
      cv wss va cv vu cv wss vv cv vs cv vu cv cin wss vv cU wrex wi va cv cU
      wcel vb cv cU wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU
      wral vb cv vs cv wss va cv vu cv wss vv cv vs cv vu cv cin wss vv cU wrex
      wi wi wi va cv cU wcel vb cv cU wcel wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vv cU wral vt cv va cv vb cv cin wss vt cU wrex vb cv vs
      cv wss va cv vu cv wss vv cv vs cv vu cv cin wss vv cU wrex wi wi vt cv
      vv cv vw cv cin wss vt cU wrex vt cv va cv vb cv cin wss vt cU wrex vt cv
      va cv vw cv cin wss vt cU wrex vv vw va cv vb cv cU cU vv cv va cv wceq
      vt cv vv cv vw cv cin wss vt cv va cv vw cv cin wss vt cU vv cv va cv
      wceq vv cv vw cv cin va cv vw cv cin vt cv vv cv va cv vw cv ineq1 sseq2d
      rexbidv vw cv vb cv wceq vt cv va cv vw cv cin wss vt cv va cv vb cv cin
      wss vt cU vw cv vb cv wceq va cv vw cv cin va cv vb cv cin vt cv vw cv vb
      cv va cv ineq2 sseq2d rexbidv rcla42v vt cv va cv vb cv cin wss vb cv vs
      cv wss va cv vu cv wss vv cv vs cv vu cv cin wss vv cU wrex wi wi vt cU
      vt cv cU wcel vt cv va cv vb cv cin wss vb cv vs cv wss va cv vu cv wss
      vv cv vs cv vu cv cin wss vv cU wrex vt cv cU wcel vt cv vs cv vu cv cin
      wss vv cv vs cv vu cv cin wss vv cU wrex vt cv va cv vb cv cin wss vb cv
      vs cv wss va cv vu cv wss wa wa vv cv vs cv vu cv cin wss vt cv vs cv vu
      cv cin wss vv vt cv cU vv cv vt cv vs cv vu cv cin sseq1 rcla4ev vt cv va
      cv vb cv cin wss vb cv vs cv wss va cv vu cv wss wa wa vt cv vs cv wss vt
      cv vu cv wss wa vt cv vs cv vu cv cin wss vt cv va cv vb cv cin wss vb cv
      vs cv wss va cv vu cv wss wa wa vt cv vs cv wss vt cv vu cv wss vt cv va
      cv vb cv cin wss vb cv vs cv wss vt cv vs cv wss va cv vu cv wss vt cv vb
      cv wss vb cv vs cv wss vt cv vs cv wss vt cv va cv vb cv cin wss vt cv vb
      cv vs cv sstr vt cv va cv vb cv cin wss va cv vb cv cin vb cv wss vt cv
      vb cv wss va cv vb cv inss2 vt cv va cv vb cv cin vb cv sstr mpan2 sylan
      adantrr vt cv va cv vb cv cin wss va cv vu cv wss vt cv vu cv wss vb cv
      vs cv wss vt cv va cv wss va cv vu cv wss vt cv vu cv wss vt cv va cv vb
      cv cin wss vt cv va cv vu cv sstr vt cv va cv vb cv cin wss va cv vb cv
      cin va cv wss vt cv va cv wss va cv vb cv inss1 vt cv va cv vb cv cin va
      cv sstr mpan2 sylan adantrl jca vt cv vs cv vu cv ssin sylib sylan2 exp45
      r19.23aiv syl6 ex com34 com25 r19.23aiv sylbi com14 r19.23aiv sylbi com12
      syl6 com24 syld com23 syld imp4c syl6 com3l 19.20dv vx cv vs cv wcel vv
      cv vs cv wss vv cU wrex wi vx cv vu cv wcel vv cv vu cv wss vv cU wrex wi
      wa vx cv cX wcel vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU
      wral wi vx 19.26 syl5ibr expdimp vv cv vs cv wss vv cU wrex vx vs cv wral
      vv cv vu cv wss vv cU wrex vx vu cv wral wa vx cv vs cv wcel vv cv vs cv
      wss vv cU wrex wi vx wal vx cv vu cv wcel vv cv vu cv wss vv cU wrex wi
      vx wal wa vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx cv vu cv wcel
      vv cv vu cv wss vv cU wrex wi wa vx wal vv cv vs cv wss vv cU wrex vx vs
      cv wral vx cv vs cv wcel vv cv vs cv wss vv cU wrex wi vx wal vv cv vu cv
      wss vv cU wrex vx vu cv wral vx cv vu cv wcel vv cv vu cv wss vv cU wrex
      wi vx wal vv cv vs cv wss vv cU wrex vx vs cv df-ral vv cv vu cv wss vv
      cU wrex vx vu cv df-ral anbi12i vx cv vs cv wcel vv cv vs cv wss vv cU
      wrex wi vx cv vu cv wcel vv cv vu cv wss vv cU wrex wi vx 19.26 bitr4i
      sylan2b anassrs vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vv cU
      wral vx cX df-ral vv cv vs cv vu cv cin wss vv cU wrex vx vs cv vu cv cin
      df-ral 3imtr4g adantrl com12 jcad vs cv vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab wcel vs cv cX wss vv cv vs cv wss vv cU
      wrex vx vs cv wral wa vu cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab wcel vu cv cX wss vv cv vu cv wss vv cU wrex vx vu cv
      wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vs cv cX
      wss vv cv vs cv wss vv cU wrex vx vs cv wral wa vo vs cv vs visset vo cv
      vs cv wceq vo cv cX wss vs cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral vv cv vs cv wss vv cU wrex vx vs cv wral vo cv vs cv cX sseq1 vv cv
      vo cv wss vv cU wrex vv cv vs cv wss vv cU wrex vx vo cv vs cv vo cv vs
      cv wceq vv cv vo cv wss vv cv vs cv wss vv cU vo cv vs cv vv cv sseq2
      rexbidv raleqd anbi12d elab vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vu cv cX wss vv cv vu cv wss vv cU wrex vx vu cv wral wa vo vu
      cv vu visset vo cv vu cv wceq vo cv cX wss vu cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral vv cv vu cv wss vv cU wrex vx vu cv wral vo cv
      vu cv cX sseq1 vv cv vo cv wss vv cU wrex vv cv vu cv wss vv cU wrex vx
      vo cv vu cv vo cv vu cv wceq vv cv vo cv wss vv cv vu cv wss vv cU vo cv
      vu cv vv cv sseq2 rexbidv raleqd anbi12d elab anbi12i vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vs cv vu cv cin cX wss vv cv vs cv
      vu cv cin wss vv cU wrex vx vs cv vu cv cin wral wa vo vs cv vu cv cin vs
      cv vu cv vs visset inex1 vo cv vs cv vu cv cin wceq vo cv cX wss vs cv vu
      cv cin cX wss vv cv vo cv wss vv cU wrex vx vo cv wral vv cv vs cv vu cv
      cin wss vv cU wrex vx vs cv vu cv cin wral vo cv vs cv vu cv cin cX sseq1
      vv cv vo cv wss vv cU wrex vv cv vs cv vu cv cin wss vv cU wrex vx vo cv
      vs cv vu cv cin vo cv vs cv vu cv cin wceq vv cv vo cv wss vv cv vs cv vu
      cv cin wss vv cU vo cv vs cv vu cv cin vv cv sseq2 rexbidv raleqd anbi12d
      elab 3imtr4g r19.21aivv vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab wss vs cv cuni vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wcel wi vs vs cv vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wss vs cv cuni cX wss vv cv vs cv
      cuni wss vv cU wrex vx vs cv cuni wral wa vs cv cuni vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel vs cv vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wss vs cv cuni cX wss vv
      cv vs cv cuni wss vv cU wrex vx vs cv cuni wral vs cv vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab wss va cv cX wss va vs cv
      wral vs cv cuni cX wss vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab wss va cv cX wss va vs cv vs cv vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab wss va cv vs cv wcel va cv
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel va
      cv cX wss vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab va cv ssel va cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab wcel va cv cX wss vv cv va cv wss vv cU wrex vx va cv wral
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa va cv cX wss vv
      cv va cv wss vv cU wrex vx va cv wral wa vo va cv va visset vo cv va cv
      wceq vo cv cX wss va cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      vv cv va cv wss vv cU wrex vx va cv wral vo cv va cv cX sseq1 vv cv vo cv
      wss vv cU wrex vv cv va cv wss vv cU wrex vx vo cv va cv vo cv va cv wceq
      vv cv vo cv wss vv cv va cv wss vv cU vo cv va cv vv cv sseq2 rexbidv
      raleqd anbi12d elab pm3.26bi syl6 r19.21aiv va vs cv cX unissb sylibr vs
      cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wss vv
      cv vs cv cuni wss vv cU wrex vx vs cv cuni vx va vs cv vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab va cv vs cv wcel vx ax-17 vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vx vo va vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral vx vo cv cX wss vx ax-17 vv
      cv vo cv wss vv cU wrex vx vo cv hbra1 hban hbab hbss vs cv vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wss vx cv va cv wcel
      va cv vs cv wcel wa va wex vv cv vs cv cuni wss vv cU wrex vx cv vs cv
      cuni wcel vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab wss vx cv va cv wcel va cv vs cv wcel wa vv cv vs cv cuni wss vv
      cU wrex va vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab wss vx cv va cv wcel va cv vs cv wcel vv cv vs cv cuni wss vv cU
      wrex va cv vs cv wcel vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab wss vx cv va cv wcel vv cv vs cv cuni wss vv cU wrex va
      cv vs cv wcel vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      wa vo cab wss va cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      wa vo cab wcel vx cv va cv wcel vv cv vs cv cuni wss vv cU wrex wi vs cv
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wss va cv
      vs cv wcel va cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab wcel vs cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      wa vo cab va cv ssel com12 va cv vs cv wcel va cv cX wss vv cv va cv wss
      vv cU wrex vx va cv wral wa vx cv va cv wcel vv cv vs cv cuni wss vv cU
      wrex wi va cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab wcel va cv vs cv wcel vv cv va cv wss vv cU wrex vx va cv wral vx cv
      va cv wcel vv cv vs cv cuni wss vv cU wrex wi va cv cX wss vv cv va cv
      wss vv cU wrex vx va cv wral vx cv va cv wcel vv cv va cv wss vv cU wrex
      va cv vs cv wcel vv cv vs cv cuni wss vv cU wrex vv cv va cv wss vv cU
      wrex vx va cv ra4 va cv vs cv wcel vv cv va cv wss vv cv vs cv cuni wss
      vv cU vv cv va cv wss va cv vs cv cuni wss vv cv vs cv cuni wss va cv vs
      cv wcel vv cv va cv vs cv cuni sstr2 va cv vs cv elssuni syl5com
      r19.22sdv syl9r adantld vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa va cv cX wss vv cv va cv wss vv cU wrex vx va cv wral wa vo va cv
      va visset vo cv va cv wceq vo cv cX wss va cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral vv cv va cv wss vv cU wrex vx va cv wral vo cv va
      cv cX sseq1 vv cv vo cv wss vv cU wrex vv cv va cv wss vv cU wrex vx vo
      cv va cv vo cv va cv wceq vv cv vo cv wss vv cv va cv wss vv cU vo cv va
      cv vv cv sseq2 rexbidv raleqd anbi12d elab syl5ib syld com3l imp3a
      19.23adv va vx cv vs cv eluni syl5ib r19.21ai jca vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vs cv cuni cX wss vv cv vs cv cuni wss
      vv cU wrex vx vs cv cuni wral wa vo vs cv cuni vs cv vs visset uniex vo
      cv vs cv cuni wceq vo cv cX wss vs cv cuni cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral vv cv vs cv cuni wss vv cU wrex vx vs cv cuni wral vo
      cv vs cv cuni cX sseq1 vv cv vo cv wss vv cU wrex vv cv vs cv cuni wss vv
      cU wrex vx vo cv vs cv cuni vo cv vs cv cuni wceq vv cv vo cv wss vv cv
      vs cv cuni wss vv cU vo cv vs cv cuni vv cv sseq2 rexbidv raleqd anbi12d
      elab sylibr ax-gen jctil syl adantl cX cB wcel vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vs cv vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab wss vs cv cuni vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel wi vs wal vs cv
      vu cv cin vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      wcel vu vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      wral vs vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      wral wa wb cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral cX cB wcel vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab cvv wcel vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vs cv vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wss vs cv cuni vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel wi vs wal vs
      cv vu cv cin vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab wcel vu vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab wral vs vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab wral wa wb vv cv vo cv wss vv cU wrex vx vo cv wral vo cX cB abssexg
      vs vu cvv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      istopg syl adantr mpbird $.
      $( [8-Sep-2009] $) $( [8-Sep-2009] $)

    ${
      neibastop2.1 $e |- G = { <. f , h >. | h = { y | ( y e. X /\ E. w e. W w
      C_ f ) } } $.
      neibastop2.2 $e |- F = { <. a , b >. | b = { c | E. z e. a E.
      x e. ( G ` z ) ( c e. U /\ c C_ z ) } } $.
    $( Lemma for ~ neibastop2 . $)
    neibastop2lem1 $p |- ( k e. om -> ( ( ( X e. B /\ A. x e. X A. v e. U ( x
    e. v /\ v C_ X ) ) /\ ( u e. U /\ u C_ n ) ) -> U. ( rec ( F , { u } ) ` k
    ) C_ n ) ) $=
      cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vu
      cv cU wcel vu cv vn cv wss wa wa vj cv cF vu cv csn crdg cfv cuni vn cv
      wss wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral
      wa vu cv cU wcel vu cv vn cv wss wa wa c0 cF vu cv csn crdg cfv cuni vn
      cv wss wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX
      wral wa vu cv cU wcel vu cv vn cv wss wa wa vm cv cF vu cv csn crdg cfv
      cuni vn cv wss wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral
      vx cX wral wa vu cv cU wcel vu cv vn cv wss wa wa vm cv csuc cF vu cv csn
      crdg cfv cuni vn cv wss wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv
      cU wral vx cX wral wa vu cv cU wcel vu cv vn cv wss wa wa vk cv cF vu cv
      csn crdg cfv cuni vn cv wss wi vj vm vk cv vj cv c0 wceq vj cv cF vu cv
      csn crdg cfv cuni vn cv wss c0 cF vu cv csn crdg cfv cuni vn cv wss cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vu cv cU
      wcel vu cv vn cv wss wa wa vj cv c0 wceq vj cv cF vu cv csn crdg cfv cuni
      c0 cF vu cv csn crdg cfv cuni vn cv vj cv c0 wceq vj cv cF vu cv csn crdg
      cfv c0 cF vu cv csn crdg cfv vj cv c0 cF vu cv csn crdg fveq2 unieqd
      sseq1d imbi2d vj cv vm cv wceq vj cv cF vu cv csn crdg cfv cuni vn cv wss
      vm cv cF vu cv csn crdg cfv cuni vn cv wss cX cB wcel vx cv vv cv wcel vv
      cv cX wss wa vv cU wral vx cX wral wa vu cv cU wcel vu cv vn cv wss wa wa
      vj cv vm cv wceq vj cv cF vu cv csn crdg cfv cuni vm cv cF vu cv csn crdg
      cfv cuni vn cv vj cv vm cv wceq vj cv cF vu cv csn crdg cfv vm cv cF vu
      cv csn crdg cfv vj cv vm cv cF vu cv csn crdg fveq2 unieqd sseq1d imbi2d
      vj cv vm cv csuc wceq vj cv cF vu cv csn crdg cfv cuni vn cv wss vm cv
      csuc cF vu cv csn crdg cfv cuni vn cv wss cX cB wcel vx cv vv cv wcel vv
      cv cX wss wa vv cU wral vx cX wral wa vu cv cU wcel vu cv vn cv wss wa wa
      vj cv vm cv csuc wceq vj cv cF vu cv csn crdg cfv cuni vm cv csuc cF vu
      cv csn crdg cfv cuni vn cv vj cv vm cv csuc wceq vj cv cF vu cv csn crdg
      cfv vm cv csuc cF vu cv csn crdg cfv vj cv vm cv csuc cF vu cv csn crdg
      fveq2 unieqd sseq1d imbi2d vj cv vk cv wceq vj cv cF vu cv csn crdg cfv
      cuni vn cv wss vk cv cF vu cv csn crdg cfv cuni vn cv wss cX cB wcel vx
      cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vu cv cU wcel vu
      cv vn cv wss wa wa vj cv vk cv wceq vj cv cF vu cv csn crdg cfv cuni vk
      cv cF vu cv csn crdg cfv cuni vn cv vj cv vk cv wceq vj cv cF vu cv csn
      crdg cfv vk cv cF vu cv csn crdg cfv vj cv vk cv cF vu cv csn crdg fveq2
      unieqd sseq1d imbi2d cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU
      wral vx cX wral wa vu cv cU wcel vu cv vn cv wss wa wa vu cv vn cv c0 cF
      vu cv csn crdg cfv cuni cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU
      wral vx cX wral wa vu cv cU wcel vu cv vn cv wss simprr c0 cF vu cv csn
      crdg cfv cuni vu cv csn cuni vu cv c0 cF vu cv csn crdg cfv vu cv csn vu
      cv csn cF vu cv snex rdg0 unieqi vu cv vu visset unisn eqtri syl5ss vm cv
      com wcel cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX
      wral wa vu cv cU wcel vu cv vn cv wss wa wa vm cv cF vu cv csn crdg cfv
      cuni vn cv wss vm cv csuc cF vu cv csn crdg cfv cuni vn cv wss vm cv com
      wcel cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa
      vu cv cU wcel vu cv vn cv wss wa wa vm cv csuc cF vu cv csn crdg cfv cuni
      vm cv cF vu cv csn crdg cfv cuni wss vm cv cF vu cv csn crdg cfv cuni vn
      cv wss vm cv csuc cF vu cv csn crdg cfv cuni vn cv wss wi vm cv com wcel
      cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vu
      cv cU wcel vu cv vn cv wss wa wa vm cv csuc cF vu cv csn crdg cfv cuni vm
      cv cF vu cv csn crdg cfv cuni wss vm cv com wcel cX cB wcel vx cv vv cv
      wcel vv cv cX wss wa vv cU wral vx cX wral wa vu cv cU wcel vu cv vn cv
      wss wa wa wa vm cv csuc cF vu cv csn crdg cfv cuni vm cv cF vu cv csn
      crdg cfv cF cfv cuni vm cv cF vu cv csn crdg cfv cuni vm cv com wcel vm
      cv csuc cF vu cv csn crdg cfv cuni vm cv cF vu cv csn crdg cfv cF cfv
      cuni wceq cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX
      wral wa vu cv cU wcel vu cv vn cv wss wa wa vm cv com wcel vm cv csuc cF
      vu cv csn crdg cfv vm cv cF vu cv csn crdg cfv cF cfv vm cv com wcel vm
      cv con0 wcel vm cv csuc cF vu cv csn crdg cfv vm cv cF vu cv csn crdg cfv
      cF cfv wceq vm cv nnon vu cv csn vm cv cF rdgsuc syl unieqd adantr cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vm cv cF
      vu cv csn crdg cfv cF cfv cuni vm cv cF vu cv csn crdg cfv cuni wss vm cv
      com wcel vu cv cU wcel vu cv vn cv wss wa cX cB wcel vx cv vv cv wcel vv
      cv cX wss wa vv cU wral vx cX wral wa vm cv cF vu cv csn crdg cfv cF cfv
      cuni vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu
      cv csn crdg cfv wrex vc cab cuni vm cv cF vu cv csn crdg cfv cuni cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vm cv cF
      vu cv csn crdg cfv cF cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc
      cab cvv wcel cF wfun wa vm cv cF vu cv csn crdg cfv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc
      cab cop cF wcel vm cv cF vu cv csn crdg cfv cF cfv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab
      wceq cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa
      vm cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab cvv cF funopfvg cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg
      cfv wrex vc cab cvv wcel cF wfun vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab cvv wcel cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg
      cfv wrex vc cab vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs
      vm cv cF vu cv csn crdg cfv wrex vr cab cvv vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab vc cv
      cU wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn
      crdg cfv wrex vc cab vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv
      wrex vs vm cv cF vu cv csn crdg cfv wrex vr cab vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cv cU
      wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg
      cfv wrex vc vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vc cv
      cU wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vz vs vj vm cv cF vu cv
      csn crdg cfv vz vj vm cv cF vu cv csn crdg vz vj vu cv csn cF vz vj cF vb
      cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vz vj vz vj vj vb cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab vj cv vb cv wcel vz ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz va cv wrex vz vc vj vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz va cv hbre1 hbab hbeq hbopab hbxfr vj cv vu cv csn wcel
      vz ax-17 hbrdg vj cv vm cv wcel vz ax-17 hbfv vj cv vm cv cF vu cv csn
      crdg cfv wcel vs ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vs ax-17 vc cv cU wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vz
      ax-17 vz cv vs cv wceq vc cv cU wcel vc cv vz cv wss wa vc cv cU wcel vc
      cv vs cv wss wa vx vz cv cG cfv vs cv cG cfv vz cv vs cv cG fveq2 vz cv
      vs cv wceq vc cv vz cv wss vc cv vs cv wss vc cv cU wcel vz cv vs cv vc
      cv sseq2 anbi2d rexeq12d cbvrexf abbii vc cv cU wcel vc cv vs cv wss wa
      vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg cfv wrex vr cv cU wcel vr
      cv vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg cfv wrex
      vc vr vc cv cU wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF
      vu cv csn crdg cfv wrex vr ax-17 vr cv cU wcel vr cv vs cv wss wa vx vs
      cv cG cfv wrex vc vs vm cv cF vu cv csn crdg cfv vc vs vm cv cF vu cv csn
      crdg vc vs vu cv csn cF vc vs cF vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab neibastop2.2
      vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex
      vc cab wceq va vb vc vs vc vj vj vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab vj cv vb cv wcel vc ax-17 vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc vj hbab1
      hbeq hbopab hbxfr vs cv vu cv csn wcel vc ax-17 hbrdg vs cv vm cv wcel vc
      ax-17 hbfv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vc ax-17
      hbrex vc cv vr cv wceq vc cv cU wcel vc cv vs cv wss wa vr cv cU wcel vr
      cv vs cv wss wa vs vx vm cv cF vu cv csn crdg cfv vs cv cG cfv vc cv vr
      cv wceq vc cv cU wcel vr cv cU wcel vc cv vs cv wss vr cv vs cv wss vc cv
      vr cv cU eleq1 vc cv vr cv vs cv sseq1 anbi12d 2rexbidv cbvab eqtri vr cv
      cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs vr vm cv cF vu cv csn
      crdg cfv vm cv cF vu cv csn crdg fvex vr cv cU wcel vr cv vs cv wss wa vx
      vr vs cv cG cfv vs cv cG fvex vr cv cU wcel vr cv vs cv wss wa vr cab vr
      cv vs cv wss vr cab vs cv cpw vr cv vs cv wss vr cab cvv vr vs cv df-pw
      vs cv vs visset pwex eqeltrri vr cv cU wcel vr cv vs cv wss wa vr cv vs
      cv wss vr vr cv cU wcel vr cv vs cv wss pm3.27 ss2abi ssexi abrexex2
      abrexex2 eqeltri a1i cF wfun vb cv vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab wfun va vb vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab
      funopabeq cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab wceq va vb copab wceq cF wfun vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb
      copab wfun wb neibastop2.2 cF vb cv vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab funeq ax-mp mpbir
      jctir vm cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab cop cF wcel cX
      cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn
      crdg cfv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab wceq vm cv cF vu cv csn
      crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv
      cF vu cv csn crdg cfv wrex vc cab cop cF wcel vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab
      eqid vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu
      cv csn crdg cfv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab wceq vm cv cF vu cv
      csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm
      cv cF vu cv csn crdg cfv wrex vc cab cop vs cv vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vr vs copab wcel vm
      cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab cop cF wcel vs cv vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq
      vs cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF
      vu cv csn crdg cfv wrex vc cab wceq vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg
      cfv wrex vc cab wceq vr vs vm cv cF vu cv csn crdg cfv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex
      vc cab vm cv cF vu cv csn crdg fvex vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab vr cv cU
      wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg
      cfv wrex vr cab cvv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vm cv cF vu cv csn crdg cfv wrex vc cab vc cv cU wcel vc cv vs cv wss
      wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg cfv wrex vc cab vr cv
      cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn
      crdg cfv wrex vr cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vm cv cF vu cv csn crdg cfv wrex vc cv cU wcel vc cv vs cv wss wa
      vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg cfv wrex vc vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vc cv cU wcel vc cv vs cv wss wa
      vx vs cv cG cfv wrex vz vs vj vm cv cF vu cv csn crdg cfv vz vj vm cv cF
      vu cv csn crdg vz vj vu cv csn cF vz vj cF vb cv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab
      neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab wceq va vb vz vj vz vj vj vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vj cv vb cv wcel
      vz ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv
      wrex vz vc vj vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv hbre1 hbab hbeq hbopab hbxfr vj cv vu cv csn wcel vz ax-17 hbrdg vj cv
      vm cv wcel vz ax-17 hbfv vj cv vm cv cF vu cv csn crdg cfv wcel vs ax-17
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vs ax-17 vc cv cU
      wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vz ax-17 vz cv vs cv wceq vc
      cv cU wcel vc cv vz cv wss wa vc cv cU wcel vc cv vs cv wss wa vx vz cv
      cG cfv vs cv cG cfv vz cv vs cv cG fveq2 vz cv vs cv wceq vc cv vz cv wss
      vc cv vs cv wss vc cv cU wcel vz cv vs cv vc cv sseq2 anbi2d rexeq12d
      cbvrexf abbii vc cv cU wcel vc cv vs cv wss wa vx vs cv cG cfv wrex vs vm
      cv cF vu cv csn crdg cfv wrex vr cv cU wcel vr cv vs cv wss wa vx vs cv
      cG cfv wrex vs vm cv cF vu cv csn crdg cfv wrex vc vr vc cv cU wcel vc cv
      vs cv wss wa vx vs cv cG cfv wrex vs vm cv cF vu cv csn crdg cfv wrex vr
      ax-17 vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vc vs vm cv
      cF vu cv csn crdg cfv vc vs vm cv cF vu cv csn crdg vc vs vu cv csn cF vc
      vs cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv wrex vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vc vs vc
      vj vj vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv wrex vc cab vj cv vb cv wcel vc ax-17 vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc vj hbab1 hbeq hbopab hbxfr vs cv vu
      cv csn wcel vc ax-17 hbrdg vs cv vm cv wcel vc ax-17 hbfv vr cv cU wcel
      vr cv vs cv wss wa vx vs cv cG cfv wrex vc ax-17 hbrex vc cv vr cv wceq
      vc cv cU wcel vc cv vs cv wss wa vr cv cU wcel vr cv vs cv wss wa vs vx
      vm cv cF vu cv csn crdg cfv vs cv cG cfv vc cv vr cv wceq vc cv cU wcel
      vr cv cU wcel vc cv vs cv wss vr cv vs cv wss vc cv vr cv cU eleq1 vc cv
      vr cv vs cv sseq1 anbi12d 2rexbidv cbvab eqtri vr cv cU wcel vr cv vs cv
      wss wa vx vs cv cG cfv wrex vs vr vm cv cF vu cv csn crdg cfv vm cv cF vu
      cv csn crdg fvex vr cv cU wcel vr cv vs cv wss wa vx vr vs cv cG cfv vs
      cv cG fvex vr cv cU wcel vr cv vs cv wss wa vr cab vr cv vs cv wss vr cab
      vs cv cpw vr cv vs cv wss vr cab cvv vr vs cv df-pw vs cv vs visset pwex
      eqeltrri vr cv cU wcel vr cv vs cv wss wa vr cv vs cv wss vr vr cv cU
      wcel vr cv vs cv wss pm3.27 ss2abi ssexi abrexex2 abrexex2 eqeltri vr cv
      vm cv cF vu cv csn crdg cfv wceq vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vr cv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab vs cv vr cv
      vm cv cF vu cv csn crdg cfv wceq vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vr cv wrex vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc vc vj vj vr cv vm cv cF
      vu cv csn crdg cfv vj cv vr cv wcel vc ax-17 vc vj vm cv cF vu cv csn
      crdg vc vj vu cv csn cF vc vj cF vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab neibastop2.2
      vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex
      vc cab wceq va vb vc vj vc vj vj vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab vj cv vb cv wcel vc ax-17 vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc vj hbab1
      hbeq hbopab hbxfr vj cv vu cv csn wcel vc ax-17 hbrdg vj cv vm cv wcel vc
      ax-17 hbfv hbeq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      vj vr cv vm cv cF vu cv csn crdg cfv vj cv vr cv wcel vz ax-17 vz vj vm
      cv cF vu cv csn crdg vz vj vu cv csn cF vz vj cF vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb
      copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab wceq va vb vz vj vz vj vj vb cv vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vj cv vb cv
      wcel vz ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv wrex vz vc vj vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv hbre1 hbab hbeq hbopab hbxfr vj cv vu cv csn wcel vz ax-17 hbrdg vj
      cv vm cv wcel vz ax-17 hbfv rexeq1f abbid eqeq2d vs cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex
      vc cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF
      vu cv csn crdg cfv wrex vc cab eqeq1 opelopab vs cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vr vs copab
      cF vm cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab cop vs cv vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vr
      vs copab vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vc cab wceq va vb copab cF vs cv vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq vr vs va
      vb vr cv va cv wceq vs cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vr cv wrex vc cab wceq vs cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab wceq vs cv vb cv wceq vb cv vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab
      wceq vr cv va cv wceq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vr cv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz va cv wrex vc cab vs cv vr cv va cv wceq vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz va cv wrex vc vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vr cv va cv rexeq1 abbidv eqeq2d vs cv vb
      cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab eqeq1 sylan9bb cbvopabv neibastop2.2 eqtr4i eleq2i bitr3i mpbi a1i
      sylc unieqd cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX
      wral wa vj vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv
      cF vu cv csn crdg cfv wrex vc cab cuni vm cv cF vu cv csn crdg cfv cuni
      cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vj
      cv vn cv wcel vn cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vm cv cF vu cv csn crdg cfv wrex vc cab wcel wa vn wex vj cv vm cv cF
      vu cv csn crdg cfv cuni wcel vj cv vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab cuni wcel cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vj cv vn
      cv wcel vn cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm
      cv cF vu cv csn crdg cfv wrex vc cab wcel wa vj cv vm cv cF vu cv csn
      crdg cfv cuni wcel vn cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU
      wral vx cX wral wa vj cv vn cv wcel vn cv cU wcel vn cv vz cv wss wa vx
      vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex wa vj cv vm cv cF
      vu cv csn crdg cfv cuni wcel vj cv vn cv wcel vn cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc
      cab wcel wa cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX
      wral wa vj cv vn cv wcel vn cv cU wcel vn cv vz cv wss wa vx vz cv cG cfv
      wrex vz vm cv cF vu cv csn crdg cfv wrex vj cv vm cv cF vu cv csn crdg
      cfv cuni wcel cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx
      cX wral wa vn cv cU wcel vn cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv
      cF vu cv csn crdg cfv wrex vj cv vn cv wcel vj cv vm cv cF vu cv csn crdg
      cfv cuni wcel cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx
      cX wral wa vn cv cU wcel vn cv vk cv wss wa vx vk cv cG cfv wrex vk vm cv
      cF vu cv csn crdg cfv wrex vj cv vn cv wcel vj cv vm cv cF vu cv csn crdg
      cfv cuni wcel wi vn cv cU wcel vn cv vz cv wss wa vx vz cv cG cfv wrex vz
      vm cv cF vu cv csn crdg cfv wrex cX cB wcel vx cv vv cv wcel vv cv cX wss
      wa vv cU wral vx cX wral wa vn cv cU wcel vn cv vk cv wss wa vx vk cv cG
      cfv wrex vj cv vn cv wcel vj cv vm cv cF vu cv csn crdg cfv cuni wcel wi
      vk vm cv cF vu cv csn crdg cfv cX cB wcel vx cv vv cv wcel vv cv cX wss
      wa vv cU wral vx cX wral wa vk cv vm cv cF vu cv csn crdg cfv wcel vn cv
      cU wcel vn cv vk cv wss wa vx vk cv cG cfv wrex vj cv vn cv wcel vj cv vm
      cv cF vu cv csn crdg cfv cuni wcel wi wi cX cB wcel vx cv vv cv wcel vv
      cv cX wss wa vv cU wral vx cX wral wa vk cv vm cv cF vu cv csn crdg cfv
      wcel wa vn cv cU wcel vn cv vk cv wss wa vj cv vn cv wcel vj cv vm cv cF
      vu cv csn crdg cfv cuni wcel wi vx vk cv cG cfv cX cB wcel vx cv vv cv
      wcel vv cv cX wss wa vv cU wral vx cX wral wa vk cv vm cv cF vu cv csn
      crdg cfv wcel vx cX cB wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral
      vx cX wral vx cX cB wcel vx ax-17 vx cv vv cv wcel vv cv cX wss wa vv cU
      wral vx cX hbra1 hban vx vk vm cv cF vu cv csn crdg vx vk vu cv csn cF vx
      vk cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv wrex vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vx vk vx
      vk vk vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv wrex vc cab vk cv vb cv wcel vx ax-17 vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vx vc vk vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vx vz va cv vz cv va cv wcel vx ax-17 vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv hbre1 hbrex hbab hbeq hbopab
      hbxfr vk cv vu cv csn wcel vx ax-17 hbrdg vk cv vm cv wcel vx ax-17 hbfv
      hban vj cv vn cv wcel vj cv vm cv cF vu cv csn crdg cfv cuni wcel vx vj
      cv vn cv wcel vx ax-17 vx vj vm cv cF vu cv csn crdg cfv vx vj vm cv cF
      vu cv csn crdg vx vj vu cv csn cF vx vj cF vb cv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab
      neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab wceq va vb vx vj vx vk vk vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vk cv vb cv wcel
      vx ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv
      wrex vx vc vk vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vx vz
      va cv vz cv va cv wcel vx ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv hbre1 hbrex hbab hbeq hbopab hbxfr vj cv vu cv csn wcel vx ax-17
      hbrdg vj cv vm cv wcel vx ax-17 hbfv hbuni hbim vk cv vm cv cF vu cv csn
      crdg cfv wcel vx cv vk cv cG cfv wcel vn cv cU wcel vn cv vk cv wss wa vj
      cv vn cv wcel vj cv vm cv cF vu cv csn crdg cfv cuni wcel wi wi wi cX cB
      wcel vx cv vv cv wcel vv cv cX wss wa vv cU wral vx cX wral wa vk cv vm
      cv cF vu cv csn crdg cfv wcel vn cv cU wcel vn cv vk cv wss wa vj cv vn
      cv wcel vj cv vm cv cF vu cv csn crdg cfv cuni wcel wi wi vx cv vk cv cG
      cfv wcel vk cv vm cv cF vu cv csn crdg cfv wcel vn cv vk cv wss vj cv vn
      cv wcel vj cv vm cv cF vu cv csn crdg cfv cuni wcel wi vn cv cU wcel vn
      cv vk cv wss vj cv vn cv wcel vj cv vk cv wcel vk cv vm cv cF vu cv csn
      crdg cfv wcel vj cv vm cv cF vu cv csn crdg cfv cuni wcel vn cv vk cv vj
      cv ssel vj cv vk cv wcel vk cv vm cv cF vu cv csn crdg cfv wcel vj cv vm
      cv cF vu cv csn crdg cfv cuni wcel vj cv vk cv vm cv cF vu cv csn crdg
      cfv elunii expcom syl9r adantld a1d adantl r19.23ad ex r19.23adv vn cv cU
      wcel vn cv vz cv wss wa vx vz cv cG cfv wrex vn cv cU wcel vn cv vk cv
      wss wa vx vk cv cG cfv wrex vz vk vd vm cv cF vu cv csn crdg cfv vz vd vm
      cv cF vu cv csn crdg vz vd vu cv csn cF vz vd cF vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb
      copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab wceq va vb vz vd vz vd vd vb cv vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vd cv vb cv
      wcel vz ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va
      cv wrex vz vc vd vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv hbre1 hbab hbeq hbopab hbxfr vd cv vu cv csn wcel vz ax-17 hbrdg vd
      cv vm cv wcel vz ax-17 hbfv vd cv vm cv cF vu cv csn crdg cfv wcel vk
      ax-17 vn cv cU wcel vn cv vz cv wss wa vx vz cv cG cfv wrex vk ax-17 vn
      cv cU wcel vn cv vk cv wss wa vx vk cv cG cfv wrex vz ax-17 vz cv vk cv
      wceq vn cv cU wcel vn cv vz cv wss wa vn cv cU wcel vn cv vk cv wss wa vx
      vz cv cG cfv vk cv cG cfv vz cv vk cv cG fveq2 vz cv vk cv wceq vn cv vz
      cv wss vn cv vk cv wss vn cv cU wcel vz cv vk cv vn cv sseq2 anbi2d
      rexeq12d cbvrexf syl5ib com23 imp3a vn cv vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc cab wcel
      vn cv cU wcel vn cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv
      csn crdg cfv wrex vj cv vn cv wcel vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vn cv cU wcel vn cv vz
      cv wss wa vx vz cv cG cfv wrex vz vm cv cF vu cv csn crdg cfv wrex vc vn
      cv vn cv cU wcel vn cv vz cv wss wa vx vz cv cG cfv wrex vc vz vm cv cF
      vu cv csn crdg cfv vc vj vj vz cv vm cv cF vu cv csn crdg cfv vj cv vz cv
      wcel vc ax-17 vc vj vm cv cF vu cv csn crdg vc vj vu cv csn cF vc vj cF
      vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex
      vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vc vj vc vj vj vb
      cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab vj cv vb cv wcel vc ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz va cv wrex vc vj hbab1 hbeq hbopab hbxfr vj cv vu cv csn
      wcel vc ax-17 hbrdg vj cv vm cv wcel vc ax-17 hbfv hbel vn cv cU wcel vn
      cv vz cv wss wa vx vz cv cG cfv wrex vc ax-17 hbrex vn visset vc cv vn cv
      wceq vc cv cU wcel vc cv vz cv wss wa vn cv cU wcel vn cv vz cv wss wa vz
      vx vm cv cF vu cv csn crdg cfv vz cv cG cfv vc cv vn cv wceq vc cv cU
      wcel vn cv cU wcel vc cv vz cv wss vn cv vz cv wss vc cv vn cv cU eleq1
      vc cv vn cv vz cv sseq1 anbi12d 2rexbidv elabf anbi2i syl5ib 19.23adv vn
      vj cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vm cv cF
      vu cv csn crdg cfv wrex vc cab eluni syl5ib ssrdv eqsstrd ad2antrl
      eqsstrd ex vm cv csuc cF vu cv csn crdg cfv cuni vm cv cF vu cv csn crdg
      cfv cuni vn cv sstr2 syl6 a2d finds $.
      $( [18-Sep-2009] $) $( [18-Sep-2009] $)

    $( Lemma for ~ neibastop2 . $)
    neibastop2lem2 $p |- ( ( ( X e. B /\ A. x e. X ( U =/= (/) /\ A. v e. U ( (
    x e. v /\ v C_ X ) /\ ( A. w e. U E. t e. U t C_ ( v i^i w ) /\ E. t e. U
    A. y e. t E. w e. W w C_ v ) ) ) ) /\ ( ( ( { o | ( o C_ X /\ A. x e. o E.
    v e. U v C_ o ) } e. Top /\ x e. X ) /\ n C_ X ) /\ ( u e. U /\ u C_ n ) )
    ) -> U_ k e. om U. ( G " ( rec ( F , { u } ) ` k ) ) C_ n ) $=
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss
      wa vu cv cU wcel vu cv vn cv wss wa wa wa vk com cG vk cv cF vu cv csn
      crdg cfv cima cuni ciun vk com vk cv cF vu cv csn crdg cfv cuni ciun vn
      cv cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX
      wss wa vu cv cU wcel vu cv vn cv wss wa wa wa cG vk cv cF vu cv csn crdg
      cfv cima cuni vk cv cF vu cv csn crdg cfv cuni wss vk com wral vk com cG
      vk cv cF vu cv csn crdg cfv cima cuni ciun vk com vk cv cF vu cv csn crdg
      cfv cuni ciun wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa
      vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa cG vk cv
      cF vu cv csn crdg cfv cima cuni vk cv cF vu cv csn crdg cfv cuni wss vk
      com cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX
      wss wa vu cv cU wcel vu cv vn cv wss wa wa wa cG vk cv cF vu cv csn crdg
      cfv cima cuni vk cv cF vu cv csn crdg cfv cuni wss vk cv com wcel cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv
      cU wcel vu cv vn cv wss wa wa wa vd cG vk cv cF vu cv csn crdg cfv cima
      cuni vk cv cF vu cv csn crdg cfv cuni cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv
      wss wa wa wa vd cv vm cv wcel vj cv vk cv cF vu cv csn crdg cfv wcel vm
      cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa vj wex wa
      vm wex vd cv vk cv cF vu cv csn crdg cfv cuni wcel vd cv cG vk cv cF vu
      cv csn crdg cfv cima cuni wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv
      cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
      wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel
      vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa
      vd cv vm cv wcel vj cv vk cv cF vu cv csn crdg cfv wcel vm cv vy cv cX
      wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa vj wex wa vd cv vk cv
      cF vu cv csn crdg cfv cuni wcel vm cX cB wcel cU c0 wne vx cv vv cv wcel
      vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv
      cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral
      wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop
      wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa
      wa vd cv vm cv wcel vj cv vk cv cF vu cv csn crdg cfv wcel vm cv vy cv cX
      wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa vj wex vd cv vk cv cF
      vu cv csn crdg cfv cuni wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx
      cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj
      cv vk cv cF vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss
      vw cW wrex wa vy cab wceq wa vj wex vd cv vm cv wcel vd cv vk cv cF vu cv
      csn crdg cfv cuni wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk
      cv cF vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW
      wrex wa vy cab wceq wa vd cv vm cv wcel vd cv vk cv cF vu cv csn crdg cfv
      cuni wcel wi vj cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk
      cv cF vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW
      wrex wa vy cab wceq wa vd cv vm cv wcel vd cv vk cv cF vu cv csn crdg cfv
      cuni wcel wi cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel
      wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF
      vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa
      vy cab wceq wa wa vd cv vm cv wcel vd cv vj cv wcel vj cv vk cv cF vu cv
      csn crdg cfv wcel wa vd cv vk cv cF vu cv csn crdg cfv cuni wcel cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv
      cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF vu cv csn crdg cfv wcel
      vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa wa vd cv
      vm cv wcel vd cv vj cv wcel vj cv vk cv cF vu cv csn crdg cfv wcel cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv
      cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF vu cv csn crdg cfv wcel
      vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa wa vm cv
      vj cv vd cv cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel
      wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF
      vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa
      vy cab wceq wa wa vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy
      cab vj cv cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa
      vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF vu
      cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy
      cab wceq simprr cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk
      cv cF vu cv csn crdg cfv wcel vy cv cX wcel vw cv vj cv wss vw cW wrex wa
      vy cab vj cv wss vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab
      wceq cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX
      wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF vu cv csn
      crdg cfv wcel wa vm vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab vj
      cv cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX
      wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vj cv vk cv cF vu cv csn
      crdg cfv wcel wa vm cv cX wcel vw cv vj cv wss vw vy vm cv cW csb wrex wa
      vm cv vj cv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU
      wcel vu cv vn cv wss wa wa vj cv vk cv cF vu cv csn crdg cfv wcel vm cv
      cX wcel vw cv vj cv wss vw vy vm cv cW csb wrex wa vm cv vj cv wcel wi cX
      cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa
      vu cv cU wcel vu cv vn cv wss wa wa vj cv vk cv cF vu cv csn crdg cfv
      wcel vm cv cX wcel vw cv vj cv wss vw vy vm cv cW csb wrex wa vm cv vj cv
      wcel wi cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral vm cv cX wcel vw cv vj cv wss vw vy
      vm cv cW csb wrex wa vj cv vk cv cF vu cv csn crdg cfv wcel vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa vm cv vj cv
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral vm cv cX wcel vw cv vj cv wss vw vy vm cv
      cW csb wrex vj cv vk cv cF vu cv csn crdg cfv wcel vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn
      cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa vm cv vj cv wcel wi wi
      cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral wa vx cX wral vx cv vv cv wcel vv cU wral vx cX wral vm cv
      cX wcel vw cv vj cv wss vw vy vm cv cW csb wrex vj cv vk cv cF vu cv csn
      crdg cfv wcel vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv
      wss wa wa vm cv vj cv wcel wi wi wi wi cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cv vv cv wcel
      vv cU wral vx cX vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral vx cv vv cv wcel vv cU wral cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vx cv vv cv wcel
      vv cU vx cv vv cv wcel vv cv cX wss vt cv vv cv vw cv cin wss vt cU wrex
      vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa simpll
      r19.20si adantl r19.20si vm cv cX wcel vx cv vv cv wcel vv cU wral vx cX
      wral vm cv vv cv wcel vv vx vm cv cU csb wral vw cv vj cv wss vw vy vm cv
      cW csb wrex vj cv vk cv cF vu cv csn crdg cfv wcel vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn
      cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa vm cv vj cv wcel wi wi
      wi vx cv vv cv wcel vv cU wral vm cv vv cv wcel vv vx vm cv cU csb wral
      vx vm cv cX vm cv vv cv wcel vx vv vx vm cv cU csb vx vv vm cv cU vm
      visset vv cv vm cv wcel vx ax-17 hbcsb1 vm cv vv cv wcel vx ax-17 hbral
      vx cv vm cv wceq vx cv vv cv wcel vm cv vv cv wcel vv cU vx vm cv cU csb
      vx vm cv cU csbeq1a vx cv vm cv vv cv eleq1 raleq12d rcla4 vm cv vv cv
      wcel vv vx vm cv cU csb wral vd cv vj cv wss vd vy vm cv cW csb wrex vj
      cv vk cv cF vu cv csn crdg cfv wcel vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa
      vu cv cU wcel vu cv vn cv wss wa wa vm cv vj cv wcel wi wi vw cv vj cv
      wss vw vy vm cv cW csb wrex vm cv vv cv wcel vv vx vm cv cU csb wral vd
      cv vj cv wss vj cv vk cv cF vu cv csn crdg cfv wcel vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn
      cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa vm cv vj cv wcel wi wi
      vd vy vm cv cW csb vm cv vv cv wcel vv vx vm cv cU csb wral vd cv vx vm
      cv cU csb wcel vd cv vj cv wss vj cv vk cv cF vu cv csn crdg cfv wcel vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx
      cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa vm cv
      vj cv wcel wi wi wi vd cv vy vm cv cW csb wcel vd cv vx vm cv cU csb wcel
      vm cv vv cv wcel vv vx vm cv cU csb wral vm cv vd cv wcel vd cv vj cv wss
      vj cv vk cv cF vu cv csn crdg cfv wcel vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa
      vu cv cU wcel vu cv vn cv wss wa wa vm cv vj cv wcel wi wi wi vm cv vv cv
      wcel vm cv vd cv wcel vv vd cv vx vm cv cU csb vv cv vd cv vm cv eleq2
      rcla4v vm cv vd cv wcel vd cv vj cv wss vj cv vk cv cF vu cv csn crdg cfv
      wcel vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop
      wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa
      vm cv vj cv wcel vd cv vj cv wss vm cv vd cv wcel vm cv vj cv wcel vd cv
      vj cv vm cv ssel com12 a1i34 syl6com vy vm cv cW csb vx vm cv cU csb vd
      cv vm cv cvv wcel vy vm cv cW csb vx vm cv cU csb wceq vm visset vy vx vm
      cv cW cU cvv cW cU wceq vx cv vy cv vx cv vy cv wceq cU cW neibastop1.1
      eqcomd eqcoms cbvcsbv ax-mp eleq2i syl5ib r19.23adv vw cv vj cv wss vd cv
      vj cv wss vw vd vy vm cv cW csb vw cv vd cv vj cv sseq1 cbvrexv syl5ib
      syl6com syl imp3a com24 imp31 adantlll vy cv cX wcel vw cv vj cv wss vw
      cW wrex wa vm cv cX wcel vw cv vj cv wss vw vy vm cv cW csb wrex wa vy vm
      cv vm cv cX wcel vw cv vj cv wss vw vy vm cv cW csb wrex vy vm cv cX wcel
      vy ax-17 vw cv vj cv wss vy vw vy vm cv cW csb vy vw vm cv cW vm visset
      vw cv vm cv wcel vy ax-17 hbcsb1 vw cv vj cv wss vy ax-17 hbrex hban vm
      visset vy cv vm cv wceq vy cv cX wcel vm cv cX wcel vw cv vj cv wss vw cW
      wrex vw cv vj cv wss vw vy vm cv cW csb wrex vy cv vm cv cX eleq1 vy cv
      vm cv wceq vw cv vj cv wss vw cW vy vm cv cW csb vy vm cv cW csbeq1a
      rexeq1d anbi12d elabf syl5ib ssrdv adantrr eqsstrd sseld cX cB wcel cU c0
      wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
      vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
      cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel
      vu cv vn cv wss wa wa wa vj cv vk cv cF vu cv csn crdg cfv wcel vm cv vy
      cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab wceq simprl jctird vd cv
      vj cv vk cv cF vu cv csn crdg cfv elunii syl6 ex 19.23adv com23 imp3a
      19.23adv vd cv cG vk cv cF vu cv csn crdg cfv cima cuni wcel vd cv vm cv
      wcel vm cv cG vk cv cF vu cv csn crdg cfv cima wcel wa vm wex vd cv vm cv
      wcel vj cv vk cv cF vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj
      cv wss vw cW wrex wa vy cab wceq wa vj wex wa vm wex vm vd cv cG vk cv cF
      vu cv csn crdg cfv cima eluni vd cv vm cv wcel vm cv cG vk cv cF vu cv
      csn crdg cfv cima wcel wa vd cv vm cv wcel vj cv vk cv cF vu cv csn crdg
      cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa
      vj wex wa vm vm cv cG vk cv cF vu cv csn crdg cfv cima wcel vj cv vk cv
      cF vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex
      wa vy cab wceq wa vj wex vd cv vm cv wcel vm cv cG vk cv cF vu cv csn
      crdg cfv cima wcel vj cv vk cv cF vu cv csn crdg cfv wcel vj cv vm cv cop
      cG wcel wa vj wex vj cv vk cv cF vu cv csn crdg cfv wcel vm cv vy cv cX
      wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa vj wex vj vm cv cG vk
      cv cF vu cv csn crdg cfv vm visset elima3 vj cv vk cv cF vu cv csn crdg
      cfv wcel vj cv vm cv cop cG wcel wa vj cv vk cv cF vu cv csn crdg cfv
      wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa vy cab wceq wa vj
      vj cv vm cv cop cG wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex wa
      vy cab wceq vj cv vk cv cF vu cv csn crdg cfv wcel vj cv vm cv cop cG
      wcel vj cv vm cv cop vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy
      cab wceq vf vh copab wcel vm cv vy cv cX wcel vw cv vj cv wss vw cW wrex
      wa vy cab wceq cG vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy
      cab wceq vf vh copab vj cv vm cv cop neibastop2.1 eleq2i vh cv vy cv cX
      wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vh cv vy cv cX wcel vw cv
      vj cv wss vw cW wrex wa vy cab wceq vm cv vy cv cX wcel vw cv vj cv wss
      vw cW wrex wa vy cab wceq vf vh vj cv vm cv vj visset vm visset vf cv vj
      cv wceq vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab vy cv cX wcel
      vw cv vj cv wss vw cW wrex wa vy cab vh cv vf cv vj cv wceq vy cv cX wcel
      vw cv vf cv wss vw cW wrex wa vy cv cX wcel vw cv vj cv wss vw cW wrex wa
      vy vf cv vj cv wceq vw cv vf cv wss vw cW wrex vw cv vj cv wss vw cW wrex
      vy cv cX wcel vf cv vj cv wceq vw cv vf cv wss vw cv vj cv wss vw cW vf
      cv vj cv vw cv sseq2 rexbidv anbi2d abbidv eqeq2d vh cv vm cv vy cv cX
      wcel vw cv vj cv wss vw cW wrex wa vy cab eqeq1 opelopab bitri anbi2i
      exbii bitri anbi2i exbii bitri syl5ib ssrdv a1d r19.21aiv vk com cG vk cv
      cF vu cv csn crdg cfv cima cuni vk cv cF vu cv csn crdg cfv cuni ss2iun
      syl cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX
      wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vk cv cF vu cv csn crdg cfv
      cuni vn cv wss vk com wral vk com vk cv cF vu cv csn crdg cfv cuni ciun
      vn cv wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa
      vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vk cv cF vu cv csn
      crdg cfv cuni vn cv wss vk com cX cB wcel vx cv vv cv wcel vv cv cX wss
      wa vv cU wral vx cX wral vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel
      vu cv vn cv wss wa wa vk cv com wcel vk cv cF vu cv csn crdg cfv cuni vn
      cv wss wi cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral cX cB wcel vx cv vv cv wcel vv cv
      cX wss wa vv cU wral vx cX wral wa vu cv cU wcel vu cv vn cv wss wa vk cv
      com wcel vk cv cF vu cv csn crdg cfv cuni vn cv wss wi vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa
      vn cv cX wss wa vk cv com wcel cX cB wcel vx cv vv cv wcel vv cv cX wss
      wa vv cU wral vx cX wral wa vu cv cU wcel vu cv vn cv wss wa wa vk cv cF
      vu cv csn crdg cfv cuni vn cv wss vx vy vz vw vv vu cB cU vf vh vk vn cF
      cG cW cX va vb vc neibastop1.1 neibastop2.1 neibastop2.2 neibastop2lem1
      com12 adantrl cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cv vv cv wcel vv cv cX wss wa vv cU
      wral vx cX vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral vx cv vv cv wcel vv cv cX wss wa vv cU wral cU c0 wne vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vx cv vv
      cv wcel vv cv cX wss wa vv cU vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa pm3.26 r19.20si adantl r19.20si sylanl2 r19.21aiv
      vk com vk cv cF vu cv csn crdg cfv cuni vn cv iunss sylibr sstrd $.
      $( [18-Sep-2009] $) $( [15-Sep-2009] $)

    $( Lemma for ~ neibastop2 . $)
    neibastop2lem3 $p |- ( ( ( X e. B /\ A. x e. X ( U =/= (/) /\ A. v e. U ( (
    x e. v /\ v C_ X ) /\ ( A. w e. U E. t e. U t C_ ( v i^i w ) /\ E. t e. U
    A. y e. t E. w e. W w C_ v ) ) ) ) /\ ( ( ( m e. U /\ m C_ d ) /\ ( x e. X
    /\ d e. ( rec ( F , { u } ) ` j ) ) ) /\ j e. om ) ) -> E. v e. U v C_ U. (
    G " { c | E. z e. ( rec ( F , { u } ) ` j ) E. x e. ( G ` z ) ( c e. U /\ c
    C_ z ) } ) ) $=
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vm cv cU wcel vm cv vd cv wss
      wa vx cv cX wcel vd cv vj cv cF vu cv csn crdg cfv wcel wa wa vj cv com
      wcel wa wa vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab cima wcel wa vr wex wi vn wal vv cU wrex vv cv cG vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab cima cuni wss vv cU wrex cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vm
      cv cU wcel vm cv vd cv wss wa vx cv cX wcel vd cv vj cv cF vu cv csn crdg
      cfv wcel wa vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn
      crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex cX cB wcel
      cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral wa vx cX wral wa vx cv cX wcel vd cv vj cv cF vu cv csn
      crdg cfv wcel wa vm cv cU wcel vm cv vd cv wss wa vj cv com wcel vn cv vv
      cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr
      wex wi vn wal vv cU wrex wi cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral vx cv
      cX wcel vd cv vj cv cF vu cv csn crdg cfv wcel vm cv cU wcel vm cv vd cv
      wss wa vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg
      cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi cU c0 wne
      vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
      cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      wral wa vx cX wral vx cv cX wcel cU c0 wne vx cv vv cv wcel vv cv cX wss
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa cX cB wcel vd cv vj cv
      cF vu cv csn crdg cfv wcel vm cv cU wcel vm cv vd cv wss wa vj cv com
      wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab
      cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX ra4 cX cB wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral vd cv vj cv cF vu cv csn crdg cfv wcel vm cv cU
      wcel vm cv vd cv wss wa vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel
      vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU
      wrex wi wi wi cU c0 wne cX cB wcel vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral vm cv cU wcel vm cv vd cv wss wa
      vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn
      cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn
      wal vv cU wrex wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
      vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
      wral vt cU wrex wa wa vv cU wral vm cv cU wcel vm cv vd cv wss vd cv vj
      cv cF vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv
      wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj
      cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU
      wrex wi wi cX cB wcel vt cv cX wss vt cU wral vx cv vm cv wcel vm cv cX
      wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vt cU wrex wa vm cU wral
      wa vm cv cU wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel
      vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv
      wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi wi vx cv vv
      cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral cX
      cB wcel vt cv cX wss vt cU wral vx cv vm cv wcel vm cv cX wss wa vw cv vm
      cv wss vw cW wrex vy vt cv wral vt cU wrex wa vm cU wral vm cv cU wcel vm
      cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vn cv
      vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa
      vr wex wi vn wal vv cU wrex wi wi wi wi vm cv cU wcel vt cv cX wss vt cU
      wral vx cv vm cv wcel vm cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv
      wral vt cU wrex wa vm cU wral cX cB wcel vm cv vd cv wss vd cv vj cv cF
      vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel
      vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU
      wrex wi wi wi vm cv cU wcel vx cv vm cv wcel vm cv cX wss wa vw cv vm cv
      wss vw cW wrex vy vt cv wral vt cU wrex wa vm cU wral vt cv cX wss vt cU
      wral cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj
      cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi wi vm cv cU wcel
      vx cv vm cv wcel vm cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa vm cU wral vx cv vm cv wcel vm cv cX wss wa vw cv vm cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa vt cv cX wss vt cU wral cX cB wcel
      vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vn
      cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel
      wa vr wex wi vn wal vv cU wrex wi wi wi wi wi vx cv vm cv wcel vm cv cX
      wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vt cU wrex wa vm cU wral
      vm cv cU wcel vx cv vm cv wcel vm cv cX wss wa vw cv vm cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa vx cv vm cv wcel vm cv cX wss wa vw cv vm cv
      wss vw cW wrex vy vt cv wral vt cU wrex wa vm cU ra4 com12 vm cv cU wcel
      vx cv vm cv wcel vm cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral
      vt cU wrex vt cv cX wss vt cU wral cX cB wcel vm cv vd cv wss vd cv vj cv
      cF vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv
      wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj
      cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU
      wrex wi wi wi wi wi vm cv cU wcel vw cv vm cv wss vw cW wrex vy vt cv
      wral vt cU wrex vx cv vm cv wcel vm cv cX wss wa vt cv cX wss vt cU wral
      cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj cv
      com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi wi wi vm cv cU wcel
      vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa
      vt cv cX wss vt cU wral cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv
      csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv
      cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu
      cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi
      wi wi wi wi wi vt cU vm cv cU wcel vt ax-17 vx cv vm cv wcel vm cv cX wss
      wa vt cv cX wss vt cU wral cX cB wcel vm cv vd cv wss vd cv vj cv cF vu
      cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr
      cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF
      vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex
      wi wi wi wi wi vt vx cv vm cv wcel vm cv cX wss wa vt ax-17 vt cv cX wss
      vt cU wral cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv
      wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg
      cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi wi vt
      vt cv cX wss vt cU hbra1 cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv
      csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv
      cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu
      cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi
      wi wi wi vt ax-17 hbim hbim vt cv cU wcel vm cv cU wcel vw cv vm cv wss
      vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa vt cv cX wss vt
      cU wral cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel
      vj cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv
      wrex vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi wi wi wi wi
      vt cv cU wcel vt cv cX wss vt cU wral vw cv vm cv wss vw cW wrex vy vt cv
      wral vx cv vm cv wcel vm cv cX wss wa vm cv cU wcel cX cB wcel vm cv vd
      cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv
      wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr
      wex wi vn wal vv cU wrex wi wi wi wi vt cv cU wcel vt cv cX wss vt cU
      wral vt cv cX wss vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv
      wcel vm cv cX wss wa vm cv cU wcel cX cB wcel vm cv vd cv wss vd cv vj cv
      cF vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr cv
      wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj
      cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv cU
      wrex wi wi wi wi wi wi wi vt cv cX wss vt cU wral vt cv cU wcel vt cv cX
      wss vt cv cX wss vt cU ra4 com12 vt cv cU wcel vt cv cX wss vw cv vm cv
      wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa vm cv cU
      wcel cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj
      cv com wcel vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel wa vr wex wi vn wal vv cU wrex wi wi wi wi vt cv cU wcel
      vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel
      vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss vd cv
      vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vn cv vv cv wcel vn cv vr
      cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv
      cU wrex vt cv cU wcel vn cv vt cv wcel vn cv vr cv wcel vr cv cG vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg
      cfv wrex vc cab cima wcel wa vr wex wi vn wal vn cv vv cv wcel vn cv vr
      cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv
      cU wrex vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv
      wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel
      vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com
      wcel wa wa vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab cima wcel wa vr wex wi vn wal vn cv vt cv wcel vn cv vr cv wcel vr cv
      cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu
      cv csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn wal vv vt cv cU vv
      cv vt cv wceq vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel wa vr wex wi vn cv vt cv wcel vn cv vr cv wcel vr cv cG
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv
      csn crdg cfv wrex vc cab cima wcel wa vr wex wi vn vv cv vt cv wceq vn cv
      vv cv wcel vn cv vt cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab cima wcel wa vr wex vv cv vt cv vn cv eleq2 imbi1d albidv rcla4ev vt
      cv cU wcel vt cv cX wss vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm
      cv wcel vm cv cX wss wa wa vm cv cU wcel wa cX cB wcel vm cv vd cv wss wa
      vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa simplll vt cv
      cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm
      cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss
      wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa wa vn cv
      vt cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa
      vr wex wi vn vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy
      vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB
      wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv
      com wcel wa vn cv vt cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel wa vr wex vn cv vm cv cG cfv wcel vm cv cG cfv cG vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn
      crdg cfv wrex vc cab cima wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel wa vr wex vt cv cU wcel vt cv cX wss wa vw cv vm cv wss
      vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU
      wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg
      cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vn cv vr cv wcel vr
      cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF
      vu cv csn crdg cfv wrex vc cab cima wcel wa vn cv vm cv cG cfv wcel vm cv
      cG cfv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr vm cv cG cfv vm cv cG
      fvex vr cv vm cv cG cfv wceq vn cv vr cv wcel vn cv vm cv cG cfv wcel vr
      cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF
      vu cv csn crdg cfv wrex vc cab cima wcel vm cv cG cfv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel vr cv vm cv cG cfv vn cv eleq2 vr cv vm cv cG cfv cG vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn
      crdg cfv wrex vc cab cima eleq1 anbi12d cla4ev vt cv cU wcel vt cv cX wss
      wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss
      wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu
      cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vn cv vy
      cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab vm cv cG cfv vt cv cU
      wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv
      wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa
      vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv
      wcel wa wa vn cv cX wcel vw cv vm cv wss vw vy vn cv cW csb wrex wa vn cv
      vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab wcel vt cv cU wcel vt
      cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm
      cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv
      vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa
      wa vn cv cX wcel vw cv vm cv wss vw vy vn cv cW csb wrex vt cv cU wcel vt
      cv cX wss wa vn cv vt cv wcel vn cv cX wcel vw cv vm cv wss vw cW wrex vy
      vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa cX cB
      wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv
      com wcel wa vt cv cX wss vn cv vt cv wcel vn cv cX wcel vt cv cU wcel vt
      cv cX vn cv ssel2 adantll ad2ant2rl vw cv vm cv wss vw cW wrex vy vt cv
      wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa vn cv vt cv
      wcel vw cv vm cv wss vw vy vn cv cW csb wrex vt cv cU wcel vt cv cX wss
      wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel
      wa vj cv com wcel wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv
      wcel vm cv cX wss wa wa vn cv vt cv wcel vw cv vm cv wss vw vy vn cv cW
      csb wrex vm cv cU wcel vw cv vm cv wss vw cW wrex vy vt cv wral vn cv vt
      cv wcel vw cv vm cv wss vw vy vn cv cW csb wrex vx cv vm cv wcel vm cv cX
      wss wa vn cv vt cv wcel vw cv vm cv wss vw cW wrex vy vt cv wral vw cv vm
      cv wss vw vy vn cv cW csb wrex vw cv vm cv wss vw cW wrex vw cv vm cv wss
      vw vy vn cv cW csb wrex vy vn cv vt cv vw cv vm cv wss vy vw vy vn cv cW
      csb vy vw vn cv cW vn visset vw cv vn cv wcel vy ax-17 hbcsb1 vw cv vm cv
      wss vy ax-17 hbrex vy cv vn cv wceq vw cv vm cv wss vw cW vy vn cv cW csb
      vy vn cv cW csbeq1a rexeq1d rcla4 impcom adantlr adantlr ad2ant2l jca vy
      cv cX wcel vw cv vm cv wss vw cW wrex wa vn cv cX wcel vw cv vm cv wss vw
      vy vn cv cW csb wrex wa vy vn cv vn cv cX wcel vw cv vm cv wss vw vy vn
      cv cW csb wrex vy vn cv cX wcel vy ax-17 vw cv vm cv wss vy vw vy vn cv
      cW csb vy vw vn cv cW vn visset vw cv vn cv wcel vy ax-17 hbcsb1 vw cv vm
      cv wss vy ax-17 hbrex hban vn visset vy cv vn cv wceq vy cv cX wcel vn cv
      cX wcel vw cv vm cv wss vw cW wrex vw cv vm cv wss vw vy vn cv cW csb
      wrex vy cv vn cv cX eleq1 vy cv vn cv wceq vw cv vm cv wss vw cW vy vn cv
      cW csb vy vn cv cW csbeq1a rexeq1d anbi12d elabf sylibr vy cv cX wcel vw
      cv vm cv wss vw cW wrex wa vy cab cvv wcel cG wfun wa vm cv vy cv cX wcel
      vw cv vm cv wss vw cW wrex wa vy cab cop cG wcel vm cv cG cfv vy cv cX
      wcel vw cv vm cv wss vw cW wrex wa vy cab wceq vt cv cU wcel vt cv cX wss
      wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss
      wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu
      cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vm cv vy
      cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cvv cG funopfvg vt cv cU
      wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv
      wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa
      vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv
      wcel wa wa vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cvv wcel cG
      wfun cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel
      wa vj cv com wcel wa vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab
      cvv wcel vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt
      cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa vn cv vt
      cv wcel cX cB wcel vm cv vd cv wss wa vy cv cX wcel vw cv vm cv wss vw cW
      wrex wa vy cab cvv wcel vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com
      wcel cX cB wcel vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cvv
      wcel vm cv vd cv wss cX cB wcel vw cv vm cv wss vw cW wrex vy cX crab cvv
      vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab vw cv vm cv wss vw cW
      wrex vy cX cB rabexg vw cv vm cv wss vw cW wrex vy cX df-rab syl5eqelr
      adantr ad2antrr ad2antrl cG wfun vh cv vy cv cX wcel vw cv vf cv wss vw
      cW wrex wa vy cab wceq vf vh copab wfun vf vh vy cv cX wcel vw cv vf cv
      wss vw cW wrex wa vy cab funopabeq cG vh cv vy cv cX wcel vw cv vf cv wss
      vw cW wrex wa vy cab wceq vf vh copab wceq cG wfun vh cv vy cv cX wcel vw
      cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab wfun wb neibastop2.1
      cG vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh
      copab funeq ax-mp mpbir jctir cX cB wcel vm cv vd cv wss wa vd cv vj cv
      cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vm cv vy cv cX wcel vw cv
      vm cv wss vw cW wrex wa vy cab cop cG wcel vt cv cU wcel vt cv cX wss wa
      vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa
      wa vm cv cU wcel wa wa vn cv vt cv wcel cX cB wcel vm cv vd cv wss wa vm
      cv vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cop cG wcel vd cv
      vj cv cF vu cv csn crdg cfv wcel vj cv com wcel cX cB wcel vm cv vy cv cX
      wcel vw cv vm cv wss vw cW wrex wa vy cab cop cG wcel vm cv vd cv wss cX
      cB wcel vm cv vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cop cG
      wcel vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab vy cv cX wcel vw
      cv vm cv wss vw cW wrex wa vy cab wceq vy cv cX wcel vw cv vm cv wss vw
      cW wrex wa vy cab eqid cX cB wcel vm cv vy cv cX wcel vw cv vm cv wss vw
      cW wrex wa vy cab cop vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa
      vy cab wceq vf vh copab wcel vy cv cX wcel vw cv vm cv wss vw cW wrex wa
      vy cab vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab wceq vm cv vy
      cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cop cG wcel cX cB wcel vy
      cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cvv wcel vm cv vy cv cX
      wcel vw cv vm cv wss vw cW wrex wa vy cab cop vh cv vy cv cX wcel vw cv
      vf cv wss vw cW wrex wa vy cab wceq vf vh copab wcel vy cv cX wcel vw cv
      vm cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vm cv wss vw cW wrex
      wa vy cab wceq wb cX cB wcel vw cv vm cv wss vw cW wrex vy cX crab cvv vy
      cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab vw cv vm cv wss vw cW
      wrex vy cX cB rabexg vw cv vm cv wss vw cW wrex vy cX df-rab syl5eqelr vm
      cv cvv wcel vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cvv wcel
      vm cv vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab cop vh cv vy cv
      cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab wcel vy cv
      cX wcel vw cv vm cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vm cv
      wss vw cW wrex wa vy cab wceq wb vm visset vh cv vy cv cX wcel vw cv vf
      cv wss vw cW wrex wa vy cab wceq vh cv vy cv cX wcel vw cv vm cv wss vw
      cW wrex wa vy cab wceq vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab
      vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy cab wceq vf vh vm cv vy cv
      cX wcel vw cv vm cv wss vw cW wrex wa vy cab cvv cvv vf cv vm cv wceq vy
      cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vm cv
      wss vw cW wrex wa vy cab vh cv vf cv vm cv wceq vy cv cX wcel vw cv vf cv
      wss vw cW wrex wa vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy vf cv vm
      cv wceq vw cv vf cv wss vw cW wrex vw cv vm cv wss vw cW wrex vy cv cX
      wcel vf cv vm cv wceq vw cv vf cv wss vw cv vm cv wss vw cW vf cv vm cv
      vw cv sseq2 rexbidv anbi2d abbidv eqeq2d vh cv vy cv cX wcel vw cv vm cv
      wss vw cW wrex wa vy cab vy cv cX wcel vw cv vm cv wss vw cW wrex wa vy
      cab eqeq1 opelopabg mpan syl cG vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab vm cv vy cv cX wcel vw cv vm cv wss vw cW
      wrex wa vy cab cop neibastop2.1 eleq2i syl5bb mpbiri adantr ad2antrr
      ad2antrl sylc eleqtrrd cG wfun vm cv cG cdm wcel wa vm cv vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv
      wrex vc cab wcel vm cv cG cfv cG vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel vt cv
      cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm
      cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss
      wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt
      cv wcel wa wa vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj
      cv cF vu cv csn crdg cfv wrex vc cab vm cv cG funfvima vt cv cU wcel vt
      cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm
      cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv
      vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa
      wa vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab cvv wcel vf cvv
      wral cG wfun vm cv cG cdm wcel wa vt cv cU wcel vt cv cX wss wa vw cv vm
      cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv
      cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg
      cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vy cv cX wcel vw cv
      vk cv wss vw cW wrex wa vy cab cvv wcel vk cvv wral vy cv cX wcel vw cv
      vf cv wss vw cW wrex wa vy cab cvv wcel vf cvv wral vt cv cU wcel vt cv
      cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv
      cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj
      cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa
      vy cv cX wcel vw cv vk cv wss vw cW wrex wa vy cab cvv wcel vk cvv vt cv
      cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm
      cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss
      wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt
      cv wcel wa wa vy cv cX wcel vw cv vk cv wss vw cW wrex wa vy cab cvv wcel
      vk cv cvv wcel cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn
      crdg cfv wcel wa vj cv com wcel wa vy cv cX wcel vw cv vk cv wss vw cW
      wrex wa vy cab cvv wcel vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw
      cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel
      wa wa vn cv vt cv wcel cX cB wcel vm cv vd cv wss wa vy cv cX wcel vw cv
      vk cv wss vw cW wrex wa vy cab cvv wcel vd cv vj cv cF vu cv csn crdg cfv
      wcel vj cv com wcel cX cB wcel vy cv cX wcel vw cv vk cv wss vw cW wrex
      wa vy cab cvv wcel vm cv vd cv wss cX cB wcel vw cv vk cv wss vw cW wrex
      vy cX crab cvv vy cv cX wcel vw cv vk cv wss vw cW wrex wa vy cab vw cv
      vk cv wss vw cW wrex vy cX cB rabexg vw cv vk cv wss vw cW wrex vy cX
      df-rab syl5eqelr adantr ad2antrr ad2antrl a1d r19.21aiv vy cv cX wcel vw
      cv vk cv wss vw cW wrex wa vy cab cvv wcel vy cv cX wcel vw cv vf cv wss
      vw cW wrex wa vy cab cvv wcel vk vf cvv vk cv vf cv wceq vy cv cX wcel vw
      cv vk cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab cvv vk cv vf cv wceq vy cv cX wcel vw cv vk cv wss vw cW
      wrex wa vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy vk cv vf cv wceq
      vw cv vk cv wss vw cW wrex vw cv vf cv wss vw cW wrex vy cv cX wcel vk cv
      vf cv wceq vw cv vk cv wss vw cv vf cv wss vw cW vk cv vf cv vw cv sseq2
      rexbidv anbi2d abbidv eleq1d cbvralv sylib vy cv cX wcel vw cv vf cv wss
      vw cW wrex wa vy cab cvv wcel vf cvv wral cG wfun cG cdm cvv wceq wa cG
      wfun vm cv cG cdm wcel wa vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy
      cab cvv wcel vf cvv wral cG cvv wfn cG wfun cG cdm cvv wceq wa vf vh cvv
      vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab cG cG vh cv vy cv cX
      wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab vf cv cvv wcel
      vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq wa vf vh
      copab neibastop2.1 vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy
      cab wceq vf cv cvv wcel vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa
      vy cab wceq wa vf vh vf cv cvv wcel vh cv vy cv cX wcel vw cv vf cv wss
      vw cW wrex wa vy cab wceq vf visset biantrur opabbii eqtri fnopab2g cG
      cvv df-fn bitri cG cdm cvv wceq vm cv cG cdm wcel cG wfun cG cdm cvv wceq
      vm cv cG cdm wcel vm cv cvv wcel vm visset cG cdm cvv vm cv eleq2 mpbiri
      anim2i sylbi syl vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex
      vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX
      cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj
      cv com wcel wa vn cv vt cv wcel wa wa vm cv cU wcel vm cv vz cv wss wa vx
      vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vm cv vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv
      wrex vc cab wcel vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex
      vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX
      cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj
      cv com wcel wa vn cv vt cv wcel wa wa vm cv cU wcel vm cv vk cv wss wa vx
      vk cv cG cfv wrex vk vj cv cF vu cv csn crdg cfv wrex vm cv cU wcel vm cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vd
      cv vj cv cF vu cv csn crdg cfv wcel vm cv cU wcel vm cv vd cv wss wa vx
      vd cv cG cfv wrex vm cv cU wcel vm cv vk cv wss wa vx vk cv cG cfv wrex
      vk vj cv cF vu cv csn crdg cfv wrex vt cv cU wcel vt cv cX wss wa vw cv
      vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm
      cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn
      crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vm cv cU wcel
      vm cv vk cv wss wa vx vk cv cG cfv wrex vm cv cU wcel vm cv vd cv wss wa
      vx vd cv cG cfv wrex vk vd cv vj cv cF vu cv csn crdg cfv vk cv vd cv
      wceq vm cv cU wcel vm cv vk cv wss wa vm cv cU wcel vm cv vd cv wss wa vx
      vk cv cG cfv vd cv cG cfv vk cv vd cv cG fveq2 vk cv vd cv wceq vm cv vk
      cv wss vm cv vd cv wss vm cv cU wcel vk cv vd cv vm cv sseq2 anbi2d
      rexeq12d rcla4ev cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn
      crdg cfv wcel wa vj cv com wcel wa vd cv vj cv cF vu cv csn crdg cfv wcel
      vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx
      cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa vn cv vt cv wcel cX
      cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel vj cv
      com wcel simplr ad2antrl vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw
      cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel
      wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv
      wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vx cv vd cv cG cfv wcel
      vm cv cU wcel vm cv vd cv wss wa wa vx wex vm cv cU wcel vm cv vd cv wss
      wa vx vd cv cG cfv wrex vx cv vd cv cG cfv wcel vm cv cU wcel vm cv vd cv
      wss vx cv vd cv cG cfv wcel vm cv cU wcel vm cv vd cv wss wa wa vx wex vt
      cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv
      vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv
      wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv
      vt cv wcel wa wa vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex
      vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX
      cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj
      cv com wcel wa vn cv vt cv wcel wa wa vx cv vy cv cX wcel vw cv vd cv wss
      vw cW wrex wa vy cab vd cv cG cfv vt cv cU wcel vt cv cX wss wa vw cv vm
      cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv
      cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg
      cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vx cv cX wcel vw cv
      vd cv wss vw cU wrex wa vx cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa
      vy cab wcel vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy
      vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB
      wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv
      com wcel wa vn cv vt cv wcel wa wa vx cv cX wcel vw cv vd cv wss vw cU
      wrex vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX
      wss wa wa vm cv cU wcel wa vx cv cX wcel vt cv cU wcel vt cv cX wss wa cX
      cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj
      cv com wcel wa vn cv vt cv wcel wa vx cv vm cv wcel vm cv cX wss wa vx cv
      cX wcel vw cv vm cv wss vw cW wrex vy vt cv wral vm cv cU wcel vm cv cX
      wss vx cv vm cv wcel vx cv cX wcel vm cv cX vx cv ssel2 ancoms ad2antlr
      ad2antlr vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt
      cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB
      wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv
      com wcel wa vn cv vt cv wcel wa wa vk cv vd cv wss vk cU wrex vw cv vd cv
      wss vw cU wrex vm cv cU wcel vm cv vd cv wss vk cv vd cv wss vk cU wrex
      vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx
      cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd
      cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn
      cv vt cv wcel wa wa vk cv vd cv wss vm cv vd cv wss vk vm cv cU vk cv vm
      cv vd cv sseq1 rcla4ev vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw
      cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel
      cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa
      vj cv com wcel wa vn cv vt cv wcel wa simplrr cX cB wcel vm cv vd cv wss
      wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vm cv vd
      cv wss vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv
      wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa vn cv vt cv
      wcel cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj
      cv com wcel simpllr ad2antrl sylanc vk cv vd cv wss vw cv vd cv wss vk vw
      cU vk cv vw cv vd cv sseq1 cbvrexv sylib jca vy cv cX wcel vw cv vd cv
      wss vw cW wrex wa vx cv cX wcel vw cv vd cv wss vw cU wrex wa vy vx cv vx
      visset vy cv vx cv wceq vy cv cX wcel vx cv cX wcel vw cv vd cv wss vw cW
      wrex vw cv vd cv wss vw cU wrex vy cv vx cv cX eleq1 vy cv vx cv wceq vw
      cv vd cv wss vw cW cU cW cU wceq vx cv vy cv vx cv vy cv wceq cU cW
      neibastop1.1 eqcomd eqcoms rexeq1d anbi12d elab sylibr vy cv cX wcel vw
      cv vd cv wss vw cW wrex wa vy cab cvv wcel cG wfun wa vd cv vy cv cX wcel
      vw cv vd cv wss vw cW wrex wa vy cab cop cG wcel vd cv cG cfv vy cv cX
      wcel vw cv vd cv wss vw cW wrex wa vy cab wceq vt cv cU wcel vt cv cX wss
      wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss
      wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu
      cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv wcel wa wa vd cv vy
      cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cvv cG funopfvg vt cv cU
      wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv
      wcel vm cv cX wss wa wa vm cv cU wcel wa wa cX cB wcel vm cv vd cv wss wa
      vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vn cv vt cv
      wcel wa wa vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cvv wcel cG
      wfun cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel
      wa vj cv com wcel wa vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab
      cvv wcel vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt
      cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa vn cv vt
      cv wcel cX cB wcel vm cv vd cv wss wa vy cv cX wcel vw cv vd cv wss vw cW
      wrex wa vy cab cvv wcel vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com
      wcel cX cB wcel vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cvv
      wcel vm cv vd cv wss cX cB wcel vw cv vd cv wss vw cW wrex vy cX crab cvv
      vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab vw cv vd cv wss vw cW
      wrex vy cX cB rabexg vw cv vd cv wss vw cW wrex vy cX df-rab syl5eqelr
      adantr ad2antrr ad2antrl cG wfun vh cv vy cv cX wcel vw cv vf cv wss vw
      cW wrex wa vy cab wceq vf vh copab wfun vf vh vy cv cX wcel vw cv vf cv
      wss vw cW wrex wa vy cab funopabeq cG vh cv vy cv cX wcel vw cv vf cv wss
      vw cW wrex wa vy cab wceq vf vh copab wceq cG wfun vh cv vy cv cX wcel vw
      cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab wfun wb neibastop2.1
      cG vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh
      copab funeq ax-mp mpbir jctir cX cB wcel vm cv vd cv wss wa vd cv vj cv
      cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vd cv vy cv cX wcel vw cv
      vd cv wss vw cW wrex wa vy cab cop cG wcel vt cv cU wcel vt cv cX wss wa
      vw cv vm cv wss vw cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa
      wa vm cv cU wcel wa wa vn cv vt cv wcel cX cB wcel vm cv vd cv wss wa vd
      cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cop cG wcel vd cv
      vj cv cF vu cv csn crdg cfv wcel vj cv com wcel cX cB wcel vd cv vy cv cX
      wcel vw cv vd cv wss vw cW wrex wa vy cab cop cG wcel vm cv vd cv wss cX
      cB wcel vd cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cop cG
      wcel vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab vy cv cX wcel vw
      cv vd cv wss vw cW wrex wa vy cab wceq vy cv cX wcel vw cv vd cv wss vw
      cW wrex wa vy cab eqid cX cB wcel vd cv vy cv cX wcel vw cv vd cv wss vw
      cW wrex wa vy cab cop vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa
      vy cab wceq vf vh copab wcel vy cv cX wcel vw cv vd cv wss vw cW wrex wa
      vy cab vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab wceq vd cv vy
      cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cop cG wcel cX cB wcel vy
      cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cvv wcel vd cv vy cv cX
      wcel vw cv vd cv wss vw cW wrex wa vy cab cop vh cv vy cv cX wcel vw cv
      vf cv wss vw cW wrex wa vy cab wceq vf vh copab wcel vy cv cX wcel vw cv
      vd cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vd cv wss vw cW wrex
      wa vy cab wceq wb cX cB wcel vw cv vd cv wss vw cW wrex vy cX crab cvv vy
      cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab vw cv vd cv wss vw cW
      wrex vy cX cB rabexg vw cv vd cv wss vw cW wrex vy cX df-rab syl5eqelr vd
      cv cvv wcel vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cvv wcel
      vd cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab cop vh cv vy cv
      cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab wcel vy cv
      cX wcel vw cv vd cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vd cv
      wss vw cW wrex wa vy cab wceq wb vd visset vh cv vy cv cX wcel vw cv vf
      cv wss vw cW wrex wa vy cab wceq vh cv vy cv cX wcel vw cv vd cv wss vw
      cW wrex wa vy cab wceq vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab
      vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab wceq vf vh vd cv vy cv
      cX wcel vw cv vd cv wss vw cW wrex wa vy cab cvv cvv vf cv vd cv wceq vy
      cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vd cv
      wss vw cW wrex wa vy cab vh cv vf cv vd cv wceq vy cv cX wcel vw cv vf cv
      wss vw cW wrex wa vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy vf cv vd
      cv wceq vw cv vf cv wss vw cW wrex vw cv vd cv wss vw cW wrex vy cv cX
      wcel vf cv vd cv wceq vw cv vf cv wss vw cv vd cv wss vw cW vf cv vd cv
      vw cv sseq2 rexbidv anbi2d abbidv eqeq2d vh cv vy cv cX wcel vw cv vd cv
      wss vw cW wrex wa vy cab vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy
      cab eqeq1 opelopabg mpan syl cG vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab vd cv vy cv cX wcel vw cv vd cv wss vw cW
      wrex wa vy cab cop neibastop2.1 eleq2i syl5bb mpbiri adantr ad2antrr
      ad2antrl sylc eleqtrrd vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw
      cW wrex vy vt cv wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel
      cX cB wcel vm cv vd cv wss wa vd cv vj cv cF vu cv csn crdg cfv wcel wa
      vj cv com wcel wa vn cv vt cv wcel wa simplrr cX cB wcel vm cv vd cv wss
      wa vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel wa vm cv vd
      cv wss vt cv cU wcel vt cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv
      wral vx cv vm cv wcel vm cv cX wss wa wa vm cv cU wcel wa wa vn cv vt cv
      wcel cX cB wcel vm cv vd cv wss vd cv vj cv cF vu cv csn crdg cfv wcel vj
      cv com wcel simpllr ad2antrl vx cv vd cv cG cfv wcel vm cv cU wcel vm cv
      vd cv wss wa wa vx 19.8a sylan32c vm cv cU wcel vm cv vd cv wss wa vx vd
      cv cG cfv df-rex sylibr sylanc vm cv cU wcel vm cv vk cv wss wa vx vk cv
      cG cfv wrex vm cv cU wcel vm cv vz cv wss wa vx vz cv cG cfv wrex vk vz
      vm vj cv cF vu cv csn crdg cfv vm cv vj cv cF vu cv csn crdg cfv wcel vk
      ax-17 vz vm vj cv cF vu cv csn crdg vz vm vu cv csn cF vz vm cF vb cv vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab
      wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vz vm vz vm vm vb cv vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab
      vm cv vb cv wcel vz ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz va cv wrex vz vc vm vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz va cv hbre1 hbab hbeq hbopab hbxfr vm cv vu cv csn wcel vz
      ax-17 hbrdg vm cv vj cv wcel vz ax-17 hbfv vm cv cU wcel vm cv vk cv wss
      wa vx vk cv cG cfv wrex vz ax-17 vm cv cU wcel vm cv vz cv wss wa vx vz
      cv cG cfv wrex vk ax-17 vk cv vz cv wceq vm cv cU wcel vm cv vk cv wss wa
      vm cv cU wcel vm cv vz cv wss wa vx vk cv cG cfv vz cv cG cfv vk cv vz cv
      cG fveq2 vk cv vz cv wceq vm cv vk cv wss vm cv vz cv wss vm cv cU wcel
      vk cv vz cv vm cv sseq2 anbi2d rexeq12d cbvrexf sylib vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vm
      cv cU wcel vm cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn
      crdg cfv wrex vc vm cv vm cv cU wcel vm cv vz cv wss wa vx vz cv cG cfv
      wrex vc vz vj cv cF vu cv csn crdg cfv vc vm vm vz cv vj cv cF vu cv csn
      crdg cfv vm cv vz cv wcel vc ax-17 vc vm vj cv cF vu cv csn crdg vc vm vu
      cv csn cF vc vm cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va
      vb vc vm vc vm vm vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab vm cv vb cv wcel vc ax-17 vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc vm hbab1 hbeq hbopab
      hbxfr vm cv vu cv csn wcel vc ax-17 hbrdg vm cv vj cv wcel vc ax-17 hbfv
      hbel vm cv cU wcel vm cv vz cv wss wa vx vz cv cG cfv wrex vc ax-17 hbrex
      vm visset vc cv vm cv wceq vc cv cU wcel vc cv vz cv wss wa vm cv cU wcel
      vm cv vz cv wss wa vz vx vj cv cF vu cv csn crdg cfv vz cv cG cfv vc cv
      vm cv wceq vc cv cU wcel vm cv cU wcel vc cv vz cv wss vm cv vz cv wss vc
      cv vm cv cU eleq1 vc cv vm cv vz cv sseq1 anbi12d 2rexbidv elabf sylibr
      sylc sylanc expr 19.21aiv sylanc exp510 exp58 syld com25 com12 r19.23ad
      com23 imp3a syld com23 com14 imp3a vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral vt cv cX wss vt cU wral vx cv vm
      cv wcel vm cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa vm cU wral vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral vv cv cX wss vv cU wral vt cv cX wss vt cU wral vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cv cX
      wss vv cU vx cv vv cv wcel vv cv cX wss vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      simplr r19.20si vv cv cX wss vt cv cX wss vv vt cU vv cv vt cv cX sseq1
      cbvralv sylib vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral vx cv vv cv wcel vv cv cX wss wa vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa vv cU wral vx cv vm cv wcel vm cv cX wss
      wa vw cv vm cv wss vw cW wrex vy vt cv wral vt cU wrex wa vm cU wral vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vx cv vv
      cv wcel vv cv cX wss wa vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa vv cU vx cv vv cv wcel vv cv cX wss wa vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex vx cv vv cv wcel vv cv cX wss wa vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vx cv vv cv wcel vv cv cX wss wa vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa id adantrl r19.20si vx cv vv cv wcel vv
      cv cX wss wa vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa vx cv
      vm cv wcel vm cv cX wss wa vw cv vm cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa vv vm cU vv cv vm cv wceq vx cv vv cv wcel vv cv cX wss wa vx cv
      vm cv wcel vm cv cX wss wa vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex vw cv vm cv wss vw cW wrex vy vt cv wral vt cU wrex vv cv vm cv wceq
      vx cv vv cv wcel vx cv vm cv wcel vv cv cX wss vm cv cX wss vv cv vm cv
      vx cv eleq2 vv cv vm cv cX sseq1 anbi12d vv cv vm cv wceq vw cv vv cv wss
      vw cW wrex vw cv vm cv wss vw cW wrex vt vy cU vt cv vv cv vm cv wceq vw
      cv vv cv wss vw cv vm cv wss vw cW vv cv vm cv vw cv sseq2 rexbidv
      rexralbidv anbi12d cbvralv sylib jca syl5 imp4a com34 adantld syl9r imp4b
      com23 imp44 vn cv vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex
      vc cab cima wcel wa vr wex wi vn wal vv cv cG vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab
      cima cuni wss vv cU vv cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni wss vn cv
      vv cv wcel vn cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni wcel wi vn wal vn cv
      vv cv wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa
      vr wex wi vn wal vn vv cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni dfss2 vn cv
      vv cv wcel vn cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni wcel wi vn cv vv cv
      wcel vn cv vr cv wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr
      wex wi vn vn cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni wcel vn cv vr cv
      wcel vr cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj
      cv cF vu cv csn crdg cfv wrex vc cab cima wcel wa vr wex vn cv vv cv wcel
      vr vn cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj
      cv cF vu cv csn crdg cfv wrex vc cab cima eluni imbi2i albii bitr2i
      rexbii sylib $.
      $( [19-Sep-2009] $) $( [19-Sep-2009] $)

    $( Lemma for ~ neibastop2 . $)
    neibastop2lem4 $p |- ( ( ( X e. B /\ A. x e. X ( U =/= (/) /\ A. v e. U ( (
    x e. v /\ v C_ X ) /\ ( A. w e. U E. t e. U t C_ ( v i^i w ) /\ E. t e. U
    A. y e. t E. w e. W w C_ v ) ) ) ) /\ ( ( { o | ( o C_ X /\ A. x e. o E. v
    e. U v C_ o ) } e. Top /\ x e. X ) /\ ( n C_ X /\ E. u e. U u C_ n ) ) ) ->
    E. g e. { o | ( o C_ X /\ A. x e. o E. v e. U v C_ o ) } ( x e. g /\ g C_ n
    ) ) $=
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss
      vu cv vn cv wss vu cU wrex wa vx cv vg cv wcel vg cv vn cv wss wa vg vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wrex cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa wa vn cv cX wss vu cv
      vn cv wss vu cU wrex vx cv vg cv wcel vg cv vn cv wss wa vg vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wrex cX cB wcel cU c0
      wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
      vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
      cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu
      cU wrex vx cv vg cv wcel vg cv vn cv wss wa vg vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wrex wi cX cB wcel cU c0 wne vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa wa vu cv vn cv wss vx
      cv vg cv wcel vg cv vn cv wss wa vg vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wrex vu cU cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss wa wa vu cv cU wcel vu cv vn
      cv wss vx cv vg cv wcel vg cv vn cv wss wa vg vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wrex cX cB wcel cU c0 wne vx cv vv
      cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa
      vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv
      wss wa vx cv vg cv wcel vg cv vn cv wss wa vg vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wrex cX cB wcel cU c0 wne vx cv vv
      cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa
      vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv
      wss wa wa wa vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel vx cv vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun vn cv wss wa wa vx cv vg cv wcel vg cv
      vn cv wss wa vg vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab wrex cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel
      wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vk com cG vk cv
      cF vu cv csn crdg cfv cima cuni ciun cX wss vv cv vk com cG vk cv cF vu
      cv csn crdg cfv cima cuni ciun wss vv cU wrex vx vk com cG vk cv cF vu cv
      csn crdg cfv cima cuni ciun wral wa vx cv vk com cG vk cv cF vu cv csn
      crdg cfv cima cuni ciun wcel vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun vn cv wss wa wa vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      ciun vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel
      vx cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vk com cG
      vk cv cF vu cv csn crdg cfv cima cuni ciun vn cv wss wa wa cX cB wcel cU
      c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa
      vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU
      wcel vu cv vn cv wss wa wa wa vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun vn cv wss vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun
      cX wss vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv
      cU wrex vx vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wral wa
      vx cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vk com cG
      vk cv cF vu cv csn crdg cfv cima cuni ciun vn cv wss wa wa vx vy vz vw vv
      vu vt cB cU vf vh vk vn vo cF cG cW cX va vb vc neibastop1.1 neibastop2.1
      neibastop2.2 neibastop2lem2 cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx
      cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vn cv wss wa vk com cG
      vk cv cF vu cv csn crdg cfv cima cuni ciun cX wss vv cv vk com cG vk cv
      cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex vx vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun wral vx cv vk com cG vk cv cF vu cv csn
      crdg cfv cima cuni ciun wcel vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun vn cv wss wa vn cv cX wss vk com cG vk cv cF vu cv csn crdg cfv
      cima cuni ciun vn cv wss vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      ciun cX wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel
      wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vk com cG vk cv
      cF vu cv csn crdg cfv cima cuni ciun vn cv wss vn cv cX wss vk com cG vk
      cv cF vu cv csn crdg cfv cima cuni ciun cX wss vk com cG vk cv cF vu cv
      csn crdg cfv cima cuni ciun vn cv cX sstr ancoms cX cB wcel cU c0 wne vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv cU wcel vu cv vn cv
      wss wa simprlr sylan cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vv cv vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex vx vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wral vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa
      vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa vk com cG vk cv cF vu
      cv csn crdg cfv cima cuni ciun vn cv wss cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss
      vv cU wrex vx vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral vx cX cB wcel vx ax-17 cU c0 wne vx cv vv
      cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa
      vx cX hbra1 hban cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vx cv cG vj cv
      cF vu cv csn crdg cfv cima cuni wcel vj com wrex vv cv vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun wss vv cU wrex vx cv vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun wcel cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vx cv cG vj cv cF vu cv csn crdg cfv cima cuni wcel vv cv vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex vj com
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vx cv cG vj cv cF vu cv csn
      crdg cfv cima cuni wcel vj cv com wcel vv cv vk com cG vk cv cF vu cv csn
      crdg cfv cima cuni ciun wss vv cU wrex cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vx cv vm cv wcel vd cv vj cv cF vu cv csn crdg cfv wcel vd cv
      vm cv cop cG wcel wa vd wex wa vm wex vj cv com wcel vv cv vk com cG vk
      cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex wi vx cv cG vj cv
      cF vu cv csn crdg cfv cima cuni wcel cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vx cv vm cv wcel vd cv vj cv cF vu cv csn crdg cfv wcel vd cv
      vm cv cop cG wcel wa vd wex wa vj cv com wcel vv cv vk com cG vk cv cF vu
      cv csn crdg cfv cima cuni ciun wss vv cU wrex wi vm cX cB wcel cU c0 wne
      vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
      cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      wral wa vx cX wral wa vx cv vm cv wcel vd cv vj cv cF vu cv csn crdg cfv
      wcel vd cv vm cv cop cG wcel wa vd wex vj cv com wcel vv cv vk com cG vk
      cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex wi cX cB wcel cU
      c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa
      vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv wcel vd cv
      vm cv cop cG wcel wa vd wex vx cv vm cv wcel vj cv com wcel vv cv vk com
      cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex wi cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv wcel
      vd cv vm cv cop cG wcel wa vx cv vm cv wcel vj cv com wcel vv cv vk com
      cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex wi wi vd cX
      cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv
      wcel vm cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab wceq wa vx
      cv vm cv wcel vj cv com wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv
      cima cuni ciun wss vv cU wrex wi wi vd cv vj cv cF vu cv csn crdg cfv
      wcel vd cv vm cv cop cG wcel wa cX cB wcel cU c0 wne vx cv vv cv wcel vv
      cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
      wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
      vd cv vj cv cF vu cv csn crdg cfv wcel vm cv vy cv cX wcel vw cv vd cv
      wss vw cW wrex wa vy cab wceq vx cv vm cv wcel vj cv com wcel vv cv vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex wi wi cX
      cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral wa vm cv vy cv cX wcel vw cv vd cv
      wss vw cW wrex wa vy cab wceq vd cv vj cv cF vu cv csn crdg cfv wcel vx
      cv vm cv wcel vj cv com wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv
      cima cuni ciun wss vv cU wrex wi wi vm cv vy cv cX wcel vw cv vd cv wss
      vw cW wrex wa vy cab wceq vd cv vj cv cF vu cv csn crdg cfv wcel vx cv vm
      cv wcel vj cv com wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun wss vv cU wrex wi wi wi vd cv vj cv cF vu cv csn crdg cfv wcel
      vx cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab wcel vj cv com
      wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU
      wrex wi wi wi cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vm cv vy cv cX
      wcel vw cv vd cv wss vw cW wrex wa vy cab wceq vx cv vm cv wcel vj cv com
      wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU
      wrex wi wi vx cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab wcel
      vj cv com wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun
      wss vv cU wrex wi wi vd cv vj cv cF vu cv csn crdg cfv wcel vm cv vy cv
      cX wcel vw cv vd cv wss vw cW wrex wa vy cab wceq vx cv vm cv wcel vx cv
      vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab wcel vj cv com wcel vv
      cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex wi
      vm cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab vx cv eleq2
      imbi1d imbi2d cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu
      cv csn crdg cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa vj cv
      com wcel vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss
      vv cU wrex wi vx cv vy cv cX wcel vw cv vd cv wss vw cW wrex wa vy cab
      wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn
      crdg cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa vj cv com wcel
      vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg
      cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv com wcel wa
      vv cv cG vk cv cF vu cv csn crdg cfv cima cuni wss vk com wrex vv cU wrex
      vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg
      cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv com wcel wa
      vv cv cG vk cv cF vu cv csn crdg cfv cima cuni wss vv cU wrex vk com wrex
      vv cv cG vk cv cF vu cv csn crdg cfv cima cuni wss vk com wrex vv cU wrex
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg
      cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv com wcel wa
      vv cv cG vk cv cF vu cv csn crdg cfv cima cuni wss vv cU wrex vk com wrex
      vj cv csuc com wcel vv cv cG vj cv csuc cF vu cv csn crdg cfv cima cuni
      wss vv cU wrex vv cv cG vk cv cF vu cv csn crdg cfv cima cuni wss vv cU
      wrex vk com wrex cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF
      vu cv csn crdg cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj
      cv com wcel wa wa vv cv cG vk cv cF vu cv csn crdg cfv cima cuni wss vv
      cU wrex vv cv cG vj cv csuc cF vu cv csn crdg cfv cima cuni wss vv cU
      wrex vk vj cv csuc com vk cv vj cv csuc wceq vv cv cG vk cv cF vu cv csn
      crdg cfv cima cuni wss vv cv cG vj cv csuc cF vu cv csn crdg cfv cima
      cuni wss vv cU vk cv vj cv csuc wceq cG vk cv cF vu cv csn crdg cfv cima
      cuni cG vj cv csuc cF vu cv csn crdg cfv cima cuni vv cv vk cv vj cv csuc
      wceq cG vk cv cF vu cv csn crdg cfv cima cG vj cv csuc cF vu cv csn crdg
      cfv cima vk cv vj cv csuc wceq vk cv cF vu cv csn crdg cfv vj cv csuc cF
      vu cv csn crdg cfv cG vk cv vj cv csuc cF vu cv csn crdg fveq2 imaeq2d
      unieqd sseq2d rexbidv rcla4ev vj cv com wcel vj cv csuc com wcel cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv wcel
      vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv peano2 ad2antll cX
      cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv
      wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv com wcel wa wa
      vv cv cG vj cv csuc cF vu cv csn crdg cfv cima cuni wss vv cU wrex vv cv
      cG vj cv cF vu cv csn crdg cfv cF cfv cima cuni wss vv cU wrex cX cB wcel
      cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv wcel vx
      cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv com wcel wa wa vv cv cG
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv
      csn crdg cfv wrex vc cab cima cuni wss vv cU wrex vv cv cG vj cv cF vu cv
      csn crdg cfv cF cfv cima cuni wss vv cU wrex cX cB wcel cU c0 wne vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vx cX wral wa vd cv vj cv cF vu cv csn crdg cfv wcel vx cv cX wcel vw
      cv vd cv wss vw cU wrex vj cv com wcel vv cv cG vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab
      cima cuni wss vv cU wrex cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
      wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
      cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vw cv
      vd cv wss vw cU wrex vx cv cX wcel vd cv vj cv cF vu cv csn crdg cfv wcel
      vj cv com wcel vv cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni wss vv cU wrex
      wi cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vm cv vd cv wss vm cU wrex
      vx cv cX wcel vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vv cv
      cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu
      cv csn crdg cfv wrex vc cab cima cuni wss vv cU wrex wi wi wi vw cv vd cv
      wss vw cU wrex cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vm cv vd cv
      wss vx cv cX wcel vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel
      vv cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cab cima cuni wss vv cU wrex wi wi wi vm cU
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vm cv cU wcel vm cv vd cv wss
      vx cv cX wcel vd cv vj cv cF vu cv csn crdg cfv wcel vj cv com wcel vv cv
      cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu
      cv csn crdg cfv wrex vc cab cima cuni wss vv cU wrex wi cX cB wcel cU c0
      wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
      vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
      cU wral wa vx cX wral wa vm cv cU wcel vm cv vd cv wss wa vx cv cX wcel
      vd cv vj cv cF vu cv csn crdg cfv wcel wa vj cv com wcel vv cv cG vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn
      crdg cfv wrex vc cab cima cuni wss vv cU wrex vx vy vz vw vv vu vt cB cU
      vf vh vj vm cF cG cW cX va vb vc vd neibastop1.1 neibastop2.1
      neibastop2.2 neibastop2lem3 exp44 exp5c r19.23adv vw cv vd cv wss vm cv
      vd cv wss vw vm cU vw cv vm cv vd cv sseq1 cbvrexv syl5ib com24 imp511 vv
      cv cG vj cv cF vu cv csn crdg cfv cF cfv cima cuni wss vv cU wrex vv cv
      cG vj cv cF vu cv csn crdg cfv vb cv vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab cfv cima cuni wss
      vv cU wrex vv cv cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vj cv cF vu cv csn crdg cfv wrex vc cab cima cuni wss vv cU wrex vv cv
      cG vj cv cF vu cv csn crdg cfv cF cfv cima cuni wss vv cv cG vj cv cF vu
      cv csn crdg cfv vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab wceq va vb copab cfv cima cuni wss vv cU cG vj
      cv cF vu cv csn crdg cfv cF cfv cima cuni cG vj cv cF vu cv csn crdg cfv
      vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex
      vc cab wceq va vb copab cfv cima cuni vv cv cG vj cv cF vu cv csn crdg
      cfv cF cfv cima cG vj cv cF vu cv csn crdg cfv vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab
      cfv cima vj cv cF vu cv csn crdg cfv cF cfv vj cv cF vu cv csn crdg cfv
      vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex
      vc cab wceq va vb copab cfv cG vj cv cF vu cv csn crdg cfv cF vb cv vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq
      va vb copab neibastop2.2 fveq1i imaeq2i unieqi sseq2i rexbii vv cv cG vj
      cv cF vu cv csn crdg cfv vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz va cv wrex vc cab wceq va vb copab cfv cima cuni wss vv cv
      cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu
      cv csn crdg cfv wrex vc cab cima cuni wss vv cU cG vj cv cF vu cv csn
      crdg cfv vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vc cab wceq va vb copab cfv cima cuni cG vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab cima cuni vv cv cG vj cv cF vu cv csn crdg cfv vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb
      copab cfv cima cG vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz vj cv cF vu cv csn crdg cfv wrex vc cab cima vj cv cF vu cv csn crdg
      cfv vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv
      wrex vc cab wceq va vb copab cfv vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cG vb cv vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq
      va vb copab wfun vj cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab
      cop vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv
      wrex vc cab wceq va vb copab wcel vj cv cF vu cv csn crdg cfv vb cv vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq
      va vb copab cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      vj cv cF vu cv csn crdg cfv wrex vc cab wceq va vb vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab funopabeq vj cv cF vu
      cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      vj cv cF vu cv csn crdg cfv wrex vc cab cop vb cv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab wcel
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv
      csn crdg cfv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab wceq vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab eqid vj cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cop vb cv vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab
      wceq va vb copab wcel vj cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab
      cop vs cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr cv
      wrex vc cab wceq vr vs copab wcel vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv
      wrex vc cab wceq vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab wceq va vb copab vs cv vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vr vs copab vj
      cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab cop vb cv vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq vs cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc
      cab wceq va vb vr vs va cv vr cv wceq vb cv vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vb cv vs
      cv wceq vs cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr
      cv wrex vc cab wceq va cv vr cv wceq vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz va cv wrex vc cab vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz vr cv wrex vc cab vb cv va cv vr cv wceq vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cv cU wcel
      vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv vr cv rexeq1 abbidv eqeq2d
      vb cv vs cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vr
      cv wrex vc cab eqeq1 sylan9bb cbvopabv eleq2i vs cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab wceq vs cv vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn
      crdg cfv wrex vc cab wceq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc
      cab wceq vr vs vj cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab vj cv
      cF vu cv csn crdg fvex vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vj cv vb cv vr cv cU wcel vr cv vs cv wss
      wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn
      crdg cfv wrex vc cab cvv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz vj cv vb cv vr cv cU wcel vr cv vs cv wss wa vx
      vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg
      cfv wrex vc vj cv cF vu cv csn crdg cfv vj cv vb cv vr cv cU wcel vr cv
      vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab
      vu cv csn crdg cfv wceq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz vj cv vb cv vr cv cU wcel vr cv vs cv wss wa vx
      vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg
      cfv wrex wb vj cv cF vu cv csn crdg vb cv vr cv cU wcel vr cv vs cv wss
      wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn
      crdg cF vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va
      cv wrex vr cab wceq va vb copab wceq cF vu cv csn crdg vb cv vr cv cU
      wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va
      vb copab vu cv csn crdg wceq cF vb cv vc cv cU wcel vc cv vz cv wss wa vx
      vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab vb cv vr cv cU
      wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va
      vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz va cv wrex vc cab wceq vb cv vr cv cU wcel vr cv vs cv wss wa
      vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vr cv cU wcel vr
      cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab vb cv vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vr cv
      cU wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vr cab vr
      cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vr cv
      cU wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc vr vc cv
      vr cv wceq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vr cv cU
      wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz va cv vc cv vr cv wceq vc
      cv cU wcel vc cv vz cv wss wa vr cv cU wcel vr cv vz cv wss wa vx vz cv
      cG cfv vc cv vr cv wceq vc cv cU wcel vr cv cU wcel vc cv vz cv wss vr cv
      vz cv wss vc cv vr cv cU eleq1 vc cv vr cv vz cv sseq1 anbi12d rexbidv
      rexbidv cbvabv vr cv cU wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv
      wrex vr vr cv cU wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vr cv cU
      wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vz vs va cv vz cv vs cv wceq
      vr cv cU wcel vr cv vz cv wss wa vr cv cU wcel vr cv vs cv wss wa vx vz
      cv cG cfv vs cv cG cfv vz cv vs cv cG fveq2 vz cv vs cv wceq vr cv vz cv
      wss vr cv vs cv wss vr cv cU wcel vz cv vs cv vr cv sseq2 anbi2d rexeq12d
      cbvrexv abbii eqtri eqeq2i opabbii eqtri vu cv csn cF vb cv vr cv cU wcel
      vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb
      copab rdgeq1 ax-mp fveq1i vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vm vj cv cF vu cv csn crdg cfv vj cv vb cv vr cv cU wcel vr
      cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb
      copab vu cv csn crdg cfv vz vm vj cv cF vu cv csn crdg vz vm vu cv csn cF
      vz vm cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vz vm
      vz vm vm vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vc cab vm cv vb cv wcel vz ax-17 vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz va cv wrex vz vc vm vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz va cv hbre1 hbab hbeq hbopab hbxfr vm cv
      vu cv csn wcel vz ax-17 hbrdg vm cv vj cv wcel vz ax-17 hbfv vm cv vj cv
      vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex
      vr cab wceq va vb copab vu cv csn crdg cfv wcel vz ax-17 rexeq1f ax-mp
      abbii vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vc vj cv
      vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex
      vr cab wceq va vb copab vu cv csn crdg cfv vj cv vb cv vr cv cU wcel vr
      cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb
      copab vu cv csn crdg fvex vc cv cU wcel vc cv vz cv wss wa vx vc vz cv cG
      cfv vz cv cG fvex vc cv cU wcel vc cv vz cv wss wa vc cab vc cv vz cv wss
      vc cab vz cv cpw vc cv vz cv wss vc cab cvv vc vz cv df-pw vz cv vz
      visset pwex eqeltrri vc cv cU wcel vc cv vz cv wss wa vc cv vz cv wss vc
      vc cv cU wcel vc cv vz cv wss pm3.27 ss2abi ssexi abrexex2 abrexex2
      eqeltri vr cv vj cv cF vu cv csn crdg cfv wceq vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cab vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab
      vs cv vr cv vj cv cF vu cv csn crdg cfv wceq vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz vr cv wrex vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc vc vm vm
      vr cv vj cv cF vu cv csn crdg cfv vm cv vr cv wcel vc ax-17 vc vm vj cv
      cF vu cv csn crdg vc vm vu cv csn cF vc vm cF vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb copab
      neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab wceq va vb vc vm vc vm vm vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vm cv vb cv wcel
      vc ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv
      wrex vc vm hbab1 hbeq hbopab hbxfr vm cv vu cv csn wcel vc ax-17 hbrdg vm
      cv vj cv wcel vc ax-17 hbfv hbeq vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vm vr cv vj cv cF vu cv csn crdg cfv vm cv vr cv wcel
      vz ax-17 vz vm vj cv cF vu cv csn crdg vz vm vu cv csn cF vz vm cF vb cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vz vm vz vm vm vb cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab vm cv vb cv wcel vz ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz va cv wrex vz vc vm vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz va cv hbre1 hbab hbeq hbopab hbxfr vm cv vu cv csn wcel
      vz ax-17 hbrdg vm cv vj cv wcel vz ax-17 hbfv rexeq1f abbid eqeq2d vs cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv cF vu cv
      csn crdg cfv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab eqeq1 opelopab bitri
      mpbir vj cv cF vu cv csn crdg cfv vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vj cv cF vu cv csn crdg cfv wrex vc cab vb cv vc cv cU
      wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va
      vb copab vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cab vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vz vj cv vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv
      cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg cfv wrex
      vc cab cvv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vj cv vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv
      wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg cfv wrex vc vj
      cv cF vu cv csn crdg cfv vj cv vb cv vr cv cU wcel vr cv vs cv wss wa vx
      vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg
      cfv wceq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vj cv
      cF vu cv csn crdg cfv wrex vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vj cv vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv
      wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg cfv wrex wb vj
      cv cF vu cv csn crdg vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG
      cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv csn crdg cF vb cv vr
      cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab
      wceq va vb copab wceq cF vu cv csn crdg vb cv vr cv cU wcel vr cv vs cv
      wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab vu cv
      csn crdg wceq cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv
      wrex vz va cv wrex vc cab wceq va vb copab vb cv vr cv cU wcel vr cv vs
      cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb copab
      neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab wceq vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv
      cG cfv wrex vs va cv wrex vr cab wceq va vb vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz va cv wrex vc cab vr cv cU wcel vr cv vs cv
      wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab vr cv cU wcel
      vr cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vr cab vr cv cU
      wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab vc cv
      cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vr cv cU
      wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc vr vc cv vr
      cv wceq vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vr cv cU
      wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz va cv vc cv vr cv wceq vc
      cv cU wcel vc cv vz cv wss wa vr cv cU wcel vr cv vz cv wss wa vx vz cv
      cG cfv vc cv vr cv wceq vc cv cU wcel vr cv cU wcel vc cv vz cv wss vr cv
      vz cv wss vc cv vr cv cU eleq1 vc cv vr cv vz cv sseq1 anbi12d rexbidv
      rexbidv cbvabv vr cv cU wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv
      wrex vr vr cv cU wcel vr cv vz cv wss wa vx vz cv cG cfv wrex vr cv cU
      wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vz vs va cv vz cv vs cv wceq
      vr cv cU wcel vr cv vz cv wss wa vr cv cU wcel vr cv vs cv wss wa vx vz
      cv cG cfv vs cv cG cfv vz cv vs cv cG fveq2 vz cv vs cv wceq vr cv vz cv
      wss vr cv vs cv wss vr cv cU wcel vz cv vs cv vr cv sseq2 anbi2d rexeq12d
      cbvrexv abbii eqtri eqeq2i opabbii eqtri vu cv csn cF vb cv vr cv cU wcel
      vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb
      copab rdgeq1 ax-mp fveq1i vc cv cU wcel vc cv vz cv wss wa vx vz cv cG
      cfv wrex vz vm vj cv cF vu cv csn crdg cfv vj cv vb cv vr cv cU wcel vr
      cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb
      copab vu cv csn crdg cfv vz vm vj cv cF vu cv csn crdg vz vm vu cv csn cF
      vz vm cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vz vm
      vz vm vm vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz
      va cv wrex vc cab vm cv vb cv wcel vz ax-17 vc cv cU wcel vc cv vz cv wss
      wa vx vz cv cG cfv wrex vz va cv wrex vz vc vm vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz va cv hbre1 hbab hbeq hbopab hbxfr vm cv
      vu cv csn wcel vz ax-17 hbrdg vm cv vj cv wcel vz ax-17 hbfv vm cv vj cv
      vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex
      vr cab wceq va vb copab vu cv csn crdg cfv wcel vz ax-17 rexeq1f ax-mp
      abbii vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz vc vj cv
      vb cv vr cv cU wcel vr cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex
      vr cab wceq va vb copab vu cv csn crdg cfv vj cv vb cv vr cv cU wcel vr
      cv vs cv wss wa vx vs cv cG cfv wrex vs va cv wrex vr cab wceq va vb
      copab vu cv csn crdg fvex vc cv cU wcel vc cv vz cv wss wa vx vc vz cv cG
      cfv vz cv cG fvex vc cv cU wcel vc cv vz cv wss wa vc cab vc cv vz cv wss
      vc cab vz cv cpw vc cv vz cv wss vc cab cvv vc vz cv df-pw vz cv vz
      visset pwex eqeltrri vc cv cU wcel vc cv vz cv wss wa vc cv vz cv wss vc
      vc cv cU wcel vc cv vz cv wss pm3.27 ss2abi ssexi abrexex2 abrexex2
      eqeltri funopfv mp2 imaeq2i unieqi sseq2i rexbii bitr2i sylib vj cv com
      wcel vv cv cG vj cv csuc cF vu cv csn crdg cfv cima cuni wss vv cU wrex
      vv cv cG vj cv cF vu cv csn crdg cfv cF cfv cima cuni wss vv cU wrex wb
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vd cv vj cv cF vu cv csn crdg
      cfv wcel vx cv cX wcel vw cv vd cv wss vw cU wrex wa wa vj cv com wcel vv
      cv cG vj cv csuc cF vu cv csn crdg cfv cima cuni wss vv cv cG vj cv cF vu
      cv csn crdg cfv cF cfv cima cuni wss vv cU vj cv com wcel cG vj cv csuc
      cF vu cv csn crdg cfv cima cuni cG vj cv cF vu cv csn crdg cfv cF cfv
      cima cuni vv cv vj cv com wcel cG vj cv csuc cF vu cv csn crdg cfv cima
      cG vj cv cF vu cv csn crdg cfv cF cfv cima vj cv com wcel vj cv csuc cF
      vu cv csn crdg cfv vj cv cF vu cv csn crdg cfv cF cfv cG vj cv com wcel
      vj cv con0 wcel vj cv csuc cF vu cv csn crdg cfv vj cv cF vu cv csn crdg
      cfv cF cfv wceq vj cv nnon vu cv csn vj cv cF rdgsuc syl imaeq2d unieqd
      sseq2d rexbidv ad2antll mpbird sylanc ex vv cv cG vk cv cF vu cv csn crdg
      cfv cima cuni wss vk vv com cU rexcom syl6ib vv cv cG vk cv cF vu cv csn
      crdg cfv cima cuni wss vk com wrex vv cv vk com cG vk cv cF vu cv csn
      crdg cfv cima cuni ciun wss vv cU vk com cG vk cv cF vu cv csn crdg cfv
      cima cuni vv cv ssiun r19.22si syl6 exp4c vy cv cX wcel vw cv vd cv wss
      vw cW wrex wa vx cv cX wcel vw cv vd cv wss vw cU wrex wa vy vx cv vx
      visset vy cv vx cv wceq vy cv cX wcel vx cv cX wcel vw cv vd cv wss vw cW
      wrex vw cv vd cv wss vw cU wrex vy cv vx cv cX eleq1 vy cv vx cv wceq vw
      cv vd cv wss vw cW cU cW cU wceq vx cv vy cv vx cv vy cv wceq cU cW
      neibastop1.1 eqcomd eqcoms rexeq1d anbi12d elab syl7ib syl5cbir com23
      imp3a vd cv vm cv cop cG wcel vm cv vy cv cX wcel vw cv vd cv wss vw cW
      wrex wa vy cab wceq vd cv vj cv cF vu cv csn crdg cfv wcel vd cv vm cv
      cop cG wcel vd cv vm cv cop vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab wcel vm cv vy cv cX wcel vw cv vd cv wss
      vw cW wrex wa vy cab wceq cG vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab vd cv vm cv cop neibastop2.1 eleq2i vh cv
      vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vh cv vy cv cX
      wcel vw cv vd cv wss vw cW wrex wa vy cab wceq vm cv vy cv cX wcel vw cv
      vd cv wss vw cW wrex wa vy cab wceq vf vh vd cv vm cv vd visset vm visset
      vf cv vd cv wceq vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab vy cv
      cX wcel vw cv vd cv wss vw cW wrex wa vy cab vh cv vf cv vd cv wceq vy cv
      cX wcel vw cv vf cv wss vw cW wrex wa vy cv cX wcel vw cv vd cv wss vw cW
      wrex wa vy vf cv vd cv wceq vw cv vf cv wss vw cW wrex vw cv vd cv wss vw
      cW wrex vy cv cX wcel vf cv vd cv wceq vw cv vf cv wss vw cv vd cv wss vw
      cW vf cv vd cv vw cv sseq2 rexbidv anbi2d abbidv eqeq2d vh cv vm cv vy cv
      cX wcel vw cv vd cv wss vw cW wrex wa vy cab eqeq1 opelopab bitri anbi2i
      syl5ib 19.23adv com23 imp3a 19.23adv vx cv cG vj cv cF vu cv csn crdg cfv
      cima cuni wcel vx cv vm cv wcel vm cv cG vj cv cF vu cv csn crdg cfv cima
      wcel wa vm wex vx cv vm cv wcel vd cv vj cv cF vu cv csn crdg cfv wcel vd
      cv vm cv cop cG wcel wa vd wex wa vm wex vm vx cv cG vj cv cF vu cv csn
      crdg cfv cima eluni vx cv vm cv wcel vm cv cG vj cv cF vu cv csn crdg cfv
      cima wcel wa vx cv vm cv wcel vd cv vj cv cF vu cv csn crdg cfv wcel vd
      cv vm cv cop cG wcel wa vd wex wa vm vm cv cG vj cv cF vu cv csn crdg cfv
      cima wcel vd cv vj cv cF vu cv csn crdg cfv wcel vd cv vm cv cop cG wcel
      wa vd wex vx cv vm cv wcel vd vm cv cG vj cv cF vu cv csn crdg cfv vm
      visset elima3 anbi2i exbii bitri syl5ib com23 r19.23adv vx cv vk com cG
      vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vx cv cG vk cv cF vu cv
      csn crdg cfv cima cuni wcel vk com wrex vx cv cG vj cv cF vu cv csn crdg
      cfv cima cuni wcel vj com wrex vk vx cv com cG vk cv cF vu cv csn crdg
      cfv cima cuni eliun vx cv cG vk cv cF vu cv csn crdg cfv cima cuni wcel
      vx cv cG vj cv cF vu cv csn crdg cfv cima cuni wcel vk vj com vk cv vj cv
      wceq cG vk cv cF vu cv csn crdg cfv cima cuni cG vj cv cF vu cv csn crdg
      cfv cima cuni vx cv vk cv vj cv wceq cG vk cv cF vu cv csn crdg cfv cima
      cG vj cv cF vu cv csn crdg cfv cima vk cv vj cv wceq vk cv cF vu cv csn
      crdg cfv vj cv cF vu cv csn crdg cfv cG vk cv vj cv cF vu cv csn crdg
      fveq2 imaeq2d unieqd eleq2d cbvrexv bitri syl5ib r19.21ai ad2antrr cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv
      cU wcel vu cv vn cv wss wa wa wa vx cv vk com cG vk cv cF vu cv csn crdg
      cfv cima cuni ciun wcel vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      ciun vn cv wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vx cv cG
      vk cv cF vu cv csn crdg cfv cima cuni wcel vk com wrex vx cv vk com cG vk
      cv cF vu cv csn crdg cfv cima cuni ciun wcel cX cB wcel cU c0 wne vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn
      cv wss wa wa wa vx cv cG c0 cF vu cv csn crdg cfv cima cuni wcel vx cv cG
      vk cv cF vu cv csn crdg cfv cima cuni wcel vk com wrex cX cB wcel cU c0
      wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
      vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
      cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel
      vu cv vn cv wss wa wa wa vx cv cG vu cv csn cima cuni cG c0 cF vu cv csn
      crdg cfv cima cuni cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa
      vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vx cv vu
      cv cG cfv cG vu cv csn cima cuni cX cB wcel cU c0 wne vx cv vv cv wcel vv
      cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
      wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel
      vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa
      vx cv vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab vu cv cG cfv cX
      cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa
      vu cv cU wcel vu cv vn cv wss wa wa wa vx cv cX wcel vw cv vu cv wss vw
      cU wrex wa vx cv vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab wcel
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss
      wa vu cv cU wcel vu cv vn cv wss wa wa wa vx cv cX wcel vw cv vu cv wss
      vw cU wrex vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vx cv cX wcel cX cB wcel
      cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral wa vx cX wral wa vu cv cU wcel vu cv vn cv wss wa vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel vn cv cX wss simplr ad2antrl vu cv cU wcel vu cv vn cv wss wa vw cv
      vu cv wss vw cU wrex cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vw cv vu cv wss vw cU wrex vu cv vn
      cv wss vu cv cU wcel vu cv vu cv wss vw cv vu cv wss vw cU wrex vu cv
      ssid vw cv vu cv wss vu cv vu cv wss vw vu cv cU vw cv vu cv vu cv sseq1
      rcla4ev mpan2 adantr ad2antll jca vy cv cX wcel vw cv vu cv wss vw cW
      wrex wa vx cv cX wcel vw cv vu cv wss vw cU wrex wa vy vx cv vx visset vy
      cv vx cv wceq vy cv cX wcel vx cv cX wcel vw cv vu cv wss vw cW wrex vw
      cv vu cv wss vw cU wrex vy cv vx cv cX eleq1 vy cv vx cv wceq vw cv vu cv
      wss vw cW cU cW cU wceq vx cv vy cv vx cv vy cv wceq cU cW neibastop1.1
      eqcomd eqcoms rexeq1d anbi12d elab sylibr vy cv cX wcel vw cv vu cv wss
      vw cW wrex wa vy cab cvv wcel cG wfun wa vu cv vy cv cX wcel vw cv vu cv
      wss vw cW wrex wa vy cab cop cG wcel vu cv cG cfv vy cv cX wcel vw cv vu
      cv wss vw cW wrex wa vy cab wceq cX cB wcel cU c0 wne vx cv vv cv wcel vv
      cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
      wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel
      vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa
      vu cv vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab cvv cG funopfvg
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss
      wa vu cv cU wcel vu cv vn cv wss wa wa wa vy cv cX wcel vw cv vu cv wss
      vw cW wrex wa vy cab cvv wcel cG wfun cX cB wcel vy cv cX wcel vw cv vu
      cv wss vw cW wrex wa vy cab cvv wcel cU c0 wne vx cv vv cv wcel vv cv cX
      wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
      cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa cX cB wcel vw
      cv vu cv wss vw cW wrex vy cX crab cvv vy cv cX wcel vw cv vu cv wss vw
      cW wrex wa vy cab vw cv vu cv wss vw cW wrex vy cX cB rabexg vw cv vu cv
      wss vw cW wrex vy cX df-rab syl5eqelr ad2antrr cG wfun vh cv vy cv cX
      wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab wfun vf vh vy
      cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab funopabeq cG vh cv vy cv
      cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab wceq cG
      wfun vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh
      copab wfun wb neibastop2.1 cG vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab funeq ax-mp mpbir jctir cX cB wcel vu cv
      vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab cop cG wcel cU c0 wne
      vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
      cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      wral wa vx cX wral vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss wa vu cv cU wcel vu cv
      vn cv wss wa wa cX cB wcel vu cv vy cv cX wcel vw cv vu cv wss vw cW wrex
      wa vy cab cop cG wcel vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab
      vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab wceq vy cv cX wcel vw
      cv vu cv wss vw cW wrex wa vy cab eqid cX cB wcel vy cv cX wcel vw cv vu
      cv wss vw cW wrex wa vy cab cvv wcel vu cv vy cv cX wcel vw cv vu cv wss
      vw cW wrex wa vy cab cop cG wcel vy cv cX wcel vw cv vu cv wss vw cW wrex
      wa vy cab vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab wceq wb cX
      cB wcel vw cv vu cv wss vw cW wrex vy cX crab cvv vy cv cX wcel vw cv vu
      cv wss vw cW wrex wa vy cab vw cv vu cv wss vw cW wrex vy cX cB rabexg vw
      cv vu cv wss vw cW wrex vy cX df-rab syl5eqelr vu cv cvv wcel vy cv cX
      wcel vw cv vu cv wss vw cW wrex wa vy cab cvv wcel vu cv vy cv cX wcel vw
      cv vu cv wss vw cW wrex wa vy cab cop cG wcel vy cv cX wcel vw cv vu cv
      wss vw cW wrex wa vy cab vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy
      cab wceq wb vu visset vu cv cvv wcel vy cv cX wcel vw cv vu cv wss vw cW
      wrex wa vy cab cvv wcel wa vu cv vy cv cX wcel vw cv vu cv wss vw cW wrex
      wa vy cab cop vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab
      wceq vf vh copab wcel vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab
      vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab wceq vu cv vy cv cX
      wcel vw cv vu cv wss vw cW wrex wa vy cab cop cG wcel vh cv vy cv cX wcel
      vw cv vf cv wss vw cW wrex wa vy cab wceq vh cv vy cv cX wcel vw cv vu cv
      wss vw cW wrex wa vy cab wceq vy cv cX wcel vw cv vu cv wss vw cW wrex wa
      vy cab vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab wceq vf vh vu
      cv vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy cab cvv cvv vf cv vu cv
      wceq vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab vy cv cX wcel vw
      cv vu cv wss vw cW wrex wa vy cab vh cv vf cv vu cv wceq vy cv cX wcel vw
      cv vf cv wss vw cW wrex wa vy cv cX wcel vw cv vu cv wss vw cW wrex wa vy
      vf cv vu cv wceq vw cv vf cv wss vw cW wrex vw cv vu cv wss vw cW wrex vy
      cv cX wcel vf cv vu cv wceq vw cv vf cv wss vw cv vu cv wss vw cW vf cv
      vu cv vw cv sseq2 rexbidv anbi2d abbidv eqeq2d vh cv vy cv cX wcel vw cv
      vu cv wss vw cW wrex wa vy cab vy cv cX wcel vw cv vu cv wss vw cW wrex
      wa vy cab eqeq1 opelopabg cG vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab vu cv vy cv cX wcel vw cv vu cv wss vw cW
      wrex wa vy cab cop neibastop2.1 eleq2i syl5bb mpan syl mpbiri ad2antrr
      sylc eleqtrrd cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
      vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
      vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel
      wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa wa vu cv cG cfv
      csn cuni cG vu cv csn cima cuni vu cv cG cfv cX cB wcel vu cv cG cfv csn
      cuni cG vu cv csn cima cuni wceq cU c0 wne vx cv vv cv wcel vv cv cX wss
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss wa vu cv cU wcel vu cv vn cv wss wa wa cX cB wcel cG
      cvv wfn vu cv cG cfv csn cuni cG vu cv csn cima cuni wceq cX cB wcel vy
      cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab cvv wcel vf cvv wral cG
      cvv wfn cX cB wcel vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab cvv
      wcel vf cvv cX cB wcel vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab
      cvv wcel vf cv cvv wcel cX cB wcel vw cv vf cv wss vw cW wrex vy cX crab
      cvv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab vw cv vf cv wss vw
      cW wrex vy cX cB rabexg vw cv vf cv wss vw cW wrex vy cX df-rab syl5eqelr
      a1d r19.21aiv vf vh cvv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy
      cab cG cG vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq
      vf vh copab vf cv cvv wcel vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex
      wa vy cab wceq wa vf vh copab neibastop2.1 vh cv vy cv cX wcel vw cv vf
      cv wss vw cW wrex wa vy cab wceq vf cv cvv wcel vh cv vy cv cX wcel vw cv
      vf cv wss vw cW wrex wa vy cab wceq wa vf vh vf cv cvv wcel vh cv vy cv
      cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf visset biantrur
      opabbii eqtri fnopab2g sylib cG cvv wfn vu cv cvv wcel vu cv cG cfv csn
      cuni cG vu cv csn cima cuni wceq vu visset cG cvv wfn vu cv cvv wcel wa
      vu cv cG cfv csn cG vu cv csn cima cvv vu cv cG fnsnfv unieqd mpan2 syl
      ad2antrr vu cv cG cfv vu cv cG fvex unisn syl5eqr eleqtrd cG c0 cF vu cv
      csn crdg cfv cima cG vu cv csn cima c0 cF vu cv csn crdg cfv vu cv csn cG
      vu cv csn cF vu cv snex rdg0 imaeq2i unieqi syl6eleqr c0 com wcel vx cv
      cG c0 cF vu cv csn crdg cfv cima cuni wcel vx cv cG vk cv cF vu cv csn
      crdg cfv cima cuni wcel vk com wrex peano1 vx cv cG vk cv cF vu cv csn
      crdg cfv cima cuni wcel vx cv cG c0 cF vu cv csn crdg cfv cima cuni wcel
      vk c0 com vk cv c0 wceq cG vk cv cF vu cv csn crdg cfv cima cuni cG c0 cF
      vu cv csn crdg cfv cima cuni vx cv vk cv c0 wceq cG vk cv cF vu cv csn
      crdg cfv cima cG c0 cF vu cv csn crdg cfv cima vk cv c0 wceq vk cv cF vu
      cv csn crdg cfv c0 cF vu cv csn crdg cfv cG vk cv c0 cF vu cv csn crdg
      fveq2 imaeq2d unieqd eleq2d rcla4ev mpan syl vk vx cv com cG vk cv cF vu
      cv csn crdg cfv cima cuni eliun sylibr anim1i jca31 mpdan vk com cG vk cv
      cF vu cv csn crdg cfv cima cuni ciun vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wcel vk com cG vk cv cF vu cv csn crdg cfv
      cima cuni ciun cX wss vv cv vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun wss vv cU wrex vx vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun wral wa vx cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      ciun wcel vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vn cv wss
      wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vk com cG vk
      cv cF vu cv csn crdg cfv cima cuni ciun cX wss vv cv vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun wss vv cU wrex vx vk com cG vk cv cF vu
      cv csn crdg cfv cima cuni ciun wral wa vo vk com cG vk cv cF vu cv csn
      crdg cfv cima cuni ciun vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      omex cG vk cv cF vu cv csn crdg cfv cima cG wfun cG vk cv cF vu cv csn
      crdg cfv cima cvv wcel cG wfun vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab wfun vf vh vy cv cX wcel vw cv vf cv wss
      vw cW wrex wa vy cab funopabeq cG vh cv vy cv cX wcel vw cv vf cv wss vw
      cW wrex wa vy cab wceq vf vh copab wceq cG wfun vh cv vy cv cX wcel vw cv
      vf cv wss vw cW wrex wa vy cab wceq vf vh copab wfun wb neibastop2.1 cG
      vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh copab
      funeq ax-mp mpbir cG vk cv cF vu cv csn crdg cfv vk cv cF vu cv csn crdg
      fvex funimaex ax-mp uniex iunex vo cv vk com cG vk cv cF vu cv csn crdg
      cfv cima cuni ciun wceq vo cv cX wss vk com cG vk cv cF vu cv csn crdg
      cfv cima cuni ciun cX wss vv cv vo cv wss vv cU wrex vx vo cv wral vv cv
      vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU wrex vx vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wral vo cv vk com cG vk
      cv cF vu cv csn crdg cfv cima cuni ciun cX sseq1 vo cv vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun wceq vv cv vo cv wss vv cU wrex vx vo
      cv wral vv cv vo cv wss vv cU wrex vx vk com cG vk cv cF vu cv csn crdg
      cfv cima cuni ciun wral vv cv vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun wss vv cU wrex vx vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun wral vv cv vo cv wss vv cU wrex vx vm vo cv vk com cG vk cv cF
      vu cv csn crdg cfv cima cuni ciun vm cv vo cv wcel vx ax-17 vm cv cG vk
      cv cF vu cv csn crdg cfv cima cuni wcel vk com wrex vm cv cG vk cv cF vu
      cv csn crdg cfv cima cuni wcel vk com wrex vx wal vm cv vk com cG vk cv
      cF vu cv csn crdg cfv cima cuni ciun wcel vm cv vk com cG vk cv cF vu cv
      csn crdg cfv cima cuni ciun wcel vx wal vm cv cG vk cv cF vu cv csn crdg
      cfv cima cuni wcel vx vk com vk cv com wcel vx ax-17 vx vm cG vk cv cF vu
      cv csn crdg cfv cima vx vm cG vk cv cF vu cv csn crdg cfv vm cv cG wcel
      vx ax-17 vx vm vk cv cF vu cv csn crdg vx vm vu cv csn cF vx vm cF vb cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc cv vz cv wss wa
      vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vx vm vx vm vm vb cv
      vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc
      cab vm cv vb cv wcel vx ax-17 vc cv cU wcel vc cv vz cv wss wa vx vz cv
      cG cfv wrex vz va cv wrex vx vc vm vc cv cU wcel vc cv vz cv wss wa vx vz
      cv cG cfv wrex vx vz va cv vz cv va cv wcel vx ax-17 vc cv cU wcel vc cv
      vz cv wss wa vx vz cv cG cfv hbre1 hbrex hbab hbeq hbopab hbxfr vm cv vu
      cv csn wcel vx ax-17 hbrdg vm cv vk cv wcel vx ax-17 hbfv hbima hbuni
      hbrex vk vm cv com cG vk cv cF vu cv csn crdg cfv cima cuni eliun vm cv
      vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vm cv cG vk cv
      cF vu cv csn crdg cfv cima cuni wcel vk com wrex vx vk vm cv com cG vk cv
      cF vu cv csn crdg cfv cima cuni eliun albii 3imtr4i raleq1f vo cv vk com
      cG vk cv cF vu cv csn crdg cfv cima cuni ciun wceq vv cv vo cv wss vv cU
      wrex vv cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wss vv cU
      wrex vx vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vx vm vm vo
      cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vm cv vo cv wcel
      vx ax-17 vm cv cG vk cv cF vu cv csn crdg cfv cima cuni wcel vk com wrex
      vm cv cG vk cv cF vu cv csn crdg cfv cima cuni wcel vk com wrex vx wal vm
      cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vm cv vk com
      cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vx wal vm cv cG vk cv
      cF vu cv csn crdg cfv cima cuni wcel vx vk com vk cv com wcel vx ax-17 vx
      vm cG vk cv cF vu cv csn crdg cfv cima vx vm cG vk cv cF vu cv csn crdg
      cfv vm cv cG wcel vx ax-17 vx vm vk cv cF vu cv csn crdg vx vm vu cv csn
      cF vx vm cF vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab wceq va vb copab neibastop2.2 vb cv vc cv cU wcel vc
      cv vz cv wss wa vx vz cv cG cfv wrex vz va cv wrex vc cab wceq va vb vx
      vm vx vm vm vb cv vc cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv wrex
      vz va cv wrex vc cab vm cv vb cv wcel vx ax-17 vc cv cU wcel vc cv vz cv
      wss wa vx vz cv cG cfv wrex vz va cv wrex vx vc vm vc cv cU wcel vc cv vz
      cv wss wa vx vz cv cG cfv wrex vx vz va cv vz cv va cv wcel vx ax-17 vc
      cv cU wcel vc cv vz cv wss wa vx vz cv cG cfv hbre1 hbrex hbab hbeq
      hbopab hbxfr vm cv vu cv csn wcel vx ax-17 hbrdg vm cv vk cv wcel vx
      ax-17 hbfv hbima hbuni hbrex vk vm cv com cG vk cv cF vu cv csn crdg cfv
      cima cuni eliun vm cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      ciun wcel vm cv cG vk cv cF vu cv csn crdg cfv cima cuni wcel vk com wrex
      vx vk vm cv com cG vk cv cF vu cv csn crdg cfv cima cuni eliun albii
      3imtr4i hbeq vo cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun
      wceq vv cv vo cv wss vv cv vk com cG vk cv cF vu cv csn crdg cfv cima
      cuni ciun wss vv cU vo cv vk com cG vk cv cF vu cv csn crdg cfv cima cuni
      ciun vv cv sseq2 rexbidv ralbid bitrd anbi12d elab anbi1i sylibr vx cv vg
      cv wcel vg cv vn cv wss wa vx cv vk com cG vk cv cF vu cv csn crdg cfv
      cima cuni ciun wcel vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun
      vn cv wss wa vg vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab vg cv vk com
      cG vk cv cF vu cv csn crdg cfv cima cuni ciun wceq vx cv vg cv wcel vx cv
      vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun wcel vg cv vn cv wss
      vk com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vn cv wss vg cv vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vx cv eleq2 vg cv vk
      com cG vk cv cF vu cv csn crdg cfv cima cuni ciun vn cv sseq1 anbi12d
      rcla4ev syl expr exp3a r19.23adv expr imp3a impr $.
      $( [19-Sep-2009] $) $( [12-Sep-2009] $)
    $}

    $( In the topology generated by a neighborhood base, a set is a
       neighborhood of a point iff it contains a subset in the base. $)
    neibastop2 $p |- ( ( X e. B /\ A. x e. X ( U =/= (/) /\ A. v e. U ( ( x e.
    v /\ v C_ X ) /\ ( A. w e. U E. t e. U t C_ ( v i^i w ) /\ E. t e. U A. y
    e. t E. w e. W w C_ v ) ) ) ) -> ( x e. X -> ( n e. ( ( nei ` { o | ( o C_
    X /\ A. x e. o E. v e. U v C_ o ) } ) ` { x } ) <-> ( n C_ X /\ E. u e. U u
    C_ n ) ) ) )
    $=
      cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel vn cv vx cv csn
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv
      cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb wi vx vy vw vv vt
      cB cU vo cW cX neibastop1.1 neibastop1 cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel vn cv vx cv csn vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv
      vn cv wss vu cU wrex wa wb cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
      wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
      cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv
      cX wcel wa wa vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
      wrex wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      ctop wcel vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
      wrex wa wi cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vx cv cX wcel vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vn cv
      vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex vo cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vn cv vx cv csn
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv
      cfv wcel vn cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab cuni wss vn cv cX wss vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab ctop wcel vn cv vx cv csn vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni wss vx cv csn
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab vn cv vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni eqid neii1
      ex vn cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      cuni wss vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      cuni cX wss vn cv cX wss va cv cX wss vv cv va cv wss vv cU wrex vx va cv
      wral wa va cv cX wss wi vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab cuni cX wss va vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab cuni cX wss va cv cX wss va vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wral va cv vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab wcel va cv cX wss wi va wal va
      cv cX wss vv cv va cv wss vv cU wrex vx va cv wral wa va cv cX wss wi va
      wal va vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cX
      unissb va cv cX wss va vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab df-ral va cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab wcel va cv cX wss wi va cv cX wss vv cv va cv wss vv cU
      wrex vx va cv wral wa va cv cX wss wi va va cv vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab wcel va cv cX wss vv cv va cv wss
      vv cU wrex vx va cv wral wa va cv cX wss vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa va cv cX wss vv cv va cv wss vv cU wrex vx va cv
      wral wa vo va cv va visset vo cv va cv wceq vo cv cX wss va cv cX wss vv
      cv vo cv wss vv cU wrex vx vo cv wral vv cv va cv wss vv cU wrex vx va cv
      wral vo cv va cv cX sseq1 vv cv vo cv wss vv cU wrex vv cv va cv wss vv
      cU wrex vx vo cv va cv vo cv va cv wceq vv cv vo cv wss vv cv va cv wss
      vv cU vo cv va cv vv cv sseq2 rexbidv raleqd anbi12d elab imbi1i albii
      3bitrri va cv cX wss vv cv va cv wss vv cU wrex vx va cv wral pm3.26
      mpgbi vn cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab cuni cX sstr2 mpi syl6 vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab ctop wcel vn cv vx cv csn vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vx cv csn vm cv wss
      vm cv vn cv wss wa vm vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab wrex vu cv vn cv wss vu cU wrex vo cv cX wss vv cv vo cv
      wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vn cv vx cv csn vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel
      vx cv csn vm cv wss vm cv vn cv wss wa vm vo cv cX wss vv cv vo cv wss vv
      cU wrex vx vo cv wral wa vo cab wrex vx cv csn vm vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab vn cv neii2 ex vx cv csn vm cv
      wss vm cv vn cv wss wa vu cv vn cv wss vu cU wrex vm vo cv cX wss vv cv
      vo cv wss vv cU wrex vx vo cv wral wa vo cab vm cv vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab wcel vm cv cX wss vv cv vm cv
      wss vv cU wrex vx vm cv wral wa vx cv csn vm cv wss vm cv vn cv wss wa vu
      cv vn cv wss vu cU wrex wi vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vm cv cX wss vv cv vm cv wss vv cU wrex vx vm cv wral wa vo vm
      cv vm visset vo cv vm cv wceq vo cv cX wss vm cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral vv cv vm cv wss vv cU wrex vx vm cv wral vo cv
      vm cv cX sseq1 vv cv vo cv wss vv cU wrex vv cv vm cv wss vv cU wrex vx
      vo cv vm cv vo cv vm cv wceq vv cv vo cv wss vv cv vm cv wss vv cU vo cv
      vm cv vv cv sseq2 rexbidv raleqd anbi12d elab vv cv vm cv wss vv cU wrex
      vx vm cv wral vx cv csn vm cv wss vm cv vn cv wss wa vu cv vn cv wss vu
      cU wrex wi vm cv cX wss vv cv vm cv wss vv cU wrex vx vm cv wral vx cv
      csn vm cv wss vm cv vn cv wss vu cv vn cv wss vu cU wrex vv cv vm cv wss
      vv cU wrex vx vm cv wral vx cv vm cv wcel vm cv vn cv wss vu cv vn cv wss
      vu cU wrex wi vx cv csn vm cv wss vv cv vm cv wss vv cU wrex vx vm cv
      wral vx cv vm cv wcel vv cv vm cv wss vv cU wrex vm cv vn cv wss vu cv vn
      cv wss vu cU wrex wi vv cv vm cv wss vv cU wrex vx vm cv ra4 vv cv vm cv
      wss vm cv vn cv wss vu cv vn cv wss vu cU wrex wi vv cU vv cv vm cv wss
      vm cv vn cv wss vv cv vn cv wss vv cv cU wcel vu cv vn cv wss vu cU wrex
      vv cv vm cv vn cv sstr2 vv cv cU wcel vv cv vn cv wss vu cv vn cv wss vu
      cU wrex vu cv vn cv wss vv cv vn cv wss vu vv cv cU vu cv vv cv vn cv
      sseq1 rcla4ev ex syl9r r19.23aiv syl6 vx cv vm cv vx visset snss syl5ibr
      imp3a adantl sylbi r19.23aiv syl6 jcad ad2antrl cX cB wcel cU c0 wne vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex
      wa vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      wa vo cab cnei cfv cfv wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx
      cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex wa wa wa vn cv vx
      cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      cnei cfv cfv wcel vn cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab cuni wss vx cv vg cv wcel vg cv vn cv wss wa vg vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wrex wa cX cB wcel
      cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv
      wss vu cU wrex wa wa wa vn cv vo cv cX wss vv cv vo cv wss vv cU wrex vx
      vo cv wral wa vo cab cuni wss vx cv vg cv wcel vg cv vn cv wss wa vg vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wrex cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn
      cv wss vu cU wrex wa wa wa vn cv cX vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab cuni cX cB wcel cU c0 wne vx cv vv cv wcel
      vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv
      cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral
      wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop
      wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex simprrl cX
      cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu
      cv vn cv wss vu cU wrex wa wa wa cX vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wcel cX vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab cuni wss cX cB wcel cU c0 wne vx cv vv cv
      wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
      cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex wa
      wa wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
      wcel cX cX wss vv cv cX wss vv cU wrex vx cX wral wa cX cB wcel cU c0 wne
      vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
      cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu
      cU wrex wa wa wa vv cv cX wss vv cU wrex vx cX wral cX cX wss cU c0 wne
      vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
      cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      wral wa vx cX wral vv cv cX wss vv cU wrex vx cX wral cX cB wcel vo cv cX
      wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex wa wa cU c0 wne vx cv vv
      cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
      vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa
      vv cv cX wss vv cU wrex vx cX vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa wa vv cU wral cU c0 wne vv cv cX wss vv cU wrex vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      vv cv cU wcel vv wex vv cv cU wcel vv cv cX wss wa vv wex cU c0 wne vv cv
      cX wss vv cU wrex vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
      wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
      wrex wa wa vv cU wral vv cv cU wcel vv cv cU wcel vv cv cX wss wa vv vx
      cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      hbra1 vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa
      vv cU wral vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa wi vv cv cU wcel vv cv cU wcel vv cv cX wss wa wi vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU ra4
      vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa wi vv cv cU wcel vv cv cX wss vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cv cX wss vv cv cU wcel vx cv vv cv
      wcel vv cv cX wss vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv
      vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa simplr imim2i ancld syl
      19.22d vv cU n0 vv cv cX wss vv cU df-rex 3imtr4g impcom r19.20si
      ad2antlr cX ssid jctil cX cB wcel cX vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wcel cX cX wss vv cv cX wss vv cU wrex vx cX
      wral wa wb cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu
      cv vn cv wss vu cU wrex wa wa vv cv vo cv wss vv cU wrex vx vo cv wral vv
      cv cX wss vv cU wrex vx cX wral vo cX cX cB vv cv vo cv wss vv cU wrex vv
      cv cX wss vv cU wrex vx vo cv cX vo cv cX wceq vv cv vo cv wss vv cv cX
      wss vv cU vo cv cX vv cv sseq2 rexbidv raleqd elssabg ad2antrr mpbird cX
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab elssuni
      syl sstrd vx vy vz vw vv vu vt cB cU vf vg vh vn vo vb cv vc cv cU wcel
      vc cv vz cv wss wa vx vz cv vh cv vy cv cX wcel vw cv vf cv wss vw cW
      wrex wa vy cab wceq vf vh copab cfv wrex vz va cv wrex vc cab wceq va vb
      copab vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab wceq vf vh
      copab cW cX va vb vc neibastop1.1 vh cv vy cv cX wcel vw cv vf cv wss vw
      cW wrex wa vy cab wceq vf vh copab eqid vb cv vc cv cU wcel vc cv vz cv
      wss wa vx vz cv vh cv vy cv cX wcel vw cv vf cv wss vw cW wrex wa vy cab
      wceq vf vh copab cfv wrex vz va cv wrex vc cab wceq va vb copab eqid
      neibastop2lem4 jca vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
      wa vo cab ctop wcel vx cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab cuni wcel vn cv vx cv csn vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni wss vx cv vg cv
      wcel vg cv vn cv wss wa vg vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab wrex wa wb cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
      cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
      vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx
      cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex wa wa wa vx cv vg
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab vn cv vo
      cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni vo cv
      cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni eqid
      isneip cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
      vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
      wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo
      cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel vn cv
      cX wss vu cv vn cv wss vu cU wrex wa simprll cX cB wcel cU c0 wne vx cv
      vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
      wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral
      wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
      vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex
      wa wa wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
      cab cuni vx cv cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX
      wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex wa wa wa cX vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel cX vo cv cX wss
      vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni wss cX cB wcel cU
      c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa
      vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
      cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn cv wss
      vu cU wrex wa wa wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
      wral wa vo cab wcel cX cX wss vv cv cX wss vv cU wrex vx cX wral wa cX cB
      wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss vv cU wrex
      vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu cv vn
      cv wss vu cU wrex wa wa wa vv cv cX wss vv cU wrex vx cX wral cX cX wss
      cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU wral wa vx cX wral vv cv cX wss vv cU wrex vx cX wral cX cB wcel
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel
      vx cv cX wcel wa vn cv cX wss vu cv vn cv wss vu cU wrex wa wa cU c0 wne
      vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
      cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
      wral wa vv cv cX wss vv cU wrex vx cX vx cv vv cv wcel vv cv cX wss wa vt
      cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
      vy vt cv wral vt cU wrex wa wa vv cU wral cU c0 wne vv cv cX wss vv cU
      wrex vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
      wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa
      vv cU wral vv cv cU wcel vv wex vv cv cU wcel vv cv cX wss wa vv wex cU
      c0 wne vv cv cX wss vv cU wrex vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa wa vv cU wral vv cv cU wcel vv cv cU wcel vv cv cX
      wss wa vv vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
      cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
      wa vv cU hbra1 vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
      vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
      wa wa vv cU wral vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv
      cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
      cv wral vt cU wrex wa wa wi vv cv cU wcel vv cv cU wcel vv cv cX wss wa
      wi vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
      vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
      cU ra4 vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa wi vv cv cU wcel vv cv cX wss vx cv vv cv wcel vv cv cX wss
      wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
      wrex vy vt cv wral vt cU wrex wa wa vv cv cX wss vv cv cU wcel vx cv vv
      cv wcel vv cv cX wss vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
      cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa simplr imim2i ancld
      syl 19.22d vv cU n0 vv cv cX wss vv cU df-rex 3imtr4g impcom r19.20si
      ad2antlr cX ssid jctil cX cB wcel cX vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab wcel cX cX wss vv cv cX wss vv cU wrex vx cX
      wral wa wb cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
      cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
      cU wrex wa wa vv cU wral wa vx cX wral vo cv cX wss vv cv vo cv wss vv cU
      wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel wa vn cv cX wss vu
      cv vn cv wss vu cU wrex wa wa vv cv vo cv wss vv cU wrex vx vo cv wral vv
      cv cX wss vv cU wrex vx cX wral vo cX cX cB vv cv vo cv wss vv cU wrex vv
      cv cX wss vv cU wrex vx vo cv cX vo cv cX wceq vv cv vo cv wss vv cv cX
      wss vv cU vo cv cX vv cv sseq2 rexbidv raleqd elssabg ad2antrr mpbird cX
      vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab elssuni
      syl cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
      cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
      vt cU wrex wa wa vv cU wral wa vx cX wral wa vo cv cX wss vv cv vo cv wss
      vv cU wrex vx vo cv wral wa vo cab ctop wcel vx cv cX wcel vn cv cX wss
      vu cv vn cv wss vu cU wrex wa simprlr sseldd sylanc mpbird expr impbid
      exp32 mpd $.
      $( [19-Sep-2009] $) $( [9-Sep-2009] $)

      $( The topology generated by a neighborhood base is unique. $)
      neibastop3 $p |- ( ( X e. B /\ A. x e. X ( U =/= (/)
          /\ A. v e. U ( ( x e. v /\ v C_ X ) /\ ( A. w e. U E. t e. U t
            C_ ( v i^i w ) /\ E. t e. U A. y e. t E. w e. W w C_ v ) ) ) )
     -> E! j e. Top ( X = U. j /\ A. x e. X A. n ( n e. ( ( nei ` j ) ` { x } )
        <-> ( n C_ X /\ E. u e. U u C_ n ) ) ) ) $=
        cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
        cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
        vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv
        cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral wa wa vj weu cX vj cv cuni
        wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv
        wss vu cU wrex wa wb vn wal vx cX wral wa vj ctop wreu vo cv cX wss vv
        cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel vo cv cX wss
        vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop wcel cX vo cv
        cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni wceq vn
        cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
        vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb
        vn wal vx cX wral wa wa vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv
        csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa
        wb vn wal vx cX wral wa wa vj cv vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab wceq wi vj wal vj cv ctop wcel cX vj cv
        cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral wa wa vj weu cX cB wcel cU c0
        wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv cuni wceq vn cv
        vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
        wrex wa wb vn wal vx cX wral wa wa vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab ctop wcel cX vo cv cX wss vv cv vo cv wss
        vv cU wrex vx vo cv wral wa vo cab cuni wceq vn cv vx cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv
        wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa
        wa vj vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
        ctop vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab wceq vj cv ctop wcel vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv
        cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal
        vx cX wral wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cuni wceq vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv
        wss vu cU wrex wa wb vn wal vx cX wral wa vj cv vo cv cX wss vv cv vo
        cv wss vv cU wrex vx vo cv wral wa vo cab ctop eleq1 vj cv vo cv cX wss
        vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wceq cX vj cv cuni
        wceq cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
        cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral vn cv vx cv csn vo cv cX wss
        vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn
        cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral vj cv vo
        cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wceq vj cv
        cuni vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
        cuni cX vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
        vo cab unieq eqeq2d vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX
        wss vu cv vn cv wss vu cU wrex wa wb vn wal vn cv vx cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv
        wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX vx vm
        vm vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab vm cv vj cv wcel vx ax-17 vo cv cX wss vv cv vo cv wss vv cU wrex
        vx vo cv wral wa vx vo vm vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral vx vo cv cX wss vx ax-17 vv cv vo cv wss vv cU wrex vx vo cv
        hbra1 hban hbab hbeq vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx
        vo cv wral wa vo cab wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv
        cX wss vu cv vn cv wss vu cU wrex wa wb vn cv vx cv csn vo cv cX wss vv
        cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv
        cX wss vu cv vn cv wss vu cU wrex wa wb vn vj cv vo cv cX wss vv cv vo
        cv wss vv cU wrex vx vo cv wral wa vo cab wceq vn cv vx cv csn vj cv
        cnei cfv cfv wcel vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv
        wss vu cU wrex wa vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab wceq vx cv csn vj cv cnei cfv cfv vx cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv vn
        cv vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab wceq vx cv csn vj cv cnei cfv vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cnei cfv vj cv vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab cnei fveq2 fveq1d eleq2d bibi1d
        albidv ralbid anbi12d anbi12d eqeu vx vy vw vv vt cB cU vo cW cX
        neibastop1.1 neibastop1 cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
        wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
        vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
        vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop
        wcel cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
        cuni wceq vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
        wrex wa wb vn wal vx cX wral vx vy vw vv vt cB cU vo cW cX neibastop1.1
        neibastop1 cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa cX vo cv cX wss
        vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni cX cB wcel cU
        c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral wa vx cX wral wa cX vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab wcel cX vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cuni wss cX cB wcel cU c0 wne vx cv vv cv
        wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
        cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
        cX wral wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
        vo cab wcel cX cX wss vv cv cX wss vv cU wrex vx cX wral wa cX cB wcel
        cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
        cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
        wa wa vv cU wral wa vx cX wral wa vv cv cX wss vv cU wrex vx cX wral cX
        cX wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv
        cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
        cv wral vt cU wrex wa wa vv cU wral wa vx cX wral vv cv cX wss vv cU
        wrex vx cX wral cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa
        vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
        wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vv cv cX wss vv cU
        wrex vx cX cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex cX cB
        wcel vv cv cU wcel vv wex vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
        vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex wi cU c0 wne
        cX cB wcel vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
        vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex wi vv cX cB
        wcel vv ax-17 vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex vv vx cv vv cv wcel vv
        cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv
        cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU hbra1 vv cv cX
        wss vv cU hbre1 hbim cX cB wcel vv cv cU wcel vx cv vv cv wcel vv cv cX
        wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
        vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral vv cv cX wss vv cU
        wrex wi cX cB wcel vv cv cU wcel wa vx cv vv cv wcel vv cv cX wss wa vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa wa vv cU wral vx cv vv cv wcel vv cv cX wss
        wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
        cW wrex vy vt cv wral vt cU wrex wa wa vv cv cX wss vv cU wrex vv cv cU
        wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv
        cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
        cv wral vt cU wrex wa wa vv cU wral vv cv cU wcel vx cv vv cv wcel vv
        cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv
        cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vx cv vv cv wcel vv cv
        cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
        wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU ra4 com12 adantl cX
        cB wcel vv cv cU wcel wa vx cv vv cv wcel vv cv cX wss wa vv cv cX wss
        vv cU wrex vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
        wss vw cW wrex vy vt cv wral vt cU wrex wa cX cB wcel vv cv cU wcel wa
        vv cv cX wss vv cv cX wss vv cU wrex vx cv vv cv wcel vv cv cU wcel vv
        cv cX wss vv cv cX wss vv cU wrex wi cX cB wcel vv cv cU wcel vv cv cX
        wss vv cv cX wss vv cU wrex vv cv cX wss vv cU ra4e ex adantl adantld
        adantrd syld ex 19.23ad vv cU n0 syl5ib imp3a r19.20sdv imp cX ssid
        jctil cX cB wcel cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
        wral wa vo cab wcel cX cX wss vv cv cX wss vv cU wrex vx cX wral wa wb
        cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt
        cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex
        wa wa vv cU wral wa vx cX wral vo cv cX wss vv cv vo cv wss vv cU wrex
        vx vo cv wral wa cX cX wss vv cv cX wss vv cU wrex vx cX wral wa vo cX
        cB vo cv cX wceq vo cv cX wss cX cX wss vv cv vo cv wss vv cU wrex vx
        vo cv wral vv cv cX wss vv cU wrex vx cX wral vo cv cX cX sseq1 vv cv
        vo cv wss vv cU wrex vv cv cX wss vv cU wrex vx vo cv cX vo cv cX wceq
        vv cv vo cv wss vv cv cX wss vv cU vo cv cX vv cv sseq2 rexbidv raleqd
        anbi12d elabg adantr mpbird cX vo cv cX wss vv cv vo cv wss vv cU wrex
        vx vo cv wral wa vo cab elssuni syl vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cuni cX wss cX cB wcel cU c0 wne vx cv vv
        cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
        vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa
        vx cX wral wa va cv cX wss vv cv va cv wss vv cU wrex vx va cv wral wa
        va cv cX wss wi vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cuni cX wss va vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab cuni cX wss va cv cX wss va vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab wral va cv vo cv cX wss vv cv vo
        cv wss vv cU wrex vx vo cv wral wa vo cab wcel va cv cX wss wi va wal
        va cv cX wss vv cv va cv wss vv cU wrex vx va cv wral wa va cv cX wss
        wi va wal va vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
        vo cab cX unissb va cv cX wss va vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab df-ral va cv vo cv cX wss vv cv vo cv wss
        vv cU wrex vx vo cv wral wa vo cab wcel va cv cX wss wi va cv cX wss vv
        cv va cv wss vv cU wrex vx va cv wral wa va cv cX wss wi va va cv vo cv
        cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel va cv cX
        wss vv cv va cv wss vv cU wrex vx va cv wral wa va cv cX wss vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa va cv cX wss vv cv va
        cv wss vv cU wrex vx va cv wral wa vo va cv va visset vo cv va cv wceq
        vo cv cX wss va cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral vv
        cv va cv wss vv cU wrex vx va cv wral vo cv va cv cX sseq1 vv cv vo cv
        wss vv cU wrex vv cv va cv wss vv cU wrex vx vo cv va cv vo cv va cv
        wceq vv cv vo cv wss vv cv va cv wss vv cU vo cv va cv vv cv sseq2
        rexbidv raleqd anbi12d elab imbi1i albii 3bitrri va cv cX wss vv cv va
        cv wss vv cU wrex vx va cv wral pm3.26 mpgbi a1i eqssd cX cB wcel cU c0
        wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral wa vx cX wral wa vn cv vx cv csn vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vn cv cX wss
        vu cv vn cv wss vu cU wrex wa wb vn wal vx cX cX cB wcel cU c0 wne vx
        cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
        cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
        wral wa vx cX wral vx cX cB wcel vx ax-17 cU c0 wne vx cv vv cv wcel vv
        cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv
        cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX
        hbra1 hban cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vx cv cX wcel
        vn cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa
        wb vn vx vy vw vv vu vt cB cU vn vo cW cX neibastop1.1 neibastop2
        19.21adv r19.21ai jca32 cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
        wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
        vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
        vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv
        wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa
        wa vj cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab wceq wi vj cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop
        wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv
        cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa wa vj cv
        vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wceq cX
        cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
        cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
        vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv
        cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral wa wa wa vm vj cv vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cX cB wcel cU c0
        wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv cuni wceq vn cv
        vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
        wrex wa wb vn wal vx cX wral wa wa wa vm cv vx cv csn vj cv cnei cfv
        cfv wcel vx vm cv wral vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv
        cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vx vm cv wral vm cv
        vj cv wcel vm cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop
        wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv
        cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa wa wa vm
        cv vx cv csn vj cv cnei cfv cfv wcel vm cv vx cv csn vo cv cX wss vv cv
        vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vx vm cv
        cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
        cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
        vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv
        cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral wa wa vx cX cB wcel cU c0 wne
        vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
        vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
        cU wral wa vx cX wral vx cX cB wcel vx ax-17 cU c0 wne vx cv vv cv wcel
        vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv
        vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX
        hbra1 hban vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv
        cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal
        vx cX wral wa vx vj cv ctop wcel vx ax-17 cX vj cv cuni wceq vn cv vx
        cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex
        wa wb vn wal vx cX wral vx cX vj cv cuni wceq vx ax-17 vn cv vx cv csn
        vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb
        vn wal vx cX hbra1 hban hban hban cX cB wcel cU c0 wne vx cv vv cv wcel
        vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv
        vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX
        wral wa vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei
        cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX
        wral wa wa wa vx cv vm cv wcel wa vm cv vx cv csn vj cv cnei cfv cfv
        wcel vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
        wral wa vo cab cnei cfv cfv wcel cX cB wcel cU c0 wne vx cv vv cv wcel
        vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv
        vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX
        wral wa vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei
        cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX
        wral wa wa wa vx cv vm cv wcel wa vx cv cX wcel wa cX cB wcel cU c0 wne
        vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex
        vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv
        cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv
        csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa
        wb vn wal vx cX wral wa wa wa vx cv vm cv wcel wa vm cv vx cv csn vj cv
        cnei cfv cfv wcel wa cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss
        wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
        cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vj
        cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel
        vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa wa
        wa vx cv vm cv wcel wa vx cv cX wcel cX cB wcel cU c0 wne vx cv vv cv
        wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
        cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
        cX wral wa vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv
        cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal
        vx cX wral wa wa wa vx cv vm cv wcel wa vm cv vx cv csn vj cv cnei cfv
        cfv wcel pm3.26 vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj
        cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn
        wal vx cX wral wa wa vx cv vm cv wcel vm cv vx cv csn vj cv cnei cfv
        cfv wcel vx cv cX wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
        wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
        vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
        vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv
        wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa
        wa vx cv vm cv wcel vm cv vx cv csn vj cv cnei cfv cfv wcel vx cv cX
        wcel vj cv ctop wcel cX vj cv cuni wceq vx cv vm cv wcel vm cv vx cv
        csn vj cv cnei cfv cfv wcel vx cv cX wcel wi wi vn cv vx cv csn vj cv
        cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal
        vx cX wral vj cv ctop wcel cX vj cv cuni wceq wa vx cv vm cv wcel vm cv
        vx cv csn vj cv cnei cfv cfv wcel vx cv cX wcel vj cv ctop wcel cX vj
        cv cuni wceq wa vx cv vm cv wcel vm cv vx cv csn vj cv cnei cfv cfv
        wcel wa wa vx cv vj cv cuni cX vj cv ctop wcel cX vj cv cuni wceq wa vx
        cv vm cv wcel vm cv vx cv csn vj cv cnei cfv cfv wcel wa wa vm cv vj cv
        cuni vx cv vj cv ctop wcel vm cv vx cv csn vj cv cnei cfv cfv wcel vm
        cv vj cv cuni wss cX vj cv cuni wceq vx cv vm cv wcel vx cv csn vj cv
        vm cv vj cv cuni vj cv cuni eqid neii1 ad2ant2rl vj cv ctop wcel cX vj
        cv cuni wceq wa vx cv vm cv wcel vm cv vx cv csn vj cv cnei cfv cfv
        wcel simprl sseldd vj cv ctop wcel cX vj cv cuni wceq vx cv vm cv wcel
        vm cv vx cv csn vj cv cnei cfv cfv wcel wa simplr eleqtrrd exp32
        adantrr imp31 adantlll jca cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
        cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
        wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral
        wa vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv
        cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX
        wral wa wa wa vx cv vm cv wcel wa vm cv vx cv csn vo cv cX wss vv cv vo
        cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel wa cX cB
        wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj cv cuni
        wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv
        wss vu cU wrex wa wb vn wal vx cX wral wa wa wa vx cv vm cv wcel wa vx
        cv cX wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel
        cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss
        vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa wa wa vx cv vm cv
        wcel wa vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab cnei cfv cfv wcel pm3.26 cX cB wcel cU c0 wne vx cv
        vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
        wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
        wral wa vx cX wral wa vx cv vm cv wcel vm cv vx cv csn vo cv cX wss vv
        cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vx cv
        cX wcel vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn vj cv cnei
        cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX
        wral wa wa cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vx cv vm cv
        wcel wa vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab cnei cfv cfv wcel wa vx cv vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab cuni cX cX cB wcel cU c0 wne vx
        cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw
        cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
        wral wa vx cX wral wa vx cv vm cv wcel wa vm cv vx cv csn vo cv cX wss
        vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel wa
        vm cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
        cuni vx cv cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vm cv vx cv csn
        vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei
        cfv cfv wcel vm cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
        wral wa vo cab cuni wss vx cv vm cv wcel vo cv cX wss vv cv vo cv wss
        vv cU wrex vx vo cv wral wa vo cab ctop wcel vm cv vx cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv
        wcel vm cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab cuni wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vx cv csn vo
        cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab vm cv vo
        cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni vo cv
        cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni eqid
        neii1 vx vy vw vv vt cB cU vo cW cX neibastop1.1 neibastop1 sylan
        adantlr cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv
        cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt
        cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vx cv vm cv wcel
        vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cnei cfv cfv wcel simplr sseldd cX cB wcel cU c0 wne vx cv vv
        cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral
        vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa
        vx cX wral wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cuni wceq vx cv vm cv wcel vm cv vx cv csn vo cv cX wss vv cv
        vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel cX cB
        wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa vv cU wral wa vx cX wral wa cX vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab cuni cX cB wcel cU c0 wne vx cv
        vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
        wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
        wral wa vx cX wral wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab wcel cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab cuni wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
        cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
        wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral
        wa cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab
        wcel cX cX wss vv cv cX wss vv cU wrex vx cX wral wa cX cB wcel cU c0
        wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral wa vx cX wral wa vv cv cX wss vv cU wrex vx cX wral cX cX
        wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
        vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral wa vx cX wral vv cv cX wss vv cU wrex
        vx cX wral cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vv cv cX wss vv cU wrex vx cX
        cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv
        cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral
        vt cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex cX cB wcel vv cv cU
        wcel vv wex vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss
        vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU
        wrex wa wa vv cU wral vv cv cX wss vv cU wrex wi cU c0 wne cX cB wcel
        vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex wi vv cX cB wcel vv
        ax-17 vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa vv cU wral vv cv cX wss vv cU wrex vv vx cv vv cv wcel vv cv cX wss
        wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw
        cW wrex vy vt cv wral vt cU wrex wa wa vv cU hbra1 vv cv cX wss vv cU
        hbre1 hbim cX cB wcel vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa wa vv cU wral vv cv cX wss vv cU wrex wi cX
        cB wcel vv cv cU wcel wa vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
        vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cv cX wss vv cU wrex vv cv cU wcel vx cv
        vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU
        wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU
        wral vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU
        wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa
        wa wi cX cB wcel vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa vv cU wral vv cv cU wcel vx cv vv cv wcel vv cv cX wss wa
        vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW
        wrex vy vt cv wral vt cU wrex wa wa vx cv vv cv wcel vv cv cX wss wa vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa wa vv cU ra4 com12 adantl cX cB wcel vv cv
        cU wcel wa vx cv vv cv wcel vv cv cX wss wa vv cv cX wss vv cU wrex vt
        cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex
        vy vt cv wral vt cU wrex wa cX cB wcel vv cv cU wcel wa vv cv cX wss vv
        cv cX wss vv cU wrex vx cv vv cv wcel vv cv cU wcel vv cv cX wss vv cv
        cX wss vv cU wrex wi cX cB wcel vv cv cU wcel vv cv cX wss vv cv cX wss
        vv cU wrex vv cv cX wss vv cU ra4e ex adantl adantld adantrd syld ex
        19.23ad vv cU n0 syl5ib imp3a r19.20sdv imp cX ssid jctil cX cB wcel cX
        vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel cX
        cX wss vv cv cX wss vv cU wrex vx cX wral wa wb cU c0 wne vx cv vv cv
        wcel vv cv cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw
        cv vv cv wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx
        cX wral vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa cX cX
        wss vv cv cX wss vv cU wrex vx cX wral wa vo cX cB vo cv cX wceq vo cv
        cX wss cX cX wss vv cv vo cv wss vv cU wrex vx vo cv wral vv cv cX wss
        vv cU wrex vx cX wral vo cv cX cX sseq1 vv cv vo cv wss vv cU wrex vv
        cv cX wss vv cU wrex vx vo cv cX vo cv cX wceq vv cv vo cv wss vv cv cX
        wss vv cU vo cv cX vv cv sseq2 rexbidv raleqd anbi12d elabg adantr
        mpbird cX vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab elssuni syl vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cuni cX wss cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
        wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
        vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
        va cv cX wss vv cv va cv wss vv cU wrex vx va cv wral wa va cv cX wss
        wi vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cuni
        cX wss va vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab cuni cX wss va cv cX wss va vo cv cX wss vv cv vo cv wss vv cU wrex
        vx vo cv wral wa vo cab wral va cv vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab wcel va cv cX wss wi va wal va cv cX wss
        vv cv va cv wss vv cU wrex vx va cv wral wa va cv cX wss wi va wal va
        vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cX
        unissb va cv cX wss va vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
        wral wa vo cab df-ral va cv vo cv cX wss vv cv vo cv wss vv cU wrex vx
        vo cv wral wa vo cab wcel va cv cX wss wi va cv cX wss vv cv va cv wss
        vv cU wrex vx va cv wral wa va cv cX wss wi va va cv vo cv cX wss vv cv
        vo cv wss vv cU wrex vx vo cv wral wa vo cab wcel va cv cX wss vv cv va
        cv wss vv cU wrex vx va cv wral wa va cv cX wss vo cv cX wss vv cv vo
        cv wss vv cU wrex vx vo cv wral wa va cv cX wss vv cv va cv wss vv cU
        wrex vx va cv wral wa vo va cv va visset vo cv va cv wceq vo cv cX wss
        va cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral vv cv va cv wss
        vv cU wrex vx va cv wral vo cv va cv cX sseq1 vv cv vo cv wss vv cU
        wrex vv cv va cv wss vv cU wrex vx vo cv va cv vo cv va cv wceq vv cv
        vo cv wss vv cv va cv wss vv cU vo cv va cv vv cv sseq2 rexbidv raleqd
        anbi12d elab imbi1i albii 3bitrri va cv cX wss vv cv va cv wss vv cU
        wrex vx va cv wral pm3.26 mpgbi a1i eqssd ad2antrr eleqtrrd adantllr
        jca cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
        vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel cX vj
        cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv
        vn cv wss vu cU wrex wa wb vn wal vx cX wral wa wa wa vx cv cX wcel vm
        cv vx cv csn vj cv cnei cfv cfv wcel vm cv vx cv csn vo cv cX wss vv cv
        vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel wb vx cv
        vm cv wcel cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv
        vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy
        vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa vj cv ctop wcel
        cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss
        vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa wa wa vx cv cX
        wcel wa vm cv vx cv csn vj cv cnei cfv cfv wcel vm cv cX wss vu cv vm
        cv wss vu cU wrex wa vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vj cv ctop wcel cX vj cv
        cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral wa wa vx cv cX wcel vm cv vx
        cv csn vj cv cnei cfv cfv wcel vm cv cX wss vu cv vm cv wss vu cU wrex
        wa wb cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv
        vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral wa vx cX wral wa cX vj cv cuni wceq vn
        cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
        wrex wa wb vn wal vx cX wral wa vx cv cX wcel vm cv vx cv csn vj cv
        cnei cfv cfv wcel vm cv cX wss vu cv vm cv wss vu cU wrex wa wb vj cv
        ctop wcel vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn
        cv wss vu cU wrex wa wb vn wal vx cX wral vx cv cX wcel vm cv vx cv csn
        vj cv cnei cfv cfv wcel vm cv cX wss vu cv vm cv wss vu cU wrex wa wb
        cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss
        vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral vx cv cX wcel vm cv
        vx cv csn vj cv cnei cfv cfv wcel vm cv cX wss vu cv vm cv wss vu cU
        wrex wa wb vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv
        vn cv wss vu cU wrex wa wb vn wal vx cX wral vx cv cX wcel vn cv vx cv
        csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa
        wb vn wal vm cv vx cv csn vj cv cnei cfv cfv wcel vm cv cX wss vu cv vm
        cv wss vu cU wrex wa wb vn cv vx cv csn vj cv cnei cfv cfv wcel vn cv
        cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX ra4 vn cv vx cv
        csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa
        wb vm cv vx cv csn vj cv cnei cfv cfv wcel vm cv cX wss vu cv vm cv wss
        vu cU wrex wa wb vn vm cv vm visset vn cv vm cv wceq vn cv vx cv csn vj
        cv cnei cfv cfv wcel vm cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX
        wss vu cv vn cv wss vu cU wrex wa vm cv cX wss vu cv vm cv wss vu cU
        wrex wa vn cv vm cv vx cv csn vj cv cnei cfv cfv eleq1 vn cv vm cv wceq
        vn cv cX wss vm cv cX wss vu cv vn cv wss vu cU wrex vu cv vm cv wss vu
        cU wrex vn cv vm cv cX sseq1 vn cv vm cv wceq vu cv vn cv wss vu cv vm
        cv wss vu cU vn cv vm cv vu cv sseq2 rexbidv anbi12d bibi12d cla4v syl6
        imp adantll adantll adantll cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
        cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
        wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral
        wa vx cv cX wcel vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vm cv cX wss vu cv vm cv
        wss vu cU wrex wa wb vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv csn
        vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb
        vn wal vx cX wral wa wa cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX
        wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv wss
        vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral wa
        vx cv cX wcel vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex
        vx vo cv wral wa vo cab cnei cfv cfv wcel vm cv cX wss vu cv vm cv wss
        vu cU wrex wa wb vx vy vw vv vu vt cB cU vm vo cW cX neibastop1.1
        neibastop2 imp adantlr bitr4d adantlr pm5.21nd ralbida vj cv ctop wcel
        vm cv vj cv wcel vm cv vx cv csn vj cv cnei cfv cfv wcel vx vm cv wral
        wb cX cB wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw
        cv cin wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv
        wral vt cU wrex wa wa vv cU wral wa vx cX wral wa cX vj cv cuni wceq vn
        cv vx cv csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU
        wrex wa wb vn wal vx cX wral wa vx vm cv vj cv opnnei ad2antrl cX cB
        wcel cU c0 wne vx cv vv cv wcel vv cv cX wss wa vt cv vv cv vw cv cin
        wss vt cU wrex vw cU wral vw cv vv cv wss vw cW wrex vy vt cv wral vt
        cU wrex wa wa vv cU wral wa vx cX wral wa vm cv vo cv cX wss vv cv vo
        cv wss vv cU wrex vx vo cv wral wa vo cab wcel vm cv vx cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv
        wcel vx vm cv wral wb vj cv ctop wcel cX vj cv cuni wceq vn cv vx cv
        csn vj cv cnei cfv cfv wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa
        wb vn wal vx cX wral wa wa cX cB wcel cU c0 wne vx cv vv cv wcel vv cv
        cX wss wa vt cv vv cv vw cv cin wss vt cU wrex vw cU wral vw cv vv cv
        wss vw cW wrex vy vt cv wral vt cU wrex wa wa vv cU wral wa vx cX wral
        wa vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab ctop
        wcel vm cv vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab wcel vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo
        cv wral wa vo cab cnei cfv cfv wcel vx vm cv wral wb vx vy vw vv vt cB
        cU vo cW cX neibastop1.1 neibastop1 vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab ctop wcel vm cv vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab wcel vm cv vk cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv
        wcel vk vm cv wral vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU
        wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vx vm cv wral vk vm cv
        vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab opnnei
        vm cv vk cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cnei cfv cfv wcel vm cv vx cv csn vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv wcel vk vx vm cv vx
        vm vk cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa
        vo cab cnei cfv vx vm vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv
        wral wa vo cab cnei vm cv cnei wcel vx ax-17 vo cv cX wss vv cv vo cv
        wss vv cU wrex vx vo cv wral wa vx vo vm vo cv cX wss vv cv vo cv wss
        vv cU wrex vx vo cv wral vx vo cv cX wss vx ax-17 vv cv vo cv wss vv cU
        wrex vx vo cv hbra1 hban hbab hbfv vm cv vk cv csn wcel vx ax-17 hbfv
        vm cv vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral
        wa vo cab cnei cfv cfv wcel vk ax-17 vk cv vx cv wceq vk cv csn vo cv
        cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv cfv
        vx cv csn vo cv cX wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo
        cab cnei cfv cfv vm cv vk cv vx cv wceq vk cv csn vx cv csn vo cv cX
        wss vv cv vo cv wss vv cU wrex vx vo cv wral wa vo cab cnei cfv vk cv
        vx cv sneq fveq2d eleq2d cbvral syl6bb syl adantr 3bitr4d eqrdv ex
        19.21aiv syl3anc cX vj cv cuni wceq vn cv vx cv csn vj cv cnei cfv cfv
        wcel vn cv cX wss vu cv vn cv wss vu cU wrex wa wb vn wal vx cX wral wa
        vj ctop df-reu sylibr $.
        $( [19-Sep-2009] $) $( [16-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Lattice structure of topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a j k o t u v A $. $d a j k o t u v S $. $d a j k o t u v X $.
    $( The meet of a collection of topologies on ` X ` is again a topology on
       ` X ` . $)
    topmtcl $p |- ( ( X e. A /\ S C_ { j e. Top | X = U. j } ) -> ( if ( S =
    (/) , ~P X , |^| S ) e. Top /\ X = U. if ( S = (/) , ~P X , |^| S ) ) ) $=
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq cS c0
      wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni
      wceq wa cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq cS
      c0 wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif
      cuni wceq wa cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq
      w3a cS c0 wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint
      cif cuni wceq wa cX cpw ctop wcel cX cX cpw cuni wceq wa cX cA wcel cS cX
      vj cv cuni wceq vj ctop crab wss cS c0 wceq w3a cX cpw ctop wcel cX cX
      cpw cuni wceq cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cX cpw
      ctop wcel cS c0 wceq cX cA wcel cX cpw ctop wcel cX cA wcel cX c0 cif cpw
      ctop wcel cX c0 cX cX cA wcel cX c0 cif wceq cX cpw cX cA wcel cX c0 cif
      cpw ctop cX cX cA wcel cX c0 cif pweq eleq1d cX cA wcel cX c0 cif cX cA
      wcel cX cA wcel cX c0 cif cvv wcel cX cA wcel cX cA wcel cX c0 cif cX cvv
      cX cA wcel cX c0 iftrue cX cA elisset eqeltrd cX cA wcel wn cX cA wcel cX
      c0 cif c0 cvv cX cA wcel cX c0 iffalse 0ex syl6eqel pm2.61i distop dedth
      3ad2ant1 cX cpw cuni cX cX unipw eqcomi jctir cS c0 wceq cX cA wcel cS c0
      wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni
      wceq wa cX cpw ctop wcel cX cX cpw cuni wceq wa wb cS cX vj cv cuni wceq
      vj ctop crab wss cS c0 wceq cS c0 wceq cX cpw cS cint cif ctop wcel cX
      cpw ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni wceq cX cX cpw cuni
      wceq cS c0 wceq cS c0 wceq cX cpw cS cint cif cX cpw ctop cS c0 wceq cX
      cpw cS cint iftrue eleq1d cS c0 wceq cS c0 wceq cX cpw cS cint cif cuni
      cX cpw cuni cX cS c0 wceq cS c0 wceq cX cpw cS cint cif cX cpw cS c0 wceq
      cX cpw cS cint iftrue unieqd eqeq2d anbi12d 3ad2ant3 mpbird 3expia cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn cS c0 wceq cX
      cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni wceq wa
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a cS c0
      wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni
      wceq wa cS cint ctop wcel cX cS cint cuni wceq wa cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss cS c0 wceq wn w3a cS cint ctop wcel cX cS cint
      cuni wceq cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn
      w3a cS cint ctop wcel vu cv cS cint wss vu cv cuni cS cint wcel wi vu wal
      vu cv vv cv cin cS cint wcel vv cS cint wral vu cS cint wral wa cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS
      cint wss vu cv cuni cS cint wcel wi vu wal vu cv vv cv cin cS cint wcel
      vv cS cint wral vu cS cint wral cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss cS c0 wceq wn w3a vu cv cS cint wss vu cv cuni cS cint wcel wi
      vu cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu
      cv cS cint wss vu cv cuni cS cint wcel cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wss wa vt cv cS wcel vu
      cv cuni vt cv wcel wi vt wal vu cv cuni cS cint wcel cX cA wcel cS cX vj
      cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wss wa vt
      cv cS wcel vu cv cuni vt cv wcel wi vt cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wss wa vt cv cS wcel cS
      cint vt cv wss vu cv cuni vt cv wcel vt cv cS intss1 cX cA wcel cS cX vj
      cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wss wa cS
      cint vt cv wss vt cv cS wcel vu cv cuni vt cv wcel cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wss cS cint vt
      cv wss vt cv cS wcel vu cv cuni vt cv wcel wi cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss cS c0 wceq wn w3a vu cv vt cv wss vt cv cS wcel vu
      cv cuni vt cv wcel wi vu cv cS cint wss cS cint vt cv wss wa cX cA wcel
      cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vt cv cS wcel vu
      cv vt cv wss vu cv cuni vt cv wcel cS cX vj cv cuni wceq vj ctop crab wss
      cX cA wcel vt cv cS wcel vu cv vt cv wss vu cv cuni vt cv wcel wi wi cS
      c0 wceq wn cS cX vj cv cuni wceq vj ctop crab wss vt cv cS wcel vt cv cX
      vj cv cuni wceq vj ctop crab wcel vu cv vt cv wss vu cv cuni vt cv wcel
      wi cS cX vj cv cuni wceq vj ctop crab vt cv ssel vt cv cX vj cv cuni wceq
      vj ctop crab wcel vt cv ctop wcel cX vt cv cuni wceq wa vu cv vt cv wss
      vu cv cuni vt cv wcel wi cX vj cv cuni wceq cX vt cv cuni wceq vj vt cv
      ctop vj cv vt cv wceq vj cv cuni vt cv cuni cX vj cv vt cv unieq eqeq2d
      elrab vt cv ctop wcel vu cv vt cv wss vu cv cuni vt cv wcel wi cX vt cv
      cuni wceq vt cv ctop wcel vu cv vt cv wss vu cv cuni vt cv wcel vu cv vt
      cv uniopn ex adantr sylbi syl6 3ad2ant2 com23 vu cv cS cint vt cv sstr
      syl5 expdimp com23 mpdi 19.21aiv vt vu cv cuni cS vu cv vu visset uniex
      elint sylibr ex 19.21aiv cX cA wcel cS cX vj cv cuni wceq vj ctop crab
      wss cS c0 wceq wn w3a vu cv vv cv cin cS cint wcel vu vv cS cint cS cint
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv
      cS cint wcel vv cv cS cint wcel wa vu cv vv cv cin cS cint wcel cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS
      cint wcel vv cv cS cint wcel wa wa vt cv cS wcel vu cv vv cv cin vt cv
      wcel wi vt wal vu cv vv cv cin cS cint wcel cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wcel vv cv cS cint
      wcel wa wa vt cv cS wcel vu cv vv cv cin vt cv wcel wi vt cX cA wcel cS
      cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vu cv cS cint wcel
      vv cv cS cint wcel wa vt cv cS wcel vu cv vv cv cin vt cv wcel wi cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vt cv cS
      wcel vu cv cS cint wcel vv cv cS cint wcel wa vu cv vv cv cin vt cv wcel
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vt cv
      cS wcel vu cv cS cint wcel vv cv cS cint wcel wa vu cv vt cv wcel vv cv
      vt cv wcel wa vu cv vv cv cin vt cv wcel vt cv cS wcel vu cv cS cint wcel
      vv cv cS cint wcel wa vu cv vt cv wcel vv cv vt cv wcel wa wi wi cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a vt cv cS
      wcel vu cv cS cint wcel vu cv vt cv wcel vv cv cS cint wcel vv cv vt cv
      wcel vu cv cS cint wcel vt cv cS wcel vu cv vt cv wcel vu cv cS vt cv
      elinti com12 vv cv cS cint wcel vt cv cS wcel vv cv vt cv wcel vv cv cS
      vt cv elinti com12 anim12d a1i cS cX vj cv cuni wceq vj ctop crab wss cX
      cA wcel vt cv cS wcel vu cv vt cv wcel vv cv vt cv wcel wa vu cv vv cv
      cin vt cv wcel wi wi cS c0 wceq wn cS cX vj cv cuni wceq vj ctop crab wss
      vt cv cS wcel vt cv cX vj cv cuni wceq vj ctop crab wcel vu cv vt cv wcel
      vv cv vt cv wcel wa vu cv vv cv cin vt cv wcel wi cS cX vj cv cuni wceq
      vj ctop crab vt cv ssel vt cv cX vj cv cuni wceq vj ctop crab wcel vt cv
      ctop wcel cX vt cv cuni wceq wa vu cv vt cv wcel vv cv vt cv wcel wa vu
      cv vv cv cin vt cv wcel wi cX vj cv cuni wceq cX vt cv cuni wceq vj vt cv
      ctop vj cv vt cv wceq vj cv cuni vt cv cuni cX vj cv vt cv unieq eqeq2d
      elrab vt cv ctop wcel vu cv vt cv wcel vv cv vt cv wcel wa vu cv vv cv
      cin vt cv wcel wi cX vt cv cuni wceq vt cv ctop wcel vu cv vt cv wcel vv
      cv vt cv wcel vu cv vv cv cin vt cv wcel vu cv vv cv vt cv inopn 3expib
      adantr sylbi syl6 3ad2ant2 syldd com23 imp 19.21aiv vt vu cv vv cv cin cS
      vu cv vv cv vu visset inex1 elint sylibr ex r19.21aivv jca cX cA wcel cS
      cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn w3a cS cint cvv wcel cS
      cint ctop wcel vu cv cS cint wss vu cv cuni cS cint wcel wi vu wal vu cv
      vv cv cin cS cint wcel vv cS cint wral vu cS cint wral wa wb cS c0 wceq
      wn cX cA wcel cS cint cvv wcel cS cX vj cv cuni wceq vj ctop crab wss cS
      c0 wceq wn cS cint cvv wcel cS c0 wceq wn cS c0 wne cS cint cvv wcel cS
      c0 df-ne cS intex bitr3i biimpi 3ad2ant3 vu vv cvv cS cint istopg syl
      mpbird cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn
      w3a cX cS cint cuni cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS
      c0 wceq wn w3a cX cS cint wcel cX cS cint cuni wss cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss cS c0 wceq wn w3a cX cS cint wcel cX vt cv
      wcel vt cS wral cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0
      wceq wn w3a cX vt cv wcel vt cS cS cX vj cv cuni wceq vj ctop crab wss cX
      cA wcel vt cv cS wcel cX vt cv wcel wi cS c0 wceq wn cS cX vj cv cuni
      wceq vj ctop crab wss vt cv cS wcel vt cv cX vj cv cuni wceq vj ctop crab
      wcel cX vt cv wcel cS cX vj cv cuni wceq vj ctop crab vt cv ssel vt cv cX
      vj cv cuni wceq vj ctop crab wcel vt cv ctop wcel cX vt cv cuni wceq wa
      cX vt cv wcel cX vj cv cuni wceq cX vt cv cuni wceq vj vt cv ctop vj cv
      vt cv wceq vj cv cuni vt cv cuni cX vj cv vt cv unieq eqeq2d elrab vt cv
      ctop wcel cX vt cv cuni wceq wa cX vt cv cuni vt cv vt cv ctop wcel cX vt
      cv cuni wceq pm3.27 vt cv ctop wcel vt cv cuni vt cv wcel cX vt cv cuni
      wceq vt cv vt cv cuni vt cv cuni eqid topopn adantr eqeltrd sylbi syl6
      3ad2ant2 r19.21aiv cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cX
      cS cint wcel cX vt cv wcel vt cS wral wb cS c0 wceq wn vt cX cS cA elintg
      3ad2ant1 mpbird cX cS cint elssuni syl cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab wss cS c0 wceq wn w3a vo cv cX wss vo cS cint wral cS cint
      cuni cX wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq
      wn w3a vo cv cX wss vo cS cint cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss cS c0 wceq wn vo cv cS cint wcel vo cv cX wss wi cS c0 wceq wn
      cS cX vj cv cuni wceq vj ctop crab wss cX cA wcel vo cv cS cint wcel vo
      cv cX wss wi cS c0 wceq wn vt cv cS wcel vt wex cS cX vj cv cuni wceq vj
      ctop crab wss cX cA wcel vo cv cS cint wcel vo cv cX wss wi wi wi vt cS
      neq0 vt cv cS wcel cS cX vj cv cuni wceq vj ctop crab wss cX cA wcel vo
      cv cS cint wcel vo cv cX wss wi wi wi vt vt cv cS wcel vo cv cS cint wcel
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss vo cv cX wss vt cv cS
      wcel vo cv cS cint wcel vo cv vt cv wcel cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab wss vo cv cX wss wi wi vo cv cS cint wcel vt cv cS wcel vo
      cv vt cv wcel vo cv cS vt cv elinti com12 vt cv cS wcel vo cv vt cv wcel
      cS cX vj cv cuni wceq vj ctop crab wss vo cv cX wss wi cX cA wcel cS cX
      vj cv cuni wceq vj ctop crab wss vt cv cS wcel vo cv vt cv wcel vo cv cX
      wss cS cX vj cv cuni wceq vj ctop crab wss vt cv cS wcel vt cv cX vj cv
      cuni wceq vj ctop crab wcel vo cv vt cv wcel vo cv cX wss wi cS cX vj cv
      cuni wceq vj ctop crab vt cv ssel vt cv cX vj cv cuni wceq vj ctop crab
      wcel vt cv ctop wcel cX vt cv cuni wceq wa vo cv vt cv wcel vo cv cX wss
      wi cX vj cv cuni wceq cX vt cv cuni wceq vj vt cv ctop vj cv vt cv wceq
      vj cv cuni vt cv cuni cX vj cv vt cv unieq eqeq2d elrab vt cv ctop wcel
      cX vt cv cuni wceq vo cv vt cv wcel vo cv cX wss vt cv ctop wcel cX vt cv
      cuni wceq vo cv vt cv wcel w3a vo cv vt cv cuni cX vt cv ctop wcel vo cv
      vt cv wcel vo cv vt cv cuni wss cX vt cv cuni wceq vo cv vt cv vt cv cuni
      vt cv cuni eqid eltopss 3adant2 vt cv ctop wcel cX vt cv cuni wceq vo cv
      vt cv wcel 3simp2 sseqtr4d 3expia sylbi syl6 com3l a1dd syld com24
      19.23aiv sylbi com13 3imp r19.21aiv vo cS cint cX unissb sylibr eqssd jca
      cS c0 wceq wn cX cA wcel cS c0 wceq cX cpw cS cint cif ctop wcel cX cS c0
      wceq cX cpw cS cint cif cuni wceq wa cS cint ctop wcel cX cS cint cuni
      wceq wa wb cS cX vj cv cuni wceq vj ctop crab wss cS c0 wceq wn cS c0
      wceq cX cpw cS cint cif ctop wcel cS cint ctop wcel cX cS c0 wceq cX cpw
      cS cint cif cuni wceq cX cS cint cuni wceq cS c0 wceq wn cS c0 wceq cX
      cpw cS cint cif cS cint ctop cS c0 wceq cX cpw cS cint iffalse eleq1d cS
      c0 wceq wn cS c0 wceq cX cpw cS cint cif cuni cS cint cuni cX cS c0 wceq
      wn cS c0 wceq cX cpw cS cint cif cS cint cS c0 wceq cX cpw cS cint
      iffalse unieqd eqeq2d anbi12d 3ad2ant3 mpbird 3expia pm2.61d $.
      $( [5-Oct-2009] $) $( [5-Oct-2009] $)

    $( Two equivalent formulations of the meet of a collection of
       topologies. $)
  topmeet $p |- ( ( X e. A /\ S C_ { j e. Top | X = U. j } ) -> if ( S = (/) ,
  ~P X , |^| S ) = U. { k e. Top | ( X = U. k /\ A. j e. S k C_ j ) } ) $=
    cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq cX cpw cS
    cint cif cX vk cv cuni wceq vk cv vj cv wss vj cS wral wa vk ctop crab cuni
    cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq cX cpw cS
    cint cif cX vk cv cuni wceq vk cv vj cv wss vj cS wral wa vk ctop crab wcel
    cS c0 wceq cX cpw cS cint cif cX vk cv cuni wceq vk cv vj cv wss vj cS wral
    wa vk ctop crab cuni wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss
    wa cS c0 wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif
    cuni wceq cS c0 wceq cX cpw cS cint cif vj cv wss vj cS wral wa wa cS c0
    wceq cX cpw cS cint cif cX vk cv cuni wceq vk cv vj cv wss vj cS wral wa vk
    ctop crab wcel cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0
    wceq cX cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni
    wceq wa cS c0 wceq cX cpw cS cint cif vj cv wss vj cS wral wa cS c0 wceq cX
    cpw cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni wceq cS c0
    wceq cX cpw cS cint cif vj cv wss vj cS wral wa wa cX cA wcel cS cX vj cv
    cuni wceq vj ctop crab wss wa cS c0 wceq cX cpw cS cint cif ctop wcel cX cS
    c0 wceq cX cpw cS cint cif cuni wceq wa cS c0 wceq cX cpw cS cint cif vj cv
    wss vj cS wral cA cS vj cX topmtcl cX cA wcel cS cX vj cv cuni wceq vj ctop
    crab wss wa cS c0 wceq cX cpw cS cint cif vj cv wss vj cS cX cA wcel cS cX
    vj cv cuni wceq vj ctop crab wss vj cX cA wcel vj ax-17 vj vu cS cX vj cv
    cuni wceq vj ctop crab vu cv cS wcel vj ax-17 cX vj cv cuni wceq vj vu ctop
    hbrab1 hbss hban cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa vj cv
    cS wcel cS c0 wceq cX cpw cS cint cif vj cv wss cX cA wcel cS cX vj cv cuni
    wceq vj ctop crab wss wa vj cv cS wcel wa cS c0 wceq wn cS c0 wceq cX cpw
    cS cint cif vj cv wss vj cv cS wcel cS c0 wceq wn cX cA wcel cS cX vj cv
    cuni wceq vj ctop crab wss wa cS vj cv n0i adantl cX cA wcel cS cX vj cv
    cuni wceq vj ctop crab wss wa vj cv cS wcel cS c0 wceq wn cS c0 wceq cX cpw
    cS cint cif vj cv wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa
    vj cv cS wcel cS c0 wceq wn wa wa cS c0 wceq cX cpw cS cint cif vj cv wss
    cS cint vj cv wss vj cv cS wcel cS cint vj cv wss cX cA wcel cS cX vj cv
    cuni wceq vj ctop crab wss wa cS c0 wceq wn vj cv cS intss1 ad2antrl cS c0
    wceq wn cS c0 wceq cX cpw cS cint cif vj cv wss cS cint vj cv wss wb cX cA
    wcel cS cX vj cv cuni wceq vj ctop crab wss wa vj cv cS wcel cS c0 wceq wn
    cS c0 wceq cX cpw cS cint cif cS cint vj cv cS c0 wceq cX cpw cS cint
    iffalse sseq1d ad2antll mpbird expr mpd ex r19.21ai jca cS c0 wceq cX cpw
    cS cint cif ctop wcel cX cS c0 wceq cX cpw cS cint cif cuni wceq cS c0 wceq
    cX cpw cS cint cif vj cv wss vj cS wral anass sylib cX vk cv cuni wceq vk
    cv vj cv wss vj cS wral wa cX cS c0 wceq cX cpw cS cint cif cuni wceq cS c0
    wceq cX cpw cS cint cif vj cv wss vj cS wral wa vk cS c0 wceq cX cpw cS
    cint cif ctop vk cv cS c0 wceq cX cpw cS cint cif wceq cX vk cv cuni wceq
    cX cS c0 wceq cX cpw cS cint cif cuni wceq vk cv vj cv wss vj cS wral cS c0
    wceq cX cpw cS cint cif vj cv wss vj cS wral vk cv cS c0 wceq cX cpw cS
    cint cif wceq vk cv cuni cS c0 wceq cX cpw cS cint cif cuni cX vk cv cS c0
    wceq cX cpw cS cint cif unieq eqeq2d vk cv cS c0 wceq cX cpw cS cint cif
    wceq vk cv vj cv wss cS c0 wceq cX cpw cS cint cif vj cv wss vj cS vk cv cS
    c0 wceq cX cpw cS cint cif vj cv sseq1 ralbidv anbi12d elrab sylibr cS c0
    wceq cX cpw cS cint cif cX vk cv cuni wceq vk cv vj cv wss vj cS wral wa vk
    ctop crab elssuni syl cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa
    vt cv cS c0 wceq cX cpw cS cint cif wss vt cX vk cv cuni wceq vk cv vj cv
    wss vj cS wral wa vk ctop crab wral cX vk cv cuni wceq vk cv vj cv wss vj
    cS wral wa vk ctop crab cuni cS c0 wceq cX cpw cS cint cif wss cX cA wcel
    cS cX vj cv cuni wceq vj ctop crab wss wa vt cv cS c0 wceq cX cpw cS cint
    cif wss vt cX vk cv cuni wceq vk cv vj cv wss vj cS wral wa vk ctop crab cX
    cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa vt cv ctop wcel cX vt cv
    cuni wceq vt cv vj cv wss vj cS wral wa wa vt cv cS c0 wceq cX cpw cS cint
    cif wss vt cv cX vk cv cuni wceq vk cv vj cv wss vj cS wral wa vk ctop crab
    wcel cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa vt cv ctop wcel
    cX vt cv cuni wceq vt cv vj cv wss vj cS wral wa wa vt cv cS c0 wceq cX cpw
    cS cint cif wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa vt cv
    ctop wcel cX vt cv cuni wceq vt cv vj cv wss vj cS wral wa wa wa cS c0 wceq
    vt cv cS c0 wceq cX cpw cS cint cif wss cX cA wcel cS cX vj cv cuni wceq vj
    ctop crab wss wa vt cv ctop wcel cX vt cv cuni wceq vt cv vj cv wss vj cS
    wral wa wa wa cS c0 wceq wa vt cv cS c0 wceq cX cpw cS cint cif wss vt cv
    cX cpw wss vt cv ctop wcel cX vt cv cuni wceq vt cv vj cv wss vj cS wral wa
    wa vt cv cX cpw wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS
    c0 wceq cX vt cv cuni wceq vt cv cX cpw wss vt cv ctop wcel vt cv vj cv wss
    vj cS wral cX vt cv cuni wceq vt cv cX cpw wss vt cv vt cv cuni cpw wss vt
    cv pwuni cX vt cv cuni wceq cX cpw vt cv cuni cpw vt cv cX vt cv cuni pweq
    sseq2d mpbiri ad2antrl ad2antlr cS c0 wceq vt cv cS c0 wceq cX cpw cS cint
    cif wss vt cv cX cpw wss wb cX cA wcel cS cX vj cv cuni wceq vj ctop crab
    wss wa vt cv ctop wcel cX vt cv cuni wceq vt cv vj cv wss vj cS wral wa wa
    wa cS c0 wceq cS c0 wceq cX cpw cS cint cif cX cpw vt cv cS c0 wceq cX cpw
    cS cint iftrue sseq2d adantl mpbird cX cA wcel cS cX vj cv cuni wceq vj
    ctop crab wss wa vt cv ctop wcel cX vt cv cuni wceq vt cv vj cv wss vj cS
    wral wa wa wa cS c0 wceq wn wa vt cv cS c0 wceq cX cpw cS cint cif wss vt
    cv cS cint wss vt cv ctop wcel cX vt cv cuni wceq vt cv vj cv wss vj cS
    wral wa wa vt cv cS cint wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab
    wss wa cS c0 wceq wn vt cv vj cv wss vj cS wral vt cv cS cint wss vt cv
    ctop wcel cX vt cv cuni wceq vt cv cS cint wss vt cv vj cv wss vj cS wral
    vj vt cv cS ssint biimpri ad2antll ad2antlr cS c0 wceq wn vt cv cS c0 wceq
    cX cpw cS cint cif wss vt cv cS cint wss wb cX cA wcel cS cX vj cv cuni
    wceq vj ctop crab wss wa vt cv ctop wcel cX vt cv cuni wceq vt cv vj cv wss
    vj cS wral wa wa wa cS c0 wceq wn cS c0 wceq cX cpw cS cint cif cS cint vt
    cv cS c0 wceq cX cpw cS cint iffalse sseq2d adantl mpbird pm2.61dan ex cX
    vk cv cuni wceq vk cv vj cv wss vj cS wral wa cX vt cv cuni wceq vt cv vj
    cv wss vj cS wral wa vk vt cv ctop vk cv vt cv wceq cX vk cv cuni wceq cX
    vt cv cuni wceq vk cv vj cv wss vj cS wral vt cv vj cv wss vj cS wral vk cv
    vt cv wceq vk cv cuni vt cv cuni cX vk cv vt cv unieq eqeq2d vk cv vt cv
    wceq vk cv vj cv wss vt cv vj cv wss vj cS vk cv vt cv vj cv sseq1 ralbidv
    anbi12d elrab syl5ib r19.21aiv vt cX vk cv cuni wceq vk cv vj cv wss vj cS
    wral wa vk ctop crab cS c0 wceq cX cpw cS cint cif unissb sylibr eqssd $.
    $( [4-Oct-2009] $) $( [4-Oct-2009] $)

    $( Two equivalent formulations of the join of a collection of
       topologies. $)
    topjoin $p |- ( ( X e. A /\ S C_ { j e. Top | X = U. j } ) -> if ( S = (/)
    , { (/) , X } , ( topGen ` ( fi ` U. S ) ) ) = |^| { k e. Top | ( X = U. k
    /\ A. j e. S j C_ k ) } ) $=
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq cS c0
      wceq c0 cX cpr cS cuni cfi cfv ctg cfv cif cX vk cv cuni wceq vj cv vk cv
      wss vj cS wral wa vk ctop crab cint wceq cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab wss wa cS c0 wceq wa cS c0 wceq c0 cX cpr cS cuni cfi cfv
      ctg cfv cif c0 cX cpr cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk
      ctop crab cint cS c0 wceq cS c0 wceq c0 cX cpr cS cuni cfi cfv ctg cfv
      cif c0 cX cpr wceq cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa
      cS c0 wceq c0 cX cpr cS cuni cfi cfv ctg cfv iftrue adantl cX cA wcel cS
      cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wa c0 cX cpr cX vk cv
      cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab cint cX cA wcel cS
      cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wa c0 cX cpr va cv wss
      va cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab wral c0
      cX cpr cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab cint
      wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wa c0
      cX cpr va cv wss va cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk
      ctop crab cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq
      wa va cv ctop wcel cX va cv cuni wceq vj cv va cv wss vj cS wral wa wa c0
      cX cpr va cv wss va cv cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa
      vk ctop crab wcel va cv ctop wcel cX va cv cuni wceq vj cv va cv wss vj
      cS wral wa wa c0 cX cpr va cv wss wi cX cA wcel cS cX vj cv cuni wceq vj
      ctop crab wss wa cS c0 wceq wa va cv ctop wcel cX va cv cuni wceq c0 cX
      cpr va cv wss vj cv va cv wss vj cS wral va cv ctop wcel cX va cv cuni
      wceq wa c0 va cv wcel cX va cv wcel wa c0 cX cpr va cv wss va cv ctop
      wcel cX va cv cuni wceq wa c0 va cv wcel cX va cv wcel va cv ctop wcel c0
      va cv wcel cX va cv cuni wceq va cv 0opn adantr va cv ctop wcel cX va cv
      cuni wceq wa cX va cv cuni va cv va cv ctop wcel cX va cv cuni wceq
      pm3.27 va cv ctop wcel va cv cuni va cv wcel cX va cv cuni wceq va cv va
      cv cuni va cv cuni eqid topopn adantr eqeltrd jca va cv ctop wcel cX va
      cv cuni wceq wa cX cvv wcel c0 va cv wcel cX va cv wcel wa c0 cX cpr va
      cv wss wb va cv ctop wcel cX va cv cuni wceq wa cX va cv cuni cvv va cv
      ctop wcel cX va cv cuni wceq pm3.27 va cv ctop wcel va cv cuni cvv wcel
      cX va cv cuni wceq va cv ctop uniexg adantr eqeltrd c0 cvv wcel cX cvv
      wcel c0 va cv wcel cX va cv wcel wa c0 cX cpr va cv wss wb 0ex c0 cX va
      cv cvv cvv prssg mpan syl mpbid adantrr a1i cX vk cv cuni wceq vj cv vk
      cv wss vj cS wral wa cX va cv cuni wceq vj cv va cv wss vj cS wral wa vk
      va cv ctop vk cv va cv wceq cX vk cv cuni wceq cX va cv cuni wceq vj cv
      vk cv wss vj cS wral vj cv va cv wss vj cS wral vk cv va cv wceq vk cv
      cuni va cv cuni cX vk cv va cv unieq eqeq2d vk cv va cv wceq vj cv vk cv
      wss vj cv va cv wss vj cS vk cv va cv vj cv sseq2 ralbidv anbi12d elrab
      syl5ib r19.21aiv va c0 cX cpr cX vk cv cuni wceq vj cv vk cv wss vj cS
      wral wa vk ctop crab ssint sylibr cX cA wcel cS cX vj cv cuni wceq vj
      ctop crab wss wa cS c0 wceq wa c0 cX cpr cX vk cv cuni wceq vj cv vk cv
      wss vj cS wral wa vk ctop crab wcel cX vk cv cuni wceq vj cv vk cv wss vj
      cS wral wa vk ctop crab cint c0 cX cpr wss cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa cS c0 wceq wa c0 cX cpr ctop wcel cX c0 cX cpr
      cuni wceq vj cv c0 cX cpr wss vj cS wral wa wa c0 cX cpr cX vk cv cuni
      wceq vj cv vk cv wss vj cS wral wa vk ctop crab wcel cX cA wcel cS cX vj
      cv cuni wceq vj ctop crab wss wa cS c0 wceq wa cX c0 cX cpr cuni wceq vj
      cv c0 cX cpr wss vj cS wral wa c0 cX cpr ctop wcel cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss wa cS c0 wceq wa cX c0 cX cpr cuni wceq vj cv
      c0 cX cpr wss vj cS wral cX cA wcel cX c0 cX cpr cuni wceq cS cX vj cv
      cuni wceq vj ctop crab wss cS c0 wceq cX cA wcel c0 cX cpr cuni c0 cX cun
      cX c0 cvv wcel cX cA wcel c0 cX cpr cuni c0 cX cun wceq 0ex c0 cX cvv cA
      uniprg mpan cX c0 cun cX c0 cX cun cX un0 cX c0 uncom eqtr3i syl6reqr
      ad2antrr cS c0 wceq vj cv c0 cX cpr wss vj cS wral cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss wa cS c0 wceq vj cv c0 cX cpr wss vj cS wral
      vj cv c0 cX cpr wss vj c0 wral vj cv c0 cX cpr wss vj ral0 vj cv c0 cX
      cpr wss vj cS c0 raleq1 mpbiri adantl jca cX indistop jctil cX vk cv cuni
      wceq vj cv vk cv wss vj cS wral wa cX c0 cX cpr cuni wceq vj cv c0 cX cpr
      wss vj cS wral wa vk c0 cX cpr ctop vk cv c0 cX cpr wceq cX vk cv cuni
      wceq cX c0 cX cpr cuni wceq vj cv vk cv wss vj cS wral vj cv c0 cX cpr
      wss vj cS wral vk cv c0 cX cpr wceq vk cv cuni c0 cX cpr cuni cX vk cv c0
      cX cpr unieq eqeq2d vk cv c0 cX cpr wceq vj cv vk cv wss vj cv c0 cX cpr
      wss vj cS vk cv c0 cX cpr vj cv sseq2 ralbidv anbi12d elrab sylibr c0 cX
      cpr cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab intss1
      syl eqssd eqtrd cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS
      c0 wceq wn wa cS c0 wceq c0 cX cpr cS cuni cfi cfv ctg cfv cif cS cuni
      cfi cfv ctg cfv cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop
      crab cint cS c0 wceq wn cS c0 wceq c0 cX cpr cS cuni cfi cfv ctg cfv cif
      cS cuni cfi cfv ctg cfv wceq cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss wa cS c0 wceq c0 cX cpr cS cuni cfi cfv ctg cfv iffalse adantl
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS
      cuni cfi cfv ctg cfv cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk
      ctop crab cint cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0
      wceq wn wa cS cuni cfi cfv ctg cfv vt cv wss vt cX vk cv cuni wceq vj cv
      vk cv wss vj cS wral wa vk ctop crab wral cS cuni cfi cfv ctg cfv cX vk
      cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab cint wss cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS cuni
      cfi cfv ctg cfv vt cv wss vt cX vk cv cuni wceq vj cv vk cv wss vj cS
      wral wa vk ctop crab cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa
      cS c0 wceq wn wa vt cv ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj cS
      wral wa wa cS cuni cfi cfv ctg cfv vt cv wss vt cv cX vk cv cuni wceq vj
      cv vk cv wss vj cS wral wa vk ctop crab wcel cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa cS c0 wceq wn wa vt cv ctop wcel cX vt cv cuni
      wceq vj cv vt cv wss vj cS wral wa wa cS cuni cfi cfv ctg cfv vt cv wss
      cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa vt
      cv ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj cS wral wa wa wa cS
      cuni cfi cfv ctg cfv vt cv ctg cfv vt cv cS cuni cfi cfv ctb wcel vt cv
      ctb wcel cS cuni cfi cfv vt cv wss cS cuni cfi cfv ctg cfv vt cv ctg cfv
      wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa
      vt cv ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj cS wral wa wa wa cS
      cuni cfi cfv vt cv tgss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss
      wa cS c0 wceq wn wa vt cv ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj
      cS wral wa wa wa cS cuni cvv wcel cS cuni cfi cfv ctb wcel cX cA wcel cS
      cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS cuni cvv wcel
      vt cv ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj cS wral wa wa cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS cvv
      wcel cS cuni cvv wcel cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss
      wa cS cvv wcel cS c0 wceq wn cS cX vj cv cuni wceq vj ctop crab wss cX cA
      wcel cS cvv wcel cS cX vj cv cuni wceq vj ctop crab wss cX vj cv cuni
      wceq vj ctop crab cvv wcel cS cvv wcel cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab cvv ssexg cX cA wcel cX cpw cvv wcel vj cv cX cpw wss vj cab
      cvv wcel cX vj cv cuni wceq vj ctop crab cvv wcel cX cA pwexg cX cpw cvv
      wcel cX cpw cpw cvv vj cv cX cpw wss vj cab cX cpw cvv pwexg vj cX cpw
      df-pw syl5eqelr cX vj cv cuni wceq vj ctop crab vj cv cX cpw wss vj cab
      wss vj cv cX cpw wss vj cab cvv wcel cX vj cv cuni wceq vj ctop crab cvv
      wcel cX vj cv cuni wceq vj ctop crab vj cv ctop wcel cX vj cv cuni wceq
      wa vj cab vj cv cX cpw wss vj cab cX vj cv cuni wceq vj ctop df-rab vj cv
      ctop wcel cX vj cv cuni wceq wa vj cv cX cpw wss vj cX vj cv cuni wceq vj
      cv cX cpw wss vj cv ctop wcel cX vj cv cuni wceq vj cv vj cv cuni cpw cX
      cpw vj cv vj cv cuni cpw wss cX vj cv cuni wceq vj cv pwuni a1i cX vj cv
      cuni pweq sseqtr4d adantl ss2abi eqsstri cX vj cv cuni wceq vj ctop crab
      vj cv cX cpw wss vj cab cvv ssexg mpan 3syl sylan2 ancoms adantr cS cvv
      uniexg syl adantr cS cuni cvv fibas syl vt cv ctop wcel vt cv ctb wcel cX
      cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cX vt
      cv cuni wceq vj cv vt cv wss vj cS wral wa vt cv topbas ad2antrl cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa vt cv
      ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj cS wral wa wa wa cS cuni
      cfi cfv vt cv cfi cfv vt cv vt cv ctop wcel cS cuni vt cv wss cS cuni cfi
      cfv vt cv cfi cfv wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss
      wa cS c0 wceq wn wa vt cv ctop wcel cX vt cv cuni wceq vj cv vt cv wss vj
      cS wral wa wa wa cS cuni vt cv ctop fiss cX cA wcel cS cX vj cv cuni wceq
      vj ctop crab wss wa cS c0 wceq wn wa vt cv ctop wcel cX vt cv cuni wceq
      vj cv vt cv wss vj cS wral wa simprl cX vt cv cuni wceq vj cv vt cv wss
      vj cS wral wa cS cuni vt cv wss cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss wa cS c0 wceq wn wa vt cv ctop wcel vj cv vt cv wss vj cS wral
      cS cuni vt cv wss cX vt cv cuni wceq cS cuni vt cv wss vj cv vt cv wss vj
      cS wral vj cS vt cv unissb biimpri adantl ad2antll sylanc vt cv ctop wcel
      vt cv cfi cfv vt cv wceq cX cA wcel cS cX vj cv cuni wceq vj ctop crab
      wss wa cS c0 wceq wn wa cX vt cv cuni wceq vj cv vt cv wss vj cS wral wa
      vt cv fitop ad2antrl sseqtrd syl3anc vt cv ctop wcel vt cv ctg cfv vt cv
      wceq cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn
      wa cX vt cv cuni wceq vj cv vt cv wss vj cS wral wa vt cv tgtop ad2antrl
      sseqtrd ex cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa cX vt cv cuni
      wceq vj cv vt cv wss vj cS wral wa vk vt cv ctop vk cv vt cv wceq cX vk
      cv cuni wceq cX vt cv cuni wceq vj cv vk cv wss vj cS wral vj cv vt cv
      wss vj cS wral vk cv vt cv wceq vk cv cuni vt cv cuni cX vk cv vt cv
      unieq eqeq2d vk cv vt cv wceq vj cv vk cv wss vj cv vt cv wss vj cS vk cv
      vt cv vj cv sseq2 ralbidv anbi12d elrab syl5ib r19.21aiv vt cS cuni cfi
      cfv ctg cfv cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab
      ssint sylibr cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0
      wceq wn wa cS cuni cfi cfv ctg cfv cX vk cv cuni wceq vj cv vk cv wss vj
      cS wral wa vk ctop crab wcel cX vk cv cuni wceq vj cv vk cv wss vj cS
      wral wa vk ctop crab cint cS cuni cfi cfv ctg cfv wss cX cA wcel cS cX vj
      cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS cuni cfi cfv ctg cfv
      ctop wcel cX cS cuni cfi cfv ctg cfv cuni wceq vj cv cS cuni cfi cfv ctg
      cfv wss vj cS wral wa wa cS cuni cfi cfv ctg cfv cX vk cv cuni wceq vj cv
      vk cv wss vj cS wral wa vk ctop crab wcel cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa cS c0 wceq wn wa cS cuni cfi cfv ctg cfv ctop
      wcel cX cS cuni cfi cfv ctg cfv cuni wceq vj cv cS cuni cfi cfv ctg cfv
      wss vj cS wral cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0
      wceq wn wa cS cuni cfi cfv ctb wcel cS cuni cfi cfv ctg cfv ctop wcel cX
      cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS cuni cfi cfv ctb
      wcel cS c0 wceq wn cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa
      cS cvv wcel cS cuni cvv wcel cS cuni cfi cfv ctb wcel cS cX vj cv cuni
      wceq vj ctop crab wss cX vj cv cuni wceq vj ctop crab cvv wcel cS cvv
      wcel cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS cX vj cv
      cuni wceq vj ctop crab cvv ssexg cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss pm3.27 cX cA wcel cX vj cv cuni wceq vj ctop crab cvv wcel cS cX
      vj cv cuni wceq vj ctop crab wss cX cA wcel cX cpw cvv wcel vj cv cX cpw
      wss vj cab cvv wcel cX vj cv cuni wceq vj ctop crab cvv wcel cX cA pwexg
      cX cpw cvv wcel cX cpw cpw cvv vj cv cX cpw wss vj cab cX cpw cvv pwexg
      vj cX cpw df-pw syl5eqelr cX vj cv cuni wceq vj ctop crab vj cv cX cpw
      wss vj cab wss vj cv cX cpw wss vj cab cvv wcel cX vj cv cuni wceq vj
      ctop crab cvv wcel cX vj cv cuni wceq vj ctop crab vj cv ctop wcel cX vj
      cv cuni wceq wa vj cab vj cv cX cpw wss vj cab cX vj cv cuni wceq vj ctop
      df-rab vj cv ctop wcel cX vj cv cuni wceq wa vj cv cX cpw wss vj cX vj cv
      cuni wceq vj cv cX cpw wss vj cv ctop wcel cX vj cv cuni wceq vj cv vj cv
      cuni cpw cX cpw vj cv vj cv cuni cpw wss cX vj cv cuni wceq vj cv pwuni
      a1i cX vj cv cuni pweq sseqtr4d adantl ss2abi eqsstri cX vj cv cuni wceq
      vj ctop crab vj cv cX cpw wss vj cab cvv ssexg mpan 3syl adantr sylanc cS
      cvv uniexg cS cuni cvv fibas 3syl adantr cS cuni cfi cfv tgcl syl cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS cuni
      cuni cS cuni cfi cfv cuni cX cS cuni cfi cfv ctg cfv cuni cX cA wcel cS
      cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cS cvv wcel cS
      cuni cvv wcel cS cuni cuni cS cuni cfi cfv cuni wceq cX cA wcel cS cX vj
      cv cuni wceq vj ctop crab wss wa cS cvv wcel cS c0 wceq wn cS cX vj cv
      cuni wceq vj ctop crab wss cX cA wcel cS cvv wcel cS cX vj cv cuni wceq
      vj ctop crab wss cX vj cv cuni wceq vj ctop crab cvv wcel cS cvv wcel cX
      cA wcel cS cX vj cv cuni wceq vj ctop crab cvv ssexg cX cA wcel cX cpw
      cvv wcel vj cv cX cpw wss vj cab cvv wcel cX vj cv cuni wceq vj ctop crab
      cvv wcel cX cA pwexg cX cpw cvv wcel cX cpw cpw cvv vj cv cX cpw wss vj
      cab cX cpw cvv pwexg vj cX cpw df-pw syl5eqelr cX vj cv cuni wceq vj ctop
      crab vj cv cX cpw wss vj cab wss vj cv cX cpw wss vj cab cvv wcel cX vj
      cv cuni wceq vj ctop crab cvv wcel cX vj cv cuni wceq vj ctop crab vj cv
      ctop wcel cX vj cv cuni wceq wa vj cab vj cv cX cpw wss vj cab cX vj cv
      cuni wceq vj ctop df-rab vj cv ctop wcel cX vj cv cuni wceq wa vj cv cX
      cpw wss vj cX vj cv cuni wceq vj cv cX cpw wss vj cv ctop wcel cX vj cv
      cuni wceq vj cv vj cv cuni cpw cX cpw vj cv vj cv cuni cpw wss cX vj cv
      cuni wceq vj cv pwuni a1i cX vj cv cuni pweq sseqtr4d adantl ss2abi
      eqsstri cX vj cv cuni wceq vj ctop crab vj cv cX cpw wss vj cab cvv ssexg
      mpan 3syl sylan2 ancoms adantr cS cvv uniexg cS cuni cvv fiuni 3syl cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa cX cS
      cuni cuni cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq
      wn wa cX cS cuni wcel cX cS cuni cuni wss cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa vt cv cS wcel vt wex cX cS cuni wcel cS c0 wceq
      wn cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa vt cv cS wcel vt
      wex cX cS cuni wcel cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa
      vt cv cS wcel cX cS cuni wcel vt cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss wa vt cv cS wcel cX cS cuni wcel cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa vt cv cS wcel cX vt cv wcel cX cS cuni wcel cX
      cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa vt cv cS wcel vt cv cX
      vj cv cuni wceq vj ctop crab wcel cX vt cv wcel cS cX vj cv cuni wceq vj
      ctop crab wss vt cv cS wcel vt cv cX vj cv cuni wceq vj ctop crab wcel cX
      cA wcel cS cX vj cv cuni wceq vj ctop crab vt cv ssel2 adantll cX cA wcel
      vt cv cX vj cv cuni wceq vj ctop crab wcel cX vt cv wcel cS cX vj cv cuni
      wceq vj ctop crab wss cX cA wcel vt cv ctop wcel cX vt cv cuni wceq wa cX
      vt cv wcel vt cv cX vj cv cuni wceq vj ctop crab wcel vt cv ctop wcel cX
      vt cv cuni wceq wa cX vt cv wcel cX cA wcel vt cv ctop wcel cX vt cv cuni
      wceq wa cX vt cv cuni vt cv vt cv ctop wcel cX vt cv cuni wceq pm3.27 vt
      cv ctop wcel vt cv cuni vt cv wcel cX vt cv cuni wceq vt cv vt cv cuni vt
      cv cuni eqid topopn adantr eqeltrd adantl cX vj cv cuni wceq cX vt cv
      cuni wceq vj vt cv ctop vj cv vt cv wceq vj cv cuni vt cv cuni cX vj cv
      vt cv unieq eqeq2d elrab sylan2b adantlr syldan cX vt cv cS elunii
      sylancom ex 19.23adv imp cS c0 wceq wn cS c0 wne vt cv cS wcel vt wex cS
      c0 df-ne vt cS n0 bitr3i sylan2b cX cS cuni elssuni syl cX cA wcel cS cX
      vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa vt cv cX wss vt cS
      cuni wral cS cuni cuni cX wss cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss wa cS c0 wceq wn wa vt cv cX wss vt cS cuni cX cA wcel cS cX vj
      cv cuni wceq vj ctop crab wss wa cS c0 wceq wn wa vt cv vk cv wcel vk cv
      cS wcel wa vk wex vt cv cX wss vt cv cS cuni wcel cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss wa cS c0 wceq wn wa vt cv vk cv wcel vk cv cS
      wcel wa vt cv cX wss vk cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss
      wa vt cv vk cv wcel vk cv cS wcel wa vt cv cX wss wi cS c0 wceq wn cX cA
      wcel cS cX vj cv cuni wceq vj ctop crab wss vt cv vk cv wcel vk cv cS
      wcel vt cv cX wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss vk cv
      cS wcel vt cv vk cv wcel vt cv cX wss cS cX vj cv cuni wceq vj ctop crab
      wss vk cv cS wcel vk cv cX vj cv cuni wceq vj ctop crab wcel cX cA wcel
      vt cv vk cv wcel vt cv cX wss wi cS cX vj cv cuni wceq vj ctop crab vk cv
      ssel cX cA wcel vk cv ctop wcel cX vk cv cuni wceq wa vt cv vk cv wcel vt
      cv cX wss wi vk cv cX vj cv cuni wceq vj ctop crab wcel vk cv ctop wcel
      cX vk cv cuni wceq wa vt cv vk cv wcel vt cv cX wss wi wi cX cA wcel vk
      cv ctop wcel cX vk cv cuni wceq wa vt cv vk cv wcel vt cv cX wss vk cv
      ctop wcel cX vk cv cuni wceq wa vt cv vk cv wcel wa vt cv vk cv cuni cX
      vk cv ctop wcel vt cv vk cv wcel vt cv vk cv cuni wss cX vk cv cuni wceq
      vt cv vk cv vk cv cuni vk cv cuni eqid eltopss adantlr vk cv ctop wcel cX
      vk cv cuni wceq vt cv vk cv wcel simplr sseqtr4d ex a1i cX vj cv cuni
      wceq cX vk cv cuni wceq vj vk cv ctop vj cv vk cv wceq vj cv cuni vk cv
      cuni cX vj cv vk cv unieq eqeq2d elrab syl5ib syl9r com34 imp4b adantr
      19.23adv vk vt cv cS eluni syl5ib r19.21aiv vt cS cuni cX unissb sylibr
      eqssd cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq wn
      wa cS cuni cfi cfv ctb wcel cS cuni cfi cfv ctg cfv cuni cS cuni cfi cfv
      cuni wceq cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS cuni
      cfi cfv ctb wcel cS c0 wceq wn cX cA wcel cS cX vj cv cuni wceq vj ctop
      crab wss wa cS cvv wcel cS cuni cvv wcel cS cuni cfi cfv ctb wcel cS cX
      vj cv cuni wceq vj ctop crab wss cX vj cv cuni wceq vj ctop crab cvv wcel
      cS cvv wcel cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS cX vj
      cv cuni wceq vj ctop crab cvv ssexg cX cA wcel cS cX vj cv cuni wceq vj
      ctop crab wss pm3.27 cX cA wcel cX vj cv cuni wceq vj ctop crab cvv wcel
      cS cX vj cv cuni wceq vj ctop crab wss cX cA wcel cX cpw cvv wcel vj cv
      cX cpw wss vj cab cvv wcel cX vj cv cuni wceq vj ctop crab cvv wcel cX cA
      pwexg cX cpw cvv wcel cX cpw cpw cvv vj cv cX cpw wss vj cab cX cpw cvv
      pwexg vj cX cpw df-pw syl5eqelr cX vj cv cuni wceq vj ctop crab vj cv cX
      cpw wss vj cab wss vj cv cX cpw wss vj cab cvv wcel cX vj cv cuni wceq vj
      ctop crab cvv wcel cX vj cv cuni wceq vj ctop crab vj cv ctop wcel cX vj
      cv cuni wceq wa vj cab vj cv cX cpw wss vj cab cX vj cv cuni wceq vj ctop
      df-rab vj cv ctop wcel cX vj cv cuni wceq wa vj cv cX cpw wss vj cX vj cv
      cuni wceq vj cv cX cpw wss vj cv ctop wcel cX vj cv cuni wceq vj cv vj cv
      cuni cpw cX cpw vj cv vj cv cuni cpw wss cX vj cv cuni wceq vj cv pwuni
      a1i cX vj cv cuni pweq sseqtr4d adantl ss2abi eqsstri cX vj cv cuni wceq
      vj ctop crab vj cv cX cpw wss vj cab cvv ssexg mpan 3syl adantr sylanc cS
      cvv uniexg cS cuni cvv fibas 3syl adantr cS cuni cfi cfv unitg syl
      3eqtr4d cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS c0 wceq
      wn wa vj cv cS cuni cfi cfv ctg cfv wss vj cS cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa cS c0 wceq wn vj cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss vj cX cA wcel vj ax-17 vj vk cS cX vj cv cuni wceq
      vj ctop crab vk cv cS wcel vj ax-17 cX vj cv cuni wceq vj vk ctop hbrab1
      hbss hban cS c0 wceq wn vj ax-17 hban cX cA wcel cS cX vj cv cuni wceq vj
      ctop crab wss wa cS c0 wceq wn wa vj cv cS cuni wss vj cv cS cuni cfi cfv
      ctg cfv wss vj cv cS wcel vj cv cS cuni wss cS cuni cS cuni cfi cfv ctg
      cfv wss vj cv cS cuni cfi cfv ctg cfv wss cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa cS c0 wceq wn wa vj cv cS cuni cS cuni cfi cfv
      ctg cfv sstr2 cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS
      cuni cS cuni cfi cfv ctg cfv wss cS c0 wceq wn cX cA wcel cS cX vj cv
      cuni wceq vj ctop crab wss wa cS cuni cS cuni cfi cfv cS cuni cfi cfv ctg
      cfv cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS cvv wcel cS
      cuni cvv wcel cS cuni cS cuni cfi cfv wss cS cX vj cv cuni wceq vj ctop
      crab wss cX vj cv cuni wceq vj ctop crab cvv wcel cS cvv wcel cX cA wcel
      cS cX vj cv cuni wceq vj ctop crab wss wa cS cX vj cv cuni wceq vj ctop
      crab cvv ssexg cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss pm3.27
      cX cA wcel cX vj cv cuni wceq vj ctop crab cvv wcel cS cX vj cv cuni wceq
      vj ctop crab wss cX cA wcel cX cpw cvv wcel vj cv cX cpw wss vj cab cvv
      wcel cX vj cv cuni wceq vj ctop crab cvv wcel cX cA pwexg cX cpw cvv wcel
      cX cpw cpw cvv vj cv cX cpw wss vj cab cX cpw cvv pwexg vj cX cpw df-pw
      syl5eqelr cX vj cv cuni wceq vj ctop crab vj cv cX cpw wss vj cab wss vj
      cv cX cpw wss vj cab cvv wcel cX vj cv cuni wceq vj ctop crab cvv wcel cX
      vj cv cuni wceq vj ctop crab vj cv ctop wcel cX vj cv cuni wceq wa vj cab
      vj cv cX cpw wss vj cab cX vj cv cuni wceq vj ctop df-rab vj cv ctop wcel
      cX vj cv cuni wceq wa vj cv cX cpw wss vj cX vj cv cuni wceq vj cv cX cpw
      wss vj cv ctop wcel cX vj cv cuni wceq vj cv vj cv cuni cpw cX cpw vj cv
      vj cv cuni cpw wss cX vj cv cuni wceq vj cv pwuni a1i cX vj cv cuni pweq
      sseqtr4d adantl ss2abi eqsstri cX vj cv cuni wceq vj ctop crab vj cv cX
      cpw wss vj cab cvv ssexg mpan 3syl adantr sylanc cS cvv uniexg cS cuni
      cvv abfi2 3syl cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS
      cuni cvv wcel cS cuni cfi cfv ctb wcel cS cuni cfi cfv cS cuni cfi cfv
      ctg cfv wss cX cA wcel cS cX vj cv cuni wceq vj ctop crab wss wa cS cvv
      wcel cS cuni cvv wcel cS cX vj cv cuni wceq vj ctop crab wss cX vj cv
      cuni wceq vj ctop crab cvv wcel cS cvv wcel cX cA wcel cS cX vj cv cuni
      wceq vj ctop crab wss wa cS cX vj cv cuni wceq vj ctop crab cvv ssexg cX
      cA wcel cS cX vj cv cuni wceq vj ctop crab wss pm3.27 cX cA wcel cX vj cv
      cuni wceq vj ctop crab cvv wcel cS cX vj cv cuni wceq vj ctop crab wss cX
      cA wcel cX cpw cvv wcel vj cv cX cpw wss vj cab cvv wcel cX vj cv cuni
      wceq vj ctop crab cvv wcel cX cA pwexg cX cpw cvv wcel cX cpw cpw cvv vj
      cv cX cpw wss vj cab cX cpw cvv pwexg vj cX cpw df-pw syl5eqelr cX vj cv
      cuni wceq vj ctop crab vj cv cX cpw wss vj cab wss vj cv cX cpw wss vj
      cab cvv wcel cX vj cv cuni wceq vj ctop crab cvv wcel cX vj cv cuni wceq
      vj ctop crab vj cv ctop wcel cX vj cv cuni wceq wa vj cab vj cv cX cpw
      wss vj cab cX vj cv cuni wceq vj ctop df-rab vj cv ctop wcel cX vj cv
      cuni wceq wa vj cv cX cpw wss vj cX vj cv cuni wceq vj cv cX cpw wss vj
      cv ctop wcel cX vj cv cuni wceq vj cv vj cv cuni cpw cX cpw vj cv vj cv
      cuni cpw wss cX vj cv cuni wceq vj cv pwuni a1i cX vj cv cuni pweq
      sseqtr4d adantl ss2abi eqsstri cX vj cv cuni wceq vj ctop crab vj cv cX
      cpw wss vj cab cvv ssexg mpan 3syl adantr sylanc cS cvv uniexg syl cS
      cuni cvv fibas cS cuni cfi cfv bastg 3syl sstrd adantr syl5com vj cv cS
      elssuni syl5 r19.21ai jca32 cX vk cv cuni wceq vj cv vk cv wss vj cS wral
      wa cX cS cuni cfi cfv ctg cfv cuni wceq vj cv cS cuni cfi cfv ctg cfv wss
      vj cS wral wa vk cS cuni cfi cfv ctg cfv ctop vk cv cS cuni cfi cfv ctg
      cfv wceq cX vk cv cuni wceq cX cS cuni cfi cfv ctg cfv cuni wceq vj cv vk
      cv wss vj cS wral vj cv cS cuni cfi cfv ctg cfv wss vj cS wral vk cv cS
      cuni cfi cfv ctg cfv wceq vk cv cuni cS cuni cfi cfv ctg cfv cuni cX vk
      cv cS cuni cfi cfv ctg cfv unieq eqeq2d vk cv cS cuni cfi cfv ctg cfv
      wceq vj cv vk cv wss vj cv cS cuni cfi cfv ctg cfv wss vj cS vk cv cS
      cuni cfi cfv ctg cfv vj cv sseq2 ralbidv anbi12d elrab sylibr cS cuni cfi
      cfv ctg cfv cX vk cv cuni wceq vj cv vk cv wss vj cS wral wa vk ctop crab
      intss1 syl eqssd eqtrd pm2.61dan $.
      $( [6-Oct-2009] $) $( [6-Oct-2009] $)
  $}

  ${
    $d a b c t u v w x y z A $. $d a b c t u v w x y z S $. $d a b c t u v w x
    y z X $.
    $( The meet of a collection of equivalence classes of covers with respect
       to fineness. $)
    fnemeet1 $p |- ( ( X e. A /\ S C_ { y | X = U. y } ) -> A. x e. S { z | ( z
    C_ X /\ A. w e. z A. t e. S E. u e. t ( w e. u /\ u C_ z ) ) } Fne x ) $=
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vz cv cX wss vw cv vu cv
      wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab
      vx cv cfne wbr vx cS cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS
      wcel vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS
      wral vw vz cv wral wa vz cab vx cv cfne wbr cX cA wcel cS cX vy cv cuni
      wceq vy cab wss vx cv cS wcel w3a vz cv cX wss vw cv vu cv wcel vu cv vz
      cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab vx cv cfne wbr
      vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral
      vw vz cv wral wa vz cab cuni vx cv cuni wceq vb cv vc cv wcel vc cv va cv
      wss wa vc vx cv wrex vb va cv wral va vz cv cX wss vw cv vu cv wcel vu cv
      vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wral wa cX
      cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vz cv cX wss
      vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv
      wral wa vz cab cuni vx cv cuni wceq vb cv vc cv wcel vc cv va cv wss wa
      vc vx cv wrex vb va cv wral va vz cv cX wss vw cv vu cv wcel vu cv vz cv
      wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wral cX cA wcel
      cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vz cv cX wss vw cv vu
      cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz
      cab cuni cX vx cv cuni cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv
      cS wcel w3a vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab cuni cX cX cA wcel cS cX vy cv
      cuni wceq vy cab wss vx cv cS wcel w3a va cv cX wss va vz cv cX wss vw cv
      vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa
      vz cab wral vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab cuni cX wss cX cA wcel cS cX vy
      cv cuni wceq vy cab wss vx cv cS wcel w3a va cv cX wss va vz cv cX wss vw
      cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral
      wa vz cab cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a
      va cv cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral
      vw va cv wral wa va cv cX wss va cv vz cv cX wss vw cv vu cv wcel vu cv
      vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wcel va cv
      cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va
      cv wral wa va cv cX wss wi cX cA wcel cS cX vy cv cuni wceq vy cab wss vx
      cv cS wcel w3a va cv cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv
      wrex vt cS wral vw va cv wral pm3.26 a1i vz cv cX wss vw cv vu cv wcel vu
      cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa va cv cX wss vw
      cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv wral
      wa vz va cv va visset vz cv va cv wceq vz cv cX wss va cv cX wss vw cv vu
      cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral vw cv
      vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv wral vz
      cv va cv cX sseq1 vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS
      wral vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw vz
      cv va cv vz cv va cv wceq vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS vz cv va cv
      wceq vw cv vu cv wcel vu cv vz cv wss wa vw cv vu cv wcel vu cv va cv wss
      wa vu vt cv vz cv va cv wceq vu cv vz cv wss vu cv va cv wss vw cv vu cv
      wcel vz cv va cv vu cv sseq2 anbi2d rexbidv ralbidv raleqd anbi12d elab
      syl5ib r19.21aiv va vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu
      vt cv wrex vt cS wral vw vz cv wral wa vz cab cX unissb sylibr cX cA wcel
      cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a cX vz cv cX wss vw cv
      vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa
      vz cab wcel cX vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab cuni wss cX cA wcel cS cX vy cv
      cuni wceq vy cab wss vx cv cS wcel w3a cX vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wcel
      cX cX wss vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cS wral vw cX
      wral wa cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vw
      cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cS wral vw cX wral cX cX
      wss cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vw cv
      vu cv wcel vu cv cX wss wa vu vt cv wrex vw vt cX cS cX cA wcel cS cX vy
      cv cuni wceq vy cab wss vx cv cS wcel w3a vw cv cX wcel vt cv cS wcel wa
      vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex cX cA wcel cS cX vy cv
      cuni wceq vy cab wss vx cv cS wcel w3a vw cv cX wcel vt cv cS wcel wa wa
      vt cv cX vy cv cuni wceq vy cab wcel vw cv vu cv wcel vu cv cX wss wa vu
      vt cv wrex cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a
      vt cv cS wcel vt cv cX vy cv cuni wceq vy cab wcel vw cv cX wcel cS cX vy
      cv cuni wceq vy cab wss cX cA wcel vt cv cS wcel vt cv cX vy cv cuni wceq
      vy cab wcel vx cv cS wcel cS cX vy cv cuni wceq vy cab vt cv ssel2
      3ad2antl2 adantrl cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS
      wcel w3a vw cv cX wcel vt cv cS wcel wa wa cX vt cv cuni wceq vw cv vu cv
      wcel vu cv cX wss wa vu vt cv wrex vt cv cX vy cv cuni wceq vy cab wcel
      cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vw cv cX
      wcel vt cv cS wcel cX vt cv cuni wceq vw cv vu cv wcel vu cv cX wss wa vu
      vt cv wrex wi cX vt cv cuni wceq vw cv cX wcel vt cv cS wcel cX cA wcel
      cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vw cv vu cv wcel vu cv
      cX wss wa vu vt cv wrex cX vt cv cuni wceq vw cv cX wcel vw cv vt cv cuni
      wcel vt cv cS wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS
      wcel w3a vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex wi wi cX vt cv
      cuni vw cv eleq2 cX vt cv cuni wceq vw cv va cv wcel va cv vt cv wcel wa
      va wex vt cv cS wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS
      wcel w3a vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex wi wi vw cv vt cv
      cuni wcel cX vt cv cuni wceq vw cv va cv wcel va cv vt cv wcel wa vt cv
      cS wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vw
      cv vu cv wcel vu cv cX wss wa vu vt cv wrex wi wi va cX vt cv cuni wceq
      vw cv va cv wcel va cv vt cv wcel wa vt cv cS wcel cX cA wcel cS cX vy cv
      cuni wceq vy cab wss vx cv cS wcel w3a vw cv vu cv wcel vu cv cX wss wa
      vu vt cv wrex va cv vt cv wcel vw cv va cv wcel va cv cX wss wa vw cv vu
      cv wcel vu cv cX wss wa vu vt cv wrex cX vt cv cuni wceq vw cv va cv wcel
      va cv vt cv wcel wa wa vt cv cS wcel cX cA wcel cS cX vy cv cuni wceq vy
      cab wss vx cv cS wcel w3a wa wa vw cv vu cv wcel vu cv cX wss wa vw cv va
      cv wcel va cv cX wss wa vu va cv vt cv vu cv va cv wceq vw cv vu cv wcel
      vw cv va cv wcel vu cv cX wss va cv cX wss vu cv va cv vw cv eleq2 vu cv
      va cv cX sseq1 anbi12d rcla4ev cX vt cv cuni wceq vw cv va cv wcel va cv
      vt cv wcel vt cv cS wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss vx
      cv cS wcel w3a wa simplrr cX vt cv cuni wceq vw cv va cv wcel va cv vt cv
      wcel wa wa vw cv va cv wcel va cv cX wss wa vt cv cS wcel cX cA wcel cS
      cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a wa cX vt cv cuni wceq vw
      cv va cv wcel va cv vt cv wcel wa wa vw cv va cv wcel va cv cX wss cX vt
      cv cuni wceq vw cv va cv wcel va cv vt cv wcel simprl cX vt cv cuni wceq
      va cv vt cv wcel va cv cX wss vw cv va cv wcel cX vt cv cuni wceq va cv
      vt cv wcel wa va cv vt cv cuni cX va cv vt cv wcel va cv vt cv cuni wss
      cX vt cv cuni wceq va cv vt cv elssuni adantl cX vt cv cuni wceq va cv vt
      cv wcel pm3.26 sseqtr4d adantrl jca adantr sylanc exp43 19.23adv va vw cv
      vt cv eluni syl5ib sylbid com14 imp32 cX vy cv cuni wceq cX vt cv cuni
      wceq vy vt cv vt visset vy cv vt cv wceq vy cv cuni vt cv cuni cX vy cv
      vt cv unieq eqeq2d elab syl5ib mpd ex r19.21aivv cX ssid jctil cX cA wcel
      cS cX vy cv cuni wceq vy cab wss cX vz cv cX wss vw cv vu cv wcel vu cv
      vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wcel cX cX
      wss vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cS wral vw cX wral
      wa wb vx cv cS wcel vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt
      cS wral vw vz cv wral vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt
      cS wral vw cX wral vz cX cX cA vw cv vu cv wcel vu cv vz cv wss wa vu vt
      cv wrex vt cS wral vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cS
      wral vw vz cv cX vz cv cX wceq vw cv vu cv wcel vu cv vz cv wss wa vu vt
      cv wrex vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cS vz cv cX
      wceq vw cv vu cv wcel vu cv vz cv wss wa vw cv vu cv wcel vu cv cX wss wa
      vu vt cv vz cv cX wceq vu cv vz cv wss vu cv cX wss vw cv vu cv wcel vz
      cv cX vu cv sseq2 anbi2d rexbidv ralbidv raleqd elssabg 3ad2ant1 mpbird
      cX vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS
      wral vw vz cv wral wa vz cab elssuni syl eqssd cS cX vy cv cuni wceq vy
      cab wss vx cv cS wcel cX vx cv cuni wceq cX cA wcel cS cX vy cv cuni wceq
      vy cab wss vx cv cS wcel wa vx cv cX vy cv cuni wceq vy cab wcel cX vx cv
      cuni wceq cS cX vy cv cuni wceq vy cab vx cv ssel2 cX vy cv cuni wceq cX
      vx cv cuni wceq vy vx cv vx visset vy cv vx cv wceq vy cv cuni vx cv cuni
      cX vy cv vx cv unieq eqeq2d elab sylib 3adant1 eqtrd cX cA wcel cS cX vy
      cv cuni wceq vy cab wss vx cv cS wcel w3a vb cv vc cv wcel vc cv va cv
      wss wa vc vx cv wrex va vb vz cv cX wss vw cv vu cv wcel vu cv vz cv wss
      wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab va cv cX cA wcel cS
      cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a va cv vz cv cX wss vw cv
      vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa
      vz cab wcel vb cv va cv wcel vb cv vc cv wcel vc cv va cv wss wa vc vx cv
      wrex cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a va cv
      cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va
      cv wral wa vb cv va cv wcel vb cv vc cv wcel vc cv va cv wss wa vc vx cv
      wrex wi va cv vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab wcel cX cA wcel cS cX vy cv cuni
      wceq vy cab wss vx cv cS wcel w3a va cv cX wss vw cv vu cv wcel vu cv va
      cv wss wa vu vt cv wrex vt cS wral vw va cv wral vb cv va cv wcel vb cv
      vc cv wcel vc cv va cv wss wa vc vx cv wrex wi cX cA wcel cS cX vy cv
      cuni wceq vy cab wss vx cv cS wcel w3a va cv cX wss vb cv va cv wcel vw
      cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv wral
      vb cv vc cv wcel vc cv va cv wss wa vc vx cv wrex cX cA wcel cS cX vy cv
      cuni wceq vy cab wss vx cv cS wcel w3a va cv cX wss vb cv va cv wcel vw
      cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv wral
      vb cv vc cv wcel vc cv va cv wss wa vc vx cv wrex wi cX cA wcel cS cX vy
      cv cuni wceq vy cab wss vx cv cS wcel w3a va cv cX wss vb cv va cv wcel
      wa wa vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va
      cv wral vb cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vb
      cv vc cv wcel vc cv va cv wss wa vc vx cv wrex vb cv va cv wcel vw cv vu
      cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv wral vb cv
      vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral wi cX cA wcel cS
      cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a va cv cX wss vw cv vu cv
      wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vb cv vu cv wcel vu cv
      va cv wss wa vu vt cv wrex vt cS wral vw vb cv va cv vw cv vb cv wceq vw
      cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vb cv vu cv wcel vu cv va
      cv wss wa vu vt cv wrex vt cS vw cv vb cv wceq vw cv vu cv wcel vu cv va
      cv wss wa vb cv vu cv wcel vu cv va cv wss wa vu vt cv vw cv vb cv wceq
      vw cv vu cv wcel vb cv vu cv wcel vu cv va cv wss vw cv vb cv vu cv eleq1
      anbi1d rexbidv ralbidv rcla4v ad2antll cX cA wcel cS cX vy cv cuni wceq
      vy cab wss vx cv cS wcel w3a va cv cX wss vb cv va cv wcel wa wa vb cv vu
      cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vb cv vu cv wcel vu
      cv va cv wss wa vu vx cv wrex vb cv vc cv wcel vc cv va cv wss wa vc vx
      cv wrex cX cA wcel cS cX vy cv cuni wceq vy cab wss vx cv cS wcel w3a vb
      cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vb cv vu cv
      wcel vu cv va cv wss wa vu vx cv wrex wi va cv cX wss vb cv va cv wcel wa
      vx cv cS wcel cX cA wcel vb cv vu cv wcel vu cv va cv wss wa vu vt cv
      wrex vt cS wral vb cv vu cv wcel vu cv va cv wss wa vu vx cv wrex wi cS
      cX vy cv cuni wceq vy cab wss vb cv vu cv wcel vu cv va cv wss wa vu vt
      cv wrex vb cv vu cv wcel vu cv va cv wss wa vu vx cv wrex vt vx cv cS vb
      cv vu cv wcel vu cv va cv wss wa vu vt cv vx cv rexeq1 rcla4v 3ad2ant3
      adantr vb cv vu cv wcel vu cv va cv wss wa vb cv vc cv wcel vc cv va cv
      wss wa vu vc vx cv vu cv vc cv wceq vb cv vu cv wcel vb cv vc cv wcel vu
      cv va cv wss vc cv va cv wss vu cv vc cv vb cv eleq2 vu cv vc cv va cv
      sseq1 anbi12d cbvrexv syl6ib syld exp32 com34 imp3a vz cv cX wss vw cv vu
      cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa va
      cv cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw
      va cv wral wa vz va cv va visset vz cv va cv wceq vz cv cX wss va cv cX
      wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv
      wral vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va
      cv wral vz cv va cv cX sseq1 vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS
      wral vw vz cv va cv vz cv va cv wceq vw cv vu cv wcel vu cv vz cv wss wa
      vu vt cv wrex vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS vz
      cv va cv wceq vw cv vu cv wcel vu cv vz cv wss wa vw cv vu cv wcel vu cv
      va cv wss wa vu vt cv vz cv va cv wceq vu cv vz cv wss vu cv va cv wss vw
      cv vu cv wcel vz cv va cv vu cv sseq2 anbi2d rexbidv ralbidv raleqd
      anbi12d elab syl5ib imp3a r19.21aivv jca vx cv cS wcel cX cA wcel vz cv
      cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz
      cv wral wa vz cab vx cv cfne wbr vz cv cX wss vw cv vu cv wcel vu cv vz
      cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cuni vx cv
      cuni wceq vb cv vc cv wcel vc cv va cv wss wa vc vx cv wrex vb va cv wral
      va vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS
      wral vw vz cv wral wa vz cab wral wa wb cS cX vy cv cuni wceq vy cab wss
      va vb vc vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex
      vt cS wral vw vz cv wral wa vz cab vx cv cS vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cuni
      vx cv cuni vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex
      vt cS wral vw vz cv wral wa vz cab cuni eqid vx cv cuni eqid isfne2
      3ad2ant3 mpbird 3expia r19.21aiv $.
      $( [5-Oct-2009] $) $( [5-Oct-2009] $)

    $( The meet of equivalence classes under the fineness relation-part two. $)
    fnemeet2 $p |- ( ( X e. A /\ S C_ { y | X = U. y } ) -> A. v ( ( X = U. v
    /\ A. x e. S v Fne x ) -> v Fne { z | ( z C_ X /\ A. w e. z A. t e. S E. u
    e. t ( w e. u /\ u C_ z ) ) } ) ) $=
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv
      vx cv cfne wbr vx cS wral wa vv cv vz cv cX wss vw cv vu cv wcel vu cv vz
      cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cfne wbr wi vv
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv
      vx cv cfne wbr vx cS wral wa vv cv vz cv cX wss vw cv vu cv wcel vu cv vz
      cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cfne wbr cX cA
      wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv
      cfne wbr vx cS wral wa wa vv cv vz cv cX wss vw cv vu cv wcel vu cv vz cv
      wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cfne wbr vv cv
      cuni vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS
      wral vw vz cv wral wa vz cab cuni wceq vb cv vc cv wcel vc cv va cv wss
      wa vc vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt
      cS wral vw vz cv wral wa vz cab wrex vb va cv wral va vv cv wral wa cX cA
      wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv
      cfne wbr vx cS wral wa wa vv cv cuni vz cv cX wss vw cv vu cv wcel vu cv
      vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cuni wceq
      vb cv vc cv wcel vc cv va cv wss wa vc vz cv cX wss vw cv vu cv wcel vu
      cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wrex vb
      va cv wral va vv cv wral cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa cX vv cv cuni vz
      cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw
      vz cv wral wa vz cab cuni cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral simprl cX cA wcel cS
      cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr
      vx cS wral wa wa cX vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu
      vt cv wrex vt cS wral vw vz cv wral wa vz cab cuni cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS
      wral wa wa cX vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab wcel cX vz cv cX wss vw cv vu cv
      wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab
      cuni wss cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni
      wceq vv cv vx cv cfne wbr vx cS wral wa wa cX vz cv cX wss vw cv vu cv
      wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab
      wcel cX cX wss vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cS wral
      vw cX wral wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv
      cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa vw cv vu cv wcel vu cv cX
      wss wa vu vt cv wrex vt cS wral vw cX wral cX cX wss cX cA wcel cS cX vy
      cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS
      wral wa wa vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vw vt cX cS cX
      cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx
      cv cfne wbr vx cS wral wa wa vw cv cX wcel vt cv cS wcel wa vw cv vu cv
      wcel vu cv cX wss wa vu vt cv wrex cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa vw cv
      cX wcel vt cv cS wcel wa wa vt cv cX vy cv cuni wceq vy cab wcel vw cv vu
      cv wcel vu cv cX wss wa vu vt cv wrex cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa vt cv cS wcel vt cv cX vy cv cuni wceq vy cab wcel cX vv cv
      cuni wceq vv cv vx cv cfne wbr vx cS wral wa vw cv cX wcel cS cX vy cv
      cuni wceq vy cab wss vt cv cS wcel vt cv cX vy cv cuni wceq vy cab wcel
      cX cA wcel cS cX vy cv cuni wceq vy cab vt cv ssel2 adantll ad2ant2rl cX
      cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx
      cv cfne wbr vx cS wral wa wa vw cv cX wcel vt cv cS wcel wa wa cX vt cv
      cuni wceq vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex vt cv cX vy cv
      cuni wceq vy cab wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX
      vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa vw cv cX wcel vt cv
      cS wcel cX vt cv cuni wceq vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex
      wi cX vt cv cuni wceq vw cv cX wcel vt cv cS wcel cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS
      wral wa wa vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex cX vt cv cuni
      wceq vw cv cX wcel vw cv vt cv cuni wcel vt cv cS wcel cX cA wcel cS cX
      vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx
      cS wral wa wa vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex wi wi cX vt
      cv cuni vw cv eleq2 cX vt cv cuni wceq vw cv va cv wcel va cv vt cv wcel
      wa va wex vt cv cS wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX
      vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa vw cv vu cv wcel vu
      cv cX wss wa vu vt cv wrex wi wi vw cv vt cv cuni wcel cX vt cv cuni wceq
      vw cv va cv wcel va cv vt cv wcel wa vt cv cS wcel cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS
      wral wa wa vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex wi wi va cX vt
      cv cuni wceq vw cv va cv wcel va cv vt cv wcel wa vt cv cS wcel cX cA
      wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv
      cfne wbr vx cS wral wa wa vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex
      va cv vt cv wcel vw cv va cv wcel va cv cX wss wa vw cv vu cv wcel vu cv
      cX wss wa vu vt cv wrex cX vt cv cuni wceq vw cv va cv wcel va cv vt cv
      wcel wa wa vt cv cS wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa wa wa vw cv vu
      cv wcel vu cv cX wss wa vw cv va cv wcel va cv cX wss wa vu va cv vt cv
      vu cv va cv wceq vw cv vu cv wcel vw cv va cv wcel vu cv cX wss va cv cX
      wss vu cv va cv vw cv eleq2 vu cv va cv cX sseq1 anbi12d rcla4ev cX vt cv
      cuni wceq vw cv va cv wcel va cv vt cv wcel vt cv cS wcel cX cA wcel cS
      cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr
      vx cS wral wa wa wa simplrr cX vt cv cuni wceq vw cv va cv wcel va cv vt
      cv wcel wa wa vw cv va cv wcel va cv cX wss wa vt cv cS wcel cX cA wcel
      cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne
      wbr vx cS wral wa wa wa cX vt cv cuni wceq vw cv va cv wcel va cv vt cv
      wcel wa wa vw cv va cv wcel va cv cX wss cX vt cv cuni wceq vw cv va cv
      wcel va cv vt cv wcel simprl cX vt cv cuni wceq va cv vt cv wcel va cv cX
      wss vw cv va cv wcel cX vt cv cuni wceq va cv vt cv wcel wa va cv vt cv
      cuni cX va cv vt cv wcel va cv vt cv cuni wss cX vt cv cuni wceq va cv vt
      cv elssuni adantl cX vt cv cuni wceq va cv vt cv wcel pm3.26 sseqtr4d
      adantrl jca adantr sylanc exp43 19.23adv va vw cv vt cv eluni syl5ib
      sylbid com14 imp32 cX vy cv cuni wceq cX vt cv cuni wceq vy vt cv vt
      visset vy cv vt cv wceq vy cv cuni vt cv cuni cX vy cv vt cv unieq eqeq2d
      elab syl5ib mpd ex r19.21aivv cX ssid jctil cX cA wcel cX vz cv cX wss vw
      cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral
      wa vz cab wcel cX cX wss vw cv vu cv wcel vu cv cX wss wa vu vt cv wrex
      vt cS wral vw cX wral wa wb cS cX vy cv cuni wceq vy cab wss cX vv cv
      cuni wceq vv cv vx cv cfne wbr vx cS wral wa vw cv vu cv wcel vu cv vz cv
      wss wa vu vt cv wrex vt cS wral vw vz cv wral vw cv vu cv wcel vu cv cX
      wss wa vu vt cv wrex vt cS wral vw cX wral vz cX cX cA vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw cv vu cv wcel vu cv cX wss
      wa vu vt cv wrex vt cS wral vw vz cv cX vz cv cX wceq vw cv vu cv wcel vu
      cv vz cv wss wa vu vt cv wrex vw cv vu cv wcel vu cv cX wss wa vu vt cv
      wrex vt cS vz cv cX wceq vw cv vu cv wcel vu cv vz cv wss wa vw cv vu cv
      wcel vu cv cX wss wa vu vt cv vz cv cX wceq vu cv vz cv wss vu cv cX wss
      vw cv vu cv wcel vz cv cX vu cv sseq2 anbi2d rexbidv ralbidv raleqd
      elssabg ad2antrr mpbird cX vz cv cX wss vw cv vu cv wcel vu cv vz cv wss
      wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab elssuni syl cX cA
      wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv
      cfne wbr vx cS wral wa wa va cv cX wss va vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wral
      vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral
      vw vz cv wral wa vz cab cuni cX wss cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va cv
      cX wss va vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex
      vt cS wral vw vz cv wral wa vz cab cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va cv
      cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va
      cv wral wa va cv cX wss va cv vz cv cX wss vw cv vu cv wcel vu cv vz cv
      wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wcel va cv cX wss
      vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv
      wral wa va cv cX wss wi cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX
      vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va cv cX wss vw cv
      vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va cv wral
      pm3.26 a1i vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex
      vt cS wral vw vz cv wral wa va cv cX wss vw cv vu cv wcel vu cv va cv wss
      wa vu vt cv wrex vt cS wral vw va cv wral wa vz va cv va visset vz cv va
      cv wceq vz cv cX wss va cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu
      vt cv wrex vt cS wral vw vz cv wral vw cv vu cv wcel vu cv va cv wss wa
      vu vt cv wrex vt cS wral vw va cv wral vz cv va cv cX sseq1 vw cv vu cv
      wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw cv vu cv wcel vu cv
      va cv wss wa vu vt cv wrex vt cS wral vw vz cv va cv vz cv va cv wceq vw
      cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vw cv vu cv wcel vu cv va
      cv wss wa vu vt cv wrex vt cS vz cv va cv wceq vw cv vu cv wcel vu cv vz
      cv wss wa vw cv vu cv wcel vu cv va cv wss wa vu vt cv vz cv va cv wceq
      vu cv vz cv wss vu cv va cv wss vw cv vu cv wcel vz cv va cv vu cv sseq2
      anbi2d rexbidv ralbidv raleqd anbi12d elab syl5ib r19.21aiv va vz cv cX
      wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv
      wral wa vz cab cX unissb sylibr eqssd eqtr3d cX cA wcel cS cX vy cv cuni
      wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa
      wa vb cv vc cv wcel vc cv va cv wss wa vc vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wrex
      va vb vv cv va cv cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv
      cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va cv vv cv wcel vb cv va
      cv wcel wa vb cv vc cv wcel vc cv va cv wss wa vc vz cv cX wss vw cv vu
      cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz
      cab wrex va cv vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab wcel vb cv va cv wcel va cv va cv
      wss wa vb cv vc cv wcel vc cv va cv wss wa vc vz cv cX wss vw cv vu cv
      wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab
      wrex cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vv
      cv vx cv cfne wbr vx cS wral wa wa va cv vv cv wcel vb cv va cv wcel wa
      wa vb cv vc cv wcel vc cv va cv wss wa vb cv va cv wcel va cv va cv wss
      wa vc va cv vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab vc cv va cv wceq vb cv vc cv wcel
      vb cv va cv wcel vc cv va cv wss va cv va cv wss vc cv va cv vb cv eleq2
      vc cv va cv va cv sseq1 anbi12d rcla4ev cX cA wcel cS cX vy cv cuni wceq
      vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va
      cv vv cv wcel vb cv va cv wcel wa wa va cv cX wss vw cv vu cv wcel vu cv
      va cv wss wa vu vt cv wrex vt cS wral vw va cv wral wa va cv vz cv cX wss
      vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv
      wral wa vz cab wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv
      cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va cv vv cv wcel vb cv
      va cv wcel wa wa va cv cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt
      cv wrex vt cS wral vw va cv wral cX vv cv cuni wceq vv cv vx cv cfne wbr
      vx cS wral wa va cv vv cv wcel va cv cX wss cX cA wcel cS cX vy cv cuni
      wceq vy cab wss wa vb cv va cv wcel cX vv cv cuni wceq va cv vv cv wcel
      va cv cX wss vv cv vx cv cfne wbr vx cS wral cX vv cv cuni wceq va cv vv
      cv wcel wa va cv vv cv cuni cX va cv vv cv wcel va cv vv cv cuni wss cX
      vv cv cuni wceq va cv vv cv elssuni adantl cX vv cv cuni wceq va cv vv cv
      wcel pm3.26 sseqtr4d adantlr ad2ant2lr cX cA wcel cS cX vy cv cuni wceq
      vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va
      cv vv cv wcel vb cv va cv wcel wa wa vw cv vu cv wcel vu cv va cv wss wa
      vu vt cv wrex vw vt va cv cS cX cA wcel cS cX vy cv cuni wceq vy cab wss
      wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa va cv vv cv wcel
      vb cv va cv wcel wa vw cv va cv wcel vt cv cS wcel wa vw cv vu cv wcel vu
      cv va cv wss wa vu vt cv wrex wi vw cv va cv wcel vt cv cS wcel wa cX vv
      cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa va cv vv cv wcel vb cv va
      cv wcel wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv vu cv
      wcel vu cv va cv wss wa vu vt cv wrex vw cv va cv wcel vt cv cS wcel wa
      cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS wral va cv vv cv wcel vb cv
      va cv wcel wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv vu cv
      wcel vu cv va cv wss wa vu vt cv wrex wi wi vw cv va cv wcel vt cv cS
      wcel wa vv cv vx cv cfne wbr vx cS wral cX vv cv cuni wceq va cv vv cv
      wcel vb cv va cv wcel wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex wi wi vw cv va cv wcel
      vt cv cS wcel wa vv cv vx cv cfne wbr vx cS wral vv cv vt cv cfne wbr cX
      vv cv cuni wceq va cv vv cv wcel vb cv va cv wcel wa cX cA wcel cS cX vy
      cv cuni wceq vy cab wss wa vw cv vu cv wcel vu cv va cv wss wa vu vt cv
      wrex wi wi wi vt cv cS wcel vv cv vx cv cfne wbr vx cS wral vv cv vt cv
      cfne wbr wi vw cv va cv wcel vv cv vx cv cfne wbr vv cv vt cv cfne wbr vx
      vt cv cS vx cv vt cv vv cv cfne breq2 rcla4v adantl vw cv va cv wcel vt
      cv cS wcel wa vv cv vt cv cfne wbr cX vv cv cuni wceq va cv vv cv wcel vb
      cv va cv wcel wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv vu
      cv wcel vu cv va cv wss wa vu vt cv wrex vt cv cS wcel vv cv vt cv cfne
      wbr va cv vv cv wcel w3a vw cv va cv wcel vw cv vu cv wcel vu cv va cv
      wss wa vu vt cv wrex vw cv va cv wcel vt cv cS wcel wa vv cv vt cv cfne
      wbr wa cX vv cv cuni wceq va cv vv cv wcel vb cv va cv wcel wa wa wa cX
      cA wcel cS cX vy cv cuni wceq vy cab wss wa wa vu vv cv vt cv cS vw cv va
      cv fnessex vw cv va cv wcel vt cv cS wcel wa vv cv vt cv cfne wbr wa cX
      vv cv cuni wceq va cv vv cv wcel vb cv va cv wcel wa wa wa cX cA wcel cS
      cX vy cv cuni wceq vy cab wss wa wa vt cv cS wcel vv cv vt cv cfne wbr va
      cv vv cv wcel vw cv va cv wcel vt cv cS wcel wa vv cv vt cv cfne wbr wa
      vt cv cS wcel cX vv cv cuni wceq va cv vv cv wcel vb cv va cv wcel wa wa
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv va cv wcel vt cv cS
      wcel vv cv vt cv cfne wbr simplr ad2antrr vw cv va cv wcel vt cv cS wcel
      wa vv cv vt cv cfne wbr cX vv cv cuni wceq va cv vv cv wcel vb cv va cv
      wcel wa wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa simpllr cX vv
      cv cuni wceq va cv vv cv wcel vb cv va cv wcel wa wa va cv vv cv wcel vw
      cv va cv wcel vt cv cS wcel wa vv cv vt cv cfne wbr wa cX cA wcel cS cX
      vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq va cv vv cv wcel vb cv
      va cv wcel simprl ad2antlr 3jca vw cv va cv wcel vt cv cS wcel wa vv cv
      vt cv cfne wbr wa vw cv va cv wcel cX vv cv cuni wceq va cv vv cv wcel vb
      cv va cv wcel wa wa cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv
      va cv wcel vt cv cS wcel vv cv vt cv cfne wbr simpll ad2antrr sylanc
      exp53 syld com23 imp3a com14 imp31 r19.21aivv jca vz cv cX wss vw cv vu
      cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa va
      cv cX wss vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw
      va cv wral wa vz va cv va visset vz cv va cv wceq vz cv cX wss va cv cX
      wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv
      wral vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS wral vw va
      cv wral vz cv va cv cX sseq1 vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS
      wral vw vz cv va cv vz cv va cv wceq vw cv vu cv wcel vu cv vz cv wss wa
      vu vt cv wrex vw cv vu cv wcel vu cv va cv wss wa vu vt cv wrex vt cS vz
      cv va cv wceq vw cv vu cv wcel vu cv vz cv wss wa vw cv vu cv wcel vu cv
      va cv wss wa vu vt cv vz cv va cv wceq vu cv vz cv wss vu cv va cv wss vw
      cv vu cv wcel vz cv va cv vu cv sseq2 anbi2d rexbidv ralbidv raleqd
      anbi12d elab sylibr cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv
      cv cuni wceq vv cv vx cv cfne wbr vx cS wral wa wa va cv vv cv wcel vb cv
      va cv wcel wa wa vb cv va cv wcel va cv va cv wss cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cX vv cv cuni wceq vv cv vx cv cfne wbr vx cS
      wral wa wa va cv vv cv wcel vb cv va cv wcel simprr va cv ssid jctir
      sylanc ex r19.21aivv jca cX cA wcel vv cv vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cfne
      wbr vv cv cuni vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab cuni wceq vb cv vc cv wcel vc cv
      va cv wss wa vc vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv
      wrex vt cS wral vw vz cv wral wa vz cab wrex vb va cv wral va vv cv wral
      wa wb cS cX vy cv cuni wceq vy cab wss cX vv cv cuni wceq vv cv vx cv
      cfne wbr vx cS wral wa cX cA wcel vz cv cX wss vw cv vu cv wcel vu cv vz
      cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cvv wcel vv cv
      vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral
      vw vz cv wral wa vz cab cfne wbr vv cv cuni vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cuni
      wceq vb cv vc cv wcel vc cv va cv wss wa vc vz cv cX wss vw cv vu cv wcel
      vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab wrex
      vb va cv wral va vv cv wral wa wb vw cv vu cv wcel vu cv vz cv wss wa vu
      vt cv wrex vt cS wral vw vz cv wral vz cX cA abssexg va vb vc vv cv vz cv
      cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex vt cS wral vw vz
      cv wral wa vz cab cvv vv cv cuni vz cv cX wss vw cv vu cv wcel vu cv vz
      cv wss wa vu vt cv wrex vt cS wral vw vz cv wral wa vz cab cuni vv cv
      cuni eqid vz cv cX wss vw cv vu cv wcel vu cv vz cv wss wa vu vt cv wrex
      vt cS wral vw vz cv wral wa vz cab cuni eqid isfne2 syl ad2antrr mpbird
      ex 19.21aiv $.
      $( [6-Oct-2009] $) $( [6-Oct-2009] $)
  $}

  ${
    $d k s t w x y z A $. $d k s t w x y z S $. $d k s t w x y z X $.
    $( Join of equivalence classes under the fineness relation-part one. $)
    fnejoin1 $p |- ( ( X e. A /\ S C_ { y | X = U. y } ) -> A. x e. S x Fne if
    ( S = (/) , { X } , U. S ) ) $=
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0 wceq vx cv cS c0
      wceq cX csn cS cuni cif cfne wbr vx cS wral cX cA wcel cS cX vy cv cuni
      wceq vy cab wss wa cS c0 wceq wn vx cv cS c0 wceq cX csn cS cuni cif cfne
      wbr vx cS cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn vx
      cv cS wcel vx cv cS c0 wceq cX csn cS cuni cif cfne wbr cX cA wcel cS cX
      vy cv cuni wceq vy cab wss wa cS c0 wceq wn vx cv cS wcel wa wa vx cv cS
      c0 wceq cX csn cS cuni cif cfne wbr vx cv cS cuni cfne wbr cX cA wcel cS
      cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn vx cv cS wcel wa wa vx cv
      cS cuni cfne wbr vx cv cuni cS cuni cuni wceq vw cv vt cv wcel vt cv vz
      cv wss wa vt cS cuni wrex vw vz cv wral vz vx cv wral wa cX cA wcel cS cX
      vy cv cuni wceq vy cab wss wa cS c0 wceq wn vx cv cS wcel wa wa vx cv
      cuni cS cuni cuni wceq vw cv vt cv wcel vt cv vz cv wss wa vt cS cuni
      wrex vw vz cv wral vz vx cv wral cX cA wcel cS cX vy cv cuni wceq vy cab
      wss wa cS c0 wceq wn vx cv cS wcel wa wa vx cv cuni cX cS cuni cuni cS cX
      vy cv cuni wceq vy cab wss vx cv cS wcel vx cv cuni cX wceq cX cA wcel cS
      c0 wceq wn cS cX vy cv cuni wceq vy cab wss vx cv cS wcel wa vx cv cX vy
      cv cuni wceq vy cab wcel vx cv cuni cX wceq cS cX vy cv cuni wceq vy cab
      vx cv ssel2 vx cv cX vy cv cuni wceq vy cab wcel cX vx cv cuni vx cv cX
      vy cv cuni wceq vy cab wcel cX vx cv cuni wceq cX vy cv cuni wceq cX vx
      cv cuni wceq vy vx cv vx visset vy cv vx cv wceq vy cv cuni vx cv cuni cX
      vy cv vx cv unieq eqeq2d elab biimpi eqcomd syl ad2ant2l cX cA wcel cS cX
      vy cv cuni wceq vy cab wss wa cS c0 wceq wn cX cS cuni cuni wceq vx cv cS
      wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn wa cX
      cS cuni cuni cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn
      wa vt cX cS cuni cuni cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vs
      cv cS wcel vs wex vt cv cX wcel vt cv cS cuni cuni wcel wi cS c0 wceq wn
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vs cv cS wcel vs wex vt cv
      cX wcel vt cv cS cuni cuni wcel wi cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa vs cv cS wcel vt cv cX wcel vt cv cS cuni cuni wcel wi vs cX
      cA wcel cS cX vy cv cuni wceq vy cab wss vs cv cS wcel vt cv cX wcel vt
      cv cS cuni cuni wcel wi wi vs cv cS wcel cS cX vy cv cuni wceq vy cab wss
      cX cA wcel vt cv cX wcel vt cv cS cuni cuni wcel wi vs cv cS wcel cS cX
      vy cv cuni wceq vy cab wss vs cv cX vy cv cuni wceq vy cab wcel cX cA
      wcel vt cv cX wcel vt cv cS cuni cuni wcel wi wi cS cX vy cv cuni wceq vy
      cab wss vs cv cS wcel vs cv cX vy cv cuni wceq vy cab wcel cS cX vy cv
      cuni wceq vy cab vs cv ssel com12 vs cv cS wcel cX vs cv cuni wceq cX cA
      wcel vt cv cX wcel vt cv cS cuni cuni wcel wi wi vs cv cX vy cv cuni wceq
      vy cab wcel vs cv cS wcel cX vs cv cuni wceq vt cv cX wcel vt cv cS cuni
      cuni wcel wi cX cA wcel cX vs cv cuni wceq vt cv cX wcel vt cv vs cv cuni
      wcel vs cv cS wcel vt cv cS cuni cuni wcel cX vs cv cuni wceq vt cv cX
      wcel vt cv vs cv cuni wcel cX vs cv cuni vt cv eleq2 biimpd vs cv cS wcel
      vs cv cuni cS cuni cuni vt cv vs cv cS wcel vs cv cS cuni wss vs cv cuni
      cS cuni cuni wss vs cv cS elssuni vs cv cS cuni uniss syl sseld syl9r
      a1dd cX vy cv cuni wceq cX vs cv cuni wceq vy vs cv vs visset vy cv vs cv
      wceq vy cv cuni vs cv cuni cX vy cv vs cv unieq eqeq2d elab syl5ib syld
      com13 imp 19.23adv imp vs cS neq0 sylan2b ssrdv cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cS c0 wceq wn wa vt cv cX wss vt cS cuni wral cS
      cuni cuni cX wss cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0
      wceq wn wa vt cv cX wss vt cS cuni cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa cS c0 wceq wn wa vt cv vk cv wcel vk cv cS wcel wa vk wex vt
      cv cX wss vt cv cS cuni wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss
      wa cS c0 wceq wn wa vt cv vk cv wcel vk cv cS wcel wa vt cv cX wss vk cX
      cA wcel cS cX vy cv cuni wceq vy cab wss wa vt cv vk cv wcel vk cv cS
      wcel wa vt cv cX wss wi cS c0 wceq wn cX cA wcel cS cX vy cv cuni wceq vy
      cab wss vt cv vk cv wcel vk cv cS wcel vt cv cX wss cX cA wcel cS cX vy
      cv cuni wceq vy cab wss vk cv cS wcel vt cv vk cv wcel vt cv cX wss cS cX
      vy cv cuni wceq vy cab wss vk cv cS wcel vk cv cX vy cv cuni wceq vy cab
      wcel cX cA wcel vt cv vk cv wcel vt cv cX wss wi cS cX vy cv cuni wceq vy
      cab vk cv ssel cX cA wcel cX vk cv cuni wceq vt cv vk cv wcel vt cv cX
      wss wi vk cv cX vy cv cuni wceq vy cab wcel cX vk cv cuni wceq vt cv vk
      cv wcel vt cv cX wss wi wi cX cA wcel cX vk cv cuni wceq vt cv vk cv wcel
      vt cv cX wss cX vk cv cuni wceq vt cv vk cv wcel wa vt cv vk cv cuni cX
      vt cv vk cv wcel vt cv vk cv cuni wss cX vk cv cuni wceq vt cv vk cv
      elssuni adantl cX vk cv cuni wceq vt cv vk cv wcel pm3.26 sseqtr4d ex a1i
      cX vy cv cuni wceq cX vk cv cuni wceq vy vk cv vk visset vy cv vk cv wceq
      vy cv cuni vk cv cuni cX vy cv vk cv unieq eqeq2d elab syl5ib syl9r com34
      imp4b adantr 19.23adv vk vt cv cS eluni syl5ib r19.21aiv vt cS cuni cX
      unissb sylibr eqssd adantrr eqtrd cX cA wcel cS cX vy cv cuni wceq vy cab
      wss wa cS c0 wceq wn vx cv cS wcel wa wa vw cv vt cv wcel vt cv vz cv wss
      wa vt cS cuni wrex vz vw vx cv vz cv cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa cS c0 wceq wn vx cv cS wcel wa wa vz cv vx cv wcel vw cv vz cv
      wcel wa vw cv vt cv wcel vt cv vz cv wss wa vt cS cuni wrex vz cv cS cuni
      wcel vw cv vz cv wcel vz cv vz cv wss wa vw cv vt cv wcel vt cv vz cv wss
      wa vt cS cuni wrex cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0
      wceq wn vx cv cS wcel wa wa vz cv vx cv wcel vw cv vz cv wcel wa wa vw cv
      vt cv wcel vt cv vz cv wss wa vw cv vz cv wcel vz cv vz cv wss wa vt vz
      cv cS cuni vt cv vz cv wceq vw cv vt cv wcel vw cv vz cv wcel vt cv vz cv
      wss vz cv vz cv wss vt cv vz cv vw cv eleq2 vt cv vz cv vz cv sseq1
      anbi12d rcla4ev cS c0 wceq wn vx cv cS wcel wa vz cv vx cv wcel vz cv cS
      cuni wcel cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv vz cv wcel
      vx cv cS wcel vz cv vx cv wcel vz cv cS cuni wcel cS c0 wceq wn vz cv vx
      cv wcel vx cv cS wcel vz cv cS cuni wcel vz cv vx cv cS elunii ancoms
      adantll ad2ant2lr cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS c0
      wceq wn vx cv cS wcel wa wa vz cv vx cv wcel vw cv vz cv wcel wa wa vw cv
      vz cv wcel vz cv vz cv wss cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      cS c0 wceq wn vx cv cS wcel wa wa vz cv vx cv wcel vw cv vz cv wcel
      simprr vz cv ssid jctir sylanc ex r19.21aivv jca cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cS c0 wceq wn vx cv cS wcel wa wa cS cvv wcel cS
      cuni cvv wcel vx cv cS cuni cfne wbr vx cv cuni cS cuni cuni wceq vw cv
      vt cv wcel vt cv vz cv wss wa vt cS cuni wrex vw vz cv wral vz vx cv wral
      wa wb cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cS cvv wcel cS c0
      wceq wn vx cv cS wcel wa cS cX vy cv cuni wceq vy cab wss cX vy cv cuni
      wceq vy cab cvv wcel cS cvv wcel cX cA wcel cS cX vy cv cuni wceq vy cab
      wss wa cS cX vy cv cuni wceq vy cab cvv ssexg cX cA wcel cS cX vy cv cuni
      wceq vy cab wss pm3.27 cX cA wcel cX vy cv cuni wceq vy cab cvv wcel cS
      cX vy cv cuni wceq vy cab wss cX vy cv cuni wceq vy cab cX cpw cpw wss cX
      cpw cpw cvv wcel cX vy cv cuni wceq vy cab cvv wcel cX cA wcel cX vy cv
      cuni wceq vy cab cX cpw cpw cvv ssexg cX vy cv cuni wceq vy cab cX cpw
      cpw wss cX cA wcel cX vy cv cuni wceq vy cX cpw cpw cX vy cv cuni wceq vy
      cv cuni cpw cpw cX cpw cpw vy cv cX vy cv cuni wceq cX cpw vy cv cuni cpw
      wceq cX cpw cpw vy cv cuni cpw cpw wceq cX vy cv cuni pweq cX cpw vy cv
      cuni cpw pweq syl vy cv vy cv cuni cpw cpw wcel vy cv vy cv cuni cpw wss
      vy cv pwuni vy cv vy cv cuni cpw vy visset elpw mpbir syl5eleqr abssi a1i
      cX cA wcel cX cpw cvv wcel cX cpw cpw cvv wcel cX cA pwexg cX cpw cvv
      pwexg syl sylanc adantr sylanc adantr cS cvv uniexg vz vw vt vx cv cS
      cuni cvv vx cv cuni cS cuni cuni vx cv cuni eqid cS cuni cuni eqid isfne2
      3syl mpbird cS c0 wceq wn vx cv cS c0 wceq cX csn cS cuni cif cfne wbr vx
      cv cS cuni cfne wbr wb cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vx
      cv cS wcel cS c0 wceq wn cS c0 wceq cX csn cS cuni cif cS cuni vx cv cfne
      cS c0 wceq cX csn cS cuni iffalse breq2d ad2antrl mpbird exp32 r19.21adv
      vx cv cS c0 wceq cX csn cS cuni cif cfne wbr vx cS rzal pm2.61d2 $.
      $( [8-Oct-2009] $) $( [8-Oct-2009] $)
  $}

  ${
    $d k s t v w x y z A $. $d k s t v w x y z S $. $d k s t v w x y z X $.
    $( Join of equivalence classes under the fineness relation-part two. $)
    fnejoin2 $p |- ( ( X e. A /\ S C_ { y | X = U. y } ) -> A. v ( ( X = U. v
    /\ A. x e. S x Fne v ) -> if ( S = (/) , { X } , U. S ) Fne v ) ) $=
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vx cv
      vv cv cfne wbr vx cS wral wa cS c0 wceq cX csn cS cuni cif vv cv cfne wbr
      wi vv cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq
      vx cv vv cv cfne wbr vx cS wral wa cS c0 wceq cX csn cS cuni cif vv cv
      cfne wbr cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni
      wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0 wceq cS c0 wceq cX csn
      cS cuni cif vv cv cfne wbr cS c0 wceq cS c0 wceq cX csn cS cuni cif vv cv
      cfne wbr cX csn vv cv cfne wbr cX cA wcel cS cX vy cv cuni wceq vy cab
      wss wa cX vv cv cuni wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0
      wceq cS c0 wceq cX csn cS cuni cif cX csn vv cv cfne cS c0 wceq cX csn cS
      cuni iftrue breq1d cX cA wcel cX vv cv cuni wceq cX csn vv cv cfne wbr cS
      cX vy cv cuni wceq vy cab wss vx cv vv cv cfne wbr vx cS wral cX cA wcel
      cX vv cv cuni wceq wa cX csn cuni vv cv cuni wceq vx cv vz cv wcel vz cv
      vy cv wss wa vz vv cv wrex vx vy cv wral vy cX csn wral wa cX csn vv cv
      cfne wbr cX cA wcel cX vv cv cuni wceq wa cX csn cuni vv cv cuni wceq vx
      cv vz cv wcel vz cv vy cv wss wa vz vv cv wrex vx vy cv wral vy cX csn
      wral cX cA wcel cX vv cv cuni wceq wa cX csn cuni cX vv cv cuni cX cA
      wcel cX csn cuni cX wceq cX vv cv cuni wceq cX cA unisng adantr cX cA
      wcel cX vv cv cuni wceq pm3.27 eqtrd cX cA wcel cX vv cv cuni wceq wa vx
      cv vz cv wcel vz cv vy cv wss wa vz vv cv wrex vy vx cX csn vy cv cX cA
      wcel cX vv cv cuni wceq wa vy cv cX wceq vx cv vy cv wcel vx cv vz cv
      wcel vz cv vy cv wss wa vz vv cv wrex vy cv cX csn wcel cX cA wcel cX vv
      cv cuni wceq wa vy cv cX wceq vx cv vy cv wcel vx cv vz cv wcel vz cv vy
      cv wss wa vz vv cv wrex cX cA wcel cX vv cv cuni wceq wa vy cv cX wceq wa
      vx cv cX wcel vx cv vz cv wcel vz cv cX wss wa vz vv cv wrex vx cv vy cv
      wcel vx cv vz cv wcel vz cv vy cv wss wa vz vv cv wrex cX vv cv cuni wceq
      vx cv cX wcel vx cv vz cv wcel vz cv cX wss wa vz vv cv wrex wi cX cA
      wcel vy cv cX wceq cX vv cv cuni wceq vx cv cX wcel vx cv vz cv wcel vz
      cv cX wss wa vz vv cv wrex wi vx cv vv cv cuni wcel vx cv vz cv wcel vz
      cv vv cv cuni wss wa vz vv cv wrex wi vx cv vz cv wcel vz cv vv cv wcel
      wa vz wex vz cv vv cv wcel vx cv vz cv wcel vz cv vv cv cuni wss wa wa vz
      wex vx cv vv cv cuni wcel vx cv vz cv wcel vz cv vv cv cuni wss wa vz vv
      cv wrex vx cv vz cv wcel vz cv vv cv wcel wa vz cv vv cv wcel vx cv vz cv
      wcel vz cv vv cv cuni wss wa wa vz vx cv vz cv wcel vz cv vv cv wcel wa
      vz cv vv cv wcel vx cv vz cv wcel vz cv vv cv cuni wss vx cv vz cv wcel
      vz cv vv cv wcel pm3.27 vx cv vz cv wcel vz cv vv cv wcel pm3.26 vz cv vv
      cv wcel vz cv vv cv cuni wss vx cv vz cv wcel vz cv vv cv elssuni adantl
      jca32 19.22i vz vx cv vv cv eluni vx cv vz cv wcel vz cv vv cv cuni wss
      wa vz vv cv df-rex 3imtr4i cX vv cv cuni wceq vx cv cX wcel vx cv vv cv
      cuni wcel vx cv vz cv wcel vz cv cX wss wa vz vv cv wrex vx cv vz cv wcel
      vz cv vv cv cuni wss wa vz vv cv wrex cX vv cv cuni vx cv eleq2 cX vv cv
      cuni wceq vx cv vz cv wcel vz cv cX wss wa vx cv vz cv wcel vz cv vv cv
      cuni wss wa vz vv cv cX vv cv cuni wceq vz cv cX wss vz cv vv cv cuni wss
      vx cv vz cv wcel cX vv cv cuni vz cv sseq2 anbi2d rexbidv imbi12d mpbiri
      ad2antlr vy cv cX wceq vx cv vy cv wcel vx cv cX wcel wb cX cA wcel cX vv
      cv cuni wceq wa vy cv cX vx cv eleq2 adantl vy cv cX wceq vx cv vz cv
      wcel vz cv vy cv wss wa vz vv cv wrex vx cv vz cv wcel vz cv cX wss wa vz
      vv cv wrex wb cX cA wcel cX vv cv cuni wceq wa vy cv cX wceq vx cv vz cv
      wcel vz cv vy cv wss wa vx cv vz cv wcel vz cv cX wss wa vz vv cv vy cv
      cX wceq vz cv vy cv wss vz cv cX wss vx cv vz cv wcel vy cv cX vz cv
      sseq2 anbi2d rexbidv adantl 3imtr4d expimpd vy cv cX elsni sylani
      r19.21aivv jca vv cv cvv wcel cX csn vv cv cfne wbr cX csn cuni vv cv
      cuni wceq vx cv vz cv wcel vz cv vy cv wss wa vz vv cv wrex vx vy cv wral
      vy cX csn wral wa wb vv visset vy vx vz cX csn vv cv cvv cX csn cuni vv
      cv cuni cX csn cuni eqid vv cv cuni eqid isfne2 ax-mp sylibr ad2ant2r
      syl5cbir cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni
      wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0 wceq wn cS c0 wceq cX
      csn cS cuni cif vv cv cfne wbr cX cA wcel cS cX vy cv cuni wceq vy cab
      wss wa cX vv cv cuni wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0
      wceq wn wa cS c0 wceq cX csn cS cuni cif vv cv cfne wbr cS cuni vv cv
      cfne wbr cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni
      wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0 wceq wn wa cS cuni cuni
      vv cv cuni wceq vw cv vt cv wcel vt cv vz cv wss wa vt vv cv wrex vw vz
      cv wral vz cS cuni wral wa cS cuni vv cv cfne wbr cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cX vv cv cuni wceq vx cv vv cv cfne wbr vx cS
      wral wa wa cS c0 wceq wn wa cS cuni cuni vv cv cuni wceq vw cv vt cv wcel
      vt cv vz cv wss wa vt vv cv wrex vw vz cv wral vz cS cuni wral cX cA wcel
      cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vx cv vv cv cfne
      wbr vx cS wral wa wa cS c0 wceq wn wa cS cuni cuni cX vv cv cuni cX cA
      wcel cS cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn cS cuni cuni cX
      wceq cX vv cv cuni wceq vx cv vv cv cfne wbr vx cS wral wa cX cA wcel cS
      cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn wa cS cuni cuni cX cX cA
      wcel cS cX vy cv cuni wceq vy cab wss wa cS c0 wceq wn wa vt cv cX wss vt
      cS cuni wral cS cuni cuni cX wss cX cA wcel cS cX vy cv cuni wceq vy cab
      wss wa cS c0 wceq wn wa vt cv cX wss vt cS cuni cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa cS c0 wceq wn wa vt cv vk cv wcel vk cv cS wcel
      wa vk wex vt cv cX wss vt cv cS cuni wcel cX cA wcel cS cX vy cv cuni
      wceq vy cab wss wa cS c0 wceq wn wa vt cv vk cv wcel vk cv cS wcel wa vt
      cv cX wss vk cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vt cv vk cv
      wcel vk cv cS wcel wa vt cv cX wss wi cS c0 wceq wn cX cA wcel cS cX vy
      cv cuni wceq vy cab wss vt cv vk cv wcel vk cv cS wcel vt cv cX wss cX cA
      wcel cS cX vy cv cuni wceq vy cab wss vk cv cS wcel vt cv vk cv wcel vt
      cv cX wss cS cX vy cv cuni wceq vy cab wss vk cv cS wcel vk cv cX vy cv
      cuni wceq vy cab wcel cX cA wcel vt cv vk cv wcel vt cv cX wss wi cS cX
      vy cv cuni wceq vy cab vk cv ssel cX cA wcel cX vk cv cuni wceq vt cv vk
      cv wcel vt cv cX wss wi vk cv cX vy cv cuni wceq vy cab wcel cX vk cv
      cuni wceq vt cv vk cv wcel vt cv cX wss wi wi cX cA wcel cX vk cv cuni
      wceq vt cv vk cv wcel vt cv cX wss cX vk cv cuni wceq vt cv vk cv wcel wa
      vt cv vk cv cuni cX vt cv vk cv wcel vt cv vk cv cuni wss cX vk cv cuni
      wceq vt cv vk cv elssuni adantl cX vk cv cuni wceq vt cv vk cv wcel
      pm3.26 sseqtr4d ex a1i cX vy cv cuni wceq cX vk cv cuni wceq vy vk cv vk
      visset vy cv vk cv wceq vy cv cuni vk cv cuni cX vy cv vk cv unieq eqeq2d
      elab syl5ib syl9r com34 imp4b adantr 19.23adv vk vt cv cS eluni syl5ib
      r19.21aiv vt cS cuni cX unissb sylibr cX cA wcel cS cX vy cv cuni wceq vy
      cab wss wa cS c0 wceq wn wa vt cX cS cuni cuni cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa vs cv cS wcel vs wex vt cv cX wcel vt cv cS cuni
      cuni wcel wi cS c0 wceq wn cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      vs cv cS wcel vs wex vt cv cX wcel vt cv cS cuni cuni wcel wi cX cA wcel
      cS cX vy cv cuni wceq vy cab wss wa vs cv cS wcel vt cv cX wcel vt cv cS
      cuni cuni wcel wi vs cX cA wcel cS cX vy cv cuni wceq vy cab wss vs cv cS
      wcel vt cv cX wcel vt cv cS cuni cuni wcel wi wi vs cv cS wcel cS cX vy
      cv cuni wceq vy cab wss cX cA wcel vt cv cX wcel vt cv cS cuni cuni wcel
      wi vs cv cS wcel cS cX vy cv cuni wceq vy cab wss vs cv cX vy cv cuni
      wceq vy cab wcel cX cA wcel vt cv cX wcel vt cv cS cuni cuni wcel wi wi
      cS cX vy cv cuni wceq vy cab wss vs cv cS wcel vs cv cX vy cv cuni wceq
      vy cab wcel cS cX vy cv cuni wceq vy cab vs cv ssel com12 vs cv cS wcel
      cX vs cv cuni wceq cX cA wcel vt cv cX wcel vt cv cS cuni cuni wcel wi wi
      vs cv cX vy cv cuni wceq vy cab wcel vs cv cS wcel cX vs cv cuni wceq vt
      cv cX wcel vt cv cS cuni cuni wcel wi cX cA wcel cX vs cv cuni wceq vt cv
      cX wcel vt cv vs cv cuni wcel vs cv cS wcel vt cv cS cuni cuni wcel cX vs
      cv cuni wceq vt cv cX wcel vt cv vs cv cuni wcel cX vs cv cuni vt cv
      eleq2 biimpd vs cv cS wcel vs cv cuni cS cuni cuni vt cv vs cv cS wcel vs
      cv cS cuni wss vs cv cuni cS cuni cuni wss vs cv cS elssuni vs cv cS cuni
      uniss syl sseld syl9r a1dd cX vy cv cuni wceq cX vs cv cuni wceq vy vs cv
      vs visset vy cv vs cv wceq vy cv cuni vs cv cuni cX vy cv vs cv unieq
      eqeq2d elab syl5ib syld com13 imp 19.23adv imp vs cS neq0 sylan2b ssrdv
      eqssd adantlr cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv
      cuni wceq vx cv vv cv cfne wbr vx cS wral cS c0 wceq wn simplrl eqtrd cX
      cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vx cv vv
      cv cfne wbr vx cS wral wa wa cS c0 wceq wn wa vw cv vt cv wcel vt cv vz
      cv wss wa vt vv cv wrex vz vw cS cuni vz cv cX cA wcel cS cX vy cv cuni
      wceq vy cab wss wa cX vv cv cuni wceq vx cv vv cv cfne wbr vx cS wral wa
      wa cS c0 wceq wn wa vz cv vs cv wcel vs cv cS wcel wa vs wex vw cv vz cv
      wcel vw cv vt cv wcel vt cv vz cv wss wa vt vv cv wrex vz cv cS cuni wcel
      cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni wceq vx cv
      vv cv cfne wbr vx cS wral wa wa cS c0 wceq wn wa vz cv vs cv wcel vs cv
      cS wcel wa vs wex vw cv vz cv wcel vw cv vt cv wcel vt cv vz cv wss wa vt
      vv cv wrex cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX vv cv cuni
      wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0 wceq wn wa vz cv vs cv
      wcel vs cv cS wcel wa vw cv vz cv wcel vw cv vt cv wcel vt cv vz cv wss
      wa vt vv cv wrex wi vs cX cA wcel cS cX vy cv cuni wceq vy cab wss wa cX
      vv cv cuni wceq vx cv vv cv cfne wbr vx cS wral cS c0 wceq wn vz cv vs cv
      wcel vs cv cS wcel wa vw cv vz cv wcel vw cv vt cv wcel vt cv vz cv wss
      wa vt vv cv wrex wi wi vz cv vs cv wcel vs cv cS wcel wa cX vv cv cuni
      wceq vx cv vv cv cfne wbr vx cS wral cS c0 wceq wn cX cA wcel cS cX vy cv
      cuni wceq vy cab wss wa vw cv vz cv wcel vw cv vt cv wcel vt cv vz cv wss
      wa vt vv cv wrex wi vs cv cS wcel vz cv vs cv wcel cX vv cv cuni wceq vx
      cv vv cv cfne wbr vx cS wral cS c0 wceq wn cX cA wcel cS cX vy cv cuni
      wceq vy cab wss wa vw cv vz cv wcel vw cv vt cv wcel vt cv vz cv wss wa
      vt vv cv wrex wi wi wi wi wi vs cv cS wcel vx cv vv cv cfne wbr vx cS
      wral cX vv cv cuni wceq vz cv vs cv wcel cS c0 wceq wn cX cA wcel cS cX
      vy cv cuni wceq vy cab wss wa vw cv vz cv wcel vw cv vt cv wcel vt cv vz
      cv wss wa vt vv cv wrex wi wi wi vs cv cS wcel vx cv vv cv cfne wbr vx cS
      wral vs cv vv cv cfne wbr cX vv cv cuni wceq vz cv vs cv wcel cS c0 wceq
      wn cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv vz cv wcel vw cv
      vt cv wcel vt cv vz cv wss wa vt vv cv wrex wi wi wi wi wi vx cv vv cv
      cfne wbr vs cv vv cv cfne wbr vx vs cv cS vx cv vs cv vv cv cfne breq1
      rcla4v vs cv vv cv cfne wbr cX vv cv cuni wceq vz cv vs cv wcel cS c0
      wceq wn cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vw cv vz cv wcel
      vw cv vt cv wcel vt cv vz cv wss wa vt vv cv wrex wi wi vs cv vv cv cfne
      wbr vz cv vs cv wcel vw cv vz cv wcel vw cv vt cv wcel vt cv vz cv wss wa
      vt vv cv wrex wi cX cA wcel cS cX vy cv cuni wceq vy cab wss wa vv cv cvv
      wcel vs cv vv cv cfne wbr vz cv vs cv wcel vw cv vz cv wcel vw cv vt cv
      wcel vt cv vz cv wss wa vt vv cv wrex wi wi wi vv visset vv cv cvv wcel
      vs cv vv cv cfne wbr vz cv vs cv wcel vw cv vz cv wcel vw cv vt cv wcel
      vt cv vz cv wss wa vt vv cv wrex vt vs cv vv cv cvv vw cv vz cv fnessex
      3exp1 ax-mp a1dd a1i24 syl6 com24 impcom com15 imp42 19.23adv imp3a vz cv
      cS cuni wcel vz cv vs cv wcel vs cv cS wcel wa vs wex vs vz cv cS eluni
      biimpi sylani r19.21aivv jca vv cv cvv wcel cS cuni vv cv cfne wbr cS
      cuni cuni vv cv cuni wceq vw cv vt cv wcel vt cv vz cv wss wa vt vv cv
      wrex vw vz cv wral vz cS cuni wral wa wb vv visset vz vw vt cS cuni vv cv
      cvv cS cuni cuni vv cv cuni cS cuni cuni eqid vv cv cuni eqid isfne2
      ax-mp sylibr cS c0 wceq wn cS c0 wceq cX csn cS cuni cif vv cv cfne wbr
      cS cuni vv cv cfne wbr wb cX cA wcel cS cX vy cv cuni wceq vy cab wss wa
      cX vv cv cuni wceq vx cv vv cv cfne wbr vx cS wral wa wa cS c0 wceq wn cS
      c0 wceq cX csn cS cuni cif cS cuni vv cv cfne cS c0 wceq cX csn cS cuni
      iffalse breq1d adantl mpbird ex pm2.61d ex 19.21aiv $.
      $( [8-Oct-2009] $) $( [8-Oct-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Separation axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Kol2 $.
  $( Extend class notation with the class of all T0 spaces. See comments in
     ~ df-t0ALT . $)
  ct0ALT $a class Kol2 $.

  $c Reg $.
  $( Extend class notation with the class of all regular topologies. $)
  creg $a class Reg $.

  $c Nrm $.
  $( Extend class notation with the class of all normal topologies. $)
  cnrm $a class Nrm $.

  ${
    $d j o x y $.
    $( Define T0 or Kolmogorov spaces. The use of a different symbol for this
       class is to improve compatibility with various Metamath parsers until
       the erroneous definition is removed. $)
    df-t0ALT $a |- Kol2 = { j e. Top | A. x e. U. j A. y e. U. j ( x =/= y ->
    E. o e. j -. ( x e. o <-> y e. o ) ) } $.
  $}

  ${
    $d c j o p x $.
    $( Define regular spaces. $)
    df-reg $a |- Reg = { j e. Top | A. c e. ( Clsd ` j ) A. x e. U. j ( x e/ c
    -> E. o e. j E. p e. j ( c C_ o /\ x e. p /\ ( o i^i p ) = (/) ) ) } $.
  $}

  ${
    $d c d j o p $.
    $( Define normal spaces. $)
    df-nrm $a |- Nrm = { j e. Top | A. c e. ( Clsd ` j ) A. d e. ( Clsd ` j ) (
    ( c i^i d ) = (/) -> E. o e. j E. p e. j ( c C_ o /\ d C_ p /\ ( o i^i p )
    = (/) ) ) } $.
  $}

  ${
    $d j o x y J $. $d j o x y X $.
    ist0.1 $e |- X = U. J $.
    $( The predicate "is a T0 space." Every pair of distinct points is
       topologically distinguishable. For the way this definition is usually
       encountered, see ~ ist0-2 . $)
    ist0 $p |- ( J e. Kol2 <-> ( J e. Top /\ A. x e. X A. y e. X ( x =/= y ->
    E. o e. J -. ( x e. o <-> y e. o ) ) ) ) $=
      vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo vj cv wrex wi
      vy vj cv cuni wral vx vj cv cuni wral vx cv vy cv wne vx cv vo cv wcel vy
      cv vo cv wcel wb wn vo cJ wrex wi vy cX wral vx cX wral vj cJ ctop ct0ALT
      vj cv cJ wceq vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo
      vj cv wrex wi vy vj cv cuni wral vx cv vy cv wne vx cv vo cv wcel vy cv
      vo cv wcel wb wn vo cJ wrex wi vy cX wral vx vj cv cuni cX vj cv cJ wceq
      vj cv cuni cJ cuni cX vj cv cJ unieq ist0.1 syl6eqr vj cv cJ wceq vx cv
      vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo vj cv wrex wi vx cv
      vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo cJ wrex wi vy vj cv
      cuni cX vj cv cJ wceq vj cv cuni cJ cuni cX vj cv cJ unieq ist0.1 syl6eqr
      vj cv cJ wceq vx cv vo cv wcel vy cv vo cv wcel wb wn vo vj cv wrex vx cv
      vo cv wcel vy cv vo cv wcel wb wn vo cJ wrex vx cv vy cv wne vx cv vo cv
      wcel vy cv vo cv wcel wb wn vo vj cv cJ rexeq1 imbi2d raleq12d raleq12d
      vx vy vj vo df-t0ALT elrab2 $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d j o x y J $. $d j o x y X $.
    ist0-2.1 $e |- X = U. J $.
    $( The predicate "is a T0 space," expressed in more familiar terms. $)
    ist0-2 $p |- ( J e. Top -> ( J e. Kol2 <-> A. x e. X A. y e. X ( x =/= y ->
    E. o e. J ( ( x e. o /\ -. y e. o ) \/ ( -. x e. o /\ y e. o ) ) ) ) ) $=
      cJ ctop wcel cJ ct0ALT wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv
      wcel wb wn vo cJ wrex wi vy cX wral vx cX wral vx cv vy cv wne vx cv vo
      cv wcel vy cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo
      vo cJ wrex wi vy cX wral vx cX wral cJ ct0ALT wcel cJ ctop wcel vx cv vy
      cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo cJ wrex wi vy cX wral
      vx cX wral vx vy vo cJ cX ist0-2.1 ist0 baib vx cv vy cv wne vx cv vo cv
      wcel vy cv vo cv wcel wb wn vo cJ wrex wi vx cv vy cv wne vx cv vo cv
      wcel vy cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo vo
      cJ wrex wi vx vy cX cX vx cv vo cv wcel vy cv vo cv wcel wb wn vo cJ wrex
      vx cv vo cv wcel vy cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv
      wcel wa wo vo cJ wrex vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel
      wb wn vx cv vo cv wcel vy cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv
      vo cv wcel wa wo vo cJ vx cv vo cv wcel vy cv vo cv wcel wb wn vx cv vo
      cv wcel vy cv vo cv wcel wn wa vy cv vo cv wcel vx cv vo cv wcel wn wa wo
      vx cv vo cv wcel vy cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv
      wcel wa wo vx cv vo cv wcel vy cv vo cv wcel xor vy cv vo cv wcel vx cv
      vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa vx cv vo cv wcel
      vy cv vo cv wcel wn wa vy cv vo cv wcel vx cv vo cv wcel wn ancom orbi2i
      bitri rexbii imbi2i 2ralbii syl6bb $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d o x y J $.
    $( A T0 space is a topological space. $)
    t0top $p |- ( J e. Kol2 -> J e. Top ) $=
      cJ ct0ALT wcel cJ ctop wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv
      wcel wb wn vo cJ wrex wi vy cJ cuni wral vx cJ cuni wral vx vy vo cJ cJ
      cuni cJ cuni eqid ist0 pm3.26bi $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d o x y A $. $d o x y B $. $d o x y J $. $d o x y X $.
    t0dist.1 $e |- X = U. J $.
    $( Any two distinct points in a T0 space are topologically
       distinguishable. $)
    t0dist $p |- ( ( J e. Kol2 /\ ( A e. X /\ B e. X /\ A =/= B ) ) -> E. o e.
    J -. ( A e. o <-> B e. o ) ) $=
      cJ ct0ALT wcel cA cX wcel cB cX wcel cA cB wne w3a cA vo cv wcel cB vo cv
      wcel wb wn vo cJ wrex cJ ct0ALT wcel vx cv vy cv wne vx cv vo cv wcel vy
      cv vo cv wcel wb wn vo cJ wrex wi vy cX wral vx cX wral cA cX wcel cB cX
      wcel cA cB wne w3a cA vo cv wcel cB vo cv wcel wb wn vo cJ wrex wi cJ
      ct0ALT wcel cJ ctop wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv
      wcel wb wn vo cJ wrex wi vy cX wral vx cX wral vx vy vo cJ cX t0dist.1
      ist0 pm3.27bi vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo
      cJ wrex wi vy cX wral vx cX wral cA cX wcel cB cX wcel cA cB wne cA vo cv
      wcel cB vo cv wcel wb wn vo cJ wrex vx cv vy cv wne vx cv vo cv wcel vy
      cv vo cv wcel wb wn vo cJ wrex wi vy cX wral vx cX wral cA cX wcel cB cX
      wcel cA cB wne cA vo cv wcel cB vo cv wcel wb wn vo cJ wrex wi cA cX wcel
      cB cX wcel wa vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn vo
      cJ wrex wi vy cX wral vx cX wral cA cB wne cA vo cv wcel cB vo cv wcel wb
      wn vo cJ wrex wi vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wb wn
      vo cJ wrex wi cA cB wne cA vo cv wcel cB vo cv wcel wb wn vo cJ wrex wi
      cA vy cv wne cA vo cv wcel vy cv vo cv wcel wb wn vo cJ wrex wi vx vy cA
      cB cX cX vx cv cA wceq vx cv vy cv wne cA vy cv wne vx cv vo cv wcel vy
      cv vo cv wcel wb wn vo cJ wrex cA vo cv wcel vy cv vo cv wcel wb wn vo cJ
      wrex vx cv cA vy cv neeq1 vx cv cA wceq vx cv vo cv wcel vy cv vo cv wcel
      wb wn cA vo cv wcel vy cv vo cv wcel wb wn vo cJ vx cv cA wceq vx cv vo
      cv wcel vy cv vo cv wcel wb cA vo cv wcel vy cv vo cv wcel wb vx cv cA
      wceq vx cv vo cv wcel cA vo cv wcel vy cv vo cv wcel vx cv cA vo cv eleq1
      bibi1d notbid rexbidv imbi12d vy cv cB wceq cA vy cv wne cA cB wne cA vo
      cv wcel vy cv vo cv wcel wb wn vo cJ wrex cA vo cv wcel cB vo cv wcel wb
      wn vo cJ wrex vy cv cB cA neeq2 vy cv cB wceq cA vo cv wcel vy cv vo cv
      wcel wb wn cA vo cv wcel cB vo cv wcel wb wn vo cJ vy cv cB wceq cA vo cv
      wcel vy cv vo cv wcel wb cA vo cv wcel cB vo cv wcel wb vy cv cB wceq vy
      cv vo cv wcel cB vo cv wcel cA vo cv wcel vy cv cB vo cv eleq1 bibi2d
      notbid rexbidv imbi12d rcla42v com12 exp3a 3impd syl imp $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d o w x y z J $. $d o w x y z X $.
    ist1-2.1 $e |- X = U. J $.
    $( An alternate characterization of T1 spaces. $)
    ist1-2 $p |- ( J e. Top -> ( J e. Fre <-> A. x e. X A. y e. X ( x =/= y ->
    E. o e. J ( x e. o /\ -. y e. o ) ) ) ) $=
      cJ ctop wcel cJ ct1 wcel vz cv csn cJ ccld cfv wcel vz cX wral vx cv vy
      cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy cX wral
      vx cX wral cJ ct1 wcel cJ ctop wcel vz cv csn cJ ccld cfv wcel vz cX wral
      cJ cX vz ist1-2.1 ist1 baib cJ ctop wcel vz cv csn cJ ccld cfv wcel vz cX
      wral vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex
      wi vy cX wral vx cX wral cJ ctop wcel vz cv csn cJ ccld cfv wcel vz cX
      wral vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex
      wi vx vy cX cX cJ ctop wcel vx cv cX wcel vy cv cX wcel wa vz cv csn cJ
      ccld cfv wcel vz cX wral vx cv vy cv wne vx cv vo cv wcel vy cv vo cv
      wcel wn wa vo cJ wrex wi cJ ctop wcel vx cv cX wcel vy cv cX wcel vz cv
      csn cJ ccld cfv wcel vz cX wral vx cv vy cv wne vx cv vo cv wcel vy cv vo
      cv wcel wn wa vo cJ wrex wi wi cJ ctop wcel vx cv cX wcel vy cv cX wcel
      w3a vz cv csn cJ ccld cfv wcel vz cX wral vy cv csn cJ ccld cfv wcel vx
      cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy cv
      cX wcel cJ ctop wcel vz cv csn cJ ccld cfv wcel vz cX wral vy cv csn cJ
      ccld cfv wcel wi vx cv cX wcel vz cv csn cJ ccld cfv wcel vy cv csn cJ
      ccld cfv wcel vz vy cv cX vz cv vy cv wceq vz cv csn vy cv csn cJ ccld
      cfv vz cv vy cv sneq eleq1d rcla4v 3ad2ant3 cJ ctop wcel vx cv cX wcel vy
      cv cX wcel w3a vy cv csn cJ ccld cfv wcel vx cv vy cv wne vx cv vo cv
      wcel vy cv vo cv wcel wn wa vo cJ wrex cX vy cv csn cdif cJ wcel vx cv cX
      vy cv csn cdif wcel vy cv cX vy cv csn cdif wcel wn wa vx cv vo cv wcel
      vy cv vo cv wcel wn wa vo cJ wrex cJ ctop wcel vx cv cX wcel vy cv cX
      wcel w3a vy cv csn cJ ccld cfv wcel vx cv vy cv wne wa wa vx cv vo cv
      wcel vy cv vo cv wcel wn wa vx cv cX vy cv csn cdif wcel vy cv cX vy cv
      csn cdif wcel wn wa vo cX vy cv csn cdif cJ vo cv cX vy cv csn cdif wceq
      vx cv vo cv wcel vx cv cX vy cv csn cdif wcel vy cv vo cv wcel wn vy cv
      cX vy cv csn cdif wcel wn vo cv cX vy cv csn cdif vx cv eleq2 vo cv cX vy
      cv csn cdif wceq vy cv vo cv wcel vy cv cX vy cv csn cdif wcel vo cv cX
      vy cv csn cdif vy cv eleq2 notbid anbi12d rcla4ev cJ ctop wcel vx cv cX
      wcel vy cv cX wcel w3a vy cv csn cJ ccld cfv wcel cX vy cv csn cdif cJ
      wcel vx cv vy cv wne cJ ctop wcel vx cv cX wcel vy cv csn cJ ccld cfv
      wcel cX vy cv csn cdif cJ wcel vy cv cX wcel vy cv csn cJ cX ist1-2.1
      cldopn 3ad2antl1 adantrr cJ ctop wcel vx cv cX wcel vy cv cX wcel w3a vy
      cv csn cJ ccld cfv wcel vx cv vy cv wne wa wa vx cv cX vy cv csn cdif
      wcel vy cv cX vy cv csn cdif wcel wn cJ ctop wcel vx cv cX wcel vy cv cX
      wcel w3a vy cv csn cJ ccld cfv wcel vx cv vy cv wne wa wa vx cv cX wcel
      vx cv vy cv csn wcel wn wa vx cv cX vy cv csn cdif wcel cJ ctop wcel vx
      cv cX wcel vy cv cX wcel w3a vy cv csn cJ ccld cfv wcel vx cv vy cv wne
      wa wa vx cv cX wcel vx cv vy cv csn wcel wn cJ ctop wcel vx cv cX wcel vy
      cv cX wcel vy cv csn cJ ccld cfv wcel vx cv vy cv wne wa 3simpl2 vx cv vy
      cv wne vx cv vy cv csn wcel wn cJ ctop wcel vx cv cX wcel vy cv cX wcel
      w3a vy cv csn cJ ccld cfv wcel vx cv vy cv csn wcel vx cv vy cv vx cv vy
      cv elsni necon3ai ad2antll jca vx cv cX vy cv csn eldif sylibr vy cv vy
      cv csn wcel vy cv cX vy cv csn cdif wcel wn vy cv vy visset snid vy cv vy
      cv csn cX elndif ax-mp jctir sylanc exp32 syld 3expib com23 r19.21advv cJ
      ctop wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ
      wrex wi vy cX wral vx cX wral vz cv csn cJ ccld cfv wcel vz cX cJ ctop
      wcel vz cv cX wcel wa vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel
      wn wa vo cJ wrex wi vy cX wral vx cX wral vz cv csn cX wss cX vz cv csn
      cdif cJ wcel wa vz cv csn cJ ccld cfv wcel cJ ctop wcel vz cv cX wcel wa
      vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy
      cX wral vx cX wral cX vz cv csn cdif cJ wcel vz cv csn cX wss cJ ctop
      wcel vz cv cX wcel wa vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel
      wn wa vo cJ wrex wi vy cX wral vx cX wral cX vz cv csn cdif cJ cuni wss
      vw cv vo cv wcel vo cv cX vz cv csn cdif wss wa vo cJ wrex vw cX vz cv
      csn cdif wral wa cX vz cv csn cdif cJ wcel cJ ctop wcel vz cv cX wcel wa
      vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy
      cX wral vx cX wral vw cv vo cv wcel vo cv cX vz cv csn cdif wss wa vo cJ
      wrex vw cX vz cv csn cdif wral cX vz cv csn cdif cJ cuni wss cJ ctop wcel
      vz cv cX wcel wa vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa
      vo cJ wrex wi vy cX wral vx cX wral vw cv vo cv wcel vo cv cX vz cv csn
      cdif wss wa vo cJ wrex vw cX vz cv csn cdif cJ ctop wcel vz cv cX wcel wa
      vw cv cX vz cv csn cdif wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv
      wcel wn wa vo cJ wrex wi vy cX wral vx cX wral vw cv vo cv wcel vo cv cX
      vz cv csn cdif wss wa vo cJ wrex cJ ctop wcel vz cv cX wcel vw cv cX vz
      cv csn cdif wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa
      vo cJ wrex wi vy cX wral vx cX wral vw cv vo cv wcel vo cv cX vz cv csn
      cdif wss wa vo cJ wrex wi cJ ctop wcel vz cv cX wcel vw cv cX vz cv csn
      cdif wcel w3a vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo
      cJ wrex wi vy cX wral vx cX wral vw cv vo cv wcel vz cv vo cv wcel wn wa
      vo cJ wrex vw cv vo cv wcel vo cv cX vz cv csn cdif wss wa vo cJ wrex cJ
      ctop wcel vz cv cX wcel vw cv cX vz cv csn cdif wcel w3a vx cv vy cv wne
      vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy cX wral vx cX
      wral vw cv vz cv wne vw cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex
      vw cv cX vz cv csn cdif wcel cJ ctop wcel vw cv vz cv wne vz cv cX wcel
      vw cv cX vz cv csn cdif wcel vw cv vz cv csn wcel wn vw cv vz cv wne vw
      cv cX vz cv csn eldifn vw cv vz cv csn wcel vw cv vz cv vw vz cv elsn
      necon3bbii sylib 3ad2ant3 vw cv cX wcel vz cv cX wcel vx cv vy cv wne vx
      cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy cX wral vx cX wral
      vw cv vz cv wne vw cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi wi
      cJ ctop wcel vz cv cX wcel vw cv cX vz cv csn cdif wcel w3a vx cv vy cv
      wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vw cv vz cv wne
      vw cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vw cv vy cv wne vw
      cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vx vy vw cv vz cv cX
      cX vx cv vw cv wceq vx cv vy cv wne vw cv vy cv wne vx cv vo cv wcel vy
      cv vo cv wcel wn wa vo cJ wrex vw cv vo cv wcel vy cv vo cv wcel wn wa vo
      cJ wrex vx cv vw cv vy cv neeq1 vx cv vw cv wceq vx cv vo cv wcel vy cv
      vo cv wcel wn wa vw cv vo cv wcel vy cv vo cv wcel wn wa vo cJ vx cv vw
      cv wceq vx cv vo cv wcel vw cv vo cv wcel vy cv vo cv wcel wn vx vw vo
      elequ1 anbi1d rexbidv imbi12d vy cv vz cv wceq vw cv vy cv wne vw cv vz
      cv wne vw cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex vw cv vo cv
      wcel vz cv vo cv wcel wn wa vo cJ wrex vy cv vz cv vw cv neeq2 vy cv vz
      cv wceq vw cv vo cv wcel vy cv vo cv wcel wn wa vw cv vo cv wcel vz cv vo
      cv wcel wn wa vo cJ vy cv vz cv wceq vy cv vo cv wcel wn vz cv vo cv wcel
      wn vw cv vo cv wcel vy cv vz cv wceq vy cv vo cv wcel vz cv vo cv wcel vy
      vz vo elequ1 notbid anbi2d rexbidv imbi12d rcla42v vw cv cX vz cv csn
      cdif wcel cJ ctop wcel vw cv cX wcel vz cv cX wcel vw cv cX vz cv csn
      eldifi 3ad2ant3 cJ ctop wcel vz cv cX wcel vw cv cX vz cv csn cdif wcel
      3simp2 sylanc mpid cJ ctop wcel vz cv cX wcel vw cv cX vz cv csn cdif
      wcel w3a vw cv vo cv wcel vz cv vo cv wcel wn wa vw cv vo cv wcel vo cv
      cX vz cv csn cdif wss wa vo cJ cJ ctop wcel vz cv cX wcel vw cv cX vz cv
      csn cdif wcel w3a vo cv cJ wcel wa vz cv vo cv wcel wn vo cv cX vz cv csn
      cdif wss vw cv vo cv wcel cJ ctop wcel vz cv cX wcel vw cv cX vz cv csn
      cdif wcel w3a vo cv cJ wcel wa vo cv vz cv csn cin c0 wceq vo cv cX vz cv
      csn cdif wss vz cv vo cv wcel wn cJ ctop wcel vz cv cX wcel vo cv cJ wcel
      vo cv vz cv csn cin c0 wceq vo cv cX vz cv csn cdif wss wi vw cv cX vz cv
      csn cdif wcel cJ ctop wcel vo cv cJ wcel wa vo cv cX wss vo cv vz cv csn
      cin c0 wceq vo cv cX vz cv csn cdif wss wi vo cv cJ cX ist1-2.1 eltopss
      vo cv cX wss vo cv vz cv csn cin c0 wceq vo cv cX vz cv csn cdif wss vo
      cv vz cv csn cX reldisj biimpd syl 3ad2antl1 vo cv vz cv disjsn syl5ibr
      anim2d r19.22dva syld 3expia com23 r19.21adv cX vz cv csn cdif cJ cuni
      wss cJ ctop wcel vz cv cX wcel wa cX vz cv csn cdif cX cJ cuni cX vz cv
      csn difss ist1-2.1 sseqtri a1i jctild cJ ctop wcel cX vz cv csn cdif cJ
      wcel cX vz cv csn cdif cJ cuni wss vw cv vo cv wcel vo cv cX vz cv csn
      cdif wss wa vo cJ wrex vw cX vz cv csn cdif wral wa wb vz cv cX wcel vw
      vo cX vz cv csn cdif cJ eltop2 adantr sylibrd vz cv cX wcel vz cv csn cX
      wss cJ ctop wcel vz cv cX snssi adantl jctild cJ ctop wcel vz cv csn cJ
      ccld cfv wcel vz cv csn cX wss cX vz cv csn cdif cJ wcel wa wb vz cv cX
      wcel vz cv csn cJ cX ist1-2.1 iscld adantr sylibrd r19.21adva impbid
      bitrd $.
      $( [31-Jan-2010] $) $( [31-Jan-2010] $)
  $}

  ${
    $d o w x y z J $. $d o w x y z X $.
    ist1-3.1 $e |- X = U. J $.
    $( A space is T1 iff every point is the only point in the intersection of
       all open sets containing that point. $)
    ist1-3 $p |- ( J e. Top -> ( J e. Fre <-> A. x e. X |^| { o e. J | x e. o }
    = { x } ) ) $=
      cJ ctop wcel cJ ct1 wcel vy cv vz cv wne vy cv vo cv wcel vz cv vo cv
      wcel wn wa vo cJ wrex wi vz cX wral vy cX wral vx cv vo cv wcel vo cJ
      crab cint vx cv csn wceq vx cX wral vy vz vo cJ cX ist1-3.1 ist1-2 cJ
      ctop wcel vy cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ
      wrex wi vz cX wral vy cX wral vx cv vo cv wcel vo cJ crab cint vx cv csn
      wceq vx cX wral cJ ctop wcel vy cv vz cv wne vy cv vo cv wcel vz cv vo cv
      wcel wn wa vo cJ wrex wi vz cX wral vy cX wral vx cv vo cv wcel vo cJ
      crab cint vx cv csn wceq vx cX cJ ctop wcel vx cv cX wcel vy cv vz cv wne
      vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX
      wral vx cv vo cv wcel vo cJ crab cint vx cv csn wceq cJ ctop wcel vx cv
      cX wcel vy cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ
      wrex wi vz cX wral vy cX wral vx cv vo cv wcel vo cJ crab cint vx cv csn
      wceq cJ ctop wcel vx cv cX wcel wa vy cv vz cv wne vy cv vo cv wcel vz cv
      vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral wa vx cv vo cv wcel
      vo cJ crab cint vx cv csn cJ ctop wcel vx cv cX wcel wa vy cv vz cv wne
      vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX
      wral wa vw vx cv vo cv wcel vo cJ crab cint vx cv csn cJ ctop wcel vx cv
      cX wcel wa vy cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ
      wrex wi vz cX wral vy cX wral wa vw cv vx cv vo cv wcel vo cJ crab cint
      wcel vw cv vx cv wceq vw cv vx cv csn wcel cJ ctop wcel vx cv cX wcel wa
      vy cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz
      cX wral vy cX wral wa vw cv vx cv vo cv wcel vo cJ crab cint wcel vw cv
      vx cv cJ ctop wcel vx cv cX wcel wa vy cv vz cv wne vy cv vo cv wcel vz
      cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral wa vw cv vx cv
      wne vx cv vo cv wcel vw cv vo cv wcel wn wa vo cJ wrex vw cv vx cv vo cv
      wcel vo cJ crab cint wcel wn cJ ctop wcel vx cv cX wcel wa vy cv vz cv
      wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy
      cX wral wa vw cv cX wcel vw cv vx cv wne vx cv vo cv wcel vw cv vo cv
      wcel wn wa vo cJ wrex wi cJ ctop wcel vx cv cX wcel wa vy cv vz cv wne vy
      cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral
      vw cv cX wcel vw cv vx cv wne vx cv vo cv wcel vw cv vo cv wcel wn wa vo
      cJ wrex wi wi cJ ctop wcel vx cv cX wcel wa vw cv cX wcel vy cv vz cv wne
      vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX
      wral vw cv vx cv wne vx cv vo cv wcel vw cv vo cv wcel wn wa vo cJ wrex
      wi vx cv cX wcel vw cv cX wcel vy cv vz cv wne vy cv vo cv wcel vz cv vo
      cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral vw cv vx cv wne vx cv
      vo cv wcel vw cv vo cv wcel wn wa vo cJ wrex wi wi wi cJ ctop wcel vx cv
      cX wcel vw cv cX wcel vy cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel
      wn wa vo cJ wrex wi vz cX wral vy cX wral vw cv vx cv wne vx cv vo cv
      wcel vw cv vo cv wcel wn wa vo cJ wrex wi wi vx cv cX wcel vw cv cX wcel
      wa vy cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi
      vz cX wral vy cX wral vx cv vw cv wne vx cv vo cv wcel vw cv vo cv wcel
      wn wa vo cJ wrex vw cv vx cv wne vy cv vz cv wne vy cv vo cv wcel vz cv
      vo cv wcel wn wa vo cJ wrex wi vx cv vw cv wne vx cv vo cv wcel vw cv vo
      cv wcel wn wa vo cJ wrex wi vx cv vz cv wne vx cv vo cv wcel vz cv vo cv
      wcel wn wa vo cJ wrex wi vy vz vx cv vw cv cX cX vy cv vx cv wceq vy cv
      vz cv wne vx cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ
      wrex vx cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex vy cv vx cv vz cv
      neeq1 vy cv vx cv wceq vy cv vo cv wcel vz cv vo cv wcel wn wa vx cv vo
      cv wcel vz cv vo cv wcel wn wa vo cJ vy cv vx cv wceq vy cv vo cv wcel vx
      cv vo cv wcel vz cv vo cv wcel wn vy cv vx cv vo cv eleq1 anbi1d rexbidv
      imbi12d vz cv vw cv wceq vx cv vz cv wne vx cv vw cv wne vx cv vo cv wcel
      vz cv vo cv wcel wn wa vo cJ wrex vx cv vo cv wcel vw cv vo cv wcel wn wa
      vo cJ wrex vz cv vw cv vx cv neeq2 vz cv vw cv wceq vx cv vo cv wcel vz
      cv vo cv wcel wn wa vx cv vo cv wcel vw cv vo cv wcel wn wa vo cJ vz cv
      vw cv wceq vz cv vo cv wcel wn vw cv vo cv wcel wn vx cv vo cv wcel vz cv
      vw cv wceq vz cv vo cv wcel vw cv vo cv wcel vz cv vw cv vo cv eleq1
      notbid anbi2d rexbidv imbi12d rcla42v vw cv vx cv necom syl7ib ex adantl
      com23 imp cJ ctop wcel vx cv cX wcel wa vy cv vz cv wne vy cv vo cv wcel
      vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral wa vw cv cX
      wcel wn vx cv vo cv wcel vw cv vo cv wcel wn wa vo cJ wrex vw cv vx cv
      wne cJ ctop wcel vx cv cX wcel wa vw cv cX wcel wn vx cv vo cv wcel vw cv
      vo cv wcel wn wa vo cJ wrex wi vy cv vz cv wne vy cv vo cv wcel vz cv vo
      cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral cJ ctop wcel vx cv cX
      wcel vw cv cX wcel wn vx cv vo cv wcel vw cv vo cv wcel wn wa vo cJ wrex
      cX cJ wcel vx cv cX wcel vw cv cX wcel wn wa vx cv vo cv wcel vw cv vo cv
      wcel wn wa vo cJ wrex cJ ctop wcel vx cv cX wcel vw cv cX wcel wn w3a vx
      cv vo cv wcel vw cv vo cv wcel wn wa vx cv cX wcel vw cv cX wcel wn wa vo
      cX cJ vo cv cX wceq vx cv vo cv wcel vx cv cX wcel vw cv vo cv wcel wn vw
      cv cX wcel wn vo cv cX vx cv eleq2 vo cv cX wceq vw cv vo cv wcel vw cv
      cX wcel vo cv cX vw cv eleq2 notbid anbi12d rcla4ev cJ ctop wcel vx cv cX
      wcel cX cJ wcel vw cv cX wcel wn cJ cX ist1-3.1 topopn 3ad2ant1 cJ ctop
      wcel vx cv cX wcel vw cv cX wcel wn 3simpc sylanc 3expia adantr a1dd
      pm2.61d vx cv vo cv wcel vw cv vo cv wcel wn wa vo cJ wrex vx cv vo cv
      wcel vw cv vo cv wcel wi vo cJ wral wn vw cv vx cv vo cv wcel vo cJ crab
      cint wcel wn vx cv vo cv wcel vw cv vo cv wcel vo cJ rexanali vw cv vx cv
      vo cv wcel vo cJ crab cint wcel vx cv vo cv wcel vw cv vo cv wcel wi vo
      cJ wral vx cv vo cv wcel vo vw cv cJ vw visset elintrab notbii bitr4i
      syl6ib necon4ad vw vx cv elsn syl6ibr ssrdv vx cv csn vx cv vo cv wcel vo
      cJ crab cint wss cJ ctop wcel vx cv cX wcel wa vy cv vz cv wne vy cv vo
      cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vz cX wral vy cX wral wa vo
      cv cJ wcel vx cv vo cv wcel wa vx cv csn vo cv wss wi vx cv csn vx cv vo
      cv wcel vo cJ crab cint wss vo vx cv csn vx cv vo cv wcel vo cJ crab cint
      wss vx cv csn vo cv cJ wcel vx cv vo cv wcel wa vo cab cint wss vo cv cJ
      wcel vx cv vo cv wcel wa vx cv csn vo cv wss wi vo wal vx cv vo cv wcel
      vo cJ crab cint vo cv cJ wcel vx cv vo cv wcel wa vo cab cint vx cv csn
      vx cv vo cv wcel vo cJ crab vo cv cJ wcel vx cv vo cv wcel wa vo cab vx
      cv vo cv wcel vo cJ df-rab inteqi sseq2i vo cv cJ wcel vx cv vo cv wcel
      wa vo vx cv csn ssintab bitr2i vx cv vo cv wcel vx cv csn vo cv wss vo cv
      cJ wcel vx cv vo cv snssi adantl mpgbi a1i eqssd exp31 com23 r19.21adv cJ
      ctop wcel vx cv vo cv wcel vo cJ crab cint vx cv csn wceq vx cX wral vy
      cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vy vz
      cX cX cJ ctop wcel vy cv cX wcel vz cv cX wcel wa vx cv vo cv wcel vo cJ
      crab cint vx cv csn wceq vx cX wral vy cv vz cv wne vy cv vo cv wcel vz
      cv vo cv wcel wn wa vo cJ wrex wi cJ ctop wcel vy cv cX wcel vz cv cX
      wcel vx cv vo cv wcel vo cJ crab cint vx cv csn wceq vx cX wral vy cv vz
      cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi wi cJ ctop
      wcel vy cv cX wcel vz cv cX wcel w3a vx cv vo cv wcel vo cJ crab cint vx
      cv csn wceq vx cX wral vy cv vo cv wcel vo cJ crab cint vy cv csn wceq vy
      cv vz cv wne vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex wi vy cv
      cX wcel cJ ctop wcel vx cv vo cv wcel vo cJ crab cint vx cv csn wceq vx
      cX wral vy cv vo cv wcel vo cJ crab cint vy cv csn wceq wi vz cv cX wcel
      vx cv vo cv wcel vo cJ crab cint vx cv csn wceq vy cv vo cv wcel vo cJ
      crab cint vy cv csn wceq vx vy cv cX vx cv vy cv wceq vx cv vo cv wcel vo
      cJ crab cint vy cv vo cv wcel vo cJ crab cint vx cv csn vy cv csn vx cv
      vy cv wceq vx cv vo cv wcel vo cJ crab vy cv vo cv wcel vo cJ crab vx cv
      vy cv wceq vx cv vo cv wcel vy cv vo cv wcel vo cJ vx cv vy cv vo cv
      eleq1 rabbisdv inteqd vx cv vy cv sneq eqeq12d rcla4v 3ad2ant2 vy cv vo
      cv wcel vo cJ crab cint vy cv csn wceq vy cv vz cv wne vz cv vy cv vo cv
      wcel vo cJ crab cint wcel wn cJ ctop wcel vy cv cX wcel vz cv cX wcel w3a
      vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex vy cv vo cv wcel vo cJ
      crab cint vy cv csn wceq vz cv vy cv vo cv wcel vo cJ crab cint wcel wn
      vz cv vy cv csn wcel wn vy cv vz cv wne vy cv vo cv wcel vo cJ crab cint
      vy cv csn wceq vz cv vy cv vo cv wcel vo cJ crab cint wcel vz cv vy cv
      csn wcel vy cv vo cv wcel vo cJ crab cint vy cv csn vz cv eleq2 notbid vz
      cv vy cv csn wcel vy cv vz cv vz cv vy cv csn wcel vz cv vy cv vz cv vy
      cv elsni eqcomd necon3ai syl5bir cJ ctop wcel vy cv cX wcel vz cv cX wcel
      w3a vy cv vo cv wcel vz cv vo cv wcel wn wa vo cJ wrex vy cv vo cv wcel
      vz cv vo cv wcel wn wa vo cJ wrex vz cv vy cv vo cv wcel vo cJ crab cint
      wcel wn cJ ctop wcel vy cv cX wcel vz cv cX wcel w3a vy cv vo cv wcel vz
      cv vo cv wcel wn wa vo cJ wrex idd vz cv vy cv vo cv wcel vo cJ crab cint
      wcel wn vy cv vo cv wcel vz cv vo cv wcel wi vo cJ wral wn vy cv vo cv
      wcel vz cv vo cv wcel wn wa vo cJ wrex vz cv vy cv vo cv wcel vo cJ crab
      cint wcel vy cv vo cv wcel vz cv vo cv wcel wi vo cJ wral vy cv vo cv
      wcel vo vz cv cJ vz visset elintrab notbii vy cv vo cv wcel vz cv vo cv
      wcel vo cJ rexanali bitr4i syl5ib syl9r syld 3expib com23 r19.21advv
      impbid bitrd $.
      $( [31-Jan-2010] $) $( [31-Jan-2010] $)
  $}

  ${
    $d x J $.
    $( A T1 space is a topological space. $)
    t1top $p |- ( J e. Fre -> J e. Top ) $=
      cJ ct1 wcel cJ ctop wcel vx cv csn cJ ccld cfv wcel vx cJ cuni wral cJ cJ
      cuni vx cJ cuni eqid ist1 pm3.26bi $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d x A $. $d x J $. $d x X $.
    t1sncld.1 $e |- X = U. J $.
    $( In a T1 space, one-point sets are closed. $)
    t1sncld $p |- ( ( J e. Fre /\ A e. X ) -> { A } e. ( Clsd ` J ) ) $=
      cJ ct1 wcel cA cX wcel cA csn cJ ccld cfv wcel cJ ct1 wcel vx cv csn cJ
      ccld cfv wcel vx cX wral cA cX wcel cA csn cJ ccld cfv wcel wi cJ ct1
      wcel cJ ctop wcel vx cv csn cJ ccld cfv wcel vx cX wral cJ cX vx
      t1sncld.1 ist1 pm3.27bi vx cv csn cJ ccld cfv wcel cA csn cJ ccld cfv
      wcel vx cA cX vx cv cA wceq vx cv csn cA csn cJ ccld cfv vx cv cA sneq
      eleq1d rcla4cv syl imp $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d o x y A $. $d o x y B $. $d o x y J $. $d o x y X $.
    t1sep.1 $e |- X = U. J $.
    $( Any two distinct points in a T1 space are separated by an open set. $)
    t1sep $p |- ( ( J e. Fre /\ ( A e. X /\ B e. X /\ A =/= B ) ) -> E. o e. J
    ( A e. o /\ -. B e. o ) ) $=
      cJ ct1 wcel cA cX wcel cB cX wcel cA cB wne w3a cA vo cv wcel cB vo cv
      wcel wn wa vo cJ wrex cJ ct1 wcel vx cv vy cv wne vx cv vo cv wcel vy cv
      vo cv wcel wn wa vo cJ wrex wi vy cX wral vx cX wral cA cX wcel cB cX
      wcel cA cB wne w3a cA vo cv wcel cB vo cv wcel wn wa vo cJ wrex wi cJ
      ctop wcel cJ ct1 wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel
      wn wa vo cJ wrex wi vy cX wral vx cX wral cJ t1top cJ ctop wcel cJ ct1
      wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex
      wi vy cX wral vx cX wral vx vy vo cJ cX t1sep.1 ist1-2 biimpd mpcom vx cv
      vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy cX
      wral vx cX wral cA cX wcel cB cX wcel cA cB wne cA vo cv wcel cB vo cv
      wcel wn wa vo cJ wrex vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel
      wn wa vo cJ wrex wi vy cX wral vx cX wral cA cX wcel cB cX wcel cA cB wne
      cA vo cv wcel cB vo cv wcel wn wa vo cJ wrex wi cA cX wcel cB cX wcel wa
      vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vy
      cX wral vx cX wral cA cB wne cA vo cv wcel cB vo cv wcel wn wa vo cJ wrex
      wi vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi
      cA cB wne cA vo cv wcel cB vo cv wcel wn wa vo cJ wrex wi cA vy cv wne cA
      vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex wi vx vy cA cB cX cX vx cv
      cA wceq vx cv vy cv wne cA vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn
      wa vo cJ wrex cA vo cv wcel vy cv vo cv wcel wn wa vo cJ wrex vx cv cA vy
      cv neeq1 vx cv cA wceq vx cv vo cv wcel vy cv vo cv wcel wn wa cA vo cv
      wcel vy cv vo cv wcel wn wa vo cJ vx cv cA wceq vx cv vo cv wcel cA vo cv
      wcel vy cv vo cv wcel wn vx cv cA vo cv eleq1 anbi1d rexbidv imbi12d vy
      cv cB wceq cA vy cv wne cA cB wne cA vo cv wcel vy cv vo cv wcel wn wa vo
      cJ wrex cA vo cv wcel cB vo cv wcel wn wa vo cJ wrex vy cv cB cA neeq2 vy
      cv cB wceq cA vo cv wcel vy cv vo cv wcel wn wa cA vo cv wcel cB vo cv
      wcel wn wa vo cJ vy cv cB wceq vy cv vo cv wcel wn cB vo cv wcel wn cA vo
      cv wcel vy cv cB wceq vy cv vo cv wcel cB vo cv wcel vy cv cB vo cv eleq1
      notbid anbi2d rexbidv imbi12d rcla42v com12 exp3a 3impd syl imp $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d o x y J $.
    $( A T1 space is a T0 space. $)
    t1t0 $p |- ( J e. Fre -> J e. Kol2 ) $=
      cJ ct1 wcel cJ ct0ALT wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv
      wcel wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo vo cJ wrex wi vy cJ
      cuni wral vx cJ cuni wral cJ ct1 wcel vx cv vy cv wne vx cv vo cv wcel vy
      cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo vo cJ wrex
      wi vx vy cJ cuni cJ cuni cJ ct1 wcel vx cv cJ cuni wcel vy cv cJ cuni
      wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel wn wa vx cv vo cv
      wcel wn vy cv vo cv wcel wa wo vo cJ wrex wi cJ ct1 wcel vx cv cJ cuni
      wcel vy cv cJ cuni wcel vx cv vy cv wne vx cv vo cv wcel vy cv vo cv wcel
      wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo vo cJ wrex cJ ct1 wcel
      vx cv cJ cuni wcel vy cv cJ cuni wcel vx cv vy cv wne w3a wa vx cv vo cv
      wcel vy cv vo cv wcel wn wa vo cJ wrex vx cv vo cv wcel vy cv vo cv wcel
      wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo vo cJ wrex vx cv vy cv
      vo cJ cJ cuni cJ cuni eqid t1sep vx cv vo cv wcel vy cv vo cv wcel wn wa
      vx cv vo cv wcel vy cv vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv
      wcel wa wo vo cJ vx cv vo cv wcel vy cv vo cv wcel wn wa vx cv vo cv wcel
      wn vy cv vo cv wcel wa orc r19.22si syl 3exp2 imp3a r19.21aivv cJ ct1
      wcel cJ ctop wcel cJ ct0ALT wcel vx cv vy cv wne vx cv vo cv wcel vy cv
      vo cv wcel wn wa vx cv vo cv wcel wn vy cv vo cv wcel wa wo vo cJ wrex wi
      vy cJ cuni wral vx cJ cuni wral wb cJ t1top vx vy vo cJ cJ cuni cJ cuni
      eqid ist0-2 syl mpbird $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c j o p x J $. $d c j o p x X $.
    isreg.1 $e |- X = U. J $.
    $( The predicate "is a regular space."  In a regular space, any closed set
       is separated from any point not in it by neighborhoods.  Note that some
       authors require the space to be Hausdorff (which would make it the same
       as T3), but we reserve the phrase "regular Hausdorff" for that as many
       topologists do.  $)
    isreg $p |- ( J e. Reg <-> ( J e. Top /\ A. c e. ( Clsd ` J ) A. x e. X ( x
    e/ c -> E. o e. J E. p e. J ( c C_ o /\ x e. p /\ ( o i^i p ) = (/) ) ) ) )
    $=
      vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq
      w3a vp vj cv wrex vo vj cv wrex wi vx vj cv cuni wral vc vj cv ccld cfv
      wral vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0
      wceq w3a vp cJ wrex vo cJ wrex wi vx cX wral vc cJ ccld cfv wral vj cJ
      ctop creg vj cv cJ wceq vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel
      vo cv vp cv cin c0 wceq w3a vp vj cv wrex vo vj cv wrex wi vx vj cv cuni
      wral vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0
      wceq w3a vp cJ wrex vo cJ wrex wi vx cX wral vc vj cv ccld cfv cJ ccld
      cfv vj cv cJ ccld fveq2 vj cv cJ wceq vx cv vc cv wnel vc cv vo cv wss vx
      cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp vj cv wrex vo vj cv wrex wi
      vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq
      w3a vp cJ wrex vo cJ wrex wi vx vj cv cuni cX vj cv cJ wceq vj cv cuni cJ
      cuni cX vj cv cJ unieq isreg.1 syl6eqr vj cv cJ wceq vc cv vo cv wss vx
      cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp vj cv wrex vo vj cv wrex vc
      cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo
      cJ wrex vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin
      c0 wceq w3a vp vj cv wrex vc cv vo cv wss vx cv vp cv wcel vo cv vp cv
      cin c0 wceq w3a vp cJ wrex vo vj cv cJ vc cv vo cv wss vx cv vp cv wcel
      vo cv vp cv cin c0 wceq w3a vp vj cv cJ rexeq1 rexeqd imbi2d raleq12d
      raleq12d vx vj vo vp vc df-reg elrab2 $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c o p x J $.
    $( A regular space is a topological space. $)
    regtop $p |- ( J e. Reg -> J e. Top ) $=
      cJ creg wcel cJ ctop wcel vx cv vc cv wnel vc cv vo cv wss vx cv vp cv
      wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vx cJ cuni wral
      vc cJ ccld cfv wral vx vo cJ cJ cuni vp vc cJ cuni eqid isreg pm3.26bi $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c o p x A $. $d c o p x C $. $d c o p x J $. $d c o p x X $.
    regsep.1 $e |- X = U. J $.
    $( In a regular space, a closed set is separated by open sets from a point
       not in it. $)
    regsep $p |- ( ( J e. Reg /\ ( C e. ( Clsd ` J ) /\ A e. X /\ A e/ C ) ) ->
    E. o e. J E. p e. J ( C C_ o /\ A e. p /\ ( o i^i p ) = (/) ) ) $=
      cJ creg wcel cC cJ ccld cfv wcel cA cX wcel cA cC wnel w3a cC vo cv wss
      cA vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex cJ creg
      wcel vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0
      wceq w3a vp cJ wrex vo cJ wrex wi vx cX wral vc cJ ccld cfv wral cC cJ
      ccld cfv wcel cA cX wcel cA cC wnel w3a cC vo cv wss cA vp cv wcel vo cv
      vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi cJ creg wcel cJ ctop wcel
      vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq
      w3a vp cJ wrex vo cJ wrex wi vx cX wral vc cJ ccld cfv wral vx vo cJ cX
      vp vc regsep.1 isreg pm3.27bi vx cv vc cv wnel vc cv vo cv wss vx cv vp
      cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vx cX wral
      vc cJ ccld cfv wral cC cJ ccld cfv wcel cA cX wcel cA cC wnel cC vo cv
      wss cA vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex vx cv
      vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a
      vp cJ wrex vo cJ wrex wi vx cX wral vc cJ ccld cfv wral cC cJ ccld cfv
      wcel cA cX wcel cA cC wnel cC vo cv wss cA vp cv wcel vo cv vp cv cin c0
      wceq w3a vp cJ wrex vo cJ wrex wi cC cJ ccld cfv wcel cA cX wcel wa vx cv
      vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a
      vp cJ wrex vo cJ wrex wi vx cX wral vc cJ ccld cfv wral cA cC wnel cC vo
      cv wss cA vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi
      vx cv vc cv wnel vc cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq
      w3a vp cJ wrex vo cJ wrex wi cA cC wnel cC vo cv wss cA vp cv wcel vo cv
      vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vx cv cC wnel cC vo cv wss
      vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vc
      vx cC cA cJ ccld cfv cX vc cv cC wceq vx cv vc cv wnel vx cv cC wnel vc
      cv vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo
      cJ wrex cC vo cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ
      wrex vo cJ wrex vc cv cC vx cv neleq2 vc cv cC wceq vc cv vo cv wss vx cv
      vp cv wcel vo cv vp cv cin c0 wceq w3a cC vo cv wss vx cv vp cv wcel vo
      cv vp cv cin c0 wceq w3a vo vp cJ cJ vc cv cC wceq vc cv vo cv wss cC vo
      cv wss vx cv vp cv wcel vo cv vp cv cin c0 wceq vc cv cC vo cv sseq1
      3anbi1d 2rexbidv imbi12d vx cv cA wceq vx cv cC wnel cA cC wnel cC vo cv
      wss vx cv vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex cC
      vo cv wss cA vp cv wcel vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex
      vx cv cA cC neleq1 vx cv cA wceq cC vo cv wss vx cv vp cv wcel vo cv vp
      cv cin c0 wceq w3a cC vo cv wss cA vp cv wcel vo cv vp cv cin c0 wceq w3a
      vo vp cJ cJ vx cv cA wceq vx cv vp cv wcel cA vp cv wcel cC vo cv wss vo
      cv vp cv cin c0 wceq vx cv cA vp cv eleq1 3anbi2d 2rexbidv imbi12d
      rcla42v com12 exp3a 3impd syl imp $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c d j o p J $.
    $( The predicate "is a normal space." Much like the case for regular
       spaces, normal does not imply Hausdorff or even regular. $)
    isnrm $p |- ( J e. Nrm <-> ( J e. Top /\ A. c e. ( Clsd ` J ) A. d e. (
    Clsd ` J ) ( ( c i^i d ) = (/) -> E. o e. J E. p e. J ( c C_ o /\ d C_ p /\
    ( o i^i p ) = (/) ) ) ) ) $=
      vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin
      c0 wceq w3a vp vj cv wrex vo vj cv wrex wi vd vj cv ccld cfv wral vc vj
      cv ccld cfv wral vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss
      vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld cfv wral
      vc cJ ccld cfv wral vj cJ ctop cnrm vj cv cJ wceq vc cv vd cv cin c0 wceq
      vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp vj cv wrex
      vo vj cv wrex wi vd vj cv ccld cfv wral vc cv vd cv cin c0 wceq vc cv vo
      cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex
      wi vd cJ ccld cfv wral vc vj cv ccld cfv cJ ccld cfv vj cv cJ ccld fveq2
      vj cv cJ wceq vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss vo
      cv vp cv cin c0 wceq w3a vp vj cv wrex vo vj cv wrex wi vc cv vd cv cin
      c0 wceq vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ
      wrex vo cJ wrex wi vd vj cv ccld cfv cJ ccld cfv vj cv cJ ccld fveq2 vj
      cv cJ wceq vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp
      vj cv wrex vo vj cv wrex vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin
      c0 wceq w3a vp cJ wrex vo cJ wrex vc cv vd cv cin c0 wceq vc cv vo cv wss
      vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp vj cv wrex vc cv vo cv wss
      vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo vj cv cJ vc cv
      vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp vj cv cJ rexeq1
      rexeqd imbi2d raleq12d raleq12d vj vo vp vc vd df-nrm elrab2 $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c d o p J $.
    $( An alternate characterization of normality. This is the important
       property in the proof of Urysohn's lemma. $)
    isnrm2 $p |- ( J e. Top -> ( J e. Nrm <-> A. c e. ( Clsd ` J ) A. d e. (
    Clsd ` J ) ( ( c i^i d ) = (/) -> E. o e. J ( c C_ o /\ ( ( ( cls ` J ) ` o
    ) i^i d ) = (/) ) ) ) ) $=
      cJ ctop wcel cJ cnrm wcel vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv
      vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld
      cfv wral vc cJ ccld cfv wral vc cv vd cv cin c0 wceq vc cv vo cv wss vo
      cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex wi vd cJ ccld cfv wral
      vc cJ ccld cfv wral cJ cnrm wcel cJ ctop wcel vc cv vd cv cin c0 wceq vc
      cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ
      wrex wi vd cJ ccld cfv wral vc cJ ccld cfv wral vo cJ vp vc vd isnrm baib
      cJ ctop wcel vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss vo
      cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld cfv wral vc
      cv vd cv cin c0 wceq vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0
      wceq wa vo cJ wrex wi vd cJ ccld cfv wral vc cJ ccld cfv cJ ctop wcel vc
      cv cJ ccld cfv wcel wa vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp
      cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vc cv vd cv
      cin c0 wceq vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo
      cJ wrex wi vd cJ ccld cfv cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ
      ccld cfv wcel wa vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss
      vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex vc cv vo cv wss vo cv
      cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex cJ ctop wcel vc cv cJ ccld
      cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq vc cv vo cv
      wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex vc
      cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex wb cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq
      w3a vp cJ wrex vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa
      vo cJ cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv
      vd cv cin c0 wceq wa wa vo cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss
      vo cv vp cv cin c0 wceq w3a vp cJ wrex vc cv vo cv wss vo cv cJ ccl cfv
      cfv vd cv cin c0 wceq wa cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ
      ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel wa vc cv vo cv
      wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vc cv vo cv wss vo cv cJ
      ccl cfv cfv vd cv cin c0 wceq wa vp cJ cJ ctop wcel vc cv cJ ccld cfv
      wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ
      wcel vp cv cJ wcel vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0
      wceq w3a vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa wi cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp
      cv wss vo cv vp cv cin c0 wceq w3a vc cv vo cv wss vo cv cJ ccl cfv cfv
      vd cv cin c0 wceq wa cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld
      cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc
      cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa wa vc cv vo
      cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv
      wss vo cv vp cv cin c0 wceq w3a vc cv vo cv wss cJ ctop wcel vc cv cJ
      ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo
      cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv
      cin c0 wceq 3simp1 ad2antll cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv
      cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ
      wcel wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa wa
      vd cv vo cv cJ ccl cfv cfv cin c0 vo cv cJ ccl cfv cfv vd cv cin cJ ctop
      wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0
      wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss
      vo cv vp cv cin c0 wceq w3a wa wa vd cv vo cv cJ ccl cfv cfv cin c0 wceq
      vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss cJ ctop wcel vc cv cJ ccld
      cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ
      wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0
      wceq w3a wa wa vd cv cJ cuni vo cv cdif cJ cnt cfv cfv cJ cuni vo cv cJ
      ccl cfv cfv cdif cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv
      wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv
      vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa wa vd cv vp cv
      cJ cuni vo cv cdif cJ cnt cfv cfv vc cv vo cv wss vd cv vp cv wss vo cv
      vp cv cin c0 wceq w3a vd cv vp cv wss cJ ctop wcel vc cv cJ ccld cfv wcel
      wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp
      cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq
      3simp2 ad2antll cJ ctop wcel cJ cuni vo cv cdif cJ cuni wss vp cv cJ wcel
      vp cv cJ cuni vo cv cdif wss vp cv cJ cuni vo cv cdif cJ cnt cfv cfv wss
      cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp
      cv wss vo cv vp cv cin c0 wceq w3a wa wa cJ cuni vo cv cdif cJ vp cv cJ
      cuni cJ cuni eqid ssntr cJ ctop wcel vc cv cJ ccld cfv wcel vd cv cJ ccld
      cfv wcel vc cv vd cv cin c0 wceq wa vo cv cJ wcel vp cv cJ wcel wa vc cv
      vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa simplll cJ cuni
      vo cv cdif cJ cuni wss cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ
      ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel
      wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa wa cJ
      cuni vo cv difss a1i cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld
      cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel vc cv
      vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a simprlr cJ ctop
      wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0
      wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss
      vo cv vp cv cin c0 wceq w3a wa wa vp cv vo cv cin c0 wceq vp cv cJ cuni
      vo cv cdif wss vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq
      w3a vp cv vo cv cin c0 wceq cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv
      cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ
      wcel wa vo cv vp cv cin c0 wceq vc cv vo cv wss vp cv vo cv cin c0 wceq
      vd cv vp cv wss vo cv vp cv cin c0 wceq vp cv vo cv cin c0 wceq vo cv vp
      cv cin vp cv vo cv cin c0 vo cv vp cv incom eqeq1i biimpi 3ad2ant3
      ad2antll cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc
      cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss
      vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa wa vp cv cJ cuni wss vp cv
      vo cv cin c0 wceq vp cv cJ cuni vo cv cdif wss wb cJ ctop wcel vc cv cJ
      ccld cfv wcel wa vo cv cJ wcel vp cv cJ wcel wa vp cv cJ cuni wss vd cv
      cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa vc cv vo cv wss vd cv vp cv
      wss vo cv vp cv cin c0 wceq w3a cJ ctop wcel vp cv cJ wcel vp cv cJ cuni
      wss vc cv cJ ccld cfv wcel vo cv cJ wcel vp cv cJ cJ cuni cJ cuni eqid
      eltopss ad2ant2rl ad2ant2r vp cv vo cv cJ cuni reldisj syl mpbid syl2anc
      sstrd cJ ctop wcel vo cv cJ cuni wss cJ cuni vo cv cdif cJ cnt cfv cfv cJ
      cuni vo cv cJ ccl cfv cfv cdif wceq cJ ctop wcel vc cv cJ ccld cfv wcel
      wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vp
      cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a
      wa wa vo cv cJ cJ cuni cJ cuni eqid ntrcmp cJ ctop wcel vc cv cJ ccld cfv
      wcel vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa vo cv cJ wcel vp
      cv cJ wcel wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a
      wa simplll cJ ctop wcel vc cv cJ ccld cfv wcel wa vo cv cJ wcel vp cv cJ
      wcel wa vo cv cJ cuni wss vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq
      wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a cJ ctop
      wcel vo cv cJ wcel vo cv cJ cuni wss vc cv cJ ccld cfv wcel vp cv cJ wcel
      vo cv cJ cJ cuni cJ cuni eqid eltopss ad2ant2r ad2ant2r sylanc sseqtrd cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vo cv cJ wcel vp cv cJ wcel wa vc cv vo cv wss vd cv vp
      cv wss vo cv vp cv cin c0 wceq w3a wa wa vd cv cJ cuni wss vd cv vo cv cJ
      ccl cfv cfv cin c0 wceq vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss wb cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vd cv cJ cuni wss vo cv cJ wcel vp cv cJ wcel wa vc cv
      vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a wa cJ ctop wcel vd
      cv cJ ccld cfv wcel vd cv cJ cuni wss vc cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq vd cv cJ cJ cuni cJ cuni eqid cldss ad2ant2r adantr vd cv vo
      cv cJ ccl cfv cfv cJ cuni reldisj syl mpbird vo cv cJ ccl cfv cfv vd cv
      incom syl5eq jca expr expr r19.23adv cJ ctop wcel vc cv cJ ccld cfv wcel
      wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vc
      cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vc cv vo cv wss vd
      cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex cJ cuni vo cv cJ ccl
      cfv cfv cdif cJ wcel vc cv vo cv wss vd cv cJ cuni vo cv cJ ccl cfv cfv
      cdif wss vo cv cJ cuni vo cv cJ ccl cfv cfv cdif cin c0 wceq w3a vc cv vo
      cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex cJ ctop
      wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0
      wceq wa wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin
      c0 wceq wa wa wa vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq
      w3a vc cv vo cv wss vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss vo cv cJ
      cuni vo cv cJ ccl cfv cfv cdif cin c0 wceq w3a vp cJ cuni vo cv cJ ccl
      cfv cfv cdif cJ vp cv cJ cuni vo cv cJ ccl cfv cfv cdif wceq vd cv vp cv
      wss vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss vo cv vp cv cin c0 wceq
      vo cv cJ cuni vo cv cJ ccl cfv cfv cdif cin c0 wceq vc cv vo cv wss vp cv
      cJ cuni vo cv cJ ccl cfv cfv cdif vd cv sseq2 vp cv cJ cuni vo cv cJ ccl
      cfv cfv cdif wceq vo cv vp cv cin vo cv cJ cuni vo cv cJ ccl cfv cfv cdif
      cin c0 vp cv cJ cuni vo cv cJ ccl cfv cfv cdif vo cv ineq2 eqeq1d
      3anbi23d rcla4ev cJ ctop wcel vo cv cJ cuni wss cJ cuni vo cv cJ ccl cfv
      cfv cdif cJ wcel cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv
      wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vc cv vo cv wss vo cv cJ
      ccl cfv cfv vd cv cin c0 wceq wa wa wa vo cv cJ cJ cuni cJ cuni eqid
      cmclsopn cJ ctop wcel vc cv cJ ccld cfv wcel vd cv cJ ccld cfv wcel vc cv
      vd cv cin c0 wceq wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv
      vd cv cin c0 wceq wa wa simplll cJ ctop wcel vc cv cJ ccld cfv wcel wa vo
      cv cJ wcel vo cv cJ cuni wss vd cv cJ ccld cfv wcel vc cv vd cv cin c0
      wceq wa vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa cJ ctop
      wcel vo cv cJ wcel vo cv cJ cuni wss vc cv cJ ccld cfv wcel vo cv cJ cJ
      cuni cJ cuni eqid eltopss adantlr ad2ant2r sylanc cJ ctop wcel vc cv cJ
      ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo
      cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa wa
      wa vc cv vo cv wss vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss vo cv cJ
      cuni vo cv cJ ccl cfv cfv cdif cin c0 wceq cJ ctop wcel vc cv cJ ccld cfv
      wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ
      wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq simprrl cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd
      cv cin c0 wceq wa vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss cJ ctop
      wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0
      wceq wa wa vo cv cJ wcel wa vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv
      cin c0 wceq vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss cJ ctop wcel vc
      cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa
      wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq
      vd cv cJ cuni vo cv cJ ccl cfv cfv cdif wss wi cJ ctop wcel vc cv cJ ccld
      cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ
      wcel vc cv vo cv wss wa wa vo cv cJ ccl cfv cfv vd cv cin c0 wceq vd cv
      cJ cuni vo cv cJ ccl cfv cfv cdif wss cJ ctop wcel vc cv cJ ccld cfv wcel
      wa vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vc
      cv vo cv wss wa wa vd cv vo cv cJ ccl cfv cfv cin c0 wceq vd cv cJ cuni
      vo cv cJ ccl cfv cfv cdif wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vd cv vo cv cJ ccl cfv cfv cin c0 wceq vd cv cJ cuni vo
      cv cJ ccl cfv cfv cdif wss wb vo cv cJ wcel vc cv vo cv wss wa cJ ctop
      wcel vd cv cJ ccld cfv wcel vd cv vo cv cJ ccl cfv cfv cin c0 wceq vd cv
      cJ cuni vo cv cJ ccl cfv cfv cdif wss wb vc cv cJ ccld cfv wcel vc cv vd
      cv cin c0 wceq cJ ctop wcel vd cv cJ ccld cfv wcel wa vd cv cJ cuni wss
      vd cv vo cv cJ ccl cfv cfv cin c0 wceq vd cv cJ cuni vo cv cJ ccl cfv cfv
      cdif wss wb vd cv cJ cJ cuni cJ cuni eqid cldss vd cv vo cv cJ ccl cfv
      cfv cJ cuni reldisj syl ad2ant2r adantr vo cv cJ ccl cfv cfv vd cv cin vd
      cv vo cv cJ ccl cfv cfv cin c0 vo cv cJ ccl cfv cfv vd cv incom eqeq1i
      syl5bb biimpd expr imp3a impr cJ ctop wcel vc cv cJ ccld cfv wcel wa vd
      cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vc cv vo
      cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa wa wa vo cv cJ cuni vo
      cv cJ ccl cfv cfv cdif cin c0 wss vo cv cJ cuni vo cv cJ ccl cfv cfv cdif
      cin c0 wceq cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel
      vc cv vd cv cin c0 wceq wa wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl
      cfv cfv vd cv cin c0 wceq wa wa wa vo cv cJ cuni vo cv cJ ccl cfv cfv
      cdif cin vo cv cJ ccl cfv cfv cJ cuni vo cv cJ ccl cfv cfv cdif cin c0 cJ
      ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc cv vd cv
      cin c0 wceq wa wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd
      cv cin c0 wceq wa wa wa vo cv vo cv cJ ccl cfv cfv wss vo cv cJ cuni vo
      cv cJ ccl cfv cfv cdif cin vo cv cJ ccl cfv cfv cJ cuni vo cv cJ ccl cfv
      cfv cdif cin wss cJ ctop wcel vo cv cJ cuni wss vo cv vo cv cJ ccl cfv
      cfv wss cJ ctop wcel vc cv cJ ccld cfv wcel wa vd cv cJ ccld cfv wcel vc
      cv vd cv cin c0 wceq wa wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv
      cfv vd cv cin c0 wceq wa wa wa vo cv cJ cJ cuni cJ cuni eqid sscls cJ
      ctop wcel vc cv cJ ccld cfv wcel vd cv cJ ccld cfv wcel vc cv vd cv cin
      c0 wceq wa vo cv cJ wcel vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin
      c0 wceq wa wa simplll cJ ctop wcel vc cv cJ ccld cfv wcel wa vo cv cJ
      wcel vo cv cJ cuni wss vd cv cJ ccld cfv wcel vc cv vd cv cin c0 wceq wa
      vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa cJ ctop wcel vo
      cv cJ wcel vo cv cJ cuni wss vc cv cJ ccld cfv wcel vo cv cJ cJ cuni cJ
      cuni eqid eltopss adantlr ad2ant2r sylanc vo cv vo cv cJ ccl cfv cfv cJ
      cuni vo cv cJ ccl cfv cfv cdif ssrin syl vo cv cJ ccl cfv cfv cJ cuni
      difdisj syl6ss vo cv cJ cuni vo cv cJ ccl cfv cfv cdif cin ss0 syl 3jca
      sylanc expr impbid rexbidva expr pm5.74d ralbidva ralbidva bitrd $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c d o p J $.
    $( A normal space is a topological space. $)
    nrmtop $p |- ( J e. Nrm -> J e. Top ) $=
      cJ cnrm wcel cJ ctop wcel vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv
      vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld
      cfv wral vc cJ ccld cfv wral vo cJ vp vc vd isnrm pm3.26bi $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c d o p C $. $d c d o p D $. $d c d o p J $.
    $( In a normal space, disjoint closed sets are separated by open sets. $)
    nrmsep $p |- ( ( J e. Nrm /\ ( C e. ( Clsd ` J ) /\ D e. ( Clsd ` J ) /\ (
    C i^i D ) = (/) ) ) -> E. o e. J E. p e. J ( C C_ o /\ D C_ p /\ ( o i^i p
    ) = (/) ) ) $=
      cJ cnrm wcel cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD cin c0 wceq
      w3a cC vo cv wss cD vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo
      cJ wrex cJ cnrm wcel vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv
      wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld cfv
      wral vc cJ ccld cfv wral cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD
      cin c0 wceq w3a cC vo cv wss cD vp cv wss vo cv vp cv cin c0 wceq w3a vp
      cJ wrex vo cJ wrex wi cJ cnrm wcel cJ ctop wcel vc cv vd cv cin c0 wceq
      vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo
      cJ wrex wi vd cJ ccld cfv wral vc cJ ccld cfv wral vo cJ vp vc vd isnrm
      pm3.27bi vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss vo cv vp
      cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld cfv wral vc cJ
      ccld cfv wral cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD cin c0 wceq
      cC vo cv wss cD vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ
      wrex vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss vo cv vp cv
      cin c0 wceq w3a vp cJ wrex vo cJ wrex wi vd cJ ccld cfv wral vc cJ ccld
      cfv wral cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD cin c0 wceq cC vo
      cv wss cD vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi
      cC cJ ccld cfv wcel cD cJ ccld cfv wcel wa vc cv vd cv cin c0 wceq vc cv
      vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ
      wrex wi vd cJ ccld cfv wral vc cJ ccld cfv wral cC cD cin c0 wceq cC vo
      cv wss cD vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi
      vc cv vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss vo cv vp cv cin
      c0 wceq w3a vp cJ wrex vo cJ wrex wi cC cD cin c0 wceq cC vo cv wss cD vp
      cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex wi cC vd cv cin
      c0 wceq cC vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a vp cJ
      wrex vo cJ wrex wi vc vd cC cD cJ ccld cfv cJ ccld cfv vc cv cC wceq vc
      cv vd cv cin c0 wceq cC vd cv cin c0 wceq vc cv vo cv wss vd cv vp cv wss
      vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex cC vo cv wss vd cv vp
      cv wss vo cv vp cv cin c0 wceq w3a vp cJ wrex vo cJ wrex vc cv cC wceq vc
      cv vd cv cin cC vd cv cin c0 vc cv cC vd cv ineq1 eqeq1d vc cv cC wceq vc
      cv vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq w3a cC vo cv wss vd
      cv vp cv wss vo cv vp cv cin c0 wceq w3a vo vp cJ cJ vc cv cC wceq vc cv
      vo cv wss cC vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq vc cv cC
      vo cv sseq1 3anbi1d 2rexbidv imbi12d vd cv cD wceq cC vd cv cin c0 wceq
      cC cD cin c0 wceq cC vo cv wss vd cv vp cv wss vo cv vp cv cin c0 wceq
      w3a vp cJ wrex vo cJ wrex cC vo cv wss cD vp cv wss vo cv vp cv cin c0
      wceq w3a vp cJ wrex vo cJ wrex vd cv cD wceq cC vd cv cin cC cD cin c0 vd
      cv cD cC ineq2 eqeq1d vd cv cD wceq cC vo cv wss vd cv vp cv wss vo cv vp
      cv cin c0 wceq w3a cC vo cv wss cD vp cv wss vo cv vp cv cin c0 wceq w3a
      vo vp cJ cJ vd cv cD wceq vd cv vp cv wss cD vp cv wss cC vo cv wss vo cv
      vp cv cin c0 wceq vd cv cD vp cv sseq1 3anbi2d 2rexbidv imbi12d rcla42v
      com12 exp3a 3impd syl imp $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

  ${
    $d c d o C $. $d c d o D $. $d c d o J $.
    $( In a normal space, any two disjoint closed sets have the property that
       each one is a subset of an open set whose closure is disjoint from the
       other. $)
    nrmsep2 $p |- ( ( J e. Nrm /\ ( C e. ( Clsd ` J ) /\ D e. ( Clsd ` J ) /\ (
    C i^i D ) = (/) ) ) -> E. o e. J ( C C_ o /\ ( ( ( cls ` J ) ` o ) i^i D )
    = (/) ) ) $=
      cJ cnrm wcel cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD cin c0 wceq
      w3a cC vo cv wss vo cv cJ ccl cfv cfv cD cin c0 wceq wa vo cJ wrex cJ
      cnrm wcel vc cv vd cv cin c0 wceq vc cv vo cv wss vo cv cJ ccl cfv cfv vd
      cv cin c0 wceq wa vo cJ wrex wi vd cJ ccld cfv wral vc cJ ccld cfv wral
      cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD cin c0 wceq w3a cC vo cv
      wss vo cv cJ ccl cfv cfv cD cin c0 wceq wa vo cJ wrex wi cJ ctop wcel cJ
      cnrm wcel vc cv vd cv cin c0 wceq vc cv vo cv wss vo cv cJ ccl cfv cfv vd
      cv cin c0 wceq wa vo cJ wrex wi vd cJ ccld cfv wral vc cJ ccld cfv wral
      cJ nrmtop cJ ctop wcel cJ cnrm wcel vc cv vd cv cin c0 wceq vc cv vo cv
      wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex wi vd cJ ccld
      cfv wral vc cJ ccld cfv wral vo cJ vc vd isnrm2 biimpd mpcom vc cv vd cv
      cin c0 wceq vc cv vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo
      cJ wrex wi vd cJ ccld cfv wral vc cJ ccld cfv wral cC cJ ccld cfv wcel cD
      cJ ccld cfv wcel cC cD cin c0 wceq cC vo cv wss vo cv cJ ccl cfv cfv cD
      cin c0 wceq wa vo cJ wrex vc cv vd cv cin c0 wceq vc cv vo cv wss vo cv
      cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex wi vd cJ ccld cfv wral vc
      cJ ccld cfv wral cC cJ ccld cfv wcel cD cJ ccld cfv wcel cC cD cin c0
      wceq cC vo cv wss vo cv cJ ccl cfv cfv cD cin c0 wceq wa vo cJ wrex wi cC
      cJ ccld cfv wcel cD cJ ccld cfv wcel wa vc cv vd cv cin c0 wceq vc cv vo
      cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex wi vd cJ ccld
      cfv wral vc cJ ccld cfv wral cC cD cin c0 wceq cC vo cv wss vo cv cJ ccl
      cfv cfv cD cin c0 wceq wa vo cJ wrex wi vc cv vd cv cin c0 wceq vc cv vo
      cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex wi cC cD cin
      c0 wceq cC vo cv wss vo cv cJ ccl cfv cfv cD cin c0 wceq wa vo cJ wrex wi
      cC vd cv cin c0 wceq cC vo cv wss vo cv cJ ccl cfv cfv vd cv cin c0 wceq
      wa vo cJ wrex wi vc vd cC cD cJ ccld cfv cJ ccld cfv vc cv cC wceq vc cv
      vd cv cin c0 wceq cC vd cv cin c0 wceq vc cv vo cv wss vo cv cJ ccl cfv
      cfv vd cv cin c0 wceq wa vo cJ wrex cC vo cv wss vo cv cJ ccl cfv cfv vd
      cv cin c0 wceq wa vo cJ wrex vc cv cC wceq vc cv vd cv cin cC vd cv cin
      c0 vc cv cC vd cv ineq1 eqeq1d vc cv cC wceq vc cv vo cv wss vo cv cJ ccl
      cfv cfv vd cv cin c0 wceq wa cC vo cv wss vo cv cJ ccl cfv cfv vd cv cin
      c0 wceq wa vo cJ vc cv cC wceq vc cv vo cv wss cC vo cv wss vo cv cJ ccl
      cfv cfv vd cv cin c0 wceq vc cv cC vo cv sseq1 anbi1d rexbidv imbi12d vd
      cv cD wceq cC vd cv cin c0 wceq cC cD cin c0 wceq cC vo cv wss vo cv cJ
      ccl cfv cfv vd cv cin c0 wceq wa vo cJ wrex cC vo cv wss vo cv cJ ccl cfv
      cfv cD cin c0 wceq wa vo cJ wrex vd cv cD wceq cC vd cv cin cC cD cin c0
      vd cv cD cC ineq2 eqeq1d vd cv cD wceq cC vo cv wss vo cv cJ ccl cfv cfv
      vd cv cin c0 wceq wa cC vo cv wss vo cv cJ ccl cfv cfv cD cin c0 wceq wa
      vo cJ vd cv cD wceq vo cv cJ ccl cfv cfv vd cv cin c0 wceq vo cv cJ ccl
      cfv cfv cD cin c0 wceq cC vo cv wss vd cv cD wceq vo cv cJ ccl cfv cfv vd
      cv cin vo cv cJ ccl cfv cfv cD cin c0 vd cv cD vo cv cJ ccl cfv cfv ineq2
      eqeq1d anbi2d rexbidv imbi12d rcla42v com12 exp3a 3impd syl imp $.
      $( [1-Feb-2010] $) $( [1-Feb-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Filter bases
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d x y z F $.
    $( A filter base has the finite intersection property. $)
    fbasfip $p |- ( F e. fBas -> (/) e/ ( fi ` F ) ) $=
      cF cfbas wcel c0 cF cfi cfv wcel wn c0 cF cfi cfv wnel cF cfbas wcel c0
      cF cfi cfv wcel vy cv cF wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex
      cF cfbas wcel vy cv cF wss vy cv cfn wcel c0 vy cv cint wceq w3a vy cF
      cfbas wcel vy cv cF wss vy cv cfn wcel wa c0 vy cv cint wceq wn wi vy cv
      cF wss vy cv cfn wcel c0 vy cv cint wceq w3a wn cF cfbas wcel vy cv cF
      wss vy cv cfn wcel c0 vy cv cint wceq wn cF cfbas wcel vy cv cF wss wa vy
      cv cfn wcel wa vy cv c0 wceq c0 vy cv cint wceq wn cF cfbas wcel vy cv cF
      wss wa vy cv cfn wcel wa vy cv c0 wne c0 vy cv cint wceq wn vy cv c0 wceq
      wn cF cfbas wcel vy cv cF wss wa vy cv cfn wcel vy cv c0 wne c0 vy cv
      cint wceq wn cF cfbas wcel vy cv cF wss wa vy cv cfn wcel vy cv c0 wne wa
      wa vy cv cint c0 wne c0 vy cv cint wceq wn cF cfbas wcel vy cv cF wss wa
      vy cv cfn wcel vy cv c0 wne wa wa vz cv vy cv cint wss vz cF wrex vy cv
      cint c0 wne cF cfbas wcel vy cv cF wss wa vy cv cfn wcel vz cv vy cv cint
      wss vz cF wrex vy cv c0 wne cF cfbas wcel vy cv cF wss vy cv cfn wcel vz
      cv vy cv cint wss vz cF wrex vz vy cv cF fbssint 3expa adantrr cF cfbas
      wcel vy cv cF wss wa vy cv cfn wcel vy cv c0 wne wa wa vz cv vy cv cint
      wss vy cv cint c0 wne vz cF cF cfbas wcel vz cv cF wcel vz cv vy cv cint
      wss vy cv cint c0 wne wi wi vy cv cF wss vy cv cfn wcel vy cv c0 wne wa
      cF cfbas wcel vz cv cF wcel vz cv c0 wne vz cv vy cv cint wss vy cv cint
      c0 wne wi cF cfbas wcel vz cv cF wcel vz cv c0 cF cfbas wcel c0 cF wnel
      vz cv c0 wceq vz cv cF wcel wn wi cF 0nelfb c0 cF wnel c0 cF wcel wn vz
      cv c0 wceq vz cv cF wcel wn wi c0 cF df-nel vz cv c0 wceq vz cv cF wcel
      wn c0 cF wcel wn vz cv c0 wceq vz cv cF wcel c0 cF wcel vz cv c0 cF eleq1
      notbid biimprcd sylbi syl necon2ad vz cv vy cv cint wss vz cv c0 wne vy
      cv cint c0 wne vz cv vy cv cint ssn0 expcom syl6 ad2antrr r19.23adv mpd
      vy cv cint c0 wne c0 vy cv cint wne c0 vy cv cint wceq wn vy cv cint c0
      necom c0 vy cv cint df-ne bitri sylib expr vy cv c0 df-ne syl5ibr vy cv
      c0 wceq c0 vy cv cint wceq c0 c0 cint wceq c0 c0 cint wceq c0 cvv wceq
      cvv c0 wne c0 cvv wceq wn vn0 cvv c0 wne c0 cvv wne c0 cvv wceq wn cvv c0
      necom c0 cvv df-ne bitri mpbi c0 c0 cint wceq c0 cint cvv wceq c0 cvv
      wceq int0 c0 c0 cint cvv eqtr mpan2 mto vy cv c0 wceq vy cv cint c0 cint
      c0 vy cv c0 inteq eqeq2d mtbiri pm2.61d2 expl vy cv cF wss vy cv cfn wcel
      wa c0 vy cv cint wceq wn wi vy cv cF wss vy cv cfn wcel wa c0 vy cv cint
      wceq wa wn vy cv cF wss vy cv cfn wcel c0 vy cv cint wceq w3a wn vy cv cF
      wss vy cv cfn wcel wa c0 vy cv cint wceq imnan vy cv cF wss vy cv cfn
      wcel c0 vy cv cint wceq w3a vy cv cF wss vy cv cfn wcel wa c0 vy cv cint
      wceq wa vy cv cF wss vy cv cfn wcel c0 vy cv cint wceq df-3an notbii
      bitr4i sylib nexdv cF cfbas wcel c0 cF cfi cfv wcel c0 vy cv cF wss vy cv
      cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab wcel vy cv cF wss vy cv
      cfn wcel c0 vy cv cint wceq w3a vy wex cF cfbas wcel cF cfi cfv vy cv cF
      wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy wex vx cab c0 vy vx cF
      cfbas fiv eleq2d vy cv cF wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy
      wex vy cv cF wss vy cv cfn wcel c0 vy cv cint wceq w3a vy wex vx c0 0ex
      vx cv c0 wceq vy cv cF wss vy cv cfn wcel vx cv vy cv cint wceq w3a vy cv
      cF wss vy cv cfn wcel c0 vy cv cint wceq w3a vy vx cv c0 wceq vx cv vy cv
      cint wceq c0 vy cv cint wceq vy cv cF wss vy cv cfn wcel vx cv c0 vy cv
      cint eqeq1 3anbi3d exbidv elab syl6bb mtbird c0 cF cfi cfv df-nel sylibr
      $.
      $( [2-Sep-2009] $) $( [2-Sep-2009] $)
  $}

  ${
    $d r s t x J $. $d r s t x S $. $d r s t x X $.
    opnfbas.1 $e |- X = U. J $.
  $( The collection of open supersets of a nonempty set in a topology is a
     neighborhoods of the set, one of the motivations for the filter
     concept. $)
  opnfbas $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) -> { x e. J | S C_ x } e.
  fBas ) $=
    cJ ctop wcel cS cX wss cS c0 wne w3a cS vx cv wss vx cJ crab cfbas wcel cS
    vx cv wss vx cJ crab c0 wne c0 cS vx cv wss vx cJ crab wnel vt cv vr cv vs
    cv cin wss vt cS vx cv wss vx cJ crab wrex vs cS vx cv wss vx cJ crab wral
    vr cS vx cv wss vx cJ crab wral w3a cJ ctop wcel cS cX wss cS c0 wne w3a cS
    vx cv wss vx cJ crab c0 wne c0 cS vx cv wss vx cJ crab wnel vt cv vr cv vs
    cv cin wss vt cS vx cv wss vx cJ crab wrex vs cS vx cv wss vx cJ crab wral
    vr cS vx cv wss vx cJ crab wral cJ ctop wcel cS cX wss cS c0 wne w3a cX cS
    vx cv wss vx cJ crab wcel cS vx cv wss vx cJ crab c0 wne cJ ctop wcel cS cX
    wss cS c0 wne w3a cX cJ wcel cS cX wss wa cX cS vx cv wss vx cJ crab wcel
    cJ ctop wcel cS cX wss cX cJ wcel cS cX wss wa cS c0 wne cJ ctop wcel cX cJ
    wcel cS cX wss cJ cX opnfbas.1 topopn anim1i 3adant3 cS vx cv wss cS cX wss
    vx cX cJ vx cv cX cS sseq2 elrab sylibr cS vx cv wss vx cJ crab cX ne0i syl
    cJ ctop wcel cS cX wss cS c0 wne w3a c0 cJ wcel cS c0 wss wa wn c0 cS vx cv
    wss vx cJ crab wnel cJ ctop wcel cS cX wss cS c0 wne w3a cS c0 wss c0 cJ
    wcel cS c0 wne cJ ctop wcel cS c0 wss wn cS cX wss cS c0 wss cS c0 cS ss0
    necon3ai 3ad2ant3 intnand c0 cS vx cv wss vx cJ crab wnel c0 cS vx cv wss
    vx cJ crab wcel wn c0 cJ wcel cS c0 wss wa wn c0 cS vx cv wss vx cJ crab
    df-nel c0 cS vx cv wss vx cJ crab wcel c0 cJ wcel cS c0 wss wa cS vx cv wss
    cS c0 wss vx c0 cJ vx cv c0 cS sseq2 elrab notbii bitr2i sylib cJ ctop wcel
    cS cX wss cS c0 wne w3a vt cv vr cv vs cv cin wss vt cS vx cv wss vx cJ
    crab wrex vr vs cS vx cv wss vx cJ crab cS vx cv wss vx cJ crab cJ ctop
    wcel cS cX wss cS c0 wne w3a vr cv cJ wcel cS vr cv wss wa vs cv cJ wcel cS
    vs cv wss wa wa vt cv vr cv vs cv cin wss vt cS vx cv wss vx cJ crab wrex
    vr cv cS vx cv wss vx cJ crab wcel vs cv cS vx cv wss vx cJ crab wcel wa cJ
    ctop wcel cS cX wss cS c0 wne w3a vr cv cJ wcel cS vr cv wss wa vs cv cJ
    wcel cS vs cv wss wa wa vt cv vr cv vs cv cin wss vt cS vx cv wss vx cJ
    crab wrex vr cv vs cv cin cS vx cv wss vx cJ crab wcel vr cv vs cv cin vr
    cv vs cv cin wss vt cv vr cv vs cv cin wss vt cS vx cv wss vx cJ crab wrex
    cJ ctop wcel cS cX wss cS c0 wne w3a vr cv cJ wcel cS vr cv wss wa vs cv cJ
    wcel cS vs cv wss wa wa wa vt cv vr cv vs cv cin wss vr cv vs cv cin vr cv
    vs cv cin wss vt vr cv vs cv cin cS vx cv wss vx cJ crab vt cv vr cv vs cv
    cin vr cv vs cv cin sseq1 rcla4ev cJ ctop wcel cS cX wss cS c0 wne w3a vr
    cv cJ wcel cS vr cv wss wa vs cv cJ wcel cS vs cv wss wa wa wa vr cv vs cv
    cin cJ wcel cS vr cv vs cv cin wss wa vr cv vs cv cin cS vx cv wss vx cJ
    crab wcel cJ ctop wcel cS cX wss vr cv cJ wcel cS vr cv wss wa vs cv cJ
    wcel cS vs cv wss wa wa vr cv vs cv cin cJ wcel cS vr cv vs cv cin wss wa
    cS c0 wne cJ ctop wcel vr cv cJ wcel cS vr cv wss wa vs cv cJ wcel cS vs cv
    wss wa wa wa vr cv vs cv cin cJ wcel cS vr cv vs cv cin wss cJ ctop wcel vr
    cv cJ wcel vs cv cJ wcel vr cv vs cv cin cJ wcel cJ ctop wcel vr cv cJ wcel
    cS vr cv wss wa vs cv cJ wcel cS vs cv wss wa wa wa vr cv vs cv cJ inopn cJ
    ctop wcel vr cv cJ wcel cS vr cv wss wa vs cv cJ wcel cS vs cv wss wa wa
    pm3.26 cJ ctop wcel vr cv cJ wcel cS vr cv wss vs cv cJ wcel cS vs cv wss
    wa simprll cJ ctop wcel vr cv cJ wcel cS vr cv wss wa vs cv cJ wcel cS vs
    cv wss simprrl syl3anc vr cv cJ wcel cS vr cv wss wa vs cv cJ wcel cS vs cv
    wss wa wa cS vr cv vs cv cin wss cJ ctop wcel cS vr cv wss cS vs cv wss cS
    vr cv vs cv cin wss vr cv cJ wcel vs cv cJ wcel cS vr cv wss cS vs cv wss
    wa cS vr cv vs cv cin wss cS vr cv vs cv ssin biimpi ad2ant2l adantl jca
    3ad2antl1 cS vx cv wss cS vr cv vs cv cin wss vx vr cv vs cv cin cJ vx cv
    vr cv vs cv cin cS sseq2 elrab sylibr vr cv vs cv cin vr cv vs cv cin wss
    cJ ctop wcel cS cX wss cS c0 wne w3a vr cv cJ wcel cS vr cv wss wa vs cv cJ
    wcel cS vs cv wss wa wa wa vr cv vs cv cin ssid a1i sylanc ex vr cv cS vx
    cv wss vx cJ crab wcel vr cv cJ wcel cS vr cv wss wa vs cv cS vx cv wss vx
    cJ crab wcel vs cv cJ wcel cS vs cv wss wa cS vx cv wss cS vr cv wss vx vr
    cv cJ vx cv vr cv cS sseq2 elrab cS vx cv wss cS vs cv wss vx vs cv cJ vx
    cv vs cv cS sseq2 elrab anbi12i syl5ib r19.21aivv 3jca cJ ctop wcel cS cX
    wss cS vx cv wss vx cJ crab cfbas wcel cS vx cv wss vx cJ crab c0 wne c0 cS
    vx cv wss vx cJ crab wnel vt cv vr cv vs cv cin wss vt cS vx cv wss vx cJ
    crab wrex vs cS vx cv wss vx cJ crab wral vr cS vx cv wss vx cJ crab wral
    w3a wb cS c0 wne cJ ctop wcel cS vx cv wss vx cJ crab cvv wcel cS vx cv wss
    vx cJ crab cfbas wcel cS vx cv wss vx cJ crab c0 wne c0 cS vx cv wss vx cJ
    crab wnel vt cv vr cv vs cv cin wss vt cS vx cv wss vx cJ crab wrex vs cS
    vx cv wss vx cJ crab wral vr cS vx cv wss vx cJ crab wral w3a wb cS vx cv
    wss vx cJ ctop rabexg vr vs vt cvv cS vx cv wss vx cJ crab isfbas2 syl
    3ad2ant1 mpbird $.
    $( [2-Sep-2009] $) $( [2-Sep-2009] $)
  $}

  ${
    $d t x F $. $d t x G $.
    $( A bigger base generates a bigger filter. $)
    fgss $p |- ( ( F e. fBas /\ G e. fBas /\ F C_ G ) -> ( filGen ` F ) C_ (
    filGen ` G ) ) $=
      cF cfbas wcel cG cfbas wcel cF cG wss w3a vt cF cfg cfv cG cfg cfv cF
      cfbas wcel cG cfbas wcel cF cG wss w3a vt cv cF cuni wss vx cv vt cv wss
      vx cF wrex wa vt cv cG cuni wss vx cv vt cv wss vx cG wrex wa vt cv cF
      cfg cfv wcel vt cv cG cfg cfv wcel cF cG wss cF cfbas wcel vt cv cF cuni
      wss vx cv vt cv wss vx cF wrex wa vt cv cG cuni wss vx cv vt cv wss vx cG
      wrex wa wi cG cfbas wcel cF cG wss vt cv cF cuni wss vt cv cG cuni wss vx
      cv vt cv wss vx cF wrex vx cv vt cv wss vx cG wrex vt cv cF cuni wss cF
      cuni cG cuni wss vt cv cG cuni wss cF cG wss vt cv cF cuni cG cuni sstr2
      cF cG uniss syl5com vx cv vt cv wss vx cF cG ssrexv anim12d 3ad2ant3 cF
      cfbas wcel cG cfbas wcel vt cv cF cfg cfv wcel vt cv cF cuni wss vx cv vt
      cv wss vx cF wrex wa wb cF cG wss vx vt cv cF cF cuni cF cuni eqid elfg
      3ad2ant1 cG cfbas wcel cF cfbas wcel vt cv cG cfg cfv wcel vt cv cG cuni
      wss vx cv vt cv wss vx cG wrex wa wb cF cG wss vx vt cv cG cG cuni cG
      cuni eqid elfg 3ad2ant2 3imtr4d ssrdv $.
      $( [5-Sep-2009] $) $( [5-Sep-2009] $)
  $}


  ${
    $d t x F $.
    $( A filter generates itself. $)
    fgid $p |- ( F e. Fil -> ( filGen ` F ) = F ) $=
      cF cfil wcel cF cfg cfv cF cF cfil wcel vt cF cfg cfv cF cF cfil wcel vt
      cv cF cfg cfv wcel vt cv cF cuni wss vx cv vt cv wss vx cF wrex wa vt cv
      cF wcel cF cfil wcel cF cfbas wcel vt cv cF cfg cfv wcel vt cv cF cuni
      wss vx cv vt cv wss vx cF wrex wa wb cF filfbas vx vt cv cF cF cuni cF
      cuni eqid elfg syl cF cfil wcel vt cv cF cuni wss vx cv vt cv wss vx cF
      wrex vt cv cF wcel cF cfil wcel vx cv vt cv wss vx cF wrex vt cv cF cuni
      wss vt cv cF wcel cF cfil wcel vx cv vt cv wss vt cv cF cuni wss vt cv cF
      wcel wi vx cF cF cfil wcel vx cv cF wcel vt cv cF cuni wss vx cv vt cv
      wss vt cv cF wcel cF cfil wcel vx cv cF wcel vt cv cF cuni wss vx cv vt
      cv wss vt cv cF wcel vx cv vt cv cF cF cuni cF cuni eqid fillsb 3expd
      com34 r19.23adv com23 imp3a sylbid ssrdv cF cfil wcel cF cfbas wcel cF cF
      cfg cfv wss cF filfbas cF fbssfg syl eqssd $.
      $( [5-Sep-2009] $) $( [5-Sep-2009] $)
  $}

  ${
    $d t x B $. $d t x F $. $d t x X $. $d t x Y $.
    fgmin.1 $e |- X = U. B $.
    fgmin.2 $e |- Y = U. F $.
    $( Minimality property of a generated filter: every filter that contains `
       B ` contains its generated filter. $)
    fgmin $p |- ( ( B e. fBas /\ F e. Fil /\ X = Y ) -> ( B C_ F <-> ( filGen `
    B ) C_ F ) ) $=
      cB cfbas wcel cF cfil wcel cX cY wceq w3a cB cF wss cB cfg cfv cF wss cB
      cfbas wcel cF cfil wcel cX cY wceq w3a cB cF wss cB cfg cfv cF wss cB
      cfbas wcel cF cfil wcel cX cY wceq w3a cB cF wss wa vt cB cfg cfv cF cB
      cfbas wcel cF cfil wcel cX cY wceq w3a cB cF wss wa vt cv cB cfg cfv wcel
      vt cv cX wss vx cv vt cv wss vx cB wrex wa vt cv cF wcel cB cfbas wcel cF
      cfil wcel cX cY wceq w3a vt cv cB cfg cfv wcel vt cv cX wss vx cv vt cv
      wss vx cB wrex wa wb cB cF wss cB cfbas wcel cF cfil wcel vt cv cB cfg
      cfv wcel vt cv cX wss vx cv vt cv wss vx cB wrex wa wb cX cY wceq vx vt
      cv cB cX fgmin.1 elfg 3ad2ant1 adantr cB cfbas wcel cF cfil wcel cX cY
      wceq w3a cB cF wss wa vt cv cX wss vx cv vt cv wss vx cB wrex vt cv cF
      wcel cB cfbas wcel cF cfil wcel cX cY wceq w3a cB cF wss wa vt cv cX wss
      vt cv cY wss vx cv vt cv wss vx cB wrex vt cv cF wcel wi cB cfbas wcel cF
      cfil wcel cX cY wceq w3a vt cv cX wss vt cv cY wss wb cB cF wss cX cY
      wceq cB cfbas wcel vt cv cX wss vt cv cY wss wb cF cfil wcel cX cY vt cv
      sseq2 3ad2ant3 adantr cB cfbas wcel cF cfil wcel cB cF wss vt cv cY wss
      vx cv vt cv wss vx cB wrex vt cv cF wcel wi wi cX cY wceq cB cfbas wcel
      cF cfil wcel wa cB cF wss wa vx cv vt cv wss vx cB wrex vt cv cY wss vt
      cv cF wcel cB cfbas wcel cF cfil wcel wa cB cF wss wa vx cv vt cv wss vx
      cB wrex vx cv vt cv wss vx cF wrex vt cv cY wss vt cv cF wcel wi cB cF
      wss vx cv vt cv wss vx cB wrex vx cv vt cv wss vx cF wrex wi cB cfbas
      wcel cF cfil wcel wa vx cv vt cv wss vx cB cF ssrexv adantl cF cfil wcel
      vx cv vt cv wss vx cF wrex vt cv cY wss vt cv cF wcel wi wi cB cfbas wcel
      cB cF wss cF cfil wcel vx cv vt cv wss vt cv cY wss vt cv cF wcel wi vx
      cF cF cfil wcel vx cv cF wcel vt cv cY wss vx cv vt cv wss vt cv cF wcel
      cF cfil wcel vx cv cF wcel vt cv cY wss vx cv vt cv wss vt cv cF wcel vx
      cv vt cv cF cY fgmin.2 fillsb 3expd com34 r19.23adv ad2antlr syld com23
      3adantl3 sylbid imp3a sylbid ssrdv ex cB cfbas wcel cF cfil wcel cB cfg
      cfv cF wss cB cF wss wi cX cY wceq cB cfbas wcel cB cB cfg cfv wss cB cfg
      cfv cF wss cB cF wss wi cB fbssfg cB cB cfg cfv cF sstr2 syl 3ad2ant1
      impbid $.
      $( [5-Sep-2009] $) $( [5-Sep-2009] $)
  $}

  ${
    $d t u v x y F $. $d t u v x y G $. $d t u v x y X $. $d t u v x y Y $. $d
    t u v x y $.
    fbfgss.1 $e |- X = U. F $.
    fbfgss.2 $e |- Y = U. G $.
    $( A condition for a filter to be finer than another involving their filter
       bases. $)
    fbfgss $p |- ( ( F e. fBas /\ G e. fBas /\ X = Y ) -> ( ( filGen ` F ) C_ (
    filGen ` G ) <-> A. x e. F E. y e. G y C_ x ) ) $=
      cF cfbas wcel cG cfbas wcel cX cY wceq w3a cF cfg cfv cG cfg cfv wss vy
      cv vx cv wss vy cG wrex vx cF wral cF cfbas wcel cG cfbas wcel cX cY wceq
      w3a cF cfg cfv cG cfg cfv wss vy cv vx cv wss vy cG wrex vx cF cF cfbas
      wcel cG cfbas wcel cX cY wceq w3a cF cfg cfv cG cfg cfv wss vx cv cF cfg
      cfv wcel vy cv vx cv wss vy cG wrex vx cv cF wcel cF cfbas wcel cG cfbas
      wcel cX cY wceq w3a cF cfg cfv cG cfg cfv wss vx cv cF cfg cfv wcel vy cv
      vx cv wss vy cG wrex cF cfbas wcel cG cfbas wcel cX cY wceq w3a vx cv cG
      cfg cfv wcel vy cv vx cv wss vy cG wrex cF cfg cfv cG cfg cfv wss vx cv
      cF cfg cfv wcel wa cG cfbas wcel cF cfbas wcel vx cv cG cfg cfv wcel vy
      cv vx cv wss vy cG wrex wi cX cY wceq cG cfbas wcel vx cv cG cfg cfv wcel
      vx cv cY wss vy cv vx cv wss vy cG wrex wa vy cv vx cv wss vy cG wrex vy
      vx cv cG cY fbfgss.2 elfg vx cv cY wss vy cv vx cv wss vy cG wrex pm3.27
      syl6bi 3ad2ant2 cF cfg cfv cG cfg cfv vx cv ssel2 syl5 exp3a cF cfbas
      wcel cG cfbas wcel cX cY wceq w3a cF cF cfg cfv vx cv cF cfbas wcel cG
      cfbas wcel cF cF cfg cfv wss cX cY wceq cF fbssfg 3ad2ant1 sseld syl5d
      r19.21adv cF cfbas wcel cG cfbas wcel cX cY wceq w3a vy cv vx cv wss vy
      cG wrex vx cF wral cF cfg cfv cG cfg cfv wss cF cfbas wcel cG cfbas wcel
      cX cY wceq w3a vy cv vx cv wss vy cG wrex vx cF wral wa vt cF cfg cfv cG
      cfg cfv cF cfbas wcel cG cfbas wcel cX cY wceq w3a vy cv vx cv wss vy cG
      wrex vx cF wral wa vt cv cX wss vu cv vt cv wss vu cF wrex wa vt cv cY
      wss vv cv vt cv wss vv cG wrex wa vt cv cF cfg cfv wcel vt cv cG cfg cfv
      wcel cF cfbas wcel cG cfbas wcel cX cY wceq w3a vy cv vx cv wss vy cG
      wrex vx cF wral wa vt cv cX wss vu cv vt cv wss vu cF wrex vt cv cY wss
      vv cv vt cv wss vv cG wrex wa cF cfbas wcel cG cfbas wcel cX cY wceq w3a
      vy cv vx cv wss vy cG wrex vx cF wral wa vu cv vt cv wss vu cF wrex vt cv
      cX wss vt cv cY wss vv cv vt cv wss vv cG wrex wa cF cfbas wcel cG cfbas
      wcel cX cY wceq w3a vy cv vx cv wss vy cG wrex vx cF wral wa vu cv vt cv
      wss vt cv cX wss vt cv cY wss vv cv vt cv wss vv cG wrex wa wi vu cF cF
      cfbas wcel cG cfbas wcel cX cY wceq w3a vy cv vx cv wss vy cG wrex vx cF
      wral vu cv cF wcel vu cv vt cv wss vt cv cX wss vt cv cY wss vv cv vt cv
      wss vv cG wrex wa wi wi wi cF cfbas wcel cG cfbas wcel cX cY wceq w3a vu
      cv cF wcel vy cv vx cv wss vy cG wrex vx cF wral vu cv vt cv wss vt cv cX
      wss vt cv cY wss vv cv vt cv wss vv cG wrex wa wi wi cF cfbas wcel cG
      cfbas wcel cX cY wceq w3a vu cv cF wcel vy cv vx cv wss vy cG wrex vx cF
      wral vu cv vt cv wss vt cv cX wss vt cv cY wss vv cv vt cv wss vv cG wrex
      wa wi wi wi cF cfbas wcel cG cfbas wcel cX cY wceq w3a vu cv cF wcel wa
      vy cv vx cv wss vy cG wrex vx cF wral vy cv vu cv wss vy cG wrex vu cv vt
      cv wss vt cv cX wss vt cv cY wss vv cv vt cv wss vv cG wrex wa wi wi vu
      cv cF wcel vy cv vx cv wss vy cG wrex vx cF wral vy cv vu cv wss vy cG
      wrex wi cF cfbas wcel cG cfbas wcel cX cY wceq w3a vy cv vx cv wss vy cG
      wrex vy cv vu cv wss vy cG wrex vx vu cv cF vx cv vu cv wceq vy cv vx cv
      wss vy cv vu cv wss vy cG vx cv vu cv vy cv sseq2 rexbidv rcla4v adantl
      cF cfbas wcel cG cfbas wcel cX cY wceq w3a vu cv cF wcel wa vy cv vu cv
      wss vu cv vt cv wss vt cv cX wss vt cv cY wss vv cv vt cv wss vv cG wrex
      wa wi wi vy cG cF cfbas wcel cG cfbas wcel cX cY wceq w3a vu cv cF wcel
      wa vy cv cG wcel vy cv vu cv wss vu cv vt cv wss vt cv cX wss vt cv cY
      wss vv cv vt cv wss vv cG wrex wa wi cF cfbas wcel cG cfbas wcel cX cY
      wceq w3a vu cv cF wcel wa vy cv cG wcel vy cv vu cv wss vu cv vt cv wss
      wa wa wa vt cv cX wss vt cv cY wss vv cv vt cv wss vv cG wrex cF cfbas
      wcel cG cfbas wcel cX cY wceq w3a vu cv cF wcel wa vy cv cG wcel vy cv vu
      cv wss vu cv vt cv wss wa wa wa vt cv cX wss vt cv cY wss cF cfbas wcel
      cG cfbas wcel cX cY wceq w3a vu cv cF wcel wa vy cv cG wcel vy cv vu cv
      wss vu cv vt cv wss wa wa wa cX cY vt cv cF cfbas wcel cG cfbas wcel cX
      cY wceq w3a cX cY wceq vu cv cF wcel vy cv cG wcel vy cv vu cv wss vu cv
      vt cv wss wa wa cF cfbas wcel cG cfbas wcel cX cY wceq 3simp3 ad2antrr
      sseq2d biimpd cF cfbas wcel cG cfbas wcel cX cY wceq w3a vu cv cF wcel wa
      vy cv cG wcel vy cv vt cv wss vt cv cX wss vv cv vt cv wss vv cG wrex wi
      vy cv vu cv wss vu cv vt cv wss wa cF cfbas wcel cG cfbas wcel cX cY wceq
      w3a vu cv cF wcel wa vy cv cG wcel vy cv vt cv wss wa wa vv cv vt cv wss
      vv cG wrex vt cv cX wss vy cv cG wcel vy cv vt cv wss wa vv cv vt cv wss
      vv cG wrex cF cfbas wcel cG cfbas wcel cX cY wceq w3a vu cv cF wcel wa vv
      cv vt cv wss vy cv vt cv wss vv vy cv cG vv cv vy cv vt cv sseq1 rcla4ev
      adantl a1d vy cv vu cv vt cv sstr sylanr2 jcad exp45 r19.23adv syld ex
      com23 imp r19.23adv com23 imp3a cF cfbas wcel cG cfbas wcel cX cY wceq
      w3a vt cv cF cfg cfv wcel vt cv cX wss vu cv vt cv wss vu cF wrex wa wb
      vy cv vx cv wss vy cG wrex vx cF wral cF cfbas wcel cG cfbas wcel vt cv
      cF cfg cfv wcel vt cv cX wss vu cv vt cv wss vu cF wrex wa wb cX cY wceq
      vu vt cv cF cX fbfgss.1 elfg 3ad2ant1 adantr cF cfbas wcel cG cfbas wcel
      cX cY wceq w3a vt cv cG cfg cfv wcel vt cv cY wss vv cv vt cv wss vv cG
      wrex wa wb vy cv vx cv wss vy cG wrex vx cF wral cG cfbas wcel cF cfbas
      wcel vt cv cG cfg cfv wcel vt cv cY wss vv cv vt cv wss vv cG wrex wa wb
      cX cY wceq vv vt cv cG cY fbfgss.2 elfg 3ad2ant2 adantr 3imtr4d ssrdv ex
      impbid $.
      $( [3-Sep-2009] $) $( [3-Sep-2009] $)
  $}

  ${
    $d t u x y z J $. $d t u x y z S $. $d t u x y z X $.
    neifg.1 $e |- X = U. J $.
    $( The neighborhood filter of a nonempty set is generated by its open
       supersets. See comments for ~ opnfbas . $)
    neifg $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) -> ( filGen ` { x e. J |
    S C_ x } ) = ( ( nei ` J ) ` S ) ) $=
      cJ ctop wcel cS cX wss cS c0 wne w3a cS vx cv wss vx cJ crab cfg cfv cS
      vx cv wss vx cJ crab vt cv cpw cin c0 wne vt cS vx cv wss vx cJ crab cuni
      cpw crab cS cJ cnei cfv cfv cJ ctop wcel cS cX wss cS c0 wne w3a cS vx cv
      wss vx cJ crab cfbas wcel cS vx cv wss vx cJ crab cfg cfv cS vx cv wss vx
      cJ crab vt cv cpw cin c0 wne vt cS vx cv wss vx cJ crab cuni cpw crab
      wceq vx cS cJ cX neifg.1 opnfbas vt cS vx cv wss vx cJ crab cS vx cv wss
      vx cJ crab cuni cS vx cv wss vx cJ crab cuni eqid fgf syl cJ ctop wcel cS
      cX wss cS c0 wne w3a vu cS vx cv wss vx cJ crab vt cv cpw cin c0 wne vt
      cS vx cv wss vx cJ crab cuni cpw crab cS cJ cnei cfv cfv cJ ctop wcel cS
      cX wss cS c0 wne w3a vu cv cS vx cv wss vx cJ crab cuni cpw wcel cS vx cv
      wss vx cJ crab vu cv cpw cin c0 wne wa vu cv cS cJ cnei cfv cfv wcel vu
      cv cS vx cv wss vx cJ crab vt cv cpw cin c0 wne vt cS vx cv wss vx cJ
      crab cuni cpw crab wcel cJ ctop wcel cS cX wss cS c0 wne w3a vu cv cS vx
      cv wss vx cJ crab cuni cpw wcel cS vx cv wss vx cJ crab vu cv cpw cin c0
      wne wa vu cv cX wss vz cv cJ wcel cS vz cv wss wa vz cv vu cv wss wa vz
      wex wa vu cv cS cJ cnei cfv cfv wcel cJ ctop wcel cS cX wss cS c0 wne w3a
      vu cv cS vx cv wss vx cJ crab cuni cpw wcel vu cv cX wss cS vx cv wss vx
      cJ crab vu cv cpw cin c0 wne vz cv cJ wcel cS vz cv wss wa vz cv vu cv
      wss wa vz wex cJ ctop wcel cS cX wss cS c0 wne w3a vu cv cS vx cv wss vx
      cJ crab cuni wss vu cv cX wss vu cv cS vx cv wss vx cJ crab cuni cpw wcel
      cJ ctop wcel cS cX wss cS c0 wne w3a cS vx cv wss vx cJ crab cuni cX vu
      cv cJ ctop wcel cS cX wss cS c0 wne w3a cS vx cv wss vx cJ crab cuni cX
      cJ ctop wcel cS cX wss cS c0 wne w3a vy cv cX wss vy cS vx cv wss vx cJ
      crab wral cS vx cv wss vx cJ crab cuni cX wss cJ ctop wcel cS cX wss cS
      c0 wne w3a vy cv cX wss vy cS vx cv wss vx cJ crab cJ ctop wcel cS cX wss
      cS c0 wne w3a vy cv cJ wcel cS vy cv wss wa vy cv cX wss vy cv cS vx cv
      wss vx cJ crab wcel cJ ctop wcel cS cX wss vy cv cJ wcel cS vy cv wss wa
      vy cv cX wss wi cS c0 wne cJ ctop wcel vy cv cJ wcel vy cv cX wss cS vy
      cv wss cJ ctop wcel vy cv cJ wcel vy cv cX wss vy cv cJ cX neifg.1
      eltopss ex adantrd 3ad2ant1 cS vx cv wss cS vy cv wss vx vy cv cJ vx cv
      vy cv cS sseq2 elrab syl5ib r19.21aiv vy cS vx cv wss vx cJ crab cX
      unissb sylibr cJ ctop wcel cS cX wss cS c0 wne w3a cX cS vx cv wss vx cJ
      crab wcel cX cS vx cv wss vx cJ crab cuni wss cJ ctop wcel cS cX wss cS
      c0 wne w3a cX cJ wcel cS cX wss wa cX cS vx cv wss vx cJ crab wcel cJ
      ctop wcel cS cX wss cS c0 wne w3a cX cJ wcel cS cX wss cJ ctop wcel cS cX
      wss cX cJ wcel cS c0 wne cJ cX neifg.1 topopn 3ad2ant1 cJ ctop wcel cS cX
      wss cS c0 wne 3simp2 jca cS vx cv wss cS cX wss vx cX cJ vx cv cX cS
      sseq2 elrab sylibr cX cS vx cv wss vx cJ crab elssuni syl eqssd sseq2d vu
      cv cS vx cv wss vx cJ crab cuni vu visset elpw syl5bb cS vx cv wss vx cJ
      crab vu cv cpw cin c0 wne vz cv cJ wcel cS vz cv wss wa vz cv vu cv wss
      wa vz wex wb cJ ctop wcel cS cX wss cS c0 wne w3a cS vx cv wss vx cJ crab
      vu cv cpw cin c0 wne vz cv cS vx cv wss vx cJ crab vu cv cpw cin wcel vz
      wex vz cv cJ wcel cS vz cv wss wa vz cv vu cv wss wa vz wex vz cS vx cv
      wss vx cJ crab vu cv cpw cin n0 vz cv cS vx cv wss vx cJ crab vu cv cpw
      cin wcel vz cv cJ wcel cS vz cv wss wa vz cv vu cv wss wa vz vz cv cS vx
      cv wss vx cJ crab vu cv cpw cin wcel vz cv cS vx cv wss vx cJ crab wcel
      vz cv vu cv cpw wcel wa vz cv cJ wcel cS vz cv wss wa vz cv vu cv wss wa
      vz cv cS vx cv wss vx cJ crab vu cv cpw elin vz cv cS vx cv wss vx cJ
      crab wcel vz cv cJ wcel cS vz cv wss wa vz cv vu cv cpw wcel vz cv vu cv
      wss cS vx cv wss cS vz cv wss vx vz cv cJ vx cv vz cv cS sseq2 elrab vz
      cv vu cv vz visset elpw anbi12i bitri exbii bitri a1i anbi12d cJ ctop
      wcel cS cX wss cS c0 wne w3a vu cv cS cJ cnei cfv cfv wcel vu cv cX wss
      cS vz cv wss vz cv vu cv wss wa vz cJ wrex wa vu cv cX wss vz cv cJ wcel
      cS vz cv wss wa vz cv vu cv wss wa vz wex wa cJ ctop wcel cS cX wss vu cv
      cS cJ cnei cfv cfv wcel vu cv cX wss cS vz cv wss vz cv vu cv wss wa vz
      cJ wrex wa wb cS c0 wne cS vz cJ vu cv cX neifg.1 isnei 3adant3 vz cv cJ
      wcel cS vz cv wss wa vz cv vu cv wss wa vz wex cS vz cv wss vz cv vu cv
      wss wa vz cJ wrex vu cv cX wss vz cv cJ wcel cS vz cv wss wa vz cv vu cv
      wss wa vz wex vz cv cJ wcel cS vz cv wss vz cv vu cv wss wa wa vz wex cS
      vz cv wss vz cv vu cv wss wa vz cJ wrex vz cv cJ wcel cS vz cv wss wa vz
      cv vu cv wss wa vz cv cJ wcel cS vz cv wss vz cv vu cv wss wa wa vz vz cv
      cJ wcel cS vz cv wss vz cv vu cv wss anass exbii cS vz cv wss vz cv vu cv
      wss wa vz cJ df-rex bitr4i anbi2i syl6rbbr bitrd cS vx cv wss vx cJ crab
      vt cv cpw cin c0 wne cS vx cv wss vx cJ crab vu cv cpw cin c0 wne vt vu
      cv cS vx cv wss vx cJ crab cuni cpw vt cv vu cv wceq cS vx cv wss vx cJ
      crab vt cv cpw cin cS vx cv wss vx cJ crab vu cv cpw cin c0 vt cv vu cv
      wceq vt cv cpw vu cv cpw cS vx cv wss vx cJ crab vt cv vu cv pweq ineq2d
      neeq1d elrab syl5bb eqrdv eqtrd $.
      $( [3-Sep-2009] $) $( [3-Sep-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $.
  $( The supersets of a nonempty set which are also subsets of a given base set
     form a filter. $)
  supfil $p |- ( ( A e. C /\ B C_ A /\ B =/= (/) ) -> ( { x | ( x C_ A /\ B C_
  x ) } e. Fil /\ A = U. { x | ( x C_ A /\ B C_ x ) } ) ) $=
    cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv wss wa vx cab
    cuni wceq vx cv cA wss cB vx cv wss wa vx cab cfil wcel cA cC wcel cB cA
    wss cB c0 wne w3a cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq vx cv cA
    wss cB vx cv wss wa vx cab cfil wcel cA cC wcel cB cA wss cB c0 wne w3a cA
    vx cv cA wss cB vx cv wss wa vx cab cuni cA cC wcel cB cA wss cB c0 wne w3a
    cA vx cv cA wss cB vx cv wss wa vx cab wcel cA vx cv cA wss cB vx cv wss wa
    vx cab cuni wss cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv
    wss wa vx cab wcel cA cA wss cB cA wss wa cA cC wcel cB cA wss cB c0 wne
    w3a cB cA wss cA cA wss cA cC wcel cB cA wss cB c0 wne 3simp2 cA ssid jctil
    cA cC wcel cB cA wss cA vx cv cA wss cB vx cv wss wa vx cab wcel cA cA wss
    cB cA wss wa wb cB c0 wne cB vx cv wss cB cA wss vx cA cA cC vx cv cA cB
    sseq2 elssabg 3ad2ant1 mpbird cA vx cv cA wss cB vx cv wss wa vx cab
    elssuni syl cA cC wcel cB cA wss cB c0 wne w3a vy cv cA wss vy vx cv cA wss
    cB vx cv wss wa vx cab wral vx cv cA wss cB vx cv wss wa vx cab cuni cA wss
    cA cC wcel cB cA wss cB c0 wne w3a vy cv cA wss vy vx cv cA wss cB vx cv
    wss wa vx cab cA cC wcel cB cA wss cB c0 wne w3a vy cv cA wss cB vy cv wss
    wa vy cv cA wss vy cv vx cv cA wss cB vx cv wss wa vx cab wcel vy cv cA wss
    cB vy cv wss wa vy cv cA wss wi cA cC wcel cB cA wss cB c0 wne w3a vy cv cA
    wss cB vy cv wss pm3.26 a1i vx cv cA wss cB vx cv wss wa vy cv cA wss cB vy
    cv wss wa vx vy cv vy visset vx cv vy cv wceq vx cv cA wss vy cv cA wss cB
    vx cv wss cB vy cv wss vx cv vy cv cA sseq1 vx cv vy cv cB sseq2 anbi12d
    elab syl5ib r19.21aiv vy vx cv cA wss cB vx cv wss wa vx cab cA unissb
    sylibr eqssd cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv
    wss wa vx cab cuni wceq vx cv cA wss cB vx cv wss wa vx cab cfil wcel cA cC
    wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv wss wa vx cab cuni
    wceq wa vx cv cA wss cB vx cv wss wa vx cab cfil wcel c0 vx cv cA wss cB vx
    cv wss wa vx cab wcel wn vx cv cA wss cB vx cv wss wa vx cab cuni vx cv cA
    wss cB vx cv wss wa vx cab wcel wa vy cv vx cv cA wss cB vx cv wss wa vx
    cab wcel vz cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vy cv vz cv wss
    w3a vz cv vx cv cA wss cB vx cv wss wa vx cab wcel wi vz wal vy wal vy cv
    vz cv cin vx cv cA wss cB vx cv wss wa vx cab wcel vz vx cv cA wss cB vx cv
    wss wa vx cab wral vy vx cv cA wss cB vx cv wss wa vx cab wral w3a cA cC
    wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv wss wa vx cab cuni
    wceq wa c0 vx cv cA wss cB vx cv wss wa vx cab wcel wn vx cv cA wss cB vx
    cv wss wa vx cab cuni vx cv cA wss cB vx cv wss wa vx cab wcel wa vy cv vx
    cv cA wss cB vx cv wss wa vx cab wcel vz cv vx cv cA wss cB vx cv wss wa vx
    cab cuni wss vy cv vz cv wss w3a vz cv vx cv cA wss cB vx cv wss wa vx cab
    wcel wi vz wal vy wal vy cv vz cv cin vx cv cA wss cB vx cv wss wa vx cab
    wcel vz vx cv cA wss cB vx cv wss wa vx cab wral vy vx cv cA wss cB vx cv
    wss wa vx cab wral cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx
    cv wss wa vx cab cuni wceq wa c0 vx cv cA wss cB vx cv wss wa vx cab wcel
    wn vx cv cA wss cB vx cv wss wa vx cab cuni vx cv cA wss cB vx cv wss wa vx
    cab wcel cA cC wcel cB cA wss cB c0 wne w3a c0 vx cv cA wss cB vx cv wss wa
    vx cab wcel wn cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq cA cC wcel
    cB cA wss cB c0 wne w3a c0 vx cv cA wss cB vx cv wss wa vx cab wcel c0 cA
    wss cB c0 wss wa cA cC wcel cB cA wss cB c0 wne w3a cB c0 wceq c0 cA wss cB
    c0 wss wa cB c0 wne cA cC wcel cB c0 wceq wn cB cA wss cB c0 wne cB c0 wceq
    wn cB c0 df-ne biimpi 3ad2ant3 cB c0 wss cB c0 wceq c0 cA wss cB ss0 adantl
    nsyl c0 vx cv cA wss cB vx cv wss wa vx cab wcel c0 cA wss cB c0 wss wa wb
    cA cC wcel cB cA wss cB c0 wne w3a vx cv cA wss cB vx cv wss wa c0 cA wss
    cB c0 wss wa vx c0 0ex vx cv c0 wceq vx cv cA wss c0 cA wss cB vx cv wss cB
    c0 wss vx cv c0 cA sseq1 vx cv c0 cB sseq2 anbi12d elab a1i mtbird adantr
    cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv wss wa vx cab
    cuni wceq wa cA vx cv cA wss cB vx cv wss wa vx cab cuni vx cv cA wss cB vx
    cv wss wa vx cab cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx
    cv wss wa vx cab cuni wceq pm3.27 cA cC wcel cB cA wss cB c0 wne w3a cA vx
    cv cA wss cB vx cv wss wa vx cab wcel cA vx cv cA wss cB vx cv wss wa vx
    cab cuni wceq cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv
    wss wa vx cab wcel cA cA wss cB cA wss wa cA cC wcel cB cA wss cB c0 wne
    w3a cB cA wss cA cA wss cA cC wcel cB cA wss cB c0 wne 3simp2 cA ssid jctil
    cA cC wcel cB cA wss cA vx cv cA wss cB vx cv wss wa vx cab wcel cA cA wss
    cB cA wss wa wb cB c0 wne cB vx cv wss cB cA wss vx cA cA cC vx cv cA cB
    sseq2 elssabg 3ad2ant1 mpbird adantr eqeltrrd jca cA cC wcel cB cA wss cB
    c0 wne w3a cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq wa vy cv vx cv
    cA wss cB vx cv wss wa vx cab wcel vz cv vx cv cA wss cB vx cv wss wa vx
    cab cuni wss vy cv vz cv wss w3a vz cv vx cv cA wss cB vx cv wss wa vx cab
    wcel wi vy vz cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv
    wss wa vx cab cuni wceq vy cv vx cv cA wss cB vx cv wss wa vx cab wcel vz
    cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vy cv vz cv wss w3a vz cv
    vx cv cA wss cB vx cv wss wa vx cab wcel cA cC wcel cB cA wss cB c0 wne w3a
    cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq vy cv vx cv cA wss cB vx
    cv wss wa vx cab wcel vz cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vy
    cv vz cv wss w3a wa wa vz cv cA wss cB vz cv wss wa vz cv vx cv cA wss cB
    vx cv wss wa vx cab wcel cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss
    cB vx cv wss wa vx cab cuni wceq vy cv vx cv cA wss cB vx cv wss wa vx cab
    wcel vz cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vy cv vz cv wss w3a
    wa wa vz cv cA wss cB vz cv wss cA cC wcel cB cA wss cB c0 wne w3a cA vx cv
    cA wss cB vx cv wss wa vx cab cuni wceq vy cv vx cv cA wss cB vx cv wss wa
    vx cab wcel vz cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vy cv vz cv
    wss w3a vz cv cA wss cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB
    vx cv wss wa vx cab cuni wceq wa vy cv vx cv cA wss cB vx cv wss wa vx cab
    wcel vz cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vz cv cA wss vy cv
    vz cv wss cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq vz cv vx cv cA
    wss cB vx cv wss wa vx cab cuni wss vz cv cA wss cA cC wcel cB cA wss cB c0
    wne w3a cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq vz cv cA wss vz cv
    vx cv cA wss cB vx cv wss wa vx cab cuni wss cA vx cv cA wss cB vx cv wss
    wa vx cab cuni vz cv sseq2 biimpar adantll 3ad2antr2 anasss vy cv vx cv cA
    wss cB vx cv wss wa vx cab wcel vz cv vx cv cA wss cB vx cv wss wa vx cab
    cuni wss vy cv vz cv wss w3a cB vz cv wss cA cC wcel cB cA wss cB c0 wne
    w3a cA vx cv cA wss cB vx cv wss wa vx cab cuni wceq vy cv vx cv cA wss cB
    vx cv wss wa vx cab wcel vy cv vz cv wss cB vz cv wss vz cv vx cv cA wss cB
    vx cv wss wa vx cab cuni wss vy cv vx cv cA wss cB vx cv wss wa vx cab wcel
    vy cv vz cv wss cB vz cv wss vy cv vx cv cA wss cB vx cv wss wa vx cab wcel
    vy cv cA wss cB vy cv wss wa vy cv vz cv wss cB vz cv wss wi vx cv cA wss
    cB vx cv wss wa vy cv cA wss cB vy cv wss wa vx vy cv vy visset vx cv vy cv
    wceq vx cv cA wss vy cv cA wss cB vx cv wss cB vy cv wss vx cv vy cv cA
    sseq1 vx cv vy cv cB sseq2 anbi12d elab cB vy cv wss vy cv vz cv wss cB vz
    cv wss wi vy cv cA wss cB vy cv vz cv sstr2 adantl sylbi imp 3adant2
    ad2antll jca vx cv cA wss cB vx cv wss wa vz cv cA wss cB vz cv wss wa vx
    vz cv vz visset vx cv vz cv wceq vx cv cA wss vz cv cA wss cB vx cv wss cB
    vz cv wss vx cv vz cv cA sseq1 vx cv vz cv cB sseq2 anbi12d elab sylibr
    expr 19.21aivv vy cv vz cv cin vx cv cA wss cB vx cv wss wa vx cab wcel vz
    vx cv cA wss cB vx cv wss wa vx cab wral vy vx cv cA wss cB vx cv wss wa vx
    cab wral cA cC wcel cB cA wss cB c0 wne w3a cA vx cv cA wss cB vx cv wss wa
    vx cab cuni wceq wa vy cv vz cv cin vx cv cA wss cB vx cv wss wa vx cab
    wcel vy vz vx cv cA wss cB vx cv wss wa vx cab vy cv cA wss cB vy cv wss wa
    vz cv cA wss cB vz cv wss wa vy cv vz cv cin vx cv cA wss cB vx cv wss wa
    vx cab wcel vy cv vx cv cA wss cB vx cv wss wa vx cab wcel vz cv vx cv cA
    wss cB vx cv wss wa vx cab wcel vy cv cA wss cB vy cv wss wa vz cv cA wss
    cB vz cv wss wa wa vy cv vz cv cin cA wss cB vy cv vz cv cin wss wa vy cv
    vz cv cin vx cv cA wss cB vx cv wss wa vx cab wcel vy cv cA wss cB vy cv
    wss wa vz cv cA wss cB vz cv wss wa wa vy cv vz cv cin cA wss cB vy cv vz
    cv cin wss vy cv cA wss vy cv vz cv cin cA wss cB vy cv wss vz cv cA wss cB
    vz cv wss wa vy cv vz cv cA ssinss1 ad2antrr cB vy cv wss cB vz cv wss cB
    vy cv vz cv cin wss vy cv cA wss vz cv cA wss cB vy cv wss cB vz cv wss wa
    cB vy cv vz cv cin wss cB vy cv vz cv ssin biimpi ad2ant2l jca vx cv cA wss
    cB vx cv wss wa vy cv vz cv cin cA wss cB vy cv vz cv cin wss wa vx vy cv
    vz cv cin vy cv vz cv vy visset inex1 vx cv vy cv vz cv cin wceq vx cv cA
    wss vy cv vz cv cin cA wss cB vx cv wss cB vy cv vz cv cin wss vx cv vy cv
    vz cv cin cA sseq1 vx cv vy cv vz cv cin cB sseq2 anbi12d elab sylibr vx cv
    cA wss cB vx cv wss wa vy cv cA wss cB vy cv wss wa vx vy cv vy visset vx
    cv vy cv wceq vx cv cA wss vy cv cA wss cB vx cv wss cB vy cv wss vx cv vy
    cv cA sseq1 vx cv vy cv cB sseq2 anbi12d elab vx cv cA wss cB vx cv wss wa
    vz cv cA wss cB vz cv wss wa vx vz cv vz visset vx cv vz cv wceq vx cv cA
    wss vz cv cA wss cB vx cv wss cB vz cv wss vx cv vz cv cA sseq1 vx cv vz cv
    cB sseq2 anbi12d elab syl2anb rgen2a a1i 3jca cA cC wcel cB cA wss cB c0
    wne w3a vx cv cA wss cB vx cv wss wa vx cab cfil wcel c0 vx cv cA wss cB vx
    cv wss wa vx cab wcel wn vx cv cA wss cB vx cv wss wa vx cab cuni vx cv cA
    wss cB vx cv wss wa vx cab wcel wa vy cv vx cv cA wss cB vx cv wss wa vx
    cab wcel vz cv vx cv cA wss cB vx cv wss wa vx cab cuni wss vy cv vz cv wss
    w3a vz cv vx cv cA wss cB vx cv wss wa vx cab wcel wi vz wal vy wal vy cv
    vz cv cin vx cv cA wss cB vx cv wss wa vx cab wcel vz vx cv cA wss cB vx cv
    wss wa vx cab wral vy vx cv cA wss cB vx cv wss wa vx cab wral w3a wb cA vx
    cv cA wss cB vx cv wss wa vx cab cuni wceq cA cC wcel cB cA wss vx cv cA
    wss cB vx cv wss wa vx cab cfil wcel c0 vx cv cA wss cB vx cv wss wa vx cab
    wcel wn vx cv cA wss cB vx cv wss wa vx cab cuni vx cv cA wss cB vx cv wss
    wa vx cab wcel wa vy cv vx cv cA wss cB vx cv wss wa vx cab wcel vz cv vx
    cv cA wss cB vx cv wss wa vx cab cuni wss vy cv vz cv wss w3a vz cv vx cv
    cA wss cB vx cv wss wa vx cab wcel wi vz wal vy wal vy cv vz cv cin vx cv
    cA wss cB vx cv wss wa vx cab wcel vz vx cv cA wss cB vx cv wss wa vx cab
    wral vy vx cv cA wss cB vx cv wss wa vx cab wral w3a wb cB c0 wne cA cC
    wcel vx cv cA wss cB vx cv wss wa vx cab cvv wcel vx cv cA wss cB vx cv wss
    wa vx cab cfil wcel c0 vx cv cA wss cB vx cv wss wa vx cab wcel wn vx cv cA
    wss cB vx cv wss wa vx cab cuni vx cv cA wss cB vx cv wss wa vx cab wcel wa
    vy cv vx cv cA wss cB vx cv wss wa vx cab wcel vz cv vx cv cA wss cB vx cv
    wss wa vx cab cuni wss vy cv vz cv wss w3a vz cv vx cv cA wss cB vx cv wss
    wa vx cab wcel wi vz wal vy wal vy cv vz cv cin vx cv cA wss cB vx cv wss
    wa vx cab wcel vz vx cv cA wss cB vx cv wss wa vx cab wral vy vx cv cA wss
    cB vx cv wss wa vx cab wral w3a wb cB vx cv wss vx cA cC abssexg vy vz cvv
    vx cv cA wss cB vx cv wss wa vx cab vx cv cA wss cB vx cv wss wa vx cab
    cuni vx cv cA wss cB vx cv wss wa vx cab cuni eqid isfil syl 3ad2ant1
    adantr mpbird ex jcai ancomd $.
    $( [12-Nov-2009] $) $( [12-Nov-2009] $)
  $}

  ${
    $d s t x y F $. $d s t x y S $.
    $( No filter containing a finite element is free. $)
    filfinnfr $p |- ( ( F e. Fil /\ S e. F /\ S e. Fin ) -> |^| F =/= (/) ) $=
      cF cfil wcel cS cF wcel cS cfn wcel cF cint c0 wne cF cfil wcel vs cv cF
      wcel vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt wal wa vs
      wex cF cint c0 wne cS cF wcel cS cfn wcel wa cF cfil wcel vs cv cF wcel
      vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt wal wa cF cint c0
      wne vs cF cfil wcel vs cv cF wcel vt cv vs cv wss vt cv cF wcel wa vs cv
      vt cv wceq wi vt wal cF cint c0 wne cF cfil wcel vs cv cF wcel wa vx cv
      vs cv wcel vx wex vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt
      wal cF cint c0 wne wi cF cfil wcel vs cv cF wcel wa vs cv c0 wne vx cv vs
      cv wcel vx wex cF cfil wcel vs cv cF wcel vs cv c0 wne cF cfil wcel vs cv
      cF wcel vs cv c0 vs cv c0 wceq vs cv cF wcel wn c0 cF wcel wn cF cfil
      wcel vs cv c0 wceq vs cv cF wcel c0 cF wcel vs cv c0 cF eleq1 notbid cF
      filesn syl5cbir necon2ad imp vx vs cv n0 sylib cF cfil wcel vs cv cF wcel
      wa vx cv vs cv wcel vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi
      vt wal cF cint c0 wne wi vx cF cfil wcel vs cv cF wcel vx cv vs cv wcel
      vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt wal cF cint c0
      wne wi cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vt cv vs cv wss vt
      cv cF wcel wa vs cv vt cv wceq wi vt wal vx cv cF cint wcel cF cint c0
      wne cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vx cv cF cint wcel vt
      cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt wal cF cfil wcel vs
      cv cF wcel vx cv vs cv wcel w3a vy cv cF wcel vx cv vy cv wcel wn wa vy
      wex vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wn wa vt wex vx cv
      cF cint wcel wn vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt
      wal wn cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy cv cF wcel vx
      cv vy cv wcel wn wa vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wn
      wa vt wex vy cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy cv cF
      wcel vx cv vy cv wcel wn wa vt cv vs cv wss vt cv cF wcel wa vs cv vt cv
      wceq wn wa vt wex vs cv vy cv cin vs cv wss vs cv vy cv cin cF wcel vs cv
      vs cv vy cv cin wceq wn vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq
      wn wa vt wex cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy cv cF
      wcel vx cv vy cv wcel wn wa wa vs cv vy cv cin vs cv wss cF cfil wcel vs
      cv cF wcel vx cv vs cv wcel w3a vy cv cF wcel vx cv vy cv wcel wn wa wa
      vs cv vy cv inss1 a1i cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy
      cv cF wcel vs cv vy cv cin cF wcel vx cv vy cv wcel wn cF cfil wcel vs cv
      cF wcel vy cv cF wcel vs cv vy cv cin cF wcel vx cv vs cv wcel cF cfil
      wcel vs cv cF wcel vy cv cF wcel vs cv vy cv cin cF wcel vs cv vy cv cF
      filint 3expa 3adantl3 adantrr cF cfil wcel vs cv cF wcel vx cv vs cv wcel
      w3a vy cv cF wcel vx cv vy cv wcel wn vs cv vs cv vy cv cin wceq wn cF
      cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy cv cF wcel wa vs cv vs cv
      vy cv cin wceq vx cv vy cv wcel cF cfil wcel vs cv cF wcel vx cv vs cv
      wcel w3a vy cv cF wcel vs cv vs cv vy cv cin wceq vx cv vy cv wcel cF
      cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy cv cF wcel vs cv vs cv vy
      cv cin wceq wa wa vs cv vy cv vx cv vs cv vs cv vy cv cin wceq vs cv vy
      cv wss cF cfil wcel vs cv cF wcel vx cv vs cv wcel w3a vy cv cF wcel vs
      cv vs cv vy cv cin wceq vs cv vy cv wss vs cv vy cv cin vy cv wss vs cv
      vy cv inss2 vs cv vs cv vy cv cin vy cv sseq1 mpbiri ad2antll cF cfil
      wcel vs cv cF wcel vx cv vs cv wcel vy cv cF wcel vs cv vs cv vy cv cin
      wceq wa 3simpl3 sseldd expr con3d impr vt cv vs cv wss vt cv cF wcel wa
      vs cv vt cv wceq wn wa vs cv vy cv cin vs cv wss vs cv vy cv cin cF wcel
      wa vs cv vs cv vy cv cin wceq wn wa vt vs cv vy cv cin vs cv vy cv vs
      visset inex1 vt cv vs cv vy cv cin wceq vt cv vs cv wss vt cv cF wcel wa
      vs cv vy cv cin vs cv wss vs cv vy cv cin cF wcel wa vs cv vt cv wceq wn
      vs cv vs cv vy cv cin wceq wn vt cv vs cv vy cv cin wceq vt cv vs cv wss
      vs cv vy cv cin vs cv wss vt cv cF wcel vs cv vy cv cin cF wcel vt cv vs
      cv vy cv cin vs cv sseq1 vt cv vs cv vy cv cin cF eleq1 anbi12d vt cv vs
      cv vy cv cin wceq vs cv vt cv wceq vs cv vs cv vy cv cin wceq vt cv vs cv
      vy cv cin vs cv eqeq2 notbid anbi12d cla4ev sylan31c ex 19.23adv vy cv cF
      wcel vx cv vy cv wcel wn wa vy wex vy cv cF wcel vx cv vy cv wcel wi vy
      wal wn vx cv cF cint wcel wn vy cv cF wcel vx cv vy cv wcel vy exanali vx
      cv cF cint wcel vy cv cF wcel vx cv vy cv wcel wi vy wal vy vx cv cF vx
      visset elint notbii bitr4i vt cv vs cv wss vt cv cF wcel wa vs cv vt cv
      wceq vt exanali 3imtr3g con4d cF cint vx cv ne0i syl6 3expia 19.23adv mpd
      expimpd 19.23adv cS cF wcel cS cfn wcel wa vs cv cF wcel vs cfn wrex vs
      cv cF wcel vt cv vs cv wss vt cv cF wcel wa vs cv vt cv wceq wi vt wal wa
      vs wex cS cfn wcel cS cF wcel vs cv cF wcel vs cfn wrex vs cv cF wcel cS
      cF wcel vs cS cfn vs cv cS cF eleq1 rcla4ev ancoms vs cv cF wcel vt cv cF
      wcel vs vt vs cv vt cv cF eleq1 finminlem syl syl5 3impib $.
      $( [5-Dec-2009] $) $( [5-Dec-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ultrafilters
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$c UFil $.
  $( Extend class notation with the class of all ultrafilters. $)
  cufil $a class UFil $.

  ${
    $d f x $.
    $( Define the class of all ultrafilters. $)
    df-ufil $a |- UFil = { f e. Fil | A. x e. ~P U. f ( x e. f \/ ( U. f \ x )
    e. f ) } $.
  $}

  ${
    $d f t w x y z F $. $d f t w x y z X $.
    isufil.1 $e |- X = U. F $.
    $( The property of being an ultrafilter. $)
    isufil $p |- ( F e. UFil <-> ( F e. Fil /\ A. x e. ~P X ( x e. F \/ ( X \ x
    ) e. F ) ) ) $=
      vx cv vf cv wcel vf cv cuni vx cv cdif vf cv wcel wo vx vf cv cuni cpw
      wral vx cv cF wcel cX vx cv cdif cF wcel wo vx cX cpw wral vf cF cfil
      cufil vf cv cF wceq vx cv vf cv wcel vf cv cuni vx cv cdif vf cv wcel wo
      vx cv cF wcel cX vx cv cdif cF wcel wo vx vf cv cuni cpw cX cpw vf cv cF
      wceq vf cv cuni cX wceq vf cv cuni cpw cX cpw wceq vf cv cF wceq vf cv
      cuni cF cuni cX vf cv cF unieq isufil.1 syl6eqr vf cv cuni cX pweq syl vf
      cv cF wceq vx cv vf cv wcel vx cv cF wcel vf cv cuni vx cv cdif vf cv
      wcel cX vx cv cdif cF wcel vf cv cF vx cv eleq2 vf cv cF wceq vf cv cuni
      vx cv cdif cX vx cv cdif vf cv cF vf cv cF wceq vf cv cuni cX vx cv vf cv
      cF wceq vf cv cuni cF cuni cX vf cv cF unieq isufil.1 syl6eqr difeq1d vf
      cv cF wceq id eleq12d orbi12d raleq12d vx vf df-ufil elrab2 $.
      $( [30-Nov-2009] $) $( [30-Nov-2009] $)

    $( The maximal property of an ultrafilter. $)
    isufil2 $p |- ( F e. UFil <-> ( F e. Fil /\ A. f e. Fil ( ( X = U. f /\ F
    C_ f ) -> F = f ) ) ) $=
      cF cufil wcel cF cfil wcel vx cv cF wcel cX vx cv cdif cF wcel wo vx cX
      cpw wral wa cF cfil wcel cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq
      wi vf cfil wral wa vx cF cX isufil.1 isufil cF cfil wcel vx cv cF wcel cX
      vx cv cdif cF wcel wo vx cX cpw wral cX vf cv cuni wceq cF vf cv wss wa
      cF vf cv wceq wi vf cfil wral cF cfil wcel vx cv cF wcel cX vx cv cdif cF
      wcel wo vx cX cpw wral cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq
      wi vf cfil wral cF cfil wcel vx cv cF wcel cX vx cv cdif cF wcel wo vx cX
      cpw wral cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil cF
      cfil wcel vf cv cfil wcel vx cv cF wcel cX vx cv cdif cF wcel wo vx cX
      cpw wral cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi cF cfil wcel
      vf cv cfil wcel vx cv cF wcel cX vx cv cdif cF wcel wo vx cX cpw wral cX
      vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi cF cfil wcel vf cv cfil
      wcel wa vx cv cF wcel cX vx cv cdif cF wcel wo vx cX cpw wral wa cX vf cv
      cuni wceq cF vf cv wss wa cF vf cv wss vf cv cF wss wa cF vf cv wceq cF
      cfil wcel vf cv cfil wcel wa vx cv cF wcel cX vx cv cdif cF wcel wo vx cX
      cpw wral wa cX vf cv cuni wceq cF vf cv wss wa cF vf cv wss vf cv cF wss
      cX vf cv cuni wceq cF vf cv wss wa cF vf cv wss wi cF cfil wcel vf cv
      cfil wcel wa vx cv cF wcel cX vx cv cdif cF wcel wo vx cX cpw wral wa cX
      vf cv cuni wceq cF vf cv wss pm3.27 a1i cF cfil wcel vf cv cfil wcel wa
      vx cv cF wcel cX vx cv cdif cF wcel wo vx cX cpw wral cX vf cv cuni wceq
      cF vf cv wss wa vf cv cF wss cF cfil wcel vf cv cfil wcel wa vx cv cF
      wcel cX vx cv cdif cF wcel wo vx cX cpw wral cX vf cv cuni wceq cF vf cv
      wss wa wa wa vt vf cv cF cF cfil wcel vf cv cfil wcel wa vx cv cF wcel cX
      vx cv cdif cF wcel wo vx cX cpw wral cX vf cv cuni wceq cF vf cv wss wa
      vt cv vf cv wcel vt cv cF wcel wi cF cfil wcel vf cv cfil wcel wa vt cv
      vf cv wcel cX vf cv cuni wceq cF vf cv wss wa vx cv cF wcel cX vx cv cdif
      cF wcel wo vx cX cpw wral vt cv cF wcel cF cfil wcel vf cv cfil wcel wa
      vt cv vf cv wcel cX vf cv cuni wceq cF vf cv wss wa vx cv cF wcel cX vx
      cv cdif cF wcel wo vx cX cpw wral vt cv cF wcel wi cF cfil wcel vf cv
      cfil wcel wa vt cv vf cv wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vx
      cv cF wcel cX vx cv cdif cF wcel wo vx cX cpw wral vt cv cF wcel cX vt cv
      cdif cF wcel wo vt cv cF wcel cF cfil wcel vf cv cfil wcel wa vt cv vf cv
      wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vt cv cX cpw wcel vx cv cF
      wcel cX vx cv cdif cF wcel wo vx cX cpw wral vt cv cF wcel cX vt cv cdif
      cF wcel wo wi cF cfil wcel vf cv cfil wcel wa vt cv vf cv wcel cX vf cv
      cuni wceq cF vf cv wss wa wa wa vt cv vf cv cuni cpw cX cpw vt cv vf cv
      wcel vt cv vf cv cuni cpw wcel cF cfil wcel vf cv cfil wcel wa cX vf cv
      cuni wceq cF vf cv wss wa vt cv vf cv wcel vt cv vf cv cuni wss vt cv vf
      cv cuni cpw wcel vt cv vf cv elssuni vt cv vf cv cuni vt visset elpw
      sylibr ad2antrl cX vf cv cuni wceq cF vf cv wss wa cX cpw vf cv cuni cpw
      wceq cF cfil wcel vf cv cfil wcel wa vt cv vf cv wcel cX vf cv cuni wceq
      cX cpw vf cv cuni cpw wceq cF vf cv wss cX vf cv cuni pweq adantr
      ad2antll eleqtrrd vx cv cF wcel cX vx cv cdif cF wcel wo vt cv cF wcel cX
      vt cv cdif cF wcel wo vx vt cv cX cpw vx cv vt cv wceq vx cv cF wcel vt
      cv cF wcel cX vx cv cdif cF wcel cX vt cv cdif cF wcel vx cv vt cv cF
      eleq1 vx cv vt cv wceq cX vx cv cdif cX vt cv cdif cF vx cv vt cv cX
      difeq2 eleq1d orbi12d rcla4v syl cF cfil wcel vf cv cfil wcel wa vt cv vf
      cv wcel cX vf cv cuni wceq cF vf cv wss wa wa wa cX vt cv cdif cF wcel wn
      vt cv cF wcel wi vt cv cF wcel vt cv cF wcel cX vt cv cdif cF wcel wo cF
      cfil wcel vf cv cfil wcel wa vt cv vf cv wcel cX vf cv cuni wceq cF vf cv
      wss wa wa wa cX vt cv cdif cF wcel wn cX vt cv cdif cF wcel wn vt cv cF
      wcel wi vt cv cF wcel wi cF cfil wcel vf cv cfil wcel wa vt cv vf cv wcel
      cX vf cv cuni wceq cF vf cv wss wa wa wa cX vt cv cdif cF wcel c0 vf cv
      wcel vf cv cfil wcel c0 vf cv wcel wn cF cfil wcel vt cv vf cv wcel cX vf
      cv cuni wceq cF vf cv wss wa wa vf cv filesn ad2antlr cF cfil wcel vf cv
      cfil wcel wa vt cv vf cv wcel cX vf cv cuni wceq cF vf cv wss wa wa wa cX
      vt cv cdif cF wcel wa vt cv cX vt cv cdif cin vf cv c0 vf cv cfil wcel vt
      cv vf cv wcel cX vt cv cdif vf cv wcel vt cv cX vt cv cdif cin vf cv wcel
      cF cfil wcel vf cv cfil wcel wa vt cv vf cv wcel cX vf cv cuni wceq cF vf
      cv wss wa wa wa cX vt cv cdif cF wcel wa vt cv cX vt cv cdif vf cv filint
      cF cfil wcel vf cv cfil wcel vt cv vf cv wcel cX vf cv cuni wceq cF vf cv
      wss wa wa cX vt cv cdif cF wcel simpllr cF cfil wcel vf cv cfil wcel wa
      vt cv vf cv wcel cX vf cv cuni wceq cF vf cv wss wa cX vt cv cdif cF wcel
      simplrl cF cfil wcel vf cv cfil wcel wa vt cv vf cv wcel cX vf cv cuni
      wceq cF vf cv wss wa wa wa cX vt cv cdif cF wcel wa cF vf cv cX vt cv
      cdif vt cv vf cv wcel cX vf cv cuni wceq cF vf cv wss wa wa cF vf cv wss
      cF cfil wcel vf cv cfil wcel wa cX vt cv cdif cF wcel vt cv vf cv wcel cX
      vf cv cuni wceq cF vf cv wss simprr ad2antlr cF cfil wcel vf cv cfil wcel
      wa vt cv vf cv wcel cX vf cv cuni wceq cF vf cv wss wa wa wa cX vt cv
      cdif cF wcel pm3.27 sseldd syl3anc vt cv cX difdisj syl5eqelr mtand cX vt
      cv cdif cF wcel wn vt cv cF wcel pm2.27 syl vt cv cF wcel cX vt cv cdif
      cF wcel wo cX vt cv cdif cF wcel vt cv cF wcel wo cX vt cv cdif cF wcel
      wn vt cv cF wcel wi vt cv cF wcel cX vt cv cdif cF wcel orcom cX vt cv
      cdif cF wcel vt cv cF wcel df-or bitri syl5ib syld exp32 com24 imp32
      ssrdv expr jcad cF vf cv eqss syl6ibr exp31 com23 r19.21adv cF cfil wcel
      cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral vx cv cF
      wcel cX vx cv cdif cF wcel wo vx cX cpw cF cfil wcel cX vf cv cuni wceq
      cF vf cv wss wa cF vf cv wceq wi vf cfil wral vx cv cX wss vx cv cF wcel
      cX vx cv cdif cF wcel wo vx cv cX cpw wcel cF cfil wcel vx cv cX wss cX
      vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral vx cv cF
      wcel cX vx cv cdif cF wcel wo cF cfil wcel vx cv cX wss cX vf cv cuni
      wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral vx cv cF wcel cX vx cv
      cdif cF wcel wo wi cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy
      cF wral cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral
      vx cv cF wcel cX vx cv cdif cF wcel wo wi cF cfil wcel vx cv cX wss wa vy
      cv vx cv cin c0 wne vy cF wral cX vf cv cuni wceq cF vf cv wss wa cF vf
      cv wceq wi vf cfil wral vx cv cF wcel vx cv cF wcel cX vx cv cdif cF wcel
      wo cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral cX vf
      cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral vx cv cF wcel
      wi cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cX
      vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral cF cF vx cv
      csn cun cfi cfv cfg cfv wceq vx cv cF wcel cF cfil wcel vx cv cX wss wa
      vy cv vx cv cin c0 wne vy cF wral wa cX vf cv cuni wceq cF vf cv wss wa
      cF vf cv wceq wi vf cfil wral cX cF vx cv csn cun cfi cfv cfg cfv cuni
      wceq cF cF vx cv csn cun cfi cfv cfg cfv wss wa cF cF vx cv csn cun cfi
      cfv cfg cfv wceq cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy
      cF wral wa cX cF vx cv csn cun cfi cfv cfg cfv cuni wceq cF cF vx cv csn
      cun cfi cfv cfg cfv wss cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0
      wne vy cF wral wa cX cF vx cv csn cun cuni cF vx cv csn cun cfi cfv cuni
      cF vx cv csn cun cfi cfv cfg cfv cuni cF cfil wcel vx cv cX wss wa vy cv
      vx cv cin c0 wne vy cF wral wa cX vx cv cun cX cF vx cv csn cun cuni vx
      cv cX wss cX vx cv cun cX wceq cF cfil wcel vy cv vx cv cin c0 wne vy cF
      wral vx cv cX wss cX vx cv cun cX wceq vx cv cX ssequn2 biimpi ad2antlr
      cX vx cv cun cF cuni vx cv csn cuni cun cF vx cv csn cun cuni cX cF cuni
      vx cv vx cv csn cuni isufil.1 vx cv csn cuni vx cv vx cv vx visset unisn
      eqcomi uneq12i cF vx cv csn uniun eqtr4i syl5reqr cF cfil wcel cF vx cv
      csn cun cuni cF vx cv csn cun cfi cfv cuni wceq vx cv cX wss vy cv vx cv
      cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun cvv wcel cF vx cv csn
      cun cuni cF vx cv csn cun cfi cfv cuni wceq cF cfil wcel vx cv csn cvv
      wcel cF vx cv csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg
      mpan2 cF vx cv csn cun cvv fiuni syl ad2antrr cF cfil wcel vx cv cX wss
      wa vy cv vx cv cin c0 wne vy cF wral wa cF vx cv csn cun cfi cfv cfbas
      wcel cF vx cv csn cun cfi cfv cuni cF vx cv csn cun cfi cfv cfg cfv cuni
      wceq cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF
      vx cv csn cun cfi cfv cfbas wcel cF vx cv csn cun c0 wne c0 cF vx cv csn
      cun cfi cfv wnel wa cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne
      vy cF wral wa cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel cF
      cfil wcel cF vx cv csn cun c0 wne vx cv cX wss vy cv vx cv cin c0 wne vy
      cF wral cF cfil wcel cX cF wcel cF c0 wne cF vx cv csn cun c0 wne cF cX
      isufil.1 filusb cF cX ne0i cF cF vx cv csn cun wss cF c0 wne cF vx cv csn
      cun c0 wne cF vx cv csn ssun1 cF cF vx cv csn cun ssn0 mpan 3syl ad2antrr
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa c0 cF
      vx cv csn cun cfi cfv wnel vz cv vw cv cin c0 wne vw vx cv csn wral vz cF
      wral cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vz
      cv vw cv cin c0 wne vz vw cF vx cv csn cF cfil wcel vx cv cX wss wa vy cv
      vx cv cin c0 wne vy cF wral wa vz cv cF wcel vw cv vx cv csn wcel vz cv
      vw cv cin c0 wne cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy
      cF wral wa vz cv cF wcel vw cv vx cv wceq vz cv vw cv cin c0 wne vw cv vx
      cv csn wcel cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral vz cv cF wcel vw cv vx cv wceq vz cv vw cv cin c0 wne wi vw cv vx cv
      wceq vz cv vw cv cin c0 wne vz cv vx cv cin c0 wne cF cfil wcel vx cv cX
      wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel wa wa vw cv vx cv
      wceq vz cv vw cv cin vz cv vx cv cin c0 vw cv vx cv vz cv ineq2 neeq1d cF
      cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel
      vz cv vx cv cin c0 wne vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel vz
      cv vx cv cin c0 wne wi wi cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0
      wne vz cv vx cv cin c0 wne vy vz cv cF vy cv vz cv wceq vy cv vx cv cin
      vz cv vx cv cin c0 vy cv vz cv vx cv ineq1 neeq1d rcla4cv a1i imp32
      syl5cbir expr vw vx cv elsn syl7ib imp3a r19.21aivv cF cfbas wcel vx cv
      csn cfbas wcel c0 cF vx cv csn cun cfi cfv wnel vz cv vw cv cin c0 wne vw
      vx cv csn wral vz cF wral wb cF cfil wcel vx cv cX wss wa vy cv vx cv cin
      c0 wne vy cF wral wa vz vw cF vx cv csn fbunfip cF cfil wcel cF cfbas
      wcel vx cv cX wss vy cv vx cv cin c0 wne vy cF wral cF filfbas ad2antrr
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vx cv
      csn cfil wcel vx cv csn cfbas wcel cF cfil wcel vy cv vx cv cin c0 wne vy
      cF wral vx cv csn cfil wcel vx cv cX wss cF cfil wcel vy cv vx cv cin c0
      wne vy cF wral wa cX vx cv cin c0 wne vx cv c0 wne vx cv csn cfil wcel cF
      cfil wcel vy cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne cF cfil
      wcel cX cF wcel vy cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne wi
      cF cX isufil.1 filusb vy cv vx cv cin c0 wne cX vx cv cin c0 wne vy cX cF
      vy cv cX wceq vy cv vx cv cin cX vx cv cin c0 vy cv cX vx cv ineq1 neeq1d
      rcla4v syl imp cX vx cv cin vx cv wss cX vx cv cin c0 wne vx cv c0 wne cX
      vx cv inss2 cX vx cv cin vx cv ssn0 mpan vx cv cvv wcel vx cv c0 wne vx
      cv csn cfil wcel vx visset vx cv cvv oefil2 mpan 3syl adantlr vx cv csn
      filfbas syl sylanc mpbird jca cF cfil wcel cF vx cv csn cun cfi cfv cfbas
      wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel wa wb vx cv
      cX wss vy cv vx cv cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun
      cvv wcel cF vx cv csn cun cfi cfv cfbas wcel cF vx cv csn cun c0 wne c0
      cF vx cv csn cun cfi cfv wnel wa wb cF cfil wcel vx cv csn cvv wcel cF vx
      cv csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg mpan2 cF vx cv
      csn cun cvv fsubbas syl ad2antrr mpbird cF vx cv csn cun cfi cfv cF vx cv
      csn cun cfi cfv cuni cF vx cv csn cun cfi cfv cuni eqid fgbas syl 3eqtrd
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF cF
      vx cv csn cun cfi cfv cF vx cv csn cun cfi cfv cfg cfv cF cfil wcel vx cv
      cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF cF vx cv csn cun cF vx
      cv csn cun cfi cfv cF cF vx cv csn cun wss cF cfil wcel vx cv cX wss wa
      vy cv vx cv cin c0 wne vy cF wral wa cF vx cv csn ssun1 a1i cF cfil wcel
      cF vx cv csn cun cF vx cv csn cun cfi cfv wss vx cv cX wss vy cv vx cv
      cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun cvv wcel cF vx cv csn
      cun cF vx cv csn cun cfi cfv wss cF cfil wcel vx cv csn cvv wcel cF vx cv
      csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg mpan2 cF vx cv
      csn cun cvv abfi2 syl ad2antrr sstrd cF cfil wcel vx cv cX wss wa vy cv
      vx cv cin c0 wne vy cF wral wa cF vx cv csn cun cfi cfv cfbas wcel cF vx
      cv csn cun cfi cfv cF vx cv csn cun cfi cfv cfg cfv wss cF cfil wcel vx
      cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF vx cv csn cun cfi
      cfv cfbas wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel
      wa cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF
      vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel cF cfil wcel cF vx
      cv csn cun c0 wne vx cv cX wss vy cv vx cv cin c0 wne vy cF wral cF cfil
      wcel cX cF wcel cF c0 wne cF vx cv csn cun c0 wne cF cX isufil.1 filusb
      cF cX ne0i cF cF vx cv csn cun wss cF c0 wne cF vx cv csn cun c0 wne cF
      vx cv csn ssun1 cF cF vx cv csn cun ssn0 mpan 3syl ad2antrr cF cfil wcel
      vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa c0 cF vx cv csn cun
      cfi cfv wnel vz cv vw cv cin c0 wne vw vx cv csn wral vz cF wral cF cfil
      wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vz cv vw cv cin
      c0 wne vz vw cF vx cv csn cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0
      wne vy cF wral wa vz cv cF wcel vw cv vx cv csn wcel vz cv vw cv cin c0
      wne cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vz
      cv cF wcel vw cv vx cv wceq vz cv vw cv cin c0 wne vw cv vx cv csn wcel
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF
      wcel vw cv vx cv wceq vz cv vw cv cin c0 wne wi vw cv vx cv wceq vz cv vw
      cv cin c0 wne vz cv vx cv cin c0 wne cF cfil wcel vx cv cX wss wa vy cv
      vx cv cin c0 wne vy cF wral vz cv cF wcel wa wa vw cv vx cv wceq vz cv vw
      cv cin vz cv vx cv cin c0 vw cv vx cv vz cv ineq2 neeq1d cF cfil wcel vx
      cv cX wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel vz cv vx cv
      cin c0 wne vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel vz cv vx cv
      cin c0 wne wi wi cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vz
      cv vx cv cin c0 wne vy vz cv cF vy cv vz cv wceq vy cv vx cv cin vz cv vx
      cv cin c0 vy cv vz cv vx cv ineq1 neeq1d rcla4cv a1i imp32 syl5cbir expr
      vw vx cv elsn syl7ib imp3a r19.21aivv cF cfbas wcel vx cv csn cfbas wcel
      c0 cF vx cv csn cun cfi cfv wnel vz cv vw cv cin c0 wne vw vx cv csn wral
      vz cF wral wb cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral wa vz vw cF vx cv csn fbunfip cF cfil wcel cF cfbas wcel vx cv cX
      wss vy cv vx cv cin c0 wne vy cF wral cF filfbas ad2antrr cF cfil wcel vx
      cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vx cv csn cfil wcel vx
      cv csn cfbas wcel cF cfil wcel vy cv vx cv cin c0 wne vy cF wral vx cv
      csn cfil wcel vx cv cX wss cF cfil wcel vy cv vx cv cin c0 wne vy cF wral
      wa cX vx cv cin c0 wne vx cv c0 wne vx cv csn cfil wcel cF cfil wcel vy
      cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne cF cfil wcel cX cF
      wcel vy cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne wi cF cX
      isufil.1 filusb vy cv vx cv cin c0 wne cX vx cv cin c0 wne vy cX cF vy cv
      cX wceq vy cv vx cv cin cX vx cv cin c0 vy cv cX vx cv ineq1 neeq1d
      rcla4v syl imp cX vx cv cin vx cv wss cX vx cv cin c0 wne vx cv c0 wne cX
      vx cv inss2 cX vx cv cin vx cv ssn0 mpan vx cv cvv wcel vx cv c0 wne vx
      cv csn cfil wcel vx visset vx cv cvv oefil2 mpan 3syl adantlr vx cv csn
      filfbas syl sylanc mpbird jca cF cfil wcel cF vx cv csn cun cfi cfv cfbas
      wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel wa wb vx cv
      cX wss vy cv vx cv cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun
      cvv wcel cF vx cv csn cun cfi cfv cfbas wcel cF vx cv csn cun c0 wne c0
      cF vx cv csn cun cfi cfv wnel wa wb cF cfil wcel vx cv csn cvv wcel cF vx
      cv csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg mpan2 cF vx cv
      csn cun cvv fsubbas syl ad2antrr mpbird cF vx cv csn cun cfi cfv fbssfg
      syl sstrd jca cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral wa cF vx cv csn cun cfi cfv cfbas wcel cF vx cv csn cun cfi cfv cfg
      cfv cfil wcel cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil
      wral cX cF vx cv csn cun cfi cfv cfg cfv cuni wceq cF cF vx cv csn cun
      cfi cfv cfg cfv wss wa cF cF vx cv csn cun cfi cfv cfg cfv wceq wi wi cF
      cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF vx cv
      csn cun cfi cfv cfbas wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun
      cfi cfv wnel wa cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral wa cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel cF cfil
      wcel cF vx cv csn cun c0 wne vx cv cX wss vy cv vx cv cin c0 wne vy cF
      wral cF cfil wcel cX cF wcel cF c0 wne cF vx cv csn cun c0 wne cF cX
      isufil.1 filusb cF cX ne0i cF cF vx cv csn cun wss cF c0 wne cF vx cv csn
      cun c0 wne cF vx cv csn ssun1 cF cF vx cv csn cun ssn0 mpan 3syl ad2antrr
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa c0 cF
      vx cv csn cun cfi cfv wnel vz cv vw cv cin c0 wne vw vx cv csn wral vz cF
      wral cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vz
      cv vw cv cin c0 wne vz vw cF vx cv csn cF cfil wcel vx cv cX wss wa vy cv
      vx cv cin c0 wne vy cF wral wa vz cv cF wcel vw cv vx cv csn wcel vz cv
      vw cv cin c0 wne cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy
      cF wral wa vz cv cF wcel vw cv vx cv wceq vz cv vw cv cin c0 wne vw cv vx
      cv csn wcel cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral vz cv cF wcel vw cv vx cv wceq vz cv vw cv cin c0 wne wi vw cv vx cv
      wceq vz cv vw cv cin c0 wne vz cv vx cv cin c0 wne cF cfil wcel vx cv cX
      wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel wa wa vw cv vx cv
      wceq vz cv vw cv cin vz cv vx cv cin c0 vw cv vx cv vz cv ineq2 neeq1d cF
      cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel
      vz cv vx cv cin c0 wne vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel vz
      cv vx cv cin c0 wne wi wi cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0
      wne vz cv vx cv cin c0 wne vy vz cv cF vy cv vz cv wceq vy cv vx cv cin
      vz cv vx cv cin c0 vy cv vz cv vx cv ineq1 neeq1d rcla4cv a1i imp32
      syl5cbir expr vw vx cv elsn syl7ib imp3a r19.21aivv cF cfbas wcel vx cv
      csn cfbas wcel c0 cF vx cv csn cun cfi cfv wnel vz cv vw cv cin c0 wne vw
      vx cv csn wral vz cF wral wb cF cfil wcel vx cv cX wss wa vy cv vx cv cin
      c0 wne vy cF wral wa vz vw cF vx cv csn fbunfip cF cfil wcel cF cfbas
      wcel vx cv cX wss vy cv vx cv cin c0 wne vy cF wral cF filfbas ad2antrr
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vx cv
      csn cfil wcel vx cv csn cfbas wcel cF cfil wcel vy cv vx cv cin c0 wne vy
      cF wral vx cv csn cfil wcel vx cv cX wss cF cfil wcel vy cv vx cv cin c0
      wne vy cF wral wa cX vx cv cin c0 wne vx cv c0 wne vx cv csn cfil wcel cF
      cfil wcel vy cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne cF cfil
      wcel cX cF wcel vy cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne wi
      cF cX isufil.1 filusb vy cv vx cv cin c0 wne cX vx cv cin c0 wne vy cX cF
      vy cv cX wceq vy cv vx cv cin cX vx cv cin c0 vy cv cX vx cv ineq1 neeq1d
      rcla4v syl imp cX vx cv cin vx cv wss cX vx cv cin c0 wne vx cv c0 wne cX
      vx cv inss2 cX vx cv cin vx cv ssn0 mpan vx cv cvv wcel vx cv c0 wne vx
      cv csn cfil wcel vx visset vx cv cvv oefil2 mpan 3syl adantlr vx cv csn
      filfbas syl sylanc mpbird jca cF cfil wcel cF vx cv csn cun cfi cfv cfbas
      wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel wa wb vx cv
      cX wss vy cv vx cv cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun
      cvv wcel cF vx cv csn cun cfi cfv cfbas wcel cF vx cv csn cun c0 wne c0
      cF vx cv csn cun cfi cfv wnel wa wb cF cfil wcel vx cv csn cvv wcel cF vx
      cv csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg mpan2 cF vx cv
      csn cun cvv fsubbas syl ad2antrr mpbird cF vx cv csn cun cfi cfv fgfil cX
      vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi cX cF vx cv csn cun cfi
      cfv cfg cfv cuni wceq cF cF vx cv csn cun cfi cfv cfg cfv wss wa cF cF vx
      cv csn cun cfi cfv cfg cfv wceq wi vf cF vx cv csn cun cfi cfv cfg cfv
      cfil vf cv cF vx cv csn cun cfi cfv cfg cfv wceq cX vf cv cuni wceq cF vf
      cv wss wa cX cF vx cv csn cun cfi cfv cfg cfv cuni wceq cF cF vx cv csn
      cun cfi cfv cfg cfv wss wa cF vf cv wceq cF cF vx cv csn cun cfi cfv cfg
      cfv wceq vf cv cF vx cv csn cun cfi cfv cfg cfv wceq cX vf cv cuni wceq
      cX cF vx cv csn cun cfi cfv cfg cfv cuni wceq cF vf cv wss cF cF vx cv
      csn cun cfi cfv cfg cfv wss vf cv cF vx cv csn cun cfi cfv cfg cfv wceq
      vf cv cuni cF vx cv csn cun cfi cfv cfg cfv cuni cX vf cv cF vx cv csn
      cun cfi cfv cfg cfv unieq eqeq2d vf cv cF vx cv csn cun cfi cfv cfg cfv
      cF sseq2 anbi12d vf cv cF vx cv csn cun cfi cfv cfg cfv cF eqeq2 imbi12d
      rcla4v 3syl mpid cF cF vx cv csn cun cfi cfv cfg cfv wceq vx cv cF wcel
      vx cv cF vx cv csn cun cfi cfv cfg cfv wcel cF cfil wcel vx cv cX wss wa
      vy cv vx cv cin c0 wne vy cF wral wa cF cF vx cv csn cun cfi cfv cfg cfv
      vx cv eleq2 cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral wa vx cv csn cF vx cv csn cun cfi cfv cfg cfv vx cv cF cfil wcel vx
      cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vx cv csn cF vx cv csn
      cun cfi cfv cF vx cv csn cun cfi cfv cfg cfv cF cfil wcel vx cv cX wss wa
      vy cv vx cv cin c0 wne vy cF wral wa vx cv csn cF vx cv csn cun cF vx cv
      csn cun cfi cfv vx cv csn cF vx cv csn cun wss cF cfil wcel vx cv cX wss
      wa vy cv vx cv cin c0 wne vy cF wral wa vx cv csn cF ssun2 a1i cF cfil
      wcel cF vx cv csn cun cF vx cv csn cun cfi cfv wss vx cv cX wss vy cv vx
      cv cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun cvv wcel cF vx cv
      csn cun cF vx cv csn cun cfi cfv wss cF cfil wcel vx cv csn cvv wcel cF
      vx cv csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg mpan2 cF vx
      cv csn cun cvv abfi2 syl ad2antrr sstrd cF cfil wcel vx cv cX wss wa vy
      cv vx cv cin c0 wne vy cF wral wa cF vx cv csn cun cfi cfv cfbas wcel cF
      vx cv csn cun cfi cfv cF vx cv csn cun cfi cfv cfg cfv wss cF cfil wcel
      vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF vx cv csn cun cfi
      cfv cfbas wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel
      wa cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa cF
      vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel cF cfil wcel cF vx
      cv csn cun c0 wne vx cv cX wss vy cv vx cv cin c0 wne vy cF wral cF cfil
      wcel cX cF wcel cF c0 wne cF vx cv csn cun c0 wne cF cX isufil.1 filusb
      cF cX ne0i cF cF vx cv csn cun wss cF c0 wne cF vx cv csn cun c0 wne cF
      vx cv csn ssun1 cF cF vx cv csn cun ssn0 mpan 3syl ad2antrr cF cfil wcel
      vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa c0 cF vx cv csn cun
      cfi cfv wnel vz cv vw cv cin c0 wne vw vx cv csn wral vz cF wral cF cfil
      wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vz cv vw cv cin
      c0 wne vz vw cF vx cv csn cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0
      wne vy cF wral wa vz cv cF wcel vw cv vx cv csn wcel vz cv vw cv cin c0
      wne cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vz
      cv cF wcel vw cv vx cv wceq vz cv vw cv cin c0 wne vw cv vx cv csn wcel
      cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF
      wcel vw cv vx cv wceq vz cv vw cv cin c0 wne wi vw cv vx cv wceq vz cv vw
      cv cin c0 wne vz cv vx cv cin c0 wne cF cfil wcel vx cv cX wss wa vy cv
      vx cv cin c0 wne vy cF wral vz cv cF wcel wa wa vw cv vx cv wceq vz cv vw
      cv cin vz cv vx cv cin c0 vw cv vx cv vz cv ineq2 neeq1d cF cfil wcel vx
      cv cX wss wa vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel vz cv vx cv
      cin c0 wne vy cv vx cv cin c0 wne vy cF wral vz cv cF wcel vz cv vx cv
      cin c0 wne wi wi cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vz
      cv vx cv cin c0 wne vy vz cv cF vy cv vz cv wceq vy cv vx cv cin vz cv vx
      cv cin c0 vy cv vz cv vx cv ineq1 neeq1d rcla4cv a1i imp32 syl5cbir expr
      vw vx cv elsn syl7ib imp3a r19.21aivv cF cfbas wcel vx cv csn cfbas wcel
      c0 cF vx cv csn cun cfi cfv wnel vz cv vw cv cin c0 wne vw vx cv csn wral
      vz cF wral wb cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wne vy cF
      wral wa vz vw cF vx cv csn fbunfip cF cfil wcel cF cfbas wcel vx cv cX
      wss vy cv vx cv cin c0 wne vy cF wral cF filfbas ad2antrr cF cfil wcel vx
      cv cX wss wa vy cv vx cv cin c0 wne vy cF wral wa vx cv csn cfil wcel vx
      cv csn cfbas wcel cF cfil wcel vy cv vx cv cin c0 wne vy cF wral vx cv
      csn cfil wcel vx cv cX wss cF cfil wcel vy cv vx cv cin c0 wne vy cF wral
      wa cX vx cv cin c0 wne vx cv c0 wne vx cv csn cfil wcel cF cfil wcel vy
      cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne cF cfil wcel cX cF
      wcel vy cv vx cv cin c0 wne vy cF wral cX vx cv cin c0 wne wi cF cX
      isufil.1 filusb vy cv vx cv cin c0 wne cX vx cv cin c0 wne vy cX cF vy cv
      cX wceq vy cv vx cv cin cX vx cv cin c0 vy cv cX vx cv ineq1 neeq1d
      rcla4v syl imp cX vx cv cin vx cv wss cX vx cv cin c0 wne vx cv c0 wne cX
      vx cv inss2 cX vx cv cin vx cv ssn0 mpan vx cv cvv wcel vx cv c0 wne vx
      cv csn cfil wcel vx visset vx cv cvv oefil2 mpan 3syl adantlr vx cv csn
      filfbas syl sylanc mpbird jca cF cfil wcel cF vx cv csn cun cfi cfv cfbas
      wcel cF vx cv csn cun c0 wne c0 cF vx cv csn cun cfi cfv wnel wa wb vx cv
      cX wss vy cv vx cv cin c0 wne vy cF wral cF cfil wcel cF vx cv csn cun
      cvv wcel cF vx cv csn cun cfi cfv cfbas wcel cF vx cv csn cun c0 wne c0
      cF vx cv csn cun cfi cfv wnel wa wb cF cfil wcel vx cv csn cvv wcel cF vx
      cv csn cun cvv wcel vx cv snex cF vx cv csn cfil cvv unexg mpan2 cF vx cv
      csn cun cvv fsubbas syl ad2antrr mpbird cF vx cv csn cun cfi cfv fbssfg
      syl sstrd vx cv vx cv csn wcel cF cfil wcel vx cv cX wss wa vy cv vx cv
      cin c0 wne vy cF wral wa vx cv vx visset snid a1i sseldd syl5cbir syld ex
      vx cv cF wcel cX vx cv cdif cF wcel orc syl8 cF cfil wcel vx cv cX wss wa
      vy cv vx cv cin c0 wne vy cF wral wn cX vf cv cuni wceq cF vf cv wss wa
      cF vf cv wceq wi vf cfil wral cX vx cv cdif cF wcel vx cv cF wcel cX vx
      cv cdif cF wcel wo cF cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wceq
      vy cF wrex cX vf cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil
      wral cX vx cv cdif cF wcel wi vy cv vx cv cin c0 wne vy cF wral wn cF
      cfil wcel vx cv cX wss wa vy cv vx cv cin c0 wceq cX vf cv cuni wceq cF
      vf cv wss wa cF vf cv wceq wi vf cfil wral cX vx cv cdif cF wcel wi vy cF
      cF cfil wcel vx cv cX wss wa vy cv cF wcel vy cv vx cv cin c0 wceq cX vf
      cv cuni wceq cF vf cv wss wa cF vf cv wceq wi vf cfil wral cX vx cv cdif
      cF wcel cF cfil wcel vx cv cX wss wa vy cv cF wcel vy cv vx cv cin c0
      wceq cX vx cv cdif cF wcel cF cfil wcel vy cv cF wcel cX vx cv cdif cX
      wss vy cv cX vx cv cdif wss w3a cX vx cv cdif cF wcel cF cfil wcel vx cv
      cX wss wa vy cv cF wcel vy cv vx cv cin c0 wceq wa wa vy cv cX vx cv cdif
      cF cX isufil.1 fillsb cF cfil wcel vx cv cX wss vy cv cF wcel vy cv vx cv
      cin c0 wceq wa simpll cF cfil wcel vx cv cX wss wa vy cv cF wcel vy cv vx
      cv cin c0 wceq wa wa vy cv cF wcel cX vx cv cdif cX wss vy cv cX vx cv
      cdif wss cF cfil wcel vx cv cX wss wa vy cv cF wcel vy cv vx cv cin c0
      wceq simprl cX vx cv cdif cX wss cF cfil wcel vx cv cX wss wa vy cv cF
      wcel vy cv vx cv cin c0 wceq wa wa cX vx cv difss a1i cF cfil wcel vx cv
      cX wss wa vy cv cF wcel vy cv vx cv cin c0 wceq vy cv cX vx cv cdif wss
      cF cfil wcel vx cv cX wss wa vy cv cF wcel wa vy cv vx cv cin c0 wceq vy
      cv cX vx cv cdif wss vy cv cF wcel vy cv vx cv cin c0 wceq vy cv cX vx cv
      cdif wss wb cF cfil wcel vx cv cX wss wa vy cv cF wcel vy cv cX wss vy cv
      vx cv cin c0 wceq vy cv cX vx cv cdif wss wb vy cv cF wcel vy cv cF cuni
      cX vy cv cF elssuni isufil.1 syl6ssr vy cv vx cv cX reldisj syl adantl
      biimpd impr 3jca sylc exp32 a1i4 r19.23adv vy cv vx cv cin c0 wne vy cF
      wral wn vy cv vx cv cin c0 wne wn vy cF wrex vy cv vx cv cin c0 wceq vy
      cF wrex vy cv vx cv cin c0 wne vy cF rexnal vy cv vx cv cin c0 wne wn vy
      cv vx cv cin c0 wceq vy cF vy cv vx cv cin c0 nne rexbii bitr3i syl5ib cX
      vx cv cdif cF wcel vx cv cF wcel olc syl8 pm2.61d ex com23 vx cv cX vx
      visset elpw syl7ib r19.21adv impbid pm5.32i bitri $.
      $( [30-Nov-2009] $) $( [30-Nov-2009] $)
  $}

  ${
    $d x F $.
    $( An ultrafilter is a filter. $)
    ufilfil $p |- ( F e. UFil -> F e. Fil ) $=
      cF cufil wcel cF cfil wcel vx cv cF wcel cF cuni vx cv cdif cF wcel wo vx
      cF cuni cpw wral vx cF cF cuni cF cuni eqid isufil pm3.26bi $.
      $( [1-Dec-2009] $) $( [1-Dec-2009] $)
  $}

  ${
    $d s F $. $d s S $. $d s X $.
    ufilss.1 $e |- X = U. F $.
    $( For any subset of the base set of an ultrafilter, either the set is in
       the ultrafilter or the complement is. $)
    ufilss $p |- ( ( F e. UFil /\ S C_ X ) -> ( S e. F \/ ( X \ S ) e. F ) ) $=
      cF cufil wcel cS cX wss cS cF wcel cX cS cdif cF wcel wo cF cufil wcel cS
      cX wss cS cX cpw wcel cS cF wcel cX cS cdif cF wcel wo cF cufil wcel cX
      cvv wcel cS cX cpw wcel cS cX wss wb cF cufil wcel cF cuni cvv cX cF
      cufil uniexg ufilss.1 syl5eqel cS cX cvv elpw2g syl cF cufil wcel vs cv
      cF wcel cX vs cv cdif cF wcel wo vs cX cpw wral cS cX cpw wcel cS cF wcel
      cX cS cdif cF wcel wo wi cF cufil wcel cF cfil wcel vs cv cF wcel cX vs
      cv cdif cF wcel wo vs cX cpw wral vs cF cX ufilss.1 isufil pm3.27bi vs cv
      cF wcel cX vs cv cdif cF wcel wo cS cF wcel cX cS cdif cF wcel wo vs cS
      cX cpw vs cv cS wceq vs cv cF wcel cS cF wcel cX vs cv cdif cF wcel cX cS
      cdif cF wcel vs cv cS cF eleq1 vs cv cS wceq cX vs cv cdif cX cS cdif cF
      vs cv cS cX difeq2 eleq1d orbi12d rcla4cv syl sylbird imp $.
      $( [1-Dec-2009] $) $( [1-Dec-2009] $)
  $}

  ${
    $d g F $. $d g G $. $d g X $. $d g Y $.
    ufilmax.1 $e |- X = U. F $.
    ufilmax.2 $e |- Y = U. G $.
    $( Any filter finer than an ultrafilter is actually equal to it. $)
    ufilmax $p |- ( ( ( F e. UFil /\ G e. Fil ) /\ ( X = Y /\ F C_ G ) ) -> F =
    G ) $=
      cF cufil wcel cG cfil wcel cX cY wceq cF cG wss wa cF cG wceq cF cufil
      wcel cX vg cv cuni wceq cF vg cv wss wa cF vg cv wceq wi vg cfil wral cG
      cfil wcel cX cY wceq cF cG wss wa cF cG wceq wi wi cF cufil wcel cF cfil
      wcel cX vg cv cuni wceq cF vg cv wss wa cF vg cv wceq wi vg cfil wral vg
      cF cX ufilmax.1 isufil2 pm3.27bi cX vg cv cuni wceq cF vg cv wss wa cF vg
      cv wceq wi cX cY wceq cF cG wss wa cF cG wceq wi vg cG cfil vg cv cG wceq
      cX vg cv cuni wceq cF vg cv wss wa cX cY wceq cF cG wss wa cF vg cv wceq
      cF cG wceq vg cv cG wceq cX vg cv cuni wceq cX cY wceq cF vg cv wss cF cG
      wss vg cv cG wceq vg cv cuni cY cX vg cv cG wceq vg cv cuni cG cuni cY vg
      cv cG unieq ufilmax.2 syl6eqr eqeq2d vg cv cG cF sseq2 anbi12d vg cv cG
      cF eqeq2 imbi12d rcla4cv syl imp31 $.
      $( [1-Dec-2009] $) $( [1-Dec-2009] $)
  $}

  ${
    $d x A $. $d x B $. $d x F $. $d x X $.
    ufprim.1 $e |- X = U. F $.
    $( An ultrafilter is a prime filter. $)
    ufprim $p |- ( ( F e. UFil /\ A C_ X /\ B C_ X ) -> ( ( A e. F \/ B e. F )
    <-> ( A u. B ) e. F ) ) $=
      cF cufil wcel cA cX wss cB cX wss w3a cA cF wcel cB cF wcel wo cA cB cun
      cF wcel cF cufil wcel cA cX wss cB cX wss w3a cA cF wcel cA cB cun cF
      wcel cB cF wcel cF cufil wcel cA cX wss cB cX wss w3a cA cF wcel cA cB
      cun cF wcel cF cfil wcel cA cF wcel cA cB cun cX wss cA cA cB cun wss w3a
      cA cB cun cF wcel cF cufil wcel cA cX wss cB cX wss w3a cA cF wcel wa cA
      cA cB cun cF cX ufprim.1 fillsb cF cufil wcel cA cX wss cB cX wss w3a cF
      cfil wcel cA cF wcel cF cufil wcel cA cX wss cF cfil wcel cB cX wss cF
      ufilfil 3ad2ant1 adantr cF cufil wcel cA cX wss cB cX wss w3a cA cF wcel
      wa cA cF wcel cA cB cun cX wss cA cA cB cun wss cF cufil wcel cA cX wss
      cB cX wss w3a cA cF wcel pm3.27 cF cufil wcel cA cX wss cB cX wss w3a cA
      cB cun cX wss cA cF wcel cA cX wss cB cX wss cA cB cun cX wss cF cufil
      wcel cA cX wss cB cX wss wa cA cB cun cX wss cA cB cX unss biimpi 3adant1
      adantr cA cA cB cun wss cF cufil wcel cA cX wss cB cX wss w3a cA cF wcel
      wa cA cB ssun1 a1i 3jca sylc ex cF cufil wcel cA cX wss cB cX wss w3a cB
      cF wcel cA cB cun cF wcel cF cfil wcel cB cF wcel cA cB cun cX wss cB cA
      cB cun wss w3a cA cB cun cF wcel cF cufil wcel cA cX wss cB cX wss w3a cB
      cF wcel wa cB cA cB cun cF cX ufprim.1 fillsb cF cufil wcel cA cX wss cB
      cX wss w3a cF cfil wcel cB cF wcel cF cufil wcel cA cX wss cF cfil wcel
      cB cX wss cF ufilfil 3ad2ant1 adantr cF cufil wcel cA cX wss cB cX wss
      w3a cB cF wcel wa cB cF wcel cA cB cun cX wss cB cA cB cun wss cF cufil
      wcel cA cX wss cB cX wss w3a cB cF wcel pm3.27 cF cufil wcel cA cX wss cB
      cX wss w3a cA cB cun cX wss cB cF wcel cA cX wss cB cX wss cA cB cun cX
      wss cF cufil wcel cA cX wss cB cX wss wa cA cB cun cX wss cA cB cX unss
      biimpi 3adant1 adantr cB cA cB cun wss cF cufil wcel cA cX wss cB cX wss
      w3a cB cF wcel wa cB cA ssun2 a1i 3jca sylc ex jaod cF cufil wcel cA cX
      wss cB cX wss w3a cA cB cun cF wcel cA cF wcel cB cF wcel wo cF cufil
      wcel cA cX wss cB cX wss w3a cA cB cun cF wcel wa cA cF wcel cB cF wcel
      cF cufil wcel cA cX wss cB cX wss w3a cA cB cun cF wcel wa cA cF wcel wn
      cX cA cdif cF wcel cB cF wcel cF cufil wcel cA cX wss cB cX wss w3a cA cB
      cun cF wcel wa cA cF wcel cX cA cdif cF wcel cF cufil wcel cA cX wss cB
      cX wss w3a cA cF wcel cX cA cdif cF wcel wo cA cB cun cF wcel cF cufil
      wcel cA cX wss cA cF wcel cX cA cdif cF wcel wo cB cX wss cA cF cX
      ufprim.1 ufilss 3adant3 adantr ord cF cufil wcel cA cX wss cB cX wss w3a
      cA cB cun cF wcel cX cA cdif cF wcel cB cF wcel cF cfil wcel cA cB cun cX
      cA cdif cin cF wcel cB cX wss cA cB cun cX cA cdif cin cB wss w3a cB cF
      wcel cF cufil wcel cA cX wss cB cX wss w3a cA cB cun cF wcel cX cA cdif
      cF wcel w3a cA cB cun cX cA cdif cin cB cF cX ufprim.1 fillsb cF cufil
      wcel cA cX wss cB cX wss w3a cA cB cun cF wcel cF cfil wcel cX cA cdif cF
      wcel cF cufil wcel cA cX wss cF cfil wcel cB cX wss cF ufilfil 3ad2ant1
      3ad2ant1 cF cufil wcel cA cX wss cB cX wss w3a cA cB cun cF wcel cX cA
      cdif cF wcel w3a cA cB cun cX cA cdif cin cF wcel cB cX wss cA cB cun cX
      cA cdif cin cB wss cF cufil wcel cA cX wss cB cX wss w3a cA cB cun cF
      wcel cX cA cdif cF wcel cA cB cun cX cA cdif cin cF wcel cF cufil wcel cA
      cX wss cA cB cun cF wcel cX cA cdif cF wcel cA cB cun cX cA cdif cin cF
      wcel wi wi cB cX wss cF cufil wcel cF cfil wcel cA cB cun cF wcel cX cA
      cdif cF wcel cA cB cun cX cA cdif cin cF wcel wi wi cF ufilfil cF cfil
      wcel cA cB cun cF wcel cX cA cdif cF wcel cA cB cun cX cA cdif cin cF
      wcel cA cB cun cX cA cdif cF filint 3exp syl 3ad2ant1 3imp cF cufil wcel
      cA cX wss cB cX wss w3a cA cB cun cF wcel cB cX wss cX cA cdif cF wcel cF
      cufil wcel cA cX wss cB cX wss 3simp3 3ad2ant1 cA cB cun cX cA cdif cin
      cB wss cF cufil wcel cA cX wss cB cX wss w3a cA cB cun cF wcel cX cA cdif
      cF wcel w3a vx cA cB cun cX cA cdif cin cB vx cv cA cB cun cX cA cdif cin
      wcel vx cv cA cB cun wcel vx cv cX cA cdif wcel wa vx cv cB wcel vx cv cA
      cB cun cX cA cdif elin vx cv cA wcel wn vx cv cB wcel wi vx cv cX cA cdif
      wcel vx cv cB wcel vx cv cA cB cun wcel vx cv cA wcel wn vx cv cB wcel wi
      vx cv cA wcel wn vx cv cB wcel vx cv cX cA cdif wcel vx cv cA wcel wn vx
      cv cB wcel wi vx cv cA wcel wn vx cv cB wcel vx cv cA wcel wn vx cv cB
      wcel wi id imp vx cv cX cA eldifn sylan2 vx cv cA cB cun wcel vx cv cA
      wcel vx cv cB wcel wo vx cv cA wcel wn vx cv cB wcel wi vx cv cA cB elun
      vx cv cA wcel vx cv cB wcel df-or bitri sylanb sylbi ssriv a1i 3jca sylc
      3expia syld orrd ex impbid $.
      $( [1-Jan-2010] $) $( [1-Jan-2010] $)
  $}

    ${
    $d a b f g h j k w x y z F $. $d a b f g h j k w x y z X $.
    filssufil.1 $e |- X = U. F $.
    $( Lemma for ~ filssufil . $)
    filssufillem $p |- ( k e. Fil -> A. x ( ( x C_ ( { (/) } u. { g e. Fil | (
    U. k = U. g /\ k C_ g ) } ) /\ A. f e. x A. h e. x ( f C_ h \/ h C_ f ) )
    -> U. x e. ( { (/) } u. { g e. Fil | ( U. k = U. g /\ k C_ g ) } ) ) ) $=
      vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral
      vf vx cv wral wa vx cv cuni c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wcel wi vx vk cv cfil wcel vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv
      wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa vx cv cuni c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wcel vk cv
      cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx
      cv wral wa wa vx cv cuni c0 wceq vx cv cuni cfil wcel vk cv cuni vx cv
      cuni cuni wceq vk cv vx cv cuni wss wa wa wo vx cv cuni c0 csn vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wcel vk cv cfil wcel
      vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa
      wa vx cv cuni c0 wceq vx cv cuni cfil wcel vk cv cuni vx cv cuni cuni
      wceq vk cv vx cv cuni wss wa wa vk cv cfil wcel vx cv c0 csn vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss
      vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vx cv c0 csn wss wn
      vx cv cuni cfil wcel vk cv cuni vx cv cuni cuni wceq vk cv vx cv cuni wss
      wa wa vx cv cuni c0 wceq wn vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv
      vf cv wss wo vh vx cv wral vf vx cv wral wa wa vx cv c0 csn wss wn vx cv
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cin c0 wne vx
      cv cuni cfil wcel vk cv cuni vx cv cuni cuni wceq vk cv vx cv cuni wss wa
      wa vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vx cv c0 csn wss wn vx cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab cin c0 wne wi vk cv cfil wcel vf cv vh cv wss
      vh cv vf cv wss wo vh vx cv wral vf vx cv wral vx cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vx cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab c0 csn cun wss vx cv c0 csn
      wss wn vx cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cin c0 wne wi c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      c0 csn cun vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab uncom sseq2i vx cv vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab c0 csn cun wss vx cv c0 csn wss vx cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cin c0 vx cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cin c0 wceq vx cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab c0 csn cun wss vx cv c0 csn
      wss vx cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab c0
      csn disjssun biimpcd necon3bd sylbi ad2antrl vk cv cfil wcel vx cv c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv
      vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx
      cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa vj wex vx cv cuni cfil wcel vk cv cuni vx cv cuni cuni wceq vk cv
      vx cv cuni wss wa wa vx cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cin c0 wne vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv
      vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vx cv
      cuni cfil wcel vk cv cuni vx cv cuni cuni wceq vk cv vx cv cuni wss wa wa
      vj vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv
      wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab wcel wa vx cv cuni cfil wcel vk cv
      cuni vx cv cuni cuni wceq vk cv vx cv cuni wss wa wa vk cv cfil wcel vx
      cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa
      vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab wcel wa wa vx cv cuni cfil wcel vk cv cuni vx cv cuni cuni wceq
      vk cv vx cv cuni wss w3a vx cv cuni cfil wcel vk cv cuni vx cv cuni cuni
      wceq vk cv vx cv cuni wss wa wa vk cv cfil wcel vx cv c0 csn vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss
      vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj
      cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa
      vk cv cuni vx cv cuni cuni wceq vx cv cuni cfil wcel vk cv vx cv cuni wss
      vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral
      vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq
      vx cv cuni cfil wcel wa vk cv vx cv cuni wss wa vk cv cuni vx cv cuni
      cuni wceq vx cv cuni cfil wcel vk cv vx cv cuni wss w3a vk cv cfil wcel
      vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa
      wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq vx cv cuni cfil
      wcel wa vk cv vx cv cuni wss vk cv cfil wcel vx cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh
      cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk
      cv cuni vx cv cuni cuni wceq vx cv cuni cfil wcel vk cv cfil wcel vx cv
      c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss
      vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj
      cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vk cv cuni vx cv cuni cuni vk cv cfil wcel vx cv c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv
      vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx
      cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa vk cv vx cv cuni wss vk cv cuni vx cv cuni cuni wss vk cv cfil
      wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv
      wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab wcel wa wa vk cv vj cv vx cv cuni vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel vk cv vj cv wss vk cv
      cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx
      cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel vj cv cfil wcel vk cv cuni vj cv cuni wceq vk
      cv vj cv wss wa wa vk cv vj cv wss vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vk cv cuni vj cv cuni wceq vk cv vj cv wss wa vg vj cv cfil vg cv
      vj cv wceq vk cv cuni vg cv cuni wceq vk cv cuni vj cv cuni wceq vk cv vg
      cv wss vk cv vj cv wss vg cv vj cv wceq vg cv cuni vj cv cuni vk cv cuni
      vg cv vj cv unieq eqeq2d vg cv vj cv vk cv sseq2 anbi12d elrab vj cv cfil
      wcel vk cv cuni vj cv cuni wceq vk cv vj cv wss simprr sylbi ad2antll vj
      cv vx cv wcel vj cv vx cv cuni wss vk cv cfil wcel vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv
      wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel vj cv vx cv elssuni
      ad2antrl sstrd vk cv vx cv cuni uniss syl vk cv cfil wcel vx cv c0 csn vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh
      cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa va cv vk cv cuni wss va vx cv cuni wral vx cv cuni cuni vk cv
      cuni wss vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx
      cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab wcel wa wa va cv vk cv cuni wss va
      vx cv cuni vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh
      vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa va cv vb cv wcel vb
      cv vx cv wcel wa vb wex va cv vk cv cuni wss va cv vx cv cuni wcel vk cv
      cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx
      cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wa wa va cv vb cv wcel vb cv vx cv wcel wa va
      cv vk cv cuni wss vb vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa va cv vb
      cv wcel vb cv vx cv wcel va cv vk cv cuni wss vk cv cfil wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf
      cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv
      vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vb cv vx cv wcel va cv vb cv wcel va cv vk cv cuni wss vx
      cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa vb
      cv vx cv wcel va cv vb cv wcel va cv vk cv cuni wss wi wi vk cv cfil wcel
      vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab wcel wa vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vb cv vx cv wcel va cv vb cv wcel va cv vk cv
      cuni wss wi wi vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv
      wral vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vb cv vx cv wcel vb cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wcel va cv vb cv wcel va cv vk cv cuni
      wss wi vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun vb cv ssel vb cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wcel vb cv c0 csn wcel vb cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wo va cv vb cv wcel va cv
      vk cv cuni wss wi vb cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab elun vb cv c0 csn wcel va cv vb cv wcel va cv vk cv cuni
      wss wi vb cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel vb cv c0 csn wcel vb cv c0 wceq va cv vb cv wcel va cv vk cv cuni
      wss wi vb c0 elsn vb cv c0 wceq va cv vb cv wcel va cv vk cv cuni wss vb
      cv c0 wceq va cv vb cv wcel va cv c0 wcel va cv noel vb cv c0 va cv eleq2
      mtbiri pm2.21d sylbi vb cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab wcel vb cv cfil wcel vk cv cuni vb cv cuni wceq vk cv vb cv
      wss wa wa va cv vb cv wcel va cv vk cv cuni wss wi vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vk cv cuni vb cv cuni wceq vk cv vb cv wss wa vg
      vb cv cfil vg cv vb cv wceq vk cv cuni vg cv cuni wceq vk cv cuni vb cv
      cuni wceq vk cv vg cv wss vk cv vb cv wss vg cv vb cv wceq vg cv cuni vb
      cv cuni vk cv cuni vg cv vb cv unieq eqeq2d vg cv vb cv vk cv sseq2
      anbi12d elrab vk cv cuni vb cv cuni wceq va cv vb cv wcel va cv vk cv
      cuni wss wi vb cv cfil wcel vk cv vb cv wss vk cv cuni vb cv cuni wceq va
      cv vk cv cuni wss va cv vb cv cuni wss va cv vb cv wcel vk cv cuni vb cv
      cuni va cv sseq2 va cv vb cv elssuni syl5bir ad2antrl sylbi jaoi sylbi
      syl6 adantr ad2antlr com23 imp3a 19.23adv vb va cv vx cv eluni syl5ib
      r19.21aiv va vx cv cuni vk cv cuni unissb sylibr eqssd vk cv cfil wcel vx
      cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa
      vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq c0 vx cv cuni wcel
      wn vx cv cuni cuni vx cv cuni wcel wa va cv vx cv cuni wcel vb cv vx cv
      cuni cuni wss va cv vb cv wss w3a vb cv vx cv cuni wcel wi vb wal va wal
      va cv vb cv cin vx cv cuni wcel vb vx cv cuni wral va vx cv cuni wral w3a
      vx cv cuni cfil wcel vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv
      cuni vx cv cuni cuni wceq c0 vx cv cuni wcel wn vx cv cuni cuni vx cv
      cuni wcel wa va cv vx cv cuni wcel vb cv vx cv cuni cuni wss va cv vb cv
      wss w3a vb cv vx cv cuni wcel wi vb wal va wal va cv vb cv cin vx cv cuni
      wcel vb vx cv cuni wral va vx cv cuni wral vk cv cfil wcel vx cv c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv
      vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx
      cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa vk cv cuni vx cv cuni cuni wceq vx cv cuni cuni vx cv cuni
      wcel c0 vx cv cuni wcel wn vk cv cuni vx cv cuni cuni wceq vk cv cuni vx
      cv cuni wcel vx cv cuni cuni vx cv cuni wcel vk cv cfil wcel vx cv c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv
      vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx
      cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa vk cv cuni vx cv cuni cuni vx cv cuni eleq1 vk cv cfil wcel vx
      cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa
      vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab wcel wa wa vj cv vx cv cuni vk cv cuni vj cv vx cv wcel vj cv
      vx cv cuni wss vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo
      vh vx cv wral vf vx cv wral wa wa vj cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab wcel vj cv vx cv elssuni ad2antrl vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel vk cv cuni vj
      cv wcel vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx
      cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab wcel vj cv cfil wcel vk cv cuni vj
      cv cuni wceq vk cv vj cv wss wa wa vk cv cuni vj cv wcel vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vk cv cuni vj cv cuni wceq vk cv vj cv wss
      wa vg vj cv cfil vg cv vj cv wceq vk cv cuni vg cv cuni wceq vk cv cuni
      vj cv cuni wceq vk cv vg cv wss vk cv vj cv wss vg cv vj cv wceq vg cv
      cuni vj cv cuni vk cv cuni vg cv vj cv unieq eqeq2d vg cv vj cv vk cv
      sseq2 anbi12d elrab vj cv cfil wcel vk cv cuni vj cv cuni wceq vk cv cuni
      vj cv wcel vk cv vj cv wss vj cv cfil wcel vk cv cuni vj cv cuni wceq vk
      cv cuni vj cv wcel vk cv cuni vj cv cuni wceq vk cv cuni vj cv wcel vj cv
      cuni vj cv wcel vj cv cfil wcel vk cv cuni vj cv cuni vj cv eleq1 vj cv
      vj cv cuni vj cv cuni eqid filusb syl5cbir imp adantrr sylbi ad2antll
      sseldd syl5cbi vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo
      vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa c0 vw cv wcel vw cv
      vx cv wcel wn wi vw wal c0 vx cv cuni wcel wn vk cv cfil wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf
      cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv
      vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa c0 vw cv wcel vw cv vx cv wcel wn wi vw vk cv cfil wcel
      vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa
      wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab wcel wa wa vw cv vx cv wcel c0 vw cv wcel vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv
      wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa vw cv vx cv wcel c0
      vw cv wcel wn wi vk cv cfil wcel vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vx cv c0 csn vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vw cv vx cv wcel
      c0 vw cv wcel wn wi vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf
      vx cv wral vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wss vw cv vx cv wcel vw cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wcel c0 vw cv wcel wn vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun vw cv
      ssel vw cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wcel vw cv c0 csn wcel vw cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wo c0 vw cv wcel wn vw cv c0 csn vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab elun vw cv c0 csn wcel c0
      vw cv wcel wn vw cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel vw cv c0 csn wcel vw cv c0 wceq c0 vw cv wcel wn vw c0 elsn vw
      cv c0 wceq c0 vw cv wcel c0 c0 wcel c0 noel vw cv c0 c0 eleq2 mtbiri
      sylbi vw cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel vw cv cfil wcel vk cv cuni vw cv cuni wceq vk cv vw cv wss wa wa c0
      vw cv wcel wn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vk cv cuni vw
      cv cuni wceq vk cv vw cv wss wa vg vw cv cfil vg cv vw cv wceq vk cv cuni
      vg cv cuni wceq vk cv cuni vw cv cuni wceq vk cv vg cv wss vk cv vw cv
      wss vg cv vw cv wceq vg cv cuni vw cv cuni vk cv cuni vg cv vw cv unieq
      eqeq2d vg cv vw cv vk cv sseq2 anbi12d elrab vw cv cfil wcel c0 vw cv
      wcel wn vk cv cuni vw cv cuni wceq vk cv vw cv wss wa vw cv filesn adantr
      sylbi jaoi sylbi syl6 adantr ad2antlr con2d 19.21aiv c0 vw cv wcel vw cv
      vx cv wcel wa wn vw wal c0 vw cv wcel vw cv vx cv wcel wa vw wex wn c0 vw
      cv wcel vw cv vx cv wcel wn wi vw wal c0 vx cv cuni wcel wn c0 vw cv wcel
      vw cv vx cv wcel wa vw alnex c0 vw cv wcel vw cv vx cv wcel wn wi c0 vw
      cv wcel vw cv vx cv wcel wa wn vw c0 vw cv wcel vw cv vx cv wcel imnan
      albii c0 vx cv cuni wcel c0 vw cv wcel vw cv vx cv wcel wa vw wex vw c0
      vx cv eluni notbii 3bitr4i sylib jctild vk cv cfil wcel vx cv c0 csn vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh
      cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa vk cv cuni vx cv cuni cuni wceq va cv vx cv cuni wcel vb cv vx
      cv cuni cuni wss va cv vb cv wss w3a vb cv vx cv cuni wcel wi vb wal va
      wal vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv
      wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv cuni
      cuni wceq wa va cv vx cv cuni wcel vb cv vx cv cuni cuni wss va cv vb cv
      wss w3a vb cv vx cv cuni wcel wi va vb vk cv cfil wcel vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv
      wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel
      vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa
      wa vk cv cuni vx cv cuni cuni wceq wa va cv vx cv cuni wcel vb cv vx cv
      cuni cuni wss va cv vb cv wss vb cv vx cv cuni wcel vk cv cfil wcel vx cv
      c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss
      vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj
      cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa va cv vw cv wcel vw cv
      vx cv wcel wa vw wex vb cv vx cv cuni cuni wss va cv vb cv wss vb cv vx
      cv cuni wcel wi wi va cv vx cv cuni wcel vk cv cfil wcel vx cv c0 csn vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh
      cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa vk cv cuni vx cv cuni cuni wceq wa va cv vw cv wcel vw cv vx
      cv wcel wa vb cv vx cv cuni cuni wss va cv vb cv wss vb cv vx cv cuni
      wcel wi wi vw vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo
      vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv
      cuni cuni wceq wa va cv vw cv wcel vw cv vx cv wcel vb cv vx cv cuni cuni
      wss va cv vb cv wss vb cv vx cv cuni wcel wi wi vk cv cfil wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf
      cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv
      vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa vw cv vx cv wcel va cv
      vw cv wcel vb cv vx cv cuni cuni wss va cv vb cv wss vb cv vx cv cuni
      wcel wi wi vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh
      vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv
      cuni cuni wceq wa vw cv vx cv wcel va cv vw cv wcel vb cv vx cv cuni cuni
      wss va cv vb cv wss vb cv vx cv cuni wcel vk cv cfil wcel vx cv c0 csn vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh
      cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa wa vk cv cuni vx cv cuni cuni wceq wa vw cv vx cv wcel wa va cv
      vw cv wcel vb cv vx cv cuni cuni wss wa va cv vb cv wss wa wa vw cv vx cv
      cuni vb cv vw cv vx cv wcel vw cv vx cv cuni wss vk cv cfil wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf
      cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv
      vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa va cv vw cv wcel vb cv
      vx cv cuni cuni wss wa va cv vb cv wss wa vw cv vx cv elssuni ad2antlr vk
      cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf
      vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa
      vw cv vx cv wcel va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv vb
      cv wss wa vb cv vw cv wcel vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv
      vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv
      cuni vx cv cuni cuni wceq wa vw cv vx cv wcel vw cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wcel va cv vw cv wcel vb
      cv vx cv cuni cuni wss wa va cv vb cv wss wa vb cv vw cv wcel wi vk cv
      cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx
      cv wral wa wa vw cv vx cv wcel vw cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wcel wi vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cuni
      vx cv cuni cuni wceq vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wss vw cv vx cv wcel vw cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wcel wi vk cv cfil wcel
      vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun vw cv
      ssel ad2antrl ad2antrr vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv
      cuni vx cv cuni cuni wceq wa vw cv c0 csn wcel vw cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wo va cv vw cv wcel vb cv
      vx cv cuni cuni wss wa va cv vb cv wss wa vb cv vw cv wcel wi vw cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wcel
      vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral
      vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq
      wa vw cv c0 csn wcel va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv
      vb cv wss wa vb cv vw cv wcel wi vw cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab wcel vk cv cfil wcel vx cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh
      cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk
      cv cuni vx cv cuni cuni wceq wa vw cv c0 wceq va cv vw cv wcel vb cv vx
      cv cuni cuni wss wa va cv vb cv wss wa vb cv vw cv wcel wi vw cv c0 csn
      wcel vw cv c0 wceq va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv vb
      cv wss wa vb cv vw cv wcel wi wi vk cv cfil wcel vx cv c0 csn vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss
      vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj
      cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa
      vk cv cuni vx cv cuni cuni wceq wa vw cv c0 wceq va cv vw cv wcel vb cv
      vx cv cuni cuni wss wa vb cv vw cv wcel va cv vb cv wss vw cv c0 wceq va
      cv vw cv wcel vb cv vw cv wcel vb cv vx cv cuni cuni wss vw cv c0 wceq va
      cv vw cv wcel vb cv vw cv wcel vw cv c0 wceq va cv vw cv wcel va cv c0
      wcel va cv noel vw cv c0 va cv eleq2 mtbiri pm2.21d adantrd adantrd a1i
      vw c0 elsn syl5ib vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss
      wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv
      cuni cuni wceq wa vw cv cfil wcel vk cv cuni vw cv cuni wceq vk cv vw cv
      wss wa wa va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv vb cv wss
      wa vb cv vw cv wcel wi vw cv vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab wcel vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv
      cuni vx cv cuni cuni wceq wa vw cv cfil wcel vk cv cuni vw cv cuni wceq
      vk cv vw cv wss wa wa va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv
      vb cv wss wa vb cv vw cv wcel vw cv cfil wcel va cv vw cv wcel vb cv vw
      cv cuni wss va cv vb cv wss w3a vb cv vw cv wcel vk cv cfil wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf
      cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv
      vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa vw cv cfil wcel vk cv
      cuni vw cv cuni wceq vk cv vw cv wss wa wa va cv vw cv wcel vb cv vx cv
      cuni cuni wss wa va cv vb cv wss wa wa wa va cv vb cv vw cv vw cv cuni vw
      cv cuni eqid fillsb vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv
      cuni vx cv cuni cuni wceq wa vw cv cfil wcel vk cv cuni vw cv cuni wceq
      vk cv vw cv wss wa va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv vb
      cv wss wa simprll vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss
      wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv
      cuni cuni wceq wa vw cv cfil wcel vk cv cuni vw cv cuni wceq vk cv vw cv
      wss wa wa va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv vb cv wss
      wa wa wa va cv vw cv wcel vb cv vw cv cuni wss va cv vb cv wss va cv vw
      cv wcel vb cv vx cv cuni cuni wss wa va cv vb cv wss wa va cv vw cv wcel
      vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral
      vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq
      wa vw cv cfil wcel vk cv cuni vw cv cuni wceq vk cv vw cv wss wa wa va cv
      vw cv wcel vb cv vx cv cuni cuni wss va cv vb cv wss simpll ad2antll vk
      cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf
      vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa
      vw cv cfil wcel vk cv cuni vw cv cuni wceq vk cv vw cv wss wa wa va cv vw
      cv wcel vb cv vx cv cuni cuni wss wa va cv vb cv wss wa wa wa vb cv vx cv
      cuni cuni vw cv cuni va cv vw cv wcel vb cv vx cv cuni cuni wss wa va cv
      vb cv wss wa vb cv vx cv cuni cuni wss vk cv cfil wcel vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv
      wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel
      vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa
      wa vk cv cuni vx cv cuni cuni wceq wa vw cv cfil wcel vk cv cuni vw cv
      cuni wceq vk cv vw cv wss wa wa va cv vw cv wcel vb cv vx cv cuni cuni
      wss va cv vb cv wss simplr ad2antll vk cv cfil wcel vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv
      wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel
      vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa
      wa vk cv cuni vx cv cuni cuni wceq wa vw cv cfil wcel vk cv cuni vw cv
      cuni wceq vk cv vw cv wss wa wa vx cv cuni cuni vw cv cuni wceq va cv vw
      cv wcel vb cv vx cv cuni cuni wss wa va cv vb cv wss wa vk cv cuni vx cv
      cuni cuni wceq vk cv cuni vw cv cuni wceq vk cv vw cv wss wa vx cv cuni
      cuni vw cv cuni wceq vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vw cv
      cfil wcel vk cv cuni vx cv cuni cuni wceq vk cv cuni vw cv cuni wceq vx
      cv cuni cuni vw cv cuni wceq vk cv vw cv wss vk cv cuni vx cv cuni cuni
      vw cv cuni eqtr2 adantrr ad2ant2l adantrr sseqtrd vk cv cfil wcel vx cv
      c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss
      vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral wa wa vj
      cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab wcel wa wa vk cv cuni vx cv cuni cuni wceq wa vw cv cfil wcel vk cv
      cuni vw cv cuni wceq vk cv vw cv wss wa wa va cv vw cv wcel vb cv vx cv
      cuni cuni wss wa va cv vb cv wss simprrr 3jca sylc exp32 vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vk cv cuni vw cv cuni wceq vk cv vw cv wss
      wa vg vw cv cfil vg cv vw cv wceq vk cv cuni vg cv cuni wceq vk cv cuni
      vw cv cuni wceq vk cv vg cv wss vk cv vw cv wss vg cv vw cv wceq vg cv
      cuni vw cv cuni vk cv cuni vg cv vw cv unieq eqeq2d vg cv vw cv vk cv
      sseq2 anbi12d elrab syl5ib jaod vw cv c0 csn vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab elun syl5ib syld imp31 sseldd exp58 com23
      imp3a 19.23adv vw va cv vx cv eluni syl5ib 3impd 19.21aivv ex vk cv cfil
      wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv
      wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab wcel wa wa va cv vb cv cin vx cv cuni wcel vb vx cv
      cuni wral va vx cv cuni wral vk cv cuni vx cv cuni cuni wceq vk cv cfil
      wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv
      wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab wcel wa wa va cv vb cv cin vx cv cuni wcel va vb vx
      cv cuni vx cv cuni vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa va cv vy
      cv wcel vy cv vx cv wcel wa vb cv vz cv wcel vz cv vx cv wcel wa wa vz
      wex vy wex va cv vb cv cin vx cv cuni wcel va cv vx cv cuni wcel vb cv vx
      cv cuni wcel wa vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss
      wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa va cv vy cv wcel
      vy cv vx cv wcel wa vb cv vz cv wcel vz cv vx cv wcel wa wa va cv vb cv
      cin vx cv cuni wcel vy vz vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv
      vf cv wss wo vh vx cv wral vf vx cv wral vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa va cv vy cv
      wcel vy cv vx cv wcel wa vb cv vz cv wcel vz cv vx cv wcel wa wa va cv vb
      cv cin vx cv cuni wcel wi vk cv cfil wcel vf cv vh cv wss vh cv vf cv wss
      wo vh vx cv wral vf vx cv wral vx cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa va cv vy cv wcel vy
      cv vx cv wcel wa vb cv vz cv wcel vz cv vx cv wcel wa wa va cv vb cv cin
      vx cv cuni wcel wi wi va cv vy cv wcel vy cv vx cv wcel wa vb cv vz cv
      wcel vz cv vx cv wcel wa wa vf cv vh cv wss vh cv vf cv wss wo vh vx cv
      wral vf vx cv wral vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv
      cin vx cv cuni wcel va cv vy cv wcel vy cv vx cv wcel vb cv vz cv wcel vz
      cv vx cv wcel vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv
      wral vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni
      wcel wi wi wi wi vy cv vx cv wcel va cv vy cv wcel vb cv vz cv wcel vz cv
      vx cv wcel vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral
      vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni wcel
      wi wi wi wi wi wi vy cv vx cv wcel vz cv vx cv wcel vb cv vz cv wcel va
      cv vy cv wcel vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv
      wral vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni
      wcel wi wi wi wi vy cv vx cv wcel vz cv vx cv wcel vb cv vz cv wcel va cv
      vy cv wcel vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf vx cv wral
      vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni wcel
      wi wi wi wi wi wi vy cv vx cv wcel vz cv vx cv wcel wa vf cv vh cv wss vh
      cv vf cv wss wo vh vx cv wral vf vx cv wral va cv vy cv wcel vb cv vz cv
      wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni
      wcel wi wi wi vy cv vx cv wcel vz cv vx cv wcel wa vf cv vh cv wss vh cv
      vf cv wss wo vh vx cv wral vf vx cv wral vy cv vz cv wss vz cv vy cv wss
      wo va cv vy cv wcel vb cv vz cv wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil
      wcel va cv vb cv cin vx cv cuni wcel wi wi wi wi wi vf cv vh cv wss vh cv
      vf cv wss wo vy cv vz cv wss vz cv vy cv wss wo vy cv vh cv wss vh cv vy
      cv wss wo vf vh vy cv vz cv vx cv vx cv vf cv vy cv wceq vf cv vh cv wss
      vy cv vh cv wss vh cv vf cv wss vh cv vy cv wss vf cv vy cv vh cv sseq1
      vf cv vy cv vh cv sseq2 orbi12d vh cv vz cv wceq vy cv vh cv wss vy cv vz
      cv wss vh cv vy cv wss vz cv vy cv wss vh cv vz cv vy cv sseq2 vh cv vz
      cv vy cv sseq1 orbi12d rcla42v vy cv vx cv wcel vz cv vx cv wcel wa vy cv
      vz cv wss va cv vy cv wcel vb cv vz cv wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv
      cfil wcel va cv vb cv cin vx cv cuni wcel wi wi wi wi wi vz cv vy cv wss
      vy cv vz cv wss va cv vy cv wcel va cv vz cv wcel vy cv vx cv wcel vz cv
      vx cv wcel wa vb cv vz cv wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va
      cv vb cv cin vx cv cuni wcel wi wi wi wi vy cv vz cv va cv ssel vz cv vx
      cv wcel va cv vz cv wcel vb cv vz cv wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv
      cfil wcel va cv vb cv cin vx cv cuni wcel wi wi wi wi wi vy cv vx cv wcel
      vz cv vx cv wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vb cv vz cv wcel va cv vz cv wcel vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni wcel wi wi vz cv vx cv
      wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vb cv vz cv wcel va cv vz cv wcel vj cv vx cv wcel vj cv vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv
      cfil wcel va cv vb cv cin vx cv cuni wcel wi wi vz cv vx cv wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vb
      cv vz cv wcel wa va cv vz cv wcel wa vj cv vx cv wcel vj cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va
      cv vb cv cin vx cv cuni wcel vz cv vx cv wcel vx cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vb cv vz cv wcel wa
      va cv vz cv wcel wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel wa wa vz cv vx cv
      cuni va cv vb cv cin vz cv vx cv wcel vz cv vx cv cuni wss vx cv c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vb cv
      vz cv wcel wa va cv vz cv wcel wa vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel wa vz
      cv vx cv elssuni ad2antrr vz cv vx cv wcel vx cv c0 csn vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vb cv vz cv wcel wa va
      cv vz cv wcel wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vz cv
      wcel vz cv vx cv wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wss vb cv vz cv wcel va cv vz cv wcel vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa vk cv cfil wcel va cv vb cv cin vz cv wcel wi wi vx cv c0 csn vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vz cv vx
      cv wcel vz cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wcel vb cv vz cv wcel va cv vz cv wcel vj cv vx cv wcel vj
      cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk
      cv cfil wcel va cv vb cv cin vz cv wcel wi wi wi wi vx cv c0 csn vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun vz cv ssel vz cv
      c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wcel vz cv c0 csn wcel vz cv vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab wcel wo vb cv vz cv wcel va cv vz cv wcel vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa vk cv cfil wcel va cv vb cv cin vz cv wcel wi wi wi wi vz cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab elun vz cv
      c0 csn wcel vb cv vz cv wcel va cv vz cv wcel vj cv vx cv wcel vj cv vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv
      cfil wcel va cv vb cv cin vz cv wcel wi wi wi wi vz cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel vz cv c0 csn wcel vz cv c0
      wceq vb cv vz cv wcel va cv vz cv wcel vj cv vx cv wcel vj cv vk cv cuni
      vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel
      va cv vb cv cin vz cv wcel wi wi wi wi vz c0 elsn vz cv c0 wceq vb cv vz
      cv wcel va cv vz cv wcel vj cv vx cv wcel vj cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv
      cin vz cv wcel wi wi wi vz cv c0 wceq vb cv vz cv wcel vb cv c0 wcel vb
      cv noel vz cv c0 vb cv eleq2 mtbiri pm2.21d sylbi vz cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel vz cv cfil wcel vk cv cuni
      vz cv cuni wceq vk cv vz cv wss wa wa vb cv vz cv wcel va cv vz cv wcel
      vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vz cv wcel wi wi wi wi
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vk cv cuni vz cv cuni wceq
      vk cv vz cv wss wa vg vz cv cfil vg cv vz cv wceq vk cv cuni vg cv cuni
      wceq vk cv cuni vz cv cuni wceq vk cv vg cv wss vk cv vz cv wss vg cv vz
      cv wceq vg cv cuni vz cv cuni vk cv cuni vg cv vz cv unieq eqeq2d vg cv
      vz cv vk cv sseq2 anbi12d elrab vz cv cfil wcel vk cv cuni vz cv cuni
      wceq vk cv vz cv wss wa wa vb cv vz cv wcel va cv vz cv wcel vj cv vx cv
      wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel wa vk cv cfil wcel va cv vb cv cin vz cv wcel wi vz cv cfil wcel vk
      cv cuni vz cv cuni wceq vk cv vz cv wss wa wa vb cv vz cv wcel va cv vz
      cv wcel vk cv cfil wcel va cv vb cv cin vz cv wcel vz cv cfil wcel vb cv
      vz cv wcel va cv vz cv wcel va cv vb cv cin vz cv wcel wi wi vk cv cuni
      vz cv cuni wceq vk cv vz cv wss wa vz cv cfil wcel va cv vz cv wcel vb cv
      vz cv wcel va cv vb cv cin vz cv wcel vz cv cfil wcel va cv vz cv wcel vb
      cv vz cv wcel va cv vb cv cin vz cv wcel va cv vb cv vz cv filint 3exp
      com23 adantr a1i4 a1i4 sylbi jaoi sylbi syl6com imp4c imp43 sseldd exp43
      exp4c com24 adantl syl9r vy cv vx cv wcel vz cv vx cv wcel wa vz cv vy cv
      wss vb cv vz cv wcel va cv vy cv wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil
      wcel va cv vb cv cin vx cv cuni wcel wi wi wi vz cv vy cv wss vb cv vz cv
      wcel vb cv vy cv wcel vy cv vx cv wcel vz cv vx cv wcel wa va cv vy cv
      wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin vx cv cuni
      wcel wi wi wi wi vz cv vy cv vb cv ssel vy cv vx cv wcel vb cv vy cv wcel
      va cv vy cv wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss
      wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin
      vx cv cuni wcel wi wi wi wi wi vz cv vx cv wcel vy cv vx cv wcel vb cv vy
      cv wcel va cv vy cv wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab cun wss vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv
      vb cv cin vx cv cuni wcel wi wi vy cv vx cv wcel vb cv vy cv wcel va cv
      vy cv wcel wa vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun wss wa vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab wcel wa vk cv cfil wcel va cv vb cv cin
      vx cv cuni wcel vy cv vx cv wcel vb cv vy cv wcel va cv vy cv wcel wa vx
      cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wss wa va cv vb cv cin vx cv cuni wcel vy cv vx cv wcel vb cv vy cv wcel
      va cv vy cv wcel wa vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wss wa wa vy cv vx cv cuni va cv vb cv cin vy cv
      vx cv wcel vy cv vx cv cuni wss vb cv vy cv wcel va cv vy cv wcel wa vx
      cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun
      wss wa vy cv vx cv elssuni adantr vy cv vx cv wcel vb cv vy cv wcel va cv
      vy cv wcel wa vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun wss va cv vb cv cin vy cv wcel vy cv vx cv wcel vx cv c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vb
      cv vy cv wcel va cv vy cv wcel wa va cv vb cv cin vy cv wcel vx cv c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wss vy cv
      vx cv wcel vy cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wcel vb cv vy cv wcel va cv vy cv wcel wa va cv vb cv cin
      vy cv wcel wi vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun vy cv ssel vy cv c0 csn vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab cun wcel vy cv c0 csn wcel vy cv vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wo vb cv vy cv wcel va
      cv vy cv wcel wa va cv vb cv cin vy cv wcel wi vy cv c0 csn vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab elun vy cv c0 csn wcel vb cv
      vy cv wcel va cv vy cv wcel wa va cv vb cv cin vy cv wcel wi vy cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel vy cv c0 csn
      wcel vy cv c0 wceq vb cv vy cv wcel va cv vy cv wcel wa va cv vb cv cin
      vy cv wcel wi vy c0 elsn vy cv c0 wceq vb cv vy cv wcel va cv vb cv cin
      vy cv wcel va cv vy cv wcel vy cv c0 wceq vb cv vy cv wcel va cv vb cv
      cin vy cv wcel vy cv c0 wceq vb cv vy cv wcel vb cv c0 wcel vb cv noel vy
      cv c0 vb cv eleq2 mtbiri pm2.21d adantrd sylbi vy cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel vy cv cfil wcel vk cv cuni
      vy cv cuni wceq vk cv vy cv wss wa wa vb cv vy cv wcel va cv vy cv wcel
      wa va cv vb cv cin vy cv wcel wi vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vk cv cuni vy cv cuni wceq vk cv vy cv wss wa vg vy cv cfil vg cv
      vy cv wceq vk cv cuni vg cv cuni wceq vk cv cuni vy cv cuni wceq vk cv vg
      cv wss vk cv vy cv wss vg cv vy cv wceq vg cv cuni vy cv cuni vk cv cuni
      vg cv vy cv unieq eqeq2d vg cv vy cv vk cv sseq2 anbi12d elrab vy cv cfil
      wcel vb cv vy cv wcel va cv vy cv wcel wa va cv vb cv cin vy cv wcel wi
      vk cv cuni vy cv cuni wceq vk cv vy cv wss wa vy cv cfil wcel va cv vy cv
      wcel vb cv vy cv wcel va cv vb cv cin vy cv wcel vy cv cfil wcel va cv vy
      cv wcel vb cv vy cv wcel va cv vb cv cin vy cv wcel va cv vb cv vy cv
      filint 3expib ancomsd adantr sylbi jaoi sylbi syl6com com23 imp32 sseldd
      ex a1i34 exp4c adantr syl9r com34 jaod syld com24 ex com24 com12 imp43
      com15 com23 imp42 19.23advv va cv vx cv cuni wcel vb cv vx cv cuni wcel
      wa va cv vy cv wcel vy cv vx cv wcel wa vy wex vb cv vz cv wcel vz cv vx
      cv wcel wa vz wex wa va cv vy cv wcel vy cv vx cv wcel wa vb cv vz cv
      wcel vz cv vx cv wcel wa wa vz wex vy wex va cv vx cv cuni wcel va cv vy
      cv wcel vy cv vx cv wcel wa vy wex vb cv vx cv cuni wcel vb cv vz cv wcel
      vz cv vx cv wcel wa vz wex vy va cv vx cv eluni vz vb cv vx cv eluni
      anbi12i va cv vy cv wcel vy cv vx cv wcel wa vb cv vz cv wcel vz cv vx cv
      wcel wa vy vz eeanv bitr4i syl5ib r19.21aivv a1d 3jcad vx cv cuni cvv
      wcel vx cv cuni cfil wcel c0 vx cv cuni wcel wn vx cv cuni cuni vx cv
      cuni wcel wa va cv vx cv cuni wcel vb cv vx cv cuni cuni wss va cv vb cv
      wss w3a vb cv vx cv cuni wcel wi vb wal va wal va cv vb cv cin vx cv cuni
      wcel vb vx cv cuni wral va vx cv cuni wral w3a wb vx cv vx visset uniex
      va vb cvv vx cv cuni vx cv cuni cuni vx cv cuni cuni eqid isfil ax-mp
      syl6ibr jcai vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo
      vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv cuni vg cv
      cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa wa vk cv vj cv vx cv
      cuni vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      wcel vk cv vj cv wss vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv
      wss wo vh vx cv wral vf vx cv wral wa wa vj cv vx cv wcel vj cv vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel vj cv cfil wcel
      vk cv cuni vj cv cuni wceq vk cv vj cv wss wa wa vk cv vj cv wss vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vk cv cuni vj cv cuni wceq vk cv
      vj cv wss wa vg vj cv cfil vg cv vj cv wceq vk cv cuni vg cv cuni wceq vk
      cv cuni vj cv cuni wceq vk cv vg cv wss vk cv vj cv wss vg cv vj cv wceq
      vg cv cuni vj cv cuni vk cv cuni vg cv vj cv unieq eqeq2d vg cv vj cv vk
      cv sseq2 anbi12d elrab vj cv cfil wcel vk cv cuni vj cv cuni wceq vk cv
      vj cv wss simprr sylbi ad2antll vj cv vx cv wcel vj cv vx cv cuni wss vk
      cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss wo vh vx cv wral vf
      vx cv wral wa wa vj cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab wcel vj cv vx cv elssuni ad2antrl sstrd jca vk cv cuni vx cv
      cuni cuni wceq vx cv cuni cfil wcel vk cv vx cv cuni wss df-3an sylibr
      3com12d vx cv cuni cfil wcel vk cv cuni vx cv cuni cuni wceq vk cv vx cv
      cuni wss 3anass sylib ex 19.23adv vx cv vk cv cuni vg cv cuni wceq vk cv
      vg cv wss wa vg cfil crab cin c0 wne vj cv vx cv vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cin wcel vj wex vj cv vx cv wcel vj
      cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab wcel wa vj
      wex vj vx cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cin n0 vj cv vx cv vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cin wcel vj cv vx cv wcel vj cv vk cv cuni vg cv cuni wceq vk cv vg
      cv wss wa vg cfil crab wcel wa vj vj cv vx cv vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab elin exbii bitri syl5ib syld vx cv cuni
      c0 wceq vx cv c0 csn wss vx cv uni0b notbii syl5ib orrd vx cv cuni c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun wcel vx cv
      cuni c0 csn wcel vx cv cuni vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab wcel wo vx cv cuni c0 wceq vx cv cuni cfil wcel vk cv cuni
      vx cv cuni cuni wceq vk cv vx cv cuni wss wa wa wo vx cv cuni c0 csn vk
      cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab elun vx cv cuni
      c0 csn wcel vx cv cuni c0 wceq vx cv cuni vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab wcel vx cv cuni cfil wcel vk cv cuni vx cv
      cuni cuni wceq vk cv vx cv cuni wss wa wa vx cv cuni c0 vx cv vx visset
      uniex elsnc vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vk cv cuni vx
      cv cuni cuni wceq vk cv vx cv cuni wss wa vg vx cv cuni cfil vg cv vx cv
      cuni wceq vk cv cuni vg cv cuni wceq vk cv cuni vx cv cuni cuni wceq vk
      cv vg cv wss vk cv vx cv cuni wss vg cv vx cv cuni wceq vg cv cuni vx cv
      cuni cuni vk cv cuni vg cv vx cv cuni unieq eqeq2d vg cv vx cv cuni vk cv
      sseq2 anbi12d elrab orbi12i bitr2i sylib ex 19.21aiv $.
      $( [3-Dec-2009] $) $( [10-Dec-2009] $)

    $( A filter is contained in some ultrafilter. (Requires the Axiom of
       Choice.) $)
    filssufil $p |- ( F e. Fil -> E. f e. UFil ( X = U. f /\ F C_ f ) ) $=
      cF cfil wcel vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv
      wss wa vg cfil crab cun wral vf c0 csn cX vg cv cuni wceq cF vg cv wss wa
      vg cfil crab cun wrex cX vf cv cuni wceq cF vf cv wss wa vf cufil wrex vf
      cv vh cv wpss wn vh c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa
      vg cfil crab cun wral vf c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cun wrex vf cv vh cv wpss wn vh c0 csn cX vg cv cuni
      wceq cF vg cv wss wa vg cfil crab cun wral vf c0 csn cX vg cv cuni wceq
      cF vg cv wss wa vg cfil crab cun wrex vk cF cfil vk cv cF wceq vf cv vh
      cv wpss wn vh c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg
      cfil crab cun wral vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg
      cv wss wa vg cfil crab cun wral vf c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun c0 csn cX vg cv cuni wceq cF vg cv wss
      wa vg cfil crab cun vk cv cF wceq vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cX vg cv cuni wceq cF vg cv wss wa vg cfil crab c0
      csn vk cv cF wceq vk cv cuni vg cv cuni wceq vk cv vg cv wss wa cX vg cv
      cuni wceq cF vg cv wss wa vg cfil vk cv cF wceq vk cv cuni vg cv cuni
      wceq cX vg cv cuni wceq vk cv vg cv wss cF vg cv wss vk cv cF wceq vk cv
      cuni cX vg cv cuni vk cv cF wceq vk cv cuni cF cuni cX vk cv cF unieq
      filssufil.1 syl6eqr eqeq1d vk cv cF vg cv sseq1 anbi12d rabbisdv uneq2d
      vk cv cF wceq vf cv vh cv wpss wn vh c0 csn vk cv cuni vg cv cuni wceq vk
      cv vg cv wss wa vg cfil crab cun c0 csn cX vg cv cuni wceq cF vg cv wss
      wa vg cfil crab cun vk cv cF wceq vk cv cuni vg cv cuni wceq vk cv vg cv
      wss wa vg cfil crab cX vg cv cuni wceq cF vg cv wss wa vg cfil crab c0
      csn vk cv cF wceq vk cv cuni vg cv cuni wceq vk cv vg cv wss wa cX vg cv
      cuni wceq cF vg cv wss wa vg cfil vk cv cF wceq vk cv cuni vg cv cuni
      wceq cX vg cv cuni wceq vk cv vg cv wss cF vg cv wss vk cv cF wceq vk cv
      cuni cX vg cv cuni vk cv cF wceq vk cv cuni cF cuni cX vk cv cF unieq
      filssufil.1 syl6eqr eqeq1d vk cv cF vg cv sseq1 anbi12d rabbisdv uneq2d
      raleq1d rexeq12d vk cv cfil wcel vx cv c0 csn vk cv cuni vg cv cuni wceq
      vk cv vg cv wss wa vg cfil crab cun wss vf cv vh cv wss vh cv vf cv wss
      wo vh vx cv wral vf vx cv wral wa vx cv cuni c0 csn vk cv cuni vg cv cuni
      wceq vk cv vg cv wss wa vg cfil crab cun wcel wi vx wal vf cv vh cv wpss
      wn vh c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab
      cun wral vf c0 csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil
      crab cun wrex vx vf vg vh vk cF cX filssufil.1 filssufillem vf vh vx c0
      csn vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab cun c0 csn
      vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab p0ex vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil crab vk cv cuni cpw cpw
      vk cv cuni cpw vk cv cuni vk cv vk visset uniex pwex pwex vk cv cuni vg
      cv cuni wceq vk cv vg cv wss wa vg cfil crab vk cv cuni cpw cpw wss vk cv
      cuni vg cv cuni wceq vk cv vg cv wss wa vg cv vk cv cuni cpw cpw wcel wi
      vg cfil vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cfil vk cv cuni
      cpw cpw rabss vk cv cuni vg cv cuni wceq vk cv vg cv wss wa vg cv vk cv
      cuni cpw cpw wcel wi vg cv cfil wcel vk cv cuni vg cv cuni wceq vg cv vk
      cv cuni cpw cpw wcel vk cv vg cv wss vk cv cuni vg cv cuni wceq vg cv
      cuni vk cv cuni wss vg cv vk cv cuni cpw cpw wcel vg cv cuni vk cv cuni
      eqimss2 vg cv cuni cpw vk cv cuni cpw wss vg cv vk cv cuni cpw wss vg cv
      cuni vk cv cuni wss vg cv vk cv cuni cpw cpw wcel vg cv vg cv cuni cpw
      wss vg cv cuni cpw vk cv cuni cpw wss vg cv vk cv cuni cpw wss vg cv
      pwuni vg cv vg cv cuni cpw vk cv cuni cpw sstr mpan vg cv cuni vk cv cuni
      sspwb vg cv vk cv cuni cpw vg visset elpw 3imtr4i syl adantr a1i mprgbir
      ssexi unex zorn syl vtoclga cF cfil wcel vf cv vh cv wpss wn vh c0 csn cX
      vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wral cX vf cv cuni wceq
      cF vf cv wss wa vf c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab
      cun cufil cF cfil wcel vf cv c0 csn cX vg cv cuni wceq cF vg cv wss wa vg
      cfil crab cun wcel vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg
      cv wss wa vg cfil crab cun wral vf cv cufil wcel cX vf cv cuni wceq cF vf
      cv wss wa wa cF cfil wcel vf cv c0 csn wcel vf cv cX vg cv cuni wceq cF
      vg cv wss wa vg cfil crab wcel wo vf cv vh cv wpss wn vh c0 csn cX vg cv
      cuni wceq cF vg cv wss wa vg cfil crab cun wral vf cv cufil wcel cX vf cv
      cuni wceq cF vf cv wss wa wa wi vf cv c0 csn cX vg cv cuni wceq cF vg cv
      wss wa vg cfil crab cun wcel cF cfil wcel vf cv c0 csn wcel vf cv vh cv
      wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun
      wral vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa wi vf cv cX
      vg cv cuni wceq cF vg cv wss wa vg cfil crab wcel cF cfil wcel vf cv c0
      wceq vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg
      cfil crab cun wral vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa
      wi vf cv c0 csn wcel cF cfil wcel vf cv c0 wceq vf cv vh cv wpss wn vh c0
      csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wral vf cv cufil
      wcel cX vf cv cuni wceq cF vf cv wss wa wa wi cF cfil wcel vf cv c0 wceq
      wa vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg
      cfil crab cun wral vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa
      cF cfil wcel vf cv c0 wceq vf cv vh cv wpss wn vh c0 csn cX vg cv cuni
      wceq cF vg cv wss wa vg cfil crab cun wral wn cF cfil wcel vf cv vh cv
      wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun
      wral vf cv c0 wceq cF cfil wcel vf cv vh cv wpss wn vh c0 csn cX vg cv
      cuni wceq cF vg cv wss wa vg cfil crab cun wral vf cv cF wpss vf cv c0
      wceq cF cfil wcel cF c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil
      crab cun wcel vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv
      wss wa vg cfil crab cun wral vf cv cF wpss wn wi cF cfil wcel cX vg cv
      cuni wceq cF vg cv wss wa vg cfil crab c0 csn cX vg cv cuni wceq cF vg cv
      wss wa vg cfil crab cun cF cX vg cv cuni wceq cF vg cv wss wa vg cfil
      crab c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wss cF
      cfil wcel cX vg cv cuni wceq cF vg cv wss wa vg cfil crab c0 csn ssun2
      a1i cF cfil wcel cF cfil wcel cX cX wceq cF cF wss wa wa cF cX vg cv cuni
      wceq cF vg cv wss wa vg cfil crab wcel cF cfil wcel cX cX wceq cF cF wss
      wa cX cX wceq cF cF wss cX eqid cF ssid pm3.2i jctr cX vg cv cuni wceq cF
      vg cv wss wa cX cX wceq cF cF wss wa vg cF cfil vg cv cF wceq cX vg cv
      cuni wceq cX cX wceq cF vg cv wss cF cF wss vg cv cF wceq vg cv cuni cX
      cX vg cv cF wceq vg cv cuni cF cuni cX vg cv cF unieq filssufil.1 syl6eqr
      eqeq2d vg cv cF cF sseq2 anbi12d elrab sylibr sseldd vf cv vh cv wpss wn
      vf cv cF wpss wn vh cF c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil
      crab cun vh cv cF wceq vf cv vh cv wpss vf cv cF wpss vh cv cF vf cv
      psseq2 notbid rcla4v syl vf cv c0 wceq vf cv cF wpss c0 cF wpss cF cfil
      wcel vf cv c0 cF psseq1 cF cfil wcel cF c0 wne c0 cF wpss cF cfil wcel cX
      cF wcel cF c0 wne cF cX filssufil.1 filusb cF cX ne0i syl cF 0pss sylibr
      syl5cbir nsyld con2d imp pm2.21d ex vf c0 elsn syl5ib cF cfil wcel vf cv
      cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa vf cv vh cv wpss wn vh c0
      csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wral vf cv cufil
      wcel cX vf cv cuni wceq cF vf cv wss wa wa wi vf cv cX vg cv cuni wceq cF
      vg cv wss wa vg cfil crab wcel cF cfil wcel vf cv cfil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq
      cF vg cv wss wa vg cfil crab cun wral vf cv cufil wcel cX vf cv cuni wceq
      cF vf cv wss wa wa cF cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf
      cv wss wa wa wa vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv
      wss wa vg cfil crab cun wral wa vf cv cufil wcel cX vf cv cuni wceq cF vf
      cv wss wa cF cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa
      wa wa vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg
      cfil crab cun wral wa vf cv cfil wcel vf cv cuni vh cv cuni wceq vf cv vh
      cv wss wa vf cv vh cv wceq wi vh cfil wral wa vf cv cufil wcel cF cfil
      wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vf cv vh cv
      wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun
      wral wa vf cv cfil wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss wa vf
      cv vh cv wceq wi vh cfil wral cF cfil wcel vf cv cfil wcel cX vf cv cuni
      wceq cF vf cv wss wa vf cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF
      vg cv wss wa vg cfil crab cun wral simplrl cF cfil wcel vf cv cfil wcel
      cX vf cv cuni wceq cF vf cv wss wa wa wa vf cv vh cv wpss wn vh c0 csn cX
      vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wral vf cv cuni vh cv
      cuni wceq vf cv vh cv wss wa vf cv vh cv wceq wi vh cfil wral cF cfil
      wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vf cv vh cv
      wpss wn vf cv cuni vh cv cuni wceq vf cv vh cv wss wa vf cv vh cv wceq wi
      vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun cfil cF
      cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv
      cfil wcel vh cv c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab
      cun wcel vf cv vh cv wpss wn wi vf cv cuni vh cv cuni wceq vf cv vh cv
      wss wa vf cv vh cv wceq wi cF cfil wcel vf cv cfil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa wa vh cv cfil wcel vh cv c0 csn cX vg cv cuni
      wceq cF vg cv wss wa vg cfil crab cun wcel vf cv vh cv wpss wn wi vf cv
      cuni vh cv cuni wceq vf cv vh cv wss wa vf cv vh cv wceq wi wi cF cfil
      wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv cfil
      wcel wa vf cv cuni vh cv cuni wceq vf cv vh cv wss wa vh cv c0 csn cX vg
      cv cuni wceq cF vg cv wss wa vg cfil crab cun wcel vf cv vh cv wpss wn wi
      vf cv vh cv wceq cF cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv
      wss wa wa wa vh cv cfil wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss
      wa vh cv c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wcel
      vf cv vh cv wpss wn wi vf cv vh cv wceq wi cF cfil wcel vf cv cfil wcel
      cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv cfil wcel vf cv cuni vh cv
      cuni wceq vf cv vh cv wss wa wa wa vh cv c0 csn cX vg cv cuni wceq cF vg
      cv wss wa vg cfil crab cun wcel vf cv vh cv wpss wn wi vh cv c0 csn cX vg
      cv cuni wceq cF vg cv wss wa vg cfil crab cun wcel vf cv vh cv wceq cF
      cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv
      cfil wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss wa wa wa cX vg cv
      cuni wceq cF vg cv wss wa vg cfil crab c0 csn cX vg cv cuni wceq cF vg cv
      wss wa vg cfil crab cun vh cv cX vg cv cuni wceq cF vg cv wss wa vg cfil
      crab c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil crab cun wss cF
      cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv
      cfil wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss wa wa wa cX vg cv
      cuni wceq cF vg cv wss wa vg cfil crab c0 csn ssun2 a1i cF cfil wcel vf
      cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv cfil wcel vf
      cv cuni vh cv cuni wceq vf cv vh cv wss wa wa wa vh cv cfil wcel cX vh cv
      cuni wceq cF vh cv wss wa wa vh cv cX vg cv cuni wceq cF vg cv wss wa vg
      cfil crab wcel cF cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv
      wss wa wa wa vh cv cfil wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss
      wa wa wa vh cv cfil wcel cX vh cv cuni wceq cF vh cv wss cF cfil wcel vf
      cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv cfil wcel vf
      cv cuni vh cv cuni wceq vf cv vh cv wss wa simprl cF cfil wcel vf cv cfil
      wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh cv cfil wcel vf cv cuni
      vh cv cuni wceq cX vh cv cuni wceq vf cv vh cv wss vf cv cfil wcel cX vf
      cv cuni wceq cF vf cv wss wa wa vf cv cuni vh cv cuni wceq cX vh cv cuni
      wceq cF cfil wcel vh cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa vf
      cv cuni vh cv cuni wceq cX vh cv cuni wceq vf cv cfil wcel cX vf cv cuni
      wceq vf cv cuni vh cv cuni wceq cX vh cv cuni wceq cF vf cv wss cX vf cv
      cuni vh cv cuni eqtr adantlr adantll ad2ant2l adantrrr cF cfil wcel vf cv
      cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vf cv cuni vh cv cuni
      wceq vf cv vh cv wss wa cF vh cv wss vh cv cfil wcel vf cv cfil wcel cX
      vf cv cuni wceq cF vf cv wss wa wa vf cv vh cv wss cF vh cv wss cF cfil
      wcel vf cv cuni vh cv cuni wceq cX vf cv cuni wceq cF vf cv wss wa vf cv
      vh cv wss cF vh cv wss vf cv cfil wcel cF vf cv wss vf cv vh cv wss cF vh
      cv wss cX vf cv cuni wceq cF vf cv vh cv sstr adantll adantll ad2ant2l
      adantrl jca32 cX vg cv cuni wceq cF vg cv wss wa cX vh cv cuni wceq cF vh
      cv wss wa vg vh cv cfil vg cv vh cv wceq cX vg cv cuni wceq cX vh cv cuni
      wceq cF vg cv wss cF vh cv wss vg cv vh cv wceq vg cv cuni vh cv cuni cX
      vg cv vh cv unieq eqeq2d vg cv vh cv cF sseq2 anbi12d elrab sylibr sseldd
      cF cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa wa wa vh
      cv cfil wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss wa wa wa vf cv vh
      cv wpss wn vf cv vh cv wceq vh cv c0 csn cX vg cv cuni wceq cF vg cv wss
      wa vg cfil crab cun wcel vf cv cuni vh cv cuni wceq vf cv vh cv wss wa vf
      cv vh cv wpss wn vf cv vh cv wceq wi cF cfil wcel vf cv cfil wcel cX vf
      cv cuni wceq cF vf cv wss wa wa wa vh cv cfil wcel vf cv vh cv wss vf cv
      vh cv wpss wn vf cv vh cv wceq wi vf cv cuni vh cv cuni wceq vf cv vh cv
      wss vf cv vh cv wpss vf cv vh cv vf cv vh cv wss vf cv vh cv wne vf cv vh
      cv wpss vf cv vh cv wpss vf cv vh cv wss vf cv vh cv wne wa vf cv vh cv
      df-pss biimpri ex necon1bd adantl ad2antll imim2d mpid expr com23 ex
      com23 r19.20dv2 imp jca vh vf cv vf cv cuni vf cv cuni eqid isufil2
      sylibr cF cfil wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss wa vf
      cv vh cv wpss wn vh c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil
      crab cun wral simplrr jca exp31 cX vg cv cuni wceq cF vg cv wss wa cX vf
      cv cuni wceq cF vf cv wss wa vg vf cv cfil vg cv vf cv wceq cX vg cv cuni
      wceq cX vf cv cuni wceq cF vg cv wss cF vf cv wss vg cv vf cv wceq vg cv
      cuni vf cv cuni cX vg cv vf cv unieq eqeq2d vg cv vf cv cF sseq2 anbi12d
      elrab syl5ib jaod vf cv c0 csn cX vg cv cuni wceq cF vg cv wss wa vg cfil
      crab elun syl5ib imp3a r19.22dv2 mpd $.
      $( [3-Dec-2009] $) $( [2-Dec-2009] $)
  $}

  ${
    $d f g s u v x y F $. $d f g s u v x y X $.
    ufileu.1 $e |- X = U. F $.
    $( Lemma for ~ ufileu . $)
    ufileulem $p |- ( ( ( F e. Fil /\ s C_ X ) /\ ( -. s e. F /\ -. ( X \ s )
    e. F ) ) -> ( fi ` ( F u. { s } ) ) e. fBas ) $=
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa cF vs cv csn cun cfi cfv cfbas wcel cF vs cv csn cun c0 wne c0 cF vs
      cv csn cun cfi cfv wnel wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn
      cX vs cv cdif cF wcel wn wa wa cF vs cv csn cun c0 wne c0 cF vs cv csn
      cun cfi cfv wnel cF cfil wcel cF vs cv csn cun c0 wne vs cv cX wss vs cv
      cF wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cX cF wcel cF c0 wne
      cF vs cv csn cun c0 wne cF cX ufileu.1 filusb cF cX ne0i cF cF vs cv csn
      cun wss cF c0 wne cF vs cv csn cun c0 wne cF vs cv csn ssun1 cF cF vs cv
      csn cun ssn0 mpan 3syl ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF
      wcel wn cX vs cv cdif cF wcel wn wa wa c0 cF vs cv csn cun cfi cfv wnel
      vx cv vy cv cin c0 wne vy vs cv csn wral vx cF wral cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vx cv vy cv cin c0
      wne vx vy cF vs cv csn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa wa vx cv cF wcel vy cv vs cv csn wcel vx cv vy
      cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa vx cv cF wcel vy cv vs cv wceq vx cv vy cv cin c0 wne vy
      cv vs cv csn wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa vy cv vs cv wceq vx cv cF wcel vx cv vy cv cin c0
      wne vy cv vs cv wceq vx cv cF wcel vx cv vy cv cin c0 wne wi vx cv cF
      wcel vx cv vs cv cin c0 wne wi cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vy cv vs cv wceq vx cv vy cv cin c0 wne
      vx cv vs cv cin c0 wne vx cv cF wcel vy cv vs cv wceq vx cv vy cv cin vx
      cv vs cv cin c0 vy cv vs cv vx cv ineq2 neeq1d imbi2d cF cfil wcel vs cv
      cX wss wa cX vs cv cdif cF wcel wn vx cv cF wcel vx cv vs cv cin c0 wne
      wi vs cv cF wcel wn cF cfil wcel vs cv cX wss wa cX vs cv cdif cF wcel wn
      vx cv cF wcel vx cv vs cv cin c0 wne wi cF cfil wcel vs cv cX wss wa vx
      cv cF wcel cX vs cv cdif cF wcel wn vx cv vs cv cin c0 wne cF cfil wcel
      vs cv cX wss wa vx cv cF wcel cX vs cv cdif cF wcel wn vx cv vs cv cin c0
      wne wi cF cfil wcel vs cv cX wss wa vx cv cF wcel wa cX vs cv cdif cF
      wcel vx cv vs cv cin c0 cF cfil wcel vs cv cX wss wa vx cv cF wcel wa vx
      cv vs cv cin c0 wceq vx cv cX vs cv cdif wss cX vs cv cdif cF wcel vx cv
      cF wcel vx cv vs cv cin c0 wceq vx cv cX vs cv cdif wss wb cF cfil wcel
      vs cv cX wss wa vx cv cF wcel vx cv cX wss vx cv vs cv cin c0 wceq vx cv
      cX vs cv cdif wss wb vx cv cF wcel vx cv cF cuni cX vx cv cF elssuni
      ufileu.1 syl6ssr vx cv vs cv cX reldisj syl adantl cF cfil wcel vx cv cF
      wcel vx cv cX vs cv cdif wss cX vs cv cdif cF wcel wi vs cv cX wss cF
      cfil wcel vx cv cF wcel wa cX vs cv cdif cX wss vx cv cX vs cv cdif wss
      cX vs cv cdif cF wcel wi cX vs cv difss cF cfil wcel vx cv cF wcel cX vs
      cv cdif cX wss vx cv cX vs cv cdif wss cX vs cv cdif cF wcel wi wi cF
      cfil wcel vx cv cF wcel cX vs cv cdif cX wss vx cv cX vs cv cdif wss cX
      vs cv cdif cF wcel vx cv cX vs cv cdif cF cX ufileu.1 fillsb 3expd imp
      mpi adantlr sylbid necon3bd ex com23 imp adantrl syl5cbir com23 vy vs cv
      elsn syl7ib imp3a r19.21aivv cF cfbas wcel vs cv csn cfbas wcel c0 cF vs
      cv csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy vs cv csn wral vx cF
      wral wb cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vx vy cF vs cv csn fbunfip cF cfil wcel cF cfbas wcel vs cv
      cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF filfbas ad2antrr
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa vs cv csn cfil wcel vs cv csn cfbas wcel vs cv cvv wcel vs cv c0 wne
      vs cv csn cfil wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa vs cv cvv oefil2 vs cv cvv wcel cF cfil wcel vs
      cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vs visset
      a1i cF cfil wcel vs cv cX wss wa cX vs cv cdif cF wcel wn vs cv c0 wne vs
      cv cF wcel wn cF cfil wcel vs cv cX wss wa cX vs cv cdif cF wcel wn vs cv
      c0 wne cF cfil wcel vs cv cX wss wa cX vs cv cdif cF wcel vs cv c0 cF
      cfil wcel vs cv c0 wceq cX vs cv cdif cF wcel wi vs cv cX wss vs cv c0
      wceq cX vs cv cdif cF wcel cX c0 cdif cF wcel cF cfil wcel vs cv c0 wceq
      cX vs cv cdif cX c0 cdif cF vs cv c0 cX difeq2 eleq1d cF cfil wcel cX cF
      cX c0 cdif cF cX ufileu.1 filusb cX dif0 syl5eqel syl5cbir adantr
      necon3bd imp adantrl sylanc vs cv csn filfbas syl sylanc mpbird jca cF
      cfil wcel cF vs cv csn cun cfi cfv cfbas wcel cF vs cv csn cun c0 wne c0
      cF vs cv csn cun cfi cfv wnel wa wb vs cv cX wss vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa cF cfil wcel cF vs cv csn cun cvv wcel cF vs cv csn
      cun cfi cfv cfbas wcel cF vs cv csn cun c0 wne c0 cF vs cv csn cun cfi
      cfv wnel wa wb cF cfil wcel vs cv csn cvv wcel cF vs cv csn cun cvv wcel
      vs cv snex cF vs cv csn cfil cvv unexg mpan2 cF vs cv csn cun cvv fsubbas
      syl ad2antrr mpbird $.
      $( [3-Dec-2009] $) $( [15-Dec-2009] $)

    $( If the ultrafilter containing a given filter is unique, the filter is an
       ultrafilter. $)
    ufileu $p |- ( F e. Fil ->
        ( F e. UFil <-> E! f e. UFil ( X = U. f /\ F C_ f ) ) ) $=
      cF cfil wcel cF cufil wcel cX vf cv cuni wceq cF vf cv wss wa vf cufil
      wreu cF cufil wcel cX vf cv cuni wceq cF vf cv wss wa vf cv vg cv wceq wb
      vf cufil wral vg cufil wrex cX vf cv cuni wceq cF vf cv wss wa vf cufil
      wreu cF cufil wcel cX vf cv cuni wceq cF vf cv wss wa vf cv cF wceq wb vf
      cufil wral cX vf cv cuni wceq cF vf cv wss wa vf cv vg cv wceq wb vf
      cufil wral vg cufil wrex cF cufil wcel cX vf cv cuni wceq cF vf cv wss wa
      vf cv cF wceq wb vf cufil cF cufil wcel vf cv cufil wcel wa cX vf cv cuni
      wceq cF vf cv wss wa vf cv cF wceq cF cufil wcel vf cv cfil wcel cX vf cv
      cuni wceq cF vf cv wss wa vf cv cF wceq wi vf cv cufil wcel cF cufil wcel
      vf cv cfil wcel wa cX vf cv cuni wceq cF vf cv wss wa vf cv cF wceq cF
      cufil wcel vf cv cfil wcel wa cX vf cv cuni wceq cF vf cv wss wa wa cF vf
      cv cF vf cv cX vf cv cuni ufileu.1 vf cv cuni eqid ufilmax eqcomd ex vf
      cv ufilfil sylan2 vf cv cF wceq cX vf cv cuni wceq cF vf cv wss wa cX cX
      wceq cF cF wss wa cX cX wceq cF cF wss cX eqid cF ssid pm3.2i vf cv cF
      wceq cX vf cv cuni wceq cX cX wceq cF vf cv wss cF cF wss vf cv cF wceq
      vf cv cuni cX cX vf cv cF wceq vf cv cuni cF cuni cX vf cv cF unieq
      ufileu.1 syl6eqr eqeq2d vf cv cF cF sseq2 anbi12d mpbiri impbid1
      r19.21aiva cX vf cv cuni wceq cF vf cv wss wa vf cv vg cv wceq wb vf
      cufil wral cX vf cv cuni wceq cF vf cv wss wa vf cv cF wceq wb vf cufil
      wral vg cF cufil vg cv cF wceq cX vf cv cuni wceq cF vf cv wss wa vf cv
      vg cv wceq wb cX vf cv cuni wceq cF vf cv wss wa vf cv cF wceq wb vf
      cufil vg cv cF wceq vf cv vg cv wceq vf cv cF wceq cX vf cv cuni wceq cF
      vf cv wss wa vg cv cF vf cv eqeq2 bibi2d ralbidv rcla4ev mpdan cX vf cv
      cuni wceq cF vf cv wss wa vf vg cufil reu6 sylibr cF cfil wcel cX vf cv
      cuni wceq cF vf cv wss wa vf cufil wreu vs cv cF wcel cX vs cv cdif cF
      wcel wo vs cX cpw wral cF cufil wcel cF cfil wcel vf cv cufil wcel cX vf
      cv cuni wceq cF vf cv wss wa wa vf weu vs cv cF wcel cX vs cv cdif cF
      wcel wo vs cX cpw wral cX vf cv cuni wceq cF vf cv wss wa vf cufil wreu
      cF cfil wcel vs cv cF wcel cX vs cv cdif cF wcel wo vs cX cpw wral vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vf weu cF cfil wcel vs
      cv cF wcel cX vs cv cdif cF wcel wo vs cX cpw wral wn vf cv cufil wcel cX
      vf cv cuni wceq cF vf cv wss wa wa vf wmo vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vf weu cF cfil wcel vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa vs cX cpw wrex vf cv cufil wcel cX vf cv cuni wceq cF
      vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss wa wa wa
      vf cv vg cv wceq wn wa vg wex vf wex vs cv cF wcel cX vs cv cdif cF wcel
      wo vs cX cpw wral wn vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa
      wa vf wmo wn cF cfil wcel vs cv cF wcel wn cX vs cv cdif cF wcel wn wa vf
      cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX
      vg cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf
      wex vs cX cpw cF cfil wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv
      cufil wcel cX vg cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn
      wa vg wex vf wex wi vs cv cX cpw wcel cF cfil wcel vs cv cX wss vs cv cF
      wcel wn cX vs cv cdif cF wcel wn wa vf cv cufil wcel cX vf cv cuni wceq
      cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss wa wa
      wa vf cv vg cv wceq wn wa vg wex vf wex cF cfil wcel vs cv cX wss wa vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF vs cv csn cun cfi cfv cfg
      cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa vu
      cufil wrex cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq
      cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa vv cufil wrex vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf wex
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa cF vs cv csn cun cfi cfv cfbas wcel cF vs cv csn cun cfi cfv cfg cfv
      cfil wcel cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv
      csn cun cfi cfv cfg cfv vu cv wss wa vu cufil wrex cF cX vs ufileu.1
      ufileulem cF vs cv csn cun cfi cfv fgfil vu cF vs cv csn cun cfi cfv cfg
      cfv cF vs cv csn cun cfi cfv cfg cfv cuni cF vs cv csn cun cfi cfv cfg
      cfv cuni eqid filssufil 3syl cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi cfv cfbas
      wcel cF cX vs cv cdif csn cun cfi cfv cfg cfv cfil wcel cF cX vs cv cdif
      csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi
      cfv cfg cfv vv cv wss wa vv cufil wrex cF cfil wcel vs cv cX wss wa vs cv
      cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi
      cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif csn
      cun cfi cfv wnel wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv
      cdif csn cun cfi cfv wnel cF cfil wcel cF cX vs cv cdif csn cun c0 wne vs
      cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cX cF
      wcel cF c0 wne cF cX vs cv cdif csn cun c0 wne cF cX ufileu.1 filusb cF
      cX ne0i cF cF cX vs cv cdif csn cun wss cF c0 wne cF cX vs cv cdif csn
      cun c0 wne cF cX vs cv cdif csn ssun1 cF cF cX vs cv cdif csn cun ssn0
      mpan 3syl ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy
      cv cin c0 wne vy cX vs cv cdif csn wral vx cF wral cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vx cv vy cv cin c0
      wne vx vy cF cX vs cv cdif csn cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vx cv cF wcel vy cv cX vs cv cdif csn
      wcel vx cv vy cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn
      cX vs cv cdif cF wcel wn wa wa vy cv cX vs cv cdif csn wcel vx cv cF wcel
      vx cv vy cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa wa vy cv cX vs cv cdif wceq vx cv cF wcel vx cv
      vy cv cin c0 wne wi vy cv cX vs cv cdif csn wcel vy cv cX vs cv cdif wceq
      vx cv cF wcel vx cv vy cv cin c0 wne wi vx cv cF wcel vx cv cX vs cv cdif
      cin c0 wne wi cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa vy cv cX vs cv cdif wceq vx cv vy cv cin c0 wne vx cv cX
      vs cv cdif cin c0 wne vx cv cF wcel vy cv cX vs cv cdif wceq vx cv vy cv
      cin vx cv cX vs cv cdif cin c0 vy cv cX vs cv cdif vx cv ineq2 neeq1d
      imbi2d cF cfil wcel vs cv cX wss wa vs cv cF wcel wn vx cv cF wcel vx cv
      cX vs cv cdif cin c0 wne wi cX vs cv cdif cF wcel wn cF cfil wcel vs cv
      cX wss wa vs cv cF wcel wn vx cv cF wcel vx cv cX vs cv cdif cin c0 wne
      wi cF cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF wcel wn vx cv cX
      vs cv cdif cin c0 wne cF cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF
      wcel wn vx cv cX vs cv cdif cin c0 wne wi cF cfil wcel vs cv cX wss wa vx
      cv cF wcel wa vs cv cF wcel vx cv cX vs cv cdif cin c0 cF cfil wcel vs cv
      cX wss wa vx cv cF wcel wa vx cv cX vs cv cdif cin c0 wceq vx cv vs cv
      wss vs cv cF wcel cF cfil wcel vs cv cX wss wa vx cv cF wcel wa vx cv cX
      vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss vx cv vs cv wss vx
      cv cF wcel vx cv cX vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif
      wss wb cF cfil wcel vs cv cX wss wa vx cv cF wcel vx cv cX wss vx cv cX
      vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss wb vx cv cF wcel
      vx cv cF cuni cX vx cv cF elssuni ufileu.1 syl6ssr vx cv cX vs cv cdif cX
      reldisj syl adantl vs cv cX wss vx cv cX cX vs cv cdif cdif wss vx cv vs
      cv wss wb cF cfil wcel vx cv cF wcel vs cv cX wss cX cX vs cv cdif cdif
      vs cv vx cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv cX dfss4
      biimpi sseq2d ad2antlr bitrd cF cfil wcel vs cv cX wss vx cv cF wcel vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel vx cv vs cv cF cX ufileu.1 fillsb 3expd com23
      imp31 sylbid necon3bd ex com23 imp adantrr syl5cbir vy cX vs cv cdif elsn
      syl5ib com23 imp3a r19.21aivv cF cfbas wcel cX vs cv cdif csn cfbas wcel
      c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cX vs
      cv cdif csn wral vx cF wral wb cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vx vy cF cX vs cv cdif csn fbunfip cF
      cfil wcel cF cfbas wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa cF filfbas ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cX vs cv cdif csn cfil wcel cX vs cv
      cdif csn cfbas wcel cX vs cv cdif cvv wcel cX vs cv cdif c0 wne cX vs cv
      cdif csn cfil wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cX vs cv cdif cvv oefil2 cF cfil wcel cX vs cv cdif
      cvv wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF
      cfil wcel cX cvv wcel cX vs cv cdif cvv wcel cF cfil wcel cF cuni cvv cX
      cF cfil uniexg ufileu.1 syl5eqel cX vs cv cvv difexg syl ad2antrr cF cfil
      wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0 wne cX vs cv cdif
      cF wcel wn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0
      wne cF cfil wcel vs cv cX wss wa vs cv cF wcel cX vs cv cdif c0 cF cfil
      wcel vs cv cX wss wa cX vs cv cdif c0 wceq vs cv cF wcel cF cfil wcel vs
      cv cX wss wa cX vs cv cdif c0 wceq wa vs cv cX cF cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq wa vs cv cX c0 cdif cX cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq vs cv cX cX vs cv cdif cdif cX c0 cdif vs cv
      cX wss vs cv cX cX vs cv cdif cdif wceq cF cfil wcel vs cv cX wss cX cX
      vs cv cdif cdif vs cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv
      cX dfss4 biimpi eqcomd adantl cX vs cv cdif c0 cX difeq2 sylan9eq cX dif0
      syl6eq cF cfil wcel cX cF wcel vs cv cX wss cX vs cv cdif c0 wceq cF cX
      ufileu.1 filusb ad2antrr eqeltrd ex necon3bd imp adantrr sylanc cX vs cv
      cdif csn filfbas syl sylanc mpbird jca cF cfil wcel cF cX vs cv cdif csn
      cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv
      cdif csn cun cfi cfv wnel wa wb vs cv cX wss vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa cF cfil wcel cF cX vs cv cdif csn cun cvv wcel cF cX
      vs cv cdif csn cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0
      cF cX vs cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vs cv cdif
      csn cvv wcel cF cX vs cv cdif csn cun cvv wcel cX vs cv cdif snex cF cX
      vs cv cdif csn cfil cvv unexg mpan2 cF cX vs cv cdif csn cun cvv fsubbas
      syl ad2antrr mpbird cF cX vs cv cdif csn cun cfi cfv fgfil vv cF cX vs cv
      cdif csn cun cfi cfv cfg cfv cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cuni cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni eqid filssufil 3syl cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun
      cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss
      wa wa vv cufil wrex vu cufil wrex vf cv cufil wcel cX vf cv cuni wceq cF
      vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss wa wa wa
      vf cv vg cv wceq wn wa vg wex vf wex cF vs cv csn cun cfi cfv cfg cfv
      cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa vu
      cufil wrex cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq
      cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa vv cufil wrex wa cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun
      cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss
      wa wa vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil
      wcel cX vg cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg
      wex vf wex vu vv cufil cufil cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa cF
      vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi
      cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv
      cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa vf
      cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX
      vg cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf
      wex vu cv cufil wcel cX vu cv cuni wceq cF vu cv wss wa wa vv cv cufil
      wcel cX vv cv cuni wceq cF vv cv wss wa wa vu cv vv cv wceq wn vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf wex
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg
      cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF
      cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv
      cdif csn cun cfi cfv cfg cfv vv cv wss wa wa wa cF cfil wcel vs cv cX wss
      wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv
      cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF
      vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi
      cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv
      vv cv wss wa wa wa vu cv cufil wcel cX vu cv cuni wceq cF vu cv wss cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vu cv cufil wcel vv cv cufil wcel cF vs cv csn cun cfi cfv cfg cfv cuni
      vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv
      cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn
      cun cfi cfv cfg cfv vv cv wss wa wa simplrl cF cfil wcel vs cv cX wss wa
      vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv
      cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF
      vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi
      cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv
      vv cv wss wa wa wa cX cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      cX cF vs cv csn cun cfi cfv cfg cfv cuni wceq vu cv cufil wcel vv cv
      cufil wcel wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs
      cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv
      cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv
      cv wss wa wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa cX cF vs cv csn cun cuni cF vs cv csn cun cfi cfv cuni
      cF vs cv csn cun cfi cfv cfg cfv cuni cF cfil wcel vs cv cX wss wa vs cv
      cF wcel wn cX vs cv cdif cF wcel wn wa wa cX cF cuni vs cv csn cuni cun
      cF vs cv csn cun cuni cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa cX vs cv cun cX cF cuni vs cv csn cuni cun cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vs cv cX wss cX vs cv cun cX wceq cF cfil wcel vs cv cX wss vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa simplr vs cv cX ssequn2 sylib cX cF cuni
      vs cv vs cv csn cuni ufileu.1 vs cv csn cuni vs cv vs cv vs visset unisn
      eqcomi uneq12i syl5reqr cF vs cv csn uniun syl6eqr cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF vs cv csn cun
      cvv wcel cF vs cv csn cun cuni cF vs cv csn cun cfi cfv cuni wceq cF cfil
      wcel cF vs cv csn cun cvv wcel vs cv cX wss vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa cF cfil wcel vs cv csn cvv wcel cF vs cv csn cun cvv
      wcel vs cv snex cF vs cv csn cfil cvv unexg mpan2 ad2antrr cF vs cv csn
      cun cvv fiuni syl cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cF vs cv csn cun cfi cfv cfbas wcel cF vs cv csn
      cun cfi cfv cuni cF vs cv csn cun cfi cfv cfg cfv cuni wceq cF cX vs
      ufileu.1 ufileulem cF vs cv csn cun cfi cfv cF vs cv csn cun cfi cfv cuni
      cF vs cv csn cun cfi cfv cuni eqid fgbas syl 3eqtrd ad2antrr cF cfil wcel
      vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv
      cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni
      vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss cF cX vs cv
      cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn
      cun cfi cfv cfg cfv vv cv wss wa simprll eqtrd cF cfil wcel vs cv cX wss
      wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv
      cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF
      vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi
      cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv
      vv cv wss wa wa wa cF cF vs cv csn cun cfi cfv cfg cfv vu cv cF cfil wcel
      vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cF vs
      cv csn cun cfi cfv cfg cfv wss vu cv cufil wcel vv cv cufil wcel wa cF vs
      cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv
      cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv
      cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      cF cF vs cv csn cun cfi cfv cF vs cv csn cun cfi cfv cfg cfv cF cfil wcel
      vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cF vs
      cv csn cun cF vs cv csn cun cfi cfv cF cF vs cv csn cun wss cF cfil wcel
      vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF vs cv
      csn ssun1 a1i cF cfil wcel cF vs cv csn cun cF vs cv csn cun cfi cfv wss
      vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cF
      vs cv csn cun cvv wcel cF vs cv csn cun cF vs cv csn cun cfi cfv wss cF
      cfil wcel vs cv csn cvv wcel cF vs cv csn cun cvv wcel vs cv snex cF vs
      cv csn cfil cvv unexg mpan2 cF vs cv csn cun cvv abfi2 syl ad2antrr sstrd
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa cF vs cv csn cun cfi cfv cfbas wcel cF vs cv csn cun cfi cfv cF vs cv
      csn cun cfi cfv cfg cfv wss cF cX vs ufileu.1 ufileulem cF vs cv csn cun
      cfi cfv fbssfg syl sstrd ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF
      wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel
      wa wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn
      cun cfi cfv cfg cfv vu cv wss cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss
      wa simprlr sstrd jca32 cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs
      cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv
      cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv
      cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa wa vv
      cv cufil wcel cX vv cv cuni wceq cF vv cv wss cF cfil wcel vs cv cX wss
      wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv
      cufil wcel cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv
      csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg
      cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv
      wss wa wa simplrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv
      csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg
      cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni
      wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa wa cX cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cX cF cX vs cv
      cdif csn cun cfi cfv cfg cfv cuni wceq vu cv cufil wcel vv cv cufil wcel
      wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun
      cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss
      wa wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel
      wn wa wa cX cF cX vs cv cdif csn cun cfi cfv cuni cF cX vs cv cdif csn
      cun cfi cfv cfg cfv cuni cF cfil wcel cX cF cX vs cv cdif csn cun cfi cfv
      cuni wceq vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF
      cfil wcel cX cF cX vs cv cdif csn cun cuni cF cX vs cv cdif csn cun cfi
      cfv cuni cF cfil wcel cX cF cuni cX vs cv cdif csn cuni cun cF cX vs cv
      cdif csn cun cuni cF cfil wcel cX cX vs cv cdif cun cF cuni cX vs cv cdif
      csn cuni cun cX cF cfil wcel cX cF cuni cX vs cv cdif cX vs cv cdif csn
      cuni cX cF cuni wceq cF cfil wcel ufileu.1 a1i cF cfil wcel cX vs cv cdif
      csn cuni cX vs cv cdif cF cfil wcel cX cvv wcel cX vs cv cdif cvv wcel cX
      vs cv cdif csn cuni cX vs cv cdif wceq cF cfil wcel cF cuni cvv cX cF
      cfil uniexg ufileu.1 syl5eqel cX vs cv cvv difexg cX vs cv cdif cvv
      unisng 3syl eqcomd uneq12d cX vs cv cdif cX wss cX cX vs cv cdif cun cX
      wceq cX vs cv difss cX vs cv cdif cX ssequn2 mpbi syl5eqr cF cX vs cv
      cdif csn uniun syl6eqr cF cfil wcel cF cX vs cv cdif csn cun cvv wcel cF
      cX vs cv cdif csn cun cuni cF cX vs cv cdif csn cun cfi cfv cuni wceq cF
      cfil wcel cX vs cv cdif csn cvv wcel cF cX vs cv cdif csn cun cvv wcel cX
      vs cv cdif snex cF cX vs cv cdif csn cfil cvv unexg mpan2 cF cX vs cv
      cdif csn cun cvv fiuni syl eqtrd ad2antrr cF cfil wcel vs cv cX wss wa vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi
      cfv cfbas wcel cF cX vs cv cdif csn cun cfi cfv cuni cF cX vs cv cdif csn
      cun cfi cfv cfg cfv cuni wceq cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi cfv cfbas
      wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif csn cun cfi cfv
      wnel wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif csn cun
      cfi cfv wnel cF cfil wcel cF cX vs cv cdif csn cun c0 wne vs cv cX wss vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cX cF wcel cF c0
      wne cF cX vs cv cdif csn cun c0 wne cF cX ufileu.1 filusb cF cX ne0i cF
      cF cX vs cv cdif csn cun wss cF c0 wne cF cX vs cv cdif csn cun c0 wne cF
      cX vs cv cdif csn ssun1 cF cF cX vs cv cdif csn cun ssn0 mpan 3syl
      ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy cv cin c0
      wne vy cX vs cv cdif csn wral vx cF wral cF cfil wcel vs cv cX wss wa vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vx cv vy cv cin c0 wne vx vy
      cF cX vs cv cdif csn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa vx cv cF wcel vy cv cX vs cv cdif csn wcel vx cv
      vy cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa vy cv cX vs cv cdif csn wcel vx cv cF wcel vx cv vy
      cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa vy cv cX vs cv cdif wceq vx cv cF wcel vx cv vy cv cin
      c0 wne wi vy cv cX vs cv cdif csn wcel vy cv cX vs cv cdif wceq vx cv cF
      wcel vx cv vy cv cin c0 wne wi vx cv cF wcel vx cv cX vs cv cdif cin c0
      wne wi cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vy cv cX vs cv cdif wceq vx cv vy cv cin c0 wne vx cv cX vs
      cv cdif cin c0 wne vx cv cF wcel vy cv cX vs cv cdif wceq vx cv vy cv cin
      vx cv cX vs cv cdif cin c0 vy cv cX vs cv cdif vx cv ineq2 neeq1d imbi2d
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn vx cv cF wcel vx cv cX vs
      cv cdif cin c0 wne wi cX vs cv cdif cF wcel wn cF cfil wcel vs cv cX wss
      wa vs cv cF wcel wn vx cv cF wcel vx cv cX vs cv cdif cin c0 wne wi cF
      cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF wcel wn vx cv cX vs cv
      cdif cin c0 wne cF cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF wcel
      wn vx cv cX vs cv cdif cin c0 wne wi cF cfil wcel vs cv cX wss wa vx cv
      cF wcel wa vs cv cF wcel vx cv cX vs cv cdif cin c0 cF cfil wcel vs cv cX
      wss wa vx cv cF wcel wa vx cv cX vs cv cdif cin c0 wceq vx cv vs cv wss
      vs cv cF wcel cF cfil wcel vs cv cX wss wa vx cv cF wcel wa vx cv cX vs
      cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss vx cv vs cv wss vx cv
      cF wcel vx cv cX vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss
      wb cF cfil wcel vs cv cX wss wa vx cv cF wcel vx cv cX wss vx cv cX vs cv
      cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss wb vx cv cF wcel vx cv
      cF cuni cX vx cv cF elssuni ufileu.1 syl6ssr vx cv cX vs cv cdif cX
      reldisj syl adantl vs cv cX wss vx cv cX cX vs cv cdif cdif wss vx cv vs
      cv wss wb cF cfil wcel vx cv cF wcel vs cv cX wss cX cX vs cv cdif cdif
      vs cv vx cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv cX dfss4
      biimpi sseq2d ad2antlr bitrd cF cfil wcel vs cv cX wss vx cv cF wcel vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel vx cv vs cv cF cX ufileu.1 fillsb 3expd com23
      imp31 sylbid necon3bd ex com23 imp adantrr syl5cbir vy cX vs cv cdif elsn
      syl5ib com23 imp3a r19.21aivv cF cfbas wcel cX vs cv cdif csn cfbas wcel
      c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cX vs
      cv cdif csn wral vx cF wral wb cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vx vy cF cX vs cv cdif csn fbunfip cF
      cfil wcel cF cfbas wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa cF filfbas ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cX vs cv cdif csn cfil wcel cX vs cv
      cdif csn cfbas wcel cX vs cv cdif cvv wcel cX vs cv cdif c0 wne cX vs cv
      cdif csn cfil wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cX vs cv cdif cvv oefil2 cF cfil wcel cX vs cv cdif
      cvv wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF
      cfil wcel cX cvv wcel cX vs cv cdif cvv wcel cF cfil wcel cF cuni cvv cX
      cF cfil uniexg ufileu.1 syl5eqel cX vs cv cvv difexg syl ad2antrr cF cfil
      wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0 wne cX vs cv cdif
      cF wcel wn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0
      wne cF cfil wcel vs cv cX wss wa vs cv cF wcel cX vs cv cdif c0 cF cfil
      wcel vs cv cX wss wa cX vs cv cdif c0 wceq vs cv cF wcel cF cfil wcel vs
      cv cX wss wa cX vs cv cdif c0 wceq wa vs cv cX cF cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq wa vs cv cX c0 cdif cX cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq vs cv cX cX vs cv cdif cdif cX c0 cdif vs cv
      cX wss vs cv cX cX vs cv cdif cdif wceq cF cfil wcel vs cv cX wss cX cX
      vs cv cdif cdif vs cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv
      cX dfss4 biimpi eqcomd adantl cX vs cv cdif c0 cX difeq2 sylan9eq cX dif0
      syl6eq cF cfil wcel cX cF wcel vs cv cX wss cX vs cv cdif c0 wceq cF cX
      ufileu.1 filusb ad2antrr eqeltrd ex necon3bd imp adantrr sylanc cX vs cv
      cdif csn filfbas syl sylanc mpbird jca cF cfil wcel cF cX vs cv cdif csn
      cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv
      cdif csn cun cfi cfv wnel wa wb vs cv cX wss vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa cF cfil wcel cF cX vs cv cdif csn cun cvv wcel cF cX
      vs cv cdif csn cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0
      cF cX vs cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vs cv cdif
      csn cvv wcel cF cX vs cv cdif csn cun cvv wcel cX vs cv cdif snex cF cX
      vs cv cdif csn cfil cvv unexg mpan2 cF cX vs cv cdif csn cun cvv fsubbas
      syl ad2antrr mpbird cF cX vs cv cdif csn cun cfi cfv cF cX vs cv cdif csn
      cun cfi cfv cuni cF cX vs cv cdif csn cun cfi cfv cuni eqid fgbas syl
      eqtrd ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv
      csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg
      cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni
      wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss simprrl eqtrd cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv
      cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif
      csn cun cfi cfv cfg cfv vv cv wss wa wa wa cF cF cX vs cv cdif csn cun
      cfi cfv cfg cfv vv cv cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa cF cF cX vs cv cdif csn cun cfi cfv cfg cfv wss
      vu cv cufil wcel vv cv cufil wcel wa cF vs cv csn cun cfi cfv cfg cfv
      cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif
      csn cun cfi cfv cfg cfv vv cv wss wa wa cF cfil wcel vs cv cX wss wa vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cF cX vs cv cdif csn cun
      cfi cfv cF cX vs cv cdif csn cun cfi cfv cfg cfv cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cF cX vs cv
      cdif csn cun cF cX vs cv cdif csn cun cfi cfv cF cF cX vs cv cdif csn cun
      wss cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel
      wn wa wa cF cX vs cv cdif csn ssun1 a1i cF cfil wcel cF cX vs cv cdif csn
      cun cF cX vs cv cdif csn cun cfi cfv wss vs cv cX wss vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa cF cfil wcel cF cX vs cv cdif csn cun cvv wcel
      cF cX vs cv cdif csn cun cF cX vs cv cdif csn cun cfi cfv wss cF cfil
      wcel cX vs cv cdif csn cvv wcel cF cX vs cv cdif csn cun cvv wcel cX vs
      cv cdif snex cF cX vs cv cdif csn cfil cvv unexg mpan2 cF cX vs cv cdif
      csn cun cvv abfi2 syl ad2antrr sstrd cF cfil wcel vs cv cX wss wa vs cv
      cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi
      cfv cfbas wcel cF cX vs cv cdif csn cun cfi cfv cF cX vs cv cdif csn cun
      cfi cfv cfg cfv wss cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi cfv cfbas wcel cF
      cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif csn cun cfi cfv wnel wa
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif csn cun cfi cfv
      wnel cF cfil wcel cF cX vs cv cdif csn cun c0 wne vs cv cX wss vs cv cF
      wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cX cF wcel cF c0 wne cF
      cX vs cv cdif csn cun c0 wne cF cX ufileu.1 filusb cF cX ne0i cF cF cX vs
      cv cdif csn cun wss cF c0 wne cF cX vs cv cdif csn cun c0 wne cF cX vs cv
      cdif csn ssun1 cF cF cX vs cv cdif csn cun ssn0 mpan 3syl ad2antrr cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cX vs
      cv cdif csn wral vx cF wral cF cfil wcel vs cv cX wss wa vs cv cF wcel wn
      cX vs cv cdif cF wcel wn wa wa vx cv vy cv cin c0 wne vx vy cF cX vs cv
      cdif csn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vx cv cF wcel vy cv cX vs cv cdif csn wcel vx cv vy cv cin
      c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vy cv cX vs cv cdif csn wcel vx cv cF wcel vx cv vy cv cin
      c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vy cv cX vs cv cdif wceq vx cv cF wcel vx cv vy cv cin c0
      wne wi vy cv cX vs cv cdif csn wcel vy cv cX vs cv cdif wceq vx cv cF
      wcel vx cv vy cv cin c0 wne wi vx cv cF wcel vx cv cX vs cv cdif cin c0
      wne wi cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vy cv cX vs cv cdif wceq vx cv vy cv cin c0 wne vx cv cX vs
      cv cdif cin c0 wne vx cv cF wcel vy cv cX vs cv cdif wceq vx cv vy cv cin
      vx cv cX vs cv cdif cin c0 vy cv cX vs cv cdif vx cv ineq2 neeq1d imbi2d
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn vx cv cF wcel vx cv cX vs
      cv cdif cin c0 wne wi cX vs cv cdif cF wcel wn cF cfil wcel vs cv cX wss
      wa vs cv cF wcel wn vx cv cF wcel vx cv cX vs cv cdif cin c0 wne wi cF
      cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF wcel wn vx cv cX vs cv
      cdif cin c0 wne cF cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF wcel
      wn vx cv cX vs cv cdif cin c0 wne wi cF cfil wcel vs cv cX wss wa vx cv
      cF wcel wa vs cv cF wcel vx cv cX vs cv cdif cin c0 cF cfil wcel vs cv cX
      wss wa vx cv cF wcel wa vx cv cX vs cv cdif cin c0 wceq vx cv vs cv wss
      vs cv cF wcel cF cfil wcel vs cv cX wss wa vx cv cF wcel wa vx cv cX vs
      cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss vx cv vs cv wss vx cv
      cF wcel vx cv cX vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss
      wb cF cfil wcel vs cv cX wss wa vx cv cF wcel vx cv cX wss vx cv cX vs cv
      cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss wb vx cv cF wcel vx cv
      cF cuni cX vx cv cF elssuni ufileu.1 syl6ssr vx cv cX vs cv cdif cX
      reldisj syl adantl vs cv cX wss vx cv cX cX vs cv cdif cdif wss vx cv vs
      cv wss wb cF cfil wcel vx cv cF wcel vs cv cX wss cX cX vs cv cdif cdif
      vs cv vx cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv cX dfss4
      biimpi sseq2d ad2antlr bitrd cF cfil wcel vs cv cX wss vx cv cF wcel vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel vx cv vs cv cF cX ufileu.1 fillsb 3expd com23
      imp31 sylbid necon3bd ex com23 imp adantrr syl5cbir vy cX vs cv cdif elsn
      syl5ib com23 imp3a r19.21aivv cF cfbas wcel cX vs cv cdif csn cfbas wcel
      c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cX vs
      cv cdif csn wral vx cF wral wb cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vx vy cF cX vs cv cdif csn fbunfip cF
      cfil wcel cF cfbas wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa cF filfbas ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cX vs cv cdif csn cfil wcel cX vs cv
      cdif csn cfbas wcel cX vs cv cdif cvv wcel cX vs cv cdif c0 wne cX vs cv
      cdif csn cfil wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cX vs cv cdif cvv oefil2 cF cfil wcel cX vs cv cdif
      cvv wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF
      cfil wcel cX cvv wcel cX vs cv cdif cvv wcel cF cfil wcel cF cuni cvv cX
      cF cfil uniexg ufileu.1 syl5eqel cX vs cv cvv difexg syl ad2antrr cF cfil
      wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0 wne cX vs cv cdif
      cF wcel wn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0
      wne cF cfil wcel vs cv cX wss wa vs cv cF wcel cX vs cv cdif c0 cF cfil
      wcel vs cv cX wss wa cX vs cv cdif c0 wceq vs cv cF wcel cF cfil wcel vs
      cv cX wss wa cX vs cv cdif c0 wceq wa vs cv cX cF cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq wa vs cv cX c0 cdif cX cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq vs cv cX cX vs cv cdif cdif cX c0 cdif vs cv
      cX wss vs cv cX cX vs cv cdif cdif wceq cF cfil wcel vs cv cX wss cX cX
      vs cv cdif cdif vs cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv
      cX dfss4 biimpi eqcomd adantl cX vs cv cdif c0 cX difeq2 sylan9eq cX dif0
      syl6eq cF cfil wcel cX cF wcel vs cv cX wss cX vs cv cdif c0 wceq cF cX
      ufileu.1 filusb ad2antrr eqeltrd ex necon3bd imp adantrr sylanc cX vs cv
      cdif csn filfbas syl sylanc mpbird jca cF cfil wcel cF cX vs cv cdif csn
      cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv
      cdif csn cun cfi cfv wnel wa wb vs cv cX wss vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa cF cfil wcel cF cX vs cv cdif csn cun cvv wcel cF cX
      vs cv cdif csn cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0
      cF cX vs cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vs cv cdif
      csn cvv wcel cF cX vs cv cdif csn cun cvv wcel cX vs cv cdif snex cF cX
      vs cv cdif csn cfil cvv unexg mpan2 cF cX vs cv cdif csn cun cvv fsubbas
      syl ad2antrr mpbird cF cX vs cv cdif csn cun cfi cfv fbssfg syl sstrd
      ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun
      cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu
      cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq
      cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss simprrr sstrd jca32 cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv
      cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif
      csn cun cfi cfv cfg cfv vv cv wss wa wa wa vu cv vv cv wceq c0 vu cv wcel
      vu cv cufil wcel vv cv cufil wcel wa c0 vu cv wcel wn cF cfil wcel vs cv
      cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF vs cv csn
      cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv
      vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni
      wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa vu cv cufil
      wcel c0 vu cv wcel wn vv cv cufil wcel vu cv cufil wcel vu cv cfil wcel
      c0 vu cv wcel wn vu cv ufilfil vu cv filesn syl adantr ad2antlr cF cfil
      wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu
      cv cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv
      cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif
      csn cun cfi cfv cfg cfv vv cv wss wa wa wa vu cv vv cv wceq wa vs cv cX
      vs cv cdif cin vu cv c0 vu cv cfil wcel vs cv vu cv wcel cX vs cv cdif vu
      cv wcel vs cv cX vs cv cdif cin vu cv wcel cF cfil wcel vs cv cX wss wa
      vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv
      cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF
      vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi
      cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv
      vv cv wss wa wa wa vu cv vv cv wceq wa vs cv cX vs cv cdif vu cv filint
      cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa
      wa vu cv cufil wcel vv cv cufil wcel wa wa vu cv cfil wcel cF vs cv csn
      cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv
      vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni
      wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa vu cv vv cv
      wceq vu cv cufil wcel vu cv cfil wcel cF cfil wcel vs cv cX wss wa vs cv
      cF wcel wn cX vs cv cdif cF wcel wn wa wa vv cv cufil wcel vu cv ufilfil
      ad2antrl ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs cv
      csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg
      cfv vu cv wss wa cF cX vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni
      wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss wa wa wa vs cv vu
      cv wcel vu cv vv cv wceq cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF vs
      cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv
      cfg cfv vu cv wss wa vs cv vu cv wcel cF cX vs cv cdif csn cun cfi cfv
      cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv
      cv wss wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vu cv cufil wcel cF vs cv csn cun cfi cfv cfg cfv cuni vu
      cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa vs cv vu cv
      wcel vv cv cufil wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa vu cv cufil wcel wa cF vs cv csn cun cfi cfv cfg
      cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa wa
      vs cv csn vu cv vs cv cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs
      cv cdif cF wcel wn wa wa vu cv cufil wcel wa cF vs cv csn cun cfi cfv cfg
      cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa wa
      vs cv csn cF vs cv csn cun cfi cfv cfg cfv vu cv cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vs cv csn cF vs cv
      csn cun cfi cfv cfg cfv wss vu cv cufil wcel cF vs cv csn cun cfi cfv cfg
      cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vs cv csn cF vs cv csn cun cfi cfv cF vs cv csn cun cfi cfv cfg cfv cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vs cv csn cF vs cv csn cun cF vs cv csn cun cfi cfv vs cv csn cF vs cv
      csn cun wss cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa vs cv csn cF ssun2 a1i cF cfil wcel cF vs cv csn cun cF
      vs cv csn cun cfi cfv wss vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa cF cfil wcel cF vs cv csn cun cvv wcel cF vs cv csn cun cF vs
      cv csn cun cfi cfv wss cF cfil wcel vs cv csn cvv wcel cF vs cv csn cun
      cvv wcel vs cv snex cF vs cv csn cfil cvv unexg mpan2 cF vs cv csn cun
      cvv abfi2 syl ad2antrr sstrd cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cF vs cv csn cun cfi cfv cfbas wcel cF
      vs cv csn cun cfi cfv cF vs cv csn cun cfi cfv cfg cfv wss cF cX vs
      ufileu.1 ufileulem cF vs cv csn cun cfi cfv fbssfg syl sstrd ad2antrr cF
      cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa
      vu cv cufil wcel wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq
      cF vs cv csn cun cfi cfv cfg cfv vu cv wss simprr sstrd vs cv vs cv csn
      wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel
      wn wa wa vu cv cufil wcel wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv
      cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa wa vs cv vs
      visset snid a1i sseldd adantlrr adantrr adantr cF cfil wcel vs cv cX wss
      wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv cufil wcel vv cv
      cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF
      vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi
      cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv
      vv cv wss wa wa wa vu cv vv cv wceq wa cX vs cv cdif vv cv vu cv cF cfil
      wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu
      cv cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv
      cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif
      csn cun cfi cfv cfg cfv vv cv wss wa wa wa cX vs cv cdif vv cv wcel vu cv
      vv cv wceq cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vu cv cufil wcel vv cv cufil wcel wa wa cF cX vs cv cdif
      csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi
      cfv cfg cfv vv cv wss wa cX vs cv cdif vv cv wcel cF vs cv csn cun cfi
      cfv cfg cfv cuni vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv
      wss wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa vv cv cufil wcel cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv wss
      wa cX vs cv cdif vv cv wcel vu cv cufil wcel cF cfil wcel vs cv cX wss wa
      vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vv cv cufil wcel wa cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif
      csn cun cfi cfv cfg cfv vv cv wss wa wa cF cX vs cv cdif csn cun cfi cfv
      cfg cfv vv cv cX vs cv cdif cF cfil wcel vs cv cX wss wa vs cv cF wcel wn
      cX vs cv cdif cF wcel wn wa wa vv cv cufil wcel wa cF cX vs cv cdif csn
      cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv
      cfg cfv vv cv wss simprr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa wa cX vs cv cdif cF cX vs cv cdif csn cun cfi
      cfv cfg cfv wcel vv cv cufil wcel cF cX vs cv cdif csn cun cfi cfv cfg
      cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv vv cv
      wss wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa wa cX vs cv cdif csn cF cX vs cv cdif csn cun cfi cfv cfg cfv
      cX vs cv cdif cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa cX vs cv cdif csn cF cX vs cv cdif csn cun cfi cfv cF cX
      vs cv cdif csn cun cfi cfv cfg cfv cF cfil wcel vs cv cX wss wa vs cv cF
      wcel wn cX vs cv cdif cF wcel wn wa wa cX vs cv cdif csn cF cX vs cv cdif
      csn cun cF cX vs cv cdif csn cun cfi cfv cX vs cv cdif csn cF cX vs cv
      cdif csn cun wss cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cX vs cv cdif csn cF ssun2 a1i cF cfil wcel cF cX
      vs cv cdif csn cun cF cX vs cv cdif csn cun cfi cfv wss vs cv cX wss vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cF cX vs cv cdif
      csn cun cvv wcel cF cX vs cv cdif csn cun cF cX vs cv cdif csn cun cfi
      cfv wss cF cfil wcel cX vs cv cdif csn cvv wcel cF cX vs cv cdif csn cun
      cvv wcel cX vs cv cdif snex cF cX vs cv cdif csn cfil cvv unexg mpan2 cF
      cX vs cv cdif csn cun cvv abfi2 syl ad2antrr sstrd cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif
      csn cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun cfi cfv cF cX vs cv
      cdif csn cun cfi cfv cfg cfv wss cF cfil wcel vs cv cX wss wa vs cv cF
      wcel wn cX vs cv cdif cF wcel wn wa wa cF cX vs cv cdif csn cun cfi cfv
      cfbas wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif csn cun
      cfi cfv wnel wa cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv cdif
      csn cun cfi cfv wnel cF cfil wcel cF cX vs cv cdif csn cun c0 wne vs cv
      cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF cfil wcel cX cF
      wcel cF c0 wne cF cX vs cv cdif csn cun c0 wne cF cX ufileu.1 filusb cF
      cX ne0i cF cF cX vs cv cdif csn cun wss cF c0 wne cF cX vs cv cdif csn
      cun c0 wne cF cX vs cv cdif csn ssun1 cF cF cX vs cv cdif csn cun ssn0
      mpan 3syl ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy
      cv cin c0 wne vy cX vs cv cdif csn wral vx cF wral cF cfil wcel vs cv cX
      wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vx cv vy cv cin c0
      wne vx vy cF cX vs cv cdif csn cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vx cv cF wcel vy cv cX vs cv cdif csn
      wcel vx cv vy cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn
      cX vs cv cdif cF wcel wn wa wa vy cv cX vs cv cdif csn wcel vx cv cF wcel
      vx cv vy cv cin c0 wne cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX
      vs cv cdif cF wcel wn wa wa vy cv cX vs cv cdif wceq vx cv cF wcel vx cv
      vy cv cin c0 wne wi vy cv cX vs cv cdif csn wcel vy cv cX vs cv cdif wceq
      vx cv cF wcel vx cv vy cv cin c0 wne wi vx cv cF wcel vx cv cX vs cv cdif
      cin c0 wne wi cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif
      cF wcel wn wa wa vy cv cX vs cv cdif wceq vx cv vy cv cin c0 wne vx cv cX
      vs cv cdif cin c0 wne vx cv cF wcel vy cv cX vs cv cdif wceq vx cv vy cv
      cin vx cv cX vs cv cdif cin c0 vy cv cX vs cv cdif vx cv ineq2 neeq1d
      imbi2d cF cfil wcel vs cv cX wss wa vs cv cF wcel wn vx cv cF wcel vx cv
      cX vs cv cdif cin c0 wne wi cX vs cv cdif cF wcel wn cF cfil wcel vs cv
      cX wss wa vs cv cF wcel wn vx cv cF wcel vx cv cX vs cv cdif cin c0 wne
      wi cF cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF wcel wn vx cv cX
      vs cv cdif cin c0 wne cF cfil wcel vs cv cX wss wa vx cv cF wcel vs cv cF
      wcel wn vx cv cX vs cv cdif cin c0 wne wi cF cfil wcel vs cv cX wss wa vx
      cv cF wcel wa vs cv cF wcel vx cv cX vs cv cdif cin c0 cF cfil wcel vs cv
      cX wss wa vx cv cF wcel wa vx cv cX vs cv cdif cin c0 wceq vx cv vs cv
      wss vs cv cF wcel cF cfil wcel vs cv cX wss wa vx cv cF wcel wa vx cv cX
      vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss vx cv vs cv wss vx
      cv cF wcel vx cv cX vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif
      wss wb cF cfil wcel vs cv cX wss wa vx cv cF wcel vx cv cX wss vx cv cX
      vs cv cdif cin c0 wceq vx cv cX cX vs cv cdif cdif wss wb vx cv cF wcel
      vx cv cF cuni cX vx cv cF elssuni ufileu.1 syl6ssr vx cv cX vs cv cdif cX
      reldisj syl adantl vs cv cX wss vx cv cX cX vs cv cdif cdif wss vx cv vs
      cv wss wb cF cfil wcel vx cv cF wcel vs cv cX wss cX cX vs cv cdif cdif
      vs cv vx cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv cX dfss4
      biimpi sseq2d ad2antlr bitrd cF cfil wcel vs cv cX wss vx cv cF wcel vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel wi cF cfil wcel vx cv cF wcel vs cv cX wss vx
      cv vs cv wss vs cv cF wcel vx cv vs cv cF cX ufileu.1 fillsb 3expd com23
      imp31 sylbid necon3bd ex com23 imp adantrr syl5cbir vy cX vs cv cdif elsn
      syl5ib com23 imp3a r19.21aivv cF cfbas wcel cX vs cv cdif csn cfbas wcel
      c0 cF cX vs cv cdif csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cX vs
      cv cdif csn wral vx cF wral wb cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa vx vy cF cX vs cv cdif csn fbunfip cF
      cfil wcel cF cfbas wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF
      wcel wn wa cF filfbas ad2antrr cF cfil wcel vs cv cX wss wa vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa wa cX vs cv cdif csn cfil wcel cX vs cv
      cdif csn cfbas wcel cX vs cv cdif cvv wcel cX vs cv cdif c0 wne cX vs cv
      cdif csn cfil wcel cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa wa cX vs cv cdif cvv oefil2 cF cfil wcel cX vs cv cdif
      cvv wcel vs cv cX wss vs cv cF wcel wn cX vs cv cdif cF wcel wn wa cF
      cfil wcel cX cvv wcel cX vs cv cdif cvv wcel cF cfil wcel cF cuni cvv cX
      cF cfil uniexg ufileu.1 syl5eqel cX vs cv cvv difexg syl ad2antrr cF cfil
      wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0 wne cX vs cv cdif
      cF wcel wn cF cfil wcel vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif c0
      wne cF cfil wcel vs cv cX wss wa vs cv cF wcel cX vs cv cdif c0 cF cfil
      wcel vs cv cX wss wa cX vs cv cdif c0 wceq vs cv cF wcel cF cfil wcel vs
      cv cX wss wa cX vs cv cdif c0 wceq wa vs cv cX cF cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq wa vs cv cX c0 cdif cX cF cfil wcel vs cv cX
      wss wa cX vs cv cdif c0 wceq vs cv cX cX vs cv cdif cdif cX c0 cdif vs cv
      cX wss vs cv cX cX vs cv cdif cdif wceq cF cfil wcel vs cv cX wss cX cX
      vs cv cdif cdif vs cv vs cv cX wss cX cX vs cv cdif cdif vs cv wceq vs cv
      cX dfss4 biimpi eqcomd adantl cX vs cv cdif c0 cX difeq2 sylan9eq cX dif0
      syl6eq cF cfil wcel cX cF wcel vs cv cX wss cX vs cv cdif c0 wceq cF cX
      ufileu.1 filusb ad2antrr eqeltrd ex necon3bd imp adantrr sylanc cX vs cv
      cdif csn filfbas syl sylanc mpbird jca cF cfil wcel cF cX vs cv cdif csn
      cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0 cF cX vs cv
      cdif csn cun cfi cfv wnel wa wb vs cv cX wss vs cv cF wcel wn cX vs cv
      cdif cF wcel wn wa cF cfil wcel cF cX vs cv cdif csn cun cvv wcel cF cX
      vs cv cdif csn cun cfi cfv cfbas wcel cF cX vs cv cdif csn cun c0 wne c0
      cF cX vs cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vs cv cdif
      csn cvv wcel cF cX vs cv cdif csn cun cvv wcel cX vs cv cdif snex cF cX
      vs cv cdif csn cfil cvv unexg mpan2 cF cX vs cv cdif csn cun cvv fsubbas
      syl ad2antrr mpbird cF cX vs cv cdif csn cun cfi cfv fbssfg syl sstrd cF
      cfil wcel cX vs cv cdif cX vs cv cdif csn wcel vs cv cX wss vs cv cF wcel
      wn cX vs cv cdif cF wcel wn wa cF cfil wcel cX cvv wcel cX vs cv cdif cvv
      wcel cX vs cv cdif cX vs cv cdif csn wcel cF cfil wcel cF cuni cvv cX cF
      cfil uniexg ufileu.1 syl5eqel cX vs cv cvv difexg cX vs cv cdif cvv snidg
      3syl ad2antrr sseldd ad2antrr sseldd adantlrl adantrl adantr cF cfil wcel
      vs cv cX wss wa vs cv cF wcel wn cX vs cv cdif cF wcel wn wa wa vu cv
      cufil wcel vv cv cufil wcel wa wa cF vs cv csn cun cfi cfv cfg cfv cuni
      vu cv cuni wceq cF vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv
      cdif csn cun cfi cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn
      cun cfi cfv cfg cfv vv cv wss wa wa wa vu cv vv cv wceq pm3.27 eleqtrrd
      syl3anc vs cv cX difdisj syl5eqelr mtand vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss
      wa wa wa vf cv vg cv wceq wn wa vu cv cufil wcel cX vu cv cuni wceq cF vu
      cv wss wa wa vv cv cufil wcel cX vv cv cuni wceq cF vv cv wss wa wa wa vu
      cv vv cv wceq wn wa vf vg vu cv vv cv vu visset vv visset vf cv vu cv
      wceq vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil
      wcel cX vg cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vu
      cv cufil wcel cX vu cv cuni wceq cF vu cv wss wa wa vg cv cufil wcel cX
      vg cv cuni wceq cF vg cv wss wa wa wa vu cv vg cv wceq wn wa vg cv vv cv
      wceq vu cv cufil wcel cX vu cv cuni wceq cF vu cv wss wa wa vv cv cufil
      wcel cX vv cv cuni wceq cF vv cv wss wa wa wa vu cv vv cv wceq wn wa vf
      cv vu cv wceq vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg
      cv cufil wcel cX vg cv cuni wceq cF vg cv wss wa wa wa vu cv cufil wcel
      cX vu cv cuni wceq cF vu cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq
      cF vg cv wss wa wa wa vf cv vg cv wceq wn vu cv vg cv wceq wn vf cv vu cv
      wceq vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vu cv cufil
      wcel cX vu cv cuni wceq cF vu cv wss wa wa vg cv cufil wcel cX vg cv cuni
      wceq cF vg cv wss wa wa vf cv vu cv wceq vf cv cufil wcel vu cv cufil
      wcel cX vf cv cuni wceq cF vf cv wss wa cX vu cv cuni wceq cF vu cv wss
      wa vf cv vu cv cufil eleq1 vf cv vu cv wceq cX vf cv cuni wceq cX vu cv
      cuni wceq cF vf cv wss cF vu cv wss vf cv vu cv wceq vf cv cuni vu cv
      cuni cX vf cv vu cv unieq eqeq2d vf cv vu cv cF sseq2 anbi12d anbi12d
      anbi1d vf cv vu cv wceq vf cv vg cv wceq vu cv vg cv wceq vf cv vu cv vg
      cv eqeq1 notbid anbi12d vg cv vv cv wceq vu cv cufil wcel cX vu cv cuni
      wceq cF vu cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss
      wa wa wa vu cv cufil wcel cX vu cv cuni wceq cF vu cv wss wa wa vv cv
      cufil wcel cX vv cv cuni wceq cF vv cv wss wa wa wa vu cv vg cv wceq wn
      vu cv vv cv wceq wn vg cv vv cv wceq vg cv cufil wcel cX vg cv cuni wceq
      cF vg cv wss wa wa vv cv cufil wcel cX vv cv cuni wceq cF vv cv wss wa wa
      vu cv cufil wcel cX vu cv cuni wceq cF vu cv wss wa wa vg cv vv cv wceq
      vg cv cufil wcel vv cv cufil wcel cX vg cv cuni wceq cF vg cv wss wa cX
      vv cv cuni wceq cF vv cv wss wa vg cv vv cv cufil eleq1 vg cv vv cv wceq
      cX vg cv cuni wceq cX vv cv cuni wceq cF vg cv wss cF vv cv wss vg cv vv
      cv wceq vg cv cuni vv cv cuni cX vg cv vv cv unieq eqeq2d vg cv vv cv cF
      sseq2 anbi12d anbi12d anbi2d vg cv vv cv wceq vu cv vg cv wceq vu cv vv
      cv wceq vg cv vv cv vu cv eqeq2 notbid anbi12d sylan9bb cla42ev sylan31c
      exp31 r19.23advv cF vs cv csn cun cfi cfv cfg cfv cuni vu cv cuni wceq cF
      vs cv csn cun cfi cfv cfg cfv vu cv wss wa cF cX vs cv cdif csn cun cfi
      cfv cfg cfv cuni vv cv cuni wceq cF cX vs cv cdif csn cun cfi cfv cfg cfv
      vv cv wss wa vu vv cufil cufil reeanv syl5ibr mp2and exp31 vs cv cX vs
      visset elpw syl5ib r19.23adv vs cv cF wcel cX vs cv cdif cF wcel wo vs cX
      cpw wral wn vs cv cF wcel cX vs cv cdif cF wcel wo wn vs cX cpw wrex vs
      cv cF wcel wn cX vs cv cdif cF wcel wn wa vs cX cpw wrex vs cv cF wcel cX
      vs cv cdif cF wcel wo vs cX cpw rexnal vs cv cF wcel cX vs cv cdif cF
      wcel wo wn vs cv cF wcel wn cX vs cv cdif cF wcel wn wa vs cX cpw vs cv
      cF wcel cX vs cv cdif cF wcel ioran rexbii bitr3i vf cv cufil wcel cX vf
      cv cuni wceq cF vf cv wss wa wa vf wmo wn vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss
      wa wa wa vf cv vg cv wceq wi vg wal vf wal wn vf cv cufil wcel cX vf cv
      cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv
      wss wa wa wa vf cv vg cv wceq wi vg wal wn vf wex vf cv cufil wcel cX vf
      cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg
      cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf wex vf cv cufil wcel cX
      vf cv cuni wceq cF vf cv wss wa wa vf wmo vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss
      wa wa wa vf cv vg cv wceq wi vg wal vf wal vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv wss
      wa wa vf vg vf cv vg cv wceq vf cv cufil wcel vg cv cufil wcel cX vf cv
      cuni wceq cF vf cv wss wa cX vg cv cuni wceq cF vg cv wss wa vf cv vg cv
      cufil eleq1 vf cv vg cv wceq cX vf cv cuni wceq cX vg cv cuni wceq cF vf
      cv wss cF vg cv wss vf cv vg cv wceq vf cv cuni vg cv cuni cX vf cv vg cv
      unieq eqeq2d vf cv vg cv cF sseq2 anbi12d anbi12d mo4 notbii vf cv cufil
      wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni
      wceq cF vg cv wss wa wa wa vf cv vg cv wceq wi vg wal vf exnal vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wi vg wal wn vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vg wex vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wi wn vg wex vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wi vg wal wn vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg
      cv cuni wceq cF vg cv wss wa wa wa vf cv vg cv wceq wn wa vf cv cufil
      wcel cX vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni
      wceq cF vg cv wss wa wa wa vf cv vg cv wceq wi wn vg vf cv cufil wcel cX
      vf cv cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF
      vg cv wss wa wa wa vf cv vg cv wceq annim exbii vf cv cufil wcel cX vf cv
      cuni wceq cF vf cv wss wa wa vg cv cufil wcel cX vg cv cuni wceq cF vg cv
      wss wa wa wa vf cv vg cv wceq wi vg exnal bitr2i exbii 3bitr2i 3imtr4g vf
      cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vf weu vf cv cufil
      wcel cX vf cv cuni wceq cF vf cv wss wa wa vf wmo wi cF cfil wcel vf cv
      cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vf eumo a1i nsyld con4d
      cX vf cv cuni wceq cF vf cv wss wa vf cufil df-reu syl5ib cF cufil wcel
      cF cfil wcel vs cv cF wcel cX vs cv cdif cF wcel wo vs cX cpw wral vs cF
      cX ufileu.1 isufil baibr sylibd impbid2 $.
      $( [3-Dec-2009] $) $( [3-Dec-2009] $)
  $}

  ${
    $d f x y z F $. $d f x y z X $.
    filufint.1 $e |- X = U. F $.
    $( A filter is equal to the intersection of the ultrafilters containing
       it. $)
    filufint $p |- ( F e. Fil -> |^| { f e. UFil | ( X = U. f /\ F C_ f ) } = F
    ) $=
      cF cfil wcel cX vf cv cuni wceq cF vf cv wss wa vf cufil crab cint cF cF
      cfil wcel vx cX vf cv cuni wceq cF vf cv wss wa vf cufil crab cint cF cF
      cfil wcel cX vf cv cuni wceq cF vf cv wss wa vx cv vf cv wcel wi vf cufil
      wral vx cv cF wcel vx cv cX vf cv cuni wceq cF vf cv wss wa vf cufil crab
      cint wcel cF cfil wcel vx cv cF wcel cX vf cv cuni wceq cF vf cv wss wa
      vx cv vf cv wcel wi vf cufil wral cF cfil wcel vx cv cF wcel wn cX vf cv
      cuni wceq cF vf cv wss wa vx cv vf cv wcel wn wa vf cufil wrex cX vf cv
      cuni wceq cF vf cv wss wa vx cv vf cv wcel wi vf cufil wral wn cF cfil
      wcel vx cv cF wcel wn cX vf cv cuni wceq cF vf cv wss wa vx cv vf cv wcel
      wn wa vf cufil wrex cF cfil wcel vx cv cF wcel wn wa vx cv cX wss cX vf
      cv cuni wceq cF vf cv wss wa vx cv vf cv wcel wn wa vf cufil wrex cF cfil
      wcel vx cv cF wcel wn vx cv cX wss cX vf cv cuni wceq cF vf cv wss wa vx
      cv vf cv wcel wn wa vf cufil wrex cF cfil wcel vx cv cF wcel wn vx cv cX
      wss w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cfil wcel cX cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cuni wceq cX vf cv cuni wceq cF vf cv wss wa
      vx cv vf cv wcel wn wa vf cufil wrex cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif
      csn cun cfi cfv cfg cfv cfil wcel cF cfil wcel vx cv cF wcel wn vx cv cX
      wss w3a cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn
      cun c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel wa cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a cF cX vx cv cdif csn cun c0 wne c0 cF cX vx
      cv cdif csn cun cfi cfv wnel cF cfil wcel vx cv cF wcel wn cF cX vx cv
      cdif csn cun c0 wne vx cv cX wss cF cfil wcel cX cF wcel cF c0 wne cF cX
      vx cv cdif csn cun c0 wne cF cX filufint.1 filusb cF cX ne0i cF cF cX vx
      cv cdif csn cun wss cF c0 wne cF cX vx cv cdif csn cun c0 wne cF cX vx cv
      cdif csn ssun1 cF cF cX vx cv cdif csn cun ssn0 mpan 3syl 3ad2ant1 cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a c0 cF cX vx cv cdif csn cun
      cfi cfv wnel vy cv vz cv cin c0 wne vz cX vx cv cdif csn wral vy cF wral
      cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv vz cv cin c0 wne vy
      vz cF cX vx cv cdif csn cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy
      cv cF wcel vz cv cX vx cv cdif wceq vy cv vz cv cin c0 wne vz cv cX vx cv
      cdif csn wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv cF
      wcel vz cv cX vx cv cdif wceq vy cv vz cv cin c0 wne vz cv cX vx cv cdif
      wceq vy cv vz cv cin c0 wne vy cv cX vx cv cdif cin c0 wne cF cfil wcel
      vx cv cF wcel wn vx cv cX wss w3a vy cv cF wcel wa vz cv cX vx cv cdif
      wceq vy cv vz cv cin vy cv cX vx cv cdif cin c0 vz cv cX vx cv cdif vy cv
      ineq2 neeq1d cF cfil wcel vx cv cF wcel wn vx cv cX wss vy cv cF wcel vy
      cv cX vx cv cdif cin c0 wne cF cfil wcel vy cv cF wcel vx cv cX wss vx cv
      cF wcel wn vy cv cX vx cv cdif cin c0 wne cF cfil wcel vy cv cF wcel vx
      cv cX wss vx cv cF wcel wn vy cv cX vx cv cdif cin c0 wne wi cF cfil wcel
      vy cv cF wcel vx cv cX wss w3a vx cv cF wcel vy cv cX vx cv cdif cin c0
      cF cfil wcel vy cv cF wcel vx cv cX wss w3a vy cv cX vx cv cdif cin c0
      wceq vy cv vx cv wss vx cv cF wcel cF cfil wcel vy cv cF wcel vx cv cX
      wss w3a vy cv cX vx cv cdif cin c0 wceq vy cv cX cX vx cv cdif cdif wss
      vy cv vx cv wss vy cv cF wcel cF cfil wcel vy cv cX vx cv cdif cin c0
      wceq vy cv cX cX vx cv cdif cdif wss wb vx cv cX wss vy cv cF wcel vy cv
      cX wss vy cv cX vx cv cdif cin c0 wceq vy cv cX cX vx cv cdif cdif wss wb
      vy cv cF wcel vy cv cF cuni cX vy cv cF elssuni filufint.1 syl6ssr vy cv
      cX vx cv cdif cX reldisj syl 3ad2ant2 vx cv cX wss cF cfil wcel vy cv cX
      cX vx cv cdif cdif wss vy cv vx cv wss wb vy cv cF wcel vx cv cX wss cX
      cX vx cv cdif cdif vx cv vy cv vx cv cX wss cX cX vx cv cdif cdif vx cv
      wceq vx cv cX dfss4 biimpi sseq2d 3ad2ant3 bitrd cF cfil wcel vy cv cF
      wcel vx cv cX wss vy cv vx cv wss vx cv cF wcel wi cF cfil wcel vy cv cF
      wcel vx cv cX wss vy cv vx cv wss vx cv cF wcel vy cv vx cv cF cX
      filufint.1 fillsb 3expd 3imp sylbid necon3bd 3exp com24 3imp1 syl5cbir
      expimpd vz cv cX vx cv cdif elsni sylan2i r19.21aivv cF cfbas wcel cX vx
      cv cdif csn cfbas wcel c0 cF cX vx cv cdif csn cun cfi cfv wnel vy cv vz
      cv cin c0 wne vz cX vx cv cdif csn wral vy cF wral wb cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a vy vz cF cX vx cv cdif csn fbunfip cF cfil
      wcel vx cv cF wcel wn cF cfbas wcel vx cv cX wss cF filfbas 3ad2ant1 cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX vx cv cdif csn cfil wcel
      cX vx cv cdif csn cfbas wcel cX vx cv cdif cvv wcel cX vx cv cdif c0 wne
      cX vx cv cdif csn cfil wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cX vx cv cdif cvv oefil2 cF cfil wcel vx cv cF wcel wn cX vx cv cdif
      cvv wcel vx cv cX wss cF cfil wcel cX cvv wcel cX vx cv cdif cvv wcel cF
      cfil wcel cF cuni cvv cX cF cfil uniexg filufint.1 syl5eqel cX vx cv cvv
      difexg syl 3ad2ant1 cF cfil wcel vx cv cF wcel wn vx cv cX wss cX vx cv
      cdif c0 wne cF cfil wcel vx cv cX wss vx cv cF wcel wn cX vx cv cdif c0
      wne cF cfil wcel vx cv cX wss vx cv cF wcel wn cX vx cv cdif c0 wne wi cF
      cfil wcel vx cv cX wss wa vx cv cF wcel cX vx cv cdif c0 cF cfil wcel vx
      cv cX wss cX vx cv cdif c0 wceq vx cv cF wcel cF cfil wcel vx cv cX wss
      cX vx cv cdif c0 wceq w3a vx cv cX cF cF cfil wcel vx cv cX wss cX vx cv
      cdif c0 wceq w3a cX cX vx cv cdif cdif vx cv cX vx cv cX wss cF cfil wcel
      cX cX vx cv cdif cdif vx cv wceq cX vx cv cdif c0 wceq vx cv cX wss cX cX
      vx cv cdif cdif vx cv wceq vx cv cX dfss4 biimpi 3ad2ant2 cX vx cv cdif
      c0 wceq cF cfil wcel cX cX vx cv cdif cdif cX wceq vx cv cX wss cX vx cv
      cdif c0 wceq cX cX vx cv cdif cdif cX c0 cdif cX cX vx cv cdif c0 cX
      difeq2 cX dif0 syl6eq 3ad2ant3 eqtr3d cF cfil wcel vx cv cX wss cX cF
      wcel cX vx cv cdif c0 wceq cF cX filufint.1 filusb 3ad2ant1 eqeltrd
      3expia necon3bd ex com23 3imp sylanc cX vx cv cdif csn filfbas syl sylanc
      mpbird jca cF cfil wcel vx cv cF wcel wn cF cX vx cv cdif csn cun cfi cfv
      cfbas wcel cF cX vx cv cdif csn cun c0 wne c0 cF cX vx cv cdif csn cun
      cfi cfv wnel wa wb vx cv cX wss cF cfil wcel cF cX vx cv cdif csn cun cvv
      wcel cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun
      c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vx
      cv cdif csn cvv wcel cF cX vx cv cdif csn cun cvv wcel cX vx cv cdif snex
      cF cX vx cv cdif csn cfil cvv unexg mpan2 cF cX vx cv cdif csn cun cvv
      fsubbas syl 3ad2ant1 mpbird cF cX vx cv cdif csn cun cfi cfv fgfil syl cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun
      cuni cF cX vx cv cdif csn cun cfi cfv cuni cF cX vx cv cdif csn cun cfi
      cfv cfg cfv cuni cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF
      cuni cX vx cv cdif csn cuni cun cF cX vx cv cdif csn cun cuni cF cfil
      wcel vx cv cF wcel wn vx cv cX wss w3a cX cX vx cv cdif cun cF cuni cX vx
      cv cdif csn cuni cun cX cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX
      cF cuni cX vx cv cdif cX vx cv cdif csn cuni cX cF cuni wceq cF cfil wcel
      vx cv cF wcel wn vx cv cX wss w3a filufint.1 a1i cF cfil wcel vx cv cF
      wcel wn cX vx cv cdif cX vx cv cdif csn cuni wceq vx cv cX wss cF cfil
      wcel cX vx cv cdif csn cuni cX vx cv cdif cF cfil wcel cX cvv wcel cX vx
      cv cdif cvv wcel cX vx cv cdif csn cuni cX vx cv cdif wceq cF cfil wcel
      cF cuni cvv cX cF cfil uniexg filufint.1 syl5eqel cX vx cv cvv difexg cX
      vx cv cdif cvv unisng 3syl eqcomd 3ad2ant1 uneq12d cX vx cv cdif cX wss
      cX cX vx cv cdif cun cX wceq cX vx cv difss cX vx cv cdif cX ssequn2 mpbi
      syl5eqr cF cX vx cv cdif csn uniun syl6eqr cF cfil wcel vx cv cF wcel wn
      cF cX vx cv cdif csn cun cuni cF cX vx cv cdif csn cun cfi cfv cuni wceq
      vx cv cX wss cF cfil wcel cF cX vx cv cdif csn cun cvv wcel cF cX vx cv
      cdif csn cun cuni cF cX vx cv cdif csn cun cfi cfv cuni wceq cF cfil wcel
      cX vx cv cdif csn cvv wcel cF cX vx cv cdif csn cun cvv wcel cX vx cv
      cdif snex cF cX vx cv cdif csn cfil cvv unexg mpan2 cF cX vx cv cdif csn
      cun cvv fiuni syl 3ad2ant1 cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a
      cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun cfi
      cfv cuni cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq cF cfil wcel
      vx cv cF wcel wn vx cv cX wss w3a cF cX vx cv cdif csn cun cfi cfv cfbas
      wcel cF cX vx cv cdif csn cun c0 wne c0 cF cX vx cv cdif csn cun cfi cfv
      wnel wa cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cF cX vx cv cdif
      csn cun c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel cF cfil wcel vx
      cv cF wcel wn cF cX vx cv cdif csn cun c0 wne vx cv cX wss cF cfil wcel
      cX cF wcel cF c0 wne cF cX vx cv cdif csn cun c0 wne cF cX filufint.1
      filusb cF cX ne0i cF cF cX vx cv cdif csn cun wss cF c0 wne cF cX vx cv
      cdif csn cun c0 wne cF cX vx cv cdif csn ssun1 cF cF cX vx cv cdif csn
      cun ssn0 mpan 3syl 3ad2ant1 cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a c0 cF cX vx cv cdif csn cun cfi cfv wnel vy cv vz cv cin c0 wne vz cX
      vx cv cdif csn wral vy cF wral cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a vy cv vz cv cin c0 wne vy vz cF cX vx cv cdif csn cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a vy cv cF wcel vz cv cX vx cv cdif wceq vy cv
      vz cv cin c0 wne vz cv cX vx cv cdif csn wcel cF cfil wcel vx cv cF wcel
      wn vx cv cX wss w3a vy cv cF wcel vz cv cX vx cv cdif wceq vy cv vz cv
      cin c0 wne vz cv cX vx cv cdif wceq vy cv vz cv cin c0 wne vy cv cX vx cv
      cdif cin c0 wne cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv cF
      wcel wa vz cv cX vx cv cdif wceq vy cv vz cv cin vy cv cX vx cv cdif cin
      c0 vz cv cX vx cv cdif vy cv ineq2 neeq1d cF cfil wcel vx cv cF wcel wn
      vx cv cX wss vy cv cF wcel vy cv cX vx cv cdif cin c0 wne cF cfil wcel vy
      cv cF wcel vx cv cX wss vx cv cF wcel wn vy cv cX vx cv cdif cin c0 wne
      cF cfil wcel vy cv cF wcel vx cv cX wss vx cv cF wcel wn vy cv cX vx cv
      cdif cin c0 wne wi cF cfil wcel vy cv cF wcel vx cv cX wss w3a vx cv cF
      wcel vy cv cX vx cv cdif cin c0 cF cfil wcel vy cv cF wcel vx cv cX wss
      w3a vy cv cX vx cv cdif cin c0 wceq vy cv vx cv wss vx cv cF wcel cF cfil
      wcel vy cv cF wcel vx cv cX wss w3a vy cv cX vx cv cdif cin c0 wceq vy cv
      cX cX vx cv cdif cdif wss vy cv vx cv wss vy cv cF wcel cF cfil wcel vy
      cv cX vx cv cdif cin c0 wceq vy cv cX cX vx cv cdif cdif wss wb vx cv cX
      wss vy cv cF wcel vy cv cX wss vy cv cX vx cv cdif cin c0 wceq vy cv cX
      cX vx cv cdif cdif wss wb vy cv cF wcel vy cv cF cuni cX vy cv cF elssuni
      filufint.1 syl6ssr vy cv cX vx cv cdif cX reldisj syl 3ad2ant2 vx cv cX
      wss cF cfil wcel vy cv cX cX vx cv cdif cdif wss vy cv vx cv wss wb vy cv
      cF wcel vx cv cX wss cX cX vx cv cdif cdif vx cv vy cv vx cv cX wss cX cX
      vx cv cdif cdif vx cv wceq vx cv cX dfss4 biimpi sseq2d 3ad2ant3 bitrd cF
      cfil wcel vy cv cF wcel vx cv cX wss vy cv vx cv wss vx cv cF wcel wi cF
      cfil wcel vy cv cF wcel vx cv cX wss vy cv vx cv wss vx cv cF wcel vy cv
      vx cv cF cX filufint.1 fillsb 3expd 3imp sylbid necon3bd 3exp com24 3imp1
      syl5cbir expimpd vz cv cX vx cv cdif elsni sylan2i r19.21aivv cF cfbas
      wcel cX vx cv cdif csn cfbas wcel c0 cF cX vx cv cdif csn cun cfi cfv
      wnel vy cv vz cv cin c0 wne vz cX vx cv cdif csn wral vy cF wral wb cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy vz cF cX vx cv cdif csn
      fbunfip cF cfil wcel vx cv cF wcel wn cF cfbas wcel vx cv cX wss cF
      filfbas 3ad2ant1 cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX vx cv
      cdif csn cfil wcel cX vx cv cdif csn cfbas wcel cX vx cv cdif cvv wcel cX
      vx cv cdif c0 wne cX vx cv cdif csn cfil wcel cF cfil wcel vx cv cF wcel
      wn vx cv cX wss w3a cX vx cv cdif cvv oefil2 cF cfil wcel vx cv cF wcel
      wn cX vx cv cdif cvv wcel vx cv cX wss cF cfil wcel cX cvv wcel cX vx cv
      cdif cvv wcel cF cfil wcel cF cuni cvv cX cF cfil uniexg filufint.1
      syl5eqel cX vx cv cvv difexg syl 3ad2ant1 cF cfil wcel vx cv cF wcel wn
      vx cv cX wss cX vx cv cdif c0 wne cF cfil wcel vx cv cX wss vx cv cF wcel
      wn cX vx cv cdif c0 wne cF cfil wcel vx cv cX wss vx cv cF wcel wn cX vx
      cv cdif c0 wne wi cF cfil wcel vx cv cX wss wa vx cv cF wcel cX vx cv
      cdif c0 cF cfil wcel vx cv cX wss cX vx cv cdif c0 wceq vx cv cF wcel cF
      cfil wcel vx cv cX wss cX vx cv cdif c0 wceq w3a vx cv cX cF cF cfil wcel
      vx cv cX wss cX vx cv cdif c0 wceq w3a cX cX vx cv cdif cdif vx cv cX vx
      cv cX wss cF cfil wcel cX cX vx cv cdif cdif vx cv wceq cX vx cv cdif c0
      wceq vx cv cX wss cX cX vx cv cdif cdif vx cv wceq vx cv cX dfss4 biimpi
      3ad2ant2 cX vx cv cdif c0 wceq cF cfil wcel cX cX vx cv cdif cdif cX wceq
      vx cv cX wss cX vx cv cdif c0 wceq cX cX vx cv cdif cdif cX c0 cdif cX cX
      vx cv cdif c0 cX difeq2 cX dif0 syl6eq 3ad2ant3 eqtr3d cF cfil wcel vx cv
      cX wss cX cF wcel cX vx cv cdif c0 wceq cF cX filufint.1 filusb 3ad2ant1
      eqeltrd 3expia necon3bd ex com23 3imp sylanc cX vx cv cdif csn filfbas
      syl sylanc mpbird jca cF cfil wcel vx cv cF wcel wn cF cX vx cv cdif csn
      cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun c0 wne c0 cF cX vx cv
      cdif csn cun cfi cfv wnel wa wb vx cv cX wss cF cfil wcel cF cX vx cv
      cdif csn cun cvv wcel cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX
      vx cv cdif csn cun c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel wa wb
      cF cfil wcel cX vx cv cdif csn cvv wcel cF cX vx cv cdif csn cun cvv wcel
      cX vx cv cdif snex cF cX vx cv cdif csn cfil cvv unexg mpan2 cF cX vx cv
      cdif csn cun cvv fsubbas syl 3ad2ant1 mpbird cF cX vx cv cdif csn cun cfi
      cfv cF cX vx cv cdif csn cun cfi cfv cuni cF cX vx cv cdif csn cun cfi
      cfv cuni eqid fgbas syl 3eqtrd cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cfil wcel cX cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cuni wceq cX vf cv cuni wceq cF vf cv wss wa
      vx cv vf cv wcel wn wa vf cufil wrex cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq cF cX vx
      cv cdif csn cun cfi cfv cfg cfv cfil wcel cX vf cv cuni wceq cF vf cv wss
      wa vx cv vf cv wcel wn wa vf cufil wrex cF cfil wcel vx cv cF wcel wn vx
      cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq cF cX
      vx cv cdif csn cun cfi cfv cfg cfv cfil wcel cX vf cv cuni wceq cF vf cv
      wss wa vx cv vf cv wcel wn wa vf cufil wrex wi cF cfil wcel vx cv cF wcel
      wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq
      wa cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx
      cv cdif csn cun cfi cfv cfg cfv vf cv wss wa vf cufil wrex cX vf cv cuni
      wceq cF vf cv wss wa vx cv vf cv wcel wn wa vf cufil wrex cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cfil wcel cF cfil wcel vx cv cF wcel wn vx
      cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq wa cF
      cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv
      cdif csn cun cfi cfv cfg cfv vf cv wss wa cX vf cv cuni wceq cF vf cv wss
      wa vx cv vf cv wcel wn wa vf cufil cF cfil wcel vx cv cF wcel wn vx cv cX
      wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil
      wcel cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX
      vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa cX vf cv cuni wceq cF vf
      cv wss wa vx cv vf cv wcel wn wa wi cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv
      cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni
      wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa cX vf cv cuni
      wceq cF vf cv wss wa vx cv vf cv wcel wn wa cF cfil wcel vx cv cF wcel wn
      vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf
      cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv
      cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa wa cX vf
      cv cuni wceq cF vf cv wss vx cv vf cv wcel wn cF cfil wcel vx cv cF wcel
      wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq
      vf cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv
      cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa wa cX cF
      cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv
      cuni wceq vf cv cufil wcel cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni
      vf cv cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa
      3simpl2 cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel w3a cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv cdif csn
      cun cfi cfv cfg cfv vf cv wss simprl eqtrd cF cfil wcel vx cv cF wcel wn
      vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf
      cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv
      cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa wa cF cF
      cX vx cv cdif csn cun cfi cfv cfg cfv vf cv cF cfil wcel vx cv cF wcel wn
      vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf
      cv cufil wcel w3a cF cF cX vx cv cdif csn cun cfi cfv cfg cfv wss cF cX
      vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv cdif
      csn cun cfi cfv cfg cfv vf cv wss wa cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq cF cF cX
      vx cv cdif csn cun cfi cfv cfg cfv wss vf cv cufil wcel cF cfil wcel vx
      cv cF wcel wn vx cv cX wss w3a cF cF cX vx cv cdif csn cun cfi cfv cF cX
      vx cv cdif csn cun cfi cfv cfg cfv cF cfil wcel vx cv cF wcel wn vx cv cX
      wss w3a cF cF cX vx cv cdif csn cun cF cX vx cv cdif csn cun cfi cfv cF
      cF cX vx cv cdif csn cun wss cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cF cX vx cv cdif csn ssun1 a1i cF cfil wcel vx cv cF wcel wn cF cX vx
      cv cdif csn cun cF cX vx cv cdif csn cun cfi cfv wss vx cv cX wss cF cfil
      wcel cF cX vx cv cdif csn cun cvv wcel cF cX vx cv cdif csn cun cF cX vx
      cv cdif csn cun cfi cfv wss cF cfil wcel cX vx cv cdif csn cvv wcel cF cX
      vx cv cdif csn cun cvv wcel cX vx cv cdif snex cF cX vx cv cdif csn cfil
      cvv unexg mpan2 cF cX vx cv cdif csn cun cvv abfi2 syl 3ad2ant1 sstrd cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a cF cX vx cv cdif csn cun cfi
      cfv cfbas wcel cF cX vx cv cdif csn cun cfi cfv cF cX vx cv cdif csn cun
      cfi cfv cfg cfv wss cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cF cX
      vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun c0 wne c0
      cF cX vx cv cdif csn cun cfi cfv wnel wa cF cfil wcel vx cv cF wcel wn vx
      cv cX wss w3a cF cX vx cv cdif csn cun c0 wne c0 cF cX vx cv cdif csn cun
      cfi cfv wnel cF cfil wcel vx cv cF wcel wn cF cX vx cv cdif csn cun c0
      wne vx cv cX wss cF cfil wcel cX cF wcel cF c0 wne cF cX vx cv cdif csn
      cun c0 wne cF cX filufint.1 filusb cF cX ne0i cF cF cX vx cv cdif csn cun
      wss cF c0 wne cF cX vx cv cdif csn cun c0 wne cF cX vx cv cdif csn ssun1
      cF cF cX vx cv cdif csn cun ssn0 mpan 3syl 3ad2ant1 cF cfil wcel vx cv cF
      wcel wn vx cv cX wss w3a c0 cF cX vx cv cdif csn cun cfi cfv wnel vy cv
      vz cv cin c0 wne vz cX vx cv cdif csn wral vy cF wral cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a vy cv vz cv cin c0 wne vy vz cF cX vx cv cdif
      csn cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv cF wcel vz cv cX
      vx cv cdif wceq vy cv vz cv cin c0 wne vz cv cX vx cv cdif csn wcel cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv cF wcel vz cv cX vx cv
      cdif wceq vy cv vz cv cin c0 wne vz cv cX vx cv cdif wceq vy cv vz cv cin
      c0 wne vy cv cX vx cv cdif cin c0 wne cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a vy cv cF wcel wa vz cv cX vx cv cdif wceq vy cv vz cv cin vy
      cv cX vx cv cdif cin c0 vz cv cX vx cv cdif vy cv ineq2 neeq1d cF cfil
      wcel vx cv cF wcel wn vx cv cX wss vy cv cF wcel vy cv cX vx cv cdif cin
      c0 wne cF cfil wcel vy cv cF wcel vx cv cX wss vx cv cF wcel wn vy cv cX
      vx cv cdif cin c0 wne cF cfil wcel vy cv cF wcel vx cv cX wss vx cv cF
      wcel wn vy cv cX vx cv cdif cin c0 wne wi cF cfil wcel vy cv cF wcel vx
      cv cX wss w3a vx cv cF wcel vy cv cX vx cv cdif cin c0 cF cfil wcel vy cv
      cF wcel vx cv cX wss w3a vy cv cX vx cv cdif cin c0 wceq vy cv vx cv wss
      vx cv cF wcel cF cfil wcel vy cv cF wcel vx cv cX wss w3a vy cv cX vx cv
      cdif cin c0 wceq vy cv cX cX vx cv cdif cdif wss vy cv vx cv wss vy cv cF
      wcel cF cfil wcel vy cv cX vx cv cdif cin c0 wceq vy cv cX cX vx cv cdif
      cdif wss wb vx cv cX wss vy cv cF wcel vy cv cX wss vy cv cX vx cv cdif
      cin c0 wceq vy cv cX cX vx cv cdif cdif wss wb vy cv cF wcel vy cv cF
      cuni cX vy cv cF elssuni filufint.1 syl6ssr vy cv cX vx cv cdif cX
      reldisj syl 3ad2ant2 vx cv cX wss cF cfil wcel vy cv cX cX vx cv cdif
      cdif wss vy cv vx cv wss wb vy cv cF wcel vx cv cX wss cX cX vx cv cdif
      cdif vx cv vy cv vx cv cX wss cX cX vx cv cdif cdif vx cv wceq vx cv cX
      dfss4 biimpi sseq2d 3ad2ant3 bitrd cF cfil wcel vy cv cF wcel vx cv cX
      wss vy cv vx cv wss vx cv cF wcel wi cF cfil wcel vy cv cF wcel vx cv cX
      wss vy cv vx cv wss vx cv cF wcel vy cv vx cv cF cX filufint.1 fillsb
      3expd 3imp sylbid necon3bd 3exp com24 3imp1 syl5cbir expimpd vz cv cX vx
      cv cdif elsni sylan2i r19.21aivv cF cfbas wcel cX vx cv cdif csn cfbas
      wcel c0 cF cX vx cv cdif csn cun cfi cfv wnel vy cv vz cv cin c0 wne vz
      cX vx cv cdif csn wral vy cF wral wb cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a vy vz cF cX vx cv cdif csn fbunfip cF cfil wcel vx cv cF wcel
      wn cF cfbas wcel vx cv cX wss cF filfbas 3ad2ant1 cF cfil wcel vx cv cF
      wcel wn vx cv cX wss w3a cX vx cv cdif csn cfil wcel cX vx cv cdif csn
      cfbas wcel cX vx cv cdif cvv wcel cX vx cv cdif c0 wne cX vx cv cdif csn
      cfil wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX vx cv cdif
      cvv oefil2 cF cfil wcel vx cv cF wcel wn cX vx cv cdif cvv wcel vx cv cX
      wss cF cfil wcel cX cvv wcel cX vx cv cdif cvv wcel cF cfil wcel cF cuni
      cvv cX cF cfil uniexg filufint.1 syl5eqel cX vx cv cvv difexg syl
      3ad2ant1 cF cfil wcel vx cv cF wcel wn vx cv cX wss cX vx cv cdif c0 wne
      cF cfil wcel vx cv cX wss vx cv cF wcel wn cX vx cv cdif c0 wne cF cfil
      wcel vx cv cX wss vx cv cF wcel wn cX vx cv cdif c0 wne wi cF cfil wcel
      vx cv cX wss wa vx cv cF wcel cX vx cv cdif c0 cF cfil wcel vx cv cX wss
      cX vx cv cdif c0 wceq vx cv cF wcel cF cfil wcel vx cv cX wss cX vx cv
      cdif c0 wceq w3a vx cv cX cF cF cfil wcel vx cv cX wss cX vx cv cdif c0
      wceq w3a cX cX vx cv cdif cdif vx cv cX vx cv cX wss cF cfil wcel cX cX
      vx cv cdif cdif vx cv wceq cX vx cv cdif c0 wceq vx cv cX wss cX cX vx cv
      cdif cdif vx cv wceq vx cv cX dfss4 biimpi 3ad2ant2 cX vx cv cdif c0 wceq
      cF cfil wcel cX cX vx cv cdif cdif cX wceq vx cv cX wss cX vx cv cdif c0
      wceq cX cX vx cv cdif cdif cX c0 cdif cX cX vx cv cdif c0 cX difeq2 cX
      dif0 syl6eq 3ad2ant3 eqtr3d cF cfil wcel vx cv cX wss cX cF wcel cX vx cv
      cdif c0 wceq cF cX filufint.1 filusb 3ad2ant1 eqeltrd 3expia necon3bd ex
      com23 3imp sylanc cX vx cv cdif csn filfbas syl sylanc mpbird jca cF cfil
      wcel vx cv cF wcel wn cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX
      vx cv cdif csn cun c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel wa wb
      vx cv cX wss cF cfil wcel cF cX vx cv cdif csn cun cvv wcel cF cX vx cv
      cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun c0 wne c0 cF cX
      vx cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vx cv cdif csn cvv
      wcel cF cX vx cv cdif csn cun cvv wcel cX vx cv cdif snex cF cX vx cv
      cdif csn cfil cvv unexg mpan2 cF cX vx cv cdif csn cun cvv fsubbas syl
      3ad2ant1 mpbird cF cX vx cv cdif csn cun cfi cfv fbssfg syl sstrd
      3ad2ant1 adantr cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX
      vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel w3a cF cX
      vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv cdif
      csn cun cfi cfv cfg cfv vf cv wss simprr sstrd cF cfil wcel vx cv cF wcel
      wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq
      vf cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv
      cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa wa vx cv
      vf cv wcel c0 vf cv wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a
      cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel
      w3a c0 vf cv wcel wn cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv
      cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss wa vf cv
      cufil wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a c0 vf cv wcel
      wn cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel
      vf cv cfil wcel c0 vf cv wcel wn vf cv ufilfil vf cv filesn syl 3ad2ant3
      adantr cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif
      csn cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel w3a cF cX vx cv cdif
      csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv cdif csn cun cfi
      cfv cfg cfv vf cv wss vx cv vf cv wcel c0 vf cv wcel wi cF cfil wcel vx
      cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg
      cfv cuni wceq vf cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg
      cfv cuni vf cv cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv
      wss vx cv vf cv wcel c0 vf cv wcel cF cfil wcel vx cv cF wcel wn vx cv cX
      wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil
      wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF
      cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss vx cv vf cv wcel w3a wa
      vx cv cX vx cv cdif cin vf cv c0 vf cv cfil wcel vx cv vf cv wcel cX vx
      cv cdif vf cv wcel vx cv cX vx cv cdif cin vf cv wcel cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv
      cuni wceq vf cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv
      cuni vf cv cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss
      vx cv vf cv wcel w3a wa vx cv cX vx cv cdif vf cv filint cF cfil wcel vx
      cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg
      cfv cuni wceq vf cv cufil wcel w3a vf cv cfil wcel cF cX vx cv cdif csn
      cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv cdif csn cun cfi cfv
      cfg cfv vf cv wss vx cv vf cv wcel w3a vf cv cufil wcel cF cfil wcel vx
      cv cF wcel wn vx cv cX wss w3a vf cv cfil wcel cX cF cX vx cv cdif csn
      cun cfi cfv cfg cfv cuni wceq vf cv ufilfil 3ad2ant3 adantr cF cfil wcel
      vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg
      cfv cuni wceq vf cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg
      cfv cuni vf cv cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv
      wss vx cv vf cv wcel 3simpr3 cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil
      wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF
      cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss vx cv vf cv wcel w3a wa
      cX vx cv cdif csn vf cv cX vx cv cdif cF cfil wcel vx cv cF wcel wn vx cv
      cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv
      cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni
      wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss vx cv vf cv wcel
      w3a wa cX vx cv cdif csn cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv
      cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn
      cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel w3a cX vx cv cdif csn cF
      cX vx cv cdif csn cun cfi cfv cfg cfv wss cF cX vx cv cdif csn cun cfi
      cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv
      vf cv wss vx cv vf cv wcel w3a cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil
      wcel w3a cX vx cv cdif csn cF cX vx cv cdif csn cun cfi cfv cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cX cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq cX vx cv cdif
      csn cF cX vx cv cdif csn cun cfi cfv wss vf cv cufil wcel cF cfil wcel vx
      cv cF wcel wn cX vx cv cdif csn cF cX vx cv cdif csn cun cfi cfv wss vx
      cv cX wss cF cfil wcel cX vx cv cdif csn cF cX vx cv cdif csn cun cF cX
      vx cv cdif csn cun cfi cfv cX vx cv cdif csn cF cX vx cv cdif csn cun wss
      cF cfil wcel cX vx cv cdif csn cF ssun2 a1i cF cfil wcel cF cX vx cv cdif
      csn cun cvv wcel cF cX vx cv cdif csn cun cF cX vx cv cdif csn cun cfi
      cfv wss cF cfil wcel cX vx cv cdif csn cvv wcel cF cX vx cv cdif csn cun
      cvv wcel cX vx cv cdif snex cF cX vx cv cdif csn cfil cvv unexg mpan2 cF
      cX vx cv cdif csn cun cvv abfi2 syl sstrd 3ad2ant1 3ad2ant1 cF cfil wcel
      vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun cfi cfv cfg
      cfv cuni wceq vf cv cufil wcel w3a cF cX vx cv cdif csn cun cfi cfv cfbas
      wcel cF cX vx cv cdif csn cun cfi cfv cF cX vx cv cdif csn cun cfi cfv
      cfg cfv wss cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cuni wceq cF cX vx cv cdif csn cun cfi cfv
      cfbas wcel vf cv cufil wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun
      c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel wa cF cfil wcel vx cv cF
      wcel wn vx cv cX wss w3a cF cX vx cv cdif csn cun c0 wne c0 cF cX vx cv
      cdif csn cun cfi cfv wnel cF cfil wcel vx cv cF wcel wn cF cX vx cv cdif
      csn cun c0 wne vx cv cX wss cF cfil wcel cX cF wcel cF c0 wne cF cX vx cv
      cdif csn cun c0 wne cF cX filufint.1 filusb cF cX ne0i cF cF cX vx cv
      cdif csn cun wss cF c0 wne cF cX vx cv cdif csn cun c0 wne cF cX vx cv
      cdif csn ssun1 cF cF cX vx cv cdif csn cun ssn0 mpan 3syl 3ad2ant1 cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a c0 cF cX vx cv cdif csn cun
      cfi cfv wnel vy cv vz cv cin c0 wne vz cX vx cv cdif csn wral vy cF wral
      cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv vz cv cin c0 wne vy
      vz cF cX vx cv cdif csn cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy
      cv cF wcel vz cv cX vx cv cdif wceq vy cv vz cv cin c0 wne vz cv cX vx cv
      cdif csn wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a vy cv cF
      wcel vz cv cX vx cv cdif wceq vy cv vz cv cin c0 wne vz cv cX vx cv cdif
      wceq vy cv vz cv cin c0 wne vy cv cX vx cv cdif cin c0 wne cF cfil wcel
      vx cv cF wcel wn vx cv cX wss w3a vy cv cF wcel wa vz cv cX vx cv cdif
      wceq vy cv vz cv cin vy cv cX vx cv cdif cin c0 vz cv cX vx cv cdif vy cv
      ineq2 neeq1d cF cfil wcel vx cv cF wcel wn vx cv cX wss vy cv cF wcel vy
      cv cX vx cv cdif cin c0 wne cF cfil wcel vy cv cF wcel vx cv cX wss vx cv
      cF wcel wn vy cv cX vx cv cdif cin c0 wne cF cfil wcel vy cv cF wcel vx
      cv cX wss vx cv cF wcel wn vy cv cX vx cv cdif cin c0 wne wi cF cfil wcel
      vy cv cF wcel vx cv cX wss w3a vx cv cF wcel vy cv cX vx cv cdif cin c0
      cF cfil wcel vy cv cF wcel vx cv cX wss w3a vy cv cX vx cv cdif cin c0
      wceq vy cv vx cv wss vx cv cF wcel cF cfil wcel vy cv cF wcel vx cv cX
      wss w3a vy cv cX vx cv cdif cin c0 wceq vy cv cX cX vx cv cdif cdif wss
      vy cv vx cv wss vy cv cF wcel cF cfil wcel vy cv cX vx cv cdif cin c0
      wceq vy cv cX cX vx cv cdif cdif wss wb vx cv cX wss vy cv cF wcel vy cv
      cX wss vy cv cX vx cv cdif cin c0 wceq vy cv cX cX vx cv cdif cdif wss wb
      vy cv cF wcel vy cv cF cuni cX vy cv cF elssuni filufint.1 syl6ssr vy cv
      cX vx cv cdif cX reldisj syl 3ad2ant2 vx cv cX wss cF cfil wcel vy cv cX
      cX vx cv cdif cdif wss vy cv vx cv wss wb vy cv cF wcel vx cv cX wss cX
      cX vx cv cdif cdif vx cv vy cv vx cv cX wss cX cX vx cv cdif cdif vx cv
      wceq vx cv cX dfss4 biimpi sseq2d 3ad2ant3 bitrd cF cfil wcel vy cv cF
      wcel vx cv cX wss vy cv vx cv wss vx cv cF wcel wi cF cfil wcel vy cv cF
      wcel vx cv cX wss vy cv vx cv wss vx cv cF wcel vy cv vx cv cF cX
      filufint.1 fillsb 3expd 3imp sylbid necon3bd 3exp com24 3imp1 syl5cbir
      expimpd vz cv cX vx cv cdif elsni sylan2i r19.21aivv cF cfbas wcel cX vx
      cv cdif csn cfbas wcel c0 cF cX vx cv cdif csn cun cfi cfv wnel vy cv vz
      cv cin c0 wne vz cX vx cv cdif csn wral vy cF wral wb cF cfil wcel vx cv
      cF wcel wn vx cv cX wss w3a vy vz cF cX vx cv cdif csn fbunfip cF cfil
      wcel vx cv cF wcel wn cF cfbas wcel vx cv cX wss cF filfbas 3ad2ant1 cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX vx cv cdif csn cfil wcel
      cX vx cv cdif csn cfbas wcel cX vx cv cdif cvv wcel cX vx cv cdif c0 wne
      cX vx cv cdif csn cfil wcel cF cfil wcel vx cv cF wcel wn vx cv cX wss
      w3a cX vx cv cdif cvv oefil2 cF cfil wcel vx cv cF wcel wn cX vx cv cdif
      cvv wcel vx cv cX wss cF cfil wcel cX cvv wcel cX vx cv cdif cvv wcel cF
      cfil wcel cF cuni cvv cX cF cfil uniexg filufint.1 syl5eqel cX vx cv cvv
      difexg syl 3ad2ant1 cF cfil wcel vx cv cF wcel wn vx cv cX wss cX vx cv
      cdif c0 wne cF cfil wcel vx cv cX wss vx cv cF wcel wn cX vx cv cdif c0
      wne cF cfil wcel vx cv cX wss vx cv cF wcel wn cX vx cv cdif c0 wne wi cF
      cfil wcel vx cv cX wss wa vx cv cF wcel cX vx cv cdif c0 cF cfil wcel vx
      cv cX wss cX vx cv cdif c0 wceq vx cv cF wcel cF cfil wcel vx cv cX wss
      cX vx cv cdif c0 wceq w3a vx cv cX cF cF cfil wcel vx cv cX wss cX vx cv
      cdif c0 wceq w3a cX cX vx cv cdif cdif vx cv cX vx cv cX wss cF cfil wcel
      cX cX vx cv cdif cdif vx cv wceq cX vx cv cdif c0 wceq vx cv cX wss cX cX
      vx cv cdif cdif vx cv wceq vx cv cX dfss4 biimpi 3ad2ant2 cX vx cv cdif
      c0 wceq cF cfil wcel cX cX vx cv cdif cdif cX wceq vx cv cX wss cX vx cv
      cdif c0 wceq cX cX vx cv cdif cdif cX c0 cdif cX cX vx cv cdif c0 cX
      difeq2 cX dif0 syl6eq 3ad2ant3 eqtr3d cF cfil wcel vx cv cX wss cX cF
      wcel cX vx cv cdif c0 wceq cF cX filufint.1 filusb 3ad2ant1 eqeltrd
      3expia necon3bd ex com23 3imp sylanc cX vx cv cdif csn filfbas syl sylanc
      mpbird jca cF cfil wcel vx cv cF wcel wn cF cX vx cv cdif csn cun cfi cfv
      cfbas wcel cF cX vx cv cdif csn cun c0 wne c0 cF cX vx cv cdif csn cun
      cfi cfv wnel wa wb vx cv cX wss cF cfil wcel cF cX vx cv cdif csn cun cvv
      wcel cF cX vx cv cdif csn cun cfi cfv cfbas wcel cF cX vx cv cdif csn cun
      c0 wne c0 cF cX vx cv cdif csn cun cfi cfv wnel wa wb cF cfil wcel cX vx
      cv cdif csn cvv wcel cF cX vx cv cdif csn cun cvv wcel cX vx cv cdif snex
      cF cX vx cv cdif csn cfil cvv unexg mpan2 cF cX vx cv cdif csn cun cvv
      fsubbas syl 3ad2ant1 mpbird 3ad2ant1 cF cX vx cv cdif csn cun cfi cfv
      fbssfg syl sstrd adantr cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX
      cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni wceq vf cv cufil wcel w3a
      cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni wceq cF cX vx cv
      cdif csn cun cfi cfv cfg cfv vf cv wss vx cv vf cv wcel 3simpr2 sstrd cF
      cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif csn cun
      cfi cfv cfg cfv cuni wceq vf cv cufil wcel w3a cX vx cv cdif cX vx cv
      cdif csn wcel cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni vf cv cuni
      wceq cF cX vx cv cdif csn cun cfi cfv cfg cfv vf cv wss vx cv vf cv wcel
      w3a cF cfil wcel vx cv cF wcel wn vx cv cX wss w3a cX cF cX vx cv cdif
      csn cun cfi cfv cfg cfv cuni wceq cX vx cv cdif cX vx cv cdif csn wcel vf
      cv cufil wcel cF cfil wcel vx cv cF wcel wn cX vx cv cdif cX vx cv cdif
      csn wcel vx cv cX wss cF cfil wcel cX cvv wcel cX vx cv cdif cvv wcel cX
      vx cv cdif cX vx cv cdif csn wcel cF cfil wcel cF cuni cvv cX cF cfil
      uniexg filufint.1 syl5eqel cX vx cv cvv difexg cX vx cv cdif cvv snidg
      3syl 3ad2ant1 3ad2ant1 adantr sseldd syl3anc vx cv cX difdisj syl5eqelr
      3exp2 imp32 mtod jca31 ex 3expia r19.22dv vf cF cX vx cv cdif csn cun cfi
      cfv cfg cfv cF cX vx cv cdif csn cun cfi cfv cfg cfv cuni cF cX vx cv
      cdif csn cun cfi cfv cfg cfv cuni eqid filssufil syl5 ex com23 imp3a
      mp2and 3expia cF cfil wcel vx cv cX wss wn cX vf cv cuni wceq cF vf cv
      wss wa vx cv vf cv wcel wn wa vf cufil wrex wi vx cv cF wcel wn vx cv cX
      wss wn cX vf cv cuni wceq cF vf cv wss wa vf cufil wrex cX vf cv cuni
      wceq cF vf cv wss wa vx cv vf cv wcel wn wa vf cufil wrex cF cfil wcel vx
      cv cX wss wn cX vf cv cuni wceq cF vf cv wss wa cX vf cv cuni wceq cF vf
      cv wss wa vx cv vf cv wcel wn wa vf cufil vx cv cX wss wn cX vf cv cuni
      wceq cF vf cv wss wa vx cv vf cv wcel wn vx cv cX wss wn cX vf cv cuni
      wceq vx cv vf cv wcel wn cF vf cv wss cX vf cv cuni wceq vx cv cX wss wn
      vx cv vf cv wcel wn cX vf cv cuni wceq vx cv vf cv wcel vx cv cX wss cX
      vf cv cuni wceq vx cv cX wss vx cv vf cv cuni wss vx cv vf cv wcel cX vf
      cv cuni vx cv sseq2 vx cv vf cv elssuni syl5bir con3d com12 adantrd ancld
      r19.22sdv vf cF cX filufint.1 filssufil syl5com adantr pm2.61d ex cX vf
      cv cuni wceq cF vf cv wss wa vx cv vf cv wcel vf cufil rexanali syl6ib
      con4d cX vf cv cuni wceq cF vf cv wss wa vf vx cv cufil vx visset
      elintrab syl5ib ssrdv cF cfil wcel vf cv cufil wcel cX vf cv cuni wceq cF
      vf cv wss wa wa cF vf cv wss wi vf wal cF cX vf cv cuni wceq cF vf cv wss
      wa vf cufil crab cint wss cF cfil wcel vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa cF vf cv wss wi vf vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa cF vf cv wss wi cF cfil wcel vf cv cufil wcel cX
      vf cv cuni wceq cF vf cv wss simprr a1i 19.21aiv cF cX vf cv cuni wceq cF
      vf cv wss wa vf cufil crab cint wss cF vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa vf cab cint wss vf cv cufil wcel cX vf cv cuni
      wceq cF vf cv wss wa wa cF vf cv wss wi vf wal cX vf cv cuni wceq cF vf
      cv wss wa vf cufil crab cint vf cv cufil wcel cX vf cv cuni wceq cF vf cv
      wss wa wa vf cab cint cF cX vf cv cuni wceq cF vf cv wss wa vf cufil crab
      vf cv cufil wcel cX vf cv cuni wceq cF vf cv wss wa wa vf cab cX vf cv
      cuni wceq cF vf cv wss wa vf cufil df-rab inteqi sseq2i vf cv cufil wcel
      cX vf cv cuni wceq cF vf cv wss wa wa vf cF ssintab bitr2i sylib eqssd $.
      $( [1-Jan-2010] $) $( [1-Jan-2010] $)
  $}

  ${
    $d w x y z F $. $d w x y z X $.
    uffixfr.1 $e |- X = U. F $.
    $( An ultrafilter is either fixed or free. A fixed ultrafilter is called
       principal, and a free ultrafilter is called nonprincipal. Note that free
       ultrafilters cannot be constructed. $)
    uffixfr $p |- ( F e. UFil -> ( |^| F = (/) \/ E. x e. X A. y e. ~P X ( y e.
    F <-> x e. y ) ) ) $=
      cF cufil wcel cF cint c0 wceq vy cv cF wcel vx cv vy cv wcel wb vy cX cpw
      wral vx cX wrex cF cufil wcel vz cv cF cint wcel vz wex vy cv cF wcel vx
      cv vy cv wcel wb vy cX cpw wral vx cX wrex cF cint c0 wceq wn cF cufil
      wcel vz cv cF cint wcel vy cv cF wcel vx cv vy cv wcel wb vy cX cpw wral
      vx cX wrex vz cF cufil wcel vz cv cF cint wcel vy cv cF wcel vx cv vy cv
      wcel wb vy cX cpw wral vx cX wrex vz cv cX wcel vy cv cF wcel vz cv vy cv
      wcel wb vy cX cpw wral vy cv cF wcel vx cv vy cv wcel wb vy cX cpw wral
      vx cX wrex cF cufil wcel vz cv cF cint wcel wa vy cv cF wcel vx cv vy cv
      wcel wb vy cX cpw wral vy cv cF wcel vz cv vy cv wcel wb vy cX cpw wral
      vx vz cv cX vx cv vz cv wceq vy cv cF wcel vx cv vy cv wcel wb vy cv cF
      wcel vz cv vy cv wcel wb vy cX cpw vx cv vz cv wceq vx cv vy cv wcel vz
      cv vy cv wcel vy cv cF wcel vx cv vz cv vy cv eleq1 bibi2d ralbidv
      rcla4ev cF cufil wcel vz cv vx cv wcel vx cF wral vz cv cX wcel vz cv cF
      cint wcel cF c0 wne vz cv vx cv wcel vx cF wral vz cv cX wcel cF cufil
      wcel cF c0 wne vz cv vx cv wcel vx cF wral wa vz cv vx cv wcel vx cF wrex
      vz cv cX wcel vz cv vx cv wcel vx cF r19.2z vz cv vx cv wcel vz cv cX
      wcel vx cF vx cv cF wcel vx cv cX vz cv vx cv cF wcel vx cv cF cuni cX vx
      cv cF elssuni uffixfr.1 syl6ssr sseld r19.23aiv syl cF cufil wcel cF cfil
      wcel cX cF wcel cF c0 wne cF ufilfil cF cX uffixfr.1 filusb cF cX ne0i
      3syl sylan vx vz cv cF vz visset elint2 sylan2b cF cufil wcel vz cv cF
      cint wcel wa vy cv cF wcel vz cv vy cv wcel wb vy cX cpw cF cufil wcel vz
      cv cF cint wcel wa vy cv cX wss vy cv cF wcel vz cv vy cv wcel wb vy cv
      cX cpw wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vy cv cF
      wcel vz cv vy cv wcel wb cF cufil wcel vz cv cF cint wcel wa vy cv cX wss
      wa vy cv cF wcel vz cv vy cv wcel vz cv cF cint wcel vy cv cF wcel vz cv
      vy cv wcel wi cF cufil wcel vy cv cX wss vz cv cF vy cv elinti ad2antlr
      cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel vy cv
      cF wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel
      wa wa vy cv vz cv csn csn cX csn cun cfg cfv cF cF cufil wcel vz cv cF
      cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vy cv vz cv csn csn cX
      csn cun cfg cfv wcel vy cv vz cv csn csn cuni cX csn cuni cun wss vx cv
      vy cv wss vx vz cv csn csn cX csn cun wrex wa cF cufil wcel vz cv cF cint
      wcel wa vy cv cX wss vz cv vy cv wcel wa wa vy cv vz cv csn csn cuni cX
      csn cuni cun wss vx cv vy cv wss vx vz cv csn csn cX csn cun wrex cF
      cufil wcel vy cv cX wss vy cv vz cv csn csn cuni cX csn cuni cun wss vz
      cv cF cint wcel vz cv vy cv wcel cF cufil wcel vy cv cX wss wa vy cv cX
      csn cuni vz cv csn csn cuni cX csn cuni cun cF cufil wcel vy cv cX wss wa
      vy cv cX cX csn cuni cF cufil wcel vy cv cX wss pm3.27 cF cufil wcel cX
      csn cuni cX wceq vy cv cX wss cF cufil wcel cX cvv wcel cX csn cuni cX
      wceq cF cufil wcel cF cuni cvv cX cF cufil uniexg uffixfr.1 syl5eqel cX
      cvv unisng syl adantr sseqtr4d cX csn cuni vz cv csn csn cuni cX csn cuni
      cun wss cF cufil wcel vy cv cX wss wa cX csn cuni vz cv csn csn cuni
      ssun2 a1i sstrd ad2ant2r vz cv csn vz cv csn csn cX csn cun wcel vz cv
      csn vy cv wss vx cv vy cv wss vx vz cv csn csn cX csn cun wrex cF cufil
      wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vx cv vy
      cv wss vz cv csn vy cv wss vx vz cv csn vz cv csn csn cX csn cun vx cv vz
      cv csn vy cv sseq1 rcla4ev vz cv csn vz cv csn csn cX csn cun wcel cF
      cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vz
      cv csn csn vz cv csn csn cX csn cun vz cv csn vz cv csn csn cX csn ssun1
      vz cv csn vz cv snex snid sselii a1i vz cv vy cv wcel vz cv csn vy cv wss
      cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv snssi
      ad2antll sylanc jca cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz
      cv vy cv wcel wa wa vz cv csn csn cX csn cun cfbas wcel vy cv vz cv csn
      csn cX csn cun cfg cfv wcel vy cv vz cv csn csn cuni cX csn cuni cun wss
      vx cv vy cv wss vx vz cv csn csn cX csn cun wrex wa wb vz cv csn csn
      cfbas wcel vz cv csn cX wss vz cv csn csn cX csn cun cfbas wcel cF cufil
      wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa cX vz cv
      csn csn vz cv csn vz cv csn csn cuni vz cv csn vz cv csn vz cv snex unisn
      eqcomi extbas1 vz cv csn cvv wcel vz cv csn c0 wne vz cv csn csn cfbas
      wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa
      wa vz cv csn cvv wcel vz cv csn c0 wne wa vz cv csn csn cfil wcel vz cv
      csn csn cfbas wcel vz cv csn cvv oefil2 vz cv csn csn filfbas syl vz cv
      csn cvv wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv
      wcel wa wa vz cv snex a1i vz cv vy cv wcel vz cv csn c0 wne cF cufil wcel
      vz cv cF cint wcel wa vy cv cX wss vz cv vy cv snnzg ad2antll sylanc cF
      cufil wcel vz cv cF cint wcel wa vz cv csn cX wss vy cv cX wss vz cv vy
      cv wcel wa cF cufil wcel vz cv cF cint wcel wa vz cv cX wcel vz cv csn cX
      wss cF cufil wcel vz cv vx cv wcel vx cF wral vz cv cX wcel vz cv cF cint
      wcel cF c0 wne vz cv vx cv wcel vx cF wral vz cv cX wcel cF cufil wcel cF
      c0 wne vz cv vx cv wcel vx cF wral wa vz cv vx cv wcel vx cF wrex vz cv
      cX wcel vz cv vx cv wcel vx cF r19.2z vz cv vx cv wcel vz cv cX wcel vx
      cF vx cv cF wcel vx cv cX vz cv vx cv cF wcel vx cv cF cuni cX vx cv cF
      elssuni uffixfr.1 syl6ssr sseld r19.23aiv syl cF cufil wcel cF cfil wcel
      cX cF wcel cF c0 wne cF ufilfil cF cX uffixfr.1 filusb cF cX ne0i 3syl
      sylan vx vz cv cF vz visset elint2 sylan2b vz cv cX snssi syl adantr
      sylanc vx vy cv vz cv csn csn cX csn cun vz cv csn csn cuni cX csn cuni
      cun vz cv csn csn cX csn cun cuni vz cv csn csn cuni cX csn cuni cun vz
      cv csn csn cX csn uniun eqcomi elfg syl mpbird cF cufil wcel vz cv csn
      csn cX csn cun cfg cfv cfil wcel cX vz cv csn csn cX csn cun cfg cfv cuni
      wceq cF vz cv csn csn cX csn cun cfg cfv wss cF vz cv csn csn cX csn cun
      cfg cfv wceq cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv
      wcel wa wa cF vz cv csn csn cX csn cun cfg cfv cX vz cv csn csn cX csn
      cun cfg cfv cuni uffixfr.1 vz cv csn csn cX csn cun cfg cfv cuni eqid
      ufilmax cF cufil wcel vz cv cF cint wcel vy cv cX wss vz cv vy cv wcel wa
      simpll cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel
      wa wa vz cv csn csn cX csn cun cfbas wcel vz cv csn csn cX csn cun cfg
      cfv cfil wcel vz cv csn csn cfbas wcel vz cv csn cX wss vz cv csn csn cX
      csn cun cfbas wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv
      vy cv wcel wa wa cX vz cv csn csn vz cv csn vz cv csn csn cuni vz cv csn
      vz cv csn vz cv snex unisn eqcomi extbas1 vz cv csn cvv wcel vz cv csn c0
      wne vz cv csn csn cfbas wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX
      wss vz cv vy cv wcel wa wa vz cv csn cvv wcel vz cv csn c0 wne wa vz cv
      csn csn cfil wcel vz cv csn csn cfbas wcel vz cv csn cvv oefil2 vz cv csn
      csn filfbas syl vz cv csn cvv wcel cF cufil wcel vz cv cF cint wcel wa vy
      cv cX wss vz cv vy cv wcel wa wa vz cv snex a1i vz cv vy cv wcel vz cv
      csn c0 wne cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv
      snnzg ad2antll sylanc cF cufil wcel vz cv cF cint wcel wa vz cv csn cX
      wss vy cv cX wss vz cv vy cv wcel wa cF cufil wcel vz cv cF cint wcel wa
      vz cv cX wcel vz cv csn cX wss cF cufil wcel vz cv vx cv wcel vx cF wral
      vz cv cX wcel vz cv cF cint wcel cF c0 wne vz cv vx cv wcel vx cF wral vz
      cv cX wcel cF cufil wcel cF c0 wne vz cv vx cv wcel vx cF wral wa vz cv
      vx cv wcel vx cF wrex vz cv cX wcel vz cv vx cv wcel vx cF r19.2z vz cv
      vx cv wcel vz cv cX wcel vx cF vx cv cF wcel vx cv cX vz cv vx cv cF wcel
      vx cv cF cuni cX vx cv cF elssuni uffixfr.1 syl6ssr sseld r19.23aiv syl
      cF cufil wcel cF cfil wcel cX cF wcel cF c0 wne cF ufilfil cF cX
      uffixfr.1 filusb cF cX ne0i 3syl sylan vx vz cv cF vz visset elint2
      sylan2b vz cv cX snssi syl adantr sylanc vz cv csn csn cX csn cun fgfil
      syl cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa
      wa vz cv csn csn cuni cX csn cuni cun vz cv csn cX cun vz cv csn csn cX
      csn cun cfg cfv cuni cX cF cufil wcel vz cv cF cint wcel wa vy cv cX wss
      vz cv vy cv wcel wa wa vz cv csn csn cuni vz cv csn cX csn cuni cX vz cv
      csn csn cuni vz cv csn wceq cF cufil wcel vz cv cF cint wcel wa vy cv cX
      wss vz cv vy cv wcel wa wa vz cv csn vz cv snex unisn a1i cF cufil wcel
      cX csn cuni cX wceq vz cv cF cint wcel vy cv cX wss vz cv vy cv wcel wa
      cF cufil wcel cX cvv wcel cX csn cuni cX wceq cF cufil wcel cF cuni cvv
      cX cF cufil uniexg uffixfr.1 syl5eqel cX cvv unisng syl ad2antrr uneq12d
      cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa
      vz cv csn csn cX csn cun cfbas wcel vz cv csn csn cuni cX csn cuni cun vz
      cv csn csn cX csn cun cfg cfv cuni wceq vz cv csn csn cfbas wcel vz cv
      csn cX wss vz cv csn csn cX csn cun cfbas wcel cF cufil wcel vz cv cF
      cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa cX vz cv csn csn vz cv
      csn vz cv csn csn cuni vz cv csn vz cv csn vz cv snex unisn eqcomi
      extbas1 vz cv csn cvv wcel vz cv csn c0 wne vz cv csn csn cfbas wcel cF
      cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vz
      cv csn cvv wcel vz cv csn c0 wne wa vz cv csn csn cfil wcel vz cv csn csn
      cfbas wcel vz cv csn cvv oefil2 vz cv csn csn filfbas syl vz cv csn cvv
      wcel cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa
      wa vz cv snex a1i vz cv vy cv wcel vz cv csn c0 wne cF cufil wcel vz cv
      cF cint wcel wa vy cv cX wss vz cv vy cv snnzg ad2antll sylanc cF cufil
      wcel vz cv cF cint wcel wa vz cv csn cX wss vy cv cX wss vz cv vy cv wcel
      wa cF cufil wcel vz cv cF cint wcel wa vz cv cX wcel vz cv csn cX wss cF
      cufil wcel vz cv vx cv wcel vx cF wral vz cv cX wcel vz cv cF cint wcel
      cF c0 wne vz cv vx cv wcel vx cF wral vz cv cX wcel cF cufil wcel cF c0
      wne vz cv vx cv wcel vx cF wral wa vz cv vx cv wcel vx cF wrex vz cv cX
      wcel vz cv vx cv wcel vx cF r19.2z vz cv vx cv wcel vz cv cX wcel vx cF
      vx cv cF wcel vx cv cX vz cv vx cv cF wcel vx cv cF cuni cX vx cv cF
      elssuni uffixfr.1 syl6ssr sseld r19.23aiv syl cF cufil wcel cF cfil wcel
      cX cF wcel cF c0 wne cF ufilfil cF cX uffixfr.1 filusb cF cX ne0i 3syl
      sylan vx vz cv cF vz visset elint2 sylan2b vz cv cX snssi syl adantr
      sylanc vz cv csn csn cX csn cun vz cv csn csn cuni cX csn cuni cun vz cv
      csn csn cX csn cun cuni vz cv csn csn cuni cX csn cuni cun vz cv csn csn
      cX csn uniun eqcomi fgbas syl cF cufil wcel vz cv cF cint wcel wa vy cv
      cX wss vz cv vy cv wcel wa wa vz cv csn cX wss vz cv csn cX cun cX wceq
      cF cufil wcel vz cv cF cint wcel wa vz cv csn cX wss vy cv cX wss vz cv
      vy cv wcel wa cF cufil wcel vz cv cF cint wcel wa vz cv cX wcel vz cv csn
      cX wss cF cufil wcel vz cv vx cv wcel vx cF wral vz cv cX wcel vz cv cF
      cint wcel cF c0 wne vz cv vx cv wcel vx cF wral vz cv cX wcel cF cufil
      wcel cF c0 wne vz cv vx cv wcel vx cF wral wa vz cv vx cv wcel vx cF wrex
      vz cv cX wcel vz cv vx cv wcel vx cF r19.2z vz cv vx cv wcel vz cv cX
      wcel vx cF vx cv cF wcel vx cv cX vz cv vx cv cF wcel vx cv cF cuni cX vx
      cv cF elssuni uffixfr.1 syl6ssr sseld r19.23aiv syl cF cufil wcel cF cfil
      wcel cX cF wcel cF c0 wne cF ufilfil cF cX uffixfr.1 filusb cF cX ne0i
      3syl sylan vx vz cv cF vz visset elint2 sylan2b vz cv cX snssi syl adantr
      vz cv csn cX ssequn1 sylib 3eqtr3rd cF cufil wcel vz cv cF cint wcel wa
      vy cv cX wss vz cv vy cv wcel wa wa vx cF vz cv csn csn cX csn cun cfg
      cfv cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa
      wa vx cv cF wcel vx cv vz cv csn csn cX csn cun cfg cfv wcel cF cufil
      wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vx cv cF
      wcel wa vx cv vz cv csn csn cX csn cun cfg cfv wcel vx cv vz cv csn csn
      cuni cX csn cuni cun wss vw cv vx cv wss vw vz cv csn csn cX csn cun wrex
      wa cF cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa
      wa vx cv cF wcel wa vx cv vz cv csn csn cuni cX csn cuni cun wss vw cv vx
      cv wss vw vz cv csn csn cX csn cun wrex cF cufil wcel vz cv cF cint wcel
      wa vx cv cF wcel vx cv vz cv csn csn cuni cX csn cuni cun wss vy cv cX
      wss vz cv vy cv wcel wa cF cufil wcel vx cv cF wcel vx cv vz cv csn csn
      cuni cX csn cuni cun wss vz cv cF cint wcel cF cufil wcel vx cv cF wcel
      wa vx cv cX csn cuni vz cv csn csn cuni cX csn cuni cun cF cufil wcel vx
      cv cF wcel wa vx cv cX cX csn cuni vx cv cF wcel vx cv cX wss cF cufil
      wcel vx cv cF wcel vx cv cF cuni cX vx cv cF elssuni uffixfr.1 syl6ssr
      adantl cF cufil wcel cX csn cuni cX wceq vx cv cF wcel cF cufil wcel cX
      cvv wcel cX csn cuni cX wceq cF cufil wcel cF cuni cvv cX cF cufil uniexg
      uffixfr.1 syl5eqel cX cvv unisng syl adantr sseqtr4d cX csn cuni vz cv
      csn csn cuni cX csn cuni cun wss cF cufil wcel vx cv cF wcel wa cX csn
      cuni vz cv csn csn cuni ssun2 a1i sstrd adantlr adantlr cF cufil wcel vz
      cv cF cint wcel wa vx cv cF wcel vw cv vx cv wss vw vz cv csn csn cX csn
      cun wrex vy cv cX wss vz cv vy cv wcel wa vz cv cF cint wcel vx cv cF
      wcel vw cv vx cv wss vw vz cv csn csn cX csn cun wrex cF cufil wcel vz cv
      csn vz cv csn csn cX csn cun wcel vz cv csn vx cv wss vw cv vx cv wss vw
      vz cv csn csn cX csn cun wrex vz cv cF cint wcel vx cv cF wcel wa vw cv
      vx cv wss vz cv csn vx cv wss vw vz cv csn vz cv csn csn cX csn cun vw cv
      vz cv csn vx cv sseq1 rcla4ev vz cv csn vz cv csn csn cX csn cun wcel vz
      cv cF cint wcel vx cv cF wcel wa vz cv csn csn vz cv csn csn cX csn cun
      vz cv csn vz cv csn csn cX csn ssun1 vz cv csn vz cv snex snid sselii a1i
      vz cv cF cint wcel vx cv cF wcel wa vz cv vx cv wcel vz cv csn vx cv wss
      vz cv cF cint wcel vx cv cF wcel vz cv vx cv wcel vz cv cF vx cv elinti
      imp vz cv vx cv snssi syl sylanc adantll adantlr jca cF cufil wcel vz cv
      cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vx cv vz cv csn csn
      cX csn cun cfg cfv wcel vx cv vz cv csn csn cuni cX csn cuni cun wss vw
      cv vx cv wss vw vz cv csn csn cX csn cun wrex wa wb vx cv cF wcel cF
      cufil wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vz
      cv csn csn cX csn cun cfbas wcel vx cv vz cv csn csn cX csn cun cfg cfv
      wcel vx cv vz cv csn csn cuni cX csn cuni cun wss vw cv vx cv wss vw vz
      cv csn csn cX csn cun wrex wa wb vz cv csn csn cfbas wcel vz cv csn cX
      wss vz cv csn csn cX csn cun cfbas wcel cF cufil wcel vz cv cF cint wcel
      wa vy cv cX wss vz cv vy cv wcel wa wa cX vz cv csn csn vz cv csn vz cv
      csn csn cuni vz cv csn vz cv csn vz cv snex unisn eqcomi extbas1 vz cv
      csn cvv wcel vz cv csn c0 wne vz cv csn csn cfbas wcel cF cufil wcel vz
      cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vz cv csn cvv wcel
      vz cv csn c0 wne wa vz cv csn csn cfil wcel vz cv csn csn cfbas wcel vz
      cv csn cvv oefil2 vz cv csn csn filfbas syl vz cv csn cvv wcel cF cufil
      wcel vz cv cF cint wcel wa vy cv cX wss vz cv vy cv wcel wa wa vz cv snex
      a1i vz cv vy cv wcel vz cv csn c0 wne cF cufil wcel vz cv cF cint wcel wa
      vy cv cX wss vz cv vy cv snnzg ad2antll sylanc cF cufil wcel vz cv cF
      cint wcel wa vz cv csn cX wss vy cv cX wss vz cv vy cv wcel wa cF cufil
      wcel vz cv cF cint wcel wa vz cv cX wcel vz cv csn cX wss cF cufil wcel
      vz cv vx cv wcel vx cF wral vz cv cX wcel vz cv cF cint wcel cF c0 wne vz
      cv vx cv wcel vx cF wral vz cv cX wcel cF cufil wcel cF c0 wne vz cv vx
      cv wcel vx cF wral wa vz cv vx cv wcel vx cF wrex vz cv cX wcel vz cv vx
      cv wcel vx cF r19.2z vz cv vx cv wcel vz cv cX wcel vx cF vx cv cF wcel
      vx cv cX vz cv vx cv cF wcel vx cv cF cuni cX vx cv cF elssuni uffixfr.1
      syl6ssr sseld r19.23aiv syl cF cufil wcel cF cfil wcel cX cF wcel cF c0
      wne cF ufilfil cF cX uffixfr.1 filusb cF cX ne0i 3syl sylan vx vz cv cF
      vz visset elint2 sylan2b vz cv cX snssi syl adantr sylanc vw vx cv vz cv
      csn csn cX csn cun vz cv csn csn cuni cX csn cuni cun vz cv csn csn cX
      csn cun cuni vz cv csn csn cuni cX csn cuni cun vz cv csn csn cX csn
      uniun eqcomi elfg syl adantr mpbird ex ssrdv syl2anc eleqtrrd expr impbid
      ex vy cv cX vy visset elpw syl5ib r19.21aiv sylanc ex 19.23adv vz cF cint
      neq0 syl5ib orrd $.
      $( [4-Dec-2009] $) $( [4-Dec-2009] $)
  $}

  ${
    $d x y A $. $d x y B $. $d x y X $.
    $( The condition describing a fixed ultrafilter always produces an
       ultrafilter. $)
    fixufil $p |- ( ( X e. B /\ A e. X ) -> { x e. ~P X | A e. x } e. UFil ) $=
      cX cB wcel cA cX wcel wa cA vx cv wcel vx cX cpw crab cfil wcel vy cv cA
      vx cv wcel vx cX cpw crab wcel cA vx cv wcel vx cX cpw crab cuni vy cv
      cdif cA vx cv wcel vx cX cpw crab wcel wo vy cA vx cv wcel vx cX cpw crab
      cuni cpw wral wa cA vx cv wcel vx cX cpw crab cufil wcel cX cB wcel cA cX
      wcel wa cA vx cv wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx cX cpw
      crab cuni wceq wa cA vx cv wcel vx cX cpw crab cfil wcel vy cv cA vx cv
      wcel vx cX cpw crab wcel cA vx cv wcel vx cX cpw crab cuni vy cv cdif cA
      vx cv wcel vx cX cpw crab wcel wo vy cA vx cv wcel vx cX cpw crab cuni
      cpw wral wa cX cB wcel cA cX wcel wa cA vx cv wcel vx cX cpw crab cfil
      wcel cX cA vx cv wcel vx cX cpw crab cuni wceq wa vx cv cX wss cA csn vx
      cv wss wa vx cab cfil wcel cX vx cv cX wss cA csn vx cv wss wa vx cab
      cuni wceq wa cX cB wcel cA csn cX wss cA csn c0 wne vx cv cX wss cA csn
      vx cv wss wa vx cab cfil wcel cX vx cv cX wss cA csn vx cv wss wa vx cab
      cuni wceq wa cX cB wcel cA cX wcel wa vx cX cA csn cB supfil cX cB wcel
      cA cX wcel pm3.26 cA cX wcel cA csn cX wss cX cB wcel cA cX snssi adantl
      cA cX wcel cA csn c0 wne cX cB wcel cA cX snnzg adantl syl3anc cX cB wcel
      cA cX wcel wa cA vx cv wcel vx cX cpw crab vx cv cX wss cA csn vx cv wss
      wa vx cab wceq cA vx cv wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx
      cX cpw crab cuni wceq wa vx cv cX wss cA csn vx cv wss wa vx cab cfil
      wcel cX vx cv cX wss cA csn vx cv wss wa vx cab cuni wceq wa wb cX cB
      wcel cA cX wcel wa vx cv cX cpw wcel cA vx cv wcel wa vx cab vx cv cX wss
      cA csn vx cv wss wa vx cab cA vx cv wcel vx cX cpw crab cX cB wcel cA cX
      wcel wa vx cv cX cpw wcel cA vx cv wcel wa vx cv cX wss cA csn vx cv wss
      wa vx cX cB wcel cA cX wcel wa vx cv cX cpw wcel vx cv cX wss cA vx cv
      wcel cA csn vx cv wss vx cv cX cpw wcel vx cv cX wss wb cX cB wcel cA cX
      wcel wa vx cv cX vx visset elpw a1i cA cX wcel cA vx cv wcel cA csn vx cv
      wss wb cX cB wcel cA vx cv cX snssg adantl anbi12d abbidv cA vx cv wcel
      vx cX cpw df-rab syl5eq cA vx cv wcel vx cX cpw crab vx cv cX wss cA csn
      vx cv wss wa vx cab wceq cA vx cv wcel vx cX cpw crab cfil wcel vx cv cX
      wss cA csn vx cv wss wa vx cab cfil wcel cX cA vx cv wcel vx cX cpw crab
      cuni wceq cX vx cv cX wss cA csn vx cv wss wa vx cab cuni wceq cA vx cv
      wcel vx cX cpw crab vx cv cX wss cA csn vx cv wss wa vx cab cfil eleq1 cA
      vx cv wcel vx cX cpw crab vx cv cX wss cA csn vx cv wss wa vx cab wceq cA
      vx cv wcel vx cX cpw crab cuni vx cv cX wss cA csn vx cv wss wa vx cab
      cuni cX cA vx cv wcel vx cX cpw crab vx cv cX wss cA csn vx cv wss wa vx
      cab unieq eqeq2d anbi12d syl mpbird cX cB wcel cA cX wcel wa cA vx cv
      wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx cX cpw crab cuni wceq
      wa wa cA vx cv wcel vx cX cpw crab cfil wcel vy cv cA vx cv wcel vx cX
      cpw crab wcel cA vx cv wcel vx cX cpw crab cuni vy cv cdif cA vx cv wcel
      vx cX cpw crab wcel wo vy cA vx cv wcel vx cX cpw crab cuni cpw wral cX
      cB wcel cA cX wcel wa cA vx cv wcel vx cX cpw crab cfil wcel cX cA vx cv
      wcel vx cX cpw crab cuni wceq simprl cX cB wcel cA cX wcel wa cA vx cv
      wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx cX cpw crab cuni wceq
      wa wa vy cv cA vx cv wcel vx cX cpw crab wcel cA vx cv wcel vx cX cpw
      crab cuni vy cv cdif cA vx cv wcel vx cX cpw crab wcel wo vy cA vx cv
      wcel vx cX cpw crab cuni cpw cX cB wcel cA cX wcel wa cA vx cv wcel vx cX
      cpw crab cfil wcel cX cA vx cv wcel vx cX cpw crab cuni wceq wa wa vy cv
      cA vx cv wcel vx cX cpw crab cuni wss vy cv cA vx cv wcel vx cX cpw crab
      wcel cA vx cv wcel vx cX cpw crab cuni vy cv cdif cA vx cv wcel vx cX cpw
      crab wcel wo vy cv cA vx cv wcel vx cX cpw crab cuni cpw wcel cX cB wcel
      cA cX wcel wa cA vx cv wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx
      cX cpw crab cuni wceq wa wa vy cv cX wss vy cv cA vx cv wcel vx cX cpw
      crab wcel cX vy cv cdif cA vx cv wcel vx cX cpw crab wcel wo vy cv cA vx
      cv wcel vx cX cpw crab cuni wss vy cv cA vx cv wcel vx cX cpw crab wcel
      cA vx cv wcel vx cX cpw crab cuni vy cv cdif cA vx cv wcel vx cX cpw crab
      wcel wo cX cB wcel cA cX wcel wa vy cv cX wss vy cv cA vx cv wcel vx cX
      cpw crab wcel cX vy cv cdif cA vx cv wcel vx cX cpw crab wcel wo wi cA vx
      cv wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx cX cpw crab cuni
      wceq wa cX cB wcel cA cX wcel wa vy cv cX wss vy cv cA vx cv wcel vx cX
      cpw crab wcel cX vy cv cdif cA vx cv wcel vx cX cpw crab wcel wo cX cB
      wcel cA cX wcel wa vy cv cX wss wa vy cv cA vx cv wcel vx cX cpw crab
      wcel cX vy cv cdif cA vx cv wcel vx cX cpw crab wcel cX cB wcel cA cX
      wcel wa vy cv cX wss wa vy cv cX wss cA vy cv wcel wn wi cX vy cv cdif cA
      vx cv wcel vx cX cpw crab wcel vy cv cA vx cv wcel vx cX cpw crab wcel wn
      cX cB wcel cA cX wcel wa vy cv cX wss wa vy cv cX wss cA vy cv wcel wn wi
      cA vy cv wcel wn cX vy cv cdif cA vx cv wcel vx cX cpw crab wcel vy cv cX
      wss vy cv cX wss cA vy cv wcel wn wi cA vy cv wcel wn wi cX cB wcel cA cX
      wcel wa vy cv cX wss cA vy cv wcel wn pm2.27 adantl cX cB wcel cA cX wcel
      wa vy cv cX wss cA vy cv wcel wn cX vy cv cdif cA vx cv wcel vx cX cpw
      crab wcel cX cB wcel cA cX wcel wa vy cv cX wss cA vy cv wcel wn wa wa cX
      vy cv cdif cX cpw wcel cA cX vy cv cdif wcel wa cX vy cv cdif cA vx cv
      wcel vx cX cpw crab wcel cX cB wcel cA cX wcel wa vy cv cX wss cA vy cv
      wcel wn wa wa cX vy cv cdif cX cpw wcel cA cX vy cv cdif wcel cX cB wcel
      cX vy cv cdif cX cpw wcel cA cX wcel vy cv cX wss cA vy cv wcel wn wa cX
      cB wcel cX vy cv cdif cX cpw wcel cX vy cv cdif cX wss cX vy cv difss cX
      vy cv cdif cX cB elpw2g mpbiri ad2antrr cA cX wcel cA vy cv wcel wn cA cX
      vy cv cdif wcel cX cB wcel vy cv cX wss cA cX vy cv cdif wcel cA cX wcel
      cA vy cv wcel wn wa cA cX vy cv eldif biimpri ad2ant2l jca cA vx cv wcel
      cA cX vy cv cdif wcel vx cX vy cv cdif cX cpw vx cv cX vy cv cdif cA
      eleq2 elrab sylibr expr syld vy cv cA vx cv wcel vx cX cpw crab wcel wn
      vy cv cX wss cA vy cv wcel wa wn vy cv cX wss cA vy cv wcel wn wi vy cv
      cA vx cv wcel vx cX cpw crab wcel vy cv cX wss cA vy cv wcel wa vy cv cA
      vx cv wcel vx cX cpw crab wcel vy cv cX cpw wcel cA vy cv wcel wa vy cv
      cX wss cA vy cv wcel wa cA vx cv wcel cA vy cv wcel vx vy cv cX cpw vx cv
      vy cv cA eleq2 elrab vy cv cX cpw wcel vy cv cX wss cA vy cv wcel vy cv
      cX vy visset elpw anbi1i bitri notbii vy cv cX wss cA vy cv wcel imnan
      bitr4i syl5ib orrd ex adantr cX cA vx cv wcel vx cX cpw crab cuni wceq vy
      cv cX wss vy cv cA vx cv wcel vx cX cpw crab cuni wss wb cX cB wcel cA cX
      wcel wa cA vx cv wcel vx cX cpw crab cfil wcel cX cA vx cv wcel vx cX cpw
      crab cuni vy cv sseq2 ad2antll cX cA vx cv wcel vx cX cpw crab cuni wceq
      vy cv cA vx cv wcel vx cX cpw crab wcel cX vy cv cdif cA vx cv wcel vx cX
      cpw crab wcel wo vy cv cA vx cv wcel vx cX cpw crab wcel cA vx cv wcel vx
      cX cpw crab cuni vy cv cdif cA vx cv wcel vx cX cpw crab wcel wo wb cX cB
      wcel cA cX wcel wa cA vx cv wcel vx cX cpw crab cfil wcel cX cA vx cv
      wcel vx cX cpw crab cuni wceq cX vy cv cdif cA vx cv wcel vx cX cpw crab
      wcel cA vx cv wcel vx cX cpw crab cuni vy cv cdif cA vx cv wcel vx cX cpw
      crab wcel vy cv cA vx cv wcel vx cX cpw crab wcel cX cA vx cv wcel vx cX
      cpw crab cuni wceq cX vy cv cdif cA vx cv wcel vx cX cpw crab cuni vy cv
      cdif cA vx cv wcel vx cX cpw crab cX cA vx cv wcel vx cX cpw crab cuni vy
      cv difeq1 eleq1d orbi2d ad2antll 3imtr3d vy cv cA vx cv wcel vx cX cpw
      crab cuni vy visset elpw syl5ib r19.21aiv jca mpdan vy cA vx cv wcel vx
      cX cpw crab cA vx cv wcel vx cX cpw crab cuni cA vx cv wcel vx cX cpw
      crab cuni eqid isufil sylibr $.
      $( [9-Dec-2009] $) $( [9-Dec-2009] $)
  $}

  ${
    $d x y F $. $d x y X $.
    uffinfix.1 $e |- X = U. F $.
    $( An ultrafilter containing a finite element is fixed. $)
    uffinfix $p |- ( ( F e. UFil /\ S e. F /\ S e. Fin ) -> E. x e. X A. y e.
    ~P X ( y e. F <-> x e. y ) ) $=
      cF cufil wcel cS cF wcel cS cfn wcel w3a cF cint c0 wceq wn vy cv cF wcel
      vx cv vy cv wcel wb vy cX cpw wral vx cX wrex cF cufil wcel cS cF wcel cS
      cfn wcel w3a cF cint c0 wne cF cint c0 wceq wn cF cfil wcel cS cF wcel cS
      cfn wcel cF cint c0 wne cF cufil wcel cS cF filfinnfr cF ufilfil syl3an1
      cF cint c0 df-ne sylib cF cufil wcel cS cF wcel cS cfn wcel w3a cF cint
      c0 wceq vy cv cF wcel vx cv vy cv wcel wb vy cX cpw wral vx cX wrex cF
      cufil wcel cS cF wcel cF cint c0 wceq vy cv cF wcel vx cv vy cv wcel wb
      vy cX cpw wral vx cX wrex wo cS cfn wcel vx vy cF cX uffinfix.1 uffixfr
      3ad2ant1 ord mpd $.
      $( [5-Dec-2009] $) $( [5-Dec-2009] $)
  $}

  ${
    $d f u v x y z A $. $d f u v x y z B $. $d f u v x y z X $.
    $( An infinite subset is contained in a free ultrafilter. $)
    ufinffr $p |- ( ( X e. B /\ A C_ X /\ om ~<_ A ) -> E. f e. UFil ( X = U. f
    /\ A e. f /\ |^| f = (/) ) ) $=
      cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab cfil wcel cX vf cv cuni wceq cA vf cv wcel vf cv cint c0
      wceq w3a vf cufil wrex cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab cfil wcel c0 vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab wcel wn vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab cuni vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wa vu cv vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vv cv vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab cuni wss vu cv vv cv wss w3a vv cv vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab wcel wi vv wal vu wal vu cv vv cv
      cin vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vv vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab wral vu vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wral w3a cX cB wcel cA cX wss com cA cdom wbr w3a c0 vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab wcel wn vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab cuni vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      wcel wa vu cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vv cv vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni wss vu cv vv cv wss w3a
      vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wi vv wal vu wal
      vu cv vv cv cin vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vv vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab wral vu vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab wral cX cB wcel cA cX wss com cA cdom wbr w3a c0
      vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wn vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab cuni vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab wcel cX cB wcel cA cX wss com cA cdom wbr w3a c0 cX wss cA c0 cdif
      cfn wcel wa wn c0 vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wn
      cX cB wcel cA cX wss com cA cdom wbr w3a cA c0 cdif cfn wcel c0 cX wss cX
      cB wcel cA cX wss com cA cdom wbr w3a cA com csdm wbr cA c0 cdif cfn wcel
      com cA cdom wbr cX cB wcel cA com csdm wbr wn cA cX wss com cA domnsym
      3ad2ant3 cA c0 cdif cfn wcel cA cfn wcel cA com csdm wbr cA c0 cdif cA
      cfn cA dif0 eleq1i cA com csdm wbr cA cfn wcel cA isfinite biimpri sylbi
      nsyl intnand c0 vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel c0 cX
      wss cA c0 cdif cfn wcel wa vx cv cX wss cA vx cv cdif cfn wcel wa c0 cX
      wss cA c0 cdif cfn wcel wa vx c0 0ex vx cv c0 wceq vx cv cX wss c0 cX wss
      cA vx cv cdif cfn wcel cA c0 cdif cfn wcel vx cv c0 cX sseq1 vx cv c0
      wceq cA vx cv cdif cA c0 cdif cfn vx cv c0 cA difeq2 eleq1d anbi12d elab
      notbii sylibr cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab cuni cX vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab cuni cX cX cB wcel cA cX wss com cA cdom wbr w3a
      vy cv cX wss vy vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wral vx cv
      cX wss cA vx cv cdif cfn wcel wa vx cab cuni cX wss cX cB wcel cA cX wss
      com cA cdom wbr w3a vy cv cX wss vy vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab cX cB wcel cA cX wss com cA cdom wbr w3a vy cv cX wss cA vy cv
      cdif cfn wcel wa vy cv cX wss vy cv vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wcel vy cv cX wss cA vy cv cdif cfn wcel wa vy cv cX wss wi cX
      cB wcel cA cX wss com cA cdom wbr w3a vy cv cX wss cA vy cv cdif cfn wcel
      pm3.26 a1i vx cv cX wss cA vx cv cdif cfn wcel wa vy cv cX wss cA vy cv
      cdif cfn wcel wa vx vy cv vy visset vx cv vy cv wceq vx cv cX wss vy cv
      cX wss cA vx cv cdif cfn wcel cA vy cv cdif cfn wcel vx cv vy cv cX sseq1
      vx cv vy cv wceq cA vx cv cdif cA vy cv cdif cfn vx cv vy cv cA difeq2
      eleq1d anbi12d elab syl5ib r19.21aiv vy vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab cX unissb sylibr cX cB wcel cA cX wss com cA cdom wbr w3a
      cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab cuni wss cX cB wcel cA cX wss com cA cdom
      wbr w3a cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX cX wss
      cA cX cdif cfn wcel wa cX cB wcel cA cX wss com cA cdom wbr w3a cA cX
      cdif cfn wcel cX cX wss cA cX wss cX cB wcel cA cX cdif cfn wcel com cA
      cdom wbr cA cX wss cA cX cdif c0 cfn cA cX wss cA cX cdif c0 wceq cA cX
      ssdif0 biimpi emfin syl6eqel 3ad2ant2 cX ssid jctil cX cB wcel cA cX wss
      cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX cX wss cA cX
      cdif cfn wcel wa wb com cA cdom wbr cA vx cv cdif cfn wcel cA cX cdif cfn
      wcel vx cX cX cB vx cv cX wceq cA vx cv cdif cA cX cdif cfn vx cv cX cA
      difeq2 eleq1d elssabg 3ad2ant1 mpbird cX vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab elssuni syl eqssd cX cB wcel cA cX wss com cA cdom wbr w3a
      cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX cX wss cA cX
      cdif cfn wcel wa cX cB wcel cA cX wss com cA cdom wbr w3a cA cX cdif cfn
      wcel cX cX wss cA cX wss cX cB wcel cA cX cdif cfn wcel com cA cdom wbr
      cA cX wss cA cX cdif c0 cfn cA cX wss cA cX cdif c0 wceq cA cX ssdif0
      biimpi emfin syl6eqel 3ad2ant2 cX ssid jctil cX cB wcel cA cX wss cX vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX cX wss cA cX cdif cfn
      wcel wa wb com cA cdom wbr cA vx cv cdif cfn wcel cA cX cdif cfn wcel vx
      cX cX cB vx cv cX wceq cA vx cv cdif cA cX cdif cfn vx cv cX cA difeq2
      eleq1d elssabg 3ad2ant1 mpbird eqeltrd jca cX cB wcel cA cX wss com cA
      cdom wbr w3a vu cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vv
      cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni wss vu cv vv cv wss
      w3a vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wi vu vv cX
      cB wcel cA cX wss com cA cdom wbr w3a vu cv vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab wcel vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab cuni wss vu cv vv cv wss w3a vv cv cX wss cA vv cv cdif cfn wcel wa
      vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX cB wcel cA cX
      wss com cA cdom wbr w3a vu cv vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab wcel vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni wss vu
      cv vv cv wss vv cv cX wss cA vv cv cdif cfn wcel wa cX cB wcel cA cX wss
      com cA cdom wbr w3a vu cv cX wss cA vu cv cdif cfn wcel wa vv cv vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab cuni wss vu cv vv cv wss vv cv cX
      wss cA vv cv cdif cfn wcel wa wi wi vu cv vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel cX cB wcel cA cX wss com cA cdom wbr w3a vv cv vx cv
      cX wss cA vx cv cdif cfn wcel wa vx cab cuni wss vu cv cX wss cA vu cv
      cdif cfn wcel wa vu cv vv cv wss vv cv cX wss cA vv cv cdif cfn wcel wa
      wi cX cB wcel cA cX wss com cA cdom wbr w3a vv cv vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab cuni wss vv cv cX wss vu cv cX wss cA vu cv cdif
      cfn wcel wa vu cv vv cv wss vv cv cX wss cA vv cv cdif cfn wcel wa wi wi
      cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab cuni cX vv cv cX cB wcel cA cX wss com cA cdom wbr w3a vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni cX cX cB wcel cA cX wss
      com cA cdom wbr w3a vy cv cX wss vy vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wral vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni cX wss
      cX cB wcel cA cX wss com cA cdom wbr w3a vy cv cX wss vy vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab cX cB wcel cA cX wss com cA cdom wbr w3a vy
      cv cX wss cA vy cv cdif cfn wcel wa vy cv cX wss vy cv vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab wcel vy cv cX wss cA vy cv cdif cfn wcel wa vy
      cv cX wss wi cX cB wcel cA cX wss com cA cdom wbr w3a vy cv cX wss cA vy
      cv cdif cfn wcel pm3.26 a1i vx cv cX wss cA vx cv cdif cfn wcel wa vy cv
      cX wss cA vy cv cdif cfn wcel wa vx vy cv vy visset vx cv vy cv wceq vx
      cv cX wss vy cv cX wss cA vx cv cdif cfn wcel cA vy cv cdif cfn wcel vx
      cv vy cv cX sseq1 vx cv vy cv wceq cA vx cv cdif cA vy cv cdif cfn vx cv
      vy cv cA difeq2 eleq1d anbi12d elab syl5ib r19.21aiv vy vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab cX unissb sylibr cX cB wcel cA cX wss com
      cA cdom wbr w3a cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX
      vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni wss cX cB wcel cA cX
      wss com cA cdom wbr w3a cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      wcel cX cX wss cA cX cdif cfn wcel wa cX cB wcel cA cX wss com cA cdom
      wbr w3a cA cX cdif cfn wcel cX cX wss cA cX wss cX cB wcel cA cX cdif cfn
      wcel com cA cdom wbr cA cX wss cA cX cdif c0 cfn cA cX wss cA cX cdif c0
      wceq cA cX ssdif0 biimpi emfin syl6eqel 3ad2ant2 cX ssid jctil cX cB wcel
      cA cX wss cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cX cX wss
      cA cX cdif cfn wcel wa wb com cA cdom wbr cA vx cv cdif cfn wcel cA cX
      cdif cfn wcel vx cX cX cB vx cv cX wceq cA vx cv cdif cA cX cdif cfn vx
      cv cX cA difeq2 eleq1d elssabg 3ad2ant1 mpbird cX vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab elssuni syl eqssd sseq2d cX cB wcel cA cX wss com
      cA cdom wbr w3a vv cv cX wss vu cv cX wss cA vu cv cdif cfn wcel wa vu cv
      vv cv wss vv cv cX wss cA vv cv cdif cfn wcel wa cX cB wcel cA cX wss com
      cA cdom wbr w3a vv cv cX wss vu cv cX wss cA vu cv cdif cfn wcel wa vu cv
      vv cv wss wa wa wa vv cv cX wss cA vv cv cdif cfn wcel cX cB wcel cA cX
      wss com cA cdom wbr w3a vv cv cX wss vu cv cX wss cA vu cv cdif cfn wcel
      wa vu cv vv cv wss wa simprl cA vu cv cdif cfn wcel cA vv cv cdif cA vu
      cv cdif wss cA vv cv cdif cfn wcel cX cB wcel cA cX wss com cA cdom wbr
      w3a vv cv cX wss vu cv cX wss cA vu cv cdif cfn wcel wa vu cv vv cv wss
      wa wa wa cA vu cv cdif cA vv cv cdif ssfi vu cv cX wss cA vu cv cdif cfn
      wcel wa vu cv vv cv wss wa cA vu cv cdif cfn wcel cX cB wcel cA cX wss
      com cA cdom wbr w3a vv cv cX wss vu cv cX wss cA vu cv cdif cfn wcel vu
      cv vv cv wss simplr ad2antll vu cv cX wss cA vu cv cdif cfn wcel wa vu cv
      vv cv wss wa cA vv cv cdif cA vu cv cdif wss cX cB wcel cA cX wss com cA
      cdom wbr w3a vv cv cX wss vu cv vv cv wss cA vv cv cdif cA vu cv cdif wss
      vu cv cX wss cA vu cv cdif cfn wcel wa vu cv vv cv cA sscon adantl
      ad2antll sylanc jca exp45 sylbid com23 vx cv cX wss cA vx cv cdif cfn
      wcel wa vu cv cX wss cA vu cv cdif cfn wcel wa vx vu cv vu visset vx cv
      vu cv wceq vx cv cX wss vu cv cX wss cA vx cv cdif cfn wcel cA vu cv cdif
      cfn wcel vx cv vu cv cX sseq1 vx cv vu cv wceq cA vx cv cdif cA vu cv
      cdif cfn vx cv vu cv cA difeq2 eleq1d anbi12d elab syl5ib 3impd vx cv cX
      wss cA vx cv cdif cfn wcel wa vv cv cX wss cA vv cv cdif cfn wcel wa vx
      vv cv vv visset vx cv vv cv wceq vx cv cX wss vv cv cX wss cA vx cv cdif
      cfn wcel cA vv cv cdif cfn wcel vx cv vv cv cX sseq1 vx cv vv cv wceq cA
      vx cv cdif cA vv cv cdif cfn vx cv vv cv cA difeq2 eleq1d anbi12d elab
      syl6ibr 19.21aivv cX cB wcel cA cX wss com cA cdom wbr w3a vu cv vv cv
      cin vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vu vv vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab cX cB wcel cA cX wss com cA cdom wbr w3a vu cv cX wss cA vu cv
      cdif cfn wcel wa vv cv cX wss cA vv cv cdif cfn wcel wa wa vu cv vv cv
      cin cX wss cA vu cv vv cv cin cdif cfn wcel wa vu cv vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab wcel vv cv vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wcel wa vu cv vv cv cin vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab wcel vu cv cX wss cA vu cv cdif cfn wcel wa vv cv cX wss cA vv cv
      cdif cfn wcel wa wa vu cv vv cv cin cX wss cA vu cv vv cv cin cdif cfn
      wcel wa wi cX cB wcel cA cX wss com cA cdom wbr w3a vu cv cX wss cA vu cv
      cdif cfn wcel wa vv cv cX wss cA vv cv cdif cfn wcel wa wa vu cv vv cv
      cin cX wss cA vu cv vv cv cin cdif cfn wcel vu cv cX wss vu cv vv cv cin
      cX wss cA vu cv cdif cfn wcel vv cv cX wss cA vv cv cdif cfn wcel wa vu
      cv vv cv cX ssinss1 ad2antrr cA vu cv cdif cfn wcel cA vv cv cdif cfn
      wcel cA vu cv vv cv cin cdif cfn wcel vu cv cX wss vv cv cX wss cA vu cv
      cdif cfn wcel cA vv cv cdif cfn wcel wa cA vu cv cdif cA vv cv cdif cun
      cfn cA vu cv vv cv cin cdif cA vu cv cdif cA vv cv cdif unfi cA vu cv vv
      cv difindi syl5eqel ad2ant2l jca a1i vu cv vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel vu cv cX wss cA vu cv cdif cfn wcel wa vv cv vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab wcel vv cv cX wss cA vv cv cdif cfn
      wcel wa vx cv cX wss cA vx cv cdif cfn wcel wa vu cv cX wss cA vu cv cdif
      cfn wcel wa vx vu cv vu visset vx cv vu cv wceq vx cv cX wss vu cv cX wss
      cA vx cv cdif cfn wcel cA vu cv cdif cfn wcel vx cv vu cv cX sseq1 vx cv
      vu cv wceq cA vx cv cdif cA vu cv cdif cfn vx cv vu cv cA difeq2 eleq1d
      anbi12d elab vx cv cX wss cA vx cv cdif cfn wcel wa vv cv cX wss cA vv cv
      cdif cfn wcel wa vx vv cv vv visset vx cv vv cv wceq vx cv cX wss vv cv
      cX wss cA vx cv cdif cfn wcel cA vv cv cdif cfn wcel vx cv vv cv cX sseq1
      vx cv vv cv wceq cA vx cv cdif cA vv cv cdif cfn vx cv vv cv cA difeq2
      eleq1d anbi12d elab anbi12i vx cv cX wss cA vx cv cdif cfn wcel wa vu cv
      vv cv cin cX wss cA vu cv vv cv cin cdif cfn wcel wa vx vu cv vv cv cin
      vu cv vv cv vu visset inex1 vx cv vu cv vv cv cin wceq vx cv cX wss vu cv
      vv cv cin cX wss cA vx cv cdif cfn wcel cA vu cv vv cv cin cdif cfn wcel
      vx cv vu cv vv cv cin cX sseq1 vx cv vu cv vv cv cin wceq cA vx cv cdif
      cA vu cv vv cv cin cdif cfn vx cv vu cv vv cv cin cA difeq2 eleq1d
      anbi12d elab 3imtr4g r19.21aivv 3jca cX cB wcel cA cX wss vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab cfil wcel c0 vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel wn vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni
      vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wa vu cv vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab wcel vv cv vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab cuni wss vu cv vv cv wss w3a vv cv vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab wcel wi vv wal vu wal vu cv vv cv cin vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab wcel vv vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab wral vu vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      wral w3a wb com cA cdom wbr cX cB wcel vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab cvv wcel vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      cfil wcel c0 vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel wn vx cv
      cX wss cA vx cv cdif cfn wcel wa vx cab cuni vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab wcel wa vu cv vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab wcel vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni wss
      vu cv vv cv wss w3a vv cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      wcel wi vv wal vu wal vu cv vv cv cin vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wcel vv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wral vu
      vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wral w3a wb cA vx cv cdif
      cfn wcel vx cX cB abssexg vu vv cvv vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab cuni eqid isfil syl 3ad2ant1 mpbird cX
      cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab cfil wcel wa cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab vf cv wss wa vf cufil wrex cX vf cv cuni wceq cA vf cv
      wcel vf cv cint c0 wceq w3a vf cufil wrex cX cB wcel cA cX wss com cA
      cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel wa
      vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni vf cv cuni wceq vx cv
      cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa vf cufil wrex cX vf
      cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa
      vf cufil wrex vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni vf cv cuni wceq vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa vf cufil wrex cX cB
      wcel cA cX wss com cA cdom wbr w3a vf vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab cuni eqid filssufil adantl cX cB wcel cA
      cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      cuni vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv
      wss wa vf cufil wrex cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab vf cv wss wa vf cufil wrex wb vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab cfil wcel cX cB wcel cA cX wss com cA cdom wbr w3a vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni vf cv cuni wceq vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa cX vf cv cuni wceq vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa vf cufil cX cB
      wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab cuni vf cv cuni wceq cX vf cv cuni wceq vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab vf cv wss cX cB wcel cA cX wss com cA cdom wbr w3a vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab cuni cX vf cv cuni cX cB wcel
      cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab cuni cX cX cB wcel cA cX wss com cA cdom wbr w3a vy cv cX wss vy vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab wral vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab cuni cX wss cX cB wcel cA cX wss com cA cdom wbr
      w3a vy cv cX wss vy vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cX cB
      wcel cA cX wss com cA cdom wbr w3a vy cv cX wss cA vy cv cdif cfn wcel wa
      vy cv cX wss vy cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vy
      cv cX wss cA vy cv cdif cfn wcel wa vy cv cX wss wi cX cB wcel cA cX wss
      com cA cdom wbr w3a vy cv cX wss cA vy cv cdif cfn wcel pm3.26 a1i vx cv
      cX wss cA vx cv cdif cfn wcel wa vy cv cX wss cA vy cv cdif cfn wcel wa
      vx vy cv vy visset vx cv vy cv wceq vx cv cX wss vy cv cX wss cA vx cv
      cdif cfn wcel cA vy cv cdif cfn wcel vx cv vy cv cX sseq1 vx cv vy cv
      wceq cA vx cv cdif cA vy cv cdif cfn vx cv vy cv cA difeq2 eleq1d anbi12d
      elab syl5ib r19.21aiv vy vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cX
      unissb sylibr cX cB wcel cA cX wss com cA cdom wbr w3a cX vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab wcel cX vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab cuni wss cX cB wcel cA cX wss com cA cdom wbr w3a cX vx cv cX
      wss cA vx cv cdif cfn wcel wa vx cab wcel cX cX wss cA cX cdif cfn wcel
      wa cX cB wcel cA cX wss com cA cdom wbr w3a cA cX cdif cfn wcel cX cX wss
      cA cX wss cX cB wcel cA cX cdif cfn wcel com cA cdom wbr cA cX wss cA cX
      cdif c0 cfn cA cX wss cA cX cdif c0 wceq cA cX ssdif0 biimpi emfin
      syl6eqel 3ad2ant2 cX ssid jctil cX cB wcel cA cX wss cX vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab wcel cX cX wss cA cX cdif cfn wcel wa wb
      com cA cdom wbr cA vx cv cdif cfn wcel cA cX cdif cfn wcel vx cX cX cB vx
      cv cX wceq cA vx cv cdif cA cX cdif cfn vx cv cX cA difeq2 eleq1d elssabg
      3ad2ant1 mpbird cX vx cv cX wss cA vx cv cdif cfn wcel wa vx cab elssuni
      syl eqssd eqeq1d anbi1d rexbidv adantr mpbid cX cB wcel cA cX wss com cA
      cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel wa
      cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv
      wss wa cX vf cv cuni wceq cA vf cv wcel vf cv cint c0 wceq w3a vf cufil
      cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab cfil wcel vf cv cufil wcel cX vf cv cuni wceq vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab vf cv wss wa cX vf cv cuni wceq cA vf cv
      wcel vf cv cint c0 wceq w3a wi cX cB wcel cA cX wss com cA cdom wbr w3a
      vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil wcel
      wa wa cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf
      cv wss wa cX vf cv cuni wceq cA vf cv wcel vf cv cint c0 wceq cX vf cv
      cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa cX
      vf cv cuni wceq wi cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil wcel wa wa cX vf
      cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss
      pm3.26 a1i cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab cfil wcel vf cv cufil wcel wa wa cX vf cv cuni
      wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa cA vf cv
      wcel cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab cfil wcel vf cv cufil wcel wa wa cX vf cv cuni wceq vx
      cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa wa vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab vf cv cA cX cB wcel cA cX wss com cA
      cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel vf
      cv cufil wcel wa wa cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab vf cv wss simprr cX cB wcel cA cX wss com cA cdom wbr w3a
      cA vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil wcel wa cX vf cv cuni
      wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa cX cB
      wcel cA cX wss cA vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel com
      cA cdom wbr cX cB wcel cA cX wss wa cA vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel cA cX wss cA cA cdif cfn wcel wa cX cB wcel cA cX wss
      wa cA cX wss cA cA cdif cfn wcel cX cB wcel cA cX wss pm3.27 cA cA cdif
      c0 cfn cA difid emfin eqeltri jctir cX cB wcel cA cX wss wa cA cvv wcel
      cA vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel cA cX wss cA cA
      cdif cfn wcel wa wb cA cX wss cX cB wcel cA cvv wcel cA cX cB ssexg
      ancoms vx cv cX wss cA vx cv cdif cfn wcel wa cA cX wss cA cA cdif cfn
      wcel wa vx cA cvv vx cv cA wceq vx cv cX wss cA cX wss cA vx cv cdif cfn
      wcel cA cA cdif cfn wcel vx cv cA cX sseq1 vx cv cA wceq cA vx cv cdif cA
      cA cdif cfn vx cv cA cA difeq2 eleq1d anbi12d elabg syl mpbird 3adant3
      ad2antrr sseldd ex cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil wcel wa wa cX vf
      cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa
      vf cv cint c0 wss vf cv cint c0 wceq cX cB wcel cA cX wss com cA cdom wbr
      w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil
      wcel wa wa cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab vf cv wss wa vf cv cint c0 wss cX cB wcel cA cX wss com cA cdom wbr
      w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil
      wcel wa wa cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab vf cv wss wa wa vf cv cint vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab cint c0 vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss vf cv
      cint vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cint wss cX cB wcel cA
      cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      cfil wcel vf cv cufil wcel wa wa cX vf cv cuni wceq vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab vf cv intss ad2antll cX cB wcel cA cX wss com cA
      cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cfil wcel vf
      cv cufil wcel wa wa cX vf cv cuni wceq vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab vf cv wss wa wa vy cv vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab cint wcel wn vy wal vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab cint c0 wceq cX cB wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab cfil wcel vf cv cufil wcel wa wa cX vf cv
      cuni wceq vx cv cX wss cA vx cv cdif cfn wcel wa vx cab vf cv wss wa wa
      vy cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cint wcel wn vy cX cB
      wcel cA cX wss com cA cdom wbr w3a vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab cfil wcel vf cv cufil wcel wa wa cX vf cv cuni wceq vx cv cX wss
      cA vx cv cdif cfn wcel wa vx cab vf cv wss wa wa vz cv vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab wcel vy cv vz cv wcel wn wa vz wex vy cv vx cv
      cX wss cA vx cv cdif cfn wcel wa vx cab cint wcel wn cX cB wcel cA cX wss
      com cA cdom wbr w3a vz cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab
      wcel vy cv vz cv wcel wn wa vz wex vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab cfil wcel vf cv cufil wcel wa cX vf cv cuni wceq vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab vf cv wss wa cA vy cv csn cdif cvv wcel cA
      vy cv csn cdif vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vy cv
      cA vy cv csn cdif wcel wn wa vz cv vx cv cX wss cA vx cv cdif cfn wcel wa
      vx cab wcel vy cv vz cv wcel wn wa vz wex cX cB wcel cA cX wss com cA
      cdom wbr w3a vz cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vy
      cv vz cv wcel wn wa cA vy cv csn cdif vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wcel vy cv cA vy cv csn cdif wcel wn wa vz cA vy cv csn cdif
      cvv vz cv cA vy cv csn cdif wceq vz cv vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel cA vy cv csn cdif vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wcel vy cv vz cv wcel wn vy cv cA vy cv csn cdif wcel wn vz cv
      cA vy cv csn cdif vx cv cX wss cA vx cv cdif cfn wcel wa vx cab eleq1 vz
      cv cA vy cv csn cdif wceq vy cv vz cv wcel vy cv cA vy cv csn cdif wcel
      vz cv cA vy cv csn cdif vy cv eleq2 notbid anbi12d cla4egv cX cB wcel cA
      cX wss cA vy cv csn cdif cvv wcel com cA cdom wbr cX cB wcel cA cX wss wa
      cA cvv wcel cA vy cv csn cdif cvv wcel cA cX wss cX cB wcel cA cvv wcel
      cA cX cB ssexg ancoms cA vy cv csn cvv difexg syl 3adant3 cX cB wcel cA
      cX wss com cA cdom wbr w3a cA vy cv csn cdif vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab wcel vy cv cA vy cv csn cdif wcel wn cX cB wcel cA cX
      wss com cA cdom wbr w3a cA vy cv csn cdif vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel cA vy cv csn cdif cX wss cA cA vy cv csn cdif cdif
      cfn wcel wa cX cB wcel cA cX wss com cA cdom wbr w3a cA vy cv csn cdif cX
      wss cA cA vy cv csn cdif cdif cfn wcel cA cX wss cX cB wcel cA vy cv csn
      cdif cX wss com cA cdom wbr cA cX vy cv csn ssdifss 3ad2ant2 vy cv csn
      cfn wcel cA cA vy cv csn cdif cdif vy cv csn wss cA cA vy cv csn cdif
      cdif cfn wcel vy cv snfi vx cA cA vy cv csn cdif cdif vy cv csn vx cv cA
      cA vy cv csn cdif cdif wcel vx cv cA wcel vx cv cA wcel vx cv vy cv csn
      wcel wi wa vx cv vy cv csn wcel vx cv cA cA vy cv csn cdif cdif wcel vx
      cv cA wcel vx cv cA vy cv csn cdif wcel wn wa vx cv cA wcel vx cv cA wcel
      vx cv vy cv csn wcel wi wa vx cv cA cA vy cv csn cdif eldif vx cv cA vy
      cv csn cdif wcel wn vx cv cA wcel vx cv vy cv csn wcel wi vx cv cA wcel
      vx cv cA vy cv csn cdif wcel wn vx cv cA wcel vx cv vy cv csn wcel wn wa
      wn vx cv cA wcel vx cv vy cv csn wcel wi vx cv cA vy cv csn cdif wcel vx
      cv cA wcel vx cv vy cv csn wcel wn wa vx cv cA vy cv csn eldif notbii vx
      cv cA wcel vx cv vy cv csn wcel iman bitr4i anbi2i bitri vx cv cA wcel vx
      cv vy cv csn wcel pm3.35 sylbi ssriv vy cv csn cA cA vy cv csn cdif cdif
      ssfi mp2an jctir cX cB wcel cA cX wss cA vy cv csn cdif vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab wcel cA vy cv csn cdif cX wss cA cA vy cv
      csn cdif cdif cfn wcel wa wb com cA cdom wbr cX cB wcel cA cX wss wa cA
      cvv wcel cA vy cv csn cdif cvv wcel cA vy cv csn cdif vx cv cX wss cA vx
      cv cdif cfn wcel wa vx cab wcel cA vy cv csn cdif cX wss cA cA vy cv csn
      cdif cdif cfn wcel wa wb cA cX wss cX cB wcel cA cvv wcel cA cX cB ssexg
      ancoms cA vy cv csn cvv difexg vx cv cX wss cA vx cv cdif cfn wcel wa cA
      vy cv csn cdif cX wss cA cA vy cv csn cdif cdif cfn wcel wa vx cA vy cv
      csn cdif cvv vx cv cA vy cv csn cdif wceq vx cv cX wss cA vy cv csn cdif
      cX wss cA vx cv cdif cfn wcel cA cA vy cv csn cdif cdif cfn wcel vx cv cA
      vy cv csn cdif cX sseq1 vx cv cA vy cv csn cdif wceq cA vx cv cdif cA cA
      vy cv csn cdif cdif cfn vx cv cA vy cv csn cdif cA difeq2 eleq1d anbi12d
      elabg 3syl 3adant3 mpbird vy cv vy cv csn wcel vy cv cA vy cv csn cdif
      wcel wn vy cv vy visset snid vy cv vy cv csn cA elndif ax-mp jctir sylc
      ad2antrr vz cv vx cv cX wss cA vx cv cdif cfn wcel wa vx cab wcel vy cv
      vz cv wcel wn wa vz wex vz cv vx cv cX wss cA vx cv cdif cfn wcel wa vx
      cab wcel vy cv vz cv wcel wi vz wal wn vy cv vx cv cX wss cA vx cv cdif
      cfn wcel wa vx cab cint wcel wn vz cv vx cv cX wss cA vx cv cdif cfn wcel
      wa vx cab wcel vy cv vz cv wcel vz exanali vy cv vx cv cX wss cA vx cv
      cdif cfn wcel wa vx cab cint wcel vz cv vx cv cX wss cA vx cv cdif cfn
      wcel wa vx cab wcel vy cv vz cv wcel wi vz wal vz vy cv vx cv cX wss cA
      vx cv cdif cfn wcel wa vx cab vy visset elint notbii bitr4i sylib
      19.21aiv vy vx cv cX wss cA vx cv cdif cfn wcel wa vx cab cint eq0 sylibr
      sseqtrd ex vf cv cint ss0 syl6 3jcad expr r19.22dv mpd mpdan $.
      $( [6-Dec-2009] $) $( [6-Dec-2009] $)
  $}

  ${
    $d f u v x y z A $. $d f u v x y z F $. $d f u v x y z X $.
    $( Any infinite set has an ultrafilter on it whose elements are of the same
       cardinality as the set. Any such ultrafilter is necessarily free. $)
    ufilen $p |- ( ( X e. A /\ om ~<_ X ) -> E. f e. UFil ( X = U. f /\ A. x e.
    f x ~~ X ) ) $=
      cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil
      wcel wa cX vf cv cuni wceq vx cv cX cen wbr vx vf cv wral wa vf cufil
      wrex cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cfil wcel cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX cX cA wcel com cX cdom wbr wa vz cv cX wss vz
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wral vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab cuni cX wss vz cv cX wss vz vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab wral cX cA wcel com cX cdom wbr wa vz cv
      cX wss vz vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vz cv vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab wcel vz cv cX wss cX vz cv cdif
      cX csdm wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vz cv cX wss cX vz
      cv cdif cX csdm wbr wa vy vz cv vz visset vy cv vz cv wceq vy cv cX wss
      vz cv cX wss cX vy cv cdif cX csdm wbr cX vz cv cdif cX csdm wbr vy cv vz
      cv cX sseq1 vy cv vz cv wceq cX vy cv cdif cX vz cv cdif cX csdm vy cv vz
      cv cX difeq2 breq1d anbi12d elab pm3.26bi rgen a1i vz vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab cX unissb sylibr cX cA wcel com cX cdom wbr
      wa cX vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab cuni wss cX cA wcel com cX cdom
      wbr wa cX vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX cX wss
      cX cX cdif cX csdm wbr wa cX cA wcel com cX cdom wbr wa cX cX cdif cX
      csdm wbr cX cX wss cX cA wcel cX cX cdif com csdm wbr com cX cdom wbr wa
      cX cX cdif cX csdm wbr cX cA wcel com cX cdom wbr wa cX cX cdif com cX cA
      sdomdomtr cX cA wcel com cX cdom wbr pm3.26 com cX cdom wbr cX cX cdif
      com csdm wbr com cX cdom wbr wa cX cA wcel com cX cdom wbr cX cX cdif com
      csdm wbr cX cX cdif c0 com csdm cX difid c0 com wcel c0 com csdm wbr
      peano1 c0 nnsdom ax-mp eqbrtri jctl adantl sylc cX ssid jctil cX cA wcel
      cX vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX cX wss cX cX
      cdif cX csdm wbr wa wb com cX cdom wbr cX vy cv cdif cX csdm wbr cX cX
      cdif cX csdm wbr vy cX cX cA vy cv cX wceq cX vy cv cdif cX cX cdif cX
      csdm vy cv cX cX difeq2 breq1d elssabg adantr mpbird cX vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab elssuni syl eqssd cX cA wcel com cX cdom
      wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv
      cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel cX cA wcel com cX
      cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      w3a vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel c0 vy cv
      cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel wn vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab wcel wa vu cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      wcel vv cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni wss vu
      cv vv cv wss w3a vv cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      wcel wi vv wal vu wal vu cv vv cv cin vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab wcel vv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      wral vu vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wral w3a cX cA
      wcel com cX cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cuni cX wceq w3a c0 vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel
      wn vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab wcel wa vu cv vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab wcel vv cv vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cuni wss vu cv vv cv wss w3a vv cv vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab wcel wi vv wal vu wal vu cv vv cv cin vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab wcel vv vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wral vu vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab wral cX cA wcel com cX cdom wbr vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab cuni cX wceq w3a c0 vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab wcel wn vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX cA wcel com cX
      cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      w3a c0 cX wss cX c0 cdif cX csdm wbr wa wn c0 vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab wcel wn c0 cX wss cX c0 cdif cX csdm wbr wa wn cX
      cA wcel com cX cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cuni cX wceq w3a cX c0 cdif cX csdm wbr c0 cX wss cX c0 cdif cX csdm wbr
      cX cX csdm wbr cX sdomirr cX c0 cdif cX cX csdm cX dif0 breq1i mtbir
      intnan a1i c0 vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel c0 cX
      wss cX c0 cdif cX csdm wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa
      c0 cX wss cX c0 cdif cX csdm wbr wa vy c0 0ex vy cv c0 wceq vy cv cX wss
      c0 cX wss cX vy cv cdif cX csdm wbr cX c0 cdif cX csdm wbr vy cv c0 cX
      sseq1 vy cv c0 wceq cX vy cv cdif cX c0 cdif cX csdm vy cv c0 cX difeq2
      breq1d anbi12d elab notbii sylibr cX cA wcel com cX cdom wbr vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab wcel vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab wcel cX vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab wcel cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni cX vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab eleq1 cX cA wcel com cX cdom wbr wa cX vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab wcel cX cX wss cX cX cdif cX csdm wbr wa cX cA
      wcel com cX cdom wbr wa cX cX cdif cX csdm wbr cX cX wss cX cA wcel cX cX
      cdif com csdm wbr com cX cdom wbr wa cX cX cdif cX csdm wbr cX cA wcel
      com cX cdom wbr wa cX cX cdif com cX cA sdomdomtr cX cA wcel com cX cdom
      wbr pm3.26 com cX cdom wbr cX cX cdif com csdm wbr com cX cdom wbr wa cX
      cA wcel com cX cdom wbr cX cX cdif com csdm wbr cX cX cdif c0 com csdm cX
      difid c0 com wcel c0 com csdm wbr peano1 c0 nnsdom ax-mp eqbrtri jctl
      adantl sylc cX ssid jctil cX cA wcel cX vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wcel cX cX wss cX cX cdif cX csdm wbr wa wb com cX
      cdom wbr cX vy cv cdif cX csdm wbr cX cX cdif cX csdm wbr vy cX cX cA vy
      cv cX wceq cX vy cv cdif cX cX cdif cX csdm vy cv cX cX difeq2 breq1d
      elssabg adantr mpbird syl5cbir 3impia jca cX cA wcel com cX cdom wbr vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq w3a vu cv vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel vv cv vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab cuni wss vu cv vv cv wss w3a vv cv vy cv
      cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel wi vu vv cX cA wcel com
      cX cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      w3a vu cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel vv cv vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni wss vu cv vv cv wss
      w3a vv cv cX wss cX vv cv cdif cX csdm wbr wa vv cv vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab wcel cX cA wcel com cX cdom wbr vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq w3a vu cv vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab wcel vv cv vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni wss vu cv vv cv wss vv cv cX wss cX vv cv cdif
      cX csdm wbr wa cX cA wcel com cX cdom wbr vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX wceq w3a vu cv cX wss cX vu cv cdif cX csdm
      wbr wa vv cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni wss vu
      cv vv cv wss vv cv cX wss cX vv cv cdif cX csdm wbr wa wi wi vu cv vy cv
      cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX cA wcel com cX cdom
      wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq w3a vv
      cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni wss vu cv cX wss
      cX vu cv cdif cX csdm wbr wa vu cv vv cv wss vv cv cX wss cX vv cv cdif
      cX csdm wbr wa wi cX cA wcel com cX cdom wbr vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni cX wceq w3a vv cv vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni wss vv cv cX wss vu cv cX wss cX vu cv cdif cX
      csdm wbr wa vu cv vv cv wss vv cv cX wss cX vv cv cdif cX csdm wbr wa wi
      wi vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq cX cA
      wcel vv cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni wss vv
      cv cX wss wb com cX cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab cuni cX vv cv sseq2 3ad2ant3 cX cA wcel com cX cdom wbr vv cv cX wss
      vu cv cX wss cX vu cv cdif cX csdm wbr wa vu cv vv cv wss vv cv cX wss cX
      vv cv cdif cX csdm wbr wa wi wi wi vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cuni cX wceq cX cA wcel vv cv cX wss vu cv cX wss cX vu cv cdif
      cX csdm wbr wa vu cv vv cv wss vv cv cX wss cX vv cv cdif cX csdm wbr wa
      cX cA wcel vv cv cX wss wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vu
      cv vv cv wss wa wa vv cv cX wss cX vv cv cdif cX csdm wbr cX cA wcel vv
      cv cX wss vu cv cX wss cX vu cv cdif cX csdm wbr wa vu cv vv cv wss wa
      simplr cX cA wcel vv cv cX wss wa vu cv cX wss cX vu cv cdif cX csdm wbr
      wa vu cv vv cv wss cX vv cv cdif cX csdm wbr cX cA wcel vu cv cX wss cX
      vu cv cdif cX csdm wbr wa vu cv vv cv wss cX vv cv cdif cX csdm wbr wi wi
      vv cv cX wss cX cA wcel cX vu cv cdif cX csdm wbr vu cv vv cv wss cX vv
      cv cdif cX csdm wbr wi vu cv cX wss cX cA wcel cX vu cv cdif cX csdm wbr
      vu cv vv cv wss cX vv cv cdif cX csdm wbr cX vv cv cdif cX vu cv cdif
      cdom wbr cX vu cv cdif cX csdm wbr cX vv cv cdif cX csdm wbr cX cA wcel
      cX vu cv cdif cX csdm wbr vu cv vv cv wss w3a cX vv cv cdif cX vu cv cdif
      cX domsdomtr cX cA wcel vu cv vv cv wss cX vv cv cdif cX vu cv cdif cdom
      wbr cX vu cv cdif cX csdm wbr cX cA wcel vu cv vv cv wss cX vv cv cdif cX
      vu cv cdif cdom wbr cX cA wcel cX vv cv cdif cX vu cv cdif wss cX vv cv
      cdif cX vu cv cdif cdom wbr vu cv vv cv wss cX cA wcel cX vv cv cdif cvv
      wcel cX vv cv cdif cX vu cv cdif wss cX vv cv cdif cX vu cv cdif cdom wbr
      wi cX vv cv cA difexg cX vv cv cdif cX vu cv cdif cvv ssdomg syl vu cv vv
      cv cX sscon syl5 imp 3adant2 cX cA wcel cX vu cv cdif cX csdm wbr vu cv
      vv cv wss 3simp2 sylanc 3exp adantld adantr imp32 jca exp43 3ad2ant1
      sylbid com23 vy cv cX wss cX vy cv cdif cX csdm wbr wa vu cv cX wss cX vu
      cv cdif cX csdm wbr wa vy vu cv vu visset vy cv vu cv wceq vy cv cX wss
      vu cv cX wss cX vy cv cdif cX csdm wbr cX vu cv cdif cX csdm wbr vy cv vu
      cv cX sseq1 vy cv vu cv wceq cX vy cv cdif cX vu cv cdif cX csdm vy cv vu
      cv cX difeq2 breq1d anbi12d elab syl5ib 3impd vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa vy vv cv vv
      visset vy cv vv cv wceq vy cv cX wss vv cv cX wss cX vy cv cdif cX csdm
      wbr cX vv cv cdif cX csdm wbr vy cv vv cv cX sseq1 vy cv vv cv wceq cX vy
      cv cdif cX vv cv cdif cX csdm vy cv vv cv cX difeq2 breq1d anbi12d elab
      syl6ibr 19.21aivv cX cA wcel com cX cdom wbr vu cv vv cv cin vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab wcel vv vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wral vu vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab wral vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq cX
      cA wcel com cX cdom wbr wa vu cv vv cv cin vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wcel vu vv vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cX cA wcel com cX
      cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv
      cv cdif cX csdm wbr wa wa vu cv vv cv cin cX wss cX vu cv vv cv cin cdif
      cX csdm wbr wa vu cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      wcel vv cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel wa vu cv
      vv cv cin vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX cA
      wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv
      cX wss cX vv cv cdif cX csdm wbr wa wa vu cv vv cv cin cX wss cX vu cv vv
      cv cin cdif cX csdm wbr wa cX cA wcel com cX cdom wbr wa vu cv cX wss cX
      vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa
      vu cv vv cv cin cX wss cX vu cv vv cv cin cdif cX csdm wbr vu cv cX wss
      cX vu cv cdif cX csdm wbr wa vu cv vv cv cin cX wss cX cA wcel com cX
      cdom wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa vu cv cX wss vu cv
      vv cv cin cX wss cX vu cv cdif cX csdm wbr vu cv vv cv cX ssinss1 adantr
      ad2antrl cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm
      wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX
      vv cv cdif cun cX cX vu cv vv cv cin cdif csdm cX cA wcel com cX cdom wbr
      wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif
      cX csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif cdom wbr cX vv cv cdif
      cX vu cv cdif cdom wbr wo cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX
      cA wcel cX vu cv cdif cX vv cv cdif cdom wbr cX vv cv cdif cX vu cv cdif
      cdom wbr wo com cX cdom wbr vu cv cX wss cX vu cv cdif cX csdm wbr wa vv
      cv cX wss cX vv cv cdif cX csdm wbr wa wa cX vu cv cdif cvv wcel cX vv cv
      cdif cvv wcel cX vu cv cdif cX vv cv cdif cdom wbr cX vv cv cdif cX vu cv
      cdif cdom wbr wo cX cA wcel cX vu cv cdif cX vv cv cdif cvv cvv entri3 cX
      vu cv cA difexg cX vv cv cA difexg sylanc ad2antrr cX cA wcel com cX cdom
      wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv
      cdif cX csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif cdom wbr cX vu cv
      cdif cX vv cv cdif cun cX csdm wbr cX vv cv cdif cX vu cv cdif cdom wbr
      cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa
      vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX vv cv
      cdif cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX cA wcel com
      cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX
      vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif cdom wbr wa
      com cX vv cv cdif cdom wbr cX vv cv cdif com csdm wbr wo cX vu cv cdif cX
      vv cv cdif cun cX csdm wbr cX cA wcel com cX cdom wbr wa com cX vv cv
      cdif cdom wbr cX vv cv cdif com csdm wbr wo vu cv cX wss cX vu cv cdif cX
      csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa cX vu cv cdif cX
      vv cv cdif cdom wbr cX cA wcel com cX vv cv cdif cdom wbr cX vv cv cdif
      com csdm wbr wo com cX cdom wbr cX cA wcel cX vv cv cdif cvv wcel com cX
      vv cv cdif cdom wbr cX vv cv cdif com csdm wbr wo cX vv cv cA difexg com
      cvv wcel cX vv cv cdif cvv wcel com cX vv cv cdif cdom wbr cX vv cv cdif
      com csdm wbr wo omex com cX vv cv cdif cvv cvv entri2 mpan syl adantr
      ad2antrr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm
      wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX
      vv cv cdif cdom wbr wa com cX vv cv cdif cdom wbr cX vu cv cdif cX vv cv
      cdif cun cX csdm wbr cX vv cv cdif com csdm wbr cX cA wcel com cX cdom
      wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv
      cdif cX csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif cdom wbr com cX vv
      cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX vu cv
      cdif cX vv cv cdif cun cX vv cv cdif cen wbr cX vv cv cdif cX csdm wbr cX
      vu cv cdif cX vv cv cdif cun cX csdm wbr cX cA wcel com cX cdom wbr wa vu
      cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm
      wbr wa wa wa cX vu cv cdif cX vv cv cdif cdom wbr com cX vv cv cdif cdom
      wbr wa wa cX vu cv cdif cX vv cv cdif cun cX vv cv cdif cX ensdomtr cX cA
      wcel com cX cdom wbr wa cX vu cv cdif cX vv cv cdif cdom wbr com cX vv cv
      cdif cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX vv cv cdif cen wbr vu
      cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm
      wbr wa wa cX cA wcel cX vu cv cdif cX vv cv cdif cdom wbr com cX vv cv
      cdif cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX vv cv cdif cen wbr
      com cX cdom wbr cX cA wcel cX vu cv cdif cX vv cv cdif cdom wbr com cX vv
      cv cdif cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX vv cv cdif cen wbr
      vx cv vu cv cdif vx cv vv cv cdif cdom wbr com vx cv vv cv cdif cdom wbr
      wa vx cv vu cv cdif vx cv vv cv cdif cun vx cv vv cv cdif cen wbr wi cX
      vu cv cdif cX vv cv cdif cdom wbr com cX vv cv cdif cdom wbr wa cX vu cv
      cdif cX vv cv cdif cun cX vv cv cdif cen wbr wi vx cX cA vx cv cX wceq vx
      cv vu cv cdif vx cv vv cv cdif cdom wbr com vx cv vv cv cdif cdom wbr wa
      cX vu cv cdif cX vv cv cdif cdom wbr com cX vv cv cdif cdom wbr wa vx cv
      vu cv cdif vx cv vv cv cdif cun vx cv vv cv cdif cen wbr cX vu cv cdif cX
      vv cv cdif cun cX vv cv cdif cen wbr vx cv cX wceq vx cv vu cv cdif vx cv
      vv cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cdom wbr com vx cv vv cv
      cdif cdom wbr com cX vv cv cdif cdom wbr vx cv cX wceq vx cv vu cv cdif
      cX vu cv cdif vx cv vv cv cdif cX vv cv cdif cdom vx cv cX vu cv difeq1
      vx cv cX vv cv difeq1 breq12d vx cv cX wceq vx cv vv cv cdif cX vv cv
      cdif com cdom vx cv cX vv cv difeq1 breq2d anbi12d vx cv cX wceq vx cv vu
      cv cdif vx cv vv cv cdif cun cX vu cv cdif cX vv cv cdif cun vx cv vv cv
      cdif cX vv cv cdif cen vx cv cX wceq vx cv vu cv cdif cX vu cv cdif vx cv
      vv cv cdif cX vv cv cdif vx cv cX vu cv difeq1 vx cv cX vv cv difeq1
      uneq12d vx cv cX vv cv difeq1 breq12d imbi12d vx cv vu cv cdif vx cv vv
      cv cdif cdom wbr com vx cv vv cv cdif cdom wbr wa vx cv vv cv cdif vx cv
      vu cv cdif cun vx cv vv cv cdif vx cv vu cv cdif vx cv vv cv cdif cun cen
      com vx cv vv cv cdif cdom wbr vx cv vu cv cdif vx cv vv cv cdif cdom wbr
      vx cv vv cv cdif vx cv vu cv cdif cun vx cv vv cv cdif cen wbr vx cv vv
      cv cdif vx cv vu cv cdif vx cv cvv wcel vx cv vv cv cdif cvv wcel vx
      visset vx cv vv cv cvv difexg ax-mp vx cv cvv wcel vx cv vu cv cdif cvv
      wcel vx visset vx cv vu cv cvv difexg ax-mp infunabs ancoms vx cv vu cv
      cdif vx cv vv cv cdif uncom syl5eqbr vtoclg imp adantlr adantlr vu cv cX
      wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr
      wa wa cX vv cv cdif cX csdm wbr cX cA wcel com cX cdom wbr wa cX vu cv
      cdif cX vv cv cdif cdom wbr com cX vv cv cdif cdom wbr wa vu cv cX wss cX
      vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr simprr
      ad2antlr sylanc expr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv
      cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu
      cv cdif cX vv cv cdif cdom wbr wa cX vv cv cdif cfn wcel cX vu cv cdif cX
      vv cv cdif cun cX csdm wbr cX vv cv cdif com csdm wbr cX cA wcel com cX
      cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv
      cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif cdom wbr cX vv
      cv cdif cfn wcel cX vu cv cdif cX vv cv cdif cun cX csdm wbr wi cX cA
      wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv
      cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cfn wcel cX vu cv
      cdif cX vv cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr
      cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa
      vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cfn wcel cX
      vu cv cdif cX vv cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm
      wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr
      wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cfn wcel
      cX vu cv cdif cX vv cv cdif cdom wbr wa cX vu cv cdif cfn wcel cX vu cv
      cdif cX vv cv cdif cun cX csdm wbr cX vv cv cdif cX vu cv cdif domfi cX
      cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv
      cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cfn wcel cX vu
      cv cdif cfn wcel cX vu cv cdif cX vv cv cdif cun cX csdm wbr wi cX vu cv
      cdif cX vv cv cdif cdom wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX
      vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa
      cX vu cv cdif cfn wcel cX vv cv cdif cfn wcel cX vu cv cdif cX vv cv cdif
      cun cX csdm wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif
      cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv
      cdif cfn wcel cX vv cv cdif cfn wcel cX vu cv cdif cX vv cv cdif cun cX
      csdm wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm
      wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX
      vv cv cdif cun cfn wcel cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX vu
      cv cdif cfn wcel cX vv cv cdif cfn wcel wa cX cA wcel com cX cdom wbr wa
      vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX
      csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif cun com csdm wbr cX vu cv
      cdif cX vv cv cdif cun cX csdm wbr cX vu cv cdif cX vv cv cdif cun cfn
      wcel cX cA wcel com cX cdom wbr wa cX vu cv cdif cX vv cv cdif cun com
      csdm wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr wi vu cv cX wss cX
      vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa cX
      cA wcel com cX cdom wbr cX vu cv cdif cX vv cv cdif cun com csdm wbr cX
      vu cv cdif cX vv cv cdif cun cX csdm wbr wi cX cA wcel cX vu cv cdif cX
      vv cv cdif cun com csdm wbr com cX cdom wbr cX vu cv cdif cX vv cv cdif
      cun cX csdm wbr cX cA wcel cX vu cv cdif cX vv cv cdif cun com csdm wbr
      com cX cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX vu cv cdif
      cX vv cv cdif cun com cX cA sdomdomtr exp3a com23 imp adantr cX vu cv
      cdif cX vv cv cdif cun isfinite syl5ibr cX vu cv cdif cX vv cv cdif unfi
      syl5 exp3a com23 adantrd mpdi exp3a com23 imp cX vv cv cdif isfinite
      syl5ib jaod mpd ex cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv
      cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv
      cv cdif cX vu cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm
      wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr
      wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cX vu cv
      cdif cdom wbr wa com cX vu cv cdif cdom wbr cX vu cv cdif com csdm wbr wo
      cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX cA wcel com cX cdom wbr wa
      com cX vu cv cdif cdom wbr cX vu cv cdif com csdm wbr wo vu cv cX wss cX
      vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa cX
      vv cv cdif cX vu cv cdif cdom wbr cX cA wcel com cX vu cv cdif cdom wbr
      cX vu cv cdif com csdm wbr wo com cX cdom wbr cX cA wcel cX vu cv cdif
      cvv wcel com cX vu cv cdif cdom wbr cX vu cv cdif com csdm wbr wo cX vu
      cv cA difexg com cvv wcel cX vu cv cdif cvv wcel com cX vu cv cdif cdom
      wbr cX vu cv cdif com csdm wbr wo omex com cX vu cv cdif cvv cvv entri2
      mpan syl adantr ad2antrr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu
      cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX
      vv cv cdif cX vu cv cdif cdom wbr wa com cX vu cv cdif cdom wbr cX vu cv
      cdif cX vv cv cdif cun cX csdm wbr cX vu cv cdif com csdm wbr cX cA wcel
      com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss
      cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cX vu cv cdif cdom wbr
      com cX vu cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX
      vu cv cdif cX vv cv cdif cun cX vu cv cdif cen wbr cX vu cv cdif cX csdm
      wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX cA wcel com cX cdom
      wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv
      cdif cX csdm wbr wa wa wa cX vv cv cdif cX vu cv cdif cdom wbr com cX vu
      cv cdif cdom wbr wa wa cX vu cv cdif cX vv cv cdif cun cX vu cv cdif cX
      ensdomtr cX cA wcel com cX cdom wbr wa cX vv cv cdif cX vu cv cdif cdom
      wbr com cX vu cv cdif cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX vu
      cv cdif cen wbr vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX
      vv cv cdif cX csdm wbr wa wa cX cA wcel cX vv cv cdif cX vu cv cdif cdom
      wbr com cX vu cv cdif cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX vu
      cv cdif cen wbr com cX cdom wbr cX cA wcel cX vv cv cdif cX vu cv cdif
      cdom wbr com cX vu cv cdif cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX
      vu cv cdif cen wbr vx cv vv cv cdif vx cv vu cv cdif cdom wbr com vx cv
      vu cv cdif cdom wbr wa vx cv vu cv cdif vx cv vv cv cdif cun vx cv vu cv
      cdif cen wbr wi cX vv cv cdif cX vu cv cdif cdom wbr com cX vu cv cdif
      cdom wbr wa cX vu cv cdif cX vv cv cdif cun cX vu cv cdif cen wbr wi vx
      cX cA vx cv cX wceq vx cv vv cv cdif vx cv vu cv cdif cdom wbr com vx cv
      vu cv cdif cdom wbr wa cX vv cv cdif cX vu cv cdif cdom wbr com cX vu cv
      cdif cdom wbr wa vx cv vu cv cdif vx cv vv cv cdif cun vx cv vu cv cdif
      cen wbr cX vu cv cdif cX vv cv cdif cun cX vu cv cdif cen wbr vx cv cX
      wceq vx cv vv cv cdif vx cv vu cv cdif cdom wbr cX vv cv cdif cX vu cv
      cdif cdom wbr com vx cv vu cv cdif cdom wbr com cX vu cv cdif cdom wbr vx
      cv cX wceq vx cv vv cv cdif cX vv cv cdif vx cv vu cv cdif cX vu cv cdif
      cdom vx cv cX vv cv difeq1 vx cv cX vu cv difeq1 breq12d vx cv cX wceq vx
      cv vu cv cdif cX vu cv cdif com cdom vx cv cX vu cv difeq1 breq2d anbi12d
      vx cv cX wceq vx cv vu cv cdif vx cv vv cv cdif cun cX vu cv cdif cX vv
      cv cdif cun vx cv vu cv cdif cX vu cv cdif cen vx cv cX wceq vx cv vu cv
      cdif cX vu cv cdif vx cv vv cv cdif cX vv cv cdif vx cv cX vu cv difeq1
      vx cv cX vv cv difeq1 uneq12d vx cv cX vu cv difeq1 breq12d imbi12d com
      vx cv vu cv cdif cdom wbr vx cv vv cv cdif vx cv vu cv cdif cdom wbr vx
      cv vu cv cdif vx cv vv cv cdif cun vx cv vu cv cdif cen wbr vx cv vu cv
      cdif vx cv vv cv cdif vx cv cvv wcel vx cv vu cv cdif cvv wcel vx visset
      vx cv vu cv cvv difexg ax-mp vx cv cvv wcel vx cv vv cv cdif cvv wcel vx
      visset vx cv vv cv cvv difexg ax-mp infunabs ancoms vtoclg imp adantlr
      adantlr vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv
      cdif cX csdm wbr wa wa cX vu cv cdif cX csdm wbr cX cA wcel com cX cdom
      wbr wa cX vv cv cdif cX vu cv cdif cdom wbr com cX vu cv cdif cdom wbr wa
      vu cv cX wss cX vu cv cdif cX csdm wbr vv cv cX wss cX vv cv cdif cX csdm
      wbr wa simplr ad2antlr sylanc expr cX cA wcel com cX cdom wbr wa vu cv cX
      wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr
      wa wa wa cX vv cv cdif cX vu cv cdif cdom wbr wa cX vu cv cdif cfn wcel
      cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX vu cv cdif com csdm wbr cX
      cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv
      cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vv cv cdif cX vu cv cdif
      cdom wbr cX vu cv cdif cfn wcel cX vu cv cdif cX vv cv cdif cun cX csdm
      wbr wi cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm
      wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cfn
      wcel cX vv cv cdif cX vu cv cdif cdom wbr cX vu cv cdif cX vv cv cdif cun
      cX csdm wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX
      csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif
      cfn wcel cX vv cv cdif cX vu cv cdif cdom wbr cX vu cv cdif cX vv cv cdif
      cun cX csdm wbr cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif
      cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv
      cdif cfn wcel cX vv cv cdif cX vu cv cdif cdom wbr wa cX vv cv cdif cfn
      wcel cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX vu cv cdif cX vv cv
      cdif domfi cX cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX
      csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif
      cfn wcel cX vv cv cdif cfn wcel cX vu cv cdif cX vv cv cdif cun cX csdm
      wbr wi cX vv cv cdif cX vu cv cdif cdom wbr cX cA wcel com cX cdom wbr wa
      vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX
      csdm wbr wa wa wa cX vu cv cdif cfn wcel cX vv cv cdif cfn wcel cX vu cv
      cdif cX vv cv cdif cun cX csdm wbr cX cA wcel com cX cdom wbr wa vu cv cX
      wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv cv cdif cX csdm wbr
      wa wa wa cX vu cv cdif cX vv cv cdif cun cfn wcel cX vu cv cdif cX vv cv
      cdif cun cX csdm wbr cX vu cv cdif cfn wcel cX vv cv cdif cfn wcel wa cX
      cA wcel com cX cdom wbr wa vu cv cX wss cX vu cv cdif cX csdm wbr wa vv
      cv cX wss cX vv cv cdif cX csdm wbr wa wa wa cX vu cv cdif cX vv cv cdif
      cun com csdm wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX vu cv
      cdif cX vv cv cdif cun cfn wcel cX cA wcel com cX cdom wbr wa cX vu cv
      cdif cX vv cv cdif cun com csdm wbr cX vu cv cdif cX vv cv cdif cun cX
      csdm wbr wi vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv cX wss cX vv
      cv cdif cX csdm wbr wa wa cX cA wcel com cX cdom wbr cX vu cv cdif cX vv
      cv cdif cun com csdm wbr cX vu cv cdif cX vv cv cdif cun cX csdm wbr wi
      cX cA wcel cX vu cv cdif cX vv cv cdif cun com csdm wbr com cX cdom wbr
      cX vu cv cdif cX vv cv cdif cun cX csdm wbr cX cA wcel cX vu cv cdif cX
      vv cv cdif cun com csdm wbr com cX cdom wbr cX vu cv cdif cX vv cv cdif
      cun cX csdm wbr cX vu cv cdif cX vv cv cdif cun com cX cA sdomdomtr exp3a
      com23 imp adantr cX vu cv cdif cX vv cv cdif cun isfinite syl5ibr cX vu
      cv cdif cX vv cv cdif unfi syl5 exp3a adantrd mpdi exp3a com23 imp cX vu
      cv cdif isfinite syl5ib jaod mpd ex jaod mpd cX vu cv vv cv difindi
      syl5eqbr jca ex vu cv vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      wcel vu cv cX wss cX vu cv cdif cX csdm wbr wa vv cv vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab wcel vv cv cX wss cX vv cv cdif cX csdm wbr
      wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vu cv cX wss cX vu cv cdif
      cX csdm wbr wa vy vu cv vu visset vy cv vu cv wceq vy cv cX wss vu cv cX
      wss cX vy cv cdif cX csdm wbr cX vu cv cdif cX csdm wbr vy cv vu cv cX
      sseq1 vy cv vu cv wceq cX vy cv cdif cX vu cv cdif cX csdm vy cv vu cv cX
      difeq2 breq1d anbi12d elab vy cv cX wss cX vy cv cdif cX csdm wbr wa vv
      cv cX wss cX vv cv cdif cX csdm wbr wa vy vv cv vv visset vy cv vv cv
      wceq vy cv cX wss vv cv cX wss cX vy cv cdif cX csdm wbr cX vv cv cdif cX
      csdm wbr vy cv vv cv cX sseq1 vy cv vv cv wceq cX vy cv cdif cX vv cv
      cdif cX csdm vy cv vv cv cX difeq2 breq1d anbi12d elab anbi12i vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vu cv vv cv cin cX wss cX vu cv vv cv
      cin cdif cX csdm wbr wa vy vu cv vv cv cin vu cv vv cv vu visset inex1 vy
      cv vu cv vv cv cin wceq vy cv cX wss vu cv vv cv cin cX wss cX vy cv cdif
      cX csdm wbr cX vu cv vv cv cin cdif cX csdm wbr vy cv vu cv vv cv cin cX
      sseq1 vy cv vu cv vv cv cin wceq cX vy cv cdif cX vu cv vv cv cin cdif cX
      csdm vy cv vu cv vv cv cin cX difeq2 breq1d anbi12d elab 3imtr4g
      r19.21aivv 3adant3 3jca cX cA wcel com cX cdom wbr vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cfil wcel c0 vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wcel wn vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab cuni vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel wa vu cv
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel vv cv vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab cuni wss vu cv vv cv wss w3a vv cv vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel wi vv wal vu wal vu cv
      vv cv cin vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel vv vy cv
      cX wss cX vy cv cdif cX csdm wbr wa vy cab wral vu vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab wral w3a wb vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab cuni cX wceq cX cA wcel vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab cvv wcel vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cfil wcel c0 vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel wn vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab wcel wa vu cv vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wcel vv cv vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cuni wss vu cv vv cv wss w3a vv cv vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wcel wi vv wal vu wal vu cv vv cv cin vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab wcel vv vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab wral vu vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab wral w3a wb cX vy cv cdif cX csdm wbr vy cX cA abssexg vu vv cvv vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab cuni eqid isfil syl 3ad2ant1 mpbird 3expia jcai cX cA wcel com cX
      cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa cX vf cv
      cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa
      vf cufil wrex cX vf cv cuni wceq vx cv cX cen wbr vx vf cv wral wa vf
      cufil wrex vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa cX vf cv
      cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa
      vf cufil wrex cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cfil wcel wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni
      vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa vf cufil wrex cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa vf cufil wrex vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cfil wcel vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cuni vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab vf cv wss wa vf cufil wrex vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cuni cX wceq vf vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab cuni eqid filssufil adantl vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa vf cufil wrex cX vf cv cuni wceq vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa vf cufil wrex wb vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss wa vf cufil vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni vf cv cuni wceq cX vf cv cuni wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab vf cv wss vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni cX vf cv cuni eqeq1 anbi1d rexbidv adantr
      mpbid adantl cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cfil wcel wa wa cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa cX vf cv cuni wceq vx cv cX cen wbr vx vf
      cv wral wa vf cufil cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel wa cX vf cv cuni wceq
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa cX vf cv
      cuni wceq vx cv cX cen wbr vx vf cv wral cX vf cv cuni wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa cX vf cv cuni wceq wi cX
      cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil
      wcel wa wa vf cv cufil wcel wa cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss pm3.26 a1i cX cA wcel com cX cdom
      wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil
      wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      vf cv wss wa vx cv cX cen wbr vx vf cv wral cX cA wcel com cX cdom wbr wa
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel
      cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa wa wa vx cv cX cen wbr vx vf cv cX cA wcel com cX cdom wbr wa vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel cX
      vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa wa wa vx cv vf cv wcel wa cX vx cv cdom wbr vx cv cX csdm wbr wo
      vx cv cX cen wbr cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cfil wcel wa wa cX vx cv cdom wbr vx cv cX csdm wbr wo vf cv
      cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab vf cv wss wa wa vx cv vf cv wcel cX cA wcel cX vx cv cdom wbr vx
      cv cX csdm wbr wo com cX cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cfil wcel wa cX cA wcel vx cv cvv wcel cX vx cv cdom wbr vx cv cX csdm
      wbr wo vx visset cX vx cv cA cvv entri2 mpan2 ad2antrr ad2antrr cX cA
      wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel
      wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel wa cX vx cv cdom
      wbr vx cv cX cen wbr vx cv cX csdm wbr cX cA wcel com cX cdom wbr wa vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel cX
      vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa wa wa vx cv vf cv wcel wa vx cv cX cdom wbr cX vx cv cdom wbr vx
      cv cX cen wbr wi vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab vf cv wss wa wa vx cv vf cv wcel vx cv cX
      cdom wbr cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab cfil wcel wa wa cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab vf cv wss wa vx cv vf cv wcel vx cv cX cdom wbr vf cv cufil
      wcel cX vf cv cuni wceq vx cv vf cv wcel vx cv cX cdom wbr vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab vf cv wss cX vf cv cuni wceq vx cv vf
      cv wcel wa vx cv vf cv cuni cX cdom vx cv vf cv wcel vx cv vf cv cuni
      cdom wbr cX vf cv cuni wceq vx cv vf cv wcel vx cv vf cv cuni wss vx cv
      vf cv cuni cdom wbr vx cv vf cv elssuni vx cv cvv wcel vx cv vf cv cuni
      wss vx cv vf cv cuni cdom wbr wi vx visset vx cv vf cv cuni cvv ssdomg
      ax-mp syl adantl cX vf cv cuni wceq vx cv vf cv wcel pm3.26 breqtrrd
      adantlr adantll adantll vx cv cX cdom wbr cX vx cv cdom wbr vx cv cX cen
      wbr vx cv cX sbth ex syl cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf
      cv wcel wa vx cv cX csdm wbr vx cv cX cen wbr cX cA wcel com cX cdom wbr
      wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel
      cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa wa wa vx cv vf cv wcel wa vx cv cX csdm wbr c0 vf cv wcel vf cv
      cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab vf cv wss wa wa c0 vf cv wcel wn cX cA wcel com cX cdom wbr wa vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vx cv vf cv wcel vf
      cv cufil wcel c0 vf cv wcel wn cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss wa vf cv cufil wcel vf cv cfil wcel
      c0 vf cv wcel wn vf cv ufilfil vf cv filesn syl adantr ad2antlr cX cA
      wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel
      wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel vx cv cX csdm wbr
      c0 vf cv wcel cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cfil wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel
      vx cv cX csdm wbr wa wa vx cv cX vx cv cdif cin vf cv c0 vf cv cfil wcel
      vx cv vf cv wcel cX vx cv cdif vf cv wcel vx cv cX vx cv cdif cin vf cv
      wcel cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cfil wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel vx cv cX
      csdm wbr wa wa vx cv cX vx cv cdif vf cv filint vf cv cufil wcel cX vf cv
      cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa
      wa vf cv cfil wcel cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cfil wcel wa wa vx cv vf cv wcel vx cv cX csdm wbr wa
      vf cv cufil wcel vf cv cfil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss wa vf cv ufilfil adantr ad2antlr cX
      cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy
      cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil
      wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel vx cv cX csdm
      wbr simprl cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cfil wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss
      cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel
      vx cv cX csdm wbr wa wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      vf cv cX vx cv cdif vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab vf cv wss wa wa vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss cX cA wcel com cX cdom wbr wa vy cv
      cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX
      vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vx cv vf cv wcel vx cv
      cX csdm wbr wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss simprr ad2antlr cX cA wcel com cX
      cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv
      cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab vf cv wss wa wa wa vx cv vf cv wcel vx cv cX csdm wbr wa wa cX vx
      cv cdif vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab wcel cX vx cv
      cdif cX wss cX cX vx cv cdif cdif cX csdm wbr wa cX cA wcel com cX cdom
      wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil
      wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      vf cv wss wa wa wa vx cv vf cv wcel vx cv cX csdm wbr wa wa cX cX vx cv
      cdif cdif cX csdm wbr cX vx cv cdif cX wss cX cA wcel com cX cdom wbr wa
      vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel
      cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa wa wa vx cv vf cv wcel vx cv cX csdm wbr wa wa cX cX vx cv cdif
      cdif vx cv cX csdm cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf
      cv wcel vx cv cX csdm wbr wa wa vx cv cX wss cX cX vx cv cdif cdif vx cv
      wceq cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr
      wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cfil wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv
      cdif cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv vf cv wcel vx cv cX
      csdm wbr wa wa vx cv vf cv cuni cX vx cv vf cv wcel vx cv vf cv cuni wss
      cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil
      wcel wa wa vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif
      cX csdm wbr wa vy cab vf cv wss wa wa wa vx cv cX csdm wbr vx cv vf cv
      elssuni ad2antrl vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy
      cv cdif cX csdm wbr wa vy cab vf cv wss wa wa cX vf cv cuni wceq cX cA
      wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel
      wa wa vx cv vf cv wcel vx cv cX csdm wbr wa vf cv cufil wcel cX vf cv
      cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv wss
      simprl ad2antlr sseqtr4d vx cv cX dfss4 sylib cX cA wcel com cX cdom wbr
      wa vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy cv cX
      wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa wa vf cv cufil wcel
      cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab vf cv
      wss wa wa wa vx cv vf cv wcel vx cv cX csdm wbr simprr eqbrtrd cX vx cv
      difss jctil cX cA wcel com cX cdom wbr wa vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab cuni cX wceq vy cv cX wss cX vy cv cdif cX csdm wbr wa
      vy cab cfil wcel wa wa cX vx cv cdif vy cv cX wss cX vy cv cdif cX csdm
      wbr wa vy cab wcel cX vx cv cdif cX wss cX cX vx cv cdif cdif cX csdm wbr
      wa wb vf cv cufil wcel cX vf cv cuni wceq vy cv cX wss cX vy cv cdif cX
      csdm wbr wa vy cab vf cv wss wa wa vx cv vf cv wcel vx cv cX csdm wbr wa
      cX cA wcel cX vx cv cdif vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab
      wcel cX vx cv cdif cX wss cX cX vx cv cdif cdif cX csdm wbr wa wb com cX
      cdom wbr vy cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cuni cX wceq vy
      cv cX wss cX vy cv cdif cX csdm wbr wa vy cab cfil wcel wa cX vy cv cdif
      cX csdm wbr cX cX vx cv cdif cdif cX csdm wbr vy cX vx cv cdif cX cA vy
      cv cX vx cv cdif wceq cX vy cv cdif cX cX vx cv cdif cdif cX csdm vy cv
      cX vx cv cdif cX difeq2 breq1d elssabg ad2antrr ad2antrr mpbird sseldd
      syl3anc vx cv cX difdisj syl5eqelr expr mtod pm2.21d jaod mpd r19.21aiva
      expr jcad r19.22dva mpd mpdan $.
      $( [7-Dec-2009] $) $( [7-Dec-2009] $)
  $}

  ${
    $d x y F $.
    $( A filter gives rise to a connected topology. $)
    filcon $p |- ( F e. Fil -> ( F u. { (/) } ) e. Con ) $=
      cF cfil wcel cF c0 csn cun ctop wcel cF c0 csn cun ccon wcel cF cfil wcel
      cF c0 csn cun ctop wcel vx cv cF c0 csn cun wss vx cv cuni cF c0 csn cun
      wcel wi vx wal vx cv vy cv cin cF c0 csn cun wcel vy cF c0 csn cun wral
      vx cF c0 csn cun wral wa cF cfil wcel vx cv cF c0 csn cun wss vx cv cuni
      cF c0 csn cun wcel wi vx wal vx cv vy cv cin cF c0 csn cun wcel vy cF c0
      csn cun wral vx cF c0 csn cun wral cF cfil wcel vx cv cF c0 csn cun wss
      vx cv cuni cF c0 csn cun wcel wi vx cF cfil wcel vx cv cF c0 csn cun wss
      vx cv cuni cF c0 csn cun wcel cF cfil wcel vx cv cF c0 csn cun wss wa vx
      cv cuni cF wcel vx cv cuni c0 wceq wo vx cv cuni cF c0 csn cun wcel cF
      cfil wcel vx cv cF c0 csn cun wss wa vx cv cuni c0 wceq vx cv cuni cF
      wcel wo vx cv cuni cF wcel vx cv cuni c0 wceq wo cF cfil wcel vx cv cF c0
      csn cun wss wa vx cv cuni c0 wceq vx cv cuni cF wcel cF cfil wcel vx cv
      cF c0 csn cun wss wa vx cv c0 csn wss wn vx cv cuni cF wcel vx cv cuni c0
      wceq wn cF cfil wcel vx cv cF c0 csn cun wss wa vx cv c0 csn wss wn vx cv
      cF cin c0 wne vx cv cuni cF wcel vx cv cF c0 csn cun wss vx cv c0 csn wss
      wn vx cv cF cin c0 wne wi cF cfil wcel vx cv cF c0 csn cun wss vx cv c0
      csn wss vx cv cF cin c0 vx cv cF cin c0 wceq vx cv cF c0 csn cun wss vx
      cv c0 csn wss vx cv cF c0 csn disjssun biimpcd necon3bd adantl cF cfil
      wcel vx cv cF c0 csn cun wss wa vy cv vx cv cF cin wcel vy wex vx cv cuni
      cF wcel vx cv cF cin c0 wne cF cfil wcel vx cv cF c0 csn cun wss wa vy cv
      vx cv cF cin wcel vx cv cuni cF wcel vy cF cfil wcel vx cv cF c0 csn cun
      wss vy cv vx cv cF cin wcel vx cv cuni cF wcel cF cfil wcel vy cv cF wcel
      vx cv cuni cF cuni wss vy cv vx cv cuni wss w3a vx cv cuni cF wcel cF
      cfil wcel vx cv cF c0 csn cun wss vy cv vx cv cF cin wcel w3a vy cv vx cv
      cuni cF cF cuni cF cuni eqid fillsb cF cfil wcel vx cv cF c0 csn cun wss
      vy cv vx cv cF cin wcel 3simp1 cF cfil wcel vx cv cF c0 csn cun wss vy cv
      vx cv cF cin wcel w3a vy cv cF wcel vx cv cuni cF cuni wss vy cv vx cv
      cuni wss vy cv vx cv cF cin wcel cF cfil wcel vy cv cF wcel vx cv cF c0
      csn cun wss vx cv cF cin cF vy cv vx cv cF inss2 sseli 3ad2ant3 vx cv cF
      c0 csn cun wss cF cfil wcel vx cv cuni cF cuni wss vy cv vx cv cF cin
      wcel vx cv cF c0 csn cun wss vx cv cuni cF c0 csn cun cuni cF cuni vx cv
      cF c0 csn cun uniss cF c0 csn cun cuni cF cuni c0 csn cuni cun cF cuni c0
      cun cF cuni cF c0 csn uniun c0 csn cuni c0 cF cuni c0 0ex unisn uneq2i cF
      cuni un0 3eqtri syl6ss 3ad2ant2 vy cv vx cv cF cin wcel cF cfil wcel vy
      cv vx cv cuni wss vx cv cF c0 csn cun wss vy cv vx cv cF cin wcel vy cv
      vx cv wcel vy cv vx cv cuni wss vx cv cF cin vx cv vy cv vx cv cF inss1
      sseli vy cv vx cv elssuni syl 3ad2ant3 3jca sylc 3expia 19.23adv vy vx cv
      cF cin n0 syl5ib syld vx cv cuni c0 wceq vx cv c0 csn wss vx cv uni0b
      notbii syl5ib orrd vx cv cuni c0 wceq vx cv cuni cF wcel orcom sylib vx
      cv cuni cF c0 csn cun wcel vx cv cuni cF wcel vx cv cuni c0 csn wcel wo
      vx cv cuni cF wcel vx cv cuni c0 wceq wo vx cv cuni cF c0 csn elun vx cv
      cuni c0 csn wcel vx cv cuni c0 wceq vx cv cuni cF wcel vx cv cuni c0 vx
      cv vx visset uniex elsnc orbi2i bitr2i sylib ex 19.21aiv cF cfil wcel vx
      cv vy cv cin cF c0 csn cun wcel vx vy cF c0 csn cun cF c0 csn cun cF cfil
      wcel vx cv cF c0 csn cun wcel vy cv cF c0 csn cun wcel vx cv vy cv cin cF
      c0 csn cun wcel cF cfil wcel vx cv cF wcel vx cv c0 wceq wo vy cv cF c0
      csn cun wcel vx cv vy cv cin cF c0 csn cun wcel wi vx cv cF c0 csn cun
      wcel cF cfil wcel vx cv cF wcel vy cv cF c0 csn cun wcel vx cv vy cv cin
      cF c0 csn cun wcel wi vx cv c0 wceq cF cfil wcel vx cv cF wcel vy cv cF
      wcel vy cv c0 wceq wo vx cv vy cv cin cF c0 csn cun wcel vy cv cF c0 csn
      cun wcel cF cfil wcel vy cv cF wcel vy cv c0 wceq wo vx cv cF wcel vx cv
      vy cv cin cF c0 csn cun wcel cF cfil wcel vy cv cF wcel vx cv cF wcel vx
      cv vy cv cin cF c0 csn cun wcel wi vy cv c0 wceq cF cfil wcel vx cv cF
      wcel vy cv cF wcel vx cv vy cv cin cF c0 csn cun wcel cF cfil wcel vx cv
      cF wcel vy cv cF wcel vx cv vy cv cin cF c0 csn cun wcel cF cfil wcel vx
      cv cF wcel vy cv cF wcel w3a vx cv vy cv cin cF wcel vx cv vy cv cin cF
      c0 csn cun wcel vx cv vy cv cF filint vx cv vy cv cin cF c0 csn elun1 syl
      3exp com23 cF cfil wcel vy cv c0 wceq vx cv cF wcel vx cv vy cv cin cF c0
      csn cun wcel vy cv c0 wceq vx cv vy cv cin c0 csn wcel vx cv vy cv cin cF
      c0 csn cun wcel vy cv c0 wceq vx cv vy cv cin c0 wceq vx cv vy cv cin c0
      csn wcel vy cv c0 wceq vx cv vy cv cin vx cv c0 cin c0 vy cv c0 vx cv
      ineq2 vx cv in0 syl6eq vx cv vy cv cin c0 vx cv vy cv vx visset inex1
      elsnc sylibr vx cv vy cv cin c0 csn cF elun2 syl a1i13 jaod com23 vy cv
      cF c0 csn cun wcel vy cv cF wcel vy cv c0 csn wcel wo vy cv cF wcel vy cv
      c0 wceq wo vy cv cF c0 csn elun vy cv c0 csn wcel vy cv c0 wceq vy cv cF
      wcel vy c0 elsn orbi2i bitri syl7ib cF cfil wcel vx cv c0 wceq vx cv vy
      cv cin cF c0 csn cun wcel vy cv cF c0 csn cun wcel cF cfil wcel vx cv c0
      wceq vx cv vy cv cin c0 csn wcel vx cv vy cv cin cF c0 csn cun wcel cF
      cfil wcel vx cv c0 wceq vx cv vy cv cin c0 wceq vx cv vy cv cin c0 csn
      wcel vx cv c0 wceq vx cv vy cv cin c0 wceq wi cF cfil wcel vx cv c0 wceq
      vx cv vy cv cin c0 vy cv cin c0 vx cv c0 vy cv ineq1 c0 vy cv cin vy cv
      c0 cin c0 c0 vy cv incom vy cv in0 eqtri syl6eq a1i vx cv vy cv cin c0 vx
      cv vy cv vx visset inex1 elsnc syl6ibr vx cv vy cv cin c0 csn cF elun2
      syl6 a1dd jaod vx cv cF c0 csn cun wcel vx cv cF wcel vx cv c0 csn wcel
      wo vx cv cF wcel vx cv c0 wceq wo vx cv cF c0 csn elun vx cv c0 csn wcel
      vx cv c0 wceq vx cv cF wcel vx c0 elsn orbi2i bitri syl5ib imp3a
      r19.21aivv jca cF cfil wcel cF c0 csn cun cvv wcel cF c0 csn cun ctop
      wcel vx cv cF c0 csn cun wss vx cv cuni cF c0 csn cun wcel wi vx wal vx
      cv vy cv cin cF c0 csn cun wcel vy cF c0 csn cun wral vx cF c0 csn cun
      wral wa wb cF cfil wcel c0 csn cvv wcel cF c0 csn cun cvv wcel p0ex cF c0
      csn cfil cvv unexg mpan2 vx vy cvv cF c0 csn cun istopg syl mpbird cF
      cfil wcel cF c0 csn cun ctop wcel wa cF c0 csn cun ccon wcel cF c0 csn
      cun cF c0 csn cun ccld cfv cin c0 cF c0 csn cun cuni cpr wceq cF cfil
      wcel cF c0 csn cun ctop wcel wa vx cF c0 csn cun cF c0 csn cun ccld cfv
      cin c0 cF c0 csn cun cuni cpr cF cfil wcel cF c0 csn cun ctop wcel wa vx
      cv cF c0 csn cun cF c0 csn cun ccld cfv cin wcel vx cv c0 cF c0 csn cun
      cuni cpr wcel cF cfil wcel cF c0 csn cun ctop wcel wa vx cv cF c0 csn cun
      wcel vx cv cF c0 csn cun ccld cfv wcel wa vx cv c0 cF c0 csn cun cuni cpr
      wcel vx cv cF c0 csn cun cF c0 csn cun ccld cfv cin wcel cF cfil wcel cF
      c0 csn cun ctop wcel wa vx cv cF c0 csn cun wcel vx cv cF c0 csn cun ccld
      cfv wcel vx cv c0 cF c0 csn cun cuni cpr wcel cF cfil wcel cF c0 csn cun
      ctop wcel wa vx cv cF wcel vx cv c0 wceq wo vx cv cF c0 csn cun ccld cfv
      wcel vx cv c0 cF c0 csn cun cuni cpr wcel wi vx cv cF c0 csn cun wcel cF
      cfil wcel cF c0 csn cun ctop wcel wa vx cv cF wcel vx cv cF c0 csn cun
      ccld cfv wcel vx cv c0 cF c0 csn cun cuni cpr wcel wi vx cv c0 wceq cF
      cfil wcel cF c0 csn cun ctop wcel wa vx cv cF c0 csn cun ccld cfv wcel vx
      cv cF wcel vx cv c0 cF c0 csn cun cuni cpr wcel cF cfil wcel cF c0 csn
      cun ctop wcel wa vx cv cF c0 csn cun ccld cfv wcel vx cv cF cuni wss cF
      cuni vx cv cdif cF c0 csn cun wcel wa vx cv cF wcel vx cv c0 cF c0 csn
      cun cuni cpr wcel wi cF c0 csn cun ctop wcel vx cv cF c0 csn cun ccld cfv
      wcel vx cv cF cuni wss cF cuni vx cv cdif cF c0 csn cun wcel wa wb cF
      cfil wcel vx cv cF c0 csn cun cF cuni cF c0 csn cun cuni cF cuni c0 csn
      cuni cun cF cuni c0 cun cF cuni cF c0 csn uniun c0 csn cuni c0 cF cuni c0
      0ex unisn uneq2i cF cuni un0 3eqtrri iscld adantl cF cfil wcel cF c0 csn
      cun ctop wcel wa vx cv cF cuni wss cF cuni vx cv cdif cF c0 csn cun wcel
      vx cv cF wcel vx cv c0 cF c0 csn cun cuni cpr wcel wi cF cfil wcel cF c0
      csn cun ctop wcel wa cF cuni vx cv cdif cF c0 csn cun wcel vx cv cF cuni
      wss vx cv cF wcel vx cv c0 cF c0 csn cun cuni cpr wcel wi cF cfil wcel cF
      c0 csn cun ctop wcel wa cF cuni vx cv cdif cF wcel cF cuni vx cv cdif c0
      wceq wo vx cv cF cuni wss vx cv cF wcel vx cv c0 cF c0 csn cun cuni cpr
      wcel wi wi cF cuni vx cv cdif cF c0 csn cun wcel cF cfil wcel cF c0 csn
      cun ctop wcel wa cF cuni vx cv cdif cF wcel vx cv cF cuni wss vx cv cF
      wcel vx cv c0 cF c0 csn cun cuni cpr wcel wi wi cF cuni vx cv cdif c0
      wceq cF cfil wcel cF cuni vx cv cdif cF wcel vx cv cF cuni wss vx cv cF
      wcel vx cv c0 cF c0 csn cun cuni cpr wcel wi wi wi cF c0 csn cun ctop
      wcel cF cfil wcel cF cuni vx cv cdif cF wcel vx cv cF wcel vx cv c0 cF c0
      csn cun cuni cpr wcel wi vx cv cF cuni wss cF cfil wcel cF cuni vx cv
      cdif cF wcel vx cv cF wcel vx cv c0 cF c0 csn cun cuni cpr wcel cF cfil
      wcel cF cuni vx cv cdif cF wcel vx cv cF wcel wa vx cv c0 cF c0 csn cun
      cuni cpr wcel cF cfil wcel cF cuni vx cv cdif cF wcel vx cv cF wcel wa c0
      cF wcel cF filesn cF cfil wcel cF cuni vx cv cdif cF wcel vx cv cF wcel
      c0 cF wcel cF cfil wcel cF cuni vx cv cdif cF wcel vx cv cF wcel w3a cF
      cuni vx cv cdif vx cv cin cF c0 cF cuni vx cv cdif vx cv cF filint vx cv
      cF cuni vx cv cdif cin c0 cF cuni vx cv cdif vx cv cin vx cv cF cuni
      difdisj vx cv cF cuni vx cv cdif incom eqtr3i syl5eqel 3expib mtod
      pm2.21d exp3a a1dd adantr cF cfil wcel cF c0 csn cun ctop wcel wa cF cuni
      vx cv cdif c0 wceq vx cv cF cuni wss vx cv cF wcel vx cv c0 cF c0 csn cun
      cuni cpr wcel cF cfil wcel cF c0 csn cun ctop wcel wa cF cuni vx cv cdif
      c0 wceq vx cv cF cuni wss wa vx cv c0 cF c0 csn cun cuni cpr wcel vx cv
      cF wcel cF cfil wcel cF c0 csn cun ctop wcel wa cF cuni vx cv cdif c0
      wceq vx cv cF cuni wss wa wa vx cv cF c0 csn cun cuni c0 cF c0 csn cun
      cuni cpr cF cfil wcel cF c0 csn cun ctop wcel wa cF cuni vx cv cdif c0
      wceq vx cv cF cuni wss wa wa vx cv cF cuni cF c0 csn cun cuni cF cuni vx
      cv cdif c0 wceq vx cv cF cuni wss wa vx cv cF cuni wceq cF cfil wcel cF
      c0 csn cun ctop wcel wa cF cuni cF cuni vx cv cdif cdif cF cuni wceq vx
      cv cF cuni wss vx cv cF cuni wceq cF cuni vx cv cdif c0 wceq cF cuni cF
      cuni vx cv cdif cdif cF cuni wceq cF cuni cF cuni vx cv cdif cdif vx cv
      wceq vx cv cF cuni wceq vx cv cF cuni wss cF cuni cF cuni vx cv cdif cdif
      cF cuni wceq cF cuni cF cuni vx cv cdif cdif vx cv wceq wa cF cuni vx cv
      cF cuni cF cuni vx cv cdif cdif cF cuni vx cv eqtr2 eqcomd vx cv cF cuni
      dfss4 sylan2b cF cuni vx cv cdif c0 wceq cF cuni cF cuni vx cv cdif cdif
      cF cuni c0 cdif cF cuni cF cuni vx cv cdif c0 cF cuni difeq2 cF cuni dif0
      syl6eq sylan adantl cF c0 csn cun cuni cF cuni c0 csn cuni cun cF cuni c0
      cun cF cuni cF c0 csn uniun c0 csn cuni c0 cF cuni c0 0ex unisn uneq2i cF
      cuni un0 3eqtrri syl6eq cF cfil wcel cF c0 csn cun cuni c0 cF c0 csn cun
      cuni cpr wcel cF c0 csn cun ctop wcel cF cuni vx cv cdif c0 wceq vx cv cF
      cuni wss wa cF cfil wcel cF c0 csn cun cvv wcel cF c0 csn cun cuni cvv
      wcel cF c0 csn cun cuni c0 cF c0 csn cun cuni cpr wcel cF cfil wcel c0
      csn cvv wcel cF c0 csn cun cvv wcel p0ex cF c0 csn cfil cvv unexg mpan2
      cF c0 csn cun cvv uniexg c0 cF c0 csn cun cuni cvv prid2g 3syl ad2antrr
      eqeltrd adantrr exp44 jaod cF cuni vx cv cdif cF c0 csn cun wcel cF cuni
      vx cv cdif cF wcel cF cuni vx cv cdif c0 csn wcel wo cF cuni vx cv cdif
      cF wcel cF cuni vx cv cdif c0 wceq wo cF cuni vx cv cdif cF c0 csn elun
      cF cuni vx cv cdif c0 csn wcel cF cuni vx cv cdif c0 wceq cF cuni vx cv
      cdif cF wcel cF cuni vx cv cdif c0 elsni orim2i sylbi syl5 com23 imp3a
      sylbid com23 cF cfil wcel cF c0 csn cun ctop wcel wa vx cv c0 wceq vx cv
      cF c0 csn cun ccld cfv wcel vx cv c0 cF c0 csn cun cuni cpr wcel vx cv c0
      wceq vx cv c0 cF c0 csn cun cuni cpr wcel c0 c0 cF c0 csn cun cuni cpr
      wcel c0 cF c0 csn cun cuni 0ex prid1 vx cv c0 c0 cF c0 csn cun cuni cpr
      eleq1 mpbiri a1i13 jaod vx cv cF c0 csn cun wcel vx cv cF wcel vx cv c0
      csn wcel wo vx cv cF wcel vx cv c0 wceq wo vx cv cF c0 csn elun vx cv c0
      csn wcel vx cv c0 wceq vx cv cF wcel vx c0 elsn orbi2i bitri syl5ib imp3a
      vx cv cF c0 csn cun cF c0 csn cun ccld cfv elin syl5ib cF c0 csn cun ctop
      wcel vx cv c0 cF c0 csn cun cuni cpr wcel vx cv cF c0 csn cun cF c0 csn
      cun ccld cfv cin wcel wi cF cfil wcel cF c0 csn cun ctop wcel vx cv c0
      wceq vx cv cF c0 csn cun cuni wceq wo vx cv cF c0 csn cun cF c0 csn cun
      ccld cfv cin wcel vx cv c0 cF c0 csn cun cuni cpr wcel cF c0 csn cun ctop
      wcel vx cv c0 wceq vx cv cF c0 csn cun cF c0 csn cun ccld cfv cin wcel vx
      cv cF c0 csn cun cuni wceq cF c0 csn cun ctop wcel vx cv c0 wceq vx cv cF
      c0 csn cun wcel vx cv cF c0 csn cun ccld cfv wcel wa vx cv cF c0 csn cun
      cF c0 csn cun ccld cfv cin wcel vx cv c0 wceq vx cv cF c0 csn cun wcel vx
      cv cF c0 csn cun ccld cfv wcel wa c0 cF c0 csn cun wcel c0 cF c0 csn cun
      ccld cfv wcel wa cF c0 csn cun ctop wcel vx cv c0 wceq vx cv cF c0 csn
      cun wcel c0 cF c0 csn cun wcel vx cv cF c0 csn cun ccld cfv wcel c0 cF c0
      csn cun ccld cfv wcel vx cv c0 cF c0 csn cun eleq1 vx cv c0 cF c0 csn cun
      ccld cfv eleq1 anbi12d cF c0 csn cun ctop wcel c0 cF c0 csn cun wcel c0
      cF c0 csn cun ccld cfv wcel cF c0 csn cun 0opn cF c0 csn cun 0cld jca
      syl5cbir vx cv cF c0 csn cun cF c0 csn cun ccld cfv elin syl6ibr vx cv cF
      c0 csn cun cuni wceq vx cv cF c0 csn cun cF c0 csn cun ccld cfv cin wcel
      cF c0 csn cun cuni cF c0 csn cun cF c0 csn cun ccld cfv cin wcel cF c0
      csn cun ctop wcel vx cv cF c0 csn cun cuni cF c0 csn cun cF c0 csn cun
      ccld cfv cin eleq1 cF c0 csn cun ctop wcel cF c0 csn cun cuni cF c0 csn
      cun wcel cF c0 csn cun cuni cF c0 csn cun ccld cfv wcel wa cF c0 csn cun
      cuni cF c0 csn cun cF c0 csn cun ccld cfv cin wcel cF c0 csn cun ctop
      wcel cF c0 csn cun cuni cF c0 csn cun wcel cF c0 csn cun cuni cF c0 csn
      cun ccld cfv wcel cF c0 csn cun cF c0 csn cun cuni cF c0 csn cun cuni
      eqid topopn cF c0 csn cun cF c0 csn cun cuni cF c0 csn cun cuni eqid
      topcld jca cF c0 csn cun cuni cF c0 csn cun cF c0 csn cun ccld cfv elin
      sylibr syl5cbir jaod vx cv c0 cF c0 csn cun cuni vx visset elpr syl5ib
      adantl impbid eqrdv cF c0 csn cun ctop wcel cF c0 csn cun ccon wcel cF c0
      csn cun cF c0 csn cun ccld cfv cin c0 cF c0 csn cun cuni cpr wceq wb cF
      cfil wcel cF c0 csn cun iscon adantl mpbird mpdan $.
      $( [6-Dec-2009] $) $( [6-Dec-2009] $)
  $}

  ${
    $d x F $. $d x J $. $d x X $.
    ufcondr.1 $e |- J = ( F u. { (/) } ) $.
    ufcondr.2 $e |- X = U. F $.
    $( An ultrafilter gives rise to a connected door topology. $)
    ufcondr $p |- ( F e. UFil -> ( J e. Con /\ ( J u. ( Clsd ` J ) ) = ~P X ) )
    $=
      cF cufil wcel cJ ccon wcel cJ cJ ccld cfv cun cX cpw wceq cF cufil wcel
      cF cfil wcel cJ ccon wcel cF ufilfil cF cfil wcel cF c0 csn cun ccon cJ
      cF filcon ufcondr.1 syl5eqel syl cF cufil wcel cJ ccon wcel cJ cJ ccld
      cfv cun cX cpw wceq cF cufil wcel cJ ccon wcel wa cJ cJ ccld cfv cun cX
      cpw cF cufil wcel cJ ccon wcel wa cJ cX cpw wss cJ ccld cfv cX cpw wss wa
      cJ cJ ccld cfv cun cX cpw wss cF cufil wcel cJ ccon wcel wa cJ cX cpw wss
      cJ ccld cfv cX cpw wss cF cufil wcel cJ ccon wcel wa vx cJ cX cpw cF
      cufil wcel cJ ccon wcel wa vx cv cJ wcel vx cv cX wss vx cv cX cpw wcel
      cJ ccon wcel vx cv cJ wcel vx cv cX wss wi cF cufil wcel cJ ccon wcel cJ
      ctop wcel vx cv cJ wcel vx cv cX wss wi ccon ctop cJ contop sseli cJ ctop
      wcel vx cv cJ wcel vx cv cX wss vx cv cJ cX cX cF cuni cJ cuni ufcondr.2
      cF c0 csn cun cuni cF cuni c0 csn cuni cun cJ cuni cF cuni cF c0 csn
      uniun cJ cF c0 csn cun ufcondr.1 unieqi cF cuni c0 csn cuni cun cF cuni
      c0 cun cF cuni c0 csn cuni c0 cF cuni c0 0ex unisn uneq2i cF cuni un0
      eqtr2i 3eqtr4ri eqtri eltopss ex syl adantl vx cv cX vx visset elpw
      syl6ibr ssrdv cJ ccon wcel cJ ccld cfv cX cpw wss cF cufil wcel cJ ccon
      wcel vx cJ ccld cfv cX cpw cJ ccon wcel cJ ctop wcel vx cv cJ ccld cfv
      wcel vx cv cX cpw wcel wi ccon ctop cJ contop sseli cJ ctop wcel vx cv cJ
      ccld cfv wcel vx cv cX cpw wcel cJ ctop wcel vx cv cJ ccld cfv wcel wa vx
      cv cX wss vx cv cX cpw wcel vx cv cJ cX cX cF cuni cJ cuni ufcondr.2 cF
      c0 csn cun cuni cF cuni c0 csn cuni cun cJ cuni cF cuni cF c0 csn uniun
      cJ cF c0 csn cun ufcondr.1 unieqi cF cuni c0 csn cuni cun cF cuni c0 cun
      cF cuni c0 csn cuni c0 cF cuni c0 0ex unisn uneq2i cF cuni un0 eqtr2i
      3eqtr4ri eqtri cldss vx cv cX vx visset elpw sylibr ex syl ssrdv adantl
      jca cJ cJ ccld cfv cX cpw unss sylib cF cufil wcel cJ ccon wcel wa vx cX
      cpw cJ cJ ccld cfv cun cF cufil wcel cJ ccon wcel wa vx cv cX wss vx cv
      cJ cJ ccld cfv cun wcel vx cv cX cpw wcel cF cufil wcel cJ ccon wcel vx
      cv cX wss vx cv cJ cJ ccld cfv cun wcel cF cufil wcel cJ ccon wcel vx cv
      cX wss w3a vx cv cF wcel cX vx cv cdif cF wcel wo vx cv cJ cJ ccld cfv
      cun wcel cF cufil wcel vx cv cX wss vx cv cF wcel cX vx cv cdif cF wcel
      wo cJ ccon wcel vx cv cF cX ufcondr.2 ufilss 3adant2 cF cufil wcel cJ
      ccon wcel vx cv cX wss w3a vx cv cF wcel cX vx cv cdif cF wcel wo vx cv
      cJ wcel vx cv cJ ccld cfv wcel wo vx cv cJ cJ ccld cfv cun wcel cF cufil
      wcel cJ ccon wcel vx cv cX wss w3a vx cv cF wcel vx cv cJ wcel cX vx cv
      cdif cF wcel vx cv cJ ccld cfv wcel vx cv cF wcel vx cv cJ wcel wi cF
      cufil wcel cJ ccon wcel vx cv cX wss w3a cF cJ vx cv cF cF c0 csn cun cJ
      cF c0 csn ssun1 ufcondr.1 sseqtr4i sseli a1i cF cufil wcel cJ ccon wcel
      vx cv cX wss w3a cX vx cv cdif cF wcel vx cv cX wss cX vx cv cdif cJ wcel
      wa vx cv cJ ccld cfv wcel cF cufil wcel cJ ccon wcel vx cv cX wss w3a cX
      vx cv cdif cF wcel cX vx cv cdif cJ wcel vx cv cX wss cX vx cv cdif cF
      wcel cX vx cv cdif cJ wcel wi cF cufil wcel cJ ccon wcel vx cv cX wss w3a
      cF cJ cX vx cv cdif cF cF c0 csn cun cJ cF c0 csn ssun1 ufcondr.1
      sseqtr4i sseli a1i cF cufil wcel cJ ccon wcel vx cv cX wss 3simp3 jctild
      cJ ccon wcel cF cufil wcel vx cv cJ ccld cfv wcel vx cv cX wss cX vx cv
      cdif cJ wcel wa wb vx cv cX wss cJ ccon wcel cJ ctop wcel vx cv cJ ccld
      cfv wcel vx cv cX wss cX vx cv cdif cJ wcel wa wb ccon ctop cJ contop
      sseli vx cv cJ cX cX cF cuni cJ cuni ufcondr.2 cF c0 csn cun cuni cF cuni
      c0 csn cuni cun cJ cuni cF cuni cF c0 csn uniun cJ cF c0 csn cun
      ufcondr.1 unieqi cF cuni c0 csn cuni cun cF cuni c0 cun cF cuni c0 csn
      cuni c0 cF cuni c0 0ex unisn uneq2i cF cuni un0 eqtr2i 3eqtr4ri eqtri
      iscld syl 3ad2ant2 sylibrd orim12d vx cv cJ cJ ccld cfv elun syl6ibr mpd
      3expia vx cv cX vx visset elpw syl5ib ssrdv eqssd ex jcai $.
      $( [6-Dec-2009] $) $( [6-Dec-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Filter limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b t x y $.
    $( Define a function that takes a filter in a topology to its set of
       cluster points. (Contributed by Jeff Hankins, 4-Sep-2009.) $)
    df-fclus $a |- fClus = { <. x , y >. | ( x e. Top /\ y = { <. a , b >. | (
    a e. Fil /\ U. a = U. x /\ b = |^|_ t e. a ( ( cls ` x ) ` t ) ) } ) } $.
  $}

  ${
    $d f s x y z $.
    $( Define a function that gives the cluster points of a function.
       (Contributed by Jeff Hankins, 4-Sep-2009.) $)
    df-fclusf $a |- fClusf = { <. <. x , y >. , z >. | ( x e. Top /\ y e. Fil
    /\ z = { <. f , s >. | ( f : U. y --> U. x /\ s = ( ( fClus ` x ) ` ( ( U.
    x FilMap y ) ` f ) ) ) } ) } $.
  $}

  ${
    $d o A $. $d o x B $. $d o F $. $d o J $. $d o X $. $d o Y $.
    fbaslim.1 $e |- X = U. J $.
    fbaslim.2 $e |- Y = U. B $.
    fbaslim.3 $e |- F = ( filGen ` B ) $.
    $( A condition for a filter to converge to a point involving one of its
       bases. (Contributed by Jeff Hankins, 4-Sep-2009.) $)
    fbaslim $p |- ( ( ( J e. Top /\ B e. fBas /\ X = Y ) /\ A e. X ) -> ( A e.
    ( ( fLim1 ` J ) ` F ) <-> A. o e. J ( A e. o -> E. x e. B x C_ o ) ) ) $=
      cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA cX wcel wa cA cF cJ cflim1
      cfv cfv wcel cA vo cv wcel vo cv cF wcel wi vo cJ wral cA vo cv wcel vx
      cv vo cv wss vx cB wrex wi vo cJ wral cJ ctop wcel cF cfil wcel cX cF
      cuni wceq w3a cA cX wcel cA cF cJ cflim1 cfv cfv wcel cA vo cv wcel vo cv
      cF wcel wi vo cJ wral wb cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA vo
      cF cJ cX cF cuni fbaslim.1 cF cuni eqid flimopn cJ ctop wcel cB cfbas
      wcel cX cY wceq w3a cJ ctop wcel cF cfil wcel cX cF cuni wceq cJ ctop
      wcel cB cfbas wcel cX cY wceq 3simp1 cB cfbas wcel cJ ctop wcel cF cfil
      wcel cX cY wceq cB cfbas wcel cB cfg cfv cfil cF cB fgfil fbaslim.3
      syl5eqel 3ad2ant2 cJ ctop wcel cB cfbas wcel cX cY wceq w3a cX cY cF cuni
      cJ ctop wcel cB cfbas wcel cX cY wceq 3simp3 cB cfbas wcel cJ ctop wcel
      cY cF cuni wceq cX cY wceq cB cfbas wcel cY cB cfg cfv cuni cF cuni cB cY
      fbaslim.2 fgbas cF cB cfg cfv fbaslim.3 unieqi syl6eqr 3ad2ant2 eqtrd
      3jca sylan cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA cX wcel wa cA vo
      cv wcel vo cv cF wcel wi cA vo cv wcel vx cv vo cv wss vx cB wrex wi vo
      cJ cJ cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wi cA vo cv wcel vx cv vo cv wss vx cB
      wrex wi cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel vo cv cX wss cA vo cv wcel vo cv cF wcel wi cA vo cv wcel vx cv vo
      cv wss vx cB wrex wi wb cJ ctop wcel cB cfbas wcel cX cY wceq w3a vo cv
      cJ wcel vo cv cX wss wi cA cX wcel cJ ctop wcel cB cfbas wcel vo cv cJ
      wcel vo cv cX wss wi cX cY wceq cJ ctop wcel vo cv cJ wcel vo cv cX wss
      vo cv cJ cX fbaslim.1 eltopss ex 3ad2ant1 adantr cJ ctop wcel cB cfbas
      wcel cX cY wceq w3a vo cv cX wss cA vo cv wcel vo cv cF wcel wi cA vo cv
      wcel vx cv vo cv wss vx cB wrex wi wb wi cA cX wcel cJ ctop wcel cB cfbas
      wcel cX cY wceq w3a vo cv cX wss cA vo cv wcel vo cv cF wcel wi cA vo cv
      wcel vx cv vo cv wss vx cB wrex wi wb cJ ctop wcel cB cfbas wcel cX cY
      wceq w3a vo cv cX wss wa vo cv cF wcel vx cv vo cv wss vx cB wrex cA vo
      cv wcel cJ ctop wcel cB cfbas wcel cX cY wceq w3a vo cv cX wss vo cv cY
      wss vo cv cF wcel vx cv vo cv wss vx cB wrex wb cJ ctop wcel cB cfbas
      wcel cX cY wceq w3a vo cv cX wss vo cv cY wss cX cY wceq cJ ctop wcel vo
      cv cX wss vo cv cY wss wb cB cfbas wcel cX cY vo cv sseq2 3ad2ant3 biimpa
      cB cfbas wcel cJ ctop wcel vo cv cY wss vo cv cF wcel vx cv vo cv wss vx
      cB wrex wb cX cY wceq cB cfbas wcel vo cv cY wss wa vo cv cF wcel vo cv
      cY wss vx cv vo cv wss vx cB wrex wa vx cv vo cv wss vx cB wrex cB cfbas
      wcel vo cv cF wcel vo cv cY wss vx cv vo cv wss vx cB wrex wa wb vo cv cY
      wss cB cfbas wcel vo cv cB cfg cfv wcel vo cv cY wss vx cv vo cv wss vx
      cB wrex wa vo cv cF wcel vx vo cv cB cY fbaslim.2 elfg cF cB cfg cfv vo
      cv fbaslim.3 eleq2i syl5bb adantr vo cv cY wss vx cv vo cv wss vx cB wrex
      vo cv cY wss vx cv vo cv wss vx cB wrex wa wb cB cfbas wcel vo cv cY wss
      vx cv vo cv wss vx cB wrex ibar adantl bitr4d 3ad2antl2 syldan imbi2d ex
      adantr syld pm5.74d ralbidv2 bitrd $.
      $( [4-Sep-2009] $) $( [4-Sep-2009] $)
  $}

  ${
    neiplim.1 $e |- X = U. J $.
    $( A point is a limit point of its neighborhood filter. (Contributed by
       Jeff Hankins, 7-Sep-2009.) $)
    neiplim $p |- ( ( J e. Top /\ A e. X ) -> A e. ( ( fLim1 ` J ) ` ( ( nei `
    J ) ` { A } ) ) ) $=
      cJ ctop wcel cA cX wcel wa cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv
      wcel cA cX wcel cA csn cJ cnei cfv cfv cA csn cJ cnei cfv cfv wss wa cA
      cX wcel cA cX wcel cA csn cJ cnei cfv cfv cA csn cJ cnei cfv cfv wss wa
      cJ ctop wcel cA cX wcel cA csn cJ cnei cfv cfv cA csn cJ cnei cfv cfv wss
      cA csn cJ cnei cfv cfv ssid jctr adantl cJ ctop wcel cA csn cJ cnei cfv
      cfv cfil wcel cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ cnei cfv
      cfv cJ cflim1 cfv cfv wcel cA cX wcel cA csn cJ cnei cfv cfv cA csn cJ
      cnei cfv cfv wss wa wb cJ ctop wcel cA cX wcel wa cA cA csn cJ cnei cfv
      cfv cJ cX cA csn cJ cnei cfv cfv cuni neiplim.1 cA csn cJ cnei cfv cfv
      cuni eqid isfillim cJ ctop wcel cA cX wcel pm3.26 cJ ctop wcel cA csn cX
      wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel cA cX
      wcel wa cA csn cJ cX neiplim.1 neifil cJ ctop wcel cA cX wcel pm3.26 cA
      cX wcel cA csn cX wss cJ ctop wcel cA cX snssi adantl cA cX wcel cA csn
      c0 wne cJ ctop wcel cA cX snnzg adantl syl3anc cJ ctop wcel cA cX wcel wa
      cA csn cJ cnei cfv cfv cuni cX cJ ctop wcel cA csn cX wss cA csn cJ cnei
      cfv cfv cuni cX wceq cA cX wcel cA csn cJ cX neiplim.1 unnei cA cX snssi
      sylan2 eqcomd syl3anc mpbird $.
      $( [7-Sep-2009] $) $( [7-Sep-2009] $)
  $}

  ${
    limfilss.1 $e |- X = U. J $.
    limfilss.2 $e |- Y = U. F $.
    limfilss.3 $e |- Z = U. G $.
    $( A limit point of a filter is a limit point of a finer filter.
      (Contributed by Jeff Hankins, 5-Sep-2009.) $)
    limfilss $p |- ( ( ( ( J e. Top /\ F e. Fil /\ G e. Fil ) /\ X = Y /\ X = Z
    ) /\ F C_ G /\ A e. ( ( fLim1 ` J ) ` F ) ) -> A e. ( ( fLim1 ` J ) ` G ) )
    $=
      cJ ctop wcel cF cfil wcel cG cfil wcel w3a cX cY wceq cX cZ wceq w3a cF
      cG wss cA cF cJ cflim1 cfv cfv wcel cA cG cJ cflim1 cfv cfv wcel cJ ctop
      wcel cF cfil wcel cG cfil wcel w3a cX cY wceq cX cZ wceq w3a cF cG wss wa
      cA cX wcel cA csn cJ cnei cfv cfv cF wss wa cA cX wcel cA csn cJ cnei cfv
      cfv cG wss wa cA cF cJ cflim1 cfv cfv wcel cA cG cJ cflim1 cfv cfv wcel
      cF cG wss cA cX wcel cA csn cJ cnei cfv cfv cF wss wa cA cX wcel cA csn
      cJ cnei cfv cfv cG wss wa wi cJ ctop wcel cF cfil wcel cG cfil wcel w3a
      cX cY wceq cX cZ wceq w3a cF cG wss cA csn cJ cnei cfv cfv cF wss cA csn
      cJ cnei cfv cfv cG wss cA cX wcel cA csn cJ cnei cfv cfv cF wss cF cG wss
      cA csn cJ cnei cfv cfv cG wss cA csn cJ cnei cfv cfv cF cG sstr2 com12
      anim2d adantl cJ ctop wcel cF cfil wcel cG cfil wcel w3a cX cY wceq cX cZ
      wceq w3a cA cF cJ cflim1 cfv cfv wcel cA cX wcel cA csn cJ cnei cfv cfv
      cF wss wa wb cF cG wss cJ ctop wcel cF cfil wcel cG cfil wcel w3a cX cY
      wceq cA cF cJ cflim1 cfv cfv wcel cA cX wcel cA csn cJ cnei cfv cfv cF
      wss wa wb cX cZ wceq cJ ctop wcel cF cfil wcel cX cY wceq cA cF cJ cflim1
      cfv cfv wcel cA cX wcel cA csn cJ cnei cfv cfv cF wss wa wb cG cfil wcel
      cJ ctop wcel cF cfil wcel cX cY wceq cA cF cJ cflim1 cfv cfv wcel cA cX
      wcel cA csn cJ cnei cfv cfv cF wss wa wb cA cF cJ cX cY limfilss.1
      limfilss.2 isfillim 3expa 3adantl3 3adant3 adantr cJ ctop wcel cF cfil
      wcel cG cfil wcel w3a cX cY wceq cX cZ wceq w3a cA cG cJ cflim1 cfv cfv
      wcel cA cX wcel cA csn cJ cnei cfv cfv cG wss wa wb cF cG wss cJ ctop
      wcel cF cfil wcel cG cfil wcel w3a cX cZ wceq cA cG cJ cflim1 cfv cfv
      wcel cA cX wcel cA csn cJ cnei cfv cfv cG wss wa wb cX cY wceq cJ ctop
      wcel cG cfil wcel cX cZ wceq cA cG cJ cflim1 cfv cfv wcel cA cX wcel cA
      csn cJ cnei cfv cfv cG wss wa wb cF cfil wcel cJ ctop wcel cG cfil wcel
      cX cZ wceq cA cG cJ cflim1 cfv cfv wcel cA cX wcel cA csn cJ cnei cfv cfv
      cG wss wa wb cA cG cJ cX cZ limfilss.1 limfilss.3 isfillim 3expa 3adantl2
      3adant2 adantr 3imtr4d 3impia $.
      $( [5-Sep-2009] $) $( [5-Sep-2009] $)
  $}

  ${
    $d f o p q r x y J $. $d f o p q r x y K $. $d f o p q r x y X $. $d f o p
    q r x y Y $.
    limfilcf.1 $e |- X = U. J $.
    limfilcf.2 $e |- Y = U. K $.
    $( Fineness is properly characterized by the property that every limit
       point of a filter in the finer topology is a limit point in the coarser
       topology. (Contributed by Jeff Hankins, 28-Sep-2009.) $)
    limfilcf $p |- ( ( J e. Top /\ K e. Top /\ X = Y ) -> ( J C_ K <-> A. f e.
    Fil ( X = U. f -> ( ( fLim1 ` K ) ` f ) C_ ( ( fLim1 ` J ) ` f ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK wss cJ cK cfne wbr cX vf
      cv cuni wceq vf cv cK cflim1 cfv cfv vf cv cJ cflim1 cfv cfv wss wi vf
      cfil wral cJ cK cX cY limfilcf.1 limfilcf.2 topfne cJ ctop wcel cK ctop
      wcel cX cY wceq w3a cJ cK cfne wbr cX vf cv cuni wceq vx cv vf cv cK
      cflim1 cfv cfv wcel vx cv vf cv cJ cflim1 cfv cfv wcel wi vx wal wi vf
      cfil wral cX vf cv cuni wceq vf cv cK cflim1 cfv cfv vf cv cJ cflim1 cfv
      cfv wss wi vf cfil wral cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK
      cfne wbr cX vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv
      wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi
      vo cJ wral wa wi vx wal wi vf cfil wral cX vf cv cuni wceq vx cv vf cv cK
      cflim1 cfv cfv wcel vx cv vf cv cJ cflim1 cfv cfv wcel wi vx wal wi vf
      cfil wral cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr cX vf
      cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK
      wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa
      wi vx wal wi vf cfil wral cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK
      cfne wbr wa cX vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv
      wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi
      vo cJ wral wa wi vx wal wi vf cfil cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq vx cv cY wcel vx
      cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv
      wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal cJ ctop wcel cK ctop
      wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq
      wa wa vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx
      cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx cJ
      ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel
      cX vf cv cuni wceq wa wa vx cv cY wcel vx cv cX wcel vx cv vp cv wcel vp
      cv vf cv wcel wi vp cK wral vx cv vo cv wcel vo cv vf cv wcel wi vo cJ
      wral cJ ctop wcel cK ctop wcel cX cY wceq w3a vx cv cY wcel vx cv cX wcel
      wi cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa cX cY wceq cJ
      ctop wcel vx cv cY wcel vx cv cX wcel wi cK ctop wcel cX cY wceq vx cv cX
      wcel vx cv cY wcel cX cY vx cv eleq2 biimprd 3ad2ant3 ad2antrr cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf
      cv cuni wceq wa wa vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral vx cv
      vo cv wcel vo cv vf cv wcel wi vo cJ cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vx cv vo
      cv wcel vo cv cJ wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral vo
      cv vf cv wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa
      vf cv cfil wcel cX vf cv cuni wceq wa wa vx cv vo cv wcel vo cv cJ wcel
      vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral vo cv vf cv wcel wi cJ
      ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel
      cX vf cv cuni wceq wa wa vx cv vo cv wcel vo cv cJ wcel wa vo cv cX wss
      vx cv vp cv wcel vp cv vo cv wss wa vp cK wrex wa vx cv vp cv wcel vp cv
      vf cv wcel wi vp cK wral vo cv vf cv wcel wi cJ ctop wcel cK ctop wcel cX
      cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vx
      cv vo cv wcel vo cv cJ wcel wa wa vo cv cX wss vx cv vp cv wcel vp cv vo
      cv wss wa vp cK wrex vo cv cJ wcel vo cv cX wss cJ ctop wcel cK ctop wcel
      cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa
      vx cv vo cv wcel vo cv cJ wcel vo cv cJ cuni cX vo cv cJ elssuni
      limfilcf.1 syl6ssr ad2antll cK ctop wcel cJ cK cfne wbr vo cv cJ wcel w3a
      vx cv vo cv wcel vx cv vp cv wcel vp cv vo cv wss wa vp cK wrex cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf
      cv cuni wceq wa wa vx cv vo cv wcel vo cv cJ wcel wa wa vp cJ cK ctop vx
      cv vo cv fnessex cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr
      wa vf cv cfil wcel cX vf cv cuni wceq wa wa vx cv vo cv wcel vo cv cJ
      wcel wa wa cK ctop wcel cJ cK cfne wbr vo cv cJ wcel cJ ctop wcel cK ctop
      wcel cX cY wceq w3a cJ cK cfne wbr wa cK ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq wa vx cv vo cv wcel vo cv cJ wcel wa cJ ctop wcel cK ctop
      wcel cX cY wceq w3a cK ctop wcel cJ cK cfne wbr cJ ctop wcel cK ctop wcel
      cX cY wceq 3simp2 adantr ad2antrr cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa vx cv vo cv wcel
      vo cv cJ wcel wa simpllr cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK
      cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vx cv vo cv wcel vo
      cv cJ wcel simprr 3jca cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK
      cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vx cv vo cv wcel vo
      cv cJ wcel simprl sylanc jca cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ
      cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vo cv cX wss vx
      cv vp cv wcel vp cv vo cv wss wa vp cK wrex vx cv vp cv wcel vp cv vf cv
      wcel wi vp cK wral vo cv vf cv wcel wi cJ ctop wcel cK ctop wcel cX cY
      wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vo cv
      cX wss wa vx cv vp cv wcel vp cv vo cv wss wa vx cv vp cv wcel vp cv vf
      cv wcel wi vp cK wral vo cv vf cv wcel wi vp cK cJ ctop wcel cK ctop wcel
      cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa
      vo cv cX wss wa vp ax-17 vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral
      vo cv vf cv wcel vp vx cv vp cv wcel vp cv vf cv wcel wi vp cK hbra1 vo
      cv vf cv wcel vp ax-17 hbim vx cv vp cv wcel vp cv vf cv wcel wi vp cK
      wral vp cv cK wcel vx cv vp cv wcel vp cv vo cv wss wa cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni
      wceq wa wa vo cv cX wss wa vo cv vf cv wcel vx cv vp cv wcel vp cv vf cv
      wcel wi vp cK wral vp cv cK wcel vx cv vp cv wcel vp cv vf cv wcel wi vx
      cv vp cv wcel vp cv vo cv wss wa cJ ctop wcel cK ctop wcel cX cY wceq w3a
      cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vo cv cX wss
      wa vo cv vf cv wcel wi wi vx cv vp cv wcel vp cv vf cv wcel wi vp cK ra4
      vx cv vp cv wcel vp cv vf cv wcel wi vx cv vp cv wcel vp cv vo cv wss cJ
      ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vf cv cfil wcel
      cX vf cv cuni wceq wa wa vo cv cX wss wa vo cv vf cv wcel wi vp cv vf cv
      wcel vp cv vo cv wss cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne
      wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vo cv cX wss wa vo cv vf
      cv wcel wi wi vx cv vp cv wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a
      cJ cK cfne wbr wa vf cv cfil wcel cX vf cv cuni wceq wa wa vo cv cX wss
      wa vp cv vo cv wss vp cv vf cv wcel vo cv vf cv wcel vf cv cfil wcel cX
      vf cv cuni wceq wa vo cv cX wss vp cv vo cv wss vp cv vf cv wcel vo cv vf
      cv wcel wi wi cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa
      vf cv cfil wcel cX vf cv cuni wceq wa vo cv cX wss vo cv vf cv cuni wss
      vp cv vo cv wss vp cv vf cv wcel vo cv vf cv wcel wi wi cX vf cv cuni
      wceq vo cv cX wss vo cv vf cv cuni wss vf cv cfil wcel cX vf cv cuni wceq
      vo cv cX wss vo cv vf cv cuni wss cX vf cv cuni vo cv sseq2 biimpa
      adantll vf cv cfil wcel vo cv vf cv cuni wss vp cv vo cv wss vp cv vf cv
      wcel vo cv vf cv wcel wi wi cX vf cv cuni wceq vf cv cfil wcel vo cv vf
      cv cuni wss wa vp cv vo cv wss vp cv vf cv wcel vo cv vf cv wcel vf cv
      cfil wcel vp cv vf cv wcel vo cv vf cv cuni wss vp cv vo cv wss w3a vo cv
      vf cv wcel vf cv cfil wcel vo cv vf cv cuni wss wa vp cv vo cv wss vp cv
      vf cv wcel wa wa vp cv vo cv vf cv vf cv cuni vf cv cuni eqid fillsb vf
      cv cfil wcel vo cv vf cv cuni wss vp cv vo cv wss vp cv vf cv wcel wa
      simpll vf cv cfil wcel vo cv vf cv cuni wss wa vp cv vo cv wss vp cv vf
      cv wcel wa wa vp cv vf cv wcel vo cv vf cv cuni wss vp cv vo cv wss vf cv
      cfil wcel vo cv vf cv cuni wss wa vp cv vo cv wss vp cv vf cv wcel simprr
      vf cv cfil wcel vo cv vf cv cuni wss vp cv vo cv wss vp cv vf cv wcel wa
      simplr vf cv cfil wcel vo cv vf cv cuni wss wa vp cv vo cv wss vp cv vf
      cv wcel simprl 3jca sylc exp32 adantlr syldan adantll com13 imim2i imp3a
      syl6 com14 r19.23ad impr syldan exp32 com24 r19.21adv anim12d 19.21aiv
      expr r19.21aiva cJ ctop wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni
      wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx
      cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal
      wi vf cfil wral wa cJ cK cfne wbr cX cY wceq vy cv vr cv wcel vr cv vq cv
      wss wa vr cK wrex vy vq cv wral vq cJ wral wa cJ ctop wcel cK ctop wcel
      cX cY wceq w3a cX vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf
      cv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel
      wi vo cJ wral wa wi vx wal wi vf cfil wral wa cX cY wceq vy cv vr cv wcel
      vr cv vq cv wss wa vr cK wrex vy vq cv wral vq cJ wral cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cX cY wceq cX vf cv cuni wceq vx cv cY wcel vx
      cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv
      wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal wi vf cfil wral cJ ctop
      wcel cK ctop wcel cX cY wceq 3simp3 adantr cJ ctop wcel cK ctop wcel cX
      cY wceq w3a cX vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv
      wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi
      vo cJ wral wa wi vx wal wi vf cfil wral wa vy cv vr cv wcel vr cv vq cv
      wss wa vr cK wrex vq vy cJ vq cv cJ ctop wcel cK ctop wcel cX cY wceq w3a
      cX vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp
      cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral
      wa wi vx wal wi vf cfil wral vq cv cJ wcel vy cv vq cv wcel wa vy cv vr
      cv wcel vr cv vq cv wss wa vr cK wrex wi cJ ctop wcel cK ctop wcel cX cY
      wceq w3a vq cv cJ wcel vy cv vq cv wcel wa cX vf cv cuni wceq vx cv cY
      wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx
      cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal wi vf cfil wral
      vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa cX vf cv cuni wceq vx cv
      cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel
      vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal wi vf cfil
      wral vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex wi cJ ctop wcel cK
      ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa wa cX vf cv
      cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral
      wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx
      wal wi vf cfil wral cX vy cv csn cK cnei cfv cfv cuni wceq vx cv cY wcel
      vx cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx
      cv cX wcel vx cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ
      wral wa wi vx wal wi vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa
      wa vy cv csn cK cnei cfv cfv cfil wcel cX vf cv cuni wceq vx cv cY wcel
      vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx cv vo
      cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal wi vf cfil wral cX vy
      cv csn cK cnei cfv cfv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vy
      cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv
      wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa wi vx wal wi
      wi cK ctop wcel vy cv csn cY wss vy cv csn c0 wne vy cv csn cK cnei cfv
      cfv cfil wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy
      cv vq cv wcel wa wa vy cv csn cK cY limfilcf.2 neifil cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cK ctop wcel vq cv cJ wcel vy cv vq cv wcel wa
      cJ ctop wcel cK ctop wcel cX cY wceq 3simp2 adantr cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vy cv csn cX wss vy cv csn cY wss vq cv cJ wcel vy cv
      vq cv wcel wa cX cY wceq cJ ctop wcel vy cv csn cX wss vy cv csn cY wss
      cK ctop wcel cX cY wceq vy cv csn cX wss vy cv csn cY wss cX cY vy cv csn
      sseq2 biimpa 3ad2antl3 vy cv vq cv wcel vq cv cJ wcel vy cv csn vq cv cX
      vy cv vq cv snssi vq cv cJ wcel vq cv cJ cuni cX vq cv cJ elssuni
      limfilcf.1 syl6ssr sylan9ssr sylan2 vy cv csn c0 wne cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa wa vy cv vy visset
      snnz a1i syl3anc cX vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv
      vf cv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv
      wcel wi vo cJ wral wa wi vx wal wi cX vy cv csn cK cnei cfv cfv cuni wceq
      vx cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp
      cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv
      wcel wi vo cJ wral wa wi vx wal wi vf vy cv csn cK cnei cfv cfv cfil vf
      cv vy cv csn cK cnei cfv cfv wceq cX vf cv cuni wceq cX vy cv csn cK cnei
      cfv cfv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp
      cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral
      wa wi vx wal vx cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei cfv
      cfv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vy cv csn
      cK cnei cfv cfv wcel wi vo cJ wral wa wi vx wal vf cv vy cv csn cK cnei
      cfv cfv wceq vf cv cuni vy cv csn cK cnei cfv cfv cuni cX vf cv vy cv csn
      cK cnei cfv cfv unieq eqeq2d vf cv vy cv csn cK cnei cfv cfv wceq vx cv
      cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel
      vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx cv cY wcel vx cv
      vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx cv cX
      wcel vx cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral
      wa wi vx vf cv vy cv csn cK cnei cfv cfv wceq vx cv cY wcel vx cv vp cv
      wcel vp cv vf cv wcel wi vp cK wral wa vx cv cY wcel vx cv vp cv wcel vp
      cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx cv cX wcel vx cv vo
      cv wcel vo cv vf cv wcel wi vo cJ wral wa vx cv cX wcel vx cv vo cv wcel
      vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa vf cv vy cv csn cK
      cnei cfv cfv wceq vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral vx cv
      vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral vx cv cY
      wcel vf cv vy cv csn cK cnei cfv cfv wceq vx cv vp cv wcel vp cv vf cv
      wcel wi vx cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK vf
      cv vy cv csn cK cnei cfv cfv wceq vp cv vf cv wcel vp cv vy cv csn cK
      cnei cfv cfv wcel vx cv vp cv wcel vf cv vy cv csn cK cnei cfv cfv vp cv
      eleq2 imbi2d ralbidv anbi2d vf cv vy cv csn cK cnei cfv cfv wceq vx cv vo
      cv wcel vo cv vf cv wcel wi vo cJ wral vx cv vo cv wcel vo cv vy cv csn
      cK cnei cfv cfv wcel wi vo cJ wral vx cv cX wcel vf cv vy cv csn cK cnei
      cfv cfv wceq vx cv vo cv wcel vo cv vf cv wcel wi vx cv vo cv wcel vo cv
      vy cv csn cK cnei cfv cfv wcel wi vo cJ vf cv vy cv csn cK cnei cfv cfv
      wceq vo cv vf cv wcel vo cv vy cv csn cK cnei cfv cfv wcel vx cv vo cv
      wcel vf cv vy cv csn cK cnei cfv cfv vo cv eleq2 imbi2d ralbidv anbi2d
      imbi12d albidv imbi12d rcla4v syl cJ ctop wcel cK ctop wcel cX cY wceq
      w3a vq cv cJ wcel vy cv vq cv wcel wa wa cX vy cv csn cK cnei cfv cfv
      cuni wceq cX vy cv csn cK cnei cfv cfv cuni wceq vx cv cY wcel vx cv vp
      cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx cv cX
      wcel vx cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral
      wa wi vx wal wi vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex wi cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa wa cX
      cY vy cv csn cK cnei cfv cfv cuni cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cX cY wceq vq cv cJ wcel vy cv vq cv wcel wa cJ ctop wcel cK ctop
      wcel cX cY wceq 3simp3 adantr cJ ctop wcel cK ctop wcel cX cY wceq w3a vy
      cv csn cX wss vy cv csn cK cnei cfv cfv cuni cY wceq vq cv cJ wcel vy cv
      vq cv wcel wa cJ ctop wcel cK ctop wcel cX cY wceq w3a vy cv csn cX wss
      vy cv csn cY wss vy cv csn cK cnei cfv cfv cuni cY wceq cX cY wceq cJ
      ctop wcel vy cv csn cX wss vy cv csn cY wss cK ctop wcel cX cY wceq vy cv
      csn cX wss vy cv csn cY wss cX cY vy cv csn sseq2 biimpa 3ad2antl3 cK
      ctop wcel cJ ctop wcel vy cv csn cY wss vy cv csn cK cnei cfv cfv cuni cY
      wceq cX cY wceq vy cv csn cK cY limfilcf.2 unnei 3ad2antl2 syldan vy cv
      vq cv wcel vq cv cJ wcel vy cv csn vq cv cX vy cv vq cv snssi vq cv cJ
      wcel vq cv cJ cuni cX vq cv cJ elssuni limfilcf.1 syl6ssr sylan9ssr
      sylan2 eqtr4d cX vy cv csn cK cnei cfv cfv cuni wceq cX vy cv csn cK cnei
      cfv cfv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei
      cfv cfv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vy cv
      csn cK cnei cfv cfv wcel wi vo cJ wral wa wi vx wal wi vx cv cY wcel vx
      cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx cv
      cX wcel vx cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ
      wral wa wi vx wal cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel
      vy cv vq cv wcel wa wa vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex cX
      vy cv csn cK cnei cfv cfv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv
      vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv
      wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa wi vx wal
      pm2.27 cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv
      wcel wa wa vy cv cY wcel vy cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv
      wcel wi vp cK wral wa vy cv cX wcel vy cv vo cv wcel vo cv vy cv csn cK
      cnei cfv cfv wcel wi vo cJ wral wa wi vy cv vr cv wcel vr cv vq cv wss wa
      vr cK wrex vx cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv
      wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vy cv csn cK
      cnei cfv cfv wcel wi vo cJ wral wa wi vx wal cJ ctop wcel cK ctop wcel cX
      cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa wa vy cv cY wcel vy cv vp
      cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral vy cv cY wcel
      vy cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vy
      cv cX wcel vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ
      wral wa wi vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex wi cJ ctop wcel
      cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa wa vy cv cX
      cY vq cv cJ wcel vy cv vq cv wcel wa vy cv cX wcel cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vq cv cX wss vy cv vq cv wcel vy cv cX wcel vq cv cJ
      wcel vq cv cX vy cv ssel2 vq cv cJ wcel vq cv cJ cuni cX vq cv cJ elssuni
      limfilcf.1 syl6ssr sylan adantl cJ ctop wcel cK ctop wcel cX cY wceq w3a
      cX cY wceq vq cv cJ wcel vy cv vq cv wcel wa cJ ctop wcel cK ctop wcel cX
      cY wceq 3simp3 adantr eleqtrd cJ ctop wcel cK ctop wcel cX cY wceq w3a vq
      cv cJ wcel vy cv vq cv wcel wa wa vy cv vp cv wcel vp cv vy cv csn cK
      cnei cfv cfv wcel wi vp cK cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv
      cJ wcel vy cv vq cv wcel wa wa vp cv cK wcel vy cv vp cv wcel vp cv vy cv
      csn cK cnei cfv cfv wcel cK ctop wcel vp cv cK wcel vy cv vp cv wcel vp
      cv vy cv csn cK cnei cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY wceq
      w3a vq cv cJ wcel vy cv vq cv wcel wa wa vp cv cK wcel vy cv vp cv wcel
      wa wa vy cv cK vp cv opnneip cJ ctop wcel cK ctop wcel cX cY wceq w3a cK
      ctop wcel vq cv cJ wcel vy cv vq cv wcel wa vp cv cK wcel vy cv vp cv
      wcel wa cJ ctop wcel cK ctop wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel
      cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel wa wa vp cv cK
      wcel vy cv vp cv wcel simprl cJ ctop wcel cK ctop wcel cX cY wceq w3a vq
      cv cJ wcel vy cv vq cv wcel wa wa vp cv cK wcel vy cv vp cv wcel simprr
      syl3anc expr r19.21aiva vy cv cY wcel vy cv vp cv wcel vp cv vy cv csn cK
      cnei cfv cfv wcel wi vp cK wral wa vy cv cY wcel vy cv vp cv wcel vp cv
      vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vy cv cX wcel vy cv vo cv
      wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa wi vy cv cX
      wcel vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral
      wa cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv
      wcel wa wa vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex vy cv cY wcel
      vy cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vy
      cv cX wcel vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ
      wral wa pm2.27 cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy
      cv vq cv wcel wa wa vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel
      wi vo cJ wral vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex vy cv cX
      wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv
      wcel wa wa vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ
      wral vy cv vq cv wcel vq cv vy cv csn cK cnei cfv cfv wcel wi vy cv vr cv
      wcel vr cv vq cv wss wa vr cK wrex vq cv cJ wcel vy cv vo cv wcel vo cv
      vy cv csn cK cnei cfv cfv wcel wi vo cJ wral vy cv vq cv wcel vq cv vy cv
      csn cK cnei cfv cfv wcel wi wi cJ ctop wcel cK ctop wcel cX cY wceq w3a
      vy cv vq cv wcel vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi
      vy cv vq cv wcel vq cv vy cv csn cK cnei cfv cfv wcel wi vo vq cv cJ vo
      cv vq cv wceq vy cv vo cv wcel vy cv vq cv wcel vo cv vy cv csn cK cnei
      cfv cfv wcel vq cv vy cv csn cK cnei cfv cfv wcel vo cv vq cv vy cv eleq2
      vo cv vq cv vy cv csn cK cnei cfv cfv eleq1 imbi12d rcla4v ad2antrl cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel vy cv vq cv wcel vy
      cv vq cv wcel vq cv vy cv csn cK cnei cfv cfv wcel wi vy cv vr cv wcel vr
      cv vq cv wss wa vr cK wrex wi vy cv vq cv wcel vy cv vq cv wcel vq cv vy
      cv csn cK cnei cfv cfv wcel wi vq cv vy cv csn cK cnei cfv cfv wcel cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vq cv cJ wcel wa vy cv vr cv wcel
      vr cv vq cv wss wa vr cK wrex vy cv vq cv wcel vq cv vy cv csn cK cnei
      cfv cfv wcel pm2.27 cJ ctop wcel cK ctop wcel cX cY wceq w3a vq cv vy cv
      csn cK cnei cfv cfv wcel vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex
      wi vq cv cJ wcel cK ctop wcel cJ ctop wcel vq cv vy cv csn cK cnei cfv
      cfv wcel vy cv vr cv wcel vr cv vq cv wss wa vr cK wrex wi cX cY wceq cK
      ctop wcel vq cv vy cv csn cK cnei cfv cfv wcel vy cv vr cv wcel vr cv vq
      cv wss wa vr cK wrex cK ctop wcel vq cv vy cv csn cK cnei cfv cfv wcel wa
      vy cv csn vr cv wss vr cv vq cv wss wa vr cK wrex vy cv vr cv wcel vr cv
      vq cv wss wa vr cK wrex vy cv csn vr cK vq cv neii2 vy cv vr cv wcel vr
      cv vq cv wss wa vy cv csn vr cv wss vr cv vq cv wss wa vr cK vy cv vr cv
      wcel vy cv csn vr cv wss vr cv vq cv wss vy cv vr cv vy visset snss
      anbi1i rexbii sylibr ex 3ad2ant2 adantr syl9r impr syld adantld syl9r
      mp2and vx cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei cfv cfv
      wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo cv vy cv csn cK
      cnei cfv cfv wcel wi vo cJ wral wa wi vy cv cY wcel vy cv vp cv wcel vp
      cv vy cv csn cK cnei cfv cfv wcel wi vp cK wral wa vy cv cX wcel vy cv vo
      cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa wi vx vy vx
      cv vy cv wceq vx cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei cfv
      cfv wcel wi vp cK wral wa vy cv cY wcel vy cv vp cv wcel vp cv vy cv csn
      cK cnei cfv cfv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo
      cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa vy cv cX wcel vy cv vo
      cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral wa vx cv vy cv
      wceq vx cv cY wcel vy cv cY wcel vx cv vp cv wcel vp cv vy cv csn cK cnei
      cfv cfv wcel wi vp cK wral vy cv vp cv wcel vp cv vy cv csn cK cnei cfv
      cfv wcel wi vp cK wral vx cv vy cv cY eleq1 vx cv vy cv wceq vx cv vp cv
      wcel vp cv vy cv csn cK cnei cfv cfv wcel wi vy cv vp cv wcel vp cv vy cv
      csn cK cnei cfv cfv wcel wi vp cK vx cv vy cv wceq vx cv vp cv wcel vy cv
      vp cv wcel vp cv vy cv csn cK cnei cfv cfv wcel vx cv vy cv vp cv eleq1
      imbi1d ralbidv anbi12d vx cv vy cv wceq vx cv cX wcel vy cv cX wcel vx cv
      vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral vy cv vo cv
      wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ wral vx cv vy cv cX
      eleq1 vx cv vy cv wceq vx cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv
      wcel wi vy cv vo cv wcel vo cv vy cv csn cK cnei cfv cfv wcel wi vo cJ vx
      cv vy cv wceq vx cv vo cv wcel vy cv vo cv wcel vo cv vy cv csn cK cnei
      cfv cfv wcel vx cv vy cv vo cv eleq1 imbi1d ralbidv anbi12d imbi12d a4v
      syl5 syl9r mpd syld ex com23 imp r19.21aivv jca cJ ctop wcel cK ctop wcel
      cX cY wceq w3a cJ cK cfne wbr cX cY wceq vy cv vr cv wcel vr cv vq cv wss
      wa vr cK wrex vy vq cv wral vq cJ wral wa wb cX vf cv cuni wceq vx cv cY
      wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx
      cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal wi vf cfil wral
      cK ctop wcel cJ ctop wcel cJ cK cfne wbr cX cY wceq vy cv vr cv wcel vr
      cv vq cv wss wa vr cK wrex vy vq cv wral vq cJ wral wa wb cX cY wceq vq
      vy vr cJ cK ctop cX cY limfilcf.1 limfilcf.2 isfne2 3ad2ant2 adantr
      mpbird impbida cJ ctop wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni
      wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx
      cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx wal
      wi cX vf cv cuni wceq vx cv vf cv cK cflim1 cfv cfv wcel vx cv vf cv cJ
      cflim1 cfv cfv wcel wi vx wal wi vf cfil cJ ctop wcel cK ctop wcel cX cY
      wceq w3a vf cv cfil wcel wa cX vf cv cuni wceq vx cv cY wcel vx cv vp cv
      wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx cv vo cv wcel vo
      cv vf cv wcel wi vo cJ wral wa wi vx wal vx cv vf cv cK cflim1 cfv cfv
      wcel vx cv vf cv cJ cflim1 cfv cfv wcel wi vx wal cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vf cv cfil wcel wa cX vf cv cuni wceq wa vx cv cY
      wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cX wcel vx
      cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wi vx cv vf cv cK cflim1
      cfv cfv wcel vx cv vf cv cJ cflim1 cfv cfv wcel wi vx cJ ctop wcel cK
      ctop wcel cX cY wceq w3a vf cv cfil wcel wa cX vf cv cuni wceq wa vx cv
      cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv vf cv cK
      cflim1 cfv cfv wcel vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo
      cJ wral wa vx cv vf cv cJ cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vf cv cfil wcel wa cX vf cv cuni wceq cY vf cv cuni wceq
      vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv vf
      cv cK cflim1 cfv cfv wcel wb cJ ctop wcel cK ctop wcel cX cY wceq w3a cX
      vf cv cuni wceq cY vf cv cuni wceq vf cv cfil wcel cX cY wceq cJ ctop
      wcel cX vf cv cuni wceq cY vf cv cuni wceq cK ctop wcel cX cY vf cv cuni
      eqtr2 3ad2antl3 adantlr cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv
      cfil wcel cY vf cv cuni wceq vx cv cY wcel vx cv vp cv wcel vp cv vf cv
      wcel wi vp cK wral wa vx cv vf cv cK cflim1 cfv cfv wcel wb cK ctop wcel
      cJ ctop wcel vf cv cfil wcel cY vf cv cuni wceq wa vx cv cY wcel vx cv vp
      cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv vf cv cK cflim1 cfv cfv
      wcel wb cX cY wceq cK ctop wcel vf cv cfil wcel cY vf cv cuni wceq vx cv
      cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv vf cv cK
      cflim1 cfv cfv wcel wb cK ctop wcel vf cv cfil wcel cY vf cv cuni wceq
      w3a vx cv vf cv cK cflim1 cfv cfv wcel vx cv cY wcel vx cv vp cv wcel vp
      cv vf cv wcel wi vp cK wral wa cK ctop wcel vf cv cfil wcel cY vf cv cuni
      wceq w3a vx cv vf cv cK cflim1 cfv cfv wcel vx cv cY wcel vx cv vp cv
      wcel vp cv vf cv wcel wi vp cK wral wa cK ctop wcel vf cv cfil wcel cY vf
      cv cuni wceq w3a vx cv cY wcel wa cK ctop wcel vf cv cfil wcel cY vf cv
      cuni wceq w3a vx cv vf cv cK cflim1 cfv cfv wcel wa cK ctop wcel vf cv
      cfil wcel cY vf cv cuni wceq w3a vx cv cY wcel cK ctop wcel vf cv cfil
      wcel cY vf cv cuni wceq w3a vx cv vf cv cK cflim1 cfv cfv wcel pm3.26 vx
      cv vf cv cK cY vf cv cuni limfilcf.2 vf cv cuni eqid flimelbas jca vx cv
      cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv cY wcel
      cK ctop wcel vf cv cfil wcel cY vf cv cuni wceq w3a vx cv cY wcel vx cv
      vp cv wcel vp cv vf cv wcel wi vp cK wral pm3.26 anim2i cK ctop wcel vf
      cv cfil wcel cY vf cv cuni wceq w3a vx cv cY wcel wa vx cv vf cv cK
      cflim1 cfv cfv wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral vx cv
      cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK wral wa vx cv vp vf cv
      cK cY vf cv cuni limfilcf.2 vf cv cuni eqid flimopn vx cv cY wcel vx cv
      vp cv wcel vp cv vf cv wcel wi vp cK wral vx cv cY wcel vx cv vp cv wcel
      vp cv vf cv wcel wi vp cK wral wa wb cK ctop wcel vf cv cfil wcel cY vf
      cv cuni wceq w3a vx cv cY wcel vx cv vp cv wcel vp cv vf cv wcel wi vp cK
      wral ibar adantl bitrd pm5.21nd bicomd 3expb 3ad2antl2 anassrs syldan cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil wcel wa cX vf cv cuni
      wceq wa vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cX wcel vx cv vo cv wcel
      vo cv vf cv wcel wi vo cJ wral wa cJ ctop wcel cK ctop wcel cX cY wceq
      w3a vf cv cfil wcel cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel
      vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa wb cJ
      ctop wcel cK ctop wcel vf cv cfil wcel cX vf cv cuni wceq wa vx cv vf cv
      cJ cflim1 cfv cfv wcel vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi
      vo cJ wral wa wb cX cY wceq cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cX wcel vx cv vo cv wcel vo
      cv vf cv wcel wi vo cJ wral wa wb cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cX wcel vx cv vo
      cv wcel vo cv vf cv wcel wi vo cJ wral wa cJ ctop wcel vf cv cfil wcel cX
      vf cv cuni wceq w3a vx cv cX wcel wa cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel wa cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv cX wcel cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vx cv vf cv cJ cflim1 cfv cfv wcel pm3.26 vx
      cv vf cv cJ cX vf cv cuni limfilcf.1 vf cv cuni eqid flimelbas jca vx cv
      cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa vx cv cX wcel
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv cX wcel vx cv
      vo cv wcel vo cv vf cv wcel wi vo cJ wral pm3.26 anim2i cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq w3a vx cv cX wcel wa vx cv vf cv cJ
      cflim1 cfv cfv wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral vx cv
      cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ wral wa vx cv vo vf cv
      cJ cX vf cv cuni limfilcf.1 vf cv cuni eqid flimopn vx cv cX wcel vx cv
      vo cv wcel vo cv vf cv wcel wi vo cJ wral vx cv cX wcel vx cv vo cv wcel
      vo cv vf cv wcel wi vo cJ wral wa wb cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vx cv cX wcel vx cv vo cv wcel vo cv vf cv wcel wi vo cJ
      wral ibar adantl bitrd pm5.21nd 3expb 3ad2antl1 anassrs bicomd imbi12d
      albidv pm5.74da ralbidva bitrd cX vf cv cuni wceq vf cv cK cflim1 cfv cfv
      vf cv cJ cflim1 cfv cfv wss wi cX vf cv cuni wceq vx cv vf cv cK cflim1
      cfv cfv wcel vx cv vf cv cJ cflim1 cfv cfv wcel wi vx wal wi vf cfil vf
      cv cK cflim1 cfv cfv vf cv cJ cflim1 cfv cfv wss vx cv vf cv cK cflim1
      cfv cfv wcel vx cv vf cv cJ cflim1 cfv cfv wcel wi vx wal cX vf cv cuni
      wceq vx vf cv cK cflim1 cfv cfv vf cv cJ cflim1 cfv cfv dfss2 imbi2i
      ralbii syl6bbr bitrd $.
      $( [28-Sep-2009] $) $( [28-Sep-2009] $)
  $}

  ${
    $d f o x y A $. $d f o x y J $. $d f o x y S $. $d f o x y X $.
    flimcls.1 $e |- X = U. J $.
    $( Closure in terms of filter convergence. (Contributed by Jeff Hankins,
       28-Nov-2009.) $)
    flimcls $p |- ( ( J e. Top /\ S C_ X /\ A e. X ) -> ( A e. ( ( cls ` J ) `
    S ) <-> E. f e. Fil ( X = U. f /\ S e. f /\ A e. ( ( fLim1 ` J ) ` f ) ) )
    ) $=
      cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel cX vf cv
      cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a vf cfil wrex
      cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel cX vf cv
      cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a vf cfil wrex
      cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cfil wcel cX cA csn cJ
      cnei cfv cfv cS csn cun cfi cfv cfg cfv cuni wceq cS cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv cfg cfv wcel cA cA csn cJ cnei cfv cfv cS csn cun
      cfi cfv cfg cfv cJ cflim1 cfv cfv wcel w3a cX vf cv cuni wceq cS vf cv
      wcel cA vf cv cJ cflim1 cfv cfv wcel w3a vf cfil wrex cJ ctop wcel cS cX
      wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX vf cv cuni wceq cS vf
      cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a cX cA csn cJ cnei cfv cfv cS
      csn cun cfi cfv cfg cfv cuni wceq cS cA csn cJ cnei cfv cfv cS csn cun
      cfi cfv cfg cfv wcel cA cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv
      cJ cflim1 cfv cfv wcel w3a vf cA csn cJ cnei cfv cfv cS csn cun cfi cfv
      cfg cfv cfil vf cv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv wceq
      cX vf cv cuni wceq cX cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv
      cuni wceq cS vf cv wcel cS cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg
      cfv wcel cA vf cv cJ cflim1 cfv cfv wcel cA cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel vf cv cA csn cJ cnei cfv cfv
      cS csn cun cfi cfv cfg cfv wceq vf cv cuni cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfg cfv cuni cX vf cv cA csn cJ cnei cfv cfv cS csn cun cfi
      cfv cfg cfv unieq eqeq2d vf cv cA csn cJ cnei cfv cfv cS csn cun cfi cfv
      cfg cfv cS eleq2 vf cv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv
      wceq vf cv cJ cflim1 cfv cfv cA csn cJ cnei cfv cfv cS csn cun cfi cfv
      cfg cfv cJ cflim1 cfv cfv cA vf cv cA csn cJ cnei cfv cfv cS csn cun cfi
      cfv cfg cfv cJ cflim1 cfv fveq2 eleq2d 3anbi123d rcla4ev cJ ctop wcel cS
      cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv
      cS csn cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun cfi cfv
      cfg cfv cfil wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv
      cfv wcel wa cA csn cJ cnei cfv cfv cS csn cun c0 wne c0 cA csn cJ cnei
      cfv cfv cS csn cun cfi cfv wnel wa cA csn cJ cnei cfv cfv cS csn cun cfi
      cfv cfbas wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa cA csn cJ cnei cfv cfv cS csn cun c0 wne c0 cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv wnel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn
      cJ cnei cfv cfv cS csn cun c0 wne cA cS cJ ccl cfv cfv wcel cJ ctop wcel
      cS cX wss cA csn cJ cnei cfv cfv cS csn cun c0 wne cA cX wcel cJ ctop
      wcel cS cX wss wa cS cvv wcel cS csn c0 wne cA csn cJ cnei cfv cfv cS csn
      cun c0 wne cS cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS
      cvv wcel cJ ctop wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg flimcls.1 syl5eqel sylan2 ancoms cS cvv snnzg cS csn cA csn cJ
      cnei cfv cfv cS csn cun wss cS csn c0 wne cA csn cJ cnei cfv cfv cS csn
      cun c0 wne cS csn cA csn cJ cnei cfv cfv ssun2 cS csn cA csn cJ cnei cfv
      cfv cS csn cun ssn0 mpan 3syl 3adant3 adantr cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel wa c0 cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv wnel vx cv vy cv cin c0 wne vy cS csn wral vx cA csn cJ cnei
      cfv cfv wral cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa vx cv vy cv cin c0 wne vx vy cA csn cJ cnei cfv cfv cS csn cJ
      ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv cA
      csn cJ cnei cfv cfv wcel vy cv cS csn wcel vx cv vy cv cin c0 wne cJ ctop
      wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv cA csn
      cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy cv cin c0 wne vy cv cS csn
      wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx
      cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy cv cin c0 wne wi vy
      cv cS wceq vx cv vy cv cin c0 wne vx cv cS cin c0 wne cJ ctop wcel cS cX
      wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx cv cA csn cJ cnei cfv cfv
      wcel wa wa vy cv cS wceq vx cv vy cv cin vx cv cS cin c0 vy cv cS vx cv
      ineq2 neeq1d cJ ctop wcel cS cX wss cA cS cJ ccl cfv cfv wcel vx cv cA
      csn cJ cnei cfv cfv wcel wa vx cv cS cin c0 wne cA cX wcel cA cS cJ vx cv
      cX flimcls.1 neindisj 3adantl3 syl5cbir expr vy cS elsn syl7ib imp3a
      r19.21aivv cA csn cJ cnei cfv cfv cfbas wcel cS csn cfbas wcel c0 cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cS csn
      wral vx cA csn cJ cnei cfv cfv wral wb cJ ctop wcel cS cX wss cA cX wcel
      w3a cA cS cJ ccl cfv cfv wcel wa vx vy cA csn cJ cnei cfv cfv cS csn
      fbunfip cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv
      cfbas wcel cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cA cX wcel
      w3a cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ
      ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ
      ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cX flimcls.1 neifil cJ ctop
      wcel cS cX wss cA cX wcel 3simp1 cA cX wcel cJ ctop wcel cA csn cX wss cS
      cX wss cA cX snssi 3ad2ant3 cA cX wcel cJ ctop wcel cA csn c0 wne cS cX
      wss cA cX snnzg 3ad2ant3 syl3anc cA csn cJ cnei cfv cfv filfbas syl
      adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel cS
      c0 wne cS csn cfbas wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel cS c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel cS c0 cS c0 wceq cA cS cJ ccl cfv cfv wcel wn cA c0 cJ
      ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cA cX wcel w3a cS c0 wceq cA
      cS cJ ccl cfv cfv wcel cA c0 cJ ccl cfv cfv wcel cS c0 wceq cS cJ ccl cfv
      cfv c0 cJ ccl cfv cfv cA cS c0 cJ ccl cfv fveq2 eleq2d notbid cJ ctop
      wcel cS cX wss cA c0 cJ ccl cfv cfv wcel wn cA cX wcel cJ ctop wcel cA c0
      cJ ccl cfv cfv wcel cA c0 wcel cA noel cJ ctop wcel c0 cJ ccl cfv cfv c0
      cA cJ cls0 eleq2d mtbiri 3ad2ant1 syl5cbir necon2ad imp cJ ctop wcel cS
      cX wss cA cX wcel w3a cS c0 wne wa cS csn cfil wcel cS csn cfbas wcel cJ
      ctop wcel cS cX wss cS c0 wne cS csn cfil wcel cA cX wcel cS cvv wcel cS
      c0 wne cS csn cfil wcel cJ ctop wcel cS cX wss wa cS cvv oefil2 cS cX wss
      cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop wcel
      cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1
      syl5eqel sylan2 ancoms sylan 3adantl3 cS csn filfbas syl syldan sylanc
      mpbird jca cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun c0
      wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa wb cA csn cJ
      cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn cJ cnei
      cfv cfv cS csn cun cvv fsubbas ax-mp sylibr cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv fgfil syl cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl
      cfv cfv wcel wa cX cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cuni
      wceq cS cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv wcel cA cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cJ ctop
      wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX cS cun cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cX cA csn cJ cnei cfv cfv cS
      csn cun cfi cfv cfg cfv cuni cJ ctop wcel cS cX wss cA cX wcel w3a cA cS
      cJ ccl cfv cfv wcel wa cX cS cun cA csn cJ cnei cfv cfv cS csn cun cuni
      cA csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX cS cun cA csn cJ cnei cfv cfv
      cuni cS csn cuni cun cA csn cJ cnei cfv cfv cS csn cun cuni cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX cA csn cJ cnei
      cfv cfv cuni cS cS csn cuni cJ ctop wcel cS cX wss cA cX wcel w3a cA cS
      cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cuni cX cJ ctop wcel cS cX
      wss cA cX wcel w3a cA csn cJ cnei cfv cfv cuni cX wceq cA cS cJ ccl cfv
      cfv wcel cJ ctop wcel cA cX wcel cA csn cJ cnei cfv cfv cuni cX wceq cS
      cX wss cJ ctop wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX wceq cA
      cX wcel cA csn cJ cX flimcls.1 unnei cA cX snssi sylan2 3adant2 adantr
      eqcomd cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa
      cS csn cuni cS cJ ctop wcel cS cX wss cA cX wcel w3a cS csn cuni cS wceq
      cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cS csn cuni cS wceq cA
      cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS csn cuni cS wceq cS cX
      wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop
      wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1
      syl5eqel sylan2 ancoms cS cvv unisng syl 3adant3 adantr eqcomd uneq12d cA
      csn cJ cnei cfv cfv cS csn uniun syl6eqr cA csn cJ cnei cfv cfv cS csn
      cun cvv wcel cA csn cJ cnei cfv cfv cS csn cun cuni cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv cuni wceq cA csn cJ cnei cfv cfv cS csn cA csn cJ
      cnei cfv fvex cS snex unex cA csn cJ cnei cfv cfv cS csn cun cvv fiuni
      ax-mp syl6eq cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa cS cX wss cX cS cun cX wceq cJ ctop wcel cS cX wss cA cX wcel cA
      cS cJ ccl cfv cfv wcel 3simpl2 cS cX ssequn2 sylib cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cuni wceq cJ ctop wcel cS
      cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv
      cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas wcel cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel cJ ctop wcel
      cS cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv cS csn cun c0 wne cA cS
      cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cA csn cJ cnei cfv cfv cS csn
      cun c0 wne cA cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS csn c0 wne
      cA csn cJ cnei cfv cfv cS csn cun c0 wne cS cX wss cJ ctop wcel cS cvv
      wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop wcel cS cX cvv ssexg cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1 syl5eqel sylan2 ancoms
      cS cvv snnzg cS csn cA csn cJ cnei cfv cfv cS csn cun wss cS csn c0 wne
      cA csn cJ cnei cfv cfv cS csn cun c0 wne cS csn cA csn cJ cnei cfv cfv
      ssun2 cS csn cA csn cJ cnei cfv cfv cS csn cun ssn0 mpan 3syl 3adant3
      adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa
      c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv cin c0 wne
      vy cS csn wral vx cA csn cJ cnei cfv cfv wral cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cA
      csn cJ cnei cfv cfv cS csn cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS csn wcel
      vx cv vy cv cin c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl
      cfv cfv wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy
      cv cin c0 wne vy cv cS csn wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA
      cS cJ ccl cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx
      cv vy cv cin c0 wne wi vy cv cS wceq vx cv vy cv cin c0 wne vx cv cS cin
      c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx
      cv cA csn cJ cnei cfv cfv wcel wa wa vy cv cS wceq vx cv vy cv cin vx cv
      cS cin c0 vy cv cS vx cv ineq2 neeq1d cJ ctop wcel cS cX wss cA cS cJ ccl
      cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel wa vx cv cS cin c0 wne cA
      cX wcel cA cS cJ vx cv cX flimcls.1 neindisj 3adantl3 syl5cbir expr vy cS
      elsn syl7ib imp3a r19.21aivv cA csn cJ cnei cfv cfv cfbas wcel cS csn
      cfbas wcel c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv
      cin c0 wne vy cS csn wral vx cA csn cJ cnei cfv cfv wral wb cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx vy cA csn cJ
      cnei cfv cfv cS csn fbunfip cJ ctop wcel cS cX wss cA cX wcel w3a cA csn
      cJ cnei cfv cfv cfbas wcel cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX
      wss cA cX wcel w3a cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv
      cfv cfbas wcel cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei
      cfv cfv cfil wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cX
      flimcls.1 neifil cJ ctop wcel cS cX wss cA cX wcel 3simp1 cA cX wcel cJ
      ctop wcel cA csn cX wss cS cX wss cA cX snssi 3ad2ant3 cA cX wcel cJ ctop
      wcel cA csn c0 wne cS cX wss cA cX snnzg 3ad2ant3 syl3anc cA csn cJ cnei
      cfv cfv filfbas syl adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel cS c0 wne cS csn cfbas wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 wne cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 cS c0 wceq cA cS cJ ccl cfv cfv
      wcel wn cA c0 cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cA cX wcel
      w3a cS c0 wceq cA cS cJ ccl cfv cfv wcel cA c0 cJ ccl cfv cfv wcel cS c0
      wceq cS cJ ccl cfv cfv c0 cJ ccl cfv cfv cA cS c0 cJ ccl cfv fveq2 eleq2d
      notbid cJ ctop wcel cS cX wss cA c0 cJ ccl cfv cfv wcel wn cA cX wcel cJ
      ctop wcel cA c0 cJ ccl cfv cfv wcel cA c0 wcel cA noel cJ ctop wcel c0 cJ
      ccl cfv cfv c0 cA cJ cls0 eleq2d mtbiri 3ad2ant1 syl5cbir necon2ad imp cJ
      ctop wcel cS cX wss cA cX wcel w3a cS c0 wne wa cS csn cfil wcel cS csn
      cfbas wcel cJ ctop wcel cS cX wss cS c0 wne cS csn cfil wcel cA cX wcel
      cS cvv wcel cS c0 wne cS csn cfil wcel cJ ctop wcel cS cX wss wa cS cvv
      oefil2 cS cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv
      wcel cJ ctop wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg flimcls.1 syl5eqel sylan2 ancoms sylan 3adantl3 cS csn filfbas syl
      syldan sylanc mpbird jca cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv
      cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa wb
      cA csn cJ cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn
      cJ cnei cfv cfv cS csn cun cvv fsubbas ax-mp sylibr cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cuni eqid fgbas syl 3eqtr3d cJ
      ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cS csn cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cS cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cS csn cA csn cJ cnei cfv cfv
      cS csn cun cfi cfv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cS
      csn cA csn cJ cnei cfv cfv cS csn cun cfi cfv wss cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cS csn cA csn cJ cnei cfv cfv
      cS csn cun cA csn cJ cnei cfv cfv cS csn cun cfi cfv cS csn cA csn cJ
      cnei cfv cfv ssun2 cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA csn cJ
      cnei cfv cfv cS csn cun cA csn cJ cnei cfv cfv cS csn cun cfi cfv wss cA
      csn cJ cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn cJ
      cnei cfv cfv cS csn cun cvv abfi2 ax-mp sstri a1i cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun cfi cfv cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv wss cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa cA csn cJ
      cnei cfv cfv cS csn cun cfi cfv cfbas wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn cun
      c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel cJ ctop wcel cS
      cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv cS csn cun c0 wne cA cS cJ
      ccl cfv cfv wcel cJ ctop wcel cS cX wss cA csn cJ cnei cfv cfv cS csn cun
      c0 wne cA cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS csn c0 wne cA
      csn cJ cnei cfv cfv cS csn cun c0 wne cS cX wss cJ ctop wcel cS cvv wcel
      cS cX wss cX cvv wcel cS cvv wcel cJ ctop wcel cS cX cvv ssexg cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1 syl5eqel sylan2 ancoms cS
      cvv snnzg cS csn cA csn cJ cnei cfv cfv cS csn cun wss cS csn c0 wne cA
      csn cJ cnei cfv cfv cS csn cun c0 wne cS csn cA csn cJ cnei cfv cfv ssun2
      cS csn cA csn cJ cnei cfv cfv cS csn cun ssn0 mpan 3syl 3adant3 adantr cJ
      ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa c0 cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cS csn
      wral vx cA csn cJ cnei cfv cfv wral cJ ctop wcel cS cX wss cA cX wcel w3a
      cA cS cJ ccl cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cA csn cJ cnei
      cfv cfv cS csn cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS csn wcel vx cv vy cv
      cin c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy cv cin
      c0 wne vy cv cS csn wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy
      cv cin c0 wne wi vy cv cS wceq vx cv vy cv cin c0 wne vx cv cS cin c0 wne
      cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx cv cA
      csn cJ cnei cfv cfv wcel wa wa vy cv cS wceq vx cv vy cv cin vx cv cS cin
      c0 vy cv cS vx cv ineq2 neeq1d cJ ctop wcel cS cX wss cA cS cJ ccl cfv
      cfv wcel vx cv cA csn cJ cnei cfv cfv wcel wa vx cv cS cin c0 wne cA cX
      wcel cA cS cJ vx cv cX flimcls.1 neindisj 3adantl3 syl5cbir expr vy cS
      elsn syl7ib imp3a r19.21aivv cA csn cJ cnei cfv cfv cfbas wcel cS csn
      cfbas wcel c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv
      cin c0 wne vy cS csn wral vx cA csn cJ cnei cfv cfv wral wb cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx vy cA csn cJ
      cnei cfv cfv cS csn fbunfip cJ ctop wcel cS cX wss cA cX wcel w3a cA csn
      cJ cnei cfv cfv cfbas wcel cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX
      wss cA cX wcel w3a cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv
      cfv cfbas wcel cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei
      cfv cfv cfil wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cX
      flimcls.1 neifil cJ ctop wcel cS cX wss cA cX wcel 3simp1 cA cX wcel cJ
      ctop wcel cA csn cX wss cS cX wss cA cX snssi 3ad2ant3 cA cX wcel cJ ctop
      wcel cA csn c0 wne cS cX wss cA cX snnzg 3ad2ant3 syl3anc cA csn cJ cnei
      cfv cfv filfbas syl adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel cS c0 wne cS csn cfbas wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 wne cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 cS c0 wceq cA cS cJ ccl cfv cfv
      wcel wn cA c0 cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cA cX wcel
      w3a cS c0 wceq cA cS cJ ccl cfv cfv wcel cA c0 cJ ccl cfv cfv wcel cS c0
      wceq cS cJ ccl cfv cfv c0 cJ ccl cfv cfv cA cS c0 cJ ccl cfv fveq2 eleq2d
      notbid cJ ctop wcel cS cX wss cA c0 cJ ccl cfv cfv wcel wn cA cX wcel cJ
      ctop wcel cA c0 cJ ccl cfv cfv wcel cA c0 wcel cA noel cJ ctop wcel c0 cJ
      ccl cfv cfv c0 cA cJ cls0 eleq2d mtbiri 3ad2ant1 syl5cbir necon2ad imp cJ
      ctop wcel cS cX wss cA cX wcel w3a cS c0 wne wa cS csn cfil wcel cS csn
      cfbas wcel cJ ctop wcel cS cX wss cS c0 wne cS csn cfil wcel cA cX wcel
      cS cvv wcel cS c0 wne cS csn cfil wcel cJ ctop wcel cS cX wss wa cS cvv
      oefil2 cS cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv
      wcel cJ ctop wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg flimcls.1 syl5eqel sylan2 ancoms sylan 3adantl3 cS csn filfbas syl
      syldan sylanc mpbird jca cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv
      cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa wb
      cA csn cJ cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn
      cJ cnei cfv cfv cS csn cun cvv fsubbas ax-mp sylibr cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv fbssfg syl sstrd cJ ctop wcel cS cX wss cA cX wcel
      w3a cS cS csn wcel cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cS cS
      csn wcel cA cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS cS csn wcel
      cS cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv wcel cJ
      ctop wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      flimcls.1 syl5eqel sylan2 ancoms cS cvv snidg syl 3adant3 adantr sseldd
      cJ ctop wcel cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cS
      csn cun cfi cfv cfg cfv cfil wcel w3a cX cA csn cJ cnei cfv cfv cuni wceq
      cX cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cuni wceq w3a cA csn
      cJ cnei cfv cfv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv wss cA
      cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel cA cA csn cJ cnei cfv cfv
      cS csn cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA cA csn cJ cnei cfv cfv cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cJ cX cA csn cJ cnei cfv
      cfv cuni cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cuni flimcls.1
      cA csn cJ cnei cfv cfv cuni eqid cA csn cJ cnei cfv cfv cS csn cun cfi
      cfv cfg cfv cuni eqid limfilss cJ ctop wcel cS cX wss cA cX wcel w3a cA
      cS cJ ccl cfv cfv wcel wa cJ ctop wcel cA csn cJ cnei cfv cfv cfil wcel
      cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cfil wcel w3a cX cA csn
      cJ cnei cfv cfv cuni wceq cX cA csn cJ cnei cfv cfv cS csn cun cfi cfv
      cfg cfv cuni wceq cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv
      cfv wcel wa cJ ctop wcel cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei
      cfv cfv cS csn cun cfi cfv cfg cfv cfil wcel cJ ctop wcel cS cX wss cA cX
      wcel cA cS cJ ccl cfv cfv wcel 3simpl1 cJ ctop wcel cA csn cX wss cA csn
      c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel cS cX wss cA cX wcel
      w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cX flimcls.1 neifil cJ ctop
      wcel cS cX wss cA cX wcel cA cS cJ ccl cfv cfv wcel 3simpl1 cJ ctop wcel
      cS cX wss cA cX wcel w3a cA csn cX wss cA cS cJ ccl cfv cfv wcel cA cX
      wcel cJ ctop wcel cA csn cX wss cS cX wss cA cX snssi 3ad2ant3 adantr cA
      cS cJ ccl cfv cfv wcel cA csn c0 wne cJ ctop wcel cS cX wss cA cX wcel
      w3a cA cS cJ ccl cfv cfv snnzg adantl syl3anc cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv
      cfil wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel
      wa cA csn cJ cnei cfv cfv cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS
      csn cun cfi cfv wnel wa cA csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas
      wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa
      cA csn cJ cnei cfv cfv cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv wnel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cnei cfv
      cfv cS csn cun c0 wne cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cA
      csn cJ cnei cfv cfv cS csn cun c0 wne cA cX wcel cJ ctop wcel cS cX wss
      wa cS cvv wcel cS csn c0 wne cA csn cJ cnei cfv cfv cS csn cun c0 wne cS
      cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop
      wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1
      syl5eqel sylan2 ancoms cS cvv snnzg cS csn cA csn cJ cnei cfv cfv cS csn
      cun wss cS csn c0 wne cA csn cJ cnei cfv cfv cS csn cun c0 wne cS csn cA
      csn cJ cnei cfv cfv ssun2 cS csn cA csn cJ cnei cfv cfv cS csn cun ssn0
      mpan 3syl 3adant3 adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel wa c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx
      cv vy cv cin c0 wne vy cS csn wral vx cA csn cJ cnei cfv cfv wral cJ ctop
      wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv vy cv
      cin c0 wne vx vy cA csn cJ cnei cfv cfv cS csn cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv cA csn cJ cnei cfv cfv
      wcel vy cv cS csn wcel vx cv vy cv cin c0 wne cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv cA csn cJ cnei cfv cfv
      wcel vy cv cS wceq vx cv vy cv cin c0 wne vy cv cS csn wcel cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx cv cA csn cJ cnei
      cfv cfv wcel vy cv cS wceq vx cv vy cv cin c0 wne wi vy cv cS wceq vx cv
      vy cv cin c0 wne vx cv cS cin c0 wne cJ ctop wcel cS cX wss cA cX wcel
      w3a cA cS cJ ccl cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel wa wa vy
      cv cS wceq vx cv vy cv cin vx cv cS cin c0 vy cv cS vx cv ineq2 neeq1d cJ
      ctop wcel cS cX wss cA cS cJ ccl cfv cfv wcel vx cv cA csn cJ cnei cfv
      cfv wcel wa vx cv cS cin c0 wne cA cX wcel cA cS cJ vx cv cX flimcls.1
      neindisj 3adantl3 syl5cbir expr vy cS elsn syl7ib imp3a r19.21aivv cA csn
      cJ cnei cfv cfv cfbas wcel cS csn cfbas wcel c0 cA csn cJ cnei cfv cfv cS
      csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cS csn wral vx cA csn cJ
      cnei cfv cfv wral wb cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl
      cfv cfv wcel wa vx vy cA csn cJ cnei cfv cfv cS csn fbunfip cJ ctop wcel
      cS cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv cfbas wcel cA cS cJ ccl
      cfv cfv wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv
      cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel cA csn cX wss cA
      csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA csn cJ cX flimcls.1 neifil cJ ctop wcel cS cX wss cA cX wcel
      3simp1 cA cX wcel cJ ctop wcel cA csn cX wss cS cX wss cA cX snssi
      3ad2ant3 cA cX wcel cJ ctop wcel cA csn c0 wne cS cX wss cA cX snnzg
      3ad2ant3 syl3anc cA csn cJ cnei cfv cfv filfbas syl adantr cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 wne cS csn cfbas
      wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel cS
      c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel cS
      c0 cS c0 wceq cA cS cJ ccl cfv cfv wcel wn cA c0 cJ ccl cfv cfv wcel wn
      cJ ctop wcel cS cX wss cA cX wcel w3a cS c0 wceq cA cS cJ ccl cfv cfv
      wcel cA c0 cJ ccl cfv cfv wcel cS c0 wceq cS cJ ccl cfv cfv c0 cJ ccl cfv
      cfv cA cS c0 cJ ccl cfv fveq2 eleq2d notbid cJ ctop wcel cS cX wss cA c0
      cJ ccl cfv cfv wcel wn cA cX wcel cJ ctop wcel cA c0 cJ ccl cfv cfv wcel
      cA c0 wcel cA noel cJ ctop wcel c0 cJ ccl cfv cfv c0 cA cJ cls0 eleq2d
      mtbiri 3ad2ant1 syl5cbir necon2ad imp cJ ctop wcel cS cX wss cA cX wcel
      w3a cS c0 wne wa cS csn cfil wcel cS csn cfbas wcel cJ ctop wcel cS cX
      wss cS c0 wne cS csn cfil wcel cA cX wcel cS cvv wcel cS c0 wne cS csn
      cfil wcel cJ ctop wcel cS cX wss wa cS cvv oefil2 cS cX wss cJ ctop wcel
      cS cvv wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop wcel cS cX cvv
      ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1 syl5eqel
      sylan2 ancoms sylan 3adantl3 cS csn filfbas syl syldan sylanc mpbird jca
      cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun c0 wne c0 cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv wnel wa wb cA csn cJ cnei cfv cfv cS
      csn cA csn cJ cnei cfv fvex cS snex unex cA csn cJ cnei cfv cfv cS csn
      cun cvv fsubbas ax-mp sylibr cA csn cJ cnei cfv cfv cS csn cun cfi cfv
      fgfil syl 3jca cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa cA csn cJ cnei cfv cfv cuni cX cJ ctop wcel cS cX wss cA cX wcel
      w3a cA csn cJ cnei cfv cfv cuni cX wceq cA cS cJ ccl cfv cfv wcel cJ ctop
      wcel cA cX wcel cA csn cJ cnei cfv cfv cuni cX wceq cS cX wss cJ ctop
      wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX wceq cA cX wcel cA csn
      cJ cX flimcls.1 unnei cA cX snssi sylan2 3adant2 adantr eqcomd cJ ctop
      wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX cS cun cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cX cA csn cJ cnei cfv cfv cS
      csn cun cfi cfv cfg cfv cuni cJ ctop wcel cS cX wss cA cX wcel w3a cA cS
      cJ ccl cfv cfv wcel wa cX cS cun cA csn cJ cnei cfv cfv cS csn cun cuni
      cA csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX cS cun cA csn cJ cnei cfv cfv
      cuni cS csn cuni cun cA csn cJ cnei cfv cfv cS csn cun cuni cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cX cA csn cJ cnei
      cfv cfv cuni cS cS csn cuni cJ ctop wcel cS cX wss cA cX wcel w3a cA cS
      cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cuni cX cJ ctop wcel cS cX
      wss cA cX wcel w3a cA csn cJ cnei cfv cfv cuni cX wceq cA cS cJ ccl cfv
      cfv wcel cJ ctop wcel cA cX wcel cA csn cJ cnei cfv cfv cuni cX wceq cS
      cX wss cJ ctop wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX wceq cA
      cX wcel cA csn cJ cX flimcls.1 unnei cA cX snssi sylan2 3adant2 adantr
      eqcomd cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa
      cS csn cuni cS cJ ctop wcel cS cX wss cA cX wcel w3a cS csn cuni cS wceq
      cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cS csn cuni cS wceq cA
      cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS csn cuni cS wceq cS cX
      wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop
      wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1
      syl5eqel sylan2 ancoms cS cvv unisng syl 3adant3 adantr eqcomd uneq12d cA
      csn cJ cnei cfv cfv cS csn uniun syl6eqr cA csn cJ cnei cfv cfv cS csn
      cun cvv wcel cA csn cJ cnei cfv cfv cS csn cun cuni cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv cuni wceq cA csn cJ cnei cfv cfv cS csn cA csn cJ
      cnei cfv fvex cS snex unex cA csn cJ cnei cfv cfv cS csn cun cvv fiuni
      ax-mp syl6eq cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa cS cX wss cX cS cun cX wceq cJ ctop wcel cS cX wss cA cX wcel cA
      cS cJ ccl cfv cfv wcel 3simpl2 cS cX ssequn2 sylib cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv cuni wceq cJ ctop wcel cS
      cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv
      cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas wcel cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel cJ ctop wcel
      cS cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv cS csn cun c0 wne cA cS
      cJ ccl cfv cfv wcel cJ ctop wcel cS cX wss cA csn cJ cnei cfv cfv cS csn
      cun c0 wne cA cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS csn c0 wne
      cA csn cJ cnei cfv cfv cS csn cun c0 wne cS cX wss cJ ctop wcel cS cvv
      wcel cS cX wss cX cvv wcel cS cvv wcel cJ ctop wcel cS cX cvv ssexg cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1 syl5eqel sylan2 ancoms
      cS cvv snnzg cS csn cA csn cJ cnei cfv cfv cS csn cun wss cS csn c0 wne
      cA csn cJ cnei cfv cfv cS csn cun c0 wne cS csn cA csn cJ cnei cfv cfv
      ssun2 cS csn cA csn cJ cnei cfv cfv cS csn cun ssn0 mpan 3syl 3adant3
      adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa
      c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv cin c0 wne
      vy cS csn wral vx cA csn cJ cnei cfv cfv wral cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cA
      csn cJ cnei cfv cfv cS csn cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS csn wcel
      vx cv vy cv cin c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl
      cfv cfv wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy
      cv cin c0 wne vy cv cS csn wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA
      cS cJ ccl cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx
      cv vy cv cin c0 wne wi vy cv cS wceq vx cv vy cv cin c0 wne vx cv cS cin
      c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx
      cv cA csn cJ cnei cfv cfv wcel wa wa vy cv cS wceq vx cv vy cv cin vx cv
      cS cin c0 vy cv cS vx cv ineq2 neeq1d cJ ctop wcel cS cX wss cA cS cJ ccl
      cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel wa vx cv cS cin c0 wne cA
      cX wcel cA cS cJ vx cv cX flimcls.1 neindisj 3adantl3 syl5cbir expr vy cS
      elsn syl7ib imp3a r19.21aivv cA csn cJ cnei cfv cfv cfbas wcel cS csn
      cfbas wcel c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv
      cin c0 wne vy cS csn wral vx cA csn cJ cnei cfv cfv wral wb cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx vy cA csn cJ
      cnei cfv cfv cS csn fbunfip cJ ctop wcel cS cX wss cA cX wcel w3a cA csn
      cJ cnei cfv cfv cfbas wcel cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX
      wss cA cX wcel w3a cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv
      cfv cfbas wcel cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei
      cfv cfv cfil wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cX
      flimcls.1 neifil cJ ctop wcel cS cX wss cA cX wcel 3simp1 cA cX wcel cJ
      ctop wcel cA csn cX wss cS cX wss cA cX snssi 3ad2ant3 cA cX wcel cJ ctop
      wcel cA csn c0 wne cS cX wss cA cX snnzg 3ad2ant3 syl3anc cA csn cJ cnei
      cfv cfv filfbas syl adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel cS c0 wne cS csn cfbas wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 wne cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 cS c0 wceq cA cS cJ ccl cfv cfv
      wcel wn cA c0 cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cA cX wcel
      w3a cS c0 wceq cA cS cJ ccl cfv cfv wcel cA c0 cJ ccl cfv cfv wcel cS c0
      wceq cS cJ ccl cfv cfv c0 cJ ccl cfv cfv cA cS c0 cJ ccl cfv fveq2 eleq2d
      notbid cJ ctop wcel cS cX wss cA c0 cJ ccl cfv cfv wcel wn cA cX wcel cJ
      ctop wcel cA c0 cJ ccl cfv cfv wcel cA c0 wcel cA noel cJ ctop wcel c0 cJ
      ccl cfv cfv c0 cA cJ cls0 eleq2d mtbiri 3ad2ant1 syl5cbir necon2ad imp cJ
      ctop wcel cS cX wss cA cX wcel w3a cS c0 wne wa cS csn cfil wcel cS csn
      cfbas wcel cJ ctop wcel cS cX wss cS c0 wne cS csn cfil wcel cA cX wcel
      cS cvv wcel cS c0 wne cS csn cfil wcel cJ ctop wcel cS cX wss wa cS cvv
      oefil2 cS cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv
      wcel cJ ctop wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg flimcls.1 syl5eqel sylan2 ancoms sylan 3adantl3 cS csn filfbas syl
      syldan sylanc mpbird jca cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv
      cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa wb
      cA csn cJ cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn
      cJ cnei cfv cfv cS csn cun cvv fsubbas ax-mp sylibr cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cuni cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cuni eqid fgbas syl 3eqtr3d 3jca
      cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn
      cJ cnei cfv cfv cA csn cJ cnei cfv cfv cS csn cun cfi cfv cA csn cJ cnei
      cfv cfv cS csn cun cfi cfv cfg cfv cA csn cJ cnei cfv cfv cA csn cJ cnei
      cfv cfv cS csn cun cfi cfv wss cJ ctop wcel cS cX wss cA cX wcel w3a cA
      cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cA csn cJ cnei cfv cfv
      cS csn cun cA csn cJ cnei cfv cfv cS csn cun cfi cfv cA csn cJ cnei cfv
      cfv cS csn ssun1 cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA csn cJ
      cnei cfv cfv cS csn cun cA csn cJ cnei cfv cfv cS csn cun cfi cfv wss cA
      csn cJ cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn cJ
      cnei cfv cfv cS csn cun cvv abfi2 ax-mp sstri a1i cJ ctop wcel cS cX wss
      cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv cS csn cun cfi cfv cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv cfg cfv wss cJ ctop wcel cS cX wss cA
      cX wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn
      cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa cA csn cJ
      cnei cfv cfv cS csn cun cfi cfv cfbas wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel wa cA csn cJ cnei cfv cfv cS csn cun
      c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel cJ ctop wcel cS
      cX wss cA cX wcel w3a cA csn cJ cnei cfv cfv cS csn cun c0 wne cA cS cJ
      ccl cfv cfv wcel cJ ctop wcel cS cX wss cA csn cJ cnei cfv cfv cS csn cun
      c0 wne cA cX wcel cJ ctop wcel cS cX wss wa cS cvv wcel cS csn c0 wne cA
      csn cJ cnei cfv cfv cS csn cun c0 wne cS cX wss cJ ctop wcel cS cvv wcel
      cS cX wss cX cvv wcel cS cvv wcel cJ ctop wcel cS cX cvv ssexg cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimcls.1 syl5eqel sylan2 ancoms cS
      cvv snnzg cS csn cA csn cJ cnei cfv cfv cS csn cun wss cS csn c0 wne cA
      csn cJ cnei cfv cfv cS csn cun c0 wne cS csn cA csn cJ cnei cfv cfv ssun2
      cS csn cA csn cJ cnei cfv cfv cS csn cun ssn0 mpan 3syl 3adant3 adantr cJ
      ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa c0 cA csn
      cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv cin c0 wne vy cS csn
      wral vx cA csn cJ cnei cfv cfv wral cJ ctop wcel cS cX wss cA cX wcel w3a
      cA cS cJ ccl cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cA csn cJ cnei
      cfv cfv cS csn cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS csn wcel vx cv vy cv
      cin c0 wne cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv
      wcel wa vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy cv cin
      c0 wne vy cv cS csn wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel vx cv cA csn cJ cnei cfv cfv wcel vy cv cS wceq vx cv vy
      cv cin c0 wne wi vy cv cS wceq vx cv vy cv cin c0 wne vx cv cS cin c0 wne
      cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel vx cv cA
      csn cJ cnei cfv cfv wcel wa wa vy cv cS wceq vx cv vy cv cin vx cv cS cin
      c0 vy cv cS vx cv ineq2 neeq1d cJ ctop wcel cS cX wss cA cS cJ ccl cfv
      cfv wcel vx cv cA csn cJ cnei cfv cfv wcel wa vx cv cS cin c0 wne cA cX
      wcel cA cS cJ vx cv cX flimcls.1 neindisj 3adantl3 syl5cbir expr vy cS
      elsn syl7ib imp3a r19.21aivv cA csn cJ cnei cfv cfv cfbas wcel cS csn
      cfbas wcel c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel vx cv vy cv
      cin c0 wne vy cS csn wral vx cA csn cJ cnei cfv cfv wral wb cJ ctop wcel
      cS cX wss cA cX wcel w3a cA cS cJ ccl cfv cfv wcel wa vx vy cA csn cJ
      cnei cfv cfv cS csn fbunfip cJ ctop wcel cS cX wss cA cX wcel w3a cA csn
      cJ cnei cfv cfv cfbas wcel cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS cX
      wss cA cX wcel w3a cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv
      cfv cfbas wcel cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei
      cfv cfv cfil wcel cJ ctop wcel cS cX wss cA cX wcel w3a cA csn cJ cX
      flimcls.1 neifil cJ ctop wcel cS cX wss cA cX wcel 3simp1 cA cX wcel cJ
      ctop wcel cA csn cX wss cS cX wss cA cX snssi 3ad2ant3 cA cX wcel cJ ctop
      wcel cA csn c0 wne cS cX wss cA cX snnzg 3ad2ant3 syl3anc cA csn cJ cnei
      cfv cfv filfbas syl adantr cJ ctop wcel cS cX wss cA cX wcel w3a cA cS cJ
      ccl cfv cfv wcel cS c0 wne cS csn cfbas wcel cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 wne cJ ctop wcel cS cX wss cA cX
      wcel w3a cA cS cJ ccl cfv cfv wcel cS c0 cS c0 wceq cA cS cJ ccl cfv cfv
      wcel wn cA c0 cJ ccl cfv cfv wcel wn cJ ctop wcel cS cX wss cA cX wcel
      w3a cS c0 wceq cA cS cJ ccl cfv cfv wcel cA c0 cJ ccl cfv cfv wcel cS c0
      wceq cS cJ ccl cfv cfv c0 cJ ccl cfv cfv cA cS c0 cJ ccl cfv fveq2 eleq2d
      notbid cJ ctop wcel cS cX wss cA c0 cJ ccl cfv cfv wcel wn cA cX wcel cJ
      ctop wcel cA c0 cJ ccl cfv cfv wcel cA c0 wcel cA noel cJ ctop wcel c0 cJ
      ccl cfv cfv c0 cA cJ cls0 eleq2d mtbiri 3ad2ant1 syl5cbir necon2ad imp cJ
      ctop wcel cS cX wss cA cX wcel w3a cS c0 wne wa cS csn cfil wcel cS csn
      cfbas wcel cJ ctop wcel cS cX wss cS c0 wne cS csn cfil wcel cA cX wcel
      cS cvv wcel cS c0 wne cS csn cfil wcel cJ ctop wcel cS cX wss wa cS cvv
      oefil2 cS cX wss cJ ctop wcel cS cvv wcel cS cX wss cX cvv wcel cS cvv
      wcel cJ ctop wcel cS cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg flimcls.1 syl5eqel sylan2 ancoms sylan 3adantl3 cS csn filfbas syl
      syldan sylanc mpbird jca cA csn cJ cnei cfv cfv cS csn cun cvv wcel cA
      csn cJ cnei cfv cfv cS csn cun cfi cfv cfbas wcel cA csn cJ cnei cfv cfv
      cS csn cun c0 wne c0 cA csn cJ cnei cfv cfv cS csn cun cfi cfv wnel wa wb
      cA csn cJ cnei cfv cfv cS csn cA csn cJ cnei cfv fvex cS snex unex cA csn
      cJ cnei cfv cfv cS csn cun cvv fsubbas ax-mp sylibr cA csn cJ cnei cfv
      cfv cS csn cun cfi cfv fbssfg syl sstrd cJ ctop wcel cS cX wss cA cX wcel
      w3a cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel cA cS cJ ccl cfv cfv
      wcel cJ ctop wcel cA cX wcel cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv
      wcel cS cX wss cA cJ cX flimcls.1 neiplim 3adant2 adantr syl3anc 3jca
      sylanc ex cJ ctop wcel cS cX wss cA cX wcel w3a cX vf cv cuni wceq cS vf
      cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a vf cfil wrex cA vo cv wcel vo
      cv cS cin c0 wne wi vo cJ wral cA cS cJ ccl cfv cfv wcel cJ ctop wcel cS
      cX wss cA cX wcel w3a cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1
      cfv cfv wcel w3a vf cfil wrex cA vo cv wcel vo cv cS cin c0 wne wi vo cJ
      cJ ctop wcel cS cX wss cA cX wcel w3a cX vf cv cuni wceq cS vf cv wcel cA
      vf cv cJ cflim1 cfv cfv wcel w3a vo cv cJ wcel cA vo cv wcel vo cv cS cin
      c0 wne wi wi vf cfil cJ ctop wcel cS cX wss cA cX wcel w3a vf cv cfil
      wcel wa cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel
      w3a vo cv cJ wcel cA vo cv wcel vo cv cS cin c0 wne vf cv cfil wcel vo cv
      cS cin vf cv wcel vo cv cS cin c0 wne cJ ctop wcel cS cX wss cA cX wcel
      w3a vf cv cfil wcel wa cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ
      cflim1 cfv cfv wcel w3a vo cv cJ wcel cA vo cv wcel wa wa wa vf cv cfil
      wcel vo cv cS cin vf cv wcel vo cv cS cin c0 vo cv cS cin c0 wceq vo cv
      cS cin vf cv wcel wn c0 vf cv wcel wn vf cv cfil wcel vo cv cS cin c0
      wceq vo cv cS cin vf cv wcel c0 vf cv wcel vo cv cS cin c0 vf cv eleq1
      notbid vf cv filesn syl5cbir necon2ad cJ ctop wcel cS cX wss cA cX wcel
      w3a vf cv cfil wcel cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1
      cfv cfv wcel w3a vo cv cJ wcel cA vo cv wcel wa wa simplr vf cv cfil wcel
      vo cv vf cv wcel cS vf cv wcel vo cv cS cin vf cv wcel cJ ctop wcel cS cX
      wss cA cX wcel w3a vf cv cfil wcel wa cX vf cv cuni wceq cS vf cv wcel cA
      vf cv cJ cflim1 cfv cfv wcel w3a vo cv cJ wcel cA vo cv wcel wa wa wa vo
      cv cS vf cv filint cJ ctop wcel cS cX wss cA cX wcel w3a vf cv cfil wcel
      cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a vo
      cv cJ wcel cA vo cv wcel wa wa simplr cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a cA vf cv cJ cflim1 cfv cfv wcel vo cv cA csn cJ cnei cfv
      cfv wcel vo cv vf cv wcel cJ ctop wcel cS cX wss cA cX wcel w3a vf cv
      cfil wcel wa cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv
      wcel w3a vo cv cJ wcel cA vo cv wcel wa wa wa cA vf cv cJ vo cv cX vf cv
      cuni flimcls.1 vf cv cuni eqid flimnei cJ ctop wcel cS cX wss cA cX wcel
      w3a vf cv cfil wcel wa cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ
      cflim1 cfv cfv wcel w3a vo cv cJ wcel cA vo cv wcel wa wa wa cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq cJ ctop wcel cS cX wss cA cX wcel w3a
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ
      cflim1 cfv cfv wcel w3a vo cv cJ wcel cA vo cv wcel wa wa cJ ctop wcel cS
      cX wss cA cX wcel 3simp1 ad2antrr cJ ctop wcel cS cX wss cA cX wcel w3a
      vf cv cfil wcel cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv
      cfv wcel w3a vo cv cJ wcel cA vo cv wcel wa wa simplr cX vf cv cuni wceq
      cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a cX vf cv cuni wceq cJ
      ctop wcel cS cX wss cA cX wcel w3a vf cv cfil wcel wa vo cv cJ wcel cA vo
      cv wcel wa cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv
      wcel 3simp1 ad2antrl 3jca cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ
      cflim1 cfv cfv wcel w3a cA vf cv cJ cflim1 cfv cfv wcel cJ ctop wcel cS
      cX wss cA cX wcel w3a vf cv cfil wcel wa vo cv cJ wcel cA vo cv wcel wa
      cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel 3simp3
      ad2antrl cJ ctop wcel cS cX wss cA cX wcel w3a vo cv cJ wcel cA vo cv
      wcel wa vo cv cA csn cJ cnei cfv cfv wcel vf cv cfil wcel cX vf cv cuni
      wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a cJ ctop wcel cS cX
      wss vo cv cJ wcel cA vo cv wcel wa vo cv cA csn cJ cnei cfv cfv wcel cA
      cX wcel cJ ctop wcel vo cv cJ wcel cA vo cv wcel vo cv cA csn cJ cnei cfv
      cfv wcel cA cJ vo cv opnneip 3expb 3ad2antl1 ad2ant2rl syl3anc cX vf cv
      cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv wcel w3a cS vf cv wcel
      cJ ctop wcel cS cX wss cA cX wcel w3a vf cv cfil wcel wa vo cv cJ wcel cA
      vo cv wcel wa cX vf cv cuni wceq cS vf cv wcel cA vf cv cJ cflim1 cfv cfv
      wcel 3simp2 ad2antrl syl3anc sylc exp45 r19.23adva r19.21adv vo cA cS cJ
      cX flimcls.1 elcls sylibrd impbid $.
      $( [28-Nov-2009] $) $( [28-Nov-2009] $)
  $}

  ${
    $d f w x y z A $. $d a f w x y z F $. $d f w x J $. $d y z J $. $d f w x z
    K $. $d w L $. $d f w x z X $. $d a f w x z Y $. $d f w y $.
    cnfillim.1 $e |- X = U. J $.
    cnfillim.2 $e |- Y = U. K $.
    cnfillim.3 $e |- L = ( filGen ` ( { y | E. z e. f y = ( F " z ) } u. { Y }
    ) ) $.
    $( Continuity of a function at a point in terms of filter limits.
       (Contributed by Jeff Hankins, 7-Sep-2009.) $)
    cnpfillim $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X ) ->
    ( F e. ( ( J CnP K ) ` A ) <-> A. f e. Fil ( ( X = U. f /\ A e. ( ( fLim1 `
    J ) ` f ) ) -> ( F ` A ) e. ( ( fLim1 ` K ) ` L ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp
      co cfv wcel cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv
      csn cK cnei cfv cfv wral cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa cA cF cfv cL cK cflim1 cfv cfv wcel wi vf cfil wral vx cA cF cJ
      cK cX cY cnfillim.1 cnfillim.2 cnpnei cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA
      cF cfv csn cK cnei cfv cfv wral cX vf cv cuni wceq cA vf cv cJ cflim1 cfv
      cfv wcel wa cA cF cfv cL cK cflim1 cfv cfv wcel wi vf cfil wral cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vx cv cima cA csn
      cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa cA cF cfv cL cK cflim1 cfv cfv
      wcel wi vf cfil cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa vf cv cfil wcel cF
      ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv
      cfv wral cA cF cfv cL cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx
      cA cF cfv csn cK cnei cfv cfv wral cA cF cfv cL cK cflim1 cfv cfv wcel wi
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel
      cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa cF ccnv vx cv cima
      cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral cA cF
      cfv cL cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv
      cfv wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF
      cfv csn cK cnei cfv cfv wral wa cA cF cfv cL cK cflim1 cfv cfv wcel cA cF
      cfv cY wcel cA cF cfv csn cK cnei cfv cfv cL wss wa cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA
      vf cv cJ cflim1 cfv cfv wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral wa cA cF cfv cY wcel
      cA cF cfv csn cK cnei cfv cfv cL wss cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cA cF cfv cY wcel vf cv cfil wcel cX vf cv cuni wceq
      cA vf cv cJ cflim1 cfv cfv wcel wa wa cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral cX cY cF wf cJ ctop
      wcel cA cX wcel cA cF cfv cY wcel cK ctop wcel cX cY cA cF ffvelrn
      3ad2antl3 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK
      cnei cfv cfv wral wa vw cA cF cfv csn cK cnei cfv cfv cL cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa cF ccnv vx cv cima cA csn
      cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral vw cv cA cF
      cfv csn cK cnei cfv cfv wcel vw cv cL wcel wi cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv
      cJ cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel
      cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei
      cfv cfv wral vw cv cL wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vx cv cima
      cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral vw cv
      cL wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv
      cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa vw
      cv cA cF cfv csn cK cnei cfv cfv wcel wa cF ccnv vx cv cima cA csn cJ
      cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral cF ccnv vw cv
      cima cA csn cJ cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel vw cv cL
      wcel vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vx cv cima cA csn
      cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral cF ccnv vw cv
      cima cA csn cJ cnei cfv cfv wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1
      cfv cfv wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel cF
      ccnv vw cv cima cA csn cJ cnei cfv cfv wcel vx vw cv cA cF cfv csn cK
      cnei cfv cfv vx cv vw cv wceq cF ccnv vx cv cima cF ccnv vw cv cima cA
      csn cJ cnei cfv cfv vx cv vw cv cF ccnv imaeq2 eleq1d rcla4v adantl cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a cA vf cv cJ cflim1 cfv
      cfv wcel cF ccnv vw cv cima cA csn cJ cnei cfv cfv wcel cF ccnv vw cv
      cima vf cv wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel wa cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a cA vf cv cJ cflim1 cfv cfv wcel cF ccnv vw cv
      cima cA csn cJ cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel cA vf cv
      cJ cF ccnv vw cv cima cX vf cv cuni cnfillim.1 vf cv cuni eqid flimnei
      3expia cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil
      wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa vw cv cA
      cF cfv csn cK cnei cfv cfv wcel wa cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel
      wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cJ ctop wcel cA cX wcel cJ ctop wcel cK ctop wcel cX cY
      cF wf 3simp1 adantr ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa vw cv cA cF cfv csn cK cnei cfv cfv wcel simplrl vf cv cfil wcel
      cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa cX vf cv cuni
      wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vw cv cA cF
      cfv csn cK cnei cfv cfv wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv
      cJ cflim1 cfv cfv wcel simprl ad2antlr 3jca vf cv cfil wcel cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa cA vf cv cJ cflim1 cfv cfv
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vw cv cA cF
      cfv csn cK cnei cfv cfv wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv
      cJ cflim1 cfv cfv wcel simprr ad2antlr sylanc cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv
      cJ cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel
      cF ccnv vw cv cima vf cv wcel vw cv cL wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF
      ccnv vw cv cima vf cv wcel wa wa vw cv cL wcel vw cv vy cv cF vz cv cima
      wceq vz vf cv wrex vy cab cY csn cun cuni wss va cv vw cv wss va vy cv cF
      vz cv cima wceq vz vf cv wrex vy cab cY csn cun wrex wa cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei
      cfv cfv wcel cF ccnv vw cv cima vf cv wcel wa wa vw cv vy cv cF vz cv
      cima wceq vz vf cv wrex vy cab cY csn cun cuni wss va cv vw cv wss va vy
      cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun wrex cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei
      cfv cfv wcel cF ccnv vw cv cima vf cv wcel wa wa vw cv cY vy cv cF vz cv
      cima wceq vz vf cv wrex vy cab cY csn cun cuni cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vw cv cA cF cfv csn cK cnei cfv cfv wcel vw
      cv cY wss vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa cF ccnv vw cv cima vf cv wcel cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a vw cv cA cF cfv csn cK cnei cfv cfv wcel vw cv cY wss cA cX
      wcel cK ctop wcel cJ ctop wcel vw cv cA cF cfv csn cK cnei cfv cfv wcel
      vw cv cY wss cX cY cF wf cA cF cfv csn cK vw cv cY cnfillim.2 neii1
      3ad2antl2 adantlr ad2ant2r vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cuni cY wss cY cvv wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY
      csn cun cuni cY wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima vf cv
      wcel wa wa cY cvv vy cv cF vz cv cima wceq vz vf cv wrex vy cab vy cv cF
      vz cv cima wceq vz vf cv wrex vy cab cuni vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cuni eqid extbas2 cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY
      wss vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel
      wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cF vz cv cima wceq vz
      vf cv wrex vy cab cuni cY wss cA cX wcel cX cY cF wf cJ ctop wcel vy cv
      cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss cK ctop wcel cX cY cF
      wf vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni vz vf cv cF vz cv
      cima ciun cY cX cY cF wf cF vz cv cima cvv wcel vz vf cv wral vz vf cv cF
      vz cv cima ciun vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni wceq
      cX cY cF wf cF vz cv cima cvv wcel vz vf cv cF wfun vz cv vf cv wcel cF
      vz cv cima cvv wcel cX cY cF wf cF vz cv vf cv funimaexg cX cY cF ffun
      sylan r19.21aiva vz vy vf cv cF vz cv cima cvv dfiun2g syl cX cY cF wf cF
      vz cv cima cY wss vz vf cv wral vz vf cv cF vz cv cima ciun cY wss cX cY
      cF wf cF vz cv cima cY wss vz vf cv cX cY cF wf cF vz cv cima cY wss vz
      cv vf cv wcel cX cY cF wf cF vz cv cima cF crn cY cF vz cv cima cF crn
      wss cX cY cF wf cF vz cv imassrn a1i cX cY cF frn sstrd a1d r19.21aiv vz
      vf cv cF vz cv cima cY iunss sylibr eqsstr3d 3ad2ant3 adantr ad2antrr cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cY cvv wcel vf cv
      cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa vw cv
      cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel wa cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv wcel cA cX wcel cK ctop
      wcel cJ ctop wcel cY cvv wcel cX cY cF wf cK ctop wcel cK cuni cvv cY cK
      ctop uniexg cnfillim.2 syl5eqel 3ad2ant2 adantr ad2antrr sylanc sseqtr4d
      cF cF ccnv vw cv cima cima vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cY csn cun wcel cF cF ccnv vw cv cima cima vw cv wss va cv vw cv wss va
      vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun wrex cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv
      cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK
      cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel wa wa va cv vw cv wss cF
      cF ccnv vw cv cima cima vw cv wss va cF cF ccnv vw cv cima cima vy cv cF
      vz cv cima wceq vz vf cv wrex vy cab cY csn cun va cv cF cF ccnv vw cv
      cima cima vw cv sseq1 rcla4ev cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv
      cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv
      cima vf cv wcel wa wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab vy cv
      cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cF cF ccnv vw cv cima
      cima vy cv cF vz cv cima wceq vz vf cv wrex vy cab vy cv cF vz cv cima
      wceq vz vf cv wrex vy cab cY csn cun wss cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF
      ccnv vw cv cima vf cv wcel wa wa vy cv cF vz cv cima wceq vz vf cv wrex
      vy cab cY csn ssun1 a1i cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima
      vf cv wcel wa wa cF cF ccnv vw cv cima cima vy cv cF vz cv cima wceq vz
      vf cv wrex vy cab wcel cF cF ccnv vw cv cima cima cF vz cv cima wceq vz
      vf cv wrex cF ccnv vw cv cima vf cv wcel cF cF ccnv vw cv cima cima cF vz
      cv cima wceq vz vf cv wrex cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima
      vf cv wcel cF cF ccnv vw cv cima cima cF cF ccnv vw cv cima cima wceq cF
      cF ccnv vw cv cima cima cF vz cv cima wceq vz vf cv wrex cF cF ccnv vw cv
      cima cima eqid cF cF ccnv vw cv cima cima cF vz cv cima wceq cF cF ccnv
      vw cv cima cima cF cF ccnv vw cv cima cima wceq vz cF ccnv vw cv cima vf
      cv vz cv cF ccnv vw cv cima wceq cF vz cv cima cF cF ccnv vw cv cima cima
      cF cF ccnv vw cv cima cima vz cv cF ccnv vw cv cima cF imaeq2 eqeq2d
      rcla4ev mpan2 ad2antll cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima
      vf cv wcel wa wa cF cF ccnv vw cv cima cima cvv wcel cF cF ccnv vw cv
      cima cima vy cv cF vz cv cima wceq vz vf cv wrex vy cab wcel cF cF ccnv
      vw cv cima cima cF vz cv cima wceq vz vf cv wrex wb cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vw cv cima vf cv wcel cF cF
      ccnv vw cv cima cima cvv wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv
      cJ cflim1 cfv cfv wcel wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cF ccnv vw cv cima vf cv wcel cF
      cF ccnv vw cv cima cima cvv wcel cA cX wcel cX cY cF wf cJ ctop wcel cF
      ccnv vw cv cima vf cv wcel cF cF ccnv vw cv cima cima cvv wcel cK ctop
      wcel cF wfun cF ccnv vw cv cima vf cv wcel cF cF ccnv vw cv cima cima cvv
      wcel cX cY cF wf cF cF ccnv vw cv cima vf cv funimaexg cX cY cF ffun
      sylan 3ad2antl3 adantlr ad2ant2rl vy cv cF vz cv cima wceq vz vf cv wrex
      cF cF ccnv vw cv cima cima cF vz cv cima wceq vz vf cv wrex vy cF cF ccnv
      vw cv cima cima cvv vy cv cF cF ccnv vw cv cima cima wceq vy cv cF vz cv
      cima wceq cF cF ccnv vw cv cima cima cF vz cv cima wceq vz vf cv vy cv cF
      cF ccnv vw cv cima cima cF vz cv cima eqeq1 rexbidv elabg syl mpbird
      sseldd cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cF ccnv
      vw cv cima cima vw cv wss vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF
      ccnv vw cv cima vf cv wcel wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cF cF ccnv vw cv cima cima vw cv wss cA cX wcel cX cY cF wf cJ ctop wcel
      cF cF ccnv vw cv cima cima vw cv wss cK ctop wcel cX cY cF wf cF wfun cF
      cF ccnv vw cv cima cima vw cv wss cX cY cF ffun cF wfun cF ccnv vw cv
      cima cF ccnv vw cv cima wss cF cF ccnv vw cv cima cima vw cv wss cF ccnv
      vw cv cima ssid cF ccnv vw cv cima vw cv cF funimass2 mpan2 syl 3ad2ant3
      adantr ad2antrr sylanc jca cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima
      vf cv wcel wa wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun
      cfbas wcel vw cv cL wcel vw cv vy cv cF vz cv cima wceq vz vf cv wrex vy
      cab cY csn cun cuni wss va cv vw cv wss va vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cY csn cun wrex wa wb vy cv cF vz cv cima wceq vz vf cv
      wrex vy cab cfbas wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni
      cY wss vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfbas
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil
      wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa vw cv cA
      cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel wa wa cY vy
      cv cF vz cv cima wceq vz vf cv wrex vy cab vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cuni vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni
      eqid extbas1 vf cv cfbas wcel cF vf cv cuni wfn vy cv cF vz cv cima wceq
      vz vf cv wrex vy cab cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv
      cfv wcel wa wa wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv
      cima vf cv wcel wa wa vz vy vf cv vy cv cF vz cv cima wceq vz vf cv wrex
      vy cab cF vf cv cuni vf cv cuni eqid vy cv cF vz cv cima wceq vz vf cv
      wrex vy cab eqid filrn vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa wa vf cv cfbas wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vw cv cA cF cfv csn cK cnei cfv cfv wcel cF
      ccnv vw cv cima vf cv wcel wa vf cv cfil wcel vf cv cfbas wcel cX vf cv
      cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa vf cv filfbas adantr
      ad2antlr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv
      cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa cF
      vf cv cuni wfn vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv
      cima vf cv wcel wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv
      cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa cF vf cv cuni wfn cA cX wcel
      vf cv cfil wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv cuni
      wceq cF vf cv cuni wfn cA vf cv cJ cflim1 cfv cfv wcel cX cY cF wf cJ
      ctop wcel cX vf cv cuni wceq cF vf cv cuni wfn cK ctop wcel cX cY cF wf
      cX vf cv cuni wceq wa cF cX wfn cF vf cv cuni wfn cX cY cF wf cF cX wfn
      cX vf cv cuni wceq cX cY cF ffn adantr cX vf cv cuni wceq cF cX wfn cF vf
      cv cuni wfn wb cX cY cF wf cX vf cv cuni cF fneq2 adantl mpbid 3ad2antl3
      adantrr ad2ant2rl adantr sylanc cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss
      vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa
      vw cv cA cF cfv csn cK cnei cfv cfv wcel cF ccnv vw cv cima vf cv wcel wa
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cuni cY wss cA cX wcel cX cY cF wf cJ ctop wcel vy cv cF
      vz cv cima wceq vz vf cv wrex vy cab cuni cY wss cK ctop wcel cX cY cF wf
      vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni vz vf cv cF vz cv cima
      ciun cY cX cY cF wf cF vz cv cima cvv wcel vz vf cv wral vz vf cv cF vz
      cv cima ciun vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni wceq cX
      cY cF wf cF vz cv cima cvv wcel vz vf cv cF wfun vz cv vf cv wcel cF vz
      cv cima cvv wcel cX cY cF wf cF vz cv vf cv funimaexg cX cY cF ffun sylan
      r19.21aiva vz vy vf cv cF vz cv cima cvv dfiun2g syl cX cY cF wf cF vz cv
      cima cY wss vz vf cv wral vz vf cv cF vz cv cima ciun cY wss cX cY cF wf
      cF vz cv cima cY wss vz vf cv cX cY cF wf cF vz cv cima cY wss vz cv vf
      cv wcel cX cY cF wf cF vz cv cima cF crn cY cF vz cv cima cF crn wss cX
      cY cF wf cF vz cv imassrn a1i cX cY cF frn sstrd a1d r19.21aiv vz vf cv
      cF vz cv cima cY iunss sylibr eqsstr3d 3ad2ant3 adantr ad2antrr sylanc vy
      cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfbas wcel vw cv vy
      cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfg cfv wcel vw cv
      vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cuni wss va cv
      vw cv wss va vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun
      wrex wa vw cv cL wcel va vw cv vy cv cF vz cv cima wceq vz vf cv wrex vy
      cab cY csn cun vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun
      cuni vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cuni eqid
      elfg cL vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfg cfv
      vw cv cnfillim.3 eleq2i syl5bb syl mpbird expr 3syld ex com23 imp ssrdv
      jca cK ctop wcel cL cfil wcel cY cL cuni wceq cA cF cfv cL cK cflim1 cfv
      cfv wcel cA cF cfv cY wcel cA cF cfv csn cK cnei cfv cfv cL wss wa wb cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX
      vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa cF ccnv vx cv
      cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral wa
      cA cF cfv cL cK cY cL cuni cnfillim.2 cL cuni eqid isfillim cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cK ctop wcel vf cv cfil wcel
      cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa cF ccnv vx cv
      cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cK ctop wcel cA cX wcel cJ ctop
      wcel cK ctop wcel cX cY cF wf 3simp2 adantr ad2antrr cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA
      vf cv cJ cflim1 cfv cfv wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral wa vy cv cF vz cv cima
      wceq vz vf cv wrex vy cab cY csn cun cfbas wcel cL cfil wcel vy cv cF vz
      cv cima wceq vz vf cv wrex vy cab cfbas wcel vy cv cF vz cv cima wceq vz
      vf cv wrex vy cab cuni cY wss vy cv cF vz cv cima wceq vz vf cv wrex vy
      cab cY csn cun cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv
      csn cK cnei cfv cfv wral wa cY vy cv cF vz cv cima wceq vz vf cv wrex vy
      cab vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni vy cv cF vz cv
      cima wceq vz vf cv wrex vy cab cuni eqid extbas1 vf cv cfbas wcel cF vf
      cv cuni wfn vy cv cF vz cv cima wceq vz vf cv wrex vy cab cfbas wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX
      vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa cF ccnv vx cv
      cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral wa
      vz vy vf cv vy cv cF vz cv cima wceq vz vf cv wrex vy cab cF vf cv cuni
      vf cv cuni eqid vy cv cF vz cv cima wceq vz vf cv wrex vy cab eqid filrn
      vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa
      vf cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei
      cfv cfv wral vf cv cfil wcel vf cv cfbas wcel cX vf cv cuni wceq cA vf cv
      cJ cflim1 cfv cfv wcel wa vf cv filfbas adantr ad2antlr cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa cF vf cv cuni wfn cF ccnv
      vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv
      wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv cuni wceq cA vf
      cv cJ cflim1 cfv cfv wcel wa cF vf cv cuni wfn cA cX wcel vf cv cfil wcel
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv cuni wceq cF vf cv
      cuni wfn cA vf cv cJ cflim1 cfv cfv wcel cX cY cF wf cJ ctop wcel cX vf
      cv cuni wceq cF vf cv cuni wfn cK ctop wcel cX cY cF wf cX vf cv cuni
      wceq wa cF cX wfn cF vf cv cuni wfn cX cY cF wf cF cX wfn cX vf cv cuni
      wceq cX cY cF ffn adantr cX vf cv cuni wceq cF cX wfn cF vf cv cuni wfn
      wb cX cY cF wf cX vf cv cuni cF fneq2 adantl mpbid 3ad2antl3 adantrr
      ad2ant2rl adantr sylanc cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss vf cv
      cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa cF
      ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv
      cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cF vz cv cima
      wceq vz vf cv wrex vy cab cuni cY wss cA cX wcel cX cY cF wf cJ ctop wcel
      vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss cK ctop wcel cX
      cY cF wf vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni vz vf cv cF
      vz cv cima ciun cY cX cY cF wf cF vz cv cima cvv wcel vz vf cv wral vz vf
      cv cF vz cv cima ciun vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni
      wceq cX cY cF wf cF vz cv cima cvv wcel vz vf cv cF wfun vz cv vf cv wcel
      cF vz cv cima cvv wcel cX cY cF wf cF vz cv vf cv funimaexg cX cY cF ffun
      sylan r19.21aiva vz vy vf cv cF vz cv cima cvv dfiun2g syl cX cY cF wf cF
      vz cv cima cY wss vz vf cv wral vz vf cv cF vz cv cima ciun cY wss cX cY
      cF wf cF vz cv cima cY wss vz vf cv cX cY cF wf cF vz cv cima cY wss vz
      cv vf cv wcel cX cY cF wf cF vz cv cima cF crn cY cF vz cv cima cF crn
      wss cX cY cF wf cF vz cv imassrn a1i cX cY cF frn sstrd a1d r19.21aiv vz
      vf cv cF vz cv cima cY iunss sylibr eqsstr3d 3ad2ant3 adantr ad2antrr
      sylanc vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfbas
      wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfg cfv
      cfil cL vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun fgfil
      cnfillim.3 syl5eqel syl cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv
      csn cK cnei cfv cfv wral wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cY csn cun cuni cY cL cuni vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cuni cY wss cY cvv wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY
      csn cun cuni cY wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK
      cnei cfv cfv wral wa cY cvv vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni vy cv cF vz cv cima
      wceq vz vf cv wrex vy cab cuni eqid extbas2 cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cuni cY wss vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv
      csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a vy cv
      cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss cA cX wcel cX cY cF
      wf cJ ctop wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss
      cK ctop wcel cX cY cF wf vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cuni vz vf cv cF vz cv cima ciun cY cX cY cF wf cF vz cv cima cvv wcel vz
      vf cv wral vz vf cv cF vz cv cima ciun vy cv cF vz cv cima wceq vz vf cv
      wrex vy cab cuni wceq cX cY cF wf cF vz cv cima cvv wcel vz vf cv cF wfun
      vz cv vf cv wcel cF vz cv cima cvv wcel cX cY cF wf cF vz cv vf cv
      funimaexg cX cY cF ffun sylan r19.21aiva vz vy vf cv cF vz cv cima cvv
      dfiun2g syl cX cY cF wf cF vz cv cima cY wss vz vf cv wral vz vf cv cF vz
      cv cima ciun cY wss cX cY cF wf cF vz cv cima cY wss vz vf cv cX cY cF wf
      cF vz cv cima cY wss vz cv vf cv wcel cX cY cF wf cF vz cv cima cF crn cY
      cF vz cv cima cF crn wss cX cY cF wf cF vz cv imassrn a1i cX cY cF frn
      sstrd a1d r19.21aiv vz vf cv cF vz cv cima cY iunss sylibr eqsstr3d
      3ad2ant3 adantr ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cY cvv wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1
      cfv cfv wcel wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA
      cF cfv csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cY cvv wcel cA cX wcel cK ctop wcel cJ ctop wcel cY cvv wcel cX cY cF wf
      cK ctop wcel cK cuni cvv cY cK ctop uniexg cnfillim.2 syl5eqel 3ad2ant2
      adantr ad2antrr sylanc cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv
      csn cK cnei cfv cfv wral wa vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cY csn cun cfbas wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY
      csn cun cuni cL cuni wceq vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cfbas wcel vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss vy
      cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfbas wcel cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel cX vf cv
      cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa wa cF ccnv vx cv cima cA
      csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral wa cY vy
      cv cF vz cv cima wceq vz vf cv wrex vy cab vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cuni vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni
      eqid extbas1 vf cv cfbas wcel cF vf cv cuni wfn vy cv cF vz cv cima wceq
      vz vf cv wrex vy cab cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv
      cfv wcel wa wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF
      cfv csn cK cnei cfv cfv wral wa vz vy vf cv vy cv cF vz cv cima wceq vz
      vf cv wrex vy cab cF vf cv cuni vf cv cuni eqid vy cv cF vz cv cima wceq
      vz vf cv wrex vy cab eqid filrn vf cv cfil wcel cX vf cv cuni wceq cA vf
      cv cJ cflim1 cfv cfv wcel wa wa vf cv cfbas wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vx cv cima cA csn cJ cnei cfv
      cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral vf cv cfil wcel vf cv
      cfbas wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa vf cv
      filfbas adantr ad2antlr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa wa cF vf cv cuni wfn cF ccnv vx cv cima cA csn cJ cnei cfv cfv
      wcel vx cA cF cfv csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa cF vf
      cv cuni wfn cA cX wcel vf cv cfil wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cX vf cv cuni wceq cF vf cv cuni wfn cA vf cv cJ cflim1 cfv cfv
      wcel cX cY cF wf cJ ctop wcel cX vf cv cuni wceq cF vf cv cuni wfn cK
      ctop wcel cX cY cF wf cX vf cv cuni wceq wa cF cX wfn cF vf cv cuni wfn
      cX cY cF wf cF cX wfn cX vf cv cuni wceq cX cY cF ffn adantr cX vf cv
      cuni wceq cF cX wfn cF vf cv cuni wfn wb cX cY cF wf cX vf cv cuni cF
      fneq2 adantl mpbid 3ad2antl3 adantrr ad2ant2rl adantr sylanc cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cuni cY wss vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel
      vx cA cF cfv csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a vy cv cF vz cv cima wceq vz vf cv wrex vy cab cuni cY wss cA cX
      wcel cX cY cF wf cJ ctop wcel vy cv cF vz cv cima wceq vz vf cv wrex vy
      cab cuni cY wss cK ctop wcel cX cY cF wf vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cuni vz vf cv cF vz cv cima ciun cY cX cY cF wf cF vz cv
      cima cvv wcel vz vf cv wral vz vf cv cF vz cv cima ciun vy cv cF vz cv
      cima wceq vz vf cv wrex vy cab cuni wceq cX cY cF wf cF vz cv cima cvv
      wcel vz vf cv cF wfun vz cv vf cv wcel cF vz cv cima cvv wcel cX cY cF wf
      cF vz cv vf cv funimaexg cX cY cF ffun sylan r19.21aiva vz vy vf cv cF vz
      cv cima cvv dfiun2g syl cX cY cF wf cF vz cv cima cY wss vz vf cv wral vz
      vf cv cF vz cv cima ciun cY wss cX cY cF wf cF vz cv cima cY wss vz vf cv
      cX cY cF wf cF vz cv cima cY wss vz cv vf cv wcel cX cY cF wf cF vz cv
      cima cF crn cY cF vz cv cima cF crn wss cX cY cF wf cF vz cv imassrn a1i
      cX cY cF frn sstrd a1d r19.21aiv vz vf cv cF vz cv cima cY iunss sylibr
      eqsstr3d 3ad2ant3 adantr ad2antrr sylanc vy cv cF vz cv cima wceq vz vf
      cv wrex vy cab cY csn cun cfbas wcel vy cv cF vz cv cima wceq vz vf cv
      wrex vy cab cY csn cun cuni vy cv cF vz cv cima wceq vz vf cv wrex vy cab
      cY csn cun cfg cfv cuni cL cuni vy cv cF vz cv cima wceq vz vf cv wrex vy
      cab cY csn cun vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun
      cuni vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cuni eqid
      fgbas cL vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn cun cfg cfv
      cnfillim.3 unieqi syl6eqr syl eqtr3d syl3anc mpbird exp42 com23 com24
      r19.21adv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf
      cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa cA cF cfv cL cK cflim1
      cfv cfv wcel wi vf cfil wral cX cA csn cJ cnei cfv cfv cuni wceq cA cA
      csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel wa cA cF cfv vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel wi cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx
      cA cF cfv csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cA csn cJ cnei cfv cfv cfil wcel cX vf cv cuni wceq cA
      vf cv cJ cflim1 cfv cfv wcel wa cA cF cfv cL cK cflim1 cfv cfv wcel wi vf
      cfil wral cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ cnei cfv cfv
      cJ cflim1 cfv cfv wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wi wi
      cJ ctop wcel cK ctop wcel cA cX wcel cA csn cJ cnei cfv cfv cfil wcel cX
      cY cF wf cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv
      cfil wcel cJ ctop wcel cA cX wcel wa cA csn cJ cX cnfillim.1 neifil cJ
      ctop wcel cA cX wcel pm3.26 cA cX wcel cA csn cX wss cJ ctop wcel cA cX
      snssi adantl cA cX wcel cA csn c0 wne cJ ctop wcel cA cX snnzg adantl
      syl3anc 3ad2antl1 cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      cA cF cfv cL cK cflim1 cfv cfv wcel wi cX cA csn cJ cnei cfv cfv cuni
      wceq cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel wa cA cF cfv vy cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg
      cfv cK cflim1 cfv cfv wcel wi vf cA csn cJ cnei cfv cfv cfil vf cv cA csn
      cJ cnei cfv cfv wceq cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel
      wa cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ cnei cfv cfv cJ
      cflim1 cfv cfv wcel wa cA cF cfv cL cK cflim1 cfv cfv wcel cA cF cfv vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cfg cfv cK cflim1 cfv cfv wcel vf cv cA csn cJ cnei cfv cfv wceq cX vf cv
      cuni wceq cX cA csn cJ cnei cfv cfv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel vf cv cA csn cJ
      cnei cfv cfv wceq vf cv cuni cA csn cJ cnei cfv cfv cuni cX vf cv cA csn
      cJ cnei cfv cfv unieq eqeq2d vf cv cA csn cJ cnei cfv cfv wceq vf cv cJ
      cflim1 cfv cfv cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv cA vf cv cA csn
      cJ cnei cfv cfv cJ cflim1 cfv fveq2 eleq2d anbi12d vf cv cA csn cJ cnei
      cfv cfv wceq cL cK cflim1 cfv cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv cA cF cfv
      vf cv cA csn cJ cnei cfv cfv wceq cL vy cv cF vz cv cima wceq vz cA csn
      cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv vf cv cA csn
      cJ cnei cfv cfv wceq vy cv cF vz cv cima wceq vz vf cv wrex vy cab cY csn
      cun cfg cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cY csn cun cfg cfv cL vf cv cA csn cJ cnei cfv cfv wceq vy cv cF vz
      cv cima wceq vz vf cv wrex vy cab cY csn cun vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg vf cv cA csn cJ cnei
      cfv cfv wceq vy cv cF vz cv cima wceq vz vf cv wrex vy cab vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn vf cv cA csn cJ
      cnei cfv cfv wceq vy cv cF vz cv cima wceq vz vf cv wrex vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy vy cv cF vz cv cima wceq vz
      vf cv cA csn cJ cnei cfv cfv rexeq1 abbidv uneq1d fveq2d cnfillim.3
      syl5eq fveq2d eleq2d imbi12d rcla4v syl cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ
      cnei cfv cfv cJ cflim1 cfv cfv wcel wa cX cA csn cJ cnei cfv cfv cuni
      wceq cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel wa cA cF cfv vy cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg
      cfv cK cflim1 cfv cfv wcel wi cF ccnv vx cv cima cA csn cJ cnei cfv cfv
      wcel vx cA cF cfv csn cK cnei cfv cfv wral wi cJ ctop wcel cK ctop wcel
      cA cX wcel cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ cnei cfv cfv
      cJ cflim1 cfv cfv wcel wa cX cY cF wf cJ ctop wcel cA cX wcel wa cX cA
      csn cJ cnei cfv cfv cuni wceq cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv
      wcel cJ ctop wcel cA cX wcel wa cA csn cJ cnei cfv cfv cuni cX cJ ctop
      wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX wceq cA cX wcel cA csn
      cJ cX cnfillim.1 unnei cA cX snssi sylan2 eqcomd cA cJ cX cnfillim.1
      neiplim jca 3ad2antl1 cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ
      cnei cfv cfv cJ cflim1 cfv cfv wcel wa cX cA csn cJ cnei cfv cfv cuni
      wceq cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel wa cA cF cfv vy cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg
      cfv cK cflim1 cfv cfv wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv
      csn cK cnei cfv cfv wral cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ
      cnei cfv cfv cJ cflim1 cfv cfv wcel wa cX cA csn cJ cnei cfv cfv cuni
      wceq cA cA csn cJ cnei cfv cfv cJ cflim1 cfv cfv wcel wa cA cF cfv vy cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg
      cfv cK cflim1 cfv cfv wcel wi cA cF cfv vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv vx cv
      cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv wral wi
      cX cA csn cJ cnei cfv cfv cuni wceq cA cA csn cJ cnei cfv cfv cJ cflim1
      cfv cfv wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv
      cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel pm2.27 cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel vx cA
      cF cfv csn cK cnei cfv cfv wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv
      cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa cF ccnv vx
      cv cima cA csn cJ cnei cfv cfv wcel vx cA cF cfv csn cK cnei cfv cfv cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF
      vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv
      cK cflim1 cfv cfv wcel wa vx cv cA cF cfv csn cK cnei cfv cfv wcel vx cv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cfg cfv wcel cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1
      cfv cfv wcel cK ctop wcel vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv
      cfv wrex vy cab cY csn cun cfg cfv cfil wcel cY vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cuni wceq w3a vx
      cv cA cF cfv csn cK cnei cfv cfv wcel vx cv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv wcel wi cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel wa cK ctop wcel vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cfil wcel cY vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cuni
      wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cK ctop wcel cA cX wcel cA
      cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun cfg cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf 3simp2 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfbas wcel vy cv cF vz
      cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv
      cfil wcel vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cfbas wcel vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cuni cY wss vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cY csn cun cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa cY vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cuni vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cuni eqid extbas1 cA csn cJ cnei cfv cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cuni wfn vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cfbas wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel
      wa vz vy cA csn cJ cnei cfv cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cF cA csn cJ cnei cfv cfv cuni cA csn cJ cnei
      cfv cfv cuni eqid vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab eqid filrn cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cA csn cJ cnei cfv cfv cfbas wcel cA cF cfv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv
      wcel cJ ctop wcel cK ctop wcel cA cX wcel cA csn cJ cnei cfv cfv cfbas
      wcel cX cY cF wf cJ ctop wcel cA cX wcel wa cA csn cJ cnei cfv cfv cfil
      wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel cA csn cX wss cA csn
      c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel cA cX wcel wa cA csn
      cJ cX cnfillim.1 neifil cJ ctop wcel cA cX wcel pm3.26 cA cX wcel cA csn
      cX wss cJ ctop wcel cA cX snssi adantl cA cX wcel cA csn c0 wne cJ ctop
      wcel cA cX snnzg adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl
      3ad2antl1 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cF cA csn cJ cnei cfv cfv cuni wfn cA cF cfv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA csn cJ
      cnei cfv cfv cuni wfn cF cX wfn cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cF cX wfn cA cX wcel cX cY cF wf cJ ctop wcel cF cX wfn cK ctop wcel cX
      cY cF ffn 3ad2ant3 adantr cJ ctop wcel cK ctop wcel cA cX wcel cF cA csn
      cJ cnei cfv cfv cuni wfn cF cX wfn wb cX cY cF wf cJ ctop wcel cA cX wcel
      wa cA csn cJ cnei cfv cfv cuni cX wceq cF cA csn cJ cnei cfv cfv cuni wfn
      cF cX wfn wb cJ ctop wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX
      wceq cA cX wcel cA csn cJ cX cnfillim.1 unnei cA cX snssi sylan2 cA csn
      cJ cnei cfv cfv cuni cX cF fneq2 syl 3ad2antl1 mpbird adantr sylanc cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cF vz cv cima wceq vz cA csn
      cJ cnei cfv cfv wrex vy cab cuni cY wss cA cX wcel cA cF cfv vy cv cF vz
      cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel cX cY cF wf cJ ctop wcel vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cuni cY wss cK ctop wcel cX cY cF wf
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni vz cA
      csn cJ cnei cfv cfv cF vz cv cima ciun cY cX cY cF wf cF vz cv cima cvv
      wcel vz cA csn cJ cnei cfv cfv wral vz cA csn cJ cnei cfv cfv cF vz cv
      cima ciun vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cuni wceq cX cY cF wf cF vz cv cima cvv wcel vz cA csn cJ cnei cfv cfv cF
      wfun vz cv cA csn cJ cnei cfv cfv wcel cF vz cv cima cvv wcel cX cY cF wf
      cF vz cv cA csn cJ cnei cfv cfv funimaexg cX cY cF ffun sylan r19.21aiva
      vz vy cA csn cJ cnei cfv cfv cF vz cv cima cvv dfiun2g syl cX cY cF wf cF
      vz cv cima cY wss vz cA csn cJ cnei cfv cfv wral vz cA csn cJ cnei cfv
      cfv cF vz cv cima ciun cY wss cX cY cF wf cF vz cv cima cY wss vz cA csn
      cJ cnei cfv cfv cX cY cF wf cF vz cv cima cY wss vz cv cA csn cJ cnei cfv
      cfv wcel cX cY cF wf cF vz cv cima cF crn cY cF vz cv cima cF crn wss cX
      cY cF wf cF vz cv imassrn a1i cX cY cF frn sstrd a1d r19.21aiv vz cA csn
      cJ cnei cfv cfv cF vz cv cima cY iunss sylibr eqsstr3d 3ad2ant3 ad2antrr
      sylanc vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun fgfil syl cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cuni cY vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cuni cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cuni cY wceq cA cF
      cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn
      cun cfg cfv cK cflim1 cfv cfv wcel vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cuni cY wss cY cvv wcel vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cuni cY wceq cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cY cvv vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cuni vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cuni eqid extbas2 cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv
      wrex vy cab cuni cY wss cA cX wcel cX cY cF wf cJ ctop wcel vy cv cF vz
      cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni cY wss cK ctop
      wcel cX cY cF wf vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab cuni vz cA csn cJ cnei cfv cfv cF vz cv cima ciun cY cX cY cF wf
      cF vz cv cima cvv wcel vz cA csn cJ cnei cfv cfv wral vz cA csn cJ cnei
      cfv cfv cF vz cv cima ciun vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv
      cfv wrex vy cab cuni wceq cX cY cF wf cF vz cv cima cvv wcel vz cA csn cJ
      cnei cfv cfv cF wfun vz cv cA csn cJ cnei cfv cfv wcel cF vz cv cima cvv
      wcel cX cY cF wf cF vz cv cA csn cJ cnei cfv cfv funimaexg cX cY cF ffun
      sylan r19.21aiva vz vy cA csn cJ cnei cfv cfv cF vz cv cima cvv dfiun2g
      syl cX cY cF wf cF vz cv cima cY wss vz cA csn cJ cnei cfv cfv wral vz cA
      csn cJ cnei cfv cfv cF vz cv cima ciun cY wss cX cY cF wf cF vz cv cima
      cY wss vz cA csn cJ cnei cfv cfv cX cY cF wf cF vz cv cima cY wss vz cv
      cA csn cJ cnei cfv cfv wcel cX cY cF wf cF vz cv cima cF crn cY cF vz cv
      cima cF crn wss cX cY cF wf cF vz cv imassrn a1i cX cY cF frn sstrd a1d
      r19.21aiv vz cA csn cJ cnei cfv cfv cF vz cv cima cY iunss sylibr
      eqsstr3d 3ad2ant3 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv
      wcel cA cX wcel cK ctop wcel cJ ctop wcel cY cvv wcel cX cY cF wf cK ctop
      wcel cK cuni cvv cY cK ctop uniexg cnfillim.2 syl5eqel 3ad2ant2 adantr
      sylanc adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA
      cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun cfg cfv cK cflim1 cfv cfv wcel wa vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cY csn cun cfbas wcel vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cuni vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cuni
      wceq vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cfbas
      wcel vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni
      cY wss vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa cY vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cuni vy cv cF vz cv cima wceq vz cA csn
      cJ cnei cfv cfv wrex vy cab cuni eqid extbas1 cA csn cJ cnei cfv cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cuni wfn vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cfbas wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel
      wa vz vy cA csn cJ cnei cfv cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cF cA csn cJ cnei cfv cfv cuni cA csn cJ cnei
      cfv cfv cuni eqid vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab eqid filrn cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cA csn cJ cnei cfv cfv cfbas wcel cA cF cfv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv
      wcel cJ ctop wcel cK ctop wcel cA cX wcel cA csn cJ cnei cfv cfv cfbas
      wcel cX cY cF wf cJ ctop wcel cA cX wcel wa cA csn cJ cnei cfv cfv cfil
      wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel cA csn cX wss cA csn
      c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel cA cX wcel wa cA csn
      cJ cX cnfillim.1 neifil cJ ctop wcel cA cX wcel pm3.26 cA cX wcel cA csn
      cX wss cJ ctop wcel cA cX snssi adantl cA cX wcel cA csn c0 wne cJ ctop
      wcel cA cX snnzg adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl
      3ad2antl1 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cF cA csn cJ cnei cfv cfv cuni wfn cA cF cfv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA csn cJ
      cnei cfv cfv cuni wfn cF cX wfn cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cF cX wfn cA cX wcel cX cY cF wf cJ ctop wcel cF cX wfn cK ctop wcel cX
      cY cF ffn 3ad2ant3 adantr cJ ctop wcel cK ctop wcel cA cX wcel cF cA csn
      cJ cnei cfv cfv cuni wfn cF cX wfn wb cX cY cF wf cJ ctop wcel cA cX wcel
      wa cA csn cJ cnei cfv cfv cuni cX wceq cF cA csn cJ cnei cfv cfv cuni wfn
      cF cX wfn wb cJ ctop wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX
      wceq cA cX wcel cA csn cJ cX cnfillim.1 unnei cA cX snssi sylan2 cA csn
      cJ cnei cfv cfv cuni cX cF fneq2 syl 3ad2antl1 mpbird adantr sylanc cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a vy cv cF vz cv cima wceq vz cA csn
      cJ cnei cfv cfv wrex vy cab cuni cY wss cA cX wcel cA cF cfv vy cv cF vz
      cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel cX cY cF wf cJ ctop wcel vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cuni cY wss cK ctop wcel cX cY cF wf
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni vz cA
      csn cJ cnei cfv cfv cF vz cv cima ciun cY cX cY cF wf cF vz cv cima cvv
      wcel vz cA csn cJ cnei cfv cfv wral vz cA csn cJ cnei cfv cfv cF vz cv
      cima ciun vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cuni wceq cX cY cF wf cF vz cv cima cvv wcel vz cA csn cJ cnei cfv cfv cF
      wfun vz cv cA csn cJ cnei cfv cfv wcel cF vz cv cima cvv wcel cX cY cF wf
      cF vz cv cA csn cJ cnei cfv cfv funimaexg cX cY cF ffun sylan r19.21aiva
      vz vy cA csn cJ cnei cfv cfv cF vz cv cima cvv dfiun2g syl cX cY cF wf cF
      vz cv cima cY wss vz cA csn cJ cnei cfv cfv wral vz cA csn cJ cnei cfv
      cfv cF vz cv cima ciun cY wss cX cY cF wf cF vz cv cima cY wss vz cA csn
      cJ cnei cfv cfv cX cY cF wf cF vz cv cima cY wss vz cv cA csn cJ cnei cfv
      cfv wcel cX cY cF wf cF vz cv cima cF crn cY cF vz cv cima cF crn wss cX
      cY cF wf cF vz cv imassrn a1i cX cY cF frn sstrd a1d r19.21aiv vz cA csn
      cJ cnei cfv cfv cF vz cv cima cY iunss sylibr eqsstr3d 3ad2ant3 ad2antrr
      sylanc vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun cuni vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cY csn cun cuni eqid fgbas syl eqtr3d 3jca cK ctop wcel vy cv cF vz
      cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv
      cfil wcel cY vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cY csn cun cfg cfv cuni wceq w3a cA cF cfv vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv
      cfv wcel vx cv cA cF cfv csn cK cnei cfv cfv wcel vx cv vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv wcel
      cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cY csn cun cfg cfv cK vx cv cY vy cv cF vz cv cima wceq vz cA csn cJ cnei
      cfv cfv wrex vy cab cY csn cun cfg cfv cuni cnfillim.2 vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cuni
      eqid flimnei 3expia sylancom cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv
      wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vx cv vy cv cF
      vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv
      wcel cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi vx cv cA cF cfv
      csn cK cnei cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vx cv vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv wcel
      vx cv cY wss vw cv vx cv wss vw vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun wrex wa cF ccnv vx cv cima cA csn cJ
      cnei cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vx cv vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv wcel vx cv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cuni wss vw cv vx cv wss vw vy cv cF vz cv cima wceq vz cA csn cJ cnei
      cfv cfv wrex vy cab cY csn cun wrex wa vx cv cY wss vw cv vx cv wss vw vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      wrex wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cfg cfv cK cflim1 cfv cfv wcel wa vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfbas wcel vx cv vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv wcel vx cv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cuni wss vw cv vx cv wss vw vy cv cF vz cv cima wceq vz cA csn cJ cnei
      cfv cfv wrex vy cab cY csn cun wrex wa wb vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cfbas wcel vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cuni cY wss vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfbas wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1
      cfv cfv wcel wa cY vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv
      wrex vy cab vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cuni vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cuni eqid extbas1 cA csn cJ cnei cfv cfv cfbas wcel cF cA csn cJ cnei cfv
      cfv cuni wfn vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy
      cab cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA
      cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun cfg cfv cK cflim1 cfv cfv wcel wa vz vy cA csn cJ cnei cfv cfv vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cF cA csn cJ
      cnei cfv cfv cuni cA csn cJ cnei cfv cfv cuni eqid vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab eqid filrn cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cA csn cJ cnei cfv cfv cfbas wcel
      cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cY csn cun cfg cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cA cX
      wcel cA csn cJ cnei cfv cfv cfbas wcel cX cY cF wf cJ ctop wcel cA cX
      wcel wa cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cfbas
      wcel cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil
      wcel cJ ctop wcel cA cX wcel wa cA csn cJ cX cnfillim.1 neifil cJ ctop
      wcel cA cX wcel pm3.26 cA cX wcel cA csn cX wss cJ ctop wcel cA cX snssi
      adantl cA cX wcel cA csn c0 wne cJ ctop wcel cA cX snnzg adantl syl3anc
      cA csn cJ cnei cfv cfv filfbas syl 3ad2antl1 adantr cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cF cA csn cJ cnei cfv cfv cuni wfn cA
      cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY
      csn cun cfg cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cF cA csn cJ cnei cfv cfv cuni wfn cF cX wfn cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cF cX wfn cA cX wcel cX cY cF wf cJ
      ctop wcel cF cX wfn cK ctop wcel cX cY cF ffn 3ad2ant3 adantr cJ ctop
      wcel cK ctop wcel cA cX wcel cF cA csn cJ cnei cfv cfv cuni wfn cF cX wfn
      wb cX cY cF wf cJ ctop wcel cA cX wcel wa cA csn cJ cnei cfv cfv cuni cX
      wceq cF cA csn cJ cnei cfv cfv cuni wfn cF cX wfn wb cJ ctop wcel cA csn
      cX wss cA csn cJ cnei cfv cfv cuni cX wceq cA cX wcel cA csn cJ cX
      cnfillim.1 unnei cA cX snssi sylan2 cA csn cJ cnei cfv cfv cuni cX cF
      fneq2 syl 3ad2antl1 mpbird adantr sylanc cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cuni cY wss cA cX wcel cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel cX cY
      cF wf cJ ctop wcel vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv
      wrex vy cab cuni cY wss cK ctop wcel cX cY cF wf vy cv cF vz cv cima wceq
      vz cA csn cJ cnei cfv cfv wrex vy cab cuni vz cA csn cJ cnei cfv cfv cF
      vz cv cima ciun cY cX cY cF wf cF vz cv cima cvv wcel vz cA csn cJ cnei
      cfv cfv wral vz cA csn cJ cnei cfv cfv cF vz cv cima ciun vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni wceq cX cY cF wf cF
      vz cv cima cvv wcel vz cA csn cJ cnei cfv cfv cF wfun vz cv cA csn cJ
      cnei cfv cfv wcel cF vz cv cima cvv wcel cX cY cF wf cF vz cv cA csn cJ
      cnei cfv cfv funimaexg cX cY cF ffun sylan r19.21aiva vz vy cA csn cJ
      cnei cfv cfv cF vz cv cima cvv dfiun2g syl cX cY cF wf cF vz cv cima cY
      wss vz cA csn cJ cnei cfv cfv wral vz cA csn cJ cnei cfv cfv cF vz cv
      cima ciun cY wss cX cY cF wf cF vz cv cima cY wss vz cA csn cJ cnei cfv
      cfv cX cY cF wf cF vz cv cima cY wss vz cv cA csn cJ cnei cfv cfv wcel cX
      cY cF wf cF vz cv cima cF crn cY cF vz cv cima cF crn wss cX cY cF wf cF
      vz cv imassrn a1i cX cY cF frn sstrd a1d r19.21aiv vz cA csn cJ cnei cfv
      cfv cF vz cv cima cY iunss sylibr eqsstr3d 3ad2ant3 ad2antrr sylanc vw vx
      cv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn
      cun vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn
      cun cuni vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab
      cY csn cun cuni eqid elfg syl cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv
      cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vx cv vy cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cuni
      wss vx cv cY wss vw cv vx cv wss vw vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun wrex cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cuni cY vx cv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cuni cY wceq cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv
      wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni cY wss cY cvv wcel vy cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cuni
      cY wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cY cvv vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab vy cv cF vz
      cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni eqid extbas2 cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cuni cY wss cA cX wcel cX cY cF wf cJ ctop wcel
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cuni cY
      wss cK ctop wcel cX cY cF wf vy cv cF vz cv cima wceq vz cA csn cJ cnei
      cfv cfv wrex vy cab cuni vz cA csn cJ cnei cfv cfv cF vz cv cima ciun cY
      cX cY cF wf cF vz cv cima cvv wcel vz cA csn cJ cnei cfv cfv wral vz cA
      csn cJ cnei cfv cfv cF vz cv cima ciun vy cv cF vz cv cima wceq vz cA csn
      cJ cnei cfv cfv wrex vy cab cuni wceq cX cY cF wf cF vz cv cima cvv wcel
      vz cA csn cJ cnei cfv cfv cF wfun vz cv cA csn cJ cnei cfv cfv wcel cF vz
      cv cima cvv wcel cX cY cF wf cF vz cv cA csn cJ cnei cfv cfv funimaexg cX
      cY cF ffun sylan r19.21aiva vz vy cA csn cJ cnei cfv cfv cF vz cv cima
      cvv dfiun2g syl cX cY cF wf cF vz cv cima cY wss vz cA csn cJ cnei cfv
      cfv wral vz cA csn cJ cnei cfv cfv cF vz cv cima ciun cY wss cX cY cF wf
      cF vz cv cima cY wss vz cA csn cJ cnei cfv cfv cX cY cF wf cF vz cv cima
      cY wss vz cv cA csn cJ cnei cfv cfv wcel cX cY cF wf cF vz cv cima cF crn
      cY cF vz cv cima cF crn wss cX cY cF wf cF vz cv imassrn a1i cX cY cF frn
      sstrd a1d r19.21aiv vz cA csn cJ cnei cfv cfv cF vz cv cima cY iunss
      sylibr eqsstr3d 3ad2ant3 adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cY cvv wcel cA cX wcel cK ctop wcel cJ ctop wcel cY cvv wcel cX cY cF wf
      cK ctop wcel cK cuni cvv cY cK ctop uniexg cnfillim.2 syl5eqel 3ad2ant2
      adantr sylanc adantr sseq2d anbi1d bitrd cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vx
      cv cY wss vw cv vx cv wss vw vy cv cF vz cv cima wceq vz cA csn cJ cnei
      cfv cfv wrex vy cab cY csn cun wrex cF ccnv vx cv cima cA csn cJ cnei cfv
      cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF
      cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn
      cun cfg cfv cK cflim1 cfv cfv wcel wa vw cv vx cv wss vw vy cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun wrex vx cv cY
      wss cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv
      wcel wa vw cv vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel wi vw vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv
      wrex vy cab cY csn cun cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vw cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vw cv cY wceq wo vw cv vx cv wss vx
      cv cY wss cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi wi vw cv vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy
      cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cfg cfv cK cflim1 cfv cfv wcel wa vw cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vw cv vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn
      cJ cnei cfv cfv wcel wi wi vw cv cY wceq cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa vw cv cF vz cv cima wceq vz cA csn cJ cnei cfv
      cfv wrex vw cv vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel wi wi wi cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vw cv cF vz cv cima
      wceq vw cv vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei cfv
      cfv wcel wi wi vz cA csn cJ cnei cfv cfv cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel vw cv cF vz cv
      cima wceq vw cv vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel wi wi wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa cF vz cv cima vw cv wss vw
      cv vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel
      wi wi vw cv cF vz cv cima wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa cF vz cv cima vw cv
      wss vz cv cF ccnv vw cv cima wss vw cv vx cv wss vx cv cY wss cF ccnv vx
      cv cima cA csn cJ cnei cfv cfv wcel wi wi cF wfun vz cv cF cdm wss cF vz
      cv cima vw cv wss vz cv cF ccnv vw cv cima wss wb cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa
      vz cv vw cv cF funimass3 cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF
      wfun cA cX wcel vz cv cA csn cJ cnei cfv cfv wcel cX cY cF wf cJ ctop
      wcel cF wfun cK ctop wcel cX cY cF ffun 3ad2ant3 ad2antrr cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel
      wa vz cv cF cdm wss vz cv cX wss cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a vz cv cA csn cJ cnei cfv cfv wcel vz cv cX wss cA cX wcel cJ ctop
      wcel cK ctop wcel vz cv cA csn cJ cnei cfv cfv wcel vz cv cX wss cX cY cF
      wf cA csn cJ vz cv cX cnfillim.1 neii1 3ad2antl1 adantlr cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel
      wa cF cdm cX vz cv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cdm cX
      wceq cA cX wcel vz cv cA csn cJ cnei cfv cfv wcel cX cY cF wf cJ ctop
      wcel cF cdm cX wceq cK ctop wcel cX cY cF fdm 3ad2ant3 ad2antrr sseq2d
      mpbird sylanc cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vz
      cv cA csn cJ cnei cfv cfv wcel wa vz cv cF ccnv vw cv cima wss cF ccnv vw
      cv cima cF ccnv vx cv cima wss vx cv cY wss cF ccnv vx cv cima cA csn cJ
      cnei cfv cfv wcel wi vw cv vx cv wss cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa vz cv cF ccnv
      vw cv cima wss cF ccnv vw cv cima cF ccnv vx cv cima wss vx cv cY wss cF
      ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa vz cv
      cF ccnv vx cv cima wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei cfv
      cfv wcel wi vz cv cF ccnv vw cv cima wss cF ccnv vw cv cima cF ccnv vx cv
      cima wss wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vz cv
      cA csn cJ cnei cfv cfv wcel wa vx cv cY wss vz cv cF ccnv vx cv cima wss
      cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa cF
      ccnv vx cv cima cF ccnv cY cima wss vz cv cF ccnv vx cv cima wss cF ccnv
      vx cv cima cA csn cJ cnei cfv cfv wcel wi vx cv cY wss cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel
      wa cF ccnv vx cv cima cF ccnv cY cima wss cF ccnv vx cv cima cX wss vz cv
      cF ccnv vx cv cima wss cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ
      cnei cfv cfv wcel wa cF ccnv cY cima cX cF ccnv vx cv cima cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cF ccnv cY cima cX wceq cA cX wcel vz cv cA
      csn cJ cnei cfv cfv wcel cX cY cF wf cJ ctop wcel cF ccnv cY cima cX wceq
      cK ctop wcel cX cY cF fimacnv 3ad2ant3 ad2antrr sseq2d cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel
      wa vz cv cF ccnv vx cv cima wss cF ccnv vx cv cima cX wss cF ccnv vx cv
      cima cA csn cJ cnei cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vz cv cA csn cJ cnei cfv cfv wcel wa vz cv cF ccnv vx
      cv cima wss cF ccnv vx cv cima cX wss cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a vz cv cA csn cJ
      cnei cfv cfv wcel vz cv cF ccnv vx cv cima wss cF ccnv vx cv cima cX wss
      wa cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi cA cX wcel cJ ctop
      wcel cK ctop wcel vz cv cA csn cJ cnei cfv cfv wcel vz cv cF ccnv vx cv
      cima wss cF ccnv vx cv cima cX wss wa cF ccnv vx cv cima cA csn cJ cnei
      cfv cfv wcel wi cX cY cF wf cJ ctop wcel vz cv cA csn cJ cnei cfv cfv
      wcel wa vz cv cF ccnv vx cv cima wss cF ccnv vx cv cima cX wss wa cF ccnv
      vx cv cima cA csn cJ cnei cfv cfv wcel cA csn cJ cF ccnv vx cv cima vz cv
      cX cnfillim.1 ssnei2 ex 3ad2antl1 adantlr exp3a com23 sylbid vx cv cY cF
      ccnv imass2 syl5 com23 vz cv cF ccnv vw cv cima cF ccnv vx cv cima sstr
      syl5 exp3a vw cv vx cv cF ccnv imass2 syl7 sylbid cF vz cv cima vw cv wss
      cF vz cv cima vw cv cF vz cv cima vw cv eqimss eqcoms syl5 ex r19.23adv
      adantr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cfg cfv cK cflim1 cfv cfv wcel wa vw cv cY wceq vw cv vx cv wss vx cv cY
      wss cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi wi cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima
      wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1
      cfv cfv wcel wa vw cv cY wceq wa vw cv vx cv wss cY vx cv wss vx cv cY
      wss cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel wi vw cv cY wceq vw cv
      vx cv wss cY vx cv wss wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cA cF cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex
      vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wa vw cv cY vx cv sseq1
      adantl cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn cun
      cfg cfv cK cflim1 cfv cfv wcel wa cY vx cv wss vx cv cY wss cF ccnv vx cv
      cima cA csn cJ cnei cfv cfv wcel wi wi vw cv cY wceq cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cA cF cfv vy cv cF vz cv cima wceq vz
      cA csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv
      wcel wa cY vx cv wss vx cv cY wss cF ccnv vx cv cima cA csn cJ cnei cfv
      cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA cF
      cfv vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn
      cun cfg cfv cK cflim1 cfv cfv wcel wa cY vx cv wceq cF ccnv vx cv cima cA
      csn cJ cnei cfv cfv wcel cY vx cv wss vx cv cY wss wa cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cY vx cv wceq cF ccnv vx cv cima
      cA csn cJ cnei cfv cfv wcel wi cA cF cfv vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cY vx cv wceq cF
      ccnv vx cv cima cA csn cJ cnei cfv cfv wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cY vx cv wceq wa cF ccnv cY cima cA csn cJ
      cnei cfv cfv wcel cF ccnv vx cv cima cA csn cJ cnei cfv cfv wcel cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF ccnv cY cima cA csn cJ
      cnei cfv cfv wcel cY vx cv wceq cJ ctop wcel cX cY cF wf cA cX wcel cF
      ccnv cY cima cA csn cJ cnei cfv cfv wcel cK ctop wcel cJ ctop wcel cX cY
      cF wf wa cA cX wcel wa cF ccnv cY cima cA csn cJ cnei cfv cfv wcel cX cA
      csn cJ cnei cfv cfv wcel cJ ctop wcel cA cX wcel cX cA csn cJ cnei cfv
      cfv wcel cX cY cF wf cJ ctop wcel cA csn cX wss cX cA csn cJ cnei cfv cfv
      wcel cA cX wcel cJ ctop wcel cA csn cX wss cX cA csn cJ cnei cfv cfv wcel
      cA csn cJ cX cnfillim.1 tpnei biimpa cA cX snssi sylan2 adantlr cX cY cF
      wf cF ccnv cY cima cA csn cJ cnei cfv cfv wcel cX cA csn cJ cnei cfv cfv
      wcel wb cJ ctop wcel cA cX wcel cX cY cF wf cF ccnv cY cima cX cA csn cJ
      cnei cfv cfv cX cY cF fimacnv eleq1d ad2antlr mpbird 3adantl2 adantr cY
      vx cv wceq cF ccnv cY cima cA csn cJ cnei cfv cfv wcel cF ccnv vx cv cima
      cA csn cJ cnei cfv cfv wcel wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cY vx cv wceq cF ccnv cY cima cF ccnv vx cv cima cA csn cJ
      cnei cfv cfv cY vx cv cF ccnv imaeq2 eleq1d adantl mpbid ex adantr cY vx
      cv wceq cY vx cv wss vx cv cY wss wa cY vx cv eqss bicomi syl5ib exp3a
      adantr sylbid ex jaod vw cv vy cv cF vz cv cima wceq vz cA csn cJ cnei
      cfv cfv wrex vy cab cY csn cun wcel vw cv vy cv cF vz cv cima wceq vz cA
      csn cJ cnei cfv cfv wrex vy cab wcel vw cv cY csn wcel wo vw cv cF vz cv
      cima wceq vz cA csn cJ cnei cfv cfv wrex vw cv cY wceq wo vw cv vy cv cF
      vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab cY csn elun vw cv
      vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy cab wcel vw cv
      cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vw cv cY csn wcel vw cv
      cY wceq vy cv cF vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vw cv cF
      vz cv cima wceq vz cA csn cJ cnei cfv cfv wrex vy vw cv vw visset vy cv
      vw cv wceq vy cv cF vz cv cima wceq vw cv cF vz cv cima wceq vz cA csn cJ
      cnei cfv cfv vy cv vw cv cF vz cv cima eqeq1 rexbidv elab vw cY elsn
      orbi12i bitri syl5ib r19.23adv com23 imp3a sylbid a1d mpdd r19.21aiv
      expcom syl6 com3r mpd syld impbid bitrd $.
      $( [7-Sep-2009] $) $( [7-Sep-2009] $)

    $( A function is continuous iff it respects filter limits.
       (Contributed by Jeff Hankins, 6-Sep-2009.) $)
    cnfillim $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) -> ( F e. ( J Cn K
    ) <-> A. f e. Fil ( X = U. f -> A. x e. X ( x e. ( ( fLim1 ` J ) ` f ) -> (
    F ` x ) e. ( ( fLim1 ` K ) ` L ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cF vx cv
      cJ cK ccnp co cfv wcel vx cX wral cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vf cfil
      wral vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx
      cv cF cfv cL cK cflim1 cfv cfv wcel wi vx cX wral wi vf cfil wral vx cF
      cJ cK cX cY cnfillim.1 cnfillim.2 cncnp cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cF vx cv cJ cK ccnp co cfv wcel cX vf cv cuni wceq vx cv vf cv
      cJ cflim1 cfv cfv wcel wa vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vf
      cfil wral vx cX vy vz vx cv vf cF cJ cK cL cX cY cnfillim.1 cnfillim.2
      cnfillim.3 cnpfillim ralbidva cX vf cv cuni wceq vx cv vf cv cJ cflim1
      cfv cfv wcel wa vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vf cfil wral vx
      cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF
      cfv cL cK cflim1 cfv cfv wcel wi vx cX wral wi vf cfil wral wb cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vf cfil
      wral vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel wa
      vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vx cX wral vf cfil wral cX vf
      cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cL cK cflim1
      cfv cfv wcel wi wi vx cX wral vf cfil wral cX vf cv cuni wceq vx cv vf cv
      cJ cflim1 cfv cfv wcel vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vx cX
      wral wi vf cfil wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv
      wcel wa vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vx vf cX cfil ralcom cX
      vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel wa vx cv cF cfv cL cK
      cflim1 cfv cfv wcel wi cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv
      wcel vx cv cF cfv cL cK cflim1 cfv cfv wcel wi wi vf vx cfil cX cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cL cK cflim1
      cfv cfv wcel impexp 2ralbii cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv
      cfv wcel vx cv cF cfv cL cK cflim1 cfv cfv wcel wi wi vx cX wral cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cL cK cflim1
      cfv cfv wcel wi vx cX wral wi vf cfil cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel vx cv cF cfv cL cK cflim1 cfv cfv wcel wi vx cX
      r19.21v ralbii 3bitri a1i 3bitrd $.
      $( [6-Sep-2009] $) $( [6-Sep-2009] $)
  $}


  ${
    $d x A $. $d x B $. $d x F $. $d x L $. $d x S $. $d x X $. $d x Y $.
    imaelfm.1 $e |- Y = U. B $.
    imaelfm.2 $e |- L = ( filGen ` B ) $.
    $( An image of a filter element is in the image filter. (Contributed by
       Jeff Hankins, 5-Oct-2009.) $)
    imaelfm $p |- ( ( ( X e. A /\ B e. fBas /\ F : Y --> X ) /\ S e. L ) -> ( F
    " S ) e. ( ( X FilMap B ) ` F ) ) $=
      cX cA wcel cB cfbas wcel cY cX cF wf w3a cS cL wcel wa cF cS cima cF cX
      cB cfilmap co cfv wcel cF cS cima cX wss cF vx cv cima cF cS cima wss vx
      cL wrex wa cX cA wcel cB cfbas wcel cY cX cF wf w3a cF cS cima cX wss cS
      cL wcel cF vx cv cima cF cS cima wss vx cL wrex cY cX cF wf cX cA wcel cF
      cS cima cX wss cB cfbas wcel cY cX cF wf cF cS cima cF crn cX cF cS cima
      cF crn wss cY cX cF wf cF cS imassrn a1i cY cX cF frn sstrd 3ad2ant3 cS
      cL wcel cF cS cima cF cS cima wss cF vx cv cima cF cS cima wss vx cL wrex
      cF cS cima ssid cF vx cv cima cF cS cima wss cF cS cima cF cS cima wss vx
      cS cL vx cv cS wceq cF vx cv cima cF cS cima cF cS cima vx cv cS cF
      imaeq2 sseq1d rcla4ev mpan2 anim12i cX cA wcel cB cfbas wcel cY cX cF wf
      w3a cF cS cima cF cX cB cfilmap co cfv wcel cF cS cima cX wss cF vx cv
      cima cF cS cima wss vx cL wrex wa wb cS cL wcel vx cF cS cima cB cA cF cL
      cX cY imaelfm.1 imaelfm.2 elfilmap2 adantr mpbird $.
      $( [5-Oct-2009] $) $( [5-Oct-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $. $d x y z F $. $d x y z X $. $d x
    y z Y $. $d x y z Z $.
    filmapss.1 $e |- Y = U. B $.
    filmapss.2 $e |- Z = U. C $.
    $( A finer filter produces a finer image filter.
       (Contributed by Jeff Hankins, 16-Nov-2009.) $)
    filmapss $p |- ( ( ( X e. A /\ B e. fBas /\ C e. fBas ) /\ ( F : Y --> X /\
    Y = Z /\ B C_ C ) ) -> ( ( X FilMap B ) ` F ) C_ ( ( X FilMap C ) ` F ) )
    $=
      cX cA wcel cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY cZ wceq cB cC
      wss w3a wa vx cv cF vy cv cima wceq vy cB wrex vx cab cX csn cun cfg cfv
      vx cv cF vy cv cima wceq vy cC wrex vx cab cX csn cun cfg cfv cF cX cB
      cfilmap co cfv cF cX cC cfilmap co cfv vx cv cF vy cv cima wceq vy cB
      wrex vx cab cX csn cun cfbas wcel vx cv cF vy cv cima wceq vy cC wrex vx
      cab cX csn cun cfbas wcel vx cv cF vy cv cima wceq vy cB wrex vx cab cX
      csn cun vx cv cF vy cv cima wceq vy cC wrex vx cab cX csn cun wss vx cv
      cF vy cv cima wceq vy cB wrex vx cab cX csn cun cfg cfv vx cv cF vy cv
      cima wceq vy cC wrex vx cab cX csn cun cfg cfv wss cX cA wcel cB cfbas
      wcel cC cfbas wcel w3a cY cX cF wf cY cZ wceq cB cC wss w3a wa vx cv cF
      vy cv cima wceq vy cB wrex vx cab cX csn cun vx cv cF vy cv cima wceq vy
      cC wrex vx cab cX csn cun fgss vx cv cF vy cv cima wceq vy cB wrex vx cab
      cfbas wcel vx cv cF vy cv cima wceq vy cB wrex vx cab cuni cX wss vx cv
      cF vy cv cima wceq vy cB wrex vx cab cX csn cun cfbas wcel cX cA wcel cB
      cfbas wcel cC cfbas wcel w3a cY cX cF wf cY cZ wceq cB cC wss w3a wa cX
      vx cv cF vy cv cima wceq vy cB wrex vx cab vx cv cF vy cv cima wceq vy cB
      wrex vx cab cuni vx cv cF vy cv cima wceq vy cB wrex vx cab cuni eqid
      extbas1 cB cfbas wcel cF cY wfn vx cv cF vy cv cima wceq vy cB wrex vx
      cab cfbas wcel cX cA wcel cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY
      cZ wceq cB cC wss w3a vy vx cB vx cv cF vy cv cima wceq vy cB wrex vx cab
      cF cY filmapss.1 vx cv cF vy cv cima wceq vy cB wrex vx cab eqid filrn cX
      cA wcel cB cfbas wcel cC cfbas wcel 3simp2 cY cX cF wf cY cZ wceq cF cY
      wfn cB cC wss cY cX cF ffn 3ad2ant1 syl2an cY cX cF wf cY cZ wceq cB cC
      wss w3a vx cv cF vy cv cima wceq vy cB wrex vx cab cuni cX wss cX cA wcel
      cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY cZ wceq vx cv cF vy cv
      cima wceq vy cB wrex vx cab cuni cX wss cB cC wss cY cX cF wf vz cv cX
      wss vz vx cv cF vy cv cima wceq vy cB wrex vx cab wral vx cv cF vy cv
      cima wceq vy cB wrex vx cab cuni cX wss cY cX cF wf vz cv cX wss vz vx cv
      cF vy cv cima wceq vy cB wrex vx cab cY cX cF wf vz cv cF vy cv cima wceq
      vy cB wrex vz cv cX wss vz cv vx cv cF vy cv cima wceq vy cB wrex vx cab
      wcel cY cX cF wf vz cv cF vy cv cima wceq vz cv cX wss vy cB cY cX cF wf
      vz cv cF vy cv cima wceq vz cv cX wss wi vy cv cB wcel vz cv cF vy cv
      cima wceq vz cv cX wss cF vy cv cima cX wss cY cX cF wf vz cv cF vy cv
      cima cX sseq1 cY cX cF wf cF vy cv cima cF crn cX cF vy cv cima cF crn
      wss cY cX cF wf cF vy cv imassrn a1i cY cX cF frn sstrd syl5cbir a1d
      r19.23adv vx cv cF vy cv cima wceq vy cB wrex vz cv cF vy cv cima wceq vy
      cB wrex vx vz cv vz visset vx cv vz cv wceq vx cv cF vy cv cima wceq vz
      cv cF vy cv cima wceq vy cB vx cv vz cv cF vy cv cima eqeq1 rexbidv elab
      syl5ib r19.21aiv vz vx cv cF vy cv cima wceq vy cB wrex vx cab cX unissb
      sylibr 3ad2ant1 adantl sylanc vx cv cF vy cv cima wceq vy cC wrex vx cab
      cfbas wcel vx cv cF vy cv cima wceq vy cC wrex vx cab cuni cX wss vx cv
      cF vy cv cima wceq vy cC wrex vx cab cX csn cun cfbas wcel cX cA wcel cB
      cfbas wcel cC cfbas wcel w3a cY cX cF wf cY cZ wceq cB cC wss w3a wa cX
      vx cv cF vy cv cima wceq vy cC wrex vx cab vx cv cF vy cv cima wceq vy cC
      wrex vx cab cuni vx cv cF vy cv cima wceq vy cC wrex vx cab cuni eqid
      extbas1 cC cfbas wcel cF cZ wfn vx cv cF vy cv cima wceq vy cC wrex vx
      cab cfbas wcel cX cA wcel cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY
      cZ wceq cB cC wss w3a vy vx cC vx cv cF vy cv cima wceq vy cC wrex vx cab
      cF cZ filmapss.2 vx cv cF vy cv cima wceq vy cC wrex vx cab eqid filrn cX
      cA wcel cB cfbas wcel cC cfbas wcel 3simp3 cY cX cF wf cY cZ wceq cF cZ
      wfn cB cC wss cF cY wfn cY cZ wceq cF cZ wfn cY cX cF wf cY cZ wceq cF cY
      wfn cF cZ wfn cY cZ cF fneq2 biimpac cY cX cF ffn sylan 3adant3 syl2an cY
      cX cF wf cY cZ wceq cB cC wss w3a vx cv cF vy cv cima wceq vy cC wrex vx
      cab cuni cX wss cX cA wcel cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY
      cZ wceq vx cv cF vy cv cima wceq vy cC wrex vx cab cuni cX wss cB cC wss
      cY cX cF wf vz cv cX wss vz vx cv cF vy cv cima wceq vy cC wrex vx cab
      wral vx cv cF vy cv cima wceq vy cC wrex vx cab cuni cX wss cY cX cF wf
      vz cv cX wss vz vx cv cF vy cv cima wceq vy cC wrex vx cab cY cX cF wf vz
      cv cF vy cv cima wceq vy cC wrex vz cv cX wss vz cv vx cv cF vy cv cima
      wceq vy cC wrex vx cab wcel cY cX cF wf vz cv cF vy cv cima wceq vz cv cX
      wss vy cC cY cX cF wf vz cv cF vy cv cima wceq vz cv cX wss wi vy cv cC
      wcel vz cv cF vy cv cima wceq vz cv cX wss cF vy cv cima cX wss cY cX cF
      wf vz cv cF vy cv cima cX sseq1 cY cX cF wf cF vy cv cima cF crn cX cF vy
      cv cima cF crn wss cY cX cF wf cF vy cv imassrn a1i cY cX cF frn sstrd
      syl5cbir a1d r19.23adv vx cv cF vy cv cima wceq vy cC wrex vz cv cF vy cv
      cima wceq vy cC wrex vx vz cv vz visset vx cv vz cv wceq vx cv cF vy cv
      cima wceq vz cv cF vy cv cima wceq vy cC vx cv vz cv cF vy cv cima eqeq1
      rexbidv elab syl5ib r19.21aiv vz vx cv cF vy cv cima wceq vy cC wrex vx
      cab cX unissb sylibr 3ad2ant1 adantl sylanc cX cA wcel cB cfbas wcel cC
      cfbas wcel w3a cY cX cF wf cY cZ wceq cB cC wss w3a wa vx cv cF vy cv
      cima wceq vy cB wrex vx cab vx cv cF vy cv cima wceq vy cC wrex vx cab
      wss vx cv cF vy cv cima wceq vy cB wrex vx cab cX csn cun vx cv cF vy cv
      cima wceq vy cC wrex vx cab cX csn cun wss cX cA wcel cB cfbas wcel cC
      cfbas wcel w3a cY cX cF wf cY cZ wceq cB cC wss w3a wa vx cv cF vy cv
      cima wceq vy cB wrex vx cv cF vy cv cima wceq vy cC wrex wi vx wal vx cv
      cF vy cv cima wceq vy cB wrex vx cab vx cv cF vy cv cima wceq vy cC wrex
      vx cab wss cX cA wcel cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY cZ
      wceq cB cC wss w3a wa vx cv cF vy cv cima wceq vy cB wrex vx cv cF vy cv
      cima wceq vy cC wrex wi vx cY cX cF wf cY cZ wceq cB cC wss w3a vx cv cF
      vy cv cima wceq vy cB wrex vx cv cF vy cv cima wceq vy cC wrex wi cX cA
      wcel cB cfbas wcel cC cfbas wcel w3a cB cC wss cY cX cF wf vx cv cF vy cv
      cima wceq vy cB wrex vx cv cF vy cv cima wceq vy cC wrex wi cY cZ wceq vx
      cv cF vy cv cima wceq vy cB cC ssrexv 3ad2ant3 adantl 19.21aiv vx cv cF
      vy cv cima wceq vy cB wrex vx cv cF vy cv cima wceq vy cC wrex vx ss2ab
      sylibr vx cv cF vy cv cima wceq vy cB wrex vx cab vx cv cF vy cv cima
      wceq vy cC wrex vx cab cX csn unss1 syl syl3anc cX cA wcel cB cfbas wcel
      cY cX cF wf cY cZ wceq cB cC wss w3a cF cX cB cfilmap co cfv vx cv cF vy
      cv cima wceq vy cB wrex vx cab cX csn cun cfg cfv wceq cC cfbas wcel cX
      cA wcel cB cfbas wcel wa cY cZ wceq cY cX cF wf cF cX cB cfilmap co cfv
      vx cv cF vy cv cima wceq vy cB wrex vx cab cX csn cun cfg cfv wceq cB cC
      wss cX cA wcel cB cfbas wcel cY cX cF wf cF cX cB cfilmap co cfv vx cv cF
      vy cv cima wceq vy cB wrex vx cab cX csn cun cfg cfv wceq vx vy cA cB cF
      cX cY filmapss.1 isfilmap 3expa 3ad2antr1 3adantl3 cX cA wcel cC cfbas
      wcel cZ cX cF wf cF cX cC cfilmap co cfv vx cv cF vy cv cima wceq vy cC
      wrex vx cab cX csn cun cfg cfv wceq cX cA wcel cB cfbas wcel cC cfbas
      wcel w3a cY cX cF wf cY cZ wceq cB cC wss w3a wa vx vy cA cC cF cX cZ
      filmapss.2 isfilmap cX cA wcel cB cfbas wcel cC cfbas wcel w3a cX cA wcel
      cY cX cF wf cY cZ wceq cB cC wss w3a cX cA wcel cB cfbas wcel cC cfbas
      wcel 3simp1 adantr cX cA wcel cB cfbas wcel cC cfbas wcel w3a cC cfbas
      wcel cY cX cF wf cY cZ wceq cB cC wss w3a cX cA wcel cB cfbas wcel cC
      cfbas wcel 3simp3 adantr cY cX cF wf cY cZ wceq cB cC wss w3a cZ cX cF wf
      cX cA wcel cB cfbas wcel cC cfbas wcel w3a cY cX cF wf cY cZ wceq cZ cX
      cF wf cB cC wss cY cZ wceq cY cX cF wf cZ cX cF wf cY cZ cX cF feq2
      biimpac 3adant3 adantl syl3anc 3sstr4d $.
      $( [16-Nov-2009] $) $( [16-Nov-2009] $)
  $}

  ${
    $d s x B $. $d s x C $. $d s x F $. $d s x L $. $d s x X $. $d s x Y $.
    fbfgfmeq.1 $e |- Y = U. B $.
    fbfgfmeq.2 $e |- L = ( filGen ` B ) $.
    $( The image filter of a filter base is the same as the image filter of its
       generated filter. (Contributed by Jeff Hankins, 18-Nov-2009.) $)
    fbfgfmeq $p |- ( ( X e. C /\ B e. fBas /\ F : Y --> X ) -> ( ( X FilMap B )
    ` F ) = ( ( X FilMap L ) ` F ) ) $=
      cX cC wcel cB cfbas wcel cY cX cF wf w3a vx cF cX cB cfilmap co cfv cF cX
      cL cfilmap co cfv cX cC wcel cB cfbas wcel cY cX cF wf w3a vx cv cF cX cB
      cfilmap co cfv wcel vx cv cX wss cF vs cv cima vx cv wss vs cL wrex wa vx
      cv cF cX cL cfilmap co cfv wcel vs vx cv cB cC cF cL cX cY fbfgfmeq.1
      fbfgfmeq.2 elfilmap2 cX cC wcel cL cfbas wcel cB cfg cfv cuni cX cF wf vx
      cv cF cX cL cfilmap co cfv wcel vx cv cX wss cF vs cv cima vx cv wss vs
      cL wrex wa wb cX cC wcel cB cfbas wcel cY cX cF wf w3a vs vx cv cL cC cF
      cX cB cfg cfv cuni cL cuni cB cfg cfv cuni cL cB cfg cfv fbfgfmeq.2
      unieqi eqcomi elfilmap cX cC wcel cB cfbas wcel cY cX cF wf 3simp1 cB
      cfbas wcel cX cC wcel cL cfbas wcel cY cX cF wf cB cfbas wcel cL cfil
      wcel cL cfbas wcel cB cfbas wcel cB cfg cfv cfil cL cB fgfil fbfgfmeq.2
      syl5eqel cL filfbas syl 3ad2ant2 cX cC wcel cB cfbas wcel cY cX cF wf cB
      cfg cfv cuni cX cF wf cB cfbas wcel cY cX cF wf cB cfg cfv cuni cX cF wf
      wb cX cC wcel cB cfbas wcel cY cB cfg cfv cuni wceq cY cX cF wf cB cfg
      cfv cuni cX cF wf wb cB cY fbfgfmeq.1 fgbas cY cB cfg cfv cuni cX cF feq2
      syl adantl biimp3a syl3anc bitr4d eqrdv $.
      $( [18-Nov-2009] $) $( [18-Nov-2009] $)
  $}

  ${
    $d b r s t u v x y z A $. $d b r s t u v x y z F $. $d b r s t u v x y z L
    $. $d b r s t u v x y z L $. $d b r s t u v x y z X $. $d b r s t u v x y z
    Y $.
    rnelfm.1 $e |- X = U. L $.
    $( Lemma for ~ rnelfm . (Contributed by Jeff Hankins, 14-Nov-2009.) $)
    rnelfmlem $p |- ( ( ( Y e. A /\ L e. Fil /\ F : Y --> X ) /\ ran F e. L )
    -> { y | E. x e. L y = ( `' F " x ) } e. fBas ) $=
      cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cfbas wcel vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab c0 wne c0 vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab wnel vt cv vr cv vs cv cin wss vt vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wrex vs vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wral vr vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral w3a cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab c0 wne c0 vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wnel vt cv vr cv vs cv cin wss vt vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab wrex vs vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab wral vr vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab wcel vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab c0 wne cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx
      cv cima wceq vx cL wrex cX cL wcel cY cF ccnv cX cima wceq cY cF ccnv vx
      cv cima wceq vx cL wrex cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa cY cF ccnv vx cv cima wceq cY cF ccnv cX cima wceq vx cX cL vx cv
      cX wceq cF ccnv vx cv cima cF ccnv cX cima cY vx cv cX cF ccnv imaeq2
      eqeq2d rcla4ev cY cA wcel cL cfil wcel cY cX cF wf w3a cX cL wcel cF crn
      cL wcel cL cfil wcel cY cA wcel cX cL wcel cY cX cF wf cL cX rnelfm.1
      filusb 3ad2ant2 adantr cY cA wcel cL cfil wcel cY cX cF wf w3a cY cF ccnv
      cX cima wceq cF crn cL wcel cY cX cF wf cY cA wcel cY cF ccnv cX cima
      wceq cL cfil wcel cY cX cF wf cF ccnv cX cima cY cY cX cF fimacnv eqcomd
      3ad2ant3 adantr sylanc cY cA wcel cL cfil wcel cY cX cF wf w3a cY vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx cv cima wceq
      vx cL wrex wb cF crn cL wcel cY cA wcel cL cfil wcel cY vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx cv cima wceq vx cL wrex
      wb cY cX cF wf vy cv cF ccnv vx cv cima wceq vx cL wrex cY cF ccnv vx cv
      cima wceq vx cL wrex vy cY cA vy cv cY wceq vy cv cF ccnv vx cv cima wceq
      cY cF ccnv vx cv cima wceq vx cL vy cv cY cF ccnv vx cv cima eqeq1
      rexbidv elabg 3ad2ant1 adantr mpbird vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cY ne0i syl cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa c0 vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel wn c0 vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab wnel cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa c0 vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wcel c0 cL wcel cY cA wcel cL cfil wcel cY cX cF wf w3a c0 cL
      wcel wn cF crn cL wcel cL cfil wcel cY cA wcel c0 cL wcel wn cY cX cF wf
      cL filesn 3ad2ant2 adantr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa c0 cF ccnv vx cv cima wceq vx cL wrex c0 cL wcel c0 vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa c0 cF ccnv vx cv cima wceq c0 cL wcel vx cL
      cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel
      c0 cF ccnv vx cv cima wceq c0 cL wcel cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel c0 cF ccnv vx cv cima wceq wa wa c0
      vx cv cF crn cin cL cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa vx cv cL wcel c0 cF ccnv vx cv cima wceq wa wa vy cv vx cv wcel
      vy cv cF crn wcel wn wi vy wal c0 vx cv cF crn cin wceq cY cA wcel cL
      cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel c0 cF ccnv vx
      cv cima wceq wa wa vy cv vx cv wcel vy cv cF crn wcel wn wi vy cY cA wcel
      cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel c0 cF ccnv
      vx cv cima wceq vy cv vx cv wcel vy cv cF crn wcel wn wi cY cA wcel cL
      cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa vy cv vx cv
      wcel c0 cF ccnv vx cv cima wceq vy cv cF crn wcel wn cY cA wcel cL cfil
      wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel vy cv vx cv wcel c0
      cF ccnv vx cv cima wceq vy cv cF crn wcel wn wi cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel vy cv vx cv wcel wa wa vy
      cv cF crn wcel c0 cF ccnv vx cv cima wceq cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa vx cv cL wcel vy cv vx cv wcel wa wa vy cv cF
      crn wcel vz cv cF cfv vy cv wceq vz cY wrex c0 cF ccnv vx cv cima wceq wn
      cY cA wcel cL cfil wcel cY cX cF wf w3a vy cv cF crn wcel vz cv cF cfv vy
      cv wceq vz cY wrex wb cF crn cL wcel vx cv cL wcel vy cv vx cv wcel wa cY
      cX cF wf cY cA wcel vy cv cF crn wcel vz cv cF cfv vy cv wceq vz cY wrex
      wb cL cfil wcel cY cX cF wf cF cY wfn vy cv cF crn wcel vz cv cF cfv vy
      cv wceq vz cY wrex wb cY cX cF ffn vz cY vy cv cF fvelrnb syl 3ad2ant3
      ad2antrr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv
      cL wcel vy cv vx cv wcel wa wa vz cv cF cfv vy cv wceq c0 cF ccnv vx cv
      cima wceq wn vz cY cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa vx cv cL wcel vy cv vx cv wcel wa wa vz cv cY wcel vz cv cF cfv vy cv
      wceq c0 cF ccnv vx cv cima wceq wn cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel vy cv vx cv wcel wa wa vz cv cY wcel
      vz cv cF cfv vy cv wceq wa wa vz cv cF ccnv vx cv cima wcel c0 cF ccnv vx
      cv cima wceq wn cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa
      vx cv cL wcel vy cv vx cv wcel wa wa vz cv cY wcel vz cv cF cfv vy cv
      wceq wa wa vz cv cF cfv vx cv wcel vz cv cF ccnv vx cv cima wcel vx cv cL
      wcel vy cv vx cv wcel wa vz cv cY wcel vz cv cF cfv vy cv wceq wa vz cv
      cF cfv vx cv wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa vy cv vx cv wcel vz cv cF cfv vy cv wceq vz cv cF cfv vx cv wcel vx cv
      cL wcel vz cv cY wcel vz cv cF cfv vy cv wceq vz cv cF cfv vx cv wcel vy
      cv vx cv wcel vz cv cF cfv vy cv vx cv eleq1 biimparc ad2ant2l adantll cF
      wfun vz cv cF cdm wcel vz cv cF cfv vx cv wcel vz cv cF ccnv vx cv cima
      wcel wb cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv
      cL wcel vy cv vx cv wcel wa wa vz cv cY wcel vz cv cF cfv vy cv wceq wa
      wa vz cv vx cv cF fvimacnv cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa cF wfun vx cv cL wcel vy cv vx cv wcel wa vz cv cY wcel vz cv
      cF cfv vy cv wceq wa cY cA wcel cL cfil wcel cY cX cF wf w3a cF wfun cF
      crn cL wcel cY cX cF wf cY cA wcel cF wfun cL cfil wcel cY cX cF ffun
      3ad2ant3 adantr ad2antrr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa vz cv cY wcel vz cv cF cdm wcel vx cv cL wcel vy cv vx cv wcel
      wa vz cv cF cfv vy cv wceq cY cA wcel cL cfil wcel cY cX cF wf w3a vz cv
      cY wcel vz cv cF cdm wcel cF crn cL wcel cY cX cF wf cY cA wcel vz cv cY
      wcel vz cv cF cdm wcel cL cfil wcel cY cX cF wf vz cv cF cdm wcel vz cv
      cY wcel cY cX cF wf cF cdm cY vz cv cY cX cF fdm eleq2d biimpar 3ad2antl3
      adantlr ad2ant2r sylanc mpbid vz cv cF ccnv vx cv cima wcel cF ccnv vx cv
      cima c0 wceq wn c0 cF ccnv vx cv cima wceq wn cF ccnv vx cv cima vz cv
      n0i cF ccnv vx cv cima c0 wceq c0 cF ccnv vx cv cima wceq cF ccnv vx cv
      cima c0 eqcom notbii sylib syl exp32 r19.23adv sylbid con2d expr com23
      impr 19.21aiv vy cv vx cv wcel vy cv cF crn wcel wn wi vy wal vy cv vx cv
      cF crn cin wcel wn vy wal vx cv cF crn cin c0 wceq c0 vx cv cF crn cin
      wceq vy cv vx cv wcel vy cv cF crn wcel wn wi vy cv vx cv cF crn cin wcel
      wn vy vy cv vx cv wcel vy cv cF crn wcel wn wi vy cv vx cv wcel vy cv cF
      crn wcel wa wn vy cv vx cv cF crn cin wcel wn vy cv vx cv wcel vy cv cF
      crn wcel imnan vy cv vx cv cF crn cin wcel vy cv vx cv wcel vy cv cF crn
      wcel wa vy cv vx cv cF crn elin notbii bitr4i albii vy vx cv cF crn cin
      eq0 vx cv cF crn cin c0 eqcom 3bitr2i sylib cL cfil wcel vx cv cL wcel cF
      crn cL wcel vx cv cF crn cin cL wcel cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel c0 cF ccnv vx cv cima wceq wa wa vx
      cv cF crn cL filint cY cA wcel cL cfil wcel cY cX cF wf w3a cL cfil wcel
      cF crn cL wcel vx cv cL wcel c0 cF ccnv vx cv cima wceq wa cY cA wcel cL
      cfil wcel cY cX cF wf 3simp2 ad2antrr cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel c0 cF ccnv vx cv cima wceq simprl cY
      cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel vx cv cL wcel c0 cF
      ccnv vx cv cima wceq wa simplr syl3anc eqeltrd exp32 r19.23adv vy cv cF
      ccnv vx cv cima wceq vx cL wrex c0 cF ccnv vx cv cima wceq vx cL wrex vy
      c0 0ex vy cv c0 wceq vy cv cF ccnv vx cv cima wceq c0 cF ccnv vx cv cima
      wceq vx cL vy cv c0 cF ccnv vx cv cima eqeq1 rexbidv elab syl5ib mtod c0
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab df-nel sylibr cY cA wcel
      cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vt cv vr cv vs cv cin wss
      vt vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex vr vs vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa
      vr cv cF ccnv vu cv cima wceq vs cv cF ccnv vv cv cima wceq wa vv cL wrex
      vu cL wrex vt cv vr cv vs cv cin wss vt vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wrex vr cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wcel vs cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel wa cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vr cv cF ccnv vu cv
      cima wceq vs cv cF ccnv vv cv cima wceq wa vt cv vr cv vs cv cin wss vt
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex vu vv cL cL cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vu cv cL wcel vv cv
      cL wcel wa vr cv cF ccnv vu cv cima wceq vs cv cF ccnv vv cv cima wceq wa
      vt cv vr cv vs cv cin wss vt vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab wrex cF ccnv vu cv vv cv cin cima vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wcel cF ccnv vu cv vv cv cin cima vr cv vs cv cin wss vt cv
      vr cv vs cv cin wss vt vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wrex cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vu cv cL
      wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq vs cv cF ccnv vv cv
      cima wceq wa wa wa vt cv vr cv vs cv cin wss cF ccnv vu cv vv cv cin cima
      vr cv vs cv cin wss vt cF ccnv vu cv vv cv cin cima vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab vt cv cF ccnv vu cv vv cv cin cima vr cv vs
      cv cin sseq1 rcla4ev cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq vs
      cv cF ccnv vv cv cima wceq wa wa wa cF ccnv vu cv vv cv cin cima vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wcel cF ccnv vu cv vv cv cin cima
      cF ccnv vx cv cima wceq vx cL wrex cY cA wcel cL cfil wcel cY cX cF wf
      w3a vu cv cL wcel vv cv cL wcel wa cF ccnv vu cv vv cv cin cima cF ccnv
      vx cv cima wceq vx cL wrex cF crn cL wcel vr cv cF ccnv vu cv cima wceq
      vs cv cF ccnv vv cv cima wceq wa cL cfil wcel cY cX cF wf vu cv cL wcel
      vv cv cL wcel wa cF ccnv vu cv vv cv cin cima cF ccnv vx cv cima wceq vx
      cL wrex cY cA wcel vu cv vv cv cin cL wcel cF ccnv vu cv vv cv cin cima
      cF ccnv vu cv vv cv cin cima wceq cF ccnv vu cv vv cv cin cima cF ccnv vx
      cv cima wceq vx cL wrex cL cfil wcel cY cX cF wf wa vu cv cL wcel vv cv
      cL wcel wa wa cF ccnv vu cv vv cv cin cima cF ccnv vx cv cima wceq cF
      ccnv vu cv vv cv cin cima cF ccnv vu cv vv cv cin cima wceq vx vu cv vv
      cv cin cL vx cv vu cv vv cv cin wceq cF ccnv vx cv cima cF ccnv vu cv vv
      cv cin cima cF ccnv vu cv vv cv cin cima vx cv vu cv vv cv cin cF ccnv
      imaeq2 eqeq2d rcla4ev cL cfil wcel vu cv cL wcel vv cv cL wcel wa vu cv
      vv cv cin cL wcel cY cX cF wf cL cfil wcel vu cv cL wcel vv cv cL wcel vu
      cv vv cv cin cL wcel vu cv vv cv cL filint 3expb adantlr cL cfil wcel cY
      cX cF wf wa vu cv cL wcel vv cv cL wcel wa wa cF ccnv vu cv vv cv cin
      cima eqidd sylanc 3adantl1 ad2ant2r cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv
      cima wceq vs cv cF ccnv vv cv cima wceq wa wa wa cF ccnv vu cv vv cv cin
      cima cvv wcel cF ccnv vu cv vv cv cin cima vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab wcel cF ccnv vu cv vv cv cin cima cF ccnv vx cv cima
      wceq vx cL wrex wb cF ccnv vu cv vv cv cin cima cY wss cY cA wcel cF ccnv
      vu cv vv cv cin cima cvv wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF
      crn cL wcel wa vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima
      wceq vs cv cF ccnv vv cv cima wceq wa wa wa cF ccnv vu cv vv cv cin cima
      cY cA ssexg cY cA wcel cL cfil wcel cY cX cF wf w3a cF ccnv vu cv vv cv
      cin cima cY wss cF crn cL wcel vu cv cL wcel vv cv cL wcel wa vr cv cF
      ccnv vu cv cima wceq vs cv cF ccnv vv cv cima wceq wa wa cY cX cF wf cY
      cA wcel cF ccnv vu cv vv cv cin cima cY wss cL cfil wcel cY cX cF wf cF
      ccnv vu cv vv cv cin cima cF cdm cY cF ccnv vu cv vv cv cin cima cF cdm
      wss cY cX cF wf cF vu cv vv cv cin cnvimass a1i cY cX cF fdm sseqtrd
      3ad2ant3 ad2antrr cY cA wcel cL cfil wcel cY cX cF wf w3a cY cA wcel cF
      crn cL wcel vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq
      vs cv cF ccnv vv cv cima wceq wa wa cY cA wcel cL cfil wcel cY cX cF wf
      3simp1 ad2antrr sylanc vy cv cF ccnv vx cv cima wceq vx cL wrex cF ccnv
      vu cv vv cv cin cima cF ccnv vx cv cima wceq vx cL wrex vy cF ccnv vu cv
      vv cv cin cima cvv vy cv cF ccnv vu cv vv cv cin cima wceq vy cv cF ccnv
      vx cv cima wceq cF ccnv vu cv vv cv cin cima cF ccnv vx cv cima wceq vx
      cL vy cv cF ccnv vu cv vv cv cin cima cF ccnv vx cv cima eqeq1 rexbidv
      elabg syl mpbird cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq vs cv cF
      ccnv vv cv cima wceq wa wa wa vr cv vs cv cin cF ccnv vu cv vv cv cin
      cima wceq cF ccnv vu cv vv cv cin cima vr cv vs cv cin wss cY cA wcel cL
      cfil wcel cY cX cF wf w3a cF crn cL wcel wa vu cv cL wcel vv cv cL wcel
      wa vr cv cF ccnv vu cv cima wceq vs cv cF ccnv vv cv cima wceq wa wa wa
      vr cv vs cv cin cF ccnv vu cv cima cF ccnv vv cv cima cin cF ccnv vu cv
      vv cv cin cima cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa
      vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq vs cv cF
      ccnv vv cv cima wceq wa wa wa vr cv cF ccnv vu cv cima vs cv cF ccnv vv
      cv cima cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vu cv
      cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq vs cv cF ccnv vv
      cv cima wceq simprrl cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv vu cv cima wceq vs
      cv cF ccnv vv cv cima wceq simprrr ineq12d cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF ccnv vu cv vv cv cin cima cF ccnv vu cv cima cF ccnv vv cv
      cima cin wceq cF crn cL wcel vu cv cL wcel vv cv cL wcel wa vr cv cF ccnv
      vu cv cima wceq vs cv cF ccnv vv cv cima wceq wa wa cY cX cF wf cY cA
      wcel cF ccnv vu cv vv cv cin cima cF ccnv vu cv cima cF ccnv vv cv cima
      cin wceq cL cfil wcel cY cX cF wf cF wfun cF ccnv ccnv wfun cF ccnv vu cv
      vv cv cin cima cF ccnv vu cv cima cF ccnv vv cv cima cin wceq cY cX cF
      ffun cF funcnvcnv vu cv vv cv cF ccnv imain 3syl 3ad2ant3 ad2antrr eqtr4d
      cF ccnv vu cv vv cv cin cima vr cv vs cv cin eqimss2 syl sylanc exp32
      r19.23advv vr cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vs
      cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel wa vr cv cF ccnv
      vu cv cima wceq vu cL wrex vs cv cF ccnv vv cv cima wceq vv cL wrex wa vr
      cv cF ccnv vu cv cima wceq vs cv cF ccnv vv cv cima wceq wa vv cL wrex vu
      cL wrex vr cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vr cv
      cF ccnv vu cv cima wceq vu cL wrex vs cv vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wcel vs cv cF ccnv vv cv cima wceq vv cL wrex vr cv vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vr cv cF ccnv vx cv cima
      wceq vx cL wrex vr cv cF ccnv vu cv cima wceq vu cL wrex vy cv cF ccnv vx
      cv cima wceq vx cL wrex vr cv cF ccnv vx cv cima wceq vx cL wrex vy vr cv
      vr visset vy cv vr cv wceq vy cv cF ccnv vx cv cima wceq vr cv cF ccnv vx
      cv cima wceq vx cL vy cv vr cv cF ccnv vx cv cima eqeq1 rexbidv elab vr
      cv cF ccnv vx cv cima wceq vr cv cF ccnv vu cv cima wceq vx vu cL vx cv
      vu cv wceq cF ccnv vx cv cima cF ccnv vu cv cima vr cv vx cv vu cv cF
      ccnv imaeq2 eqeq2d cbvrexv bitri vs cv vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wcel vs cv cF ccnv vx cv cima wceq vx cL wrex vs cv cF
      ccnv vv cv cima wceq vv cL wrex vy cv cF ccnv vx cv cima wceq vx cL wrex
      vs cv cF ccnv vx cv cima wceq vx cL wrex vy vs cv vs visset vy cv vs cv
      wceq vy cv cF ccnv vx cv cima wceq vs cv cF ccnv vx cv cima wceq vx cL vy
      cv vs cv cF ccnv vx cv cima eqeq1 rexbidv elab vs cv cF ccnv vx cv cima
      wceq vs cv cF ccnv vv cv cima wceq vx vv cL vx cv vv cv wceq cF ccnv vx
      cv cima cF ccnv vv cv cima vs cv vx cv vv cv cF ccnv imaeq2 eqeq2d
      cbvrexv bitri anbi12i vr cv cF ccnv vu cv cima wceq vs cv cF ccnv vv cv
      cima wceq vu vv cL cL reeanv bitr4i syl5ib r19.21aivv 3jca cY cA wcel cL
      cfil wcel cY cX cF wf w3a vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab c0 wne c0 vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab wnel vt cv vr cv vs cv cin
      wss vt vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex vs vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wral vr vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab wral w3a wb cF crn cL wcel cL cfil wcel cY cA wcel
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas wcel vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab c0 wne c0 vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab wnel vt cv vr cv vs cv cin wss vt vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab wrex vs vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wral vr vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral
      w3a wb cY cX cF wf cL cfil wcel vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cvv wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas
      wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab c0 wne c0 vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wnel vt cv vr cv vs cv cin wss vt
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex vs vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab wral vr vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wral w3a wb vx vy cL cF ccnv vx cv cima cfil abrexexg vr
      vs vt cvv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab isfbas2 syl
      3ad2ant2 adantr mpbird $.
      $( [14-Nov-2009] $) $( [14-Nov-2009] $)

    $( A condition for a filter to be an image filter for a given function.
       (Contributed by Jeff Hankins, 14-NoV-2009.) $)
    rnelfm $p |- ( ( Y e. A /\ L e. Fil /\ F : Y --> X ) -> ( E. b e. fBas ( Y
    = U. b /\ L = ( ( X FilMap b ) ` F ) ) <-> ran F e. L ) ) $=
      cY cA wcel cL cfil wcel cY cX cF wf w3a cY vb cv cuni wceq cL cF cX vb cv
      cfilmap co cfv wceq wa vb cfbas wrex cF crn cL wcel cY cA wcel cL cfil
      wcel cY cX cF wf w3a cY vb cv cuni wceq cL cF cX vb cv cfilmap co cfv
      wceq wa cF crn cL wcel vb cfbas cL cfil wcel cY cX cF wf vb cv cfbas wcel
      cY vb cv cuni wceq cL cF cX vb cv cfilmap co cfv wceq wa cF crn cL wcel
      wi wi cY cA wcel cX cL wcel cY cX cF wf vb cv cfbas wcel cY vb cv cuni
      wceq cL cF cX vb cv cfilmap co cfv wceq wa cF crn cL wcel wi wi cL cfil
      wcel cX cL wcel cY cX cF wf wa vb cv cfbas wcel cY vb cv cuni wceq cL cF
      cX vb cv cfilmap co cfv wceq cF crn cL wcel cX cL wcel cY cX cF wf wa vb
      cv cfbas wcel cY vb cv cuni wceq cL cF cX vb cv cfilmap co cfv wceq cF
      crn cL wcel wi cL cF cX vb cv cfilmap co cfv wceq cF crn cL wcel cF crn
      cF cX vb cv cfilmap co cfv wcel cX cL wcel cY cX cF wf wa vb cv cfbas
      wcel cY vb cv cuni wceq wa wa cL cF cX vb cv cfilmap co cfv cF crn eleq2
      cX cL wcel cY cX cF wf wa vb cv cfbas wcel cY vb cv cuni wceq wa wa cF cY
      cima cF crn cF cX vb cv cfilmap co cfv cY cX cF wf cF cY cima cF crn wceq
      cX cL wcel vb cv cfbas wcel cY vb cv cuni wceq wa cY cX cF wf cY cF crn
      cF wfo cF cY cima cF crn wceq cY cX cF wf cF cY wfn cY cF crn cF wfo cY
      cX cF ffn cY cF dffn4 sylib cY cF crn cF foima syl ad2antlr cX cL wcel vb
      cv cfbas wcel vb cv cuni cX cF wf w3a cY vb cv cfg cfv wcel cF cY cima cF
      cX vb cv cfilmap co cfv wcel cX cL wcel cY cX cF wf wa vb cv cfbas wcel
      cY vb cv cuni wceq wa wa cL vb cv cY cF vb cv cfg cfv cX vb cv cuni vb cv
      cuni eqid vb cv cfg cfv eqid imaelfm cX cL wcel cY cX cF wf wa vb cv
      cfbas wcel cY vb cv cuni wceq wa wa cX cL wcel vb cv cfbas wcel vb cv
      cuni cX cF wf cX cL wcel cY cX cF wf vb cv cfbas wcel cY vb cv cuni wceq
      wa simpll cX cL wcel cY cX cF wf wa vb cv cfbas wcel cY vb cv cuni wceq
      simprl cY cX cF wf cY vb cv cuni wceq vb cv cuni cX cF wf cX cL wcel vb
      cv cfbas wcel cY vb cv cuni wceq cY cX cF wf vb cv cuni cX cF wf cY vb cv
      cuni cX cF feq2 biimpac ad2ant2l 3jca cX cL wcel cY cX cF wf wa vb cv
      cfbas wcel cY vb cv cuni wceq wa wa cY vb cv cfg cfv cuni vb cv cfg cfv
      vb cv cfbas wcel cY vb cv cuni wceq wa cY vb cv cfg cfv cuni wceq cX cL
      wcel cY cX cF wf wa vb cv cfbas wcel cY vb cv cuni wceq wa cY vb cv cuni
      vb cv cfg cfv cuni vb cv cfbas wcel cY vb cv cuni wceq pm3.27 vb cv cfbas
      wcel vb cv cuni vb cv cfg cfv cuni wceq cY vb cv cuni wceq vb cv vb cv
      cuni vb cv cuni eqid fgbas adantr eqtrd adantl vb cv cfbas wcel vb cv cfg
      cfv cuni vb cv cfg cfv wcel cX cL wcel cY cX cF wf wa cY vb cv cuni wceq
      vb cv cfbas wcel vb cv cfg cfv cfil wcel vb cv cfg cfv cuni vb cv cfg cfv
      wcel vb cv fgfil vb cv cfg cfv vb cv cfg cfv cuni vb cv cfg cfv cuni eqid
      filusb syl ad2antrl eqeltrd sylanc eqeltrrd syl5cbir exp32 imp4a cL cX
      rnelfm.1 filusb sylan 3adant1 r19.23adv cY cA wcel cL cfil wcel cY cX cF
      wf w3a cF crn cL wcel cY vb cv cuni wceq cL cF cX vb cv cfilmap co cfv
      wceq wa vb cfbas wrex vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cfbas wcel cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq
      cL cF cX vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfilmap co cfv
      wceq wa cY vb cv cuni wceq cL cF cX vb cv cfilmap co cfv wceq wa vb cfbas
      wrex cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vb cv
      cuni wceq cL cF cX vb cv cfilmap co cfv wceq wa cY vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cuni wceq cL cF cX vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cfilmap co cfv wceq wa vb vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cfbas vb cv vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wceq cY vb cv cuni wceq cY vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cuni wceq cL cF cX vb cv cfilmap co cfv wceq cL cF cX vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfilmap co cfv wceq vb cv vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab wceq vb cv cuni vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cuni cY vb cv vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab unieq eqeq2d vb cv vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab wceq cF cX vb cv cfilmap co cfv cF cX vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cfilmap co cfv cL vb cv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wceq cF cX vb cv cfilmap co cX vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfilmap co vb cv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cX cfilmap opreq2 fveq1d eqeq2d
      anbi12d rcla4ev vx vy cA cF cL cX cY rnelfm.1 rnelfmlem cY cA wcel cL
      cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cuni wceq cL cF cX vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cfilmap co cfv wceq cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cuni cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cuni wss cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wcel cY cF ccnv vx cv cima wceq vx cL wrex cX cL wcel cY cF ccnv cX cima
      wceq cY cF ccnv vx cv cima wceq vx cL wrex cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa cY cF ccnv vx cv cima wceq cY cF ccnv cX cima
      wceq vx cX cL vx cv cX wceq cF ccnv vx cv cima cF ccnv cX cima cY vx cv
      cX cF ccnv imaeq2 eqeq2d rcla4ev cY cA wcel cL cfil wcel cY cX cF wf w3a
      cX cL wcel cF crn cL wcel cL cfil wcel cY cA wcel cX cL wcel cY cX cF wf
      cL cX rnelfm.1 filusb 3ad2ant2 adantr cY cA wcel cL cfil wcel cY cX cF wf
      w3a cY cF ccnv cX cima wceq cF crn cL wcel cY cX cF wf cY cA wcel cY cF
      ccnv cX cima wceq cL cfil wcel cY cX cF wf cF ccnv cX cima cY cY cX cF
      fimacnv eqcomd 3ad2ant3 adantr sylanc cY cA wcel cL cfil wcel cY cX cF wf
      w3a cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx
      cv cima wceq vx cL wrex wb cF crn cL wcel cY cA wcel cL cfil wcel cY vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx cv cima
      wceq vx cL wrex wb cY cX cF wf vy cv cF ccnv vx cv cima wceq vx cL wrex
      cY cF ccnv vx cv cima wceq vx cL wrex vy cY cA vy cv cY wceq vy cv cF
      ccnv vx cv cima wceq cY cF ccnv vx cv cima wceq vx cL vy cv cY cF ccnv vx
      cv cima eqeq1 rexbidv elabg 3ad2ant1 adantr mpbird cY vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab elssuni syl cY cA wcel cL cfil wcel cY cX cF
      wf w3a cF crn cL wcel wa vz cv cY wss vz vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wral vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni
      cY wss cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vz cv cY
      wss vz vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cY cA wcel cL cfil
      wcel cY cX cF wf w3a cF crn cL wcel wa vz cv cF ccnv vx cv cima wceq vx
      cL wrex vz cv cY wss vz cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vz cv
      cF ccnv vx cv cima wceq vz cv cY wss vx cL cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa vz cv cF ccnv vx cv cima wceq vz cv cY wss wi
      vx cv cL wcel vz cv cF ccnv vx cv cima wceq vz cv cY wss cF ccnv vx cv
      cima cY wss cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vz
      cv cF ccnv vx cv cima cY sseq1 cY cA wcel cL cfil wcel cY cX cF wf w3a cF
      ccnv vx cv cima cY wss cF crn cL wcel cY cX cF wf cY cA wcel cF ccnv vx
      cv cima cY wss cL cfil wcel cY cX cF wf cF ccnv vx cv cima cF cdm cY cF
      ccnv vx cv cima cF cdm wss cY cX cF wf cF vx cv cnvimass a1i cY cX cF fdm
      sseqtrd 3ad2ant3 adantr syl5cbir a1d r19.23adv vy cv cF ccnv vx cv cima
      wceq vx cL wrex vz cv cF ccnv vx cv cima wceq vx cL wrex vy vz cv vz
      visset vy cv vz cv wceq vy cv cF ccnv vx cv cima wceq vz cv cF ccnv vx cv
      cima wceq vx cL vy cv vz cv cF ccnv vx cv cima eqeq1 rexbidv elab syl5ib
      r19.21aiv vz vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cY unissb
      sylibr eqssd cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq cL cF cX vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cfilmap co cfv wceq cY cA wcel
      cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cuni wceq wa vt cL cF cX vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cfilmap co cfv cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cuni wceq wa vt cv cL wcel vt cv cX wss cF vs cv cima vt cv wss vs
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex wa vt cv cF cX vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cfilmap co cfv wcel cY cA wcel
      cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cuni wceq wa vt cv cL wcel vt cv cX wss cF vs
      cv cima vt cv wss vs vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex
      wa cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq wa vt cv cL wcel vt cv
      cX wss cF vs cv cima vt cv wss vs vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wrex vt cv cL wcel vt cv cX wss wi cY cA wcel cL cfil wcel cY
      cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cuni wceq wa vt cv cL wcel vt cv cL cuni cX vt cv cL elssuni
      rnelfm.1 syl6ssr a1i cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq vt
      cv cL wcel cF vs cv cima vt cv wss vs vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wrex cF ccnv vt cv cima vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wcel cF cF ccnv vt cv cima cima vt cv wss cF vs cv cima vt cv
      wss vs vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex cY cA wcel cL
      cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cuni wceq vt cv cL wcel wa wa cF vs cv cima vt cv
      wss cF cF ccnv vt cv cima cima vt cv wss vs cF ccnv vt cv cima vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab vs cv cF ccnv vt cv cima wceq cF
      vs cv cima cF cF ccnv vt cv cima cima vt cv vs cv cF ccnv vt cv cima cF
      imaeq2 sseq1d rcla4ev cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq vt
      cv cL wcel wa wa cF ccnv vt cv cima vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wcel cF ccnv vt cv cima cF ccnv vx cv cima wceq vx cL wrex vt
      cv cL wcel cF ccnv vt cv cima cF ccnv vt cv cima wceq cF ccnv vt cv cima
      cF ccnv vx cv cima wceq vx cL wrex cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cuni wceq vt cv cL wcel wa wa cF ccnv vt cv cima cF ccnv vx cv cima wceq
      cF ccnv vt cv cima cF ccnv vt cv cima wceq vx vt cv cL vx cv vt cv wceq
      cF ccnv vx cv cima cF ccnv vt cv cima cF ccnv vt cv cima vx cv vt cv cF
      ccnv imaeq2 eqeq2d rcla4ev cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq
      vt cv cL wcel simprr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq vt
      cv cL wcel wa wa cF ccnv vt cv cima eqidd sylanc cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa cF ccnv vt cv cima vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab wcel cF ccnv vt cv cima cF ccnv vx cv cima
      wceq vx cL wrex wb cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cuni wceq vt cv cL wcel wa cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa cF ccnv vt cv cima cvv wcel cF ccnv vt cv cima vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab wcel cF ccnv vt cv cima cF ccnv vx cv
      cima wceq vx cL wrex wb cF ccnv vt cv cima cY wss cY cA wcel cF ccnv vt
      cv cima cvv wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa cF ccnv vt cv cima cY cA ssexg cY cA wcel cL cfil wcel cY cX cF wf w3a
      cF ccnv vt cv cima cY wss cF crn cL wcel cY cX cF wf cY cA wcel cF ccnv
      vt cv cima cY wss cL cfil wcel cY cX cF wf cF ccnv vt cv cima cF cdm cY
      cF ccnv vt cv cima cF cdm wss cY cX cF wf cF vt cv cnvimass a1i cY cX cF
      fdm sseqtrd 3ad2ant3 adantr cY cA wcel cL cfil wcel cY cX cF wf cF crn cL
      wcel 3simpl1 sylanc vy cv cF ccnv vx cv cima wceq vx cL wrex cF ccnv vt
      cv cima cF ccnv vx cv cima wceq vx cL wrex vy cF ccnv vt cv cima cvv vy
      cv cF ccnv vt cv cima wceq vy cv cF ccnv vx cv cima wceq cF ccnv vt cv
      cima cF ccnv vx cv cima wceq vx cL vy cv cF ccnv vt cv cima cF ccnv vx cv
      cima eqeq1 rexbidv elabg syl adantr mpbird cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cuni wceq vt cv cL wcel wa wa cF cF ccnv vt cv cima cima vt cv wss
      cF ccnv vt cv cima cF ccnv vt cv cima wss cF ccnv vt cv cima ssid cF wfun
      cF ccnv vt cv cima cF cdm wss cF cF ccnv vt cv cima cima vt cv wss cF
      ccnv vt cv cima cF ccnv vt cv cima wss wb cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cuni wceq vt cv cL wcel wa wa cF ccnv vt cv cima vt cv cF
      funimass3 cY cA wcel cL cfil wcel cY cX cF wf w3a cF wfun cF crn cL wcel
      cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq vt cv cL
      wcel wa cY cX cF wf cY cA wcel cF wfun cL cfil wcel cY cX cF ffun
      3ad2ant3 ad2antrr cF ccnv vt cv cima cF cdm wss cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cuni wceq vt cv cL wcel wa wa cF vt cv cnvimass a1i sylanc
      mpbiri sylanc expr jcad cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq wa
      vt cv cX wss cF vs cv cima vt cv wss vs vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wrex vt cv cL wcel cY cA wcel cL cfil wcel cY cX cF wf w3a
      cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni
      wceq wa cF vs cv cima vt cv wss vs vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wrex vt cv cX wss vt cv cL wcel cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cuni wceq wa cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi
      vs vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cY cA wcel cL cfil
      wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cuni wceq wa vs cv vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wcel cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel cL
      cfil wcel cF vs cv cima cL wcel vt cv cX wss cF vs cv cima vt cv wss w3a
      vt cv cL wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa
      cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq wa vs cv vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cF vs cv cima vt cv wss
      wa vt cv cX wss wa wa cF vs cv cima vt cv cL cX rnelfm.1 fillsb cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cL cfil wcel cY vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq vs cv vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab wcel cF vs cv cima vt cv wss wa vt cv
      cX wss wa cY cA wcel cL cfil wcel cY cX cF wf cF crn cL wcel 3simpl2
      ad2antrr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq wa vs cv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wcel cF vs cv cima vt cv wss wa vt
      cv cX wss wa wa cF vs cv cima cL wcel vt cv cX wss cF vs cv cima vt cv
      wss cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq wa vs cv vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab wcel cF vs cv cima vt cv wss vt cv cX
      wss cF vs cv cima cL wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq
      wa vs cv cF ccnv vx cv cima wceq vx cL wrex cF vs cv cima vt cv wss vt cv
      cX wss cF vs cv cima cL wcel wi wi vs cv vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL
      wcel wa vs cv cF ccnv vx cv cima wceq vx cL wrex cF vs cv cima vt cv wss
      vt cv cX wss cF vs cv cima cL wcel wi wi wi cY vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cuni wceq cY cA wcel cL cfil wcel cY cX cF wf w3a
      cF crn cL wcel wa vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss
      vt cv cX wss cF vs cv cima cL wcel wi wi vx cL vs cv cF ccnv vx cv cima
      wceq cF vs cv cima vt cv wss vt cv cX wss cF vs cv cima cL wcel wi wi cF
      cF ccnv vx cv cima cima vt cv wss vt cv cX wss cF cF ccnv vx cv cima cima
      cL wcel wi wi cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa
      vx cv cL wcel wa vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss cF
      cF ccnv vx cv cima cima vt cv wss vt cv cX wss cF vs cv cima cL wcel wi
      vt cv cX wss cF cF ccnv vx cv cima cima cL wcel wi vs cv cF ccnv vx cv
      cima wceq cF vs cv cima cF cF ccnv vx cv cima cima vt cv vs cv cF ccnv vx
      cv cima cF imaeq2 sseq1d vs cv cF ccnv vx cv cima wceq cF vs cv cima cL
      wcel cF cF ccnv vx cv cima cima cL wcel vt cv cX wss vs cv cF ccnv vx cv
      cima wceq cF vs cv cima cF cF ccnv vx cv cima cima cL vs cv cF ccnv vx cv
      cima cF imaeq2 eleq1d imbi2d imbi12d cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv
      wss vt cv cX wss cF cF ccnv vx cv cima cima cL wcel cY cA wcel cL cfil
      wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv
      cima cima vt cv wss vt cv cX wss wa wa cF cF ccnv vx cv cima cima vx cv
      cF crn cin cL cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa
      vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa
      cF cF ccnv vx cv cima cima vx cv cF crn cin cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima
      vt cv wss vt cv cX wss wa wa cF cF ccnv vx cv cima cima vx cv wss cF cF
      ccnv vx cv cima cima cF crn wss wa cF cF ccnv vx cv cima cima vx cv cF
      crn cin wss cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx
      cv cL wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa cF
      cF ccnv vx cv cima cima vx cv wss cF cF ccnv vx cv cima cima cF crn wss
      cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel
      wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa cF cF ccnv vx
      cv cima cima vx cv wss cF ccnv vx cv cima cF ccnv vx cv cima wss cF ccnv
      vx cv cima ssid cF wfun cF ccnv vx cv cima cF cdm wss cF cF ccnv vx cv
      cima cima vx cv wss cF ccnv vx cv cima cF ccnv vx cv cima wss wb cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF
      cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa cF ccnv vx cv cima
      vx cv cF funimass3 cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa cF wfun vx cv cL wcel cF cF ccnv vx cv cima cima vt cv wss vt cv cX
      wss wa cY cA wcel cL cfil wcel cY cX cF wf w3a cF wfun cF crn cL wcel cY
      cX cF wf cY cA wcel cF wfun cL cfil wcel cY cX cF ffun 3ad2ant3 adantr
      ad2antrr cF ccnv vx cv cima cF cdm wss cY cA wcel cL cfil wcel cY cX cF
      wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt
      cv wss vt cv cX wss wa wa cF vx cv cnvimass a1i sylanc mpbiri cF cF ccnv
      vx cv cima imassrn jctir cF cF ccnv vx cv cima cima vx cv cF crn ssin
      sylib cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL
      wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa vz vx cv
      cF crn cin cF cF ccnv vx cv cima cima cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv
      wss vt cv cX wss wa wa vz cv vx cv wcel vz cv cF crn wcel wa vz cv cF cF
      ccnv vx cv cima cima wcel vz cv vx cv cF crn cin wcel cY cA wcel cL cfil
      wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv
      cima cima vt cv wss vt cv cX wss wa wa vz cv vx cv wcel vz cv cF crn wcel
      vz cv cF cF ccnv vx cv cima cima wcel cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv
      wss vt cv cX wss wa wa vz cv cF crn wcel vz cv vx cv wcel vz cv cF cF
      ccnv vx cv cima cima wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX
      wss wa wa vz cv cF crn wcel vy cv cF cfv vz cv wceq vy cY wrex vz cv vx
      cv wcel vz cv cF cF ccnv vx cv cima cima wcel wi cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa vz cv cF crn wcel vy cv cF cfv vz cv
      wceq vy cY wrex wb vx cv cL wcel cF cF ccnv vx cv cima cima vt cv wss vt
      cv cX wss wa cY cA wcel cL cfil wcel cY cX cF wf w3a vz cv cF crn wcel vy
      cv cF cfv vz cv wceq vy cY wrex wb cF crn cL wcel cY cX cF wf cY cA wcel
      vz cv cF crn wcel vy cv cF cfv vz cv wceq vy cY wrex wb cL cfil wcel cY
      cX cF wf cF cY wfn vz cv cF crn wcel vy cv cF cfv vz cv wceq vy cY wrex
      wb cY cX cF ffn vy cY vz cv cF fvelrnb syl 3ad2ant3 adantr ad2antrr cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF
      cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa vy cv cF cfv vz cv
      wceq vz cv vx cv wcel vz cv cF cF ccnv vx cv cima cima wcel wi vy cY vy
      cv cF cfv vz cv wceq vy cv cF cfv vx cv wcel vy cv cF cfv cF cF ccnv vx
      cv cima cima wcel wi vz cv vx cv wcel vz cv cF cF ccnv vx cv cima cima
      wcel wi cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv
      cL wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa vy cv
      cY wcel wa vy cv cF cfv vz cv wceq vy cv cF cfv vx cv wcel vz cv vx cv
      wcel vy cv cF cfv cF cF ccnv vx cv cima cima wcel vz cv cF cF ccnv vx cv
      cima cima wcel vy cv cF cfv vz cv vx cv eleq1 vy cv cF cfv vz cv cF cF
      ccnv vx cv cima cima eleq1 imbi12d cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv
      wss vt cv cX wss wa wa vy cv cY wcel wa vy cv cF cfv vx cv wcel vy cv cF
      cfv cF cF ccnv vx cv cima cima wcel cF wfun cF ccnv vx cv cima cF cdm wss
      wa vy cv cF ccnv vx cv cima wcel vy cv cF cfv cF cF ccnv vx cv cima cima
      wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL
      wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa vy cv cY
      wcel wa vy cv cF cfv vx cv wcel wa cF ccnv vx cv cima vy cv cF funfvima2
      cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel
      wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa vy cv cY wcel
      wa vy cv cF cfv vx cv wcel wa cF wfun cF ccnv vx cv cima cF cdm wss cY cA
      wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF
      cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa wa cF wfun vy cv cY
      wcel vy cv cF cfv vx cv wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF
      crn cL wcel wa cF wfun vx cv cL wcel cF cF ccnv vx cv cima cima vt cv wss
      vt cv cX wss wa cY cA wcel cL cfil wcel cY cX cF wf w3a cF wfun cF crn cL
      wcel cY cX cF wf cY cA wcel cF wfun cL cfil wcel cY cX cF ffun 3ad2ant3
      adantr ad2antrr ad2antrr cF vx cv cnvimass jctir cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima
      cima vt cv wss vt cv cX wss wa wa vy cv cY wcel wa vy cv cF cfv vx cv
      wcel vy cv cF ccnv vx cv cima wcel cF wfun vy cv cF cdm wcel vy cv cF cfv
      vx cv wcel vy cv cF ccnv vx cv cima wcel wb cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima
      vt cv wss vt cv cX wss wa wa vy cv cY wcel wa vy cv vx cv cF fvimacnv cY
      cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa vx cv cL wcel wa
      cF wfun cF cF ccnv vx cv cima cima vt cv wss vt cv cX wss wa vy cv cY
      wcel cY cA wcel cL cfil wcel cY cX cF wf w3a cF wfun cF crn cL wcel vx cv
      cL wcel cY cX cF wf cY cA wcel cF wfun cL cfil wcel cY cX cF ffun
      3ad2ant3 ad2antrr ad2antrr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima vt cv wss vt cv cX
      wss wa wa vy cv cF cdm wcel vy cv cY wcel cY cA wcel cL cfil wcel cY cX
      cF wf w3a cF crn cL wcel wa vx cv cL wcel wa cF cF ccnv vx cv cima cima
      vt cv wss vt cv cX wss wa wa cF cdm cY vy cv cY cA wcel cL cfil wcel cY
      cX cF wf w3a cF crn cL wcel wa cF cdm cY wceq vx cv cL wcel cF cF ccnv vx
      cv cima cima vt cv wss vt cv cX wss wa cY cA wcel cL cfil wcel cY cX cF
      wf w3a cF cdm cY wceq cF crn cL wcel cY cX cF wf cY cA wcel cF cdm cY
      wceq cL cfil wcel cY cX cF fdm 3ad2ant3 adantr ad2antrr eleq2d biimpar
      sylanc biimpa sylc ex syl5cbi r19.23adva sylbid com23 imp3a vz cv vx cv
      cF crn elin syl5ib ssrdv eqssd cY cA wcel cL cfil wcel cY cX cF wf w3a cF
      crn cL wcel wa vx cv cL wcel wa vx cv cF crn cin cL wcel cF cF ccnv vx cv
      cima cima vt cv wss vt cv cX wss wa cY cA wcel cL cfil wcel cY cX cF wf
      w3a cF crn cL wcel vx cv cL wcel vx cv cF crn cin cL wcel cL cfil wcel cY
      cA wcel cF crn cL wcel vx cv cL wcel vx cv cF crn cin cL wcel wi wi cY cX
      cF wf cL cfil wcel vx cv cL wcel cF crn cL wcel vx cv cF crn cin cL wcel
      cL cfil wcel vx cv cL wcel cF crn cL wcel vx cv cF crn cin cL wcel vx cv
      cF crn cL filint 3exp com23 3ad2ant2 imp31 adantr eqeltrd exp32 syl5cbir
      r19.23adva adantr vy cv cF ccnv vx cv cima wceq vx cL wrex vs cv cF ccnv
      vx cv cima wceq vx cL wrex vy vs cv vs visset vy cv vs cv wceq vy cv cF
      ccnv vx cv cima wceq vs cv cF ccnv vx cv cima wceq vx cL vy cv vs cv cF
      ccnv vx cv cima eqeq1 rexbidv elab syl5ib imp44 cY cA wcel cL cfil wcel
      cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cuni wceq wa vs cv vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab wcel cF vs cv cima vt cv wss wa vt cv cX wss simprr cY cA wcel cL
      cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cuni wceq wa vs cv vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab wcel cF vs cv cima vt cv wss vt cv cX wss simprlr 3jca
      sylc exp44 r19.23adv com23 imp3a impbid cX cL wcel vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cfbas wcel vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cuni cX cF wf vt cv cF cX vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cfilmap co cfv wcel vt cv cX wss cF vs cv cima vt cv wss
      vs vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wrex wa wb cY cA wcel
      cL cfil wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cuni wceq wa vs vt cv vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cL cF cX vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cuni vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni
      eqid elfilmap cY cA wcel cL cfil wcel cY cX cF wf w3a cX cL wcel cF crn
      cL wcel cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq cL
      cfil wcel cY cA wcel cX cL wcel cY cX cF wf cL cX rnelfm.1 filusb
      3ad2ant2 ad2antrr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn cL wcel
      wa vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas wcel cY vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq vx vy cA cF cL cX cY
      rnelfm.1 rnelfmlem adantr cY cA wcel cL cfil wcel cY cX cF wf w3a cF crn
      cL wcel wa cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni cX cF wf cY vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cuni wceq cY cX cF wf vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cuni cX cF wf cY cA wcel cL cfil
      wcel cY cX cF wf w3a cF crn cL wcel wa cY vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cuni cX cF feq2 cY cA wcel cL cfil wcel cY cX cF wf cF
      crn cL wcel 3simpl3 syl5cbi imp syl3anc bitr4d eqrdv ex jcai sylanc ex
      impbid $.
      $( [14-Nov-2009] $) $( [14-Nov-2009] $)
  $}

  ${
    $d b r s t u v w x y z B $. $d b r s t u v w x y z F $. $d b r s t u v w x
    y z L $. $d b r s t u v w x y z X $. $d b r s t u v w x y z Y $. $d b r s t
    u v w x y z Z $.
    fmfnfm.1 $e |- Y = U. B $.
    fmfnfm.2 $e |- Z = U. L $.
    $( Lemma for ~ fmfnfm . $)
    fmfnfmlem1 $p |- ( ( ( ( B e. fBas /\ L e. Fil /\ F : Y --> X ) /\ ( ( X
    FilMap B ) ` F ) C_ L /\ X = Z ) /\ Y = U. ( fi ` ( B u. { y | E. x e. L y
    = ( `' F " x ) } ) ) ) -> ( s e. ( fi ` B ) -> ( ( F " s ) C_ t -> ( t C_ X
    -> t e. L ) ) ) ) $=
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq wa vs cv cB cfi cfv wcel vz cv cB wss vz cv cfn wcel vs
      cv vz cv cint wceq w3a vz wex cF vs cv cima vt cv wss vt cv cX wss vt cv
      cL wcel wi wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vs cv cB cfi cfv wcel vz cv cB wss vz cv cfn
      wcel vs cv vz cv cint wceq w3a vz wex wb cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss vs cv cB cfi cfv wcel vz
      cv cB wss vz cv cfn wcel vs cv vz cv cint wceq w3a vz wex wb cX cZ wceq
      cB cfbas wcel cL cfil wcel vs cv cB cfi cfv wcel vz cv cB wss vz cv cfn
      wcel vs cv vz cv cint wceq w3a vz wex wb cY cX cF wf vs cv cvv wcel cB
      cfbas wcel vs cv cB cfi cfv wcel vz cv cB wss vz cv cfn wcel vs cv vz cv
      cint wceq w3a vz wex wb vs visset vz vs cv cvv cB cfbas sppfi mpan
      3ad2ant1 3ad2ant1 adantr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vz cv cB wss vz cv cfn
      wcel vs cv vz cv cint wceq w3a cF vs cv cima vt cv wss vt cv cX wss vt cv
      cL wcel wi wi vz cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq wa vz cv cB wss vz cv cfn wcel vs
      cv vz cv cint wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi
      wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cuni wceq wa vz cv cB wss vz cv cfn wcel vs cv vz cv cint
      wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi wi vs cv vz
      cv cint wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi cF
      vz cv cint cima vt cv wss vt cv cX wss vt cv cL wcel wi wi cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq wa vz cv cB wss vz cv cfn wcel wa wa vs cv vz cv cint wceq cF
      vs cv cima vt cv wss cF vz cv cint cima vt cv wss vt cv cX wss vt cv cL
      wcel wi vs cv vz cv cint wceq cF vs cv cima cF vz cv cint cima vt cv vs
      cv vz cv cint cF imaeq2 sseq1d imbi1d cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vz cv cB wss
      vz cv cfn wcel wa vw cv vz cv cint wss vw cB wrex cF vz cv cint cima vt
      cv wss vt cv cX wss vt cv cL wcel wi wi cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cB wss vz
      cv cfn wcel wa vw cv vz cv cint wss vw cB wrex cY cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss vz cv cB wss vz cv
      cfn wcel wa vw cv vz cv cint wss vw cB wrex cX cZ wceq cB cfbas wcel cL
      cfil wcel vz cv cB wss vz cv cfn wcel wa vw cv vz cv cint wss vw cB wrex
      cY cX cF wf cB cfbas wcel vz cv cB wss vz cv cfn wcel vw cv vz cv cint
      wss vw cB wrex vw vz cv cB fbssint 3expb 3ad2antl1 3ad2antl1 adantlr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vw cv vz cv cint wss vw cB wrex cF vz cv cint cima vt cv
      wss vt cv cX wss vt cv cL wcel wi wi cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vw cv vz cv
      cint wss cF vz cv cint cima vt cv wss vt cv cX wss vt cv cL wcel wi wi vw
      cB cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cuni wceq wa vw cv cB wcel vw cv vz cv cint wss cF vz cv cint
      cima vt cv wss vt cv cX wss vt cv cL wcel wi cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vw cv
      cB wcel wa cF vw cv cima vt cv wss vt cv cX wss vt cv cL wcel wi vw cv vz
      cv cint wss cF vz cv cint cima vt cv wss wa cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vw cv cB
      wcel wa cF vw cv cima vt cv wss vt cv cX wss vt cv cL wcel cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq wa vw cv cB wcel wa cF vw cv cima vt cv wss vt cv cX wss wa wa
      cF cX cB cfilmap co cfv cL vt cv cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa cF cX cB cfilmap
      co cfv cL wss vw cv cB wcel cF vw cv cima vt cv wss vt cv cX wss wa cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq 3simpl2 ad2antrr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vw cv cB wcel wa cF vw cv
      cima vt cv wss vt cv cX wss wa wa vt cv cF cX cB cfilmap co cfv wcel vt
      cv cX wss cF vs cv cima vt cv wss vs cB wrex wa cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa
      vw cv cB wcel wa cF vw cv cima vt cv wss vt cv cX wss wa wa vt cv cX wss
      cF vs cv cima vt cv wss vs cB wrex cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vw cv cB wcel wa
      cF vw cv cima vt cv wss vt cv cX wss simprr vw cv cB wcel cF vw cv cima
      vt cv wss cF vs cv cima vt cv wss vs cB wrex cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vt cv
      cX wss cF vs cv cima vt cv wss cF vw cv cima vt cv wss vs vw cv cB vs cv
      vw cv wceq cF vs cv cima cF vw cv cima vt cv vs cv vw cv cF imaeq2 sseq1d
      rcla4ev ad2ant2lr jca cX cL wcel cB cfbas wcel cY cX cF wf vt cv cF cX cB
      cfilmap co cfv wcel vt cv cX wss cF vs cv cima vt cv wss vs cB wrex wa wb
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq wa vw cv cB wcel wa cF vw cv cima vt cv wss vt cv cX
      wss wa wa vs vt cv cB cL cF cX cY fmfnfm.1 elfilmap cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa
      cX cL wcel vw cv cB wcel cF vw cv cima vt cv wss vt cv cX wss wa cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cX cL wcel cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cuni wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cX cZ
      wceq cX cL wcel cF cX cB cfilmap co cfv cL wss cL cfil wcel cB cfbas wcel
      cX cZ wceq cX cL wcel cY cX cF wf cL cfil wcel cX cZ wceq wa cX cZ cL cL
      cfil wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL wcel cX cZ wceq cL cZ
      fmfnfm.2 filusb adantr eqeltrd 3ad2antl2 3adant2 adantr ad2antrr cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa cB cfbas wcel vw cv cB wcel cF vw cv cima vt cv wss vt
      cv cX wss wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a cB cfbas wcel cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB cfbas wcel cX cZ wceq
      cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1 3ad2ant1 adantr ad2antrr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa cY cX cF wf vw cv cB wcel cF vw cv cima vt cv wss vt cv
      cX wss wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cY cX cF wf cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cY cX cF wf cX cZ wceq cB cfbas
      wcel cL cfil wcel cY cX cF wf 3simp3 3ad2ant1 adantr ad2antrr syl3anc
      mpbird sseldd exp32 cF vw cv cima cF vz cv cint cima wss cF vz cv cint
      cima vt cv wss cF vw cv cima vt cv wss vw cv vz cv cint wss cF vw cv cima
      cF vz cv cint cima vt cv sstr vw cv vz cv cint cF imass2 sylan syl5 exp4b
      r19.23adv imp syldan syl5cbir exp32 3impd 19.23adv sylbid $.
      $( [18-Nov-2009] $) $( [18-Nov-2009] $)

    $( Lemma for ~ fmfnfm . $)
    fmfnfmlem2 $p |- ( ( ( ( B e. fBas /\ L e. Fil /\ F : Y --> X ) /\ ( ( X
    FilMap B ) ` F ) C_ L /\ X = Z ) /\ Y = U. ( fi ` ( B u. { y | E. x e. L y
    = ( `' F " x ) } ) ) ) -> ( E. x e. L s = ( `' F " x ) -> ( ( F " s ) C_ t
    -> ( t C_ X -> t e. L ) ) ) ) $=
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a vs cv cF ccnv vx cv cima wceq vx cL wrex cF vs cv cima vt
      cv wss vt cv cX wss vt cv cL wcel wi wi wi cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vs cv cF
      ccnv vx cv cima wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel
      wi wi vx cL cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq
      cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel cL cfil wcel vx cv cF
      crn cin cL wcel vt cv cZ wss vx cv cF crn cin vt cv wss w3a vt cv cL wcel
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima
      vt cv wss wa wa vt cv cX wss wa wa vx cv cF crn cin vt cv cL cZ fmfnfm.2
      fillsb cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a cL cfil wcel vx cv cL wcel vs cv cF ccnv vx cv cima
      wceq cF vs cv cima vt cv wss wa wa vt cv cX wss wa cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cL cfil wcel cX cZ
      wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp2 3ad2ant1 adantr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt
      cv wss wa wa vt cv cX wss wa wa vx cv cF crn cin cL wcel vt cv cZ wss vx
      cv cF crn cin vt cv wss cL cfil wcel vx cv cL wcel cF crn cL wcel vx cv
      cF crn cin cL wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv
      cima wceq cF vs cv cima vt cv wss wa wa vt cv cX wss wa wa vx cv cF crn
      cL filint cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cL cfil wcel vx cv cL wcel vs cv cF ccnv vx cv
      cima wceq cF vs cv cima vt cv wss wa wa vt cv cX wss wa cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cL cfil wcel cX
      cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp2 3ad2ant1 adantr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt
      cv wss wa vt cv cX wss simprll cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF crn cL wcel vx cv cL
      wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa vt cv cX
      wss wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a cF cX cB cfilmap co cfv cL cF crn cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      3simp2 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a cF cY cima cF crn cF cX cB cfilmap co cfv cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cF cY
      cima cF crn wceq cX cZ wceq cY cX cF wf cB cfbas wcel cF cY cima cF crn
      wceq cL cfil wcel cY cX cF wf cY cF crn cF wfo cF cY cima cF crn wceq cY
      cX cF wf cF cY wfn cY cF crn cF wfo cY cX cF ffn cY cF dffn4 sylib cY cF
      crn cF foima syl 3ad2ant3 3ad2ant1 cX cL wcel cB cfbas wcel cY cX cF wf
      w3a cY cB cfg cfv wcel cF cY cima cF cX cB cfilmap co cfv wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cL cB cY cF cB cfg cfv cX cY fmfnfm.1 cB cfg cfv eqid imaelfm cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cX cL wcel cB cfbas wcel cY cX cF wf cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cX cZ wceq cX cL wcel cF cX cB cfilmap co cfv cL wss
      cL cfil wcel cB cfbas wcel cX cZ wceq cX cL wcel cY cX cF wf cL cfil wcel
      cX cZ wceq wa cX cZ cL cL cfil wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL
      wcel cX cZ wceq cL cZ fmfnfm.2 filusb adantr eqeltrd 3ad2antl2 3adant2 cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB
      cfbas wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1
      3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cY cX cF wf cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf
      3simp3 3ad2ant1 3jca cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cY cB cfg cfv wcel cX cZ wceq cB cfbas wcel cL cfil
      wcel cY cB cfg cfv wcel cY cX cF wf cB cfbas wcel cY cB cfg cfv cuni cB
      cfg cfv cB cY fmfnfm.1 fgbas cB cfbas wcel cB cfg cfv cfil wcel cB cfg
      cfv cuni cB cfg cfv wcel cB fgfil cB cfg cfv cB cfg cfv cuni cB cfg cfv
      cuni eqid filusb syl eqeltrd 3ad2ant1 3ad2ant1 sylanc eqeltrrd sseldd
      adantr syl3anc cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv
      cima wceq cF vs cv cima vt cv wss wa wa vt cv cX wss wa wa vt cv cX cZ cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt
      cv wss wa wa vt cv cX wss simprr cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq vx cv cL wcel vs cv cF ccnv
      vx cv cima wceq cF vs cv cima vt cv wss wa wa vt cv cX wss wa 3simpl3
      sseqtrd cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF
      vs cv cima vt cv wss wa wa vt cv cX wss wa wa vy vx cv cF crn cin vt cv
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima
      vt cv wss wa wa vt cv cX wss wa wa vy cv vx cv wcel vy cv cF crn wcel wa
      vy cv vt cv wcel vy cv vx cv cF crn cin wcel cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa vy cv vx
      cv wcel vy cv cF crn wcel wa vy cv vt cv wcel wi vt cv cX wss cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa wa vy cv vx cv wcel vy cv cF crn wcel vy cv vt cv wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa wa vy cv cF crn wcel vy cv vx cv wcel vy cv vt cv wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa wa vy cv cF crn wcel vz cv cF cfv vy cv wceq vz cY wrex vy cv
      vx cv wcel vy cv vt cv wcel wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vy cv cF crn wcel vz cv cF
      cfv vy cv wceq vz cY wrex wb vx cv cL wcel vs cv cF ccnv vx cv cima wceq
      cF vs cv cima vt cv wss wa wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss vy cv cF crn wcel vz cv cF cfv vy cv wceq
      vz cY wrex wb cX cZ wceq cY cX cF wf cB cfbas wcel vy cv cF crn wcel vz
      cv cF cfv vy cv wceq vz cY wrex wb cL cfil wcel cY cX cF wf cF cY wfn vy
      cv cF crn wcel vz cv cF cfv vy cv wceq vz cY wrex wb cY cX cF ffn vz cY
      vy cv cF fvelrnb syl 3ad2ant3 3ad2ant1 adantr cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv
      cF cfv vy cv wceq vy cv vx cv wcel vy cv vt cv wcel wi vz cY cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa wa vz cv cY wcel vz cv cF cfv vy cv wceq vy cv vx cv wcel vy cv
      vt cv wcel wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq
      cF vs cv cima vt cv wss wa wa wa vz cv cY wcel vz cv cF cfv vy cv wceq wa
      wa vy cv vx cv wcel vz cv vs cv wcel vy cv vt cv wcel cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa
      wa vz cv cY wcel vz cv cF cfv vy cv wceq wa wa vz cv vs cv wcel vz cv cF
      ccnv vx cv cima wcel vz cv cF cfv vx cv wcel vy cv vx cv wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa wa vz cv cY wcel vz cv cF cfv vy cv wceq wa wa vs cv cF ccnv vx
      cv cima vz cv vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima
      vt cv wss wa wa vs cv cF ccnv vx cv cima wceq cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cY
      wcel vz cv cF cfv vy cv wceq wa vx cv cL wcel vs cv cF ccnv vx cv cima
      wceq cF vs cv cima vt cv wss simprl ad2antlr eleq2d cF wfun vz cv cF cdm
      wcel vz cv cF cfv vx cv wcel vz cv cF ccnv vx cv cima wcel wb cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa wa vz cv cY wcel vz cv cF cfv vy cv wceq wa wa vz cv vx cv cF
      fvimacnv cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cF wfun vx cv cL wcel vs cv cF ccnv vx cv cima
      wceq cF vs cv cima vt cv wss wa wa vz cv cY wcel vz cv cF cfv vy cv wceq
      wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cF wfun cX cZ wceq cY cX cF wf cB cfbas wcel cF wfun cL cfil wcel cY
      cX cF ffun 3ad2ant3 3ad2ant1 ad2antrr cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv
      cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY wcel vz
      cv cF cfv vy cv wceq wa wa vz cv cY cF cdm cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY
      wcel vz cv cF cfv vy cv wceq simprl cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF cdm cY wceq vx cv
      cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa vz cv
      cY wcel vz cv cF cfv vy cv wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cF cdm cY wceq cX cZ wceq cY cX cF wf
      cB cfbas wcel cF cdm cY wceq cL cfil wcel cY cX cF fdm 3ad2ant3 3ad2ant1
      ad2antrr eleqtrrd sylanc cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv
      cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY wcel vz cv cF cfv vy
      cv wceq wa wa vz cv cF cfv vy cv vx cv cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs
      cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY wcel
      vz cv cF cfv vy cv wceq simprr eleq1d 3bitr2rd cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv
      cY wcel vz cv cF cfv vy cv wceq wa wa vz cv vs cv wcel vz cv cF cfv cF vs
      cv cima wcel vy cv vt cv wcel cF wfun vs cv cF cdm wss vz cv vs cv wcel
      vz cv cF cfv cF vs cv cima wcel wi cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF
      ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY wcel vz cv
      cF cfv vy cv wceq wa wa vs cv vz cv cF funfvima2 cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF
      wfun vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss
      wa wa vz cv cY wcel vz cv cF cfv vy cv wceq wa cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cF wfun cX cZ wceq cY cX
      cF wf cB cfbas wcel cF wfun cL cfil wcel cY cX cF ffun 3ad2ant3 3ad2ant1
      ad2antrr vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv
      wss wa wa vs cv cF cdm wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cY wcel vz cv cF cfv vy
      cv wceq wa vs cv cF ccnv vx cv cima wceq vs cv cF cdm wss vx cv cL wcel
      cF vs cv cima vt cv wss vs cv cF ccnv vx cv cima wceq vs cv cF cdm wss cF
      ccnv vx cv cima cF cdm wss cF vx cv cnvimass vs cv cF ccnv vx cv cima cF
      cdm sseq1 mpbiri ad2antrl ad2antlr sylanc cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY
      wcel vz cv cF cfv vy cv wceq wa wa vz cv cF cfv cF vs cv cima wcel vz cv
      cF cfv vt cv wcel vy cv vt cv wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF
      ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa wa vz cv cY wcel vz cv
      cF cfv vy cv wceq wa wa cF vs cv cima vt cv vz cv cF cfv vx cv cL wcel vs
      cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss wa wa cF vs cv cima vt
      cv wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vz cv cY wcel vz cv cF cfv vy cv wceq wa vx cv cL
      wcel vs cv cF ccnv vx cv cima wceq cF vs cv cima vt cv wss simprr
      ad2antlr sseld vz cv cF cfv vy cv wceq vz cv cF cfv vt cv wcel vy cv vt
      cv wcel wb cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vs cv cF ccnv vx cv cima wceq cF
      vs cv cima vt cv wss wa wa wa vz cv cY wcel vz cv cF cfv vy cv vt cv
      eleq1 ad2antll sylibd syld sylbid exp32 r19.23adv sylbid com23 imp3a
      adantrr vy cv vx cv cF crn elin syl5ib ssrdv 3jca sylc exp511 r19.23adv
      adantr $.
      $( [19-Nov-2009] $) $( [19-Nov-2009] $)

    $( Lemma for ~ fmfnfm . $)
    fmfnfmlem3 $p |- ( ( ( ( B e. fBas /\ L e. Fil /\ F : Y --> X ) /\ ( ( X
    FilMap B ) ` F ) C_ L /\ X = Z ) /\ Y = U. ( fi ` ( B u. { y | E. x e. L y
    = ( `' F " x ) } ) ) ) -> ( fi ` { y | E. x e. L y = ( `' F " x ) } ) = { y
    | E. x e. L y = ( `' F " x ) } ) $=
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq wa vu cv vv cv cin vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wcel vv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral
      vu vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cfi cfv vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq wa vu cv vv cv cin vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab wcel vu vv vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vu cv cF ccnv vx cv cima wceq vx cL wrex vv cv cF ccnv
      vx cv cima wceq vx cL wrex wa vu cv vv cv cin cF ccnv vx cv cima wceq vx
      cL wrex vu cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vv cv
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel wa vu cv vv cv cin
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq wa vu cv cF ccnv vr cv cima wceq vv cv cF ccnv vs cv cima wceq wa vs
      cL wrex vr cL wrex vu cv vv cv cin cF ccnv vx cv cima wceq vx cL wrex vu
      cv cF ccnv vx cv cima wceq vx cL wrex vv cv cF ccnv vx cv cima wceq vx cL
      wrex wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv cuni wceq wa vu cv cF ccnv vr cv cima wceq vv cv cF
      ccnv vs cv cima wceq wa vu cv vv cv cin cF ccnv vx cv cima wceq vx cL
      wrex vr vs cL cL cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq wa vr cv cL wcel vs cv cL wcel wa
      vu cv cF ccnv vr cv cima wceq vv cv cF ccnv vs cv cima wceq wa vu cv vv
      cv cin cF ccnv vx cv cima wceq vx cL wrex vr cv vs cv cin cL wcel vu cv
      vv cv cin cF ccnv vr cv vs cv cin cima wceq vu cv vv cv cin cF ccnv vx cv
      cima wceq vx cL wrex cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq wa vr cv cL wcel vs cv cL wcel wa
      vu cv cF ccnv vr cv cima wceq vv cv cF ccnv vs cv cima wceq wa wa wa vu
      cv vv cv cin cF ccnv vx cv cima wceq vu cv vv cv cin cF ccnv vr cv vs cv
      cin cima wceq vx vr cv vs cv cin cL vx cv vr cv vs cv cin wceq cF ccnv vx
      cv cima cF ccnv vr cv vs cv cin cima vu cv vv cv cin vx cv vr cv vs cv
      cin cF ccnv imaeq2 eqeq2d rcla4ev cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vr cv cL wcel vs cv cL
      wcel wa vr cv vs cv cin cL wcel cY cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cuni wceq vu cv cF ccnv vr cv cima wceq vv cv cF
      ccnv vs cv cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss vr cv cL wcel vs cv cL wcel wa vr cv vs cv cin
      cL wcel cX cZ wceq cL cfil wcel cB cfbas wcel vr cv cL wcel vs cv cL wcel
      wa vr cv vs cv cin cL wcel cY cX cF wf cL cfil wcel vr cv cL wcel vs cv
      cL wcel vr cv vs cv cin cL wcel vr cv vs cv cL filint 3expb 3ad2antl2
      3ad2antl1 ad2ant2r cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq wa vr cv cL wcel vs cv cL wcel wa
      vu cv cF ccnv vr cv cima wceq vv cv cF ccnv vs cv cima wceq wa wa wa vu
      cv vv cv cin cF ccnv vr cv cima cF ccnv vs cv cima cin cF ccnv vr cv vs
      cv cin cima vu cv cF ccnv vr cv cima wceq vv cv cF ccnv vs cv cima wceq
      wa vu cv vv cv cin cF ccnv vr cv cima cF ccnv vs cv cima cin wceq cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vr cv cL wcel vs cv cL wcel wa vu cv cF ccnv vr cv cima
      vv cv cF ccnv vs cv cima ineq12 ad2antll cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF ccnv vr cv vs
      cv cin cima cF ccnv vr cv cima cF ccnv vs cv cima cin wceq cY cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq vr cv cL
      wcel vs cv cL wcel wa vu cv cF ccnv vr cv cima wceq vv cv cF ccnv vs cv
      cima wceq wa wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cF ccnv vr cv vs cv cin cima cF ccnv vr cv cima cF
      ccnv vs cv cima cin wceq cX cZ wceq cY cX cF wf cB cfbas wcel cF ccnv vr
      cv vs cv cin cima cF ccnv vr cv cima cF ccnv vs cv cima cin wceq cL cfil
      wcel cY cX cF wf cF wfun cF ccnv ccnv wfun cF ccnv vr cv vs cv cin cima
      cF ccnv vr cv cima cF ccnv vs cv cima cin wceq cY cX cF ffun cF funcnvcnv
      vr cv vs cv cF ccnv imain 3syl 3ad2ant3 3ad2ant1 ad2antrr eqtr4d sylanc
      exp32 r19.23advv vu cv cF ccnv vx cv cima wceq vx cL wrex vv cv cF ccnv
      vx cv cima wceq vx cL wrex wa vu cv cF ccnv vr cv cima wceq vr cL wrex vv
      cv cF ccnv vs cv cima wceq vs cL wrex wa vu cv cF ccnv vr cv cima wceq vv
      cv cF ccnv vs cv cima wceq wa vs cL wrex vr cL wrex vu cv cF ccnv vx cv
      cima wceq vx cL wrex vu cv cF ccnv vr cv cima wceq vr cL wrex vv cv cF
      ccnv vx cv cima wceq vx cL wrex vv cv cF ccnv vs cv cima wceq vs cL wrex
      vu cv cF ccnv vx cv cima wceq vu cv cF ccnv vr cv cima wceq vx vr cL vx
      cv vr cv wceq cF ccnv vx cv cima cF ccnv vr cv cima vu cv vx cv vr cv cF
      ccnv imaeq2 eqeq2d cbvrexv vv cv cF ccnv vx cv cima wceq vv cv cF ccnv vs
      cv cima wceq vx vs cL vx cv vs cv wceq cF ccnv vx cv cima cF ccnv vs cv
      cima vv cv vx cv vs cv cF ccnv imaeq2 eqeq2d cbvrexv anbi12i vu cv cF
      ccnv vr cv cima wceq vv cv cF ccnv vs cv cima wceq vr vs cL cL reeanv
      bitr4i syl5ib vu cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel
      vu cv cF ccnv vx cv cima wceq vx cL wrex vv cv vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab wcel vv cv cF ccnv vx cv cima wceq vx cL wrex vy
      cv cF ccnv vx cv cima wceq vx cL wrex vu cv cF ccnv vx cv cima wceq vx cL
      wrex vy vu cv vu visset vy cv vu cv wceq vy cv cF ccnv vx cv cima wceq vu
      cv cF ccnv vx cv cima wceq vx cL vy cv vu cv cF ccnv vx cv cima eqeq1
      rexbidv elab vy cv cF ccnv vx cv cima wceq vx cL wrex vv cv cF ccnv vx cv
      cima wceq vx cL wrex vy vv cv vv visset vy cv vv cv wceq vy cv cF ccnv vx
      cv cima wceq vv cv cF ccnv vx cv cima wceq vx cL vy cv vv cv cF ccnv vx
      cv cima eqeq1 rexbidv elab anbi12i vy cv cF ccnv vx cv cima wceq vx cL
      wrex vu cv vv cv cin cF ccnv vx cv cima wceq vx cL wrex vy vu cv vv cv
      cin vu cv vv cv vu visset inex1 vy cv vu cv vv cv cin wceq vy cv cF ccnv
      vx cv cima wceq vu cv vv cv cin cF ccnv vx cv cima wceq vx cL vy cv vu cv
      vv cv cin cF ccnv vx cv cima eqeq1 rexbidv elab 3imtr4g r19.21aivv cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel
      vu cv vv cv cin vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vv
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral vu vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab wral vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cfi cfv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wceq
      wb cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv
      wcel cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cX cZ
      wceq cL cfil wcel cB cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cvv wcel cY cX cF wf vx vy cL cF ccnv vx cv cima cfil abrexexg
      3ad2ant2 3ad2ant1 adantr vu vv vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cvv inficlALT syl mpbid $.
      $( [19-Nov-2009] $) $( [19-Nov-2009] $)

    $( Lemma for ~ fmfnfm . $)
    fmfnfmlem4 $p |- ( ( ( ( B e. fBas /\ L e. Fil /\ F : Y --> X ) /\ ( ( X
    FilMap B ) ` F ) C_ L /\ X = Z ) /\ Y = U. ( fi ` ( B u. { y | E. x e. L y
    = ( `' F " x ) } ) ) ) -> ( t e. L <-> ( t C_ X /\ E. s e. ( fi ` ( B u. {
    y | E. x e. L y = ( `' F " x ) } ) ) ( F " s ) C_ t ) ) ) $=
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq wa vt cv cL wcel vt cv cX wss cF vs cv cima vt cv wss
      vs cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wrex wa
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq wa vt cv cL wcel vt cv cX wss cF vs cv cima vt cv wss
      vs cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wrex cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq vt cv cL wcel vt cv cX wss cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq vt cv cL
      wcel wa wa vt cv cZ cX vt cv cL wcel vt cv cZ wss cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq vt
      cv cL wcel vt cv cL cuni cZ vt cv cL elssuni fmfnfm.2 syl6ssr ad2antll cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq vt cv cL wcel wa 3simpl3 sseqtr4d expr cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq vt
      cv cL wcel cF vs cv cima vt cv wss vs cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cfi cfv wrex cF ccnv vt cv cima cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv wcel cF cF ccnv vt cv cima cima
      vt cv wss cF vs cv cima vt cv wss vs cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cfi cfv wrex cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq vt cv cL wcel wa wa
      cF vs cv cima vt cv wss cF cF ccnv vt cv cima cima vt cv wss vs cF ccnv
      vt cv cima cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      vs cv cF ccnv vt cv cima wceq cF vs cv cima cF cF ccnv vt cv cima cima vt
      cv vs cv cF ccnv vt cv cima cF imaeq2 sseq1d rcla4ev cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq vt cv cL wcel wa wa vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cF ccnv vt
      cv cima cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv cuni wceq vt cv cL wcel wa wa vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq vt cv cL wcel wa wa vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cB ssun2 a1i cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq vt cv cL wcel wa wa cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cvv wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wss cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cvv
      wcel cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq vt cv cL wcel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cvv wcel cX cZ wceq cB cfbas wcel cL cfil wcel cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel cY cX cF wf cB cfbas
      wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel cL cfil wcel cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas cvv unexg vx vy cL cF
      ccnv vx cv cima cfil abrexexg sylan2 3adant3 3ad2ant1 adantr cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cvv abfi2 syl sstrd cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq vt cv cL wcel wa wa cF ccnv vt cv cima vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab wcel cF ccnv vt cv cima cF ccnv vx cv cima
      wceq vx cL wrex vt cv cL wcel cF ccnv vt cv cima cF ccnv vx cv cima wceq
      vx cL wrex cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv cuni wceq vt cv cL wcel cF ccnv vt cv cima cF ccnv vt
      cv cima wceq cF ccnv vt cv cima cF ccnv vx cv cima wceq vx cL wrex cF
      ccnv vt cv cima eqid cF ccnv vt cv cima cF ccnv vx cv cima wceq cF ccnv
      vt cv cima cF ccnv vt cv cima wceq vx vt cv cL vx cv vt cv wceq cF ccnv
      vx cv cima cF ccnv vt cv cima cF ccnv vt cv cima vx cv vt cv cF ccnv
      imaeq2 eqeq2d rcla4ev mpan2 ad2antll cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF ccnv vt cv cima
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cF ccnv vt cv cima
      cF ccnv vx cv cima wceq vx cL wrex wb cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq vt cv cL wcel wa cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cF ccnv vt cv
      cima vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cF ccnv vt cv
      cima cF ccnv vx cv cima wceq vx cL wrex wb cX cZ wceq cB cfbas wcel cY cX
      cF wf cF ccnv vt cv cima vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wcel cF ccnv vt cv cima cF ccnv vx cv cima wceq vx cL wrex wb cL cfil
      wcel cB cfbas wcel cY cX cF wf wa cF ccnv vt cv cima cvv wcel cF ccnv vt
      cv cima vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cF ccnv vt
      cv cima cF ccnv vx cv cima wceq vx cL wrex wb cF ccnv vt cv cima cY wss
      cY cvv wcel cF ccnv vt cv cima cvv wcel cB cfbas wcel cY cX cF wf wa cF
      ccnv vt cv cima cY cvv ssexg cB cfbas wcel cY cX cF wf wa cF ccnv vt cv
      cima cF cdm cY cF ccnv vt cv cima cF cdm wss cB cfbas wcel cY cX cF wf wa
      cF vt cv cnvimass a1i cY cX cF wf cF cdm cY wceq cB cfbas wcel cY cX cF
      fdm adantl sseqtrd cB cfbas wcel cY cvv wcel cY cX cF wf cB cfbas wcel cB
      cuni cvv cY cB cfbas uniexg fmfnfm.1 syl5eqel adantr sylanc vy cv cF ccnv
      vx cv cima wceq vx cL wrex cF ccnv vt cv cima cF ccnv vx cv cima wceq vx
      cL wrex vy cF ccnv vt cv cima cvv vy cv cF ccnv vt cv cima wceq vy cv cF
      ccnv vx cv cima wceq cF ccnv vt cv cima cF ccnv vx cv cima wceq vx cL vy
      cv cF ccnv vt cv cima cF ccnv vx cv cima eqeq1 rexbidv elabg syl 3adant2
      3ad2ant1 adantr mpbird sseldd cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF cF ccnv vt cv cima cima
      vt cv wss cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq vt cv cL wcel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cF cF ccnv vt cv cima cima vt cv wss cX cZ
      wceq cY cX cF wf cB cfbas wcel cF cF ccnv vt cv cima cima vt cv wss cL
      cfil wcel cY cX cF wf cF wfun cF cF ccnv vt cv cima cima vt cv wss cY cX
      cF ffun cF wfun cF ccnv vt cv cima cF ccnv vt cv cima wss cF cF ccnv vt
      cv cima cima vt cv wss cF ccnv vt cv cima ssid cF ccnv vt cv cima vt cv
      cF funimass2 mpan2 syl 3ad2ant3 3ad2ant1 adantr sylanc expr jcad cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vt cv cX wss cF vs cv cima vt cv wss vs cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv wrex vt cv cL wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa cF vs cv cima vt cv wss vs cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv wrex vt cv cX wss vt cv cL wcel cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi vs
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vs cv cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv wcel vs cv cB cfi cfv wcel vs cv vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cfi cfv wcel vs cv vu cv vv cv cin wceq vv vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cfi cfv wrex vu cB cfi cfv wrex
      w3o cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi cB cfbas
      wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel vs cv cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wcel vs cv cB
      cfi cfv wcel vs cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfi
      cfv wcel vs cv vu cv vv cv cin wceq vv vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cfi cfv wrex vu cB cfi cfv wrex w3o wb cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq wa vu vv vs cv cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cfbas cvv elfiun cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cB cfbas wcel cY cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB cfbas wcel cX
      cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1 3ad2ant1 adantr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cY
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cX cZ wceq cL
      cfil wcel cB cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cvv wcel cY cX cF wf vx vy cL cF ccnv vx cv cima cfil abrexexg 3ad2ant2
      3ad2ant1 adantr sylanc cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vs cv cB cfi cfv wcel cF
      vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi vs cv vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cfi cfv wcel vs cv vu cv vv cv cin wceq
      vv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfi cfv wrex vu cB cfi
      cfv wrex vx vy vt cB cF cL cX cY cZ vs fmfnfm.1 fmfnfm.2 fmfnfmlem1 cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vs cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cfi cfv wcel vs cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel
      cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq wa vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfi cfv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab vs cv vx vy cB cF cL cX cY cZ
      fmfnfm.1 fmfnfm.2 fmfnfmlem3 eleq2d cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vs cv cF ccnv
      vx cv cima wceq vx cL wrex cF vs cv cima vt cv wss vt cv cX wss vt cv cL
      wcel wi wi vs cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vx
      vy vt cB cF cL cX cY cZ vs fmfnfm.1 fmfnfm.2 fmfnfmlem2 vy cv cF ccnv vx
      cv cima wceq vx cL wrex vs cv cF ccnv vx cv cima wceq vx cL wrex vy vs cv
      vs visset vy cv vs cv wceq vy cv cF ccnv vx cv cima wceq vs cv cF ccnv vx
      cv cima wceq vx cL vy cv vs cv cF ccnv vx cv cima eqeq1 rexbidv elab
      syl5ib sylbid cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cuni wceq wa vs cv vu cv vv cv cin wceq cF vs cv
      cima vt cv wss vt cv cX wss vt cv cL wcel wi wi vu vv cB cfi cfv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cfi cfv cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vu cv
      cB cfi cfv wcel vv cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfi
      cfv wcel vs cv vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss
      vt cv cL wcel wi wi wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vv cv vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cfi cfv wcel vu cv cB cfi cfv wcel vs cv vu
      cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi
      wi wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun cfi cfv cuni wceq wa vv cv vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cfi cfv wcel vv cv vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab wcel vu cv cB cfi cfv wcel vs cv vu cv vv cv cin wceq cF vs cv
      cima vt cv wss vt cv cX wss vt cv cL wcel wi wi wi wi cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq wa vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfi cfv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab vv cv vx vy cB cF cL cX cY cZ
      fmfnfm.1 fmfnfm.2 fmfnfmlem3 eleq2d cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vv cv cF ccnv
      vx cv cima wceq vx cL wrex vu cv cB cfi cfv wcel vs cv vu cv vv cv cin
      wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi wi wi vv cv
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vv cv cF ccnv vx cv cima wceq vx cL wrex vu cv cB cfi cfv wcel vs cv vu
      cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi
      wi wi wi wi cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vv cv cF ccnv vx cv cima wceq vu cv cB cfi
      cfv wcel vs cv vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss
      vt cv cL wcel wi wi wi wi vx cL cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq vu cv cB cfi cfv wcel vs cv vu cv vv cv cin wceq cF
      vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi wi wi cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vu cv cB cfi cfv
      wcel vy cv cB wss vy cv cfn wcel vu cv vy cv cint wceq w3a vy wex vs cv
      vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel
      wi wi wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vu cv cB cfi cfv wcel vy cv cB wss vy cv cfn
      wcel vu cv vy cv cint wceq w3a vy wex wb vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss vu cv cB cfi cfv wcel vy cv cB wss vy cv cfn wcel
      vu cv vy cv cint wceq w3a vy wex wb cX cZ wceq cB cfbas wcel cL cfil wcel
      vu cv cB cfi cfv wcel vy cv cB wss vy cv cfn wcel vu cv vy cv cint wceq
      w3a vy wex wb cY cX cF wf vu cv cvv wcel cB cfbas wcel vu cv cB cfi cfv
      wcel vy cv cB wss vy cv cfn wcel vu cv vy cv cint wceq w3a vy wex wb vu
      visset vy vu cv cvv cB cfbas sppfi mpan 3ad2ant1 3ad2ant1 adantr cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vy cv cB wss
      vy cv cfn wcel vu cv vy cv cint wceq w3a vs cv vu cv vv cv cin wceq cF vs
      cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi wi vy cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vy cv cB wss vy cv cfn
      wcel vu cv vy cv cint wceq vs cv vu cv vv cv cin wceq cF vs cv cima vt cv
      wss vt cv cX wss vt cv cL wcel wi wi wi cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv
      cv cF ccnv vx cv cima wceq wa wa vy cv cB wss vy cv cfn wcel vu cv vy cv
      cint wceq vs cv vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss
      vt cv cL wcel wi wi wi wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa wa vy cv cB wss vy cv cfn wcel wa vz cv vy cv cint wss vz
      cB wrex vu cv vy cv cint wceq vs cv vu cv vv cv cin wceq cF vs cv cima vt
      cv wss vt cv cX wss vt cv cL wcel wi wi wi wi cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vy cv cB
      wss vy cv cfn wcel wa vz cv vy cv cint wss vz cB wrex wi vx cv cL wcel vv
      cv cF ccnv vx cv cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss vy cv cB wss vy cv cfn wcel wa vz cv vy cv
      cint wss vz cB wrex wi cX cZ wceq cB cfbas wcel cL cfil wcel vy cv cB wss
      vy cv cfn wcel wa vz cv vy cv cint wss vz cB wrex wi cY cX cF wf cB cfbas
      wcel vy cv cB wss vy cv cfn wcel vz cv vy cv cint wss vz cB wrex vz vy cv
      cB fbssint 3expib 3ad2ant1 3ad2ant1 adantr cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa wa vz cv vy cv cint wss vu cv vy cv cint
      wceq vs cv vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss vt
      cv cL wcel wi wi wi wi vz cB cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq wa wa vz cv cB wcel vz cv vy cv cint wss vu cv vy cv cint
      wceq vs cv vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss vt
      cv cL wcel wi wi wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa wa vz cv cB wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq
      cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi wi vz cv vy cv
      cint wss vu cv vy cv cint wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel vz cv vu cv wss vs cv vu cv vv
      cv cin wceq cF vs cv cima vt cv wss vt cv cX wss vt cv cL wcel wi wi cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB
      wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa wa cF vs cv cima vt
      cv wss vt cv cX wss vt cv cL wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv
      vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa vt cv cL wcel
      cL cfil wcel cF vz cv cima vx cv cin cL wcel vt cv cZ wss cF vz cv cima
      vx cv cin vt cv wss w3a vt cv cL wcel cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv
      cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu
      cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa wa cF vz
      cv cima vx cv cin vt cv cL cZ fmfnfm.2 fillsb cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa wa cL cfil wcel vz cv cB wcel vz cv
      vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX
      wss wa wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cL cfil wcel vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cL cfil wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF
      wf 3simp2 3ad2ant1 adantr ad2antrr cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv
      vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa wa cF vz cv
      cima vx cv cin cL wcel vt cv cZ wss cF vz cv cima vx cv cin vt cv wss cL
      cfil wcel cF vz cv cima cL wcel vx cv cL wcel cF vz cv cima vx cv cin cL
      wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa
      vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv
      cima vt cv wss vt cv cX wss wa wa wa cF vz cv cima vx cv cL filint cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa cL cfil
      wcel vz cv cB wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv
      cima vt cv wss vt cv cX wss wa wa cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cL cfil wcel vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cL cfil wcel cX cZ wceq cB cfbas
      wcel cL cfil wcel cY cX cF wf 3simp2 3ad2ant1 adantr ad2antrr cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel
      wa cF vz cv cima cL wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF
      vs cv cima vt cv wss vt cv cX wss wa wa cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv
      cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa cF cX cB cfilmap co cfv
      cL cF vz cv cima cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cF cX cB cfilmap co cfv cL wss vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa vz cv cB wcel cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      3simp2 ad2antrr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vz cv cB wcel cF vz cv cima cF cX cB
      cfilmap co cfv wcel vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa cX cL
      wcel cB cfbas wcel cY cX cF wf w3a vz cv cB cfg cfv wcel cF vz cv cima cF
      cX cB cfilmap co cfv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cB wcel wa cL cB vz cv
      cF cB cfg cfv cX cY fmfnfm.1 cB cfg cfv eqid imaelfm cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vz cv cB wcel wa cX cL wcel cB cfbas wcel cY cX cF wf cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cX cL wcel vz cv cB wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cX cZ
      wceq cX cL wcel cF cX cB cfilmap co cfv cL wss cL cfil wcel cB cfbas wcel
      cX cZ wceq cX cL wcel cY cX cF wf cL cfil wcel cX cZ wceq wa cX cZ cL cL
      cfil wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL wcel cX cZ wceq cL cZ
      fmfnfm.2 filusb adantr eqeltrd 3ad2antl2 3adant2 adantr cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cB cfbas wcel vz cv cB wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cB cfbas wcel cX cZ wceq cB cfbas wcel cL
      cfil wcel cY cX cF wf 3simp1 3ad2ant1 adantr cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cX cF wf
      vz cv cB wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cY cX cF wf cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF
      wf 3simp3 3ad2ant1 adantr 3jca cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cB wcel vz cv cB cfg
      cfv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cB cB cfg cfv vz cv cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB cB cfg cfv wss cX cZ
      wceq cB cfbas wcel cL cfil wcel cB cB cfg cfv wss cY cX cF wf cB fbssfg
      3ad2ant1 3ad2ant1 sseld imp sylanc adantlr sseldd adantr cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vx cv cL wcel vz cv cB
      wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv
      wss vt cv cX wss wa wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq simprl ad2antrr syl3anc cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv
      vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa vt cv cZ wss cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB
      wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa wa cF vs cv cima vt
      cv wss vt cv cX wss vt cv cZ wss cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv
      vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss vt cv cZ wss wi cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB
      wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv
      wss wa wa vt cv cX wss vt cv cZ wss cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv
      cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu
      cv vv cv cin wceq wa cF vs cv cima vt cv wss wa wa cX cZ vt cv cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa cX cZ wceq vz
      cv cB wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt
      cv wss wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      3simpl3 ad2antrr sseq2d biimpd expr imp3a impr cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss
      vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa
      wa cF vz cv cima vx cv cin cF vs cv cima vt cv cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss
      vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa
      wa vw cF vz cv cima vx cv cin cF vs cv cima cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs
      cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa wa
      vw cv cF vz cv cima wcel vw cv vx cv wcel wa vw cv cF vs cv cima wcel vw
      cv cF vz cv cima vx cv cin wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv
      vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa wa vw cv cF
      vz cv cima wcel vw cv vx cv wcel vw cv cF vs cv cima wcel cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz
      cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv
      cX wss wa wa wa vw cv cF vz cv cima wcel vy cv cF cfv vw cv wceq vy vz cv
      wrex vw cv vx cv wcel vw cv cF vs cv cima wcel wi cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa wa vw cv cF vz cv cima wcel vy
      cv cF cfv vw cv wceq vy vz cv wrex wi vz cv cB wcel vz cv vu cv wss vs cv
      vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vw cv cF vz cv cima wcel vy cv cF cfv vw cv wceq vy vz cv
      wrex wi vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss vw cv cF vz cv
      cima wcel vy cv cF cfv vw cv wceq vy vz cv wrex wi cX cZ wceq cY cX cF wf
      cB cfbas wcel vw cv cF vz cv cima wcel vy cv cF cfv vw cv wceq vy vz cv
      wrex wi cL cfil wcel cY cX cF wf cF wfun vw cv cF vz cv cima wcel vy cv
      cF cfv vw cv wceq vy vz cv wrex wi cY cX cF ffun cF wfun vw cv cF vz cv
      cima wcel vy cv cF cfv vw cv wceq vy vz cv wrex vy vw cv vz cv cF fvelima
      ex syl 3ad2ant3 3ad2ant1 adantr ad2antrr cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv
      cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv
      vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa wa vy
      cv cF cfv vw cv wceq vw cv vx cv wcel vw cv cF vs cv cima wcel wi vy vz
      cv cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz
      cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima
      vt cv wss vt cv cX wss wa wa vy cv vz cv wcel vy cv cF cfv vw cv wceq vw
      cv vx cv wcel vw cv cF vs cv cima wcel wi wi vy cv cF cfv vw cv wceq vy
      cv cF cfv vx cv wcel vy cv cF cfv cF vs cv cima wcel wi vw cv vx cv wcel
      vw cv cF vs cv cima wcel wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin
      wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa wa
      vy cv cF cfv vw cv wceq vy cv cF cfv vx cv wcel vw cv vx cv wcel vy cv cF
      cfv cF vs cv cima wcel vw cv cF vs cv cima wcel vy cv cF cfv vw cv vx cv
      eleq1 vy cv cF cfv vw cv cF vs cv cima eleq1 imbi12d cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv
      vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX
      wss wa wa vy cv vz cv wcel wa wa vy cv cF cfv vx cv wcel vy cv cF ccnv vx
      cv cima wcel vy cv cF cfv cF vs cv cima wcel cF wfun vy cv cF cdm wcel vy
      cv cF cfv vx cv wcel vy cv cF ccnv vx cv cima wcel wb cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv
      vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX
      wss wa wa vy cv vz cv wcel wa wa vy cv vx cv cF fvimacnv cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa cF wfun vz cv cB wcel
      vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt
      cv cX wss wa wa vy cv vz cv wcel wa cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF wfun vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cF wfun cX cZ wceq cY cX cF wf cB
      cfbas wcel cF wfun cL cfil wcel cY cX cF ffun 3ad2ant3 3ad2ant1 adantr
      ad2antrr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      wa vz cv cB wcel wa vy cv vz cv wcel vy cv cF cdm wcel vz cv vu cv wss vs
      cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vz cv cB wcel vy cv vz cv wcel vy cv cF cdm wcel vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cB wcel vy cv
      vz cv wcel vy cv cF cdm wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss vz cv cB wcel vy cv vz cv wcel wa vy cv cF
      cdm wcel cX cZ wceq cY cX cF wf cB cfbas wcel vz cv cB wcel vy cv vz cv
      wcel wa vy cv cF cdm wcel cL cfil wcel cY cX cF wf vz cv cB wcel vy cv vz
      cv wcel wa wa vy cv cY cF cdm vz cv cB wcel vy cv vz cv wcel wa vy cv cY
      wcel cY cX cF wf vz cv cY wss vy cv vz cv wcel vy cv cY wcel vz cv cB
      wcel vz cv cY vy cv ssel2 vz cv cB wcel vz cv cB cuni cY vz cv cB elssuni
      fmfnfm.1 syl6ssr sylan adantl cY cX cF wf cF cdm cY wceq vz cv cB wcel vy
      cv vz cv wcel wa cY cX cF fdm adantr eleqtrrd 3ad2antl3 3ad2antl1 anassrs
      adantllr adantrl sylanc cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin
      wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy
      cv cF ccnv vx cv cima wcel vy cv cF cfv cF vs cv cima wcel cF wfun vs cv
      cF cdm wss wa vy cv vs cv wcel vy cv cF cfv cF vs cv cima wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel
      wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss
      vt cv cX wss wa wa vy cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel wa
      wa vs cv vy cv cF funfvima2 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin
      wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy
      cv cF ccnv vx cv cima wcel wa wa cF wfun vs cv cF cdm wss cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa cF wfun vz cv cB
      wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv
      wss vt cv cX wss wa wa vy cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel
      wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a cF wfun vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cF wfun cX cZ wceq cY cX cF wf cB cfbas wcel cF wfun cL cfil wcel cY cX
      cF ffun 3ad2ant3 3ad2ant1 adantr ad2antrr cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs
      cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy
      cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel wa wa vs cv cF ccnv vx cv
      cima cF cdm cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq
      wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF
      vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy cv cF ccnv
      vx cv cima wcel wa wa vu cv vv cv cin vv cv vs cv cF ccnv vx cv cima vu
      cv vv cv cin vv cv wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin
      wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy
      cv cF ccnv vx cv cima wcel wa wa vu cv vv cv inss2 a1i vz cv vu cv wss vs
      cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy
      cv vz cv wcel wa vs cv vu cv vv cv cin wceq cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vy cv cF ccnv vx cv
      cima wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq cF vs cv cima vt cv
      wss vt cv cX wss wa vy cv vz cv wcel simpllr ad2antrl cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv
      vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX
      wss wa wa vy cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel wa wa vv cv
      cF ccnv vx cv cima cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa wa vv cv cF ccnv vx cv cima wceq vz cv cB wcel vz cv vu cv
      wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa
      wa vy cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel wa cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq simprr ad2antrr eqcomd
      3sstr4d cF ccnv vx cv cima cF cdm wss cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv
      cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu
      cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz
      cv wcel wa vy cv cF ccnv vx cv cima wcel wa wa cF vx cv cnvimass a1i
      sstrd jca cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs
      cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy cv cF ccnv vx
      cv cima wcel wa wa vy cv vu cv vv cv cin vs cv cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss
      vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa
      vy cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel wa wa vy cv vu cv wcel
      vy cv vv cv wcel wa vy cv vu cv vv cv cin wcel cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss
      vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa
      vy cv vz cv wcel wa vy cv cF ccnv vx cv cima wcel wa wa vy cv vu cv wcel
      vy cv vv cv wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv
      cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy cv vu cv wcel cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB
      wcel wa vy cv cF ccnv vx cv cima wcel vz cv vu cv wss vs cv vu cv vv cv
      cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel
      vy cv vu cv wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv
      cima vt cv wss vt cv cX wss wa wa vz cv vu cv vy cv vz cv vu cv wss vs cv
      vu cv vv cv cin wceq cF vs cv cima vt cv wss vt cv cX wss wa simpll sseld
      imp ad2antrl cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq
      wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF
      vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa vy cv cF ccnv
      vx cv cima wcel vy cv vv cv wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv
      vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv
      wcel wa wa vy cv vv cv wcel vy cv cF ccnv vx cv cima wcel cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vz
      cv vu cv wss vs cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv
      cX wss wa wa vy cv vz cv wcel wa wa vv cv cF ccnv vx cv cima vy cv cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa wa vv cv cF
      ccnv vx cv cima wceq vz cv cB wcel vz cv vu cv wss vs cv vu cv vv cv cin
      wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy cv vz cv wcel wa cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq simprr ad2antrr
      eleq2d biimprd impr jca vy cv vu cv vv cv elin sylibr vz cv vu cv wss vs
      cv vu cv vv cv cin wceq wa cF vs cv cima vt cv wss vt cv cX wss wa wa vy
      cv vz cv wcel wa vs cv vu cv vv cv cin wceq cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa wa vz cv cB wcel wa vy cv cF ccnv vx cv
      cima wcel vz cv vu cv wss vs cv vu cv vv cv cin wceq cF vs cv cima vt cv
      wss vt cv cX wss wa vy cv vz cv wcel simpllr ad2antrl eleqtrrd sylc expr
      sylbid syl5cbi expr r19.23adv syld imp3a vw cv cF vz cv cima vx cv elin
      syl5ib ssrdv cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq
      wa wa vz cv cB wcel wa vz cv vu cv wss vs cv vu cv vv cv cin wceq wa cF
      vs cv cima vt cv wss vt cv cX wss simprrl sstrd 3jca sylc expr exp3a
      exp43 vu cv vy cv cint wceq vz cv vu cv wss vz cv vy cv cint wss vu cv vy
      cv cint vz cv sseq2 biimparc syl7 exp4a r19.23adv syld exp3a 3impd
      19.23adv sylbid exp32 r19.23adv adantr vy cv cF ccnv vx cv cima wceq vx
      cL wrex vv cv cF ccnv vx cv cima wceq vx cL wrex vy vv cv vv visset vy cv
      vv cv wceq vy cv cF ccnv vx cv cima wceq vv cv cF ccnv vx cv cima wceq vx
      cL vy cv vv cv cF ccnv vx cv cima eqeq1 rexbidv elab syl5ib sylbid com23
      imp3a r19.23advv 3jaod sylbid r19.23adv com23 imp3a impbid $.
      $( [19-Nov-2009] $) $( [19-Nov-2009] $)

    $( A filter finer than an image filter is an image filter of the same
       function. $)
    fmfnfm $p |- ( ( ( B e. fBas /\ L e. Fil /\ F : Y --> X ) /\ ( ( X FilMap B
    ) ` F ) C_ L /\ X = Z ) -> E. b e. fBas ( Y = U. b /\ B C_ b /\ L = ( ( X
    FilMap b ) ` F ) ) ) $=
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfbas wcel
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq cB cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      wss cL cF cX cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cfilmap co cfv wceq w3a cY vb cv cuni wceq cB vb cv wss cL cF cX vb
      cv cfilmap co cfv wceq w3a vb cfbas wrex cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY vb cv cuni
      wceq cB vb cv wss cL cF cX vb cv cfilmap co cfv wceq w3a cY cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wss cL cF cX cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfilmap co cfv
      wceq w3a vb cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cfbas vb cv cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv wceq cY vb cv cuni wceq cY cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cuni wceq cB vb cv wss cB cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv wss cL cF cX vb cv cfilmap co cfv
      wceq cL cF cX cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cfilmap co cfv wceq vb cv cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv wceq vb cv cuni cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cuni cY vb cv cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cfi cfv unieq eqeq2d vb cv cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cB sseq2 vb cv cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv wceq cF cX vb cv cfilmap co cfv
      cF cX cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cfilmap co cfv cL vb cv cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun cfi cfv wceq cF cX vb cv cfilmap co cX cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cfilmap co vb cv cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv cX cfilmap opreq2 fveq1d
      eqeq2d 3anbi123d rcla4ev cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cfbas wcel cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun c0 wne c0 cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv wnel wa cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun c0 wne c0 cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv wnel cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun c0 wne cX cZ wceq cB cfbas wcel cL cfil wcel cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun c0 wne cY cX cF wf cB
      cfbas wcel cB c0 wne cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun c0 wne cB fbasne0 cB cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun wss cB c0 wne cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun c0 wne cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab ssun1 cB cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun ssn0 mpan syl
      3ad2ant1 3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a c0 cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv wnel vu cv vv cv cin c0 wne vv vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab wral vu cB wral cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vu cv vv cv cin c0 wne vu vv cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vu cv cB wcel vv cv cF ccnv vx cv cima wceq vx cL
      wrex wa vu cv vv cv cin c0 wne vu cv cB wcel vv cv vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab wcel wa cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vu cv cB wcel vv cv
      cF ccnv vx cv cima wceq vx cL wrex vu cv vv cv cin c0 wne cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vv cv cF ccnv vx cv cima wceq vx cL wrex vu cv cB wcel vu cv vv cv
      cin c0 wne cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vv cv cF ccnv vx cv cima wceq vu cv cB wcel vu
      cv vv cv cin c0 wne wi vx cL cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq vu cv cB wcel vu cv vv cv cin c0 wne cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa cF vu
      cv cima vx cv cin c0 wceq wn vu cv vv cv cin c0 wne cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa cF vu cv
      cima vx cv cin c0 wceq c0 cL wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a c0 cL wcel wn vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss c0 cL wcel wn cX
      cZ wceq cL cfil wcel cB cfbas wcel c0 cL wcel wn cY cX cF wf cL filesn
      3ad2ant2 3ad2ant1 adantr cF vu cv cima vx cv cin c0 wceq cF vu cv cima vx
      cv cin cL wcel c0 cL wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa vu cv cB wcel wa wa cF vu cv cima vx cv cin c0 cL eleq1
      cL cfil wcel cF vu cv cima cL wcel vx cv cL wcel cF vu cv cima vx cv cin
      cL wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      vu cv cB wcel wa wa cF vu cv cima vx cv cL filint cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cL
      cfil wcel vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cL cfil wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp2
      3ad2ant1 adantr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa wa cF cX cB cfilmap co cfv cL cF vu cv cima
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel
      wa 3simpl2 cX cL wcel cB cfbas wcel cY cX cF wf w3a vu cv cB cfg cfv wcel
      cF vu cv cima cF cX cB cfilmap co cfv wcel cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa cL cB vu cv cF cB
      cfg cfv cX cY fmfnfm.1 cB cfg cfv eqid imaelfm cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cX cL wcel
      cB cfbas wcel cY cX cF wf w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq
      wa vu cv cB wcel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cX cL wcel cB cfbas wcel cY cX cF wf
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cX cZ wceq cX cL wcel cF cX cB
      cfilmap co cfv cL wss cL cfil wcel cB cfbas wcel cX cZ wceq cX cL wcel cY
      cX cF wf cL cfil wcel cX cZ wceq wa cX cZ cL cL cfil wcel cX cZ wceq
      pm3.27 cL cfil wcel cZ cL wcel cX cZ wceq cL cZ fmfnfm.2 filusb adantr
      eqeltrd 3ad2antl2 3adant2 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cB cfbas wcel cX cZ wceq cB cfbas wcel cL
      cfil wcel cY cX cF wf 3simp1 3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cY cX cF wf cX cZ wceq cB cfbas
      wcel cL cfil wcel cY cX cF wf 3simp3 3ad2ant1 3jca adantr cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vu cv cB wcel vu cv cB cfg cfv wcel vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a vu cv cB wcel vu cv cB cfg cfv wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cB cB cfg cfv vu cv cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cB cB cfg cfv wss cX cZ wceq cB cfbas wcel
      cL cfil wcel cB cB cfg cfv wss cY cX cF wf cB fbssfg 3ad2ant1 3ad2ant1
      sseld imp adantrl sylanc sseldd cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq vu cv cB wcel simprll syl3anc syl5cbi mtod cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      wa vt cv cF vu cv cima vx cv cin wcel vt wex vu cv vv cv cin c0 wne cF vu
      cv cima vx cv cin c0 wceq wn cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq wa vu cv cB wcel wa wa vt cv cF vu cv cima vx cv cin wcel
      vu cv vv cv cin c0 wne vt cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa vu cv cB wcel wa wa vt cv cF vu cv cima wcel vt cv vx cv
      wcel wa vu cv vv cv cin c0 wne vt cv cF vu cv cima vx cv cin wcel cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel
      wa wa vt cv cF vu cv cima wcel vt cv vx cv wcel vu cv vv cv cin c0 wne cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel
      wa wa vt cv cF vu cv cima wcel vy cv cF cfv vt cv wceq vy vu cv wrex vt
      cv vx cv wcel vu cv vv cv cin c0 wne wi cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vt cv cF vu cv
      cima wcel vy cv cF cfv vt cv wceq vy vu cv wrex wi vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa vu cv cB wcel wa cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss vt cv cF vu cv cima wcel vy cv
      cF cfv vt cv wceq vy vu cv wrex wi cX cZ wceq cY cX cF wf cB cfbas wcel
      vt cv cF vu cv cima wcel vy cv cF cfv vt cv wceq vy vu cv wrex wi cL cfil
      wcel cY cX cF wf cF wfun vt cv cF vu cv cima wcel vy cv cF cfv vt cv wceq
      vy vu cv wrex wi cY cX cF ffun cF wfun vt cv cF vu cv cima wcel vy cv cF
      cfv vt cv wceq vy vu cv wrex vy vt cv vu cv cF fvelima ex syl 3ad2ant3
      3ad2ant1 adantr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa wa vy cv cF cfv vt cv wceq vt cv vx cv wcel
      vu cv vv cv cin c0 wne wi vy vu cv vy cv cF cfv vt cv wceq vy cv cF cfv
      vx cv wcel vu cv vv cv cin c0 wne wi vt cv vx cv wcel vu cv vv cv cin c0
      wne wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu
      cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF cfv vt cv wceq vy cv cF cfv
      vx cv wcel vt cv vx cv wcel vu cv vv cv cin c0 wne vy cv cF cfv vt cv vx
      cv eleq1 imbi1d cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF cfv vx cv
      wcel vy cv vu cv vv cv cin wcel vu cv vv cv cin c0 wne cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv
      vu cv wcel wa vy cv cF cfv vx cv wcel vy cv vu cv wcel vy cv vv cv wcel
      wa vy cv vu cv vv cv cin wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF cfv
      vx cv wcel vy cv vu cv wcel vy cv vv cv wcel vy cv vu cv wcel vy cv cF
      cfv vx cv wcel vy cv vu cv wcel wi cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel vy cv cF cfv
      vx cv wcel ax-1 adantl cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF cfv vx cv
      wcel vy cv cF ccnv vx cv cima wcel vy cv vv cv wcel cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv
      wcel wa vy cv cF cfv vx cv wcel vy cv cF ccnv vx cv cima wcel cF wfun vy
      cv cF cdm wcel vy cv cF cfv vx cv wcel vy cv cF ccnv vx cv cima wcel wb
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB
      wcel wa wa vy cv vu cv wcel wa vy cv vx cv cF fvimacnv cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cF wfun vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      vy cv vu cv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cF wfun cX cZ wceq cY cX cF wf cB cfbas wcel cF
      wfun cL cfil wcel cY cX cF ffun 3ad2ant3 3ad2ant1 ad2antrr cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy
      cv vu cv wcel wa vy cv cY cF cdm vx cv cL wcel vv cv cF ccnv vx cv cima
      wceq wa vu cv cB wcel wa vy cv vu cv wcel vy cv cY wcel cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vu cv cB wcel vy cv vu cv wcel vy cv cY wcel vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq wa vu cv cB wcel vy cv vu cv wcel wa vy cv cB cuni cY vy
      cv vu cv wcel vu cv cB wcel vy cv cB cuni wcel vy cv vu cv cB elunii
      ancoms fmfnfm.1 syl6eleqr adantll adantll cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF cdm cY wceq
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa vy cv vu
      cv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cF cdm cY wceq cX cZ wceq cY cX cF wf cB cfbas wcel cF cdm cY
      wceq cL cfil wcel cY cX cF fdm 3ad2ant3 3ad2ant1 ad2antrr eleqtrrd sylanc
      biimpd cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu
      cv cB wcel wa wa vy cv vu cv wcel wa vv cv cF ccnv vx cv cima vy cv vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa vv cv cF ccnv
      vx cv cima wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vy cv vu cv wcel vx cv cL wcel vv cv
      cF ccnv vx cv cima wceq vu cv cB wcel simplr ad2antlr eleq2d sylibrd jcad
      vy cv vu cv vv cv elin syl6ibr vu cv vv cv cin vy cv ne0i syl6 syl5cbi
      r19.23adva syld imp3a vt cv cF vu cv cima vx cv elin syl5ib 19.23adv vt
      cF vu cv cima vx cv cin neq0 syl5ib mpd exp44 r19.23adv com23 imp3a vv cv
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel vv cv cF ccnv vx cv
      cima wceq vx cL wrex vu cv cB wcel vy cv cF ccnv vx cv cima wceq vx cL
      wrex vv cv cF ccnv vx cv cima wceq vx cL wrex vy vv cv vv visset vy cv vv
      cv wceq vy cv cF ccnv vx cv cima wceq vv cv cF ccnv vx cv cima wceq vx cL
      vy cv vv cv cF ccnv vx cv cima eqeq1 rexbidv elab anbi2i syl5ib
      r19.21aivv cB cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cfbas wcel c0 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv wnel vu cv vv cv cin c0 wne vv vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wral vu cB wral wb cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vu vv cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab fbunfip cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cB cfbas wcel cX cZ wceq cB
      cfbas wcel cL cfil wcel cY cX cF wf 3simp1 3ad2ant1 cY cvv wcel cL cfil
      wcel cY cZ cF wf w3a cF crn cL wcel vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cfbas wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a vx vy cvv cF cL cZ cY fmfnfm.2
      rnelfmlem cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cY cvv wcel cL cfil wcel cY cZ cF wf cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cY cvv
      wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cvv wcel cY cX cF wf cB
      cfbas wcel cB cuni cvv cY cB cfbas uniexg fmfnfm.1 syl5eqel 3ad2ant1
      3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cL cfil wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf
      3simp2 3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cX cZ wceq cY
      cZ cF wf cF cX cB cfilmap co cfv cL wss cY cX cF wf cB cfbas wcel cX cZ
      wceq cY cZ cF wf cL cfil wcel cX cZ wceq cY cX cF wf cY cZ cF wf cX cZ cY
      cF feq3 biimpac 3ad2antl3 3adant2 3jca cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF cX cB cfilmap
      co cfv cL cF crn cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq 3simp2 cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cF cY cima cF crn
      cF cX cB cfilmap co cfv cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cF cY cima cF crn wceq cX cZ wceq cY cX cF wf cB
      cfbas wcel cF cY cima cF crn wceq cL cfil wcel cY cX cF wf cY cF crn cF
      wfo cF cY cima cF crn wceq cY cX cF wf cF cY wfn cY cF crn cF wfo cY cX
      cF ffn cY cF dffn4 sylib cY cF crn cF foima syl 3ad2ant3 3ad2ant1 cX cL
      wcel cB cfbas wcel cY cX cF wf w3a cY cB cfg cfv wcel cF cY cima cF cX cB
      cfilmap co cfv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cL cB cY cF cB cfg cfv cX cY
      fmfnfm.1 cB cfg cfv eqid imaelfm cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cX cL wcel cB cfbas
      wcel cY cX cF wf cB cfbas wcel cL cfil wcel cY cX cF wf w3a cX cZ wceq cX
      cL wcel cF cX cB cfilmap co cfv cL wss cL cfil wcel cB cfbas wcel cX cZ
      wceq cX cL wcel cY cX cF wf cL cfil wcel cX cZ wceq wa cX cZ cL cL cfil
      wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL wcel cX cZ wceq cL cZ fmfnfm.2
      filusb adantr eqeltrd 3ad2antl2 3adant2 cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cB cfbas wcel cX cZ wceq cB
      cfbas wcel cL cfil wcel cY cX cF wf 3simp1 3ad2ant1 cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cY cX cF wf cX cZ
      wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp3 3ad2ant1 3jca cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cY cB
      cfg cfv wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cB cfg cfv wcel cY
      cX cF wf cB cfbas wcel cY cB cfg cfv cuni cB cfg cfv cB cY fmfnfm.1 fgbas
      cB cfbas wcel cB cfg cfv cfil wcel cB cfg cfv cuni cB cfg cfv wcel cB
      fgfil cB cfg cfv cB cfg cfv cuni cB cfg cfv cuni eqid filusb syl eqeltrd
      3ad2ant1 3ad2ant1 sylanc eqeltrrd sseldd sylanc sylanc mpbird jca cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfbas wcel cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun c0 wne c0 cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wnel wa wb cX cZ wceq
      cB cfbas wcel cL cfil wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun cfi cfv cfbas wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun c0 wne c0 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv wnel wa wb cY cX cF wf cB cfbas wcel cL cfil wcel wa cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cfbas wcel cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun c0 wne c0 cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv wnel wa wb cB cfbas wcel vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cvv wcel cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cvv wcel cL cfil wcel cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cfbas cvv unexg vx vy cL cF ccnv vx cv cima
      cfil abrexexg sylan2 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cvv fsubbas syl 3adant3 3ad2ant1 mpbird cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cB cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wss cY cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cL cF cX cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfilmap co
      cfv wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cB cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv wss cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun cfi cfv cuni wceq cL cF cX cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cfilmap co cfv wceq wa wa cB cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv wss cY cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cL cF cX cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfilmap co cfv wceq
      w3a cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a cB cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv wss cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq cL cF cX cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cun cfi cfv cfilmap co cfv wceq wa cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cB cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cB cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab ssun1 a1i cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cvv wcel cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv wss cB cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cvv wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas
      cvv unexg cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cB cfbas wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF
      wf 3simp1 3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv
      wcel cX cZ wceq cL cfil wcel cB cfbas wcel vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cvv wcel cY cX cF wf vx vy cL cF ccnv vx cv cima cfil
      abrexexg 3ad2ant2 3ad2ant1 sylanc cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cvv abfi2 syl sstrd cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cL cF cX cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfilmap co cfv wceq
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv wcel cY cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cuni wss cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv cY cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cB ssun2 a1i cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cvv wcel cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv wss cB cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cvv wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas
      cvv unexg cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cB cfbas wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF
      wf 3simp1 3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv
      wcel cX cZ wceq cL cfil wcel cB cfbas wcel vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cvv wcel cY cX cF wf vx vy cL cF ccnv vx cv cima cfil
      abrexexg 3ad2ant2 3ad2ant1 sylanc cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cvv abfi2 syl sstrd cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx cv cima wceq vx cL wrex
      cZ cL wcel cY cF ccnv cZ cima wceq cY cF ccnv vx cv cima wceq vx cL wrex
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cX cZ wceq w3a cY cF ccnv vx cv cima wceq cY cF ccnv cZ cima wceq vx cZ
      cL vx cv cZ wceq cF ccnv vx cv cima cF ccnv cZ cima cY vx cv cZ cF ccnv
      imaeq2 eqeq2d rcla4ev cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cZ cL wcel cX cZ wceq cL cfil wcel cB cfbas wcel cZ
      cL wcel cY cX cF wf cL cZ fmfnfm.2 filusb 3ad2ant2 3ad2ant1 cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a cY cF ccnv cX cima wceq cY cF ccnv cZ cima wceq cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cY cF ccnv cX cima
      wceq cX cZ wceq cY cX cF wf cB cfbas wcel cY cF ccnv cX cima wceq cL cfil
      wcel cY cX cF wf cF ccnv cX cima cY cY cX cF fimacnv eqcomd 3ad2ant3
      3ad2ant1 cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cY cF ccnv
      cX cima wceq cY cF ccnv cZ cima wceq wb cF cX cB cfilmap co cfv cL wss cX
      cZ wceq cF ccnv cX cima cF ccnv cZ cima cY cX cZ cF ccnv imaeq2 eqeq2d
      3ad2ant3 mpbid sylanc cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wcel cY cF ccnv vx cv cima wceq vx cL wrex wb cX cZ wceq cB cfbas wcel cL
      cfil wcel cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cF
      ccnv vx cv cima wceq vx cL wrex wb cY cX cF wf cB cfbas wcel cY cvv wcel
      cY vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wcel cY cF ccnv vx cv
      cima wceq vx cL wrex wb cB cfbas wcel cB cuni cvv cY cB cfbas uniexg
      fmfnfm.1 syl5eqel vy cv cF ccnv vx cv cima wceq vx cL wrex cY cF ccnv vx
      cv cima wceq vx cL wrex vy cY cvv vy cv cY wceq vy cv cF ccnv vx cv cima
      wceq cY cF ccnv vx cv cima wceq vx cL vy cv cY cF ccnv vx cv cima eqeq1
      rexbidv elabg syl 3ad2ant1 3ad2ant1 mpbird sseldd cY cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv elssuni syl cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cuni cY cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cuni cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas wcel vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cvv wcel cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cfbas cvv unexg cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB cfbas wcel cX cZ
      wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1 3ad2ant1 cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cvv wcel cX cZ wceq cL cfil wcel cB
      cfbas wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cY cX
      cF wf vx vy cL cF ccnv vx cv cima cfil abrexexg 3ad2ant2 3ad2ant1 sylanc
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cvv fiuni syl cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cB cuni vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cuni
      cun cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cuni cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cB cuni cY wss vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cuni cY wss wa cB cuni vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab cuni cun cY wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cuni cY wss cB cuni cY wss cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cY wss vz
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab wral vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cuni cY wss cB cfbas wcel cL cfil wcel cY cX
      cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cY wss vz
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv
      cF ccnv vx cv cima wceq vx cL wrex vz cv cY wss vz cv vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cF ccnv vx cv
      cima wceq vz cv cY wss vx cL cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cF ccnv vx cv cima
      wceq vz cv cY wss wi vx cv cL wcel vz cv cF ccnv vx cv cima wceq vz cv cY
      wss cF ccnv vx cv cima cY wss cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vz cv cF ccnv vx cv cima cY
      sseq1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cF ccnv vx cv cima cY wss cX cZ wceq cY cX cF wf cB cfbas wcel cF
      ccnv vx cv cima cY wss cL cfil wcel cY cX cF wf cF ccnv vx cv cima cF cdm
      cY cF ccnv vx cv cima cF cdm wss cY cX cF wf cF vx cv cnvimass a1i cY cX
      cF fdm sseqtrd 3ad2ant3 3ad2ant1 syl5cbir a1d r19.23adv vy cv cF ccnv vx
      cv cima wceq vx cL wrex vz cv cF ccnv vx cv cima wceq vx cL wrex vy vz cv
      vz visset vy cv vz cv wceq vy cv cF ccnv vx cv cima wceq vz cv cF ccnv vx
      cv cima wceq vx cL vy cv vz cv cF ccnv vx cv cima eqeq1 rexbidv elab
      syl5ib r19.21aiv vz vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cY
      unissb sylibr cY cB cuni fmfnfm.1 eqimss2i jctil cB cuni vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cuni cY unss sylib cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab uniun syl5ss eqsstr3d eqssd cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq cL cF cX cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cfilmap co cfv wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cuni wceq wa vt cL cF cX cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfilmap co cfv cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa vt cv cL wcel vt cv cX wss cF vs cv cima vt cv wss vs cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wrex wa vt cv
      cF cX cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cfilmap co cfv wcel vx vy vt cB cF cL cX cY cZ vs fmfnfm.1 fmfnfm.2
      fmfnfmlem4 cX cL wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cfbas wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cuni cX cF wf vt cv cF cX cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cfi cfv cfilmap co cfv wcel vt cv cX wss cF vs cv cima
      vt cv wss vs cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv wrex wa wb cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cuni wceq wa vs vt cv cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cL cF cX cB vy cv cF ccnv vx
      cv cima wceq vx cL wrex vy cab cun cfi cfv cuni cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cuni eqid elfilmap cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq
      w3a cX cL wcel cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun
      cfi cfv cuni wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cX cZ wceq
      cX cL wcel cF cX cB cfilmap co cfv cL wss cL cfil wcel cB cfbas wcel cX
      cZ wceq cX cL wcel cY cX cF wf cL cfil wcel cX cZ wceq wa cX cZ cL cL
      cfil wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL wcel cX cZ wceq cL cZ
      fmfnfm.2 filusb adantr eqeltrd 3ad2antl2 3adant2 adantr cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfbas wcel
      cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni
      wceq cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cfbas wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun c0 wne c0 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv wnel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cX cZ wceq w3a cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun c0 wne c0 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv wnel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun c0 wne cX cZ wceq cB cfbas wcel cL cfil wcel cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun c0 wne cY cX cF wf cB cfbas wcel cB c0
      wne cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun c0 wne cB
      fbasne0 cB cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun wss cB
      c0 wne cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun c0 wne cB
      vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab ssun1 cB cB vy cv cF ccnv
      vx cv cima wceq vx cL wrex vy cab cun ssn0 mpan syl 3ad2ant1 3ad2ant1 cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a c0 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv wnel vu cv vv cv cin c0 wne vv vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab wral vu cB wral cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vu cv vv cv cin c0 wne vu vv
      cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vu cv
      cB wcel vv cv cF ccnv vx cv cima wceq vx cL wrex wa vu cv vv cv cin c0
      wne vu cv cB wcel vv cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      wcel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vu cv cB wcel vv cv cF ccnv vx cv cima wceq vx
      cL wrex vu cv vv cv cin c0 wne cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vv cv cF ccnv vx cv cima
      wceq vx cL wrex vu cv cB wcel vu cv vv cv cin c0 wne cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vv cv cF ccnv vx cv cima wceq vu cv cB wcel vu cv vv cv cin c0 wne wi vx
      cL cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL
      wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq vu cv cB
      wcel vu cv vv cv cin c0 wne cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx
      cv cima wceq wa vu cv cB wcel wa wa cF vu cv cima vx cv cin c0 wceq wn vu
      cv vv cv cin c0 wne cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa wa cF vu cv cima vx cv cin c0 wceq c0 cL
      wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a c0 cL wcel wn vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss c0 cL wcel wn cX cZ wceq cL cfil wcel cB
      cfbas wcel c0 cL wcel wn cY cX cF wf cL filesn 3ad2ant2 3ad2ant1 adantr
      cF vu cv cima vx cv cin c0 wceq cF vu cv cima vx cv cin cL wcel c0 cL
      wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu
      cv cB wcel wa wa cF vu cv cima vx cv cin c0 cL eleq1 cL cfil wcel cF vu
      cv cima cL wcel vx cv cL wcel cF vu cv cima vx cv cin cL wcel cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      wa cF vu cv cima vx cv cL filint cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cL cfil wcel vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cL cfil wcel cX
      cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp2 3ad2ant1 adantr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel
      wa wa cF cX cB cfilmap co cfv cL cF vu cv cima cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq vx cv cL wcel
      vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa 3simpl2 cX cL wcel cB
      cfbas wcel cY cX cF wf w3a vu cv cB cfg cfv wcel cF vu cv cima cF cX cB
      cfilmap co cfv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv
      cima wceq wa vu cv cB wcel wa wa cL cB vu cv cF cB cfg cfv cX cY fmfnfm.1
      cB cfg cfv eqid imaelfm cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX
      cB cfilmap co cfv cL wss cX cZ wceq w3a cX cL wcel cB cfbas wcel cY cX cF
      wf w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cX cL wcel cB cfbas wcel cY cX cF wf cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cX cZ wceq cX cL wcel cF cX cB cfilmap co cfv cL wss
      cL cfil wcel cB cfbas wcel cX cZ wceq cX cL wcel cY cX cF wf cL cfil wcel
      cX cZ wceq wa cX cZ cL cL cfil wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL
      wcel cX cZ wceq cL cZ fmfnfm.2 filusb adantr eqeltrd 3ad2antl2 3adant2 cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB
      cfbas wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1
      3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cY cX cF wf cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf
      3simp3 3ad2ant1 3jca adantr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF
      cX cB cfilmap co cfv cL wss cX cZ wceq w3a vu cv cB wcel vu cv cB cfg cfv
      wcel vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vu cv
      cB wcel vu cv cB cfg cfv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cB cB cfg cfv vu cv cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB
      cB cfg cfv wss cX cZ wceq cB cfbas wcel cL cfil wcel cB cB cfg cfv wss cY
      cX cF wf cB fbssfg 3ad2ant1 3ad2ant1 sseld imp adantrl sylanc sseldd cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq vu cv cB wcel
      simprll syl3anc syl5cbi mtod cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq wa vu cv cB wcel wa wa vt cv cF vu cv cima vx cv cin wcel
      vt wex vu cv vv cv cin c0 wne cF vu cv cima vx cv cin c0 wceq wn cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      wa vt cv cF vu cv cima vx cv cin wcel vu cv vv cv cin c0 wne vt cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      wa vt cv cF vu cv cima wcel vt cv vx cv wcel wa vu cv vv cv cin c0 wne vt
      cv cF vu cv cima vx cv cin wcel cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa vu cv cB wcel wa wa vt cv cF vu cv cima wcel vt
      cv vx cv wcel vu cv vv cv cin c0 wne cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv
      cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vt cv cF vu cv cima wcel
      vy cv cF cfv vt cv wceq vy vu cv wrex vt cv vx cv wcel vu cv vv cv cin c0
      wne wi cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vt cv cF vu cv cima wcel vy cv cF cfv vt cv wceq vy
      vu cv wrex wi vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB
      wcel wa cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss vt cv cF vu cv cima wcel vy cv cF cfv vt cv wceq vy vu cv wrex
      wi cX cZ wceq cY cX cF wf cB cfbas wcel vt cv cF vu cv cima wcel vy cv cF
      cfv vt cv wceq vy vu cv wrex wi cL cfil wcel cY cX cF wf cF wfun vt cv cF
      vu cv cima wcel vy cv cF cfv vt cv wceq vy vu cv wrex wi cY cX cF ffun cF
      wfun vt cv cF vu cv cima wcel vy cv cF cfv vt cv wceq vy vu cv wrex vy vt
      cv vu cv cF fvelima ex syl 3ad2ant3 3ad2ant1 adantr cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv cF cfv
      vt cv wceq vt cv vx cv wcel vu cv vv cv cin c0 wne wi vy vu cv vy cv cF
      cfv vt cv wceq vy cv cF cfv vx cv wcel vu cv vv cv cin c0 wne wi vt cv vx
      cv wcel vu cv vv cv cin c0 wne wi cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF
      cfv vt cv wceq vy cv cF cfv vx cv wcel vt cv vx cv wcel vu cv vv cv cin
      c0 wne vy cv cF cfv vt cv vx cv eleq1 imbi1d cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL
      wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv
      wcel wa vy cv cF cfv vx cv wcel vy cv vu cv vv cv cin wcel vu cv vv cv
      cin c0 wne cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF cfv vx cv wcel vy cv vu
      cv wcel vy cv vv cv wcel wa vy cv vu cv vv cv cin wcel cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv
      vu cv wcel wa vy cv cF cfv vx cv wcel vy cv vu cv wcel vy cv vv cv wcel
      vy cv vu cv wcel vy cv cF cfv vx cv wcel vy cv vu cv wcel wi cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa
      wa vy cv vu cv wcel vy cv cF cfv vx cv wcel ax-1 adantl cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv
      vu cv wcel wa vy cv cF cfv vx cv wcel vy cv cF ccnv vx cv cima wcel vy cv
      vv cv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cF cfv vx cv wcel vy cv cF
      ccnv vx cv cima wcel cF wfun vy cv cF cdm wcel vy cv cF cfv vx cv wcel vy
      cv cF ccnv vx cv cima wcel wb cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv
      vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv vx cv cF
      fvimacnv cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a cF wfun vx cv cL wcel vv cv cF ccnv vx cv cima
      wceq wa vu cv cB wcel wa vy cv vu cv wcel cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cF wfun cX cZ wceq cY cX cF
      wf cB cfbas wcel cF wfun cL cfil wcel cY cX cF ffun 3ad2ant3 3ad2ant1
      ad2antrr cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa
      vu cv cB wcel wa wa vy cv vu cv wcel wa vy cv cY cF cdm vx cv cL wcel vv
      cv cF ccnv vx cv cima wceq wa vu cv cB wcel wa vy cv vu cv wcel vy cv cY
      wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv
      cL wss cX cZ wceq w3a vu cv cB wcel vy cv vu cv wcel vy cv cY wcel vx cv
      cL wcel vv cv cF ccnv vx cv cima wceq wa vu cv cB wcel vy cv vu cv wcel
      wa vy cv cB cuni cY vy cv vu cv wcel vu cv cB wcel vy cv cB cuni wcel vy
      cv vu cv cB elunii ancoms fmfnfm.1 syl6eleqr adantll adantll cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cF cdm cY wceq vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu
      cv cB wcel wa vy cv vu cv wcel cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cF cdm cY wceq cX cZ wceq cY cX cF wf cB
      cfbas wcel cF cdm cY wceq cL cfil wcel cY cX cF fdm 3ad2ant3 3ad2ant1
      ad2antrr eleqtrrd sylanc biimpd cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx cv cL wcel vv cv cF
      ccnv vx cv cima wceq wa vu cv cB wcel wa wa vy cv vu cv wcel wa vv cv cF
      ccnv vx cv cima vy cv vx cv cL wcel vv cv cF ccnv vx cv cima wceq wa vu
      cv cB wcel wa vv cv cF ccnv vx cv cima wceq cB cfbas wcel cL cfil wcel cY
      cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vy cv vu cv
      wcel vx cv cL wcel vv cv cF ccnv vx cv cima wceq vu cv cB wcel simplr
      ad2antlr eleq2d sylibrd jcad vy cv vu cv vv cv elin syl6ibr vu cv vv cv
      cin vy cv ne0i syl6 syl5cbi r19.23adva syld imp3a vt cv cF vu cv cima vx
      cv elin syl5ib 19.23adv vt cF vu cv cima vx cv cin neq0 syl5ib mpd exp44
      r19.23adv com23 imp3a vv cv vy cv cF ccnv vx cv cima wceq vx cL wrex vy
      cab wcel vv cv cF ccnv vx cv cima wceq vx cL wrex vu cv cB wcel vy cv cF
      ccnv vx cv cima wceq vx cL wrex vv cv cF ccnv vx cv cima wceq vx cL wrex
      vy vv cv vv visset vy cv vv cv wceq vy cv cF ccnv vx cv cima wceq vv cv
      cF ccnv vx cv cima wceq vx cL vy cv vv cv cF ccnv vx cv cima eqeq1
      rexbidv elab anbi2i syl5ib r19.21aivv cB cfbas wcel vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cfbas wcel c0 cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv wnel vu cv vv cv cin c0 wne vv vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab wral vu cB wral wb cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a vu vv cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab fbunfip
      cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss
      cB cfbas wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1
      3ad2ant1 cY cvv wcel cL cfil wcel cY cZ cF wf w3a cF crn cL wcel vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cfbas wcel cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a vx vy
      cvv cF cL cZ cY fmfnfm.2 rnelfmlem cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cvv wcel cL cfil
      wcel cY cZ cF wf cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB
      cfilmap co cfv cL wss cY cvv wcel cX cZ wceq cB cfbas wcel cL cfil wcel
      cY cvv wcel cY cX cF wf cB cfbas wcel cB cuni cvv cY cB cfbas uniexg
      fmfnfm.1 syl5eqel 3ad2ant1 3ad2ant1 cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cF cX cB cfilmap co cfv cL wss cL cfil wcel cX cZ wceq cB cfbas
      wcel cL cfil wcel cY cX cF wf 3simp2 3ad2ant1 cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cX cZ wceq cY cZ cF wf cF cX cB cfilmap co cfv cL wss cY
      cX cF wf cB cfbas wcel cX cZ wceq cY cZ cF wf cL cfil wcel cX cZ wceq cY
      cX cF wf cY cZ cF wf cX cZ cY cF feq3 biimpac 3ad2antl3 3adant2 3jca cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cF cX cB cfilmap co cfv cL cF crn cB cfbas wcel cL cfil wcel
      cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq 3simp2 cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ
      wceq w3a cF cY cima cF crn cF cX cB cfilmap co cfv cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cF cY cima cF crn
      wceq cX cZ wceq cY cX cF wf cB cfbas wcel cF cY cima cF crn wceq cL cfil
      wcel cY cX cF wf cY cF crn cF wfo cF cY cima cF crn wceq cY cX cF wf cF
      cY wfn cY cF crn cF wfo cY cX cF ffn cY cF dffn4 sylib cY cF crn cF foima
      syl 3ad2ant3 3ad2ant1 cX cL wcel cB cfbas wcel cY cX cF wf w3a cY cB cfg
      cfv wcel cF cY cima cF cX cB cfilmap co cfv wcel cB cfbas wcel cL cfil
      wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cL cB
      cY cF cB cfg cfv cX cY fmfnfm.1 cB cfg cfv eqid imaelfm cB cfbas wcel cL
      cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a
      cX cL wcel cB cfbas wcel cY cX cF wf cB cfbas wcel cL cfil wcel cY cX cF
      wf w3a cX cZ wceq cX cL wcel cF cX cB cfilmap co cfv cL wss cL cfil wcel
      cB cfbas wcel cX cZ wceq cX cL wcel cY cX cF wf cL cfil wcel cX cZ wceq
      wa cX cZ cL cL cfil wcel cX cZ wceq pm3.27 cL cfil wcel cZ cL wcel cX cZ
      wceq cL cZ fmfnfm.2 filusb adantr eqeltrd 3ad2antl2 3adant2 cB cfbas wcel
      cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cB cfbas wcel
      cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp1 3ad2ant1 cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cY
      cX cF wf cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp3
      3ad2ant1 3jca cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap
      co cfv cL wss cY cB cfg cfv wcel cX cZ wceq cB cfbas wcel cL cfil wcel cY
      cB cfg cfv wcel cY cX cF wf cB cfbas wcel cY cB cfg cfv cuni cB cfg cfv
      cB cY fmfnfm.1 fgbas cB cfbas wcel cB cfg cfv cfil wcel cB cfg cfv cuni
      cB cfg cfv wcel cB fgfil cB cfg cfv cB cfg cfv cuni cB cfg cfv cuni eqid
      filusb syl eqeltrd 3ad2ant1 3ad2ant1 sylanc eqeltrrd sseldd sylanc sylanc
      mpbird jca cB cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co
      cfv cL wss cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cfbas wcel cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun c0 wne
      c0 cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wnel wa
      wb cX cZ wceq cB cfbas wcel cL cfil wcel cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun cfi cfv cfbas wcel cB vy cv cF ccnv vx cv cima wceq
      vx cL wrex vy cab cun c0 wne c0 cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv wnel wa wb cY cX cF wf cB cfbas wcel cL cfil wcel
      wa cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cfbas wcel cB vy
      cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun c0 wne c0 cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv wnel wa wb cB cfbas
      wcel vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cvv wcel cB vy cv cF
      ccnv vx cv cima wceq vx cL wrex vy cab cun cvv wcel cL cfil wcel cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cfbas cvv unexg vx vy cL cF
      ccnv vx cv cima cfil abrexexg sylan2 cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cvv fsubbas syl 3adant3 3ad2ant1 mpbird adantr cB
      cfbas wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cX
      cZ wceq w3a cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi
      cfv cuni wceq wa cY cX cF wf cB vy cv cF ccnv vx cv cima wceq vx cL wrex
      vy cab cun cfi cfv cuni cX cF wf cB cfbas wcel cL cfil wcel cY cX cF wf
      w3a cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cX cF wf cY cB vy cv
      cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv cuni wceq cB cfbas
      wcel cL cfil wcel cY cX cF wf w3a cF cX cB cfilmap co cfv cL wss cY cX cF
      wf cX cZ wceq cB cfbas wcel cL cfil wcel cY cX cF wf 3simp3 3ad2ant1
      adantr cY cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab cun cfi cfv
      cuni wceq cY cX cF wf cB vy cv cF ccnv vx cv cima wceq vx cL wrex vy cab
      cun cfi cfv cuni cX cF wf wb cB cfbas wcel cL cfil wcel cY cX cF wf w3a
      cF cX cB cfilmap co cfv cL wss cX cZ wceq w3a cY cB vy cv cF ccnv vx cv
      cima wceq vx cL wrex vy cab cun cfi cfv cuni cX cF feq2 adantl mpbid
      syl3anc bitr4d eqrdv ex jcai jca cB cB vy cv cF ccnv vx cv cima wceq vx
      cL wrex vy cab cun cfi cfv wss cY cB vy cv cF ccnv vx cv cima wceq vx cL
      wrex vy cab cun cfi cfv cuni wceq cL cF cX cB vy cv cF ccnv vx cv cima
      wceq vx cL wrex vy cab cun cfi cfv cfilmap co cfv wceq 3anass sylibr
      3com12d sylanc $.
      $( [19-Nov-2009] $) $( [13-Nov-2009] $)
  $}

  ${
    $d b f A $. $d b f F $. $d b f L $. $d b f X $. $d b f Y $.
    fmufil.1 $e |- Y = U. L $.
    $( An image filter of an ultrafilter is an ultrafilter. $)
    fmufil $p |- ( ( X e. A /\ L e. UFil /\ F : Y --> X ) -> ( ( X FilMap L ) `
    F ) e. UFil ) $=
      cX cA wcel cL cufil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cfil
      wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv
      vf cv wss wa cF cX cL cfilmap co cfv vf cv wceq wi vf cfil wral wa cF cX
      cL cfilmap co cfv cufil wcel cX cA wcel cL cufil wcel cY cX cF wf w3a cF
      cX cL cfilmap co cfv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni
      wceq cF cX cL cfilmap co cfv vf cv wss wa cF cX cL cfilmap co cfv vf cv
      wceq wi vf cfil wral cX cA wcel cL cfbas wcel cY cX cF wf cF cX cL
      cfilmap co cfv cfil wcel cL cufil wcel cA cL cF cX cY fmufil.1 fmf cL
      cufil wcel cL cfil wcel cL cfbas wcel cL ufilfil cL filfbas syl syl3an2
      cX cA wcel cL cufil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cuni vf
      cv cuni wceq cF cX cL cfilmap co cfv vf cv wss wa cF cX cL cfilmap co cfv
      vf cv wceq wi vf cfil cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil
      wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv
      vf cv wss cF cX cL cfilmap co cfv vf cv wceq cX cA wcel cL cufil wcel cY
      cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq
      cF cX cL cfilmap co cfv vf cv wss cF cX cL cfilmap co cfv vf cv wceq cX
      cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co
      cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a wa cY vb
      cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a vb
      cfbas wrex cF cX cL cfilmap co cfv vf cv wceq cL cfbas wcel vf cv cfil
      wcel cY cX cF wf w3a cF cX cL cfilmap co cfv vf cv wss cX vf cv cuni wceq
      cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a
      vb cfbas wrex cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF
      cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv
      wss w3a wa cL cF vf cv cX cY vf cv cuni vb fmufil.1 vf cv cuni eqid
      fmfnfm cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL
      cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a
      wa cL cfbas wcel vf cv cfil wcel cY cX cF wf cX cA wcel cL cufil wcel cY
      cX cF wf w3a cL cfbas wcel vf cv cfil wcel cF cX cL cfilmap co cfv cuni
      vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a cL cufil wcel cX cA
      wcel cL cfbas wcel cY cX cF wf cL cufil wcel cL cfil wcel cL cfbas wcel
      cL ufilfil cL filfbas syl 3ad2ant2 adantr cX cA wcel cL cufil wcel cY cX
      cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF
      cX cL cfilmap co cfv vf cv wss 3simpr1 cX cA wcel cL cufil wcel cY cX cF
      wf vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a 3simpl3 3jca cX cA wcel cL cufil wcel cY cX
      cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF
      cX cL cfilmap co cfv vf cv wss 3simpr3 cX cA wcel cL cufil wcel cY cX cF
      wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX
      cL cfilmap co cfv vf cv wss w3a wa cF cX cL cfilmap co cfv cuni cX vf cv
      cuni cX cA wcel cL cfbas wcel cY cX cF wf cF cX cL cfilmap co cfv cuni cX
      wceq cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL
      cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a
      wa cA cL cF cX cY fmufil.1 fmbas cX cA wcel cL cufil wcel cY cX cF wf vf
      cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a 3simpl1 cX cA wcel cL cufil wcel cY cX cF wf
      w3a cL cfbas wcel vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni
      wceq cF cX cL cfilmap co cfv vf cv wss w3a cL cufil wcel cX cA wcel cL
      cfbas wcel cY cX cF wf cL cufil wcel cL cfil wcel cL cfbas wcel cL
      ufilfil cL filfbas syl 3ad2ant2 adantr cX cA wcel cL cufil wcel cY cX cF
      wf vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a 3simpl3 syl3anc cX cA wcel cL cufil wcel cY
      cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq
      cF cX cL cfilmap co cfv vf cv wss 3simpr2 eqtr3d syl3anc cX cA wcel cL
      cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni
      vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a wa cY vb cv cuni
      wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a cF cX cL
      cfilmap co cfv vf cv wceq vb cfbas cX cA wcel cL cufil wcel cY cX cF wf
      w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb
      cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a cF cX cL cfilmap co cfv
      vf cv wceq cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX
      cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss
      w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv
      cfilmap co cfv wceq w3a wa wa cF cX vb cv cfilmap co cfv cF cX vb cv cfg
      cfv cfilmap co cfv vf cv cF cX cL cfilmap co cfv cX cA wcel vb cv cfbas
      wcel vb cv cuni cX cF wf cF cX vb cv cfilmap co cfv cF cX vb cv cfg cfv
      cfilmap co cfv wceq cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil
      wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv
      vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv
      cF cX vb cv cfilmap co cfv wceq w3a wa wa vb cv cA cF vb cv cfg cfv cX vb
      cv cuni vb cv cuni eqid vb cv cfg cfv eqid fbfgfmeq cX cA wcel cL cufil
      wcel cY cX cF wf w3a cX cA wcel vf cv cfil wcel cF cX cL cfilmap co cfv
      cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a vb cv cfbas
      wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv
      wceq w3a wa cX cA wcel cL cufil wcel cY cX cF wf 3simp1 ad2antrr cX cA
      wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co
      cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a wa vb cv
      cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co
      cfv wceq w3a simprl cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil
      wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv
      vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv
      cF cX vb cv cfilmap co cfv wceq w3a wa wa cY cX cF wf vb cv cuni cX cF wf
      cX cA wcel cL cufil wcel cY cX cF wf w3a cY cX cF wf vf cv cfil wcel cF
      cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv
      wss w3a vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb
      cv cfilmap co cfv wceq w3a wa cX cA wcel cL cufil wcel cY cX cF wf 3simp3
      ad2antrr cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX
      cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss
      w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv
      cfilmap co cfv wceq w3a wa wa cY vb cv cuni wceq cY cX cF wf vb cv cuni
      cX cF wf wb cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co
      cfv wceq w3a cY vb cv cuni wceq cX cA wcel cL cufil wcel cY cX cF wf w3a
      vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb
      cv wss vf cv cF cX vb cv cfilmap co cfv wceq 3simp1 ad2antll cY vb cv
      cuni cX cF feq2 syl mpbid syl3anc cY vb cv cuni wceq cL vb cv wss vf cv
      cF cX vb cv cfilmap co cfv wceq w3a vf cv cF cX vb cv cfilmap co cfv wceq
      cX cA wcel cL cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap
      co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a wa vb
      cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap
      co cfv wceq 3simp3 ad2antll cX cA wcel cL cufil wcel cY cX cF wf w3a vf
      cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb
      cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a wa wa cF cX cL cfilmap
      co cX vb cv cfg cfv cfilmap co cX cA wcel cL cufil wcel cY cX cF wf w3a
      vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb
      cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a wa wa cL vb cv cfg cfv
      cX cfilmap cL cufil wcel vb cv cfg cfv cfil wcel cY vb cv cfg cfv cuni
      wceq cL vb cv cfg cfv wss cL vb cv cfg cfv wceq cX cA wcel cL cufil wcel
      cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni
      wceq cF cX cL cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel cY vb cv
      cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a wa wa cL
      vb cv cfg cfv cY vb cv cfg cfv cuni fmufil.1 vb cv cfg cfv cuni eqid
      ufilmax cX cA wcel cL cufil wcel cY cX cF wf w3a cL cufil wcel vf cv cfil
      wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL cfilmap co cfv
      vf cv wss w3a vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF
      cX vb cv cfilmap co cfv wceq w3a wa cX cA wcel cL cufil wcel cY cX cF wf
      3simp2 ad2antrr vb cv cfbas wcel vb cv cfg cfv cfil wcel cX cA wcel cL
      cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni
      vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a wa cY vb cv cuni
      wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv wceq w3a vb cv fgfil
      ad2antrl vb cv cfbas wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb
      cv cfilmap co cfv wceq w3a wa cY vb cv cfg cfv cuni wceq cX cA wcel cL
      cufil wcel cY cX cF wf w3a vf cv cfil wcel cF cX cL cfilmap co cfv cuni
      vf cv cuni wceq cF cX cL cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel
      cL vb cv wss cY vb cv cuni wceq cY vb cv cfg cfv cuni wceq vf cv cF cX vb
      cv cfilmap co cfv wceq vb cv cfbas wcel cY vb cv cuni wceq wa cY vb cv
      cuni vb cv cfg cfv cuni vb cv cfbas wcel cY vb cv cuni wceq pm3.27 vb cv
      cfbas wcel vb cv cuni vb cv cfg cfv cuni wceq cY vb cv cuni wceq vb cv vb
      cv cuni vb cv cuni eqid fgbas adantr eqtrd 3ad2antr1 adantl vb cv cfbas
      wcel cY vb cv cuni wceq cL vb cv wss vf cv cF cX vb cv cfilmap co cfv
      wceq w3a wa cL vb cv cfg cfv wss cX cA wcel cL cufil wcel cY cX cF wf w3a
      vf cv cfil wcel cF cX cL cfilmap co cfv cuni vf cv cuni wceq cF cX cL
      cfilmap co cfv vf cv wss w3a wa vb cv cfbas wcel cY vb cv cuni wceq cL vb
      cv wss cL vb cv cfg cfv wss vf cv cF cX vb cv cfilmap co cfv wceq vb cv
      cfbas wcel cL vb cv wss wa cL vb cv vb cv cfg cfv vb cv cfbas wcel cL vb
      cv wss pm3.27 vb cv cfbas wcel vb cv vb cv cfg cfv wss cL vb cv wss vb cv
      fbssfg adantr sstrd 3ad2antr2 adantl syl2anc opreq2d fveq1d 3eqtr4rd
      exp32 r19.23adv mpd 3exp2 imp4a r19.21aiv jca vf cF cX cL cfilmap co cfv
      cF cX cL cfilmap co cfv cuni cF cX cL cfilmap co cfv cuni eqid isufil2
      sylibr $.
      $( [11-Dec-2009] $) $( [11-Dec-2009] $)
  $}

  ${
    $d s t F $. $d s t X $.
    filfm.1 $e |- X = U. F $.
    $( A filter can be expressed as an image filter. $)
    filfm $p |- ( F e. Fil -> F = ( ( X FilMap F ) ` ( _I |` X ) ) ) $=
      cF cfil wcel vt cF cid cX cres cX cF cfilmap co cfv cF cfil wcel vt cv
      cid cX cres vs cv cima wceq vs cF cfg cfv wrex vt cv cid cX cres vs cv
      cima wceq vs cF wrex vt cv cid cX cres cX cF cfilmap co cfv wcel vt cv cF
      wcel cF cfil wcel vt cv cid cX cres vs cv cima wceq vs cF cfg cfv cF cF
      fgid rexeq1d cF cfbas wcel cX cX cid cX cres wfo vt cv cid cX cres cX cF
      cfilmap co cfv wcel vt cv cid cX cres vs cv cima wceq vs cF cfg cfv wrex
      wb cF cfil wcel vs vt cv cF cid cX cres cF cfg cfv cX cX filfm.1 cF cfg
      cfv eqid elfilmap3 cF filfbas cX cX cid cX cres wfo cF cfil wcel cX cX
      cid cX cres wf1o cX cX cid cX cres wfo cX f1oi cX cX cid cX cres f1ofo
      ax-mp a1i sylanc cF cfil wcel vt cv cF wcel vt cv cid cX cres vs cv cima
      wceq vs cF wrex cF cfil wcel vt cv cF wcel vt cv cid cX cres vs cv cima
      wceq vs cF wrex vt cv cF wcel vt cv cid cX cres vt cv cima wceq vt cv cid
      cX cres vs cv cima wceq vs cF wrex cF cfil wcel vt cv cF wcel wa vt cv
      cid cX cres vs cv cima wceq vt cv cid cX cres vt cv cima wceq vs vt cv cF
      vs cv vt cv wceq cid cX cres vs cv cima cid cX cres vt cv cima vt cv vs
      cv vt cv cid cX cres imaeq2 eqeq2d rcla4ev cF cfil wcel vt cv cF wcel
      pm3.27 cF cfil wcel vt cv cF wcel wa cid cX cres vt cv cima vt cv vt cv
      cF wcel cid cX cres vt cv cima vt cv wceq cF cfil wcel vt cv cF wcel vt
      cv cX wss cid cX cres vt cv cima vt cv wceq vt cv cF wcel vt cv cF cuni
      cX vt cv cF elssuni filfm.1 syl6ssr cX vt cv resiima syl adantl eqcomd
      sylanc ex cF cfil wcel vt cv cid cX cres vs cv cima wceq vt cv cF wcel vs
      cF cF cfil wcel vs cv cF wcel vt cv cid cX cres vs cv cima wceq vt cv cF
      wcel cF cfil wcel vs cv cF wcel vt cv cid cX cres vs cv cima wceq w3a vt
      cv vs cv cF cF cfil wcel vs cv cF wcel vt cv cid cX cres vs cv cima wceq
      w3a vt cv cid cX cres vs cv cima vs cv cF cfil wcel vs cv cF wcel vt cv
      cid cX cres vs cv cima wceq 3simp3 vs cv cF wcel cF cfil wcel cid cX cres
      vs cv cima vs cv wceq vt cv cid cX cres vs cv cima wceq vs cv cF wcel vs
      cv cX wss cid cX cres vs cv cima vs cv wceq vs cv cF wcel vs cv cF cuni
      cX vs cv cF elssuni filfm.1 syl6ssr cX vs cv resiima syl 3ad2ant2 eqtrd
      cF cfil wcel vs cv cF wcel vt cv cid cX cres vs cv cima wceq 3simp2
      eqeltrd 3exp r19.23adv impbid 3bitr4rd eqrdv $.
      $( [8-Nov-2009] $) $( [8-Nov-2009] $)
  $}

  ${
    $d o s t A $. $d o s t B $. $d o s t F $. $d o s t J $. $d o s t L $. $d o
    s t X $. $d o s t Y $.
    flimfbas.1 $e |- X = U. J $.
    flimfbas.2 $e |- Y = U. B $.
    flimfbas.3 $e |- L = ( filGen ` B ) $.
    $( Limit points of a function can be defined using filter bases. $)
    flimfbas $p |- ( ( ( J e. Top /\ B e. fBas /\ F : Y --> X ) /\ A e. X ) ->
    ( A e. ( ( J fLimf L ) ` F ) <-> A. o e. J ( A e. o -> E. s e. B ( F " s )
    C_ o ) ) ) $=
      cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cX wcel wa cA cF cJ cL
      cflimf co cfv wcel cA cX wcel cA vo cv wcel cF vt cv cima vo cv wss vt cL
      wrex wi vo cJ wral wa cA vo cv wcel cF vt cv cima vo cv wss vt cL wrex wi
      vo cJ wral cA vo cv wcel cF vs cv cima vo cv wss vs cB wrex wi vo cJ wral
      cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cF cJ cL cflimf co cfv wcel
      cA cX wcel cA vo cv wcel cF vt cv cima vo cv wss vt cL wrex wi vo cJ wral
      wa wb cA cX wcel cJ ctop wcel cL cfil wcel cB cfg cfv cuni cX cF wf cA cF
      cJ cL cflimf co cfv wcel cA cX wcel cA vo cv wcel cF vt cv cima vo cv wss
      vt cL wrex wi vo cJ wral wa wb cJ ctop wcel cB cfbas wcel cY cX cF wf w3a
      cA vo cF cJ cL cX cB cfg cfv cuni vt flimfbas.1 cB cfg cfv cL cL cB cfg
      cfv flimfbas.3 eqcomi unieqi isflimf cJ ctop wcel cB cfbas wcel cY cX cF
      wf 3simp1 cB cfbas wcel cJ ctop wcel cL cfil wcel cY cX cF wf cB cfbas
      wcel cB cfg cfv cfil cL cB fgfil flimfbas.3 syl5eqel 3ad2ant2 cJ ctop
      wcel cB cfbas wcel cY cX cF wf cB cfg cfv cuni cX cF wf cJ ctop wcel cB
      cfbas wcel wa cY cB cfg cfv cuni wceq cY cX cF wf cB cfg cfv cuni cX cF
      wf wb cB cfbas wcel cY cB cfg cfv cuni wceq cJ ctop wcel cB cY flimfbas.2
      fgbas adantl cY cB cfg cfv cuni cX cF feq2 syl biimp3a syl3anc adantr cA
      cX wcel cA vo cv wcel cF vt cv cima vo cv wss vt cL wrex wi vo cJ wral cA
      cX wcel cA vo cv wcel cF vt cv cima vo cv wss vt cL wrex wi vo cJ wral wa
      wb cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cX wcel cA vo cv wcel cF
      vt cv cima vo cv wss vt cL wrex wi vo cJ wral ibar adantl cJ ctop wcel cB
      cfbas wcel cY cX cF wf w3a cA cX wcel wa cA vo cv wcel cF vt cv cima vo
      cv wss vt cL wrex wi cA vo cv wcel cF vs cv cima vo cv wss vs cB wrex wi
      vo cJ cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cX wcel wa cF vt cv
      cima vo cv wss vt cL wrex cF vs cv cima vo cv wss vs cB wrex cA vo cv
      wcel cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cX wcel wa cF vt cv
      cima vo cv wss vt cL wrex cF vs cv cima vo cv wss vs cB wrex cJ ctop wcel
      cB cfbas wcel cY cX cF wf w3a cA cX wcel wa cF vt cv cima vo cv wss cF vs
      cv cima vo cv wss vs cB wrex vt cL cJ ctop wcel cB cfbas wcel cY cX cF wf
      w3a cA cX wcel wa vt cv cB cfg cfv wcel cF vt cv cima vo cv wss cF vs cv
      cima vo cv wss vs cB wrex wi vt cv cL wcel cJ ctop wcel cB cfbas wcel cY
      cX cF wf w3a vt cv cB cfg cfv wcel cF vt cv cima vo cv wss cF vs cv cima
      vo cv wss vs cB wrex wi wi cA cX wcel cJ ctop wcel cB cfbas wcel cY cX cF
      wf w3a vt cv cB cfg cfv wcel vt cv cY wss vs cv vt cv wss vs cB wrex wa
      cF vt cv cima vo cv wss cF vs cv cima vo cv wss vs cB wrex wi cB cfbas
      wcel cJ ctop wcel vt cv cB cfg cfv wcel vt cv cY wss vs cv vt cv wss vs
      cB wrex wa wb cY cX cF wf vs vt cv cB cY flimfbas.2 elfg 3ad2ant2 cJ ctop
      wcel cB cfbas wcel cY cX cF wf w3a vs cv vt cv wss vs cB wrex cF vt cv
      cima vo cv wss cF vs cv cima vo cv wss vs cB wrex wi vt cv cY wss cJ ctop
      wcel cB cfbas wcel cY cX cF wf w3a cF vt cv cima vo cv wss vs cv vt cv
      wss vs cB wrex cF vs cv cima vo cv wss vs cB wrex cJ ctop wcel cB cfbas
      wcel cY cX cF wf w3a cF vt cv cima vo cv wss vs cv vt cv wss vs cB wrex
      cF vs cv cima vo cv wss vs cB wrex wi cJ ctop wcel cB cfbas wcel cY cX cF
      wf w3a cF vt cv cima vo cv wss wa vs cv vt cv wss cF vs cv cima vo cv wss
      vs cB cF vt cv cima vo cv wss vs cv vt cv wss cF vs cv cima vo cv wss wi
      cJ ctop wcel cB cfbas wcel cY cX cF wf w3a vs cv vt cv wss cF vt cv cima
      vo cv wss cF vs cv cima vo cv wss vs cv vt cv wss cF vs cv cima cF vt cv
      cima wss cF vt cv cima vo cv wss cF vs cv cima vo cv wss wi vs cv vt cv
      cF imass2 cF vs cv cima cF vt cv cima vo cv sstr2 syl com12 adantl
      r19.22sdv ex com23 adantld sylbid adantr cL cB cfg cfv vt cv flimfbas.3
      eleq2i syl5ib r19.23adv cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cX
      wcel wa cF vs cv cima vo cv wss cF vt cv cima vo cv wss vt cL wrex vs cB
      cJ ctop wcel cB cfbas wcel cY cX cF wf w3a cA cX wcel wa vs cv cB wcel cF
      vs cv cima vo cv wss cF vt cv cima vo cv wss vt cL wrex vs cv cL wcel cF
      vs cv cima vo cv wss cF vt cv cima vo cv wss vt cL wrex cJ ctop wcel cB
      cfbas wcel cY cX cF wf w3a cA cX wcel wa vs cv cB wcel cF vs cv cima vo
      cv wss wa wa cF vt cv cima vo cv wss cF vs cv cima vo cv wss vt vs cv cL
      vt cv vs cv wceq cF vt cv cima cF vs cv cima vo cv vt cv vs cv cF imaeq2
      sseq1d rcla4ev cJ ctop wcel cB cfbas wcel cY cX cF wf w3a vs cv cB wcel
      vs cv cL wcel cA cX wcel cF vs cv cima vo cv wss cB cfbas wcel cJ ctop
      wcel vs cv cB wcel vs cv cL wcel cY cX cF wf cB cfbas wcel vs cv cB wcel
      vs cv cL wcel cB cfbas wcel cB cL vs cv cB cfbas wcel cB cB cfg cfv cL cB
      fbssfg flimfbas.3 syl6ssr sseld imp 3ad2antl2 ad2ant2r cJ ctop wcel cB
      cfbas wcel cY cX cF wf w3a cA cX wcel wa vs cv cB wcel cF vs cv cima vo
      cv wss simprr sylanc exp32 r19.23adv impbid imbi2d ralbidv 3bitr2d $.
      $( [9-Nov-2009] $) $( [9-Nov-2009] $)
  $}

  ${
    $d f s x A $. $d f s x F $. $d f s x J $. $d f s x K $. $d f s x X $. $d f
    s x Y $.
    flimfcnp.1 $e |- X = U. J $.
    flimfcnp.2 $e |- Y = U. K $.
    $( Continuity of a function at a point in terms of its limits. $)
    flimfcnp $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X ) -> (
    F e. ( ( J CnP K ) ` A ) <-> A. f e. Fil ( ( X = U. f /\ A e. ( ( fLim1 ` J
    ) ` f ) ) -> ( F ` A ) e. ( ( K fLimf f ) ` F ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp
      co cfv wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa cA cF
      cfv vx cv cF vs cv cima wceq vs vf cv wrex vx cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel wi vf cfil wral cX vf cv cuni wceq cA vf cv cJ cflim1
      cfv cfv wcel wa cA cF cfv cF cK vf cv cflimf co cfv wcel wi vf cfil wral
      vx vs cA vf cF cJ cK vx cv cF vs cv cima wceq vs vf cv wrex vx cab cY csn
      cun cfg cfv cX cY flimfcnp.1 flimfcnp.2 vx cv cF vs cv cima wceq vs vf cv
      wrex vx cab cY csn cun cfg cfv eqid cnpfillim cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cflim1 cfv
      cfv wcel wa cA cF cfv vx cv cF vs cv cima wceq vs vf cv wrex vx cab cY
      csn cun cfg cfv cK cflim1 cfv cfv wcel wi cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa cA cF cfv cF cK vf cv cflimf co cfv wcel wi vf
      cfil cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil
      wcel wa cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa cA cF cfv
      vx cv cF vs cv cima wceq vs vf cv wrex vx cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel cA cF cfv cF cK vf cv cflimf co cfv wcel cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel wa cX vf cv
      cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa vx cv cF vs cv cima wceq
      vs vf cv wrex vx cab cY csn cun cfg cfv cK cflim1 cfv cfv cF cK vf cv
      cflimf co cfv cA cF cfv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vf cv cfil wcel wa cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa wa cF cK vf cv cflimf co cfv cF cY vf cv cfilmap co cfv cK cflim1
      cfv cfv vx cv cF vs cv cima wceq vs vf cv wrex vx cab cY csn cun cfg cfv
      cK cflim1 cfv cfv cK ctop wcel vf cv cfil wcel vf cv cuni cY cF wf cF cK
      vf cv cflimf co cfv cF cY vf cv cfilmap co cfv cK cflim1 cfv cfv wceq cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vf cv cfil wcel wa
      cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa wa cF cK vf cv cY
      vf cv cuni flimfcnp.2 vf cv cuni eqid sflimf cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cK ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq cA vf cv cJ cflim1 cfv cfv wcel wa cJ ctop wcel cK ctop wcel cX cY
      cF wf cA cX wcel 3simpl2 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1
      cfv cfv wcel wa simplr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cX vf cv cuni wceq vf cv cuni cY cF wf vf cv cfil wcel cA vf cv
      cJ cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv
      cuni wceq vf cv cuni cY cF wf cA cX wcel cX cY cF wf cJ ctop wcel cX vf
      cv cuni wceq vf cv cuni cY cF wf cK ctop wcel cX vf cv cuni wceq cX cY cF
      wf vf cv cuni cY cF wf cX vf cv cuni cY cF feq2 biimpac 3ad2antl3 adantlr
      ad2ant2r syl3anc cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      vf cv cfil wcel wa cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa
      wa cF cY vf cv cfilmap co cfv vx cv cF vs cv cima wceq vs vf cv wrex vx
      cab cY csn cun cfg cfv cK cflim1 cfv cY cvv wcel vf cv cfbas wcel vf cv
      cuni cY cF wf cF cY vf cv cfilmap co cfv vx cv cF vs cv cima wceq vs vf
      cv wrex vx cab cY csn cun cfg cfv wceq cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vf cv cfil wcel wa cX vf cv cuni wceq cA vf cv cJ
      cflim1 cfv cfv wcel wa wa vx vs cvv vf cv cF cY vf cv cuni vf cv cuni
      eqid isfilmap cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cY
      cvv wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv
      wcel wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv wcel cA cX wcel
      cK ctop wcel cJ ctop wcel cY cvv wcel cX cY cF wf cK ctop wcel cK cuni
      cvv cY cK ctop uniexg flimfcnp.2 syl5eqel 3ad2ant2 adantr ad2antrr vf cv
      cfil wcel vf cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa cX vf cv cuni wceq cA vf cv cJ cflim1 cfv cfv wcel wa vf cv
      filfbas ad2antlr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cX vf cv cuni wceq vf cv cuni cY cF wf vf cv cfil wcel cA vf cv cJ cflim1
      cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv cuni wceq
      vf cv cuni cY cF wf cA cX wcel cX cY cF wf cJ ctop wcel cX vf cv cuni
      wceq vf cv cuni cY cF wf cK ctop wcel cX vf cv cuni wceq cX cY cF wf vf
      cv cuni cY cF wf cX vf cv cuni cY cF feq2 biimpac 3ad2antl3 adantlr
      ad2ant2r syl3anc fveq2d eqtr2d eleq2d pm5.74da ralbidva bitrd $.
      $( [21-Nov-2009] $) $( [21-Nov-2009] $)

    $( Continuity of a function in terms of filter limits of a function. $)
    flimfcn $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) -> ( F e. ( J Cn K
    ) <-> A. f e. Fil ( X = U. f -> A. x e. X ( x e. ( ( fLim1 ` J ) ` f ) -> (
    F ` x ) e. ( ( K fLimf f ) ` F ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cF vx cv
      cJ cK ccnp co cfv wcel vx cX wral cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel vx cv cF cfv cF cK vf cv cflimf co cfv wcel wi vx cX
      wral wi vf cfil wral vx cF cJ cK cX cY flimfcnp.1 flimfcnp.2 cncnp cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cF vx cv cJ cK ccnp co cfv wcel vx
      cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel wa vx cv cF
      cfv cF cK vf cv cflimf co cfv wcel wi vf cfil wral vx cX wral cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cF cK vf cv
      cflimf co cfv wcel wi vx cX wral wi vf cfil wral cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cF vx cv cJ cK ccnp co cfv wcel cX vf cv cuni wceq
      vx cv vf cv cJ cflim1 cfv cfv wcel wa vx cv cF cfv cF cK vf cv cflimf co
      cfv wcel wi vf cfil wral vx cX vx cv vf cF cJ cK cX cY flimfcnp.1
      flimfcnp.2 flimfcnp ralbidva cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv
      cfv wcel wa vx cv cF cfv cF cK vf cv cflimf co cfv wcel wi vf cfil wral
      vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel wa vx cv
      cF cfv cF cK vf cv cflimf co cfv wcel wi vx cX wral vf cfil wral cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cF cK vf cv
      cflimf co cfv wcel wi vx cX wral wi vf cfil wral cX vf cv cuni wceq vx cv
      vf cv cJ cflim1 cfv cfv wcel wa vx cv cF cfv cF cK vf cv cflimf co cfv
      wcel wi vx vf cX cfil ralcom cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv
      cfv wcel wa vx cv cF cfv cF cK vf cv cflimf co cfv wcel wi vx cX wral cX
      vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cF cK vf
      cv cflimf co cfv wcel wi vx cX wral wi vf cfil cX vf cv cuni wceq vx cv
      vf cv cJ cflim1 cfv cfv wcel wa vx cv cF cfv cF cK vf cv cflimf co cfv
      wcel wi vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel
      vx cv cF cfv cF cK vf cv cflimf co cfv wcel wi wi vx cX wral cX vf cv
      cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cF cK vf cv
      cflimf co cfv wcel wi vx cX wral wi cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel wa vx cv cF cfv cF cK vf cv cflimf co cfv wcel wi cX
      vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv cF cK vf
      cv cflimf co cfv wcel wi wi vx cX cX vf cv cuni wceq vx cv vf cv cJ
      cflim1 cfv cfv wcel vx cv cF cfv cF cK vf cv cflimf co cfv wcel impexp
      ralbii cX vf cv cuni wceq vx cv vf cv cJ cflim1 cfv cfv wcel vx cv cF cfv
      cF cK vf cv cflimf co cfv wcel wi vx cX r19.21v bitri ralbii bitri syl6bb
      bitrd $.
      $( [23-Nov-2009] $) $( [23-Nov-2009] $)
  $}

  ${
    $d a b t x y z w J $. $d a b x y z w X $.
    sfcls.1 $e |- X = U. J $.
    $( Given a topology, produce a function giving cluster points for that
       topology. $)
    sfcls $p |- ( J e. Top -> ( fClus ` J ) = { <. a , b >. | ( a e. Fil /\ U.
    a = X /\ b = |^|_ t e. a ( ( cls ` J ) ` t ) ) } ) $=
      cJ ctop wcel cJ vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv
      cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb
      copab wceq wa vx vy copab cfv va cv cfil wcel va cv cuni cX wceq vb cv vt
      va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cJ cfclus cfv va cv
      cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq w3a va vb copab cvv wcel vx cv ctop wcel vy cv va cv cfil wcel va cv
      cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a
      va vb copab wceq wa vx vy copab wfun wa cJ va cv cfil wcel va cv cuni cX
      wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cop vx
      cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va
      cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab wceq wa vx vy copab
      wcel cJ vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv cuni wceq
      vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab wceq wa
      vx vy copab cfv va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv
      cJ ccl cfv cfv ciin wceq w3a va vb copab wceq cJ ctop wcel cJ va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab cvv vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv
      cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb
      copab wceq wa vx vy copab funopfvg cJ ctop wcel va cv cfil wcel va cv
      cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab cvv wcel vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv
      cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb
      copab wceq wa vx vy copab wfun va cv cfil wcel va cv cuni cX wceq vb cv
      vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab wfun va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab cdm cvv wcel va cv cfil wcel va cv cuni cX wceq vb cv vt va
      cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cvv wcel cJ ctop wcel
      cvv va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a va vb copab funex va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab wfun cJ ctop
      wcel va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a va vb copab vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq va vb copab wss vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq va vb
      copab wfun va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl
      cfv cfv ciin wceq w3a va vb copab wfun va cv cfil wcel va cv cuni cX wceq
      vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq va vb va cv cfil wcel va cv cuni cX wceq vb cv vt
      va cv vt cv cJ ccl cfv cfv ciin wceq 3simp3 ssopab2i va vb vt va cv vt cv
      cJ ccl cfv cfv ciin funopabeq va cv cfil wcel va cv cuni cX wceq vb cv vt
      va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab vb cv vt va cv vt cv
      cJ ccl cfv cfv ciin wceq va vb copab funss mp2 a1i va cv cfil wcel va cv
      cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab cdm cX cpw cpw wss cX cpw cpw cvv wcel va cv cfil wcel va cv cuni
      cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cdm
      cvv wcel cJ ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv vt va cv
      vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cdm cX cpw cpw cvv ssexg
      cJ ctop wcel vz va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv
      cJ ccl cfv cfv ciin wceq w3a va vb copab cdm cX cpw cpw cJ ctop wcel vz
      cv vw cv cop va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq w3a va vb copab wcel vw wex vz cv cX cpw cpw wcel
      vz cv va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a va vb copab cdm wcel cJ ctop wcel vz cv vw cv cop va cv
      cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq w3a va vb copab wcel vz cv cX cpw cpw wcel vw cJ ctop wcel vz cv
      cfil wcel vz cv cuni cX wceq vw cv vt vz cv vt cv cJ ccl cfv cfv ciin
      wceq w3a vz cv cX cpw cpw wcel vz cv vw cv cop va cv cfil wcel va cv cuni
      cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab
      wcel vz cv cfil wcel vz cv cuni cX wceq vw cv vt vz cv vt cv cJ ccl cfv
      cfv ciin wceq w3a vz cv cX cpw cpw wcel wi cJ ctop wcel vz cv cuni cX
      wceq vz cv cfil wcel vz cv cX cpw cpw wcel vw cv vt vz cv vt cv cJ ccl
      cfv cfv ciin wceq vz cv cuni cX wceq vz cv cX cpw wss vz cv cX cpw cpw
      wcel vz cv cuni cX wceq vz cv cuni cX wss vz cv cuni cpw cX cpw wss vz cv
      cX cpw wss vz cv cuni cX eqimss vz cv cuni cX wss vz cv cuni cpw cX cpw
      wss vz cv cuni cX sspwb biimpi vz cv vz cv cuni cpw wss vz cv cuni cpw cX
      cpw wss vz cv cX cpw wss wi vz cv pwuni vz cv vz cv cuni cpw cX cpw sstr2
      ax-mp 3syl vz cv cX cpw vz visset elpw sylibr 3ad2ant2 a1i va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      vz cv cfil wcel vz cv cuni cX wceq vb cv vt vz cv vt cv cJ ccl cfv cfv
      ciin wceq w3a vz cv cfil wcel vz cv cuni cX wceq vw cv vt vz cv vt cv cJ
      ccl cfv cfv ciin wceq w3a va vb vz cv vw cv vz visset vw visset va cv vz
      cv wceq va cv cfil wcel vz cv cfil wcel va cv cuni cX wceq vz cv cuni cX
      wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq vb cv vt vz cv vt cv
      cJ ccl cfv cfv ciin wceq va cv vz cv cfil eleq1 va cv vz cv wceq va cv
      cuni vz cv cuni cX va cv vz cv unieq eqeq1d va cv vz cv wceq vt va cv vt
      cv cJ ccl cfv cfv ciin vt vz cv vt cv cJ ccl cfv cfv ciin vb cv vt va cv
      vz cv vt cv cJ ccl cfv cfv iineq1 eqeq2d 3anbi123d vb cv vw cv wceq vb cv
      vt vz cv vt cv cJ ccl cfv cfv ciin wceq vw cv vt vz cv vt cv cJ ccl cfv
      cfv ciin wceq vz cv cfil wcel vz cv cuni cX wceq vb cv vw cv vt vz cv vt
      cv cJ ccl cfv cfv ciin eqeq1 3anbi3d opelopab syl5ib 19.23adv vw vz cv va
      cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq w3a va vb copab vz visset eldm2 syl5ib ssrdv cJ ctop wcel cX cvv
      wcel cX cpw cvv wcel cX cpw cpw cvv wcel cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg sfcls.1 syl5eqel cX cvv pwexg cX cpw cvv pwexg 3syl sylanc
      sylanc vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv cuni wceq
      vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab wceq wa
      vx vy copab vy cv va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va
      cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab wceq vx vy copab wss
      vy cv va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx
      cv ccl cfv cfv ciin wceq w3a va vb copab wceq vx vy copab wfun vx cv ctop
      wcel vy cv va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt
      cv vx cv ccl cfv cfv ciin wceq w3a va vb copab wceq wa vx vy copab wfun
      vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt
      va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab wceq wa vy cv va
      cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl
      cfv cfv ciin wceq w3a va vb copab wceq vx vy vx cv ctop wcel vy cv va cv
      cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl cfv
      cfv ciin wceq w3a va vb copab wceq pm3.27 ssopab2i vx vy va cv cfil wcel
      va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin
      wceq w3a va vb copab funopabeq vx cv ctop wcel vy cv va cv cfil wcel va
      cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq
      w3a va vb copab wceq wa vx vy copab vy cv va cv cfil wcel va cv cuni vx
      cv cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb
      copab wceq vx vy copab funss mp2 jctir cJ ctop wcel cJ va cv cfil wcel va
      cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab cop vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv cuni
      wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab
      wceq wa vx vy copab wcel cJ ctop wcel va cv cfil wcel va cv cuni cX wceq
      vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab wceq wa cJ ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv
      vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab va cv cfil wcel
      va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va
      vb copab wceq va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq w3a va vb copab eqid jctr cJ ctop wcel va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab cvv wcel cJ va cv cfil wcel va cv cuni cX wceq vb cv vt va cv
      vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cop vx cv ctop wcel vy cv
      va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl
      cfv cfv ciin wceq w3a va vb copab wceq wa vx vy copab wcel cJ ctop wcel
      va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv
      ciin wceq w3a va vb copab va cv cfil wcel va cv cuni cX wceq vb cv vt va
      cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab wceq wa wb va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab wfun va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv
      cJ ccl cfv cfv ciin wceq w3a va vb copab cdm cvv wcel va cv cfil wcel va
      cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab cvv wcel cJ ctop wcel cvv va cv cfil wcel va cv cuni cX wceq vb cv
      vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab funex va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab wfun cJ ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv vt
      va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab vb cv vt va cv vt cv
      cJ ccl cfv cfv ciin wceq va vb copab wss vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq va vb copab wfun va cv cfil wcel va cv cuni cX wceq vb cv
      vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab wfun va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq va vb va cv cfil wcel va cv
      cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq 3simp3
      ssopab2i va vb vt va cv vt cv cJ ccl cfv cfv ciin funopabeq va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq va vb copab
      funss mp2 a1i va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq w3a va vb copab cdm cX cpw cpw wss cX cpw cpw cvv
      wcel va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a va vb copab cdm cvv wcel cJ ctop wcel va cv cfil wcel
      va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va
      vb copab cdm cX cpw cpw cvv ssexg cJ ctop wcel vz va cv cfil wcel va cv
      cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab cdm cX cpw cpw cJ ctop wcel vz cv vw cv cop va cv cfil wcel va cv
      cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab wcel vw wex vz cv cX cpw cpw wcel vz cv va cv cfil wcel va cv cuni
      cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cdm
      wcel cJ ctop wcel vz cv vw cv cop va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab wcel vz cv cX
      cpw cpw wcel vw cJ ctop wcel vz cv cfil wcel vz cv cuni cX wceq vw cv vt
      vz cv vt cv cJ ccl cfv cfv ciin wceq w3a vz cv cX cpw cpw wcel vz cv vw
      cv cop va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a va vb copab wcel vz cv cfil wcel vz cv cuni cX wceq vw
      cv vt vz cv vt cv cJ ccl cfv cfv ciin wceq w3a vz cv cX cpw cpw wcel wi
      cJ ctop wcel vz cv cuni cX wceq vz cv cfil wcel vz cv cX cpw cpw wcel vw
      cv vt vz cv vt cv cJ ccl cfv cfv ciin wceq vz cv cuni cX wceq vz cv cX
      cpw wss vz cv cX cpw cpw wcel vz cv cuni cX wceq vz cv cuni cX wss vz cv
      cuni cpw cX cpw wss vz cv cX cpw wss vz cv cuni cX eqimss vz cv cuni cX
      wss vz cv cuni cpw cX cpw wss vz cv cuni cX sspwb biimpi vz cv vz cv cuni
      cpw wss vz cv cuni cpw cX cpw wss vz cv cX cpw wss wi vz cv pwuni vz cv
      vz cv cuni cpw cX cpw sstr2 ax-mp 3syl vz cv cX cpw vz visset elpw sylibr
      3ad2ant2 a1i va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq w3a vz cv cfil wcel vz cv cuni cX wceq vb cv vt vz
      cv vt cv cJ ccl cfv cfv ciin wceq w3a vz cv cfil wcel vz cv cuni cX wceq
      vw cv vt vz cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb vz cv vw cv vz
      visset vw visset va cv vz cv wceq va cv cfil wcel vz cv cfil wcel va cv
      cuni cX wceq vz cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq vb cv vt vz cv vt cv cJ ccl cfv cfv ciin wceq va cv vz cv cfil eleq1
      va cv vz cv wceq va cv cuni vz cv cuni cX va cv vz cv unieq eqeq1d va cv
      vz cv wceq vt va cv vt cv cJ ccl cfv cfv ciin vt vz cv vt cv cJ ccl cfv
      cfv ciin vb cv vt va cv vz cv vt cv cJ ccl cfv cfv iineq1 eqeq2d
      3anbi123d vb cv vw cv wceq vb cv vt vz cv vt cv cJ ccl cfv cfv ciin wceq
      vw cv vt vz cv vt cv cJ ccl cfv cfv ciin wceq vz cv cfil wcel vz cv cuni
      cX wceq vb cv vw cv vt vz cv vt cv cJ ccl cfv cfv ciin eqeq1 3anbi3d
      opelopab syl5ib 19.23adv vw vz cv va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab vz visset
      eldm2 syl5ib ssrdv cJ ctop wcel cX cvv wcel cX cpw cvv wcel cX cpw cpw
      cvv wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg sfcls.1 syl5eqel cX
      cvv pwexg cX cpw cvv pwexg 3syl sylanc sylanc vx cv ctop wcel vy cv va cv
      cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl cfv
      cfv ciin wceq w3a va vb copab wceq wa cJ ctop wcel vy cv va cv cfil wcel
      va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va
      vb copab wceq wa cJ ctop wcel va cv cfil wcel va cv cuni cX wceq vb cv vt
      va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab va cv cfil wcel va
      cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab wceq wa vx vy cJ va cv cfil wcel va cv cuni cX wceq vb cv vt va cv
      vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab ctop cvv vx cv cJ wceq vx
      cv ctop wcel cJ ctop wcel vy cv va cv cfil wcel va cv cuni vx cv cuni
      wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb copab
      wceq vy cv va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl
      cfv cfv ciin wceq w3a va vb copab wceq vx cv cJ ctop eleq1 vx cv cJ wceq
      va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx cv ccl
      cfv cfv ciin wceq w3a va vb copab va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab vy cv vx cv cJ
      wceq va cv cfil wcel va cv cuni vx cv cuni wceq vb cv vt va cv vt cv vx
      cv ccl cfv cfv ciin wceq w3a va cv cfil wcel va cv cuni cX wceq vb cv vt
      va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb vx cv cJ wceq va cv cuni
      vx cv cuni wceq va cv cuni cX wceq vb cv vt va cv vt cv vx cv ccl cfv cfv
      ciin wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq va cv cfil wcel
      vx cv cJ wceq vx cv cuni cX va cv cuni vx cv cJ wceq vx cv cuni cJ cuni
      cX vx cv cJ unieq sfcls.1 syl6eqr eqeq2d vx cv cJ wceq vt va cv vt cv vx
      cv ccl cfv cfv ciin vt va cv vt cv cJ ccl cfv cfv ciin vb cv vx cv cJ
      wceq vt cv vx cv ccl cfv cfv vt cv cJ ccl cfv cfv wceq vt va cv wral vt
      va cv vt cv vx cv ccl cfv cfv ciin vt va cv vt cv cJ ccl cfv cfv ciin
      wceq vx cv cJ wceq vt cv vx cv ccl cfv cfv vt cv cJ ccl cfv cfv wceq vt
      va cv vx cv cJ wceq vt cv vx cv ccl cfv cfv vt cv cJ ccl cfv cfv wceq vt
      cv va cv wcel vx cv cJ wceq vt cv vx cv ccl cfv cJ ccl cfv vx cv cJ ccl
      fveq2 fveq1d a1d r19.21aiv vt va cv vt cv vx cv ccl cfv cfv vt cv cJ ccl
      cfv cfv iineq2 syl eqeq2d 3anbi23d opabbidv eqeq2d anbi12d vy cv va cv
      cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq w3a va vb copab wceq vy cv va cv cfil wcel va cv cuni cX wceq vb cv
      vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab wceq va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq w3a va vb copab wceq cJ ctop wcel vy cv va cv cfil
      wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a
      va vb copab va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ
      ccl cfv cfv ciin wceq w3a va vb copab eqeq1 anbi2d opelopabg mpdan mpbird
      sylc cJ cfclus vx cv ctop wcel vy cv va cv cfil wcel va cv cuni vx cv
      cuni wceq vb cv vt va cv vt cv vx cv ccl cfv cfv ciin wceq w3a va vb
      copab wceq wa vx vy copab vx vy vt va vb df-fclus fveq1i syl5eq $.
      $( [9-Nov-2009] $) $( [9-Nov-2009] $)
  $}

  ${
    $d a b t x F $. $d a b t x J $. $d a b x X $. $d a b t x Y $.
    filclus.1 $e |- X = U. J $.
    filclus.2 $e |- Y = U. F $.
    $( The set of all cluster points of a filter. $)
    filclus $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( ( fClus ` J ) ` F )
    = |^|_ t e. F ( ( cls ` J ) ` t ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cJ cfclus cfv cfv cF va cv
      cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq w3a va vb copab cfv vt cF vt cv cJ ccl cfv cfv ciin cJ ctop wcel cF
      cfil wcel cF cJ cfclus cfv cfv cF va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cfv wceq cX cY
      wceq cJ ctop wcel cF cJ cfclus cfv va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab vt cJ cX va vb
      filclus.1 sfcls fveq1d 3ad2ant1 vt cF vt cv cJ ccl cfv cfv ciin cvv wcel
      va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv
      ciin wceq w3a va vb copab wfun wa cF vt cF vt cv cJ ccl cfv cfv ciin cop
      va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv
      ciin wceq w3a va vb copab wcel cF va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab cfv vt cF vt
      cv cJ ccl cfv cfv ciin wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cF
      vt cF vt cv cJ ccl cfv cfv ciin cvv va cv cfil wcel va cv cuni cX wceq vb
      cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab funopfvg cJ
      ctop wcel cF cfil wcel cX cY wceq w3a vt cF vt cv cJ ccl cfv cfv ciin cvv
      wcel va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a va vb copab wfun cF cfil wcel cJ ctop wcel vt cF vt cv
      cJ ccl cfv cfv ciin cvv wcel cX cY wceq cF cfil wcel cY cF wcel vt cF vt
      cv cJ ccl cfv cfv ciin cY cJ ccl cfv cfv wss vt cF vt cv cJ ccl cfv cfv
      ciin cvv wcel cF cY filclus.2 filusb cY cF wcel vx vt cF vt cv cJ ccl cfv
      cfv ciin cY cJ ccl cfv cfv cY cF wcel vx cv vt cv cJ ccl cfv cfv wcel vt
      cF wral vx cv cY cJ ccl cfv cfv wcel vx cv vt cF vt cv cJ ccl cfv cfv
      ciin wcel vx cv vt cv cJ ccl cfv cfv wcel vx cv cY cJ ccl cfv cfv wcel vt
      cY cF vt cv cY wceq vt cv cJ ccl cfv cfv cY cJ ccl cfv cfv vx cv vt cv cY
      cJ ccl cfv fveq2 eleq2d rcla4v vx cv cvv wcel vx cv vt cF vt cv cJ ccl
      cfv cfv ciin wcel vx cv vt cv cJ ccl cfv cfv wcel vt cF wral wb vx visset
      vt vx cv cF vt cv cJ ccl cfv cfv cvv eliin ax-mp syl5ib ssrdv vt cF vt cv
      cJ ccl cfv cfv ciin cY cJ ccl cfv cfv cY cJ ccl cfv fvex ssex 3syl
      3ad2ant2 va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl
      cfv cfv ciin wceq w3a va vb copab vb cv vt va cv vt cv cJ ccl cfv cfv
      ciin wceq va vb copab wss vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq
      va vb copab wfun va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv
      cJ ccl cfv cfv ciin wceq w3a va vb copab wfun va cv cfil wcel va cv cuni
      cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a vb cv vt va cv
      vt cv cJ ccl cfv cfv ciin wceq va vb va cv cfil wcel va cv cuni cX wceq
      vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq 3simp3 ssopab2i va vb vt va
      cv vt cv cJ ccl cfv cfv ciin funopabeq va cv cfil wcel va cv cuni cX wceq
      vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb copab vb cv vt va
      cv vt cv cJ ccl cfv cfv ciin wceq va vb copab funss mp2 jctir cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cF vt cF vt cv cJ ccl cfv cfv ciin cop
      va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv
      ciin wceq w3a va vb copab wcel cF cfil wcel cY cX wceq vt cF vt cv cJ ccl
      cfv cfv ciin vt cF vt cv cJ ccl cfv cfv ciin wceq w3a cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cF cfil wcel cY cX wceq vt cF vt cv cJ ccl cfv
      cfv ciin vt cF vt cv cJ ccl cfv cfv ciin wceq cJ ctop wcel cF cfil wcel
      cX cY wceq 3simp2 cX cY wceq cJ ctop wcel cY cX wceq cF cfil wcel cX cY
      wceq cY cX wceq cX cY eqcom biimpi 3ad2ant3 cJ ctop wcel cF cfil wcel cX
      cY wceq w3a vt cF vt cv cJ ccl cfv cfv ciin eqidd 3jca cF cfil wcel cJ
      ctop wcel cF vt cF vt cv cJ ccl cfv cfv ciin cop va cv cfil wcel va cv
      cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq w3a va vb
      copab wcel cF cfil wcel cY cX wceq vt cF vt cv cJ ccl cfv cfv ciin vt cF
      vt cv cJ ccl cfv cfv ciin wceq w3a wb cX cY wceq cF cfil wcel vt cF vt cv
      cJ ccl cfv cfv ciin cvv wcel cF vt cF vt cv cJ ccl cfv cfv ciin cop va cv
      cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin
      wceq w3a va vb copab wcel cF cfil wcel cY cX wceq vt cF vt cv cJ ccl cfv
      cfv ciin vt cF vt cv cJ ccl cfv cfv ciin wceq w3a wb cF cfil wcel cY cF
      wcel vt cF vt cv cJ ccl cfv cfv ciin cY cJ ccl cfv cfv wss vt cF vt cv cJ
      ccl cfv cfv ciin cvv wcel cF cY filclus.2 filusb cY cF wcel vx vt cF vt
      cv cJ ccl cfv cfv ciin cY cJ ccl cfv cfv cY cF wcel vx cv vt cv cJ ccl
      cfv cfv wcel vt cF wral vx cv cY cJ ccl cfv cfv wcel vx cv vt cF vt cv cJ
      ccl cfv cfv ciin wcel vx cv vt cv cJ ccl cfv cfv wcel vx cv cY cJ ccl cfv
      cfv wcel vt cY cF vt cv cY wceq vt cv cJ ccl cfv cfv cY cJ ccl cfv cfv vx
      cv vt cv cY cJ ccl cfv fveq2 eleq2d rcla4v vx cv cvv wcel vx cv vt cF vt
      cv cJ ccl cfv cfv ciin wcel vx cv vt cv cJ ccl cfv cfv wcel vt cF wral wb
      vx visset vt vx cv cF vt cv cJ ccl cfv cfv cvv eliin ax-mp syl5ib ssrdv
      vt cF vt cv cJ ccl cfv cfv ciin cY cJ ccl cfv cfv cY cJ ccl cfv fvex ssex
      3syl va cv cfil wcel va cv cuni cX wceq vb cv vt va cv vt cv cJ ccl cfv
      cfv ciin wceq w3a cF cfil wcel cY cX wceq vb cv vt cF vt cv cJ ccl cfv
      cfv ciin wceq w3a cF cfil wcel cY cX wceq vt cF vt cv cJ ccl cfv cfv ciin
      vt cF vt cv cJ ccl cfv cfv ciin wceq w3a va vb cF vt cF vt cv cJ ccl cfv
      cfv ciin cfil cvv va cv cF wceq va cv cfil wcel cF cfil wcel va cv cuni
      cX wceq cY cX wceq vb cv vt va cv vt cv cJ ccl cfv cfv ciin wceq vb cv vt
      cF vt cv cJ ccl cfv cfv ciin wceq va cv cF cfil eleq1 va cv cF wceq va cv
      cuni cY cX va cv cF wceq va cv cuni cF cuni cY va cv cF unieq filclus.2
      syl6eqr eqeq1d va cv cF wceq vt va cv vt cv cJ ccl cfv cfv ciin vt cF vt
      cv cJ ccl cfv cfv ciin vb cv vt va cv cF vt cv cJ ccl cfv cfv iineq1
      eqeq2d 3anbi123d vb cv vt cF vt cv cJ ccl cfv cfv ciin wceq vb cv vt cF
      vt cv cJ ccl cfv cfv ciin wceq vt cF vt cv cJ ccl cfv cfv ciin vt cF vt
      cv cJ ccl cfv cfv ciin wceq cF cfil wcel cY cX wceq vb cv vt cF vt cv cJ
      ccl cfv cfv ciin vt cF vt cv cJ ccl cfv cfv ciin eqeq1 3anbi3d opelopabg
      mpdan 3ad2ant2 mpbird sylc eqtrd $.
      $( [10-Nov-2009] $) $( [10-Nov-2009] $)
  $}

  ${
    $d o s A $. $d o s F $. $d o s J $. $d o s X $. $d s Y $.
    isfclus.1 $e |- X = U. J $.
    isfclus.2 $e |- Y = U. F $.
    $( A cluster point of a filter. $)
    isfclus $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( A e. ( ( fClus ` J )
    ` F ) <-> ( A e. X /\ A. o e. J ( A e. o -> A. s e. F ( o i^i s ) =/= (/) )
    ) ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cA
      vs cF vs cv cJ ccl cfv cfv ciin wcel cA cX wcel cA vo cv wcel vo cv vs cv
      cin c0 wne vs cF wral wi vo cJ wral wa cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cF cJ cfclus cfv cfv vs cF vs cv cJ ccl cfv cfv ciin cA vs cF cJ
      cX cY isfclus.1 isfclus.2 filclus eleq2d cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA vs cF vs cv cJ ccl cfv cfv ciin wcel cA cX wcel cA vo cv wcel
      vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral wa cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA vs cF vs cv cJ ccl cfv cfv ciin wcel cA cX wcel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vs cF vs cv cJ ccl cfv cfv ciin cX cA cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vs cv cJ ccl cfv cfv cX wss vs cF wrex
      vs cF vs cv cJ ccl cfv cfv ciin cX wss cX cF wcel cX cJ ccl cfv cfv cX
      wss vs cv cJ ccl cfv cfv cX wss vs cF wrex cJ ctop wcel cF cfil wcel cX
      cY wceq w3a vs cv cJ ccl cfv cfv cX wss cX cJ ccl cfv cfv cX wss vs cX cF
      vs cv cX wceq vs cv cJ ccl cfv cfv cX cJ ccl cfv cfv cX vs cv cX cJ ccl
      cfv fveq2 sseq1d rcla4ev cF cfil wcel cX cY wceq cX cF wcel cJ ctop wcel
      cX cY wceq cF cfil wcel cX cF wcel cX cY wceq cX cF wcel cY cF wcel cF
      cfil wcel cX cY cF eleq1 cF cY isfclus.2 filusb syl5bir impcom 3adant1 cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cX cJ ccl cfv cfv cX wceq cX cJ ccl
      cfv cfv cX wss cJ ctop wcel cF cfil wcel cX cJ ccl cfv cfv cX wceq cX cY
      wceq cJ cX isfclus.1 clstop 3ad2ant1 cX cJ ccl cfv cfv cX eqimss syl
      sylanc vs cF vs cv cJ ccl cfv cfv cX iinss syl sseld imdistani cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel cA vo cv wcel vo cv vs cv cin
      c0 wne vs cF wral wi vo cJ wral wa wa cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      cA vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral wa pm3.26
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel cA vo cv wcel vo cv
      vs cv cin c0 wne vs cF wral wi vo cJ wral simprl jca cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa cA vs cF vs cv cJ ccl cfv cfv ciin wcel
      cA vs cv cJ ccl cfv cfv wcel vs cF wral cA vo cv wcel vo cv vs cv cin c0
      wne vs cF wral wi vo cJ wral cA cX wcel cA vo cv wcel vo cv vs cv cin c0
      wne vs cF wral wi vo cJ wral wa cA cX wcel cA vs cF vs cv cJ ccl cfv cfv
      ciin wcel cA vs cv cJ ccl cfv cfv wcel vs cF wral wb cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vs cA cF vs cv cJ ccl cfv cfv cX eliin adantl cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA vs cv cJ ccl cfv cfv
      wcel vs cF wral cA vo cv wcel vo cv vs cv cin c0 wne wi vo cJ wral vs cF
      wral cA vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA vs cv cJ ccl cfv
      cfv wcel cA vo cv wcel vo cv vs cv cin c0 wne wi vo cJ wral vs cF cJ ctop
      wcel vs cv cX wss cA cX wcel cA vs cv cJ ccl cfv cfv wcel cA vo cv wcel
      vo cv vs cv cin c0 wne wi vo cJ wral wb cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vs cv cF wcel wa vo cA vs cv cJ cX isfclus.1 elcls
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel cA cX wcel vs cv cF
      wcel cJ ctop wcel cF cfil wcel cX cY wceq 3simp1 ad2antrr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vs cv cF wcel vs cv cX wss cA cX wcel cX cY wceq
      cJ ctop wcel vs cv cF wcel vs cv cX wss cF cfil wcel cX cY wceq vs cv cY
      wss vs cv cX wss vs cv cF wcel cX cY wceq vs cv cX wss vs cv cY wss cX cY
      vs cv sseq2 biimpar vs cv cF wcel vs cv cF cuni cY vs cv cF elssuni
      isfclus.2 syl6ssr sylan2 3ad2antl3 adantlr cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel vs cv cF wcel simplr syl3anc ralbidva cA vo cv
      wcel vo cv vs cv cin c0 wne wi vo cJ wral vs cF wral cA vo cv wcel vo cv
      vs cv cin c0 wne wi vs cF wral vo cJ wral cA vo cv wcel vo cv vs cv cin
      c0 wne vs cF wral wi vo cJ wral cA vo cv wcel vo cv vs cv cin c0 wne wi
      vs vo cF cJ ralcom cA vo cv wcel vo cv vs cv cin c0 wne wi vs cF wral cA
      vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ cA vo cv wcel vo cv
      vs cv cin c0 wne vs cF r19.21v ralbii bitri syl6bb cA cX wcel cA vo cv
      wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral cA cX wcel cA vo cv
      wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral wa wb cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel cA vo cv wcel vo cv vs cv cin c0
      wne vs cF wral wi vo cJ wral ibar adantl 3bitrd pm5.21nd bitrd $.
      $( [10-Nov-2009] $) $( [10-Nov-2009] $)
  $}

  ${
    $d n o p s A $. $d n o p s F $. $d n o p s J $. $d n o p s X $. $d n o p s
    Y $.
    fclusnei.1 $e |- X = U. J $.
    fclusnei.2 $e |- Y = U. F $.
    $( Cluster points in terms of neighborhoods. $)
    fclusnei $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( A e. ( ( fClus ` J
    ) ` F ) <-> ( A e. X /\ A. n e. ( ( nei ` J ) ` { A } ) A. s e. F ( n i^i s
    ) =/= (/) ) ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cA
      cX wcel cA vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral wa
      cA cX wcel vn cv vs cv cin c0 wne vs cF wral vn cA csn cJ cnei cfv cfv
      wral wa cA vo cF cJ cX cY vs fclusnei.1 fclusnei.2 isfclus cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel cA vo cv wcel vo cv vs cv cin c0
      wne vs cF wral wi vo cJ wral vn cv vs cv cin c0 wne vs cF wral vn cA csn
      cJ cnei cfv cfv wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa cA vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral vn cv vs
      cv cin c0 wne vs cF wral vn cA csn cJ cnei cfv cfv wral cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv vs cv cin c0
      wne vs cF wral wi vo cJ wral vn cv vs cv cin c0 wne vs cF wral vn cA csn
      cJ cnei cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vn
      cv cA csn cJ cnei cfv cfv wcel cA vo cv wcel vo cv vs cv cin c0 wne vs cF
      wral wi vo cJ wral vn cv vs cv cin c0 wne vs cF wral cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vn cv cA csn cJ cnei cfv cfv wcel cA
      csn vp cv wss vp cv vn cv wss wa vp cJ wrex cA vo cv wcel vo cv vs cv cin
      c0 wne vs cF wral wi vo cJ wral vn cv vs cv cin c0 wne vs cF wral wi cJ
      ctop wcel cF cfil wcel cX cY wceq w3a vn cv cA csn cJ cnei cfv cfv wcel
      cA csn vp cv wss vp cv vn cv wss wa vp cJ wrex wi cA cX wcel cJ ctop wcel
      cF cfil wcel vn cv cA csn cJ cnei cfv cfv wcel cA csn vp cv wss vp cv vn
      cv wss wa vp cJ wrex wi cX cY wceq cJ ctop wcel vn cv cA csn cJ cnei cfv
      cfv wcel cA csn vp cv wss vp cv vn cv wss wa vp cJ wrex cA csn vp cJ vn
      cv neii2 ex 3ad2ant1 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa cA csn vp cv wss vp cv vn cv wss wa cA vo cv wcel vo cv vs cv
      cin c0 wne vs cF wral wi vo cJ wral vn cv vs cv cin c0 wne vs cF wral wi
      vp cJ cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vp cv cJ
      wcel cA csn vp cv wss vp cv vn cv wss wa cA vo cv wcel vo cv vs cv cin c0
      wne vs cF wral wi vo cJ wral vn cv vs cv cin c0 wne vs cF wral wi cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vp cv cJ wcel cA csn vp cv
      wss vp cv vn cv wss wa wa wa cA vo cv wcel vo cv vs cv cin c0 wne vs cF
      wral wi vo cJ wral vp cv vs cv cin c0 wne vs cF wral vn cv vs cv cin c0
      wne vs cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vp
      cv cJ wcel cA csn vp cv wss vp cv vn cv wss wa wa wa cA vo cv wcel vo cv
      vs cv cin c0 wne vs cF wral wi vo cJ wral cA vp cv wcel vp cv vs cv cin
      c0 wne vs cF wral cA cX wcel cA csn vp cv wss vp cv vn cv wss wa cA vp cv
      wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a vp cv cJ wcel cA cX wcel cA
      csn vp cv wss cA vp cv wcel vp cv vn cv wss cA cX wcel cA vp cv wcel cA
      csn vp cv wss cA vp cv cX snssg biimpar adantrr ad2ant2l vp cv cJ wcel cA
      vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral cA vp cv wcel
      vp cv vs cv cin c0 wne vs cF wral wi wi cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa cA csn vp cv wss vp cv vn cv wss wa cA vo cv wcel
      vo cv vs cv cin c0 wne vs cF wral wi cA vp cv wcel vp cv vs cv cin c0 wne
      vs cF wral wi vo vp cv cJ vo cv vp cv wceq cA vo cv wcel cA vp cv wcel vo
      cv vs cv cin c0 wne vs cF wral vp cv vs cv cin c0 wne vs cF wral vo cv vp
      cv cA eleq2 vo cv vp cv wceq vo cv vs cv cin c0 wne vp cv vs cv cin c0
      wne vs cF vo cv vp cv wceq vo cv vs cv cin vp cv vs cv cin c0 vo cv vp cv
      vs cv ineq1 neeq1d ralbidv imbi12d rcla4v ad2antrl mpid cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vp cv cJ wcel cA csn vp cv wss vp
      cv vn cv wss wa wa wa vp cv vs cv cin c0 wne vn cv vs cv cin c0 wne vs cF
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vp cv cJ wcel cA
      csn vp cv wss vp cv vn cv wss wa wa wa vs cv cF wcel wa vp cv vs cv cin
      vn cv vs cv cin wss vp cv vs cv cin c0 wne vn cv vs cv cin c0 wne wi vp
      cv cJ wcel cA csn vp cv wss vp cv vn cv wss wa wa vp cv vs cv cin vn cv
      vs cv cin wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vs
      cv cF wcel vp cv vn cv wss vp cv vs cv cin vn cv vs cv cin wss vp cv cJ
      wcel cA csn vp cv wss vp cv vn cv vs cv ssrin ad2antll ad2antlr vp cv vs
      cv cin vn cv vs cv cin wss vp cv vs cv cin c0 wne vn cv vs cv cin c0 wne
      vp cv vs cv cin vn cv vs cv cin ssn0 ex syl r19.20dva syld exp32
      r19.23adv syld com23 r19.21adv cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vn cv vs cv cin c0 wne vs cF wral vn cA csn cJ cnei cfv cfv
      wral cA vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel vn cv vs cv
      cin c0 wne vs cF wral vn cA csn cJ cnei cfv cfv wral cA vo cv wcel vo cv
      vs cv cin c0 wne vs cF wral wi cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel vn cv vs cv cin c0 wne vs cF
      wral vn cA csn cJ cnei cfv cfv wral vo cv vs cv cin c0 wne vs cF wral cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vn cv vs cv cin c0 wne vs cF wral vn cA csn cJ cnei cfv cfv wral
      vo cv vs cv cin c0 wne vs cF wral wi cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cA csn cJ cnei
      cfv cfv wcel vn cv vs cv cin c0 wne vs cF wral vn cA csn cJ cnei cfv cfv
      wral vo cv vs cv cin c0 wne vs cF wral wi cJ ctop wcel cF cfil wcel cX cY
      wceq w3a vo cv cJ wcel cA vo cv wcel wa vo cv cA csn cJ cnei cfv cfv wcel
      cA cX wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel cA vo cv wcel wa vo cv
      cA csn cJ cnei cfv cfv wcel cX cY wceq cJ ctop wcel vo cv cJ wcel cA vo
      cv wcel vo cv cA csn cJ cnei cfv cfv wcel cA cJ vo cv opnneip 3expb
      3ad2antl1 adantlr vn cv vs cv cin c0 wne vs cF wral vo cv vs cv cin c0
      wne vs cF wral vn vo cv cA csn cJ cnei cfv cfv vn cv vo cv wceq vn cv vs
      cv cin c0 wne vo cv vs cv cin c0 wne vs cF vn cv vo cv wceq vn cv vs cv
      cin vo cv vs cv cin c0 vn cv vo cv vs cv ineq1 neeq1d ralbidv rcla4v syl
      exp32 com34 com23 r19.21adv impbid pm5.32da bitrd $.
      $( [11-Nov-2009] $) $( [11-Nov-2009] $)
  $}

  ${
    $d o s A $. $d o s F $. $d o s J $. $d o s X $. $d o s Y $.
    fclselbas.1 $e |- X = U. J $.
    fclselbas.2 $e |- Y = U. F $.
    $( A cluster point is in the base set. $)
    fclselbas $p |- ( ( ( J e. Top /\ F e. Fil /\ X = Y ) /\ A e. ( ( fClus ` J
    ) ` F ) ) -> A e. X ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cA
      cX wcel cA vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral cA
      vo cF cJ cX cY vs fclselbas.1 fclselbas.2 isfclus pm3.26bda $.
      $( [11-Nov-2009] $) $( [11-Nov-2009] $)
  $}

  ${
    $d n s A $. $d n s F $. $d n s J $. $d n s N $. $d n s S $. $d n s X $. $d
    n s Y $.
    fclusneii.1 $e |- X = U. J $.
    fclusneii.2 $e |- Y = U. F $.
    $( A neighborhood of a cluster point of a filter intersects any element of
       that filter. $)
    fclusneii $p |- ( ( ( ( J e. Top /\ F e. Fil /\ X = Y ) /\ A e. ( ( fClus `
    J ) ` F ) /\ N e. ( ( nei ` J ) ` { A } ) ) /\ S e. F ) -> ( N i^i S ) =/=
    (/) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cN
      cA csn cJ cnei cfv cfv wcel w3a cS cF wcel cN cS cin c0 wne cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cN cA csn cJ
      cnei cfv cfv wcel cS cF wcel cN cS cin c0 wne wi cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cN cA csn cJ cnei cfv
      cfv wcel cS cF wcel cN cS cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel wa vn cv vs cv cin c0 wne vs cF wral vn
      cA csn cJ cnei cfv cfv wral cN cA csn cJ cnei cfv cfv wcel cS cF wcel wa
      cN cS cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel cA cX wcel vn cv vs cv cin c0 wne vs cF wral vn cA csn cJ
      cnei cfv cfv wral cA vn cF cJ cX cY vs fclusneii.1 fclusneii.2 fclusnei
      pm3.27bda vn cv vs cv cin c0 wne cN cS cin c0 wne cN vs cv cin c0 wne vn
      vs cN cS cA csn cJ cnei cfv cfv cF vn cv cN wceq vn cv vs cv cin cN vs cv
      cin c0 vn cv cN vs cv ineq1 neeq1d vs cv cS wceq cN vs cv cin cN cS cin
      c0 vs cv cS cN ineq2 neeq1d rcla42v mpan9 exp32 3impia imp $.
      $( [11-Nov-2009] $) $( [11-Nov-2009] $)
  $}

  ${
    $d o r s t A $. $d o r s t B $. $d o r s t F $. $d o r s t J $. $d o r s t
    X $. $d o r s t Y $.
    fclusbas.1 $e |- X = U. J $.
    fclusbas.2 $e |- Y = U. B $.
    fclusbas.3 $e |- F = ( filGen ` B ) $.
    $( Cluster points in terms of filter bases. $)
    fclusbas $p |- ( ( ( J e. Top /\ B e. fBas /\ X = Y ) /\ A e. X ) -> ( A e.
    ( ( fClus ` J ) ` F ) <-> A. o e. J ( A e. o -> A. s e. B ( o i^i s ) =/=
    (/) ) ) ) $=
      cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA cX wcel wa cA cF cJ cfclus
      cfv cfv wcel cA cX wcel cA vo cv wcel vo cv vt cv cin c0 wne vt cF wral
      wi vo cJ wral wa cA vo cv wcel vo cv vt cv cin c0 wne vt cF wral wi vo cJ
      wral cA vo cv wcel vo cv vs cv cin c0 wne vs cB wral wi vo cJ wral cJ
      ctop wcel cB cfbas wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cA cX
      wcel cA vo cv wcel vo cv vt cv cin c0 wne vt cF wral wi vo cJ wral wa wb
      cA cX wcel cJ ctop wcel cF cfil wcel cX cF cuni wceq cA cF cJ cfclus cfv
      cfv wcel cA cX wcel cA vo cv wcel vo cv vt cv cin c0 wne vt cF wral wi vo
      cJ wral wa wb cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA vo cF cJ cX cF
      cuni vt fclusbas.1 cF cuni eqid isfclus cJ ctop wcel cB cfbas wcel cX cY
      wceq 3simp1 cB cfbas wcel cJ ctop wcel cF cfil wcel cX cY wceq cB cfbas
      wcel cB cfg cfv cfil cF cB fgfil fclusbas.3 syl5eqel 3ad2ant2 cB cfbas
      wcel cX cY wceq cX cF cuni wceq cJ ctop wcel cB cfbas wcel cX cY wceq cX
      cF cuni wceq cB cfbas wcel cY cF cuni cX cB cfbas wcel cY cB cfg cfv cuni
      cF cuni cB cY fclusbas.2 fgbas cF cB cfg cfv fclusbas.3 unieqi syl6eqr
      eqeq2d biimpa 3adant1 syl3anc adantr cA cX wcel cA vo cv wcel vo cv vt cv
      cin c0 wne vt cF wral wi vo cJ wral cA cX wcel cA vo cv wcel vo cv vt cv
      cin c0 wne vt cF wral wi vo cJ wral wa wb cJ ctop wcel cB cfbas wcel cX
      cY wceq w3a cA cX wcel cA vo cv wcel vo cv vt cv cin c0 wne vt cF wral wi
      vo cJ wral ibar adantl cJ ctop wcel cB cfbas wcel cX cY wceq w3a cA cX
      wcel wa cA vo cv wcel vo cv vt cv cin c0 wne vt cF wral wi cA vo cv wcel
      vo cv vs cv cin c0 wne vs cB wral wi vo cJ cJ ctop wcel cB cfbas wcel cX
      cY wceq w3a cA cX wcel wa vo cv vt cv cin c0 wne vt cF wral vo cv vs cv
      cin c0 wne vs cB wral cA vo cv wcel cJ ctop wcel cB cfbas wcel cX cY wceq
      w3a vo cv vt cv cin c0 wne vt cF wral vo cv vs cv cin c0 wne vs cB wral
      wb cA cX wcel cB cfbas wcel cJ ctop wcel vo cv vt cv cin c0 wne vt cF
      wral vo cv vs cv cin c0 wne vs cB wral wb cX cY wceq cB cfbas wcel vo cv
      vt cv cin c0 wne vt cF wral vo cv vs cv cin c0 wne vs cB wral cB cfbas
      wcel vo cv vt cv cin c0 wne vt cF wral vo cv vs cv cin c0 wne vs cB cB
      cfbas wcel vs cv cB wcel wa vs cv cF wcel vo cv vt cv cin c0 wne vt cF
      wral vo cv vs cv cin c0 wne wi cB cfbas wcel vs cv cB wcel wa vs cv cB
      cfg cfv cF cB cfbas wcel vs cv cB wcel vs cv cB cfg cfv wcel cB cfbas
      wcel cB cB cfg cfv vs cv cB fbssfg sseld imp fclusbas.3 syl6eleqr vo cv
      vt cv cin c0 wne vo cv vs cv cin c0 wne vt vs cv cF vt cv vs cv wceq vo
      cv vt cv cin vo cv vs cv cin c0 vt cv vs cv vo cv ineq2 neeq1d rcla4v syl
      r19.21adva cB cfbas wcel vo cv vs cv cin c0 wne vs cB wral vo cv vt cv
      cin c0 wne vt cF cB cfbas wcel vt cv cF wcel vo cv vs cv cin c0 wne vs cB
      wral vo cv vt cv cin c0 wne cB cfbas wcel vt cv cF wcel vt cv cY wss vr
      cv vt cv wss vr cB wrex wa vo cv vs cv cin c0 wne vs cB wral vo cv vt cv
      cin c0 wne wi cB cfbas wcel vt cv cB cfg cfv wcel vt cv cY wss vr cv vt
      cv wss vr cB wrex wa vt cv cF wcel vr vt cv cB cY fclusbas.2 elfg cF cB
      cfg cfv vt cv fclusbas.3 eleq2i syl5bb vr cv vt cv wss vr cB wrex vo cv
      vs cv cin c0 wne vs cB wral vo cv vt cv cin c0 wne wi vt cv cY wss vr cv
      vt cv wss vo cv vs cv cin c0 wne vs cB wral vo cv vt cv cin c0 wne wi vr
      cB vr cv cB wcel vo cv vs cv cin c0 wne vs cB wral vr cv vt cv wss vo cv
      vt cv cin c0 wne vr cv cB wcel vo cv vs cv cin c0 wne vs cB wral vo cv vr
      cv cin c0 wne vr cv vt cv wss vo cv vt cv cin c0 wne wi vo cv vs cv cin
      c0 wne vo cv vr cv cin c0 wne vs vr cv cB vs cv vr cv wceq vo cv vs cv
      cin vo cv vr cv cin c0 vs cv vr cv vo cv ineq2 neeq1d rcla4v vr cv vt cv
      wss vo cv vr cv cin c0 wne vo cv vt cv cin c0 wne vo cv vr cv cin vo cv
      vt cv cin wss vo cv vr cv cin c0 wne vo cv vt cv cin c0 wne vr cv vt cv
      wss vo cv vr cv cin vo cv vt cv cin ssn0 vr cv vt cv vo cv sslin sylan
      expcom syl6 com23 r19.23aiv adantl syl6bi com23 r19.21adv impbid 3ad2ant2
      adantr imbi2d ralbidv 3bitr2d $.
      $( [13-Nov-2009] $) $( [13-Nov-2009] $)
  $}

  ${
    $d s t F $. $d s t G $. $d s t J $. $d s t X $. $d s t Y $. $d s t Z $.
    fclusss.1 $e |- X = U. J $.
    fclusss.2 $e |- Y = U. F $.
    fclusss.3 $e |- Z = U. G $.
    $( A finer filter has fewer cluster points. $)
    fclusss $p |- ( ( ( ( J e. Top /\ F e. Fil /\ G e. Fil ) /\ X = Y /\ X = Z
     ) /\ F C_ G ) -> ( ( fClus ` J ) ` G ) C_ ( ( fClus ` J ) ` F ) ) $=
      cJ ctop wcel cF cfil wcel cG cfil wcel w3a cX cY wceq cX cZ wceq w3a cF
      cG wss wa cG cJ cfclus cfv cfv cF cJ cfclus cfv cfv wss vt cG vt cv cJ
      ccl cfv cfv ciin vt cF vt cv cJ ccl cfv cfv ciin wss cF cG wss vt cG vt
      cv cJ ccl cfv cfv ciin vt cF vt cv cJ ccl cfv cfv ciin wss cJ ctop wcel
      cF cfil wcel cG cfil wcel w3a cX cY wceq cX cZ wceq w3a cF cG wss vs cv
      vt cv cJ ccl cfv cfv wcel vt cG wral vs cab vs cv vt cv cJ ccl cfv cfv
      wcel vt cF wral vs cab vt cG vt cv cJ ccl cfv cfv ciin vt cF vt cv cJ ccl
      cfv cfv ciin cF cG wss vs cv vt cv cJ ccl cfv cfv wcel vt cG wral vs cv
      vt cv cJ ccl cfv cfv wcel vt cF wral wi vs wal vs cv vt cv cJ ccl cfv cfv
      wcel vt cG wral vs cab vs cv vt cv cJ ccl cfv cfv wcel vt cF wral vs cab
      wss cF cG wss vs cv vt cv cJ ccl cfv cfv wcel vt cG wral vs cv vt cv cJ
      ccl cfv cfv wcel vt cF wral wi vs vs cv vt cv cJ ccl cfv cfv wcel vt cF
      cG ssralv 19.21aiv vs cv vt cv cJ ccl cfv cfv wcel vt cG wral vs cv vt cv
      cJ ccl cfv cfv wcel vt cF wral vs ss2ab sylibr vt vs cG vt cv cJ ccl cfv
      cfv df-iin vt vs cF vt cv cJ ccl cfv cfv df-iin 3sstr4g adantl cJ ctop
      wcel cF cfil wcel cG cfil wcel w3a cX cY wceq cX cZ wceq w3a cG cJ cfclus
      cfv cfv cF cJ cfclus cfv cfv wss vt cG vt cv cJ ccl cfv cfv ciin vt cF vt
      cv cJ ccl cfv cfv ciin wss wb cF cG wss cJ ctop wcel cF cfil wcel cG cfil
      wcel w3a cX cY wceq cX cZ wceq w3a cG cJ cfclus cfv cfv vt cG vt cv cJ
      ccl cfv cfv ciin cF cJ cfclus cfv cfv vt cF vt cv cJ ccl cfv cfv ciin cJ
      ctop wcel cF cfil wcel cG cfil wcel w3a cX cZ wceq cG cJ cfclus cfv cfv
      vt cG vt cv cJ ccl cfv cfv ciin wceq cX cY wceq cJ ctop wcel cG cfil wcel
      cX cZ wceq cG cJ cfclus cfv cfv vt cG vt cv cJ ccl cfv cfv ciin wceq cF
      cfil wcel cJ ctop wcel cG cfil wcel cX cZ wceq cG cJ cfclus cfv cfv vt cG
      vt cv cJ ccl cfv cfv ciin wceq vt cG cJ cX cZ fclusss.1 fclusss.3 filclus
      3expa 3adantl2 3adant2 cJ ctop wcel cF cfil wcel cG cfil wcel w3a cX cY
      wceq cF cJ cfclus cfv cfv vt cF vt cv cJ ccl cfv cfv ciin wceq cX cZ wceq
      cJ ctop wcel cF cfil wcel cX cY wceq cF cJ cfclus cfv cfv vt cF vt cv cJ
      ccl cfv cfv ciin wceq cG cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq
      cF cJ cfclus cfv cfv vt cF vt cv cJ ccl cfv cfv ciin wceq vt cF cJ cX cY
      fclusss.1 fclusss.2 filclus 3expa 3adantl3 3adant3 sseq12d adantr mpbird
      $.
      $( [11-Nov-2009] $) $( [11-Nov-2009] $)
  $}

  ${
    $d a b f g h j k o p q s t x y J $. $d a b f g h j k o p q s t x y K $. $d
    a b f g h j k o p q s t x y X $. $d a b f g h j k o p q s t x y Y $.
    fcluscf.1 $e |- X = U. J $.
    fcluscf.2 $e |- Y = U. K $.
    $( Characterization of fineness of topologies in terms of cluster
       points. $)
    fcluscf $p |- ( ( J e. Top /\ K e. Top /\ X = Y ) -> ( J C_ K <-> A. f e.
    Fil ( X = U. f -> ( ( fClus ` K ) ` f ) C_ ( ( fClus ` J ) ` f ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK wss cJ cK cfne wbr cX vf
      cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf
      cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral cX vf cv
      cuni wceq vf cv cK cfclus cfv cfv vf cv cJ cfclus cfv cfv wss wi vf cfil
      wral cJ cK cX cY fcluscf.1 fcluscf.2 topfne cJ ctop wcel cK ctop wcel cX
      cY wceq w3a cJ cK cfne wbr cX vf cv cuni wceq va cv cX wcel va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel
      va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi
      va wal wi vf cfil wral cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK
      cfne wbr cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv
      cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel
      vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf
      cfil cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil
      wcel cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0
      wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv
      vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf
      cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vf cv wral wi vo cJ wral wa wi va cJ ctop wcel cK ctop wcel cX
      cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va
      cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK
      wral va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral
      cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel
      cX vf cv cuni wceq wa wa wa va cv cX wcel va cv vp cv wcel vp cv vt cv
      cin c0 wne vt vf cv wral wi vp cK wral va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vf cv wral wi vo cJ wral wi cJ ctop wcel cK ctop wcel cX cY
      wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv
      cX wcel wa va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK
      wral va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ cJ
      ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX
      vf cv cuni wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va cv vp cv wcel
      vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral va cv vo cv wcel vo cv
      vs cv cin c0 wne vs vf cv wral wi cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv cX
      wcel wa vo cv cJ wcel va cv vo cv wcel va cv vp cv wcel vp cv vt cv cin
      c0 wne vt vf cv wral wi vp cK wral vo cv vs cv cin c0 wne vs vf cv wral
      cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel
      cX vf cv cuni wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va cv vo cv
      wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral
      vo cv vs cv cin c0 wne vs vf cv wral wi cJ ctop wcel cK ctop wcel cX cY
      wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv
      cX wcel wa vo cv cJ wcel va cv vo cv wcel wa wa va cv vq cv wcel vq cv vo
      cv wss wa vq cK wrex va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv
      wral wi vp cK wral vo cv vs cv cin c0 wne vs vf cv wral wi cJ ctop wcel
      cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa vo cv cJ wcel va cv vo cv wcel wa va cv vq cv wcel vq cv vo
      cv wss wa vq cK wrex va cv cX wcel cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cJ cK cfne wbr vo cv cJ wcel va cv vo cv wcel wa va cv vq cv wcel vq
      cv vo cv wss wa vq cK wrex vf cv cfil wcel cX vf cv cuni wceq wa cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr wa vo cv cJ wcel va cv vo
      cv wcel wa va cv vq cv wcel vq cv vo cv wss wa vq cK wrex cK ctop wcel cJ
      ctop wcel cJ cK cfne wbr vo cv cJ wcel va cv vo cv wcel wa va cv vq cv
      wcel vq cv vo cv wss wa vq cK wrex wi cX cY wceq cK ctop wcel cJ cK cfne
      wbr wa vo cv cJ wcel va cv vo cv wcel va cv vq cv wcel vq cv vo cv wss wa
      vq cK wrex cK ctop wcel cJ cK cfne wbr vo cv cJ wcel va cv vo cv wcel va
      cv vq cv wcel vq cv vo cv wss wa vq cK wrex wi cK ctop wcel cJ cK cfne
      wbr vo cv cJ wcel w3a va cv vo cv wcel va cv vq cv wcel vq cv vo cv wss
      wa vq cK wrex vq cJ cK ctop va cv vo cv fnessex ex 3expia imp3a 3ad2antl2
      imp adantlrr adantlr cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne
      wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv cX wcel wa vo cv cJ
      wcel va cv vo cv wcel wa wa va cv vq cv wcel vq cv vo cv wss wa va cv vp
      cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral vo cv vs cv
      cin c0 wne vs vf cv wral wi vq cK cJ ctop wcel cK ctop wcel cX cY wceq
      w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv cX
      wcel wa vo cv cJ wcel va cv vo cv wcel wa wa vq cv cK wcel va cv vq cv
      wcel vq cv vo cv wss wa va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv
      wral wi vp cK wral vo cv vs cv cin c0 wne vs vf cv wral wi cJ ctop wcel
      cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va cv vo cv wcel wa vq cv cK
      wcel va cv vq cv wcel vq cv vo cv wss wa wa va cv vp cv wcel vp cv vt cv
      cin c0 wne vt vf cv wral wi vp cK wral vo cv vs cv cin c0 wne vs vf cv
      wral wi cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv
      cfil wcel cX vf cv cuni wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va
      cv vo cv wcel wa vq cv cK wcel va cv vq cv wcel vq cv vo cv wss wa wa wa
      wa va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral vq
      cv vt cv cin c0 wne vt vf cv wral vo cv vs cv cin c0 wne vs vf cv wral cJ
      ctop wcel cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX
      vf cv cuni wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va cv vo cv wcel
      wa vq cv cK wcel va cv vq cv wcel vq cv vo cv wss wa wa wa wa va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral va cv vq cv wcel
      vq cv vt cv cin c0 wne vt vf cv wral vq cv cK wcel va cv vq cv wcel vq cv
      vo cv wss wa wa va cv vq cv wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a
      cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv cX wcel
      wa vo cv cJ wcel va cv vo cv wcel wa vq cv cK wcel va cv vq cv wcel vq cv
      vo cv wss simprl ad2antll vq cv cK wcel va cv vq cv wcel vq cv vo cv wss
      wa wa va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral
      va cv vq cv wcel vq cv vt cv cin c0 wne vt vf cv wral wi wi cJ ctop wcel
      cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va cv vo cv wcel wa vq cv cK
      wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral
      va cv vq cv wcel vq cv vt cv cin c0 wne vt vf cv wral wi wi va cv vq cv
      wcel vq cv vo cv wss wa va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv
      wral wi va cv vq cv wcel vq cv vt cv cin c0 wne vt vf cv wral wi vp vq cv
      cK vp cv vq cv wceq va cv vp cv wcel va cv vq cv wcel vp cv vt cv cin c0
      wne vt vf cv wral vq cv vt cv cin c0 wne vt vf cv wral vp cv vq cv va cv
      eleq2 vp cv vq cv wceq vp cv vt cv cin c0 wne vq cv vt cv cin c0 wne vt
      vf cv vp cv vq cv wceq vp cv vt cv cin vq cv vt cv cin c0 vp cv vq cv vt
      cv ineq1 neeq1d ralbidv imbi12d rcla4v adantr ad2antll mpid cJ ctop wcel
      cK ctop wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa va cv cX wcel wa vo cv cJ wcel va cv vo cv wcel wa vq cv cK
      wcel va cv vq cv wcel vq cv vo cv wss wa wa wa wa vq cv vt cv cin c0 wne
      vt vf cv wral vo cv vs cv cin c0 wne vs vf cv vq cv vt cv cin c0 wne vt
      vf cv wral vs cv vf cv wcel vq cv vs cv cin c0 wne cJ ctop wcel cK ctop
      wcel cX cY wceq w3a cJ cK cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa va cv cX wcel wa vo cv cJ wcel va cv vo cv wcel wa vq cv cK wcel va
      cv vq cv wcel vq cv vo cv wss wa wa wa wa vo cv vs cv cin c0 wne vq cv vt
      cv cin c0 wne vq cv vs cv cin c0 wne vt vs cv vf cv vt cv vs cv wceq vq
      cv vt cv cin vq cv vs cv cin c0 vt cv vs cv vq cv ineq2 neeq1d rcla4cv vq
      cv cK wcel va cv vq cv wcel vq cv vo cv wss wa wa vq cv vs cv cin c0 wne
      vo cv vs cv cin c0 wne wi cJ ctop wcel cK ctop wcel cX cY wceq w3a cJ cK
      cfne wbr vf cv cfil wcel cX vf cv cuni wceq wa wa wa va cv cX wcel wa vo
      cv cJ wcel va cv vo cv wcel wa vq cv vo cv wss vq cv vs cv cin c0 wne vo
      cv vs cv cin c0 wne wi vq cv cK wcel va cv vq cv wcel vq cv vo cv wss vq
      cv vs cv cin vo cv vs cv cin wss vq cv vs cv cin c0 wne vo cv vs cv cin
      c0 wne wi vq cv vo cv vs cv ssrin vq cv vs cv cin vo cv vs cv cin wss vq
      cv vs cv cin c0 wne vo cv vs cv cin c0 wne vq cv vs cv cin vo cv vs cv
      cin ssn0 ex syl ad2antll ad2antll syl9r r19.21adv syld expr exp3a
      r19.23adv mpd exp32 com34 com23 r19.21adv ex imdistand 19.21aiv exp45
      r19.21adv cJ ctop wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni wceq va
      cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK
      wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv
      wral wi vo cJ wral wa wi va wal wi vf cfil wral cJ cK cfne wbr cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni wceq va cv cX wcel va cv
      vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX
      wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral
      wa wi va wal wi vf cfil wral wa cJ cK cfne wbr cX cY wceq vb cv vk cv
      wcel vk cv vj cv wss wa vk cK wrex vb vj cv wral vj cJ wral wa cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni wceq va cv cX wcel va cv
      vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX
      wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral
      wa wi va wal wi vf cfil wral wa cX cY wceq vb cv vk cv wcel vk cv vj cv
      wss wa vk cK wrex vb vj cv wral vj cJ wral cJ ctop wcel cK ctop wcel cX
      cY wceq w3a cX cY wceq cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel
      vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv
      vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va
      wal wi vf cfil wral cJ ctop wcel cK ctop wcel cX cY wceq 3simp3 adantr cJ
      ctop wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni wceq va cv cX wcel va
      cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv
      cX wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ
      wral wa wi va wal wi vf cfil wral wa vb cv vk cv wcel vk cv vj cv wss wa
      vk cK wrex vj vb cJ vj cv cJ ctop wcel cK ctop wcel cX cY wceq w3a cX vf
      cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf
      cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral vj cv cJ
      wcel vb cv vj cv wcel wa vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex
      wi cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin
      c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo
      cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil
      wral vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa cX vf cv cuni wceq
      va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp
      cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv
      wral wi vo cJ wral wa wi va wal wi vf cfil wral vb cv vk cv wcel vk cv vj
      cv wss wa vk cK wrex wi cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa wa cX vf cv cuni wceq va cv cX wcel va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel
      va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi
      va wal wi vf cfil wral vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex wi
      vj cv cX cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj
      cv wcel wa wa vj cv cX wceq vb cv vk cv wcel vk cv vj cv wss wa vk cK
      wrex cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0
      wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv
      vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral
      cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel
      wa wa vj cv cX wceq vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex cX cK
      wcel vb cv cX wcel cX vj cv wss vb cv vk cv wcel vk cv vj cv wss wa vk cK
      wrex cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa wa vj cv cX wceq wa cJ ctop wcel cK ctop wcel cX cY wceq w3a cX
      cK wcel vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wceq cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cX cY cK cJ ctop wcel cK ctop wcel cX cY wceq
      3simp3 cK ctop wcel cJ ctop wcel cY cK wcel cX cY wceq cK cY fcluscf.2
      topopn 3ad2ant2 eqeltrd ad2antrr vj cv cJ wcel vb cv vj cv wcel wa vj cv
      cX wceq vb cv cX wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a vb cv vj
      cv wcel vj cv cX wceq vb cv cX wcel vj cv cJ wcel vj cv cX wceq vb cv vj
      cv wcel vb cv cX wcel vj cv cX vb cv eleq2 biimpac adantll adantll vj cv
      cX wceq cX vj cv wss cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa wa cX vj cv eqimss2 adantl vb cv vk cv wcel vk
      cv vj cv wss wa vb cv cX wcel cX vj cv wss wa vk cX cK vk cv cX wceq vb
      cv vk cv wcel vb cv cX wcel vk cv vj cv wss cX vj cv wss vk cv cX vb cv
      eleq2 vk cv cX vj cv sseq1 anbi12d rcla4ev sylan32c ex a1dd cJ ctop wcel
      cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX
      wne cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0
      wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv
      vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral
      vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex wi cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa
      cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne
      vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv
      cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral cX vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab cuni wceq va cv cX wcel va cv
      vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs
      cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi
      vo cJ wral wa wi va wal wi vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex
      cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel
      wa vj cv cX wne wa wa vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cfil
      wcel cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0
      wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv
      vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral
      cX vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cuni wceq va cv cX wcel
      va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo
      cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vo cJ wral wa wi va wal wi wi cX cvv wcel cX vj cv cdif cX wss cX
      vj cv cdif c0 wne vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cfil
      wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa vj cv cX wne wa wa cX cvv wcel cX vj cv cdif cX wss cX vj cv cdif
      c0 wne w3a vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cfil wcel cX vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab cuni wceq vg cX cX vj cv cdif
      cvv supfil pm3.26d cJ ctop wcel cK ctop wcel cX cY wceq w3a cX cvv wcel
      vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa cJ ctop wcel cK ctop
      wcel cX cvv wcel cX cY wceq cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      fcluscf.1 syl5eqel 3ad2ant1 adantr cX vj cv cdif cX wss cJ ctop wcel cK
      ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne
      wa wa cX vj cv difss a1i cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv
      cJ wcel vb cv vj cv wcel wa vj cv cX wne cX vj cv cdif c0 wne cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa wa cX
      vj cv cdif c0 vj cv cX cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa wa cX cX vj cv cdif cdif cX c0 cdif wceq vj cv
      cX wceq cX vj cv cdif c0 wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj
      cv cJ wcel vb cv vj cv wcel wa wa cX cX vj cv cdif cdif vj cv cX c0 cdif
      cX cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa wa vj cv cX wss cX cX vj cv cdif cdif vj cv wceq cJ ctop wcel cK
      ctop wcel cX cY wceq w3a vj cv cJ wcel vj cv cX wss vb cv vj cv wcel cJ
      ctop wcel cK ctop wcel vj cv cJ wcel vj cv cX wss cX cY wceq vj cv cJ cX
      fcluscf.1 eltopss 3ad2antl1 adantrr vj cv cX dfss4 sylib cX c0 cdif cX
      wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa wa cX dif0 a1i eqeq12d cX vj cv cdif c0 cX difeq2 syl5bi necon3d
      impr syl3anc cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt
      cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv
      wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal wi
      cX vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cuni wceq va cv cX wcel
      va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo
      cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vo cJ wral wa wi va wal wi vf vg cv cX wss cX vj cv cdif vg cv
      wss wa vg cab cfil vf cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wceq cX vf cv cuni wceq cX vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      cuni wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv
      wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0
      wne vs vf cv wral wi vo cJ wral wa wi va wal va cv cX wcel va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg
      cab wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ
      wral wa wi va wal vf cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wceq vf cv cuni vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cuni cX vf
      cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab unieq eqeq2d vf cv vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab wceq va cv cX wcel va cv vp
      cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX
      wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral
      wa wi va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral wa va cv cX wcel
      va cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wi vo cJ wral wa wi va vf cv vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wceq va cv cX wcel va cv vp cv wcel vp cv vt cv
      cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vp cv wcel
      vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0
      wne vs vf cv wral wi vo cJ wral wa va cv cX wcel va cv vo cv wcel vo cv
      vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral
      wi vo cJ wral wa vf cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wceq va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral
      va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wi vp cK wral va cv cX wcel vf cv vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wceq va cv vp cv wcel vp cv vt cv cin c0
      wne vt vf cv wral wi va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK vf cv vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wceq vp cv vt cv cin c0 wne vt vf cv wral
      vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv vg cv cX wss cX vj
      cv cdif vg cv wss wa vg cab raleq1 imbi2d ralbidv anbi2d vf cv vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wceq va cv vo cv wcel vo cv vs cv
      cin c0 wne vs vf cv wral wi vo cJ wral va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ
      wral va cv cX wcel vf cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wceq va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi va cv vo cv
      wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg
      cab wral wi vo cJ vf cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wceq vo cv vs cv cin c0 wne vs vf cv wral vo cv vs cv cin c0 wne vs vg cv
      cX wss cX vj cv cdif vg cv wss wa vg cab wral va cv vo cv wcel vo cv vs
      cv cin c0 wne vs vf cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      raleq1 imbi2d ralbidv anbi2d imbi12d albidv imbi12d rcla4v syl cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv
      cX wne wa wa cX vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cuni wceq
      va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wral wi vp cK wral wa va cv cX wcel va cv
      vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wral wi vo cJ wral wa wi va wal wi cX vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab cuni wceq vb cv vk cv wcel vk cv vj cv wss wa vk
      cK wrex cX cvv wcel cX vj cv cdif cX wss cX vj cv cdif c0 wne cX vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab cuni wceq cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa cX
      cvv wcel cX vj cv cdif cX wss cX vj cv cdif c0 wne w3a vg cv cX wss cX vj
      cv cdif vg cv wss wa vg cab cfil wcel cX vg cv cX wss cX vj cv cdif vg cv
      wss wa vg cab cuni wceq vg cX cX vj cv cdif cvv supfil pm3.27d cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cX cvv wcel vj cv cJ wcel vb cv vj cv
      wcel wa vj cv cX wne wa cJ ctop wcel cK ctop wcel cX cvv wcel cX cY wceq
      cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg fcluscf.1 syl5eqel 3ad2ant1
      adantr cX vj cv cdif cX wss cJ ctop wcel cK ctop wcel cX cY wceq w3a vj
      cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa cX vj cv difss a1i cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa
      vj cv cX wne cX vj cv cdif c0 wne cJ ctop wcel cK ctop wcel cX cY wceq
      w3a vj cv cJ wcel vb cv vj cv wcel wa wa cX vj cv cdif c0 vj cv cX cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa
      wa cX cX vj cv cdif cdif cX c0 cdif wceq vj cv cX wceq cX vj cv cdif c0
      wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa wa cX cX vj cv cdif cdif vj cv cX c0 cdif cX cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa wa vj cv cX wss cX
      cX vj cv cdif cdif vj cv wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj
      cv cJ wcel vj cv cX wss vb cv vj cv wcel cJ ctop wcel cK ctop wcel vj cv
      cJ wcel vj cv cX wss cX cY wceq vj cv cJ cX fcluscf.1 eltopss 3ad2antl1
      adantrr vj cv cX dfss4 sylib cX c0 cdif cX wceq cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa wa cX dif0 a1i eqeq12d
      cX vj cv cdif c0 cX difeq2 syl5bi necon3d impr syl3anc cJ ctop wcel cK
      ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne
      wa wa va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral wa va cv cX wcel
      va cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wi vo cJ wral wa wi va wal vb cv vk cv wcel vk cv
      vj cv wss wa vk cK wrex cX vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      cuni wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj
      cv wcel wa vj cv cX wne wa wa vb cv cX wcel vb cv vp cv wcel vp cv vt cv
      cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp
      cK wral wa vb cv cX wcel vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv
      cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral wa wi vb cv
      vk cv wcel vk cv vj cv wss wa vk cK wrex va cv cX wcel va cv vp cv wcel
      vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0
      wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral
      wa wi va wal cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv
      vj cv wcel wa vj cv cX wne wa wa vb cv cX wcel vb cv vo cv wcel vo cv vs
      cv cin c0 wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa
      vo cJ wrex vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj
      cv cdif vg cv wss wa vg cab wrex wa vp cK wrex wi wi vb cv vk cv wcel vk
      cv vj cv wss wa vk cK wrex vb cv cX wcel vb cv vp cv wcel vp cv vt cv cin
      c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK
      wral wa vb cv cX wcel vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral wa wi cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv
      cX wne wa wa vb cv cX wcel vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vo cJ wrex vb cv vp
      cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wrex wa vp cK wrex wi wi vb cv cX wcel vb cv vk cv wcel vk cv
      vj cv wss wa vk cK wrex cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa vb cv cX wcel vj cv cX wne cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel vb cv cX wcel cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel wa vj cv cX vb cv cJ ctop
      wcel cK ctop wcel vj cv cJ wcel vj cv cX wss cX cY wceq vj cv cJ cX
      fcluscf.1 eltopss 3ad2antl1 sseld impr adantrr cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vb cv
      vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv cdif vg cv
      wss wa vg cab wrex wa vo cJ wrex vb cv vp cv wcel vp cv vt cv cin c0 wceq
      vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vp cK wrex wi
      vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex vb cv cX wcel cJ ctop wcel
      cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX
      wne wa wa vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj
      cv cdif vg cv wss wa vg cab wrex wa vo cJ wrex vb cv vp cv wcel vp cv vt
      cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa
      vp cK wrex wi vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wrex wa vo cJ wrex vb cv vk cv wcel vk cv
      vj cv wss wa vk cK wrex vj cv cJ wcel vb cv vj cv wcel vj cv vs cv cin c0
      wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex vb cv vo cv
      wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wrex wa vo cJ wrex cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv
      cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel vj cv cX wne simprll cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel vj
      cv cX wne simprlr cX vj cv cdif vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wcel vj cv cX vj cv cdif cin c0 wceq vj cv vs cv cin c0 wceq vs vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa
      vj cv vs cv cin c0 wceq vj cv cX vj cv cdif cin c0 wceq vs cX vj cv cdif
      vg cv cX wss cX vj cv cdif vg cv wss wa vg cab vs cv cX vj cv cdif wceq
      vj cv vs cv cin vj cv cX vj cv cdif cin c0 vs cv cX vj cv cdif vj cv
      ineq2 eqeq1d rcla4ev cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa vj cv cX wne wa wa cX vj cv cdif vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wcel cX vj cv cdif cX wss cX vj cv cdif cX
      vj cv cdif wss wa cX vj cv cdif cX wss cX vj cv cdif cX vj cv cdif wss cX
      vj cv difss cX vj cv cdif ssid pm3.2i cJ ctop wcel cK ctop wcel cX cY
      wceq w3a cX vj cv cdif vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wcel cX vj cv cdif cX wss cX vj cv cdif cX vj cv cdif wss wa wb vj cv cJ
      wcel vb cv vj cv wcel wa vj cv cX wne wa cJ ctop wcel cK ctop wcel cX vj
      cv cdif vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wcel cX vj cv cdif
      cX wss cX vj cv cdif cX vj cv cdif wss wa wb cX cY wceq cJ ctop wcel cX
      cvv wcel cX vj cv cdif cvv wcel cX vj cv cdif vg cv cX wss cX vj cv cdif
      vg cv wss wa vg cab wcel cX vj cv cdif cX wss cX vj cv cdif cX vj cv cdif
      wss wa wb cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg fcluscf.1 syl5eqel
      cX vj cv cvv difexg vg cv cX wss cX vj cv cdif vg cv wss wa cX vj cv cdif
      cX wss cX vj cv cdif cX vj cv cdif wss wa vg cX vj cv cdif cvv vg cv cX
      vj cv cdif wceq vg cv cX wss cX vj cv cdif cX wss cX vj cv cdif vg cv wss
      cX vj cv cdif cX vj cv cdif wss vg cv cX vj cv cdif cX sseq1 vg cv cX vj
      cv cdif cX vj cv cdif sseq2 anbi12d elabg 3syl 3ad2ant1 adantr mpbiri vj
      cv cX vj cv cdif cin c0 wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj
      cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vj cv cX difdisj a1i
      sylanc vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wrex wa vb cv vj cv wcel vj cv vs cv cin c0 wceq
      vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vo vj cv cJ vo
      cv vj cv wceq vb cv vo cv wcel vb cv vj cv wcel vo cv vs cv cin c0 wceq
      vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex vj cv vs cv cin c0
      wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex vo cv vj cv
      vb cv eleq2 vo cv vj cv wceq vo cv vs cv cin c0 wceq vj cv vs cv cin c0
      wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab vo cv vj cv wceq
      vo cv vs cv cin vj cv vs cv cin c0 vo cv vj cv vs cv ineq1 eqeq1d rexbidv
      anbi12d rcla4ev sylan32c cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv
      cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vb cv vp cv wcel vp cv vt
      cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa
      vp cK wrex vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex vb cv vo cv
      wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wrex wa vo cJ wrex cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv
      cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vb cv vp cv wcel vp cv vt
      cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa
      vb cv vk cv wcel vk cv vj cv wss wa vk cK wrex vp cK cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa
      vp cv cK wcel vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wrex wa vb cv vk cv wcel vk cv vj cv wss
      wa vk cK wrex vp cv cK wcel vb cv vp cv wcel vp cv vj cv wss vb cv vk cv
      wcel vk cv vj cv wss wa vk cK wrex cJ ctop wcel cK ctop wcel cX cY wceq
      w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel vb
      cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv
      wss wa vg cab wrex wa wa wa cJ ctop wcel cK ctop wcel cX cY wceq w3a vj
      cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel vb cv vp
      cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wrex wa simprl cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv
      cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel vb cv vp cv
      wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wrex simprrl cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel vb cv vp cv
      wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wrex wa wa wa vp cv cX cX vj cv cdif cdif vj cv cJ ctop wcel cK
      ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne
      wa wa vp cv cK wcel vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wrex wa wa wa vp cv cX vj cv cdif
      cin c0 wceq vp cv cX cX vj cv cdif cdif wss cJ ctop wcel cK ctop wcel cX
      cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK
      wcel vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wrex wa vp cv cX vj cv cdif cin c0 wceq cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv
      cX wne wa wa vp cv cK wcel wa vb cv vp cv wcel vp cv vt cv cin c0 wceq vt
      vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex vp cv cX vj cv cdif
      cin c0 wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv
      vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel wa vp cv vt cv cin c0 wceq
      vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex vb cv vp cv wcel
      vp cv cX vj cv cdif cin c0 wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a
      vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel wa vp
      cv vt cv cin c0 wceq vb cv vp cv wcel vp cv cX vj cv cdif cin c0 wceq wi
      vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa
      vp cv cK wcel wa vt cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wcel vp cv vt cv cin c0 wceq vb cv vp cv wcel vp cv cX vj cv cdif cin c0
      wceq cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv
      wcel wa vj cv cX wne wa wa vp cv cK wcel wa vt cv vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wcel vp cv vt cv cin c0 wceq vb cv vp cv wcel wa
      wa wa vp cv cX vj cv cdif cin c0 wss vp cv cX vj cv cdif cin c0 wceq cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa
      vj cv cX wne wa wa vp cv cK wcel wa vt cv vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wcel vp cv vt cv cin c0 wceq vb cv vp cv wcel wa wa wa
      vp cv cX vj cv cdif cin vp cv vt cv cin c0 cJ ctop wcel cK ctop wcel cX
      cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK
      wcel wa vt cv vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wcel vp cv
      vt cv cin c0 wceq vb cv vp cv wcel wa wa wa cX vj cv cdif vt cv wss vp cv
      cX vj cv cdif cin vp cv vt cv cin wss vt cv vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wcel cX vj cv cdif vt cv wss cJ ctop wcel cK ctop wcel
      cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv
      cK wcel wa vp cv vt cv cin c0 wceq vb cv vp cv wcel wa vt cv vg cv cX wss
      cX vj cv cdif vg cv wss wa vg cab wcel vt cv cX wss cX vj cv cdif vt cv
      wss vg cv cX wss cX vj cv cdif vg cv wss wa vt cv cX wss cX vj cv cdif vt
      cv wss wa vg vt cv vt visset vg cv vt cv wceq vg cv cX wss vt cv cX wss
      cX vj cv cdif vg cv wss cX vj cv cdif vt cv wss vg cv vt cv cX sseq1 vg
      cv vt cv cX vj cv cdif sseq2 anbi12d elab pm3.27bi ad2antrl cX vj cv cdif
      vt cv vp cv sslin syl cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel wa vt cv vg cv
      cX wss cX vj cv cdif vg cv wss wa vg cab wcel vp cv vt cv cin c0 wceq vb
      cv vp cv wcel simprrl sseqtrd vp cv cX vj cv cdif cin ss0 syl exp45
      r19.23adv com23 imp3a impr cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv
      cJ wcel vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel vb cv vp cv
      wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wrex wa wa wa vp cv cX wss vp cv cX vj cv cdif cin c0 wceq vp cv
      cX cX vj cv cdif cdif wss wb cJ ctop wcel cK ctop wcel cX cY wceq w3a vp
      cv cK wcel vp cv cX wss vj cv cJ wcel vb cv vj cv wcel wa vj cv cX wne wa
      vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wrex wa cJ ctop wcel cK ctop wcel cX cY wceq w3a vp cv
      cK wcel wa vp cv cY cX cK ctop wcel cJ ctop wcel vp cv cK wcel vp cv cY
      wss cX cY wceq vp cv cK cY fcluscf.2 eltopss 3ad2antl2 cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cX cY wceq vp cv cK wcel cJ ctop wcel cK ctop
      wcel cX cY wceq 3simp3 adantr sseqtr4d ad2ant2r vp cv cX vj cv cdif cX
      reldisj syl mpbid cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel
      vb cv vj cv wcel wa vj cv cX wne wa wa vp cv cK wcel vb cv vp cv wcel vp
      cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wrex wa wa wa vj cv cX wss cX cX vj cv cdif cdif vj cv wceq cJ ctop wcel
      cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv cX
      wne wa wa vj cv cX wss vp cv cK wcel vb cv vp cv wcel vp cv vt cv cin c0
      wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa wa cJ ctop
      wcel cK ctop wcel cX cY wceq w3a vj cv cJ wcel vb cv vj cv wcel wa vj cv
      cX wss vj cv cX wne cJ ctop wcel cK ctop wcel cX cY wceq w3a vj cv cJ
      wcel vj cv cX wss vb cv vj cv wcel cJ ctop wcel cK ctop wcel vj cv cJ
      wcel vj cv cX wss cX cY wceq vj cv cJ cX fcluscf.1 eltopss 3ad2antl1
      adantrr adantrr adantr vj cv cX dfss4 sylib sseqtrd vb cv vk cv wcel vk
      cv vj cv wss wa vb cv vp cv wcel vp cv vj cv wss wa vk vp cv cK vk cv vp
      cv wceq vb cv vk cv wcel vb cv vp cv wcel vk cv vj cv wss vp cv vj cv wss
      vk cv vp cv vb cv eleq2 vk cv vp cv vj cv sseq1 anbi12d rcla4ev sylan32c
      exp32 r19.23adv imim2d mpid imim2d mpid vb cv cX wcel vb cv vp cv wcel vp
      cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vp cK wral wa vb cv cX wcel vb cv vo cv wcel vo cv vs cv cin c0
      wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral
      wa wi vb cv cX wcel vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral vb cv vo cv wcel
      vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vo cJ wral wi wi vb cv cX wcel vb cv vo cv wcel vo cv vs cv cin
      c0 wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vo cJ
      wrex vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wrex wa vp cK wrex wi wi vb cv cX wcel vb cv vp
      cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa
      vg cab wral wi vp cK wral vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral imdistan
      vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wi vp cK wral vb cv vo cv wcel vo cv vs cv cin c0
      wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral
      wi vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv cdif
      vg cv wss wa vg cab wrex wa vo cJ wrex vb cv vp cv wcel vp cv vt cv cin
      c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vp cK
      wrex wi vb cv cX wcel vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral vb cv vo cv wcel
      vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wi vo cJ wral wi vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral wn vb cv vp cv
      wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg
      cab wral wi vp cK wral wn vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vo cJ wrex vb cv vp
      cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wrex wa vp cK wrex vb cv vp cv wcel vp cv vt cv cin c0 wne vt
      vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral vb cv
      vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wral wi vo cJ wral con3 vb cv vo cv wcel vo cv vs cv cin c0
      wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vo cJ wrex
      vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wral wn wa vo cJ wrex vb cv vo cv wcel vo cv vs cv cin
      c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ
      wral wn vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wrex wa vb cv vo cv wcel vo cv vs cv cin c0 wne
      vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wn wa vo cJ vo cv
      vs cv cin c0 wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex
      vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral wn vb cv vo cv wcel vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wrex vo cv vs cv cin c0 wne wn vs vg cv cX wss
      cX vj cv cdif vg cv wss wa vg cab wrex vo cv vs cv cin c0 wne vs vg cv cX
      wss cX vj cv cdif vg cv wss wa vg cab wral wn vo cv vs cv cin c0 wne wn
      vo cv vs cv cin c0 wceq vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      vo cv vs cv cin c0 nne rexbii vo cv vs cv cin c0 wne vs vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab rexnal bitr3i anbi2i rexbii vb cv vo cv
      wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg
      cab wral vo cJ rexanali bitri vb cv vp cv wcel vp cv vt cv cin c0 wceq vt
      vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex wa vp cK wrex vb cv
      vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wral wn wa vp cK wrex vb cv vp cv wcel vp cv vt cv cin c0 wne
      vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral wn
      vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wrex wa vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv
      cX wss cX vj cv cdif vg cv wss wa vg cab wral wn wa vp cK vp cv vt cv cin
      c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wrex vp cv vt
      cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wn
      vb cv vp cv wcel vp cv vt cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg
      cv wss wa vg cab wrex vp cv vt cv cin c0 wne wn vt vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wrex vp cv vt cv cin c0 wne vt vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wral wn vp cv vt cv cin c0 wne wn vp cv vt
      cv cin c0 wceq vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab vp cv vt
      cv cin c0 nne rexbii vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif
      vg cv wss wa vg cab rexnal bitr3i anbi2i rexbii vb cv vp cv wcel vp cv vt
      cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral vp
      cK rexanali bitri 3imtr4g imim2i sylbir syl5 va cv cX wcel va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg
      cab wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin
      c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ
      wral wa wi vb cv cX wcel vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv
      cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK wral wa vb cv cX
      wcel vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wral wi vo cJ wral wa wi va vb va cv vb cv wceq
      va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX
      vj cv cdif vg cv wss wa vg cab wral wi vp cK wral wa vb cv cX wcel vb cv
      vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs
      cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi
      vo cJ wral wa vb cv cX wcel vb cv vo cv wcel vo cv vs cv cin c0 wne vs vg
      cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral wa va cv
      vb cv wceq va cv cX wcel vb cv cX wcel va cv vp cv wcel vp cv vt cv cin
      c0 wne vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK
      wral vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wral wi vp cK wral va cv vb cv cX eleq1 va cv vb
      cv wceq va cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv cX wss cX vj cv
      cdif vg cv wss wa vg cab wral wi vb cv vp cv wcel vp cv vt cv cin c0 wne
      vt vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vp cK va cv vb
      cv wceq va cv vp cv wcel vb cv vp cv wcel vp cv vt cv cin c0 wne vt vg cv
      cX wss cX vj cv cdif vg cv wss wa vg cab wral va cv vb cv vp cv eleq1
      imbi1d ralbidv anbi12d va cv vb cv wceq va cv cX wcel vb cv cX wcel va cv
      vo cv wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss
      wa vg cab wral wi vo cJ wral vb cv vo cv wcel vo cv vs cv cin c0 wne vs
      vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vo cJ wral va cv
      vb cv cX eleq1 va cv vb cv wceq va cv vo cv wcel vo cv vs cv cin c0 wne
      vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab wral wi vb cv vo cv
      wcel vo cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg
      cab wral wi vo cJ va cv vb cv wceq va cv vo cv wcel vb cv vo cv wcel vo
      cv vs cv cin c0 wne vs vg cv cX wss cX vj cv cdif vg cv wss wa vg cab
      wral va cv vb cv vo cv eleq1 imbi1d ralbidv anbi12d imbi12d a4v syl5
      imim2d mpid syld expr pm2.61dne ex com23 imp r19.21aivv jca cJ ctop wcel
      cK ctop wcel cX cY wceq w3a cJ cK cfne wbr cX cY wceq vb cv vk cv wcel vk
      cv vj cv wss wa vk cK wrex vb vj cv wral vj cJ wral wa wb cX vf cv cuni
      wceq va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral
      wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs
      vf cv wral wi vo cJ wral wa wi va wal wi vf cfil wral cK ctop wcel cJ
      ctop wcel cJ cK cfne wbr cX cY wceq vb cv vk cv wcel vk cv vj cv wss wa
      vk cK wrex vb vj cv wral vj cJ wral wa wb cX cY wceq vj vb vk cJ cK ctop
      cX cY fcluscf.1 fcluscf.2 isfne2 3ad2ant2 adantr mpbird ex impbid cJ ctop
      wcel cK ctop wcel cX cY wceq w3a cX vf cv cuni wceq va cv cX wcel va cv
      vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX
      wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral
      wa wi va wal wi cX vf cv cuni wceq vf cv cK cfclus cfv cfv vf cv cJ
      cfclus cfv cfv wss wi vf cfil cJ ctop wcel cK ctop wcel cX cY wceq w3a vf
      cv cfil wcel wa cX vf cv cuni wceq va cv cX wcel va cv vp cv wcel vp cv
      vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv vo cv
      wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va wal vf
      cv cK cfclus cfv cfv vf cv cJ cfclus cfv cfv wss cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni wceq va cv cX wcel va
      cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv
      cX wcel va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ
      wral wa wi va wal vf cv cK cfclus cfv cfv vf cv cJ cfclus cfv cfv wss wb
      cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv
      wral wi vp cK wral wa va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0
      wne vs vf cv wral wi vo cJ wral wa wi va wal va cv vf cv cK cfclus cfv
      cfv wcel va cv vf cv cJ cfclus cfv cfv wcel wi va wal vf cv cK cfclus cfv
      cfv vf cv cJ cfclus cfv cfv wss cJ ctop wcel cK ctop wcel cX cY wceq w3a
      vf cv cfil wcel cX vf cv cuni wceq wa wa va cv cX wcel va cv vp cv wcel
      vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cX wcel va cv
      vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wi va cv
      vf cv cK cfclus cfv cfv wcel va cv vf cv cJ cfclus cfv cfv wcel wi va cJ
      ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni wceq
      wa wa va cv cX wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral
      wi vp cK wral wa va cv vf cv cK cfclus cfv cfv wcel va cv cX wcel va cv
      vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa va cv vf
      cv cJ cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa va cv cX wcel va cv vp cv wcel vp cv
      vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv cY wcel va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral wa va cv vf cv cK
      cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil
      wcel cX vf cv cuni wceq wa wa va cv cX wcel va cv cY wcel va cv vp cv
      wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK wral cJ ctop wcel cK
      ctop wcel cX cY wceq w3a va cv cX wcel va cv cY wcel wb vf cv cfil wcel
      cX vf cv cuni wceq wa cX cY wceq cJ ctop wcel va cv cX wcel va cv cY wcel
      wb cK ctop wcel cX cY va cv eleq2 3ad2ant3 adantr anbi1d cK ctop wcel vf
      cv cfil wcel cY vf cv cuni wceq va cv vf cv cK cfclus cfv cfv wcel va cv
      cY wcel va cv vp cv wcel vp cv vt cv cin c0 wne vt vf cv wral wi vp cK
      wral wa wb cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil wcel cX vf
      cv cuni wceq wa wa va cv vp vf cv cK cY vf cv cuni vt fcluscf.2 vf cv
      cuni eqid isfclus cJ ctop wcel cK ctop wcel cX cY wceq w3a cK ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq wa cJ ctop wcel cK ctop wcel cX cY
      wceq 3simp2 adantr cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil
      wcel cX vf cv cuni wceq simprl cJ ctop wcel cK ctop wcel cX cY wceq w3a
      vf cv cfil wcel cX vf cv cuni wceq wa wa cX cY vf cv cuni cJ ctop wcel cK
      ctop wcel cX cY wceq w3a cX cY wceq vf cv cfil wcel cX vf cv cuni wceq wa
      cJ ctop wcel cK ctop wcel cX cY wceq 3simp3 adantr cJ ctop wcel cK ctop
      wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni wceq simprr eqtr3d
      syl3anc bitr4d cJ ctop wcel cK ctop wcel cX cY wceq w3a vf cv cfil wcel
      cX vf cv cuni wceq wa wa va cv vf cv cJ cfclus cfv cfv wcel va cv cX wcel
      va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa cJ
      ctop wcel cK ctop wcel vf cv cfil wcel cX vf cv cuni wceq wa va cv vf cv
      cJ cfclus cfv cfv wcel va cv cX wcel va cv vo cv wcel vo cv vs cv cin c0
      wne vs vf cv wral wi vo cJ wral wa wb cX cY wceq cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq va cv vf cv cJ cfclus cfv cfv wcel va cv cX wcel
      va cv vo cv wcel vo cv vs cv cin c0 wne vs vf cv wral wi vo cJ wral wa wb
      va cv vo vf cv cJ cX vf cv cuni vs fcluscf.1 vf cv cuni eqid isfclus
      3expb 3ad2antl1 bicomd imbi12d albidv va vf cv cK cfclus cfv cfv vf cv cJ
      cfclus cfv cfv dfss2 syl6bbr anassrs pm5.74da ralbidva 3bitrd $.
      $( [12-Nov-2009] $) $( [12-Nov-2009] $)
  $}

  ${
    $d a o s F $. $d a o s J $. $d a o s X $. $d a o s Y $.
    flimfcls.1 $e |- X = U. J $.
    flimfcls.2 $e |- Y = U. F $.
    $( A limit point is a cluster point. $)
    flimfcls $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( ( fLim1 ` J ) ` F )
    C_ ( ( fClus ` J ) ` F ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a va cF cJ cflim1 cfv cfv cF cJ
      cfclus cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv cX wcel va
      cv vo cv wcel vo cv cF wcel wi vo cJ wral wa va cv cX wcel va cv vo cv
      wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral wa va cv cF cJ
      cflim1 cfv cfv wcel va cv cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a va cv cX wcel va cv vo cv wcel vo cv cF wcel wi vo cJ
      wral va cv vo cv wcel vo cv vs cv cin c0 wne vs cF wral wi vo cJ wral cJ
      ctop wcel cF cfil wcel cX cY wceq w3a va cv cX wcel va cv vo cv wcel vo
      cv cF wcel wi vo cJ wral va cv vo cv wcel vo cv vs cv cin c0 wne vs cF
      wral wi vo cJ wral wi cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv cX
      wcel wa va cv vo cv wcel vo cv cF wcel wi va cv vo cv wcel vo cv vs cv
      cin c0 wne vs cF wral wi vo cJ cJ ctop wcel cF cfil wcel cX cY wceq w3a
      va cv cX wcel vo cv cJ wcel va cv vo cv wcel vo cv cF wcel wi va cv vo cv
      wcel vo cv vs cv cin c0 wne vs cF wral wi wi cJ ctop wcel cF cfil wcel cX
      cY wceq w3a va cv cX wcel vo cv cJ wcel wa wa va cv vo cv wcel vo cv cF
      wcel vo cv vs cv cin c0 wne vs cF wral cJ ctop wcel cF cfil wcel cX cY
      wceq w3a va cv cX wcel vo cv cJ wcel wa wa va cv vo cv wcel vo cv cF wcel
      vo cv vs cv cin c0 wne vs cF wral cJ ctop wcel cF cfil wcel cX cY wceq
      w3a va cv cX wcel vo cv cJ wcel wa va cv vo cv wcel vo cv cF wcel wa vo
      cv vs cv cin c0 wne vs cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a
      va cv cX wcel vo cv cJ wcel wa va cv vo cv wcel vo cv cF wcel wa wa wa vo
      cv vs cv cin c0 wne vs cF cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv
      cX wcel vo cv cJ wcel wa va cv vo cv wcel vo cv cF wcel wa wa wa vs cv cF
      wcel vo cv vs cv cin cF wcel vo cv vs cv cin c0 wne cJ ctop wcel cF cfil
      wcel cX cY wceq w3a va cv vo cv wcel vo cv cF wcel wa vs cv cF wcel vo cv
      vs cv cin cF wcel wi va cv cX wcel vo cv cJ wcel wa cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cF wcel vs cv cF wcel vo cv vs cv cin cF wcel
      wi va cv vo cv wcel cF cfil wcel cJ ctop wcel vo cv cF wcel vs cv cF wcel
      vo cv vs cv cin cF wcel wi cX cY wceq cF cfil wcel vo cv cF wcel vs cv cF
      wcel vo cv vs cv cin cF wcel vo cv vs cv cF filint 3expia 3ad2antl2
      adantrl adantrl cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv vs cv cin
      cF wcel vo cv vs cv cin c0 wne wi va cv cX wcel vo cv cJ wcel wa va cv vo
      cv wcel vo cv cF wcel wa wa cF cfil wcel cJ ctop wcel vo cv vs cv cin cF
      wcel vo cv vs cv cin c0 wne wi cX cY wceq cF cfil wcel vo cv vs cv cin cF
      wcel vo cv vs cv cin c0 vo cv vs cv cin c0 wceq vo cv vs cv cin cF wcel
      wn c0 cF wcel wn cF cfil wcel vo cv vs cv cin c0 wceq vo cv vs cv cin cF
      wcel c0 cF wcel vo cv vs cv cin c0 cF eleq1 notbid cF filesn syl5cbir
      necon2ad 3ad2ant2 adantr syld r19.21aiv expr exp3a a2d anassrs r19.20dva
      ex imdistand cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv cF cJ cflim1
      cfv cfv wcel va cv cX wcel va cv vo cv wcel vo cv cF wcel wi vo cJ wral
      wa cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv cX wcel wa cJ ctop wcel
      cF cfil wcel cX cY wceq w3a va cv cF cJ cflim1 cfv cfv wcel wa cJ ctop
      wcel cF cfil wcel cX cY wceq w3a va cv cX wcel cJ ctop wcel cF cfil wcel
      cX cY wceq w3a va cv cF cJ cflim1 cfv cfv wcel pm3.26 va cv cF cJ cX cY
      flimfcls.1 flimfcls.2 flimelbas jca va cv cX wcel va cv vo cv wcel vo cv
      cF wcel wi vo cJ wral wa va cv cX wcel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a va cv cX wcel va cv vo cv wcel vo cv cF wcel wi vo cJ wral
      pm3.26 anim2i cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv cX wcel wa
      va cv cF cJ cflim1 cfv cfv wcel va cv vo cv wcel vo cv cF wcel wi vo cJ
      wral va cv cX wcel va cv vo cv wcel vo cv cF wcel wi vo cJ wral wa va cv
      vo cF cJ cX cY flimfcls.1 flimfcls.2 flimopn va cv cX wcel va cv vo cv
      wcel vo cv cF wcel wi vo cJ wral va cv cX wcel va cv vo cv wcel vo cv cF
      wcel wi vo cJ wral wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a va cv
      cX wcel va cv vo cv wcel vo cv cF wcel wi vo cJ wral ibar adantl bitrd
      pm5.21nd va cv vo cF cJ cX cY vs flimfcls.1 flimfcls.2 isfclus 3imtr4d
      ssrdv $.
      $( [12-Nov-2009] $) $( [12-Nov-2009] $)
  $}

  ${
    $d g x y A $. $d g x y F $. $d g x y J $. $d g x y X $. $d g x y Y $.
    fclsfnflim.1 $e |- X = U. J $.
    fclsfnflim.2 $e |- Y = U. F $.
    $( A filter clusters at a point iff a finer filter converges to it. $)
    fclsfnflim $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( A e. ( ( fClus `
    J ) ` F ) <-> E. g e. Fil ( X = U. g /\ F C_ g /\ A e. ( ( fLim1 ` J ) ` g
    ) ) ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cX
      vg cv cuni wceq cF vg cv wss cA vg cv cJ cflim1 cfv cfv wcel w3a vg cfil
      wrex cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel cX vg cv cuni wceq cF vg cv wss cA vg cv cJ cflim1 cfv cfv wcel w3a
      vg cfil wrex cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX
      cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq cF cF cA csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv wss cA cF cA csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cJ cflim1 cfv cfv wcel w3a cX vg cv cuni wceq cF vg cv wss cA
      vg cv cJ cflim1 cfv cfv wcel w3a vg cfil wrex cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cX vg cv cuni wceq cF vg
      cv wss cA vg cv cJ cflim1 cfv cfv wcel w3a cX cF cA csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cuni wceq cF cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfg cfv wss cA cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel w3a vg cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil vg
      cv cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv wceq cX vg cv cuni wceq
      cX cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq cF vg cv wss
      cF cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss cA vg cv cJ cflim1
      cfv cfv wcel cA cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1
      cfv cfv wcel vg cv cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv wceq vg
      cv cuni cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni cX vg cv cF cA
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv unieq eqeq2d vg cv cF cA csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cF sseq2 vg cv cF cA csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv wceq vg cv cJ cflim1 cfv cfv cF cA csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv cA vg cv cF cA csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cJ cflim1 cfv fveq2 eleq2d 3anbi123d rcla4ev cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF
      cA csn cJ cnei cfv cfv cun cfi cfv cfbas wcel cF cA csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas
      wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv cfv
      cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn
      cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cA csn cJ cnei cfv cfv cun c0 wne cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun c0 wne cX cY wceq cF cfil
      wcel cY cF wcel cF c0 wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cY
      fclsfnflim.2 filusb cF cY ne0i cF cF cA csn cJ cnei cfv cfv cun wss cF c0
      wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cA csn cJ cnei cfv cfv ssun1
      cF cF cA csn cJ cnei cfv cfv cun ssn0 mpan 3syl 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa c0 cF cA
      csn cJ cnei cfv cfv cun cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ
      cnei cfv cfv wral vx cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cF cA csn cJ
      cnei cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa vx cv vy cv
      cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa vy cv
      vx cv cin c0 wne vx cv vy cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vy cv cA csn cJ cnei cfv cfv wcel
      w3a vx cv cF wcel vy cv vx cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei
      cfv cfv wcel wa wa wa cA vx cv cF cJ vy cv cX cY fclsfnflim.1
      fclsfnflim.2 fclusneii cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa
      wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel
      vy cv cA csn cJ cnei cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv
      cfv wcel wa wa pm3.26 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa
      simprl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel simprrr 3jca cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF
      wcel vy cv cA csn cJ cnei cfv cfv wcel simprrl sylanc vy cv vx cv cin vx
      cv vy cv cin c0 vy cv vx cv incom neeq1i sylib expr r19.21aivv cF cfbas
      wcel cA csn cJ cnei cfv cfv cfbas wcel c0 cF cA csn cJ cnei cfv cfv cun
      cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ cnei cfv cfv wral vx cF
      wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa vx vy cF cA csn cJ cnei cfv cfv fbunfip cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cfbas wcel cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ
      ctop wcel cF cfbas wcel cX cY wceq cF filfbas 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn
      cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel
      cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cX
      fclsfnflim.1 neifil cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel
      cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq 3simp1
      adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1 fclsfnflim.2
      fclselbas cA cX snssi syl cA cF cJ cfclus cfv cfv wcel cA csn c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv snnzg
      adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF
      cA csn cJ cnei cfv cfv cun cvv wcel cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv
      cfv cun cfi cfv wnel wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun cvv wcel cX cY wceq cF
      cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA csn cJ cnei cfv cfv cun
      cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ cnei cfv cfv cfil cvv unexg
      mpan2 3ad2ant2 adantr cF cA csn cJ cnei cfv cfv cun cvv fsubbas syl
      mpbird cF cA csn cJ cnei cfv cfv cun cfi cfv fgfil syl cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cX cF cA csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cuni wceq cF cF cA csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv wss cA cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv
      cJ cflim1 cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cX cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ
      cnei cfv cfv cun cfi cfv cuni cF cA csn cJ cnei cfv cfv cun cfi cfv cfg
      cfv cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cX cF cuni cA csn cJ cnei cfv cfv cuni cun cF cA csn cJ cnei cfv
      cfv cun cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel wa cX cX cun cF cuni cA csn cJ cnei cfv cfv cuni cun cX cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cX cF
      cuni cX cA csn cJ cnei cfv cfv cuni cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cX cF cuni wceq cA cF cJ cfclus cfv cfv wcel cX cY wceq cJ ctop wcel
      cX cF cuni wceq cF cfil wcel cX cY wceq cX cF cuni wceq cY cF cuni cX
      fclsfnflim.2 eqeq2i biimpi 3ad2ant3 adantr cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cnei cfv cfv cuni
      cX cJ ctop wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX wceq cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn
      cJ cX fclsfnflim.1 unnei cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop
      wcel cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq
      3simp1 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1
      fclsfnflim.2 fclselbas cA cX snssi syl sylanc eqcomd uneq12d cX unidm
      syl5eqr cF cA csn cJ cnei cfv cfv uniun syl6eqr cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv
      cfv cun cfi cfv cuni wceq cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ
      ctop wcel cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv cfv
      cun cfi cfv cuni wceq cX cY wceq cF cfil wcel cF cA csn cJ cnei cfv cfv
      cun cvv wcel cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv cfv
      cun cfi cfv cuni wceq cF cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ
      cnei cfv cfv cfil cvv unexg mpan2 cF cA csn cJ cnei cfv cfv cun cvv fiuni
      syl 3ad2ant2 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas wcel
      cF cA csn cJ cnei cfv cfv cun cfi cfv cuni cF cA csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cuni wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF
      cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas
      wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv cfv
      cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn
      cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cA csn cJ cnei cfv cfv cun c0 wne cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun c0 wne cX cY wceq cF cfil
      wcel cY cF wcel cF c0 wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cY
      fclsfnflim.2 filusb cF cY ne0i cF cF cA csn cJ cnei cfv cfv cun wss cF c0
      wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cA csn cJ cnei cfv cfv ssun1
      cF cF cA csn cJ cnei cfv cfv cun ssn0 mpan 3syl 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa c0 cF cA
      csn cJ cnei cfv cfv cun cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ
      cnei cfv cfv wral vx cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cF cA csn cJ
      cnei cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa vx cv vy cv
      cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa vy cv
      vx cv cin c0 wne vx cv vy cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vy cv cA csn cJ cnei cfv cfv wcel
      w3a vx cv cF wcel vy cv vx cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei
      cfv cfv wcel wa wa wa cA vx cv cF cJ vy cv cX cY fclsfnflim.1
      fclsfnflim.2 fclusneii cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa
      wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel
      vy cv cA csn cJ cnei cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv
      cfv wcel wa wa pm3.26 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa
      simprl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel simprrr 3jca cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF
      wcel vy cv cA csn cJ cnei cfv cfv wcel simprrl sylanc vy cv vx cv cin vx
      cv vy cv cin c0 vy cv vx cv incom neeq1i sylib expr r19.21aivv cF cfbas
      wcel cA csn cJ cnei cfv cfv cfbas wcel c0 cF cA csn cJ cnei cfv cfv cun
      cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ cnei cfv cfv wral vx cF
      wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa vx vy cF cA csn cJ cnei cfv cfv fbunfip cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cfbas wcel cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ
      ctop wcel cF cfbas wcel cX cY wceq cF filfbas 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn
      cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel
      cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cX
      fclsfnflim.1 neifil cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel
      cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq 3simp1
      adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1 fclsfnflim.2
      fclselbas cA cX snssi syl cA cF cJ cfclus cfv cfv wcel cA csn c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv snnzg
      adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF
      cA csn cJ cnei cfv cfv cun cvv wcel cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv
      cfv cun cfi cfv wnel wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun cvv wcel cX cY wceq cF
      cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA csn cJ cnei cfv cfv cun
      cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ cnei cfv cfv cfil cvv unexg
      mpan2 3ad2ant2 adantr cF cA csn cJ cnei cfv cfv cun cvv fsubbas syl
      mpbird cF cA csn cJ cnei cfv cfv cun cfi cfv cF cA csn cJ cnei cfv cfv
      cun cfi cfv cuni cF cA csn cJ cnei cfv cfv cun cfi cfv cuni eqid fgbas
      syl 3eqtrd cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel wa cF cF cA csn cJ cnei cfv cfv cun cfi cfv cF cA csn cJ cnei
      cfv cfv cun cfi cfv cfg cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa cF cF cA csn cJ cnei cfv cfv cun cF cA csn
      cJ cnei cfv cfv cun cfi cfv cF cF cA csn cJ cnei cfv cfv cun wss cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF cA
      csn cJ cnei cfv cfv ssun1 a1i cJ ctop wcel cF cfil wcel cX cY wceq w3a cF
      cA csn cJ cnei cfv cfv cun cF cA csn cJ cnei cfv cfv cun cfi cfv wss cA
      cF cJ cfclus cfv cfv wcel cF cfil wcel cJ ctop wcel cF cA csn cJ cnei cfv
      cfv cun cF cA csn cJ cnei cfv cfv cun cfi cfv wss cX cY wceq cF cfil wcel
      cF cA csn cJ cnei cfv cfv cun cvv wcel cF cA csn cJ cnei cfv cfv cun cF
      cA csn cJ cnei cfv cfv cun cfi cfv wss cF cfil wcel cA csn cJ cnei cfv
      cfv cvv wcel cF cA csn cJ cnei cfv cfv cun cvv wcel cA csn cJ cnei cfv
      fvex cF cA csn cJ cnei cfv cfv cfil cvv unexg mpan2 cF cA csn cJ cnei cfv
      cfv cun cvv abfi2 syl 3ad2ant2 adantr sstrd cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun
      cfi cfv cfbas wcel cF cA csn cJ cnei cfv cfv cun cfi cfv cF cA csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv
      cfv cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn
      cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cA csn cJ cnei cfv cfv cun c0 wne cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun c0 wne cX cY wceq cF cfil
      wcel cY cF wcel cF c0 wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cY
      fclsfnflim.2 filusb cF cY ne0i cF cF cA csn cJ cnei cfv cfv cun wss cF c0
      wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cA csn cJ cnei cfv cfv ssun1
      cF cF cA csn cJ cnei cfv cfv cun ssn0 mpan 3syl 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa c0 cF cA
      csn cJ cnei cfv cfv cun cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ
      cnei cfv cfv wral vx cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cF cA csn cJ
      cnei cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa vx cv vy cv
      cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa vy cv
      vx cv cin c0 wne vx cv vy cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vy cv cA csn cJ cnei cfv cfv wcel
      w3a vx cv cF wcel vy cv vx cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei
      cfv cfv wcel wa wa wa cA vx cv cF cJ vy cv cX cY fclsfnflim.1
      fclsfnflim.2 fclusneii cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa
      wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel
      vy cv cA csn cJ cnei cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv
      cfv wcel wa wa pm3.26 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa
      simprl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel simprrr 3jca cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF
      wcel vy cv cA csn cJ cnei cfv cfv wcel simprrl sylanc vy cv vx cv cin vx
      cv vy cv cin c0 vy cv vx cv incom neeq1i sylib expr r19.21aivv cF cfbas
      wcel cA csn cJ cnei cfv cfv cfbas wcel c0 cF cA csn cJ cnei cfv cfv cun
      cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ cnei cfv cfv wral vx cF
      wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa vx vy cF cA csn cJ cnei cfv cfv fbunfip cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cfbas wcel cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ
      ctop wcel cF cfbas wcel cX cY wceq cF filfbas 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn
      cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel
      cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cX
      fclsfnflim.1 neifil cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel
      cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq 3simp1
      adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1 fclsfnflim.2
      fclselbas cA cX snssi syl cA cF cJ cfclus cfv cfv wcel cA csn c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv snnzg
      adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF
      cA csn cJ cnei cfv cfv cun cvv wcel cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv
      cfv cun cfi cfv wnel wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun cvv wcel cX cY wceq cF
      cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA csn cJ cnei cfv cfv cun
      cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ cnei cfv cfv cfil cvv unexg
      mpan2 3ad2ant2 adantr cF cA csn cJ cnei cfv cfv cun cvv fsubbas syl
      mpbird cF cA csn cJ cnei cfv cfv cun cfi cfv fbssfg syl sstrd cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA cF cA
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cA cX wcel
      cA csn cJ cnei cfv cfv cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss
      wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel
      wa cA cX wcel cA csn cJ cnei cfv cfv cF cA csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv wss cA cF cJ cX cY fclsfnflim.1 fclsfnflim.2 fclselbas cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA
      csn cJ cnei cfv cfv cF cA csn cJ cnei cfv cfv cun cfi cfv cF cA csn cJ
      cnei cfv cfv cun cfi cfv cfg cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cnei cfv cfv cF cA csn cJ cnei
      cfv cfv cun cF cA csn cJ cnei cfv cfv cun cfi cfv cA csn cJ cnei cfv cfv
      cF cA csn cJ cnei cfv cfv cun wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cnei cfv cfv cF ssun2 a1i
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA csn cJ cnei cfv cfv cun cF
      cA csn cJ cnei cfv cfv cun cfi cfv wss cA cF cJ cfclus cfv cfv wcel cF
      cfil wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun cF cA csn cJ cnei
      cfv cfv cun cfi cfv wss cX cY wceq cF cfil wcel cF cA csn cJ cnei cfv cfv
      cun cvv wcel cF cA csn cJ cnei cfv cfv cun cF cA csn cJ cnei cfv cfv cun
      cfi cfv wss cF cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA csn cJ
      cnei cfv cfv cun cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ cnei cfv
      cfv cfil cvv unexg mpan2 cF cA csn cJ cnei cfv cfv cun cvv abfi2 syl
      3ad2ant2 adantr sstrd cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas wcel
      cF cA csn cJ cnei cfv cfv cun cfi cfv cF cA csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas wcel cF cA
      csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv cfv cun cfi cfv
      wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv cfv
      cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA csn cJ
      cnei cfv cfv cun c0 wne cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ ctop
      wcel cF cA csn cJ cnei cfv cfv cun c0 wne cX cY wceq cF cfil wcel cY cF
      wcel cF c0 wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cY fclsfnflim.2
      filusb cF cY ne0i cF cF cA csn cJ cnei cfv cfv cun wss cF c0 wne cF cA
      csn cJ cnei cfv cfv cun c0 wne cF cA csn cJ cnei cfv cfv ssun1 cF cF cA
      csn cJ cnei cfv cfv cun ssn0 mpan 3syl 3ad2ant2 adantr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa c0 cF cA csn cJ
      cnei cfv cfv cun cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ cnei
      cfv cfv wral vx cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cF cA csn cJ cnei cfv
      cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel
      vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa vx cv vy cv cin c0 wne
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx
      cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa vy cv vx cv cin c0
      wne vx cv vy cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF
      cJ cfclus cfv cfv wcel vy cv cA csn cJ cnei cfv cfv wcel w3a vx cv cF
      wcel vy cv vx cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel
      wa wa wa cA vx cv cF cJ vy cv cX cY fclsfnflim.1 fclsfnflim.2 fclusneii
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx
      cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vy cv cA csn cJ
      cnei cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa
      pm3.26 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa simprl cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF
      wcel vy cv cA csn cJ cnei cfv cfv wcel simprrr 3jca cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA
      csn cJ cnei cfv cfv wcel simprrl sylanc vy cv vx cv cin vx cv vy cv cin
      c0 vy cv vx cv incom neeq1i sylib expr r19.21aivv cF cfbas wcel cA csn cJ
      cnei cfv cfv cfbas wcel c0 cF cA csn cJ cnei cfv cfv cun cfi cfv wnel vx
      cv vy cv cin c0 wne vy cA csn cJ cnei cfv cfv wral vx cF wral wb cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa vx vy cF
      cA csn cJ cnei cfv cfv fbunfip cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cfbas wcel cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ ctop wcel cF
      cfbas wcel cX cY wceq cF filfbas 3ad2ant2 adantr cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cnei cfv
      cfv cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel cA csn cX
      wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cX
      fclsfnflim.1 neifil cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel
      cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq 3simp1
      adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1 fclsfnflim.2
      fclselbas cA cX snssi syl cA cF cJ cfclus cfv cfv wcel cA csn c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv snnzg
      adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF
      cA csn cJ cnei cfv cfv cun cvv wcel cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv
      cfv cun cfi cfv wnel wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun cvv wcel cX cY wceq cF
      cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA csn cJ cnei cfv cfv cun
      cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ cnei cfv cfv cfil cvv unexg
      mpan2 3ad2ant2 adantr cF cA csn cJ cnei cfv cfv cun cvv fsubbas syl
      mpbird cF cA csn cJ cnei cfv cfv cun cfi cfv fbssfg syl sstrd jca cJ ctop
      wcel cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cX cF cA csn
      cJ cnei cfv cfv cun cfi cfv cfg cfv cuni wceq cA cF cA csn cJ cnei cfv
      cfv cun cfi cfv cfg cfv cJ cflim1 cfv cfv wcel cA cX wcel cA csn cJ cnei
      cfv cfv cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv wss wa wb cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA cF cA
      csn cJ cnei cfv cfv cun cfi cfv cfg cfv cJ cX cF cA csn cJ cnei cfv cfv
      cun cfi cfv cfg cfv cuni fclsfnflim.1 cF cA csn cJ cnei cfv cfv cun cfi
      cfv cfg cfv cuni eqid isfillim cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cJ ctop wcel cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY
      wceq 3simp1 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas wcel
      cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cfil wcel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF cA csn cJ
      cnei cfv cfv cun cfi cfv cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne
      c0 cF cA csn cJ cnei cfv cfv cun cfi cfv wnel wa cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv
      cfv cun c0 wne c0 cF cA csn cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cF cA csn cJ cnei cfv cfv cun c0 wne cA cF cJ
      cfclus cfv cfv wcel cF cfil wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv
      cun c0 wne cX cY wceq cF cfil wcel cY cF wcel cF c0 wne cF cA csn cJ cnei
      cfv cfv cun c0 wne cF cY fclsfnflim.2 filusb cF cY ne0i cF cF cA csn cJ
      cnei cfv cfv cun wss cF c0 wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cA
      csn cJ cnei cfv cfv ssun1 cF cF cA csn cJ cnei cfv cfv cun ssn0 mpan 3syl
      3ad2ant2 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel wa c0 cF cA csn cJ cnei cfv cfv cun cfi cfv wnel vx cv vy cv
      cin c0 wne vy cA csn cJ cnei cfv cfv wral vx cF wral cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa vx cv vy cv cin c0
      wne vx vy cF cA csn cJ cnei cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv
      cfv wcel wa vx cv vy cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv
      cfv wcel wa wa wa vy cv vx cv cin c0 wne vx cv vy cv cin c0 wne cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vy cv cA
      csn cJ cnei cfv cfv wcel w3a vx cv cF wcel vy cv vx cv cin c0 wne cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF
      wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa cA vx cv cF cJ vy cv cX
      cY fclsfnflim.1 fclsfnflim.2 fclusneii cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei
      cfv cfv wcel wa wa wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vy cv cA csn cJ cnei cfv cfv wcel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv
      cA csn cJ cnei cfv cfv wcel wa wa pm3.26 cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei
      cfv cfv wcel wa simprl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel
      simprrr 3jca cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel simprrl sylanc
      vy cv vx cv cin vx cv vy cv cin c0 vy cv vx cv incom neeq1i sylib expr
      r19.21aivv cF cfbas wcel cA csn cJ cnei cfv cfv cfbas wcel c0 cF cA csn
      cJ cnei cfv cfv cun cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ cnei
      cfv cfv wral vx cF wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF
      cJ cfclus cfv cfv wcel wa vx vy cF cA csn cJ cnei cfv cfv fbunfip cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cF cfbas wcel cA cF cJ cfclus cfv cfv
      wcel cF cfil wcel cJ ctop wcel cF cfbas wcel cX cY wceq cF filfbas
      3ad2ant2 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel wa cA csn cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv
      cfbas wcel cJ ctop wcel cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv
      cfv cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel wa cA csn cJ cX fclsfnflim.1 neifil cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cJ ctop wcel cA cF cJ cfclus cfv cfv wcel cJ ctop
      wcel cF cfil wcel cX cY wceq 3simp1 adantr cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA cX wcel cA csn cX wss cA
      cF cJ cX cY fclsfnflim.1 fclsfnflim.2 fclselbas cA cX snssi syl cA cF cJ
      cfclus cfv cfv wcel cA csn c0 wne cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv snnzg adantl syl3anc cA csn cJ cnei cfv cfv
      filfbas syl sylanc mpbird jca cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cvv wcel cF cA
      csn cJ cnei cfv cfv cun cfi cfv cfbas wcel cF cA csn cJ cnei cfv cfv cun
      c0 wne c0 cF cA csn cJ cnei cfv cfv cun cfi cfv wnel wa wb cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cF cA csn cJ cnei cfv cfv cun cvv wcel cA cF
      cJ cfclus cfv cfv wcel cF cfil wcel cJ ctop wcel cF cA csn cJ cnei cfv
      cfv cun cvv wcel cX cY wceq cF cfil wcel cA csn cJ cnei cfv cfv cvv wcel
      cF cA csn cJ cnei cfv cfv cun cvv wcel cA csn cJ cnei cfv fvex cF cA csn
      cJ cnei cfv cfv cfil cvv unexg mpan2 3ad2ant2 adantr cF cA csn cJ cnei
      cfv cfv cun cvv fsubbas syl mpbird cF cA csn cJ cnei cfv cfv cun cfi cfv
      fgfil syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel wa cX cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv
      cfv cun cfi cfv cuni cF cA csn cJ cnei cfv cfv cun cfi cfv cfg cfv cuni
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa
      cX cF cuni cA csn cJ cnei cfv cfv cuni cun cF cA csn cJ cnei cfv cfv cun
      cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cX cX cun cF cuni cA csn cJ cnei cfv cfv cuni cun cX cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cX cF cuni cX
      cA csn cJ cnei cfv cfv cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cX
      cF cuni wceq cA cF cJ cfclus cfv cfv wcel cX cY wceq cJ ctop wcel cX cF
      cuni wceq cF cfil wcel cX cY wceq cX cF cuni wceq cY cF cuni cX
      fclsfnflim.2 eqeq2i biimpi 3ad2ant3 adantr cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cnei cfv cfv cuni
      cX cJ ctop wcel cA csn cX wss cA csn cJ cnei cfv cfv cuni cX wceq cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn
      cJ cX fclsfnflim.1 unnei cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop
      wcel cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq
      3simp1 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus
      cfv cfv wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1
      fclsfnflim.2 fclselbas cA cX snssi syl sylanc eqcomd uneq12d cX unidm
      syl5eqr cF cA csn cJ cnei cfv cfv uniun syl6eqr cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv
      cfv cun cfi cfv cuni wceq cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ
      ctop wcel cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv cfv
      cun cfi cfv cuni wceq cX cY wceq cF cfil wcel cF cA csn cJ cnei cfv cfv
      cun cvv wcel cF cA csn cJ cnei cfv cfv cun cuni cF cA csn cJ cnei cfv cfv
      cun cfi cfv cuni wceq cF cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ
      cnei cfv cfv cfil cvv unexg mpan2 cF cA csn cJ cnei cfv cfv cun cvv fiuni
      syl 3ad2ant2 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas wcel
      cF cA csn cJ cnei cfv cfv cun cfi cfv cuni cF cA csn cJ cnei cfv cfv cun
      cfi cfv cfg cfv cuni wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF
      cJ cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun cfi cfv cfbas
      wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv cfv
      cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel wa cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn
      cJ cnei cfv cfv cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cA csn cJ cnei cfv cfv cun c0 wne cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun c0 wne cX cY wceq cF cfil
      wcel cY cF wcel cF c0 wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cY
      fclsfnflim.2 filusb cF cY ne0i cF cF cA csn cJ cnei cfv cfv cun wss cF c0
      wne cF cA csn cJ cnei cfv cfv cun c0 wne cF cA csn cJ cnei cfv cfv ssun1
      cF cF cA csn cJ cnei cfv cfv cun ssn0 mpan 3syl 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa c0 cF cA
      csn cJ cnei cfv cfv cun cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ
      cnei cfv cfv wral vx cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cF cJ cfclus cfv cfv wcel wa vx cv vy cv cin c0 wne vx vy cF cA csn cJ
      cnei cfv cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa vx cv vy cv
      cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv
      cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa wa vy cv
      vx cv cin c0 wne vx cv vy cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vy cv cA csn cJ cnei cfv cfv wcel
      w3a vx cv cF wcel vy cv vx cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei
      cfv cfv wcel wa wa wa cA vx cv cF cJ vy cv cX cY fclsfnflim.1
      fclsfnflim.2 fclusneii cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa wa
      wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel
      vy cv cA csn cJ cnei cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cF cJ cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv
      cfv wcel wa wa pm3.26 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ
      cfclus cfv cfv wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel wa
      simprl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel vx cv cF wcel vy cv cA csn cJ cnei cfv cfv wcel simprrr 3jca cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel vx cv cF
      wcel vy cv cA csn cJ cnei cfv cfv wcel simprrl sylanc vy cv vx cv cin vx
      cv vy cv cin c0 vy cv vx cv incom neeq1i sylib expr r19.21aivv cF cfbas
      wcel cA csn cJ cnei cfv cfv cfbas wcel c0 cF cA csn cJ cnei cfv cfv cun
      cfi cfv wnel vx cv vy cv cin c0 wne vy cA csn cJ cnei cfv cfv wral vx cF
      wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa vx vy cF cA csn cJ cnei cfv cfv fbunfip cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cF cfbas wcel cA cF cJ cfclus cfv cfv wcel cF cfil wcel cJ
      ctop wcel cF cfbas wcel cX cY wceq cF filfbas 3ad2ant2 adantr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn
      cJ cnei cfv cfv cfil wcel cA csn cJ cnei cfv cfv cfbas wcel cJ ctop wcel
      cA csn cX wss cA csn c0 wne cA csn cJ cnei cfv cfv cfil wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cA csn cJ cX
      fclsfnflim.1 neifil cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel
      cA cF cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq 3simp1
      adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv
      wcel wa cA cX wcel cA csn cX wss cA cF cJ cX cY fclsfnflim.1 fclsfnflim.2
      fclselbas cA cX snssi syl cA cF cJ cfclus cfv cfv wcel cA csn c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv snnzg
      adantl syl3anc cA csn cJ cnei cfv cfv filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wa cF
      cA csn cJ cnei cfv cfv cun cvv wcel cF cA csn cJ cnei cfv cfv cun cfi cfv
      cfbas wcel cF cA csn cJ cnei cfv cfv cun c0 wne c0 cF cA csn cJ cnei cfv
      cfv cun cfi cfv wnel wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cA
      csn cJ cnei cfv cfv cun cvv wcel cA cF cJ cfclus cfv cfv wcel cF cfil
      wcel cJ ctop wcel cF cA csn cJ cnei cfv cfv cun cvv wcel cX cY wceq cF
      cfil wcel cA csn cJ cnei cfv cfv cvv wcel cF cA csn cJ cnei cfv cfv cun
      cvv wcel cA csn cJ cnei cfv fvex cF cA csn cJ cnei cfv cfv cfil cvv unexg
      mpan2 3ad2ant2 adantr cF cA csn cJ cnei cfv cfv cun cvv fsubbas syl
      mpbird cF cA csn cJ cnei cfv cfv cun cfi cfv cF cA csn cJ cnei cfv cfv
      cun cfi cfv cuni cF cA csn cJ cnei cfv cfv cun cfi cfv cuni eqid fgbas
      syl 3eqtrd syl3anc mpbird 3jca sylanc ex cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cX vg cv cuni wceq cF vg cv wss cA vg cv cJ cflim1 cfv cfv wcel
      w3a cA cF cJ cfclus cfv cfv wcel vg cfil cX vg cv cuni wceq cF vg cv wss
      cA vg cv cJ cflim1 cfv cfv wcel w3a vg cv cfil wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel cX vg cv cuni wceq cF vg
      cv wss cA vg cv cJ cflim1 cfv cfv wcel vg cv cfil wcel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cF cJ cfclus cfv cfv wcel wi wi cX vg cv cuni
      wceq cF vg cv wss wa cJ ctop wcel cF cfil wcel cX cY wceq w3a vg cv cfil
      wcel cA vg cv cJ cflim1 cfv cfv wcel cA cF cJ cfclus cfv cfv wcel cX vg
      cv cuni wceq cF vg cv wss wa cJ ctop wcel cF cfil wcel cX cY wceq w3a vg
      cv cfil wcel cA vg cv cJ cflim1 cfv cfv wcel cA cF cJ cfclus cfv cfv wcel
      wi cX vg cv cuni wceq cF vg cv wss wa cJ ctop wcel cF cfil wcel cX cY
      wceq w3a vg cv cfil wcel wa wa vg cv cJ cflim1 cfv cfv cF cJ cfclus cfv
      cfv cA cX vg cv cuni wceq cF vg cv wss wa cJ ctop wcel cF cfil wcel cX cY
      wceq w3a vg cv cfil wcel wa wa vg cv cJ cflim1 cfv cfv vg cv cJ cfclus
      cfv cfv cF cJ cfclus cfv cfv cX vg cv cuni wceq cF vg cv wss wa cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vg cv cfil wcel wa vg cv cJ cflim1 cfv
      cfv vg cv cJ cfclus cfv cfv wss cX vg cv cuni wceq cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vg cv cfil wcel wa vg cv cJ cflim1 cfv cfv vg cv cJ
      cfclus cfv cfv wss wi cF vg cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a vg cv cfil wcel wa cX vg cv cuni wceq vg cv cJ cflim1 cfv cfv vg cv
      cJ cfclus cfv cfv wss cJ ctop wcel cF cfil wcel vg cv cfil wcel cX vg cv
      cuni wceq vg cv cJ cflim1 cfv cfv vg cv cJ cfclus cfv cfv wss wi cX cY
      wceq cJ ctop wcel vg cv cfil wcel cX vg cv cuni wceq vg cv cJ cflim1 cfv
      cfv vg cv cJ cfclus cfv cfv wss vg cv cJ cX vg cv cuni fclsfnflim.1 vg cv
      cuni eqid flimfcls 3expia 3ad2antl1 com12 adantr imp cJ ctop wcel cF cfil
      wcel vg cv cfil wcel w3a cX cY wceq cX vg cv cuni wceq w3a cF vg cv wss
      vg cv cJ cfclus cfv cfv cF cJ cfclus cfv cfv wss cX vg cv cuni wceq cF vg
      cv wss wa cJ ctop wcel cF cfil wcel cX cY wceq w3a vg cv cfil wcel wa wa
      cF vg cv cJ cX cY vg cv cuni fclsfnflim.1 fclsfnflim.2 vg cv cuni eqid
      fclusss cX vg cv cuni wceq cF vg cv wss wa cJ ctop wcel cF cfil wcel cX
      cY wceq w3a vg cv cfil wcel wa wa cJ ctop wcel cF cfil wcel vg cv cfil
      wcel w3a cX cY wceq cX vg cv cuni wceq cJ ctop wcel cF cfil wcel cX cY
      wceq w3a vg cv cfil wcel wa cJ ctop wcel cF cfil wcel vg cv cfil wcel w3a
      cX vg cv cuni wceq cF vg cv wss wa cJ ctop wcel cF cfil wcel vg cv cfil
      wcel cJ ctop wcel cF cfil wcel vg cv cfil wcel w3a cX cY wceq cJ ctop
      wcel cF cfil wcel vg cv cfil wcel w3a cJ ctop wcel cF cfil wcel wa vg cv
      cfil wcel wa cJ ctop wcel cF cfil wcel vg cv cfil wcel df-3an biimpri
      3adantl3 adantl cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cY wceq cX vg
      cv cuni wceq cF vg cv wss wa vg cv cfil wcel cJ ctop wcel cF cfil wcel cX
      cY wceq 3simp3 ad2antrl cX vg cv cuni wceq cF vg cv wss cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vg cv cfil wcel wa simpll 3jca cX vg cv cuni
      wceq cF vg cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a vg cv cfil
      wcel wa simplr sylanc sstrd sseld exp32 com24 3impia com13 r19.23adv
      impbid $.
      $( [12-Nov-2009] $) $( [12-Nov-2009] $)
  $}

  ${
    $d g j o s x y z A $. $d g j o s x y z F $. $d g j o s x y z J $. $d g j o
    s x y z X $. $d g j o s x y z Y $.
    flimfnfcls.1 $e |- X = U. J $.
    flimfnfcls.2 $e |- Y = U. F $.
    $( A filter converges to a point iff every finer filter clusters there.
       Along with ~ fclsfnflim , this theorem illustrates the duality between
       convergence and clustering. $)
    flimfnfcls $p |- ( ( J e. Top /\ F e. Fil /\ X = Y ) -> ( A e. ( ( fLim1 `
    J ) ` F ) <-> A. g e. Fil ( ( X = U. g /\ F C_ g ) -> A e. ( ( fClus ` J )
    ` g ) ) ) ) $=
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv cfv wcel cX
      vg cv cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv wcel wi vg
      cfil wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cF cJ cflim1 cfv
      cfv wcel cX vg cv cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv
      wcel wi vg cfil cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg cv cuni
      wceq cF vg cv wss wa vg cv cfil wcel cA cF cJ cflim1 cfv cfv wcel cA vg
      cv cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg
      cv cuni wceq cF vg cv wss wa vg cv cfil wcel cA cF cJ cflim1 cfv cfv wcel
      cA vg cv cJ cfclus cfv cfv wcel wi cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cX vg cv cuni wceq cF vg cv wss wa vg cv cfil wcel wa wa cA cF cJ
      cflim1 cfv cfv wcel cA vg cv cJ cflim1 cfv cfv wcel cA vg cv cJ cfclus
      cfv cfv wcel cJ ctop wcel cF cfil wcel vg cv cfil wcel w3a cX cY wceq cX
      vg cv cuni wceq w3a cF vg cv wss cA cF cJ cflim1 cfv cfv wcel cA vg cv cJ
      cflim1 cfv cfv wcel wi cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg cv
      cuni wceq cF vg cv wss wa vg cv cfil wcel wa wa cJ ctop wcel cF cfil wcel
      vg cv cfil wcel w3a cX cY wceq cX vg cv cuni wceq w3a cF vg cv wss cA cF
      cJ cflim1 cfv cfv wcel cA vg cv cJ cflim1 cfv cfv wcel cA cF vg cv cJ cX
      cY vg cv cuni flimfnfcls.1 flimfnfcls.2 vg cv cuni eqid limfilss 3expia
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg cv cuni wceq cF vg cv wss
      wa vg cv cfil wcel wa wa cJ ctop wcel cF cfil wcel vg cv cfil wcel w3a cX
      cY wceq cX vg cv cuni wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg
      cv cuni wceq cF vg cv wss wa vg cv cfil wcel wa wa cJ ctop wcel cF cfil
      wcel vg cv cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ ctop
      wcel cX vg cv cuni wceq cF vg cv wss wa vg cv cfil wcel wa cJ ctop wcel
      cF cfil wcel cX cY wceq 3simp1 adantr cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cF cfil wcel cX vg cv cuni wceq cF vg cv wss wa vg cv cfil wcel
      wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 adantr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cX vg cv cuni wceq cF vg cv wss wa vg cv cfil
      wcel simprr 3jca cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cY wceq cX
      vg cv cuni wceq cF vg cv wss wa vg cv cfil wcel wa cJ ctop wcel cF cfil
      wcel cX cY wceq 3simp3 adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cX
      vg cv cuni wceq cF vg cv wss vg cv cfil wcel simprll 3jca cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cX vg cv cuni wceq cF vg cv wss vg cv cfil wcel
      simprlr sylanc cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg cv cuni
      wceq cF vg cv wss wa vg cv cfil wcel wa wa vg cv cJ cflim1 cfv cfv vg cv
      cJ cfclus cfv cfv cA cJ ctop wcel vg cv cfil wcel cX vg cv cuni wceq vg
      cv cJ cflim1 cfv cfv vg cv cJ cfclus cfv cfv wss cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cX vg cv cuni wceq cF vg cv wss wa vg cv cfil wcel wa
      wa vg cv cJ cX vg cv cuni flimfnfcls.1 vg cv cuni eqid flimfcls cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cJ ctop wcel cX vg cv cuni wceq cF vg cv
      wss wa vg cv cfil wcel wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp1
      adantr cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg cv cuni wceq cF vg
      cv wss wa vg cv cfil wcel simprr cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cX vg cv cuni wceq cF vg cv wss vg cv cfil wcel simprll syl3anc sseld
      syld exp32 com24 r19.21adv cJ ctop wcel cF cfil wcel cX cY wceq w3a cX vg
      cv cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv wcel wi vg cfil
      wral cA cX wcel cA cF cJ cflim1 cfv cfv wcel cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cX vg cv cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv
      wcel wi vg cfil wral cA cF cJ cfclus cfv cfv wcel cA cX wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cX vg cv cuni wceq cF vg cv wss wa cA vg cv
      cJ cfclus cfv cfv wcel wi vg cfil wral cX cF cuni wceq cF cF wss wa cA cF
      cJ cfclus cfv cfv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cF
      cuni wceq cF cF wss cX cY wceq cJ ctop wcel cX cF cuni wceq cF cfil wcel
      cX cY wceq cX cF cuni wceq cY cF cuni cX flimfnfcls.2 eqeq2i biimpi
      3ad2ant3 cF ssid jctir cF cfil wcel cJ ctop wcel cX vg cv cuni wceq cF vg
      cv wss wa cA vg cv cJ cfclus cfv cfv wcel wi vg cfil wral cX cF cuni wceq
      cF cF wss wa cA cF cJ cfclus cfv cfv wcel wi wi cX cY wceq cX vg cv cuni
      wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv wcel wi cX cF cuni wceq
      cF cF wss wa cA cF cJ cfclus cfv cfv wcel wi vg cF cfil vg cv cF wceq cX
      vg cv cuni wceq cF vg cv wss wa cX cF cuni wceq cF cF wss wa cA vg cv cJ
      cfclus cfv cfv wcel cA cF cJ cfclus cfv cfv wcel vg cv cF wceq cX vg cv
      cuni wceq cX cF cuni wceq cF vg cv wss cF cF wss vg cv cF wceq vg cv cuni
      cF cuni cX vg cv cF unieq eqeq2d vg cv cF cF sseq2 anbi12d vg cv cF wceq
      vg cv cJ cfclus cfv cfv cF cJ cfclus cfv cfv cA vg cv cF cJ cfclus cfv
      fveq2 eleq2d imbi12d rcla4v 3ad2ant2 mpid cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cF cJ cfclus cfv cfv wcel cA cX wcel cA cF cJ cX cY
      flimfnfcls.1 flimfnfcls.2 fclselbas ex syld cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel cX vg cv cuni wceq cF vg cv wss wa cA vg cv cJ
      cfclus cfv cfv wcel wi vg cfil wral cA cF cJ cflim1 cfv cfv wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel cX vg cv cuni wceq cF vg cv
      wss wa cA vg cv cJ cfclus cfv cfv wcel wi vg cfil wral cA cF cJ cflim1
      cfv cfv wcel wi cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA
      cF cJ cflim1 cfv cfv wcel cX vg cv cuni wceq cF vg cv wss wa cA vg cv cJ
      cfclus cfv cfv wcel wi vg cfil wral cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa cA cF cJ cflim1 cfv cfv wcel wn cX vg cv cuni wceq cF
      vg cv wss cA vg cv cJ cfclus cfv cfv wcel wn w3a vg cfil wrex cX vg cv
      cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv wcel wi vg cfil wral
      wn cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA cF cJ cflim1
      cfv cfv wcel wn cA vo cv wcel vo cv cF wcel wn wa vo cJ wrex cX vg cv
      cuni wceq cF vg cv wss cA vg cv cJ cfclus cfv cfv wcel wn w3a vg cfil
      wrex cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa cA cF cJ
      cflim1 cfv cfv wcel wn cA vo cv wcel vo cv cF wcel wi vo cJ wral wn cA vo
      cv wcel vo cv cF wcel wn wa vo cJ wrex cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa cA cF cJ cflim1 cfv cfv wcel cA vo cv wcel vo cv
      cF wcel wi vo cJ wral cA vo cF cJ cX cY flimfnfcls.1 flimfnfcls.2 flimopn
      notbid cA vo cv wcel vo cv cF wcel vo cJ rexanali syl6bbr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa cA vo cv wcel vo cv cF wcel wn wa
      cX vg cv cuni wceq cF vg cv wss cA vg cv cJ cfclus cfv cfv wcel wn w3a vg
      cfil wrex vo cJ cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa cX vg cv cuni wceq cF vg cv
      wss cA vg cv cJ cfclus cfv cfv wcel wn w3a vg cfil wrex cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cfil wcel cX cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni wceq
      cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      wss cA cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv cJ cfclus cfv cfv wcel wn w3a cX vg cv cuni wceq cF vg cv wss cA vg
      cv cJ cfclus cfv cfv wcel wn w3a vg cfil wrex cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn
      wa wa wa cX vg cv cuni wceq cF vg cv wss cA vg cv cJ cfclus cfv cfv wcel
      wn w3a cX cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv
      cfg cfv cuni wceq cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv cfg cfv wss cA cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cfi cfv cfg cfv cJ cfclus cfv cfv wcel wn w3a vg cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cfil vg cv cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wceq cX vg
      cv cuni wceq cX cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv cuni wceq cF vg cv wss cF cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cfi cfv cfg cfv wss cA vg cv cJ cfclus cfv cfv wcel wn
      cA cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      cJ cfclus cfv cfv wcel wn vg cv cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv wceq vg cv cuni cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni cX vg cv cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv unieq eqeq2d vg
      cv cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      cF sseq2 vg cv cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv wceq cA vg cv cJ cfclus cfv cfv wcel cA cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cJ cfclus cfv cfv wcel vg
      cv cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      wceq vg cv cJ cfclus cfv cfv cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv cfg cfv cJ cfclus cfv cfv cA vg cv cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cJ cfclus cfv fveq2
      eleq2d notbid 3anbi123d rcla4ev cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cfil wcel
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne
      cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil
      wcel cJ ctop wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      c0 wne cX cY wceq cF cfil wcel cY cF wcel cF c0 wne cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun c0 wne cF cY flimfnfcls.2 filusb cF cY
      ne0i cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun wss cF c0
      wne cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab ssun1 cF cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun ssn0 mpan 3syl 3ad2ant2 ad2antrr cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa c0 cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab wral vy cF wral cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy cv vz cv cin c0 wne vy vz cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa vy cv vz cv cin c0
      wne vy cv cX vo cv cdif cin vy cv vz cv cin wss vy cv cX vo cv cdif cin
      c0 wne vy cv vz cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF
      wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa wa vy
      cv cX vo cv cdif cin vy cv vz cv cin ssn0 cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      wcel wa wa cX vo cv cdif vz cv wss vy cv cX vo cv cdif cin vy cv vz cv
      cin wss vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cX vo
      cv cdif vz cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel vz cv cX wss cX vo cv
      cdif vz cv wss vx cv cX wss cX vo cv cdif vx cv wss wa vz cv cX wss cX vo
      cv cdif vz cv wss wa vx vz cv vz visset vx cv vz cv wceq vx cv cX wss vz
      cv cX wss cX vo cv cdif vx cv wss cX vo cv cdif vz cv wss vx cv vz cv cX
      sseq1 vx cv vz cv cX vo cv cdif sseq2 anbi12d elab pm3.27bi ad2antll cX
      vo cv cdif vz cv vy cv sslin syl cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv
      cF wcel vy cv cX vo cv cdif cin c0 wne vz cv vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn vy cv cF wcel vy cv
      cX vo cv cdif cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel wn vy cv
      cX vo cv cdif cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel wn vy cv
      cX vo cv cdif cin c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cF
      wcel vy cv cX vo cv cdif cin c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX
      vo cv cdif cin c0 wceq vy cv cX cX vo cv cdif cdif wss vo cv cF wcel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa wa vy cv cX wss vy cv cX vo cv cdif cin c0
      wceq vy cv cX cX vo cv cdif cdif wss wb cJ ctop wcel cF cfil wcel cX cY
      wceq w3a vy cv cF wcel vy cv cX wss cA cX wcel vo cv cJ wcel cA vo cv
      wcel wa cX cY wceq cJ ctop wcel vy cv cF wcel vy cv cX wss cF cfil wcel
      cX cY wceq vy cv cF wcel wa vy cv cY cX vy cv cF wcel vy cv cY wss cX cY
      wceq vy cv cF wcel vy cv cF cuni cY vy cv cF elssuni flimfnfcls.2 syl6ssr
      adantl cX cY wceq vy cv cF wcel pm3.26 sseqtr4d 3ad2antl3 ad2ant2rl vy cv
      cX vo cv cdif cX reldisj syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX cX
      vo cv cdif cdif wss vy cv vo cv wss vo cv cF wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF
      wcel wa wa cX cX vo cv cdif cdif vo cv vy cv cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa
      wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX wss cA cX
      wcel vy cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel
      vo cv cX wss cA vo cv wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv
      cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 adantrr
      ad2ant2r vo cv cX dfss4 sylib sseq2d cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv
      vo cv wss vo cv cF wcel cF cfil wcel vy cv cF wcel vo cv cY wss vy cv vo
      cv wss w3a vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss
      wa wa vy cv vo cv cF cY flimfnfcls.2 fillsb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv
      cF wcel wa vy cv vo cv wss wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2
      ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vy cv cF
      wcel vo cv cY wss vy cv vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel vy cv vo
      cv wss simprlr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vo cv
      cX cY cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vo cv cX wss cA cX wcel vy cv vo cv wss cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX
      wss vy cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel
      vo cv cX wss cA vo cv wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv
      cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 adantrr
      adantrr ad2ant2r cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cY wceq cA
      cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss
      wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp3 ad2antrr sseqtrd cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vy cv vo cv wss simprr 3jca sylc expr sylbid
      sylbid necon3bd exp44 com45 imp55 adantrr sylanc ex r19.21aivv cF cfbas
      wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfbas wcel c0 cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel vy cv vz cv
      cin c0 wne vz vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wral vy cF
      wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy vz cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab fbunfip cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cF cfbas wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn
      wa wa cF cfil wcel cJ ctop wcel cF cfbas wcel cX cY wceq cF filfbas
      3ad2ant2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cfil wcel vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cfbas wcel cX cvv wcel cX vo cv cdif cX wss cX vo cv cdif
      c0 wne vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa cX cvv wcel cX vo cv cdif cX wss cX vo cv
      cdif c0 wne w3a vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel
      cX vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cuni wceq vx cX cX vo
      cv cdif cvv supfil pm3.26d cJ ctop wcel cF cfil wcel cX cY wceq w3a cX
      cvv wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ
      ctop wcel cF cfil wcel cX cvv wcel cX cY wceq cJ ctop wcel cJ cuni cvv cX
      cJ ctop uniexg flimfnfcls.1 syl5eqel 3ad2ant1 ad2antrr cX vo cv cdif cX
      wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa wa cX vo cv difss a1i cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn wa cX vo cv cdif c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel wa cA vo cv wcel vo cv cF wcel wn cX
      vo cv cdif c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne wi cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa wa vo cv cF wcel cX vo cv cdif c0 cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv
      cdif cdif cX wceq vo cv cF wcel cX vo cv cdif c0 wceq cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa
      cX cX vo cv cdif cdif cX wceq vo cv cX wceq vo cv cF wcel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa
      cX cX vo cv cdif cdif vo cv cX cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX wss cX cX vo cv
      cdif cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ
      wcel vo cv cX wss cA cX wcel cA vo cv wcel cJ ctop wcel cF cfil wcel vo
      cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss
      3ad2antl1 ad2ant2r vo cv cX dfss4 sylib eqeq1d vo cv cX wceq vo cv cF
      wcel cX cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel wa wa vo cv cX cF eleq1 cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cX cF wcel cA cX wcel vo cv cJ wcel cA vo cv wcel wa
      cF cfil wcel cX cY wceq cX cF wcel cJ ctop wcel cF cfil wcel cX cY wceq
      cX cF wcel cX cY wceq cX cF wcel cY cF wcel cF cfil wcel cX cY cF eleq1
      cF cY flimfnfcls.2 filusb syl5cbir imp 3adant1 ad2antrr syl5cbir sylbid
      cX vo cv cdif c0 wceq cX cX vo cv cdif cdif cX c0 cdif cX cX vo cv cdif
      c0 cX difeq2 cX dif0 syl6eq syl5 necon3bd expr imp3a impr syl3anc vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv wnel wa wb cF cfil wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv
      wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cfil cvv unexg cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cfil wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cvv wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ
      ctop wcel cF cfil wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv
      wcel cX cY wceq cJ ctop wcel cX cvv wcel vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cvv wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      flimfnfcls.1 syl5eqel cX vo cv cdif vx cv wss vx cX cvv abssexg syl
      3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cvv fsubbas syl mpbird cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv fgfil syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni wceq
      cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      wss cA cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv cJ cfclus cfv cfv wcel wn cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cuni cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv cuni cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa cX cX cun cF cuni vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cuni cun cX cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cF cuni cX vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cuni cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cX cY cF cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cY wceq cA
      cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel
      cF cfil wcel cX cY wceq 3simp3 ad2antrr flimfnfcls.2 syl6eq cX cvv wcel
      cX vo cv cdif cX wss cX vo cv cdif c0 wne cX vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cuni wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cvv
      wcel cX vo cv cdif cX wss cX vo cv cdif c0 wne w3a vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cfil wcel cX vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cuni wceq vx cX cX vo cv cdif cvv supfil pm3.27d cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cX cvv wcel cA cX wcel vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cvv wcel
      cX cY wceq cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1
      syl5eqel 3ad2ant1 ad2antrr cX vo cv cdif cX wss cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn
      wa wa wa cX vo cv difss a1i cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa cX vo cv cdif
      c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel wa cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn cX vo cv cdif c0 wne wi cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cF wcel cX
      vo cv cdif c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cF
      wcel cX vo cv cdif c0 wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq
      vo cv cX wceq vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif vo cv
      cX cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA cX wcel cA
      vo cv wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY
      wceq vo cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 ad2ant2r vo cv cX dfss4
      sylib eqeq1d vo cv cX wceq vo cv cF wcel cX cF wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv
      cX cF eleq1 cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cF wcel cA cX
      wcel vo cv cJ wcel cA vo cv wcel wa cF cfil wcel cX cY wceq cX cF wcel cJ
      ctop wcel cF cfil wcel cX cY wceq cX cF wcel cX cY wceq cX cF wcel cY cF
      wcel cF cfil wcel cX cY cF eleq1 cF cY flimfnfcls.2 filusb syl5cbir imp
      3adant1 ad2antrr syl5cbir sylbid cX vo cv cdif c0 wceq cX cX vo cv cdif
      cdif cX c0 cdif cX cX vo cv cdif c0 cX difeq2 cX dif0 syl6eq syl5
      necon3bd expr imp3a impr syl3anc uneq12d cX cX cun cX cX unidm eqcomi cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab uniun 3eqtr4g cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cuni
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cuni wceq
      cF cfil wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cfil cvv unexg cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel cA
      cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel
      cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel cF cfil wcel cX cY
      wceq w3a vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cA cX
      wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF
      cfil wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cX cY
      wceq cJ ctop wcel cX cvv wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cvv wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1
      syl5eqel cX vo cv cdif vx cv wss vx cX cvv abssexg syl 3ad2ant1 ad2antrr
      sylanc cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv fiuni
      syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cun cfi cfv cuni cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv cuni wceq cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas
      wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel wa cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY wceq w3a cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun c0 wne cA cX wcel vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel cJ ctop wcel cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cX cY wceq cF cfil wcel
      cY cF wcel cF c0 wne cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun c0 wne cF cY flimfnfcls.2 filusb cF cY ne0i cF cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun wss cF c0 wne cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun c0 wne cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab ssun1 cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun ssn0 mpan 3syl 3ad2ant2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel vy
      cv vz cv cin c0 wne vz vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      wral vy cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv vz cv cin c0 wne
      vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab wcel wa vy cv vz cv cin c0 wne vy cv cX vo cv cdif cin vy
      cv vz cv cin wss vy cv cX vo cv cdif cin c0 wne vy cv vz cv cin c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab wcel wa wa vy cv cX vo cv cdif cin vy cv vz
      cv cin ssn0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa wa cX vo cv cdif vz cv
      wss vy cv cX vo cv cdif cin vy cv vz cv cin wss vz cv vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab wcel cX vo cv cdif vz cv wss cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab wcel vz cv cX wss cX vo cv cdif vz cv wss vx cv cX wss cX
      vo cv cdif vx cv wss wa vz cv cX wss cX vo cv cdif vz cv wss wa vx vz cv
      vz visset vx cv vz cv wceq vx cv cX wss vz cv cX wss cX vo cv cdif vx cv
      wss cX vo cv cdif vz cv wss vx cv vz cv cX sseq1 vx cv vz cv cX vo cv
      cdif sseq2 anbi12d elab pm3.27bi ad2antll cX vo cv cdif vz cv vy cv sslin
      syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vy cv cX vo cv cdif
      cin c0 wne vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn vy cv cF wcel vy cv cX vo cv cdif cin c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin c0 wne wi
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel wa vy cv cF wcel wa wa vo cv cF wcel vy cv cX vo cv cdif cin
      c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX vo cv cdif cin c0 wceq vy
      cv cX cX vo cv cdif cdif wss vo cv cF wcel cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa
      wa vy cv cX wss vy cv cX vo cv cdif cin c0 wceq vy cv cX cX vo cv cdif
      cdif wss wb cJ ctop wcel cF cfil wcel cX cY wceq w3a vy cv cF wcel vy cv
      cX wss cA cX wcel vo cv cJ wcel cA vo cv wcel wa cX cY wceq cJ ctop wcel
      vy cv cF wcel vy cv cX wss cF cfil wcel cX cY wceq vy cv cF wcel wa vy cv
      cY cX vy cv cF wcel vy cv cY wss cX cY wceq vy cv cF wcel vy cv cF cuni
      cY vy cv cF elssuni flimfnfcls.2 syl6ssr adantl cX cY wceq vy cv cF wcel
      pm3.26 sseqtr4d 3ad2antl3 ad2ant2rl vy cv cX vo cv cdif cX reldisj syl cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa wa vy cv cX cX vo cv cdif cdif wss vy cv vo
      cv wss vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa cX cX vo cv cdif
      cdif vo cv vy cv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cX wss cX cX vo
      cv cdif cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ
      wcel cA vo cv wcel wa vo cv cX wss cA cX wcel vy cv cF wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel cJ
      ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ cX
      flimfnfcls.1 eltopss 3ad2antl1 adantrr ad2ant2r vo cv cX dfss4 sylib
      sseq2d cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss vo cv cF wcel cF
      cfil wcel vy cv cF wcel vo cv cY wss vy cv vo cv wss w3a vo cv cF wcel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vy cv vo cv cF cY
      flimfnfcls.2 fillsb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel
      cA cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vy cv cF wcel vo cv cY wss vy cv
      vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel vy cv vo cv wss simprlr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vo cv cX cY cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vo cv
      cX wss cA cX wcel vy cv vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX wss vy cv cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel
      cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ
      cX flimfnfcls.1 eltopss 3ad2antl1 adantrr adantrr ad2ant2r cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cX cY wceq cA cX wcel vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vy cv vo cv wss wa cJ ctop wcel cF cfil wcel cX
      cY wceq 3simp3 ad2antrr sseqtrd cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss simprr 3jca sylc expr sylbid sylbid necon3bd exp44 com45 imp55
      adantrr sylanc ex r19.21aivv cF cfbas wcel vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cfbas wcel c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab wral vy cF wral wb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab fbunfip cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfbas wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel cJ ctop wcel cF
      cfbas wcel cX cY wceq cF filfbas 3ad2ant2 ad2antrr cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfbas wcel cX cvv wcel cX
      vo cv cdif cX wss cX vo cv cdif c0 wne vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cvv wcel
      cX vo cv cdif cX wss cX vo cv cdif c0 wne w3a vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cfil wcel cX vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cuni wceq vx cX cX vo cv cdif cvv supfil pm3.26d cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cX cvv wcel cA cX wcel vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cvv wcel cX cY
      wceq cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel
      3ad2ant1 ad2antrr cX vo cv cdif cX wss cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cX vo cv difss a1i cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa cX vo cv cdif c0 wne
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel wa
      cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn cX vo cv cdif c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cF wcel cX vo cv
      cdif c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cF wcel cX
      vo cv cdif c0 wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cX
      wceq vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif vo cv cX cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA cX wcel cA vo cv
      wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo
      cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 ad2ant2r vo cv cX dfss4 sylib
      eqeq1d vo cv cX wceq vo cv cF wcel cX cF wcel cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX
      cF eleq1 cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cF wcel cA cX wcel
      vo cv cJ wcel cA vo cv wcel wa cF cfil wcel cX cY wceq cX cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq cX cF wcel cX cY wceq cX cF wcel cY cF wcel
      cF cfil wcel cX cY cF eleq1 cF cY flimfnfcls.2 filusb syl5cbir imp
      3adant1 ad2antrr syl5cbir sylbid cX vo cv cdif c0 wceq cX cX vo cv cdif
      cdif cX c0 cdif cX cX vo cv cdif c0 cX difeq2 cX dif0 syl6eq syl5
      necon3bd expr imp3a impr syl3anc vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab filfbas syl sylanc mpbird jca cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel wa wb cF cfil wcel vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cvv wcel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil cvv unexg cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY
      wceq 3simp2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX
      cvv wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx
      cv wss vx cX cvv abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cvv fsubbas syl mpbird cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv cuni cF vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cun cfi cfv cuni eqid fgbas syl 3eqtrd cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn wa wa wa cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cfi cfv cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab ssun1 a1i cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv wss cF cfil wcel vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cvv wcel cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cvv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cfil cvv unexg cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ wcel cA vo cv wcel
      vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2
      ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel cA vo cv wcel
      vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX cvv wcel vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx cv wss vx cX
      cvv abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cun cvv abfi2 syl sstrd cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas
      wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wss cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cA
      cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel
      cJ ctop wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne
      cX cY wceq cF cfil wcel cY cF wcel cF c0 wne cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun c0 wne cF cY flimfnfcls.2 filusb cF cY ne0i
      cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun wss cF c0 wne cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab ssun1 cF cF vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cun ssn0 mpan 3syl 3ad2ant2 ad2antrr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab wral vy cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv
      vz cv cin c0 wne vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab wcel wa vy cv vz cv cin c0 wne vy cv cX vo
      cv cdif cin vy cv vz cv cin wss vy cv cX vo cv cdif cin c0 wne vy cv vz
      cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa wa vy cv cX vo cv
      cdif cin vy cv vz cv cin ssn0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF
      wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa wa cX
      vo cv cdif vz cv wss vy cv cX vo cv cdif cin vy cv vz cv cin wss vz cv vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cX vo cv cdif vz cv wss
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab wcel vz cv cX wss cX vo cv cdif vz cv wss
      vx cv cX wss cX vo cv cdif vx cv wss wa vz cv cX wss cX vo cv cdif vz cv
      wss wa vx vz cv vz visset vx cv vz cv wceq vx cv cX wss vz cv cX wss cX
      vo cv cdif vx cv wss cX vo cv cdif vz cv wss vx cv vz cv cX sseq1 vx cv
      vz cv cX vo cv cdif sseq2 anbi12d elab pm3.27bi ad2antll cX vo cv cdif vz
      cv vy cv sslin syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vy cv
      cX vo cv cdif cin c0 wne vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn vy cv cF wcel vy cv cX vo cv cdif cin
      c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin
      c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin
      c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cF wcel vy cv cX vo cv
      cdif cin c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX vo cv cdif cin c0
      wceq vy cv cX cX vo cv cdif cdif wss vo cv cF wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF
      wcel wa wa vy cv cX wss vy cv cX vo cv cdif cin c0 wceq vy cv cX cX vo cv
      cdif cdif wss wb cJ ctop wcel cF cfil wcel cX cY wceq w3a vy cv cF wcel
      vy cv cX wss cA cX wcel vo cv cJ wcel cA vo cv wcel wa cX cY wceq cJ ctop
      wcel vy cv cF wcel vy cv cX wss cF cfil wcel cX cY wceq vy cv cF wcel wa
      vy cv cY cX vy cv cF wcel vy cv cY wss cX cY wceq vy cv cF wcel vy cv cF
      cuni cY vy cv cF elssuni flimfnfcls.2 syl6ssr adantl cX cY wceq vy cv cF
      wcel pm3.26 sseqtr4d 3ad2antl3 ad2ant2rl vy cv cX vo cv cdif cX reldisj
      syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX cX vo cv cdif cdif wss vy
      cv vo cv wss vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa cX cX vo cv
      cdif cdif vo cv vy cv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cX wss cX cX
      vo cv cdif cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv
      cJ wcel cA vo cv wcel wa vo cv cX wss cA cX wcel vy cv cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel
      cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ
      cX flimfnfcls.1 eltopss 3ad2antl1 adantrr ad2ant2r vo cv cX dfss4 sylib
      sseq2d cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss vo cv cF wcel cF
      cfil wcel vy cv cF wcel vo cv cY wss vy cv vo cv wss w3a vo cv cF wcel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vy cv vo cv cF cY
      flimfnfcls.2 fillsb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel
      cA cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vy cv cF wcel vo cv cY wss vy cv
      vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel vy cv vo cv wss simprlr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vo cv cX cY cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vo cv
      cX wss cA cX wcel vy cv vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX wss vy cv cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel
      cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ
      cX flimfnfcls.1 eltopss 3ad2antl1 adantrr adantrr ad2ant2r cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cX cY wceq cA cX wcel vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vy cv vo cv wss wa cJ ctop wcel cF cfil wcel cX
      cY wceq 3simp3 ad2antrr sseqtrd cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss simprr 3jca sylc expr sylbid sylbid necon3bd exp44 com45 imp55
      adantrr sylanc ex r19.21aivv cF cfbas wcel vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cfbas wcel c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab wral vy cF wral wb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab fbunfip cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfbas wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel cJ ctop wcel cF
      cfbas wcel cX cY wceq cF filfbas 3ad2ant2 ad2antrr cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfbas wcel cX cvv wcel cX
      vo cv cdif cX wss cX vo cv cdif c0 wne vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cvv wcel
      cX vo cv cdif cX wss cX vo cv cdif c0 wne w3a vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cfil wcel cX vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cuni wceq vx cX cX vo cv cdif cvv supfil pm3.26d cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cX cvv wcel cA cX wcel vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cvv wcel cX cY
      wceq cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel
      3ad2ant1 ad2antrr cX vo cv cdif cX wss cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cX vo cv difss a1i cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa cX vo cv cdif c0 wne
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel wa
      cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn cX vo cv cdif c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cF wcel cX vo cv
      cdif c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cF wcel cX
      vo cv cdif c0 wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cX
      wceq vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif vo cv cX cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA cX wcel cA vo cv
      wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo
      cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 ad2ant2r vo cv cX dfss4 sylib
      eqeq1d vo cv cX wceq vo cv cF wcel cX cF wcel cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX
      cF eleq1 cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cF wcel cA cX wcel
      vo cv cJ wcel cA vo cv wcel wa cF cfil wcel cX cY wceq cX cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq cX cF wcel cX cY wceq cX cF wcel cY cF wcel
      cF cfil wcel cX cY cF eleq1 cF cY flimfnfcls.2 filusb syl5cbir imp
      3adant1 ad2antrr syl5cbir sylbid cX vo cv cdif c0 wceq cX cX vo cv cdif
      cdif cX c0 cdif cX cX vo cv cdif c0 cX difeq2 cX dif0 syl6eq syl5
      necon3bd expr imp3a impr syl3anc vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab filfbas syl sylanc mpbird jca cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel wa wb cF cfil wcel vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cvv wcel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil cvv unexg cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY
      wceq 3simp2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX
      cvv wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx
      cv wss vx cX cvv abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cvv fsubbas syl mpbird cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv fbssfg syl sstrd cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa cA cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv cJ cfclus cfv cfv wcel cA cX wcel cA vj cv
      wcel vj cv vs cv cin c0 wne vs cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv cfg cfv wral wi vj cJ wral wa cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa cA cX wcel cA vj cv wcel vj cv vs cv cin c0 wceq vs cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wrex
      wa vj cJ wrex wi cA cX wcel cA vj cv wcel vj cv vs cv cin c0 wne vs cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wral wi
      vj cJ wral wa wn cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cA vj cv wcel vj cv
      vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv cfg cfv wrex wa vj cJ wrex cA cX wcel vo cv cJ wcel cA vo cv
      wcel vo cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv wrex cA vj cv wcel vj cv vs cv cin c0 wceq
      vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      wrex wa vj cJ wrex cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa simprl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn simprrl cX vo cv cdif cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wcel
      vo cv cX vo cv cdif cin c0 wceq vo cv vs cv cin c0 wceq vs cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wrex cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa vo cv vs cv cin c0 wceq vo cv cX vo cv
      cdif cin c0 wceq vs cX vo cv cdif cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv vs cv cX vo cv cdif wceq vo cv vs cv cin vo
      cv cX vo cv cdif cin c0 vs cv cX vo cv cdif vo cv ineq2 eqeq1d rcla4ev cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv cX vo cv cdif cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cfi cfv cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cF vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cun wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cF ssun2 a1i cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wss cF cfil wcel vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cvv wcel cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil cvv unexg cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY
      wceq 3simp2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX
      cvv wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx
      cv wss vx cX cvv abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cvv abfi2 syl sstrd cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      cfi cfv cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun c0 wne cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa cF cfil wcel cJ ctop wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun c0 wne cX cY wceq cF cfil wcel cY cF wcel cF c0 wne cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cF cY flimfnfcls.2
      filusb cF cY ne0i cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun wss cF c0 wne cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      c0 wne cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab ssun1 cF cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun ssn0 mpan 3syl 3ad2ant2
      ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa wa c0 cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab wral vy cF wral cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa vy cv vz cv cin c0 wne vy vz cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF
      wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa vy cv
      vz cv cin c0 wne vy cv cX vo cv cdif cin vy cv vz cv cin wss vy cv cX vo
      cv cdif cin c0 wne vy cv vz cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      wcel wa wa vy cv cX vo cv cdif cin vy cv vz cv cin ssn0 cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab wcel wa wa cX vo cv cdif vz cv wss vy cv cX vo cv cdif cin
      vy cv vz cv cin wss vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      wcel cX vo cv cdif vz cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF
      wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel vz cv cX
      wss cX vo cv cdif vz cv wss vx cv cX wss cX vo cv cdif vx cv wss wa vz cv
      cX wss cX vo cv cdif vz cv wss wa vx vz cv vz visset vx cv vz cv wceq vx
      cv cX wss vz cv cX wss cX vo cv cdif vx cv wss cX vo cv cdif vz cv wss vx
      cv vz cv cX sseq1 vx cv vz cv cX vo cv cdif sseq2 anbi12d elab pm3.27bi
      ad2antll cX vo cv cdif vz cv vy cv sslin syl cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy cv cF wcel vy cv cX vo cv cdif cin c0 wne vz cv vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab wcel cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn vy cv cF
      wcel vy cv cX vo cv cdif cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel
      wn vy cv cX vo cv cdif cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel
      wn vy cv cX vo cv cdif cin c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vo
      cv cF wcel vy cv cX vo cv cdif cin c0 cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa
      vy cv cX vo cv cdif cin c0 wceq vy cv cX cX vo cv cdif cdif wss vo cv cF
      wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX wss vy cv cX vo cv cdif cin
      c0 wceq vy cv cX cX vo cv cdif cdif wss wb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a vy cv cF wcel vy cv cX wss cA cX wcel vo cv cJ wcel cA vo cv
      wcel wa cX cY wceq cJ ctop wcel vy cv cF wcel vy cv cX wss cF cfil wcel
      cX cY wceq vy cv cF wcel wa vy cv cY cX vy cv cF wcel vy cv cY wss cX cY
      wceq vy cv cF wcel vy cv cF cuni cY vy cv cF elssuni flimfnfcls.2 syl6ssr
      adantl cX cY wceq vy cv cF wcel pm3.26 sseqtr4d 3ad2antl3 ad2ant2rl vy cv
      cX vo cv cdif cX reldisj syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX cX
      vo cv cdif cdif wss vy cv vo cv wss vo cv cF wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF
      wcel wa wa cX cX vo cv cdif cdif vo cv vy cv cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa
      wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX wss cA cX
      wcel vy cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel
      vo cv cX wss cA vo cv wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv
      cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 adantrr
      ad2ant2r vo cv cX dfss4 sylib sseq2d cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv
      vo cv wss vo cv cF wcel cF cfil wcel vy cv cF wcel vo cv cY wss vy cv vo
      cv wss w3a vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss
      wa wa vy cv vo cv cF cY flimfnfcls.2 fillsb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv
      cF wcel wa vy cv vo cv wss wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2
      ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vy cv cF
      wcel vo cv cY wss vy cv vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel vy cv vo
      cv wss simprlr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vo cv
      cX cY cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vo cv cX wss cA cX wcel vy cv vo cv wss cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX
      wss vy cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel
      vo cv cX wss cA vo cv wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv
      cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 adantrr
      adantrr ad2ant2r cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cY wceq cA
      cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss
      wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp3 ad2antrr sseqtrd cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vy cv vo cv wss simprr 3jca sylc expr sylbid
      sylbid necon3bd exp44 com45 imp55 adantrr sylanc ex r19.21aivv cF cfbas
      wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfbas wcel c0 cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel vy cv vz cv
      cin c0 wne vz vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wral vy cF
      wral wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy vz cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab fbunfip cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cF cfbas wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn
      wa wa cF cfil wcel cJ ctop wcel cF cfbas wcel cX cY wceq cF filfbas
      3ad2ant2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cfil wcel vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cfbas wcel cX cvv wcel cX vo cv cdif cX wss cX vo cv cdif
      c0 wne vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa cX cvv wcel cX vo cv cdif cX wss cX vo cv
      cdif c0 wne w3a vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel
      cX vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cuni wceq vx cX cX vo
      cv cdif cvv supfil pm3.26d cJ ctop wcel cF cfil wcel cX cY wceq w3a cX
      cvv wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ
      ctop wcel cF cfil wcel cX cvv wcel cX cY wceq cJ ctop wcel cJ cuni cvv cX
      cJ ctop uniexg flimfnfcls.1 syl5eqel 3ad2ant1 ad2antrr cX vo cv cdif cX
      wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa wa cX vo cv difss a1i cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn wa cX vo cv cdif c0 wne cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel wa cA vo cv wcel vo cv cF wcel wn cX
      vo cv cdif c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne wi cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa wa vo cv cF wcel cX vo cv cdif c0 cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv
      cdif cdif cX wceq vo cv cF wcel cX vo cv cdif c0 wceq cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa
      cX cX vo cv cdif cdif cX wceq vo cv cX wceq vo cv cF wcel cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa
      cX cX vo cv cdif cdif vo cv cX cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX wss cX cX vo cv
      cdif cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ
      wcel vo cv cX wss cA cX wcel cA vo cv wcel cJ ctop wcel cF cfil wcel vo
      cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss
      3ad2antl1 ad2ant2r vo cv cX dfss4 sylib eqeq1d vo cv cX wceq vo cv cF
      wcel cX cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel wa wa vo cv cX cF eleq1 cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cX cF wcel cA cX wcel vo cv cJ wcel cA vo cv wcel wa
      cF cfil wcel cX cY wceq cX cF wcel cJ ctop wcel cF cfil wcel cX cY wceq
      cX cF wcel cX cY wceq cX cF wcel cY cF wcel cF cfil wcel cX cY cF eleq1
      cF cY flimfnfcls.2 filusb syl5cbir imp 3adant1 ad2antrr syl5cbir sylbid
      cX vo cv cdif c0 wceq cX cX vo cv cdif cdif cX c0 cdif cX cX vo cv cdif
      c0 cX difeq2 cX dif0 syl6eq syl5 necon3bd expr imp3a impr syl3anc vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab filfbas syl sylanc mpbird jca cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv wnel wa wb cF cfil wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv
      wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cfil cvv unexg cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cF cfil wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cvv wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ
      ctop wcel cF cfil wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv
      wcel cX cY wceq cJ ctop wcel cX cvv wcel vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cvv wcel cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      flimfnfcls.1 syl5eqel cX vo cv cdif vx cv wss vx cX cvv abssexg syl
      3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cvv fsubbas syl mpbird cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv fbssfg syl sstrd cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cX vo cv cdif vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cX vo
      cv cdif cX wss cX vo cv cdif cX vo cv cdif wss wa cX vo cv cdif cX wss cX
      vo cv cdif cX vo cv cdif wss cX vo cv difss cX vo cv cdif ssid pm3.2i cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cX vo cv cdif vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab wcel cX vo cv cdif cX wss cX vo cv cdif cX vo cv
      cdif wss wa wb cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa cJ ctop wcel cF cfil wcel cX vo cv cdif vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab wcel cX vo cv cdif cX wss cX vo cv cdif cX vo cv cdif
      wss wa wb cX cY wceq cJ ctop wcel cX cvv wcel cX vo cv cdif cvv wcel cX
      vo cv cdif vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cX vo cv
      cdif cX wss cX vo cv cdif cX vo cv cdif wss wa wb cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cvv difexg vx cv cX
      wss cX vo cv cdif vx cv wss wa cX vo cv cdif cX wss cX vo cv cdif cX vo
      cv cdif wss wa vx cX vo cv cdif cvv vx cv cX vo cv cdif wceq vx cv cX wss
      cX vo cv cdif cX wss cX vo cv cdif vx cv wss cX vo cv cdif cX vo cv cdif
      wss vx cv cX vo cv cdif cX sseq1 vx cv cX vo cv cdif cX vo cv cdif sseq2
      anbi12d elabg 3syl 3ad2ant1 ad2antrr mpbiri sseldd vo cv cX vo cv cdif
      cin c0 wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vo cv cX difdisj a1i
      sylanc cA vj cv wcel vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wrex wa cA vo cv wcel vo cv
      vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv cfg cfv wrex wa vj vo cv cJ vj cv vo cv wceq cA vj cv wcel cA
      vo cv wcel vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cfi cfv cfg cfv wrex vo cv vs cv cin c0 wceq vs cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wrex vj
      cv vo cv cA eleq2 vj cv vo cv wceq vj cv vs cv cin c0 wceq vo cv vs cv
      cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv vj cv vo cv wceq vj cv vs cv cin vo cv vs cv cin c0 vj cv vo
      cv vs cv ineq1 eqeq1d rexbidv anbi12d rcla4ev sylan32c a1d cA cX wcel cA
      vj cv wcel vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cfi cfv cfg cfv wrex wa vj cJ wrex wi cA cX wcel cA vj
      cv wcel vj cv vs cv cin c0 wne vs cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv wral wi vj cJ wral wn wi cA cX wcel cA vj
      cv wcel vj cv vs cv cin c0 wne vs cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfg cfv wral wi vj cJ wral wa wn cA vj cv wcel vj
      cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv cfg cfv wrex wa vj cJ wrex cA vj cv wcel vj cv vs cv cin c0
      wne vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv wral wi vj cJ wral wn cA cX wcel cA vj cv wcel vj cv vs cv cin c0
      wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv wrex wa vj cJ wrex cA vj cv wcel vj cv vs cv cin c0 wne vs cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wral wn wa
      vj cJ wrex cA vj cv wcel vj cv vs cv cin c0 wne vs cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wral wi vj cJ wral wn cA
      vj cv wcel vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cfi cfv cfg cfv wrex wa cA vj cv wcel vj cv vs cv cin
      c0 wne vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv
      cfg cfv wral wn wa vj cJ vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wrex vj cv vs cv cin c0
      wne vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv wral wn cA vj cv wcel vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv wrex vj cv vs cv cin
      c0 wne wn vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv wrex vj cv vs cv cin c0 wne vs cF vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cun cfi cfv cfg cfv wral wn vj cv vs cv cin c0 wne wn
      vj cv vs cv cin c0 wceq vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cfi cfv cfg cfv vj cv vs cv cin c0 nne rexbii vj cv vs cv cin c0
      wne vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv rexnal bitr3i anbi2i rexbii cA vj cv wcel vj cv vs cv cin c0 wne vs
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      wral vj cJ rexanali bitri imbi2i cA cX wcel cA vj cv wcel vj cv vs cv cin
      c0 wne vs cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv
      cfg cfv wral wi vj cJ wral imnan bitri sylib cJ ctop wcel cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cfil wcel cX cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni wceq
      cA cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      cJ cfclus cfv cfv wcel cA cX wcel cA vj cv wcel vj cv vs cv cin c0 wne vs
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv
      wral wi vj cJ wral wa wb cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cA vj cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cJ cX cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni
      vs flimfnfcls.1 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi
      cfv cfg cfv cuni eqid isfclus cJ ctop wcel cF cfil wcel cX cY wceq w3a cJ
      ctop wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      cJ ctop wcel cF cfil wcel cX cY wceq 3simp1 ad2antrr cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun
      cfi cfv cfg cfv cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn
      wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun c0 wne cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa cF cfil wcel cJ ctop wcel cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cun c0 wne cX cY wceq cF cfil wcel cY cF wcel cF c0 wne
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cF cY
      flimfnfcls.2 filusb cF cY ne0i cF cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun wss cF c0 wne cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun c0 wne cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab ssun1 cF
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun ssn0 mpan 3syl
      3ad2ant2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa c0 cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne
      vz vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wral vy cF wral cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa vy cv vz cv cin c0 wne vy vz cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      wcel wa vy cv vz cv cin c0 wne vy cv cX vo cv cdif cin vy cv vz cv cin
      wss vy cv cX vo cv cdif cin c0 wne vy cv vz cv cin c0 wne cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab wcel wa wa vy cv cX vo cv cdif cin vy cv vz cv cin ssn0 cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab wcel wa wa cX vo cv cdif vz cv wss vy cv cX
      vo cv cdif cin vy cv vz cv cin wss vz cv vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab wcel cX vo cv cdif vz cv wss cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy cv cF wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      wcel vz cv cX wss cX vo cv cdif vz cv wss vx cv cX wss cX vo cv cdif vx
      cv wss wa vz cv cX wss cX vo cv cdif vz cv wss wa vx vz cv vz visset vx
      cv vz cv wceq vx cv cX wss vz cv cX wss cX vo cv cdif vx cv wss cX vo cv
      cdif vz cv wss vx cv vz cv cX sseq1 vx cv vz cv cX vo cv cdif sseq2
      anbi12d elab pm3.27bi ad2antll cX vo cv cdif vz cv vy cv sslin syl cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vy cv cX vo cv cdif cin
      c0 wne vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn vy cv cF wcel vy cv cX vo cv cdif cin c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin c0 wne cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin c0 wne wi
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel wa vy cv cF wcel wa wa vo cv cF wcel vy cv cX vo cv cdif cin
      c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX vo cv cdif cin c0 wceq vy
      cv cX cX vo cv cdif cdif wss vo cv cF wcel cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa
      wa vy cv cX wss vy cv cX vo cv cdif cin c0 wceq vy cv cX cX vo cv cdif
      cdif wss wb cJ ctop wcel cF cfil wcel cX cY wceq w3a vy cv cF wcel vy cv
      cX wss cA cX wcel vo cv cJ wcel cA vo cv wcel wa cX cY wceq cJ ctop wcel
      vy cv cF wcel vy cv cX wss cF cfil wcel cX cY wceq vy cv cF wcel wa vy cv
      cY cX vy cv cF wcel vy cv cY wss cX cY wceq vy cv cF wcel vy cv cF cuni
      cY vy cv cF elssuni flimfnfcls.2 syl6ssr adantl cX cY wceq vy cv cF wcel
      pm3.26 sseqtr4d 3ad2antl3 ad2ant2rl vy cv cX vo cv cdif cX reldisj syl cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa wa vy cv cX cX vo cv cdif cdif wss vy cv vo
      cv wss vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa cX cX vo cv cdif
      cdif vo cv vy cv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cX wss cX cX vo
      cv cdif cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ
      wcel cA vo cv wcel wa vo cv cX wss cA cX wcel vy cv cF wcel cJ ctop wcel
      cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel cJ
      ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ cX
      flimfnfcls.1 eltopss 3ad2antl1 adantrr ad2ant2r vo cv cX dfss4 sylib
      sseq2d cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss vo cv cF wcel cF
      cfil wcel vy cv cF wcel vo cv cY wss vy cv vo cv wss w3a vo cv cF wcel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vy cv vo cv cF cY
      flimfnfcls.2 fillsb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel
      cA cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vy cv cF wcel vo cv cY wss vy cv
      vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel vy cv vo cv wss simprlr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vo cv cX cY cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vo cv
      cX wss cA cX wcel vy cv vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX wss vy cv cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel
      cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ
      cX flimfnfcls.1 eltopss 3ad2antl1 adantrr adantrr ad2ant2r cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cX cY wceq cA cX wcel vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vy cv vo cv wss wa cJ ctop wcel cF cfil wcel cX
      cY wceq 3simp3 ad2antrr sseqtrd cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss simprr 3jca sylc expr sylbid sylbid necon3bd exp44 com45 imp55
      adantrr sylanc ex r19.21aivv cF cfbas wcel vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cfbas wcel c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab wral vy cF wral wb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab fbunfip cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfbas wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel cJ ctop wcel cF
      cfbas wcel cX cY wceq cF filfbas 3ad2ant2 ad2antrr cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfbas wcel cX cvv wcel cX
      vo cv cdif cX wss cX vo cv cdif c0 wne vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cvv wcel
      cX vo cv cdif cX wss cX vo cv cdif c0 wne w3a vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cfil wcel cX vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cuni wceq vx cX cX vo cv cdif cvv supfil pm3.26d cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cX cvv wcel cA cX wcel vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cvv wcel cX cY
      wceq cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel
      3ad2ant1 ad2antrr cX vo cv cdif cX wss cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cX vo cv difss a1i cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa cX vo cv cdif c0 wne
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel wa
      cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn cX vo cv cdif c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cF wcel cX vo cv
      cdif c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cF wcel cX
      vo cv cdif c0 wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cX
      wceq vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif vo cv cX cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA cX wcel cA vo cv
      wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo
      cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 ad2ant2r vo cv cX dfss4 sylib
      eqeq1d vo cv cX wceq vo cv cF wcel cX cF wcel cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX
      cF eleq1 cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cF wcel cA cX wcel
      vo cv cJ wcel cA vo cv wcel wa cF cfil wcel cX cY wceq cX cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq cX cF wcel cX cY wceq cX cF wcel cY cF wcel
      cF cfil wcel cX cY cF eleq1 cF cY flimfnfcls.2 filusb syl5cbir imp
      3adant1 ad2antrr syl5cbir sylbid cX vo cv cdif c0 wceq cX cX vo cv cdif
      cdif cX c0 cdif cX cX vo cv cdif c0 cX difeq2 cX dif0 syl6eq syl5
      necon3bd expr imp3a impr syl3anc vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab filfbas syl sylanc mpbird jca cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel wa wb cF cfil wcel vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cvv wcel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil cvv unexg cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY
      wceq 3simp2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX
      cvv wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx
      cv wss vx cX cvv abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cvv fsubbas syl mpbird cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv fgfil syl cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa cX cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cuni cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv
      cuni cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg
      cfv cuni cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cX cun cF cuni vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cuni cun cX cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cuni cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cX cF cuni cX vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cuni cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa wa cX cY cF cuni cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cX cY wceq cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp3 ad2antrr
      flimfnfcls.2 syl6eq cX cvv wcel cX vo cv cdif cX wss cX vo cv cdif c0 wne
      cX vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cuni wceq cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo
      cv cF wcel wn wa wa wa cX cvv wcel cX vo cv cdif cX wss cX vo cv cdif c0
      wne w3a vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel cX vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cuni wceq vx cX cX vo cv cdif
      cvv supfil pm3.27d cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cvv wcel
      cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop
      wcel cF cfil wcel cX cvv wcel cX cY wceq cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg flimfnfcls.1 syl5eqel 3ad2ant1 ad2antrr cX vo cv cdif cX wss
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa wa cX vo cv difss a1i cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa cX vo cv cdif c0 wne cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel wa cA vo cv wcel vo cv cF wcel wn cX vo
      cv cdif c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne wi cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa wa vo cv cF wcel cX vo cv cdif c0 cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif
      cdif cX wceq vo cv cF wcel cX vo cv cdif c0 wceq cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX
      vo cv cdif cdif cX wceq vo cv cX wceq vo cv cF wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa cX cX
      vo cv cdif cdif vo cv cX cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX wss cX cX vo cv cdif
      cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo
      cv cX wss cA cX wcel cA vo cv wcel cJ ctop wcel cF cfil wcel vo cv cJ
      wcel vo cv cX wss cX cY wceq vo cv cJ cX flimfnfcls.1 eltopss 3ad2antl1
      ad2ant2r vo cv cX dfss4 sylib eqeq1d vo cv cX wceq vo cv cF wcel cX cF
      wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa wa vo cv cX cF eleq1 cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cX cF wcel cA cX wcel vo cv cJ wcel cA vo cv wcel wa cF cfil
      wcel cX cY wceq cX cF wcel cJ ctop wcel cF cfil wcel cX cY wceq cX cF
      wcel cX cY wceq cX cF wcel cY cF wcel cF cfil wcel cX cY cF eleq1 cF cY
      flimfnfcls.2 filusb syl5cbir imp 3adant1 ad2antrr syl5cbir sylbid cX vo
      cv cdif c0 wceq cX cX vo cv cdif cdif cX c0 cdif cX cX vo cv cdif c0 cX
      difeq2 cX dif0 syl6eq syl5 necon3bd expr imp3a impr syl3anc uneq12d cX cX
      cun cX cX unidm eqcomi cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      uniun 3eqtr4g cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cvv wcel cF vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cun cuni cF vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab cun cfi cfv cuni wceq cF cfil wcel vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cvv wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cvv wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cfil cvv unexg cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cF cfil wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ
      ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX cvv wcel vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx cv wss vx cX cvv
      abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cun cvv fiuni syl cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cuni cF vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfg cfv cuni wceq cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun cfi cfv cfbas wcel cF vx cv cX wss cX vo cv cdif vx cv wss
      wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv wnel wa cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv wnel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cA
      cX wcel vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel
      cJ ctop wcel cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne
      cX cY wceq cF cfil wcel cY cF wcel cF c0 wne cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun c0 wne cF cY flimfnfcls.2 filusb cF cY ne0i
      cF cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun wss cF c0 wne cF
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab ssun1 cF cF vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cun ssn0 mpan 3syl 3ad2ant2 ad2antrr cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv
      cF wcel wn wa wa wa c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab wral vy cF wral cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv
      vz cv cin c0 wne vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab wcel wa vy cv vz cv cin c0 wne vy cv cX vo
      cv cdif cin vy cv vz cv cin wss vy cv cX vo cv cdif cin c0 wne vy cv vz
      cv cin c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo
      cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa wa vy cv cX vo cv
      cdif cin vy cv vz cv cin ssn0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF
      wcel vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel wa wa cX
      vo cv cdif vz cv wss vy cv cX vo cv cdif cin vy cv vz cv cin wss vz cv vx
      cv cX wss cX vo cv cdif vx cv wss wa vx cab wcel cX vo cv cdif vz cv wss
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA
      vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vz cv vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab wcel vz cv cX wss cX vo cv cdif vz cv wss
      vx cv cX wss cX vo cv cdif vx cv wss wa vz cv cX wss cX vo cv cdif vz cv
      wss wa vx vz cv vz visset vx cv vz cv wceq vx cv cX wss vz cv cX wss cX
      vo cv cdif vx cv wss cX vo cv cdif vz cv wss vx cv vz cv cX sseq1 vx cv
      vz cv cX vo cv cdif sseq2 anbi12d elab pm3.27bi ad2antll cX vo cv cdif vz
      cv vy cv sslin syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa vy cv cF wcel vy cv
      cX vo cv cdif cin c0 wne vz cv vx cv cX wss cX vo cv cdif vx cv wss wa vx
      cab wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn vy cv cF wcel vy cv cX vo cv cdif cin
      c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin
      c0 wne cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel vy cv cF wcel vo cv cF wcel wn vy cv cX vo cv cdif cin
      c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cF wcel vy cv cX vo cv
      cdif cin c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv
      cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX vo cv cdif cin c0
      wceq vy cv cX cX vo cv cdif cdif wss vo cv cF wcel cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF
      wcel wa wa vy cv cX wss vy cv cX vo cv cdif cin c0 wceq vy cv cX cX vo cv
      cdif cdif wss wb cJ ctop wcel cF cfil wcel cX cY wceq w3a vy cv cF wcel
      vy cv cX wss cA cX wcel vo cv cJ wcel cA vo cv wcel wa cX cY wceq cJ ctop
      wcel vy cv cF wcel vy cv cX wss cF cfil wcel cX cY wceq vy cv cF wcel wa
      vy cv cY cX vy cv cF wcel vy cv cY wss cX cY wceq vy cv cF wcel vy cv cF
      cuni cY vy cv cF elssuni flimfnfcls.2 syl6ssr adantl cX cY wceq vy cv cF
      wcel pm3.26 sseqtr4d 3ad2antl3 ad2ant2rl vy cv cX vo cv cdif cX reldisj
      syl cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel
      cA vo cv wcel wa vy cv cF wcel wa wa vy cv cX cX vo cv cdif cdif wss vy
      cv vo cv wss vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa cX cX vo cv
      cdif cdif vo cv vy cv cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa wa vo cv cX wss cX cX
      vo cv cdif cdif vo cv wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a vo cv
      cJ wcel cA vo cv wcel wa vo cv cX wss cA cX wcel vy cv cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel
      cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ
      cX flimfnfcls.1 eltopss 3ad2antl1 adantrr ad2ant2r vo cv cX dfss4 sylib
      sseq2d cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv wss vo cv cF wcel cF
      cfil wcel vy cv cF wcel vo cv cY wss vy cv vo cv wss w3a vo cv cF wcel cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo
      cv wcel wa vy cv cF wcel wa vy cv vo cv wss wa wa vy cv vo cv cF cY
      flimfnfcls.2 fillsb cJ ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel
      cA cX wcel vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss wa cJ ctop wcel cF cfil wcel cX cY wceq 3simp2 ad2antrr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vy cv cF wcel vo cv cY wss vy cv
      vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa vy cv cF wcel vy cv vo cv wss simprlr cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa
      vy cv cF wcel wa vy cv vo cv wss wa wa vo cv cX cY cJ ctop wcel cF cfil
      wcel cX cY wceq w3a vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vo cv
      cX wss cA cX wcel vy cv vo cv wss cJ ctop wcel cF cfil wcel cX cY wceq
      w3a vo cv cJ wcel cA vo cv wcel wa vo cv cX wss vy cv cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA vo cv wcel
      cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo cv cJ
      cX flimfnfcls.1 eltopss 3ad2antl1 adantrr adantrr ad2ant2r cJ ctop wcel
      cF cfil wcel cX cY wceq w3a cX cY wceq cA cX wcel vo cv cJ wcel cA vo cv
      wcel wa vy cv cF wcel wa vy cv vo cv wss wa cJ ctop wcel cF cfil wcel cX
      cY wceq 3simp3 ad2antrr sseqtrd cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa vy cv cF wcel wa vy cv vo cv
      wss simprr 3jca sylc expr sylbid sylbid necon3bd exp44 com45 imp55
      adantrr sylanc ex r19.21aivv cF cfbas wcel vx cv cX wss cX vo cv cdif vx
      cv wss wa vx cab cfbas wcel c0 cF vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cun cfi cfv wnel vy cv vz cv cin c0 wne vz vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab wral vy cF wral wb cJ ctop wcel cF cfil wcel cX
      cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa
      wa wa vy vz cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab fbunfip cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfbas wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cF cfil wcel cJ ctop wcel cF
      cfbas wcel cX cY wceq cF filfbas 3ad2ant2 ad2antrr cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn wa wa wa vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil wcel
      vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfbas wcel cX cvv wcel cX
      vo cv cdif cX wss cX vo cv cdif c0 wne vx cv cX wss cX vo cv cdif vx cv
      wss wa vx cab cfil wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX
      wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa cX cvv wcel
      cX vo cv cdif cX wss cX vo cv cdif c0 wne w3a vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cfil wcel cX vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab cuni wceq vx cX cX vo cv cdif cvv supfil pm3.26d cJ ctop wcel cF
      cfil wcel cX cY wceq w3a cX cvv wcel cA cX wcel vo cv cJ wcel cA vo cv
      wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cvv wcel cX cY
      wceq cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel
      3ad2ant1 ad2antrr cX vo cv cdif cX wss cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cX vo cv difss a1i cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel
      wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa cX vo cv cdif c0 wne
      cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel wa
      cA vo cv wcel vo cv cF wcel wn cX vo cv cdif c0 wne cJ ctop wcel cF cfil
      wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF
      wcel wn cX vo cv cdif c0 wne wi cJ ctop wcel cF cfil wcel cX cY wceq w3a
      cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cF wcel cX vo cv
      cdif c0 cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ
      wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cF wcel cX
      vo cv cdif c0 wceq cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif cX wceq vo cv cX
      wceq vo cv cF wcel cJ ctop wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa
      vo cv cJ wcel cA vo cv wcel wa wa cX cX vo cv cdif cdif vo cv cX cJ ctop
      wcel cF cfil wcel cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv
      wcel wa wa vo cv cX wss cX cX vo cv cdif cdif vo cv wceq cJ ctop wcel cF
      cfil wcel cX cY wceq w3a vo cv cJ wcel vo cv cX wss cA cX wcel cA vo cv
      wcel cJ ctop wcel cF cfil wcel vo cv cJ wcel vo cv cX wss cX cY wceq vo
      cv cJ cX flimfnfcls.1 eltopss 3ad2antl1 ad2ant2r vo cv cX dfss4 sylib
      eqeq1d vo cv cX wceq vo cv cF wcel cX cF wcel cJ ctop wcel cF cfil wcel
      cX cY wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel wa wa vo cv cX
      cF eleq1 cJ ctop wcel cF cfil wcel cX cY wceq w3a cX cF wcel cA cX wcel
      vo cv cJ wcel cA vo cv wcel wa cF cfil wcel cX cY wceq cX cF wcel cJ ctop
      wcel cF cfil wcel cX cY wceq cX cF wcel cX cY wceq cX cF wcel cY cF wcel
      cF cfil wcel cX cY cF eleq1 cF cY flimfnfcls.2 filusb syl5cbir imp
      3adant1 ad2antrr syl5cbir sylbid cX vo cv cdif c0 wceq cX cX vo cv cdif
      cdif cX c0 cdif cX cX vo cv cdif c0 cX difeq2 cX dif0 syl6eq syl5
      necon3bd expr imp3a impr syl3anc vx cv cX wss cX vo cv cdif vx cv wss wa
      vx cab filfbas syl sylanc mpbird jca cJ ctop wcel cF cfil wcel cX cY wceq
      w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa wa
      cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cun cvv wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cfbas wcel cF vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cun c0 wne c0 cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cfi cfv wnel wa wb cF cfil wcel vx cv
      cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cF vx cv cX wss cX vo
      cv cdif vx cv wss wa vx cab cun cvv wcel cJ ctop wcel cF cfil wcel cX cY
      wceq w3a cA cX wcel wa vo cv cJ wcel cA vo cv wcel vo cv cF wcel wn wa wa
      wa cF vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cfil cvv unexg cJ
      ctop wcel cF cfil wcel cX cY wceq w3a cF cfil wcel cA cX wcel vo cv cJ
      wcel cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel cX cY
      wceq 3simp2 ad2antrr cJ ctop wcel cF cfil wcel cX cY wceq w3a vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cA cX wcel vo cv cJ wcel
      cA vo cv wcel vo cv cF wcel wn wa wa cJ ctop wcel cF cfil wcel vx cv cX
      wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cX cY wceq cJ ctop wcel cX
      cvv wcel vx cv cX wss cX vo cv cdif vx cv wss wa vx cab cvv wcel cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg flimfnfcls.1 syl5eqel cX vo cv cdif vx
      cv wss vx cX cvv abssexg syl 3ad2ant1 ad2antrr sylanc cF vx cv cX wss cX
      vo cv cdif vx cv wss wa vx cab cun cvv fsubbas syl mpbird cF vx cv cX wss
      cX vo cv cdif vx cv wss wa vx cab cun cfi cfv cF vx cv cX wss cX vo cv
      cdif vx cv wss wa vx cab cun cfi cfv cuni cF vx cv cX wss cX vo cv cdif
      vx cv wss wa vx cab cun cfi cfv cuni eqid fgbas syl 3eqtrd syl3anc mtbird
      3jca sylanc exp32 r19.23adv sylbid cX vg cv cuni wceq cF vg cv wss cA vg
      cv cJ cfclus cfv cfv wcel wn w3a vg cfil wrex cX vg cv cuni wceq cF vg cv
      wss wa cA vg cv cJ cfclus cfv cfv wcel wn wa vg cfil wrex cX vg cv cuni
      wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv wcel wi vg cfil wral wn
      cX vg cv cuni wceq cF vg cv wss cA vg cv cJ cfclus cfv cfv wcel wn w3a cX
      vg cv cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv cfv wcel wn wa vg
      cfil cX vg cv cuni wceq cF vg cv wss cA vg cv cJ cfclus cfv cfv wcel wn
      df-3an rexbii cX vg cv cuni wceq cF vg cv wss wa cA vg cv cJ cfclus cfv
      cfv wcel vg cfil rexanali bitri syl6ib con4d ex com23 mpdd impbid $.
      $( [12-Nov-2009] $) $( [12-Nov-2009] $)
  $}

  ${
    $d f x F $. $d f x J $. $d f x X $. $d f x Y $.
    uffclsflim.1 $e |- X = U. J $.
    uffclsflim.2 $e |- Y = U. F $.
    $( The cluster points of an ultrafilter are its limit points. $)
    uffclsflim $p |- ( ( J e. Top /\ F e. UFil /\ X = Y ) -> ( ( fClus ` J ) `
    F ) = ( ( fLim1 ` J ) ` F ) ) $=
      cJ ctop wcel cF cufil wcel cX cY wceq w3a cF cJ cfclus cfv cfv cF cJ
      cflim1 cfv cfv cJ ctop wcel cF cufil wcel cX cY wceq w3a vx cF cJ cfclus
      cfv cfv cF cJ cflim1 cfv cfv cJ ctop wcel cF cufil wcel cX cY wceq w3a vx
      cv cF cJ cfclus cfv cfv wcel cX vf cv cuni wceq cF vf cv wss vx cv vf cv
      cJ cflim1 cfv cfv wcel w3a vf cfil wrex vx cv cF cJ cflim1 cfv cfv wcel
      cJ ctop wcel cF cfil wcel cX cY wceq vx cv cF cJ cfclus cfv cfv wcel cX
      vf cv cuni wceq cF vf cv wss vx cv vf cv cJ cflim1 cfv cfv wcel w3a vf
      cfil wrex wb cF cufil wcel vx cv vf cF cJ cX cY uffclsflim.1 uffclsflim.2
      fclsfnflim cF ufilfil syl3an2 cJ ctop wcel cF cufil wcel cX cY wceq w3a
      cX vf cv cuni wceq cF vf cv wss vx cv vf cv cJ cflim1 cfv cfv wcel w3a vx
      cv cF cJ cflim1 cfv cfv wcel vf cfil cJ ctop wcel cF cufil wcel cX cY
      wceq w3a vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss vx cv vf cv cJ
      cflim1 cfv cfv wcel vx cv cF cJ cflim1 cfv cfv wcel cJ ctop wcel cF cufil
      wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss vx cv
      vf cv cJ cflim1 cfv cfv wcel vx cv cF cJ cflim1 cfv cfv wcel wi cJ ctop
      wcel cF cufil wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni wceq cF
      vf cv wss w3a wa vx cv cF cJ cflim1 cfv cfv wcel vx cv vf cv cJ cflim1
      cfv cfv wcel cJ ctop wcel cF cufil wcel cX cY wceq w3a vf cv cfil wcel cX
      vf cv cuni wceq cF vf cv wss w3a wa cF cJ cflim1 cfv cfv vf cv cJ cflim1
      cfv cfv vx cv cJ ctop wcel cF cufil wcel cX cY wceq w3a vf cv cfil wcel
      cX vf cv cuni wceq cF vf cv wss w3a wa cF vf cv cJ cflim1 cfv cF cufil
      wcel vf cv cfil wcel cY vf cv cuni wceq cF vf cv wss cF vf cv wceq cJ
      ctop wcel cF cufil wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni wceq
      cF vf cv wss w3a wa cF vf cv cY vf cv cuni uffclsflim.2 vf cv cuni eqid
      ufilmax cJ ctop wcel cF cufil wcel cX cY wceq vf cv cfil wcel cX vf cv
      cuni wceq cF vf cv wss w3a 3simpl2 cJ ctop wcel cF cufil wcel cX cY wceq
      w3a vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss 3simpr1 cX cY wceq cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq cF vf cv wss w3a cY vf cv
      cuni wceq cF cufil wcel cX cY wceq vf cv cfil wcel cX vf cv cuni wceq cY
      vf cv cuni wceq cF vf cv wss cX cY vf cv cuni eqtr2 3ad2antr2 3ad2antl3
      cJ ctop wcel cF cufil wcel cX cY wceq w3a vf cv cfil wcel cX vf cv cuni
      wceq cF vf cv wss 3simpr3 syl2anc fveq2d eleq2d biimprd 3exp2 imp5p
      r19.23adv sylbid ssrdv cJ ctop wcel cF cfil wcel cX cY wceq cF cJ cflim1
      cfv cfv cF cJ cfclus cfv cfv wss cF cufil wcel cF cJ cX cY uffclsflim.1
      uffclsflim.2 flimfcls cF ufilfil syl3an2 eqssd $.
      $( [11-Dec-2009] $) $( [11-Dec-2009] $)
  $}

  ${
    $d f g h j k t x y A $. $d f g h j k t x y F $. $d f g h j k t x y J $. $d
    f g h j k t x y K $. $d f g h j k t x y X $. $d f g h j k t x y Y $.
    fcluscnp.1 $e |- X = U. J $.
    fcluscnp.2 $e |- Y = U. K $.
    $( Lemma for ~ fcluscnp . If a function is continuous at a point, it
       respects clustering there. $)
    fcluscnplem $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X )
    -> ( A. g e. Fil ( ( X = U. g /\ A e. ( ( fLim1 ` J ) ` g ) ) -> ( F ` A )
    e. ( ( fLim1 ` K ) ` ( ( Y FilMap g ) ` F ) ) ) -> A. f e. Fil ( ( X = U. f
    /\ A e. ( ( fClus ` J ) ` f ) ) -> ( F ` A ) e. ( ( fClus ` K ) ` ( (
    Y FilMap f ) ` F ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni
      wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co
      cfv cK cflim1 cfv cfv wcel wi vg cfil wral cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY
      vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil
      wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel cA cF cfv cF cY
      vf cv cfilmap co cfv cK cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv
      wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg
      cfil wral vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq
      cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv
      cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq
      wa wa wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a vh cfil wrex cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv
      wss cA cF cfv vk cv cK cflim1 cfv cfv wcel w3a vk cfil wrex cA vf cv cJ
      cfclus cfv cfv wcel cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv
      cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX
      vf cv cuni wceq wa wa wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ
      cflim1 cfv cfv wcel w3a cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk
      cv wss cA cF cfv vk cv cK cflim1 cfv cfv wcel w3a vk cfil wrex vh cfil cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq
      cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv
      cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq
      wa vh cv cfil wcel cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1
      cfv cfv wcel w3a cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss
      cA cF cfv vk cv cK cflim1 cfv cfv wcel w3a vk cfil wrex wi wi cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel vf cv
      cfil wcel cX vf cv cuni wceq wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv
      cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wi vg cfil wral cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv
      cfv wcel w3a cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA
      cF cfv vk cv cK cflim1 cfv cfv wcel w3a vk cfil wrex wi cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel cX vh cv cuni
      wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a cX vg cv cuni
      wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co
      cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX vf cv cuni
      wceq wa cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv
      vk cv cK cflim1 cfv cfv wcel w3a vk cfil wrex cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel cX vh cv cuni wceq vf cv vh
      cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv
      cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral cY vk
      cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk cv cK
      cflim1 cfv cfv wcel w3a vk cfil wrex cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vh cv cfil wcel cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg
      cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral cY vk cv cuni
      wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk cv cK cflim1 cfv
      cfv wcel w3a vk cfil wrex wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv
      cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cX
      vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral cX vh cv cuni wceq
      cA vh cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vh cv cfilmap co cfv
      cK cflim1 cfv cfv wcel wi cY vk cv cuni wceq cF cY vf cv cfilmap co cfv
      vk cv wss cA cF cfv vk cv cK cflim1 cfv cfv wcel w3a vk cfil wrex vh cv
      cfil wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv
      cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral cX vh
      cv cuni wceq cA vh cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vh cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi wi cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ
      cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa cX vg cv
      cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi cX vh cv cuni wceq cA vh cv cJ
      cflim1 cfv cfv wcel wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv
      cfv wcel wi vg vh cv cfil vg cv vh cv wceq cX vg cv cuni wceq cA vg cv cJ
      cflim1 cfv cfv wcel wa cX vh cv cuni wceq cA vh cv cJ cflim1 cfv cfv wcel
      wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel cA cF cfv
      cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel vg cv vh cv wceq cX vg
      cv cuni wceq cX vh cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel cA vh cv
      cJ cflim1 cfv cfv wcel vg cv vh cv wceq vg cv cuni vh cv cuni cX vg cv vh
      cv unieq eqeq2d vg cv vh cv wceq vg cv cJ cflim1 cfv cfv vh cv cJ cflim1
      cfv cfv cA vg cv vh cv cJ cflim1 cfv fveq2 eleq2d anbi12d vg cv vh cv
      wceq cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv cF cY vh cv cfilmap co
      cfv cK cflim1 cfv cfv cA cF cfv vg cv vh cv wceq cF cY vg cv cfilmap co
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv vg cv vh cv wceq cF cY vg cv
      cfilmap co cY vh cv cfilmap co vg cv vh cv cY cfilmap opreq2 fveq1d
      fveq2d eleq2d imbi12d rcla4v ad2antlr cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv
      wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cX vh cv cuni wceq cA vh cv cJ cflim1 cfv cfv wcel wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wi cX vh cv cuni
      wceq cA vh cv cJ cflim1 cfv cfv wcel wa cY vk cv cuni wceq cF cY vf cv
      cfilmap co cfv vk cv wss cA cF cfv vk cv cK cflim1 cfv cfv wcel w3a vk
      cfil wrex cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a cX vh cv cuni wceq cA vh cv cJ cflim1 cfv cfv wcel wa cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa vf cv
      cfil wcel cX vf cv cuni wceq wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel 3simpb ad2antrl cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv
      wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk cv
      cK cflim1 cfv cfv wcel w3a vk cfil wrex cX vh cv cuni wceq cA vh cv cJ
      cflim1 cfv cfv wcel wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ
      cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cY vk cv cuni wceq
      cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk cv cK cflim1 cfv cfv
      wcel w3a vk cfil wrex cF cY vh cv cfilmap co cfv cfil wcel cY cF cY vh cv
      cfilmap co cfv cuni wceq cF cY vf cv cfilmap co cfv cF cY vh cv cfilmap
      co cfv wss cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      w3a cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk
      cv cK cflim1 cfv cfv wcel w3a vk cfil wrex cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh
      cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wa cY vk cv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk
      cv cK cflim1 cfv cfv wcel w3a cY cF cY vh cv cfilmap co cfv cuni wceq cF
      cY vf cv cfilmap co cfv cF cY vh cv cfilmap co cfv wss cA cF cfv cF cY vh
      cv cfilmap co cfv cK cflim1 cfv cfv wcel w3a vk cF cY vh cv cfilmap co
      cfv cfil vk cv cF cY vh cv cfilmap co cfv wceq cY vk cv cuni wceq cY cF
      cY vh cv cfilmap co cfv cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cF
      cY vf cv cfilmap co cfv cF cY vh cv cfilmap co cfv wss cA cF cfv vk cv cK
      cflim1 cfv cfv wcel cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv
      cfv wcel vk cv cF cY vh cv cfilmap co cfv wceq vk cv cuni cF cY vh cv
      cfilmap co cfv cuni cY vk cv cF cY vh cv cfilmap co cfv unieq eqeq2d vk
      cv cF cY vh cv cfilmap co cfv cF cY vf cv cfilmap co cfv sseq2 vk cv cF
      cY vh cv cfilmap co cfv wceq vk cv cK cflim1 cfv cfv cF cY vh cv cfilmap
      co cfv cK cflim1 cfv cfv cA cF cfv vk cv cF cY vh cv cfilmap co cfv cK
      cflim1 cfv fveq2 eleq2d 3anbi123d rcla4ev cY cvv wcel vh cv cfbas wcel vh
      cv cuni cY cF wf cF cY vh cv cfilmap co cfv cfil wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni
      wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel
      cX vf cv cuni wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK
      cflim1 cfv cfv wcel wa cvv vh cv cF cY vh cv cuni vh cv cuni eqid fmf cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa
      cY cvv wcel cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv
      cfilmap co cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cY cvv wcel cA cX wcel vh cv cfil wcel cK ctop wcel cJ ctop wcel
      cY cvv wcel cX cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg
      fcluscnp.2 syl5eqel 3ad2ant2 ad2antrr ad2antrr cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa vh cv cfbas wcel cX vh
      cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co cfv
      cK cflim1 cfv cfv wcel vh cv cfil wcel vh cv cfbas wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv filfbas adantl ad2antrr cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa
      cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf
      cv cfil wcel cX vf cv cuni wceq wa wa wa vh cv cuni cY cF wf cA cF cfv cF
      cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv
      vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vh cv cuni cY cF wf vf cv
      cfil wcel cX vf cv cuni wceq wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa vf cv vh cv wss cX vh cv cuni wceq vh cv
      cuni cY cF wf cA vh cv cJ cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vh cv cuni wceq vh cv cuni cY cF wf vh
      cv cfil wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vh cv cuni wceq
      vh cv cuni cY cF wf cA cX wcel cX cY cF wf cJ ctop wcel cX vh cv cuni
      wceq vh cv cuni cY cF wf cK ctop wcel cX vh cv cuni wceq cX cY cF wf vh
      cv cuni cY cF wf cX vh cv cuni cY cF feq2 biimpac 3ad2antl3 adantlr
      adantlr 3ad2antr1 adantrr adantr syl3anc cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv
      wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wa cY cF cY vh cv cfilmap co cfv cuni wceq cF cY vf cv cfilmap co cfv cF
      cY vh cv cfilmap co cfv wss cA cF cfv cF cY vh cv cfilmap co cfv cK
      cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ
      cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa cF cY vh cv
      cfilmap co cfv cuni cY cY cvv wcel vh cv cfbas wcel vh cv cuni cY cF wf
      cF cY vh cv cfilmap co cfv cuni cY wceq cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv
      wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wa cvv vh cv cF cY vh cv cuni vh cv cuni eqid fmbas cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cY cvv wcel cX vh
      cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co cfv
      cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv
      wcel cA cX wcel vh cv cfil wcel cK ctop wcel cJ ctop wcel cY cvv wcel cX
      cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg fcluscnp.2 syl5eqel
      3ad2ant2 ad2antrr ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vh cv cfil wcel wa vh cv cfbas wcel cX vh cv cuni wceq vf cv
      vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv
      cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv
      wcel vh cv cfil wcel vh cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vh cv filfbas adantl ad2antrr cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq
      vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf
      cv cuni wceq wa wa wa vh cv cuni cY cF wf cA cF cfv cF cY vh cv cfilmap
      co cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel w3a vh cv cuni cY cF wf vf cv cfil wcel cX vf
      cv cuni wceq wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      vh cv cfil wcel wa vf cv vh cv wss cX vh cv cuni wceq vh cv cuni cY cF wf
      cA vh cv cJ cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cX vh cv cuni wceq vh cv cuni cY cF wf vh cv cfil wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cX vh cv cuni wceq vh cv cuni cY
      cF wf cA cX wcel cX cY cF wf cJ ctop wcel cX vh cv cuni wceq vh cv cuni
      cY cF wf cK ctop wcel cX vh cv cuni wceq cX cY cF wf vh cv cuni cY cF wf
      cX vh cv cuni cY cF feq2 biimpac 3ad2antl3 adantlr adantlr 3ad2antr1
      adantrr adantr syl3anc eqcomd cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa
      cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vx cv cF
      vy cv cima wceq vy vf cv wrex vx cab cY csn cun cfg cfv vx cv cF vy cv
      cima wceq vy vh cv wrex vx cab cY csn cun cfg cfv cF cY vf cv cfilmap co
      cfv cF cY vh cv cfilmap co cfv vx cv cF vy cv cima wceq vy vf cv wrex vx
      cab cY csn cun cfbas wcel vx cv cF vy cv cima wceq vy vh cv wrex vx cab
      cY csn cun cfbas wcel vx cv cF vy cv cima wceq vy vf cv wrex vx cab cY
      csn cun vx cv cF vy cv cima wceq vy vh cv wrex vx cab cY csn cun wss vx
      cv cF vy cv cima wceq vy vf cv wrex vx cab cY csn cun cfg cfv vx cv cF vy
      cv cima wceq vy vh cv wrex vx cab cY csn cun cfg cfv wss cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni
      wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel
      cX vf cv cuni wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK
      cflim1 cfv cfv wcel wa vx cv cF vy cv cima wceq vy vf cv wrex vx cab cY
      csn cun vx cv cF vy cv cima wceq vy vh cv wrex vx cab cY csn cun fgss vx
      cv cF vy cv cima wceq vy vf cv wrex vx cab cfbas wcel vx cv cF vy cv cima
      wceq vy vf cv wrex vx cab cuni cY wss vx cv cF vy cv cima wceq vy vf cv
      wrex vx cab cY csn cun cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa cY
      vx cv cF vy cv cima wceq vy vf cv wrex vx cab vx cv cF vy cv cima wceq vy
      vf cv wrex vx cab cuni vx cv cF vy cv cima wceq vy vf cv wrex vx cab cuni
      eqid extbas1 vf cv cfbas wcel cF vf cv cuni wfn vx cv cF vy cv cima wceq
      vy vf cv wrex vx cab cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa
      cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vy vx vf
      cv vx cv cF vy cv cima wceq vy vf cv wrex vx cab cF vf cv cuni vf cv cuni
      eqid vx cv cF vy cv cima wceq vy vf cv wrex vx cab eqid filrn cX vh cv
      cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil
      wcel cX vf cv cuni wceq wa wa vf cv cfbas wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cA cF cfv cF cY vh cv
      cfilmap co cfv cK cflim1 cfv cfv wcel vf cv cfil wcel vf cv cfbas wcel cX
      vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a cX vf
      cv cuni wceq vf cv filfbas ad2antrl ad2antlr cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh
      cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cF vf cv cuni wfn cA cF cfv cF cY vh cv cfilmap co cfv cK
      cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ
      cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cF cX
      wfn cF vf cv cuni wfn cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cF cX wfn vh cv cfil wcel cX vh cv cuni wceq vf cv vh cv wss cA
      vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cX wfn cA cX wcel cX cY cF
      wf cJ ctop wcel cF cX wfn cK ctop wcel cX cY cF ffn 3ad2ant3 adantr
      ad2antrr vf cv cfil wcel cX vf cv cuni wceq wa cF cX wfn cF vf cv cuni
      wfn wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil
      wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a cX vf cv cuni wceq cF cX wfn cF vf cv cuni wfn wb vf cv cfil
      wcel cX vf cv cuni cF fneq2 adantl ad2antll mpbid adantr sylanc cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh
      cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co
      cfv cK cflim1 cfv cfv wcel wa vt cv cY wss vt vx cv cF vy cv cima wceq vy
      vf cv wrex vx cab wral vx cv cF vy cv cima wceq vy vf cv wrex vx cab cuni
      cY wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil
      wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF cfv cF cY vh
      cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vt cv cY wss vt vx cv cF vy
      cv cima wceq vy vf cv wrex vx cab cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vt
      cv cF vy cv cima wceq vy vf cv wrex vt cv cY wss vt cv vx cv cF vy cv
      cima wceq vy vf cv wrex vx cab wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vt
      cv cF vy cv cima wceq vt cv cY wss vy vf cv cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh
      cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wa vt cv cF vy cv cima wceq vt cv cY wss wi vy cv vf cv wcel vt cv cF vy
      cv cima wceq vt cv cY wss cF vy cv cima cY wss cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv
      vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv
      cuni wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv
      wcel wa vt cv cF vy cv cima cY sseq1 cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vh cv cfil wcel wa cF vy cv cima cY wss cX vh cv
      cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil
      wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK
      cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF vy cv
      cima cY wss cA cX wcel vh cv cfil wcel cX cY cF wf cJ ctop wcel cF vy cv
      cima cY wss cK ctop wcel cX cY cF wf cF vy cv cima cF crn cY cF vy cv
      cima cF crn wss cX cY cF wf cF vy cv imassrn a1i cX cY cF frn sstrd
      3ad2ant3 ad2antrr ad2antrr syl5cbir a1d r19.23adv vx cv cF vy cv cima
      wceq vy vf cv wrex vt cv cF vy cv cima wceq vy vf cv wrex vx vt cv vt
      visset vx cv vt cv wceq vx cv cF vy cv cima wceq vt cv cF vy cv cima wceq
      vy vf cv vx cv vt cv cF vy cv cima eqeq1 rexbidv elab syl5ib r19.21aiv vt
      vx cv cF vy cv cima wceq vy vf cv wrex vx cab cY unissb sylibr sylanc vx
      cv cF vy cv cima wceq vy vh cv wrex vx cab cfbas wcel vx cv cF vy cv cima
      wceq vy vh cv wrex vx cab cuni cY wss vx cv cF vy cv cima wceq vy vh cv
      wrex vx cab cY csn cun cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa cY
      vx cv cF vy cv cima wceq vy vh cv wrex vx cab vx cv cF vy cv cima wceq vy
      vh cv wrex vx cab cuni vx cv cF vy cv cima wceq vy vh cv wrex vx cab cuni
      eqid extbas1 vh cv cfbas wcel cF vh cv cuni wfn vx cv cF vy cv cima wceq
      vy vh cv wrex vx cab cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa
      cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vy vx vh
      cv vx cv cF vy cv cima wceq vy vh cv wrex vx cab cF vh cv cuni vh cv cuni
      eqid vx cv cF vy cv cima wceq vy vh cv wrex vx cab eqid filrn cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa vh cv
      cfbas wcel cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv
      cfilmap co cfv cK cflim1 cfv cfv wcel vh cv cfil wcel vh cv cfbas wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv filfbas adantl
      ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv
      cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv
      cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF cfv cF cY
      vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa cF cX wfn cF vh cv cuni
      wfn cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil
      wcel wa cF cX wfn cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1
      cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY
      vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cF cX wfn cA cX wcel vh cv cfil wcel cX cY cF wf cJ ctop
      wcel cF cX wfn cK ctop wcel cX cY cF ffn 3ad2ant3 ad2antrr ad2antrr cX vh
      cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa cF cX wfn cF vh cv cuni wfn wb cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cX vh cv cuni wceq
      vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a cF cX wfn cF vh cv
      cuni wfn wb vf cv cfil wcel cX vf cv cuni wceq wa cX vh cv cuni wceq vf
      cv vh cv wss cF cX wfn cF vh cv cuni wfn wb cA vh cv cJ cflim1 cfv cfv
      wcel cX vh cv cuni cF fneq2 3ad2ant1 adantr ad2antlr mpbid sylanc cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh
      cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co
      cfv cK cflim1 cfv cfv wcel wa vt cv cY wss vt vx cv cF vy cv cima wceq vy
      vh cv wrex vx cab wral vx cv cF vy cv cima wceq vy vh cv wrex vx cab cuni
      cY wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil
      wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv
      wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF cfv cF cY vh
      cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vt cv cY wss vt vx cv cF vy
      cv cima wceq vy vh cv wrex vx cab cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vt
      cv cF vy cv cima wceq vy vh cv wrex vt cv cY wss vt cv vx cv cF vy cv
      cima wceq vy vh cv wrex vx cab wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vt
      cv cF vy cv cima wceq vt cv cY wss vy vh cv cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh
      cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wa vt cv cF vy cv cima wceq vt cv cY wss wi vy cv vh cv wcel cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa vt cv cF vy
      cv cima wceq vt cv cY wss wi cX vh cv cuni wceq vf cv vh cv wss cA vh cv
      cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a vt cv cF vy cv cima wceq vt cv cY wss wi cA cX
      wcel vh cv cfil wcel cX cY cF wf cJ ctop wcel vt cv cF vy cv cima wceq vt
      cv cY wss wi cK ctop wcel vt cv cF vy cv cima wceq vt cv cY wss cF vy cv
      cima cY wss cX cY cF wf vt cv cF vy cv cima cY sseq1 cX cY cF wf cF vy cv
      cima cF crn cY cF vy cv cima cF crn wss cX cY cF wf cF vy cv imassrn a1i
      cX cY cF frn sstrd syl5cbir 3ad2ant3 ad2antrr ad2antrr a1d r19.23adv vx
      cv cF vy cv cima wceq vy vh cv wrex vt cv cF vy cv cima wceq vy vh cv
      wrex vx vt cv vt visset vx cv vt cv wceq vx cv cF vy cv cima wceq vt cv
      cF vy cv cima wceq vy vh cv vx cv vt cv cF vy cv cima eqeq1 rexbidv elab
      syl5ib r19.21aiv vt vx cv cF vy cv cima wceq vy vh cv wrex vx cab cY
      unissb sylibr sylanc cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ
      cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vx cv cF vy cv
      cima wceq vy vf cv wrex vx cv cF vy cv cima wceq vy vh cv wrex wi vx wal
      vx cv cF vy cv cima wceq vy vf cv wrex vx cab cY csn cun vx cv cF vy cv
      cima wceq vy vh cv wrex vx cab cY csn cun wss cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv
      vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv
      cuni wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv
      wcel wa vx cv cF vy cv cima wceq vy vf cv wrex vx cv cF vy cv cima wceq
      vy vh cv wrex wi vx cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1
      cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa vx cv cF vy cv
      cima wceq vy vf cv wrex vx cv cF vy cv cima wceq vy vh cv wrex wi cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cA cF
      cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cX vh cv cuni wceq
      vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vx cv cF vy cv cima
      wceq vy vf cv wrex vx cv cF vy cv cima wceq vy vh cv wrex wi vf cv cfil
      wcel cX vf cv cuni wceq wa vf cv vh cv wss cX vh cv cuni wceq vx cv cF vy
      cv cima wceq vy vf cv wrex vx cv cF vy cv cima wceq vy vh cv wrex wi cA
      vh cv cJ cflim1 cfv cfv wcel vx cv cF vy cv cima wceq vy vf cv vh cv
      ssrexv 3ad2ant2 adantr ad2antlr 19.21aiv vx cv cF vy cv cima wceq vy vf
      cv wrex vx cv cF vy cv cima wceq vy vh cv wrex wi vx wal vx cv cF vy cv
      cima wceq vy vf cv wrex vx cab vx cv cF vy cv cima wceq vy vh cv wrex vx
      cab wss vx cv cF vy cv cima wceq vy vf cv wrex vx cab cY csn cun vx cv cF
      vy cv cima wceq vy vh cv wrex vx cab cY csn cun wss vx cv cF vy cv cima
      wceq vy vf cv wrex vx cv cF vy cv cima wceq vy vh cv wrex vx ss2ab vx cv
      cF vy cv cima wceq vy vf cv wrex vx cab vx cv cF vy cv cima wceq vy vh cv
      wrex vx cab cY csn unss1 sylbir syl syl3anc cY cvv wcel vf cv cfbas wcel
      vf cv cuni cY cF wf cF cY vf cv cfilmap co cfv vx cv cF vy cv cima wceq
      vy vf cv wrex vx cab cY csn cun cfg cfv wceq cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh
      cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni
      wceq wa wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wa vx vy cvv vf cv cF cY vf cv cuni vf cv cuni eqid isfilmap cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cY cvv wcel
      cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf
      cv cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co
      cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY
      cvv wcel cA cX wcel vh cv cfil wcel cK ctop wcel cJ ctop wcel cY cvv wcel
      cX cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg fcluscnp.2
      syl5eqel 3ad2ant2 ad2antrr ad2antrr cX vh cv cuni wceq vf cv vh cv wss cA
      vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa
      vf cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      vh cv cfil wcel wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv
      wcel vf cv cfil wcel vf cv cfbas wcel cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a cX vf cv cuni wceq vf cv filfbas
      ad2antrl ad2antlr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1
      cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa vf cv cuni
      cY cF wf cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa
      cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a cX
      vf cv cuni wceq vf cv cuni cY cF wf vf cv cfil wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq vf cv cuni cY cF wf
      vh cv cfil wcel cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv
      cfv wcel w3a cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vf cv cuni wceq
      vf cv cuni cY cF wf cA cX wcel cX cY cF wf cJ ctop wcel cX vf cv cuni
      wceq vf cv cuni cY cF wf cK ctop wcel cX vf cv cuni wceq cX cY cF wf vf
      cv cuni cY cF wf cX vf cv cuni cY cF feq2 biimpac 3ad2antl3 adantlr
      ad2ant2rl adantrrl adantr syl3anc cY cvv wcel vh cv cfbas wcel vh cv cuni
      cY cF wf cF cY vh cv cfilmap co cfv vx cv cF vy cv cima wceq vy vh cv
      wrex vx cab cY csn cun cfg cfv wceq cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss
      cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa
      wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel wa vx
      vy cvv vh cv cF cY vh cv cuni vh cv cuni eqid isfilmap cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cY cvv wcel cX
      vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv
      cfil wcel cX vf cv cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co cfv
      cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv
      wcel cA cX wcel vh cv cfil wcel cK ctop wcel cJ ctop wcel cY cvv wcel cX
      cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg fcluscnp.2 syl5eqel
      3ad2ant2 ad2antrr ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa vh cv cfil wcel wa vh cv cfbas wcel cX vh cv cuni wceq vf cv
      vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv
      cuni wceq wa wa cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv
      wcel vh cv cfil wcel vh cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa vh cv filfbas adantl ad2antrr cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq
      vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf
      cv cuni wceq wa wa wa vh cv cuni cY cF wf cA cF cfv cF cY vh cv cfilmap
      co cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel w3a vh cv cuni cY cF wf vf cv cfil wcel cX vf
      cv cuni wceq wa cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      vh cv cfil wcel wa vf cv vh cv wss cX vh cv cuni wceq vh cv cuni cY cF wf
      cA vh cv cJ cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cX vh cv cuni wceq vh cv cuni cY cF wf vh cv cfil wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cX vh cv cuni wceq vh cv cuni cY
      cF wf cA cX wcel cX cY cF wf cJ ctop wcel cX vh cv cuni wceq vh cv cuni
      cY cF wf cK ctop wcel cX vh cv cuni wceq cX cY cF wf vh cv cuni cY cF wf
      cX vh cv cuni cY cF feq2 biimpac 3ad2antl3 adantlr adantlr 3ad2antr1
      adantrr adantr syl3anc 3sstr4d cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vh cv cfil wcel wa cX vh cv cuni wceq vf cv vh cv wss cA vh
      cv cJ cflim1 cfv cfv wcel w3a vf cv cfil wcel cX vf cv cuni wceq wa wa wa
      cA cF cfv cF cY vh cv cfilmap co cfv cK cflim1 cfv cfv wcel pm3.27 3jca
      sylanc ex imim2d mpid syld exp43 com45 com35 com24 imp32 r19.23adv cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel cX vh cv cuni wceq vf cv vh cv wss cA vh cv cJ cflim1 cfv cfv wcel
      w3a vh cfil wrex wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY
      vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil
      wcel cX vf cv cuni wceq wa wa wa cA vh vf cv cJ cX vf cv cuni fcluscnp.1
      vf cv cuni eqid fclsfnflim cJ ctop wcel cK ctop wcel cX cY cF wf w3a cJ
      ctop wcel cA cX wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel
      wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil
      wral vf cv cfil wcel cX vf cv cuni wceq wa wa cJ ctop wcel cK ctop wcel
      cX cY cF wf 3simp1 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF
      cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf
      cv cfil wcel cX vf cv cuni wceq simprrl cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv
      wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg
      cfil wral vf cv cfil wcel cX vf cv cuni wceq simprrr syl3anc cK ctop wcel
      cF cY vf cv cfilmap co cfv cfil wcel cY cF cY vf cv cfilmap co cfv cuni
      wceq cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel cY vk cv
      cuni wceq cF cY vf cv cfilmap co cfv vk cv wss cA cF cfv vk cv cK cflim1
      cfv cfv wcel w3a vk cfil wrex wb cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa
      cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil
      wral vf cv cfil wcel cX vf cv cuni wceq wa wa wa cA cF cfv vk cF cY vf cv
      cfilmap co cfv cK cY cF cY vf cv cfilmap co cfv cuni fcluscnp.2 cF cY vf
      cv cfilmap co cfv cuni eqid fclsfnflim cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cK ctop wcel cA cX wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv
      cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq wa wa cJ ctop wcel cK
      ctop wcel cX cY cF wf 3simp2 ad2antrr cY cvv wcel vf cv cfbas wcel vf cv
      cuni cY cF wf cF cY vf cv cfilmap co cfv cfil wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1
      cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv
      wcel wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq wa wa wa cvv vf
      cv cF cY vf cv cuni vf cv cuni eqid fmf cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cY cvv wcel cA cX wcel cX vg cv cuni wceq cA vg cv cJ cflim1
      cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv
      wcel wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq wa wa cK ctop
      wcel cJ ctop wcel cY cvv wcel cX cY cF wf cK ctop wcel cK cuni cvv cY cK
      ctop uniexg fcluscnp.2 syl5eqel 3ad2ant2 ad2antrr vf cv cfil wcel cX vf
      cv cuni wceq wa vf cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa
      cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil
      wral vf cv cfil wcel vf cv cfbas wcel cX vf cv cuni wceq vf cv filfbas
      adantr ad2antll cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg
      cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel
      cX vf cv cuni wceq wa wa wa cX cY cF wf vf cv cuni cY cF wf cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cX cY cF wf cA cX wcel cX vg cv cuni wceq cA
      vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK
      cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq wa
      wa cJ ctop wcel cK ctop wcel cX cY cF wf 3simp3 ad2antrr vf cv cfil wcel
      cX vf cv cuni wceq wa cX cY cF wf vf cv cuni cY cF wf wb cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ
      cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv
      cfv wcel wi vg cfil wral cX vf cv cuni wceq cX cY cF wf vf cv cuni cY cF
      wf wb vf cv cfil wcel cX vf cv cuni cY cF feq2 adantl ad2antll mpbid
      syl3anc cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv
      cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX
      vf cv cuni wceq wa wa wa cF cY vf cv cfilmap co cfv cuni cY cY cvv wcel
      vf cv cfbas wcel vf cv cuni cY cF wf cF cY vf cv cfilmap co cfv cuni cY
      wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv
      cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX
      vf cv cuni wceq wa wa wa cvv vf cv cF cY vf cv cuni vf cv cuni eqid fmbas
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv wcel cA cX wcel cX vg cv
      cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel cX
      vf cv cuni wceq wa wa cK ctop wcel cJ ctop wcel cY cvv wcel cX cY cF wf
      cK ctop wcel cK cuni cvv cY cK ctop uniexg fcluscnp.2 syl5eqel 3ad2ant2
      ad2antrr vf cv cfil wcel cX vf cv cuni wceq wa vf cv cfbas wcel cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg
      cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK
      cflim1 cfv cfv wcel wi vg cfil wral vf cv cfil wcel vf cv cfbas wcel cX
      vf cv cuni wceq vf cv filfbas adantr ad2antll cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv
      cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel
      wi vg cfil wral vf cv cfil wcel cX vf cv cuni wceq wa wa wa cX cY cF wf
      vf cv cuni cY cF wf cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX cY cF wf
      cA cX wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF
      cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral vf
      cv cfil wcel cX vf cv cuni wceq wa wa cJ ctop wcel cK ctop wcel cX cY cF
      wf 3simp3 ad2antrr vf cv cfil wcel cX vf cv cuni wceq wa cX cY cF wf vf
      cv cuni cY cF wf wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF cfv cF cY
      vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil wral cX vf cv cuni
      wceq cX cY cF wf vf cv cuni cY cF wf wb vf cv cfil wcel cX vf cv cuni cY
      cF feq2 adantl ad2antll mpbid syl3anc eqcomd syl3anc 3imtr4d exp45 imp5a
      r19.21adv $.
      $( [20-Nov-2009] $) $( [20-Nov-2009] $)

    $( A function ` F ` is continuous at point ` A ` iff ` F ` respects cluster
       points there. $)
    fcluscnp $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X ) -> (
    F e. ( ( J CnP K ) ` A ) <-> A. f e. Fil ( ( X = U. f /\ A e. ( ( fClus ` J
    ) ` f ) ) -> ( F ` A ) e. ( ( fClus ` K ) ` ( ( Y FilMap f ) ` F ) ) ) ) )
    $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp
      co cfv wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF
      cfv vx cv cF vy cv cima wceq vy vg cv wrex vx cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel wi vg cfil wral cX vg cv cuni wceq cA vg cv cJ cflim1
      cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv
      wcel wi vg cfil wral cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel
      wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral vx vy cA vg cF cJ cK vx cv cF vy cv cima wceq vy vg cv wrex vx cab
      cY csn cun cfg cfv cX cY fcluscnp.1 fcluscnp.2 vx cv cF vy cv cima wceq
      vy vg cv wrex vx cab cY csn cun cfg cfv eqid cnpfillim cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ
      cflim1 cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv
      cfv wcel wi cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel wa cA cF
      cfv vx cv cF vy cv cima wceq vy vg cv wrex vx cab cY csn cun cfg cfv cK
      cflim1 cfv cfv wcel wi vg cfil cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vg cv cfil wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1
      cfv cfv wcel wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv
      wcel cA cF cfv vx cv cF vy cv cima wceq vy vg cv wrex vx cab cY csn cun
      cfg cfv cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vg cv cfil wcel wa cX vg cv cuni wceq cA cF cfv cF cY vg cv
      cfilmap co cfv cK cflim1 cfv cfv wcel cA cF cfv vx cv cF vy cv cima wceq
      vy vg cv wrex vx cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wb cA vg
      cv cJ cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa vg cv cfil wcel cX vg cv cuni wceq cA cF cfv cF cY vg cv cfilmap
      co cfv cK cflim1 cfv cfv wcel cA cF cfv vx cv cF vy cv cima wceq vy vg cv
      wrex vx cab cY csn cun cfg cfv cK cflim1 cfv cfv wcel wb cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa vg cv cfil wcel cX vg cv cuni
      wceq wa wa cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv vx cv cF vy cv
      cima wceq vy vg cv wrex vx cab cY csn cun cfg cfv cK cflim1 cfv cfv cA cF
      cfv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vg cv cfil
      wcel cX vg cv cuni wceq wa wa cF cY vg cv cfilmap co cfv vx cv cF vy cv
      cima wceq vy vg cv wrex vx cab cY csn cun cfg cfv cK cflim1 cfv cY cvv
      wcel vg cv cfbas wcel vg cv cuni cY cF wf cF cY vg cv cfilmap co cfv vx
      cv cF vy cv cima wceq vy vg cv wrex vx cab cY csn cun cfg cfv wceq cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vg cv cfil wcel cX
      vg cv cuni wceq wa wa vx vy cvv vg cv cF cY vg cv cuni vg cv cuni eqid
      isfilmap cJ ctop wcel cK ctop wcel cX cY cF wf w3a cY cvv wcel cA cX wcel
      vg cv cfil wcel cX vg cv cuni wceq wa cK ctop wcel cJ ctop wcel cY cvv
      wcel cX cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg fcluscnp.2
      syl5eqel 3ad2ant2 ad2antrr vg cv cfil wcel vg cv cfbas wcel cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vg cv cuni wceq vg cv
      filfbas ad2antrl cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      vg cv cfil wcel cX vg cv cuni wceq vg cv cuni cY cF wf cX vg cv cuni wceq
      cX cY cF wf vg cv cuni cY cF wf cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa vg cv cfil wcel wa cX vg cv cuni cY cF feq2 cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cX cY cF wf cA cX wcel vg cv cfil wcel cJ ctop
      wcel cK ctop wcel cX cY cF wf 3simp3 ad2antrr syl5cbi impr syl3anc fveq2d
      eleq2d expr adantrd pm5.74d ralbidva cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel
      wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil
      wral cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF
      cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral cA vf vg
      cF cJ cK cX cY fcluscnp.1 fcluscnp.2 fcluscnplem cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel
      wa cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi vg cfil
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni
      wceq cA vg cv cJ cflim1 cfv cfv wcel cA cF cfv cF cY vg cv cfilmap co cfv
      cK cflim1 cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv
      cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv
      cfil wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel cA cF cfv cF
      cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel wi cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX vh cv
      cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil
      wral cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa cA cF cfv
      vk cv cK cfclus cfv cfv wcel wi vk cfil wral cA vg cv cJ cflim1 cfv cfv
      wcel cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf
      cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK
      cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa
      wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv
      wcel wi vh cfil wral cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv
      wss wa cA cF cfv vk cv cK cfclus cfv cfv wcel wi vk cfil cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX
      vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh
      cfil wral vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv
      vk cv wss wa cA cF cfv vk cv cK cfclus cfv cfv wcel cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX vh cv
      cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil
      wral vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv
      wss wa wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj
      cv cfilmap co cfv wceq w3a vj cfbas wrex cA cF cfv vk cv cK cfclus cfv
      cfv wcel vg cv cfbas wcel vk cv cfil wcel vg cv cuni cY cF wf w3a cF cY
      vg cv cfilmap co cfv vk cv wss cY vk cv cuni wceq vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cfbas
      wrex cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv
      cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni wceq
      cF cY vg cv cfilmap co cfv vk cv wss wa wa wa wa vg cv cF vk cv cY vg cv
      cuni vk cv cuni vj vg cv cuni eqid vk cv cuni eqid fmfnfm cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX
      vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh
      cfil wral vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv
      vk cv wss wa wa wa wa vg cv cfbas wcel vk cv cfil wcel vg cv cuni cY cF
      wf cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY
      vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil
      wcel cX vg cv cuni wceq wa wa vg cv cfbas wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh
      cv cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel vg cv
      cfbas wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF
      cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral cX
      vg cv cuni wceq vg cv filfbas ad2antrl ad2antlr cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv
      cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX vh cv cuni
      wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil wral
      vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss
      wa simprrl cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf
      cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa wa vg cv cuni cY cF wf cX vh cv cuni wceq vg cv vh
      cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vg cv cfil wcel cX vg cv
      cuni wceq wa vg cv cuni cY cF wf cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral cJ ctop wcel cK ctop wcel cX cY cF wf w3a cX vg cv
      cuni wceq vg cv cuni cY cF wf cA cX wcel vg cv cfil wcel cX cY cF wf cJ
      ctop wcel cX vg cv cuni wceq vg cv cuni cY cF wf cK ctop wcel cX vg cv
      cuni wceq cX cY cF wf vg cv cuni cY cF wf cX vg cv cuni cY cF feq2
      biimpac 3ad2antl3 ad2ant2rl adantrl adantr 3jca vk cv cfil wcel cY vk cv
      cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa cF cY vg cv cfilmap
      co cfv vk cv wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf
      cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel
      cX vg cv cuni wceq wa wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh
      cv cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss simprr ad2antll vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa cY vk cv
      cuni wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf
      cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv
      cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni wceq
      cF cY vg cv cfilmap co cfv vk cv wss simprl ad2antll syl3anc cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX
      vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh
      cfil wral vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv
      vk cv wss wa wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF
      cY vj cv cfilmap co cfv wceq w3a cA cF cfv vk cv cK cfclus cfv cfv wcel
      vj cfbas cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv
      cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni wceq
      cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vj cv cfbas wcel vg cv cuni
      vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a
      cA cF cfv vk cv cK cfclus cfv cfv wcel wi wi cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf
      cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv
      cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv
      cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv
      cfilmap co cfv vk cv wss wa wa wa cA cF cfv vk cv cK cfclus cfv cfv wcel
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni
      wceq wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj
      cv cfilmap co cfv wceq w3a vj cv cfbas wcel cX vh cv cuni wceq vg cv vh
      cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil wral vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa cA cF
      cfv vk cv cK cfclus cfv cfv wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa
      cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus
      cfv cfv wcel wi vh cfil wral vk cv cfil wcel cY vk cv cuni wceq cF cY vg
      cv cfilmap co cfv vk cv wss wa wa cA cF cfv vk cv cK cfclus cfv cfv wcel
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni
      wceq wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj
      cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa wa vk cv cfil wcel cY vk
      cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa cX vh cv cuni
      wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil wral
      cA cF cfv vk cv cK cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel
      wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ
      cfclus cfv cfv wcel wi vh cfil wral cA cF cfv vk cv cK cfclus cfv cfv
      wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv
      cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa wa cX vh
      cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh
      cfil wral cA vj cv cfg cfv cJ cfclus cfv cfv wcel cA cF cfv vk cv cK
      cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY
      vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil
      wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv
      wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv
      cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa
      wa wa cX vh cv cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv
      wcel wi vh cfil wral cX vj cv cfg cfv cuni wceq vg cv vj cv cfg cfv wss
      wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf
      cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv
      cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa wa wa cX vj cv cfg cfv cuni wceq vg cv vj cv cfg cfv
      wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni
      wceq wa wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj
      cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv
      cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa wa cX vg cv cuni
      vj cv cuni vj cv cfg cfv cuni cX vf cv cuni wceq cA vf cv cJ cfclus cfv
      cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa cX vg cv cuni
      wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa vg cv cuni
      vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a
      vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv
      cfilmap co cfv vk cv wss wa wa wa cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq simprr ad2antlr
      vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co
      cfv wceq w3a vj cv cfbas wcel wa vg cv cuni vj cv cuni wceq cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vk
      cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa
      wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap
      co cfv wceq vj cv cfbas wcel 3simpl1 ad2antrl vg cv cuni vj cv cuni wceq
      vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas
      wcel wa vj cv cuni vj cv cfg cfv cuni wceq cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf
      cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vk cv cfil wcel cY
      vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa vj cv cfbas
      wcel vj cv cuni vj cv cfg cfv cuni wceq vg cv cuni vj cv cuni wceq vg cv
      vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv vj cv cuni vj
      cv cuni eqid fgbas adantl ad2antrl 3eqtrd cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf
      cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv
      cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa wa wa vg cv vj cv vj cv cfg cfv vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vg cv vj cv wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF
      cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg
      cv cfil wcel cX vg cv cuni wceq wa wa wa vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq vj cv cfbas
      wcel 3simpl2 ad2antrl vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF
      cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vj cv vj cv cfg cfv
      wss cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni
      wceq wa wa wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa vj cv cfbas wcel vj cv vj cv cfg cfv wss vg cv cuni
      vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a
      vj cv fbssfg adantl ad2antrl sstrd jca cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel
      wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa wa wa vj cv cfg cfv cfil wcel cX vh cv cuni wceq vg
      cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil wral cX vj cv
      cfg cfv cuni wceq vg cv vj cv cfg cfv wss wa cA vj cv cfg cfv cJ cfclus
      cfv cfv wcel wi wi vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY
      vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vj cv cfg cfv cfil wcel
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni
      wceq wa wa wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa vj cv cfbas wcel vj cv cfg cfv cfil wcel vg cv cuni
      vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a
      vj cv fgfil adantl ad2antrl cX vh cv cuni wceq vg cv vh cv wss wa cA vh
      cv cJ cfclus cfv cfv wcel wi cX vj cv cfg cfv cuni wceq vg cv vj cv cfg
      cfv wss wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wi vh vj cv cfg cfv
      cfil vh cv vj cv cfg cfv wceq cX vh cv cuni wceq vg cv vh cv wss wa cX vj
      cv cfg cfv cuni wceq vg cv vj cv cfg cfv wss wa cA vh cv cJ cfclus cfv
      cfv wcel cA vj cv cfg cfv cJ cfclus cfv cfv wcel vh cv vj cv cfg cfv wceq
      cX vh cv cuni wceq cX vj cv cfg cfv cuni wceq vg cv vh cv wss vg cv vj cv
      cfg cfv wss vh cv vj cv cfg cfv wceq vh cv cuni vj cv cfg cfv cuni cX vh
      cv vj cv cfg cfv unieq eqeq2d vh cv vj cv cfg cfv vg cv sseq2 anbi12d vh
      cv vj cv cfg cfv wceq vh cv cJ cfclus cfv cfv vj cv cfg cfv cJ cfclus cfv
      cfv cA vh cv vj cv cfg cfv cJ cfclus cfv fveq2 eleq2d imbi12d rcla4v syl
      mpid cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF
      cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY
      vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa cA vj cv
      cfg cfv cJ cfclus cfv cfv wcel cA cF cfv vk cv cK cfclus cfv cfv wcel wi
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv
      cJ cfclus cfv cfv wcel vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv
      cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa cA cF cfv vk cv cK cfclus cfv cfv wcel cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv
      cfv wcel vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv
      cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa cX vf cv cuni wceq cA
      vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK
      cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa
      wa cA cF cfv vk cv cK cfclus cfv cfv wcel wi cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg
      cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv
      wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg
      cv cfilmap co cfv vk cv wss wa wa wa wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa cA cF cfv
      vk cv cK cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv
      cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa wa wa vg cv cfil wcel cX vg cv cuni wceq wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral cA cF cfv vk cv cK
      cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq
      vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas
      wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk
      cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq wa cX vf cv cuni wceq
      cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv
      cK cfclus cfv cfv wcel wi vf cfil wral cA cF cfv vk cv cK cfclus cfv cfv
      wcel wi cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv
      cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv
      wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv
      cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa
      wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX vf cv cuni wceq cA vf
      cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK
      cfclus cfv cfv wcel wi vf cfil wral cA cF cfv cF cY vj cv cfg cfv cfilmap
      co cfv cK cfclus cfv cfv wcel cA cF cfv vk cv cK cfclus cfv cfv wcel cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ
      cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv
      cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv
      cfil wcel cX vg cv cuni wceq wa wa wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral cX vj cv cfg cfv cuni wceq cA vj cv cfg cfv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vj cv cfg cfv cfilmap co cfv cK
      cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq
      vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas
      wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk
      cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX vj cv cfg
      cfv cuni wceq cA vj cv cfg cfv cJ cfclus cfv cfv wcel cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv
      cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv
      cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel cX vg
      cv cuni wceq wa wa wa cX vg cv cuni vj cv cuni vj cv cfg cfv cuni cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ
      cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv
      cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv
      cfil wcel cX vg cv cuni wceq simprrr vg cv cuni vj cv cuni wceq vg cv vj
      cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk
      cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa
      wa wa vg cv cuni vj cv cuni wceq cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cfil
      wcel cX vg cv cuni wceq wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk
      cv cF cY vj cv cfilmap co cfv wceq w3a vg cv cuni vj cv cuni wceq vj cv
      cfbas wcel vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv
      vk cv wss wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj
      cv cfilmap co cfv wceq 3simp1 ad2antrr ad2antrl vg cv cuni vj cv cuni
      wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa wa vj cv cuni vj cv cfg cfv cuni wceq cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv
      cfv wcel wa vg cv cfil wcel cX vg cv cuni wceq wa vj cv cfbas wcel vj cv
      cuni vj cv cfg cfv cuni wceq vg cv cuni vj cv cuni wceq vg cv vj cv wss
      vk cv cF cY vj cv cfilmap co cfv wceq w3a vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa vj cv vj cv cuni vj cv
      cuni eqid fgbas ad2antlr ad2antrl 3eqtrd cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel vg cv
      cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv
      wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg
      cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq
      wa wa simplr jca vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY
      vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk
      cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa cX vf cv cuni
      wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel wi vf cfil wral cX vj cv cfg cfv cuni wceq cA
      vj cv cfg cfv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vj cv cfg cfv
      cfilmap co cfv cK cfclus cfv cfv wcel wi wi cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg
      cv cfil wcel cX vg cv cuni wceq wa vj cv cfbas wcel cX vf cv cuni wceq cA
      vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK
      cfclus cfv cfv wcel wi vf cfil wral cX vj cv cfg cfv cuni wceq cA vj cv
      cfg cfv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vj cv cfg cfv cfilmap
      co cfv cK cfclus cfv cfv wcel wi wi vg cv cuni vj cv cuni wceq vg cv vj
      cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vk cv cfil wcel cY vk cv
      cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa vj cv cfbas wcel vj
      cv cfg cfv cfil wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel
      wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral cX vj cv cfg cfv cuni wceq cA vj cv cfg cfv cJ cfclus cfv cfv wcel
      wa cA cF cfv cF cY vj cv cfg cfv cfilmap co cfv cK cfclus cfv cfv wcel wi
      wi vj cv fgfil cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA
      cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi cX vj cv cfg
      cfv cuni wceq cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY
      vj cv cfg cfv cfilmap co cfv cK cfclus cfv cfv wcel wi vf vj cv cfg cfv
      cfil vf cv vj cv cfg cfv wceq cX vf cv cuni wceq cA vf cv cJ cfclus cfv
      cfv wcel wa cX vj cv cfg cfv cuni wceq cA vj cv cfg cfv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel cA cF
      cfv cF cY vj cv cfg cfv cfilmap co cfv cK cfclus cfv cfv wcel vf cv vj cv
      cfg cfv wceq cX vf cv cuni wceq cX vj cv cfg cfv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel cA vj cv cfg cfv cJ cfclus cfv cfv wcel vf cv vj cv
      cfg cfv wceq vf cv cuni vj cv cfg cfv cuni cX vf cv vj cv cfg cfv unieq
      eqeq2d vf cv vj cv cfg cfv wceq vf cv cJ cfclus cfv cfv vj cv cfg cfv cJ
      cfclus cfv cfv cA vf cv vj cv cfg cfv cJ cfclus cfv fveq2 eleq2d anbi12d
      vf cv vj cv cfg cfv wceq cF cY vf cv cfilmap co cfv cK cfclus cfv cfv cF
      cY vj cv cfg cfv cfilmap co cfv cK cfclus cfv cfv cA cF cfv vf cv vj cv
      cfg cfv wceq cF cY vf cv cfilmap co cfv cF cY vj cv cfg cfv cfilmap co
      cfv cK cfclus cfv vf cv vj cv cfg cfv wceq cF cY vf cv cfilmap co cY vj
      cv cfg cfv cfilmap co vf cv vj cv cfg cfv cY cfilmap opreq2 fveq1d fveq2d
      eleq2d imbi12d rcla4v syl ad2antlr ad2antrl mpid cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv
      wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv
      cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel cX vg
      cv cuni wceq wa wa wa cA cF cfv vk cv cK cfclus cfv cfv wcel cA cF cfv cF
      cY vj cv cfilmap co cfv cK cfclus cfv cfv wcel cA cF cfv cF cY vj cv cfg
      cfv cfilmap co cfv cK cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv
      cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv
      wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg
      cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq
      wa wa wa vk cv cK cfclus cfv cfv cF cY vj cv cfilmap co cfv cK cfclus cfv
      cfv cA cF cfv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA
      vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv
      vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa
      vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss
      wa wa wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa vk cv cF cY vj cv
      cfilmap co cfv cK cfclus cfv vg cv cuni vj cv cuni wceq vg cv vj cv wss
      vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil
      wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vk
      cv cF cY vj cv cfilmap co cfv wceq cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cfil
      wcel cX vg cv cuni wceq wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk
      cv cF cY vj cv cfilmap co cfv wceq w3a vk cv cF cY vj cv cfilmap co cfv
      wceq vj cv cfbas wcel vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv
      cfilmap co cfv vk cv wss wa wa vg cv cuni vj cv cuni wceq vg cv vj cv wss
      vk cv cF cY vj cv cfilmap co cfv wceq 3simp3 ad2antrr ad2antrl fveq2d
      eleq2d cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv
      cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv
      wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv
      cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa
      wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa cF cY vj cv cfilmap co cfv
      cK cfclus cfv cfv cF cY vj cv cfg cfv cfilmap co cfv cK cfclus cfv cfv cA
      cF cfv cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv
      cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv
      wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv
      cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa
      wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa cF cY vj cv cfilmap co cfv
      cF cY vj cv cfg cfv cfilmap co cfv cK cfclus cfv cY cvv wcel vj cv cfbas
      wcel vj cv cuni cY cF wf cF cY vj cv cfilmap co cfv cF cY vj cv cfg cfv
      cfilmap co cfv wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq
      vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas
      wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk
      cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa vj cv cvv cF
      vj cv cfg cfv cY vj cv cuni vj cv cuni eqid vj cv cfg cfv eqid fbfgfmeq
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cY cvv wcel cA vj
      cv cfg cfv cJ cfclus cfv cfv wcel vg cv cuni vj cv cuni wceq vg cv vj cv
      wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv
      cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa
      wa vg cv cfil wcel cX vg cv cuni wceq wa wa cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cY cvv wcel cA cX wcel cK ctop wcel cJ ctop wcel cY cvv wcel
      cX cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg fcluscnp.2
      syl5eqel 3ad2ant2 adantr ad2antrr vg cv cuni vj cv cuni wceq vg cv vj cv
      wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv
      cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa
      wa vj cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cfil wcel cX vg cv
      cuni wceq wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv
      cfilmap co cfv wceq w3a vj cv cfbas wcel vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa simplr ad2antrl cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ
      cfclus cfv cfv wcel wa vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv
      cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel
      cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv
      cfil wcel cX vg cv cuni wceq wa wa wa cX cY cF wf vj cv cuni cY cF wf cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX cY cF wf cA vj cv
      cfg cfv cJ cfclus cfv cfv wcel vg cv cuni vj cv cuni wceq vg cv vj cv wss
      vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil
      wcel cY vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg
      cv cfil wcel cX vg cv cuni wceq wa wa cJ ctop wcel cK ctop wcel cX cY cF
      wf cA cX wcel 3simpl3 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv cuni vj cv
      cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq w3a vj cv
      cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg cv cfilmap co
      cfv vk cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq wa wa wa cX vj
      cv cuni wceq cX cY cF wf vj cv cuni cY cF wf wb cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa
      vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co
      cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY
      vg cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel cX vg cv cuni
      wceq wa wa wa cX vg cv cuni vj cv cuni cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cA vj cv cfg cfv cJ cfclus cfv cfv wcel wa vg cv
      cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv
      wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni wceq cF cY vg
      cv cfilmap co cfv vk cv wss wa wa wa vg cv cfil wcel cX vg cv cuni wceq
      simprrr vg cv cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv
      cfilmap co cfv wceq w3a vj cv cfbas wcel wa vk cv cfil wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa wa vg cv cuni vj cv cuni
      wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cA vj cv cfg
      cfv cJ cfclus cfv cfv wcel wa vg cv cfil wcel cX vg cv cuni wceq wa vg cv
      cuni vj cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv
      wceq w3a vg cv cuni vj cv cuni wceq vj cv cfbas wcel vk cv cfil wcel cY
      vk cv cuni wceq cF cY vg cv cfilmap co cfv vk cv wss wa wa vg cv cuni vj
      cv cuni wceq vg cv vj cv wss vk cv cF cY vj cv cfilmap co cfv wceq 3simp1
      ad2antrr ad2antrl eqtrd cX vj cv cuni cY cF feq2 syl mpbid syl3anc fveq2d
      eleq2d bitr2d sylibd expr com23 imp3a exp31 com24 imp31 syld expr com23
      imp3a exp32 com24 imp r19.23adv mpd exp45 r19.21adv cJ ctop wcel vg cv
      cfil wcel cX vg cv cuni wceq cA vg cv cJ cflim1 cfv cfv wcel cX vh cv
      cuni wceq vg cv vh cv wss wa cA vh cv cJ cfclus cfv cfv wcel wi vh cfil
      wral wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv
      cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX
      vg cv cuni wceq wa wa wa cA vh vg cv cJ cX vg cv cuni fcluscnp.1 vg cv
      cuni eqid flimfnfcls cJ ctop wcel cK ctop wcel cX cY cF wf w3a cJ ctop
      wcel cA cX wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA
      cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral
      vg cv cfil wcel cX vg cv cuni wceq wa wa cJ ctop wcel cK ctop wcel cX cY
      cF wf 3simp1 ad2antrr cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv
      cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv
      cfil wcel cX vg cv cuni wceq simprrl cJ ctop wcel cK ctop wcel cX cY cF
      wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel
      wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral vg cv cfil wcel cX vg cv cuni wceq simprrr syl3anc cK ctop wcel cF
      cY vg cv cfilmap co cfv cfil wcel cY cF cY vg cv cfilmap co cfv cuni wceq
      cA cF cfv cF cY vg cv cfilmap co cfv cK cflim1 cfv cfv wcel cY vk cv cuni
      wceq cF cY vg cv cfilmap co cfv vk cv wss wa cA cF cfv vk cv cK cfclus
      cfv cfv wcel wi vk cfil wral wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a
      cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF
      cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg
      cv cfil wcel cX vg cv cuni wceq wa wa wa cA cF cfv vk cF cY vg cv cfilmap
      co cfv cK cY cF cY vg cv cfilmap co cfv cuni fcluscnp.2 cF cY vg cv
      cfilmap co cfv cuni eqid flimfnfcls cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cK ctop wcel cA cX wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf
      cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa cJ ctop wcel cK ctop
      wcel cX cY cF wf 3simp2 ad2antrr cY cvv wcel vg cv cfbas wcel vg cv cuni
      cY cF wf cF cY vg cv cfilmap co cfv cfil wcel cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv
      cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cvv vg cv cF
      cY vg cv cuni vg cv cuni eqid fmf cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cY cvv wcel cA cX wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf
      cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa cK ctop wcel cJ ctop
      wcel cY cvv wcel cX cY cF wf cK ctop wcel cK cuni cvv cY cK ctop uniexg
      fcluscnp.2 syl5eqel 3ad2ant2 ad2antrr vg cv cfil wcel cX vg cv cuni wceq
      wa vg cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY
      vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil
      wcel vg cv cfbas wcel cX vg cv cuni wceq vg cv filfbas adantr ad2antll cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq
      cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv
      cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq
      wa wa wa cX cY cF wf vg cv cuni cY cF wf cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cX cY cF wf cA cX wcel cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa cJ ctop
      wcel cK ctop wcel cX cY cF wf 3simp3 ad2antrr vg cv cfil wcel cX vg cv
      cuni wceq wa cX cY cF wf vg cv cuni cY cF wf wb cJ ctop wcel cK ctop wcel
      cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv
      cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      wi vf cfil wral cX vg cv cuni wceq cX cY cF wf vg cv cuni cY cF wf wb vg
      cv cfil wcel cX vg cv cuni cY cF feq2 adantl ad2antll mpbid syl3anc cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq
      cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv
      cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq
      wa wa wa cF cY vg cv cfilmap co cfv cuni cY cY cvv wcel vg cv cfbas wcel
      vg cv cuni cY cF wf cF cY vg cv cfilmap co cfv cuni cY wceq cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa wa cvv
      vg cv cF cY vg cv cuni vg cv cuni eqid fmbas cJ ctop wcel cK ctop wcel cX
      cY cF wf w3a cY cvv wcel cA cX wcel cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa wa cK ctop
      wcel cJ ctop wcel cY cvv wcel cX cY cF wf cK ctop wcel cK cuni cvv cY cK
      ctop uniexg fcluscnp.2 syl5eqel 3ad2ant2 ad2antrr vg cv cfil wcel cX vg
      cv cuni wceq wa vg cv cfbas wcel cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa
      cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil
      wral vg cv cfil wcel vg cv cfbas wcel cX vg cv cuni wceq vg cv filfbas
      adantr ad2antll cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa
      cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf
      cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel
      cX vg cv cuni wceq wa wa wa cX cY cF wf vg cv cuni cY cF wf cJ ctop wcel
      cK ctop wcel cX cY cF wf w3a cX cY cF wf cA cX wcel cX vf cv cuni wceq cA
      vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK
      cfclus cfv cfv wcel wi vf cfil wral vg cv cfil wcel cX vg cv cuni wceq wa
      wa cJ ctop wcel cK ctop wcel cX cY cF wf 3simp3 ad2antrr vg cv cfil wcel
      cX vg cv cuni wceq wa cX cY cF wf vg cv cuni cY cF wf wb cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cA cX wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vf cfil wral cX vg cv cuni wceq cX cY cF wf vg cv cuni cY cF
      wf wb vg cv cfil wcel cX vg cv cuni cY cF feq2 adantl ad2antll mpbid
      syl3anc eqcomd syl3anc 3imtr4d exp45 imp5a r19.21adv impbid 3bitr2d $.
      $( [20-Nov-2009] $) $( [14-Nov-2009] $)
  $}

  ${
    $d f x F $. $d f x J $. $d f x K $. $d f x X $. $d f x Y $.
    fcluscn.1 $e |- X = U. J $.
    fcluscn.2 $e |- Y = U. K $.
    $( A function is continuous iff it respects clustering of filters. $)
    fcluscn $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) -> ( F e. ( J Cn K
    ) <-> A. f e. Fil ( X = U. f -> A. x e. X ( x e. ( ( fClus ` J ) ` f ) -> (
    F ` x ) e. ( ( fClus ` K ) ` ( ( Y FilMap f ) ` F ) ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cF vx cv
      cJ cK ccnp co cfv wcel vx cX wral cX vf cv cuni wceq vx cv vf cv cJ
      cfclus cfv cfv wcel vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv
      cfv wcel wi vx cX wral wi vf cfil wral vx cF cJ cK cX cY fcluscn.1
      fcluscn.2 cncnp cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF vx cv cJ cK
      ccnp co cfv wcel vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv
      cfv wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus
      cfv cfv wcel vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vx cX wral wi vf cfil wral cJ ctop wcel cK ctop wcel cX cY cF wf
      w3a cF vx cv cJ cK ccnp co cfv wcel cX vf cv cuni wceq vx cv vf cv cJ
      cfclus cfv cfv wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus
      cfv cfv wcel wi vf cfil wral vx cX vx cv vf cF cJ cK cX cY fcluscn.1
      fcluscn.2 fcluscnp ralbidva cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv
      cfv wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vf cfil wral vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus
      cfv cfv wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vx cX wral vf cfil wral cX vf cv cuni wceq vx cv vf cv cJ cfclus
      cfv cfv wcel vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi vx cX wral wi vf cfil wral cX vf cv cuni wceq vx cv vf cv cJ
      cfclus cfv cfv wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus
      cfv cfv wcel wi vx vf cX cfil ralcom cX vf cv cuni wceq vx cv vf cv cJ
      cfclus cfv cfv wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus
      cfv cfv wcel wi vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv
      cfv wcel vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      wi vx cX wral wi vf cfil cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv
      wcel wa vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi
      vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv cF
      cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi wi vx cX wral cX
      vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv cF cfv cF cY vf
      cv cfilmap co cfv cK cfclus cfv cfv wcel wi vx cX wral wi cX vf cv cuni
      wceq vx cv vf cv cJ cfclus cfv cfv wcel wa vx cv cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wi cX vf cv cuni wceq vx cv vf cv
      cJ cfclus cfv cfv wcel vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus
      cfv cfv wcel wi wi vx cX cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv
      wcel vx cv cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      impexp ralbii cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv
      cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vx cX r19.21v
      bitri ralbii bitri syl6bb bitrd $.
      $( [20-Nov-2009] $) $( [20-Nov-2009] $)
  $}

  ${
    $d c f g j k n s w x y z J $. $d c f g j k n s w x y z X $.
    fcluscomp.1 $e |- X = U. J $.
    $( Lemma for ~ fcluscomp . $)
    fcluscomplem $p |- ( ( J e. Top /\ f e. Fil /\ X = U. f ) -> A. x e. ( fi `
    { y | E. s e. f y = ( ( cls ` J ) ` s ) } ) E. z e. f z C_ x ) $=
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vz cv vx cv wss vz vf
      cv wrex vx vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wcel vw cv vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab wss vw cv cfn wcel vx cv vw cv cint
      wceq w3a vw wex vz cv vx cv wss vz vf cv wrex vf cv cfil wcel cJ ctop
      wcel vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv
      wcel vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss vw cv
      cfn wcel vx cv vw cv cint wceq w3a vw wex wb cX vf cv cuni wceq vf cv
      cfil wcel vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cvv wcel
      vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wcel
      vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss vw cv cfn
      wcel vx cv vw cv cint wceq w3a vw wex wb vs vy vf cv vs cv cJ ccl cfv cfv
      cfil abrexexg vx cv cvv wcel vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab cvv wcel vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab cfi cfv wcel vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab wss vw cv cfn wcel vx cv vw cv cint wceq w3a vw wex wb vx visset
      vw vx cv cvv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cvv
      sppfi mpan syl 3ad2ant2 cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq
      w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss vw cv
      cfn wcel vx cv vw cv cint wceq w3a vz cv vx cv wss vz vf cv wrex vw cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wss vw cv cfn wcel vx cv vw cv cint
      wceq vz cv vx cv wss vz vf cv wrex cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab
      wss vw cv cfn wcel vx cv vw cv cint wceq vz cv vx cv wss vz vf cv wrex wi
      vx cv vw cv cint wceq vz cv vx cv wss vz vf cv wrex vz cv vw cv cint wss
      vz vf cv wrex cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv
      vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss vw cv cfn wcel
      wa wa vx cv vw cv cint wceq vz cv vx cv wss vz cv vw cv cint wss vz vf cv
      vx cv vw cv cint vz cv sseq2 rexbidv cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab wss vw cv cfn wcel vz cv vw cv cint wss vz vf cv wrex cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq
      vs vf cv wrex vy cab wss wa vw cv vn cv cen wbr vn com wrex vz cv vw cv
      cint wss vz vf cv wrex vw cv cfn wcel cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab wss wa vw cv vn cv cen wbr vz cv vw cv cint wss vz vf cv wrex vn com
      vn cv com wcel cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv
      vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv vn cv
      cen wbr vz cv vw cv cint wss vz vf cv wrex wi vn cv com wcel cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv
      wceq vs vf cv wrex vy cab wss wa vw cv vn cv cen wbr vz cv vw cv cint wss
      vz vf cv wrex wi wi vw cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq
      w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw
      cv vk cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw wal cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab wss wa vw cv c0 cen wbr vz cv vw cv cint
      wss vz vf cv wrex wi wi vw wal cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss
      wa vw cv vj cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw wal cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv vj cv csuc cen wbr vz cv
      vw cv cint wss vz vf cv wrex wi wi vw wal cJ ctop wcel vf cv cfil wcel cX
      vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab wss wa vw cv vn cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi
      wi vw wal vk vj vn cv vk cv c0 wceq cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab
      wss wa vw cv vk cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv c0 cen wbr vz cv vw cv
      cint wss vz vf cv wrex wi wi vw vk cv c0 wceq vw cv vk cv cen wbr vz cv
      vw cv cint wss vz vf cv wrex wi vw cv c0 cen wbr vz cv vw cv cint wss vz
      vf cv wrex wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv
      vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vk cv c0 wceq
      vw cv vk cv cen wbr vw cv c0 cen wbr vz cv vw cv cint wss vz vf cv wrex
      vk cv c0 vw cv cen breq2 imbi1d imbi2d albidv vk cv vj cv wceq cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab wss wa vw cv vk cv cen wbr vz cv vw cv cint
      wss vz vf cv wrex wi wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq
      w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw
      cv vj cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw vk cv vj cv
      wceq vw cv vk cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi vw cv vj
      cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa vk cv vj cv wceq vw cv vk cv cen wbr vw cv vj cv
      cen wbr vz cv vw cv cint wss vz vf cv wrex vk cv vj cv vw cv cen breq2
      imbi1d imbi2d albidv vk cv vj cv csuc wceq cJ ctop wcel vf cv cfil wcel
      cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab wss wa vw cv vk cv cen wbr vz cv vw cv cint wss vz vf cv wrex
      wi wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv vj cv csuc cen
      wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw vk cv vj cv csuc wceq vw
      cv vk cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi vw cv vj cv csuc
      cen wbr vz cv vw cv cint wss vz vf cv wrex wi cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa vk cv vj cv csuc wceq vw cv vk cv cen wbr vw cv vj
      cv csuc cen wbr vz cv vw cv cint wss vz vf cv wrex vk cv vj cv csuc vw cv
      cen breq2 imbi1d imbi2d albidv vk cv vn cv wceq cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa vw cv vk cv cen wbr vz cv vw cv cint wss vz vf cv
      wrex wi wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy
      cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv vn cv cen
      wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw vk cv vn cv wceq vw cv vk
      cv cen wbr vz cv vw cv cint wss vz vf cv wrex wi vw cv vn cv cen wbr vz
      cv vw cv cint wss vz vf cv wrex wi cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab
      wss wa vk cv vn cv wceq vw cv vk cv cen wbr vw cv vn cv cen wbr vz cv vw
      cv cint wss vz vf cv wrex vk cv vn cv vw cv cen breq2 imbi1d imbi2d
      albidv cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv c0 cen wbr vz cv
      vw cv cint wss vz vf cv wrex wi wi vw cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab wss wa vw cv c0 wceq vz cv vw cv cint wss vz vf cv wrex vw cv c0 cen
      wbr cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv c0 wceq vz
      cv vw cv cint wss vz vf cv wrex wi vw cv vy cv vs cv cJ ccl cfv cfv wceq
      vs vf cv wrex vy cab wss vf cv cfil wcel cJ ctop wcel vw cv c0 wceq vz cv
      vw cv cint wss vz vf cv wrex wi cX vf cv cuni wceq vw cv c0 wceq vz cv vw
      cv cint wss vz vf cv wrex vz cv c0 cint wss vz vf cv wrex vf cv cfil wcel
      vw cv c0 wceq vz cv vw cv cint wss vz cv c0 cint wss vz vf cv vw cv c0
      wceq vw cv cint c0 cint vz cv vw cv c0 inteq sseq2d rexbidv vf cv cfil
      wcel vf cv cuni vf cv wcel vz cv c0 cint wss vz vf cv wrex vf cv vf cv
      cuni vf cv cuni eqid filusb vf cv cuni vf cv wcel vf cv cuni c0 cint wss
      vz cv c0 cint wss vz vf cv wrex vf cv cuni cvv c0 cint vf cv cuni ssv
      int0 sseqtr4i vz cv c0 cint wss vf cv cuni c0 cint wss vz vf cv cuni vf
      cv vz cv vf cv cuni c0 cint sseq1 rcla4ev mpan2 syl syl5cbir 3ad2ant2
      adantr vw cv en0 syl5ib ax-gen vj cv com wcel cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf cv
      wrex wi wi vx wal cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw
      cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv vj
      cv csuc cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw wal cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab wss wa vw cv vj cv cen wbr vz cv vw cv cint
      wss vz vf cv wrex wi wi vw wal vj cv com wcel cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf cv
      wrex wi wi vx wal cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw
      cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vw cv vj
      cv csuc cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi vw cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv
      wceq vs vf cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss
      vz vf cv wrex wi wi vx wal cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss
      wa vw cv vj cv csuc cen wbr vz cv vw cv cint wss vz vf cv wrex wi wi wi
      vj cv com wcel vw cv vj cv csuc cen wbr cJ ctop wcel vf cv cfil wcel cX
      vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab wss wa cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv
      vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vx cv vj cv
      cen wbr vz cv vx cv cint wss vz vf cv wrex wi wi vx wal vz cv vw cv cint
      wss vz vf cv wrex vw cv vj cv csuc cen wbr vw cv vj cv csuc vg cv wf1o vg
      wex cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv
      cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf cv
      wrex wi wi vx wal vz cv vw cv cint wss vz vf cv wrex wi wi vw cv vj cv
      csuc vg vj cv vj visset sucex bren vw cv vj cv csuc vg cv wf1o cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab wss wa cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf cv wrex wi wi
      vx wal vz cv vw cv cint wss vz vf cv wrex wi wi vg vw cv vj cv csuc vg cv
      wf1o vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab wss wa cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vy
      cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vx cv vj cv cen
      wbr vz cv vx cv cint wss vz vf cv wrex wi wi vx wal vz cv vw cv cint wss
      vz vf cv wrex wi wi vw cv vj cv csuc vg cv f1ocnv vj cv csuc vw cv vg cv
      ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv
      vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf
      cv wrex wi wi vx wal vz cv vw cv cint wss vz vf cv wrex wi vj cv csuc vw
      cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw
      cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa wa cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint
      wss vz vf cv wrex wi wi vx wal vz cv vg cv ccnv vj cv cima cint wss vz vf
      cv wrex vz cv vw cv cint wss vz vf cv wrex vj cv csuc vw cv vg cv ccnv
      wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa wa cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf
      cv wrex wi wi vx wal vg cv ccnv vj cv cima vj cv cen wbr vz cv vg cv ccnv
      vj cv cima cint wss vz vf cv wrex vj cv csuc vw cv vg cv ccnv wf1o cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wss wa wa vj cv vg cv ccnv vj cv cima
      vg cv ccnv vj cv cres wf1o vj cv vg cv ccnv vj cv cima cen wbr vg cv ccnv
      vj cv cima vj cv cen wbr vj cv csuc vw cv vg cv ccnv wf1o vj cv vg cv
      ccnv vj cv cima vg cv ccnv vj cv cres wf1o cJ ctop wcel vf cv cfil wcel
      cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab wss wa vj cv csuc vw cv vg cv ccnv wf1o vj cv csuc vw cv vg
      cv ccnv wf1 vj cv vg cv ccnv vj cv cima vg cv ccnv vj cv cres wf1o vj cv
      csuc vw cv vg cv ccnv f1of1 vj cv csuc vw cv vg cv ccnv wf1 vj cv vj cv
      csuc wss vj cv vg cv ccnv vj cv cima vg cv ccnv vj cv cres wf1o vj cv
      sssucid vj cv csuc vw cv vj cv vg cv ccnv f1ores mpan2 syl adantr vj cv
      vg cv ccnv vj cv cima vg cv ccnv vj cv cres vj visset f1oen vj cv vg cv
      ccnv vj cv cima vg cv ccnv cvv wcel vg cv ccnv vj cv cima cvv wcel vg cv
      vg visset cnvex vg cv ccnv vj cv cvv imaexg ax-mp ensym 3syl cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv
      wceq vs vf cv wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss
      vz vf cv wrex wi wi vx wal cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a vg cv ccnv vj cv cima vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab wss wa vg cv ccnv vj cv cima vj cv cen wbr vz cv vg cv ccnv
      vj cv cima cint wss vz vf cv wrex wi vj cv csuc vw cv vg cv ccnv wf1o cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wss wa wa cJ ctop wcel vf cv cfil wcel
      cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab wss wa vx cv vj cv cen wbr vz cv vx cv cint wss vz vf cv wrex
      wi wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vg cv ccnv vj
      cv cima vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vg cv
      ccnv vj cv cima vj cv cen wbr vz cv vg cv ccnv vj cv cima cint wss vz vf
      cv wrex wi wi vx vg cv ccnv vj cv cima vg cv ccnv cvv wcel vg cv ccnv vj
      cv cima cvv wcel vg cv vg visset cnvex vg cv ccnv vj cv cvv imaexg ax-mp
      vx cv vg cv ccnv vj cv cima wceq cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab
      wss wa cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vg cv ccnv vj
      cv cima vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vx cv
      vj cv cen wbr vz cv vx cv cint wss vz vf cv wrex wi vg cv ccnv vj cv cima
      vj cv cen wbr vz cv vg cv ccnv vj cv cima cint wss vz vf cv wrex wi vx cv
      vg cv ccnv vj cv cima wceq vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab wss vg cv ccnv vj cv cima vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab wss cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a
      vx cv vg cv ccnv vj cv cima vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab sseq1 anbi2d vx cv vg cv ccnv vj cv cima wceq vx cv vj cv cen wbr
      vg cv ccnv vj cv cima vj cv cen wbr vz cv vx cv cint wss vz vf cv wrex vz
      cv vg cv ccnv vj cv cima cint wss vz vf cv wrex vx cv vg cv ccnv vj cv
      cima vj cv cen breq1 vx cv vg cv ccnv vj cv cima wceq vz cv vx cv cint
      wss vz cv vg cv ccnv vj cv cima cint wss vz vf cv vx cv vg cv ccnv vj cv
      cima wceq vx cv cint vg cv ccnv vj cv cima cint vz cv vx cv vg cv ccnv vj
      cv cima inteq sseq2d rexbidv imbi12d imbi12d cla4v vj cv csuc vw cv vg cv
      ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv
      vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa wa cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq w3a vg cv ccnv vj cv cima vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab wss vj cv csuc vw cv vg cv ccnv
      wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss simprl vj cv csuc vw cv
      vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv
      vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa wa vg cv ccnv
      vj cv cima vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab vj
      cv csuc vw cv vg cv ccnv wf1o vg cv ccnv vj cv cima vw cv wss cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab wss wa vj cv csuc vw cv vg cv ccnv wf1o vj
      cv csuc vw cv vg cv ccnv wfo vg cv ccnv crn vw cv wceq vg cv ccnv vj cv
      cima vw cv wss vj cv csuc vw cv vg cv ccnv f1ofo vj cv csuc vw cv vg cv
      ccnv forn vg cv ccnv crn vw cv wceq vg cv ccnv vj cv cima vg cv ccnv crn
      wss vg cv ccnv vj cv cima vw cv wss vg cv ccnv vj cv imassrn vg cv ccnv
      crn vw cv vg cv ccnv vj cv cima sseq2 mpbii 3syl adantr vj cv csuc vw cv
      vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv
      vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss simprr sstrd jca
      syl5com mpid vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf
      cv wrex vy cab wss wa wa vx cv vg cv ccnv vj cv cima cint wss vx vf cv
      wrex vz cv vw cv cint wss vz vf cv wrex vz cv vg cv ccnv vj cv cima cint
      wss vz vf cv wrex vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab wss wa wa vx cv vg cv ccnv vj cv cima cint wss vz cv vw
      cv cint wss vz vf cv wrex vx vf cv vj cv csuc vw cv vg cv ccnv wf1o cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wss vx cv vf cv wcel vx cv vg cv ccnv
      vj cv cima cint wss vz cv vw cv cint wss vz vf cv wrex wi wi vj cv csuc
      vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a
      wa vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss vj cv
      vg cv ccnv cfv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wcel
      vx cv vf cv wcel vx cv vg cv ccnv vj cv cima cint wss vz cv vw cv cint
      wss vz vf cv wrex wi wi vj cv csuc vw cv vg cv ccnv wf1o vw cv vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss vj cv vg cv ccnv cfv vy
      cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wcel wi cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv wceq
      vs vf cv wrex vy cab wss vj cv vg cv ccnv cfv vw cv wcel vj cv vg cv ccnv
      cfv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wcel vj cv csuc
      vw cv vg cv ccnv wf1o vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab vj cv vg cv ccnv cfv ssel vj cv csuc vw cv vg cv ccnv wf1o vj cv
      csuc vw cv vg cv ccnv wf vj cv vg cv ccnv cfv vw cv wcel vj cv csuc vw cv
      vg cv ccnv f1of vj cv csuc vw cv vg cv ccnv wf vj cv vj cv csuc wcel vj
      cv vg cv ccnv cfv vw cv wcel vj cv vj visset sucid vj cv csuc vw cv vj cv
      vg cv ccnv ffvelrn mpan2 syl syl5com adantr vj cv csuc vw cv vg cv ccnv
      wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vj cv vg cv
      ccnv cfv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vx cv vf cv wcel vx cv
      vg cv ccnv vj cv cima cint wss vz cv vw cv cint wss vz vf cv wrex wi wi
      vj cv vg cv ccnv cfv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab
      wcel vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv
      vf cv wcel vx cv vg cv ccnv vj cv cima cint wss vz cv vw cv cint wss vz
      vf cv wrex wi wi vs vf cv vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel vj cv vg cv
      ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel vx cv vg cv ccnv vj
      cv cima cint wss vz cv vw cv cint wss vz vf cv wrex vx cv vs cv cin vf cv
      wcel vx cv vs cv cin vw cv cint wss vz cv vw cv cint wss vz vf cv wrex vj
      cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv
      wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss wa wa vz cv
      vw cv cint wss vx cv vs cv cin vw cv cint wss vz vx cv vs cv cin vf cv vz
      cv vx cv vs cv cin vw cv cint sseq1 rcla4ev vj cv csuc vw cv vg cv ccnv
      wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv
      wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel
      wa vx cv vs cv cin vf cv wcel vx cv vg cv ccnv vj cv cima cint wss cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vs cv vf cv wcel vj cv
      vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vs cv
      cin vf cv wcel vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a vs cv vf cv wcel wa vx cv vf cv wcel vx cv vs
      cv cin vf cv wcel vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a vs cv vf cv wcel vx cv vf cv
      wcel vx cv vs cv cin vf cv wcel vf cv cfil wcel cJ ctop wcel vs cv vf cv
      wcel vx cv vf cv wcel wa vx cv vs cv cin vf cv wcel cX vf cv cuni wceq vf
      cv cfil wcel vs cv vf cv wcel vx cv vf cv wcel vx cv vs cv cin vf cv wcel
      vf cv cfil wcel vx cv vf cv wcel vs cv vf cv wcel vx cv vs cv cin vf cv
      wcel vx cv vs cv vf cv filint 3com23 3expb 3ad2antl2 anassrs adantrl
      adantlll adantrr vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv
      vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima
      cint wss wa wa vx cv vs cv cin vg cv ccnv vj cv cima cint vj cv vg cv
      ccnv cfv cin vw cv cint vx cv vg cv ccnv vj cv cima cint wss vs cv vj cv
      vg cv ccnv cfv wss vx cv vs cv cin vg cv ccnv vj cv cima cint vj cv vg cv
      ccnv cfv cin wss vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv
      vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima
      cint wss wa wa vx cv vg cv ccnv vj cv cima cint vs cv vj cv vg cv ccnv
      cfv ss2in vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel
      cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv vs cv
      cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint
      wss simprr vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel
      cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv vs cv
      cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint
      wss wa wa vs cv vs cv cJ ccl cfv cfv vj cv vg cv ccnv cfv cJ ctop wcel vs
      cv cX wss vs cv vs cv cJ ccl cfv cfv wss vj cv csuc vw cv vg cv ccnv wf1o
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel
      wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx
      cv vg cv ccnv vj cv cima cint wss wa wa vs cv cJ cX fcluscomp.1 sscls vj
      cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a wa cJ ctop wcel vs cv vf cv wcel vj cv vg cv ccnv cfv vs cv cJ
      ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss
      wa vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq 3simpr1 ad2antrr vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vs cv cX
      wss vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx
      cv vg cv ccnv vj cv cima cint wss wa cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vs cv vf cv wcel vs cv cX wss vj cv csuc vw cv vg cv
      ccnv wf1o cX vf cv cuni wceq cJ ctop wcel vs cv vf cv wcel vs cv cX wss
      vf cv cfil wcel cX vf cv cuni wceq vs cv vf cv wcel wa vs cv vf cv cuni
      cX vs cv vf cv wcel vs cv vf cv cuni wss cX vf cv cuni wceq vs cv vf cv
      elssuni adantl cX vf cv cuni wceq vs cv vf cv wcel pm3.26 sseqtr4d
      3ad2antl3 adantll adantr sylanc vj cv csuc vw cv vg cv ccnv wf1o cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv
      vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel vx cv vg cv
      ccnv vj cv cima cint wss simprll sseqtr4d sylanc vj cv csuc vw cv vg cv
      ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf
      cv wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv
      wcel wa vx cv vg cv ccnv vj cv cima cint wss wa wa vg cv ccnv vj cv cima
      cint vj cv vg cv ccnv cfv cin vg cv ccnv vj cv cima vg cv ccnv vj cv csn
      cima cun cint vw cv cint vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf
      cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv
      ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv
      vj cv cima cint wss wa wa vg cv ccnv vj cv cima cint vj cv vg cv ccnv cfv
      cin vg cv ccnv vj cv cima cint vg cv ccnv vj cv csn cima cint cin vg cv
      ccnv vj cv cima vg cv ccnv vj cv csn cima cun cint vj cv csuc vw cv vg cv
      ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf
      cv wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv
      wcel wa vx cv vg cv ccnv vj cv cima cint wss wa wa vj cv vg cv ccnv cfv
      vg cv ccnv vj cv csn cima cint vg cv ccnv vj cv cima cint vj cv csuc vw
      cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa
      vs cv vf cv wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv
      vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss wa wa vj cv vg cv ccnv
      cfv csn cint vg cv ccnv vj cv csn cima cint vj cv vg cv ccnv cfv vj cv
      csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv
      wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss wa wa vj cv
      vg cv ccnv cfv csn vg cv ccnv vj cv csn cima vg cv ccnv vj cv csuc wfn vj
      cv vj cv csuc wcel vj cv vg cv ccnv cfv csn vg cv ccnv vj cv csn cima
      wceq vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv vs cv cJ ccl
      cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss wa
      wa vj cv csuc vj cv vg cv ccnv fnsnfv vj cv csuc vw cv vg cv ccnv wf1o cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vg cv ccnv vj cv csuc
      wfn vs cv vf cv wcel vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv
      vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss wa vj cv csuc vw cv vg
      cv ccnv wf1o vg cv ccnv vj cv csuc wfn cJ ctop wcel vf cv cfil wcel cX vf
      cv cuni wceq w3a vj cv csuc vw cv vg cv ccnv f1ofn adantr ad2antrr vj cv
      vj cv csuc wcel vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv cfv
      vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima
      cint wss wa wa vj cv vj visset sucid a1i sylanc inteqd vj cv vg cv ccnv
      cfv vj cv vg cv ccnv fvex intsn syl5eqr ineq2d vg cv ccnv vj cv cima vg
      cv ccnv vj cv csn cima intun syl6eqr vj cv csuc vw cv vg cv ccnv wf1o cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa
      vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv
      vg cv ccnv vj cv cima cint wss wa wa vg cv ccnv vj cv cima vg cv ccnv vj
      cv csn cima cun vw cv vj cv csuc vw cv vg cv ccnv wf1o cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a wa vs cv vf cv wcel wa vj cv vg cv ccnv
      cfv vs cv cJ ccl cfv cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv
      cima cint wss wa wa vg cv ccnv vj cv csuc cima vw cv vg cv ccnv vj cv
      cima vg cv ccnv vj cv csn cima cun vj cv csuc vw cv vg cv ccnv wf1o cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a wa vg cv ccnv vj cv csuc
      cima vw cv wceq vs cv vf cv wcel vj cv vg cv ccnv cfv vs cv cJ ccl cfv
      cfv wceq vx cv vf cv wcel wa vx cv vg cv ccnv vj cv cima cint wss wa vj
      cv csuc vw cv vg cv ccnv wf1o vg cv ccnv vj cv csuc cima vw cv wceq cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vj cv csuc vw cv vg cv
      ccnv wf1o vj cv csuc vw cv vg cv ccnv wfo vg cv ccnv vj cv csuc cima vw
      cv wceq vj cv csuc vw cv vg cv ccnv f1ofo vj cv csuc vw cv vg cv ccnv
      foima syl adantr ad2antrr vg cv ccnv vj cv csuc cima vg cv ccnv vj cv vj
      cv csn cun cima vg cv ccnv vj cv cima vg cv ccnv vj cv csn cima cun vj cv
      csuc vj cv vj cv csn cun vg cv ccnv vj cv df-suc imaeq2i vg cv ccnv vj cv
      vj cv csn imaundi eqtr2i syl5eq inteqd eqtrd sseqtrd sylanc exp58
      r19.23adv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vj cv vg cv ccnv
      cfv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy vj cv vg cv ccnv cfv vj cv
      vg cv ccnv fvex vy cv vj cv vg cv ccnv cfv wceq vy cv vs cv cJ ccl cfv
      cfv wceq vj cv vg cv ccnv cfv vs cv cJ ccl cfv cfv wceq vs vf cv vy cv vj
      cv vg cv ccnv cfv vs cv cJ ccl cfv cfv eqeq1 rexbidv elab syl5ib syld
      impr r19.23adv vz cv vg cv ccnv vj cv cima cint wss vx cv vg cv ccnv vj
      cv cima cint wss vz vx vf cv vz cv vx cv vg cv ccnv vj cv cima cint sseq1
      cbvrexv syl5ib syld ex syl 19.23aiv sylbi com13 a1i 19.21adv cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs cv cJ ccl cfv cfv
      wceq vs vf cv wrex vy cab wss wa vw cv vj cv cen wbr vz cv vw cv cint wss
      vz vf cv wrex wi wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a
      vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa vx cv
      vj cv cen wbr vz cv vx cv cint wss vz vf cv wrex wi wi vw vx vw cv vx cv
      wceq cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss wa cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq w3a vx cv vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab wss wa vw cv vj cv cen wbr vz cv vw cv cint wss vz vf
      cv wrex wi vx cv vj cv cen wbr vz cv vx cv cint wss vz vf cv wrex wi vw
      cv vx cv wceq vw cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab
      wss vx cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wss cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vw cv vx cv vy cv vs cv
      cJ ccl cfv cfv wceq vs vf cv wrex vy cab sseq1 anbi2d vw cv vx cv wceq vw
      cv vj cv cen wbr vx cv vj cv cen wbr vz cv vw cv cint wss vz vf cv wrex
      vz cv vx cv cint wss vz vf cv wrex vw cv vx cv vj cv cen breq1 vw cv vx
      cv wceq vz cv vw cv cint wss vz cv vx cv cint wss vz vf cv vw cv vx cv
      wceq vw cv cint vx cv cint vz cv vw cv vx cv inteq sseq2d rexbidv imbi12d
      imbi12d cbvalv syl5ib finds 19.21bi com12 r19.23adv vn vw cv isfi syl5ib
      impr syl5cbir exp32 3impd 19.23adv sylbid r19.21aiv $.
      $( [20-Nov-2009] $) $( [20-Nov-2009] $)

    $( A space is compact iff every filter clusters. $)
    fcluscomp $p |- ( J e. Top -> ( J e. Comp <-> A. f e. Fil ( X = U. f -> ( (
    fClus ` J ) ` f ) =/= (/) ) ) ) $=
      cJ ctop wcel c0 vc cv cfi cfv wnel vc cv cint c0 wne wi vc cJ ccld cfv
      cpw wral cX vf cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi
      vf cfil wral cJ ccomp wcel cX vf cv cuni wceq vf cv cJ cfclus cfv cfv c0
      wne wi vf cfil wral cJ ctop wcel c0 vc cv cfi cfv wnel vc cv cint c0 wne
      wi vc cJ ccld cfv cpw wral cX vf cv cuni wceq vs vf cv vs cv cJ ccl cfv
      cfv ciin c0 wne wi vf cfil wral cJ ctop wcel c0 vc cv cfi cfv wnel vc cv
      cint c0 wne wi vc cJ ccld cfv cpw wral cX vf cv cuni wceq vs vf cv vs cv
      cJ ccl cfv cfv ciin c0 wne wi vf cfil cJ ctop wcel vf cv cfil wcel c0 vc
      cv cfi cfv wnel vc cv cint c0 wne wi vc cJ ccld cfv cpw wral cX vf cv
      cuni wceq vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi cJ ctop wcel vf cv
      cfil wcel cX vf cv cuni wceq c0 vc cv cfi cfv wnel vc cv cint c0 wne wi
      vc cJ ccld cfv cpw wral vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne cJ ctop
      wcel vf cv cfil wcel cX vf cv cuni wceq c0 vc cv cfi cfv wnel vc cv cint
      c0 wne wi vc cJ ccld cfv cpw wral vs vf cv vs cv cJ ccl cfv cfv ciin c0
      wne wi cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a c0 vc cv cfi
      cfv wnel vc cv cint c0 wne wi vc cJ ccld cfv cpw wral vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab cint c0 wne vs vf cv vs cv cJ ccl cfv
      cfv ciin c0 wne cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a c0 vc
      cv cfi cfv wnel vc cv cint c0 wne wi vc cJ ccld cfv cpw wral c0 vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wnel vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab cint c0 wne cJ ctop wcel vf cv cfil
      wcel cX vf cv cuni wceq w3a c0 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab cfi cfv wcel wn c0 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab cfi cfv wnel cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq
      w3a c0 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wcel
      c0 vf cv wcel vf cv cfil wcel cJ ctop wcel c0 vf cv wcel wn cX vf cv cuni
      wceq vf cv filesn 3ad2ant2 cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq w3a vz cv vx cv wss vz vf cv wrex vx vy cv vs cv cJ ccl cfv cfv wceq
      vs vf cv wrex vy cab cfi cfv wral c0 vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab cfi cfv wcel c0 vf cv wcel wi vx vy vz vf cJ cX vs
      fcluscomp.1 fcluscomplem vz cv vx cv wss vz vf cv wrex vx vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wral c0 vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab cfi cfv wcel vz cv c0 wss vz vf cv wrex
      cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a c0 vf cv wcel vz cv
      vx cv wss vz vf cv wrex vz cv c0 wss vz vf cv wrex vx c0 vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv vx cv c0 wceq vz cv vx cv
      wss vz cv c0 wss vz vf cv vx cv c0 vz cv sseq2 rexbidv rcla4cv vz cv c0
      wss vz vf cv wrex c0 vf cv wcel wi cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vz cv c0 wss c0 vf cv wcel vz vf cv vz cv vf cv wcel vz cv
      c0 wss wa vz cv c0 vf cv vz cv c0 wss vz cv c0 wceq vz cv vf cv wcel vz
      cv ss0 adantl vz cv vf cv wcel vz cv c0 wss pm3.26 eqeltrrd r19.23aiva
      a1i syl9r mpd mtod c0 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab cfi cfv df-nel sylibr cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq
      w3a vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cJ ccld cfv cpw
      wcel c0 vc cv cfi cfv wnel vc cv cint c0 wne wi vc cJ ccld cfv cpw wral
      c0 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wnel vy
      cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cint c0 wne wi wi cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cv cJ ccld cfv wcel wi vy wal vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab cJ ccld cfv cpw wcel cJ ctop wcel
      vf cv cfil wcel cX vf cv cuni wceq w3a vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cv cJ ccld cfv wcel wi vy cJ ctop wcel vf cv cfil wcel cX
      vf cv cuni wceq w3a vy cv vs cv cJ ccl cfv cfv wceq vy cv cJ ccld cfv
      wcel vs vf cv vy cv vs cv cJ ccl cfv cfv wceq vy cv cJ ccld cfv wcel vs
      cv cJ ccl cfv cfv cJ ccld cfv wcel cJ ctop wcel vf cv cfil wcel cX vf cv
      cuni wceq w3a vs cv vf cv wcel wa vy cv vs cv cJ ccl cfv cfv cJ ccld cfv
      eleq1 cJ ctop wcel vs cv cX wss vs cv cJ ccl cfv cfv cJ ccld cfv wcel cJ
      ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vs cv vf cv wcel wa vs
      cv cJ cX fcluscomp.1 clscld cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq vs cv vf cv wcel 3simpl1 cX vf cv cuni wceq cJ ctop wcel vs cv vf cv
      wcel vs cv cX wss vf cv cfil wcel cX vf cv cuni wceq vs cv vf cv wcel wa
      vs cv vf cv cuni cX vs cv vf cv wcel vs cv vf cv cuni wss cX vf cv cuni
      wceq vs cv vf cv elssuni adantl cX vf cv cuni wceq vs cv vf cv wcel
      pm3.26 sseqtr4d 3ad2antl3 sylanc syl5cbir r19.23adva 19.21aiv vy cv vs cv
      cJ ccl cfv cfv wceq vs vf cv wrex vy cab cJ ccld cfv cpw wcel vy cv vs cv
      cJ ccl cfv cfv wceq vs vf cv wrex vy cab cJ ccld cfv wss vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cv cJ ccld cfv wcel wi vy wal vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cJ ccld cfv cJ ccld fvex
      elpw2 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cJ ccld cfv abss
      bitr2i sylib c0 vc cv cfi cfv wnel vc cv cint c0 wne wi c0 vy cv vs cv cJ
      ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wnel vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab cint c0 wne wi vc vy cv vs cv cJ ccl cfv
      cfv wceq vs vf cv wrex vy cab cJ ccld cfv cpw vc cv vy cv vs cv cJ ccl
      cfv cfv wceq vs vf cv wrex vy cab wceq c0 vc cv cfi cfv wnel c0 vy cv vs
      cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wnel vc cv cint c0
      wne vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cint c0 wne vc
      cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab wceq vc cv cfi
      cfv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cfi cfv wceq c0
      vc cv cfi cfv wnel c0 vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy
      cab cfi cfv wnel wb vc cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex
      vy cab cfi fveq2 vc cv cfi cfv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab cfi cfv c0 neleq2 syl vc cv vy cv vs cv cJ ccl cfv cfv wceq
      vs vf cv wrex vy cab wceq vc cv cint vy cv vs cv cJ ccl cfv cfv wceq vs
      vf cv wrex vy cab cint c0 vc cv vy cv vs cv cJ ccl cfv cfv wceq vs vf cv
      wrex vy cab inteq neeq1d imbi12d rcla4v syl mpid vs vf cv vs cv cJ ccl
      cfv cfv ciin vy cv vs cv cJ ccl cfv cfv wceq vs vf cv wrex vy cab cint c0
      vs vy vf cv vs cv cJ ccl cfv cfv vs cv cJ ccl cfv fvex dfiin2 neeq1i
      syl6ibr 3exp com34 com23 r19.21adv cJ ctop wcel cX vf cv cuni wceq vs vf
      cv vs cv cJ ccl cfv cfv ciin c0 wne wi vf cfil wral c0 vc cv cfi cfv wnel
      vc cv cint c0 wne wi vc cJ ccld cfv cpw cJ ctop wcel c0 vc cv cfi cfv
      wnel vc cv cJ ccld cfv cpw wcel cX vf cv cuni wceq vs vf cv vs cv cJ ccl
      cfv cfv ciin c0 wne wi vf cfil wral vc cv cint c0 wne cJ ctop wcel vc cv
      cJ ccld cfv cpw wcel c0 vc cv cfi cfv wnel cX vf cv cuni wceq vs vf cv vs
      cv cJ ccl cfv cfv ciin c0 wne wi vf cfil wral vc cv cint c0 wne wi cJ
      ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel cX vf cv cuni wceq
      vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi vf cfil wral vc cv cint c0
      wne wi wi vc cv cJ ccld cfv cpw wcel cJ ctop wcel vc cv cJ ccld cfv wss
      c0 vc cv cfi cfv wnel cX vf cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv
      ciin c0 wne wi vf cfil wral vc cv cint c0 wne wi cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a cX vf cv cuni wceq vs vf cv vs cv
      cJ ccl cfv cfv ciin c0 wne wi vf cfil wral vc cv cint c0 wne wi vc cv c0
      cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0
      wceq cX vf cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi vf
      cfil wral vc cv cint c0 wne vc cv c0 wceq vc cv cint c0 wne c0 cint c0
      wne c0 cint c0 wne cvv c0 wne vn0 c0 cint cvv c0 int0 neeq1i mpbir vc cv
      c0 wceq vc cv cint c0 cint c0 vc cv c0 inteq neeq1d mpbiri a1i13 cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne cX vf
      cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi vf cfil wral vc
      cv cint c0 wne wi cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv
      wnel w3a vc cv c0 wne wa cX vf cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv
      ciin c0 wne wi vf cfil wral vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ
      ccl cfv cfv ciin c0 wne vc cv cint c0 wne cJ ctop wcel vc cv cJ ccld cfv
      wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa cX vf cv cuni wceq vs vf cv
      vs cv cJ ccl cfv cfv ciin c0 wne wi vf cfil wral cX vc cv cfi cfv cX csn
      cun cfg cfv cuni wceq vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ ccl
      cfv cfv ciin c0 wne cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv
      wnel w3a vc cv c0 wne wa vc cv cfi cfv cX csn cun cuni cX vc cv cfi cfv
      cX csn cun cfg cfv cuni vc cv cfi cfv cuni cX wss cX cvv wcel vc cv cfi
      cfv cX csn cun cuni cX wceq cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv
      cfi cfv wnel w3a vc cv c0 wne wa cX cvv vc cv cfi cfv vc cv cfi cfv cuni
      vc cv cfi cfv cuni eqid extbas2 cJ ctop wcel vc cv cJ ccld cfv wss c0 vc
      cv cfi cfv wnel w3a vc cv c0 wne wa vc cv cuni cX vc cv cfi cfv cuni cJ
      ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa
      vs cv cX wss vs vc cv wral vc cv cuni cX wss cJ ctop wcel vc cv cJ ccld
      cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vs cv cX wss vs vc cv
      cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne
      wa vs cv vc cv wcel vs cv cJ ccld cfv wcel vs cv cX wss cJ ctop wcel vc
      cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vs cv vc cv wcel vs cv cJ
      ccld cfv wcel wi vc cv c0 wne vc cv cJ ccld cfv wss cJ ctop wcel vs cv vc
      cv wcel vs cv cJ ccld cfv wcel wi c0 vc cv cfi cfv wnel vc cv cJ ccld cfv
      vs cv ssel 3ad2ant2 adantr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv
      cfi cfv wnel w3a vs cv cJ ccld cfv wcel vs cv cX wss wi vc cv c0 wne cJ
      ctop wcel vc cv cJ ccld cfv wss vs cv cJ ccld cfv wcel vs cv cX wss wi c0
      vc cv cfi cfv wnel cJ ctop wcel vs cv cJ ccld cfv wcel vs cv cX wss vs cv
      cJ cX fcluscomp.1 cldss ex 3ad2ant1 adantr syld r19.21aiv vs vc cv cX
      unissb sylibr vc cv cvv wcel vc cv cuni vc cv cfi cfv cuni wceq vc visset
      vc cv cvv fiuni ax-mp syl5ssr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv
      cfi cfv wnel w3a cX cvv wcel vc cv c0 wne cJ ctop wcel vc cv cJ ccld cfv
      wss cX cvv wcel c0 vc cv cfi cfv wnel cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg fcluscomp.1 syl5eqel 3ad2ant1 adantr sylanc cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv cfi cfv cX
      csn cun cfbas wcel vc cv cfi cfv cX csn cun cuni vc cv cfi cfv cX csn cun
      cfg cfv cuni wceq vc cv cfi cfv cfbas wcel vc cv cfi cfv cuni cX wss vc
      cv cfi cfv cX csn cun cfbas wcel cJ ctop wcel vc cv cJ ccld cfv wss c0 vc
      cv cfi cfv wnel w3a vc cv c0 wne wa cX vc cv cfi cfv vc cv cfi cfv cuni
      vc cv cfi cfv cuni eqid extbas1 cJ ctop wcel vc cv cJ ccld cfv wss c0 vc
      cv cfi cfv wnel w3a vc cv c0 wne wa vc cv c0 wne c0 vc cv cfi cfv wnel wa
      vc cv cfi cfv cfbas wcel c0 vc cv cfi cfv wnel cJ ctop wcel vc cv c0 wne
      vc cv c0 wne c0 vc cv cfi cfv wnel wa vc cv cJ ccld cfv wss c0 vc cv cfi
      cfv wnel vc cv c0 wne pm3.22 3ad2antl3 vc cv cvv wcel vc cv cfi cfv cfbas
      wcel vc cv c0 wne c0 vc cv cfi cfv wnel wa wb vc visset vc cv cvv fsubbas
      ax-mp sylibr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a
      vc cv c0 wne wa vc cv cuni cX vc cv cfi cfv cuni cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vs cv cX wss vs vc
      cv wral vc cv cuni cX wss cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi
      cfv wnel w3a vc cv c0 wne wa vs cv cX wss vs vc cv cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vs cv vc cv wcel
      vs cv cJ ccld cfv wcel vs cv cX wss cJ ctop wcel vc cv cJ ccld cfv wss c0
      vc cv cfi cfv wnel w3a vs cv vc cv wcel vs cv cJ ccld cfv wcel wi vc cv
      c0 wne vc cv cJ ccld cfv wss cJ ctop wcel vs cv vc cv wcel vs cv cJ ccld
      cfv wcel wi c0 vc cv cfi cfv wnel vc cv cJ ccld cfv vs cv ssel 3ad2ant2
      adantr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vs cv
      cJ ccld cfv wcel vs cv cX wss wi vc cv c0 wne cJ ctop wcel vc cv cJ ccld
      cfv wss vs cv cJ ccld cfv wcel vs cv cX wss wi c0 vc cv cfi cfv wnel cJ
      ctop wcel vs cv cJ ccld cfv wcel vs cv cX wss vs cv cJ cX fcluscomp.1
      cldss ex 3ad2ant1 adantr syld r19.21aiv vs vc cv cX unissb sylibr vc cv
      cvv wcel vc cv cuni vc cv cfi cfv cuni wceq vc visset vc cv cvv fiuni
      ax-mp syl5ssr sylanc vc cv cfi cfv cX csn cun vc cv cfi cfv cX csn cun
      cuni vc cv cfi cfv cX csn cun cuni eqid fgbas syl eqtr3d cJ ctop wcel vc
      cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv cfi
      cfv cX csn cun cfbas wcel vc cv cfi cfv cX csn cun cfg cfv cfil wcel cX
      vf cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi vf cfil wral
      cX vc cv cfi cfv cX csn cun cfg cfv cuni wceq vs vc cv cfi cfv cX csn cun
      cfg cfv vs cv cJ ccl cfv cfv ciin c0 wne wi wi vc cv cfi cfv cfbas wcel
      vc cv cfi cfv cuni cX wss vc cv cfi cfv cX csn cun cfbas wcel cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa cX
      vc cv cfi cfv vc cv cfi cfv cuni vc cv cfi cfv cuni eqid extbas1 cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc
      cv c0 wne c0 vc cv cfi cfv wnel wa vc cv cfi cfv cfbas wcel c0 vc cv cfi
      cfv wnel cJ ctop wcel vc cv c0 wne vc cv c0 wne c0 vc cv cfi cfv wnel wa
      vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel vc cv c0 wne pm3.22 3ad2antl3
      vc cv cvv wcel vc cv cfi cfv cfbas wcel vc cv c0 wne c0 vc cv cfi cfv
      wnel wa wb vc visset vc cv cvv fsubbas ax-mp sylibr cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv cuni cX vc
      cv cfi cfv cuni cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel
      w3a vc cv c0 wne wa vs cv cX wss vs vc cv wral vc cv cuni cX wss cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vs
      cv cX wss vs vc cv cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv
      wnel w3a vc cv c0 wne wa vs cv vc cv wcel vs cv cJ ccld cfv wcel vs cv cX
      wss cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vs cv vc
      cv wcel vs cv cJ ccld cfv wcel wi vc cv c0 wne vc cv cJ ccld cfv wss cJ
      ctop wcel vs cv vc cv wcel vs cv cJ ccld cfv wcel wi c0 vc cv cfi cfv
      wnel vc cv cJ ccld cfv vs cv ssel 3ad2ant2 adantr cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a vs cv cJ ccld cfv wcel vs cv cX
      wss wi vc cv c0 wne cJ ctop wcel vc cv cJ ccld cfv wss vs cv cJ ccld cfv
      wcel vs cv cX wss wi c0 vc cv cfi cfv wnel cJ ctop wcel vs cv cJ ccld cfv
      wcel vs cv cX wss vs cv cJ cX fcluscomp.1 cldss ex 3ad2ant1 adantr syld
      r19.21aiv vs vc cv cX unissb sylibr vc cv cvv wcel vc cv cuni vc cv cfi
      cfv cuni wceq vc visset vc cv cvv fiuni ax-mp syl5ssr sylanc vc cv cfi
      cfv cX csn cun fgfil cX vf cv cuni wceq vs vf cv vs cv cJ ccl cfv cfv
      ciin c0 wne wi cX vc cv cfi cfv cX csn cun cfg cfv cuni wceq vs vc cv cfi
      cfv cX csn cun cfg cfv vs cv cJ ccl cfv cfv ciin c0 wne wi vf vc cv cfi
      cfv cX csn cun cfg cfv cfil vf cv vc cv cfi cfv cX csn cun cfg cfv wceq
      cX vf cv cuni wceq cX vc cv cfi cfv cX csn cun cfg cfv cuni wceq vs vf cv
      vs cv cJ ccl cfv cfv ciin c0 wne vs vc cv cfi cfv cX csn cun cfg cfv vs
      cv cJ ccl cfv cfv ciin c0 wne vf cv vc cv cfi cfv cX csn cun cfg cfv wceq
      vf cv cuni vc cv cfi cfv cX csn cun cfg cfv cuni cX vf cv vc cv cfi cfv
      cX csn cun cfg cfv unieq eqeq2d vf cv vc cv cfi cfv cX csn cun cfg cfv
      wceq vs vf cv vs cv cJ ccl cfv cfv ciin vs vc cv cfi cfv cX csn cun cfg
      cfv vs cv cJ ccl cfv cfv ciin c0 vs vf cv vc cv cfi cfv cX csn cun cfg
      cfv vs cv cJ ccl cfv cfv iineq1 neeq1d imbi12d rcla4v 3syl mpid cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc
      cv cint c0 vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ ccl cfv cfv ciin
      c0 cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0
      wne wa vc cv cint c0 wceq vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ
      ccl cfv cfv ciin c0 wss vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ ccl
      cfv cfv ciin c0 wceq vc cv cint c0 wceq vs vc cv cfi cfv cX csn cun cfg
      cfv vs cv cJ ccl cfv cfv ciin vc cv cint wss vs vc cv cfi cfv cX csn cun
      cfg cfv vs cv cJ ccl cfv cfv ciin c0 wss cJ ctop wcel vc cv cJ ccld cfv
      wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv cint c0 vs vc cv cfi
      cfv cX csn cun cfg cfv vs cv cJ ccl cfv cfv ciin sseq2 cJ ctop wcel vc cv
      cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vx cv vs cv cJ
      ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun cfg cfv wrex vx cab cint vc
      cv cint vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ ccl cfv cfv ciin cJ
      ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa
      vc cv vx cv vs cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun cfg cfv
      wrex vx cab wss vx cv vs cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn
      cun cfg cfv wrex vx cab cint vc cv cint wss cJ ctop wcel vc cv cJ ccld
      cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vx cv vc cv wcel vx cv
      vs cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun cfg cfv wrex wi vx
      wal vc cv vx cv vs cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun cfg
      cfv wrex vx cab wss cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv
      wnel w3a vc cv c0 wne wa vx cv vc cv wcel vx cv vs cv cJ ccl cfv cfv wceq
      vs vc cv cfi cfv cX csn cun cfg cfv wrex wi vx cJ ctop wcel vc cv cJ ccld
      cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne vx cv vc cv wcel vx cv vs
      cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun cfg cfv wrex vx cv vc
      cv cfi cfv cX csn cun cfg cfv wcel vx cv vx cv cJ ccl cfv cfv wceq vx cv
      vs cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun cfg cfv wrex cJ
      ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne vx
      cv vc cv wcel wa wa vx cv vs cv cJ ccl cfv cfv wceq vx cv vx cv cJ ccl
      cfv cfv wceq vs vx cv vc cv cfi cfv cX csn cun cfg cfv vs cv vx cv wceq
      vs cv cJ ccl cfv cfv vx cv cJ ccl cfv cfv vx cv vs cv vx cv cJ ccl cfv
      fveq2 eqeq2d rcla4ev cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv
      wnel w3a vc cv c0 wne vx cv vc cv wcel vx cv vc cv cfi cfv cX csn cun cfg
      cfv wcel cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc
      cv c0 wne wa vc cv vc cv cfi cfv cX csn cun cfg cfv vx cv cJ ctop wcel vc
      cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv vc cv
      cfi cfv cX csn cun vc cv cfi cfv cX csn cun cfg cfv cJ ctop wcel vc cv cJ
      ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv vc cv cfi
      cfv vc cv cfi cfv cX csn cun vc cv vc cv cfi cfv wss cJ ctop wcel vc cv
      cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv cvv wcel
      vc cv vc cv cfi cfv wss vc visset vc cv cvv abfi2 ax-mp a1i vc cv cfi cfv
      vc cv cfi cfv cX csn cun wss cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv
      cfi cfv wnel w3a vc cv c0 wne wa vc cv cfi cfv cX csn ssun1 a1i sstrd cJ
      ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa
      vc cv cfi cfv cX csn cun cfbas wcel vc cv cfi cfv cX csn cun vc cv cfi
      cfv cX csn cun cfg cfv wss vc cv cfi cfv cfbas wcel vc cv cfi cfv cuni cX
      wss vc cv cfi cfv cX csn cun cfbas wcel cJ ctop wcel vc cv cJ ccld cfv
      wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa cX vc cv cfi cfv vc cv cfi
      cfv cuni vc cv cfi cfv cuni eqid extbas1 cJ ctop wcel vc cv cJ ccld cfv
      wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vc cv c0 wne c0 vc cv cfi
      cfv wnel wa vc cv cfi cfv cfbas wcel c0 vc cv cfi cfv wnel cJ ctop wcel
      vc cv c0 wne vc cv c0 wne c0 vc cv cfi cfv wnel wa vc cv cJ ccld cfv wss
      c0 vc cv cfi cfv wnel vc cv c0 wne pm3.22 3ad2antl3 vc cv cvv wcel vc cv
      cfi cfv cfbas wcel vc cv c0 wne c0 vc cv cfi cfv wnel wa wb vc visset vc
      cv cvv fsubbas ax-mp sylibr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv
      cfi cfv wnel w3a vc cv c0 wne wa vc cv cuni cX vc cv cfi cfv cuni cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vs
      cv cX wss vs vc cv wral vc cv cuni cX wss cJ ctop wcel vc cv cJ ccld cfv
      wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa vs cv cX wss vs vc cv cJ
      ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vc cv c0 wne wa
      vs cv vc cv wcel vs cv cJ ccld cfv wcel vs cv cX wss cJ ctop wcel vc cv
      cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vs cv vc cv wcel vs cv cJ ccld
      cfv wcel wi vc cv c0 wne vc cv cJ ccld cfv wss cJ ctop wcel vs cv vc cv
      wcel vs cv cJ ccld cfv wcel wi c0 vc cv cfi cfv wnel vc cv cJ ccld cfv vs
      cv ssel 3ad2ant2 adantr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi
      cfv wnel w3a vs cv cJ ccld cfv wcel vs cv cX wss wi vc cv c0 wne cJ ctop
      wcel vc cv cJ ccld cfv wss vs cv cJ ccld cfv wcel vs cv cX wss wi c0 vc
      cv cfi cfv wnel cJ ctop wcel vs cv cJ ccld cfv wcel vs cv cX wss vs cv cJ
      cX fcluscomp.1 cldss ex 3ad2ant1 adantr syld r19.21aiv vs vc cv cX unissb
      sylibr vc cv cvv wcel vc cv cuni vc cv cfi cfv cuni wceq vc visset vc cv
      cvv fiuni ax-mp syl5ssr sylanc vc cv cfi cfv cX csn cun fbssfg syl sstrd
      sseld impr cJ ctop wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a
      vc cv c0 wne vx cv vc cv wcel wa wa vx cv cJ ccl cfv cfv vx cv cJ ctop
      wcel vc cv cJ ccld cfv wss c0 vc cv cfi cfv wnel w3a vx cv vc cv wcel vx
      cv cJ ccl cfv cfv vx cv wceq vc cv c0 wne cJ ctop wcel vc cv cJ ccld cfv
      wss vx cv vc cv wcel vx cv cJ ccl cfv cfv vx cv wceq c0 vc cv cfi cfv
      wnel cJ ctop wcel vc cv cJ ccld cfv wss vx cv vc cv wcel vx cv cJ ccl cfv
      cfv vx cv wceq cJ ctop wcel vx cv cJ ccld cfv wcel vx cv cJ ccl cfv cfv
      vx cv wceq vc cv cJ ccld cfv wss vx cv vc cv wcel wa vx cv cJ cldcls vc
      cv cJ ccld cfv vx cv ssel2 sylan2 anassrs 3adantl3 adantrl eqcomd sylanc
      expr 19.21aiv vx cv vs cv cJ ccl cfv cfv wceq vs vc cv cfi cfv cX csn cun
      cfg cfv wrex vx vc cv ssab sylibr vc cv vx cv vs cv cJ ccl cfv cfv wceq
      vs vc cv cfi cfv cX csn cun cfg cfv wrex vx cab intss syl vs vx vc cv cfi
      cfv cX csn cun cfg cfv vs cv cJ ccl cfv cfv vs cv cJ ccl cfv fvex dfiin2
      syl5ss syl5cbi vs vc cv cfi cfv cX csn cun cfg cfv vs cv cJ ccl cfv cfv
      ciin ss0 syl6 necon3d syld ex pm2.61dne 3exp vc cv cJ ccld cfv vc visset
      elpw syl5ib com23 com24 r19.21adv impbid vc cJ compfipin0 cJ ctop wcel cX
      vf cv cuni wceq vf cv cJ cfclus cfv cfv c0 wne wi cX vf cv cuni wceq vs
      vf cv vs cv cJ ccl cfv cfv ciin c0 wne wi vf cfil cJ ctop wcel vf cv cfil
      wcel wa cX vf cv cuni wceq vf cv cJ cfclus cfv cfv c0 wne vs vf cv vs cv
      cJ ccl cfv cfv ciin c0 wne cJ ctop wcel vf cv cfil wcel cX vf cv cuni
      wceq vf cv cJ cfclus cfv cfv c0 wne vs vf cv vs cv cJ ccl cfv cfv ciin c0
      wne wb cJ ctop wcel vf cv cfil wcel cX vf cv cuni wceq w3a vf cv cJ
      cfclus cfv cfv vs vf cv vs cv cJ ccl cfv cfv ciin c0 vs vf cv cJ cX vf cv
      cuni fcluscomp.1 vf cv cuni eqid filclus neeq1d 3expa pm5.74da ralbidva
      3bitr4d $.
      $( [20-Nov-2009] $) $( [20-Nov-2009] $)
  $}

  ${
    $d f g l J $. $d f g l X $.
    ufcomp.1 $e |- X = U. J $.
    $( A space is compact iff every ultrafilter converges. $)
    ufcomp $p |- ( J e. Top -> ( J e. Comp <-> A. f e. UFil ( X = U. f -> ( (
    fLim1 ` J ) ` f ) =/= (/) ) ) ) $=
      cJ ctop wcel cJ ccomp wcel cX vl cv cuni wceq vl cv cJ cfclus cfv cfv c0
      wne wi vl cfil wral cX vf cv cuni wceq vf cv cJ cflim1 cfv cfv c0 wne wi
      vf cufil wral vl cJ cX ufcomp.1 fcluscomp cJ ctop wcel cX vl cv cuni wceq
      vl cv cJ cfclus cfv cfv c0 wne wi vl cfil wral cX vf cv cuni wceq vf cv
      cJ cflim1 cfv cfv c0 wne wi vf cufil wral cJ ctop wcel cX vl cv cuni wceq
      vl cv cJ cfclus cfv cfv c0 wne wi vl cfil wral cX vf cv cuni wceq vf cv
      cJ cflim1 cfv cfv c0 wne wi vf cufil cJ ctop wcel cX vf cv cuni wceq vf
      cv cufil wcel cX vl cv cuni wceq vl cv cJ cfclus cfv cfv c0 wne wi vl
      cfil wral vf cv cJ cflim1 cfv cfv c0 wne cJ ctop wcel cX vf cv cuni wceq
      vf cv cufil wcel cX vl cv cuni wceq vl cv cJ cfclus cfv cfv c0 wne wi vl
      cfil wral vf cv cJ cflim1 cfv cfv c0 wne wi cJ ctop wcel cX vf cv cuni
      wceq vf cv cufil wcel w3a cX vl cv cuni wceq vl cv cJ cfclus cfv cfv c0
      wne wi vl cfil wral vf cv cJ cfclus cfv cfv c0 wne vf cv cJ cflim1 cfv
      cfv c0 wne cJ ctop wcel cX vf cv cuni wceq vf cv cufil wcel w3a cX vl cv
      cuni wceq vl cv cJ cfclus cfv cfv c0 wne wi vl cfil wral cX vf cv cuni
      wceq vf cv cJ cfclus cfv cfv c0 wne cJ ctop wcel cX vf cv cuni wceq vf cv
      cufil wcel 3simp2 vf cv cufil wcel cJ ctop wcel cX vl cv cuni wceq vl cv
      cJ cfclus cfv cfv c0 wne wi vl cfil wral cX vf cv cuni wceq vf cv cJ
      cfclus cfv cfv c0 wne wi wi cX vf cv cuni wceq vf cv cufil wcel vf cv
      cfil wcel cX vl cv cuni wceq vl cv cJ cfclus cfv cfv c0 wne wi vl cfil
      wral cX vf cv cuni wceq vf cv cJ cfclus cfv cfv c0 wne wi wi vf cv
      ufilfil cX vl cv cuni wceq vl cv cJ cfclus cfv cfv c0 wne wi cX vf cv
      cuni wceq vf cv cJ cfclus cfv cfv c0 wne wi vl vf cv cfil vl cv vf cv
      wceq cX vl cv cuni wceq cX vf cv cuni wceq vl cv cJ cfclus cfv cfv c0 wne
      vf cv cJ cfclus cfv cfv c0 wne vl cv vf cv wceq vl cv cuni vf cv cuni cX
      vl cv vf cv unieq eqeq2d vl cv vf cv wceq vl cv cJ cfclus cfv cfv vf cv
      cJ cfclus cfv cfv c0 vl cv vf cv cJ cfclus cfv fveq2 neeq1d imbi12d
      rcla4v syl 3ad2ant3 mpid cJ ctop wcel cX vf cv cuni wceq vf cv cufil wcel
      w3a vf cv cJ cfclus cfv cfv vf cv cJ cflim1 cfv cfv c0 cJ ctop wcel vf cv
      cufil wcel cX vf cv cuni wceq vf cv cJ cfclus cfv cfv vf cv cJ cflim1 cfv
      cfv wceq vf cv cJ cX vf cv cuni ufcomp.1 vf cv cuni eqid uffclsflim
      3com23 neeq1d sylibd 3exp com24 r19.21adv cJ ctop wcel cX vf cv cuni wceq
      vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil wral cX vl cv cuni wceq vl cv
      cJ cfclus cfv cfv c0 wne wi vl cfil cJ ctop wcel cX vl cv cuni wceq vl cv
      cfil wcel cX vf cv cuni wceq vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil
      wral vl cv cJ cfclus cfv cfv c0 wne cJ ctop wcel cX vl cv cuni wceq vl cv
      cfil wcel cX vf cv cuni wceq vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil
      wral vl cv cJ cfclus cfv cfv c0 wne wi cJ ctop wcel cX vl cv cuni wceq vl
      cv cfil wcel w3a cX vg cv cuni wceq vl cv vg cv wss wa vg cufil wrex cX
      vf cv cuni wceq vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil wral vl cv cJ
      cfclus cfv cfv c0 wne wi cX vl cv cuni wceq vl cv cfil wcel cX vg cv cuni
      wceq vl cv vg cv wss wa vg cufil wrex cJ ctop wcel cX vl cv cuni wceq vl
      cv cfil wcel wa cX vg cv cuni wceq vl cv vg cv wss wa vg cufil wrex vl cv
      cuni vg cv cuni wceq vl cv vg cv wss wa vg cufil wrex vl cv cfil wcel vl
      cv cuni vg cv cuni wceq vl cv vg cv wss wa vg cufil wrex cX vl cv cuni
      wceq vg vl cv vl cv cuni vl cv cuni eqid filssufil adantl cX vl cv cuni
      wceq cX vg cv cuni wceq vl cv vg cv wss wa vg cufil wrex vl cv cuni vg cv
      cuni wceq vl cv vg cv wss wa vg cufil wrex wb vl cv cfil wcel cX vl cv
      cuni wceq cX vg cv cuni wceq vl cv vg cv wss wa vl cv cuni vg cv cuni
      wceq vl cv vg cv wss wa vg cufil cX vl cv cuni wceq cX vg cv cuni wceq vl
      cv cuni vg cv cuni wceq vl cv vg cv wss cX vl cv cuni vg cv cuni eqeq1
      anbi1d rexbidv adantr mpbird 3adant1 cJ ctop wcel cX vl cv cuni wceq vl
      cv cfil wcel w3a cX vg cv cuni wceq vl cv vg cv wss wa cX vf cv cuni wceq
      vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil wral vl cv cJ cfclus cfv cfv
      c0 wne wi vg cufil cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg
      cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss cX vf cv cuni wceq vf cv
      cJ cflim1 cfv cfv c0 wne wi vf cufil wral vl cv cJ cfclus cfv cfv c0 wne
      wi cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel
      cX vg cv cuni wceq vl cv vg cv wss cX vf cv cuni wceq vf cv cJ cflim1 cfv
      cfv c0 wne wi vf cufil wral vl cv cJ cfclus cfv cfv c0 wne wi cJ ctop
      wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv
      cuni wceq vl cv vg cv wss w3a wa cX vf cv cuni wceq vf cv cJ cflim1 cfv
      cfv c0 wne wi vf cufil wral vg cv cJ cflim1 cfv cfv c0 wne vl cv cJ
      cfclus cfv cfv c0 wne cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel w3a
      vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss w3a wa cX vf cv cuni
      wceq vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil wral cX vg cv cuni wceq
      vg cv cJ cflim1 cfv cfv c0 wne cJ ctop wcel cX vl cv cuni wceq vl cv cfil
      wcel w3a vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss 3simpr2 vg
      cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss w3a cX vf cv cuni wceq
      vf cv cJ cflim1 cfv cfv c0 wne wi vf cufil wral cX vg cv cuni wceq vg cv
      cJ cflim1 cfv cfv c0 wne wi wi cJ ctop wcel cX vl cv cuni wceq vl cv cfil
      wcel w3a vg cv cufil wcel cX vg cv cuni wceq cX vf cv cuni wceq vf cv cJ
      cflim1 cfv cfv c0 wne wi vf cufil wral cX vg cv cuni wceq vg cv cJ cflim1
      cfv cfv c0 wne wi wi vl cv vg cv wss cX vf cv cuni wceq vf cv cJ cflim1
      cfv cfv c0 wne wi cX vg cv cuni wceq vg cv cJ cflim1 cfv cfv c0 wne wi vf
      vg cv cufil vf cv vg cv wceq cX vf cv cuni wceq cX vg cv cuni wceq vf cv
      cJ cflim1 cfv cfv c0 wne vg cv cJ cflim1 cfv cfv c0 wne vf cv vg cv wceq
      vf cv cuni vg cv cuni cX vf cv vg cv unieq eqeq2d vf cv vg cv wceq vf cv
      cJ cflim1 cfv cfv vg cv cJ cflim1 cfv cfv c0 vf cv vg cv cJ cflim1 cfv
      fveq2 neeq1d imbi12d rcla4v 3ad2ant1 adantl mpid cJ ctop wcel cX vl cv
      cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv cuni wceq vl cv
      vg cv wss w3a wa vg cv cJ cflim1 cfv cfv vl cv cJ cfclus cfv cfv wss vg
      cv cJ cflim1 cfv cfv c0 wne vl cv cJ cfclus cfv cfv c0 wne wi cJ ctop
      wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv
      cuni wceq vl cv vg cv wss w3a wa vg cv cJ cflim1 cfv cfv vg cv cJ cfclus
      cfv cfv vl cv cJ cfclus cfv cfv cJ ctop wcel vg cv cufil wcel cX vg cv
      cuni wceq vg cv cJ cfclus cfv cfv vg cv cJ cflim1 cfv cfv wceq cJ ctop
      wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv
      cuni wceq vl cv vg cv wss w3a wa vg cv cJ cX vg cv cuni ufcomp.1 vg cv
      cuni eqid uffclsflim cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel vg
      cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss w3a 3simpl1 cJ ctop wcel
      cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv cuni
      wceq vl cv vg cv wss 3simpr1 cJ ctop wcel cX vl cv cuni wceq vl cv cfil
      wcel w3a vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss 3simpr2
      syl3anc cJ ctop wcel vl cv cfil wcel vg cv cfil wcel w3a cX vl cv cuni
      wceq cX vg cv cuni wceq w3a vl cv vg cv wss vg cv cJ cfclus cfv cfv vl cv
      cJ cfclus cfv cfv wss cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel w3a
      vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss w3a wa vl cv vg cv cJ
      cX vl cv cuni vg cv cuni ufcomp.1 vl cv cuni eqid vg cv cuni eqid fclusss
      cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX
      vg cv cuni wceq vl cv vg cv wss w3a wa cJ ctop wcel vl cv cfil wcel vg cv
      cfil wcel w3a cX vl cv cuni wceq cX vg cv cuni wceq cJ ctop wcel cX vl cv
      cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv cuni wceq vl cv
      vg cv wss w3a wa cJ ctop wcel vl cv cfil wcel vg cv cfil wcel cJ ctop
      wcel cX vl cv cuni wceq vl cv cfil wcel vg cv cufil wcel cX vg cv cuni
      wceq vl cv vg cv wss w3a 3simpl1 cJ ctop wcel cX vl cv cuni wceq vl cv
      cfil wcel vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss w3a 3simpl3
      vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss w3a vg cv cfil wcel
      cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX
      vg cv cuni wceq vg cv cfil wcel vl cv vg cv wss vg cv ufilfil 3ad2ant1
      adantl 3jca cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel vg cv cufil
      wcel cX vg cv cuni wceq vl cv vg cv wss w3a 3simpl2 cJ ctop wcel cX vl cv
      cuni wceq vl cv cfil wcel w3a vg cv cufil wcel cX vg cv cuni wceq vl cv
      vg cv wss 3simpr2 3jca cJ ctop wcel cX vl cv cuni wceq vl cv cfil wcel
      w3a vg cv cufil wcel cX vg cv cuni wceq vl cv vg cv wss 3simpr3 sylanc
      eqsstr3d vg cv cJ cflim1 cfv cfv vl cv cJ cfclus cfv cfv wss vg cv cJ
      cflim1 cfv cfv c0 wne vl cv cJ cfclus cfv cfv c0 wne vg cv cJ cflim1 cfv
      cfv vl cv cJ cfclus cfv cfv ssn0 ex syl syld 3exp2 imp4a r19.23adv mpd
      3exp com24 r19.21adv impbid bitrd $.
      $( [11-Dec-2009] $) $( [11-Dec-2009] $)
  $}

  ${
    $d f g s x y z J $. $d f g s x y z L $. $d f g s x y z X $. $d f g s x y z
    Y $.
    fclusff.1 $e |- X = U. J $.
    fclusff.2 $e |- Y = U. L $.
    $( A function that takes a function from a class of functions to its
       cluster points. $)
    fclusff $p |- ( ( J e. Top /\ L e. Fil ) -> ( J fClusf L ) = { <. f , s >.
    | ( f : Y --> X /\ s = ( ( fClus ` J ) ` ( ( X FilMap L ) ` f ) ) ) } ) $=
      cJ ctop wcel cL cfil wcel cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv
      cJ cfclus cfv cfv wceq wa vf vs copab cvv wcel cJ cL cfclusf co cY cX vf
      cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs
      copab wceq cJ ctop wcel cL cfil wcel wa vf cv cY cX vg cv wf vg cab wcel
      vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab
      cvv cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv
      wceq wa vf vs copab cJ ctop wcel cL cfil wcel wa cY cX vg cv wf vg cab
      cvv wcel vf cv cY cX vg cv wf vg cab wcel vs cv vf cv cX cL cfilmap co
      cfv cJ cfclus cfv cfv wceq wa vf vs copab cvv wcel cL cfil wcel cJ ctop
      wcel cY cX vg cv wf vg cab cvv wcel cY cvv wcel cX cvv wcel cY cX vg cv
      wf vg cab cvv wcel cL cfil wcel cJ ctop wcel cY cX cvv cvv vg mapex cL
      cfil wcel cL cuni cvv cY cL cfil uniexg fclusff.2 syl5eqel cJ ctop wcel
      cJ cuni cvv cX cJ ctop uniexg fclusff.1 syl5eqel syl2an ancoms vf vs cY
      cX vg cv wf vg cab vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv cvv
      opabex2g syl vf cv cY cX vg cv wf vg cab wcel vs cv vf cv cX cL cfilmap
      co cfv cJ cfclus cfv cfv wceq wa cY cX vf cv wf vs cv vf cv cX cL cfilmap
      co cfv cJ cfclus cfv cfv wceq wa vf vs vf cv cY cX vg cv wf vg cab wcel
      cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq cY
      cX vg cv wf cY cX vf cv wf vg vf cv vf visset cY cX vg cv vf cv feq1 elab
      anbi1i opabbii syl5eqelr vx vy vz cJ cL ctop cfil vy cv cuni vx cv cuni
      vf cv wf vs cv vf cv vx cv cuni vy cv cfilmap co cfv vx cv cfclus cfv cfv
      wceq wa vf vs copab cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ
      cfclus cfv cfv wceq wa vf vs copab cfclusf vy cv cuni cX vf cv wf vs cv
      vf cv cX vy cv cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab cvv
      vx cv cJ wceq vy cv cuni vx cv cuni vf cv wf vs cv vf cv vx cv cuni vy cv
      cfilmap co cfv vx cv cfclus cfv cfv wceq wa vy cv cuni cX vf cv wf vs cv
      vf cv cX vy cv cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs vx cv cJ
      wceq vy cv cuni vx cv cuni vf cv wf vy cv cuni cX vf cv wf vs cv vf cv vx
      cv cuni vy cv cfilmap co cfv vx cv cfclus cfv cfv wceq vs cv vf cv cX vy
      cv cfilmap co cfv cJ cfclus cfv cfv wceq vx cv cJ wceq vx cv cuni cX wceq
      vy cv cuni vx cv cuni vf cv wf vy cv cuni cX vf cv wf wb vx cv cJ wceq vx
      cv cuni cJ cuni cX vx cv cJ unieq fclusff.1 syl6eqr vx cv cuni cX vy cv
      cuni vf cv feq3 syl vx cv cJ wceq vf cv vx cv cuni vy cv cfilmap co cfv
      vx cv cfclus cfv cfv vf cv cX vy cv cfilmap co cfv cJ cfclus cfv cfv vs
      cv vx cv cJ wceq vf cv vx cv cuni vy cv cfilmap co cfv vf cv cX vy cv
      cfilmap co cfv vx cv cfclus cfv cJ cfclus cfv vx cv cJ cfclus fveq2 vx cv
      cJ wceq vf cv vx cv cuni vy cv cfilmap co cX vy cv cfilmap co vx cv cJ
      wceq vx cv cuni cX vy cv cfilmap vx cv cJ wceq vx cv cuni cJ cuni cX vx
      cv cJ unieq fclusff.1 syl6eqr opreq1d fveq1d fveq12d eqeq2d anbi12d
      opabbidv vy cv cL wceq vy cv cuni cX vf cv wf vs cv vf cv cX vy cv
      cfilmap co cfv cJ cfclus cfv cfv wceq wa cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs vy cv cL wceq vy cv cuni
      cX vf cv wf cY cX vf cv wf vs cv vf cv cX vy cv cfilmap co cfv cJ cfclus
      cfv cfv wceq vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq vy
      cv cL wceq vy cv cuni cY wceq vy cv cuni cX vf cv wf cY cX vf cv wf wb vy
      cv cL wceq vy cv cuni cL cuni cY vy cv cL unieq fclusff.2 syl6eqr vy cv
      cuni cY cX vf cv feq2 syl vy cv cL wceq vf cv cX vy cv cfilmap co cfv cJ
      cfclus cfv cfv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv vs cv vy cv
      cL wceq vf cv cX vy cv cfilmap co cfv vf cv cX cL cfilmap co cfv cJ
      cfclus cfv vy cv cL wceq vf cv cX vy cv cfilmap co cX cL cfilmap co vy cv
      cL cX cfilmap opreq2 fveq1d fveq2d eqeq2d anbi12d opabbidv cfclusf vx cv
      ctop wcel vy cv cfil wcel vz cv vy cv cuni vx cv cuni vf cv wf vs cv vf
      cv vx cv cuni vy cv cfilmap co cfv vx cv cfclus cfv cfv wceq wa vf vs
      copab wceq w3a vx vy vz copab2 vx cv ctop wcel vy cv cfil wcel wa vz cv
      vy cv cuni vx cv cuni vf cv wf vs cv vf cv vx cv cuni vy cv cfilmap co
      cfv vx cv cfclus cfv cfv wceq wa vf vs copab wceq wa vx vy vz copab2 vx
      vy vz vf vs df-fclusf vx cv ctop wcel vy cv cfil wcel vz cv vy cv cuni vx
      cv cuni vf cv wf vs cv vf cv vx cv cuni vy cv cfilmap co cfv vx cv cfclus
      cfv cfv wceq wa vf vs copab wceq w3a vx cv ctop wcel vy cv cfil wcel wa
      vz cv vy cv cuni vx cv cuni vf cv wf vs cv vf cv vx cv cuni vy cv cfilmap
      co cfv vx cv cfclus cfv cfv wceq wa vf vs copab wceq wa vx vy vz vx cv
      ctop wcel vy cv cfil wcel vz cv vy cv cuni vx cv cuni vf cv wf vs cv vf
      cv vx cv cuni vy cv cfilmap co cfv vx cv cfclus cfv cfv wceq wa vf vs
      copab wceq df-3an oprabbii eqtri oprabval2g mpd3an3 $.
      $( [23-Nov-2009] $) $( [23-Nov-2009] $)
  $}

  ${
    $d f s F $. $d f s J $. $d f s L $. $d f s X $. $d f s Y $.
    sfclusf.1 $e |- X = U. J $.
    sfclusf.2 $e |- Y = U. L $.
    $( The set of cluster points of a function. $)
    sfclusf $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( ( J fClusf L )
    ` F ) = ( ( fClus ` J ) ` ( ( X FilMap L ) ` F ) ) ) $=
      cJ cL cfclusf co wfun cF cF cX cL cfilmap co cfv cJ cfclus cfv cfv cop cJ
      cL cfclusf co wcel cF cJ cL cfclusf co cfv cF cX cL cfilmap co cfv cJ
      cfclus cfv cfv wceq cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cF cX cL
      cfilmap co cfv cJ cfclus cfv cfv cJ cL cfclusf co cF cX cL cfilmap co cfv
      cJ cfclus cfv fvex funopfv cJ ctop wcel cL cfil wcel cY cX cF wf w3a cJ
      cL cfclusf co wfun cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ
      cfclus cfv cfv wceq wa vf vs copab wfun cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq vf vs copab wss vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq vf vs copab wfun cY cX vf cv wf vs
      cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab wfun
      cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa
      vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq vf vs cY cX vf cv
      wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq pm3.27
      ssopab2i vf vs vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv funopabeq cY
      cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf
      vs copab vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq vf vs
      copab funss mp2 cJ ctop wcel cL cfil wcel cJ cL cfclusf co wfun cY cX vf
      cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs
      copab wfun wb cY cX cF wf cJ ctop wcel cL cfil wcel wa cJ cL cfclusf co
      cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa
      vf vs copab wceq cJ cL cfclusf co wfun cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab wfun wb vf cJ cL cX
      cY vs sfclusf.1 sfclusf.2 fclusff cJ cL cfclusf co cY cX vf cv wf vs cv
      vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab funeq
      syl 3adant3 mpbiri cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cF cX cL
      cfilmap co cfv cJ cfclus cfv cfv cop cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab cJ cL cfclusf co cJ
      ctop wcel cL cfil wcel cY cX cF wf w3a cF cF cX cL cfilmap co cfv cJ
      cfclus cfv cfv cop cY cX vf cv wf vs cv vf cv cX cL cfilmap co cfv cJ
      cfclus cfv cfv wceq wa vf vs copab wcel cY cX cF wf cF cX cL cfilmap co
      cfv cJ cfclus cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cY cX cF wf cF cX cL cfilmap co
      cfv cJ cfclus cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv wceq cJ
      ctop wcel cL cfil wcel cY cX cF wf 3simp3 cF cX cL cfilmap co cfv cJ
      cfclus cfv cfv eqid jctir cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF
      cvv wcel cF cF cX cL cfilmap co cfv cJ cfclus cfv cfv cop cY cX vf cv wf
      vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab
      wcel cY cX cF wf cF cX cL cfilmap co cfv cJ cfclus cfv cfv cF cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq wa wb cL cfil wcel cY cX cF wf cF
      cvv wcel cJ ctop wcel cY cX cF wf cL cfil wcel cF cvv wcel cY cX cF wf cY
      cvv wcel cF cvv wcel cL cfil wcel cY cX cvv cF fex cL cfil wcel cL cuni
      cvv cY cL cfil uniexg sfclusf.2 syl5eqel sylan2 ancoms 3adant1 cF cvv
      wcel cF cX cL cfilmap co cfv cJ cfclus cfv cfv cvv wcel cF cF cX cL
      cfilmap co cfv cJ cfclus cfv cfv cop cY cX vf cv wf vs cv vf cv cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab wcel cY cX cF wf cF
      cX cL cfilmap co cfv cJ cfclus cfv cfv cF cX cL cfilmap co cfv cJ cfclus
      cfv cfv wceq wa wb cF cX cL cfilmap co cfv cJ cfclus cfv fvex cY cX vf cv
      wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa cY cX cF wf
      vs cv cF cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa cY cX cF wf cF cX
      cL cfilmap co cfv cJ cfclus cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv
      cfv wceq wa vf vs cF cF cX cL cfilmap co cfv cJ cfclus cfv cfv cvv cvv vf
      cv cF wceq cY cX vf cv wf cY cX cF wf vs cv vf cv cX cL cfilmap co cfv cJ
      cfclus cfv cfv wceq vs cv cF cX cL cfilmap co cfv cJ cfclus cfv cfv wceq
      cY cX vf cv cF feq1 vf cv cF wceq vf cv cX cL cfilmap co cfv cJ cfclus
      cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv vs cv vf cv cF wceq vf
      cv cX cL cfilmap co cfv cF cX cL cfilmap co cfv cJ cfclus cfv vf cv cF cX
      cL cfilmap co fveq2 fveq2d eqeq2d anbi12d vs cv cF cX cL cfilmap co cfv
      cJ cfclus cfv cfv wceq vs cv cF cX cL cfilmap co cfv cJ cfclus cfv cfv
      wceq cF cX cL cfilmap co cfv cJ cfclus cfv cfv cF cX cL cfilmap co cfv cJ
      cfclus cfv cfv wceq cY cX cF wf vs cv cF cX cL cfilmap co cfv cJ cfclus
      cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv eqeq1 anbi2d opelopabg
      mpan2 syl mpbird cJ ctop wcel cL cfil wcel cJ cL cfclusf co cY cX vf cv
      wf vs cv vf cv cX cL cfilmap co cfv cJ cfclus cfv cfv wceq wa vf vs copab
      wceq cY cX cF wf vf cJ cL cX cY vs sfclusf.1 sfclusf.2 fclusff 3adant3
      eleqtrrd sylc $.
      $( [24-Nov-2009] $) $( [24-Nov-2009] $)
  $}

  ${
    $d o s t x A $. $d o s t x F $. $d o s t x J $. $d o s t x L $. $d o s t x
    X $. $d o s t x Y $.
    isfclusf.1 $e |- X = U. J $.
    isfclusf.2 $e |- Y = U. L $.
    $( The property of being a cluster point of a function. $)
    isfclusf $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( A e. ( ( J
    fClusf L ) ` F ) <-> ( A e. X /\ A. o e. J ( A e. o -> A. s e. L ( o i^i (
    F " s ) ) =/= (/) ) ) ) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel
      cA cF cX cL cfilmap co cfv cJ cfclus cfv cfv wcel cA cX wcel cA vo cv
      wcel vo cv vt cv cin c0 wne vt cF cX cL cfilmap co cfv wral wi vo cJ wral
      wa cA cX wcel cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi
      vo cJ wral wa cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cJ cL cfclusf
      co cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv cA cF cJ cL cX cY
      isfclusf.1 isfclusf.2 sfclusf eleq2d cJ ctop wcel cF cX cL cfilmap co cfv
      cfil wcel cX cF cX cL cfilmap co cfv cuni wceq cA cF cX cL cfilmap co cfv
      cJ cfclus cfv cfv wcel cA cX wcel cA vo cv wcel vo cv vt cv cin c0 wne vt
      cF cX cL cfilmap co cfv wral wi vo cJ wral wa wb cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cA vo cF cX cL cfilmap co cfv cJ cX cF cX cL cfilmap
      co cfv cuni vt isfclusf.1 cF cX cL cfilmap co cfv cuni eqid isfclus cJ
      ctop wcel cL cfil wcel cY cX cF wf 3simp1 cX cvv wcel cL cfbas wcel cY cX
      cF wf cF cX cL cfilmap co cfv cfil wcel cJ ctop wcel cL cfil wcel cY cX
      cF wf cvv cL cF cX cY isfclusf.2 fmf cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg isfclusf.1 syl5eqel cL filfbas cY cX cF wf id syl3an cJ ctop wcel
      cL cfil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cuni cX cX cvv wcel
      cL cfbas wcel cY cX cF wf cF cX cL cfilmap co cfv cuni cX wceq cJ ctop
      wcel cL cfil wcel cY cX cF wf cvv cL cF cX cY isfclusf.2 fmbas cJ ctop
      wcel cJ cuni cvv cX cJ ctop uniexg isfclusf.1 syl5eqel cL filfbas cY cX
      cF wf id syl3an eqcomd syl3anc cJ ctop wcel cL cfil wcel cY cX cF wf w3a
      cA cX wcel cA vo cv wcel vo cv vt cv cin c0 wne vt cF cX cL cfilmap co
      cfv wral wi vo cJ wral cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL
      wral wi vo cJ wral cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel
      wa cA vo cv wcel vo cv vt cv cin c0 wne vt cF cX cL cfilmap co cfv wral
      wi cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi vo cJ cJ
      ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel cA vo cv
      wcel vo cv vt cv cin c0 wne vt cF cX cL cfilmap co cfv wral wi cA vo cv
      wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi wb cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa vo cv vt cv cin c0
      wne vt cF cX cL cfilmap co cfv wral vo cv cF vs cv cima cin c0 wne vs cL
      wral cA vo cv wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel
      vo cv cJ wcel wa wa vo cv vt cv cin c0 wne vt cF cX cL cfilmap co cfv
      wral vo cv cF vs cv cima cin c0 wne vs cL wral cJ ctop wcel cL cfil wcel
      cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa vo cv vt cv cin c0 wne vt
      cF cX cL cfilmap co cfv wral vo cv cF vs cv cima cin c0 wne vs cL cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa vs cv cL
      wcel wa cF vs cv cima cF cX cL cfilmap co cfv wcel vo cv vt cv cin c0 wne
      vt cF cX cL cfilmap co cfv wral vo cv cF vs cv cima cin c0 wne wi cX cvv
      wcel cL cfbas wcel cY cX cF wf w3a vs cv cL cfg cfv wcel cF vs cv cima cF
      cX cL cfilmap co cfv wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX
      wcel vo cv cJ wcel wa wa vs cv cL wcel wa cvv cL vs cv cF cL cfg cfv cX
      cY isfclusf.2 cL cfg cfv eqid imaelfm cJ ctop wcel cL cfil wcel cY cX cF
      wf w3a cX cvv wcel cL cfbas wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel
      wa vs cv cL wcel cJ ctop wcel cX cvv wcel cL cfil wcel cL cfbas wcel cY
      cX cF wf cY cX cF wf cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      isfclusf.1 syl5eqel cL filfbas cY cX cF wf id 3anim123i ad2antrr cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa vs cv cL
      cfg cfv wcel vs cv cL wcel cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA
      cX wcel vo cv cJ wcel wa wa cL cfg cfv cL vs cv cJ ctop wcel cL cfil wcel
      cY cX cF wf w3a cL cfg cfv cL wceq cA cX wcel vo cv cJ wcel wa cL cfil
      wcel cJ ctop wcel cL cfg cfv cL wceq cY cX cF wf cL fgid 3ad2ant2 adantr
      eleq2d biimpar sylanc vo cv vt cv cin c0 wne vo cv cF vs cv cima cin c0
      wne vt cF vs cv cima cF cX cL cfilmap co cfv vt cv cF vs cv cima wceq vo
      cv vt cv cin vo cv cF vs cv cima cin c0 vt cv cF vs cv cima vo cv ineq2
      neeq1d rcla4v syl r19.21adva cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA
      cX wcel vo cv cJ wcel wa wa vo cv cF vs cv cima cin c0 wne vs cL wral vo
      cv vt cv cin c0 wne vt cF cX cL cfilmap co cfv cJ ctop wcel cL cfil wcel
      cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa vt cv cF cX cL cfilmap co
      cfv wcel vo cv cF vs cv cima cin c0 wne vs cL wral vo cv vt cv cin c0 wne
      wi cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa
      wa vt cv cF cX cL cfilmap co cfv wcel vt cv cX wss cF vx cv cima vt cv
      wss vx cL wrex wa vo cv cF vs cv cima cin c0 wne vs cL wral vo cv vt cv
      cin c0 wne wi cJ ctop wcel cL cfil wcel cY cX cF wf w3a vt cv cF cX cL
      cfilmap co cfv wcel vt cv cX wss cF vx cv cima vt cv wss vx cL wrex wa wb
      cA cX wcel vo cv cJ wcel wa cX cvv wcel cL cfbas wcel cY cX cF wf vt cv
      cF cX cL cfilmap co cfv wcel vt cv cX wss cF vx cv cima vt cv wss vx cL
      wrex wa wb cJ ctop wcel cL cfil wcel cY cX cF wf vx vt cv cL cvv cF cX cY
      isfclusf.2 elfilmap cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg isfclusf.1
      syl5eqel cL filfbas cY cX cF wf id syl3an adantr cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa cF vx cv cima vt cv
      wss vx cL wrex vo cv cF vs cv cima cin c0 wne vs cL wral vo cv vt cv cin
      c0 wne wi vt cv cX wss cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX
      wcel vo cv cJ wcel wa wa cF vx cv cima vt cv wss vo cv cF vs cv cima cin
      c0 wne vs cL wral vo cv vt cv cin c0 wne wi vx cL cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa wa vx cv cL wcel cF vx
      cv cima vt cv wss vo cv cF vs cv cima cin c0 wne vs cL wral vo cv vt cv
      cin c0 wne wi cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv
      cJ wcel wa vx cv cL wcel cF vx cv cima vt cv wss wa vo cv cF vs cv cima
      cin c0 wne vs cL wral vo cv vt cv cin c0 wne wi cJ ctop wcel cL cfil wcel
      cY cX cF wf w3a cA cX wcel vo cv cJ wcel wa vx cv cL wcel cF vx cv cima
      vt cv wss wa wa wa vo cv cF vs cv cima cin c0 wne vs cL wral vo cv cF vx
      cv cima cin c0 wne vo cv vt cv cin c0 wne vx cv cL wcel cF vx cv cima vt
      cv wss wa vo cv cF vs cv cima cin c0 wne vs cL wral vo cv cF vx cv cima
      cin c0 wne wi cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv
      cJ wcel wa vx cv cL wcel vo cv cF vs cv cima cin c0 wne vs cL wral vo cv
      cF vx cv cima cin c0 wne wi cF vx cv cima vt cv wss vo cv cF vs cv cima
      cin c0 wne vo cv cF vx cv cima cin c0 wne vs vx cv cL vs cv vx cv wceq vo
      cv cF vs cv cima cin vo cv cF vx cv cima cin c0 vs cv vx cv wceq cF vs cv
      cima cF vx cv cima vo cv vs cv vx cv cF imaeq2 ineq2d neeq1d rcla4v
      adantr ad2antll cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo
      cv cJ wcel wa vx cv cL wcel cF vx cv cima vt cv wss wa wa wa cF vx cv
      cima vt cv wss vo cv cF vx cv cima cin vo cv vt cv cin wss vo cv cF vx cv
      cima cin c0 wne vo cv vt cv cin c0 wne wi cJ ctop wcel cL cfil wcel cY cX
      cF wf w3a cA cX wcel vo cv cJ wcel wa vx cv cL wcel cF vx cv cima vt cv
      wss simprrr cF vx cv cima vt cv vo cv sslin vo cv cF vx cv cima cin vo cv
      vt cv cin wss vo cv cF vx cv cima cin c0 wne vo cv vt cv cin c0 wne vo cv
      cF vx cv cima cin vo cv vt cv cin ssn0 ex 3syl syld expr exp3a r19.23adv
      adantld sylbid imp r19.21adva impbid imbi2d anassrs ralbidva pm5.32da
      3bitrd $.
      $( [24-Nov-2009] $) $( [24-Nov-2009] $)
  $}

  ${
    $d j n o s A $. $d j n o s F $. $d j n o s J $. $d j n o s L $. $d j n o s
    X $. $d j n o s Y $.
    fclusfnei.1 $e |- X = U. J $.
    fclusfnei.2 $e |- Y = U. L $.
    $( The property of being a cluster point of a function in terms of
       neighborhoods. $)
    fclusfnei $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( A e. ( ( J
    fClusf L ) ` F ) <-> ( A e. X /\ A. n e. ( ( nei ` J ) ` { A } ) A. s e. L
    ( n i^i ( F " s ) ) =/= (/) ) ) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel
      cA cX wcel cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi vo
      cJ wral wa cA cX wcel vn cv cF vs cv cima cin c0 wne vs cL wral vn cA csn
      cJ cnei cfv cfv wral wa cA vo cF cJ cL cX cY vs fclusfnei.1 fclusfnei.2
      isfclusf cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel cA vo cv
      wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi vo cJ wral vn cv cF vs
      cv cima cin c0 wne vs cL wral vn cA csn cJ cnei cfv cfv wral cJ ctop wcel
      cL cfil wcel cY cX cF wf w3a cA cX wcel wa cA vo cv wcel vo cv cF vs cv
      cima cin c0 wne vs cL wral wi vo cJ wral vn cv cF vs cv cima cin c0 wne
      vs cL wral vn cA csn cJ cnei cfv cfv wral cJ ctop wcel cL cfil wcel cY cX
      cF wf w3a cA cX wcel wa cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs
      cL wral wi vo cJ wral vn cv cF vs cv cima cin c0 wne vs cL wral vn cA csn
      cJ cnei cfv cfv cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel wa
      vn cv cA csn cJ cnei cfv cfv wcel cA vo cv wcel vo cv cF vs cv cima cin
      c0 wne vs cL wral wi vo cJ wral vn cv cF vs cv cima cin c0 wne vs cL wral
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel wa vn cv cA csn cJ
      cnei cfv cfv wcel cA csn vj cv wss vj cv vn cv wss wa vj cJ wrex cA vo cv
      wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi vo cJ wral vn cv cF vs
      cv cima cin c0 wne vs cL wral wi cJ ctop wcel cL cfil wcel cY cX cF wf
      w3a vn cv cA csn cJ cnei cfv cfv wcel cA csn vj cv wss vj cv vn cv wss wa
      vj cJ wrex wi cA cX wcel cJ ctop wcel cL cfil wcel vn cv cA csn cJ cnei
      cfv cfv wcel cA csn vj cv wss vj cv vn cv wss wa vj cJ wrex wi cY cX cF
      wf cJ ctop wcel vn cv cA csn cJ cnei cfv cfv wcel cA csn vj cv wss vj cv
      vn cv wss wa vj cJ wrex cA csn vj cJ vn cv neii2 ex 3ad2ant1 adantr cJ
      ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel wa cA csn vj cv wss vj
      cv vn cv wss wa cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral
      wi vo cJ wral vn cv cF vs cv cima cin c0 wne vs cL wral wi vj cJ cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA cX wcel wa vj cv cJ wcel cA csn vj
      cv wss vj cv vn cv wss wa cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs
      cL wral wi vo cJ wral vn cv cF vs cv cima cin c0 wne vs cL wral wi cJ
      ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel wa vj cv cJ wcel cA csn
      vj cv wss vj cv vn cv wss wa wa wa cA vo cv wcel vo cv cF vs cv cima cin
      c0 wne vs cL wral wi vo cJ wral vj cv cF vs cv cima cin c0 wne vs cL wral
      vn cv cF vs cv cima cin c0 wne vs cL wral cJ ctop wcel cL cfil wcel cY cX
      cF wf w3a cA cX wcel wa vj cv cJ wcel cA csn vj cv wss vj cv vn cv wss wa
      wa wa cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi vo cJ
      wral cA vj cv wcel vj cv cF vs cv cima cin c0 wne vs cL wral cA cX wcel
      cA csn vj cv wss vj cv vn cv wss wa cA vj cv wcel cJ ctop wcel cL cfil
      wcel cY cX cF wf w3a vj cv cJ wcel cA cX wcel cA csn vj cv wss cA vj cv
      wcel vj cv vn cv wss cA cX wcel cA vj cv wcel cA csn vj cv wss cA vj cv
      cX snssg biimpar adantrr ad2ant2l vj cv cJ wcel cA vo cv wcel vo cv cF vs
      cv cima cin c0 wne vs cL wral wi vo cJ wral cA vj cv wcel vj cv cF vs cv
      cima cin c0 wne vs cL wral wi wi cJ ctop wcel cL cfil wcel cY cX cF wf
      w3a cA cX wcel wa cA csn vj cv wss vj cv vn cv wss wa cA vo cv wcel vo cv
      cF vs cv cima cin c0 wne vs cL wral wi cA vj cv wcel vj cv cF vs cv cima
      cin c0 wne vs cL wral wi vo vj cv cJ vo cv vj cv wceq cA vo cv wcel cA vj
      cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral vj cv cF vs cv cima cin
      c0 wne vs cL wral vo cv vj cv cA eleq2 vo cv vj cv wceq vo cv cF vs cv
      cima cin c0 wne vj cv cF vs cv cima cin c0 wne vs cL vo cv vj cv wceq vo
      cv cF vs cv cima cin vj cv cF vs cv cima cin c0 vo cv vj cv cF vs cv cima
      ineq1 neeq1d ralbidv imbi12d rcla4v ad2antrl mpid cA csn vj cv wss vj cv
      vn cv wss wa vj cv cF vs cv cima cin c0 wne vs cL wral vn cv cF vs cv
      cima cin c0 wne vs cL wral wi cJ ctop wcel cL cfil wcel cY cX cF wf w3a
      cA cX wcel wa vj cv cJ wcel vj cv vn cv wss vj cv cF vs cv cima cin c0
      wne vs cL wral vn cv cF vs cv cima cin c0 wne vs cL wral wi cA csn vj cv
      wss vj cv vn cv wss vj cv cF vs cv cima cin c0 wne vn cv cF vs cv cima
      cin c0 wne vs cL vj cv vn cv wss vj cv cF vs cv cima cin vn cv cF vs cv
      cima cin wss vj cv cF vs cv cima cin c0 wne vn cv cF vs cv cima cin c0
      wne wi vj cv vn cv cF vs cv cima ssrin vj cv cF vs cv cima cin vn cv cF
      vs cv cima cin wss vj cv cF vs cv cima cin c0 wne vn cv cF vs cv cima cin
      c0 wne vj cv cF vs cv cima cin vn cv cF vs cv cima cin ssn0 ex syl
      r19.20sdv adantl ad2antll syld exp32 r19.23adv syld com23 r19.21adv cJ
      ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel wa vn cv cF vs cv cima
      cin c0 wne vs cL wral vn cA csn cJ cnei cfv cfv wral cA vo cv wcel vo cv
      cF vs cv cima cin c0 wne vs cL wral wi vo cJ cJ ctop wcel cL cfil wcel cY
      cX cF wf w3a cA cX wcel wa vn cv cF vs cv cima cin c0 wne vs cL wral vn
      cA csn cJ cnei cfv cfv wral vo cv cJ wcel cA vo cv wcel vo cv cF vs cv
      cima cin c0 wne vs cL wral cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA
      cX wcel wa vo cv cJ wcel cA vo cv wcel wa vn cv cF vs cv cima cin c0 wne
      vs cL wral vn cA csn cJ cnei cfv cfv wral vo cv cF vs cv cima cin c0 wne
      vs cL wral cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv cJ
      wcel cA vo cv wcel wa vn cv cF vs cv cima cin c0 wne vs cL wral vn cA csn
      cJ cnei cfv cfv wral vo cv cF vs cv cima cin c0 wne vs cL wral wi cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA cX wcel vo cv cJ wcel cA vo cv wcel
      wa wa wa vo cv cA csn cJ cnei cfv cfv wcel vn cv cF vs cv cima cin c0 wne
      vs cL wral vn cA csn cJ cnei cfv cfv wral vo cv cF vs cv cima cin c0 wne
      vs cL wral wi cJ ctop wcel cL cfil wcel cY cX cF wf w3a vo cv cJ wcel cA
      vo cv wcel wa vo cv cA csn cJ cnei cfv cfv wcel cA cX wcel cJ ctop wcel
      cL cfil wcel vo cv cJ wcel cA vo cv wcel wa vo cv cA csn cJ cnei cfv cfv
      wcel cY cX cF wf cJ ctop wcel vo cv cJ wcel cA vo cv wcel vo cv cA csn cJ
      cnei cfv cfv wcel cA cJ vo cv opnneip 3expb 3ad2antl1 adantrl vn cv cF vs
      cv cima cin c0 wne vs cL wral vo cv cF vs cv cima cin c0 wne vs cL wral
      vn vo cv cA csn cJ cnei cfv cfv vn cv vo cv wceq vn cv cF vs cv cima cin
      c0 wne vo cv cF vs cv cima cin c0 wne vs cL vn cv vo cv wceq vn cv cF vs
      cv cima cin vo cv cF vs cv cima cin c0 vn cv vo cv cF vs cv cima ineq1
      neeq1d ralbidv rcla4v syl expr com23 exp4a r19.21adv impbid pm5.32da
      bitrd $.
      $( [26-Nov-2009] $) $( [26-Nov-2009] $)
  $}

  ${
    $d o s A $. $d o s F $. $d o s J $. $d o s L $. $d o s X $. $d o s Y $.
    fclsfelbas.1 $e |- X = U. J $.
    fclsfelbas.2 $e |- Y = U. L $.
    $( A cluster point of a function is in the base set of the topology. $)
    fclsfelbas $p |- ( ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) /\ A e. ( ( J
    fClusf L ) ` F ) ) -> A e. X ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel
      cA cX wcel cA vo cv wcel vo cv cF vs cv cima cin c0 wne vs cL wral wi vo
      cJ wral cA vo cF cJ cL cX cY vs fclsfelbas.1 fclsfelbas.2 isfclusf
      pm3.26bda $.
      $( [26-Nov-2009] $) $( [26-Nov-2009] $)
  $}

  ${
    $d n s A $. $d n s F $. $d n s J $. $d n s L $. $d n s N $. $d n s S $. $d
    n s X $. $d n s Y $.
    fclsfneii.1 $e |- X = U. J $.
    fclsfneii.2 $e |- Y = U. L $.
    $( A neighborhood of a cluster point of a function contains a function
       value from every tail. $)
    fclsfneii $p |- ( ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) /\ ( A e. ( ( J
    fClusf L ) ` F ) /\ N e. ( ( nei ` J ) ` { A } ) /\ S e. L ) ) -> ( N i^i (
    F " S ) ) =/= (/) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel
      cN cA csn cJ cnei cfv cfv wcel cS cL wcel cN cF cS cima cin c0 wne cJ
      ctop wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel cN
      cA csn cJ cnei cfv cfv wcel cS cL wcel cN cF cS cima cin c0 wne cN cA csn
      cJ cnei cfv cfv wcel cS cL wcel wa vn cv cF vs cv cima cin c0 wne vs cL
      wral vn cA csn cJ cnei cfv cfv wral cN cF cS cima cin c0 wne cJ ctop wcel
      cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel wa vn cv cF
      vs cv cima cin c0 wne cN cF cS cima cin c0 wne cN cF vs cv cima cin c0
      wne vn vs cN cS cA csn cJ cnei cfv cfv cL vn cv cN wceq vn cv cF vs cv
      cima cin cN cF vs cv cima cin c0 vn cv cN cF vs cv cima ineq1 neeq1d vs
      cv cS wceq cN cF vs cv cima cin cN cF cS cima cin c0 vs cv cS wceq cF vs
      cv cima cF cS cima cN vs cv cS cF imaeq2 ineq2d neeq1d rcla42v cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cA cF cJ cL cfclusf co cfv wcel cA cX
      wcel vn cv cF vs cv cima cin c0 wne vs cL wral vn cA csn cJ cnei cfv cfv
      wral cA vn cF cJ cL cX cY vs fclsfneii.1 fclsfneii.2 fclusfnei pm3.27bda
      syl5com exp4b 3imp2 $.
      $( [27-Nov-2009] $) $( [27-Nov-2009] $)
  $}

  ${
    flfssfcf.1 $e |- X = U. J $.
    flfssfcf.2 $e |- Y = U. L $.
    $( A limit point of a function is a cluster point of the function. $)
    flfssfcf $p |- ( ( J e. Top /\ L e. Fil /\ F : Y --> X ) -> ( ( J fLimf L )
    ` F ) C_ ( ( J fClusf L ) ` F ) ) $=
      cJ ctop wcel cL cfil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv cF cJ cL cflimf
      co cfv cF cJ cL cfclusf co cfv cJ ctop wcel cF cX cL cfilmap co cfv cfil
      wcel cX cF cX cL cfilmap co cfv cuni wceq cF cX cL cfilmap co cfv cJ
      cflim1 cfv cfv cF cX cL cfilmap co cfv cJ cfclus cfv cfv wss cJ ctop wcel
      cL cfil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cJ cX cF cX cL
      cfilmap co cfv cuni flfssfcf.1 cF cX cL cfilmap co cfv cuni eqid flimfcls
      cJ ctop wcel cL cfil wcel cY cX cF wf 3simp1 cX cvv wcel cL cfbas wcel cY
      cX cF wf cF cX cL cfilmap co cfv cfil wcel cJ ctop wcel cL cfil wcel cY
      cX cF wf cvv cL cF cX cY flfssfcf.2 fmf cJ ctop wcel cJ cuni cvv cX cJ
      ctop uniexg flfssfcf.1 syl5eqel cL filfbas cY cX cF wf id syl3an cJ ctop
      wcel cL cfil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cuni cX cX cvv
      wcel cL cfbas wcel cY cX cF wf cF cX cL cfilmap co cfv cuni cX wceq cJ
      ctop wcel cL cfil wcel cY cX cF wf cvv cL cF cX cY flfssfcf.2 fmbas cJ
      ctop wcel cJ cuni cvv cX cJ ctop uniexg flfssfcf.1 syl5eqel cL filfbas cY
      cX cF wf id syl3an eqcomd syl3anc cF cJ cL cX cY flfssfcf.1 flfssfcf.2
      sflimf cF cJ cL cX cY flfssfcf.1 flfssfcf.2 sfclusf 3sstr4d $.
      $( [28-Nov-2009] $) $( [28-Nov-2009] $)
  $}

  ${
    uffcfflf.1 $e |- X = U. J $.
    uffcfflf.2 $e |- Y = U. L $.
    $( If the domain filter is an ultrafilter, the cluster points of the
       function are the limit points. $)
    uffcfflf $p |- ( ( J e. Top /\ L e. UFil /\ F : Y --> X ) -> ( ( J fClusf L
    ) ` F ) = ( ( J fLimf L ) ` F ) ) $=
      cJ ctop wcel cL cufil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cJ
      cfclus cfv cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv cF cJ cL cfclusf
      co cfv cF cJ cL cflimf co cfv cJ ctop wcel cF cX cL cfilmap co cfv cufil
      wcel cX cF cX cL cfilmap co cfv cuni wceq cF cX cL cfilmap co cfv cJ
      cfclus cfv cfv cF cX cL cfilmap co cfv cJ cflim1 cfv cfv wceq cJ ctop
      wcel cL cufil wcel cY cX cF wf w3a cF cX cL cfilmap co cfv cJ cX cF cX cL
      cfilmap co cfv cuni uffcfflf.1 cF cX cL cfilmap co cfv cuni eqid
      uffclsflim cJ ctop wcel cL cufil wcel cY cX cF wf 3simp1 cX cvv wcel cL
      cufil wcel cY cX cF wf cF cX cL cfilmap co cfv cufil wcel cJ ctop wcel
      cvv cF cL cX cY uffcfflf.2 fmufil cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg uffcfflf.1 syl5eqel syl3an1 cJ ctop wcel cL cufil wcel cY cX cF wf
      w3a cF cX cL cfilmap co cfv cuni cX cX cvv wcel cL cfbas wcel cY cX cF wf
      cF cX cL cfilmap co cfv cuni cX wceq cJ ctop wcel cL cufil wcel cY cX cF
      wf w3a cvv cL cF cX cY uffcfflf.2 fmbas cJ ctop wcel cL cufil wcel cX cvv
      wcel cY cX cF wf cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg uffcfflf.1
      syl5eqel 3ad2ant1 cL cufil wcel cJ ctop wcel cL cfbas wcel cY cX cF wf cL
      cufil wcel cL cfil wcel cL cfbas wcel cL ufilfil cL filfbas syl 3ad2ant2
      cJ ctop wcel cL cufil wcel cY cX cF wf 3simp3 syl3anc eqcomd syl3anc cJ
      ctop wcel cL cfil wcel cY cX cF wf cF cJ cL cfclusf co cfv cF cX cL
      cfilmap co cfv cJ cfclus cfv cfv wceq cL cufil wcel cF cJ cL cX cY
      uffcfflf.1 uffcfflf.2 sfclusf cL ufilfil syl3an2 cJ ctop wcel cL cfil
      wcel cY cX cF wf cF cJ cL cflimf co cfv cF cX cL cfilmap co cfv cJ cflim1
      cfv cfv wceq cL cufil wcel cF cJ cL cX cY uffcfflf.1 uffcfflf.2 sflimf cL
      ufilfil syl3an2 3eqtr4d $.
      $( [12-Dec-2009] $) $( [12-Dec-2009] $)
  $}

  ${
    $d f A $. $d f F $. $d f J $. $d f K $. $d f X $. $d f Y $.
    fclsfcnp.1 $e |- X = U. J $.
    fclsfcnp.2 $e |- Y = U. K $.
    $( Continuity of a function at a point in terms of cluster points of a
       function. $)
    fclsfcnp $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X ) -> (
    F e. ( ( J CnP K ) ` A ) <-> A. f e. Fil ( ( X = U. f /\ A e. ( ( fClus ` J
    ) ` f ) ) -> ( F ` A ) e. ( ( K fClusf f ) ` F ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel wa cF cA cJ cK ccnp
      co cfv wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF
      cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel wi vf cfil wral cX
      vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cK vf cv
      cfclusf co cfv wcel wi vf cfil wral cA vf cF cJ cK cX cY fclsfcnp.1
      fclsfcnp.2 fcluscnp cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel
      wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv cF cK
      vf cv cfclusf co cfv wcel wi cX vf cv cuni wceq cA vf cv cJ cfclus cfv
      cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv wcel
      wi vf cfil cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel vf cv
      cfil wcel cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA cF cfv
      cF cK vf cv cfclusf co cfv wcel wi cX vf cv cuni wceq cA vf cv cJ cfclus
      cfv cfv wcel wa cA cF cfv cF cY vf cv cfilmap co cfv cK cfclus cfv cfv
      wcel wi wb cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel vf cv
      cfil wcel wa wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa cA
      cF cfv cF cK vf cv cfclusf co cfv wcel cA cF cfv cF cY vf cv cfilmap co
      cfv cK cfclus cfv cfv wcel cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA
      cX wcel vf cv cfil wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa cA cF cfv cF cK vf cv cfclusf co cfv wcel cA cF cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv wcel wb cJ ctop wcel cK ctop wcel cX cY
      cF wf w3a cA cX wcel vf cv cfil wcel wa cX vf cv cuni wceq cA vf cv cJ
      cfclus cfv cfv wcel wa wa wa cF cK vf cv cfclusf co cfv cF cY vf cv
      cfilmap co cfv cK cfclus cfv cfv cA cF cfv cK ctop wcel vf cv cfil wcel
      vf cv cuni cY cF wf cF cK vf cv cfclusf co cfv cF cY vf cv cfilmap co cfv
      cK cfclus cfv cfv wceq cJ ctop wcel cK ctop wcel cX cY cF wf w3a cA cX
      wcel vf cv cfil wcel wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa wa wa cF cK vf cv cY vf cv cuni fclsfcnp.2 vf cv cuni eqid
      sfclusf cJ ctop wcel cK ctop wcel cX cY cF wf cA cX wcel vf cv cfil wcel
      wa cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa wa 3simpl2 cJ
      ctop wcel cK ctop wcel cX cY cF wf w3a cA cX wcel vf cv cfil wcel cX vf
      cv cuni wceq cA vf cv cJ cfclus cfv cfv wcel wa simprlr cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cX vf cv cuni wceq cA vf cv cJ cfclus cfv cfv
      wcel wa vf cv cuni cY cF wf cA cX wcel vf cv cfil wcel wa cJ ctop wcel cK
      ctop wcel cX cY cF wf w3a cX vf cv cuni wceq vf cv cuni cY cF wf cA vf cv
      cJ cfclus cfv cfv wcel cX cY cF wf cJ ctop wcel cX vf cv cuni wceq vf cv
      cuni cY cF wf cK ctop wcel cX vf cv cuni wceq cX cY cF wf vf cv cuni cY
      cF wf cX vf cv cuni cY cF feq2 biimpac 3ad2antl3 adantrr adantrl syl3anc
      eleq2d expr pm5.74d anassrs ralbidva bitr4d $.
      $( [28-Nov-2009] $) $( [28-Nov-2009] $)
  $}

  ${
    $d f x F $. $d f x J $. $d f x K $. $d f x X $. $d f x Y $.
    fclsfcn.1 $e |- X = U. J $.
    fclsfcn.2 $e |- Y = U. K $.
    $( Continuity of a function in terms of cluster points of a function. $)
    fclsfcn $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) -> ( F e. ( J Cn K
    ) <-> A. f e. Fil ( X = U. f -> A. x e. X ( x e. ( ( fClus ` J ) ` f ) -> (
    F ` x ) e. ( ( K fClusf f ) ` F ) ) ) ) ) $=
      cJ ctop wcel cK ctop wcel cX cY cF wf w3a cF cJ cK ccn co wcel cF vx cv
      cJ cK ccnp co cfv wcel vx cX wral cX vf cv cuni wceq vx cv vf cv cJ
      cfclus cfv cfv wcel vx cv cF cfv cF cK vf cv cfclusf co cfv wcel wi vx cX
      wral wi vf cfil wral vx cF cJ cK cX cY fclsfcn.1 fclsfcn.2 cncnp cJ ctop
      wcel cK ctop wcel cX cY cF wf w3a cF vx cv cJ cK ccnp co cfv wcel vx cX
      wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel wa vx cv cF
      cfv cF cK vf cv cfclusf co cfv wcel wi vf cfil wral vx cX wral cX vf cv
      cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv cF cfv cF cK vf cv
      cfclusf co cfv wcel wi vx cX wral wi vf cfil wral cJ ctop wcel cK ctop
      wcel cX cY cF wf w3a cF vx cv cJ cK ccnp co cfv wcel cX vf cv cuni wceq
      vx cv vf cv cJ cfclus cfv cfv wcel wa vx cv cF cfv cF cK vf cv cfclusf co
      cfv wcel wi vf cfil wral vx cX vx cv vf cF cJ cK cX cY fclsfcn.1
      fclsfcn.2 fclsfcnp ralbidva cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv
      cfv wcel wa vx cv cF cfv cF cK vf cv cfclusf co cfv wcel wi vf cfil wral
      vx cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel wa vx cv
      cF cfv cF cK vf cv cfclusf co cfv wcel wi vx cX wral vf cfil wral cX vf
      cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv cF cfv cF cK vf cv
      cfclusf co cfv wcel wi vx cX wral wi vf cfil wral cX vf cv cuni wceq vx
      cv vf cv cJ cfclus cfv cfv wcel wa vx cv cF cfv cF cK vf cv cfclusf co
      cfv wcel wi vx vf cX cfil ralcom cX vf cv cuni wceq vx cv vf cv cJ cfclus
      cfv cfv wcel wa vx cv cF cfv cF cK vf cv cfclusf co cfv wcel wi vx cX
      wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv cF cfv
      cF cK vf cv cfclusf co cfv wcel wi vx cX wral wi vf cfil cX vf cv cuni
      wceq vx cv vf cv cJ cfclus cfv cfv wcel wa vx cv cF cfv cF cK vf cv
      cfclusf co cfv wcel wi vx cX wral cX vf cv cuni wceq vx cv vf cv cJ
      cfclus cfv cfv wcel vx cv cF cfv cF cK vf cv cfclusf co cfv wcel wi wi vx
      cX wral cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv cF
      cfv cF cK vf cv cfclusf co cfv wcel wi vx cX wral wi cX vf cv cuni wceq
      vx cv vf cv cJ cfclus cfv cfv wcel wa vx cv cF cfv cF cK vf cv cfclusf co
      cfv wcel wi cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel vx cv
      cF cfv cF cK vf cv cfclusf co cfv wcel wi wi vx cX cX vf cv cuni wceq vx
      cv vf cv cJ cfclus cfv cfv wcel vx cv cF cfv cF cK vf cv cfclusf co cfv
      wcel impexp ralbii cX vf cv cuni wceq vx cv vf cv cJ cfclus cfv cfv wcel
      vx cv cF cfv cF cK vf cv cfclusf co cfv wcel wi vx cX r19.21v bitri
      ralbii bitri syl6bb bitrd $.
      $( [28-Nov-2009] $) $( [28-Nov-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Directed sets, nets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$c Dir $.
  $( Extend class notation with the class of all directed sets. $)
  cdir $a class Dir $.

$c tail $.
  $( Extend class notation with the tail function. $)
  ctail $a class tail $.

  ${
    $d d x y z $.
    $( Define the class of all directed sets/directions. $)
    df-dir $a |- Dir = { d | ( ( Rel d /\ ( _I |` U. U. d ) C_ d )
    /\ ( ( d o. d ) C_ d /\ A. x e. U. U. d A. y e. U. U. d
           E. z e. U. U. d ( x d z /\ y d z ) ) ) } $.
  $}

  ${
    $d t w x y z $.
    $( Define the tail function for directed sets. $)
    df-tail $a |- tail = { <. x , y >. | ( x e. Dir /\ y = { <. z , w >. | ( z
    e. U. U. x /\ w = { t | z x t } ) } ) } $.
  $}

  ${
    $d d x y z A $. $d d B $. $d d x y z D $.
    isdir.1 $e |- A = U. U. D $.
    $( A condition for a relation to be a direction. $)
    isdir $p |- ( D e. B -> ( D e. Dir <-> ( ( Rel D /\ ( _I |` A ) C_ D ) /\ (
    ( D o. D ) C_ D /\ A. x e. A A. y e. A E. z e. A ( x D z /\ y D z ) ) ) ) )
    $=
      vd cv wrel cid vd cv cuni cuni cres vd cv wss wa vd cv vd cv ccom vd cv
      wss vx cv vz cv vd cv wbr vy cv vz cv vd cv wbr wa vz vd cv cuni cuni
      wrex vy vd cv cuni cuni wral vx vd cv cuni cuni wral wa wa cD wrel cid cA
      cres cD wss wa cD cD ccom cD wss vx cv vz cv cD wbr vy cv vz cv cD wbr wa
      vz cA wrex vy cA wral vx cA wral wa wa vd cD cdir cB vd cv cD wceq vd cv
      wrel cid vd cv cuni cuni cres vd cv wss wa cD wrel cid cA cres cD wss wa
      vd cv vd cv ccom vd cv wss vx cv vz cv vd cv wbr vy cv vz cv vd cv wbr wa
      vz vd cv cuni cuni wrex vy vd cv cuni cuni wral vx vd cv cuni cuni wral
      wa cD cD ccom cD wss vx cv vz cv cD wbr vy cv vz cv cD wbr wa vz cA wrex
      vy cA wral vx cA wral wa vd cv cD wceq vd cv wrel cD wrel cid vd cv cuni
      cuni cres vd cv wss cid cA cres cD wss vd cv cD releq vd cv cD wceq cid
      vd cv cuni cuni cres cid cA cres vd cv cD vd cv cD wceq vd cv cuni cuni
      cA wceq cid vd cv cuni cuni cres cid cA cres wceq vd cv cD wceq vd cv
      cuni cuni cD cuni cuni cA vd cv cD wceq vd cv cuni cD cuni vd cv cD unieq
      unieqd isdir.1 syl6eqr vd cv cuni cuni cA cid reseq2 syl vd cv cD wceq id
      sseq12d anbi12d vd cv cD wceq vd cv vd cv ccom vd cv wss cD cD ccom cD
      wss vx cv vz cv vd cv wbr vy cv vz cv vd cv wbr wa vz vd cv cuni cuni
      wrex vy vd cv cuni cuni wral vx vd cv cuni cuni wral vx cv vz cv cD wbr
      vy cv vz cv cD wbr wa vz cA wrex vy cA wral vx cA wral vd cv cD wceq vd
      cv vd cv ccom cD cD ccom vd cv cD vd cv cD wceq vd cv vd cv ccom cD vd cv
      ccom cD cD ccom vd cv cD vd cv coeq1 vd cv cD cD coeq2 eqtrd vd cv cD
      wceq id sseq12d vd cv cD wceq vx cv vz cv vd cv wbr vy cv vz cv vd cv wbr
      wa vz vd cv cuni cuni wrex vy vd cv cuni cuni wral vx cv vz cv cD wbr vy
      cv vz cv cD wbr wa vz cA wrex vy cA wral vx vd cv cuni cuni cA vd cv cD
      wceq vd cv cuni cuni cD cuni cuni cA vd cv cD wceq vd cv cuni cD cuni vd
      cv cD unieq unieqd isdir.1 syl6eqr vd cv cD wceq vx cv vz cv vd cv wbr vy
      cv vz cv vd cv wbr wa vz vd cv cuni cuni wrex vx cv vz cv cD wbr vy cv vz
      cv cD wbr wa vz cA wrex vy vd cv cuni cuni cA vd cv cD wceq vd cv cuni
      cuni cD cuni cuni cA vd cv cD wceq vd cv cuni cD cuni vd cv cD unieq
      unieqd isdir.1 syl6eqr vd cv cD wceq vx cv vz cv vd cv wbr vy cv vz cv vd
      cv wbr wa vx cv vz cv cD wbr vy cv vz cv cD wbr wa vz vd cv cuni cuni cA
      vd cv cD wceq vd cv cuni cuni cD cuni cuni cA vd cv cD wceq vd cv cuni cD
      cuni vd cv cD unieq unieqd isdir.1 syl6eqr vd cv cD wceq vx cv vz cv vd
      cv wbr vx cv vz cv cD wbr vy cv vz cv vd cv wbr vy cv vz cv cD wbr vx cv
      vz cv vd cv cD breq vy cv vz cv vd cv cD breq anbi12d rexeq12d raleq12d
      raleq12d anbi12d anbi12d vx vy vz vd df-dir elab2g $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x y z D $.
    $( A direction is a relation. $)
    reldir $p |- ( D e. Dir -> Rel D ) $=
      cD cdir wcel cD wrel cid cD cuni cuni cres cD wss cD cdir wcel cD wrel
      cid cD cuni cuni cres cD wss wa cD cD ccom cD wss vx cv vz cv cD wbr vy
      cv vz cv cD wbr wa vz cD cuni cuni wrex vy cD cuni cuni wral vx cD cuni
      cuni wral wa cD cdir wcel cD wrel cid cD cuni cuni cres cD wss wa cD cD
      ccom cD wss vx cv vz cv cD wbr vy cv vz cv cD wbr wa vz cD cuni cuni wrex
      vy cD cuni cuni wral vx cD cuni cuni wral wa wa vx vy vz cD cuni cuni
      cdir cD cD cuni cuni eqid isdir ibi pm3.26d pm3.26d $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x y z D $.
    $( A direction's domain is equal to its field. $)
    dirdm $p |- ( D e. Dir -> dom D = U. U. D ) $=
      cD cdir wcel cD cdm cD cuni cuni cD cdm cD cuni cuni wss cD cdir wcel cD
      cdm cD cdm cD crn cun cD cuni cuni cD cdm cD crn ssun1 cD dmrnssfld sstri
      a1i cD cdir wcel cid cD cuni cuni cres cD wss cD cuni cuni cD cdm wss cD
      cdir wcel cD wrel cid cD cuni cuni cres cD wss cD cdir wcel cD wrel cid
      cD cuni cuni cres cD wss wa cD cD ccom cD wss vx cv vz cv cD wbr vy cv vz
      cv cD wbr wa vz cD cuni cuni wrex vy cD cuni cuni wral vx cD cuni cuni
      wral wa cD cdir wcel cD wrel cid cD cuni cuni cres cD wss wa cD cD ccom
      cD wss vx cv vz cv cD wbr vy cv vz cv cD wbr wa vz cD cuni cuni wrex vy
      cD cuni cuni wral vx cD cuni cuni wral wa wa vx vy vz cD cuni cuni cdir
      cD cD cuni cuni eqid isdir ibi pm3.26d pm3.27d cid cD cuni cuni cres cD
      wss cid cD cuni cuni cres cdm cD cdm cD cuni cuni cid cD cuni cuni cres
      cD dmss cD cuni cuni dmresi syl5ssr syl eqssd $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x y z A $. $d x y z D $. $d x y z X $.
    dirref.1 $e |- X = dom D $.
    $( A direction is reflexive. $)
    dirref $p |- ( ( D e. Dir /\ A e. X ) -> A D A ) $=
      cD cdir wcel cA cX wcel wa cA cA cid cX cres wbr cA cA cD wbr cA cX wcel
      cA cA cid cX cres wbr cD cdir wcel cA cX wcel cA cA cid cX cres wbr cA cX
      wcel cA cX wcel wa cA cA cid cX cres wbr cA cA wceq cA eqid cX cA cA
      resieq mpbiri anidms adantl cD cdir wcel cA cX wcel wa cid cX cres cD cA
      cA cD cdir wcel cid cX cres cD wss cA cX wcel cD cdir wcel cid cX cres
      cid cD cuni cuni cres cD cD cdir wcel cX cD cuni cuni wceq cid cX cres
      cid cD cuni cuni cres wceq cD cdir wcel cD cdm cD cuni cuni cX cD dirdm
      dirref.1 syl5eq cX cD cuni cuni cid reseq2 syl cD cdir wcel cD wrel cid
      cD cuni cuni cres cD wss cD cdir wcel cD wrel cid cD cuni cuni cres cD
      wss wa cD cD ccom cD wss vx cv vz cv cD wbr vy cv vz cv cD wbr wa vz cD
      cuni cuni wrex vy cD cuni cuni wral vx cD cuni cuni wral wa cD cdir wcel
      cD wrel cid cD cuni cuni cres cD wss wa cD cD ccom cD wss vx cv vz cv cD
      wbr vy cv vz cv cD wbr wa vz cD cuni cuni wrex vy cD cuni cuni wral vx cD
      cuni cuni wral wa wa vx vy vz cD cuni cuni cdir cD cD cuni cuni eqid
      isdir ibi pm3.26d pm3.27d eqsstrd adantr ssbrd mpd $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z C $. $d x y z D $. $d x y z H $.
    $( A direction is transitive. $)
    dirtr $p |- ( ( ( D e. Dir /\ C e. H ) /\ ( A D B /\ B D C ) )
               -> A D C ) $=
      cD cdir wcel cC cH wcel wa cA cB cD wbr cB cC cD wbr wa wa cA cvv wcel cB
      cvv wcel cA cC cD wbr cD cdir wcel cA cB cD wbr cA cvv wcel cC cH wcel cB
      cC cD wbr cD wrel cA cB cD wbr cA cvv wcel cD cdir wcel cA cB cD brrelex
      cD reldir sylan ad2ant2r cD cdir wcel cB cC cD wbr cB cvv wcel cC cH wcel
      cA cB cD wbr cD wrel cB cC cD wbr cB cvv wcel cD cdir wcel cB cC cD
      brrelex cD reldir sylan ad2ant2rl cD cdir wcel cC cH wcel wa cA cB cD wbr
      cB cC cD wbr wa cA cvv wcel cB cvv wcel wa cA cC cD wbr wi cD cdir wcel
      cC cH wcel wa cA cvv wcel cB cvv wcel wa cA cB cD wbr cB cC cD wbr wa cA
      cC cD wbr cD cdir wcel cC cH wcel wa cA cvv wcel cB cvv wcel wa cA cB cD
      wbr cB cC cD wbr wa cA cC cD wbr wi cD cdir wcel cC cH wcel wa cA cvv
      wcel cB cvv wcel wa wa cA cB cD wbr cB vz cv cD wbr wa cA vz cv cD wbr wi
      vz wal cA cB cD wbr cB cC cD wbr wa cA cC cD wbr wi cD cdir wcel cC cH
      wcel wa cA cvv wcel cB cvv wcel wa wa cA vy cv cD wbr vy cv vz cv cD wbr
      wa cA vz cv cD wbr wi vz wal vy wal cA cB cD wbr cB vz cv cD wbr wa cA vz
      cv cD wbr wi vz wal cD cdir wcel cC cH wcel wa cA cvv wcel cB cvv wcel wa
      wa vx cv vy cv cD wbr vy cv vz cv cD wbr wa vx cv vz cv cD wbr wi vz wal
      vy wal vx wal cA vy cv cD wbr vy cv vz cv cD wbr wa cA vz cv cD wbr wi vz
      wal vy wal cD cdir wcel cC cH wcel wa cA cvv wcel cB cvv wcel wa wa cD cD
      ccom cD wss vx cv vy cv cD wbr vy cv vz cv cD wbr wa vx cv vz cv cD wbr
      wi vz wal vy wal vx wal cD cdir wcel cD cD ccom cD wss cC cH wcel cA cvv
      wcel cB cvv wcel wa cD cdir wcel cD cD ccom cD wss vx cv vz cv cD wbr vy
      cv vz cv cD wbr wa vz cD cuni cuni wrex vy cD cuni cuni wral vx cD cuni
      cuni wral cD cdir wcel cD wrel cid cD cuni cuni cres cD wss wa cD cD ccom
      cD wss vx cv vz cv cD wbr vy cv vz cv cD wbr wa vz cD cuni cuni wrex vy
      cD cuni cuni wral vx cD cuni cuni wral wa cD cdir wcel cD wrel cid cD
      cuni cuni cres cD wss wa cD cD ccom cD wss vx cv vz cv cD wbr vy cv vz cv
      cD wbr wa vz cD cuni cuni wrex vy cD cuni cuni wral vx cD cuni cuni wral
      wa wa vx vy vz cD cuni cuni cdir cD cD cuni cuni eqid isdir ibi pm3.27d
      pm3.26d ad2antrr vx vy vz cD cotr sylib cA cvv wcel vx cv vy cv cD wbr vy
      cv vz cv cD wbr wa vx cv vz cv cD wbr wi vz wal vy wal vx wal cA vy cv cD
      wbr vy cv vz cv cD wbr wa cA vz cv cD wbr wi vz wal vy wal wi cD cdir
      wcel cC cH wcel wa cB cvv wcel vx cv vy cv cD wbr vy cv vz cv cD wbr wa
      vx cv vz cv cD wbr wi vz wal vy wal cA vy cv cD wbr vy cv vz cv cD wbr wa
      cA vz cv cD wbr wi vz wal vy wal vx cA cvv vx cv cA wceq vx cv vy cv cD
      wbr vy cv vz cv cD wbr wa vx cv vz cv cD wbr wi cA vy cv cD wbr vy cv vz
      cv cD wbr wa cA vz cv cD wbr wi vy vz vx cv cA wceq vx cv vy cv cD wbr vy
      cv vz cv cD wbr wa cA vy cv cD wbr vy cv vz cv cD wbr wa vx cv vz cv cD
      wbr cA vz cv cD wbr vx cv cA wceq vx cv vy cv cD wbr cA vy cv cD wbr vy
      cv vz cv cD wbr vx cv cA vy cv cD breq1 anbi1d vx cv cA vz cv cD breq1
      imbi12d 2albidv cla4gv ad2antrl mpd cB cvv wcel cA vy cv cD wbr vy cv vz
      cv cD wbr wa cA vz cv cD wbr wi vz wal vy wal cA cB cD wbr cB vz cv cD
      wbr wa cA vz cv cD wbr wi vz wal wi cD cdir wcel cC cH wcel wa cA cvv
      wcel cA vy cv cD wbr vy cv vz cv cD wbr wa cA vz cv cD wbr wi vz wal cA
      cB cD wbr cB vz cv cD wbr wa cA vz cv cD wbr wi vz wal vy cB cvv vy cv cB
      wceq cA vy cv cD wbr vy cv vz cv cD wbr wa cA vz cv cD wbr wi cA cB cD
      wbr cB vz cv cD wbr wa cA vz cv cD wbr wi vz vy cv cB wceq cA vy cv cD
      wbr vy cv vz cv cD wbr wa cA cB cD wbr cB vz cv cD wbr wa cA vz cv cD wbr
      vy cv cB wceq cA vy cv cD wbr cA cB cD wbr vy cv vz cv cD wbr cB vz cv cD
      wbr vy cv cB cA cD breq2 vy cv cB vz cv cD breq1 anbi12d imbi1d albidv
      cla4gv ad2antll mpd cC cH wcel cA cB cD wbr cB vz cv cD wbr wa cA vz cv
      cD wbr wi vz wal cA cB cD wbr cB cC cD wbr wa cA cC cD wbr wi wi cD cdir
      wcel cA cvv wcel cB cvv wcel wa cA cB cD wbr cB vz cv cD wbr wa cA vz cv
      cD wbr wi cA cB cD wbr cB cC cD wbr wa cA cC cD wbr wi vz cC cH vz cv cC
      wceq cA cB cD wbr cB vz cv cD wbr wa cA cB cD wbr cB cC cD wbr wa cA vz
      cv cD wbr cA cC cD wbr vz cv cC wceq cB vz cv cD wbr cB cC cD wbr cA cB
      cD wbr vz cv cC cB cD breq2 anbi2d vz cv cC cA cD breq2 imbi12d cla4gv
      ad2antlr mpd ex com23 imp mp2and $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x y z A $. $d x y z B $. $d x y z D $. $d x y z X $.
    dirge.1 $e |- X = dom D $.
    $( For any two elements of a directed set, there exists a third element
       greater than or equal to both. (Note that this does not say that the two
       elements have a _least_ upper bound.) $)
    dirge $p |- ( ( D e. Dir /\ A e. X /\ B e. X ) -> E. x e. X ( A D x /\ B D
    x ) ) $=
      cD cdir wcel cA cX wcel cB cX wcel cA vx cv cD wbr cB vx cv cD wbr wa vx
      cX wrex cD cdir wcel cA cD cuni cuni wcel cB cD cuni cuni wcel wa cA vx
      cv cD wbr cB vx cv cD wbr wa vx cD cuni cuni wrex cA cX wcel cB cX wcel
      wa cA vx cv cD wbr cB vx cv cD wbr wa vx cX wrex cA cD cuni cuni wcel cB
      cD cuni cuni wcel wa vy cv vx cv cD wbr vz cv vx cv cD wbr wa vx cD cuni
      cuni wrex vz cD cuni cuni wral vy cD cuni cuni wral cA vx cv cD wbr cB vx
      cv cD wbr wa vx cD cuni cuni wrex cD cdir wcel vy cv vx cv cD wbr vz cv
      vx cv cD wbr wa vx cD cuni cuni wrex cA vx cv cD wbr cB vx cv cD wbr wa
      vx cD cuni cuni wrex cA vx cv cD wbr vz cv vx cv cD wbr wa vx cD cuni
      cuni wrex vy vz cA cB cD cuni cuni cD cuni cuni vy cv cA wceq vy cv vx cv
      cD wbr vz cv vx cv cD wbr wa cA vx cv cD wbr vz cv vx cv cD wbr wa vx cD
      cuni cuni vy cv cA wceq vy cv vx cv cD wbr cA vx cv cD wbr vz cv vx cv cD
      wbr vy cv cA vx cv cD breq1 anbi1d rexbidv vz cv cB wceq cA vx cv cD wbr
      vz cv vx cv cD wbr wa cA vx cv cD wbr cB vx cv cD wbr wa vx cD cuni cuni
      vz cv cB wceq vz cv vx cv cD wbr cB vx cv cD wbr cA vx cv cD wbr vz cv cB
      vx cv cD breq1 anbi2d rexbidv rcla42v cD cdir wcel cD cD ccom cD wss vy
      cv vx cv cD wbr vz cv vx cv cD wbr wa vx cD cuni cuni wrex vz cD cuni
      cuni wral vy cD cuni cuni wral cD cdir wcel cD wrel cid cD cuni cuni cres
      cD wss wa cD cD ccom cD wss vy cv vx cv cD wbr vz cv vx cv cD wbr wa vx
      cD cuni cuni wrex vz cD cuni cuni wral vy cD cuni cuni wral wa cD cdir
      wcel cD wrel cid cD cuni cuni cres cD wss wa cD cD ccom cD wss vy cv vx
      cv cD wbr vz cv vx cv cD wbr wa vx cD cuni cuni wrex vz cD cuni cuni wral
      vy cD cuni cuni wral wa wa vy vz vx cD cuni cuni cdir cD cD cuni cuni
      eqid isdir ibi pm3.27d pm3.27d syl5com cD cdir wcel cA cX wcel cA cD cuni
      cuni wcel cB cX wcel cB cD cuni cuni wcel cD cdir wcel cX cD cuni cuni cA
      cD cdir wcel cD cdm cD cuni cuni cX cD dirdm dirge.1 syl5eq eleq2d cD
      cdir wcel cX cD cuni cuni cB cD cdir wcel cD cdm cD cuni cuni cX cD dirdm
      dirge.1 syl5eq eleq2d anbi12d cD cdir wcel cA vx cv cD wbr cB vx cv cD
      wbr wa vx cX cD cuni cuni cD cdir wcel cD cdm cD cuni cuni cX cD dirdm
      dirge.1 syl5eq rexeq1d 3imtr4d 3impib $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d t x y z $.
    $( A totally ordered set is a directed set. $)
    tosdir $p |- Toset C_ Dir $=
      vt ccha cdir vt cv cps wcel vx cv vy cv vt cv wbr vy cv vx cv vt cv wbr
      wo vy vt cv cuni cuni wral vx vt cv cuni cuni wral wa vt cv wrel cid vt
      cv cuni cuni cres vt cv wss wa vt cv vt cv ccom vt cv wss vx cv vz cv vt
      cv wbr vy cv vz cv vt cv wbr wa vz vt cv cuni cuni wrex vy vt cv cuni
      cuni wral vx vt cv cuni cuni wral wa wa vt cv ccha wcel vt cv cdir wcel
      vt cv cps wcel vx cv vy cv vt cv wbr vy cv vx cv vt cv wbr wo vy vt cv
      cuni cuni wral vx vt cv cuni cuni wral wa vt cv wrel cid vt cv cuni cuni
      cres vt cv wss wa vt cv vt cv ccom vt cv wss vx cv vz cv vt cv wbr vy cv
      vz cv vt cv wbr wa vz vt cv cuni cuni wrex vy vt cv cuni cuni wral vx vt
      cv cuni cuni wral vt cv cps wcel vt cv wrel cid vt cv cuni cuni cres vt
      cv wss wa vx cv vy cv vt cv wbr vy cv vx cv vt cv wbr wo vy vt cv cuni
      cuni wral vx vt cv cuni cuni wral vt cv cps wcel vt cv wrel cid vt cv
      cuni cuni cres vt cv wss vt cv psrel vt cv cps wcel cid vt cv cuni cuni
      cres vt cv vt cv ccnv cin vt cv vt cv posanref vt cv vt cv ccnv cin vt cv
      wss vt cv cps wcel vt cv vt cv ccnv inss1 a1i eqsstr3d jca adantr vt cv
      cps wcel vt cv vt cv ccom vt cv wss vx cv vy cv vt cv wbr vy cv vx cv vt
      cv wbr wo vy vt cv cuni cuni wral vx vt cv cuni cuni wral vt cv postr
      adantr vt cv cps wcel vx cv vy cv vt cv wbr vy cv vx cv vt cv wbr wo vy
      vt cv cuni cuni wral vx vt cv cuni cuni wral vx cv vz cv vt cv wbr vy cv
      vz cv vt cv wbr wa vz vt cv cuni cuni wrex vy vt cv cuni cuni wral vx vt
      cv cuni cuni wral vt cv cps wcel vx cv vy cv vt cv wbr vy cv vx cv vt cv
      wbr wo vy vt cv cuni cuni wral vx cv vz cv vt cv wbr vy cv vz cv vt cv
      wbr wa vz vt cv cuni cuni wrex vy vt cv cuni cuni wral vx vt cv cuni cuni
      vt cv cps wcel vx cv vt cv cuni cuni wcel wa vx cv vy cv vt cv wbr vy cv
      vx cv vt cv wbr wo vx cv vz cv vt cv wbr vy cv vz cv vt cv wbr wa vz vt
      cv cuni cuni wrex vy vt cv cuni cuni vt cv cps wcel vx cv vt cv cuni cuni
      wcel wa vy cv vt cv cuni cuni wcel wa vx cv vy cv vt cv wbr vx cv vz cv
      vt cv wbr vy cv vz cv vt cv wbr wa vz vt cv cuni cuni wrex vy cv vx cv vt
      cv wbr vt cv cps wcel vx cv vt cv cuni cuni wcel wa vy cv vt cv cuni cuni
      wcel vx cv vy cv vt cv wbr vx cv vz cv vt cv wbr vy cv vz cv vt cv wbr wa
      vz vt cv cuni cuni wrex vy cv vt cv cuni cuni wcel vx cv vy cv vt cv wbr
      vy cv vy cv vt cv wbr vx cv vz cv vt cv wbr vy cv vz cv vt cv wbr wa vz
      vt cv cuni cuni wrex vt cv cps wcel vx cv vt cv cuni cuni wcel wa vy cv
      vt cv cuni cuni wcel vx cv vy cv vt cv wbr wa wa vt cv cps wcel vx cv vt
      cv cuni cuni wcel wa vy cv vt cv cuni cuni wcel vx cv vy cv vt cv wbr
      simprl vt cv cps wcel vx cv vt cv cuni cuni wcel wa vy cv vt cv cuni cuni
      wcel vx cv vy cv vt cv wbr simprr vt cv cps wcel vy cv vt cv cuni cuni
      wcel vy cv vy cv vt cv wbr vx cv vt cv cuni cuni wcel vx cv vy cv vt cv
      wbr vt cv cps wcel vy cv vt cv cuni cuni wcel vy cv vt cv cdm wcel vy cv
      vy cv vt cv wbr vt cv cps wcel vy cv vt cv cdm wcel vy cv vt cv cuni cuni
      wcel vt cv cps wcel vt cv cdm vt cv cuni cuni vy cv vt cv cps wcel vt cv
      cdm vt cv cuni cuni wceq vt cv crn vt cv cuni cuni wceq vt cv psdmrn
      pm3.26d eleq2d biimpar vy cv vt cv vt cv cdm vt cv cdm eqid psref syldan
      ad2ant2r vx cv vz cv vt cv wbr vy cv vz cv vt cv wbr wa vx cv vy cv vt cv
      wbr vy cv vy cv vt cv wbr wa vz vy cv vt cv cuni cuni vz cv vy cv wceq vx
      cv vz cv vt cv wbr vx cv vy cv vt cv wbr vy cv vz cv vt cv wbr vy cv vy
      cv vt cv wbr vz cv vy cv vx cv vt cv breq2 vz cv vy cv vy cv vt cv breq2
      anbi12d rcla4ev sylan32c expr vt cv cps wcel vx cv vt cv cuni cuni wcel
      wa vy cv vt cv cuni cuni wcel vy cv vx cv vt cv wbr vx cv vz cv vt cv wbr
      vy cv vz cv vt cv wbr wa vz vt cv cuni cuni wrex vx cv vt cv cuni cuni
      wcel vx cv vx cv vt cv wbr vy cv vx cv vt cv wbr vx cv vz cv vt cv wbr vy
      cv vz cv vt cv wbr wa vz vt cv cuni cuni wrex vt cv cps wcel vx cv vt cv
      cuni cuni wcel wa vy cv vt cv cuni cuni wcel vy cv vx cv vt cv wbr wa wa
      vt cv cps wcel vx cv vt cv cuni cuni wcel vy cv vt cv cuni cuni wcel vy
      cv vx cv vt cv wbr wa simplr vt cv cps wcel vx cv vt cv cuni cuni wcel wa
      vx cv vx cv vt cv wbr vy cv vt cv cuni cuni wcel vy cv vx cv vt cv wbr wa
      vt cv cps wcel vx cv vt cv cuni cuni wcel vx cv vt cv cdm wcel vx cv vx
      cv vt cv wbr vt cv cps wcel vx cv vt cv cdm wcel vx cv vt cv cuni cuni
      wcel vt cv cps wcel vt cv cdm vt cv cuni cuni vx cv vt cv cps wcel vt cv
      cdm vt cv cuni cuni wceq vt cv crn vt cv cuni cuni wceq vt cv psdmrn
      pm3.26d eleq2d biimpar vx cv vt cv vt cv cdm vt cv cdm eqid psref syldan
      adantr vt cv cps wcel vx cv vt cv cuni cuni wcel wa vy cv vt cv cuni cuni
      wcel vy cv vx cv vt cv wbr simprr vx cv vz cv vt cv wbr vy cv vz cv vt cv
      wbr wa vx cv vx cv vt cv wbr vy cv vx cv vt cv wbr wa vz vx cv vt cv cuni
      cuni vz cv vx cv wceq vx cv vz cv vt cv wbr vx cv vx cv vt cv wbr vy cv
      vz cv vt cv wbr vy cv vx cv vt cv wbr vz cv vx cv vx cv vt cv breq2 vz cv
      vx cv vy cv vt cv breq2 anbi12d rcla4ev sylan32c expr jaod r19.20dva
      r19.20dva imp jca32 vt cv cvv wcel vt cv ccha wcel vt cv cps wcel vx cv
      vy cv vt cv wbr vy cv vx cv vt cv wbr wo vy vt cv cuni cuni wral vx vt cv
      cuni cuni wral wa wb vt visset vx vy cvv vt cv vt cv cuni cuni vt cv cuni
      cuni eqid istoset ax-mp vt cv cvv wcel vt cv cdir wcel vt cv wrel cid vt
      cv cuni cuni cres vt cv wss wa vt cv vt cv ccom vt cv wss vx cv vz cv vt
      cv wbr vy cv vz cv vt cv wbr wa vz vt cv cuni cuni wrex vy vt cv cuni
      cuni wral vx vt cv cuni cuni wral wa wa wb vt visset vx vy vz vt cv cuni
      cuni cvv vt cv vt cv cuni cuni eqid isdir ax-mp 3imtr4i ssriv $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d t w x y z D $. $d t w x y X $. $d t w x y z $.
    tailf.1 $e |- X = dom D $.
    $( The tail function for a directed set. $)
    tailf $p |- ( D e. Dir -> ( tail ` D ) = { <. x , y >. | ( x e. X /\ y = {
    z | x D z } ) } ) $=
      cD cdir wcel cD vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx
      cv vz cv vw cv wbr vz cab wceq wa vx vy copab wceq wa vw vt copab cfv vx
      cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cD ctail
      cfv vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cvv
      wcel vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv
      vw cv wbr vz cab wceq wa vx vy copab wceq wa vw vt copab wfun wa cD vx cv
      cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cop vw cv
      cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz
      cab wceq wa vx vy copab wceq wa vw vt copab wcel cD vw cv cdir wcel vt cv
      vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx
      vy copab wceq wa vw vt copab cfv vx cv cX wcel vy cv vx cv vz cv cD wbr
      vz cab wceq wa vx vy copab wceq cD cdir wcel cD vx cv cX wcel vy cv vx cv
      vz cv cD wbr vz cab wceq wa vx vy copab cvv vw cv cdir wcel vt cv vx cv
      vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy
      copab wceq wa vw vt copab funopfvg cD cdir wcel vx cv cX wcel vy cv vx cv
      vz cv cD wbr vz cab wceq wa vx vy copab cvv wcel vw cv cdir wcel vt cv vx
      cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy
      copab wceq wa vw vt copab wfun vx cv cX wcel vy cv vx cv vz cv cD wbr vz
      cab wceq wa vx vy copab cX wfn cX cvv wcel vx cv cX wcel vy cv vx cv vz
      cv cD wbr vz cab wceq wa vx vy copab cvv wcel cD cdir wcel cX cvv vx cv
      cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab fnex cD cdir
      wcel vx cv vz cv cD wbr vz cab cvv wcel vx cX wral vx cv cX wcel vy cv vx
      cv vz cv cD wbr vz cab wceq wa vx vy copab cX wfn cD cdir wcel vx cv vz
      cv cD wbr vz cab cvv wcel vx cX cD cdir wcel vx cv vz cv cD wbr vz cab
      cvv wcel vx cv cX wcel cD cdir wcel cD cuni cvv wcel cD cuni cuni cvv
      wcel vx cv vz cv cD wbr vz cab cvv wcel cD cdir uniexg cD cuni cvv uniexg
      vx cv vz cv cD wbr vz cab cD cuni cuni wss cD cuni cuni cvv wcel vx cv vz
      cv cD wbr vz cab cvv wcel vx cv vz cv cD wbr vz cD cuni cuni vx cv vz cv
      cD wbr cD crn cD cuni cuni vz cv cD crn cD cuni cuni wss vx cv vz cv cD
      wbr cD crn cD cdm cD crn cun cD cuni cuni cD crn cD cdm ssun2 cD
      dmrnssfld sstri a1i vx cv vz cv cD vx visset vz visset brelrn sseldd
      abssi vx cv vz cv cD wbr vz cab cD cuni cuni cvv ssexg mpan 3syl adantr
      r19.21aiva vx vy cX vx cv vz cv cD wbr vz cab vx cv cX wcel vy cv vx cv
      vz cv cD wbr vz cab wceq wa vx vy copab vx cv cX wcel vy cv vx cv vz cv
      cD wbr vz cab wceq wa vx vy copab eqid fnopab2g sylib cD cdir wcel cD cdm
      cvv cX cD cdir dmexg tailf.1 syl5eqel sylanc vw cv cdir wcel vt cv vx cv
      vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy
      copab wceq wa vw vt copab vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz
      cv vw cv wbr vz cab wceq wa vx vy copab wceq vw vt copab wss vt cv vx cv
      vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy
      copab wceq vw vt copab wfun vw cv cdir wcel vt cv vx cv vw cv cuni cuni
      wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy copab wceq wa vw vt
      copab wfun vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv
      vz cv vw cv wbr vz cab wceq wa vx vy copab wceq wa vt cv vx cv vw cv cuni
      cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy copab wceq vw
      vt vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw
      cv wbr vz cab wceq wa vx vy copab wceq pm3.27 ssopab2i vw vt vx cv vw cv
      cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy copab
      funopabeq vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz
      cv vw cv wbr vz cab wceq wa vx vy copab wceq wa vw vt copab vt cv vx cv
      vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx vy
      copab wceq vw vt copab funss mp2 jctir cD cdir wcel cD vx cv cX wcel vy
      cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cop vw cv cdir wcel vt
      cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa
      vx vy copab wceq wa vw vt copab wcel cD cdir wcel vx cv cX wcel vy cv vx
      cv vz cv cD wbr vz cab wceq wa vx vy copab vx cv cD cuni cuni wcel vy cv
      vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq wa cD cdir wcel vx cv
      cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab vx cv cD cuni
      cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq cD
      cdir wcel vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx cv cD
      cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy cD cdir wcel
      vx cv cX wcel vx cv cD cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab
      wceq cD cdir wcel cX cD cuni cuni vx cv cD cdir wcel cD cdm cD cuni cuni
      cX cD dirdm tailf.1 syl5eq eleq2d anbi1d opabbidv ancli cD cdir wcel vx
      cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cvv wcel
      cD vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cop
      vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv
      wbr vz cab wceq wa vx vy copab wceq wa vw vt copab wcel cD cdir wcel vx
      cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab vx cv cD
      cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq
      wa wb vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab
      cX wfn cX cvv wcel vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa
      vx vy copab cvv wcel cD cdir wcel cX cvv vx cv cX wcel vy cv vx cv vz cv
      cD wbr vz cab wceq wa vx vy copab fnex cD cdir wcel vx cv vz cv cD wbr vz
      cab cvv wcel vx cX wral vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab
      wceq wa vx vy copab cX wfn cD cdir wcel vx cv vz cv cD wbr vz cab cvv
      wcel vx cX cD cdir wcel vx cv vz cv cD wbr vz cab cvv wcel vx cv cX wcel
      cD cdir wcel cD cuni cvv wcel cD cuni cuni cvv wcel vx cv vz cv cD wbr vz
      cab cvv wcel cD cdir uniexg cD cuni cvv uniexg vx cv vz cv cD wbr vz cab
      cD cuni cuni wss cD cuni cuni cvv wcel vx cv vz cv cD wbr vz cab cvv wcel
      vx cv vz cv cD wbr vz cD cuni cuni vx cv vz cv cD wbr cD crn cD cuni cuni
      vz cv cD crn cD cuni cuni wss vx cv vz cv cD wbr cD crn cD cdm cD crn cun
      cD cuni cuni cD crn cD cdm ssun2 cD dmrnssfld sstri a1i vx cv vz cv cD vx
      visset vz visset brelrn sseldd abssi vx cv vz cv cD wbr vz cab cD cuni
      cuni cvv ssexg mpan 3syl adantr r19.21aiva vx vy cX vx cv vz cv cD wbr vz
      cab vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab vx
      cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab eqid
      fnopab2g sylib cD cdir wcel cD cdm cvv cX cD cdir dmexg tailf.1 syl5eqel
      sylanc vw cv cdir wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv
      vw cv wbr vz cab wceq wa vx vy copab wceq wa cD cdir wcel vt cv vx cv cD
      cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq
      wa cD cdir wcel vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx
      vy copab vx cv cD cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa
      vx vy copab wceq wa vw vt cD vx cv cX wcel vy cv vx cv vz cv cD wbr vz
      cab wceq wa vx vy copab cdir cvv vw cv cD wceq vw cv cdir wcel cD cdir
      wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab
      wceq wa vx vy copab wceq vt cv vx cv cD cuni cuni wcel vy cv vx cv vz cv
      cD wbr vz cab wceq wa vx vy copab wceq vw cv cD cdir eleq1 vw cv cD wceq
      vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq wa vx
      vy copab vx cv cD cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa
      vx vy copab vt cv vw cv cD wceq vx cv vw cv cuni cuni wcel vy cv vx cv vz
      cv vw cv wbr vz cab wceq wa vx cv cD cuni cuni wcel vy cv vx cv vz cv cD
      wbr vz cab wceq wa vx vy vw cv cD wceq vx cv vw cv cuni cuni wcel vx cv
      cD cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab wceq vy cv vx cv vz
      cv cD wbr vz cab wceq vw cv cD wceq vw cv cuni cuni cD cuni cuni vx cv vw
      cv cD wceq vw cv cuni cD cuni vw cv cD unieq unieqd eleq2d vw cv cD wceq
      vx cv vz cv vw cv wbr vz cab vx cv vz cv cD wbr vz cab vy cv vw cv cD
      wceq vx cv vz cv vw cv wbr vx cv vz cv cD wbr vz vx cv vz cv vw cv cD
      breq abbidv eqeq2d anbi12d opabbidv eqeq2d anbi12d vt cv vx cv cX wcel vy
      cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq vt cv vx cv cD cuni
      cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq vx cv
      cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab vx cv cD cuni
      cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq cD
      cdir wcel vt cv vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx
      vy copab vx cv cD cuni cuni wcel vy cv vx cv vz cv cD wbr vz cab wceq wa
      vx vy copab eqeq1 anbi2d opelopabg mpdan mpbird sylc cD ctail vw cv cdir
      wcel vt cv vx cv vw cv cuni cuni wcel vy cv vx cv vz cv vw cv wbr vz cab
      wceq wa vx vy copab wceq wa vw vt copab vw vt vx vy vz df-tail fveq1i
      syl5eq $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x y z A $. $d x y z D $. $d x y z X $.
    istail.1 $e |- X = dom D $.
    $( The tail of an element in a directed set. $)
    istail $p |- ( ( D e. Dir /\ A e. X ) -> ( ( tail ` D ) ` A ) = { x | A D x
    } ) $=
      cD cdir wcel cA cX wcel wa cA cD ctail cfv cfv cA vy cv cX wcel vz cv vy
      cv vx cv cD wbr vx cab wceq wa vy vz copab cfv cA vx cv cD wbr vx cab cD
      cdir wcel cA cD ctail cfv cfv cA vy cv cX wcel vz cv vy cv vx cv cD wbr
      vx cab wceq wa vy vz copab cfv wceq cA cX wcel cD cdir wcel cA cD ctail
      cfv vy cv cX wcel vz cv vy cv vx cv cD wbr vx cab wceq wa vy vz copab vy
      vz vx cD cX istail.1 tailf fveq1d adantr cA vx cv cD wbr vx cab cvv wcel
      vy cv cX wcel vz cv vy cv vx cv cD wbr vx cab wceq wa vy vz copab wfun wa
      cA cA vx cv cD wbr vx cab cop vy cv cX wcel vz cv vy cv vx cv cD wbr vx
      cab wceq wa vy vz copab wcel cA vy cv cX wcel vz cv vy cv vx cv cD wbr vx
      cab wceq wa vy vz copab cfv cA vx cv cD wbr vx cab wceq cD cdir wcel cA
      cX wcel wa cA cA vx cv cD wbr vx cab cvv vy cv cX wcel vz cv vy cv vx cv
      cD wbr vx cab wceq wa vy vz copab funopfvg cD cdir wcel cA cX wcel wa cA
      vx cv cD wbr vx cab cvv wcel vy cv cX wcel vz cv vy cv vx cv cD wbr vx
      cab wceq wa vy vz copab wfun cA vx cv cD wbr vx cab cD cuni cuni wss cD
      cuni cuni cvv wcel cA vx cv cD wbr vx cab cvv wcel cD cdir wcel cA cX
      wcel wa cA vx cv cD wbr vx cab cD cuni cuni cvv ssexg cA cX wcel cA vx cv
      cD wbr vx cab cD cuni cuni wss cD cdir wcel cA cX wcel cA vx cv cD wbr vx
      cab cD crn cD cuni cuni cA cX wcel cA vx cv cD wbr vx cD crn cA cX wcel
      cA vx cv cD wbr vx cv cD crn wcel cA cX wcel vx cv cvv wcel cA vx cv cD
      wbr vx cv cD crn wcel vx visset cA vx cv cD cX cvv brelrng mp3an2 ex
      abssdv cD crn cD cuni cuni wss cA cX wcel cD crn cD cdm cD crn cun cD
      cuni cuni cD crn cD cdm ssun2 cD dmrnssfld sstri a1i sstrd adantl cD cdir
      wcel cD cuni cuni cvv wcel cA cX wcel cD cdir wcel cD cuni cvv wcel cD
      cuni cuni cvv wcel cD cdir uniexg cD cuni cvv uniexg syl adantr sylanc vy
      cv cX wcel vz cv vy cv vx cv cD wbr vx cab wceq wa vy vz copab vz cv vy
      cv vx cv cD wbr vx cab wceq vy vz copab wss vz cv vy cv vx cv cD wbr vx
      cab wceq vy vz copab wfun vy cv cX wcel vz cv vy cv vx cv cD wbr vx cab
      wceq wa vy vz copab wfun vy cv cX wcel vz cv vy cv vx cv cD wbr vx cab
      wceq wa vz cv vy cv vx cv cD wbr vx cab wceq vy vz vy cv cX wcel vz cv vy
      cv vx cv cD wbr vx cab wceq pm3.27 ssopab2i vy vz vy cv vx cv cD wbr vx
      cab funopabeq vy cv cX wcel vz cv vy cv vx cv cD wbr vx cab wceq wa vy vz
      copab vz cv vy cv vx cv cD wbr vx cab wceq vy vz copab funss mp2 jctir cD
      cdir wcel cA cX wcel wa cA cA vx cv cD wbr vx cab cop vy cv cX wcel vz cv
      vy cv vx cv cD wbr vx cab wceq wa vy vz copab wcel cA cX wcel cA vx cv cD
      wbr vx cab cA vx cv cD wbr vx cab wceq wa cA cX wcel cA cX wcel cA vx cv
      cD wbr vx cab cA vx cv cD wbr vx cab wceq wa cD cdir wcel cA cX wcel cA
      vx cv cD wbr vx cab cA vx cv cD wbr vx cab wceq cA vx cv cD wbr vx cab
      eqid jctr adantl cA cX wcel cD cdir wcel cA cA vx cv cD wbr vx cab cop vy
      cv cX wcel vz cv vy cv vx cv cD wbr vx cab wceq wa vy vz copab wcel cA cX
      wcel cA vx cv cD wbr vx cab cA vx cv cD wbr vx cab wceq wa wb cA cX wcel
      cD cdir wcel cA vx cv cD wbr vx cab cvv wcel cA cA vx cv cD wbr vx cab
      cop vy cv cX wcel vz cv vy cv vx cv cD wbr vx cab wceq wa vy vz copab
      wcel cA cX wcel cA vx cv cD wbr vx cab cA vx cv cD wbr vx cab wceq wa wb
      cA vx cv cD wbr vx cab cD cuni cuni wss cD cuni cuni cvv wcel cA vx cv cD
      wbr vx cab cvv wcel cA cX wcel cD cdir wcel cA vx cv cD wbr vx cab cD
      cuni cuni cvv ssexg cA cX wcel cA vx cv cD wbr vx cab cD crn cD cuni cuni
      cA cX wcel cA vx cv cD wbr vx cD crn cA cX wcel cA vx cv cD wbr vx cv cD
      crn wcel cA cX wcel vx cv cvv wcel cA vx cv cD wbr vx cv cD crn wcel vx
      visset cA vx cv cD cX cvv brelrng mp3an2 ex abssdv cD crn cD cuni cuni
      wss cA cX wcel cD crn cD cdm cD crn cun cD cuni cuni cD crn cD cdm ssun2
      cD dmrnssfld sstri a1i sstrd cD cdir wcel cD cuni cvv wcel cD cuni cuni
      cvv wcel cD cdir uniexg cD cuni cvv uniexg syl syl2an vy cv cX wcel vz cv
      vy cv vx cv cD wbr vx cab wceq wa cA cX wcel vz cv cA vx cv cD wbr vx cab
      wceq wa cA cX wcel cA vx cv cD wbr vx cab cA vx cv cD wbr vx cab wceq wa
      vy vz cA cA vx cv cD wbr vx cab cX cvv vy cv cA wceq vy cv cX wcel cA cX
      wcel vz cv vy cv vx cv cD wbr vx cab wceq vz cv cA vx cv cD wbr vx cab
      wceq vy cv cA cX eleq1 vy cv cA wceq vy cv vx cv cD wbr vx cab cA vx cv
      cD wbr vx cab vz cv vy cv cA wceq vy cv vx cv cD wbr cA vx cv cD wbr vx
      vy cv cA vx cv cD breq1 abbidv eqeq2d anbi12d vz cv cA vx cv cD wbr vx
      cab wceq vz cv cA vx cv cD wbr vx cab wceq cA vx cv cD wbr vx cab cA vx
      cv cD wbr vx cab wceq cA cX wcel vz cv cA vx cv cD wbr vx cab cA vx cv cD
      wbr vx cab eqeq1 anbi2d opelopabg syldan ancoms mpbird sylc eqtrd $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d x A $. $d x B $. $d x C $. $d x D $. $d x X $.
    eltail.1 $e |- X = dom D $.
    $( An element of a tail. $)
    eltail $p |- ( ( D e. Dir /\ A e. X /\ B e. C ) -> ( B e. ( ( tail ` D ) `
    A ) <-> A D B ) ) $=
      cD cdir wcel cA cX wcel cB cC wcel w3a cB cA cD ctail cfv cfv wcel cB cA
      vx cv cD wbr vx cab wcel cA cB cD wbr cD cdir wcel cA cX wcel cB cA cD
      ctail cfv cfv wcel cB cA vx cv cD wbr vx cab wcel wb cB cC wcel cD cdir
      wcel cA cX wcel wa cA cD ctail cfv cfv cA vx cv cD wbr vx cab cB vx cA cD
      cX eltail.1 istail eleq2d 3adant3 cB cC wcel cD cdir wcel cB cA vx cv cD
      wbr vx cab wcel cA cB cD wbr wb cA cX wcel cA vx cv cD wbr cA cB cD wbr
      vx cB cC vx cv cB cA cD breq2 elabg 3ad2ant3 bitrd $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d s x y z D $. $d s x y z X $.
    tailmap.1 $e |- X = dom D $.
    $( The tail function of a directed set sends its elements to its
       subsets. $)
    tailmap $p |- ( D e. Dir -> ( tail ` D ) : X --> ~P X ) $=
      cD cdir wcel cD ctail cfv cX wfn cD ctail cfv crn cX cpw wss wa cX cX cpw
      cD ctail cfv wf cD cdir wcel cD ctail cfv cX wfn cD ctail cfv crn cX cpw
      wss cD cdir wcel cD ctail cfv cX wfn vx cv cX wcel vy cv vx cv vz cv cD
      wbr vz cab wceq wa vx vy copab cX wfn cD cdir wcel vx cv vz cv cD wbr vz
      cab cvv wcel vx cX wral vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab
      wceq wa vx vy copab cX wfn cD cdir wcel vx cv vz cv cD wbr vz cab cvv
      wcel vx cX cD cdir wcel vx cv vz cv cD wbr vz cab cvv wcel vx cv cX wcel
      cD cdir wcel cD cuni cvv wcel cD cuni cuni cvv wcel vx cv vz cv cD wbr vz
      cab cvv wcel cD cdir uniexg cD cuni cvv uniexg vx cv vz cv cD wbr vz cab
      cD cuni cuni wss cD cuni cuni cvv wcel vx cv vz cv cD wbr vz cab cvv wcel
      vx cv vz cv cD wbr vz cab cD crn cD cuni cuni vx cv vz cv cD wbr vz cD
      crn vx cv vz cv cD vx visset vz visset brelrn abssi cD crn cD cdm cD crn
      cun cD cuni cuni cD crn cD cdm ssun2 cD dmrnssfld sstri sstri vx cv vz cv
      cD wbr vz cab cD cuni cuni cvv ssexg mpan 3syl a1d r19.21aiv vx vy cX vx
      cv vz cv cD wbr vz cab vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq
      wa vx vy copab vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx
      vy copab eqid fnopab2g sylib cD cdir wcel cD ctail cfv vx cv cX wcel vy
      cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab wceq cD ctail cfv cX wfn
      vx cv cX wcel vy cv vx cv vz cv cD wbr vz cab wceq wa vx vy copab cX wfn
      wb vx vy vz cD cX tailmap.1 tailf cX cD ctail cfv vx cv cX wcel vy cv vx
      cv vz cv cD wbr vz cab wceq wa vx vy copab fneq1 syl mpbird cD cdir wcel
      cD ctail cfv cX wfn cD ctail cfv crn cX cpw wss cD cdir wcel cD ctail cfv
      cX wfn wa vs cD ctail cfv crn cX cpw cD cdir wcel cD ctail cfv cX wfn wa
      vs cv cD ctail cfv crn wcel vx cv cD ctail cfv cfv vs cv wceq vx cX wrex
      vs cv cX cpw wcel cD ctail cfv cX wfn vs cv cD ctail cfv crn wcel vx cv
      cD ctail cfv cfv vs cv wceq vx cX wrex wb cD cdir wcel vx cX vs cv cD
      ctail cfv fvelrnb adantl cD cdir wcel vx cv cD ctail cfv cfv vs cv wceq
      vx cX wrex vs cv cX cpw wcel wi cD ctail cfv cX wfn cD cdir wcel vx cv cD
      ctail cfv cfv vs cv wceq vs cv cX cpw wcel vx cX vx cv cD ctail cfv cfv
      vs cv wceq vx cv cD ctail cfv cfv cX cpw wcel vs cv cX cpw wcel cD cdir
      wcel vx cv cX wcel wa vx cv cD ctail cfv cfv vs cv cX cpw eleq1 cD cdir
      wcel vx cv cX wcel wa vx cv cD ctail cfv cfv cX wss vx cv cD ctail cfv
      cfv cX cpw wcel cD cdir wcel vx cv cX wcel wa vx cv cD ctail cfv cfv vx
      cv vy cv cD wbr vy cab cX vy vx cv cD cX tailmap.1 istail cD cdir wcel vx
      cv cX wcel wa vx cv vy cv cD wbr vy cab cD cuni cuni cX vx cv vy cv cD
      wbr vy cab cD cuni cuni wss cD cdir wcel vx cv cX wcel wa vx cv vy cv cD
      wbr vy cab cD crn cD cuni cuni vx cv vy cv cD wbr vy cD crn vx cv vy cv
      cD vx visset vy visset brelrn abssi cD crn cD cdm cD crn cun cD cuni cuni
      cD crn cD cdm ssun2 cD dmrnssfld sstri sstri a1i cD cdir wcel vx cv cX
      wcel wa cD cdm cD cuni cuni cX cD cdir wcel cD cdm cD cuni cuni wceq vx
      cv cX wcel cD dirdm adantr tailmap.1 syl5req sseqtrd eqsstrd vx cv cD
      ctail cfv cfv cX vx cv cD ctail cfv fvex elpw sylibr syl5cbi r19.23adva
      adantr sylbid ssrdv ex jcai cX cX cpw cD ctail cfv df-f sylibr $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    tailini.1 $e |- X = dom D $.
    $( A tail contains its initial element. $)
    tailini $p |- ( ( D e. Dir /\ A e. X ) -> A e. ( ( tail ` D ) ` A ) ) $=
      cD cdir wcel cA cX wcel wa cA cA cD ctail cfv cfv wcel cA cA cD wbr cA cD
      cX tailini.1 dirref cD cdir wcel cA cX wcel cA cA cD ctail cfv cfv wcel
      cA cA cD wbr wb cA cA cX cD cX tailini.1 eltail 3anidm23 mpbird $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d t x D $. $d t x X $.
    tailuni.1 $e |- X = dom D $.
    $( The union of all the tails of a directed set. $)
    tailuni $p |- ( D e. Dir -> U. ran ( tail ` D ) = X ) $=
      cD cdir wcel cD ctail cfv crn cuni cX cD cdir wcel vx cv cX wss vx cD
      ctail cfv crn wral cD ctail cfv crn cuni cX wss cD cdir wcel vx cv cX wss
      vx cD ctail cfv crn cD cdir wcel cX cX cpw cD ctail cfv wf vx cv cD ctail
      cfv crn wcel vx cv cX wss wi cD cX tailuni.1 tailmap cX cX cpw cD ctail
      cfv wf vx cv cD ctail cfv crn wcel vx cv cX cpw wcel vx cv cX wss cX cX
      cpw cD ctail cfv wf cD ctail cfv crn cX cpw vx cv cX cX cpw cD ctail cfv
      frn sseld vx cv cX vx visset elpw syl6ib syl r19.21aiv vx cD ctail cfv
      crn cX unissb sylibr cD cdir wcel vx cX cD ctail cfv crn cuni cD cdir
      wcel vx cv cX wcel vx cv cD ctail cfv crn cuni wcel cD cdir wcel vx cv cX
      wcel wa vx cv vt cv wcel vt cv cD ctail cfv crn wcel wa vt wex vx cv cD
      ctail cfv crn cuni wcel vx cv vx cv cD ctail cfv cfv wcel vx cv cD ctail
      cfv cfv cD ctail cfv crn wcel vx cv vt cv wcel vt cv cD ctail cfv crn
      wcel wa vt wex cD cdir wcel vx cv cX wcel wa vx cv vt cv wcel vt cv cD
      ctail cfv crn wcel wa vx cv vx cv cD ctail cfv cfv wcel vx cv cD ctail
      cfv cfv cD ctail cfv crn wcel wa vt vx cv cD ctail cfv cfv vx cv cD ctail
      cfv fvex vt cv vx cv cD ctail cfv cfv wceq vx cv vt cv wcel vx cv vx cv
      cD ctail cfv cfv wcel vt cv cD ctail cfv crn wcel vx cv cD ctail cfv cfv
      cD ctail cfv crn wcel vt cv vx cv cD ctail cfv cfv vx cv eleq2 vt cv vx
      cv cD ctail cfv cfv cD ctail cfv crn eleq1 anbi12d cla4ev vx cv cD cX
      tailuni.1 tailini cD ctail cfv cX wfn vx cv cX wcel vx cv cD ctail cfv
      cfv cD ctail cfv crn wcel cD cdir wcel cX vx cv cD ctail cfv fnfvelrn cD
      cdir wcel cX cX cpw cD ctail cfv wf cD ctail cfv cX wfn cD cX tailuni.1
      tailmap cX cX cpw cD ctail cfv ffn syl sylan sylanc vt vx cv cD ctail cfv
      crn eluni sylibr ex ssrdv eqssd $.
      $( [13-Dec-2009] $) $( [13-Dec-2009] $)
  $}

  ${
    $d u v w x y z D $. $d u v w x y z X $.
    tailfb.1 $e |- X = dom D $.
    $( The collection of tails of a directed set is a filter base. $)
    tailfb $p |- ( ( D e. Dir /\ X =/= (/) ) -> ran ( tail ` D ) e. fBas ) $=
      cD cdir wcel cX c0 wne wa cD ctail cfv crn c0 wne c0 cD ctail cfv crn
      wnel vz cv vx cv vy cv cin wss vz cD ctail cfv crn wrex vy cD ctail cfv
      crn wral vx cD ctail cfv crn wral w3a cD ctail cfv crn cfbas wcel cD cdir
      wcel cX c0 wne wa cD ctail cfv crn c0 wne c0 cD ctail cfv crn wnel vz cv
      vx cv vy cv cin wss vz cD ctail cfv crn wrex vy cD ctail cfv crn wral vx
      cD ctail cfv crn wral cD cdir wcel cX c0 wne cD ctail cfv crn c0 wne cD
      cdir wcel vx cv cX wcel vx wex cD ctail cfv crn c0 wne cX c0 wne cD cdir
      wcel vx cv cX wcel cD ctail cfv crn c0 wne vx cD cdir wcel vx cv cX wcel
      vx cv cD ctail cfv cfv cD ctail cfv crn wcel cD ctail cfv crn c0 wne cD
      cdir wcel cX cX cpw cD ctail cfv wf cD ctail cfv cX wfn vx cv cX wcel vx
      cv cD ctail cfv cfv cD ctail cfv crn wcel wi cD cX tailfb.1 tailmap cX cX
      cpw cD ctail cfv ffn cD ctail cfv cX wfn vx cv cX wcel vx cv cD ctail cfv
      cfv cD ctail cfv crn wcel cX vx cv cD ctail cfv fnfvelrn ex 3syl cD ctail
      cfv crn vx cv cD ctail cfv cfv ne0i syl6 19.23adv vx cX n0 syl5ib imp cD
      cdir wcel cX c0 wne wa c0 cD ctail cfv crn wcel wn c0 cD ctail cfv crn
      wnel cD cdir wcel cX c0 wne wa c0 cD ctail cfv crn wcel vx cv cD ctail
      cfv cfv c0 wceq vx cX wrex cD cdir wcel vx cv cD ctail cfv cfv c0 wceq vx
      cX wrex wn cX c0 wne cD cdir wcel vx cv cD ctail cfv cfv c0 wceq vx cX cD
      cdir wcel vx cv cX wcel wa vx cv vx cv cD ctail cfv cfv wcel vx cv cD
      ctail cfv cfv c0 wceq wn vx cv cD cX tailfb.1 tailini vx cv cD ctail cfv
      cfv vx cv n0i syl nrexdv adantr cD cdir wcel c0 cD ctail cfv crn wcel vx
      cv cD ctail cfv cfv c0 wceq vx cX wrex wb cX c0 wne cD cdir wcel cX cX
      cpw cD ctail cfv wf cD ctail cfv cX wfn c0 cD ctail cfv crn wcel vx cv cD
      ctail cfv cfv c0 wceq vx cX wrex wb cD cX tailfb.1 tailmap cX cX cpw cD
      ctail cfv ffn vx cX c0 cD ctail cfv fvelrnb 3syl adantr mtbird c0 cD
      ctail cfv crn df-nel sylibr cD cdir wcel cX c0 wne wa vz cv vx cv vy cv
      cin wss vz cD ctail cfv crn wrex vx vy cD ctail cfv crn cD ctail cfv crn
      cD cdir wcel vx cv cD ctail cfv crn wcel vy cv cD ctail cfv crn wcel wa
      vz cv vx cv vy cv cin wss vz cD ctail cfv crn wrex wi cX c0 wne cD cdir
      wcel vx cv cD ctail cfv crn wcel vy cv cD ctail cfv crn wcel wa vu cv cD
      ctail cfv cfv vx cv wceq vu cX wrex vv cv cD ctail cfv cfv vy cv wceq vv
      cX wrex wa vz cv vx cv vy cv cin wss vz cD ctail cfv crn wrex cD cdir
      wcel cX cX cpw cD ctail cfv wf cD ctail cfv cX wfn vx cv cD ctail cfv crn
      wcel vy cv cD ctail cfv crn wcel wa vu cv cD ctail cfv cfv vx cv wceq vu
      cX wrex vv cv cD ctail cfv cfv vy cv wceq vv cX wrex wa wb cD cX tailfb.1
      tailmap cX cX cpw cD ctail cfv ffn cD ctail cfv cX wfn vx cv cD ctail cfv
      crn wcel vu cv cD ctail cfv cfv vx cv wceq vu cX wrex vy cv cD ctail cfv
      crn wcel vv cv cD ctail cfv cfv vy cv wceq vv cX wrex vu cX vx cv cD
      ctail cfv fvelrnb vv cX vy cv cD ctail cfv fvelrnb anbi12d 3syl cD cdir
      wcel vu cv cD ctail cfv cfv vx cv wceq vv cv cD ctail cfv cfv vy cv wceq
      wa vv cX wrex vu cX wrex vz cv vx cv vy cv cin wss vz cD ctail cfv crn
      wrex vu cv cD ctail cfv cfv vx cv wceq vu cX wrex vv cv cD ctail cfv cfv
      vy cv wceq vv cX wrex wa cD cdir wcel vu cv cD ctail cfv cfv vx cv wceq
      vv cv cD ctail cfv cfv vy cv wceq wa vz cv vx cv vy cv cin wss vz cD
      ctail cfv crn wrex vu vv cX cX cD cdir wcel vu cv cX wcel vv cv cX wcel
      wa vu cv cD ctail cfv cfv vx cv wceq vv cv cD ctail cfv cfv vy cv wceq wa
      vz cv vx cv vy cv cin wss vz cD ctail cfv crn wrex wi vu cv cD ctail cfv
      cfv vx cv wceq vv cv cD ctail cfv cfv vy cv wceq wa vz cv vu cv cD ctail
      cfv cfv vv cv cD ctail cfv cfv cin wss vz cD ctail cfv crn wrex vz cv vx
      cv vy cv cin wss vz cD ctail cfv crn wrex cD cdir wcel vu cv cX wcel vv
      cv cX wcel wa wa vu cv cD ctail cfv cfv vx cv wceq vz cv vu cv cD ctail
      cfv cfv vv cv cD ctail cfv cfv cin wss vz cD ctail cfv crn wrex vz cv vx
      cv vv cv cD ctail cfv cfv cin wss vz cD ctail cfv crn wrex vv cv cD ctail
      cfv cfv vy cv wceq vz cv vx cv vy cv cin wss vz cD ctail cfv crn wrex vu
      cv cD ctail cfv cfv vx cv wceq vz cv vu cv cD ctail cfv cfv vv cv cD
      ctail cfv cfv cin wss vz cv vx cv vv cv cD ctail cfv cfv cin wss vz cD
      ctail cfv crn vu cv cD ctail cfv cfv vx cv wceq vu cv cD ctail cfv cfv vv
      cv cD ctail cfv cfv cin vx cv vv cv cD ctail cfv cfv cin vz cv vu cv cD
      ctail cfv cfv vx cv vv cv cD ctail cfv cfv ineq1 sseq2d rexbidv vv cv cD
      ctail cfv cfv vy cv wceq vz cv vx cv vv cv cD ctail cfv cfv cin wss vz cv
      vx cv vy cv cin wss vz cD ctail cfv crn vv cv cD ctail cfv cfv vy cv wceq
      vx cv vv cv cD ctail cfv cfv cin vx cv vy cv cin vz cv vv cv cD ctail cfv
      cfv vy cv vx cv ineq2 sseq2d rexbidv sylan9bb cD cdir wcel vu cv cX wcel
      vv cv cX wcel wa wa vu cv vw cv cD wbr vv cv vw cv cD wbr wa vw cX wrex
      vz cv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv cin wss vz cD ctail
      cfv crn wrex cD cdir wcel vu cv cX wcel vv cv cX wcel vu cv vw cv cD wbr
      vv cv vw cv cD wbr wa vw cX wrex vw vu cv vv cv cD cX tailfb.1 dirge
      3expb cD cdir wcel vu cv cX wcel vv cv cX wcel wa wa vu cv vw cv cD wbr
      vv cv vw cv cD wbr wa vz cv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv
      cin wss vz cD ctail cfv crn wrex vw cX cD cdir wcel vu cv cX wcel vv cv
      cX wcel wa wa vw cv cX wcel vu cv vw cv cD wbr vv cv vw cv cD wbr wa vz
      cv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv cin wss vz cD ctail cfv
      crn wrex vw cv cD ctail cfv cfv cD ctail cfv crn wcel vw cv cD ctail cfv
      cfv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv cin wss vz cv vu cv cD
      ctail cfv cfv vv cv cD ctail cfv cfv cin wss vz cD ctail cfv crn wrex cD
      cdir wcel vu cv cX wcel vv cv cX wcel wa wa vw cv cX wcel vu cv vw cv cD
      wbr vv cv vw cv cD wbr wa wa wa vz cv vu cv cD ctail cfv cfv vv cv cD
      ctail cfv cfv cin wss vw cv cD ctail cfv cfv vu cv cD ctail cfv cfv vv cv
      cD ctail cfv cfv cin wss vz vw cv cD ctail cfv cfv cD ctail cfv crn vz cv
      vw cv cD ctail cfv cfv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv cin
      sseq1 rcla4ev cD cdir wcel vw cv cX wcel vw cv cD ctail cfv cfv cD ctail
      cfv crn wcel vu cv cX wcel vv cv cX wcel wa vu cv vw cv cD wbr vv cv vw
      cv cD wbr wa cD ctail cfv cX wfn vw cv cX wcel vw cv cD ctail cfv cfv cD
      ctail cfv crn wcel cD cdir wcel cX vw cv cD ctail cfv fnfvelrn cD cdir
      wcel cX cX cpw cD ctail cfv wf cD ctail cfv cX wfn cD cX tailfb.1 tailmap
      cX cX cpw cD ctail cfv ffn syl sylan ad2ant2r cD cdir wcel vu cv cX wcel
      vv cv cX wcel wa wa vw cv cX wcel vu cv vw cv cD wbr vv cv vw cv cD wbr
      wa wa wa vx vw cv cD ctail cfv cfv vu cv cD ctail cfv cfv vv cv cD ctail
      cfv cfv cin cD cdir wcel vu cv cX wcel vv cv cX wcel wa wa vw cv cX wcel
      vu cv vw cv cD wbr vv cv vw cv cD wbr wa wa wa vx cv vw cv cD ctail cfv
      cfv wcel vx cv vu cv cD ctail cfv cfv wcel vx cv vv cv cD ctail cfv cfv
      wcel wa vx cv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv cin wcel cD
      cdir wcel vu cv cX wcel vv cv cX wcel wa wa vw cv cX wcel vu cv vw cv cD
      wbr vv cv vw cv cD wbr wa wa wa vw cv vx cv cD wbr vu cv vx cv cD wbr vv
      cv vx cv cD wbr wa vx cv vw cv cD ctail cfv cfv wcel vx cv vu cv cD ctail
      cfv cfv wcel vx cv vv cv cD ctail cfv cfv wcel wa cD cdir wcel vu cv cX
      wcel vv cv cX wcel wa wa vw cv cX wcel vu cv vw cv cD wbr vv cv vw cv cD
      wbr wa vw cv vx cv cD wbr vu cv vx cv cD wbr vv cv vx cv cD wbr wa wi cD
      cdir wcel vu cv cX wcel vv cv cX wcel wa wa vw cv cX wcel wa vw cv vx cv
      cD wbr vu cv vw cv cD wbr vv cv vw cv cD wbr wa vu cv vx cv cD wbr vv cv
      vx cv cD wbr wa cD cdir wcel vu cv cX wcel vv cv cX wcel wa wa vw cv cX
      wcel vw cv vx cv cD wbr vu cv vw cv cD wbr vv cv vw cv cD wbr wa vu cv vx
      cv cD wbr vv cv vx cv cD wbr wa wi cD cdir wcel vu cv cX wcel vv cv cX
      wcel wa wa vw cv cX wcel vw cv vx cv cD wbr wa wa vu cv vw cv cD wbr vu
      cv vx cv cD wbr vv cv vw cv cD wbr vv cv vx cv cD wbr cD cdir wcel vw cv
      vx cv cD wbr vu cv vw cv cD wbr vu cv vx cv cD wbr wi vu cv cX wcel vv cv
      cX wcel wa vw cv cX wcel cD cdir wcel vw cv vx cv cD wbr vu cv vw cv cD
      wbr vu cv vx cv cD wbr wi cD cdir wcel vu cv vw cv cD wbr vw cv vx cv cD
      wbr vu cv vx cv cD wbr cD cdir wcel vx cv cvv wcel vu cv vw cv cD wbr vw
      cv vx cv cD wbr vu cv vx cv cD wbr wi wi vx visset cD cdir wcel vx cv cvv
      wcel wa vu cv vw cv cD wbr vw cv vx cv cD wbr vu cv vx cv cD wbr vu cv vw
      cv vx cv cD cvv dirtr exp32 mpan2 com23 imp ad2ant2rl cD cdir wcel vw cv
      vx cv cD wbr vv cv vw cv cD wbr vv cv vx cv cD wbr wi vu cv cX wcel vv cv
      cX wcel wa vw cv cX wcel cD cdir wcel vw cv vx cv cD wbr vv cv vw cv cD
      wbr vv cv vx cv cD wbr wi cD cdir wcel vv cv vw cv cD wbr vw cv vx cv cD
      wbr vv cv vx cv cD wbr cD cdir wcel vx cv cvv wcel vv cv vw cv cD wbr vw
      cv vx cv cD wbr vv cv vx cv cD wbr wi wi vx visset cD cdir wcel vx cv cvv
      wcel wa vv cv vw cv cD wbr vw cv vx cv cD wbr vv cv vx cv cD wbr vv cv vw
      cv vx cv cD cvv dirtr exp32 mpan2 com23 imp ad2ant2rl anim12d expr com23
      impr cD cdir wcel vw cv cX wcel vx cv vw cv cD ctail cfv cfv wcel vw cv
      vx cv cD wbr wb vu cv cX wcel vv cv cX wcel wa vu cv vw cv cD wbr vv cv
      vw cv cD wbr wa cD cdir wcel vw cv cX wcel vx cv cvv wcel vx cv vw cv cD
      ctail cfv cfv wcel vw cv vx cv cD wbr wb vx visset vw cv vx cv cvv cD cX
      tailfb.1 eltail mp3an3 ad2ant2r cD cdir wcel vu cv cX wcel vv cv cX wcel
      wa wa vx cv vu cv cD ctail cfv cfv wcel vx cv vv cv cD ctail cfv cfv wcel
      wa vu cv vx cv cD wbr vv cv vx cv cD wbr wa wb vw cv cX wcel vu cv vw cv
      cD wbr vv cv vw cv cD wbr wa wa cD cdir wcel vu cv cX wcel vv cv cX wcel
      wa wa vx cv vu cv cD ctail cfv cfv wcel vu cv vx cv cD wbr vx cv vv cv cD
      ctail cfv cfv wcel vv cv vx cv cD wbr cD cdir wcel vu cv cX wcel vx cv vu
      cv cD ctail cfv cfv wcel vu cv vx cv cD wbr wb vv cv cX wcel cD cdir wcel
      vu cv cX wcel vx cv cvv wcel vx cv vu cv cD ctail cfv cfv wcel vu cv vx
      cv cD wbr wb vx visset vu cv vx cv cvv cD cX tailfb.1 eltail mp3an3
      adantrr cD cdir wcel vv cv cX wcel vx cv vv cv cD ctail cfv cfv wcel vv
      cv vx cv cD wbr wb vu cv cX wcel cD cdir wcel vv cv cX wcel vx cv cvv
      wcel vx cv vv cv cD ctail cfv cfv wcel vv cv vx cv cD wbr wb vx visset vv
      cv vx cv cvv cD cX tailfb.1 eltail mp3an3 adantrl anbi12d adantr 3imtr4d
      vx cv vu cv cD ctail cfv cfv vv cv cD ctail cfv cfv elin syl6ibr ssrdv
      sylanc exp32 r19.23adv mpd syl5cbi ex r19.23advv vu cv cD ctail cfv cfv
      vx cv wceq vv cv cD ctail cfv cfv vy cv wceq vu vv cX cX reeanv syl5ibr
      sylbid adantr r19.21aivv 3jca cD ctail cfv crn cvv wcel cD ctail cfv crn
      cfbas wcel cD ctail cfv crn c0 wne c0 cD ctail cfv crn wnel vz cv vx cv
      vy cv cin wss vz cD ctail cfv crn wrex vy cD ctail cfv crn wral vx cD
      ctail cfv crn wral w3a wb cD ctail cfv cD ctail fvex rnex vx vy vz cvv cD
      ctail cfv crn isfbas2 ax-mp sylibr $.
      $( [25-Nov-2009] $) $( [25-Nov-2009] $)
  $}

  ${
    $d a b c d f g h j k l m n o p r s t u v w x y z F $. $d a b c d f g h j k
    l m n o p r s t u v w x y z X $.
    filnet.1 $e |- X = U. F $.
    $( Lemma for ~ filnet . The field of the direction. $)
    filnetlem1 $p |- U. U. { <. x , y >. | E. u e. X E. v e. X E. h e. F E. g
    e. F ( ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e. h /\ v e. g /\ g C_
    h ) ) } = { <. m , n >. | ( n e. F /\ m e. n ) } $=
      vt vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cuni cuni vn cv cF wcel vm cv vn cv wcel wa
      vm vn copab vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wcel vt cv vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab wcel vt cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cuni cuni wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab crn wcel wo vt cv vn cv cF wcel vm cv vn cv wcel wa vm
      vn copab wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wcel vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab crn cun wcel vt cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cdm wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab crn wcel wo vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cuni cuni vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab crn cun vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wrel vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab crn cun wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy relopab vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab relfld
      ax-mp eleq2i vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab crn
      elun bitri vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vt cv vn cv cF wcel vm cv
      vn cv wcel wa vm vn copab wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab crn wcel
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm wcel vt cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vy wex vt cv vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab wcel vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vy wex vt cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vy wex vx vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vt visset vx cv vt cv wceq vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vy vx cv vt cv wceq vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vt cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vu vv cX cX vx cv vt cv wceq vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF
      vx cv vt cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a vx cv vt cv wceq vx cv vu cv vh cv
      cop wceq vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq vx cv vt
      cv vu cv vh cv cop eqeq1 anbi1d anbi1d 2rexbidv 2rexbidv exbidv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy dmopab elab2 vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vt cv vn cv cF wcel vm cv vn cv
      wcel wa vm vn copab wcel vy vt cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel vu vv cX cX vu cv cX wcel vv cv cX wcel wa vt cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel vh vg cF cF vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF
      wcel wa vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt cv vn cv cF wcel vm cv
      vn cv wcel wa vm vn copab wcel wi vh cv cF wcel vt cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel wi vu cv cX wcel vv cv cX wcel wa vg cv cF wcel vh cv cF wcel vt cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab wcel vh cv cF wcel vt cv vu cv vh cv cop wceq vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a vt cv vn cv cF wcel vm cv vn cv wcel wa
      vm vn copab wcel wi vy cv vv cv vg cv cop wceq vh cv cF wcel vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a vt cv vu cv vh cv cop wceq vt
      cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vh cv cF wcel vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vt cv vu cv vh cv cop
      wceq vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel wi vt cv vu
      cv vh cv cop wceq vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel vu cv vh cv cop vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel
      vh cv cF wcel vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt
      cv vu cv vh cv cop vn cv cF wcel vm cv vn cv wcel wa vm vn copab eleq1 vh
      cv cF wcel vv cv vg cv wcel vu cv vh cv wcel vu cv vh cv cop vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab wcel vg cv vh cv wss vu cv vh cv cop
      vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vh cv cF wcel vu cv vh
      cv wcel wa vn cv cF wcel vm cv vn cv wcel wa vn cv cF wcel vu cv vn cv
      wcel wa vh cv cF wcel vu cv vh cv wcel wa vm vn vu cv vh cv vu visset vh
      visset vm cv vu cv wceq vm cv vn cv wcel vu cv vn cv wcel vn cv cF wcel
      vm cv vu cv vn cv eleq1 anbi2d vn cv vh cv wceq vn cv cF wcel vh cv cF
      wcel vu cv vn cv wcel vu cv vh cv wcel vn cv vh cv cF eleq1 vn cv vh cv
      vu cv eleq2 anbi12d opelopab biimpri 3ad2antr1 syl5cbir ex com23 a1dd
      imp4c ad2antrl ex r19.23advv r19.23aivv 19.23aiv sylbi vt cv vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab crn wcel vx cv vu cv vh cv cop wceq vt cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx wex vt cv vn cv cF wcel vm cv vn
      cv wcel wa vm vn copab wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx wex vx cv vu cv vh cv cop
      wceq vt cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx wex vy
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab crn vt visset vy cv vt cv wceq vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx cv vu cv vh cv cop wceq vt cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy cv vt cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vx cv vu cv vh cv cop wceq vt cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vu vv cX cX vy cv vt cv wceq vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vx cv vu cv vh cv cop wceq vt cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vy cv
      vt cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vx cv
      vu cv vh cv cop wceq vt cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vy cv vt cv wceq vy cv vv cv vg cv cop
      wceq vt cv vv cv vg cv cop wceq vx cv vu cv vh cv cop wceq vy cv vt cv vv
      cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv exbidv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy rnopab elab2 vx cv vu cv vh cv cop wceq vt cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vt cv vn cv cF wcel vm cv vn cv wcel wa vm
      vn copab wcel vx vx cv vu cv vh cv cop wceq vt cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vu vv cX cX
      vu cv cX wcel vv cv cX wcel wa vx cv vu cv vh cv cop wceq vt cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vh vg cF cF vu
      cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa vx cv vu cv vh
      cv cop wceq vt cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab wcel wi vg cv cF wcel vx cv vu cv vh cv cop wceq vt cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt
      cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel wi vu cv cX wcel vv
      cv cX wcel wa vh cv cF wcel vg cv cF wcel vx cv vu cv vh cv cop wceq vt
      cv vv cv vg cv cop wceq vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vg cv cF
      wcel vt cv vv cv vg cv cop wceq vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel wi
      wi vx cv vu cv vh cv cop wceq vg cv cF wcel vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a vt cv vv cv vg cv cop wceq vt cv vn cv cF wcel
      vm cv vn cv wcel wa vm vn copab wcel vg cv cF wcel vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vt cv vv cv vg cv cop wceq vt cv vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab wcel wi vt cv vv cv vg cv cop wceq
      vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vv cv vg cv cop
      vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vg cv cF wcel vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt cv vv cv vg cv cop vn
      cv cF wcel vm cv vn cv wcel wa vm vn copab eleq1 vg cv cF wcel vu cv vh
      cv wcel vv cv vg cv wcel vv cv vg cv cop vn cv cF wcel vm cv vn cv wcel
      wa vm vn copab wcel vg cv vh cv wss vv cv vg cv cop vn cv cF wcel vm cv
      vn cv wcel wa vm vn copab wcel vg cv cF wcel vv cv vg cv wcel wa vn cv cF
      wcel vm cv vn cv wcel wa vn cv cF wcel vv cv vn cv wcel wa vg cv cF wcel
      vv cv vg cv wcel wa vm vn vv cv vg cv vv visset vg visset vm cv vv cv
      wceq vm cv vn cv wcel vv cv vn cv wcel vn cv cF wcel vm cv vv cv vn cv
      eleq1 anbi2d vn cv vg cv wceq vn cv cF wcel vg cv cF wcel vv cv vn cv
      wcel vv cv vg cv wcel vn cv vg cv cF eleq1 vn cv vg cv vv cv eleq2
      anbi12d opelopab biimpri 3ad2antr2 syl5cbir ex com23 a1d imp4c ad2antll
      ex r19.23advv r19.23aivv 19.23aiv sylbi jaoi sylbi vt cv vn cv cF wcel vm
      cv vn cv wcel wa vm vn copab wcel vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cuni cuni vt cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cuni cuni wss vt cv vn cv cF wcel vm cv vn cv wcel wa vm
      vn copab wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab crn cun vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab crn ssun1 vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab dmrnssfld sstri a1i vt cv vn cv cF wcel vm cv vn cv wcel wa
      vm vn copab wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vn wex vm wex vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vn cv cF
      wcel vm cv vn cv wcel wa vm vn vt cv elopab vt cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa vt cv vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel
      vm vn vn cv cF wcel vm cv vn cv wcel wa vt cv vm cv vn cv cop wceq vt cv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm wcel vt cv vm cv vn cv cop wceq vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm wcel vm cv vn cv cop vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      wcel vn cv cF wcel vm cv vn cv wcel wa vt cv vm cv vn cv cop vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm eleq1 vn cv cF wcel vm cv vn cv wcel wa vm cv vn cv cop
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vy wex vm cv vn cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vn cv cF
      wcel vm cv vn cv wcel wa vm cv vn cv cop vu cv vh cv cop wceq vm cv vn cv
      cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vm cv vn cv cop vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vy wex vm cv cX wcel vm cv cX wcel vm cv vn cv cop vm cv vh cv cop
      wceq vm cv vn cv cop vm cv vg cv cop wceq wa vm cv vh cv wcel vm cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vm cv vn cv cop vu cv
      vh cv cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vn cv cF wcel vm cv vn cv wcel wa vm cv vn cv cop vu cv vh cv
      cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vm cv vn cv cop
      vm cv vh cv cop wceq vm cv vn cv cop vm cv vg cv cop wceq wa vm cv vh cv
      wcel vm cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vm cv
      vn cv cop vm cv vh cv cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vm
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vu vv vm cv vm cv cX cX vu cv vm cv wceq vm cv vn cv cop vu cv vh cv
      cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vm cv vn cv cop vm cv vh cv cop wceq vm
      cv vn cv cop vv cv vg cv cop wceq wa vm cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vh vg cF cF vu cv vm cv wceq vm cv vn cv cop vu cv vh
      cv cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vm cv vn cv cop vm cv
      vh cv cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a vm cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a vu cv vm cv wceq vm cv vn cv cop vu cv vh cv cop wceq vm
      cv vn cv cop vm cv vh cv cop wceq vm cv vn cv cop vv cv vg cv cop wceq vu
      cv vm cv wceq vu cv vh cv cop vm cv vh cv cop vm cv vn cv cop vu cv vm cv
      vh cv opeq1 eqeq2d anbi1d vu cv vm cv wceq vu cv vh cv wcel vm cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss vu cv vm cv vh cv eleq1 3anbi1d
      anbi12d 2rexbidv vv cv vm cv wceq vm cv vn cv cop vm cv vh cv cop wceq vm
      cv vn cv cop vv cv vg cv cop wceq wa vm cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vm cv vn cv cop vm cv vh cv cop wceq vm cv vn cv cop
      vm cv vg cv cop wceq wa vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss
      w3a wa vh vg cF cF vv cv vm cv wceq vm cv vn cv cop vm cv vh cv cop wceq
      vm cv vn cv cop vv cv vg cv cop wceq wa vm cv vn cv cop vm cv vh cv cop
      wceq vm cv vn cv cop vm cv vg cv cop wceq wa vm cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv
      wss w3a vv cv vm cv wceq vm cv vn cv cop vv cv vg cv cop wceq vm cv vn cv
      cop vm cv vg cv cop wceq vm cv vn cv cop vm cv vh cv cop wceq vv cv vm cv
      wceq vv cv vg cv cop vm cv vg cv cop vm cv vn cv cop vv cv vm cv vg cv
      opeq1 eqeq2d anbi2d vv cv vm cv wceq vv cv vg cv wcel vm cv vg cv wcel vm
      cv vh cv wcel vg cv vh cv wss vv cv vm cv vg cv eleq1 3anbi2d anbi12d
      2rexbidv rcla42ev vn cv cF wcel vm cv vn cv wcel wa vm cv cF cuni cX vm
      cv vn cv wcel vn cv cF wcel vm cv cF cuni wcel vm cv vn cv cF elunii
      ancoms filnet.1 syl6eleqr vn cv cF wcel vm cv vn cv wcel wa vm cv cF cuni
      cX vm cv vn cv wcel vn cv cF wcel vm cv cF cuni wcel vm cv vn cv cF
      elunii ancoms filnet.1 syl6eleqr vn cv cF wcel vn cv cF wcel vm cv vn cv
      cop vm cv vn cv cop wceq vm cv vn cv cop vm cv vn cv cop wceq wa vm cv vn
      cv wcel vm cv vn cv wcel vn cv vn cv wss w3a wa vm cv vn cv cop vm cv vh
      cv cop wceq vm cv vn cv cop vm cv vg cv cop wceq wa vm cv vh cv wcel vm
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vn cv cF wcel
      vm cv vn cv wcel wa vm cv vn cv cop vm cv vh cv cop wceq vm cv vn cv cop
      vm cv vg cv cop wceq wa vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss
      w3a wa vm cv vn cv cop vm cv vn cv cop wceq vm cv vn cv cop vm cv vn cv
      cop wceq wa vm cv vn cv wcel vm cv vn cv wcel vn cv vn cv wss w3a wa vm
      cv vn cv cop vm cv vn cv cop wceq vm cv vn cv cop vm cv vg cv cop wceq wa
      vm cv vn cv wcel vm cv vg cv wcel vg cv vn cv wss w3a wa vh vg vn cv vn
      cv cF cF vh cv vn cv wceq vm cv vn cv cop vm cv vh cv cop wceq vm cv vn
      cv cop vm cv vg cv cop wceq wa vm cv vn cv cop vm cv vn cv cop wceq vm cv
      vn cv cop vm cv vg cv cop wceq wa vm cv vh cv wcel vm cv vg cv wcel vg cv
      vh cv wss w3a vm cv vn cv wcel vm cv vg cv wcel vg cv vn cv wss w3a vh cv
      vn cv wceq vm cv vn cv cop vm cv vh cv cop wceq vm cv vn cv cop vm cv vn
      cv cop wceq vm cv vn cv cop vm cv vg cv cop wceq vh cv vn cv wceq vm cv
      vh cv cop vm cv vn cv cop vm cv vn cv cop vh cv vn cv vm cv opeq2 eqeq2d
      anbi1d vh cv vn cv wceq vm cv vh cv wcel vm cv vn cv wcel vg cv vh cv wss
      vg cv vn cv wss vm cv vg cv wcel vh cv vn cv vm cv eleq2 vh cv vn cv vg
      cv sseq2 3anbi13d anbi12d vg cv vn cv wceq vm cv vn cv cop vm cv vn cv
      cop wceq vm cv vn cv cop vm cv vg cv cop wceq wa vm cv vn cv cop vm cv vn
      cv cop wceq vm cv vn cv cop vm cv vn cv cop wceq wa vm cv vn cv wcel vm
      cv vg cv wcel vg cv vn cv wss w3a vm cv vn cv wcel vm cv vn cv wcel vn cv
      vn cv wss w3a vg cv vn cv wceq vm cv vn cv cop vm cv vg cv cop wceq vm cv
      vn cv cop vm cv vn cv cop wceq vm cv vn cv cop vm cv vn cv cop wceq vg cv
      vn cv wceq vm cv vg cv cop vm cv vn cv cop vm cv vn cv cop vg cv vn cv vm
      cv opeq2 eqeq2d anbi2d vg cv vn cv wceq vm cv vg cv wcel vm cv vn cv wcel
      vg cv vn cv wss vn cv vn cv wss vm cv vn cv wcel vg cv vn cv vm cv eleq2
      vg cv vn cv vn cv sseq1 3anbi23d anbi12d rcla42ev vn cv cF wcel vm cv vn
      cv wcel pm3.26 vn cv cF wcel vm cv vn cv wcel pm3.26 vn cv cF wcel vm cv
      vn cv wcel wa vm cv vn cv wcel vm cv vn cv wcel vn cv vn cv wss w3a vm cv
      vn cv cop vm cv vn cv cop wceq vm cv vn cv cop vm cv vn cv cop wceq wa vn
      cv cF wcel vm cv vn cv wcel wa vm cv vn cv wcel vm cv vn cv wcel vn cv vn
      cv wss vn cv cF wcel vm cv vn cv wcel pm3.27 vn cv cF wcel vm cv vn cv
      wcel pm3.27 vn cv vn cv wss vn cv cF wcel vm cv vn cv wcel wa vn cv ssid
      a1i 3jca vm cv vn cv cop vm cv vn cv cop wceq vm cv vn cv cop vm cv vn cv
      cop wceq vm cv vn cv cop eqid vm cv vn cv cop eqid pm3.2i jctil syl3anc
      syl3anc vm cv vn cv cop vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vm cv vn cv cop vu cv vh cv cop wceq vm cv
      vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vy vm cv vn
      cv cop vm cv vn cv opex vy cv vm cv vn cv cop wceq vm cv vn cv cop vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vm cv vn cv cop vu cv
      vh cv cop wceq vm cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX
      vy cv vm cv vn cv cop wceq vm cv vn cv cop vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vm cv vn cv cop vu cv vh cv cop wceq vm cv vn cv cop vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh
      vg cF cF vy cv vm cv vn cv cop wceq vm cv vn cv cop vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vm cv vn cv cop vu cv vh cv cop wceq vm cv
      vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a vy cv vm cv vn cv cop wceq vy cv vv cv vg cv cop wceq vm cv
      vn cv cop vv cv vg cv cop wceq vm cv vn cv cop vu cv vh cv cop wceq vy cv
      vm cv vn cv cop vv cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv
      cla4ev syl vm cv vn cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vm cv vn cv
      cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vy wex vx cab wcel vm cv vn cv cop vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vy wex vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vy wex vx cab vm cv vn cv cop vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy dmopab eleq2i vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vy wex vm cv vn cv cop vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vy wex
      vx vm cv vn cv cop vm cv vn cv opex vx cv vm cv vn cv cop wceq vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vm cv vn cv cop vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vy vx cv vm cv vn cv cop wceq vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vm cv vn cv cop vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vx cv vm cv
      vn cv cop wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vm cv vn cv cop
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vx cv vm cv vn cv cop wceq
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vm cv vn cv cop
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vx cv vm cv vn cv cop wceq vx cv vu cv vh
      cv cop wceq vm cv vn cv cop vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq vx cv vm cv vn cv cop vu cv vh cv cop eqeq1 anbi1d anbi1d 2rexbidv
      2rexbidv exbidv elab bitr2i sylib syl5cbir impcom 19.23aivv sylbi sseldd
      impbii eqriv $.
      $( [15-Dec-2009] $) $( [13-Dec-2009] $)

    $( Lemma for ~ filnet . Change variables. $)
    filnetlem2 $p |- ( E. u e. X E. v e. X E. h e. F E. g e. F ( ( a = <. u , h
    >. /\ b = <. v , g >. ) /\ ( u e. h /\ v e. g /\ g C_ h ) ) <-> E. d e. X
    E. j e. X E. k e. F E. l e. F ( ( a = <. d , k >. /\ b = <. j , l >. ) /\ (
    d e. k /\ j e. l /\ l C_ k ) ) ) $=
      va cv vu cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex va cv vd cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vd cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vd cX wrex va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop
      wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vl cF
      wrex vk cF wrex vj cX wrex vd cX wrex va cv vu cv vh cv cop wceq vb cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex va cv vd cv vh cv cop wceq vb cv
      vv cv vg cv cop wceq wa vd cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu vd cX vu cv vd cv wceq va cv
      vu cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex va cv vd cv vh cv cop wceq
      vb cv vv cv vg cv cop wceq wa vd cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vv vh cX cF vu cv vd cv wceq va cv vu cv vh cv
      cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa va cv vd cv vh cv cop wceq vb cv vv cv vg cv cop
      wceq wa vd cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF vu
      cv vd cv wceq va cv vu cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa va
      cv vd cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a vd cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a vu cv vd cv wceq va cv vu cv vh cv cop wceq va cv vd cv vh
      cv cop wceq vb cv vv cv vg cv cop wceq vu cv vd cv wceq vu cv vh cv cop
      vd cv vh cv cop va cv vu cv vd cv vh cv opeq1 eqeq2d anbi1d vu cv vd cv
      wceq vu cv vh cv wcel vd cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      vu cv vd cv vh cv eleq1 3anbi1d anbi12d rexbidv 2rexbidv cbvrexv va cv vd
      cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vd cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex va cv vd
      cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl
      cv wcel vl cv vk cv wss w3a wa vl cF wrex vk cF wrex vj cX wrex vd cX va
      cv vd cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vd cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex va
      cv vd cv vh cv cop wceq vb cv vj cv vg cv cop wceq wa vd cv vh cv wcel vj
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vj cX wrex va
      cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj
      cv vl cv wcel vl cv vk cv wss w3a wa vl cF wrex vk cF wrex vj cX wrex va
      cv vd cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vd cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex va cv vd cv vh
      cv cop wceq vb cv vj cv vg cv cop wceq wa vd cv vh cv wcel vj cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv vj cX vv cv vj cv
      wceq va cv vd cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vd cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa va cv vd cv vh cv cop wceq
      vb cv vj cv vg cv cop wceq wa vd cv vh cv wcel vj cv vg cv wcel vg cv vh
      cv wss w3a wa vh vg cF cF vv cv vj cv wceq va cv vd cv vh cv cop wceq vb
      cv vv cv vg cv cop wceq wa va cv vd cv vh cv cop wceq vb cv vj cv vg cv
      cop wceq wa vd cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vd cv
      vh cv wcel vj cv vg cv wcel vg cv vh cv wss w3a vv cv vj cv wceq vb cv vv
      cv vg cv cop wceq vb cv vj cv vg cv cop wceq va cv vd cv vh cv cop wceq
      vv cv vj cv wceq vv cv vg cv cop vj cv vg cv cop vb cv vv cv vj cv vg cv
      opeq1 eqeq2d anbi2d vv cv vj cv wceq vv cv vg cv wcel vj cv vg cv wcel vd
      cv vh cv wcel vg cv vh cv wss vv cv vj cv vg cv eleq1 3anbi2d anbi12d
      2rexbidv cbvrexv va cv vd cv vh cv cop wceq vb cv vj cv vg cv cop wceq wa
      vd cv vh cv wcel vj cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vl cF wrex vk cF wrex vj cX
      va cv vd cv vh cv cop wceq vb cv vj cv vg cv cop wceq wa vd cv vh cv wcel
      vj cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex va cv vd cv
      vk cv cop wceq vb cv vj cv vg cv cop wceq wa vd cv vk cv wcel vj cv vg cv
      wcel vg cv vk cv wss w3a wa vg cF wrex vk cF wrex va cv vd cv vk cv cop
      wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl
      cv vk cv wss w3a wa vl cF wrex vk cF wrex va cv vd cv vh cv cop wceq vb
      cv vj cv vg cv cop wceq wa vd cv vh cv wcel vj cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex va cv vd cv vk cv cop wceq vb cv vj cv vg cv cop
      wceq wa vd cv vk cv wcel vj cv vg cv wcel vg cv vk cv wss w3a wa vg cF
      wrex vh vk cF vh cv vk cv wceq va cv vd cv vh cv cop wceq vb cv vj cv vg
      cv cop wceq wa vd cv vh cv wcel vj cv vg cv wcel vg cv vh cv wss w3a wa
      va cv vd cv vk cv cop wceq vb cv vj cv vg cv cop wceq wa vd cv vk cv wcel
      vj cv vg cv wcel vg cv vk cv wss w3a wa vg cF vh cv vk cv wceq va cv vd
      cv vh cv cop wceq vb cv vj cv vg cv cop wceq wa va cv vd cv vk cv cop
      wceq vb cv vj cv vg cv cop wceq wa vd cv vh cv wcel vj cv vg cv wcel vg
      cv vh cv wss w3a vd cv vk cv wcel vj cv vg cv wcel vg cv vk cv wss w3a vh
      cv vk cv wceq va cv vd cv vh cv cop wceq va cv vd cv vk cv cop wceq vb cv
      vj cv vg cv cop wceq vh cv vk cv wceq vd cv vh cv cop vd cv vk cv cop va
      cv vh cv vk cv vd cv opeq2 eqeq2d anbi1d vh cv vk cv wceq vd cv vh cv
      wcel vd cv vk cv wcel vg cv vh cv wss vg cv vk cv wss vj cv vg cv wcel vh
      cv vk cv vd cv eleq2 vh cv vk cv vg cv sseq2 3anbi13d anbi12d rexbidv
      cbvrexv va cv vd cv vk cv cop wceq vb cv vj cv vg cv cop wceq wa vd cv vk
      cv wcel vj cv vg cv wcel vg cv vk cv wss w3a wa vg cF wrex va cv vd cv vk
      cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv
      wcel vl cv vk cv wss w3a wa vl cF wrex vk cF va cv vd cv vk cv cop wceq
      vb cv vj cv vg cv cop wceq wa vd cv vk cv wcel vj cv vg cv wcel vg cv vk
      cv wss w3a wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd
      cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vg vl cF vg cv vl
      cv wceq va cv vd cv vk cv cop wceq vb cv vj cv vg cv cop wceq wa va cv vd
      cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vg
      cv wcel vg cv vk cv wss w3a vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv
      wss w3a vg cv vl cv wceq vb cv vj cv vg cv cop wceq vb cv vj cv vl cv cop
      wceq va cv vd cv vk cv cop wceq vg cv vl cv wceq vj cv vg cv cop vj cv vl
      cv cop vb cv vg cv vl cv vj cv opeq2 eqeq2d anbi2d vg cv vl cv wceq vj cv
      vg cv wcel vj cv vl cv wcel vg cv vk cv wss vl cv vk cv wss vd cv vk cv
      wcel vg cv vl cv vj cv eleq2 vg cv vl cv vk cv sseq1 3anbi23d anbi12d
      cbvrexv rexbii bitri rexbii bitri rexbii bitri $.
      $( [15-Dec-2009] $) $( [13-Dec-2009] $)

    $( Lemma for ~ filnet . $)
    filnetlem3 $p |- ( F e. Fil -> A. a e. U. U. { <. x , y >. | E. u e. X E. v
    e. X E. h e. F E. g e. F ( ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e.
    h /\ v e. g /\ g C_ h ) ) } A. b e. U. U. { <. x , y >. | E. u e. X E. v e.
    X E. h e. F E. g e. F ( ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e. h
    /\ v e. g /\ g C_ h ) ) } E. c e. U. U. { <. x , y >. | E. u e. X E. v e. X
    E. h e. F E. g e. F ( ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e. h /\
    v e. g /\ g C_ h ) ) } ( a { <. x , y >. | E. u e. X E. v e. X E. h e. F E.
    g e. F ( ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e. h /\ v e. g /\ g
    C_ h ) ) } c /\ b { <. x , y >. | E. u e. X E. v e. X E. h e. F E. g e. F (
    ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e. h /\ v e. g /\ g C_ h ) )
    } c ) ) $=
      cF cfil wcel va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wbr wa vc vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wrex va vb
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cuni cuni vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni cF
      cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa vs wex
      vr wex vn wex vm wex va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab wbr wa vc vw cv cF wcel vz cv vw cv wcel wa
      vz vw copab wrex va cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wcel vb cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cuni cuni wcel wa va cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni wrex cF cfil wcel va cv vm cv vn cv cop wceq vn cv
      cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel
      vr cv vs cv wcel wa wa wa vs wex vr wex va cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vw cv cF wcel
      vz cv vw cv wcel wa vz vw copab wrex vm vn cF cfil wcel va cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq
      vs cv cF wcel vr cv vs cv wcel wa wa wa va cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vw cv cF wcel
      vz cv vw cv wcel wa vz vw copab wrex vr vs cF cfil wcel va cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq
      vs cv cF wcel vr cv vs cv wcel wa wa wa va cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vw cv cF wcel
      vz cv vw cv wcel wa vz vw copab wrex cF cfil wcel va cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs
      cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel vd wex
      va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr wa vc vw cv cF wcel vz cv vw cv wcel wa vz vw copab wrex cF
      cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vn
      cv vs cv cin c0 wceq wn vd cv vn cv vs cv cin wcel vd wex cF cfil wcel va
      cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv
      vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vn cv vs cv cin
      c0 wceq c0 cF wcel cF cfil wcel c0 cF wcel wn va cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF
      wcel vr cv vs cv wcel wa wa wa cF filesn adantr vn cv vs cv cin c0 wceq
      vn cv vs cv cin cF wcel c0 cF wcel cF cfil wcel va cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs
      cv cF wcel vr cv vs cv wcel wa wa wa wa vn cv vs cv cin c0 cF eleq1 cF
      cfil wcel vn cv cF wcel vm cv vn cv wcel wa vb cv vr cv vs cv cop wceq vs
      cv cF wcel vr cv vs cv wcel wa wa vn cv vs cv cin cF wcel va cv vm cv vn
      cv cop wceq cF cfil wcel vn cv cF wcel vb cv vr cv vs cv cop wceq vs cv
      cF wcel vr cv vs cv wcel wa wa vn cv vs cv cin cF wcel vm cv vn cv wcel
      cF cfil wcel vn cv cF wcel vs cv cF wcel vr cv vs cv wcel wa vn cv vs cv
      cin cF wcel vb cv vr cv vs cv cop wceq cF cfil wcel vn cv cF wcel vs cv
      cF wcel vn cv vs cv cin cF wcel vr cv vs cv wcel cF cfil wcel vn cv cF
      wcel vs cv cF wcel vn cv vs cv cin cF wcel vn cv vs cv cF filint 3expb
      adantrrr adantrrl adantrlr adantrll syl5cbi mtod vd vn cv vs cv cin neq0
      sylib cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa
      wa wa wa vd cv vn cv vs cv cin wcel va cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vw cv cF wcel
      vz cv vw cv wcel wa vz vw copab wrex vd cF cfil wcel va cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq
      vs cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel va
      cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr wa vc vw cv cF wcel vz cv vw cv wcel wa vz vw copab wrex vd cv
      vn cv vs cv cin cop vw cv cF wcel vz cv vw cv wcel wa vz vw copab wcel va
      cv vd cv vn cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vd cv vn
      cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr wa va cv vc cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vw cv cF
      wcel vz cv vw cv wcel wa vz vw copab wrex cF cfil wcel va cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq
      vs cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa
      va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr wa va cv vd cv vn cv vs cv cin cop vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr
      vb cv vd cv vn cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vd cv
      vn cv vs cv cin cop vw cv cF wcel vz cv vw cv wcel wa vz vw copab vc cv
      vd cv vn cv vs cv cin cop wceq va cv vc cv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr va
      cv vd cv vn cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab wbr vb cv vd cv vn cv vs cv cin cop vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr vc cv vd cv vn cv vs cv cin cop va cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab breq2 vc cv vd cv vn cv vs cv cin cop vb cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab breq2 anbi12d rcla4ev cF cfil wcel va cv vm cv vn cv cop wceq vn cv
      cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel
      vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa vn cv vs cv
      cin cF wcel vd cv vn cv vs cv cin wcel wa vd cv vn cv vs cv cin cop vw cv
      cF wcel vz cv vw cv wcel wa vz vw copab wcel cF cfil wcel va cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vn cv vs cv cin cF wcel
      vd cv vn cv vs cv cin wcel cF cfil wcel vn cv cF wcel vm cv vn cv wcel wa
      vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa vn cv vs
      cv cin cF wcel va cv vm cv vn cv cop wceq cF cfil wcel vn cv cF wcel vb
      cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa vn cv vs cv
      cin cF wcel vm cv vn cv wcel cF cfil wcel vn cv cF wcel vs cv cF wcel vr
      cv vs cv wcel wa vn cv vs cv cin cF wcel vb cv vr cv vs cv cop wceq cF
      cfil wcel vn cv cF wcel vs cv cF wcel vn cv vs cv cin cF wcel vr cv vs cv
      wcel cF cfil wcel vn cv cF wcel vs cv cF wcel vn cv vs cv cin cF wcel vn
      cv vs cv cF filint 3expb adantrrr adantrrl adantrlr adantrll anim1i vw cv
      cF wcel vz cv vw cv wcel wa vw cv cF wcel vd cv vw cv wcel wa vn cv vs cv
      cin cF wcel vd cv vn cv vs cv cin wcel wa vz vw vd cv vn cv vs cv cin vd
      visset vn cv vs cv vn visset inex1 vz cv vd cv wceq vz cv vw cv wcel vd
      cv vw cv wcel vw cv cF wcel vz cv vd cv vw cv eleq1 anbi2d vw cv vn cv vs
      cv cin wceq vw cv cF wcel vn cv vs cv cin cF wcel vd cv vw cv wcel vd cv
      vn cv vs cv cin wcel vw cv vn cv vs cv cin cF eleq1 vw cv vn cv vs cv cin
      vd cv eleq2 anbi12d opelopab sylibr cF cfil wcel va cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs
      cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa va
      cv vu cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vb cv vu cv vh cv cop wceq vd cv vn cv vs cv
      cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex wa va cv vd
      cv vn cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vd cv vn cv
      vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr wa cF cfil wcel va cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin
      wcel wa va cv vu cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vb cv vu cv vh cv cop wceq vd cv
      vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vm cv cX wcel vd cv cX wcel va cv vm cv vh cv cop wceq vd cv vn cv vs cv
      cin cop vd cv vg cv cop wceq wa vm cv vh cv wcel vd cv vg cv wcel vg cv
      vh cv wss w3a wa vg cF wrex vh cF wrex va cv vu cv vh cv cop wceq vd cv
      vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa
      wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa
      vd cv vn cv vs cv cin wcel wa va cv vu cv vh cv cop wceq vd cv vn cv vs
      cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex va cv vm cv vh cv cop wceq vd
      cv vn cv vs cv cin cop vd cv vg cv cop wceq wa vm cv vh cv wcel vd cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex va cv vm cv vh cv
      cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vm cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv
      vm cv vd cv cX cX vu cv vm cv wceq va cv vu cv vh cv cop wceq vd cv vn cv
      vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa va cv vm cv vh cv cop wceq vd cv vn cv vs cv cin
      cop vv cv vg cv cop wceq wa vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vh vg cF cF vu cv vm cv wceq va cv vu cv vh cv cop wceq vd cv
      vn cv vs cv cin cop vv cv vg cv cop wceq wa va cv vm cv vh cv cop wceq vd
      cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a vu cv vm cv wceq va cv vu cv vh cv cop wceq va cv vm cv vh cv cop
      wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq vu cv vm cv wceq vu
      cv vh cv cop vm cv vh cv cop va cv vu cv vm cv vh cv opeq1 eqeq2d anbi1d
      vu cv vm cv wceq vu cv vh cv wcel vm cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss vu cv vm cv vh cv eleq1 3anbi1d anbi12d 2rexbidv vv cv vd cv
      wceq va cv vm cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop
      wceq wa vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa va cv vm
      cv vh cv cop wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq wa vm cv
      vh cv wcel vd cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vv cv vd
      cv wceq va cv vm cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv
      cop wceq wa va cv vm cv vh cv cop wceq vd cv vn cv vs cv cin cop vd cv vg
      cv cop wceq wa vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vm
      cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss w3a vv cv vd cv wceq vd cv
      vn cv vs cv cin cop vv cv vg cv cop wceq vd cv vn cv vs cv cin cop vd cv
      vg cv cop wceq va cv vm cv vh cv cop wceq vv cv vd cv wceq vv cv vg cv
      cop vd cv vg cv cop vd cv vn cv vs cv cin cop vv cv vd cv vg cv opeq1
      eqeq2d anbi2d vv cv vd cv wceq vv cv vg cv wcel vd cv vg cv wcel vm cv vh
      cv wcel vg cv vh cv wss vv cv vd cv vg cv eleq1 3anbi2d anbi12d 2rexbidv
      rcla42ev va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa vm cv
      cX wcel cF cfil wcel vd cv vn cv vs cv cin wcel vn cv cF wcel vm cv vn cv
      wcel wa vm cv cX wcel va cv vm cv vn cv cop wceq vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa wa vn cv cF wcel vm cv vn cv wcel
      wa vm cv cF cuni cX vm cv vn cv wcel vn cv cF wcel vm cv cF cuni wcel vm
      cv vn cv cF elunii ancoms filnet.1 syl6eleqr ad2antlr ad2antlr va cv vm
      cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv
      cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa vd cv vn cv vs cv cin
      wcel vd cv cX wcel cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa vd cv vn cv vs cv cin wcel vd cv cX wcel vb cv vr
      cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa vn cv cF wcel vm
      cv vn cv wcel wa vd cv vn cv vs cv cin wcel vd cv cX wcel va cv vm cv vn
      cv cop wceq vn cv cF wcel vd cv vn cv vs cv cin wcel vd cv cX wcel vm cv
      vn cv wcel vn cv cF wcel vd cv vn cv wcel vd cv cX wcel vd cv vn cv vs cv
      cin wcel vn cv cF wcel vd cv vn cv wcel wa vd cv cF cuni cX vd cv vn cv
      wcel vn cv cF wcel vd cv cF cuni wcel vd cv vn cv cF elunii ancoms
      filnet.1 syl6eleqr vn cv vs cv cin vn cv vd cv vn cv vs cv inss1 sseli
      sylan2 adantlr adantll adantlr adantll vn cv cF wcel vn cv vs cv cin cF
      wcel va cv vm cv vn cv cop wceq vd cv vn cv vs cv cin cop vd cv vn cv vs
      cv cin cop wceq wa vm cv vn cv wcel vd cv vn cv vs cv cin wcel vn cv vs
      cv cin vn cv wss w3a wa va cv vm cv vh cv cop wceq vd cv vn cv vs cv cin
      cop vd cv vg cv cop wceq wa vm cv vh cv wcel vd cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex cF cfil wcel va cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF
      wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa va cv vm
      cv vh cv cop wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq wa vm cv
      vh cv wcel vd cv vg cv wcel vg cv vh cv wss w3a wa va cv vm cv vn cv cop
      wceq vd cv vn cv vs cv cin cop vd cv vn cv vs cv cin cop wceq wa vm cv vn
      cv wcel vd cv vn cv vs cv cin wcel vn cv vs cv cin vn cv wss w3a wa va cv
      vm cv vn cv cop wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq wa vm
      cv vn cv wcel vd cv vg cv wcel vg cv vn cv wss w3a wa vh vg vn cv vn cv
      vs cv cin cF cF vh cv vn cv wceq va cv vm cv vh cv cop wceq vd cv vn cv
      vs cv cin cop vd cv vg cv cop wceq wa va cv vm cv vn cv cop wceq vd cv vn
      cv vs cv cin cop vd cv vg cv cop wceq wa vm cv vh cv wcel vd cv vg cv
      wcel vg cv vh cv wss w3a vm cv vn cv wcel vd cv vg cv wcel vg cv vn cv
      wss w3a vh cv vn cv wceq va cv vm cv vh cv cop wceq va cv vm cv vn cv cop
      wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq vh cv vn cv wceq vm
      cv vh cv cop vm cv vn cv cop va cv vh cv vn cv vm cv opeq2 eqeq2d anbi1d
      vh cv vn cv wceq vm cv vh cv wcel vm cv vn cv wcel vg cv vh cv wss vg cv
      vn cv wss vd cv vg cv wcel vh cv vn cv vm cv eleq2 vh cv vn cv vg cv
      sseq2 3anbi13d anbi12d vg cv vn cv vs cv cin wceq va cv vm cv vn cv cop
      wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq wa va cv vm cv vn cv
      cop wceq vd cv vn cv vs cv cin cop vd cv vn cv vs cv cin cop wceq wa vm
      cv vn cv wcel vd cv vg cv wcel vg cv vn cv wss w3a vm cv vn cv wcel vd cv
      vn cv vs cv cin wcel vn cv vs cv cin vn cv wss w3a vg cv vn cv vs cv cin
      wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq vd cv vn cv vs cv cin
      cop vd cv vn cv vs cv cin cop wceq va cv vm cv vn cv cop wceq vg cv vn cv
      vs cv cin wceq vd cv vg cv cop vd cv vn cv vs cv cin cop vd cv vn cv vs
      cv cin cop vg cv vn cv vs cv cin vd cv opeq2 eqeq2d anbi2d vg cv vn cv vs
      cv cin wceq vd cv vg cv wcel vd cv vn cv vs cv cin wcel vg cv vn cv wss
      vn cv vs cv cin vn cv wss vm cv vn cv wcel vg cv vn cv vs cv cin vd cv
      eleq2 vg cv vn cv vs cv cin vn cv sseq1 3anbi23d anbi12d rcla42ev va cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs
      cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa vn cv cF wcel cF cfil
      wcel vd cv vn cv vs cv cin wcel va cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv
      wcel wa wa simplrl ad2antlr cF cfil wcel va cv vm cv vn cv cop wceq vn cv
      cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel
      vr cv vs cv wcel wa wa wa wa vn cv vs cv cin cF wcel vd cv vn cv vs cv
      cin wcel cF cfil wcel vn cv cF wcel vm cv vn cv wcel wa vb cv vr cv vs cv
      cop wceq vs cv cF wcel vr cv vs cv wcel wa wa vn cv vs cv cin cF wcel va
      cv vm cv vn cv cop wceq cF cfil wcel vn cv cF wcel vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa wa vn cv vs cv cin cF wcel vm cv
      vn cv wcel cF cfil wcel vn cv cF wcel vs cv cF wcel vr cv vs cv wcel wa
      vn cv vs cv cin cF wcel vb cv vr cv vs cv cop wceq cF cfil wcel vn cv cF
      wcel vs cv cF wcel vn cv vs cv cin cF wcel vr cv vs cv wcel cF cfil wcel
      vn cv cF wcel vs cv cF wcel vn cv vs cv cin cF wcel vn cv vs cv cF filint
      3expb adantrrr adantrrl adantrlr adantrll adantr cF cfil wcel va cv vm cv
      vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin
      wcel wa va cv vm cv vn cv cop wceq vd cv vn cv vs cv cin cop vd cv vn cv
      vs cv cin cop wceq wa vm cv vn cv wcel vd cv vn cv vs cv cin wcel vn cv
      vs cv cin vn cv wss w3a cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr
      cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa va cv vm cv vn cv
      cop wceq vd cv vn cv vs cv cin cop vd cv vn cv vs cv cin cop wceq va cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs
      cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa va cv vm cv vn cv cop
      wceq cF cfil wcel vd cv vn cv vs cv cin wcel va cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa vb cv vr cv vs cv cop wceq vs cv cF
      wcel vr cv vs cv wcel wa wa simpll ad2antlr vd cv vn cv vs cv cin cop
      eqid jctir cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel
      wa wa wa wa vd cv vn cv vs cv cin wcel wa vm cv vn cv wcel vd cv vn cv vs
      cv cin wcel vn cv vs cv cin vn cv wss va cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr
      cv vs cv wcel wa wa wa vm cv vn cv wcel cF cfil wcel vd cv vn cv vs cv
      cin wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel vb cv
      vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa simplrr
      ad2antlr cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel
      wa wa wa wa vd cv vn cv vs cv cin wcel pm3.27 vn cv vs cv cin vn cv wss
      cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa
      wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa
      vd cv vn cv vs cv cin wcel wa vn cv vs cv inss1 a1i 3jca jca syl3anc
      syl3anc vr cv cX wcel vd cv cX wcel vb cv vr cv vh cv cop wceq vd cv vn
      cv vs cv cin cop vd cv vg cv cop wceq wa vr cv vh cv wcel vd cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vb cv vu cv vh cv cop
      wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel
      wa wa wa wa vd cv vn cv vs cv cin wcel wa vb cv vu cv vh cv cop wceq vd
      cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vb cv vr cv vh cv
      cop wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq wa vr cv vh cv
      wcel vd cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vb cv
      vr cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vr
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vu vv vr cv vd cv cX cX vu cv vr cv wceq vb cv vu cv vh cv cop wceq
      vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vb cv vr cv vh cv cop wceq vd cv vn cv
      vs cv cin cop vv cv vg cv cop wceq wa vr cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vh vg cF cF vu cv vr cv wceq vb cv vu cv vh cv cop
      wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vb cv vr cv vh cv
      cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a vr cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a vu cv vr cv wceq vb cv vu cv vh cv cop wceq vb
      cv vr cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq vu
      cv vr cv wceq vu cv vh cv cop vr cv vh cv cop vb cv vu cv vr cv vh cv
      opeq1 eqeq2d anbi1d vu cv vr cv wceq vu cv vh cv wcel vr cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss vu cv vr cv vh cv eleq1 3anbi1d anbi12d
      2rexbidv vv cv vd cv wceq vb cv vr cv vh cv cop wceq vd cv vn cv vs cv
      cin cop vv cv vg cv cop wceq wa vr cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a wa vb cv vr cv vh cv cop wceq vd cv vn cv vs cv cin cop vd
      cv vg cv cop wceq wa vr cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss
      w3a wa vh vg cF cF vv cv vd cv wceq vb cv vr cv vh cv cop wceq vd cv vn
      cv vs cv cin cop vv cv vg cv cop wceq wa vb cv vr cv vh cv cop wceq vd cv
      vn cv vs cv cin cop vd cv vg cv cop wceq wa vr cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a vr cv vh cv wcel vd cv vg cv wcel vg cv vh cv
      wss w3a vv cv vd cv wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq
      vd cv vn cv vs cv cin cop vd cv vg cv cop wceq vb cv vr cv vh cv cop wceq
      vv cv vd cv wceq vv cv vg cv cop vd cv vg cv cop vd cv vn cv vs cv cin
      cop vv cv vd cv vg cv opeq1 eqeq2d anbi2d vv cv vd cv wceq vv cv vg cv
      wcel vd cv vg cv wcel vr cv vh cv wcel vg cv vh cv wss vv cv vd cv vg cv
      eleq1 3anbi2d anbi12d 2rexbidv rcla42ev va cv vm cv vn cv cop wceq vn cv
      cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel
      vr cv vs cv wcel wa wa wa vr cv cX wcel cF cfil wcel vd cv vn cv vs cv
      cin wcel vs cv cF wcel vr cv vs cv wcel wa vr cv cX wcel va cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa vr cv cF cuni cX vr cv vs cv wcel
      vs cv cF wcel vr cv cF cuni wcel vr cv vs cv cF elunii ancoms filnet.1
      syl6eleqr ad2antll ad2antlr va cv vm cv vn cv cop wceq vn cv cF wcel vm
      cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv
      wcel wa wa wa vd cv vn cv vs cv cin wcel vd cv cX wcel cF cfil wcel va cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vd cv vn cv vs
      cv cin wcel vd cv cX wcel vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv
      vs cv wcel wa wa vn cv cF wcel vm cv vn cv wcel wa vd cv vn cv vs cv cin
      wcel vd cv cX wcel va cv vm cv vn cv cop wceq vn cv cF wcel vd cv vn cv
      vs cv cin wcel vd cv cX wcel vm cv vn cv wcel vn cv cF wcel vd cv vn cv
      wcel vd cv cX wcel vd cv vn cv vs cv cin wcel vn cv cF wcel vd cv vn cv
      wcel wa vd cv cF cuni cX vd cv vn cv wcel vn cv cF wcel vd cv cF cuni
      wcel vd cv vn cv cF elunii ancoms filnet.1 syl6eleqr vn cv vs cv cin vn
      cv vd cv vn cv vs cv inss1 sseli sylan2 adantlr adantll adantlr adantll
      vs cv cF wcel vn cv vs cv cin cF wcel vb cv vr cv vs cv cop wceq vd cv vn
      cv vs cv cin cop vd cv vn cv vs cv cin cop wceq wa vr cv vs cv wcel vd cv
      vn cv vs cv cin wcel vn cv vs cv cin vs cv wss w3a wa vb cv vr cv vh cv
      cop wceq vd cv vn cv vs cv cin cop vd cv vg cv cop wceq wa vr cv vh cv
      wcel vd cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex cF
      cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vd
      cv vn cv vs cv cin wcel wa vb cv vr cv vh cv cop wceq vd cv vn cv vs cv
      cin cop vd cv vg cv cop wceq wa vr cv vh cv wcel vd cv vg cv wcel vg cv
      vh cv wss w3a wa vb cv vr cv vs cv cop wceq vd cv vn cv vs cv cin cop vd
      cv vn cv vs cv cin cop wceq wa vr cv vs cv wcel vd cv vn cv vs cv cin
      wcel vn cv vs cv cin vs cv wss w3a wa vb cv vr cv vs cv cop wceq vd cv vn
      cv vs cv cin cop vd cv vg cv cop wceq wa vr cv vs cv wcel vd cv vg cv
      wcel vg cv vs cv wss w3a wa vh vg vs cv vn cv vs cv cin cF cF vh cv vs cv
      wceq vb cv vr cv vh cv cop wceq vd cv vn cv vs cv cin cop vd cv vg cv cop
      wceq wa vb cv vr cv vs cv cop wceq vd cv vn cv vs cv cin cop vd cv vg cv
      cop wceq wa vr cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss w3a vr cv
      vs cv wcel vd cv vg cv wcel vg cv vs cv wss w3a vh cv vs cv wceq vb cv vr
      cv vh cv cop wceq vb cv vr cv vs cv cop wceq vd cv vn cv vs cv cin cop vd
      cv vg cv cop wceq vh cv vs cv wceq vr cv vh cv cop vr cv vs cv cop vb cv
      vh cv vs cv vr cv opeq2 eqeq2d anbi1d vh cv vs cv wceq vr cv vh cv wcel
      vr cv vs cv wcel vg cv vh cv wss vg cv vs cv wss vd cv vg cv wcel vh cv
      vs cv vr cv eleq2 vh cv vs cv vg cv sseq2 3anbi13d anbi12d vg cv vn cv vs
      cv cin wceq vb cv vr cv vs cv cop wceq vd cv vn cv vs cv cin cop vd cv vg
      cv cop wceq wa vb cv vr cv vs cv cop wceq vd cv vn cv vs cv cin cop vd cv
      vn cv vs cv cin cop wceq wa vr cv vs cv wcel vd cv vg cv wcel vg cv vs cv
      wss w3a vr cv vs cv wcel vd cv vn cv vs cv cin wcel vn cv vs cv cin vs cv
      wss w3a vg cv vn cv vs cv cin wceq vd cv vn cv vs cv cin cop vd cv vg cv
      cop wceq vd cv vn cv vs cv cin cop vd cv vn cv vs cv cin cop wceq vb cv
      vr cv vs cv cop wceq vg cv vn cv vs cv cin wceq vd cv vg cv cop vd cv vn
      cv vs cv cin cop vd cv vn cv vs cv cin cop vg cv vn cv vs cv cin vd cv
      opeq2 eqeq2d anbi2d vg cv vn cv vs cv cin wceq vd cv vg cv wcel vd cv vn
      cv vs cv cin wcel vg cv vs cv wss vn cv vs cv cin vs cv wss vr cv vs cv
      wcel vg cv vn cv vs cv cin vd cv eleq2 vg cv vn cv vs cv cin vs cv sseq1
      3anbi23d anbi12d rcla42ev va cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv
      wcel wa wa wa vs cv cF wcel cF cfil wcel vd cv vn cv vs cv cin wcel va cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs
      cv cop wceq vs cv cF wcel vr cv vs cv wcel simprrl ad2antlr cF cfil wcel
      va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr
      cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vn cv vs cv
      cin cF wcel vd cv vn cv vs cv cin wcel cF cfil wcel vn cv cF wcel vm cv
      vn cv wcel wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel
      wa wa vn cv vs cv cin cF wcel va cv vm cv vn cv cop wceq cF cfil wcel vn
      cv cF wcel vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa
      wa vn cv vs cv cin cF wcel vm cv vn cv wcel cF cfil wcel vn cv cF wcel vs
      cv cF wcel vr cv vs cv wcel wa vn cv vs cv cin cF wcel vb cv vr cv vs cv
      cop wceq cF cfil wcel vn cv cF wcel vs cv cF wcel vn cv vs cv cin cF wcel
      vr cv vs cv wcel cF cfil wcel vn cv cF wcel vs cv cF wcel vn cv vs cv cin
      cF wcel vn cv vs cv cF filint 3expb adantrrr adantrrl adantrlr adantrll
      adantr cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa
      wa wa wa vd cv vn cv vs cv cin wcel wa vb cv vr cv vs cv cop wceq vd cv
      vn cv vs cv cin cop vd cv vn cv vs cv cin cop wceq wa vr cv vs cv wcel vd
      cv vn cv vs cv cin wcel vn cv vs cv cin vs cv wss w3a cF cfil wcel va cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs
      cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv
      cin wcel wa vb cv vr cv vs cv cop wceq vd cv vn cv vs cv cin cop vd cv vn
      cv vs cv cin cop wceq va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel
      wa wa wa vb cv vr cv vs cv cop wceq cF cfil wcel vd cv vn cv vs cv cin
      wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb
      cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa simprl ad2antlr
      vd cv vn cv vs cv cin cop eqid jctir cF cfil wcel va cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs
      cv cF wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa vr
      cv vs cv wcel vd cv vn cv vs cv cin wcel vn cv vs cv cin vs cv wss va cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs
      cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa wa vr cv vs cv wcel cF
      cfil wcel vd cv vn cv vs cv cin wcel va cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr
      cv vs cv wcel simprrr ad2antlr cF cfil wcel va cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF
      wcel vr cv vs cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel pm3.27 vn cv
      vs cv cin vs cv wss cF cfil wcel va cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs
      cv wcel wa wa wa wa vd cv vn cv vs cv cin wcel wa vn cv vs cv inss2 a1i
      3jca jca syl3anc syl3anc jca va cv vd cv vn cv vs cv cin cop vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab wbr va cv vu cv vh cv cop wceq vd cv vn cv vs cv cin cop vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vb cv vd cv vn cv vs
      cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab wbr vb cv vu cv vh cv cop wceq vd cv vn
      cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex va cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex va cv vu cv vh cv cop wceq vd cv vn cv vs cv cin
      cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy va cv vd cv
      vn cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab va visset vd cv vn cv vs cv cin
      opex vx cv va cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex va cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vu vv cX cX vx cv va cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa va cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vx cv va cv wceq
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa va cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a vx cv va cv wceq vx cv vu cv vh cv cop wceq va
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq vx cv va cv vu cv vh
      cv cop eqeq1 anbi1d anbi1d 2rexbidv 2rexbidv vy cv vd cv vn cv vs cv cin
      cop wceq va cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      va cv vu cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vu vv cX cX vy cv vd cv vn cv vs cv cin cop wceq va cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa va cv vu cv vh cv cop wceq vd cv vn cv vs cv
      cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a wa vh vg cF cF vy cv vd cv vn cv vs cv cin cop wceq va cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa va cv vu cv vh cv cop
      wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a vy cv vd cv vn cv vs cv cin cop wceq
      vy cv vv cv vg cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq
      va cv vu cv vh cv cop wceq vy cv vd cv vn cv vs cv cin cop vv cv vg cv
      cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab eqid
      brab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vb cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vb cv vu cv vh cv cop wceq vd cv vn cv vs cv
      cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy vb cv
      vd cv vn cv vs cv cin cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vb visset vd cv vn
      cv vs cv cin opex vx cv vb cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vb cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vu vv cX cX vx cv vb cv wceq vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vb cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vx cv
      vb cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vb cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vx cv vb cv wceq vx cv vu cv vh cv cop
      wceq vb cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq vx cv vb cv vu
      cv vh cv cop eqeq1 anbi1d anbi1d 2rexbidv 2rexbidv vy cv vd cv vn cv vs
      cv cin cop wceq vb cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vb cv vu cv vh cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vu vv cX cX vy cv vd cv vn cv vs cv cin cop wceq vb cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vb cv vu cv vh cv cop wceq vd cv vn cv vs
      cv cin cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vh vg cF cF vy cv vd cv vn cv vs cv cin cop wceq vb
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vb cv vu cv vh cv
      cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a vy cv vd cv vn cv vs cv cin cop
      wceq vy cv vv cv vg cv cop wceq vd cv vn cv vs cv cin cop vv cv vg cv cop
      wceq vb cv vu cv vh cv cop wceq vy cv vd cv vn cv vs cv cin cop vv cv vg
      cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      eqid brab anbi12i sylibr sylanc ex 19.23adv mpd ex 19.23advv 19.23advv va
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cuni cuni wcel vb cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cuni cuni wcel wa va cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa vn wex vm wex vb cv vr cv vs cv cop wceq vs cv cF wcel vr
      cv vs cv wcel wa wa vs wex vr wex wa va cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop wceq vs cv cF wcel vr
      cv vs cv wcel wa wa wa vs wex vr wex vn wex vm wex va cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni wcel va cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa vn wex vm wex vb cv vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni
      wcel vb cv vr cv vs cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa vs
      wex vr wex va cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wcel va cv vn cv cF wcel
      vm cv vn cv wcel wa vm vn copab wcel va cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vn wex vm wex vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni
      cuni vn cv cF wcel vm cv vn cv wcel wa vm vn copab va cv vx vy vv vu vg
      vh vm vn cF cX filnet.1 filnetlem1 eleq2i vn cv cF wcel vm cv vn cv wcel
      wa vm vn va cv elopab bitri vb cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wcel
      vb cv vs cv cF wcel vr cv vs cv wcel wa vr vs copab wcel vb cv vr cv vs
      cv cop wceq vs cv cF wcel vr cv vs cv wcel wa wa vs wex vr wex vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cuni cuni vs cv cF wcel vr cv vs cv wcel wa vr vs copab
      vb cv vx vy vv vu vg vh vr vs cF cX filnet.1 filnetlem1 eleq2i vs cv cF
      wcel vr cv vs cv wcel wa vr vs vb cv elopab bitri anbi12i va cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vb cv vr cv vs cv cop
      wceq vs cv cF wcel vr cv vs cv wcel wa wa vm vn vr vs ee4anv bitr4i vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cuni cuni vw cv cF wcel vz cv vw cv wcel wa vz vw copab
      wceq va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr wa vc vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wrex va cv vc cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa vc vw
      cv cF wcel vz cv vw cv wcel wa vz vw copab wrex wb vx vy vv vu vg vh vz
      vw cF cX filnet.1 filnetlem1 va cv vc cv vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv
      vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab wbr wa vc vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni
      vw cv cF wcel vz cv vw cv wcel wa vz vw copab rexeq1 ax-mp 3imtr4g
      r19.21aivv $.
      $( [15-Dec-2009] $) $( [15-Dec-2009] $)

    $( Lemma for ~ filnet . $)
    filnetlem4 $p |- ( F e. Fil -> { <. x , y >. | E. u e. X E. v e. X E. h e.
    F E. g e. F ( ( x = <. u , h >. /\ y = <. v , g >. ) /\ ( u e. h /\ v e. g
    /\ g C_ h ) ) } e. Dir ) $=
      cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wrel cid vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni cres vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wss wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ccom vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wss va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab wbr wa vc vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni
      wrex vb vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cuni cuni wral va vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cuni cuni wral wa wa cF cfil wcel vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wrel cid
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cuni cuni cres vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wss wa vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ccom vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wss
      va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr wa vc vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wrex vb vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni wral va vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wral cF
      cfil wcel cid vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni cres vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wss vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab wrel cid vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni
      cuni cres vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab wss cF cfil wcel vr vs cid vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni cres vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cid vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni relres vr cv vs cv cop cid vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cuni cuni cres wcel vr cv vs cv wceq vr cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa vn wex vm wex wa vr cv vs cv cop vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wcel vr cv vs cv cop cid vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni
      cuni cres wcel vr cv vs cv cop cid wcel vr cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      cuni cuni wcel wa vr cv vs cv wceq vr cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vn wex vm wex wa vr cv vs cv cid vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni vs visset opelres vr cv vs cv cop cid wcel vr cv vs
      cv wceq vr cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wcel vr cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn wex vm wex vr cv vs cv
      cop cid wcel vr cv vs cv cid wbr vr cv vs cv wceq vr cv vs cv cid df-br
      vr cv vs cv vs visset ideq bitr3i vr cv vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni
      wcel vr cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vr cv vm cv
      vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn wex vm wex vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cuni cuni vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      vr cv vx vy vv vu vg vh vm vn cF cX filnet.1 filnetlem1 eleq2i vn cv cF
      wcel vm cv vn cv wcel wa vm vn vr cv elopab bitri anbi12i bitri vr cv vm
      cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn wex vm wex vr
      cv vs cv wceq vr cv vs cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wcel vr cv vs cv
      wceq vr cv vr cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wcel vr cv vs cv cop vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab wcel vr cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa vn wex vm wex vr cv vs cv wceq vr cv vr cv cop vr cv vs
      cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab vr cv vs cv vr cv opeq2 eleq1d vr cv vm cv
      vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vr cv vr cv cop vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wcel vm vn vr cv vm cv vn cv cop wceq vn cv cF wcel vm
      cv vn cv wcel wa wa vr cv vu cv vh cv cop wceq vr cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vr cv vr cv cop vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      wcel vm cv cX wcel vm cv cX wcel vr cv vm cv vh cv cop wceq vr cv vm cv
      vg cv cop wceq wa vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vr cv vu cv vh cv cop wceq vr cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vr cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vr cv vu cv vh cv cop wceq vr cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vr cv vm cv vh cv cop wceq vr cv vm cv vg cv cop wceq
      wa vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vr cv vm cv vh cv cop wceq vr cv vv cv vg cv cop wceq wa vm cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu
      vv vm cv vm cv cX cX vu cv vm cv wceq vr cv vu cv vh cv cop wceq vr cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vr cv vm cv vh cv cop wceq vr cv vv cv vg cv cop wceq wa vm cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vu cv vm cv
      wceq vr cv vu cv vh cv cop wceq vr cv vv cv vg cv cop wceq wa vr cv vm cv
      vh cv cop wceq vr cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a vu cv vm cv wceq vr cv vu cv vh cv cop wceq vr cv vm cv vh cv cop
      wceq vr cv vv cv vg cv cop wceq vu cv vm cv wceq vu cv vh cv cop vm cv vh
      cv cop vr cv vu cv vm cv vh cv opeq1 eqeq2d anbi1d vu cv vm cv wceq vu cv
      vh cv wcel vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss vu cv vm cv
      vh cv eleq1 3anbi1d anbi12d 2rexbidv vv cv vm cv wceq vr cv vm cv vh cv
      cop wceq vr cv vv cv vg cv cop wceq wa vm cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vr cv vm cv vh cv cop wceq vr cv vm cv vg cv cop
      wceq wa vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF
      cF vv cv vm cv wceq vr cv vm cv vh cv cop wceq vr cv vv cv vg cv cop wceq
      wa vr cv vm cv vh cv cop wceq vr cv vm cv vg cv cop wceq wa vm cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a vm cv vh cv wcel vm cv vg cv
      wcel vg cv vh cv wss w3a vv cv vm cv wceq vr cv vv cv vg cv cop wceq vr
      cv vm cv vg cv cop wceq vr cv vm cv vh cv cop wceq vv cv vm cv wceq vv cv
      vg cv cop vm cv vg cv cop vr cv vv cv vm cv vg cv opeq1 eqeq2d anbi2d vv
      cv vm cv wceq vv cv vg cv wcel vm cv vg cv wcel vm cv vh cv wcel vg cv vh
      cv wss vv cv vm cv vg cv eleq1 3anbi2d anbi12d 2rexbidv rcla42ev vn cv cF
      wcel vm cv vn cv wcel wa vm cv cX wcel vr cv vm cv vn cv cop wceq vn cv
      cF wcel vm cv vn cv wcel wa vm cv cF cuni cX vm cv vn cv wcel vn cv cF
      wcel vm cv cF cuni wcel vm cv vn cv cF elunii ancoms filnet.1 syl6eleqr
      adantl vn cv cF wcel vm cv vn cv wcel wa vm cv cX wcel vr cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa vm cv cF cuni cX vm cv vn cv
      wcel vn cv cF wcel vm cv cF cuni wcel vm cv vn cv cF elunii ancoms
      filnet.1 syl6eleqr adantl vn cv cF wcel vn cv cF wcel vr cv vm cv vn cv
      cop wceq vr cv vm cv vn cv cop wceq wa vm cv vn cv wcel vm cv vn cv wcel
      vn cv vn cv wss w3a wa vr cv vm cv vh cv cop wceq vr cv vm cv vg cv cop
      wceq wa vm cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vr cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel
      wa wa vr cv vm cv vh cv cop wceq vr cv vm cv vg cv cop wceq wa vm cv vh
      cv wcel vm cv vg cv wcel vg cv vh cv wss w3a wa vr cv vm cv vn cv cop
      wceq vr cv vm cv vn cv cop wceq wa vm cv vn cv wcel vm cv vn cv wcel vn
      cv vn cv wss w3a wa vr cv vm cv vn cv cop wceq vr cv vm cv vg cv cop wceq
      wa vm cv vn cv wcel vm cv vg cv wcel vg cv vn cv wss w3a wa vh vg vn cv
      vn cv cF cF vh cv vn cv wceq vr cv vm cv vh cv cop wceq vr cv vm cv vg cv
      cop wceq wa vr cv vm cv vn cv cop wceq vr cv vm cv vg cv cop wceq wa vm
      cv vh cv wcel vm cv vg cv wcel vg cv vh cv wss w3a vm cv vn cv wcel vm cv
      vg cv wcel vg cv vn cv wss w3a vh cv vn cv wceq vr cv vm cv vh cv cop
      wceq vr cv vm cv vn cv cop wceq vr cv vm cv vg cv cop wceq vh cv vn cv
      wceq vm cv vh cv cop vm cv vn cv cop vr cv vh cv vn cv vm cv opeq2 eqeq2d
      anbi1d vh cv vn cv wceq vm cv vh cv wcel vm cv vn cv wcel vg cv vh cv wss
      vg cv vn cv wss vm cv vg cv wcel vh cv vn cv vm cv eleq2 vh cv vn cv vg
      cv sseq2 3anbi13d anbi12d vg cv vn cv wceq vr cv vm cv vn cv cop wceq vr
      cv vm cv vg cv cop wceq wa vr cv vm cv vn cv cop wceq vr cv vm cv vn cv
      cop wceq wa vm cv vn cv wcel vm cv vg cv wcel vg cv vn cv wss w3a vm cv
      vn cv wcel vm cv vn cv wcel vn cv vn cv wss w3a vg cv vn cv wceq vr cv vm
      cv vg cv cop wceq vr cv vm cv vn cv cop wceq vr cv vm cv vn cv cop wceq
      vg cv vn cv wceq vm cv vg cv cop vm cv vn cv cop vr cv vg cv vn cv vm cv
      opeq2 eqeq2d anbi2d vg cv vn cv wceq vm cv vg cv wcel vm cv vn cv wcel vg
      cv vn cv wss vn cv vn cv wss vm cv vn cv wcel vg cv vn cv vm cv eleq2 vg
      cv vn cv vn cv sseq1 3anbi23d anbi12d rcla42ev vr cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel simprl vr cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel simprl vr cv vm cv vn cv cop wceq vn cv cF wcel vm
      cv vn cv wcel wa wa vr cv vm cv vn cv cop wceq vr cv vm cv vn cv cop wceq
      vm cv vn cv wcel vm cv vn cv wcel vn cv vn cv wss w3a vr cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa pm3.26 vr cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa pm3.26 vr cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa vm cv vn cv wcel vm cv vn cv wcel vn
      cv vn cv wss vr cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel
      simprr vr cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel simprr
      vn cv vn cv wss vr cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel
      wa wa vn cv ssid a1i 3jca jca31 syl3anc syl3anc vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vr cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vr cv vu cv vh cv cop wceq vr cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy vr cv vr cv vr visset vr visset vx cv vr cv wceq vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vr cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vx cv vr cv
      wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vr cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vh vg cF cF vx cv vr cv wceq vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vr cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vx cv
      vr cv wceq vx cv vu cv vh cv cop wceq vr cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq vx cv vr cv vu cv vh cv cop eqeq1 anbi1d anbi1d
      2rexbidv 2rexbidv vy cv vr cv wceq vr cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vr cv vu cv vh cv cop wceq vr cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vu vv cX cX vy cv vr cv wceq vr cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vr cv vu cv vh cv cop wceq vr cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vy cv
      vr cv wceq vr cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vr cv
      vu cv vh cv cop wceq vr cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vy cv vr cv wceq vy cv vv cv vg cv cop
      wceq vr cv vv cv vg cv cop wceq vr cv vu cv vh cv cop wceq vy cv vr cv vv
      cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv opelopab sylibr
      19.23aivv syl5cbi impcom sylbi relssi a1i vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy relopab
      jctil cF cfil wcel va cv vb cv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc cv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab wbr wa va cv vc cv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wi
      vc wal vb wal va wal vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ccom vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab wss cF cfil wcel va cv vb cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa va cv
      vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab wbr wi vc wal va vb cF cfil wcel va cv vb
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab wbr vb cv vc cv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wa
      va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr wi vc cF cfil wcel va cv vu cv
      vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vb cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex wa va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex va cv vb cv vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv
      vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab wbr wa va cv vc cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr cF cfil wcel va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop
      wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vl cF
      wrex vk cF wrex vj cX wrex vd cX wrex vb cv vm cv vo cv cop wceq vc cv vn
      cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss
      w3a wa vp cF wrex vo cF wrex vn cX wrex vm cX wrex wa va cv vu cv vh cv
      cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex va cv
      vu cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vb cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex wa cF cfil wcel va cv vd cv vk cv cop wceq vb cv vj cv vl
      cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa
      vl cF wrex vk cF wrex vj cX wrex vd cX wrex vb cv vm cv vo cv cop wceq vc
      cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv
      wss w3a wa vp cF wrex vo cF wrex vn cX wrex vm cX wrex va cv vu cv vh cv
      cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex cF
      cfil wcel va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv
      vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vl cF wrex vk cF wrex
      vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel
      vn cv vp cv wcel vp cv vo cv wss w3a wa vp cF wrex vo cF wrex vn cX wrex
      vm cX wrex va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex wi vd vj cX cX cF cfil wcel vd cv cX wcel vj cv cX
      wcel va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vl cF wrex vk cF wrex vb cv
      vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv
      vp cv wcel vp cv vo cv wss w3a wa vp cF wrex vo cF wrex vn cX wrex vm cX
      wrex va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex wi wi cF cfil wcel vd cv cX wcel vj cv cX wcel w3a va cv
      vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv
      vl cv wcel vl cv vk cv wss w3a wa vb cv vm cv vo cv cop wceq vc cv vn cv
      vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a
      wa vp cF wrex vo cF wrex vn cX wrex vm cX wrex va cv vu cv vh cv cop wceq
      vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex wi vk vl cF cF
      cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel
      wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vb cv vm cv vo cv cop wceq
      vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo
      cv wss w3a wa vp cF wrex vo cF wrex vn cX wrex vm cX wrex va cv vu cv vh
      cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      wi cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF
      wcel wa wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv
      vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vb cv vm cv vo cv
      cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel
      vp cv vo cv wss w3a wa vp cF wrex vo cF wrex va cv vu cv vh cv cop wceq
      vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vm vn cX cX cF
      cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel wa
      wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vm cv cX wcel vn cv cX
      wcel wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo
      cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa vp cF wrex vo cF wrex va
      cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex wi cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl
      cv cF wcel wa wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa
      vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vm cv cX wcel
      vn cv cX wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq
      wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa va cv vu cv
      vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vo vp cF cF cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl
      cv cF wcel wa wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa
      vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vm cv cX wcel
      vn cv cX wcel wa vo cv cF wcel vp cv cF wcel wa vb cv vm cv vo cv cop
      wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp
      cv vo cv wss w3a wa va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex wi cF cfil wcel vd cv cX wcel vj cv cX wcel
      w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd cv vk cv cop wceq vb cv vj
      cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss
      w3a wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF wcel wa
      wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv
      wcel vn cv vp cv wcel vp cv vo cv wss w3a wa va cv vu cv vh cv cop wceq
      vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vd cv cX wcel
      vn cv cX wcel va cv vd cv vh cv cop wceq vc cv vn cv vg cv cop wceq wa vd
      cv vh cv wcel vn cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF
      wcel vl cv cF wcel wa wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop
      wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vm cv
      cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF wcel wa wa vb cv vm cv vo
      cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv
      wcel vp cv vo cv wss w3a wa wa wa va cv vu cv vh cv cop wceq vc cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex va cv vd cv vh cv cop wceq vc cv vn cv vg cv cop
      wceq wa vd cv vh cv wcel vn cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex va cv vd cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa
      vd cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vu vv vd cv vn cv cX cX vu cv vd cv wceq va cv vu cv vh cv cop wceq
      vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa va cv vd cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vd
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vu cv
      vd cv wceq va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa va cv
      vd cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vd cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a vu cv vd cv wceq va cv vu cv vh cv cop wceq va cv vd cv vh cv
      cop wceq vc cv vv cv vg cv cop wceq vu cv vd cv wceq vu cv vh cv cop vd
      cv vh cv cop va cv vu cv vd cv vh cv opeq1 eqeq2d anbi1d vu cv vd cv wceq
      vu cv vh cv wcel vd cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss vu cv
      vd cv vh cv eleq1 3anbi1d anbi12d 2rexbidv vv cv vn cv wceq va cv vd cv
      vh cv cop wceq vc cv vv cv vg cv cop wceq wa vd cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa va cv vd cv vh cv cop wceq vc cv vn cv vg cv
      cop wceq wa vd cv vh cv wcel vn cv vg cv wcel vg cv vh cv wss w3a wa vh
      vg cF cF vv cv vn cv wceq va cv vd cv vh cv cop wceq vc cv vv cv vg cv
      cop wceq wa va cv vd cv vh cv cop wceq vc cv vn cv vg cv cop wceq wa vd
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vd cv vh cv wcel vn cv
      vg cv wcel vg cv vh cv wss w3a vv cv vn cv wceq vc cv vv cv vg cv cop
      wceq vc cv vn cv vg cv cop wceq va cv vd cv vh cv cop wceq vv cv vn cv
      wceq vv cv vg cv cop vn cv vg cv cop vc cv vv cv vn cv vg cv opeq1 eqeq2d
      anbi2d vv cv vn cv wceq vv cv vg cv wcel vn cv vg cv wcel vd cv vh cv
      wcel vg cv vh cv wss vv cv vn cv vg cv eleq1 3anbi2d anbi12d 2rexbidv
      rcla42ev cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv
      cF wcel wa wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd
      cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vd cv cX wcel vm
      cv cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF wcel wa wa vb cv vm cv
      vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv
      wcel vp cv vo cv wss w3a wa wa vk cv cF wcel vl cv cF wcel wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a vd cv cX wcel cF cfil wcel vd
      cv cX wcel vj cv cX wcel w3a va cv vd cv vk cv cop wceq vb cv vj cv vl cv
      cop wceq wa vk cv cF wcel vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv
      wss w3a vd cv cX wcel vl cv cF wcel vk cv cF wcel vj cv vl cv wcel vd cv
      vk cv wcel vd cv cX wcel vl cv vk cv wss vk cv cF wcel vd cv vk cv wcel
      wa vd cv cF cuni cX vd cv vk cv wcel vk cv cF wcel vd cv cF cuni wcel vd
      cv vk cv cF elunii ancoms filnet.1 syl6eleqr 3ad2antr1 adantlr ad2ant2l
      adantr vm cv cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF wcel wa wa
      vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel
      vn cv vp cv wcel vp cv vo cv wss w3a wa wa vn cv cX wcel cF cfil wcel vd
      cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd
      cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl
      cv wcel vl cv vk cv wss w3a wa wa vm cv cX wcel vn cv cX wcel vo cv cF
      wcel vp cv cF wcel wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop
      wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa simpllr
      adantl vk cv cF wcel vp cv cF wcel va cv vd cv vk cv cop wceq vc cv vn cv
      vp cv cop wceq wa vd cv vk cv wcel vn cv vp cv wcel vp cv vk cv wss w3a
      wa va cv vd cv vh cv cop wceq vc cv vn cv vg cv cop wceq wa vd cv vh cv
      wcel vn cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex cF
      cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel wa
      wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a wa wa vm cv cX wcel vn cv cX
      wcel wa vo cv cF wcel vp cv cF wcel wa wa vb cv vm cv vo cv cop wceq vc
      cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv
      wss w3a wa wa wa va cv vd cv vh cv cop wceq vc cv vn cv vg cv cop wceq wa
      vd cv vh cv wcel vn cv vg cv wcel vg cv vh cv wss w3a wa va cv vd cv vk
      cv cop wceq vc cv vn cv vp cv cop wceq wa vd cv vk cv wcel vn cv vp cv
      wcel vp cv vk cv wss w3a wa va cv vd cv vk cv cop wceq vc cv vn cv vg cv
      cop wceq wa vd cv vk cv wcel vn cv vg cv wcel vg cv vk cv wss w3a wa vh
      vg vk cv vp cv cF cF vh cv vk cv wceq va cv vd cv vh cv cop wceq vc cv vn
      cv vg cv cop wceq wa va cv vd cv vk cv cop wceq vc cv vn cv vg cv cop
      wceq wa vd cv vh cv wcel vn cv vg cv wcel vg cv vh cv wss w3a vd cv vk cv
      wcel vn cv vg cv wcel vg cv vk cv wss w3a vh cv vk cv wceq va cv vd cv vh
      cv cop wceq va cv vd cv vk cv cop wceq vc cv vn cv vg cv cop wceq vh cv
      vk cv wceq vd cv vh cv cop vd cv vk cv cop va cv vh cv vk cv vd cv opeq2
      eqeq2d anbi1d vh cv vk cv wceq vd cv vh cv wcel vd cv vk cv wcel vg cv vh
      cv wss vg cv vk cv wss vn cv vg cv wcel vh cv vk cv vd cv eleq2 vh cv vk
      cv vg cv sseq2 3anbi13d anbi12d vg cv vp cv wceq va cv vd cv vk cv cop
      wceq vc cv vn cv vg cv cop wceq wa va cv vd cv vk cv cop wceq vc cv vn cv
      vp cv cop wceq wa vd cv vk cv wcel vn cv vg cv wcel vg cv vk cv wss w3a
      vd cv vk cv wcel vn cv vp cv wcel vp cv vk cv wss w3a vg cv vp cv wceq vc
      cv vn cv vg cv cop wceq vc cv vn cv vp cv cop wceq va cv vd cv vk cv cop
      wceq vg cv vp cv wceq vn cv vg cv cop vn cv vp cv cop vc cv vg cv vp cv
      vn cv opeq2 eqeq2d anbi2d vg cv vp cv wceq vn cv vg cv wcel vn cv vp cv
      wcel vg cv vk cv wss vp cv vk cv wss vd cv vk cv wcel vg cv vp cv vn cv
      eleq2 vg cv vp cv vk cv sseq1 3anbi23d anbi12d rcla42ev cF cfil wcel vd
      cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel wa wa vk cv cF
      wcel va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vm cv cX wcel vn cv cX wcel
      wa vo cv cF wcel vp cv cF wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn
      cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss
      w3a wa wa cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl
      cv cF wcel simprl ad2antrr vm cv cX wcel vn cv cX wcel wa vo cv cF wcel
      vp cv cF wcel wa wa vp cv cF wcel cF cfil wcel vd cv cX wcel vj cv cX
      wcel w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd cv vk cv cop wceq vb
      cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv
      wss w3a wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm
      cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa vm cv cX wcel vn cv
      cX wcel wa vo cv cF wcel vp cv cF wcel simprr ad2antrl cF cfil wcel vd cv
      cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd cv
      vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv
      wcel vl cv vk cv wss w3a wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF
      wcel vp cv cF wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop
      wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa wa wa va
      cv vd cv vk cv cop wceq vc cv vn cv vp cv cop wceq vd cv vk cv wcel vn cv
      vp cv wcel vp cv vk cv wss w3a va cv vd cv vk cv cop wceq vb cv vj cv vl
      cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa
      va cv vd cv vk cv cop wceq cF cfil wcel vd cv cX wcel vj cv cX wcel w3a
      vk cv cF wcel vl cv cF wcel wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF
      wcel vp cv cF wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop
      wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa wa va cv
      vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq vd cv vk cv wcel vj cv vl
      cv wcel vl cv vk cv wss w3a simpll ad2antlr vb cv vm cv vo cv cop wceq vc
      cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv
      wss w3a wa vc cv vn cv vp cv cop wceq cF cfil wcel vd cv cX wcel vj cv cX
      wcel w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd cv vk cv cop wceq vb
      cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv
      wss w3a wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF wcel
      wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq vm cv vo cv
      wcel vn cv vp cv wcel vp cv vo cv wss w3a simplr ad2antll cF cfil wcel vd
      cv cX wcel vj cv cX wcel w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd
      cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl
      cv wcel vl cv vk cv wss w3a wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF
      wcel vp cv cF wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop
      wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa wa wa vd
      cv vk cv wcel vn cv vp cv wcel vp cv vk cv wss va cv vd cv vk cv cop wceq
      vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk
      cv wss w3a wa vd cv vk cv wcel cF cfil wcel vd cv cX wcel vj cv cX wcel
      w3a vk cv cF wcel vl cv cF wcel wa wa vm cv cX wcel vn cv cX wcel wa vo
      cv cF wcel vp cv cF wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp
      cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa
      wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss 3simpr1 ad2antlr vb cv vm cv vo cv
      cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel
      vp cv vo cv wss w3a wa vn cv vp cv wcel cF cfil wcel vd cv cX wcel vj cv
      cX wcel w3a vk cv cF wcel vl cv cF wcel wa wa va cv vd cv vk cv cop wceq
      vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk
      cv wss w3a wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF
      wcel wa wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv
      vo cv wcel vn cv vp cv wcel vp cv vo cv wss 3simpr2 ad2antll va cv vd cv
      vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv
      wcel vl cv vk cv wss w3a wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv
      cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa vp
      cv vk cv wss cF cfil wcel vd cv cX wcel vj cv cX wcel w3a vk cv cF wcel
      vl cv cF wcel wa wa vm cv cX wcel vn cv cX wcel wa vo cv cF wcel vp cv cF
      wcel wa wa va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv
      vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a wa vb cv vm cv vo cv cop
      wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp
      cv vo cv wss w3a wa wa vp cv vo cv vk cv vm cv vo cv wcel vn cv vp cv
      wcel vp cv vo cv wss w3a vp cv vo cv wss va cv vd cv vk cv cop wceq vb cv
      vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss
      w3a wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo
      cv wcel vn cv vp cv wcel vp cv vo cv wss 3simp3 ad2antll va cv vd cv vk
      cv cop wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv
      wcel vl cv vk cv wss w3a wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv
      cop wceq wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa wa
      vo cv vl cv vk cv va cv vd cv vk cv cop wceq vb cv vj cv vl cv cop wceq
      wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vl cv vo cv
      wceq vd cv vk cv wcel vj cv vl cv wcel vl cv vk cv wss w3a vm cv vo cv
      wcel vn cv vp cv wcel vp cv vo cv wss w3a vb cv vj cv vl cv cop wceq vb
      cv vm cv vo cv cop wceq vl cv vo cv wceq va cv vd cv vk cv cop wceq vc cv
      vn cv vp cv cop wceq vb cv vj cv vl cv cop wceq vb cv vm cv vo cv cop
      wceq wa vj cv vl cv cop vm cv vo cv cop wceq vl cv vo cv wceq vb cv vj cv
      vl cv cop vm cv vo cv cop eqtr2 vj cv vl cv vm cv vo cv vl visset vo
      visset opth2 syl ad2ant2lr ad2ant2r vd cv vk cv wcel vj cv vl cv wcel vl
      cv vk cv wss w3a vl cv vk cv wss va cv vd cv vk cv cop wceq vb cv vj cv
      vl cv cop wceq wa vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq
      wa vm cv vo cv wcel vn cv vp cv wcel vp cv vo cv wss w3a wa vd cv vk cv
      wcel vj cv vl cv wcel vl cv vk cv wss 3simp3 ad2antlr eqsstr3d sstrd
      ad2ant2l 3jca jca31 syl3anc syl3anc expr expr r19.23advv ex r19.23advv
      exp31 r19.23advv 3expib r19.23advv imp3a va cv vu cv vh cv cop wceq vb cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex va cv vd cv vk cv cop
      wceq vb cv vj cv vl cv cop wceq wa vd cv vk cv wcel vj cv vl cv wcel vl
      cv vk cv wss w3a wa vl cF wrex vk cF wrex vj cX wrex vd cX wrex vb cv vu
      cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vb cv vm cv vo cv cop wceq vc cv vn cv vp cv cop wceq wa vm cv vo cv
      wcel vn cv vp cv wcel vp cv vo cv wss w3a wa vp cF wrex vo cF wrex vn cX
      wrex vm cX wrex vv vu vg vh vj vk cF cX va vb vd vl filnet.1 filnetlem2
      vv vu vg vh vn vo cF cX vb vc vm vp filnet.1 filnetlem2 anbi12i syl5ib va
      cv vb cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab wbr va cv vu cv vh cv cop wceq vb cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vb cv vc cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wbr vb cv vu cv vh cv cop wceq vc cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex va cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex va cv vu
      cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy va cv vb cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab va visset vb visset vx
      cv va cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex va cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv
      cX cX vx cv va cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa va cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vh vg cF cF vx cv va cv wceq vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa va cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a vx cv va cv wceq vx cv vu cv vh cv cop wceq va cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq vx cv va cv vu cv vh cv cop eqeq1
      anbi1d anbi1d 2rexbidv 2rexbidv vy cv vb cv wceq va cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex va cv vu cv vh cv cop wceq vb
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vy cv vb cv wceq va cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa va cv vu cv vh cv cop wceq vb cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh
      vg cF cF vy cv vb cv wceq va cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa va cv vu cv vh cv cop wceq vb cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vy cv vb cv wceq vy cv
      vv cv vg cv cop wceq vb cv vv cv vg cv cop wceq va cv vu cv vh cv cop
      wceq vy cv vb cv vv cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab eqid brab vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vb cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vb cv vu cv vh cv
      cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      vb cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab vb visset vc visset vx cv vb cv
      wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vb cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vx cv
      vb cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vb cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vh vg cF cF vx cv vb cv wceq vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vb cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      vx cv vb cv wceq vx cv vu cv vh cv cop wceq vb cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq vx cv vb cv vu cv vh cv cop eqeq1 anbi1d anbi1d
      2rexbidv 2rexbidv vy cv vc cv wceq vb cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vb cv vu cv vh cv cop wceq vc cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vu vv cX cX vy cv vc cv wceq vb cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vb cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vy cv
      vc cv wceq vb cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vb cv
      vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vy cv vc cv wceq vy cv vv cv vg cv cop
      wceq vc cv vv cv vg cv cop wceq vb cv vu cv vh cv cop wceq vy cv vc cv vv
      cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab eqid brab anbi12i vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex va cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex va cv vu cv vh cv cop
      wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy va
      cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab va visset vc visset vx cv va cv wceq vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex va cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vx cv va cv
      wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa va cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vh vg cF cF vx cv va cv wceq vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa va cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vx cv
      va cv wceq vx cv vu cv vh cv cop wceq va cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq vx cv va cv vu cv vh cv cop eqeq1 anbi1d anbi1d
      2rexbidv 2rexbidv vy cv vc cv wceq va cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vu vv cX cX vy cv vc cv wceq va cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa va cv vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vy cv
      vc cv wceq va cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa va cv
      vu cv vh cv cop wceq vc cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a vy cv vc cv wceq vy cv vv cv vg cv cop
      wceq vc cv vv cv vg cv cop wceq va cv vu cv vh cv cop wceq vy cv vc cv vv
      cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab eqid brab 3imtr4g 19.21aiv 19.21aivv va vb vc vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cotr sylibr vx vy vv vu vg vh cF cX va vb vc filnet.1 filnetlem3
      jca32 cF cfil wcel cX cF cxp cX cF cxp cxp cvv wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cvv wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wrel cid vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni cres vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wss wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ccom vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wss va cv vc cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vb cv vc
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab wbr wa vc vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni
      wrex vb vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cuni cuni wral va vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cuni cuni wral wa wa wb cX cvv wcel cF cfil wcel cX cF cxp cX cF
      cxp cxp cvv wcel cF cfil wcel cF cuni cvv cX cF cfil uniexg filnet.1
      syl5eqel cX cF cxp cvv wcel cX cF cxp cvv wcel cX cF cxp cX cF cxp cxp
      cvv wcel cX cvv wcel cF cfil wcel wa cX cF cxp cX cF cxp cvv cvv xpexg cX
      cF cvv cfil xpexg cX cF cvv cfil xpexg sylanc mpancom vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cX cF cxp cX cF cxp cxp wss cX cF cxp cX cF cxp cxp cvv wcel vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cvv wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vx cv cX cF cxp wcel
      vy cv cX cF cxp wcel wa vx vy copab cX cF cxp cX cF cxp cxp vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa vx vy vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vx cv cX cF cxp wcel vy cv cX
      cF cxp wcel wa vu vv cX cX vu cv cX wcel vv cv cX wcel wa vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa
      vh vg cF cF vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vx cv cX cF cxp wcel vy cv cX cF
      cxp wcel wa wi vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel
      wa wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vx cv cX
      cF cxp wcel vy cv cX cF cxp wcel wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa vu cv vh cv cop cX cF cxp
      wcel vv cv vg cv cop cX cF cxp wcel wa vu cv cX wcel vv cv cX wcel wa vh
      cv cF wcel vg cv cF wcel wa wa vx cv vu cv vh cv cop wceq vx cv cX cF cxp
      wcel vu cv vh cv cop cX cF cxp wcel vy cv vv cv vg cv cop wceq vy cv cX
      cF cxp wcel vv cv vg cv cop cX cF cxp wcel vx cv vu cv vh cv cop cX cF
      cxp eleq1 vy cv vv cv vg cv cop cX cF cxp eleq1 bi2anan9 vu cv cX wcel vv
      cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vu cv vh cv cop cX cF cxp
      wcel vv cv vg cv cop cX cF cxp wcel vu cv cX wcel vh cv cF wcel vu cv vh
      cv cop cX cF cxp wcel vv cv cX wcel vg cv cF wcel vu cv vh cv cX cF
      opelxpi ad2ant2r vv cv cX wcel vg cv cF wcel vv cv vg cv cop cX cF cxp
      wcel vu cv cX wcel vh cv cF wcel vv cv vg cv cX cF opelxpi ad2ant2l jca
      syl5cbir adantrd ex r19.23advv r19.23aivv ssopab2i vx vy cX cF cxp cX cF
      cxp df-xp sseqtr4i vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cX cF cxp cX cF cxp cxp cvv
      ssexg mpan va vb vc vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni cvv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cuni cuni eqid isdir 3syl mpbird $.
      $( [15-Dec-2009] $) $( [13-Dec-2009] $)

    $( Lemma for ~ filnet . $)
    filnetlem5 $p |- ( F e. Fil -> ( ( t C_ X /\ E. z e. ran ( tail ` { <. x ,
    y >. | E. u e. X E. v e. X E. h e. F E. g e. F ( ( x = <. u , h >. /\ y =
    <. v , g >. ) /\ ( u e. h /\ v e. g /\ g C_ h ) ) } ) ( ( 1st |` dom { <. x
    , y >. | E. u e. X E. v e. X E. h e. F E. g e. F ( ( x = <. u , h >. /\ y =
    <. v , g >. ) /\ ( u e. h /\ v e. g /\ g C_ h ) ) } ) " z ) C_ t ) -> t e.
    F ) ) $=
      cF cfil wcel vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima vt cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex vt cv cF
      wcel cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima vt
      cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex vt cv cX wss vt cv
      cF wcel cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima
      vt cv wss vt cv cX wss vt cv cF wcel wi vz vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv crn cF cfil wcel vz cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wcel
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres vz cv cima vt cv wss vt cv cX wss vt
      cv cF wcel cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima
      cF wcel vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima
      vt cv wss w3a vt cv cF wcel cF cfil wcel vz cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv crn wcel wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima
      vt cv wss vt cv cX wss wa wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima vt cv cF cX filnet.1 fillsb cF cfil wcel vz cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv crn wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima vt cv wss vt cv cX wss wa simpll cF cfil wcel vz cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv crn wcel wa c1st vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      vz cv cima vt cv wss vt cv cX wss wa wa c1st vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres vz cv cima cF wcel vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres vz cv cima vt cv wss cF cfil wcel vz cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv crn wcel wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima
      cF wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima vt cv wss vt
      cv cX wss wa cF cfil wcel vz cv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn
      wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima cF wcel cF cfil
      wcel vz cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv crn wcel vt cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv vz cv wceq vt vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wrex
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres vz cv cima cF wcel cF cfil wcel vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wfn vz cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv crn wcel vt cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv cfv vz cv wceq vt vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wrex wb cF cfil
      wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cpw vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv wf vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wfn vx vy vv vu
      vg vh cF cX filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm eqid tailmap vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cpw vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv ffn 3syl vt vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vz cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv fvelrnb syl cF cfil wcel vt cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv cfv vz cv wceq c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima cF wcel vt vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vt cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv vz cv wceq c1st vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab ctail cfv cfv cima cF wcel c1st vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres vz cv cima cF wcel cF cfil wcel vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm wcel wa vt cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv
      vz cv wceq c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vt cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv cima c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima cF vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv vz cv c1st vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres imaeq2 eleq1d cF cfil wcel vt cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima cF wcel cF cfil wcel vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm wcel vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vt cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv cima cF wcel cF cfil wcel vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      vn cv cF wcel vm cv vn cv wcel wa vm vn copab vt cv cF cfil wcel vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni vn cv cF wcel
      vm cv vn cv wcel wa vm vn copab cF cfil wcel vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      cdir wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni
      wceq vx vy vv vu vg vh cF cX filnet.1 filnetlem4 vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab dirdm syl vx vy vv vu vg vh vm vn cF cX filnet.1 filnetlem1 syl6eq
      eleq2d cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vn wex vm wex c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vt cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv cima cF wcel vt cv vn cv cF wcel vm cv
      vn cv wcel wa vm vn copab wcel cF cfil wcel vt cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa c1st vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab ctail cfv cfv cima cF wcel vm vn cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa c1st
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm cres vt cv vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      cfv cima cF wcel cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm
      cv vn cv wcel wa wa wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima vn cv cF cF cfil wcel vt cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa c1st vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cres vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cres
      crn vn cv c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vt cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv cima cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa wa c1st vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab ctail cfv cfv cres crn c1st vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cres crn vn cv cF cfil wcel vt cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa c1st vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cres vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cres
      c1st vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cres cF cfil wcel vt cv
      vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wss c1st vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cdm cres vt cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv
      cres c1st vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cres wceq cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cpw wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm wss vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cpw vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv wf vt cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cpw wcel cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cpw vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv ffvelrn cF
      cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cpw vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv wf vt cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cpw vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv wf vx vy vv vu vg vh cF cX filnet.1 filnetlem4 vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      eqid tailmap syl adantr cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vt cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel cF
      cfil wcel vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel vt cv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm wcel vt cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa cF cfil wcel vn cv cF wcel vm cv vn cv wcel wa vm
      vn copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm vt cv cF cfil wcel vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni vn cv cF wcel vm cv vn
      cv wcel wa vm vn copab cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wceq vx vy
      vv vu vg vh cF cX filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab dirdm syl
      vx vy vv vu vg vh vm vn cF cX filnet.1 filnetlem1 syl6req eleq2d vt cv vm
      cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn wex vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn wex vm wex vt cv vn cv
      cF wcel vm cv vn cv wcel wa vm vn copab wcel vt cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa vn 19.8a vt cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa vn wex vm 19.8a vt cv vn cv cF wcel
      vm cv vn cv wcel wa vm vn copab wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vn wex vm wex vn cv cF wcel vm cv vn cv wcel
      wa vm vn vt cv elopab biimpri 3syl syl5bi imp sylanc vt cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv fvex elpw sylib c1st vt cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm resabs1 syl rneqd cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      c1st vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cima vn cv c1st vt cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv cres crn cF cfil wcel vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vd c1st vt cv vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima vn cv cF cfil wcel vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vd cv c1st vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima wcel vd cv vn cv wcel cF cfil wcel vt
      cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vo cv
      c1st cfv vd cv wceq vo vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv wrex
      vd cv vn cv wcel vd cv c1st vt cv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv
      cima wcel cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa wa vo cv c1st cfv vd cv wceq vd cv vn cv wcel vo vt cv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv cF cfil wcel vt cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa wa vo cv vt cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv wcel vt cv vo cv vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vo cv
      c1st cfv vd cv wceq vd cv vn cv wcel wi vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm wcel vo cv vt cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv wcel vt cv vo cv vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr wb cF
      cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdir wcel vt cv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      wcel vo cv cvv wcel vo cv vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv
      wcel vt cv vo cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wbr wb vo visset vt cv vo cv cvv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm eqid eltail mp3an3 cF cfil wcel vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vx
      vy vv vu vg vh cF cX filnet.1 filnetlem4 adantr cF cfil wcel vt cv vm cv
      vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vt cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wcel cF cfil wcel vt cv vn cv cF wcel vm cv vn cv wcel wa
      vm vn copab wcel vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vt cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa cF cfil wcel vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vt cv
      cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni
      cuni vn cv cF wcel vm cv vn cv wcel wa vm vn copab cF cfil wcel vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni wceq vx vy vv vu vg vh cF cX filnet.1 filnetlem4 vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab dirdm syl vx vy vv vu vg vh vm vn cF cX filnet.1
      filnetlem1 syl6req eleq2d vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vn wex vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vn wex vm wex vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa
      wa vn 19.8a vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa
      wa vn wex vm 19.8a vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn
      wex vm wex vn cv cF wcel vm cv vn cv wcel wa vm vn vt cv elopab biimpri
      3syl syl5bi imp sylanc cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa wa vt cv vu cv vh cv cop wceq vo cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vo cv c1st cfv vd cv wceq vd
      cv vn cv wcel wi vt cv vo cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vt cv vu cv vh
      cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa
      wa wa vo cv c1st cfv vd cv wceq vd cv vn cv wcel wi vt cv vu cv vh cv cop
      wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex cF cfil wcel vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vo cv c1st cfv vd cv
      wceq vd cv vn cv wcel wi wi vu vv cX cX vu cv cX wcel vv cv cX wcel wa vt
      cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa cF cfil wcel vt cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vo cv c1st cfv vd cv wceq vd
      cv vn cv wcel wi wi vh vg cF cF vu cv cX wcel vv cv cX wcel wa vh cv cF
      wcel vg cv cF wcel wa vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      vo cv c1st cfv vd cv wceq vd cv vn cv wcel vu cv cX wcel vv cv cX wcel wa
      vh cv cF wcel vg cv cF wcel wa wa vt cv vu cv vh cv cop wceq vo cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel
      wa wa wa wa wa vo cv c1st cfv vd cv wceq wa vg cv vn cv vd cv vu cv cX
      wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vt cv vu cv vh cv
      cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa wa wa wa vg cv vn cv wss vo cv c1st cfv vd cv
      wceq vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vt
      cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa cF cfil wcel vt cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa wa wa wa vg cv vh cv vn cv vt
      cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cv vh cv wss vu cv cX wcel vv cv
      cX wcel wa vh cv cF wcel vg cv cF wcel wa wa cF cfil wcel vt cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vt cv vu cv vh cv cop
      wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss 3simpr3 ad2antrl vt cv vu cv vh cv cop wceq vo cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa
      wa wa wa vh cv vn cv wceq vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg
      cv cF wcel wa wa vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa cF cfil wcel vt
      cv vm cv vn cv cop wceq vh cv vn cv wceq vn cv cF wcel vm cv vn cv wcel
      wa vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vt cv vm cv
      vn cv cop wceq vh cv vn cv wceq vu cv vh cv wcel vv cv vg cv wcel vg cv
      vh cv wss w3a cF cfil wcel vt cv vu cv vh cv cop wceq vt cv vm cv vn cv
      cop wceq vh cv vn cv wceq vo cv vv cv vg cv cop wceq vt cv vu cv vh cv
      cop wceq vt cv vm cv vn cv cop wceq wa vu cv vh cv cop vm cv vn cv cop
      wceq vh cv vn cv wceq vt cv vu cv vh cv cop vm cv vn cv cop eqtr2 vu cv
      vh cv vm cv vn cv vh visset vn visset opth2 syl adantlr ad2ant2rl
      adantrrr adantl sseqtrd adantr vu cv cX wcel vv cv cX wcel wa vh cv cF
      wcel vg cv cF wcel wa wa vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      wa wa vo cv c1st cfv vd cv wceq wa vd cv vv cv vg cv vu cv cX wcel vv cv
      cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vt cv vu cv vh cv cop wceq
      vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa wa wa wa vo cv c1st cfv vd cv wceq wa vo cv c1st cfv vd
      cv vv cv vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa
      vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa cF cfil wcel vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa wa wa vo cv c1st cfv vd
      cv wceq pm3.27 vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel
      wa wa vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa cF cfil wcel vt cv vm cv
      vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa wa wa vo cv c1st
      cfv vv cv wceq vo cv c1st cfv vd cv wceq vu cv cX wcel vv cv cX wcel wa
      vh cv cF wcel vg cv cF wcel wa wa vt cv vu cv vh cv cop wceq vo cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel
      wa wa wa wa wa vo cv c1st cfv vv cv vg cv cop c1st cfv vv cv vu cv cX
      wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vt cv vu cv vh cv
      cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa wa wa wa vo cv vv cv vg cv cop c1st vt cv vu
      cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vo cv vv cv vg cv cop wceq vu cv cX wcel
      vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa cF cfil wcel vt cv vm
      cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vt cv vu cv vh
      cv cop wceq vo cv vv cv vg cv cop wceq vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a simplr ad2antrl fveq2d vv cv vg cv vv visset op1st
      syl6eq adantr eqtr3d vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      wa vv cv vg cv wcel vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF
      wcel wa wa vo cv c1st cfv vd cv wceq vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a vv cv vg cv wcel vt cv vu cv vh cv cop wceq vo cv vv cv
      vg cv cop wceq wa cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss 3simp2 ad2antlr ad2antlr eqeltrd sseldd exp53 r19.23advv r19.23aivv
      com12 vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vt cv vu cv vh cv cop wceq vo cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy vt cv vo cv vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab vt visset vo visset vx cv vt cv wceq vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vt cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vx cv vt cv wceq vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vt cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh
      vg cF cF vx cv vt cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vx cv vt cv wceq vx cv
      vu cv vh cv cop wceq vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq vx cv vt cv vu cv vh cv cop eqeq1 anbi1d anbi1d 2rexbidv 2rexbidv vy
      cv vo cv wceq vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vt cv vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv
      cX cX vy cv vo cv wceq vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt cv vu
      cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vh vg cF cF vy cv vo cv wceq vt cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vt cv vu cv vh cv cop wceq
      vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a vy cv vo cv wceq vy cv vv cv vg cv cop wceq vo cv vv cv vg cv
      cop wceq vt cv vu cv vh cv cop wceq vy cv vo cv vv cv vg cv cop eqeq1
      anbi2d anbi1d 2rexbidv 2rexbidv vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab eqid brab syl5ib
      sylbid r19.23adv c1st wfun vd cv c1st vt cv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv cfv cima wcel vo cv c1st cfv vd cv wceq vo vt cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv wrex cvv cvv c1st wfo c1st wfun fo1st cvv cvv c1st
      fofun ax-mp vo vd cv vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv c1st
      fvelima mpan syl5 cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel
      vm cv vn cv wcel wa wa wa vd cv vn cv wcel vf cv c1st cfv vd cv wceq vf
      vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab ctail cfv cfv wrex vd cv c1st vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima wcel cF cfil wcel vt cv vm cv vn cv
      cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel vd cv
      vn cv cop vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv wcel vd cv vn cv cop
      c1st cfv vd cv wceq wa vf cv c1st cfv vd cv wceq vf vt cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv wrex cF cfil wcel vt cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel vd cv vn cv cop vt
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv cfv wcel vd cv vn cv cop c1st cfv
      vd cv wceq cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa wa vd cv vn cv wcel vd cv vn cv cop vt cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv wcel cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel wa vd cv vn cv cop vt cv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv cfv wcel vt cv vd cv vn cv cop vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab wbr cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel wa vt cv vu cv vh cv cop
      wceq vd cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vt cv vd cv vn cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr vm cv cX wcel vd cv
      cX wcel vt cv vm cv vh cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq
      wa vm cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vt cv vu cv vh cv cop wceq vd cv vn cv cop vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex cF cfil wcel vt cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel wa vt cv vu cv vh
      cv cop wceq vd cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vt cv vm cv vh
      cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq wa vm cv vh cv wcel vd
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vt cv vm cv vh
      cv cop wceq vd cv vn cv cop vv cv vg cv cop wceq wa vm cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv vm cv vd
      cv cX cX vu cv vm cv wceq vt cv vu cv vh cv cop wceq vd cv vn cv cop vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vt cv vm cv vh cv cop wceq vd cv vn cv cop vv cv vg cv cop wceq wa
      vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vu
      cv vm cv wceq vt cv vu cv vh cv cop wceq vd cv vn cv cop vv cv vg cv cop
      wceq wa vt cv vm cv vh cv cop wceq vd cv vn cv cop vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vm cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a vu cv vm cv wceq vt cv vu cv vh cv
      cop wceq vt cv vm cv vh cv cop wceq vd cv vn cv cop vv cv vg cv cop wceq
      vu cv vm cv wceq vu cv vh cv cop vm cv vh cv cop vt cv vu cv vm cv vh cv
      opeq1 eqeq2d anbi1d vu cv vm cv wceq vu cv vh cv wcel vm cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss vu cv vm cv vh cv eleq1 3anbi1d anbi12d
      2rexbidv vv cv vd cv wceq vt cv vm cv vh cv cop wceq vd cv vn cv cop vv
      cv vg cv cop wceq wa vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vt cv vm cv vh cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq wa
      vm cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vv
      cv vd cv wceq vt cv vm cv vh cv cop wceq vd cv vn cv cop vv cv vg cv cop
      wceq wa vt cv vm cv vh cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq
      wa vm cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vm cv vh cv wcel
      vd cv vg cv wcel vg cv vh cv wss w3a vv cv vd cv wceq vd cv vn cv cop vv
      cv vg cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq vt cv vm cv vh cv
      cop wceq vv cv vd cv wceq vv cv vg cv cop vd cv vg cv cop vd cv vn cv cop
      vv cv vd cv vg cv opeq1 eqeq2d anbi2d vv cv vd cv wceq vv cv vg cv wcel
      vd cv vg cv wcel vm cv vh cv wcel vg cv vh cv wss vv cv vd cv vg cv eleq1
      3anbi2d anbi12d 2rexbidv rcla42ev vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel wa wa vm cv cX wcel cF cfil wcel vd cv vn cv wcel
      vn cv cF wcel vm cv vn cv wcel wa vm cv cX wcel vt cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa vm cv cF cuni cX vm cv vn cv wcel
      vn cv cF wcel vm cv cF cuni wcel vm cv vn cv cF elunii ancoms filnet.1
      syl6eleqr adantl ad2antlr vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa vd cv vn cv wcel vd cv cX wcel cF cfil wcel vn cv cF
      wcel vm cv vn cv wcel wa vd cv vn cv wcel vd cv cX wcel vt cv vm cv vn cv
      cop wceq vn cv cF wcel vd cv vn cv wcel vd cv cX wcel vm cv vn cv wcel vn
      cv cF wcel vd cv vn cv wcel wa vd cv cF cuni cX vd cv vn cv wcel vn cv cF
      wcel vd cv cF cuni wcel vd cv vn cv cF elunii ancoms filnet.1 syl6eleqr
      adantlr adantll adantll vn cv cF wcel vn cv cF wcel vt cv vm cv vn cv cop
      wceq vd cv vn cv cop vd cv vn cv cop wceq wa vm cv vn cv wcel vd cv vn cv
      wcel vn cv vn cv wss w3a wa vt cv vm cv vh cv cop wceq vd cv vn cv cop vd
      cv vg cv cop wceq wa vm cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex cF cfil wcel vt cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel wa vt cv vm cv vh
      cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq wa vm cv vh cv wcel vd
      cv vg cv wcel vg cv vh cv wss w3a wa vt cv vm cv vn cv cop wceq vd cv vn
      cv cop vd cv vn cv cop wceq wa vm cv vn cv wcel vd cv vn cv wcel vn cv vn
      cv wss w3a wa vt cv vm cv vn cv cop wceq vd cv vn cv cop vd cv vg cv cop
      wceq wa vm cv vn cv wcel vd cv vg cv wcel vg cv vn cv wss w3a wa vh vg vn
      cv vn cv cF cF vh cv vn cv wceq vt cv vm cv vh cv cop wceq vd cv vn cv
      cop vd cv vg cv cop wceq wa vt cv vm cv vn cv cop wceq vd cv vn cv cop vd
      cv vg cv cop wceq wa vm cv vh cv wcel vd cv vg cv wcel vg cv vh cv wss
      w3a vm cv vn cv wcel vd cv vg cv wcel vg cv vn cv wss w3a vh cv vn cv
      wceq vt cv vm cv vh cv cop wceq vt cv vm cv vn cv cop wceq vd cv vn cv
      cop vd cv vg cv cop wceq vh cv vn cv wceq vm cv vh cv cop vm cv vn cv cop
      vt cv vh cv vn cv vm cv opeq2 eqeq2d anbi1d vh cv vn cv wceq vm cv vh cv
      wcel vm cv vn cv wcel vg cv vh cv wss vg cv vn cv wss vd cv vg cv wcel vh
      cv vn cv vm cv eleq2 vh cv vn cv vg cv sseq2 3anbi13d anbi12d vg cv vn cv
      wceq vt cv vm cv vn cv cop wceq vd cv vn cv cop vd cv vg cv cop wceq wa
      vt cv vm cv vn cv cop wceq vd cv vn cv cop vd cv vn cv cop wceq wa vm cv
      vn cv wcel vd cv vg cv wcel vg cv vn cv wss w3a vm cv vn cv wcel vd cv vn
      cv wcel vn cv vn cv wss w3a vg cv vn cv wceq vd cv vn cv cop vd cv vg cv
      cop wceq vd cv vn cv cop vd cv vn cv cop wceq vt cv vm cv vn cv cop wceq
      vg cv vn cv wceq vd cv vg cv cop vd cv vn cv cop vd cv vn cv cop vg cv vn
      cv vd cv opeq2 eqeq2d anbi2d vg cv vn cv wceq vd cv vg cv wcel vd cv vn
      cv wcel vg cv vn cv wss vn cv vn cv wss vm cv vn cv wcel vg cv vn cv vd
      cv eleq2 vg cv vn cv vn cv sseq1 3anbi23d anbi12d rcla42ev vt cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vn cv cF wcel cF cfil
      wcel vd cv vn cv wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel simprl ad2antlr vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa vn cv cF wcel cF cfil wcel vd cv vn cv wcel vt cv vm cv vn
      cv cop wceq vn cv cF wcel vm cv vn cv wcel simprl ad2antlr cF cfil wcel
      vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vd cv
      vn cv wcel wa vt cv vm cv vn cv cop wceq vd cv vn cv cop vd cv vn cv cop
      wceq wa vm cv vn cv wcel vd cv vn cv wcel vn cv vn cv wss w3a cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      vd cv vn cv wcel wa vt cv vm cv vn cv cop wceq vd cv vn cv cop vd cv vn
      cv cop wceq cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa vd cv vn cv wcel simplrl vd cv vn cv cop eqid jctir cF cfil
      wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa wa
      vd cv vn cv wcel wa vm cv vn cv wcel vd cv vn cv wcel vn cv vn cv wss vt
      cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vm cv vn cv
      wcel cF cfil wcel vd cv vn cv wcel vt cv vm cv vn cv cop wceq vn cv cF
      wcel vm cv vn cv wcel simprr ad2antlr cF cfil wcel vt cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel pm3.27 vn
      cv vn cv wss cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa wa vd cv vn cv wcel wa vn cv ssid a1i 3jca jca syl3anc
      syl3anc vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vt cv vu cv vh cv cop wceq vd cv vn cv cop
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy vt cv vd cv vn
      cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab vt visset vd cv vn cv opex vx cv vt cv
      wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vt cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vx cv
      vt cv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vh vg cF cF vx cv vt cv wceq vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vt cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      vx cv vt cv wceq vx cv vu cv vh cv cop wceq vt cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq vx cv vt cv vu cv vh cv cop eqeq1 anbi1d anbi1d
      2rexbidv 2rexbidv vy cv vd cv vn cv cop wceq vt cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vt cv vu cv vh cv cop wceq vd cv vn
      cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vu vv cX cX vy cv vd cv vn cv cop
      wceq vt cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vt cv vu cv vh cv cop wceq
      vd cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vh vg cF cF vy cv vd cv vn cv cop wceq vt cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vt cv vu cv vh cv cop wceq
      vd cv vn cv cop vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a vy cv vd cv vn cv cop wceq vy cv vv cv vg cv cop wceq
      vd cv vn cv cop vv cv vg cv cop wceq vt cv vu cv vh cv cop wceq vy cv vd
      cv vn cv cop vv cv vg cv cop eqeq1 anbi2d anbi1d 2rexbidv 2rexbidv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab eqid brab sylibr vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vt
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm wcel vd cv vn cv cop cvv wcel vd cv vn cv
      cop vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv wcel vt cv vd cv vn cv
      cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab wbr wb cF cfil wcel vt cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa wa vd cv vn cv wcel wa vt cv vd
      cv vn cv cop cvv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm eqid eltail cF cfil wcel vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      cdir wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      vd cv vn cv wcel vx vy vv vu vg vh cF cX filnet.1 filnetlem4 ad2antrr cF
      cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa
      wa vd cv vn cv wcel wa vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vt cv vn cv
      cF wcel vm cv vn cv wcel wa vm vn copab wcel vt cv vm cv vn cv cop wceq
      vn cv cF wcel vm cv vn cv wcel wa wa vt cv vn cv cF wcel vm cv vn cv wcel
      wa vm vn copab wcel cF cfil wcel vd cv vn cv wcel vt cv vm cv vn cv cop
      wceq vn cv cF wcel vm cv vn cv wcel wa wa vt cv vm cv vn cv cop wceq vn
      cv cF wcel vm cv vn cv wcel wa wa vn wex vt cv vm cv vn cv cop wceq vn cv
      cF wcel vm cv vn cv wcel wa wa vn wex vm wex vt cv vn cv cF wcel vm cv vn
      cv wcel wa vm vn copab wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm
      cv vn cv wcel wa wa vn 19.8a vt cv vm cv vn cv cop wceq vn cv cF wcel vm
      cv vn cv wcel wa wa vn wex vm 19.8a vt cv vn cv cF wcel vm cv vn cv wcel
      wa vm vn copab wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel wa wa vn wex vm wex vn cv cF wcel vm cv vn cv wcel wa vm vn vt cv
      elopab biimpri 3syl ad2antlr cF cfil wcel vt cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm wcel vt cv vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel
      wb vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv wcel wa wa vd cv
      vn cv wcel cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vn cv cF wcel vm cv
      vn cv wcel wa vm vn copab vt cv cF cfil wcel vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cuni cuni vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cuni cuni wceq vx vy vv vu vg vh cF cX
      filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab dirdm syl vx vy vv vu vg vh vm
      vn cF cX filnet.1 filnetlem1 syl6eq eleq2d ad2antrr mpbird vd cv vn cv
      cop cvv wcel cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv
      vn cv wcel wa wa wa vd cv vn cv wcel wa vd cv vn cv opex a1i syl3anc
      mpbird ex cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn
      cv wcel wa wa wa vd cv vn cv wcel vd cv vn cv cop c1st cfv vd cv wceq vd
      cv vn cv vd visset op1st a1i12 jcad vf cv c1st cfv vd cv wceq vd cv vn cv
      cop c1st cfv vd cv wceq vf vd cv vn cv cop vt cv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv vf cv vd cv vn cv cop wceq vf cv c1st cfv vd cv vn cv
      cop c1st cfv vd cv vf cv vd cv vn cv cop c1st fveq2 eqeq1d rcla4ev syl6
      c1st cvv wfn vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cvv wss vd cv
      c1st vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cima wcel vf cv c1st cfv
      vd cv wceq vf vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv wrex wb cvv cvv
      c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp vt cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv ssv vf cvv vt cv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv cfv vd cv c1st fvelimab mp2an syl6ibr impbid eqrdv c1st vt cv vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv df-ima syl5eqr eqtrd c1st vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cres vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv df-ima
      syl5eq cF cfil wcel vt cv vm cv vn cv cop wceq vn cv cF wcel vm cv vn cv
      wcel simprrl eqeltrd ex 19.23advv vn cv cF wcel vm cv vn cv wcel wa vm vn
      vt cv elopab syl5ib sylbid imp syl5cbi r19.23adva sylbid imp adantr cF
      cfil wcel vz cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wcel wa c1st vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres vz cv cima vt cv wss vt cv cX wss simprr cF
      cfil wcel vz cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wcel wa c1st vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres vz cv cima vt cv wss vt cv cX wss simprl 3jca
      sylc exp43 r19.23adv com23 imp3a $.
      $( [15-Dec-2009] $) $( [15-Dec-2009] $)

    $( A filter has the same convergence and clustering properties as some
       net. $)
    filnet $p |- ( F e. Fil -> E. d e. Dir E. f ( f : dom d --> X /\ F = ( ( X
    FilMap ran ( tail ` d ) ) ` f ) ) ) $=
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX vf cv
      wf cF vf cv cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv wceq
      wa vf wex vd cv cdm cX vf cv wf cF vf cv cX vd cv ctail cfv crn cfilmap
      co cfv wceq wa vf wex vd cdir wrex cF cfil wcel vd cv cdm cX vf cv wf cF
      vf cv cX vd cv ctail cfv crn cfilmap co cfv wceq wa vf wex vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cX vf cv wf cF vf cv cX vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      crn cfilmap co cfv wceq wa vf wex vd vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir vd cv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab wceq vd cv cdm cX vf cv wf cF vf cv cX vd cv ctail
      cfv crn cfilmap co cfv wceq wa vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX vf cv wf
      cF vf cv cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv wceq
      wa vf vd cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab wceq vd cv cdm cX vf cv wf vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cX vf cv wf cF vf cv cX vd cv ctail cfv crn cfilmap
      co cfv wceq cF vf cv cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap
      co cfv wceq vd cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab wceq vd cv cdm vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wceq vd cv cdm cX vf cv wf vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX
      vf cv wf wb vd cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab dmeq vd cv cdm vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cX vf cv feq2 syl vd cv vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wceq vf cv
      cX vd cv ctail cfv crn cfilmap co cfv vf cv cX vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv crn cfilmap co cfv cF vd cv vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wceq vf cv
      cX vd cv ctail cfv crn cfilmap co cX vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      crn cfilmap co vd cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wceq vd cv ctail cfv
      crn vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv crn cX cfilmap vd cv vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab wceq vd cv ctail cfv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv vd
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail fveq2 rneqd opreq2d fveq1d eqeq2d
      anbi12d exbidv rcla4ev vx vy vv vu vg vh cF cX filnet.1 filnetlem4 c1st
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm cres cvv wcel vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres wf cF c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv
      wceq wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm cX vf cv wf cF vf cv cX vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv crn cfilmap co cfv wceq wa vf wex cF cfil wcel vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cdm cX vf cv wf cF vf cv cX vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv crn cfilmap co cfv wceq wa vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres wf cF c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv
      wceq wa vf c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres cvv vf cv c1st vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX vf cv wf
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf cF
      vf cv cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv wceq cF
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      crn cfilmap co cfv wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX vf cv c1st vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres feq1 vf cv c1st vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres wceq vf cv cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      crn cfilmap co cfv cF vf cv c1st vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres cX vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv crn cfilmap co fveq2 eqeq2d anbi12d cla4egv
      c1st wfun vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cvv wcel c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres cvv wcel cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cvv resfunexg c1st wfun cF cfil wcel cvv cvv c1st wfo c1st wfun fo1st cvv
      cvv c1st fofun ax-mp a1i cF cfil wcel cX cF cxp cX cF cxp cxp cvv wcel vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cvv wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cvv wcel cX cvv
      wcel cF cfil wcel cX cF cxp cX cF cxp cxp cvv wcel cF cfil wcel cF cuni
      cvv cX cF cfil uniexg filnet.1 syl5eqel cX cF cxp cvv wcel cX cF cxp cvv
      wcel cX cF cxp cX cF cxp cxp cvv wcel cX cvv wcel cF cfil wcel wa cX cF
      cxp cX cF cxp cvv cvv xpexg cX cF cvv cfil xpexg cX cF cvv cfil xpexg
      sylanc mpancom vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cX cF cxp cX cF cxp cxp wss cX cF
      cxp cX cF cxp cxp cvv wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cvv wcel vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa vx vy copab cX
      cF cxp cX cF cxp cxp vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx cv cX cF cxp wcel vy cv cX cF
      cxp wcel wa vx vy vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa vu vv cX cX vu cv cX
      wcel vv cv cX wcel wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vx cv cX
      cF cxp wcel vy cv cX cF cxp wcel wa vh vg cF cF vu cv cX wcel vv cv cX
      wcel wa vh cv cF wcel vg cv cF wcel wa vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa wi vu cv cX wcel vv
      cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vx cv cX cF cxp wcel vy cv cX cF cxp
      wcel wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vx cv cX cF cxp wcel vy cv
      cX cF cxp wcel wa vu cv vh cv cop cX cF cxp wcel vv cv vg cv cop cX cF
      cxp wcel wa vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa
      wa vx cv vu cv vh cv cop wceq vx cv cX cF cxp wcel vu cv vh cv cop cX cF
      cxp wcel vy cv vv cv vg cv cop wceq vy cv cX cF cxp wcel vv cv vg cv cop
      cX cF cxp wcel vx cv vu cv vh cv cop cX cF cxp eleq1 vy cv vv cv vg cv
      cop cX cF cxp eleq1 bi2anan9 vu cv cX wcel vv cv cX wcel wa vh cv cF wcel
      vg cv cF wcel wa wa vu cv vh cv cop cX cF cxp wcel vv cv vg cv cop cX cF
      cxp wcel vu cv cX wcel vh cv cF wcel vu cv vh cv cop cX cF cxp wcel vv cv
      cX wcel vg cv cF wcel vu cv vh cv cX cF opelxpi ad2ant2r vv cv cX wcel vg
      cv cF wcel vv cv vg cv cop cX cF cxp wcel vu cv cX wcel vh cv cF wcel vv
      cv vg cv cX cF opelxpi ad2ant2l jca syl5cbir adantrd ex r19.23advv
      r19.23aivv ssopab2i vx vy cX cF cxp cX cF cxp df-xp sseqtr4i vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cX cF cxp cX cF cxp cxp cvv ssexg mpan vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cvv dmexg 3syl sylanc cF cfil wcel vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres wf cF c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap co cfv
      wceq cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wfn c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres crn cX wss wa
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf cF
      cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm wfn c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres crn cX wss c1st vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wfn cF cfil wcel
      c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cres vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wfn vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cdm cvv wss vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm ssv c1st cvv
      wfn c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cres vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      wfn vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cvv wss wb cvv cvv c1st wfo c1st cvv wfn
      fo1st cvv cvv c1st fofn ax-mp cvv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm c1st
      fnssresb ax-mp mpbir a1i cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm wfn c1st vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      crn cX wss cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wfn wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres crn c1st cX
      cF cxp cres crn cX cF cfil wcel c1st vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm wfn wa vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX cF cxp
      wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cres c1st cX cF cxp cres wss c1st
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm cres crn c1st cX cF cxp cres crn wss vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cX cF cxp wss cF cfil wcel c1st vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm wfn wa vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cX cF cxp cX cF cxp cxp cdm cX cF cxp vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cX cF cxp cX cF cxp cxp wss vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX cF cxp
      cX cF cxp cxp cdm wss vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vx cv cX cF cxp wcel vy
      cv cX cF cxp wcel wa vx vy copab cX cF cxp cX cF cxp cxp vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa vx vy vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vx cv cX cF cxp wcel vy cv cX
      cF cxp wcel wa vu vv cX cX vu cv cX wcel vv cv cX wcel wa vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa
      vh vg cF cF vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vx cv cX cF cxp wcel vy cv cX cF
      cxp wcel wa wi vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel
      wa wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vx cv cX
      cF cxp wcel vy cv cX cF cxp wcel wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vx cv cX cF cxp wcel vy cv cX cF cxp wcel wa vu cv vh cv cop cX cF cxp
      wcel vv cv vg cv cop cX cF cxp wcel wa vu cv cX wcel vv cv cX wcel wa vh
      cv cF wcel vg cv cF wcel wa wa vx cv vu cv vh cv cop wceq vx cv cX cF cxp
      wcel vu cv vh cv cop cX cF cxp wcel vy cv vv cv vg cv cop wceq vy cv cX
      cF cxp wcel vv cv vg cv cop cX cF cxp wcel vx cv vu cv vh cv cop cX cF
      cxp eleq1 vy cv vv cv vg cv cop cX cF cxp eleq1 bi2anan9 vu cv cX wcel vv
      cv cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vu cv vh cv cop cX cF cxp
      wcel vv cv vg cv cop cX cF cxp wcel vu cv cX wcel vh cv cF wcel vu cv vh
      cv cop cX cF cxp wcel vv cv cX wcel vg cv cF wcel vu cv vh cv cX cF
      opelxpi ad2ant2r vv cv cX wcel vg cv cF wcel vv cv vg cv cop cX cF cxp
      wcel vu cv cX wcel vh cv cF wcel vv cv vg cv cX cF opelxpi ad2ant2l jca
      syl5cbir adantrd ex r19.23advv r19.23aivv ssopab2i vx vy cX cF cxp cX cF
      cxp df-xp sseqtr4i vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cX cF cxp cX cF cxp cxp dmss
      ax-mp cX cF cxp dmxpid sseqtri a1i vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX cF cxp
      c1st ssres2 c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres c1st cX cF cxp cres rnss
      3syl c1st cX cF cxp cres crn cX wss cF cfil wcel c1st vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm wfn wa cX cF cxp cX c1st cX cF
      cxp cres wf c1st cX cF cxp cres crn cX wss cX cF f1stres cX cF cxp cX
      c1st cX cF cxp cres frn ax-mp a1i sstrd ex jcai vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres df-f sylibr cF cfil
      wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      wf cF c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cres cX vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv crn cfilmap co cfv wceq cF cfil wcel vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm cres wf wa vt cF c1st vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap
      co cfv cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres wf wa vt cv cF wcel vt cv cX wss c1st vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres vz cv cima vt cv wss vz vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      crn wrex wa vt cv c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres cX vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv crn cfilmap co cfv wcel cF cfil wcel vt cv cF wcel
      vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima vt cv wss
      vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv crn wrex wa wb vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf cF cfil wcel vt cv
      cF wcel vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima
      vt cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex wa cF cfil wcel
      vt cv cF wcel vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima vt cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex vt cv cF
      wcel vt cv cX wss wi cF cfil wcel vt cv cF wcel vt cv cF cuni cX vt cv cF
      elssuni filnet.1 syl6ssr a1i cF cfil wcel vt cv cF wcel vd cv vt cv wcel
      vd wex c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima vt cv wss vz
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv crn wrex cF cfil wcel vt cv cF wcel vt
      cv c0 wne vd cv vt cv wcel vd wex cF cfil wcel vt cv cF wcel vt cv c0 vt
      cv c0 wceq vt cv cF wcel wn c0 cF wcel wn cF cfil wcel vt cv c0 wceq vt
      cv cF wcel c0 cF wcel vt cv c0 cF eleq1 notbid cF filesn syl5cbir
      necon2ad vd vt cv n0 syl6ib cF cfil wcel vt cv cF wcel vd cv vt cv wcel
      vd wex c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima vt cv wss vz
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv crn wrex wi cF cfil wcel vt cv cF wcel
      wa vd cv vt cv wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv cima vt
      cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex vd cF cfil wcel vt
      cv cF wcel vd cv vt cv wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima vt cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex vd cv vt cv
      cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv crn wcel c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vd cv vt cv cop vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima vt cv wss c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres vz cv cima vt cv wss vz vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      crn wrex cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa c1st vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres vz cv cima vt cv wss c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv
      cima vt cv wss vz vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv crn vz cv vd cv vt cv cop vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv wceq c1st vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      vz cv cima c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vd cv vt cv cop vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cima vt cv vz cv vd cv vt cv cop vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv c1st vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      imaeq2 sseq1d rcla4ev vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wfn vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel
      vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv crn wcel cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa
      wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm vd cv vt cv cop vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv fnfvelrn cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm wfn vt cv cF wcel vd cv vt cv wcel wa cF cfil
      wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cpw vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv wf vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wfn vx vy vv vu
      vg vh cF cX filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm eqid tailmap vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cpw vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv ffn 3syl adantr cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vd
      cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vd cv vt cv cop vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab wcel cF cfil wcel vt cv cF wcel vd
      cv vt cv wcel wa wa vt cv cF wcel vd cv vt cv wcel wa vd cv vt cv cop vn
      cv cF wcel vm cv vn cv wcel wa vm vn copab wcel cF cfil wcel vt cv cF
      wcel vd cv vt cv wcel wa pm3.27 vn cv cF wcel vm cv vn cv wcel wa vn cv
      cF wcel vd cv vn cv wcel wa vt cv cF wcel vd cv vt cv wcel wa vm vn vd cv
      vt cv vd visset vt visset vm cv vd cv wceq vm cv vn cv wcel vd cv vn cv
      wcel vn cv cF wcel vm cv vd cv vn cv eleq1 anbi2d vn cv vt cv wceq vn cv
      cF wcel vt cv cF wcel vd cv vn cv wcel vd cv vt cv wcel vn cv vt cv cF
      eleq1 vn cv vt cv vd cv eleq2 anbi12d opelopab sylibr cF cfil wcel vd cv
      vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm wcel vd cv vt cv cop vn cv cF wcel
      vm cv vn cv wcel wa vm vn copab wcel wb vt cv cF wcel vd cv vt cv wcel wa
      cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vn cv cF wcel vm cv vn cv wcel
      wa vm vn copab vd cv vt cv cop cF cfil wcel vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cuni cuni vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cuni cuni wceq vx vy vv vu vg vh cF cX
      filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab dirdm syl vx vy vv vu vg vh vm
      vn cF cX filnet.1 filnetlem1 syl6eq eleq2d adantr mpbird sylanc cF cfil
      wcel vt cv cF wcel vd cv vt cv wcel wa wa c1st vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cres crn
      vt cv c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cres vd cv vt cv cop vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv cima cF cfil wcel vt cv cF wcel vd cv vt cv
      wcel wa wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres vd cv vt cv cop vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cres crn c1st vd cv vt cv cop vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv cres crn vt cv cF cfil wcel vt cv cF wcel vd cv
      vt cv wcel wa wa c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vd cv vt cv
      cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv cfv cres c1st vd cv vt cv cop vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv cfv cres cF cfil wcel vt cv cF wcel vd cv vt
      cv wcel wa wa vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv cfv vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cdm wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vd cv
      vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cres c1st vd cv vt cv cop
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv cfv cres wceq cF cfil wcel vt cv cF wcel
      vd cv vt cv wcel wa wa vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab cdm cpw wcel vd cv vt cv cop vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wss vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cpw vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv wf vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vd cv vt cv
      cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cpw wcel cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cpw vd cv vt cv cop vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv ffvelrn cF cfil wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cpw vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail
      cfv wf vt cv cF wcel vd cv vt cv wcel wa cF cfil wcel vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdir wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cpw vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv wf vx vy vv vu vg vh cF cX filnet.1
      filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm eqid tailmap syl adantr cF cfil wcel vt cv cF wcel
      vd cv vt cv wcel wa wa vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel
      vd cv vt cv cop vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel cF
      cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vt cv cF wcel vd cv vt cv
      wcel wa vd cv vt cv cop vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa pm3.27 vn cv cF wcel
      vm cv vn cv wcel wa vn cv cF wcel vd cv vn cv wcel wa vt cv cF wcel vd cv
      vt cv wcel wa vm vn vd cv vt cv vd visset vt visset vm cv vd cv wceq vm
      cv vn cv wcel vd cv vn cv wcel vn cv cF wcel vm cv vd cv vn cv eleq1
      anbi2d vn cv vt cv wceq vn cv cF wcel vt cv cF wcel vd cv vn cv wcel vd
      cv vt cv wcel vn cv vt cv cF eleq1 vn cv vt cv vd cv eleq2 anbi12d
      opelopab sylibr cF cfil wcel vd cv vt cv cop vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      wcel vd cv vt cv cop vn cv cF wcel vm cv vn cv wcel wa vm vn copab wcel
      wb vt cv cF wcel vd cv vt cv wcel wa cF cfil wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vn cv cF wcel vm cv vn cv wcel wa vm vn copab vd cv vt cv cop
      cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni
      cuni vn cv cF wcel vm cv vn cv wcel wa vm vn copab cF cfil wcel vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni wceq vx vy vv vu vg vh cF cX filnet.1 filnetlem4 vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab dirdm syl vx vy vv vu vg vh vm vn cF cX filnet.1
      filnetlem1 syl6eq eleq2d adantr mpbird sylanc vd cv vt cv cop vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vd cv vt cv cop
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv fvex elpw sylib c1st vd cv vt cv cop vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm resabs1
      syl rneqd cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa c1st vd cv vt
      cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab ctail cfv cfv cima vt cv c1st vd cv vt cv
      cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab ctail cfv cfv cres crn cF cfil wcel vt cv cF
      wcel vd cv vt cv wcel wa wa vf c1st vd cv vt cv cop vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv cima vt cv cF cfil wcel vt cv cF wcel vd cv vt cv
      wcel wa wa vo cv c1st cfv vf cv wceq vo vd cv vt cv cop vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv wrex vf cv vt cv wcel vf cv c1st vd cv vt cv cop vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv cima wcel cF cfil wcel vt cv cF wcel vd
      cv vt cv wcel wa wa vo cv c1st cfv vf cv wceq vf cv vt cv wcel vo vd cv
      vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv cF cfil wcel vt cv cF
      wcel vd cv vt cv wcel wa wa vo cv vd cv vt cv cop vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv wcel vd cv vt cv cop vo cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr
      vo cv c1st cfv vf cv wceq vf cv vt cv wcel wi vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      cdir wcel vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wcel vo cv vd cv
      vt cv cop vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv cfv wcel vd cv vt cv cop vo
      cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX
      wrex vu cX wrex vx vy copab wbr wb cF cfil wcel vt cv cF wcel vd cv vt cv
      wcel wa wa vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdir wcel vd cv vt cv cop vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm wcel vo cv cvv wcel vo cv vd cv vt cv cop vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv cfv wcel vd cv vt cv cop vo cv vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab wbr wb vo visset vd cv vt cv cop vo cv cvv vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm eqid
      eltail mp3an3 cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vt cv cF
      wcel vd cv vt cv wcel wa vx vy vv vu vg vh cF cX filnet.1 filnetlem4
      adantr cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vd cv vt cv cop
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm wcel vd cv vt cv cop vn cv cF wcel vm cv vn cv
      wcel wa vm vn copab wcel cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa
      wa vt cv cF wcel vd cv vt cv wcel wa vd cv vt cv cop vn cv cF wcel vm cv
      vn cv wcel wa vm vn copab wcel cF cfil wcel vt cv cF wcel vd cv vt cv
      wcel wa pm3.27 vn cv cF wcel vm cv vn cv wcel wa vn cv cF wcel vd cv vn
      cv wcel wa vt cv cF wcel vd cv vt cv wcel wa vm vn vd cv vt cv vd visset
      vt visset vm cv vd cv wceq vm cv vn cv wcel vd cv vn cv wcel vn cv cF
      wcel vm cv vd cv vn cv eleq1 anbi2d vn cv vt cv wceq vn cv cF wcel vt cv
      cF wcel vd cv vn cv wcel vd cv vt cv wcel vn cv vt cv cF eleq1 vn cv vt
      cv vd cv eleq2 anbi12d opelopab sylibr cF cfil wcel vd cv vt cv cop vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm wcel vd cv vt cv cop vn cv cF wcel vm cv vn cv wcel
      wa vm vn copab wcel wb vt cv cF wcel vd cv vt cv wcel wa cF cfil wcel vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cdm vn cv cF wcel vm cv vn cv wcel wa vm vn copab vd
      cv vt cv cop cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cuni cuni vn cv cF wcel vm cv vn cv wcel wa vm vn copab cF
      cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab cuni cuni wceq vx vy vv vu vg vh cF cX filnet.1
      filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab dirdm syl vx vy vv vu vg vh vm vn cF cX
      filnet.1 filnetlem1 syl6eq eleq2d adantr mpbird sylanc cF cfil wcel vt cv
      cF wcel vd cv vt cv wcel wa wa vd cv vt cv cop vu cv vh cv cop wceq vo cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vo cv c1st cfv vf cv
      wceq vf cv vt cv wcel wi vd cv vt cv cop vo cv vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab wbr
      vd cv vt cv cop vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa
      vo cv c1st cfv vf cv wceq vf cv vt cv wcel wi vd cv vt cv cop vu cv vh cv
      cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex cF cfil wcel vt cv cF wcel
      vd cv vt cv wcel wa wa vo cv c1st cfv vf cv wceq vf cv vt cv wcel wi wi
      vu vv cX cX vu cv cX wcel vv cv cX wcel wa vd cv vt cv cop vu cv vh cv
      cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa
      vo cv c1st cfv vf cv wceq vf cv vt cv wcel wi wi vh vg cF cF vu cv cX
      wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel wa vd cv vt cv cop vu
      cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa cF cfil wcel vt cv cF wcel vd cv vt cv
      wcel wa wa vo cv c1st cfv vf cv wceq vf cv vt cv wcel vu cv cX wcel vv cv
      cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vd cv vt cv cop vu cv vh cv
      cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa
      wa vo cv c1st cfv vf cv wceq wa wa vf cv vh cv vt cv vu cv cX wcel vv cv
      cX wcel wa vh cv cF wcel vg cv cF wcel wa wa vd cv vt cv cop vu cv vh cv
      cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa
      wa vo cv c1st cfv vf cv wceq wa wa vg cv vh cv vf cv vd cv vt cv cop vu
      cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cv vh cv wss vu cv cX wcel vv cv cX
      wcel wa vh cv cF wcel vg cv cF wcel wa wa cF cfil wcel vt cv cF wcel vd
      cv vt cv wcel wa wa vo cv c1st cfv vf cv wceq wa vd cv vt cv cop vu cv vh
      cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss 3simpr3 ad2antlr vu cv cX wcel vv cv cX wcel wa vh
      cv cF wcel vg cv cF wcel wa wa vd cv vt cv cop vu cv vh cv cop wceq vo cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vo cv c1st
      cfv vf cv wceq wa wa vf cv vv cv vg cv vu cv cX wcel vv cv cX wcel wa vh
      cv cF wcel vg cv cF wcel wa wa vd cv vt cv cop vu cv vh cv cop wceq vo cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vo cv c1st
      cfv vf cv wceq wa wa vo cv c1st cfv vf cv vv cv vu cv cX wcel vv cv cX
      wcel wa vh cv cF wcel vg cv cF wcel wa wa vd cv vt cv cop vu cv vh cv cop
      wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa
      vo cv c1st cfv vf cv wceq simprr vu cv cX wcel vv cv cX wcel wa vh cv cF
      wcel vg cv cF wcel wa wa vd cv vt cv cop vu cv vh cv cop wceq vo cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vo cv c1st cfv vf
      cv wceq wa wa vo cv c1st cfv vv cv vg cv cop c1st cfv vv cv vd cv vt cv
      cop vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vo cv c1st cfv vv cv vg cv cop
      c1st cfv wceq vu cv cX wcel vv cv cX wcel wa vh cv cF wcel vg cv cF wcel
      wa wa cF cfil wcel vt cv cF wcel vd cv vt cv wcel wa wa vo cv c1st cfv vf
      cv wceq wa vd cv vt cv cop vu cv vh cv cop wceq vo cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vo cv vv
      cv vg cv cop c1st vd cv vt cv cop vu cv vh cv cop wceq vo cv vv cv vg cv
      cop wceq vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a simplr
      fveq2d ad2antlr vv cv vg cv vv visset op1st syl6eq eqtr3d vd cv vt cv cop
      vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vv cv vg cv wcel vu cv cX wcel vv cv cX
      wcel wa vh cv cF wcel vg cv cF wcel wa wa cF cfil wcel vt cv cF wcel vd
      cv vt cv wcel wa wa vo cv c1st cfv vf cv wceq wa vd cv vt cv cop vu cv vh
      cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss 3simpr2 ad2antlr eqeltrd sseldd vd cv vt cv cop vu
      cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vt cv vh cv wceq vu cv cX wcel vv cv cX
      wcel wa vh cv cF wcel vg cv cF wcel wa wa cF cfil wcel vt cv cF wcel vd
      cv vt cv wcel wa wa vo cv c1st cfv vf cv wceq wa vd cv vt cv cop vu cv vh
      cv cop wceq vt cv vh cv wceq vo cv vv cv vg cv cop wceq vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a vd cv vt cv vu cv vh cv vt visset vh
      visset opth2 ad2antrr ad2antlr eleqtrrd exp56 r19.23advv r19.23aivv com12
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vd cv vt cv cop vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vd cv vt cv cop vu cv vh cv cop
      wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy vd
      cv vt cv cop vo cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab vd cv vt cv opex vo visset vx
      cv vd cv vt cv cop wceq vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vd cv vt cv cop vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vu vv cX cX vx cv vd cv vt cv cop wceq vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vd cv vt cv cop vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vh vg cF cF vx cv vd cv vt cv cop wceq vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vd cv vt cv cop vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a vx cv vd cv vt cv cop wceq vx cv vu cv vh cv cop wceq vd cv vt cv cop
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq vx cv vd cv vt cv cop vu
      cv vh cv cop eqeq1 anbi1d anbi1d 2rexbidv 2rexbidv vy cv vo cv wceq vd cv
      vt cv cop vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vd cv
      vt cv cop vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu cv vh cv
      wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vu vv
      cX cX vy cv vo cv wceq vd cv vt cv cop vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vd cv vt cv cop vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vh vg cF cF vy cv
      vo cv wceq vd cv vt cv cop vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vd cv vt cv cop vu cv vh cv cop wceq vo cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a vy cv vo cv wceq
      vy cv vv cv vg cv cop wceq vo cv vv cv vg cv cop wceq vd cv vt cv cop vu
      cv vh cv cop wceq vy cv vo cv vv cv vg cv cop eqeq1 anbi2d anbi1d
      2rexbidv 2rexbidv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab eqid brab syl5ib sylbid
      r19.23adv c1st wfun vf cv c1st vd cv vt cv cop vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab
      ctail cfv cfv cima wcel vo cv c1st cfv vf cv wceq vo vd cv vt cv cop vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv wrex cvv cvv c1st wfo c1st wfun fo1st
      cvv cvv c1st fofun ax-mp vo vf cv vd cv vt cv cop vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv cfv c1st fvelima mpan syl5 ssrdv c1st vd cv vt cv cop vx
      cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv
      cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu
      cX wrex vx vy copab ctail cfv cfv df-ima syl5ssr eqsstrd c1st vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cres vd cv vt cv cop vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv
      cfv df-ima syl5ss sylanc expr 19.23adv ex mpdd jcad vx vy vz vv vu vt vg
      vh cF cX filnet.1 filnetlem5 impbid adantr cX cvv wcel vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab ctail cfv crn cfbas wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn
      cuni cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf vt cv c1st vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cfilmap
      co cfv wcel vt cv cX wss c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg
      cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa
      vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres vz cv
      cima vt cv wss vz vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn wrex wa wb cF
      cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres wf wa vz vt cv vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cvv c1st vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres cX vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cuni
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv crn cuni eqid elfilmap cF cfil wcel cX
      cvv wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq
      vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh
      cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      cres wf cF cfil wcel cF cuni cvv cX cF cfil uniexg filnet.1 syl5eqel
      adantr vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm c0 wne
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab ctail cfv crn cfbas wcel cF cfil wcel vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf wa vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm
      eqid tailfb cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf vx vy vv vu
      vg vh cF cX filnet.1 filnetlem4 adantr cF cfil wcel vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm c0 wne vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cX c1st vx cv vu cv vh cv cop
      wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg
      cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm cres wf cF cfil wcel vn cv cF wcel vm cv vn cv wcel wa vm vn
      copab c0 wne vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm c0 wne cF cfil wcel vr cv cF
      wcel vs cv vr cv wcel wa vs wex vr wex vn cv cF wcel vm cv vn cv wcel wa
      vm vn copab c0 wne cF cfil wcel vr cv cF wcel vr wex vr cv cF wcel vs cv
      vr cv wcel wa vs wex vr wex cX cvv wcel cX cF wcel vr cv cF wcel vr wex
      cF cfil wcel vr cv cF wcel cX cF wcel vr cX cvv vr cv cX cF eleq1 cla4egv
      cF cfil wcel cF cuni cvv cX cF cfil uniexg filnet.1 syl5eqel cF cX
      filnet.1 filusb sylc cF cfil wcel vr cv cF wcel vr cv cF wcel vs cv vr cv
      wcel wa vs wex vr cF cfil wcel vr cv cF wcel vs cv vr cv wcel vs wex vr
      cv cF wcel vs cv vr cv wcel wa vs wex cF cfil wcel vr cv cF wcel vr cv c0
      wne vs cv vr cv wcel vs wex cF cfil wcel vr cv cF wcel vr cv c0 vr cv c0
      wceq vr cv cF wcel wn c0 cF wcel wn cF cfil wcel vr cv c0 wceq vr cv cF
      wcel c0 cF wcel vr cv c0 cF eleq1 notbid cF filesn syl5cbir necon2ad vs
      vr cv n0 syl6ib cF cfil wcel vr cv cF wcel vs cv vr cv wcel vs wex vr cv
      cF wcel vs cv vr cv wcel wa vs wex wi cF cfil wcel vr cv cF wcel wa vs cv
      vr cv wcel vr cv cF wcel vs cv vr cv wcel wa vs cF cfil wcel vr cv cF
      wcel wa vs cv vr cv wcel vr cv cF wcel cF cfil wcel vr cv cF wcel wa vr
      cv cF wcel vs cv vr cv wcel cF cfil wcel vr cv cF wcel pm3.27 a1d ancrd
      19.22dv ex mpdd 19.22dv mpd vr cv cF wcel vs cv vr cv wcel wa vn cv cF
      wcel vm cv vn cv wcel wa vm vn copab c0 wne vr vs vr cv cF wcel vs cv vr
      cv wcel wa vs cv vr cv cop vn cv cF wcel vm cv vn cv wcel wa vm vn copab
      wcel vn cv cF wcel vm cv vn cv wcel wa vm vn copab c0 wne vn cv cF wcel
      vm cv vn cv wcel wa vn cv cF wcel vs cv vn cv wcel wa vr cv cF wcel vs cv
      vr cv wcel wa vm vn vs cv vr cv vs visset vr visset vm cv vs cv wceq vm
      cv vn cv wcel vs cv vn cv wcel vn cv cF wcel vm cv vs cv vn cv eleq1
      anbi2d vn cv vr cv wceq vn cv cF wcel vr cv cF wcel vs cv vn cv wcel vs
      cv vr cv wcel vn cv vr cv cF eleq1 vn cv vr cv vs cv eleq2 anbi12d
      opelopab vn cv cF wcel vm cv vn cv wcel wa vm vn copab vs cv vr cv cop
      ne0i sylbir 19.23aivv syl cF cfil wcel vn cv cF wcel vm cv vn cv wcel wa
      vm vn copab vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm c0 cF cfil wcel vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa
      vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cuni cuni vn cv cF wcel vm cv vn
      cv wcel wa vm vn copab cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel
      vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel
      vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex
      vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cuni cuni wceq vx vy
      vv vu vg vh cF cX filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab dirdm syl
      vx vy vv vu vg vh vm vn cF cX filnet.1 filnetlem1 syl6req neeq1d mpbid
      adantr sylanc cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cX c1st vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm cres wf vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cuni
      cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm cres wf cF cfil wcel vx cv vu cv vh cv
      cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel
      vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy
      copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv
      vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex
      vv cX wrex vu cX wrex vx vy copab ctail cfv crn cuni wceq vx cv vu cv vh
      cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres wf vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab ctail cfv crn cuni cX c1st vx cv vu cv vh cv cop wceq vy cv
      vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm cres
      wf wb cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq
      wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh
      cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn cuni vx cv vu cv
      vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv
      wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex
      vx vy copab cdm cF cfil wcel vx cv vu cv vh cv cop wceq vy cv vv cv vg cv
      cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg
      cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdir wcel vx cv vu
      cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg
      cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab ctail cfv crn cuni vx cv vu cv vh cv cop wceq vy cv vv
      cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss
      w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm wceq
      vx vy vv vu vg vh cF cX filnet.1 filnetlem4 vx cv vu cv vh cv cop wceq vy
      cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv
      wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab vx cv
      vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh cv wcel vv cv
      vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv cX wrex vu cX
      wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop
      wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF
      wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab cdm eqid tailuni syl
      eqcomd vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu cv vh
      cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF wrex vv
      cX wrex vu cX wrex vx vy copab cdm vx cv vu cv vh cv cop wceq vy cv vv cv
      vg cv cop wceq wa vu cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a
      wa vg cF wrex vh cF wrex vv cX wrex vu cX wrex vx vy copab ctail cfv crn
      cuni cX c1st vx cv vu cv vh cv cop wceq vy cv vv cv vg cv cop wceq wa vu
      cv vh cv wcel vv cv vg cv wcel vg cv vh cv wss w3a wa vg cF wrex vh cF
      wrex vv cX wrex vu cX wrex vx vy copab cdm cres feq2 syl biimpa syl3anc
      bitr4d eqrdv ex jcai sylc sylanc $.
      $( [15-Dec-2009] $) $( [12-Dec-2009] $)
  $}

$( (End of Jeffrey Hankins' mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                          Mathbox for Jeff Madsen
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logic and set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d w x z $. $d w y z $. $d w ph $.
    $( Substitution into "at most one". $)
    sbmo $p |- ( [ y / x ] E* z ph <-> E* z [ y / x ] ph ) $=
      wph vz cv vw cv wceq wi vz wal vw wex vx vy cv wsbc wph vx vy cv wsbc vz
      cv vw cv wceq wi vz wal vw wex wph vz wmo vx vy cv wsbc wph vx vy cv wsbc
      vz wmo wph vz cv vw cv wceq wi vz wal vw wex vx vy cv wsbc wph vz cv vw
      cv wceq wi vz wal vx vy cv wsbc vw wex wph vx vy cv wsbc vz cv vw cv wceq
      wi vz wal vw wex wph vz cv vw cv wceq wi vz wal vw vx vy sbex wph vz cv
      vw cv wceq wi vz wal vx vy cv wsbc wph vx vy cv wsbc vz cv vw cv wceq wi
      vz wal vw wph vz cv vw cv wceq wi wph vx vy cv wsbc vz cv vw cv wceq wi
      vx vy vz wph vz cv vw cv wceq wi vx vy cv wsbc wph vx vy cv wsbc vz cv vw
      cv wceq vx vy cv wsbc wi wph vx vy cv wsbc vz cv vw cv wceq wi wph vz cv
      vw cv wceq vx vy sbim vz cv vw cv wceq vx vy cv wsbc vz cv vw cv wceq wph
      vx vy cv wsbc vz cv vw cv wceq vx vy vz cv vw cv wceq vx ax-17 sbf imbi2i
      bitri sbalv exbii bitri wph vz wmo wph vz cv vw cv wceq wi vz wal vw wex
      vx vy wph vz vw wph vw ax-17 mo2 sbbii wph vx vy cv wsbc vz vw wph vx vy
      cv wsbc vw ax-17 mo2 3bitr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d B x y $. $d ch x y $.
    brabg2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    brabg2.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    brabg2.3 $e |- R = { <. x , y >. | ph } $.
    brabg2.4 $e |- ( ch -> A e. C ) $.
    $( Relation by a binary relation abstraction. $)
    brabg2 $p |- ( B e. D -> ( A R B <-> ch ) ) $=
      cB cD wcel cA cB cR wbr wch cB cD wcel cA cB cR wbr cA cvv wcel wch cA cB
      cR cR wrel wph vx vy copab wrel wph vx vy relopab cR wph vx vy copab
      brabg2.3 releqi mpbir brrelexi cA cvv wcel cB cD wcel cA cB cR wbr wch cA
      cvv wcel cB cD wcel cA cB cR wbr wch wi cA cvv wcel cB cD wcel wa cA cB
      cR wbr wch wph wps wch vx vy cA cB cvv cD cR brabg2.1 brabg2.2 brabg2.3
      brabg biimpd ex com3l mpdi cB cD wcel wch cA cC wcel cA cB cR wbr
      brabg2.4 cA cC wcel cB cD wcel wch cA cB cR wbr cA cC wcel cB cD wcel wch
      cA cB cR wbr wi cA cC wcel cB cD wcel wa cA cB cR wbr wch wph wps wch vx
      vy cA cB cC cD cR brabg2.1 brabg2.2 brabg2.3 brabg biimprd ex com3l mpdi
      impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d B x y $. $d ph y $.
    $( Restricted quantification over union. $)
    ralun $p |- ( ( A. x e. A ph /\ A. x e. B ph )
            -> A. x e. ( A u. B ) ph ) $=
      wph vx cA wral wph vx cB wral wa wph vx vy cv wsbc vy cA cB cun wral wph
      vx cA cB cun wral wph vx cA wral wph vx cB wral wa wph vx vy cv wsbc vy
      cA cB cun wph vx cA wral wph vx cB wral wa vy cv cA wcel vy cv cB wcel wo
      wph vx vy cv wsbc vy cv cA cB cun wcel wph vx cA wral vy cv cA wcel wph
      vx vy cv wsbc wph vx cB wral vy cv cB wcel vy cv cA wcel wph vx cA wral
      wph vx vy cv wsbc wph vx vy cv cA ra4sbc com12 vy cv cB wcel wph vx cB
      wral wph vx vy cv wsbc wph vx vy cv cB ra4sbc com12 jaao vy cv cA cB elun
      syl5ib r19.21aiv wph vx vy cA cB cun cbvralsv sylibr $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F x y $. $d A x y $. $d B x y $. $d ph x $. $d ps y $.
    raleqfn.1 $e |- ( y = ( F ` x ) -> ( ph <-> ps ) ) $.
    $( Change the domain of quantification by a function. $)
    raleqfn $p |- ( ( F Fn A /\ B C_ A ) ->
                              ( A. x e. B ps <-> A. y e. ( F " B ) ph ) ) $=
      cF cA wfn cB cA wss wa wps vx cB wral wph vy cF cB cima wral cF cA wfn cB
      cA wss wa wps vx cB wral wph vy cF cB cima cF cA wfn cB cA wss wa vy cv
      cF cB cima wcel wps vx cB wral wph cF cA wfn cB cA wss wa vy cv cF cB
      cima wcel vx cv cF cfv vy cv wceq vx cB wrex wps vx cB wral wph wi vx cA
      cB vy cv cF fvelimab vx cv cF cfv vy cv wceq vx cB wrex wps vx cB wral
      wph vx cv cF cfv vy cv wceq vx cB wrex wps vx cB wral wa vx cv cF cfv vy
      cv wceq wps wa vx cB wrex wph vx cv cF cfv vy cv wceq wps vx cB r19.29r
      vx cv cF cfv vy cv wceq wps wa wph vx cB vx cv cF cfv vy cv wceq wps wa
      wph vx cv cB wcel vx cv cF cfv vy cv wceq wph wps wph wps wb vy cv vx cv
      cF cfv raleqfn.1 eqcoms biimpar adantl r19.23aiva syl ex syl6bi com23
      r19.21adv cF cA wfn cB cA wss wa wph vy cF cB cima wral wps vx cB cF cA
      wfn cB cA wss wa vx cv cB wcel wph vy cF cB cima wral wps cF cA wfn cB cA
      wss wa vx cv cB wcel vx cv cF cfv cF cB cima wcel wph vy cF cB cima wral
      wps wi cF wfun cB cF cdm wss vx cv cB wcel vx cv cF cfv cF cB cima wcel
      wi cF cA wfn cB cA wss wa cB vx cv cF funfvima2 cF cA wfn cF wfun cB cA
      wss cA cF fnfun adantr cF cA wfn cB cF cdm wss cB cA wss cF cA wfn cF cdm
      cA cB cA cF fndm sseq2d biimpar sylanc wph wps vy vx cv cF cfv cF cB cima
      raleqfn.1 rcla4v syl6 com23 r19.21adv impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A z $. $d B z $. $d C z $.
    $( Represent a set difference as an intersection with a larger
       difference. $)
    difin2 $p |- ( A C_ C -> ( A \ B ) = ( ( C \ B ) i^i A ) ) $=
      cA cC wss vz cA cB cdif cC cB cdif cA cin cA cC wss vz cv cA wcel vz cv
      cB wcel wn wa vz cv cA wcel vz cv cC wcel wa vz cv cB wcel wn wa vz cv cA
      cB cdif wcel vz cv cC cB cdif cA cin wcel cA cC wss vz cv cA wcel vz cv
      cA wcel vz cv cC wcel wa vz cv cB wcel wn cA cC wss vz cv cA wcel vz cv
      cC wcel wi vz cv cA wcel vz cv cA wcel vz cv cC wcel wa wb cA cC vz cv
      ssel vz cv cA wcel vz cv cC wcel pm4.71 sylib anbi1d vz cv cA cB eldif vz
      cv cC cB cdif cA cin wcel vz cv cC cB cdif wcel vz cv cA wcel wa vz cv cC
      wcel vz cv cB wcel wn wa vz cv cA wcel wa vz cv cA wcel vz cv cC wcel wa
      vz cv cB wcel wn wa vz cv cC cB cdif cA elin vz cv cC cB cdif wcel vz cv
      cC wcel vz cv cB wcel wn wa vz cv cA wcel vz cv cC cB eldif anbi1i vz cv
      cC wcel vz cv cB wcel wn wa vz cv cA wcel wa vz cv cA wcel vz cv cC wcel
      vz cv cB wcel wn wa wa vz cv cA wcel vz cv cC wcel wa vz cv cB wcel wn wa
      vz cv cC wcel vz cv cB wcel wn wa vz cv cA wcel ancom vz cv cA wcel vz cv
      cC wcel vz cv cB wcel wn anass bitr4i 3bitri 3bitr4g eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F x $. $d A x $. $d B x $.
    $( Preimage of an intersection. $)
    inpreima $p |- ( Fun F -> ( `' F " ( A i^i B ) )
                                  = ( ( `' F " A ) i^i ( `' F " B ) ) ) $=
      cF wfun cF cF cdm wfn cF ccnv cA cB cin cima cF ccnv cA cima cF ccnv cB
      cima cin wceq cF funfn cF cF cdm wfn vx cF ccnv cA cB cin cima cF ccnv cA
      cima cF ccnv cB cima cin cF cF cdm wfn vx cv cF ccnv cA cB cin cima wcel
      vx cv cF ccnv cA cima wcel vx cv cF ccnv cB cima wcel wa vx cv cF ccnv cA
      cima cF ccnv cB cima cin wcel cF cF cdm wfn vx cv cF cdm wcel vx cv cF
      cfv cA cB cin wcel wa vx cv cF cdm wcel vx cv cF cfv cA wcel wa vx cv cF
      cdm wcel vx cv cF cfv cB wcel wa wa vx cv cF ccnv cA cB cin cima wcel vx
      cv cF ccnv cA cima wcel vx cv cF ccnv cB cima wcel wa cF cF cdm wfn vx cv
      cF cdm wcel vx cv cF cfv cA cB cin wcel wa vx cv cF cdm wcel vx cv cF cfv
      cA wcel vx cv cF cfv cB wcel wa wa vx cv cF cdm wcel vx cv cF cfv cA wcel
      wa vx cv cF cdm wcel vx cv cF cfv cB wcel wa wa vx cv cF cdm wcel vx cv
      cF cfv cA cB cin wcel wa vx cv cF cdm wcel vx cv cF cfv cA wcel vx cv cF
      cfv cB wcel wa wa wb cF cF cdm wfn vx cv cF cfv cA cB cin wcel vx cv cF
      cfv cA wcel vx cv cF cfv cB wcel wa vx cv cF cdm wcel vx cv cF cfv cA cB
      elin anbi2i a1i vx cv cF cdm wcel vx cv cF cfv cA wcel vx cv cF cfv cB
      wcel anandi syl6bb cF cdm vx cv cA cB cin cF elpreima cF cF cdm wfn vx cv
      cF ccnv cA cima wcel vx cv cF cdm wcel vx cv cF cfv cA wcel wa vx cv cF
      ccnv cB cima wcel vx cv cF cdm wcel vx cv cF cfv cB wcel wa cF cdm vx cv
      cA cF elpreima cF cdm vx cv cB cF elpreima anbi12d 3bitr4d vx cv cF ccnv
      cA cima cF ccnv cB cima elin syl6bbr eqrdv sylbi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F x $. $d A x $. $d B x $.
    $( Preimage of a union. $)
    unpreima $p |- ( Fun F -> ( `' F " ( A u. B ) )
                                  = ( ( `' F " A ) u. ( `' F " B ) ) ) $=
      cF wfun cF cF cdm wfn cF ccnv cA cB cun cima cF ccnv cA cima cF ccnv cB
      cima cun wceq cF funfn cF cF cdm wfn vx cF ccnv cA cB cun cima cF ccnv cA
      cima cF ccnv cB cima cun cF cF cdm wfn vx cv cF cdm wcel vx cv cF cfv cA
      cB cun wcel wa vx cv cF cdm wcel vx cv cF cfv cA wcel wa vx cv cF cdm
      wcel vx cv cF cfv cB wcel wa wo vx cv cF ccnv cA cB cun cima wcel vx cv
      cF ccnv cA cima cF ccnv cB cima cun wcel vx cv cF cdm wcel vx cv cF cfv
      cA cB cun wcel wa vx cv cF cdm wcel vx cv cF cfv cA wcel wa vx cv cF cdm
      wcel vx cv cF cfv cB wcel wa wo wb cF cF cdm wfn vx cv cF cdm wcel vx cv
      cF cfv cA cB cun wcel wa vx cv cF cdm wcel vx cv cF cfv cA wcel vx cv cF
      cfv cB wcel wo wa vx cv cF cdm wcel vx cv cF cfv cA wcel wa vx cv cF cdm
      wcel vx cv cF cfv cB wcel wa wo vx cv cF cfv cA cB cun wcel vx cv cF cfv
      cA wcel vx cv cF cfv cB wcel wo vx cv cF cdm wcel vx cv cF cfv cA cB elun
      anbi2i vx cv cF cdm wcel vx cv cF cfv cA wcel vx cv cF cfv cB wcel andi
      bitri a1i cF cdm vx cv cA cB cun cF elpreima cF cF cdm wfn vx cv cF ccnv
      cA cima wcel vx cv cF ccnv cB cima wcel wo vx cv cF cdm wcel vx cv cF cfv
      cA wcel wa vx cv cF cdm wcel vx cv cF cfv cB wcel wa wo vx cv cF ccnv cA
      cima cF ccnv cB cima cun wcel cF cF cdm wfn vx cv cF ccnv cA cima wcel vx
      cv cF cdm wcel vx cv cF cfv cA wcel wa vx cv cF ccnv cB cima wcel vx cv
      cF cdm wcel vx cv cF cfv cB wcel wa cF cdm vx cv cA cF elpreima cF cdm vx
      cv cB cF elpreima orbi12d vx cv cF ccnv cA cima cF ccnv cB cima elun
      syl5bb 3bitr4d eqrdv sylbi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F z $. $d A z $. $d B z $.
    $( The preimage of a restricted function. $)
    respreima $p |- ( Fun F -> ( `' ( F |` B ) " A )
                                    = ( ( `' F " A ) i^i B ) ) $=
      cF wfun vz cF cB cres ccnv cA cima cF ccnv cA cima cB cin cF wfun cF cF
      cdm wfn vz cv cF cB cres ccnv cA cima wcel vz cv cF ccnv cA cima cB cin
      wcel wb cF funfn cF cF cdm wfn vz cv cB cF cdm cin wcel vz cv cF cB cres
      cfv cA wcel wa vz cv cF cdm wcel vz cv cF cfv cA wcel wa vz cv cB wcel wa
      vz cv cF cB cres ccnv cA cima wcel vz cv cF ccnv cA cima cB cin wcel cF
      cF cdm wfn vz cv cB cF cdm cin wcel vz cv cF cB cres cfv cA wcel wa vz cv
      cF cdm wcel vz cv cB wcel wa vz cv cF cfv cA wcel wa vz cv cF cdm wcel vz
      cv cF cfv cA wcel wa vz cv cB wcel wa vz cv cB cF cdm cin wcel vz cv cF
      cB cres cfv cA wcel wa vz cv cF cdm wcel vz cv cB wcel wa vz cv cF cfv cA
      wcel wa wb cF cF cdm wfn vz cv cB cF cdm cin wcel vz cv cF cB cres cfv cA
      wcel wa vz cv cF cdm wcel vz cv cB wcel wa vz cv cF cB cres cfv cA wcel
      wa vz cv cF cdm wcel vz cv cB wcel wa vz cv cF cfv cA wcel wa vz cv cB cF
      cdm cin wcel vz cv cF cdm wcel vz cv cB wcel wa vz cv cF cB cres cfv cA
      wcel vz cv cB cF cdm cin wcel vz cv cB wcel vz cv cF cdm wcel wa vz cv cF
      cdm wcel vz cv cB wcel wa vz cv cB cF cdm elin vz cv cB wcel vz cv cF cdm
      wcel ancom bitri anbi1i vz cv cF cdm wcel vz cv cB wcel wa vz cv cF cB
      cres cfv cA wcel vz cv cF cfv cA wcel vz cv cB wcel vz cv cF cB cres cfv
      cA wcel vz cv cF cfv cA wcel wb vz cv cF cdm wcel vz cv cB wcel vz cv cF
      cB cres cfv vz cv cF cfv cA vz cv cB cF fvres eleq1d adantl pm5.32i bitri
      a1i vz cv cF cdm wcel vz cv cB wcel vz cv cF cfv cA wcel an23 syl6bb cF
      cF cdm wfn cF cB cres cB cF cdm cin wfn vz cv cF cB cres ccnv cA cima
      wcel vz cv cB cF cdm cin wcel vz cv cF cB cres cfv cA wcel wa wb cF cF
      cdm wfn cF cB cres wfun cF cB cres cdm cB cF cdm cin wceq wa cF cB cres
      cB cF cdm cin wfn cF cF cdm wfn cF cB cres wfun cF cB cres cdm cB cF cdm
      cin wceq cF cF cdm wfn cF wfun cF cB cres wfun cF cdm cF fnfun cB cF
      funres syl cF cB dmres jctir cF cB cres cB cF cdm cin df-fn sylibr cB cF
      cdm cin vz cv cA cF cB cres elpreima syl cF cF cdm wfn vz cv cF ccnv cA
      cima wcel vz cv cB wcel wa vz cv cF cdm wcel vz cv cF cfv cA wcel wa vz
      cv cB wcel wa vz cv cF ccnv cA cima cB cin wcel cF cF cdm wfn vz cv cF
      ccnv cA cima wcel vz cv cF cdm wcel vz cv cF cfv cA wcel wa vz cv cB wcel
      cF cdm vz cv cA cF elpreima anbi1d vz cv cF ccnv cA cima cB elin syl5bb
      3bitr4d sylbi eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x $. $d B x $. $d C x $. $d D x $.
    $( Difference of Cartesian products, expressed in terms of a union
    of Cartesian products of differences. $)
    difxp $p |- ( ( C X. D ) \ ( A X. B ) ) =
                        ( ( ( ( C \ A ) X. D ) u. ( C X. ( D \ B ) ) )
                                          u. ( ( C \ A ) X. ( D \ B ) ) ) $=
      vx cC cD cxp cA cB cxp cdif cC cA cdif cD cxp cC cD cB cdif cxp cun cC cA
      cdif cD cB cdif cxp cun vx cv cC cD cxp cA cB cxp cdif wcel vx cv cC cA
      cdif cD cxp cC cD cB cdif cxp cun cC cA cdif cD cB cdif cxp cun wcel vx
      cv cC cD cxp wcel vx cv cA cB cxp wcel wn wa vx cv cC cA cdif cD cxp wcel
      vx cv cC cD cB cdif cxp wcel vx cv cC cA cdif cD cB cdif cxp wcel wo wo
      vx cv cC cD cxp cA cB cxp cdif wcel vx cv cC cA cdif cD cxp cC cD cB cdif
      cxp cun cC cA cdif cD cB cdif cxp cun wcel vx cv cC cD cxp wcel vx cv cA
      cB cxp wcel wn wa vx cv c2nd cfv cB wcel vx cv cC cA cdif cD cxp wcel vx
      cv cC cD cB cdif cxp wcel vx cv cC cA cdif cD cB cdif cxp wcel wo wo vx
      cv cC cD cxp wcel vx cv cA cB cxp wcel wn wa vx cv c2nd cfv cB wcel wa vx
      cv cC cA cdif cD cxp wcel vx cv cC cD cB cdif cxp wcel vx cv cC cA cdif
      cD cB cdif cxp wcel wo vx cv cC cD cxp wcel vx cv cA cB cxp wcel wn vx cv
      c2nd cfv cB wcel vx cv cC cA cdif cD cxp wcel vx cv vx cv c1st cfv vx cv
      c2nd cfv cop wceq vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa wa vx
      cv cA cB cxp wcel wn vx cv c2nd cfv cB wcel wa vx cv cC cA cdif cD cxp
      wcel vx cv cC cD cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx
      cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa wa vx cv cA cB cxp wcel wn
      vx cv c2nd cfv cB wcel wa wa vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq
      vx cv c1st cfv cC cA cdif wcel vx cv c2nd cfv cD wcel wa wa vx cv cC cA
      cdif cD cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st
      cfv cC wcel vx cv c2nd cfv cD wcel wa vx cv cA cB cxp wcel wn vx cv c2nd
      cfv cB wcel wa vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st
      cfv cC cA cdif wcel vx cv c2nd cfv cD wcel wa wa vx cv vx cv c1st cfv vx
      cv c2nd cfv cop wceq vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa vx
      cv cA cB cxp wcel wn vx cv c2nd cfv cB wcel wa wa vx cv c1st cfv cC cA
      cdif wcel vx cv c2nd cfv cD wcel wa vx cv vx cv c1st cfv vx cv c2nd cfv
      cop wceq vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa vx cv cA cB cxp
      wcel wn vx cv c2nd cfv cB wcel wa wa vx cv c1st cfv cC wcel vx cv c2nd
      cfv cD wcel wa vx cv c1st cfv cA wcel wn wa vx cv c1st cfv cC cA cdif
      wcel vx cv c2nd cfv cD wcel wa vx cv vx cv c1st cfv vx cv c2nd cfv cop
      wceq vx cv cA cB cxp wcel wn vx cv c2nd cfv cB wcel wa vx cv c1st cfv cA
      wcel wn vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa vx cv vx cv c1st
      cfv vx cv c2nd cfv cop wceq vx cv c2nd cfv cB wcel vx cv cA cB cxp wcel
      wn vx cv c1st cfv cA wcel wn vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq
      vx cv c2nd cfv cB wcel vx cv cA cB cxp wcel wn vx cv c1st cfv cA wcel wn
      vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c2nd cfv cB wcel wa vx
      cv c1st cfv cA wcel vx cv cA cB cxp wcel vx cv vx cv c1st cfv vx cv c2nd
      cfv cop wceq vx cv c2nd cfv cB wcel wa vx cv c1st cfv cA wcel vx cv cA cB
      cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st cfv cA
      wcel vx cv c2nd cfv cB wcel vx cv cA cB cxp wcel vx cv vx cv c1st cfv vx
      cv c2nd cfv cop wceq vx cv c1st cfv cA wcel vx cv c2nd cfv cB wcel vx cv
      cA cB cxp wcel vx cv cA cB cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv
      cop wceq vx cv c1st cfv cA wcel vx cv c2nd cfv cB wcel wa wa vx cv cA cB
      elxp6 biimpri anassrs an1rs ex con3d expimpd ancomsd anim2d vx cv c1st
      cfv cC wcel vx cv c1st cfv cA wcel wn vx cv c2nd cfv cD wcel vx cv c1st
      cfv cC cA cdif wcel vx cv c2nd cfv cD wcel wa vx cv c1st cfv cC wcel vx
      cv c1st cfv cA wcel wn wa vx cv c1st cfv cC cA cdif wcel vx cv c2nd cfv
      cD wcel vx cv c1st cfv cC cA cdif wcel vx cv c1st cfv cC wcel vx cv c1st
      cfv cA wcel wn wa vx cv c1st cfv cC cA eldif biimpri anim1i an1rs syl6
      imdistani anassrs vx cv cC cA cdif cD elxp6 sylibr vx cv cC cD elxp6
      sylanb anassrs orcd vx cv cC cD cxp wcel vx cv cA cB cxp wcel wn wa vx cv
      c2nd cfv cB wcel wn wa vx cv cC cD cB cdif cxp wcel vx cv cC cA cdif cD
      cB cdif cxp wcel wo vx cv cC cA cdif cD cxp wcel vx cv cC cD cxp wcel vx
      cv cA cB cxp wcel wn wa vx cv c2nd cfv cB wcel wn wa vx cv c1st cfv cA
      wcel vx cv cC cD cB cdif cxp wcel vx cv cC cA cdif cD cB cdif cxp wcel wo
      vx cv cC cD cxp wcel vx cv cA cB cxp wcel wn wa vx cv c2nd cfv cB wcel wn
      wa vx cv c1st cfv cA wcel wa vx cv cC cD cB cdif cxp wcel vx cv cC cA
      cdif cD cB cdif cxp wcel vx cv cC cD cxp wcel vx cv c2nd cfv cB wcel wn
      vx cv c1st cfv cA wcel vx cv cC cD cB cdif cxp wcel vx cv cA cB cxp wcel
      wn vx cv cC cD cxp wcel vx cv c2nd cfv cB wcel wn vx cv c1st cfv cA wcel
      vx cv cC cD cB cdif cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq
      vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa wa vx cv c2nd cfv cB
      wcel wn vx cv c1st cfv cA wcel wa vx cv cC cD cB cdif cxp wcel vx cv cC
      cD cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st cfv
      cC wcel vx cv c2nd cfv cD wcel wa wa vx cv c2nd cfv cB wcel wn vx cv c1st
      cfv cA wcel wa wa vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st
      cfv cC wcel vx cv c2nd cfv cD cB cdif wcel wa wa vx cv cC cD cB cdif cxp
      wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st cfv cC wcel
      vx cv c2nd cfv cD wcel wa vx cv c2nd cfv cB wcel wn vx cv c1st cfv cA
      wcel wa vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st cfv cC
      wcel vx cv c2nd cfv cD cB cdif wcel wa wa vx cv c1st cfv cC wcel vx cv
      c2nd cfv cD wcel wa vx cv c2nd cfv cB wcel wn vx cv c1st cfv cA wcel wa
      wa vx cv c1st cfv cC wcel vx cv c2nd cfv cD cB cdif wcel wa vx cv vx cv
      c1st cfv vx cv c2nd cfv cop wceq vx cv c1st cfv cC wcel vx cv c1st cfv cA
      wcel vx cv c2nd cfv cD wcel vx cv c2nd cfv cB wcel wn vx cv c1st cfv cC
      wcel vx cv c2nd cfv cD cB cdif wcel wa vx cv c1st cfv cC wcel vx cv c1st
      cfv cA wcel wa vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel vx cv c2nd
      cfv cB wcel wn wa vx cv c2nd cfv cD cB cdif wcel vx cv c1st cfv cC wcel
      vx cv c1st cfv cA wcel pm3.26 vx cv c2nd cfv cD cB cdif wcel vx cv c2nd
      cfv cD wcel vx cv c2nd cfv cB wcel wn wa vx cv c2nd cfv cD cB eldif
      biimpri anim12i an42s anim2i anassrs vx cv cC cD cB cdif elxp6 sylibr vx
      cv cC cD elxp6 sylanb anassrs adantllr orcd vx cv cC cD cxp wcel vx cv cA
      cB cxp wcel wn wa vx cv c2nd cfv cB wcel wn wa vx cv c1st cfv cA wcel wn
      wa vx cv cC cA cdif cD cB cdif cxp wcel vx cv cC cD cB cdif cxp wcel vx
      cv cC cD cxp wcel vx cv c2nd cfv cB wcel wn vx cv c1st cfv cA wcel wn vx
      cv cC cA cdif cD cB cdif cxp wcel vx cv cA cB cxp wcel wn vx cv cC cD cxp
      wcel vx cv c2nd cfv cB wcel wn vx cv c1st cfv cA wcel wn vx cv cC cA cdif
      cD cB cdif cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv
      c1st cfv cC wcel vx cv c2nd cfv cD wcel wa wa vx cv c2nd cfv cB wcel wn
      vx cv c1st cfv cA wcel wn wa vx cv cC cA cdif cD cB cdif cxp wcel vx cv
      cC cD cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx cv c1st
      cfv cC wcel vx cv c2nd cfv cD wcel wa wa vx cv c2nd cfv cB wcel wn vx cv
      c1st cfv cA wcel wn wa wa vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq vx
      cv c1st cfv cC cA cdif wcel vx cv c2nd cfv cD cB cdif wcel wa wa vx cv cC
      cA cdif cD cB cdif cxp wcel vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq
      vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa vx cv c2nd cfv cB wcel
      wn vx cv c1st cfv cA wcel wn wa vx cv vx cv c1st cfv vx cv c2nd cfv cop
      wceq vx cv c1st cfv cC cA cdif wcel vx cv c2nd cfv cD cB cdif wcel wa wa
      vx cv c1st cfv cC wcel vx cv c2nd cfv cD wcel wa vx cv c2nd cfv cB wcel
      wn vx cv c1st cfv cA wcel wn wa wa vx cv c1st cfv cC cA cdif wcel vx cv
      c2nd cfv cD cB cdif wcel wa vx cv vx cv c1st cfv vx cv c2nd cfv cop wceq
      vx cv c1st cfv cC wcel vx cv c1st cfv cA wcel wn vx cv c2nd cfv cD wcel
      vx cv c2nd cfv cB wcel wn vx cv c1st cfv cC cA cdif wcel vx cv c2nd cfv
      cD cB cdif wcel wa vx cv c1st cfv cC cA cdif wcel vx cv c2nd cfv cD cB
      cdif wcel wa vx cv c1st cfv cC wcel vx cv c1st cfv cA wcel wn wa vx cv
      c2nd cfv cD wcel vx cv c2nd cfv cB wcel wn wa wa vx cv c1st cfv cC cA
      cdif wcel vx cv c1st cfv cC wcel vx cv c1st cfv cA wcel wn wa vx cv c2nd
      cfv cD cB cdif wcel vx cv c2nd cfv cD wcel vx cv c2nd cfv cB wcel wn wa
      vx cv c1st cfv cC cA eldif vx cv c2nd cfv cD cB eldif anbi12i biimpri
      an42s anim2i anassrs vx cv cC cA cdif cD cB cdif elxp6 sylibr vx cv cC cD
      elxp6 sylanb anassrs adantllr olcd pm2.61dan olcd pm2.61dan vx cv cC cD
      cxp cA cB cxp eldif vx cv cC cA cdif cD cxp cC cD cB cdif cxp cun cC cA
      cdif cD cB cdif cxp cun wcel vx cv cC cA cdif cD cxp cC cD cB cdif cxp
      cun wcel vx cv cC cA cdif cD cB cdif cxp wcel wo vx cv cC cA cdif cD cxp
      wcel vx cv cC cD cB cdif cxp wcel wo vx cv cC cA cdif cD cB cdif cxp wcel
      wo vx cv cC cA cdif cD cxp wcel vx cv cC cD cB cdif cxp wcel vx cv cC cA
      cdif cD cB cdif cxp wcel wo wo vx cv cC cA cdif cD cxp cC cD cB cdif cxp
      cun cC cA cdif cD cB cdif cxp elun vx cv cC cA cdif cD cxp cC cD cB cdif
      cxp cun wcel vx cv cC cA cdif cD cxp wcel vx cv cC cD cB cdif cxp wcel wo
      vx cv cC cA cdif cD cB cdif cxp wcel vx cv cC cA cdif cD cxp cC cD cB
      cdif cxp elun orbi1i vx cv cC cA cdif cD cxp wcel vx cv cC cD cB cdif cxp
      wcel vx cv cC cA cdif cD cB cdif cxp wcel orass 3bitri 3imtr4i vx cv cC
      cA cdif cD cxp cC cD cB cdif cxp cun wcel vx cv cC cA cdif cD cB cdif cxp
      wcel wo vx cv cC cD cxp wcel vx cv cA cB cxp wcel wn wa vx cv cC cA cdif
      cD cxp cC cD cB cdif cxp cun cC cA cdif cD cB cdif cxp cun wcel vx cv cC
      cD cxp cA cB cxp cdif wcel vx cv cC cA cdif cD cxp cC cD cB cdif cxp cun
      wcel vx cv cC cD cxp wcel vx cv cA cB cxp wcel wn wa vx cv cC cA cdif cD
      cB cdif cxp wcel vx cv cC cA cdif cD cxp cC cD cB cdif cxp cun wcel vx cv
      cC cA cdif cD cxp wcel vx cv cC cD cB cdif cxp wcel wo vx cv cC cD cxp
      wcel vx cv cA cB cxp wcel wn wa vx cv cC cA cdif cD cxp cC cD cB cdif cxp
      elun vx cv cC cA cdif cD cxp wcel vx cv cC cD cxp wcel vx cv cA cB cxp
      wcel wn wa vx cv cC cD cB cdif cxp wcel vx cv cC cA cdif cD cxp wcel vx
      cv cC cD cxp wcel vx cv cA cB cxp wcel wn cC cA cdif cD cxp cC cD cxp vx
      cv cC cA cdif cC wss cD cD wss cC cA cdif cD cxp cC cD cxp wss cC cA
      difss cD ssid cC cA cdif cC cD cD ssxp mp2an sseli vx cv cC cA cdif cD
      cxp wcel vx cv c1st cfv cC cA cdif wcel vx cv c1st cfv cA wcel wn vx cv
      cA cB cxp wcel wn vx cv cC cA cdif cD xp1st vx cv c1st cfv cC cA eldifn
      vx cv cA cB cxp wcel vx cv c1st cfv cA wcel vx cv cA cB xp1st con3i 3syl
      jca vx cv cC cD cB cdif cxp wcel vx cv cC cD cxp wcel vx cv cA cB cxp
      wcel wn cC cD cB cdif cxp cC cD cxp vx cv cC cC wss cD cB cdif cD wss cC
      cD cB cdif cxp cC cD cxp wss cC ssid cD cB difss cC cC cD cB cdif cD ssxp
      mp2an sseli vx cv cC cD cB cdif cxp wcel vx cv c2nd cfv cD cB cdif wcel
      vx cv c2nd cfv cB wcel wn vx cv cA cB cxp wcel wn vx cv cC cD cB cdif
      xp2nd vx cv c2nd cfv cD cB eldifn vx cv cA cB cxp wcel vx cv c2nd cfv cB
      wcel vx cv cA cB xp2nd con3i 3syl jca jaoi sylbi vx cv cC cA cdif cD cB
      cdif cxp wcel vx cv cC cD cxp wcel vx cv cA cB cxp wcel wn cC cA cdif cD
      cB cdif cxp cC cD cxp vx cv cC cA cdif cC wss cD cB cdif cD wss cC cA
      cdif cD cB cdif cxp cC cD cxp wss cC cA difss cD cB difss cC cA cdif cC
      cD cB cdif cD ssxp mp2an sseli vx cv cC cA cdif cD cB cdif cxp wcel vx cv
      c1st cfv cC cA cdif wcel vx cv c1st cfv cA wcel wn vx cv cA cB cxp wcel
      wn vx cv cC cA cdif cD cB cdif xp1st vx cv c1st cfv cC cA eldifn vx cv cA
      cB cxp wcel vx cv c1st cfv cA wcel vx cv cA cB xp1st con3i 3syl jca jaoi
      vx cv cC cA cdif cD cxp cC cD cB cdif cxp cun cC cA cdif cD cB cdif cxp
      elun vx cv cC cD cxp cA cB cxp eldif 3imtr4i impbii eqriv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Move a conditional outside of a function. $)
    fvif $p |- ( F ` if ( ph , A , B ) ) = if ( ph , ( F ` A ) , ( F ` B ) ) $=
      wph wph cA cB cif cF cfv wph cA cF cfv cB cF cfv cif wceq wph wph cA cB
      cif cF cfv cA cF cfv wph cA cF cfv cB cF cfv cif wph wph cA cB cif cA cF
      wph cA cB iftrue fveq2d wph cA cF cfv cB cF cfv iftrue eqtr4d wph wn wph
      cA cB cif cF cfv cB cF cfv wph cA cF cfv cB cF cfv cif wph wn wph cA cB
      cif cB cF wph cA cB iffalse fveq2d wph cA cF cfv cB cF cfv iffalse eqtr4d
      pm2.61i $.
      $( [2-Sep-2009] $)
  $}

  ${
    ifeq1da.1 $e |- ( ( ph /\ ps ) -> A = B ) $.
    $( Conditional equality. $)
    ifeq1da $p |- ( ph -> if ( ps , A , C ) = if ( ps , B , C ) ) $=
      wph wps wps cA cC cif wps cB cC cif wceq wph wps wa wps cA cB cC
      ifeq1da.1 ifeq1d wps wn wps cA cC cif wps cB cC cif wceq wph wps wn wps
      cA cC cif cC wps cB cC cif wps cA cC iffalse wps cB cC iffalse eqtr4d
      adantl pm2.61dan $.
      $( [2-Sep-2009] $)
  $}

  ${
    ifeq2da.1 $e |- ( ( ph /\ -. ps ) -> A = B ) $.
    $( Conditional equality. $)
    ifeq2da $p |- ( ph -> if ( ps , C , A ) = if ( ps , C , B ) ) $=
      wph wps wps cC cA cif wps cC cB cif wceq wps wps cC cA cif wps cC cB cif
      wceq wph wps wps cC cA cif cC wps cC cB cif wps cC cA iftrue wps cC cB
      iftrue eqtr4d adantl wph wps wn wa wps cA cB cC ifeq2da.1 ifeq2d
      pm2.61dan $.
      $( [2-Sep-2009] $)
  $}

  ${
    ifclda.1 $e |- ( ( ph /\ ps ) -> A e. C ) $.
    ifclda.2 $e |- ( ( ph /\ -. ps ) -> B e. C ) $.
    $( Conditional closure. $)
    ifclda $p |- ( ph -> if ( ps , A , B ) e. C ) $=
      wph wps wps cA cB cif cC wcel wph wps wa wps cA cB cif cA cC wps wps cA
      cB cif cA wceq wph wps cA cB iftrue adantl ifclda.1 eqeltrd wph wps wn wa
      wps cA cB cif cB cC wps wn wps cA cB cif cB wceq wph wps cA cB iffalse
      adantl ifclda.2 eqeltrd pm2.61dan $.
      $( [2-Sep-2009] $)
  $}

  ${
    ifbieq12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    ifbieq12d.2 $e |- ( ph -> A = C ) $.
    ifbieq12d.3 $e |- ( ph -> B = D ) $.
    $( Conditional equality. $)
    ifbieq12d $p |- ( ph -> if ( ps , A , B ) = if ( ch , C , D ) ) $=
      wph wps cA cB cif wch cA cB cif wch cC cB cif wch cC cD cif wph wps wch
      cA cB ifbieq12d.1 ifbid wph wch cA cC cB ifbieq12d.2 ifeq1d wph wch cB cD
      cC ifbieq12d.3 ifeq2d 3eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d B x y $. $d A x y $. $d ph y $. $d ps x y $.
    morex.1 $e |- B e. _V $.
    morex.2 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Derive membership from uniqueness. $)
    morex $p |- ( ( E. x e. A ph /\ E* x ph ) -> ( ps -> B e. A ) ) $=
      vx cv cA wcel wph wa vx wex wph wph vx vy cv wsbc wa vx cv vy cv wceq wi
      vy wal vx wal wps cB cA wcel wi wph vx cA wrex wph vx wmo vx cv cA wcel
      wph wa vx wex wph wph vx vy cv wsbc wa vx cv vy cv wceq wi vy wal vx wal
      wa vx cv cA wcel wph wa wph wph vx vy cv wsbc wa vx cv vy cv wceq wi vy
      wal wa vx wex wps cB cA wcel wi vx cv cA wcel wph wa wph wph vx vy cv
      wsbc wa vx cv vy cv wceq wi vy wal vx 19.29r vx cv cA wcel wph wa wph wph
      vx vy cv wsbc wa vx cv vy cv wceq wi vy wal wa wps cB cA wcel wi vx vx cv
      cA wcel wph wa wph wps wa vx cv cB wceq wi wps cB cA wcel wi wph wph vx
      vy cv wsbc wa vx cv vy cv wceq wi vy wal vx cv cA wcel wph wa wph wps wa
      vx cv cB wceq wi wps cB cA wcel wi vx cv cA wcel wph wa wps wph wps wa vx
      cv cB wceq wi cB cA wcel vx cv cA wcel wph wps wph wps wa vx cv cB wceq
      wi cB cA wcel wi wph wps wa wph wps wa vx cv cB wceq wi vx cv cA wcel cB
      cA wcel wph wps wa wph wps wa vx cv cB wceq wi vx cv cB wceq vx cv cA
      wcel cB cA wcel wi wph wps wa vx cv cB wceq pm2.27 vx cv cB wceq vx cv cA
      wcel cB cA wcel vx cv cB cA eleq1 biimpd syl6 com3r expdimp com23 imp wph
      wph vx vy cv wsbc wa vx cv vy cv wceq wi wph wps wa vx cv cB wceq wi vy
      cB morex.1 vy cv cB wceq wph wph vx vy cv wsbc wa wph wps wa vx cv vy cv
      wceq vx cv cB wceq vy cv cB wceq wph vx vy cv wsbc wps wph vy cv cB wceq
      wph vx vy cv wsbc wph vx cB wsbc wps wph vx vy cv cB dfsbcq wph wps vx cB
      morex.1 morex.2 sbcie syl6bb anbi2d vy cv cB vx cv eqeq2 imbi12d cla4v
      sylan2 19.23aiv syl wph vx cA df-rex wph vx vy wph vy ax-17 mo3 syl2anb
      $.
      $( [2-Sep-2009] $)
  $}

  ${
    brresi.1 $e |- B e. _V $.
    $( Restriction of a binary relation. $)
    brresi $p |- ( A ( R |` C ) B -> A R B ) $=
      cR cC cres cR cA cB cR cC resss ssbri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y v w z $. $d ph v w z $.
    opabex3.1 $e |- A e. _V $.
    opabex3.2 $e |- ( x e. A -> { y | ph } e. _V ) $.
    $( Existence of an ordered pair abstraction. $)
    opabex3 $p |- { <. x , y >. | ( x e. A /\ ph ) } e. _V $=
      vx cA vx cv csn wph vy cab cxp ciun vx cv cA wcel wph wa vx vy copab cvv
      vz vx cA vx cv csn wph vy cab cxp ciun vx cv cA wcel wph wa vx vy copab
      vx cv cA wcel vz cv vx cv csn wph vy cab cxp wcel wa vx wex vz cv vx cv
      vy cv cop wceq vx cv cA wcel wph wa wa vy wex vx wex vz cv vx cA vx cv
      csn wph vy cab cxp ciun wcel vz cv vx cv cA wcel wph wa vx vy copab wcel
      vx cv cA wcel vz cv vx cv csn wph vy cab cxp wcel wa vz cv vx cv vy cv
      cop wceq vx cv cA wcel wph wa wa vy wex vx vx cv cA wcel vz cv vx cv vy
      cv cop wceq wph wa wa vy wex vx cv cA wcel vz cv vx cv vy cv cop wceq wph
      wa vy wex wa vz cv vx cv vy cv cop wceq vx cv cA wcel wph wa wa vy wex vx
      cv cA wcel vz cv vx cv csn wph vy cab cxp wcel wa vx cv cA wcel vz cv vx
      cv vy cv cop wceq wph wa vy 19.42v vz cv vx cv vy cv cop wceq vx cv cA
      wcel wph wa wa vx cv cA wcel vz cv vx cv vy cv cop wceq wph wa wa vy vz
      cv vx cv vy cv cop wceq vx cv cA wcel wph an12 exbii vz cv vx cv csn wph
      vy cab cxp wcel vz cv vx cv vy cv cop wceq wph wa vy wex vx cv cA wcel vz
      cv vx cv csn wph vy cab cxp wcel vz cv vv cv vw cv cop wceq vv cv vx cv
      csn wcel vw cv wph vy cab wcel wa wa vw wex vv wex vz cv vx cv vw cv cop
      wceq vw cv wph vy cab wcel wa vw wex vz cv vx cv vy cv cop wceq wph wa vy
      wex vv vw vz cv vx cv csn wph vy cab elxp vz cv vv cv vw cv cop wceq vv
      cv vx cv csn wcel vw cv wph vy cab wcel wa wa vw wex vv wex vz cv vv cv
      vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy cab wcel wa wa vv wex vw
      wex vz cv vx cv vw cv cop wceq vw cv wph vy cab wcel wa vw wex vz cv vv
      cv vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy cab wcel wa wa vv vw
      excom vz cv vv cv vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy cab
      wcel wa wa vv wex vz cv vx cv vw cv cop wceq vw cv wph vy cab wcel wa vw
      vz cv vv cv vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy cab wcel wa
      wa vv wex vv cv vx cv wceq vz cv vv cv vw cv cop wceq vw cv wph vy cab
      wcel wa wa vv wex vz cv vx cv vw cv cop wceq vw cv wph vy cab wcel wa vz
      cv vv cv vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy cab wcel wa wa
      vv cv vx cv wceq vz cv vv cv vw cv cop wceq vw cv wph vy cab wcel wa wa
      vv vz cv vv cv vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy cab wcel
      wa wa vv cv vx cv csn wcel vz cv vv cv vw cv cop wceq vw cv wph vy cab
      wcel wa wa vv cv vx cv wceq vz cv vv cv vw cv cop wceq vw cv wph vy cab
      wcel wa wa vz cv vv cv vw cv cop wceq vv cv vx cv csn wcel vw cv wph vy
      cab wcel an12 vv cv vx cv csn wcel vv cv vx cv wceq vz cv vv cv vw cv cop
      wceq vw cv wph vy cab wcel wa vv vx cv elsn anbi1i bitri exbii vz cv vv
      cv vw cv cop wceq vw cv wph vy cab wcel wa vz cv vx cv vw cv cop wceq vw
      cv wph vy cab wcel wa vv vx cv vx visset vv cv vx cv wceq vz cv vv cv vw
      cv cop wceq vz cv vx cv vw cv cop wceq vw cv wph vy cab wcel vv cv vx cv
      wceq vv cv vw cv cop vx cv vw cv cop vz cv vv cv vx cv vw cv opeq1 eqeq2d
      anbi1d ceqsexv bitri exbii bitri vz cv vx cv vw cv cop wceq vw cv wph vy
      cab wcel wa vz cv vx cv vy cv cop wceq wph wa vw vy vz cv vx cv vw cv cop
      wceq vw cv wph vy cab wcel vy vz cv vx cv vw cv cop wceq vy ax-17 wph vy
      vw hbab1 hban vz cv vx cv vy cv cop wceq wph wa vw ax-17 vw cv vy cv wceq
      vz cv vx cv vw cv cop wceq vz cv vx cv vy cv cop wceq vw cv wph vy cab
      wcel wph vw cv vy cv wceq vx cv vw cv cop vx cv vy cv cop vz cv vw cv vy
      cv vx cv opeq2 eqeq2d vw cv vy cv wceq wph wph vy vw cv wsbc vw cv wph vy
      cab wcel wph wph vy vw cv wsbc wb vy cv vw cv wph vy vw cv sbceq1a eqcoms
      wph vw vy df-clab syl6rbbr anbi12d cbvex 3bitri anbi2i 3bitr4ri exbii vz
      cv vx cA vx cv csn wph vy cab cxp ciun wcel vz cv vx cv csn wph vy cab
      cxp wcel vx cA wrex vx cv cA wcel vz cv vx cv csn wph vy cab cxp wcel wa
      vx wex vx vz cv cA vx cv csn wph vy cab cxp eliun vz cv vx cv csn wph vy
      cab cxp wcel vx cA df-rex bitri vx cv cA wcel wph wa vx vy vz cv elopab
      3bitr4i eqriv cA cvv wcel vx cv csn wph vy cab cxp cvv wcel vx cA wral vx
      cA vx cv csn wph vy cab cxp ciun cvv wcel opabex3.1 vx cv csn wph vy cab
      cxp cvv wcel vx cA vx cv csn cvv wcel wph vy cab cvv wcel vx cv csn wph
      vy cab cxp cvv wcel vx cv cA wcel vx cv csn wph vy cab cvv cvv xpexg vx
      cv snex opabex3.2 sylancr rgen vx cA vx cv csn wph vy cab cxp cvv cvv
      iunexg mp2an eqeltrri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C x y z $. $d D x y z $.
    $( Restriction of an operator abstraction. $)
    resoprab2 $p |- ( ( C C_ A /\ D C_ B ) -> ( { <. <. x , y >. , z >. |
                  ( ( x e. A /\ y e. B ) /\ ph ) } |` ( C X. D ) ) =
              { <. <. x , y >. , z >. | ( ( x e. C /\ y e. D ) /\ ph ) } ) $=
      cC cA wss cD cB wss wa vx cv cC wcel vy cv cD wcel wa vx cv cA wcel vy cv
      cB wcel wa wph wa wa vx vy vz copab2 vx cv cC wcel vy cv cD wcel wa wph
      wa vx vy vz copab2 vx cv cA wcel vy cv cB wcel wa wph wa vx vy vz copab2
      cC cD cxp cres cC cA wss cD cB wss wa vx cv cC wcel vy cv cD wcel wa vx
      cv cA wcel vy cv cB wcel wa wph wa wa vx cv cC wcel vy cv cD wcel wa wph
      wa vx vy vz cC cA wss cD cB wss wa vx cv cC wcel vy cv cD wcel wa vx cv
      cA wcel vy cv cB wcel wa wa wph wa vx cv cC wcel vy cv cD wcel wa wph wa
      vx cv cC wcel vy cv cD wcel wa vx cv cA wcel vy cv cB wcel wa wph wa wa
      cC cA wss cD cB wss wa vx cv cC wcel vy cv cD wcel wa vx cv cA wcel vy cv
      cB wcel wa wa vx cv cC wcel vy cv cD wcel wa wph cC cA wss cD cB wss wa
      vx cv cC wcel vx cv cA wcel wa vy cv cD wcel vy cv cB wcel wa wa vx cv cC
      wcel vy cv cD wcel wa vx cv cC wcel vy cv cD wcel wa vx cv cA wcel vy cv
      cB wcel wa wa cC cA wss vx cv cC wcel vx cv cA wcel wa vx cv cC wcel cD
      cB wss vy cv cD wcel vy cv cB wcel wa vy cv cD wcel cC cA wss vx cv cC
      wcel vx cv cC wcel vx cv cA wcel wa cC cA wss vx cv cC wcel vx cv cA wcel
      wi vx cv cC wcel vx cv cC wcel vx cv cA wcel wa wb cC cA vx cv ssel vx cv
      cC wcel vx cv cA wcel pm4.71 sylib bicomd cD cB wss vy cv cD wcel vy cv
      cD wcel vy cv cB wcel wa cD cB wss vy cv cD wcel vy cv cB wcel wi vy cv
      cD wcel vy cv cD wcel vy cv cB wcel wa wb cD cB vy cv ssel vy cv cD wcel
      vy cv cB wcel pm4.71 sylib bicomd bi2anan9 vx cv cC wcel vy cv cD wcel vx
      cv cA wcel vy cv cB wcel an4 syl5bb anbi1d vx cv cC wcel vy cv cD wcel wa
      vx cv cA wcel vy cv cB wcel wa wph anass syl5bbr oprabbidv vx cv cA wcel
      vy cv cB wcel wa wph wa vx vy vz cC cD resoprab syl5eq $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d C x y z $. $d B y z $. $d H x y z $. $d A x y z $.
    $d B z $. $d F z $. $d G z $.
    fnopabco.1 $e |- ( x e. A -> B e. C ) $.
    fnopabco.2 $e |- F = { <. x , y >. | ( x e. A /\ y = B ) } $.
    fnopabco.3 $e |- G = { <. x , y >. | ( x e. A /\ y = ( H ` B ) ) } $.
    $( Composition of a function with a function abstraction. $)
    fnopabco $p |- ( H Fn C -> G = ( H o. F ) ) $=
      cH cC wfn cG cH cF ccom wceq cA cA wceq vz cv cG cfv vz cv cH cF ccom cfv
      wceq vz cA wral wa cH cC wfn cA cA wceq vz cv cG cfv vz cv cH cF ccom cfv
      wceq vz cA wral cH cC wfn cA eqidd cH cC wfn vz cv cG cfv vz cv cH cF
      ccom cfv wceq vz cA cH cC wfn vz cv cA wcel wa vz cv cF cfv cH cfv vx vz
      cv cB csb cH cfv vz cv cH cF ccom cfv vz cv cG cfv cH cC wfn vz cv cA
      wcel wa vz cv cF cfv vx vz cv cB csb cH vz cv cA wcel vz cv cF cfv vx vz
      cv cB csb wceq cH cC wfn vz cv cA wcel vx vz cv cB csb cC wcel vz cv cF
      cfv vx vz cv cB csb wceq vz cv cA wcel cB cC wcel vx vz cv wsbc vx vz cv
      cB csb cC wcel cB cC wcel vx vz cv cA fnopabco.1 sbcth2 vz cv cvv wcel cB
      cC wcel vx vz cv wsbc vx vz cv cB csb cC wcel wb vz visset vx vz cv cB cC
      cvv sbcel1g ax-mp sylib vx vy vy vz cv cB vx vz cv cB csb cA cC cF vy cv
      vz cv wcel vx ax-17 vx vy vz cv cB vz visset vy cv vz cv wcel vx ax-17
      hbcsb1 vx vz cv cB csbeq1a fnopabco.2 fvopab4gf mpdan adantl fveq2d cH
      wfun cF wfun vz cv cF cdm wcel vz cv cH cF ccom cfv vz cv cF cfv cH cfv
      wceq cH cC wfn vz cv cA wcel wa vz cv cH cF fvco cH cC wfn cH wfun vz cv
      cA wcel cC cH fnfun adantr cF wfun cH cC wfn vz cv cA wcel wa cA cC cF wf
      cF wfun vx vy cA cC cB cF fnopabco.2 fnopabco.1 fopab cA cC cF ffun ax-mp
      a1i vz cv cA wcel vz cv cF cdm wcel cH cC wfn vz cv cF cdm wcel vz cv cA
      wcel cF cdm cA vz cv cA cC cF vx vy cA cC cB cF fnopabco.2 fnopabco.1
      fopab fdmi eleq2i biimpri adantl syl3anc vz cv cA wcel vz cv cG cfv vx vz
      cv cB csb cH cfv wceq cH cC wfn vz cv cA wcel vx vz cv cB csb cH cfv cvv
      wcel vz cv cG cfv vx vz cv cB csb cH cfv wceq vx vz cv cB csb cH fvex vx
      vy vy vz cv cB cH cfv vx vz cv cB csb cH cfv cA cvv cG vy cv vz cv wcel
      vx ax-17 vx vy vx vz cv cB csb cH vy cv cH wcel vx ax-17 vx vy vz cv cB
      vz visset vy cv vz cv wcel vx ax-17 hbcsb1 hbfv vx cv vz cv wceq cB vx vz
      cv cB csb cH vx vz cv cB csbeq1a fveq2d fnopabco.3 fvopab4gf mpan2 adantl
      3eqtr4rd r19.21aiva jca cG cA wfn cH cF ccom cA wfn cG cH cF ccom wceq cA
      cA wceq vz cv cG cfv vz cv cH cF ccom cfv wceq vz cA wral wa wb cH cC wfn
      vz cA cA cG cH cF ccom eqfnfv vx vy cA cB cH cfv cG cB cH fvex fnopabco.3
      fnopab2 cH cC wfn cF cA wfn cF crn cC wss cH cF ccom cA wfn cA cC cF wf
      cF cA wfn vx vy cA cC cB cF fnopabco.2 fnopabco.1 fopab cA cC cF ffn
      ax-mp cA cC cF wf cF crn cC wss vx vy cA cC cB cF fnopabco.2 fnopabco.1
      fopab cA cC cF frn ax-mp cC cA cH cF fnco mp3an23 sylancr mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d ph x y z $.
    oprabexd.1 $e |- ( ph -> A e. _V ) $.
    oprabexd.2 $e |- ( ph -> B e. _V ) $.
    oprabexd.3 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> E* z ps ) $.
    oprabexd.4 $e |- ( ph -> F = { <. <. x , y >. , z >. |
                                        ( ( x e. A /\ y e. B ) /\ ps ) } ) $.
    $( Existence of an operator abstraction. $)
    oprabexd $p |- ( ph -> F e. _V ) $=
      wph cF vx cv cA wcel vy cv cB wcel wa wps wa vx vy vz copab2 cvv
      oprabexd.4 vx cv cA wcel vy cv cB wcel wa wps wa vx vy vz copab2 wfun vx
      cv cA wcel vy cv cB wcel wa wps wa vx vy vz copab2 cdm cvv wcel vx cv cA
      wcel vy cv cB wcel wa wps wa vx vy vz copab2 cvv wcel wph cvv vx cv cA
      wcel vy cv cB wcel wa wps wa vx vy vz copab2 funex wph vx cv cA wcel vy
      cv cB wcel wa wps wa vz wmo vy wal vx wal vx cv cA wcel vy cv cB wcel wa
      wps wa vx vy vz copab2 wfun wph vx cv cA wcel vy cv cB wcel wa wps wa vz
      wmo vx vy wph vx cv cA wcel vy cv cB wcel wa wps vz wmo wi vx cv cA wcel
      vy cv cB wcel wa wps wa vz wmo wph vx cv cA wcel vy cv cB wcel wa wps vz
      wmo oprabexd.3 ex vx cv cA wcel vy cv cB wcel wa wps vz moanimv sylibr
      19.21aivv vx cv cA wcel vy cv cB wcel wa wps wa vx vy vz funoprabg syl vx
      cv cA wcel vy cv cB wcel wa wps wa vx vy vz copab2 cdm cA cB cxp wss cA
      cB cxp cvv wcel vx cv cA wcel vy cv cB wcel wa wps wa vx vy vz copab2 cdm
      cvv wcel wph vx cv cA wcel vy cv cB wcel wa wps wa vx vy vz copab2 cdm cA
      cB cxp cvv ssexg wps vx vy vz cA cB dmoprabss cA cvv wcel cB cvv wcel cA
      cB cxp cvv wcel wph cA cB cvv cvv xpexg oprabexd.1 oprabexd.2 sylanc
      sylancr sylanc eqeltrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Composition with the converse. $)
    cnvcan $p |- ( Fun G -> ( G o. `' G ) = ( _I |` ran G ) ) $=
      cG wfun cG cG ccnv ccom cid wss cG cG ccnv ccom cid cG crn cres wceq cG
      wfun cG wrel cG cG ccnv ccom cid wss cG df-fun pm3.27bi cG wfun cG cG
      ccnv ccom cid cG cG ccnv ccom cdm cres wceq cG cG ccnv ccom cid cG crn
      cres wceq cG cG ccnv ccom cid wss cG wfun cid cG cG ccnv ccom cdm cres
      cid cG crn cres cG cG ccnv ccom cG wfun cG cG ccnv ccom cdm cG crn wceq
      cid cG cG ccnv ccom cdm cres cid cG crn cres wceq cG cG ccnv ccom cdm cG
      crn wceq cG wfun cG cG ccnv ccom cdm cG ccnv cdm cG crn cG cdm cG ccnv
      crn wceq cG cG ccnv ccom cdm cG ccnv cdm wceq cG dfdm4 cG cG ccnv dmcoeq
      ax-mp cG df-rn eqtr4i a1i cG cG ccnv ccom cdm cG crn cid reseq2 syl
      eqeq2d cG cG ccnv ccom iss syl5bb mpbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Composition with a function and then with the converse. $)
    cocnv $p |- ( ( Fun F /\ Fun G ) ->
                                ( ( F o. G ) o. `' G ) = ( F |` ran G ) ) $=
      cF wfun cG wfun wa cF cG cG ccnv ccom ccom cF cG crn cres cF cG ccom cG
      ccnv ccom cF wfun cG wfun wa cF cG cG ccnv ccom ccom cF cid cG crn cres
      ccom cF cG crn cres cF wfun cG wfun wa cG cG ccnv ccom cid cG crn cres cF
      cG wfun cG cG ccnv ccom cid cG crn cres wceq cF wfun cG cnvcan adantl
      coeq2d cF wfun cG wfun wa cF cid ccom cG crn cres cF cG crn cres cF cid
      cG crn cres ccom cF wfun cF cid ccom cG crn cres cF cG crn cres wceq cG
      wfun cF wfun cF wrel cF cid ccom cF wceq cF cid ccom cG crn cres cF cG
      crn cres wceq cF funrel cF coi1 cF cid ccom cF cG crn reseq1 3syl adantr
      cF cid cG crn resco syl5eqr eqtrd cF cG cG ccnv coass syl5eq $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Cancel a composition by a bijection by preapplying the converse. $)
    f1ocan1fv $p |- ( ( Fun F /\ G : A -1-1-onto-> B /\ X e. B ) ->
                              ( ( F o. G ) ` ( `' G ` X ) ) = ( F ` X ) ) $=
      cF wfun cA cB cG wf1o cX cB wcel w3a cX cF cG ccom cG ccnv ccom cfv cX cF
      cG crn cres cfv cX cG ccnv cfv cF cG ccom cfv cX cF cfv cF wfun cA cB cG
      wf1o cX cF cG ccom cG ccnv ccom cfv cX cF cG crn cres cfv wceq cX cB wcel
      cF wfun cG wfun cX cF cG ccom cG ccnv ccom cfv cX cF cG crn cres cfv wceq
      cA cB cG wf1o cF wfun cG wfun wa cX cF cG ccom cG ccnv ccom cF cG crn
      cres cF cG cocnv fveq1d cA cB cG f1ofun sylan2 3adant3 cF cG ccom wfun cG
      ccnv wfun cX cG ccnv cdm wcel cX cF cG ccom cG ccnv ccom cfv cX cG ccnv
      cfv cF cG ccom cfv wceq cF wfun cA cB cG wf1o cX cB wcel w3a cX cF cG
      ccom cG ccnv fvco cF wfun cA cB cG wf1o cF cG ccom wfun cX cB wcel cF
      wfun cG wfun cF cG ccom wfun cA cB cG wf1o cF cG funco cA cB cG f1ofun
      sylan2 3adant3 cA cB cG wf1o cF wfun cG ccnv wfun cX cB wcel cA cB cG
      wf1o cB cA cG ccnv wf1o cG ccnv wfun cA cB cG f1ocnv cB cA cG ccnv f1ofun
      syl 3ad2ant2 cA cB cG wf1o cX cB wcel cX cG ccnv cdm wcel cF wfun cB cA
      cG ccnv wf cX cB wcel cX cG ccnv cdm wcel cA cB cG wf1o cB cA cG ccnv wf
      cX cG ccnv cdm wcel cX cB wcel cB cA cG ccnv wf cG ccnv cdm cB cX cB cA
      cG ccnv fdm eleq2d biimpar cA cB cG wf1o cB cA cG ccnv wf1o cB cA cG ccnv
      wf cA cB cG f1ocnv cB cA cG ccnv f1of syl sylan 3adant1 syl3anc cA cB cG
      wf1o cX cB wcel cX cF cG crn cres cfv cX cF cfv wceq cF wfun cA cB cG
      wf1o cX cB wcel wa cX cG crn wcel cX cF cG crn cres cfv cX cF cfv wceq cA
      cB cG wf1o cX cB wcel wa cX cG ccnv cdm cG crn cB cA cG ccnv wf cX cB
      wcel cX cG ccnv cdm wcel cA cB cG wf1o cB cA cG ccnv wf cX cG ccnv cdm
      wcel cX cB wcel cB cA cG ccnv wf cG ccnv cdm cB cX cB cA cG ccnv fdm
      eleq2d biimpar cA cB cG wf1o cB cA cG ccnv wf1o cB cA cG ccnv wf cA cB cG
      f1ocnv cB cA cG ccnv f1of syl sylan cG df-rn syl6eleqr cX cG crn cF fvres
      syl 3adant1 3eqtr3d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Cancel a composition by the converse of a  bijection by preapplying
       the bijection. $)
    f1ocan2fv $p |- ( ( Fun F /\ G : A -1-1-onto-> B /\ X e. A ) ->
                              ( ( F o. `' G ) ` ( G ` X ) ) = ( F ` X ) ) $=
      cF wfun cA cB cG wf1o cX cA wcel w3a cX cG ccnv ccnv cfv cF cG ccnv ccom
      cfv cX cG cfv cF cG ccnv ccom cfv cX cF cfv cF wfun cA cB cG wf1o cX cA
      wcel w3a cX cG ccnv ccnv cfv cX cG cfv cF cG ccnv ccom cF wfun cA cB cG
      wf1o cX cA wcel w3a cX cG ccnv ccnv cG cA cB cG wf1o cF wfun cG ccnv ccnv
      cG wceq cX cA wcel cA cB cG wf1o cG wfun cG wrel cG ccnv ccnv cG wceq cA
      cB cG f1ofun cG funrel cG wrel cG ccnv ccnv cG wceq cG dfrel2 biimpi 3syl
      3ad2ant2 fveq1d fveq2d cF wfun cB cA cG ccnv wf1o cX cA wcel cX cG ccnv
      ccnv cfv cF cG ccnv ccom cfv cX cF cfv wceq cA cB cG wf1o cB cA cF cG
      ccnv cX f1ocan1fv cA cB cG f1ocnv syl3an2 eqtr3d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F z $. $d A z $. $d Y z $. $d X z $. $d B z $.
    $( Membership in the image of a 1-1 map. $)
    f1elima $p |- ( ( F : A -1-1-> B /\ X e. A /\ Y C_ A )
                                -> ( ( F ` X ) e. ( F " Y ) <-> X e. Y ) ) $=
      cA cB cF wf1 cX cA wcel cY cA wss w3a cX cF cfv cF cY cima wcel vz cv cF
      cfv cX cF cfv wceq vz cY wrex cX cY wcel cA cB cF wf1 cY cA wss cX cF cfv
      cF cY cima wcel vz cv cF cfv cX cF cfv wceq vz cY wrex wb cX cA wcel cF
      cA wfn cY cA wss cX cF cfv cF cY cima wcel vz cv cF cfv cX cF cfv wceq vz
      cY wrex wb cA cB cF wf1 vz cA cY cX cF cfv cF fvelimab cA cB cF wf1 cA cB
      cF wf cF cA wfn cA cB cF f1f cA cB cF ffn syl sylan 3adant2 cA cB cF wf1
      cX cA wcel cY cA wss w3a vz cv cF cfv cX cF cfv wceq vz cY wrex cX cY
      wcel cA cB cF wf1 cX cA wcel cY cA wss vz cv cF cfv cX cF cfv wceq vz cY
      wrex cX cY wcel wi cA cB cF wf1 cX cA wcel wa cY cA wss wa vz cv cF cfv
      cX cF cfv wceq cX cY wcel vz cY cA cB cF wf1 cX cA wcel wa cY cA wss vz
      cv cY wcel vz cv cF cfv cX cF cfv wceq cX cY wcel wi cA cB cF wf1 cX cA
      wcel wa vz cv cA wcel vz cv cY wcel wa vz cv cF cfv cX cF cfv wceq cX cY
      wcel wi cY cA wss vz cv cY wcel wa cA cB cF wf1 cX cA wcel wa vz cv cA
      wcel vz cv cY wcel vz cv cF cfv cX cF cfv wceq cX cY wcel wi cA cB cF wf1
      cX cA wcel wa vz cv cA wcel wa vz cv cF cfv cX cF cfv wceq vz cv cX wceq
      vz cv cY wcel cX cY wcel cA cB cF wf1 cX cA wcel vz cv cA wcel vz cv cF
      cfv cX cF cfv wceq vz cv cX wceq wi cA cB cF wf1 cX cA wcel vz cv cA wcel
      wa wa vz cv cF cfv cX cF cfv wceq vz cv cX wceq cA cB cF wf1 vz cv cA
      wcel cX cA wcel vz cv cF cfv cX cF cfv wceq vz cv cX wceq wb cA cB vz cv
      cX cF f1fveq ancom2s biimpd anassrs vz cv cX wceq vz cv cY wcel cX cY
      wcel vz cv cX cY eleq1 biimpcd sylan9 anasss cY cA wss vz cv cY wcel vz
      cv cA wcel cY cA vz cv ssel impac sylan2 anassrs r19.23adva 3impa cX cY
      wcel cX cF cfv cX cF cfv wceq vz cv cF cfv cX cF cfv wceq vz cY wrex cX
      cF cfv eqid vz cv cF cfv cX cF cfv wceq cX cF cfv cX cF cfv wceq vz cX cY
      vz cv cX wceq vz cv cF cfv cX cF cfv cX cF cfv vz cv cX cF fveq2 eqeq1d
      rcla4ev mpan2 impbid1 bitrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x $. $d B x $. $d F x $. $d G x $.
    $( Derive equality of functions from equality of their values. $)
    eqfnfv3 $p |- ( ( F Fn A /\ G Fn B ) -> ( F = G <-> ( B C_ A /\ A. x e. A
                              ( x e. B /\ ( F ` x ) = ( G ` x ) ) ) ) ) $=
      cF cA wfn cG cB wfn wa cF cG wceq cA cB wceq vx cv cF cfv vx cv cG cfv
      wceq vx cA wral wa cB cA wss vx cv cB wcel vx cv cF cfv vx cv cG cfv wceq
      wa vx cA wral wa vx cA cB cF cG eqfnfv cA cB wceq vx cv cF cfv vx cv cG
      cfv wceq vx cA wral wa cB cA wss cA cB wss wa vx cv cF cfv vx cv cG cfv
      wceq vx cA wral wa cB cA wss cA cB wss vx cv cF cfv vx cv cG cfv wceq vx
      cA wral wa wa cB cA wss vx cv cB wcel vx cv cF cfv vx cv cG cfv wceq wa
      vx cA wral wa cA cB wceq cB cA wss cA cB wss wa vx cv cF cfv vx cv cG cfv
      wceq vx cA wral cA cB wceq cA cB wss cB cA wss wa cB cA wss cA cB wss wa
      cA cB eqss cA cB wss cB cA wss ancom bitri anbi1i cB cA wss cA cB wss vx
      cv cF cfv vx cv cG cfv wceq vx cA wral anass cA cB wss vx cv cF cfv vx cv
      cG cfv wceq vx cA wral wa vx cv cB wcel vx cv cF cfv vx cv cG cfv wceq wa
      vx cA wral cB cA wss cA cB wss vx cv cF cfv vx cv cG cfv wceq vx cA wral
      wa vx cv cB wcel vx cA wral vx cv cF cfv vx cv cG cfv wceq vx cA wral wa
      vx cv cB wcel vx cv cF cfv vx cv cG cfv wceq wa vx cA wral cA cB wss vx
      cv cB wcel vx cA wral vx cv cF cfv vx cv cG cfv wceq vx cA wral vx cA cB
      dfss3 anbi1i vx cv cB wcel vx cv cF cfv vx cv cG cfv wceq vx cA r19.26
      bitr4i anbi2i 3bitri syl6bb $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d x f $. $d A f $. $d B f $. $d C f $.
    $( Intersection of Cartesian products over the same base set. $)
    inixp $p |- ( X_ x e. A B i^i X_ x e. A C ) = X_ x e. A ( B i^i C ) $=
      vf vx cA cB cixp vx cA cC cixp vx cA cB cC cin cixp vf cv cA wfn vx cv vf
      cv cfv cB wcel vx cA wral wa vf cv cA wfn vx cv vf cv cfv cC wcel vx cA
      wral wa wa vf cv cA wfn vx cv vf cv cfv cB cC cin wcel vx cA wral wa vf
      cv vx cA cB cixp wcel vf cv vx cA cC cixp wcel wa vf cv vx cA cB cC cin
      cixp wcel vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vf cv cA wfn
      vx cv vf cv cfv cC wcel vx cA wral wa wa vf cv cA wfn vf cv cA wfn wa vx
      cv vf cv cfv cB wcel vx cA wral vx cv vf cv cfv cC wcel vx cA wral wa wa
      vf cv cA wfn vx cv vf cv cfv cB cC cin wcel vx cA wral wa vf cv cA wfn vx
      cv vf cv cfv cB wcel vx cA wral vf cv cA wfn vx cv vf cv cfv cC wcel vx
      cA wral an4 vf cv cA wfn vf cv cA wfn wa vf cv cA wfn vx cv vf cv cfv cB
      wcel vx cA wral vx cv vf cv cfv cC wcel vx cA wral wa vx cv vf cv cfv cB
      cC cin wcel vx cA wral vf cv cA wfn anidm vx cv vf cv cfv cB wcel vx cA
      wral vx cv vf cv cfv cC wcel vx cA wral wa vx cv vf cv cfv cB wcel vx cv
      vf cv cfv cC wcel wa vx cA wral vx cv vf cv cfv cB cC cin wcel vx cA wral
      vx cv vf cv cfv cB wcel vx cv vf cv cfv cC wcel vx cA r19.26 vx cv vf cv
      cfv cB wcel vx cv vf cv cfv cC wcel wa vx cv vf cv cfv cB cC cin wcel vx
      cA vx cv vf cv cfv cB cC cin wcel vx cv vf cv cfv cB wcel vx cv vf cv cfv
      cC wcel wa vx cv vf cv cfv cB cC elin bicomi ralbii bitr3i anbi12i bitri
      vf cv vx cA cB cixp wcel vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral
      wa vf cv vx cA cC cixp wcel vf cv cA wfn vx cv vf cv cfv cC wcel vx cA
      wral wa vx cA cB vf cv vf visset elixp vx cA cC vf cv vf visset elixp
      anbi12i vx cA cB cC cin vf cv vf visset elixp 3bitr4i ineqri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y f $. $d B y f $. $d C x f $.
    cbvixpv.1 $e |- ( x = y -> B = C ) $.
    $( Change bound variable in an indexed Cartesian product. $)
    cbvixpv $p |- X_ x e. A B = X_ y e. A C $=
      vf cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vf cab vf cv cA wfn vy
      cv vf cv cfv cC wcel vy cA wral wa vf cab vx cA cB cixp vy cA cC cixp vf
      cv cA wfn vx cv vf cv cfv cB wcel vx cA wral wa vf cv cA wfn vy cv vf cv
      cfv cC wcel vy cA wral wa vf vx cv vf cv cfv cB wcel vx cA wral vy cv vf
      cv cfv cC wcel vy cA wral vf cv cA wfn vx cv vf cv cfv cB wcel vy cv vf
      cv cfv cC wcel vx vy cA vx cv vy cv wceq vx cv vf cv cfv vy cv vf cv cfv
      cB cC vx cv vy cv vf cv fveq2 cbvixpv.1 eleq12d cbvralv anbi2i abbii vx
      cA cB vf df-ixp vy cA cC vf df-ixp 3eqtr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A a b c d h s t u v w x y z $. $d R a b c d h s t u v w x y z $.
    $d S a b c d h s t u v w x y z $. $d F a b c d h s t u v w x y z $.
    $d B a b c d h s t u v w x y z $. $d C a b c d h s t u v w x y z $.
    $d X a c d h s t u v w x y z $. $d P a c d h s t u v $.
    upixp.1 $e |- X = X_ b e. A ( C ` b ) $.
    upixp.2 $e |- P = { <. w , z >. | ( w e. A /\ z =
                          { <. x , y >. | ( x e. X /\ y = ( x ` w ) ) } ) } $.
    $( Universal property of the indexed Cartesian product. $)
    upixp $p |- ( ( A e. R /\ B e. S /\ A. a e. A ( F ` a ) : B --> ( C ` a ) )
       -> E! h ( h : B --> X /\ A. a e. A ( F ` a ) = ( ( P ` a ) o. h ) ) ) $=
      cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB
      cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa vh
      weu vh cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab wceq vh weu cB cS wcel cA cR wcel
      vh cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab wceq wa vu vv copab wceq vh weu cB va cv cC cfv va cv cF
      cfv wf va cA wral cB cS wcel vu cv cB wcel vv cv vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cvv wcel vh
      cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa
      vs vt copab wceq wa vu vv copab wceq vh weu vu vv cB vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab cS opabex2g vh vu cv cB wcel
      vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      wa vu vv copab eueq sylib 3ad2ant2 cA cR wcel cB cS wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv
      vh cv ccom wceq va cA wral wa vh cv vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wceq vh
      cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB
      cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa vh cv
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab wceq cA cR wcel cB cS wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv
      vh cv ccom wceq va cA wral wa vh cv vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wceq cA
      cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX
      vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vh cv
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab wceq cB cB wceq vc cv vh cv cfv vc cv vu cv
      cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cfv wceq vc cB wral wa cA cR wcel cB cS wcel cB
      va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv
      va cv cP cfv vh cv ccom wceq va cA wral wa wa cB cB wceq vc cv vh cv cfv
      vc cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab wceq wa vu vv copab cfv wceq vc cB wral cA cR wcel cB cS
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv
      cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa cB eqidd cA cR wcel
      cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf
      va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vc cv vh cv
      cfv vc cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab cfv wceq vc cB cA cR wcel cB cS
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv
      cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vc cv cB wcel wa vc
      cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa
      vs vt copab wceq wa vu vv copab cfv vs cv cA wcel vt cv vc cv vs cv cF
      cfv cfv wceq wa vs vt copab vc cv vh cv cfv cA cR wcel cB cS wcel cB va
      cv cC cfv va cv cF cfv wf va cA wral w3a vc cv cB wcel vc cv vu cv cB
      wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq wa vu vv copab cfv vs cv cA wcel vt cv vc cv vs cv cF cfv cfv wceq
      wa vs vt copab wceq cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom
      wceq va cA wral wa cA cR wcel cB cS wcel vc cv cB wcel vc cv vu cv cB
      wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq wa vu vv copab cfv vs cv cA wcel vt cv vc cv vs cv cF cfv cfv wceq
      wa vs vt copab wceq cB va cv cC cfv va cv cF cfv wf va cA wral vc cv cB
      wcel cA cR wcel vc cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cfv vs cv cA wcel vt
      cv vc cv vs cv cF cfv cfv wceq wa vs vt copab wceq vc cv cB wcel vs cv cA
      wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab cvv wcel vc cv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cfv vs cv cA wcel vt cv vc cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq cA cR wcel vu vv vc cv vs cv cA wcel vt cv vu cv
      vs cv cF cfv cfv wceq wa vs vt copab vs cv cA wcel vt cv vc cv vs cv cF
      cfv cfv wceq wa vs vt copab cB cvv vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab vu cv
      vc cv wceq vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs cv cA
      wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt vu cv vc cv wceq vt cv vu
      cv vs cv cF cfv cfv wceq vt cv vc cv vs cv cF cfv cfv wceq vs cv cA wcel
      vu cv vc cv wceq vu cv vs cv cF cfv cfv vc cv vs cv cF cfv cfv vt cv vu
      cv vc cv vs cv cF cfv fveq2 eqeq2d anbi2d opabbidv vu cv cB wcel vv cv vs
      cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab eqid fvopab4g vs vt cA vc cv vs cv cF cfv cfv cR opabex2g sylan2
      ancoms 3ad2antl1 adantlr cA cR wcel cB cS wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom
      wceq va cA wral wa wa vc cv cB wcel wa vs cv cA wcel vt cv vc cv vs cv cF
      cfv cfv wceq wa vs vt copab vc cv vh cv cfv wceq cA cA wceq vd cv vs cv
      cA wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab cfv vd cv vc cv
      vh cv cfv cfv wceq vd cA wral wa cA cR wcel cB cS wcel cB va cv cC cfv va
      cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh
      cv ccom wceq va cA wral wa wa vc cv cB wcel wa cA cA wceq vd cv vs cv cA
      wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab cfv vd cv vc cv vh
      cv cfv cfv wceq vd cA wral cA cR wcel cB cS wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom
      wceq va cA wral wa wa vc cv cB wcel wa cA eqidd cA cR wcel cB cS wcel cB
      va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv
      va cv cP cfv vh cv ccom wceq va cA wral wa wa vc cv cB wcel wa vd cv vs
      cv cA wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab cfv vd cv vc
      cv vh cv cfv cfv wceq vd cA cA cR wcel cB cS wcel cB va cv cC cfv va cv
      cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv
      ccom wceq va cA wral wa wa vc cv cB wcel wa vd cv cA wcel wa vd cv vs cv
      cA wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab cfv vc cv vd cv
      cF cfv cfv vc cv vd cv cP cfv vh cv ccom cfv vd cv vc cv vh cv cfv cfv vd
      cv cA wcel vd cv vs cv cA wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt
      copab cfv vc cv vd cv cF cfv cfv wceq cA cR wcel cB cS wcel cB va cv cC
      cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP
      cfv vh cv ccom wceq va cA wral wa wa vc cv cB wcel wa vs vt vd cv vc cv
      vs cv cF cfv cfv vc cv vd cv cF cfv cfv cA vs cv cA wcel vt cv vc cv vs
      cv cF cfv cfv wceq wa vs vt copab vs cv vd cv wceq vc cv vs cv cF cfv vd
      cv cF cfv vs cv vd cv cF fveq2 fveq1d vs cv cA wcel vt cv vc cv vs cv cF
      cfv cfv wceq wa vs vt copab eqid vc cv vd cv cF cfv fvex fvopab4 adantl
      cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB
      cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vc
      cv cB wcel wa vd cv cA wcel wa vc cv vd cv cF cfv vd cv cP cfv vh cv ccom
      cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB
      cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vd
      cv cA wcel vd cv cF cfv vd cv cP cfv vh cv ccom wceq vc cv cB wcel cB cX
      vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa vd cv cA
      wcel vd cv cF cfv vd cv cP cfv vh cv ccom wceq cA cR wcel cB cS wcel cB
      va cv cC cfv va cv cF cfv wf va cA wral w3a va cv cF cfv va cv cP cfv vh
      cv ccom wceq va cA wral vd cv cA wcel vd cv cF cfv vd cv cP cfv vh cv
      ccom wceq cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq vd cv
      cF cfv vd cv cP cfv vh cv ccom wceq va vd cv cA va cv vd cv wceq va cv cF
      cfv vd cv cF cfv va cv cP cfv vh cv ccom vd cv cP cfv vh cv ccom va cv vd
      cv cF fveq2 va cv vd cv wceq va cv cP cfv vd cv cP cfv vh cv va cv vd cv
      cP fveq2 coeq1d eqeq12d rcla4cva adantll adantll adantlr fveq1d cA cR
      wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh
      cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vc cv cB
      wcel wa vd cv cA wcel wa vc cv vd cv cP cfv vh cv ccom cfv vc cv vh cv
      cfv vd cv cP cfv cfv vc cv vh cv cfv vx cv cX wcel vy cv vd cv vx cv cfv
      wceq wa vx vy copab cfv vd cv vc cv vh cv cfv cfv vd cv cP cfv wfun vh cv
      wfun vc cv vh cv cdm wcel vc cv vd cv cP cfv vh cv ccom cfv vc cv vh cv
      cfv vd cv cP cfv cfv wceq cA cR wcel cB cS wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom
      wceq va cA wral wa wa vc cv cB wcel wa vd cv cA wcel wa vc cv vd cv cP
      cfv vh cv fvco cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va
      cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va
      cA wral wa wa vc cv cB wcel wa vd cv cA wcel wa vd cv cP cfv wfun vx cv
      cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab wfun vx cv cX wcel vy
      cv vd cv vx cv cfv wceq wa vx vy copab cX wfn vx cv cX wcel vy cv vd cv
      vx cv cfv wceq wa vx vy copab wfun vx vy cX vd cv vx cv cfv vx cv cX wcel
      vy cv vd cv vx cv cfv wceq wa vx vy copab vd cv vx cv fvex vx cv cX wcel
      vy cv vd cv vx cv cfv wceq wa vx vy copab eqid fnopab2 cX vx cv cX wcel
      vy cv vd cv vx cv cfv wceq wa vx vy copab fnfun ax-mp cA cR wcel cB cS
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv
      cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vc cv cB wcel wa vd
      cv cA wcel wa vd cv cP cfv vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx
      vy copab wceq vd cv cP cfv wfun vx cv cX wcel vy cv vd cv vx cv cfv wceq
      wa vx vy copab wfun wb vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy
      copab cvv wcel vd cv cA wcel vd cv cP cfv vx cv cX wcel vy cv vd cv vx cv
      cfv wceq wa vx vy copab wceq cA cR wcel cB cS wcel cB va cv cC cfv va cv
      cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv
      ccom wceq va cA wral wa wa vc cv cB wcel wa vd cv cA wcel vx cv cX wcel
      vy cv vd cv vx cv cfv wceq wa vx vy copab cvv wcel vd cv cP cfv vx cv cX
      wcel vy cv vd cv vx cv cfv wceq wa vx vy copab wceq vw vz vd cv vx cv cX
      wcel vy cv vw cv vx cv cfv wceq wa vx vy copab vx cv cX wcel vy cv vd cv
      vx cv cfv wceq wa vx vy copab cA cvv cP vw cv vd cv wceq vx cv cX wcel vy
      cv vw cv vx cv cfv wceq wa vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx
      vy vw cv vd cv wceq vy cv vw cv vx cv cfv wceq vy cv vd cv vx cv cfv wceq
      vx cv cX wcel vw cv vd cv wceq vw cv vx cv cfv vd cv vx cv cfv vy cv vw
      cv vd cv vx cv fveq2 eqeq2d anbi2d opabbidv upixp.2 fvopab4g ancoms cA cR
      wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a vx cv cX
      wcel vy cv vd cv vx cv cfv wceq wa vx vy copab cvv wcel cB cX vh cv wf va
      cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa vc cv cB wcel cA cR
      wcel cB cS wcel vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab
      cvv wcel cB va cv cC cfv va cv cF cfv wf va cA wral cA cR wcel cX cvv
      wcel vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab cvv wcel cA
      cR wcel vb cA vb cv cC cfv cixp cvv cX cA cR wcel vb cv cC cfv cvv wcel
      vb cA wral vb cA vb cv cC cfv cixp cvv wcel vb cv cC cfv cvv wcel vb cA
      vb cv cC cfv cvv wcel vb cv cA wcel vb cv cC fvex a1i rgen vb cA vb cv cC
      cfv cR cvv ixpexg mpan2 upixp.1 syl5eqel vx vy cX vd cv vx cv cfv cvv
      opabex2g syl 3ad2ant1 ad2antrr sylan vd cv cP cfv vx cv cX wcel vy cv vd
      cv vx cv cfv wceq wa vx vy copab funeq syl mpbiri cA cR wcel cB cS wcel
      cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF
      cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vh cv wfun vc cv cB
      wcel vd cv cA wcel cB cX vh cv wf vh cv wfun cA cR wcel cB cS wcel cB va
      cv cC cfv va cv cF cfv wf va cA wral w3a va cv cF cfv va cv cP cfv vh cv
      ccom wceq va cA wral cB cX vh cv ffun ad2antrl ad2antrr cA cR wcel cB cS
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv
      cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa vc cv cB wcel wa vc
      cv vh cv cdm wcel vd cv cA wcel cB cX vh cv wf va cv cF cfv va cv cP cfv
      vh cv ccom wceq va cA wral wa vc cv cB wcel vc cv vh cv cdm wcel cA cR
      wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh
      cv wf vc cv cB wcel vc cv vh cv cdm wcel va cv cF cfv va cv cP cfv vh cv
      ccom wceq va cA wral cB cX vh cv wf vc cv vh cv cdm wcel vc cv cB wcel cB
      cX vh cv wf vh cv cdm cB vc cv cB cX vh cv fdm eleq2d biimpar adantlr
      adantll adantr syl3anc cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom
      wceq va cA wral wa wa vc cv cB wcel wa vd cv cA wcel wa vc cv vh cv cfv
      vd cv cP cfv vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab vx
      cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab cvv wcel vd cv cA
      wcel vd cv cP cfv vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab
      wceq cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a
      cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa wa
      vc cv cB wcel wa vd cv cA wcel vx cv cX wcel vy cv vd cv vx cv cfv wceq
      wa vx vy copab cvv wcel vd cv cP cfv vx cv cX wcel vy cv vd cv vx cv cfv
      wceq wa vx vy copab wceq vw vz vd cv vx cv cX wcel vy cv vw cv vx cv cfv
      wceq wa vx vy copab vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy
      copab cA cvv cP vw cv vd cv wceq vx cv cX wcel vy cv vw cv vx cv cfv wceq
      wa vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy vw cv vd cv wceq vy
      cv vw cv vx cv cfv wceq vy cv vd cv vx cv cfv wceq vx cv cX wcel vw cv vd
      cv wceq vw cv vx cv cfv vd cv vx cv cfv vy cv vw cv vd cv vx cv fveq2
      eqeq2d anbi2d opabbidv upixp.2 fvopab4g ancoms cA cR wcel cB cS wcel cB
      va cv cC cfv va cv cF cfv wf va cA wral w3a vx cv cX wcel vy cv vd cv vx
      cv cfv wceq wa vx vy copab cvv wcel cB cX vh cv wf va cv cF cfv va cv cP
      cfv vh cv ccom wceq va cA wral wa vc cv cB wcel cA cR wcel cB cS wcel vx
      cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab cvv wcel cB va cv cC
      cfv va cv cF cfv wf va cA wral cA cR wcel cX cvv wcel vx cv cX wcel vy cv
      vd cv vx cv cfv wceq wa vx vy copab cvv wcel cA cR wcel vb cA vb cv cC
      cfv cixp cvv cX cA cR wcel vb cv cC cfv cvv wcel vb cA wral vb cA vb cv
      cC cfv cixp cvv wcel vb cv cC cfv cvv wcel vb cA vb cv cC cfv cvv wcel vb
      cv cA wcel vb cv cC fvex a1i rgen vb cA vb cv cC cfv cR cvv ixpexg mpan2
      upixp.1 syl5eqel vx vy cX vd cv vx cv cfv cvv opabex2g syl 3ad2ant1
      ad2antrr sylan fveq1d cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom
      wceq va cA wral wa wa vc cv cB wcel wa vc cv vh cv cfv vx cv cX wcel vy
      cv vd cv vx cv cfv wceq wa vx vy copab cfv vd cv vc cv vh cv cfv cfv wceq
      vd cv cA wcel cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va
      cA wral wa vc cv cB wcel vc cv vh cv cfv vx cv cX wcel vy cv vd cv vx cv
      cfv wceq wa vx vy copab cfv vd cv vc cv vh cv cfv cfv wceq cA cR wcel cB
      cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vh cv wf vc
      cv cB wcel vc cv vh cv cfv vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx
      vy copab cfv vd cv vc cv vh cv cfv cfv wceq va cv cF cfv va cv cP cfv vh
      cv ccom wceq va cA wral cB cX vh cv wf vc cv cB wcel wa vc cv vh cv cfv
      cX wcel vc cv vh cv cfv vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy
      copab cfv vd cv vc cv vh cv cfv cfv wceq cB cX vc cv vh cv ffvelrn vx vy
      vc cv vh cv cfv vd cv vx cv cfv vd cv vc cv vh cv cfv cfv cX vx cv cX
      wcel vy cv vd cv vx cv cfv wceq wa vx vy copab vd cv vx cv vc cv vh cv
      cfv fveq1 vx cv cX wcel vy cv vd cv vx cv cfv wceq wa vx vy copab eqid vd
      cv vc cv vh cv cfv fvex fvopab4 syl adantlr adantll adantr 3eqtrd 3eqtrd
      r19.21aiva jca vs cv cA wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt
      copab cA wfn vc cv vh cv cfv cA wfn vs cv cA wcel vt cv vc cv vs cv cF
      cfv cfv wceq wa vs vt copab vc cv vh cv cfv wceq cA cA wceq vd cv vs cv
      cA wcel vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab cfv vd cv vc cv
      vh cv cfv cfv wceq vd cA wral wa wb cA cR wcel cB cS wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv
      vh cv ccom wceq va cA wral wa wa vc cv cB wcel wa vd cA cA vs cv cA wcel
      vt cv vc cv vs cv cF cfv cfv wceq wa vs vt copab vc cv vh cv cfv eqfnfv
      vs vt cA vc cv vs cv cF cfv cfv vs cv cA wcel vt cv vc cv vs cv cF cfv
      cfv wceq wa vs vt copab vc cv vs cv cF cfv fvex vs cv cA wcel vt cv vc cv
      vs cv cF cfv cfv wceq wa vs vt copab eqid fnopab2 cB cX vh cv wf va cv cF
      cfv va cv cP cfv vh cv ccom wceq va cA wral wa vc cv cB wcel vc cv vh cv
      cfv cA wfn cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA
      wral w3a cB cX vh cv wf vc cv cB wcel vc cv vh cv cfv cA wfn va cv cF cfv
      va cv cP cfv vh cv ccom wceq va cA wral cB cX vh cv wf vc cv cB wcel wa
      vc cv vh cv cfv cX wcel vc cv vh cv cfv cA wfn cB cX vc cv vh cv ffvelrn
      vc cv vh cv cfv cX wcel vc cv vh cv cfv vb cA vb cv cC cfv cixp wcel vc
      cv vh cv cfv cA wfn cX vb cA vb cv cC cfv cixp vc cv vh cv cfv upixp.1
      eleq2i vc cv vh cv cfv vb cA vb cv cC cfv cixp wcel cA vb cA vb cv cC cfv
      ciun vc cv vh cv cfv wf vc cv vh cv cfv cA wfn vb cA vb cv cC cfv vc cv
      vh cv cfv ixpf cA vb cA vb cv cC cfv ciun vc cv vh cv cfv ffn syl sylbi
      syl adantlr adantll sylancr mpbird eqtr2d r19.21aiva jca vh cv cB wfn vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cB wfn vh cv vu cv cB wcel vv cv vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wceq
      cB cB wceq vc cv vh cv cfv vc cv vu cv cB wcel vv cv vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cfv wceq
      vc cB wral wa wb cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va
      cA wral w3a cB cX vh cv wf va cv cF cfv va cv cP cfv vh cv ccom wceq va
      cA wral wa wa vc cB cB vh cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab eqfnfv cB cX
      vh cv wf vh cv cB wfn cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral w3a va cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral cB
      cX vh cv ffn ad2antrl cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral w3a vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab wceq wa vu vv copab cB wfn cB cX vh cv wf va
      cv cF cfv va cv cP cfv vh cv ccom wceq va cA wral wa cA cR wcel cB cS
      wcel vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab wceq wa vu vv copab cB wfn cB va cv cC cfv va cv cF cfv wf
      va cA wral cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa
      vs vt copab cvv wcel vu cB wral vu cv cB wcel vv cv vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cB wfn cA
      cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      cvv wcel vu cB cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab cvv wcel vu cv cB wcel vs vt cA vu cv vs cv cF cfv cfv cR
      opabex2g adantr r19.21aiva vu vv cB vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv
      vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab vu cv cB wcel vv
      cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa
      vu vv copab eqid fnopab2g sylib 3ad2ant1 adantr sylanc mpbird ex vh cv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab wceq cB cX vh cv wf va cv cF cfv va cv cP cfv
      vh cv ccom wceq va cA wral wa cB cX vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wf va
      cv cF cfv va cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs
      cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom wceq va cA
      wral wa cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral
      w3a vh cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab wceq cB cX vh cv wf cB cX vu cv
      cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab wf va cv cF cfv va cv cP cfv vh cv ccom wceq va
      cA wral va cv cF cfv va cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom wceq
      va cA wral cB cX vh cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs
      cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab feq1 vh cv vu cv cB
      wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq wa vu vv copab wceq va cv cF cfv va cv cP cfv vh cv ccom wceq va cv
      cF cfv va cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom wceq va cA vh cv
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab wceq va cv cP cfv vh cv ccom va cv cP cfv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab ccom va cv cF cfv vh cv vu cv cB wcel vv cv vs
      cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab va cv cP cfv coeq2 eqeq2d ralbidv anbi12d cA cR wcel cB cS wcel cB
      va cv cC cfv va cv cF cfv wf va cA wral w3a cB cX vu cv cB wcel vv cv vs
      cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab wf va cv cF cfv va cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom
      wceq va cA wral cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va
      cA wral w3a vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab cX wcel vu cB wral cB cX vu cv cB wcel vv cv vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wf cA cR wcel
      cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab cX wcel vu cB cA cR wcel
      cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a vu cv cB wcel
      wa vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vb cA
      vb cv cC cfv cixp cX cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral w3a vu cv cB wcel wa vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab cvv wcel vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab cA wfn vb cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab cfv vb cv cC cfv wcel vb cA wral w3a vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vb cA vb cv cC cfv
      cixp wcel cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA
      wral w3a vu cv cB wcel wa vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab cvv wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab cA wfn vb cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab cfv vb cv cC cfv wcel vb cA wral cA cR wcel cB cS
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab cvv wcel vu cv cB wcel cA cR
      wcel cB cS wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab cvv wcel cB va cv cC cfv va cv cF cfv wf va cA wral vs vt cA vu cv
      vs cv cF cfv cfv cR opabex2g 3ad2ant1 adantr vs cv cA wcel vt cv vu cv vs
      cv cF cfv cfv wceq wa vs vt copab cA wfn cA cR wcel cB cS wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral w3a vu cv cB wcel wa vs vt cA vu cv vs
      cv cF cfv cfv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab vu cv vs cv cF cfv fvex vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab eqid fnopab2 a1i cA cR wcel cB cS wcel cB va cv cC
      cfv va cv cF cfv wf va cA wral w3a vu cv cB wcel wa vb cv vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab cfv vb cv cC cfv wcel vb
      cA cA cR wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a
      vu cv cB wcel wa vb cv cA wcel wa vb cv vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab cfv vu cv vb cv cF cfv cfv vb cv cC cfv vb
      cv cA wcel vb cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab cfv vu cv vb cv cF cfv cfv wceq cA cR wcel cB cS wcel cB va cv cC
      cfv va cv cF cfv wf va cA wral w3a vu cv cB wcel wa vs vt vb cv vu cv vs
      cv cF cfv cfv vu cv vb cv cF cfv cfv cA vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab vs cv vb cv wceq vu cv vs cv cF cfv vb cv
      cF cfv vs cv vb cv cF fveq2 fveq1d vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab eqid vu cv vb cv cF cfv fvex fvopab4 adantl cA cR
      wcel cB cS wcel cB va cv cC cfv va cv cF cfv wf va cA wral w3a vu cv cB
      wcel vb cv cA wcel vu cv vb cv cF cfv cfv vb cv cC cfv wcel cB va cv cC
      cfv va cv cF cfv wf va cA wral cA cR wcel vu cv cB wcel vb cv cA wcel wa
      vu cv vb cv cF cfv cfv vb cv cC cfv wcel cB cS wcel cB va cv cC cfv va cv
      cF cfv wf va cA wral vb cv cA wcel vu cv cB wcel vu cv vb cv cF cfv cfv
      vb cv cC cfv wcel cB va cv cC cfv va cv cF cfv wf va cA wral vb cv cA
      wcel vu cv cB wcel vu cv vb cv cF cfv cfv vb cv cC cfv wcel cB vb cv cC
      cfv vb cv cF cfv wf vu cv cB wcel vu cv vb cv cF cfv cfv vb cv cC cfv
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral vb cv cA wcel wa cB vb cv
      cC cfv vu cv vb cv cF cfv ffvelrn cB va cv cC cfv va cv cF cfv wf cB vb
      cv cC cfv vb cv cF cfv wf va vb cv cA va cv vb cv wceq cB va cv cC cfv va
      cv cF cfv wf cB va cv cC cfv vb cv cF cfv wf cB vb cv cC cfv vb cv cF cfv
      wf va cv vb cv wceq cB va cv cC cfv va cv cF cfv vb cv cF cfv va cv vb cv
      cF fveq2 feq1d va cv vb cv wceq va cv cC cfv vb cv cC cfv wceq cB va cv
      cC cfv vb cv cF cfv wf cB vb cv cC cfv vb cv cF cfv wf wb va cv vb cv cC
      fveq2 va cv cC cfv vb cv cC cfv cB vb cv cF cfv feq3 syl bitrd rcla4cva
      sylan anasss ancom2s 3ad2antl3 anassrs eqeltrd r19.21aiva 3jca vb cA vb
      cv cC cfv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      elixp2 sylibr upixp.1 syl6eleqr r19.21aiva vu vv cB cX vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vu cv cB wcel vv cv vs cv
      cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq
      wa vs vt copab wceq wa vu vv copab eqid fopab2 sylib cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral va cv cF cfv va cv cP cfv vu cv cB wcel
      vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      wa vu vv copab ccom wceq va cA wral cB cS wcel cA cR wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral wa vc cv cF cfv vc cv cP cfv vu cv cB wcel vv
      cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa
      vu vv copab ccom wceq vc cA wral va cv cF cfv va cv cP cfv vu cv cB wcel
      vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      wa vu vv copab ccom wceq va cA wral cA cR wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral wa vc cv cF cfv vc cv cP cfv vu cv cB wcel vv cv vs cv
      cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab ccom wceq vc cA cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA
      wral wa vc cv cA wcel wa vc cv cF cfv vc cv cP cfv vu cv cB wcel vv cv vs
      cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab ccom wceq cB cB wceq vd cv vc cv cF cfv cfv vd cv vc cv cP cfv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab ccom cfv wceq vd cB wral wa cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa cB cB wceq vd cv vc
      cv cF cfv cfv vd cv vc cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom cfv
      wceq vd cB wral cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa
      vc cv cA wcel wa cB eqidd cA cR wcel cB va cv cC cfv va cv cF cfv wf va
      cA wral wa vc cv cA wcel wa vd cv vc cv cF cfv cfv vd cv vc cv cP cfv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab ccom cfv wceq vd cB cA cR wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cv cB wcel wa vd cv vc
      cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab ccom cfv vd cv vu cv cB wcel vv
      cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa
      vu vv copab cfv vc cv cP cfv cfv vd cv vc cv cF cfv cfv vc cv cP cfv wfun
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab wfun vd cv vu cv cB wcel vv cv vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cdm
      wcel vd cv vc cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs
      cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom cfv vd cv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cfv vc cv cP cfv cfv wceq cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cv cB wcel wa vd
      cv vc cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab wceq wa vu vv copab fvco cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cv cB wcel wa vc
      cv cP cfv cX wfn vc cv cP cfv wfun cA cR wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral wa vc cv cA wcel wa vc cv cP cfv cX wfn vd cv cB wcel
      cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa
      vc cv cP cfv cX wfn vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy
      copab cX wfn vx vy cX vc cv vx cv cfv vx cv cX wcel vy cv vc cv vx cv cfv
      wceq wa vx vy copab vc cv vx cv fvex vx cv cX wcel vy cv vc cv vx cv cfv
      wceq wa vx vy copab eqid fnopab2 cA cR wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral wa vc cv cA wcel wa vc cv cP cfv vx cv cX wcel vy cv vc cv
      vx cv cfv wceq wa vx vy copab wceq vc cv cP cfv cX wfn vx cv cX wcel vy
      cv vc cv vx cv cfv wceq wa vx vy copab cX wfn wb cA cR wcel vc cv cA wcel
      vc cv cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq
      cB va cv cC cfv va cv cF cfv wf va cA wral vc cv cA wcel cA cR wcel vc cv
      cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq vc cv
      cA wcel vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cvv wcel
      vc cv cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq
      cA cR wcel vw vz vc cv vx cv cX wcel vy cv vw cv vx cv cfv wceq wa vx vy
      copab vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cA cvv cP
      vw cv vc cv wceq vx cv cX wcel vy cv vw cv vx cv cfv wceq wa vx cv cX
      wcel vy cv vc cv vx cv cfv wceq wa vx vy vw cv vc cv wceq vy cv vw cv vx
      cv cfv wceq vy cv vc cv vx cv cfv wceq vx cv cX wcel vw cv vc cv wceq vw
      cv vx cv cfv vc cv vx cv cfv vy cv vw cv vc cv vx cv fveq2 eqeq2d anbi2d
      opabbidv upixp.2 fvopab4g cA cR wcel cX cvv wcel vx cv cX wcel vy cv vc
      cv vx cv cfv wceq wa vx vy copab cvv wcel cA cR wcel vb cA vb cv cC cfv
      cixp cvv cX cA cR wcel vb cv cC cfv cvv wcel vb cA wral vb cA vb cv cC
      cfv cixp cvv wcel vb cv cC cfv cvv wcel vb cA vb cv cC cfv cvv wcel vb cv
      cA wcel vb cv cC fvex a1i rgen vb cA vb cv cC cfv cR cvv ixpexg mpan2
      upixp.1 syl5eqel vx vy cX vc cv vx cv cfv cvv opabex2g syl sylan2 ancoms
      adantlr cX vc cv cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy
      copab fneq1 syl mpbiri adantr cX vc cv cP cfv fnfun syl cA cR wcel cB va
      cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cv cB wcel wa
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab cB wfn vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wfun cA
      cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cB wfn vd cv cB wcel cA cR wcel vu cv cB wcel
      vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      wa vu vv copab cB wfn cB va cv cC cfv va cv cF cfv wf va cA wral vc cv cA
      wcel cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab cvv wcel vu cB wral vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv
      vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cB wfn cA cR
      wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab cvv
      wcel vu cB cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa
      vs vt copab cvv wcel vu cv cB wcel vs vt cA vu cv vs cv cF cfv cfv cR
      opabex2g adantr r19.21aiva vu vv cB vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv
      vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab vu cv cB wcel vv
      cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa
      vu vv copab eqid fnopab2g sylib ad2antrr adantr cB vu cv cB wcel vv cv vs
      cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab fnfun syl cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa
      vc cv cA wcel wa vd cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs
      cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cdm wcel vd cv cB
      wcel cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA
      wcel wa vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab cdm cB vd cv cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vu cv cB wcel vv cv
      vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu
      vv copab cB wfn vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab wceq wa vu vv copab cdm cB wceq cA cR wcel vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cB wfn cB va cv cC cfv va cv cF cfv wf va cA
      wral vc cv cA wcel cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab cvv wcel vu cB wral vu cv cB wcel vv cv vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab cB
      wfn cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab cvv wcel vu cB cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab cvv wcel vu cv cB wcel vs vt cA vu cv vs cv cF
      cfv cfv cR opabex2g adantr r19.21aiva vu vv cB vs cv cA wcel vt cv vu cv
      vs cv cF cfv cfv wceq wa vs vt copab vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab vu cv
      cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab eqid fnopab2g sylib ad2antrr cB vu cv cB wcel
      vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      wa vu vv copab fndm syl eleq2d biimpar syl3anc cA cR wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cv cB wcel wa vd cv vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab cfv vc cv cP cfv cfv vs cv cA wcel vt cv vd cv
      vs cv cF cfv cfv wceq wa vs vt copab vc cv cP cfv cfv vs cv cA wcel vt cv
      vd cv vs cv cF cfv cfv wceq wa vs vt copab vx cv cX wcel vy cv vc cv vx
      cv cfv wceq wa vx vy copab cfv vd cv vc cv cF cfv cfv cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cv cB wcel wa vd
      cv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa
      vs vt copab wceq wa vu vv copab cfv vs cv cA wcel vt cv vd cv vs cv cF
      cfv cfv wceq wa vs vt copab vc cv cP cfv cA cR wcel cB va cv cC cfv va cv
      cF cfv wf va cA wral wa vd cv cB wcel vd cv vu cv cB wcel vv cv vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab
      cfv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      vc cv cA wcel cA cR wcel vd cv cB wcel vd cv vu cv cB wcel vv cv vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab
      cfv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      cB va cv cC cfv va cv cF cfv wf va cA wral vd cv cB wcel cA cR wcel vd cv
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab cfv vs cv cA wcel vt cv vd cv vs cv cF cfv
      cfv wceq wa vs vt copab wceq vd cv cB wcel vs cv cA wcel vt cv vd cv vs
      cv cF cfv cfv wceq wa vs vt copab cvv wcel vd cv vu cv cB wcel vv cv vs
      cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab cfv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq cA cR wcel vu vv vd cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs
      vt copab cB cvv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab wceq wa vu vv copab vu cv vd cv wceq vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs cv cA wcel vt cv vd cv vs cv
      cF cfv cfv wceq wa vs vt vu cv vd cv wceq vt cv vu cv vs cv cF cfv cfv
      wceq vt cv vd cv vs cv cF cfv cfv wceq vs cv cA wcel vu cv vd cv wceq vu
      cv vs cv cF cfv cfv vd cv vs cv cF cfv cfv vt cv vu cv vd cv vs cv cF cfv
      fveq2 eqeq2d anbi2d opabbidv vu cv cB wcel vv cv vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab eqid fvopab4g
      vs vt cA vd cv vs cv cF cfv cfv cR opabex2g sylan2 ancoms adantlr adantlr
      fveq2d cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA
      wcel wa vd cv cB wcel wa vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab vc cv cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa
      vx vy copab cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc
      cv cA wcel wa vc cv cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx
      vy copab wceq vd cv cB wcel cA cR wcel vc cv cA wcel vc cv cP cfv vx cv
      cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq cB va cv cC cfv va
      cv cF cfv wf va cA wral vc cv cA wcel cA cR wcel vc cv cP cfv vx cv cX
      wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq vc cv cA wcel vx cv
      cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cvv wcel vc cv cP cfv
      vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq cA cR wcel
      vw vz vc cv vx cv cX wcel vy cv vw cv vx cv cfv wceq wa vx vy copab vx cv
      cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cA cvv cP vw cv vc cv
      wceq vx cv cX wcel vy cv vw cv vx cv cfv wceq wa vx cv cX wcel vy cv vc
      cv vx cv cfv wceq wa vx vy vw cv vc cv wceq vy cv vw cv vx cv cfv wceq vy
      cv vc cv vx cv cfv wceq vx cv cX wcel vw cv vc cv wceq vw cv vx cv cfv vc
      cv vx cv cfv vy cv vw cv vc cv vx cv fveq2 eqeq2d anbi2d opabbidv upixp.2
      fvopab4g cA cR wcel cX cvv wcel vx cv cX wcel vy cv vc cv vx cv cfv wceq
      wa vx vy copab cvv wcel cA cR wcel vb cA vb cv cC cfv cixp cvv cX cA cR
      wcel vb cv cC cfv cvv wcel vb cA wral vb cA vb cv cC cfv cixp cvv wcel vb
      cv cC cfv cvv wcel vb cA vb cv cC cfv cvv wcel vb cv cA wcel vb cv cC
      fvex a1i rgen vb cA vb cv cC cfv cR cvv ixpexg mpan2 upixp.1 syl5eqel vx
      vy cX vc cv vx cv cfv cvv opabex2g syl sylan2 ancoms adantlr adantr
      fveq1d cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA
      wcel wa vd cv cB wcel wa vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab
      cfv vc cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab
      cfv vd cv vc cv cF cfv cfv cA cR wcel cB va cv cC cfv va cv cF cfv wf va
      cA wral wa vd cv cB wcel vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab
      cfv vc cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab
      cfv wceq vc cv cA wcel cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA
      wral wa vd cv cB wcel wa vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab cX wcel vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa
      vs vt copab vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cfv
      vc cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab cfv
      wceq cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vd cv cB
      wcel wa vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab vb
      cA vb cv cC cfv cixp cX cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA
      wral wa vd cv cB wcel wa vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab cvv wcel vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab cA wfn vb cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv
      wceq wa vs vt copab cfv vb cv cC cfv wcel vb cA wral w3a vs cv cA wcel vt
      cv vd cv vs cv cF cfv cfv wceq wa vs vt copab vb cA vb cv cC cfv cixp
      wcel cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vd cv cB
      wcel wa vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab
      cvv wcel vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab
      cA wfn vb cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt
      copab cfv vb cv cC cfv wcel vb cA wral cA cR wcel vs cv cA wcel vt cv vd
      cv vs cv cF cfv cfv wceq wa vs vt copab cvv wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral vd cv cB wcel vs vt cA vd cv vs cv cF cfv cfv cR
      opabex2g ad2antrr vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs
      vt copab cA wfn cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa
      vd cv cB wcel wa vs vt cA vd cv vs cv cF cfv cfv vs cv cA wcel vt cv vd
      cv vs cv cF cfv cfv wceq wa vs vt copab vd cv vs cv cF cfv fvex vs cv cA
      wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab eqid fnopab2 a1i cB
      va cv cC cfv va cv cF cfv wf va cA wral vd cv cB wcel vb cv vs cv cA wcel
      vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab cfv vb cv cC cfv wcel vb
      cA wral cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral vd cv cB
      wcel wa vb cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt
      copab cfv vb cv cC cfv wcel vb cA cB va cv cC cfv va cv cF cfv wf va cA
      wral vd cv cB wcel wa vb cv cA wcel wa vb cv vs cv cA wcel vt cv vd cv vs
      cv cF cfv cfv wceq wa vs vt copab cfv vd cv vb cv cF cfv cfv vb cv cC cfv
      vb cv cA wcel vb cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs
      vt copab cfv vd cv vb cv cF cfv cfv wceq cB va cv cC cfv va cv cF cfv wf
      va cA wral vd cv cB wcel wa vs vt vb cv vd cv vs cv cF cfv cfv vd cv vb
      cv cF cfv cfv cA vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt
      copab vs cv vb cv wceq vd cv vs cv cF cfv vb cv cF cfv vs cv vb cv cF
      fveq2 fveq1d vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt
      copab eqid vd cv vb cv cF cfv fvex fvopab4 adantl cB va cv cC cfv va cv
      cF cfv wf va cA wral vb cv cA wcel vd cv cB wcel vd cv vb cv cF cfv cfv
      vb cv cC cfv wcel cB vb cv cC cfv vb cv cF cfv wf vd cv cB wcel vd cv vb
      cv cF cfv cfv vb cv cC cfv wcel cB va cv cC cfv va cv cF cfv wf va cA
      wral vb cv cA wcel wa cB vb cv cC cfv vd cv vb cv cF cfv ffvelrn cB va cv
      cC cfv va cv cF cfv wf cB vb cv cC cfv vb cv cF cfv wf va vb cv cA va cv
      vb cv wceq cB va cv cC cfv va cv cF cfv wf cB va cv cC cfv vb cv cF cfv
      wf cB vb cv cC cfv vb cv cF cfv wf va cv vb cv wceq cB va cv cC cfv va cv
      cF cfv vb cv cF cfv va cv vb cv cF fveq2 feq1d va cv vb cv wceq va cv cC
      cfv vb cv cC cfv wceq cB va cv cC cfv vb cv cF cfv wf cB vb cv cC cfv vb
      cv cF cfv wf wb va cv vb cv cC fveq2 va cv cC cfv vb cv cC cfv cB vb cv
      cF cfv feq3 syl bitrd rcla4cva sylan an1rs eqeltrd r19.21aiva adantll
      3jca vb cA vb cv cC cfv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq
      wa vs vt copab elixp2 sylibr upixp.1 syl6eleqr vx vy vs cv cA wcel vt cv
      vd cv vs cv cF cfv cfv wceq wa vs vt copab vc cv vx cv cfv vc cv vs cv cA
      wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab cfv cX vx cv cX
      wcel vy cv vc cv vx cv cfv wceq wa vx vy copab vc cv vx cv vs cv cA wcel
      vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab fveq1 vx cv cX wcel vy
      cv vc cv vx cv cfv wceq wa vx vy copab eqid vc cv vs cv cA wcel vt cv vd
      cv vs cv cF cfv cfv wceq wa vs vt copab fvex fvopab4 syl adantlr vc cv cA
      wcel vc cv vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt copab
      cfv vd cv vc cv cF cfv cfv wceq cA cR wcel cB va cv cC cfv va cv cF cfv
      wf va cA wral wa vd cv cB wcel vs vt vc cv vd cv vs cv cF cfv cfv vd cv
      vc cv cF cfv cfv cA vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs
      vt copab vs cv vc cv wceq vd cv vs cv cF cfv vc cv cF cfv vs cv vc cv cF
      fveq2 fveq1d vs cv cA wcel vt cv vd cv vs cv cF cfv cfv wceq wa vs vt
      copab eqid vd cv vc cv cF cfv fvex fvopab4 ad2antlr eqtrd 3eqtrd eqtr2d
      r19.21aiva jca vc cv cF cfv cB wfn vc cv cP cfv vu cv cB wcel vv cv vs cv
      cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv
      copab ccom cB wfn vc cv cF cfv vc cv cP cfv vu cv cB wcel vv cv vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab
      ccom wceq cB cB wceq vd cv vc cv cF cfv cfv vd cv vc cv cP cfv vu cv cB
      wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq wa vu vv copab ccom cfv wceq vd cB wral wa wb cA cR wcel cB va cv cC
      cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vd cB cB vc cv cF cfv
      vc cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab wceq wa vu vv copab ccom eqfnfv cB va cv cC cfv
      va cv cF cfv wf va cA wral vc cv cA wcel vc cv cF cfv cB wfn cA cR wcel
      cB va cv cC cfv va cv cF cfv wf va cA wral vc cv cA wcel wa cB vc cv cC
      cfv vc cv cF cfv wf vc cv cF cfv cB wfn cB va cv cC cfv va cv cF cfv wf
      cB vc cv cC cfv vc cv cF cfv wf va vc cv cA va cv vc cv wceq cB va cv cC
      cfv va cv cF cfv wf cB va cv cC cfv vc cv cF cfv wf cB vc cv cC cfv vc cv
      cF cfv wf va cv vc cv wceq cB va cv cC cfv va cv cF cfv vc cv cF cfv va
      cv vc cv cF fveq2 feq1d va cv vc cv wceq va cv cC cfv vc cv cC cfv wceq
      cB va cv cC cfv vc cv cF cfv wf cB vc cv cC cfv vc cv cF cfv wf wb va cv
      vc cv cC fveq2 va cv cC cfv vc cv cC cfv cB vc cv cF cfv feq3 syl bitrd
      rcla4cva cB vc cv cC cfv vc cv cF cfv ffn syl adantll vc cv cP cfv cX wfn
      vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs
      vt copab wceq wa vu vv copab cB wfn vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab crn cX
      wss vc cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom cB wfn cA cR wcel cB
      va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa cX cB vc cv
      cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab fnco cA cR wcel cB va cv cC cfv
      va cv cF cfv wf va cA wral wa vc cv cA wcel wa vc cv cP cfv cX wfn vx cv
      cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cX wfn vx vy cX vc cv
      vx cv cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab vc cv
      vx cv fvex vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab eqid
      fnopab2 cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA
      wcel wa vc cv cP cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy
      copab wceq vc cv cP cfv cX wfn vx cv cX wcel vy cv vc cv vx cv cfv wceq
      wa vx vy copab cX wfn wb cA cR wcel vc cv cA wcel vc cv cP cfv vx cv cX
      wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq cB va cv cC cfv va cv
      cF cfv wf va cA wral vc cv cA wcel cA cR wcel vc cv cP cfv vx cv cX wcel
      vy cv vc cv vx cv cfv wceq wa vx vy copab wceq vc cv cA wcel vx cv cX
      wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cvv wcel vc cv cP cfv vx
      cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab wceq cA cR wcel vw
      vz vc cv vx cv cX wcel vy cv vw cv vx cv cfv wceq wa vx vy copab vx cv cX
      wcel vy cv vc cv vx cv cfv wceq wa vx vy copab cA cvv cP vw cv vc cv wceq
      vx cv cX wcel vy cv vw cv vx cv cfv wceq wa vx cv cX wcel vy cv vc cv vx
      cv cfv wceq wa vx vy vw cv vc cv wceq vy cv vw cv vx cv cfv wceq vy cv vc
      cv vx cv cfv wceq vx cv cX wcel vw cv vc cv wceq vw cv vx cv cfv vc cv vx
      cv cfv vy cv vw cv vc cv vx cv fveq2 eqeq2d anbi2d opabbidv upixp.2
      fvopab4g cA cR wcel cX cvv wcel vx cv cX wcel vy cv vc cv vx cv cfv wceq
      wa vx vy copab cvv wcel cA cR wcel vb cA vb cv cC cfv cixp cvv cX cA cR
      wcel vb cv cC cfv cvv wcel vb cA wral vb cA vb cv cC cfv cixp cvv wcel vb
      cv cC cfv cvv wcel vb cA vb cv cC cfv cvv wcel vb cv cA wcel vb cv cC
      fvex a1i rgen vb cA vb cv cC cfv cR cvv ixpexg mpan2 upixp.1 syl5eqel vx
      vy cX vc cv vx cv cfv cvv opabex2g syl sylan2 ancoms adantlr cX vc cv cP
      cfv vx cv cX wcel vy cv vc cv vx cv cfv wceq wa vx vy copab fneq1 syl
      mpbiri cA cR wcel vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab wceq wa vu vv copab cB wfn cB va cv cC cfv va
      cv cF cfv wf va cA wral vc cv cA wcel cA cR wcel vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab cvv wcel vu cB wral vu cv cB wcel
      vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq
      wa vu vv copab cB wfn cA cR wcel vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab cvv wcel vu cB cA cR wcel vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab cvv wcel vu cv cB wcel vs vt cA
      vu cv vs cv cF cfv cfv cR opabex2g adantr r19.21aiva vu vv cB vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vu cv cB wcel vv cv
      vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu
      vv copab vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab wceq wa vu vv copab eqid fnopab2g sylib ad2antrr cA
      cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa cB
      cX vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa
      vs vt copab wceq wa vu vv copab wf vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab crn cX
      wss cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA
      wcel wa vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab cX
      wcel vu cB wral cB cX vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab wf cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab cX wcel vu cB cA cR wcel cB va
      cv cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vu cv cB wcel wa
      vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vb cA vb
      cv cC cfv cixp cX cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral
      wa vc cv cA wcel wa vu cv cB wcel wa vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab cvv wcel vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab cA wfn vb cv vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab cfv vb cv cC cfv wcel vb cA wral w3a vs cv
      cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vb cA vb cv cC
      cfv cixp wcel cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc
      cv cA wcel wa vu cv cB wcel wa vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab cvv wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab cA wfn vb cv vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab cfv vb cv cC cfv wcel vb cA wral cA cR wcel cB va
      cv cC cfv va cv cF cfv wf va cA wral wa vs cv cA wcel vt cv vu cv vs cv
      cF cfv cfv wceq wa vs vt copab cvv wcel vc cv cA wcel vu cv cB wcel cA cR
      wcel vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab cvv
      wcel cB va cv cC cfv va cv cF cfv wf va cA wral vs vt cA vu cv vs cv cF
      cfv cfv cR opabex2g adantr ad2antrr vs cv cA wcel vt cv vu cv vs cv cF
      cfv cfv wceq wa vs vt copab cA wfn cA cR wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral wa vc cv cA wcel wa vu cv cB wcel wa vs vt cA vu cv vs
      cv cF cfv cfv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab vu cv vs cv cF cfv fvex vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab eqid fnopab2 a1i cA cR wcel cB va cv cC cfv va cv cF
      cfv wf va cA wral wa vc cv cA wcel wa vu cv cB wcel wa vb cv vs cv cA
      wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab cfv vb cv cC cfv
      wcel vb cA cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vc cv
      cA wcel wa vu cv cB wcel wa vb cv cA wcel wa vb cv vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab cfv vu cv vb cv cF cfv cfv vb cv
      cC cfv vb cv cA wcel vb cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv
      wceq wa vs vt copab cfv vu cv vb cv cF cfv cfv wceq cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral wa vc cv cA wcel wa vu cv cB wcel wa vs
      vt vb cv vu cv vs cv cF cfv cfv vu cv vb cv cF cfv cfv cA vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vs cv vb cv wceq vu cv
      vs cv cF cfv vb cv cF cfv vs cv vb cv cF fveq2 fveq1d vs cv cA wcel vt cv
      vu cv vs cv cF cfv cfv wceq wa vs vt copab eqid vu cv vb cv cF cfv fvex
      fvopab4 adantl cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa
      vc cv cA wcel wa vu cv cB wcel vb cv cA wcel vu cv vb cv cF cfv cfv vb cv
      cC cfv wcel cA cR wcel cB va cv cC cfv va cv cF cfv wf va cA wral wa vu
      cv cB wcel vb cv cA wcel wa vu cv vb cv cF cfv cfv vb cv cC cfv wcel vc
      cv cA wcel cB va cv cC cfv va cv cF cfv wf va cA wral vu cv cB wcel vb cv
      cA wcel wa vu cv vb cv cF cfv cfv vb cv cC cfv wcel cA cR wcel cB va cv
      cC cfv va cv cF cfv wf va cA wral vu cv cB wcel vb cv cA wcel vu cv vb cv
      cF cfv cfv vb cv cC cfv wcel cB va cv cC cfv va cv cF cfv wf va cA wral
      vb cv cA wcel vu cv cB wcel vu cv vb cv cF cfv cfv vb cv cC cfv wcel cB
      vb cv cC cfv vb cv cF cfv wf vu cv cB wcel vu cv vb cv cF cfv cfv vb cv
      cC cfv wcel cB va cv cC cfv va cv cF cfv wf va cA wral vb cv cA wcel wa
      cB vb cv cC cfv vu cv vb cv cF cfv ffvelrn cB va cv cC cfv va cv cF cfv
      wf cB vb cv cC cfv vb cv cF cfv wf va vb cv cA va cv vb cv wceq cB va cv
      cC cfv va cv cF cfv wf cB va cv cC cfv vb cv cF cfv wf cB vb cv cC cfv vb
      cv cF cfv wf va cv vb cv wceq cB va cv cC cfv va cv cF cfv vb cv cF cfv
      va cv vb cv cF fveq2 feq1d va cv vb cv wceq va cv cC cfv vb cv cC cfv
      wceq cB va cv cC cfv vb cv cF cfv wf cB vb cv cC cfv vb cv cF cfv wf wb
      va cv vb cv cC fveq2 va cv cC cfv vb cv cC cfv cB vb cv cF cfv feq3 syl
      bitrd rcla4cva sylan an1rs anasss adantll adantlr anassrs eqeltrd
      r19.21aiva 3jca vb cA vb cv cC cfv vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab elixp2 sylibr upixp.1 syl6eleqr r19.21aiva vu vv
      cB cX vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab vu
      cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt
      copab wceq wa vu vv copab vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv
      vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab eqid fopab2
      sylib cB cX vu cv cB wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv
      cfv wceq wa vs vt copab wceq wa vu vv copab frn syl syl3anc sylanc mpbird
      r19.21aiva vc cv cF cfv vc cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt
      cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom
      wceq va cv cF cfv va cv cP cfv vu cv cB wcel vv cv vs cv cA wcel vt cv vu
      cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom wceq vc
      va cA vc cv va cv wceq vc cv cF cfv va cv cF cfv vc cv cP cfv vu cv cB
      wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq wa vu vv copab ccom va cv cP cfv vu cv cB wcel vv cv vs cv cA wcel
      vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab wceq wa vu vv copab ccom
      vc cv va cv cF fveq2 vc cv va cv wceq vc cv cP cfv va cv cP cfv vu cv cB
      wcel vv cv vs cv cA wcel vt cv vu cv vs cv cF cfv cfv wceq wa vs vt copab
      wceq wa vu vv copab vc cv va cv cP fveq2 coeq1d eqeq12d cbvralv sylib
      3adant2 jca syl5cbir impbid eubidv mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Equality of equivalence classes. $)
    erthdmg $p |- ( ( B e. C /\ Er R /\ A e. dom R )
                                  -> ( [ A ] R = [ B ] R <-> A R B ) ) $=
      cB cC wcel cR wer cA cR cdm wcel cA cR cec cB cR cec wceq cA cB cR wbr wb
      cB cvv wcel cR wer cA cR cdm wcel cA cR cec cB cR cec wceq cA cB cR wbr
      wb wi cB cC wcel cB cvv wcel cR wer cA cR cdm wcel cA cR cec cB cR cec
      wceq cA cB cR wbr wb wi cA cR cdm wcel cA cR cec cB cvv wcel cB c0 cif cR
      cec wceq cA cB cvv wcel cB c0 cif cR wbr wb wi cA cR wer cR cid cif cdm
      wcel cA cR wer cR cid cif cec cB cvv wcel cB c0 cif cR wer cR cid cif cec
      wceq cA cB cvv wcel cB c0 cif cR wer cR cid cif wbr wb wi cB cR c0 cid cB
      cB cvv wcel cB c0 cif wceq cA cR cec cB cR cec wceq cA cB cR wbr wb cA cR
      cec cB cvv wcel cB c0 cif cR cec wceq cA cB cvv wcel cB c0 cif cR wbr wb
      cA cR cdm wcel cB cB cvv wcel cB c0 cif wceq cA cR cec cB cR cec wceq cA
      cR cec cB cvv wcel cB c0 cif cR cec wceq cA cB cR wbr cA cB cvv wcel cB
      c0 cif cR wbr cB cB cvv wcel cB c0 cif wceq cB cR cec cB cvv wcel cB c0
      cif cR cec cA cR cec cB cB cvv wcel cB c0 cif cR eceq2 eqeq2d cB cB cvv
      wcel cB c0 cif cA cR breq2 bibi12d imbi2d cR cR wer cR cid cif wceq cA cR
      cdm wcel cA cR wer cR cid cif cdm wcel cA cR cec cB cvv wcel cB c0 cif cR
      cec wceq cA cB cvv wcel cB c0 cif cR wbr wb cA cR wer cR cid cif cec cB
      cvv wcel cB c0 cif cR wer cR cid cif cec wceq cA cB cvv wcel cB c0 cif cR
      wer cR cid cif wbr wb cR cR wer cR cid cif wceq cR cdm cR wer cR cid cif
      cdm cA cR cR wer cR cid cif dmeq eleq2d cR cR wer cR cid cif wceq cA cR
      cec cB cvv wcel cB c0 cif cR cec wceq cA cR wer cR cid cif cec cB cvv
      wcel cB c0 cif cR wer cR cid cif cec wceq cA cB cvv wcel cB c0 cif cR wbr
      cA cB cvv wcel cB c0 cif cR wer cR cid cif wbr cR cR wer cR cid cif wceq
      cA cR cec cA cR wer cR cid cif cec cB cvv wcel cB c0 cif cR cec cB cvv
      wcel cB c0 cif cR wer cR cid cif cec cR cR wer cR cid cif cA eceq1 cR cR
      wer cR cid cif cB cvv wcel cB c0 cif eceq1 eqeq12d cA cB cvv wcel cB c0
      cif cR cR wer cR cid cif breq bibi12d imbi12d cA cB cvv wcel cB c0 cif cR
      wer cR cid cif cB c0 cvv 0ex elimel cR wer cR wer cR cid cif wer cid wer
      cR cid cR cR wer cR cid cif ereq cid cR wer cR cid cif ereq ider elimhyp
      erthdm dedth2h cB cC elisset sylan 3impia $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C x y z $. $d ph z $.
    $( Existence of an existentially restricted class abstraction. $)
    abrexex2g $p |- ( ( A e. B /\ A. x e. A { y | ph } e. C )
                                  -> { y | E. x e. A ph } e. _V ) $=
      cA cB wcel wph vy cab cC wcel vx cA wral wa vz cv wph vy cab wcel vx cA
      wrex vz cab cvv wph vx cA wrex vy cab cA cB wcel wph vy cab cC wcel vx cA
      wral wa vx cA wph vy cab ciun cvv vz cv wph vy cab wcel vx cA wrex vz cab
      vx cA wph vy cab cB cC iunexg vx vz cA wph vy cab df-iun syl5eqelr wph vx
      cA wrex vy cab wph vy vz cv wsbc vx cA wrex vz cab vz cv wph vy cab wcel
      vx cA wrex vz cab wph vx cA wrex wph vy vz cv wsbc vx cA wrex vy vz wph
      vx cA wrex vz ax-17 wph vy vz cv wsbc vy vx cA vx cv cA wcel vy ax-17 wph
      vy vz hbs1 hbrex vy cv vz cv wceq wph wph vy vz cv wsbc vx cA wph vy vz
      cv sbceq1a rexbidv cbvab vz cv wph vy cab wcel vx cA wrex wph vy vz cv
      wsbc vx cA wrex vz vz cv wph vy cab wcel wph vy vz cv wsbc vx cA wph vz
      vy df-clab rexbii abbii eqtr4i syl5eqel $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $.
    abrexdom.1 $e |- ( y e. A -> E* x ph ) $.
    $( An indexed set is dominated by the indexing set. $)
    abrexdom $p |- ( A e. C -> { x | E. y e. A ph } ~<_ A ) $=
      cA cC wcel vy cv cA wcel wph wa vy vx copab crn cA wph vy cA wrex vx cab
      cdom vy cv cA wcel wph wa vy vx copab crn vy cv cA wcel wph wa vy vx
      copab cdm cdom wbr vy cv cA wcel wph wa vy vx copab cdm cA cdom wbr vy cv
      cA wcel wph wa vy vx copab crn cA cdom wbr cA cC wcel vy cv cA wcel wph
      wa vy vx copab crn vy cv cA wcel wph wa vy vx copab cdm cA domtr vy cv cA
      wcel wph wa vy vx copab cdm cvv wcel vy cv cA wcel wph wa vy vx copab vy
      cv cA wcel wph wa vy vx copab cdm wfn vy cv cA wcel wph wa vy vx copab
      crn vy cv cA wcel wph wa vy vx copab cdm cdom wbr cA cC wcel vy cv cA
      wcel wph wa vy vx copab cdm cvv vy cv cA wcel wph wa vy vx copab fnrndomg
      vy cv cA wcel wph wa vy vx copab cdm cA wss cA cC wcel vy cv cA wcel wph
      wa vy vx copab cdm cvv wcel wph vy vx cA dmopabss vy cv cA wcel wph wa vy
      vx copab cdm cA cC ssexg mpan cA cC wcel vy cv cA wcel wph wa vy vx copab
      wfun vy cv cA wcel wph wa vy vx copab vy cv cA wcel wph wa vy vx copab
      cdm wfn vy cv cA wcel wph wa vy vx copab wfun cA cC wcel vy cv cA wcel
      wph wa vy vx copab wfun vy cv cA wcel wph wa vx wmo vy vy cv cA wcel wph
      wa vy vx funopab vy cv cA wcel wph wa vx wmo vy cv cA wcel wph vx wmo wi
      abrexdom.1 vy cv cA wcel wph vx moanimv mpbir mpgbir a1i vy cv cA wcel
      wph wa vy vx copab funfn sylib sylc cA cC wcel vy cv cA wcel wph wa vy vx
      copab cdm cA wss vy cv cA wcel wph wa vy vx copab cdm cA cdom wbr wph vy
      vx cA dmopabss vy cv cA wcel wph wa vy vx copab cdm cA cC ssdom2g mpi
      sylanc wph vy cA wrex vx cab vy cv cA wcel wph wa vy wex vx cab vy cv cA
      wcel wph wa vy vx copab crn wph vy cA wrex vy cv cA wcel wph wa vy wex vx
      wph vy cA df-rex abbii vy cv cA wcel wph wa vy vx rnopab eqtr4i syl5eqbr
      $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d B x $.
    $( An indexed set is dominated by the indexing set. $)
    abrexdom2 $p |- ( A e. C -> { x | E. y e. A x = B } ~<_ A ) $=
      vx cv cB wceq vx vy cA cC vx cv cB wceq vx wmo vy cv cA wcel vx cB moeq
      a1i abrexdom $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $.
    firnfi.1 $e |- ( y e. A -> E* x ph ) $.
    $( A set indexed by a finite set is finite. $)
    firnfi $p |- ( A e. Fin -> { x | E. y e. A ph } e. Fin ) $=
      cA cfn wcel wph vy cA wrex vx cab cA cdom wbr wph vy cA wrex vx cab cfn
      wcel wph vx vy cA cfn firnfi.1 abrexdom cA wph vy cA wrex vx cab domfi
      mpdan $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d B x $.
    $( A set indexed by a finite set is finite. $)
    firnfi2 $p |- ( A e. Fin -> { x | E. y e. A x = B } e. Fin ) $=
      vx cv cB wceq vx vy cA vx cv cB wceq vx wmo vy cv cA wcel vx cB moeq a1i
      firnfi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d ph w x z $. $d w x y z $. $d ps w z $.
    firnfi3.1 $e |- ( ph -> E* x ps ) $.
    $( A set indexed by a finite set is finite. $)
    firnfi3 $p |- ( { y | ph } e. Fin -> { x | E. y ( ph /\ ps ) } e. Fin ) $=
      wph vy cab cfn wcel wps vy vz cv wsbc vz wph vy cab wrex vx cab cfn wph
      wps wa vy wex vx cab wps vy vz cv wsbc vx vz wph vy cab wph vy vz cv wsbc
      wps vx wmo vy vz cv wsbc vz cv wph vy cab wcel wps vy vz cv wsbc vx wmo
      wph wps vx wmo vy vz firnfi3.1 sbimi wph vz vy df-clab wps vx wmo vy vz
      cv wsbc wps vy vz cv wsbc vx wmo wps vy vz vx sbmo bicomi 3imtr4i firnfi
      wph wps wa vy wex wps vy vz cv wsbc vz wph vy cab wrex vx wps vy wph vy
      cab wrex vy cv wph vy cab wcel wps wa vy wex wps vy vz cv wsbc vz wph vy
      cab wrex wph wps wa vy wex wps vy wph vy cab df-rex wps wps vy vz cv wsbc
      vy vz vw wph vy cab wph vy vw hbab1 vw cv wph vy cab wcel vz ax-17 wps vz
      ax-17 wps vy vz wps vz ax-17 hbsb3 wps vy vz cv sbceq1a cbvrexf vy cv wph
      vy cab wcel wps wa wph wps wa vy vy cv wph vy cab wcel wph wps wph vy
      abid anbi1i exbii 3bitr3ri abbii syl5eqel $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d ph x $. $d A x $. $d x y $.
    $( A set indexed by a finite set is finite. $)
    firnfi4 $p |- ( { y | ph } e. Fin
             -> { x | E. y ( ph /\ x = A ) } e. Fin ) $=
      wph vx cv cA wceq vx vy vx cv cA wceq vx wmo wph vx cA moeq a1i firnfi3
      $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( If ` A ` is equinumerous to a natural number, then that number is its
       cardinal. $)
    cardennn $p |- ( ( A e. C /\ A ~~ B /\ B e. om ) -> ( card ` A ) = B ) $=
      cA cC wcel cA cB cen wbr cB com wcel w3a cA ccrd cfv cB ccrd cfv cB cA cC
      wcel cA cB cen wbr cB com wcel cA ccrd cfv cB ccrd cfv wceq cA cC wcel cB
      com wcel cA cB cen wbr cA ccrd cfv cB ccrd cfv wceq cA cC wcel cB com
      wcel cA cB cen wbr cA ccrd cfv cB ccrd cfv wceq wi cA cC wcel cB com wcel
      wa cA ccrd cfv cB ccrd cfv wceq cA cB cen wbr cA cB cC com carden biimprd
      ex com23 3imp cB com wcel cA cC wcel cB ccrd cfv cB wceq cA cB cen wbr cB
      cardnn 3ad2ant3 eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x $. $d X x $. $d M x $.
    dif1en.1 $e |- A e. _V $.
    $( If a set ` A ` is equinumerous to the successor of natural number
       ` M ` , then ` A ` with an element removed is equinumerous to the
       predecessor of ` M ` . $)
    dif1en $p |- ( ( M e. om /\ A ~~ suc M /\ X e. A )
            -> ( A \ { X } ) ~~ M ) $=
      cM com wcel cA cM csuc cen wbr cX cA wcel cA cX csn cdif cM cen wbr cX cA
      wcel cM com wcel cA cM csuc cen wbr wa cA cX csn cdif cM cen wbr cX cA
      wcel cM com wcel cA cM csuc cen wbr wa cA cX csn cdif cM cen wbr wi vx cv
      cA wcel cM com wcel cA cM csuc cen wbr wa cA vx cv csn cdif cM cen wbr wi
      wi cX cA wcel cM com wcel cA cM csuc cen wbr wa cA cX csn cdif cM cen wbr
      wi wi vx cX cA vx cv cX wceq vx cv cA wcel cX cA wcel cM com wcel cA cM
      csuc cen wbr wa cA vx cv csn cdif cM cen wbr wi cM com wcel cA cM csuc
      cen wbr wa cA cX csn cdif cM cen wbr wi vx cv cX cA eleq1 vx cv cX wceq
      cA vx cv csn cdif cM cen wbr cA cX csn cdif cM cen wbr cM com wcel cA cM
      csuc cen wbr wa vx cv cX wceq cA vx cv csn cdif cA cX csn cdif cM cen vx
      cv cX wceq vx cv csn cX csn cA vx cv cX sneq difeq2d breq1d imbi2d
      imbi12d vx cv cA wcel cM com wcel cA cM csuc cen wbr cA vx cv csn cdif cM
      cen wbr vx cv cA wcel cA cM csuc cen wbr cM com wcel cA vx cv csn cdif cM
      cen wbr vx cv cA wcel cA cA vx cv csn cdif ccrd cfv csuc cen wbr cA cM
      csuc cen wbr cM com wcel cA vx cv csn cdif cM cen wbr wi wi vx cv cA wcel
      vx cv csn cA wss cA cA vx cv csn cdif vx cv csn cun wceq cA cA vx cv csn
      cdif ccrd cfv csuc cen wbr vx cv cA snssi vx cv csn cA wss vx cv csn cA
      vx cv csn cdif cun cA cA vx cv csn cdif vx cv csn cun vx cv csn cA wss vx
      cv csn cA vx cv csn cdif cun cA wceq vx cv csn cA undif biimpi vx cv csn
      cA vx cv csn cdif uncom syl5reqr cA cA vx cv csn cdif vx cv csn cun wceq
      cA cA vx cv csn cdif ccrd cfv csuc cen wbr cA vx cv csn cdif vx cv csn
      cun cA vx cv csn cdif ccrd cfv csuc cen wbr vx cv cA vx cv csn cdif wcel
      wn cA vx cv csn cdif vx cv csn cun cA vx cv csn cdif ccrd cfv csuc cen
      wbr vx cv vx cv csn wcel vx cv cA vx cv csn cdif wcel wn vx cv vx visset
      snid vx cv vx cv csn cA elndif ax-mp cA vx cv csn cdif vx cv cA cvv wcel
      cA vx cv csn cdif cvv wcel dif1en.1 cA vx cv csn cvv difexg ax-mp vx
      visset unsnen ax-mp cA cA vx cv csn cdif vx cv csn cun cA vx cv csn cdif
      ccrd cfv csuc cen breq1 mpbiri 3syl cA cA vx cv csn cdif ccrd cfv csuc
      cen wbr cA cM csuc cen wbr cM com wcel cA vx cv csn cdif cM cen wbr wi cA
      vx cv csn cdif ccrd cfv csuc cA cen wbr cA cM csuc cen wbr cM com wcel cA
      vx cv csn cdif cM cen wbr wi cA cA vx cv csn cdif ccrd cfv csuc cen wbr
      cM com wcel cA vx cv csn cdif ccrd cfv csuc cM csuc cen wbr cA vx cv csn
      cdif cM cen wbr cA vx cv csn cdif ccrd cfv csuc cA cen wbr cA cM csuc cen
      wbr wa cM com wcel cA vx cv csn cdif ccrd cfv csuc cM csuc cen wbr cA vx
      cv csn cdif ccrd cfv cM wceq cA vx cv csn cdif cM cen wbr cM com wcel cA
      vx cv csn cdif ccrd cfv csuc cM csuc cen wbr cA vx cv csn cdif ccrd cfv
      csuc cM csuc wceq cA vx cv csn cdif ccrd cfv cM wceq cA vx cv csn cdif
      ccrd cfv csuc con0 wcel cM csuc com wcel cA vx cv csn cdif ccrd cfv csuc
      cM csuc cen wbr cA vx cv csn cdif ccrd cfv csuc cM csuc wceq wb cM com
      wcel cA vx cv csn cdif ccrd cfv csuc cM csuc onomeneq cA vx cv csn cdif
      ccrd cfv cA vx cv csn cdif cardon onsuci cM peano2 sylancr cA vx cv csn
      cdif ccrd cfv con0 wcel cM con0 wcel cA vx cv csn cdif ccrd cfv csuc cM
      csuc wceq cA vx cv csn cdif ccrd cfv cM wceq wb cM com wcel cA vx cv csn
      cdif ccrd cfv cM suc11 cA vx cv csn cdif cardon cM nnon sylancr bitrd cA
      vx cv csn cdif ccrd cfv cM wceq cA vx cv csn cdif cA vx cv csn cdif ccrd
      cfv cen wbr cA vx cv csn cdif cM cen wbr cA vx cv csn cdif ccrd cfv cA vx
      cv csn cdif cA cvv wcel cA vx cv csn cdif cvv wcel dif1en.1 cA vx cv csn
      cvv difexg ax-mp cA vx cv csn cdif cardid ensymi cA vx cv csn cdif ccrd
      cfv cM cA vx cv csn cdif cen breq2 mpbii syl6bi cA vx cv csn cdif ccrd
      cfv csuc cA cM csuc entr syl5com cA cA vx cv csn cdif ccrd cfv csuc cA vx
      cv csn cdif ccrd cfv cA vx cv csn cdif ccrd fvex sucex ensym sylan ex syl
      com23 imp3a vtoclg pm2.43i com12 3impia $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x $. $d B x $.
    $( A set is finite iff its cardinal is a natural number. $)
    ficard $p |- ( A e. B -> ( A e. Fin <-> ( card ` A ) e. om ) ) $=
      cA cB wcel cA cfn wcel cA ccrd cfv com wcel cA cB wcel cA vx cv cen wbr
      vx com wrex cA ccrd cfv com wcel cA cfn wcel cA cB wcel cA vx cv cen wbr
      cA ccrd cfv com wcel vx com cA cB wcel vx cv com wcel wa cA vx cv cen wbr
      cA ccrd cfv vx cv ccrd cfv wceq cA ccrd cfv com wcel cA vx cv cB com
      carden vx cv com wcel cA ccrd cfv vx cv ccrd cfv wceq cA ccrd cfv com
      wcel wi cA cB wcel vx cv com wcel cA ccrd cfv vx cv ccrd cfv wceq cA ccrd
      cfv vx cv wceq cA ccrd cfv com wcel vx cv com wcel vx cv ccrd cfv vx cv
      wceq cA ccrd cfv vx cv ccrd cfv wceq cA ccrd cfv vx cv wceq wi vx cv
      cardnn cA ccrd cfv vx cv ccrd cfv wceq vx cv ccrd cfv vx cv wceq cA ccrd
      cfv vx cv wceq cA ccrd cfv vx cv ccrd cfv vx cv eqtr expcom syl vx cv com
      cA ccrd cfv eleq1a syld adantl sylbird r19.23adva vx cA isfi syl5ib cA cB
      wcel cA ccrd cfv com wcel cA ccrd cfv com wcel cA cA ccrd cfv cen wbr wa
      cA cfn wcel cA cB wcel cA ccrd cfv com wcel cA cA ccrd cfv cen wbr cA cB
      wcel cA ccrd cfv com wcel cA cA ccrd cfv cen wbr cA cB wcel cA ccrd cfv
      com wcel wa cA ccrd cfv cA ccrd cfv ccrd cfv wceq cA cA ccrd cfv cen wbr
      cA ccrd cfv com wcel cA ccrd cfv cA ccrd cfv ccrd cfv wceq cA cB wcel cA
      ccrd cfv com wcel cA ccrd cfv ccrd cfv cA ccrd cfv cA ccrd cfv cardnn
      eqcomd adantl cA cA ccrd cfv cB com carden mpbid ex ancld cA ccrd cfv com
      wcel cA cA ccrd cfv cen wbr wa cA vx cv cen wbr vx com wrex cA cfn wcel
      cA vx cv cen wbr cA cA ccrd cfv cen wbr vx cA ccrd cfv com vx cv cA ccrd
      cfv cA cen breq2 rcla4ev vx cA isfi sylibr syl6 impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d X x y $.
    $( The cardinality of a non-empty finite set is one greater than the
       cardinality of the set with one element removed. $)
    dif1card $p |- ( ( A e. Fin /\ X e. A ) -> ( card ` A ) =
                                      suc ( card ` ( A \ { X } ) ) ) $=
      cA cfn wcel cX cA wcel wa cA vx cv cen wbr vx com wrex cA ccrd cfv cA cX
      csn cdif ccrd cfv csuc wceq cA cfn wcel cA vx cv cen wbr vx com wrex cX
      cA wcel cA cfn wcel cA vx cv cen wbr vx com wrex vx cA isfi biimpi adantr
      cA cfn wcel cX cA wcel wa cA vx cv cen wbr vx com wrex cA vy cv csuc cen
      wbr vy com wrex cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq cX cA wcel
      cA vx cv cen wbr vx com wrex cA vy cv csuc cen wbr vy com wrex wi cA cfn
      wcel cX cA wcel cA c0 wceq wn cA vx cv cen wbr vx com wrex cA vy cv csuc
      cen wbr vy com wrex wi cA cX n0i cA c0 wceq wn cA vx cv cen wbr cA vy cv
      csuc cen wbr vy com wrex vx com vx cv com wcel cA c0 wceq wn cA vx cv cen
      wbr cA vy cv csuc cen wbr vy com wrex wi vx cv com wcel vx cv c0 wceq vx
      cv vy cv csuc wceq vy com wrex wo cA c0 wceq wn cA vx cv cen wbr cA vy cv
      csuc cen wbr vy com wrex wi wi vy vx cv nn0suc vx cv c0 wceq cA c0 wceq
      wn cA vx cv cen wbr cA vy cv csuc cen wbr vy com wrex wi wi vx cv vy cv
      csuc wceq vy com wrex vx cv c0 wceq cA vx cv cen wbr cA c0 wceq wn cA vy
      cv csuc cen wbr vy com wrex vx cv c0 wceq cA vx cv cen wbr cA c0 wceq cA
      c0 wceq wn cA vy cv csuc cen wbr vy com wrex wi vx cv c0 wceq cA vx cv
      cen wbr cA c0 cen wbr cA c0 wceq vx cv c0 wceq cA vx cv cen wbr cA c0 cen
      wbr vx cv c0 cA cen breq2 biimpd cA en0 syl6ib cA c0 wceq cA vy cv csuc
      cen wbr vy com wrex pm2.24 syl6 com23 vx cv vy cv csuc wceq vy com wrex
      cA vx cv cen wbr cA vy cv csuc cen wbr vy com wrex wi cA c0 wceq wn cA vx
      cv cen wbr vx cv vy cv csuc wceq vy com wrex cA vy cv csuc cen wbr vy com
      wrex cA vx cv cen wbr vx cv vy cv csuc wceq cA vy cv csuc cen wbr vy com
      vx cv vy cv csuc wceq cA vx cv cen wbr cA vy cv csuc cen wbr vx cv vy cv
      csuc cA cen breq2 biimpcd r19.22sdv com12 a1d jaoi syl impcom r19.23adva
      syl adantl cA cfn wcel cX cA wcel wa cA vy cv csuc cen wbr cA ccrd cfv cA
      cX csn cdif ccrd cfv csuc wceq vy com cA cfn wcel cX cA wcel vy cv com
      wcel cA vy cv csuc cen wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq
      wi cX cA wcel vy cv com wcel wa cA cfn wcel cA vy cv csuc cen wbr cA ccrd
      cfv cA cX csn cdif ccrd cfv csuc wceq wi cX cA wcel vy cv com wcel wa cA
      vy cv csuc cen wbr cA cfn wcel cA ccrd cfv cA cX csn cdif ccrd cfv csuc
      wceq cX cA wcel vy cv com wcel cA vy cv csuc cen wbr cA cfn wcel cA ccrd
      cfv cA cX csn cdif ccrd cfv csuc wceq wi vy cv com wcel cA vy cv csuc cen
      wbr cX cA wcel cA cfn wcel cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq
      wi cA cfn wcel vy cv com wcel cA vy cv csuc cen wbr cX cA wcel w3a cA
      ccrd cfv cA cX csn cdif ccrd cfv csuc wceq cA cfn wcel vy cv com wcel cA
      vy cv csuc cen wbr cX cA wcel w3a cA cX csn cdif vy cv cen wbr cA ccrd
      cfv cA cX csn cdif ccrd cfv csuc wceq cA cfn wcel cA cvv wcel vy cv com
      wcel cA vy cv csuc cen wbr cX cA wcel w3a cA cX csn cdif vy cv cen wbr wi
      cA cfn elisset cA cvv wcel vy cv com wcel cA vy cv csuc cen wbr cX cA
      wcel w3a cA cX csn cdif vy cv cen wbr wi vy cv com wcel cA cvv wcel cA c0
      cif vy cv csuc cen wbr cX cA cvv wcel cA c0 cif wcel w3a cA cvv wcel cA
      c0 cif cX csn cdif vy cv cen wbr wi cA c0 cA cA cvv wcel cA c0 cif wceq
      vy cv com wcel cA vy cv csuc cen wbr cX cA wcel w3a vy cv com wcel cA cvv
      wcel cA c0 cif vy cv csuc cen wbr cX cA cvv wcel cA c0 cif wcel w3a cA cX
      csn cdif vy cv cen wbr cA cvv wcel cA c0 cif cX csn cdif vy cv cen wbr cA
      cA cvv wcel cA c0 cif wceq cA vy cv csuc cen wbr cA cvv wcel cA c0 cif vy
      cv csuc cen wbr cX cA wcel cX cA cvv wcel cA c0 cif wcel vy cv com wcel
      cA cA cvv wcel cA c0 cif vy cv csuc cen breq1 cA cA cvv wcel cA c0 cif cX
      eleq2 3anbi23d cA cA cvv wcel cA c0 cif wceq cA cX csn cdif cA cvv wcel
      cA c0 cif cX csn cdif vy cv cen cA cA cvv wcel cA c0 cif cX csn difeq1
      breq1d imbi12d cA cvv wcel cA c0 cif vy cv cX cA c0 cvv 0ex elimel dif1en
      dedth syl cA cfn wcel vy cv com wcel cA vy cv csuc cen wbr cX cA wcel cA
      cX csn cdif vy cv cen wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq
      wi cA cfn wcel cA vy cv csuc cen wbr vy cv com wcel cX cA wcel cA cX csn
      cdif vy cv cen wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq wi wi cA
      cfn wcel cA vy cv csuc cen wbr vy cv com wcel cX cA wcel cA cX csn cdif
      vy cv cen wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq wi wi cA cfn
      wcel cA vy cv csuc cen wbr vy cv com wcel w3a cA cX csn cdif vy cv cen
      wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq wi cX cA wcel cA cfn
      wcel cA vy cv csuc cen wbr vy cv com wcel w3a cA ccrd cfv vy cv csuc wceq
      cA cX csn cdif vy cv cen wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc
      wceq wi cA cfn wcel cA vy cv csuc cen wbr vy cv csuc com wcel cA ccrd cfv
      vy cv csuc wceq vy cv com wcel cA vy cv csuc cfn cardennn vy cv peano2
      syl3an3 cA cfn wcel vy cv com wcel cA ccrd cfv vy cv csuc wceq cA cX csn
      cdif vy cv cen wbr cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq wi wi cA
      vy cv csuc cen wbr cA cfn wcel vy cv com wcel wa cA cX csn cdif vy cv cen
      wbr cA ccrd cfv vy cv csuc wceq cA ccrd cfv cA cX csn cdif ccrd cfv csuc
      wceq cA cfn wcel vy cv com wcel wa cA cX csn cdif vy cv cen wbr cA cX csn
      cdif ccrd cfv vy cv wceq cA ccrd cfv vy cv csuc wceq cA ccrd cfv cA cX
      csn cdif ccrd cfv csuc wceq wi cA cfn wcel vy cv com wcel cA cX csn cdif
      vy cv cen wbr cA cX csn cdif ccrd cfv vy cv wceq wi cA cfn wcel cA cX csn
      cdif vy cv cen wbr vy cv com wcel cA cX csn cdif ccrd cfv vy cv wceq cA
      cfn wcel cA cX csn cdif vy cv cen wbr vy cv com wcel cA cX csn cdif ccrd
      cfv vy cv wceq cA cX csn cdif cvv wcel cA cX csn cdif vy cv cen wbr vy cv
      com wcel cA cX csn cdif ccrd cfv vy cv wceq cA cfn wcel cA cX csn cdif vy
      cv cvv cardennn cA cX csn cfn difexg syl3an1 3exp com23 imp cA cX csn
      cdif ccrd cfv vy cv wceq cA ccrd cfv cA cX csn cdif ccrd cfv csuc wceq cA
      ccrd cfv vy cv csuc wceq cA cX csn cdif ccrd cfv vy cv wceq cA cX csn
      cdif ccrd cfv csuc vy cv csuc cA ccrd cfv cA cX csn cdif ccrd cfv vy cv
      suceq eqeq2d biimprd syl6 com23 3adant2 mpd a1d 3exp com23 3impd mpdd
      com12 3comr 3expia com23 impcom anassrs r19.23adva syld mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d w x y z $. $d A x y z $. $d ps x $. $d ch x $.
    $d th x $. $d ta x $. $d ph w y z $.
    findcard.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    findcard.2 $e |- ( x = ( y \ { z } ) -> ( ph <-> ch ) ) $.
    findcard.3 $e |- ( x = y -> ( ph <-> th ) ) $.
    findcard.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    findcard.5 $e |- ps $.
    findcard.6 $e |- ( y e. Fin -> ( A. z e. y ch -> th ) ) $.
    $( Schema for induction on the cardinality of a set. The inductive
       hypothesis is that the result is true on the given set with any one
       element removed. The result is then proven to be true for all finite
       sets. $)
    findcard $p |- ( A e. Fin -> ta ) $=
      cA cfn wcel cA ccrd cfv cA ccrd cfv wceq wta cA ccrd cfv eqid cA cfn wcel
      vx cv ccrd cfv cA ccrd cfv wceq wph wi vx wal cA ccrd cfv cA ccrd cfv
      wceq wta wi cA cfn wcel cA ccrd cfv com wcel vx cv ccrd cfv cA ccrd cfv
      wceq wph wi vx wal cA ficardom vx cv ccrd cfv vy cv wceq wph wi vx wal vx
      cv ccrd cfv c0 wceq wph wi vx wal vx cv ccrd cfv vw cv wceq wph wi vx wal
      vx cv ccrd cfv vw cv csuc wceq wph wi vx wal vx cv ccrd cfv cA ccrd cfv
      wceq wph wi vx wal vy vw cA ccrd cfv vy cv c0 wceq vx cv ccrd cfv vy cv
      wceq wph wi vx cv ccrd cfv c0 wceq wph wi vx vy cv c0 wceq vx cv ccrd cfv
      vy cv wceq vx cv ccrd cfv c0 wceq wph vy cv c0 vx cv ccrd cfv eqeq2
      imbi1d albidv vy cv vw cv wceq vx cv ccrd cfv vy cv wceq wph wi vx cv
      ccrd cfv vw cv wceq wph wi vx vy cv vw cv wceq vx cv ccrd cfv vy cv wceq
      vx cv ccrd cfv vw cv wceq wph vy cv vw cv vx cv ccrd cfv eqeq2 imbi1d
      albidv vy cv vw cv csuc wceq vx cv ccrd cfv vy cv wceq wph wi vx cv ccrd
      cfv vw cv csuc wceq wph wi vx vy cv vw cv csuc wceq vx cv ccrd cfv vy cv
      wceq vx cv ccrd cfv vw cv csuc wceq wph vy cv vw cv csuc vx cv ccrd cfv
      eqeq2 imbi1d albidv vy cv cA ccrd cfv wceq vx cv ccrd cfv vy cv wceq wph
      wi vx cv ccrd cfv cA ccrd cfv wceq wph wi vx vy cv cA ccrd cfv wceq vx cv
      ccrd cfv vy cv wceq vx cv ccrd cfv cA ccrd cfv wceq wph vy cv cA ccrd cfv
      vx cv ccrd cfv eqeq2 imbi1d albidv vx cv ccrd cfv c0 wceq wph wi vx vx cv
      ccrd cfv c0 wceq wph wps findcard.5 vx cv ccrd cfv c0 wceq vx cv c0 wceq
      wph wps wb vx cv cvv wcel vx cv ccrd cfv c0 wceq vx cv c0 wceq wb vx
      visset vx cv cvv cardeq0 ax-mp findcard.1 sylbi mpbiri ax-gen vw cv com
      wcel vx cv ccrd cfv vw cv wceq wph wi vx wal vy cv ccrd cfv vw cv csuc
      wceq wth wi vy wal vx cv ccrd cfv vw cv csuc wceq wph wi vx wal vw cv com
      wcel vx cv ccrd cfv vw cv wceq wph wi vx wal vy cv ccrd cfv vw cv csuc
      wceq wth wi vy vw cv com wcel vy cv ccrd cfv vw cv csuc wceq vx cv ccrd
      cfv vw cv wceq wph wi vx wal wth vw cv com wcel vy cv ccrd cfv vw cv csuc
      wceq vy cv cfn wcel vx cv ccrd cfv vw cv wceq wph wi vx wal wth wi vw cv
      com wcel vw cv csuc com wcel vy cv ccrd cfv vw cv csuc wceq vy cv cfn
      wcel wi vw cv peano2 vw cv csuc com wcel vy cv ccrd cfv vw cv csuc wceq
      vy cv ccrd cfv com wcel vy cv cfn wcel vw cv csuc com vy cv ccrd cfv
      eleq1a vy cv cvv wcel vy cv cfn wcel vy cv ccrd cfv com wcel wb vy visset
      vy cv cvv ficard ax-mp syl6ibr syl vy cv cfn wcel vy cv ccrd cfv vw cv
      csuc wceq vw cv com wcel vx cv ccrd cfv vw cv wceq wph wi vx wal wth wi
      vy cv cfn wcel vy cv ccrd cfv vw cv csuc wceq vw cv com wcel vx cv ccrd
      cfv vw cv wceq wph wi vx wal wth vy cv cfn wcel wch vz vy cv wral wth vy
      cv ccrd cfv vw cv csuc wceq vw cv com wcel vx cv ccrd cfv vw cv wceq wph
      wi vx wal w3a findcard.6 vy cv ccrd cfv vw cv csuc wceq vw cv com wcel vx
      cv ccrd cfv vw cv wceq wph wi vx wal w3a wch vz vy cv vy cv ccrd cfv vw
      cv csuc wceq vw cv com wcel vx cv ccrd cfv vw cv wceq wph wi vx wal vz cv
      vy cv wcel wch wi vy cv ccrd cfv vw cv csuc wceq vw cv com wcel vy cv vz
      cv csn cdif ccrd cfv vw cv wceq wch wi vz cv vy cv wcel wch wi vx cv ccrd
      cfv vw cv wceq wph wi vx wal vy cv ccrd cfv vw cv csuc wceq vw cv com
      wcel vy cv vz cv csn cdif ccrd cfv vw cv wceq wch wi vz cv vy cv wcel wch
      wi wi vy cv ccrd cfv vw cv csuc wceq vw cv com wcel wa vz cv vy cv wcel
      vy cv vz cv csn cdif ccrd cfv vw cv wceq wch vy cv ccrd cfv vw cv csuc
      wceq vw cv com wcel wa vy cv cfn wcel vz cv vy cv wcel vy cv vz cv csn
      cdif ccrd cfv vw cv wceq vy cv ccrd cfv vw cv csuc wceq vw cv com wcel vy
      cv cfn wcel vy cv ccrd cfv vw cv csuc wceq vw cv csuc com wcel vy cv cfn
      wcel vw cv com wcel vy cv ccrd cfv vw cv csuc wceq vw cv csuc com wcel vy
      cv ccrd cfv com wcel vy cv cfn wcel vy cv ccrd cfv vw cv csuc wceq vy cv
      ccrd cfv com wcel vw cv csuc com wcel vy cv ccrd cfv vw cv csuc com eleq1
      biimprd vy cv cvv wcel vy cv cfn wcel vy cv ccrd cfv com wcel wb vy
      visset vy cv cvv ficard ax-mp syl6ibr vw cv peano2 syl5 imp vy cv cfn
      wcel vz cv vy cv wcel wa vy cv ccrd cfv vw cv csuc wceq vw cv com wcel wa
      vy cv vz cv csn cdif ccrd cfv vw cv wceq vy cv cfn wcel vz cv vy cv wcel
      wa vy cv ccrd cfv vy cv vz cv csn cdif ccrd cfv csuc wceq vy cv ccrd cfv
      vw cv csuc wceq vw cv com wcel wa vy cv vz cv csn cdif ccrd cfv vw cv
      wceq wi vy cv vz cv dif1card vy cv ccrd cfv vy cv vz cv csn cdif ccrd cfv
      csuc wceq vy cv ccrd cfv vw cv csuc wceq vw cv com wcel wa vy cv vz cv
      csn cdif ccrd cfv csuc vw cv csuc wceq vw cv com wcel wa vy cv vz cv csn
      cdif ccrd cfv vw cv wceq vy cv ccrd cfv vy cv vz cv csn cdif ccrd cfv
      csuc wceq vy cv ccrd cfv vw cv csuc wceq vy cv vz cv csn cdif ccrd cfv
      csuc vw cv csuc wceq vw cv com wcel vy cv ccrd cfv vy cv vz cv csn cdif
      ccrd cfv csuc wceq vy cv ccrd cfv vw cv csuc wceq vy cv vz cv csn cdif
      ccrd cfv csuc vw cv csuc wceq vy cv ccrd cfv vy cv vz cv csn cdif ccrd
      cfv csuc vw cv csuc eqeq1 biimpd anim1d vw cv com wcel vy cv vz cv csn
      cdif ccrd cfv csuc vw cv csuc wceq vy cv vz cv csn cdif ccrd cfv vw cv
      wceq vy cv vz cv csn cdif ccrd cfv con0 wcel vw cv con0 wcel vy cv vz cv
      csn cdif ccrd cfv csuc vw cv csuc wceq vy cv vz cv csn cdif ccrd cfv vw
      cv wceq wb vw cv com wcel vy cv vz cv csn cdif ccrd cfv vw cv suc11 vy cv
      vz cv csn cdif cardon vw cv nnon sylancr biimpac syl6 syl com12 mpand
      imim1d ex vx cv ccrd cfv vw cv wceq wph wi vy cv vz cv csn cdif ccrd cfv
      vw cv wceq wch wi vx vy cv vz cv csn cdif vy cv cvv wcel vy cv vz cv csn
      cdif cvv wcel vy visset vy cv vz cv csn cvv difexg ax-mp vx cv vy cv vz
      cv csn cdif wceq vx cv ccrd cfv vw cv wceq vy cv vz cv csn cdif ccrd cfv
      vw cv wceq wph wch vx cv vy cv vz cv csn cdif wceq vx cv ccrd cfv vy cv
      vz cv csn cdif ccrd cfv vw cv vx cv vy cv vz cv csn cdif ccrd fveq2
      eqeq1d findcard.2 imbi12d cla4v syl7 3imp r19.21aiv syl5 3expd com13 mpdd
      com23 19.21adv vx cv ccrd cfv vw cv csuc wceq wph wi vy cv ccrd cfv vw cv
      csuc wceq wth wi vx vy vx cv vy cv wceq vx cv ccrd cfv vw cv csuc wceq vy
      cv ccrd cfv vw cv csuc wceq wph wth vx cv vy cv wceq vx cv ccrd cfv vy cv
      ccrd cfv vw cv csuc vx cv vy cv ccrd fveq2 eqeq1d findcard.3 imbi12d
      cbvalv syl6ibr finds syl vx cv ccrd cfv cA ccrd cfv wceq wph wi cA ccrd
      cfv cA ccrd cfv wceq wta wi vx cA cfn vx cv cA wceq vx cv ccrd cfv cA
      ccrd cfv wceq cA ccrd cfv cA ccrd cfv wceq wph wta vx cv cA wceq vx cv
      ccrd cfv cA ccrd cfv cA ccrd cfv vx cv cA ccrd fveq2 eqeq1d findcard.4
      imbi12d cla4gv mpd mpi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A s t u v w x y z $. $d R s t u v w x y z $.
    fimax.1 $e |- R Or A $.
    $( A finite set has a maximum under a total order. $)
    fimax $p |- ( ( A e. Fin /\ A =/= (/) ) ->
                            E. x e. A A. y e. A ( x =/= y -> y R x ) ) $=
      cA cfn wcel cA c0 wne wa cA cA wss vx cv vy cv wne vy cv vx cv cR wbr wi
      vy cA wral vx cA wrex cA ssid cA cfn wcel cA c0 wne cA cA wss vx cv vy cv
      wne vy cv vx cv cR wbr wi vy cA wral vx cA wrex wi vz cv c0 wne vz cv cA
      wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vz cv wral vx vz cv wrex wi
      wi c0 c0 wne c0 cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy c0 wral
      vx c0 wrex wi wi vw cv vu cv csn cdif c0 wne vw cv vu cv csn cdif cA wss
      vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral vx vw
      cv vu cv csn cdif wrex wi wi vw cv c0 wne vw cv cA wss vx cv vy cv wne vy
      cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi cA c0 wne cA cA wss
      vx cv vy cv wne vy cv vx cv cR wbr wi vy cA wral vx cA wrex wi wi vz vw
      vu cA vz cv c0 wceq vz cv c0 wne c0 c0 wne vz cv cA wss vx cv vy cv wne
      vy cv vx cv cR wbr wi vy vz cv wral vx vz cv wrex wi c0 cA wss vx cv vy
      cv wne vy cv vx cv cR wbr wi vy c0 wral vx c0 wrex wi vz cv c0 c0 neeq1
      vz cv c0 wceq vz cv cA wss c0 cA wss vx cv vy cv wne vy cv vx cv cR wbr
      wi vy vz cv wral vx vz cv wrex vx cv vy cv wne vy cv vx cv cR wbr wi vy
      c0 wral vx c0 wrex vz cv c0 cA sseq1 vx cv vy cv wne vy cv vx cv cR wbr
      wi vy vz cv wral vx cv vy cv wne vy cv vx cv cR wbr wi vy c0 wral vx vz
      cv c0 vx cv vy cv wne vy cv vx cv cR wbr wi vy vz cv c0 raleq1 rexeqd
      imbi12d imbi12d vz cv vw cv vu cv csn cdif wceq vz cv c0 wne vw cv vu cv
      csn cdif c0 wne vz cv cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vz
      cv wral vx vz cv wrex wi vw cv vu cv csn cdif cA wss vx cv vy cv wne vy
      cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral vx vw cv vu cv csn cdif
      wrex wi vz cv vw cv vu cv csn cdif c0 neeq1 vz cv vw cv vu cv csn cdif
      wceq vz cv cA wss vw cv vu cv csn cdif cA wss vx cv vy cv wne vy cv vx cv
      cR wbr wi vy vz cv wral vx vz cv wrex vx cv vy cv wne vy cv vx cv cR wbr
      wi vy vw cv vu cv csn cdif wral vx vw cv vu cv csn cdif wrex vz cv vw cv
      vu cv csn cdif cA sseq1 vx cv vy cv wne vy cv vx cv cR wbr wi vy vz cv
      wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral
      vx vz cv vw cv vu cv csn cdif vx cv vy cv wne vy cv vx cv cR wbr wi vy vz
      cv vw cv vu cv csn cdif raleq1 rexeqd imbi12d imbi12d vz cv vw cv wceq vz
      cv c0 wne vw cv c0 wne vz cv cA wss vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vz cv wral vx vz cv wrex wi vw cv cA wss vx cv vy cv wne vy cv vx cv
      cR wbr wi vy vw cv wral vx vw cv wrex wi vz cv vw cv c0 neeq1 vz cv vw cv
      wceq vz cv cA wss vw cv cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy
      vz cv wral vx vz cv wrex vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv
      wral vx vw cv wrex vz cv vw cv cA sseq1 vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vz cv wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral
      vx vz cv vw cv vx cv vy cv wne vy cv vx cv cR wbr wi vy vz cv vw cv
      raleq1 rexeqd imbi12d imbi12d vz cv cA wceq vz cv c0 wne cA c0 wne vz cv
      cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vz cv wral vx vz cv wrex
      wi cA cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy cA wral vx cA wrex
      wi vz cv cA c0 neeq1 vz cv cA wceq vz cv cA wss cA cA wss vx cv vy cv wne
      vy cv vx cv cR wbr wi vy vz cv wral vx vz cv wrex vx cv vy cv wne vy cv
      vx cv cR wbr wi vy cA wral vx cA wrex vz cv cA cA sseq1 vx cv vy cv wne
      vy cv vx cv cR wbr wi vy vz cv wral vx cv vy cv wne vy cv vx cv cR wbr wi
      vy cA wral vx vz cv cA vx cv vy cv wne vy cv vx cv cR wbr wi vy vz cv cA
      raleq1 rexeqd imbi12d imbi12d c0 c0 wne c0 cA wss vx cv vy cv wne vy cv
      vx cv cR wbr wi vy c0 wral vx c0 wrex wi c0 c0 wceq c0 c0 wne wn c0 eqid
      c0 c0 wne c0 c0 wceq c0 c0 df-ne con2bii mpbi pm2.21i vw cv vv cv csn
      wceq vv wex vw cv cfn wcel vw cv vu cv csn cdif c0 wne vw cv vu cv csn
      cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif
      wral vx vw cv vu cv csn cdif wrex wi wi vu vw cv wral vw cv c0 wne vw cv
      cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex
      wi wi wi wi vw cv vv cv csn wceq vv wex vw cv cfn wcel vw cv vu cv csn
      cdif c0 wne vw cv vu cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv vu cv csn cdif wral vx vw cv vu cv csn cdif wrex wi wi vu
      vw cv wral vw cv c0 wne vw cv cA wss vx cv vy cv wne vy cv vx cv cR wbr
      wi vy vw cv wral vx vw cv wrex wi vw cv vv cv csn wceq vv wex vw cv cA
      wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi
      vw cv cfn wcel vw cv vu cv csn cdif c0 wne vw cv vu cv csn cdif cA wss vx
      cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral vx vw cv
      vu cv csn cdif wrex wi wi vu vw cv wral vw cv c0 wne w3a vw cv vv cv csn
      wceq vv wex vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv
      wrex vw cv cA wss vw cv vv cv csn wceq vx cv vy cv wne vy cv vx cv cR wbr
      wi vy vw cv wral vx vw cv wrex vv vv cv vw cv wcel vv cv vy cv wne vy cv
      vv cv cR wbr wi vy vw cv wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw
      cv wral vx vw cv wrex vw cv vv cv csn wceq vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv wral vv cv vy cv wne vy cv vv cv cR wbr wi vy vw cv wral
      vx vv cv vw cv vx cv vv cv wceq vx cv vy cv wne vy cv vx cv cR wbr wi vv
      cv vy cv wne vy cv vv cv cR wbr wi vy vw cv vx cv vv cv wceq vx cv vy cv
      wne vv cv vy cv wne vy cv vx cv cR wbr vy cv vv cv cR wbr vx cv vv cv vy
      cv neeq1 vx cv vv cv vy cv cR breq2 imbi12d ralbidv rcla4ev vw cv vv cv
      csn wceq vv cv vw cv wcel vv cv vv cv wceq vv cv eqid vw cv vv cv csn
      wceq vv cv vw cv wcel vv cv vv cv csn wcel vv cv vv cv wceq vw cv vv cv
      csn vv cv eleq2 vv cv vv cv vv visset elsnc syl6bb mpbiri vw cv vv cv csn
      wceq vv cv vy cv wne vy cv vv cv cR wbr wi vy vw cv vw cv vv cv csn wceq
      vy cv vw cv wcel vy cv vv cv wceq vv cv vy cv wne vy cv vv cv cR wbr wi
      vw cv vv cv csn wceq vy cv vw cv wcel vy cv vv cv wceq vw cv vv cv csn
      wceq vy cv vw cv wcel vy cv vv cv csn wcel vy cv vv cv wceq vw cv vv cv
      csn vy cv eleq2 vy vv cv elsn syl6bb biimpd vy cv vv cv wceq vv cv vy cv
      wne wn vv cv vy cv wne vy cv vv cv cR wbr wi vy cv vv cv wceq vv cv vy cv
      wceq vv cv vy cv wne wn vy cv vv cv eqcom vv cv vy cv wne vv cv vy cv
      wceq vv cv vy cv df-ne con2bii bitri vv cv vy cv wne vy cv vv cv cR wbr
      pm2.21 sylbi syl6 r19.21aiv sylanc 19.23aiv a1d a1d 3expd vw cv vv cv csn
      wceq vv wex wn vw cv vu cv csn cdif c0 wne vw cv vu cv csn cdif cA wss vx
      cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral vx vw cv
      vu cv csn cdif wrex wi wi vu vw cv wral vw cv c0 wne vw cv cA wss vx cv
      vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi wi vw
      cv cfn wcel vw cv c0 wne vw cv vu cv csn cdif c0 wne vw cv vu cv csn cdif
      cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral
      vx vw cv vu cv csn cdif wrex wi wi vu vw cv wral vw cv vv cv csn wceq vv
      wex wn vw cv cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral
      vx vw cv wrex wi vw cv c0 wne vt cv vw cv wcel vt wex vw cv vu cv csn
      cdif c0 wne vw cv vu cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv vu cv csn cdif wral vx vw cv vu cv csn cdif wrex wi wi vu
      vw cv wral vw cv vv cv csn wceq vv wex wn vw cv cA wss vx cv vy cv wne vy
      cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi wi vt vw cv n0 vt cv
      vw cv wcel vw cv vu cv csn cdif c0 wne vw cv vu cv csn cdif cA wss vx cv
      vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif wral vx vw cv vu
      cv csn cdif wrex wi wi vu vw cv wral vw cv vv cv csn wceq vv wex wn vw cv
      cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex
      wi wi wi vt vt cv vw cv wcel vw cv vu cv csn cdif c0 wne vw cv vu cv csn
      cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif
      wral vx vw cv vu cv csn cdif wrex wi wi vu vw cv wral vw cv vt cv csn
      cdif c0 wne vw cv vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt cv csn cdif wrex wi wi vw
      cv vv cv csn wceq vv wex wn vw cv cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv wral vx vw cv wrex wi wi vw cv vu cv csn cdif c0 wne vw
      cv vu cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv
      vu cv csn cdif wral vx vw cv vu cv csn cdif wrex wi wi vw cv vt cv csn
      cdif c0 wne vw cv vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt cv csn cdif wrex wi wi vu
      vt cv vw cv vu cv vt cv wceq vw cv vu cv csn cdif c0 wne vw cv vt cv csn
      cdif c0 wne vw cv vu cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv vu cv csn cdif wral vx vw cv vu cv csn cdif wrex wi vw cv
      vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vt
      cv csn cdif wral vx vw cv vt cv csn cdif wrex wi vu cv vt cv wceq vw cv
      vu cv csn cdif vw cv vt cv csn cdif c0 vu cv vt cv wceq vu cv csn vt cv
      csn vw cv vu cv vt cv sneq difeq2d neeq1d vu cv vt cv wceq vw cv vu cv
      csn cdif cA wss vw cv vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv
      cR wbr wi vy vw cv vu cv csn cdif wral vx vw cv vu cv csn cdif wrex vx cv
      vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt
      cv csn cdif wrex vu cv vt cv wceq vw cv vu cv csn cdif vw cv vt cv csn
      cdif cA vu cv vt cv wceq vu cv csn vt cv csn vw cv vu cv vt cv sneq
      difeq2d sseq1d vu cv vt cv wceq vx cv vy cv wne vy cv vx cv cR wbr wi vy
      vw cv vu cv csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv
      vt cv csn cdif wral vx vw cv vu cv csn cdif vw cv vt cv csn cdif vu cv vt
      cv wceq vu cv csn vt cv csn vw cv vu cv vt cv sneq difeq2d vu cv vt cv
      wceq vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vu cv csn cdif vw cv
      vt cv csn cdif vu cv vt cv wceq vu cv csn vt cv csn vw cv vu cv vt cv
      sneq difeq2d raleq1d rexeq12d imbi12d imbi12d rcla4v vt cv vw cv wcel vw
      cv vv cv csn wceq vv wex wn vw cv vt cv csn cdif c0 wne vw cv vt cv csn
      cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif
      wral vx vw cv vt cv csn cdif wrex wi wi vw cv cA wss vx cv vy cv wne vy
      cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi vt cv vw cv wcel vw cv
      vv cv csn wceq vv wex wn vt cv csn vw cv wne vw cv vt cv csn cdif c0 wne
      vw cv vt cv csn cdif c0 wne vw cv vt cv csn cdif cA wss vx cv vy cv wne
      vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt cv csn
      cdif wrex wi wi vw cv cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw
      cv wral vx vw cv wrex wi wi vw cv vv cv csn wceq vv wex wn vt cv csn vw
      cv wne wi vt cv vw cv wcel vt cv csn vw cv wne vw cv vv cv csn wceq vv
      wex vt cv csn vw cv wne wn vt cv csn vw cv wceq vw cv vv cv csn wceq vv
      wex vt cv csn vw cv wne vt cv csn vw cv wceq vt cv csn vw cv df-ne
      con2bii vt cv csn vw cv wceq vw cv vt cv csn wceq vw cv vv cv csn wceq vv
      wex vt cv csn vw cv eqcom vw cv vv cv csn wceq vw cv vt cv csn wceq vv vt
      cv vt visset vv cv vt cv wceq vv cv csn vt cv csn vw cv vv cv vt cv sneq
      eqeq2d cla4ev sylbi sylbir con1i a1i vt cv vw cv wcel vt cv csn vw cv wss
      vt cv csn vw cv wne vw cv vt cv csn cdif c0 wne wi vt cv vw cv wcel vt cv
      csn vw cv wss vt cv vw cv vt visset snss biimpi vt cv csn vw cv wss vt cv
      csn vw cv wne vw cv vt cv csn cdif c0 wne vt cv csn vw cv pssdifn0 ex syl
      vw cv vt cv csn cdif c0 wne vw cv vt cv csn cdif c0 wne vw cv vt cv csn
      cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif
      wral vx vw cv vt cv csn cdif wrex wi wi vt cv vw cv wcel vw cv cA wss vx
      cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi vw cv
      vt cv csn cdif c0 wne vw cv vt cv csn cdif c0 wne vw cv vt cv csn cdif cA
      wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx
      vw cv vt cv csn cdif wrex wi wi vw cv vt cv csn cdif cA wss vx cv vy cv
      wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt cv csn
      cdif wrex wi vt cv vw cv wcel vw cv cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv wral vx vw cv wrex wi wi vw cv vt cv csn cdif c0 wne vw
      cv vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv
      vt cv csn cdif wral vx vw cv vt cv csn cdif wrex wi pm2.27 vw cv cA wss
      vw cv vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw
      cv vt cv csn cdif wral vx vw cv vt cv csn cdif wrex wi vt cv vw cv wcel
      vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex vw cv
      cA wss vw cv vt cv csn cdif cA wss vw cv vt cv csn cdif cA wss vx cv vy
      cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt cv
      csn cdif wrex wi vt cv vw cv wcel vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vw cv wral vx vw cv wrex wi wi vw cv vt cv csn cdif vw cv wss vw cv cA
      wss vw cv vt cv csn cdif cA wss vw cv vt cv csn difss vw cv vt cv csn
      cdif vw cv cA sstr mpan vw cv vt cv csn cdif cA wss vw cv vt cv csn cdif
      cA wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral
      vx vw cv vt cv csn cdif wrex wi vw cv cA wss vt cv vw cv wcel vx cv vy cv
      wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi vw cv vt cv csn
      cdif cA wss vw cv vt cv csn cdif cA wss vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt cv csn cdif wrex wi vx cv
      vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx vw cv vt
      cv csn cdif wrex vw cv cA wss vt cv vw cv wcel vx cv vy cv wne vy cv vx
      cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi vw cv vt cv csn cdif cA
      wss vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv vt cv csn cdif wral vx
      vw cv vt cv csn cdif wrex pm2.27 vx cv vy cv wne vy cv vx cv cR wbr wi vy
      vw cv vt cv csn cdif wral vx vw cv vt cv csn cdif wrex vs cv vy cv wne vy
      cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vs vw cv vt cv csn cdif
      wrex vw cv cA wss vt cv vw cv wcel vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vw cv wral vx vw cv wrex wi wi vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vw cv vt cv csn cdif wral vs cv vy cv wne vy cv vs cv cR wbr wi vy vw
      cv vt cv csn cdif wral vx vs vw cv vt cv csn cdif vx cv vs cv wceq vx cv
      vy cv wne vy cv vx cv cR wbr wi vs cv vy cv wne vy cv vs cv cR wbr wi vy
      vw cv vt cv csn cdif vx cv vs cv wceq vx cv vy cv wne vs cv vy cv wne vy
      cv vx cv cR wbr vy cv vs cv cR wbr vx cv vs cv vy cv neeq1 vx cv vs cv vy
      cv cR breq2 imbi12d ralbidv cbvrexv vs cv vy cv wne vy cv vs cv cR wbr wi
      vy vw cv vt cv csn cdif wral vw cv cA wss vt cv vw cv wcel vx cv vy cv
      wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi vs vw cv vt
      cv csn cdif vw cv cA wss vt cv vw cv wcel vs cv vw cv vt cv csn cdif wcel
      vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv
      vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex vw cv cA wss
      vt cv vw cv wcel vs cv vw cv vt cv csn cdif wcel vs cv vy cv wne vy cv vs
      cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv wral vx vw cv wrex wi vw cv cA wss vt cv vw cv wcel vs cv
      vw cv vt cv csn cdif wcel wa vt cv cA wcel vs cv cA wcel wa vs cv vy cv
      wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy
      cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi vw cv cA wss vt cv vw
      cv wcel vt cv cA wcel vs cv vw cv vt cv csn cdif wcel vs cv cA wcel vw cv
      cA vt cv ssel vw cv cA wss vw cv vt cv csn cdif cA wss vs cv vw cv vt cv
      csn cdif wcel vs cv cA wcel wi vw cv vt cv csn cdif vw cv wss vw cv cA
      wss vw cv vt cv csn cdif cA wss vw cv vt cv csn difss vw cv vt cv csn
      cdif vw cv cA sstr mpan vw cv vt cv csn cdif cA vs cv ssel syl anim12d vt
      cv cA wcel vs cv cA wcel wa vt cv vw cv wcel vs cv vw cv vt cv csn cdif
      wcel wa vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv
      csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw
      cv wrex wi vt cv cA wcel vs cv cA wcel wa vt cv vs cv wceq vt cv vs cv cR
      wbr vs cv vt cv cR wbr wo wn wb vt cv vw cv wcel vs cv vw cv vt cv csn
      cdif wcel wa vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv
      vt cv csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral
      vx vw cv wrex wi wi wi cA cR wor vt cv cA wcel vs cv cA wcel wa vt cv vs
      cv wceq vt cv vs cv cR wbr vs cv vt cv cR wbr wo wn wb fimax.1 cA vt cv
      vs cv cR sotrieq mpan vt cv vs cv wceq vt cv vs cv cR wbr vs cv vt cv cR
      wbr wo wn wb vt cv vw cv wcel vs cv vw cv vt cv csn cdif wcel vw cv cA
      wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vx
      cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi vs
      cv vw cv vt cv csn cdif wcel vt cv vs cv wceq vt cv vs cv cR wbr vs cv vt
      cv cR wbr wo wn wb vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs
      cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv wral vx vw cv wrex wi wi vs cv vw cv vt cv csn cdif wcel
      vt cv vs cv wceq wn vt cv vs cv wceq vt cv vs cv cR wbr vs cv vt cv cR
      wbr wo wn wb vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR
      wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vw cv wral vx vw cv wrex wi wi wi wi vs cv vw cv vt cv csn cdif wcel
      vs cv vt cv csn wcel wn vt cv vs cv wceq wn vs cv vw cv vt cv csn cdif
      wcel vs cv vw cv wcel vs cv vt cv csn wcel wn vs cv vw cv vt cv csn cdif
      wcel vs cv vw cv wcel vs cv vt cv csn wcel wn wa vs cv vw cv vt cv csn
      eldif biimpi pm3.27d vs cv vt cv csn wcel vt cv vs cv wceq vs cv vt cv
      csn wcel vs cv vt cv wceq vt cv vs cv wceq vs vt cv elsn vs cv vt cv
      eqcom bitri notbii sylib vt cv vs cv wceq vt cv vs cv cR wbr vs cv vt cv
      cR wbr wo wn wb vt cv vs cv wceq wn vs cv vw cv vt cv csn cdif wcel vt cv
      vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt
      cv csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx
      vw cv wrex wi wi wi vt cv vs cv wceq vt cv vs cv cR wbr vs cv vt cv cR
      wbr wo wn wb vt cv vs cv wceq wn vt cv vs cv cR wbr vs cv vt cv cR wbr wo
      wi vt cv vs cv wceq wn vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel
      vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn
      cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv
      wrex wi wi wi wi wi vt cv vs cv wceq vt cv vs cv cR wbr vs cv vt cv cR
      wbr wo wn wb vt cv vs cv cR wbr vs cv vt cv cR wbr wo vt cv vs cv wceq wn
      wb vt cv vs cv wceq wn vt cv vs cv cR wbr vs cv vt cv cR wbr wo wi vt cv
      vs cv wceq vt cv vs cv cR wbr vs cv vt cv cR wbr wo wn wb vt cv vs cv cR
      wbr vs cv vt cv cR wbr wo vt cv vs cv wceq wn wb vt cv vs cv wceq vt cv
      vs cv cR wbr vs cv vt cv cR wbr wo con2bi biimpi vt cv vs cv cR wbr vs cv
      vt cv cR wbr wo vt cv vs cv wceq wn bi2 syl vt cv vs cv wceq wn vt cv vs
      cv wceq wn vt cv vs cv cR wbr vs cv vt cv cR wbr wo wi vs cv vw cv vt cv
      csn cdif wcel vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv
      cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr
      wi vy vw cv wral vx vw cv wrex wi wi wi wi vt cv vs cv wceq wn vt cv vs
      cv wceq wn vt cv vs cv cR wbr vs cv vt cv cR wbr wo wi vt cv vs cv cR wbr
      vs cv vt cv cR wbr wo vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel vw
      cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif
      wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi
      wi wi wi vt cv vs cv wceq wn vt cv vs cv cR wbr vs cv vt cv cR wbr wo
      pm2.27 vt cv vs cv cR wbr vs cv vw cv vt cv csn cdif wcel vt cv vw cv
      wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv
      csn cdif wral vx cv vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw
      cv wrex wi wi wi wi vs cv vt cv cR wbr vt cv vs cv cR wbr vs cv vw cv vt
      cv csn cdif wcel vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs
      cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy cv vx cv cR
      wbr wi vy vw cv wral vx vw cv wrex wi wi vt cv vs cv cR wbr vs cv vw cv
      vt cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy
      cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy cv vx
      cv cR wbr wi vy vw cv wral vx vw cv wrex vs cv vw cv wcel vs cv vy cv wne
      vy cv vs cv cR wbr wi vy vw cv wral vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vw cv wral vx vw cv wrex vt cv vs cv cR wbr vs cv vw cv vt cv csn cdif
      wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr
      wi vy vw cv vt cv csn cdif wral w3a vx cv vy cv wne vy cv vx cv cR wbr wi
      vy vw cv wral vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv wral vx vs
      cv vw cv vx cv vs cv wceq vx cv vy cv wne vy cv vx cv cR wbr wi vs cv vy
      cv wne vy cv vs cv cR wbr wi vy vw cv vx cv vs cv wceq vx cv vy cv wne vs
      cv vy cv wne vy cv vx cv cR wbr vy cv vs cv cR wbr vx cv vs cv vy cv
      neeq1 vx cv vs cv vy cv cR breq2 imbi12d ralbidv rcla4ev vt cv vs cv cR
      wbr vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs
      cv vw cv wcel vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn
      cdif wral vs cv vw cv vt cv csn cdif wcel vt cv vs cv cR wbr vs cv vw cv
      wcel vt cv vw cv wcel vs cv vw cv vt cv csn eldifi 3ad2ant2 3ad2ant1 vt
      cv vs cv cR wbr vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel w3a vw
      cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif
      wral w3a vs cv vu cv wne vu cv vs cv cR wbr wi vu vw cv wral vs cv vy cv
      wne vy cv vs cv cR wbr wi vy vw cv wral vt cv vs cv cR wbr vs cv vw cv vt
      cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy cv
      vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vs cv vu cv wne vu cv vs
      cv cR wbr wi vu vw cv vu cv vt cv wceq vt cv vs cv cR wbr vs cv vw cv vt
      cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy cv
      vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vu cv vw cv wcel vs cv
      vu cv wne vu cv vs cv cR wbr wi wi wi vt cv vs cv cR wbr vs cv vw cv vt
      cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy cv
      vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vu cv vt cv wceq vu cv
      vw cv wcel vs cv vu cv wne vu cv vs cv cR wbr wi wi vt cv vs cv cR wbr vs
      cv vw cv vt cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vu cv vt
      cv wceq vu cv vw cv wcel vs cv vu cv wne vu cv vs cv cR wbr wi wi wi vs
      cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vt cv vs
      cv cR wbr vs cv vw cv vt cv csn cdif wcel vu cv vt cv wceq vu cv vw cv
      wcel vs cv vu cv wne vu cv vs cv cR wbr wi wi wi vt cv vw cv wcel vt cv
      vs cv cR wbr vu cv vt cv wceq vs cv vu cv wne vu cv vs cv cR wbr wi vu cv
      vw cv wcel vt cv vs cv cR wbr vu cv vt cv wceq vu cv vs cv cR wbr vs cv
      vu cv wne vu cv vt cv wceq vt cv vs cv cR wbr vu cv vs cv cR wbr vu cv vt
      cv wceq vu cv vs cv cR wbr vt cv vs cv cR wbr vu cv vt cv vs cv cR breq1
      biimprd com12 a1dd a1dd 3ad2ant1 3ad2ant1 com12 vu cv vt cv wceq wn vu cv
      vt cv wne vt cv vs cv cR wbr vs cv vw cv vt cv csn cdif wcel vt cv vw cv
      wcel w3a vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt
      cv csn cdif wral w3a vu cv vw cv wcel vs cv vu cv wne vu cv vs cv cR wbr
      wi wi wi vu cv vt cv df-ne vu cv vw cv wcel vu cv vt cv wne vt cv vs cv
      cR wbr vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss
      vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vs
      cv vu cv wne vu cv vs cv cR wbr wi vu cv vw cv wcel vu cv vt cv wne vt cv
      vs cv cR wbr vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel w3a vw cv
      cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral
      w3a vs cv vu cv wne vu cv vs cv cR wbr wi wi vu cv vw cv wcel vu cv vt cv
      wne wa vu cv vw cv vt cv csn cdif wcel vt cv vs cv cR wbr vs cv vw cv vt
      cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy cv
      vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vs cv vu cv wne vu cv vs
      cv cR wbr wi wi vu cv vw cv vt cv eldifsn vt cv vs cv cR wbr vs cv vw cv
      vt cv csn cdif wcel vt cv vw cv wcel w3a vw cv cA wss vs cv vy cv wne vy
      cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vu cv vw cv vt cv csn
      cdif wcel vs cv vu cv wne vu cv vs cv cR wbr wi vs cv vy cv wne vy cv vs
      cv cR wbr wi vy vw cv vt cv csn cdif wral vt cv vs cv cR wbr vs cv vw cv
      vt cv csn cdif wcel vt cv vw cv wcel w3a vu cv vw cv vt cv csn cdif wcel
      vs cv vu cv wne vu cv vs cv cR wbr wi wi vw cv cA wss vs cv vy cv wne vy
      cv vs cv cR wbr wi vs cv vu cv wne vu cv vs cv cR wbr wi vy vu cv vw cv
      vt cv csn cdif vy cv vu cv wceq vs cv vy cv wne vs cv vu cv wne vy cv vs
      cv cR wbr vu cv vs cv cR wbr vy cv vu cv vs cv neeq2 vy cv vu cv vs cv cR
      breq1 imbi12d rcla4cv 3ad2ant3 com12 sylbir ex com3l sylbir pm2.61i
      r19.21aiv vs cv vu cv wne vu cv vs cv cR wbr wi vs cv vy cv wne vy cv vs
      cv cR wbr wi vu vy vw cv vu cv vy cv wceq vs cv vu cv wne vs cv vy cv wne
      vu cv vs cv cR wbr vy cv vs cv cR wbr vu cv vy cv vs cv neeq2 vu cv vy cv
      vs cv cR breq1 imbi12d cbvralv sylib sylanc 3exp 3exp vs cv vt cv cR wbr
      vs cv vw cv vt cv csn cdif wcel vt cv vw cv wcel vw cv cA wss vs cv vy cv
      wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy cv wne vy
      cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex wi wi wi vs cv vt cv cR
      wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss vs
      cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vx cv vy
      cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex vs cv vt cv cR
      wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss vs
      cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a vx cv
      vy cv wne vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex vt cv vw cv
      wcel vt cv vy cv wne vy cv vt cv cR wbr wi vy vw cv wral vx cv vy cv wne
      vy cv vx cv cR wbr wi vy vw cv wral vx vw cv wrex vs cv vt cv cR wbr vs
      cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss vs cv vy cv
      wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a wa vx cv vy cv
      wne vy cv vx cv cR wbr wi vy vw cv wral vt cv vy cv wne vy cv vt cv cR
      wbr wi vy vw cv wral vx vt cv vw cv vx cv vt cv wceq vx cv vy cv wne vy
      cv vx cv cR wbr wi vt cv vy cv wne vy cv vt cv cR wbr wi vy vw cv vx cv
      vt cv wceq vx cv vy cv wne vt cv vy cv wne vy cv vx cv cR wbr vy cv vt cv
      cR wbr vx cv vt cv vy cv neeq1 vx cv vt cv vy cv cR breq2 imbi12d ralbidv
      rcla4ev vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr
      wi vy vw cv vt cv csn cdif wral w3a vt cv vw cv wcel vs cv vt cv cR wbr
      vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss vs cv vy
      cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral 3simp1 adantl
      vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw
      cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw cv vt cv csn cdif
      wral w3a wa vt cv vu cv wne vu cv vt cv cR wbr wi vu vw cv wral vt cv vy
      cv wne vy cv vt cv cR wbr wi vy vw cv wral vs cv vt cv cR wbr vs cv vw cv
      vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy
      cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral w3a wa vt cv vu cv wne vu
      cv vt cv cR wbr wi vu vw cv vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif
      wcel wa vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr
      wi vy vw cv vt cv csn cdif wral w3a wa vu cv vw cv wcel vt cv vu cv wne
      vu cv vt cv cR wbr vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa
      vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR wbr wi vy vw
      cv vt cv csn cdif wral w3a wa vu cv vw cv vt cv csn cdif wcel vu cv vt cv
      cR wbr vu cv vw cv wcel vt cv vu cv wne wa vs cv vt cv cR wbr vs cv vw cv
      vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy
      cv vs cv cR wbr wi vy vw cv vt cv csn cdif wral vu cv vw cv vt cv csn
      cdif wcel vu cv vt cv cR wbr wi vs cv vt cv cR wbr vs cv vw cv vt cv csn
      cdif wcel wa vt cv vw cv wcel vw cv cA wss vs cv vy cv wne vy cv vs cv cR
      wbr wi vy vw cv vt cv csn cdif wral vu cv vw cv vt cv csn cdif wcel vu cv
      vt cv cR wbr wi wi vu cv vw cv vt cv csn cdif wcel vs cv vy cv wne vy cv
      vs cv cR wbr wi vy vw cv vt cv csn cdif wral vs cv vt cv cR wbr vs cv vw
      cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss w3a vu cv vt cv
      cR wbr vu cv vw cv vt cv csn cdif wcel vs cv vy cv wne vy cv vs cv cR wbr
      wi vy vw cv vt cv csn cdif wral vs cv vu cv wne vu cv vs cv cR wbr wi vs
      cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv
      cA wss w3a vu cv vt cv cR wbr wi vs cv vy cv wne vy cv vs cv cR wbr wi vs
      cv vu cv wne vu cv vs cv cR wbr wi vy vu cv vw cv vt cv csn cdif vy cv vu
      cv wceq vs cv vy cv wne vs cv vu cv wne vy cv vs cv cR wbr vu cv vs cv cR
      wbr vy cv vu cv vs cv neeq2 vy cv vu cv vs cv cR breq1 imbi12d rcla4v vs
      cv vu cv wceq vu cv vw cv vt cv csn cdif wcel vs cv vu cv wne vu cv vs cv
      cR wbr wi vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw
      cv wcel vw cv cA wss w3a vu cv vt cv cR wbr wi wi wi vs cv vu cv wceq vs
      cv vu cv wne vu cv vs cv cR wbr wi vs cv vt cv cR wbr vs cv vw cv vt cv
      csn cdif wcel wa vt cv vw cv wcel vw cv cA wss w3a vu cv vt cv cR wbr wi
      wi vu cv vw cv vt cv csn cdif wcel vs cv vu cv wceq vs cv vt cv cR wbr vs
      cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss w3a vu cv
      vt cv cR wbr wi vs cv vu cv wne vu cv vs cv cR wbr wi vs cv vu cv wceq vs
      cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv
      cA wss w3a vu cv vt cv cR wbr vs cv vu cv wceq vt cv vw cv wcel vs cv vt
      cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vu cv vt cv cR wbr vw cv cA
      wss vs cv vu cv wceq vs cv vt cv cR wbr vu cv vt cv cR wbr vs cv vw cv vt
      cv csn cdif wcel vs cv vu cv wceq vs cv vt cv cR wbr vu cv vt cv cR wbr
      vs cv vu cv wceq vs cv vt cv cR wbr vu cv vt cv cR wbr vs cv vu cv vt cv
      cR breq1 biimpd imp adantrr 3ad2antr1 ex a1d a1d vs cv vu cv wceq wn vs
      cv vu cv wne vu cv vw cv vt cv csn cdif wcel vs cv vu cv wne vu cv vs cv
      cR wbr wi vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw
      cv wcel vw cv cA wss w3a vu cv vt cv cR wbr wi wi wi vs cv vu cv df-ne vs
      cv vu cv wne vs cv vu cv wne vu cv vs cv cR wbr wi vu cv vw cv vt cv csn
      cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw
      cv wcel vw cv cA wss w3a vu cv vt cv cR wbr wi vs cv vu cv wne vs cv vu
      cv wne vu cv vs cv cR wbr wi vu cv vs cv cR wbr vu cv vw cv vt cv csn
      cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw
      cv wcel vw cv cA wss w3a vu cv vt cv cR wbr wi wi vs cv vu cv wne vu cv
      vs cv cR wbr pm2.27 vu cv vs cv cR wbr vu cv vw cv vt cv csn cdif wcel vs
      cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv
      cA wss w3a vu cv vt cv cR wbr vu cv vs cv cR wbr vu cv vw cv vt cv csn
      cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw
      cv wcel vw cv cA wss w3a w3a vu cv vs cv cR wbr vs cv vt cv cR wbr vu cv
      vt cv cR wbr vu cv vs cv cR wbr vu cv vw cv vt cv csn cdif wcel vs cv vt
      cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA
      wss w3a 3simp1 vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt
      cv vw cv wcel vw cv cA wss w3a vu cv vs cv cR wbr vs cv vt cv cR wbr vu
      cv vw cv vt cv csn cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn
      cdif wcel wa vt cv vw cv wcel vs cv vt cv cR wbr vw cv cA wss vs cv vt cv
      cR wbr vs cv vw cv vt cv csn cdif wcel pm3.26 3ad2ant1 3ad2ant3 cA cR wor
      vu cv cA wcel vs cv cA wcel vt cv cA wcel w3a vu cv vs cv cR wbr vs cv vt
      cv cR wbr wa vu cv vt cv cR wbr wi vu cv vs cv cR wbr vu cv vw cv vt cv
      csn cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv
      vw cv wcel vw cv cA wss w3a w3a cA vu cv vs cv vt cv cR sotr cA cR wor vu
      cv vs cv cR wbr vu cv vw cv vt cv csn cdif wcel vs cv vt cv cR wbr vs cv
      vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss w3a w3a
      fimax.1 a1i vu cv vs cv cR wbr vu cv vw cv vt cv csn cdif wcel vs cv vt
      cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA
      wss w3a w3a vu cv cA wcel vs cv cA wcel vt cv cA wcel vu cv vw cv vt cv
      csn cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa vt cv
      vw cv wcel vw cv cA wss w3a vu cv cA wcel vu cv vs cv cR wbr vu cv vw cv
      vt cv csn cdif wcel vs cv vt cv cR wbr vs cv vw cv vt cv csn cdif wcel wa
      vw cv cA wss vu cv cA wcel vt cv vw cv wcel vw cv cA wss vu cv vw cv vt
      cv csn cdif wcel vu cv cA wcel vw cv cA wss vw cv vt cv csn cdif cA wss
      vu cv vw cv vt cv csn cdif wcel vu cv cA wcel wi vw cv vt cv csn cdif vw
      cv wss vw cv cA wss vw cv vt cv csn cdif cA wss vw cv vt cv csn difss vw
      cv vt cv csn cdif vw cv cA sstr mpan vw cv vt cv csn cdif cA vu cv ssel
      syl impcom 3ad2antr3 3adant1 vs cv vt cv cR wbr vs cv vw cv vt cv csn
      cdif wcel wa vt cv vw cv wcel vw cv cA wss w3a vu cv vs cv cR wbr vs cv
      cA wcel vu cv vw cv vt cv csn cdif wcel vs cv vt cv cR wbr vs cv vw cv vt
      cv csn cdif wcel wa vw cv cA wss vs cv cA wcel vt cv vw cv wcel vs cv vw
      cv vt cv csn cdif wcel vw cv cA wss vs cv cA wcel vs cv vt cv cR wbr vw
      cv cA wss vs cv vw cv vt cv csn cdif wcel vs cv cA wcel vw cv cA wss vw
      cv vt cv csn cdif cA wss vs cv vw cv vt cv csn cdif wcel vs cv cA wcel wi
      vw cv vt cv csn cdif vw cv wss vw cv cA wss vw cv vt cv csn cdif cA wss
      vw cv vt cv csn difss vw cv vt cv csn cdif vw cv cA sstr mpan vw cv vt cv
      csn cdif cA vs cv ssel syl impcom adantll 3adant2 3ad2ant3 vs cv vt cv cR
      wbr vs cv vw cv vt cv csn cdif wcel wa vt cv vw cv wcel vw cv cA wss w3a
      vu cv vs cv cR wbr vt cv cA wcel vu cv vw cv vt cv csn cdif wcel vt cv vw
      cv wcel vw cv cA wss vt cv cA wcel vs cv vt cv cR wbr vs cv vw cv vt cv
      csn cdif wcel wa vw cv cA wss vt cv vw cv wcel vt cv cA wcel vw cv cA vt
      cv ssel impcom 3adant1 3ad2ant3 3jca sylanc mp2and 3exp syl6 com23 sylbir
      pm2.61i syld com13 3exp 3imp2 vu cv vw cv vt cv csn cdif wcel vu cv vw cv
      wcel vu cv vt cv wne wa vu cv vw cv wcel vt cv vu cv wne wa vu cv vw cv
      vt cv eldifsn vu cv vt cv wne vt cv vu cv wne vu cv vw cv wcel vu cv vt
      cv necom anbi2i bitri syl5ibr exp3a r19.21aiv vt cv vu cv wne vu cv vt cv
      cR wbr wi vt cv vy cv wne vy cv vt cv cR wbr wi vu vy vw cv vu cv vy cv
      wceq vt cv vu cv wne vt cv vy cv wne vu cv vt cv cR wbr vy cv vt cv cR
      wbr vu cv vy cv vt cv neeq2 vu cv vy cv vt cv cR breq1 imbi12d cbvralv
      sylib sylanc ex 3expd ex jaoi syl6 com12 syl com13 mpd com3l imp3a syl
      com13 mpdd exp3a com4t r19.23aiv sylbi syl6 com3r mpd com3l syl6 com3r
      3syld com23 syld 19.23aiv sylbi com13 a1d pm2.61i findcard imp mpi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d R x y $. $d A x y $.
    $( A finite set has a maximum under a total order. $)
    fimaxg $p |- ( ( R Or A /\ A e. Fin /\ A =/= (/) ) ->
                            E. x e. A A. y e. A ( x =/= y -> y R x ) ) $=
      cA cR wor cA cfn wcel cA c0 wne vx cv vy cv wne vy cv vx cv cR wbr wi vy
      cA wral vx cA wrex cA cR wor cA cfn wcel cA c0 wne wa vx cv vy cv wne vy
      cv vx cv cR wbr wi vy cA wral vx cA wrex wi cA cR wor cA c0 cif cfn wcel
      cA cR wor cA c0 cif c0 wne wa vx cv vy cv wne vy cv vx cv cR wbr wi vy cA
      cR wor cA c0 cif wral vx cA cR wor cA c0 cif wrex wi cA c0 cA cA cR wor
      cA c0 cif wceq cA cfn wcel cA c0 wne wa cA cR wor cA c0 cif cfn wcel cA
      cR wor cA c0 cif c0 wne wa vx cv vy cv wne vy cv vx cv cR wbr wi vy cA
      wral vx cA wrex vx cv vy cv wne vy cv vx cv cR wbr wi vy cA cR wor cA c0
      cif wral vx cA cR wor cA c0 cif wrex cA cA cR wor cA c0 cif wceq cA cfn
      wcel cA cR wor cA c0 cif cfn wcel cA c0 wne cA cR wor cA c0 cif c0 wne cA
      cA cR wor cA c0 cif cfn eleq1 cA cA cR wor cA c0 cif c0 neeq1 anbi12d vx
      cv vy cv wne vy cv vx cv cR wbr wi vy cA wral vx cv vy cv wne vy cv vx cv
      cR wbr wi vy cA cR wor cA c0 cif wral vx cA cA cR wor cA c0 cif vx cv vy
      cv wne vy cv vx cv cR wbr wi vy cA cA cR wor cA c0 cif raleq1 rexeqd
      imbi12d vx vy cA cR wor cA c0 cif cR cA cR wor cA cR wor cA c0 cif cR wor
      c0 cR wor cA c0 cA cA cR wor cA c0 cif cR soeq2 c0 cA cR wor cA c0 cif cR
      soeq2 cR so0 elimhyp fimax dedth 3impib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d R x y z $. $d A x y z $.
    $( Lemma showing existence and closure of supremum of a finite set. $)
    fisupg $p |- ( ( R Or A /\ A e. Fin /\ A =/= (/) ) -> E. x e. A ( A. y e. A
            -. x R y /\ A. y e. A ( y R x -> E. z e. A y R z ) ) ) $=
      cA cR wor cA cfn wcel cA c0 wne w3a vx cv vy cv wne vy cv vx cv cR wbr wi
      vy cA wral vx cA wrex vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr
      vy cv vz cv cR wbr vz cA wrex wi vy cA wral wa vx cA wrex vx vy cA cR
      fimaxg cA cR wor cA cfn wcel vx cv vy cv wne vy cv vx cv cR wbr wi vy cA
      wral vx cA wrex vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cA wrex wi vy cA wral wa vx cA wrex wi cA c0 wne cA cR
      wor vx cv vy cv wne vy cv vx cv cR wbr wi vy cA wral vx cv vy cv cR wbr
      wn vy cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cA
      wral wa vx cA cA cR wor vx cv cA wcel wa vx cv vy cv wne vy cv vx cv cR
      wbr wi vy cA wral vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cA wrex wi vy cA wral cA cR wor vx cv cA wcel wa vx cv
      vy cv wne vy cv vx cv cR wbr wi vx cv vy cv cR wbr wn vy cA cA cR wor vx
      cv cA wcel wa vy cv cA wcel wa vx cv vy cv wne vy cv vx cv cR wbr wi vx
      cv vy cv cR wbr wn wi vx cv vy cv cA cR wor vx cv cA wcel wa vy cv cA
      wcel wa vx cv vy cv wceq vx cv vy cv cR wbr wn vx cv vy cv wne vy cv vx
      cv cR wbr wi cA cR wor vx cv cA wcel vy cv cA wcel vx cv vy cv wceq vx cv
      vy cv cR wbr wn wi cA cR wor vx cv cA wcel vy cv cA wcel wa wa vx cv vy
      cv wceq vx cv vy cv cR wbr wn cA cR wor vx cv cA wcel vy cv cA wcel wa wa
      vx cv vy cv wceq vx cv vy cv cR wbr wn vy cv vx cv cR wbr wn cA vx cv vy
      cv cR sotrieq2 pm3.26bda ex anassrs a1dd vx cv vy cv wne vx cv vy cv wne
      vy cv vx cv cR wbr wi vy cv vx cv cR wbr cA cR wor vx cv cA wcel wa vy cv
      cA wcel wa vx cv vy cv cR wbr wn vx cv vy cv wne vy cv vx cv cR wbr
      pm2.27 cA cR wor vx cv cA wcel vy cv cA wcel vy cv vx cv cR wbr vx cv vy
      cv cR wbr wn wi vy cv vx cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR wbr
      wa wn vx cv vy cv cR wbr wn cA cR wor vx cv cA wcel vy cv cA wcel wa wa
      vy cv vx cv cR wbr vx cv vy cv cR wbr vx cv vy cv cR wbr vy cv vx cv cR
      wbr wa vy cv vx cv cR wbr vx cv vy cv cR wbr pm3.21 con3d cA vx cv vy cv
      cR so2nr syl5com anassrs syl9r pm2.61dne r19.20dva vx cv cA wcel vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cA wral cA cR wor vx cv cA
      wcel vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cA vx cv cA
      wcel vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cv cA wcel vx
      cv cA wcel vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex vy cv vz cv
      cR wbr vy cv vx cv cR wbr vz vx cv cA vz cv vx cv vy cv cR breq2 rcla4ev
      ex adantr r19.21aiva adantl jctird r19.22dva 3ad2ant1 mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A w x y z $. $d B w x y z $.
    $( The Cartesian product of two finite sets is finite. $)
    fixp $p |- ( ( A e. Fin /\ B e. Fin ) -> ( A X. B ) e. Fin ) $=
      cA cfn wcel cB cfn wcel cA cB cxp cfn wcel cB cfn wcel vx cv cB cxp cfn
      wcel wi cB cfn wcel c0 cB cxp cfn wcel wi cB cfn wcel vy cv vz cv csn
      cdif cB cxp cfn wcel wi cB cfn wcel vy cv cB cxp cfn wcel wi cB cfn wcel
      cA cB cxp cfn wcel wi vx vy vz cA vx cv c0 wceq vx cv cB cxp cfn wcel c0
      cB cxp cfn wcel cB cfn wcel vx cv c0 wceq vx cv cB cxp c0 cB cxp cfn vx
      cv c0 cB xpeq1 eleq1d imbi2d vx cv vy cv vz cv csn cdif wceq vx cv cB cxp
      cfn wcel vy cv vz cv csn cdif cB cxp cfn wcel cB cfn wcel vx cv vy cv vz
      cv csn cdif wceq vx cv cB cxp vy cv vz cv csn cdif cB cxp cfn vx cv vy cv
      vz cv csn cdif cB xpeq1 eleq1d imbi2d vx cv vy cv wceq vx cv cB cxp cfn
      wcel vy cv cB cxp cfn wcel cB cfn wcel vx cv vy cv wceq vx cv cB cxp vy
      cv cB cxp cfn vx cv vy cv cB xpeq1 eleq1d imbi2d vx cv cA wceq vx cv cB
      cxp cfn wcel cA cB cxp cfn wcel cB cfn wcel vx cv cA wceq vx cv cB cxp cA
      cB cxp cfn vx cv cA cB xpeq1 eleq1d imbi2d c0 cB cxp cfn wcel cB cfn wcel
      c0 cB cxp c0 cfn cB xp0r emfin eqeltri a1i vy cv cfn wcel cB cfn wcel cB
      cfn wcel vy cv vz cv csn cdif cB cxp cfn wcel wi vz vy cv wral vy cv cB
      cxp cfn wcel vy cv cfn wcel cB cfn wcel cB cfn wcel vy cv vz cv csn cdif
      cB cxp cfn wcel wi vz vy cv wral vy cv cB cxp cfn wcel wi vy cv cfn wcel
      cB cfn wcel wa vy cv c0 wceq cB cfn wcel vy cv vz cv csn cdif cB cxp cfn
      wcel wi vz vy cv wral vy cv cB cxp cfn wcel wi vy cv cfn wcel cB cfn wcel
      wa vw cv vy cv wcel vw wex cB cfn wcel vy cv vz cv csn cdif cB cxp cfn
      wcel wi vz vy cv wral vy cv cB cxp cfn wcel wi vy cv c0 wceq wn vy cv cfn
      wcel cB cfn wcel wa vw cv vy cv wcel cB cfn wcel vy cv vz cv csn cdif cB
      cxp cfn wcel wi vz vy cv wral vy cv cB cxp cfn wcel wi vw vy cv cfn wcel
      cB cfn wcel wa vw cv vy cv wcel cB cfn wcel vy cv vz cv csn cdif cB cxp
      cfn wcel wi vz vy cv wral vy cv cB cxp cfn wcel wi vy cv cfn wcel cB cfn
      wcel wa vw cv vy cv wcel wa cB cfn wcel vy cv vz cv csn cdif cB cxp cfn
      wcel wi vz vy cv wral cB cfn wcel vy cv vw cv csn cdif cB cxp cfn wcel wi
      vy cv vw cv csn cdif cB cxp cfn wcel vy cv cB cxp cfn wcel vw cv vy cv
      wcel cB cfn wcel vy cv vz cv csn cdif cB cxp cfn wcel wi vz vy cv wral cB
      cfn wcel vy cv vw cv csn cdif cB cxp cfn wcel wi wi vy cv cfn wcel cB cfn
      wcel wa cB cfn wcel vy cv vz cv csn cdif cB cxp cfn wcel wi cB cfn wcel
      vy cv vw cv csn cdif cB cxp cfn wcel wi vz vw cv vy cv vz cv vw cv wceq
      vy cv vz cv csn cdif cB cxp cfn wcel vy cv vw cv csn cdif cB cxp cfn wcel
      cB cfn wcel vz cv vw cv wceq vy cv vz cv csn cdif cB cxp vy cv vw cv csn
      cdif cB cxp cfn vz cv vw cv wceq vy cv vz cv csn cdif vy cv vw cv csn
      cdif wceq vy cv vz cv csn cdif cB cxp vy cv vw cv csn cdif cB cxp wceq vz
      cv vw cv wceq vz cv csn vw cv csn vy cv vz cv vw cv sneq difeq2d vy cv vz
      cv csn cdif vy cv vw cv csn cdif cB xpeq1 syl eleq1d imbi2d rcla4v adantl
      cB cfn wcel cB cfn wcel vy cv vw cv csn cdif cB cxp cfn wcel wi vy cv vw
      cv csn cdif cB cxp cfn wcel wi vy cv cfn wcel vw cv vy cv wcel cB cfn
      wcel vy cv vw cv csn cdif cB cxp cfn wcel pm2.27 ad2antlr vy cv cfn wcel
      cB cfn wcel wa vw cv vy cv wcel wa vy cv vw cv csn cdif cB cxp cfn wcel
      vw cv csn cB cxp cfn wcel vy cv cB cxp cfn wcel cB cfn wcel vw cv csn cB
      cxp cfn wcel vy cv cfn wcel vw cv vy cv wcel cB cfn wcel vw cv csn cB cxp
      cfn wcel cB cfn wcel vw cv csn cB cxp cB cen wbr vw cv csn cB cxp cfn
      wcel cB cfn wcel wb vw cv csn cB cxp cvv wcel vw cv csn cB cxp cB c2nd vw
      cv csn cB cxp cres wf1o vw cv csn cB cxp cB cen wbr cB cfn wcel vw cv csn
      cB cxp cB cvv c2nd vw cv csn cB cxp cres f1oeng vw cv csn cvv wcel cB cfn
      wcel vw cv csn cB cxp cvv wcel vw cv snex vw cv csn cB cvv cfn xpexg mpan
      vw cv cvv wcel vw cv csn cB cxp cB c2nd vw cv csn cB cxp cres wf1o vw
      visset vw cv cB cvv 2ndconst ax-mp sylancl vw cv csn cB cxp cB cfn enfi
      mpdan ibir ad2antlr vy cv cfn wcel cB cfn wcel wa vw cv vy cv wcel wa vy
      cv vw cv csn cdif cB cxp vw cv csn cB cxp cun cfn wcel vy cv cB cxp cfn
      wcel vy cv vw cv csn cdif cB cxp cfn wcel vw cv csn cB cxp cfn wcel wa vw
      cv vy cv wcel vy cv vw cv csn cdif cB cxp vw cv csn cB cxp cun cfn wcel
      vy cv cB cxp cfn wcel wi vy cv cfn wcel cB cfn wcel wa vw cv vy cv wcel
      vy cv vw cv csn cdif cB cxp vw cv csn cB cxp cun cfn wcel vy cv cB cxp
      cfn wcel vw cv vy cv wcel vy cv vw cv csn cdif cB cxp vw cv csn cB cxp
      cun vy cv cB cxp cfn vw cv vy cv wcel vy cv vw cv csn cdif vw cv csn cun
      cB cxp vy cv cB cxp vy cv vw cv csn cdif cB cxp vw cv csn cB cxp cun vw
      cv vy cv wcel vy cv vw cv csn cdif vw cv csn cun vy cv wceq vy cv vw cv
      csn cdif vw cv csn cun cB cxp vy cv cB cxp wceq vy cv vw cv difsnid vy cv
      vw cv csn cdif vw cv csn cun vy cv cB xpeq1 syl vy cv vw cv csn cdif vw
      cv csn cB xpundir syl5eqr eleq1d biimpd adantl vy cv vw cv csn cdif cB
      cxp vw cv csn cB cxp unfi syl5 mpan2d 3syld ex 19.23adv vw vy cv neq0
      syl5ib vy cv c0 wceq vy cv cB cxp cfn wcel cB cfn wcel vy cv vz cv csn
      cdif cB cxp cfn wcel wi vz vy cv wral vy cv c0 wceq vy cv cB cxp c0 cB
      cxp cfn vy cv c0 cB xpeq1 c0 cB cxp c0 cfn cB xp0r emfin eqeltri syl6eqel
      a1d pm2.61d2 ex com23 findcard imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z f $. $d B x y z f $. $d ph z f $. $d ps z $.
    ac6gf.1 $e |- ( ps -> A. y ps ) $.
    ac6gf.2 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Axiom of Choice. $)
    ac6gf $p |- ( ( A e. C /\ A. x e. A E. y e. B ph ) ->
                                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      cA cC wcel wph vy vz cv wsbc vz cB wrex vx cA wral cA cB vf cv wf wps vx
      cA wral wa vf wex wph vy cB wrex vx cA wral cA cC wcel wph vy vz cv wsbc
      vz cB wrex vx cA wral cA cB vf cv wf wps vx cA wral wa vf wex cA cC wcel
      cA cvv wcel wph vy vz cv wsbc vz cB wrex vx cA wral cA cB vf cv wf wps vx
      cA wral wa vf wex wi cA cC elisset wph vy vz cv wsbc wps vx vz cA cB vf
      vz cv vx cv vf cv cfv wceq wph vy vz cv wsbc wph vy vx cv vf cv cfv wsbc
      wps wph vy vz cv vx cv vf cv cfv dfsbcq vx cv vf cv cfv cvv wcel wph vy
      vx cv vf cv cfv wsbc wps wb vx cv vf cv fvex wph wps vy vx cv vf cv cfv
      cvv wps wps vy wal wi vx cv vf cv cfv cvv wcel ac6gf.1 a1i ac6gf.2
      sbciegf ax-mp syl6bb ac6sg syl imp wph vy cB wrex wph vy vz cv wsbc vz cB
      wrex vx cA wph wph vy vz cv wsbc vy vz cB wph vz ax-17 wph vy vz cv vz
      visset hbsbc1v wph vy vz cv sbceq1a cbvrex ralbii sylan2b $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A a g k $. $d F a g k $. $d B a g k $.
    $( Dependent choice. $)
    acdcg $p |- ( ( A e. B /\ A =/= (/) /\ F : A --> ( ~P A \ { (/) } ) ) ->
                              E. g ( g : NN --> A /\ A. k e. NN
                          ( g ` ( k + 1 ) ) e. ( F ` ( g ` k ) ) ) ) $=
      cA cB wcel cA c0 wne cA cA cpw c0 csn cdif cF wf cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg wex va cv
      c0 wne va cv va cv cpw c0 csn cdif cF wf wa cn va cv vg cv wf vk cv c1
      caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg wex wi cA
      c0 wne cA cA cpw c0 csn cdif cF wf wa cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg wex wi va cA cB va cv
      cA wceq va cv c0 wne va cv va cv cpw c0 csn cdif cF wf wa cA c0 wne cA cA
      cpw c0 csn cdif cF wf wa cn va cv vg cv wf vk cv c1 caddc co vg cv cfv vk
      cv vg cv cfv cF cfv wcel vk cn wral wa vg wex cn cA vg cv wf vk cv c1
      caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg wex va cv
      cA wceq va cv c0 wne cA c0 wne va cv va cv cpw c0 csn cdif cF wf cA cA
      cpw c0 csn cdif cF wf va cv cA c0 neeq1 va cv cA wceq va cv va cv cpw c0
      csn cdif cF wf cA va cv cpw c0 csn cdif cF wf cA cA cpw c0 csn cdif cF wf
      va cv cA va cv cpw c0 csn cdif cF feq2 va cv cA wceq va cv cpw c0 csn
      cdif cA cpw c0 csn cdif wceq cA va cv cpw c0 csn cdif cF wf cA cA cpw c0
      csn cdif cF wf wb va cv cA wceq va cv cpw cA cpw c0 csn va cv cA pweq
      difeq1d va cv cpw c0 csn cdif cA cpw c0 csn cdif cA cF feq3 syl bitrd
      anbi12d va cv cA wceq cn va cv vg cv wf vk cv c1 caddc co vg cv cfv vk cv
      vg cv cfv cF cfv wcel vk cn wral wa cn cA vg cv wf vk cv c1 caddc co vg
      cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral wa vg va cv cA wceq cn va
      cv vg cv wf cn cA vg cv wf vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF
      cfv wcel vk cn wral va cv cA cn vg cv feq3 anbi1d exbidv imbi12d va cv vg
      vk cF va visset acdc vtoclg 3impib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A a g k $. $d B a g k $. $d F a g k $. $d C a g $.
    $( Dependent choice. $)
    acdc3g $p |- ( ( A e. B /\ F : A --> ( ~P A \ { (/) } ) /\ C e. A ) ->
                  E. g ( g : NN --> A /\ ( g ` 1 ) = C /\ A. k e. NN
                        ( g ` ( k + 1 ) ) e. ( F ` ( g ` k ) ) ) ) $=
      cA cB wcel cA cA cpw c0 csn cdif cF wf cC cA wcel cn cA vg cv wf c1 vg cv
      cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn
      wral w3a vg wex va cv va cv cpw c0 csn cdif cF wf cC va cv wcel wa cn va
      cv vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv vg cv
      cfv cF cfv wcel vk cn wral w3a vg wex wi cA cA cpw c0 csn cdif cF wf cC
      cA wcel wa cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv
      cfv vk cv vg cv cfv cF cfv wcel vk cn wral w3a vg wex wi va cA cB va cv
      cA wceq va cv va cv cpw c0 csn cdif cF wf cC va cv wcel wa cA cA cpw c0
      csn cdif cF wf cC cA wcel wa cn va cv vg cv wf c1 vg cv cfv cC wceq vk cv
      c1 caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral w3a vg wex
      cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv vg
      cv cfv cF cfv wcel vk cn wral w3a vg wex va cv cA wceq va cv va cv cpw c0
      csn cdif cF wf cA cA cpw c0 csn cdif cF wf cC va cv wcel cC cA wcel va cv
      cA wceq va cv va cv cpw c0 csn cdif cF wf cA va cv cpw c0 csn cdif cF wf
      cA cA cpw c0 csn cdif cF wf va cv cA va cv cpw c0 csn cdif cF feq2 va cv
      cA wceq va cv cpw c0 csn cdif cA cpw c0 csn cdif wceq cA va cv cpw c0 csn
      cdif cF wf cA cA cpw c0 csn cdif cF wf wb va cv cA wceq va cv cpw cA cpw
      c0 csn va cv cA pweq difeq1d va cv cpw c0 csn cdif cA cpw c0 csn cdif cA
      cF feq3 syl bitrd va cv cA cC eleq2 anbi12d va cv cA wceq cn va cv vg cv
      wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv vg cv cfv cF
      cfv wcel vk cn wral w3a cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1
      caddc co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral w3a vg va cv cA
      wceq cn va cv vg cv wf cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc
      co vg cv cfv vk cv vg cv cfv cF cfv wcel vk cn wral va cv cA cn vg cv
      feq3 3anbi1d exbidv imbi12d va cv cC vg vk cF va visset acdc3 vtoclg
      3impib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A a g k $. $d B a g k $. $d F a g k $. $d C a g $.
    $( Dependent choice. $)
    acdc5g $p |- ( ( A e. B /\ F : ( NN X. A ) --> ( ~P A \ { (/) } )
                    /\ C e. A )
                -> E. g ( g : NN --> A /\ ( g ` 1 ) = C /\ A. k e. NN
                    ( g ` ( k + 1 ) ) e. ( ( k + 1 ) F ( g ` k ) ) ) ) $=
      cA cB wcel cn cA cxp cA cpw c0 csn cdif cF wf cC cA wcel cn cA vg cv wf
      c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv
      vg cv cfv cF co wcel vk cn wral w3a vg wex cn va cv cxp va cv cpw c0 csn
      cdif cF wf cC va cv wcel wa cn va cv vg cv wf c1 vg cv cfv cC wceq vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral w3a vg wex wi cn cA cxp cA cpw c0 csn cdif cF wf cC cA wcel wa cn cA
      vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc
      co vk cv vg cv cfv cF co wcel vk cn wral w3a vg wex wi va cA cB va cv cA
      wceq cn va cv cxp va cv cpw c0 csn cdif cF wf cC va cv wcel wa cn cA cxp
      cA cpw c0 csn cdif cF wf cC cA wcel wa cn va cv vg cv wf c1 vg cv cfv cC
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral w3a vg wex cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1
      caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral w3a vg wex va cv cA wceq cn va cv cxp va cv cpw c0 csn cdif cF wf cn
      cA cxp cA cpw c0 csn cdif cF wf cC va cv wcel cC cA wcel va cv cA wceq cn
      va cv cxp va cv cpw c0 csn cdif cF wf cn cA cxp va cv cpw c0 csn cdif cF
      wf cn cA cxp cA cpw c0 csn cdif cF wf va cv cA wceq cn va cv cxp cn cA
      cxp wceq cn va cv cxp va cv cpw c0 csn cdif cF wf cn cA cxp va cv cpw c0
      csn cdif cF wf wb va cv cA cn xpeq2 cn va cv cxp cn cA cxp va cv cpw c0
      csn cdif cF feq2 syl va cv cA wceq va cv cpw c0 csn cdif cA cpw c0 csn
      cdif wceq cn cA cxp va cv cpw c0 csn cdif cF wf cn cA cxp cA cpw c0 csn
      cdif cF wf wb va cv cA wceq va cv cpw cA cpw c0 csn va cv cA pweq difeq1d
      va cv cpw c0 csn cdif cA cpw c0 csn cdif cn cA cxp cF feq3 syl bitrd va
      cv cA cC eleq2 anbi12d va cv cA wceq cn va cv vg cv wf c1 vg cv cfv cC
      wceq vk cv c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co
      wcel vk cn wral w3a cn cA vg cv wf c1 vg cv cfv cC wceq vk cv c1 caddc co
      vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn wral w3a vg
      va cv cA wceq cn va cv vg cv wf cn cA vg cv wf c1 vg cv cfv cC wceq vk cv
      c1 caddc co vg cv cfv vk cv c1 caddc co vk cv vg cv cfv cF co wcel vk cn
      wral va cv cA cn vg cv feq3 3anbi1d exbidv imbi12d va cv cC vg vk cF va
      visset acdc5 vtoclg 3impib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y c z w v q $. $d B x y c z w v q $. $d ph c z w v q $.
    $( If for every element of an indexing set ` A ` there exists a
       corresponding element of another set ` B ` , then there exists a subset
       of ` B ` consisting only of those elements which are indexed by ` A ` .
       Used to avoid the Axiom of Choice in situations where only the range of
       the choice function is needed. $)
    indexa $p |- ( ( B e. M /\ A. x e. A E. y e. B ph ) -> E. c
          ( c C_ B /\ A. x e. A E. y e. c ph /\ A. y e. c E. x e. A ph ) ) $=
      wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab cvv wcel wph vy vz
      cv wsbc vx vw cv wsbc vw cA wrex vz cB crab cB wss wph vy wph vy vz cv
      wsbc vx vw cv wsbc vw cA wrex vz cB crab wrex vx cA wral wph vx cA wrex
      vy wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab wral w3a vc cv
      cB wss wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral w3a vc
      wex cB cM wcel wph vy cB wrex vx cA wral wph vy vz cv wsbc vx vw cv wsbc
      vw cA wrex vz cB crab cvv wcel wph vy vz cv wsbc vx vw cv wsbc vw cA wrex
      vz cB crab cB wss wph vy wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB
      crab wrex vx cA wral wph vx cA wrex vy wph vy vz cv wsbc vx vw cv wsbc vw
      cA wrex vz cB crab wral w3a vc cv cB wss wph vy vc cv wrex vx cA wral wph
      vx cA wrex vy vc cv wral w3a vc wex vc cv cB wss wph vy vc cv wrex vx cA
      wral wph vx cA wrex vy vc cv wral w3a wph vy vz cv wsbc vx vw cv wsbc vw
      cA wrex vz cB crab cB wss wph vy wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab wrex vx cA wral wph vx cA wrex vy wph vy vz cv wsbc vx vw
      cv wsbc vw cA wrex vz cB crab wral w3a vc wph vy vz cv wsbc vx vw cv wsbc
      vw cA wrex vz cB crab cvv vc cv wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab wceq vc cv cB wss wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab cB wss wph vy vc cv wrex vx cA wral wph vy wph vy vz cv
      wsbc vx vw cv wsbc vw cA wrex vz cB crab wrex vx cA wral wph vx cA wrex
      vy vc cv wral wph vx cA wrex vy wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab wral vc cv wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz
      cB crab cB sseq1 vc cv wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB
      crab wceq wph vy vc cv wrex wph vy wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab wrex vx cA vx vq vq vc cv wph vy vz cv wsbc vx vw cv wsbc
      vw cA wrex vz cB crab vq cv vc cv wcel vx ax-17 wph vy vz cv wsbc vx vw
      cv wsbc vw cA wrex vx vz vq cB wph vy vz cv wsbc vx vw cv wsbc vx vw cA
      vw cv cA wcel vx ax-17 wph vy vz cv wsbc vx vw wph vy vz cv wsbc vw ax-17
      hbsb3 hbrex vq cv cB wcel vx ax-17 hbrab hbeq wph vy vq vc cv wph vy vz
      cv wsbc vx vw cv wsbc vw cA wrex vz cB crab vq cv vc cv wcel vy ax-17 wph
      vy vz cv wsbc vx vw cv wsbc vw cA wrex vy vz vq cB wph vy vz cv wsbc vx
      vw cv wsbc vy vw cA vw cv cA wcel vy ax-17 wph vy vz cv wsbc vx vw vy wph
      vy vz wph vz ax-17 hbsb3 hbsb hbrex vq cv cB wcel vy ax-17 hbrab rexeq1f
      ralbid wph vx cA wrex vy vq vc cv wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab vq cv vc cv wcel vy ax-17 wph vy vz cv wsbc vx vw cv wsbc
      vw cA wrex vy vz vq cB wph vy vz cv wsbc vx vw cv wsbc vy vw cA vw cv cA
      wcel vy ax-17 wph vy vz cv wsbc vx vw vy wph vy vz wph vz ax-17 hbsb3
      hbsb hbrex vq cv cB wcel vy ax-17 hbrab raleq1f 3anbi123d cla4egv imp wph
      vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB cM rabexg wph vy cB wrex vx
      cA wral wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab cB wss wph
      vy wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab wrex vx cA wral
      wph vx cA wrex vy wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab
      wral wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab cB wss wph vy
      cB wrex vx cA wral wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB
      ssrab2 a1i wph vy cB wrex wph vy wph vy vz cv wsbc vx vw cv wsbc vw cA
      wrex vz cB crab wrex vx cA vx cv cA wcel wph wph vy wph vy vz cv wsbc vx
      vw cv wsbc vw cA wrex vz cB crab wrex vy cB vx cv cA wcel vy ax-17 wph vy
      wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab hbre1 vx cv cA wcel
      vy cv cB wcel wph wph vy wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB
      crab wrex vx cv cA wcel vy cv cB wcel wa wph wa wph vy vv cv wsbc vv wph
      vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab wrex wph vy wph vy vz
      cv wsbc vx vw cv wsbc vw cA wrex vz cB crab wrex vx cv cA wcel vy cv cB
      wcel wa wph vy cv wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab
      wcel wph vy vv cv wsbc vv wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz
      cB crab wrex vx cv cA wcel vy cv cB wcel wa wph wa vy cv cB wcel wph vx
      vw cv wsbc vw cA wrex wa vy cv wph vy vz cv wsbc vx vw cv wsbc vw cA wrex
      vz cB crab wcel wph vx cv cA wcel vy cv cB wcel wa vy cv cB wcel wph vx
      vw cv wsbc vw cA wrex wa wph vx cv cA wcel vy cv cB wcel vy cv cB wcel
      wph vx vw cv wsbc vw cA wrex wa vy cv cB wcel wph vx cv cA wcel wa vy cv
      cB wcel wph vx vw cv wsbc vw cA wrex wa wph vx cv cA wcel wa wph vx vw cv
      wsbc vw cA wrex vy cv cB wcel vx cv cA wcel wph wph vx vw cv wsbc vw cA
      wrex wph vx vw cv wsbc wph vw vx cv cA vw cv vx cv wceq wph wph vx vw cv
      wsbc wph wph vx vw cv wsbc wb vx cv vw cv wph vx vw cv sbceq1a eqcoms
      bicomd rcla4ev ancoms anim2i ancoms anasss ancoms wph vy vz cv wsbc vx vw
      cv wsbc vw cA wrex wph vx vw cv wsbc vw cA wrex vz vy cv cB vz cv vy cv
      wceq wph vy vz cv wsbc vx vw cv wsbc wph vx vw cv wsbc vw cA vz cv vy cv
      wceq wph vy vz cv wsbc wph vx vw vz cv vy cv wceq vx ax-17 vz cv vy cv
      wceq wph wph vy vz cv wsbc wph wph vy vz cv wsbc wb vy cv vz cv wph vy vz
      cv sbceq1a eqcoms bicomd sbbid rexbidv elrab sylibr wph vy vv cv wsbc wph
      vv vy cv wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab vv cv vy
      cv wceq wph wph vy vv cv wsbc wph wph vy vv cv wsbc wb vy cv vv cv wph vy
      vv cv sbceq1a eqcoms bicomd rcla4ev sylancom wph vy vv cv wsbc wph vv vy
      vq wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab vq cv wph vy vz
      cv wsbc vx vw cv wsbc vw cA wrex vz cB crab wcel vv ax-17 wph vy vz cv
      wsbc vx vw cv wsbc vw cA wrex vy vz vq cB wph vy vz cv wsbc vx vw cv wsbc
      vy vw cA vw cv cA wcel vy ax-17 wph vy vz cv wsbc vx vw vy wph vy vz wph
      vz ax-17 hbsb3 hbsb hbrex vq cv cB wcel vy ax-17 hbrab wph vy vv wph vv
      ax-17 hbsb3 wph vv ax-17 vv cv vy cv wceq wph wph vy vv cv wsbc wph wph
      vy vv cv wsbc wb vy cv vv cv wph vy vv cv sbceq1a eqcoms bicomd cbvrexf
      sylib exp31 r19.23ad r19.20i wph vx cA wrex vy wph vy vz cv wsbc vx vw cv
      wsbc vw cA wrex vz cB crab wral wph vy cB wrex vx cA wral wph vx cA wrex
      vy wph vy vz cv wsbc vx vw cv wsbc vw cA wrex vz cB crab vy cv wph vy vz
      cv wsbc vx vw cv wsbc vw cA wrex vz cB crab wcel vy cv cB wcel wph vx cA
      wrex wph vy vz cv wsbc vx vw cv wsbc vw cA wrex wph vx cA wrex vz vq vy
      cv cB vq cv vy cv wcel vz ax-17 vq cv cB wcel vz ax-17 wph vx cA wrex vz
      ax-17 vz cv vy cv wceq wph vy vz cv wsbc vx vw cv wsbc vw cA wrex wph vx
      vw cv wsbc vw cA wrex wph vx cA wrex vz cv vy cv wceq wph vy vz cv wsbc
      vx vw cv wsbc wph vx vw cv wsbc vw cA vz cv vy cv wceq wph vy vz cv wsbc
      wph vx vw vz cv vy cv wceq vx ax-17 vz cv vy cv wceq wph wph vy vz cv
      wsbc wph wph vy vz cv wsbc wb vy cv vz cv wph vy vz cv sbceq1a eqcoms
      bicomd sbbid rexbidv wph vx vw cv wsbc wph vw vx cA wph vx vw wph vw
      ax-17 hbsb3 wph vw ax-17 vw cv vx cv wceq wph wph vx vw cv wsbc wph wph
      vx vw cv wsbc wb vx cv vw cv wph vx vw cv sbceq1a eqcoms bicomd cbvrex
      syl6bb elrabf pm3.27bi rgen a1i 3jca syl2an $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A c f x y $. $d B c f x y $. $d ph f c $.
    $( If for every element of an indexing set ` A ` there exists a
       corresponding element of another set ` B ` , then there exists a subset
       of ` B ` consisting only of those elements which are indexed by ` A ` ,
       and which is dominated by the set ` A ` . $)
    indexd $p |- ( ( A e. M /\ A. x e. A E. y e. B ph ) -> E. c ( ( c ~<_ A /\
        c C_ B ) /\ ( A. x e. A E. y e. c ph /\ A. y e. c E. x e. A ph ) ) ) $=
      cA cM wcel wph vy cB wrex vx cA wral wa cA cB vf cv wf wph vy vx cv vf cv
      cfv wsbc vx cA wral wa vf wex vc cv cA cdom wbr vc cv cB wss wa wph vy vc
      cv wrex vx cA wral wph vx cA wrex vy vc cv wral wa wa vc wex wph wph vy
      vx cv vf cv cfv wsbc vx vy cA cB cM vf wph vy vx cv vf cv cfv vx cv vf cv
      fvex hbsbc1v wph vy vx cv vf cv cfv sbceq1a ac6gf cA cB vf cv wf wph vy
      vx cv vf cv cfv wsbc vx cA wral wa vc cv cA cdom wbr vc cv cB wss wa wph
      vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral wa wa vc wex vf vf
      cv crn cA cdom wbr vf cv crn cB wss wph vy vf cv crn wrex vx cA wral wph
      vx cA wrex vy vf cv crn wral vc cv cA cdom wbr vc cv cB wss wa wph vy vc
      cv wrex vx cA wral wph vx cA wrex vy vc cv wral wa wa vc wex cA cB vf cv
      wf wph vy vx cv vf cv cfv wsbc vx cA wral wa vc cv cA cdom wbr vc cv cB
      wss wa wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral wa wa vf
      cv crn cA cdom wbr vf cv crn cB wss wa wph vy vf cv crn wrex vx cA wral
      wph vx cA wrex vy vf cv crn wral wa wa vc vf cv crn vf cv vf visset rnex
      vc cv vf cv crn wceq vc cv cA cdom wbr vc cv cB wss wa vf cv crn cA cdom
      wbr vf cv crn cB wss wa wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc
      cv wral wa wph vy vf cv crn wrex vx cA wral wph vx cA wrex vy vf cv crn
      wral wa vc cv vf cv crn wceq vc cv cA cdom wbr vf cv crn cA cdom wbr vc
      cv cB wss vf cv crn cB wss vc cv vf cv crn cA cdom breq1 vc cv vf cv crn
      cB sseq1 anbi12d vc cv vf cv crn wceq wph vy vc cv wrex vx cA wral wph vy
      vf cv crn wrex vx cA wral wph vx cA wrex vy vc cv wral wph vx cA wrex vy
      vf cv crn wral vc cv vf cv crn wceq wph vy vc cv wrex wph vy vf cv crn
      wrex vx cA wph vy vc cv vf cv crn rexeq1 ralbidv wph vx cA wrex vy vc cv
      vf cv crn raleq1 anbi12d anbi12d cla4ev cA cB vf cv wf vf cv crn cA cdom
      wbr wph vy vx cv vf cv cfv wsbc vx cA wral cA cvv wcel vf cv cA wfn vf cv
      crn cA cdom wbr cA cB vf cv wf cA cvv vf cv fnrndomg cA cB vf cv wf cA vf
      cv cdm cvv cA cB vf cv fdm vf cv vf visset dmex syl6eqelr cA cB vf cv ffn
      sylc adantr cA cB vf cv wf vf cv crn cB wss wph vy vx cv vf cv cfv wsbc
      vx cA wral cA cB vf cv frn adantr cA cB vf cv wf wph vy vx cv vf cv cfv
      wsbc vx cA wral wa wph vy vf cv crn wrex vx cA cA cB vf cv wf wph vy vx
      cv vf cv cfv wsbc vx cA wral vx cA cB vf cv wf vx ax-17 wph vy vx cv vf
      cv cfv wsbc vx cA hbra1 hban cA cB vf cv wf wph vy vx cv vf cv cfv wsbc
      vx cA wral wa vx cv cA wcel wph vy vf cv crn wrex vx cv vf cv cfv vf cv
      crn wcel wph vy vx cv vf cv cfv wsbc wph vy vf cv crn wrex cA cB vf cv wf
      wph vy vx cv vf cv cfv wsbc vx cA wral wa vx cv cA wcel wa wph wph vy vx
      cv vf cv cfv wsbc vy vx cv vf cv cfv vf cv crn wph vy vx cv vf cv cfv vx
      cv vf cv fvex hbsbc1v wph vy vx cv vf cv cfv sbceq1a rcla4e cA cB vf cv
      wf vx cv cA wcel vx cv vf cv cfv vf cv crn wcel wph vy vx cv vf cv cfv
      wsbc vx cA wral vf cv wfun vx cv vf cv cdm wcel vx cv vf cv cfv vf cv crn
      wcel cA cB vf cv wf vx cv cA wcel wa vx cv vf cv fvelrn cA cB vf cv wf vf
      cv wfun vx cv cA wcel cA cB vf cv ffun adantr cA cB vf cv wf vx cv vf cv
      cdm wcel vx cv cA wcel cA cB vf cv wf vf cv cdm cA vx cv cA cB vf cv fdm
      eleq2d biimpar sylanc adantlr wph vy vx cv vf cv cfv wsbc vx cA wral vx
      cv cA wcel wph vy vx cv vf cv cfv wsbc cA cB vf cv wf wph vy vx cv vf cv
      cfv wsbc vx cA wral vx cv cA wcel wph vy vx cv vf cv cfv wsbc wph vy vx
      cv vf cv cfv wsbc vx cA ra4 imp adantll sylanc ex r19.21ai cA cB vf cv wf
      wph vy vx cv vf cv cfv wsbc vx cA wral wa wph vx cA wrex vy vf cv crn cA
      cB vf cv wf wph vy vx cv vf cv cfv wsbc vx cA wral vy cA cB vf cv wf vy
      ax-17 wph vy vx cv vf cv cfv wsbc vy vx cA vx cv cA wcel vy ax-17 wph vy
      vx cv vf cv cfv vx cv vf cv fvex hbsbc1v hbral hban cA cB vf cv wf wph vy
      vx cv vf cv cfv wsbc vx cA wral wa vy cv vf cv crn wcel vx cv vf cv cfv
      vy cv wceq vx cA wrex wph vx cA wrex cA cB vf cv wf vy cv vf cv crn wcel
      vx cv vf cv cfv vy cv wceq vx cA wrex wb wph vy vx cv vf cv cfv wsbc vx
      cA wral cA cB vf cv wf vf cv cA wfn vy cv vf cv crn wcel vx cv vf cv cfv
      vy cv wceq vx cA wrex wb cA cB vf cv ffn vx cA vy cv vf cv fvelrnb syl
      adantr cA cB vf cv wf wph vy vx cv vf cv cfv wsbc vx cA wral wa vx cv vf
      cv cfv vy cv wceq wph vx cA cA cB vf cv wf wph vy vx cv vf cv cfv wsbc vx
      cA wral vx cA cB vf cv wf vx ax-17 wph vy vx cv vf cv cfv wsbc vx cA
      hbra1 hban cA cB vf cv wf wph vy vx cv vf cv cfv wsbc vx cA wral wa vx cv
      cA wcel wph vy vx cv vf cv cfv wsbc vx cv vf cv cfv vy cv wceq wph wi wph
      vy vx cv vf cv cfv wsbc vx cA wral vx cv cA wcel wph vy vx cv vf cv cfv
      wsbc wi cA cB vf cv wf wph vy vx cv vf cv cfv wsbc vx cA ra4 adantl vx cv
      vf cv cfv vy cv wceq wph wph vy vx cv vf cv cfv wsbc wph wph vy vx cv vf
      cv cfv wsbc wb vy cv vx cv vf cv cfv wph vy vx cv vf cv cfv sbceq1a
      eqcoms biimprcd syl6 r19.22d sylbid r19.21ai syl2anc 19.23aiv syl $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A a b x y c z w m n p $. $d B a b x y c z w m n p $.
    $d ph a b c z w m n p $. $d M a b m n p z y x w c $.
    $( If for every element of a finite indexing set ` A ` there exists a
       corresponding element of another set ` B ` , then there exists a finite
       subset of ` B ` consisting only of those elements which are indexed by
       ` A ` .  Proven without the Axiom of Choice, unlike ~ indexd . $)
    indexf $p |- ( ( A e. Fin /\ B e. M /\ A. x e. A E. y e. B ph ) ->
                E. c e. Fin ( c C_ B /\ A. x e. A E. y e. c ph /\
                                                  A. y e. c E. x e. A ph ) ) $=
      cA cfn wcel cB cM wcel wph vy cB wrex vx cA wral vc cv cB wss wph vy vc
      cv wrex vx cA wral wph vx cA wrex vy vc cv wral w3a vc cfn wrex cA vp cv
      cen wbr vp com wrex cA cfn wcel cB cM wcel wph vy cB wrex vx cA wral wa
      vc cv cB wss wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral
      w3a vc cfn wrex wi cA cfn wcel cA va cv vp cv cen wbr vp com wrex va cab
      wcel cA vp cv cen wbr vp com wrex cfn va cv vp cv cen wbr vp com wrex va
      cab cA va vp df-fin eleq2i cA va cv vp cv cen wbr vp com wrex va cab wcel
      cA vp cv cen wbr vp com wrex va cv vp cv cen wbr vp com wrex cA vp cv cen
      wbr vp com wrex va cA va cv vp cv cen wbr vp com wrex va cab va cv cA
      wceq va cv vp cv cen wbr cA vp cv cen wbr vp com va cv cA vp cv cen breq1
      rexbidv elabg ibi sylbi cA vp cv cen wbr cA cfn wcel cB cM wcel wph vy cB
      wrex vx cA wral wa vc cv cB wss wph vy vc cv wrex vx cA wral wph vx cA
      wrex vy vc cv wral w3a vc cfn wrex wi wi vp com cA cfn wcel vp cv com
      wcel cA vp cv cen wbr cB cM wcel wph vy cB wrex vx cA wral wa vc cv cB
      wss wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral w3a vc cfn
      wrex wi cA cfn wcel va cv vp cv cen wbr cB cM wcel wph vy cB wrex vx va
      cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex
      vy vc cv wral w3a vc cfn wrex wi wi va wal cA vp cv cen wbr cB cM wcel
      wph vy cB wrex vx cA wral wa vc cv cB wss wph vy vc cv wrex vx cA wral
      wph vx cA wrex vy vc cv wral w3a vc cfn wrex wi wi vp cv com wcel va cv
      vp cv cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph
      vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn
      wrex wi wi cA vp cv cen wbr cB cM wcel wph vy cB wrex vx cA wral wa vc cv
      cB wss wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral w3a vc
      cfn wrex wi wi va cA cfn va cv cA wceq va cv vp cv cen wbr cA vp cv cen
      wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv
      wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi cB
      cM wcel wph vy cB wrex vx cA wral wa vc cv cB wss wph vy vc cv wrex vx cA
      wral wph vx cA wrex vy vc cv wral w3a vc cfn wrex wi va cv cA vp cv cen
      breq1 va cv cA wceq cB cM wcel wph vy cB wrex vx va cv wral wa cB cM wcel
      wph vy cB wrex vx cA wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral
      wph vx va cv wrex vy vc cv wral w3a vc cfn wrex vc cv cB wss wph vy vc cv
      wrex vx cA wral wph vx cA wrex vy vc cv wral w3a vc cfn wrex va cv cA
      wceq wph vy cB wrex vx va cv wral wph vy cB wrex vx cA wral cB cM wcel
      wph vy cB wrex vx va cv cA raleq1 anbi2d va cv cA wceq vc cv cB wss wph
      vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cv cB
      wss wph vy vc cv wrex vx cA wral wph vx cA wrex vy vc cv wral w3a vc cfn
      va cv cA wceq wph vy vc cv wrex vx va cv wral wph vy vc cv wrex vx cA
      wral wph vx va cv wrex vy vc cv wral wph vx cA wrex vy vc cv wral vc cv
      cB wss wph vy vc cv wrex vx va cv cA raleq1 va cv cA wceq wph vx va cv
      wrex wph vx cA wrex vy vc cv wph vx va cv cA rexeq1 ralbidv 3anbi23d
      rexbidv imbi12d imbi12d cla4gv va cv vn cv cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal va cv c0 cen wbr cB
      cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx
      va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal
      va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB
      wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a
      vc cfn wrex wi wi va wal va cv vm cv csuc cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal va cv vp cv cen wbr
      cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex
      vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va
      wal vn vm vp cv vn cv c0 wceq va cv vn cv cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va cv c0 cen wbr cB cM
      wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va
      cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va vn cv c0
      wceq va cv vn cv cen wbr va cv c0 cen wbr cB cM wcel wph vy cB wrex vx va
      cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex
      vy vc cv wral w3a vc cfn wrex wi vn cv c0 va cv cen breq2 imbi1d albidv
      vn cv vm cv wceq va cv vn cv cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi va cv vm cv cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va vn cv vm cv wceq va cv
      vn cv cen wbr va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv wral
      wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc
      cv wral w3a vc cfn wrex wi vn cv vm cv va cv cen breq2 imbi1d albidv vn
      cv vm cv csuc wceq va cv vn cv cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi va cv vm cv csuc cen wbr cB cM wcel wph
      vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral
      wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va vn cv vm cv csuc
      wceq va cv vn cv cen wbr va cv vm cv csuc cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi vn cv vm cv csuc va cv cen
      breq2 imbi1d albidv vn cv vp cv wceq va cv vn cv cen wbr cB cM wcel wph
      vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral
      wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va cv vp cv cen wbr
      cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex
      vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va vn
      cv vp cv wceq va cv vn cv cen wbr va cv vp cv cen wbr cB cM wcel wph vy
      cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph
      vx va cv wrex vy vc cv wral w3a vc cfn wrex wi vn cv vp cv va cv cen
      breq2 imbi1d albidv va cv c0 cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi va va cv c0 cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex c0 cB wss wph vy c0 wrex vx va
      cv wral wph vx va cv wrex vy c0 wral vc cv cB wss wph vy vc cv wrex vx va
      cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex va cv c0 cen wbr
      cB cM wcel wph vy cB wrex vx va cv wral wa wa c0 cfn wcel c0 cB wss wph
      vy c0 wrex vx va cv wral wph vx va cv wrex vy c0 wral w3a vc cv cB wss
      wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc
      cfn wrex emfin vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv
      wrex vy vc cv wral w3a c0 cB wss wph vy c0 wrex vx va cv wral wph vx va
      cv wrex vy c0 wral w3a vc c0 cfn vc cv c0 wceq vc cv cB wss c0 cB wss wph
      vy vc cv wrex vx va cv wral wph vy c0 wrex vx va cv wral wph vx va cv
      wrex vy vc cv wral wph vx va cv wrex vy c0 wral vc cv c0 cB sseq1 vc cv
      c0 wceq wph vy vc cv wrex wph vy c0 wrex vx va cv wph vy vc cv c0 rexeq1
      ralbidv wph vx va cv wrex vy vc cv c0 raleq1 3anbi123d rcla4ev mpan c0 cB
      wss va cv c0 cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa wa cB 0ss
      a1i va cv c0 cen wbr wph vy c0 wrex vx va cv wral cB cM wcel wph vy cB
      wrex vx va cv wral wa va cv c0 cen wbr wph vy c0 wrex vx va cv wral wph
      vy c0 wrex vx c0 wral wph vy c0 wrex vx ral0 va cv c0 cen wbr va cv c0
      wceq wph vy c0 wrex vx va cv wral wph vy c0 wrex vx c0 wral wb va cv en0
      wph vy c0 wrex vx va cv c0 raleq1 sylbi mpbiri adantr wph vx va cv wrex
      vy c0 wral va cv c0 cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa wa
      wph vx va cv wrex vy ral0 a1i syl3anc ex ax-gen vm cv com wcel va cv vm
      cv cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy
      vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex
      wi wi va wal va cv vm cv csuc cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi va vm cv com wcel va ax-17 va cv vm cv
      cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc
      cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi
      wi va hba1 vm cv com wcel va cv vm cv cen wbr cB cM wcel wph vy cB wrex
      vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va
      cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal va cv vm cv csuc cen
      wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv
      wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi vm
      cv com wcel va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv wral
      wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc
      cv wral w3a vc cfn wrex wi wi va wal va cv vm cv csuc cen wbr w3a vz cv
      va cv wcel vz wex cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss
      wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc
      cfn wrex wi va cv vm cv csuc cen wbr vm cv com wcel vz cv va cv wcel vz
      wex va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv
      cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral
      w3a vc cfn wrex wi wi va wal va cv vm cv csuc cen wbr va cv c0 wceq wn vz
      cv va cv wcel vz wex va cv vm cv csuc cen wbr va cv c0 wceq vm cv csuc c0
      cen wbr vm cv csuc c0 cen wbr vm cv csuc c0 vm cv nsuceq0 vm cv csuc en0
      nemtbir va cv vm cv csuc cen wbr va cv c0 cen wbr vm cv csuc c0 cen wbr
      va cv c0 wceq va cv vm cv csuc cen wbr vm cv csuc va cv cen wbr va cv c0
      cen wbr vm cv csuc c0 cen wbr wi va cv vm cv csuc vm cv vm visset sucex
      ensym vm cv csuc va cv cen wbr va cv c0 cen wbr vm cv csuc c0 cen wbr vm
      cv csuc va cv c0 entr ex syl va cv en0 syl5ibr mtoi vz va cv neq0 sylib
      3ad2ant3 vm cv com wcel va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx
      va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv
      wrex vy vc cv wral w3a vc cfn wrex wi wi va wal va cv vm cv csuc cen wbr
      w3a vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB
      wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a
      vc cfn wrex wi vz vm cv com wcel va cv vm cv cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal va cv vm cv csuc
      cen wbr vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa vc cv
      cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral
      w3a vc cfn wrex wi wi vm cv com wcel va cv vm cv csuc cen wbr va cv vm cv
      cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc
      cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi
      wi va wal vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa vc
      cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral
      w3a vc cfn wrex wi wi vm cv com wcel va cv vm cv csuc cen wbr va cv vm cv
      cen wbr cB cM wcel wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc
      cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi
      wi va wal vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa vc
      cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral
      w3a vc cfn wrex wi wi wi va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx
      va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv
      wrex vy vc cv wral w3a vc cfn wrex wi wi va wal vm cv com wcel va cv vm
      cv csuc cen wbr wa vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi va cv vm cv cen wbr cB cM wcel wph vy cB
      wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx
      va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal vm cv com wcel va
      cv vm cv csuc cen wbr wa vz cv va cv wcel cB cM wcel wph vy cB wrex vx va
      cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex
      vy vc cv wral w3a vc cfn wrex vm cv com wcel va cv vm cv csuc cen wbr wa
      vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa w3a va cv vz
      cv csn cdif vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv vz cv csn
      cdif wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral
      wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex wi wi vc
      cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral
      w3a vc cfn wrex va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi va wal vm cv com wcel va cv vm cv csuc
      cen wbr wa vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa
      w3a va cv vz cv csn cdif vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv
      vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn
      cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex
      wi wi cB cM wcel wph vy cB wrex vx va cv vz cv csn cdif wral wa vc cv cB
      wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn
      cdif wrex vy vc cv wral w3a vc cfn wrex wi vc cv cB wss wph vy vc cv wrex
      vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex vm cv com
      wcel va cv vm cv csuc cen wbr wa vz cv va cv wcel cB cM wcel wph vy cB
      wrex vx va cv wral wa w3a va cv vz cv csn cdif vm cv cen wbr va cv vz cv
      csn cdif vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv vz cv csn cdif
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph
      vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex wi wi cB cM
      wcel wph vy cB wrex vx va cv vz cv csn cdif wral wa vc cv cB wss wph vy
      vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex
      vy vc cv wral w3a vc cfn wrex wi wi vm cv com wcel va cv vm cv csuc cen
      wbr wa vz cv va cv wcel va cv vz cv csn cdif vm cv cen wbr cB cM wcel wph
      vy cB wrex vx va cv wral wa vm cv com wcel va cv vm cv csuc cen wbr vz cv
      va cv wcel va cv vz cv csn cdif vm cv cen wbr va cv vm cv vz cv va visset
      dif1en 3expa 3adant3 va cv vz cv csn cdif vm cv cen wbr cB cM wcel wph vy
      cB wrex vx va cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx
      va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral
      w3a vc cfn wrex wi pm2.27 syl vz cv va cv wcel cB cM wcel wph vy cB wrex
      vx va cv wral wa cB cM wcel wph vy cB wrex vx va cv vz cv csn cdif wral
      wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va
      cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex wi vc cv cB wss wph
      vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cfn
      wrex wi vm cv com wcel va cv vm cv csuc cen wbr wa vz cv va cv wcel cB cM
      wcel wph vy cB wrex vx va cv wral wa wa cB cM wcel wph vy cB wrex vx va
      cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv
      csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn
      wrex wi vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph
      vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex vc cv cB wss
      wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc
      cfn wrex vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa
      cB cM wcel wph vy cB wrex vx va cv vz cv csn cdif wral wa cB cM wcel wph
      vy cB wrex vx va cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex
      vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv
      wral w3a vc cfn wrex wi vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn
      cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex
      wi cB cM wcel wph vy cB wrex vx va cv wral wa cB cM wcel wph vy cB wrex
      vx va cv vz cv csn cdif wral wa vz cv va cv wcel wph vy cB wrex vx va cv
      wral wph vy cB wrex vx va cv vz cv csn cdif wral cB cM wcel va cv vz cv
      csn cdif va cv wss wph vy cB wrex vx va cv wral wph vy cB wrex vx va cv
      vz cv csn cdif wral wi va cv vz cv csn difss wph vy cB wrex vx va cv vz
      cv csn cdif va cv ssralv ax-mp anim2i adantl cB cM wcel wph vy cB wrex vx
      va cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz
      cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc
      cfn wrex pm2.27 syl vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv
      wral wa wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral
      wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn wrex vb cv cB
      wss wph vy vb cv wrex vx va cv wral wph vx va cv wrex vy vb cv wral w3a
      vb cfn wrex vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv
      wrex vy vc cv wral w3a vc cfn wrex vz cv va cv wcel cB cM wcel wph vy cB
      wrex vx va cv wral wa wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv
      csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vb cv cB
      wss wph vy vb cv wrex vx va cv wral wph vx va cv wrex vy vb cv wral w3a
      vb cfn wrex vc cfn vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv
      wral wa wa vc cv cfn wcel wa wph vx vz wsb vy cB wrex vc cv cB wss wph vy
      vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex
      vy vc cv wral w3a vb cv cB wss wph vy vb cv wrex vx va cv wral wph vx va
      cv wrex vy vb cv wral w3a vb cfn wrex wi vz cv va cv wcel cB cM wcel wph
      vy cB wrex vx va cv wral wa wa wph vx vz wsb vy cB wrex vc cv cfn wcel vz
      cv va cv wcel wph vy cB wrex vx va cv wral wph vx vz wsb vy cB wrex cB cM
      wcel vz cv va cv wcel wph vy cB wrex vx va cv wral wph vx vz wsb vy cB
      wrex wph vy cB wrex wph vx vz wsb vy cB wrex vx vz cv va cv wph vx vz wsb
      vx vy cB vy cv cB wcel vx ax-17 wph vx vz wph vz ax-17 hbsb3 hbrex vx cv
      vz cv wceq wph wph vx vz wsb vy cB wph vx vz cv sbceq1a rexbidv rcla4 imp
      adantrl adantr vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral
      wa wa vc cv cfn wcel wa wph vx vz wsb vy vw wsb vw cB wrex vc cv cB wss
      wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn
      cdif wrex vy vc cv wral w3a vb cv cB wss wph vy vb cv wrex vx va cv wral
      wph vx va cv wrex vy vb cv wral w3a vb cfn wrex wi wph vx vz wsb vy cB
      wrex vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv
      cfn wcel wa wph vx vz wsb vy vw wsb vc cv cB wss wph vy vc cv wrex vx va
      cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a
      vb cv cB wss wph vy vb cv wrex vx va cv wral wph vx va cv wrex vy vb cv
      wral w3a vb cfn wrex wi vw cB vz cv va cv wcel cB cM wcel wph vy cB wrex
      vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy
      vw wsb vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx
      va cv vz cv csn cdif wrex vy vc cv wral w3a vb cv cB wss wph vy vb cv
      wrex vx va cv wral wph vx va cv wrex vy vb cv wral w3a vb cfn wrex vc cv
      vw cv csn cun cfn wcel vc cv vw cv csn cun cB wss wph vy vc cv vw cv csn
      cun wrex vx va cv wral wph vx va cv wrex vy vc cv vw cv csn cun wral w3a
      vb cv cB wss wph vy vb cv wrex vx va cv wral wph vx va cv wrex vy vb cv
      wral w3a vb cfn wrex vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv
      wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw wsb wa
      vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv
      vz cv csn cdif wrex vy vc cv wral w3a wa vb cv cB wss wph vy vb cv wrex
      vx va cv wral wph vx va cv wrex vy vb cv wral w3a vc cv vw cv csn cun cB
      wss wph vy vc cv vw cv csn cun wrex vx va cv wral wph vx va cv wrex vy vc
      cv vw cv csn cun wral w3a vb vc cv vw cv csn cun cfn vb cv vc cv vw cv
      csn cun wceq vb cv cB wss vc cv vw cv csn cun cB wss wph vy vb cv wrex vx
      va cv wral wph vy vc cv vw cv csn cun wrex vx va cv wral wph vx va cv
      wrex vy vb cv wral wph vx va cv wrex vy vc cv vw cv csn cun wral vb cv vc
      cv vw cv csn cun cB sseq1 vb cv vc cv vw cv csn cun wceq wph vy vb cv
      wrex wph vy vc cv vw cv csn cun wrex vx va cv wph vy vb cv vc cv vw cv
      csn cun rexeq1 ralbidv wph vx va cv wrex vy vb cv vc cv vw cv csn cun
      raleq1 3anbi123d rcla4ev vz cv va cv wcel cB cM wcel wph vy cB wrex vx va
      cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa vc cv vw cv csn cun cfn
      wcel wph vx vz wsb vy vw wsb vc cv cB wss wph vy vc cv wrex vx va cv vz
      cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cv
      cfn wcel vc cv vw cv csn cun cfn wcel vz cv va cv wcel cB cM wcel wph vy
      cB wrex vx va cv wral wa wa vw cv cB wcel vc cv cfn wcel vw cv csn cfn
      wcel vc cv vw cv csn cun cfn wcel vw cv snfi vc cv vw cv csn unfi mpan2
      ad2antlr ad2antrr vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv
      wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw wsb wa
      vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv
      vz cv csn cdif wrex vy vc cv wral w3a wa vc cv vw cv csn cun cB wss wph
      vy vc cv vw cv csn cun wrex vx va cv wral wph vx va cv wrex vy vc cv vw
      cv csn cun wral vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral
      wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw wsb wa wph
      vy vc cv wrex vx va cv vz cv csn cdif wral vc cv cB wss vc cv vw cv csn
      cun cB wss wph vx va cv vz cv csn cdif wrex vy vc cv wral vw cv cB wcel
      wph vx vz wsb vy vw wsb vc cv cB wss vc cv vw cv csn cun cB wss vz cv va
      cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa
      vw cv cB wcel vc cv cB wss vc cv vw cv csn cun cB wss wph vx vz wsb vy vw
      wsb vc cv cB wss vw cv cB wcel vc cv vw cv csn cun cB wss vc cv cB wss vw
      cv csn cB wss vc cv vw cv csn cun cB wss vw cv cB wcel vc cv cB wss vw cv
      csn cB wss wa vc cv vw cv csn cun cB wss vc cv vw cv csn cB unss biimpi
      vw cv cB vw visset snss sylan2b ancoms adantlr adantlll 3ad2antr1 vz cv
      va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel
      wa vw cv cB wcel wa wph vx vz wsb vy vw wsb wa vc cv cB wss wph vy vc cv
      wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc
      cv wral w3a wa wph vy vc cv vw cv csn cun wrex vx va cv vz cv va cv wcel
      cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB
      wcel wa wph vx vz wsb vy vw wsb wa vc cv cB wss wph vy vc cv wrex vx va
      cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a
      vx vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv
      cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw wsb vx vz cv va cv wcel
      cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB
      wcel vx vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc
      cv cfn wcel vx vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv wral
      wa vx vz cv va cv wcel vx ax-17 cB cM wcel wph vy cB wrex vx va cv wral
      vx cB cM wcel vx ax-17 wph vy cB wrex vx va cv hbra1 hban hban vc cv cfn
      wcel vx ax-17 hban vw cv cB wcel vx ax-17 hban wph vx vz wsb vy vw vx wph
      vx vz wph vz ax-17 hbsb3 hbsb hban vc cv cB wss wph vy vc cv wrex vx va
      cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral vx
      vc cv cB wss vx ax-17 wph vy vc cv wrex vx va cv vz cv csn cdif hbra1 wph
      vx va cv vz cv csn cdif wrex vx vy vc cv vy cv vc cv wcel vx ax-17 wph vx
      va cv vz cv csn cdif hbre1 hbral hb3an hban vz cv va cv wcel cB cM wcel
      wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph
      vx vz wsb vy vw wsb wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn
      cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a wa vx cv va
      cv wcel vx cv vz cv wceq vx cv va cv vz cv csn cdif wcel wo wph vy vc cv
      vw cv csn cun wrex vz cv va cv wcel cB cM wcel wph vy cB wrex vx va cv
      wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw wsb wa
      vx cv va cv wcel vx cv vz cv wceq vx cv va cv vz cv csn cdif wcel wo wi
      vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv
      vz cv csn cdif wrex vy vc cv wral w3a vz cv va cv wcel cB cM wcel wph vy
      cB wrex vx va cv wral wa wa vc cv cfn wcel wa vx cv va cv wcel vx cv vz
      cv wceq vx cv va cv vz cv csn cdif wcel wo wi vw cv cB wcel wph vx vz wsb
      vy vw wsb vz cv va cv wcel vx cv va cv wcel vx cv vz cv wceq vx cv va cv
      vz cv csn cdif wcel wo wi cB cM wcel wph vy cB wrex vx va cv wral wa vc
      cv cfn wcel vz cv va cv wcel vz cv csn va cv wss vz cv csn va cv vz cv
      csn cdif cun va cv wceq vx cv va cv wcel vx cv vz cv wceq vx cv va cv vz
      cv csn cdif wcel wo wi vz cv va cv snssi vz cv csn va cv wss vz cv csn va
      cv vz cv csn cdif cun va cv wceq vz cv csn va cv undif biimpi vz cv csn
      va cv vz cv csn cdif cun va cv wceq vx cv va cv wcel vx cv vz cv csn va
      cv vz cv csn cdif cun wcel vx cv vz cv wceq vx cv va cv vz cv csn cdif
      wcel wo vz cv csn va cv vz cv csn cdif cun va cv vx cv eleq2 vx cv vz cv
      csn va cv vz cv csn cdif cun wcel vx cv vz cv wceq vx cv va cv vz cv csn
      cdif wcel wo vx cv vz cv csn va cv vz cv csn cdif cun wcel vx cv vz cv
      csn wcel vx cv va cv vz cv csn cdif wcel wo vx cv vz cv wceq vx cv va cv
      vz cv csn cdif wcel wo vx cv vz cv csn va cv vz cv csn cdif elun vx cv vz
      cv csn wcel vx cv vz cv wceq vx cv va cv vz cv csn cdif wcel vx vz cv
      elsn orbi1i bitri biimpi syl6bir 3syl ad2antrr ad2antrr adantr vz cv va
      cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa
      vw cv cB wcel wa wph vx vz wsb vy vw wsb wa vc cv cB wss wph vy vc cv
      wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc
      cv wral w3a wa vx cv vz cv wceq wph vy vc cv vw cv csn cun wrex vx cv va
      cv vz cv csn cdif wcel wph vx vz wsb vy vw wsb vx cv vz cv wceq wph vy vc
      cv vw cv csn cun wrex wi vz cv va cv wcel cB cM wcel wph vy cB wrex vx va
      cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa vc cv cB wss wph vy vc
      cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy
      vc cv wral w3a vx cv vz cv wceq wph vx vz wsb vy vw wsb wph vy vc cv vw
      cv csn cun wrex vx cv vz cv wceq wph vx vz wsb vy vw wsb wph vy vw wsb
      wph vy vc cv vw cv csn cun wrex vx cv vz cv wceq wph wph vx vz wsb vy vw
      vx cv vz cv wceq vy ax-17 wph vx vz cv sbceq1a sbbid vw cv vc cv vw cv
      csn cun wcel wph vy vw wsb wph vy vc cv vw cv csn cun wrex vw cv vw cv
      csn wcel vw cv vc cv vw cv csn cun wcel vw cv vw visset snid vw cv vw cv
      csn vc cv elun2 ax-mp wph wph vy vw wsb vy vw cv vc cv vw cv csn cun wph
      vy vw wph vw ax-17 hbsb3 wph vy vw cv sbceq1a rcla4e mpan syl6bir com12
      ad2antlr vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph
      vx va cv vz cv csn cdif wrex vy vc cv wral w3a vx cv va cv vz cv csn cdif
      wcel wph vy vc cv vw cv csn cun wrex wi vz cv va cv wcel cB cM wcel wph
      vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx
      vz wsb vy vw wsb wa wph vy vc cv wrex vx va cv vz cv csn cdif wral vc cv
      cB wss vx cv va cv vz cv csn cdif wcel wph vy vc cv vw cv csn cun wrex wi
      wph vx va cv vz cv csn cdif wrex vy vc cv wral wph vy vc cv wrex vx va cv
      vz cv csn cdif wral vx cv va cv vz cv csn cdif wcel wph vy vc cv wrex wph
      vy vc cv vw cv csn cun wrex wph vy vc cv wrex vx va cv vz cv csn cdif ra4
      vc cv vc cv vw cv csn cun wss wph vy vc cv wrex wph vy vc cv vw cv csn
      cun wrex wi vc cv vw cv csn ssun1 wph vy vc cv vc cv vw cv csn cun ssrexv
      ax-mp syl6 3ad2ant2 adantl jaod syld r19.21ai vz cv va cv wcel cB cM wcel
      wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph
      vx vz wsb vy vw wsb wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn
      cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a wa wph vx va
      cv wrex vy vc cv vw cv csn cun vz cv va cv wcel cB cM wcel wph vy cB wrex
      vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy
      vw wsb wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph
      vx va cv vz cv csn cdif wrex vy vc cv wral w3a vy vz cv va cv wcel cB cM
      wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel
      wa wph vx vz wsb vy vw wsb vy vz cv va cv wcel cB cM wcel wph vy cB wrex
      vx va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel vy vz cv va cv wcel
      cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel vy vz cv va
      cv wcel cB cM wcel wph vy cB wrex vx va cv wral wa vy vz cv va cv wcel vy
      ax-17 cB cM wcel wph vy cB wrex vx va cv wral vy cB cM wcel vy ax-17 wph
      vy cB wrex vy vx va cv vx cv va cv wcel vy ax-17 wph vy cB hbre1 hbral
      hban hban vc cv cfn wcel vy ax-17 hban vw cv cB wcel vy ax-17 hban wph vx
      vz wsb vy vw wph vx vz wsb vw ax-17 hbsb3 hban vc cv cB wss wph vy vc cv
      wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc
      cv wral vy vc cv cB wss vy ax-17 wph vy vc cv wrex vy vx va cv vz cv csn
      cdif vx cv va cv vz cv csn cdif wcel vy ax-17 wph vy vc cv hbre1 hbral
      wph vx va cv vz cv csn cdif wrex vy vc cv hbra1 hb3an hban vz cv va cv
      wcel cB cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw
      cv cB wcel wa wph vx vz wsb vy vw wsb wa vc cv cB wss wph vy vc cv wrex
      vx va cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv
      wral w3a wa vy cv vc cv wcel vy cv vw cv wceq wo wph vx va cv wrex vy cv
      vc cv vw cv csn cun wcel vz cv va cv wcel cB cM wcel wph vy cB wrex vx va
      cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw wsb
      wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va
      cv vz cv csn cdif wrex vy vc cv wral w3a wa vy cv vc cv wcel wph vx va cv
      wrex vy cv vw cv wceq vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn
      cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vy cv vc cv
      wcel wph vx va cv wrex wi vz cv va cv wcel cB cM wcel wph vy cB wrex vx
      va cv wral wa wa vc cv cfn wcel wa vw cv cB wcel wa wph vx vz wsb vy vw
      wsb wa wph vx va cv vz cv csn cdif wrex vy vc cv wral vc cv cB wss vy cv
      vc cv wcel wph vx va cv wrex wi wph vy vc cv wrex vx va cv vz cv csn cdif
      wral wph vx va cv vz cv csn cdif wrex vy vc cv wral vy cv vc cv wcel wph
      vx va cv vz cv csn cdif wrex wph vx va cv wrex wph vx va cv vz cv csn
      cdif wrex vy vc cv ra4 va cv vz cv csn cdif va cv wss wph vx va cv vz cv
      csn cdif wrex wph vx va cv wrex wi va cv vz cv csn difss wph vx va cv vz
      cv csn cdif va cv ssrexv ax-mp syl6 3ad2ant3 adantl vz cv va cv wcel cB
      cM wcel wph vy cB wrex vx va cv wral wa wa vc cv cfn wcel wa vw cv cB
      wcel wa wph vx vz wsb vy vw wsb wa vy cv vw cv wceq wph vx va cv wrex wi
      vc cv cB wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv
      vz cv csn cdif wrex vy vc cv wral w3a vz cv va cv wcel cB cM wcel wph vy
      cB wrex vx va cv wral wa wa vc cv cfn wcel wa wph vx vz wsb vy vw wsb vy
      cv vw cv wceq wph vx va cv wrex wi vw cv cB wcel vz cv va cv wcel cB cM
      wcel wph vy cB wrex vx va cv wral wa wa wph vx vz wsb vy vw wsb vy cv vw
      cv wceq wph vx va cv wrex wi vc cv cfn wcel vz cv va cv wcel wph vx vz
      wsb vy vw wsb vy cv vw cv wceq wph vx va cv wrex wi cB cM wcel wph vy cB
      wrex vx va cv wral wa vz cv va cv wcel wph vx vz wsb vy vw wsb vy cv vw
      cv wceq wph vx va cv wrex vz cv va cv wcel wph vx vz wsb wph vx va cv
      wrex wph vx vz wsb vy vw wsb vy cv vw cv wceq wa wph wph vx vz wsb vx vz
      cv va cv wph vx vz wph vz ax-17 hbsb3 wph vx vz cv sbceq1a rcla4e vy cv
      vw cv wceq wph vx vz wsb wph vx vz wsb vy vw wsb wph vx vz wsb vy vw cv
      sbceq1a biimparc sylan2 expr adantlr adantlr adantlr adantr jaod vy cv vc
      cv vw cv csn cun wcel vy cv vc cv wcel vy cv vw cv csn wcel wo vy cv vc
      cv wcel vy cv vw cv wceq wo vy cv vc cv vw cv csn elun vy cv vw cv csn
      wcel vy cv vw cv wceq vy cv vc cv wcel vy vw cv elsn orbi2i bitri syl5ib
      r19.21ai 3jca sylanc exp31 r19.23adva wph vx vz wsb wph vx vz wsb vy vw
      wsb vy vw cB wph vx vz wsb vw ax-17 wph vx vz wsb vy vw wph vx vz wsb vw
      ax-17 hbsb3 wph vx vz wsb vy vw cv sbceq1a cbvrex syl5ib mpd r19.23adva
      vb cv cB wss wph vy vb cv wrex vx va cv wral wph vx va cv wrex vy vb cv
      wral w3a vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex
      vy vc cv wral w3a vb vc cfn vb cv vc cv wceq vb cv cB wss vc cv cB wss
      wph vy vb cv wrex vx va cv wral wph vy vc cv wrex vx va cv wral wph vx va
      cv wrex vy vb cv wral wph vx va cv wrex vy vc cv wral vb cv vc cv cB
      sseq1 vb cv vc cv wceq wph vy vb cv wrex wph vy vc cv wrex vx va cv wph
      vy vb cv vc cv rexeq1 ralbidv wph vx va cv wrex vy vb cv vc cv raleq1
      3anbi123d cbvrexv syl6ib syld 3adant1 syld va cv vm cv cen wbr cB cM wcel
      wph vy cB wrex vx va cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv
      wral wph vx va cv wrex vy vc cv wral w3a vc cfn wrex wi wi va wal vb cv
      vm cv cen wbr cB cM wcel wph vy cB wrex vx vb cv wral wa vc cv cB wss wph
      vy vc cv wrex vx vb cv wral wph vx vb cv wrex vy vc cv wral w3a vc cfn
      wrex wi wi vb wal va cv vz cv csn cdif vm cv cen wbr cB cM wcel wph vy cB
      wrex vx va cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx va
      cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a
      vc cfn wrex wi wi va cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi wi vb cv vm cv cen wbr cB cM wcel wph vy cB
      wrex vx vb cv wral wa vc cv cB wss wph vy vc cv wrex vx vb cv wral wph vx
      vb cv wrex vy vc cv wral w3a vc cfn wrex wi wi va vb va cv vb cv wceq va
      cv vm cv cen wbr vb cv vm cv cen wbr cB cM wcel wph vy cB wrex vx va cv
      wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex vy
      vc cv wral w3a vc cfn wrex wi cB cM wcel wph vy cB wrex vx vb cv wral wa
      vc cv cB wss wph vy vc cv wrex vx vb cv wral wph vx vb cv wrex vy vc cv
      wral w3a vc cfn wrex wi va cv vb cv vm cv cen breq1 va cv vb cv wceq cB
      cM wcel wph vy cB wrex vx va cv wral wa cB cM wcel wph vy cB wrex vx vb
      cv wral wa vc cv cB wss wph vy vc cv wrex vx va cv wral wph vx va cv wrex
      vy vc cv wral w3a vc cfn wrex vc cv cB wss wph vy vc cv wrex vx vb cv
      wral wph vx vb cv wrex vy vc cv wral w3a vc cfn wrex va cv vb cv wceq wph
      vy cB wrex vx va cv wral wph vy cB wrex vx vb cv wral cB cM wcel wph vy
      cB wrex vx va cv vb cv raleq1 anbi2d va cv vb cv wceq vc cv cB wss wph vy
      vc cv wrex vx va cv wral wph vx va cv wrex vy vc cv wral w3a vc cv cB wss
      wph vy vc cv wrex vx vb cv wral wph vx vb cv wrex vy vc cv wral w3a vc
      cfn va cv vb cv wceq wph vy vc cv wrex vx va cv wral wph vy vc cv wrex vx
      vb cv wral wph vx va cv wrex vy vc cv wral wph vx vb cv wrex vy vc cv
      wral vc cv cB wss wph vy vc cv wrex vx va cv vb cv raleq1 va cv vb cv
      wceq wph vx va cv wrex wph vx vb cv wrex vy vc cv wph vx va cv vb cv
      rexeq1 ralbidv 3anbi23d rexbidv imbi12d imbi12d cbvalv va cv vz cv csn
      cdif cvv wcel vb cv vm cv cen wbr cB cM wcel wph vy cB wrex vx vb cv wral
      wa vc cv cB wss wph vy vc cv wrex vx vb cv wral wph vx vb cv wrex vy vc
      cv wral w3a vc cfn wrex wi wi vb wal va cv vz cv csn cdif vm cv cen wbr
      cB cM wcel wph vy cB wrex vx va cv vz cv csn cdif wral wa vc cv cB wss
      wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn
      cdif wrex vy vc cv wral w3a vc cfn wrex wi wi wi va cv cvv wcel va cv vz
      cv csn cdif cvv wcel va visset va cv vz cv csn cvv difexg ax-mp vb cv vm
      cv cen wbr cB cM wcel wph vy cB wrex vx vb cv wral wa vc cv cB wss wph vy
      vc cv wrex vx vb cv wral wph vx vb cv wrex vy vc cv wral w3a vc cfn wrex
      wi wi va cv vz cv csn cdif vm cv cen wbr cB cM wcel wph vy cB wrex vx va
      cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz cv
      csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc cfn
      wrex wi wi vb va cv vz cv csn cdif cvv vb cv va cv vz cv csn cdif wceq vb
      cv vm cv cen wbr va cv vz cv csn cdif vm cv cen wbr cB cM wcel wph vy cB
      wrex vx vb cv wral wa vc cv cB wss wph vy vc cv wrex vx vb cv wral wph vx
      vb cv wrex vy vc cv wral w3a vc cfn wrex wi cB cM wcel wph vy cB wrex vx
      va cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex vx va cv vz
      cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a vc
      cfn wrex wi vb cv va cv vz cv csn cdif vm cv cen breq1 vb cv va cv vz cv
      csn cdif wceq cB cM wcel wph vy cB wrex vx vb cv wral wa cB cM wcel wph
      vy cB wrex vx va cv vz cv csn cdif wral wa vc cv cB wss wph vy vc cv wrex
      vx vb cv wral wph vx vb cv wrex vy vc cv wral w3a vc cfn wrex vc cv cB
      wss wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx va cv vz cv csn
      cdif wrex vy vc cv wral w3a vc cfn wrex vb cv va cv vz cv csn cdif wceq
      wph vy cB wrex vx vb cv wral wph vy cB wrex vx va cv vz cv csn cdif wral
      cB cM wcel wph vy cB wrex vx vb cv va cv vz cv csn cdif raleq1 anbi2d vb
      cv va cv vz cv csn cdif wceq vc cv cB wss wph vy vc cv wrex vx vb cv wral
      wph vx vb cv wrex vy vc cv wral w3a vc cv cB wss wph vy vc cv wrex vx va
      cv vz cv csn cdif wral wph vx va cv vz cv csn cdif wrex vy vc cv wral w3a
      vc cfn vb cv va cv vz cv csn cdif wceq wph vy vc cv wrex vx vb cv wral
      wph vy vc cv wrex vx va cv vz cv csn cdif wral wph vx vb cv wrex vy vc cv
      wral wph vx va cv vz cv csn cdif wrex vy vc cv wral vc cv cB wss wph vy
      vc cv wrex vx vb cv va cv vz cv csn cdif raleq1 vb cv va cv vz cv csn
      cdif wceq wph vx vb cv wrex wph vx va cv vz cv csn cdif wrex vy vc cv wph
      vx vb cv va cv vz cv csn cdif rexeq1 ralbidv 3anbi23d rexbidv imbi12d
      imbi12d cla4gv ax-mp sylbi syl5com 3expd com12 ex com23 3imp 19.23adv mpd
      3exp 19.21ad finds syl5 com3l r19.23aiv mpcom 3impib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F c x y $. $d A c x y $. $d B c x y $. $d M c x y $.
    $( Given a finite subset ` A ` of the range of a function, there exists a
    finite subset of the domain whose image is ` A ` . $)
    fipreima $p |- ( ( ( F Fn B /\ B e. M ) /\ ( A C_ ran F /\ A e. Fin ) ) ->
                                    E. c e. ( ~P B i^i Fin ) ( F " c ) = A ) $=
      cF cB wfn cB cM wcel wa cA cF crn wss cA cfn wcel wa wa vc cv cB wss vy
      cv cF cfv vx cv wceq vy vc cv wrex vx cA wral vy cv cF cfv vx cv wceq vx
      cA wrex vy vc cv wral w3a vc cfn wrex cF vc cv cima cA wceq vc cB cpw cfn
      cin wrex cA cfn wcel cB cM wcel vy cv cF cfv vx cv wceq vy cB wrex vx cA
      wral vc cv cB wss vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral vy cv
      cF cfv vx cv wceq vx cA wrex vy vc cv wral w3a vc cfn wrex cF cB wfn cB
      cM wcel wa cA cF crn wss cA cfn wcel wa wa vy cv cF cfv vx cv wceq vx vy
      cA cB cM vc indexf cF cB wfn cB cM wcel wa cA cF crn wss cA cfn wcel
      simprr cF cB wfn cB cM wcel cA cF crn wss cA cfn wcel wa simplr cF cB wfn
      cA cF crn wss vy cv cF cfv vx cv wceq vy cB wrex vx cA wral cB cM wcel cA
      cfn wcel cF cB wfn cA cF crn wss vy cv cF cfv vx cv wceq vy cB wrex vx cA
      wral cF cB wfn vx cv cF crn wcel vx cA wral vy cv cF cfv vx cv wceq vy cB
      wrex vx cA wral cA cF crn wss cF cB wfn vx cv cF crn wcel vx cA wral vy
      cv cF cfv vx cv wceq vy cB wrex vx cA wral cF cB wfn vx cv cF crn wcel vy
      cv cF cfv vx cv wceq vy cB wrex vx cA vy cB vx cv cF fvelrnb ralbidv
      biimpd vx cA cF crn dfss3 syl5ib imp ad2ant2r syl3anc cF cB wfn vc cv cB
      wss vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral vy cv cF cfv vx cv
      wceq vx cA wrex vy vc cv wral w3a vc cfn wrex cF vc cv cima cA wceq vc cB
      cpw cfn cin wrex wi cB cM wcel cA cF crn wss cA cfn wcel wa cF cB wfn vc
      cv cB wss vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral vy cv cF cfv
      vx cv wceq vx cA wrex vy vc cv wral w3a cF vc cv cima cA wceq vc cfn cB
      cpw cfn cin cF cB wfn vc cv cfn wcel vc cv cB wss vy cv cF cfv vx cv wceq
      vy vc cv wrex vx cA wral vy cv cF cfv vx cv wceq vx cA wrex vy vc cv wral
      w3a wa vc cv cB cpw cfn cin wcel cF vc cv cima cA wceq vc cv cfn wcel vc
      cv cB wss vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral vy cv cF cfv
      vx cv wceq vx cA wrex vy vc cv wral w3a wa vc cv cB cpw cfn cin wcel wi
      cF cB wfn vc cv cfn wcel vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral
      vc cv cB wss vc cv cB cpw cfn cin wcel vy cv cF cfv vx cv wceq vx cA wrex
      vy vc cv wral vc cv cfn wcel vc cv cB wss wa vc cv cB cpw wcel vc cv cfn
      wcel wa vc cv cB cpw cfn cin wcel vc cv cB wss vc cv cfn wcel vc cv cB
      cpw wcel vc cv cfn wcel wa vc cv cB wss vc cv cB cpw wcel vc cv cfn wcel
      vc cv cB cpw wcel vc cv cB wss vc cv cB wss vc cB cpw vc cB df-pw abeq2i
      biimpri anim1i ancoms vc cv cB cpw cfn elin sylibr 3ad2antr1 a1i cF cB
      wfn vc cv cB wss vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral vy cv
      cF cfv vx cv wceq vx cA wrex vy vc cv wral w3a cF vc cv cima cA wceq vc
      cv cfn wcel cF cB wfn vc cv cB wss vy cv cF cfv vx cv wceq vy vc cv wrex
      vx cA wral vy cv cF cfv vx cv wceq vx cA wrex vy vc cv wral w3a cF vc cv
      cima cA wceq cF cB wfn vc cv cB wss vy cv cF cfv vx cv wceq vy vc cv wrex
      vx cA wral vy cv cF cfv vx cv wceq vx cA wrex vy vc cv wral w3a wa cF vc
      cv cima cA cF cB wfn vc cv cB wss vy cv cF cfv vx cv wceq vx cA wrex vy
      vc cv wral cF vc cv cima cA wss vy cv cF cfv vx cv wceq vy vc cv wrex vx
      cA wral cF cB wfn vc cv cB wss vy cv cF cfv vx cv wceq vx cA wrex vy vc
      cv wral cF vc cv cima cA wss cF cB wfn vc cv cB wss wa cF vc cv cima cA
      wss vy cv cF cfv cA wcel vy vc cv wral vy cv cF cfv vx cv wceq vx cA wrex
      vy vc cv wral cF wfun vc cv cF cdm wss cF vc cv cima cA wss vy cv cF cfv
      cA wcel vy vc cv wral wb cF cB wfn vc cv cB wss wa vy vc cv cA cF
      funimass4 cF cB wfn cF wfun vc cv cB wss cB cF fnfun adantr cF cB wfn vc
      cv cF cdm wss vc cv cB wss cF cB wfn cF cdm cB vc cv cB cF fndm sseq2d
      biimpar sylanc vy cv cF cfv vx cv wceq vx cA wrex vy cv cF cfv cA wcel vy
      vc cv vy cv cF cfv vx cv wceq vy cv cF cfv cA wcel vx cA vx cv cA vy cv
      cF cfv eleq1a r19.23aiv r19.20si syl5bir impr 3adantr2 cF cB wfn vc cv cB
      wss vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral cA cF vc cv cima wss
      vy cv cF cfv vx cv wceq vx cA wrex vy vc cv wral cF cB wfn vc cv cB wss
      vy cv cF cfv vx cv wceq vy vc cv wrex vx cA wral wa wa vx cv cF vc cv
      cima wcel vx cA wral cA cF vc cv cima wss cF cB wfn vc cv cB wss vy cv cF
      cfv vx cv wceq vy vc cv wrex vx cA wral vx cv cF vc cv cima wcel vx cA
      wral cF cB wfn vc cv cB wss wa vy cv cF cfv vx cv wceq vy vc cv wrex vx
      cv cF vc cv cima wcel vx cA cF cB wfn vc cv cB wss wa vy cv cF cfv vx cv
      wceq vx cv cF vc cv cima wcel vy vc cv vy cv cF cfv vx cv wceq vy cv cF
      cfv cF vc cv cima wcel vx cv cF vc cv cima wcel cF cB wfn vc cv cB wss wa
      vy cv vc cv wcel wa vy cv cF cfv vx cv cF vc cv cima eleq1 cF wfun vy cv
      cF cdm wcel vy cv vc cv wcel vy cv cF cfv cF vc cv cima wcel cF cB wfn vc
      cv cB wss wa vy cv vc cv wcel wa cF wfun vy cv cF cdm wcel vy cv vc cv
      wcel vy cv cF cfv cF vc cv cima wcel vc cv vy cv cF funfvima 3impia cF cB
      wfn cF wfun vc cv cB wss vy cv vc cv wcel cB cF fnfun ad2antrr cF cB wfn
      vc cv cB wss vy cv vc cv wcel vy cv cF cdm wcel cF cB wfn vy cv cB wcel
      vy cv cF cdm wcel vc cv cB wss vy cv vc cv wcel wa vy cv cF cdm wcel cB
      vy cv cF cF wfun vy cv cF cdm wcel pm3.27 funfni vc cv cB vy cv ssel2
      sylan2 anassrs cF cB wfn vc cv cB wss wa vy cv vc cv wcel pm3.27 syl3anc
      syl5cbi r19.23adva r19.20sdv impr vx cA cF vc cv cima dfss3 sylibr
      3adantr3 eqssd ex adantld jcad r19.22dv2 ad2antrr mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y z $. $d B u v w x y z $.
    $( A set which is closed under pairwise intersection is closed under
    finite intersection. $)
    inficl $p |- ( ( A e. B /\ A. x e. A A. y e. A ( x i^i y ) e. A )
                                                        -> ( fi ` A ) = A ) $=
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa cA cfi cfv cA
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vz cA cfi cfv
      cA cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vz cv cA
      cfi cfv wcel vw cv cA wss vw cv cfn wcel vz cv vw cv cint wceq w3a vw wex
      vz cv cA wcel cA cB wcel vz cv cA cfi cfv wcel vw cv cA wss vw cv cfn
      wcel vz cv vw cv cint wceq w3a vw wex wb vx cv vy cv cin cA wcel vy cA
      wral vx cA wral vz cv cvv wcel cA cB wcel vz cv cA cfi cfv wcel vw cv cA
      wss vw cv cfn wcel vz cv vw cv cint wceq w3a vw wex wb vz visset vw vz cv
      cvv cA cB sppfi mpan adantr cA cB wcel vx cv vy cv cin cA wcel vy cA wral
      vx cA wral wa vw cv cA wss vw cv cfn wcel vz cv vw cv cint wceq w3a vz cv
      cA wcel vw cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vw
      cv cA wss vw cv cfn wcel vz cv vw cv cint wceq vz cv cA wcel cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vw cv cA wss vw cv cfn
      wcel vz cv vw cv cint wceq vz cv cA wcel wi cA cB wcel vx cv vy cv cin cA
      wcel vy cA wral vx cA wral wa vw cv cA wss vw cv cfn wcel w3a vz cv vw cv
      cint wceq vw cv c0 wne vz cv cA wcel vz cv vw cv cint wceq vw cv c0 vw cv
      c0 wceq vz cv vw cv cint wceq vz cv cvv wceq vz cv cvv wceq cvv cvv wcel
      vprc vz cv cvv wceq vz cv cvv wcel cvv cvv wcel vz visset vz cv cvv cvv
      eleq1 mpbii mto vw cv c0 wceq vz cv vw cv cint wceq vz cv c0 cint wceq vz
      cv cvv wceq vw cv c0 wceq vw cv cint c0 cint vz cv vw cv c0 inteq eqeq2d
      vz cv c0 cint wceq c0 cint cvv wceq vz cv cvv wceq int0 vz cv c0 cint cvv
      eqtr mpan2 syl6bi mtoi necon2ai cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa vw cv cA wss vw cv cfn wcel w3a vw cv c0 wne vz cv vw
      cv cint wceq vz cv cA wcel cA cB wcel vx cv vy cv cin cA wcel vy cA wral
      vx cA wral wa vw cv cA wss vw cv cfn wcel w3a vw cv c0 wne vw cv cint cA
      wcel vz cv vw cv cint wceq vz cv cA wcel wi cA cB wcel vx cv vy cv cin cA
      wcel vy cA wral vx cA wral wa vw cv cA wss vw cv cfn wcel vw cv c0 wne vw
      cv cint cA wcel wi cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA
      wral wa vw cv cA wss wa vw cv c0 wne vw cv cfn wcel vw cv cint cA wcel cA
      cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vw cv cA wss vw
      cv c0 wne vw cv cfn wcel vw cv cint cA wcel wi vw cv cfn wcel cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vw cv cA wss vw cv c0
      wne wa wa vw cv cint cA wcel cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa vu cv cA wss vu cv c0 wne wa wa vu cv cint cA wcel wi
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa c0 cA wss c0
      c0 wne wa wa c0 cint cA wcel wi cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0
      wne wa wa vv cv vz cv csn cdif cint cA wcel wi cA cB wcel vx cv vy cv cin
      cA wcel vy cA wral vx cA wral wa vv cv cA wss vv cv c0 wne wa wa vv cv
      cint cA wcel wi cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral
      wa vw cv cA wss vw cv c0 wne wa wa vw cv cint cA wcel wi vu vv vz vw cv
      vu cv c0 wceq cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa
      vu cv cA wss vu cv c0 wne wa wa cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa c0 cA wss c0 c0 wne wa wa vu cv cint cA wcel c0 cint
      cA wcel vu cv c0 wceq vu cv cA wss vu cv c0 wne wa c0 cA wss c0 c0 wne wa
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vu cv c0 wceq
      vu cv cA wss c0 cA wss vu cv c0 wne c0 c0 wne vu cv c0 cA sseq1 vu cv c0
      c0 neeq1 anbi12d anbi2d vu cv c0 wceq vu cv cint c0 cint cA vu cv c0
      inteq eleq1d imbi12d vu cv vv cv vz cv csn cdif wceq cA cB wcel vx cv vy
      cv cin cA wcel vy cA wral vx cA wral wa vu cv cA wss vu cv c0 wne wa wa
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv
      csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vu cv cint cA wcel vv
      cv vz cv csn cdif cint cA wcel vu cv vv cv vz cv csn cdif wceq vu cv cA
      wss vu cv c0 wne wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0
      wne wa cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vu cv
      vv cv vz cv csn cdif wceq vu cv cA wss vv cv vz cv csn cdif cA wss vu cv
      c0 wne vv cv vz cv csn cdif c0 wne vu cv vv cv vz cv csn cdif cA sseq1 vu
      cv vv cv vz cv csn cdif c0 neeq1 anbi12d anbi2d vu cv vv cv vz cv csn
      cdif wceq vu cv cint vv cv vz cv csn cdif cint cA vu cv vv cv vz cv csn
      cdif inteq eleq1d imbi12d vu cv vv cv wceq cA cB wcel vx cv vy cv cin cA
      wcel vy cA wral vx cA wral wa vu cv cA wss vu cv c0 wne wa wa cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv cA wss vv cv c0
      wne wa wa vu cv cint cA wcel vv cv cint cA wcel vu cv vv cv wceq vu cv cA
      wss vu cv c0 wne wa vv cv cA wss vv cv c0 wne wa cA cB wcel vx cv vy cv
      cin cA wcel vy cA wral vx cA wral wa vu cv vv cv wceq vu cv cA wss vv cv
      cA wss vu cv c0 wne vv cv c0 wne vu cv vv cv cA sseq1 vu cv vv cv c0
      neeq1 anbi12d anbi2d vu cv vv cv wceq vu cv cint vv cv cint cA vu cv vv
      cv inteq eleq1d imbi12d vu cv vw cv wceq cA cB wcel vx cv vy cv cin cA
      wcel vy cA wral vx cA wral wa vu cv cA wss vu cv c0 wne wa wa cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vw cv cA wss vw cv c0
      wne wa wa vu cv cint cA wcel vw cv cint cA wcel vu cv vw cv wceq vu cv cA
      wss vu cv c0 wne wa vw cv cA wss vw cv c0 wne wa cA cB wcel vx cv vy cv
      cin cA wcel vy cA wral vx cA wral wa vu cv vw cv wceq vu cv cA wss vw cv
      cA wss vu cv c0 wne vw cv c0 wne vu cv vw cv cA sseq1 vu cv vw cv c0
      neeq1 anbi12d anbi2d vu cv vw cv wceq vu cv cint vw cv cint cA vu cv vw
      cv inteq eleq1d imbi12d c0 c0 wne c0 cint cA wcel cA cB wcel vx cv vy cv
      cin cA wcel vy cA wral vx cA wral wa c0 cA wss c0 cint cA wcel c0 c0 c0
      cint cA wcel wn c0 eqidd necon1ai ad2antll cA cB wcel vx cv vy cv cin cA
      wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn
      cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral cA
      cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv cA wss vv
      cv c0 wne wa wa vv cv cint cA wcel wi wi vv cv cfn wcel cA cB wcel vx cv
      vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv
      cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv
      cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv
      cA wss vv cv c0 wne wa wa vv cv cint cA wcel cA cB wcel vx cv vy cv cin
      cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv
      csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv cA wss
      vv cv c0 wne wa wa wa vv cv vw cv csn wceq vw wex vv cv cint cA wcel cA
      cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv cA wss vv
      cv c0 wne wa wa vv cv vw cv csn wceq vw wex vv cv cint cA wcel wi cA cB
      wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn
      cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint
      cA wcel wi vz vv cv wral vv cv cA wss vv cv vw cv csn wceq vw wex vv cv
      cint cA wcel wi cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral
      wa vv cv c0 wne vv cv cA wss vv cv vw cv csn wceq vv cv cint cA wcel vw
      vv cv vw cv csn wceq vv cv cA wss vv cv cint cA wcel vv cv vw cv csn wceq
      vv cv cA wss vv cv cint cA wcel wi vw cv cA wcel vw cv csn cint cA wcel
      wi vw cv csn cint cA wcel vw cv cA wcel vw cv csn cint vw cv cA vw cv vw
      visset intsn eleq1i biimpri vv cv vw cv csn wceq vv cv cA wss vw cv cA
      wcel vv cv cint cA wcel vw cv csn cint cA wcel vv cv vw cv csn wceq vv cv
      cA wss vw cv csn cA wss vw cv cA wcel vv cv vw cv csn cA sseq1 vw cv cA
      vw visset snss syl6bbr vv cv vw cv csn wceq vv cv cint vw cv csn cint cA
      vv cv vw cv csn inteq eleq1d imbi12d mpbiri com12 19.23adv ad2antrl
      adantl cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv
      vz cv csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn
      cdif cint cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy
      cA wral vx cA wral wa vv cv cA wss vv cv c0 wne wa vv cv vw cv csn wceq
      vw wex wn vv cv cint cA wcel wi cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0
      wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa wa vv cv cA wss vv cv c0
      wne vv cv vw cv csn wceq vw wex wn vv cv cint cA wcel wi cA cB wcel vx cv
      vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv
      cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv
      cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa wa vv
      cv cA wss wa vu cv vv cv wcel vu wex vv cv vw cv csn wceq vw wex wn vv cv
      cint cA wcel wi vv cv c0 wne cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0
      wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa wa vv cv cA wss wa vu cv
      vv cv wcel vv cv vw cv csn wceq vw wex wn vv cv cint cA wcel wi vu cA cB
      wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn
      cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint
      cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx
      cA wral wa wa vv cv cA wss wa vu cv vv cv wcel vv cv vw cv csn wceq vw
      wex wn vv cv vu cv csn cdif c0 wne vv cv cint cA wcel vu cv vv cv wcel vv
      cv vw cv csn wceq vw wex wn vv cv vu cv csn cdif c0 wne wi wi cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA
      wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel
      wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral
      wa wa vv cv cA wss wa vu cv vv cv wcel vv cv vw cv csn wceq wn vw wal vv
      cv vu cv csn cdif c0 wne vv cv vw cv csn wceq vw wex wn vu cv vv cv wcel
      vv cv vu cv csn wceq wn vv cv vu cv csn cdif c0 wne vv cv vw cv csn wceq
      wn vw wal vu cv vv cv wcel vv cv vu cv csn wceq vv cv vu cv csn cdif c0
      vu cv vv cv wcel vu cv csn vv cv wss vv cv vu cv csn cdif c0 wceq vv cv
      vu cv csn wceq wi vu cv vv cv vu visset snss vu cv csn vv cv wss vv cv vu
      cv csn wss vv cv vu cv csn wceq vv cv vu cv csn cdif c0 wceq vv cv vu cv
      csn wss vu cv csn vv cv wss vv cv vu cv csn wceq vv cv vu cv csn wceq vv
      cv vu cv csn wss vu cv csn vv cv wss wa vv cv vu cv csn eqss biimpri
      expcom vv cv vu cv csn ssdif0 syl5ibr sylbi necon3bd vv cv vw cv csn wceq
      wn vv cv vu cv csn wceq wn vw vu vw cv vu cv wceq vv cv vw cv csn wceq vv
      cv vu cv csn wceq vw cv vu cv wceq vw cv csn vu cv csn vv cv vw cv vu cv
      sneq eqeq2d notbid a4v syl5 vv cv vw cv csn wceq vw alnex syl5ibr a1i cA
      cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn
      cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint
      cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx
      cA wral wa wa vv cv cA wss wa vv cv vu cv csn cdif cA wss vu cv vv cv
      wcel vv cv vu cv csn cdif c0 wne vv cv cint cA wcel wi wi vv cv cA wss vv
      cv vu cv csn cdif cA wss cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx
      cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa
      vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv
      cin cA wcel vy cA wral vx cA wral wa wa vv cv cA vu cv csn ssdifss adantl
      cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv
      csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif
      cint cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa wa vv cv cA wss vv cv vu cv csn cdif cA wss vu cv vv
      cv wcel vv cv vu cv csn cdif c0 wne vv cv cint cA wcel wi wi wi cA cB
      wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn
      cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint
      cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx
      cA wral wa wa vv cv vu cv csn cdif cA wss vv cv cA wss vu cv vv cv wcel
      vv cv vu cv csn cdif c0 wne vv cv cint cA wcel wi wi cA cB wcel vx cv vy
      cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv
      vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv
      wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa wa vv cv
      vu cv csn cdif cA wss vv cv cA wss vu cv vv cv wcel vv cv vu cv csn cdif
      c0 wne vv cv cint cA wcel wi wi wi cA cB wcel vx cv vy cv cin cA wcel vy
      cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0
      wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral cA cB wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral wa wa vv cv vu cv csn cdif
      cA wss wa vv cv vu cv csn cdif c0 wne vu cv vv cv wcel vv cv cA wss vv cv
      cint cA wcel cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa
      vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv
      csn cdif cint cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel
      vy cA wral vx cA wral wa wa vv cv vu cv csn cdif cA wss vv cv vu cv csn
      cdif c0 wne vu cv vv cv wcel vv cv cA wss vv cv cint cA wcel wi wi cA cB
      wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn
      cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint
      cA wcel wi vz vv cv wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx
      cA wral wa vv cv vu cv csn cdif cA wss vv cv vu cv csn cdif c0 wne wa vu
      cv vv cv wcel vv cv cA wss vv cv cint cA wcel wi wi cA cB wcel vx cv vy
      cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv
      vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv
      wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vu
      cv csn cdif cA wss vv cv vu cv csn cdif c0 wne wa wa vu cv vv cv wcel vv
      cv cA wss vv cv cint cA wcel wi wi vu cv vv cv wcel cA cB wcel vx cv vy
      cv cin cA wcel vy cA wral vx cA wral wa vv cv vu cv csn cdif cA wss vv cv
      vu cv csn cdif c0 wne wa wa cA cB wcel vx cv vy cv cin cA wcel vy cA wral
      vx cA wral wa vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0 wne wa
      wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv wral vv cv cA wss vv cv
      cint cA wcel wi vu cv vv cv wcel cA cB wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral wa vv cv vu cv csn cdif cA wss vv cv vu cv csn cdif c0
      wne wa wa cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv
      cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv
      csn cdif cint cA wcel wi vz vv cv wral vv cv vu cv csn cdif cint cA wcel
      vv cv cA wss vv cv cint cA wcel wi vu cv vv cv wcel cA cB wcel vx cv vy
      cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn cdif cA wss vv cv
      vz cv csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel wi vz vv cv
      wral cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vu
      cv csn cdif cA wss vv cv vu cv csn cdif c0 wne wa wa vv cv vu cv csn cdif
      cint cA wcel cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa
      vv cv vz cv csn cdif cA wss vv cv vz cv csn cdif c0 wne wa wa vv cv vz cv
      csn cdif cint cA wcel wi cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx
      cA wral wa vv cv vu cv csn cdif cA wss vv cv vu cv csn cdif c0 wne wa wa
      vv cv vu cv csn cdif cint cA wcel wi vz vu cv vv cv vz cv vu cv wceq cA
      cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv cv vz cv csn
      cdif cA wss vv cv vz cv csn cdif c0 wne wa wa cA cB wcel vx cv vy cv cin
      cA wcel vy cA wral vx cA wral wa vv cv vu cv csn cdif cA wss vv cv vu cv
      csn cdif c0 wne wa wa vv cv vz cv csn cdif cint cA wcel vv cv vu cv csn
      cdif cint cA wcel vz cv vu cv wceq vv cv vz cv csn cdif cA wss vv cv vz
      cv csn cdif c0 wne wa vv cv vu cv csn cdif cA wss vv cv vu cv csn cdif c0
      wne wa cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vz cv
      vu cv wceq vv cv vz cv csn cdif cA wss vv cv vu cv csn cdif cA wss vv cv
      vz cv csn cdif c0 wne vv cv vu cv csn cdif c0 wne vz cv vu cv wceq vv cv
      vz cv csn cdif vv cv vu cv csn cdif cA vz cv vu cv wceq vz cv csn vu cv
      csn vv cv vz cv vu cv sneq difeq2d sseq1d vz cv vu cv wceq vv cv vz cv
      csn cdif vv cv vu cv csn cdif c0 vz cv vu cv wceq vz cv csn vu cv csn vv
      cv vz cv vu cv sneq difeq2d neeq1d anbi12d anbi2d vz cv vu cv wceq vv cv
      vz cv csn cdif cint vv cv vu cv csn cdif cint cA vz cv vu cv wceq vv cv
      vz cv csn cdif vv cv vu cv csn cdif vz cv vu cv wceq vz cv csn vu cv csn
      vv cv vz cv vu cv sneq difeq2d inteqd eleq1d imbi12d rcla4v com23 vu cv
      vv cv wcel cA cB wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral wa vv
      cv vu cv csn cdif cint cA wcel vv cv cA wss vv cv cint cA wcel wi wi vv
      cv vu cv csn cdif cA wss vv cv vu cv csn cdif c0 wne wa vu cv vv cv wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral vv cv vu cv csn cdif cint
      cA wcel vv cv cA wss vv cv cint cA wcel wi wi cA cB wcel vu cv vv cv wcel
      vv cv cA wss vv cv vu cv csn cdif cint cA wcel vx cv vy cv cin cA wcel vy
      cA wral vx cA wral vv cv cint cA wcel vu cv vv cv wcel vv cv cA wss vu cv
      cA wcel vv cv vu cv csn cdif cint cA wcel vx cv vy cv cin cA wcel vy cA
      wral vx cA wral vv cv cint cA wcel wi wi vv cv cA wss vu cv vv cv wcel vu
      cv cA wcel vv cv cA vu cv ssel com12 vu cv cA wcel vv cv vu cv csn cdif
      cint cA wcel vx cv vy cv cin cA wcel vy cA wral vx cA wral vu cv vv cv
      wcel vv cv cint cA wcel vv cv vu cv csn cdif cint cA wcel vu cv cA wcel
      vx cv vy cv cin cA wcel vy cA wral vx cA wral vu cv vv cv wcel vv cv cint
      cA wcel wi wi vv cv vu cv csn cdif cint cA wcel vu cv cA wcel wa vx cv vy
      cv cin cA wcel vy cA wral vx cA wral vv cv vu cv csn cdif cint vu cv cin
      cA wcel vu cv vv cv wcel vv cv cint cA wcel wi vx cv vy cv cin cA wcel vv
      cv vu cv csn cdif cint vu cv cin cA wcel vv cv vu cv csn cdif cint vy cv
      cin cA wcel vx vy vv cv vu cv csn cdif cint vu cv cA cA vx cv vv cv vu cv
      csn cdif cint wceq vx cv vy cv cin vv cv vu cv csn cdif cint vy cv cin cA
      vx cv vv cv vu cv csn cdif cint vy cv ineq1 eleq1d vy cv vu cv wceq vv cv
      vu cv csn cdif cint vy cv cin vv cv vu cv csn cdif cint vu cv cin cA vy
      cv vu cv vv cv vu cv csn cdif cint ineq2 eleq1d rcla42v vu cv vv cv wcel
      vv cv vu cv csn cdif cint vu cv cin cA wcel vv cv cint cA wcel vu cv vv
      cv wcel vv cv vu cv csn cdif cint vu cv cin vv cv cint cA vu cv vv cv
      wcel vv cv cint vv cv vu cv csn cdif vu cv csn cun cint vv cv vu cv csn
      cdif cint vu cv cin vu cv vv cv wcel vv cv vv cv vu cv csn cdif vu cv csn
      cun vu cv vv cv wcel vv cv vu cv csn cdif vu cv csn cun vv cv vv cv vu cv
      difsnid eqcomd inteqd vv cv vu cv csn cdif vu cv vu visset intunsn
      syl6req eleq1d biimpcd syl6 expcom com4r syld com24 adantld adantrd syldd
      com13 imp anassrs expr com24 ex com23 imp mpd syldd 19.23adv vu vv cv n0
      syl5ib impr anasss pm2.61d ex a1i findcard com12 expr com23 3impia vw cv
      cint cA vz cv eleq1a syl6 com23 mpdi 3exp 3impd 19.23adv sylbid ssrdv cA
      cB wcel cA cA cfi cfv wss vx cv vy cv cin cA wcel vy cA wral vx cA wral
      cA cB abfi2 adantr eqssd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d R x y z $. $d A x y z $. $d B x y z $.
    $( A subset of a well founded set has an infimum. $)
    frinfm $p |- ( ( R Fr A /\ ( B e. C /\ B C_ A /\ B =/= (/) ) ) ->
                    E. x e. A ( A. y e. B -. x `' R y /\
                    A. y e. A ( y `' R x -> E. z e. B y `' R z ) ) ) $=
      cA cR wfr cB cC wcel cB cA wss cB c0 wne w3a wa vy cv vx cv cR wbr wn vy
      cB wral vx cB wrex vx cv vy cv cR ccnv wbr wn vy cB wral vy cv vx cv cR
      ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy cA wral wa vx cA wrex
      cA cR wfr cB cC wcel cB cA wss cB c0 wne vy cv vx cv cR wbr wn vy cB wral
      vx cB wrex cA cR wfr cB cC wcel cB cA wss cB c0 wne vy cv vx cv cR wbr wn
      vy cB wral vx cB wrex cB cC wcel cA cR wfr cB cA wss cB c0 wne wa vy cv
      vx cv cR wbr wn vy cB wral vx cB wrex vx vy cA cB cC cR fri ancom1s exp43
      3imp2 cA cR wfr cB cC wcel cB cA wss vy cv vx cv cR wbr wn vy cB wral vx
      cB wrex vx cv vy cv cR ccnv wbr wn vy cB wral vy cv vx cv cR ccnv wbr vy
      cv vz cv cR ccnv wbr vz cB wrex wi vy cA wral wa vx cA wrex wi cB c0 wne
      cB cA wss vy cv vx cv cR wbr wn vy cB wral vx cB wrex vx cv vy cv cR ccnv
      wbr wn vy cB wral vy cv vx cv cR ccnv wbr vy cv vz cv cR ccnv wbr vz cB
      wrex wi vy cA wral wa vx cA wrex wi cA cR wfr cB cA wss vy cv vx cv cR
      wbr wn vy cB wral vx cv vy cv cR ccnv wbr wn vy cB wral vy cv vx cv cR
      ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy cA wral wa vx cB cA cB
      cA wss vx cv cB wcel vy cv vx cv cR wbr wn vy cB wral wa vx cv cA wcel vx
      cv vy cv cR ccnv wbr wn vy cB wral vy cv vx cv cR ccnv wbr vy cv vz cv cR
      ccnv wbr vz cB wrex wi vy cA wral wa wa cB cA wss vx cv cB wcel vy cv vx
      cv cR wbr wn vy cB wral wa wa vx cv cA wcel vx cv vy cv cR ccnv wbr wn vy
      cB wral vy cv vx cv cR ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy
      cA wral cB cA wss vx cv cB wcel vx cv cA wcel vy cv vx cv cR wbr wn vy cB
      wral cB cA vx cv ssel2 adantrr vy cv vx cv cR wbr wn vy cB wral vx cv vy
      cv cR ccnv wbr wn vy cB wral cB cA wss vx cv cB wcel vy cv vx cv cR wbr
      wn vx cv vy cv cR ccnv wbr wn vy cB vx cv vy cv cR ccnv wbr vy cv vx cv
      cR wbr vx cv vy cv cR ccnv wbr vy cv vx cv cR wbr vx cv vy cv cR vx
      visset vy visset brcnv biimpi con3i r19.20si ad2antll vx cv cB wcel vy cv
      vx cv cR ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy cA wral cB cA
      wss vy cv vx cv cR wbr wn vy cB wral vx cv cB wcel vy cv vx cv cR ccnv
      wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy cA vx cv cB wcel vy cv vx cv
      cR ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy cv cA wcel vx cv cB
      wcel vy cv vx cv cR ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex vy cv vz
      cv cR ccnv wbr vy cv vx cv cR ccnv wbr vz vx cv cB vz cv vx cv vy cv cR
      ccnv breq2 rcla4ev ex a1d r19.21aiv ad2antrl jca32 ex r19.22dv2 adantl
      3ad2antr2 mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C x y z $. $d R x y z $.
    $( A non-empty subset of a well ordered set has a lower bound. $)
    welb $p |- ( ( R We A /\ ( B e. C /\ B C_ A /\ B =/= (/) ) ) -> ( `' R Or B
                    /\ E. x e. B ( A. y e. B -. x `' R y /\
                        A. y e. B ( y `' R x -> E. z e. B y `' R z ) ) ) ) $=
      cA cR wwe cB cC wcel cB cA wss cB c0 wne w3a wa cB cR ccnv wor vx cv vy
      cv cR ccnv wbr wn vy cB wral vy cv vx cv cR ccnv wbr vy cv vz cv cR ccnv
      wbr vz cB wrex wi vy cB wral wa vx cB wrex cA cR wwe cB cC wcel cB cA wss
      cB cR ccnv wor cB c0 wne cA cR wwe cB cA wss wa cB cR wwe cB cR wor cB cR
      ccnv wor cB cA wss cA cR wwe cB cR wwe cB cA cR wess impcom cB cR weso cB
      cR wor cB cR ccnv wor cB cR cnvso biimpi 3syl 3ad2antr2 cB cR wfr cB cC
      wcel cB cB wss cB c0 wne w3a vx cv vy cv cR ccnv wbr wn vy cB wral vy cv
      vx cv cR ccnv wbr vy cv vz cv cR ccnv wbr vz cB wrex wi vy cB wral wa vx
      cB wrex cA cR wwe cB cC wcel cB cA wss cB c0 wne w3a wa vx vy vz cB cB cC
      cR frinfm cA cR wwe cB cC wcel cB cA wss cB cR wfr cB c0 wne cA cR wwe cB
      cA wss wa cB cR wwe cB cR wfr cB cA wss cA cR wwe cB cR wwe cB cA cR wess
      impcom cB cR wefr syl 3ad2antr2 cB cC wcel cB cA wss cB c0 wne w3a cB cC
      wcel cB cB wss cB c0 wne w3a cA cR wwe cB cC wcel cB cC wcel cB cA wss cB
      cB wss cB c0 wne cB c0 wne cB cC wcel id cB cB wss cB cA wss cB ssid a1i
      cB c0 wne id 3anim123i adantl sylanc jca $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C x y z $. $d R x y z $.
    $( Equality theorem for supremum. $)
    supeq2 $p |- ( B = C -> sup ( A , B , R ) = sup ( A , C , R ) ) $=
      cB cC wceq vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cA wrex wi vy cB wral wa vx cB crab cuni vx cv vy cv cR wbr
      wn vy cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cC
      wral wa vx cC crab cuni cA cB cR csup cA cC cR csup cB cC wceq vx cv vy
      cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex
      wi vy cB wral wa vx cB crab vx cv vy cv cR wbr wn vy cA wral vy cv vx cv
      cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cC wral wa vx cC crab cB cC
      wceq vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cA wrex wi vy cB wral wa vx cB crab vx cv vy cv cR wbr wn vy cA
      wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cB wral wa vx
      cC crab vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy cv vz cv
      cR wbr vz cA wrex wi vy cC wral wa vx cC crab vx cv vy cv cR wbr wn vy cA
      wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cB wral wa vx
      cB cC rabeq cB cC wceq vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cA wrex wi vy cB wral wa vx cv vy cv cR wbr wn
      vy cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cC wral
      wa vx cC cB cC wceq vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi
      vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cA wrex wi vy cC wral
      vx cv vy cv cR wbr wn vy cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz
      cA wrex wi vy cB cC raleq1 anbi2d rabbisdv eqtrd unieqd vx vy vz cB cA cR
      df-sup vx vy vz cC cA cR df-sup 3eqtr4g $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C x y z $. $d R x y z $.
    $( Existence of supremum. $)
    supex2g $p |- ( A e. C -> sup ( B , A , R ) e. _V ) $=
      cA cC wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab cuni cvv cB cA cR csup
      cA cC wcel vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA wral wa vx cA crab cvv wcel vx cv vy cv cR
      wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral wa vx cA crab cuni cvv wcel vx cv vy cv cR wbr wn vy cB wral vy
      cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA cC
      rabexg vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral wa vx cA crab cvv uniexg syl vx vy vz cA cB
      cR df-sup syl5eqel $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d R x y z $.
    $( Closure of supremum. $)
    supclt $p |- ( ( R Or A /\ E. x e. A ( A. y e. B -. x R y /\
      A. y e. A ( y R x -> E. z e. B y R z ) ) ) -> sup ( B , A , R ) e. A ) $=
      cA cR wor vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv
      cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup cA wcel cA cR
      wor vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR
      wbr vz cB wrex wi vy cA wral wa vx cA wrex cB cA cR csup cA wcel wi vx cv
      vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA cR wor cA c0 cif wral wa vx cA cR wor cA c0 cif wrex cB cA
      cR wor cA c0 cif cR csup cA cR wor cA c0 cif wcel wi cA c0 cA cA cR wor
      cA c0 cif wceq vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex vx cv vy cv cR wbr wn
      vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA cR
      wor cA c0 cif wral wa vx cA cR wor cA c0 cif wrex cB cA cR csup cA wcel
      cB cA cR wor cA c0 cif cR csup cA cR wor cA c0 cif wcel vx cv vy cv cR
      wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral wa vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz
      cv cR wbr vz cB wrex wi vy cA cR wor cA c0 cif wral wa vx cA cA cR wor cA
      c0 cif cA cA cR wor cA c0 cif wceq vy cv vx cv cR wbr vy cv vz cv cR wbr
      vz cB wrex wi vy cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex
      wi vy cA cR wor cA c0 cif wral vx cv vy cv cR wbr wn vy cB wral vy cv vx
      cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA cA cR wor cA c0 cif
      raleq1 anbi2d rexeqd cA cA cR wor cA c0 cif wceq cB cA cR csup cB cA cR
      wor cA c0 cif cR csup cA cA cR wor cA c0 cif cB cA cA cR wor cA c0 cif cR
      supeq2 cA cA cR wor cA c0 cif wceq id eleq12d imbi12d vx vy vz cA cR wor
      cA c0 cif cB cR cA cR wor cA cR wor cA c0 cif cR wor c0 cR wor cA c0 cA
      cA cR wor cA c0 cif cR soeq2 c0 cA cR wor cA c0 cif cR soeq2 cR so0
      elimhyp supcl dedth imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d C x y z $. $d R x y z $.
    $( Upper bound property of supremum. $)
    supubt $p |- ( ( R Or A /\ E. x e. A ( A. y e. B -. x R y /\
                        A. y e. A ( y R x -> E. z e. B y R z ) ) ) ->
                                ( C e. B -> -. sup ( B , A , R ) R C ) ) $=
      cA cR wor vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv
      cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cC cB wcel cB cA cR csup cC
      cR wbr wn wi cA cR wor vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR
      wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cA wrex cC cB wcel
      cB cA cR csup cC cR wbr wn wi wi vx cv vy cv cR wbr wn vy cB wral vy cv
      vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA cR wor cA c0 cif wral
      wa vx cA cR wor cA c0 cif wrex cC cB wcel cB cA cR wor cA c0 cif cR csup
      cC cR wbr wn wi wi cA c0 cA cA cR wor cA c0 cif wceq vx cv vy cv cR wbr
      wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA
      wral wa vx cA wrex vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy
      cv vz cv cR wbr vz cB wrex wi vy cA cR wor cA c0 cif wral wa vx cA cR wor
      cA c0 cif wrex cC cB wcel cB cA cR csup cC cR wbr wn wi cC cB wcel cB cA
      cR wor cA c0 cif cR csup cC cR wbr wn wi vx cv vy cv cR wbr wn vy cB wral
      vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA wral wa vx cv
      vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB
      wrex wi vy cA cR wor cA c0 cif wral wa vx cA cA cR wor cA c0 cif cA cA cR
      wor cA c0 cif wceq vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy
      cA wral vy cv vx cv cR wbr vy cv vz cv cR wbr vz cB wrex wi vy cA cR wor
      cA c0 cif wral vx cv vy cv cR wbr wn vy cB wral vy cv vx cv cR wbr vy cv
      vz cv cR wbr vz cB wrex wi vy cA cA cR wor cA c0 cif raleq1 anbi2d rexeqd
      cA cA cR wor cA c0 cif wceq cB cA cR csup cC cR wbr wn cB cA cR wor cA c0
      cif cR csup cC cR wbr wn cC cB wcel cA cA cR wor cA c0 cif wceq cB cA cR
      csup cC cR wbr cB cA cR wor cA c0 cif cR csup cC cR wbr cA cA cR wor cA
      c0 cif wceq cB cA cR csup cB cA cR wor cA c0 cif cR csup cC cR cB cA cA
      cR wor cA c0 cif cR supeq2 breq1d notbid imbi2d imbi12d vx vy vz cA cR
      wor cA c0 cif cB cC cR cA cR wor cA cR wor cA c0 cif cR wor c0 cR wor cA
      c0 cA cA cR wor cA c0 cif cR soeq2 c0 cA cR wor cA c0 cif cR soeq2 cR so0
      elimhyp supub dedth imp $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Real and complex numbers; integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.
    $( A finite set of real numbers has a maximum. $)
    fimaxre $p |- ( ( A C_ RR /\ A e. Fin /\ A =/= (/) )
                                            -> E. x e. A A. y e. A y <_ x ) $=
      cA cr wss cA cfn wcel cA c0 wne w3a vx cv vy cv wne vy cv vx cv clt wbr
      wi vy cA wral vx cA wrex vy cv vx cv cle wbr vy cA wral vx cA wrex cA clt
      wor cA cfn wcel cA c0 wne vx cv vy cv wne vy cv vx cv clt wbr wi vy cA
      wral vx cA wrex cA cr wss vx vy cA clt fimaxg cA cr wss cr clt wor cA clt
      wor ltso cA cr clt soss mpi syl3an1 cA cr wss cA cfn wcel vx cv vy cv wne
      vy cv vx cv clt wbr wi vy cA wral vx cA wrex vy cv vx cv cle wbr vy cA
      wral vx cA wrex wi cA c0 wne cA cr wss vx cv vy cv wne vy cv vx cv clt
      wbr wi vy cA wral vy cv vx cv cle wbr vy cA wral vx cA cA cr wss vx cv cA
      wcel wa vx cv vy cv wne vy cv vx cv clt wbr wi vy cv vx cv cle wbr vy cA
      cA cr wss vx cv cA wcel vy cv cA wcel vx cv vy cv wne vy cv vx cv clt wbr
      wi vy cv vx cv cle wbr wi cA cr wss vx cv cA wcel vy cv cA wcel wa wa vx
      cv cr wcel vy cv cr wcel wa vx cv vy cv wne vy cv vx cv clt wbr wi vy cv
      vx cv cle wbr wi cA cr wss vx cv cA wcel vy cv cA wcel wa vx cv cr wcel
      vy cv cr wcel wa cA cr wss vx cv cA wcel vx cv cr wcel vy cv cA wcel vy
      cv cr wcel cA cr vx cv ssel cA cr vy cv ssel anim12d imp vx cv cr wcel vy
      cv cr wcel wa vy cv vx cv cle wbr vx cv vy cv wne vy cv vx cv clt wbr wi
      vx cv cr wcel vy cv cr wcel wa vy cv vx cv cle wbr vy cv vx cv clt wbr vy
      cv vx cv wceq wo vx cv vy cv wne vy cv vx cv clt wbr wi vy cv cr wcel vx
      cv cr wcel vy cv vx cv cle wbr vy cv vx cv clt wbr vy cv vx cv wceq wo wb
      vy cv vx cv leloe ancoms vy cv vx cv clt wbr vy cv vx cv wceq wo vy cv vx
      cv clt wbr vx cv vy cv wceq wo vx cv vy cv wceq vy cv vx cv clt wbr wo vx
      cv vy cv wne vy cv vx cv clt wbr wi vy cv vx cv wceq vx cv vy cv wceq vy
      cv vx cv clt wbr vy cv vx cv eqcom orbi2i vy cv vx cv clt wbr vx cv vy cv
      wceq orcom vy cv vx cv clt wbr vx cv vy cv neor 3bitri syl6bb biimprd syl
      anassrs r19.20dva r19.22dva 3ad2ant1 mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y z $. $d B u v w x y z $. $d ph u v w y $.
    $( Combine a finite set of lower bounds. $)
    filbcmb $p |- ( ( A e. Fin /\ A =/= (/) /\ B C_ RR ) ->
                      ( A. x e. A E. y e. B A. z e. B ( y <_ z -> ph )
                 -> E. y e. B A. z e. B ( y <_ z -> A. x e. A ph ) ) ) $=
      cA cfn wcel cA c0 wne cB cr wss w3a vy cv vz cv cle wbr wph wi vz cB wral
      vy cB wrex vx cA wral vw cv cB wss vy cv vz cv cle wbr wph wi vz cB wral
      vy vw cv wrex vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex
      vy vw cv wral w3a vw cfn wrex vy cv vz cv cle wbr wph vx cA wral wi vz cB
      wral vy cB wrex cA cfn wcel cB cr wss vy cv vz cv cle wbr wph wi vz cB
      wral vy cB wrex vx cA wral vw cv cB wss vy cv vz cv cle wbr wph wi vz cB
      wral vy vw cv wrex vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx cA
      wrex vy vw cv wral w3a vw cfn wrex wi cA c0 wne cA cfn wcel cB cvv wcel
      vy cv vz cv cle wbr wph wi vz cB wral vy cB wrex vx cA wral vw cv cB wss
      vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vy cv vz
      cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral w3a vw cfn wrex wi
      cB cr wss cA cfn wcel cB cvv wcel vy cv vz cv cle wbr wph wi vz cB wral
      vy cB wrex vx cA wral vw cv cB wss vy cv vz cv cle wbr wph wi vz cB wral
      vy vw cv wrex vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex
      vy vw cv wral w3a vw cfn wrex vy cv vz cv cle wbr wph wi vz cB wral vx vy
      cA cB cvv vw indexf 3expia cB cr reex ssex sylan2 3adant2 cA cfn wcel cA
      c0 wne cB cr wss w3a vw cv cB wss vy cv vz cv cle wbr wph wi vz cB wral
      vy vw cv wrex vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex
      vy vw cv wral w3a vy cv vz cv cle wbr wph vx cA wral wi vz cB wral vy cB
      wrex vw cfn cA cfn wcel cA c0 wne cB cr wss w3a vw cv cfn wcel wa vw cv
      cB wss vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vy
      cv vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral w3a vu cv vy
      cv cle wbr vu vw cv wral vy vw cv wrex vy cv vz cv cle wbr wph vx cA wral
      wi vz cB wral vy cB wrex cA cfn wcel cA c0 wne cB cr wss w3a vw cv cfn
      wcel wa vw cv cB wss vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex
      vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral
      vu cv vy cv cle wbr vu vw cv wral vy vw cv wrex cA cfn wcel cA c0 wne cB
      cr wss w3a vw cv cfn wcel wa vw cv cB wss vy cv vz cv cle wbr wph wi vz
      cB wral vy vw cv wrex vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx
      cA wrex vy vw cv wral vu cv vy cv cle wbr vu vw cv wral vy vw cv wrex wi
      wi cA cfn wcel cA c0 wne cB cr wss w3a vw cv cfn wcel wa vw cv cB wss wa
      vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vu cv vy
      cv cle wbr vu vw cv wral vy vw cv wrex vy cv vz cv cle wbr wph wi vz cB
      wral vx cA wrex vy vw cv wral cA cfn wcel cA c0 wne cB cr wss w3a vw cv
      cfn wcel wa vw cv cB wss wa vy cv vz cv cle wbr wph wi vz cB wral vy vw
      cv wrex vx cA wral vw cv c0 wne vu cv vy cv cle wbr vu vw cv wral vy vw
      cv wrex cA cfn wcel cA c0 wne cB cr wss w3a vy cv vz cv cle wbr wph wi vz
      cB wral vy vw cv wrex vx cA wral vw cv c0 wne wi vw cv cfn wcel vw cv cB
      wss cA c0 wne cA cfn wcel vy cv vz cv cle wbr wph wi vz cB wral vy vw cv
      wrex vx cA wral vw cv c0 wne wi cB cr wss cA c0 wne vy cv vz cv cle wbr
      wph wi vz cB wral vy vw cv wrex vx cA wral vw cv c0 wne cA c0 wne vy cv
      vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral wa vy cv vz cv
      cle wbr wph wi vz cB wral vy vw cv wrex vx cA wrex vw cv c0 wne vy cv vz
      cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA r19.2z vy cv vz cv cle
      wbr wph wi vz cB wral vy vw cv wrex vw cv c0 wne vx cA vy cv vz cv cle
      wbr wph wi vz cB wral vy vw cv wrex vw cv c0 wne wi vx cv cA wcel vy cv
      vz cv cle wbr wph wi vz cB wral vy vw cv rexn0 a1i r19.23aiv syl ex
      3ad2ant2 ad2antrr cA cfn wcel cA c0 wne cB cr wss w3a vw cv cfn wcel vw
      cv cB wss vw cv c0 wne vu cv vy cv cle wbr vu vw cv wral vy vw cv wrex wi
      cB cr wss cA cfn wcel vw cv cfn wcel vw cv cB wss wa vw cv c0 wne vu cv
      vy cv cle wbr vu vw cv wral vy vw cv wrex wi cA c0 wne cB cr wss vw cv cB
      wss vw cv cfn wcel vw cv c0 wne vu cv vy cv cle wbr vu vw cv wral vy vw
      cv wrex wi cB cr wss vw cv cB wss vw cv cfn wcel vw cv c0 wne vu cv vy cv
      cle wbr vu vw cv wral vy vw cv wrex wi vw cv cr wss vw cv cfn wcel vw cv
      c0 wne vu cv vy cv cle wbr vu vw cv wral vy vw cv wrex wi cB cr wss vw cv
      cB wss wa vw cv cr wss vw cv cfn wcel vw cv c0 wne vu cv vy cv cle wbr vu
      vw cv wral vy vw cv wrex vy vu vw cv fimaxre 3expia vw cv cB wss cB cr
      wss vw cv cr wss vw cv cB cr sstr ancoms sylan anasss ancom2s 3ad2antl3
      anassrs syld a1dd ex 3impd cA cfn wcel cA c0 wne cB cr wss w3a vw cv cB
      wss vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vy cv
      vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral w3a vu cv vy cv
      cle wbr vu vw cv wral vy vw cv wrex vy cv vz cv cle wbr wph vx cA wral wi
      vz cB wral vy cB wrex wi wi vw cv cfn wcel cB cr wss cA cfn wcel vw cv cB
      wss vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vy cv
      vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral w3a vu cv vy cv
      cle wbr vu vw cv wral vy vw cv wrex vy cv vz cv cle wbr wph vx cA wral wi
      vz cB wral vy cB wrex wi wi cA c0 wne cB cr wss vw cv cB wss vy cv vz cv
      cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vy cv vz cv cle wbr
      wph wi vz cB wral vx cA wrex vy vw cv wral vu cv vy cv cle wbr vu vw cv
      wral vy vw cv wrex vy cv vz cv cle wbr wph vx cA wral wi vz cB wral vy cB
      wrex wi cB cr wss vw cv cB wss vy cv vz cv cle wbr wph wi vz cB wral vy
      vw cv wrex vx cA wral vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex vy
      vw cv wral vu cv vy cv cle wbr vu vw cv wral vy vw cv wrex vy cv vz cv
      cle wbr wph vx cA wral wi vz cB wral vy cB wrex wi cB cr wss vw cv cB wss
      wa vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral vy cv
      vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral wa wa vu cv vy
      cv cle wbr vu vw cv wral vy vw cv wrex vy cv vz cv cle wbr wph vx cA wral
      wi vz cB wral vy vw cv wrex vy cv vz cv cle wbr wph vx cA wral wi vz cB
      wral vy cB wrex cB cr wss vw cv cB wss wa vy cv vz cv cle wbr wph wi vz
      cB wral vy vw cv wrex vx cA wral vu cv vy cv cle wbr vu vw cv wral vy vw
      cv wrex vy cv vz cv cle wbr wph vx cA wral wi vz cB wral vy vw cv wrex wi
      vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral cB cr wss
      vw cv cB wss wa vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA
      wral wa vu cv vy cv cle wbr vu vw cv wral vy cv vz cv cle wbr wph vx cA
      wral wi vz cB wral vy vw cv cB cr wss vw cv cB wss wa vy cv vz cv cle wbr
      wph wi vz cB wral vy vw cv wrex vx cA wral vy cB cr wss vw cv cB wss wa
      vy ax-17 vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vy vx cA vx
      cv cA wcel vy ax-17 vy cv vz cv cle wbr wph wi vz cB wral vy vw cv hbre1
      hbral hban cB cr wss vw cv cB wss wa vy cv vz cv cle wbr wph wi vz cB
      wral vy vw cv wrex vx cA wral wa vy vw wel vu cv vy cv cle wbr vu vw cv
      wral vy cv vz cv cle wbr wph vx cA wral wi vz cB wral cB cr wss vw cv cB
      wss wa vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral wa
      vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vy cv vz cv cle wbr wph
      vx cA wral wi vz cB cB cr wss vw cv cB wss wa vy cv vz cv cle wbr wph wi
      vz cB wral vy vw cv wrex vx cA wral wa vy vw wel vu cv vy cv cle wbr vu
      vw cv wral wa vz cB cr wss vw cv cB wss wa vy cv vz cv cle wbr wph wi vz
      cB wral vy vw cv wrex vx cA wral vz cB cr wss vw cv cB wss wa vz ax-17 vy
      cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vz vx cA vx cv cA wcel
      vz ax-17 vy cv vz cv cle wbr wph wi vz cB wral vz vy vw cv vy vw wel vz
      ax-17 vy cv vz cv cle wbr wph wi vz cB hbra1 hbrex hbral hban vy vw wel
      vu cv vy cv cle wbr vu vw cv wral wa vz ax-17 hban cB cr wss vw cv cB wss
      wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa vy cv vz cv cle wbr wph
      wi vz cB wral vy vw cv wrex vx cA wral vz cv cB wcel vy cv vz cv cle wbr
      wph vx cA wral wi wi cB cr wss vw cv cB wss wa vy vw wel vu cv vy cv cle
      wbr vu vw cv wral wa wa vy cv vz cv cle wbr wph wi vz cB wral vy vw cv
      wrex vx cA wral wa vz cv cB wcel vy cv vz cv cle wbr wph vx cA wral cB cr
      wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vz
      cv cB wcel vy cv vz cv cle wbr wa vy cv vz cv cle wbr wph wi vz cB wral
      vy vw cv wrex vx cA wral wph vx cA wral cB cr wss vw cv cB wss wa vy vw
      wel vu cv vy cv cle wbr vu vw cv wral wa wa vz cv cB wcel vy cv vz cv cle
      wbr wa wa vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral
      wph vx cA wral cB cr wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu
      vw cv wral wa wa vz cv cB wcel vy cv vz cv cle wbr wa wa vy cv vz cv cle
      wbr wph wi vz cB wral vy vw cv wrex wph vx cA cB cr wss vw cv cB wss wa
      vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vz cv cB wcel vy cv vz
      cv cle wbr wa wa vx cv cA wcel wa vv cv vz cv cle wbr wph wi vz cB wral
      vv vw cv wrex wph vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex cB
      cr wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa
      vz cv cB wcel vy cv vz cv cle wbr wa wa vx cv cA wcel wa vv cv vz cv cle
      wbr wph wi vz cB wral wph vv vw cv cB cr wss vw cv cB wss wa vy vw wel vu
      cv vy cv cle wbr vu vw cv wral wa wa vz cv cB wcel vy cv vz cv cle wbr wa
      wa vv vw wel vv cv vz cv cle wbr wph wi vz cB wral wph wi vx cv cA wcel
      cB cr wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa
      wa vz cv cB wcel vy cv vz cv cle wbr wa wa vv vw wel wa vz cv cB wcel vv
      cv vz cv cle wbr wph wi wi wph vv cv vz cv cle wbr wph wi vz cB wral cB
      cr wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa
      vz cv cB wcel vy cv vz cv cle wbr wa wa vv vw wel wa vz cv cB wcel vv cv
      vz cv cle wbr wph wi wi vv cv vz cv cle wbr wph cB cr wss vw cv cB wss wa
      vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vz cv cB wcel vy cv vz
      cv cle wbr wa wa vv vw wel wa vv cv vy cv vz cv cB cr wss vw cv cB wss wa
      vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vv vw wel vv cv cr wcel
      vz cv cB wcel vy cv vz cv cle wbr wa cB cr wss vw cv cB wss wa vv vw wel
      vv cv cr wcel vy vw wel vu cv vy cv cle wbr vu vw cv wral wa cB cr wss vw
      cv cB wss vv vw wel vv cv cr wcel cB cr wss vv cv cB wcel vv cv cr wcel
      vw cv cB wss vv vw wel wa cB cr vv cv ssel2 vw cv cB vv cv ssel2 sylan2
      anassrs adantlr adantlr cB cr wss vw cv cB wss wa vy vw wel vu cv vy cv
      cle wbr vu vw cv wral wa wa vy cv cr wcel vz cv cB wcel vy cv vz cv cle
      wbr wa vv vw wel cB cr wss vw cv cB wss wa vy vw wel vy cv cr wcel vu cv
      vy cv cle wbr vu vw cv wral cB cr wss vw cv cB wss vy vw wel vy cv cr
      wcel cB cr wss vy cv cB wcel vy cv cr wcel vw cv cB wss vy vw wel wa cB
      cr vy cv ssel2 vw cv cB vy cv ssel2 sylan2 anassrs adantrr ad2antrr cB cr
      wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vz
      cv cB wcel vy cv vz cv cle wbr wa wa vz cv cr wcel vv vw wel cB cr wss vw
      cv cB wss wa vz cv cB wcel vz cv cr wcel vy vw wel vu cv vy cv cle wbr vu
      vw cv wral wa vy cv vz cv cle wbr cB cr wss vz cv cB wcel vz cv cr wcel
      vw cv cB wss cB cr vz cv ssel2 adantlr ad2ant2r adantr cB cr wss vw cv cB
      wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vv vw wel vv cv
      vy cv cle wbr vz cv cB wcel vy cv vz cv cle wbr wa vy vw wel vu cv vy cv
      cle wbr vu vw cv wral wa vv vw wel vv cv vy cv cle wbr cB cr wss vw cv cB
      wss wa vu cv vy cv cle wbr vu vw cv wral vv vw wel vv cv vy cv cle wbr vy
      vw wel vu cv vy cv cle wbr vv cv vy cv cle wbr vu vv cv vw cv vu cv vv cv
      vy cv cle breq1 rcla4cva adantll adantll adantlr cB cr wss vw cv cB wss
      wa vy vw wel vu cv vy cv cle wbr vu vw cv wral wa wa vz cv cB wcel vy cv
      vz cv cle wbr vv vw wel simplrr letrd vz cv cB wcel vy cv vz cv cle wbr
      wa vz cv cB wcel vv cv vz cv cle wbr wph wi wi vv cv vz cv cle wbr wph wi
      wi cB cr wss vw cv cB wss wa vy vw wel vu cv vy cv cle wbr vu vw cv wral
      wa wa vv vw wel vz cv cB wcel vz cv cB wcel vv cv vz cv cle wbr wph wi wi
      vv cv vz cv cle wbr wph wi wi vy cv vz cv cle wbr vz cv cB wcel vv cv vz
      cv cle wbr wph wi pm2.27 adantr ad2antlr mpid vv cv vz cv cle wbr wph wi
      vz cB ra4 syl5 adantlr r19.23adva vy cv vz cv cle wbr wph wi vz cB wral
      vv cv vz cv cle wbr wph wi vz cB wral vy vv vw cv vy vv weq vy cv vz cv
      cle wbr wph wi vv cv vz cv cle wbr wph wi vz cB vy vv weq vy cv vz cv cle
      wbr vv cv vz cv cle wbr wph vy cv vv cv vz cv cle breq1 imbi1d ralbidv
      cbvrexv syl5ib r19.20dva imp an1rs exp32 an1rs r19.21ai exp32 r19.22d
      adantrr vw cv cB wss vy cv vz cv cle wbr wph vx cA wral wi vz cB wral vy
      vw cv wrex vy cv vz cv cle wbr wph vx cA wral wi vz cB wral vy cB wrex wi
      cB cr wss vy cv vz cv cle wbr wph wi vz cB wral vy vw cv wrex vx cA wral
      vy cv vz cv cle wbr wph wi vz cB wral vx cA wrex vy vw cv wral wa vy cv
      vz cv cle wbr wph vx cA wral wi vz cB wral vy vw cv cB ssrexv ad2antlr
      syld exp43 3impd 3ad2ant3 adantr mpdd r19.23adva syld $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Two nonnegative numbers are zero iff their sum is zero. $)
    add20 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) )
                          -> ( ( A + B ) = 0 <-> ( A = 0 /\ B = 0 ) ) ) $=
      cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr cA cB caddc co cc0
      wceq cA cc0 wceq cB cc0 wceq wa wb cA cr wcel cB cr wcel wa cc0 cA cle
      wbr cc0 cB cle wbr wa cA cB caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa
      wb cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB cle wbr wa cA cB caddc co
      cc0 wceq cA cc0 wceq cB cc0 wceq wa wb wi cc0 cA cr wcel cA cc0 cif cle
      wbr cc0 cB cle wbr wa cA cr wcel cA cc0 cif cB caddc co cc0 wceq cA cr
      wcel cA cc0 cif cc0 wceq cB cc0 wceq wa wb wi cc0 cA cr wcel cA cc0 cif
      cle wbr cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB cr
      wcel cB cc0 cif caddc co cc0 wceq cA cr wcel cA cc0 cif cc0 wceq cB cr
      wcel cB cc0 cif cc0 wceq wa wb wi cA cB cc0 cc0 cA cA cr wcel cA cc0 cif
      wceq cc0 cA cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr
      cc0 cB cle wbr wa cA cB caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa wb
      cA cr wcel cA cc0 cif cB caddc co cc0 wceq cA cr wcel cA cc0 cif cc0 wceq
      cB cc0 wceq wa wb cA cA cr wcel cA cc0 cif wceq cc0 cA cle wbr cc0 cA cr
      wcel cA cc0 cif cle wbr cc0 cB cle wbr cA cA cr wcel cA cc0 cif cc0 cle
      breq2 anbi1d cA cA cr wcel cA cc0 cif wceq cA cB caddc co cc0 wceq cA cr
      wcel cA cc0 cif cB caddc co cc0 wceq cA cc0 wceq cB cc0 wceq wa cA cr
      wcel cA cc0 cif cc0 wceq cB cc0 wceq wa cA cA cr wcel cA cc0 cif wceq cA
      cB caddc co cA cr wcel cA cc0 cif cB caddc co cc0 cA cA cr wcel cA cc0
      cif cB caddc opreq1 eqeq1d cA cA cr wcel cA cc0 cif wceq cA cc0 wceq cA
      cr wcel cA cc0 cif cc0 wceq cB cc0 wceq cA cA cr wcel cA cc0 cif cc0
      eqeq1 anbi1d bibi12d imbi12d cB cB cr wcel cB cc0 cif wceq cc0 cA cr wcel
      cA cc0 cif cle wbr cc0 cB cle wbr wa cc0 cA cr wcel cA cc0 cif cle wbr
      cc0 cB cr wcel cB cc0 cif cle wbr wa cA cr wcel cA cc0 cif cB caddc co
      cc0 wceq cA cr wcel cA cc0 cif cc0 wceq cB cc0 wceq wa wb cA cr wcel cA
      cc0 cif cB cr wcel cB cc0 cif caddc co cc0 wceq cA cr wcel cA cc0 cif cc0
      wceq cB cr wcel cB cc0 cif cc0 wceq wa wb cB cB cr wcel cB cc0 cif wceq
      cc0 cB cle wbr cc0 cB cr wcel cB cc0 cif cle wbr cc0 cA cr wcel cA cc0
      cif cle wbr cB cB cr wcel cB cc0 cif cc0 cle breq2 anbi2d cB cB cr wcel
      cB cc0 cif wceq cA cr wcel cA cc0 cif cB caddc co cc0 wceq cA cr wcel cA
      cc0 cif cB cr wcel cB cc0 cif caddc co cc0 wceq cA cr wcel cA cc0 cif cc0
      wceq cB cc0 wceq wa cA cr wcel cA cc0 cif cc0 wceq cB cr wcel cB cc0 cif
      cc0 wceq wa cB cB cr wcel cB cc0 cif wceq cA cr wcel cA cc0 cif cB caddc
      co cA cr wcel cA cc0 cif cB cr wcel cB cc0 cif caddc co cc0 cB cB cr wcel
      cB cc0 cif cA cr wcel cA cc0 cif caddc opreq2 eqeq1d cB cB cr wcel cB cc0
      cif wceq cB cc0 wceq cB cr wcel cB cc0 cif cc0 wceq cA cr wcel cA cc0 cif
      cc0 wceq cB cB cr wcel cB cc0 cif cc0 eqeq1 anbi2d bibi12d imbi12d cA cr
      wcel cA cc0 cif cB cr wcel cB cc0 cif cA cc0 cr 0re elimel cB cc0 cr 0re
      elimel add20i dedth2h imp an4s $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Natural number exponentiation of a quotient. $)
    divexp $p |- ( ( ( A e. CC /\ B e. CC /\ B =/= 0 ) /\ N e. NN0 ) ->
                          ( ( A / B ) ^ N ) = ( ( A ^ N ) / ( B ^ N ) ) ) $=
      cA cc wcel cB cc wcel cB cc0 wne w3a cN cn0 wcel wa cA cB cdiv co cN cexp
      co cA c1 cB cdiv co cmul co cN cexp co cA cN cexp co c1 cB cdiv co cN
      cexp co cmul co cA cN cexp co cB cN cexp co cdiv co cA cc wcel cB cc wcel
      cB cc0 wne w3a cN cn0 wcel wa cA cB cdiv co cA c1 cB cdiv co cmul co cN
      cexp cA cc wcel cB cc wcel cB cc0 wne w3a cA cB cdiv co cA c1 cB cdiv co
      cmul co wceq cN cn0 wcel cA cB divrec adantr opreq1d cA cc wcel c1 cB
      cdiv co cc wcel cN cn0 wcel cA c1 cB cdiv co cmul co cN cexp co cA cN
      cexp co c1 cB cdiv co cN cexp co cmul co wceq cA cc wcel cB cc wcel cB
      cc0 wne w3a cN cn0 wcel wa cA c1 cB cdiv co cN mulexp cA cc wcel cB cc
      wcel cB cc0 wne w3a cA cc wcel cN cn0 wcel cA cc wcel cB cc wcel cB cc0
      wne 3simp1 adantr cA cc wcel cB cc wcel cB cc0 wne w3a c1 cB cdiv co cc
      wcel cN cn0 wcel cB cc wcel cB cc0 wne c1 cB cdiv co cc wcel cA cc wcel
      cB reccl 3adant1 adantr cA cc wcel cB cc wcel cB cc0 wne w3a cN cn0 wcel
      pm3.27 syl3anc cA cc wcel cB cc wcel cB cc0 wne w3a cN cn0 wcel wa cA cN
      cexp co c1 cB cdiv co cN cexp co cmul co cA cN cexp co c1 cB cN cexp co
      cdiv co cmul co cA cN cexp co cB cN cexp co cdiv co cA cc wcel cB cc wcel
      cB cc0 wne w3a cN cn0 wcel wa c1 cB cdiv co cN cexp co c1 cB cN cexp co
      cdiv co cA cN cexp co cmul cB cc wcel cB cc0 wne cN cn0 wcel c1 cB cdiv
      co cN cexp co c1 cB cN cexp co cdiv co wceq cA cc wcel cB cc wcel cB cc0
      wne cN cn0 wcel c1 cB cdiv co cN cexp co c1 cB cN cexp co cdiv co wceq cB
      cN exprec 3expa 3adantl1 opreq2d cA cN cexp co cc wcel cB cN cexp co cc
      wcel cB cN cexp co cc0 wne cA cN cexp co c1 cB cN cexp co cdiv co cmul co
      cA cN cexp co cB cN cexp co cdiv co wceq cA cc wcel cB cc wcel cB cc0 wne
      w3a cN cn0 wcel wa cA cN cexp co cc wcel cB cN cexp co cc wcel cB cN cexp
      co cc0 wne w3a cA cN cexp co cB cN cexp co cdiv co cA cN cexp co c1 cB cN
      cexp co cdiv co cmul co cA cN cexp co cB cN cexp co divrec eqcomd cA cc
      wcel cB cc wcel cN cn0 wcel cA cN cexp co cc wcel cB cc0 wne cA cN expcl
      3ad2antl1 cB cc wcel cA cc wcel cN cn0 wcel cB cN cexp co cc wcel cB cc0
      wne cB cN expcl 3ad2antl2 cA cc wcel cB cc wcel cB cc0 wne w3a cN cn0
      wcel wa cB cc0 wne cB cN cexp co cc0 wne cA cc wcel cB cc wcel cB cc0 wne
      w3a cB cc0 wne cN cn0 wcel cA cc wcel cB cc wcel cB cc0 wne 3simp3 adantr
      cA cc wcel cB cc wcel cB cc0 wne w3a cN cn0 wcel wa cB cN cexp co cc0 cB
      cc0 cB cc wcel cA cc wcel cN cn0 wcel cB cN cexp co cc0 wceq cB cc0 wceq
      wi cB cc0 wne cB cc wcel cN cn wcel cN cc0 wceq wo cB cN cexp co cc0 wceq
      cB cc0 wceq wi cN cn0 wcel cB cc wcel cN cn wcel cB cN cexp co cc0 wceq
      cB cc0 wceq wi cN cc0 wceq cB cc wcel cN cn wcel wa cB cN cexp co cc0
      wceq cB cc0 wceq cB cN expeq0 biimpd cB cc wcel cN cc0 wceq wa cB cN cexp
      co cc0 wceq cB cc0 wceq cB cc wcel cN cc0 wceq wa cB cN cexp co cc0 wceq
      c1 cc0 wceq c1 cc0 wne c1 cc0 wceq wn ax1ne0 c1 cc0 df-ne mpbi cB cc wcel
      cN cc0 wceq wa cB cN cexp co c1 cc0 cN cc0 wceq cB cc wcel cB cN cexp co
      cB cc0 cexp co c1 cN cc0 cB cexp opreq2 cB exp0 sylan9eqr eqeq1d mtbiri
      pm2.21d jaodan cN elnn0 sylan2b 3ad2antl2 necon3d mpd syl3anc eqtrd
      3eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Membership in a later set of upper integers. $)
    eluzadd $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ ) ->
                                        ( N + K ) e. ( ZZ>= ` ( M + K ) ) ) $=
      cN cM cuz cfv wcel cK cz wcel cN cK caddc co cM cK caddc co cuz cfv wcel
      cN cM cuz cfv wcel cM cz wcel cK cz wcel cN cK caddc co cM cK caddc co
      cuz cfv wcel cM cN eluzel2 cM cz wcel cK cz wcel wa cN cM cuz cfv wcel cN
      cK caddc co cM cK caddc co cuz cfv wcel cM cz wcel cK cz wcel cN cM cuz
      cfv wcel cN cK caddc co cM cK caddc co cuz cfv wcel wi cN cM cz wcel cM
      cc0 cif cuz cfv wcel cN cK caddc co cM cz wcel cM cc0 cif cK caddc co cuz
      cfv wcel wi cN cM cz wcel cM cc0 cif cuz cfv wcel cN cK cz wcel cK cc0
      cif caddc co cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cfv
      wcel wi cM cK cc0 cc0 cM cM cz wcel cM cc0 cif wceq cN cM cuz cfv wcel cN
      cM cz wcel cM cc0 cif cuz cfv wcel cN cK caddc co cM cK caddc co cuz cfv
      wcel cN cK caddc co cM cz wcel cM cc0 cif cK caddc co cuz cfv wcel cM cM
      cz wcel cM cc0 cif wceq cM cuz cfv cM cz wcel cM cc0 cif cuz cfv cN cM cM
      cz wcel cM cc0 cif cuz fveq2 eleq2d cM cM cz wcel cM cc0 cif wceq cM cK
      caddc co cuz cfv cM cz wcel cM cc0 cif cK caddc co cuz cfv cN cK caddc co
      cM cM cz wcel cM cc0 cif wceq cM cK caddc co cM cz wcel cM cc0 cif cK
      caddc co cuz cM cM cz wcel cM cc0 cif cK caddc opreq1 fveq2d eleq2d
      imbi12d cK cK cz wcel cK cc0 cif wceq cN cK caddc co cM cz wcel cM cc0
      cif cK caddc co cuz cfv wcel cN cK cz wcel cK cc0 cif caddc co cM cz wcel
      cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cfv wcel cN cM cz wcel cM
      cc0 cif cuz cfv wcel cK cK cz wcel cK cc0 cif wceq cN cK caddc co cN cK
      cz wcel cK cc0 cif caddc co cM cz wcel cM cc0 cif cK caddc co cuz cfv cM
      cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cfv cK cK cz wcel
      cK cc0 cif cN caddc opreq2 cK cK cz wcel cK cc0 cif wceq cM cz wcel cM
      cc0 cif cK caddc co cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co
      cuz cK cK cz wcel cK cc0 cif cM cz wcel cM cc0 cif caddc opreq2 fveq2d
      eleq12d imbi2d cK cz wcel cK cc0 cif cM cz wcel cM cc0 cif cN cM cc0 cz
      0z elimel cK cc0 cz 0z elimel eluzaddi dedth2h com12 mpand imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Membership in an earlier set of upper integers. $)
    eluzsub $p |- ( ( M e. ZZ /\ K e. ZZ /\ N e. ( ZZ>= ` ( M + K ) ) )
                                            -> ( N - K ) e. ( ZZ>= ` M ) ) $=
      cM cz wcel cK cz wcel cN cM cK caddc co cuz cfv wcel cN cK cmin co cM cuz
      cfv wcel cM cz wcel cK cz wcel cN cM cK caddc co cuz cfv wcel cN cK cmin
      co cM cuz cfv wcel wi cN cM cz wcel cM cc0 cif cK caddc co cuz cfv wcel
      cN cK cmin co cM cz wcel cM cc0 cif cuz cfv wcel wi cN cM cz wcel cM cc0
      cif cK cz wcel cK cc0 cif caddc co cuz cfv wcel cN cK cz wcel cK cc0 cif
      cmin co cM cz wcel cM cc0 cif cuz cfv wcel wi cM cK cc0 cc0 cM cM cz wcel
      cM cc0 cif wceq cN cM cK caddc co cuz cfv wcel cN cM cz wcel cM cc0 cif
      cK caddc co cuz cfv wcel cN cK cmin co cM cuz cfv wcel cN cK cmin co cM
      cz wcel cM cc0 cif cuz cfv wcel cM cM cz wcel cM cc0 cif wceq cM cK caddc
      co cuz cfv cM cz wcel cM cc0 cif cK caddc co cuz cfv cN cM cM cz wcel cM
      cc0 cif wceq cM cK caddc co cM cz wcel cM cc0 cif cK caddc co cuz cM cM
      cz wcel cM cc0 cif cK caddc opreq1 fveq2d eleq2d cM cM cz wcel cM cc0 cif
      wceq cM cuz cfv cM cz wcel cM cc0 cif cuz cfv cN cK cmin co cM cM cz wcel
      cM cc0 cif cuz fveq2 eleq2d imbi12d cK cK cz wcel cK cc0 cif wceq cN cM
      cz wcel cM cc0 cif cK caddc co cuz cfv wcel cN cM cz wcel cM cc0 cif cK
      cz wcel cK cc0 cif caddc co cuz cfv wcel cN cK cmin co cM cz wcel cM cc0
      cif cuz cfv wcel cN cK cz wcel cK cc0 cif cmin co cM cz wcel cM cc0 cif
      cuz cfv wcel cK cK cz wcel cK cc0 cif wceq cM cz wcel cM cc0 cif cK caddc
      co cuz cfv cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cfv
      cN cK cK cz wcel cK cc0 cif wceq cM cz wcel cM cc0 cif cK caddc co cM cz
      wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cK cK cz wcel cK cc0
      cif cM cz wcel cM cc0 cif caddc opreq2 fveq2d eleq2d cK cK cz wcel cK cc0
      cif wceq cN cK cmin co cN cK cz wcel cK cc0 cif cmin co cM cz wcel cM cc0
      cif cuz cfv cK cK cz wcel cK cc0 cif cN cmin opreq2 eleq1d imbi12d cK cz
      wcel cK cc0 cif cM cz wcel cM cc0 cif cN cM cc0 cz 0z elimel cK cc0 cz 0z
      elimel eluzsubi dedth2h 3impia $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Choices for an element of an upper interval of integers. $)
    uzm1 $p |- ( N e. ( ZZ>= ` M )
                 -> ( N = M \/ ( N - 1 ) e. ( ZZ>= ` M ) ) ) $=
      cN cM cuz cfv wcel cN cM wceq cN c1 cmin co cM cuz cfv wcel cN cM cuz cfv
      wcel cN cM wceq wn cM cz wcel cN c1 cmin co cz wcel cM cN c1 cmin co cle
      wbr w3a cN c1 cmin co cM cuz cfv wcel cN cM cuz cfv wcel cN cM wceq wn cM
      cz wcel cN c1 cmin co cz wcel cM cN c1 cmin co cle wbr cN cM cuz cfv wcel
      cM cz wcel cN cM wceq wn cM cN eluzel2 a1d cN cM cuz cfv wcel cN c1 cmin
      co cz wcel cN cM wceq wn cN cM cuz cfv wcel cN cz wcel cN c1 cmin co cz
      wcel cM cN eluzelz cN peano2zm syl a1d cN cM cuz cfv wcel cN cM wceq wn
      cM cN clt wbr cM cN c1 cmin co cle wbr cN cM cuz cfv wcel cN cM wne cM cN
      clt wbr cN cM wceq wn cN cM cuz cfv wcel cM cN cle wbr cN cM wne cM cN
      clt wbr cM cN eluzle cN cM cuz cfv wcel cM cN clt wbr cM cN cle wbr cN cM
      wne wa cM cr wcel cN cr wcel cM cN clt wbr cM cN cle wbr cN cM wne wa wb
      cN cM cuz cfv wcel cM cN ltlen cN cM cuz cfv wcel cM cz wcel cM cr wcel
      cM cN eluzel2 cM zre syl cN cM cuz cfv wcel cN cz wcel cN cr wcel cM cN
      eluzelz cN zre syl sylanc biimprd mpand cN cM df-ne syl5ibr cM cz wcel cN
      cz wcel cM cN clt wbr cM cN c1 cmin co cle wbr wb cN cM cuz cfv wcel cM
      cN zltlem1 cM cN eluzel2 cM cN eluzelz sylanc sylibd 3jcad cM cN c1 cmin
      co eluz2 syl6ibr orrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Choices for an element of an upper interval of integers. $)
    uzp1 $p |- ( N e. ( ZZ>= ` M )
                -> ( N = M \/ N e. ( ZZ>= ` ( M + 1 ) ) ) ) $=
      cN cM cuz cfv wcel cN cM wceq cN c1 cmin co cM cuz cfv wcel wo cN cM wceq
      cN cM c1 caddc co cuz cfv wcel wo cM cN uzm1 cN cM cuz cfv wcel cN c1
      cmin co cM cuz cfv wcel cN cM c1 caddc co cuz cfv wcel cN cM wceq cN cM
      cuz cfv wcel cN c1 cmin co c1 caddc co cM c1 caddc co cuz cfv wcel cN cM
      c1 caddc co cuz cfv wcel cN c1 cmin co cM cuz cfv wcel cN cM cuz cfv wcel
      cN c1 cmin co c1 caddc co cN cM c1 caddc co cuz cfv cN cM cuz cfv wcel cN
      cz wcel cN cc wcel cN c1 cmin co c1 caddc co cN wceq cM cN eluzelz cN zcn
      cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq ax1cn cN c1 npcan
      mpan2 3syl eleq1d cM cN c1 cmin co eluzp1p1 syl5bi orim2d mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M m n $. $d N m n $.
    $( A finite interval of integers is finite. $)
    fzfi $p |- ( N e. ( ZZ>= ` M ) -> ( M ... N ) e. Fin ) $=
      cM vm cv cfz co cfn wcel cM cM cfz co cfn wcel cM vn cv cfz co cfn wcel
      cM vn cv c1 caddc co cfz co cfn wcel cM cN cfz co cfn wcel vm vn cM cN vm
      cv cM wceq cM vm cv cfz co cM cM cfz co cfn vm cv cM cM cfz opreq2 eleq1d
      vm cv vn cv wceq cM vm cv cfz co cM vn cv cfz co cfn vm cv vn cv cM cfz
      opreq2 eleq1d vm cv vn cv c1 caddc co wceq cM vm cv cfz co cM vn cv c1
      caddc co cfz co cfn vm cv vn cv c1 caddc co cM cfz opreq2 eleq1d vm cv cN
      wceq cM vm cv cfz co cM cN cfz co cfn vm cv cN cM cfz opreq2 eleq1d cM cz
      wcel cM cM cfz co cM csn cfn cM cz wcel cM cM cfz co cM csn cM cz wcel vm
      cM cM cfz co cM csn vm cv cM cM cfz co wcel vm cv cM csn wcel wi cM cz
      wcel vm cv cM cM cfz co wcel vm cv cM wceq vm cv cM csn wcel vm cv cM
      elfz1eq vm cM elsn sylibr a1i ssrdv cM cz wcel cM cM cM cfz co wcel cM
      csn cM cM cfz co wss cM elfz3 cM cM cM cfz co cz snssg mpbid eqssd cM
      snfi syl6eqel vn cv cM cuz cfv wcel cM vn cv cfz co cfn wcel vn cv c1
      caddc co csn cfn wcel cM vn cv c1 caddc co cfz co cfn wcel vn cv c1 caddc
      co snfi vn cv cM cuz cfv wcel cM vn cv c1 caddc co cfz co cfn wcel cM vn
      cv cfz co vn cv c1 caddc co csn cun cfn wcel cM vn cv cfz co cfn wcel vn
      cv c1 caddc co csn cfn wcel wa vn cv cM cuz cfv wcel cM vn cv c1 caddc co
      cfz co cM vn cv cfz co vn cv c1 caddc co csn cun cfn cM cz wcel vn cv cz
      wcel cM vn cv c1 caddc co cle wbr cM vn cv c1 caddc co cfz co cM vn cv
      cfz co vn cv c1 caddc co csn cun wceq vn cv cM cuz cfv wcel cM vn cv
      fzsuc cM vn cv eluzel2 cM vn cv eluzelz vn cv cM cuz cfv wcel cM vn cv vn
      cv c1 caddc co vn cv cM cuz cfv wcel cM cz wcel cM cr wcel cM vn cv
      eluzel2 cM zre syl vn cv cM cuz cfv wcel vn cv cz wcel vn cv cr wcel cM
      vn cv eluzelz vn cv zre syl vn cv cM cuz cfv wcel vn cv cz wcel vn cv cr
      wcel vn cv c1 caddc co cr wcel cM vn cv eluzelz vn cv zre vn cv peano2re
      3syl cM vn cv eluzle vn cv cM cuz cfv wcel vn cv cz wcel vn cv cr wcel vn
      cv vn cv c1 caddc co cle wbr cM vn cv eluzelz vn cv zre vn cv lep1 3syl
      letrd syl3anc eleq1d cM vn cv cfz co vn cv c1 caddc co csn unfi syl5bir
      mpan2i uzind4 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Choices for an element of a finite interval of integers. $)
    fzm1 $p |- ( N e. ( ZZ>= ` M ) -> ( K e. ( M ... N ) <->
                                ( K e. ( M ... ( N - 1 ) ) \/ K = N ) ) ) $=
      cN cM cuz cfv wcel cK cM cN cfz co wcel cK cM cN c1 cmin co cfz co wcel
      cK cN wceq wo cN cM cuz cfv wcel cK cM cN cfz co wcel cK cM cN c1 cmin co
      cfz co wcel cK cN wceq wo cN cM cuz cfv wcel cK cM cN cfz co wcel wa cK
      cN wceq cK cM cN c1 cmin co cfz co wcel wo cK cM cN c1 cmin co cfz co
      wcel cK cN wceq wo cN cM cuz cfv wcel cK cM cN cfz co wcel wa cK cN wceq
      cK cM cN c1 cmin co cfz co wcel cN cM cuz cfv wcel cK cM cN cfz co wcel
      cK cN wceq wn cK cM cN c1 cmin co cfz co wcel wi cN cM cuz cfv wcel cK cM
      cN cfz co wcel cK cz wcel cM cK cle wbr cK cN cle wbr w3a cK cN wceq wn
      cK cM cN c1 cmin co cfz co wcel wi cM cz wcel cN cz wcel cK cM cN cfz co
      wcel cK cz wcel cM cK cle wbr cK cN cle wbr w3a wb cN cM cuz cfv wcel cK
      cM cN elfz1 cM cN eluzel2 cM cN eluzelz sylanc cN cM cuz cfv wcel cK cN
      wceq wn cK cz wcel cM cK cle wbr cK cN cle wbr w3a cK cM cN c1 cmin co
      cfz co wcel cN cM cuz cfv wcel cK cN wceq wn cK cz wcel cM cK cle wbr cK
      cN cle wbr w3a cK cz wcel cM cK cle wbr cK cN c1 cmin co cle wbr w3a cK
      cM cN c1 cmin co cfz co wcel cN cM cuz cfv wcel cK cN wceq wn cK cz wcel
      cM cK cle wbr cK cN cle wbr w3a cK cz wcel cM cK cle wbr cK cN c1 cmin co
      cle wbr w3a wi cN cM cuz cfv wcel cK cN wceq wn wa cK cz wcel cM cK cle
      wbr cK cN cle wbr w3a cK cz wcel cM cK cle wbr cK cN c1 cmin co cle wbr
      cK cz wcel cM cK cle wbr cK cN cle wbr w3a cK cz wcel wi cN cM cuz cfv
      wcel cK cN wceq wn wa cK cz wcel cM cK cle wbr cK cN cle wbr 3simp1 a1i
      cK cz wcel cM cK cle wbr cK cN cle wbr w3a cM cK cle wbr wi cN cM cuz cfv
      wcel cK cN wceq wn wa cK cz wcel cM cK cle wbr cK cN cle wbr 3simp2 a1i
      cN cM cuz cfv wcel cK cN wceq wn wa cK cz wcel cM cK cle wbr cK cN cle
      wbr w3a cK cN c1 cmin co cle wbr cN cM cuz cfv wcel cK cN wceq wn wa cK
      cz wcel cK cN cle wbr cK cN c1 cmin co cle wbr cM cK cle wbr cN cM cuz
      cfv wcel cK cN wceq wn wa cK cz wcel cK cN cle wbr wa wa cK cN clt wbr cK
      cN c1 cmin co cle wbr cN cM cuz cfv wcel cK cz wcel cK cN wceq wn cK cN
      cle wbr cK cN clt wbr cN cM cuz cfv wcel cK cz wcel wa cK cN clt wbr cK
      cN wceq wn cK cN cle wbr wa cN cM cuz cfv wcel cK cz wcel wa cK cN clt
      wbr cK cN cle wbr cN cK wne wa cK cN wceq wn cK cN cle wbr wa cK cz wcel
      cN cM cuz cfv wcel cK cN clt wbr cK cN cle wbr cN cK wne wa wb cK cr wcel
      cN cr wcel cK cN clt wbr cK cN cle wbr cN cK wne wa wb cK cz wcel cN cM
      cuz cfv wcel cK cN ltlen cK zre cN cM cuz cfv wcel cN cz wcel cN cr wcel
      cM cN eluzelz cN zre syl syl2an ancoms cK cN cle wbr cN cK wne wa cK cN
      cle wbr cK cN wceq wn wa cK cN wceq wn cK cN cle wbr wa cN cK wne cK cN
      wceq wn cK cN cle wbr cN cK wne cK cN wne cK cN wceq wn cN cK necom cK cN
      df-ne bitri anbi2i cK cN cle wbr cK cN wceq wn ancom bitri syl6bb biimpar
      an4s cN cM cuz cfv wcel cK cz wcel cK cN clt wbr cK cN c1 cmin co cle wbr
      wi cK cN wceq wn cK cN cle wbr cK cz wcel cN cM cuz cfv wcel cK cN clt
      wbr cK cN c1 cmin co cle wbr wi cK cz wcel cN cM cuz cfv wcel wa cK cN
      clt wbr cK cN c1 cmin co cle wbr cK cz wcel cN cz wcel cK cN clt wbr cK
      cN c1 cmin co cle wbr wb cN cM cuz cfv wcel cK cN zltlem1 cM cN eluzelz
      sylan2 biimpd ancoms ad2ant2r mpd 3adantr2 ex 3jcad ex cN cM cuz cfv wcel
      cK cM cN c1 cmin co cfz co wcel cK cz wcel cM cK cle wbr cK cN c1 cmin co
      cle wbr w3a cM cz wcel cN c1 cmin co cz wcel cK cM cN c1 cmin co cfz co
      wcel cK cz wcel cM cK cle wbr cK cN c1 cmin co cle wbr w3a wb cN cM cuz
      cfv wcel cK cM cN c1 cmin co elfz1 cM cN eluzel2 cN cz wcel c1 cz wcel cN
      c1 cmin co cz wcel cN cM cuz cfv wcel cN c1 zsubcl cM cN eluzelz 1z
      sylancl sylanc biimprd syl6d com23 sylbid imp orrd cK cN wceq cK cM cN c1
      cmin co cfz co wcel orcom sylib ex cN cM cuz cfv wcel cK cM cN c1 cmin co
      cfz co wcel cK cM cN cfz co wcel cK cN wceq cN cM cuz cfv wcel cM cN c1
      cmin co cfz co cM cN cfz co cK cN cM cuz cfv wcel cM cN c1 cmin co cfz co
      cM cN c1 cmin co c1 caddc co cfz co cM cN cfz co cM cz wcel cN c1 cmin co
      cz wcel cM cN c1 cmin co cfz co cM cN c1 cmin co c1 caddc co cfz co wss
      cN cM cuz cfv wcel cM cN c1 cmin co fzssp1 cM cN eluzel2 cN cz wcel c1 cz
      wcel cN c1 cmin co cz wcel cN cM cuz cfv wcel cN c1 zsubcl cM cN eluzelz
      1z sylancl sylanc cN cM cuz cfv wcel cN c1 cmin co c1 caddc co cN cM cfz
      cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq cN cM cuz cfv
      wcel cN c1 npcan cN cM cuz cfv wcel cN cz wcel cN cc wcel cM cN eluzelz
      cN zcn syl ax1cn sylancl opreq2d sseqtrd sseld cK cN wceq cK cM cN cfz co
      wcel cN cM cN cfz co wcel cN cM cuz cfv wcel cK cN cM cN cfz co eleq1 cM
      cN eluzfz2 syl5cbir jaod impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( A real number is an integer iff its absolute value is an integer. $)
    absz $p |- ( A e. RR -> ( A e. ZZ <-> ( abs ` A ) e. ZZ ) ) $=
      cA cr wcel cA cz wcel cA cabs cfv cz wcel cA cz wcel cA cabs cfv cn0 wcel
      cA cabs cfv cz wcel cA nn0abscl cA cabs cfv nn0z syl cA cr wcel cA cabs
      cfv cA wceq cA cabs cfv cA cneg wceq wo cA cabs cfv cz wcel cA cz wcel wi
      cA absor cA cr wcel cA cabs cfv cA wceq cA cabs cfv cz wcel cA cz wcel wi
      cA cabs cfv cA cneg wceq cA cabs cfv cA wceq cA cabs cfv cz wcel cA cz
      wcel wi wi cA cr wcel cA cabs cfv cA wceq cA cabs cfv cz wcel cA cz wcel
      cA cabs cfv cA cz eleq1 biimpd a1i cA cabs cfv cA cneg wceq cA cabs cfv
      cz wcel cA cneg cz wcel cA cr wcel cA cz wcel cA cabs cfv cA cneg wceq cA
      cabs cfv cz wcel cA cneg cz wcel cA cabs cfv cA cneg cz eleq1 biimpd cA
      cr wcel cA cneg cneg cz wcel cA cz wcel cA cneg cz wcel cA cr wcel cA
      cneg cneg cA cz cA cr wcel cA cc wcel cA cneg cneg cA wceq cA recn cA
      negneg syl eleq1d cA cneg znegcl syl5bi syl9r jaod mpd impbid2 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The difference between a real number and its nearest integer is less
    than or equal to one half. $)
    rddif $p |- ( A e. RR -> ( abs ` ( ( |_ ` ( A + ( 1 / 2 ) ) ) - A ) )
                                                            <_ ( 1 / 2 ) ) $=
      cA cr wcel cA c1 c2 cdiv co caddc co cfl cfv cA cmin co cabs cfv c1 c2
      cdiv co cle wbr cA cA cfl cfv cmin co c1 c2 cdiv co cA cr wcel cA cA cfl
      cfv cmin co c1 c2 cdiv co clt wbr wa cA c1 c2 cdiv co caddc co cfl cfv cA
      cmin co cabs cfv cA cA cfl cfv cmin co c1 c2 cdiv co cle cA cr wcel cA cA
      cfl cfv cmin co c1 c2 cdiv co clt wbr wa cA c1 c2 cdiv co caddc co cfl
      cfv cA cmin co cabs cfv cA cfl cfv cA cmin co cabs cfv cA cA cfl cfv cmin
      co cA cr wcel cA cA cfl cfv cmin co c1 c2 cdiv co clt wbr wa cA c1 c2
      cdiv co caddc co cfl cfv cA cmin co cA cfl cfv cA cmin co cabs cA cr wcel
      cA cA cfl cfv cmin co c1 c2 cdiv co clt wbr wa cA c1 c2 cdiv co caddc co
      cfl cfv cA cfl cfv cA cmin cA cr wcel cA cA cfl cfv cmin co c1 c2 cdiv co
      clt wbr wa cA c1 c2 cdiv co caddc co cfl cfv cA cfl cfv wceq cA cfl cfv
      cA c1 c2 cdiv co caddc co cle wbr cA c1 c2 cdiv co caddc co cA cfl cfv c1
      caddc co clt wbr wa cA cr wcel cA cA cfl cfv cmin co c1 c2 cdiv co clt
      wbr wa cA cfl cfv cA c1 c2 cdiv co caddc co cle wbr cA c1 c2 cdiv co
      caddc co cA cfl cfv c1 caddc co clt wbr cA cr wcel cA cfl cfv cA c1 c2
      cdiv co caddc co cle wbr cA cA cfl cfv cmin co c1 c2 cdiv co clt wbr cA
      cr wcel cA cfl cfv cA cA c1 c2 cdiv co caddc co cA reflcl cA cr wcel id
      cA cr wcel c1 c2 cdiv co cr wcel cA c1 c2 cdiv co caddc co cr wcel c2 2re
      2ne0 rereccli cA c1 c2 cdiv co readdcl mpan2 cA flle cA cr wcel cA cc0
      caddc co cA cA c1 c2 cdiv co caddc co cle cA cr wcel cA cc wcel cA cc0
      caddc co cA wceq cA recn cA ax0id syl cA cr wcel cc0 c1 c2 cdiv co cle
      wbr cA cc0 caddc co cA c1 c2 cdiv co caddc co cle wbr cc0 c1 c2 cdiv co
      0re c2 2re 2ne0 rereccli halfgt0 ltleii cc0 cr wcel c1 c2 cdiv co cr wcel
      cA cr wcel cc0 c1 c2 cdiv co cle wbr cA cc0 caddc co cA c1 c2 cdiv co
      caddc co cle wbr wb 0re c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co cA leadd2
      mp3an12 mpbii eqbrtrrd letrd adantr cA cr wcel cA cA cfl cfv cmin co c1
      c2 cdiv co clt wbr wa cA c1 c2 cdiv co caddc co cA cfl cfv c1 c2 cdiv co
      caddc co c1 c2 cdiv co caddc co cA cfl cfv c1 caddc co clt cA cr wcel cA
      cA cfl cfv cmin co c1 c2 cdiv co clt wbr wa cA cA cfl cfv c1 c2 cdiv co
      caddc co clt wbr cA c1 c2 cdiv co caddc co cA cfl cfv c1 c2 cdiv co caddc
      co c1 c2 cdiv co caddc co clt wbr cA cr wcel cA cA cfl cfv cmin co c1 c2
      cdiv co clt wbr cA cA cfl cfv c1 c2 cdiv co caddc co clt wbr cA cr wcel
      cA cfl cfv cr wcel c1 c2 cdiv co cr wcel cA cA cfl cfv cmin co c1 c2 cdiv
      co clt wbr cA cA cfl cfv c1 c2 cdiv co caddc co clt wbr wb cA reflcl c1
      c2 cdiv co cr wcel cA cr wcel c2 2re 2ne0 rereccli a1i cA cA cfl cfv c1
      c2 cdiv co ltsubadd2 mpd3an23 biimpa cA cr wcel cA cA cfl cfv c1 c2 cdiv
      co caddc co clt wbr cA c1 c2 cdiv co caddc co cA cfl cfv c1 c2 cdiv co
      caddc co c1 c2 cdiv co caddc co clt wbr wb cA cA cfl cfv cmin co c1 c2
      cdiv co clt wbr cA cr wcel cA cfl cfv c1 c2 cdiv co caddc co cr wcel c1
      c2 cdiv co cr wcel cA cA cfl cfv c1 c2 cdiv co caddc co clt wbr cA c1 c2
      cdiv co caddc co cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co caddc co
      clt wbr wb cA cfl cfv cr wcel c1 c2 cdiv co cr wcel cA cfl cfv c1 c2 cdiv
      co caddc co cr wcel cA cr wcel cA cfl cfv c1 c2 cdiv co readdcl cA reflcl
      c2 2re 2ne0 rereccli sylancl c1 c2 cdiv co cr wcel cA cr wcel c2 2re 2ne0
      rereccli a1i cA cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co ltadd1
      mpd3an23 adantr mpbid cA cr wcel cA cfl cfv c1 c2 cdiv co caddc co c1 c2
      cdiv co caddc co cA cfl cfv c1 caddc co wceq cA cA cfl cfv cmin co c1 c2
      cdiv co clt wbr cA cr wcel cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv
      co caddc co cA cfl cfv c1 c2 cdiv co c1 c2 cdiv co caddc co caddc co cA
      cfl cfv c1 caddc co cA cr wcel cA cfl cfv cc wcel cA cfl cfv c1 c2 cdiv
      co caddc co c1 c2 cdiv co caddc co cA cfl cfv c1 c2 cdiv co c1 c2 cdiv co
      caddc co caddc co wceq cA cr wcel cA cfl cfv cA reflcl recnd cA cfl cfv
      cc wcel c1 c2 cdiv co cc wcel c1 c2 cdiv co cc wcel cA cfl cfv c1 c2 cdiv
      co caddc co c1 c2 cdiv co caddc co cA cfl cfv c1 c2 cdiv co c1 c2 cdiv co
      caddc co caddc co wceq c1 c2 cdiv co c2 2re 2ne0 rereccli recni c1 c2
      cdiv co c2 2re 2ne0 rereccli recni cA cfl cfv c1 c2 cdiv co c1 c2 cdiv co
      addass mp3an23 syl cA cr wcel c1 c2 cdiv co c1 c2 cdiv co caddc co c1 cA
      cfl cfv caddc c1 c2 cdiv co c1 c2 cdiv co caddc co c1 wceq cA cr wcel c2
      c1 c2 cdiv co cmul co c1 c2 cdiv co c1 c2 cdiv co caddc co c1 c1 c2 cdiv
      co c1 c2 cdiv co c2 2re 2ne0 rereccli recni 2timesi c2 2cn 2ne0 recidi
      eqtr3i a1i opreq2d eqtrd adantr breqtrd jca cA cr wcel cA c1 c2 cdiv co
      caddc co cfl cfv cA cfl cfv wceq cA cfl cfv cA c1 c2 cdiv co caddc co cle
      wbr cA c1 c2 cdiv co caddc co cA cfl cfv c1 caddc co clt wbr wa wb cA cA
      cfl cfv cmin co c1 c2 cdiv co clt wbr cA c1 c2 cdiv co caddc co cr wcel
      cA cfl cfv cz wcel cA c1 c2 cdiv co caddc co cfl cfv cA cfl cfv wceq cA
      cfl cfv cA c1 c2 cdiv co caddc co cle wbr cA c1 c2 cdiv co caddc co cA
      cfl cfv c1 caddc co clt wbr wa wb cA cr wcel cA c1 c2 cdiv co caddc co cA
      cfl cfv flbi cA cr wcel c1 c2 cdiv co cr wcel cA c1 c2 cdiv co caddc co
      cr wcel c2 2re 2ne0 rereccli cA c1 c2 cdiv co readdcl mpan2 cA flcl
      sylanc adantr mpbird opreq1d fveq2d cA cr wcel cA cfl cfv cA cmin co cabs
      cfv cA cA cfl cfv cmin co wceq cA cA cfl cfv cmin co c1 c2 cdiv co clt
      wbr cA cfl cfv cr wcel cA cr wcel cA cfl cfv cA cle wbr cA cfl cfv cA
      cmin co cabs cfv cA cA cfl cfv cmin co wceq cA cr wcel cA cfl cfv cA
      abssuble0 cA reflcl cA cr wcel id cA flle syl3anc adantr eqtrd cA cr wcel
      cA cA cfl cfv cmin co c1 c2 cdiv co clt wbr cA cA cfl cfv cmin co c1 c2
      cdiv co cle wbr cA cA cfl cfv cmin co cr wcel c1 c2 cdiv co cr wcel cA cA
      cfl cfv cmin co c1 c2 cdiv co clt wbr cA cA cfl cfv cmin co c1 c2 cdiv co
      cle wbr wi cA cr wcel cA cA cfl cfv cmin co c1 c2 cdiv co ltle cA cr wcel
      cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl cfv
      resubcl mpdan c2 2re 2ne0 rereccli sylancl imp eqbrtrd cA cr wcel c1 c2
      cdiv co cA cA cfl cfv cmin co cle wbr wa cA c1 c2 cdiv co caddc co cfl
      cfv cA cmin co cabs cfv c1 cA cA cfl cfv cmin co cmin co c1 c2 cdiv co
      cle cA cr wcel c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr wa cA c1 c2
      cdiv co caddc co cfl cfv cA cmin co cabs cfv c1 cA cA cfl cfv cmin co
      cmin co cabs cfv c1 cA cA cfl cfv cmin co cmin co cA cr wcel c1 c2 cdiv
      co cA cA cfl cfv cmin co cle wbr wa cA c1 c2 cdiv co caddc co cfl cfv cA
      cmin co c1 cA cA cfl cfv cmin co cmin co cabs cA cr wcel c1 c2 cdiv co cA
      cA cfl cfv cmin co cle wbr wa cA c1 c2 cdiv co caddc co cfl cfv cA cmin
      co c1 cA cfl cfv caddc co cA cmin co c1 cA cA cfl cfv cmin co cmin co cA
      cr wcel c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr wa cA c1 c2 cdiv co
      caddc co cfl cfv c1 cA cfl cfv caddc co cA cmin cA cr wcel c1 c2 cdiv co
      cA cA cfl cfv cmin co cle wbr wa cA c1 c2 cdiv co caddc co cfl cfv c1 cA
      cfl cfv caddc co wceq c1 cA cfl cfv caddc co cA c1 c2 cdiv co caddc co
      cle wbr cA c1 c2 cdiv co caddc co c1 cA cfl cfv caddc co c1 caddc co clt
      wbr wa cA cr wcel c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr wa c1 cA
      cfl cfv caddc co cA c1 c2 cdiv co caddc co cle wbr cA c1 c2 cdiv co caddc
      co c1 cA cfl cfv caddc co c1 caddc co clt wbr cA cr wcel c1 c2 cdiv co cA
      cA cfl cfv cmin co cle wbr wa cA cfl cfv c1 c2 cdiv co caddc co c1 c2
      cdiv co caddc co c1 cA cfl cfv caddc co cA c1 c2 cdiv co caddc co cle cA
      cr wcel cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co caddc co c1 cA
      cfl cfv caddc co wceq c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr cA cr
      wcel cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co caddc co cA cfl cfv
      c1 c2 cdiv co c1 c2 cdiv co caddc co caddc co cA cfl cfv c1 caddc co c1
      cA cfl cfv caddc co cA cfl cfv cc wcel c1 c2 cdiv co cc wcel c1 c2 cdiv
      co cc wcel cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co caddc co cA
      cfl cfv c1 c2 cdiv co c1 c2 cdiv co caddc co caddc co wceq cA cr wcel cA
      cfl cfv c1 c2 cdiv co c1 c2 cdiv co addass cA cr wcel cA cfl cfv cA
      reflcl recnd c1 c2 cdiv co cc wcel cA cr wcel c1 c2 cdiv co c2 2re 2ne0
      rereccli recni a1i c1 c2 cdiv co cc wcel cA cr wcel c1 c2 cdiv co c2 2re
      2ne0 rereccli recni a1i syl3anc cA cr wcel c1 c2 cdiv co c1 c2 cdiv co
      caddc co c1 cA cfl cfv caddc c1 c2 cdiv co c1 c2 cdiv co caddc co c1 wceq
      cA cr wcel c2 c1 c2 cdiv co cmul co c1 c2 cdiv co c1 c2 cdiv co caddc co
      c1 c1 c2 cdiv co c1 c2 cdiv co c2 2re 2ne0 rereccli recni 2timesi c2 2cn
      2ne0 recidi eqtr3i a1i opreq2d cA cfl cfv cc wcel c1 cc wcel cA cfl cfv
      c1 caddc co c1 cA cfl cfv caddc co wceq cA cr wcel cA cfl cfv c1 addcom
      cA cr wcel cA cfl cfv cA reflcl recnd ax1cn sylancl 3eqtrd adantr cA cr
      wcel c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr wa cA cfl cfv c1 c2 cdiv
      co caddc co cA cle wbr cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co
      caddc co cA c1 c2 cdiv co caddc co cle wbr cA cr wcel cA cfl cfv c1 c2
      cdiv co caddc co cA cle wbr c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr
      cA cfl cfv cr wcel c1 c2 cdiv co cr wcel cA cr wcel cA cfl cfv c1 c2 cdiv
      co caddc co cA cle wbr c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr wb cA
      cr wcel cA cfl cfv c1 c2 cdiv co cA leaddsub2 cA reflcl c1 c2 cdiv co cr
      wcel cA cr wcel c2 2re 2ne0 rereccli a1i cA cr wcel id syl3anc biimpar cA
      cr wcel cA cfl cfv c1 c2 cdiv co caddc co cA cle wbr cA cfl cfv c1 c2
      cdiv co caddc co c1 c2 cdiv co caddc co cA c1 c2 cdiv co caddc co cle wbr
      wb c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr cA cfl cfv c1 c2 cdiv co
      caddc co cr wcel cA cr wcel c1 c2 cdiv co cr wcel cA cfl cfv c1 c2 cdiv
      co caddc co cA cle wbr cA cfl cfv c1 c2 cdiv co caddc co c1 c2 cdiv co
      caddc co cA c1 c2 cdiv co caddc co cle wbr wb cA cr wcel cA cfl cfv c1 c2
      cdiv co caddc co cA c1 c2 cdiv co leadd1 cA cfl cfv cr wcel c1 c2 cdiv co
      cr wcel cA cfl cfv c1 c2 cdiv co caddc co cr wcel cA cr wcel cA cfl cfv
      c1 c2 cdiv co readdcl cA reflcl c2 2re 2ne0 rereccli sylancl cA cr wcel
      id c1 c2 cdiv co cr wcel cA cr wcel c2 2re 2ne0 rereccli a1i syl3anc
      adantr mpbid eqbrtrrd cA cr wcel cA c1 c2 cdiv co caddc co c1 cA cfl cfv
      caddc co c1 caddc co clt wbr c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr
      cA cr wcel cA c1 cA cfl cfv caddc co clt wbr c1 c2 cdiv co c1 clt wbr wa
      cA c1 c2 cdiv co caddc co c1 cA cfl cfv caddc co c1 caddc co clt wbr cA
      cr wcel cA c1 cA cfl cfv caddc co clt wbr c1 c2 cdiv co c1 clt wbr cA cr
      wcel cA cA cfl cfv cmin co c1 clt wbr cA c1 cA cfl cfv caddc co clt wbr
      cA fraclt1 cA cr wcel cA cfl cfv cr wcel c1 cr wcel cA cA cfl cfv cmin co
      c1 clt wbr cA c1 cA cfl cfv caddc co clt wbr wb cA reflcl c1 cr wcel cA
      cr wcel 1re a1i cA cA cfl cfv c1 ltsubadd mpd3an23 mpbid halflt1 jctir cA
      cr wcel c1 c2 cdiv co cr wcel c1 cA cfl cfv caddc co cr wcel c1 cr wcel
      cA c1 cA cfl cfv caddc co clt wbr c1 c2 cdiv co c1 clt wbr wa cA c1 c2
      cdiv co caddc co c1 cA cfl cfv caddc co c1 caddc co clt wbr wi cA cr wcel
      cA c1 c2 cdiv co c1 cA cfl cfv caddc co c1 lt2add cA cr wcel id c1 c2
      cdiv co cr wcel cA cr wcel c2 2re 2ne0 rereccli a1i c1 cr wcel cA cfl cfv
      cr wcel c1 cA cfl cfv caddc co cr wcel cA cr wcel c1 cA cfl cfv readdcl
      1re cA reflcl sylancr c1 cr wcel cA cr wcel 1re a1i syl2anc mpd adantr
      jca cA cr wcel cA c1 c2 cdiv co caddc co cfl cfv c1 cA cfl cfv caddc co
      wceq c1 cA cfl cfv caddc co cA c1 c2 cdiv co caddc co cle wbr cA c1 c2
      cdiv co caddc co c1 cA cfl cfv caddc co c1 caddc co clt wbr wa wb c1 c2
      cdiv co cA cA cfl cfv cmin co cle wbr cA c1 c2 cdiv co caddc co cr wcel
      c1 cA cfl cfv caddc co cz wcel cA c1 c2 cdiv co caddc co cfl cfv c1 cA
      cfl cfv caddc co wceq c1 cA cfl cfv caddc co cA c1 c2 cdiv co caddc co
      cle wbr cA c1 c2 cdiv co caddc co c1 cA cfl cfv caddc co c1 caddc co clt
      wbr wa wb cA cr wcel cA c1 c2 cdiv co caddc co c1 cA cfl cfv caddc co
      flbi cA cr wcel c1 c2 cdiv co cr wcel cA c1 c2 cdiv co caddc co cr wcel
      c2 2re 2ne0 rereccli cA c1 c2 cdiv co readdcl mpan2 c1 cz wcel cA cfl cfv
      cz wcel c1 cA cfl cfv caddc co cz wcel cA cr wcel c1 cA cfl cfv zaddcl 1z
      cA flcl sylancr sylanc adantr mpbird opreq1d cA cr wcel c1 cA cA cfl cfv
      cmin co cmin co c1 cA cfl cfv caddc co cA cmin co wceq c1 c2 cdiv co cA
      cA cfl cfv cmin co cle wbr c1 cc wcel cA cc wcel cA cfl cfv cc wcel c1 cA
      cA cfl cfv cmin co cmin co c1 cA cfl cfv caddc co cA cmin co wceq cA cr
      wcel c1 cA cA cfl cfv subsub3 c1 cc wcel cA cr wcel ax1cn a1i cA recn cA
      cr wcel cA cfl cfv cA reflcl recnd syl3anc adantr eqtr4d fveq2d cA cr
      wcel c1 cA cA cfl cfv cmin co cmin co cabs cfv c1 cA cA cfl cfv cmin co
      cmin co wceq c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr c1 cA cA cfl cfv
      cmin co cmin co cr wcel cc0 c1 cA cA cfl cfv cmin co cmin co cle wbr c1
      cA cA cfl cfv cmin co cmin co cabs cfv c1 cA cA cfl cfv cmin co cmin co
      wceq cA cr wcel c1 cA cA cfl cfv cmin co cmin co absid c1 cr wcel cA cA
      cfl cfv cmin co cr wcel c1 cA cA cfl cfv cmin co cmin co cr wcel cA cr
      wcel c1 cA cA cfl cfv cmin co resubcl 1re cA cr wcel cA cfl cfv cr wcel
      cA cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl cfv resubcl mpdan
      sylancr cA cr wcel cc0 c1 cA cA cfl cfv cmin co cmin co cle wbr cA cA cfl
      cfv cmin co c1 cle wbr cA cr wcel cA cA cfl cfv cmin co c1 clt wbr cA cA
      cfl cfv cmin co c1 cle wbr cA fraclt1 cA cA cfl cfv cmin co cr wcel c1 cr
      wcel cA cA cfl cfv cmin co c1 clt wbr cA cA cfl cfv cmin co c1 cle wbr wi
      cA cr wcel cA cA cfl cfv cmin co c1 ltle cA cr wcel cA cfl cfv cr wcel cA
      cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl cfv resubcl mpdan 1re
      sylancl mpd c1 cr wcel cA cA cfl cfv cmin co cr wcel cc0 c1 cA cA cfl cfv
      cmin co cmin co cle wbr cA cA cfl cfv cmin co c1 cle wbr wb cA cr wcel c1
      cA cA cfl cfv cmin co subge0 1re cA cr wcel cA cfl cfv cr wcel cA cA cfl
      cfv cmin co cr wcel cA reflcl cA cA cfl cfv resubcl mpdan sylancr mpbird
      sylanc adantr eqtrd cA cr wcel c1 c2 cdiv co cA cA cfl cfv cmin co cle
      wbr wa c1 cA cA cfl cfv cmin co cmin co c1 c1 c2 cdiv co cmin co c1 c2
      cdiv co cle cA cr wcel c1 c2 cdiv co cA cA cfl cfv cmin co cle wbr c1 cA
      cA cfl cfv cmin co cmin co c1 c1 c2 cdiv co cmin co cle wbr c1 c2 cdiv co
      cr wcel cA cA cfl cfv cmin co cr wcel c1 cr wcel c1 c2 cdiv co cA cA cfl
      cfv cmin co cle wbr c1 cA cA cfl cfv cmin co cmin co c1 c1 c2 cdiv co
      cmin co cle wbr wb cA cr wcel c1 c2 cdiv co cA cA cfl cfv cmin co c1
      lesub2 c1 c2 cdiv co cr wcel cA cr wcel c2 2re 2ne0 rereccli a1i cA cr
      wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel cA reflcl cA cA cfl
      cfv resubcl mpdan c1 cr wcel cA cr wcel 1re a1i syl3anc biimpa c1 c1 c2
      cdiv co c1 c2 cdiv co ax1cn c1 c2 cdiv co c2 2re 2ne0 rereccli recni c1
      c2 cdiv co c2 2re 2ne0 rereccli recni c2 c1 c2 cdiv co cmul co c1 c2 cdiv
      co c1 c2 cdiv co caddc co c1 c1 c2 cdiv co c1 c2 cdiv co c2 2re 2ne0
      rereccli recni 2timesi c2 2cn 2ne0 recidi eqtr3i subaddrii syl6breq
      eqbrtrd cA cr wcel cA cfl cfv cr wcel cA cA cfl cfv cmin co cr wcel cA
      reflcl cA cA cfl cfv resubcl mpdan c1 c2 cdiv co cr wcel cA cr wcel c2
      2re 2ne0 rereccli a1i pm2.61ltlei $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Bound on the absolute value of a real number rounded to the nearest
    integer. $)
    absrdbnd $p |- ( A e. RR -> ( abs ` ( |_ ` ( A + ( 1 / 2 ) ) ) )
                                          <_ ( ( |_ ` ( abs ` A ) ) + 1 ) ) $=
      cA cr wcel cA c1 c2 cdiv co caddc co cfl cfv cabs cfv cA cabs cfv cfl cfv
      c1 caddc co cle wbr cA cc0 cA cr wcel cA cc0 clt wbr wa cA c1 c2 cdiv co
      caddc co cfl cfv cneg cA cneg cfl cfv c1 caddc co cA c1 c2 cdiv co caddc
      co cfl cfv cabs cfv cA cabs cfv cfl cfv c1 caddc co cle cA cr wcel cA cc0
      clt wbr wa cA c1 c2 cdiv co caddc co cfl cfv cneg cA cfl cfv cneg cA cneg
      cfl cfv c1 caddc co cA cr wcel cA c1 c2 cdiv co caddc co cfl cfv cneg cr
      wcel cA cc0 clt wbr cA cr wcel cA c1 c2 cdiv co caddc co cfl cfv cr wcel
      cA c1 c2 cdiv co caddc co cfl cfv cneg cr wcel cA cr wcel cA c1 c2 cdiv
      co caddc co cr wcel cA c1 c2 cdiv co caddc co cfl cfv cz wcel cA c1 c2
      cdiv co caddc co cfl cfv cr wcel cA cr wcel c1 c2 cdiv co cr wcel cA c1
      c2 cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA c1 c2 cdiv co readdcl
      mpan2 cA c1 c2 cdiv co caddc co flcl cA c1 c2 cdiv co caddc co cfl cfv
      zre 3syl cA c1 c2 cdiv co caddc co cfl cfv renegcl syl adantr cA cr wcel
      cA cfl cfv cneg cr wcel cA cc0 clt wbr cA cr wcel cA cfl cfv cr wcel cA
      cfl cfv cneg cr wcel cA reflcl cA cfl cfv renegcl syl adantr cA cr wcel
      cA cneg cfl cfv c1 caddc co cr wcel cA cc0 clt wbr cA cr wcel cA cneg cfl
      cfv cr wcel cA cneg cfl cfv c1 caddc co cr wcel cA cr wcel cA cneg cr
      wcel cA cneg cfl cfv cz wcel cA cneg cfl cfv cr wcel cA renegcl cA cneg
      flcl cA cneg cfl cfv zre 3syl cA cneg cfl cfv peano2re syl adantr cA cr
      wcel cA c1 c2 cdiv co caddc co cfl cfv cneg cA cfl cfv cneg cle wbr cA
      cc0 clt wbr cA cr wcel cA cfl cfv cA c1 c2 cdiv co caddc co cfl cfv cle
      wbr cA c1 c2 cdiv co caddc co cfl cfv cneg cA cfl cfv cneg cle wbr cA cr
      wcel cA c1 c2 cdiv co caddc co cr wcel cA cA c1 c2 cdiv co caddc co cle
      wbr cA cfl cfv cA c1 c2 cdiv co caddc co cfl cfv cle wbr cA cr wcel c1 c2
      cdiv co cr wcel cA c1 c2 cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA
      c1 c2 cdiv co readdcl mpan2 cA cr wcel cA cc0 caddc co cA cA c1 c2 cdiv
      co caddc co cle cA cr wcel cA cc wcel cA cc0 caddc co cA wceq cA recn cA
      addid1 syl cA cr wcel cc0 c1 c2 cdiv co cle wbr cA cc0 caddc co cA c1 c2
      cdiv co caddc co cle wbr cc0 c1 cle wbr cc0 c2 clt wbr cc0 c1 c2 cdiv co
      cle wbr cc0 c1 0re 1re lt01 ltleii 2pos c1 c2 1re 2re divge0i mp2an cc0
      cr wcel c1 c2 cdiv co cr wcel cA cr wcel cc0 c1 c2 cdiv co cle wbr cA cc0
      caddc co cA c1 c2 cdiv co caddc co cle wbr wb 0re c2 2re 2ne0 rereccli
      cc0 c1 c2 cdiv co cA leadd2 mp3an12 mpbii eqbrtrrd cA cA c1 c2 cdiv co
      caddc co flwordi mpd3an23 cA cfl cfv cr wcel cA c1 c2 cdiv co caddc co
      cfl cfv cr wcel cA cfl cfv cA c1 c2 cdiv co caddc co cfl cfv cle wbr cA
      c1 c2 cdiv co caddc co cfl cfv cneg cA cfl cfv cneg cle wbr wb cA cr wcel
      cA cfl cfv cA c1 c2 cdiv co caddc co cfl cfv leneg cA reflcl cA cr wcel
      cA c1 c2 cdiv co caddc co cr wcel cA c1 c2 cdiv co caddc co cfl cfv cz
      wcel cA c1 c2 cdiv co caddc co cfl cfv cr wcel cA cr wcel c1 c2 cdiv co
      cr wcel cA c1 c2 cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA c1 c2
      cdiv co readdcl mpan2 cA c1 c2 cdiv co caddc co flcl cA c1 c2 cdiv co
      caddc co cfl cfv zre 3syl sylanc mpbid adantr cA cr wcel cA cfl cfv cneg
      cA cneg cfl cfv c1 caddc co cle wbr cA cc0 clt wbr cA cr wcel cA cfl cfv
      cneg c1 cmin co cA cneg cfl cfv cle wbr cA cfl cfv cneg cA cneg cfl cfv
      c1 caddc co cle wbr cA cr wcel cA cfl cfv c1 caddc co cneg cA cneg cfl
      cfv cneg cneg cA cfl cfv cneg c1 cmin co cA cneg cfl cfv cle cA cr wcel
      cA cneg cfl cfv cneg cA cfl cfv c1 caddc co cle wbr cA cfl cfv c1 caddc
      co cneg cA cneg cfl cfv cneg cneg cle wbr cA cr wcel cA cfl cfv c1 caddc
      co cz wcel cA cA cfl cfv c1 caddc co cle wbr cA cneg cfl cfv cneg cA cfl
      cfv c1 caddc co cle wbr cA cr wcel cA cfl cfv cA flcl peano2zdi cA cr
      wcel cA cA cfl cfv c1 caddc co clt wbr cA cA cfl cfv c1 caddc co cle wbr
      cA flltp1 cA cr wcel cA cfl cfv c1 caddc co cr wcel cA cA cfl cfv c1
      caddc co clt wbr cA cA cfl cfv c1 caddc co cle wbr wi cA cr wcel cA cfl
      cfv cr wcel cA cfl cfv c1 caddc co cr wcel cA reflcl cA cfl cfv peano2re
      syl cA cA cfl cfv c1 caddc co ltle mpdan mpd cA cA cfl cfv c1 caddc co
      ceile mpd3an23 cA cneg cfl cfv cneg cr wcel cA cfl cfv c1 caddc co cr
      wcel cA cneg cfl cfv cneg cA cfl cfv c1 caddc co cle wbr cA cfl cfv c1
      caddc co cneg cA cneg cfl cfv cneg cneg cle wbr wb cA cr wcel cA cneg cfl
      cfv cneg cA cfl cfv c1 caddc co leneg cA cr wcel cA cneg cfl cfv cr wcel
      cA cneg cfl cfv cneg cr wcel cA cr wcel cA cneg cr wcel cA cneg cfl cfv
      cz wcel cA cneg cfl cfv cr wcel cA renegcl cA cneg flcl cA cneg cfl cfv
      zre 3syl cA cneg cfl cfv renegcl syl cA cr wcel cA cfl cfv cr wcel cA cfl
      cfv c1 caddc co cr wcel cA reflcl cA cfl cfv peano2re syl sylanc mpbid cA
      cfl cfv cc wcel c1 cc wcel cA cfl cfv c1 caddc co cneg cA cfl cfv cneg c1
      cmin co wceq cA cr wcel cA cfl cfv c1 negdi2 cA cr wcel cA cfl cfv cA
      reflcl recnd ax1cn sylancl cA cr wcel cA cneg cfl cfv cc wcel cA cneg cfl
      cfv cneg cneg cA cneg cfl cfv wceq cA cr wcel cA cneg cr wcel cA cneg cfl
      cfv cz wcel cA cneg cfl cfv cc wcel cA renegcl cA cneg flcl cA cneg cfl
      cfv zcn 3syl cA cneg cfl cfv negneg syl 3brtr3d cA cfl cfv cneg cr wcel
      c1 cr wcel cA cneg cfl cfv cr wcel cA cfl cfv cneg c1 cmin co cA cneg cfl
      cfv cle wbr cA cfl cfv cneg cA cneg cfl cfv c1 caddc co cle wbr wb cA cr
      wcel cA cfl cfv cneg c1 cA cneg cfl cfv lesubadd cA cr wcel cA cfl cfv cr
      wcel cA cfl cfv cneg cr wcel cA reflcl cA cfl cfv renegcl syl c1 cr wcel
      cA cr wcel 1re a1i cA cr wcel cA cneg cr wcel cA cneg cfl cfv cz wcel cA
      cneg cfl cfv cr wcel cA renegcl cA cneg flcl cA cneg cfl cfv zre 3syl
      syl3anc mpbid adantr letrd cA c1 c2 cdiv co caddc co cfl cfv cr wcel cA
      c1 c2 cdiv co caddc co cfl cfv cc0 cle wbr cA c1 c2 cdiv co caddc co cfl
      cfv cabs cfv cA c1 c2 cdiv co caddc co cfl cfv cneg wceq cA cr wcel cA
      cc0 clt wbr wa cA c1 c2 cdiv co caddc co cfl cfv absnid cA cr wcel cA cc0
      clt wbr wa cA c1 c2 cdiv co caddc co cr wcel cA c1 c2 cdiv co caddc co
      cfl cfv cz wcel cA c1 c2 cdiv co caddc co cfl cfv cr wcel cA cr wcel cA
      c1 c2 cdiv co caddc co cr wcel cA cc0 clt wbr cA cr wcel c1 c2 cdiv co cr
      wcel cA c1 c2 cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA c1 c2 cdiv
      co readdcl mpan2 adantr cA c1 c2 cdiv co caddc co flcl cA c1 c2 cdiv co
      caddc co cfl cfv zre 3syl cA cr wcel cA cc0 clt wbr wa cA c1 c2 cdiv co
      caddc co cfl cfv c1 c2 cdiv co cfl cfv cc0 cle cA c1 c2 cdiv co caddc co
      cr wcel c1 c2 cdiv co cr wcel cA c1 c2 cdiv co caddc co c1 c2 cdiv co cle
      wbr cA c1 c2 cdiv co caddc co cfl cfv c1 c2 cdiv co cfl cfv cle wbr cA cr
      wcel cA cc0 clt wbr wa cA c1 c2 cdiv co caddc co c1 c2 cdiv co flwordi cA
      cr wcel cA c1 c2 cdiv co caddc co cr wcel cA cc0 clt wbr cA cr wcel c1 c2
      cdiv co cr wcel cA c1 c2 cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA
      c1 c2 cdiv co readdcl mpan2 adantr c1 c2 cdiv co cr wcel cA cr wcel cA
      cc0 clt wbr wa c2 2re 2ne0 rereccli a1i cA cr wcel cA cc0 clt wbr wa cA
      c1 c2 cdiv co caddc co cc0 c1 c2 cdiv co caddc co c1 c2 cdiv co cle cA cr
      wcel cA cc0 clt wbr wa cA cc0 cle wbr cA c1 c2 cdiv co caddc co cc0 c1 c2
      cdiv co caddc co cle wbr cA cr wcel cA cc0 clt wbr cA cc0 cle wbr cA cr
      wcel cc0 cr wcel cA cc0 clt wbr cA cc0 cle wbr wi 0re cA cc0 ltle mpan2
      imp cA cr wcel cA cc0 cle wbr cA c1 c2 cdiv co caddc co cc0 c1 c2 cdiv co
      caddc co cle wbr wb cA cc0 clt wbr cA cr wcel cc0 cr wcel c1 c2 cdiv co
      cr wcel cA cc0 cle wbr cA c1 c2 cdiv co caddc co cc0 c1 c2 cdiv co caddc
      co cle wbr wb 0re c2 2re 2ne0 rereccli cA cc0 c1 c2 cdiv co leadd1
      mp3an23 adantr mpbid c1 c2 cdiv co c1 c2 cdiv co c2 2re 2ne0 rereccli
      recni addid2i syl6breq syl3anc c1 c2 cdiv co cfl cfv cc0 wceq cc0 c1 c2
      cdiv co cle wbr c1 c2 cdiv co cc0 c1 caddc co clt wbr c1 c2 cdiv co cr
      wcel cc0 cz wcel c1 c2 cdiv co cfl cfv cc0 wceq cc0 c1 c2 cdiv co cle wbr
      c1 c2 cdiv co cc0 c1 caddc co clt wbr wa wb c2 2re 2ne0 rereccli 0z c1 c2
      cdiv co cc0 flbi mp2an cc0 c1 cle wbr cc0 c2 clt wbr cc0 c1 c2 cdiv co
      cle wbr cc0 c1 0re 1re lt01 ltleii 2pos c1 c2 1re 2re divge0i mp2an c1 c2
      cdiv co c1 cc0 c1 caddc co clt halflt1 c1 ax1cn addid2i breqtrri mpbir2an
      syl6breq sylanc cA cr wcel cA cc0 clt wbr wa cA cabs cfv cfl cfv cA cneg
      cfl cfv c1 caddc cA cr wcel cA cc0 clt wbr wa cA cabs cfv cA cneg cfl cA
      cr wcel cA cc0 clt wbr cA cc0 cle wbr cA cabs cfv cA cneg wceq cA cr wcel
      cA cc0 clt wbr cA cc0 cle wbr cA cr wcel cc0 cr wcel cA cc0 clt wbr cA
      cc0 cle wbr wi 0re cA cc0 ltle mpan2 imp cA absnid syldan fveq2d opreq1d
      3brtr4d cA cr wcel cc0 cA cle wbr wa cA c1 c2 cdiv co caddc co cfl cfv cA
      cfl cfv c1 caddc co cA c1 c2 cdiv co caddc co cfl cfv cabs cfv cA cabs
      cfv cfl cfv c1 caddc co cle cA cr wcel cA c1 c2 cdiv co caddc co cfl cfv
      cA cfl cfv c1 caddc co cle wbr cc0 cA cle wbr cA cr wcel cA c1 c2 cdiv co
      caddc co cfl cfv cA c1 caddc co cfl cfv cA cfl cfv c1 caddc co cle cA c1
      c2 cdiv co caddc co cr wcel cA c1 caddc co cr wcel cA c1 c2 cdiv co caddc
      co cA c1 caddc co cle wbr cA c1 c2 cdiv co caddc co cfl cfv cA c1 caddc
      co cfl cfv cle wbr cA cr wcel cA c1 c2 cdiv co caddc co cA c1 caddc co
      flwordi cA cr wcel c1 c2 cdiv co cr wcel cA c1 c2 cdiv co caddc co cr
      wcel c2 2re 2ne0 rereccli cA c1 c2 cdiv co readdcl mpan2 cA peano2re cA
      cr wcel c1 c2 cdiv co c1 cle wbr cA c1 c2 cdiv co caddc co cA c1 caddc co
      cle wbr c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1 ltleii c1 c2
      cdiv co cr wcel c1 cr wcel cA cr wcel c1 c2 cdiv co c1 cle wbr cA c1 c2
      cdiv co caddc co cA c1 caddc co cle wbr wb c2 2re 2ne0 rereccli 1re c1 c2
      cdiv co c1 cA leadd2 mp3an12 mpbii syl3anc cA cr wcel c1 cz wcel cA c1
      caddc co cfl cfv cA cfl cfv c1 caddc co wceq 1z cA c1 fladdz mpan2
      breqtrd adantr cA c1 c2 cdiv co caddc co cfl cfv cr wcel cc0 cA c1 c2
      cdiv co caddc co cfl cfv cle wbr cA c1 c2 cdiv co caddc co cfl cfv cabs
      cfv cA c1 c2 cdiv co caddc co cfl cfv wceq cA cr wcel cc0 cA cle wbr wa
      cA c1 c2 cdiv co caddc co cfl cfv absid cA cr wcel cc0 cA cle wbr wa cA
      c1 c2 cdiv co caddc co cr wcel cA c1 c2 cdiv co caddc co cfl cfv cz wcel
      cA c1 c2 cdiv co caddc co cfl cfv cr wcel cA cr wcel cA c1 c2 cdiv co
      caddc co cr wcel cc0 cA cle wbr cA cr wcel c1 c2 cdiv co cr wcel cA c1 c2
      cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA c1 c2 cdiv co readdcl
      mpan2 adantr cA c1 c2 cdiv co caddc co flcl cA c1 c2 cdiv co caddc co cfl
      cfv zre 3syl cA cr wcel cc0 cA cle wbr wa cc0 cA c1 c2 cdiv co caddc co
      cle wbr cc0 cA c1 c2 cdiv co caddc co cfl cfv cle wbr cA cr wcel cc0 cA
      cle wbr wa c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr cc0 cA c1 c2
      cdiv co caddc co cle wbr c2 2re 2ne0 rereccli cc0 c1 cle wbr cc0 c2 clt
      wbr cc0 c1 c2 cdiv co cle wbr cc0 c1 0re 1re lt01 ltleii 2pos c1 c2 1re
      2re divge0i mp2an cA cr wcel c1 c2 cdiv co cr wcel cc0 cA cle wbr cc0 c1
      c2 cdiv co cle wbr cc0 cA c1 c2 cdiv co caddc co cle wbr cA c1 c2 cdiv co
      addge0 an4s mpanr12 cA c1 c2 cdiv co caddc co cr wcel cc0 cz wcel cc0 cA
      c1 c2 cdiv co caddc co cle wbr cc0 cA c1 c2 cdiv co caddc co cfl cfv cle
      wbr wb cA cr wcel cc0 cA cle wbr wa cA c1 c2 cdiv co caddc co cc0 flge cA
      cr wcel cA c1 c2 cdiv co caddc co cr wcel cc0 cA cle wbr cA cr wcel c1 c2
      cdiv co cr wcel cA c1 c2 cdiv co caddc co cr wcel c2 2re 2ne0 rereccli cA
      c1 c2 cdiv co readdcl mpan2 adantr 0z sylancl mpbid sylanc cA cr wcel cc0
      cA cle wbr wa cA cabs cfv cfl cfv cA cfl cfv c1 caddc cA cr wcel cc0 cA
      cle wbr wa cA cabs cfv cA cfl cA absid fveq2d opreq1d 3brtr4d cA cr wcel
      id cc0 cr wcel cA cr wcel 0re a1i pm2.61ltlei $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( ` A mod B ` is zero iff ` A ` is evenly divisible by ` B ` . $)
    mod0 $p |- ( ( A e. RR /\ B e. RR+ ) ->
                                ( ( A mod B ) = 0 <-> ( A / B ) e. ZZ ) ) $=
      cA cr wcel cB crp wcel wa cA cB cmo co cc0 wceq cA cB cdiv co cfl cfv cA
      cB cdiv co wceq cA cB cdiv co cz wcel cA cr wcel cB crp wcel wa cA cB cmo
      co cc0 wceq cA cB cA cB cdiv co cfl cfv cmul co cmin co cc0 wceq cA cB cA
      cB cdiv co cfl cfv cmul co wceq cA cB cdiv co cfl cfv cA cB cdiv co wceq
      cA cr wcel cB crp wcel wa cA cB cmo co cA cB cA cB cdiv co cfl cfv cmul
      co cmin co cc0 cA cB modval eqeq1d cA cc wcel cB cA cB cdiv co cfl cfv
      cmul co cc wcel cA cB cA cB cdiv co cfl cfv cmul co cmin co cc0 wceq cA
      cB cA cB cdiv co cfl cfv cmul co wceq wb cA cr wcel cB crp wcel wa cA cB
      cA cB cdiv co cfl cfv cmul co subeq0 cA cr wcel cA cc wcel cB crp wcel cA
      recn adantr cA cr wcel cB crp wcel wa cB cA cB cdiv co cfl cfv cmul co cB
      cr wcel cA cB cdiv co cfl cfv cr wcel cB cA cB cdiv co cfl cfv cmul co cr
      wcel cA cr wcel cB crp wcel wa cB cA cB cdiv co cfl cfv remulcl cB crp
      wcel cB cr wcel cA cr wcel cB rpre adantl cA cr wcel cB crp wcel wa cA cB
      cdiv co cr wcel cA cB cdiv co cfl cfv cr wcel cA cB rerpdivcl cA cB cdiv
      co reflcl syl sylanc recnd sylanc cA cr wcel cB crp wcel wa cA cB cdiv co
      cA cB cdiv co cfl cfv wceq cA cB cA cB cdiv co cfl cfv cmul co wceq cA cB
      cdiv co cfl cfv cA cB cdiv co wceq cA cc wcel cA cB cdiv co cfl cfv cc
      wcel cB cc wcel cB cc0 wne wa cA cB cdiv co cA cB cdiv co cfl cfv wceq cA
      cB cA cB cdiv co cfl cfv cmul co wceq wb cA cr wcel cB crp wcel wa cA cA
      cB cdiv co cfl cfv cB divmul2 cA cr wcel cA cc wcel cB crp wcel cA recn
      adantr cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cfl
      cfv cc wcel cA cB rerpdivcl cA cB cdiv co cr wcel cA cB cdiv co cfl cfv
      cA cB cdiv co reflcl recnd syl cB crp wcel cB cc wcel cB cc0 wne wa cA cr
      wcel cB rpcnne0 adantl syl3anc cA cB cdiv co cA cB cdiv co cfl cfv eqcom
      syl5rbbr 3bitrd cA cr wcel cB crp wcel wa cA cB cdiv co cr wcel cA cB
      cdiv co cfl cfv cA cB cdiv co wceq cA cB cdiv co cz wcel wb cA cB
      rerpdivcl cA cB cdiv co flidz syl bitrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( ` A ` is divisible by ` B ` iff its negative is. $)
    negmod0 $p |- ( ( A e. RR /\ B e. RR+ ) ->
                      ( ( A mod B ) = 0 <-> ( -u A mod B ) = 0 ) ) $=
      cA cr wcel cB crp wcel wa cA cB cdiv co cz wcel cA cneg cB cdiv co cz
      wcel cA cB cmo co cc0 wceq cA cneg cB cmo co cc0 wceq cA cr wcel cB crp
      wcel wa cA cB cdiv co cz wcel cA cB cdiv co cneg cz wcel cA cneg cB cdiv
      co cz wcel cA cr wcel cB crp wcel wa cA cB cdiv co cz wcel cA cB cdiv co
      cneg cz wcel cA cB cdiv co znegcl cA cr wcel cB crp wcel wa cA cB cdiv co
      cneg cneg cz wcel cA cB cdiv co cz wcel cA cB cdiv co cneg cz wcel cA cr
      wcel cB crp wcel wa cA cB cdiv co cneg cneg cA cB cdiv co cz cA cr wcel
      cB crp wcel wa cA cB cdiv co cr wcel cA cB cdiv co cc wcel cA cB cdiv co
      cneg cneg cA cB cdiv co wceq cA cB rerpdivcl cA cB cdiv co recn cA cB
      cdiv co negneg 3syl eleq1d cA cB cdiv co cneg znegcl syl5bi impbid2 cA cr
      wcel cB crp wcel wa cA cB cdiv co cneg cA cneg cB cdiv co cz cA cc wcel
      cB cc wcel cB cc0 wne cA cB cdiv co cneg cA cneg cB cdiv co wceq cA cr
      wcel cB crp wcel wa cA cB divneg cA cr wcel cA cc wcel cB crp wcel cA
      recn adantr cB crp wcel cB cc wcel cA cr wcel cB rpcn adantl cB crp wcel
      cB cc0 wne cA cr wcel cB rpne0 adantl syl3anc eleq1d bitrd cA cB mod0 cA
      cneg cr wcel cB crp wcel cA cneg cB cmo co cc0 wceq cA cneg cB cdiv co cz
      wcel wb cA cr wcel cA cneg cB mod0 cA renegcl sylan 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( ` A ` is divisible by ` B ` iff its absolute value is. $)
    absmod0 $p |- ( ( A e. RR /\ B e. RR+ ) ->
                      ( ( A mod B ) = 0 <-> ( ( abs ` A ) mod B ) = 0 ) ) $=
      cA cr wcel cB crp wcel wa cA cabs cfv cA wceq cA cabs cfv cA cneg wceq wo
      cA cB cmo co cc0 wceq cA cabs cfv cB cmo co cc0 wceq wb cA cr wcel cA
      cabs cfv cA wceq cA cabs cfv cA cneg wceq wo cB crp wcel cA absor adantr
      cA cr wcel cB crp wcel wa cA cabs cfv cA wceq cA cB cmo co cc0 wceq cA
      cabs cfv cB cmo co cc0 wceq wb cA cabs cfv cA cneg wceq cA cabs cfv cA
      wceq cA cB cmo co cc0 wceq cA cabs cfv cB cmo co cc0 wceq wb wi cA cr
      wcel cB crp wcel wa cA cabs cfv cA wceq cA cB cmo co cA cabs cfv cB cmo
      co cc0 cA cB cmo co cA cabs cfv cB cmo co wceq cA cA cabs cfv cA cA cabs
      cfv cB cmo opreq1 eqcoms eqeq1d a1i cA cr wcel cB crp wcel wa cA cB cmo
      co cc0 wceq cA cneg cB cmo co cc0 wceq wb cA cabs cfv cA cneg wceq cA cB
      cmo co cc0 wceq cA cabs cfv cB cmo co cc0 wceq wb wi cA cB negmod0 cA
      cabs cfv cA cneg wceq cA cB cmo co cc0 wceq cA cabs cfv cB cmo co cc0
      wceq wb cA cB cmo co cc0 wceq cA cneg cB cmo co cc0 wceq wb cA cabs cfv
      cA cneg wceq cA cabs cfv cB cmo co cc0 wceq cA cneg cB cmo co cc0 wceq cA
      cB cmo co cc0 wceq cA cabs cfv cA cneg wceq cA cabs cfv cB cmo co cA cneg
      cB cmo co cc0 cA cabs cfv cA cneg cB cmo opreq1 eqeq1d bibi2d biimprcd
      syl jaod mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The predicate "is a nonnegative real". $)
    elnnr $p |- ( X e. ( 0 [,) +oo ) <-> ( X e. RR /\ 0 <_ X ) ) $=
      cX cc0 cpnf cico co wcel cX cxr wcel cc0 cX cle wbr cX cpnf clt wbr w3a
      cX cr wcel cc0 cX cle wbr wa cc0 cxr wcel cpnf cxr wcel cX cc0 cpnf cico
      co wcel cX cxr wcel cc0 cX cle wbr cX cpnf clt wbr w3a wb cc0 cr wcel cc0
      cxr wcel 0re cc0 rexr ax-mp pnfxr cc0 cpnf cX elico1 mp2an cX cxr wcel
      cc0 cX cle wbr cX cpnf clt wbr w3a cX cr wcel cc0 cX cle wbr wa cX cxr
      wcel cc0 cX cle wbr cX cpnf clt wbr w3a cX cr wcel cc0 cX cle wbr cX cxr
      wcel cc0 cX cle wbr cX cpnf clt wbr cX cr wcel cX cxr wcel cc0 cX cle wbr
      cX cpnf clt wbr wa cmnf cX clt wbr cX cpnf clt wbr wa cX cr wcel cX cxr
      wcel cc0 cX cle wbr cmnf cX clt wbr cX cpnf clt wbr cX cxr wcel cmnf cc0
      clt wbr cc0 cX cle wbr cmnf cX clt wbr cc0 cr wcel cmnf cc0 clt wbr 0re
      cc0 mnflt ax-mp cmnf cxr wcel cc0 cxr wcel cX cxr wcel cmnf cc0 clt wbr
      cc0 cX cle wbr wa cmnf cX clt wbr wi mnfxr cc0 cr wcel cc0 cxr wcel 0re
      cc0 rexr ax-mp cmnf cc0 cX xrltletr mp3an12 mpani anim1d cX xrrebnd
      sylibrd 3impib cX cxr wcel cc0 cX cle wbr cX cpnf clt wbr 3simp2 jca cX
      cr wcel cc0 cX cle wbr wa cX cxr wcel cc0 cX cle wbr cX cpnf clt wbr cX
      cr wcel cX cxr wcel cc0 cX cle wbr cX rexr adantr cX cr wcel cc0 cX cle
      wbr pm3.27 cX cr wcel cX cpnf clt wbr cc0 cX cle wbr cX ltpnf adantr 3jca
      impbii bitri $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Sequences and sums
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d M a j k m n p s t $. $d Z a j k m n p s t $. $d F a j k m n p s t $.
    $d A a j k m n p s t $. $d G j k n p s t $.
    sdclem1.1 $e |- Z = ( ZZ>= ` M ) $.
    sdclem1.2 $e |- G
                   = { <. m , a >. | ( m e. Z /\ a = ( ( F ` m ) ` m ) ) } $.
    $( Lemma for ~ sdc . Construct a function from a sequence of partial
       functions. $)
    sdclem1 $p |- ( ( M e. ZZ /\ F Fn Z /\
                        A. n e. Z ( ( F ` n ) : ( M ... n ) --> A /\
          A. s e. ( M ... n ) ( ( F ` n ) ` s ) = ( ( F ` ( n + 1 ) ) ` s ) ) )
          -> ( G : Z --> A /\ A. n e. Z ( G |` ( M ... n ) ) = ( F ` n ) ) ) $=
      cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF
      cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral
      wa vn cZ wral w3a cZ cA cG wf cG cM vn cv cfz co cres vn cv cF cfv wceq
      vn cZ wral cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv
      vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz
      co wral wa vn cZ wral w3a vm cv vm cv cF cfv cfv cA wcel vm cZ wral cZ cA
      cG wf cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral wa vn cZ wral w3a vm cv vm cv cF cfv cfv cA wcel vm cZ cM vm cv cfz
      co cA vm cv cF cfv wf vm cv cM vm cv cfz co wcel vm cv vm cv cF cfv cfv
      cA wcel cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn
      cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral wa vn cZ wral w3a vm cv cZ wcel wa cM vm cv cfz co cA vm cv vm cv cF
      cfv ffvelrn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs
      cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ
      wral cM cz wcel vm cv cZ wcel cM vm cv cfz co cA vm cv cF cfv wf cF cZ
      wfn cM vn cv cfz co cA vn cv cF cfv wf vn cZ wral vm cv cZ wcel cM vm cv
      cfz co cA vm cv cF cfv wf cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral wa vn cZ wral cM vn cv cfz co cA vn cv cF cfv wf cM vm cv cfz co cA
      vm cv cF cfv wf vn vm cv cZ vn cv vm cv wceq cM vn cv cfz co cA vn cv cF
      cfv wf cM vn cv cfz co cA vm cv cF cfv wf cM vm cv cfz co cA vm cv cF cfv
      wf vn cv vm cv wceq cM vn cv cfz co cA vn cv cF cfv vm cv cF cfv vn cv vm
      cv cF fveq2 feq1d vn cv vm cv wceq cM vn cv cfz co cM vm cv cfz co wceq
      cM vn cv cfz co cA vm cv cF cfv wf cM vm cv cfz co cA vm cv cF cfv wf wb
      vn cv vm cv cM cfz opreq2 cM vn cv cfz co cM vm cv cfz co cA vm cv cF cfv
      feq2 syl bitrd rcla4cva cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF
      cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral
      wa cM vn cv cfz co cA vn cv cF cfv wf vn cZ cM vn cv cfz co cA vn cv cF
      cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs
      cM vn cv cfz co wral pm3.26 r19.20si sylan 3ad2antl3 vm cv cZ wcel vm cv
      cM vm cv cfz co wcel cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv
      wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM
      vn cv cfz co wral wa vn cZ wral w3a vm cv cZ wcel vm cv cM cuz cfv wcel
      vm cv cM vm cv cfz co wcel cZ cM cuz cfv vm cv sdclem1.1 eleq2i cM vm cv
      eluzfz2 sylbi adantl sylanc r19.21aiva vm va cZ cA vm cv vm cv cF cfv cfv
      cG sdclem1.2 fopab2 sylib cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv
      cF cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq
      vs cM vn cv cfz co wral wa vn cZ wral w3a cG cM vp cv cfz co cres vp cv
      cF cfv wceq vp cZ wral cG cM vn cv cfz co cres vn cv cF cfv wceq vn cZ
      wral cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral wa vn cZ wral w3a cG cM vp cv cfz co cres vp cv cF cfv wceq vp cZ cM
      cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv
      cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn
      cZ wral w3a vp cv cZ wcel wa cG cM vp cv cfz co cres vp cv cF cfv wceq cM
      vp cv cfz co cM vp cv cfz co wceq vt cv cG cM vp cv cfz co cres cfv vt cv
      vp cv cF cfv cfv wceq vt cM vp cv cfz co wral wa cM cz wcel cF cZ wfn cM
      vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1
      caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ wral w3a vp cv
      cZ wcel wa vt cv cG cM vp cv cfz co cres cfv vt cv vp cv cF cfv cfv wceq
      vt cM vp cv cfz co wral cM vp cv cfz co cM vp cv cfz co wceq cM cz wcel
      cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs cv
      vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ wral
      w3a vp cv cZ wcel wa vt cv cG cM vp cv cfz co cres cfv vt cv vp cv cF cfv
      cfv wceq vt cM vp cv cfz co cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv
      cF cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq
      vs cM vn cv cfz co wral wa vn cZ wral w3a vp cv cZ wcel wa vt cv cM vp cv
      cfz co wcel wa vt cv cG cM vp cv cfz co cres cfv vt cv vt cv cF cfv cfv
      vt cv vp cv cF cfv cfv vt cv cM vp cv cfz co wcel vt cv cG cM vp cv cfz
      co cres cfv vt cv vt cv cF cfv cfv wceq cM cz wcel cF cZ wfn cM vn cv cfz
      co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF
      cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ wral w3a vp cv cZ wcel wa
      vt cv cM vp cv cfz co wcel vt cv cG cM vp cv cfz co cres cfv vt cv cG cfv
      vt cv vt cv cF cfv cfv vt cv cM vp cv cfz co cG fvres vt cv cM vp cv cfz
      co wcel vt cv cZ wcel vt cv cG cfv vt cv vt cv cF cfv cfv wceq cM vp cv
      cfz co cZ vt cv cM vp cv cfz co cM cuz cfv cZ cM vp cv fzssuz sdclem1.1
      sseqtr4i sseli vm va vt cv vm cv vm cv cF cfv cfv vt cv vt cv cF cfv cfv
      cZ cG vm cv vt cv wceq vm cv vt cv vm cv cF cfv vt cv cF cfv vm cv vt cv
      cF fveq2 vm cv vt cv wceq id fveq12d sdclem1.2 vt cv vt cv cF cfv fvex
      fvopab4 syl eqtrd adantl cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF
      cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs
      cM vn cv cfz co wral wa vn cZ wral w3a vt cv cM vp cv cfz co wcel vt cv
      vp cv cF cfv cfv vt cv vt cv cF cfv cfv wceq vp cv cZ wcel cM cz wcel cF
      cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs cv vn
      cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ wral w3a
      vt cv cM cuz cfv wcel vp cv vt cv cuz cfv wcel wa vt cv vp cv cF cfv cfv
      vt cv vt cv cF cfv cfv wceq vt cv cM vp cv cfz co wcel cM cz wcel cF cZ
      wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs cv vn cv
      c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ wral w3a vt
      cv cM cuz cfv wcel vp cv vt cv cuz cfv wcel vt cv vp cv cF cfv cfv vt cv
      vt cv cF cfv cfv wceq cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF
      cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs
      cM vn cv cfz co wral wa vn cZ wral w3a vt cv cZ wcel vp cv vt cv cuz cfv
      wcel vt cv vp cv cF cfv cfv vt cv vt cv cF cfv cfv wceq vt cv cM cuz cfv
      wcel cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral wa vn cZ wral w3a vt cv cZ wcel wa vp cv vt cv cuz cfv wcel vt cv vp
      cv cF cfv cfv vt cv vt cv cF cfv cfv wceq cM vn cv cfz co cA vn cv cF cfv
      wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM
      vn cv cfz co wral wa vn cZ wral cM cz wcel vt cv cZ wcel vp cv vt cv cuz
      cfv wcel vt cv vp cv cF cfv cfv vt cv vt cv cF cfv cfv wceq wi cF cZ wfn
      vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn
      cv cfz co wral vn cZ wral vt cv cZ wcel vp cv vt cv cuz cfv wcel vt cv vp
      cv cF cfv cfv vt cv vt cv cF cfv cfv wceq wi cM vn cv cfz co cA vn cv cF
      cfv wf vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs
      cM vn cv cfz co wral wa vn cZ wral vp cv vt cv cuz cfv wcel vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral vn cZ wral vt cv cZ wcel wa vt cv vp cv cF cfv cfv vt cv vt cv cF
      cfv cfv wceq vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv
      wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ wcel wa vt cv vj cv cF
      cfv cfv vt cv vt cv cF cfv cfv wceq wi vs cv vn cv cF cfv cfv vs cv vn cv
      c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ
      wcel wa vt cv vt cv cF cfv cfv vt cv vt cv cF cfv cfv wceq wi vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral vn cZ wral vt cv cZ wcel wa vt cv vk cv cF cfv cfv vt cv vt cv cF
      cfv cfv wceq wi vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv
      wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ wcel wa vt cv vk cv c1
      caddc co cF cfv cfv vt cv vt cv cF cfv cfv wceq wi vs cv vn cv cF cfv cfv
      vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ
      wral vt cv cZ wcel wa vt cv vp cv cF cfv cfv vt cv vt cv cF cfv cfv wceq
      wi vj vk vt cv vp cv vj cv vt cv wceq vt cv vj cv cF cfv cfv vt cv vt cv
      cF cfv cfv wceq vt cv vt cv cF cfv cfv vt cv vt cv cF cfv cfv wceq vs cv
      vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz
      co wral vn cZ wral vt cv cZ wcel wa vj cv vt cv wceq vt cv vj cv cF cfv
      cfv vt cv vt cv cF cfv cfv vt cv vt cv cF cfv cfv vj cv vt cv wceq vt cv
      vj cv cF cfv vt cv cF cfv vj cv vt cv cF fveq2 fveq1d eqeq1d imbi2d vj cv
      vk cv wceq vt cv vj cv cF cfv cfv vt cv vt cv cF cfv cfv wceq vt cv vk cv
      cF cfv cfv vt cv vt cv cF cfv cfv wceq vs cv vn cv cF cfv cfv vs cv vn cv
      c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ
      wcel wa vj cv vk cv wceq vt cv vj cv cF cfv cfv vt cv vk cv cF cfv cfv vt
      cv vt cv cF cfv cfv vj cv vk cv wceq vt cv vj cv cF cfv vk cv cF cfv vj
      cv vk cv cF fveq2 fveq1d eqeq1d imbi2d vj cv vk cv c1 caddc co wceq vt cv
      vj cv cF cfv cfv vt cv vt cv cF cfv cfv wceq vt cv vk cv c1 caddc co cF
      cfv cfv vt cv vt cv cF cfv cfv wceq vs cv vn cv cF cfv cfv vs cv vn cv c1
      caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ wcel
      wa vj cv vk cv c1 caddc co wceq vt cv vj cv cF cfv cfv vt cv vk cv c1
      caddc co cF cfv cfv vt cv vt cv cF cfv cfv vj cv vk cv c1 caddc co wceq
      vt cv vj cv cF cfv vk cv c1 caddc co cF cfv vj cv vk cv c1 caddc co cF
      fveq2 fveq1d eqeq1d imbi2d vj cv vp cv wceq vt cv vj cv cF cfv cfv vt cv
      vt cv cF cfv cfv wceq vt cv vp cv cF cfv cfv vt cv vt cv cF cfv cfv wceq
      vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn
      cv cfz co wral vn cZ wral vt cv cZ wcel wa vj cv vp cv wceq vt cv vj cv
      cF cfv cfv vt cv vp cv cF cfv cfv vt cv vt cv cF cfv cfv vj cv vp cv wceq
      vt cv vj cv cF cfv vp cv cF cfv vj cv vp cv cF fveq2 fveq1d eqeq1d imbi2d
      vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn
      cv cfz co wral vn cZ wral vt cv cZ wcel wa vt cv vt cv cF cfv cfv vt cv
      vt cv cF cfv cfv wceq wi vt cv cz wcel vs cv vn cv cF cfv cfv vs cv vn cv
      c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ
      wcel wa vt cv vt cv cF cfv cfv eqidd a1i vk cv vt cv cuz cfv wcel vs cv
      vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz
      co wral vn cZ wral vt cv cZ wcel wa vt cv vk cv cF cfv cfv vt cv vt cv cF
      cfv cfv wceq vt cv vk cv c1 caddc co cF cfv cfv vt cv vt cv cF cfv cfv
      wceq vk cv vt cv cuz cfv wcel vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc
      co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ wcel wa vt
      cv vk cv cF cfv cfv vt cv vk cv c1 caddc co cF cfv cfv wceq vt cv vk cv
      cF cfv cfv vt cv vt cv cF cfv cfv wceq vt cv vk cv c1 caddc co cF cfv cfv
      vt cv vt cv cF cfv cfv wceq wi vs cv vn cv cF cfv cfv vs cv vn cv c1
      caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ wcel
      wa vk cv vt cv cuz cfv wcel vt cv vk cv cF cfv cfv vt cv vk cv c1 caddc
      co cF cfv cfv wceq vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv
      cfv wceq vs cM vn cv cfz co wral vn cZ wral vt cv cZ wcel vk cv vt cv cuz
      cfv wcel vt cv vk cv cF cfv cfv vt cv vk cv c1 caddc co cF cfv cfv wceq
      vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn
      cv cfz co wral vn cZ wral vt cv cZ wcel vk cv vt cv cuz cfv wcel wa wa vs
      cv vk cv cF cfv cfv vs cv vk cv c1 caddc co cF cfv cfv wceq vs cM vk cv
      cfz co wral vt cv cZ wcel vk cv vt cv cuz cfv wcel wa wa vt cv vk cv cF
      cfv cfv vt cv vk cv c1 caddc co cF cfv cfv wceq vt cv cZ wcel vk cv vt cv
      cuz cfv wcel wa vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv
      wceq vs cM vn cv cfz co wral vn cZ wral vs cv vk cv cF cfv cfv vs cv vk
      cv c1 caddc co cF cfv cfv wceq vs cM vk cv cfz co wral vt cv cZ wcel vk
      cv vt cv cuz cfv wcel wa vk cv cZ wcel vs cv vn cv cF cfv cfv vs cv vn cv
      c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral vn cZ wral vs cv vk
      cv cF cfv cfv vs cv vk cv c1 caddc co cF cfv cfv wceq vs cM vk cv cfz co
      wral wi vt cv cM cuz cfv wcel vk cv vt cv cuz cfv wcel vk cv cZ wcel vt
      cv cZ wcel vt cv cM cuz cfv wcel vk cv vt cv cuz cfv wcel wa vk cv cM cuz
      cfv cZ vk cv vt cv cuz cfv wcel vt cv cM cuz cfv wcel vk cv cM cuz cfv
      wcel vt cv vk cv cM uztrn ancoms sdclem1.1 syl6eleqr cZ cM cuz cfv vt cv
      sdclem1.1 eleq2i sylanb vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF
      cfv cfv wceq vs cM vn cv cfz co wral vs cv vk cv cF cfv cfv vs cv vk cv
      c1 caddc co cF cfv cfv wceq vs cM vk cv cfz co wral vn vk cv cZ vn cv vk
      cv wceq vs cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs
      cv vk cv cF cfv cfv vs cv vk cv c1 caddc co cF cfv cfv wceq vs cM vn cv
      cfz co cM vk cv cfz co vn cv vk cv cM cfz opreq2 vn cv vk cv wceq vs cv
      vn cv cF cfv cfv vs cv vk cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv
      cfv vs cv vk cv c1 caddc co cF cfv cfv vn cv vk cv wceq vs cv vn cv cF
      cfv vk cv cF cfv vn cv vk cv cF fveq2 fveq1d vn cv vk cv wceq vs cv vn cv
      c1 caddc co cF cfv vk cv c1 caddc co cF cfv vn cv vk cv wceq vn cv c1
      caddc co vk cv c1 caddc co cF vn cv vk cv c1 caddc opreq1 fveq2d fveq1d
      eqeq12d raleq12d rcla4v syl imdistanri vs cv vk cv cF cfv cfv vs cv vk cv
      c1 caddc co cF cfv cfv wceq vs cM vk cv cfz co wral vt cv cM vk cv cfz co
      wcel vt cv vk cv cF cfv cfv vt cv vk cv c1 caddc co cF cfv cfv wceq vt cv
      cZ wcel vk cv vt cv cuz cfv wcel wa vs cv vk cv cF cfv cfv vs cv vk cv c1
      caddc co cF cfv cfv wceq vt cv vk cv cF cfv cfv vt cv vk cv c1 caddc co
      cF cfv cfv wceq vs vt cv cM vk cv cfz co vs cv vt cv wceq vs cv vk cv cF
      cfv cfv vt cv vk cv cF cfv cfv vs cv vk cv c1 caddc co cF cfv cfv vt cv
      vk cv c1 caddc co cF cfv cfv vs cv vt cv vk cv cF cfv fveq2 vs cv vt cv
      vk cv c1 caddc co cF cfv fveq2 eqeq12d rcla4cva vt cv cM cuz cfv wcel vk
      cv vt cv cuz cfv wcel vt cv cM vk cv cfz co wcel vt cv cZ wcel vt cv cM
      vk cv eluzfz cZ cM cuz cfv vt cv sdclem1.1 eleq2i sylanb sylan2 syl
      anassrs expcom vt cv vk cv cF cfv cfv vt cv vk cv c1 caddc co cF cfv cfv
      wceq vt cv vk cv cF cfv cfv vt cv vt cv cF cfv cfv wceq vt cv vk cv c1
      caddc co cF cfv cfv vt cv vt cv cF cfv cfv wceq vt cv vk cv cF cfv cfv vt
      cv vk cv c1 caddc co cF cfv cfv vt cv vt cv cF cfv cfv eqeq1 biimpd syl6
      a2d uzind4 com12 cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv
      cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vs
      cv vn cv cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv
      cfz co wral vn cZ cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv
      cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral
      pm3.27 r19.20si sylan 3ad2antl3 imp vt cv cZ wcel vt cv cM cuz cfv wcel
      cZ cM cuz cfv vt cv sdclem1.1 eleq2i biimpri sylanl2 anasss vp cv cvv
      wcel vt cv cM vp cv cfz co wcel vt cv cM cuz cfv wcel vp cv vt cv cuz cfv
      wcel wa wb vp visset cvv vt cv cM vp cv elfzuzb ax-mp sylan2b adantlr
      eqtr4d r19.21aiva cM vp cv cfz co eqid jctil cG cM vp cv cfz co cres cM
      vp cv cfz co wfn vp cv cF cfv cM vp cv cfz co wfn cG cM vp cv cfz co cres
      vp cv cF cfv wceq cM vp cv cfz co cM vp cv cfz co wceq vt cv cG cM vp cv
      cfz co cres cfv vt cv vp cv cF cfv cfv wceq vt cM vp cv cfz co wral wa wb
      cM cz wcel cF cZ wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF
      cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral
      wa vn cZ wral w3a vp cv cZ wcel wa vt cM vp cv cfz co cM vp cv cfz co cG
      cM vp cv cfz co cres vp cv cF cfv eqfnfv cG cZ wfn cM vp cv cfz co cZ wss
      cG cM vp cv cfz co cres cM vp cv cfz co wfn vm va cZ vm cv vm cv cF cfv
      cfv cG vm cv vm cv cF cfv fvex sdclem1.2 fnopab2 cM vp cv cfz co cM cuz
      cfv cZ cM vp cv fzssuz sdclem1.1 sseqtr4i cZ cM vp cv cfz co cG fnssres
      mp2an cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs cv vn
      cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ wral cM
      cz wcel vp cv cZ wcel vp cv cF cfv cM vp cv cfz co wfn cF cZ wfn vn cv cF
      cfv cM vn cv cfz co wfn vn cZ wral vp cv cZ wcel vp cv cF cfv cM vp cv
      cfz co wfn cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv cF cfv cfv vs
      cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral wa vn cZ
      wral vn cv cF cfv cM vn cv cfz co wfn vp cv cF cfv cM vp cv cfz co wfn vn
      vp cv cZ vn cv vp cv wceq vn cv cF cfv cM vn cv cfz co wfn vp cv cF cfv
      cM vn cv cfz co wfn vp cv cF cfv cM vp cv cfz co wfn vn cv vp cv wceq vn
      cv cF cfv vp cv cF cfv wceq vn cv cF cfv cM vn cv cfz co wfn vp cv cF cfv
      cM vn cv cfz co wfn wb vn cv vp cv cF fveq2 cM vn cv cfz co vn cv cF cfv
      vp cv cF cfv fneq1 syl vn cv vp cv wceq cM vn cv cfz co cM vp cv cfz co
      wceq vp cv cF cfv cM vn cv cfz co wfn vp cv cF cfv cM vp cv cfz co wfn wb
      vn cv vp cv cM cfz opreq2 cM vn cv cfz co cM vp cv cfz co vp cv cF cfv
      fneq2 syl bitrd rcla4cva cM vn cv cfz co cA vn cv cF cfv wf vs cv vn cv
      cF cfv cfv vs cv vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co
      wral wa vn cv cF cfv cM vn cv cfz co wfn vn cZ cM vn cv cfz co cA vn cv
      cF cfv wf vn cv cF cfv cM vn cv cfz co wfn vs cv vn cv cF cfv cfv vs cv
      vn cv c1 caddc co cF cfv cfv wceq vs cM vn cv cfz co wral cM vn cv cfz co
      cA vn cv cF cfv ffn adantr r19.20si sylan 3ad2antl3 sylancr mpbird
      r19.21aiva cG cM vn cv cfz co cres vn cv cF cfv wceq cG cM vp cv cfz co
      cres vp cv cF cfv wceq vn vp cZ vn cv vp cv wceq cG cM vn cv cfz co cres
      cG cM vp cv cfz co cres vn cv cF cfv vp cv cF cfv vn cv vp cv wceq cM vn
      cv cfz co cM vp cv cfz co wceq cG cM vn cv cfz co cres cG cM vp cv cfz co
      cres wceq vn cv vp cv cM cfz opreq2 cM vn cv cfz co cM vp cv cfz co cG
      reseq2 syl vn cv vp cv cF fveq2 eqeq12d cbvralv sylibr jca $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d q x j z d y w b h u $. $d A x y z q w b d u $. $d C x b $.
    $d ps y w b d u $. $d ph q b d $. $d S y w x b d $.
    sdclem2.1 $e |- ( ph -> A e. B ) $.
    $( Lemma for ~ sdc . A consequence of ~ acdc5g that will be used multiple
       times in the proof. $)
    sdclem2 $p |- ( ( ( ( ph /\ h : { 1 } --> A ) /\ ( j : NN --> S /\
            ( j ` 1 ) = h /\ A. w e. NN ( j ` ( w + 1 ) ) e. ( { <. x , y >. |
                ( x e. S /\ y = { z | E. q e. NN ( ( x : ( 1 ... q ) --> A /\
              z : ( 1 ... ( q + 1 ) ) --> A ) /\ ps ) } ) } ` ( j ` w ) ) ) )
                          /\ C e. NN ) -> ( j ` C ) : ( 1 ... C ) --> A ) $=
      cC cn wcel wph c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv vh cv
      wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1
      vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps
      wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa c1 cC
      cfz co cA cC vj cv cfv wf wph c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj
      cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv cS
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral
      w3a wa c1 vb cv cfz co cA vb cv vj cv cfv wf wi wph c1 csn cA vh cv wf wa
      cn cS vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv
      vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral w3a wa c1 c1 cfz co cA c1 vj cv cfv wf wi wph
      c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv vh cv wceq vw cv c1
      caddc co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz
      cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa c1 vd cv cfz co cA vd
      cv vj cv cfv wf wi wph c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv
      vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa
      c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wph c1
      csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc
      co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab
      wceq wa vx vy copab cfv wcel vw cn wral w3a wa c1 cC cfz co cA cC vj cv
      cfv wf wi vb vd cC vb cv c1 wceq c1 vb cv cfz co cA vb cv vj cv cfv wf c1
      c1 cfz co cA c1 vj cv cfv wf wph c1 csn cA vh cv wf wa cn cS vj cv wf c1
      vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv cS
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral
      w3a wa vb cv c1 wceq c1 vb cv cfz co cA vb cv vj cv cfv wf c1 vb cv cfz
      co cA c1 vj cv cfv wf c1 c1 cfz co cA c1 vj cv cfv wf vb cv c1 wceq c1 vb
      cv cfz co cA vb cv vj cv cfv c1 vj cv cfv vb cv c1 vj cv fveq2 feq1d vb
      cv c1 wceq c1 vb cv cfz co c1 c1 cfz co wceq c1 vb cv cfz co cA c1 vj cv
      cfv wf c1 c1 cfz co cA c1 vj cv cfv wf wb vb cv c1 c1 cfz opreq2 c1 vb cv
      cfz co c1 c1 cfz co cA c1 vj cv cfv feq2 syl bitrd imbi2d vb cv vd cv
      wceq c1 vb cv cfz co cA vb cv vj cv cfv wf c1 vd cv cfz co cA vd cv vj cv
      cfv wf wph c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv vh cv wceq
      vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq
      cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa vb cv vd cv
      wceq c1 vb cv cfz co cA vb cv vj cv cfv wf c1 vb cv cfz co cA vd cv vj cv
      cfv wf c1 vd cv cfz co cA vd cv vj cv cfv wf vb cv vd cv wceq c1 vb cv
      cfz co cA vb cv vj cv cfv vd cv vj cv cfv vb cv vd cv vj cv fveq2 feq1d
      vb cv vd cv wceq c1 vb cv cfz co c1 vd cv cfz co wceq c1 vb cv cfz co cA
      vd cv vj cv cfv wf c1 vd cv cfz co cA vd cv vj cv cfv wf wb vb cv vd cv
      c1 cfz opreq2 c1 vb cv cfz co c1 vd cv cfz co cA vd cv vj cv cfv feq2 syl
      bitrd imbi2d vb cv vd cv c1 caddc co wceq c1 vb cv cfz co cA vb cv vj cv
      cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wph
      c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv vh cv wceq vw cv c1
      caddc co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz
      cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa vb cv vd cv c1 caddc
      co wceq c1 vb cv cfz co cA vb cv vj cv cfv wf c1 vb cv cfz co cA vd cv c1
      caddc co vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj
      cv cfv wf vb cv vd cv c1 caddc co wceq c1 vb cv cfz co cA vb cv vj cv cfv
      vd cv c1 caddc co vj cv cfv vb cv vd cv c1 caddc co vj cv fveq2 feq1d vb
      cv vd cv c1 caddc co wceq c1 vb cv cfz co c1 vd cv c1 caddc co cfz co
      wceq c1 vb cv cfz co cA vd cv c1 caddc co vj cv cfv wf c1 vd cv c1 caddc
      co cfz co cA vd cv c1 caddc co vj cv cfv wf wb vb cv vd cv c1 caddc co c1
      cfz opreq2 c1 vb cv cfz co c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc
      co vj cv cfv feq2 syl bitrd imbi2d vb cv cC wceq c1 vb cv cfz co cA vb cv
      vj cv cfv wf c1 cC cfz co cA cC vj cv cfv wf wph c1 csn cA vh cv wf wa cn
      cS vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj
      cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral w3a wa vb cv cC wceq c1 vb cv cfz co cA vb cv vj cv cfv
      wf c1 vb cv cfz co cA cC vj cv cfv wf c1 cC cfz co cA cC vj cv cfv wf vb
      cv cC wceq c1 vb cv cfz co cA vb cv vj cv cfv cC vj cv cfv vb cv cC vj cv
      fveq2 feq1d vb cv cC wceq c1 vb cv cfz co c1 cC cfz co wceq c1 vb cv cfz
      co cA cC vj cv cfv wf c1 cC cfz co cA cC vj cv cfv wf wb vb cv cC c1 cfz
      opreq2 c1 vb cv cfz co c1 cC cfz co cA cC vj cv cfv feq2 syl bitrd imbi2d
      wph c1 csn cA vh cv wf wa cn cS vj cv wf c1 vj cv cfv vh cv wceq c1 c1
      cfz co cA c1 vj cv cfv wf vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx
      cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw
      cn wral c1 c1 cfz co cA vh cv wf c1 vj cv cfv vh cv wceq c1 c1 cfz co cA
      c1 vj cv cfv wf wph c1 csn cA vh cv wf wa c1 vj cv cfv vh cv wceq c1 c1
      cfz co cA c1 vj cv cfv wf c1 c1 cfz co cA vh cv wf c1 c1 cfz co cA c1 vj
      cv cfv vh cv feq1 biimparc c1 csn cA vh cv wf c1 c1 cfz co cA vh cv wf
      wph c1 c1 cfz co cA vh cv wf c1 csn cA vh cv wf c1 c1 cfz co c1 csn wceq
      c1 c1 cfz co cA vh cv wf c1 csn cA vh cv wf wb c1 cz wcel c1 c1 cfz co c1
      csn wceq 1z c1 fzsn ax-mp c1 c1 cfz co c1 csn cA vh cv feq2 ax-mp biimpri
      adantl sylan 3ad2antr2 vd cv cn wcel wph c1 csn cA vh cv wf wa cn cS vj
      cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv
      vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel
      vw cn wral w3a wa c1 vd cv cfz co cA vd cv vj cv cfv wf c1 vd cv c1 caddc
      co cfz co cA vd cv c1 caddc co vj cv cfv wf wph c1 csn cA vh cv wf wa cn
      cS vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj
      cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral w3a wa vd cv cn wcel c1 vd cv cfz co cA vd cv vj cv cfv
      wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wph
      c1 csn cA vh cv wf wa cn cS vj cv wf vw cv c1 caddc co vj cv cfv vw cv vj
      cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral vd cv cn wcel c1 vd cv cfz co cA vd cv vj cv cfv wf c1 vd
      cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wi c1 vj cv
      cfv vh cv wceq wph cn cS vj cv wf vw cv c1 caddc co vj cv cfv vw cv vj cv
      cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral wa vd cv cn wcel c1 vd cv cfz co cA vd cv vj cv cfv wf c1
      vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wi c1 csn
      cA vh cv wf wph cn cS vj cv wf vw cv c1 caddc co vj cv cfv vw cv vj cv
      cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral wa vd cv cn wcel c1 vd cv cfz co cA vd cv vj cv cfv wf c1
      vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wph vd cv
      vj cv cfv cS wcel vd cv c1 caddc co vj cv cfv vd cv vj cv cfv vx cv cS
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel wa c1 vd
      cv cfz co cA vd cv vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf wi cn cS vj cv wf vw cv c1 caddc co vj cv cfv vw cv
      vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral wa vd cv cn wcel wa wph vd cv vj cv cfv cS wcel
      vd cv c1 caddc co vj cv cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq
      cn wrex vz cab wceq wa vx vy copab cfv wcel wa vd cv c1 caddc co vj cv
      cfv c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex vz cab wcel c1 vd
      cv cfz co cA vd cv vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf wi wph vd cv vj cv cfv cS wcel vd cv c1 caddc co vj
      cv cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa
      vx vy copab cfv wcel vd cv c1 caddc co vj cv cfv c1 vq cv cfz co cA vd cv
      vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj
      cv cfv wsbc wa vq cn wrex vz cab wcel wph vd cv vj cv cfv cS wcel wa vd
      cv c1 caddc co vj cv cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn
      wrex vz cab wceq wa vx vy copab cfv wcel vd cv c1 caddc co vj cv cfv c1
      vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv
      wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex vz cab wcel wph vd cv vj
      cv cfv cS wcel wa vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz
      cab wceq wa vx vy copab cfv c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn
      wrex vz cab vd cv c1 caddc co vj cv cfv vd cv vj cv cfv cS wcel wph vd cv
      vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy
      copab cfv c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex vz cab wceq
      vd cv vj cv cfv cS wcel c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex
      vz cab cvv wcel vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx
      cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab
      wceq wa vx vy copab cfv c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex
      vz cab wceq wph vx vy vu vd cv vj cv cfv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab c1 vq cv
      cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      wps vx vd cv vj cv cfv wsbc wa vq cn wrex vz cab cS cvv vx cv cS wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      wps wa vq cn wrex vz cab wceq wa vx vy copab vu cv vd cv vj cv cfv wcel
      vx ax-17 c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex vx vz vu c1
      vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv
      wf wa wps vx vd cv vj cv cfv wsbc wa vx vq cn vq cv cn wcel vx ax-17 c1
      vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv
      wf wa wps vx vd cv vj cv cfv wsbc vx c1 vq cv cfz co cA vd cv vj cv cfv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vx ax-17 wps vx vd cv vj cv
      cfv vd cv vj cv fvex hbsbc1v hban hbrex hbab vx cv vd cv vj cv cfv wceq
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      wps wa vq cn wrex c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex vz vx
      cv vd cv vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa wps wa c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn
      vx cv vd cv vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa wps wps vx vd cv vj cv cfv wsbc vx cv
      vd cv vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq cv cfz co cA vd cv
      vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf c1 vq cv cfz co cA
      vx cv vd cv vj cv cfv feq1 anbi1d wps vx vd cv vj cv cfv sbceq1a anbi12d
      rexbidv abbidv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy
      copab eqid fvopab4gf cn cvv wcel c1 vq cv cfz co cA vd cv vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vz
      cab cvv wcel vq cn wral c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn wrex
      vz cab cvv wcel wph c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq vz cn
      cvv cvv abrexex2g nnex wph c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vz cab
      cvv wcel vq cn wph c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vz cab cvv
      wcel vq cv cn wcel c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vz cab c1
      vq cv c1 caddc co cfz co cA vz cv wf vz cab wss c1 vq cv c1 caddc co cfz
      co cA vz cv wf vz cab cvv wcel c1 vq cv cfz co cA vd cv vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vz
      cab cvv wcel wph c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vz cab c1 vq cv
      c1 caddc co cfz co cA vz cv wf vz cab cvv ssexg c1 vq cv cfz co cA vd cv
      vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj
      cv cfv wsbc wa c1 vq cv c1 caddc co cfz co cA vz cv wf vz c1 vq cv cfz co
      cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wps vx vd
      cv vj cv cfv wsbc simplr ss2abi c1 vq cv c1 caddc co cfz co cvv wcel cA
      cB wcel c1 vq cv c1 caddc co cfz co cA vz cv wf vz cab cvv wcel wph c1 vq
      cv c1 caddc co cfz co cA cvv cB vz mapex c1 vq cv c1 caddc co cfz oprex
      sdclem2.1 sylancr sylancr a1d r19.21aiv sylancr sylan2 ancoms eleq2d
      biimpd expimpd vd cv c1 caddc co vj cv cfv c1 vq cv cfz co cA vd cv vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv
      wsbc wa vq cn wrex vz cab wcel c1 vq cv cfz co cA vd cv vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wa wps vx vd
      cv vj cv cfv wsbc vz vd cv c1 caddc co vj cv cfv wsbc wa vq cn wrex c1 vd
      cv cfz co cA vd cv vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf wi c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa wps vx vd cv vj cv cfv wsbc wa vq cn
      wrex c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA
      vd cv c1 caddc co vj cv cfv wf wa wps vx vd cv vj cv cfv wsbc vz vd cv c1
      caddc co vj cv cfv wsbc wa vq cn wrex vz vd cv c1 caddc co vj cv cfv c1
      vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vd cv
      c1 caddc co vj cv cfv wf wa wps vx vd cv vj cv cfv wsbc vz vd cv c1 caddc
      co vj cv cfv wsbc wa vz vq cn vq cv cn wcel vz ax-17 c1 vq cv cfz co cA
      vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv
      cfv wf wa wps vx vd cv vj cv cfv wsbc vz vd cv c1 caddc co vj cv cfv wsbc
      vz c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA
      vd cv c1 caddc co vj cv cfv wf wa vz ax-17 wps vx vd cv vj cv cfv wsbc vz
      vd cv c1 caddc co vj cv cfv vd cv c1 caddc co vj cv fvex hbsbc1v hban
      hbrex vd cv c1 caddc co vj cv fvex vz cv vd cv c1 caddc co vj cv cfv wceq
      c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa wps vx vd cv vj cv cfv wsbc wa c1 vq cv cfz co cA vd cv vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wa
      wps vx vd cv vj cv cfv wsbc vz vd cv c1 caddc co vj cv cfv wsbc wa vq cn
      vz cv vd cv c1 caddc co vj cv cfv wceq c1 vq cv cfz co cA vd cv vj cv cfv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa c1 vq cv cfz co cA vd cv vj
      cv cfv wf c1 vq cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf
      wa wps vx vd cv vj cv cfv wsbc wps vx vd cv vj cv cfv wsbc vz vd cv c1
      caddc co vj cv cfv wsbc vz cv vd cv c1 caddc co vj cv cfv wceq c1 vq cv
      c1 caddc co cfz co cA vz cv wf c1 vq cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv vd cv c1 caddc co vj cv cfv feq1 anbi2d wps vx
      vd cv vj cv cfv wsbc vz vd cv c1 caddc co vj cv cfv sbceq1a anbi12d
      rexbidv elabf c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co
      cfz co cA vd cv c1 caddc co vj cv cfv wf wa wps vx vd cv vj cv cfv wsbc
      vz vd cv c1 caddc co vj cv cfv wsbc wa c1 vd cv cfz co cA vd cv vj cv cfv
      wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi vq cn
      vq cv cn wcel c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co
      cfz co cA vd cv c1 caddc co vj cv cfv wf wa c1 vd cv cfz co cA vd cv vj
      cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf
      wi wps vx vd cv vj cv cfv wsbc vz vd cv c1 caddc co vj cv cfv wsbc c1 vq
      cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf wa vq cv cn wcel c1 vd cv cfz co cA vd cv vj cv cfv
      wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi c1 vq
      cv cfz co cA vd cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf vq cv cn wcel c1 vd cv cfz co cA vd cv vj cv cfv wf
      c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wi c1 vq
      cv cfz co cA vd cv vj cv cfv wf c1 vd cv cfz co cA vd cv vj cv cfv wf vq
      cv cn wcel c1 vq cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf
      c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf c1 vq cv
      cfz co cA vd cv vj cv cfv wf c1 vd cv cfz co cA vd cv vj cv cfv wf vq cv
      cn wcel c1 vq cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf c1
      vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv wf wi wi vq cv cn
      wcel c1 vq cv cfz co c1 vd cv cfz co wceq c1 vq cv c1 caddc co cfz co cA
      vd cv c1 caddc co vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf wi c1 vq cv cfz co cA vd cv vj cv cfv wf c1 vd cv
      cfz co cA vd cv vj cv cfv wf wa vq cv cn wcel c1 vq cv cfz co c1 vd cv
      cfz co wceq c1 c1 wceq vq cv vd cv wceq wa c1 vq cv c1 caddc co cfz co cA
      vd cv c1 caddc co vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf wi vq cv cn wcel vd cv cvv wcel c1 vq cv cfz co c1
      vd cv cfz co wceq c1 c1 wceq vq cv vd cv wceq wa wb vd visset vq cv c1
      cuz cfv wcel vd cv cvv wcel c1 vq cv cfz co c1 vd cv cfz co wceq c1 c1
      wceq vq cv vd cv wceq wa wb vq cv cn wcel cvv c1 vd cv c1 vq cv fzopth vq
      cv elnnuz sylanb mpan2 vq cv vd cv wceq c1 vq cv c1 caddc co cfz co cA vd
      cv c1 caddc co vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc
      co vj cv cfv wf wi c1 c1 wceq vq cv vd cv wceq c1 vq cv c1 caddc co cfz
      co cA vd cv c1 caddc co vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv
      c1 caddc co vj cv cfv wf vq cv vd cv wceq c1 vq cv c1 caddc co cfz co c1
      vd cv c1 caddc co cfz co wceq c1 vq cv c1 caddc co cfz co cA vd cv c1
      caddc co vj cv cfv wf c1 vd cv c1 caddc co cfz co cA vd cv c1 caddc co vj
      cv cfv wf wb vq cv vd cv wceq vq cv c1 caddc co vd cv c1 caddc co c1 cfz
      vq cv vd cv c1 caddc opreq1 opreq2d c1 vq cv c1 caddc co cfz co c1 vd cv
      c1 caddc co cfz co cA vd cv c1 caddc co vj cv cfv feq2 syl biimpd adantl
      syl6bi vd cv vj cv cfv c1 vq cv cfz co wfn vd cv vj cv cfv c1 vd cv cfz
      co wfn c1 vq cv cfz co c1 vd cv cfz co wceq c1 vq cv cfz co cA vd cv vj
      cv cfv wf c1 vd cv cfz co cA vd cv vj cv cfv wf c1 vq cv cfz co c1 vd cv
      cfz co vd cv vj cv cfv fndmu c1 vq cv cfz co cA vd cv vj cv cfv ffn c1 vd
      cv cfz co cA vd cv vj cv cfv ffn syl2an syl5com ex com24 imp impcom
      adantrr r19.23aiva sylbi syl6 vd cv cn wcel cn cS vj cv wf vw cv c1 caddc
      co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab
      wceq wa vx vy copab cfv wcel vw cn wral wa vd cv vj cv cfv cS wcel vd cv
      c1 caddc co vj cv cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co
      cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel wa vd cv cn wcel cn cS vj cv wf vd cv
      vj cv cfv cS wcel vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv cS
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral
      vd cv c1 caddc co vj cv cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq
      cn wrex vz cab wceq wa vx vy copab cfv wcel cn cS vj cv wf vd cv cn wcel
      vd cv vj cv cfv cS wcel cn cS vd cv vj cv ffvelrn expcom vw cv c1 caddc
      co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab
      wceq wa vx vy copab cfv wcel vd cv c1 caddc co vj cv cfv vd cv vj cv cfv
      vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa wps wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel
      vw vd cv cn vw cv vd cv wceq vw cv c1 caddc co vj cv cfv vd cv c1 caddc
      co vj cv cfv vw cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab
      wceq wa vx vy copab cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn
      wrex vz cab wceq wa vx vy copab cfv vw cv vd cv wceq vw cv c1 caddc co vd
      cv c1 caddc co vj cv vw cv vd cv c1 caddc opreq1 fveq2d vw cv vd cv wceq
      vw cv vj cv cfv vd cv vj cv cfv vx cv cS wcel vy cv c1 vq cv cfz co cA vx
      cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa wps wa vq cn wrex vz cab
      wceq wa vx vy copab vw cv vd cv vj cv fveq2 fveq2d eleq12d rcla4v anim12d
      impcom syl5 expdimp adantlr 3adantr2 com12 a2d nnind impcom $.
      $( [2-Sep-2009] $)
  $}

  ${
    $v et $. $v ze $. $v si $. $v mu $.
    $d A g h n q z x y u r s k j v w d m c a b t f $. $d mu h g j $.
    $d th n x d m c j $. $d ta g k $. $d ph g n x h r k q d m c j $.
    $d si n q $. $d ze g z $. $d ch g $. $d ps q z x y u r s k j w d m c f $.
    sdc.wet $f wff et $.
    sdc.wze $f wff ze $.
    sdc.wsi $f wff si $.
    sdc.wmu $f wff mu $.
    sdc.1 $e |- ( g = h -> ( ps <-> ch ) ) $.
    sdc.2 $e |- ( g = r -> ( ps <-> ta ) ) $.
    sdc.3 $e |- ( g = s -> ( ps <-> ze ) ) $.
    sdc.4 $e |- ( g = ( f |` ( 1 ... n ) ) -> ( ps <-> mu ) ) $.
    sdc.5 $e |- ( n = 1 -> ( ch <-> th ) ) $.
    sdc.6 $e |- ( n = k -> ( ta <-> et ) ) $.
    sdc.7 $e |- ( n = ( k + 1 ) -> ( ze <-> si ) ) $.
    sdc.8 $e |- ( ph -> A e. C ) $.
    sdc.9 $e |- ( ph -> E. h ( h : { 1 } --> A /\ th ) ) $.
    sdc.10 $e |- ( ( ph /\ k e. NN ) -> ( ( r : ( 1 ... k ) --> A /\ et ) ->
                  E. s ( s : ( 1 ... ( k + 1 ) ) --> A /\ A. v e. ( 1 ... k )
                                      ( s ` v ) = ( r ` v ) /\ si ) ) ) $.
    $( Strong dependent choice.  Suppose we may choose an element of ` A ` such
       that property ` ps ` holds, and suppose that if we have already chosen
       the first ` k ` elements (represented here by a function from
       ` 1 ... k ` to ` A ` ), we may choose another element so that all
       ` k + 1 ` elements taken together have property ` ps ` . Then there
       exists an infinite sequence of elements of ` A ` such that the first
       ` n ` terms of this sequence satisfy ` ps ` for all ` n ` . This theorem
       allows us to construct infinite seqeunces where each term depends on all
       the previous terms in the sequence.  $)
    sdc $p |- ( ph -> E. f ( f : NN --> A /\ A. n e. NN mu ) ) $=
      wph c1 csn cA vh cv wf wth wa vh wex cn cA vf cv wf sdc.wmu vn cn wral wa
      vf wex sdc.9 wph c1 csn cA vh cv wf wth wa cn cA vf cv wf sdc.wmu vn cn
      wral wa vf wex vh wph c1 csn cA vh cv wf wth wa cn cA vf cv wf sdc.wmu vn
      cn wral wa vf wex wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv
      c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv
      c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq
      cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a vj wex cn cA
      vf cv wf sdc.wmu vn cn wral wa vf wex c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab cvv wcel c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw c0 csn
      cdif vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab wf vh cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel
      cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv
      cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn
      wral w3a vj wex wph c1 csn cA vh cv wf wth wa wa c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab cvv vh cv vj vw vx cv c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wceq wa vx vy copab acdc3g wph c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab cvv wcel c1 csn cA vh cv wf wth wa cn
      cvv wcel c1 vn cv cfz co cA vg cv wf wps wa vg cab cvv wcel vn cn wral c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cvv wcel wph c1 vn cv
      cfz co cA vg cv wf wps wa vn vg cn cvv cvv abrexex2g nnex wph c1 vn cv
      cfz co cA vg cv wf wps wa vg cab cvv wcel vn cn wph c1 vn cv cfz co cA vg
      cv wf wps wa vg cab cvv wcel vn cv cn wcel c1 vn cv cfz co cA vg cv wf
      wps wa vg cab c1 vn cv cfz co cA vg cv wf vg cab wss c1 vn cv cfz co cA
      vg cv wf vg cab cvv wcel c1 vn cv cfz co cA vg cv wf wps wa vg cab cvv
      wcel wph c1 vn cv cfz co cA vg cv wf wps wa vg cab c1 vn cv cfz co cA vg
      cv wf vg cab cvv ssexg c1 vn cv cfz co cA vg cv wf wps wa c1 vn cv cfz co
      cA vg cv wf vg c1 vn cv cfz co cA vg cv wf wps pm3.26 ss2abi c1 vn cv cfz
      co cvv wcel cA cC wcel c1 vn cv cfz co cA vg cv wf vg cab cvv wcel wph c1
      vn cv cfz co cA cvv cC vg mapex c1 vn cv cfz oprex sdc.8 sylancr sylancr
      a1d r19.21aiv sylancr adantr wph c1 csn cA vh cv wf wth wa wa c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab cpw c0 csn cdif wcel vx c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wral c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw c0
      csn cdif vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel
      vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab wf wph c1 csn cA vh cv wf wth wa wa c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab cpw c0 csn cdif wcel vx c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab wph c1 csn cA vh cv wf wth wa wa c1 vn cv cfz co cA vx cv wf wps
      vg vx cv wsbc wa vn cn wrex c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw c0 csn
      cdif wcel vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel
      wph c1 csn cA vh cv wf wth wa wa c1 vn cv cfz co cA vx cv wf wps vg vx cv
      wsbc wa c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv
      wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg
      vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab cpw c0 csn cdif wcel vn cn wph c1
      csn cA vh cv wf wth wa wa vn ax-17 vn vu vu c1 vq cv cfz co cA vx cv wf
      c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab cpw c0 csn cdif c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vn vz vu c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv
      wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg
      vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vn vq cn vq cv cn wcel vn
      ax-17 c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc wa vn c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vn ax-17 vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc vn vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral vn
      ax-17 wps vg vz cv wsbc vn vq cv c1 caddc co vq cv c1 caddc oprex hbsbc1v
      hban hban hbrex hbab vn vu c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab cpw c0 csn vn vu c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vn vg vu c1 vn cv cfz
      co cA vg cv wf wps wa vn cn hbre1 hbab hbpw vu cv c0 csn wcel vn ax-17
      hbdif hbel wph c1 csn cA vh cv wf wth wa wa vn cv cn wcel c1 vn cv cfz co
      cA vx cv wf wps vg vx cv wsbc wa c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw c0
      csn cdif wcel c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw c0 csn cdif wcel c1 vq
      cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab cpw wcel c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv
      c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq
      cn wrex vz cab c0 wne wph c1 csn cA vh cv wf wth wa wa vn cv cn wcel wa
      c1 vn cv cfz co cA vx cv wf wps vg vx cv wsbc wa wa c1 vq cv cfz co cA vx
      cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx
      cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab cpw c0 eldifsn wph c1 csn cA vh cv wf wth wa wa vn cv cn wcel
      wa c1 vn cv cfz co cA vx cv wf wps vg vx cv wsbc wa wa c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab cpw wcel c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wss c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vq cn wrex vz c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vz cv c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab wcel vq cn vq cv cn wcel c1 vq cv
      c1 caddc co cfz co cA vz cv wf vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vz cv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel c1 vq cv cfz co cA
      vx cv wf vq cv cn wcel c1 vq cv c1 caddc co cfz co cA vz cv wf wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc vz cv c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab wcel vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq
      cv cfz co wral vq cv cn wcel c1 vq cv c1 caddc co cfz co cA vz cv wf wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa c1 vn cv cfz co cA vz cv wf
      wps vg vz cv wsbc wa vn cn wrex vz cv c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab wcel vq cv c1 caddc co cn wcel c1 vq cv c1 caddc co cfz
      co cA vz cv wf wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa c1 vn cv
      cfz co cA vz cv wf wps vg vz cv wsbc wa vn cn wrex vq cv cn wcel c1 vn cv
      cfz co cA vz cv wf wps vg vz cv wsbc wa c1 vq cv c1 caddc co cfz co cA vz
      cv wf wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vn vq cv c1 caddc co
      cn c1 vq cv c1 caddc co cfz co cA vz cv wf wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc vn c1 vq cv c1 caddc co cfz co cA vz cv wf vn ax-17 wps vg
      vz cv wsbc vn vq cv c1 caddc co vq cv c1 caddc oprex hbsbc1v hban vn cv
      vq cv c1 caddc co wceq c1 vn cv cfz co cA vz cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wps vg vz cv wsbc wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc vn cv vq cv c1 caddc co wceq c1 vn cv cfz co c1 vq cv c1 caddc co
      cfz co wceq c1 vn cv cfz co cA vz cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wb vn cv vq cv c1 caddc co c1 cfz opreq2 c1 vn cv cfz co c1 vq cv
      c1 caddc co cfz co cA vz cv feq2 syl wps vg vz cv wsbc vn vq cv c1 caddc
      co sbceq1a anbi12d rcla4e vq cv peano2nn sylan c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex c1 vn cv cfz co cA vz cv wf wps vg vz cv wsbc wa vn
      cn wrex vg vz cv c1 vn cv cfz co cA vz cv wf wps vg vz cv wsbc wa vg vn
      cn vn cv cn wcel vg ax-17 c1 vn cv cfz co cA vz cv wf wps vg vz cv wsbc
      vg c1 vn cv cfz co cA vz cv wf vg ax-17 wps vg vz cv vz visset hbsbc1v
      hban hbrex vz visset vg cv vz cv wceq c1 vn cv cfz co cA vg cv wf wps wa
      c1 vn cv cfz co cA vz cv wf wps vg vz cv wsbc wa vn cn vg cv vz cv wceq
      c1 vn cv cfz co cA vg cv wf c1 vn cv cfz co cA vz cv wf wps wps vg vz cv
      wsbc c1 vn cv cfz co cA vg cv vz cv feq1 wps vg vz cv sbceq1a anbi12d
      rexbidv elabf sylibr adantrrl adantrll r19.23aiva abssi wph c1 csn cA vh
      cv wf wth wa wa c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw wcel c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab wss wb vn cv cn wcel c1 vn cv cfz co cA vx cv wf
      wps vg vx cv wsbc wa wph c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cpw wcel c1
      vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wss wb c1 csn cA vh cv wf wth wa wph c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cvv wcel c1 vq cv cfz co
      cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab cpw wcel c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wss wb cn cvv
      wcel c1 vn cv cfz co cA vg cv wf wps wa vg cab cvv wcel vn cn wral c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cvv wcel wph c1 vn cv cfz
      co cA vg cv wf wps wa vn vg cn cvv cvv abrexex2g nnex wph c1 vn cv cfz co
      cA vg cv wf wps wa vg cab cvv wcel vn cn wph c1 vn cv cfz co cA vg cv wf
      wps wa vg cab cvv wcel vn cv cn wcel c1 vn cv cfz co cA vg cv wf wps wa
      vg cab c1 vn cv cfz co cA vg cv wf vg cab wss c1 vn cv cfz co cA vg cv wf
      vg cab cvv wcel c1 vn cv cfz co cA vg cv wf wps wa vg cab cvv wcel wph c1
      vn cv cfz co cA vg cv wf wps wa vg cab c1 vn cv cfz co cA vg cv wf vg cab
      cvv ssexg c1 vn cv cfz co cA vg cv wf wps wa c1 vn cv cfz co cA vg cv wf
      vg c1 vn cv cfz co cA vg cv wf wps pm3.26 ss2abi c1 vn cv cfz co cvv wcel
      cA cC wcel c1 vn cv cfz co cA vg cv wf vg cab cvv wcel wph c1 vn cv cfz
      co cA cvv cC vg mapex c1 vn cv cfz oprex sdc.8 sylancr sylancr a1d
      r19.21aiv sylancr c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab cvv elpw2g syl
      adantr ad2antrr mpbiri wph vn cv cn wcel c1 vn cv cfz co cA vx cv wf wps
      vg vx cv wsbc wa c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      c0 wne c1 csn cA vh cv wf wth wa wph vn cv cn wcel wa c1 vn cv cfz co cA
      vr cv wf wta wa wa c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      c0 wne wi wph vn cv cn wcel wa c1 vn cv cfz co cA vx cv wf wps vg vx cv
      wsbc wa wa c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c0 wne wi
      vr vx vr cv vx cv wceq wph vn cv cn wcel wa c1 vn cv cfz co cA vr cv wf
      wta wa wa wph vn cv cn wcel wa c1 vn cv cfz co cA vx cv wf wps vg vx cv
      wsbc wa wa c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c0 wne c1
      vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c0 wne vr cv vx cv wceq
      c1 vn cv cfz co cA vr cv wf wta wa c1 vn cv cfz co cA vx cv wf wps vg vx
      cv wsbc wa wph vn cv cn wcel wa vr cv vx cv wceq c1 vn cv cfz co cA vr cv
      wf c1 vn cv cfz co cA vx cv wf wta wps vg vx cv wsbc c1 vn cv cfz co cA
      vr cv vx cv feq1 vr cv vx cv wceq wps vg vr cv wsbc wps vg vx cv wsbc wta
      wps vg vr cv vx cv dfsbcq wps wta vg vr cv vr visset sdc.2 sbcie syl5bbr
      anbi12d anbi2d vr cv vx cv wceq c1 vq cv cfz co cA vr cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c0 vr cv
      vx cv wceq c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex c1 vq cv cfz co
      cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz vr cv vx cv wceq c1 vq cv cfz co cA vr
      cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr
      cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wa wa c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn vr cv vx cv wceq
      c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa c1
      vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vr cv vx
      cv wceq c1 vq cv cfz co cA vr cv wf c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf c1 vq cv cfz co cA vr cv vx cv feq1 anbi1d
      vr cv vx cv wceq vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co
      wral vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg
      vz cv wsbc vn vq cv c1 caddc co wsbc vr cv vx cv wceq vv cv vz cv cfv vv
      cv vr cv cfv wceq vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      vr cv vx cv wceq vv cv vr cv cfv vv cv vx cv cfv vv cv vz cv cfv vv cv vr
      cv vx cv fveq1 eqeq2d ralbidv anbi1d anbi12d rexbidv abbidv neeq1d
      imbi12d wph vk cv cn wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa wa c1
      vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c0 wne wi wph vn cv cn
      wcel wa c1 vn cv cfz co cA vr cv wf wta wa wa c1 vq cv cfz co cA vr cv wf
      c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa wa vq cn wrex vz cab c0 wne wi vk vn vk cv vn cv wceq wph vk cv
      cn wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa wa wph vn cv cn wcel wa
      c1 vn cv cfz co cA vr cv wf wta wa wa c1 vq cv cfz co cA vr cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab c0 wne vk cv vn cv wceq wph vk cv cn wcel wa wph vn cv
      cn wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa c1 vn cv cfz co cA vr
      cv wf wta wa vk cv vn cv wceq vk cv cn wcel vn cv cn wcel wph vk cv vn cv
      cn eleq1 anbi2d vk cv vn cv wceq c1 vk cv cfz co cA vr cv wf c1 vn cv cfz
      co cA vr cv wf sdc.wet wta vk cv vn cv wceq c1 vk cv cfz co c1 vn cv cfz
      co wceq c1 vk cv cfz co cA vr cv wf c1 vn cv cfz co cA vr cv wf wb vk cv
      vn cv c1 cfz opreq2 c1 vk cv cfz co c1 vn cv cfz co cA vr cv feq2 syl
      sdc.wet wta wb vn cv vk cv vn cv vk cv wceq wta sdc.wet sdc.6 bicomd
      eqcoms anbi12d anbi12d imbi1d wph vk cv cn wcel wa c1 vk cv cfz co cA vr
      cv wf sdc.wet wa wa c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz wex
      c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c0 wne wph vk cv
      cn wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa wa c1 vq cv cfz co cA
      vr cv wf c1 vq cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv
      vr cv cfv wceq vv c1 vq cv cfz co wral sdc.wze vn vq cv c1 caddc co wsbc
      wa wa vs wex vq cn wrex c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz wex vk cv cn wcel c1 vk cv cfz co cA vr cv wf c1 vk cv c1 caddc co cfz
      co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co
      wral sdc.wsi wa wa vs wex c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc
      co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vq cv
      cfz co wral sdc.wze vn vq cv c1 caddc co wsbc wa wa vs wex vq cn wrex wph
      vk cv cn wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa wa c1 vq cv cfz
      co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv
      vv cv vr cv cfv wceq vv c1 vq cv cfz co wral sdc.wze vn vq cv c1 caddc co
      wsbc wa wa vs wex c1 vk cv cfz co cA vr cv wf c1 vk cv c1 caddc co cfz co
      cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co
      wral sdc.wsi wa wa vs wex vq vk cv cn vq cv vk cv wceq c1 vq cv cfz co cA
      vr cv wf c1 vq cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv
      vr cv cfv wceq vv c1 vq cv cfz co wral sdc.wze vn vq cv c1 caddc co wsbc
      wa wa c1 vk cv cfz co cA vr cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf
      wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi
      wa wa vs vq cv vk cv wceq c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc
      co cfz co cA vs cv wf wa c1 vk cv cfz co cA vr cv wf c1 vk cv c1 caddc co
      cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vq cv
      cfz co wral sdc.wze vn vq cv c1 caddc co wsbc wa vv cv vs cv cfv vv cv vr
      cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi wa vq cv vk cv wceq c1 vq cv
      cfz co cA vr cv wf c1 vk cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz
      co cA vs cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf vq cv vk cv wceq
      c1 vq cv cfz co c1 vk cv cfz co wceq c1 vq cv cfz co cA vr cv wf c1 vk cv
      cfz co cA vr cv wf wb vq cv vk cv c1 cfz opreq2 c1 vq cv cfz co c1 vk cv
      cfz co cA vr cv feq2 syl vq cv vk cv wceq c1 vq cv c1 caddc co cfz co c1
      vk cv c1 caddc co cfz co wceq c1 vq cv c1 caddc co cfz co cA vs cv wf c1
      vk cv c1 caddc co cfz co cA vs cv wf wb vq cv vk cv wceq vq cv c1 caddc
      co vk cv c1 caddc co c1 cfz vq cv vk cv c1 caddc opreq1 opreq2d c1 vq cv
      c1 caddc co cfz co c1 vk cv c1 caddc co cfz co cA vs cv feq2 syl anbi12d
      vq cv vk cv wceq vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co
      wral vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co wral sdc.wze
      vn vq cv c1 caddc co wsbc sdc.wsi vq cv vk cv wceq vv cv vs cv cfv vv cv
      vr cv cfv wceq vv c1 vq cv cfz co c1 vk cv cfz co vq cv vk cv c1 cfz
      opreq2 raleq1d vq cv vk cv wceq vq cv c1 caddc co vk cv c1 caddc co wceq
      sdc.wze vn vq cv c1 caddc co wsbc sdc.wsi wb vq cv vk cv c1 caddc opreq1
      vq cv c1 caddc co vk cv c1 caddc co wceq sdc.wze vn vq cv c1 caddc co
      wsbc sdc.wze vn vk cv c1 caddc co wsbc sdc.wsi sdc.wze vn vq cv c1 caddc
      co vk cv c1 caddc co dfsbcq sdc.wze sdc.wsi vn vk cv c1 caddc co vk cv c1
      caddc oprex sdc.7 sbcie syl6bb syl anbi12d anbi12d exbidv rcla4ev wph vk
      cv cn wcel c1 vk cv cfz co cA vr cv wf sdc.wet wa simplr wph vk cv cn
      wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa wa c1 vk cv cfz co cA vr
      cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv
      cfv wceq vv c1 vk cv cfz co wral sdc.wsi w3a vs wex wa c1 vk cv cfz co cA
      vr cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv
      vr cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi wa wa vs wex wph vk cv cn
      wcel wa c1 vk cv cfz co cA vr cv wf sdc.wet wa wa c1 vk cv cfz co cA vr
      cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv
      cfv wceq vv c1 vk cv cfz co wral sdc.wsi w3a vs wex wph vk cv cn wcel wa
      c1 vk cv cfz co cA vr cv wf sdc.wet simprl wph vk cv cn wcel wa c1 vk cv
      cfz co cA vr cv wf sdc.wet wa c1 vk cv c1 caddc co cfz co cA vs cv wf vv
      cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi w3a vs
      wex sdc.10 imp jca c1 vk cv cfz co cA vr cv wf c1 vk cv c1 caddc co cfz
      co cA vs cv wf vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co
      wral sdc.wsi w3a vs wex wa c1 vk cv cfz co cA vr cv wf c1 vk cv c1 caddc
      co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv
      cfz co wral sdc.wsi w3a wa vs wex c1 vk cv cfz co cA vr cv wf c1 vk cv c1
      caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1
      vk cv cfz co wral sdc.wsi wa wa vs wex c1 vk cv cfz co cA vr cv wf c1 vk
      cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv cfv wceq vv
      c1 vk cv cfz co wral sdc.wsi w3a vs 19.42v c1 vk cv cfz co cA vr cv wf c1
      vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv cfv wceq
      vv c1 vk cv cfz co wral sdc.wsi w3a wa c1 vk cv cfz co cA vr cv wf c1 vk
      cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq
      vv c1 vk cv cfz co wral sdc.wsi wa wa vs c1 vk cv cfz co cA vr cv wf c1
      vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv cfv wceq
      vv c1 vk cv cfz co wral sdc.wsi w3a wa c1 vk cv cfz co cA vr cv wf c1 vk
      cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr cv cfv wceq vv
      c1 vk cv cfz co wral sdc.wsi wa wa wa c1 vk cv cfz co cA vr cv wf c1 vk
      cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq
      vv c1 vk cv cfz co wral sdc.wsi wa wa c1 vk cv c1 caddc co cfz co cA vs
      cv wf vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vk cv cfz co wral
      sdc.wsi w3a c1 vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv
      vr cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi wa wa c1 vk cv cfz co cA
      vr cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv vr
      cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi 3anass anbi2i c1 vk cv cfz co
      cA vr cv wf c1 vk cv c1 caddc co cfz co cA vs cv wf vv cv vs cv cfv vv cv
      vr cv cfv wceq vv c1 vk cv cfz co wral sdc.wsi wa anass bitr4i exbii
      bitr3i sylib sylanc c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co cfz
      co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co
      wral sdc.wze vn vq cv c1 caddc co wsbc wa wa vs wex vq cn wrex c1 vq cv
      cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vz wex vq cn wrex c1 vq cv cfz co cA vr cv wf
      c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa wa vq cn wrex vz wex c1 vq cv cfz co cA vr cv wf c1 vq cv c1
      caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq vv c1
      vq cv cfz co wral sdc.wze vn vq cv c1 caddc co wsbc wa wa vs wex c1 vq cv
      cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vz wex vq cn c1 vq cv cfz co cA vr cv wf c1 vq
      cv c1 caddc co cfz co cA vs cv wf wa vv cv vs cv cfv vv cv vr cv cfv wceq
      vv c1 vq cv cfz co wral sdc.wze vn vq cv c1 caddc co wsbc wa wa c1 vq cv
      cfz co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vs vz vs cv vz cv wceq c1 vq cv cfz co cA vr cv
      wf c1 vq cv c1 caddc co cfz co cA vs cv wf wa c1 vq cv cfz co cA vr cv wf
      c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vs cv cfv vv cv vr cv
      cfv wceq vv c1 vq cv cfz co wral sdc.wze vn vq cv c1 caddc co wsbc wa vv
      cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa vs cv vz cv wceq c1 vq cv c1 caddc co
      cfz co cA vs cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf c1 vq cv cfz
      co cA vr cv wf c1 vq cv c1 caddc co cfz co cA vs cv vz cv feq1 anbi2d vs
      cv vz cv wceq vv cv vs cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co
      wral vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv cfz co wral sdc.wze
      vn vq cv c1 caddc co wsbc wps vg vz cv wsbc vn vq cv c1 caddc co wsbc vs
      cv vz cv wceq vv cv vs cv cfv vv cv vr cv cfv wceq vv cv vz cv cfv vv cv
      vr cv cfv wceq vv c1 vq cv cfz co vs cv vz cv wceq vv cv vs cv cfv vv cv
      vz cv cfv vv cv vr cv cfv vv cv vs cv vz cv fveq1 eqeq1d ralbidv vs cv vz
      cv wceq vq cv c1 caddc co cvv wcel sdc.wze vn vq cv c1 caddc co wsbc wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wb vq cv c1 caddc oprex vs cv vz
      cv wceq sdc.wze wps vg vz cv wsbc vn vq cv c1 caddc co cvv vs cv vz cv
      wceq wps vg vs cv wsbc wps vg vz cv wsbc sdc.wze wps vg vs cv vz cv
      dfsbcq wps sdc.wze vg vs cv vs visset sdc.3 sbcie syl5bbr sbcbidv mpan2
      anbi12d anbi12d cbvexv rexbii c1 vq cv cfz co cA vr cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq vz
      cn rexcom4 bitri sylib c1 vq cv cfz co cA vr cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vr cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz abn0 sylibr chvarv chvarv adantllr sylanbrc exp31 r19.23ad c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex c1 vn cv cfz co cA vx cv wf wps vg
      vx cv wsbc wa vn cn wrex vg vx cv c1 vn cv cfz co cA vx cv wf wps vg vx
      cv wsbc wa vg vn cn vn cv cn wcel vg ax-17 c1 vn cv cfz co cA vx cv wf
      wps vg vx cv wsbc vg c1 vn cv cfz co cA vx cv wf vg ax-17 wps vg vx cv vx
      visset hbsbc1v hban hbrex vx visset vg cv vx cv wceq c1 vn cv cfz co cA
      vg cv wf wps wa c1 vn cv cfz co cA vx cv wf wps vg vx cv wsbc wa vn cn vg
      cv vx cv wceq c1 vn cv cfz co cA vg cv wf c1 vn cv cfz co cA vx cv wf wps
      wps vg vx cv wsbc c1 vn cv cfz co cA vg cv vx cv feq1 wps vg vx cv
      sbceq1a anbi12d rexbidv elabf syl5ib r19.21aiv vx vy c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab cpw c0 csn cdif c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa
      vx vy copab vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa
      vx vy copab eqid fopab2 sylib c1 csn cA vh cv wf wth wa vh cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel wph c1 csn cA vh cv wf
      wth wa c1 vn cv cfz co cA vh cv wf wch wa vn cn wrex vh cv c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab wcel c1 cn wcel c1 csn cA vh cv
      wf wth wa c1 vn cv cfz co cA vh cv wf wch wa vn cn wrex 1nn c1 vn cv cfz
      co cA vh cv wf wch wa c1 csn cA vh cv wf wth wa vn c1 cn vn cv c1 wceq c1
      vn cv cfz co cA vh cv wf c1 csn cA vh cv wf wch wth vn cv c1 wceq c1 vn
      cv cfz co c1 csn wceq c1 vn cv cfz co cA vh cv wf c1 csn cA vh cv wf wb
      vn cv c1 wceq c1 vn cv cfz co c1 c1 cfz co c1 csn vn cv c1 c1 cfz opreq2
      c1 cz wcel c1 c1 cfz co c1 csn wceq 1z c1 fzsn ax-mp syl6eq c1 vn cv cfz
      co c1 csn cA vh cv feq2 syl sdc.5 anbi12d rcla4ev mpan c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex c1 vn cv cfz co cA vh cv wf wch wa vn cn wrex
      vg vh cv vh visset vg cv vh cv wceq c1 vn cv cfz co cA vg cv wf wps wa c1
      vn cv cfz co cA vh cv wf wch wa vn cn vg cv vh cv wceq c1 vn cv cfz co cA
      vg cv wf c1 vn cv cfz co cA vh cv wf wps wch c1 vn cv cfz co cA vg cv vh
      cv feq1 sdc.1 anbi12d rexbidv elab sylibr adantl syl3anc wph c1 csn cA vh
      cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral w3a cn cA vf cv wf sdc.wmu vn cn wral wa vf wex
      vj wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj
      cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a cn cA vf cv wf sdc.wmu
      vn cn wral wa vf wex wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw
      cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa cn cA va
      cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab wf wps vg
      va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn
      cv cfz co cres wsbc vn cn wral wa cn cA vf cv wf sdc.wmu vn cn wral wa vf
      wex wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co
      vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa cn cA va cv cn wcel
      vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab wf va cv cn wcel vb
      cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv cfz co cres vc
      cv vj cv cfv wceq vc cn wral wa cn cA va cv cn wcel vb cv va cv va cv vj
      cv cfv cfv wceq wa va vb copab wf wps vg va cv cn wcel vb cv va cv va cv
      vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres wsbc vn cn wral wa
      c1 cz wcel vj cv cn wfn c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv vc cv
      vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vc cv cfz
      co wral wa vc cn wral cn cA va cv cn wcel vb cv va cv va cv vj cv cfv cfv
      wceq wa va vb copab wf va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq
      wa va vb copab c1 vc cv cfz co cres vc cv vj cv cfv wceq vc cn wral wa
      wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv
      cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      wceq wa vx vy copab cfv wcel vw cn wral w3a wa cA va vc vj cv va cv cn
      wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 cn vt vb nnuz
      va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab eqid
      sdclem1 c1 cz wcel wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv
      c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv
      c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq
      cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa 1z a1i cn
      c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv
      cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn
      wral w3a vj cv cn wfn wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vj
      cv cn wfn vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx
      cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx
      cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral
      cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv ffn
      3ad2ant1 adantl wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1
      caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa c1 vc cv cfz
      co cA vc cv vj cv cfv wf vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc
      co vj cv cfv cfv wceq vt c1 vc cv cfz co wral wa vc cn wph c1 csn cA vh
      cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral w3a wa vc cv cn wcel wa c1 vc cv cfz co cA vc
      cv vj cv cfv wf vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv
      cfv cfv wceq vt c1 vc cv cfz co wral wph c1 csn cA vh cv wf wa cn c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh
      cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a
      vc cv cn wcel c1 vc cv cfz co cA vc cv vj cv cfv wf wph c1 csn cA vh cv
      wf wth wa wa wph vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vx vy vz vw cA cC vc
      cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vh vj vq sdc.8
      sdclem2 wph c1 csn cA vh cv wf wph c1 csn cA vh cv wf wa wth wph c1 csn
      cA vh cv wf wa id adantrr sylanl1 wph cn c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co
      vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a vc cv cn wcel c1 vc cv
      cfz co cA vc cv vj cv cfv wf vt cv vc cv vj cv cfv cfv vt cv vc cv c1
      caddc co vj cv cfv cfv wceq vt c1 vc cv cfz co wral wi c1 csn cA vh cv wf
      wth wa wph vc cv cn wcel cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv
      vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel
      vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral w3a c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv
      vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vc
      cv cfz co wral wi wph vc cv cn wcel wa cn c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab vj cv wf vw cv c1 caddc co vj cv cfv vw cv vj cv cfv
      vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1
      vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv vc cv vj cv
      cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vc cv cfz co
      wral wi c1 vj cv cfv vh cv wceq wph vc cv cn wcel wa cn c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab vj cv wf vw cv c1 caddc co vj cv cfv
      vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      wa vx vy copab cfv wcel vw cn wral wa vc cv c1 caddc co vj cv cfv c1 vq
      cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wcel
      c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv vc cv vj cv cfv cfv vt cv vc
      cv c1 caddc co vj cv cfv cfv wceq vt c1 vc cv cfz co wral wi wph vc cv cn
      wcel wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf
      vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral vc cv c1
      caddc co vj cv cfv c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wcel wph vc cv cn wcel wa cn c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab vj cv wf wa vw cv c1 caddc co vj cv cfv
      vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      wa vx vy copab cfv wcel vw cn wral vc cv c1 caddc co vj cv cfv vc cv vj
      cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vc cv c1 caddc co vj cv cfv c1 vq cv cfz co cA vc cv vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vq cn wrex vz cab wcel wph vc cv cn wcel wa vw
      cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral vc cv c1 caddc
      co vj cv cfv vc cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel cn c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab vj cv wf vc cv cn wcel vw cv c1 caddc co vj cv cfv vw
      cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa
      vx vy copab cfv wcel vw cn wral vc cv c1 caddc co vj cv cfv vc cv vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel wph vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vc
      cv c1 caddc co vj cv cfv vc cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw vc cv cn vw cv vc cv
      wceq vw cv c1 caddc co vj cv cfv vc cv c1 caddc co vj cv cfv vw cv vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv vc cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv vw cv vc cv wceq vw cv c1 caddc co vc cv
      c1 caddc co vj cv vw cv vc cv c1 caddc opreq1 fveq2d vw cv vc cv wceq vw
      cv vj cv cfv vc cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab vw cv vc cv vj cv fveq2 fveq2d eleq12d rcla4va
      adantll adantlr wph vc cv cn wcel wa cn c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab vj cv wf wa vc cv c1 caddc co vj cv cfv vc cv vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vc cv c1 caddc co vj cv cfv c1 vq cv cfz co cA vc cv vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vq cn wrex vz cab wcel wph vc cv cn wcel wa cn
      c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf wa vc cv vj
      cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz
      co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq
      cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab vc cv c1 caddc co vj cv cfv wph vc cv cn wcel cn c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf vc cv vj cv cfv vx cv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv c1 vq cv
      cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      wph vc cv vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      wcel vc cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      wceq wa vx vy copab cfv c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wceq vc cv cn wcel cn c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab vj cv wf wa vc cv vj cv cfv c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab wcel wph vc cv vj cv cfv vx cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv c1 vq cv
      cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      vc cv vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel
      c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz
      co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz
      cab cvv wcel vc cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv c1 vq cv cfz co cA vc cv vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv
      cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wa wa vq cn wrex vz cab wceq wph vx vy vc cv vj cv cfv c1 vq cv
      cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq
      cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vq cv cfz co cA vc cv vj
      cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab cvv vx cv c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab wceq wa vx vy copab vx cv vc cv vj cv cfv wceq c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa vq cn wrex c1 vq cv cfz co cA vc cv vj cv cfv wf
      c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz vx cv vc cv vj cv cfv wceq c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn vx cv vc cv vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa c1 vq cv cfz co cA vc cv vj cv cfv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vx cv vc cv vj cv cfv
      wceq c1 vq cv cfz co cA vx cv wf c1 vq cv cfz co cA vc cv vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf c1 vq cv cfz co cA vx cv vc cv vj cv
      cfv feq1 anbi1d vx cv vc cv vj cv cfv wceq vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral vv cv vz cv cfv vv cv vc cv vj cv cfv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc vx cv vc cv vj cv cfv wceq vv cv vz cv cfv vv cv vx cv cfv wceq vv
      cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co vx cv vc
      cv vj cv cfv wceq vv cv vx cv cfv vv cv vc cv vj cv cfv cfv vv cv vz cv
      cfv vv cv vx cv vc cv vj cv cfv fveq1 eqeq2d ralbidv anbi1d anbi12d
      rexbidv abbidv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz
      cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa
      vx vy copab eqid fvopab4g cn cvv wcel c1 vq cv cfz co cA vc cv vj cv cfv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv
      vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vz cab cvv wcel vq cn wral c1 vq cv cfz co cA vc cv
      vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab cvv wcel wph c1 vq cv
      cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq vz cn cvv cvv
      abrexex2g nnex wph c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vz cab cvv wcel vq cn wph c1 vq cv cfz co cA vc cv vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv
      cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wa wa vz cab cvv wcel vq cv cn wcel c1 vq cv cfz co cA vc cv vj
      cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vz cab c1 vq cv c1 caddc co cfz co cA vz cv
      wf vz cab wss c1 vq cv c1 caddc co cfz co cA vz cv wf vz cab cvv wcel c1
      vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv
      wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vz cab cvv wcel
      wph c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vz cab c1
      vq cv c1 caddc co cfz co cA vz cv wf vz cab cvv ssexg c1 vq cv cfz co cA
      vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa c1 vq cv c1 caddc co cfz co cA vz cv
      wf vz c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa simplr ss2abi
      c1 vq cv c1 caddc co cfz co cvv wcel cA cC wcel c1 vq cv c1 caddc co cfz
      co cA vz cv wf vz cab cvv wcel wph c1 vq cv c1 caddc co cfz co cA cvv cC
      vz mapex c1 vq cv c1 caddc co cfz oprex sdc.8 sylancr sylancr adantr
      r19.21aiva sylancr sylan2 ancoms cn c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab vj cv wf vc cv cn wcel vc cv vj cv cfv c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab wcel cn c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab vc cv vj cv ffvelrn ancoms sylan2 anassrs eleq2d
      biimpa syldan anasss wph vc cv cn wcel wa c1 vq cv cfz co cA vc cv vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vc cv c1 caddc co vj cv cfv wf wa
      vv cv vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq vv
      c1 vq cv cfz co wral wps vg vc cv c1 caddc co vj cv cfv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex c1 vc cv cfz co cA vc cv vj cv cfv wf vt
      cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1
      vc cv cfz co wral wi vc cv c1 caddc co vj cv cfv c1 vq cv cfz co cA vc cv
      vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wcel c1 vq cv cfz co cA
      vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv c1 caddc co vj cv
      cfv wf wa vv cv vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vc cv c1 caddc co vj cv cfv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex c1 vc cv cfz co cA vc cv vj cv
      cfv wf vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv
      wceq vt c1 vc cv cfz co wral wi wph vc cv cn wcel wa c1 vq cv cfz co cA
      vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv c1 caddc co vj cv
      cfv wf wa vv cv vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vc cv c1 caddc co vj cv cfv wsbc vn
      vq cv c1 caddc co wsbc wa wa c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv
      vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vc
      cv cfz co wral wi vq cn c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vc cv c1 caddc co vj cv cfv wf wa vv cv vc cv c1 caddc
      co vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vc cv c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cv cn wcel c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv vc cv vj cv cfv
      cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vc cv cfz co wral wi
      c1 vq cv cfz co cA vc cv vj cv cfv wf vv cv vc cv c1 caddc co vj cv cfv
      cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral vq cv cn wcel
      c1 vc cv cfz co cA vc cv vj cv cfv wf vt cv vc cv vj cv cfv cfv vt cv vc
      cv c1 caddc co vj cv cfv cfv wceq vt c1 vc cv cfz co wral wi wi c1 vq cv
      c1 caddc co cfz co cA vc cv c1 caddc co vj cv cfv wf wps vg vc cv c1
      caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc c1 vq cv cfz co cA vc
      cv vj cv cfv wf vv cv vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv
      cfv cfv wceq vv c1 vq cv cfz co wral vq cv cn wcel c1 vc cv cfz co cA vc
      cv vj cv cfv wf vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv
      cfv cfv wceq vt c1 vc cv cfz co wral wi wi c1 vq cv cfz co cA vc cv vj cv
      cfv wf c1 vc cv cfz co cA vc cv vj cv cfv wf vq cv cn wcel vv cv vc cv c1
      caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq
      vt c1 vc cv cfz co wral c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vc cv
      cfz co cA vc cv vj cv cfv wf vq cv cn wcel vv cv vc cv c1 caddc co vj cv
      cfv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral vt cv vc
      cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vc cv
      cfz co wral wi wi c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vc cv cfz co
      cA vc cv vj cv cfv wf wa c1 vq cv cfz co c1 vc cv cfz co wceq vq cv cn
      wcel vv cv vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq
      vv c1 vq cv cfz co wral vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co
      vj cv cfv cfv wceq vt c1 vc cv cfz co wral wi wi vc cv vj cv cfv c1 vq cv
      cfz co wfn vc cv vj cv cfv c1 vc cv cfz co wfn c1 vq cv cfz co c1 vc cv
      cfz co wceq c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vc cv cfz co cA vc
      cv vj cv cfv wf c1 vq cv cfz co c1 vc cv cfz co vc cv vj cv cfv fndmu c1
      vq cv cfz co cA vc cv vj cv cfv ffn c1 vc cv cfz co cA vc cv vj cv cfv
      ffn syl2an c1 vq cv cfz co c1 vc cv cfz co wceq vv cv vc cv c1 caddc co
      vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral vt
      cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1
      vc cv cfz co wral wi vq cv cn wcel c1 vq cv cfz co c1 vc cv cfz co wceq
      vv cv vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq vv
      c1 vq cv cfz co wral vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj
      cv cfv cfv wceq vt c1 vc cv cfz co wral c1 vq cv cfz co c1 vc cv cfz co
      wceq vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq
      vt c1 vq cv cfz co wral vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc co
      vj cv cfv cfv wceq vt c1 vc cv cfz co wral vv cv vc cv c1 caddc co vj cv
      cfv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral vt cv vc
      cv vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vt c1 vq cv
      cfz co c1 vc cv cfz co raleq1 vv cv vc cv c1 caddc co vj cv cfv cfv vv cv
      vc cv vj cv cfv cfv wceq vt cv vc cv vj cv cfv cfv vt cv vc cv c1 caddc
      co vj cv cfv cfv wceq vv vt c1 vq cv cfz co vv cv vt cv wceq vv cv vc cv
      vj cv cfv cfv vv cv vc cv c1 caddc co vj cv cfv cfv wceq vt cv vc cv vj
      cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv wceq vv cv vc cv c1
      caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv wceq vv cv vt cv wceq vv
      cv vc cv vj cv cfv cfv vt cv vc cv vj cv cfv cfv vv cv vc cv c1 caddc co
      vj cv cfv cfv vt cv vc cv c1 caddc co vj cv cfv cfv vv cv vt cv vc cv vj
      cv cfv fveq2 vv cv vt cv vc cv c1 caddc co vj cv cfv fveq2 eqeq12d vv cv
      vc cv c1 caddc co vj cv cfv cfv vv cv vc cv vj cv cfv cfv eqcom syl5bb
      cbvralv syl5bb biimpd a1d syl ex com24 imp ad2ant2r com12 r19.23aiv
      adantl c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc
      cv c1 caddc co vj cv cfv wf wa vv cv vc cv c1 caddc co vj cv cfv cfv vv
      cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vc cv c1 caddc
      co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz vc cv c1
      caddc co vj cv cfv vc cv c1 caddc co vj cv fvex vz cv vc cv c1 caddc co
      vj cv cfv wceq c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv vj cv cfv cfv wceq vv
      c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa c1
      vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv
      c1 caddc co vj cv cfv wf wa vv cv vc cv c1 caddc co vj cv cfv cfv vv cv
      vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vc cv c1 caddc co
      vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn vz cv vc cv c1 caddc
      co vj cv cfv wceq c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa c1 vq cv cfz co cA vc cv vj cv cfv wf c1 vq cv
      c1 caddc co cfz co cA vc cv c1 caddc co vj cv cfv wf wa vv cv vz cv cfv
      vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa vv cv vc cv c1 caddc co vj cv cfv cfv vv cv
      vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vc cv c1 caddc co
      vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa vz cv vc cv c1 caddc co vj cv
      cfv wceq c1 vq cv c1 caddc co cfz co cA vz cv wf c1 vq cv c1 caddc co cfz
      co cA vc cv c1 caddc co vj cv cfv wf c1 vq cv cfz co cA vc cv vj cv cfv
      wf c1 vq cv c1 caddc co cfz co cA vz cv vc cv c1 caddc co vj cv cfv feq1
      anbi2d vz cv vc cv c1 caddc co vj cv cfv wceq vv cv vz cv cfv vv cv vc cv
      vj cv cfv cfv wceq vv c1 vq cv cfz co wral vv cv vc cv c1 caddc co vj cv
      cfv cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc wps vg vc cv c1 caddc co vj cv cfv wsbc
      vn vq cv c1 caddc co wsbc vz cv vc cv c1 caddc co vj cv cfv wceq vv cv vz
      cv cfv vv cv vc cv vj cv cfv cfv wceq vv cv vc cv c1 caddc co vj cv cfv
      cfv vv cv vc cv vj cv cfv cfv wceq vv c1 vq cv cfz co vz cv vc cv c1
      caddc co vj cv cfv wceq vv cv vz cv cfv vv cv vc cv c1 caddc co vj cv cfv
      cfv vv cv vc cv vj cv cfv cfv vv cv vz cv vc cv c1 caddc co vj cv cfv
      fveq1 eqeq1d ralbidv vz cv vc cv c1 caddc co vj cv cfv wceq vq cv c1
      caddc co cvv wcel wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wps vg vc
      cv c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wb vq cv c1 caddc
      oprex vz cv vc cv c1 caddc co vj cv cfv wceq wps vg vz cv wsbc wps vg vc
      cv c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co cvv wps vg vz cv vc cv
      c1 caddc co vj cv cfv dfsbcq sbcbidv mpan2 anbi12d anbi12d rexbidv elab
      sylan2b syldan 3adantr2 an1rs adantllr jcai r19.21aiva syl3anc wph c1 csn
      cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj
      cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral w3a wa va cv cn wcel vb cv va cv va cv vj cv
      cfv cfv wceq wa va vb copab c1 vc cv cfz co cres vc cv vj cv cfv wceq vc
      cn wral wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va
      vb copab c1 vn cv cfz co cres wsbc vn cn wral cn cA va cv cn wcel vb cv
      va cv va cv vj cv cfv cfv wceq wa va vb copab wf wph c1 csn cA vh cv wf
      wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv
      wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx
      cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq
      cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral w3a wa va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq
      wa va vb copab c1 vc cv cfz co cres vc cv vj cv cfv wceq vc cn wral wps
      vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1
      vc cv cfz co cres wsbc vn vc cv wsbc vc cn wral wps vg va cv cn wcel vb
      cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres
      wsbc vn cn wral wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1
      caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa va cv cn wcel
      vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv cfz co cres
      vc cv vj cv cfv wceq wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv
      wceq wa va vb copab c1 vc cv cfz co cres wsbc vn vc cv wsbc vc cn va cv
      cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv cfz
      co cres vc cv vj cv cfv wceq wps vg va cv cn wcel vb cv va cv va cv vj cv
      cfv cfv wceq wa va vb copab c1 vc cv cfz co cres wsbc vn vc cv wsbc wps
      vg vc cv vj cv cfv wsbc vn vc cv wsbc wph c1 csn cA vh cv wf wth wa wa cn
      c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv
      cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn
      wral w3a wa vc cv cn wcel wa va cv cn wcel vb cv va cv va cv vj cv cfv
      cfv wceq wa va vb copab c1 vc cv cfz co cres vc cv vj cv cfv wceq vc cv
      cvv wcel wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va
      vb copab c1 vc cv cfz co cres wsbc vn vc cv wsbc wps vg vc cv vj cv cfv
      wsbc vn vc cv wsbc wb vc visset va cv cn wcel vb cv va cv va cv vj cv cfv
      cfv wceq wa va vb copab c1 vc cv cfz co cres vc cv vj cv cfv wceq wps vg
      va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc
      cv cfz co cres wsbc wps vg vc cv vj cv cfv wsbc vn vc cv cvv wps vg va cv
      cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv cfz
      co cres vc cv vj cv cfv dfsbcq sbcbidv mpan2 wph c1 csn cA vh cv wf wth
      wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1
      vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw
      cn wral w3a wa vc cv cn wcel wa vc cv c1 wceq vc cv c1 cmin co cn wcel wo
      wps vg vc cv vj cv cfv wsbc vn vc cv wsbc vc cv cn wcel vc cv c1 wceq vc
      cv c1 cmin co cn wcel wo wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq
      vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa vc
      cv c1 cuz cfv wcel vc cv c1 wceq vc cv c1 cmin co c1 cuz cfv wcel wo vc
      cv cn wcel vc cv c1 wceq vc cv c1 cmin co cn wcel wo c1 vc cv uzm1 vc cv
      elnnuz vc cv c1 cmin co cn wcel vc cv c1 cmin co c1 cuz cfv wcel vc cv c1
      wceq vc cv c1 cmin co elnnuz orbi2i 3imtr4i adantl wph c1 csn cA vh cv wf
      wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv
      wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx
      cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq
      cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral w3a wa vc cv cn wcel wa vc cv c1 wceq wps vg vc cv vj cv
      cfv wsbc vn vc cv wsbc vc cv c1 cmin co cn wcel wph c1 csn cA vh cv wf
      wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv
      wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx
      cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq
      cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral w3a wa vc cv c1 wceq wps vg vc cv vj cv cfv wsbc vn vc cv
      wsbc vc cv cn wcel wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv
      c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv
      c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq
      cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa vc cv c1
      wceq wps vg vc cv vj cv cfv wsbc vn vc cv wsbc vc cv c1 wceq wps vg vc cv
      vj cv cfv wsbc vn vc cv wsbc wps vg c1 vj cv cfv wsbc vn c1 wsbc wph c1
      csn cA vh cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv
      vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      wa vx vy copab cfv wcel vw cn wral w3a wa vc cv c1 wceq wps vg vc cv vj
      cv cfv wsbc vn vc cv wsbc wps vg vc cv vj cv cfv wsbc vn c1 wsbc wps vg
      c1 vj cv cfv wsbc vn c1 wsbc wps vg vc cv vj cv cfv wsbc vn vc cv c1
      dfsbcq vc cv c1 wceq c1 cn wcel wps vg vc cv vj cv cfv wsbc vn c1 wsbc
      wps vg c1 vj cv cfv wsbc vn c1 wsbc wb 1nn vc cv c1 wceq wps vg vc cv vj
      cv cfv wsbc wps vg c1 vj cv cfv wsbc vn c1 cn vc cv c1 wceq vc cv vj cv
      cfv c1 vj cv cfv wceq wps vg vc cv vj cv cfv wsbc wps vg c1 vj cv cfv
      wsbc wb vc cv c1 vj cv fveq2 wps vg vc cv vj cv cfv c1 vj cv cfv dfsbcq
      syl sbcbidv mpan2 bitrd wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq
      wps vg c1 vj cv cfv wsbc vn c1 wsbc vw cv c1 caddc co vj cv cfv vw cv vj
      cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral wph c1 csn cA vh cv wf wth wa wa c1 vj cv cfv
      vh cv wceq wps vg c1 vj cv cfv wsbc vn c1 wsbc wth c1 vj cv cfv vh cv
      wceq wps vg c1 vj cv cfv wsbc vn c1 wsbc wi wph c1 csn cA vh cv wf c1 vj
      cv cfv vh cv wceq wps vg c1 vj cv cfv wsbc vn c1 wsbc wth c1 vj cv cfv vh
      cv wceq wps vg c1 vj cv cfv wsbc vn c1 wsbc wch vn c1 wsbc wth c1 vj cv
      cfv vh cv wceq c1 cn wcel wps vg c1 vj cv cfv wsbc vn c1 wsbc wch vn c1
      wsbc wb 1nn c1 vj cv cfv vh cv wceq wps vg c1 vj cv cfv wsbc wch vn c1 cn
      c1 vj cv cfv vh cv wceq wps vg c1 vj cv cfv wsbc wps vg vh cv wsbc wch
      wps vg c1 vj cv cfv vh cv dfsbcq wps wch vg vh cv vh visset sdc.1 sbcie
      syl6bb sbcbidv mpan2 wch wth vn c1 c1 cn 1nn elisseti sdc.5 sbcie syl6bb
      biimprcd ad2antll imp 3ad2antr2 syl5cbir imp adantlr wph c1 csn cA vh cv
      wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj
      cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv
      vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1
      vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc
      vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel vw cn wral w3a wa vc cv c1 cmin co cn wcel vc cv cn wcel wps vg vc
      cv vj cv cfv wsbc vn vc cv wsbc wph c1 csn cA vh cv wf wth wa wa cn c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh
      cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a
      wa vc cv c1 cmin co cn wcel wa vc cv vc cv c1 cmin co c1 caddc co wceq
      wps vg vc cv vj cv cfv wsbc vn vc cv wsbc vc cv cn wcel wph c1 csn cA vh
      cv wf wth wa wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral w3a wa vc cv c1 cmin co cn wcel wa vc cv vc cv
      c1 cmin co c1 caddc co wceq wps vg vc cv vj cv cfv wsbc vn vc cv wsbc vc
      cv vc cv c1 cmin co c1 caddc co wceq wps vg vc cv vj cv cfv wsbc vn vc cv
      wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin
      co c1 caddc co wsbc wph c1 csn cA vh cv wf wth wa wa cn c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw
      cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa vc cv c1
      cmin co cn wcel wa vc cv vc cv c1 cmin co c1 caddc co wceq wps vg vc cv
      vj cv cfv wsbc vn vc cv wsbc wps vg vc cv vj cv cfv wsbc vn vc cv c1 cmin
      co c1 caddc co wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn
      vc cv c1 cmin co c1 caddc co wsbc wps vg vc cv vj cv cfv wsbc vn vc cv vc
      cv c1 cmin co c1 caddc co dfsbcq vc cv vc cv c1 cmin co c1 caddc co wceq
      vc cv c1 cmin co c1 caddc co cvv wcel wps vg vc cv vj cv cfv wsbc vn vc
      cv c1 cmin co c1 caddc co wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv
      cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wb vc cv c1 cmin co c1
      caddc oprex vc cv vc cv c1 cmin co c1 caddc co wceq wps vg vc cv vj cv
      cfv wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1
      cmin co c1 caddc co cvv vc cv vc cv c1 cmin co c1 caddc co wceq vc cv vj
      cv cfv vc cv c1 cmin co c1 caddc co vj cv cfv wceq wps vg vc cv vj cv cfv
      wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc wb vc cv vc cv c1
      cmin co c1 caddc co vj cv fveq2 wps vg vc cv vj cv cfv vc cv c1 cmin co
      c1 caddc co vj cv cfv dfsbcq syl sbcbidv mpan2 bitrd wph c1 csn cA vh cv
      wf wa cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1
      vj cv cfv vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw
      cn wral w3a vc cv c1 cmin co cn wcel wps vg vc cv c1 cmin co c1 caddc co
      vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wph c1 csn cA vh cv
      wf wth wa wa wph c1 csn cA vh cv wf wa cn c1 vn cv cfz co cA vg cv wf wps
      wa vn cn wrex vg cab vj cv wf c1 vj cv cfv vh cv wceq vw cv c1 caddc co
      vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel vw cn wral w3a wa vc cv c1 cmin co cn
      wcel wa c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps
      vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1
      caddc co wsbc wph vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vx vy vz vw cA cC vc
      cv c1 cmin co c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vh vj
      vq sdc.8 sdclem2 wph c1 csn cA vh cv wf wa vc cv c1 cmin co cn wcel cn c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf c1 vj cv cfv
      vh cv wceq vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx
      cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx
      cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral
      w3a c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc
      cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co
      wsbc wi wph c1 csn cA vh cv wf wa vc cv c1 cmin co cn wcel wa cn c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf vw cv c1 caddc co vj
      cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel vw cn wral c1 vc cv c1 cmin co cfz co
      cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv c1 cmin co c1 caddc co vj
      cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi c1 vj cv cfv vh cv
      wceq wph c1 csn cA vh cv wf wa vc cv c1 cmin co cn wcel wa cn c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf vw cv c1 caddc co vj
      cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co
      cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex
      vz cab wceq wa vx vy copab cfv wcel vw cn wral wa vc cv c1 cmin co vj cv
      cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vc cv c1
      cmin co c1 caddc co vj cv cfv vc cv c1 cmin co vj cv cfv vx cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel wa c1
      vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv c1
      cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc
      wi vc cv c1 cmin co cn wcel cn c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab vj cv wf vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz
      co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv
      vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw
      cn wral wa vc cv c1 cmin co vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab wcel vc cv c1 cmin co c1 caddc co vj cv cfv vc cv c1
      cmin co vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      wa vx vy copab cfv wcel wa wph c1 csn cA vh cv wf wa vc cv c1 cmin co cn
      wcel cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab vj cv wf vw
      cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw cn wral wa vc cv c1
      cmin co vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab
      wcel vc cv c1 cmin co c1 caddc co vj cv cfv vc cv c1 cmin co vj cv cfv vx
      cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq
      cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv
      wcel wa vc cv c1 cmin co cn wcel cn c1 vn cv cfz co cA vg cv wf wps wa vn
      cn wrex vg cab vj cv wf vc cv c1 cmin co vj cv cfv c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wcel vw cv c1 caddc co vj cv cfv vw cv vj
      cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy
      cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel vw cn wral vc cv c1 cmin co c1 caddc co vj cv cfv vc cv c1
      cmin co vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg
      cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq
      wa vx vy copab cfv wcel cn c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab vj cv wf vc cv c1 cmin co cn wcel vc cv c1 cmin co vj cv cfv c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel cn c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab vc cv c1 cmin co vj cv ffvelrn expcom
      vw cv c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vc cv c1 cmin co c1
      caddc co vj cv cfv vc cv c1 cmin co vj cv cfv vx cv c1 vn cv cfz co cA vg
      cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vw vc cv c1 cmin co
      cn vw cv vc cv c1 cmin co wceq vw cv c1 caddc co vj cv cfv vc cv c1 cmin
      co c1 caddc co vj cv cfv vw cv vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv vc cv c1 cmin co vj cv cfv vx
      cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq
      cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv vw
      cv vc cv c1 cmin co wceq vw cv c1 caddc co vc cv c1 cmin co c1 caddc co
      vj cv vw cv vc cv c1 cmin co c1 caddc opreq1 fveq2d vw cv vc cv c1 cmin
      co wceq vw cv vj cv cfv vc cv c1 cmin co vj cv cfv vx cv c1 vn cv cfz co
      cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv
      wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab vw cv vc cv c1 cmin co
      vj cv fveq2 fveq2d eleq12d rcla4v anim12d imp adantll wph c1 csn cA vh cv
      wf wa vc cv c1 cmin co vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn
      wrex vg cab wcel vc cv c1 cmin co c1 caddc co vj cv cfv vc cv c1 cmin co
      vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel
      vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv wcel wa c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv
      cfv wf wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1
      cmin co c1 caddc co wsbc wi vc cv c1 cmin co cn wcel wph vc cv c1 cmin co
      vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vc cv
      c1 cmin co c1 caddc co vj cv cfv vc cv c1 cmin co vj cv cfv vx cv c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co
      cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel wa c1
      vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv c1
      cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc
      wi c1 csn cA vh cv wf wph vc cv c1 cmin co vj cv cfv c1 vn cv cfz co cA
      vg cv wf wps wa vn cn wrex vg cab wcel vc cv c1 cmin co c1 caddc co vj cv
      cfv vc cv c1 cmin co vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab wceq wa vx vy copab cfv wcel c1 vc cv c1 cmin co cfz co cA vc
      cv c1 cmin co vj cv cfv wf wps vg vc cv c1 cmin co c1 caddc co vj cv cfv
      wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi wph vc cv c1 cmin co vj cv
      cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel wa vc cv c1
      cmin co c1 caddc co vj cv cfv vc cv c1 cmin co vj cv cfv vx cv c1 vn cv
      cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA
      vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab cfv wcel vc cv
      c1 cmin co c1 caddc co vj cv cfv c1 vq cv cfz co cA vc cv c1 cmin co vj
      cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz
      cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wcel c1 vc cv
      c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv c1 cmin
      co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi wph
      vc cv c1 cmin co vj cv cfv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab wcel wa vc cv c1 cmin co vj cv cfv vx cv c1 vn cv cfz co cA vg cv
      wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq
      cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq
      vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa
      vq cn wrex vz cab wceq wa vx vy copab cfv c1 vq cv cfz co cA vc cv c1
      cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab vc cv
      c1 cmin co c1 caddc co vj cv cfv vc cv c1 cmin co vj cv cfv c1 vn cv cfz
      co cA vg cv wf wps wa vn cn wrex vg cab wcel wph vc cv c1 cmin co vj cv
      cfv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv
      c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy
      copab cfv c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq vc cv c1 cmin co vj cv cfv c1
      vn cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel c1 vq cv cfz co cA
      vc cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa
      vv cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz
      co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz
      cab cvv wcel vc cv c1 cmin co vj cv cfv vx cv c1 vn cv cfz co cA vg cv wf
      wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv
      c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq
      cn wrex vz cab wceq wa vx vy copab cfv c1 vq cv cfz co cA vc cv c1 cmin
      co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wceq wph
      vx vy vc cv c1 cmin co vj cv cfv c1 vq cv cfz co cA vx cv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn
      wrex vz cab c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab c1 vn cv cfz co cA vg cv wf wps wa
      vn cn wrex vg cab cvv vx cv c1 vn cv cfz co cA vg cv wf wps wa vn cn wrex
      vg cab wcel vy cv c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co
      cA vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      wceq wa vx vy copab vx cv vc cv c1 cmin co vj cv cfv wceq c1 vq cv cfz co
      cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex c1 vq cv cfz co cA vc cv c1 cmin co vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz vx cv vc cv c1 cmin co
      vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc co cfz co cA
      vz cv wf wa vv cv vz cv cfv vv cv vx cv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa c1 vq cv cfz co cA vc
      cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn vx cv vc cv
      c1 cmin co vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq cv c1 caddc
      co cfz co cA vz cv wf wa c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf
      c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vx cv
      cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co
      wsbc wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1
      vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa vx cv vc
      cv c1 cmin co vj cv cfv wceq c1 vq cv cfz co cA vx cv wf c1 vq cv cfz co
      cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      c1 vq cv cfz co cA vx cv vc cv c1 cmin co vj cv cfv feq1 anbi1d vx cv vc
      cv c1 cmin co vj cv cfv wceq vv cv vz cv cfv vv cv vx cv cfv wceq vv c1
      vq cv cfz co wral vv cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv
      wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc
      vx cv vc cv c1 cmin co vj cv cfv wceq vv cv vz cv cfv vv cv vx cv cfv
      wceq vv cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq
      cv cfz co vx cv vc cv c1 cmin co vj cv cfv wceq vv cv vx cv cfv vv cv vc
      cv c1 cmin co vj cv cfv cfv vv cv vz cv cfv vv cv vx cv vc cv c1 cmin co
      vj cv cfv fveq1 eqeq2d ralbidv anbi1d anbi12d rexbidv abbidv vx cv c1 vn
      cv cfz co cA vg cv wf wps wa vn cn wrex vg cab wcel vy cv c1 vq cv cfz co
      cA vx cv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv
      cv vx cv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex vz cab wceq wa vx vy copab eqid fvopab4g
      cn cvv wcel c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vz cab cvv wcel vq cn wral c1 vq cv cfz co cA vc cv
      c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab
      cvv wcel wph c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vq vz cn cvv cvv abrexex2g nnex wph c1 vq cv cfz co
      cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf
      wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv
      cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vz cab cvv
      wcel vq cn wph c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv
      c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin co
      vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa vz cab cvv wcel vq cv cn wcel c1 vq cv cfz co cA vc
      cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv
      cv vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vz cab c1 vq cv c1
      caddc co cfz co cA vz cv wf vz cab wss c1 vq cv c1 caddc co cfz co cA vz
      cv wf vz cab cvv wcel c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1
      cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn
      vq cv c1 caddc co wsbc wa wa vz cab cvv wcel wph c1 vq cv cfz co cA vc cv
      c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv
      vz cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vz cab c1 vq cv c1
      caddc co cfz co cA vz cv wf vz cab cvv ssexg c1 vq cv cfz co cA vc cv c1
      cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz
      cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa c1 vq cv c1 caddc co
      cfz co cA vz cv wf vz c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vz cv wf vv cv vz cv cfv vv cv vc cv c1 cmin
      co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa simplr ss2abi c1 vq cv c1 caddc co cfz co cvv wcel cA
      cC wcel c1 vq cv c1 caddc co cfz co cA vz cv wf vz cab cvv wcel wph c1 vq
      cv c1 caddc co cfz co cA cvv cC vz mapex c1 vq cv c1 caddc co cfz oprex
      sdc.8 sylancr sylancr a1d r19.21aiv sylancr sylan2 ancoms eleq2d vc cv c1
      cmin co c1 caddc co vj cv cfv c1 vq cv cfz co cA vc cv c1 cmin co vj cv
      cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv
      vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv
      wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex vz cab wcel c1 vq cv cfz
      co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv
      c1 cmin co c1 caddc co vj cv cfv wf wa vv cv vc cv c1 cmin co c1 caddc co
      vj cv cfv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz
      co wral wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1
      caddc co wsbc wa wa vq cn wrex c1 vc cv c1 cmin co cfz co cA vc cv c1
      cmin co vj cv cfv wf wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc
      vn vc cv c1 cmin co c1 caddc co wsbc wi c1 vq cv cfz co cA vc cv c1 cmin
      co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa vv cv vz cv
      cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps
      vg vz cv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn wrex c1 vq cv cfz co
      cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv c1
      cmin co c1 caddc co vj cv cfv wf wa vv cv vc cv c1 cmin co c1 caddc co vj
      cv cfv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co
      wral wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc
      co wsbc wa wa vq cn wrex vz vc cv c1 cmin co c1 caddc co vj cv cfv vc cv
      c1 cmin co c1 caddc co vj cv fvex vz cv vc cv c1 cmin co c1 caddc co vj
      cv cfv wceq c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1
      caddc co cfz co cA vz cv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin co vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1
      caddc co wsbc wa wa c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1
      vq cv c1 caddc co cfz co cA vc cv c1 cmin co c1 caddc co vj cv cfv wf wa
      vv cv vc cv c1 cmin co c1 caddc co vj cv cfv cfv vv cv vc cv c1 cmin co
      vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vc cv c1 cmin co c1
      caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa wa vq cn vz cv vc cv
      c1 cmin co c1 caddc co vj cv cfv wceq c1 vq cv cfz co cA vc cv c1 cmin co
      vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vz cv wf wa c1 vq cv cfz co
      cA vc cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv c1
      cmin co c1 caddc co vj cv cfv wf wa vv cv vz cv cfv vv cv vc cv c1 cmin
      co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv
      c1 caddc co wsbc wa vv cv vc cv c1 cmin co c1 caddc co vj cv cfv cfv vv
      cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vc
      cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa vz
      cv vc cv c1 cmin co c1 caddc co vj cv cfv wceq c1 vq cv c1 caddc co cfz
      co cA vz cv wf c1 vq cv c1 caddc co cfz co cA vc cv c1 cmin co c1 caddc
      co vj cv cfv wf c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf c1 vq cv
      c1 caddc co cfz co cA vz cv vc cv c1 cmin co c1 caddc co vj cv cfv feq1
      anbi2d vz cv vc cv c1 cmin co c1 caddc co vj cv cfv wceq vv cv vz cv cfv
      vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral vv cv
      vc cv c1 cmin co c1 caddc co vj cv cfv cfv vv cv vc cv c1 cmin co vj cv
      cfv cfv wceq vv c1 vq cv cfz co wral wps vg vz cv wsbc vn vq cv c1 caddc
      co wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1
      caddc co wsbc vz cv vc cv c1 cmin co c1 caddc co vj cv cfv wceq vv cv vz
      cv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv cv vc cv c1 cmin co
      c1 caddc co vj cv cfv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1
      vq cv cfz co vz cv vc cv c1 cmin co c1 caddc co vj cv cfv wceq vv cv vz
      cv cfv vv cv vc cv c1 cmin co c1 caddc co vj cv cfv cfv vv cv vc cv c1
      cmin co vj cv cfv cfv vv cv vz cv vc cv c1 cmin co c1 caddc co vj cv cfv
      fveq1 eqeq1d ralbidv vz cv vc cv c1 cmin co c1 caddc co vj cv cfv wceq vq
      cv c1 caddc co cvv wcel wps vg vz cv wsbc vn vq cv c1 caddc co wsbc wps
      vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc
      wb vq cv c1 caddc oprex vz cv vc cv c1 cmin co c1 caddc co vj cv cfv wceq
      wps vg vz cv wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn
      vq cv c1 caddc co cvv wps vg vz cv vc cv c1 cmin co c1 caddc co vj cv cfv
      dfsbcq sbcbidv mpan2 anbi12d anbi12d rexbidv elab c1 vq cv cfz co cA vc
      cv c1 cmin co vj cv cfv wf c1 vq cv c1 caddc co cfz co cA vc cv c1 cmin
      co c1 caddc co vj cv cfv wf wa vv cv vc cv c1 cmin co c1 caddc co vj cv
      cfv cfv vv cv vc cv c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral
      wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co
      wsbc wa wa c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf
      wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1
      caddc co wsbc wi vq cn vq cv cn wcel c1 vq cv cfz co cA vc cv c1 cmin co
      vj cv cfv wf vv cv vc cv c1 cmin co c1 caddc co vj cv cfv cfv vv cv vc cv
      c1 cmin co vj cv cfv cfv wceq vv c1 vq cv cfz co wral wps vg vc cv c1
      cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wa c1 vc cv
      c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv c1 cmin
      co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi c1
      vq cv c1 caddc co cfz co cA vc cv c1 cmin co c1 caddc co vj cv cfv wf vq
      cv cn wcel c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv
      c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc c1 vc cv
      c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv wf wps vg vc cv c1 cmin
      co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi vv
      cv vc cv c1 cmin co c1 caddc co vj cv cfv cfv vv cv vc cv c1 cmin co vj
      cv cfv cfv wceq vv c1 vq cv cfz co wral c1 vq cv cfz co cA vc cv c1 cmin
      co vj cv cfv wf vq cv cn wcel wps vg vc cv c1 cmin co c1 caddc co vj cv
      cfv wsbc vn vq cv c1 caddc co wsbc c1 vc cv c1 cmin co cfz co cA vc cv c1
      cmin co vj cv cfv wf wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc
      vn vc cv c1 cmin co c1 caddc co wsbc wi c1 vq cv cfz co cA vc cv c1 cmin
      co vj cv cfv wf vq cv cn wcel wps vg vc cv c1 cmin co c1 caddc co vj cv
      cfv wsbc vn vq cv c1 caddc co wsbc wa c1 vc cv c1 cmin co cfz co cA vc cv
      c1 cmin co vj cv cfv wf wps vg vc cv c1 cmin co c1 caddc co vj cv cfv
      wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi c1 vq cv cfz co cA vc cv c1
      cmin co vj cv cfv wf c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv
      cfv wf vq cv cn wcel wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc
      vn vq cv c1 caddc co wsbc wa wps vg vc cv c1 cmin co c1 caddc co vj cv
      cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc c1 vq cv cfz co cA vc cv c1
      cmin co vj cv cfv wf c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv
      cfv wf vq cv cn wcel wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc
      vn vq cv c1 caddc co wsbc wa wps vg vc cv c1 cmin co c1 caddc co vj cv
      cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi c1 vq cv cfz co cA vc cv
      c1 cmin co vj cv cfv wf c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj
      cv cfv wf wa c1 vq cv cfz co c1 vc cv c1 cmin co cfz co wceq vq cv cn
      wcel wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc
      co wsbc wa wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1
      cmin co c1 caddc co wsbc wi vc cv c1 cmin co vj cv cfv c1 vq cv cfz co
      wfn vc cv c1 cmin co vj cv cfv c1 vc cv c1 cmin co cfz co wfn c1 vq cv
      cfz co c1 vc cv c1 cmin co cfz co wceq c1 vq cv cfz co cA vc cv c1 cmin
      co vj cv cfv wf c1 vc cv c1 cmin co cfz co cA vc cv c1 cmin co vj cv cfv
      wf c1 vq cv cfz co c1 vc cv c1 cmin co cfz co vc cv c1 cmin co vj cv cfv
      fndmu c1 vq cv cfz co cA vc cv c1 cmin co vj cv cfv ffn c1 vc cv c1 cmin
      co cfz co cA vc cv c1 cmin co vj cv cfv ffn syl2an c1 vq cv cfz co c1 vc
      cv c1 cmin co cfz co wceq vq cv cn wcel wps vg vc cv c1 cmin co c1 caddc
      co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wps vg vc cv c1 cmin co c1
      caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc vq cv cn
      wcel c1 vq cv cfz co c1 vc cv c1 cmin co cfz co wceq wps vg vc cv c1 cmin
      co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wps vg vc cv c1
      cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc
      wi vq cv cn wcel c1 vq cv cfz co c1 vc cv c1 cmin co cfz co wceq c1 c1
      wceq vq cv vc cv c1 cmin co wceq wa wps vg vc cv c1 cmin co c1 caddc co
      vj cv cfv wsbc vn vq cv c1 caddc co wsbc wps vg vc cv c1 cmin co c1 caddc
      co vj cv cfv wsbc vn vc cv c1 cmin co c1 caddc co wsbc wi vq cv cn wcel
      vq cv c1 cuz cfv wcel c1 vq cv cfz co c1 vc cv c1 cmin co cfz co wceq c1
      c1 wceq vq cv vc cv c1 cmin co wceq wa wb vq cv elnnuz vq cv c1 cuz cfv
      wcel vc cv c1 cmin co cvv wcel c1 vq cv cfz co c1 vc cv c1 cmin co cfz co
      wceq c1 c1 wceq vq cv vc cv c1 cmin co wceq wa wb vc cv c1 cmin oprex cvv
      c1 vc cv c1 cmin co c1 vq cv fzopth mpan2 sylbi vq cv vc cv c1 cmin co
      wceq wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc
      co wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1
      cmin co c1 caddc co wsbc wi c1 c1 wceq vq cv vc cv c1 cmin co wceq wps vg
      vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1 caddc co wsbc wps
      vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vc cv c1 cmin co c1
      caddc co wsbc vq cv vc cv c1 cmin co wceq vq cv c1 caddc co vc cv c1 cmin
      co c1 caddc co wceq wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn
      vq cv c1 caddc co wsbc wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc
      vn vc cv c1 cmin co c1 caddc co wsbc wb vq cv vc cv c1 cmin co c1 caddc
      opreq1 wps vg vc cv c1 cmin co c1 caddc co vj cv cfv wsbc vn vq cv c1
      caddc co vc cv c1 cmin co c1 caddc co dfsbcq syl biimpd adantl syl6bi
      com12 imp3a syl ex com23 imp an1s adantrrl adantrlr r19.23aiva sylbi
      syl6bi impr adantlr adantlr syldan 3adantr2 an1rs mpd wph c1 csn cA vh cv
      wf wph c1 csn cA vh cv wf wa wth wph c1 csn cA vh cv wf wa id adantrr
      sylanl1 syl5cbir imp vc cv cc wcel c1 cc wcel vc cv vc cv c1 cmin co c1
      caddc co wceq vc cv cn wcel vc cv cc wcel c1 cc wcel wa vc cv c1 cmin co
      c1 caddc co vc cv vc cv c1 npcan eqcomd vc cv nncn ax1cn sylancl sylan2
      an1rs jaodan mpdan syl5cbir r19.20dva wps vg va cv cn wcel vb cv va cv va
      cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres wsbc wps vg va
      cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv
      cfz co cres wsbc vn vc cv wsbc vn vc cn wps vg va cv cn wcel vb cv va cv
      va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres wsbc vc
      ax-17 wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb
      copab c1 vc cv cfz co cres wsbc vn vc cv vc visset hbsbc1v vn cv vc cv
      wceq wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb
      copab c1 vn cv cfz co cres wsbc wps vg va cv cn wcel vb cv va cv va cv vj
      cv cfv cfv wceq wa va vb copab c1 vc cv cfz co cres wsbc wps vg va cv cn
      wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv cfz co
      cres wsbc vn vc cv wsbc vn cv vc cv wceq c1 vn cv cfz co c1 vc cv cfz co
      wceq va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1
      vn cv cfz co cres va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa
      va vb copab c1 vc cv cfz co cres wceq wps vg va cv cn wcel vb cv va cv va
      cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres wsbc wps vg va
      cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv
      cfz co cres wsbc wb vn cv vc cv c1 cfz opreq2 c1 vn cv cfz co c1 vc cv
      cfz co va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab
      reseq2 wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb
      copab c1 vn cv cfz co cres va cv cn wcel vb cv va cv va cv vj cv cfv cfv
      wceq wa va vb copab c1 vc cv cfz co cres dfsbcq 3syl wps vg va cv cn wcel
      vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vc cv cfz co cres
      wsbc vn vc cv sbceq1a bitrd cbvral syl6ibr anim2d mpd cn cA vf cv wf
      sdc.wmu vn cn wral wa cn cA va cv cn wcel vb cv va cv va cv vj cv cfv cfv
      wceq wa va vb copab wf wps vg va cv cn wcel vb cv va cv va cv vj cv cfv
      cfv wceq wa va vb copab c1 vn cv cfz co cres wsbc vn cn wral wa vf va cv
      cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab va vb cn va
      cv va cv vj cv cfv cfv nnex opabex2 vf cv va cv cn wcel vb cv va cv va cv
      vj cv cfv cfv wceq wa va vb copab wceq cn cA vf cv wf cn cA va cv cn wcel
      vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab wf sdc.wmu vn cn wral
      wps vg va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab
      c1 vn cv cfz co cres wsbc vn cn wral cn cA vf cv va cv cn wcel vb cv va
      cv va cv vj cv cfv cfv wceq wa va vb copab feq1 vf cv va cv cn wcel vb cv
      va cv va cv vj cv cfv cfv wceq wa va vb copab wceq sdc.wmu wps vg va cv
      cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz
      co cres wsbc vn cn vf cv va cv cn wcel vb cv va cv va cv vj cv cfv cfv
      wceq wa va vb copab wceq wps vg vf cv c1 vn cv cfz co cres wsbc wps vg va
      cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv
      cfz co cres wsbc sdc.wmu vf cv va cv cn wcel vb cv va cv va cv vj cv cfv
      cfv wceq wa va vb copab wceq vf cv c1 vn cv cfz co cres va cv cn wcel vb
      cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres
      wceq wps vg vf cv c1 vn cv cfz co cres wsbc wps vg va cv cn wcel vb cv va
      cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres wsbc wb
      vf cv va cv cn wcel vb cv va cv va cv vj cv cfv cfv wceq wa va vb copab
      c1 vn cv cfz co reseq1 wps vg vf cv c1 vn cv cfz co cres va cv cn wcel vb
      cv va cv va cv vj cv cfv cfv wceq wa va vb copab c1 vn cv cfz co cres
      dfsbcq syl wps sdc.wmu vg vf cv c1 vn cv cfz co cres vf cv cvv wcel vf cv
      c1 vn cv cfz co cres cvv wcel vf visset vf cv c1 vn cv cfz co cvv resexg
      ax-mp sdc.4 sbcie syl5bbr ralbidv anbi12d cla4ev syl ex 19.23adv mpd ex
      19.23adv mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F m n p q s x y z $. $d A m n p q s x y z $. $d R m n p q s x y z $.
    $( Two ways to say that a sequence respects a partial order. $)
    seqpo $p |- ( ( R Po A /\ F : NN --> A ) ->
                      ( A. s e. NN ( F ` s ) R ( F ` ( s + 1 ) ) <-> A. m e. NN
                      A. n e. ( ZZ>= ` ( m + 1 ) ) ( F ` m ) R ( F ` n ) ) ) $=
      cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs
      cn wral vm cv cF cfv vn cv cF cfv cR wbr vn vm cv c1 caddc co cuz cfv
      wral vm cn wral cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc co
      cF cfv cR wbr vs cn wral vm cv cF cfv vn cv cF cfv cR wbr vn vm cv c1
      caddc co cuz cfv wral vm cn wral cA cR wpo cn cA cF wf wa vs cv cF cfv vs
      cv c1 caddc co cF cfv cR wbr vs cn wral wa vm cv cF cfv vn cv cF cfv cR
      wbr vn vm cv c1 caddc co cuz cfv wral vm cn cA cR wpo cn cA cF wf wa vs
      cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel vm cv
      cF cfv vn cv cF cfv cR wbr vn vm cv c1 caddc co cuz cfv wral cA cR wpo cn
      cA cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn wral vm cv
      cn wcel wa wa vm cv cF cfv vn cv cF cfv cR wbr vn vm cv c1 caddc co cuz
      cfv vn cv vm cv c1 caddc co cuz cfv wcel cA cR wpo cn cA cF wf wa vs cv
      cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm
      cv cF cfv vn cv cF cfv cR wbr cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv
      c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm cv cF cfv vp
      cv cF cfv cR wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc
      co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm cv cF cfv vm cv c1
      caddc co cF cfv cR wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1
      caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm cv cF cfv vq cv
      cF cfv cR wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc co
      cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm cv cF cfv vq cv c1 caddc
      co cF cfv cR wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc
      co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm cv cF cfv vn cv cF cfv
      cR wbr wi vp vq vm cv c1 caddc co vn cv vp cv vm cv c1 caddc co wceq vm
      cv cF cfv vp cv cF cfv cR wbr vm cv cF cfv vm cv c1 caddc co cF cfv cR
      wbr cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr
      vs cn wral vm cv cn wcel wa wa vp cv vm cv c1 caddc co wceq vp cv cF cfv
      vm cv c1 caddc co cF cfv vm cv cF cfv cR vp cv vm cv c1 caddc co cF fveq2
      breq2d imbi2d vp cv vq cv wceq vm cv cF cfv vp cv cF cfv cR wbr vm cv cF
      cfv vq cv cF cfv cR wbr cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1
      caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vp cv vq cv wceq vp
      cv cF cfv vq cv cF cfv vm cv cF cfv cR vp cv vq cv cF fveq2 breq2d imbi2d
      vp cv vq cv c1 caddc co wceq vm cv cF cfv vp cv cF cfv cR wbr vm cv cF
      cfv vq cv c1 caddc co cF cfv cR wbr cA cR wpo cn cA cF wf wa vs cv cF cfv
      vs cv c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vp cv vq
      cv c1 caddc co wceq vp cv cF cfv vq cv c1 caddc co cF cfv vm cv cF cfv cR
      vp cv vq cv c1 caddc co cF fveq2 breq2d imbi2d vp cv vn cv wceq vm cv cF
      cfv vp cv cF cfv cR wbr vm cv cF cfv vn cv cF cfv cR wbr cA cR wpo cn cA
      cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn wral vm cv cn
      wcel wa wa vp cv vn cv wceq vp cv cF cfv vn cv cF cfv vm cv cF cfv cR vp
      cv vn cv cF fveq2 breq2d imbi2d cA cR wpo cn cA cF wf wa vs cv cF cfv vs
      cv c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vm cv cF cfv
      vm cv c1 caddc co cF cfv cR wbr wi vm cv c1 caddc co cz wcel vs cv cF cfv
      vs cv c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa vm cv cF cfv
      vm cv c1 caddc co cF cfv cR wbr cA cR wpo cn cA cF wf wa vs cv cF cfv vs
      cv c1 caddc co cF cfv cR wbr vm cv cF cfv vm cv c1 caddc co cF cfv cR wbr
      vs vm cv cn vs cv vm cv wceq vs cv cF cfv vm cv cF cfv vs cv c1 caddc co
      cF cfv vm cv c1 caddc co cF cfv cR vs cv vm cv cF fveq2 vs cv vm cv wceq
      vs cv c1 caddc co vm cv c1 caddc co cF vs cv vm cv c1 caddc opreq1 fveq2d
      breq12d rcla4cva adantl a1i vq cv vm cv c1 caddc co cuz cfv wcel cA cR
      wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn
      wral vm cv cn wcel wa wa vm cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq
      cv c1 caddc co cF cfv cR wbr cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv
      c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel wa wa vq cv vm cv c1
      caddc co cuz cfv wcel vm cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq cv
      c1 caddc co cF cfv cR wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv
      c1 caddc co cF cfv cR wbr vs cn wral vm cv cn wcel vq cv vm cv c1 caddc
      co cuz cfv wcel vm cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq cv c1
      caddc co cF cfv cR wbr wi wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv
      c1 caddc co cF cfv cR wbr vs cn wral wa vm cv cn wcel vq cv vm cv c1
      caddc co cuz cfv wcel vm cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq cv
      c1 caddc co cF cfv cR wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv
      c1 caddc co cF cfv cR wbr vs cn wral wa vm cv cn wcel vq cv cn wcel wa vm
      cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq cv c1 caddc co cF cfv cR
      wbr wi vm cv cn wcel vq cv vm cv c1 caddc co cuz cfv wcel wa cA cR wpo cn
      cA cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn wral wa vm
      cv cn wcel vq cv cn wcel wa vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr
      vm cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq cv c1 caddc co cF cfv cR
      wbr wi cA cR wpo cn cA cF wf wa vs cv cF cfv vs cv c1 caddc co cF cfv cR
      wbr vs cn wral wa vm cv cn wcel vq cv cn wcel wa vq cv cF cfv vq cv c1
      caddc co cF cfv cR wbr vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn
      wral vq cv cn wcel vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr cA cR wpo
      cn cA cF wf wa vm cv cn wcel vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr
      vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr vs vq cv cn vs cv vq cv wceq
      vs cv cF cfv vq cv cF cfv vs cv c1 caddc co cF cfv vq cv c1 caddc co cF
      cfv cR vs cv vq cv cF fveq2 vs cv vq cv wceq vs cv c1 caddc co vq cv c1
      caddc co cF vs cv vq cv c1 caddc opreq1 fveq2d breq12d rcla4cva ad2ant2l
      ex cA cR wpo cn cA cF wf wa vm cv cn wcel vq cv cn wcel wa vq cv cF cfv
      vq cv c1 caddc co cF cfv cR wbr vm cv cF cfv vq cv cF cfv cR wbr vm cv cF
      cfv vq cv c1 caddc co cF cfv cR wbr wi wi wi vs cv cF cfv vs cv c1 caddc
      co cF cfv cR wbr vs cn wral cA cR wpo cn cA cF wf vm cv cn wcel vq cv cn
      wcel wa vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr vm cv cF cfv vq cv
      cF cfv cR wbr vm cv cF cfv vq cv c1 caddc co cF cfv cR wbr wi wi cA cR
      wpo vm cv cF cfv cA wcel vq cv cF cfv cA wcel vq cv c1 caddc co cF cfv cA
      wcel w3a vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr vm cv cF cfv vq cv
      cF cfv cR wbr vm cv cF cfv vq cv c1 caddc co cF cfv cR wbr wi wi cn cA cF
      wf vm cv cn wcel vq cv cn wcel wa wa cA cR wpo vm cv cF cfv cA wcel vq cv
      cF cfv cA wcel vq cv c1 caddc co cF cfv cA wcel w3a vq cv cF cfv vq cv c1
      caddc co cF cfv cR wbr vm cv cF cfv vq cv cF cfv cR wbr vm cv cF cfv vq
      cv c1 caddc co cF cfv cR wbr wi wi cA cR wpo vm cv cF cfv cA wcel vq cv
      cF cfv cA wcel vq cv c1 caddc co cF cfv cA wcel w3a wa vm cv cF cfv vq cv
      cF cfv cR wbr vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr vm cv cF cfv
      vq cv c1 caddc co cF cfv cR wbr cA cR wpo vm cv cF cfv cA wcel vq cv cF
      cfv cA wcel vq cv c1 caddc co cF cfv cA wcel w3a wa vm cv cF cfv vq cv cF
      cfv cR wbr vq cv cF cfv vq cv c1 caddc co cF cfv cR wbr vm cv cF cfv vq
      cv c1 caddc co cF cfv cR wbr cA vm cv cF cfv vq cv cF cfv vq cv c1 caddc
      co cF cfv cR potr exp3a com23 ex cn cA cF wf vm cv cn wcel vq cv cn wcel
      wa wa vm cv cF cfv cA wcel vq cv cF cfv cA wcel vq cv c1 caddc co cF cfv
      cA wcel cn cA cF wf vm cv cn wcel vm cv cF cfv cA wcel vq cv cn wcel cn
      cA vm cv cF ffvelrn adantrr cn cA cF wf vq cv cn wcel vq cv cF cfv cA
      wcel vm cv cn wcel cn cA vq cv cF ffvelrn adantrl cn cA cF wf vq cv cn
      wcel vq cv c1 caddc co cF cfv cA wcel vm cv cn wcel cn cA cF wf vq cv c1
      caddc co cn wcel vq cv c1 caddc co cF cfv cA wcel vq cv cn wcel cn cA vq
      cv c1 caddc co cF ffvelrn vq cv peano2nn sylan2 adantrl 3jca syl5 expdimp
      adantr mpdd vm cv cn wcel vq cv vm cv c1 caddc co cuz cfv wcel vq cv cn
      wcel vm cv cn wcel vm cv c1 caddc co c1 cuz cfv wcel vq cv vm cv c1 caddc
      co cuz cfv wcel vq cv cn wcel wi vm cv cn wcel vm cv c1 caddc co cn wcel
      vm cv c1 caddc co c1 cuz cfv wcel vm cv peano2nn vm cv c1 caddc co elnnuz
      sylib vq cv vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc co c1 cuz cfv
      wcel vq cv cn wcel vq cv vm cv c1 caddc co cuz cfv wcel vm cv c1 caddc co
      c1 cuz cfv wcel wa vq cv c1 cuz cfv wcel vq cv cn wcel vm cv c1 caddc co
      vq cv c1 uztrn vq cv elnnuz sylibr expcom syl imdistani syl5 expdimp
      anasss com12 a2d uzind4 com12 r19.21aiv anassrs r19.21aiva ex vm cv cF
      cfv vn cv cF cfv cR wbr vn vm cv c1 caddc co cuz cfv wral vm cn wral vs
      cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cn vm cv cF cfv vn cv cF cfv
      cR wbr vn vm cv c1 caddc co cuz cfv wral vm cn wral vs cv cn wcel wa vs
      cv cF cfv vn cv cF cfv cR wbr vn vs cv c1 caddc co cuz cfv wral vs cv cn
      wcel wa vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cv cn wcel vm cv
      cF cfv vn cv cF cfv cR wbr vn vm cv c1 caddc co cuz cfv wral vm cn wral
      vs cv cF cfv vn cv cF cfv cR wbr vn vs cv c1 caddc co cuz cfv wral vm cv
      cF cfv vn cv cF cfv cR wbr vn vm cv c1 caddc co cuz cfv wral vs cv cF cfv
      vn cv cF cfv cR wbr vn vs cv c1 caddc co cuz cfv wral vm vs cv cn vm cv
      vs cv wceq vm cv cF cfv vn cv cF cfv cR wbr vs cv cF cfv vn cv cF cfv cR
      wbr vn vm cv c1 caddc co cuz cfv vs cv c1 caddc co cuz cfv vm cv vs cv
      wceq vm cv c1 caddc co vs cv c1 caddc co cuz vm cv vs cv c1 caddc opreq1
      fveq2d vm cv vs cv wceq vm cv cF cfv vs cv cF cfv vn cv cF cfv cR vm cv
      vs cv cF fveq2 breq1d raleq12d rcla4v imdistanri vs cv cF cfv vn cv cF
      cfv cR wbr vn vs cv c1 caddc co cuz cfv wral vs cv c1 caddc co vs cv c1
      caddc co cuz cfv wcel vs cv cF cfv vs cv c1 caddc co cF cfv cR wbr vs cv
      cn wcel vs cv cF cfv vn cv cF cfv cR wbr vs cv cF cfv vs cv c1 caddc co
      cF cfv cR wbr vn vs cv c1 caddc co vs cv c1 caddc co cuz cfv vn cv vs cv
      c1 caddc co wceq vn cv cF cfv vs cv c1 caddc co cF cfv vs cv cF cfv cR vn
      cv vs cv c1 caddc co cF fveq2 breq2d rcla4cva vs cv cn wcel vs cv c1
      caddc co cn wcel vs cv c1 caddc co cz wcel vs cv c1 caddc co vs cv c1
      caddc co cuz cfv wcel vs cv peano2nn vs cv c1 caddc co nnz vs cv c1 caddc
      co uzid 3syl sylan2 syl r19.21aiva impbid1 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F k m n p q $. $d A k m n p q $.
    $( An increasing sequence of natural numbers takes on indefinitely large
       values. $)
    incsequz $p |- ( ( F : NN --> NN /\ A. m e. NN ( F ` m )
                            < ( F ` ( m + 1 ) )
                      /\ A e. NN ) -> E. n e. NN ( F ` n ) e. ( ZZ>= ` A ) ) $=
      cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral cA
      cn wcel vn cv cF cfv cA cuz cfv wcel vn cn wrex cA cn wcel cn cn cF wf vm
      cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa vn cv cF cfv cA
      cuz cfv wcel vn cn wrex cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv
      clt wbr vm cn wral wa vn cv cF cfv vp cv cuz cfv wcel vn cn wrex wi cn cn
      cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa vn cv
      cF cfv c1 cuz cfv wcel vn cn wrex wi cn cn cF wf vm cv cF cfv vm cv c1
      caddc co cF cfv clt wbr vm cn wral wa vn cv cF cfv vq cv cuz cfv wcel vn
      cn wrex wi cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm
      cn wral wa vn cv cF cfv vq cv c1 caddc co cuz cfv wcel vn cn wrex wi cn
      cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa vn
      cv cF cfv cA cuz cfv wcel vn cn wrex wi vp vq cA vp cv c1 wceq vn cv cF
      cfv vp cv cuz cfv wcel vn cn wrex vn cv cF cfv c1 cuz cfv wcel vn cn wrex
      cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa
      vp cv c1 wceq vn cv cF cfv vp cv cuz cfv wcel vn cv cF cfv c1 cuz cfv
      wcel vn cn vp cv c1 wceq vp cv cuz cfv c1 cuz cfv vn cv cF cfv vp cv c1
      cuz fveq2 eleq2d rexbidv imbi2d vp cv vq cv wceq vn cv cF cfv vp cv cuz
      cfv wcel vn cn wrex vn cv cF cfv vq cv cuz cfv wcel vn cn wrex cn cn cF
      wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa vp cv vq
      cv wceq vn cv cF cfv vp cv cuz cfv wcel vn cv cF cfv vq cv cuz cfv wcel
      vn cn vp cv vq cv wceq vp cv cuz cfv vq cv cuz cfv vn cv cF cfv vp cv vq
      cv cuz fveq2 eleq2d rexbidv imbi2d vp cv vq cv c1 caddc co wceq vn cv cF
      cfv vp cv cuz cfv wcel vn cn wrex vn cv cF cfv vq cv c1 caddc co cuz cfv
      wcel vn cn wrex cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr
      vm cn wral wa vp cv vq cv c1 caddc co wceq vn cv cF cfv vp cv cuz cfv
      wcel vn cv cF cfv vq cv c1 caddc co cuz cfv wcel vn cn vp cv vq cv c1
      caddc co wceq vp cv cuz cfv vq cv c1 caddc co cuz cfv vn cv cF cfv vp cv
      vq cv c1 caddc co cuz fveq2 eleq2d rexbidv imbi2d vp cv cA wceq vn cv cF
      cfv vp cv cuz cfv wcel vn cn wrex vn cv cF cfv cA cuz cfv wcel vn cn wrex
      cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa
      vp cv cA wceq vn cv cF cfv vp cv cuz cfv wcel vn cv cF cfv cA cuz cfv
      wcel vn cn vp cv cA wceq vp cv cuz cfv cA cuz cfv vn cv cF cfv vp cv cA
      cuz fveq2 eleq2d rexbidv imbi2d cn cn cF wf vn cv cF cfv c1 cuz cfv wcel
      vn cn wrex vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral cn c0
      wne vn cv cF cfv c1 cuz cfv wcel vn cn wral vn cv cF cfv c1 cuz cfv wcel
      vn cn wrex cn cn cF wf vn cv cF cfv c1 cuz cfv wcel vn cn r19.2z c1 cn
      wcel cn c0 wne 1nn cn c1 ne0i ax-mp cn cn cF wf vn cv cF cfv c1 cuz cfv
      wcel vn cn cn cn cF wf vn cv cn wcel wa vn cv cF cfv cn wcel vn cv cF cfv
      c1 cuz cfv wcel cn cn vn cv cF ffvelrn vn cv cF cfv elnnuz sylib
      r19.21aiva sylancr adantr vq cv cn wcel cn cn cF wf vm cv cF cfv vm cv c1
      caddc co cF cfv clt wbr vm cn wral wa vn cv cF cfv vq cv cuz cfv wcel vn
      cn wrex vn cv cF cfv vq cv c1 caddc co cuz cfv wcel vn cn wrex vq cv cn
      wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral
      wa vn cv cF cfv vq cv cuz cfv wcel vn cn wrex vn cv cF cfv vq cv c1 caddc
      co cuz cfv wcel vn cn wrex wi vq cv cn wcel cn cn cF wf vm cv cF cfv vm
      cv c1 caddc co cF cfv clt wbr vm cn wral wa wa vn cv cF cfv vq cv cuz cfv
      wcel vn cn wrex vk cv cF cfv vq cv c1 caddc co cuz cfv wcel vk cn wrex vn
      cv cF cfv vq cv c1 caddc co cuz cfv wcel vn cn wrex vq cv cn wcel cn cn
      cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa wa vn
      cv cF cfv vq cv cuz cfv wcel vk cv cF cfv vq cv c1 caddc co cuz cfv wcel
      vk cn wrex vn cn vq cv cn wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co
      cF cfv clt wbr vm cn wral wa wa vn cv cn wcel wa vn cv cF cfv vq cv cuz
      cfv wcel vn cv c1 caddc co cn wcel vn cv c1 caddc co cF cfv vq cv c1
      caddc co cuz cfv wcel wa vk cv cF cfv vq cv c1 caddc co cuz cfv wcel vk
      cn wrex vq cv cn wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv
      clt wbr vm cn wral wa wa vn cv cn wcel wa vn cv cF cfv vq cv cuz cfv wcel
      vn cv c1 caddc co cF cfv vq cv c1 caddc co cuz cfv wcel vn cv c1 caddc co
      cn wcel vq cv cn wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv
      clt wbr vm cn wral wa wa vn cv cn wcel wa vq cv vn cv cF cfv cle wbr vq
      cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr vn cv cF cfv vq cv cuz
      cfv wcel vn cv c1 caddc co cF cfv vq cv c1 caddc co cuz cfv wcel vq cv cn
      wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral
      wa wa vn cv cn wcel wa vq cv vn cv cF cfv cle wbr vq cv c1 caddc co vn cv
      cF cfv c1 caddc co cle wbr vq cv c1 caddc co vn cv c1 caddc co cF cfv cle
      wbr vq cv cr wcel vn cv cF cfv cr wcel c1 cr wcel vq cv vn cv cF cfv cle
      wbr vq cv c1 caddc co vn cv cF cfv c1 caddc co cle wbr wb vq cv cn wcel
      cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa
      wa vn cv cn wcel wa vq cv vn cv cF cfv c1 leadd1 vq cv cn wcel vq cv cr
      wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral
      wa vn cv cn wcel vq cv nnre ad2antrr cn cn cF wf vm cv cF cfv vm cv c1
      caddc co cF cfv clt wbr vm cn wral wa vn cv cn wcel vn cv cF cfv cr wcel
      vq cv cn wcel cn cn cF wf vn cv cn wcel vn cv cF cfv cr wcel vm cv cF cfv
      vm cv c1 caddc co cF cfv clt wbr vm cn wral cn cn cF wf vn cv cn wcel wa
      vn cv cF cfv cn wcel vn cv cF cfv cr wcel cn cn vn cv cF ffvelrn vn cv cF
      cfv nnre syl adantlr adantll c1 cr wcel vq cv cn wcel cn cn cF wf vm cv
      cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa wa vn cv cn wcel wa
      1re a1i syl3anc vq cv cn wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co
      cF cfv clt wbr vm cn wral wa wa vn cv cn wcel wa vq cv c1 caddc co vn cv
      cF cfv c1 caddc co cle wbr vn cv cF cfv c1 caddc co vn cv c1 caddc co cF
      cfv cle wbr vq cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr cn cn cF
      wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa vn cv cn
      wcel vn cv cF cfv c1 caddc co vn cv c1 caddc co cF cfv cle wbr vq cv cn
      wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral
      vn cv cn wcel vn cv cF cfv c1 caddc co vn cv c1 caddc co cF cfv cle wbr
      cn cn cF wf vn cv cn wcel vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr
      vm cn wral vn cv cF cfv c1 caddc co vn cv c1 caddc co cF cfv cle wbr cn
      cn cF wf vn cv cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv clt wbr wa
      vn cv cF cfv c1 caddc co vn cv c1 caddc co cF cfv cle wbr vn cv cn wcel
      vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa cn cn cF wf
      vn cv cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv clt wbr vn cv cF cfv
      c1 caddc co vn cv c1 caddc co cF cfv cle wbr cn cn cF wf vn cv cn wcel wa
      vn cv cF cfv vn cv c1 caddc co cF cfv clt wbr vn cv cF cfv c1 caddc co vn
      cv c1 caddc co cF cfv cle wbr vn cv cF cfv cn wcel vn cv c1 caddc co cF
      cfv cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv clt wbr vn cv cF cfv c1
      caddc co vn cv c1 caddc co cF cfv cle wbr wb cn cn cF wf vn cv cn wcel wa
      vn cv cF cfv vn cv c1 caddc co cF cfv nnltp1le cn cn vn cv cF ffvelrn cn
      cn cF wf vn cv c1 caddc co cn wcel vn cv c1 caddc co cF cfv cn wcel vn cv
      cn wcel cn cn vn cv c1 caddc co cF ffvelrn vn cv peano2nn sylan2 sylanc
      biimpa anasss vn cv cn wcel vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr
      vm cn wral vn cv cF cfv vn cv c1 caddc co cF cfv clt wbr vm cv cF cfv vm
      cv c1 caddc co cF cfv clt wbr vn cv cF cfv vn cv c1 caddc co cF cfv clt
      wbr vm vn cv cn vm cv vn cv wceq vm cv cF cfv vn cv cF cfv vm cv c1 caddc
      co cF cfv vn cv c1 caddc co cF cfv clt vm cv vn cv cF fveq2 vm cv vn cv
      wceq vm cv c1 caddc co vn cv c1 caddc co cF vm cv vn cv c1 caddc opreq1
      fveq2d breq12d rcla4v imdistani sylan2 ancom2s anassrs adantll vq cv cn
      wcel cn cn cF wf vn cv cn wcel vq cv c1 caddc co vn cv cF cfv c1 caddc co
      cle wbr vn cv cF cfv c1 caddc co vn cv c1 caddc co cF cfv cle wbr wa vq
      cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr wi vm cv cF cfv vm cv c1
      caddc co cF cfv clt wbr vm cn wral vq cv c1 caddc co cr wcel vn cv cF cfv
      c1 caddc co cr wcel vn cv c1 caddc co cF cfv cr wcel vq cv c1 caddc co vn
      cv cF cfv c1 caddc co cle wbr vn cv cF cfv c1 caddc co vn cv c1 caddc co
      cF cfv cle wbr wa vq cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr wi
      vq cv cn wcel cn cn cF wf wa vn cv cn wcel wa vq cv c1 caddc co vn cv cF
      cfv c1 caddc co vn cv c1 caddc co cF cfv letr vq cv cn wcel vq cv c1
      caddc co cr wcel cn cn cF wf vn cv cn wcel vq cv cn wcel vq cv cr wcel vq
      cv c1 caddc co cr wcel vq cv nnre vq cv peano2re syl ad2antrr cn cn cF wf
      vn cv cn wcel vn cv cF cfv c1 caddc co cr wcel vq cv cn wcel cn cn cF wf
      vn cv cn wcel wa vn cv cF cfv cn wcel vn cv cF cfv c1 caddc co cn wcel vn
      cv cF cfv c1 caddc co cr wcel cn cn vn cv cF ffvelrn vn cv cF cfv
      peano2nn vn cv cF cfv c1 caddc co nnre 3syl adantll cn cn cF wf vn cv cn
      wcel vn cv c1 caddc co cF cfv cr wcel vq cv cn wcel cn cn cF wf vn cv c1
      caddc co cn wcel vn cv c1 caddc co cF cfv cr wcel vn cv cn wcel cn cn cF
      wf vn cv c1 caddc co cn wcel wa vn cv c1 caddc co cF cfv cn wcel vn cv c1
      caddc co cF cfv cr wcel cn cn vn cv c1 caddc co cF ffvelrn vn cv c1 caddc
      co cF cfv nnre syl vn cv peano2nn sylan2 adantll syl3anc adantlrr mpan2d
      sylbid vq cv cn wcel cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv
      clt wbr vm cn wral wa vn cv cn wcel vn cv cF cfv vq cv cuz cfv wcel vq cv
      vn cv cF cfv cle wbr wb vq cv cn wcel cn cn cF wf vn cv cn wcel vn cv cF
      cfv vq cv cuz cfv wcel vq cv vn cv cF cfv cle wbr wb vm cv cF cfv vm cv
      c1 caddc co cF cfv clt wbr vm cn wral vq cv cz wcel vn cv cF cfv cz wcel
      vn cv cF cfv vq cv cuz cfv wcel vq cv vn cv cF cfv cle wbr wb vq cv cn
      wcel cn cn cF wf vn cv cn wcel wa vq cv vn cv cF cfv eluz vq cv nnz cn cn
      cF wf vn cv cn wcel wa vn cv cF cfv cn wcel vn cv cF cfv cz wcel cn cn vn
      cv cF ffvelrn vn cv cF cfv nnz syl syl2an adantrlr anassrs vq cv cn wcel
      cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa
      vn cv cn wcel vn cv c1 caddc co cF cfv vq cv c1 caddc co cuz cfv wcel vq
      cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr wb vq cv cn wcel cn cn cF
      wf vn cv cn wcel vn cv c1 caddc co cF cfv vq cv c1 caddc co cuz cfv wcel
      vq cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr wb vm cv cF cfv vm cv
      c1 caddc co cF cfv clt wbr vm cn wral vq cv c1 caddc co cz wcel vn cv c1
      caddc co cF cfv cz wcel vn cv c1 caddc co cF cfv vq cv c1 caddc co cuz
      cfv wcel vq cv c1 caddc co vn cv c1 caddc co cF cfv cle wbr wb vq cv cn
      wcel cn cn cF wf vn cv cn wcel wa vq cv c1 caddc co vn cv c1 caddc co cF
      cfv eluz vq cv cn wcel vq cv vq cv nnz peano2zdi cn cn cF wf vn cv c1
      caddc co cn wcel vn cv c1 caddc co cF cfv cz wcel vn cv cn wcel cn cn cF
      wf vn cv c1 caddc co cn wcel wa vn cv c1 caddc co cF cfv cn wcel vn cv c1
      caddc co cF cfv cz wcel cn cn vn cv c1 caddc co cF ffvelrn vn cv c1 caddc
      co cF cfv nnz syl vn cv peano2nn sylan2 syl2an adantrlr anassrs 3imtr4d
      vn cv cn wcel vn cv c1 caddc co cn wcel vq cv cn wcel cn cn cF wf vm cv
      cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral wa wa vn cv peano2nn
      adantl jctild vk cv cF cfv vq cv c1 caddc co cuz cfv wcel vn cv c1 caddc
      co cF cfv vq cv c1 caddc co cuz cfv wcel vk vn cv c1 caddc co cn vk cv vn
      cv c1 caddc co wceq vk cv cF cfv vn cv c1 caddc co cF cfv vq cv c1 caddc
      co cuz cfv vk cv vn cv c1 caddc co cF fveq2 eleq1d rcla4ev syl6
      r19.23adva vk cv cF cfv vq cv c1 caddc co cuz cfv wcel vn cv cF cfv vq cv
      c1 caddc co cuz cfv wcel vk vn cn vk cv vn cv wceq vk cv cF cfv vn cv cF
      cfv vq cv c1 caddc co cuz cfv vk cv vn cv cF fveq2 eleq1d cbvrexv syl6ib
      ex a2d nnind com12 3impia $.
      $( [2-Sep-2009] $)

    $( An increasing sequence of natural numbers takes on indefinitely large
       values. $)
    incsequz2 $p |- ( ( F : NN --> NN /\ A. m e. NN ( F ` m )
         < ( F ` ( m + 1 ) ) /\ A e. NN )
            -> E. n e. NN A. k e. ( ZZ>= ` n ) ( F ` k ) e. ( ZZ>= ` A ) ) $=
      cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral cA
      cn wcel w3a vn cv cF cfv cA cuz cfv wcel vn cn wrex vk cv cF cfv cA cuz
      cfv wcel vk vn cv cuz cfv wral vn cn wrex cA vm vn cF incsequz cn cn cF
      wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr vm cn wral cA cn wcel
      w3a vn cv cF cfv cA cuz cfv wcel vk cv cF cfv cA cuz cfv wcel vk vn cv
      cuz cfv wral vn cn cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt
      wbr vm cn wral cA cn wcel vn cv cn wcel vn cv cF cfv cA cuz cfv wcel vk
      cv cF cfv cA cuz cfv wcel vk vn cv cuz cfv wral wi wi cn cn cF wf vp cv
      cF cfv vq cv cF cfv clt wbr vq vp cv c1 caddc co cuz cfv wral vp cn wral
      wa cA cn wcel vn cv cn wcel vn cv cF cfv cA cuz cfv wcel vk cv cF cfv cA
      cuz cfv wcel vk vn cv cuz cfv wral wi wi cn cn cF wf vm cv cF cfv vm cv
      c1 caddc co cF cfv clt wbr vm cn wral wa cn cn cF wf vp cv cF cfv vq cv
      cF cfv clt wbr vq vp cv c1 caddc co cuz cfv wral vp cn wral wa cA cn wcel
      wa vn cv cn wcel vn cv cF cfv cA cuz cfv wcel vk cv cF cfv cA cuz cfv
      wcel vk vn cv cuz cfv wral wi cn cn cF wf vp cv cF cfv vq cv cF cfv clt
      wbr vq vp cv c1 caddc co cuz cfv wral vp cn wral wa cA cn wcel wa vn cv
      cn wcel wa vn cv cF cfv cA cuz cfv wcel vk cv cF cfv cA cuz cfv wcel vk
      vn cv cuz cfv cn cn cF wf vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1
      caddc co cuz cfv wral vp cn wral wa vn cv cn wcel vk cv vn cv cuz cfv
      wcel vn cv cF cfv cA cuz cfv wcel vk cv cF cfv cA cuz cfv wcel wi cA cn
      wcel cn cn cF wf vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1 caddc co
      cuz cfv wral vp cn wral wa vn cv cn wcel wa vk cv vn cv cuz cfv wcel wa
      vk cv cF cfv vn cv cF cfv cuz cfv wcel vn cv cF cfv cA cuz cfv wcel vk cv
      cF cfv cA cuz cfv wcel wi cn cn cF wf vp cv cF cfv vq cv cF cfv clt wbr
      vq vp cv c1 caddc co cuz cfv wral vp cn wral wa vn cv cn wcel wa vk cv vn
      cv wceq vk cv vn cv c1 caddc co cuz cfv wcel wo vk cv cF cfv vn cv cF cfv
      cuz cfv wcel vk cv vn cv cuz cfv wcel cn cn cF wf vp cv cF cfv vq cv cF
      cfv clt wbr vq vp cv c1 caddc co cuz cfv wral vp cn wral wa vn cv cn wcel
      wa vk cv vn cv wceq vk cv cF cfv vn cv cF cfv cuz cfv wcel vk cv vn cv c1
      caddc co cuz cfv wcel cn cn cF wf vn cv cn wcel vk cv vn cv wceq vk cv cF
      cfv vn cv cF cfv cuz cfv wcel vp cv cF cfv vq cv cF cfv clt wbr vq vp cv
      c1 caddc co cuz cfv wral vp cn wral cn cn cF wf vn cv cn wcel wa vk cv vn
      cv wceq wa vk cv cF cfv vn cv cF cfv vn cv cF cfv cuz cfv vk cv vn cv
      wceq vk cv cF cfv vn cv cF cfv wceq cn cn cF wf vn cv cn wcel wa vk cv vn
      cv cF fveq2 adantl cn cn cF wf vn cv cn wcel wa vn cv cF cfv vn cv cF cfv
      cuz cfv wcel vk cv vn cv wceq cn cn cF wf vn cv cn wcel wa vn cv cF cfv
      cn wcel vn cv cF cfv cz wcel vn cv cF cfv vn cv cF cfv cuz cfv wcel cn cn
      vn cv cF ffvelrn vn cv cF cfv nnz vn cv cF cfv uzid 3syl adantr eqeltrd
      adantllr cn cn cF wf vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1 caddc
      co cuz cfv wral vp cn wral wa vn cv cn wcel wa vk cv vn cv c1 caddc co
      cuz cfv wcel wa vn cv cF cfv vk cv cF cfv clt wbr vk cv cF cfv vn cv cF
      cfv cuz cfv wcel vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1 caddc co
      cuz cfv wral vp cn wral vn cv cn wcel vk cv vn cv c1 caddc co cuz cfv
      wcel vn cv cF cfv vk cv cF cfv clt wbr cn cn cF wf vn cv cF cfv vq cv cF
      cfv clt wbr vq vn cv c1 caddc co cuz cfv wral vk cv vn cv c1 caddc co cuz
      cfv wcel vn cv cF cfv vk cv cF cfv clt wbr vp cv cF cfv vq cv cF cfv clt
      wbr vq vp cv c1 caddc co cuz cfv wral vp cn wral vn cv cn wcel wa vn cv
      cF cfv vq cv cF cfv clt wbr vn cv cF cfv vk cv cF cfv clt wbr vq vk cv vn
      cv c1 caddc co cuz cfv vq cv vk cv wceq vq cv cF cfv vk cv cF cfv vn cv
      cF cfv clt vq cv vk cv cF fveq2 breq2d rcla4cva vp cv cF cfv vq cv cF cfv
      clt wbr vq vp cv c1 caddc co cuz cfv wral vn cv cF cfv vq cv cF cfv clt
      wbr vq vn cv c1 caddc co cuz cfv wral vp vn cv cn vp cv vn cv wceq vp cv
      cF cfv vq cv cF cfv clt wbr vn cv cF cfv vq cv cF cfv clt wbr vq vp cv c1
      caddc co cuz cfv vn cv c1 caddc co cuz cfv vp cv vn cv wceq vp cv c1
      caddc co vn cv c1 caddc co cuz vp cv vn cv c1 caddc opreq1 fveq2d vp cv
      vn cv wceq vp cv cF cfv vn cv cF cfv vq cv cF cfv clt vp cv vn cv cF
      fveq2 breq1d raleq12d rcla4cva sylan adantlll cn cn cF wf vn cv cn wcel
      vk cv vn cv c1 caddc co cuz cfv wcel vn cv cF cfv vk cv cF cfv clt wbr vk
      cv cF cfv vn cv cF cfv cuz cfv wcel wi vp cv cF cfv vq cv cF cfv clt wbr
      vq vp cv c1 caddc co cuz cfv wral vp cn wral vn cv cF cfv cz wcel vk cv
      cF cfv cz wcel vn cv cF cfv vk cv cF cfv clt wbr vk cv cF cfv vn cv cF
      cfv cuz cfv wcel wi cn cn cF wf vn cv cn wcel wa vk cv vn cv c1 caddc co
      cuz cfv wcel wa vn cv cF cfv cz wcel vk cv cF cfv cz wcel wa vn cv cF cfv
      vk cv cF cfv clt wbr vn cv cF cfv vk cv cF cfv cle wbr vk cv cF cfv vn cv
      cF cfv cuz cfv wcel vn cv cF cfv cr wcel vk cv cF cfv cr wcel vn cv cF
      cfv vk cv cF cfv clt wbr vn cv cF cfv vk cv cF cfv cle wbr wi vn cv cF
      cfv cz wcel vk cv cF cfv cz wcel vn cv cF cfv vk cv cF cfv ltle vn cv cF
      cfv zre vk cv cF cfv zre syl2an vn cv cF cfv vk cv cF cfv eluz sylibrd cn
      cn cF wf vn cv cn wcel wa vn cv cF cfv cz wcel vk cv vn cv c1 caddc co
      cuz cfv wcel cn cn cF wf vn cv cn wcel wa vn cv cF cfv cn wcel vn cv cF
      cfv cz wcel cn cn vn cv cF ffvelrn vn cv cF cfv nnz syl adantr cn cn cF
      wf vn cv cn wcel vk cv vn cv c1 caddc co cuz cfv wcel vk cv cF cfv cz
      wcel cn cn cF wf vk cv cn wcel vk cv cF cfv cz wcel vn cv cn wcel vk cv
      vn cv c1 caddc co cuz cfv wcel wa cn cn cF wf vk cv cn wcel wa vk cv cF
      cfv cn wcel vk cv cF cfv cz wcel cn cn vk cv cF ffvelrn vk cv cF cfv nnz
      syl vn cv c1 caddc co c1 cuz cfv wcel vk cv vn cv c1 caddc co cuz cfv
      wcel vk cv cn wcel vn cv cn wcel vn cv c1 caddc co c1 cuz cfv wcel vk cv
      vn cv c1 caddc co cuz cfv wcel wa vk cv c1 cuz cfv wcel vk cv cn wcel vk
      cv vn cv c1 caddc co cuz cfv wcel vn cv c1 caddc co c1 cuz cfv wcel vk cv
      c1 cuz cfv wcel vn cv c1 caddc co vk cv c1 uztrn ancoms vk cv elnnuz
      sylibr vn cv cn wcel vn cv c1 caddc co cn wcel vn cv c1 caddc co c1 cuz
      cfv wcel vn cv peano2nn vn cv c1 caddc co elnnuz sylib sylan sylan2
      anassrs sylanc adantllr mpd jaodan vn cv vk cv uzp1 sylan2 vk cv cF cfv
      vn cv cF cfv cuz cfv wcel vn cv cF cfv cA cuz cfv wcel vk cv cF cfv cA
      cuz cfv wcel vn cv cF cfv vk cv cF cfv cA uztrn ex syl adantllr
      r19.21adva ex cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr
      vm cn wral vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1 caddc co cuz cfv
      wral vp cn wral cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF cfv clt wbr
      vm cn wral vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1 caddc co cuz cfv
      wral vp cn wral cn clt wpo cn cn cF wf vm cv cF cfv vm cv c1 caddc co cF
      cfv clt wbr vm cn wral vp cv cF cfv vq cv cF cfv clt wbr vq vp cv c1
      caddc co cuz cfv wral vp cn wral wb cn cr wss cr clt wpo cn clt wpo
      nnssre cr clt wor cr clt wpo ltso cr clt sopo ax-mp cn cr clt poss mp2 cn
      clt vp vq cF vm seqpo mpan biimpd imdistani sylan 3impa r19.22dv mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x $. $d B x $.
    $( A bounded above set of natural numbers is finite. $)
    nnubfi $p |- ( ( A C_ NN /\ B e. NN ) -> { x e. A | x < B } e. Fin ) $=
      cc0 cB cfz co cfn wcel vx cv cB clt wbr vx cA crab cc0 cB cfz co wss vx
      cv cB clt wbr vx cA crab cfn wcel cA cn wss cB cn wcel wa cc0 cB cfz co
      vx cv cB clt wbr vx cA crab ssfi cA cn wss cB cn wcel wa cB cc0 cuz cfv
      wcel cc0 cB cfz co cfn wcel cB cn wcel cB cc0 cuz cfv wcel cA cn wss cB
      cn wcel cB cn0 wcel cB cc0 cuz cfv wcel cB nnnn0 cB elnn0uz sylib adantl
      cc0 cB fzfi syl cA cn wss cB cn wcel wa vx cv cB clt wbr vx cv cc0 cB cfz
      co wcel wi vx cA wral vx cv cB clt wbr vx cA crab cc0 cB cfz co wss cA cn
      wss cB cn wcel wa vx cv cB clt wbr vx cv cc0 cB cfz co wcel wi vx cA cA
      cn wss cB cn wcel wa vx cv cA wcel wa vx cv cB clt wbr vx cv cc0 cB cfz
      co wcel cA cn wss cB cn wcel wa vx cv cA wcel wa vx cv cB clt wbr wa vx
      cv cc0 cB cfz co wcel vx cv cn0 wcel cB cn0 wcel vx cv cB cle wbr w3a cA
      cn wss cB cn wcel wa vx cv cA wcel wa vx cv cB clt wbr wa vx cv cn0 wcel
      cB cn0 wcel vx cv cB cle wbr cA cn wss cB cn wcel wa vx cv cA wcel wa vx
      cv cn0 wcel vx cv cB clt wbr cA cn wss vx cv cA wcel vx cv cn0 wcel cB cn
      wcel cA cn wss vx cv cA wcel wa vx cv cn wcel vx cv cn0 wcel cA cn vx cv
      ssel2 vx cv nnnn0 syl adantlr adantr cA cn wss cB cn wcel wa cB cn0 wcel
      vx cv cA wcel vx cv cB clt wbr cB cn wcel cB cn0 wcel cA cn wss cB nnnn0
      adantl ad2antrr cA cn wss cB cn wcel wa vx cv cA wcel wa vx cv cB clt wbr
      vx cv cB cle wbr vx cv cr wcel cB cr wcel vx cv cB clt wbr vx cv cB cle
      wbr wi cA cn wss cB cn wcel wa vx cv cA wcel wa vx cv cB ltle cA cn wss
      vx cv cA wcel vx cv cr wcel cB cn wcel cA cn wss vx cv cA wcel wa vx cv
      cn wcel vx cv cr wcel cA cn vx cv ssel2 vx cv nnre syl adantlr cB cn wcel
      cB cr wcel cA cn wss vx cv cA wcel cB nnre ad2antlr sylanc imp 3jca cA cn
      wss cB cn wcel wa vx cv cc0 cB cfz co wcel vx cv cn0 wcel cB cn0 wcel vx
      cv cB cle wbr w3a wb vx cv cA wcel vx cv cB clt wbr cB cn wcel vx cv cc0
      cB cfz co wcel vx cv cn0 wcel cB cn0 wcel vx cv cB cle wbr w3a wb cA cn
      wss cn vx cv cB elfz2nn0 adantl ad2antrr mpbird ex r19.21aiva vx cv cB
      clt wbr vx cA cc0 cB cfz co rabss sylibr sylanc $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d B x y $.
    $( An infinite set of natural numbers is unbounded above. $)
    nninfnub $p |- ( ( A C_ NN /\ -. A e. Fin /\ B e. NN )
                                  -> { x e. A | B < x } =/= (/) ) $=
      cA cn wss cA cfn wcel wn cB cn wcel cB vx cv clt wbr vx cA crab c0 wne cA
      cn wss cB cn wcel cA cfn wcel wn cB vx cv clt wbr vx cA crab c0 wne cA cn
      wss cB cn wcel wa cA cfn wcel wn cB vx cv clt wbr vx cA crab c0 wne cA cn
      wss cB cn wcel wa cA cfn wcel cB vx cv clt wbr vx cA crab c0 cA cn wss cB
      cn wcel wa vy cv cB vx cv clt wbr vx cA crab wcel wn vy wal cA cfn wcel
      cB vx cv clt wbr vx cA crab c0 wceq cA cn wss cB cn wcel wa cB vy cv clt
      wbr wn vy cA wral cA cfn wcel vy cv cB vx cv clt wbr vx cA crab wcel wn
      vy wal cA cn wss cB cn wcel wa cB vy cv clt wbr wn vy cA wral vy cv cB
      cle wbr vy cA wral cA cfn wcel cA cn wss cB cn wcel wa cB vy cv clt wbr
      wn vy cv cB cle wbr vy cA vy cv cr wcel cB cr wcel cB vy cv clt wbr wn vy
      cv cB cle wbr wi cA cn wss cB cn wcel wa vy cv cA wcel wa vy cv cr wcel
      cB cr wcel wa vy cv cB cle wbr cB vy cv clt wbr wn vy cv cB lenlt biimprd
      cA cn wss vy cv cA wcel vy cv cr wcel cB cn wcel cA cn wss vy cv cA wcel
      wa vy cv cn wcel vy cv cr wcel cA cn vy cv ssel2 vy cv nnre syl adantlr
      cB cn wcel cB cr wcel cA cn wss vy cv cA wcel cB nnre ad2antlr sylanc
      r19.20dva cA cn wss cB cn wcel wa vy cv cB cle wbr vy cA wral cA cfn wcel
      cc0 cB cfz co cfn wcel cA cc0 cB cfz co wss cA cfn wcel cA cn wss cB cn
      wcel wa vy cv cB cle wbr vy cA wral wa cc0 cB cfz co cA ssfi cA cn wss cB
      cn wcel wa vy cv cB cle wbr vy cA wral wa cB cc0 cuz cfv wcel cc0 cB cfz
      co cfn wcel cA cn wss cB cn wcel wa cB cc0 cuz cfv wcel vy cv cB cle wbr
      vy cA wral cA cn wss cB cn wcel wa cB cn0 wcel cB cc0 cuz cfv wcel cB cn
      wcel cB cn0 wcel cA cn wss cB nnnn0 adantl cB elnn0uz sylib adantr cc0 cB
      fzfi syl cA cn wss cB cn wcel wa vy cv cB cle wbr vy cA wral wa vy cv cc0
      cB cfz co wcel vy cA wral cA cc0 cB cfz co wss cA cn wss cB cn wcel wa vy
      cv cB cle wbr vy cA wral vy cv cc0 cB cfz co wcel vy cA wral cA cn wss cB
      cn wcel wa vy cv cB cle wbr vy cv cc0 cB cfz co wcel vy cA cA cn wss cB
      cn wcel wa vy cv cA wcel wa vy cv cB cle wbr vy cv cn0 wcel cB cn0 wcel
      vy cv cB cle wbr w3a vy cv cc0 cB cfz co wcel cA cn wss cB cn wcel wa vy
      cv cA wcel wa vy cv cB cle wbr vy cv cn0 wcel cB cn0 wcel vy cv cB cle
      wbr w3a cA cn wss cB cn wcel wa vy cv cA wcel wa vy cv cB cle wbr wa vy
      cv cn0 wcel cB cn0 wcel vy cv cB cle wbr cA cn wss cB cn wcel wa vy cv cA
      wcel wa vy cv cn0 wcel vy cv cB cle wbr cA cn wss vy cv cA wcel vy cv cn0
      wcel cB cn wcel cA cn wss vy cv cA wcel wa vy cv cn wcel vy cv cn0 wcel
      cA cn vy cv ssel2 vy cv nnnn0 syl adantlr adantr cA cn wss cB cn wcel wa
      cB cn0 wcel vy cv cA wcel vy cv cB cle wbr cB cn wcel cB cn0 wcel cA cn
      wss cB nnnn0 adantl ad2antrr cA cn wss cB cn wcel wa vy cv cA wcel wa vy
      cv cB cle wbr pm3.27 3jca ex cB cn wcel vy cv cc0 cB cfz co wcel vy cv
      cn0 wcel cB cn0 wcel vy cv cB cle wbr w3a wb cA cn wss vy cv cA wcel cn
      vy cv cB elfz2nn0 ad2antlr sylibrd r19.20dva imp vy cA cc0 cB cfz co
      dfss3 sylibr sylanc ex syld vy cv cB vx cv clt wbr vx cA crab wcel wn vy
      wal vy cv cA wcel cB vy cv clt wbr wn wi vy wal cB vy cv clt wbr wn vy cA
      wral vy cv cB vx cv clt wbr vx cA crab wcel wn vy cv cA wcel cB vy cv clt
      wbr wn wi vy vy cv cB vx cv clt wbr vx cA crab wcel wn vy cv cA wcel cB
      vy cv clt wbr wn wi vy cv cB vx cv clt wbr vx cA crab wcel wn vy cv cA
      wcel cB vy cv clt wbr wa wn vy cv cA wcel cB vy cv clt wbr wn wi vy cv cB
      vx cv clt wbr vx cA crab wcel vy cv cA wcel cB vy cv clt wbr wa cB vx cv
      clt wbr cB vy cv clt wbr vx vy cv cA vx cv vy cv cB clt breq2 elrab
      notbii vy cv cA wcel cB vy cv clt wbr imnan bitr4i biimpi 19.20i cB vy cv
      clt wbr wn vy cA df-ral sylibr syl5 vy cB vx cv clt wbr vx cA crab eq0
      syl5ib necon3bd imp an1rs 3impa $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k m n $. $d N k m n $. $d A m n $.
    $( A sum of nonnegative numbers is zero iff all terms are zero. $)
    fsum00 $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N ) ( A e. RR
         /\ 0 <_ A ) )
          -> ( sum_ k e. ( M ... N ) A = 0 <-> A. k e. ( M ... N ) A = 0 ) ) $=
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa
      cM cN cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM cN cfz co wral cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cM cN cfz
      co cA vk csu cc0 wceq cA cc0 wceq vk cM cN cfz co wral wi cA cr wcel cc0
      cA cle wbr wa vk cM vm cv cfz co wral cM vm cv cfz co cA vk csu cc0 wceq
      cA cc0 wceq vk cM vm cv cfz co wral wi wi cA cr wcel cc0 cA cle wbr wa vk
      cM cM cfz co wral cM cM cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM cM
      cfz co wral wi wi cA cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co wral cM
      vn cv cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vn cv cfz co wral wi wi
      cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral cM vn cv
      c1 caddc co cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vn cv c1 caddc co
      cfz co wral wi wi cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cM cN
      cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM cN cfz co wral wi wi vm vn cM
      cN vm cv cM wceq cA cr wcel cc0 cA cle wbr wa vk cM vm cv cfz co wral cA
      cr wcel cc0 cA cle wbr wa vk cM cM cfz co wral cM vm cv cfz co cA vk csu
      cc0 wceq cA cc0 wceq vk cM vm cv cfz co wral wi cM cM cfz co cA vk csu
      cc0 wceq cA cc0 wceq vk cM cM cfz co wral wi vm cv cM wceq cA cr wcel cc0
      cA cle wbr wa vk cM vm cv cfz co cM cM cfz co vm cv cM cM cfz opreq2
      raleq1d vm cv cM wceq cM vm cv cfz co cA vk csu cc0 wceq cM cM cfz co cA
      vk csu cc0 wceq cA cc0 wceq vk cM vm cv cfz co wral cA cc0 wceq vk cM cM
      cfz co wral vm cv cM wceq cM vm cv cfz co cA vk csu cM cM cfz co cA vk
      csu cc0 vm cv cM wceq cM vm cv cfz co cM cM cfz co cA vk vm cv cM cM cfz
      opreq2 sumeq1d eqeq1d vm cv cM wceq cA cc0 wceq vk cM vm cv cfz co cM cM
      cfz co vm cv cM cM cfz opreq2 raleq1d imbi12d imbi12d vm cv vn cv wceq cA
      cr wcel cc0 cA cle wbr wa vk cM vm cv cfz co wral cA cr wcel cc0 cA cle
      wbr wa vk cM vn cv cfz co wral cM vm cv cfz co cA vk csu cc0 wceq cA cc0
      wceq vk cM vm cv cfz co wral wi cM vn cv cfz co cA vk csu cc0 wceq cA cc0
      wceq vk cM vn cv cfz co wral wi vm cv vn cv wceq cA cr wcel cc0 cA cle
      wbr wa vk cM vm cv cfz co cM vn cv cfz co vm cv vn cv cM cfz opreq2
      raleq1d vm cv vn cv wceq cM vm cv cfz co cA vk csu cc0 wceq cM vn cv cfz
      co cA vk csu cc0 wceq cA cc0 wceq vk cM vm cv cfz co wral cA cc0 wceq vk
      cM vn cv cfz co wral vm cv vn cv wceq cM vm cv cfz co cA vk csu cM vn cv
      cfz co cA vk csu cc0 vm cv vn cv wceq cM vm cv cfz co cM vn cv cfz co cA
      vk vm cv vn cv cM cfz opreq2 sumeq1d eqeq1d vm cv vn cv wceq cA cc0 wceq
      vk cM vm cv cfz co cM vn cv cfz co vm cv vn cv cM cfz opreq2 raleq1d
      imbi12d imbi12d vm cv vn cv c1 caddc co wceq cA cr wcel cc0 cA cle wbr wa
      vk cM vm cv cfz co wral cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc
      co cfz co wral cM vm cv cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vm cv
      cfz co wral wi cM vn cv c1 caddc co cfz co cA vk csu cc0 wceq cA cc0 wceq
      vk cM vn cv c1 caddc co cfz co wral wi vm cv vn cv c1 caddc co wceq cA cr
      wcel cc0 cA cle wbr wa vk cM vm cv cfz co cM vn cv c1 caddc co cfz co vm
      cv vn cv c1 caddc co cM cfz opreq2 raleq1d vm cv vn cv c1 caddc co wceq
      cM vm cv cfz co cA vk csu cc0 wceq cM vn cv c1 caddc co cfz co cA vk csu
      cc0 wceq cA cc0 wceq vk cM vm cv cfz co wral cA cc0 wceq vk cM vn cv c1
      caddc co cfz co wral vm cv vn cv c1 caddc co wceq cM vm cv cfz co cA vk
      csu cM vn cv c1 caddc co cfz co cA vk csu cc0 vm cv vn cv c1 caddc co
      wceq cM vm cv cfz co cM vn cv c1 caddc co cfz co cA vk vm cv vn cv c1
      caddc co cM cfz opreq2 sumeq1d eqeq1d vm cv vn cv c1 caddc co wceq cA cc0
      wceq vk cM vm cv cfz co cM vn cv c1 caddc co cfz co vm cv vn cv c1 caddc
      co cM cfz opreq2 raleq1d imbi12d imbi12d vm cv cN wceq cA cr wcel cc0 cA
      cle wbr wa vk cM vm cv cfz co wral cA cr wcel cc0 cA cle wbr wa vk cM cN
      cfz co wral cM vm cv cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vm cv
      cfz co wral wi cM cN cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM cN cfz
      co wral wi vm cv cN wceq cA cr wcel cc0 cA cle wbr wa vk cM vm cv cfz co
      cM cN cfz co vm cv cN cM cfz opreq2 raleq1d vm cv cN wceq cM vm cv cfz co
      cA vk csu cc0 wceq cM cN cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vm
      cv cfz co wral cA cc0 wceq vk cM cN cfz co wral vm cv cN wceq cM vm cv
      cfz co cA vk csu cM cN cfz co cA vk csu cc0 vm cv cN wceq cM vm cv cfz co
      cM cN cfz co cA vk vm cv cN cM cfz opreq2 sumeq1d eqeq1d vm cv cN wceq cA
      cc0 wceq vk cM vm cv cfz co cM cN cfz co vm cv cN cM cfz opreq2 raleq1d
      imbi12d imbi12d cM cz wcel cA cr wcel cc0 cA cle wbr wa vk cM cM cfz co
      wral cM cM cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM cM cfz co wral wi
      cM cz wcel cA cr wcel vk cM cM cfz co wral cM cM cfz co cA vk csu cc0
      wceq cA cc0 wceq vk cM cM cfz co wral wi cA cr wcel cc0 cA cle wbr wa vk
      cM cM cfz co wral cM cz wcel cA cr wcel vk cM cM cfz co wral wa cM cM cfz
      co cA vk csu cc0 wceq vk cM cA csb cc0 wceq cA cc0 wceq vk cM cM cfz co
      wral cM cz wcel cA cr wcel vk cM cM cfz co wral wa cM cM cfz co cA vk csu
      vk cM cA csb cc0 cA cr vk cM fsum1s eqeq1d cM cz wcel vk cM cA csb cc0
      wceq cA cc0 wceq vk cM cM cfz co wral wi cA cr wcel vk cM cM cfz co wral
      cM cz wcel vk cM cA csb cc0 wceq cA cc0 wceq vk cM wsbc cA cc0 wceq vk cM
      cM cfz co wral cM cz wcel cA cc0 wceq vk cM wsbc vk cM cA csb cc0 wceq vk
      cM cA cc0 cz sbceq1dig biimprd cA cc0 wceq vk cM fz1sbc sylibrd adantr
      sylbid cA cr wcel cc0 cA cle wbr wa cA cr wcel vk cM cM cfz co cA cr wcel
      cc0 cA cle wbr pm3.26 r19.20si sylan2 ex vn cv cM cuz cfv wcel cA cr wcel
      cc0 cA cle wbr wa vk cM vn cv cfz co wral cM vn cv cfz co cA vk csu cc0
      wceq cA cc0 wceq vk cM vn cv cfz co wral wi wi cA cr wcel cc0 cA cle wbr
      wa vk cM vn cv c1 caddc co cfz co wral cM vn cv cfz co cA vk csu cc0 wceq
      cA cc0 wceq vk cM vn cv cfz co wral wi wi cA cr wcel cc0 cA cle wbr wa vk
      cM vn cv c1 caddc co cfz co wral cM vn cv c1 caddc co cfz co cA vk csu
      cc0 wceq cA cc0 wceq vk cM vn cv c1 caddc co cfz co wral wi wi vn cv cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co
      wral cA cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co wral cM vn cv cfz co
      cA vk csu cc0 wceq cA cc0 wceq vk cM vn cv cfz co wral wi vn cv cM cuz
      cfv wcel cM vn cv cfz co cM vn cv c1 caddc co cfz co wss cA cr wcel cc0
      cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral cA cr wcel cc0 cA cle
      wbr wa vk cM vn cv cfz co wral wi cM cz wcel vn cv cz wcel cM vn cv cfz
      co cM vn cv c1 caddc co cfz co wss vn cv cM cuz cfv wcel cM vn cv fzssp1
      cM vn cv eluzel2 cM vn cv eluzelz sylanc cA cr wcel cc0 cA cle wbr wa vk
      cM vn cv cfz co cM vn cv c1 caddc co cfz co ssralv syl imim1d vn cv cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co
      wral cM vn cv cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vn cv cfz co
      wral wi cM vn cv c1 caddc co cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM
      vn cv c1 caddc co cfz co wral wi vn cv cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM vn cv c1 caddc co cfz co wral cM vn cv cfz co cA vk csu
      cc0 wceq cA cc0 wceq vk cM vn cv cfz co wral wi cM vn cv c1 caddc co cfz
      co cA vk csu cc0 wceq cA cc0 wceq vk cM vn cv c1 caddc co cfz co wral wi
      wi vn cv cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1
      caddc co cfz co wral wa cM vn cv cfz co cA vk csu cc0 wceq cA cc0 wceq vk
      cM vn cv cfz co wral wi cM vn cv cfz co cA vk csu vk vn cv c1 caddc co cA
      csb caddc co cc0 wceq cA cc0 wceq vk cM vn cv c1 caddc co cfz co wral cM
      vn cv c1 caddc co cfz co cA vk csu cc0 wceq vn cv cM cuz cfv wcel cA cr
      wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral wa cM vn cv
      cfz co cA vk csu cc0 wceq cA cc0 wceq vk cM vn cv cfz co wral wi cM vn cv
      cfz co cA vk csu cc0 wceq vk vn cv c1 caddc co cA csb cc0 wceq wa cA cc0
      wceq vk cM vn cv c1 caddc co cfz co wral cM vn cv cfz co cA vk csu vk vn
      cv c1 caddc co cA csb caddc co cc0 wceq cM vn cv cfz co cA vk csu cc0
      wceq cA cc0 wceq vk cM vn cv cfz co wral wi cM vn cv cfz co cA vk csu cc0
      wceq vk vn cv c1 caddc co cA csb cc0 wceq wa cA cc0 wceq vk cM vn cv cfz
      co wral vk vn cv c1 caddc co cA csb cc0 wceq wa vn cv cM cuz cfv wcel cA
      cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral wa cA cc0
      wceq vk cM vn cv c1 caddc co cfz co wral cM vn cv cfz co cA vk csu cc0
      wceq cA cc0 wceq vk cM vn cv cfz co wral vk vn cv c1 caddc co cA csb cc0
      wceq pm3.45 vn cv cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM vn
      cv c1 caddc co cfz co wral wa cA cc0 wceq vk cM vn cv cfz co wral cA cc0
      wceq vk vn cv c1 caddc co vn cv c1 caddc co cfz co wral cA cc0 wceq vk cM
      vn cv c1 caddc co cfz co wral vk vn cv c1 caddc co cA csb cc0 wceq vn cv
      cM cuz cfv wcel cA cc0 wceq vk cM vn cv cfz co wral cA cc0 wceq vk vn cv
      c1 caddc co vn cv c1 caddc co cfz co wral wa cA cc0 wceq vk cM vn cv c1
      caddc co cfz co wral wi cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc
      co cfz co wral vn cv cM cuz cfv wcel cA cc0 wceq vk cM vn cv c1 caddc co
      cfz co wral cA cc0 wceq vk cM vn cv cfz co vn cv c1 caddc co vn cv c1
      caddc co cfz co cun wral cA cc0 wceq vk cM vn cv cfz co wral cA cc0 wceq
      vk vn cv c1 caddc co vn cv c1 caddc co cfz co wral wa vn cv cM cuz cfv
      wcel cA cc0 wceq vk cM vn cv c1 caddc co cfz co cM vn cv cfz co vn cv c1
      caddc co vn cv c1 caddc co cfz co cun vn cv cM cuz cfv wcel cM vn cv c1
      caddc co cfz co cM vn cv cfz co vn cv c1 caddc co csn cun cM vn cv cfz co
      vn cv c1 caddc co vn cv c1 caddc co cfz co cun cM cz wcel vn cv cz wcel
      cM vn cv c1 caddc co cle wbr cM vn cv c1 caddc co cfz co cM vn cv cfz co
      vn cv c1 caddc co csn cun wceq vn cv cM cuz cfv wcel cM vn cv fzsuc cM vn
      cv eluzel2 cM vn cv eluzelz vn cv cM cuz cfv wcel vn cv c1 caddc co cM
      cuz cfv wcel cM vn cv c1 caddc co cle wbr cM vn cv peano2uz cM vn cv c1
      caddc co eluzle syl syl3anc vn cv cM cuz cfv wcel vn cv c1 caddc co csn
      vn cv c1 caddc co vn cv c1 caddc co cfz co cM vn cv cfz co vn cv cM cuz
      cfv wcel vn cv c1 caddc co vn cv c1 caddc co cfz co vn cv c1 caddc co csn
      vn cv cM cuz cfv wcel vn cv cz wcel vn cv c1 caddc co cz wcel vn cv c1
      caddc co vn cv c1 caddc co cfz co vn cv c1 caddc co csn wceq cM vn cv
      eluzelz vn cv peano2z vn cv c1 caddc co fzsn 3syl eqcomd uneq2d eqtrd
      raleq1d cA cc0 wceq vk cM vn cv cfz co vn cv c1 caddc co vn cv c1 caddc
      co cfz co ralun syl5bir adantr vn cv cM cuz cfv wcel vk vn cv c1 caddc co
      cA csb cc0 wceq cA cc0 wceq vk vn cv c1 caddc co vn cv c1 caddc co cfz co
      wral wi cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral
      vn cv cM cuz cfv wcel cA cc0 wceq vk vn cv c1 caddc co vn cv c1 caddc co
      cfz co wral vk vn cv c1 caddc co cA csb cc0 wceq vn cv cM cuz cfv wcel cA
      cc0 wceq vk vn cv c1 caddc co vn cv c1 caddc co cfz co wral cA cc0 wceq
      vk vn cv c1 caddc co wsbc vk vn cv c1 caddc co cA csb cc0 wceq vn cv cM
      cuz cfv wcel vn cv cz wcel vn cv c1 caddc co cz wcel cA cc0 wceq vk vn cv
      c1 caddc co vn cv c1 caddc co cfz co wral cA cc0 wceq vk vn cv c1 caddc
      co wsbc wb cM vn cv eluzelz vn cv peano2z cA cc0 wceq vk vn cv c1 caddc
      co fz1sbc 3syl vn cv c1 caddc co cvv wcel cA cc0 wceq vk vn cv c1 caddc
      co wsbc vk vn cv c1 caddc co cA csb cc0 wceq wb vn cv c1 caddc oprex vk
      vn cv c1 caddc co cA cc0 cvv sbceq1dig ax-mp syl6bb biimprd adantr
      sylan2d syl9r vn cv cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM vn
      cv c1 caddc co cfz co wral wa cM vn cv cfz co cA vk csu vk vn cv c1 caddc
      co cA csb caddc co cc0 wceq cM vn cv cfz co cA vk csu cc0 wceq vk vn cv
      c1 caddc co cA csb cc0 wceq wa cM vn cv cfz co cA vk csu cr wcel cc0 cM
      vn cv cfz co cA vk csu cle wbr vk vn cv c1 caddc co cA csb cr wcel cc0 vk
      vn cv c1 caddc co cA csb cle wbr wa cM vn cv cfz co cA vk csu vk vn cv c1
      caddc co cA csb caddc co cc0 wceq cM vn cv cfz co cA vk csu cc0 wceq vk
      vn cv c1 caddc co cA csb cc0 wceq wa wb vn cv cM cuz cfv wcel cA cr wcel
      cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral wa vn cv cM cuz cfv
      wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral wa
      vn cv cM cuz cfv wcel cA cr wcel vk cM vn cv cfz co wral wa cM vn cv cfz
      co cA vk csu cr wcel vn cv cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa
      vk cM vn cv c1 caddc co cfz co wral cA cr wcel vk cM vn cv cfz co wral vn
      cv cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co
      cfz co wral cA cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co wral cA cr
      wcel vk cM vn cv cfz co wral vn cv cM cuz cfv wcel cM vn cv cfz co cM vn
      cv c1 caddc co cfz co wss cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1
      caddc co cfz co wral cA cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co wral
      wi cM cz wcel vn cv cz wcel cM vn cv cfz co cM vn cv c1 caddc co cfz co
      wss vn cv cM cuz cfv wcel cM vn cv fzssp1 cM vn cv eluzel2 cM vn cv
      eluzelz sylanc cA cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co cM vn cv
      c1 caddc co cfz co ssralv syl cA cr wcel cc0 cA cle wbr wa cA cr wcel vk
      cM vn cv cfz co cA cr wcel cc0 cA cle wbr pm3.26 r19.20si syl6 imdistani
      cA vk cM vn cv fsumrecl syl vn cv cM cuz cfv wcel cA cr wcel cc0 cA cle
      wbr wa vk cM vn cv c1 caddc co cfz co wral wa vn cv cM cuz cfv wcel cA cr
      wcel cc0 cA cle wbr wa vk cM vn cv cfz co wral wa cc0 cM vn cv cfz co cA
      vk csu cle wbr vn cv cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM
      vn cv c1 caddc co cfz co wral cA cr wcel cc0 cA cle wbr wa vk cM vn cv
      cfz co wral vn cv cM cuz cfv wcel cM vn cv cfz co cM vn cv c1 caddc co
      cfz co wss cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co
      wral cA cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co wral wi cM cz wcel
      vn cv cz wcel cM vn cv cfz co cM vn cv c1 caddc co cfz co wss vn cv cM
      cuz cfv wcel cM vn cv fzssp1 cM vn cv eluzel2 cM vn cv eluzelz sylanc cA
      cr wcel cc0 cA cle wbr wa vk cM vn cv cfz co cM vn cv c1 caddc co cfz co
      ssralv syl imdistani cA vk cM vn cv fsumcmp0 syl vn cv c1 caddc co cM vn
      cv c1 caddc co cfz co wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1
      caddc co cfz co wral vk vn cv c1 caddc co cA csb cr wcel cc0 vk vn cv c1
      caddc co cA csb cle wbr wa vn cv cM cuz cfv wcel vn cv c1 caddc co cM vn
      cv c1 caddc co cfz co wcel cA cr wcel cc0 cA cle wbr wa vk cM vn cv c1
      caddc co cfz co wral wa cA cr wcel cc0 cA cle wbr wa vk vn cv c1 caddc co
      wsbc vk vn cv c1 caddc co cA csb cr wcel cc0 vk vn cv c1 caddc co cA csb
      cle wbr wa cA cr wcel cc0 cA cle wbr wa vk vn cv c1 caddc co cM vn cv c1
      caddc co cfz co ra4sbca cA cr wcel cc0 cA cle wbr wa vk vn cv c1 caddc co
      wsbc cA cr wcel vk vn cv c1 caddc co wsbc cc0 cA cle wbr vk vn cv c1
      caddc co wsbc wa vk vn cv c1 caddc co cA csb cr wcel cc0 vk vn cv c1
      caddc co cA csb cle wbr wa vn cv c1 caddc co cvv wcel cA cr wcel cc0 cA
      cle wbr wa vk vn cv c1 caddc co wsbc cA cr wcel vk vn cv c1 caddc co wsbc
      cc0 cA cle wbr vk vn cv c1 caddc co wsbc wa wb vn cv c1 caddc oprex cA cr
      wcel cc0 cA cle wbr vk vn cv c1 caddc co cvv sbcang ax-mp cA cr wcel vk
      vn cv c1 caddc co wsbc vk vn cv c1 caddc co cA csb cr wcel cc0 cA cle wbr
      vk vn cv c1 caddc co wsbc cc0 vk vn cv c1 caddc co cA csb cle wbr vn cv
      c1 caddc co cvv wcel cA cr wcel vk vn cv c1 caddc co wsbc vk vn cv c1
      caddc co cA csb cr wcel wb vn cv c1 caddc oprex vk vn cv c1 caddc co cA
      cr cvv sbcel1g ax-mp vn cv c1 caddc co cvv wcel cc0 cA cle wbr vk vn cv
      c1 caddc co wsbc cc0 vk vn cv c1 caddc co cA csb cle wbr wb vn cv c1
      caddc oprex vk vn cv c1 caddc co cc0 cA cvv cle sbcbr2g ax-mp anbi12i
      bitri sylib vn cv cM cuz cfv wcel vn cv c1 caddc co cM cuz cfv wcel vn cv
      c1 caddc co cM vn cv c1 caddc co cfz co wcel cM vn cv peano2uz cM vn cv
      c1 caddc co eluzfz2 syl sylan cM vn cv cfz co cA vk csu vk vn cv c1 caddc
      co cA csb add20 sylan31c biimpd syl5d vn cv cM cuz cfv wcel cA cr wcel
      cc0 cA cle wbr wa vk cM vn cv c1 caddc co cfz co wral wa cM vn cv c1
      caddc co cfz co cA vk csu cc0 wceq cM vn cv cfz co cA vk csu vk vn cv c1
      caddc co cA csb caddc co cc0 wceq vn cv cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM vn cv c1 caddc co cfz co wral wa cM vn cv c1 caddc co
      cfz co cA vk csu cM vn cv cfz co cA vk csu vk vn cv c1 caddc co cA csb
      caddc co cc0 vn cv cM cuz cfv wcel cA cr wcel vk cM vn cv c1 caddc co cfz
      co wral cM vn cv c1 caddc co cfz co cA vk csu cM vn cv cfz co cA vk csu
      vk vn cv c1 caddc co cA csb caddc co wceq cA cr wcel cc0 cA cle wbr wa vk
      cM vn cv c1 caddc co cfz co wral cA cr vk cM vn cv fsump1s cA cr wcel cc0
      cA cle wbr wa cA cr wcel vk cM vn cv c1 caddc co cfz co cA cr wcel cc0 cA
      cle wbr pm3.26 r19.20si sylan2 eqeq1d biimpd syl5d ex a2d syld uzind4 imp
      cN cM cuz cfv wcel cA cc0 wceq vk cM cN cfz co wral cM cN cfz co cA vk
      csu cc0 wceq wi cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cA cc0
      wceq vk cM cN cfz co wral cM cN cfz co cA vk csu cc0 wceq cM cN cfz co
      cc0 vk csu cc0 wceq cN cM cuz cfv wcel cA cc0 wceq vk cM cN cfz co wral
      cM cN cfz co cA vk csu cM cN cfz co cc0 vk csu cc0 cM cN cfz co cA cc0 vk
      sumeq2 eqeq1d vk cM cN fsum0 syl5cbir adantr impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M j k n $. $d N j k n $. $d B j n $. $d C j n $.
    $( If every term in one finite sum is less than the corresponding term in
       another, then the first sum is less than the second. $)
    fsumlt $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
                    ( B e. RR /\ C e. RR /\ B < C ) ) ->
                        sum_ k e. ( M ... N ) B < sum_ k e. ( M ... N ) C ) $=
      cN cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM cN cfz
      co wral cM cN cfz co cB vk csu cM cN cfz co cC vk csu clt wbr cB cr wcel
      cC cr wcel cB cC clt wbr w3a vk cM vn cv cfz co wral cM vn cv cfz co cB
      vk csu cM vn cv cfz co cC vk csu clt wbr wi cB cr wcel cC cr wcel cB cC
      clt wbr w3a vk cM cM cfz co wral cM cM cfz co cB vk csu cM cM cfz co cC
      vk csu clt wbr wi cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz
      co wral cM vj cv cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr wi cB
      cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral
      cM vj cv c1 caddc co cfz co cB vk csu cM vj cv c1 caddc co cfz co cC vk
      csu clt wbr wi cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM cN cfz co
      wral cM cN cfz co cB vk csu cM cN cfz co cC vk csu clt wbr wi vn vj cM cN
      vn cv cM wceq cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vn cv cfz co
      wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM cM cfz co wral cM vn
      cv cfz co cB vk csu cM vn cv cfz co cC vk csu clt wbr cM cM cfz co cB vk
      csu cM cM cfz co cC vk csu clt wbr vn cv cM wceq cB cr wcel cC cr wcel cB
      cC clt wbr w3a vk cM vn cv cfz co cM cM cfz co vn cv cM cM cfz opreq2
      raleq1d vn cv cM wceq cM vn cv cfz co cB vk csu cM cM cfz co cB vk csu cM
      vn cv cfz co cC vk csu cM cM cfz co cC vk csu clt vn cv cM wceq cM vn cv
      cfz co cM cM cfz co cB vk vn cv cM cM cfz opreq2 sumeq1d vn cv cM wceq cM
      vn cv cfz co cM cM cfz co cC vk vn cv cM cM cfz opreq2 sumeq1d breq12d
      imbi12d vn cv vj cv wceq cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vn
      cv cfz co wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz co
      wral cM vn cv cfz co cB vk csu cM vn cv cfz co cC vk csu clt wbr cM vj cv
      cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr vn cv vj cv wceq cB cr
      wcel cC cr wcel cB cC clt wbr w3a vk cM vn cv cfz co cM vj cv cfz co vn
      cv vj cv cM cfz opreq2 raleq1d vn cv vj cv wceq cM vn cv cfz co cB vk csu
      cM vj cv cfz co cB vk csu cM vn cv cfz co cC vk csu cM vj cv cfz co cC vk
      csu clt vn cv vj cv wceq cM vn cv cfz co cM vj cv cfz co cB vk vn cv vj
      cv cM cfz opreq2 sumeq1d vn cv vj cv wceq cM vn cv cfz co cM vj cv cfz co
      cC vk vn cv vj cv cM cfz opreq2 sumeq1d breq12d imbi12d vn cv vj cv c1
      caddc co wceq cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vn cv cfz co
      wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz
      co wral cM vn cv cfz co cB vk csu cM vn cv cfz co cC vk csu clt wbr cM vj
      cv c1 caddc co cfz co cB vk csu cM vj cv c1 caddc co cfz co cC vk csu clt
      wbr vn cv vj cv c1 caddc co wceq cB cr wcel cC cr wcel cB cC clt wbr w3a
      vk cM vn cv cfz co cM vj cv c1 caddc co cfz co vn cv vj cv c1 caddc co cM
      cfz opreq2 raleq1d vn cv vj cv c1 caddc co wceq cM vn cv cfz co cB vk csu
      cM vj cv c1 caddc co cfz co cB vk csu cM vn cv cfz co cC vk csu cM vj cv
      c1 caddc co cfz co cC vk csu clt vn cv vj cv c1 caddc co wceq cM vn cv
      cfz co cM vj cv c1 caddc co cfz co cB vk vn cv vj cv c1 caddc co cM cfz
      opreq2 sumeq1d vn cv vj cv c1 caddc co wceq cM vn cv cfz co cM vj cv c1
      caddc co cfz co cC vk vn cv vj cv c1 caddc co cM cfz opreq2 sumeq1d
      breq12d imbi12d vn cv cN wceq cB cr wcel cC cr wcel cB cC clt wbr w3a vk
      cM vn cv cfz co wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM cN cfz
      co wral cM vn cv cfz co cB vk csu cM vn cv cfz co cC vk csu clt wbr cM cN
      cfz co cB vk csu cM cN cfz co cC vk csu clt wbr vn cv cN wceq cB cr wcel
      cC cr wcel cB cC clt wbr w3a vk cM vn cv cfz co cM cN cfz co vn cv cN cM
      cfz opreq2 raleq1d vn cv cN wceq cM vn cv cfz co cB vk csu cM cN cfz co
      cB vk csu cM vn cv cfz co cC vk csu cM cN cfz co cC vk csu clt vn cv cN
      wceq cM vn cv cfz co cM cN cfz co cB vk vn cv cN cM cfz opreq2 sumeq1d vn
      cv cN wceq cM vn cv cfz co cM cN cfz co cC vk vn cv cN cM cfz opreq2
      sumeq1d breq12d imbi12d cM cz wcel cB cr wcel cC cr wcel cB cC clt wbr
      w3a vk cM cM cfz co wral cM cM cfz co cB vk csu cM cM cfz co cC vk csu
      clt wbr cM cz wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM cM cfz
      co wral wa vk cM cB csb vk cM cC csb cM cM cfz co cB vk csu cM cM cfz co
      cC vk csu clt cM cM cM cfz co wcel cB cC clt wbr vk cM cM cfz co wral vk
      cM cB csb vk cM cC csb clt wbr cM cz wcel cB cr wcel cC cr wcel cB cC clt
      wbr w3a vk cM cM cfz co wral cM cM cM cfz co wcel cB cC clt wbr vk cM cM
      cfz co wral wa cB cC clt wbr vk cM wsbc vk cM cB csb vk cM cC csb clt wbr
      cB cC clt wbr vk cM cM cM cfz co ra4sbca cM cM cM cfz co wcel cB cC clt
      wbr vk cM wsbc vk cM cB csb vk cM cC csb clt wbr wb cB cC clt wbr vk cM
      cM cfz co wral vk cM cB cC cM cM cfz co clt sbcbr12g adantr mpbid cM
      elfz3 cB cr wcel cC cr wcel cB cC clt wbr w3a cB cC clt wbr vk cM cM cfz
      co cB cr wcel cC cr wcel cB cC clt wbr 3simp3 r19.20si syl2an cM cz wcel
      cB cr wcel vk cM cM cfz co wral cM cM cfz co cB vk csu vk cM cB csb wceq
      cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM cM cfz co wral cB cr vk cM
      fsum1s cB cr wcel cC cr wcel cB cC clt wbr w3a cB cr wcel vk cM cM cfz co
      cB cr wcel cC cr wcel cB cC clt wbr 3simp1 r19.20si sylan2 cM cz wcel cC
      cr wcel vk cM cM cfz co wral cM cM cfz co cC vk csu vk cM cC csb wceq cB
      cr wcel cC cr wcel cB cC clt wbr w3a vk cM cM cfz co wral cC cr vk cM
      fsum1s cB cr wcel cC cr wcel cB cC clt wbr w3a cC cr wcel vk cM cM cfz co
      cB cr wcel cC cr wcel cB cC clt wbr 3simp2 r19.20si sylan2 3brtr4d ex vj
      cv cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv
      cfz co wral cM vj cv cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr
      wi cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co
      wral cM vj cv cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr wi cB cr
      wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral cM
      vj cv c1 caddc co cfz co cB vk csu cM vj cv c1 caddc co cfz co cC vk csu
      clt wbr wi vj cv cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a
      vk cM vj cv c1 caddc co cfz co wral cB cr wcel cC cr wcel cB cC clt wbr
      w3a vk cM vj cv cfz co wral cM vj cv cfz co cB vk csu cM vj cv cfz co cC
      vk csu clt wbr vj cv cM cuz cfv wcel cM vj cv cfz co cM vj cv c1 caddc co
      cfz co wss cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc
      co cfz co wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz co
      wral wi cM cz wcel vj cv cz wcel cM vj cv cfz co cM vj cv c1 caddc co cfz
      co wss vj cv cM cuz cfv wcel cM vj cv fzssp1 cM vj cv eluzel2 cM vj cv
      eluzelz sylanc cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz co
      cM vj cv c1 caddc co cfz co ssralv syl imim1d vj cv cM cuz cfv wcel cB cr
      wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral cM
      vj cv cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr cM vj cv c1
      caddc co cfz co cB vk csu cM vj cv c1 caddc co cfz co cC vk csu clt wbr
      vj cv cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv
      c1 caddc co cfz co wral cM vj cv cfz co cB vk csu cM vj cv cfz co cC vk
      csu clt wbr cM vj cv c1 caddc co cfz co cB vk csu cM vj cv c1 caddc co
      cfz co cC vk csu clt wbr vj cv cM cuz cfv wcel cB cr wcel cC cr wcel cB
      cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral wa cM vj cv cfz co cB
      vk csu cM vj cv cfz co cC vk csu clt wbr wa cM vj cv cfz co cB vk csu vk
      vj cv c1 caddc co cB csb caddc co cM vj cv cfz co cC vk csu vk vj cv c1
      caddc co cC csb caddc co cM vj cv c1 caddc co cfz co cB vk csu cM vj cv
      c1 caddc co cfz co cC vk csu clt vj cv cM cuz cfv wcel cB cr wcel cC cr
      wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral wa cM vj cv
      cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr wa vk vj cv c1 caddc
      co cB csb vk vj cv c1 caddc co cC csb clt wbr cM vj cv cfz co cB vk csu
      vk vj cv c1 caddc co cB csb caddc co cM vj cv cfz co cC vk csu vk vj cv
      c1 caddc co cC csb caddc co clt wbr vj cv cM cuz cfv wcel cB cr wcel cC
      cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral wa vk vj cv
      c1 caddc co cB csb vk vj cv c1 caddc co cC csb clt wbr cM vj cv cfz co cB
      vk csu cM vj cv cfz co cC vk csu clt wbr vj cv c1 caddc co cM vj cv c1
      caddc co cfz co wcel cB cC clt wbr vk cM vj cv c1 caddc co cfz co wral vk
      vj cv c1 caddc co cB csb vk vj cv c1 caddc co cC csb clt wbr vj cv cM cuz
      cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co
      cfz co wral vj cv c1 caddc co cM vj cv c1 caddc co cfz co wcel cB cC clt
      wbr vk cM vj cv c1 caddc co cfz co wral wa cB cC clt wbr vk vj cv c1
      caddc co wsbc vk vj cv c1 caddc co cB csb vk vj cv c1 caddc co cC csb clt
      wbr cB cC clt wbr vk vj cv c1 caddc co cM vj cv c1 caddc co cfz co
      ra4sbca vj cv c1 caddc co cM vj cv c1 caddc co cfz co wcel cB cC clt wbr
      vk vj cv c1 caddc co wsbc vk vj cv c1 caddc co cB csb vk vj cv c1 caddc
      co cC csb clt wbr wb cB cC clt wbr vk cM vj cv c1 caddc co cfz co wral vk
      vj cv c1 caddc co cB cC cM vj cv c1 caddc co cfz co clt sbcbr12g adantr
      mpbid vj cv cM cuz cfv wcel vj cv c1 caddc co cM cuz cfv wcel vj cv c1
      caddc co cM vj cv c1 caddc co cfz co wcel cM vj cv peano2uz cM vj cv c1
      caddc co eluzfz2 syl cB cr wcel cC cr wcel cB cC clt wbr w3a cB cC clt
      wbr vk cM vj cv c1 caddc co cfz co cB cr wcel cC cr wcel cB cC clt wbr
      3simp3 r19.20si syl2an adantr vj cv cM cuz cfv wcel cB cr wcel cC cr wcel
      cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral wa cM vj cv cfz co
      cB vk csu cM vj cv cfz co cC vk csu clt wbr vk vj cv c1 caddc co cB csb
      vk vj cv c1 caddc co cC csb clt wbr cM vj cv cfz co cB vk csu vk vj cv c1
      caddc co cB csb caddc co cM vj cv cfz co cC vk csu vk vj cv c1 caddc co
      cC csb caddc co clt wbr cM vj cv cfz co cB vk csu cr wcel vk vj cv c1
      caddc co cB csb cr wcel cM vj cv cfz co cC vk csu cr wcel vk vj cv c1
      caddc co cC csb cr wcel cM vj cv cfz co cB vk csu cM vj cv cfz co cC vk
      csu clt wbr vk vj cv c1 caddc co cB csb vk vj cv c1 caddc co cC csb clt
      wbr wa cM vj cv cfz co cB vk csu vk vj cv c1 caddc co cB csb caddc co cM
      vj cv cfz co cC vk csu vk vj cv c1 caddc co cC csb caddc co clt wbr wi vj
      cv cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1
      caddc co cfz co wral wa cM vj cv cfz co cB vk csu vk vj cv c1 caddc co cB
      csb cM vj cv cfz co cC vk csu vk vj cv c1 caddc co cC csb lt2add vj cv cM
      cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc
      co cfz co wral wa vj cv cM cuz cfv wcel cB cr wcel vk cM vj cv cfz co
      wral wa cM vj cv cfz co cB vk csu cr wcel vj cv cM cuz cfv wcel cB cr
      wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral cB
      cr wcel vk cM vj cv cfz co wral vj cv cM cuz cfv wcel cB cr wcel cC cr
      wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral cB cr wcel cC
      cr wcel cB cC clt wbr w3a vk cM vj cv cfz co wral cB cr wcel vk cM vj cv
      cfz co wral vj cv cM cuz cfv wcel cM vj cv cfz co cM vj cv c1 caddc co
      cfz co wss cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc
      co cfz co wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz co
      wral wi cM cz wcel vj cv cz wcel cM vj cv cfz co cM vj cv c1 caddc co cfz
      co wss vj cv cM cuz cfv wcel cM vj cv fzssp1 cM vj cv eluzel2 cM vj cv
      eluzelz sylanc cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz co
      cM vj cv c1 caddc co cfz co ssralv syl cB cr wcel cC cr wcel cB cC clt
      wbr w3a cB cr wcel vk cM vj cv cfz co cB cr wcel cC cr wcel cB cC clt wbr
      3simp1 r19.20si syl6 imdistani cB vk cM vj cv fsumrecl syl vj cv c1 caddc
      co cM vj cv c1 caddc co cfz co wcel cB cr wcel vk cM vj cv c1 caddc co
      cfz co wral vk vj cv c1 caddc co cB csb cr wcel vj cv cM cuz cfv wcel cB
      cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral
      vk vj cv c1 caddc co cM vj cv c1 caddc co cfz co cB cr ra4csbela vj cv cM
      cuz cfv wcel vj cv c1 caddc co cM cuz cfv wcel vj cv c1 caddc co cM vj cv
      c1 caddc co cfz co wcel cM vj cv peano2uz cM vj cv c1 caddc co eluzfz2
      syl cB cr wcel cC cr wcel cB cC clt wbr w3a cB cr wcel vk cM vj cv c1
      caddc co cfz co cB cr wcel cC cr wcel cB cC clt wbr 3simp1 r19.20si
      syl2an vj cv cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk
      cM vj cv c1 caddc co cfz co wral wa vj cv cM cuz cfv wcel cC cr wcel vk
      cM vj cv cfz co wral wa cM vj cv cfz co cC vk csu cr wcel vj cv cM cuz
      cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co
      cfz co wral cC cr wcel vk cM vj cv cfz co wral vj cv cM cuz cfv wcel cB
      cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral
      cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv cfz co wral cC cr
      wcel vk cM vj cv cfz co wral vj cv cM cuz cfv wcel cM vj cv cfz co cM vj
      cv c1 caddc co cfz co wss cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM
      vj cv c1 caddc co cfz co wral cB cr wcel cC cr wcel cB cC clt wbr w3a vk
      cM vj cv cfz co wral wi cM cz wcel vj cv cz wcel cM vj cv cfz co cM vj cv
      c1 caddc co cfz co wss vj cv cM cuz cfv wcel cM vj cv fzssp1 cM vj cv
      eluzel2 cM vj cv eluzelz sylanc cB cr wcel cC cr wcel cB cC clt wbr w3a
      vk cM vj cv cfz co cM vj cv c1 caddc co cfz co ssralv syl cB cr wcel cC
      cr wcel cB cC clt wbr w3a cC cr wcel vk cM vj cv cfz co cB cr wcel cC cr
      wcel cB cC clt wbr 3simp2 r19.20si syl6 imdistani cC vk cM vj cv fsumrecl
      syl vj cv c1 caddc co cM vj cv c1 caddc co cfz co wcel cC cr wcel vk cM
      vj cv c1 caddc co cfz co wral vk vj cv c1 caddc co cC csb cr wcel vj cv
      cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1
      caddc co cfz co wral vk vj cv c1 caddc co cM vj cv c1 caddc co cfz co cC
      cr ra4csbela vj cv cM cuz cfv wcel vj cv c1 caddc co cM cuz cfv wcel vj
      cv c1 caddc co cM vj cv c1 caddc co cfz co wcel cM vj cv peano2uz cM vj
      cv c1 caddc co eluzfz2 syl cB cr wcel cC cr wcel cB cC clt wbr w3a cC cr
      wcel vk cM vj cv c1 caddc co cfz co cB cr wcel cC cr wcel cB cC clt wbr
      3simp2 r19.20si syl2an syl2anc expdimp mpd vj cv cM cuz cfv wcel cB cr
      wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral wa
      cM vj cv c1 caddc co cfz co cB vk csu cM vj cv cfz co cB vk csu vk vj cv
      c1 caddc co cB csb caddc co wceq cM vj cv cfz co cB vk csu cM vj cv cfz
      co cC vk csu clt wbr vj cv cM cuz cfv wcel cB cr wcel vk cM vj cv c1
      caddc co cfz co wral cM vj cv c1 caddc co cfz co cB vk csu cM vj cv cfz
      co cB vk csu vk vj cv c1 caddc co cB csb caddc co wceq cB cr wcel cC cr
      wcel cB cC clt wbr w3a vk cM vj cv c1 caddc co cfz co wral cB cr vk cM vj
      cv fsump1s cB cr wcel cC cr wcel cB cC clt wbr w3a cB cr wcel vk cM vj cv
      c1 caddc co cfz co cB cr wcel cC cr wcel cB cC clt wbr 3simp1 r19.20si
      sylan2 adantr vj cv cM cuz cfv wcel cB cr wcel cC cr wcel cB cC clt wbr
      w3a vk cM vj cv c1 caddc co cfz co wral wa cM vj cv c1 caddc co cfz co cC
      vk csu cM vj cv cfz co cC vk csu vk vj cv c1 caddc co cC csb caddc co
      wceq cM vj cv cfz co cB vk csu cM vj cv cfz co cC vk csu clt wbr vj cv cM
      cuz cfv wcel cC cr wcel vk cM vj cv c1 caddc co cfz co wral cM vj cv c1
      caddc co cfz co cC vk csu cM vj cv cfz co cC vk csu vk vj cv c1 caddc co
      cC csb caddc co wceq cB cr wcel cC cr wcel cB cC clt wbr w3a vk cM vj cv
      c1 caddc co cfz co wral cC cr vk cM vj cv fsump1s cB cr wcel cC cr wcel
      cB cC clt wbr w3a cC cr wcel vk cM vj cv c1 caddc co cfz co cB cr wcel cC
      cr wcel cB cC clt wbr 3simp2 r19.20si sylan2 adantr 3brtr4d exp31 a2d
      syld uzind4 imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k x $. $d N k x $. $d F k x $.
    fsumltisumii.1 $e |- N e. ( ZZ>= ` M ) $.
    fsumltisumii.2 $e |- F : ( ZZ>= ` M ) --> RR+ $.
    fsumltisumii.3 $e |- E. x ( <. M , + >. seq F ) ~~> x $.
    $( A partial sum of a series with positive terms is less than the
       infinite sum. $)
    fsumltisumii $p |- sum_ k e. ( M ... N ) ( F ` k ) <
                                        sum_ k e. ( ZZ>= ` M ) ( F ` k ) $=
      cM cN cfz co vk cv cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cN c1
      caddc co cuz cfv vk cv cF cfv vk csu caddc co cM cuz cfv vk cv cF cfv vk
      csu clt cM cN cfz co vk cv cF cfv vk csu cc0 caddc co cM cN cfz co vk cv
      cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cN c1 caddc co cuz cfv vk
      cv cF cfv vk csu caddc co clt cM cN cfz co vk cv cF cfv vk csu cN cM cuz
      cfv wcel vk cv cF cfv cc wcel vk cM cN cfz co wral cM cN cfz co vk cv cF
      cfv vk csu cc wcel fsumltisumii.1 vk cv cF cfv cc wcel vk cM cN cfz co vk
      cv cM cN cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv crp wcel vk cv cF
      cfv cc wcel vk cv cM cN elfzuz cM cuz cfv crp vk cv cF fsumltisumii.2
      ffvelrni vk cv cF cfv rpcn 3syl rgen vk cv cF cfv vk cM cN fsumcl mp2an
      addid1i cc0 cN c1 caddc co cuz cfv vk cv cF cfv vk csu clt wbr cM cN cfz
      co vk cv cF cfv vk csu cc0 caddc co cM cN cfz co vk cv cF cfv vk csu cN
      c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co clt wbr cN c1 caddc co
      cM cuz cfv wcel vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cc0 cN c1
      caddc co cuz cfv vk cv cF cfv vk csu clt wbr cN cM cuz cfv wcel c1 cn0
      wcel cN c1 caddc co cM cuz cfv wcel fsumltisumii.1 1nn0 c1 cM cN uzaddcl
      mp2an vk cv cF cfv cr wcel cc0 vk cv cF cfv clt wbr wa vk cM cuz cfv vk
      cv cM cuz cfv wcel vk cv cF cfv crp wcel vk cv cF cfv cr wcel cc0 vk cv
      cF cfv clt wbr wa cM cuz cfv crp vk cv cF fsumltisumii.2 ffvelrni vk cv
      cF cfv elrp sylib rgen fsumltisumii.3 vx vk cF cM cN c1 caddc co cM cuz
      cfv crp cF wf cM cuz cfv cvv wcel cF cvv wcel fsumltisumii.2 cM cuz fvex
      cM cuz cfv crp cvv cF fex mp2an iserzgt0 mp3an cc0 cN c1 caddc co cuz cfv
      vk cv cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu 0re cN c1 caddc co
      cz wcel vk cv cF cfv cr wcel vk cN c1 caddc co cuz cfv wral cN c1 caddc
      co caddc cop cF cseqz co vx cv cli wbr vx wex cN c1 caddc co cuz cfv vk
      cv cF cfv vk csu cr wcel cN cz wcel cN c1 caddc co cz wcel cN cM cuz cfv
      wcel cN cz wcel fsumltisumii.1 cM cN eluzelz ax-mp cN peano2z ax-mp vk cv
      cF cfv cr wcel vk cN c1 caddc co cuz cfv vk cv cN c1 caddc co cuz cfv
      wcel vk cv cM cuz cfv wcel vk cv cF cfv crp wcel vk cv cF cfv cr wcel cN
      c1 caddc co cuz cfv cM cuz cfv vk cv cN c1 caddc co cM cuz cfv wcel cN c1
      caddc co cuz cfv cM cuz cfv wss cN cM cuz cfv wcel c1 cn0 wcel cN c1
      caddc co cM cuz cfv wcel fsumltisumii.1 1nn0 c1 cM cN uzaddcl mp2an cM cN
      c1 caddc co uzss ax-mp sseli cM cuz cfv crp vk cv cF fsumltisumii.2
      ffvelrni vk cv cF cfv rpre 3syl rgen cN cM cuz cfv wcel vk cv cF cfv cc
      wcel vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cN
      c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex fsumltisumii.1 vk
      cv cF cfv cc wcel vk cM cuz cfv vk cv cM cuz cfv wcel vk cv cF cfv crp
      wcel vk cv cF cfv cc wcel cM cuz cfv crp vk cv cF fsumltisumii.2 ffvelrni
      vk cv cF cfv rpcn syl rgen fsumltisumii.3 vx vk cF cM cN cM cuz cfv crp
      cF wf cM cuz cfv cvv wcel cF cvv wcel fsumltisumii.2 cM cuz fvex cM cuz
      cfv crp cvv cF fex mp2an iserzex mp3an vx vk cF cN c1 caddc co cM cuz cfv
      crp cF wf cM cuz cfv cvv wcel cF cvv wcel fsumltisumii.2 cM cuz fvex cM
      cuz cfv crp cvv cF fex mp2an isumrecl mp3an cN cM cuz cfv wcel vk cv cF
      cfv cr wcel vk cM cN cfz co wral cM cN cfz co vk cv cF cfv vk csu cr wcel
      fsumltisumii.1 vk cv cF cfv cr wcel vk cM cN cfz co vk cv cM cN cfz co
      wcel vk cv cM cuz cfv wcel vk cv cF cfv crp wcel vk cv cF cfv cr wcel vk
      cv cM cN elfzuz cM cuz cfv crp vk cv cF fsumltisumii.2 ffvelrni vk cv cF
      cfv rpre 3syl rgen vk cv cF cfv vk cM cN fsumrecl mp2an ltadd2i mpbi
      eqbrtrri vx vk cF cM cN cN cM cuz cfv wcel cM cz wcel fsumltisumii.1 cM
      cN eluzel2 ax-mp fsumltisumii.1 cM cuz cfv crp cF wf crp cc wss cM cuz
      cfv cc cF wf fsumltisumii.2 crp cr cc rpssre axresscn sstri cM cuz cfv
      crp cc cF fss mp2an fsumltisumii.3 isumspliti breqtrri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k u v x y z $. $d N k u v x y z $. $d F k u v x y z $.
    fsumltisumi.1 $e |- N e. ( ZZ>= ` M ) $.
    $( A partial sum of a series with positive terms is less than the
       infinite sum. $)
    fsumltisumi $p |- ( ( F : ( ZZ>= ` M ) --> RR+ /\
                                    E. x ( <. M , + >. seq F ) ~~> x ) ->
        sum_ k e. ( M ... N ) ( F ` k ) < sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $=
      cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM
      cN cfz co vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu clt wbr cM
      cN cfz co vk cv cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin
      co cexp co wceq wa vy vz copab cif cfv vk csu cM cuz cfv vk cv cM cuz cfv
      crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cif cfv vk csu clt wbr cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co
      vy cv cM cmin co cexp co wceq wa vy vz copab cF cM cuz cfv crp cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz
      cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif wceq cM
      cN cfz co vk cv cF cfv vk csu cM cN cfz co vk cv cM cuz cfv crp cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz
      cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cfv vk
      csu cM cuz cfv vk cv cF cfv vk csu cM cuz cfv vk cv cM cuz cfv crp cF wf
      cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel
      vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cfv
      vk csu clt cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr
      vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cif wceq cM cN cfz co vk cv cF cfv vk cv cM
      cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy
      cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa
      vy vz copab cif cfv vk vk cv cF cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif fveq1 sumeq2sdv
      cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa
      cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cif wceq cM cuz cfv vk cv cF cfv vk cv cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cif cfv vk vk cv cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cif fveq1 sumeq2sdv breq12d vv vk cM
      cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy
      cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa
      vy vz copab cif cM cN fsumltisumi.1 cM cuz cfv crp cM cuz cfv crp cF wf
      cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel
      vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif wf
      cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr
      vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cif cseqz co vx cv cli wbr vx wex cM cuz cfv
      crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cuz cfv crp
      cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cif wf cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co vx cv
      cli wbr vx wex wa cM cuz cfv crp vy cv cM cuz cfv wcel vz cv c1 c2 cdiv
      co vy cv cM cmin co cexp co wceq wa vy vz copab wf cM caddc cop vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cF cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cif wceq cM cuz cfv crp cF wf cM cuz cfv crp cM cuz cfv crp cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz
      cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cM cuz cfv crp cF
      wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif
      cseqz co vx cv cli wbr vx wex cM cuz cfv crp cF cM cuz cfv crp cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz
      cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif feq1 cF
      cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cif wceq cM caddc cop cF cseqz co vx cv cli wbr cM caddc
      cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa
      cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cif cseqz co vx cv cli wbr vx vx vu vu cF cM cuz cfv
      crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cif vu cv cF wcel vx ax-17 cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa vx vu cF vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM cuz cfv crp cF
      wf cM caddc cop cF cseqz co vx cv cli wbr vx wex vx cM cuz cfv crp cF wf
      vx ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx hbe1 hban vu cv cF
      wcel vx ax-17 vu cv vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab wcel vx ax-17 hbif hbeq cF cM cuz cfv
      crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cif wceq cM caddc cop cF cseqz co cM caddc cop cM cuz cfv crp cF wf
      cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel
      vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif
      cseqz co vx cv cli cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cif cM caddc cop cseqz opreq2 breq1d
      exbid anbi12d vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cif wceq cM cuz cfv crp vy cv
      cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy
      vz copab wf cM cuz cfv crp cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cif wf cM caddc cop vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cseqz co vx cv cli wbr vx wex cM caddc cop cM cuz cfv crp cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz
      cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz
      co vx cv cli wbr vx wex cM cuz cfv crp vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM cuz cfv crp cF wf
      cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel
      vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif feq1
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin
      co cexp co wceq wa vy vz copab cif wceq cM caddc cop vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cseqz co vx cv cli wbr cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co vx cv
      cli wbr vx vx vu vu vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif vu cv vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab wcel vx ax-17 cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa vx vu cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc
      cop cF cseqz co vx cv cli wbr vx wex vx cM cuz cfv crp cF wf vx ax-17 cM
      caddc cop cF cseqz co vx cv cli wbr vx hbe1 hban vu cv cF wcel vx ax-17
      vu cv vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab wcel vx ax-17 hbif hbeq vy cv cM cuz cfv wcel vz cv
      c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cif wceq cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cseqz co cM caddc cop cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cif cseqz co vx cv cli vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cM caddc cop
      cseqz opreq2 breq1d exbid anbi12d cM cuz cfv crp vy cv cM cuz cfv wcel vz
      cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab wf cM caddc
      cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cseqz co vx cv cli wbr vx wex vy vz cM cuz cfv crp c1
      c2 cdiv co vy cv cM cmin co cexp co vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      eqid c1 c2 cdiv co crp wcel vy cv cM cmin co cn0 wcel c1 c2 cdiv co vy cv
      cM cmin co cexp co crp wcel vy cv cM cuz cfv wcel c1 c2 cdiv co vy cv cM
      cmin co rpexpcl c2 crp wcel c1 c2 cdiv co crp wcel c2 2re 2pos elrpii c2
      rpreccl ax-mp vy cv cc0 cM caddc co cuz cfv wcel vy cv cM cmin co cc0 cuz
      cfv wcel vy cv cM cuz cfv wcel vy cv cM cmin co cn0 wcel cM cc0 vy cv 0z
      cN cM cuz cfv wcel cM cz wcel fsumltisumi.1 cM cN eluzel2 ax-mp eluzsubi
      cM cuz cfv cc0 cM caddc co cuz cfv vy cv cM cc0 cM caddc co cuz cc0 cM
      caddc co cM cM cM cz wcel cM cc wcel cN cM cuz cfv wcel cM cz wcel
      fsumltisumi.1 cM cN eluzel2 ax-mp cM zcn ax-mp addid2i eqcomi fveq2i
      eleq2i vy cv cM cmin co elnn0uz 3imtr4i sylancr fopab cM caddc cop vy cv
      cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy
      vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr cM caddc
      cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cseqz co vx cv cli wbr vx wex cc0 caddc cop vy cv cn0
      wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cseqz co c1 c1
      c1 c2 cdiv co cmin co cdiv co cli wbr cM caddc cop vy cv cM cuz cfv wcel
      vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co
      c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr caddc vy cv cn0 wcel vz cv c1
      c2 cdiv co vy cv cexp co wceq wa vy vz copab cseq0 co cc0 caddc cop vy cv
      cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cseqz co
      c1 c1 c1 c2 cdiv co cmin co cdiv co cli caddc vy cv cn0 wcel vz cv c1 c2
      cdiv co vy cv cexp co wceq wa vy vz copab addex vy vz cn0 c1 c2 cdiv co
      vy cv cexp co nn0ex opabex2 seq0seqz vz c1 c2 cdiv co vy vy cv cn0 wcel
      vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab vy cv cn0 wcel vz
      cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab eqid c2 2cn 2ne0
      reccli c1 c2 cdiv co cabs cfv c1 c2 cdiv co c1 clt c1 c2 cdiv co cabs cfv
      c1 c2 cdiv co c2 cexp co csqr cfv c1 c2 cdiv co c1 c2 cdiv co cmul co
      csqr cfv c1 c2 cdiv co c1 c2 cdiv co c2 2re 2ne0 rereccli absrei c1 c2
      cdiv co c2 cexp co c1 c2 cdiv co c1 c2 cdiv co cmul co csqr c1 c2 cdiv co
      c2 2cn 2ne0 reccli sqvali fveq2i cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co
      c1 c2 cdiv co cmul co csqr cfv c1 c2 cdiv co wceq cc0 c1 cle wbr cc0 c2
      clt wbr cc0 c1 c2 cdiv co cle wbr cc0 c1 0re 1re lt01 ltleii 2pos c1 c2
      1re 2re divge0i mp2an c1 c2 cdiv co c2 2re 2ne0 rereccli sqrmsqi ax-mp
      3eqtri halflt1 eqbrtri geolimi eqbrtrri cc0 caddc cop vy cv cn0 wcel vz
      cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2
      cdiv co cmin co cdiv co cli wbr cc0 cM caddc co caddc cop vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr cM caddc cop vy cv
      cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy
      vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr c1 c1 c1 c2
      cdiv co cmin co cdiv co cvv wcel vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co
      vy cv cexp co wceq wa vy vz copab cfv cc wcel vu cv cM caddc co vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cfv vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa
      vy vz copab cfv wceq wa vu cc0 cuz cfv wral cc0 caddc cop vy cv cn0 wcel
      vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cseqz co c1 c1 c1
      c2 cdiv co cmin co cdiv co cli wbr cc0 cM caddc co caddc cop vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr wb c1 c1 c1 c2 cdiv
      co cmin co cdiv oprex vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp
      co wceq wa vy vz copab cfv cc wcel vu cv cM caddc co vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cfv
      vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz
      copab cfv wceq wa vu cc0 cuz cfv vu cv cc0 cuz cfv wcel vu cv cn0 wcel vu
      cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab
      cfv cc wcel vu cv cM caddc co vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co
      vy cv cM cmin co cexp co wceq wa vy vz copab cfv vu cv vy cv cn0 wcel vz
      cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv wceq wa vu cv
      elnn0uz vu cv cn0 wcel vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv
      cexp co wceq wa vy vz copab cfv cc wcel vu cv cM caddc co vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cfv vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz
      copab cfv wceq vu cv cn0 wcel vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy
      cv cexp co wceq wa vy vz copab cfv c1 c2 cdiv co vu cv cexp co cc vy vz
      vu cv c1 c2 cdiv co vy cv cexp co c1 c2 cdiv co vu cv cexp co cn0 vy cv
      cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab vy cv vu
      cv c1 c2 cdiv co cexp opreq2 vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv
      cexp co wceq wa vy vz copab eqid c1 c2 cdiv co vu cv cexp oprex fvopab4
      c1 c2 cdiv co cc wcel vu cv cn0 wcel c1 c2 cdiv co vu cv cexp co cc wcel
      c2 2cn 2ne0 reccli c1 c2 cdiv co vu cv expcl mpan eqeltrd vu cv cn0 wcel
      c1 c2 cdiv co vu cv cM caddc co cM cmin co cexp co c1 c2 cdiv co vu cv
      cexp co vu cv cM caddc co vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv
      cM cmin co cexp co wceq wa vy vz copab cfv vu cv vy cv cn0 wcel vz cv c1
      c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv vu cv cn0 wcel vu cv cM
      caddc co cM cmin co vu cv c1 c2 cdiv co cexp vu cv cc wcel cM cc wcel vu
      cv cM caddc co cM cmin co vu cv wceq vu cv cn0 wcel vu cv cM pncan vu cv
      nn0cn cM cz wcel cM cc wcel cN cM cuz cfv wcel cM cz wcel fsumltisumi.1
      cM cN eluzel2 ax-mp cM zcn ax-mp sylancl opreq2d vu cv cn0 wcel vu cv cM
      caddc co cM cuz cfv wcel vu cv cM caddc co vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cfv c1 c2 cdiv co
      vu cv cM caddc co cM cmin co cexp co wceq vu cv cn0 wcel vu cv cM caddc
      co cM vu cv caddc co cM cuz cfv vu cv cc wcel cM cc wcel vu cv cM caddc
      co cM vu cv caddc co wceq vu cv cn0 wcel vu cv cM addcom vu cv nn0cn cM
      cz wcel cM cc wcel cN cM cuz cfv wcel cM cz wcel fsumltisumi.1 cM cN
      eluzel2 ax-mp cM zcn ax-mp sylancl cM cM cuz cfv wcel vu cv cn0 wcel cM
      vu cv caddc co cM cuz cfv wcel cM cz wcel cM cM cuz cfv wcel cN cM cuz
      cfv wcel cM cz wcel fsumltisumi.1 cM cN eluzel2 ax-mp cM uzid ax-mp vu cv
      cM cM uzaddcl mpan eqeltrd vy vz vu cv cM caddc co c1 c2 cdiv co vy cv cM
      cmin co cexp co c1 c2 cdiv co vu cv cM caddc co cM cmin co cexp co cM cuz
      cfv vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab vy cv vu cv cM caddc co wceq vy cv cM cmin co vu cv
      cM caddc co cM cmin co c1 c2 cdiv co cexp vy cv vu cv cM caddc co cM cmin
      opreq1 opreq2d vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab eqid c1 c2 cdiv co vu cv cM caddc co cM cmin
      co cexp oprex fvopab4 syl vy vz vu cv c1 c2 cdiv co vy cv cexp co c1 c2
      cdiv co vu cv cexp co cn0 vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp
      co wceq wa vy vz copab vy cv vu cv c1 c2 cdiv co cexp opreq2 vy cv cn0
      wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab eqid c1 c2
      cdiv co vu cv cexp oprex fvopab4 3eqtr4d jca sylbir rgen c1 c1 c1 c2 cdiv
      co cmin co cdiv co cvv vu vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp
      co wceq wa vy vz copab vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cM cc0 vy vz cn0 c1 c2 cdiv co vy cv
      cexp co nn0ex opabex2 vy vz cM cuz cfv c1 c2 cdiv co vy cv cM cmin co
      cexp co cM cuz fvex opabex2 0z cN cM cuz cfv wcel cM cz wcel
      fsumltisumi.1 cM cN eluzel2 ax-mp iserzshft2i mp2an cc0 cM caddc co caddc
      cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cseqz co cM caddc cop vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co c1 c1 c1
      c2 cdiv co cmin co cdiv co cli cc0 cM caddc co caddc cop cM caddc cop vy
      cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa
      vy vz copab cseqz cc0 cM caddc co cM caddc cM cM cz wcel cM cc wcel cN cM
      cuz cfv wcel cM cz wcel fsumltisumi.1 cM cN eluzel2 ax-mp cM zcn ax-mp
      addid2i opeq1i opreq1i breq1i bitri mpbi cM caddc cop vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cseqz co vx cv cli wbr cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2
      cdiv co cmin co cdiv co cli wbr vx c1 c1 c1 c2 cdiv co cmin co cdiv co c1
      c1 c1 c2 cdiv co cmin co cdiv oprex vx cv c1 c1 c1 c2 cdiv co cmin co
      cdiv co cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cseqz co cli breq2 cla4ev ax-mp
      pm3.2i elimhyp pm3.26i cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co vx cv
      cli wbr vx wex cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co vv cv cli wbr vv
      wex cM cuz cfv crp cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cif wf cM caddc cop cM cuz cfv crp cF
      wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif
      cseqz co vx cv cli wbr vx wex cM cuz cfv crp cF wf cM caddc cop cF cseqz
      co vx cv cli wbr vx wex wa cM cuz cfv crp cM cuz cfv crp cF wf cM caddc
      cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif wf cM caddc
      cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa
      cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cif cseqz co vx cv cli wbr vx wex wa cM cuz cfv crp
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab wf cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co
      vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co vx cv cli wbr vx
      wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp
      co wceq wa vy vz copab cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cif wceq cM cuz cfv crp cF wf
      cM cuz cfv crp cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin
      co cexp co wceq wa vy vz copab cif wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx
      cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv
      cM cmin co cexp co wceq wa vy vz copab cif cseqz co vx cv cli wbr vx wex
      cM cuz cfv crp cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin
      co cexp co wceq wa vy vz copab cif feq1 cF cM cuz cfv crp cF wf cM caddc
      cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif wceq cM caddc
      cop cF cseqz co vx cv cli wbr cM caddc cop cM cuz cfv crp cF wf cM caddc
      cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co vx
      cv cli wbr vx vx vu vu cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cif vu cv cF wcel vx ax-17 cM
      cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa vx vu
      cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex vx cM cuz cfv crp cF wf vx ax-17 cM caddc cop cF cseqz co
      vx cv cli wbr vx hbe1 hban vu cv cF wcel vx ax-17 vu cv vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      wcel vx ax-17 hbif hbeq cF cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cif wceq cM caddc cop cF cseqz
      co cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin
      co cexp co wceq wa vy vz copab cif cseqz co vx cv cli cF cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cif cM caddc cop cseqz opreq2 breq1d exbid anbi12d vy cv cM cuz cfv wcel
      vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM cuz
      cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv
      cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy
      vz copab cif wceq cM cuz cfv crp vy cv cM cuz cfv wcel vz cv c1 c2 cdiv
      co vy cv cM cmin co cexp co wceq wa vy vz copab wf cM cuz cfv crp cM cuz
      cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv
      cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy
      vz copab cif wf cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cseqz co vx cv cli wbr vx wex
      cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr
      vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cif cseqz co vx cv cli wbr vx wex cM cuz cfv
      crp vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cif feq1 vy cv cM cuz cfv wcel vz cv
      c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cif wceq cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cseqz co vx cv cli wbr cM caddc cop
      cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cif cseqz co vx cv cli wbr vx vx vu vu vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM
      cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy
      cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa
      vy vz copab cif vu cv vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab wcel vx ax-17 cM cuz cfv crp cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex wa vx vu cF vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM
      cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex vx cM cuz
      cfv crp cF wf vx ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx hbe1
      hban vu cv cF wcel vx ax-17 vu cv vy cv cM cuz cfv wcel vz cv c1 c2 cdiv
      co vy cv cM cmin co cexp co wceq wa vy vz copab wcel vx ax-17 hbif hbeq
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli
      wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin
      co cexp co wceq wa vy vz copab cif wceq cM caddc cop vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cseqz co cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cif cseqz co vx cv cli vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cif cM caddc cop cseqz opreq2 breq1d exbid anbi12d cM cuz
      cfv crp vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp
      co wceq wa vy vz copab wf cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co vx cv cli
      wbr vx wex vy vz cM cuz cfv crp c1 c2 cdiv co vy cv cM cmin co cexp co vy
      cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa
      vy vz copab vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab eqid c1 c2 cdiv co crp wcel vy cv cM cmin co
      cn0 wcel c1 c2 cdiv co vy cv cM cmin co cexp co crp wcel vy cv cM cuz cfv
      wcel c1 c2 cdiv co vy cv cM cmin co rpexpcl c2 crp wcel c1 c2 cdiv co crp
      wcel c2 2re 2pos elrpii c2 rpreccl ax-mp vy cv cc0 cM caddc co cuz cfv
      wcel vy cv cM cmin co cc0 cuz cfv wcel vy cv cM cuz cfv wcel vy cv cM
      cmin co cn0 wcel cM cc0 vy cv 0z cN cM cuz cfv wcel cM cz wcel
      fsumltisumi.1 cM cN eluzel2 ax-mp eluzsubi cM cuz cfv cc0 cM caddc co cuz
      cfv vy cv cM cc0 cM caddc co cuz cc0 cM caddc co cM cM cM cz wcel cM cc
      wcel cN cM cuz cfv wcel cM cz wcel fsumltisumi.1 cM cN eluzel2 ax-mp cM
      zcn ax-mp addid2i eqcomi fveq2i eleq2i vy cv cM cmin co elnn0uz 3imtr4i
      sylancr fopab cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy
      cv cM cmin co cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co
      cmin co cdiv co cli wbr cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co vx cv cli
      wbr vx wex cc0 caddc cop vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co
      wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr
      cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co
      cli wbr caddc vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy
      vz copab cseq0 co cc0 caddc cop vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv
      cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co
      cli caddc vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz
      copab addex vy vz cn0 c1 c2 cdiv co vy cv cexp co nn0ex opabex2 seq0seqz
      vz c1 c2 cdiv co vy vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq
      wa vy vz copab vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa
      vy vz copab eqid c2 2cn 2ne0 reccli c1 c2 cdiv co cabs cfv c1 c2 cdiv co
      c1 clt c1 c2 cdiv co cabs cfv c1 c2 cdiv co c2 cexp co csqr cfv c1 c2
      cdiv co c1 c2 cdiv co cmul co csqr cfv c1 c2 cdiv co c1 c2 cdiv co c2 2re
      2ne0 rereccli absrei c1 c2 cdiv co c2 cexp co c1 c2 cdiv co c1 c2 cdiv co
      cmul co csqr c1 c2 cdiv co c2 2cn 2ne0 reccli sqvali fveq2i cc0 c1 c2
      cdiv co cle wbr c1 c2 cdiv co c1 c2 cdiv co cmul co csqr cfv c1 c2 cdiv
      co wceq cc0 c1 cle wbr cc0 c2 clt wbr cc0 c1 c2 cdiv co cle wbr cc0 c1
      0re 1re lt01 ltleii 2pos c1 c2 1re 2re divge0i mp2an c1 c2 cdiv co c2 2re
      2ne0 rereccli sqrmsqi ax-mp 3eqtri halflt1 eqbrtri geolimi eqbrtrri cc0
      caddc cop vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz
      copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr cc0 cM caddc
      co caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co
      cli wbr cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co
      cdiv co cli wbr c1 c1 c1 c2 cdiv co cmin co cdiv co cvv wcel vu cv vy cv
      cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv cc
      wcel vu cv cM caddc co vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cfv vu cv vy cv cn0 wcel vz cv c1 c2
      cdiv co vy cv cexp co wceq wa vy vz copab cfv wceq wa vu cc0 cuz cfv wral
      cc0 caddc cop vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy
      vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co cdiv co cli wbr cc0 cM
      caddc co caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2 cdiv co cmin co
      cdiv co cli wbr wb c1 c1 c1 c2 cdiv co cmin co cdiv oprex vu cv vy cv cn0
      wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv cc wcel vu
      cv cM caddc co vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cfv vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co
      vy cv cexp co wceq wa vy vz copab cfv wceq wa vu cc0 cuz cfv vu cv cc0
      cuz cfv wcel vu cv cn0 wcel vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy
      cv cexp co wceq wa vy vz copab cfv cc wcel vu cv cM caddc co vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cfv vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz
      copab cfv wceq wa vu cv elnn0uz vu cv cn0 wcel vu cv vy cv cn0 wcel vz cv
      c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv cc wcel vu cv cM
      caddc co vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp
      co wceq wa vy vz copab cfv vu cv vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv
      cexp co wceq wa vy vz copab cfv wceq vu cv cn0 wcel vu cv vy cv cn0 wcel
      vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv c1 c2 cdiv co
      vu cv cexp co cc vy vz vu cv c1 c2 cdiv co vy cv cexp co c1 c2 cdiv co vu
      cv cexp co cn0 vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa
      vy vz copab vy cv vu cv c1 c2 cdiv co cexp opreq2 vy cv cn0 wcel vz cv c1
      c2 cdiv co vy cv cexp co wceq wa vy vz copab eqid c1 c2 cdiv co vu cv
      cexp oprex fvopab4 c1 c2 cdiv co cc wcel vu cv cn0 wcel c1 c2 cdiv co vu
      cv cexp co cc wcel c2 2cn 2ne0 reccli c1 c2 cdiv co vu cv expcl mpan
      eqeltrd vu cv cn0 wcel c1 c2 cdiv co vu cv cM caddc co cM cmin co cexp co
      c1 c2 cdiv co vu cv cexp co vu cv cM caddc co vy cv cM cuz cfv wcel vz cv
      c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cfv vu cv vy
      cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz copab cfv vu
      cv cn0 wcel vu cv cM caddc co cM cmin co vu cv c1 c2 cdiv co cexp vu cv
      cc wcel cM cc wcel vu cv cM caddc co cM cmin co vu cv wceq vu cv cn0 wcel
      vu cv cM pncan vu cv nn0cn cM cz wcel cM cc wcel cN cM cuz cfv wcel cM cz
      wcel fsumltisumi.1 cM cN eluzel2 ax-mp cM zcn ax-mp sylancl opreq2d vu cv
      cn0 wcel vu cv cM caddc co cM cuz cfv wcel vu cv cM caddc co vy cv cM cuz
      cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cfv c1 c2 cdiv co vu cv cM caddc co cM cmin co cexp co wceq vu cv cn0
      wcel vu cv cM caddc co cM vu cv caddc co cM cuz cfv vu cv cc wcel cM cc
      wcel vu cv cM caddc co cM vu cv caddc co wceq vu cv cn0 wcel vu cv cM
      addcom vu cv nn0cn cM cz wcel cM cc wcel cN cM cuz cfv wcel cM cz wcel
      fsumltisumi.1 cM cN eluzel2 ax-mp cM zcn ax-mp sylancl cM cM cuz cfv wcel
      vu cv cn0 wcel cM vu cv caddc co cM cuz cfv wcel cM cz wcel cM cM cuz cfv
      wcel cN cM cuz cfv wcel cM cz wcel fsumltisumi.1 cM cN eluzel2 ax-mp cM
      uzid ax-mp vu cv cM cM uzaddcl mpan eqeltrd vy vz vu cv cM caddc co c1 c2
      cdiv co vy cv cM cmin co cexp co c1 c2 cdiv co vu cv cM caddc co cM cmin
      co cexp co cM cuz cfv vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab vy cv vu cv cM caddc co wceq vy cv cM
      cmin co vu cv cM caddc co cM cmin co c1 c2 cdiv co cexp vy cv vu cv cM
      caddc co cM cmin opreq1 opreq2d vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co
      vy cv cM cmin co cexp co wceq wa vy vz copab eqid c1 c2 cdiv co vu cv cM
      caddc co cM cmin co cexp oprex fvopab4 syl vy vz vu cv c1 c2 cdiv co vy
      cv cexp co c1 c2 cdiv co vu cv cexp co cn0 vy cv cn0 wcel vz cv c1 c2
      cdiv co vy cv cexp co wceq wa vy vz copab vy cv vu cv c1 c2 cdiv co cexp
      opreq2 vy cv cn0 wcel vz cv c1 c2 cdiv co vy cv cexp co wceq wa vy vz
      copab eqid c1 c2 cdiv co vu cv cexp oprex fvopab4 3eqtr4d jca sylbir rgen
      c1 c1 c1 c2 cdiv co cmin co cdiv co cvv vu vy cv cn0 wcel vz cv c1 c2
      cdiv co vy cv cexp co wceq wa vy vz copab vy cv cM cuz cfv wcel vz cv c1
      c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cM cc0 vy vz cn0
      c1 c2 cdiv co vy cv cexp co nn0ex opabex2 vy vz cM cuz cfv c1 c2 cdiv co
      vy cv cM cmin co cexp co cM cuz fvex opabex2 0z cN cM cuz cfv wcel cM cz
      wcel fsumltisumi.1 cM cN eluzel2 ax-mp iserzshft2i mp2an cc0 cM caddc co
      caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp
      co wceq wa vy vz copab cseqz co cM caddc cop vy cv cM cuz cfv wcel vz cv
      c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co c1 c1
      c1 c2 cdiv co cmin co cdiv co cli cc0 cM caddc co caddc cop cM caddc cop
      vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq
      wa vy vz copab cseqz cc0 cM caddc co cM caddc cM cM cz wcel cM cc wcel cN
      cM cuz cfv wcel cM cz wcel fsumltisumi.1 cM cN eluzel2 ax-mp cM zcn ax-mp
      addid2i opeq1i opreq1i breq1i bitri mpbi cM caddc cop vy cv cM cuz cfv
      wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab
      cseqz co vx cv cli wbr cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cseqz co c1 c1 c1 c2
      cdiv co cmin co cdiv co cli wbr vx c1 c1 c1 c2 cdiv co cmin co cdiv co c1
      c1 c1 c2 cdiv co cmin co cdiv oprex vx cv c1 c1 c1 c2 cdiv co cmin co
      cdiv co cM caddc cop vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cseqz co cli breq2 cla4ev ax-mp
      pm3.2i elimhyp pm3.27i cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co vx cv
      cli wbr cM caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM
      cmin co cexp co wceq wa vy vz copab cif cseqz co vv cv cli wbr vx vv cM
      caddc cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx
      wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp
      co wceq wa vy vz copab cif cseqz co vx cv cli wbr vv ax-17 vx vu cM caddc
      cop cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa
      cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co
      wceq wa vy vz copab cif cseqz co vv cv cli vx vu cM caddc cop cM cuz cfv
      crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab cif cseqz vu cv cM caddc cop wcel vx ax-17 vu cv cseqz wcel vx
      ax-17 cM cuz cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex
      wa vx vu cF vy cv cM cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co
      cexp co wceq wa vy vz copab cM cuz cfv crp cF wf cM caddc cop cF cseqz co
      vx cv cli wbr vx wex vx cM cuz cfv crp cF wf vx ax-17 cM caddc cop cF
      cseqz co vx cv cli wbr vx hbe1 hban vu cv cF wcel vx ax-17 vu cv vy cv cM
      cuz cfv wcel vz cv c1 c2 cdiv co vy cv cM cmin co cexp co wceq wa vy vz
      copab wcel vx ax-17 hbif hbopr vu cv cli wcel vx ax-17 vu cv vv cv wcel
      vx ax-17 hbbr vx cv vv cv cM caddc cop cM cuz cfv crp cF wf cM caddc cop
      cF cseqz co vx cv cli wbr vx wex wa cF vy cv cM cuz cfv wcel vz cv c1 c2
      cdiv co vy cv cM cmin co cexp co wceq wa vy vz copab cif cseqz co cli
      breq2 cbvex mpbi fsumltisumii dedth $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k x y z $. $d N k x y z $. $d F k x y z $.
    $( A partial sum of a series with positive terms is less than the
       infinite sum. $)
    fsumltisum $p |- ( ( ( M e. ZZ /\ N e. ( ZZ>= ` M ) ) /\
          ( F : ( ZZ>= ` M ) --> RR+ /\ E. x ( <. M , + >. seq F ) ~~> x ) ) ->
        sum_ k e. ( M ... N ) ( F ` k ) < sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $=
      cM cz wcel cN cM cuz cfv wcel wa cM cuz cfv crp cF wf cM caddc cop cF
      cseqz co vx cv cli wbr vx wex wa cM cN cfz co vk cv cF cfv vk csu cM cuz
      cfv vk cv cF cfv vk csu clt wbr cM cz wcel cN cM cuz cfv wcel wa cM cuz
      cfv crp cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cN cfz
      co vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu clt wbr wi cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv crp cF wf cM cz wcel cN cM
      cuz cfv wcel wa cM c1 cif caddc cop cF cseqz co vx cv cli wbr vx wex wa
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk csu
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk csu
      clt wbr wi cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv crp cF wf
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF cseqz co vx cv
      cli wbr vx wex wa cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cM cz wcel
      cN cM cuz cfv wcel wa cN c1 cif cfz co vk cv cF cfv vk csu cM cz wcel cN
      cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk csu clt wbr wi cM cN
      c1 c1 cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM cuz cfv crp
      cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cz wcel cN cM
      cuz cfv wcel wa cM c1 cif cuz cfv crp cF wf cM cz wcel cN cM cuz cfv wcel
      wa cM c1 cif caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cN cfz co
      vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu clt wbr cM cz wcel cN
      cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk csu cM cz wcel cN
      cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk csu clt wbr cM cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM cuz cfv crp cF wf cM cz wcel
      cN cM cuz cfv wcel wa cM c1 cif cuz cfv crp cF wf cM caddc cop cF cseqz
      co vx cv cli wbr vx wex cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc
      cop cF cseqz co vx cv cli wbr vx wex cM cM cz wcel cN cM cuz cfv wcel wa
      cM c1 cif wceq cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz
      cfv wceq cM cuz cfv crp cF wf cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      cuz cfv crp cF wf wb cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz
      fveq2 cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv crp
      cF feq2 syl cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM caddc
      cop cF cseqz co vx cv cli wbr cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      caddc cop cF cseqz co vx cv cli wbr vx cM cM cz wcel cN cM cuz cfv wcel
      wa cM c1 cif wceq cM caddc cop cF cseqz co cM cz wcel cN cM cuz cfv wcel
      wa cM c1 cif caddc cop cF cseqz co vx cv cli cM cM cz wcel cN cM cuz cfv
      wcel wa cM c1 cif wceq cM caddc cop cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif caddc cop cF cseqz cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      caddc opeq1 opreq1d breq1d exbidv anbi12d cM cM cz wcel cN cM cuz cfv
      wcel wa cM c1 cif wceq cM cN cfz co vk cv cF cfv vk csu cM cz wcel cN cM
      cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk csu cM cuz cfv vk cv
      cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF
      cfv vk csu clt cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM cN
      cfz co cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv
      vk cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz opreq1 sumeq1d cM
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM cuz cfv cM cz wcel cN
      cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk cM cM cz wcel cN cM
      cuz cfv wcel wa cM c1 cif cuz fveq2 sumeq1d breq12d imbi12d cN cM cz wcel
      cN cM cuz cfv wcel wa cN c1 cif wceq cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif cN cfz co vk cv cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif cuz cfv vk cv cF cfv vk csu clt wbr cM cz wcel cN cM cuz cfv wcel
      wa cM c1 cif cM cz wcel cN cM cuz cfv wcel wa cN c1 cif cfz co vk cv cF
      cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF
      cfv vk csu clt wbr cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv crp
      cF wf cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF cseqz co vx
      cv cli wbr vx wex wa cN cM cz wcel cN cM cuz cfv wcel wa cN c1 cif wceq
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk csu
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cM cz wcel cN cM cuz cfv wcel
      wa cN c1 cif cfz co vk cv cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa
      cM c1 cif cuz cfv vk cv cF cfv vk csu clt cN cM cz wcel cN cM cuz cfv
      wcel wa cN c1 cif wceq cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz
      co cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cM cz wcel cN cM cuz cfv
      wcel wa cN c1 cif cfz co vk cv cF cfv vk cN cM cz wcel cN cM cuz cfv wcel
      wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cfz opreq2
      sumeq1d breq1d imbi2d vx vk cF cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      cM cz wcel cN cM cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel
      wa cN cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv wcel cM cz wcel
      cN cM cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cM c1
      cif cuz cfv wcel c1 c1 cuz cfv wcel cM cN c1 c1 c1 cM cz wcel cN cM cuz
      cfv wcel wa cM c1 cif cuz cfv wcel cM cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif wceq cN cM cuz cfv wcel cN cM cz wcel cN cM cuz cfv wcel wa cM c1
      cif cuz cfv wcel cM cz wcel cN cM cuz cfv wcel wa cM cM cz wcel cN cM cuz
      cfv wcel wa cM c1 cif wceq cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif cuz cfv cN cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz fveq2
      eleq2d cN cM cuz cfv wcel cM cz wcel cM cN eluzel2 pm4.71ri syl5bbr cN cM
      cz wcel cN cM cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa
      cM c1 cif cuz cfv eleq1 c1 cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      wceq c1 cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv c1 c1
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz fveq2 eleq2d c1 cM cz wcel
      cN cM cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cM c1
      cif cuz cfv eleq1 c1 cz wcel c1 c1 cuz cfv wcel 1z c1 uzid ax-mp
      elimhyp2v fsumltisumi dedth2v imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k x $. $d N k x $. $d F k x $.
    fsumleisumii.1 $e |- N e. ( ZZ>= ` M ) $.
    fsumleisumii.2 $e |- F : ( ZZ>= ` M ) --> RR $.
    fsumleisumii.3 $e |- A. k e. ( ZZ>= ` M ) 0 <_ ( F ` k ) $.
    fsumleisumii.4 $e |- E. x ( <. M , + >. seq F ) ~~> x $.
    $( A partial sum of a series with nonnegative terms is less than or equal
       to the infinite sum. $)
    fsumleisumii $p |- sum_ k e. ( M ... N ) ( F ` k ) <_
                                        sum_ k e. ( ZZ>= ` M ) ( F ` k ) $=
      cM cN cfz co vk cv cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cN c1
      caddc co cuz cfv vk cv cF cfv vk csu caddc co cM cuz cfv vk cv cF cfv vk
      csu cle cM cN cfz co vk cv cF cfv vk csu cc0 caddc co cM cN cfz co vk cv
      cF cfv vk csu cM cN cfz co vk cv cF cfv vk csu cN c1 caddc co cuz cfv vk
      cv cF cfv vk csu caddc co cle cM cN cfz co vk cv cF cfv vk csu cN cM cuz
      cfv wcel vk cv cF cfv cc wcel vk cM cN cfz co wral cM cN cfz co vk cv cF
      cfv vk csu cc wcel fsumleisumii.1 vk cv cF cfv cc wcel vk cM cN cfz co vk
      cv cM cN cfz co wcel vk cv cM cuz cfv wcel vk cv cF cfv cr wcel vk cv cF
      cfv cc wcel vk cv cM cN elfzuz cM cuz cfv cr vk cv cF fsumleisumii.2
      ffvelrni vk cv cF cfv recn 3syl rgen vk cv cF cfv vk cM cN fsumcl mp2an
      addid1i cc0 cN c1 caddc co cuz cfv vk cv cF cfv vk csu cle wbr cM cN cfz
      co vk cv cF cfv vk csu cc0 caddc co cM cN cfz co vk cv cF cfv vk csu cN
      c1 caddc co cuz cfv vk cv cF cfv vk csu caddc co cle wbr cN c1 caddc co
      cz wcel cN c1 caddc co caddc cop cF cseqz co cN c1 caddc co cuz cfv vk cv
      cF cfv vk csu cli wbr vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk
      cN c1 caddc co cuz cfv wral cc0 cN c1 caddc co cuz cfv vk cv cF cfv vk
      csu cle wbr cN cz wcel cN c1 caddc co cz wcel cN cM cuz cfv wcel cN cz
      wcel fsumleisumii.1 cM cN eluzelz ax-mp cN peano2z ax-mp cN c1 caddc co
      cz wcel cN c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex cN c1
      caddc co caddc cop cF cseqz co cN c1 caddc co cuz cfv vk cv cF cfv vk csu
      cli wbr cN cz wcel cN c1 caddc co cz wcel cN cM cuz cfv wcel cN cz wcel
      fsumleisumii.1 cM cN eluzelz ax-mp cN peano2z ax-mp cN cM cuz cfv wcel vk
      cv cF cfv cc wcel vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex cN c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex
      fsumleisumii.1 vk cv cF cfv cc wcel vk cM cuz cfv vk cv cM cuz cfv wcel
      vk cv cF cfv cM cuz cfv cr vk cv cF fsumleisumii.2 ffvelrni recnd rgen
      fsumleisumii.4 vx vk cF cM cN cM cuz cfv cr cF wf cM cuz cfv cvv wcel cF
      cvv wcel fsumleisumii.2 cM cuz fvex cM cuz cfv cr cvv cF fex mp2an
      iserzex mp3an vx vk cF cN c1 caddc co cM cuz cfv cr cF wf cM cuz cfv cvv
      wcel cF cvv wcel fsumleisumii.2 cM cuz fvex cM cuz cfv cr cvv cF fex
      mp2an isumclim2 mp2an vk cv cF cfv cr wcel cc0 vk cv cF cfv cle wbr wa vk
      cN c1 caddc co cuz cfv vk cv cN c1 caddc co cuz cfv wcel vk cv cF cfv cr
      wcel cc0 vk cv cF cfv cle wbr vk cv cN c1 caddc co cuz cfv wcel vk cv cM
      cuz cfv wcel vk cv cF cfv cr wcel cN c1 caddc co cuz cfv cM cuz cfv vk cv
      cN c1 caddc co cM cuz cfv wcel cN c1 caddc co cuz cfv cM cuz cfv wss cN
      cM cuz cfv wcel c1 cn0 wcel cN c1 caddc co cM cuz cfv wcel fsumleisumii.1
      1nn0 c1 cM cN uzaddcl mp2an cM cN c1 caddc co uzss ax-mp sseli cM cuz cfv
      cr vk cv cF fsumleisumii.2 ffvelrni syl vk cv cN c1 caddc co cuz cfv wcel
      vk cv cM cuz cfv wcel cc0 vk cv cF cfv cle wbr cN c1 caddc co cuz cfv cM
      cuz cfv vk cv cN c1 caddc co cM cuz cfv wcel cN c1 caddc co cuz cfv cM
      cuz cfv wss cN cM cuz cfv wcel c1 cn0 wcel cN c1 caddc co cM cuz cfv wcel
      fsumleisumii.1 1nn0 c1 cM cN uzaddcl mp2an cM cN c1 caddc co uzss ax-mp
      sseli cc0 vk cv cF cfv cle wbr vk cM cuz cfv fsumleisumii.3 rspec syl jca
      rgen cN c1 caddc co cuz cfv vk cv cF cfv vk csu vk cF cN c1 caddc co cN
      c1 caddc co cuz cfv vk cv cF cfv vk sumex cM cuz cfv cr cF wf cM cuz cfv
      cvv wcel cF cvv wcel fsumleisumii.2 cM cuz fvex cM cuz cfv cr cvv cF fex
      mp2an iserzcmp0 mp3an cc0 cN c1 caddc co cuz cfv vk cv cF cfv vk csu cM
      cN cfz co vk cv cF cfv vk csu 0re cN c1 caddc co cz wcel vk cv cF cfv cr
      wcel vk cN c1 caddc co cuz cfv wral cN c1 caddc co caddc cop cF cseqz co
      vx cv cli wbr vx wex cN c1 caddc co cuz cfv vk cv cF cfv vk csu cr wcel
      cN cz wcel cN c1 caddc co cz wcel cN cM cuz cfv wcel cN cz wcel
      fsumleisumii.1 cM cN eluzelz ax-mp cN peano2z ax-mp vk cv cF cfv cr wcel
      vk cN c1 caddc co cuz cfv vk cv cN c1 caddc co cuz cfv wcel vk cv cM cuz
      cfv wcel vk cv cF cfv cr wcel cN c1 caddc co cuz cfv cM cuz cfv vk cv cN
      c1 caddc co cM cuz cfv wcel cN c1 caddc co cuz cfv cM cuz cfv wss cN cM
      cuz cfv wcel c1 cn0 wcel cN c1 caddc co cM cuz cfv wcel fsumleisumii.1
      1nn0 c1 cM cN uzaddcl mp2an cM cN c1 caddc co uzss ax-mp sseli cM cuz cfv
      cr vk cv cF fsumleisumii.2 ffvelrni syl rgen cN cM cuz cfv wcel vk cv cF
      cfv cc wcel vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex cN c1 caddc co caddc cop cF cseqz co vx cv cli wbr vx wex
      fsumleisumii.1 vk cv cF cfv cc wcel vk cM cuz cfv vk cv cM cuz cfv wcel
      vk cv cF cfv cM cuz cfv cr vk cv cF fsumleisumii.2 ffvelrni recnd rgen
      fsumleisumii.4 vx vk cF cM cN cM cuz cfv cr cF wf cM cuz cfv cvv wcel cF
      cvv wcel fsumleisumii.2 cM cuz fvex cM cuz cfv cr cvv cF fex mp2an
      iserzex mp3an vx vk cF cN c1 caddc co cM cuz cfv cr cF wf cM cuz cfv cvv
      wcel cF cvv wcel fsumleisumii.2 cM cuz fvex cM cuz cfv cr cvv cF fex
      mp2an isumrecl mp3an cN cM cuz cfv wcel vk cv cF cfv cr wcel vk cM cN cfz
      co wral cM cN cfz co vk cv cF cfv vk csu cr wcel fsumleisumii.1 vk cv cF
      cfv cr wcel vk cM cN cfz co vk cv cM cN cfz co wcel vk cv cM cuz cfv wcel
      vk cv cF cfv cr wcel vk cv cM cN elfzuz cM cuz cfv cr vk cv cF
      fsumleisumii.2 ffvelrni syl rgen vk cv cF cfv vk cM cN fsumrecl mp2an
      leadd2i mpbi eqbrtrri vx vk cF cM cN cN cM cuz cfv wcel cM cz wcel
      fsumleisumii.1 cM cN eluzel2 ax-mp fsumleisumii.1 cM cuz cfv cr cF wf cr
      cc wss cM cuz cfv cc cF wf fsumleisumii.2 axresscn cM cuz cfv cr cc cF
      fss mp2an fsumleisumii.4 isumspliti breqtrri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M j k u v x y z $. $d N j k u v x y z $. $d F j k u v x y z $.
    fsumleisumi.1 $e |- N e. ( ZZ>= ` M ) $.
    $( A partial sum of a series with nonnegative terms is less than or equal
       to the infinite sum. $)
    fsumleisumi $p |- ( ( F : ( ZZ>= ` M ) --> RR /\ A. k e. ( ZZ>= ` M )
                      0 <_ ( F ` k ) /\ E. x ( <. M , + >. seq F ) ~~> x ) ->
       sum_ k e. ( M ... N ) ( F ` k ) <_ sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $=
      cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex cM cN cfz co vk cv cF cfv vk csu cM
      cuz cfv vk cv cF cfv vk csu cle wbr cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cN cfz co vk cv cF
      cfv vk csu cM cuz cfv vk cv cF cfv vk csu cle wbr cM cN cfz co vk cv cM
      cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv vk
      csu cM cuz cfv vk cv cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cfv vk csu cle wbr cF cM cuz cfv cc0 csn cxp cF cM
      cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq
      cM cN cfz co vk cv cF cfv vk csu cM cN cfz co vk cv cM cuz cfv cr cF wf
      cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv vk csu cM cuz cfv
      vk cv cF cfv vk csu cM cuz cfv vk cv cM cuz cfv cr cF wf cc0 vj cv cF cfv
      cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cfv vk csu cle cF cM cuz cfv cr cF wf
      cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM cN cfz co vk
      cv cF cfv vk cv cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif cfv vk vk cv cF cM cuz cfv cr cF wf cc0 vj cv cF cfv cle
      wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif fveq1 sumeq2sdv cF cM cuz cfv cr cF wf cc0
      vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM cuz cfv vk cv cF
      cfv vk cv cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif cfv vk vk cv cF cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM
      cuz cfv cc0 csn cxp cif fveq1 sumeq2sdv breq12d vv vk cM cuz cfv cr cF wf
      cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM cN fsumleisumi.1
      cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0
      csn cxp cif wf cM cuz cfv cr cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr
      vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF
      cM cuz cfv cc0 csn cxp cif wf cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx wex cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0
      csn cxp cif cseqz co vx cv cli wbr vx wex w3a cM cuz cfv cr cM cuz cfv
      cc0 csn cxp wf cc0 vk cv cM cuz cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif wceq cM cuz cfv cr cF wf cM cuz cfv cr cM
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cc0 vk cv cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex cM caddc cop cM
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz
      co vx cv cli wbr vx wex cM cuz cfv cr cF cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif feq1 cF cM cuz cfv cr cF wf cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cc0 vk cv cF cfv cle
      wbr cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0
      csn cxp cif cfv cle wbr vk cM cuz cfv vk vu vu cF cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif vu cv cF wcel vk ax-17
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a vk vu cF cM cuz cfv cc0 csn cxp
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex vk cM cuz cfv cr cF wf vk ax-17 cc0
      vk cv cF cfv cle wbr vk cM cuz cfv hbra1 cM caddc cop cF cseqz co vx cv
      cli wbr vx wex vk ax-17 hb3an vu cv cF wcel vk ax-17 vu cv cM cuz cfv cc0
      csn cxp wcel vk ax-17 hbif hbeq cF cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif wceq vk cv cF cfv vk cv cM cuz cfv cr
      cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cc0 cle vk
      cv cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif fveq1 breq2d ralbid cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF
      cM cuz cfv cc0 csn cxp cif wceq cM caddc cop cF cseqz co vx cv cli wbr cM
      caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif cseqz co vx cv cli wbr vx vx vu vu cF cM cuz cfv cr cF wf cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif vu cv cF wcel vx ax-17 cM
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a vx vu cF cM cuz cfv cc0 csn cxp cM
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex vx cM cuz cfv cr cF wf vx ax-17 cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral vx ax-17 cM caddc cop cF cseqz co vx
      cv cli wbr vx hbe1 hb3an vu cv cF wcel vx ax-17 vu cv cM cuz cfv cc0 csn
      cxp wcel vx ax-17 hbif hbeq cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif wceq cM caddc cop cF cseqz co cM caddc cop
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif
      cseqz co vx cv cli cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cM caddc cop cseqz opreq2 breq1d exbid 3anbi123d cM
      cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif wceq cM cuz cfv cr cM cuz cfv cc0 csn cxp wf cM cuz
      cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif wf cc0 vk cv cM cuz cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv wral
      cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif cfv cle wbr vk cM cuz cfv wral cM caddc cop cM cuz cfv cc0 csn
      cxp cseqz co vx cv cli wbr vx wex cM caddc cop cM cuz cfv cr cF wf cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx
      wex cM cuz cfv cr cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif feq1 cM cuz cfv cc0 csn cxp cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cc0
      vk cv cM cuz cfv cc0 csn cxp cfv cle wbr cc0 vk cv cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz
      cfv vk vu vu cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif vu cv cM cuz cfv cc0 csn cxp wcel vk
      ax-17 cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a vk vu cF cM cuz cfv cc0
      csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex vk cM cuz cfv cr cF wf vk
      ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz cfv hbra1 cM caddc cop cF cseqz
      co vx cv cli wbr vx wex vk ax-17 hb3an vu cv cF wcel vk ax-17 vu cv cM
      cuz cfv cc0 csn cxp wcel vk ax-17 hbif hbeq cM cuz cfv cc0 csn cxp cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq vk
      cv cM cuz cfv cc0 csn cxp cfv vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cfv cc0 cle vk cv cM cuz cfv cc0 csn
      cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif fveq1 breq2d ralbid cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM caddc cop cM cuz cfv
      cc0 csn cxp cseqz co vx cv cli wbr cM caddc cop cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr
      vx vx vu vu cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif vu cv cM cuz cfv cc0 csn cxp wcel vx
      ax-17 cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a vx vu cF cM cuz cfv cc0
      csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex vx cM cuz cfv cr cF wf vx
      ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral vx ax-17 cM caddc cop
      cF cseqz co vx cv cli wbr vx hbe1 hb3an vu cv cF wcel vx ax-17 vu cv cM
      cuz cfv cc0 csn cxp wcel vx ax-17 hbif hbeq cM cuz cfv cc0 csn cxp cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM
      caddc cop cM cuz cfv cc0 csn cxp cseqz co cM caddc cop cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli
      cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cM caddc cop cseqz opreq2 breq1d exbid 3anbi123d cM
      cuz cfv cr cM cuz cfv cc0 csn cxp wf cc0 vk cv cM cuz cfv cc0 csn cxp cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cM cuz cfv cc0 csn cxp cseqz co
      vx cv cli wbr vx wex cM cuz cfv cc0 csn cM cuz cfv cc0 csn cxp wf cc0 csn
      cr wss cM cuz cfv cr cM cuz cfv cc0 csn cxp wf cM cuz cfv cc0 cc0 cc 0cn
      elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp cM cuz
      cfv cc0 csn cr cM cuz cfv cc0 csn cxp fss mp2an cc0 vk cv cM cuz cfv cc0
      csn cxp cfv cle wbr vk cM cuz cfv vk cv cM cuz cfv wcel cc0 vk cv cM cuz
      cfv cc0 csn cxp cfv cc0 cle cM cuz cfv cc0 vk cv cc0 cc 0cn elisseti
      fvconst2 cc0 0re leidi syl5breqr rgen cM caddc cop cM cuz cfv cc0 csn cxp
      cseqz co cc0 cli wbr cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv
      cli wbr vx wex cM cz wcel cM caddc cop cM cuz cfv cc0 csn cxp cseqz co
      cc0 cli wbr cN cM cuz cfv wcel cM cz wcel fsumleisumi.1 cM cN eluzel2
      ax-mp cM serzclim0 ax-mp cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx
      cv cli wbr cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cc0 cli wbr vx
      cc0 cc0 cc 0cn elisseti vx cv cc0 cM caddc cop cM cuz cfv cc0 csn cxp
      cseqz co cli breq2 cla4ev ax-mp 3pm3.2i elimhyp 3simp1i cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF
      wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM cuz cfv cr
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf
      cM cuz cfv cr cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0
      csn cxp cif wf wb cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cuz cfv cr
      cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a wb cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF wf cc0 vj cv cF cfv cle
      wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif wceq cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM cuz cfv cr cF wf cM
      caddc cop cF cseqz co vx cv cli wbr vx wex cc0 vk cv cF cfv cle wbr cc0
      vj cv cF cfv cle wbr vk vj cM cuz cfv vk cv vj cv wceq vk cv cF cfv vj cv
      cF cfv cc0 cle vk cv vj cv cF fveq2 breq2d cbvralv 3anbi2i cM cuz cfv cr
      cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr
      vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF
      cM cuz cfv cc0 csn cxp ifbi ax-mp cM cuz cfv cr cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF wf cc0
      vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif feq1 ax-mp mpbi cc0 vk
      cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif cfv cle wbr vk cM cuz cfv wral cc0 vk cv cM cuz cfv cr cF wf cc0 vj
      cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv
      wral cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif wf cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF
      cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv wral cM caddc cop cM
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz
      co vx cv cli wbr vx wex cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cuz
      cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif wf cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif cfv cle wbr vk cM cuz cfv wral cM caddc cop cM cuz cfv cr
      cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv
      cli wbr vx wex w3a cM cuz cfv cr cM cuz cfv cc0 csn cxp wf cc0 vk cv cM
      cuz cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv wral cM caddc cop cM cuz
      cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif wceq cM cuz cfv cr cF wf cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cF cfv cle wbr vk
      cM cuz cfv wral cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM
      cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex cM caddc cop cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx wex cM
      cuz cfv cr cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0
      csn cxp cif feq1 cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif wceq cc0 vk cv cF cfv cle wbr cc0 vk cv cM cuz cfv cr
      cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk
      cM cuz cfv vk vu vu cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif vu cv cF wcel vk ax-17 cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a vk vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex vk cM cuz cfv cr cF wf vk ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv hbra1 cM caddc cop cF cseqz co vx cv cli wbr vx wex vk ax-17 hb3an vu
      cv cF wcel vk ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vk ax-17 hbif hbeq
      cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif wceq vk cv cF cfv vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF
      cM cuz cfv cc0 csn cxp cif cfv cc0 cle vk cv cF cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif fveq1 breq2d ralbid cF
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif
      wceq cM caddc cop cF cseqz co vx cv cli wbr cM caddc cop cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli
      wbr vx vx vu vu cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif vu cv cF wcel vx ax-17 cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a vx vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex vx cM cuz cfv cr cF wf vx ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral vx ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx hbe1 hb3an vu
      cv cF wcel vx ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vx ax-17 hbif hbeq
      cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif wceq cM caddc cop cF cseqz co cM caddc cop cM cuz cfv cr cF wf cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli cF cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM caddc
      cop cseqz opreq2 breq1d exbid 3anbi123d cM cuz cfv cc0 csn cxp cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM
      cuz cfv cr cM cuz cfv cc0 csn cxp wf cM cuz cfv cr cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cM cuz
      cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv wral cc0 vk cv cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr
      vx wex cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx wex cM cuz cfv cr cM cuz
      cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif feq1 cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cc0 vk cv cM cuz cfv cc0
      csn cxp cfv cle wbr cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv vk vu vu cM cuz
      cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif vu cv cM cuz cfv cc0 csn cxp wcel vk ax-17 cM cuz cfv cr
      cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a vk vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr
      cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex vk cM cuz cfv cr cF wf vk ax-17 cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv hbra1 cM caddc cop cF cseqz co vx cv cli wbr vx wex
      vk ax-17 hb3an vu cv cF wcel vk ax-17 vu cv cM cuz cfv cc0 csn cxp wcel
      vk ax-17 hbif hbeq cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq vk cv cM cuz cfv cc0 csn
      cxp cfv vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0
      csn cxp cif cfv cc0 cle vk cv cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif fveq1 breq2d ralbid
      cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif wceq cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx
      cv cli wbr cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM
      cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx vx vu vu cM cuz cfv cc0
      csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif vu cv cM cuz cfv cc0 csn cxp wcel vx ax-17 cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a vx vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex vx cM cuz cfv cr cF wf vx ax-17 cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral vx ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx
      hbe1 hb3an vu cv cF wcel vx ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vx
      ax-17 hbif hbeq cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM caddc cop cM cuz cfv cc0
      csn cxp cseqz co cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli cM cuz cfv cc0 csn cxp
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM
      caddc cop cseqz opreq2 breq1d exbid 3anbi123d cM cuz cfv cr cM cuz cfv
      cc0 csn cxp wf cc0 vk cv cM cuz cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex cM
      cuz cfv cc0 csn cM cuz cfv cc0 csn cxp wf cc0 csn cr wss cM cuz cfv cr cM
      cuz cfv cc0 csn cxp wf cM cuz cfv cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp cM cuz cfv cc0 csn cr cM cuz
      cfv cc0 csn cxp fss mp2an cc0 vk cv cM cuz cfv cc0 csn cxp cfv cle wbr vk
      cM cuz cfv vk cv cM cuz cfv wcel cc0 vk cv cM cuz cfv cc0 csn cxp cfv cc0
      cle cM cuz cfv cc0 vk cv cc0 cc 0cn elisseti fvconst2 cc0 0re leidi
      syl5breqr rgen cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cc0 cli wbr
      cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex cM cz
      wcel cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cc0 cli wbr cN cM cuz
      cfv wcel cM cz wcel fsumleisumi.1 cM cN eluzel2 ax-mp cM serzclim0 ax-mp
      cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr cM caddc cop
      cM cuz cfv cc0 csn cxp cseqz co cc0 cli wbr vx cc0 cc0 cc 0cn elisseti vx
      cv cc0 cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cli breq2 cla4ev
      ax-mp 3pm3.2i elimhyp 3simp2i cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr cc0 vk cv cM cuz cfv cr
      cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz
      co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk
      cM cuz cfv vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif cfv vk cv cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM
      cuz cfv cc0 csn cxp cif cfv cc0 cle vk cv cM cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr
      vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF wf cc0 vj cv cF
      cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a wb cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF wf
      cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM
      cuz cfv cr cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex cc0 vk cv
      cF cfv cle wbr cc0 vj cv cF cfv cle wbr vk vj cM cuz cfv vk cv vj cv wceq
      vk cv cF cfv vj cv cF cfv cc0 cle vk cv vj cv cF fveq2 breq2d cbvralv
      3anbi2i cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cuz cfv cr cF wf cc0
      vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp ifbi ax-mp fveq1i breq2i
      ralbii mpbi cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk
      cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM
      cuz cfv cc0 csn cxp cif cseqz co vv cv cli wbr vv wex cM caddc cop cM cuz
      cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co
      vv cv cli wbr vv wex cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx wex cM caddc
      cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif cseqz co vv cv cli wbr vv wex cM cuz cfv cr cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx wex cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cM cuz cfv cr cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx wex w3a cM
      cuz cfv cr cM cuz cfv cc0 csn cxp wf cc0 vk cv cM cuz cfv cc0 csn cxp cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cM cuz cfv cc0 csn cxp cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cF cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM cuz cfv cr cF
      wf cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cc0 vk cv
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif cseqz co vx cv cli wbr vx wex cM cuz cfv cr cF cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif feq1 cF
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif
      wceq cc0 vk cv cF cfv cle wbr cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv vk vu vu
      cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif vu cv cF wcel vk ax-17 cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a vk
      vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex vk cM
      cuz cfv cr cF wf vk ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz cfv hbra1 cM
      caddc cop cF cseqz co vx cv cli wbr vx wex vk ax-17 hb3an vu cv cF wcel
      vk ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vk ax-17 hbif hbeq cF cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq vk
      cv cF cfv vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif cfv cc0 cle vk cv cF cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif fveq1 breq2d ralbid cF cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM caddc cop
      cF cseqz co vx cv cli wbr cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vx vx vu vu
      cF cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif vu cv cF wcel vx ax-17 cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a vx
      vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex vx cM
      cuz cfv cr cF wf vx ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral vx
      ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx hbe1 hb3an vu cv cF wcel
      vx ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vx ax-17 hbif hbeq cF cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM
      caddc cop cF cseqz co cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli cF cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM caddc cop cseqz
      opreq2 breq1d exbid 3anbi123d cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cM cuz cfv cr cM
      cuz cfv cc0 csn cxp wf cM cuz cfv cr cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif wf cc0 vk cv cM cuz cfv cc0 csn cxp cfv
      cle wbr vk cM cuz cfv wral cc0 vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a cF cM cuz cfv cc0 csn cxp cif cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex cM caddc cop cM
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz
      co vx cv cli wbr vx wex cM cuz cfv cr cM cuz cfv cc0 csn cxp cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif feq1 cM
      cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif wceq cc0 vk cv cM cuz cfv cc0 csn cxp cfv cle wbr cc0
      vk cv cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif cfv cle wbr vk cM cuz cfv vk vu vu cM cuz cfv cc0 csn cxp cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif vu cv cM
      cuz cfv cc0 csn cxp wcel vk ax-17 cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a vk vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      vk cM cuz cfv cr cF wf vk ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      hbra1 cM caddc cop cF cseqz co vx cv cli wbr vx wex vk ax-17 hb3an vu cv
      cF wcel vk ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vk ax-17 hbif hbeq cM
      cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif wceq vk cv cM cuz cfv cc0 csn cxp cfv vk cv cM cuz
      cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cfv cc0
      cle vk cv cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif fveq1 breq2d ralbid cM cuz cfv cc0 csn cxp
      cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc
      cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif
      wceq cM caddc cop cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr cM caddc
      cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif cseqz co vx cv cli wbr vx vx vu vu cM cuz cfv cc0 csn cxp cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif vu cv cM
      cuz cfv cc0 csn cxp wcel vx ax-17 cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      w3a vx vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex
      vx cM cuz cfv cr cF wf vx ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral vx ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx hbe1 hb3an vu cv
      cF wcel vx ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vx ax-17 hbif hbeq cM
      cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif wceq cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cM
      caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif cseqz co vx cv cli cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0
      vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM caddc cop cseqz
      opreq2 breq1d exbid 3anbi123d cM cuz cfv cr cM cuz cfv cc0 csn cxp wf cc0
      vk cv cM cuz cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv wral cM caddc cop
      cM cuz cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex cM cuz cfv cc0 csn
      cM cuz cfv cc0 csn cxp wf cc0 csn cr wss cM cuz cfv cr cM cuz cfv cc0 csn
      cxp wf cM cuz cfv cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr
      wss 0re cc0 cr snssi ax-mp cM cuz cfv cc0 csn cr cM cuz cfv cc0 csn cxp
      fss mp2an cc0 vk cv cM cuz cfv cc0 csn cxp cfv cle wbr vk cM cuz cfv vk
      cv cM cuz cfv wcel cc0 vk cv cM cuz cfv cc0 csn cxp cfv cc0 cle cM cuz
      cfv cc0 vk cv cc0 cc 0cn elisseti fvconst2 cc0 0re leidi syl5breqr rgen
      cM caddc cop cM cuz cfv cc0 csn cxp cseqz co cc0 cli wbr cM caddc cop cM
      cuz cfv cc0 csn cxp cseqz co vx cv cli wbr vx wex cM cz wcel cM caddc cop
      cM cuz cfv cc0 csn cxp cseqz co cc0 cli wbr cN cM cuz cfv wcel cM cz wcel
      fsumleisumi.1 cM cN eluzel2 ax-mp cM serzclim0 ax-mp cM caddc cop cM cuz
      cfv cc0 csn cxp cseqz co vx cv cli wbr cM caddc cop cM cuz cfv cc0 csn
      cxp cseqz co cc0 cli wbr vx cc0 cc0 cc 0cn elisseti vx cv cc0 cM caddc
      cop cM cuz cfv cc0 csn cxp cseqz co cli breq2 cla4ev ax-mp 3pm3.2i
      elimhyp 3simp3i cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr
      vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF
      cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr cM caddc cop cM cuz cfv
      cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF
      cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co
      vv cv cli wbr vx vv cM caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cF cM cuz cfv cc0 csn cxp cif cseqz co vx cv cli wbr vv ax-17 vx vu cM
      caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif cseqz co vv cv cli vx vu cM caddc cop cM cuz cfv cr cF wf cc0 vk
      cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz vu cv cM caddc cop
      wcel vx ax-17 vu cv cseqz wcel vx ax-17 cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a vx vu cF cM cuz cfv cc0 csn cxp cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex vx cM cuz cfv cr cF wf vx ax-17 cc0 vk cv cF cfv cle wbr vk cM cuz
      cfv wral vx ax-17 cM caddc cop cF cseqz co vx cv cli wbr vx hbe1 hb3an vu
      cv cF wcel vx ax-17 vu cv cM cuz cfv cc0 csn cxp wcel vx ax-17 hbif hbopr
      vu cv cli wcel vx ax-17 vu cv vv cv wcel vx ax-17 hbbr vx cv vv cv cM
      caddc cop cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn
      cxp cif cseqz co cli breq2 cbvex mpbi cM caddc cop cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co vv cv cli
      wbr cM caddc cop cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz
      cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv
      cc0 csn cxp cif cseqz co vv cv cli wbr vv cM caddc cop cM cuz cfv cr cF
      wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co
      vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cseqz co cM caddc
      cop cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp
      cif cseqz co vv cv cli cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM
      cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cF cM cuz
      cfv cc0 csn cxp cif cM caddc cop cseqz cM cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx
      wex w3a cM cuz cfv cr cF wf cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a wb cM cuz cfv cr cF wf
      cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif cM cuz cfv cr cF wf
      cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp cif wceq cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv wral cc0 vj cv cF cfv cle wbr vj cM cuz cfv wral cM
      cuz cfv cr cF wf cM caddc cop cF cseqz co vx cv cli wbr vx wex cc0 vk cv
      cF cfv cle wbr cc0 vj cv cF cfv cle wbr vk vj cM cuz cfv vk cv vj cv wceq
      vk cv cF cfv vj cv cF cfv cc0 cle vk cv vj cv cF fveq2 breq2d cbvralv
      3anbi2i cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv wral
      cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cuz cfv cr cF wf cc0
      vj cv cF cfv cle wbr vj cM cuz cfv wral cM caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cF cM cuz cfv cc0 csn cxp ifbi ax-mp opreq2i breq1i
      exbii mpbi fsumleisumii dedth cc0 vk cv cF cfv cle wbr cc0 vj cv cF cfv
      cle wbr vk vj cM cuz cfv vk cv vj cv wceq vk cv cF cfv vj cv cF cfv cc0
      cle vk cv vj cv cF fveq2 breq2d cbvralv syl3an2b $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k x y z $. $d N k x y z $. $d F k x y z $.
    $( A partial sum of a series with nonnegative terms is less than or equal
       to the infinite sum. $)
    fsumleisum $p |- ( ( ( M e. ZZ /\ N e. ( ZZ>= ` M ) ) /\
               ( F : ( ZZ>= ` M ) --> RR /\ A. k e. ( ZZ>= ` M ) 0 <_ ( F ` k )
                              /\ E. x ( <. M , + >. seq F ) ~~> x ) ) ->
       sum_ k e. ( M ... N ) ( F ` k ) <_ sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) $=
      cM cz wcel cN cM cuz cfv wcel wa cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cM cN cfz co vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu cle wbr
      cM cz wcel cN cM cuz cfv wcel wa cM cuz cfv cr cF wf cc0 vk cv cF cfv cle
      wbr vk cM cuz cfv wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a
      cM cN cfz co vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu cle wbr
      wi cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv wral
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF cseqz co vx cv
      cli wbr vx wex w3a cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co
      vk cv cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk
      cv cF cfv vk csu cle wbr wi cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cz wcel cN cM cuz cfv
      wcel wa cM c1 cif cuz cfv wral cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cz wcel cN cM cuz cfv
      wcel wa cM c1 cif cM cz wcel cN cM cuz cfv wcel wa cN c1 cif cfz co vk cv
      cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF
      cfv vk csu cle wbr wi cM cN c1 c1 cM cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif wceq cM cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM cuz cfv
      wral cM caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM cz wcel cN cM
      cuz cfv wcel wa cM c1 cif cuz cfv cr cF wf cc0 vk cv cF cfv cle wbr vk cM
      cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv wral cM cz wcel cN cM cuz
      cfv wcel wa cM c1 cif caddc cop cF cseqz co vx cv cli wbr vx wex w3a cM
      cN cfz co vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu cle wbr cM
      cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk csu cM
      cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk csu cle
      wbr cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM cuz cfv cr cF
      wf cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv cr cF wf cc0 vk cv
      cF cfv cle wbr vk cM cuz cfv wral cc0 vk cv cF cfv cle wbr vk cM cz wcel
      cN cM cuz cfv wcel wa cM c1 cif cuz cfv wral cM caddc cop cF cseqz co vx
      cv cli wbr vx wex cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF
      cseqz co vx cv cli wbr vx wex cM cM cz wcel cN cM cuz cfv wcel wa cM c1
      cif wceq cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv
      wceq cM cuz cfv cr cF wf cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz
      cfv cr cF wf wb cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz fveq2
      cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv cr cF feq2
      syl cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cc0 vk cv cF cfv
      cle wbr vk cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv
      cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz fveq2 raleq1d cM cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM caddc cop cF cseqz co vx cv
      cli wbr cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF cseqz co
      vx cv cli wbr vx cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM
      caddc cop cF cseqz co cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc
      cop cF cseqz co vx cv cli cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      wceq cM caddc cop cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF
      cseqz cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc opeq1 opreq1d
      breq1d exbidv 3anbi123d cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif
      wceq cM cN cfz co vk cv cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM
      c1 cif cN cfz co vk cv cF cfv vk csu cM cuz cfv vk cv cF cfv vk csu cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk csu cle cM
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq cM cN cfz co cM cz wcel
      cN cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk cM cM cz wcel
      cN cM cuz cfv wcel wa cM c1 cif cN cfz opreq1 sumeq1d cM cM cz wcel cN cM
      cuz cfv wcel wa cM c1 cif wceq cM cuz cfv cM cz wcel cN cM cuz cfv wcel
      wa cM c1 cif cuz cfv vk cv cF cfv vk cM cM cz wcel cN cM cuz cfv wcel wa
      cM c1 cif cuz fveq2 sumeq1d breq12d imbi12d cN cM cz wcel cN cM cuz cfv
      wcel wa cN c1 cif wceq cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz
      co vk cv cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv
      vk cv cF cfv vk csu cle wbr cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cM
      cz wcel cN cM cuz cfv wcel wa cN c1 cif cfz co vk cv cF cfv vk csu cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv vk cv cF cfv vk csu cle wbr
      cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv cr cF wf cc0 vk cv cF
      cfv cle wbr vk cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv wral cM
      cz wcel cN cM cuz cfv wcel wa cM c1 cif caddc cop cF cseqz co vx cv cli
      wbr vx wex w3a cN cM cz wcel cN cM cuz cfv wcel wa cN c1 cif wceq cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co vk cv cF cfv vk csu cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cM cz wcel cN cM cuz cfv wcel wa cN
      c1 cif cfz co vk cv cF cfv vk csu cM cz wcel cN cM cuz cfv wcel wa cM c1
      cif cuz cfv vk cv cF cfv vk csu cle cN cM cz wcel cN cM cuz cfv wcel wa
      cN c1 cif wceq cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cN cfz co cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cM cz wcel cN cM cuz cfv wcel wa cN
      c1 cif cfz co vk cv cF cfv vk cN cM cz wcel cN cM cuz cfv wcel wa cN c1
      cif cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cfz opreq2 sumeq1d breq1d
      imbi2d vx vk cF cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cM cz wcel cN
      cM cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cN cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv wcel cM cz wcel cN cM cuz
      cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv
      wcel c1 c1 cuz cfv wcel cM cN c1 c1 c1 cM cz wcel cN cM cuz cfv wcel wa
      cM c1 cif cuz cfv wcel cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq
      cN cM cuz cfv wcel cN cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv
      wcel cM cz wcel cN cM cuz cfv wcel wa cM cM cz wcel cN cM cuz cfv wcel wa
      cM c1 cif wceq cM cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz
      cfv cN cM cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz fveq2 eleq2d cN
      cM cuz cfv wcel cM cz wcel cM cN eluzel2 pm4.71ri syl5bbr cN cM cz wcel
      cN cM cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cM c1
      cif cuz cfv eleq1 c1 cM cz wcel cN cM cuz cfv wcel wa cM c1 cif wceq c1
      cuz cfv cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz cfv c1 c1 cM cz
      wcel cN cM cuz cfv wcel wa cM c1 cif cuz fveq2 eleq2d c1 cM cz wcel cN cM
      cuz cfv wcel wa cN c1 cif cM cz wcel cN cM cuz cfv wcel wa cM c1 cif cuz
      cfv eleq1 c1 cz wcel c1 c1 cuz cfv wcel 1z c1 uzid ax-mp elimhyp2v
      fsumleisumi dedth2v imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F x z j $. $d M x z j $. $d k z j $.
    isumclf.1 $e |- ( z e. F -> A. k z e. F ) $.
    isumclf.2 $e |- F e. _V $.
    $( Closure of an infinite sum. $)
    isumclf $p |- ( ( M e. ZZ /\ E. x ( <. M , + >. seq F ) ~~> x )
                          -> sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. CC ) $=
      cM cz wcel cM caddc cop cF cseqz co vx cv cli wbr vx wex wa cM cuz cfv vj
      cv cF cfv vj csu cc cM cuz cfv vk cv cF cfv vk csu vx vj cF cM isumclf.2
      isumcl vz cM cuz cfv vk cv cF cfv vj cv cF cfv vk vj vz cv vk cv cF cfv
      wcel vj ax-17 vk vz vj cv cF isumclf.1 vz cv vj cv wcel vk ax-17 hbfv vk
      cv vj cv cF fveq2 cbvsumi syl5eqel $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F k $. $d G k $. $d M k $. $d K k $.
    $( Index shift of an infinite series. $)
    iserzshft2 $p |- ( ( ( F e. R /\ G e. S ) /\ ( M e. ZZ /\ K e. ZZ ) /\
                      ( A e. B /\ A. k e. ( ZZ>= ` M ) ( ( F ` k ) e. CC /\
           ( G ` ( k + K ) ) = ( F ` k ) ) ) ) -> ( ( <. M , + >. seq F ) ~~> A
                                 <-> ( <. ( M + K ) , + >. seq G ) ~~> A ) ) $=
      cF cR wcel cG cS wcel wa cM cz wcel cK cz wcel wa cA cB wcel vk cv cF cfv
      cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral
      wa cM caddc cop cF cseqz co cA cli wbr cM cK caddc co caddc cop cG cseqz
      co cA cli wbr wb cF cvv wcel cG cvv wcel wa cM cz wcel cK cz wcel wa cA
      cB wcel vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq
      wa vk cM cuz cfv wral wa cM caddc cop cF cseqz co cA cli wbr cM cK caddc
      co caddc cop cG cseqz co cA cli wbr wb wi cF cR wcel cG cS wcel wa cF cvv
      wcel cG cvv wcel cM cz wcel cK cz wcel cA cB wcel vk cv cF cfv cc wcel vk
      cv cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral wa cM caddc
      cop cF cseqz co cA cli wbr cM cK caddc co caddc cop cG cseqz co cA cli
      wbr wb wi cF cG cM cK c0 c0 cA cB wcel vk cv cF cvv wcel cF c0 cif cfv cc
      wcel vk cv cK caddc co cG cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk
      cM cuz cfv wral wa cM caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr
      cM cK caddc co caddc cop cG cseqz co cA cli wbr wb wi cA cB wcel vk cv cF
      cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv wral wa cM
      caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr cM cK caddc co caddc
      cop cG cvv wcel cG c0 cif cseqz co cA cli wbr wb wi cA cB wcel vk cv cF
      cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cz wcel cM cc0 cif cuz
      cfv wral wa cM cz wcel cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz
      co cA cli wbr cM cz wcel cM cc0 cif cK caddc co caddc cop cG cvv wcel cG
      c0 cif cseqz co cA cli wbr wb wi cA cB wcel vk cv cF cvv wcel cF c0 cif
      cfv cc wcel vk cv cK cz wcel cK cc0 cif caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cz wcel cM cc0 cif cuz
      cfv wral wa cM cz wcel cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz
      co cA cli wbr cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co caddc
      cop cG cvv wcel cG c0 cif cseqz co cA cli wbr wb wi cc0 cc0 cF cF cvv
      wcel cF c0 cif wceq cA cB wcel vk cv cF cfv cc wcel vk cv cK caddc co cG
      cfv vk cv cF cfv wceq wa vk cM cuz cfv wral wa cA cB wcel vk cv cF cvv
      wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cvv wcel cF
      c0 cif cfv wceq wa vk cM cuz cfv wral wa cM caddc cop cF cseqz co cA cli
      wbr cM cK caddc co caddc cop cG cseqz co cA cli wbr wb cM caddc cop cF
      cvv wcel cF c0 cif cseqz co cA cli wbr cM cK caddc co caddc cop cG cseqz
      co cA cli wbr wb cF cF cvv wcel cF c0 cif wceq vk cv cF cfv cc wcel vk cv
      cK caddc co cG cfv vk cv cF cfv wceq wa vk cM cuz cfv wral vk cv cF cvv
      wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cvv wcel cF
      c0 cif cfv wceq wa vk cM cuz cfv wral cA cB wcel cF cF cvv wcel cF c0 cif
      wceq vk cv cF cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cfv wceq wa
      vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cfv vk cv cF
      cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv cF cF cvv wcel cF c0 cif
      wceq vk cv cF cfv cc wcel vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv
      cK caddc co cG cfv vk cv cF cfv wceq vk cv cK caddc co cG cfv vk cv cF
      cvv wcel cF c0 cif cfv wceq cF cF cvv wcel cF c0 cif wceq vk cv cF cfv vk
      cv cF cvv wcel cF c0 cif cfv cc vk cv cF cF cvv wcel cF c0 cif fveq1
      eleq1d cF cF cvv wcel cF c0 cif wceq vk cv cF cfv vk cv cF cvv wcel cF c0
      cif cfv vk cv cK caddc co cG cfv vk cv cF cF cvv wcel cF c0 cif fveq1
      eqeq2d anbi12d ralbidv anbi2d cF cF cvv wcel cF c0 cif wceq cM caddc cop
      cF cseqz co cA cli wbr cM caddc cop cF cvv wcel cF c0 cif cseqz co cA cli
      wbr cM cK caddc co caddc cop cG cseqz co cA cli wbr cF cF cvv wcel cF c0
      cif wceq cM caddc cop cF cseqz co cM caddc cop cF cvv wcel cF c0 cif
      cseqz co cA cli cF cF cvv wcel cF c0 cif cM caddc cop cseqz opreq2 breq1d
      bibi1d imbi12d cG cG cvv wcel cG c0 cif wceq cA cB wcel vk cv cF cvv wcel
      cF c0 cif cfv cc wcel vk cv cK caddc co cG cfv vk cv cF cvv wcel cF c0
      cif cfv wceq wa vk cM cuz cfv wral wa cA cB wcel vk cv cF cvv wcel cF c0
      cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv
      wcel cF c0 cif cfv wceq wa vk cM cuz cfv wral wa cM caddc cop cF cvv wcel
      cF c0 cif cseqz co cA cli wbr cM cK caddc co caddc cop cG cseqz co cA cli
      wbr wb cM caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr cM cK caddc
      co caddc cop cG cvv wcel cG c0 cif cseqz co cA cli wbr wb cG cG cvv wcel
      cG c0 cif wceq vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co
      cG cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv wral vk cv
      cF cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv wral cA cB wcel
      cG cG cvv wcel cG c0 cif wceq vk cv cF cvv wcel cF c0 cif cfv cc wcel vk
      cv cK caddc co cG cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cv cF
      cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv cG cG cvv wcel
      cG c0 cif wceq vk cv cK caddc co cG cfv vk cv cF cvv wcel cF c0 cif cfv
      wceq vk cv cK caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel cF c0
      cif cfv wceq vk cv cF cvv wcel cF c0 cif cfv cc wcel cG cG cvv wcel cG c0
      cif wceq vk cv cK caddc co cG cfv vk cv cK caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv vk cv cK caddc co cG cG cvv wcel cG
      c0 cif fveq1 eqeq1d anbi2d ralbidv anbi2d cG cG cvv wcel cG c0 cif wceq
      cM cK caddc co caddc cop cG cseqz co cA cli wbr cM cK caddc co caddc cop
      cG cvv wcel cG c0 cif cseqz co cA cli wbr cM caddc cop cF cvv wcel cF c0
      cif cseqz co cA cli wbr cG cG cvv wcel cG c0 cif wceq cM cK caddc co
      caddc cop cG cseqz co cM cK caddc co caddc cop cG cvv wcel cG c0 cif
      cseqz co cA cli cG cG cvv wcel cG c0 cif cM cK caddc co caddc cop cseqz
      opreq2 breq1d bibi2d imbi12d cM cM cz wcel cM cc0 cif wceq cA cB wcel vk
      cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0
      cif cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv wral wa cA
      cB wcel vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv
      wcel cG c0 cif cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cz wcel
      cM cc0 cif cuz cfv wral wa cM caddc cop cF cvv wcel cF c0 cif cseqz co cA
      cli wbr cM cK caddc co caddc cop cG cvv wcel cG c0 cif cseqz co cA cli
      wbr wb cM cz wcel cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz co cA
      cli wbr cM cz wcel cM cc0 cif cK caddc co caddc cop cG cvv wcel cG c0 cif
      cseqz co cA cli wbr wb cM cM cz wcel cM cc0 cif wceq vk cv cF cvv wcel cF
      c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif cfv vk cv cF
      cvv wcel cF c0 cif cfv wceq wa vk cM cuz cfv wral vk cv cF cvv wcel cF c0
      cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv
      wcel cF c0 cif cfv wceq wa vk cM cz wcel cM cc0 cif cuz cfv wral cA cB
      wcel cM cM cz wcel cM cc0 cif wceq vk cv cF cvv wcel cF c0 cif cfv cc
      wcel vk cv cK caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel cF c0
      cif cfv wceq wa vk cM cuz cfv cM cz wcel cM cc0 cif cuz cfv cM cM cz wcel
      cM cc0 cif cuz fveq2 raleq1d anbi2d cM cM cz wcel cM cc0 cif wceq cM
      caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr cM cz wcel cM cc0 cif
      caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr cM cK caddc co caddc
      cop cG cvv wcel cG c0 cif cseqz co cA cli wbr cM cz wcel cM cc0 cif cK
      caddc co caddc cop cG cvv wcel cG c0 cif cseqz co cA cli wbr cM cM cz
      wcel cM cc0 cif wceq cM caddc cop cF cvv wcel cF c0 cif cseqz co cM cz
      wcel cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz co cA cli cM cM cz
      wcel cM cc0 cif wceq cM caddc cop cM cz wcel cM cc0 cif caddc cop cF cvv
      wcel cF c0 cif cseqz cM cM cz wcel cM cc0 cif caddc opeq1 opreq1d breq1d
      cM cM cz wcel cM cc0 cif wceq cM cK caddc co caddc cop cG cvv wcel cG c0
      cif cseqz co cM cz wcel cM cc0 cif cK caddc co caddc cop cG cvv wcel cG
      c0 cif cseqz co cA cli cM cM cz wcel cM cc0 cif wceq cM cK caddc co caddc
      cop cM cz wcel cM cc0 cif cK caddc co caddc cop cG cvv wcel cG c0 cif
      cseqz cM cM cz wcel cM cc0 cif wceq cM cK caddc co cM cz wcel cM cc0 cif
      cK caddc co caddc cM cM cz wcel cM cc0 cif cK caddc opreq1 opeq1d opreq1d
      breq1d bibi12d imbi12d cK cK cz wcel cK cc0 cif wceq cA cB wcel vk cv cF
      cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG c0 cif
      cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cz wcel cM cc0 cif cuz
      cfv wral wa cA cB wcel vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK
      cz wcel cK cc0 cif caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel
      cF c0 cif cfv wceq wa vk cM cz wcel cM cc0 cif cuz cfv wral wa cM cz wcel
      cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr cM cz wcel
      cM cc0 cif cK caddc co caddc cop cG cvv wcel cG c0 cif cseqz co cA cli
      wbr wb cM cz wcel cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz co cA
      cli wbr cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co caddc cop cG
      cvv wcel cG c0 cif cseqz co cA cli wbr wb cK cK cz wcel cK cc0 cif wceq
      vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK caddc co cG cvv wcel cG
      c0 cif cfv vk cv cF cvv wcel cF c0 cif cfv wceq wa vk cM cz wcel cM cc0
      cif cuz cfv wral vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK cz wcel
      cK cc0 cif caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel cF c0 cif
      cfv wceq wa vk cM cz wcel cM cc0 cif cuz cfv wral cA cB wcel cK cK cz
      wcel cK cc0 cif wceq vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK
      caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel cF c0 cif cfv wceq
      wa vk cv cF cvv wcel cF c0 cif cfv cc wcel vk cv cK cz wcel cK cc0 cif
      caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel cF c0 cif cfv wceq
      wa vk cM cz wcel cM cc0 cif cuz cfv cK cK cz wcel cK cc0 cif wceq vk cv
      cK caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv wcel cF c0 cif cfv
      wceq vk cv cK cz wcel cK cc0 cif caddc co cG cvv wcel cG c0 cif cfv vk cv
      cF cvv wcel cF c0 cif cfv wceq vk cv cF cvv wcel cF c0 cif cfv cc wcel cK
      cK cz wcel cK cc0 cif wceq vk cv cK caddc co cG cvv wcel cG c0 cif cfv vk
      cv cK cz wcel cK cc0 cif caddc co cG cvv wcel cG c0 cif cfv vk cv cF cvv
      wcel cF c0 cif cfv cK cK cz wcel cK cc0 cif wceq vk cv cK caddc co vk cv
      cK cz wcel cK cc0 cif caddc co cG cvv wcel cG c0 cif cK cK cz wcel cK cc0
      cif vk cv caddc opreq2 fveq2d eqeq1d anbi2d ralbidv anbi2d cK cK cz wcel
      cK cc0 cif wceq cM cz wcel cM cc0 cif cK caddc co caddc cop cG cvv wcel
      cG c0 cif cseqz co cA cli wbr cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif
      caddc co caddc cop cG cvv wcel cG c0 cif cseqz co cA cli wbr cM cz wcel
      cM cc0 cif caddc cop cF cvv wcel cF c0 cif cseqz co cA cli wbr cK cK cz
      wcel cK cc0 cif wceq cM cz wcel cM cc0 cif cK caddc co caddc cop cG cvv
      wcel cG c0 cif cseqz co cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc
      co caddc cop cG cvv wcel cG c0 cif cseqz co cA cli cK cK cz wcel cK cc0
      cif wceq cM cz wcel cM cc0 cif cK caddc co caddc cop cM cz wcel cM cc0
      cif cK cz wcel cK cc0 cif caddc co caddc cop cG cvv wcel cG c0 cif cseqz
      cK cK cz wcel cK cc0 cif wceq cM cz wcel cM cc0 cif cK caddc co cM cz
      wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co caddc cK cK cz wcel cK cc0
      cif cM cz wcel cM cc0 cif caddc opreq2 opeq1d opreq1d breq1d bibi2d
      imbi12d cA cB vk cF cvv wcel cF c0 cif cG cvv wcel cG c0 cif cK cz wcel
      cK cc0 cif cM cz wcel cM cc0 cif cF c0 cvv 0ex elimel cG c0 cvv 0ex
      elimel cM cc0 cz 0z elimel cK cc0 cz 0z elimel iserzshft2i dedth4h cF cR
      wcel cF cvv wcel cG cS wcel cG cvv wcel cF cR elisset cG cS elisset
      anim12i sylan 3impia $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F k $. $d G k $. $d M k $. $d K k $.
    $( Index shift of an infinite sum. $)
    isumshft2 $p |- ( ( F e. A /\ K e. ZZ /\ M e. ZZ ) -> sum_ k e. ( ZZ>= `
          ( M + K ) ) ( F ` k ) = sum_ k e. ( ZZ>= ` M ) ( F ` ( K + k ) ) ) $=
      cF cvv wcel cK cz wcel cM cz wcel cM cK caddc co cuz cfv vk cv cF cfv vk
      csu cM cuz cfv cK vk cv caddc co cF cfv vk csu wceq cF cA wcel cF cvv
      wcel cK cz wcel cM cz wcel cM cK caddc co cuz cfv vk cv cF cfv vk csu cM
      cuz cfv cK vk cv caddc co cF cfv vk csu wceq cM cK caddc co cuz cfv vk cv
      cF cvv wcel cF c0 cif cfv vk csu cM cuz cfv cK vk cv caddc co cF cvv wcel
      cF c0 cif cfv vk csu wceq cF cK cM c0 cc0 cc0 cM cK cz wcel cK cc0 cif
      caddc co cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk csu cM cuz cfv cK cz
      wcel cK cc0 cif vk cv caddc co cF cvv wcel cF c0 cif cfv vk csu wceq cM
      cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cfv vk cv cF cvv
      wcel cF c0 cif cfv vk csu cM cz wcel cM cc0 cif cuz cfv cK cz wcel cK cc0
      cif vk cv caddc co cF cvv wcel cF c0 cif cfv vk csu wceq cF cF cvv wcel
      cF c0 cif wceq cM cK caddc co cuz cfv vk cv cF cfv vk csu cM cK caddc co
      cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk csu cM cuz cfv cK vk cv caddc
      co cF cfv vk csu cM cuz cfv cK vk cv caddc co cF cvv wcel cF c0 cif cfv
      vk csu cF cF cvv wcel cF c0 cif wceq cM cK caddc co cuz cfv vk cv cF cfv
      vk cv cF cvv wcel cF c0 cif cfv vk vk cv cF cF cvv wcel cF c0 cif fveq1
      sumeq2sdv cF cF cvv wcel cF c0 cif wceq cM cuz cfv cK vk cv caddc co cF
      cfv cK vk cv caddc co cF cvv wcel cF c0 cif cfv vk cK vk cv caddc co cF
      cF cvv wcel cF c0 cif fveq1 sumeq2sdv eqeq12d cK cK cz wcel cK cc0 cif
      wceq cM cK caddc co cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk csu cM cK
      cz wcel cK cc0 cif caddc co cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk
      csu cM cuz cfv cK vk cv caddc co cF cvv wcel cF c0 cif cfv vk csu cM cuz
      cfv cK cz wcel cK cc0 cif vk cv caddc co cF cvv wcel cF c0 cif cfv vk csu
      cK cK cz wcel cK cc0 cif wceq cM cK caddc co cuz cfv cM cK cz wcel cK cc0
      cif caddc co cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk cK cK cz wcel cK
      cc0 cif wceq cM cK caddc co cM cK cz wcel cK cc0 cif caddc co cuz cK cK
      cz wcel cK cc0 cif cM caddc opreq2 fveq2d sumeq1d cK cK cz wcel cK cc0
      cif wceq cM cuz cfv cK vk cv caddc co cF cvv wcel cF c0 cif cfv cK cz
      wcel cK cc0 cif vk cv caddc co cF cvv wcel cF c0 cif cfv vk cK cK cz wcel
      cK cc0 cif wceq cK vk cv caddc co cK cz wcel cK cc0 cif vk cv caddc co cF
      cvv wcel cF c0 cif cK cK cz wcel cK cc0 cif vk cv caddc opreq1 fveq2d
      sumeq2sdv eqeq12d cM cM cz wcel cM cc0 cif wceq cM cK cz wcel cK cc0 cif
      caddc co cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk csu cM cz wcel cM cc0
      cif cK cz wcel cK cc0 cif caddc co cuz cfv vk cv cF cvv wcel cF c0 cif
      cfv vk csu cM cuz cfv cK cz wcel cK cc0 cif vk cv caddc co cF cvv wcel cF
      c0 cif cfv vk csu cM cz wcel cM cc0 cif cuz cfv cK cz wcel cK cc0 cif vk
      cv caddc co cF cvv wcel cF c0 cif cfv vk csu cM cM cz wcel cM cc0 cif
      wceq cM cK cz wcel cK cc0 cif caddc co cuz cfv cM cz wcel cM cc0 cif cK
      cz wcel cK cc0 cif caddc co cuz cfv vk cv cF cvv wcel cF c0 cif cfv vk cM
      cM cz wcel cM cc0 cif wceq cM cK cz wcel cK cc0 cif caddc co cM cz wcel
      cM cc0 cif cK cz wcel cK cc0 cif caddc co cuz cM cM cz wcel cM cc0 cif cK
      cz wcel cK cc0 cif caddc opreq1 fveq2d sumeq1d cM cM cz wcel cM cc0 cif
      wceq cM cuz cfv cM cz wcel cM cc0 cif cuz cfv cK cz wcel cK cc0 cif vk cv
      caddc co cF cvv wcel cF c0 cif cfv vk cM cM cz wcel cM cc0 cif cuz fveq2
      sumeq1d eqeq12d vk cF cvv wcel cF c0 cif cK cz wcel cK cc0 cif cM cz wcel
      cM cc0 cif cM cz wcel cM cc0 cif cK cz wcel cK cc0 cif caddc co cF c0 cvv
      0ex elimel cK cc0 cz 0z elimel cM cc0 cz 0z elimel cM cz wcel cM cc0 cif
      cK cz wcel cK cc0 cif caddc co eqid isumshft2i dedth3h cF cA elisset
      syl3an1 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N k z $. $d M k z $. $d K k z $. $d B k z $.
    fsumlt1.1 $e |- ( k = K -> A = B ) $.
    $( A sum of nonnegative numbers is greater than or equal to any one of its
       terms. $)
    fsumlt1 $p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N ) ( A e. RR /\
            0 <_ A ) /\ K e. ( M ... N ) ) -> B <_ sum_ k e. ( M ... N ) A ) $=
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK
      cM cN cfz co wcel w3a cM cN cfz co vk cv cK wceq cB cc0 cif vk csu cB cM
      cN cfz co cA vk csu cle cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa
      vk cM cN cfz co wral cK cM cN cfz co wcel w3a cM cN cfz co vk cv cK wceq
      cB cc0 cif vk csu cM cK cfz co vk cv cK wceq cB cc0 cif vk csu cB cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN
      cfz co wcel cM cN cfz co vk cv cK wceq cB cc0 cif vk csu cM cK cfz co vk
      cv cK wceq cB cc0 cif vk csu wceq cN cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM cN cfz co wral wa cK cM cN cfz co wcel wa cN cM cuz cfv
      wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa cK cM cN c1
      cmin co cfz co wcel cK cN wceq wo wa cM cN cfz co vk cv cK wceq cB cc0
      cif vk csu cM cK cfz co vk cv cK wceq cB cc0 cif vk csu wceq cN cM cuz
      cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa cK cM cN
      cfz co wcel cK cM cN c1 cmin co cfz co wcel cK cN wceq wo cN cM cuz cfv
      wcel cK cM cN cfz co wcel cK cM cN c1 cmin co cfz co wcel cK cN wceq wo
      wi cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cN cM cuz cfv wcel
      cK cM cN cfz co wcel cK cM cN c1 cmin co cfz co wcel cK cN wceq wo cK cM
      cN fzm1 biimpd adantr imdistani cN cM cuz cfv wcel cA cr wcel cc0 cA cle
      wbr wa vk cM cN cfz co wral wa cK cM cN c1 cmin co cfz co wcel cM cN cfz
      co vk cv cK wceq cB cc0 cif vk csu cM cK cfz co vk cv cK wceq cB cc0 cif
      vk csu wceq cK cN wceq cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk
      cM cN cfz co wral wa cK cM cN c1 cmin co cfz co wcel wa cM cN cfz co vk
      cv cK wceq cB cc0 cif vk csu cM cK cfz co vk cv cK wceq cB cc0 cif vk csu
      cK c1 caddc co cN cfz co vk cv cK wceq cB cc0 cif vk csu caddc co cM cK
      cfz co vk cv cK wceq cB cc0 cif vk csu cc0 caddc co cM cK cfz co vk cv cK
      wceq cB cc0 cif vk csu cN cz wcel cK cM cN c1 cmin co cfz co wcel vk cv
      cK wceq cB cc0 cif cc wcel vk cM cN cfz co wral cM cN cfz co vk cv cK
      wceq cB cc0 cif vk csu cM cK cfz co vk cv cK wceq cB cc0 cif vk csu cK c1
      caddc co cN cfz co vk cv cK wceq cB cc0 cif vk csu caddc co wceq cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa cK cM
      cN c1 cmin co cfz co wcel wa vk cv cK wceq cB cc0 cif vk cK cM cN
      fsumsplit cN cM cuz cfv wcel cN cz wcel cA cr wcel cc0 cA cle wbr wa vk
      cM cN cfz co wral cK cM cN c1 cmin co cfz co wcel cM cN eluzelz ad2antrr
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa
      cK cM cN c1 cmin co cfz co wcel pm3.27 cA cr wcel cc0 cA cle wbr wa vk cM
      cN cfz co wral vk cv cK wceq cB cc0 cif cc wcel vk cM cN cfz co wral cN
      cM cuz cfv wcel cK cM cN c1 cmin co cfz co wcel cA cr wcel cc0 cA cle wbr
      wa vk cv cK wceq cB cc0 cif cc wcel vk cM cN cfz co cA cr wcel cc0 cA cle
      wbr wa vk cv cK wceq cB cc0 cif cA cr wcel cc0 cA cle wbr wa vk cv cK
      wceq vk cv cK wceq cB cc0 cif cr wcel vk cv cK wceq vk cv cK wceq cB cc0
      cif cr wcel cA cr wcel cA cr wcel cc0 cA cle wbr wa vk cv cK wceq vk cv
      cK wceq cB cc0 cif cA cr vk cv cK wceq vk cv cK wceq cB cc0 cif cB cA vk
      cv cK wceq cB cc0 iftrue fsumlt1.1 eqtr4d eleq1d cA cr wcel cc0 cA cle
      wbr pm3.26 syl5cbir vk cv cK wceq wn vk cv cK wceq cB cc0 cif cr wcel cc0
      cr wcel cA cr wcel cc0 cA cle wbr wa vk cv cK wceq wn vk cv cK wceq cB
      cc0 cif cc0 cr vk cv cK wceq cB cc0 iffalse eleq1d cc0 cr wcel cA cr wcel
      cc0 cA cle wbr wa 0re a1i syl5cbir pm2.61d recnd r19.20si ad2antlr
      syl3anc cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral wa cK cM cN c1 cmin co cfz co wcel wa cK c1 caddc co cN cfz co vk cv
      cK wceq cB cc0 cif vk csu cc0 cM cK cfz co vk cv cK wceq cB cc0 cif vk
      csu caddc cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral wa cK cM cN c1 cmin co cfz co wcel wa cK c1 caddc co cN cfz co vk cv
      cK wceq cB cc0 cif vk csu cK c1 caddc co cN cfz co cc0 vk csu cc0 cK cM
      cN c1 cmin co cfz co wcel cK c1 caddc co cN cfz co vk cv cK wceq cB cc0
      cif vk csu cK c1 caddc co cN cfz co cc0 vk csu wceq cN cM cuz cfv wcel cA
      cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa cK cM cN c1 cmin co cfz
      co wcel cK c1 caddc co cN cfz co vk cv cK wceq cB cc0 cif cc0 vk cK cM cN
      c1 cmin co cfz co wcel vk cv cK c1 caddc co cN cfz co wcel wa vk cv cK
      wceq wn vk cv cK wceq cB cc0 cif cc0 wceq cK cM cN c1 cmin co cfz co wcel
      vk cv cK c1 caddc co cN cfz co wcel vk cv cK wceq wn cK cM cN c1 cmin co
      cfz co wcel vk cv cK wceq vk cv cK c1 caddc co cN cfz co wcel cK cM cN c1
      cmin co cfz co wcel cK cz wcel cK cK c1 caddc co cN cfz co wcel wn vk cv
      cK wceq vk cv cK c1 caddc co cN cfz co wcel wn wi cK cM cN c1 cmin co
      elfzelz cK cz wcel cK cK c1 caddc co cN cfz co wcel cK c1 caddc co cK cle
      wbr cK cz wcel cK cK c1 caddc co clt wbr cK c1 caddc co cK cle wbr wn cK
      cz wcel cK cr wcel cK cK c1 caddc co clt wbr cK zre cK ltp1 syl cK cr
      wcel cK c1 caddc co cr wcel cK cK c1 caddc co clt wbr cK c1 caddc co cK
      cle wbr wn wb cK cz wcel cK cK c1 caddc co ltnle cK zre cK cz wcel cK cr
      wcel cK c1 caddc co cr wcel cK zre cK peano2re syl sylanc mpbid cK cz
      wcel cK cK c1 caddc co cuz cfv wcel cK c1 caddc co cK cle wbr cK cK c1
      caddc co cN cfz co wcel cK cK c1 caddc co cuz cfv wcel cK c1 caddc co cK
      cle wbr wi cK cz wcel cK c1 caddc co cK eluzle a1i cK cK c1 caddc co cN
      elfzuz syl5 mtod vk cv cK wceq vk cv cK c1 caddc co cN cfz co wcel wn cK
      cK c1 caddc co cN cfz co wcel wn vk cv cK wceq vk cv cK c1 caddc co cN
      cfz co wcel cK cK c1 caddc co cN cfz co wcel vk cv cK cK c1 caddc co cN
      cfz co eleq1 notbid biimprcd 3syl con2d imp vk cv cK wceq cB cc0 iffalse
      syl sumeq2dv adantl cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM
      cN cfz co wral wa cK cM cN c1 cmin co cfz co wcel wa cN cK c1 caddc co
      cuz cfv wcel cK c1 caddc co cN cfz co cc0 vk csu cc0 wceq cN cM cuz cfv
      wcel cK cM cN c1 cmin co cfz co wcel cN cK c1 caddc co cuz cfv wcel cA cr
      wcel cc0 cA cle wbr wa vk cM cN cfz co wral cN cM cuz cfv wcel cN c1 cmin
      co cK cuz cfv wcel cN cK c1 caddc co cuz cfv wcel cK cM cN c1 cmin co cfz
      co wcel cN cM cuz cfv wcel cN c1 cmin co cK cuz cfv wcel wa cN c1 cmin co
      c1 caddc co cN cK c1 caddc co cuz cfv cN cM cuz cfv wcel cN c1 cmin co c1
      caddc co cN wceq cN c1 cmin co cK cuz cfv wcel cN cM cuz cfv wcel cN cz
      wcel cN cc wcel cN c1 cmin co c1 caddc co cN wceq cM cN eluzelz cN zcn cN
      cc wcel c1 cc wcel cN c1 cmin co c1 caddc co cN wceq ax1cn cN c1 npcan
      mpan2 3syl adantr cN c1 cmin co cK cuz cfv wcel cN c1 cmin co c1 caddc co
      cK c1 caddc co cuz cfv wcel cN cM cuz cfv wcel cK cN c1 cmin co eluzp1p1
      adantl eqeltrrd cN c1 cmin co cvv wcel cK cM cN c1 cmin co cfz co wcel cN
      c1 cmin co cK cuz cfv wcel cN c1 cmin oprex cvv cK cM cN c1 cmin co
      elfzuz3 mpan sylan2 adantlr vk cK c1 caddc co cN fsum0 syl eqtrd opreq2d
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa
      cK cM cN c1 cmin co cfz co wcel wa cM cK cfz co vk cv cK wceq cB cc0 cif
      vk csu cc wcel cM cK cfz co vk cv cK wceq cB cc0 cif vk csu cc0 caddc co
      cM cK cfz co vk cv cK wceq cB cc0 cif vk csu wceq cK cM cuz cfv wcel vk
      cv cK wceq cB cc0 cif cc wcel vk cM cK cfz co wral cM cK cfz co vk cv cK
      wceq cB cc0 cif vk csu cc wcel cN cM cuz cfv wcel cA cr wcel cc0 cA cle
      wbr wa vk cM cN cfz co wral wa cK cM cN c1 cmin co cfz co wcel wa vk cv
      cK wceq cB cc0 cif vk cM cK fsumcl cK cM cN c1 cmin co cfz co wcel cK cM
      cuz cfv wcel cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz
      co wral wa cK cM cN c1 cmin co elfzuz adantl cN cM cuz cfv wcel cA cr
      wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa cK cM cN c1 cmin co cfz co
      wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral vk cv cK wceq
      cB cc0 cif cc wcel vk cM cK cfz co wral cN cM cuz cfv wcel cK cM cN c1
      cmin co cfz co wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cA
      cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cN cM cuz cfv wcel cK cM
      cN c1 cmin co cfz co wcel wa cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral cA cr wcel cc0 cA cle wbr wa vk cM cK cfz co wral cN cM cuz cfv wcel
      cK cM cN c1 cmin co cfz co wcel wa cM cK cfz co cM cN cfz co wss cA cr
      wcel cc0 cA cle wbr wa vk cM cN cfz co wral cA cr wcel cc0 cA cle wbr wa
      vk cM cK cfz co wral wi cN cK cuz cfv wcel cM cz wcel cM cK cfz co cM cN
      cfz co wss cN cM cuz cfv wcel cK cM cN c1 cmin co cfz co wcel wa cK cM cN
      fzss2 cN cM cuz cfv wcel cK cM cN c1 cmin co cfz co wcel cN cK cuz cfv
      wcel cN cM cuz cfv wcel cK cM cN c1 cmin co cfz co wcel cK cN wceq wo cN
      cK cuz cfv wcel cK cM cN c1 cmin co cfz co wcel cN cM cuz cfv wcel cK cM
      cN c1 cmin co cfz co wcel cK cN wceq wo cK cM cN cfz co wcel cN cK cuz
      cfv wcel cK cM cN fzm1 cN cM cuz cfv wcel cK cM cN cfz co wcel cN cK cuz
      cfv wcel cM cuz cfv cK cM cN elfzuz3 ex sylbird cK cM cN c1 cmin co cfz
      co wcel cK cN wceq orc syl5 imp cK cM cN c1 cmin co cfz co wcel cM cz
      wcel cN cM cuz cfv wcel cK cM cN c1 cmin co elfzel1 adantl sylanc cA cr
      wcel cc0 cA cle wbr wa vk cM cK cfz co cM cN cfz co ssralv syl imp an1rs
      cA cr wcel cc0 cA cle wbr wa vk cv cK wceq cB cc0 cif cc wcel vk cM cK
      cfz co cA cr wcel cc0 cA cle wbr wa vk cv cK wceq cB cc0 cif cA cr wcel
      cc0 cA cle wbr wa vk cv cK wceq vk cv cK wceq cB cc0 cif cr wcel vk cv cK
      wceq vk cv cK wceq cB cc0 cif cr wcel cA cr wcel cA cr wcel cc0 cA cle
      wbr wa vk cv cK wceq vk cv cK wceq cB cc0 cif cA cr vk cv cK wceq vk cv
      cK wceq cB cc0 cif cB cA vk cv cK wceq cB cc0 iftrue fsumlt1.1 eqtr4d
      eleq1d cA cr wcel cc0 cA cle wbr pm3.26 syl5cbir vk cv cK wceq wn vk cv
      cK wceq cB cc0 cif cr wcel cc0 cr wcel cA cr wcel cc0 cA cle wbr wa vk cv
      cK wceq wn vk cv cK wceq cB cc0 cif cc0 cr vk cv cK wceq cB cc0 iffalse
      eleq1d cc0 cr wcel cA cr wcel cc0 cA cle wbr wa 0re a1i syl5cbir pm2.61d
      recnd r19.20si syl sylanc cM cK cfz co vk cv cK wceq cB cc0 cif vk csu
      addid1 syl 3eqtrd cK cN wceq cM cN cfz co vk cv cK wceq cB cc0 cif vk csu
      cM cK cfz co vk cv cK wceq cB cc0 cif vk csu wceq cN cM cuz cfv wcel cA
      cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral wa cK cN wceq cM cN cfz co
      cM cK cfz co vk cv cK wceq cB cc0 cif vk cK cN wceq cM cK cfz co cM cN
      cfz co cK cN cM cfz opreq2 eqcomd sumeq1d adantl jaodan syl 3impa cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN
      cfz co wcel w3a cK cM wceq cK c1 cmin co cM cuz cfv wcel wo cM cK cfz co
      vk cv cK wceq cB cc0 cif vk csu cB wceq cK cM cN cfz co wcel cN cM cuz
      cfv wcel cK cM wceq cK c1 cmin co cM cuz cfv wcel wo cA cr wcel cc0 cA
      cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel cK cM cuz cfv wcel
      cK cM wceq cK c1 cmin co cM cuz cfv wcel wo cK cM cN elfzuz cM cK uzm1
      syl 3ad2ant3 cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz
      co wral cK cM cN cfz co wcel w3a cK cM wceq cM cK cfz co vk cv cK wceq cB
      cc0 cif vk csu cB wceq cK c1 cmin co cM cuz cfv wcel cK cM wceq cM cK cfz
      co vk cv cK wceq cB cc0 cif vk csu cB wceq cK cK cfz co vk cv cK wceq cB
      cc0 cif vk csu cB wceq cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk
      cM cN cfz co wral cK cM cN cfz co wcel w3a cK cM wceq cM cK cfz co vk cv
      cK wceq cB cc0 cif vk csu cK cK cfz co vk cv cK wceq cB cc0 cif vk csu cB
      cK cM wceq cM cK cfz co cK cK cfz co vk cv cK wceq cB cc0 cif vk cK cM
      wceq cK cK cfz co cM cK cfz co cK cM cK cfz opreq1 eqcomd sumeq1d eqeq1d
      cB cr wcel cK cz wcel cK cK cfz co vk cv cK wceq cB cc0 cif vk csu cB
      wceq cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral
      cK cM cN cfz co wcel w3a vk cv cK wceq cB cc0 cif cB cr vk cK vk cv cK
      wceq cB cc0 iftrue fsum1i cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral cK cM cN cfz co wcel cB cr wcel cN cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel wa cB cr wcel cc0 cB
      cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr wa vk cK
      cM cN cfz co vk cv cK wceq cA cr wcel cB cr wcel cc0 cA cle wbr cc0 cB
      cle wbr vk cv cK wceq cA cB cr fsumlt1.1 eleq1d vk cv cK wceq cA cB cc0
      cle fsumlt1.1 breq2d anbi12d rcla4cva pm3.26d 3adant1 cK cM cN cfz co
      wcel cN cM cuz cfv wcel cK cz wcel cA cr wcel cc0 cA cle wbr wa vk cM cN
      cfz co wral cK cM cN elfzelz 3ad2ant3 sylanc syl5cbir cN cM cuz cfv wcel
      cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel
      w3a cK c1 cmin co cM cuz cfv wcel cM cK cfz co vk cv cK wceq cB cc0 cif
      vk csu cB wceq cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN
      cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel wa cM
      cK cfz co vk cv cK wceq cB cc0 cif vk csu cM cK c1 cmin co cfz co vk cv
      cK wceq cB cc0 cif vk csu vk cK c1 cmin co c1 caddc co vk cv cK wceq cB
      cc0 cif csb caddc co cc0 vk cK c1 cmin co c1 caddc co vk cv cK wceq cB
      cc0 cif csb caddc co cB cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa
      vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv
      wcel wa cM cK cfz co vk cv cK wceq cB cc0 cif vk csu cM cK c1 cmin co c1
      caddc co cfz co vk cv cK wceq cB cc0 cif vk csu cM cK c1 cmin co cfz co
      vk cv cK wceq cB cc0 cif vk csu vk cK c1 cmin co c1 caddc co vk cv cK
      wceq cB cc0 cif csb caddc co cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr
      wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv
      wcel wa cM cK cfz co cM cK c1 cmin co c1 caddc co cfz co vk cv cK wceq cB
      cc0 cif vk cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz
      co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel wa cK cK
      c1 cmin co c1 caddc co cM cfz cN cM cuz cfv wcel cA cr wcel cc0 cA cle
      wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK cK c1 cmin co c1
      caddc co wceq cK c1 cmin co cM cuz cfv wcel cK cM cN cfz co wcel cN cM
      cuz cfv wcel cK cK c1 cmin co c1 caddc co wceq cA cr wcel cc0 cA cle wbr
      wa vk cM cN cfz co wral cK cM cN cfz co wcel cK c1 cmin co c1 caddc co cK
      cK cM cN cfz co wcel cK cz wcel cK cc wcel cK c1 cmin co c1 caddc co cK
      wceq cK cM cN elfzelz cK zcn cK cc wcel c1 cc wcel cK c1 cmin co c1 caddc
      co cK wceq ax1cn cK c1 npcan mpan2 3syl eqcomd 3ad2ant3 adantr opreq2d
      sumeq1d cK c1 cmin co cM cuz cfv wcel vk cv cK wceq cB cc0 cif cr wcel vk
      cM cK c1 cmin co c1 caddc co cfz co wral cM cK c1 cmin co c1 caddc co cfz
      co vk cv cK wceq cB cc0 cif vk csu cM cK c1 cmin co cfz co vk cv cK wceq
      cB cc0 cif vk csu vk cK c1 cmin co c1 caddc co vk cv cK wceq cB cc0 cif
      csb caddc co wceq cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM
      cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel wa
      vk cv cK wceq cB cc0 cif cr vk cM cK c1 cmin co fsump1s cN cM cuz cfv
      wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co
      wcel w3a cK c1 cmin co cM cuz cfv wcel pm3.27 cN cM cuz cfv wcel cA cr
      wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a vk
      cv cK wceq cB cc0 cif cr wcel vk cM cK c1 cmin co c1 caddc co cfz co wral
      cK c1 cmin co cM cuz cfv wcel cN cM cuz cfv wcel cA cr wcel cc0 cA cle
      wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel vk cv cK wceq cB cc0 cif
      cr wcel vk cM cK c1 cmin co c1 caddc co cfz co wral cN cM cuz cfv wcel cK
      cM cN cfz co wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral vk cv
      cK wceq cB cc0 cif cr wcel vk cM cK c1 cmin co c1 caddc co cfz co wral cN
      cM cuz cfv wcel cK cM cN cfz co wcel wa cA cr wcel cc0 cA cle wbr wa vk
      cM cN cfz co wral vk cv cK wceq cB cc0 cif cr wcel vk cM cK c1 cmin co c1
      caddc co cfz co wral cN cM cuz cfv wcel cK cM cN cfz co wcel wa cA cr
      wcel cc0 cA cle wbr wa vk cM cN cfz co wral cA cr wcel cc0 cA cle wbr wa
      vk cM cK c1 cmin co c1 caddc co cfz co wral vk cv cK wceq cB cc0 cif cr
      wcel vk cM cK c1 cmin co c1 caddc co cfz co wral cN cM cuz cfv wcel cK cM
      cN cfz co wcel wa cM cK c1 cmin co c1 caddc co cfz co cM cN cfz co wss cA
      cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cA cr wcel cc0 cA cle wbr
      wa vk cM cK c1 cmin co c1 caddc co cfz co wral wi cN cM cuz cfv wcel cK
      cM cN cfz co wcel wa cM cK c1 cmin co c1 caddc co cfz co cM cK cfz co cM
      cN cfz co cN cM cuz cfv wcel cK cM cN cfz co wcel wa cK c1 cmin co c1
      caddc co cK cM cfz cK cM cN cfz co wcel cK c1 cmin co c1 caddc co cK wceq
      cN cM cuz cfv wcel cK cM cN cfz co wcel cK cz wcel cK cc wcel cK c1 cmin
      co c1 caddc co cK wceq cK cM cN elfzelz cK zcn cK cc wcel c1 cc wcel cK
      c1 cmin co c1 caddc co cK wceq ax1cn cK c1 npcan mpan2 3syl adantl
      opreq2d cN cK cuz cfv wcel cM cz wcel cM cK cfz co cM cN cfz co wss cN cM
      cuz cfv wcel cK cM cN cfz co wcel wa cK cM cN fzss2 cM cuz cfv cK cM cN
      elfzuz3 cK cM cN cfz co wcel cM cz wcel cN cM cuz cfv wcel cK cM cN
      elfzel1 adantl sylanc eqsstrd cA cr wcel cc0 cA cle wbr wa vk cM cK c1
      cmin co c1 caddc co cfz co cM cN cfz co ssralv syl cA cr wcel cc0 cA cle
      wbr wa vk cv cK wceq cB cc0 cif cr wcel vk cM cK c1 cmin co c1 caddc co
      cfz co cA cr wcel cc0 cA cle wbr wa vk cv cK wceq vk cv cK wceq cB cc0
      cif cr wcel vk cv cK wceq vk cv cK wceq cB cc0 cif cr wcel cA cr wcel cA
      cr wcel cc0 cA cle wbr wa vk cv cK wceq vk cv cK wceq cB cc0 cif cA cr vk
      cv cK wceq vk cv cK wceq cB cc0 cif cB cA vk cv cK wceq cB cc0 iftrue
      fsumlt1.1 eqtr4d eleq1d cA cr wcel cc0 cA cle wbr pm3.26 syl5cbir vk cv
      cK wceq wn vk cv cK wceq cB cc0 cif cr wcel cc0 cr wcel cA cr wcel cc0 cA
      cle wbr wa vk cv cK wceq wn vk cv cK wceq cB cc0 cif cc0 cr vk cv cK wceq
      cB cc0 iffalse eleq1d cc0 cr wcel cA cr wcel cc0 cA cle wbr wa 0re a1i
      syl5cbir pm2.61d r19.20si syl6 imp an1rs 3impa adantr sylanc eqtrd cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN
      cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel wa cM cK c1 cmin co cfz co
      vk cv cK wceq cB cc0 cif vk csu cc0 vk cK c1 cmin co c1 caddc co vk cv cK
      wceq cB cc0 cif csb caddc cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa
      vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv
      wcel wa cM cK c1 cmin co cfz co vk cv cK wceq cB cc0 cif vk csu cM cK c1
      cmin co cfz co cc0 vk csu cc0 cK cM cN cfz co wcel cN cM cuz cfv wcel cK
      c1 cmin co cM cuz cfv wcel cM cK c1 cmin co cfz co vk cv cK wceq cB cc0
      cif vk csu cM cK c1 cmin co cfz co cc0 vk csu wceq cA cr wcel cc0 cA cle
      wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel cK c1 cmin co cM cuz cfv
      wcel wa cM cK c1 cmin co cfz co vk cv cK wceq cB cc0 cif cc0 vk cK cM cN
      cfz co wcel cK c1 cmin co cM cuz cfv wcel wa vk cv cM cK c1 cmin co cfz
      co wcel wa vk cv cK wceq wn vk cv cK wceq cB cc0 cif cc0 wceq cK cM cN
      cfz co wcel cK c1 cmin co cM cuz cfv wcel wa vk cv cM cK c1 cmin co cfz
      co wcel vk cv cK wceq wn cK cM cN cfz co wcel cK c1 cmin co cM cuz cfv
      wcel wa vk cv cK wceq vk cv cM cK c1 cmin co cfz co wcel vk cv cK wceq vk
      cv cM cK c1 cmin co cfz co wcel wn cK cM cK c1 cmin co cfz co wcel wn cK
      cM cN cfz co wcel cK c1 cmin co cM cuz cfv wcel wa vk cv cK wceq vk cv cM
      cK c1 cmin co cfz co wcel cK cM cK c1 cmin co cfz co wcel vk cv cK cM cK
      c1 cmin co cfz co eleq1 notbid cK cM cN cfz co wcel cK cM cK c1 cmin co
      cfz co wcel wn cK c1 cmin co cM cuz cfv wcel cK cM cN cfz co wcel cK cz
      wcel cK cr wcel cK cM cK c1 cmin co cfz co wcel wn cK cM cN elfzelz cK
      zre cK cr wcel cK cK c1 cmin co cle wbr cK cM cK c1 cmin co cfz co wcel
      cK cr wcel cK c1 cmin co cK clt wbr cK cK c1 cmin co cle wbr wn cK ltm1
      cK c1 cmin co cr wcel cK cr wcel cK c1 cmin co cK clt wbr cK cK c1 cmin
      co cle wbr wn wb cK peano2rem cK c1 cmin co cK ltnle mpancom mpbid cK cM
      cK c1 cmin co elfzle2 nsyl 3syl adantr syl5cbir con2d imp vk cv cK wceq
      cB cc0 iffalse syl sumeq2dv 3ad2antl3 cK c1 cmin co cM cuz cfv wcel cM cK
      c1 cmin co cfz co cc0 vk csu cc0 wceq cN cM cuz cfv wcel cA cr wcel cc0
      cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a vk cM cK c1
      cmin co fsum0 adantl eqtrd opreq1d cN cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM
      cuz cfv wcel wa cc0 vk cK c1 cmin co c1 caddc co vk cv cK wceq cB cc0 cif
      csb caddc co vk cK c1 cmin co c1 caddc co vk cv cK wceq cB cc0 cif csb vk
      cK vk cv cK wceq cB cc0 cif csb cB cN cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM
      cuz cfv wcel wa vk cK c1 cmin co c1 caddc co vk cv cK wceq cB cc0 cif csb
      cc wcel cc0 vk cK c1 cmin co c1 caddc co vk cv cK wceq cB cc0 cif csb
      caddc co vk cK c1 cmin co c1 caddc co vk cv cK wceq cB cc0 cif csb wceq
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK
      cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel wa vk cK c1 cmin co
      c1 caddc co vk cv cK wceq cB cc0 cif csb cB cc cN cM cuz cfv wcel cA cr
      wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK
      c1 cmin co cM cuz cfv wcel wa vk cK c1 cmin co c1 caddc co vk cv cK wceq
      cB cc0 cif csb vk cK vk cv cK wceq cB cc0 cif csb cB cN cM cuz cfv wcel
      cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel
      w3a cK c1 cmin co cM cuz cfv wcel wa vk cK c1 cmin co c1 caddc co cK vk
      cv cK wceq cB cc0 cif cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk
      cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel
      wa cK cK c1 cmin co c1 caddc co cN cM cuz cfv wcel cA cr wcel cc0 cA cle
      wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK cK c1 cmin co c1
      caddc co wceq cK c1 cmin co cM cuz cfv wcel cK cM cN cfz co wcel cN cM
      cuz cfv wcel cK cK c1 cmin co c1 caddc co wceq cA cr wcel cc0 cA cle wbr
      wa vk cM cN cfz co wral cK cM cN cfz co wcel cK c1 cmin co c1 caddc co cK
      cK cM cN cfz co wcel cK cz wcel cK cc wcel cK c1 cmin co c1 caddc co cK
      wceq cK cM cN elfzelz cK zcn cK cc wcel c1 cc wcel cK c1 cmin co c1 caddc
      co cK wceq ax1cn cK c1 npcan mpan2 3syl eqcomd 3ad2ant3 adantr eqcomd
      csbeq1d cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral cK cM cN cfz co wcel w3a vk cK vk cv cK wceq cB cc0 cif csb cB wceq
      cK c1 cmin co cM cuz cfv wcel cK cM cN cfz co wcel cN cM cuz cfv wcel vk
      cK vk cv cK wceq cB cc0 cif csb cB wceq cA cr wcel cc0 cA cle wbr wa vk
      cM cN cfz co wral vk vz cK vk cv cK wceq cB cc0 cif cB cM cN cfz co vz cv
      cB wcel vz cv cB wcel vk wal wi cK cM cN cfz co wcel vz cv cB wcel vk
      ax-17 a1i vk cv cK wceq cB cc0 iftrue csbiegf 3ad2ant3 adantr eqtrd cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN
      cfz co wcel w3a cB cc wcel cK c1 cmin co cM cuz cfv wcel cA cr wcel cc0
      cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel cB cc wcel cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN
      cfz co wcel wa cB cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM
      cN cfz co wcel wa cB cr wcel cc0 cB cle wbr cA cr wcel cc0 cA cle wbr wa
      cB cr wcel cc0 cB cle wbr wa vk cK cM cN cfz co vk cv cK wceq cA cr wcel
      cB cr wcel cc0 cA cle wbr cc0 cB cle wbr vk cv cK wceq cA cB cr fsumlt1.1
      eleq1d vk cv cK wceq cA cB cc0 cle fsumlt1.1 breq2d anbi12d rcla4cva
      pm3.26d recnd 3adant1 adantr eqeltrd vk cK c1 cmin co c1 caddc co vk cv
      cK wceq cB cc0 cif csb addid2 syl cN cM cuz cfv wcel cA cr wcel cc0 cA
      cle wbr wa vk cM cN cfz co wral cK cM cN cfz co wcel w3a cK c1 cmin co cM
      cuz cfv wcel wa vk cK c1 cmin co c1 caddc co cK vk cv cK wceq cB cc0 cif
      cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK
      cM cN cfz co wcel w3a cK c1 cmin co cM cuz cfv wcel wa cK cK c1 cmin co
      c1 caddc co cN cM cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz
      co wral cK cM cN cfz co wcel w3a cK cK c1 cmin co c1 caddc co wceq cK c1
      cmin co cM cuz cfv wcel cK cM cN cfz co wcel cN cM cuz cfv wcel cK cK c1
      cmin co c1 caddc co wceq cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral cK cM cN cfz co wcel cK c1 cmin co c1 caddc co cK cK cM cN cfz co
      wcel cK cz wcel cK cc wcel cK c1 cmin co c1 caddc co cK wceq cK cM cN
      elfzelz cK zcn cK cc wcel c1 cc wcel cK c1 cmin co c1 caddc co cK wceq
      ax1cn cK c1 npcan mpan2 3syl eqcomd 3ad2ant3 adantr eqcomd csbeq1d cN cM
      cuz cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN
      cfz co wcel w3a vk cK vk cv cK wceq cB cc0 cif csb cB wceq cK c1 cmin co
      cM cuz cfv wcel cK cM cN cfz co wcel cN cM cuz cfv wcel vk cK vk cv cK
      wceq cB cc0 cif csb cB wceq cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co
      wral vk vz cK vk cv cK wceq cB cc0 cif cB cM cN cfz co vz cv cB wcel vz
      cv cB wcel vk wal wi cK cM cN cfz co wcel vz cv cB wcel vk ax-17 a1i vk
      cv cK wceq cB cc0 iftrue csbiegf 3ad2ant3 adantr 3eqtrd 3eqtrd ex jaod
      mpd eqtrd cN cM cuz cfv wcel vk cv cK wceq cB cc0 cif cr wcel cA cr wcel
      vk cv cK wceq cB cc0 cif cA cle wbr w3a vk cM cN cfz co wral cM cN cfz co
      vk cv cK wceq cB cc0 cif vk csu cM cN cfz co cA vk csu cle wbr cN cM cuz
      cfv wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz
      co wcel w3a vk cv cK wceq cB cc0 cif cA vk cM cN fsumcmp cN cM cuz cfv
      wcel cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cK cM cN cfz co
      wcel 3simp1 cA cr wcel cc0 cA cle wbr wa vk cM cN cfz co wral cN cM cuz
      cfv wcel vk cv cK wceq cB cc0 cif cr wcel cA cr wcel vk cv cK wceq cB cc0
      cif cA cle wbr w3a vk cM cN cfz co wral cK cM cN cfz co wcel cA cr wcel
      cc0 cA cle wbr wa vk cv cK wceq cB cc0 cif cr wcel cA cr wcel vk cv cK
      wceq cB cc0 cif cA cle wbr w3a vk cM cN cfz co cA cr wcel cc0 cA cle wbr
      wa vk cv cK wceq cB cc0 cif cr wcel cA cr wcel vk cv cK wceq cB cc0 cif
      cA cle wbr cA cr wcel cc0 cA cle wbr wa vk cv cK wceq vk cv cK wceq cB
      cc0 cif cr wcel vk cv cK wceq vk cv cK wceq cB cc0 cif cr wcel cA cr wcel
      cA cr wcel cc0 cA cle wbr wa vk cv cK wceq vk cv cK wceq cB cc0 cif cA cr
      vk cv cK wceq vk cv cK wceq cB cc0 cif cB cA vk cv cK wceq cB cc0 iftrue
      fsumlt1.1 eqtr4d eleq1d cA cr wcel cc0 cA cle wbr pm3.26 syl5cbir vk cv
      cK wceq wn vk cv cK wceq cB cc0 cif cr wcel cc0 cr wcel cA cr wcel cc0 cA
      cle wbr wa vk cv cK wceq wn vk cv cK wceq cB cc0 cif cc0 cr vk cv cK wceq
      cB cc0 iffalse eleq1d cc0 cr wcel cA cr wcel cc0 cA cle wbr wa 0re a1i
      syl5cbir pm2.61d cA cr wcel cc0 cA cle wbr pm3.26 cA cr wcel cc0 cA cle
      wbr wa vk cv cK wceq vk cv cK wceq cB cc0 cif cA cle wbr vk cv cK wceq vk
      cv cK wceq cB cc0 cif cA cle wbr cA cA cle wbr cA cr wcel cc0 cA cle wbr
      wa vk cv cK wceq vk cv cK wceq cB cc0 cif cA cA cle vk cv cK wceq vk cv
      cK wceq cB cc0 cif cB cA vk cv cK wceq cB cc0 iftrue fsumlt1.1 eqtr4d
      breq1d cA cr wcel cA cA cle wbr cc0 cA cle wbr cA leid adantr syl5cbir vk
      cv cK wceq wn vk cv cK wceq cB cc0 cif cA cle wbr cc0 cA cle wbr cA cr
      wcel cc0 cA cle wbr wa vk cv cK wceq wn vk cv cK wceq cB cc0 cif cc0 cA
      cle vk cv cK wceq cB cc0 iffalse breq1d cA cr wcel cc0 cA cle wbr pm3.27
      syl5cbir pm2.61d 3jca r19.20si 3ad2ant2 sylanc eqbrtrrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N k t $. $d X k t $. $d Y k t $.
    csbrni.1 $e |- N e. NN $.
    csbrni.2 $e |- X : ( 1 ... N ) --> RR $.
    csbrni.3 $e |- Y : ( 1 ... N ) --> RR $.
    $( Cauchy-Schwarz-Bunjakovsky inequality for R^n. $)
    csbrni $p |- ( sum_ k e. ( 1 ... N ) ( ( X ` k ) x. ( Y ` k ) ) ^ 2 ) <_
                        ( sum_ k e. ( 1 ... N ) ( ( X ` k ) ^ 2 ) x.
                          sum_ k e. ( 1 ... N ) ( ( Y ` k ) ^ 2 ) ) $=
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co cmin co cc0 cle wbr c1 cN cfz co vk cv cX cfv vk cv cY
      cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co cle wbr c1 cN cfz co
      vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co
      cmin co cc0 cle wbr c4 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk
      csu c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co
      vk cv cY cfv c2 cexp co vk csu cmul co cmin co cmul co c4 cc0 cmul co cle
      wbr c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul co c2
      cexp co c4 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu cmul co cmul co cmin co cc0 c4 c1 cN cfz co vk
      cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co
      cmin co cmul co c4 cc0 cmul co cle cc0 c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu cle wbr c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk
      csu cmul co c2 cexp co c4 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co cmul co cmin co cc0 cle
      wbr cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cX cfv
      c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN
      elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co
      cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv c2 cexp
      co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv cr wcel c2
      cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 reexpcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni 2nn0 sylancl vk
      cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX cfv c2 cexp co cle
      wbr c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni vk cv cX cfv sqge0 syl jca
      rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an vt c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cmul co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN c1
      cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      csbrni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu
      2re cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN
      cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv vk cv
      cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel vk cv cY cfv
      cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1 cN cfz co wcel
      vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX csbrni.2
      ffvelrni c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc rgen vk cv cX
      cfv vk cv cY cfv cmul co vk c1 cN fsumrecl mp2an remulcli cN c1 cuz cfv
      wcel vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel
      csbrni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co
      vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1
      cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY csbrni.3
      ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp co vk c1 cN fsumrecl
      mp2an cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu vt cv c2 cexp co
      cmul co c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul co
      vt cv cmul co caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc
      co cle wbr vt cr vt cv cr wcel cc0 c1 cN cfz co vk cv cX cfv c2 cexp co
      vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt
      cv cmul co caddc co vk cv cY cfv c2 cexp co caddc co vk csu c1 cN cfz co
      vk cv cX cfv c2 cexp co vk csu vt cv c2 cexp co cmul co c2 c1 cN cfz co
      vk cv cX cfv vk cv cY cfv cmul co vk csu cmul co vt cv cmul co caddc co
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc co cle cN c1 cuz cfv
      wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk
      cv cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co
      caddc co cr wcel cc0 vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2
      vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY
      cfv c2 cexp co caddc co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co
      vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY
      cfv cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co caddc
      co vk csu cle wbr vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co
      cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc
      co vk cv cY cfv c2 cexp co caddc co vk c1 cN fsumcmp0 cN cn wcel cN c1
      cuz cfv wcel csbrni.1 cN elnnuz mpbi vt cv cr wcel vk cv cX cfv c2 cexp
      co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      vt cv cmul co caddc co vk cv cY cfv c2 cexp co caddc co cr wcel cc0 vk cv
      cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co caddc co
      cle wbr wa vk c1 cN cfz co vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv
      cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co caddc co
      cr wcel cc0 vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX
      cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2
      cexp co caddc co cle wbr vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co
      c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc co cr
      wcel vk cv cY cfv c2 cexp co cr wcel vk cv cX cfv c2 cexp co vt cv c2
      cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul
      co caddc co vk cv cY cfv c2 cexp co caddc co cr wcel vt cv cr wcel vk cv
      c1 cN cfz co wcel wa vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2
      vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY
      cfv c2 cexp co readdcl vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co
      cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co cr
      wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk
      cv cY cfv cmul co cmul co vt cv cmul co caddc co cr wcel vt cv cr wcel vk
      cv c1 cN cfz co wcel wa vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co
      c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co readdcl vk cv
      c1 cN cfz co wcel vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co
      cmul co cr wcel vk cv cX cfv c2 cexp co cr wcel vt cv c2 cexp co cr wcel
      vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co cr wcel vk cv c1 cN cfz
      co wcel vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co remulcl vk
      cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN
      cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX csbrni.2
      ffvelrni 2nn0 sylancl vt cv resqcl syl2an ancoms vk cv c1 cN cfz co wcel
      vt cv cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co
      cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cr wcel vt cv cr
      wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co cr wcel
      vk cv c1 cN cfz co wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt
      cv remulcl c2 cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel c2 vk cv
      cX cfv vk cv cY cfv cmul co cmul co cr wcel vk cv c1 cN cfz co wcel c2 vk
      cv cX cfv vk cv cY cfv cmul co remulcl 2re vk cv cX cfv cr wcel vk cv cY
      cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX csbrni.2
      ffvelrni c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc sylancr sylan
      ancoms sylanc vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp co cr wcel vt
      cv cr wcel vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr
      wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk
      cv cY csbrni.3 ffvelrni 2nn0 sylancl adantl sylanc vt cv cr wcel vk cv c1
      cN cfz co wcel wa cc0 vk cv cX cfv vt cv cmul co vk cv cY cfv caddc co c2
      cexp co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv
      vk cv cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp
      co caddc co cle vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv cX cfv vt
      cv cmul co vk cv cY cfv caddc co cr wcel cc0 vk cv cX cfv vt cv cmul co
      vk cv cY cfv caddc co c2 cexp co cle wbr vk cv cX cfv vt cv cmul co cr
      wcel vk cv cY cfv cr wcel vk cv cX cfv vt cv cmul co vk cv cY cfv caddc
      co cr wcel vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv cX cfv vt cv
      cmul co vk cv cY cfv readdcl vk cv c1 cN cfz co wcel vt cv cr wcel vk cv
      cX cfv vt cv cmul co cr wcel vk cv cX cfv cr wcel vt cv cr wcel vk cv cX
      cfv vt cv cmul co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vt cv
      remulcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni sylan ancoms vk cv c1
      cN cfz co wcel vk cv cY cfv cr wcel vt cv cr wcel c1 cN cfz co cr vk cv
      cY csbrni.3 ffvelrni adantl sylanc vk cv cX cfv vt cv cmul co vk cv cY
      cfv caddc co sqge0 syl vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv cX
      cfv vt cv cmul co vk cv cY cfv caddc co c2 cexp co vk cv cX cfv vt cv
      cmul co c2 cexp co c2 vk cv cX cfv vt cv cmul co vk cv cY cfv cmul co
      cmul co caddc co vk cv cY cfv c2 cexp co caddc co vk cv cX cfv c2 cexp co
      vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt
      cv cmul co caddc co vk cv cY cfv c2 cexp co caddc co vk cv cX cfv vt cv
      cmul co cc wcel vk cv cY cfv cc wcel vk cv cX cfv vt cv cmul co vk cv cY
      cfv caddc co c2 cexp co vk cv cX cfv vt cv cmul co c2 cexp co c2 vk cv cX
      cfv vt cv cmul co vk cv cY cfv cmul co cmul co caddc co vk cv cY cfv c2
      cexp co caddc co wceq vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv cX
      cfv vt cv cmul co vk cv cY cfv binom2 vk cv c1 cN cfz co wcel vt cv cr
      wcel vk cv cX cfv vt cv cmul co cc wcel vk cv cX cfv cc wcel vt cv cc
      wcel vk cv cX cfv vt cv cmul co cc wcel vk cv c1 cN cfz co wcel vt cv cr
      wcel vk cv cX cfv vt cv mulcl vk cv c1 cN cfz co wcel vk cv cX cfv c1 cN
      cfz co cr vk cv cX csbrni.2 ffvelrni recnd vt cv recn syl2an ancoms vk cv
      c1 cN cfz co wcel vk cv cY cfv cc wcel vt cv cr wcel vk cv c1 cN cfz co
      wcel vk cv cY cfv c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni recnd adantl
      sylanc vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv cX cfv vt cv cmul
      co c2 cexp co c2 vk cv cX cfv vt cv cmul co vk cv cY cfv cmul co cmul co
      caddc co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv
      vk cv cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp
      co caddc vt cv cr wcel vk cv c1 cN cfz co wcel wa vk cv cX cfv vt cv cmul
      co c2 cexp co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv
      cX cfv vt cv cmul co vk cv cY cfv cmul co cmul co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co vt cv cmul co caddc vk cv cX cfv cc wcel vt cv cc
      wcel c2 cn0 wcel vk cv cX cfv vt cv cmul co c2 cexp co vk cv cX cfv c2
      cexp co vt cv c2 cexp co cmul co wceq vt cv cr wcel vk cv c1 cN cfz co
      wcel wa vk cv cX cfv vt cv c2 mulexp vk cv c1 cN cfz co wcel vk cv cX cfv
      cc wcel vt cv cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c1 cN cfz co
      cr vk cv cX csbrni.2 ffvelrni recnd adantl vt cv cr wcel vt cv cc wcel vk
      cv c1 cN cfz co wcel vt cv recn adantr c2 cn0 wcel vt cv cr wcel vk cv c1
      cN cfz co wcel wa 2nn0 a1i syl3anc vt cv cr wcel vk cv c1 cN cfz co wcel
      wa c2 vk cv cX cfv vt cv cmul co vk cv cY cfv cmul co cmul co c2 vk cv cX
      cfv vk cv cY cfv cmul co vt cv cmul co cmul co c2 vk cv cX cfv vk cv cY
      cfv cmul co cmul co vt cv cmul co vt cv cr wcel vk cv c1 cN cfz co wcel
      wa vk cv cX cfv vt cv cmul co vk cv cY cfv cmul co vk cv cX cfv vk cv cY
      cfv cmul co vt cv cmul co c2 cmul vk cv cX cfv cc wcel vt cv cc wcel vk
      cv cY cfv cc wcel vk cv cX cfv vt cv cmul co vk cv cY cfv cmul co vk cv
      cX cfv vk cv cY cfv cmul co vt cv cmul co wceq vt cv cr wcel vk cv c1 cN
      cfz co wcel wa vk cv cX cfv vt cv vk cv cY cfv mul23 vk cv c1 cN cfz co
      wcel vk cv cX cfv cc wcel vt cv cr wcel vk cv c1 cN cfz co wcel vk cv cX
      cfv c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni recnd adantl vt cv cr wcel
      vt cv cc wcel vk cv c1 cN cfz co wcel vt cv recn adantr vk cv c1 cN cfz
      co wcel vk cv cY cfv cc wcel vt cv cr wcel vk cv c1 cN cfz co wcel vk cv
      cY cfv c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni recnd adantl syl3anc
      opreq2d c2 cc wcel vk cv cX cfv vk cv cY cfv cmul co cc wcel vt cv cc
      wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co c2 vk cv
      cX cfv vk cv cY cfv cmul co vt cv cmul co cmul co wceq vt cv cr wcel vk
      cv c1 cN cfz co wcel wa c2 vk cv cX cfv vk cv cY cfv cmul co vt cv mulass
      c2 cc wcel vt cv cr wcel vk cv c1 cN cfz co wcel wa 2cn a1i vk cv c1 cN
      cfz co wcel vk cv cX cfv vk cv cY cfv cmul co cc wcel vt cv cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv cmul co vk cv cX cfv cr wcel
      vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1
      cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX
      csbrni.2 ffvelrni c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc recnd
      adantl vt cv cr wcel vt cv cc wcel vk cv c1 cN cfz co wcel vt cv recn
      adantr syl3anc eqtr4d opreq12d opreq1d eqtrd breqtrd jca r19.21aiva
      sylancr vt cv cr wcel c1 cN cfz co vk cv cX cfv c2 cexp co vt cv c2 cexp
      co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co
      caddc co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc co c1
      cN cfz co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co vk csu c1 cN
      cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co vk csu
      caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc co c1 cN cfz
      co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co
      caddc co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co vk csu vt cv c2 cexp
      co cmul co c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul
      co vt cv cmul co caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      caddc co vt cv cr wcel c1 cN cfz co vk cv cX cfv c2 cexp co vt cv c2 cexp
      co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co
      caddc co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co vt cv c2 cexp co
      cmul co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      vt cv cmul co vk csu caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      caddc cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co
      cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co cc
      wcel wa vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vt cv
      c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv
      cmul co caddc co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co vt cv c2
      cexp co cmul co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co
      cmul co vt cv cmul co vk csu caddc co wceq vt cv cr wcel vk cv cX cfv c2
      cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul co
      cmul co vt cv cmul co vk c1 cN fsumadd cN cn wcel cN c1 cuz cfv wcel
      csbrni.1 cN elnnuz mpbi vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2
      cexp co cmul co cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt
      cv cmul co cc wcel wa vk c1 cN cfz co vt cv cr wcel vk cv c1 cN cfz co
      wcel wa vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co cc wcel c2 vk cv
      cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co cc wcel vk cv c1 cN cfz
      co wcel vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co cc
      wcel vk cv cX cfv c2 cexp co cc wcel vt cv c2 cexp co cc wcel vk cv cX
      cfv c2 cexp co vt cv c2 cexp co cmul co cc wcel vk cv c1 cN cfz co wcel
      vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co mulcl vk cv c1 cN
      cfz co wcel vk cv cX cfv c2 cexp co vk cv cX cfv cr wcel c2 cn0 wcel vk
      cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2
      reexpcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni 2nn0 sylancl recnd vt
      cv cr wcel vt cv c2 cexp co vt cv resqcl recnd syl2an ancoms vk cv c1 cN
      cfz co wcel vt cv cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt
      cv cmul co cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc wcel
      vt cv cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co
      cc wcel vk cv c1 cN cfz co wcel vt cv cr wcel c2 vk cv cX cfv vk cv cY
      cfv cmul co cmul co vt cv mulcl vk cv c1 cN cfz co wcel c2 vk cv cX cfv
      vk cv cY cfv cmul co cmul co c2 cr wcel vk cv cX cfv vk cv cY cfv cmul co
      cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cr wcel vk cv c1 cN
      cfz co wcel c2 vk cv cX cfv vk cv cY cfv cmul co remulcl 2re vk cv cX cfv
      cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk
      cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk
      cv cX csbrni.2 ffvelrni c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc
      sylancr recnd vt cv recn syl2an ancoms jca r19.21aiva sylancr opreq1d cN
      c1 cuz cfv wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv
      cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc co cc wcel vk cv
      cY cfv c2 cexp co cc wcel wa vk c1 cN cfz co wral c1 cN cfz co vk cv cX
      cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul
      co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co caddc co vk csu
      c1 cN cfz co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX
      cfv vk cv cY cfv cmul co cmul co vt cv cmul co caddc co vk csu c1 cN cfz
      co vk cv cY cfv c2 cexp co vk csu caddc co wceq vt cv cr wcel vk cv cX
      cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv cmul
      co cmul co vt cv cmul co caddc co vk cv cY cfv c2 cexp co vk c1 cN
      fsumadd cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vt cv cr
      wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk
      cv cY cfv cmul co cmul co vt cv cmul co caddc co cc wcel vk cv cY cfv c2
      cexp co cc wcel wa vk c1 cN cfz co vt cv cr wcel vk cv c1 cN cfz co wcel
      wa vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co vt cv cmul co caddc co cc wcel vk cv cY cfv c2
      cexp co cc wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co cc wcel
      c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co cc wcel vk cv
      cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vt cv cmul co caddc co cc wcel vt cv cr wcel vk cv c1 cN
      cfz co wcel wa vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co c2 vk cv
      cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co addcl vk cv c1 cN cfz
      co wcel vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co cc
      wcel vk cv cX cfv c2 cexp co cc wcel vt cv c2 cexp co cc wcel vk cv cX
      cfv c2 cexp co vt cv c2 cexp co cmul co cc wcel vk cv c1 cN cfz co wcel
      vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co mulcl vk cv c1 cN
      cfz co wcel vk cv cX cfv c2 cexp co vk cv cX cfv cr wcel c2 cn0 wcel vk
      cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2
      reexpcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni 2nn0 sylancl recnd vt
      cv cr wcel vt cv c2 cexp co vt cv resqcl recnd syl2an ancoms vk cv c1 cN
      cfz co wcel vt cv cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt
      cv cmul co cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc wcel
      vt cv cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vt cv cmul co
      cc wcel vk cv c1 cN cfz co wcel vt cv cr wcel c2 vk cv cX cfv vk cv cY
      cfv cmul co cmul co vt cv mulcl vk cv c1 cN cfz co wcel c2 vk cv cX cfv
      vk cv cY cfv cmul co cmul co c2 cr wcel vk cv cX cfv vk cv cY cfv cmul co
      cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cr wcel vk cv c1 cN
      cfz co wcel c2 vk cv cX cfv vk cv cY cfv cmul co remulcl 2re vk cv cX cfv
      cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk
      cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk
      cv cX csbrni.2 ffvelrni c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc
      sylancr recnd vt cv recn syl2an ancoms sylanc vk cv c1 cN cfz co wcel vk
      cv cY cfv c2 cexp co cc wcel vt cv cr wcel vk cv c1 cN cfz co wcel vk cv
      cY cfv c2 cexp co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp
      co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co
      cr vk cv cY csbrni.3 ffvelrni 2nn0 sylancl recnd adantl jca r19.21aiva
      sylancr vt cv cr wcel c1 cN cfz co vk cv cX cfv c2 cexp co vk csu vt cv
      c2 cexp co cmul co c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk
      csu cmul co vt cv cmul co caddc co c1 cN cfz co vk cv cX cfv c2 cexp co
      vt cv c2 cexp co cmul co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vt cv cmul co vk csu caddc co c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu caddc vt cv cr wcel c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu vt cv c2 cexp co cmul co c1 cN cfz co vk cv cX cfv c2 cexp co
      vt cv c2 cexp co cmul co vk csu c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cmul co vt cv cmul co c1 cN cfz co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co vt cv cmul co vk csu caddc cN c1 cuz cfv wcel vt
      cv c2 cexp co cc wcel vk cv cX cfv c2 cexp co cc wcel vk c1 cN cfz co
      wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu vt cv c2 cexp co cmul co
      c1 cN cfz co vk cv cX cfv c2 cexp co vt cv c2 cexp co cmul co vk csu wceq
      vt cv cr wcel vk cv cX cfv c2 cexp co vt cv c2 cexp co vk c1 cN fsummulc2
      cN c1 cuz cfv wcel vt cv cr wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1
      cN elnnuz mpbi a1i vt cv cr wcel vt cv c2 cexp co vt cv resqcl recnd vk
      cv cX cfv c2 cexp co cc wcel vk c1 cN cfz co wral vt cv cr wcel vk cv cX
      cfv c2 cexp co cc wcel vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 cexp co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr
      vk cv cX csbrni.2 ffvelrni 2nn0 sylancl recnd rgen a1i syl3anc vt cv cr
      wcel c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul co vt
      cv cmul co c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk
      csu vt cv cmul co c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul
      co vt cv cmul co vk csu vt cv cr wcel c2 c1 cN cfz co vk cv cX cfv vk cv
      cY cfv cmul co vk csu cmul co c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vk csu vt cv cmul cN c1 cuz cfv wcel c2 cc wcel vk cv cX
      cfv vk cv cY cfv cmul co cc wcel vk c1 cN cfz co wral c2 c1 cN cfz co vk
      cv cX cfv vk cv cY cfv cmul co vk csu cmul co c1 cN cfz co c2 vk cv cX
      cfv vk cv cY cfv cmul co cmul co vk csu wceq vt cv cr wcel vk cv cX cfv
      vk cv cY cfv cmul co c2 vk c1 cN fsummulc1 cN c1 cuz cfv wcel vt cv cr
      wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi a1i c2 cc wcel
      vt cv cr wcel 2cn a1i vk cv cX cfv vk cv cY cfv cmul co cc wcel vk c1 cN
      cfz co wral vt cv cr wcel vk cv cX cfv vk cv cY cfv cmul co cc wcel vk c1
      cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv cmul co vk cv
      cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz
      co cr vk cv cX csbrni.2 ffvelrni c1 cN cfz co cr vk cv cY csbrni.3
      ffvelrni sylanc recnd rgen a1i syl3anc opreq1d cN c1 cuz cfv wcel vt cv
      cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc wcel vk c1 cN cfz
      co wral c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu
      vt cv cmul co c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      vt cv cmul co vk csu wceq vt cv cr wcel c2 vk cv cX cfv vk cv cY cfv cmul
      co cmul co vt cv vk c1 cN fsummulc2 cN c1 cuz cfv wcel vt cv cr wcel cN
      cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi a1i vt cv recn c2 vk
      cv cX cfv vk cv cY cfv cmul co cmul co cc wcel vk c1 cN cfz co wral vt cv
      cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc wcel vk c1 cN cfz
      co vk cv c1 cN cfz co wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      c2 cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel c2 vk cv cX cfv vk
      cv cY cfv cmul co cmul co cr wcel vk cv c1 cN cfz co wcel c2 vk cv cX cfv
      vk cv cY cfv cmul co remulcl 2re vk cv cX cfv cr wcel vk cv cY cfv cr
      wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1 cN cfz co wcel vk
      cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni
      c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc sylancr recnd rgen a1i
      syl3anc eqtrd opreq12d opreq1d 3eqtr4rd breqtrrd rgen discrlem ax-mp c4
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co cmin co cmul co c4 c1 cN cfz co vk cv cX cfv vk cv cY
      cfv cmul co vk csu c2 cexp co cmul co c4 c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co cmul
      co cmin co c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul
      co c2 cexp co c4 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co
      vk cv cY cfv c2 cexp co vk csu cmul co cmul co cmin co c4 c1 cN cfz co vk
      cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co
      c4 4re recni c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2
      cexp co c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cN c1 cuz
      cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co wral
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cr wcel cN cn wcel
      cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv vk cv cY cfv cmul
      co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk
      cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1 cN cfz co wcel vk cv cX
      cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni c1 cN
      cfz co cr vk cv cY csbrni.3 ffvelrni sylanc rgen vk cv cX cfv vk cv cY
      cfv cmul co vk c1 cN fsumrecl mp2an resqcli recni c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co
      c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn
      wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co
      cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2
      cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz
      co cr vk cv cX csbrni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp
      co vk c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cY cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv
      cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl
      c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv
      c2 cexp co vk c1 cN fsumrecl mp2an remulcli recni subdii c4 c1 cN cfz co
      vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co cmul co c2 c1 cN cfz
      co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul co c2 cexp co c4 c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co cmul co cmin c4 c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu c2 cexp co cmul co c2 c2 cexp co c1 cN cfz co vk cv cX cfv
      vk cv cY cfv cmul co vk csu c2 cexp co cmul co c2 c1 cN cfz co vk cv cX
      cfv vk cv cY cfv cmul co vk csu cmul co c2 cexp co c4 c2 c2 cexp co c1 cN
      cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co cmul c2 c2
      cexp co c4 sq2 eqcomi opreq1i c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu 2cn c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu
      cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cr wcel cN
      cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv vk cv cY
      cfv cmul co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel vk cv cY cfv cr
      wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1 cN cfz co wcel vk
      cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni
      c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni sylanc rgen vk cv cX cfv vk cv
      cY cfv cmul co vk c1 cN fsumrecl mp2an recni sqmuli eqtr4i opreq1i eqtri
      c4 c4 4re recni mul01i 3brtr4i cc0 c4 clt wbr c1 cN cfz co vk cv cX cfv
      vk cv cY cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co cmin co cc0
      cle wbr c4 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp
      co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cmul co cmin co cmul co c4 cc0 cmul co cle wbr wb 4pos
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co cmin co cc0 c4 c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co c1 cN cfz co vk cv cX
      cfv vk cv cY cfv cmul co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk cv cY
      cfv cmul co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv
      cY cfv cmul co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN
      elnnuz mpbi vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk
      cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN
      cfz co cr vk cv cX csbrni.2 ffvelrni c1 cN cfz co cr vk cv cY csbrni.3
      ffvelrni sylanc rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl
      mp2an resqcli c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv
      cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl
      c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv
      c2 cexp co vk c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co
      vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk
      cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0
      wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv
      c2 reexpcl c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni 2nn0 sylancl rgen
      vk cv cY cfv c2 cexp co vk c1 cN fsumrecl mp2an remulcli resubcli 0re 4re
      lemul2i ax-mp mpbir c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu
      c2 cexp co cr wcel c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz
      co vk cv cY cfv c2 cexp co vk csu cmul co cr wcel c1 cN cfz co vk cv cX
      cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co cmin
      co cc0 cle wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2
      cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu cmul co cle wbr wb c1 cN cfz co vk cv cX cfv vk cv
      cY cfv cmul co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul
      co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz
      mpbi vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX
      cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz
      co cr vk cv cX csbrni.2 ffvelrni c1 cN cfz co cr vk cv cY csbrni.3
      ffvelrni sylanc rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl
      mp2an resqcli c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk cv cX cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv
      cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl
      c1 cN cfz co cr vk cv cX csbrni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv
      c2 cexp co vk c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co
      vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel csbrni.1 cN elnnuz mpbi vk
      cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0
      wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv
      c2 reexpcl c1 cN cfz co cr vk cv cY csbrni.3 ffvelrni 2nn0 sylancl rgen
      vk cv cY cfv c2 cexp co vk c1 cN fsumrecl mp2an remulcli c1 cN cfz co vk
      cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co
      suble0 mp2an mpbi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N k $. $d X k $. $d Y k $.
    trirni.1 $e |- N e. NN $.
    trirni.2 $e |- X : ( 1 ... N ) --> RR $.
    trirni.3 $e |- Y : ( 1 ... N ) --> RR $.
    $( Triangle inequality in R^n. $)
    trirni $p |- ( sqr ` sum_ k e. ( 1 ... N ) ( ( ( X ` k ) + ( Y ` k ) ) ^ 2
             ) ) <_ ( ( sqr ` sum_ k e. ( 1 ... N ) ( ( X ` k ) ^ 2 ) )
                      + ( sqr ` sum_ k e. ( 1 ... N ) ( ( Y ` k ) ^ 2 ) ) ) $=
      c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr
      cfv c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu csqr cfv caddc co cle wbr c1 cN cfz co vk cv
      cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cfv c2 cexp co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu csqr cfv caddc co c2 cexp co cle wbr c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul
      co cmul co vk csu caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      caddc co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c2 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co
      vk csu csqr cfv cmul co cmul co caddc co c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu caddc co c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co
      c2 cexp co vk csu csqr cfv c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv
      caddc co c2 cexp co cle c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN
      cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu caddc co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c2 c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr
      cfv cmul co cmul co caddc co cle wbr c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu
      caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc co c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul
      co cmul co caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc co
      cle wbr c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu
      c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu csqr cfv cmul co cmul co cle wbr c1 cN cfz co
      vk cv cX cfv c2 cexp co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vk csu caddc co c1 cN cfz co vk cv cX cfv c2 cexp co vk
      csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co
      vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co cmul co caddc co cle wbr
      c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cmul co c2 c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co csqr cfv cmul co c1 cN cfz co c2 vk cv cX cfv vk cv cY
      cfv cmul co cmul co vk csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co
      cmul co cle c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co csqr cfv cle wbr c2 c1 cN cfz co vk cv cX cfv vk cv cY
      cfv cmul co vk csu cmul co c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr cfv cmul co cle
      wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN cfz co vk
      cv cX cfv vk cv cY cfv cmul co vk csu cabs cfv cle wbr c1 cN cfz co vk cv
      cX cfv vk cv cY cfv cmul co vk csu cabs cfv c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr
      cfv cle wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co csqr cfv cle wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co
      vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk
      cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX cfv cr
      wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv
      cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc
      rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl mp2an leabsi c1
      cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cabs cfv c1 cN cfz co
      vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu cmul co csqr cfv cle wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul
      co vk csu cabs cfv c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr cfv c2 cexp co
      cle wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c2 cexp co
      c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cmul co c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk
      csu cabs cfv c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr cfv c2 cexp co cle vk
      cN cX cY trirni.1 trirni.2 trirni.3 csbrni c1 cN cfz co vk cv cX cfv vk
      cv cY cfv cmul co vk csu cr wcel c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cabs cfv c2 cexp co c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu c2 cexp co wceq cN c1 cuz cfv wcel vk cv cX cfv vk cv cY
      cfv cmul co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv
      cY cfv cmul co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk
      cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN
      cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3
      ffvelrni sylanc rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl
      mp2an c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu absresq ax-mp
      cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cmul co cle wbr c1 cN cfz co vk cv cX cfv c2 cexp co vk
      csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr cfv c2 cexp
      co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cmul co wceq cc0 c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu cle wbr cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr
      cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cmul co cle wbr cN c1 cuz cfv wcel vk cv cX cfv c2 cexp
      co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral
      cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1
      cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0
      vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr
      vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1
      cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk
      cv cX cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      vk cv cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0
      mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co
      cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp
      co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2
      cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY
      cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk
      cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle
      wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN
      c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co
      cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2
      cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz
      co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp
      co vk c1 cN fsumrecl mp2an mulge0i mp2an c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN
      c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel
      vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr
      vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk
      c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1
      cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2
      cexp co vk c1 cN fsumrecl mp2an remulcli sqsqri ax-mp 3brtr4i cc0 c1 cN
      cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cabs cfv cle wbr cc0 c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cmul co csqr cfv cle wbr c1 cN cfz co vk cv cX cfv vk cv
      cY cfv cmul co vk csu cabs cfv c1 cN cfz co vk cv cX cfv c2 cexp co vk
      csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr cfv cle wbr
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cabs cfv c2 cexp co
      c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cmul co csqr cfv c2 cexp co cle wbr wb c1 cN cfz co vk cv
      cX cfv vk cv cY cfv cmul co vk csu c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co
      vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk
      cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX cfv cr
      wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv
      cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc
      rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl mp2an recni
      absge0i cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu cmul co cle wbr cc0 c1 cN cfz co vk cv cX cfv
      c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co
      csqr cfv cle wbr cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr
      cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cc0 c1 cN cfz co
      vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu cmul co cle wbr cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel
      cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv
      cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2
      cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2 cn0 wcel
      vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2
      reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk cv c1
      cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN
      c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co
      cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2
      cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz
      co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp
      co vk c1 cN fsumrecl mp2an mulge0i mp2an c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN
      c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel
      vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr
      vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk
      c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1
      cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2
      cexp co vk c1 cN fsumrecl mp2an remulcli sqrge0i ax-mp c1 cN cfz co vk cv
      cX cfv vk cv cY cfv cmul co vk csu cabs cfv c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr
      cfv c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN cfz co vk
      cv cX cfv vk cv cY cfv cmul co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk
      cv cY cfv cmul co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv
      vk cv cY cfv cmul co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1
      cN cfz co vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY
      cfv cmul co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv
      remulcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv
      cY trirni.3 ffvelrni sylanc rgen vk cv cX cfv vk cv cY cfv cmul co vk c1
      cN fsumrecl mp2an recni abscli cc0 c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co cle wbr c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cmul co csqr cfv cr wcel cc0 c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu cle wbr cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr
      cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cmul co cle wbr cN c1 cuz cfv wcel vk cv cX cfv c2 cexp
      co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral
      cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1
      cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0
      vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr
      vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1
      cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk
      cv cX cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      vk cv cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0
      mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co
      cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp
      co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2
      cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY
      cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk
      cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle
      wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN
      c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co
      cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2
      cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz
      co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp
      co vk c1 cN fsumrecl mp2an mulge0i mp2an c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN
      c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel
      vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr
      vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk
      c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1
      cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2
      cexp co vk c1 cN fsumrecl mp2an remulcli sqrcli ax-mp le2sqi mp2an mpbir
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN cfz co vk cv
      cX cfv vk cv cY cfv cmul co vk csu cabs cfv c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr
      cfv cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN
      cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv vk cv
      cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel vk cv cY cfv
      cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv c1 cN cfz co wcel
      vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc rgen vk cv cX
      cfv vk cv cY cfv cmul co vk c1 cN fsumrecl mp2an c1 cN cfz co vk cv cX
      cfv vk cv cY cfv cmul co vk csu c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co
      vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk
      cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX cfv cr
      wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv
      cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc
      rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl mp2an recni
      abscli cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu cmul co cle wbr c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr
      cfv cr wcel cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cc0
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cc0 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      cmul co cle wbr cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk
      cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv
      cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2
      cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2 cn0 wcel
      vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2
      reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk cv c1
      cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN
      c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co
      cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2
      cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz
      co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp
      co vk c1 cN fsumrecl mp2an mulge0i mp2an c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN
      c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel
      vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr
      vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk
      c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1
      cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2
      cexp co vk c1 cN fsumrecl mp2an remulcli sqrcli ax-mp letri mp2an cc0 c2
      clt wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu cmul co csqr cfv cle wbr c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cmul co c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr cfv cmul co cle wbr
      wb 2pos c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul co vk csu c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu cmul co csqr cfv c2 cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv cmul
      co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv
      cmul co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cX cfv vk cv cY cfv cmul co cr wcel vk c1 cN cfz co vk cv cX
      cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz
      co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3
      ffvelrni sylanc rgen vk cv cX cfv vk cv cY cfv cmul co vk c1 cN fsumrecl
      mp2an cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu cmul co cle wbr c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co csqr
      cfv cr wcel cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cc0
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cc0 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      cmul co cle wbr cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk
      cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv
      cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2
      cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2 cn0 wcel
      vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2
      reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk cv c1
      cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN
      c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co
      cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2
      cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz
      co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp
      co vk c1 cN fsumrecl mp2an mulge0i mp2an c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cmul co c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN
      c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel
      vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr
      vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk
      c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2
      cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1
      cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2
      cexp co vk c1 cN fsumrecl mp2an remulcli sqrcli ax-mp 2re lemul2i ax-mp
      mpbi cN c1 cuz cfv wcel c2 cc wcel vk cv cX cfv vk cv cY cfv cmul co cc
      wcel vk c1 cN cfz co wral c2 c1 cN cfz co vk cv cX cfv vk cv cY cfv cmul
      co vk csu cmul co c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul
      co vk csu wceq cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi 2cn
      vk cv cX cfv vk cv cY cfv cmul co cc wcel vk c1 cN cfz co vk cv cX cfv cc
      wcel vk cv cY cfv cc wcel vk cv cX cfv vk cv cY cfv cmul co cc wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv mulcl vk cv c1 cN cfz co wcel
      vk cv cX cfv c1 cN cfz co cr vk cv cX trirni.2 ffvelrni recnd vk cv c1 cN
      cfz co wcel vk cv cY cfv c1 cN cfz co cr vk cv cY trirni.3 ffvelrni recnd
      sylanc rgen vk cv cX cfv vk cv cY cfv cmul co c2 vk c1 cN fsummulc1 mp3an
      c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cmul co csqr cfv c1 cN cfz co vk cv cX cfv c2 cexp co vk
      csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co
      c2 cmul c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel
      cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2
      cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1
      cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2
      cexp co vk c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp
      co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv
      cY cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0
      wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv
      c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen
      vk cv cY cfv c2 cexp co vk c1 cN fsumrecl mp2an cN c1 cuz cfv wcel vk cv
      cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN
      cfz co wral cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co
      cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1
      cN cfz co wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp
      co cle wbr vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk
      cv cX trirni.2 ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv
      cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni vk cv cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co
      vk c1 cN fsumcmp0 mp2an cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY
      cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv
      cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY
      cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz
      co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3
      ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk
      cv cY cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni
      vk cv cY cfv sqge0 syl jca rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0
      mp2an sqrmulii opreq2i 3brtr3i c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vk csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co
      cmul co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel c2
      vk cv cX cfv vk cv cY cfv cmul co cmul co cr wcel vk c1 cN cfz co wral c1
      cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu cr wcel cN
      cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co cr wcel vk c1 cN cfz co c2 cr wcel vk cv cX cfv vk
      cv cY cfv cmul co cr wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cr
      wcel vk cv c1 cN cfz co wcel c2 vk cv cX cfv vk cv cY cfv cmul co remulcl
      2re vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv
      cmul co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl
      c1 cN cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY
      trirni.3 ffvelrni sylanc sylancr rgen c2 vk cv cX cfv vk cv cY cfv cmul
      co cmul co vk c1 cN fsumrecl mp2an c2 c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv
      cmul co 2re c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cc0 c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      csqr cfv cr wcel cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0
      vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co
      vk cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv
      cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX
      cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel
      c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv
      cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl
      rgen vk cv cX cfv c2 cexp co vk c1 cN fsumrecl mp2an sqrcli ax-mp cc0 c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu csqr cfv cr wcel cN c1 cuz cfv wcel vk cv cY cfv c2
      cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co
      wral cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cN cn wcel
      cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN
      cfz co wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co
      cle wbr vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel
      vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY
      trirni.3 ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cY cfv cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cY
      trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca rgen vk cv cY cfv c2 cexp co
      vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN c1
      cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY
      trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp co vk c1 cN
      fsumrecl mp2an sqrcli ax-mp remulcli remulcli cN c1 cuz cfv wcel vk cv cX
      cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel
      c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv
      cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl
      rgen vk cv cX cfv c2 cexp co vk c1 cN fsumrecl mp2an leadd2i mpbi c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co vk csu caddc co c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co cmul co caddc co
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co
      wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1
      cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk
      c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk
      cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1
      cN fsumrecl mp2an cN c1 cuz cfv wcel c2 vk cv cX cfv vk cv cY cfv cmul co
      cmul co cr wcel vk c1 cN cfz co wral c1 cN cfz co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cr
      wcel vk c1 cN cfz co c2 cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel
      c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cr wcel vk cv c1 cN cfz co
      wcel c2 vk cv cX cfv vk cv cY cfv cmul co remulcl 2re vk cv cX cfv cr
      wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv cmul co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv remulcl c1 cN cfz co cr vk cv
      cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc
      sylancr rgen c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk c1 cN
      fsumrecl mp2an readdcli c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c2 c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu csqr cfv cmul co cmul co cN c1 cuz cfv wcel vk cv
      cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv
      c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN fsumrecl mp2an c2 c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu csqr cfv cmul co 2re c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr
      cfv cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr c1 cN cfz co
      vk cv cX cfv c2 cexp co vk csu csqr cfv cr wcel cN c1 cuz cfv wcel vk cv
      cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN
      cfz co wral cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn
      wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co
      cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1
      cN cfz co wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp
      co cle wbr vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk
      cv cX trirni.2 ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv
      cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni vk cv cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co
      vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cN c1
      cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN
      cfz co vk cv cX cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN
      fsumrecl mp2an sqrcli ax-mp cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu cle wbr c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cr wcel
      cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2
      cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2 cn0 wcel
      vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2
      reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk cv c1
      cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv
      cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv
      c2 cexp co vk c1 cN fsumrecl mp2an sqrcli ax-mp remulcli remulcli
      readdcli cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz
      co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn wcel cN
      c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel
      vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr
      vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp co vk
      c1 cN fsumrecl mp2an leadd1i mpbi c1 cN cfz co vk cv cX cfv vk cv cY cfv
      caddc co c2 cexp co vk csu csqr cfv c2 cexp co c1 cN cfz co vk cv cX cfv
      vk cv cY cfv caddc co c2 cexp co vk csu c1 cN cfz co vk cv cX cfv c2 cexp
      co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co caddc co vk cv cY cfv c2
      cexp co caddc co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN
      cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu caddc co c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu caddc co cc0 c1 cN cfz co vk cv cX
      cfv vk cv cY cfv caddc co c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cX
      cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cfv c2 cexp co c1 cN cfz
      co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu wceq cN c1 cuz
      cfv wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel cc0 vk cv
      cX cfv vk cv cY cfv caddc co c2 cexp co cle wbr wa vk c1 cN cfz co wral
      cc0 c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu cle
      wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv vk
      cv cY cfv caddc co c2 cexp co cr wcel cc0 vk cv cX cfv vk cv cY cfv caddc
      co c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv vk cv cY cfv caddc co c2 cexp co cr wcel cc0 vk cv cX cfv vk cv cY
      cfv caddc co c2 cexp co cle wbr vk cv cX cfv vk cv cY cfv caddc co cr
      wcel c2 cn0 wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel vk
      cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv caddc co c2 reexpcl vk cv
      cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv caddc co cr
      wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv readdcl c1 cN cfz
      co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3
      ffvelrni sylanc 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv vk cv
      cY cfv caddc co cr wcel cc0 vk cv cX cfv vk cv cY cfv caddc co c2 cexp co
      cle wbr vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY
      cfv caddc co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv
      readdcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv
      cY trirni.3 ffvelrni sylanc vk cv cX cfv vk cv cY cfv caddc co sqge0 syl
      jca rgen vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk c1 cN fsumcmp0
      mp2an c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu
      cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel
      vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2
      cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cX cfv vk cv cY cfv caddc co cr wcel c2 cn0 wcel vk cv cX cfv vk
      cv cY cfv caddc co c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX
      cfv vk cv cY cfv caddc co c2 reexpcl vk cv cX cfv cr wcel vk cv cY cfv cr
      wcel vk cv cX cfv vk cv cY cfv caddc co cr wcel vk cv c1 cN cfz co wcel
      vk cv cX cfv vk cv cY cfv readdcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc 2nn0 sylancl
      rgen vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk c1 cN fsumrecl
      mp2an sqsqri ax-mp c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2
      cexp co vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul
      co caddc co vk cv cY cfv c2 cexp co caddc co vk vk cv cX cfv cc wcel vk
      cv cY cfv cc wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk cv cX
      cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co caddc co vk
      cv cY cfv c2 cexp co caddc co wceq vk cv c1 cN cfz co wcel vk cv cX cfv
      vk cv cY cfv binom2 vk cv c1 cN cfz co wcel vk cv cX cfv c1 cN cfz co cr
      vk cv cX trirni.2 ffvelrni recnd vk cv c1 cN cfz co wcel vk cv cY cfv c1
      cN cfz co cr vk cv cY trirni.3 ffvelrni recnd sylanc sumeq2i c1 cN cfz co
      vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      caddc co vk cv cY cfv c2 cexp co caddc co vk csu c1 cN cfz co vk cv cX
      cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co caddc co vk
      csu c1 cN cfz co vk cv cY cfv c2 cexp co vk csu caddc co c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv
      cmul co cmul co vk csu caddc co c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu caddc co cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co c2 vk cv cX cfv
      vk cv cY cfv cmul co cmul co caddc co cc wcel vk cv cY cfv c2 cexp co cc
      wcel wa vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co c2 vk
      cv cX cfv vk cv cY cfv cmul co cmul co caddc co vk cv cY cfv c2 cexp co
      caddc co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk
      cv cY cfv cmul co cmul co caddc co vk csu c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu caddc co wceq cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co
      cmul co caddc co cc wcel vk cv cY cfv c2 cexp co cc wcel wa vk c1 cN cfz
      co vk cv c1 cN cfz co wcel vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co caddc co cc wcel vk cv cY cfv c2 cexp co cc wcel
      vk cv cX cfv c2 cexp co cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul
      co cc wcel vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co
      cmul co caddc co cc wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 cexp co
      c2 vk cv cX cfv vk cv cY cfv cmul co cmul co addcl vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 cexp co vk cv cX cfv cr wcel c2 cn0 wcel vk cv cX
      cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl c1
      cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl recnd c2 cc wcel vk
      cv cX cfv vk cv cY cfv cmul co cc wcel c2 vk cv cX cfv vk cv cY cfv cmul
      co cmul co cc wcel vk cv c1 cN cfz co wcel c2 vk cv cX cfv vk cv cY cfv
      cmul co mulcl 2cn vk cv cX cfv cc wcel vk cv cY cfv cc wcel vk cv cX cfv
      vk cv cY cfv cmul co cc wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv
      cY cfv mulcl vk cv c1 cN cfz co wcel vk cv cX cfv c1 cN cfz co cr vk cv
      cX trirni.2 ffvelrni recnd vk cv c1 cN cfz co wcel vk cv cY cfv c1 cN cfz
      co cr vk cv cY trirni.3 ffvelrni recnd sylanc sylancr sylanc vk cv c1 cN
      cfz co wcel vk cv cY cfv c2 cexp co vk cv cY cfv cr wcel c2 cn0 wcel vk
      cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2
      reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl recnd jca
      rgen vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co
      caddc co vk cv cY cfv c2 cexp co vk c1 cN fsumadd mp2an c1 cN cfz co vk
      cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co caddc
      co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN cfz co c2 vk
      cv cX cfv vk cv cY cfv cmul co cmul co vk csu caddc co c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu caddc cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co
      cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc wcel wa vk c1 cN
      cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY
      cfv cmul co cmul co caddc co vk csu c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu c1 cN cfz co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk csu
      caddc co wceq cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv
      cX cfv c2 cexp co cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc
      wcel wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv c2 cexp co
      cc wcel c2 vk cv cX cfv vk cv cY cfv cmul co cmul co cc wcel vk cv c1 cN
      cfz co wcel vk cv cX cfv c2 cexp co vk cv cX cfv cr wcel c2 cn0 wcel vk
      cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2
      reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl recnd c2
      cc wcel vk cv cX cfv vk cv cY cfv cmul co cc wcel c2 vk cv cX cfv vk cv
      cY cfv cmul co cmul co cc wcel vk cv c1 cN cfz co wcel c2 vk cv cX cfv vk
      cv cY cfv cmul co mulcl 2cn vk cv cX cfv cc wcel vk cv cY cfv cc wcel vk
      cv cX cfv vk cv cY cfv cmul co cc wcel vk cv c1 cN cfz co wcel vk cv cX
      cfv vk cv cY cfv mulcl vk cv c1 cN cfz co wcel vk cv cX cfv c1 cN cfz co
      cr vk cv cX trirni.2 ffvelrni recnd vk cv c1 cN cfz co wcel vk cv cY cfv
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni recnd sylanc sylancr jca rgen
      vk cv cX cfv c2 cexp co c2 vk cv cX cfv vk cv cY cfv cmul co cmul co vk
      c1 cN fsumadd mp2an opreq1i eqtri 3eqtri c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr
      cfv caddc co c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr
      cfv c2 cexp co c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co cmul co caddc
      co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv c2 cexp co caddc
      co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c2 c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk
      csu csqr cfv cmul co cmul co caddc co c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu caddc co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu csqr cfv cc0 c1 cN cfz co vk cv cX cfv c2 cexp
      co vk csu cle wbr c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv cr
      wcel cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cX cfv
      c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co
      cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv c2 cexp
      co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv cr wcel c2
      cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl vk
      cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX cfv c2 cexp co cle
      wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv cX cfv sqge0 syl jca
      rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv
      cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl
      c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv
      c2 cexp co vk c1 cN fsumrecl mp2an sqrcli ax-mp recni c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu csqr cfv cc0 c1 cN cfz co vk cv cY cfv c2 cexp
      co vk csu cle wbr c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cr
      wcel cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co
      cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY cfv c2 cexp
      co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv cr wcel c2
      cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY
      cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk
      cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle
      wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel c2 cn0 wcel vk cv
      cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl
      c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv
      c2 cexp co vk c1 cN fsumrecl mp2an sqrcli ax-mp recni binom2i c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu csqr cfv c2 cexp co c2 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co
      vk csu csqr cfv cmul co cmul co caddc co c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co cmul co caddc
      co c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv c2 cexp co c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu caddc c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu csqr cfv c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu c2 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz
      co vk cv cY cfv c2 cexp co vk csu csqr cfv cmul co cmul co caddc cc0 c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu csqr cfv c2 cexp co c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu wceq cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel
      cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX
      cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv
      cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX
      cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel
      c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv
      cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl
      rgen vk cv cX cfv c2 cexp co vk c1 cN fsumrecl mp2an sqsqri ax-mp opreq1i
      cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu csqr cfv c2 cexp co c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu wceq cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel
      cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz
      co vk cv cY cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY
      cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv
      cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv
      cY cfv sqge0 syl jca rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cY
      cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel
      c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv
      cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumrecl mp2an sqsqri ax-mp
      opreq12i eqtri 3brtr4i cc0 c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc
      co c2 cexp co vk csu csqr cfv cle wbr cc0 c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr
      cfv caddc co cle wbr c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr
      cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co cle wbr
      c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr
      cfv c2 cexp co c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co c2 cexp co cle
      wbr wb cc0 c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk
      csu cle wbr cc0 c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp
      co vk csu csqr cfv cle wbr cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv
      caddc co c2 cexp co cr wcel cc0 vk cv cX cfv vk cv cY cfv caddc co c2
      cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cX cfv vk
      cv cY cfv caddc co c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv vk cv cY cfv caddc co c2 cexp
      co cr wcel cc0 vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cle wbr wa
      vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv caddc
      co c2 cexp co cr wcel cc0 vk cv cX cfv vk cv cY cfv caddc co c2 cexp co
      cle wbr vk cv cX cfv vk cv cY cfv caddc co cr wcel c2 cn0 wcel vk cv cX
      cfv vk cv cY cfv caddc co c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk
      cv cX cfv vk cv cY cfv caddc co c2 reexpcl vk cv cX cfv cr wcel vk cv cY
      cfv cr wcel vk cv cX cfv vk cv cY cfv caddc co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv vk cv cY cfv readdcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc 2nn0 sylancl
      vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv caddc co cr wcel cc0 vk
      cv cX cfv vk cv cY cfv caddc co c2 cexp co cle wbr vk cv cX cfv cr wcel
      vk cv cY cfv cr wcel vk cv cX cfv vk cv cY cfv caddc co cr wcel vk cv c1
      cN cfz co wcel vk cv cX cfv vk cv cY cfv readdcl c1 cN cfz co cr vk cv cX
      trirni.2 ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc vk cv
      cX cfv vk cv cY cfv caddc co sqge0 syl jca rgen vk cv cX cfv vk cv cY cfv
      caddc co c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv cX cfv vk
      cv cY cfv caddc co c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv vk
      cv cY cfv caddc co c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co
      vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu cr wcel cN cn wcel
      cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv vk cv cY cfv
      caddc co c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv vk cv cY cfv
      caddc co cr wcel c2 cn0 wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp
      co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv caddc co c2
      reexpcl vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY
      cfv caddc co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv
      readdcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv
      cY trirni.3 ffvelrni sylanc 2nn0 sylancl rgen vk cv cX cfv vk cv cY cfv
      caddc co c2 cexp co vk c1 cN fsumrecl mp2an sqrge0i ax-mp cc0 c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu csqr cfv cle wbr cc0 c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu csqr cfv cle wbr cc0 c1 cN cfz co vk cv cX cfv
      c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      csqr cfv caddc co cle wbr cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu
      cle wbr cc0 c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv cle wbr
      cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2
      cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr
      wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv c2 cexp co cr
      wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv cr wcel c2 cn0 wcel
      vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2
      reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl vk cv c1
      cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr
      c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv cX cfv sqge0 syl jca
      rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv
      cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl
      c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv
      c2 cexp co vk c1 cN fsumrecl mp2an sqrge0i ax-mp cc0 c1 cN cfz co vk cv
      cY cfv c2 cexp co vk csu cle wbr cc0 c1 cN cfz co vk cv cY cfv c2 cexp co
      vk csu csqr cfv cle wbr cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr
      wcel cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1
      cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY
      cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv
      cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY
      cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz
      co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3
      ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk
      cv cY cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni
      vk cv cY cfv sqge0 syl jca rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0
      mp2an c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk
      cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv
      cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni
      2nn0 sylancl rgen vk cv cY cfv c2 cexp co vk c1 cN fsumrecl mp2an sqrge0i
      ax-mp c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co
      vk cv cY cfv c2 cexp co vk csu csqr cfv cc0 c1 cN cfz co vk cv cX cfv c2
      cexp co vk csu cle wbr c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr
      cfv cr wcel cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr wcel cc0 vk cv
      cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv
      cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1
      cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp
      co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cX cfv c2
      cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX cfv cr wcel
      c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv
      cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl
      vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk cv cX cfv c2 cexp co
      cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni vk cv cX cfv sqge0 syl
      jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cr
      wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cX cfv
      c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv cr wcel c2 cn0 wcel vk cv
      cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv c2 reexpcl
      c1 cN cfz co cr vk cv cX trirni.2 ffvelrni 2nn0 sylancl rgen vk cv cX cfv
      c2 cexp co vk c1 cN fsumrecl mp2an sqrcli ax-mp cc0 c1 cN cfz co vk cv cY
      cfv c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cY cfv c2 cexp co vk csu
      csqr cfv cr wcel cN c1 cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel cc0
      vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co
      vk cv cY cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv wcel
      trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv
      c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv cY
      cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr vk cv cY cfv
      cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni
      2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cY cfv cr wcel cc0 vk cv cY
      cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cY trirni.3 ffvelrni vk cv
      cY cfv sqge0 syl jca rgen vk cv cY cfv c2 cexp co vk c1 cN fsumcmp0 mp2an
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk cv cY
      cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz
      mpbi vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cY cfv cr wcel
      c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk cv
      cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY trirni.3 ffvelrni 2nn0 sylancl
      rgen vk cv cY cfv c2 cexp co vk c1 cN fsumrecl mp2an sqrcli ax-mp addge0i
      mp2an c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu
      csqr cfv c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz
      co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co cc0 c1 cN cfz co vk
      cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu cle wbr c1 cN cfz co vk
      cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cfv cr wcel cN c1
      cuz cfv wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel cc0 vk
      cv cX cfv vk cv cY cfv caddc co c2 cexp co cle wbr wa vk c1 cN cfz co
      wral cc0 c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk
      csu cle wbr cN cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv
      cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel cc0 vk cv cX cfv vk cv cY
      cfv caddc co c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co
      wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel cc0 vk cv cX
      cfv vk cv cY cfv caddc co c2 cexp co cle wbr vk cv cX cfv vk cv cY cfv
      caddc co cr wcel c2 cn0 wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp
      co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv caddc co c2
      reexpcl vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv vk cv cY
      cfv caddc co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv cY cfv
      readdcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr vk cv
      cY trirni.3 ffvelrni sylanc 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX
      cfv vk cv cY cfv caddc co cr wcel cc0 vk cv cX cfv vk cv cY cfv caddc co
      c2 cexp co cle wbr vk cv cX cfv cr wcel vk cv cY cfv cr wcel vk cv cX cfv
      vk cv cY cfv caddc co cr wcel vk cv c1 cN cfz co wcel vk cv cX cfv vk cv
      cY cfv readdcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni c1 cN cfz co cr
      vk cv cY trirni.3 ffvelrni sylanc vk cv cX cfv vk cv cY cfv caddc co
      sqge0 syl jca rgen vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk c1 cN
      fsumcmp0 mp2an c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co
      vk csu cN c1 cuz cfv wcel vk cv cX cfv vk cv cY cfv caddc co c2 cexp co
      cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc
      co c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cX cfv vk cv cY cfv caddc co c2 cexp co cr wcel vk c1
      cN cfz co vk cv cX cfv vk cv cY cfv caddc co cr wcel c2 cn0 wcel vk cv cX
      cfv vk cv cY cfv caddc co c2 cexp co cr wcel vk cv c1 cN cfz co wcel vk
      cv cX cfv vk cv cY cfv caddc co c2 reexpcl vk cv cX cfv cr wcel vk cv cY
      cfv cr wcel vk cv cX cfv vk cv cY cfv caddc co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv vk cv cY cfv readdcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni c1 cN cfz co cr vk cv cY trirni.3 ffvelrni sylanc 2nn0 sylancl
      rgen vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk c1 cN fsumrecl
      mp2an sqrcli ax-mp c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv
      c1 cN cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv cc0 c1 cN cfz co vk
      cv cX cfv c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cX cfv c2 cexp co
      vk csu csqr cfv cr wcel cN c1 cuz cfv wcel vk cv cX cfv c2 cexp co cr
      wcel cc0 vk cv cX cfv c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1
      cN cfz co vk cv cX cfv c2 cexp co vk csu cle wbr cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel cc0 vk cv cX
      cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv c1 cN cfz co wcel vk cv
      cX cfv c2 cexp co cr wcel cc0 vk cv cX cfv c2 cexp co cle wbr vk cv cX
      cfv cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz
      co wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2
      ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cX cfv cr wcel cc0 vk
      cv cX cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      vk cv cX cfv sqge0 syl jca rgen vk cv cX cfv c2 cexp co vk c1 cN fsumcmp0
      mp2an c1 cN cfz co vk cv cX cfv c2 cexp co vk csu cN c1 cuz cfv wcel vk
      cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cX
      cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv wcel trirni.1 cN
      elnnuz mpbi vk cv cX cfv c2 cexp co cr wcel vk c1 cN cfz co vk cv cX cfv
      cr wcel c2 cn0 wcel vk cv cX cfv c2 cexp co cr wcel vk cv c1 cN cfz co
      wcel vk cv cX cfv c2 reexpcl c1 cN cfz co cr vk cv cX trirni.2 ffvelrni
      2nn0 sylancl rgen vk cv cX cfv c2 cexp co vk c1 cN fsumrecl mp2an sqrcli
      ax-mp cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr c1 cN cfz
      co vk cv cY cfv c2 cexp co vk csu csqr cfv cr wcel cN c1 cuz cfv wcel vk
      cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1
      cN cfz co wral cc0 c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cle wbr cN
      cn wcel cN c1 cuz cfv wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp
      co cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr wa vk c1 cN cfz co vk cv
      c1 cN cfz co wcel vk cv cY cfv c2 cexp co cr wcel cc0 vk cv cY cfv c2
      cexp co cle wbr vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co
      cr wcel vk cv c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr
      vk cv cY trirni.3 ffvelrni 2nn0 sylancl vk cv c1 cN cfz co wcel vk cv cY
      cfv cr wcel cc0 vk cv cY cfv c2 cexp co cle wbr c1 cN cfz co cr vk cv cY
      trirni.3 ffvelrni vk cv cY cfv sqge0 syl jca rgen vk cv cY cfv c2 cexp co
      vk c1 cN fsumcmp0 mp2an c1 cN cfz co vk cv cY cfv c2 cexp co vk csu cN c1
      cuz cfv wcel vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN
      cfz co vk cv cY cfv c2 cexp co vk csu cr wcel cN cn wcel cN c1 cuz cfv
      wcel trirni.1 cN elnnuz mpbi vk cv cY cfv c2 cexp co cr wcel vk c1 cN cfz
      co vk cv cY cfv cr wcel c2 cn0 wcel vk cv cY cfv c2 cexp co cr wcel vk cv
      c1 cN cfz co wcel vk cv cY cfv c2 reexpcl c1 cN cfz co cr vk cv cY
      trirni.3 ffvelrni 2nn0 sylancl rgen vk cv cY cfv c2 cexp co vk c1 cN
      fsumrecl mp2an sqrcli ax-mp readdcli le2sqi mp2an mpbir $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N k $. $d X k $. $d Y k $.
    $( Triangle inequality in R^n. $)
    trirn $p |- ( ( N e. NN /\ X : ( 1 ... N ) --> RR
                 /\ Y : ( 1 ... N ) --> RR )
            -> ( sqr ` sum_ k e. ( 1 ... N ) ( ( ( X ` k ) + ( Y ` k ) ) ^ 2 )
                  ) <_ ( ( sqr ` sum_ k e. ( 1 ... N ) ( ( X ` k ) ^ 2 ) )
                    + ( sqr ` sum_ k e. ( 1 ... N ) ( ( Y ` k ) ^ 2 ) ) ) ) $=
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a c1 cN cfz co
      vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cfv c1 cN cfz
      co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cY cfv c2
      cexp co vk csu csqr cfv caddc co cle wbr c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv vk cv cY cfv
      caddc co c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv c2 cexp co vk csu
      csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co cle wbr c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1
      c1 cfz co cc0 csn cxp cif cfv vk cv cY cfv caddc co c2 cexp co vk csu
      csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cfv c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co cle wbr c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co
      cc0 csn cxp cif cfv vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv caddc co c2 cexp co vk
      csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr
      cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cY c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cfv caddc
      co cle wbr cN cX cY c1 c1 c1 cfz co cc0 csn cxp c1 c1 cfz co cc0 csn cxp
      cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      wceq c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu
      csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr
      cfv c1 cN cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co vk
      cv cY cfv c2 cexp co vk csu csqr cfv caddc co c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv c2 cexp
      co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co
      cle cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif wceq c1 cN cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk
      csu c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cN
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq
      c1 cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk cN
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1
      cfz opreq2 sumeq1d fveq2d cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif wceq c1 cN cfz co vk cv cX cfv c2 cexp co vk
      csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cfz co
      vk cv cY cfv c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co vk
      csu csqr cfv caddc cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif wceq c1 cN cfz co vk cv cX cfv c2 cexp co vk csu c1 cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co
      vk cv cX cfv c2 cexp co vk csu csqr cN cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cN cfz co c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv
      c2 cexp co vk cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif c1 cfz opreq2 sumeq1d fveq2d cN cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cN cfz co vk cv cY cfv
      c2 cexp co vk csu c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co vk csu csqr cN cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cN cfz
      co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co vk cv cY cfv c2 cexp co vk cN cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2 sumeq1d fveq2d opreq12d
      breq12d cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX
      c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv vk cv cY cfv caddc
      co c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif cfv vk cv cY
      cfv caddc co c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv c2 cexp co vk
      csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1
      c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cfv c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cY
      cfv c2 cexp co vk csu csqr cfv caddc co cle cX cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk csu c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cX cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co vk cv cX cfv vk cv cY cfv caddc co c2 cexp co vk
      cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif cfv vk cv cY cfv caddc co c2 cexp co vk cX cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif wceq vk cv cX cfv vk cv cY cfv caddc co vk cv cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp
      cif cfv vk cv cY cfv caddc co c2 cexp cX cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq vk cv cX
      cfv vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX
      c1 c1 cfz co cc0 csn cxp cif cfv vk cv cY cfv caddc vk cv cX cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn
      cxp cif fveq1 opreq1d opreq1d sumeq2sdv fveq2d cX cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq
      c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cfz co vk cv cX cfv c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp
      cif cfv c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co vk csu
      csqr cfv caddc cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cX c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cX cfv c2 cexp co vk
      csu c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cX c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cX cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co vk cv cX cfv c2 cexp co vk cv cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif
      cfv c2 cexp co vk cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq vk cv cX cfv vk cv cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn
      cxp cif cfv c2 cexp vk cv cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif fveq1 opreq1d sumeq2sdv
      fveq2d opreq1d breq12d cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn
      cxp cif cfv vk cv cY cfv caddc co c2 cexp co vk csu csqr cfv c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk
      cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif cfv vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv caddc co c2 cexp
      co vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu
      csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co vk cv cY cfv c2 cexp co vk csu csqr cfv caddc co c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk
      cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cfv c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0
      csn cxp cif cfv c2 cexp co vk csu csqr cfv caddc co cle cY cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp
      cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif cfv vk cv cY cfv caddc co c2 cexp
      co vk csu c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif cfv vk cv cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv
      caddc co c2 cexp co vk csu csqr cY cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif cfv vk cv cY cfv caddc co c2 cexp co vk cv cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif
      cfv vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY
      c1 c1 cfz co cc0 csn cxp cif cfv caddc co c2 cexp co vk cY cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp
      cif wceq vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cX c1 c1 cfz co cc0 csn cxp cif cfv vk cv cY cfv caddc co vk cv cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif cfv vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv caddc co c2 cexp cY cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn
      cxp cif wceq vk cv cY cfv vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv vk cv cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn
      cxp cif cfv caddc vk cv cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif fveq1 opreq2d opreq1d
      sumeq2sdv fveq2d cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co
      vk csu csqr cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr
      cfv c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co vk cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cX c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cfv caddc
      cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1
      cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif cfz co vk cv cY cfv c2 cexp co vk csu c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co vk
      cv cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1
      cfz co cc0 csn cxp cif cfv c2 cexp co vk csu csqr cY cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif
      wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co vk cv cY cfv c2 cexp co vk cv cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv c2 cexp co
      vk cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1
      cfz co cc0 csn cxp cif wceq vk cv cY cfv vk cv cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cfv c2
      cexp vk cv cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cY c1 c1 cfz co cc0 csn cxp cif fveq1 opreq1d sumeq2sdv fveq2d opreq2d
      breq12d vk cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1
      c1 cfz co cc0 csn cxp cif cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp
      cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cY c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif cfz co cr cX wf c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf w3a cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif cfz co cr cY wf w3a cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp
      cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cY c1 c1 cfz co cc0 csn cxp cif wf w3a cN cX cY c1 c1 c1 cfz co cc0
      csn cxp c1 c1 cfz co cc0 csn cxp c1 cn wcel c1 c1 cfz co cr c1 c1 cfz co
      cc0 csn cxp wf c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf w3a cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co
      cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf w3a
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn
      wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf
      w3a cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif wceq cN cn wcel cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cn wcel c1 cN cfz co cr cX wf c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX wf c1 cN cfz co
      cr cY wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cY wf cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cn eleq1 cN cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif wceq c1 cN cfz co c1 cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co wceq c1 cN cfz co
      cr cX wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cX wf wb cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif c1 cfz opreq2 c1 cN cfz co c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX feq2 syl
      cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      wceq c1 cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co wceq c1 cN cfz co cr cY wf c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf wb cN
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1
      cfz opreq2 c1 cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cfz co cr cY feq2 syl 3anbi123d cX cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp
      cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cX wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf
      c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cfz co cr cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cX c1 c1 cfz co cc0 csn cxp cif feq1 3anbi2d cY cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq
      c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cfz co cr cY wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp
      cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cY c1 c1 cfz co cc0 csn cxp cif feq1 3anbi3d c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cn wcel cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1
      c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp
      wf c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0
      csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cn eleq1 c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif wceq c1 c1 cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co wceq c1 c1 cfz co cr c1 c1 cfz co
      cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf wb c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2 c1
      c1 cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp feq2 syl c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 c1 cfz co c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co wceq c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz
      co cc0 csn cxp wf wb c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif c1 cfz opreq2 c1 c1 cfz co c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0
      csn cxp feq2 syl 3anbi123d c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif
      wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn
      wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn
      cxp cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif feq1 3anbi2d c1 c1 cfz co cc0 csn cxp cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn
      cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn
      cxp cif wf cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0
      csn cxp cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1
      c1 cfz co cc0 csn cxp cif feq1 3anbi3d c1 cn wcel c1 c1 cfz co cr c1 c1
      cfz co cc0 csn cxp wf c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf 1nn c1
      c1 cfz co cc0 csn c1 c1 cfz co cc0 csn cxp wf cc0 csn cr wss c1 c1 cfz co
      cr c1 c1 cfz co cc0 csn cxp wf c1 c1 cfz co cc0 cc0 cr 0re elisseti
      fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr cc0 cr 0re elisseti snss
      mpbi c1 c1 cfz co cc0 csn cr c1 c1 cfz co cc0 csn cxp fss mp2an c1 c1 cfz
      co cc0 csn c1 c1 cfz co cc0 csn cxp wf cc0 csn cr wss c1 c1 cfz co cr c1
      c1 cfz co cc0 csn cxp wf c1 c1 cfz co cc0 cc0 cr 0re elisseti fconst cc0
      cr wcel cc0 csn cr wss 0re cc0 cr cc0 cr 0re elisseti snss mpbi c1 c1 cfz
      co cc0 csn cr c1 c1 cfz co cc0 csn cxp fss mp2an 3pm3.2i elimhyp3v
      3simp1i cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wf
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr
      cX wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr cY wf w3a cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf
      w3a cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wf w3a
      cN cX cY c1 c1 c1 cfz co cc0 csn cxp c1 c1 cfz co cc0 csn cxp c1 cn wcel
      c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1 cfz co cr c1 c1 cfz co
      cc0 csn cxp wf w3a cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp wf w3a cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr
      c1 c1 cfz co cc0 csn cxp wf w3a cN cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif wceq cN cn wcel cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cfz co cr cX wf
      c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cfz co cr cX wf c1 cN cfz co cr cY wf c1 cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf cN cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn eleq1 cN cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cN
      cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co wceq c1 cN cfz co cr cX wf c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX wf wb cN cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2
      c1 cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr cX feq2 syl cN cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cN cfz co c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co wceq c1 cN cfz
      co cr cY wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr cY wf wb cN cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2 c1 cN cfz co c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY feq2
      syl 3anbi123d cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cX c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX wf c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif wf cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cfz co cr cY wf c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif feq1
      3anbi2d cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY
      c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf c1 cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp
      cif wf cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif
      feq1 3anbi3d c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif wceq c1 cn wcel cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif cn wcel c1 c1 cfz co cr c1 c1 cfz co cc0 csn
      cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1 cfz co cr c1 c1 cfz co
      cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn eleq1 c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 c1
      cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN
      c1 cif cfz co wceq c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr
      c1 c1 cfz co cc0 csn cxp wf wb c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2 c1 c1 cfz co c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp feq2 syl c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif wceq c1 c1 cfz co c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co wceq c1 c1 cfz co cr c1
      c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf wb c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1 cfz
      opreq2 c1 c1 cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp feq2 syl 3anbi123d
      c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0
      csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0
      csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif feq1
      3anbi2d c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif feq1
      3anbi3d c1 cn wcel c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1 cfz
      co cr c1 c1 cfz co cc0 csn cxp wf 1nn c1 c1 cfz co cc0 csn c1 c1 cfz co
      cc0 csn cxp wf cc0 csn cr wss c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf
      c1 c1 cfz co cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0 csn cr wss
      0re cc0 cr cc0 cr 0re elisseti snss mpbi c1 c1 cfz co cc0 csn cr c1 c1
      cfz co cc0 csn cxp fss mp2an c1 c1 cfz co cc0 csn c1 c1 cfz co cc0 csn
      cxp wf cc0 csn cr wss c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1
      cfz co cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0
      cr cc0 cr 0re elisseti snss mpbi c1 c1 cfz co cc0 csn cr c1 c1 cfz co cc0
      csn cxp fss mp2an 3pm3.2i elimhyp3v 3simp2i cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif
      wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cY c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co
      cr cY wf w3a cN c1 cif cfz co cr cX wf c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf w3a cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz
      co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr cY wf w3a cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf
      c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY
      c1 c1 cfz co cc0 csn cxp cif wf w3a cN cX cY c1 c1 c1 cfz co cc0 csn cxp
      c1 c1 cfz co cc0 csn cxp c1 cn wcel c1 c1 cfz co cr c1 c1 cfz co cc0 csn
      cxp wf c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf w3a cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf w3a cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co
      cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf w3a cN cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq cN
      cn wcel cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cn wcel c1 cN cfz co cr cX wf c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX wf c1 cN cfz co cr cY wf c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co cr cY wf cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cn eleq1 cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cN c1 cif wceq c1 cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co wceq c1 cN cfz co cr cX wf c1 cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co
      cr cX wf wb cN cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif c1 cfz opreq2 c1 cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cX feq2 syl cN cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cN cfz
      co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co wceq c1 cN cfz co cr cY wf c1 cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf wb cN cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2 c1
      cN cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr cY feq2 syl 3anbi123d cX cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz
      co cr cX wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY
      wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cY wf c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr
      cX cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1
      cfz co cc0 csn cxp cif feq1 3anbi2d cY cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr
      cY wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a
      cY c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf c1 cN
      cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co
      cr cY cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1
      cfz co cc0 csn cxp cif feq1 3anbi3d c1 cN cn wcel c1 cN cfz co cr cX wf
      c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 cn wcel cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 c1 cfz co cr
      c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1 cfz
      co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp wf c1
      cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn
      eleq1 c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif wceq c1 c1 cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co wceq c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp
      wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif cfz co cr c1 c1 cfz co cc0 csn cxp wf wb c1 cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif c1 cfz opreq2 c1 c1 cfz co
      c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif
      cfz co cr c1 c1 cfz co cc0 csn cxp feq2 syl c1 cN cn wcel c1 cN cfz co cr
      cX wf c1 cN cfz co cr cY wf w3a cN c1 cif wceq c1 c1 cfz co c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co wceq c1
      c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX
      wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp
      wf wb c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1
      cif c1 cfz opreq2 c1 c1 cfz co c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp feq2 syl
      3anbi123d c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co cr cX wf c1 cN
      cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN
      cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0 csn cxp cif
      feq1 3anbi2d c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co cr cX wf c1
      cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wceq c1 cN cn wcel
      c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr c1 c1
      cfz co cc0 csn cxp wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr
      cY wf w3a cN c1 cif cfz co cr cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz
      co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif wf cN cn wcel c1 cN cfz
      co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cn wcel c1 cN cn wcel c1
      cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cN c1 cif cfz co cr cN cn
      wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf w3a cX c1 c1 cfz co cc0
      csn cxp cif wf c1 cN cn wcel c1 cN cfz co cr cX wf c1 cN cfz co cr cY wf
      w3a cN c1 cif cfz co cr c1 c1 cfz co cc0 csn cxp cN cn wcel c1 cN cfz co
      cr cX wf c1 cN cfz co cr cY wf w3a cY c1 c1 cfz co cc0 csn cxp cif feq1
      3anbi3d c1 cn wcel c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1 cfz
      co cr c1 c1 cfz co cc0 csn cxp wf 1nn c1 c1 cfz co cc0 csn c1 c1 cfz co
      cc0 csn cxp wf cc0 csn cr wss c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf
      c1 c1 cfz co cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0 csn cr wss
      0re cc0 cr cc0 cr 0re elisseti snss mpbi c1 c1 cfz co cc0 csn cr c1 c1
      cfz co cc0 csn cxp fss mp2an c1 c1 cfz co cc0 csn c1 c1 cfz co cc0 csn
      cxp wf cc0 csn cr wss c1 c1 cfz co cr c1 c1 cfz co cc0 csn cxp wf c1 c1
      cfz co cc0 cc0 cr 0re elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0
      cr cc0 cr 0re elisseti snss mpbi c1 c1 cfz co cc0 csn cr c1 c1 cfz co cc0
      csn cxp fss mp2an 3pm3.2i elimhyp3v 3simp3i trirni dedth3v $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( The union of two open sets is open. $)
    unopn $p |- ( ( J e. Top /\ A e. J /\ B e. J ) -> ( A u. B ) e. J ) $=
      cJ ctop wcel cA cJ wcel cB cJ wcel w3a cA cB cpr cuni cA cB cun cJ cA cJ
      wcel cB cJ wcel cA cB cpr cuni cA cB cun wceq cJ ctop wcel cA cB cJ cJ
      uniprg 3adant1 cJ ctop wcel cA cJ wcel cB cJ wcel cA cB cpr cuni cJ wcel
      cJ ctop wcel cA cB cpr cJ wss cA cB cpr cuni cJ wcel cA cJ wcel cB cJ
      wcel wa cA cB cpr cJ uniopn cA cJ wcel cB cJ wcel wa cA cB cpr cJ wss cA
      cB cJ cJ cJ prssg ibi sylan2 3impb eqeltrrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A a $. $d B a $.
    $( The intersection of two closed sets is closed. $)
    incld $p |- ( ( J e. Top /\ A e. ( Clsd ` J ) /\ B e. ( Clsd ` J ) )
                                      -> ( A i^i B ) e. ( Clsd ` J ) ) $=
      cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel w3a cA cB cpr cint
      cA cB cin cJ ccld cfv cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB cpr
      cint cA cB cin wceq cJ ctop wcel cA cvv wcel cB cvv wcel cA cB cpr cint
      cA cB cin wceq cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB intprd cA cJ
      ccld cfv elisset cB cJ ccld cfv elisset syl2an 3adant1 cJ ctop wcel cA cB
      cpr c0 wne cA cB cpr cJ ccld cfv wss cA cB cpr cint cJ ccld cfv wcel cJ
      ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel w3a cA cB cpr cJ intcld
      cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel 3simp1 cA cJ ccld
      cfv wcel cJ ctop wcel cA cB cpr c0 wne cB cJ ccld cfv wcel va cv cB cpr
      c0 wne cA cB cpr c0 wne va cA cJ ccld cfv va cv cA wceq va cv cB cpr cA
      cB cpr c0 va cv cA cB preq1 neeq1d va cv cB va visset prnz vtoclg
      3ad2ant2 cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB cpr cJ ccld cfv
      wss cJ ctop wcel cA cJ ccld cfv wcel cB cJ ccld cfv wcel wa cA cB cpr cJ
      ccld cfv wss cA cB cJ ccld cfv cJ ccld cfv cJ ccld cfv prssg ibi 3adant1
      syl3anc eqeltrrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J v $. $d X v $. $d A v $. $d B v $.
    subspopn.1 $e |- X = U. J $.
    $( An open set is open in the subspace topology. $)
    subspopn $p |- ( ( ( J e. Top /\ A C_ X ) /\ ( B e. J /\ B C_ A ) )
                                      -> B e. ( subSp ` <. A , J >. ) ) $=
      cJ ctop wcel cA cX wss wa cB cJ wcel cB cA wss wa wa cB cA cJ cop csubsp
      cfv wcel cB vv cv cA cin wceq vv cJ wrex cB cJ wcel cB cB cA cin wceq cB
      vv cv cA cin wceq vv cJ wrex cJ ctop wcel cA cX wss wa cB cJ wcel cB cA
      wss wa wa cB vv cv cA cin wceq cB cB cA cin wceq vv cB cJ vv cv cB wceq
      vv cv cA cin cB cA cin cB vv cv cB cA ineq1 eqeq2d rcla4ev cJ ctop wcel
      cA cX wss wa cB cJ wcel cB cA wss simprl cB cA wss cB cB cA cin wceq cJ
      ctop wcel cA cX wss wa cB cJ wcel cB cA wss cB cB cA cin wceq cB cA dfss
      biimpi ad2antll sylanc cJ ctop wcel cB cJ wcel cA cvv wcel cB cA cJ cop
      csubsp cfv wcel cB vv cv cA cin wceq vv cJ wrex wb cJ ctop wcel cA cX wss
      wa cB cJ wcel cB cA wss wa wa vv cB cA cJ cJ issubspt cJ ctop wcel cA cX
      wss cB cJ wcel cB cA wss wa simpll cJ ctop wcel cA cX wss wa cB cJ wcel
      cB cA wss simprl cJ ctop wcel cA cX wss wa cA cvv wcel cB cJ wcel cB cA
      wss wa cA cX wss cJ ctop wcel cA cvv wcel cA cX wss cX cvv wcel cA cvv
      wcel cJ ctop wcel cA cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop
      uniexg subspopn.1 syl5eqel sylan2 ancoms adantr syl3anc mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J v $. $d X v $. $d A v $. $d B v $.
    subspcld.1 $e |- X = U. J $.
    $( A closed set is closed in the subspace topology. $)
    subspcld $p |- ( ( ( J e. Top /\ A C_ X ) /\ ( B e. ( Clsd ` J )
                /\ B C_ A ) ) -> B e. ( Clsd ` ( subSp ` <. A , J >. ) ) ) $=
      cJ ctop wcel cA cX wss wa cB cJ ccld cfv wcel cB cA wss wa wa cB cA cJ
      cop csubsp cfv ccld cfv wcel cB vv cv cA cin wceq vv cJ ccld cfv wrex cB
      cJ ccld cfv wcel cB cB cA cin wceq cB vv cv cA cin wceq vv cJ ccld cfv
      wrex cJ ctop wcel cA cX wss wa cB cJ ccld cfv wcel cB cA wss wa wa cB vv
      cv cA cin wceq cB cB cA cin wceq vv cB cJ ccld cfv vv cv cB wceq vv cv cA
      cin cB cA cin cB vv cv cB cA ineq1 eqeq2d rcla4ev cJ ctop wcel cA cX wss
      wa cB cJ ccld cfv wcel cB cA wss simprl cB cA wss cB cB cA cin wceq cJ
      ctop wcel cA cX wss wa cB cJ ccld cfv wcel cB cA wss cB cB cA cin wceq cB
      cA dfss biimpi ad2antll sylanc cJ ctop wcel cA cX wss wa cB cA cJ cop
      csubsp cfv ccld cfv wcel cB vv cv cA cin wceq vv cJ ccld cfv wrex wb cB
      cJ ccld cfv wcel cB cA wss wa vv cB cA cJ cX subspcld.1 subcld adantr
      mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A v $. $d B v $. $d J v $.
    $( A set which is closed in the subspace topology induced by a closed set
       is closed in the original topology. $)
    subspcld2 $p |- ( ( J e. Top /\ A e. ( Clsd ` J ) /\
            B e. ( Clsd ` ( subSp ` <. A , J >. ) ) ) -> B e. ( Clsd ` J ) ) $=
      cJ ctop wcel cA cJ ccld cfv wcel cB cA cJ cop csubsp cfv ccld cfv wcel cB
      cJ ccld cfv wcel cJ ctop wcel cA cJ ccld cfv wcel wa cB cA cJ cop csubsp
      cfv ccld cfv wcel cB vv cv cA cin wceq vv cJ ccld cfv wrex cB cJ ccld cfv
      wcel cJ ctop wcel cA cJ ccld cfv wcel cA cJ cuni wss cB cA cJ cop csubsp
      cfv ccld cfv wcel cB vv cv cA cin wceq vv cJ ccld cfv wrex wb cA cJ cJ
      cuni cJ cuni eqid cldss vv cB cA cJ cJ cuni cJ cuni eqid subcld syldan cJ
      ctop wcel cA cJ ccld cfv wcel wa cB vv cv cA cin wceq cB cJ ccld cfv wcel
      vv cJ ccld cfv cB vv cv cA cin wceq cB cJ ccld cfv wcel vv cv cA cin cJ
      ccld cfv wcel cJ ctop wcel cA cJ ccld cfv wcel wa vv cv cJ ccld cfv wcel
      wa cB vv cv cA cin cJ ccld cfv eleq1 cJ ctop wcel vv cv cJ ccld cfv wcel
      cA cJ ccld cfv wcel vv cv cA cin cJ ccld cfv wcel cJ ctop wcel vv cv cJ
      ccld cfv wcel cA cJ ccld cfv wcel vv cv cA cin cJ ccld cfv wcel vv cv cA
      cJ incld 3expa an1rs syl5cbir r19.23adva sylbid 3impia $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J w x y z $. $d X w x y z $. $d A w x y z $. $d B w x y z $.
    subspabs.1 $e |- X = U. J $.
    $( Absorption law for subspace. $)
    subspabs $p |- ( ( J e. Top /\ A C_ X /\ B C_ A ) -> ( subSp ` <. B ,
                  ( subSp ` <. A , J >. ) >. ) = ( subSp ` <. B , J >. ) ) $=
      cJ ctop wcel cA cX wss cB cA wss w3a vx cB cA cJ cop csubsp cfv cop
      csubsp cfv cB cJ cop csubsp cfv cJ ctop wcel cA cX wss cB cA wss w3a vx
      cv vy cv cB cin wceq vy cA cJ cop csubsp cfv wrex vx cv vz cv cB cin wceq
      vz cJ wrex vx cv cB cA cJ cop csubsp cfv cop csubsp cfv wcel vx cv cB cJ
      cop csubsp cfv wcel cJ ctop wcel cA cX wss cB cA wss w3a vx cv vy cv cB
      cin wceq vy cA cJ cop csubsp cfv wrex vx cv vz cv cB cin wceq vz cJ wrex
      cJ ctop wcel cA cX wss cB cA wss w3a vx cv vy cv cB cin wceq vx cv vz cv
      cB cin wceq vz cJ wrex vy cA cJ cop csubsp cfv cJ ctop wcel cA cX wss cB
      cA wss w3a vy cv cA cJ cop csubsp cfv wcel vy cv vw cv cA cin wceq vw cJ
      wrex vx cv vy cv cB cin wceq vx cv vz cv cB cin wceq vz cJ wrex wi cJ
      ctop wcel vy cv cvv wcel cA cvv wcel vy cv cA cJ cop csubsp cfv wcel vy
      cv vw cv cA cin wceq vw cJ wrex wb cJ ctop wcel cA cX wss cB cA wss w3a
      vw vy cv cA cvv cJ issubspt cJ ctop wcel cA cX wss cB cA wss 3simp1 vy cv
      cvv wcel cJ ctop wcel cA cX wss cB cA wss w3a vy visset a1i cJ ctop wcel
      cA cX wss cA cvv wcel cB cA wss cA cX wss cJ ctop wcel cA cvv wcel cA cX
      wss cX cvv wcel cA cvv wcel cJ ctop wcel cA cX cvv ssexg cJ ctop wcel cJ
      cuni cvv cX cJ ctop uniexg subspabs.1 syl5eqel sylan2 ancoms 3adant3
      syl3anc cJ ctop wcel cA cX wss cB cA wss w3a vy cv vw cv cA cin wceq vx
      cv vy cv cB cin wceq vx cv vz cv cB cin wceq vz cJ wrex wi vw cJ cJ ctop
      wcel cA cX wss cB cA wss w3a vw cv cJ wcel wa vy cv vw cv cA cin wceq vx
      cv vy cv cB cin wceq vx cv vz cv cB cin wceq vz cJ wrex vw cv cJ wcel vx
      cv vw cv cB cin wceq vx cv vz cv cB cin wceq vz cJ wrex cJ ctop wcel cA
      cX wss cB cA wss w3a vw cv cJ wcel wa vy cv vw cv cA cin wceq wa vx cv vy
      cv cB cin wceq wa vx cv vz cv cB cin wceq vx cv vw cv cB cin wceq vz vw
      cv cJ vz cv vw cv wceq vz cv cB cin vw cv cB cin vx cv vz cv vw cv cB
      ineq1 eqeq2d rcla4ev cJ ctop wcel cA cX wss cB cA wss w3a vw cv cJ wcel
      vy cv vw cv cA cin wceq vx cv vy cv cB cin wceq simpllr cJ ctop wcel cA
      cX wss cB cA wss w3a vw cv cJ wcel wa vy cv vw cv cA cin wceq wa vx cv vy
      cv cB cin wceq vx cv vw cv cB cin wceq cJ ctop wcel cA cX wss cB cA wss
      w3a vw cv cJ wcel wa vy cv vw cv cA cin wceq wa vy cv cB cin vw cv cB cin
      vx cv cJ ctop wcel cA cX wss cB cA wss w3a vw cv cJ wcel wa vy cv vw cv
      cA cin wceq wa vy cv cB cin vw cv cA cin cB cin vw cv cB cin vy cv vw cv
      cA cin wceq vy cv cB cin vw cv cA cin cB cin wceq cJ ctop wcel cA cX wss
      cB cA wss w3a vw cv cJ wcel wa vy cv vw cv cA cin cB ineq1 adantl cJ ctop
      wcel cA cX wss cB cA wss w3a vw cv cA cin cB cin vw cv cB cin wceq vw cv
      cJ wcel vy cv vw cv cA cin wceq cJ ctop wcel cA cX wss cB cA wss w3a vw
      cv cA cB cin cin vw cv cB cin vw cv cA cin cB cin cJ ctop wcel cA cX wss
      cB cA wss w3a cA cB cin cB vw cv cB cA wss cJ ctop wcel cA cB cin cB wceq
      cA cX wss cB cA wss cA cB cin cB wceq cB cA sseqin2 biimpi 3ad2ant3
      ineq2d vw cv cA cB inass syl5eq ad2antrr eqtrd eqeq2d biimpa sylanc exp31
      r19.23adva sylbid r19.23adv cJ ctop wcel cA cX wss cB cA wss w3a vx cv vz
      cv cB cin wceq vx cv vy cv cB cin wceq vy cA cJ cop csubsp cfv wrex vz cJ
      cJ ctop wcel cA cX wss cB cA wss w3a vz cv cJ wcel wa vx cv vz cv cB cin
      wceq vx cv vy cv cB cin wceq vy cA cJ cop csubsp cfv wrex vz cv cA cin cA
      cJ cop csubsp cfv wcel vx cv vz cv cA cin cB cin wceq vx cv vy cv cB cin
      wceq vy cA cJ cop csubsp cfv wrex cJ ctop wcel cA cX wss cB cA wss w3a vz
      cv cJ wcel wa vx cv vz cv cB cin wceq wa vx cv vy cv cB cin wceq vx cv vz
      cv cA cin cB cin wceq vy vz cv cA cin cA cJ cop csubsp cfv vy cv vz cv cA
      cin wceq vy cv cB cin vz cv cA cin cB cin vx cv vy cv vz cv cA cin cB
      ineq1 eqeq2d rcla4ev cJ ctop wcel cA cX wss cB cA wss w3a vz cv cJ wcel
      wa vz cv cA cin cA cJ cop csubsp cfv wcel vx cv vz cv cB cin wceq cJ ctop
      wcel cA cX wss vz cv cJ wcel vz cv cA cin cA cJ cop csubsp cfv wcel cB cA
      wss cJ ctop wcel cA cX wss wa vz cv cJ wcel wa vz cv cA cin cA cJ cop
      csubsp cfv wcel vz cv cA cin vy cv cA cin wceq vy cJ wrex vz cv cJ wcel
      vz cv cA cin vy cv cA cin wceq vy cJ wrex cJ ctop wcel cA cX wss wa vz cv
      cJ wcel vz cv cA cin vz cv cA cin wceq vz cv cA cin vy cv cA cin wceq vy
      cJ wrex vz cv cA cin eqid vz cv cA cin vy cv cA cin wceq vz cv cA cin vz
      cv cA cin wceq vy vz cv cJ vy cv vz cv wceq vy cv cA cin vz cv cA cin vz
      cv cA cin vy cv vz cv cA ineq1 eqeq2d rcla4ev mpan2 adantl cJ ctop wcel
      vz cv cA cin cvv wcel cA cvv wcel vz cv cA cin cA cJ cop csubsp cfv wcel
      vz cv cA cin vy cv cA cin wceq vy cJ wrex wb cJ ctop wcel cA cX wss wa vz
      cv cJ wcel wa vy vz cv cA cin cA cvv cJ issubspt cJ ctop wcel cA cX wss
      vz cv cJ wcel simpll vz cv cA cin cvv wcel cJ ctop wcel cA cX wss wa vz
      cv cJ wcel wa vz cv cA vz visset inex1 a1i cJ ctop wcel cA cX wss wa cA
      cvv wcel vz cv cJ wcel cA cX wss cJ ctop wcel cA cvv wcel cA cX wss cX
      cvv wcel cA cvv wcel cJ ctop wcel cA cX cvv ssexg cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg subspabs.1 syl5eqel sylan2 ancoms adantr syl3anc
      mpbird 3adantl3 adantr cJ ctop wcel cA cX wss cB cA wss w3a vz cv cJ wcel
      wa vx cv vz cv cB cin wceq vx cv vz cv cA cin cB cin wceq cJ ctop wcel cA
      cX wss cB cA wss w3a vz cv cJ wcel wa vz cv cB cin vz cv cA cin cB cin vx
      cv cJ ctop wcel cA cX wss cB cA wss w3a vz cv cJ wcel wa vz cv cB cin vz
      cv cA cB cin cin vz cv cA cin cB cin cJ ctop wcel cA cX wss cB cA wss w3a
      vz cv cJ wcel wa cB cA cB cin vz cv cJ ctop wcel cA cX wss cB cA wss w3a
      cB cA cB cin wceq vz cv cJ wcel cB cA wss cJ ctop wcel cB cA cB cin wceq
      cA cX wss cB cA wss cA cB cin cB cB cA wss cA cB cin cB wceq cB cA
      sseqin2 biimpi eqcomd 3ad2ant3 adantr ineq2d vz cv cA cB inass syl6eqr
      eqeq2d biimpa sylanc ex r19.23adva impbid cA cJ cop csubsp cfv ctop wcel
      vx cv cvv wcel cB cvv wcel vx cv cB cA cJ cop csubsp cfv cop csubsp cfv
      wcel vx cv vy cv cB cin wceq vy cA cJ cop csubsp cfv wrex wb cJ ctop wcel
      cA cX wss cB cA wss w3a vy vx cv cB cvv cA cJ cop csubsp cfv issubspt cJ
      ctop wcel cA cX wss cA cJ cop csubsp cfv ctop wcel cB cA wss cJ ctop wcel
      cA cJ cuni wss cA cJ cop csubsp cfv ctop wcel cA cX wss cA cJ stoig3 cX
      cJ cuni cA subspabs.1 sseq2i sylan2b 3adant3 vx cv cvv wcel cJ ctop wcel
      cA cX wss cB cA wss w3a vx visset a1i cJ ctop wcel cA cX wss cB cA wss cB
      cvv wcel cJ ctop wcel cB cX wss cB cvv wcel cA cX wss cB cA wss wa cB cX
      wss cJ ctop wcel cB cvv wcel cB cX wss cX cvv wcel cB cvv wcel cJ ctop
      wcel cB cX cvv ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      subspabs.1 syl5eqel sylan2 ancoms cB cA wss cA cX wss cB cX wss cB cA cX
      sstr ancoms sylan2 3impb syl3anc cJ ctop wcel vx cv cvv wcel cB cvv wcel
      vx cv cB cJ cop csubsp cfv wcel vx cv vz cv cB cin wceq vz cJ wrex wb cJ
      ctop wcel cA cX wss cB cA wss w3a vz vx cv cB cvv cJ issubspt cJ ctop
      wcel cA cX wss cB cA wss 3simp1 vx cv cvv wcel cJ ctop wcel cA cX wss cB
      cA wss w3a vx visset a1i cJ ctop wcel cA cX wss cB cA wss cB cvv wcel cJ
      ctop wcel cB cX wss cB cvv wcel cA cX wss cB cA wss wa cB cX wss cJ ctop
      wcel cB cvv wcel cB cX wss cX cvv wcel cB cvv wcel cJ ctop wcel cB cX cvv
      ssexg cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg subspabs.1 syl5eqel
      sylan2 ancoms cB cA wss cA cX wss cB cX wss cB cA cX sstr ancoms sylan2
      3impb syl3anc 3bitr4d eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J x y z $. $d X x y z $. $d N x y z $. $d S x y z $.
    neificl.1 $e |- X = U. J $.
    $( Neighborhoods are closed under finite intersection. $)
    neificl $p |- ( ( ( J e. Top /\ N C_ ( ( nei ` J ) ` S ) ) /\
              ( N e. Fin /\ N =/= (/) ) ) -> |^| N e. ( ( nei ` J ) ` S ) ) $=
      cJ ctop wcel cN cS cJ cnei cfv cfv wss cN cfn wcel cN c0 wne wa cN cint
      cS cJ cnei cfv cfv wcel cJ ctop wcel cN cint cS cJ cnei cfv cfv cfi cfv
      wcel cN cint cS cJ cnei cfv cfv wcel cN cS cJ cnei cfv cfv wss cN cfn
      wcel cN c0 wne wa wa cJ ctop wcel cN cint cS cJ cnei cfv cfv cfi cfv wcel
      cN cint cS cJ cnei cfv cfv wcel cJ ctop wcel cS cJ cnei cfv cfv cfi cfv
      cS cJ cnei cfv cfv cN cint cS cJ cnei cfv cfv cvv wcel vx cv vy cv cin cS
      cJ cnei cfv cfv wcel vy cS cJ cnei cfv cfv wral vx cS cJ cnei cfv cfv
      wral cS cJ cnei cfv cfv cfi cfv cS cJ cnei cfv cfv wceq cJ ctop wcel vx
      vy cS cJ cnei cfv cfv cvv inficl cS cJ cnei cfv fvex cJ ctop wcel vx cv
      vy cv cin cS cJ cnei cfv cfv wcel vx vy cS cJ cnei cfv cfv cS cJ cnei cfv
      cfv cJ ctop wcel vx cv cS cJ cnei cfv cfv wcel vy cv cS cJ cnei cfv cfv
      wcel vx cv vy cv cin cS cJ cnei cfv cfv wcel cS cJ vy cv vx cv innei
      3expib r19.21aivv sylancr eleq2d biimpa cN cS cJ cnei cfv cfv wss cN cfn
      wcel cN c0 wne wa wa cN cint cS cJ cnei cfv cfv cfi cfv wcel vz cv cS cJ
      cnei cfv cfv wss vz cv cfn wcel cN cint vz cv cint wceq w3a vz wex cN cS
      cJ cnei cfv cfv wss cN cfn wcel vz cv cS cJ cnei cfv cfv wss vz cv cfn
      wcel cN cint vz cv cint wceq w3a vz wex cN c0 wne cN cS cJ cnei cfv cfv
      wss cN cfn wcel cN cint cN cint wceq vz cv cS cJ cnei cfv cfv wss vz cv
      cfn wcel cN cint vz cv cint wceq w3a vz wex cN cint eqid cN cS cJ cnei
      cfv cfv wss cN cfn wcel cN cint cN cint wceq w3a vz cv cS cJ cnei cfv cfv
      wss vz cv cfn wcel cN cint vz cv cint wceq w3a vz wex cN cfn wcel cN cS
      cJ cnei cfv cfv wss cN cS cJ cnei cfv cfv wss cN cfn wcel cN cint cN cint
      wceq w3a vz cv cS cJ cnei cfv cfv wss vz cv cfn wcel cN cint vz cv cint
      wceq w3a vz wex wi cN cint cN cint wceq vz cv cS cJ cnei cfv cfv wss vz
      cv cfn wcel cN cint vz cv cint wceq w3a cN cS cJ cnei cfv cfv wss cN cfn
      wcel cN cint cN cint wceq w3a vz cN cfn vz cv cN wceq vz cv cS cJ cnei
      cfv cfv wss cN cS cJ cnei cfv cfv wss vz cv cfn wcel cN cfn wcel cN cint
      vz cv cint wceq cN cint cN cint wceq vz cv cN cS cJ cnei cfv cfv sseq1 vz
      cv cN cfn eleq1 vz cv cN wceq vz cv cint cN cint cN cint vz cv cN inteq
      eqeq2d 3anbi123d cla4egv 3ad2ant2 pm2.43i mp3an3 adantrr cN c0 wne cN
      cint cS cJ cnei cfv cfv cfi cfv wcel vz cv cS cJ cnei cfv cfv wss vz cv
      cfn wcel cN cint vz cv cint wceq w3a vz wex wb cN cS cJ cnei cfv cfv wss
      cN cfn wcel cN c0 wne cN cint cvv wcel cN cint cS cJ cnei cfv cfv cfi cfv
      wcel vz cv cS cJ cnei cfv cfv wss vz cv cfn wcel cN cint vz cv cint wceq
      w3a vz wex wb cN intex cN cint cvv wcel cS cJ cnei cfv cfv cvv wcel cN
      cint cS cJ cnei cfv cfv cfi cfv wcel vz cv cS cJ cnei cfv cfv wss vz cv
      cfn wcel cN cint vz cv cint wceq w3a vz wex wb cS cJ cnei cfv fvex vz cN
      cint cvv cS cJ cnei cfv cfv cvv sppfi mpan2 sylbi ad2antll mpbird sylan2
      anassrs $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J x $. $d X x $. $d A x $. $d B x $.
    lpss2.1 $e |- X = U. J $.
    $( Limit points of a subset are limit points of the larger set. $)
    lpss2 $p |- ( ( J e. Top /\ A C_ X /\ B C_ A ) ->
                          ( ( limPt ` J ) ` B ) C_ ( ( limPt ` J ) ` A ) ) $=
      cJ ctop wcel cA cX wss cB cA wss w3a vx cB cJ clp cfv cfv cA cJ clp cfv
      cfv cJ ctop wcel cA cX wss cB cA wss w3a vx cv cB vx cv csn cdif cJ ccl
      cfv cfv wcel vx cv cA vx cv csn cdif cJ ccl cfv cfv wcel vx cv cB cJ clp
      cfv cfv wcel vx cv cA cJ clp cfv cfv wcel cJ ctop wcel cA cX wss cB cA
      wss w3a cB vx cv csn cdif cJ ccl cfv cfv cA vx cv csn cdif cJ ccl cfv cfv
      vx cv cJ ctop wcel cA vx cv csn cdif cX wss cB vx cv csn cdif cA vx cv
      csn cdif wss cB vx cv csn cdif cJ ccl cfv cfv cA vx cv csn cdif cJ ccl
      cfv cfv wss cJ ctop wcel cA cX wss cB cA wss cA vx cv csn cdif cB vx cv
      csn cdif cJ cX lpss2.1 clsss cJ ctop wcel id cA cX vx cv csn ssdifss cB
      cA vx cv csn ssdif syl3an sseld cJ ctop wcel cA cX wss cB cA wss vx cv cB
      cJ clp cfv cfv wcel vx cv cB vx cv csn cdif cJ ccl cfv cfv wcel wb cJ
      ctop wcel cB cX wss vx cv cB cJ clp cfv cfv wcel vx cv cB vx cv csn cdif
      cJ ccl cfv cfv wcel wb cA cX wss cB cA wss wa vx cv cB cJ cX lpss2.1 islp
      cB cA wss cA cX wss cB cX wss cB cA cX sstr ancoms sylan2 3impb cJ ctop
      wcel cA cX wss vx cv cA cJ clp cfv cfv wcel vx cv cA vx cv csn cdif cJ
      ccl cfv cfv wcel wb cB cA wss vx cv cA cJ cX lpss2.1 islp 3adant3 3imtr4d
      ssrdv $.
      $( [2-Sep-2009] $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d M u v w x y z $. $d X u v w x y z $. $d Y u v w x y z $.
    $d F u v w x y z $. $d A u v w x y z $. $d N u v w $.
    metf1o.1 $e |- X = dom dom M $.
    metf1o.2 $e |- N = { <. <. x , y >. , z >. | ( ( x e. Y /\ y e. Y )
                                      /\ z = ( ( F ` x ) M ( F ` y ) ) ) } $.
    $( Use a bijection with a metric space to construct a metric on a set. $)
    metf1o $p |- ( ( Y e. A /\ M e. Met /\ F : Y -1-1-onto-> X )
               -> N e. Met ) $=
      cY cA wcel cM cme wcel cY cX cF wf1o w3a cN cme wcel cY cY cxp cr cN wf
      vu cv vv cv cN co cc0 wceq vu cv vv cv wceq wb vu cv vv cv cN co vw cv vu
      cv cN co vw cv vv cv cN co caddc co cle wbr vw cY wral wa vv cY wral vu
      cY wral wa cY cA wcel cM cme wcel cY cX cF wf1o w3a cY cY cxp cr cN wf vu
      cv vv cv cN co cc0 wceq vu cv vv cv wceq wb vu cv vv cv cN co vw cv vu cv
      cN co vw cv vv cv cN co caddc co cle wbr vw cY wral wa vv cY wral vu cY
      wral cY cA wcel cM cme wcel cY cX cF wf1o w3a vx cv cF cfv vy cv cF cfv
      cM co cr wcel vy cY wral vx cY wral cY cY cxp cr cN wf cY cA wcel cM cme
      wcel cY cX cF wf1o w3a vx cv cF cfv vy cv cF cfv cM co cr wcel vx vy cY
      cY cM cme wcel cY cX cF wf1o vx cv cY wcel vy cv cY wcel wa vx cv cF cfv
      vy cv cF cfv cM co cr wcel wi cY cA wcel cY cX cF wf1o vx cv cY wcel vy
      cv cY wcel wa vx cv cF cfv cX wcel vy cv cF cfv cX wcel wa cM cme wcel vx
      cv cF cfv vy cv cF cfv cM co cr wcel cY cX cF wf1o cY cX cF wf vx cv cY
      wcel vy cv cY wcel wa vx cv cF cfv cX wcel vy cv cF cfv cX wcel wa wi cY
      cX cF f1of cY cX cF wf vx cv cY wcel vx cv cF cfv cX wcel vy cv cY wcel
      vy cv cF cfv cX wcel cY cX cF wf vx cv cY wcel vx cv cF cfv cX wcel cY cX
      vx cv cF ffvelrn ex cY cX cF wf vy cv cY wcel vy cv cF cfv cX wcel cY cX
      vy cv cF ffvelrn ex anim12d syl cM cme wcel vx cv cF cfv cX wcel vy cv cF
      cfv cX wcel vx cv cF cfv vy cv cF cfv cM co cr wcel vx cv cF cfv vy cv cF
      cfv cM cX metf1o.1 metcl 3expib sylan9r 3adant1 r19.21aivv vx vy vz cY cY
      vx cv cF cfv vy cv cF cfv cM co cr cN metf1o.2 foprab2 sylib cY cA wcel
      cM cme wcel cY cX cF wf1o w3a vu cv vv cv cN co cc0 wceq vu cv vv cv wceq
      wb vu cv vv cv cN co vw cv vu cv cN co vw cv vv cv cN co caddc co cle wbr
      vw cY wral wa vu vv cY cY cY cA wcel cM cme wcel cY cX cF wf1o w3a vu cv
      cY wcel vv cv cY wcel wa vu cv vv cv cN co cc0 wceq vu cv vv cv wceq wb
      vu cv vv cv cN co vw cv vu cv cN co vw cv vv cv cN co caddc co cle wbr vw
      cY wral wa cM cme wcel cY cX cF wf1o vu cv cY wcel vv cv cY wcel wa vu cv
      vv cv cN co cc0 wceq vu cv vv cv wceq wb vu cv vv cv cN co vw cv vu cv cN
      co vw cv vv cv cN co caddc co cle wbr vw cY wral wa cY cA wcel cM cme
      wcel cY cX cF wf1o wa vu cv cY wcel vv cv cY wcel wa wa vu cv vv cv cN co
      cc0 wceq vu cv vv cv wceq wb vu cv vv cv cN co vw cv vu cv cN co vw cv vv
      cv cN co caddc co cle wbr vw cY wral cM cme wcel cY cX cF wf1o wa vu cv
      cY wcel vv cv cY wcel wa wa vu cv vv cv cN co cc0 wceq vu cv cF cfv vv cv
      cF cfv cM co cc0 wceq vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq vu
      cv cY wcel vv cv cY wcel wa vu cv vv cv cN co cc0 wceq vu cv cF cfv vv cv
      cF cfv cM co cc0 wceq wb cM cme wcel cY cX cF wf1o wa vu cv cY wcel vv cv
      cY wcel wa vu cv vv cv cN co vu cv cF cfv vv cv cF cfv cM co cc0 vx vy vz
      vu cv vv cv cY cY vx cv cF cfv vy cv cF cfv cM co vu cv cF cfv vv cv cF
      cfv cM co cN vu cv cF cfv vy cv cF cfv cM co vu cv cF cfv vv cv cF cfv cM
      oprex vx cv vu cv wceq vx cv cF cfv vu cv cF cfv vy cv cF cfv cM vx cv vu
      cv cF fveq2 opreq1d vy cv vv cv wceq vy cv cF cfv vv cv cF cfv vu cv cF
      cfv cM vy cv vv cv cF fveq2 opreq2d metf1o.2 oprabval2 eqeq1d adantl cM
      cme wcel cY cX cF wf1o wa vu cv cY wcel vv cv cY wcel wa vu cv cF cfv cX
      wcel vv cv cF cfv cX wcel wa vu cv cF cfv vv cv cF cfv cM co cc0 wceq vu
      cv cF cfv vv cv cF cfv wceq wb cY cX cF wf1o vu cv cY wcel vv cv cY wcel
      wa vu cv cF cfv cX wcel vv cv cF cfv cX wcel wa cM cme wcel cY cX cF wf1o
      vu cv cY wcel vv cv cY wcel wa vu cv cF cfv cX wcel vv cv cF cfv cX wcel
      wa cY cX cF wf1o cY cX cF wf vu cv cY wcel vv cv cY wcel wa vu cv cF cfv
      cX wcel vv cv cF cfv cX wcel wa wi cY cX cF f1of cY cX cF wf vu cv cY
      wcel vu cv cF cfv cX wcel vv cv cY wcel vv cv cF cfv cX wcel cY cX cF wf
      vu cv cY wcel vu cv cF cfv cX wcel cY cX vu cv cF ffvelrn ex cY cX cF wf
      vv cv cY wcel vv cv cF cfv cX wcel cY cX vv cv cF ffvelrn ex anim12d syl
      imp adantll cM cme wcel vu cv cF cfv cX wcel vv cv cF cfv cX wcel wa vu
      cv cF cfv vv cv cF cfv cM co cc0 wceq vu cv cF cfv vv cv cF cfv wceq wb
      cY cX cF wf1o cM cme wcel vu cv cF cfv cX wcel vv cv cF cfv cX wcel vu cv
      cF cfv vv cv cF cfv cM co cc0 wceq vu cv cF cfv vv cv cF cfv wceq wb vu
      cv cF cfv vv cv cF cfv cM cX metf1o.1 meteq0 3expb adantlr syldan cY cX
      cF wf1o vu cv cY wcel vv cv cY wcel wa vu cv cF cfv vv cv cF cfv wceq vu
      cv vv cv wceq wb cM cme wcel cY cX cF wf1 vu cv cY wcel vv cv cY wcel wa
      vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq wb cY cX cF wf1o cY cX vu
      cv vv cv cF f1fveq cY cX cF f1of1 sylan adantll 3bitrd cM cme wcel cY cX
      cF wf1o wa vu cv cY wcel vv cv cY wcel wa wa vu cv vv cv cN co vw cv vu
      cv cN co vw cv vv cv cN co caddc co cle wbr vw cY cM cme wcel cY cX cF
      wf1o wa vu cv cY wcel vv cv cY wcel wa wa vw cv cY wcel wa vu cv vv cv cN
      co vw cv vu cv cN co vw cv vv cv cN co caddc co cle wbr vu cv cF cfv vv
      cv cF cfv cM co vw cv cF cfv vu cv cF cfv cM co vw cv cF cfv vv cv cF cfv
      cM co caddc co cle wbr cM cme wcel cY cX cF wf1o wa vu cv cY wcel vv cv
      cY wcel wa vw cv cY wcel vu cv cF cfv vv cv cF cfv cM co vw cv cF cfv vu
      cv cF cfv cM co vw cv cF cfv vv cv cF cfv cM co caddc co cle wbr cM cme
      wcel cY cX cF wf1o wa vu cv cY wcel vv cv cY wcel wa vw cv cY wcel wa vu
      cv cF cfv cX wcel vv cv cF cfv cX wcel wa vw cv cF cfv cX wcel wa vu cv
      cF cfv vv cv cF cfv cM co vw cv cF cfv vu cv cF cfv cM co vw cv cF cfv vv
      cv cF cfv cM co caddc co cle wbr cY cX cF wf1o vu cv cY wcel vv cv cY
      wcel wa vw cv cY wcel wa vu cv cF cfv cX wcel vv cv cF cfv cX wcel wa vw
      cv cF cfv cX wcel wa cM cme wcel cY cX cF wf1o vu cv cY wcel vv cv cY
      wcel wa vw cv cY wcel wa vu cv cF cfv cX wcel vv cv cF cfv cX wcel wa vw
      cv cF cfv cX wcel wa cY cX cF wf1o cY cX cF wf vu cv cY wcel vv cv cY
      wcel wa vw cv cY wcel wa vu cv cF cfv cX wcel vv cv cF cfv cX wcel wa vw
      cv cF cfv cX wcel wa wi cY cX cF f1of cY cX cF wf vu cv cY wcel vv cv cY
      wcel wa vu cv cF cfv cX wcel vv cv cF cfv cX wcel wa vw cv cY wcel vw cv
      cF cfv cX wcel cY cX cF wf vu cv cY wcel vu cv cF cfv cX wcel vv cv cY
      wcel vv cv cF cfv cX wcel cY cX cF wf vu cv cY wcel vu cv cF cfv cX wcel
      cY cX vu cv cF ffvelrn ex cY cX cF wf vv cv cY wcel vv cv cF cfv cX wcel
      cY cX vv cv cF ffvelrn ex anim12d cY cX cF wf vw cv cY wcel vw cv cF cfv
      cX wcel cY cX vw cv cF ffvelrn ex anim12d syl imp adantll cM cme wcel vu
      cv cF cfv cX wcel vv cv cF cfv cX wcel wa vw cv cF cfv cX wcel wa vu cv
      cF cfv vv cv cF cfv cM co vw cv cF cfv vu cv cF cfv cM co vw cv cF cfv vv
      cv cF cfv cM co caddc co cle wbr cY cX cF wf1o vu cv cF cfv cX wcel vv cv
      cF cfv cX wcel wa vw cv cF cfv cX wcel wa cM cme wcel vu cv cF cfv vv cv
      cF cfv cM co vw cv cF cfv vu cv cF cfv cM co vw cv cF cfv vv cv cF cfv cM
      co caddc co cle wbr vw cv cF cfv cX wcel vu cv cF cfv cX wcel vv cv cF
      cfv cX wcel wa cM cme wcel vu cv cF cfv vv cv cF cfv cM co vw cv cF cfv
      vu cv cF cfv cM co vw cv cF cfv vv cv cF cfv cM co caddc co cle wbr wi vw
      cv cF cfv cX wcel vu cv cF cfv cX wcel vv cv cF cfv cX wcel cM cme wcel
      vu cv cF cfv vv cv cF cfv cM co vw cv cF cfv vu cv cF cfv cM co vw cv cF
      cfv vv cv cF cfv cM co caddc co cle wbr wi cM cme wcel vw cv cF cfv cX
      wcel vu cv cF cfv cX wcel vv cv cF cfv cX wcel w3a vu cv cF cfv vv cv cF
      cfv cM co vw cv cF cfv vu cv cF cfv cM co vw cv cF cfv vv cv cF cfv cM co
      caddc co cle wbr vu cv cF cfv vv cv cF cfv vw cv cF cfv cM cX metf1o.1
      mettri2 expcom 3expb ancoms impcom adantlr syldan anassrs vu cv cY wcel
      vv cv cY wcel wa vw cv cY wcel vu cv vv cv cN co vw cv vu cv cN co vw cv
      vv cv cN co caddc co cle wbr vu cv cF cfv vv cv cF cfv cM co vw cv cF cfv
      vu cv cF cfv cM co vw cv cF cfv vv cv cF cfv cM co caddc co cle wbr wb cM
      cme wcel cY cX cF wf1o wa vu cv cY wcel vv cv cY wcel wa vw cv cY wcel wa
      vu cv vv cv cN co vu cv cF cfv vv cv cF cfv cM co vw cv vu cv cN co vw cv
      vv cv cN co caddc co vw cv cF cfv vu cv cF cfv cM co vw cv cF cfv vv cv
      cF cfv cM co caddc co cle vu cv cY wcel vv cv cY wcel wa vu cv vv cv cN
      co vu cv cF cfv vv cv cF cfv cM co wceq vw cv cY wcel vx vy vz vu cv vv
      cv cY cY vx cv cF cfv vy cv cF cfv cM co vu cv cF cfv vv cv cF cfv cM co
      cN vu cv cF cfv vy cv cF cfv cM co vu cv cF cfv vv cv cF cfv cM oprex vx
      cv vu cv wceq vx cv cF cfv vu cv cF cfv vy cv cF cfv cM vx cv vu cv cF
      fveq2 opreq1d vy cv vv cv wceq vy cv cF cfv vv cv cF cfv vu cv cF cfv cM
      vy cv vv cv cF fveq2 opreq2d metf1o.2 oprabval2 adantr vu cv cY wcel vv
      cv cY wcel wa vw cv cY wcel wa vw cv vu cv cN co vw cv cF cfv vu cv cF
      cfv cM co vw cv vv cv cN co vw cv cF cfv vv cv cF cfv cM co caddc vu cv
      cY wcel vw cv cY wcel vw cv vu cv cN co vw cv cF cfv vu cv cF cfv cM co
      wceq vv cv cY wcel vw cv cY wcel vu cv cY wcel vw cv vu cv cN co vw cv cF
      cfv vu cv cF cfv cM co wceq vx vy vz vw cv vu cv cY cY vx cv cF cfv vy cv
      cF cfv cM co vw cv cF cfv vu cv cF cfv cM co cN vw cv cF cfv vy cv cF cfv
      cM co vw cv cF cfv vu cv cF cfv cM oprex vx cv vw cv wceq vx cv cF cfv vw
      cv cF cfv vy cv cF cfv cM vx cv vw cv cF fveq2 opreq1d vy cv vu cv wceq
      vy cv cF cfv vu cv cF cfv vw cv cF cfv cM vy cv vu cv cF fveq2 opreq2d
      metf1o.2 oprabval2 ancoms adantlr vv cv cY wcel vw cv cY wcel vw cv vv cv
      cN co vw cv cF cfv vv cv cF cfv cM co wceq vu cv cY wcel vw cv cY wcel vv
      cv cY wcel vw cv vv cv cN co vw cv cF cfv vv cv cF cfv cM co wceq vx vy
      vz vw cv vv cv cY cY vx cv cF cfv vy cv cF cfv cM co vw cv cF cfv vv cv
      cF cfv cM co cN vw cv cF cfv vy cv cF cfv cM co vw cv cF cfv vv cv cF cfv
      cM oprex vx cv vw cv wceq vx cv cF cfv vw cv cF cfv vy cv cF cfv cM vx cv
      vw cv cF fveq2 opreq1d vy cv vv cv wceq vy cv cF cfv vv cv cF cfv vw cv
      cF cfv cM vy cv vv cv cF fveq2 opreq2d metf1o.2 oprabval2 ancoms adantll
      opreq12d breq12d adantll mpbird r19.21aiva jca 3adantl1 ex r19.21aivv jca
      cY cA wcel cM cme wcel cN cme wcel cY cY cxp cr cN wf vu cv vv cv cN co
      cc0 wceq vu cv vv cv wceq wb vu cv vv cv cN co vw cv vu cv cN co vw cv vv
      cv cN co caddc co cle wbr vw cY wral wa vv cY wral vu cY wral wa wb cY cX
      cF wf1o cY cA wcel cN cvv wcel cN cme wcel cY cY cxp cr cN wf vu cv vv cv
      cN co cc0 wceq vu cv vv cv wceq wb vu cv vv cv cN co vw cv vu cv cN co vw
      cv vv cv cN co caddc co cle wbr vw cY wral wa vv cY wral vu cY wral wa wb
      cY cA wcel cN cvv wcel vx vy vz cY cY vx cv cF cfv vy cv cF cfv cM co cA
      cA cN metf1o.2 oprabex2g anidms vu vv vw cvv cN cY cN cdm cdm cY cY cxp
      cdm cY cN cdm cY cY cxp vx vy vz cY cY vx cv cF cfv vy cv cF cfv cM co cN
      vx cv cF cfv vy cv cF cfv cM oprex metf1o.2 dmoprab2 dmeqi cY dmxpid
      eqtr2i ismet syl 3ad2ant1 mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M x $. $d S x $. $d R x $. $d N x $. $d X x $. $d Y x $.
    blssp.1 $e |- X = dom dom M $.
    blssp.2 $e |- N = ( M |` ( S X. S ) ) $.
    $( A ball in the subspace metric. $)
    blssp $p |- ( ( ( M e. Met /\ S C_ X ) /\ ( Y e. S /\ R e. RR+ ) ) ->
                    ( Y ( ball ` N ) R ) = ( ( Y ( ball ` M ) R ) i^i S ) ) $=
      cM cme wcel cS cX wss wa cY cS wcel cR crp wcel wa wa vx cY cR cN cbl cfv
      co cY cR cM cbl cfv co cS cin cM cme wcel cS cX wss wa cY cS wcel cR crp
      wcel wa wa vx cv cN cdm cdm wcel cY vx cv cN co cR clt wbr wa vx cv cX
      wcel cY vx cv cM co cR clt wbr wa vx cv cS wcel wa vx cv cY cR cN cbl cfv
      co wcel vx cv cY cR cM cbl cfv co cS cin wcel cM cme wcel cS cX wss wa cY
      cS wcel cR crp wcel wa wa vx cv cS wcel cY vx cv cN co cR clt wbr wa vx
      cv cS wcel cY vx cv cM co cR clt wbr wa vx cv cN cdm cdm wcel cY vx cv cN
      co cR clt wbr wa vx cv cX wcel cY vx cv cM co cR clt wbr wa vx cv cS wcel
      wa cM cme wcel cS cX wss wa cY cS wcel cR crp wcel wa wa vx cv cS wcel cY
      vx cv cN co cR clt wbr cY vx cv cM co cR clt wbr cM cme wcel cS cX wss wa
      cY cS wcel cR crp wcel wa wa vx cv cS wcel wa cY vx cv cN co cY vx cv cM
      co cR clt cM cme wcel cS cX wss wa cY cS wcel cR crp wcel wa wa vx cv cS
      wcel wa cY vx cv cM cS cS cxp cres co cY vx cv cM co cY vx cv cN co cY cS
      wcel cR crp wcel wa vx cv cS wcel cY vx cv cM cS cS cxp cres co cY vx cv
      cM co wceq cM cme wcel cS cX wss wa cY cS wcel vx cv cS wcel cY vx cv cM
      cS cS cxp cres co cY vx cv cM co wceq cR crp wcel cY vx cv cS cS cM
      oprvres adantlr adantll cN cM cS cS cxp cres cY vx cv blssp.2 opreqi
      syl5eq breq1d pm5.32da cM cme wcel cS cX wss wa cY cS wcel cR crp wcel wa
      wa vx cv cS wcel vx cv cN cdm cdm wcel cY vx cv cN co cR clt wbr cM cme
      wcel cS cX wss wa cY cS wcel cR crp wcel wa wa cS cN cdm cdm vx cv cM cme
      wcel cS cX wss wa cS cN cdm cdm wceq cY cS wcel cR crp wcel wa cM cN cX
      cS blssp.2 blssp.1 basmetres adantr eleq2d anbi1d cS cX wss vx cv cS wcel
      cY vx cv cM co cR clt wbr wa vx cv cX wcel cY vx cv cM co cR clt wbr wa
      vx cv cS wcel wa wb cM cme wcel cY cS wcel cR crp wcel wa cS cX wss vx cv
      cS wcel cY vx cv cM co cR clt wbr wa vx cv cX wcel cY vx cv cM co cR clt
      wbr wa vx cv cS wcel wa cS cX wss vx cv cS wcel cY vx cv cM co cR clt wbr
      wa vx cv cX wcel cY vx cv cM co cR clt wbr wa vx cv cS wcel cS cX wss vx
      cv cS wcel vx cv cX wcel cY vx cv cM co cR clt wbr cS cX vx cv ssel
      anim1d vx cv cS wcel cY vx cv cM co cR clt wbr wa vx cv cS wcel wi cS cX
      wss vx cv cS wcel cY vx cv cM co cR clt wbr pm3.26 a1i jcad vx cv cX wcel
      cY vx cv cM co cR clt wbr wa vx cv cS wcel wa vx cv cS wcel cY vx cv cM
      co cR clt wbr vx cv cX wcel cY vx cv cM co cR clt wbr wa vx cv cS wcel
      pm3.27 vx cv cX wcel cY vx cv cM co cR clt wbr vx cv cS wcel simplr jca
      impbid1 ad2antlr 3bitr3d cN cme wcel cY cN cdm cdm wcel cR cr wcel cc0 cR
      clt wbr vx cv cY cR cN cbl cfv co wcel vx cv cN cdm cdm wcel cY vx cv cN
      co cR clt wbr wa wb cM cme wcel cS cX wss wa cY cS wcel cR crp wcel wa wa
      vx cv cN cY cR cN cdm cdm cN cdm cdm eqid elbl cM cme wcel cN cme wcel cS
      cX wss cY cS wcel cR crp wcel wa cM cme wcel cM cS cS cxp cres cme cN cM
      cS metres blssp.2 syl5eqel ad2antrr cM cme wcel cS cX wss wa cY cS wcel
      cY cN cdm cdm wcel cR crp wcel cM cme wcel cS cX wss wa cY cS wcel cY cN
      cdm cdm wcel cM cme wcel cS cX wss wa cS cN cdm cdm cY cM cN cX cS
      blssp.2 blssp.1 basmetres eleq2d biimpa adantrr cR crp wcel cR cr wcel cM
      cme wcel cS cX wss wa cY cS wcel cR rpre ad2antll cR crp wcel cc0 cR clt
      wbr cM cme wcel cS cX wss wa cY cS wcel cR rpgt0 ad2antll syl2anc cM cme
      wcel cS cX wss wa cY cS wcel cR crp wcel wa wa vx cv cY cR cM cbl cfv co
      wcel vx cv cS wcel wa vx cv cX wcel cY vx cv cM co cR clt wbr wa vx cv cS
      wcel wa vx cv cY cR cM cbl cfv co cS cin wcel cM cme wcel cS cX wss wa cY
      cS wcel cR crp wcel wa wa vx cv cY cR cM cbl cfv co wcel vx cv cX wcel cY
      vx cv cM co cR clt wbr wa vx cv cS wcel cM cme wcel cY cX wcel cR cr wcel
      cc0 cR clt wbr vx cv cY cR cM cbl cfv co wcel vx cv cX wcel cY vx cv cM
      co cR clt wbr wa wb cM cme wcel cS cX wss wa cY cS wcel cR crp wcel wa wa
      vx cv cM cY cR cX blssp.1 elbl cM cme wcel cS cX wss cY cS wcel cR crp
      wcel wa simpll cS cX wss cY cS wcel cY cX wcel cM cme wcel cR crp wcel cS
      cX cY ssel2 ad2ant2lr cR crp wcel cR cr wcel cM cme wcel cS cX wss wa cY
      cS wcel cR rpre ad2antll cR crp wcel cc0 cR clt wbr cM cme wcel cS cX wss
      wa cY cS wcel cR rpgt0 ad2antll syl2anc anbi1d vx cv cY cR cM cbl cfv co
      cS elin syl5bb 3bitr4d eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M r s t u v w x y z $. $d X r s t u v w x y z $.
    $d J r s t u v w x y z $. $d Y r s t u v w x y z $.
    metsstop.1 $e |- X = dom dom M $.
    metsstop.2 $e |- J = ( Open ` M ) $.
    $( The topology on a subset of a metric space is the subspace topology. $)
    metsstop $p |- ( ( M e. Met /\ Y C_ X ) ->
                  ( Open ` ( M |` ( Y X. Y ) ) ) = ( subSp ` <. Y , J >. ) ) $=
      cM cme wcel cY cX wss wa vx cM cY cY cxp cres copn cfv cY cJ cop csubsp
      cfv cM cme wcel cY cX wss wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv
      cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa vw cv cX
      wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex
      vu vw cv wral wa vx cv vw cv cY cin wceq wa vw wex vx cv cM cY cY cxp
      cres copn cfv wcel vx cv cY cJ cop csubsp cfv wcel cM cme wcel cY cX wss
      wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv
      wss wa vz cr wrex vy vx cv wral wa vw cv cX wss cc0 vv cv clt wbr vu cv
      vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv wral wa vx cv vw cv
      cY cin wceq wa vw wex cM cme wcel cY cX wss wa vx cv cY wss cc0 vz cv clt
      wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv
      wral wa vw cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv
      wss wa vv cr wrex vu vw cv wral wa vx cv vw cv cY cin wceq wa vw wex vt
      cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cX wss cc0 vv cv clt wbr
      vu cv vv cv cM cbl cfv co vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv
      vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni
      wss wa vv cr wrex vu vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv
      vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wral
      wa vx cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cY cin wceq vw
      cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr
      wrex vu vw cv wral wa vx cv vw cv cY cin wceq wa vw wex cM cme wcel cY cX
      wss wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx
      cv wss wa vz cr wrex vy vx cv wral wa wa vw cv cX wss cc0 vv cv clt wbr
      vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv wral wa vx cv
      vw cv cY cin wceq wa vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv
      vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cX
      wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cuni wss wa vv cr wrex vu vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni wral wa vx cv vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab cuni cY cin wceq wa vw vt cv cY cin vx cv wss cc0 vs cv clt wbr vt
      cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab
      cuni vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex vt cab cc0 vs cv clt wbr vt cv vr cv vs
      cv cM cbl cfv co wceq wa vs cr wrex vr vt vx cv vx visset cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs vt cr reex cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vt cab vt cv vr cv vs cv cM
      cbl cfv co wceq vt cab vr cv vs cv cM cbl cfv co csn vt cv vr cv vs cv cM
      cbl cfv co wceq vt cab cvv vt vr cv vs cv cM cbl cfv co df-sn vr cv vs cv
      cM cbl cfv co snex eqeltrri cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vt cv vr cv vs cv cM cbl cfv co wceq vt cc0 vs cv clt wbr
      vt cv vr cv vs cv cM cbl cfv co wceq pm3.27 ss2abi ssexi abrexex2
      abrexex2 vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa cc0 vs cv clt wbr vt cv vr
      cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex vt vt cv cY cin
      vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex pm3.27 ss2abi ssexi uniex vw cv vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cuni wceq vw cv cX wss cc0 vv cv clt wbr vu cv vv cv
      cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv wral wa vt cv cY cin vx cv
      wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex
      vr vx cv wrex wa vt cab cuni cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl
      cfv co vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wss wa vv cr wrex
      vu vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv
      co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wral wa vx cv vw cv cY
      cin wceq vx cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv
      cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cY cin wceq
      vw cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wceq vw cv cX wss
      vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cX wss cc0 vv cv clt wbr
      vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv wral cc0 vv cv
      clt wbr vu cv vv cv cM cbl cfv co vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab cuni wss wa vv cr wrex vu vt cv cY cin vx cv wss cc0 vs cv clt wbr
      vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt
      cab cuni wral vw cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv
      vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cX
      sseq1 cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex
      cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vt cv cY cin vx cv wss cc0 vs
      cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni wss wa vv cr wrex vu vw cv vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni vw cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv
      vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni
      wceq cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa cc0 vv cv
      clt wbr vu cv vv cv cM cbl cfv co vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab cuni wss wa vv cr vw cv vt cv cY cin vx cv wss cc0 vs cv clt wbr
      vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt
      cab cuni wceq vu cv vv cv cM cbl cfv co vw cv wss vu cv vv cv cM cbl cfv
      co vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv
      co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wss cc0 vv cv clt wbr
      vw cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni vu cv vv cv cM cbl
      cfv co sseq2 anbi2d rexbidv raleqd anbi12d vw cv vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cuni wceq vw cv cY cin vt cv cY cin vx cv wss cc0 vs
      cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni cY cin vx cv vw cv vt cv cY cin vx cv wss cc0 vs cv
      clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex
      wa vt cab cuni cY ineq1 eqeq2d anbi12d cla4ev cM cme wcel cY cX wss wa vx
      cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa
      vz cr wrex vy vx cv wral wa wa vt cv cY cin vx cv wss cc0 vs cv clt wbr
      vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt
      cab cuni cM copn cfv wcel vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv
      vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni
      cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cuni wss wa vv cr wrex vu vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni wral wa cM copn cfv ctop wcel vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cM copn cfv wss vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab cuni cM copn cfv wcel cM cme wcel cY cX wss wa vx cv cY wss cc0 vz
      cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx
      cv wral wa wa vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv
      cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cM copn cfv
      uniopn cM cme wcel cM copn cfv ctop wcel cY cX wss vx cv cY wss cc0 vz cv
      clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv
      wral wa cM cM copn cfv cM copn cfv eqid opntop ad2antrr cM cme wcel cY cX
      wss wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx
      cv wss wa vz cr wrex vy vx cv wral wa wa vt cv cY cin vx cv wss cc0 vs cv
      clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex
      wa vt cM copn cfv cM cme wcel cY cX wss wa vx cv cY wss cc0 vz cv clt wbr
      vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa
      wa cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex
      vr vx cv wrex vt cv cM copn cfv wcel vt cv cY cin vx cv wss cM cme wcel
      cY cX wss wa vx cv cY wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv
      co wceq wa vs cr wrex vr vx cv wrex vt cv cM copn cfv wcel wi cc0 vz cv
      clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv
      wral cM cme wcel cY cX wss vx cv cY wss cc0 vs cv clt wbr vt cv vr cv vs
      cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex vt cv cM copn cfv wcel
      wi cM cme wcel vx cv cX wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vs cr wrex vr vx cv wrex vt cv cM copn cfv wcel wi cY cX
      wss vx cv cY wss wa cM cme wcel vx cv cX wss wa cc0 vs cv clt wbr vt cv
      vr cv vs cv cM cbl cfv co wceq wa vt cv cM copn cfv wcel vr vs vx cv cr
      cM cme wcel vx cv cX wss wa vr vx wel vs cv cr wcel cc0 vs cv clt wbr vt
      cv vr cv vs cv cM cbl cfv co wceq wa vt cv cM copn cfv wcel wi cM cme
      wcel vx cv cX wss vr vx wel vs cv cr wcel cc0 vs cv clt wbr vt cv vr cv
      vs cv cM cbl cfv co wceq wa vt cv cM copn cfv wcel wi wi cM cme wcel vr
      cv cX wcel vs cv cr wcel cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv
      co wceq wa vt cv cM copn cfv wcel wi wi vx cv cX wss vr vx wel wa cM cme
      wcel vr cv cX wcel wa vs cv cr wcel cc0 vs cv clt wbr vt cv vr cv vs cv
      cM cbl cfv co wceq wa vt cv cM copn cfv wcel wi cM cme wcel vr cv cX wcel
      wa vs cv cr wcel wa cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq vt cv cM copn cfv wcel cM cme wcel vr cv cX wcel wa vs cv cr wcel
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq vt cv cM copn cfv
      wcel wi vt cv vr cv vs cv cM cbl cfv co wceq vt cv cM copn cfv wcel vr cv
      vs cv cM cbl cfv co cM copn cfv wcel cM cme wcel vr cv cX wcel wa vs cv
      cr wcel cc0 vs cv clt wbr wa wa vt cv vr cv vs cv cM cbl cfv co cM copn
      cfv eleq1 cM vr cv vs cv cM copn cfv cX metsstop.1 cM copn cfv eqid blopn
      syl5cbir anassrs expimpd ex vx cv cX vr cv ssel2 sylan2 anassrs expimpd
      r19.23advv vx cv cY wss cY cX wss vx cv cX wss vx cv cY cX sstr ancoms
      sylan2 anassrs adantrr adantld abssdv sylanc cM cme wcel vt cv cY cin vx
      cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab cuni cM copn cfv wcel vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab cuni cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv
      co vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv
      co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wss wa vv cr wrex vu
      vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni wral wa wb cY cX wss vx
      cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa
      vz cr wrex vy vx cv wral wa vu vv vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab cuni cM cM copn cfv cX metsstop.1 cM copn cfv eqid isopn4 ad2antrr
      mpbid cM cme wcel cY cX wss wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv
      cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa wa vx cv vt
      cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cY cin cM cme wcel cY cX
      wss wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx
      cv wss wa vz cr wrex vy vx cv wral wa wa vx cv vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni wss vx cv cY wss wa vx cv vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni cY cin wss cM cme wcel cY cX wss wa vx cv cY wss cc0
      vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy
      vx cv wral wa wa vx cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr
      cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni
      wss vx cv cY wss cM cme wcel cY cX wss wa vx cv cY wss cc0 vz cv clt wbr
      vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa
      wa vw vx cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cuni cM cme wcel cY
      cX wss wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin
      vx cv wss wa vz cr wrex vy vx cv wral wa wa vw vx wel vw vv wel vv cv vt
      cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv wex vw cv vt cv cY
      cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa
      vs cr wrex vr vx cv wrex wa vt cab cuni wcel cM cme wcel cY cX wss wa vx
      cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa
      vz cr wrex vy vx cv wral vw vx wel vw vv wel vv cv vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab wcel wa vv wex wi cM cme wcel cY cX wss wa vx cv cY
      wss wa cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz
      cr wrex vy vx cv wral vw vx wel vw vv wel vv cv vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab wcel wa vv wex cM cme wcel cY cX wss wa vx cv cY wss
      wa cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr
      wrex vw vx wel wa vw vv wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab wcel wa vv wex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin
      vx cv wss wa vz cr wrex vy vx cv wral vw vx wel wa cM cme wcel cY cX wss
      wa vx cv cY wss wa vw vx wel cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co
      cY cin vx cv wss wa vz cr wrex vw vv wel vv cv vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab wcel wa vv wex cM cme wcel cY cX wss vx cv cY wss vw vx
      wel cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr
      wrex wa vw vv wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr
      cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel wa
      vv wex wi cM cme wcel vx cv cX wss vw vx wel cc0 vz cv clt wbr vw cv vz
      cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex wa vw vv wel vv cv vt cv
      cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq
      wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv wex wi cY cX wss vx cv
      cY wss wa cM cme wcel vx cv cX wss wa vw vx wel cc0 vz cv clt wbr vw cv
      vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vw vv wel vv cv vt cv
      cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq
      wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv wex cM cme wcel vx cv cX
      wss vw vx wel cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv
      wss wa vz cr wrex vw vv wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab wcel wa vv wex wi cM cme wcel vw cv cX wcel vw vx wel wa cc0 vz cv
      clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vw vv
      wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv wex wi
      vx cv cX wss vw vx wel wa cM cme wcel vw cv cX wcel vw vx wel cc0 vz cv
      clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vw vv
      wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv wex wi
      cM cme wcel vw cv cX wcel wa vw vx wel wa cc0 vz cv clt wbr vw cv vz cv
      cM cbl cfv co cY cin vx cv wss wa vw vv wel vv cv vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab wcel wa vv wex vz cr cM cme wcel vw cv cX wcel wa vw
      vx wel vz cv cr wcel cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY cin
      vx cv wss wa vw vv wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt
      cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab
      wcel wa vv wex wi cM cme wcel vw cv cX wcel wa vw vx wel vz cv cr wcel wa
      wa cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv wss wa vw vv
      wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv wex vw
      cv vw cv vz cv cM cbl cfv co wcel vw cv vz cv cM cbl cfv co vt cv cY cin
      vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wcel vw vv wel vv cv vt cv cY cin vx cv wss
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr
      vx cv wrex wa vt cab wcel wa vv wex cM cme wcel vw cv cX wcel wa vw vx
      wel vz cv cr wcel wa wa cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY
      cin vx cv wss wa wa vw vv wel vv cv vt cv cY cin vx cv wss cc0 vs cv clt
      wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vt cab wcel wa vw cv vw cv vz cv cM cbl cfv co wcel vw cv vz cv cM cbl
      cfv co vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl
      cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel wa vv vw cv vz cv
      cM cbl cfv co vw cv vz cv cM cbl cfv oprex vv cv vw cv vz cv cM cbl cfv
      co wceq vw vv wel vw cv vw cv vz cv cM cbl cfv co wcel vv cv vt cv cY cin
      vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wcel vw cv vz cv cM cbl cfv co vt cv cY cin
      vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wcel vv cv vw cv vz cv cM cbl cfv co vw cv
      eleq2 vv cv vw cv vz cv cM cbl cfv co vt cv cY cin vx cv wss cc0 vs cv
      clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex
      wa vt cab eleq1 anbi12d cla4ev cM cme wcel vw cv cX wcel wa vw vx wel vz
      cv cr wcel wa wa cc0 vz cv clt wbr vw cv vw cv vz cv cM cbl cfv co wcel
      vw cv vz cv cM cbl cfv co cY cin vx cv wss cM cme wcel vw cv cX wcel wa
      vz cv cr wcel cc0 vz cv clt wbr vw cv vw cv vz cv cM cbl cfv co wcel vw
      vx wel cM cme wcel vw cv cX wcel wa vz cv cr wcel cc0 vz cv clt wbr vw cv
      vw cv vz cv cM cbl cfv co wcel cM vw cv vz cv cX metsstop.1 blcntr
      anassrs adantlrl adantrr vw vx wel vz cv cr wcel wa cc0 vz cv clt wbr vw
      cv vz cv cM cbl cfv co cY cin vx cv wss wa vw cv vz cv cM cbl cfv co vt
      cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel cM cme wcel vw cv cX wcel
      wa vw cv vz cv cM cbl cfv co vt cv cY cin vx cv wss cc0 vs cv clt wbr vt
      cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab
      wcel vw cv vz cv cM cbl cfv co cY cin vx cv wss cc0 vs cv clt wbr vw cv
      vz cv cM cbl cfv co vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex vw vx wel vz cv cr wcel wa cc0 vz cv clt wbr vw cv vz cv cM cbl cfv
      co cY cin vx cv wss wa wa vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv
      vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vw cv vz cv
      cM cbl cfv co cY cin vx cv wss cc0 vs cv clt wbr vw cv vz cv cM cbl cfv
      co vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt vw cv
      vz cv cM cbl cfv co vw cv vz cv cM cbl cfv oprex vt cv vw cv vz cv cM cbl
      cfv co wceq vt cv cY cin vx cv wss vw cv vz cv cM cbl cfv co cY cin vx cv
      wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex
      vr vx cv wrex cc0 vs cv clt wbr vw cv vz cv cM cbl cfv co vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex vt cv vw cv vz cv cM cbl cfv
      co wceq vt cv cY cin vw cv vz cv cM cbl cfv co cY cin vx cv vt cv vw cv
      vz cv cM cbl cfv co cY ineq1 sseq1d vt cv vw cv vz cv cM cbl cfv co wceq
      cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa cc0 vs cv clt
      wbr vw cv vz cv cM cbl cfv co vr cv vs cv cM cbl cfv co wceq wa vr vs vx
      cv cr vt cv vw cv vz cv cM cbl cfv co wceq vt cv vr cv vs cv cM cbl cfv
      co wceq vw cv vz cv cM cbl cfv co vr cv vs cv cM cbl cfv co wceq cc0 vs
      cv clt wbr vt cv vw cv vz cv cM cbl cfv co vr cv vs cv cM cbl cfv co
      eqeq1 anbi2d 2rexbidv anbi12d elab vw vx wel vz cv cr wcel wa cc0 vz cv
      clt wbr vw cv vz cv cM cbl cfv co cY cin vx cv wss simprr vw vx wel vz cv
      cr wcel wa cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co vw cv vz cv cM cbl
      cfv co wceq cc0 vs cv clt wbr vw cv vz cv cM cbl cfv co vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex vw cv vz cv cM cbl cfv co cY
      cin vx cv wss vw vx wel vz cv cr wcel cc0 vz cv clt wbr vw cv vz cv cM
      cbl cfv co vw cv vz cv cM cbl cfv co wceq wa cc0 vs cv clt wbr vw cv vz
      cv cM cbl cfv co vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex cc0 vs cv clt wbr vw cv vz cv cM cbl cfv co vr cv vs cv cM cbl cfv
      co wceq wa cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co vw cv vz cv cM cbl
      cfv co wceq wa cc0 vs cv clt wbr vw cv vz cv cM cbl cfv co vw cv vs cv cM
      cbl cfv co wceq wa vr vs vw cv vz cv vx cv cr vr vw weq vw cv vz cv cM
      cbl cfv co vr cv vs cv cM cbl cfv co wceq vw cv vz cv cM cbl cfv co vw cv
      vs cv cM cbl cfv co wceq cc0 vs cv clt wbr vr vw weq vr cv vs cv cM cbl
      cfv co vw cv vs cv cM cbl cfv co vw cv vz cv cM cbl cfv co vr cv vw cv vs
      cv cM cbl cfv opreq1 eqeq2d anbi2d vs vz weq cc0 vs cv clt wbr cc0 vz cv
      clt wbr vw cv vz cv cM cbl cfv co vw cv vs cv cM cbl cfv co wceq vw cv vz
      cv cM cbl cfv co vw cv vz cv cM cbl cfv co wceq vs cv vz cv cc0 clt breq2
      vs vz weq vw cv vs cv cM cbl cfv co vw cv vz cv cM cbl cfv co vw cv vz cv
      cM cbl cfv co vs cv vz cv vw cv cM cbl cfv opreq2 eqeq2d anbi12d rcla42ev
      3expa vw cv vz cv cM cbl cfv co cY cin vx cv wss vw cv vz cv cM cbl cfv
      co eqidd sylanr2 sylanbrc adantll sylanc ex anassrs r19.23adva anasss vw
      vx wel vx cv cX wss vw cv cX wcel vx cv cX wss vw vx wel vw cv cX wcel vx
      cv cX vw cv ssel2 expcom imdistanri sylan2 anassrs expimpd vx cv cY wss
      cY cX wss vx cv cX wss vx cv cY cX sstr ancoms sylan2 anassrs ancomsd vw
      vx wel cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz
      cr wrex vy vx cv wral cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co cY cin
      vx cv wss wa vz cr wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY
      cin vx cv wss wa vz cr wrex cc0 vz cv clt wbr vw cv vz cv cM cbl cfv co
      cY cin vx cv wss wa vz cr wrex vy vw cv vx cv vy vw weq cc0 vz cv clt wbr
      vy cv vz cv cM cbl cfv co cY cin vx cv wss wa cc0 vz cv clt wbr vw cv vz
      cv cM cbl cfv co cY cin vx cv wss wa vz cr vy vw weq vy cv vz cv cM cbl
      cfv co cY cin vx cv wss vw cv vz cv cM cbl cfv co cY cin vx cv wss cc0 vz
      cv clt wbr vy vw weq vy cv vz cv cM cbl cfv co cY cin vw cv vz cv cM cbl
      cfv co cY cin vx cv vy vw weq vy cv vz cv cM cbl cfv co vw cv vz cv cM
      cbl cfv co cY vy cv vw cv vz cv cM cbl cfv opreq1 ineq1d sseq1d anbi2d
      rexbidv rcla4v imdistanri syl5 expdimp anasss vv vw cv vt cv cY cin vx cv
      wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex
      vr vx cv wrex wa vt cab eluni syl6ibr ssrdv cM cme wcel cY cX wss wa vx
      cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa
      vz cr wrex vy vx cv wral simprl jca vx cv vt cv cY cin vx cv wss cc0 vs
      cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni cY ssin sylib cM cme wcel cY cX wss wa vx cv cY wss
      cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr
      wrex vy vx cv wral wa wa vu cv vv cv cY cin wceq vv vt cv cY cin vx cv
      wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex
      vr vx cv wrex wa vt cab wrex vu cab cuni vx cv vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab cuni cY cin cM cme wcel cY cX wss wa vx cv cY wss cc0 vz
      cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx
      cv wral wa wa vw cv vx cv wss vw vu cv vv cv cY cin wceq vv vt cv cY cin
      vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wrex vu cab wral vu cv vv cv cY cin wceq vv
      vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab wrex vu cab cuni vx cv wss cc0
      vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy
      vx cv wral vw cv vx cv wss vw vu cv vv cv cY cin wceq vv vt cv cY cin vx
      cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wrex vu cab wral cM cme wcel cY cX wss wa vx
      cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa
      vz cr wrex vy vx cv wral vw cv vx cv wss vw vu cv vv cv cY cin wceq vv vt
      cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab wrex vu cab cc0 vz cv clt wbr
      vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral vw
      cv vv cv cY cin wceq vv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr
      cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wrex vw
      cv vx cv wss vw cv vu cv vv cv cY cin wceq vv vt cv cY cin vx cv wss cc0
      vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex wa vt cab wrex vu cab wcel cc0 vz cv clt wbr vy cv vz cv cM cbl cfv
      co cY cin vx cv wss wa vz cr wrex vy vx cv wral vw cv vv cv cY cin wceq
      vw cv vx cv wss vv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv
      vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab cc0 vz cv
      clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv
      wral vv cv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vt cab wcel vv cv cY cin
      vx cv wss vw cv vv cv cY cin wceq vw cv vx cv wss wi cc0 vz cv clt wbr vy
      cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral vv cv
      cY cin vx cv wss cc0 vs cv clt wbr vv cv vr cv vs cv cM cbl cfv co wceq
      wa vs cr wrex vr vx cv wrex wa vv cv cY cin vx cv wss vv cv vt cv cY cin
      vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wcel vv cv cY cin vx cv wss cc0 vs cv clt
      wbr vv cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa
      vv cv cY cin vx cv wss wi cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY
      cin vx cv wss wa vz cr wrex vy vx cv wral vv cv cY cin vx cv wss cc0 vs
      cv clt wbr vv cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex vr vx cv
      wrex pm3.26 a1i vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs
      cv cM cbl cfv co wceq wa vs cr wrex vr vx cv wrex wa vv cv cY cin vx cv
      wss cc0 vs cv clt wbr vv cv vr cv vs cv cM cbl cfv co wceq wa vs cr wrex
      vr vx cv wrex wa vt vv cv vv visset vt vv weq vt cv cY cin vx cv wss vv
      cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex cc0 vs cv clt wbr vv cv vr cv vs cv cM
      cbl cfv co wceq wa vs cr wrex vr vx cv wrex vt vv weq vt cv cY cin vv cv
      cY cin vx cv vt cv vv cv cY ineq1 sseq1d vt vv weq cc0 vs cv clt wbr vt
      cv vr cv vs cv cM cbl cfv co wceq wa cc0 vs cv clt wbr vv cv vr cv vs cv
      cM cbl cfv co wceq wa vr vs vx cv cr vt vv weq vt cv vr cv vs cv cM cbl
      cfv co wceq vv cv vr cv vs cv cM cbl cfv co wceq cc0 vs cv clt wbr vt cv
      vv cv vr cv vs cv cM cbl cfv co eqeq1 anbi2d 2rexbidv anbi12d elab syl5ib
      vw cv vv cv cY cin wceq vw cv vx cv wss vv cv cY cin vx cv wss vw cv vv
      cv cY cin vx cv sseq1 biimprcd syl6 r19.23adv vu cv vv cv cY cin wceq vv
      vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co
      wceq wa vs cr wrex vr vx cv wrex wa vt cab wrex vw cv vv cv cY cin wceq
      vv vt cv cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv
      co wceq wa vs cr wrex vr vx cv wrex wa vt cab wrex vu vw cv vw visset vu
      vw weq vu cv vv cv cY cin wceq vw cv vv cv cY cin wceq vv vt cv cY cin vx
      cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab vu cv vw cv vv cv cY cin eqeq1 rexbidv elab
      syl5ib r19.21aiv ad2antll vw vu cv vv cv cY cin wceq vv vt cv cY cin vx
      cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq wa vs cr
      wrex vr vx cv wrex wa vt cab wrex vu cab vx cv unissb sylibr vu vv vt cv
      cY cin vx cv wss cc0 vs cv clt wbr vt cv vr cv vs cv cM cbl cfv co wceq
      wa vs cr wrex vr vx cv wrex wa vt cab cY ntunte syl5ss eqssd sylanc ex cM
      cme wcel cY cX wss wa vw cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl
      cfv co vw cv wss wa vv cr wrex vu vw cv wral wa vx cv vw cv cY cin wceq
      wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv
      wss wa vz cr wrex vy vx cv wral wa vw cM cme wcel cY cX wss wa vw cv cX
      wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex
      vu vw cv wral wa vx cv vw cv cY cin wceq vx cv cY wss cc0 vz cv clt wbr
      vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa
      vx cv vw cv cY cin wceq vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl
      cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa vw cv cY cin cY
      wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin wss
      wa vz cr wrex vy vw cv cY cin wral wa cM cme wcel cY cX wss wa vw cv cX
      wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex
      vu vw cv wral wa wa vx cv vw cv cY cin wceq vx cv cY wss vw cv cY cin cY
      wss cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz cr
      wrex vy vx cv wral cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw
      cv cY cin wss wa vz cr wrex vy vw cv cY cin wral vx cv vw cv cY cin cY
      sseq1 cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz
      cr wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin
      wss wa vz cr wrex vy vx cv vw cv cY cin vx cv vw cv cY cin wceq cc0 vz cv
      clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa cc0 vz cv clt wbr
      vy cv vz cv cM cbl cfv co cY cin vw cv cY cin wss wa vz cr vx cv vw cv cY
      cin wceq vy cv vz cv cM cbl cfv co cY cin vx cv wss vy cv vz cv cM cbl
      cfv co cY cin vw cv cY cin wss cc0 vz cv clt wbr vx cv vw cv cY cin vy cv
      vz cv cM cbl cfv co cY cin sseq2 anbi2d rexbidv raleqd anbi12d cM cme
      wcel cY cX wss wa vw cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv
      co vw cv wss wa vv cr wrex vu vw cv wral wa wa cc0 vz cv clt wbr vy cv vz
      cv cM cbl cfv co cY cin vw cv cY cin wss wa vz cr wrex vy vw cv cY cin
      wral vw cv cY cin cY wss cM cme wcel cY cX wss wa vw cv cX wss cc0 vv cv
      clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv wral
      cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin wss wa vz
      cr wrex vy vw cv cY cin wral cM cme wcel cY cX wss wa vw cv cX wss wa cc0
      vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv
      wral wa cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin
      wss wa vz cr wrex vy vw cv cY cin cM cme wcel cY cX wss wa vw cv cX wss
      wa cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu
      vw cv wral vy cv vw cv cY cin wcel cc0 vz cv clt wbr vy cv vz cv cM cbl
      cfv co cY cin vw cv cY cin wss wa vz cr wrex cM cme wcel cY cX wss wa vw
      cv cX wss wa cc0 vv cv clt wbr vy cv vv cv cM cbl cfv co vw cv wss wa vv
      cr wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin
      wss wa vz cr wrex cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss
      wa vv cr wrex vu vw cv wral vy cv vw cv cY cin wcel wa cM cme wcel cY cX
      wss wa vw cv cX wss wa cc0 vv cv clt wbr vy cv vv cv cM cbl cfv co vw cv
      wss wa vv cr wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vw
      cv cY cin wss wa vz cr wrex cM cme wcel cY cX wss wa vw cv cX wss wa cc0
      vz cv clt wbr vy cv vz cv cM cbl cfv co vw cv wss wa vz cr wrex cc0 vz cv
      clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin wss wa vz cr wrex
      cc0 vv cv clt wbr vy cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex cc0
      vz cv clt wbr vy cv vz cv cM cbl cfv co vw cv wss wa vz cr wrex cc0 vz cv
      clt wbr vy cv vz cv cM cbl cfv co cY cin vw cv cY cin wss wa vz cr wrex
      wi cM cme wcel cY cX wss wa vw cv cX wss wa cc0 vz cv clt wbr vy cv vz cv
      cM cbl cfv co vw cv wss wa cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY
      cin vw cv cY cin wss wa vz cr vy cv vz cv cM cbl cfv co vw cv wss vy cv
      vz cv cM cbl cfv co cY cin vw cv cY cin wss cc0 vz cv clt wbr vy cv vz cv
      cM cbl cfv co vw cv cY ssrin anim2i r19.22si a1i cc0 vv cv clt wbr vy cv
      vv cv cM cbl cfv co vw cv wss wa cc0 vz cv clt wbr vy cv vz cv cM cbl cfv
      co vw cv wss wa vv vz cr vv vz weq cc0 vv cv clt wbr cc0 vz cv clt wbr vy
      cv vv cv cM cbl cfv co vw cv wss vy cv vz cv cM cbl cfv co vw cv wss vv
      cv vz cv cc0 clt breq2 vv vz weq vy cv vv cv cM cbl cfv co vy cv vz cv cM
      cbl cfv co vw cv vv cv vz cv vy cv cM cbl cfv opreq2 sseq1d anbi12d
      cbvrexv syl5ib imp cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss
      wa vv cr wrex vu vw cv wral vy vw wel cc0 vv cv clt wbr vy cv vv cv cM
      cbl cfv co vw cv wss wa vv cr wrex vy cv vw cv cY cin wcel cc0 vv cv clt
      wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex cc0 vv cv clt wbr
      vy cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vy cv vw cv vu vy
      weq cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa cc0 vv cv
      clt wbr vy cv vv cv cM cbl cfv co vw cv wss wa vv cr vu vy weq vu cv vv
      cv cM cbl cfv co vw cv wss vy cv vv cv cM cbl cfv co vw cv wss cc0 vv cv
      clt wbr vu vy weq vu cv vv cv cM cbl cfv co vy cv vv cv cM cbl cfv co vw
      cv vu cv vy cv vv cv cM cbl cfv opreq1 sseq1d anbi2d rexbidv rcla4cva vw
      cv cY cin vw cv vy cv vw cv cY inss1 sseli sylan2 sylan2 anassrs
      r19.21aiva anasss vw cv cY inss2 jctil syl5cbir expimpd 19.23adv impbid
      cM cme wcel cY cX wss wa vx cv cM cY cY cxp cres copn cfv wcel vx cv cM
      cY cY cxp cres cdm cdm wss cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp
      cres cbl cfv co vx cv wss wa vz cr wrex vy vx cv wral wa vx cv cY wss cc0
      vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss wa vz cr
      wrex vy vx cv wral wa vx cv cY wss cc0 vz cv clt wbr vy cv vz cv cM cbl
      cfv co cY cin vx cv wss wa vz cr wrex vy vx cv wral wa cM cme wcel vx cv
      cM cY cY cxp cres copn cfv wcel vx cv cM cY cY cxp cres cdm cdm wss cc0
      vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss wa vz cr
      wrex vy vx cv wral wa wb cY cX wss cM cme wcel cM cY cY cxp cres cme wcel
      vx cv cM cY cY cxp cres copn cfv wcel vx cv cM cY cY cxp cres cdm cdm wss
      cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss wa
      vz cr wrex vy vx cv wral wa wb cM cY metres vy vz vx cv cM cY cY cxp cres
      cM cY cY cxp cres copn cfv cM cY cY cxp cres cdm cdm cM cY cY cxp cres
      cdm cdm eqid cM cY cY cxp cres copn cfv eqid isopn4 syl adantr cM cme
      wcel cY cX wss wa vx cv cM cY cY cxp cres cdm cdm wss vx cv cY wss cc0 vz
      cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss wa vz cr
      wrex vy vx cv wral cM cme wcel cY cX wss wa cM cY cY cxp cres cdm cdm cY
      vx cv cM cme wcel cY cX wss wa cY cM cY cY cxp cres cdm cdm cM cX cY
      metsstop.1 metssba2 eqcomd sseq2d anbi1d cM cme wcel cY cX wss wa vx cv
      cY wss cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv
      wss wa vz cr wrex vy vx cv wral cc0 vz cv clt wbr vy cv vz cv cM cbl cfv
      co cY cin vx cv wss wa vz cr wrex vy vx cv wral cM cme wcel cY cX wss wa
      vx cv cY wss wa cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv
      co vx cv wss wa vz cr wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY
      cin vx cv wss wa vz cr wrex vy vx cv cM cme wcel cY cX wss wa vx cv cY
      wss vy vx wel cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co
      vx cv wss wa vz cr wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY
      cin vx cv wss wa vz cr wrex wb cM cme wcel cY cX wss wa vy cv cY wcel cc0
      vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss wa vz cr
      wrex cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz
      cr wrex wb vx cv cY wss vy vx wel wa cM cme wcel cY cX wss wa vy cv cY
      wcel wa cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv
      wss wa cc0 vz cv clt wbr vy cv vz cv cM cbl cfv co cY cin vx cv wss wa vz
      cr cM cme wcel cY cX wss wa vy cv cY wcel wa vz cv cr wcel wa cc0 vz cv
      clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss vy cv vz cv cM
      cbl cfv co cY cin vx cv wss cM cme wcel cY cX wss wa vy cv cY wcel wa vz
      cv cr wcel cc0 vz cv clt wbr vy cv vz cv cM cY cY cxp cres cbl cfv co vx
      cv wss vy cv vz cv cM cbl cfv co cY cin vx cv wss wb cM cme wcel cY cX
      wss wa vy cv cY wcel wa vz cv crp wcel vy cv vz cv cM cY cY cxp cres cbl
      cfv co vx cv wss vy cv vz cv cM cbl cfv co cY cin vx cv wss wb vz cv cr
      wcel cc0 vz cv clt wbr wa cM cme wcel cY cX wss wa vy cv cY wcel vz cv
      crp wcel vy cv vz cv cM cY cY cxp cres cbl cfv co vx cv wss vy cv vz cv
      cM cbl cfv co cY cin vx cv wss wb cM cme wcel cY cX wss wa vy cv cY wcel
      vz cv crp wcel wa wa vy cv vz cv cM cY cY cxp cres cbl cfv co vy cv vz cv
      cM cbl cfv co cY cin vx cv vz cv cY cM cM cY cY cxp cres cX vy cv
      metsstop.1 cM cY cY cxp cres eqid blssp sseq1d anassrs vz cv elrp
      sylan2br anassrs pm5.32da rexbidva vx cv cY vy cv ssel2 sylan2 anassrs
      ralbidva pm5.32da 3bitrd cM cme wcel cY cX wss wa vx cv cY cJ cop csubsp
      cfv wcel vx cv vw cv cY cin wceq vw cJ wrex vw cv cX wss cc0 vv cv clt
      wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv wral wa vx
      cv vw cv cY cin wceq wa vw wex cJ ctop wcel vx cv cvv wcel cY cvv wcel vx
      cv cY cJ cop csubsp cfv wcel vx cv vw cv cY cin wceq vw cJ wrex wb cM cme
      wcel cY cX wss wa vw vx cv cY cvv cJ issubspt cM cme wcel cJ ctop wcel cY
      cX wss cM cJ metsstop.2 opntop adantr vx cv cvv wcel cM cme wcel cY cX
      wss wa vx visset a1i cY cX wss cM cme wcel cY cvv wcel cY cX wss cX cvv
      wcel cY cvv wcel cM cme wcel cY cX cvv ssexg cM cme wcel cM cdm cdm cvv
      cX cM cme wcel cM cdm cvv wcel cM cdm cdm cvv wcel cM cme dmexg cM cdm
      cvv dmexg syl metsstop.1 syl5eqel sylan2 ancoms syl3anc cM cme wcel cY cX
      wss wa vw cv cJ wcel vx cv vw cv cY cin wceq wa vw wex vw cv cX wss cc0
      vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr wrex vu vw cv
      wral wa vx cv vw cv cY cin wceq wa vw wex vx cv vw cv cY cin wceq vw cJ
      wrex cM cme wcel cY cX wss wa vw cv cJ wcel vx cv vw cv cY cin wceq wa vw
      cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co vw cv wss wa vv cr
      wrex vu vw cv wral wa vx cv vw cv cY cin wceq wa vw cM cme wcel cY cX wss
      wa vw cv cJ wcel vw cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv co
      vw cv wss wa vv cr wrex vu vw cv wral wa vx cv vw cv cY cin wceq cM cme
      wcel vw cv cJ wcel vw cv cX wss cc0 vv cv clt wbr vu cv vv cv cM cbl cfv
      co vw cv wss wa vv cr wrex vu vw cv wral wa wb cY cX wss vu vv vw cv cM
      cJ cX metsstop.1 metsstop.2 isopn4 adantr anbi1d exbidv vx cv vw cv cY
      cin wceq vw cJ df-rex syl5bb bitrd 3bitr4d eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Two ways of expressing a subspace of ` RR ` . $)
    stioo $p |- ( A C_ RR -> ( subSp ` <. A , ( topGen ` ran (,) ) >. )
                              = ( Open ` ( ( abs o. - ) |` ( A X. A ) ) ) ) $=
      cA cr wss cabs cmin ccom cr cr cxp cres cA cA cxp cres copn cfv cA cioo
      crn ctg cfv cop csubsp cfv cabs cmin ccom cA cA cxp cres copn cfv cabs
      cmin ccom cr cr cxp cres cme wcel cA cr wss cabs cmin ccom cr cr cxp cres
      cA cA cxp cres copn cfv cA cioo crn ctg cfv cop csubsp cfv wceq cabs cmin
      ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid remet cabs cmin
      ccom cr cr cxp cres cme wcel cA cr wss wa cA cioo crn ctg cfv cop csubsp
      cfv cabs cmin ccom cr cr cxp cres cA cA cxp cres copn cfv cabs cmin ccom
      cr cr cxp cres cabs cmin ccom cr cr cxp cres cA cA cxp cres cioo crn ctg
      cfv cabs cmin ccom cr cr cxp cres cA cA cxp cres copn cfv cr cA cabs cmin
      ccom cr cr cxp cres cA cA cxp cres eqid cabs cmin ccom cr cr cxp cres
      cabs cmin ccom cr cr cxp cres eqid remetba cabs cmin ccom cr cr cxp cres
      cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom cr cr cxp cres eqid
      cabs cmin ccom cr cr cxp cres copn cfv eqid tgioo cabs cmin ccom cr cr
      cxp cres cA cA cxp cres copn cfv eqid subtopmet eqcomd mpan cA cr wss
      cabs cmin ccom cr cr cxp cres cA cA cxp cres cabs cmin ccom cA cA cxp
      cres copn cA cr wss cA cA cxp cr cr cxp wss cabs cmin ccom cr cr cxp cres
      cA cA cxp cres cabs cmin ccom cA cA cxp cres wceq cA cr wss cA cA cxp cr
      cr cxp wss cA cr cA cr ssxp anidms cabs cmin ccom cA cA cxp cr cr cxp
      resabs1 syl fveq2d eqtr3d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d X s $. $d M s $. $d R s $. $d Y s $. $d Z s $.
    blhalf.1 $e |- X = dom dom M $.
    $( A ball of radius ` R / 2 ` is contained in a ball of radius ` R `
       centered at any point inside the smaller ball. $)
    blhalf $p |- ( ( ( M e. Met /\ Y e. X ) /\ ( R e. RR+ /\
                    Z e. ( Y ( ball ` M ) ( R / 2 ) ) ) ) ->
              ( Y ( ball ` M ) ( R / 2 ) ) C_ ( Z ( ball ` M ) R ) ) $=
      cM cme wcel cY cX wcel wa cR crp wcel cZ cY cR c2 cdiv co cM cbl cfv co
      wcel wa wa vs cY cR c2 cdiv co cM cbl cfv co cZ cR cM cbl cfv co cM cme
      wcel cY cX wcel wa cR crp wcel cZ cY cR c2 cdiv co cM cbl cfv co wcel vs
      cv cY cR c2 cdiv co cM cbl cfv co wcel vs cv cZ cR cM cbl cfv co wcel wi
      cM cme wcel cY cX wcel wa cR crp wcel wa cZ cY cR c2 cdiv co cM cbl cfv
      co wcel vs cv cY cR c2 cdiv co cM cbl cfv co wcel vs cv cZ cR cM cbl cfv
      co wcel cM cme wcel cY cX wcel wa cR crp wcel wa cZ cY cR c2 cdiv co cM
      cbl cfv co wcel vs cv cY cR c2 cdiv co cM cbl cfv co wcel wa cZ cX wcel
      cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv cM co cR c2
      cdiv co clt wbr wa wa vs cv cZ cR cM cbl cfv co wcel cM cme wcel cY cX
      wcel wa cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr wa cZ cY cR c2
      cdiv co cM cbl cfv co wcel vs cv cY cR c2 cdiv co cM cbl cfv co wcel wa
      cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv cM
      co cR c2 cdiv co clt wbr wa wa wb cR crp wcel cM cme wcel cY cX wcel wa
      cR c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr wa wa cZ cY cR c2 cdiv co
      cM cbl cfv co wcel cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv
      cY cR c2 cdiv co cM cbl cfv co wcel vs cv cX wcel cY vs cv cM co cR c2
      cdiv co clt wbr wa cZ cM cY cR c2 cdiv co cX blhalf.1 elbl vs cv cM cY cR
      c2 cdiv co cX blhalf.1 elbl anbi12d cR crp wcel cR c2 cdiv co crp wcel cR
      c2 cdiv co cr wcel cc0 cR c2 cdiv co clt wbr wa cR crp wcel c2 crp wcel
      cR c2 cdiv co crp wcel c2 2re 2pos elrpii cR c2 rpdivcl mpan2 cR c2 cdiv
      co rpregt0 syl sylan2 cM cme wcel cY cX wcel wa cR cr wcel cc0 cR clt wbr
      wa cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv
      cM co cR c2 cdiv co clt wbr wa wa vs cv cZ cR cM cbl cfv co wcel wi cR
      crp wcel cM cme wcel cY cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cZ cX
      wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv cM co cR
      c2 cdiv co clt wbr wa wa vs cv cX wcel cZ vs cv cM co cR clt wbr wa vs cv
      cZ cR cM cbl cfv co wcel cM cme wcel cY cX wcel wa cR cr wcel cc0 cR clt
      wbr wa wa cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel
      cY vs cv cM co cR c2 cdiv co clt wbr wa wa vs cv cX wcel cZ vs cv cM co
      cR clt wbr cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel
      cY vs cv cM co cR c2 cdiv co clt wbr wa wa vs cv cX wcel wi cM cme wcel
      cY cX wcel wa cR cr wcel cc0 cR clt wbr wa wa cZ cX wcel cY cZ cM co cR
      c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv cM co cR c2 cdiv co clt wbr
      simprl a1i cM cme wcel cY cX wcel wa cR cr wcel cZ cX wcel cY cZ cM co cR
      c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv cM co cR c2 cdiv co clt wbr
      wa wa cZ vs cv cM co cR clt wbr wi cc0 cR clt wbr cM cme wcel cY cX wcel
      wa cR cr wcel wa cZ cX wcel vs cv cX wcel wa cY cZ cM co cR c2 cdiv co
      clt wbr cY vs cv cM co cR c2 cdiv co clt wbr wa wa cZ vs cv cM co cR clt
      wbr cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel cY vs
      cv cM co cR c2 cdiv co clt wbr wa wa cM cme wcel cY cX wcel wa cR cr wcel
      cZ cX wcel vs cv cX wcel wa cY cZ cM co cR c2 cdiv co clt wbr cY vs cv cM
      co cR c2 cdiv co clt wbr wa wa cZ vs cv cM co cR clt wbr wi cM cme wcel
      cY cX wcel wa cZ cX wcel vs cv cX wcel wa cY cZ cM co cR c2 cdiv co clt
      wbr cY vs cv cM co cR c2 cdiv co clt wbr wa wa cR cr wcel cZ vs cv cM co
      cR clt wbr cM cme wcel cY cX wcel wa cZ cX wcel vs cv cX wcel wa cY cZ cM
      co cR c2 cdiv co clt wbr cY vs cv cM co cR c2 cdiv co clt wbr wa cR cr
      wcel cZ vs cv cM co cR clt wbr wi cM cme wcel cZ cX wcel cY cX wcel vs cv
      cX wcel cY cZ cM co cR c2 cdiv co clt wbr cY vs cv cM co cR c2 cdiv co
      clt wbr wa cR cr wcel cZ vs cv cM co cR clt wbr wi wi cM cme wcel cZ cX
      wcel wa vs cv cX wcel cY cX wcel cY cZ cM co cR c2 cdiv co clt wbr cY vs
      cv cM co cR c2 cdiv co clt wbr wa cR cr wcel cZ vs cv cM co cR clt wbr wi
      wi cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cZ vs cv cM
      co cY cZ cM co cY vs cv cM co caddc co cle wbr cY cZ cM co cR c2 cdiv co
      clt wbr cY vs cv cM co cR c2 cdiv co clt wbr wa cR cr wcel cZ vs cv cM co
      cR clt wbr wi wi cZ vs cv cY cM cX blhalf.1 mettri4 cM cme wcel cZ cX
      wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel cY cZ cM co cR c2 cdiv
      co clt wbr cY vs cv cM co cR c2 cdiv co clt wbr wa cZ vs cv cM co cY cZ
      cM co cY vs cv cM co caddc co cle wbr cZ vs cv cM co cR clt wbr cM cme
      wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel cY cZ cM co
      cR c2 cdiv co clt wbr cY vs cv cM co cR c2 cdiv co clt wbr wa cZ vs cv cM
      co cY cZ cM co cY vs cv cM co caddc co cle wbr cZ vs cv cM co cR clt wbr
      wi wi cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel
      wa cY cZ cM co cR c2 cdiv co clt wbr cY vs cv cM co cR c2 cdiv co clt wbr
      wa cY cZ cM co cY vs cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc
      co clt wbr cZ vs cv cM co cY cZ cM co cY vs cv cM co caddc co cle wbr cZ
      vs cv cM co cR clt wbr wi cY cZ cM co cr wcel cY vs cv cM co cr wcel cR
      c2 cdiv co cr wcel cR c2 cdiv co cr wcel cY cZ cM co cR c2 cdiv co clt
      wbr cY vs cv cM co cR c2 cdiv co clt wbr wa cY cZ cM co cY vs cv cM co
      caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr wi cM cme wcel cZ
      cX wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel wa cY cZ cM co cY vs
      cv cM co cR c2 cdiv co cR c2 cdiv co lt2add cM cme wcel cZ cX wcel wa vs
      cv cX wcel cY cX wcel wa wa cY cZ cM co cr wcel cR cr wcel cM cme wcel cZ
      cX wcel wa cY cX wcel cY cZ cM co cr wcel vs cv cX wcel cM cme wcel cZ cX
      wcel cY cX wcel cY cZ cM co cr wcel cM cme wcel cY cX wcel cZ cX wcel cY
      cZ cM co cr wcel cM cme wcel cY cX wcel cZ cX wcel cY cZ cM co cr wcel cY
      cZ cM cX blhalf.1 metcl 3expb ancom2s anassrs adantrl adantr cM cme wcel
      cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cY vs cv cM co cr wcel cR cr
      wcel cM cme wcel vs cv cX wcel cY cX wcel wa cY vs cv cM co cr wcel cZ cX
      wcel cM cme wcel cY cX wcel vs cv cX wcel cY vs cv cM co cr wcel cM cme
      wcel cY cX wcel vs cv cX wcel cY vs cv cM co cr wcel cY vs cv cM cX
      blhalf.1 metcl 3expb ancom2s adantlr adantr cR cr wcel cR c2 cdiv co cr
      wcel cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR rehalfcl
      adantl cR cr wcel cR c2 cdiv co cr wcel cM cme wcel cZ cX wcel wa vs cv
      cX wcel cY cX wcel wa wa cR rehalfcl adantl syl2anc cM cme wcel cZ cX
      wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel wa cZ vs cv cM co cY cZ
      cM co cY vs cv cM co caddc co cle wbr cY cZ cM co cY vs cv cM co caddc co
      cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cZ vs cv cM co cR clt wbr cM
      cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel wa cZ vs
      cv cM co cY cZ cM co cY vs cv cM co caddc co cle wbr cY cZ cM co cY vs cv
      cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cZ vs cv cM
      co cR clt wbr cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR
      cr wcel wa cZ vs cv cM co cY cZ cM co cY vs cv cM co caddc co cle wbr cY
      cZ cM co cY vs cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt
      wbr wa cZ vs cv cM co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cZ vs
      cv cM co cR clt wbr cZ vs cv cM co cr wcel cY cZ cM co cY vs cv cM co
      caddc co cr wcel cR c2 cdiv co cR c2 cdiv co caddc co cr wcel cZ vs cv cM
      co cY cZ cM co cY vs cv cM co caddc co cle wbr cY cZ cM co cY vs cv cM co
      caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr wa cZ vs cv cM co
      cR c2 cdiv co cR c2 cdiv co caddc co clt wbr wi cM cme wcel cZ cX wcel wa
      vs cv cX wcel cY cX wcel wa wa cR cr wcel wa cZ vs cv cM co cY cZ cM co
      cY vs cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co lelttr cM
      cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cZ vs cv cM co cr
      wcel cR cr wcel cM cme wcel cZ cX wcel wa vs cv cX wcel cZ vs cv cM co cr
      wcel cY cX wcel cM cme wcel cZ cX wcel vs cv cX wcel cZ vs cv cM co cr
      wcel cZ vs cv cM cX blhalf.1 metcl 3expa adantrr adantr cY cZ cM co cr
      wcel cY vs cv cM co cr wcel cY cZ cM co cY vs cv cM co caddc co cr wcel
      cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR cr wcel wa cY
      cZ cM co cY vs cv cM co readdcl cM cme wcel cZ cX wcel wa vs cv cX wcel
      cY cX wcel wa wa cY cZ cM co cr wcel cR cr wcel cM cme wcel cZ cX wcel wa
      cY cX wcel cY cZ cM co cr wcel vs cv cX wcel cM cme wcel cZ cX wcel cY cX
      wcel cY cZ cM co cr wcel cM cme wcel cY cX wcel cZ cX wcel cY cZ cM co cr
      wcel cM cme wcel cY cX wcel cZ cX wcel cY cZ cM co cr wcel cY cZ cM cX
      blhalf.1 metcl 3expb ancom2s anassrs adantrl adantr cM cme wcel cZ cX
      wcel wa vs cv cX wcel cY cX wcel wa wa cY vs cv cM co cr wcel cR cr wcel
      cM cme wcel vs cv cX wcel cY cX wcel wa cY vs cv cM co cr wcel cZ cX wcel
      cM cme wcel cY cX wcel vs cv cX wcel cY vs cv cM co cr wcel cM cme wcel
      cY cX wcel vs cv cX wcel cY vs cv cM co cr wcel cY vs cv cM cX blhalf.1
      metcl 3expb ancom2s adantlr adantr sylanc cR cr wcel cR c2 cdiv co cR c2
      cdiv co caddc co cr wcel cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX
      wcel wa wa cR c2 cdiv co cr wcel cR c2 cdiv co cr wcel cR c2 cdiv co cR
      c2 cdiv co caddc co cr wcel cR cr wcel cR c2 cdiv co cR c2 cdiv co
      readdcl cR rehalfcl cR rehalfcl sylanc adantl syl3anc cR cr wcel cZ vs cv
      cM co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cZ vs cv cM co cR clt
      wbr wi cM cme wcel cZ cX wcel wa vs cv cX wcel cY cX wcel wa wa cR cr
      wcel cZ vs cv cM co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cZ vs cv
      cM co cR clt wbr cR cr wcel cR c2 cdiv co cR c2 cdiv co caddc co cR cZ vs
      cv cM co clt cR cr wcel cR cc wcel cR c2 cdiv co cR c2 cdiv co caddc co
      cR wceq cR recn cR 2halves syl breq2d biimpd adantl syld exp3a com23 syld
      ex com24 mpd ancom2s an4s expimpd com23 imp cZ cX wcel cY cZ cM co cR c2
      cdiv co clt wbr vs cv cX wcel cY vs cv cM co cR c2 cdiv co clt wbr an4
      syl5ib adantrr jcad cM cme wcel cR cr wcel cc0 cR clt wbr wa cZ cX wcel
      cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel cY vs cv cM co cR c2
      cdiv co clt wbr wa wa vs cv cX wcel cZ vs cv cM co cR clt wbr wa vs cv cZ
      cR cM cbl cfv co wcel wi wi cY cX wcel cM cme wcel cR cr wcel cc0 cR clt
      wbr wa wa cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs cv cX wcel
      cY vs cv cM co cR c2 cdiv co clt wbr wa wa vs cv cX wcel cZ vs cv cM co
      cR clt wbr wa vs cv cZ cR cM cbl cfv co wcel wi cM cme wcel cR cr wcel
      cc0 cR clt wbr wa wa cZ cX wcel cY cZ cM co cR c2 cdiv co clt wbr wa vs
      cv cX wcel cZ vs cv cM co cR clt wbr wa vs cv cZ cR cM cbl cfv co wcel wi
      vs cv cX wcel cY vs cv cM co cR c2 cdiv co clt wbr wa cM cme wcel cR cr
      wcel cc0 cR clt wbr wa wa cZ cX wcel vs cv cX wcel cZ vs cv cM co cR clt
      wbr wa vs cv cZ cR cM cbl cfv co wcel wi cY cZ cM co cR c2 cdiv co clt
      wbr cM cme wcel cZ cX wcel cR cr wcel cc0 cR clt wbr wa vs cv cX wcel cZ
      vs cv cM co cR clt wbr wa vs cv cZ cR cM cbl cfv co wcel wi cM cme wcel
      cZ cX wcel wa cR cr wcel cc0 cR clt wbr wa wa vs cv cZ cR cM cbl cfv co
      wcel vs cv cX wcel cZ vs cv cM co cR clt wbr wa vs cv cM cZ cR cX
      blhalf.1 elbl biimprd an1rs adantrr adantrr ex adantlr mpdd cR rpregt0
      sylan2 sylbid expdimp anasss ssrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M j k m $. $d N j k m $. $d F j k m $. $d G j k m $. $d X j k m $.
    mettrifi.1 $e |- X = dom dom M $.
    $( Generalized triangle inequality for arbitrary finite sums. $)
    mettrifi $p |- ( ( ( M e. Met /\ N e. NN ) /\
        ( A. k e. ( 1 ... ( N + 1 ) ) ( F ` k ) e. X /\
        A. k e. ( 1 ... N ) ( G ` k ) = ( ( F ` k ) M ( F ` ( k + 1 ) ) ) ) )
   -> ( ( F ` 1 ) M ( F ` ( N + 1 ) ) ) <_ sum_ k e. ( 1 ... N ) ( G ` k ) ) $=
      cN cn wcel cM cme wcel vk cv cF cfv cX wcel vk c1 cN c1 caddc co cfz co
      wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1
      cN cfz co wral wa c1 cF cfv cN c1 caddc co cF cfv cM co c1 cN cfz co vk
      cv cG cfv vk csu cle wbr cN cn wcel cM cme wcel vk cv cF cfv cX wcel vk
      c1 cN c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co wceq vk c1 cN cfz co wral wa c1 cF cfv cN c1 caddc co cF cfv
      cM co c1 cN cfz co vk cv cG cfv vk csu cle wbr cN cn wcel cM cme wcel vk
      cv cF cfv cX wcel vk c1 cN c1 caddc co cfz co wral vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 cN cfz co wral wa wa c1 cF
      cfv cN c1 caddc co cF cfv cM co c1 cN cfz co vk cv cG cfv vk csu cle wbr
      cM cme wcel vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk
      cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv
      cfz co wral wa wa c1 cF cfv vj cv c1 caddc co cF cfv cM co c1 vj cv cfz
      co vk cv cG cfv vk csu cle wbr wi cM cme wcel vk cv cF cfv cX wcel vk c1
      c1 c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 c1 cfz co wral wa wa c1 cF cfv c1 c1 caddc co cF cfv
      cM co c1 c1 cfz co vk cv cG cfv vk csu cle wbr wi cM cme wcel vk cv cF
      cfv cX wcel vk c1 vm cv c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv cfz co wral wa wa c1 cF
      cfv vm cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu
      cle wbr wi cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1
      caddc co c1 caddc co cF cfv cM co c1 vm cv c1 caddc co cfz co vk cv cG
      cfv vk csu cle wbr wi cM cme wcel vk cv cF cfv cX wcel vk c1 cN c1 caddc
      co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      wceq vk c1 cN cfz co wral wa wa c1 cF cfv cN c1 caddc co cF cfv cM co c1
      cN cfz co vk cv cG cfv vk csu cle wbr wi vj vm cN vj cv c1 wceq cM cme
      wcel vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co
      wral wa wa cM cme wcel vk cv cF cfv cX wcel vk c1 c1 c1 caddc co cfz co
      wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1
      c1 cfz co wral wa wa c1 cF cfv vj cv c1 caddc co cF cfv cM co c1 vj cv
      cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv c1 c1 caddc co cF cfv cM co
      c1 c1 cfz co vk cv cG cfv vk csu cle wbr vj cv c1 wceq vk cv cF cfv cX
      wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co wral wa vk cv cF cfv cX
      wcel vk c1 c1 c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1
      caddc co cF cfv cM co wceq vk c1 c1 cfz co wral wa cM cme wcel vj cv c1
      wceq vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cF
      cfv cX wcel vk c1 c1 c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co wral vk cv cG cfv vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 c1 cfz co wral vj cv
      c1 wceq vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co c1 c1 c1
      caddc co cfz co vj cv c1 wceq vj cv c1 caddc co c1 c1 caddc co c1 cfz vj
      cv c1 c1 caddc opreq1 opreq2d raleq1d vj cv c1 wceq vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co c1 c1 cfz co
      vj cv c1 c1 cfz opreq2 raleq1d anbi12d anbi2d vj cv c1 wceq c1 cF cfv vj
      cv c1 caddc co cF cfv cM co c1 cF cfv c1 c1 caddc co cF cfv cM co c1 vj
      cv cfz co vk cv cG cfv vk csu c1 c1 cfz co vk cv cG cfv vk csu cle vj cv
      c1 wceq vj cv c1 caddc co cF cfv c1 c1 caddc co cF cfv c1 cF cfv cM vj cv
      c1 wceq vj cv c1 caddc co c1 c1 caddc co cF vj cv c1 c1 caddc opreq1
      fveq2d opreq2d vj cv c1 wceq c1 vj cv cfz co c1 c1 cfz co vk cv cG cfv vk
      vj cv c1 c1 cfz opreq2 sumeq1d breq12d imbi12d vj cv vm cv wceq cM cme
      wcel vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co
      wral wa wa cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co cfz
      co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk
      c1 vm cv cfz co wral wa wa c1 cF cfv vj cv c1 caddc co cF cfv cM co c1 vj
      cv cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv vm cv c1 caddc co cF cfv
      cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr vj cv vm cv wceq vk cv
      cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co wral wa vk cv
      cF cfv cX wcel vk c1 vm cv c1 caddc co cfz co wral vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv cfz co wral wa cM cme
      wcel vj cv vm cv wceq vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co
      wral vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co cfz co wral vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co
      wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1
      vm cv cfz co wral vj cv vm cv wceq vk cv cF cfv cX wcel vk c1 vj cv c1
      caddc co cfz co c1 vm cv c1 caddc co cfz co vj cv vm cv wceq vj cv c1
      caddc co vm cv c1 caddc co c1 cfz vj cv vm cv c1 caddc opreq1 opreq2d
      raleq1d vj cv vm cv wceq vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 vj cv cfz co c1 vm cv cfz co vj cv vm cv c1 cfz
      opreq2 raleq1d anbi12d anbi2d vj cv vm cv wceq c1 cF cfv vj cv c1 caddc
      co cF cfv cM co c1 cF cfv vm cv c1 caddc co cF cfv cM co c1 vj cv cfz co
      vk cv cG cfv vk csu c1 vm cv cfz co vk cv cG cfv vk csu cle vj cv vm cv
      wceq vj cv c1 caddc co cF cfv vm cv c1 caddc co cF cfv c1 cF cfv cM vj cv
      vm cv wceq vj cv c1 caddc co vm cv c1 caddc co cF vj cv vm cv c1 caddc
      opreq1 fveq2d opreq2d vj cv vm cv wceq c1 vj cv cfz co c1 vm cv cfz co vk
      cv cG cfv vk vj cv vm cv c1 cfz opreq2 sumeq1d breq12d imbi12d vj cv vm
      cv c1 caddc co wceq cM cme wcel vk cv cF cfv cX wcel vk c1 vj cv c1 caddc
      co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      wceq vk c1 vj cv cfz co wral wa wa cM cme wcel vk cv cF cfv cX wcel vk c1
      vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa
      c1 cF cfv vj cv c1 caddc co cF cfv cM co c1 vj cv cfz co vk cv cG cfv vk
      csu cle wbr c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 vm cv
      c1 caddc co cfz co vk cv cG cfv vk csu cle wbr vj cv vm cv c1 caddc co
      wceq vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co
      wral wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co
      wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1
      vm cv c1 caddc co cfz co wral wa cM cme wcel vj cv vm cv c1 caddc co wceq
      vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cF cfv cX
      wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co wral vk cv
      cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral vj cv vm cv c1 caddc co wceq vk cv cF cfv cX wcel vk
      c1 vj cv c1 caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz co vj cv
      vm cv c1 caddc co wceq vj cv c1 caddc co vm cv c1 caddc co c1 caddc co c1
      cfz vj cv vm cv c1 caddc co c1 caddc opreq1 opreq2d raleq1d vj cv vm cv
      c1 caddc co wceq vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      wceq vk c1 vj cv cfz co c1 vm cv c1 caddc co cfz co vj cv vm cv c1 caddc
      co c1 cfz opreq2 raleq1d anbi12d anbi2d vj cv vm cv c1 caddc co wceq c1
      cF cfv vj cv c1 caddc co cF cfv cM co c1 cF cfv vm cv c1 caddc co c1
      caddc co cF cfv cM co c1 vj cv cfz co vk cv cG cfv vk csu c1 vm cv c1
      caddc co cfz co vk cv cG cfv vk csu cle vj cv vm cv c1 caddc co wceq vj
      cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv c1 cF cfv cM
      vj cv vm cv c1 caddc co wceq vj cv c1 caddc co vm cv c1 caddc co c1 caddc
      co cF vj cv vm cv c1 caddc co c1 caddc opreq1 fveq2d opreq2d vj cv vm cv
      c1 caddc co wceq c1 vj cv cfz co c1 vm cv c1 caddc co cfz co vk cv cG cfv
      vk vj cv vm cv c1 caddc co c1 cfz opreq2 sumeq1d breq12d imbi12d vj cv cN
      wceq cM cme wcel vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral
      vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv
      cfz co wral wa wa cM cme wcel vk cv cF cfv cX wcel vk c1 cN c1 caddc co
      cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk c1 cN cfz co wral wa wa c1 cF cfv vj cv c1 caddc co cF cfv cM co c1 vj
      cv cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv cN c1 caddc co cF cfv cM
      co c1 cN cfz co vk cv cG cfv vk csu cle wbr vj cv cN wceq vk cv cF cfv cX
      wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co wral wa vk cv cF cfv cX
      wcel vk c1 cN c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1
      caddc co cF cfv cM co wceq vk c1 cN cfz co wral wa cM cme wcel vj cv cN
      wceq vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co wral vk cv cF
      cfv cX wcel vk c1 cN c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co wral vk cv cG cfv vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 cN cfz co wral vj cv
      cN wceq vk cv cF cfv cX wcel vk c1 vj cv c1 caddc co cfz co c1 cN c1
      caddc co cfz co vj cv cN wceq vj cv c1 caddc co cN c1 caddc co c1 cfz vj
      cv cN c1 caddc opreq1 opreq2d raleq1d vj cv cN wceq vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vj cv cfz co c1 cN cfz co
      vj cv cN c1 cfz opreq2 raleq1d anbi12d anbi2d vj cv cN wceq c1 cF cfv vj
      cv c1 caddc co cF cfv cM co c1 cF cfv cN c1 caddc co cF cfv cM co c1 vj
      cv cfz co vk cv cG cfv vk csu c1 cN cfz co vk cv cG cfv vk csu cle vj cv
      cN wceq vj cv c1 caddc co cF cfv cN c1 caddc co cF cfv c1 cF cfv cM vj cv
      cN wceq vj cv c1 caddc co cN c1 caddc co cF vj cv cN c1 caddc opreq1
      fveq2d opreq2d vj cv cN wceq c1 vj cv cfz co c1 cN cfz co vk cv cG cfv vk
      vj cv cN c1 cfz opreq2 sumeq1d breq12d imbi12d c1 cF cfv c1 c1 caddc co
      cF cfv cM co cr wcel c1 cF cfv c1 c1 caddc co cF cfv cM co c1 c1 cfz co
      vk cv cG cfv vk csu wceq c1 cF cfv c1 c1 caddc co cF cfv cM co c1 c1 cfz
      co vk cv cG cfv vk csu cle wbr cM cme wcel vk cv cF cfv cX wcel vk c1 c1
      c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 c1 cfz co wral wa wa c1 cF cfv c1 c1 caddc co cF cfv
      cM co c1 c1 cfz co vk cv cG cfv vk csu eqle cM cme wcel vk cv cF cfv cX
      wcel vk c1 c1 c1 caddc co cfz co wral c1 cF cfv c1 c1 caddc co cF cfv cM
      co cr wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk c1 c1 cfz co wral cM cme wcel c1 cF cfv cX wcel c1 c1 caddc co cF cfv
      cX wcel wa c1 cF cfv c1 c1 caddc co cF cfv cM co cr wcel vk cv cF cfv cX
      wcel vk c1 c1 c1 caddc co cfz co wral cM cme wcel c1 cF cfv cX wcel c1 c1
      caddc co cF cfv cX wcel c1 cF cfv c1 c1 caddc co cF cfv cM co cr wcel c1
      cF cfv c1 c1 caddc co cF cfv cM cX mettrifi.1 metcl 3expb vk cv cF cfv cX
      wcel vk c1 c1 c1 caddc co cfz co wral c1 cF cfv cX wcel c1 c1 caddc co cF
      cfv cX wcel c1 c1 c1 c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1
      c1 c1 caddc co cfz co wral c1 cF cfv cX wcel wi c1 c1 caddc co c1 cuz cfv
      wcel c1 c1 c1 c1 caddc co cfz co wcel c1 c1 caddc co c1 cuz cfv wcel c2
      cz wcel c1 c2 cle wbr c1 c1 caddc co c1 cuz cfv wcel c2 c1 cuz cfv wcel
      c2 cz wcel c1 c2 cle wbr wa c2 c1 c1 caddc co c1 cuz cfv df-2 eleq1i c1
      c2 1z eluz1i bitr3i 2z c1 c2 1re 2re 1lt2 ltleii mpbir2an c1 c1 c1 caddc
      co eluzfz1 ax-mp vk cv cF cfv cX wcel c1 cF cfv cX wcel vk c1 c1 c1 c1
      caddc co cfz co vk cv c1 wceq vk cv cF cfv c1 cF cfv cX vk cv c1 cF fveq2
      eleq1d rcla4v ax-mp c1 c1 caddc co c1 c1 c1 caddc co cfz co wcel vk cv cF
      cfv cX wcel vk c1 c1 c1 caddc co cfz co wral c1 c1 caddc co cF cfv cX
      wcel wi c1 c1 caddc co c1 cuz cfv wcel c1 c1 caddc co c1 c1 c1 caddc co
      cfz co wcel c1 c1 caddc co c1 cuz cfv wcel c2 cz wcel c1 c2 cle wbr c1 c1
      caddc co c1 cuz cfv wcel c2 c1 cuz cfv wcel c2 cz wcel c1 c2 cle wbr wa
      c2 c1 c1 caddc co c1 cuz cfv df-2 eleq1i c1 c2 1z eluz1i bitr3i 2z c1 c2
      1re 2re 1lt2 ltleii mpbir2an c1 c1 c1 caddc co eluzfz2 ax-mp vk cv cF cfv
      cX wcel c1 c1 caddc co cF cfv cX wcel vk c1 c1 caddc co c1 c1 c1 caddc co
      cfz co vk cv c1 c1 caddc co wceq vk cv cF cfv c1 c1 caddc co cF cfv cX vk
      cv c1 c1 caddc co cF fveq2 eleq1d rcla4v ax-mp jca sylan2 adantrr cM cme
      wcel vk cv cF cfv cX wcel vk c1 c1 c1 caddc co cfz co wral vk cv cG cfv
      vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 c1 cfz co wral wa
      wa c1 cG cfv c1 cF cfv c1 c1 caddc co cF cfv cM co c1 c1 cfz co vk cv cG
      cfv vk csu vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk c1 c1 cfz co wral c1 cG cfv c1 cF cfv c1 c1 caddc co cF cfv cM co wceq
      cM cme wcel vk cv cF cfv cX wcel vk c1 c1 c1 caddc co cfz co wral c1 c1
      c1 cfz co wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      wceq vk c1 c1 cfz co wral c1 cG cfv c1 cF cfv c1 c1 caddc co cF cfv cM co
      wceq wi c1 cz wcel c1 c1 c1 cfz co wcel 1z c1 elfz3 ax-mp vk cv cG cfv vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co wceq c1 cG cfv c1 cF cfv c1 c1
      caddc co cF cfv cM co wceq vk c1 c1 c1 cfz co vk cv c1 wceq vk cv cG cfv
      c1 cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co c1 cF cfv c1 c1
      caddc co cF cfv cM co vk cv c1 cG fveq2 vk cv c1 wceq vk cv cF cfv c1 cF
      cfv vk cv c1 caddc co cF cfv c1 c1 caddc co cF cfv cM vk cv c1 cF fveq2
      vk cv c1 wceq vk cv c1 caddc co c1 c1 caddc co cF vk cv c1 c1 caddc
      opreq1 fveq2d opreq12d eqeq12d rcla4v ax-mp ad2antll c1 cG cfv cvv wcel
      c1 cz wcel c1 c1 cfz co vk cv cG cfv vk csu c1 cG cfv wceq c1 cG fvex 1z
      vk cv cG cfv c1 cG cfv cvv vk c1 vk cv c1 cG fveq2 fsum1i mp2an syl5req
      sylanc vm cv cn wcel cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF
      cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr wi cM cme wcel vk
      cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv
      cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM co c1 vm
      cv cfz co vk cv cG cfv vk csu cle wbr wi cM cme wcel vk cv cF cfv cX wcel
      vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral
      wa wa c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 vm cv c1
      caddc co cfz co vk cv cG cfv vk csu cle wbr wi vm cv cn wcel cM cme wcel
      vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk
      cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral wa wa cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv
      c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 vm cv cfz co wral wa wa c1 cF cfv vm cv c1 caddc co
      cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr vm cv cn wcel vk
      cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv
      cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co cfz
      co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk
      c1 vm cv cfz co wral wa cM cme wcel vm cv cn wcel vk cv cF cfv cX wcel vk
      c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cF cfv cX wcel vk c1
      vm cv c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral vk cv cG cfv vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv cfz co wral vm cv
      cn wcel c1 vm cv c1 caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz
      co wss vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co
      wral vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co cfz co wral wi c1 cz
      wcel vm cv c1 caddc co cz wcel c1 vm cv c1 caddc co cfz co c1 vm cv c1
      caddc co c1 caddc co cfz co wss vm cv cn wcel c1 vm cv c1 caddc co fzssp1
      1z vm cv cn wcel vm cv vm cv nnz peano2zdi sylancr vk cv cF cfv cX wcel
      vk c1 vm cv c1 caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz co
      ssralv syl vm cv cn wcel c1 vm cv cfz co c1 vm cv c1 caddc co cfz co wss
      vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv
      c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 vm cv cfz co wral wi c1 cz wcel vm cv cz wcel c1 vm
      cv cfz co c1 vm cv c1 caddc co cfz co wss vm cv cn wcel c1 vm cv fzssp1
      1z vm cv nnz sylancr vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv cfz co c1 vm cv c1 caddc co cfz co ssralv syl
      anim12d anim2d imim1d vm cv cn wcel cM cme wcel vk cv cF cfv cX wcel vk
      c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa
      wa c1 cF cfv vm cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv
      vk csu cle wbr c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 vm
      cv c1 caddc co cfz co vk cv cG cfv vk csu cle wbr vm cv cn wcel cM cme
      wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral
      vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv
      c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM co c1
      vm cv cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv vm cv c1 caddc co c1
      caddc co cF cfv cM co c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu cle
      wbr wi vm cv cn wcel cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa c1 cF cfv vm
      cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr
      c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 vm cv c1 caddc co
      cfz co vk cv cG cfv vk csu cle wbr wi vm cv cn wcel cM cme wcel wa vk cv
      cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc
      co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM co c1 vm cv
      cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv cM co c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc
      co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co caddc co cle wbr c1
      cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1
      caddc co c1 caddc co cF cfv cM co caddc co c1 vm cv c1 caddc co cfz co vk
      cv cG cfv vk csu cle wbr wa c1 cF cfv vm cv c1 caddc co c1 caddc co cF
      cfv cM co c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu cle wbr vm cv
      cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1
      caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr c1 cF
      cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1
      caddc co c1 caddc co cF cfv cM co caddc co c1 vm cv c1 caddc co cfz co vk
      cv cG cfv vk csu cle wbr c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv
      cM co c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv
      vm cv c1 caddc co c1 caddc co cF cfv cM co caddc co cle wbr vm cv cn wcel
      cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co
      cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk c1 vm cv c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF
      cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv vm cv c1
      caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv cM co caddc co c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu
      cle wbr vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa c1 cF cfv
      vm cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle
      wbr wa c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv
      vm cv c1 caddc co c1 caddc co cF cfv cM co caddc co c1 vm cv cfz co vk cv
      cG cfv vk csu vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF
      cfv cM co caddc co c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu cle vm
      cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1
      caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr c1 cF
      cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1
      caddc co c1 caddc co cF cfv cM co caddc co c1 vm cv cfz co vk cv cG cfv
      vk csu vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM
      co caddc co cle wbr c1 cF cfv vm cv c1 caddc co cF cfv cM co cr wcel c1
      vm cv cfz co vk cv cG cfv vk csu cr wcel vm cv c1 caddc co cF cfv vm cv
      c1 caddc co c1 caddc co cF cfv cM co cr wcel c1 cF cfv vm cv c1 caddc co
      cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr c1 cF cfv vm cv
      c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1 caddc co c1
      caddc co cF cfv cM co caddc co c1 vm cv cfz co vk cv cG cfv vk csu vm cv
      c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co caddc co
      cle wbr wb vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv
      c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1
      caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa c1
      cF cfv vm cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu
      vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co
      leadd1 cM cme wcel c1 cF cfv cX wcel vm cv c1 caddc co cF cfv cX wcel c1
      cF cfv vm cv c1 caddc co cF cfv cM co cr wcel vm cv cn wcel cM cme wcel
      wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral
      vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv
      c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM cX
      mettrifi.1 metcl vm cv cn wcel cM cme wcel vk cv cF cfv cX wcel vk c1 vm
      cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1
      caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa simplr
      vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co
      cfz co wral c1 cF cfv cX wcel cM cme wcel vk cv cG cfv vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral c1 c1
      vm cv c1 caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm
      cv c1 caddc co c1 caddc co cfz co wral c1 cF cfv cX wcel vm cv cn wcel vk
      cv cF cfv cX wcel c1 cF cfv cX wcel vk c1 c1 vm cv c1 caddc co c1 caddc
      co cfz co vk cv c1 wceq vk cv cF cfv c1 cF cfv cX vk cv c1 cF fveq2
      eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 caddc co c1 cuz cfv
      wcel c1 c1 vm cv c1 caddc co c1 caddc co cfz co wcel vm cv cn wcel vm cv
      c1 caddc co c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co c1 cuz cfv
      wcel vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co c1 caddc
      co cn wcel vm cv peano2nn vm cv c1 caddc co peano2nn syl vm cv c1 caddc
      co c1 caddc co elnnuz sylib c1 vm cv c1 caddc co c1 caddc co eluzfz1 syl
      sylan ad2ant2r vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co
      c1 caddc co cfz co wral vm cv c1 caddc co cF cfv cX wcel cM cme wcel vk
      cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co
      cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz
      co wral vm cv c1 caddc co cF cfv cX wcel vm cv cn wcel vk cv cF cfv cX
      wcel vm cv c1 caddc co cF cfv cX wcel vk vm cv c1 caddc co c1 vm cv c1
      caddc co c1 caddc co cfz co vk cv vm cv c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co cF cfv cX vk cv vm cv c1 caddc co cF fveq2 eleq1d rcla4va
      vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel c1 vm cv c1 caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co c1
      caddc co cle wbr wa vm cv cn wcel c1 vm cv c1 caddc co cle wbr vm cv c1
      caddc co vm cv c1 caddc co c1 caddc co cle wbr vm cv cn wcel vm cv c1
      caddc co cn wcel c1 vm cv c1 caddc co cle wbr vm cv peano2nn vm cv c1
      caddc co nnge1 syl vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc
      co cr wcel vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr vm cv
      peano2nn vm cv c1 caddc co nnre vm cv c1 caddc co lep1 3syl jca vm cv c1
      caddc co cz wcel c1 cz wcel vm cv c1 caddc co c1 caddc co cz wcel vm cv
      c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co wcel c1 vm cv c1
      caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr
      wa wb vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co
      elfz vm cv cn wcel vm cv vm cv nnz peano2zdi c1 cz wcel vm cv cn wcel 1z
      a1i vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co
      cn wcel vm cv c1 caddc co c1 caddc co cz wcel vm cv peano2nn vm cv c1
      caddc co peano2nn vm cv c1 caddc co c1 caddc co nnz 3syl syl3anc mpbird
      sylan ad2ant2r syl3anc vm cv c1 cuz cfv wcel vk cv cG cfv cr wcel vk c1
      vm cv cfz co wral c1 vm cv cfz co vk cv cG cfv vk csu cr wcel vm cv cn
      wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc
      co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      wceq vk c1 vm cv c1 caddc co cfz co wral wa wa vk cv cG cfv vk c1 vm cv
      fsumrecl vm cv cn wcel vm cv c1 cuz cfv wcel cM cme wcel vk cv cF cfv cX
      wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co
      wral wa vm cv cn wcel vm cv c1 cuz cfv wcel vm cv elnnuz biimpi ad2antrr
      vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co
      c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral vk cv cG cfv cr wcel
      vk c1 vm cv cfz co wral vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel
      vk c1 vm cv c1 caddc co c1 caddc co cfz co wral wa vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co
      wral vk cv cG cfv cr wcel vk c1 vm cv c1 caddc co cfz co wral vk cv cG
      cfv cr wcel vk c1 vm cv cfz co wral vm cv cn wcel cM cme wcel wa vk cv cF
      cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral wa vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk cv cG cfv cr wcel
      vk c1 vm cv c1 caddc co cfz co vm cv cn wcel cM cme wcel wa vk cv cF cfv
      cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk vm cv cn wcel
      cM cme wcel wa vk ax-17 vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co hbra1 hban vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk cv cG cfv cr wcel vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cr wcel vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm
      cv c1 caddc co c1 caddc co cfz co wral wa vk cv c1 vm cv c1 caddc co cfz
      co wcel wa vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co cr
      eleq1 vm cv cn wcel cM cme wcel wa vk cv c1 vm cv c1 caddc co cfz co wcel
      vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co cr wcel vm cv cn wcel cM cme
      wcel wa vk cv c1 vm cv c1 caddc co cfz co wcel wa vj cv cF cfv cX wcel vj
      c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cr wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral cM cme wcel vk cv cF cfv cX wcel vk cv c1 caddc co
      cF cfv cX wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cr wcel vm cv
      cn wcel cM cme wcel wa vk cv c1 vm cv c1 caddc co cfz co wcel wa vj cv cF
      cfv cX wcel vj c1 vm cv c1 caddc co c1 caddc co cfz co wral wa vk cv cF
      cfv vk cv c1 caddc co cF cfv cM cX mettrifi.1 metcl vm cv cn wcel cM cme
      wcel vk cv c1 vm cv c1 caddc co cfz co wcel vj cv cF cfv cX wcel vj c1 vm
      cv c1 caddc co c1 caddc co cfz co wral simpllr vm cv cn wcel vk cv c1 vm
      cv c1 caddc co cfz co wcel vj cv cF cfv cX wcel vj c1 vm cv c1 caddc co
      c1 caddc co cfz co wral vk cv cF cfv cX wcel cM cme wcel vk cv c1 vm cv
      c1 caddc co c1 caddc co cfz co wcel vj cv cF cfv cX wcel vj c1 vm cv c1
      caddc co c1 caddc co cfz co wral vk cv cF cfv cX wcel vm cv cn wcel vk cv
      c1 vm cv c1 caddc co cfz co wcel wa vj cv cF cfv cX wcel vk cv cF cfv cX
      wcel vj vk cv c1 vm cv c1 caddc co c1 caddc co cfz co vj cv vk cv wceq vj
      cv cF cfv vk cv cF cfv cX vj cv vk cv cF fveq2 eleq1d rcla4va c1 vm cv c1
      caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz co wss vk cv c1 vm
      cv c1 caddc co cfz co wcel vk cv c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel vm cv cn wcel c1 vm cv c1 caddc co cfz co c1 vm cv c1 caddc co c1
      caddc co cfz co vk cv ssel2 c1 cz wcel vm cv c1 caddc co cz wcel c1 vm cv
      c1 caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz co wss vm cv cn
      wcel c1 vm cv c1 caddc co fzssp1 1z vm cv cn wcel vm cv vm cv nnz
      peano2zdi sylancr sylan sylan adantllr vm cv cn wcel vk cv c1 vm cv c1
      caddc co cfz co wcel vj cv cF cfv cX wcel vj c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv c1 caddc co cF cfv cX wcel cM cme wcel vk cv
      c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co wcel vj cv cF cfv cX
      wcel vj c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv c1 caddc co cF
      cfv cX wcel vm cv cn wcel vk cv c1 vm cv c1 caddc co cfz co wcel wa vj cv
      cF cfv cX wcel vk cv c1 caddc co cF cfv cX wcel vj vk cv c1 caddc co c1
      vm cv c1 caddc co c1 caddc co cfz co vj cv vk cv c1 caddc co wceq vj cv
      cF cfv vk cv c1 caddc co cF cfv cX vj cv vk cv c1 caddc co cF fveq2
      eleq1d rcla4va vm cv cn wcel vk cv c1 vm cv c1 caddc co cfz co wcel wa c1
      c1 caddc co vm cv c1 caddc co c1 caddc co cfz co c1 vm cv c1 caddc co c1
      caddc co cfz co vk cv c1 caddc co vm cv cn wcel c1 c1 caddc co vm cv c1
      caddc co c1 caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz co wss
      vk cv c1 vm cv c1 caddc co cfz co wcel c1 cz wcel vm cv c1 caddc co c1
      caddc co cz wcel c1 c1 caddc co vm cv c1 caddc co c1 caddc co cfz co c1
      vm cv c1 caddc co c1 caddc co cfz co wss vm cv cn wcel c1 vm cv c1 caddc
      co c1 caddc co fzp1ss 1z vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1
      caddc co c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co cz wcel vm cv
      peano2nn vm cv c1 caddc co peano2nn vm cv c1 caddc co c1 caddc co nnz
      3syl sylancr adantr vm cv cn wcel vk cv c1 vm cv c1 caddc co cfz co wcel
      wa vk cv cz wcel vk cv c1 caddc co c1 c1 caddc co vm cv c1 caddc co c1
      caddc co cfz co wcel vk cv c1 vm cv c1 caddc co cfz co wcel vk cv cz wcel
      vm cv cn wcel vk cv c1 vm cv c1 caddc co elfzelz adantl vm cv cn wcel vk
      cv c1 vm cv c1 caddc co cfz co wcel vk cv cz wcel vk cv c1 caddc co c1 c1
      caddc co vm cv c1 caddc co c1 caddc co cfz co wcel wi vm cv cn wcel vk cv
      cz wcel vk cv c1 vm cv c1 caddc co cfz co wcel vk cv c1 caddc co c1 c1
      caddc co vm cv c1 caddc co c1 caddc co cfz co wcel vm cv cn wcel vk cv cz
      wcel vk cv c1 vm cv c1 caddc co cfz co wcel vk cv c1 caddc co c1 c1 caddc
      co vm cv c1 caddc co c1 caddc co cfz co wcel wi vm cv cn wcel vk cv cz
      wcel wa vk cv c1 vm cv c1 caddc co cfz co wcel vk cv c1 caddc co c1 c1
      caddc co vm cv c1 caddc co c1 caddc co cfz co wcel c1 cz wcel vm cv c1
      caddc co cz wcel vk cv cz wcel c1 cz wcel vk cv c1 vm cv c1 caddc co cfz
      co wcel vk cv c1 caddc co c1 c1 caddc co vm cv c1 caddc co c1 caddc co
      cfz co wcel wb vm cv cn wcel vk cv cz wcel wa vk cv c1 c1 vm cv c1 caddc
      co fzaddel c1 cz wcel vm cv cn wcel vk cv cz wcel wa 1z a1i vm cv cn wcel
      vm cv c1 caddc co cz wcel vk cv cz wcel vm cv cn wcel vm cv vm cv nnz
      peano2zdi adantr vm cv cn wcel vk cv cz wcel pm3.27 c1 cz wcel vm cv cn
      wcel vk cv cz wcel wa 1z a1i syl2anc biimpd ex com23 imp mpd sseldd sylan
      adantllr syl3anc vk cv cF cfv cX wcel vj cv cF cfv cX wcel vk vj c1 vm cv
      c1 caddc co c1 caddc co cfz co vk cv vj cv wceq vk cv cF cfv vj cv cF cfv
      cX vk cv vj cv cF fveq2 eleq1d cbvralv sylan2b an1rs syl5cbir r19.20da vm
      cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral wa c1 vm cv cfz co c1 vm cv c1 caddc co cfz co wss
      vk cv cG cfv cr wcel vk c1 vm cv c1 caddc co cfz co wral vk cv cG cfv cr
      wcel vk c1 vm cv cfz co wral wi vm cv cn wcel c1 vm cv cfz co c1 vm cv c1
      caddc co cfz co wss cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc
      co c1 caddc co cfz co wral c1 cz wcel vm cv cz wcel c1 vm cv cfz co c1 vm
      cv c1 caddc co cfz co wss vm cv cn wcel c1 vm cv fzssp1 1z vm cv nnz
      sylancr ad2antrr vk cv cG cfv cr wcel vk c1 vm cv cfz co c1 vm cv c1
      caddc co cfz co ssralv syl syld impr sylanc cM cme wcel vm cv c1 caddc co
      cF cfv cX wcel vm cv c1 caddc co c1 caddc co cF cfv cX wcel vm cv c1
      caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co cr wcel vm cv
      cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa vm cv c1 caddc co cF
      cfv vm cv c1 caddc co c1 caddc co cF cfv cM cX mettrifi.1 metcl vm cv cn
      wcel cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co
      cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk c1 vm cv c1 caddc co cfz co wral wa simplr vm cv cn wcel vk cv cF cfv
      cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vm cv c1 caddc co
      cF cfv cX wcel cM cme wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral vm cv c1 caddc co c1
      vm cv c1 caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm
      cv c1 caddc co c1 caddc co cfz co wral vm cv c1 caddc co cF cfv cX wcel
      vm cv cn wcel vk cv cF cfv cX wcel vm cv c1 caddc co cF cfv cX wcel vk vm
      cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co vk cv vm cv c1
      caddc co wceq vk cv cF cfv vm cv c1 caddc co cF cfv cX vk cv vm cv c1
      caddc co cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 vm cv
      c1 caddc co c1 caddc co cfz co wcel c1 vm cv c1 caddc co cle wbr vm cv c1
      caddc co vm cv c1 caddc co c1 caddc co cle wbr wa vm cv cn wcel c1 vm cv
      c1 caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle
      wbr vm cv cn wcel vm cv c1 caddc co cn wcel c1 vm cv c1 caddc co cle wbr
      vm cv peano2nn vm cv c1 caddc co nnge1 syl vm cv cn wcel vm cv c1 caddc
      co cn wcel vm cv c1 caddc co cr wcel vm cv c1 caddc co vm cv c1 caddc co
      c1 caddc co cle wbr vm cv peano2nn vm cv c1 caddc co nnre vm cv c1 caddc
      co lep1 3syl jca vm cv c1 caddc co cz wcel c1 cz wcel vm cv c1 caddc co
      c1 caddc co cz wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co
      cfz co wcel c1 vm cv c1 caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc
      co c1 caddc co cle wbr wa wb vm cv cn wcel vm cv c1 caddc co c1 vm cv c1
      caddc co c1 caddc co elfz vm cv cn wcel vm cv vm cv nnz peano2zdi c1 cz
      wcel vm cv cn wcel 1z a1i vm cv cn wcel vm cv c1 caddc co cn wcel vm cv
      c1 caddc co c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co cz wcel vm
      cv peano2nn vm cv c1 caddc co peano2nn vm cv c1 caddc co c1 caddc co nnz
      3syl syl3anc mpbird sylan ad2ant2r vm cv cn wcel vk cv cF cfv cX wcel vk
      c1 vm cv c1 caddc co c1 caddc co cfz co wral vm cv c1 caddc co c1 caddc
      co cF cfv cX wcel cM cme wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral vm cv c1 caddc co
      c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co wcel vk cv cF cfv cX
      wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vm cv c1 caddc co c1
      caddc co cF cfv cX wcel vm cv cn wcel vk cv cF cfv cX wcel vm cv c1 caddc
      co c1 caddc co cF cfv cX wcel vk vm cv c1 caddc co c1 caddc co c1 vm cv
      c1 caddc co c1 caddc co cfz co vk cv vm cv c1 caddc co c1 caddc co wceq
      vk cv cF cfv vm cv c1 caddc co c1 caddc co cF cfv cX vk cv vm cv c1 caddc
      co c1 caddc co cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1
      caddc co c1 cuz cfv wcel vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc
      co c1 caddc co cfz co wcel vm cv cn wcel vm cv c1 caddc co c1 caddc co cn
      wcel vm cv c1 caddc co c1 caddc co c1 cuz cfv wcel vm cv cn wcel vm cv c1
      caddc co cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv peano2nn vm
      cv c1 caddc co peano2nn syl vm cv c1 caddc co c1 caddc co elnnuz sylib c1
      vm cv c1 caddc co c1 caddc co eluzfz2 syl sylan ad2ant2r syl3anc syl3anc
      biimpa vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa c1 cF cfv
      vm cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle
      wbr wa c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu c1 vm cv cfz co vk
      cv cG cfv vk csu vm cv c1 caddc co cG cfv caddc co c1 vm cv cfz co vk cv
      cG cfv vk csu vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF
      cfv cM co caddc co vm cv cn wcel cM cme wcel wa c1 vm cv c1 caddc co cfz
      co vk cv cG cfv vk csu c1 vm cv cfz co vk cv cG cfv vk csu vm cv c1 caddc
      co cG cfv caddc co wceq vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa c1 cF cfv vm cv c1
      caddc co cF cfv cM co c1 vm cv cfz co vk cv cG cfv vk csu cle wbr vm cv
      cn wcel c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu c1 vm cv cfz co
      vk cv cG cfv vk csu vm cv c1 caddc co cG cfv caddc co wceq cM cme wcel vm
      cv cn wcel vm cv c1 cuz cfv wcel c1 vm cv c1 caddc co cfz co vk cv cG cfv
      vk csu c1 vm cv cfz co vk cv cG cfv vk csu vm cv c1 caddc co cG cfv caddc
      co wceq vm cv elnnuz vk cv cG cfv vm cv c1 caddc co cG cfv vk c1 vm cv vk
      cv cG fvex vm cv c1 caddc co cG fvex vk cv vm cv c1 caddc co cG fveq2
      fsump1i sylbi adantr ad2antrr vm cv cn wcel cM cme wcel wa vk cv cF cfv
      cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz
      co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM co c1 vm cv cfz co vk
      cv cG cfv vk csu cle wbr wa vm cv c1 caddc co cG cfv vm cv c1 caddc co cF
      cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 vm cv cfz co vk cv cG
      cfv vk csu caddc vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1
      vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa
      vm cv c1 caddc co cG cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co c1
      caddc co cF cfv cM co wceq c1 cF cfv vm cv c1 caddc co cF cfv cM co c1 vm
      cv cfz co vk cv cG cfv vk csu cle wbr vm cv cn wcel vk cv cG cfv vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co
      wral vm cv c1 caddc co cG cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co
      c1 caddc co cF cfv cM co wceq cM cme wcel vk cv cF cfv cX wcel vk c1 vm
      cv c1 caddc co c1 caddc co cfz co wral vm cv c1 caddc co c1 vm cv c1
      caddc co cfz co wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral vm cv c1 caddc co cG cfv
      vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co wceq
      vm cv cn wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      wceq vm cv c1 caddc co cG cfv vm cv c1 caddc co cF cfv vm cv c1 caddc co
      c1 caddc co cF cfv cM co wceq vk vm cv c1 caddc co c1 vm cv c1 caddc co
      cfz co vk cv vm cv c1 caddc co wceq vk cv cG cfv vm cv c1 caddc co cG cfv
      vk cv cF cfv vk cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm
      cv c1 caddc co c1 caddc co cF cfv cM co vk cv vm cv c1 caddc co cG fveq2
      vk cv vm cv c1 caddc co wceq vk cv cF cfv vm cv c1 caddc co cF cfv vk cv
      c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM vk cv vm cv c1
      caddc co cF fveq2 vk cv vm cv c1 caddc co wceq vk cv c1 caddc co vm cv c1
      caddc co c1 caddc co cF vk cv vm cv c1 caddc co c1 caddc opreq1 fveq2d
      opreq12d eqeq12d rcla4va vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1
      caddc co c1 vm cv c1 caddc co cfz co wcel vm cv peano2nn vm cv c1 caddc
      co cn wcel vm cv c1 caddc co c1 cuz cfv wcel vm cv c1 caddc co c1 vm cv
      c1 caddc co cfz co wcel vm cv c1 caddc co elnnuz c1 vm cv c1 caddc co
      eluzfz2 sylbi syl sylan ad2ant2rl adantr opreq2d eqtrd breqtrrd ex vm cv
      cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co
      c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv
      c1 caddc co c1 caddc co cF cfv cM co caddc co cle wbr vk cv cG cfv vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co
      wral cM cme wcel c1 cF cfv cX wcel vm cv c1 caddc co c1 caddc co cF cfv
      cX wcel vm cv c1 caddc co cF cfv cX wcel w3a c1 cF cfv vm cv c1 caddc co
      c1 caddc co cF cfv cM co c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv
      c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co caddc co
      cle wbr vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral wa c1 cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv vm cv c1 caddc co cF cfv cM cX mettrifi.1 mettri vm cv cn wcel
      cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz
      co wral simplr vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co
      c1 caddc co cfz co wral c1 cF cfv cX wcel vm cv c1 caddc co c1 caddc co
      cF cfv cX wcel vm cv c1 caddc co cF cfv cX wcel w3a cM cme wcel vm cv cn
      wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral
      wa c1 cF cfv cX wcel vm cv c1 caddc co c1 caddc co cF cfv cX wcel vm cv
      c1 caddc co cF cfv cX wcel c1 c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral
      c1 cF cfv cX wcel vm cv cn wcel vk cv cF cfv cX wcel c1 cF cfv cX wcel vk
      c1 c1 vm cv c1 caddc co c1 caddc co cfz co vk cv c1 wceq vk cv cF cfv c1
      cF cfv cX vk cv c1 cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc
      co c1 caddc co c1 cuz cfv wcel c1 c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel vm cv cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv c1 caddc
      co c1 caddc co c1 cuz cfv wcel vm cv cn wcel vm cv c1 caddc co cn wcel vm
      cv c1 caddc co c1 caddc co cn wcel vm cv peano2nn vm cv c1 caddc co
      peano2nn syl vm cv c1 caddc co c1 caddc co elnnuz sylib c1 vm cv c1 caddc
      co c1 caddc co eluzfz1 syl sylan vm cv c1 caddc co c1 caddc co c1 vm cv
      c1 caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vm cv c1 caddc co c1 caddc co cF cfv cX
      wcel vm cv cn wcel vk cv cF cfv cX wcel vm cv c1 caddc co c1 caddc co cF
      cfv cX wcel vk vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc co c1
      caddc co cfz co vk cv vm cv c1 caddc co c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co c1 caddc co cF cfv cX vk cv vm cv c1 caddc co c1 caddc co
      cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 caddc co c1
      cuz cfv wcel vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc co c1 caddc
      co cfz co wcel vm cv cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv
      c1 caddc co c1 caddc co c1 cuz cfv wcel vm cv cn wcel vm cv c1 caddc co
      cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv peano2nn vm cv c1
      caddc co peano2nn syl vm cv c1 caddc co c1 caddc co elnnuz sylib c1 vm cv
      c1 caddc co c1 caddc co eluzfz2 syl sylan vm cv c1 caddc co c1 vm cv c1
      caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vm cv c1 caddc co cF cfv cX wcel vm cv
      cn wcel vk cv cF cfv cX wcel vm cv c1 caddc co cF cfv cX wcel vk vm cv c1
      caddc co c1 vm cv c1 caddc co c1 caddc co cfz co vk cv vm cv c1 caddc co
      wceq vk cv cF cfv vm cv c1 caddc co cF cfv cX vk cv vm cv c1 caddc co cF
      fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co
      c1 caddc co cfz co wcel c1 vm cv c1 caddc co cle wbr vm cv c1 caddc co vm
      cv c1 caddc co c1 caddc co cle wbr wa vm cv cn wcel c1 vm cv c1 caddc co
      cle wbr vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr vm cv cn
      wcel vm cv c1 caddc co cn wcel c1 vm cv c1 caddc co cle wbr vm cv
      peano2nn vm cv c1 caddc co nnge1 syl vm cv cn wcel vm cv c1 caddc co cn
      wcel vm cv c1 caddc co cr wcel vm cv c1 caddc co vm cv c1 caddc co c1
      caddc co cle wbr vm cv peano2nn vm cv c1 caddc co nnre vm cv c1 caddc co
      lep1 3syl jca vm cv c1 caddc co cz wcel c1 cz wcel vm cv c1 caddc co c1
      caddc co cz wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz
      co wcel c1 vm cv c1 caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co
      c1 caddc co cle wbr wa wb vm cv cn wcel vm cv c1 caddc co c1 vm cv c1
      caddc co c1 caddc co elfz vm cv cn wcel vm cv vm cv nnz peano2zdi c1 cz
      wcel vm cv cn wcel 1z a1i vm cv cn wcel vm cv c1 caddc co cn wcel vm cv
      c1 caddc co c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co cz wcel vm
      cv peano2nn vm cv c1 caddc co peano2nn vm cv c1 caddc co c1 caddc co nnz
      3syl syl3anc mpbird sylan 3jca adantlr sylanc adantrr jctild c1 cF cfv vm
      cv c1 caddc co c1 caddc co cF cfv cM co cr wcel c1 cF cfv vm cv c1 caddc
      co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc co cF
      cfv cM co caddc co cr wcel c1 vm cv c1 caddc co cfz co vk cv cG cfv vk
      csu cr wcel c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 cF
      cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1
      caddc co c1 caddc co cF cfv cM co caddc co cle wbr c1 cF cfv vm cv c1
      caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv cM co caddc co c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu
      cle wbr wa c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co c1 vm cv
      c1 caddc co cfz co vk cv cG cfv vk csu cle wbr wi vm cv cn wcel cM cme
      wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co
      wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1
      vm cv c1 caddc co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv cM co c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1 caddc
      co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co caddc co c1 vm cv c1
      caddc co cfz co vk cv cG cfv vk csu letr vm cv cn wcel cM cme wcel wa vk
      cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral c1 cF
      cfv vm cv c1 caddc co c1 caddc co cF cfv cM co cr wcel vk cv cG cfv vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co
      wral cM cme wcel vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc
      co c1 caddc co cfz co wral c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv
      cM co cr wcel cM cme wcel vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv
      c1 caddc co c1 caddc co cfz co wral c1 cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv cM co cr wcel cM cme wcel c1 cF cfv cX wcel vm cv c1 caddc co
      c1 caddc co cF cfv cX wcel wa c1 cF cfv vm cv c1 caddc co c1 caddc co cF
      cfv cM co cr wcel vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc
      co c1 caddc co cfz co wral wa cM cme wcel c1 cF cfv cX wcel vm cv c1
      caddc co c1 caddc co cF cfv cX wcel c1 cF cfv vm cv c1 caddc co c1 caddc
      co cF cfv cM co cr wcel c1 cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM
      cX mettrifi.1 metcl 3expb vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv
      c1 caddc co c1 caddc co cfz co wral wa c1 cF cfv cX wcel vm cv c1 caddc
      co c1 caddc co cF cfv cX wcel c1 c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral
      c1 cF cfv cX wcel vm cv cn wcel vk cv cF cfv cX wcel c1 cF cfv cX wcel vk
      c1 c1 vm cv c1 caddc co c1 caddc co cfz co vk cv c1 wceq vk cv cF cfv c1
      cF cfv cX vk cv c1 cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc
      co c1 caddc co c1 cuz cfv wcel c1 c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel vm cv cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv c1 caddc
      co c1 caddc co c1 cuz cfv wcel vm cv cn wcel vm cv c1 caddc co cn wcel vm
      cv c1 caddc co c1 caddc co cn wcel vm cv peano2nn vm cv c1 caddc co
      peano2nn syl vm cv c1 caddc co c1 caddc co elnnuz sylib c1 vm cv c1 caddc
      co c1 caddc co eluzfz1 syl sylan vm cv c1 caddc co c1 caddc co c1 vm cv
      c1 caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vm cv c1 caddc co c1 caddc co cF cfv cX
      wcel vm cv cn wcel vk cv cF cfv cX wcel vm cv c1 caddc co c1 caddc co cF
      cfv cX wcel vk vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc co c1
      caddc co cfz co vk cv vm cv c1 caddc co c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co c1 caddc co cF cfv cX vk cv vm cv c1 caddc co c1 caddc co
      cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 caddc co c1
      cuz cfv wcel vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc co c1 caddc
      co cfz co wcel vm cv cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv
      c1 caddc co c1 caddc co c1 cuz cfv wcel vm cv cn wcel vm cv c1 caddc co
      cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv peano2nn vm cv c1
      caddc co peano2nn syl vm cv c1 caddc co c1 caddc co elnnuz sylib c1 vm cv
      c1 caddc co c1 caddc co eluzfz2 syl sylan jca sylan2 anassrs ancom1s
      adantrr c1 cF cfv vm cv c1 caddc co cF cfv cM co cr wcel vm cv c1 caddc
      co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co cr wcel c1 cF cfv vm
      cv c1 caddc co cF cfv cM co vm cv c1 caddc co cF cfv vm cv c1 caddc co c1
      caddc co cF cfv cM co caddc co cr wcel vm cv cn wcel cM cme wcel wa vk cv
      cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG
      cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc
      co cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM co vm cv c1
      caddc co cF cfv vm cv c1 caddc co c1 caddc co cF cfv cM co readdcl cM cme
      wcel c1 cF cfv cX wcel vm cv c1 caddc co cF cfv cX wcel c1 cF cfv vm cv
      c1 caddc co cF cfv cM co cr wcel vm cv cn wcel cM cme wcel wa vk cv cF
      cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv
      vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co
      cfz co wral wa wa c1 cF cfv vm cv c1 caddc co cF cfv cM cX mettrifi.1
      metcl vm cv cn wcel cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc
      co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa simplr vm cv cn
      wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral
      c1 cF cfv cX wcel cM cme wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral c1 c1 vm cv c1
      caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral c1 cF cfv cX wcel vm cv cn wcel vk cv cF
      cfv cX wcel c1 cF cfv cX wcel vk c1 c1 vm cv c1 caddc co c1 caddc co cfz
      co vk cv c1 wceq vk cv cF cfv c1 cF cfv cX vk cv c1 cF fveq2 eleq1d
      rcla4va vm cv cn wcel vm cv c1 caddc co c1 caddc co c1 cuz cfv wcel c1 c1
      vm cv c1 caddc co c1 caddc co cfz co wcel vm cv cn wcel vm cv c1 caddc co
      c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co c1 cuz cfv wcel vm cv
      cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co cn wcel
      vm cv peano2nn vm cv c1 caddc co peano2nn syl vm cv c1 caddc co c1 caddc
      co elnnuz sylib c1 vm cv c1 caddc co c1 caddc co eluzfz1 syl sylan
      ad2ant2r vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vm cv c1 caddc co cF cfv cX wcel cM cme wcel vk cv
      cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co
      cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz
      co wral vm cv c1 caddc co cF cfv cX wcel vm cv cn wcel vk cv cF cfv cX
      wcel vm cv c1 caddc co cF cfv cX wcel vk vm cv c1 caddc co c1 vm cv c1
      caddc co c1 caddc co cfz co vk cv vm cv c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co cF cfv cX vk cv vm cv c1 caddc co cF fveq2 eleq1d rcla4va
      vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co
      wcel c1 vm cv c1 caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co c1
      caddc co cle wbr wa vm cv cn wcel c1 vm cv c1 caddc co cle wbr vm cv c1
      caddc co vm cv c1 caddc co c1 caddc co cle wbr vm cv cn wcel vm cv c1
      caddc co cn wcel c1 vm cv c1 caddc co cle wbr vm cv peano2nn vm cv c1
      caddc co nnge1 syl vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc
      co cr wcel vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr vm cv
      peano2nn vm cv c1 caddc co nnre vm cv c1 caddc co lep1 3syl jca vm cv c1
      caddc co cz wcel c1 cz wcel vm cv c1 caddc co c1 caddc co cz wcel vm cv
      c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co wcel c1 vm cv c1
      caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr
      wa wb vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co
      elfz vm cv cn wcel vm cv vm cv nnz peano2zdi c1 cz wcel vm cv cn wcel 1z
      a1i vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co c1 caddc co
      cn wcel vm cv c1 caddc co c1 caddc co cz wcel vm cv peano2nn vm cv c1
      caddc co peano2nn vm cv c1 caddc co c1 caddc co nnz 3syl syl3anc mpbird
      sylan ad2ant2r syl3anc cM cme wcel vm cv c1 caddc co cF cfv cX wcel vm cv
      c1 caddc co c1 caddc co cF cfv cX wcel vm cv c1 caddc co cF cfv vm cv c1
      caddc co c1 caddc co cF cfv cM co cr wcel vm cv cn wcel cM cme wcel wa vk
      cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv
      cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1
      caddc co cfz co wral wa wa vm cv c1 caddc co cF cfv vm cv c1 caddc co c1
      caddc co cF cfv cM cX mettrifi.1 metcl vm cv cn wcel cM cme wcel vk cv cF
      cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv
      vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co
      cfz co wral wa simplr vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vm cv c1 caddc co cF cfv cX wcel cM cme
      wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk c1
      vm cv c1 caddc co cfz co wral vm cv c1 caddc co c1 vm cv c1 caddc co c1
      caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vm cv c1 caddc co cF cfv cX wcel vm cv cn wcel vk cv
      cF cfv cX wcel vm cv c1 caddc co cF cfv cX wcel vk vm cv c1 caddc co c1
      vm cv c1 caddc co c1 caddc co cfz co vk cv vm cv c1 caddc co wceq vk cv
      cF cfv vm cv c1 caddc co cF cfv cX vk cv vm cv c1 caddc co cF fveq2
      eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1
      caddc co cfz co wcel c1 vm cv c1 caddc co cle wbr vm cv c1 caddc co vm cv
      c1 caddc co c1 caddc co cle wbr wa vm cv cn wcel c1 vm cv c1 caddc co cle
      wbr vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr vm cv cn wcel
      vm cv c1 caddc co cn wcel c1 vm cv c1 caddc co cle wbr vm cv peano2nn vm
      cv c1 caddc co nnge1 syl vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1
      caddc co cr wcel vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle wbr
      vm cv peano2nn vm cv c1 caddc co nnre vm cv c1 caddc co lep1 3syl jca vm
      cv c1 caddc co cz wcel c1 cz wcel vm cv c1 caddc co c1 caddc co cz wcel
      vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co wcel c1 vm cv
      c1 caddc co cle wbr vm cv c1 caddc co vm cv c1 caddc co c1 caddc co cle
      wbr wa wb vm cv cn wcel vm cv c1 caddc co c1 vm cv c1 caddc co c1 caddc
      co elfz vm cv cn wcel vm cv vm cv nnz peano2zdi c1 cz wcel vm cv cn wcel
      1z a1i vm cv cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co c1 caddc
      co cn wcel vm cv c1 caddc co c1 caddc co cz wcel vm cv peano2nn vm cv c1
      caddc co peano2nn vm cv c1 caddc co c1 caddc co nnz 3syl syl3anc mpbird
      sylan ad2ant2r vm cv cn wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co
      c1 caddc co cfz co wral vm cv c1 caddc co c1 caddc co cF cfv cX wcel cM
      cme wcel vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq vk
      c1 vm cv c1 caddc co cfz co wral vm cv c1 caddc co c1 caddc co c1 vm cv
      c1 caddc co c1 caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1
      caddc co c1 caddc co cfz co wral vm cv c1 caddc co c1 caddc co cF cfv cX
      wcel vm cv cn wcel vk cv cF cfv cX wcel vm cv c1 caddc co c1 caddc co cF
      cfv cX wcel vk vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc co c1
      caddc co cfz co vk cv vm cv c1 caddc co c1 caddc co wceq vk cv cF cfv vm
      cv c1 caddc co c1 caddc co cF cfv cX vk cv vm cv c1 caddc co c1 caddc co
      cF fveq2 eleq1d rcla4va vm cv cn wcel vm cv c1 caddc co c1 caddc co c1
      cuz cfv wcel vm cv c1 caddc co c1 caddc co c1 vm cv c1 caddc co c1 caddc
      co cfz co wcel vm cv cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv
      c1 caddc co c1 caddc co c1 cuz cfv wcel vm cv cn wcel vm cv c1 caddc co
      cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv peano2nn vm cv c1
      caddc co peano2nn syl vm cv c1 caddc co c1 caddc co elnnuz sylib c1 vm cv
      c1 caddc co c1 caddc co eluzfz2 syl sylan ad2ant2r syl3anc sylanc vm cv
      c1 caddc co c1 cuz cfv wcel vk cv cG cfv cr wcel vk c1 vm cv c1 caddc co
      cfz co wral c1 vm cv c1 caddc co cfz co vk cv cG cfv vk csu cr wcel vm cv
      cn wcel cM cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co wceq vk c1 vm cv c1 caddc co cfz co wral wa wa vk cv cG cfv vk c1
      vm cv c1 caddc co fsumrecl vm cv cn wcel vm cv c1 caddc co c1 cuz cfv
      wcel cM cme wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co
      cfz co wral vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk c1 vm cv c1 caddc co cfz co wral wa vm cv cn wcel vm cv c1 caddc co cn
      wcel vm cv c1 caddc co c1 cuz cfv wcel vm cv peano2nn vm cv c1 caddc co
      elnnuz sylib ad2antrr vm cv cn wcel cM cme wcel wa vk cv cF cfv cX wcel
      vk c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cG cfv vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co wceq vk c1 vm cv c1 caddc co cfz co wral
      vk cv cG cfv cr wcel vk c1 vm cv c1 caddc co cfz co wral vm cv cn wcel cM
      cme wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz
      co wral wa vk cv cG cfv vk cv cF cfv vk cv c1 caddc co cF cfv cM co wceq
      vk cv cG cfv cr wcel vk c1 vm cv c1 caddc co cfz co vm cv cn wcel cM cme
      wcel wa vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co
      wral vk vm cv cn wcel cM cme wcel wa vk ax-17 vk cv cF cfv cX wcel vk c1
      vm cv c1 caddc co c1 caddc co cfz co hbra1 hban vk cv cG cfv vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co wceq vk cv cG cfv cr wcel vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co cr wcel vm cv cn wcel cM cme wcel wa vk cv cF
      cfv cX wcel vk c1 vm cv c1 caddc co c1 caddc co cfz co wral wa vk cv c1
      vm cv c1 caddc co cfz co wcel wa vk cv cG cfv vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cr eleq1 vm cv cn wcel cM cme wcel wa vk cv c1 vm cv c1
      caddc co cfz co wcel vk cv cF cfv cX wcel vk c1 vm cv c1 caddc co c1
      caddc co cfz co wral vk cv cF cfv vk cv c1 caddc co cF cfv cM co cr wcel
      vm cv cn wcel cM cme wcel wa vk cv c1 vm cv c1 caddc co cfz co wcel wa vj
      cv cF cfv cX wcel vj c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cr wcel vk cv cF cfv cX wcel vk c1
      vm cv c1 caddc co c1 caddc co cfz co wral cM cme wcel vk cv cF cfv cX
      wcel vk cv c1 caddc co cF cfv cX wcel vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cr wcel vm cv cn wcel cM cme wcel wa vk cv c1 vm cv c1 caddc co
      cfz co wcel wa vj cv cF cfv cX wcel vj c1 vm cv c1 caddc co c1 caddc co
      cfz co wral wa vk cv cF cfv vk cv c1 caddc co cF cfv cM cX mettrifi.1
      metcl vm cv cn wcel cM cme wcel vk cv c1 vm cv c1 caddc co cfz co wcel vj
      cv cF cfv cX wcel vj c1 vm cv c1 caddc co c1 caddc co cfz co wral simpllr
      vm cv cn wcel vk cv c1 vm cv c1 caddc co cfz co wcel vj cv cF cfv cX wcel
      vj c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cF cfv cX wcel cM
      cme wcel vk cv c1 vm cv c1 caddc co c1 caddc co cfz co wcel vj cv cF cfv
      cX wcel vj c1 vm cv c1 caddc co c1 caddc co cfz co wral vk cv cF cfv cX
      wcel vm cv cn wcel vk cv c1 vm cv c1 caddc co cfz co wcel wa vj cv cF cfv
      cX wcel vk cv cF cfv cX wcel vj vk cv c1 vm cv c1 caddc co c1 caddc co
      cfz co vj cv vk cv wceq vj cv cF cfv vk cv cF cfv cX vj cv vk cv cF fveq2
      eleq1d rcla4va c1 vm cv c1 caddc co cfz co c1 vm cv c1 caddc co c1 caddc
      co cfz co wss vk cv c1 vm cv c1 caddc co cfz co wcel vk cv c1 vm cv c1
      caddc co c1 caddc co cfz co wcel vm cv cn wcel c1 vm cv c1 caddc co cfz
      co c1 vm cv c1 caddc co c1 caddc co cfz co vk cv ssel2 c1 cz wcel vm cv
      c1 caddc co cz wcel c1 vm cv c1 caddc co cfz co c1 vm cv c1 caddc co c1
      caddc co cfz co wss vm cv cn wcel c1 vm cv c1 caddc co fzssp1 1z vm cv cn
      wcel vm cv vm cv nnz peano2zdi sylancr sylan sylan adantllr vm cv cn wcel
      vk cv c1 vm cv c1 caddc co cfz co wcel vj cv cF cfv cX wcel vj c1 vm cv
      c1 caddc co c1 caddc co cfz co wral vk cv c1 caddc co cF cfv cX wcel cM
      cme wcel vk cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co wcel
      vj cv cF cfv cX wcel vj c1 vm cv c1 caddc co c1 caddc co cfz co wral vk
      cv c1 caddc co cF cfv cX wcel vm cv cn wcel vk cv c1 vm cv c1 caddc co
      cfz co wcel wa vj cv cF cfv cX wcel vk cv c1 caddc co cF cfv cX wcel vj
      vk cv c1 caddc co c1 vm cv c1 caddc co c1 caddc co cfz co vj cv vk cv c1
      caddc co wceq vj cv cF cfv vk cv c1 caddc co cF cfv cX vj cv vk cv c1
      caddc co cF fveq2 eleq1d rcla4va vm cv cn wcel vk cv c1 vm cv c1 caddc co
      cfz co wcel wa c1 c1 caddc co vm cv c1 caddc co c1 caddc co cfz co c1 vm
      cv c1 caddc co c1 caddc co cfz co vk cv c1 caddc co vm cv cn wcel c1 c1
      caddc co vm cv c1 caddc co c1 caddc co cfz co c1 vm cv c1 caddc co c1
      caddc co cfz co wss vk cv c1 vm cv c1 caddc co cfz co wcel c1 cz wcel vm
      cv c1 caddc co c1 caddc co cz wcel c1 c1 caddc co vm cv c1 caddc co c1
      caddc co cfz co c1 vm cv c1 caddc co c1 caddc co cfz co wss vm cv cn wcel
      c1 vm cv c1 caddc co c1 caddc co fzp1ss 1z vm cv cn wcel vm cv c1 caddc
      co cn wcel vm cv c1 caddc co c1 caddc co cn wcel vm cv c1 caddc co c1
      caddc co cz wcel vm cv peano2nn vm cv c1 caddc co peano2nn vm cv c1 caddc
      co c1 caddc co nnz 3syl sylancr adantr vm cv cn wcel vk cv c1 vm cv c1
      caddc co cfz co wcel wa vk cv cz wcel vk cv c1 caddc co c1 c1 caddc co vm
      cv c1 caddc co c1 caddc co cfz co wcel vk cv c1 vm cv c1 caddc co cfz co
      wcel vk cv cz wcel vm cv cn wcel vk cv c1 vm cv c1 caddc co elfzelz
      adantl vm cv cn wcel vk cv c1 vm cv c1 caddc co cfz co wcel vk cv cz wcel
      vk cv c1 caddc co c1 c1 caddc co vm cv c1 caddc co c1 caddc co cfz co
      wcel wi vm cv cn wcel vk cv cz wcel vk cv c1 vm cv c1 caddc co cfz co
      wcel vk cv c1 caddc co c1 c1 caddc co vm cv c1 caddc co c1 caddc co cfz
      co wcel vm cv cn wcel vk cv cz wcel vk cv c1 vm cv c1 caddc co cfz co
      wcel vk cv c1 caddc co c1 c1 caddc co vm cv c1 caddc co c1 caddc co cfz
      co wcel wi vm cv cn wcel vk cv cz wcel wa vk cv c1 vm cv c1 caddc co cfz
      co wcel vk cv c1 caddc co c1 c1 caddc co vm cv c1 caddc co c1 caddc co
      cfz co wcel c1 cz wcel vm cv c1 caddc co cz wcel vk cv cz wcel c1 cz wcel
      vk cv c1 vm cv c1 caddc co cfz co wcel vk cv c1 caddc co c1 c1 caddc co
      vm cv c1 caddc co c1 caddc co cfz co wcel wb vm cv cn wcel vk cv cz wcel
      wa vk cv c1 c1 vm cv c1 caddc co fzaddel c1 cz wcel vm cv cn wcel vk cv
      cz wcel wa 1z a1i vm cv cn wcel vm cv c1 caddc co cz wcel vk cv cz wcel
      vm cv cn wcel vm cv vm cv nnz peano2zdi adantr vm cv cn wcel vk cv cz
      wcel pm3.27 c1 cz wcel vm cv cn wcel vk cv cz wcel wa 1z a1i syl2anc
      biimpd ex com23 imp mpd sseldd sylan adantllr syl3anc vk cv cF cfv cX
      wcel vj cv cF cfv cX wcel vk vj c1 vm cv c1 caddc co c1 caddc co cfz co
      vk cv vj cv wceq vk cv cF cfv vj cv cF cfv cX vk cv vj cv cF fveq2 eleq1d
      cbvralv sylan2b an1rs syl5cbir r19.20da impr sylanc syl3anc syld anasss
      ex a2d syld nnind imp anassrs ancom1s $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M f j k m z $. $d N f j k m z $. $d F f j k m z $. $d S f j k m z $.
    $d G f j k m z $. $d X f j k m z $. $d P f j k m z $.
    mettrifi2.1 $e |- X = dom dom M $.
    mettrifi2.2 $e |- S e. _V $.
    $( Generalized triangle inequality for arbitrary finite sums. $)
    mettrifi2 $p |- ( ( ( M e. Met /\ F : S --> X ) /\ ( N e. ZZ /\ P e.
      ( ZZ>= ` ( N + 1 ) ) /\ ( N ... P ) C_ S ) ) -> ( ( F ` N ) M ( F ` P ) )
        <_ sum_ k e. ( N ... ( P - 1 ) ) ( ( F ` k ) M ( F ` ( k + 1 ) ) ) ) $=
      cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss w3a wa c1 cF cN c1 cmin co cneg cshi co cfv cP cN cmin
      co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co c1 cP cN cmin co
      cfz co vk cv vj cv c1 cP cN cmin co cfz co wcel vz cv vj cv cF cN c1 cmin
      co cneg cshi co cfv vj cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv
      cM co wceq wa vj vz copab cfv vk csu cN cF cfv cP cF cfv cM co cN cP c1
      cmin co cfz co vk cv cF cfv vk cv c1 caddc co cF cfv cM co vk csu cle cM
      cme wcel cP cN cmin co cn wcel vk cv cF cN c1 cmin co cneg cshi co cfv cX
      wcel vk c1 cP cN cmin co c1 caddc co cfz co wral vk cv vj cv c1 cP cN
      cmin co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv
      c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab
      cfv vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1
      cmin co cneg cshi co cfv cM co wceq vk c1 cP cN cmin co cfz co wral c1 cF
      cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co cF cN c1 cmin co
      cneg cshi co cfv cM co c1 cP cN cmin co cfz co vk cv vj cv c1 cP cN cmin
      co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv c1
      caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab cfv
      vk csu cle wbr cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a wa vk cF cN c1 cmin co cneg cshi co
      vj cv c1 cP cN cmin co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi
      co cfv vj cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa
      vj vz copab cM cP cN cmin co cX mettrifi2.1 mettrifi cM cme wcel cS cX cF
      wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      simpll cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      cP cN cmin co cn wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1
      caddc co cuz cfv wcel cP cN cmin co cn wcel cN cP cfz co cS wss cN cz
      wcel cP cN c1 caddc co cuz cfv wcel wa cP cN cneg caddc co cN c1 caddc co
      cN cneg caddc co cuz cfv wcel cP cN cmin co cn wcel cP cN c1 caddc co cuz
      cfv wcel cN cz wcel cP cN cneg caddc co cN c1 caddc co cN cneg caddc co
      cuz cfv wcel cP cN c1 caddc co cuz cfv wcel cN cneg cz wcel cP cN cneg
      caddc co cN c1 caddc co cN cneg caddc co cuz cfv wcel cN cz wcel cN cneg
      cN c1 caddc co cP eluzadd cN znegcl sylan2 ancoms cN cz wcel cP cN c1
      caddc co cuz cfv wcel wa cP cN cneg caddc co cP cN cmin co cN c1 caddc co
      cN cneg caddc co cuz cfv cn cP cc wcel cN cc wcel cP cN cneg caddc co cP
      cN cmin co wceq cN cz wcel cP cN c1 caddc co cuz cfv wcel wa cP cN negsub
      cP cN c1 caddc co cuz cfv wcel cP cc wcel cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cP cz wcel cP cc wcel cN c1 caddc co cP eluzelz cP zcn syl
      adantl cN cz wcel cN cc wcel cP cN c1 caddc co cuz cfv wcel cN zcn adantr
      sylanc cN cz wcel cN c1 caddc co cN cneg caddc co cuz cfv cn wceq cP cN
      c1 caddc co cuz cfv wcel cN cz wcel cN c1 caddc co cN cneg caddc co cuz
      cfv c1 cuz cfv cn cN cz wcel cN c1 caddc co cN cneg caddc co c1 cuz cN cz
      wcel cN c1 caddc co cN cneg caddc co cN c1 caddc co cN cmin co c1 cN c1
      caddc co cc wcel cN cc wcel cN c1 caddc co cN cneg caddc co cN c1 caddc
      co cN cmin co wceq cN cz wcel cN c1 caddc co cN negsub cN cz wcel cN c1
      caddc co cz wcel cN c1 caddc co cc wcel cN peano2z cN c1 caddc co zcn syl
      cN zcn sylanc cN cc wcel c1 cc wcel cN c1 caddc co cN cmin co c1 wceq cN
      cz wcel cN c1 pncan2 cN zcn ax1cn sylancl eqtrd fveq2d nnuz syl6eqr
      adantr eleq12d mpbid 3adant3 adantl cM cme wcel cS cX cF wf wa cN cz wcel
      cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv cF cN c1
      cmin co cneg cshi co cfv cX wcel vk c1 cP cN cmin co c1 caddc co cfz co
      cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa
      vk cv cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co cF
      cfv cX cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co
      cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv cF cN c1
      cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co cF cfv wceq cM cme
      wcel cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co
      cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv cF cN c1
      cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co cF cfv wceq cS cX
      cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv cF cN c1 cmin co
      cneg cshi co cfv cN c1 cmin co vk cv caddc co cF cfv wceq cS cX cF wf cF
      cvv wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv cF cN c1 cmin
      co cneg cshi co cfv cN c1 cmin co vk cv caddc co cF cfv wceq wi cS cX cF
      wf cS cvv wcel cF cvv wcel mettrifi2.2 cS cX cvv cF fex mpan2 cN cz wcel
      cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN
      cmin co c1 caddc co cfz co wcel wa vk cv vf cv cN c1 cmin co cneg cshi co
      cfv cN c1 cmin co vk cv caddc co vf cv cfv wceq wi cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co c1
      caddc co cfz co wcel wa vk cv cF cN c1 cmin co cneg cshi co cfv cN c1
      cmin co vk cv caddc co cF cfv wceq wi vf cF cvv vf cv cF wceq vk cv vf cv
      cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co vf cv cfv
      wceq vk cv cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co
      cF cfv wceq cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vf cv cF wceq vk cv
      vf cv cN c1 cmin co cneg cshi co cfv vk cv cF cN c1 cmin co cneg cshi co
      cfv cN c1 cmin co vk cv caddc co vf cv cfv cN c1 cmin co vk cv caddc co
      cF cfv vf cv cF wceq vk cv vf cv cN c1 cmin co cneg cshi co cF cN c1 cmin
      co cneg cshi co vf cv cF cN c1 cmin co cneg cshi opreq1 fveq1d cN c1 cmin
      co vk cv caddc co vf cv cF fveq1 eqeq12d imbi2d cN c1 cmin co cc wcel vk
      cv cc wcel vk cv vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv
      caddc co vf cv cfv wceq cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN c1
      cmin co vk cv vf cv vf visset shftval4 cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN c1 cmin co cc wcel cN cP cfz co cS wss cN cc wcel c1 cc wcel
      cN c1 cmin co cc wcel cN cz wcel cN c1 subcl cN zcn ax1cn sylancl
      3ad2ant1 vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv c1 cuz cfv
      wcel vk cv cz wcel vk cv cc wcel vk cv c1 cP cN cmin co c1 caddc co
      elfzuz c1 vk cv eluzelz vk cv zcn 3syl syl2an vtoclg syl imp anassrs
      adantlll cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co
      wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel cM cme wcel cS cX cF wf
      wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa
      vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN c1 cmin co vk cv caddc
      co cN cP cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel cM cme
      wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz
      co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN c1
      cmin co vk cv caddc co cN cP cfz co wcel cM cme wcel cS cX cF wf wa cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1
      cP cN cmin co c1 caddc co cfz co wcel vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel cN c1 cmin co vk cv caddc co cN cP cfz co wcel wi cM cme wcel
      cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS
      wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv c1 cP
      cN cmin co c1 caddc co cfz co wcel vk cv cN c1 cmin co caddc co c1 cN c1
      cmin co caddc co cP cN cmin co c1 caddc co cN c1 cmin co caddc co cfz co
      wcel cN c1 cmin co vk cv caddc co cN cP cfz co wcel cM cme wcel cS cX cF
      wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv c1 cP cN cmin
      co c1 caddc co cfz co wcel vk cv cN c1 cmin co caddc co c1 cN c1 cmin co
      caddc co cP cN cmin co c1 caddc co cN c1 cmin co caddc co cfz co wcel c1
      cz wcel cP cN cmin co c1 caddc co cz wcel vk cv cz wcel cN c1 cmin co cz
      wcel vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv cN c1 cmin co
      caddc co c1 cN c1 cmin co caddc co cP cN cmin co c1 caddc co cN c1 cmin
      co caddc co cfz co wcel wb cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel wa vk cv cN c1 cmin co c1 cP cN cmin co c1 caddc
      co fzaddel c1 cz wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel wa 1z a1i cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a cP cN cmin co c1 caddc co cz wcel cM cme
      wcel cS cX cF wf wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a cP cN cmin co
      cP cz wcel cN cz wcel cP cN cmin co cz wcel cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a cP cN zsubcl cP cN c1 caddc co cuz
      cfv wcel cN cz wcel cP cz wcel cN cP cfz co cS wss cN c1 caddc co cP
      eluzelz 3ad2ant2 cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co
      cS wss 3simp1 sylanc peano2zdi ad2antlr vk cv c1 cP cN cmin co c1 caddc
      co cfz co wcel vk cv cz wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN
      c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin
      co c1 caddc co elfzelz adantl cN cz wcel cP cN c1 caddc co cuz cfv wcel
      cN cP cfz co cS wss w3a cN c1 cmin co cz wcel cM cme wcel cS cX cF wf wa
      vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN c1 cmin co cz wcel cN cP cfz co cS wss cN peano2zm
      3ad2ant1 ad2antlr syl2anc biimpd cM cme wcel cS cX cF wf wa cN cz wcel cP
      cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN
      cmin co c1 caddc co cfz co wcel wa vk cv cN c1 cmin co caddc co cN c1
      cmin co vk cv caddc co c1 cN c1 cmin co caddc co cP cN cmin co c1 caddc
      co cN c1 cmin co caddc co cfz co cN cP cfz co vk cv cc wcel cN c1 cmin co
      cc wcel vk cv cN c1 cmin co caddc co cN c1 cmin co vk cv caddc co wceq cM
      cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk
      cv cN c1 cmin co addcom vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk
      cv cc wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel vk cv c1 cuz cfv wcel vk cv cz wcel vk cv cc wcel vk cv c1 cP
      cN cmin co c1 caddc co elfzuz c1 vk cv eluzelz vk cv zcn 3syl adantl cN
      cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a cN c1 cmin
      co cc wcel cM cme wcel cS cX cF wf wa vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN c1 cmin co cc
      wcel cN cP cfz co cS wss cN cc wcel c1 cc wcel cN c1 cmin co cc wcel cN
      cz wcel cN c1 subcl cN zcn ax1cn sylancl 3ad2ant1 ad2antlr sylanc cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a c1 cN c1 cmin
      co caddc co cP cN cmin co c1 caddc co cN c1 cmin co caddc co cfz co cN cP
      cfz co wceq cM cme wcel cS cX cF wf wa vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a c1 cN c1 cmin co caddc co cN cP cN cmin co c1 caddc co cN c1 cmin co
      caddc co cP cfz c1 cc wcel cN cc wcel c1 cN c1 cmin co caddc co cN wceq
      cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a c1 cN
      pncan3 ax1cn cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cc wcel cN cP
      cfz co cS wss cN zcn 3ad2ant1 sylancr cN cc wcel cP cc wcel cP cN cmin co
      c1 caddc co cN c1 cmin co caddc co cP wceq cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a cN cc wcel cP cc wcel wa cP cN cmin
      co c1 caddc co cN c1 cmin co caddc co cN cP cN cmin co c1 caddc co c1
      cmin co caddc co cN cP cN cmin co caddc co cP cP cN cmin co c1 caddc co
      cc wcel cN cc wcel c1 cc wcel cP cN cmin co c1 caddc co cN c1 cmin co
      caddc co cN cP cN cmin co c1 caddc co c1 cmin co caddc co wceq cN cc wcel
      cP cc wcel wa cP cN cmin co c1 caddc co cN c1 addsub12 cP cN cmin co cc
      wcel c1 cc wcel cP cN cmin co c1 caddc co cc wcel cN cc wcel cP cc wcel
      wa cP cN cmin co c1 addcl cP cc wcel cN cc wcel cP cN cmin co cc wcel cP
      cN subcl ancoms ax1cn sylancl cN cc wcel cP cc wcel pm3.26 c1 cc wcel cN
      cc wcel cP cc wcel wa ax1cn a1i syl3anc cN cc wcel cP cc wcel wa cP cN
      cmin co c1 caddc co c1 cmin co cP cN cmin co cN caddc cP cN cmin co cc
      wcel c1 cc wcel cP cN cmin co c1 caddc co c1 cmin co cP cN cmin co wceq
      cN cc wcel cP cc wcel wa cP cN cmin co c1 pncan cP cc wcel cN cc wcel cP
      cN cmin co cc wcel cP cN subcl ancoms ax1cn sylancl opreq2d cN cP pncan3
      3eqtrd cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cc wcel cN cP cfz co
      cS wss cN zcn 3ad2ant1 cP cN c1 caddc co cuz cfv wcel cN cz wcel cP cc
      wcel cN cP cfz co cS wss cP cN c1 caddc co cuz cfv wcel cP cz wcel cP cc
      wcel cN c1 caddc co cP eluzelz cP zcn syl 3ad2ant2 sylanc opreq12d
      ad2antlr eleq12d sylibd ex pm2.43d cS cX cF wf cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN cP cfz co cS wss w3a cN c1 cmin co vk cv caddc co cN
      cP cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel wi cM cme wcel
      cS cX cF wf cN cz wcel cN cP cfz co cS wss cN c1 cmin co vk cv caddc co
      cN cP cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel wi cP cN c1
      caddc co cuz cfv wcel cS cX cF wf cN cP cfz co cS wss cN c1 cmin co vk cv
      caddc co cN cP cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel cS
      cX cF wf cN c1 cmin co vk cv caddc co cS wcel cN c1 cmin co vk cv caddc
      co cF cfv cX wcel cN cP cfz co cS wss cN c1 cmin co vk cv caddc co cN cP
      cfz co wcel wa cS cX cF wf cN c1 cmin co vk cv caddc co cS wcel cN c1
      cmin co vk cv caddc co cF cfv cX wcel cS cX cN c1 cmin co vk cv caddc co
      cF ffvelrn ex cN cP cfz co cS cN c1 cmin co vk cv caddc co ssel2 syl5
      expdimp 3ad2antr3 adantll syld imp eqeltrd r19.21aiva vk cv vj cv c1 cP
      cN cmin co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj
      cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz
      copab cfv vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN
      c1 cmin co cneg cshi co cfv cM co wceq vk c1 cP cN cmin co cfz co wral cM
      cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a wa vk cv vj cv c1 cP cN cmin co cfz co wcel vz cv vj cv
      cF cN c1 cmin co cneg cshi co cfv vj cv c1 caddc co cF cN c1 cmin co cneg
      cshi co cfv cM co wceq wa vj vz copab cfv vk cv cF cN c1 cmin co cneg
      cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co
      wceq vk c1 cP cN cmin co cfz co vj vz vk cv vj cv cF cN c1 cmin co cneg
      cshi co cfv vj cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co vk
      cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co
      cneg cshi co cfv cM co c1 cP cN cmin co cfz co vj cv c1 cP cN cmin co cfz
      co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv c1 caddc co
      cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab vj vk weq vj
      cv cF cN c1 cmin co cneg cshi co cfv vk cv cF cN c1 cmin co cneg cshi co
      cfv vj cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co
      cF cN c1 cmin co cneg cshi co cfv cM vj cv vk cv cF cN c1 cmin co cneg
      cshi co fveq2 vj vk weq vj cv c1 caddc co vk cv c1 caddc co cF cN c1 cmin
      co cneg cshi co vj cv vk cv c1 caddc opreq1 fveq2d opreq12d vj cv c1 cP
      cN cmin co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj
      cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz
      copab eqid vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF
      cN c1 cmin co cneg cshi co cfv cM oprex fvopab4 rgen a1i syl2anc cS cX cF
      wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a c1
      cF cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co cF cN c1 cmin
      co cneg cshi co cfv cM co cN cF cfv cP cF cfv cM co wceq cM cme wcel cS
      cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a c1 cF cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co cF cN
      c1 cmin co cneg cshi co cfv cM co cN cF cfv cP cF cfv cM co wceq cS cX cF
      wf cF cvv wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS
      wss w3a c1 cF cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co cF
      cN c1 cmin co cneg cshi co cfv cM co cN cF cfv cP cF cfv cM co wceq wi cS
      cX cF wf cS cvv wcel cF cvv wcel mettrifi2.2 cS cX cvv cF fex mpan2 cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a c1 vf cv cN
      c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co vf cv cN c1 cmin co
      cneg cshi co cfv cM co cN vf cv cfv cP vf cv cfv cM co wceq wi cN cz wcel
      cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a c1 cF cN c1 cmin
      co cneg cshi co cfv cP cN cmin co c1 caddc co cF cN c1 cmin co cneg cshi
      co cfv cM co cN cF cfv cP cF cfv cM co wceq wi vf cF cvv vf cv cF wceq c1
      vf cv cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co vf cv cN
      c1 cmin co cneg cshi co cfv cM co cN vf cv cfv cP vf cv cfv cM co wceq c1
      cF cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co cF cN c1 cmin
      co cneg cshi co cfv cM co cN cF cfv cP cF cfv cM co wceq cN cz wcel cP cN
      c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vf cv cF wceq c1 vf cv
      cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co vf cv cN c1 cmin
      co cneg cshi co cfv cM co c1 cF cN c1 cmin co cneg cshi co cfv cP cN cmin
      co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co cN vf cv cfv cP vf
      cv cfv cM co cN cF cfv cP cF cfv cM co vf cv cF wceq c1 vf cv cN c1 cmin
      co cneg cshi co cfv c1 cF cN c1 cmin co cneg cshi co cfv cP cN cmin co c1
      caddc co vf cv cN c1 cmin co cneg cshi co cfv cP cN cmin co c1 caddc co
      cF cN c1 cmin co cneg cshi co cfv cM vf cv cF wceq c1 vf cv cN c1 cmin co
      cneg cshi co cF cN c1 cmin co cneg cshi co vf cv cF cN c1 cmin co cneg
      cshi opreq1 fveq1d vf cv cF wceq cP cN cmin co c1 caddc co vf cv cN c1
      cmin co cneg cshi co cF cN c1 cmin co cneg cshi co vf cv cF cN c1 cmin co
      cneg cshi opreq1 fveq1d opreq12d vf cv cF wceq cN vf cv cfv cN cF cfv cP
      vf cv cfv cP cF cfv cM cN vf cv cF fveq1 cP vf cv cF fveq1 opreq12d
      eqeq12d imbi2d cN cc wcel cP cc wcel c1 vf cv cN c1 cmin co cneg cshi co
      cfv cP cN cmin co c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cM co
      cN vf cv cfv cP vf cv cfv cM co wceq cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a cN cc wcel cP cc wcel wa c1 vf cv cN c1 cmin
      co cneg cshi co cfv cN vf cv cfv cP cN cmin co c1 caddc co vf cv cN c1
      cmin co cneg cshi co cfv cP vf cv cfv cM cN cc wcel cP cc wcel wa c1 vf
      cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co c1 caddc co vf cv cfv cN
      vf cv cfv cN c1 cmin co cc wcel c1 cc wcel c1 vf cv cN c1 cmin co cneg
      cshi co cfv cN c1 cmin co c1 caddc co vf cv cfv wceq cN cc wcel cP cc
      wcel wa cN c1 cmin co c1 vf cv vf visset shftval4 cN cc wcel cN c1 cmin
      co cc wcel cP cc wcel cN cc wcel c1 cc wcel cN c1 cmin co cc wcel ax1cn
      cN c1 subcl mpan2 adantr ax1cn sylancl cN cc wcel cP cc wcel wa cN c1
      cmin co c1 caddc co cN vf cv cN cc wcel c1 cc wcel cN c1 cmin co c1 caddc
      co cN wceq cP cc wcel cN c1 npcan c1 cc wcel cP cc wcel ax1cn a1i sylan2
      fveq2d eqtrd cN cc wcel cP cc wcel wa cP cN cmin co c1 caddc co vf cv cN
      c1 cmin co cneg cshi co cfv cN c1 cmin co cP cN cmin co c1 caddc co caddc
      co vf cv cfv cP vf cv cfv cN c1 cmin co cc wcel cP cN cmin co c1 caddc co
      cc wcel cP cN cmin co c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cN
      c1 cmin co cP cN cmin co c1 caddc co caddc co vf cv cfv wceq cN cc wcel
      cP cc wcel wa cN c1 cmin co cP cN cmin co c1 caddc co vf cv vf visset
      shftval4 cN cc wcel cN c1 cmin co cc wcel cP cc wcel cN cc wcel c1 cc
      wcel cN c1 cmin co cc wcel ax1cn cN c1 subcl mpan2 adantr cP cN cmin co
      cc wcel c1 cc wcel cP cN cmin co c1 caddc co cc wcel cN cc wcel cP cc
      wcel wa cP cN cmin co c1 addcl cP cc wcel cN cc wcel cP cN cmin co cc
      wcel cP cN subcl ancoms ax1cn sylancl sylanc cN cc wcel cP cc wcel wa cN
      c1 cmin co cP cN cmin co c1 caddc co caddc co cP vf cv cN cc wcel cP cc
      wcel wa cN c1 cmin co cP cN cmin co c1 caddc co caddc co cN cP cN cmin co
      c1 caddc co c1 cmin co caddc co cN cP cN cmin co caddc co cP cN cc wcel
      c1 cc wcel cP cN cmin co c1 caddc co cc wcel cN c1 cmin co cP cN cmin co
      c1 caddc co caddc co cN cP cN cmin co c1 caddc co c1 cmin co caddc co
      wceq cN cc wcel cP cc wcel wa cN c1 cP cN cmin co c1 caddc co subadd23 cN
      cc wcel cP cc wcel pm3.26 c1 cc wcel cN cc wcel cP cc wcel wa ax1cn a1i
      cP cN cmin co cc wcel c1 cc wcel cP cN cmin co c1 caddc co cc wcel cN cc
      wcel cP cc wcel wa cP cN cmin co c1 addcl cP cc wcel cN cc wcel cP cN
      cmin co cc wcel cP cN subcl ancoms ax1cn sylancl syl3anc cN cc wcel cP cc
      wcel wa cP cN cmin co c1 caddc co c1 cmin co cP cN cmin co cN caddc cP cN
      cmin co cc wcel c1 cc wcel cP cN cmin co c1 caddc co c1 cmin co cP cN
      cmin co wceq cN cc wcel cP cc wcel wa cP cN cmin co c1 pncan cP cc wcel
      cN cc wcel cP cN cmin co cc wcel cP cN subcl ancoms ax1cn sylancl opreq2d
      cN cP pncan3 3eqtrd fveq2d eqtrd opreq12d cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cc wcel cN cP cfz co cS wss cN zcn 3ad2ant1 cP cN c1
      caddc co cuz cfv wcel cN cz wcel cP cc wcel cN cP cfz co cS wss cP cN c1
      caddc co cuz cfv wcel cP cz wcel cP cc wcel cN c1 caddc co cP eluzelz cP
      zcn syl 3ad2ant2 sylanc vtoclg syl imp adantll cM cme wcel cS cX cF wf wa
      cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa c1
      cP cN cmin co cfz co vk cv vj cv c1 cP cN cmin co cfz co wcel vz cv vj cv
      cF cN c1 cmin co cneg cshi co cfv vj cv c1 caddc co cF cN c1 cmin co cneg
      cshi co cfv cM co wceq wa vj vz copab cfv vk csu c1 cP cN cmin co cfz co
      vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin
      co cneg cshi co cfv cM co vk csu c1 cN c1 cmin co caddc co cP cN cmin co
      cN c1 cmin co caddc co cfz co vk vj cv cN c1 cmin co cmin co vk cv cF cN
      c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi
      co cfv cM co csb vj csu cN cP c1 cmin co cfz co vk cv cF cfv vk cv c1
      caddc co cF cfv cM co vk csu c1 cP cN cmin co cfz co vk cv vj cv c1 cP cN
      cmin co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv
      c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab
      cfv vk csu c1 cP cN cmin co cfz co vk cv cF cN c1 cmin co cneg cshi co
      cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co vk csu wceq
      cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss w3a wa c1 cP cN cmin co cfz co vk cv vj cv c1 cP cN cmin
      co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv c1
      caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab cfv
      vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin
      co cneg cshi co cfv cM co vk vj vz vk cv vj cv cF cN c1 cmin co cneg cshi
      co cfv vj cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co vk cv cF
      cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg
      cshi co cfv cM co c1 cP cN cmin co cfz co vj cv c1 cP cN cmin co cfz co
      wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv c1 caddc co cF
      cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab vj vk weq vj cv
      cF cN c1 cmin co cneg cshi co cfv vk cv cF cN c1 cmin co cneg cshi co cfv
      vj cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF
      cN c1 cmin co cneg cshi co cfv cM vj cv vk cv cF cN c1 cmin co cneg cshi
      co fveq2 vj vk weq vj cv c1 caddc co vk cv c1 caddc co cF cN c1 cmin co
      cneg cshi co vj cv vk cv c1 caddc opreq1 fveq2d opreq12d vj cv c1 cP cN
      cmin co cfz co wcel vz cv vj cv cF cN c1 cmin co cneg cshi co cfv vj cv
      c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wceq wa vj vz copab
      eqid vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1
      cmin co cneg cshi co cfv cM oprex fvopab4 sumeq2i a1i cP cN cmin co c1
      cuz cfv wcel cN c1 cmin co cz wcel vk cv cF cN c1 cmin co cneg cshi co
      cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co cc wcel vk
      c1 cP cN cmin co cfz co wral c1 cP cN cmin co cfz co vk cv cF cN c1 cmin
      co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv
      cM co vk csu c1 cN c1 cmin co caddc co cP cN cmin co cN c1 cmin co caddc
      co cfz co vk vj cv cN c1 cmin co cmin co vk cv cF cN c1 cmin co cneg cshi
      co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co csb vj
      csu wceq cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a wa vk cv cF cN c1 cmin co cneg cshi co cfv
      vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co vk vj cN c1
      cmin co c1 cP cN cmin co fsumshft cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a cP cN cmin co c1 cuz cfv wcel cM cme wcel cS
      cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cP cN cmin co c1
      cuz cfv wcel cN cP cfz co cS wss cN cz wcel cP cN c1 caddc co cuz cfv
      wcel wa cP cN cmin co cn c1 cuz cfv cN cz wcel cP cN c1 caddc co cuz cfv
      wcel wa cP cN cneg caddc co cN c1 caddc co cN cneg caddc co cuz cfv wcel
      cP cN cmin co cn wcel cP cN c1 caddc co cuz cfv wcel cN cz wcel cP cN
      cneg caddc co cN c1 caddc co cN cneg caddc co cuz cfv wcel cP cN c1 caddc
      co cuz cfv wcel cN cneg cz wcel cP cN cneg caddc co cN c1 caddc co cN
      cneg caddc co cuz cfv wcel cN cz wcel cN cneg cN c1 caddc co cP eluzadd
      cN znegcl sylan2 ancoms cN cz wcel cP cN c1 caddc co cuz cfv wcel wa cP
      cN cneg caddc co cP cN cmin co cN c1 caddc co cN cneg caddc co cuz cfv cn
      cP cc wcel cN cc wcel cP cN cneg caddc co cP cN cmin co wceq cN cz wcel
      cP cN c1 caddc co cuz cfv wcel wa cP cN negsub cP cN c1 caddc co cuz cfv
      wcel cP cc wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cP cz wcel cP
      cc wcel cN c1 caddc co cP eluzelz cP zcn syl adantl cN cz wcel cN cc wcel
      cP cN c1 caddc co cuz cfv wcel cN zcn adantr sylanc cN cz wcel cN c1
      caddc co cN cneg caddc co cuz cfv cn wceq cP cN c1 caddc co cuz cfv wcel
      cN cz wcel cN c1 caddc co cN cneg caddc co cuz cfv c1 cuz cfv cn cN cz
      wcel cN c1 caddc co cN cneg caddc co c1 cuz cN cz wcel cN c1 caddc co cN
      cneg caddc co cN c1 caddc co cN cmin co c1 cN c1 caddc co cc wcel cN cc
      wcel cN c1 caddc co cN cneg caddc co cN c1 caddc co cN cmin co wceq cN cz
      wcel cN c1 caddc co cN negsub cN cz wcel cN c1 caddc co cz wcel cN c1
      caddc co cc wcel cN peano2z cN c1 caddc co zcn syl cN zcn sylanc cN cc
      wcel c1 cc wcel cN c1 caddc co cN cmin co c1 wceq cN cz wcel cN c1 pncan2
      cN zcn ax1cn sylancl eqtrd fveq2d nnuz syl6eqr adantr eleq12d mpbid nnuz
      syl6eleq 3adant3 adantl cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a cN c1 cmin co cz wcel cM cme wcel cS cX cF wf wa cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN c1 cmin co cz wcel cN cP cfz co cS
      wss cN peano2zm 3ad2ant1 adantl cM cme wcel cS cX cF wf wa cN cz wcel cP
      cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv cF cN c1
      cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co
      cfv cM co cc wcel vk c1 cP cN cmin co cfz co cM cme wcel cS cX cF wf wa
      cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk
      cv c1 cP cN cmin co cfz co wcel wa vk cv cF cN c1 cmin co cneg cshi co
      cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co cM cme wcel
      vk cv cF cN c1 cmin co cneg cshi co cfv cX wcel vk cv c1 caddc co cF cN
      c1 cmin co cneg cshi co cfv cX wcel vk cv cF cN c1 cmin co cneg cshi co
      cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co cr wcel cM
      cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a wa vk cv c1 cP cN cmin co cfz co wcel wa vk cv cF cN c1
      cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co
      cfv cM cX mettrifi2.1 metcl cM cme wcel cS cX cF wf cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz
      co wcel simplll cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc
      co cfz co wcel vk cv cF cN c1 cmin co cneg cshi co cfv cX wcel vk cv c1
      cP cN cmin co cfz co wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel wa vk cv cF cN c1 cmin co cneg cshi co cfv cN c1
      cmin co vk cv caddc co cF cfv cX cS cX cF wf cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel vk cv cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv
      caddc co cF cfv wceq cM cme wcel cS cX cF wf cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel vk cv cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv
      caddc co cF cfv wceq cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz co
      wcel wa vk cv cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc
      co cF cfv wceq cS cX cF wf cF cvv wcel cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz
      co wcel wa vk cv cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv
      caddc co cF cfv wceq wi cS cX cF wf cS cvv wcel cF cvv wcel mettrifi2.2
      cS cX cvv cF fex mpan2 cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv
      vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co vf cv
      cfv wceq wi cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv cF cN c1 cmin
      co cneg cshi co cfv cN c1 cmin co vk cv caddc co cF cfv wceq wi vf cF cvv
      vf cv cF wceq vk cv vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk
      cv caddc co vf cv cfv wceq vk cv cF cN c1 cmin co cneg cshi co cfv cN c1
      cmin co vk cv caddc co cF cfv wceq cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co c1 caddc co cfz co
      wcel wa vf cv cF wceq vk cv vf cv cN c1 cmin co cneg cshi co cfv vk cv cF
      cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv caddc co vf cv cfv cN
      c1 cmin co vk cv caddc co cF cfv vf cv cF wceq vk cv vf cv cN c1 cmin co
      cneg cshi co cF cN c1 cmin co cneg cshi co vf cv cF cN c1 cmin co cneg
      cshi opreq1 fveq1d cN c1 cmin co vk cv caddc co vf cv cF fveq1 eqeq12d
      imbi2d cN c1 cmin co cc wcel vk cv cc wcel vk cv vf cv cN c1 cmin co cneg
      cshi co cfv cN c1 cmin co vk cv caddc co vf cv cfv wceq cN cz wcel cP cN
      c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel cN c1 cmin co vk cv vf cv vf visset shftval4 cN
      cz wcel cP cN c1 caddc co cuz cfv wcel cN c1 cmin co cc wcel cN cP cfz co
      cS wss cN cc wcel c1 cc wcel cN c1 cmin co cc wcel cN cz wcel cN c1 subcl
      cN zcn ax1cn sylancl 3ad2ant1 vk cv c1 cP cN cmin co c1 caddc co cfz co
      wcel vk cv c1 cuz cfv wcel vk cv cz wcel vk cv cc wcel vk cv c1 cP cN
      cmin co c1 caddc co elfzuz c1 vk cv eluzelz vk cv zcn 3syl syl2an vtoclg
      syl imp anassrs adantlll cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel cM
      cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN c1
      cmin co vk cv caddc co cN cP cfz co wcel cN c1 cmin co vk cv caddc co cF
      cfv cX wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co
      cfz co wcel cN c1 cmin co vk cv caddc co cN cP cfz co wcel cM cme wcel cS
      cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv c1 cP cN cmin
      co c1 caddc co cfz co wcel cN c1 cmin co vk cv caddc co cN cP cfz co wcel
      wi cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel
      cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel
      wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv cN c1 cmin co
      caddc co c1 cN c1 cmin co caddc co cP cN cmin co c1 caddc co cN c1 cmin
      co caddc co cfz co wcel cN c1 cmin co vk cv caddc co cN cP cfz co wcel cM
      cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk
      cv c1 cP cN cmin co c1 caddc co cfz co wcel vk cv cN c1 cmin co caddc co
      c1 cN c1 cmin co caddc co cP cN cmin co c1 caddc co cN c1 cmin co caddc
      co cfz co wcel c1 cz wcel cP cN cmin co c1 caddc co cz wcel vk cv cz wcel
      cN c1 cmin co cz wcel vk cv c1 cP cN cmin co c1 caddc co cfz co wcel vk
      cv cN c1 cmin co caddc co c1 cN c1 cmin co caddc co cP cN cmin co c1
      caddc co cN c1 cmin co caddc co cfz co wcel wb cM cme wcel cS cX cF wf wa
      cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk
      cv c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv cN c1 cmin co c1 cP
      cN cmin co c1 caddc co fzaddel c1 cz wcel cM cme wcel cS cX cF wf wa cN
      cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv
      c1 cP cN cmin co c1 caddc co cfz co wcel wa 1z a1i cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a cP cN cmin co c1 caddc co
      cz wcel cM cme wcel cS cX cF wf wa vk cv c1 cP cN cmin co c1 caddc co cfz
      co wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      cP cN cmin co cP cz wcel cN cz wcel cP cN cmin co cz wcel cN cz wcel cP
      cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a cP cN zsubcl cP cN c1
      caddc co cuz cfv wcel cN cz wcel cP cz wcel cN cP cfz co cS wss cN c1
      caddc co cP eluzelz 3ad2ant2 cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss 3simp1 sylanc peano2zdi ad2antlr vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel vk cv cz wcel cM cme wcel cS cX cF wf wa cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1
      cP cN cmin co c1 caddc co elfzelz adantl cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a cN c1 cmin co cz wcel cM cme wcel cS cX
      cF wf wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel cN cz wcel cP cN
      c1 caddc co cuz cfv wcel cN c1 cmin co cz wcel cN cP cfz co cS wss cN
      peano2zm 3ad2ant1 ad2antlr syl2anc biimpd cM cme wcel cS cX cF wf wa cN
      cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv
      c1 cP cN cmin co c1 caddc co cfz co wcel wa vk cv cN c1 cmin co caddc co
      cN c1 cmin co vk cv caddc co c1 cN c1 cmin co caddc co cP cN cmin co c1
      caddc co cN c1 cmin co caddc co cfz co cN cP cfz co vk cv cc wcel cN c1
      cmin co cc wcel vk cv cN c1 cmin co caddc co cN c1 cmin co vk cv caddc co
      wceq cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel
      cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1 caddc co cfz co wcel
      wa vk cv cN c1 cmin co addcom vk cv c1 cP cN cmin co c1 caddc co cfz co
      wcel vk cv cc wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co c1
      caddc co cfz co wcel vk cv c1 cuz cfv wcel vk cv cz wcel vk cv cc wcel vk
      cv c1 cP cN cmin co c1 caddc co elfzuz c1 vk cv eluzelz vk cv zcn 3syl
      adantl cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      cN c1 cmin co cc wcel cM cme wcel cS cX cF wf wa vk cv c1 cP cN cmin co
      c1 caddc co cfz co wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN c1
      cmin co cc wcel cN cP cfz co cS wss cN cc wcel c1 cc wcel cN c1 cmin co
      cc wcel cN cz wcel cN c1 subcl cN zcn ax1cn sylancl 3ad2ant1 ad2antlr
      sylanc cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a
      c1 cN c1 cmin co caddc co cP cN cmin co c1 caddc co cN c1 cmin co caddc
      co cfz co cN cP cfz co wceq cM cme wcel cS cX cF wf wa vk cv c1 cP cN
      cmin co c1 caddc co cfz co wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel
      cN cP cfz co cS wss w3a c1 cN c1 cmin co caddc co cN cP cN cmin co c1
      caddc co cN c1 cmin co caddc co cP cfz c1 cc wcel cN cc wcel c1 cN c1
      cmin co caddc co cN wceq cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a c1 cN pncan3 ax1cn cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cc wcel cN cP cfz co cS wss cN zcn 3ad2ant1 sylancr cN cc wcel cP
      cc wcel cP cN cmin co c1 caddc co cN c1 cmin co caddc co cP wceq cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a cN cc wcel cP
      cc wcel wa cP cN cmin co c1 caddc co cN c1 cmin co caddc co cN cP cN cmin
      co c1 caddc co c1 cmin co caddc co cN cP cN cmin co caddc co cP cP cN
      cmin co c1 caddc co cc wcel cN cc wcel c1 cc wcel cP cN cmin co c1 caddc
      co cN c1 cmin co caddc co cN cP cN cmin co c1 caddc co c1 cmin co caddc
      co wceq cN cc wcel cP cc wcel wa cP cN cmin co c1 caddc co cN c1 addsub12
      cP cN cmin co cc wcel c1 cc wcel cP cN cmin co c1 caddc co cc wcel cN cc
      wcel cP cc wcel wa cP cN cmin co c1 addcl cP cc wcel cN cc wcel cP cN
      cmin co cc wcel cP cN subcl ancoms ax1cn sylancl cN cc wcel cP cc wcel
      pm3.26 c1 cc wcel cN cc wcel cP cc wcel wa ax1cn a1i syl3anc cN cc wcel
      cP cc wcel wa cP cN cmin co c1 caddc co c1 cmin co cP cN cmin co cN caddc
      cP cN cmin co cc wcel c1 cc wcel cP cN cmin co c1 caddc co c1 cmin co cP
      cN cmin co wceq cN cc wcel cP cc wcel wa cP cN cmin co c1 pncan cP cc
      wcel cN cc wcel cP cN cmin co cc wcel cP cN subcl ancoms ax1cn sylancl
      opreq2d cN cP pncan3 3eqtrd cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cc wcel cN cP cfz co cS wss cN zcn 3ad2ant1 cP cN c1 caddc co cuz cfv
      wcel cN cz wcel cP cc wcel cN cP cfz co cS wss cP cN c1 caddc co cuz cfv
      wcel cP cz wcel cP cc wcel cN c1 caddc co cP eluzelz cP zcn syl 3ad2ant2
      sylanc opreq12d ad2antlr eleq12d sylibd ex pm2.43d cS cX cF wf cN cz wcel
      cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a cN c1 cmin co vk
      cv caddc co cN cP cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel
      wi cM cme wcel cS cX cF wf cN cz wcel cN cP cfz co cS wss cN c1 cmin co
      vk cv caddc co cN cP cfz co wcel cN c1 cmin co vk cv caddc co cF cfv cX
      wcel wi cP cN c1 caddc co cuz cfv wcel cS cX cF wf cN cP cfz co cS wss cN
      c1 cmin co vk cv caddc co cN cP cfz co wcel cN c1 cmin co vk cv caddc co
      cF cfv cX wcel cS cX cF wf cN c1 cmin co vk cv caddc co cS wcel cN c1
      cmin co vk cv caddc co cF cfv cX wcel cN cP cfz co cS wss cN c1 cmin co
      vk cv caddc co cN cP cfz co wcel wa cS cX cF wf cN c1 cmin co vk cv caddc
      co cS wcel cN c1 cmin co vk cv caddc co cF cfv cX wcel cS cX cN c1 cmin
      co vk cv caddc co cF ffvelrn ex cN cP cfz co cS cN c1 cmin co vk cv caddc
      co ssel2 syl5 expdimp 3ad2antr3 adantll syld imp eqeltrd vk cv c1 cP cN
      cmin co cP cN cmin oprex fzelp1i sylan2 cM cme wcel cS cX cF wf wa cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1
      cP cN cmin co cfz co wcel wa vk cv c1 caddc co cF cN c1 cmin co cneg cshi
      co cfv vk cv cN caddc co cF cfv cX cM cme wcel cS cX cF wf wa cN cz wcel
      cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN
      cmin co cfz co wcel wa vk cv c1 caddc co cF cN c1 cmin co cneg cshi co
      cfv cN c1 cmin co vk cv c1 caddc co caddc co cF cfv vk cv cN caddc co cF
      cfv cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS
      wss w3a vk cv c1 cP cN cmin co cfz co wcel vk cv c1 caddc co cF cN c1
      cmin co cneg cshi co cfv cN c1 cmin co vk cv c1 caddc co caddc co cF cfv
      wceq cM cme wcel cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel vk cv c1 caddc co
      cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv c1 caddc co caddc
      co cF cfv wceq cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel wa vk cv c1 caddc
      co cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv c1 caddc co
      caddc co cF cfv wceq cS cX cF wf cF cvv wcel cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel
      wa vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk
      cv c1 caddc co caddc co cF cfv wceq wi cS cX cF wf cS cvv wcel cF cvv
      wcel mettrifi2.2 cS cX cvv cF fex mpan2 cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel wa vk
      cv c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv
      c1 caddc co caddc co vf cv cfv wceq wi cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel wa vk
      cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv c1
      caddc co caddc co cF cfv wceq wi vf cF cvv vf cv cF wceq vk cv c1 caddc
      co vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv c1 caddc co
      caddc co vf cv cfv wceq vk cv c1 caddc co cF cN c1 cmin co cneg cshi co
      cfv cN c1 cmin co vk cv c1 caddc co caddc co cF cfv wceq cN cz wcel cP cN
      c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co
      cfz co wcel wa vf cv cF wceq vk cv c1 caddc co vf cv cN c1 cmin co cneg
      cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cN c1
      cmin co vk cv c1 caddc co caddc co vf cv cfv cN c1 cmin co vk cv c1 caddc
      co caddc co cF cfv vf cv cF wceq vk cv c1 caddc co vf cv cN c1 cmin co
      cneg cshi co cF cN c1 cmin co cneg cshi co vf cv cF cN c1 cmin co cneg
      cshi opreq1 fveq1d cN c1 cmin co vk cv c1 caddc co caddc co vf cv cF
      fveq1 eqeq12d imbi2d cN c1 cmin co cc wcel vk cv c1 caddc co cc wcel vk
      cv c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vk cv
      c1 caddc co caddc co vf cv cfv wceq cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel cN c1
      cmin co vk cv c1 caddc co vf cv vf visset shftval4 cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN c1 cmin co cc wcel cN cP cfz co cS wss cN cc
      wcel c1 cc wcel cN c1 cmin co cc wcel cN cz wcel cN c1 subcl cN zcn ax1cn
      sylancl 3ad2ant1 vk cv c1 cP cN cmin co cfz co wcel vk cv c1 cuz cfv wcel
      vk cv cz wcel vk cv c1 caddc co cc wcel vk cv c1 cP cN cmin co elfzuz c1
      vk cv eluzelz vk cv cz wcel vk cv c1 caddc co cz wcel vk cv c1 caddc co
      cc wcel vk cv peano2z vk cv c1 caddc co zcn syl 3syl syl2an vtoclg syl
      imp anassrs adantlll cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz
      co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel cN c1 cmin co vk cv c1
      caddc co caddc co cF cfv vk cv cN caddc co cF cfv wceq cM cme wcel cS cX
      cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss
      w3a vk cv c1 cP cN cmin co cfz co wcel wa cN c1 cmin co vk cv c1 caddc co
      caddc co vk cv cN caddc co cF cN cc wcel vk cv cc wcel cN c1 cmin co vk
      cv c1 caddc co caddc co vk cv cN caddc co wceq cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co
      wcel cN cc wcel vk cv cc wcel wa cN c1 cmin co vk cv c1 caddc co caddc co
      cN vk cv c1 caddc co c1 cmin co caddc co cN vk cv caddc co vk cv cN caddc
      co cN cc wcel c1 cc wcel vk cv c1 caddc co cc wcel cN c1 cmin co vk cv c1
      caddc co caddc co cN vk cv c1 caddc co c1 cmin co caddc co wceq cN cc
      wcel vk cv cc wcel wa cN c1 vk cv c1 caddc co subadd23 cN cc wcel vk cv
      cc wcel pm3.26 c1 cc wcel cN cc wcel vk cv cc wcel wa ax1cn a1i vk cv cc
      wcel vk cv c1 caddc co cc wcel cN cc wcel vk cv peano2cn adantl syl3anc
      cN cc wcel vk cv cc wcel wa vk cv c1 caddc co c1 cmin co vk cv cN caddc
      vk cv cc wcel c1 cc wcel vk cv c1 caddc co c1 cmin co vk cv wceq cN cc
      wcel vk cv cc wcel wa vk cv c1 pncan cN cc wcel vk cv cc wcel pm3.27
      ax1cn sylancl opreq2d cN vk cv addcom 3eqtrd cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cc wcel cN cP cfz co cS wss cN zcn 3ad2ant1 vk cv c1 cP
      cN cmin co cfz co wcel vk cv c1 cuz cfv wcel vk cv cz wcel vk cv cc wcel
      vk cv c1 cP cN cmin co elfzuz c1 vk cv eluzelz vk cv zcn 3syl syl2an
      fveq2d adantll eqtrd cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co cfz co
      wcel wa vk cv c1 cP cN cmin co cfz co wcel vk cv cN caddc co cF cfv cX
      wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel
      cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co cfz co wcel pm3.27 cM
      cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP
      cfz co cS wss w3a wa vk cv c1 cP cN cmin co cfz co wcel wa vk cv c1 cP cN
      cmin co cfz co wcel vk cv cN caddc co cN cP cfz co wcel vk cv cN caddc co
      cF cfv cX wcel cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a wa vk cv c1 cP cN cmin co cfz co
      wcel wa vk cv c1 cP cN cmin co cfz co wcel vk cv cN caddc co cN c1 caddc
      co cP cfz co wcel vk cv cN caddc co cN cP cfz co wcel cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz
      co wcel vk cv c1 cP cN cmin co cfz co wcel vk cv cN caddc co cN c1 caddc
      co cP cfz co wcel wb cM cme wcel cS cX cF wf wa cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co
      wcel wa vk cv c1 cP cN cmin co cfz co wcel vk cv cN caddc co c1 cN caddc
      co cP cN cmin co cN caddc co cfz co wcel vk cv cN caddc co cN c1 caddc co
      cP cfz co wcel c1 cz wcel cP cN cmin co cz wcel vk cv cz wcel cN cz wcel
      vk cv c1 cP cN cmin co cfz co wcel vk cv cN caddc co c1 cN caddc co cP cN
      cmin co cN caddc co cfz co wcel wb cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel wa vk cv
      cN c1 cP cN cmin co fzaddel c1 cz wcel cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co cfz co wcel wa 1z
      a1i cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a cP
      cN cmin co cz wcel vk cv c1 cP cN cmin co cfz co wcel cP cz wcel cN cz
      wcel cP cN cmin co cz wcel cN cz wcel cP cN c1 caddc co cuz cfv wcel cN
      cP cfz co cS wss w3a cP cN zsubcl cP cN c1 caddc co cuz cfv wcel cN cz
      wcel cP cz wcel cN cP cfz co cS wss cN c1 caddc co cP eluzelz 3ad2ant2 cN
      cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss 3simp1 sylanc
      adantr vk cv c1 cP cN cmin co cfz co wcel vk cv cz wcel cN cz wcel cP cN
      c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin co
      elfzelz adantl cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS
      wss w3a cN cz wcel vk cv c1 cP cN cmin co cfz co wcel cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss 3simp1 adantr syl2anc cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP
      cN cmin co cfz co wcel wa c1 cN caddc co cP cN cmin co cN caddc co cfz co
      cN c1 caddc co cP cfz co vk cv cN caddc co cN cz wcel cP cN c1 caddc co
      cuz cfv wcel cN cP cfz co cS wss w3a c1 cN caddc co cP cN cmin co cN
      caddc co cfz co cN c1 caddc co cP cfz co wceq vk cv c1 cP cN cmin co cfz
      co wcel cP cc wcel cN cc wcel c1 cN caddc co cP cN cmin co cN caddc co
      cfz co cN c1 caddc co cP cfz co wceq cN cz wcel cP cN c1 caddc co cuz cfv
      wcel cN cP cfz co cS wss w3a cP cc wcel cN cc wcel wa c1 cN caddc co cN
      c1 caddc co cP cN cmin co cN caddc co cP cfz cP cc wcel cN cc wcel c1 cc
      wcel c1 cN caddc co cN c1 caddc co wceq c1 cc wcel cP cc wcel cN cc wcel
      wa ax1cn a1i c1 cN addcom sylancom cP cN npcan opreq12d cP cN c1 caddc co
      cuz cfv wcel cN cz wcel cP cc wcel cN cP cfz co cS wss cP cN c1 caddc co
      cuz cfv wcel cP cz wcel cP cc wcel cN c1 caddc co cP eluzelz cP zcn syl
      3ad2ant2 cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cc wcel cN cP cfz
      co cS wss cN zcn 3ad2ant1 sylanc adantr eleq2d bitrd adantll cM cme wcel
      cS cX cF wf wa cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS
      wss w3a wa vk cv c1 cP cN cmin co cfz co wcel wa cN c1 caddc co cP cfz co
      cN cP cfz co vk cv cN caddc co cN cz wcel cP cN c1 caddc co cuz cfv wcel
      cN cP cfz co cS wss w3a cN c1 caddc co cP cfz co cN cP cfz co wss cM cme
      wcel cS cX cF wf wa vk cv c1 cP cN cmin co cfz co wcel cN cz wcel cP cz
      wcel cN c1 caddc co cP cfz co cN cP cfz co wss cN cz wcel cP cN c1 caddc
      co cuz cfv wcel cN cP cfz co cS wss w3a cN cP fzp1ss cN cz wcel cP cN c1
      caddc co cuz cfv wcel cN cP cfz co cS wss 3simp1 cP cN c1 caddc co cuz
      cfv wcel cN cz wcel cP cz wcel cN cP cfz co cS wss cN c1 caddc co cP
      eluzelz 3ad2ant2 sylanc ad2antlr sseld sylbid cS cX cF wf cN cz wcel cP
      cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a vk cv c1 cP cN cmin
      co cfz co wcel vk cv cN caddc co cN cP cfz co wcel vk cv cN caddc co cF
      cfv cX wcel wi cM cme wcel cS cX cF wf cN cz wcel cP cN c1 caddc co cuz
      cfv wcel cN cP cfz co cS wss w3a wa vk cv cN caddc co cN cP cfz co wcel
      vk cv cN caddc co cF cfv cX wcel wi vk cv c1 cP cN cmin co cfz co wcel cS
      cX cF wf cN cz wcel cN cP cfz co cS wss vk cv cN caddc co cN cP cfz co
      wcel vk cv cN caddc co cF cfv cX wcel wi cP cN c1 caddc co cuz cfv wcel
      cS cX cF wf cN cP cfz co cS wss vk cv cN caddc co cN cP cfz co wcel vk cv
      cN caddc co cF cfv cX wcel cS cX cF wf vk cv cN caddc co cS wcel vk cv cN
      caddc co cF cfv cX wcel cN cP cfz co cS wss vk cv cN caddc co cN cP cfz
      co wcel wa cS cX cF wf vk cv cN caddc co cS wcel vk cv cN caddc co cF cfv
      cX wcel cS cX vk cv cN caddc co cF ffvelrn ex cN cP cfz co cS vk cv cN
      caddc co ssel2 syl5 expdimp 3ad2antr3 adantr adantlll syld mpd eqeltrd
      syl3anc recnd r19.21aiva syl3anc cM cme wcel cS cX cF wf wa cN cz wcel cP
      cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a wa c1 cN c1 cmin co
      caddc co cP cN cmin co cN c1 cmin co caddc co cfz co vk vj cv cN c1 cmin
      co cmin co vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF
      cN c1 cmin co cneg cshi co cfv cM co csb vj csu cN cP c1 cmin co cfz co
      vj cv cF cfv vj cv c1 caddc co cF cfv cM co vj csu cN cP c1 cmin co cfz
      co vk cv cF cfv vk cv c1 caddc co cF cfv cM co vk csu cS cX cF wf cN cz
      wcel cP cN c1 caddc co cuz cfv wcel cN cP cfz co cS wss w3a c1 cN c1 cmin
      co caddc co cP cN cmin co cN c1 cmin co caddc co cfz co vk vj cv cN c1
      cmin co cmin co vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co
      cF cN c1 cmin co cneg cshi co cfv cM co csb vj csu cN cP c1 cmin co cfz
      co vj cv cF cfv vj cv c1 caddc co cF cfv cM co vj csu wceq cM cme wcel cS
      cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel c1 cN c1 cmin co caddc
      co cP cN cmin co cN c1 cmin co caddc co cfz co vk vj cv cN c1 cmin co
      cmin co vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN
      c1 cmin co cneg cshi co cfv cM co csb vj csu cN cP c1 cmin co cfz co vj
      cv cF cfv vj cv c1 caddc co cF cfv cM co vj csu wceq cN cP cfz co cS wss
      cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel wa wa c1 cN c1 cmin
      co caddc co cP cN cmin co cN c1 cmin co caddc co cfz co cN cP c1 cmin co
      cfz co vk vj cv cN c1 cmin co cmin co vk cv cF cN c1 cmin co cneg cshi co
      cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co csb vj cv
      cF cfv vj cv c1 caddc co cF cfv cM co vj cN cz wcel cP cN c1 caddc co cuz
      cfv wcel wa c1 cN c1 cmin co caddc co cP cN cmin co cN c1 cmin co caddc
      co cfz co cN cP c1 cmin co cfz co wceq cS cX cF wf cN cc wcel cP cc wcel
      c1 cN c1 cmin co caddc co cP cN cmin co cN c1 cmin co caddc co cfz co cN
      cP c1 cmin co cfz co wceq cN cz wcel cP cN c1 caddc co cuz cfv wcel cN cc
      wcel cP cc wcel wa c1 cN c1 cmin co caddc co cN cP cN cmin co cN c1 cmin
      co caddc co cP c1 cmin co cfz cN cc wcel c1 cN c1 cmin co caddc co cN
      wceq cP cc wcel c1 cc wcel cN cc wcel c1 cN c1 cmin co caddc co cN wceq
      ax1cn c1 cN pncan3 mpan adantr cP cc wcel cN cc wcel cP cN cmin co cN c1
      cmin co caddc co cP c1 cmin co wceq cP cc wcel cN cc wcel c1 cc wcel cP
      cN cmin co cN c1 cmin co caddc co cP c1 cmin co wceq ax1cn cP cN c1
      npncan mp3an3 ancoms opreq12d cN zcn cP cN c1 caddc co cuz cfv wcel cP cz
      wcel cP cc wcel cN c1 caddc co cP eluzelz cP zcn syl syl2an adantl cS cX
      cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel wa wa vj cv c1 cN c1 cmin
      co caddc co cP cN cmin co cN c1 cmin co caddc co cfz co wcel wa vj cv cN
      c1 cmin co cmin co cF cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co
      cmin co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co vj cv cF cfv
      vj cv c1 caddc co cF cfv cM co vk vj cv cN c1 cmin co cmin co vk cv cF cN
      c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN c1 cmin co cneg cshi
      co cfv cM co csb cS cX cF wf cN cz wcel cP cN c1 caddc co cuz cfv wcel wa
      vj cv c1 cN c1 cmin co caddc co cP cN cmin co cN c1 cmin co caddc co cfz
      co wcel vj cv cN c1 cmin co cmin co cF cN c1 cmin co cneg cshi co cfv vj
      cv cN c1 cmin co cmin co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM
      co vj cv cF cfv vj cv c1 caddc co cF cfv cM co wceq cS cX cF wf cN cz
      wcel cP cN c1 caddc co cuz cfv wcel wa vj cv c1 cN c1 cmin co caddc co cP
      cN cmin co cN c1 cmin co caddc co cfz co wcel wa vj cv cN c1 cmin co cmin
      co cF cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co cmin co c1 caddc
      co cF cN c1 cmin co cneg cshi co cfv cM co vj cv cF cfv vj cv c1 caddc co
      cF cfv cM co wceq cS cX cF wf cF cvv wcel cN cz wcel cP cN c1 caddc co
      cuz cfv wcel wa vj cv c1 cN c1 cmin co caddc co cP cN cmin co cN c1 cmin
      co caddc co cfz co wcel wa vj cv cN c1 cmin co cmin co cF cN c1 cmin co
      cneg cshi co cfv vj cv cN c1 cmin co cmin co c1 caddc co cF cN c1 cmin co
      cneg cshi co cfv cM co vj cv cF cfv vj cv c1 caddc co cF cfv cM co wceq
      wi cS cX cF wf cS cvv wcel cF cvv wcel mettrifi2.2 cS cX cvv cF fex mpan2
      cN cz wcel cP cN c1 caddc co cuz cfv wcel wa vj cv c1 cN c1 cmin co caddc
      co cP cN cmin co cN c1 cmin co caddc co cfz co wcel wa vj cv cN c1 cmin
      co cmin co vf cv cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co cmin
      co c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cM co vj cv vf cv cfv
      vj cv c1 caddc co vf cv cfv cM co wceq wi cN cz wcel cP cN c1 caddc co
      cuz cfv wcel wa vj cv c1 cN c1 cmin co caddc co cP cN cmin co cN c1 cmin
      co caddc co cfz co wcel wa vj cv cN c1 cmin co cmin co cF cN c1 cmin co
      cneg cshi co cfv vj cv cN c1 cmin co cmin co c1 caddc co cF cN c1 cmin co
      cneg cshi co cfv cM co vj cv cF cfv vj cv c1 caddc co cF cfv cM co wceq
      wi vf cF cvv vf cv cF wceq vj cv cN c1 cmin co cmin co vf cv cN c1 cmin
      co cneg cshi co cfv vj cv cN c1 cmin co cmin co c1 caddc co vf cv cN c1
      cmin co cneg cshi co cfv cM co vj cv vf cv cfv vj cv c1 caddc co vf cv
      cfv cM co wceq vj cv cN c1 cmin co cmin co cF cN c1 cmin co cneg cshi co
      cfv vj cv cN c1 cmin co cmin co c1 caddc co cF cN c1 cmin co cneg cshi co
      cfv cM co vj cv cF cfv vj cv c1 caddc co cF cfv cM co wceq cN cz wcel cP
      cN c1 caddc co cuz cfv wcel wa vj cv c1 cN c1 cmin co caddc co cP cN cmin
      co cN c1 cmin co caddc co cfz co wcel wa vf cv cF wceq vj cv cN c1 cmin
      co cmin co vf cv cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co cmin
      co c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cM co vj cv cN c1
      cmin co cmin co cF cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co
      cmin co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co vj cv vf cv
      cfv vj cv c1 caddc co vf cv cfv cM co vj cv cF cfv vj cv c1 caddc co cF
      cfv cM co vf cv cF wceq vj cv cN c1 cmin co cmin co vf cv cN c1 cmin co
      cneg cshi co cfv vj cv cN c1 cmin co cmin co cF cN c1 cmin co cneg cshi
      co cfv vj cv cN c1 cmin co cmin co c1 caddc co vf cv cN c1 cmin co cneg
      cshi co cfv vj cv cN c1 cmin co cmin co c1 caddc co cF cN c1 cmin co cneg
      cshi co cfv cM vf cv cF wceq vj cv cN c1 cmin co cmin co vf cv cN c1 cmin
      co cneg cshi co cF cN c1 cmin co cneg cshi co vf cv cF cN c1 cmin co cneg
      cshi opreq1 fveq1d vf cv cF wceq vj cv cN c1 cmin co cmin co c1 caddc co
      vf cv cN c1 cmin co cneg cshi co cF cN c1 cmin co cneg cshi co vf cv cF
      cN c1 cmin co cneg cshi opreq1 fveq1d opreq12d vf cv cF wceq vj cv vf cv
      cfv vj cv cF cfv vj cv c1 caddc co vf cv cfv vj cv c1 caddc co cF cfv cM
      vj cv vf cv cF fveq1 vj cv c1 caddc co vf cv cF fveq1 opreq12d eqeq12d
      imbi2d cN cz wcel cP cN c1 caddc co cuz cfv wcel vj cv c1 cN c1 cmin co
      caddc co cP cN cmin co cN c1 cmin co caddc co cfz co wcel vj cv cN c1
      cmin co cmin co vf cv cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co
      cmin co c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cM co vj cv vf
      cv cfv vj cv c1 caddc co vf cv cfv cM co wceq cN cc wcel cP cc wcel vj cv
      cc wcel vj cv cN c1 cmin co cmin co vf cv cN c1 cmin co cneg cshi co cfv
      vj cv cN c1 cmin co cmin co c1 caddc co vf cv cN c1 cmin co cneg cshi co
      cfv cM co vj cv vf cv cfv vj cv c1 caddc co vf cv cfv cM co wceq cN cz
      wcel cP cN c1 caddc co cuz cfv wcel vj cv c1 cN c1 cmin co caddc co cP cN
      cmin co cN c1 cmin co caddc co cfz co wcel cN cc wcel cP cc wcel vj cv cc
      wcel w3a vj cv cN c1 cmin co cmin co vf cv cN c1 cmin co cneg cshi co cfv
      vj cv vf cv cfv vj cv cN c1 cmin co cmin co c1 caddc co vf cv cN c1 cmin
      co cneg cshi co cfv vj cv c1 caddc co vf cv cfv cM cN cc wcel cP cc wcel
      vj cv cc wcel w3a vj cv cN c1 cmin co cmin co vf cv cN c1 cmin co cneg
      cshi co cfv cN c1 cmin co vj cv cN c1 cmin co cmin co caddc co vf cv cfv
      vj cv vf cv cfv cN c1 cmin co cc wcel vj cv cN c1 cmin co cmin co cc wcel
      vj cv cN c1 cmin co cmin co vf cv cN c1 cmin co cneg cshi co cfv cN c1
      cmin co vj cv cN c1 cmin co cmin co caddc co vf cv cfv wceq cN cc wcel cP
      cc wcel vj cv cc wcel w3a cN c1 cmin co vj cv cN c1 cmin co cmin co vf cv
      vf visset shftval4 cN cc wcel cP cc wcel cN c1 cmin co cc wcel vj cv cc
      wcel cN cc wcel c1 cc wcel cN c1 cmin co cc wcel ax1cn cN c1 subcl mpan2
      3ad2ant1 vj cv cc wcel cN c1 cmin co cc wcel vj cv cN c1 cmin co cmin co
      cc wcel cN cc wcel cP cc wcel vj cv cc wcel w3a vj cv cN c1 cmin co subcl
      cN cc wcel cP cc wcel vj cv cc wcel 3simp3 cN cc wcel cP cc wcel cN c1
      cmin co cc wcel vj cv cc wcel cN cc wcel c1 cc wcel cN c1 cmin co cc wcel
      ax1cn cN c1 subcl mpan2 3ad2ant1 sylanc sylanc cN cc wcel cP cc wcel vj
      cv cc wcel w3a cN c1 cmin co vj cv cN c1 cmin co cmin co caddc co vj cv
      vf cv cN c1 cmin co cc wcel vj cv cc wcel cN c1 cmin co vj cv cN c1 cmin
      co cmin co caddc co vj cv wceq cN cc wcel cP cc wcel vj cv cc wcel w3a cN
      c1 cmin co vj cv pncan3 cN cc wcel cP cc wcel cN c1 cmin co cc wcel vj cv
      cc wcel cN cc wcel c1 cc wcel cN c1 cmin co cc wcel ax1cn cN c1 subcl
      mpan2 3ad2ant1 cN cc wcel cP cc wcel vj cv cc wcel 3simp3 sylanc fveq2d
      eqtrd cN cc wcel cP cc wcel vj cv cc wcel w3a vj cv cN c1 cmin co cmin co
      c1 caddc co vf cv cN c1 cmin co cneg cshi co cfv cN c1 cmin co vj cv cN
      c1 cmin co cmin co c1 caddc co caddc co vf cv cfv vj cv c1 caddc co vf cv
      cfv cN c1 cmin co cc wcel vj cv cN c1 cmin co cmin co c1 caddc co cc wcel
      vj cv cN c1 cmin co cmin co c1 caddc co vf cv cN c1 cmin co cneg cshi co
      cfv cN c1 cmin co vj cv cN c1 cmin co cmin co c1 caddc co caddc co vf cv
      cfv wceq cN cc wcel cP cc wcel vj cv cc wcel w3a cN c1 cmin co vj cv cN
      c1 cmin co cmin co c1 caddc co vf cv vf visset shftval4 cN cc wcel cP cc
      wcel cN c1 cmin co cc wcel vj cv cc wcel cN cc wcel c1 cc wcel cN c1 cmin
      co cc wcel ax1cn cN c1 subcl mpan2 3ad2ant1 cN cc wcel cP cc wcel vj cv
      cc wcel w3a vj cv cN c1 cmin co cmin co cc wcel vj cv cN c1 cmin co cmin
      co c1 caddc co cc wcel vj cv cc wcel cN c1 cmin co cc wcel vj cv cN c1
      cmin co cmin co cc wcel cN cc wcel cP cc wcel vj cv cc wcel w3a vj cv cN
      c1 cmin co subcl cN cc wcel cP cc wcel vj cv cc wcel 3simp3 cN cc wcel cP
      cc wcel cN c1 cmin co cc wcel vj cv cc wcel cN cc wcel c1 cc wcel cN c1
      cmin co cc wcel ax1cn cN c1 subcl mpan2 3ad2ant1 sylanc vj cv cN c1 cmin
      co cmin co peano2cn syl sylanc cN cc wcel cP cc wcel vj cv cc wcel w3a cN
      c1 cmin co vj cv cN c1 cmin co cmin co c1 caddc co caddc co vj cv c1
      caddc co vf cv cN cc wcel cP cc wcel vj cv cc wcel w3a cN c1 cmin co vj
      cv cN c1 cmin co cmin co caddc co c1 caddc co cN c1 cmin co vj cv cN c1
      cmin co cmin co c1 caddc co caddc co vj cv c1 caddc co cN c1 cmin co cc
      wcel vj cv cN c1 cmin co cmin co cc wcel c1 cc wcel cN c1 cmin co vj cv
      cN c1 cmin co cmin co caddc co c1 caddc co cN c1 cmin co vj cv cN c1 cmin
      co cmin co c1 caddc co caddc co wceq cN cc wcel cP cc wcel vj cv cc wcel
      w3a cN c1 cmin co vj cv cN c1 cmin co cmin co c1 addass cN cc wcel cP cc
      wcel cN c1 cmin co cc wcel vj cv cc wcel cN cc wcel c1 cc wcel cN c1 cmin
      co cc wcel ax1cn cN c1 subcl mpan2 3ad2ant1 vj cv cc wcel cN c1 cmin co
      cc wcel vj cv cN c1 cmin co cmin co cc wcel cN cc wcel cP cc wcel vj cv
      cc wcel w3a vj cv cN c1 cmin co subcl cN cc wcel cP cc wcel vj cv cc wcel
      3simp3 cN cc wcel cP cc wcel cN c1 cmin co cc wcel vj cv cc wcel cN cc
      wcel c1 cc wcel cN c1 cmin co cc wcel ax1cn cN c1 subcl mpan2 3ad2ant1
      sylanc c1 cc wcel cN cc wcel cP cc wcel vj cv cc wcel w3a ax1cn a1i
      syl3anc cN cc wcel cP cc wcel vj cv cc wcel w3a cN c1 cmin co vj cv cN c1
      cmin co cmin co caddc co vj cv c1 caddc cN c1 cmin co cc wcel vj cv cc
      wcel cN c1 cmin co vj cv cN c1 cmin co cmin co caddc co vj cv wceq cN cc
      wcel cP cc wcel vj cv cc wcel w3a cN c1 cmin co vj cv pncan3 cN cc wcel
      cP cc wcel cN c1 cmin co cc wcel vj cv cc wcel cN cc wcel c1 cc wcel cN
      c1 cmin co cc wcel ax1cn cN c1 subcl mpan2 3ad2ant1 cN cc wcel cP cc wcel
      vj cv cc wcel 3simp3 sylanc opreq1d eqtr3d fveq2d eqtrd opreq12d cN zcn
      cP cN c1 caddc co cuz cfv wcel cP cz wcel cP cc wcel cN c1 caddc co cP
      eluzelz cP zcn syl vj cv c1 cN c1 cmin co caddc co cP cN cmin co cN c1
      cmin co caddc co cfz co wcel vj cv c1 cN c1 cmin co caddc co cuz cfv wcel
      vj cv cz wcel vj cv cc wcel vj cv c1 cN c1 cmin co caddc co cP cN cmin co
      cN c1 cmin co caddc co elfzuz c1 cN c1 cmin co caddc co vj cv eluzelz vj
      cv zcn 3syl syl3an 3expa vtoclg syl imp anassrs vk vz vj cv cN c1 cmin co
      cmin co vk cv cF cN c1 cmin co cneg cshi co cfv vk cv c1 caddc co cF cN
      c1 cmin co cneg cshi co cfv cM co vj cv cN c1 cmin co cmin co cF cN c1
      cmin co cneg cshi co cfv vj cv cN c1 cmin co cmin co c1 caddc co cF cN c1
      cmin co cneg cshi co cfv cM co vj cv cN c1 cmin co cmin oprex vz cv vj cv
      cN c1 cmin co cmin co cF cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin
      co cmin co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM co wcel vk
      ax-17 vk cv vj cv cN c1 cmin co cmin co wceq vk cv cF cN c1 cmin co cneg
      cshi co cfv vj cv cN c1 cmin co cmin co cF cN c1 cmin co cneg cshi co cfv
      vk cv c1 caddc co cF cN c1 cmin co cneg cshi co cfv vj cv cN c1 cmin co
      cmin co c1 caddc co cF cN c1 cmin co cneg cshi co cfv cM vk cv vj cv cN
      c1 cmin co cmin co cF cN c1 cmin co cneg cshi co fveq2 vk cv vj cv cN c1
      cmin co cmin co wceq vk cv c1 caddc co vj cv cN c1 cmin co cmin co c1
      caddc co cF cN c1 cmin co cneg cshi co vk cv vj cv cN c1 cmin co cmin co
      c1 caddc opreq1 fveq2d opreq12d csbief syl5eq sumeq12dv 3adantr3 adantll
      vz cN cP c1 cmin co cfz co vj cv cF cfv vj cv c1 caddc co cF cfv cM co vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co vj vk vz cv vj cv cF cfv vj cv
      c1 caddc co cF cfv cM co wcel vk ax-17 vz cv vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co wcel vj ax-17 vj vk weq vj cv cF cfv vk cv cF cfv vj cv
      c1 caddc co cF cfv vk cv c1 caddc co cF cfv cM vj cv vk cv cF fveq2 vj vk
      weq vj cv c1 caddc co vk cv c1 caddc co cF vj cv vk cv c1 caddc opreq1
      fveq2d opreq12d cbvsumi syl6eq 3eqtrd 3brtr3d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M j k m n s t x $. $d X j k m n s t x $. $d F j k m n s t x $.
    $d A j k m n s t x $. $d B j k m n s t x $.
    geomcau.1 $e |- X = dom dom M $.
    $( If the distance between consecutive points in a sequence is bounded by
       a geometric sequence, then the sequence is Cauchy. $)
    geomcau $p |- ( ( ( M e. Met /\ F : NN --> X ) /\
                ( A e. RR /\ B e. RR+ /\ B < 1 ) /\ A. k e. NN ( ( F ` k ) M
           ( F ` ( k + 1 ) ) ) <_ ( A x. ( B ^ k ) ) ) -> F e. ( Cau ` M ) ) $=
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a cF cM cca cfv wcel vj cv vm cv cle wbr vj cv cF cfv vm cv
      cF cfv cM co vx cv clt wbr wi vm cn wral vj cn wrex vx crp wral cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt
      wbr wi vm cn wral vj cn wrex vx crp cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel wa cA
      cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr
      vj cn wrex vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt
      wbr wi vm cn wral vj cn wrex cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel wa cc0 cA cle
      wbr cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv
      clt wbr vj cn wrex cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB
      c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a cc0 cA cle wbr vx cv crp wcel cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 cF
      cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr cc0 cA
      cle wbr vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1
      cexp co cmul co cle wbr w3a cc0 cA cB cmul co cle wbr cc0 cA cle wbr cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 cF
      cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr w3a cc0
      c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB cmul co cc0 cr wcel cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 cF cfv c1
      c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr w3a 0re a1i cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 cF
      cfv c1 c1 caddc co cF cfv cM co cr wcel c1 cF cfv c1 c1 caddc co cF cfv
      cM co cA cB c1 cexp co cmul co cle wbr cM cme wcel c1 cF cfv cX wcel c1
      c1 caddc co cF cfv cX wcel wa c1 cF cfv c1 c1 caddc co cF cfv cM co cr
      wcel cn cX cF wf cM cme wcel c1 cF cfv cX wcel c1 c1 caddc co cF cfv cX
      wcel c1 cF cfv c1 c1 caddc co cF cfv cM co cr wcel c1 cF cfv c1 c1 caddc
      co cF cfv cM cX geomcau.1 metcl 3expb cn cX cF wf c1 cF cfv cX wcel c1 c1
      caddc co cF cfv cX wcel cn cX cF wf c1 cn wcel c1 cF cfv cX wcel 1nn cn
      cX c1 cF ffvelrn mpan2 cn cX cF wf c1 c1 caddc co cn wcel c1 c1 caddc co
      cF cfv cX wcel c1 cn wcel c1 cn wcel c1 c1 caddc co cn wcel 1nn 1nn c1 c1
      nnaddcl mp2an cn cX c1 c1 caddc co cF ffvelrn mpan2 jca sylan2 3ad2ant1
      cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa cA cB
      cmul co cr wcel c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co
      cmul co cle wbr cA cr wcel cB crp wcel cA cB cmul co cr wcel cB c1 clt
      wbr cA cr wcel cB cr wcel cA cB cmul co cr wcel cB crp wcel cA cB
      axmulrcl cB rpre sylan2 3adant3 3ad2ant2 cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a cc0 c1 cF cfv c1 c1 caddc co cF cfv cM
      co cle wbr c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co
      cle wbr cM cme wcel c1 cF cfv cX wcel c1 c1 caddc co cF cfv cX wcel wa
      cc0 c1 cF cfv c1 c1 caddc co cF cfv cM co cle wbr cn cX cF wf cM cme wcel
      c1 cF cfv cX wcel c1 c1 caddc co cF cfv cX wcel cc0 c1 cF cfv c1 c1 caddc
      co cF cfv cM co cle wbr c1 cF cfv c1 c1 caddc co cF cfv cM cX geomcau.1
      metge0 3expb cn cX cF wf c1 cF cfv cX wcel c1 c1 caddc co cF cfv cX wcel
      cn cX cF wf c1 cn wcel c1 cF cfv cX wcel 1nn cn cX c1 cF ffvelrn mpan2 cn
      cX cF wf c1 c1 caddc co cn wcel c1 c1 caddc co cF cfv cX wcel c1 cn wcel
      c1 cn wcel c1 c1 caddc co cn wcel 1nn 1nn c1 c1 nnaddcl mp2an cn cX c1 c1
      caddc co cF ffvelrn mpan2 jca sylan2 3ad2ant1 cM cme wcel cn cX cF wf wa
      cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv
      cM co cA cB c1 cexp co cmul co cle wbr c1 cF cfv c1 c1 caddc co cF cfv cM
      co cA cB cmul co cle wbr cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a wa cA cB c1 cexp co cmul co cA cB cmul co c1 cF
      cfv c1 c1 caddc co cF cfv cM co cle cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a wa cB c1 cexp co cB cA cmul cA cr wcel cB
      crp wcel cB c1 clt wbr w3a cB c1 cexp co cB wceq cM cme wcel cn cX cF wf
      wa cB crp wcel cA cr wcel cB c1 cexp co cB wceq cB c1 clt wbr cB crp wcel
      cB cc wcel cB c1 cexp co cB wceq cB rpcn cB exp1 syl 3ad2ant2 adantl
      opreq2d breq2d biimp3a letrd cA cr wcel cB crp wcel cB c1 clt wbr w3a cM
      cme wcel cn cX cF wf wa cc0 cA cB cmul co cle wbr cc0 cA cle wbr wi c1 cF
      cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr cA cr
      wcel cB crp wcel cc0 cA cB cmul co cle wbr cc0 cA cle wbr wi cB c1 clt
      wbr cA cr wcel cB crp wcel wa cc0 cA cB cmul co cle wbr cc0 cA cle wbr cA
      cr wcel cc0 cA cB cmul co cle wbr cB crp wcel cc0 cA cle wbr cA cr wcel
      cc0 cA cB cmul co cle wbr wa cB cr wcel cc0 cB clt wbr wa cc0 cA cle wbr
      cB crp wcel cA cr wcel cB cr wcel cc0 cA cB cmul co cle wbr cc0 cB clt
      wbr cc0 cA cle wbr cA cr wcel cB cr wcel wa cc0 cB clt wbr cc0 cA cB cmul
      co cle wbr cc0 cA cle wbr cA cB prodge02 ancom2s an4s cB rpregt0 sylan2
      an1rs ex 3adant3 3ad2ant2 mpd c1 cn wcel vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral c1 cF cfv c1
      c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr wi 1nn vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr c1
      cF cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr vk c1
      cn vk cv c1 wceq vk cv cF cfv vk cv c1 caddc co cF cfv cM co c1 cF cfv c1
      c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cA cB c1 cexp co
      cmul co cle vk cv c1 wceq vk cv cF cfv c1 cF cfv vk cv c1 caddc co cF cfv
      c1 c1 caddc co cF cfv cM vk cv c1 cF fveq2 vk cv c1 wceq vk cv c1 caddc
      co c1 c1 caddc co cF vk cv c1 c1 caddc opreq1 fveq2d opreq12d vk cv c1
      wceq cB vk cv cexp co cB c1 cexp co cA cmul vk cv c1 cB cexp opreq2
      opreq2d breq12d rcla4v ax-mp syl3an3 adantr cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp
      wcel wa cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo cA cB vj cv cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr vj cn wrex cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo wb vx cv crp wcel
      cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa cc0
      cA cle wbr cc0 cA clt wbr cc0 cA wceq wo wb vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel
      cB crp wcel cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo wb cB c1 clt wbr
      cc0 cr wcel cA cr wcel cc0 cA cle wbr cc0 cA clt wbr cc0 cA wceq wo wb
      0re cc0 cA leloe mpan 3ad2ant1 3ad2ant2 adantr cA cr wcel cB crp wcel cB
      c1 clt wbr w3a cM cme wcel cn cX cF wf wa vx cv crp wcel cc0 cA clt wbr
      cc0 cA wceq wo cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul
      co vx cv clt wbr vj cn wrex wi vk cv cF cfv vk cv c1 caddc co cF cfv cM
      co cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vx cv crp wcel wa cc0 cA clt wbr cc0 cA wceq wo cA cB
      vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr vj
      cn wrex cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa cc0 cA
      clt wbr cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx
      cv clt wbr vj cn wrex cc0 cA wceq cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vx cv crp wcel wa cc0 cA clt wbr wa cB vj cv cexp co vx cv cA c1 c1
      cB cmin co cdiv co cmul co cdiv co clt wbr vj cn wrex cA cB vj cv cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr vj cn wrex cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa cc0 cA clt wbr wa c1
      c1 cB cdiv co vj cv cexp co cdiv co vx cv cA c1 c1 cB cmin co cdiv co
      cmul co cdiv co clt wbr vj cn wrex cB vj cv cexp co vx cv cA c1 c1 cB
      cmin co cdiv co cmul co cdiv co clt wbr vj cn wrex vx cv cA c1 c1 cB cmin
      co cdiv co cmul co cdiv co crp wcel c1 cB cdiv co cr wcel c1 c1 cB cdiv
      co clt wbr c1 c1 cB cdiv co vj cv cexp co cdiv co vx cv cA c1 c1 cB cmin
      co cdiv co cmul co cdiv co clt wbr vj cn wrex cA cr wcel cB crp wcel cB
      c1 clt wbr w3a vx cv crp wcel wa cc0 cA clt wbr wa vx cv cA c1 c1 cB cmin
      co cdiv co cmul co cdiv co c1 cB cdiv co vj expnlbnd vx cv crp wcel cA c1
      c1 cB cmin co cdiv co cmul co crp wcel vx cv cA c1 c1 cB cmin co cdiv co
      cmul co cdiv co crp wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv
      crp wcel wa cc0 cA clt wbr wa vx cv cA c1 c1 cB cmin co cdiv co cmul co
      rpdivcl cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel cc0 cA
      clt wbr simplr cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA clt wbr cA
      c1 c1 cB cmin co cdiv co cmul co crp wcel vx cv crp wcel cA crp wcel c1
      c1 cB cmin co cdiv co crp wcel cA c1 c1 cB cmin co cdiv co cmul co crp
      wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA clt wbr wa cA c1 c1
      cB cmin co cdiv co rpmulcl cA cr wcel cB crp wcel cc0 cA clt wbr cA crp
      wcel cB c1 clt wbr cA crp wcel cA cr wcel cc0 cA clt wbr wa cA elrp
      biimpri 3ad2antl1 cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 c1 cB cmin
      co cdiv co crp wcel cc0 cA clt wbr cB crp wcel cB c1 clt wbr c1 c1 cB
      cmin co cdiv co crp wcel cA cr wcel cB crp wcel cB c1 clt wbr wa c1 cB
      cmin co crp wcel c1 c1 cB cmin co cdiv co crp wcel c1 cB cmin co crp wcel
      c1 cB cmin co cr wcel cc0 c1 cB cmin co clt wbr cB crp wcel cB c1 clt wbr
      wa c1 cB cmin co elrp cB crp wcel c1 cB cmin co cr wcel cB c1 clt wbr c1
      cr wcel cB cr wcel c1 cB cmin co cr wcel cB crp wcel c1 cB resubcl 1re cB
      rpre sylancr adantr cB crp wcel cB c1 clt wbr cc0 c1 cB cmin co clt wbr
      cB cr wcel c1 cr wcel cB c1 clt wbr cc0 c1 cB cmin co clt wbr wb cB crp
      wcel cB c1 posdif cB rpre 1re sylancl biimpa sylanbrc c1 cB cmin co
      rpreccl syl 3adant1 adantr sylanc adantlr sylanc cA cr wcel cB crp wcel
      cB c1 clt wbr w3a c1 cB cdiv co cr wcel vx cv crp wcel cc0 cA clt wbr cB
      crp wcel cA cr wcel c1 cB cdiv co cr wcel cB c1 clt wbr cB crp wcel c1 cB
      cdiv co crp wcel c1 cB cdiv co cr wcel cB rpreccl c1 cB cdiv co rpre syl
      3ad2ant2 ad2antrr cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 c1 cB cdiv
      co clt wbr vx cv crp wcel cc0 cA clt wbr cB crp wcel cB c1 clt wbr c1 c1
      cB cdiv co clt wbr cA cr wcel cB crp wcel cB c1 clt wbr c1 c1 cB cdiv co
      clt wbr cB crp wcel cB cr wcel cc0 cB clt wbr wa cB c1 clt wbr c1 c1 cB
      cdiv co clt wbr wb cB rpregt0 cB reclt1 syl biimpa 3adant1 ad2antrr
      syl3anc cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa cc0 cA
      clt wbr wa c1 c1 cB cdiv co vj cv cexp co cdiv co vx cv cA c1 c1 cB cmin
      co cdiv co cmul co cdiv co clt wbr cB vj cv cexp co vx cv cA c1 c1 cB
      cmin co cdiv co cmul co cdiv co clt wbr vj cn cA cr wcel cB crp wcel cB
      c1 clt wbr w3a vx cv crp wcel wa cc0 cA clt wbr wa vj cv cn wcel wa c1 c1
      cB cdiv co vj cv cexp co cdiv co cB vj cv cexp co vx cv cA c1 c1 cB cmin
      co cdiv co cmul co cdiv co clt cA cr wcel cB crp wcel cB c1 clt wbr w3a
      vx cv crp wcel wa cc0 cA clt wbr wa vj cv cn wcel wa c1 c1 cB cdiv co vj
      cv cexp co cdiv co c1 c1 cB cdiv co cdiv co vj cv cexp co cB vj cv cexp
      co cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa vj cv cn
      wcel c1 c1 cB cdiv co vj cv cexp co cdiv co c1 c1 cB cdiv co cdiv co vj
      cv cexp co wceq cc0 cA clt wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a
      vj cv cn wcel c1 c1 cB cdiv co vj cv cexp co cdiv co c1 c1 cB cdiv co
      cdiv co vj cv cexp co wceq vx cv crp wcel cB crp wcel cA cr wcel vj cv cn
      wcel c1 c1 cB cdiv co vj cv cexp co cdiv co c1 c1 cB cdiv co cdiv co vj
      cv cexp co wceq cB c1 clt wbr cB crp wcel vj cv cn wcel wa c1 c1 cB cdiv
      co cdiv co vj cv cexp co c1 c1 cB cdiv co vj cv cexp co cdiv co c1 cB
      cdiv co cc wcel c1 cB cdiv co cc0 wne vj cv cn0 wcel c1 c1 cB cdiv co
      cdiv co vj cv cexp co c1 c1 cB cdiv co vj cv cexp co cdiv co wceq cB crp
      wcel vj cv cn wcel wa c1 cB cdiv co vj cv exprec cB crp wcel c1 cB cdiv
      co cc wcel vj cv cn wcel cB crp wcel c1 cB cdiv co crp wcel c1 cB cdiv co
      cc wcel cB rpreccl c1 cB cdiv co rpcn syl adantr cB crp wcel c1 cB cdiv
      co cc0 wne vj cv cn wcel cB crp wcel c1 cB cdiv co crp wcel c1 cB cdiv co
      cc0 wne cB rpreccl c1 cB cdiv co rpne0 syl adantr vj cv cn wcel vj cv cn0
      wcel cB crp wcel vj cv nnnn0 adantl syl3anc eqcomd 3ad2antl2 adantlr
      adantlr cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa cc0 cA
      clt wbr wa vj cv cn wcel wa c1 c1 cB cdiv co cdiv co cB vj cv cexp cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa c1 c1 cB cdiv co
      cdiv co cB wceq cc0 cA clt wbr vj cv cn wcel cA cr wcel cB crp wcel cB c1
      clt wbr w3a c1 c1 cB cdiv co cdiv co cB wceq vx cv crp wcel cB crp wcel
      cA cr wcel c1 c1 cB cdiv co cdiv co cB wceq cB c1 clt wbr cB cc wcel cB
      cc0 wne c1 c1 cB cdiv co cdiv co cB wceq cB crp wcel cB recrec cB rpcn cB
      rpne0 sylanc 3ad2ant2 adantr ad2antrr opreq1d eqtrd breq1d rexbidva mpbid
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa cc0 cA clt wbr
      wa cB vj cv cexp co vx cv cA c1 c1 cB cmin co cdiv co cmul co cdiv co clt
      wbr cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv
      clt wbr vj cn cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa
      cc0 cA clt wbr wa vj cv cn wcel wa cA c1 c1 cB cmin co cdiv co cmul co cB
      vj cv cexp co cmul co vx cv clt wbr cB vj cv cexp co vx cv cA c1 c1 cB
      cmin co cdiv co cmul co cdiv co clt wbr cA cB vj cv cexp co cmul co c1 c1
      cB cmin co cdiv co cmul co vx cv clt wbr cB vj cv cexp co cr wcel vx cv
      cr wcel cA c1 c1 cB cmin co cdiv co cmul co cr wcel cc0 cA c1 c1 cB cmin
      co cdiv co cmul co clt wbr wa cA c1 c1 cB cmin co cdiv co cmul co cB vj
      cv cexp co cmul co vx cv clt wbr cB vj cv cexp co vx cv cA c1 c1 cB cmin
      co cdiv co cmul co cdiv co clt wbr wb cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vx cv crp wcel wa cc0 cA clt wbr wa vj cv cn wcel wa cB vj cv
      cexp co vx cv cA c1 c1 cB cmin co cdiv co cmul co ltmuldiv2 cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vx cv crp wcel wa vj cv cn wcel cB vj cv cexp
      co cr wcel cc0 cA clt wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv
      cn wcel cB vj cv cexp co cr wcel vx cv crp wcel cB crp wcel cA cr wcel vj
      cv cn wcel cB vj cv cexp co cr wcel cB c1 clt wbr cB cr wcel vj cv cn0
      wcel cB vj cv cexp co cr wcel cB crp wcel vj cv cn wcel cB vj cv reexpcl
      cB rpre vj cv nnnn0 syl2an 3ad2antl2 adantlr adantlr cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vx cv crp wcel wa vx cv cr wcel cc0 cA clt wbr vj
      cv cn wcel vx cv crp wcel vx cv cr wcel cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vx cv rpre adantl ad2antrr cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vx cv crp wcel wa cc0 cA clt wbr wa cA c1 c1 cB cmin co cdiv co cmul
      co cr wcel cc0 cA c1 c1 cB cmin co cdiv co cmul co clt wbr wa vj cv cn
      wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA clt wbr cA c1 c1 cB
      cmin co cdiv co cmul co cr wcel cc0 cA c1 c1 cB cmin co cdiv co cmul co
      clt wbr wa vx cv crp wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA
      clt wbr wa cA c1 c1 cB cmin co cdiv co cmul co cr wcel cc0 cA c1 c1 cB
      cmin co cdiv co cmul co clt wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a
      cA c1 c1 cB cmin co cdiv co cmul co cr wcel cc0 cA clt wbr cA cr wcel cB
      crp wcel cB c1 clt wbr cA c1 c1 cB cmin co cdiv co cmul co cr wcel cA cr
      wcel c1 c1 cB cmin co cdiv co cr wcel cA c1 c1 cB cmin co cdiv co cmul co
      cr wcel cB crp wcel cB c1 clt wbr wa cA c1 c1 cB cmin co cdiv co remulcl
      c1 cB cmin co cr wcel c1 cB cmin co cc0 wne c1 c1 cB cmin co cdiv co cr
      wcel cB crp wcel cB c1 clt wbr wa c1 cB cmin co rereccl cB crp wcel c1 cB
      cmin co cr wcel cB c1 clt wbr c1 cr wcel cB cr wcel c1 cB cmin co cr wcel
      cB crp wcel c1 cB resubcl 1re cB rpre sylancr adantr cB crp wcel cB c1
      clt wbr wa c1 cB cmin co cc0 wne c1 cB wne cB cr wcel c1 cr wcel cB c1
      clt wbr c1 cB wne cB crp wcel cB c1 clt wbr wa cB c1 ltne cB crp wcel cB
      cr wcel cB c1 clt wbr cB rpre adantr c1 cr wcel cB crp wcel cB c1 clt wbr
      wa 1re a1i cB crp wcel cB c1 clt wbr pm3.27 syl3anc cB crp wcel cB c1 clt
      wbr wa c1 cB cmin co cc0 c1 cB cB crp wcel c1 cB cmin co cc0 wceq c1 cB
      wceq wb cB c1 clt wbr c1 cc wcel cB cc wcel c1 cB cmin co cc0 wceq c1 cB
      wceq wb cB crp wcel c1 cB subeq0 ax1cn cB rpcn sylancr adantr necon3bid
      mpbird sylanc sylan2 3impb adantr cA cr wcel cc0 cA clt wbr c1 c1 cB cmin
      co cdiv co cr wcel cc0 c1 c1 cB cmin co cdiv co clt wbr cc0 cA c1 c1 cB
      cmin co cdiv co cmul co clt wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a
      cc0 cA clt wbr wa cA c1 c1 cB cmin co cdiv co mulgt0 cA cr wcel cB crp
      wcel cB c1 clt wbr w3a cA cr wcel cc0 cA clt wbr cA cr wcel cB crp wcel
      cB c1 clt wbr 3simp1 adantr cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0
      cA clt wbr pm3.27 cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 c1 cB cmin
      co cdiv co cr wcel cc0 cA clt wbr cB crp wcel cB c1 clt wbr c1 c1 cB cmin
      co cdiv co cr wcel cA cr wcel c1 cB cmin co cr wcel c1 cB cmin co cc0 wne
      c1 c1 cB cmin co cdiv co cr wcel cB crp wcel cB c1 clt wbr wa c1 cB cmin
      co rereccl cB crp wcel c1 cB cmin co cr wcel cB c1 clt wbr c1 cr wcel cB
      cr wcel c1 cB cmin co cr wcel cB crp wcel c1 cB resubcl 1re cB rpre
      sylancr adantr cB crp wcel cB c1 clt wbr wa c1 cB cmin co cc0 wne c1 cB
      wne cB cr wcel c1 cr wcel cB c1 clt wbr c1 cB wne cB crp wcel cB c1 clt
      wbr wa cB c1 ltne cB crp wcel cB cr wcel cB c1 clt wbr cB rpre adantr c1
      cr wcel cB crp wcel cB c1 clt wbr wa 1re a1i cB crp wcel cB c1 clt wbr
      pm3.27 syl3anc cB crp wcel cB c1 clt wbr wa c1 cB cmin co cc0 c1 cB cB
      crp wcel c1 cB cmin co cc0 wceq c1 cB wceq wb cB c1 clt wbr c1 cc wcel cB
      cc wcel c1 cB cmin co cc0 wceq c1 cB wceq wb cB crp wcel c1 cB subeq0
      ax1cn cB rpcn sylancr adantr necon3bid mpbird sylanc 3adant1 adantr cA cr
      wcel cB crp wcel cB c1 clt wbr w3a cc0 c1 c1 cB cmin co cdiv co clt wbr
      cc0 cA clt wbr cB crp wcel cB c1 clt wbr cc0 c1 c1 cB cmin co cdiv co clt
      wbr cA cr wcel c1 cB cmin co cr wcel cc0 c1 cB cmin co clt wbr cc0 c1 c1
      cB cmin co cdiv co clt wbr cB crp wcel cB c1 clt wbr wa c1 cB cmin co
      recgt0 cB crp wcel c1 cB cmin co cr wcel cB c1 clt wbr c1 cr wcel cB cr
      wcel c1 cB cmin co cr wcel cB crp wcel c1 cB resubcl 1re cB rpre sylancr
      adantr cB crp wcel cB c1 clt wbr cc0 c1 cB cmin co clt wbr cB cr wcel c1
      cr wcel cB c1 clt wbr cc0 c1 cB cmin co clt wbr wb cB crp wcel cB c1
      posdif cB rpre 1re sylancl biimpa sylanc 3adant1 adantr syl2anc jca
      adantlr adantr syl3anc cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp
      wcel wa cc0 cA clt wbr wa vj cv cn wcel wa cA c1 c1 cB cmin co cdiv co
      cmul co cB vj cv cexp co cmul co cA cB vj cv cexp co cmul co c1 c1 cB
      cmin co cdiv co cmul co vx cv clt cA cc wcel c1 c1 cB cmin co cdiv co cc
      wcel cB vj cv cexp co cc wcel cA c1 c1 cB cmin co cdiv co cmul co cB vj
      cv cexp co cmul co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co wceq cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa
      cc0 cA clt wbr wa vj cv cn wcel wa cA c1 c1 cB cmin co cdiv co cB vj cv
      cexp co mul23 cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa
      cA cc wcel cc0 cA clt wbr vj cv cn wcel cA cr wcel cB crp wcel cB c1 clt
      wbr w3a cA cc wcel vx cv crp wcel cA cr wcel cB crp wcel cA cc wcel cB c1
      clt wbr cA recn 3ad2ant1 adantr ad2antrr cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vx cv crp wcel wa c1 c1 cB cmin co cdiv co cc wcel cc0 cA clt wbr
      vj cv cn wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 c1 cB cmin co
      cdiv co cc wcel vx cv crp wcel cB crp wcel cB c1 clt wbr c1 c1 cB cmin co
      cdiv co cc wcel cA cr wcel cB crp wcel cB c1 clt wbr wa c1 c1 cB cmin co
      cdiv co c1 cB cmin co cr wcel c1 cB cmin co cc0 wne c1 c1 cB cmin co cdiv
      co cr wcel cB crp wcel cB c1 clt wbr wa c1 cB cmin co rereccl cB crp wcel
      c1 cB cmin co cr wcel cB c1 clt wbr c1 cr wcel cB cr wcel c1 cB cmin co
      cr wcel cB crp wcel c1 cB resubcl 1re cB rpre sylancr adantr cB crp wcel
      cB c1 clt wbr wa c1 cB cmin co cc0 wne c1 cB wne cB cr wcel c1 cr wcel cB
      c1 clt wbr c1 cB wne cB crp wcel cB c1 clt wbr wa cB c1 ltne cB crp wcel
      cB cr wcel cB c1 clt wbr cB rpre adantr c1 cr wcel cB crp wcel cB c1 clt
      wbr wa 1re a1i cB crp wcel cB c1 clt wbr pm3.27 syl3anc cB crp wcel cB c1
      clt wbr wa c1 cB cmin co cc0 c1 cB cB crp wcel c1 cB cmin co cc0 wceq c1
      cB wceq wb cB c1 clt wbr c1 cc wcel cB cc wcel c1 cB cmin co cc0 wceq c1
      cB wceq wb cB crp wcel c1 cB subeq0 ax1cn cB rpcn sylancr adantr
      necon3bid mpbird sylanc recnd 3adant1 adantr ad2antrr cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vx cv crp wcel wa vj cv cn wcel cB vj cv cexp co
      cc wcel cc0 cA clt wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel cB vj cv cexp co cc wcel vx cv crp wcel cB crp wcel cA cr wcel vj cv
      cn wcel cB vj cv cexp co cc wcel cB c1 clt wbr cB crp wcel vj cv cn wcel
      wa cB vj cv cexp co cB cr wcel vj cv cn0 wcel cB vj cv cexp co cr wcel cB
      crp wcel vj cv cn wcel cB vj cv reexpcl cB rpre vj cv nnnn0 syl2an recnd
      3ad2antl2 adantlr adantlr syl3anc breq1d bitr3d rexbidva mpbid c1 cn wcel
      cA cB c1 cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr
      cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt
      wbr vj cn wrex cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel wa
      cc0 cA wceq wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul
      co vx cv clt wbr cA cB c1 cexp co cmul co c1 c1 cB cmin co cdiv co cmul
      co vx cv clt wbr vj c1 cn vj cv c1 wceq cA cB vj cv cexp co cmul co c1 c1
      cB cmin co cdiv co cmul co cA cB c1 cexp co cmul co c1 c1 cB cmin co cdiv
      co cmul co vx cv clt vj cv c1 wceq cA cB vj cv cexp co cmul co cA cB c1
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul vj cv c1 wceq cB vj cv cexp
      co cB c1 cexp co cA cmul vj cv c1 cB cexp opreq2 opreq2d opreq1d breq1d
      rcla4ev 1nn cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel cc0
      cA wceq cA cB c1 cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv
      clt wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a vx cv crp wcel cc0 cA
      wceq wa wa cA cB c1 cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cc0
      vx cv clt cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA wceq cA cB c1
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cc0 wceq vx cv crp wcel
      cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA wceq wa cA cB c1 cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co cc0 c1 c1 cB cmin co cdiv co
      cmul co cc0 cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA wceq wa cA cB
      c1 cexp co cmul co cc0 c1 c1 cB cmin co cdiv co cmul cc0 cA wceq cA cr
      wcel cB crp wcel cB c1 clt wbr w3a cA cB c1 cexp co cmul co cc0 cB c1
      cexp co cmul co cc0 cc0 cA wceq cc0 cB c1 cexp co cmul co cA cB c1 cexp
      co cmul co cc0 cA cB c1 cexp co cmul opreq1 eqcomd cB crp wcel cB c1 clt
      wbr cc0 cB c1 cexp co cmul co cc0 wceq cA cr wcel cB crp wcel cB c1 clt
      wbr wa cB c1 cexp co cc wcel cc0 cB c1 cexp co cmul co cc0 wceq cB crp
      wcel cB c1 cexp co cc wcel cB c1 clt wbr cB cc wcel c1 cn0 wcel cB c1
      cexp co cc wcel cB crp wcel cB c1 expcl cB rpcn 1nn0 sylancl adantr cB c1
      cexp co mul02 syl 3adant1 sylan9eqr opreq1d cA cr wcel cB crp wcel cB c1
      clt wbr w3a cc0 c1 c1 cB cmin co cdiv co cmul co cc0 wceq cc0 cA wceq cB
      crp wcel cB c1 clt wbr cc0 c1 c1 cB cmin co cdiv co cmul co cc0 wceq cA
      cr wcel cB crp wcel cB c1 clt wbr wa c1 c1 cB cmin co cdiv co cc wcel cc0
      c1 c1 cB cmin co cdiv co cmul co cc0 wceq cB crp wcel cB c1 clt wbr wa c1
      c1 cB cmin co cdiv co c1 cB cmin co cr wcel c1 cB cmin co cc0 wne c1 c1
      cB cmin co cdiv co cr wcel cB crp wcel cB c1 clt wbr wa c1 cB cmin co
      rereccl cB crp wcel c1 cB cmin co cr wcel cB c1 clt wbr c1 cr wcel cB cr
      wcel c1 cB cmin co cr wcel cB crp wcel c1 cB resubcl 1re cB rpre sylancr
      adantr cB crp wcel cB c1 clt wbr wa c1 cB cmin co cc0 wne c1 cB wne cB cr
      wcel c1 cr wcel cB c1 clt wbr c1 cB wne cB crp wcel cB c1 clt wbr wa cB
      c1 ltne cB crp wcel cB cr wcel cB c1 clt wbr cB rpre adantr c1 cr wcel cB
      crp wcel cB c1 clt wbr wa 1re a1i cB crp wcel cB c1 clt wbr pm3.27
      syl3anc cB crp wcel cB c1 clt wbr wa c1 cB cmin co cc0 c1 cB cB crp wcel
      c1 cB cmin co cc0 wceq c1 cB wceq wb cB c1 clt wbr c1 cc wcel cB cc wcel
      c1 cB cmin co cc0 wceq c1 cB wceq wb cB crp wcel c1 cB subeq0 ax1cn cB
      rpcn sylancr adantr necon3bid mpbird sylanc recnd c1 c1 cB cmin co cdiv
      co mul02 syl 3adant1 adantr eqtrd adantrl vx cv crp wcel cc0 vx cv clt
      wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 cA wceq vx cv rpgt0
      ad2antrl eqbrtrd anassrs sylancr jaodan ex 3ad2antl2 sylbid mpd cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vx cv crp wcel wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co vx cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF
      cfv cM co vx cv clt wbr wi vm cn wral vj cn cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp
      wcel wa vj cv cn wcel wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co vx cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF
      cfv cM co vx cv clt wbr wi vm cn cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel wa vj cv
      cn wcel vm cv cn wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv
      co cmul co vx cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM
      co vx cv clt wbr wi wi cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv
      cn wcel wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co
      vx cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv
      clt wbr wi wi cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv cn wcel
      wa wa wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx
      cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt
      wbr wi cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv cn wcel wa
      wa wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv
      clt wbr wa vj cv vm cv cle wbr vj cv vm cv clt wbr vj vm weq wo vj cv cF
      cfv vm cv cF cfv cM co vx cv clt wbr vx cv crp wcel vj cv cn wcel vm cv
      cn wcel wa wa vj cv vm cv cle wbr vj cv vm cv clt wbr vj vm weq wo wi cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk
      cn wral w3a cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co
      vx cv clt wbr vj cv cn wcel vm cv cn wcel wa vj cv vm cv cle wbr vj cv vm
      cv clt wbr vj vm weq wo wi vx cv crp wcel vj cv cr wcel vm cv cr wcel vj
      cv vm cv cle wbr vj cv vm cv clt wbr vj vm weq wo wi vj cv cn wcel vm cv
      cn wcel vj cv cr wcel vm cv cr wcel wa vj cv vm cv cle wbr vj cv vm cv
      clt wbr vj vm weq wo vj cv vm cv leloe biimpd vj cv nnre vm cv nnre
      syl2an adantl ad2antlr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv
      cn wcel wa wa wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co vx cv clt wbr wa vj cv vm cv clt wbr vj cv cF cfv vm cv cF cfv cM
      co vx cv clt wbr vj vm weq cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel
      vm cv cn wcel wa wa wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv
      co cmul co vx cv clt wbr wa vj cv vm cv clt wbr vm cv vj cv c1 caddc co
      cuz cfv wcel vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr vx cv crp wcel
      vj cv cn wcel vm cv cn wcel wa wa vj cv vm cv clt wbr vm cv vj cv c1
      caddc co cuz cfv wcel wb cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral w3a cA cB vj cv cexp co cmul co
      c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr vj cv cn wcel vm cv cn
      wcel wa vj cv vm cv clt wbr vm cv vj cv c1 caddc co cuz cfv wcel wb vx cv
      crp wcel vj cv cn wcel vm cv cn wcel wa vj cv vm cv clt wbr vj cv c1
      caddc co vm cv cle wbr vm cv vj cv c1 caddc co cuz cfv wcel vj cv vm cv
      nnltp1le vj cv c1 caddc co cz wcel vm cv cz wcel vm cv vj cv c1 caddc co
      cuz cfv wcel vj cv c1 caddc co vm cv cle wbr wb vj cv cn wcel vm cv cn
      wcel vj cv c1 caddc co vm cv eluz vj cv cn wcel vj cv vj cv nnz peano2zdi
      vm cv nnz syl2an bitr4d adantl ad2antlr cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel
      vj cv cn wcel vm cv cn wcel wa wa wa cA cB vj cv cexp co cmul co c1 c1 cB
      cmin co cdiv co cmul co vx cv clt wbr wa vm cv vj cv c1 caddc co cuz cfv
      wcel vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr cM cme wcel cn cX cF
      wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vx cv crp wcel vj cv cn wcel vm cv cn wcel wa wa wa cA cB vj cv cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr wa vm cv vj cv c1
      caddc co cuz cfv wcel wa vj cv cF cfv vm cv cF cfv cM co cA cB vj cv cexp
      co cmul co c1 c1 cB cmin co cdiv co cmul co vx cv cM cme wcel cn cX cF wf
      wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv
      crp wcel vj cv cn wcel vm cv cn wcel wa wa wa vj cv cF cfv vm cv cF cfv
      cM co cr wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul
      co vx cv clt wbr vm cv vj cv c1 caddc co cuz cfv wcel cM cme wcel cn cX
      cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vj cv cn wcel vm cv cn wcel wa vj cv cF cfv vm cv cF cfv cM co cr wcel vx
      cv crp wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vj cv cn wcel vm cv cn wcel wa vj cv cF cfv vm cv cF cfv cM co cr
      wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral cM cme wcel cn cX cF wf vj cv cn wcel vm cv cn wcel
      wa vj cv cF cfv vm cv cF cfv cM co cr wcel cM cme wcel vj cv cF cfv cX
      wcel vm cv cF cfv cX wcel wa vj cv cF cfv vm cv cF cfv cM co cr wcel cn
      cX cF wf vj cv cn wcel vm cv cn wcel wa wa cM cme wcel vj cv cF cfv cX
      wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF cfv cM co cr wcel vj cv
      cF cfv vm cv cF cfv cM cX geomcau.1 metcl 3expb cn cX cF wf vj cv cn wcel
      vm cv cn wcel wa vj cv cF cfv cX wcel vm cv cF cfv cX wcel wa cn cX cF wf
      vj cv cn wcel vj cv cF cfv cX wcel vm cv cn wcel vm cv cF cfv cX wcel cn
      cX cF wf vj cv cn wcel vj cv cF cfv cX wcel cn cX vj cv cF ffvelrn ex cn
      cX cF wf vm cv cn wcel vm cv cF cfv cX wcel cn cX vm cv cF ffvelrn ex
      anim12d imp sylan2 anassrs 3ad2antl1 adantrl ad2antrr cM cme wcel cn cX
      cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vx cv crp wcel vj cv cn wcel vm cv cn wcel wa wa wa cA cB vj cv cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel cA cB vj cv cexp co cmul
      co c1 c1 cB cmin co cdiv co cmul co vx cv clt wbr vm cv vj cv c1 caddc co
      cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel vx cv crp wcel
      cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa vj cv
      cn wcel vm cv cn wcel wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co cr wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vj cv cn wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv
      co cmul co cr wcel vm cv cn wcel cA cB vj cv cexp co cmul co cr wcel c1
      c1 cB cmin co cdiv co cr wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin
      co cdiv co cmul co cr wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv
      cn wcel wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co remulcl
      cA cr wcel cB crp wcel vj cv cn wcel cA cB vj cv cexp co cmul co cr wcel
      cB c1 clt wbr cA cr wcel cB crp wcel vj cv cn wcel cA cB vj cv cexp co
      cmul co cr wcel cA cr wcel cB vj cv cexp co cr wcel cA cB vj cv cexp co
      cmul co cr wcel cB crp wcel vj cv cn wcel wa cA cB vj cv cexp co remulcl
      cB cr wcel vj cv cn0 wcel cB vj cv cexp co cr wcel cB crp wcel vj cv cn
      wcel cB vj cv reexpcl cB rpre vj cv nnnn0 syl2an sylan2 anassrs 3adantl3
      cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 c1 cB cmin co cdiv co cr wcel
      vj cv cn wcel cB crp wcel cB c1 clt wbr c1 c1 cB cmin co cdiv co cr wcel
      cA cr wcel c1 cB cmin co cr wcel c1 cB cmin co cc0 wne c1 c1 cB cmin co
      cdiv co cr wcel cB crp wcel cB c1 clt wbr wa c1 cB cmin co rereccl cB crp
      wcel c1 cB cmin co cr wcel cB c1 clt wbr c1 cr wcel cB cr wcel c1 cB cmin
      co cr wcel cB crp wcel c1 cB resubcl 1re cB rpre sylancr adantr cB crp
      wcel cB c1 clt wbr wa c1 cB cmin co cc0 wne c1 cB wne cB cr wcel c1 cr
      wcel cB c1 clt wbr c1 cB wne cB crp wcel cB c1 clt wbr wa cB c1 ltne cB
      crp wcel cB cr wcel cB c1 clt wbr cB rpre adantr c1 cr wcel cB crp wcel
      cB c1 clt wbr wa 1re a1i cB crp wcel cB c1 clt wbr pm3.27 syl3anc cB crp
      wcel cB c1 clt wbr wa c1 cB cmin co cc0 c1 cB cB crp wcel c1 cB cmin co
      cc0 wceq c1 cB wceq wb cB c1 clt wbr c1 cc wcel cB cc wcel c1 cB cmin co
      cc0 wceq c1 cB wceq wb cB crp wcel c1 cB subeq0 ax1cn cB rpcn sylancr
      adantr necon3bid mpbird sylanc 3adant1 adantr sylanc adantrr 3ad2antl2
      adantrl ad2antrr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1
      clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp
      co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv cn
      wcel wa wa wa vx cv cr wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co vx cv clt wbr vm cv vj cv c1 caddc co cuz cfv wcel vx cv
      crp wcel vx cv cr wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vx
      cv rpre ad2antrl ad2antrr cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel
      vm cv cn wcel wa wa wa vm cv vj cv c1 caddc co cuz cfv wcel vj cv cF cfv
      vm cv cF cfv cM co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co cle wbr cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul
      co vx cv clt wbr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1
      clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp
      co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv cn
      wcel wa wa wa vm cv vj cv c1 caddc co cuz cfv wcel wa vj cv cF cfv vm cv
      cF cfv cM co vj cv vm cv c1 cmin co cfz co vn cv cF cfv vn cv c1 caddc co
      cF cfv cM co vn csu cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv cn wcel wa
      wa wa vj cv cF cfv vm cv cF cfv cM co cr wcel vm cv vj cv c1 caddc co cuz
      cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vj cv cF cfv vm
      cv cF cfv cM co cr wcel vx cv crp wcel cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel vm cv cn wcel wa vj cv
      cF cfv vm cv cF cfv cM co cr wcel vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cM cme wcel cn cX cF
      wf vj cv cn wcel vm cv cn wcel wa vj cv cF cfv vm cv cF cfv cM co cr wcel
      cM cme wcel vj cv cF cfv cX wcel vm cv cF cfv cX wcel wa vj cv cF cfv vm
      cv cF cfv cM co cr wcel cn cX cF wf vj cv cn wcel vm cv cn wcel wa wa cM
      cme wcel vj cv cF cfv cX wcel vm cv cF cfv cX wcel vj cv cF cfv vm cv cF
      cfv cM co cr wcel vj cv cF cfv vm cv cF cfv cM cX geomcau.1 metcl 3expb
      cn cX cF wf vj cv cn wcel vm cv cn wcel wa vj cv cF cfv cX wcel vm cv cF
      cfv cX wcel wa cn cX cF wf vj cv cn wcel vj cv cF cfv cX wcel vm cv cn
      wcel vm cv cF cfv cX wcel cn cX cF wf vj cv cn wcel vj cv cF cfv cX wcel
      cn cX vj cv cF ffvelrn ex cn cX cF wf vm cv cn wcel vm cv cF cfv cX wcel
      cn cX vm cv cF ffvelrn ex anim12d imp sylan2 anassrs 3ad2antl1 adantrl
      adantr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1
      caddc co cuz cfv wcel vj cv vm cv c1 cmin co cfz co vn cv cF cfv vn cv c1
      caddc co cF cfv cM co vn csu cr wcel vx cv crp wcel cM cme wcel cn cX cF
      wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel vj cv
      vm cv c1 cmin co cfz co vn cv cF cfv vn cv c1 caddc co cF cfv cM co vn
      csu cr wcel vm cv c1 cmin co vj cv cuz cfv wcel vn cv cF cfv vn cv c1
      caddc co cF cfv cM co cr wcel vn vj cv vm cv c1 cmin co cfz co wral vj cv
      vm cv c1 cmin co cfz co vn cv cF cfv vn cv c1 caddc co cF cfv cM co vn
      csu cr wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv
      c1 caddc co cuz cfv wcel wa wa vn cv cF cfv vn cv c1 caddc co cF cfv cM
      co vn vj cv vm cv c1 cmin co fsumrecl vj cv cn wcel vm cv cn wcel wa vm
      cv vj cv c1 caddc co cuz cfv wcel wa vm cv c1 cmin co vj cv cuz cfv wcel
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a vj cv cn wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv
      c1 cmin co vj cv cuz cfv wcel vm cv cn wcel vj cv cn wcel c1 cz wcel vm
      cv vj cv c1 caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel 1z
      vj cv cz wcel c1 cz wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv c1
      cmin co vj cv cuz cfv wcel vj cv cn wcel c1 vj cv vm cv eluzsub vj cv nnz
      syl3an1 mp3an2 adantlr adantl cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel vn vj cv vm
      cv c1 cmin co cfz co wral vm cv vj cv c1 caddc co cuz cfv wcel cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr
      wcel vn vj cv vm cv c1 cmin co cfz co wral vm cv cn wcel cM cme wcel cn
      cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral
      w3a vj cv cn wcel wa vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel
      vn vj cv vm cv c1 cmin co cfz co cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vn cv vj cv
      vm cv c1 cmin co cfz co wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co
      cr wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vj cv cn wcel vn cv vj cv vm cv c1 cmin co cfz co wcel wa vn cv cF
      cfv vn cv c1 caddc co cF cfv cM co cr wcel vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cM cme wcel
      cn cX cF wf wa vn cv cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co
      cr wcel vj cv cn wcel vn cv vj cv vm cv c1 cmin co cfz co wcel wa cM cme
      wcel cn cX cF wf vn cv cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM
      co cr wcel cM cme wcel vn cv cF cfv cX wcel vn cv c1 caddc co cF cfv cX
      wcel wa vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel cn cX cF wf
      vn cv cn wcel wa cM cme wcel vn cv cF cfv cX wcel vn cv c1 caddc co cF
      cfv cX wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel vn cv cF
      cfv vn cv c1 caddc co cF cfv cM cX geomcau.1 metcl 3expb cn cX cF wf vn
      cv cn wcel wa vn cv cF cfv cX wcel vn cv c1 caddc co cF cfv cX wcel cn cX
      vn cv cF ffvelrn cn cX cF wf vn cv c1 caddc co cn wcel vn cv c1 caddc co
      cF cfv cX wcel vn cv cn wcel cn cX vn cv c1 caddc co cF ffvelrn vn cv
      peano2nn sylan2 jca sylan2 anassrs vj cv cn wcel vn cv vj cv cuz cfv wcel
      vn cv cn wcel vn cv vj cv vm cv c1 cmin co cfz co wcel vj cv cn wcel vn
      cv vj cv cuz cfv wcel wa vn cv c1 cuz cfv wcel vn cv cn wcel vj cv cuz
      cfv c1 cuz cfv wss vn cv vj cv cuz cfv wcel vn cv c1 cuz cfv wcel vj cv
      cn wcel vj cv cuz cfv c1 cuz cfv vn cv ssel2 vj cv cn wcel vj cv c1 cuz
      cfv wcel vj cv cuz cfv c1 cuz cfv wss vj cv elnnuz c1 vj cv uzss sylbi
      sylan vn cv elnnuz sylibr vn cv vj cv vm cv c1 cmin co elfzuz sylan2
      sylan2 3ad2antl1 anassrs r19.21aiva adantrr adantrr sylanc anassrs
      adantlrl cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vx cv crp wcel vj cv cn wcel vm cv cn wcel wa
      wa wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr
      wcel vm cv vj cv c1 caddc co cuz cfv wcel cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vm cv cn wcel wa cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv
      co cmul co cr wcel vx cv crp wcel cA cr wcel cB crp wcel cB c1 clt wbr
      w3a cM cme wcel cn cX cF wf wa vj cv cn wcel vm cv cn wcel wa cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel vm cv cn wcel cA
      cB vj cv cexp co cmul co cr wcel c1 c1 cB cmin co cdiv co cr wcel cA cB
      vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa cA cB vj cv cexp co cmul
      co c1 c1 cB cmin co cdiv co remulcl cA cr wcel cB crp wcel vj cv cn wcel
      cA cB vj cv cexp co cmul co cr wcel cB c1 clt wbr cA cr wcel cB crp wcel
      vj cv cn wcel cA cB vj cv cexp co cmul co cr wcel cA cr wcel cB vj cv
      cexp co cr wcel cA cB vj cv cexp co cmul co cr wcel cB crp wcel vj cv cn
      wcel wa cA cB vj cv cexp co remulcl cB cr wcel vj cv cn0 wcel cB vj cv
      cexp co cr wcel cB crp wcel vj cv cn wcel cB vj cv reexpcl cB rpre vj cv
      nnnn0 syl2an sylan2 anassrs 3adantl3 cA cr wcel cB crp wcel cB c1 clt wbr
      w3a c1 c1 cB cmin co cdiv co cr wcel vj cv cn wcel cB crp wcel cB c1 clt
      wbr c1 c1 cB cmin co cdiv co cr wcel cA cr wcel c1 cB cmin co cr wcel c1
      cB cmin co cc0 wne c1 c1 cB cmin co cdiv co cr wcel cB crp wcel cB c1 clt
      wbr wa c1 cB cmin co rereccl cB crp wcel c1 cB cmin co cr wcel cB c1 clt
      wbr c1 cr wcel cB cr wcel c1 cB cmin co cr wcel cB crp wcel c1 cB resubcl
      1re cB rpre sylancr adantr cB crp wcel cB c1 clt wbr wa c1 cB cmin co cc0
      wne c1 cB wne cB cr wcel c1 cr wcel cB c1 clt wbr c1 cB wne cB crp wcel
      cB c1 clt wbr wa cB c1 ltne cB crp wcel cB cr wcel cB c1 clt wbr cB rpre
      adantr c1 cr wcel cB crp wcel cB c1 clt wbr wa 1re a1i cB crp wcel cB c1
      clt wbr pm3.27 syl3anc cB crp wcel cB c1 clt wbr wa c1 cB cmin co cc0 c1
      cB cB crp wcel c1 cB cmin co cc0 wceq c1 cB wceq wb cB c1 clt wbr c1 cc
      wcel cB cc wcel c1 cB cmin co cc0 wceq c1 cB wceq wb cB crp wcel c1 cB
      subeq0 ax1cn cB rpcn sylancr adantr necon3bid mpbird sylanc 3adant1
      adantr sylanc adantrr 3ad2antl2 adantrl adantr cM cme wcel cn cX cF wf wa
      vj cv cz wcel vm cv vj cv c1 caddc co cuz cfv wcel vj cv vm cv cfz co cn
      wss w3a vj cv cF cfv vm cv cF cfv cM co vj cv vm cv c1 cmin co cfz co vn
      cv cF cfv vn cv c1 caddc co cF cfv cM co vn csu cle wbr cM cme wcel cn cX
      cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vx cv crp wcel vj cv cn wcel vm cv cn wcel wa wa wa vm cv vj cv c1 caddc
      co cuz cfv wcel wa vm cv cn vn cF cM vj cv cX geomcau.1 nnex mettrifi2 cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk
      cn wral w3a cM cme wcel cn cX cF wf wa vx cv crp wcel vj cv cn wcel vm cv
      cn wcel wa wa vm cv vj cv c1 caddc co cuz cfv wcel cM cme wcel cn cX cF
      wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral
      3simp1 ad2antrr vx cv crp wcel vj cv cn wcel vm cv cn wcel wa wa vm cv vj
      cv c1 caddc co cuz cfv wcel vj cv cz wcel vm cv vj cv c1 caddc co cuz cfv
      wcel vj cv vm cv cfz co cn wss w3a cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel vj cv cz wcel vm cv vj cv c1
      caddc co cuz cfv wcel vj cv vm cv cfz co cn wss w3a vx cv crp wcel vj cv
      cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa vj cv cz
      wcel vm cv vj cv c1 caddc co cuz cfv wcel vj cv vm cv cfz co cn wss vj cv
      cn wcel vj cv cz wcel vm cv cn wcel vm cv vj cv c1 caddc co cuz cfv wcel
      vj cv nnz ad2antrr vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co
      cuz cfv wcel pm3.27 vj cv cn wcel vj cv vm cv cfz co cn wss vm cv cn wcel
      vm cv vj cv c1 caddc co cuz cfv wcel vj cv cn wcel vj cv vm cv cfz co vj
      cv cuz cfv cn vj cv vm cv cfz co vj cv cuz cfv wss vj cv cn wcel vj cv vm
      cv fzssuz a1i vj cv cn wcel vj cv cuz cfv c1 cuz cfv cn vj cv cn wcel vj
      cv c1 cuz cfv wcel vj cv cuz cfv c1 cuz cfv wss vj cv elnnuz c1 vj cv
      uzss sylbi nnuz syl6ssr sstrd ad2antrr 3jca adantll adantll sylanc cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv
      wcel vj cv vm cv c1 cmin co cfz co vn cv cF cfv vn cv c1 caddc co cF cfv
      cM co vn csu cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co
      cle wbr vx cv crp wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm
      cv vj cv c1 caddc co cuz cfv wcel vj cv vm cv c1 cmin co cfz co vn cv cF
      cfv vn cv c1 caddc co cF cfv cM co vn csu cA cB vj cv cexp co cmul co c1
      c1 cB cmin co cdiv co cmul co cle wbr cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm
      cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv vm cv c1
      cmin co cfz co vn cv cF cfv vn cv c1 caddc co cF cfv cM co vn csu vj cv
      vm cv c1 cmin co cfz co cA cB vn cv cexp co cmul co vn csu cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co vm cv c1 cmin co vj cv
      cuz cfv wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel vn vj cv
      vm cv c1 cmin co cfz co wral vj cv vm cv c1 cmin co cfz co vn cv cF cfv
      vn cv c1 caddc co cF cfv cM co vn csu cr wcel cM cme wcel cn cX cF wf wa
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vn cv cF
      cfv vn cv c1 caddc co cF cfv cM co vn vj cv vm cv c1 cmin co fsumrecl vj
      cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa vm cv
      c1 cmin co vj cv cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv vj cv
      c1 caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel vm cv cn
      wcel vj cv cn wcel c1 cz wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv
      c1 cmin co vj cv cuz cfv wcel 1z vj cv cz wcel c1 cz wcel vm cv vj cv c1
      caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel vj cv cn wcel
      c1 vj cv vm cv eluzsub vj cv nnz syl3an1 mp3an2 adantlr adantl cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vm cv cn wcel wa vn cv cF cfv vn cv c1 caddc co cF
      cfv cM co cr wcel vn vj cv vm cv c1 cmin co cfz co wral vm cv vj cv c1
      caddc co cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vn cv cF cfv vn cv
      c1 caddc co cF cfv cM co cr wcel vn vj cv vm cv c1 cmin co cfz co wral vm
      cv cn wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vj cv cn wcel wa vn cv cF cfv vn cv c1
      caddc co cF cfv cM co cr wcel vn vj cv vm cv c1 cmin co cfz co cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vn cv vj cv vm cv c1 cmin co cfz co wcel vn cv cF
      cfv vn cv c1 caddc co cF cfv cM co cr wcel cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel vn cv vj cv vm cv c1
      cmin co cfz co wcel wa vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr
      wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral cM cme wcel cn cX cF wf wa vn cv cn wcel vn cv cF
      cfv vn cv c1 caddc co cF cfv cM co cr wcel vj cv cn wcel vn cv vj cv vm
      cv c1 cmin co cfz co wcel wa cM cme wcel cn cX cF wf vn cv cn wcel vn cv
      cF cfv vn cv c1 caddc co cF cfv cM co cr wcel cM cme wcel vn cv cF cfv cX
      wcel vn cv c1 caddc co cF cfv cX wcel wa vn cv cF cfv vn cv c1 caddc co
      cF cfv cM co cr wcel cn cX cF wf vn cv cn wcel wa cM cme wcel vn cv cF
      cfv cX wcel vn cv c1 caddc co cF cfv cX wcel vn cv cF cfv vn cv c1 caddc
      co cF cfv cM co cr wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM cX
      geomcau.1 metcl 3expb cn cX cF wf vn cv cn wcel wa vn cv cF cfv cX wcel
      vn cv c1 caddc co cF cfv cX wcel cn cX vn cv cF ffvelrn cn cX cF wf vn cv
      c1 caddc co cn wcel vn cv c1 caddc co cF cfv cX wcel vn cv cn wcel cn cX
      vn cv c1 caddc co cF ffvelrn vn cv peano2nn sylan2 jca sylan2 anassrs vj
      cv cn wcel vn cv vj cv cuz cfv wcel vn cv cn wcel vn cv vj cv vm cv c1
      cmin co cfz co wcel vj cv cn wcel vn cv vj cv cuz cfv wcel wa vn cv c1
      cuz cfv wcel vn cv cn wcel vj cv cuz cfv c1 cuz cfv wss vn cv vj cv cuz
      cfv wcel vn cv c1 cuz cfv wcel vj cv cn wcel vj cv cuz cfv c1 cuz cfv vn
      cv ssel2 vj cv cn wcel vj cv c1 cuz cfv wcel vj cv cuz cfv c1 cuz cfv wss
      vj cv elnnuz c1 vj cv uzss sylbi sylan vn cv elnnuz sylibr vn cv vj cv vm
      cv c1 cmin co elfzuz sylan2 sylan2 3ad2antl1 anassrs r19.21aiva adantrr
      adantrr sylanc vm cv c1 cmin co vj cv cuz cfv wcel cA cB vn cv cexp co
      cmul co cr wcel vn vj cv vm cv c1 cmin co cfz co wral vj cv vm cv c1 cmin
      co cfz co cA cB vn cv cexp co cmul co vn csu cr wcel cM cme wcel cn cX cF
      wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa
      cA cB vn cv cexp co cmul co vn vj cv vm cv c1 cmin co fsumrecl vj cv cn
      wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa vm cv c1
      cmin co vj cv cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv vj cv c1
      caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel vm cv cn wcel
      vj cv cn wcel c1 cz wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv c1
      cmin co vj cv cuz cfv wcel 1z vj cv cz wcel c1 cz wcel vm cv vj cv c1
      caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel vj cv cn wcel
      c1 vj cv vm cv eluzsub vj cv nnz syl3an1 mp3an2 adantlr adantl cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vm cv cn wcel wa cA cB vn cv cexp co cmul co cr
      wcel vn vj cv vm cv c1 cmin co cfz co wral vm cv vj cv c1 caddc co cuz
      cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vj cv cn wcel cA cB vn cv cexp co cmul co cr
      wcel vn vj cv vm cv c1 cmin co cfz co wral vm cv cn wcel cA cr wcel cB
      crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa vj cv cn wcel cA cB
      vn cv cexp co cmul co cr wcel vn vj cv vm cv c1 cmin co cfz co wral vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral cA cr wcel cB crp wcel vj cv cn wcel cA cB vn cv cexp co cmul
      co cr wcel vn vj cv vm cv c1 cmin co cfz co wral cB c1 clt wbr cA cr wcel
      cB crp wcel wa vj cv cn wcel wa cA cB vn cv cexp co cmul co cr wcel vn vj
      cv vm cv c1 cmin co cfz co cA cr wcel cB crp wcel wa vj cv cn wcel vn cv
      vj cv vm cv c1 cmin co cfz co wcel cA cB vn cv cexp co cmul co cr wcel cA
      cr wcel cB crp wcel wa vn cv cn0 wcel cA cB vn cv cexp co cmul co cr wcel
      vj cv cn wcel vn cv vj cv vm cv c1 cmin co cfz co wcel wa cA cr wcel cB
      crp wcel vn cv cn0 wcel cA cB vn cv cexp co cmul co cr wcel cA cr wcel cB
      vn cv cexp co cr wcel cA cB vn cv cexp co cmul co cr wcel cB crp wcel vn
      cv cn0 wcel wa cA cB vn cv cexp co remulcl cB cr wcel vn cv cn0 wcel cB
      vn cv cexp co cr wcel cB crp wcel cB vn cv reexpcl cB rpre sylan sylan2
      anassrs vj cv cn wcel vn cv vj cv cuz cfv wcel vn cv cn0 wcel vn cv vj cv
      vm cv c1 cmin co cfz co wcel vj cv cn wcel vn cv vj cv cuz cfv wcel wa vn
      cv cn wcel vn cv cn0 wcel vj cv cn wcel vn cv vj cv cuz cfv wcel wa vn cv
      c1 cuz cfv wcel vn cv cn wcel vj cv cuz cfv c1 cuz cfv wss vn cv vj cv
      cuz cfv wcel vn cv c1 cuz cfv wcel vj cv cn wcel vj cv cuz cfv c1 cuz cfv
      vn cv ssel2 vj cv cn wcel vj cv c1 cuz cfv wcel vj cv cuz cfv c1 cuz cfv
      wss vj cv elnnuz c1 vj cv uzss sylbi sylan vn cv elnnuz sylibr vn cv
      nnnn0 syl vn cv vj cv vm cv c1 cmin co elfzuz sylan2 sylan2 anassrs
      r19.21aiva 3adantl3 3ad2antl2 adantrr adantrr sylanc cA cr wcel cB crp
      wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa cA cB vj cv cexp co cmul
      co c1 c1 cB cmin co cdiv co cmul co cr wcel vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vj cv cn wcel vm cv cn wcel wa cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel vm cv vj cv c1
      caddc co cuz cfv wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cr wcel
      vm cv cn wcel cA cB vj cv cexp co cmul co cr wcel c1 c1 cB cmin co cdiv
      co cr wcel cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co
      cr wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa cA cB
      vj cv cexp co cmul co c1 c1 cB cmin co cdiv co remulcl cA cr wcel cB crp
      wcel vj cv cn wcel cA cB vj cv cexp co cmul co cr wcel cB c1 clt wbr cA
      cr wcel cB crp wcel vj cv cn wcel cA cB vj cv cexp co cmul co cr wcel cA
      cr wcel cB vj cv cexp co cr wcel cA cB vj cv cexp co cmul co cr wcel cB
      crp wcel vj cv cn wcel wa cA cB vj cv cexp co remulcl cB cr wcel vj cv
      cn0 wcel cB vj cv cexp co cr wcel cB crp wcel vj cv cn wcel cB vj cv
      reexpcl cB rpre vj cv nnnn0 syl2an sylan2 anassrs 3adantl3 cA cr wcel cB
      crp wcel cB c1 clt wbr w3a c1 c1 cB cmin co cdiv co cr wcel vj cv cn wcel
      cB crp wcel cB c1 clt wbr c1 c1 cB cmin co cdiv co cr wcel cA cr wcel c1
      cB cmin co cr wcel c1 cB cmin co cc0 wne c1 c1 cB cmin co cdiv co cr wcel
      cB crp wcel cB c1 clt wbr wa c1 cB cmin co rereccl cB crp wcel c1 cB cmin
      co cr wcel cB c1 clt wbr c1 cr wcel cB cr wcel c1 cB cmin co cr wcel cB
      crp wcel c1 cB resubcl 1re cB rpre sylancr adantr cB crp wcel cB c1 clt
      wbr wa c1 cB cmin co cc0 wne c1 cB wne cB cr wcel c1 cr wcel cB c1 clt
      wbr c1 cB wne cB crp wcel cB c1 clt wbr wa cB c1 ltne cB crp wcel cB cr
      wcel cB c1 clt wbr cB rpre adantr c1 cr wcel cB crp wcel cB c1 clt wbr wa
      1re a1i cB crp wcel cB c1 clt wbr pm3.27 syl3anc cB crp wcel cB c1 clt
      wbr wa c1 cB cmin co cc0 c1 cB cB crp wcel c1 cB cmin co cc0 wceq c1 cB
      wceq wb cB c1 clt wbr c1 cc wcel cB cc wcel c1 cB cmin co cc0 wceq c1 cB
      wceq wb cB crp wcel c1 cB subeq0 ax1cn cB rpcn sylancr adantr necon3bid
      mpbird sylanc 3adant1 adantr sylanc adantrr adantrr 3ad2antl2 vm cv c1
      cmin co vj cv cuz cfv wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr
      wcel cA cB vn cv cexp co cmul co cr wcel vn cv cF cfv vn cv c1 caddc co
      cF cfv cM co cA cB vn cv cexp co cmul co cle wbr w3a vn vj cv vm cv c1
      cmin co cfz co wral vj cv vm cv c1 cmin co cfz co vn cv cF cfv vn cv c1
      caddc co cF cfv cM co vn csu vj cv vm cv c1 cmin co cfz co cA cB vn cv
      cexp co cmul co vn csu cle wbr cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vn cv cF cfv vn cv c1
      caddc co cF cfv cM co cA cB vn cv cexp co cmul co vn vj cv vm cv c1 cmin
      co fsumcmp vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv
      wcel wa vm cv c1 cmin co vj cv cuz cfv wcel cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv
      wcel vm cv cn wcel vj cv cn wcel c1 cz wcel vm cv vj cv c1 caddc co cuz
      cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel 1z vj cv cz wcel c1 cz wcel
      vm cv vj cv c1 caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel
      vj cv cn wcel c1 vj cv vm cv eluzsub vj cv nnz syl3an1 mp3an2 adantlr
      adantl cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1
      caddc co cuz cfv wcel wa wa vn cv cF cfv vn cv c1 caddc co cF cfv cM co
      cr wcel cA cB vn cv cexp co cmul co cr wcel vn cv cF cfv vn cv c1 caddc
      co cF cfv cM co cA cB vn cv cexp co cmul co cle wbr w3a vn vj cv vm cv c1
      cmin co cfz co cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1
      clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp
      co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj
      cv c1 caddc co cuz cfv wcel wa wa vn cv vj cv vm cv c1 cmin co cfz co
      wcel wa vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel cA cB vn cv
      cexp co cmul co cr wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cA cB
      vn cv cexp co cmul co cle wbr cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vn cv vj cv vm cv c1
      cmin co cfz co wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz
      cfv wcel wa wa vn cv vj cv vm cv c1 cmin co cfz co wcel vn cv cn wcel vn
      cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel cM cme wcel cn cX cF wf
      wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv
      cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv
      vm cv c1 cmin co cfz co cn vn cv vj cv cn wcel vm cv cn wcel wa vm cv vj
      cv c1 caddc co cuz cfv wcel wa vj cv vm cv c1 cmin co cfz co cn wss cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk
      cn wral w3a vj cv cn wcel vj cv vm cv c1 cmin co cfz co cn wss vm cv cn
      wcel vm cv vj cv c1 caddc co cuz cfv wcel vj cv cn wcel vj cv vm cv c1
      cmin co cfz co vj cv cuz cfv cn vj cv vm cv c1 cmin co cfz co vj cv cuz
      cfv wss vj cv cn wcel vj cv vm cv c1 cmin co fzssuz a1i vj cv cn wcel vj
      cv cuz cfv c1 cuz cfv cn vj cv cn wcel vj cv c1 cuz cfv wcel vj cv cuz
      cfv c1 cuz cfv wss vj cv elnnuz c1 vj cv uzss sylbi nnuz syl6ssr sstrd
      ad2antrr adantl sseld cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vn cv cn wcel vn cv cF cfv vn cv
      c1 caddc co cF cfv cM co cr wcel wi vj cv cn wcel vm cv cn wcel wa vm cv
      vj cv c1 caddc co cuz cfv wcel wa cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vn cv cn wcel vn cv cF cfv vn cv c1 caddc
      co cF cfv cM co cr wcel wi vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral cM cme wcel cn cX cF wf vn cv
      cn wcel vn cv cF cfv vn cv c1 caddc co cF cfv cM co cr wcel cM cme wcel
      vn cv cF cfv cX wcel vn cv c1 caddc co cF cfv cX wcel wa vn cv cF cfv vn
      cv c1 caddc co cF cfv cM co cr wcel cn cX cF wf vn cv cn wcel wa cM cme
      wcel vn cv cF cfv cX wcel vn cv c1 caddc co cF cfv cX wcel vn cv cF cfv
      vn cv c1 caddc co cF cfv cM co cr wcel vn cv cF cfv vn cv c1 caddc co cF
      cfv cM cX geomcau.1 metcl 3expb cn cX cF wf vn cv cn wcel wa vn cv cF cfv
      cX wcel vn cv c1 caddc co cF cfv cX wcel cn cX vn cv cF ffvelrn cn cX cF
      wf vn cv c1 caddc co cn wcel vn cv c1 caddc co cF cfv cX wcel vn cv cn
      wcel cn cX vn cv c1 caddc co cF ffvelrn vn cv peano2nn sylan2 jca sylan2
      expr 3ad2ant1 adantr syld imp cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vn cv vj cv vm cv c1
      cmin co cfz co wcel cA cB vn cv cexp co cmul co cr wcel cM cme wcel cn cX
      cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a
      vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa
      vn cv vj cv vm cv c1 cmin co cfz co wcel vn cv cn wcel cA cB vn cv cexp
      co cmul co cr wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB
      c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm
      cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv vm cv c1 cmin co cfz co cn
      vn cv vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel
      wa vj cv vm cv c1 cmin co cfz co cn wss cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vj
      cv vm cv c1 cmin co cfz co cn wss vm cv cn wcel vm cv vj cv c1 caddc co
      cuz cfv wcel vj cv cn wcel vj cv vm cv c1 cmin co cfz co vj cv cuz cfv cn
      vj cv vm cv c1 cmin co cfz co vj cv cuz cfv wss vj cv cn wcel vj cv vm cv
      c1 cmin co fzssuz a1i vj cv cn wcel vj cv cuz cfv c1 cuz cfv cn vj cv cn
      wcel vj cv c1 cuz cfv wcel vj cv cuz cfv c1 cuz cfv wss vj cv elnnuz c1
      vj cv uzss sylbi nnuz syl6ssr sstrd ad2antrr adantl sseld cM cme wcel cn
      cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral
      w3a vn cv cn wcel cA cB vn cv cexp co cmul co cr wcel wi vj cv cn wcel vm
      cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa vn cv cn wcel cA cB vn
      cv cexp co cmul co cr wcel wi vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel cB crp wcel vn
      cv cn wcel cA cB vn cv cexp co cmul co cr wcel wi cB c1 clt wbr cA cr
      wcel cB crp wcel vn cv cn wcel cA cB vn cv cexp co cmul co cr wcel cA cr
      wcel cB vn cv cexp co cr wcel cA cB vn cv cexp co cmul co cr wcel cB crp
      wcel vn cv cn wcel wa cA cB vn cv cexp co remulcl cB cr wcel vn cv cn0
      wcel cB vn cv cexp co cr wcel cB crp wcel vn cv cn wcel cB vn cv reexpcl
      cB rpre vn cv nnnn0 syl2an sylan2 expr 3adant3 3ad2ant2 adantr syld imp
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz
      cfv wcel wa wa vn cv vj cv vm cv c1 cmin co cfz co wcel vn cv cF cfv vn
      cv c1 caddc co cF cfv cM co cA cB vn cv cexp co cmul co cle wbr cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv
      wcel wa wa vn cv vj cv vm cv c1 cmin co cfz co wcel vn cv cn wcel vn cv
      cF cfv vn cv c1 caddc co cF cfv cM co cA cB vn cv cexp co cmul co cle wbr
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz
      cfv wcel wa wa vj cv vm cv c1 cmin co cfz co cn vn cv vj cv cn wcel vm cv
      cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa vj cv vm cv c1 cmin co
      cfz co cn wss cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vj cv cn wcel vj cv vm cv c1 cmin co cfz
      co cn wss vm cv cn wcel vm cv vj cv c1 caddc co cuz cfv wcel vj cv cn
      wcel vj cv vm cv c1 cmin co cfz co vj cv cuz cfv cn vj cv vm cv c1 cmin
      co cfz co vj cv cuz cfv wss vj cv cn wcel vj cv vm cv c1 cmin co fzssuz
      a1i vj cv cn wcel vj cv cuz cfv c1 cuz cfv cn vj cv cn wcel vj cv c1 cuz
      cfv wcel vj cv cuz cfv c1 cuz cfv wss vj cv elnnuz c1 vj cv uzss sylbi
      nnuz syl6ssr sstrd ad2antrr adantl sseld cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vn cv cn wcel vn
      cv cF cfv vn cv c1 caddc co cF cfv cM co cA cB vn cv cexp co cmul co cle
      wbr wi vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv
      wcel wa vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral cM cme wcel cn cX cF wf wa vn cv cn wcel vn cv
      cF cfv vn cv c1 caddc co cF cfv cM co cA cB vn cv cexp co cmul co cle wbr
      wi cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc
      co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vn cv cF cfv vn cv c1
      caddc co cF cfv cM co cA cB vn cv cexp co cmul co cle wbr vk vn cv cn vk
      vn weq vk cv cF cfv vk cv c1 caddc co cF cfv cM co vn cv cF cfv vn cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cA cB vn cv cexp co
      cmul co cle vk vn weq vk cv cF cfv vn cv cF cfv vk cv c1 caddc co cF cfv
      vn cv c1 caddc co cF cfv cM vk cv vn cv cF fveq2 vk vn weq vk cv c1 caddc
      co vn cv c1 caddc co cF vk cv vn cv c1 caddc opreq1 fveq2d opreq12d vk vn
      weq cB vk cv cexp co cB vn cv cexp co cA cmul vk cv vn cv cB cexp opreq2
      opreq2d breq12d rcla4cv 3ad2ant3 adantr syld imp 3jca r19.21aiva sylanc
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz
      cfv wcel wa wa vj cv vm cv c1 cmin co cfz co vn cv vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn csu vj
      cv cuz cfv vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul
      co wceq wa vs vt copab cfv vn csu vj cv vm cv c1 cmin co cfz co cA cB vn
      cv cexp co cmul co vn csu cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co cle vj cv cz wcel vm cv c1 cmin co vj cv cuz cfv wcel vj
      cv cuz cfv cr vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab wf cc0 vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs
      cv cexp co cmul co wceq wa vs vt copab cfv cle wbr vn vj cv cuz cfv wral
      vj cv caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul
      co wceq wa vs vt copab cseqz co vx cv cli wbr vx wex w3a vj cv vm cv c1
      cmin co cfz co vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab cfv vn csu vj cv cuz cfv vn cv vs cv vj cv
      cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn
      csu cle wbr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv
      c1 caddc co cuz cfv wcel wa wa vj cv cn wcel vm cv cn wcel wa vm cv vj cv
      c1 caddc co cuz cfv wcel wa vj cv cz wcel cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vj cv cz wcel vm cv cn wcel vm cv vj cv c1 caddc co cuz cfv wcel vj
      cv nnz ad2antrr adantl vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1
      caddc co cuz cfv wcel wa vm cv c1 cmin co vj cv cuz cfv wcel cM cme wcel
      cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv c1 cmin
      co vj cv cuz cfv wcel vm cv cn wcel vj cv cn wcel c1 cz wcel vm cv vj cv
      c1 caddc co cuz cfv wcel vm cv c1 cmin co vj cv cuz cfv wcel 1z vj cv cz
      wcel c1 cz wcel vm cv vj cv c1 caddc co cuz cfv wcel vm cv c1 cmin co vj
      cv cuz cfv wcel vj cv cn wcel c1 vj cv vm cv eluzsub vj cv nnz syl3an1
      mp3an2 adantlr adantl cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm
      cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv cuz cfv cr vs cv vj cv cuz
      cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab wf cc0 vn
      cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs
      vt copab cfv cle wbr vn vj cv cuz cfv wral vj cv caddc cop vs cv vj cv
      cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cseqz
      co vx cv cli wbr vx wex cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm
      cv vj cv c1 caddc co cuz cfv wcel wa wa cA cB vs cv cexp co cmul co cr
      wcel vs vj cv cuz cfv wral vj cv cuz cfv cr vs cv vj cv cuz cfv wcel vt
      cv cA cB vs cv cexp co cmul co wceq wa vs vt copab wf cA cr wcel cB crp
      wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa cA cB vs cv cexp co cmul
      co cr wcel vs vj cv cuz cfv wral vk cv cF cfv vk cv c1 caddc co cF cfv cM
      co cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vj cv cn wcel vm cv cn wcel wa cA cB vs cv cexp co cmul
      co cr wcel vs vj cv cuz cfv wral vm cv vj cv c1 caddc co cuz cfv wcel cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel cA cB vs cv cexp co
      cmul co cr wcel vs vj cv cuz cfv wral vm cv cn wcel cA cr wcel cB crp
      wcel vj cv cn wcel cA cB vs cv cexp co cmul co cr wcel vs vj cv cuz cfv
      wral cB c1 clt wbr cA cr wcel cB crp wcel wa vj cv cn wcel wa cA cB vs cv
      cexp co cmul co cr wcel vs vj cv cuz cfv cA cr wcel cB crp wcel wa vj cv
      cn wcel vs cv vj cv cuz cfv wcel cA cB vs cv cexp co cmul co cr wcel cA
      cr wcel cB crp wcel wa vs cv cn0 wcel cA cB vs cv cexp co cmul co cr wcel
      vj cv cn wcel vs cv vj cv cuz cfv wcel wa cA cr wcel cB crp wcel vs cv
      cn0 wcel cA cB vs cv cexp co cmul co cr wcel cA cr wcel cB vs cv cexp co
      cr wcel cA cB vs cv cexp co cmul co cr wcel cB crp wcel vs cv cn0 wcel wa
      cA cB vs cv cexp co remulcl cB cr wcel vs cv cn0 wcel cB vs cv cexp co cr
      wcel cB crp wcel cB vs cv reexpcl cB rpre sylan sylan2 anassrs vj cv cn
      wcel vs cv vj cv cuz cfv wcel wa vs cv cn wcel vs cv cn0 wcel vj cv cn
      wcel vs cv vj cv cuz cfv wcel wa vs cv c1 cuz cfv wcel vs cv cn wcel vj
      cv cuz cfv c1 cuz cfv wss vs cv vj cv cuz cfv wcel vs cv c1 cuz cfv wcel
      vj cv cn wcel vj cv cuz cfv c1 cuz cfv vs cv ssel2 vj cv cn wcel vj cv c1
      cuz cfv wcel vj cv cuz cfv c1 cuz cfv wss vj cv elnnuz c1 vj cv uzss
      sylbi sylan vs cv elnnuz sylibr vs cv nnnn0 syl sylan2 anassrs r19.21aiva
      3adantl3 adantrr adantrr 3ad2antl2 vs vt vj cv cuz cfv cr cA cB vs cv
      cexp co cmul co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul
      co wceq wa vs vt copab vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab eqid fopab2 sylib cM cme wcel cn cX cF wf wa
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vm cv cn wcel wa cc0 vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs
      cv cexp co cmul co wceq wa vs vt copab cfv cle wbr vn vj cv cuz cfv wral
      vm cv vj cv c1 caddc co cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel
      cc0 vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq
      wa vs vt copab cfv cle wbr vn vj cv cuz cfv wral vm cv cn wcel cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel wa cc0 vn cv vs cv vj cv cuz cfv wcel vt cv cA cB
      vs cv cexp co cmul co wceq wa vs vt copab cfv cle wbr vn vj cv cuz cfv cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF
      cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk
      cn wral w3a vj cv cn wcel wa vn cv vj cv cuz cfv wcel wa cc0 cA cB vn cv
      cexp co cmul co vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab cfv cle cA cr wcel cc0 cA cle wbr cB vn cv
      cexp co cr wcel cc0 cB vn cv cexp co cle wbr cc0 cA cB vn cv cexp co cmul
      co cle wbr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral w3a vj cv cn wcel wa vn cv vj cv cuz cfv wcel
      wa cA cB vn cv cexp co mulge0 cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a cA cr wcel vj cv cn wcel
      vn cv vj cv cuz cfv wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme
      wcel cn cX cF wf wa cA cr wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM
      co cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel cB crp wcel
      cB c1 clt wbr 3simp1 3ad2ant2 ad2antrr cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a cc0 cA cle wbr
      vj cv cn wcel vn cv vj cv cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv cM co
      cA cB c1 cexp co cmul co cle wbr cc0 cA cle wbr vk cv cF cfv vk cv c1
      caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a c1 cF
      cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr w3a cc0
      cA cB cmul co cle wbr cc0 cA cle wbr cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv cM co
      cA cB c1 cexp co cmul co cle wbr w3a cc0 c1 cF cfv c1 c1 caddc co cF cfv
      cM co cA cB cmul co cc0 cr wcel cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1
      cexp co cmul co cle wbr w3a 0re a1i cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv cM co cr
      wcel c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul co cle
      wbr cM cme wcel c1 cF cfv cX wcel c1 c1 caddc co cF cfv cX wcel wa c1 cF
      cfv c1 c1 caddc co cF cfv cM co cr wcel cn cX cF wf cM cme wcel c1 cF cfv
      cX wcel c1 c1 caddc co cF cfv cX wcel c1 cF cfv c1 c1 caddc co cF cfv cM
      co cr wcel c1 cF cfv c1 c1 caddc co cF cfv cM cX geomcau.1 metcl 3expb cn
      cX cF wf c1 cF cfv cX wcel c1 c1 caddc co cF cfv cX wcel cn cX cF wf c1
      cn wcel c1 cF cfv cX wcel 1nn cn cX c1 cF ffvelrn mpan2 cn cX cF wf c1 c1
      caddc co cn wcel c1 c1 caddc co cF cfv cX wcel c1 cn wcel c1 cn wcel c1
      c1 caddc co cn wcel 1nn 1nn c1 c1 nnaddcl mp2an cn cX c1 c1 caddc co cF
      ffvelrn mpan2 jca sylan2 3ad2ant1 cA cr wcel cB crp wcel cB c1 clt wbr
      w3a cM cme wcel cn cX cF wf wa cA cB cmul co cr wcel c1 cF cfv c1 c1
      caddc co cF cfv cM co cA cB c1 cexp co cmul co cle wbr cA cr wcel cB crp
      wcel cA cB cmul co cr wcel cB c1 clt wbr cA cr wcel cB cr wcel cA cB cmul
      co cr wcel cB crp wcel cA cB axmulrcl cB rpre sylan2 3adant3 3ad2ant2 cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 c1
      cF cfv c1 c1 caddc co cF cfv cM co cle wbr c1 cF cfv c1 c1 caddc co cF
      cfv cM co cA cB c1 cexp co cmul co cle wbr cM cme wcel c1 cF cfv cX wcel
      c1 c1 caddc co cF cfv cX wcel wa cc0 c1 cF cfv c1 c1 caddc co cF cfv cM
      co cle wbr cn cX cF wf cM cme wcel c1 cF cfv cX wcel c1 c1 caddc co cF
      cfv cX wcel cc0 c1 cF cfv c1 c1 caddc co cF cfv cM co cle wbr c1 cF cfv
      c1 c1 caddc co cF cfv cM cX geomcau.1 metge0 3expb cn cX cF wf c1 cF cfv
      cX wcel c1 c1 caddc co cF cfv cX wcel cn cX cF wf c1 cn wcel c1 cF cfv cX
      wcel 1nn cn cX c1 cF ffvelrn mpan2 cn cX cF wf c1 c1 caddc co cn wcel c1
      c1 caddc co cF cfv cX wcel c1 cn wcel c1 cn wcel c1 c1 caddc co cn wcel
      1nn 1nn c1 c1 nnaddcl mp2an cn cX c1 c1 caddc co cF ffvelrn mpan2 jca
      sylan2 3ad2ant1 cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1
      clt wbr w3a c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1 cexp co cmul
      co cle wbr c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB cmul co cle wbr cM
      cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a wa cA cB
      c1 cexp co cmul co cA cB cmul co c1 cF cfv c1 c1 caddc co cF cfv cM co
      cle cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a
      wa cB c1 cexp co cB cA cmul cA cr wcel cB crp wcel cB c1 clt wbr w3a cB
      c1 cexp co cB wceq cM cme wcel cn cX cF wf wa cB crp wcel cA cr wcel cB
      c1 cexp co cB wceq cB c1 clt wbr cB crp wcel cB cc wcel cB c1 cexp co cB
      wceq cB rpcn cB exp1 syl 3ad2ant2 adantl opreq2d breq2d biimp3a letrd cA
      cr wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa cc0 cA
      cB cmul co cle wbr cc0 cA cle wbr wi c1 cF cfv c1 c1 caddc co cF cfv cM
      co cA cB c1 cexp co cmul co cle wbr cA cr wcel cB crp wcel cc0 cA cB cmul
      co cle wbr cc0 cA cle wbr wi cB c1 clt wbr cA cr wcel cB crp wcel wa cc0
      cA cB cmul co cle wbr cc0 cA cle wbr cA cr wcel cc0 cA cB cmul co cle wbr
      cB crp wcel cc0 cA cle wbr cA cr wcel cc0 cA cB cmul co cle wbr wa cB cr
      wcel cc0 cB clt wbr wa cc0 cA cle wbr cB crp wcel cA cr wcel cB cr wcel
      cc0 cA cB cmul co cle wbr cc0 cB clt wbr cc0 cA cle wbr cA cr wcel cB cr
      wcel wa cc0 cB clt wbr cc0 cA cB cmul co cle wbr cc0 cA cle wbr cA cB
      prodge02 ancom2s an4s cB rpregt0 sylan2 an1rs ex 3adant3 3ad2ant2 mpd c1
      cn wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co
      cmul co cle wbr vk cn wral c1 cF cfv c1 c1 caddc co cF cfv cM co cA cB c1
      cexp co cmul co cle wbr wi 1nn vk cv cF cfv vk cv c1 caddc co cF cfv cM
      co cA cB vk cv cexp co cmul co cle wbr c1 cF cfv c1 c1 caddc co cF cfv cM
      co cA cB c1 cexp co cmul co cle wbr vk c1 cn vk cv c1 wceq vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co c1 cF cfv c1 c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cA cB c1 cexp co cmul co cle vk cv c1 wceq vk cv
      cF cfv c1 cF cfv vk cv c1 caddc co cF cfv c1 c1 caddc co cF cfv cM vk cv
      c1 cF fveq2 vk cv c1 wceq vk cv c1 caddc co c1 c1 caddc co cF vk cv c1 c1
      caddc opreq1 fveq2d opreq12d vk cv c1 wceq cB vk cv cexp co cB c1 cexp co
      cA cmul vk cv c1 cB cexp opreq2 opreq2d breq12d rcla4v ax-mp syl3an3
      ad2antrr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vj cv cn wcel vn cv vj cv cuz cfv wcel cB vn cv
      cexp co cr wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1
      clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp
      co cmul co cle wbr vk cn wral w3a vn cv cn0 wcel cB vn cv cexp co cr wcel
      vj cv cn wcel vn cv vj cv cuz cfv wcel wa cA cr wcel cB crp wcel cB c1
      clt wbr w3a cM cme wcel cn cX cF wf wa vn cv cn0 wcel cB vn cv cexp co cr
      wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral cB crp wcel cA cr wcel vn cv cn0 wcel cB vn cv cexp
      co cr wcel cB c1 clt wbr cB cr wcel vn cv cn0 wcel cB vn cv cexp co cr
      wcel cB crp wcel cB vn cv reexpcl cB rpre sylan 3ad2antl2 3ad2antl2 vj cv
      cn wcel vn cv vj cv cuz cfv wcel wa vn cv cn wcel vn cv cn0 wcel vj cv cn
      wcel vn cv vj cv cuz cfv wcel wa vn cv c1 cuz cfv wcel vn cv cn wcel vj
      cv cuz cfv c1 cuz cfv wss vn cv vj cv cuz cfv wcel vn cv c1 cuz cfv wcel
      vj cv cn wcel vj cv cuz cfv c1 cuz cfv vn cv ssel2 vj cv cn wcel vj cv c1
      cuz cfv wcel vj cv cuz cfv c1 cuz cfv wss vj cv elnnuz c1 vj cv uzss
      sylbi sylan vn cv elnnuz sylibr vn cv nnnn0 syl sylan2 anassrs cM cme
      wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv
      vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel vn cv vj cv cuz cfv wcel cc0 cB vn cv cexp co cle
      wbr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a
      vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co
      cle wbr vk cn wral w3a vn cv cn0 wcel cc0 cB vn cv cexp co cle wbr vj cv
      cn wcel vn cv vj cv cuz cfv wcel wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a cM cme wcel cn cX cF wf wa vn cv cn0 wcel cc0 cB vn cv cexp co cle
      wbr vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral cB crp wcel cA cr wcel vn cv cn0 wcel cc0 cB vn cv
      cexp co cle wbr cB c1 clt wbr cB crp wcel vn cv cn0 wcel wa cB vn cv cexp
      co crp wcel cc0 cB vn cv cexp co cle wbr cB vn cv rpexpcl cB vn cv cexp
      co rpge0 syl 3ad2antl2 3ad2antl2 vj cv cn wcel vn cv vj cv cuz cfv wcel
      wa vn cv cn wcel vn cv cn0 wcel vj cv cn wcel vn cv vj cv cuz cfv wcel wa
      vn cv c1 cuz cfv wcel vn cv cn wcel vj cv cuz cfv c1 cuz cfv wss vn cv vj
      cv cuz cfv wcel vn cv c1 cuz cfv wcel vj cv cn wcel vj cv cuz cfv c1 cuz
      cfv vn cv ssel2 vj cv cn wcel vj cv c1 cuz cfv wcel vj cv cuz cfv c1 cuz
      cfv wss vj cv elnnuz c1 vj cv uzss sylbi sylan vn cv elnnuz sylibr vn cv
      nnnn0 syl sylan2 anassrs syl2anc vn cv vj cv cuz cfv wcel vn cv vs cv vj
      cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv
      cA cB vn cv cexp co cmul co wceq cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel wa vs vt vn
      cv cA cB vs cv cexp co cmul co cA cB vn cv cexp co cmul co vj cv cuz cfv
      vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab vs vn weq cB vs cv cexp co cB vn cv cexp co cA cmul vs cv vn cv cB
      cexp opreq2 opreq2d vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab eqid cA cB vn cv cexp co cmul oprex fvopab4
      adantl breqtrrd r19.21aiva adantrr adantrr cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv
      caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq
      wa vs vt copab cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv
      co cmul co cli wbr vj cv caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB
      vs cv cexp co cmul co wceq wa vs vt copab cseqz co vx cv cli wbr vx wex
      cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vj cv caddc cop vs cv vj cv
      cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cseqz
      co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cli wbr
      vm cv vj cv c1 caddc co cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vj
      cv caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co cli wbr vm cv cn wcel cA cr wcel cB crp wcel cB c1 clt
      wbr w3a cM cme wcel cn cX cF wf wa vj cv cn wcel vj cv caddc cop vs cv vj
      cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab
      cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cli
      wbr vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel wa cc0 vj cv caddc co caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB
      vs cv cexp co cmul co wceq wa vs vt copab cseqz co vj cv caddc cop vs cv
      vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab
      cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cli
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa cc0 vj cv caddc
      co caddc cop vj cv caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cseqz cA cr wcel cB crp wcel cB c1
      clt wbr w3a vj cv cn wcel wa cc0 vj cv caddc co vj cv caddc vj cv cn wcel
      cc0 vj cv caddc co vj cv wceq cA cr wcel cB crp wcel cB c1 clt wbr w3a vj
      cv cn wcel vj cv cc wcel cc0 vj cv caddc co vj cv wceq vj cv nncn vj cv
      addid2 syl adantl opeq1d opreq1d cA cr wcel cB crp wcel cB c1 clt wbr w3a
      vj cv cn wcel wa cc0 caddc cop vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cseqz co cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cli wbr cc0 vj cv caddc
      co caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co cli wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel wa cc0 caddc cop vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cseqz co c1 c1 cB cmin co cdiv co cli wbr cc0 caddc cop vs cv cn0
      wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa
      vs vt copab cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co cli wbr cA cr wcel cB crp wcel cB c1 clt wbr w3a cc0 caddc cop vs
      cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseqz co c1 c1 cB
      cmin co cdiv co cli wbr vj cv cn wcel cB crp wcel cB c1 clt wbr cc0 caddc
      cop vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseqz co c1
      c1 cB cmin co cdiv co cli wbr cA cr wcel cB crp wcel cB c1 clt wbr wa
      caddc vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseq0 co
      c1 c1 cB cmin co cdiv co cc0 caddc cop vs cv cn0 wcel vt cv cB vs cv cexp
      co wceq wa vs vt copab cseqz co cli cB cc wcel cB cabs cfv c1 clt wbr
      caddc vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseq0 co
      c1 c1 cB cmin co cdiv co cli wbr cB crp wcel cB c1 clt wbr wa vt cB vs vs
      cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab vs cv cn0 wcel vt
      cv cB vs cv cexp co wceq wa vs vt copab eqid geolim cB crp wcel cB cc
      wcel cB c1 clt wbr cB rpcn adantr cB crp wcel cB c1 clt wbr wa cB cabs
      cfv cB c1 clt cB crp wcel cB cabs cfv cB wceq cB c1 clt wbr cB cr wcel
      cc0 cB cle wbr cB cabs cfv cB wceq cB crp wcel cB absid cB rpre cB rpge0
      sylanc adantr cB crp wcel cB c1 clt wbr pm3.27 eqbrtrd sylanc caddc vs cv
      cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab addex vs vt cn0 cB vs
      cv cexp co nn0ex opabex2 seq0seqz syl5eqbrr 3adant1 adantr cc0 cz wcel cA
      cB vj cv cexp co cmul co cc wcel vk cv vs cv cn0 wcel vt cv cB vs cv cexp
      co wceq wa vs vt copab cfv cc wcel vk cv vs cv cn0 wcel vt cv cA cB vj cv
      cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB vj
      cv cexp co cmul co vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs
      vt copab cfv cmul co wceq wa vk cc0 cuz cfv wral cc0 caddc cop vs cv cn0
      wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseqz co c1 c1 cB cmin co
      cdiv co cli wbr cc0 caddc cop vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cseqz co cA cB vj cv
      cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cli wbr wi cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vj cv cn wcel wa c1 c1 cB cmin co cdiv co cA
      cB vj cv cexp co cmul co vk vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa
      vs vt copab vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv
      cexp co cmul co wceq wa vs vt copab cc0 c1 c1 cB cmin co cdiv oprex vs vt
      cn0 cB vs cv cexp co nn0ex opabex2 vs vt cn0 cA cB vj cv cexp co cmul co
      cB vs cv cexp co cmul co nn0ex opabex2 iserzmulc1 cc0 cz wcel cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa 0z a1i cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vj cv cn wcel wa cA cB vj cv cexp co cmul co cA cr
      wcel cB crp wcel vj cv cn wcel cA cB vj cv cexp co cmul co cr wcel cB c1
      clt wbr cA cr wcel cB crp wcel vj cv cn wcel cA cB vj cv cexp co cmul co
      cr wcel cA cr wcel cB vj cv cexp co cr wcel cA cB vj cv cexp co cmul co
      cr wcel cB crp wcel vj cv cn wcel wa cA cB vj cv cexp co remulcl cB cr
      wcel vj cv cn0 wcel cB vj cv cexp co cr wcel cB crp wcel vj cv cn wcel cB
      vj cv reexpcl cB rpre vj cv nnnn0 syl2an sylan2 anassrs 3adantl3 recnd cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv vs cv cn0
      wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv cc wcel vk cv vs cv
      cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq
      wa vs vt copab cfv cA cB vj cv cexp co cmul co vk cv vs cv cn0 wcel vt cv
      cB vs cv cexp co wceq wa vs vt copab cfv cmul co wceq wa vk cc0 cuz cfv
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz
      cfv wcel wa vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cfv cc wcel vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co
      cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB vj cv cexp co cmul
      co vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv
      cmul co wceq cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cc0 cuz cfv
      wcel vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv
      cc wcel vj cv cn wcel cB crp wcel cA cr wcel vk cv cc0 cuz cfv wcel vk cv
      vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv cc wcel cB
      c1 clt wbr cB crp wcel vk cv cc0 cuz cfv wcel wa vk cv vs cv cn0 wcel vt
      cv cB vs cv cexp co wceq wa vs vt copab cfv cB vk cv cexp co cc vk cv cc0
      cuz cfv wcel vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cfv cB vk cv cexp co wceq cB crp wcel vk cv cc0 cuz cfv wcel vk cv
      cn0 wcel vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab
      cfv cB vk cv cexp co wceq vk cv elnn0uz vs vt vk cv cB vs cv cexp co cB
      vk cv cexp co cn0 vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab vs cv vk cv cB cexp opreq2 vs cv cn0 wcel vt cv cB vs cv cexp co
      wceq wa vs vt copab eqid cB vk cv cexp oprex fvopab4 sylbir adantl cB cc
      wcel vk cv cn0 wcel cB vk cv cexp co cc wcel cB crp wcel vk cv cc0 cuz
      cfv wcel cB vk cv expcl cB rpcn vk cv cn0 wcel vk cv cc0 cuz cfv wcel vk
      cv elnn0uz biimpri syl2an eqeltrd 3ad2antl2 adantlr vk cv cc0 cuz cfv
      wcel vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp
      co cmul co wceq wa vs vt copab cfv cA cB vj cv cexp co cmul co vk cv vs
      cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv cmul co wceq
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz
      cfv wcel vk cv cn0 wcel vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB vj cv cexp
      co cmul co vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cfv cmul co wceq vk cv elnn0uz vk cv cn0 wcel vk cv vs cv cn0 wcel
      vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv cA cB vj cv cexp co cmul co cB vk cv cexp co cmul co cA cB vj
      cv cexp co cmul co vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq wa vs
      vt copab cfv cmul co vs vt vk cv cA cB vj cv cexp co cmul co cB vs cv
      cexp co cmul co cA cB vj cv cexp co cmul co cB vk cv cexp co cmul co cn0
      vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co
      wceq wa vs vt copab vs vk weq cB vs cv cexp co cB vk cv cexp co cA cB vj
      cv cexp co cmul co cmul vs cv vk cv cB cexp opreq2 opreq2d vs cv cn0 wcel
      vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt
      copab eqid cA cB vj cv cexp co cmul co cB vk cv cexp co cmul oprex
      fvopab4 vk cv cn0 wcel vk cv vs cv cn0 wcel vt cv cB vs cv cexp co wceq
      wa vs vt copab cfv cB vk cv cexp co cA cB vj cv cexp co cmul co cmul vs
      vt vk cv cB vs cv cexp co cB vk cv cexp co cn0 vs cv cn0 wcel vt cv cB vs
      cv cexp co wceq wa vs vt copab vs cv vk cv cB cexp opreq2 vs cv cn0 wcel
      vt cv cB vs cv cexp co wceq wa vs vt copab eqid cB vk cv cexp oprex
      fvopab4 opreq2d eqtr4d sylbir adantl jca r19.21aiva syl3anc mpd vs cv cn0
      wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa
      vs vt copab cvv wcel vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab cvv wcel wa cc0 cz wcel vj cv cz wcel wa cA
      cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cvv wcel vk cv
      vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv cc wcel vk cv vj cv caddc co vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vk cv vs
      cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv wceq wa vk cc0 cuz cfv wral wa cc0 caddc cop vs
      cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co
      wceq wa vs vt copab cseqz co cA cB vj cv cexp co cmul co c1 c1 cB cmin co
      cdiv co cmul co cli wbr cc0 vj cv caddc co caddc cop vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cseqz co cA cB
      vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cli wbr wb cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa cA cB vj cv cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co cvv cvv cvv vk vs cv cn0 wcel vt
      cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt
      copab vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa
      vs vt copab vj cv cc0 iserzshft2 cA cr wcel cB crp wcel cB c1 clt wbr w3a
      vj cv cn wcel wa vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul
      co wceq wa vs vt copab cvv wcel vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cvv wcel vs cv vj cv
      cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cvv
      wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vs vt vj
      cv cuz cfv cA cB vs cv cexp co cmul co vj cv cuz fvex opabex2 a1i vs vt
      cn0 cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co nn0ex opabex2
      jctil cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vj cv cz
      wcel cc0 cz wcel vj cv cn wcel vj cv cz wcel cA cr wcel cB crp wcel cB c1
      clt wbr w3a vj cv nnz adantl 0z jctil cA cr wcel cB crp wcel cB c1 clt
      wbr w3a vj cv cn wcel wa vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv cc wcel vk cv vj
      cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv wceq wa vk cc0
      cuz cfv wral cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co
      cvv wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv
      vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv cc wcel vk cv vj cv caddc co vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vk cv vs
      cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv wceq wa vk cc0 cuz cfv cA cr wcel cB crp wcel cB
      c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz cfv wcel wa vk cv vs cv cn0
      wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa
      vs vt copab cfv cc wcel vk cv vj cv caddc co vs cv vj cv cuz cfv wcel vt
      cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vk cv vs cv cn0
      wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa
      vs vt copab cfv wceq cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel wa vk cv cc0 cuz cfv wcel wa vk cv vs cv cn0 wcel vt cv cA cB vj cv
      cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB vj
      cv cexp co cmul co cB vk cv cexp co cmul co cc vk cv cc0 cuz cfv wcel vk
      cv vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul
      co wceq wa vs vt copab cfv cA cB vj cv cexp co cmul co cB vk cv cexp co
      cmul co wceq cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk
      cv cc0 cuz cfv wcel vk cv cn0 wcel vk cv vs cv cn0 wcel vt cv cA cB vj cv
      cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB vj
      cv cexp co cmul co cB vk cv cexp co cmul co wceq vk cv elnn0uz vs vt vk
      cv cA cB vj cv cexp co cmul co cB vs cv cexp co cmul co cA cB vj cv cexp
      co cmul co cB vk cv cexp co cmul co cn0 vs cv cn0 wcel vt cv cA cB vj cv
      cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt copab vs vk weq cB
      vs cv cexp co cB vk cv cexp co cA cB vj cv cexp co cmul co cmul vs cv vk
      cv cB cexp opreq2 opreq2d vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul
      co cB vs cv cexp co cmul co wceq wa vs vt copab eqid cA cB vj cv cexp co
      cmul co cB vk cv cexp co cmul oprex fvopab4 sylbir adantl cA cB vj cv
      cexp co cmul co cc wcel cB vk cv cexp co cc wcel cA cB vj cv cexp co cmul
      co cB vk cv cexp co cmul co cc wcel cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vj cv cn wcel wa vk cv cc0 cuz cfv wcel wa cA cB vj cv cexp co cmul
      co cB vk cv cexp co mulcl cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv
      cn wcel wa cA cB vj cv cexp co cmul co cc wcel vk cv cc0 cuz cfv wcel cA
      cc wcel cB vj cv cexp co cc wcel cA cB vj cv cexp co cmul co cc wcel cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa cA cB vj cv cexp
      co mulcl cA cr wcel cB crp wcel cB c1 clt wbr w3a cA cc wcel vj cv cn
      wcel cA cr wcel cB crp wcel cA cc wcel cB c1 clt wbr cA recn 3ad2ant1
      adantr cB crp wcel cA cr wcel vj cv cn wcel cB vj cv cexp co cc wcel cB
      c1 clt wbr cB crp wcel vj cv cn wcel wa cB vj cv cexp co cB cr wcel vj cv
      cn0 wcel cB vj cv cexp co cr wcel cB crp wcel vj cv cn wcel cB vj cv
      reexpcl cB rpre vj cv nnnn0 syl2an recnd 3ad2antl2 sylanc adantr cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cc0 cuz cfv wcel cB vk cv cexp
      co cc wcel vj cv cn wcel cB crp wcel cA cr wcel vk cv cc0 cuz cfv wcel cB
      vk cv cexp co cc wcel cB c1 clt wbr cB cc wcel vk cv cn0 wcel cB vk cv
      cexp co cc wcel cB crp wcel vk cv cc0 cuz cfv wcel cB vk cv expcl cB rpcn
      vk cv cn0 wcel vk cv cc0 cuz cfv wcel vk cv elnn0uz biimpri syl2an
      3ad2antl2 adantlr sylanc eqeltrd cA cr wcel cB crp wcel cB c1 clt wbr w3a
      vj cv cn wcel wa vk cv cc0 cuz cfv wcel wa cA cB vk cv vj cv caddc co
      cexp co cmul co cA cB vj cv cexp co cmul co cB vk cv cexp co cmul co vk
      cv vj cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul
      co wceq wa vs vt copab cfv vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz cfv wcel wa cA
      cB vk cv vj cv caddc co cexp co cmul co cA cB vj cv cexp co cB vk cv cexp
      co cmul co cmul co cA cB vj cv cexp co cmul co cB vk cv cexp co cmul co
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz
      cfv wcel wa cB vk cv vj cv caddc co cexp co cB vj cv cexp co cB vk cv
      cexp co cmul co cA cmul cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel wa vk cv cc0 cuz cfv wcel wa cB vk cv vj cv caddc co cexp co cB vj
      cv vk cv caddc co cexp co cB vj cv cexp co cB vk cv cexp co cmul co cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz cfv
      wcel wa vk cv vj cv caddc co vj cv vk cv caddc co cB cexp vj cv cn wcel
      vk cv cc0 cuz cfv wcel vk cv vj cv caddc co vj cv vk cv caddc co wceq cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cc0 cuz cfv wcel vj cv cn
      wcel vk cv vj cv caddc co vj cv vk cv caddc co wceq vk cv cc wcel vj cv
      cc wcel vk cv vj cv caddc co vj cv vk cv caddc co wceq vk cv cc0 cuz cfv
      wcel vj cv cn wcel vk cv vj cv addcom vk cv cc0 cuz cfv wcel vk cv cz
      wcel vk cv cc wcel cc0 vk cv eluzelz vk cv zcn syl vj cv nncn syl2an
      ancoms adantll opreq2d cB cc wcel vj cv cn0 wcel vk cv cn0 wcel cB vj cv
      vk cv caddc co cexp co cB vj cv cexp co cB vk cv cexp co cmul co wceq cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz cfv
      wcel wa cB vj cv vk cv expadd cA cr wcel cB crp wcel cB c1 clt wbr w3a cB
      cc wcel vj cv cn wcel vk cv cc0 cuz cfv wcel cB crp wcel cA cr wcel cB cc
      wcel cB c1 clt wbr cB rpcn 3ad2ant2 ad2antrr vj cv cn wcel vj cv cn0 wcel
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cc0 cuz cfv wcel vj cv
      nnnn0 ad2antlr vk cv cc0 cuz cfv wcel vk cv cn0 wcel cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cn0 wcel vk cv cc0 cuz cfv
      wcel vk cv elnn0uz biimpri adantl syl3anc eqtrd opreq2d cA cc wcel cB vj
      cv cexp co cc wcel cB vk cv cexp co cc wcel cA cB vj cv cexp co cB vk cv
      cexp co cmul co cmul co cA cB vj cv cexp co cmul co cB vk cv cexp co cmul
      co wceq cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv
      cc0 cuz cfv wcel wa cA cc wcel cB vj cv cexp co cc wcel cB vk cv cexp co
      cc wcel w3a cA cB vj cv cexp co cmul co cB vk cv cexp co cmul co cA cB vj
      cv cexp co cB vk cv cexp co cmul co cmul co cA cB vj cv cexp co cB vk cv
      cexp co mulass eqcomd cA cr wcel cB crp wcel cB c1 clt wbr w3a cA cc wcel
      vj cv cn wcel vk cv cc0 cuz cfv wcel cA cr wcel cB crp wcel cA cc wcel cB
      c1 clt wbr cA recn 3ad2ant1 ad2antrr cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vj cv cn wcel wa cB vj cv cexp co cc wcel vk cv cc0 cuz cfv wcel cB
      crp wcel cA cr wcel vj cv cn wcel cB vj cv cexp co cc wcel cB c1 clt wbr
      cB crp wcel vj cv cn wcel wa cB vj cv cexp co cB cr wcel vj cv cn0 wcel
      cB vj cv cexp co cr wcel cB crp wcel vj cv cn wcel cB vj cv reexpcl cB
      rpre vj cv nnnn0 syl2an recnd 3ad2antl2 adantr cA cr wcel cB crp wcel cB
      c1 clt wbr w3a vk cv cc0 cuz cfv wcel cB vk cv cexp co cc wcel vj cv cn
      wcel cB crp wcel cA cr wcel vk cv cc0 cuz cfv wcel cB vk cv cexp co cc
      wcel cB c1 clt wbr cB cc wcel vk cv cn0 wcel cB vk cv cexp co cc wcel cB
      crp wcel vk cv cc0 cuz cfv wcel cB vk cv expcl cB rpcn vk cv cn0 wcel vk
      cv cc0 cuz cfv wcel vk cv elnn0uz biimpri syl2an 3ad2antl2 adantlr
      syl3anc eqtrd vj cv cn wcel vk cv cc0 cuz cfv wcel vk cv vj cv caddc co
      vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv cA cB vk cv vj cv caddc co cexp co cmul co wceq cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vj cv cn wcel vk cv cc0 cuz cfv wcel wa vk cv
      vj cv caddc co vj cv cuz cfv wcel vk cv vj cv caddc co vs cv vj cv cuz
      cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB
      vk cv vj cv caddc co cexp co cmul co wceq vj cv cn wcel vk cv cc0 cuz cfv
      wcel wa vk cv vj cv caddc co cc0 vj cv caddc co cuz cfv vj cv cuz cfv vk
      cv cc0 cuz cfv wcel vj cv cn wcel vk cv vj cv caddc co cc0 vj cv caddc co
      cuz cfv wcel vk cv cc0 cuz cfv wcel vj cv cz wcel vk cv vj cv caddc co
      cc0 vj cv caddc co cuz cfv wcel vj cv cn wcel vj cv cc0 vk cv eluzadd vj
      cv nnz sylan2 ancoms vj cv cn wcel vk cv cc0 cuz cfv wcel wa cc0 vj cv
      caddc co vj cv cuz vj cv cn wcel cc0 vj cv caddc co vj cv wceq vk cv cc0
      cuz cfv wcel vj cv cn wcel vj cv cc wcel cc0 vj cv caddc co vj cv wceq vj
      cv nncn vj cv addid2 syl adantr fveq2d eleqtrd vs vt vk cv vj cv caddc co
      cA cB vs cv cexp co cmul co cA cB vk cv vj cv caddc co cexp co cmul co vj
      cv cuz cfv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab vs cv vk cv vj cv caddc co wceq cB vs cv cexp co cB
      vk cv vj cv caddc co cexp co cA cmul vs cv vk cv vj cv caddc co cB cexp
      opreq2 opreq2d vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab eqid cA cB vk cv vj cv caddc co cexp co cmul oprex
      fvopab4 syl adantll vk cv cc0 cuz cfv wcel vk cv vs cv cn0 wcel vt cv cA
      cB vj cv cexp co cmul co cB vs cv cexp co cmul co wceq wa vs vt copab cfv
      cA cB vj cv cexp co cmul co cB vk cv cexp co cmul co wceq cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vk cv cc0 cuz cfv wcel vk cv
      cn0 wcel vk cv vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv
      cexp co cmul co wceq wa vs vt copab cfv cA cB vj cv cexp co cmul co cB vk
      cv cexp co cmul co wceq vk cv elnn0uz vs vt vk cv cA cB vj cv cexp co
      cmul co cB vs cv cexp co cmul co cA cB vj cv cexp co cmul co cB vk cv
      cexp co cmul co cn0 vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB
      vs cv cexp co cmul co wceq wa vs vt copab vs vk weq cB vs cv cexp co cB
      vk cv cexp co cA cB vj cv cexp co cmul co cmul vs cv vk cv cB cexp opreq2
      opreq2d vs cv cn0 wcel vt cv cA cB vj cv cexp co cmul co cB vs cv cexp co
      cmul co wceq wa vs vt copab eqid cA cB vj cv cexp co cmul co cB vk cv
      cexp co cmul oprex fvopab4 sylbir adantl 3eqtr4d jca r19.21aiva cA cB vj
      cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul oprex jctil syl3anc
      mpbid eqbrtrrd 3ad2antl2 adantrr adantrr vj cv caddc cop vs cv vj cv cuz
      cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cseqz co
      vx cv cli wbr vj cv caddc cop vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cseqz co cA cB vj cv cexp co cmul co
      c1 c1 cB cmin co cdiv co cmul co cli wbr vx cA cB vj cv cexp co cmul co
      c1 c1 cB cmin co cdiv co cmul co cA cB vj cv cexp co cmul co c1 c1 cB
      cmin co cdiv co cmul oprex vx cv cA cB vj cv cexp co cmul co c1 c1 cB
      cmin co cdiv co cmul co vj cv caddc cop vs cv vj cv cuz cfv wcel vt cv cA
      cB vs cv cexp co cmul co wceq wa vs vt copab cseqz co cli breq2 cla4ev
      syl 3jca vx vn vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab vj cv vm cv c1 cmin co fsumleisum sylan31c vj cv vm
      cv c1 cmin co cfz co vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cfv vn csu vj cv vm cv c1 cmin co cfz
      co cA cB vn cv cexp co cmul co vn csu wceq cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn
      wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv vm
      cv c1 cmin co cfz co vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cfv cA cB vn cv cexp co cmul co vn vn
      cv vj cv vm cv c1 cmin co cfz co wcel vn cv vj cv cuz cfv wcel vn cv vs
      cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv cA cB vn cv cexp co cmul co wceq vn cv vj cv vm cv c1 cmin co
      elfzuz vs vt vn cv cA cB vs cv cexp co cmul co cA cB vn cv cexp co cmul
      co vj cv cuz cfv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul
      co wceq wa vs vt copab vs vn weq cB vs cv cexp co cB vn cv cexp co cA
      cmul vs cv vn cv cB cexp opreq2 opreq2d vs cv vj cv cuz cfv wcel vt cv cA
      cB vs cv cexp co cmul co wceq wa vs vt copab eqid cA cB vn cv cexp co
      cmul oprex fvopab4 syl sumeq2i a1i cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa wa vj cv cuz cfv vn cv vs
      cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv vn csu cc0 cuz cfv vj cv vn cv caddc co vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn csu cc0
      cuz cfv cA cB vj cv cexp co cmul co cB vn cv cexp co cmul co vn csu cA cB
      vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co cM cme wcel cn cX
      cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel vm cv cn
      wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa vj cv cuz cfv vn cv vs cv
      vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab
      cfv vn csu cc0 cuz cfv vj cv vn cv caddc co vs cv vj cv cuz cfv wcel vt
      cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn csu wceq vk cv
      cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr
      vk cn wral cn cX cF wf vj cv cn wcel vm cv cn wcel wa vj cv cuz cfv vn cv
      vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv vn csu cc0 cuz cfv vj cv vn cv caddc co vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn csu
      wceq cM cme wcel vm cv vj cv c1 caddc co cuz cfv wcel cn cX cF wf vj cv
      cn wcel vj cv cuz cfv vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cfv vn csu cc0 cuz cfv vj cv vn cv
      caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq
      wa vs vt copab cfv vn csu wceq vm cv cn wcel cn cX cF wf vj cv cn wcel wa
      vj cv cuz cfv vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab cfv vn csu cc0 vj cv caddc co cuz cfv vn cv
      vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv vn csu cc0 cuz cfv vj cv vn cv caddc co vs cv vj cv cuz cfv
      wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn csu vj
      cv cn wcel vj cv cuz cfv vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cfv vn csu cc0 vj cv caddc co cuz cfv
      vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa
      vs vt copab cfv vn csu wceq cn cX cF wf vj cv cn wcel vj cv cuz cfv cc0
      vj cv caddc co cuz cfv vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv
      cexp co cmul co wceq wa vs vt copab cfv vn vj cv cn wcel vj cv cc0 vj cv
      caddc co cuz vj cv cn wcel cc0 vj cv caddc co vj cv vj cv cn wcel vj cv
      cc wcel cc0 vj cv caddc co vj cv wceq vj cv nncn vj cv addid2 syl eqcomd
      fveq2d sumeq1d adantl vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab cvv wcel vj cv cz wcel cc0 cz wcel cc0 vj cv
      caddc co cuz cfv vn cv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co
      cmul co wceq wa vs vt copab cfv vn csu cc0 cuz cfv vj cv vn cv caddc co
      vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv vn csu wceq cn cX cF wf vj cv cn wcel wa cvv vn vs cv vj cv cuz
      cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab vj cv cc0
      isumshft2 vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq
      wa vs vt copab cvv wcel cn cX cF wf vj cv cn wcel wa vs vt vj cv cuz cfv
      cA cB vs cv cexp co cmul co vj cv cuz fvex opabex2 a1i vj cv cn wcel vj
      cv cz wcel cn cX cF wf vj cv nnz adantl cc0 cz wcel cn cX cF wf vj cv cn
      wcel wa 0z a1i syl3anc eqtrd adantrr ad2ant2lr 3ad2antl1 cA cr wcel cB
      crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa vj cv cn wcel vm cv
      cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa cc0 cuz cfv vj cv vn
      cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv vn csu cc0 cuz cfv cA cB vj cv cexp co cmul co cB
      vn cv cexp co cmul co vn csu wceq vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vj cv cn wcel vm cv cn wcel wa cc0 cuz cfv vj cv
      vn cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv vn csu cc0 cuz cfv cA cB vj cv cexp co cmul co cB
      vn cv cexp co cmul co vn csu wceq vm cv vj cv c1 caddc co cuz cfv wcel cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel cc0 cuz cfv vj cv vn
      cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv vn csu cc0 cuz cfv cA cB vj cv cexp co cmul co cB
      vn cv cexp co cmul co vn csu wceq vm cv cn wcel cA cr wcel cB crp wcel vj
      cv cn wcel cc0 cuz cfv vj cv vn cv caddc co vs cv vj cv cuz cfv wcel vt
      cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv vn csu cc0 cuz cfv
      cA cB vj cv cexp co cmul co cB vn cv cexp co cmul co vn csu wceq cB c1
      clt wbr cA cr wcel cB crp wcel wa vj cv cn wcel wa cc0 cuz cfv vj cv vn
      cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co
      wceq wa vs vt copab cfv cA cB vj cv cexp co cmul co cB vn cv cexp co cmul
      co vn cA cr wcel cB crp wcel wa vj cv cn wcel wa vn cv cc0 cuz cfv wcel
      wa cA cB vj cv vn cv caddc co cexp co cmul co cA cB vj cv cexp co cB vn
      cv cexp co cmul co cmul co vj cv vn cv caddc co vs cv vj cv cuz cfv wcel
      vt cv cA cB vs cv cexp co cmul co wceq wa vs vt copab cfv cA cB vj cv
      cexp co cmul co cB vn cv cexp co cmul co cA cr wcel cB crp wcel wa vj cv
      cn wcel wa vn cv cc0 cuz cfv wcel wa cB vj cv vn cv caddc co cexp co cB
      vj cv cexp co cB vn cv cexp co cmul co cA cmul cB crp wcel vj cv cn wcel
      vn cv cc0 cuz cfv wcel cB vj cv vn cv caddc co cexp co cB vj cv cexp co
      cB vn cv cexp co cmul co wceq cA cr wcel cB crp wcel vj cv cn wcel vn cv
      cc0 cuz cfv wcel cB vj cv vn cv caddc co cexp co cB vj cv cexp co cB vn
      cv cexp co cmul co wceq cB cc wcel vj cv cn0 wcel vn cv cn0 wcel cB vj cv
      vn cv caddc co cexp co cB vj cv cexp co cB vn cv cexp co cmul co wceq cB
      crp wcel vj cv cn wcel vn cv cc0 cuz cfv wcel cB vj cv vn cv expadd cB
      rpcn vj cv nnnn0 vn cv cn0 wcel vn cv cc0 cuz cfv wcel vn cv elnn0uz
      biimpri syl3an 3expa adantlll opreq2d vj cv cn wcel vn cv cc0 cuz cfv
      wcel vj cv vn cv caddc co vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp
      co cmul co wceq wa vs vt copab cfv cA cB vj cv vn cv caddc co cexp co
      cmul co wceq cA cr wcel cB crp wcel wa vj cv cn wcel vn cv cc0 cuz cfv
      wcel wa vj cv vn cv caddc co vj cv cuz cfv wcel vj cv vn cv caddc co vs
      cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq wa vs vt
      copab cfv cA cB vj cv vn cv caddc co cexp co cmul co wceq vj cv cn wcel
      vn cv cc0 cuz cfv wcel wa vn cv vj cv caddc co cc0 vj cv caddc co cuz cfv
      wcel vj cv vn cv caddc co vj cv cuz cfv wcel vn cv cc0 cuz cfv wcel vj cv
      cn wcel vn cv vj cv caddc co cc0 vj cv caddc co cuz cfv wcel vn cv cc0
      cuz cfv wcel vj cv cz wcel vn cv vj cv caddc co cc0 vj cv caddc co cuz
      cfv wcel vj cv cn wcel vj cv cc0 vn cv eluzadd vj cv nnz sylan2 ancoms vj
      cv cn wcel vn cv cc0 cuz cfv wcel wa vn cv vj cv caddc co vj cv vn cv
      caddc co cc0 vj cv caddc co cuz cfv vj cv cuz cfv vn cv cc0 cuz cfv wcel
      vj cv cn wcel vn cv vj cv caddc co vj cv vn cv caddc co wceq vn cv cc
      wcel vj cv cc wcel vn cv vj cv caddc co vj cv vn cv caddc co wceq vn cv
      cc0 cuz cfv wcel vj cv cn wcel vn cv vj cv addcom vn cv cc0 cuz cfv wcel
      vn cv cz wcel vn cv cc wcel cc0 vn cv eluzelz vn cv zcn syl vj cv nncn
      syl2an ancoms vj cv cn wcel cc0 vj cv caddc co cuz cfv vj cv cuz cfv wceq
      vn cv cc0 cuz cfv wcel vj cv cn wcel cc0 vj cv caddc co vj cv cuz vj cv
      cn wcel vj cv cc wcel cc0 vj cv caddc co vj cv wceq vj cv nncn vj cv
      addid2 syl fveq2d adantr eleq12d mpbid vs vt vj cv vn cv caddc co cA cB
      vs cv cexp co cmul co cA cB vj cv vn cv caddc co cexp co cmul co vj cv
      cuz cfv vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq
      wa vs vt copab vs cv vj cv vn cv caddc co wceq cB vs cv cexp co cB vj cv
      vn cv caddc co cexp co cA cmul vs cv vj cv vn cv caddc co cB cexp opreq2
      opreq2d vs cv vj cv cuz cfv wcel vt cv cA cB vs cv cexp co cmul co wceq
      wa vs vt copab eqid cA cB vj cv vn cv caddc co cexp co cmul oprex fvopab4
      syl adantll cA cc wcel cB vj cv cexp co cc wcel cB vn cv cexp co cc wcel
      cA cB vj cv cexp co cmul co cB vn cv cexp co cmul co cA cB vj cv cexp co
      cB vn cv cexp co cmul co cmul co wceq cA cr wcel cB crp wcel wa vj cv cn
      wcel wa vn cv cc0 cuz cfv wcel wa cA cB vj cv cexp co cB vn cv cexp co
      mulass cA cr wcel cB crp wcel wa cA cc wcel vj cv cn wcel vn cv cc0 cuz
      cfv wcel cA cr wcel cA cc wcel cB crp wcel cA recn adantr ad2antrr cA cr
      wcel cB crp wcel wa vj cv cn wcel wa cB vj cv cexp co cc wcel vn cv cc0
      cuz cfv wcel cB crp wcel vj cv cn wcel cB vj cv cexp co cc wcel cA cr
      wcel cB crp wcel vj cv cn wcel wa cB vj cv cexp co cB cr wcel vj cv cn0
      wcel cB vj cv cexp co cr wcel cB crp wcel vj cv cn wcel cB vj cv reexpcl
      cB rpre vj cv nnnn0 syl2an recnd adantll adantr cA cr wcel cB crp wcel wa
      vn cv cc0 cuz cfv wcel cB vn cv cexp co cc wcel vj cv cn wcel cB crp wcel
      vn cv cc0 cuz cfv wcel cB vn cv cexp co cc wcel cA cr wcel cB crp wcel vn
      cv cc0 cuz cfv wcel wa cB vn cv cexp co cB cr wcel vn cv cn0 wcel cB vn
      cv cexp co cr wcel cB crp wcel vn cv cc0 cuz cfv wcel cB vn cv reexpcl cB
      rpre vn cv cn0 wcel vn cv cc0 cuz cfv wcel vn cv elnn0uz biimpri syl2an
      recnd adantll adantlr syl3anc 3eqtr4d sumeq2dv 3adantl3 adantrr adantrr
      3ad2antl2 cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1
      caddc co cuz cfv wcel wa wa cc0 cuz cfv cA cB vj cv cexp co cmul co cB vn
      cv cexp co cmul co vn csu cA cB vj cv cexp co cmul co cn0 cB vn cv cexp
      co vn csu cmul co cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf
      wa vj cv cn wcel vm cv cn wcel wa vm cv vj cv c1 caddc co cuz cfv wcel wa
      cc0 cuz cfv cA cB vj cv cexp co cmul co cB vn cv cexp co cmul co vn csu
      cA cB vj cv cexp co cmul co cn0 cB vn cv cexp co vn csu cmul co wceq vk
      cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle
      wbr vk cn wral cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel vm
      cv cn wcel wa cc0 cuz cfv cA cB vj cv cexp co cmul co cB vn cv cexp co
      cmul co vn csu cA cB vj cv cexp co cmul co cn0 cB vn cv cexp co vn csu
      cmul co wceq vm cv vj cv c1 caddc co cuz cfv wcel cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vj cv cn wcel cc0 cuz cfv cA cB vj cv cexp co cmul co
      cB vn cv cexp co cmul co vn csu cA cB vj cv cexp co cmul co cn0 cB vn cv
      cexp co vn csu cmul co wceq vm cv cn wcel cA cr wcel cB crp wcel cB c1
      clt wbr w3a vj cv cn wcel wa cA cB vj cv cexp co cmul co cc0 cuz cfv cB
      vn cv cexp co vn csu cmul co cc0 cuz cfv cA cB vj cv cexp co cmul co cB
      vn cv cexp co cmul co vn csu cA cB vj cv cexp co cmul co cn0 cB vn cv
      cexp co vn csu cmul co cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel wa cA cB vj cv cexp co cmul co cc0 cuz cfv vn cv vs cv cc0 cuz cfv
      wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv vn csu cmul co cc0
      cuz cfv cA cB vj cv cexp co cmul co vn cv vs cv cc0 cuz cfv wcel vt cv cB
      vs cv cexp co wceq wa vs vt copab cfv cmul co vn csu cA cB vj cv cexp co
      cmul co cc0 cuz cfv cB vn cv cexp co vn csu cmul co cc0 cuz cfv cA cB vj
      cv cexp co cmul co cB vn cv cexp co cmul co vn csu cc0 cz wcel cA cB vj
      cv cexp co cmul co cc wcel vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv
      cexp co wceq wa vs vt copab cfv cc wcel vn cc0 cuz cfv wral cc0 caddc cop
      vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseqz
      co vx cv cli wbr vx wex cA cB vj cv cexp co cmul co cc0 cuz cfv vn cv vs
      cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv vn csu
      cmul co cc0 cuz cfv cA cB vj cv cexp co cmul co vn cv vs cv cc0 cuz cfv
      wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv cmul co vn csu wceq
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa vx cA cB vj cv
      cexp co cmul co vn vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa
      vs vt copab cc0 vs vt cc0 cuz cfv cB vs cv cexp co cc0 cuz fvex opabex2
      isummulc1 cc0 cz wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn
      wcel wa 0z a1i cA cr wcel cB crp wcel cB c1 clt wbr w3a vj cv cn wcel wa
      cA cB vj cv cexp co cmul co cA cr wcel cB crp wcel vj cv cn wcel cA cB vj
      cv cexp co cmul co cr wcel cB c1 clt wbr cA cr wcel cB crp wcel vj cv cn
      wcel cA cB vj cv cexp co cmul co cr wcel cA cr wcel cB vj cv cexp co cr
      wcel cA cB vj cv cexp co cmul co cr wcel cB crp wcel vj cv cn wcel wa cA
      cB vj cv cexp co remulcl cB cr wcel vj cv cn0 wcel cB vj cv cexp co cr
      wcel cB crp wcel vj cv cn wcel cB vj cv reexpcl cB rpre vj cv nnnn0
      syl2an sylan2 anassrs 3adantl3 recnd cA cr wcel cB crp wcel cB c1 clt wbr
      w3a vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cfv cc wcel vn cc0 cuz cfv wral vj cv cn wcel cB crp wcel cA cr
      wcel vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cfv cc wcel vn cc0 cuz cfv wral cB c1 clt wbr cB crp wcel vn cv vs
      cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv cc
      wcel vn cc0 cuz cfv cB crp wcel vn cv cc0 cuz cfv wcel wa vn cv vs cv cc0
      cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab cfv cB vn cv cexp
      co cc vn cv cc0 cuz cfv wcel vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv
      cexp co wceq wa vs vt copab cfv cB vn cv cexp co wceq cB crp wcel vs vt
      vn cv cB vs cv cexp co cB vn cv cexp co cc0 cuz cfv vs cv cc0 cuz cfv
      wcel vt cv cB vs cv cexp co wceq wa vs vt copab vs cv vn cv cB cexp
      opreq2 vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab
      eqid cB vn cv cexp oprex fvopab4 adantl cB crp wcel vn cv cc0 cuz cfv
      wcel wa cB vn cv cexp co cB cr wcel vn cv cn0 wcel cB vn cv cexp co cr
      wcel cB crp wcel vn cv cc0 cuz cfv wcel cB vn cv reexpcl cB rpre vn cv
      cn0 wcel vn cv cc0 cuz cfv wcel vn cv elnn0uz biimpri syl2an recnd
      eqeltrd r19.21aiva 3ad2ant2 adantr cA cr wcel cB crp wcel cB c1 clt wbr
      w3a cc0 caddc cop vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa
      vs vt copab cseqz co vx cv cli wbr vx wex vj cv cn wcel cB crp wcel cB c1
      clt wbr cc0 caddc cop vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq
      wa vs vt copab cseqz co vx cv cli wbr vx wex cA cr wcel cB crp wcel cB c1
      clt wbr wa cc0 caddc cop vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co
      wceq wa vs vt copab cseqz co c1 c1 cB cmin co cdiv co cli wbr cc0 caddc
      cop vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab
      cseqz co vx cv cli wbr vx wex cB crp wcel cB c1 clt wbr wa caddc vs cv
      cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab cseq0 co c1
      c1 cB cmin co cdiv co cc0 caddc cop vs cv cc0 cuz cfv wcel vt cv cB vs cv
      cexp co wceq wa vs vt copab cseqz co cli cB cc wcel cB cabs cfv c1 clt
      wbr caddc vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cseq0 co c1 c1 cB cmin co cdiv co cli wbr cB crp wcel cB c1 clt wbr
      wa vt cB vs vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs cv cn0
      wcel vt cv cB vs cv cexp co wceq wa vs vt vs cv cc0 cuz cfv wcel vs cv
      cn0 wcel vt cv cB vs cv cexp co wceq vs cv cn0 wcel vs cv cc0 cuz cfv
      wcel vs cv elnn0uz bicomi anbi1i opabbii geolim cB crp wcel cB cc wcel cB
      c1 clt wbr cB rpcn adantr cB crp wcel cB c1 clt wbr wa cB cabs cfv cB c1
      clt cB crp wcel cB cabs cfv cB wceq cB c1 clt wbr cB cr wcel cc0 cB cle
      wbr cB cabs cfv cB wceq cB crp wcel cB absid cB rpre cB rpge0 sylanc
      adantr cB crp wcel cB c1 clt wbr pm3.27 eqbrtrd sylanc caddc vs cv cc0
      cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab addex vs vt cc0
      cuz cfv cB vs cv cexp co cc0 cuz fvex opabex2 seq0seqz syl5eqbrr cc0
      caddc cop vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cseqz co vx cv cli wbr cc0 caddc cop vs cv cc0 cuz cfv wcel vt cv
      cB vs cv cexp co wceq wa vs vt copab cseqz co c1 c1 cB cmin co cdiv co
      cli wbr vx c1 c1 cB cmin co cdiv co c1 c1 cB cmin co cdiv oprex vx cv c1
      c1 cB cmin co cdiv co cc0 caddc cop vs cv cc0 cuz cfv wcel vt cv cB vs cv
      cexp co wceq wa vs vt copab cseqz co cli breq2 cla4ev syl 3adant1 adantr
      syl2anc cc0 cuz cfv vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co
      wceq wa vs vt copab cfv vn csu cc0 cuz cfv cB vn cv cexp co vn csu cA cB
      vj cv cexp co cmul co cmul cc0 cuz cfv vn cv vs cv cc0 cuz cfv wcel vt cv
      cB vs cv cexp co wceq wa vs vt copab cfv cB vn cv cexp co vn vs vt vn cv
      cB vs cv cexp co cB vn cv cexp co cc0 cuz cfv vs cv cc0 cuz cfv wcel vt
      cv cB vs cv cexp co wceq wa vs vt copab vs cv vn cv cB cexp opreq2 vs cv
      cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab eqid cB vn cv
      cexp oprex fvopab4 sumeq2i opreq2i cc0 cuz cfv cA cB vj cv cexp co cmul
      co vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab cfv cmul co cA cB vj cv cexp co cmul co cB vn cv cexp co cmul co vn
      vn cv cc0 cuz cfv wcel vn cv vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp
      co wceq wa vs vt copab cfv cB vn cv cexp co cA cB vj cv cexp co cmul co
      cmul vs vt vn cv cB vs cv cexp co cB vn cv cexp co cc0 cuz cfv vs cv cc0
      cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt copab vs cv vn cv cB
      cexp opreq2 vs cv cc0 cuz cfv wcel vt cv cB vs cv cexp co wceq wa vs vt
      copab eqid cB vn cv cexp oprex fvopab4 opreq2d sumeq2i 3eqtr3g cn0 cB vn
      cv cexp co vn csu cc0 cuz cfv cB vn cv cexp co vn csu cA cB vj cv cexp co
      cmul co cmul cn0 cc0 cuz cfv cB vn cv cexp co vn nn0uz sumeq1i opreq2i
      syl5req adantrr adantrr 3ad2antl2 cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel vm cv cn
      wcel wa cA cB vj cv cexp co cmul co cn0 cB vn cv cexp co vn csu cmul co
      cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co cmul co wceq vm cv
      vj cv c1 caddc co cuz cfv wcel cM cme wcel cn cX cF wf wa cA cr wcel cB
      crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA
      cB vk cv cexp co cmul co cle wbr vk cn wral w3a vj cv cn wcel cA cB vj cv
      cexp co cmul co cn0 cB vn cv cexp co vn csu cmul co cA cB vj cv cexp co
      cmul co c1 c1 cB cmin co cdiv co cmul co wceq vm cv cn wcel cM cme wcel
      cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel wa cn0 cB vn cv cexp co vn csu c1 c1 cB cmin co
      cdiv co cA cB vj cv cexp co cmul co cmul cB cc wcel cB cabs cfv c1 clt
      wbr cn0 cB vn cv cexp co vn csu c1 c1 cB cmin co cdiv co wceq cM cme wcel
      cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk
      cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn
      wral w3a vj cv cn wcel wa cB vn geoisum cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a cB cc wcel vj cv
      cn wcel cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf
      wa cB cc wcel vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv
      cexp co cmul co cle wbr vk cn wral cB crp wcel cA cr wcel cB cc wcel cB
      c1 clt wbr cB rpcn 3ad2ant2 3ad2ant2 adantr cM cme wcel cn cX cF wf wa cA
      cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a cB cabs cfv
      c1 clt wbr vj cv cn wcel cM cme wcel cn cX cF wf wa cA cr wcel cB crp
      wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB
      vk cv cexp co cmul co cle wbr vk cn wral w3a cB cabs cfv cB c1 clt cB cr
      wcel cc0 cB cle wbr cB cabs cfv cB wceq cM cme wcel cn cX cF wf wa cA cr
      wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a cB absid cA cr
      wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa cB cr wcel
      vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co
      cle wbr vk cn wral cB crp wcel cA cr wcel cB cr wcel cB c1 clt wbr cB
      rpre 3ad2ant2 3ad2ant2 cA cr wcel cB crp wcel cB c1 clt wbr w3a cM cme
      wcel cn cX cF wf wa cc0 cB cle wbr vk cv cF cfv vk cv c1 caddc co cF cfv
      cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral cB crp wcel cA cr
      wcel cc0 cB cle wbr cB c1 clt wbr cB rpge0 3ad2ant2 3ad2ant2 sylanc cA cr
      wcel cB crp wcel cB c1 clt wbr w3a cM cme wcel cn cX cF wf wa cB c1 clt
      wbr vk cv cF cfv vk cv c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul
      co cle wbr vk cn wral cA cr wcel cB crp wcel cB c1 clt wbr 3simp3
      3ad2ant2 eqbrtrd adantr sylanc opreq2d adantrr adantrr eqtrd 3eqtrd
      3brtr3d letrd anassrs adantlrl letrd adantlr cM cme wcel cn cX cF wf wa
      cA cr wcel cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co
      cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp
      wcel vj cv cn wcel vm cv cn wcel wa wa wa cA cB vj cv cexp co cmul co c1
      c1 cB cmin co cdiv co cmul co vx cv clt wbr vm cv vj cv c1 caddc co cuz
      cfv wcel simplr lelttrd ex sylbid cM cme wcel cn cX cF wf wa cA cr wcel
      cB crp wcel cB c1 clt wbr w3a vk cv cF cfv vk cv c1 caddc co cF cfv cM co
      cA cB vk cv cexp co cmul co cle wbr vk cn wral w3a vx cv crp wcel vj cv
      cn wcel vm cv cn wcel wa wa wa vj vm weq vj cv cF cfv vm cv cF cfv cM co
      vx cv clt wbr wi cA cB vj cv cexp co cmul co c1 c1 cB cmin co cdiv co
      cmul co vx cv clt wbr cM cme wcel cn cX cF wf wa cA cr wcel cB crp wcel
      cB c1 clt wbr w3a vx cv crp wcel vj cv cn wcel vm cv cn wcel wa wa vj vm
      weq vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi vk cv cF cfv vk cv
      c1 caddc co cF cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral
      vj vm weq vj cv cF cfv vj cv cF cfv cM co vx cv clt wbr vj cv cF cfv vm
      cv cF cfv cM co vx cv clt wbr cM cme wcel cn cX cF wf wa vx cv crp wcel
      vj cv cn wcel vm cv cn wcel wa wa wa vj vm weq vj cv cF cfv vj cv cF cfv
      cM co vj cv cF cfv vm cv cF cfv cM co vx cv clt vj vm weq vj cv cF cfv vm
      cv cF cfv vj cv cF cfv cM vj cv vm cv cF fveq2 opreq2d breq1d cM cme wcel
      cn cX cF wf wa vx cv crp wcel vj cv cn wcel vj cv cF cfv vj cv cF cfv cM
      co vx cv clt wbr vm cv cn wcel cM cme wcel vx cv crp wcel cn cX cF wf vj
      cv cn wcel vj cv cF cfv vj cv cF cfv cM co vx cv clt wbr cM cme wcel vx
      cv crp wcel wa vj cv cF cfv cX wcel vj cv cF cfv vj cv cF cfv cM co vx cv
      clt wbr cn cX cF wf vj cv cn wcel wa cM cme wcel vx cv crp wcel wa vj cv
      cF cfv cX wcel wa vj cv cF cfv vj cv cF cfv cM co cc0 vx cv clt cM cme
      wcel vj cv cF cfv cX wcel vj cv cF cfv vj cv cF cfv cM co cc0 wceq vx cv
      crp wcel vj cv cF cfv cM cX geomcau.1 met0 adantlr vx cv crp wcel cc0 vx
      cv clt wbr cM cme wcel vj cv cF cfv cX wcel vx cv rpgt0 ad2antlr eqbrtrd
      cn cX vj cv cF ffvelrn sylan2 an4s adantrrr syl5cbi 3ad2antl1 adantr jaod
      syld ex anassrs anassrs r19.21adva r19.22dva mpd r19.21aiva cM cme wcel
      cn cX cF wf wa cA cr wcel cB crp wcel cB c1 clt wbr w3a cF cM cca cfv
      wcel vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi
      vm cn wral vj cn wrex vx crp wral wb vk cv cF cfv vk cv c1 caddc co cF
      cfv cM co cA cB vk cv cexp co cmul co cle wbr vk cn wral vx cM vj vm cF
      cX geomcau.1 iscau5 3ad2ant1 mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d X j k r x y $. $d M j k r x y $. $d F j k r x y $.
    $d Y j k r x y $. $d G j k r $.
    lmclim2.1 $e |- X = dom dom M $.
    lmclim2.2 $e |- G
                   = { <. x , y >. | ( x e. NN /\ y = ( ( F ` x ) M Y ) ) } $.
    $( A sequence in a metric space converges to a point iff the distance
       between the point and the elements of the sequence converges to 0. $)
    lmclim2 $p |- ( ( M e. Met /\ F : NN --> X /\ Y e. X )
                                    -> ( F ( ~~>m ` M ) Y <-> G ~~> 0 ) ) $=
      cM cme wcel cn cX cF wf cY cX wcel w3a vj cv vk cv cle wbr vk cv cF cfv
      cY cM co vr cv clt wbr wi vk cn wral vj cn wrex vr crp wral cc0 vr cv clt
      wbr vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr
      wi vk cn wral vj cn wrex wi vr cr wral cF cY cM clm cfv wbr cG cc0 cli
      wbr cM cme wcel cn cX cF wf cY cX wcel w3a vr cv crp wcel vj cv vk cv cle
      wbr vk cv cF cfv cY cM co vr cv clt wbr wi vk cn wral vj cn wrex wi vr
      wal vr cv cr wcel cc0 vr cv clt wbr wa vj cv vk cv cle wbr vk cv cG cfv
      cc0 cmin co cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex wi vr wal vj
      cv vk cv cle wbr vk cv cF cfv cY cM co vr cv clt wbr wi vk cn wral vj cn
      wrex vr crp wral cc0 vr cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cc0
      cmin co cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex wi vr cr wral cM
      cme wcel cn cX cF wf cY cX wcel w3a vr cv crp wcel vj cv vk cv cle wbr vk
      cv cF cfv cY cM co vr cv clt wbr wi vk cn wral vj cn wrex wi vr cv cr
      wcel cc0 vr cv clt wbr wa vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co
      cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex wi vr cM cme wcel cn cX
      cF wf cY cX wcel w3a vr cv crp wcel vr cv cr wcel cc0 vr cv clt wbr wa vj
      cv vk cv cle wbr vk cv cF cfv cY cM co vr cv clt wbr wi vk cn wral vj cn
      wrex vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr
      wi vk cn wral vj cn wrex vr cv crp wcel vr cv cr wcel cc0 vr cv clt wbr
      wa wb cM cme wcel cn cX cF wf cY cX wcel w3a vr cv elrp a1i cM cme wcel
      cn cX cF wf cY cX wcel w3a vj cv vk cv cle wbr vk cv cF cfv cY cM co vr
      cv clt wbr wi vk cn wral vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co
      cabs cfv vr cv clt wbr wi vk cn wral vj cn cM cme wcel cn cX cF wf cY cX
      wcel w3a vj cv vk cv cle wbr vk cv cF cfv cY cM co vr cv clt wbr wi vj cv
      vk cv cle wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr wi vk cn cM
      cme wcel cn cX cF wf cY cX wcel w3a vk cv cn wcel wa vk cv cF cfv cY cM
      co vr cv clt wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr vj cv vk
      cv cle wbr cM cme wcel cn cX cF wf cY cX wcel w3a vk cv cn wcel wa vk cv
      cF cfv cY cM co vk cv cG cfv cc0 cmin co cabs cfv vr cv clt cM cme wcel
      cn cX cF wf cY cX wcel w3a vk cv cn wcel wa vk cv cF cfv cY cM co vk cv
      cF cfv cY cM co cabs cfv vk cv cF cfv cY cM co cc0 cmin co cabs cfv vk cv
      cG cfv cc0 cmin co cabs cfv cM cme wcel cn cX cF wf cY cX wcel w3a vk cv
      cn wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cabs cfv wceq cM cme
      wcel cY cX wcel cn cX cF wf vk cv cn wcel vk cv cF cfv cY cM co vk cv cF
      cfv cY cM co cabs cfv wceq wi cM cme wcel cY cX wcel cn cX cF wf vk cv cn
      wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cabs cfv wceq wi cM cme
      wcel cY cX wcel wa cn cX cF wf vk cv cn wcel vk cv cF cfv cY cM co vk cv
      cF cfv cY cM co cabs cfv wceq cM cme wcel cY cX wcel wa vk cv cF cfv cX
      wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cabs cfv wceq cn cX cF
      wf vk cv cn wcel wa cM cme wcel vk cv cF cfv cX wcel cY cX wcel vk cv cF
      cfv cY cM co vk cv cF cfv cY cM co cabs cfv wceq cM cme wcel vk cv cF cfv
      cX wcel cY cX wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cabs cfv
      wceq cM cme wcel vk cv cF cfv cX wcel cY cX wcel w3a vk cv cF cfv cY cM
      co cabs cfv vk cv cF cfv cY cM co vk cv cF cfv cY cM co cr wcel cc0 vk cv
      cF cfv cY cM co cle wbr vk cv cF cfv cY cM co cabs cfv vk cv cF cfv cY cM
      co wceq cM cme wcel vk cv cF cfv cX wcel cY cX wcel w3a vk cv cF cfv cY
      cM co absid vk cv cF cfv cY cM cX lmclim2.1 metcl vk cv cF cfv cY cM cX
      lmclim2.1 metge0 sylanc eqcomd 3expa an1rs cn cX vk cv cF ffvelrn sylan2
      expr 3impa 3com23 imp cM cme wcel cn cX cF wf cY cX wcel w3a vk cv cn
      wcel wa vk cv cF cfv cY cM co vk cv cF cfv cY cM co cc0 cmin co cabs cM
      cme wcel cn cX cF wf cY cX wcel w3a vk cv cn wcel vk cv cF cfv cY cM co
      vk cv cF cfv cY cM co cc0 cmin co wceq cM cme wcel cY cX wcel cn cX cF wf
      vk cv cn wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cc0 cmin co
      wceq wi cM cme wcel cY cX wcel cn cX cF wf vk cv cn wcel vk cv cF cfv cY
      cM co vk cv cF cfv cY cM co cc0 cmin co wceq wi cM cme wcel cY cX wcel wa
      cn cX cF wf vk cv cn wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cc0
      cmin co wceq cM cme wcel cY cX wcel wa vk cv cF cfv cX wcel vk cv cF cfv
      cY cM co vk cv cF cfv cY cM co cc0 cmin co wceq cn cX cF wf vk cv cn wcel
      wa cM cme wcel vk cv cF cfv cX wcel cY cX wcel vk cv cF cfv cY cM co vk
      cv cF cfv cY cM co cc0 cmin co wceq cM cme wcel vk cv cF cfv cX wcel cY
      cX wcel vk cv cF cfv cY cM co vk cv cF cfv cY cM co cc0 cmin co wceq cM
      cme wcel vk cv cF cfv cX wcel cY cX wcel w3a vk cv cF cfv cY cM co cr
      wcel vk cv cF cfv cY cM co cc wcel vk cv cF cfv cY cM co vk cv cF cfv cY
      cM co cc0 cmin co wceq vk cv cF cfv cY cM cX lmclim2.1 metcl vk cv cF cfv
      cY cM co recn vk cv cF cfv cY cM co cc wcel vk cv cF cfv cY cM co cc0
      cmin co vk cv cF cfv cY cM co vk cv cF cfv cY cM co subid1 eqcomd 3syl
      3expa an1rs cn cX vk cv cF ffvelrn sylan2 expr 3impa 3com23 imp fveq2d cM
      cme wcel cn cX cF wf cY cX wcel w3a vk cv cn wcel wa vk cv cF cfv cY cM
      co cc0 cmin co vk cv cG cfv cc0 cmin co cabs cM cme wcel cn cX cF wf cY
      cX wcel w3a vk cv cn wcel wa vk cv cF cfv cY cM co vk cv cG cfv cc0 cmin
      cM cme wcel cn cX cF wf cY cX wcel w3a vk cv cn wcel wa vk cv cG cfv vk
      cv cF cfv cY cM co vk cv cn wcel vk cv cG cfv vk cv cF cfv cY cM co wceq
      cM cme wcel cn cX cF wf cY cX wcel w3a vx vy vk cv vx cv cF cfv cY cM co
      vk cv cF cfv cY cM co cn cG vx cv vk cv wceq vx cv cF cfv vk cv cF cfv cY
      cM vx cv vk cv cF fveq2 opreq1d lmclim2.2 vk cv cF cfv cY cM oprex
      fvopab4 adantl eqcomd opreq1d fveq2d 3eqtrd breq1d imbi2d ralbidva
      rexbidv imbi12d albidv vj cv vk cv cle wbr vk cv cF cfv cY cM co vr cv
      clt wbr wi vk cn wral vj cn wrex vr crp df-ral cc0 vr cv clt wbr vj cv vk
      cv cle wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr wi vk cn wral
      vj cn wrex wi vr cr wral vr cv cr wcel cc0 vr cv clt wbr vj cv vk cv cle
      wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr wi vk cn wral vj cn
      wrex wi wi vr wal vr cv cr wcel cc0 vr cv clt wbr wa vj cv vk cv cle wbr
      vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex
      wi vr wal cc0 vr cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co
      cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex wi vr cr df-ral vr cv cr
      wcel cc0 vr cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co cabs
      cfv vr cv clt wbr wi vk cn wral vj cn wrex wi wi vr cv cr wcel cc0 vr cv
      clt wbr wa vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv
      clt wbr wi vk cn wral vj cn wrex wi vr vr cv cr wcel cc0 vr cv clt wbr wa
      vj cv vk cv cle wbr vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr wi vk
      cn wral vj cn wrex wi vr cv cr wcel cc0 vr cv clt wbr vj cv vk cv cle wbr
      vk cv cG cfv cc0 cmin co cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex
      wi wi vr cv cr wcel cc0 vr cv clt wbr vj cv vk cv cle wbr vk cv cG cfv
      cc0 cmin co cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex impexp bicomi
      albii bitri 3bitr4g cM cme wcel cY cX wcel cn cX cF wf cF cY cM clm cfv
      wbr vj cv vk cv cle wbr vk cv cF cfv cY cM co vr cv clt wbr wi vk cn wral
      vj cn wrex vr crp wral wb vr vk cv cF cfv cM cY vj vk cF cX lmclim2.1 vk
      cv cn wcel vk cv cF cfv eqidd lmbrnns 3com23 cn cc cG wf cc0 cc wcel cG
      cc0 cli wbr cc0 vr cv clt wbr vj cv vk cv cle wbr vk cv cG cfv cc0 cmin
      co cabs cfv vr cv clt wbr wi vk cn wral vj cn wrex wi vr cr wral wb cM
      cme wcel cn cX cF wf cY cX wcel w3a vr cc0 vj vk cG climfnn cM cme wcel
      cn cX cF wf cY cX wcel w3a vx cv cF cfv cY cM co cc wcel vx cn wral cn cc
      cG wf cM cme wcel cn cX cF wf cY cX wcel vx cv cF cfv cY cM co cc wcel vx
      cn wral cM cme wcel cY cX wcel cn cX cF wf vx cv cF cfv cY cM co cc wcel
      vx cn wral cM cme wcel cY cX wcel wa cn cX cF wf wa vx cv cF cfv cY cM co
      cc wcel vx cn cM cme wcel cY cX wcel wa cn cX cF wf vx cv cn wcel vx cv
      cF cfv cY cM co cc wcel cM cme wcel cY cX wcel wa vx cv cF cfv cX wcel vx
      cv cF cfv cY cM co cc wcel cn cX cF wf vx cv cn wcel wa cM cme wcel vx cv
      cF cfv cX wcel cY cX wcel vx cv cF cfv cY cM co cc wcel cM cme wcel vx cv
      cF cfv cX wcel cY cX wcel vx cv cF cfv cY cM co cc wcel cM cme wcel vx cv
      cF cfv cX wcel cY cX wcel w3a vx cv cF cfv cY cM co vx cv cF cfv cY cM cX
      lmclim2.1 metcl recnd 3expa an1rs cn cX vx cv cF ffvelrn sylan2 anassrs
      r19.21aiva an1rs 3impa vx vy cn cc vx cv cF cfv cY cM co cG lmclim2.2
      fopab2 sylib 0cn sylancl 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d K k j m n p x $. $d N k j m n p x $. $d Z k j m n p x $.
    $d W k j m n p x $. $d M k j m n p x $. $d X k j m n p x $.
    $d F k j m n p x $. $d G k j m n p x $.
    caushft.1 $e |- K e. NN $.
    caushft.2 $e |- N e. NN $.
    caushft.3 $e |- Z = ( ZZ>= ` K ) $.
    caushft.4 $e |- W = ( ZZ>= ` ( K + N ) ) $.
    caushft.5 $e |- X = dom dom M $.
    $( A shifted Cauchy sequence is Cauchy. $)
    caushft $p |- ( ( M e. Met /\ ( F : Z --> X /\ G : W --> X ) /\
                        A. k e. Z ( F ` k ) = ( G ` ( k + N ) ) ) ->
                            ( F e. ( Cau ` M ) <-> G e. ( Cau ` M ) ) ) $=
      cM cme wcel cZ cX cF wf cW cX cG wf wa vk cv cF cfv vk cv cN caddc co cG
      cfv wceq vk cZ wral w3a cc0 vx cv clt wbr vj cv vm cv cle wbr vj cv cF
      cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral vj cZ wrex wi vx cr
      wral cc0 vx cv clt wbr vn cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM
      co vx cv clt wbr wi vp cW wral vn cW wrex wi vx cr wral cF cM cca cfv
      wcel cG cM cca cfv wcel cM cme wcel cZ cX cF wf cW cX cG wf wa vk cv cF
      cfv vk cv cN caddc co cG cfv wceq vk cZ wral w3a cc0 vx cv clt wbr vj cv
      vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral
      vj cZ wrex wi cc0 vx cv clt wbr vn cv vp cv cle wbr vn cv cG cfv vp cv cG
      cfv cM co vx cv clt wbr wi vp cW wral vn cW wrex wi vx cr cM cme wcel cZ
      cX cF wf cW cX cG wf wa vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ
      wral w3a vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt
      wbr wi vm cZ wral vj cZ wrex vn cv vp cv cle wbr vn cv cG cfv vp cv cG
      cfv cM co vx cv clt wbr wi vp cW wral vn cW wrex cc0 vx cv clt wbr vk cv
      cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral cM cme wcel vj cv vm cv
      cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral vj cZ
      wrex vn cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi
      vp cW wral vn cW wrex wb cZ cX cF wf cW cX cG wf wa vk cv cF cfv vk cv cN
      caddc co cG cfv wceq vk cZ wral vj cv vm cv cle wbr vj cv cF cfv vm cv cF
      cfv cM co vx cv clt wbr wi vm cZ wral vj cZ wrex vn cv vp cv cle wbr vn
      cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cW wrex vk cv
      cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vj cv vm cv cle wbr vj cv
      cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral vn cv vp cv cle wbr
      vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cW wrex vj
      cZ vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vj cv cZ wcel wa
      vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm
      cZ wral vj cv cN caddc co cW wcel vj cv cN caddc co vp cv cle wbr vj cv
      cN caddc co cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral wa vn
      cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW
      wral vn cW wrex vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vj
      cv cZ wcel wa vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv
      clt wbr wi vm cZ wral vj cv cN caddc co cW wcel vj cv cN caddc co vp cv
      cle wbr vj cv cN caddc co cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp
      cW wral vj cv cZ wcel vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co
      vx cv clt wbr wi vm cZ wral vj cv cN caddc co cW wcel wi vk cv cF cfv vk
      cv cN caddc co cG cfv wceq vk cZ wral vj cv cZ wcel vj cv cN caddc co cW
      wcel vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi
      vm cZ wral vj cv cK cuz cfv wcel vj cv cN caddc co cK cN caddc co cuz cfv
      wcel vj cv cZ wcel vj cv cN caddc co cW wcel cN cK vj cv cK cn wcel cK cz
      wcel caushft.1 cK nnz ax-mp cN cn wcel cN cz wcel caushft.2 cN nnz ax-mp
      eluzaddi cZ cK cuz cfv vj cv caushft.3 eleq2i cW cK cN caddc co cuz cfv
      vj cv cN caddc co caushft.4 eleq2i 3imtr4i a1d adantl vk cv cF cfv vk cv
      cN caddc co cG cfv wceq vk cZ wral vj cv cZ wcel wa vj cv vm cv cle wbr
      vj cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral vj cv cN
      caddc co vp cv cle wbr vj cv cN caddc co cG cfv vp cv cG cfv cM co vx cv
      clt wbr wi vp cW vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vj
      cv cZ wcel wa vp cv cW wcel wa vj cv vm cv cle wbr vj cv cF cfv vm cv cF
      cfv cM co vx cv clt wbr wi vm cZ wral vj cv vp cv cN cmin co cle wbr vj
      cv cF cfv vp cv cN cmin co cF cfv cM co vx cv clt wbr wi vj cv cN caddc
      co vp cv cle wbr vj cv cN caddc co cG cfv vp cv cG cfv cM co vx cv clt
      wbr wi vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vj cv cZ
      wcel wa vp cv cW wcel wa vp cv cN cmin co cZ wcel vj cv vm cv cle wbr vj
      cv cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral vj cv vp cv cN
      cmin co cle wbr vj cv cF cfv vp cv cN cmin co cF cfv cM co vx cv clt wbr
      wi wi vp cv cW wcel vp cv cN cmin co cZ wcel vk cv cF cfv vk cv cN caddc
      co cG cfv wceq vk cZ wral vj cv cZ wcel wa vp cv cK cN caddc co cuz cfv
      wcel vp cv cN cmin co cK cuz cfv wcel vp cv cW wcel vp cv cN cmin co cZ
      wcel cN cK vp cv cK cn wcel cK cz wcel caushft.1 cK nnz ax-mp cN cn wcel
      cN cz wcel caushft.2 cN nnz ax-mp eluzsubi cW cK cN caddc co cuz cfv vp
      cv caushft.4 eleq2i cZ cK cuz cfv vp cv cN cmin co caushft.3 eleq2i
      3imtr4i adantl vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx cv
      clt wbr wi vj cv vp cv cN cmin co cle wbr vj cv cF cfv vp cv cN cmin co
      cF cfv cM co vx cv clt wbr wi vm vp cv cN cmin co cZ vm cv vp cv cN cmin
      co wceq vj cv vm cv cle wbr vj cv vp cv cN cmin co cle wbr vj cv cF cfv
      vm cv cF cfv cM co vx cv clt wbr vj cv cF cfv vp cv cN cmin co cF cfv cM
      co vx cv clt wbr vm cv vp cv cN cmin co vj cv cle breq2 vm cv vp cv cN
      cmin co wceq vj cv cF cfv vm cv cF cfv cM co vj cv cF cfv vp cv cN cmin
      co cF cfv cM co vx cv clt vm cv vp cv cN cmin co wceq vm cv cF cfv vp cv
      cN cmin co cF cfv vj cv cF cfv cM vm cv vp cv cN cmin co cF fveq2 opreq2d
      breq1d imbi12d rcla4v syl vk cv cF cfv vk cv cN caddc co cG cfv wceq vk
      cZ wral vj cv cZ wcel wa vp cv cW wcel wa vj cv vp cv cN cmin co cle wbr
      vj cv cN caddc co vp cv cle wbr vj cv cF cfv vp cv cN cmin co cF cfv cM
      co vx cv clt wbr vj cv cN caddc co cG cfv vp cv cG cfv cM co vx cv clt
      wbr vj cv cZ wcel vp cv cW wcel vj cv vp cv cN cmin co cle wbr vj cv cN
      caddc co vp cv cle wbr wb vk cv cF cfv vk cv cN caddc co cG cfv wceq vk
      cZ wral vj cv cZ wcel vp cv cW wcel wa vj cv cN caddc co vp cv cle wbr vj
      cv vp cv cN cmin co cle wbr vj cv cr wcel cN cr wcel vp cv cr wcel vj cv
      cN caddc co vp cv cle wbr vj cv vp cv cN cmin co cle wbr wb vj cv cZ wcel
      vp cv cW wcel wa vj cv cN vp cv leaddsub vj cv cZ wcel vj cv cr wcel vp
      cv cW wcel vj cv cZ wcel vj cv cK cuz cfv wcel vj cv cz wcel vj cv cr
      wcel vj cv cZ wcel vj cv cK cuz cfv wcel cZ cK cuz cfv vj cv caushft.3
      eleq2i biimpi cK vj cv eluzelz vj cv zre 3syl adantr cN cr wcel vj cv cZ
      wcel vp cv cW wcel wa cN caushft.2 nnrei a1i vp cv cW wcel vp cv cr wcel
      vj cv cZ wcel vp cv cW wcel vp cv cK cN caddc co cuz cfv wcel vp cv cz
      wcel vp cv cr wcel vp cv cW wcel vp cv cK cN caddc co cuz cfv wcel cW cK
      cN caddc co cuz cfv vp cv caushft.4 eleq2i biimpi cK cN caddc co vp cv
      eluzelz vp cv zre 3syl adantl syl3anc bicomd adantll vk cv cF cfv vk cv
      cN caddc co cG cfv wceq vk cZ wral vj cv cZ wcel wa vp cv cW wcel wa vj
      cv cF cfv vp cv cN cmin co cF cfv cM co vj cv cN caddc co cG cfv vp cv cG
      cfv cM co vx cv clt vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral
      vj cv cZ wcel wa vp cv cW wcel wa vj cv cF cfv vj cv cN caddc co cG cfv
      vp cv cN cmin co cF cfv vp cv cG cfv cM vk cv cF cfv vk cv cN caddc co cG
      cfv wceq vk cZ wral vj cv cZ wcel wa vj cv cF cfv vj cv cN caddc co cG
      cfv wceq vp cv cW wcel vk cv cF cfv vk cv cN caddc co cG cfv wceq vj cv
      cF cfv vj cv cN caddc co cG cfv wceq vk vj cv cZ vk cv vj cv wceq vk cv
      cF cfv vj cv cF cfv vk cv cN caddc co cG cfv vj cv cN caddc co cG cfv vk
      cv vj cv cF fveq2 vk cv vj cv wceq vk cv cN caddc co vj cv cN caddc co cG
      vk cv vj cv cN caddc opreq1 fveq2d eqeq12d rcla4cva adantr vk cv cF cfv
      vk cv cN caddc co cG cfv wceq vk cZ wral vp cv cW wcel vp cv cN cmin co
      cF cfv vp cv cG cfv wceq vj cv cZ wcel vk cv cF cfv vk cv cN caddc co cG
      cfv wceq vk cZ wral vp cv cW wcel wa vp cv cN cmin co cF cfv vp cv cN
      cmin co cN caddc co cG cfv vp cv cG cfv vk cv cF cfv vk cv cN caddc co cG
      cfv wceq vk cZ wral vp cv cN cmin co cZ wcel vp cv cN cmin co cF cfv vp
      cv cN cmin co cN caddc co cG cfv wceq vp cv cW wcel vk cv cF cfv vk cv cN
      caddc co cG cfv wceq vp cv cN cmin co cF cfv vp cv cN cmin co cN caddc co
      cG cfv wceq vk vp cv cN cmin co cZ vk cv vp cv cN cmin co wceq vk cv cF
      cfv vp cv cN cmin co cF cfv vk cv cN caddc co cG cfv vp cv cN cmin co cN
      caddc co cG cfv vk cv vp cv cN cmin co cF fveq2 vk cv vp cv cN cmin co
      wceq vk cv cN caddc co vp cv cN cmin co cN caddc co cG vk cv vp cv cN
      cmin co cN caddc opreq1 fveq2d eqeq12d rcla4cva vp cv cK cN caddc co cuz
      cfv wcel vp cv cN cmin co cK cuz cfv wcel vp cv cW wcel vp cv cN cmin co
      cZ wcel cN cK vp cv cK cn wcel cK cz wcel caushft.1 cK nnz ax-mp cN cn
      wcel cN cz wcel caushft.2 cN nnz ax-mp eluzsubi cW cK cN caddc co cuz cfv
      vp cv caushft.4 eleq2i cZ cK cuz cfv vp cv cN cmin co caushft.3 eleq2i
      3imtr4i sylan2 vp cv cW wcel vp cv cN cmin co cN caddc co cG cfv vp cv cG
      cfv wceq vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vp cv cW
      wcel vp cv cN cmin co cN caddc co vp cv cG vp cv cc wcel cN cc wcel vp cv
      cN cmin co cN caddc co vp cv wceq vp cv cW wcel vp cv cN npcan vp cv cW
      wcel vp cv vp cv cW wcel vp cv cK cN caddc co cuz cfv wcel vp cv cz wcel
      vp cv cr wcel vp cv cW wcel vp cv cK cN caddc co cuz cfv wcel cW cK cN
      caddc co cuz cfv vp cv caushft.4 eleq2i biimpi cK cN caddc co vp cv
      eluzelz vp cv zre 3syl recnd cN caushft.2 nncni sylancl fveq2d adantl
      eqtrd adantlr opreq12d breq1d imbi12d sylibd r19.21adva jcad vn cv vp cv
      cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vj cv
      cN caddc co vp cv cle wbr vj cv cN caddc co cG cfv vp cv cG cfv cM co vx
      cv clt wbr wi vp cW wral vn vj cv cN caddc co cW vn cv vj cv cN caddc co
      wceq vn cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi
      vj cv cN caddc co vp cv cle wbr vj cv cN caddc co cG cfv vp cv cG cfv cM
      co vx cv clt wbr wi vp cW vn cv vj cv cN caddc co wceq vn cv vp cv cle
      wbr vj cv cN caddc co vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv
      clt wbr vj cv cN caddc co cG cfv vp cv cG cfv cM co vx cv clt wbr vn cv
      vj cv cN caddc co vp cv cle breq1 vn cv vj cv cN caddc co wceq vn cv cG
      cfv vp cv cG cfv cM co vj cv cN caddc co cG cfv vp cv cG cfv cM co vx cv
      clt vn cv vj cv cN caddc co wceq vn cv cG cfv vj cv cN caddc co cG cfv vp
      cv cG cfv cM vn cv vj cv cN caddc co cG fveq2 opreq1d breq1d imbi12d
      ralbidv rcla4ev syl6 r19.23adva vk cv cF cfv vk cv cN caddc co cG cfv
      wceq vk cZ wral vn cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv
      clt wbr wi vp cW wral vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co
      vx cv clt wbr wi vm cZ wral vj cZ wrex vn cW vk cv cF cfv vk cv cN caddc
      co cG cfv wceq vk cZ wral vn cv cW wcel wa vn cv vp cv cle wbr vn cv cG
      cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cv cN cmin co cZ
      wcel vn cv cN cmin co vm cv cle wbr vn cv cN cmin co cF cfv vm cv cF cfv
      cM co vx cv clt wbr wi vm cZ wral wa vj cv vm cv cle wbr vj cv cF cfv vm
      cv cF cfv cM co vx cv clt wbr wi vm cZ wral vj cZ wrex vk cv cF cfv vk cv
      cN caddc co cG cfv wceq vk cZ wral vn cv cW wcel wa vn cv vp cv cle wbr
      vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cv cN cmin
      co cZ wcel vn cv cN cmin co vm cv cle wbr vn cv cN cmin co cF cfv vm cv
      cF cfv cM co vx cv clt wbr wi vm cZ wral vn cv cW wcel vn cv vp cv cle
      wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cv cN
      cmin co cZ wcel wi vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral
      vn cv cW wcel vn cv cN cmin co cZ wcel vn cv vp cv cle wbr vn cv cG cfv
      vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cv cK cN caddc co cuz
      cfv wcel vn cv cN cmin co cK cuz cfv wcel vn cv cW wcel vn cv cN cmin co
      cZ wcel cN cK vn cv cK cn wcel cK cz wcel caushft.1 cK nnz ax-mp cN cn
      wcel cN cz wcel caushft.2 cN nnz ax-mp eluzsubi cW cK cN caddc co cuz cfv
      vn cv caushft.4 eleq2i cZ cK cuz cfv vn cv cN cmin co caushft.3 eleq2i
      3imtr4i a1d adantl vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral
      vn cv cW wcel wa vn cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx
      cv clt wbr wi vp cW wral vn cv cN cmin co vm cv cle wbr vn cv cN cmin co
      cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ vk cv cF cfv vk cv cN
      caddc co cG cfv wceq vk cZ wral vn cv cW wcel wa vm cv cZ wcel wa vn cv
      vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral
      vn cv vm cv cN caddc co cle wbr vn cv cG cfv vm cv cN caddc co cG cfv cM
      co vx cv clt wbr wi vn cv cN cmin co vm cv cle wbr vn cv cN cmin co cF
      cfv vm cv cF cfv cM co vx cv clt wbr wi vk cv cF cfv vk cv cN caddc co cG
      cfv wceq vk cZ wral vn cv cW wcel wa vm cv cZ wcel wa vm cv cN caddc co
      cW wcel vn cv vp cv cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr
      wi vp cW wral vn cv vm cv cN caddc co cle wbr vn cv cG cfv vm cv cN caddc
      co cG cfv cM co vx cv clt wbr wi wi vm cv cZ wcel vm cv cN caddc co cW
      wcel vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vn cv cW wcel
      wa vm cv cK cuz cfv wcel vm cv cN caddc co cK cN caddc co cuz cfv wcel vm
      cv cZ wcel vm cv cN caddc co cW wcel cN cK vm cv cK cn wcel cK cz wcel
      caushft.1 cK nnz ax-mp cN cn wcel cN cz wcel caushft.2 cN nnz ax-mp
      eluzaddi cZ cK cuz cfv vm cv caushft.3 eleq2i cW cK cN caddc co cuz cfv
      vm cv cN caddc co caushft.4 eleq2i 3imtr4i adantl vn cv vp cv cle wbr vn
      cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vn cv vm cv cN caddc co cle
      wbr vn cv cG cfv vm cv cN caddc co cG cfv cM co vx cv clt wbr wi vp vm cv
      cN caddc co cW vp cv vm cv cN caddc co wceq vn cv vp cv cle wbr vn cv vm
      cv cN caddc co cle wbr vn cv cG cfv vp cv cG cfv cM co vx cv clt wbr vn
      cv cG cfv vm cv cN caddc co cG cfv cM co vx cv clt wbr vp cv vm cv cN
      caddc co vn cv cle breq2 vp cv vm cv cN caddc co wceq vn cv cG cfv vp cv
      cG cfv cM co vn cv cG cfv vm cv cN caddc co cG cfv cM co vx cv clt vp cv
      vm cv cN caddc co wceq vp cv cG cfv vm cv cN caddc co cG cfv vn cv cG cfv
      cM vp cv vm cv cN caddc co cG fveq2 opreq2d breq1d imbi12d rcla4v syl vk
      cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vn cv cW wcel wa vm cv
      cZ wcel wa vn cv vm cv cN caddc co cle wbr vn cv cN cmin co vm cv cle wbr
      vn cv cG cfv vm cv cN caddc co cG cfv cM co vx cv clt wbr vn cv cN cmin
      co cF cfv vm cv cF cfv cM co vx cv clt wbr vn cv cW wcel vm cv cZ wcel vn
      cv vm cv cN caddc co cle wbr vn cv cN cmin co vm cv cle wbr wb vk cv cF
      cfv vk cv cN caddc co cG cfv wceq vk cZ wral vn cv cW wcel vm cv cZ wcel
      wa vn cv cN cmin co vm cv cle wbr vn cv vm cv cN caddc co cle wbr vn cv
      cr wcel cN cr wcel vm cv cr wcel vn cv cN cmin co vm cv cle wbr vn cv vm
      cv cN caddc co cle wbr wb vn cv cW wcel vm cv cZ wcel wa vn cv cN vm cv
      lesubadd vn cv cW wcel vn cv cr wcel vm cv cZ wcel vn cv cW wcel vn cv cK
      cN caddc co cuz cfv wcel vn cv cz wcel vn cv cr wcel vn cv cW wcel vn cv
      cK cN caddc co cuz cfv wcel cW cK cN caddc co cuz cfv vn cv caushft.4
      eleq2i biimpi cK cN caddc co vn cv eluzelz vn cv zre 3syl adantr cN cr
      wcel vn cv cW wcel vm cv cZ wcel wa cN caushft.2 nnrei a1i vm cv cZ wcel
      vm cv cr wcel vn cv cW wcel vm cv cZ wcel vm cv cK cuz cfv wcel vm cv cz
      wcel vm cv cr wcel vm cv cZ wcel vm cv cK cuz cfv wcel cZ cK cuz cfv vm
      cv caushft.3 eleq2i biimpi cK vm cv eluzelz vm cv zre 3syl adantl syl3anc
      bicomd adantll vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vn
      cv cW wcel wa vm cv cZ wcel wa vn cv cG cfv vm cv cN caddc co cG cfv cM
      co vn cv cN cmin co cF cfv vm cv cF cfv cM co vx cv clt vk cv cF cfv vk
      cv cN caddc co cG cfv wceq vk cZ wral vn cv cW wcel wa vm cv cZ wcel wa
      vn cv cN cmin co cF cfv vm cv cF cfv cM co vn cv cG cfv vm cv cN caddc co
      cG cfv cM co vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vn cv
      cW wcel wa vm cv cZ wcel wa vn cv cN cmin co cF cfv vn cv cG cfv vm cv cF
      cfv vm cv cN caddc co cG cfv cM vk cv cF cfv vk cv cN caddc co cG cfv
      wceq vk cZ wral vn cv cW wcel wa vn cv cN cmin co cF cfv vn cv cG cfv
      wceq vm cv cZ wcel vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral
      vn cv cW wcel wa vn cv cN cmin co cF cfv vn cv cN cmin co cN caddc co cG
      cfv vn cv cG cfv vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral vn
      cv cN cmin co cZ wcel vn cv cN cmin co cF cfv vn cv cN cmin co cN caddc
      co cG cfv wceq vn cv cW wcel vk cv cF cfv vk cv cN caddc co cG cfv wceq
      vn cv cN cmin co cF cfv vn cv cN cmin co cN caddc co cG cfv wceq vk vn cv
      cN cmin co cZ vk cv vn cv cN cmin co wceq vk cv cF cfv vn cv cN cmin co
      cF cfv vk cv cN caddc co cG cfv vn cv cN cmin co cN caddc co cG cfv vk cv
      vn cv cN cmin co cF fveq2 vk cv vn cv cN cmin co wceq vk cv cN caddc co
      vn cv cN cmin co cN caddc co cG vk cv vn cv cN cmin co cN caddc opreq1
      fveq2d eqeq12d rcla4cva vn cv cK cN caddc co cuz cfv wcel vn cv cN cmin
      co cK cuz cfv wcel vn cv cW wcel vn cv cN cmin co cZ wcel cN cK vn cv cK
      cn wcel cK cz wcel caushft.1 cK nnz ax-mp cN cn wcel cN cz wcel caushft.2
      cN nnz ax-mp eluzsubi cW cK cN caddc co cuz cfv vn cv caushft.4 eleq2i cZ
      cK cuz cfv vn cv cN cmin co caushft.3 eleq2i 3imtr4i sylan2 vn cv cW wcel
      vn cv cN cmin co cN caddc co cG cfv vn cv cG cfv wceq vk cv cF cfv vk cv
      cN caddc co cG cfv wceq vk cZ wral vn cv cW wcel vn cv cN cmin co cN
      caddc co vn cv cG vn cv cc wcel cN cc wcel vn cv cN cmin co cN caddc co
      vn cv wceq vn cv cW wcel vn cv cN npcan vn cv cW wcel vn cv cK cN caddc
      co cuz cfv wcel vn cv cz wcel vn cv cc wcel vn cv cW wcel vn cv cK cN
      caddc co cuz cfv wcel cW cK cN caddc co cuz cfv vn cv caushft.4 eleq2i
      biimpi cK cN caddc co vn cv eluzelz vn cv zcn 3syl cN caushft.2 nncni
      sylancl fveq2d adantl eqtrd adantr vk cv cF cfv vk cv cN caddc co cG cfv
      wceq vk cZ wral vm cv cZ wcel vm cv cF cfv vm cv cN caddc co cG cfv wceq
      vn cv cW wcel vk cv cF cfv vk cv cN caddc co cG cfv wceq vm cv cF cfv vm
      cv cN caddc co cG cfv wceq vk vm cv cZ vk cv vm cv wceq vk cv cF cfv vm
      cv cF cfv vk cv cN caddc co cG cfv vm cv cN caddc co cG cfv vk cv vm cv
      cF fveq2 vk cv vm cv wceq vk cv cN caddc co vm cv cN caddc co cG vk cv vm
      cv cN caddc opreq1 fveq2d eqeq12d rcla4cva adantlr opreq12d eqcomd breq1d
      imbi12d sylibd r19.21adva jcad vj cv vm cv cle wbr vj cv cF cfv vm cv cF
      cfv cM co vx cv clt wbr wi vm cZ wral vn cv cN cmin co vm cv cle wbr vn
      cv cN cmin co cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ wral vj vn
      cv cN cmin co cZ vj cv vn cv cN cmin co wceq vj cv vm cv cle wbr vj cv cF
      cfv vm cv cF cfv cM co vx cv clt wbr wi vn cv cN cmin co vm cv cle wbr vn
      cv cN cmin co cF cfv vm cv cF cfv cM co vx cv clt wbr wi vm cZ vj cv vn
      cv cN cmin co wceq vj cv vm cv cle wbr vn cv cN cmin co vm cv cle wbr vj
      cv cF cfv vm cv cF cfv cM co vx cv clt wbr vn cv cN cmin co cF cfv vm cv
      cF cfv cM co vx cv clt wbr vj cv vn cv cN cmin co vm cv cle breq1 vj cv
      vn cv cN cmin co wceq vj cv cF cfv vm cv cF cfv cM co vn cv cN cmin co cF
      cfv vm cv cF cfv cM co vx cv clt vj cv vn cv cN cmin co wceq vj cv cF cfv
      vn cv cN cmin co cF cfv vm cv cF cfv cM vj cv vn cv cN cmin co cF fveq2
      opreq1d breq1d imbi12d ralbidv rcla4ev syl6 r19.23adva impbid 3ad2ant3
      imbi2d ralbidv cM cme wcel cZ cX cF wf cW cX cG wf wa cF cM cca cfv wcel
      cc0 vx cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM co vx
      cv clt wbr wi vm cZ wral vj cZ wrex wi vx cr wral wb vk cv cF cfv vk cv
      cN caddc co cG cfv wceq vk cZ wral cM cme wcel cZ cX cF wf cF cM cca cfv
      wcel cc0 vx cv clt wbr vj cv vm cv cle wbr vj cv cF cfv vm cv cF cfv cM
      co vx cv clt wbr wi vm cZ wral vj cZ wrex wi vx cr wral wb cW cX cG wf vx
      cM vj vm cF cK cX cZ caushft.5 cK cn wcel cK cz wcel caushft.1 cK nnz
      ax-mp caushft.3 iscauf adantrr 3adant3 cM cme wcel cZ cX cF wf cW cX cG
      wf wa cG cM cca cfv wcel cc0 vx cv clt wbr vn cv vp cv cle wbr vn cv cG
      cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cW wrex wi vx cr
      wral wb vk cv cF cfv vk cv cN caddc co cG cfv wceq vk cZ wral cM cme wcel
      cW cX cG wf cG cM cca cfv wcel cc0 vx cv clt wbr vn cv vp cv cle wbr vn
      cv cG cfv vp cv cG cfv cM co vx cv clt wbr wi vp cW wral vn cW wrex wi vx
      cr wral wb cZ cX cF wf vx cM vn vp cG cK cN caddc co cX cW caushft.5 cK
      cz wcel cN cz wcel cK cN caddc co cz wcel cK cn wcel cK cz wcel caushft.1
      cK nnz ax-mp cN cn wcel cN cz wcel caushft.2 cN nnz ax-mp cK cN zaddcl
      mp2an caushft.4 iscauf adantrl 3adant3 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M j k x $. $d N j k x $. $d X j k x $. $d Z j k x $. $d F j k x $.
    caures.1 $e |- X = dom dom M $.
    caures.2 $e |- N e. ZZ $.
    caures.3 $e |- Z = ( ZZ>= ` N ) $.
    $( The restriction of a Cauchy sequence to a set of upper integers is
       Cauchy. $)
    caures $p |- ( ( M e. Met /\ F C_ ( CC X. X ) ) ->
                      ( F e. ( Cau ` M ) <-> ( F |` Z ) e. ( Cau ` M ) ) ) $=
      cM cme wcel cF cc cX cxp wss wa cF cc cX cxp wss cc0 vx cv clt wbr vj cv
      vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk
      cv cF cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral
      wa cF cZ cres cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv
      cF cZ cres cfv cX wcel vk cv cF cZ cres cfv cX wcel vj cv cF cZ cres cfv
      vk cv cF cZ cres cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi
      vx cr wral wa cF cM cca cfv wcel cF cZ cres cM cca cfv wcel cF cc cX cxp
      wss cF cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv
      cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cM co vx cv clt
      wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral wa cF cZ cres cc cX cxp
      wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cZ cres cfv cX wcel vk
      cv cF cZ cres cfv cX wcel vj cv cF cZ cres cfv vk cv cF cZ cres cfv cM co
      vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral wa wb cM cme
      wcel cF cc cX cxp wss cF cc cX cxp wss cF cZ cres cc cX cxp wss cc0 vx cv
      clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj
      cv cF cfv vk cv cF cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex
      wi vx cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cZ cres cfv
      cX wcel vk cv cF cZ cres cfv cX wcel vj cv cF cZ cres cfv vk cv cF cZ
      cres cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral
      cF cc cX cxp wss cF cc cX cxp wss wi cF cc cX cxp wss cF cZ cres cc cX
      cxp wss wi cF cc cX cxp wss cF cc cX cxp wss cF cZ cres cc cX cxp wss wb
      wi cF cc cX cxp wss id cF cZ cres cF wss cF cc cX cxp wss cF cZ cres cc
      cX cxp wss cF cZ resss cF cZ cres cF cc cX cxp sstr mpan cF cc cX cxp wss
      cF cc cX cxp wss cF cZ cres cc cX cxp wss pm5.35 mp2an cc0 vx cv clt wbr
      vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
      cfv vk cv cF cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx
      cr wral cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cZ cres cfv cX
      wcel vk cv cF cZ cres cfv cX wcel vj cv cF cZ cres cfv vk cv cF cZ cres
      cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx cr wral wb cF
      cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel
      vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cM co vx cv clt wbr w3a wi
      vk cZ wral vj cZ wrex wi cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF
      cZ cres cfv cX wcel vk cv cF cZ cres cfv cX wcel vj cv cF cZ cres cfv vk
      cv cF cZ cres cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex wi vx
      cr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF
      cfv vk cv cF cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ wrex vj cv
      vk cv cle wbr vj cv cF cZ cres cfv cX wcel vk cv cF cZ cres cfv cX wcel
      vj cv cF cZ cres cfv vk cv cF cZ cres cfv cM co vx cv clt wbr w3a wi vk
      cZ wral vj cZ wrex cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX
      wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cM co vx cv clt wbr
      w3a wi vk cZ wral vj cv vk cv cle wbr vj cv cF cZ cres cfv cX wcel vk cv
      cF cZ cres cfv cX wcel vj cv cF cZ cres cfv vk cv cF cZ cres cfv cM co vx
      cv clt wbr w3a wi vk cZ wral vj cZ vj cv cZ wcel vj cv vk cv cle wbr vj
      cv cF cfv cX wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cM co vx
      cv clt wbr w3a wi vj cv vk cv cle wbr vj cv cF cZ cres cfv cX wcel vk cv
      cF cZ cres cfv cX wcel vj cv cF cZ cres cfv vk cv cF cZ cres cfv cM co vx
      cv clt wbr w3a wi vk cZ vj cv cZ wcel vk cv cZ wcel wa vj cv cF cfv cX
      wcel vk cv cF cfv cX wcel vj cv cF cfv vk cv cF cfv cM co vx cv clt wbr
      w3a vj cv cF cZ cres cfv cX wcel vk cv cF cZ cres cfv cX wcel vj cv cF cZ
      cres cfv vk cv cF cZ cres cfv cM co vx cv clt wbr w3a vj cv vk cv cle wbr
      vj cv cZ wcel vk cv cZ wcel wa vj cv cF cfv cX wcel vj cv cF cZ cres cfv
      cX wcel vk cv cF cfv cX wcel vk cv cF cZ cres cfv cX wcel vj cv cF cfv vk
      cv cF cfv cM co vx cv clt wbr vj cv cF cZ cres cfv vk cv cF cZ cres cfv
      cM co vx cv clt wbr vj cv cZ wcel vk cv cZ wcel wa vj cv cF cfv vj cv cF
      cZ cres cfv cX vj cv cZ wcel vj cv cF cfv vj cv cF cZ cres cfv wceq vk cv
      cZ wcel vj cv cZ wcel vj cv cF cZ cres cfv vj cv cF cfv vj cv cZ cF fvres
      eqcomd adantr eleq1d vj cv cZ wcel vk cv cZ wcel wa vk cv cF cfv vk cv cF
      cZ cres cfv cX vk cv cZ wcel vk cv cF cfv vk cv cF cZ cres cfv wceq vj cv
      cZ wcel vk cv cZ wcel vk cv cF cZ cres cfv vk cv cF cfv vk cv cZ cF fvres
      eqcomd adantl eleq1d vj cv cZ wcel vk cv cZ wcel wa vj cv cF cfv vk cv cF
      cfv cM co vj cv cF cZ cres cfv vk cv cF cZ cres cfv cM co vx cv clt vj cv
      cZ wcel vk cv cZ wcel vj cv cF cfv vj cv cF cZ cres cfv vk cv cF cfv vk
      cv cF cZ cres cfv cM vj cv cZ wcel vj cv cF cZ cres cfv vj cv cF cfv vj
      cv cZ cF fvres eqcomd vk cv cZ wcel vk cv cF cZ cres cfv vk cv cF cfv vk
      cv cZ cF fvres eqcomd opreqan12d breq1d 3anbi123d imbi2d ralbidva rexbiia
      imbi2i ralbii a1i anbi12d adantl cM cme wcel cF cM cca cfv wcel cF cc cX
      cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr vj cv cF cfv cX wcel vk cv
      cF cfv cX wcel vj cv cF cfv vk cv cF cfv cM co vx cv clt wbr w3a wi vk cZ
      wral vj cZ wrex wi vx cr wral wa wb cF cc cX cxp wss vx cM vj vk cF cN cX
      cZ caures.1 caures.2 caures.3 iscau3 adantr cM cme wcel cF cZ cres cM cca
      cfv wcel cF cZ cres cc cX cxp wss cc0 vx cv clt wbr vj cv vk cv cle wbr
      vj cv cF cZ cres cfv cX wcel vk cv cF cZ cres cfv cX wcel vj cv cF cZ
      cres cfv vk cv cF cZ cres cfv cM co vx cv clt wbr w3a wi vk cZ wral vj cZ
      wrex wi vx cr wral wa wb cF cc cX cxp wss vx cM vj vk cF cZ cres cN cX cZ
      caures.1 caures.2 caures.3 iscau3 adantr 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M x y u v w z $. $d X x y u v w z $. $d J x y u v w z $.
    $d R x y u v w z $. $d Y x y u v w z $. $d D u v w z $.
    metdcn.1 $e |- X = dom dom M $.
    metdcn.2 $e |- J = ( Open ` M ) $.
    metdcn.3 $e |- R = ( Open ` ( ( abs o. - )
                                  |` ( ( 0 [,) +oo ) X. ( 0 [,) +oo ) ) ) ) $.
    metdcn.4 $e |- D = { <. x , y >. | ( x e. X /\ y = ( Y M x ) ) } $.
    $( The function which gives the distance to a fixed point in a metric space
       is a continuous function into nonnegative reals. $)
    metdcn $p |- ( ( M e. Met /\ Y e. X ) -> D e. ( J Cn R ) ) $=
      cM cme wcel cY cX wcel wa cD cJ cR ccn co wcel cX cc0 cpnf cico co cD wf
      cc0 vw cv clt wbr cc0 vz cv clt wbr vu cv vv cv cM co vz cv clt wbr vu cv
      cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp
      cres co vw cv clt wbr wi vv cX wral wa vz cr wrex wi vw cr wral vu cX
      wral wa cM cme wcel cY cX wcel wa cX cc0 cpnf cico co cD wf cc0 vw cv clt
      wbr cc0 vz cv clt wbr vu cv vv cv cM co vz cv clt wbr vu cv cD cfv vv cv
      cD cfv cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres co vw cv
      clt wbr wi vv cX wral wa vz cr wrex wi vw cr wral vu cX wral cM cme wcel
      cY cX wcel wa cY vx cv cM co cc0 cpnf cico co wcel vx cX wral cX cc0 cpnf
      cico co cD wf cM cme wcel cY cX wcel wa cY vx cv cM co cc0 cpnf cico co
      wcel vx cX cM cme wcel cY cX wcel vx cv cX wcel cY vx cv cM co cc0 cpnf
      cico co wcel cY vx cv cM co cc0 cpnf cico co wcel cY vx cv cM co cr wcel
      cc0 cY vx cv cM co cle wbr cM cme wcel cY cX wcel vx cv cX wcel w3a cY vx
      cv cM co elnnr cY vx cv cM cX metdcn.1 metcl cY vx cv cM cX metdcn.1
      metge0 sylanbrc 3expa r19.21aiva vx vy cX cc0 cpnf cico co cY vx cv cM co
      cD metdcn.4 fopab2 sylib cM cme wcel cY cX wcel wa cc0 vw cv clt wbr cc0
      vz cv clt wbr vu cv vv cv cM co vz cv clt wbr vu cv cD cfv vv cv cD cfv
      cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt
      wbr wi vv cX wral wa vz cr wrex wi vu vw cX cr cM cme wcel cY cX wcel wa
      vu cv cX wcel vw cv cr wcel wa cc0 vw cv clt wbr cc0 vz cv clt wbr vu cv
      vv cv cM co vz cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0
      cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral wa
      vz cr wrex vw cv cr wcel cc0 vw cv clt wbr vu cv vv cv cM co vw cv clt
      wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0 cpnf
      cico co cxp cres co vw cv clt wbr wi vv cX wral cc0 vz cv clt wbr vu cv
      vv cv cM co vz cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0
      cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral wa
      vz cr wrex cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa
      cc0 vw cv clt wbr wa cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr
      wcel cc0 vw cv clt wbr simplrr cM cme wcel cY cX wcel wa vu cv cX wcel vw
      cv cr wcel wa wa cc0 vw cv clt wbr pm3.27 cM cme wcel cY cX wcel wa vu cv
      cX wcel vw cv cr wcel wa wa cc0 vw cv clt wbr wa vu cv vv cv cM co vw cv
      clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0
      cpnf cico co cxp cres co vw cv clt wbr wi vv cX cM cme wcel cY cX wcel wa
      vu cv cX wcel vw cv cr wcel wa wa vv cv cX wcel vu cv vv cv cM co vw cv
      clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0
      cpnf cico co cxp cres co vw cv clt wbr wi cc0 vw cv clt wbr cM cme wcel
      cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv cv cX wcel wa vu cv vv
      cv cM co vw cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf
      cico co cc0 cpnf cico co cxp cres co vw cv clt wbr cM cme wcel cY cX wcel
      wa vu cv cX wcel vw cv cr wcel wa wa vv cv cX wcel wa vu cv vv cv cM co
      vw cv clt wbr wa vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico
      co cc0 cpnf cico co cxp cres co cY vu cv cM co cY vv cv cM co cabs cmin
      ccom co vw cv clt cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel
      wa wa vv cv cX wcel wa vu cv vv cv cM co vw cv clt wbr wa vu cv cD cfv vv
      cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres co cY
      vu cv cM co cY vv cv cM co cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico
      co cxp cres co cY vu cv cM co cY vv cv cM co cabs cmin ccom co cM cme
      wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv cv cX wcel wa vu
      cv vv cv cM co vw cv clt wbr wa vu cv cD cfv cY vu cv cM co vv cv cD cfv
      cY vv cv cM co cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres
      cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vu cv cD cfv
      cY vu cv cM co wceq vv cv cX wcel vu cv vv cv cM co vw cv clt wbr vu cv
      cX wcel vu cv cD cfv cY vu cv cM co wceq cM cme wcel cY cX wcel wa vw cv
      cr wcel vx vy vu cv cY vx cv cM co cY vu cv cM co cX cD vx cv vu cv cY cM
      opreq2 metdcn.4 cY vu cv cM oprex fvopab4 ad2antrl ad2antrr vv cv cX wcel
      vv cv cD cfv cY vv cv cM co wceq cM cme wcel cY cX wcel wa vu cv cX wcel
      vw cv cr wcel wa wa vu cv vv cv cM co vw cv clt wbr vx vy vv cv cY vx cv
      cM co cY vv cv cM co cX cD vx cv vv cv cY cM opreq2 metdcn.4 cY vv cv cM
      oprex fvopab4 ad2antlr opreq12d cM cme wcel cY cX wcel wa vu cv cX wcel
      vw cv cr wcel wa wa vv cv cX wcel wa cY vu cv cM co cY vv cv cM co cabs
      cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres co cY vu cv cM co cY
      vv cv cM co cabs cmin ccom co wceq vu cv vv cv cM co vw cv clt wbr cM cme
      wcel cY cX wcel wa vu cv cX wcel vv cv cX wcel cY vu cv cM co cY vv cv cM
      co cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres co cY vu cv
      cM co cY vv cv cM co cabs cmin ccom co wceq vw cv cr wcel cY vu cv cM co
      cc0 cpnf cico co wcel cY vv cv cM co cc0 cpnf cico co wcel cY vu cv cM co
      cY vv cv cM co cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres
      co cY vu cv cM co cY vv cv cM co cabs cmin ccom co wceq cM cme wcel cY cX
      wcel wa vu cv cX wcel wa vv cv cX wcel wa cY vu cv cM co cY vv cv cM co
      cc0 cpnf cico co cc0 cpnf cico co cabs cmin ccom oprvres cM cme wcel cY
      cX wcel wa vu cv cX wcel wa cY vu cv cM co cc0 cpnf cico co wcel vv cv cX
      wcel cM cme wcel cY cX wcel vu cv cX wcel cY vu cv cM co cc0 cpnf cico co
      wcel cY vu cv cM co cc0 cpnf cico co wcel cY vu cv cM co cr wcel cc0 cY
      vu cv cM co cle wbr cM cme wcel cY cX wcel vu cv cX wcel w3a cY vu cv cM
      co elnnr cY vu cv cM cX metdcn.1 metcl cY vu cv cM cX metdcn.1 metge0
      sylanbrc 3expa adantr cM cme wcel cY cX wcel wa vv cv cX wcel cY vv cv cM
      co cc0 cpnf cico co wcel vu cv cX wcel cM cme wcel cY cX wcel vv cv cX
      wcel cY vv cv cM co cc0 cpnf cico co wcel cY vv cv cM co cc0 cpnf cico co
      wcel cY vv cv cM co cr wcel cc0 cY vv cv cM co cle wbr cM cme wcel cY cX
      wcel vv cv cX wcel w3a cY vv cv cM co elnnr cY vv cv cM cX metdcn.1 metcl
      cY vv cv cM cX metdcn.1 metge0 sylanbrc 3expa adantlr sylanc adantlrr
      adantr eqtrd cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa
      vv cv cX wcel wa vu cv vv cv cM co vw cv clt wbr wa cY vu cv cM co cY vv
      cv cM co cabs cmin ccom co cY vu cv cM co cY vv cv cM co cmin co cabs cfv
      vw cv clt cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv
      cv cX wcel wa cY vu cv cM co cY vv cv cM co cabs cmin ccom co cY vu cv cM
      co cY vv cv cM co cmin co cabs cfv wceq vu cv vv cv cM co vw cv clt wbr
      cM cme wcel cY cX wcel wa vu cv cX wcel vv cv cX wcel cY vu cv cM co cY
      vv cv cM co cabs cmin ccom co cY vu cv cM co cY vv cv cM co cmin co cabs
      cfv wceq vw cv cr wcel cY vu cv cM co cc wcel cY vv cv cM co cc wcel cY
      vu cv cM co cY vv cv cM co cabs cmin ccom co cY vu cv cM co cY vv cv cM
      co cmin co cabs cfv wceq cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv
      cX wcel wa cY vu cv cM co cY vv cv cM co cabs cmin ccom cabs cmin ccom
      eqid cnmetdval cM cme wcel cY cX wcel wa vu cv cX wcel wa cY vu cv cM co
      cc wcel vv cv cX wcel cM cme wcel cY cX wcel vu cv cX wcel cY vu cv cM co
      cc wcel cM cme wcel cY cX wcel vu cv cX wcel w3a cY vu cv cM co cY vu cv
      cM cX metdcn.1 metcl recnd 3expa adantr cM cme wcel cY cX wcel wa vv cv
      cX wcel cY vv cv cM co cc wcel vu cv cX wcel cM cme wcel cY cX wcel vv cv
      cX wcel cY vv cv cM co cc wcel cM cme wcel cY cX wcel vv cv cX wcel w3a
      cY vv cv cM co cY vv cv cM cX metdcn.1 metcl recnd 3expa adantlr sylanc
      adantlrr adantr cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa
      wa vv cv cX wcel wa vu cv vv cv cM co vw cv clt wbr wa cY vu cv cM co cY
      vv cv cM co cmin co cabs cfv vw cv clt wbr vw cv cneg cY vu cv cM co cY
      vv cv cM co cmin co clt wbr cY vu cv cM co cY vv cv cM co cmin co vw cv
      clt wbr wa cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv
      cv cX wcel wa vu cv vv cv cM co vw cv clt wbr wa vw cv cneg cY vu cv cM
      co cY vv cv cM co cmin co clt wbr cY vu cv cM co cY vv cv cM co cmin co
      vw cv clt wbr cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa
      vv cv cX wcel wa vu cv vv cv cM co vw cv clt wbr wa vw cv cneg cY vv cv
      cM co cY vu cv cM co cmin co cneg cY vu cv cM co cY vv cv cM co cmin co
      clt cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv cv cX
      wcel wa vu cv vv cv cM co vw cv clt wbr wa cY vv cv cM co cY vu cv cM co
      cmin co vw cv clt wbr vw cv cneg cY vv cv cM co cY vu cv cM co cmin co
      cneg clt wbr cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa
      vv cv cX wcel wa vu cv vv cv cM co vw cv clt wbr cY vv cv cM co cY vu cv
      cM co cmin co vw cv clt wbr cM cme wcel cY cX wcel wa vu cv cX wcel vw cv
      cr wcel wa wa vv cv cX wcel wa cY vv cv cM co cY vu cv cM co cmin co vu
      cv vv cv cM co cle wbr vu cv vv cv cM co vw cv clt wbr cY vv cv cM co cY
      vu cv cM co cmin co vw cv clt wbr cM cme wcel cY cX wcel wa vu cv cX wcel
      vv cv cX wcel cY vv cv cM co cY vu cv cM co cmin co vu cv vv cv cM co cle
      wbr vw cv cr wcel cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv cX
      wcel wa cY vv cv cM co cY vu cv cM co cmin co vu cv vv cv cM co cle wbr
      cY vv cv cM co cY vu cv cM co vu cv vv cv cM co caddc co cle wbr cM cme
      wcel cY cX wcel wa vv cv cX wcel vu cv cX wcel cY vv cv cM co cY vu cv cM
      co vu cv vv cv cM co caddc co cle wbr cM cme wcel cY cX wcel vv cv cX
      wcel vu cv cX wcel cY vv cv cM co cY vu cv cM co vu cv vv cv cM co caddc
      co cle wbr cM cme wcel cY cX wcel vv cv cX wcel vu cv cX wcel cY vv cv cM
      co cY vu cv cM co vu cv vv cv cM co caddc co cle wbr cY vv cv vu cv cM cX
      metdcn.1 mettri 3exp2 imp41 an1rs cY vv cv cM co cr wcel cY vu cv cM co
      cr wcel vu cv vv cv cM co cr wcel cY vv cv cM co cY vu cv cM co cmin co
      vu cv vv cv cM co cle wbr cY vv cv cM co cY vu cv cM co vu cv vv cv cM co
      caddc co cle wbr wb cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv cX
      wcel wa cY vv cv cM co cY vu cv cM co vu cv vv cv cM co lesubadd2 cM cme
      wcel cY cX wcel wa vv cv cX wcel cY vv cv cM co cr wcel vu cv cX wcel cM
      cme wcel cY cX wcel vv cv cX wcel cY vv cv cM co cr wcel cY vv cv cM cX
      metdcn.1 metcl 3expa adantlr cM cme wcel cY cX wcel wa vu cv cX wcel wa
      cY vu cv cM co cr wcel vv cv cX wcel cM cme wcel cY cX wcel vu cv cX wcel
      cY vu cv cM co cr wcel cY vu cv cM cX metdcn.1 metcl 3expa adantr cM cme
      wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel cY cX wcel cM
      cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel vu cv vv
      cv cM cX metdcn.1 metcl 3expa adantllr syl3anc mpbird adantlrr cY vv cv
      cM co cY vu cv cM co cmin co cr wcel vu cv vv cv cM co cr wcel vw cv cr
      wcel cY vv cv cM co cY vu cv cM co cmin co vu cv vv cv cM co cle wbr vu
      cv vv cv cM co vw cv clt wbr wa cY vv cv cM co cY vu cv cM co cmin co vw
      cv clt wbr wi cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa
      vv cv cX wcel wa cY vv cv cM co cY vu cv cM co cmin co vu cv vv cv cM co
      vw cv lelttr cM cme wcel cY cX wcel wa vu cv cX wcel vv cv cX wcel cY vv
      cv cM co cY vu cv cM co cmin co cr wcel vw cv cr wcel cY vv cv cM co cr
      wcel cY vu cv cM co cr wcel cY vv cv cM co cY vu cv cM co cmin co cr wcel
      cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv cX wcel wa cY vv cv cM
      co cY vu cv cM co resubcl cM cme wcel cY cX wcel wa vv cv cX wcel cY vv
      cv cM co cr wcel vu cv cX wcel cM cme wcel cY cX wcel vv cv cX wcel cY vv
      cv cM co cr wcel cY vv cv cM cX metdcn.1 metcl 3expa adantlr cM cme wcel
      cY cX wcel wa vu cv cX wcel wa cY vu cv cM co cr wcel vv cv cX wcel cM
      cme wcel cY cX wcel vu cv cX wcel cY vu cv cM co cr wcel cY vu cv cM cX
      metdcn.1 metcl 3expa adantr sylanc adantlrr cM cme wcel cY cX wcel wa vu
      cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel vw cv cr wcel cM cme
      wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel cY cX wcel cM
      cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel vu cv vv
      cv cM cX metdcn.1 metcl 3expa adantllr adantlrr cM cme wcel cY cX wcel wa
      vu cv cX wcel vw cv cr wcel vv cv cX wcel simplrr syl3anc mpand imp cM
      cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv cv cX wcel wa
      cY vv cv cM co cY vu cv cM co cmin co vw cv clt wbr vw cv cneg cY vv cv
      cM co cY vu cv cM co cmin co cneg clt wbr wb vu cv vv cv cM co vw cv clt
      wbr cY vv cv cM co cY vu cv cM co cmin co cr wcel vw cv cr wcel cY vv cv
      cM co cY vu cv cM co cmin co vw cv clt wbr vw cv cneg cY vv cv cM co cY
      vu cv cM co cmin co cneg clt wbr wb cM cme wcel cY cX wcel wa vu cv cX
      wcel vw cv cr wcel wa wa vv cv cX wcel wa cY vv cv cM co cY vu cv cM co
      cmin co vw cv ltneg cM cme wcel cY cX wcel wa vu cv cX wcel vv cv cX wcel
      cY vv cv cM co cY vu cv cM co cmin co cr wcel vw cv cr wcel cY vv cv cM
      co cr wcel cY vu cv cM co cr wcel cY vv cv cM co cY vu cv cM co cmin co
      cr wcel cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv cX wcel wa cY vv
      cv cM co cY vu cv cM co resubcl cM cme wcel cY cX wcel wa vv cv cX wcel
      cY vv cv cM co cr wcel vu cv cX wcel cM cme wcel cY cX wcel vv cv cX wcel
      cY vv cv cM co cr wcel cY vv cv cM cX metdcn.1 metcl 3expa adantlr cM cme
      wcel cY cX wcel wa vu cv cX wcel wa cY vu cv cM co cr wcel vv cv cX wcel
      cM cme wcel cY cX wcel vu cv cX wcel cY vu cv cM co cr wcel cY vu cv cM
      cX metdcn.1 metcl 3expa adantr sylanc adantlrr cM cme wcel cY cX wcel wa
      vu cv cX wcel vw cv cr wcel vv cv cX wcel simplrr sylanc adantr mpbid cM
      cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv cv cX wcel wa
      cY vv cv cM co cY vu cv cM co cmin co cneg cY vu cv cM co cY vv cv cM co
      cmin co wceq vu cv vv cv cM co vw cv clt wbr cM cme wcel cY cX wcel wa vu
      cv cX wcel vv cv cX wcel cY vv cv cM co cY vu cv cM co cmin co cneg cY vu
      cv cM co cY vv cv cM co cmin co wceq vw cv cr wcel cY vv cv cM co cc wcel
      cY vu cv cM co cc wcel cY vv cv cM co cY vu cv cM co cmin co cneg cY vu
      cv cM co cY vv cv cM co cmin co wceq cM cme wcel cY cX wcel wa vu cv cX
      wcel wa vv cv cX wcel wa cY vv cv cM co cY vu cv cM co negsubdi2 cM cme
      wcel cY cX wcel wa vv cv cX wcel cY vv cv cM co cc wcel vu cv cX wcel cM
      cme wcel cY cX wcel vv cv cX wcel cY vv cv cM co cc wcel cM cme wcel cY
      cX wcel vv cv cX wcel w3a cY vv cv cM co cY vv cv cM cX metdcn.1 metcl
      recnd 3expa adantlr cM cme wcel cY cX wcel wa vu cv cX wcel wa cY vu cv
      cM co cc wcel vv cv cX wcel cM cme wcel cY cX wcel vu cv cX wcel cY vu cv
      cM co cc wcel cM cme wcel cY cX wcel vu cv cX wcel w3a cY vu cv cM co cY
      vu cv cM cX metdcn.1 metcl recnd 3expa adantr sylanc adantlrr adantr
      breqtrd cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa vv cv
      cX wcel wa vu cv vv cv cM co vw cv clt wbr cY vu cv cM co cY vv cv cM co
      cmin co vw cv clt wbr cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr
      wcel wa wa vv cv cX wcel wa cY vu cv cM co cY vv cv cM co cmin co vu cv
      vv cv cM co cle wbr vu cv vv cv cM co vw cv clt wbr cY vu cv cM co cY vv
      cv cM co cmin co vw cv clt wbr cM cme wcel cY cX wcel wa vu cv cX wcel vv
      cv cX wcel cY vu cv cM co cY vv cv cM co cmin co vu cv vv cv cM co cle
      wbr vw cv cr wcel cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv cX
      wcel wa cY vu cv cM co cY vv cv cM co cmin co vu cv vv cv cM co cle wbr
      cY vu cv cM co cY vv cv cM co vu cv vv cv cM co caddc co cle wbr cM cme
      wcel cY cX wcel vu cv cX wcel vv cv cX wcel cY vu cv cM co cY vv cv cM co
      vu cv vv cv cM co caddc co cle wbr cM cme wcel cY cX wcel vu cv cX wcel
      vv cv cX wcel cY vu cv cM co cY vv cv cM co vu cv vv cv cM co caddc co
      cle wbr cY vu cv vv cv cM cX metdcn.1 mettri3 3exp2 imp41 cY vu cv cM co
      cr wcel cY vv cv cM co cr wcel vu cv vv cv cM co cr wcel cY vu cv cM co
      cY vv cv cM co cmin co vu cv vv cv cM co cle wbr cY vu cv cM co cY vv cv
      cM co vu cv vv cv cM co caddc co cle wbr wb cM cme wcel cY cX wcel wa vu
      cv cX wcel wa vv cv cX wcel wa cY vu cv cM co cY vv cv cM co vu cv vv cv
      cM co lesubadd2 cM cme wcel cY cX wcel wa vu cv cX wcel wa cY vu cv cM co
      cr wcel vv cv cX wcel cM cme wcel cY cX wcel vu cv cX wcel cY vu cv cM co
      cr wcel cY vu cv cM cX metdcn.1 metcl 3expa adantr cM cme wcel cY cX wcel
      wa vv cv cX wcel cY vv cv cM co cr wcel vu cv cX wcel cM cme wcel cY cX
      wcel vv cv cX wcel cY vv cv cM co cr wcel cY vv cv cM cX metdcn.1 metcl
      3expa adantlr cM cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co
      cr wcel cY cX wcel cM cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM
      co cr wcel vu cv vv cv cM cX metdcn.1 metcl 3expa adantllr syl3anc mpbird
      adantlrr cY vu cv cM co cY vv cv cM co cmin co cr wcel vu cv vv cv cM co
      cr wcel vw cv cr wcel cY vu cv cM co cY vv cv cM co cmin co vu cv vv cv
      cM co cle wbr vu cv vv cv cM co vw cv clt wbr wa cY vu cv cM co cY vv cv
      cM co cmin co vw cv clt wbr wi cM cme wcel cY cX wcel wa vu cv cX wcel vw
      cv cr wcel wa wa vv cv cX wcel wa cY vu cv cM co cY vv cv cM co cmin co
      vu cv vv cv cM co vw cv lelttr cM cme wcel cY cX wcel wa vu cv cX wcel vv
      cv cX wcel cY vu cv cM co cY vv cv cM co cmin co cr wcel vw cv cr wcel cY
      vu cv cM co cr wcel cY vv cv cM co cr wcel cY vu cv cM co cY vv cv cM co
      cmin co cr wcel cM cme wcel cY cX wcel wa vu cv cX wcel wa vv cv cX wcel
      wa cY vu cv cM co cY vv cv cM co resubcl cM cme wcel cY cX wcel wa vu cv
      cX wcel wa cY vu cv cM co cr wcel vv cv cX wcel cM cme wcel cY cX wcel vu
      cv cX wcel cY vu cv cM co cr wcel cY vu cv cM cX metdcn.1 metcl 3expa
      adantr cM cme wcel cY cX wcel wa vv cv cX wcel cY vv cv cM co cr wcel vu
      cv cX wcel cM cme wcel cY cX wcel vv cv cX wcel cY vv cv cM co cr wcel cY
      vv cv cM cX metdcn.1 metcl 3expa adantlr sylanc adantlrr cM cme wcel cY
      cX wcel wa vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel vw cv cr
      wcel cM cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel cY
      cX wcel cM cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr wcel
      vu cv vv cv cM cX metdcn.1 metcl 3expa adantllr adantlrr cM cme wcel cY
      cX wcel wa vu cv cX wcel vw cv cr wcel vv cv cX wcel simplrr syl3anc
      mpand imp jca cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr wcel wa wa
      vv cv cX wcel wa cY vu cv cM co cY vv cv cM co cmin co cabs cfv vw cv clt
      wbr vw cv cneg cY vu cv cM co cY vv cv cM co cmin co clt wbr cY vu cv cM
      co cY vv cv cM co cmin co vw cv clt wbr wa wb vu cv vv cv cM co vw cv clt
      wbr cY vu cv cM co cY vv cv cM co cmin co cr wcel vw cv cr wcel cY vu cv
      cM co cY vv cv cM co cmin co cabs cfv vw cv clt wbr vw cv cneg cY vu cv
      cM co cY vv cv cM co cmin co clt wbr cY vu cv cM co cY vv cv cM co cmin
      co vw cv clt wbr wa wb cM cme wcel cY cX wcel wa vu cv cX wcel vw cv cr
      wcel wa wa vv cv cX wcel wa cY vu cv cM co cY vv cv cM co cmin co vw cv
      abslt cM cme wcel cY cX wcel wa vu cv cX wcel vv cv cX wcel cY vu cv cM
      co cY vv cv cM co cmin co cr wcel vw cv cr wcel cY vu cv cM co cr wcel cY
      vv cv cM co cr wcel cY vu cv cM co cY vv cv cM co cmin co cr wcel cM cme
      wcel cY cX wcel wa vu cv cX wcel wa vv cv cX wcel wa cY vu cv cM co cY vv
      cv cM co resubcl cM cme wcel cY cX wcel wa vu cv cX wcel wa cY vu cv cM
      co cr wcel vv cv cX wcel cM cme wcel cY cX wcel vu cv cX wcel cY vu cv cM
      co cr wcel cY vu cv cM cX metdcn.1 metcl 3expa adantr cM cme wcel cY cX
      wcel wa vv cv cX wcel cY vv cv cM co cr wcel vu cv cX wcel cM cme wcel cY
      cX wcel vv cv cX wcel cY vv cv cM co cr wcel cY vv cv cM cX metdcn.1
      metcl 3expa adantlr sylanc adantlrr cM cme wcel cY cX wcel wa vu cv cX
      wcel vw cv cr wcel vv cv cX wcel simplrr sylanc adantr mpbird eqbrtrd
      eqbrtrd ex adantlr r19.21aiva cc0 vz cv clt wbr vu cv vv cv cM co vz cv
      clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0
      cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral wa cc0 vw cv clt wbr
      vu cv vv cv cM co vw cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom
      cc0 cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral
      wa vz vw cv cr vz cv vw cv wceq cc0 vz cv clt wbr cc0 vw cv clt wbr vu cv
      vv cv cM co vz cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0
      cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral vu
      cv vv cv cM co vw cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0
      cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral vz
      cv vw cv cc0 clt breq2 vz cv vw cv wceq vu cv vv cv cM co vz cv clt wbr
      vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico
      co cxp cres co vw cv clt wbr wi vu cv vv cv cM co vw cv clt wbr vu cv cD
      cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp
      cres co vw cv clt wbr wi vv cX vz cv vw cv wceq vu cv vv cv cM co vz cv
      clt wbr vu cv vv cv cM co vw cv clt wbr vu cv cD cfv vv cv cD cfv cabs
      cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres co vw cv clt wbr vz
      cv vw cv vu cv vv cv cM co clt breq2 imbi1d ralbidv anbi12d rcla4ev
      sylan32c exp31 r19.21aivv jca cM cme wcel cD cJ cR ccn co wcel cX cc0
      cpnf cico co cD wf cc0 vw cv clt wbr cc0 vz cv clt wbr vu cv vv cv cM co
      vz cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico co
      cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral wa vz cr wrex wi
      vw cr wral vu cX wral wa wb cY cX wcel cM cme wcel cabs cmin ccom cc0
      cpnf cico co cc0 cpnf cico co cxp cres cme wcel cD cJ cR ccn co wcel cX
      cc0 cpnf cico co cD wf cc0 vw cv clt wbr cc0 vz cv clt wbr vu cv vv cv cM
      co vz cv clt wbr vu cv cD cfv vv cv cD cfv cabs cmin ccom cc0 cpnf cico
      co cc0 cpnf cico co cxp cres co vw cv clt wbr wi vv cX wral wa vz cr wrex
      wi vw cr wral vu cX wral wa wb cabs cmin ccom cme wcel cabs cmin ccom cc0
      cpnf cico co cc0 cpnf cico co cxp cres cme wcel cabs cmin ccom cabs cmin
      ccom eqid cnmet cabs cmin ccom cc0 cpnf cico co metres ax-mp vu vw vz vv
      cM cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico co cxp cres cD cJ cR cX
      cc0 cpnf cico co metdcn.1 metdcn.2 cabs cmin ccom cme wcel cc0 cpnf cico
      co cc wss cc0 cpnf cico co cabs cmin ccom cc0 cpnf cico co cc0 cpnf cico
      co cxp cres cdm cdm wceq cabs cmin ccom cabs cmin ccom eqid cnmet cc0
      cpnf cico co cr cc vx cc0 cpnf cico co cr vx cv cc0 cpnf cico co wcel vx
      cv cr wcel cc0 vx cv cle wbr vx cv elnnr pm3.26bi ssriv axresscn sstri
      cabs cmin ccom cc cc0 cpnf cico co cabs cmin ccom cabs cmin ccom eqid
      cnmetba metssba2 mp2an metdcn.3 metcn mpan2 adantr mpbird $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Intervals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $. $d B x $. $d C x $.
    $( Split a closed interval into the union of two closed intervals. $)
    iccsplit $p |- ( ( A e. RR /\ B e. RR /\ C e. ( A [,] B ) ) ->
                        ( A [,] B ) = ( ( A [,] C ) u. ( C [,] B ) ) ) $=
      cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a vx cA cB cicc co cA cC
      cicc co cC cB cicc co cun cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a
      vx cv cA cB cicc co wcel vx cv cA cC cicc co wcel vx cv cC cB cicc co
      wcel wo vx cv cA cC cicc co cC cB cicc co cun wcel cA cr wcel cB cr wcel
      cC cA cB cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel cC
      vx cv cle wbr vx cv cB cle wbr w3a wo vx cv cA cB cicc co wcel vx cv cA
      cC cicc co wcel vx cv cC cB cicc co wcel wo cA cr wcel cB cr wcel cC cA
      cB cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel cC vx
      cv cle wbr vx cv cB cle wbr w3a wo cA cr wcel cB cr wcel cC cA cB cicc co
      wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cr
      wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel cC vx cv cle wbr
      vx cv cB cle wbr w3a wo cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a
      vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vx cv cr wcel cA
      vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel cC vx cv cle wbr vx cv
      cB cle wbr w3a wo vx cv cC cA cr wcel cB cr wcel cC cA cB cicc co wcel
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vx cv cC clt
      wbr wa vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel
      cC vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel cC cA cB cicc
      co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vx cv
      cC clt wbr wa vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr vx cv cr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cr wcel cA cr wcel cB cr
      wcel cC cA cB cicc co wcel w3a vx cv cC clt wbr vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr 3simp1 ad2antlr vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr w3a cA vx cv cle wbr cA cr wcel cB cr wcel cC cA cB cicc
      co wcel w3a vx cv cC clt wbr vx cv cr wcel cA vx cv cle wbr vx cv cB cle
      wbr 3simp2 ad2antlr cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a vx cv
      cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vx cv cC clt wbr vx cv
      cC cle wbr vx cv cr wcel cC cr wcel vx cv cC clt wbr vx cv cC cle wbr wi
      cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a wa vx cv cC ltle vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a vx cv cr wcel cA cr wcel cB cr wcel cC cA cB
      cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp1
      adantl cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a cC cr wcel vx cv
      cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel cC cA
      cB cicc co wcel cC cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr cC
      cA cB iccssre sseld 3impia adantr sylanc imp 3jca orcd cA cr wcel cB cr
      wcel cC cA cB cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a wa cC vx cv cle wbr wa vx cv cr wcel cC vx cv cle wbr vx cv
      cB cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a cA cr
      wcel cB cr wcel cC cA cB cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr w3a wa cC vx cv cle wbr wa vx cv cr wcel cC vx cv cle
      wbr vx cv cB cle wbr vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      vx cv cr wcel cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a cC vx cv
      cle wbr vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp1 ad2antlr
      cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a wa cC vx cv cle wbr pm3.27 vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a vx cv cB cle wbr cA cr wcel cB cr wcel
      cC cA cB cicc co wcel w3a cC vx cv cle wbr vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr 3simp3 ad2antlr 3jca olcd vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr w3a vx cv cr wcel cA cr wcel cB cr wcel cC cA cB cicc co
      wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp1 adantl cA
      cr wcel cB cr wcel cC cA cB cicc co wcel w3a cC cr wcel vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel cC cA cB cicc co
      wcel cC cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr cC cA cB
      iccssre sseld 3impia adantr pm2.61ltlei ex cA cr wcel cB cr wcel cC cA cB
      cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx
      cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cr wcel cC vx cv
      cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel cC cA cB cicc co wcel
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr vx cv cr wcel cA vx cv cle wbr vx cv cC
      cle wbr w3a vx cv cr wcel wi cA cr wcel cB cr wcel cC cA cB cicc co wcel
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr 3simp1 a1i vx cv cr
      wcel cA vx cv cle wbr vx cv cC cle wbr w3a cA vx cv cle wbr wi cA cr wcel
      cB cr wcel cC cA cB cicc co wcel w3a vx cv cr wcel cA vx cv cle wbr vx cv
      cC cle wbr 3simp2 a1i cA cr wcel cB cr wcel cC cA cB cicc co wcel vx cv
      cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cB cle wbr wi cA cr
      wcel cB cr wcel wa cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cB
      cle wbr wi cA cB cC elicc2 cA cr wcel cB cr wcel wa cC cr wcel cA cC cle
      wbr cC cB cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a
      vx cv cB cle wbr cA cr wcel cB cr wcel wa cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a w3a vx cv
      cC cB vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a cA cr wcel cB
      cr wcel wa vx cv cr wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a vx cv
      cr wcel cA vx cv cle wbr vx cv cC cle wbr 3simp1 3ad2ant3 cC cr wcel cA
      cC cle wbr cC cB cle wbr w3a cA cr wcel cB cr wcel wa cC cr wcel vx cv cr
      wcel cA vx cv cle wbr vx cv cC cle wbr w3a cC cr wcel cA cC cle wbr cC cB
      cle wbr 3simp1 3ad2ant2 cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv
      cle wbr vx cv cC cle wbr w3a cB cr wcel cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a cA cr wcel cB cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cC
      cle wbr w3a simplr 3adant2 vx cv cr wcel cA vx cv cle wbr vx cv cC cle
      wbr w3a cA cr wcel cB cr wcel wa vx cv cC cle wbr cC cr wcel cA cC cle
      wbr cC cB cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr
      3simp3 3ad2ant3 cC cr wcel cA cC cle wbr cC cB cle wbr w3a cA cr wcel cB
      cr wcel wa cC cB cle wbr vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr
      w3a cC cr wcel cA cC cle wbr cC cB cle wbr 3simp3 3ad2ant2 letrd 3exp
      sylbid 3impia 3jcad cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a vx cv
      cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a
      vx cv cr wcel wi cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a vx cv cr
      wcel cC vx cv cle wbr vx cv cB cle wbr 3simp1 a1i cA cr wcel cB cr wcel
      cC cA cB cicc co wcel vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a
      cA vx cv cle wbr wi cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a vx cv cr wcel cC vx cv cle wbr vx cv
      cB cle wbr w3a cA vx cv cle wbr wi cA cB cC elicc2 cA cr wcel cB cr wcel
      wa cC cr wcel cA cC cle wbr cC cB cle wbr w3a vx cv cr wcel cC vx cv cle
      wbr vx cv cB cle wbr w3a cA vx cv cle wbr cA cr wcel cB cr wcel wa cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a vx cv cr wcel cC vx cv cle wbr vx cv
      cB cle wbr w3a w3a cA cC vx cv cA cr wcel cB cr wcel wa vx cv cr wcel cC
      vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cC cr wcel cA cC cle wbr cC
      cB cle wbr w3a cA cr wcel cB cr wcel vx cv cr wcel cC vx cv cle wbr vx cv
      cB cle wbr w3a simpll 3adant2 cC cr wcel cA cC cle wbr cC cB cle wbr w3a
      cA cr wcel cB cr wcel wa cC cr wcel vx cv cr wcel cC vx cv cle wbr vx cv
      cB cle wbr w3a cC cr wcel cA cC cle wbr cC cB cle wbr 3simp1 3ad2ant2 vx
      cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel wa
      vx cv cr wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a vx cv cr wcel cC
      vx cv cle wbr vx cv cB cle wbr 3simp1 3ad2ant3 cC cr wcel cA cC cle wbr
      cC cB cle wbr w3a cA cr wcel cB cr wcel wa cA cC cle wbr vx cv cr wcel cC
      vx cv cle wbr vx cv cB cle wbr w3a cC cr wcel cA cC cle wbr cC cB cle wbr
      3simp2 3ad2ant2 vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a cA cr
      wcel cB cr wcel wa cC vx cv cle wbr cC cr wcel cA cC cle wbr cC cB cle
      wbr w3a vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr 3simp2 3ad2ant3
      letrd 3exp sylbid 3impia vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr
      w3a vx cv cB cle wbr wi cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a
      vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr 3simp3 a1i 3jcad jaod
      impbid cA cr wcel cB cr wcel vx cv cA cB cicc co wcel vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr w3a wb cC cA cB cicc co wcel cA cB vx cv
      elicc2 3adant3 cA cr wcel cB cr wcel cC cA cB cicc co wcel w3a cA cr wcel
      cB cr wcel wa cC cr wcel wa vx cv cA cC cicc co wcel vx cv cC cB cicc co
      wcel wo vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a vx cv cr wcel
      cC vx cv cle wbr vx cv cB cle wbr w3a wo wb cA cr wcel cB cr wcel cC cA
      cB cicc co wcel cA cr wcel cB cr wcel wa cC cr wcel wa cA cr wcel cB cr
      wcel wa cC cA cB cicc co wcel cC cr wcel cA cr wcel cB cr wcel wa cA cB
      cicc co cr cC cA cB iccssre sseld imdistani 3impa cA cr wcel cB cr wcel
      wa cC cr wcel wa vx cv cA cC cicc co wcel vx cv cr wcel cA vx cv cle wbr
      vx cv cC cle wbr w3a vx cv cC cB cicc co wcel vx cv cr wcel cC vx cv cle
      wbr vx cv cB cle wbr w3a cA cr wcel cC cr wcel vx cv cA cC cicc co wcel
      vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a wb cB cr wcel cA cC
      vx cv elicc2 adantlr cB cr wcel cC cr wcel vx cv cC cB cicc co wcel vx cv
      cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a wb cA cr wcel cC cr wcel cB
      cr wcel vx cv cC cB cicc co wcel vx cv cr wcel cC vx cv cle wbr vx cv cB
      cle wbr w3a wb cC cB vx cv elicc2 ancoms adantll orbi12d syl 3bitr4d vx
      cv cA cC cicc co cC cB cicc co elun syl6bbr eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x $. $d B x $. $d C x $. $d D x $.
    $( Condition for a closed interval to be a subset of another
       closed interval. $)
    iccss $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) /\
                    ( A <_ C /\ D <_ B ) ) -> ( C [,] D ) C_ ( A [,] B ) ) $=
      cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cA cC cle wbr cD cB cle
      wbr wa w3a vx cC cD cicc co cA cB cicc co cA cr wcel cB cr wcel wa cC cr
      wcel cD cr wcel wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx
      cv cle wbr vx cv cD cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a vx cv cC cD cicc co wcel vx cv cA cB cicc co wcel cA cr wcel
      cB cr wcel wa cC cr wcel cD cr wcel wa cA cC cle wbr cD cB cle wbr wa w3a
      vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr vx cv cr wcel cC vx cv cle wbr vx cv cD cle
      wbr w3a vx cv cr wcel wi cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel
      wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle wbr vx
      cv cD cle wbr 3simp1 a1i cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel
      wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle wbr vx
      cv cD cle wbr w3a cA vx cv cle wbr cA cr wcel cB cr wcel wa cC cr wcel cD
      cr wcel wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle
      wbr vx cv cD cle wbr w3a wa cA cC vx cv cA cr wcel cB cr wcel wa cC cr
      wcel cD cr wcel wa vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a cA
      cr wcel cA cC cle wbr cD cB cle wbr wa cA cr wcel cB cr wcel vx cv cr
      wcel cC vx cv cle wbr vx cv cD cle wbr w3a simpll 3ad2antl1 cC cr wcel cD
      cr wcel wa cA cr wcel cB cr wcel wa vx cv cr wcel cC vx cv cle wbr vx cv
      cD cle wbr w3a cC cr wcel cA cC cle wbr cD cB cle wbr wa cC cr wcel cD cr
      wcel vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a simpll 3ad2antl2
      vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a vx cv cr wcel cA cr
      wcel cB cr wcel wa cC cr wcel cD cr wcel wa cA cC cle wbr cD cB cle wbr
      wa w3a vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr 3simp1 adantl cA
      cC cle wbr cD cB cle wbr wa cA cr wcel cB cr wcel wa vx cv cr wcel cC vx
      cv cle wbr vx cv cD cle wbr w3a cA cC cle wbr cC cr wcel cD cr wcel wa cA
      cC cle wbr cD cB cle wbr vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr
      w3a simpll 3ad2antl3 vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a
      cC vx cv cle wbr cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cA cC
      cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle wbr vx cv cD cle
      wbr 3simp2 adantl letrd ex cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel
      wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle wbr vx
      cv cD cle wbr w3a vx cv cB cle wbr cA cr wcel cB cr wcel wa cC cr wcel cD
      cr wcel wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle
      wbr vx cv cD cle wbr w3a wa vx cv cD cB vx cv cr wcel cC vx cv cle wbr vx
      cv cD cle wbr w3a vx cv cr wcel cA cr wcel cB cr wcel wa cC cr wcel cD cr
      wcel wa cA cC cle wbr cD cB cle wbr wa w3a vx cv cr wcel cC vx cv cle wbr
      vx cv cD cle wbr 3simp1 adantl cC cr wcel cD cr wcel wa cA cr wcel cB cr
      wcel wa vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a cD cr wcel cA
      cC cle wbr cD cB cle wbr wa cC cr wcel cD cr wcel vx cv cr wcel cC vx cv
      cle wbr vx cv cD cle wbr w3a simplr 3ad2antl2 cA cr wcel cB cr wcel wa cC
      cr wcel cD cr wcel wa vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a
      cB cr wcel cA cC cle wbr cD cB cle wbr wa cA cr wcel cB cr wcel vx cv cr
      wcel cC vx cv cle wbr vx cv cD cle wbr w3a simplr 3ad2antl1 vx cv cr wcel
      cC vx cv cle wbr vx cv cD cle wbr w3a vx cv cD cle wbr cA cr wcel cB cr
      wcel wa cC cr wcel cD cr wcel wa cA cC cle wbr cD cB cle wbr wa w3a vx cv
      cr wcel cC vx cv cle wbr vx cv cD cle wbr 3simp3 adantl cA cC cle wbr cD
      cB cle wbr wa cA cr wcel cB cr wcel wa vx cv cr wcel cC vx cv cle wbr vx
      cv cD cle wbr w3a cD cB cle wbr cC cr wcel cD cr wcel wa cA cC cle wbr cD
      cB cle wbr vx cv cr wcel cC vx cv cle wbr vx cv cD cle wbr w3a simplr
      3ad2antl3 letrd ex 3jcad cC cr wcel cD cr wcel wa cA cr wcel cB cr wcel
      wa vx cv cC cD cicc co wcel vx cv cr wcel cC vx cv cle wbr vx cv cD cle
      wbr w3a wb cA cC cle wbr cD cB cle wbr wa cC cD vx cv elicc2 3ad2ant2 cA
      cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa vx cv cA cB cicc co wcel
      vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wb cA cC cle wbr cD
      cB cle wbr wa cA cB vx cv elicc2 3ad2ant1 3imtr4d ssrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Condition for a closed interval to be a subset of another
       closed interval. $)
    iccss2 $p |- ( ( A e. RR /\ B e. RR ) -> ( ( C e. ( A [,] B ) /\
                      D e. ( A [,] B ) ) -> ( C [,] D ) C_ ( A [,] B ) ) ) $=
      cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel wa
      cC cr wcel cA cC cle wbr cC cB cle wbr w3a cD cr wcel cA cD cle wbr cD cB
      cle wbr w3a wa cC cD cicc co cA cB cicc co wss cA cr wcel cB cr wcel wa
      cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a cD cA cB
      cicc co wcel cD cr wcel cA cD cle wbr cD cB cle wbr w3a cA cB cC elicc2
      cA cB cD elicc2 anbi12d cC cr wcel cA cC cle wbr cC cB cle wbr w3a cD cr
      wcel cA cD cle wbr cD cB cle wbr w3a wa cA cr wcel cB cr wcel wa cC cD
      cicc co cA cB cicc co wss cC cr wcel cA cC cle wbr cD cr wcel cA cD cle
      wbr cD cB cle wbr w3a cA cr wcel cB cr wcel wa cC cD cicc co cA cB cicc
      co wss wi cC cB cle wbr cC cr wcel cA cC cle wbr wa cD cr wcel cD cB cle
      wbr cA cr wcel cB cr wcel wa cC cD cicc co cA cB cicc co wss wi cA cD cle
      wbr cC cr wcel cD cr wcel cA cC cle wbr cD cB cle wbr cA cr wcel cB cr
      wcel wa cC cD cicc co cA cB cicc co wss wi cA cr wcel cB cr wcel wa cC cr
      wcel cD cr wcel wa cA cC cle wbr cD cB cle wbr wa wa cC cD cicc co cA cB
      cicc co wss cA cr wcel cB cr wcel wa cC cr wcel cD cr wcel wa cA cC cle
      wbr cD cB cle wbr wa cC cD cicc co cA cB cicc co wss cA cB cC cD iccss
      3expb expcom an4s 3adantr2 3adantl3 com12 sylbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccshftr.1 $e |- ( A + R ) = C $.
    iccshftr.2 $e |- ( B + R ) = D $.
    $( Membership in a shifted interval. $)
    iccshftr $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR ) )
                  -> ( X e. ( A [,] B ) <-> ( X + R ) e. ( C [,] D ) ) ) $=
      cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa wa cX cr wcel cA cX cle
      wbr cX cB cle wbr w3a cX cR caddc co cr wcel cC cX cR caddc co cle wbr cX
      cR caddc co cD cle wbr w3a cX cA cB cicc co wcel cX cR caddc co cC cD
      cicc co wcel cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa wa cX cr
      wcel cX cR caddc co cr wcel cA cX cle wbr cC cX cR caddc co cle wbr cX cB
      cle wbr cX cR caddc co cD cle wbr cX cr wcel cR cr wcel wa cX cr wcel cX
      cR caddc co cr wcel wb cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa
      cX cr wcel wi cX cr wcel cR cr wcel wa cX cR caddc co cr wcel wi cX cr
      wcel cR cr wcel wa cX cr wcel cX cR caddc co cr wcel wb wi cX cr wcel cR
      cr wcel pm3.26 cX cR axaddrcl cX cr wcel cR cr wcel wa cX cr wcel cX cR
      caddc co cr wcel pm5.35 mp2an adantl cA cr wcel cB cr wcel wa cX cr wcel
      cR cr wcel wa wa cA cX cle wbr cA cR caddc co cX cR caddc co cle wbr cC
      cX cR caddc co cle wbr cA cr wcel cX cr wcel cR cr wcel wa cA cX cle wbr
      cA cR caddc co cX cR caddc co cle wbr wb cB cr wcel cA cr wcel cX cr wcel
      cR cr wcel cA cX cle wbr cA cR caddc co cX cR caddc co cle wbr wb cA cX
      cR leadd1 3expb adantlr cA cR caddc co cC cX cR caddc co cle iccshftr.1
      breq1i syl6bb cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa wa cX cB
      cle wbr cX cR caddc co cB cR caddc co cle wbr cX cR caddc co cD cle wbr
      cB cr wcel cX cr wcel cR cr wcel wa cX cB cle wbr cX cR caddc co cB cR
      caddc co cle wbr wb cA cr wcel cX cr wcel cB cr wcel cR cr wcel cX cB cle
      wbr cX cR caddc co cB cR caddc co cle wbr wb cX cr wcel cB cr wcel cR cr
      wcel cX cB cle wbr cX cR caddc co cB cR caddc co cle wbr wb cX cB cR
      leadd1 3expb an1s adantll cB cR caddc co cD cX cR caddc co cle iccshftr.2
      breq2i syl6bb 3anbi123d cA cr wcel cB cr wcel wa cX cA cB cicc co wcel cX
      cr wcel cA cX cle wbr cX cB cle wbr w3a wb cX cr wcel cR cr wcel wa cA cB
      cX elicc2 adantr cA cr wcel cB cr wcel wa cR cr wcel cX cR caddc co cC cD
      cicc co wcel cX cR caddc co cr wcel cC cX cR caddc co cle wbr cX cR caddc
      co cD cle wbr w3a wb cX cr wcel cA cr wcel cB cr wcel cR cr wcel cX cR
      caddc co cC cD cicc co wcel cX cR caddc co cr wcel cC cX cR caddc co cle
      wbr cX cR caddc co cD cle wbr w3a wb cC cr wcel cD cr wcel cX cR caddc co
      cC cD cicc co wcel cX cR caddc co cr wcel cC cX cR caddc co cle wbr cX cR
      caddc co cD cle wbr w3a wb cA cr wcel cR cr wcel wa cB cr wcel cR cr wcel
      wa cC cD cX cR caddc co elicc2 cA cr wcel cR cr wcel wa cA cR caddc co cr
      cC cA cR readdcl iccshftr.1 syl5eqelr cB cr wcel cR cr wcel wa cB cR
      caddc co cr cD cB cR readdcl iccshftr.2 syl5eqelr syl2an anandirs adantrl
      3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccshftri.1 $e |- A e. RR $.
    iccshftri.2 $e |- B e. RR $.
    iccshftri.3 $e |- R e. RR $.
    iccshftri.4 $e |- ( A + R ) = C $.
    iccshftri.5 $e |- ( B + R ) = D $.
    $( Membership in a shifted interval. $)
    iccshftri $p |- ( X e. ( A [,] B ) -> ( X + R ) e. ( C [,] D ) ) $=
      cX cr wcel cX cA cB cicc co wcel cX cR caddc co cC cD cicc co wcel cA cB
      cicc co cr cX cA cr wcel cB cr wcel cA cB cicc co cr wss iccshftri.1
      iccshftri.2 cA cB iccssre mp2an sseli cX cr wcel cX cA cB cicc co wcel cX
      cR caddc co cC cD cicc co wcel cX cr wcel cR cr wcel cX cA cB cicc co
      wcel cX cR caddc co cC cD cicc co wcel wb iccshftri.3 cA cr wcel cB cr
      wcel cX cr wcel cR cr wcel wa cX cA cB cicc co wcel cX cR caddc co cC cD
      cicc co wcel wb iccshftri.1 iccshftri.2 cA cB cC cD cR cX iccshftri.4
      iccshftri.5 iccshftr mpanl12 mpan2 biimpd mpcom $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccshftl.1 $e |- ( A - R ) = C $.
    iccshftl.2 $e |- ( B - R ) = D $.
    $( Membership in a shifted interval. $)
    iccshftl $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR ) )
                  -> ( X e. ( A [,] B ) <-> ( X - R ) e. ( C [,] D ) ) ) $=
      cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa wa cX cr wcel cA cX cle
      wbr cX cB cle wbr w3a cX cR cmin co cr wcel cC cX cR cmin co cle wbr cX
      cR cmin co cD cle wbr w3a cX cA cB cicc co wcel cX cR cmin co cC cD cicc
      co wcel cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa wa cX cr wcel
      cX cR cmin co cr wcel cA cX cle wbr cC cX cR cmin co cle wbr cX cB cle
      wbr cX cR cmin co cD cle wbr cX cr wcel cR cr wcel wa cX cr wcel cX cR
      cmin co cr wcel wb cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa cX
      cr wcel wi cX cr wcel cR cr wcel wa cX cR cmin co cr wcel wi cX cr wcel
      cR cr wcel wa cX cr wcel cX cR cmin co cr wcel wb wi cX cr wcel cR cr
      wcel pm3.26 cX cR resubcl cX cr wcel cR cr wcel wa cX cr wcel cX cR cmin
      co cr wcel pm5.35 mp2an adantl cA cr wcel cB cr wcel wa cX cr wcel cR cr
      wcel wa wa cA cX cle wbr cA cR cmin co cX cR cmin co cle wbr cC cX cR
      cmin co cle wbr cA cr wcel cX cr wcel cR cr wcel wa cA cX cle wbr cA cR
      cmin co cX cR cmin co cle wbr wb cB cr wcel cA cr wcel cX cr wcel cR cr
      wcel cA cX cle wbr cA cR cmin co cX cR cmin co cle wbr wb cA cX cR lesub1
      3expb adantlr cA cR cmin co cC cX cR cmin co cle iccshftl.1 breq1i syl6bb
      cA cr wcel cB cr wcel wa cX cr wcel cR cr wcel wa wa cX cB cle wbr cX cR
      cmin co cB cR cmin co cle wbr cX cR cmin co cD cle wbr cB cr wcel cX cr
      wcel cR cr wcel wa cX cB cle wbr cX cR cmin co cB cR cmin co cle wbr wb
      cA cr wcel cX cr wcel cB cr wcel cR cr wcel cX cB cle wbr cX cR cmin co
      cB cR cmin co cle wbr wb cX cr wcel cB cr wcel cR cr wcel cX cB cle wbr
      cX cR cmin co cB cR cmin co cle wbr wb cX cB cR lesub1 3expb an1s adantll
      cB cR cmin co cD cX cR cmin co cle iccshftl.2 breq2i syl6bb 3anbi123d cA
      cr wcel cB cr wcel wa cX cA cB cicc co wcel cX cr wcel cA cX cle wbr cX
      cB cle wbr w3a wb cX cr wcel cR cr wcel wa cA cB cX elicc2 adantr cA cr
      wcel cB cr wcel wa cR cr wcel cX cR cmin co cC cD cicc co wcel cX cR cmin
      co cr wcel cC cX cR cmin co cle wbr cX cR cmin co cD cle wbr w3a wb cX cr
      wcel cA cr wcel cB cr wcel cR cr wcel cX cR cmin co cC cD cicc co wcel cX
      cR cmin co cr wcel cC cX cR cmin co cle wbr cX cR cmin co cD cle wbr w3a
      wb cC cr wcel cD cr wcel cX cR cmin co cC cD cicc co wcel cX cR cmin co
      cr wcel cC cX cR cmin co cle wbr cX cR cmin co cD cle wbr w3a wb cA cr
      wcel cR cr wcel wa cB cr wcel cR cr wcel wa cC cD cX cR cmin co elicc2 cA
      cr wcel cR cr wcel wa cA cR cmin co cr cC cA cR resubcl iccshftl.1
      syl5eqelr cB cr wcel cR cr wcel wa cB cR cmin co cr cD cB cR resubcl
      iccshftl.2 syl5eqelr syl2an anandirs adantrl 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccshftli.1 $e |- A e. RR $.
    iccshftli.2 $e |- B e. RR $.
    iccshftli.3 $e |- R e. RR $.
    iccshftli.4 $e |- ( A - R ) = C $.
    iccshftli.5 $e |- ( B - R ) = D $.
    $( Membership in a shifted interval. $)
    iccshftli $p |- ( X e. ( A [,] B ) -> ( X - R ) e. ( C [,] D ) ) $=
      cX cr wcel cX cA cB cicc co wcel cX cR cmin co cC cD cicc co wcel cA cB
      cicc co cr cX cA cr wcel cB cr wcel cA cB cicc co cr wss iccshftli.1
      iccshftli.2 cA cB iccssre mp2an sseli cX cr wcel cX cA cB cicc co wcel cX
      cR cmin co cC cD cicc co wcel cX cr wcel cR cr wcel cX cA cB cicc co wcel
      cX cR cmin co cC cD cicc co wcel wb iccshftli.3 cA cr wcel cB cr wcel cX
      cr wcel cR cr wcel wa cX cA cB cicc co wcel cX cR cmin co cC cD cicc co
      wcel wb iccshftli.1 iccshftli.2 cA cB cC cD cR cX iccshftli.4 iccshftli.5
      iccshftl mpanl12 mpan2 biimpd mpcom $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccdil.1 $e |- ( A x. R ) = C $.
    iccdil.2 $e |- ( B x. R ) = D $.
    $( Membership in a dilated interval. $)
    iccdil $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR+ ) )
                  -> ( X e. ( A [,] B ) <-> ( X x. R ) e. ( C [,] D ) ) ) $=
      cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa wa cX cr wcel cA cX
      cle wbr cX cB cle wbr w3a cX cR cmul co cr wcel cC cX cR cmul co cle wbr
      cX cR cmul co cD cle wbr w3a cX cA cB cicc co wcel cX cR cmul co cC cD
      cicc co wcel cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa wa cX cr
      wcel cX cR cmul co cr wcel cA cX cle wbr cC cX cR cmul co cle wbr cX cB
      cle wbr cX cR cmul co cD cle wbr cX cr wcel cR crp wcel wa cX cr wcel cX
      cR cmul co cr wcel wb cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa
      cX cr wcel wi cX cr wcel cR crp wcel wa cX cR cmul co cr wcel wi cX cr
      wcel cR crp wcel wa cX cr wcel cX cR cmul co cr wcel wb wi cX cr wcel cR
      crp wcel pm3.26 cX cr wcel cR cr wcel cX cR cmul co cr wcel cR crp wcel
      cX cR axmulrcl cR rpre sylan2 cX cr wcel cR crp wcel wa cX cr wcel cX cR
      cmul co cr wcel pm5.35 mp2an adantl cA cr wcel cB cr wcel wa cX cr wcel
      cR crp wcel wa wa cA cX cle wbr cA cR cmul co cX cR cmul co cle wbr cC cX
      cR cmul co cle wbr cA cr wcel cX cr wcel cR crp wcel wa cA cX cle wbr cA
      cR cmul co cX cR cmul co cle wbr wb cB cr wcel cA cr wcel cX cr wcel cR
      crp wcel cA cX cle wbr cA cR cmul co cX cR cmul co cle wbr wb cA cr wcel
      cX cr wcel cR cr wcel cc0 cR clt wbr wa cA cX cle wbr cA cR cmul co cX cR
      cmul co cle wbr wb cR crp wcel cA cX cR lemul1 cR elrp syl3an3b 3expb
      adantlr cA cR cmul co cC cX cR cmul co cle iccdil.1 breq1i syl6bb cA cr
      wcel cB cr wcel wa cX cr wcel cR crp wcel wa wa cX cB cle wbr cX cR cmul
      co cB cR cmul co cle wbr cX cR cmul co cD cle wbr cB cr wcel cX cr wcel
      cR crp wcel wa cX cB cle wbr cX cR cmul co cB cR cmul co cle wbr wb cA cr
      wcel cX cr wcel cB cr wcel cR crp wcel cX cB cle wbr cX cR cmul co cB cR
      cmul co cle wbr wb cX cr wcel cB cr wcel cR crp wcel cX cB cle wbr cX cR
      cmul co cB cR cmul co cle wbr wb cX cr wcel cB cr wcel cR cr wcel cc0 cR
      clt wbr wa cX cB cle wbr cX cR cmul co cB cR cmul co cle wbr wb cR crp
      wcel cX cB cR lemul1 cR elrp syl3an3b 3expb an1s adantll cB cR cmul co cD
      cX cR cmul co cle iccdil.2 breq2i syl6bb 3anbi123d cA cr wcel cB cr wcel
      wa cX cA cB cicc co wcel cX cr wcel cA cX cle wbr cX cB cle wbr w3a wb cX
      cr wcel cR crp wcel wa cA cB cX elicc2 adantr cA cr wcel cB cr wcel wa cR
      crp wcel cX cR cmul co cC cD cicc co wcel cX cR cmul co cr wcel cC cX cR
      cmul co cle wbr cX cR cmul co cD cle wbr w3a wb cX cr wcel cA cr wcel cB
      cr wcel wa cR cr wcel cX cR cmul co cC cD cicc co wcel cX cR cmul co cr
      wcel cC cX cR cmul co cle wbr cX cR cmul co cD cle wbr w3a wb cR crp wcel
      cA cr wcel cB cr wcel cR cr wcel cX cR cmul co cC cD cicc co wcel cX cR
      cmul co cr wcel cC cX cR cmul co cle wbr cX cR cmul co cD cle wbr w3a wb
      cC cr wcel cD cr wcel cX cR cmul co cC cD cicc co wcel cX cR cmul co cr
      wcel cC cX cR cmul co cle wbr cX cR cmul co cD cle wbr w3a wb cA cr wcel
      cR cr wcel wa cB cr wcel cR cr wcel wa cC cD cX cR cmul co elicc2 cA cr
      wcel cR cr wcel wa cA cR cmul co cr cC cA cR remulcl iccdil.1 syl5eqelr
      cB cr wcel cR cr wcel wa cB cR cmul co cr cD cB cR remulcl iccdil.2
      syl5eqelr syl2an anandirs cR rpre sylan2 adantrl 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccdili.1 $e |- A e. RR $.
    iccdili.2 $e |- B e. RR $.
    iccdili.3 $e |- R e. RR+ $.
    iccdili.4 $e |- ( A x. R ) = C $.
    iccdili.5 $e |- ( B x. R ) = D $.
    $( Membership in a dilated interval. $)
    iccdili $p |- ( X e. ( A [,] B ) -> ( X x. R ) e. ( C [,] D ) ) $=
      cX cr wcel cX cA cB cicc co wcel cX cR cmul co cC cD cicc co wcel cA cB
      cicc co cr cX cA cr wcel cB cr wcel cA cB cicc co cr wss iccdili.1
      iccdili.2 cA cB iccssre mp2an sseli cX cr wcel cX cA cB cicc co wcel cX
      cR cmul co cC cD cicc co wcel cX cr wcel cR crp wcel cX cA cB cicc co
      wcel cX cR cmul co cC cD cicc co wcel wb iccdili.3 cA cr wcel cB cr wcel
      cX cr wcel cR crp wcel wa cX cA cB cicc co wcel cX cR cmul co cC cD cicc
      co wcel wb iccdili.1 iccdili.2 cA cB cC cD cR cX iccdili.4 iccdili.5
      iccdil mpanl12 mpan2 biimpd mpcom $.
      $( [2-Sep-2009] $)
  $}

  ${
    icccntr.1 $e |- ( A / R ) = C $.
    icccntr.2 $e |- ( B / R ) = D $.
    $( Membership in a contracted interval. $)
    icccntr $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR+ ) )
                  -> ( X e. ( A [,] B ) <-> ( X / R ) e. ( C [,] D ) ) ) $=
      cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa wa cX cr wcel cA cX
      cle wbr cX cB cle wbr w3a cX cR cdiv co cr wcel cC cX cR cdiv co cle wbr
      cX cR cdiv co cD cle wbr w3a cX cA cB cicc co wcel cX cR cdiv co cC cD
      cicc co wcel cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa wa cX cr
      wcel cX cR cdiv co cr wcel cA cX cle wbr cC cX cR cdiv co cle wbr cX cB
      cle wbr cX cR cdiv co cD cle wbr cX cr wcel cR crp wcel wa cX cr wcel cX
      cR cdiv co cr wcel wb cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa
      cX cr wcel wi cX cr wcel cR crp wcel wa cX cR cdiv co cr wcel wi cX cr
      wcel cR crp wcel wa cX cr wcel cX cR cdiv co cr wcel wb wi cX cr wcel cR
      crp wcel pm3.26 cX cR rerpdivcl cX cr wcel cR crp wcel wa cX cr wcel cX
      cR cdiv co cr wcel pm5.35 mp2an adantl cA cr wcel cB cr wcel wa cX cr
      wcel cR crp wcel wa wa cA cX cle wbr cA cR cdiv co cX cR cdiv co cle wbr
      cC cX cR cdiv co cle wbr cA cr wcel cX cr wcel cR crp wcel wa cA cX cle
      wbr cA cR cdiv co cX cR cdiv co cle wbr wb cB cr wcel cA cr wcel cX cr
      wcel cR crp wcel cA cX cle wbr cA cR cdiv co cX cR cdiv co cle wbr wb cA
      cr wcel cX cr wcel cR cr wcel cc0 cR clt wbr wa cA cX cle wbr cA cR cdiv
      co cX cR cdiv co cle wbr wb cR crp wcel cA cX cR lediv1 cR elrp syl3an3b
      3expb adantlr cA cR cdiv co cC cX cR cdiv co cle icccntr.1 breq1i syl6bb
      cA cr wcel cB cr wcel wa cX cr wcel cR crp wcel wa wa cX cB cle wbr cX cR
      cdiv co cB cR cdiv co cle wbr cX cR cdiv co cD cle wbr cB cr wcel cX cr
      wcel cR crp wcel wa cX cB cle wbr cX cR cdiv co cB cR cdiv co cle wbr wb
      cA cr wcel cX cr wcel cB cr wcel cR crp wcel cX cB cle wbr cX cR cdiv co
      cB cR cdiv co cle wbr wb cX cr wcel cB cr wcel cR crp wcel cX cB cle wbr
      cX cR cdiv co cB cR cdiv co cle wbr wb cX cr wcel cB cr wcel cR cr wcel
      cc0 cR clt wbr wa cX cB cle wbr cX cR cdiv co cB cR cdiv co cle wbr wb cR
      crp wcel cX cB cR lediv1 cR elrp syl3an3b 3expb an1s adantll cB cR cdiv
      co cD cX cR cdiv co cle icccntr.2 breq2i syl6bb 3anbi123d cA cr wcel cB
      cr wcel wa cX cA cB cicc co wcel cX cr wcel cA cX cle wbr cX cB cle wbr
      w3a wb cX cr wcel cR crp wcel wa cA cB cX elicc2 adantr cA cr wcel cB cr
      wcel wa cR crp wcel cX cR cdiv co cC cD cicc co wcel cX cR cdiv co cr
      wcel cC cX cR cdiv co cle wbr cX cR cdiv co cD cle wbr w3a wb cX cr wcel
      cA cr wcel cB cr wcel cR crp wcel cX cR cdiv co cC cD cicc co wcel cX cR
      cdiv co cr wcel cC cX cR cdiv co cle wbr cX cR cdiv co cD cle wbr w3a wb
      cC cr wcel cD cr wcel cX cR cdiv co cC cD cicc co wcel cX cR cdiv co cr
      wcel cC cX cR cdiv co cle wbr cX cR cdiv co cD cle wbr w3a wb cA cr wcel
      cR crp wcel wa cB cr wcel cR crp wcel wa cC cD cX cR cdiv co elicc2 cA cr
      wcel cR crp wcel wa cA cR cdiv co cr cC cA cR rerpdivcl icccntr.1
      syl5eqelr cB cr wcel cR crp wcel wa cB cR cdiv co cr cD cB cR rerpdivcl
      icccntr.2 syl5eqelr syl2an anandirs adantrl 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    icccntri.1 $e |- A e. RR $.
    icccntri.2 $e |- B e. RR $.
    icccntri.3 $e |- R e. RR+ $.
    icccntri.4 $e |- ( A / R ) = C $.
    icccntri.5 $e |- ( B / R ) = D $.
    $( Membership in a contracted interval. $)
    icccntri $p |- ( X e. ( A [,] B ) -> ( X / R ) e. ( C [,] D ) ) $=
      cX cr wcel cX cA cB cicc co wcel cX cR cdiv co cC cD cicc co wcel cA cB
      cicc co cr cX cA cr wcel cB cr wcel cA cB cicc co cr wss icccntri.1
      icccntri.2 cA cB iccssre mp2an sseli cX cr wcel cX cA cB cicc co wcel cX
      cR cdiv co cC cD cicc co wcel cX cr wcel cR crp wcel cX cA cB cicc co
      wcel cX cR cdiv co cC cD cicc co wcel wb icccntri.3 cA cr wcel cB cr wcel
      cX cr wcel cR crp wcel wa cX cA cB cicc co wcel cX cR cdiv co cC cD cicc
      co wcel wb icccntri.1 icccntri.2 cA cB cC cD cR cX icccntri.4 icccntri.5
      icccntr mpanl12 mpan2 biimpd mpcom $.
      $( [2-Sep-2009] $)
  $}

  $c II $.
  $( Extend class notation with the unit interval. $)
  cii $a class II $.

  $( Define the unit interval with the Euclidean topology. $)
  df-ii $a |- II = ( Open ` ( ( abs o. - )
                          |` ( ( 0 [,] 1 ) X. ( 0 [,] 1 ) ) ) ) $.

  ${
    $( The unit interval is a topological space. $)
    iitop $p |- II e. Top $=
      cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cme wcel cii ctop
      wcel cabs cmin ccom cme wcel cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co
      cxp cres cme wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom
      cc0 c1 cicc co metres ax-mp cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co
      cxp cres cii df-ii opntop ax-mp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The base set of the unit interval. $)
    iiuni $p |- U. II = ( 0 [,] 1 ) $=
      cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cme wcel cii cuni
      cc0 c1 cicc co wceq cabs cmin ccom cme wcel cabs cmin ccom cc0 c1 cicc co
      cc0 c1 cicc co cxp cres cme wcel cabs cmin ccom cabs cmin ccom eqid cnmet
      cabs cmin ccom cc0 c1 cicc co metres ax-mp cabs cmin ccom cc0 c1 cicc co
      cc0 c1 cicc co cxp cres cii cc0 c1 cicc co cabs cmin ccom cme wcel cc0 c1
      cicc co cc wss cc0 c1 cicc co cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc
      co cxp cres cdm cdm wceq cabs cmin ccom cabs cmin ccom eqid cnmet cc0 c1
      cicc co cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1
      iccssre mp2an axresscn sstri cabs cmin ccom cc cc0 c1 cicc co cabs cmin
      ccom cabs cmin ccom eqid cnmetba metssba2 mp2an df-ii uniopn2 ax-mp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Alternate definition of the unit interval. $)
    dfii2 $p |- II = ( subSp ` <. ( 0 [,] 1 ) , ( topGen ` ran (,) ) >. ) $=
      cii cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres copn cfv cc0 c1
      cicc co cioo crn ctg cfv cop csubsp cfv df-ii cc0 c1 cicc co cr wss cc0
      c1 cicc co cioo crn ctg cfv cop csubsp cfv cabs cmin ccom cc0 c1 cicc co
      cc0 c1 cicc co cxp cres copn cfv wceq cc0 cr wcel c1 cr wcel cc0 c1 cicc
      co cr wss 0re 1re cc0 c1 iccssre mp2an cc0 c1 cicc co stioo ax-mp eqtr4i
      $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Reverse the unit interval. $)
    iirev $p |- ( X e. ( 0 [,] 1 ) -> ( 1 - X ) e. ( 0 [,] 1 ) ) $=
      cX cr wcel cc0 cX cle wbr cX c1 cle wbr w3a c1 cX cmin co cr wcel cc0 c1
      cX cmin co cle wbr c1 cX cmin co c1 cle wbr w3a cX cc0 c1 cicc co wcel c1
      cX cmin co cc0 c1 cicc co wcel cX cr wcel cc0 cX cle wbr cX c1 cle wbr
      w3a c1 cX cmin co cr wcel cc0 c1 cX cmin co cle wbr c1 cX cmin co c1 cle
      wbr cX cr wcel cc0 cX cle wbr c1 cX cmin co cr wcel cX c1 cle wbr c1 cr
      wcel cX cr wcel c1 cX cmin co cr wcel 1re c1 cX resubcl mpan 3ad2ant1 cX
      cr wcel cc0 cX cle wbr cX c1 cle wbr w3a cc0 c1 cX cmin co cle wbr cX c1
      cle wbr cX cr wcel cc0 cX cle wbr cX c1 cle wbr 3simp3 c1 cr wcel cX cr
      wcel cc0 c1 cX cmin co cle wbr cX c1 cle wbr wb cX cr wcel cc0 cX cle wbr
      cX c1 cle wbr w3a c1 cX subge0 1re cX cr wcel cc0 cX cle wbr cX c1 cle
      wbr 3simp1 sylancr mpbird cX cr wcel cc0 cX cle wbr cX c1 cle wbr w3a cc0
      cX cle wbr c1 cX cmin co c1 cle wbr cX cr wcel cc0 cX cle wbr cX c1 cle
      wbr 3simp2 c1 cr wcel cX cr wcel cc0 cX cle wbr c1 cX cmin co c1 cle wbr
      wb cX cr wcel cc0 cX cle wbr cX c1 cle wbr w3a c1 cX subge02 1re cX cr
      wcel cc0 cX cle wbr cX c1 cle wbr 3simp1 sylancr mpbid 3jca cc0 cr wcel
      c1 cr wcel cX cc0 c1 cicc co wcel cX cr wcel cc0 cX cle wbr cX c1 cle wbr
      w3a wb 0re 1re cc0 c1 cX elicc2 mp2an cc0 cr wcel c1 cr wcel c1 cX cmin
      co cc0 c1 cicc co wcel c1 cX cmin co cr wcel cc0 c1 cX cmin co cle wbr c1
      cX cmin co c1 cle wbr w3a wb 0re 1re cc0 c1 c1 cX cmin co elicc2 mp2an
      3imtr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Map the first half of ` II ` into ` II ` . $)
    iihalf1 $p |- ( X e. ( 0 [,] ( 1 / 2 ) ) -> ( 2 x. X ) e. ( 0 [,] 1 ) ) $=
      cX cr wcel cc0 cX cle wbr cX c1 c2 cdiv co cle wbr w3a c2 cX cmul co cr
      wcel cc0 c2 cX cmul co cle wbr c2 cX cmul co c1 cle wbr w3a cX cc0 c1 c2
      cdiv co cicc co wcel c2 cX cmul co cc0 c1 cicc co wcel cX cr wcel cc0 cX
      cle wbr cX c1 c2 cdiv co cle wbr w3a c2 cX cmul co cr wcel cc0 c2 cX cmul
      co cle wbr c2 cX cmul co c1 cle wbr cX cr wcel cc0 cX cle wbr c2 cX cmul
      co cr wcel cX c1 c2 cdiv co cle wbr c2 cr wcel cX cr wcel c2 cX cmul co
      cr wcel 2re c2 cX remulcl mpan 3ad2ant1 cX cr wcel cc0 cX cle wbr cc0 c2
      cX cmul co cle wbr cX c1 c2 cdiv co cle wbr c2 cr wcel cc0 c2 cle wbr cX
      cr wcel cc0 cX cle wbr wa cc0 c2 cX cmul co cle wbr 2re cc0 c2 0re 2re
      2pos ltleii c2 cX mulge0 mpanl12 3adant3 cX cr wcel cX c1 c2 cdiv co cle
      wbr c2 cX cmul co c1 cle wbr cc0 cX cle wbr cX cr wcel c2 cX cmul co c1
      cle wbr cX c1 c2 cdiv co cle wbr cX cr wcel c1 cr wcel c2 cr wcel cc0 c2
      clt wbr wa c2 cX cmul co c1 cle wbr cX c1 c2 cdiv co cle wbr wb 1re c2 cr
      wcel cc0 c2 clt wbr 2re 2pos pm3.2i cX c1 c2 lemuldiv2 mp3an23 biimpar
      3adant2 3jca cc0 cr wcel c1 c2 cdiv co cr wcel cX cc0 c1 c2 cdiv co cicc
      co wcel cX cr wcel cc0 cX cle wbr cX c1 c2 cdiv co cle wbr w3a wb 0re c2
      2re 2ne0 rereccli cc0 c1 c2 cdiv co cX elicc2 mp2an cc0 cr wcel c1 cr
      wcel c2 cX cmul co cc0 c1 cicc co wcel c2 cX cmul co cr wcel cc0 c2 cX
      cmul co cle wbr c2 cX cmul co c1 cle wbr w3a wb 0re 1re cc0 c1 c2 cX cmul
      co elicc2 mp2an 3imtr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( Map the second half of ` II ` into ` II ` . $)
    iihalf2 $p |- ( X e. ( ( 1 / 2 ) [,] 1 ) ->
                                        ( ( 2 x. X ) - 1 ) e. ( 0 [,] 1 ) ) $=
      cX cr wcel c1 c2 cdiv co cX cle wbr cX c1 cle wbr w3a c2 cX cmul co c1
      cmin co cr wcel cc0 c2 cX cmul co c1 cmin co cle wbr c2 cX cmul co c1
      cmin co c1 cle wbr w3a cX c1 c2 cdiv co c1 cicc co wcel c2 cX cmul co c1
      cmin co cc0 c1 cicc co wcel cX cr wcel c1 c2 cdiv co cX cle wbr cX c1 cle
      wbr w3a c2 cX cmul co c1 cmin co cr wcel cc0 c2 cX cmul co c1 cmin co cle
      wbr c2 cX cmul co c1 cmin co c1 cle wbr cX cr wcel c1 c2 cdiv co cX cle
      wbr c2 cX cmul co c1 cmin co cr wcel cX c1 cle wbr c2 cX cmul co cr wcel
      c1 cr wcel c2 cX cmul co c1 cmin co cr wcel cX cr wcel c2 cX cmul co c1
      resubcl c2 cr wcel cX cr wcel c2 cX cmul co cr wcel 2re c2 cX remulcl
      mpan 1re sylancl 3ad2ant1 cX cr wcel c1 c2 cdiv co cX cle wbr cc0 c2 cX
      cmul co c1 cmin co cle wbr cX c1 cle wbr cX cr wcel cc0 c2 cX cmul co c1
      cmin co cle wbr c1 c2 cdiv co cX cle wbr cX cr wcel cc0 c2 cX cmul co c1
      cmin co cle wbr c1 c2 cX cmul co cle wbr c1 c2 cdiv co cX cle wbr c2 cX
      cmul co cr wcel c1 cr wcel cc0 c2 cX cmul co c1 cmin co cle wbr c1 c2 cX
      cmul co cle wbr wb cX cr wcel c2 cX cmul co c1 subge0 c2 cr wcel cX cr
      wcel c2 cX cmul co cr wcel 2re c2 cX remulcl mpan 1re sylancl c1 cr wcel
      cX cr wcel c2 cr wcel cc0 c2 clt wbr wa c1 c2 cdiv co cX cle wbr c1 c2 cX
      cmul co cle wbr wb 1re c2 cr wcel cc0 c2 clt wbr 2re 2pos pm3.2i c1 cX c2
      ledivmul mp3an13 bitr4d biimpar 3adant3 cX cr wcel cX c1 cle wbr c2 cX
      cmul co c1 cmin co c1 cle wbr c1 c2 cdiv co cX cle wbr cX cr wcel cX c1
      cle wbr c2 cX cmul co c1 cmin co c1 cle wbr cX cr wcel c2 cX cmul co c2
      c1 cmul co cle wbr c2 cX cmul co c1 c1 caddc co cle wbr cX c1 cle wbr c2
      cX cmul co c1 cmin co c1 cle wbr cX cr wcel c2 c1 cmul co c1 c1 caddc co
      c2 cX cmul co cle c2 c1 cmul co c1 c1 caddc co wceq cX cr wcel c1 ax1cn
      2timesi a1i breq2d cX cr wcel c1 cr wcel c2 cr wcel cc0 c2 clt wbr wa cX
      c1 cle wbr c2 cX cmul co c2 c1 cmul co cle wbr wb 1re c2 cr wcel cc0 c2
      clt wbr 2re 2pos pm3.2i cX c1 c2 lemul2 mp3an23 cX cr wcel c2 cX cmul co
      cr wcel c2 cX cmul co c1 cmin co c1 cle wbr c2 cX cmul co c1 c1 caddc co
      cle wbr wb c2 cr wcel cX cr wcel c2 cX cmul co cr wcel 2re c2 cX remulcl
      mpan c2 cX cmul co cr wcel c1 cr wcel c1 cr wcel c2 cX cmul co c1 cmin co
      c1 cle wbr c2 cX cmul co c1 c1 caddc co cle wbr wb 1re 1re c2 cX cmul co
      c1 c1 lesubadd mp3an23 syl 3bitr4d biimpa 3adant2 3jca c1 c2 cdiv co cr
      wcel c1 cr wcel cX c1 c2 cdiv co c1 cicc co wcel cX cr wcel c1 c2 cdiv co
      cX cle wbr cX c1 cle wbr w3a wb c2 2re 2ne0 rereccli 1re c1 c2 cdiv co c1
      cX elicc2 mp2an cc0 cr wcel c1 cr wcel c2 cX cmul co c1 cmin co cc0 c1
      cicc co wcel c2 cX cmul co c1 cmin co cr wcel cc0 c2 cX cmul co c1 cmin
      co cle wbr c2 cX cmul co c1 cmin co c1 cle wbr w3a wb 0re 1re cc0 c1 c2
      cX cmul co c1 cmin co elicc2 mp2an 3imtr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The unit interval is closed under multiplication. $)
    iimulcl $p |- ( ( A e. ( 0 [,] 1 ) /\ B e. ( 0 [,] 1 ) )
                                    -> ( A x. B ) e. ( 0 [,] 1 ) ) $=
      cA cr wcel cc0 cA cle wbr cA c1 cle wbr w3a cB cr wcel cc0 cB cle wbr cB
      c1 cle wbr w3a wa cA cB cmul co cr wcel cc0 cA cB cmul co cle wbr cA cB
      cmul co c1 cle wbr w3a cA cc0 c1 cicc co wcel cB cc0 c1 cicc co wcel wa
      cA cB cmul co cc0 c1 cicc co wcel cA cr wcel cc0 cA cle wbr cA c1 cle wbr
      w3a cB cr wcel cc0 cB cle wbr cB c1 cle wbr w3a wa cA cB cmul co cr wcel
      cc0 cA cB cmul co cle wbr cA cB cmul co c1 cle wbr cA cr wcel cc0 cA cle
      wbr cB cr wcel cc0 cB cle wbr cB c1 cle wbr w3a cA cB cmul co cr wcel cA
      c1 cle wbr cA cr wcel cc0 cB cle wbr cB cr wcel cA cB cmul co cr wcel cB
      c1 cle wbr cA cB axmulrcl 3ad2antr1 3ad2antl1 cA cr wcel cc0 cA cle wbr
      cB cr wcel cc0 cB cle wbr cB c1 cle wbr w3a cc0 cA cB cmul co cle wbr cA
      c1 cle wbr cA cr wcel cc0 cA cle wbr wa cB cr wcel cc0 cB cle wbr cc0 cA
      cB cmul co cle wbr cB c1 cle wbr cA cB mulge0 3adantr3 3adantl3 cA cr
      wcel cc0 cA cle wbr cA c1 cle wbr w3a cB cr wcel cc0 cB cle wbr cB c1 cle
      wbr w3a wa cA cB cmul co c1 c1 cmul co c1 cle cA cr wcel cc0 cA cle wbr
      cA c1 cle wbr w3a cB cr wcel cc0 cB cle wbr cB c1 cle wbr w3a wa cA cr
      wcel cB cr wcel wa cc0 cA cle wbr cc0 cB cle wbr wa cA c1 cle wbr cB c1
      cle wbr wa w3a cA cB cmul co c1 c1 cmul co cle wbr cA cr wcel cc0 cA cle
      wbr cA c1 cle wbr cB cr wcel cc0 cB cle wbr cB c1 cle wbr an6 cA cr wcel
      cB cr wcel wa cc0 cA cle wbr cc0 cB cle wbr wa cA c1 cle wbr cB c1 cle
      wbr wa cA cB cmul co c1 c1 cmul co cle wbr cA cr wcel cc0 cA cle wbr cB
      cr wcel cc0 cB cle wbr cA c1 cle wbr cB c1 cle wbr wa cA cB cmul co c1 c1
      cmul co cle wbr wi cA cr wcel cc0 cA cle wbr wa c1 cr wcel cB cr wcel cc0
      cB cle wbr wa cA c1 cle wbr cB c1 cle wbr wa cA cB cmul co c1 c1 cmul co
      cle wbr wi 1re cA cr wcel cc0 cA cle wbr wa c1 cr wcel wa cB cr wcel cc0
      cB cle wbr wa c1 cr wcel cA c1 cle wbr cB c1 cle wbr wa cA cB cmul co c1
      c1 cmul co cle wbr wi 1re cA c1 cB c1 lemul12a mpanr2 mpanl2 an4s 3impia
      sylbi c1 ax1cn mulid1i syl6breq 3jca cA cc0 c1 cicc co wcel cA cr wcel
      cc0 cA cle wbr cA c1 cle wbr w3a cB cc0 c1 cicc co wcel cB cr wcel cc0 cB
      cle wbr cB c1 cle wbr w3a cc0 cr wcel c1 cr wcel cA cc0 c1 cicc co wcel
      cA cr wcel cc0 cA cle wbr cA c1 cle wbr w3a wb 0re 1re cc0 c1 cA elicc2
      mp2an cc0 cr wcel c1 cr wcel cB cc0 c1 cicc co wcel cB cr wcel cc0 cB cle
      wbr cB c1 cle wbr w3a wb 0re 1re cc0 c1 cB elicc2 mp2an anbi12i cc0 cr
      wcel c1 cr wcel cA cB cmul co cc0 c1 cicc co wcel cA cB cmul co cr wcel
      cc0 cA cB cmul co cle wbr cA cB cmul co c1 cle wbr w3a wb 0re 1re cc0 c1
      cA cB cmul co elicc2 mp2an 3imtr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    iccst.1 $e |- R = ( topGen ` ran (,) ) $.
    iccst.2 $e |- J = ( Open ` ( ( abs o. - ) |`
                                    ( ( A [,] B ) X. ( A [,] B ) ) ) ) $.
    $( The subspace topology induced by a closed interval. $)
    iccst $p |- ( ( A e. RR /\ B e. RR ) ->
                                J = ( subSp ` <. ( A [,] B ) , R >. ) ) $=
      cA cr wcel cB cr wcel wa cJ cabs cmin ccom cA cB cicc co cA cB cicc co
      cxp cres copn cfv cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc
      co cxp cres copn cfv cA cB cicc co cR cop csubsp cfv cJ cabs cmin ccom cA
      cB cicc co cA cB cicc co cxp cres copn cfv wceq cA cr wcel cB cr wcel wa
      iccst.2 a1i cA cr wcel cB cr wcel wa cabs cmin ccom cA cB cicc co cA cB
      cicc co cxp cres cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc
      co cxp cres copn cA cr wcel cB cr wcel wa cabs cmin ccom cr cr cxp cres
      cA cB cicc co cA cB cicc co cxp cres cabs cmin ccom cA cB cicc co cA cB
      cicc co cxp cres cA cr wcel cB cr wcel wa cA cB cicc co cr wss cA cB cicc
      co cA cB cicc co cxp cr cr cxp wss cabs cmin ccom cr cr cxp cres cA cB
      cicc co cA cB cicc co cxp cres cabs cmin ccom cA cB cicc co cA cB cicc co
      cxp cres wceq cA cB iccssre cA cB cicc co cr wss cA cB cicc co cA cB cicc
      co cxp cr cr cxp wss cA cB cicc co cr cA cB cicc co cr ssxp anidms cabs
      cmin ccom cA cB cicc co cA cB cicc co cxp cr cr cxp resabs1 3syl eqcomd
      fveq2d cabs cmin ccom cr cr cxp cres cme wcel cA cB cicc co cr wss cabs
      cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres copn cfv cA
      cB cicc co cR cop csubsp cfv wceq cA cr wcel cB cr wcel wa cabs cmin ccom
      cr cr cxp cres cme wcel cA cB cicc co cr wss wa cA cB cicc co cR cop
      csubsp cfv cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp
      cres copn cfv cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres
      cA cB cicc co cA cB cicc co cxp cres cR cabs cmin ccom cr cr cxp cres cA
      cB cicc co cA cB cicc co cxp cres copn cfv cr cA cB cicc co cabs cmin
      ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres eqid cabs cmin
      ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid remetba cR cioo
      crn ctg cfv cabs cmin ccom cr cr cxp cres copn cfv iccst.1 cabs cmin ccom
      cr cr cxp cres cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom cr
      cr cxp cres eqid cabs cmin ccom cr cr cxp cres copn cfv eqid tgioo eqtri
      cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres copn
      cfv eqid subtopmet eqcomd cabs cmin ccom cr cr cxp cres cabs cmin ccom cr
      cr cxp cres eqid remet cA cB iccssre sylancr 3eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J v $. $d A v $. $d B v $. $d C v $.
    icoopnst.1 $e |- J = ( Open ` ( ( abs o. - ) |`
                                    ( ( A [,] B ) X. ( A [,] B ) ) ) ) $.
    $( A half-open interval starting at ` A ` is open in the closed interval
       from ` A ` to ` B ` . $)
    icoopnst $p |- ( ( A e. RR /\ B e. RR ) ->
                                ( C e. ( A (,] B ) -> ( A [,) C ) e. J ) ) $=
      cA cr wcel cB cr wcel wa cC cA cB cioc co wcel cA cC cico co cJ wcel cA
      cr wcel cB cr wcel wa cC cA cB cioc co wcel wa cA cC cico co cA cB cicc
      co cioo crn ctg cfv cop csubsp cfv cJ cA cr wcel cB cr wcel wa cC cA cB
      cioc co wcel wa cA cC cico co vv cv cA cB cicc co cin wceq vv cioo crn
      ctg cfv wrex cA cC cico co cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      wcel cA c1 cmin co cC cioo co cioo crn ctg cfv wcel cA cC cico co cA c1
      cmin co cC cioo co cA cB cicc co cin wceq cA cC cico co vv cv cA cB cicc
      co cin wceq vv cioo crn ctg cfv wrex cA cr wcel cB cr wcel wa cC cA cB
      cioc co wcel wa cA cC cico co vv cv cA cB cicc co cin wceq cA cC cico co
      cA c1 cmin co cC cioo co cA cB cicc co cin wceq vv cA c1 cmin co cC cioo
      co cioo crn ctg cfv vv cv cA c1 cmin co cC cioo co wceq vv cv cA cB cicc
      co cin cA c1 cmin co cC cioo co cA cB cicc co cin cA cC cico co vv cv cA
      c1 cmin co cC cioo co cA cB cicc co ineq1 eqeq2d rcla4ev cA c1 cmin co cC
      iooretop cA cr wcel cB cr wcel wa cC cA cB cioc co wcel wa vv cA cC cico
      co cA c1 cmin co cC cioo co cA cB cicc co cin cA cr wcel cB cr wcel wa cC
      cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a
      vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a vv cv cr
      wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa vv cv cA cC cico co wcel vv
      cv cA c1 cmin co cC cioo co cA cB cicc co cin wcel cA cr wcel cB cr wcel
      wa cC cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt
      wbr w3a vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a vv
      cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa cA cr wcel cB cr wcel
      wa cC cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt
      wbr w3a vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a vv
      cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a cA cr wcel cB cr wcel wa
      cC cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr
      w3a vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr vv cv cr
      wcel cA vv cv cle wbr vv cv cC clt wbr w3a vv cv cr wcel wi cA cr wcel cB
      cr wcel wa cC cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv
      cC clt wbr 3simp1 a1i cA cr wcel vv cv cr wcel cA vv cv cle wbr vv cv cC
      clt wbr w3a cA c1 cmin co vv cv clt wbr wi cB cr wcel cC cA cB cioc co
      wcel cA cr wcel vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a cA c1
      cmin co vv cv clt wbr cA cr wcel vv cv cr wcel cA vv cv cle wbr cA c1
      cmin co vv cv clt wbr vv cv cC clt wbr cA cr wcel vv cv cr wcel cA vv cv
      cle wbr cA c1 cmin co vv cv clt wbr cA cr wcel vv cv cr wcel wa cA c1
      cmin co cA clt wbr cA vv cv cle wbr cA c1 cmin co vv cv clt wbr cA cr
      wcel cA c1 cmin co cA clt wbr vv cv cr wcel cA ltm1 adantr cA c1 cmin co
      cr wcel cA cr wcel vv cv cr wcel wa cA c1 cmin co cA clt wbr cA vv cv cle
      wbr wa cA c1 cmin co vv cv clt wbr wi cA cr wcel cA c1 cmin co cr wcel vv
      cv cr wcel cA peano2rem adantr cA c1 cmin co cr wcel cA cr wcel vv cv cr
      wcel cA c1 cmin co cA clt wbr cA vv cv cle wbr wa cA c1 cmin co vv cv clt
      wbr wi cA c1 cmin co cA vv cv ltletr 3expb mpancom mpand impr 3adantr3 ex
      ad2antrr vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a vv cv cC clt
      wbr wi cA cr wcel cB cr wcel wa cC cA cB cioc co wcel wa vv cv cr wcel cA
      vv cv cle wbr vv cv cC clt wbr 3simp3 a1i 3jcad cA cr wcel cB cr wcel wa
      cC cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr
      w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr vv cv cr wcel cA vv
      cv cle wbr vv cv cC clt wbr w3a vv cv cr wcel wi cA cr wcel cB cr wcel wa
      cC cA cB cioc co wcel wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr
      3simp1 a1i vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a cA vv cv
      cle wbr wi cA cr wcel cB cr wcel wa cC cA cB cioc co wcel wa vv cv cr
      wcel cA vv cv cle wbr vv cv cC clt wbr 3simp2 a1i cA cr wcel cB cr wcel
      wa cC cA cB cioc co wcel cC cr wcel cA cC clt wbr cC cB cle wbr w3a vv cv
      cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a vv cv cB cle wbr wi cA cr
      wcel cB cr wcel wa cC cA cB cioc co wcel cC cr wcel cA cC clt wbr cC cB
      cle wbr w3a cA cB cC elioc2 biimpa cB cr wcel cC cr wcel cA cC clt wbr cC
      cB cle wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a vv cv
      cB cle wbr wi cA cr wcel cB cr wcel cC cr wcel cC cB cle wbr vv cv cr
      wcel cA vv cv cle wbr vv cv cC clt wbr w3a vv cv cB cle wbr wi cA cC clt
      wbr cB cr wcel cC cr wcel cC cB cle wbr vv cv cr wcel cA vv cv cle wbr vv
      cv cC clt wbr w3a vv cv cB cle wbr wi cB cr wcel cC cr wcel wa cC cB cle
      wbr wa vv cv cr wcel cA vv cv cle wbr vv cv cC clt wbr w3a vv cv cB cle
      wbr cB cr wcel cC cr wcel wa cC cB cle wbr wa vv cv cr wcel vv cv cC clt
      wbr vv cv cB cle wbr cA vv cv cle wbr cB cr wcel cC cr wcel wa vv cv cr
      wcel cC cB cle wbr vv cv cC clt wbr vv cv cB cle wbr cB cr wcel cC cr
      wcel wa vv cv cr wcel wa vv cv cC clt wbr cC cB cle wbr vv cv cB cle wbr
      cB cr wcel cC cr wcel wa vv cv cr wcel wa vv cv cC clt wbr cC cB cle wbr
      wa vv cv cB cle wbr vv cv cr wcel cC cr wcel cB cr wcel vv cv cC clt wbr
      cC cB cle wbr wa vv cv cB cle wbr wi vv cv cr wcel cC cr wcel cB cr wcel
      vv cv cC clt wbr cC cB cle wbr wa vv cv cB cle wbr wi vv cv cr wcel cC cr
      wcel cB cr wcel w3a vv cv cC clt wbr cC cB cle wbr wa vv cv cB clt wbr vv
      cv cB cle wbr vv cv cC cB ltletr vv cv cr wcel cB cr wcel vv cv cB clt
      wbr vv cv cB cle wbr wi cC cr wcel vv cv cB ltle 3adant2 syld 3expa
      ancom31s imp ancom2s an4s 3adantr2 ex anasss 3adantr2 adantll syldan
      3jcad jcad vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a
      vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa vv cv cr wcel cA
      vv cv cle wbr vv cv cC clt wbr vv cv cr wcel cA vv cv cle wbr vv cv cB
      cle wbr w3a vv cv cr wcel vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv
      cC clt wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr 3simp1
      adantl vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a cA vv cv cle
      wbr vv cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a vv cv
      cr wcel cA vv cv cle wbr vv cv cB cle wbr 3simp2 adantl vv cv cr wcel cA
      c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a vv cv cC clt wbr vv cv cr
      wcel cA vv cv cle wbr vv cv cB cle wbr w3a vv cv cr wcel cA c1 cmin co vv
      cv clt wbr vv cv cC clt wbr 3simp3 adantr 3jca impbid1 cA cr wcel cC cr
      wcel vv cv cA cC cico co wcel vv cv cr wcel cA vv cv cle wbr vv cv cC clt
      wbr w3a wb cA cr wcel cB cr wcel wa cC cA cB cioc co wcel wa cA cC vv cv
      elico2 cA cr wcel cB cr wcel cC cA cB cioc co wcel simpll cA cr wcel cB
      cr wcel wa cC cA cB cioc co wcel wa cC cr wcel cA cC clt wbr cC cB cle
      wbr cA cr wcel cB cr wcel wa cC cA cB cioc co wcel cC cr wcel cA cC clt
      wbr cC cB cle wbr w3a cA cB cC elioc2 biimpa 3simp1d sylanc cA cr wcel cB
      cr wcel wa cC cA cB cioc co wcel wa vv cv cA c1 cmin co cC cioo co wcel
      vv cv cA cB cicc co wcel wa vv cv cr wcel cA c1 cmin co vv cv clt wbr vv
      cv cC clt wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa
      vv cv cA c1 cmin co cC cioo co cA cB cicc co cin wcel cA cr wcel cB cr
      wcel wa cC cA cB cioc co wcel wa vv cv cA c1 cmin co cC cioo co wcel vv
      cv cr wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a vv cv cA cB
      cicc co wcel vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a cA c1
      cmin co cxr wcel cC cxr wcel vv cv cA c1 cmin co cC cioo co wcel vv cv cr
      wcel cA c1 cmin co vv cv clt wbr vv cv cC clt wbr w3a wb cA cr wcel cB cr
      wcel wa cC cA cB cioc co wcel wa cA c1 cmin co cC vv cv elioo2 cA cr wcel
      cA c1 cmin co cxr wcel cB cr wcel cC cA cB cioc co wcel cA cr wcel cA c1
      cmin co cr wcel cA c1 cmin co cxr wcel cA peano2rem cA c1 cmin co rexr
      syl ad2antrr cA cr wcel cB cr wcel wa cC cA cB cioc co wcel wa cC cr wcel
      cC cxr wcel cA cr wcel cB cr wcel wa cC cA cB cioc co wcel wa cC cr wcel
      cA cC clt wbr cC cB cle wbr cA cr wcel cB cr wcel wa cC cA cB cioc co
      wcel cC cr wcel cA cC clt wbr cC cB cle wbr w3a cA cB cC elioc2 biimpa
      3simp1d cC rexr syl sylanc cA cr wcel cB cr wcel wa vv cv cA cB cicc co
      wcel vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wb cC cA cB cioc
      co wcel cA cB vv cv elicc2 adantr anbi12d vv cv cA c1 cmin co cC cioo co
      cA cB cicc co elin syl5bb 3bitr4d eqrdv sylancr cioo crn ctg cfv ctop
      wcel cA cC cico co cvv wcel cA cB cicc co cvv wcel cA cC cico co cA cB
      cicc co cioo crn ctg cfv cop csubsp cfv wcel cA cC cico co vv cv cA cB
      cicc co cin wceq vv cioo crn ctg cfv wrex wb retop cA cC cico oprex cA cB
      cicc oprex vv cA cC cico co cA cB cicc co cvv cioo crn ctg cfv issubspt
      mp3an sylibr cA cr wcel cB cr wcel wa cJ cA cB cicc co cioo crn ctg cfv
      cop csubsp cfv wceq cC cA cB cioc co wcel cA cB cioo crn ctg cfv cJ cioo
      crn ctg cfv eqid icoopnst.1 iccst adantr eleqtrrd ex $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J v $. $d A v $. $d B v $. $d C v $.
    iocopnst.1 $e |- J = ( Open ` ( ( abs o. - ) |`
                                    ( ( A [,] B ) X. ( A [,] B ) ) ) ) $.
    $( A half-open interval ending at ` B ` is open in the closed interval from
       ` A ` to ` B ` . $)
    iocopnst $p |- ( ( A e. RR /\ B e. RR ) ->
                                ( C e. ( A [,) B ) -> ( C (,] B ) e. J ) ) $=
      cA cr wcel cB cr wcel wa cC cA cB cico co wcel cC cB cioc co cJ wcel cA
      cr wcel cB cr wcel wa cC cA cB cico co wcel wa cC cB cioc co cA cB cicc
      co cioo crn ctg cfv cop csubsp cfv cJ cA cr wcel cB cr wcel wa cC cA cB
      cico co wcel wa cC cB cioc co vv cv cA cB cicc co cin wceq vv cioo crn
      ctg cfv wrex cC cB cioc co cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      wcel cC cB c1 caddc co cioo co cioo crn ctg cfv wcel cC cB cioc co cC cB
      c1 caddc co cioo co cA cB cicc co cin wceq cC cB cioc co vv cv cA cB cicc
      co cin wceq vv cioo crn ctg cfv wrex cA cr wcel cB cr wcel wa cC cA cB
      cico co wcel wa cC cB cioc co vv cv cA cB cicc co cin wceq cC cB cioc co
      cC cB c1 caddc co cioo co cA cB cicc co cin wceq vv cC cB c1 caddc co
      cioo co cioo crn ctg cfv vv cv cC cB c1 caddc co cioo co wceq vv cv cA cB
      cicc co cin cC cB c1 caddc co cioo co cA cB cicc co cin cC cB cioc co vv
      cv cC cB c1 caddc co cioo co cA cB cicc co ineq1 eqeq2d rcla4ev cC cB c1
      caddc co iooretop cA cr wcel cB cr wcel wa cC cA cB cico co wcel wa vv cC
      cB cioc co cC cB c1 caddc co cioo co cA cB cicc co cin cA cr wcel cB cr
      wcel wa cC cA cB cico co wcel wa vv cv cr wcel cC vv cv clt wbr vv cv cB
      cle wbr w3a vv cv cr wcel cC vv cv clt wbr vv cv cB c1 caddc co clt wbr
      w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa vv cv cC cB
      cioc co wcel vv cv cC cB c1 caddc co cioo co cA cB cicc co cin wcel cA cr
      wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel cC vv cv clt
      wbr vv cv cB cle wbr w3a vv cv cr wcel cC vv cv clt wbr vv cv cB c1 caddc
      co clt wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa cA
      cr wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel cC vv cv clt
      wbr vv cv cB cle wbr w3a vv cv cr wcel cC vv cv clt wbr vv cv cB c1 caddc
      co clt wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a cA cr
      wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel cC vv cv clt
      wbr vv cv cB cle wbr w3a vv cv cr wcel cC vv cv clt wbr vv cv cB c1 caddc
      co clt wbr vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a vv cv cr
      wcel wi cA cr wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel
      cC vv cv clt wbr vv cv cB cle wbr 3simp1 a1i vv cv cr wcel cC vv cv clt
      wbr vv cv cB cle wbr w3a cC vv cv clt wbr wi cA cr wcel cB cr wcel wa cC
      cA cB cico co wcel wa vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr
      3simp2 a1i cB cr wcel vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a
      vv cv cB c1 caddc co clt wbr wi cA cr wcel cC cA cB cico co wcel cB cr
      wcel vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a vv cv cB c1
      caddc co clt wbr cB cr wcel vv cv cr wcel vv cv cB cle wbr vv cv cB c1
      caddc co clt wbr cC vv cv clt wbr cB cr wcel vv cv cr wcel vv cv cB cle
      wbr vv cv cB c1 caddc co clt wbr cB cr wcel vv cv cr wcel wa cB cB c1
      caddc co clt wbr vv cv cB cle wbr vv cv cB c1 caddc co clt wbr cB cr wcel
      cB cB c1 caddc co clt wbr vv cv cr wcel cB ltp1 adantr cB cr wcel vv cv
      cr wcel wa cB c1 caddc co cr wcel cB cB c1 caddc co clt wbr vv cv cB cle
      wbr wa vv cv cB c1 caddc co clt wbr wi cB cr wcel cB c1 caddc co cr wcel
      vv cv cr wcel cB peano2re adantr cB cr wcel vv cv cr wcel wa cB c1 caddc
      co cr wcel wa vv cv cB cle wbr cB cB c1 caddc co clt wbr vv cv cB c1
      caddc co clt wbr vv cv cr wcel cB cr wcel cB c1 caddc co cr wcel vv cv cB
      cle wbr cB cB c1 caddc co clt wbr wa vv cv cB c1 caddc co clt wbr wi vv
      cv cr wcel cB cr wcel cB c1 caddc co cr wcel vv cv cB cle wbr cB cB c1
      caddc co clt wbr wa vv cv cB c1 caddc co clt wbr wi vv cv cB cB c1 caddc
      co lelttr 3expa ancom1s ancomsd mpdan mpand impr 3adantr2 ex ad2antlr
      3jcad cA cr wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel cC
      vv cv clt wbr vv cv cB cle wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv
      cB cle wbr vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a vv cv cr
      wcel wi cA cr wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel
      cC vv cv clt wbr vv cv cB cle wbr 3simp1 a1i cA cr wcel cB cr wcel wa cC
      cA cB cico co wcel cC cr wcel cA cC cle wbr cC cB clt wbr w3a vv cv cr
      wcel cC vv cv clt wbr vv cv cB cle wbr w3a cA vv cv cle wbr wi cA cr wcel
      cB cr wcel wa cC cA cB cico co wcel cC cr wcel cA cC cle wbr cC cB clt
      wbr w3a cA cB cC elico2 biimpa cA cr wcel cC cr wcel cA cC cle wbr cC cB
      clt wbr w3a vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a cA vv cv
      cle wbr wi cB cr wcel cA cr wcel cC cr wcel cA cC cle wbr vv cv cr wcel
      cC vv cv clt wbr vv cv cB cle wbr w3a cA vv cv cle wbr wi cC cB clt wbr
      cA cr wcel cC cr wcel cA cC cle wbr vv cv cr wcel cC vv cv clt wbr vv cv
      cB cle wbr w3a cA vv cv cle wbr wi cA cr wcel cC cr wcel wa cA cC cle wbr
      wa vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a cA vv cv cle wbr
      cA cr wcel cC cr wcel wa cA cC cle wbr wa vv cv cr wcel cC vv cv clt wbr
      cA vv cv cle wbr vv cv cB cle wbr cA cr wcel cC cr wcel wa vv cv cr wcel
      cA cC cle wbr cC vv cv clt wbr cA vv cv cle wbr cA cr wcel cC cr wcel wa
      vv cv cr wcel wa cA cC cle wbr cC vv cv clt wbr wa cA vv cv cle wbr cA cr
      wcel cC cr wcel vv cv cr wcel cA cC cle wbr cC vv cv clt wbr wa cA vv cv
      cle wbr wi cA cr wcel cC cr wcel vv cv cr wcel w3a cA cC cle wbr cC vv cv
      clt wbr wa cA vv cv clt wbr cA vv cv cle wbr cA cC vv cv lelttr cA cr
      wcel vv cv cr wcel cA vv cv clt wbr cA vv cv cle wbr wi cC cr wcel cA vv
      cv ltle 3adant2 syld 3expa imp an4s 3adantr3 ex anasss 3adantr3 adantlr
      syldan vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a vv cv cB cle
      wbr wi cA cr wcel cB cr wcel wa cC cA cB cico co wcel wa vv cv cr wcel cC
      vv cv clt wbr vv cv cB cle wbr 3simp3 a1i 3jcad jcad vv cv cr wcel cC vv
      cv clt wbr vv cv cB c1 caddc co clt wbr w3a vv cv cr wcel cA vv cv cle
      wbr vv cv cB cle wbr w3a wa vv cv cr wcel cC vv cv clt wbr vv cv cB cle
      wbr vv cv cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a vv cv cr wcel vv
      cv cr wcel cC vv cv clt wbr vv cv cB c1 caddc co clt wbr w3a vv cv cr
      wcel cA vv cv cle wbr vv cv cB cle wbr 3simp1 adantl vv cv cr wcel cC vv
      cv clt wbr vv cv cB c1 caddc co clt wbr w3a cC vv cv clt wbr vv cv cr
      wcel cA vv cv cle wbr vv cv cB cle wbr w3a vv cv cr wcel cC vv cv clt wbr
      vv cv cB c1 caddc co clt wbr 3simp2 adantr vv cv cr wcel cA vv cv cle wbr
      vv cv cB cle wbr w3a vv cv cB cle wbr vv cv cr wcel cC vv cv clt wbr vv
      cv cB c1 caddc co clt wbr w3a vv cv cr wcel cA vv cv cle wbr vv cv cB cle
      wbr 3simp3 adantl 3jca impbid1 cC cr wcel cB cr wcel vv cv cC cB cioc co
      wcel vv cv cr wcel cC vv cv clt wbr vv cv cB cle wbr w3a wb cA cr wcel cB
      cr wcel wa cC cA cB cico co wcel wa cC cB vv cv elioc2 cA cr wcel cB cr
      wcel wa cC cA cB cico co wcel wa cC cr wcel cA cC cle wbr cC cB clt wbr
      cA cr wcel cB cr wcel wa cC cA cB cico co wcel cC cr wcel cA cC cle wbr
      cC cB clt wbr w3a cA cB cC elico2 biimpa 3simp1d cA cr wcel cB cr wcel cC
      cA cB cico co wcel simplr sylanc cA cr wcel cB cr wcel wa cC cA cB cico
      co wcel wa vv cv cC cB c1 caddc co cioo co wcel vv cv cA cB cicc co wcel
      wa vv cv cr wcel cC vv cv clt wbr vv cv cB c1 caddc co clt wbr w3a vv cv
      cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wa vv cv cC cB c1 caddc co
      cioo co cA cB cicc co cin wcel cA cr wcel cB cr wcel wa cC cA cB cico co
      wcel wa vv cv cC cB c1 caddc co cioo co wcel vv cv cr wcel cC vv cv clt
      wbr vv cv cB c1 caddc co clt wbr w3a vv cv cA cB cicc co wcel vv cv cr
      wcel cA vv cv cle wbr vv cv cB cle wbr w3a cC cxr wcel cB c1 caddc co cxr
      wcel vv cv cC cB c1 caddc co cioo co wcel vv cv cr wcel cC vv cv clt wbr
      vv cv cB c1 caddc co clt wbr w3a wb cA cr wcel cB cr wcel wa cC cA cB
      cico co wcel wa cC cB c1 caddc co vv cv elioo2 cA cr wcel cB cr wcel wa
      cC cA cB cico co wcel wa cC cr wcel cC cxr wcel cA cr wcel cB cr wcel wa
      cC cA cB cico co wcel wa cC cr wcel cA cC cle wbr cC cB clt wbr cA cr
      wcel cB cr wcel wa cC cA cB cico co wcel cC cr wcel cA cC cle wbr cC cB
      clt wbr w3a cA cB cC elico2 biimpa 3simp1d cC rexr syl cB cr wcel cB c1
      caddc co cxr wcel cA cr wcel cC cA cB cico co wcel cB cr wcel cB c1 caddc
      co cr wcel cB c1 caddc co cxr wcel cB peano2re cB c1 caddc co rexr syl
      ad2antlr sylanc cA cr wcel cB cr wcel wa vv cv cA cB cicc co wcel vv cv
      cr wcel cA vv cv cle wbr vv cv cB cle wbr w3a wb cC cA cB cico co wcel cA
      cB vv cv elicc2 adantr anbi12d vv cv cC cB c1 caddc co cioo co cA cB cicc
      co elin syl5bb 3bitr4d eqrdv sylancr cioo crn ctg cfv ctop wcel cC cB
      cioc co cvv wcel cA cB cicc co cvv wcel cC cB cioc co cA cB cicc co cioo
      crn ctg cfv cop csubsp cfv wcel cC cB cioc co vv cv cA cB cicc co cin
      wceq vv cioo crn ctg cfv wrex wb retop cC cB cioc oprex cA cB cicc oprex
      vv cC cB cioc co cA cB cicc co cvv cioo crn ctg cfv issubspt mp3an sylibr
      cA cr wcel cB cr wcel wa cJ cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      wceq cC cA cB cico co wcel cA cB cioo crn ctg cfv cJ cioo crn ctg cfv
      eqid iocopnst.1 iccst adantr eleqtrrd ex $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( A linear combination of two reals which lies in the interval
    between them. $)
    lincmb01cmp $p |- ( ( ( A e. RR /\ B e. RR /\ A < B ) /\ T e. ( 0 [,] 1 ) )
                    -> ( ( ( 1 - T ) x. A ) + ( T x. B ) ) e. ( A [,] B ) ) $=
      cA cr wcel cB cr wcel cA cB clt wbr w3a cT cc0 c1 cicc co wcel wa c1 cT
      cmin co cA cmul co cT cB cmul co caddc co cT cB cA cmin co cmul co cA
      caddc co cA cB cicc co cA cr wcel cB cr wcel cT cc0 c1 cicc co wcel c1 cT
      cmin co cA cmul co cT cB cmul co caddc co cT cB cA cmin co cmul co cA
      caddc co wceq cA cB clt wbr cA cc wcel cB cc wcel wa cT cc wcel c1 cT
      cmin co cA cmul co cT cB cmul co caddc co cT cB cA cmin co cmul co cA
      caddc co wceq cA cr wcel cB cr wcel wa cT cc0 c1 cicc co wcel cA cc wcel
      cB cc wcel wa cT cc wcel wa c1 cT cmin co cA cmul co cT cB cmul co caddc
      co cA cT cA cmul co cmin co cT cB cmul co caddc co cA cT cB cmul co cT cA
      cmul co cmin co caddc co cT cB cA cmin co cmul co cA caddc co cA cc wcel
      cT cc wcel c1 cT cmin co cA cmul co cT cB cmul co caddc co cA cT cA cmul
      co cmin co cT cB cmul co caddc co wceq cB cc wcel cA cc wcel cT cc wcel
      wa c1 cT cmin co cA cmul co cA cT cA cmul co cmin co cT cB cmul co caddc
      cA cc wcel cT cc wcel wa c1 cT cmin co cA cmul co c1 cA cmul co cT cA
      cmul co cmin co cA cT cA cmul co cmin co cT cc wcel cA cc wcel c1 cT cmin
      co cA cmul co c1 cA cmul co cT cA cmul co cmin co wceq c1 cc wcel cT cc
      wcel cA cc wcel c1 cT cmin co cA cmul co c1 cA cmul co cT cA cmul co cmin
      co wceq ax1cn c1 cT cA subdir mp3an1 ancoms cA cc wcel cT cc wcel wa c1
      cA cmul co cA cT cA cmul co cmin cA cc wcel c1 cA cmul co cA wceq cT cc
      wcel cA mulid2 adantr opreq1d eqtrd opreq1d adantlr cA cc wcel cT cA cmul
      co cc wcel cT cB cmul co cc wcel cA cT cA cmul co cmin co cT cB cmul co
      caddc co cA cT cB cmul co cT cA cmul co cmin co caddc co wceq cA cc wcel
      cB cc wcel wa cT cc wcel wa cA cT cA cmul co cT cB cmul co subadd23 cA cc
      wcel cB cc wcel cT cc wcel simpll cA cc wcel cT cc wcel cT cA cmul co cc
      wcel cB cc wcel cT cc wcel cA cc wcel cT cA cmul co cc wcel cT cA axmulcl
      ancoms adantlr cB cc wcel cT cc wcel cT cB cmul co cc wcel cA cc wcel cT
      cc wcel cB cc wcel cT cB cmul co cc wcel cT cB axmulcl ancoms adantll
      syl3anc cA cc wcel cB cc wcel wa cT cc wcel wa cA cT cB cmul co cT cA
      cmul co cmin co caddc co cA cT cB cA cmin co cmul co caddc co cT cB cA
      cmin co cmul co cA caddc co cA cc wcel cB cc wcel wa cT cc wcel wa cT cB
      cmul co cT cA cmul co cmin co cT cB cA cmin co cmul co cA caddc cA cc
      wcel cB cc wcel wa cT cc wcel wa cT cB cA cmin co cmul co cT cB cmul co
      cT cA cmul co cmin co cT cc wcel cA cc wcel cB cc wcel wa cT cB cA cmin
      co cmul co cT cB cmul co cT cA cmul co cmin co wceq cT cc wcel cB cc wcel
      cA cc wcel cT cB cA cmin co cmul co cT cB cmul co cT cA cmul co cmin co
      wceq cT cc wcel cB cc wcel cA cc wcel cT cB cA cmin co cmul co cT cB cmul
      co cT cA cmul co cmin co wceq cT cB cA subdi 3expb ancom2s ancoms eqcomd
      opreq2d cA cc wcel cT cB cA cmin co cmul co cc wcel cA cT cB cA cmin co
      cmul co caddc co cT cB cA cmin co cmul co cA caddc co wceq cA cc wcel cB
      cc wcel wa cT cc wcel wa cA cT cB cA cmin co cmul co addcom cA cc wcel cB
      cc wcel cT cc wcel simpll cT cc wcel cA cc wcel cB cc wcel wa cT cB cA
      cmin co cmul co cc wcel cT cc wcel cB cA cmin co cc wcel cT cB cA cmin co
      cmul co cc wcel cA cc wcel cB cc wcel wa cT cB cA cmin co mulcl cB cc
      wcel cA cc wcel cB cA cmin co cc wcel cB cA subcl ancoms sylan2 ancoms
      sylanc eqtrd 3eqtrd cA cr wcel cA cc wcel cB cr wcel cB cc wcel cA recn
      cB recn anim12i cT cc0 c1 cicc co wcel cT cc0 c1 cicc co cr cT cc0 cr
      wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an sseli
      recnd syl2an 3adantl3 cA cr wcel cB cr wcel cA cB clt wbr w3a cT cc0 c1
      cicc co wcel wa cT cB cA cmin co cmul co cA caddc co cc0 cA caddc co cB
      cA cmin co cA caddc co cicc co cA cB cicc co cA cr wcel cB cr wcel cA cB
      clt wbr w3a cT cc0 c1 cicc co wcel wa cT cB cA cmin co cmul co cc0 cB cA
      cmin co cicc co wcel cT cB cA cmin co cmul co cA caddc co cc0 cA caddc co
      cB cA cmin co cA caddc co cicc co wcel cA cr wcel cB cr wcel cA cB clt
      wbr w3a cT cc0 c1 cicc co wcel wa cT cB cA cmin co cmul co cc0 cB cA cmin
      co cmul co c1 cB cA cmin co cmul co cicc co cc0 cB cA cmin co cicc co cA
      cr wcel cB cr wcel cA cB clt wbr w3a cT cc0 c1 cicc co wcel wa cT cr wcel
      cT cB cA cmin co cmul co cc0 cB cA cmin co cmul co c1 cB cA cmin co cmul
      co cicc co wcel cT cc0 c1 cicc co wcel cT cr wcel cA cr wcel cB cr wcel
      cA cB clt wbr w3a cc0 c1 cicc co cr cT cc0 cr wcel c1 cr wcel cc0 c1 cicc
      co cr wss 0re 1re cc0 c1 iccssre mp2an sseli adantl cA cr wcel cB cr wcel
      cA cB clt wbr w3a cT cr wcel cT cc0 c1 cicc co wcel cT cB cA cmin co cmul
      co cc0 cB cA cmin co cmul co c1 cB cA cmin co cmul co cicc co wcel cA cr
      wcel cB cr wcel cA cB clt wbr w3a cT cr wcel wa cT cc0 c1 cicc co wcel cT
      cB cA cmin co cmul co cc0 cB cA cmin co cmul co c1 cB cA cmin co cmul co
      cicc co wcel cT cr wcel cA cr wcel cB cr wcel cA cB clt wbr w3a cT cc0 c1
      cicc co wcel cT cB cA cmin co cmul co cc0 cB cA cmin co cmul co c1 cB cA
      cmin co cmul co cicc co wcel wb cT cr wcel cB cA cmin co crp wcel cT cc0
      c1 cicc co wcel cT cB cA cmin co cmul co cc0 cB cA cmin co cmul co c1 cB
      cA cmin co cmul co cicc co wcel wb cA cr wcel cB cr wcel cA cB clt wbr
      w3a cc0 cr wcel c1 cr wcel cT cr wcel cB cA cmin co crp wcel wa cT cc0 c1
      cicc co wcel cT cB cA cmin co cmul co cc0 cB cA cmin co cmul co c1 cB cA
      cmin co cmul co cicc co wcel wb 0re 1re cc0 c1 cc0 cB cA cmin co cmul co
      c1 cB cA cmin co cmul co cB cA cmin co cT cc0 cB cA cmin co cmul co eqid
      c1 cB cA cmin co cmul co eqid iccdil mpanl12 cB cA cmin co crp wcel cB cA
      cmin co cr wcel cc0 cB cA cmin co clt wbr cA cr wcel cB cr wcel cA cB clt
      wbr w3a cB cA cmin co elrp cA cr wcel cB cr wcel cB cA cmin co cr wcel cA
      cB clt wbr cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl
      ancoms 3adant3 cA cr wcel cB cr wcel cA cB clt wbr cc0 cB cA cmin co clt
      wbr cA cB posdif biimp3a sylanbrc sylan2 ancoms biimpa an1rs mpdan cA cr
      wcel cB cr wcel cA cB clt wbr w3a cc0 cB cA cmin co cmul co c1 cB cA cmin
      co cmul co cicc co cc0 cB cA cmin co cicc co wceq cT cc0 c1 cicc co wcel
      cA cr wcel cB cr wcel cc0 cB cA cmin co cmul co c1 cB cA cmin co cmul co
      cicc co cc0 cB cA cmin co cicc co wceq cA cB clt wbr cA cr wcel cB cr
      wcel wa cB cA cmin co cc wcel cc0 cB cA cmin co cmul co c1 cB cA cmin co
      cmul co cicc co cc0 cB cA cmin co cicc co wceq cA cr wcel cB cr wcel wa
      cB cA cmin co cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl
      ancoms recnd cB cA cmin co cc wcel cc0 cB cA cmin co cmul co cc0 c1 cB cA
      cmin co cmul co cB cA cmin co cicc cB cA cmin co mul02 cB cA cmin co
      mulid2 opreq12d syl 3adant3 adantr eleqtrd cA cr wcel cB cr wcel cT cc0
      c1 cicc co wcel cT cB cA cmin co cmul co cc0 cB cA cmin co cicc co wcel
      cT cB cA cmin co cmul co cA caddc co cc0 cA caddc co cB cA cmin co cA
      caddc co cicc co wcel wb cA cB clt wbr cc0 cr wcel cB cA cmin co cr wcel
      cT cB cA cmin co cmul co cr wcel cA cr wcel cT cB cA cmin co cmul co cc0
      cB cA cmin co cicc co wcel cT cB cA cmin co cmul co cA caddc co cc0 cA
      caddc co cB cA cmin co cA caddc co cicc co wcel wb cA cr wcel cB cr wcel
      wa cT cc0 c1 cicc co wcel wa cc0 cB cA cmin co cc0 cA caddc co cB cA cmin
      co cA caddc co cA cT cB cA cmin co cmul co cc0 cA caddc co eqid cB cA
      cmin co cA caddc co eqid iccshftr cc0 cr wcel cA cr wcel cB cr wcel wa cT
      cc0 c1 cicc co wcel wa 0re a1i cA cr wcel cB cr wcel wa cB cA cmin co cr
      wcel cT cc0 c1 cicc co wcel cB cr wcel cA cr wcel cB cA cmin co cr wcel
      cB cA resubcl ancoms adantr cT cc0 c1 cicc co wcel cA cr wcel cB cr wcel
      wa cT cB cA cmin co cmul co cr wcel cT cr wcel cB cA cmin co cr wcel cT
      cB cA cmin co cmul co cr wcel cT cc0 c1 cicc co wcel cA cr wcel cB cr
      wcel wa cT cB cA cmin co remulcl cc0 c1 cicc co cr cT cc0 cr wcel c1 cr
      wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an sseli cB cr wcel
      cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms syl2an ancoms cA cr
      wcel cB cr wcel cT cc0 c1 cicc co wcel simpll syl2anc 3adantl3 mpbid cA
      cr wcel cB cr wcel cA cB clt wbr w3a cc0 cA caddc co cB cA cmin co cA
      caddc co cicc co cA cB cicc co wceq cT cc0 c1 cicc co wcel cA cr wcel cB
      cr wcel cc0 cA caddc co cB cA cmin co cA caddc co cicc co cA cB cicc co
      wceq cA cB clt wbr cA cr wcel cB cr wcel wa cc0 cA caddc co cA cB cA cmin
      co cA caddc co cB cicc cA cr wcel cc0 cA caddc co cA wceq cB cr wcel cA
      cr wcel cA cc wcel cc0 cA caddc co cA wceq cA recn cA addid2 syl adantr
      cB cr wcel cA cr wcel cB cA cmin co cA caddc co cB wceq cB cc wcel cA cc
      wcel cB cA cmin co cA caddc co cB wceq cB cr wcel cA cr wcel cB cA npcan
      cB recn cA recn syl2an ancoms opreq12d 3adant3 adantr eleqtrd eqeltrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( A linear combination of two reals which lies in the interval
    between them. $)
    lincmb01icc $p |- ( ( A e. RR /\ B e. RR ) ->
              ( ( C e. ( A [,] B ) /\ D e. ( A [,] B ) /\ T e. ( 0 [,] 1 ) ) ->
                     ( ( ( 1 - T ) x. C ) + ( T x. D ) ) e. ( A [,] B ) ) ) $=
      cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel cT
      cc0 c1 cicc co wcel w3a c1 cT cmin co cC cmul co cT cD cmul co caddc co
      cA cB cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA
      cB cicc co wcel cT cc0 c1 cicc co wcel w3a wa cC cD clt wbr cC cD wceq cD
      cC clt wbr w3o c1 cT cmin co cC cmul co cT cD cmul co caddc co cA cB cicc
      co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co
      wcel cC cD clt wbr cC cD wceq cD cC clt wbr w3o cT cc0 c1 cicc co wcel cC
      cr wcel cD cr wcel cC cD clt wbr cC cD wceq cD cC clt wbr w3o cA cr wcel
      cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel wa wa cC cD
      lttri4 cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cC cr wcel cD cA cB
      cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cC cr wcel cA
      cr wcel cB cr wcel wa cA cB cicc co cr cC cA cB iccssre sseld imp adantrr
      cA cr wcel cB cr wcel wa cD cA cB cicc co wcel cD cr wcel cC cA cB cicc
      co wcel cA cr wcel cB cr wcel wa cD cA cB cicc co wcel cD cr wcel cA cr
      wcel cB cr wcel wa cA cB cicc co cr cD cA cB iccssre sseld imp adantrl
      sylanc 3adantr3 cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB
      cicc co wcel cT cc0 c1 cicc co wcel w3a wa cC cD clt wbr c1 cT cmin co cC
      cmul co cT cD cmul co caddc co cA cB cicc co wcel cC cD wceq cD cC clt
      wbr cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel
      cT cc0 c1 cicc co wcel w3a wa cC cD clt wbr wa cC cD cicc co cA cB cicc
      co c1 cT cmin co cC cmul co cT cD cmul co caddc co cA cr wcel cB cr wcel
      wa cC cA cB cicc co wcel cD cA cB cicc co wcel cT cc0 c1 cicc co wcel w3a
      wa cC cD cicc co cA cB cicc co wss cC cD clt wbr cA cr wcel cB cr wcel wa
      cC cA cB cicc co wcel cD cA cB cicc co wcel cC cD cicc co cA cB cicc co
      wss cT cc0 c1 cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel
      cD cA cB cicc co wcel wa cC cD cicc co cA cB cicc co wss cA cB cC cD
      iccss2 imp 3adantr3 adantr cC cr wcel cD cr wcel wa cT cc0 c1 cicc co
      wcel wa cC cD clt wbr c1 cT cmin co cC cmul co cT cD cmul co caddc co cC
      cD cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB
      cicc co wcel cT cc0 c1 cicc co wcel w3a wa cC cr wcel cD cr wcel wa cC cD
      clt wbr cT cc0 c1 cicc co wcel c1 cT cmin co cC cmul co cT cD cmul co
      caddc co cC cD cicc co wcel cC cr wcel cD cr wcel wa cC cD clt wbr wa cT
      cc0 c1 cicc co wcel c1 cT cmin co cC cmul co cT cD cmul co caddc co cC cD
      cicc co wcel cC cr wcel cD cr wcel cC cD clt wbr cT cc0 c1 cicc co wcel
      c1 cT cmin co cC cmul co cT cD cmul co caddc co cC cD cicc co wcel wi cC
      cr wcel cD cr wcel cC cD clt wbr w3a cT cc0 c1 cicc co wcel c1 cT cmin co
      cC cmul co cT cD cmul co caddc co cC cD cicc co wcel cC cD cT lincmb01cmp
      ex 3expa imp an1rs cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA
      cB cicc co wcel cT cc0 c1 cicc co wcel w3a wa cC cr wcel cD cr wcel wa cT
      cc0 c1 cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA
      cB cicc co wcel cC cr wcel cD cr wcel wa cT cc0 c1 cicc co wcel cA cr
      wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel wa wa cC
      cr wcel cD cr wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cC cr
      wcel cD cA cB cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel
      cC cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr cC cA cB iccssre
      sseld imp adantrr cA cr wcel cB cr wcel wa cD cA cB cicc co wcel cD cr
      wcel cC cA cB cicc co wcel cA cr wcel cB cr wcel wa cD cA cB cicc co wcel
      cD cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr cD cA cB iccssre
      sseld imp adantrl jca 3adantr3 cC cA cB cicc co wcel cD cA cB cicc co
      wcel cT cc0 c1 cicc co wcel w3a cT cc0 c1 cicc co wcel cA cr wcel cB cr
      wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel cT cc0 c1 cicc co
      wcel 3simp3 adantl jca sylan sseldd cA cr wcel cB cr wcel wa cC cA cB
      cicc co wcel cD cA cB cicc co wcel cT cc0 c1 cicc co wcel w3a wa cC cD
      wceq wa c1 cT cmin co cC cmul co cT cD cmul co caddc co cD cA cB cicc co
      cC cD wceq cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc
      co wcel cT cc0 c1 cicc co wcel w3a wa c1 cT cmin co cC cmul co cT cD cmul
      co caddc co c1 cT cmin co cD cmul co cT cD cmul co caddc co cD cC cD wceq
      c1 cT cmin co cC cmul co c1 cT cmin co cD cmul co cT cD cmul co caddc cC
      cD c1 cT cmin co cmul opreq2 opreq1d cA cr wcel cB cr wcel wa cD cA cB
      cicc co wcel cT cc0 c1 cicc co wcel c1 cT cmin co cD cmul co cT cD cmul
      co caddc co cD wceq cC cA cB cicc co wcel cT cc wcel cD cc wcel c1 cT
      cmin co cD cmul co cT cD cmul co caddc co cD wceq cA cr wcel cB cr wcel
      wa cD cA cB cicc co wcel cT cc0 c1 cicc co wcel wa wa cT cc wcel cD cc
      wcel wa c1 cT cmin co cT caddc co cD cmul co c1 cD cmul co c1 cT cmin co
      cD cmul co cT cD cmul co caddc co cD cT cc wcel cD cc wcel wa c1 cT cmin
      co cT caddc co c1 cD cmul cT cc wcel c1 cT cmin co cT caddc co c1 wceq cD
      cc wcel c1 cc wcel cT cc wcel c1 cT cmin co cT caddc co c1 wceq ax1cn c1
      cT npcan mpan adantr opreq1d c1 cT cmin co cc wcel cT cc wcel wa cD cc
      wcel c1 cT cmin co cT caddc co cD cmul co c1 cT cmin co cD cmul co cT cD
      cmul co caddc co wceq cT cc wcel c1 cT cmin co cc wcel cT cc wcel cD cc
      wcel c1 cT cmin co cT caddc co cD cmul co c1 cT cmin co cD cmul co cT cD
      cmul co caddc co wceq c1 cT cmin co cT cD adddir 3expa cT cc wcel c1 cT
      cmin co cc wcel c1 cc wcel cT cc wcel c1 cT cmin co cc wcel ax1cn c1 cT
      subcl mpan ancri sylan cD cc wcel c1 cD cmul co cD wceq cT cc wcel cD
      mulid2 adantl 3eqtr3d cT cc0 c1 cicc co wcel cT cc wcel cA cr wcel cB cr
      wcel wa cD cA cB cicc co wcel cT cc0 c1 cicc co wcel cT cc0 c1 cicc co cr
      cT cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre
      mp2an sseli recnd ad2antll cA cr wcel cB cr wcel wa cD cA cB cicc co wcel
      cD cc wcel cT cc0 c1 cicc co wcel cA cr wcel cB cr wcel wa cD cA cB cicc
      co wcel wa cD cA cr wcel cB cr wcel wa cD cA cB cicc co wcel cD cr wcel
      cA cr wcel cB cr wcel wa cA cB cicc co cr cD cA cB iccssre sseld imp
      recnd adantrr sylanc 3adantr1 sylan9eqr cC cA cB cicc co wcel cD cA cB
      cicc co wcel cT cc0 c1 cicc co wcel w3a cD cA cB cicc co wcel cA cr wcel
      cB cr wcel wa cC cD wceq cC cA cB cicc co wcel cD cA cB cicc co wcel cT
      cc0 c1 cicc co wcel 3simp2 ad2antlr eqeltrd cA cr wcel cB cr wcel wa cC
      cA cB cicc co wcel cD cA cB cicc co wcel cT cc0 c1 cicc co wcel w3a wa cD
      cC clt wbr wa cD cC cicc co cA cB cicc co c1 cT cmin co cC cmul co cT cD
      cmul co caddc co cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB
      cicc co wcel cT cc0 c1 cicc co wcel w3a wa cD cC cicc co cA cB cicc co
      wss cD cC clt wbr cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB
      cicc co wcel cD cC cicc co cA cB cicc co wss cT cc0 c1 cicc co wcel cA cr
      wcel cB cr wcel wa cD cA cB cicc co wcel cC cA cB cicc co wcel cD cC cicc
      co cA cB cicc co wss cA cr wcel cB cr wcel wa cD cA cB cicc co wcel cC cA
      cB cicc co wcel wa cD cC cicc co cA cB cicc co wss cA cB cD cC iccss2 imp
      ancom2s 3adantr3 adantr cD cr wcel cC cr wcel wa cT cc0 c1 cicc co wcel
      wa cD cC clt wbr c1 cT cmin co cC cmul co cT cD cmul co caddc co cD cC
      cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc
      co wcel cT cc0 c1 cicc co wcel w3a wa cD cr wcel cC cr wcel wa cD cC clt
      wbr cT cc0 c1 cicc co wcel c1 cT cmin co cC cmul co cT cD cmul co caddc
      co cD cC cicc co wcel cD cr wcel cC cr wcel wa cD cC clt wbr wa cT cc0 c1
      cicc co wcel c1 cT cmin co cC cmul co cT cD cmul co caddc co cD cC cicc
      co wcel cD cr wcel cC cr wcel cD cC clt wbr cT cc0 c1 cicc co wcel c1 cT
      cmin co cC cmul co cT cD cmul co caddc co cD cC cicc co wcel wi cD cr
      wcel cC cr wcel cD cC clt wbr w3a cT cc0 c1 cicc co wcel c1 cT cmin co cC
      cmul co cT cD cmul co caddc co cD cC cicc co wcel cD cr wcel cC cr wcel
      cD cC clt wbr w3a cT cc0 c1 cicc co wcel wa c1 cT cmin co cC cmul co cT
      cD cmul co caddc co c1 c1 cT cmin co cmin co cD cmul co c1 cT cmin co cC
      cmul co caddc co cD cC cicc co cD cr wcel cC cr wcel cD cC clt wbr w3a cT
      cc0 c1 cicc co wcel wa c1 cT cmin co cC cmul co cT cD cmul co caddc co cT
      cD cmul co c1 cT cmin co cC cmul co caddc co c1 c1 cT cmin co cmin co cD
      cmul co c1 cT cmin co cC cmul co caddc co cD cr wcel cC cr wcel cT cc0 c1
      cicc co wcel c1 cT cmin co cC cmul co cT cD cmul co caddc co cT cD cmul
      co c1 cT cmin co cC cmul co caddc co wceq cD cC clt wbr c1 cT cmin co cC
      cmul co cc wcel cT cD cmul co cc wcel c1 cT cmin co cC cmul co cT cD cmul
      co caddc co cT cD cmul co c1 cT cmin co cC cmul co caddc co wceq cD cr
      wcel cC cr wcel wa cT cc0 c1 cicc co wcel wa c1 cT cmin co cC cmul co cT
      cD cmul co addcom cC cr wcel cT cc0 c1 cicc co wcel c1 cT cmin co cC cmul
      co cc wcel cD cr wcel cT cc0 c1 cicc co wcel cC cr wcel c1 cT cmin co cC
      cmul co cc wcel c1 cT cmin co cc wcel cC cc wcel c1 cT cmin co cC cmul co
      cc wcel cT cc0 c1 cicc co wcel cC cr wcel c1 cT cmin co cC mulcl cT cc0
      c1 cicc co wcel c1 cT cmin co cT cc0 c1 cicc co wcel c1 cT cmin co cc0 c1
      cicc co wcel c1 cT cmin co cr wcel cT iirev cc0 c1 cicc co cr c1 cT cmin
      co cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre
      mp2an sseli syl recnd cC recn syl2an ancoms adantll cD cr wcel cT cc0 c1
      cicc co wcel cT cD cmul co cc wcel cC cr wcel cT cc0 c1 cicc co wcel cD
      cr wcel cT cD cmul co cc wcel cT cc wcel cD cc wcel cT cD cmul co cc wcel
      cT cc0 c1 cicc co wcel cD cr wcel cT cD mulcl cT cc0 c1 cicc co wcel cT
      cc0 c1 cicc co cr cT cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re
      cc0 c1 iccssre mp2an sseli recnd cD recn syl2an ancoms adantlr sylanc
      3adantl3 cT cc0 c1 cicc co wcel cT cD cmul co c1 cT cmin co cC cmul co
      caddc co c1 c1 cT cmin co cmin co cD cmul co c1 cT cmin co cC cmul co
      caddc co wceq cD cr wcel cC cr wcel cD cC clt wbr w3a cT cc0 c1 cicc co
      wcel cT cc wcel cT cD cmul co c1 cT cmin co cC cmul co caddc co c1 c1 cT
      cmin co cmin co cD cmul co c1 cT cmin co cC cmul co caddc co wceq cT cc0
      c1 cicc co wcel cT cc0 c1 cicc co cr cT cc0 cr wcel c1 cr wcel cc0 c1
      cicc co cr wss 0re 1re cc0 c1 iccssre mp2an sseli recnd cT cc wcel cT cD
      cmul co c1 c1 cT cmin co cmin co cD cmul co c1 cT cmin co cC cmul co
      caddc cT cc wcel cT c1 c1 cT cmin co cmin co cD cmul cT cc wcel c1 c1 cT
      cmin co cmin co cT c1 cc wcel cT cc wcel c1 c1 cT cmin co cmin co cT wceq
      ax1cn c1 cT nncan mpan eqcomd opreq1d opreq1d syl adantl eqtrd cD cr wcel
      cC cr wcel cD cC clt wbr w3a c1 cT cmin co cc0 c1 cicc co wcel c1 c1 cT
      cmin co cmin co cD cmul co c1 cT cmin co cC cmul co caddc co cD cC cicc
      co wcel cT cc0 c1 cicc co wcel cD cC c1 cT cmin co lincmb01cmp cT iirev
      sylan2 eqeltrd ex 3expa imp an1rs cA cr wcel cB cr wcel wa cC cA cB cicc
      co wcel cD cA cB cicc co wcel cT cc0 c1 cicc co wcel w3a wa cD cr wcel cC
      cr wcel wa cT cc0 c1 cicc co wcel cA cr wcel cB cr wcel wa cC cA cB cicc
      co wcel cD cA cB cicc co wcel cD cr wcel cC cr wcel wa cT cc0 c1 cicc co
      wcel cA cr wcel cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel
      wa wa cD cr wcel cC cr wcel cA cr wcel cB cr wcel wa cD cA cB cicc co
      wcel cD cr wcel cC cA cB cicc co wcel cA cr wcel cB cr wcel wa cD cA cB
      cicc co wcel cD cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr cD cA
      cB iccssre sseld imp adantrl cA cr wcel cB cr wcel wa cC cA cB cicc co
      wcel cC cr wcel cD cA cB cicc co wcel cA cr wcel cB cr wcel wa cC cA cB
      cicc co wcel cC cr wcel cA cr wcel cB cr wcel wa cA cB cicc co cr cC cA
      cB iccssre sseld imp adantrr jca 3adantr3 cC cA cB cicc co wcel cD cA cB
      cicc co wcel cT cc0 c1 cicc co wcel w3a cT cc0 c1 cicc co wcel cA cr wcel
      cB cr wcel wa cC cA cB cicc co wcel cD cA cB cicc co wcel cT cc0 c1 cicc
      co wcel 3simp3 adantl jca sylan sseldd 3jaodan mpdan ex $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Continuous maps and homeomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.
    constcncf.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = A ) } $.
    $( A constant function is a continuous function on ` CC ` . $)
    constcncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      cA cc wcel cF cabs cmin ccom copn cfv cabs cmin ccom copn cfv ccn co cc
      cc ccncf co cabs cmin ccom cme wcel cabs cmin ccom cme wcel cA cc wcel cc
      cA csn cF wf cF cabs cmin ccom copn cfv cabs cmin ccom copn cfv ccn co
      wcel cA cc wcel cA cabs cmin ccom cabs cmin ccom cF cabs cmin ccom copn
      cfv cabs cmin ccom copn cfv cc cc cabs cmin ccom cabs cmin ccom eqid
      cnmetba cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom copn
      cfv eqid cabs cmin ccom copn cfv eqid metcnconst cabs cmin ccom cme wcel
      cA cc wcel cabs cmin ccom cabs cmin ccom eqid cnmet a1i cabs cmin ccom
      cme wcel cA cc wcel cabs cmin ccom cabs cmin ccom eqid cnmet a1i cA cc
      wcel id cA cc wcel cc cA csn cc cA csn cxp wf cc cA csn cF wf cc cA cc
      fconstg cF cc cA csn cxp wceq cc cA csn cF wf cc cA csn cc cA csn cxp wf
      wb cF vx cv cc wcel vy cv cA wceq wa vx vy copab cc cA csn cxp
      constcncf.1 vx vy cc cA fconstopab eqtr4i cc cA csn cF cc cA csn cxp feq1
      ax-mp sylibr syl2anc cabs cmin ccom cabs cmin ccom copn cfv cabs cmin
      ccom eqid cabs cmin ccom copn cfv eqid cncfmet1 syl6eleqr $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y $. $d F u v w $.
    addccncf.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( x + A ) ) } $.
    $( Adding a constant is a continuous function. $)
    addccncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      cA cc wcel cc cc wss cc cc wss cF cc cc ccncf co wcel cc ssid cc ssid cA
      cc wcel vu vv vw cc cc cF vv cv cA cc wcel vx cv cA caddc co cc wcel vx
      cc wral cc cc cF wf cA cc wcel vx cv cA caddc co cc wcel vx cc vx cv cc
      wcel cA cc wcel vx cv cA caddc co cc wcel vx cv cA axaddcl ancoms
      r19.21aiva vx vy cc cc vx cv cA caddc co cF addccncf.1 fopab2 sylib vu cv
      cc wcel vv cv crp wcel wa vv cv crp wcel wi cA cc wcel vu cv cc wcel vv
      cv crp wcel pm3.27 a1i cA cc wcel vu cv cc wcel vw cv cc wcel wa vv cv
      crp wcel wa vu cv vw cv cmin co cabs cfv vv cv clt wbr vu cv cF cfv vw cv
      cF cfv cmin co cabs cfv vv cv clt wbr wi cA cc wcel vu cv cc wcel vw cv
      cc wcel wa vv cv crp wcel wa wa vu cv cF cfv vw cv cF cfv cmin co cabs
      cfv vv cv clt wbr vu cv vw cv cmin co cabs cfv vv cv clt wbr cA cc wcel
      vu cv cc wcel vw cv cc wcel wa vv cv crp wcel wa wa vu cv cF cfv vw cv cF
      cfv cmin co cabs cfv vu cv vw cv cmin co cabs cfv vv cv clt cA cc wcel vu
      cv cc wcel vw cv cc wcel wa vv cv crp wcel wa wa vu cv cF cfv vw cv cF
      cfv cmin co vu cv vw cv cmin co cabs cA cc wcel vu cv cc wcel vw cv cc
      wcel wa vu cv cF cfv vw cv cF cfv cmin co vu cv vw cv cmin co wceq vv cv
      crp wcel cA cc wcel vu cv cc wcel vw cv cc wcel wa wa vu cv cF cfv vw cv
      cF cfv cmin co vu cv cA caddc co vw cv cA caddc co cmin co vu cv vw cv
      cmin co cA cc wcel vu cv cc wcel vw cv cc wcel wa wa vu cv cF cfv vu cv
      cA caddc co vw cv cF cfv vw cv cA caddc co cmin vu cv cc wcel vu cv cF
      cfv vu cv cA caddc co wceq cA cc wcel vw cv cc wcel vx vy vu cv vx cv cA
      caddc co vu cv cA caddc co cc cF vx cv vu cv cA caddc opreq1 addccncf.1
      vu cv cA caddc oprex fvopab4 ad2antrl vw cv cc wcel vw cv cF cfv vw cv cA
      caddc co wceq cA cc wcel vu cv cc wcel vx vy vw cv vx cv cA caddc co vw
      cv cA caddc co cc cF vx cv vw cv cA caddc opreq1 addccncf.1 vw cv cA
      caddc oprex fvopab4 ad2antll opreq12d vu cv cc wcel vw cv cc wcel wa cA
      cc wcel vu cv cA caddc co vw cv cA caddc co cmin co vu cv vw cv cmin co
      wceq vu cv cc wcel vw cv cc wcel cA cc wcel vu cv cA caddc co vw cv cA
      caddc co cmin co vu cv vw cv cmin co wceq vu cv vw cv cA pnpcan2 3expa
      ancoms eqtrd adantrr fveq2d breq1d biimprd ex elcncf1di mp2ani $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y $. $d F u v w $.
    sub1cncf.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( x - A ) ) } $.
    $( Subtracting a constant is a continuous function. $)
    sub1cncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      cA cc wcel cc cc wss cc cc wss cF cc cc ccncf co wcel cc ssid cc ssid cA
      cc wcel vu vw vv cc cc cF vw cv cA cc wcel vx cv cA cmin co cc wcel vx cc
      wral cc cc cF wf cA cc wcel vx cv cA cmin co cc wcel vx cc vx cv cc wcel
      cA cc wcel vx cv cA cmin co cc wcel vx cv cA subcl ancoms r19.21aiva vx
      vy cc cc vx cv cA cmin co cF sub1cncf.1 fopab2 sylib vu cv cc wcel vw cv
      crp wcel wa vw cv crp wcel wi cA cc wcel vu cv cc wcel vw cv crp wcel
      pm3.27 a1i cA cc wcel vu cv cc wcel vv cv cc wcel wa vw cv crp wcel wa vu
      cv vv cv cmin co cabs cfv vw cv clt wbr vu cv cF cfv vv cv cF cfv cmin co
      cabs cfv vw cv clt wbr wi cA cc wcel vu cv cc wcel vv cv cc wcel wa vw cv
      crp wcel wa wa vu cv cF cfv vv cv cF cfv cmin co cabs cfv vw cv clt wbr
      vu cv vv cv cmin co cabs cfv vw cv clt wbr cA cc wcel vu cv cc wcel vv cv
      cc wcel wa vw cv crp wcel wa wa vu cv cF cfv vv cv cF cfv cmin co cabs
      cfv vu cv vv cv cmin co cabs cfv vw cv clt cA cc wcel vu cv cc wcel vv cv
      cc wcel wa vu cv cF cfv vv cv cF cfv cmin co cabs cfv vu cv vv cv cmin co
      cabs cfv wceq vw cv crp wcel cA cc wcel vu cv cc wcel vv cv cc wcel wa wa
      vu cv cF cfv vv cv cF cfv cmin co vu cv vv cv cmin co cabs cA cc wcel vu
      cv cc wcel vv cv cc wcel wa wa vu cv cF cfv vv cv cF cfv cmin co vu cv cA
      cmin co vv cv cA cmin co cmin co vu cv vv cv cmin co cA cc wcel vu cv cc
      wcel vv cv cc wcel wa wa vu cv cF cfv vu cv cA cmin co vv cv cF cfv vv cv
      cA cmin co cmin vu cv cc wcel vu cv cF cfv vu cv cA cmin co wceq cA cc
      wcel vv cv cc wcel vx vy vu cv vx cv cA cmin co vu cv cA cmin co cc cF vx
      cv vu cv cA cmin opreq1 sub1cncf.1 vu cv cA cmin oprex fvopab4 ad2antrl
      vv cv cc wcel vv cv cF cfv vv cv cA cmin co wceq cA cc wcel vu cv cc wcel
      vx vy vv cv vx cv cA cmin co vv cv cA cmin co cc cF vx cv vv cv cA cmin
      opreq1 sub1cncf.1 vv cv cA cmin oprex fvopab4 ad2antll opreq12d vu cv cc
      wcel vv cv cc wcel wa cA cc wcel vu cv cA cmin co vv cv cA cmin co cmin
      co vu cv vv cv cmin co wceq vu cv cc wcel vv cv cc wcel cA cc wcel vu cv
      cA cmin co vv cv cA cmin co cmin co vu cv vv cv cmin co wceq vu cv vv cv
      cA nnncan2 3expa ancoms eqtrd fveq2d adantrr breq1d biimprd ex elcncf1di
      mp2ani $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A u v w x y $. $d F u v w $.
    sub2cncf.1 $e |- F = { <. x , y >. | ( x e. CC /\ y = ( A - x ) ) } $.
    $( Subtraction from a constant is a continuous function. $)
    sub2cncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      cA cc wcel cc cc wss cc cc wss cF cc cc ccncf co wcel cc ssid cc ssid cA
      cc wcel vu vw vv cc cc cF vw cv cA cc wcel cA vx cv cmin co cc wcel vx cc
      wral cc cc cF wf cA cc wcel cA vx cv cmin co cc wcel vx cc cA vx cv subcl
      r19.21aiva vx vy cc cc cA vx cv cmin co cF sub2cncf.1 fopab2 sylib vu cv
      cc wcel vw cv crp wcel wa vw cv crp wcel wi cA cc wcel vu cv cc wcel vw
      cv crp wcel pm3.27 a1i cA cc wcel vu cv cc wcel vv cv cc wcel wa vw cv
      crp wcel wa vu cv vv cv cmin co cabs cfv vw cv clt wbr vu cv cF cfv vv cv
      cF cfv cmin co cabs cfv vw cv clt wbr wi cA cc wcel vu cv cc wcel vv cv
      cc wcel wa vw cv crp wcel wa wa vu cv cF cfv vv cv cF cfv cmin co cabs
      cfv vw cv clt wbr vu cv vv cv cmin co cabs cfv vw cv clt wbr cA cc wcel
      vu cv cc wcel vv cv cc wcel wa vw cv crp wcel wa wa vu cv cF cfv vv cv cF
      cfv cmin co cabs cfv vu cv vv cv cmin co cabs cfv vw cv clt cA cc wcel vu
      cv cc wcel vv cv cc wcel wa vu cv cF cfv vv cv cF cfv cmin co cabs cfv vu
      cv vv cv cmin co cabs cfv wceq vw cv crp wcel cA cc wcel vu cv cc wcel vv
      cv cc wcel wa wa vu cv cF cfv vv cv cF cfv cmin co cabs cfv vv cv vu cv
      cmin co cabs cfv vu cv vv cv cmin co cabs cfv cA cc wcel vu cv cc wcel vv
      cv cc wcel wa wa vu cv cF cfv vv cv cF cfv cmin co vv cv vu cv cmin co
      cabs cA cc wcel vu cv cc wcel vv cv cc wcel wa wa vu cv cF cfv vv cv cF
      cfv cmin co cA vu cv cmin co cA vv cv cmin co cmin co vv cv vu cv cmin co
      cA cc wcel vu cv cc wcel vv cv cc wcel wa wa vu cv cF cfv cA vu cv cmin
      co vv cv cF cfv cA vv cv cmin co cmin vu cv cc wcel vu cv cF cfv cA vu cv
      cmin co wceq cA cc wcel vv cv cc wcel vx vy vu cv cA vx cv cmin co cA vu
      cv cmin co cc cF vx cv vu cv cA cmin opreq2 sub2cncf.1 cA vu cv cmin
      oprex fvopab4 ad2antrl vv cv cc wcel vv cv cF cfv cA vv cv cmin co wceq
      cA cc wcel vu cv cc wcel vx vy vv cv cA vx cv cmin co cA vv cv cmin co cc
      cF vx cv vv cv cA cmin opreq2 sub2cncf.1 cA vv cv cmin oprex fvopab4
      ad2antll opreq12d cA cc wcel vu cv cc wcel vv cv cc wcel cA vu cv cmin co
      cA vv cv cmin co cmin co vv cv vu cv cmin co wceq cA vu cv vv cv nnncan1
      3expb eqtrd fveq2d vu cv cc wcel vv cv cc wcel wa vv cv vu cv cmin co
      cabs cfv vu cv vv cv cmin co cabs cfv wceq cA cc wcel vv cv cc wcel vu cv
      cc wcel vv cv vu cv cmin co cabs cfv vu cv vv cv cmin co cabs cfv wceq vv
      cv vu cv abssub ancoms adantl eqtrd adantrr breq1d biimprd ex elcncf1di
      mp2ani $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The composition of two continuous maps on complex numbers is also
       continuous. $)
    cncfco $p |- ( ( ( A C_ CC /\ B C_ CC /\ C C_ CC ) /\ ( F e. ( A -cn-> B )
                /\ G e. ( B -cn-> C ) ) ) -> ( G o. F ) e. ( A -cn-> C ) ) $=
      cA cc wss cB cc wss cC cc wss w3a cF cA cB ccncf co wcel cG cB cC ccncf
      co wcel wa cG cF ccom cA cC ccncf co wcel cA cc wss cB cc wss cC cc wss
      w3a cF cA cB ccncf co wcel cG cB cC ccncf co wcel wa cG cF ccom cA cC
      ccncf co wcel wi cF cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom
      cB cB cxp cres copn cfv ccn co wcel cG cabs cmin ccom cB cB cxp cres copn
      cfv cabs cmin ccom cC cC cxp cres copn cfv ccn co wcel wa cG cF ccom cabs
      cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cC cC cxp cres copn cfv
      ccn co wcel wi cabs cmin ccom cA cA cxp cres copn cfv ctop wcel cabs cmin
      ccom cB cB cxp cres copn cfv ctop wcel cabs cmin ccom cC cC cxp cres copn
      cfv ctop wcel cF cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cB
      cB cxp cres copn cfv ccn co wcel cG cabs cmin ccom cB cB cxp cres copn
      cfv cabs cmin ccom cC cC cxp cres copn cfv ccn co wcel wa cG cF ccom cabs
      cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cC cC cxp cres copn cfv
      ccn co wcel wi cabs cmin ccom cA cA cxp cres cme wcel cabs cmin ccom cA
      cA cxp cres copn cfv ctop wcel cabs cmin ccom cme wcel cabs cmin ccom cA
      cA cxp cres cme wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin
      ccom cA metres ax-mp cabs cmin ccom cA cA cxp cres cabs cmin ccom cA cA
      cxp cres copn cfv cabs cmin ccom cA cA cxp cres copn cfv eqid opntop
      ax-mp cabs cmin ccom cB cB cxp cres cme wcel cabs cmin ccom cB cB cxp
      cres copn cfv ctop wcel cabs cmin ccom cme wcel cabs cmin ccom cB cB cxp
      cres cme wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cB
      metres ax-mp cabs cmin ccom cB cB cxp cres cabs cmin ccom cB cB cxp cres
      copn cfv cabs cmin ccom cB cB cxp cres copn cfv eqid opntop ax-mp cabs
      cmin ccom cC cC cxp cres cme wcel cabs cmin ccom cC cC cxp cres copn cfv
      ctop wcel cabs cmin ccom cme wcel cabs cmin ccom cC cC cxp cres cme wcel
      cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cC metres ax-mp
      cabs cmin ccom cC cC cxp cres cabs cmin ccom cC cC cxp cres copn cfv cabs
      cmin ccom cC cC cxp cres copn cfv eqid opntop ax-mp cabs cmin ccom cA cA
      cxp cres copn cfv ctop wcel cabs cmin ccom cB cB cxp cres copn cfv ctop
      wcel cabs cmin ccom cC cC cxp cres copn cfv ctop wcel w3a cF cabs cmin
      ccom cA cA cxp cres copn cfv cabs cmin ccom cB cB cxp cres copn cfv ccn
      co wcel cG cabs cmin ccom cB cB cxp cres copn cfv cabs cmin ccom cC cC
      cxp cres copn cfv ccn co wcel wa cG cF ccom cabs cmin ccom cA cA cxp cres
      copn cfv cabs cmin ccom cC cC cxp cres copn cfv ccn co wcel cF cG cabs
      cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cB cB cxp cres copn cfv
      cabs cmin ccom cC cC cxp cres copn cfv cnco ex mp3an cA cc wss cB cc wss
      cC cc wss w3a cF cA cB ccncf co wcel cG cB cC ccncf co wcel wa cF cabs
      cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cB cB cxp cres copn cfv
      ccn co wcel cG cabs cmin ccom cB cB cxp cres copn cfv cabs cmin ccom cC
      cC cxp cres copn cfv ccn co wcel wa cG cF ccom cA cC ccncf co wcel cG cF
      ccom cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cC cC cxp cres
      copn cfv ccn co wcel cA cc wss cB cc wss cC cc wss w3a cF cA cB ccncf co
      wcel cF cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cB cB cxp
      cres copn cfv ccn co wcel cG cB cC ccncf co wcel cG cabs cmin ccom cB cB
      cxp cres copn cfv cabs cmin ccom cC cC cxp cres copn cfv ccn co wcel cA
      cc wss cB cc wss cC cc wss w3a cA cB ccncf co cabs cmin ccom cA cA cxp
      cres copn cfv cabs cmin ccom cB cB cxp cres copn cfv ccn co cF cA cc wss
      cB cc wss cA cB ccncf co cabs cmin ccom cA cA cxp cres copn cfv cabs cmin
      ccom cB cB cxp cres copn cfv ccn co wceq cC cc wss cA cB cabs cmin ccom
      cA cA cxp cres cabs cmin ccom cB cB cxp cres cabs cmin ccom cA cA cxp
      cres copn cfv cabs cmin ccom cB cB cxp cres copn cfv cabs cmin ccom cA cA
      cxp cres eqid cabs cmin ccom cB cB cxp cres eqid cabs cmin ccom cA cA cxp
      cres copn cfv eqid cabs cmin ccom cB cB cxp cres copn cfv eqid cncfmet
      3adant3 eleq2d cA cc wss cB cc wss cC cc wss w3a cB cC ccncf co cabs cmin
      ccom cB cB cxp cres copn cfv cabs cmin ccom cC cC cxp cres copn cfv ccn
      co cG cB cc wss cC cc wss cB cC ccncf co cabs cmin ccom cB cB cxp cres
      copn cfv cabs cmin ccom cC cC cxp cres copn cfv ccn co wceq cA cc wss cB
      cC cabs cmin ccom cB cB cxp cres cabs cmin ccom cC cC cxp cres cabs cmin
      ccom cB cB cxp cres copn cfv cabs cmin ccom cC cC cxp cres copn cfv cabs
      cmin ccom cB cB cxp cres eqid cabs cmin ccom cC cC cxp cres eqid cabs
      cmin ccom cB cB cxp cres copn cfv eqid cabs cmin ccom cC cC cxp cres copn
      cfv eqid cncfmet 3adant1 eleq2d anbi12d cA cc wss cB cc wss cC cc wss w3a
      cA cC ccncf co cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cC
      cC cxp cres copn cfv ccn co cG cF ccom cA cc wss cC cc wss cA cC ccncf co
      cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom cC cC cxp cres copn
      cfv ccn co wceq cB cc wss cA cC cabs cmin ccom cA cA cxp cres cabs cmin
      ccom cC cC cxp cres cabs cmin ccom cA cA cxp cres copn cfv cabs cmin ccom
      cC cC cxp cres copn cfv cabs cmin ccom cA cA cxp cres eqid cabs cmin ccom
      cC cC cxp cres eqid cabs cmin ccom cA cA cxp cres copn cfv eqid cabs cmin
      ccom cC cC cxp cres copn cfv eqid cncfmet 3adant2 eleq2d imbi12d mpbiri
      imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J x y z $. $d K x y z $. $d X x y z $. $d Y x y z $. $d F x y z $.
    $d A x y z $.
    cnimass.1 $e |- X = U. J $.
    cnimass.2 $e |- Y = U. K $.
    $( Restriction of the image of a continuous function. $)
    cnimass $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Cn K ) ) /\
                              ( A C_ Y /\ A. x e. X ( F ` x ) e. A ) )
                            -> F e. ( J Cn ( subSp ` <. A , K >. ) ) ) $=
      cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv
      cA wcel vx cX wral wa wa cF cJ cA cK cop csubsp cfv ccn co wcel cX cA cK
      cop csubsp cfv cuni cF wf cF ccnv vy cv cima cJ wcel vy cA cK cop csubsp
      cfv wral wa cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss
      vx cv cF cfv cA wcel vx cX wral wa wa cX cA cK cop csubsp cfv cuni cF wf
      cF ccnv vy cv cima cJ wcel vy cA cK cop csubsp cfv wral cX cA cK cop
      csubsp cfv cuni cF wf cF cX wfn cF crn cA cK cop csubsp cfv cuni wss cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv cA
      wcel vx cX wral wa wa cX cA cK cop csubsp cfv cuni cF df-f cJ ctop wcel
      cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv cA wcel vx
      cX wral wa wa cX cY cF wf cF cX wfn cJ ctop wcel cK ctop wcel cF cJ cK
      ccn co wcel w3a cX cY cF wf cA cY wss vx cv cF cfv cA wcel vx cX wral wa
      cF cJ cK cX cY cnimass.1 cnimass.2 cnf adantr cX cY cF ffn syl cJ ctop
      wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv cA wcel
      vx cX wral wa wa cF crn cA cA cK cop csubsp cfv cuni cJ ctop wcel cK ctop
      wcel cF cJ cK ccn co wcel w3a vx cv cF cfv cA wcel vx cX wral cF crn cA
      wss cA cY wss cF cX wfn vx cv cF cfv cA wcel vx cX wral cF crn cA wss cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a vx cX cA cF fnfvrnss cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cX cY cF wf cF cX wfn cF
      cJ cK cX cY cnimass.1 cnimass.2 cnf cX cY cF ffn syl sylan adantrl cK
      ctop wcel cJ ctop wcel cA cY wss vx cv cF cfv cA wcel vx cX wral wa cA cK
      cop csubsp cfv cuni cA wceq cF cJ cK ccn co wcel cK ctop wcel cA cY wss
      cA cK cop csubsp cfv cuni cA wceq vx cv cF cfv cA wcel vx cX wral cK ctop
      wcel cA cK cuni wss cA cK cop csubsp cfv cuni cA wceq cA cY wss cA cK
      stoig2 cY cK cuni cA cnimass.2 sseq2i sylan2b adantrr 3ad2antl2 sseqtr4d
      sylanbrc cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx
      cv cF cfv cA wcel vx cX wral wa wa cF ccnv vy cv cima cJ wcel vy cA cK
      cop csubsp cfv cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY
      wss vx cv cF cfv cA wcel vx cX wral wa wa vy cv cA cK cop csubsp cfv wcel
      vy cv vz cv cA cin wceq vz cK wrex cF ccnv vy cv cima cJ wcel cK ctop
      wcel cJ ctop wcel cA cY wss vx cv cF cfv cA wcel vx cX wral wa vy cv cA
      cK cop csubsp cfv wcel vy cv vz cv cA cin wceq vz cK wrex wb cF cJ cK ccn
      co wcel cK ctop wcel cA cY wss vy cv cA cK cop csubsp cfv wcel vy cv vz
      cv cA cin wceq vz cK wrex wb vx cv cF cfv cA wcel vx cX wral cK ctop wcel
      cA cY wss cA cvv wcel vy cv cA cK cop csubsp cfv wcel vy cv vz cv cA cin
      wceq vz cK wrex wb cY cvv wcel cA cY wss cA cvv wcel cK ctop wcel cA cY
      wss cY cvv wcel cA cvv wcel cA cY cvv ssexg ancoms cK ctop wcel cK cuni
      cvv cY cK ctop uniexg cnimass.2 syl5eqel sylan cK ctop wcel vy cv cvv
      wcel cA cvv wcel vy cv cA cK cop csubsp cfv wcel vy cv vz cv cA cin wceq
      vz cK wrex wb vy visset vz vy cv cA cvv cK issubspt mp3an2 syldan adantrr
      3ad2antl2 cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx
      cv cF cfv cA wcel vx cX wral wa wa vy cv vz cv cA cin wceq cF ccnv vy cv
      cima cJ wcel vz cK vy cv vz cv cA cin wceq cF ccnv vy cv cima cJ wcel cF
      ccnv vz cv cA cin cima cJ wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co
      wcel w3a cA cY wss vx cv cF cfv cA wcel vx cX wral wa wa vz cv cK wcel wa
      vy cv vz cv cA cin wceq cF ccnv vy cv cima cF ccnv vz cv cA cin cima cJ
      vy cv vz cv cA cin cF ccnv imaeq2 eleq1d cJ ctop wcel cK ctop wcel cF cJ
      cK ccn co wcel w3a cA cY wss vx cv cF cfv cA wcel vx cX wral wa wa vz cv
      cK wcel wa cF ccnv vz cv cA cin cima cF ccnv vz cv cima cJ cJ ctop wcel
      cK ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv cA wcel vx
      cX wral wa wa vz cv cK wcel wa cF ccnv vz cv cA cin cima cF ccnv vz cv
      cima cF ccnv cA cima cin cF ccnv vz cv cima cJ ctop wcel cK ctop wcel cF
      cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv cA wcel vx cX wral wa wa vz
      cv cK wcel wa cF wfun cF ccnv vz cv cA cin cima cF ccnv vz cv cima cF
      ccnv cA cima cin wceq cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a
      cF wfun cA cY wss vx cv cF cfv cA wcel vx cX wral wa vz cv cK wcel cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cX cY cF wf cF cX wfn cF
      wfun cF cJ cK cX cY cnimass.1 cnimass.2 cnf cX cY cF ffn cX cF fnfun 3syl
      ad2antrr vz cv cA cF inpreima syl cJ ctop wcel cK ctop wcel cF cJ cK ccn
      co wcel w3a cA cY wss vx cv cF cfv cA wcel vx cX wral wa wa vz cv cK wcel
      wa cF ccnv vz cv cima cF ccnv cA cima wss cF ccnv vz cv cima cF ccnv cA
      cima cin cF ccnv vz cv cima wceq cJ ctop wcel cK ctop wcel cF cJ cK ccn
      co wcel w3a cA cY wss vx cv cF cfv cA wcel vx cX wral wa wa vz cv cK wcel
      wa cF ccnv vz cv cima cX cF ccnv cA cima cJ ctop wcel cK ctop wcel cF cJ
      cK ccn co wcel w3a cF ccnv vz cv cima cX wss cA cY wss vx cv cF cfv cA
      wcel vx cX wral wa vz cv cK wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn
      co wcel w3a cF ccnv vz cv cima cF ccnv crn cX cF ccnv vz cv cima cF ccnv
      crn wss cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cF ccnv vz cv
      imassrn a1i cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cF cdm cX
      cF ccnv crn cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cX cY cF
      wf cF cX wfn cF cdm cX wceq cF cJ cK cX cY cnimass.1 cnimass.2 cnf cX cY
      cF ffn cX cF fndm 3syl cF dfdm4 syl5eqr sseqtrd ad2antrr cJ ctop wcel cK
      ctop wcel cF cJ cK ccn co wcel w3a cA cY wss vx cv cF cfv cA wcel vx cX
      wral wa wa cX cF ccnv cA cima wss vz cv cK wcel cJ ctop wcel cK ctop wcel
      cF cJ cK ccn co wcel w3a vx cv cF cfv cA wcel vx cX wral cX cF ccnv cA
      cima wss cA cY wss cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a cX
      cF ccnv cA cima wss vx cv cF cfv cA wcel vx cX wral cF wfun cX cF cdm wss
      cX cF ccnv cA cima wss vx cv cF cfv cA wcel vx cX wral wb cJ ctop wcel cK
      ctop wcel cF cJ cK ccn co wcel w3a vx cX cA cF funimass5 cJ ctop wcel cK
      ctop wcel cF cJ cK ccn co wcel w3a cX cY cF wf cF cX wfn cF wfun cF cJ cK
      cX cY cnimass.1 cnimass.2 cnf cX cY cF ffn cX cF fnfun 3syl cJ ctop wcel
      cK ctop wcel cF cJ cK ccn co wcel w3a cX cX cF cdm cX cX wss cJ ctop wcel
      cK ctop wcel cF cJ cK ccn co wcel w3a cX ssid a1i cJ ctop wcel cK ctop
      wcel cF cJ cK ccn co wcel w3a cX cY cF wf cF cX wfn cF cdm cX wceq cF cJ
      cK cX cY cnimass.1 cnimass.2 cnf cX cY cF ffn cX cF fndm 3syl sseqtr4d
      sylanc biimpar adantrl adantr sstrd cF ccnv vz cv cima cF ccnv cA cima
      df-ss sylib eqtrd cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel w3a vz
      cv cK wcel cF ccnv vz cv cima cJ wcel cA cY wss vx cv cF cfv cA wcel vx
      cX wral wa vz cv cF cJ cK cnima adantlr eqeltrd syl5cbir r19.23adva
      sylbid r19.21aiv jca cJ ctop wcel cK ctop wcel cA cY wss vx cv cF cfv cA
      wcel vx cX wral wa cF cJ cA cK cop csubsp cfv ccn co wcel cX cA cK cop
      csubsp cfv cuni cF wf cF ccnv vy cv cima cJ wcel vy cA cK cop csubsp cfv
      wral wa wb cF cJ cK ccn co wcel cJ ctop wcel cK ctop wcel wa cA cY wss cF
      cJ cA cK cop csubsp cfv ccn co wcel cX cA cK cop csubsp cfv cuni cF wf cF
      ccnv vy cv cima cJ wcel vy cA cK cop csubsp cfv wral wa wb vx cv cF cfv
      cA wcel vx cX wral cJ ctop wcel cK ctop wcel cA cY wss cF cJ cA cK cop
      csubsp cfv ccn co wcel cX cA cK cop csubsp cfv cuni cF wf cF ccnv vy cv
      cima cJ wcel vy cA cK cop csubsp cfv wral wa wb cJ ctop wcel cA cK cop
      csubsp cfv ctop wcel cF cJ cA cK cop csubsp cfv ccn co wcel cX cA cK cop
      csubsp cfv cuni cF wf cF ccnv vy cv cima cJ wcel vy cA cK cop csubsp cfv
      wral wa wb cK ctop wcel cA cY wss wa vy cF cJ cA cK cop csubsp cfv cX cA
      cK cop csubsp cfv cuni cnimass.1 cA cK cop csubsp cfv cuni eqid iscn cK
      ctop wcel cA cK cuni wss cA cK cop csubsp cfv ctop wcel cA cY wss cA cK
      stoig3 cY cK cuni cA cnimass.2 sseq2i sylan2b sylan2 anassrs adantrr
      3adantl3 mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J y z $. $d K y z $. $d F y z $. $d X y z $. $d A y z $.
    cnres.1 $e |- X = U. J $.
    $( The restriction of a continuous function to a subset is continuous. $)
    cnres $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( F e. ( J Cn K ) /\ A C_ X ) )
                        -> ( F |` A ) e. ( ( subSp ` <. A , J >. ) Cn K ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cA cJ cuni wss cF cA
      cres cA cJ cop csubsp cfv cK ccn co wcel cA cX wss cJ ctop wcel cK ctop
      wcel wa cF cJ cK ccn co wcel cA cJ cuni wss wa wa cF cA cres cA cJ cop
      csubsp cfv cK ccn co wcel cA cJ cop csubsp cfv cuni cK cuni cF cA cres wf
      cF cA cres ccnv vz cv cima cA cJ cop csubsp cfv wcel vz cK wral wa cJ
      ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cA cJ cuni wss wa wa cA cJ
      cop csubsp cfv cuni cK cuni cF cA cres wf cF cA cres ccnv vz cv cima cA
      cJ cop csubsp cfv wcel vz cK wral cJ ctop wcel cK ctop wcel wa cF cJ cK
      ccn co wcel cA cJ cuni wss wa wa cA cJ cop csubsp cfv cuni cK cuni cF cA
      cres wf cA cK cuni cF cA cres wf cJ cuni cK cuni cF wf cA cJ cuni wss cA
      cK cuni cF cA cres wf cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel
      cA cJ cuni wss wa wa cJ cuni cK cuni cA cF fssres cJ ctop wcel cK ctop
      wcel wa cF cJ cK ccn co wcel cJ cuni cK cuni cF wf cA cJ cuni wss cJ ctop
      wcel cK ctop wcel cF cJ cK ccn co wcel cJ cuni cK cuni cF wf cF cJ cK cJ
      cuni cK cuni cJ cuni eqid cK cuni eqid cnf 3expa adantrr cJ ctop wcel cK
      ctop wcel wa cF cJ cK ccn co wcel cA cJ cuni wss simprr sylanc cJ ctop
      wcel cA cJ cuni wss cA cJ cop csubsp cfv cuni cK cuni cF cA cres wf cA cK
      cuni cF cA cres wf wb cK ctop wcel cF cJ cK ccn co wcel cJ ctop wcel cA
      cJ cuni wss wa cA cJ cop csubsp cfv cuni cA wceq cA cJ cop csubsp cfv
      cuni cK cuni cF cA cres wf cA cK cuni cF cA cres wf wb cA cJ stoig2 cA cJ
      cop csubsp cfv cuni cA cK cuni cF cA cres feq2 syl ad2ant2rl mpbird cJ
      ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cA cJ cuni wss wa wa cF cA
      cres ccnv vz cv cima cA cJ cop csubsp cfv wcel vz cK cJ ctop wcel cK ctop
      wcel wa cF cJ cK ccn co wcel cA cJ cuni wss wa wa vz cv cK wcel wa cF cA
      cres ccnv vz cv cima cA cJ cop csubsp cfv wcel cF cA cres ccnv vz cv cima
      vy cv cA cin wceq vy cJ wrex cF ccnv vz cv cima cJ wcel cF cA cres ccnv
      vz cv cima cF ccnv vz cv cima cA cin wceq cF cA cres ccnv vz cv cima vy
      cv cA cin wceq vy cJ wrex cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co
      wcel cA cJ cuni wss wa wa vz cv cK wcel wa cF cA cres ccnv vz cv cima vy
      cv cA cin wceq cF cA cres ccnv vz cv cima cF ccnv vz cv cima cA cin wceq
      vy cF ccnv vz cv cima cJ vy cv cF ccnv vz cv cima wceq vy cv cA cin cF
      ccnv vz cv cima cA cin cF cA cres ccnv vz cv cima vy cv cF ccnv vz cv
      cima cA ineq1 eqeq2d rcla4ev cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co
      wcel vz cv cK wcel cF ccnv vz cv cima cJ wcel cA cJ cuni wss cJ ctop wcel
      cK ctop wcel wa cF cJ cK ccn co wcel wa vz cv cK wcel cF ccnv vz cv cima
      cJ wcel cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel vz cv cK wcel cF
      ccnv vz cv cima cJ wcel wi cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel
      w3a vz cv cK wcel cF ccnv vz cv cima cJ wcel vz cv cF cJ cK cnima ex
      3expa imp adantlrr cJ cuni cK cuni cF wf cA cJ cuni wss wa vz cv cK wcel
      cF cA cres ccnv vz cv cima cF ccnv vz cv cima cA cin wceq cJ ctop wcel cK
      ctop wcel wa cF cJ cK ccn co wcel cA cJ cuni wss wa wa cF cJ cuni wfn cA
      cJ cuni wss vz cv cK wcel cF cA cres ccnv vz cv cima cF ccnv vz cv cima
      cA cin wceq cJ cuni cK cuni cF wf cF cJ cuni wfn cF cA cres ccnv vz cv
      cima cF ccnv vz cv cima cA cin wceq cA cJ cuni wss vz cv cK wcel cF cJ
      cuni wfn cF wfun cF cA cres ccnv vz cv cima cF ccnv vz cv cima cA cin
      wceq cJ cuni cF fnfun vz cv cA cF respreima syl ad2antrr cJ cuni cK cuni
      cF ffn sylanl1 cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cA cJ
      cuni wss cJ cuni cK cuni cF wf cA cJ cuni wss wa cJ ctop wcel cK ctop
      wcel wa cF cJ cK ccn co wcel wa cJ cuni cK cuni cF wf cA cJ cuni wss cJ
      ctop wcel cK ctop wcel cF cJ cK ccn co wcel cJ cuni cK cuni cF wf cF cJ
      cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid cnf 3expa anim1i anasss
      sylan sylanc cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cA cJ cuni
      wss wa wa cF cA cres ccnv vz cv cima cA cJ cop csubsp cfv wcel cF cA cres
      ccnv vz cv cima vy cv cA cin wceq vy cJ wrex wb vz cv cK wcel cJ ctop
      wcel cF cJ cK ccn co wcel cA cJ cuni wss wa cF cA cres ccnv vz cv cima cA
      cJ cop csubsp cfv wcel cF cA cres ccnv vz cv cima vy cv cA cin wceq vy cJ
      wrex wb cK ctop wcel cJ ctop wcel cF cA cres ccnv vz cv cima cvv wcel cA
      cvv wcel cF cA cres ccnv vz cv cima cA cJ cop csubsp cfv wcel cF cA cres
      ccnv vz cv cima vy cv cA cin wceq vy cJ wrex wb cJ ctop wcel cF cJ cK ccn
      co wcel cA cJ cuni wss wa wa vy cF cA cres ccnv vz cv cima cA cvv cJ
      issubspt cJ ctop wcel cF cJ cK ccn co wcel cA cJ cuni wss wa pm3.26 cF cJ
      cK ccn co wcel cF cA cres ccnv vz cv cima cvv wcel cJ ctop wcel cA cJ
      cuni wss cF cJ cK ccn co wcel cF cA cres cvv wcel cF cA cres ccnv cvv
      wcel cF cA cres ccnv vz cv cima cvv wcel cF cA cJ cK ccn co resexg cF cA
      cres cvv cnvexg cF cA cres ccnv vz cv cvv imaexg 3syl ad2antrl cJ ctop
      wcel cA cJ cuni wss cA cvv wcel cF cJ cK ccn co wcel cA cJ cuni wss cJ
      ctop wcel cA cvv wcel cA cJ cuni wss cJ cuni cvv wcel cA cvv wcel cJ ctop
      wcel cA cJ cuni cvv ssexg cJ ctop uniexg sylan2 ancoms adantrl syl3anc
      adantlr adantr mpbird r19.21aiva jca cJ ctop wcel cK ctop wcel wa cA cJ
      cuni wss cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cA cJ cop csubsp
      cfv cuni cK cuni cF cA cres wf cF cA cres ccnv vz cv cima cA cJ cop
      csubsp cfv wcel vz cK wral wa wb cF cJ cK ccn co wcel cJ ctop wcel cA cJ
      cuni wss cK ctop wcel cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cA
      cJ cop csubsp cfv cuni cK cuni cF cA cres wf cF cA cres ccnv vz cv cima
      cA cJ cop csubsp cfv wcel vz cK wral wa wb cA cJ cop csubsp cfv ctop wcel
      cK ctop wcel cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cA cJ cop
      csubsp cfv cuni cK cuni cF cA cres wf cF cA cres ccnv vz cv cima cA cJ
      cop csubsp cfv wcel vz cK wral wa wb cJ ctop wcel cA cJ cuni wss wa vz cF
      cA cres cA cJ cop csubsp cfv cK cA cJ cop csubsp cfv cuni cK cuni cA cJ
      cop csubsp cfv cuni eqid cK cuni eqid iscn cA cJ stoig3 sylan an1rs
      adantrl mpbird cA cX wss cA cJ cuni wss cX cJ cuni cA cnres.1 sseq2i
      biimpi sylanr2 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J x y z $. $d K x y z $. $d F x y z $. $d X x y z $. $d Y x y z $.
    $d A x y z $. $d B x y z $.
    cnres2.1 $e |- X = U. J $.
    cnres2.2 $e |- Y = U. K $.
    $( The restriction of a continuous function to a subset is continuous. $)
    cnres2 $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( A C_ X /\ B C_ Y ) /\
                ( F e. ( J Cn K ) /\ A. x e. A ( F ` x ) e. B ) ) -> ( F |` A )
                e. ( ( subSp ` <. A , J >. ) Cn ( subSp ` <. B , K >. ) ) ) $=
      cA cJ cop csubsp cfv ctop wcel cK ctop wcel cF cA cres cA cJ cop csubsp
      cfv cK ccn co wcel w3a cB cY wss vx cv cF cA cres cfv cB wcel vx cA cJ
      cop csubsp cfv cuni wral cF cA cres cA cJ cop csubsp cfv cB cK cop csubsp
      cfv ccn co wcel cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss wa cF cJ
      cK ccn co wcel vx cv cF cfv cB wcel vx cA wral wa w3a cJ ctop wcel cK
      ctop wcel wa cA cX wss cB cY wss wa cF cJ cK ccn co wcel vx cv cF cfv cB
      wcel vx cA wral wa w3a cA cJ cop csubsp cfv ctop wcel cK ctop wcel cF cA
      cres cA cJ cop csubsp cfv cK ccn co wcel cJ ctop wcel cK ctop wcel wa cA
      cX wss cB cY wss wa cA cJ cop csubsp cfv ctop wcel cF cJ cK ccn co wcel
      vx cv cF cfv cB wcel vx cA wral wa cJ ctop wcel cA cX wss cA cJ cop
      csubsp cfv ctop wcel cK ctop wcel cB cY wss cJ ctop wcel cA cJ cuni wss
      cA cJ cop csubsp cfv ctop wcel cA cX wss cA cJ stoig3 cX cJ cuni cA
      cnres2.1 sseq2i sylan2b ad2ant2r 3adant3 cJ ctop wcel cK ctop wcel wa cF
      cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral wa cK ctop wcel cA cX
      wss cB cY wss wa cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel vx cv cF
      cfv cB wcel vx cA wral wa simplr 3adant2 cJ ctop wcel cK ctop wcel cF cJ
      cK ccn co wcel cA cX wss cF cA cres cA cJ cop csubsp cfv cK ccn co wcel
      cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss wa cF cJ cK ccn co wcel
      vx cv cF cfv cB wcel vx cA wral wa w3a cA cF cJ cK cX cnres2.1 cnres cJ
      ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA
      wral wa cJ ctop wcel cA cX wss cB cY wss wa cJ ctop wcel cK ctop wcel cF
      cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral wa simpll 3adant2 cJ
      ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA
      wral wa cK ctop wcel cA cX wss cB cY wss wa cJ ctop wcel cK ctop wcel cF
      cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral wa simplr 3adant2 cA cX
      wss cB cY wss wa cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral wa
      cF cJ cK ccn co wcel cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss wa
      cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral simprl 3adant1 cA cX
      wss cB cY wss wa cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral wa
      cA cX wss cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss cF cJ cK ccn
      co wcel vx cv cF cfv cB wcel vx cA wral wa simpll 3adant1 syl2anc 3jca cA
      cX wss cB cY wss wa cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral
      wa cB cY wss cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss cF cJ cK
      ccn co wcel vx cv cF cfv cB wcel vx cA wral wa simplr 3adant1 cJ ctop
      wcel cK ctop wcel wa cA cX wss cB cY wss wa cF cJ cK ccn co wcel vx cv cF
      cfv cB wcel vx cA wral wa vx cv cF cA cres cfv cB wcel vx cA cJ cop
      csubsp cfv cuni wral cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss wa
      wa cF cJ cK ccn co wcel vx cv cF cfv cB wcel vx cA wral vx cv cF cA cres
      cfv cB wcel vx cA cJ cop csubsp cfv cuni wral cJ ctop wcel cK ctop wcel
      wa cA cX wss cB cY wss wa wa cF cJ cK ccn co wcel wa vx cv cF cfv cB wcel
      vx cA wral vx cv cF cA cres cfv cB wcel vx cA cJ cop csubsp cfv cuni wral
      cJ ctop wcel cK ctop wcel wa cA cX wss cB cY wss wa wa cF cJ cK ccn co
      wcel wa vx cv cF cA cres cfv cB wcel vx cA cJ cop csubsp cfv cuni wral vx
      cv cF cA cres cfv cB wcel vx cA wral vx cv cF cfv cB wcel vx cA wral cJ
      ctop wcel cK ctop wcel wa cA cX wss cB cY wss wa wa cF cJ cK ccn co wcel
      wa vx cv cF cA cres cfv cB wcel vx cA cJ cop csubsp cfv cuni cA cJ ctop
      wcel cK ctop wcel wa cA cX wss cB cY wss wa wa cA cJ cop csubsp cfv cuni
      cA wceq cF cJ cK ccn co wcel cJ ctop wcel cA cX wss cA cJ cop csubsp cfv
      cuni cA wceq cK ctop wcel cB cY wss cJ ctop wcel cA cJ cuni wss cA cJ cop
      csubsp cfv cuni cA wceq cA cX wss cA cJ stoig2 cX cJ cuni cA cnres2.1
      sseq2i sylan2b ad2ant2r adantr raleq1d vx cv cF cA cres cfv cB wcel vx cv
      cF cfv cB wcel vx cA vx cv cA wcel vx cv cF cA cres cfv vx cv cF cfv cB
      vx cv cA cF fvres eleq1d ralbiia syl6rbb biimpa anasss 3impa vx cB cF cA
      cres cA cJ cop csubsp cfv cK cA cJ cop csubsp cfv cuni cY cA cJ cop
      csubsp cfv cuni eqid cnres2.2 cnimass sylan32c $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J x y z $. $d K x y z $. $d F x y z $.
    $( A continuous function is continuous onto its image. $)
    cnresima $p |- ( ( J e. Top /\ K e. Top /\ F e. ( J Cn K ) )
                              -> F e. ( J Cn ( subSp ` <. ran F , K >. ) ) ) $=
      cJ ctop wcel cK ctop wcel cF cJ cK ccn co wcel cF cJ cF crn cK cop csubsp
      cfv ccn co wcel cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cJ cuni
      cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa cF cJ cF crn cK
      cop csubsp cfv ccn co wcel cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co
      wcel cJ cuni cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa vx cF
      cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid iscn biimpa cJ ctop wcel
      cK ctop wcel wa cJ cuni cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK
      wral wa wa cF cJ cF crn cK cop csubsp cfv ccn co wcel cJ cuni cF crn cK
      cop csubsp cfv cuni cF wf cF ccnv vy cv cima cJ wcel vy cF crn cK cop
      csubsp cfv wral wa cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf cF
      ccnv vx cv cima cJ wcel vx cK wral wa wa cJ cuni cF crn cK cop csubsp cfv
      cuni cF wf cF ccnv vy cv cima cJ wcel vy cF crn cK cop csubsp cfv wral cK
      ctop wcel cJ cuni cK cuni cF wf cJ cuni cF crn cK cop csubsp cfv cuni cF
      wf cJ ctop wcel cF ccnv vx cv cima cJ wcel vx cK wral cK ctop wcel cJ
      cuni cK cuni cF wf wa cJ cuni cF crn cK cop csubsp cfv cuni cF wf cJ cuni
      cF crn cF wf cJ cuni cK cuni cF wf cJ cuni cF crn cF wf cK ctop wcel cJ
      cuni cK cuni cF wf cF cJ cuni wfn cJ cuni cF crn cF wf cJ cuni cK cuni cF
      ffn cJ cuni cF dffn3 sylib adantl cK ctop wcel cJ cuni cK cuni cF wf wa
      cF crn cK cop csubsp cfv cuni cF crn wceq cJ cuni cF crn cK cop csubsp
      cfv cuni cF wf cJ cuni cF crn cF wf wb cK ctop wcel cF crn cK cuni wss cF
      crn cK cop csubsp cfv cuni cF crn wceq cJ cuni cK cuni cF wf cF crn cK
      stoig2 cJ cuni cK cuni cF frn sylan2 cF crn cK cop csubsp cfv cuni cF crn
      cJ cuni cF feq3 syl mpbird ad2ant2lr cJ ctop wcel cK ctop wcel wa cJ cuni
      cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa wa cF ccnv vy cv
      cima cJ wcel vy cF crn cK cop csubsp cfv cJ ctop wcel cK ctop wcel wa cJ
      cuni cK cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa wa vy cv cF
      crn cK cop csubsp cfv wcel vy cv vz cv cF crn cin wceq vz cK wrex cF ccnv
      vy cv cima cJ wcel cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf vy
      cv cF crn cK cop csubsp cfv wcel vy cv vz cv cF crn cin wceq vz cK wrex
      wb cF ccnv vx cv cima cJ wcel vx cK wral cK ctop wcel cJ ctop wcel cJ
      cuni cK cuni cF wf vy cv cF crn cK cop csubsp cfv wcel vy cv vz cv cF crn
      cin wceq vz cK wrex wb cK ctop wcel cJ ctop wcel cJ cuni cK cuni cF wf vy
      cv cF crn cK cop csubsp cfv wcel vy cv vz cv cF crn cin wceq vz cK wrex
      wb cK ctop wcel cF crn cvv wcel vy cv cF crn cK cop csubsp cfv wcel vy cv
      vz cv cF crn cin wceq vz cK wrex wb cJ ctop wcel cJ cuni cK cuni cF wf wa
      cK ctop wcel vy cv cvv wcel cF crn cvv wcel vy cv cF crn cK cop csubsp
      cfv wcel vy cv vz cv cF crn cin wceq vz cK wrex wb vy visset vz vy cv cF
      crn cvv cK issubspt mp3an2 cJ ctop wcel cJ cuni cK cuni cF wf wa cF cvv
      wcel cF crn cvv wcel cJ cuni cK cuni cF wf cJ ctop wcel cF cvv wcel cJ
      cuni cK cuni cF wf cJ cuni cvv wcel cF cvv wcel cJ ctop wcel cJ cuni cK
      cuni cvv cF fex cJ ctop uniexg sylan2 ancoms cF cvv rnexg syl sylan2
      anassrs ancom1s adantrr cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF
      wf cF ccnv vx cv cima cJ wcel vx cK wral vy cv vz cv cF crn cin wceq vz
      cK wrex cF ccnv vy cv cima cJ wcel wi cJ ctop wcel cK ctop wcel wa cJ
      cuni cK cuni cF wf wa cF ccnv vx cv cima cJ wcel vx cK wral wa vy cv vz
      cv cF crn cin wceq cF ccnv vy cv cima cJ wcel vz cK cJ ctop wcel cK ctop
      wcel wa cJ cuni cK cuni cF wf wa cF ccnv vx cv cima cJ wcel vx cK wral vz
      cv cK wcel vy cv vz cv cF crn cin wceq cF ccnv vy cv cima cJ wcel wi cJ
      ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf wa cF ccnv vz cv cima cJ
      wcel vy cv vz cv cF crn cin wceq cF ccnv vy cv cima cJ wcel wi cF ccnv vx
      cv cima cJ wcel vx cK wral vz cv cK wcel wa vy cv vz cv cF crn cin wceq
      cF ccnv vy cv cima cJ wcel cF ccnv vz cv cF crn cin cima cJ wcel cJ ctop
      wcel cK ctop wcel wa cJ cuni cK cuni cF wf wa cF ccnv vz cv cima cJ wcel
      wa vy cv vz cv cF crn cin wceq cF ccnv vy cv cima cF ccnv vz cv cF crn
      cin cima cJ vy cv vz cv cF crn cin cF ccnv imaeq2 eleq1d cJ ctop wcel cK
      ctop wcel wa cJ cuni cK cuni cF wf wa cF ccnv vz cv cF crn cin cima cJ
      wcel cF ccnv vz cv cima cJ wcel cJ ctop wcel cK ctop wcel wa cJ cuni cK
      cuni cF wf wa cF ccnv vz cv cF crn cin cima cF ccnv vz cv cima cJ cJ cuni
      cK cuni cF wf cF ccnv vz cv cF crn cin cima cF ccnv vz cv cima wceq cJ
      ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf cF cJ cuni wfn cF ccnv vz
      cv cF crn cin cima cF ccnv vz cv cima wceq cJ cuni cK cuni cF ffn cF cJ
      cuni wfn vx cF ccnv vz cv cF crn cin cima cF ccnv vz cv cima cF cJ cuni
      wfn vx cv cJ cuni wcel vx cv cF cfv vz cv cF crn cin wcel wa vx cv cJ
      cuni wcel vx cv cF cfv vz cv wcel wa vx cv cF ccnv vz cv cF crn cin cima
      wcel vx cv cF ccnv vz cv cima wcel cF cJ cuni wfn vx cv cJ cuni wcel vx
      cv cF cfv vz cv cF crn cin wcel vx cv cF cfv vz cv wcel cF cJ cuni wfn vx
      cv cJ cuni wcel wa vx cv cF cfv vz cv wcel vx cv cF cfv cF crn wcel wa vx
      cv cF cfv vz cv wcel vx cv cF cfv vz cv cF crn cin wcel cF cJ cuni wfn vx
      cv cJ cuni wcel wa vx cv cF cfv cF crn wcel vx cv cF cfv vz cv wcel vx cv
      cF cfv cF crn wcel wa vx cv cF cfv vz cv wcel wb cJ cuni vx cv cF
      fnfvelrn vx cv cF cfv cF crn wcel vx cv cF cfv vz cv wcel vx cv cF cfv cF
      crn wcel wa vx cv cF cfv vz cv wcel vx cv cF cfv vz cv wcel vx cv cF cfv
      cF crn wcel pm3.26 vx cv cF cfv cF crn wcel vx cv cF cfv vz cv wcel
      pm3.21 impbid2 syl vx cv cF cfv vz cv cF crn elin syl5bb pm5.32da cJ cuni
      vx cv vz cv cF crn cin cF elpreima cJ cuni vx cv vz cv cF elpreima
      3bitr4d eqrdv syl adantl eleq1d biimpar syl5cbir cF ccnv vx cv cima cJ
      wcel cF ccnv vz cv cima cJ wcel vx vz cv cK vx cv vz cv wceq cF ccnv vx
      cv cima cF ccnv vz cv cima cJ vx cv vz cv cF ccnv imaeq2 eleq1d rcla4cva
      sylan2 anassrs r19.23adva anasss sylbid r19.21aiv jca cJ ctop wcel cF crn
      cK cop csubsp cfv ctop wcel cF cJ cF crn cK cop csubsp cfv ccn co wcel cJ
      cuni cF crn cK cop csubsp cfv cuni cF wf cF ccnv vy cv cima cJ wcel vy cF
      crn cK cop csubsp cfv wral wa wb cJ ctop wcel cK ctop wcel wa cJ cuni cK
      cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa wa vy cF cJ cF crn cK
      cop csubsp cfv cJ cuni cF crn cK cop csubsp cfv cuni cJ cuni eqid cF crn
      cK cop csubsp cfv cuni eqid iscn cJ ctop wcel cK ctop wcel cJ cuni cK
      cuni cF wf cF ccnv vx cv cima cJ wcel vx cK wral wa simpll cK ctop wcel
      cJ cuni cK cuni cF wf cF crn cK cop csubsp cfv ctop wcel cJ ctop wcel cF
      ccnv vx cv cima cJ wcel vx cK wral cK ctop wcel cF crn cK cuni wss cF crn
      cK cop csubsp cfv ctop wcel cJ cuni cK cuni cF wf cF crn cK stoig3 cJ
      cuni cK cuni cF frn sylan2 ad2ant2lr sylanc mpbird syldan 3impa $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J u v $. $d K u v $. $d Y u v $. $d A u v $. $d F u v $.
    cnss.1 $e |- Y = U. K $.
    $( A continuous function into a subspace is continuous into the
       larger space. $)
    cnss $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( A C_ Y /\
              F e. ( J Cn ( subSp ` <. A , K >. ) ) ) ) -> F e. ( J Cn K ) ) $=
      cJ ctop wcel cK ctop wcel wa cA cY wss cF cJ cA cK cop csubsp cfv ccn co
      wcel cF cJ cK ccn co wcel cJ ctop wcel cK ctop wcel wa cA cY wss wa cJ
      cuni cA cK cop csubsp cfv cuni cF wf cF ccnv vv cv cima cJ wcel vv cA cK
      cop csubsp cfv wral wa cJ cuni cY cF wf cF ccnv vu cv cima cJ wcel vu cK
      wral wa cF cJ cA cK cop csubsp cfv ccn co wcel cF cJ cK ccn co wcel cJ
      ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni cA cK cop csubsp cfv cuni
      cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa cJ cuni
      cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa cJ
      cuni cY cF wf cF ccnv vu cv cima cJ wcel vu cK wral wa cJ ctop wcel cK
      ctop wcel wa cA cY wss wa cJ cuni cA cK cop csubsp cfv cuni cF wf cJ cuni
      cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral cJ ctop
      wcel cK ctop wcel wa cA cY wss wa cA cK cop csubsp cfv cuni cA wceq cJ
      cuni cA cK cop csubsp cfv cuni cF wf cJ cuni cA cF wf wb cK ctop wcel cA
      cY wss cA cK cop csubsp cfv cuni cA wceq cJ ctop wcel cK ctop wcel cA cK
      cuni wss cA cK cop csubsp cfv cuni cA wceq cA cY wss cA cK stoig2 cY cK
      cuni cA cnss.1 sseq2i sylan2b adantll cA cK cop csubsp cfv cuni cA cJ
      cuni cF feq3 syl anbi1d cJ ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni
      cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa cJ
      cuni cY cF wf cF ccnv vu cv cima cJ wcel vu cK wral cA cY wss cJ cuni cA
      cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa cJ cuni
      cY cF wf wi cJ ctop wcel cK ctop wcel wa cA cY wss cJ cuni cA cF wf cJ
      cuni cY cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral cJ
      cuni cA cF wf cA cY wss cJ cuni cY cF wf cJ cuni cA cY cF fss expcom
      adantrd adantl cJ ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni cA cF wf
      cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa cF ccnv vu cv
      cima cJ wcel vu cK wral cJ ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni
      cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa wa cF
      ccnv vu cv cima cJ wcel vu cK cJ ctop wcel cK ctop wcel wa cA cY wss wa
      cJ cuni cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral
      wa wa vu cv cK wcel wa cF ccnv vu cv cima cF ccnv vu cv cA cin cima cJ cJ
      ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni cA cF wf cF ccnv vv cv
      cima cJ wcel vv cA cK cop csubsp cfv wral wa wa vu cv cK wcel wa cF ccnv
      vu cv cA cin cima cF ccnv vu cv cima cF ccnv cA cima cin cF ccnv vu cv
      cima cJ ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni cA cF wf cF ccnv
      vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa wa vu cv cK wcel wa cF
      wfun cF ccnv vu cv cA cin cima cF ccnv vu cv cima cF ccnv cA cima cin
      wceq cJ cuni cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv
      wral wa cF wfun cJ ctop wcel cK ctop wcel wa cA cY wss wa vu cv cK wcel
      cJ cuni cA cF wf cF wfun cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp
      cfv wral cJ cuni cA cF ffun adantr ad2antlr vu cv cA cF inpreima syl cJ
      ctop wcel cK ctop wcel wa cA cY wss wa cJ cuni cA cF wf cF ccnv vv cv
      cima cJ wcel vv cA cK cop csubsp cfv wral wa wa vu cv cK wcel wa cF ccnv
      vu cv cima cF ccnv cA cima wss cF ccnv vu cv cima cF ccnv cA cima cin cF
      ccnv vu cv cima wceq cJ cuni cA cF wf cF ccnv vv cv cima cJ wcel vv cA cK
      cop csubsp cfv wral wa cF ccnv vu cv cima cF ccnv cA cima wss cJ ctop
      wcel cK ctop wcel wa cA cY wss wa vu cv cK wcel cJ cuni cA cF wf cF ccnv
      vu cv cima cF ccnv cA cima wss cF ccnv vv cv cima cJ wcel vv cA cK cop
      csubsp cfv wral cJ cuni cA cF wf cF ccnv vu cv cima cJ cuni cF ccnv cA
      cima cJ cuni cA cF wf cF ccnv vu cv cima cF ccnv crn cJ cuni cF ccnv vu
      cv cima cF ccnv crn wss cJ cuni cA cF wf cF ccnv vu cv imassrn a1i cJ
      cuni cA cF wf cF cdm cJ cuni cF ccnv crn cJ cuni cA cF fdm cF dfdm4
      syl5eqr sseqtrd cJ cuni cA cF fimacnv sseqtr4d adantr ad2antlr cF ccnv vu
      cv cima cF ccnv cA cima df-ss sylib eqtr2d cJ ctop wcel cK ctop wcel wa
      cA cY wss wa cF ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral vu
      cv cK wcel cF ccnv vu cv cA cin cima cJ wcel cJ cuni cA cF wf cJ ctop
      wcel cK ctop wcel wa cA cY wss wa vu cv cK wcel cF ccnv vv cv cima cJ
      wcel vv cA cK cop csubsp cfv wral cF ccnv vu cv cA cin cima cJ wcel vu cv
      cA cin cA cK cop csubsp cfv wcel cF ccnv vv cv cima cJ wcel vv cA cK cop
      csubsp cfv wral cF ccnv vu cv cA cin cima cJ wcel cJ ctop wcel cK ctop
      wcel wa cA cY wss wa vu cv cK wcel wa cF ccnv vv cv cima cJ wcel cF ccnv
      vu cv cA cin cima cJ wcel vv vu cv cA cin cA cK cop csubsp cfv vv cv vu
      cv cA cin wceq cF ccnv vv cv cima cF ccnv vu cv cA cin cima cJ vv cv vu
      cv cA cin cF ccnv imaeq2 eleq1d rcla4va cK ctop wcel cA cY wss vu cv cK
      wcel vu cv cA cin cA cK cop csubsp cfv wcel cJ ctop wcel cK ctop wcel cA
      cY wss wa vu cv cK wcel wa vu cv cA cin cA cK cop csubsp cfv wcel vu cv
      cA cin vv cv cA cin wceq vv cK wrex vu cv cK wcel vu cv cA cin vv cv cA
      cin wceq vv cK wrex cK ctop wcel cA cY wss wa vu cv cK wcel vu cv cA cin
      vu cv cA cin wceq vu cv cA cin vv cv cA cin wceq vv cK wrex vu cv cA cin
      eqid vu cv cA cin vv cv cA cin wceq vu cv cA cin vu cv cA cin wceq vv vu
      cv cK vv cv vu cv wceq vv cv cA cin vu cv cA cin vu cv cA cin vv cv vu cv
      cA ineq1 eqeq2d rcla4ev mpan2 adantl cK ctop wcel cA cY wss wa vu cv cA
      cin cA cK cop csubsp cfv wcel vu cv cA cin vv cv cA cin wceq vv cK wrex
      wb vu cv cK wcel cK ctop wcel cA cY wss cA cvv wcel vu cv cA cin cA cK
      cop csubsp cfv wcel vu cv cA cin vv cv cA cin wceq vv cK wrex wb cA cY
      wss cK ctop wcel cA cvv wcel cA cY wss cY cvv wcel cA cvv wcel cK ctop
      wcel cA cY cvv ssexg cK ctop wcel cK cuni cvv cY cK ctop uniexg cnss.1
      syl5eqel sylan2 ancoms cK ctop wcel vu cv cA cin cvv wcel cA cvv wcel vu
      cv cA cin cA cK cop csubsp cfv wcel vu cv cA cin vv cv cA cin wceq vv cK
      wrex wb vu cv cA vu visset inex1 vv vu cv cA cin cA cvv cK issubspt
      mp3an2 syldan adantr mpbird adantlll sylan an1rs adantlrl eqeltrd
      r19.21aiva ex jcad sylbid cJ ctop wcel cK ctop wcel cA cY wss cF cJ cA cK
      cop csubsp cfv ccn co wcel cJ cuni cA cK cop csubsp cfv cuni cF wf cF
      ccnv vv cv cima cJ wcel vv cA cK cop csubsp cfv wral wa wb cJ ctop wcel
      cA cK cop csubsp cfv ctop wcel cF cJ cA cK cop csubsp cfv ccn co wcel cJ
      cuni cA cK cop csubsp cfv cuni cF wf cF ccnv vv cv cima cJ wcel vv cA cK
      cop csubsp cfv wral wa wb cK ctop wcel cA cY wss wa vv cF cJ cA cK cop
      csubsp cfv cJ cuni cA cK cop csubsp cfv cuni cJ cuni eqid cA cK cop
      csubsp cfv cuni eqid iscn cK ctop wcel cA cK cuni wss cA cK cop csubsp
      cfv ctop wcel cA cY wss cA cK stoig3 cY cK cuni cA cnss.1 sseq2i sylan2b
      sylan2 anassrs cJ ctop wcel cK ctop wcel wa cF cJ cK ccn co wcel cJ cuni
      cY cF wf cF ccnv vu cv cima cJ wcel vu cK wral wa wb cA cY wss vu cF cJ
      cK cJ cuni cY cJ cuni eqid cnss.1 iscn adantr 3imtr4d impr $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J y $. $d K y $. $d A y $. $d B y $. $d X y $. $d Y y $. $d F y $.
    paste.1 $e |- X = U. J $.
    paste.2 $e |- Y = U. K $.
    $( Pasting lemma. If ` A ` and ` B ` are closed sets in ` X ` with
       ` A u. B = X ` , then any function whose restrictions to ` A ` and ` B `
       are continuous is continuous on all of ` X ` . $)
    paste $p |- ( ( ( J e. Top /\ K e. Top ) /\
            ( A e. ( Clsd ` J ) /\ B e. ( Clsd ` J ) /\ ( A u. B ) = X ) /\
             ( F : X --> Y /\ ( F |` A ) e. ( ( subSp ` <. A , J >. ) Cn K ) /\
                        ( F |` B ) e. ( ( subSp ` <. B , J >. ) Cn K ) ) )
                                          -> F e. ( J Cn K ) ) $=
      cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA
      cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co
      wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a cF cJ cK ccn
      co wcel cX cY cF wf cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv
      wral wa cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv
      wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK
      ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a cX cY
      cF wf cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv wral cX cY cF wf
      cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop
      csubsp cfv cK ccn co wcel w3a cJ ctop wcel cK ctop wcel wa cX cY cF wf cA
      cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB cun cX wceq w3a cX cY cF wf cF
      cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop csubsp
      cfv cK ccn co wcel 3simp1 3ad2ant3 cJ ctop wcel cK ctop wcel wa cA cJ
      ccld cfv wcel cB cJ ccld cfv wcel cA cB cun cX wceq w3a cX cY cF wf cF cA
      cres cA cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv
      cK ccn co wcel w3a w3a cF ccnv vy cv cima cJ ccld cfv wcel vy cK ccld cfv
      cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA
      cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co
      wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a vy cv cK ccld
      cfv wcel wa cF ccnv vy cv cima cF cA cres ccnv vy cv cima cF cB cres ccnv
      vy cv cima cun cJ ccld cfv cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv
      wcel cB cJ ccld cfv wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA
      cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn
      co wcel w3a w3a cF ccnv vy cv cima cF cA cres ccnv vy cv cima cF cB cres
      ccnv vy cv cima cun wceq vy cv cK ccld cfv wcel cA cJ ccld cfv wcel cB cJ
      ccld cfv wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop
      csubsp cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel
      w3a cF ccnv vy cv cima cF cA cres ccnv vy cv cima cF cB cres ccnv vy cv
      cima cun wceq cJ ctop wcel cK ctop wcel wa cA cB cun cX wceq cA cJ ccld
      cfv wcel cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB
      cres cB cJ cop csubsp cfv cK ccn co wcel w3a cF ccnv vy cv cima cF cA
      cres ccnv vy cv cima cF cB cres ccnv vy cv cima cun wceq cB cJ ccld cfv
      wcel cA cB cun cX wceq cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cX
      cY cF wf cF ccnv vy cv cima cF cA cres ccnv vy cv cima cF cB cres ccnv vy
      cv cima cun wceq cF cB cres cB cJ cop csubsp cfv cK ccn co wcel cA cB cun
      cX wceq cX cY cF wf wa cF ccnv vy cv cima cF ccnv vy cv cima cX cin cF
      ccnv vy cv cima cA cB cun cin cF cA cres ccnv vy cv cima cF cB cres ccnv
      vy cv cima cun cX cY cF wf cF ccnv vy cv cima cF ccnv vy cv cima cX cin
      wceq cA cB cun cX wceq cX cY cF wf cF ccnv vy cv cima cX wss cF ccnv vy
      cv cima cF ccnv vy cv cima cX cin wceq cX cY cF wf cF ccnv vy cv cima cF
      ccnv crn cX cF ccnv vy cv cima cF ccnv crn wss cX cY cF wf cF ccnv vy cv
      imassrn a1i cX cY cF wf cF cdm cX cF ccnv crn cX cY cF fdm cF dfdm4
      syl5eqr sseqtrd cF ccnv vy cv cima cX wss cF ccnv vy cv cima cX cin cF
      ccnv vy cv cima cF ccnv vy cv cima cX wss cF ccnv vy cv cima cX cin cF
      ccnv vy cv cima wceq cF ccnv vy cv cima cX df-ss biimpi eqcomd syl adantl
      cA cB cun cX wceq cF ccnv vy cv cima cX cin cF ccnv vy cv cima cA cB cun
      cin wceq cX cY cF wf cF ccnv vy cv cima cX cin cF ccnv vy cv cima cA cB
      cun cin wceq cX cA cB cun cX cA cB cun cF ccnv vy cv cima ineq2 eqcoms
      adantr cX cY cF wf cF ccnv vy cv cima cA cB cun cin cF cA cres ccnv vy cv
      cima cF cB cres ccnv vy cv cima cun wceq cA cB cun cX wceq cX cY cF wf cF
      cA cres ccnv vy cv cima cF cB cres ccnv vy cv cima cun cF ccnv vy cv cima
      cA cin cF ccnv vy cv cima cB cin cun cF ccnv vy cv cima cA cB cun cin cX
      cY cF wf cF wfun cF cA cres ccnv vy cv cima cF cB cres ccnv vy cv cima
      cun cF ccnv vy cv cima cA cin cF ccnv vy cv cima cB cin cun wceq cX cY cF
      ffun cF wfun cF cA cres ccnv vy cv cima cF ccnv vy cv cima cA cin cF cB
      cres ccnv vy cv cima cF ccnv vy cv cima cB cin vy cv cA cF respreima vy
      cv cB cF respreima uneq12d syl cF ccnv vy cv cima cA cB indi syl6reqr
      adantl 3eqtrd 3ad2antr1 3ad2antl3 3adant1 adantr cJ ctop wcel cF cA cres
      ccnv vy cv cima cJ ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv
      wcel cF cA cres ccnv vy cv cima cF cB cres ccnv vy cv cima cun cJ ccld
      cfv wcel cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv
      wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK
      ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a vy cv
      cK ccld cfv wcel wa cF cA cres ccnv vy cv cima cF cB cres ccnv vy cv cima
      cJ uncld cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv
      wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK
      ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a cJ
      ctop wcel vy cv cK ccld cfv wcel cJ ctop wcel cK ctop wcel wa cA cJ ccld
      cfv wcel cB cJ ccld cfv wcel cA cB cun cX wceq w3a cJ ctop wcel cX cY cF
      wf cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop
      csubsp cfv cK ccn co wcel w3a cJ ctop wcel cK ctop wcel pm3.26 3ad2ant1
      adantr cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv
      wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK
      ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a vy cv
      cK ccld cfv wcel cF cA cres ccnv vy cv cima cJ ccld cfv wcel cJ ctop wcel
      cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB cun cX wceq
      w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB cres
      cB cJ cop csubsp cfv cK ccn co wcel w3a vy cv cK ccld cfv wcel cF cA cres
      ccnv vy cv cima cJ ccld cfv wcel wi cJ ctop wcel cK ctop wcel wa cB cJ
      ccld cfv wcel cA cJ ccld cfv wcel cX cY cF wf cF cA cres cA cJ cop csubsp
      cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a vy
      cv cK ccld cfv wcel cF cA cres ccnv vy cv cima cJ ccld cfv wcel wi wi cA
      cB cun cX wceq cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel wa cX cY
      cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop
      csubsp cfv cK ccn co wcel w3a vy cv cK ccld cfv wcel cF cA cres ccnv vy
      cv cima cJ ccld cfv wcel wi cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv
      wcel wa cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co wcel vy cv
      cK ccld cfv wcel cF cA cres ccnv vy cv cima cJ ccld cfv wcel wi cF cB
      cres cB cJ cop csubsp cfv cK ccn co wcel cJ ctop wcel cK ctop wcel wa cA
      cJ ccld cfv wcel wa cF cA cres cA cJ cop csubsp cfv cK ccn co wcel wa vy
      cv cK ccld cfv wcel cF cA cres ccnv vy cv cima cA cJ cop csubsp cfv ccld
      cfv wcel cF cA cres ccnv vy cv cima cJ ccld cfv wcel cJ ctop wcel cK ctop
      wcel wa cA cJ ccld cfv wcel wa cF cA cres cA cJ cop csubsp cfv cK ccn co
      wcel vy cv cK ccld cfv wcel cF cA cres ccnv vy cv cima cA cJ cop csubsp
      cfv ccld cfv wcel wi cJ ctop wcel cA cJ ccld cfv wcel cK ctop wcel cF cA
      cres cA cJ cop csubsp cfv cK ccn co wcel vy cv cK ccld cfv wcel cF cA
      cres ccnv vy cv cima cA cJ cop csubsp cfv ccld cfv wcel wi wi cA cJ cop
      csubsp cfv ctop wcel cK ctop wcel cF cA cres cA cJ cop csubsp cfv cK ccn
      co wcel vy cv cK ccld cfv wcel cF cA cres ccnv vy cv cima cA cJ cop
      csubsp cfv ccld cfv wcel wi wi cJ ctop wcel cA cJ ccld cfv wcel wa cA cJ
      cop csubsp cfv ctop wcel cK ctop wcel cF cA cres cA cJ cop csubsp cfv cK
      ccn co wcel vy cv cK ccld cfv wcel cF cA cres ccnv vy cv cima cA cJ cop
      csubsp cfv ccld cfv wcel wi cA cJ cop csubsp cfv ctop wcel cK ctop wcel
      cF cA cres cA cJ cop csubsp cfv cK ccn co wcel w3a vy cv cK ccld cfv wcel
      cF cA cres ccnv vy cv cima cA cJ cop csubsp cfv ccld cfv wcel vy cv cF cA
      cres cA cJ cop csubsp cfv cK cnclima ex 3expia cJ ctop wcel cA cJ ccld
      cfv wcel cA cJ cuni wss cA cJ cop csubsp cfv ctop wcel cA cJ cJ cuni cJ
      cuni eqid cldss cA cJ stoig3 syldan sylan an1rs imp cJ ctop wcel cK ctop
      wcel wa cA cJ ccld cfv wcel wa cF cA cres ccnv vy cv cima cA cJ cop
      csubsp cfv ccld cfv wcel cF cA cres ccnv vy cv cima cJ ccld cfv wcel wi
      cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cJ ctop wcel cA cJ ccld
      cfv wcel cF cA cres ccnv vy cv cima cA cJ cop csubsp cfv ccld cfv wcel cF
      cA cres ccnv vy cv cima cJ ccld cfv wcel wi cK ctop wcel cJ ctop wcel cA
      cJ ccld cfv wcel cF cA cres ccnv vy cv cima cA cJ cop csubsp cfv ccld cfv
      wcel cF cA cres ccnv vy cv cima cJ ccld cfv wcel cA cF cA cres ccnv vy cv
      cima cJ subspcld2 3expia adantlr adantr syld 3ad2antr2 ex 3ad2antr1
      3impia imp cJ ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld
      cfv wcel cA cB cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp
      cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a w3a
      vy cv cK ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv wcel cJ
      ctop wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB
      cun cX wceq w3a cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co
      wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a vy cv cK ccld cfv
      wcel cF cB cres ccnv vy cv cima cJ ccld cfv wcel wi cJ ctop wcel cK ctop
      wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv wcel cX cY cF wf cF cA cres cA
      cJ cop csubsp cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn
      co wcel w3a vy cv cK ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv
      wcel wi wi cA cB cun cX wceq cJ ctop wcel cK ctop wcel wa cB cJ ccld cfv
      wcel wa cX cY cF wf cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cF cB
      cres cB cJ cop csubsp cfv cK ccn co wcel w3a vy cv cK ccld cfv wcel cF cB
      cres ccnv vy cv cima cJ ccld cfv wcel wi cJ ctop wcel cK ctop wcel wa cB
      cJ ccld cfv wcel wa cX cY cF wf cF cB cres cB cJ cop csubsp cfv cK ccn co
      wcel vy cv cK ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv wcel
      wi cF cA cres cA cJ cop csubsp cfv cK ccn co wcel cJ ctop wcel cK ctop
      wcel wa cB cJ ccld cfv wcel wa cF cB cres cB cJ cop csubsp cfv cK ccn co
      wcel wa vy cv cK ccld cfv wcel cF cB cres ccnv vy cv cima cB cJ cop
      csubsp cfv ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv wcel cJ
      ctop wcel cK ctop wcel wa cB cJ ccld cfv wcel wa cF cB cres cB cJ cop
      csubsp cfv cK ccn co wcel vy cv cK ccld cfv wcel cF cB cres ccnv vy cv
      cima cB cJ cop csubsp cfv ccld cfv wcel wi cJ ctop wcel cB cJ ccld cfv
      wcel cK ctop wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel vy cv cK
      ccld cfv wcel cF cB cres ccnv vy cv cima cB cJ cop csubsp cfv ccld cfv
      wcel wi wi cB cJ cop csubsp cfv ctop wcel cK ctop wcel cF cB cres cB cJ
      cop csubsp cfv cK ccn co wcel vy cv cK ccld cfv wcel cF cB cres ccnv vy
      cv cima cB cJ cop csubsp cfv ccld cfv wcel wi wi cJ ctop wcel cB cJ ccld
      cfv wcel wa cB cJ cop csubsp cfv ctop wcel cK ctop wcel cF cB cres cB cJ
      cop csubsp cfv cK ccn co wcel vy cv cK ccld cfv wcel cF cB cres ccnv vy
      cv cima cB cJ cop csubsp cfv ccld cfv wcel wi cB cJ cop csubsp cfv ctop
      wcel cK ctop wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a vy
      cv cK ccld cfv wcel cF cB cres ccnv vy cv cima cB cJ cop csubsp cfv ccld
      cfv wcel vy cv cF cB cres cB cJ cop csubsp cfv cK cnclima ex 3expia cJ
      ctop wcel cB cJ ccld cfv wcel cB cJ cuni wss cB cJ cop csubsp cfv ctop
      wcel cB cJ cJ cuni cJ cuni eqid cldss cB cJ stoig3 syldan sylan an1rs imp
      cJ ctop wcel cK ctop wcel wa cB cJ ccld cfv wcel wa cF cB cres ccnv vy cv
      cima cB cJ cop csubsp cfv ccld cfv wcel cF cB cres ccnv vy cv cima cJ
      ccld cfv wcel wi cF cB cres cB cJ cop csubsp cfv cK ccn co wcel cJ ctop
      wcel cB cJ ccld cfv wcel cF cB cres ccnv vy cv cima cB cJ cop csubsp cfv
      ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv wcel wi cK ctop wcel
      cJ ctop wcel cB cJ ccld cfv wcel cF cB cres ccnv vy cv cima cB cJ cop
      csubsp cfv ccld cfv wcel cF cB cres ccnv vy cv cima cJ ccld cfv wcel cB
      cF cB cres ccnv vy cv cima cJ subspcld2 3expia adantlr adantr syld
      3ad2antr3 ex 3ad2antr2 3impia imp syl3anc eqeltrd r19.21aiva jca cJ ctop
      wcel cK ctop wcel wa cA cJ ccld cfv wcel cB cJ ccld cfv wcel cA cB cun cX
      wceq w3a cF cJ cK ccn co wcel cX cY cF wf cF ccnv vy cv cima cJ ccld cfv
      wcel vy cK ccld cfv wral wa wb cX cY cF wf cF cA cres cA cJ cop csubsp
      cfv cK ccn co wcel cF cB cres cB cJ cop csubsp cfv cK ccn co wcel w3a vy
      cF cJ cK cX cY paste.1 paste.2 iscncl 3ad2ant1 mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y $. $d B x y $. $d C x y $. $d R y $. $d S y $.
    $d J x y $. $d K x y $. $d L x y $. $d M x y $.
    piececn.1 $e |- A e. RR $.
    piececn.2 $e |- B e. RR $.
    piececn.3 $e |- C e. ( A [,] B ) $.
    piececn.4 $e |- R e. _V $.
    piececn.5 $e |- S e. _V $.
    piececn.6 $e |- F = { <. x , y >. | ( x e. ( A [,] B )
                                            /\ y = if ( x <_ C , R , S ) ) } $.
    piececn.7 $e |- J = ( subSp ` <. ( A [,] B ) , ( topGen ` ran (,) ) >. ) $.
    piececn.8 $e |- K = ( subSp ` <. ( A [,] C ) , ( topGen ` ran (,) ) >. ) $.
    piececn.9 $e |- L = ( subSp ` <. ( C [,] B ) , ( topGen ` ran (,) ) >. ) $.
    piececn.10 $e |- ( x = C -> R = S ) $.
    piececn.11 $e |- G = { <. x , y >. | ( x e. ( A [,] C ) /\ y = R ) } $.
    piececn.12 $e |- H = { <. x , y >. | ( x e. ( C [,] B ) /\ y = S ) } $.
    piececn.13 $e |- M e. Top $.
    piececn.14 $e |- G e. ( K Cn M ) $.
    piececn.15 $e |- H e. ( L Cn M ) $.
    $( Piecewise definition of a continuous function on a real interval. $)
    piececn $p |- F e. ( J Cn M ) $=
      cJ ctop wcel cM ctop wcel wa cA cC cicc co cJ ccld cfv wcel cC cB cicc co
      cJ ccld cfv wcel cA cC cicc co cC cB cicc co cun cA cB cicc co wceq w3a
      cA cB cicc co cM cuni cF wf cF cA cC cicc co cres cA cC cicc co cJ cop
      csubsp cfv cM ccn co wcel cF cC cB cicc co cres cC cB cicc co cJ cop
      csubsp cfv cM ccn co wcel w3a cF cJ cM ccn co wcel cJ ctop wcel cM ctop
      wcel cJ cA cB cicc co cioo crn ctg cfv cop csubsp cfv ctop piececn.7 cioo
      crn ctg cfv ctop wcel cA cB cicc co cioo crn ctg cfv cuni wss cA cB cicc
      co cioo crn ctg cfv cop csubsp cfv ctop wcel retop cA cB cicc co cr cioo
      crn ctg cfv cuni cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1
      piececn.2 cA cB iccssre mp2an uniretop sseqtr4i cA cB cicc co cioo crn
      ctg cfv stoig3 mp2an eqeltri piececn.13 pm3.2i cA cC cicc co cJ ccld cfv
      wcel cC cB cicc co cJ ccld cfv wcel cA cC cicc co cC cB cicc co cun cA cB
      cicc co wceq cA cC cicc co cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      ccld cfv cJ ccld cfv cioo crn ctg cfv ctop wcel cA cB cicc co cr wss wa
      cA cC cicc co cioo crn ctg cfv ccld cfv wcel cA cC cicc co cA cB cicc co
      wss wa cA cC cicc co cA cB cicc co cioo crn ctg cfv cop csubsp cfv ccld
      cfv wcel cioo crn ctg cfv ctop wcel cA cB cicc co cr wss retop cA cr wcel
      cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an
      pm3.2i cA cC cicc co cioo crn ctg cfv ccld cfv wcel cA cC cicc co cA cB
      cicc co wss cA cr wcel cC cr wcel cA cC cicc co cioo crn ctg cfv ccld cfv
      wcel piececn.1 cA cB cicc co cr cC cA cr wcel cB cr wcel cA cB cicc co cr
      wss piececn.1 piececn.2 cA cB iccssre mp2an piececn.3 sselii cA cC clint3
      mp2an cA cr wcel cB cr wcel wa cA cr wcel cC cr wcel wa cA cA cle wbr cC
      cB cle wbr wa cA cC cicc co cA cB cicc co wss cA cr wcel cB cr wcel
      piececn.1 piececn.2 pm3.2i cA cr wcel cC cr wcel piececn.1 cA cB cicc co
      cr cC cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA
      cB iccssre mp2an piececn.3 sselii pm3.2i cA cA cle wbr cC cB cle wbr cA
      piececn.1 leidi cC cr wcel cA cC cle wbr cC cB cle wbr cC cA cB cicc co
      wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a piececn.3 cA cr wcel cB
      cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a
      wb piececn.1 piececn.2 cA cB cC elicc2 mp2an mpbi 3simp3i pm3.2i cA cB cA
      cC iccss mp3an pm3.2i cA cB cicc co cA cC cicc co cioo crn ctg cfv cr
      cioo crn ctg cfv cuni cr uniretop eqcomi subspcld mp2an cJ cA cB cicc co
      cioo crn ctg cfv cop csubsp cfv ccld piececn.7 fveq2i eleqtrri cC cB cicc
      co cA cB cicc co cioo crn ctg cfv cop csubsp cfv ccld cfv cJ ccld cfv
      cioo crn ctg cfv ctop wcel cA cB cicc co cr wss wa cC cB cicc co cioo crn
      ctg cfv ccld cfv wcel cC cB cicc co cA cB cicc co wss wa cC cB cicc co cA
      cB cicc co cioo crn ctg cfv cop csubsp cfv ccld cfv wcel cioo crn ctg cfv
      ctop wcel cA cB cicc co cr wss retop cA cr wcel cB cr wcel cA cB cicc co
      cr wss piececn.1 piececn.2 cA cB iccssre mp2an pm3.2i cC cB cicc co cioo
      crn ctg cfv ccld cfv wcel cC cB cicc co cA cB cicc co wss cC cr wcel cB
      cr wcel cC cB cicc co cioo crn ctg cfv ccld cfv wcel cA cB cicc co cr cC
      cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB
      iccssre mp2an piececn.3 sselii piececn.2 cC cB clint3 mp2an cA cr wcel cB
      cr wcel wa cC cr wcel cB cr wcel wa cA cC cle wbr cB cB cle wbr wa cC cB
      cicc co cA cB cicc co wss cA cr wcel cB cr wcel piececn.1 piececn.2
      pm3.2i cC cr wcel cB cr wcel cA cB cicc co cr cC cA cr wcel cB cr wcel cA
      cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an piececn.3
      sselii piececn.2 pm3.2i cA cC cle wbr cB cB cle wbr cC cr wcel cA cC cle
      wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a piececn.3 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a wb piececn.1 piececn.2 cA cB cC
      elicc2 mp2an mpbi 3simp2i cB piececn.2 leidi pm3.2i cA cB cC cB iccss
      mp3an pm3.2i cA cB cicc co cC cB cicc co cioo crn ctg cfv cr cioo crn ctg
      cfv cuni cr uniretop eqcomi subspcld mp2an cJ cA cB cicc co cioo crn ctg
      cfv cop csubsp cfv ccld piececn.7 fveq2i eleqtrri cA cB cicc co cA cC
      cicc co cC cB cicc co cun cA cr wcel cB cr wcel cC cA cB cicc co wcel cA
      cB cicc co cA cC cicc co cC cB cicc co cun wceq piececn.1 piececn.2
      piececn.3 cA cB cC iccsplit mp3an eqcomi 3pm3.2i cA cB cicc co cM cuni cF
      wf cF cA cC cicc co cres cA cC cicc co cJ cop csubsp cfv cM ccn co wcel
      cF cC cB cicc co cres cC cB cicc co cJ cop csubsp cfv cM ccn co wcel vx
      vy cA cB cicc co cM cuni vx cv cC cle wbr cR cS cif cF piececn.6 vx cv cA
      cB cicc co wcel vx cv cA cC cicc co wcel vx cv cC cB cicc co wcel wo vx
      cv cC cle wbr cR cS cif cM cuni wcel vx cv cA cB cicc co wcel vx cv cA cC
      cicc co cC cB cicc co cun wcel vx cv cA cC cicc co wcel vx cv cC cB cicc
      co wcel wo cA cB cicc co cA cC cicc co cC cB cicc co cun vx cv cA cr wcel
      cB cr wcel cC cA cB cicc co wcel cA cB cicc co cA cC cicc co cC cB cicc
      co cun wceq piececn.1 piececn.2 piececn.3 cA cB cC iccsplit mp3an eleq2i
      vx cv cA cC cicc co cC cB cicc co elun bitri vx cv cA cC cicc co wcel vx
      cv cC cle wbr cR cS cif cM cuni wcel vx cv cC cB cicc co wcel vx cv cA cC
      cicc co wcel vx cv cC cle wbr cR cS cif vx cv cG cfv cM cuni vx cv cA cC
      cicc co wcel vx cv cC cle wbr cR cS cif cR vx cv cG cfv vx cv cA cC cicc
      co wcel vx cv cC cle wbr vx cv cC cle wbr cR cS cif cR wceq vx cv cA cC
      cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr vx cv cA cC
      cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a cA cr
      wcel cC cr wcel vx cv cA cC cicc co wcel vx cv cr wcel cA vx cv cle wbr
      vx cv cC cle wbr w3a wb piececn.1 cA cB cicc co cr cC cA cr wcel cB cr
      wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an
      piececn.3 sselii cA cC vx cv elicc2 mp2an biimpi 3simp3d vx cv cC cle wbr
      cR cS iftrue syl vx cv cA cC cicc co wcel vx cv vx cv cA cC cicc co wcel
      vy cv cR wceq wa vx vy copab cfv cR vx cv cG cfv vx cv cA cC cicc co wcel
      cR cvv wcel vx cv vx cv cA cC cicc co wcel vy cv cR wceq wa vx vy copab
      cfv cR wceq piececn.4 vx vy cA cC cicc co cR cvv fvopab2 mpan2 vx cv cG
      vx cv cA cC cicc co wcel vy cv cR wceq wa vx vy copab piececn.11 fveq1i
      syl5eq eqtr4d cA cC cicc co cM cuni vx cv cG cK ctop wcel cM ctop wcel cG
      cK cM ccn co wcel cA cC cicc co cM cuni cG wf cK cA cC cicc co cioo crn
      ctg cfv cop csubsp cfv ctop piececn.8 cioo crn ctg cfv ctop wcel cA cC
      cicc co cioo crn ctg cfv cuni wss cA cC cicc co cioo crn ctg cfv cop
      csubsp cfv ctop wcel retop cA cC cicc co cr cioo crn ctg cfv cuni cA cr
      wcel cC cr wcel cA cC cicc co cr wss piececn.1 cA cB cicc co cr cC cA cr
      wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre
      mp2an piececn.3 sselii cA cC iccssre mp2an uniretop sseqtr4i cA cC cicc
      co cioo crn ctg cfv stoig3 mp2an eqeltri piececn.13 piececn.14 cG cK cM
      cA cC cicc co cM cuni cK cuni cA cC cicc co cioo crn ctg cfv cop csubsp
      cfv cuni cA cC cicc co cK cA cC cicc co cioo crn ctg cfv cop csubsp cfv
      piececn.8 unieqi cioo crn ctg cfv ctop wcel cA cC cicc co cioo crn ctg
      cfv cuni wss cA cC cicc co cioo crn ctg cfv cop csubsp cfv cuni cA cC
      cicc co wceq retop cA cC cicc co cr cioo crn ctg cfv cuni cA cr wcel cC
      cr wcel cA cC cicc co cr wss piececn.1 cA cB cicc co cr cC cA cr wcel cB
      cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an
      piececn.3 sselii cA cC iccssre mp2an uniretop sseqtr4i cA cC cicc co cioo
      crn ctg cfv stoig2 mp2an eqtr2i cM cuni eqid cnf mp3an ffvelrni eqeltrd
      vx cv cC cB cicc co wcel vx cv cC cle wbr cR cS cif vx cv cH cfv cM cuni
      vx cv cC cB cicc co wcel vx cv cC cle wbr cR cS cif cS vx cv cH cfv vx cv
      cC cB cicc co wcel vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a vx
      cv cC cle wbr cR cS cif cS wceq cC cr wcel cB cr wcel vx cv cC cB cicc co
      wcel vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a wb cA cB cicc co
      cr cC cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA
      cB iccssre mp2an piececn.3 sselii piececn.2 cC cB vx cv elicc2 mp2an vx
      cv cr wcel cC vx cv cle wbr vx cv cC cle wbr cR cS cif cS wceq vx cv cB
      cle wbr vx cv cr wcel cC vx cv cle wbr cC vx cv clt wbr cC vx cv wceq wo
      vx cv cC cle wbr cR cS cif cS wceq vx cv cr wcel cC vx cv cle wbr cC vx
      cv clt wbr cC vx cv wceq wo cC cr wcel vx cv cr wcel cC vx cv cle wbr cC
      vx cv clt wbr cC vx cv wceq wo wb cA cB cicc co cr cC cA cr wcel cB cr
      wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an
      piececn.3 sselii cC vx cv leloe mpan biimpa vx cv cr wcel cC vx cv clt
      wbr vx cv cC cle wbr cR cS cif cS wceq cC vx cv wceq vx cv cr wcel cC vx
      cv clt wbr wa vx cv cC cle wbr wn vx cv cC cle wbr cR cS cif cS wceq vx
      cv cr wcel cC vx cv clt wbr vx cv cC cle wbr wn cC cr wcel vx cv cr wcel
      cC vx cv clt wbr vx cv cC cle wbr wn wb cA cB cicc co cr cC cA cr wcel cB
      cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an
      piececn.3 sselii cC vx cv ltnle mpan biimpa vx cv cC cle wbr cR cS
      iffalse syl cC vx cv wceq vx cv cC cle wbr cR cS cif cS wceq vx cv cr
      wcel vx cv cC cle wbr cR cS cif cS wceq vx cv cC vx cv cC wceq vx cv cC
      cle wbr cR cS cif cR cS vx cv cC wceq vx cv cC cle wbr vx cv cC cle wbr
      cR cS cif cR wceq vx cv cC wceq vx cv cC cle wbr cC cC cle wbr cC cA cB
      cicc co cr cC cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1
      piececn.2 cA cB iccssre mp2an piececn.3 sselii leidi vx cv cC cC cle
      breq1 mpbiri vx cv cC cle wbr cR cS iftrue syl piececn.10 eqtrd eqcoms
      adantl jaodan syldan 3adant3 sylbi vx cv cC cB cicc co wcel vx cv vx cv
      cC cB cicc co wcel vy cv cS wceq wa vx vy copab cfv cS vx cv cH cfv vx cv
      cC cB cicc co wcel cS cvv wcel vx cv vx cv cC cB cicc co wcel vy cv cS
      wceq wa vx vy copab cfv cS wceq piececn.5 vx vy cC cB cicc co cS cvv
      fvopab2 mpan2 vx cv cH vx cv cC cB cicc co wcel vy cv cS wceq wa vx vy
      copab piececn.12 fveq1i syl5eq eqtr4d cC cB cicc co cM cuni vx cv cH cL
      ctop wcel cM ctop wcel cH cL cM ccn co wcel cC cB cicc co cM cuni cH wf
      cL cC cB cicc co cioo crn ctg cfv cop csubsp cfv ctop piececn.9 cioo crn
      ctg cfv ctop wcel cC cB cicc co cioo crn ctg cfv cuni wss cC cB cicc co
      cioo crn ctg cfv cop csubsp cfv ctop wcel retop cC cB cicc co cr cioo crn
      ctg cfv cuni cC cr wcel cB cr wcel cC cB cicc co cr wss cA cB cicc co cr
      cC cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB
      iccssre mp2an piececn.3 sselii piececn.2 cC cB iccssre mp2an uniretop
      sseqtr4i cC cB cicc co cioo crn ctg cfv stoig3 mp2an eqeltri piececn.13
      piececn.15 cH cL cM cC cB cicc co cM cuni cL cuni cC cB cicc co cioo crn
      ctg cfv cop csubsp cfv cuni cC cB cicc co cL cC cB cicc co cioo crn ctg
      cfv cop csubsp cfv piececn.9 unieqi cioo crn ctg cfv ctop wcel cC cB cicc
      co cioo crn ctg cfv cuni wss cC cB cicc co cioo crn ctg cfv cop csubsp
      cfv cuni cC cB cicc co wceq retop cC cB cicc co cr cioo crn ctg cfv cuni
      cC cr wcel cB cr wcel cC cB cicc co cr wss cA cB cicc co cr cC cA cr wcel
      cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an
      piececn.3 sselii piececn.2 cC cB iccssre mp2an uniretop sseqtr4i cC cB
      cicc co cioo crn ctg cfv stoig2 mp2an eqtr2i cM cuni eqid cnf mp3an
      ffvelrni eqeltrd jaoi sylbi fopab cF cA cC cicc co cres cG cA cC cicc co
      cJ cop csubsp cfv cM ccn co cF cA cC cicc co cres vx cv cA cC cicc co
      wcel vy cv cR wceq wa vx vy copab cG cF cA cC cicc co cres vx cv cA cB
      cicc co wcel vy cv vx cv cC cle wbr cR cS cif wceq wa vx vy copab cA cC
      cicc co cres vx cv cA cC cicc co wcel vy cv vx cv cC cle wbr cR cS cif
      wceq wa vx vy copab vx cv cA cC cicc co wcel vy cv cR wceq wa vx vy copab
      cF vx cv cA cB cicc co wcel vy cv vx cv cC cle wbr cR cS cif wceq wa vx
      vy copab wceq cF cA cC cicc co cres vx cv cA cB cicc co wcel vy cv vx cv
      cC cle wbr cR cS cif wceq wa vx vy copab cA cC cicc co cres wceq
      piececn.6 cF vx cv cA cB cicc co wcel vy cv vx cv cC cle wbr cR cS cif
      wceq wa vx vy copab cA cC cicc co reseq1 ax-mp cA cC cicc co cA cB cicc
      co wss vx cv cA cB cicc co wcel vy cv vx cv cC cle wbr cR cS cif wceq wa
      vx vy copab cA cC cicc co cres vx cv cA cC cicc co wcel vy cv vx cv cC
      cle wbr cR cS cif wceq wa vx vy copab wceq cA cr wcel cB cr wcel wa cA cr
      wcel cC cr wcel wa cA cA cle wbr cC cB cle wbr wa cA cC cicc co cA cB
      cicc co wss cA cr wcel cB cr wcel piececn.1 piececn.2 pm3.2i cA cr wcel
      cC cr wcel piececn.1 cA cB cicc co cr cC cA cr wcel cB cr wcel cA cB cicc
      co cr wss piececn.1 piececn.2 cA cB iccssre mp2an piececn.3 sselii pm3.2i
      cA cA cle wbr cC cB cle wbr cA piececn.1 leidi cC cr wcel cA cC cle wbr
      cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle
      wbr w3a piececn.3 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel
      cA cC cle wbr cC cB cle wbr w3a wb piececn.1 piececn.2 cA cB cC elicc2
      mp2an mpbi 3simp3i pm3.2i cA cB cA cC iccss mp3an vy cv vx cv cC cle wbr
      cR cS cif wceq vx vy cA cC cicc co cA cB cicc co resopab2 ax-mp vx cv cA
      cC cicc co wcel vy cv vx cv cC cle wbr cR cS cif wceq wa vx cv cA cC cicc
      co wcel vy cv cR wceq wa vx vy vx cv cA cC cicc co wcel vy cv vx cv cC
      cle wbr cR cS cif wceq vy cv cR wceq vx cv cA cC cicc co wcel vx cv cC
      cle wbr cR cS cif cR vy cv vx cv cA cC cicc co wcel vx cv cC cle wbr vx
      cv cC cle wbr cR cS cif cR wceq vx cv cA cC cicc co wcel vx cv cr wcel cA
      vx cv cle wbr vx cv cC cle wbr vx cv cA cC cicc co wcel vx cv cr wcel cA
      vx cv cle wbr vx cv cC cle wbr w3a cA cr wcel cC cr wcel vx cv cA cC cicc
      co wcel vx cv cr wcel cA vx cv cle wbr vx cv cC cle wbr w3a wb piececn.1
      cA cB cicc co cr cC cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1
      piececn.2 cA cB iccssre mp2an piececn.3 sselii cA cC vx cv elicc2 mp2an
      biimpi 3simp3d vx cv cC cle wbr cR cS iftrue syl eqeq2d pm5.32i opabbii
      3eqtri piececn.11 eqtr4i cG cK cM ccn co cA cC cicc co cJ cop csubsp cfv
      cM ccn co piececn.14 cA cC cicc co cJ cop csubsp cfv cK cM ccn cA cC cicc
      co cA cB cicc co cioo crn ctg cfv cop csubsp cfv cop csubsp cfv cA cC
      cicc co cioo crn ctg cfv cop csubsp cfv cA cC cicc co cJ cop csubsp cfv
      cK cioo crn ctg cfv ctop wcel cA cB cicc co cr wss cA cC cicc co cA cB
      cicc co wss cA cC cicc co cA cB cicc co cioo crn ctg cfv cop csubsp cfv
      cop csubsp cfv cA cC cicc co cioo crn ctg cfv cop csubsp cfv wceq retop
      cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB
      iccssre mp2an cA cr wcel cB cr wcel wa cA cr wcel cC cr wcel wa cA cA cle
      wbr cC cB cle wbr wa cA cC cicc co cA cB cicc co wss cA cr wcel cB cr
      wcel piececn.1 piececn.2 pm3.2i cA cr wcel cC cr wcel piececn.1 cA cB
      cicc co cr cC cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1
      piececn.2 cA cB iccssre mp2an piececn.3 sselii pm3.2i cA cA cle wbr cC cB
      cle wbr cA piececn.1 leidi cC cr wcel cA cC cle wbr cC cB cle wbr cC cA
      cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a piececn.3 cA
      cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a wb piececn.1 piececn.2 cA cB cC elicc2 mp2an mpbi 3simp3i
      pm3.2i cA cB cA cC iccss mp3an cA cB cicc co cA cC cicc co cioo crn ctg
      cfv cr cioo crn ctg cfv cuni cr uniretop eqcomi subspabs mp3an cA cC cicc
      co cJ cop cA cC cicc co cA cB cicc co cioo crn ctg cfv cop csubsp cfv cop
      csubsp cJ cA cB cicc co cioo crn ctg cfv cop csubsp cfv cA cC cicc co
      piececn.7 opeq2i fveq2i piececn.8 3eqtr4i opreq1i eleqtrri eqeltri cF cC
      cB cicc co cres cH cC cB cicc co cJ cop csubsp cfv cM ccn co cF cC cB
      cicc co cres vx cv cC cB cicc co wcel vy cv cS wceq wa vx vy copab cH cF
      cC cB cicc co cres vx cv cA cB cicc co wcel vy cv vx cv cC cle wbr cR cS
      cif wceq wa vx vy copab cC cB cicc co cres vx cv cC cB cicc co wcel vy cv
      vx cv cC cle wbr cR cS cif wceq wa vx vy copab vx cv cC cB cicc co wcel
      vy cv cS wceq wa vx vy copab cF vx cv cA cB cicc co wcel vy cv vx cv cC
      cle wbr cR cS cif wceq wa vx vy copab wceq cF cC cB cicc co cres vx cv cA
      cB cicc co wcel vy cv vx cv cC cle wbr cR cS cif wceq wa vx vy copab cC
      cB cicc co cres wceq piececn.6 cF vx cv cA cB cicc co wcel vy cv vx cv cC
      cle wbr cR cS cif wceq wa vx vy copab cC cB cicc co reseq1 ax-mp cC cB
      cicc co cA cB cicc co wss vx cv cA cB cicc co wcel vy cv vx cv cC cle wbr
      cR cS cif wceq wa vx vy copab cC cB cicc co cres vx cv cC cB cicc co wcel
      vy cv vx cv cC cle wbr cR cS cif wceq wa vx vy copab wceq cA cr wcel cB
      cr wcel wa cC cr wcel cB cr wcel wa cA cC cle wbr cB cB cle wbr wa cC cB
      cicc co cA cB cicc co wss cA cr wcel cB cr wcel piececn.1 piececn.2
      pm3.2i cC cr wcel cB cr wcel cA cB cicc co cr cC cA cr wcel cB cr wcel cA
      cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an piececn.3
      sselii piececn.2 pm3.2i cA cC cle wbr cB cB cle wbr cC cr wcel cA cC cle
      wbr cC cB cle wbr cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a piececn.3 cA cr wcel cB cr wcel cC cA cB cicc co wcel cC cr
      wcel cA cC cle wbr cC cB cle wbr w3a wb piececn.1 piececn.2 cA cB cC
      elicc2 mp2an mpbi 3simp2i cB piececn.2 leidi pm3.2i cA cB cC cB iccss
      mp3an vy cv vx cv cC cle wbr cR cS cif wceq vx vy cC cB cicc co cA cB
      cicc co resopab2 ax-mp vx cv cC cB cicc co wcel vy cv vx cv cC cle wbr cR
      cS cif wceq wa vx cv cC cB cicc co wcel vy cv cS wceq wa vx vy vx cv cC
      cB cicc co wcel vy cv vx cv cC cle wbr cR cS cif wceq vy cv cS wceq vx cv
      cC cB cicc co wcel vx cv cC cle wbr cR cS cif cS vy cv vx cv cC cB cicc
      co wcel vx cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a vx cv cC cle
      wbr cR cS cif cS wceq cC cr wcel cB cr wcel vx cv cC cB cicc co wcel vx
      cv cr wcel cC vx cv cle wbr vx cv cB cle wbr w3a wb cA cB cicc co cr cC
      cA cr wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB
      iccssre mp2an piececn.3 sselii piececn.2 cC cB vx cv elicc2 mp2an vx cv
      cr wcel cC vx cv cle wbr vx cv cC cle wbr cR cS cif cS wceq vx cv cB cle
      wbr vx cv cr wcel cC vx cv cle wbr cC vx cv clt wbr cC vx cv wceq wo vx
      cv cC cle wbr cR cS cif cS wceq vx cv cr wcel cC vx cv cle wbr cC vx cv
      clt wbr cC vx cv wceq wo cC cr wcel vx cv cr wcel cC vx cv cle wbr cC vx
      cv clt wbr cC vx cv wceq wo wb cA cB cicc co cr cC cA cr wcel cB cr wcel
      cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an piececn.3
      sselii cC vx cv leloe mpan biimpa vx cv cr wcel cC vx cv clt wbr vx cv cC
      cle wbr cR cS cif cS wceq cC vx cv wceq vx cv cr wcel cC vx cv clt wbr wa
      vx cv cC cle wbr wn vx cv cC cle wbr cR cS cif cS wceq vx cv cr wcel cC
      vx cv clt wbr vx cv cC cle wbr wn cC cr wcel vx cv cr wcel cC vx cv clt
      wbr vx cv cC cle wbr wn wb cA cB cicc co cr cC cA cr wcel cB cr wcel cA
      cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an piececn.3
      sselii cC vx cv ltnle mpan biimpa vx cv cC cle wbr cR cS iffalse syl cC
      vx cv wceq vx cv cC cle wbr cR cS cif cS wceq vx cv cr wcel vx cv cC cle
      wbr cR cS cif cS wceq vx cv cC vx cv cC wceq vx cv cC cle wbr cR cS cif
      cR cS vx cv cC wceq vx cv cC cle wbr vx cv cC cle wbr cR cS cif cR wceq
      vx cv cC wceq vx cv cC cle wbr cC cC cle wbr cC cA cB cicc co cr cC cA cr
      wcel cB cr wcel cA cB cicc co cr wss piececn.1 piececn.2 cA cB iccssre
      mp2an piececn.3 sselii leidi vx cv cC cC cle breq1 mpbiri vx cv cC cle
      wbr cR cS iftrue syl piececn.10 eqtrd eqcoms adantl jaodan syldan 3adant3
      sylbi eqeq2d pm5.32i opabbii 3eqtri piececn.12 eqtr4i cH cL cM ccn co cC
      cB cicc co cJ cop csubsp cfv cM ccn co piececn.15 cC cB cicc co cJ cop
      csubsp cfv cL cM ccn cC cB cicc co cA cB cicc co cioo crn ctg cfv cop
      csubsp cfv cop csubsp cfv cC cB cicc co cioo crn ctg cfv cop csubsp cfv
      cC cB cicc co cJ cop csubsp cfv cL cioo crn ctg cfv ctop wcel cA cB cicc
      co cr wss cC cB cicc co cA cB cicc co wss cC cB cicc co cA cB cicc co
      cioo crn ctg cfv cop csubsp cfv cop csubsp cfv cC cB cicc co cioo crn ctg
      cfv cop csubsp cfv wceq retop cA cr wcel cB cr wcel cA cB cicc co cr wss
      piececn.1 piececn.2 cA cB iccssre mp2an cA cr wcel cB cr wcel wa cC cr
      wcel cB cr wcel wa cA cC cle wbr cB cB cle wbr wa cC cB cicc co cA cB
      cicc co wss cA cr wcel cB cr wcel piececn.1 piececn.2 pm3.2i cC cr wcel
      cB cr wcel cA cB cicc co cr cC cA cr wcel cB cr wcel cA cB cicc co cr wss
      piececn.1 piececn.2 cA cB iccssre mp2an piececn.3 sselii piececn.2 pm3.2i
      cA cC cle wbr cB cB cle wbr cC cr wcel cA cC cle wbr cC cB cle wbr cC cA
      cB cicc co wcel cC cr wcel cA cC cle wbr cC cB cle wbr w3a piececn.3 cA
      cr wcel cB cr wcel cC cA cB cicc co wcel cC cr wcel cA cC cle wbr cC cB
      cle wbr w3a wb piececn.1 piececn.2 cA cB cC elicc2 mp2an mpbi 3simp2i cB
      piececn.2 leidi pm3.2i cA cB cC cB iccss mp3an cA cB cicc co cC cB cicc
      co cioo crn ctg cfv cr cioo crn ctg cfv cuni cr uniretop eqcomi subspabs
      mp3an cC cB cicc co cJ cop cC cB cicc co cA cB cicc co cioo crn ctg cfv
      cop csubsp cfv cop csubsp cJ cA cB cicc co cioo crn ctg cfv cop csubsp
      cfv cC cB cicc co piececn.7 opeq2i fveq2i piececn.9 3eqtr4i opreq1i
      eleqtrri eqeltri 3pm3.2i cA cC cicc co cC cB cicc co cF cJ cM cA cB cicc
      co cM cuni cJ cuni cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni cA
      cB cicc co cJ cA cB cicc co cioo crn ctg cfv cop csubsp cfv piececn.7
      unieqi cioo crn ctg cfv ctop wcel cA cB cicc co cioo crn ctg cfv cuni wss
      cA cB cicc co cioo crn ctg cfv cop csubsp cfv cuni cA cB cicc co wceq
      retop cA cB cicc co cr cioo crn ctg cfv cuni cA cr wcel cB cr wcel cA cB
      cicc co cr wss piececn.1 piececn.2 cA cB iccssre mp2an uniretop sseqtr4i
      cA cB cicc co cioo crn ctg cfv stoig2 mp2an eqtr2i cM cuni eqid paste
      mp3an $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A w x y z $. $d B w x y z $. $d C w y z $.
    $d J x y $. $d K x y $. $d G z $.
    cncfres.1 $e |- A C_ CC $.
    cncfres.2 $e |- B C_ CC $.
    cncfres.3 $e |- F = { <. x , y >. | ( x e. CC /\ y = C ) } $.
    cncfres.4 $e |- G = { <. x , y >. | ( x e. A /\ y = C ) } $.
    cncfres.5 $e |- ( x e. A -> C e. B ) $.
    cncfres.6 $e |- F e. ( CC -cn-> CC ) $.
    cncfres.7 $e |- J = ( Open ` ( ( abs o. - ) |` ( A X. A ) ) ) $.
    cncfres.8 $e |- K = ( Open ` ( ( abs o. - ) |` ( B X. B ) ) ) $.
    $( A continuous function on complex numbers restricted to a subset. $)
    cncfres $p |- G e. ( J Cn K ) $=
      cG cA cB ccncf co cJ cK ccn co cG cA cc ccncf co wcel cG cA cB ccncf co
      wcel cG cF cA cres cA cc ccncf co vx cv cc wcel vy cv cC wceq wa vx vy
      copab cA cres vx cv cA wcel vy cv cC wceq wa vx vy copab cF cA cres cG cA
      cc wss vx cv cc wcel vy cv cC wceq wa vx vy copab cA cres vx cv cA wcel
      vy cv cC wceq wa vx vy copab wceq cncfres.1 vy cv cC wceq vx vy cA cc
      resopab2 ax-mp cF vx cv cc wcel vy cv cC wceq wa vx vy copab wceq cF cA
      cres vx cv cc wcel vy cv cC wceq wa vx vy copab cA cres wceq cncfres.3 cF
      vx cv cc wcel vy cv cC wceq wa vx vy copab cA reseq1 ax-mp cncfres.4
      3eqtr4ri cF cc cc ccncf co wcel cF cA cres cA cc ccncf co wcel cncfres.6
      cc cc wss cc cc wss cA cc wss cF cc cc ccncf co wcel cF cA cres cA cc
      ccncf co wcel wi cc ssid cc ssid cncfres.1 cc cc cA cF rescncf mp3an
      ax-mp eqeltri cA cc wss cc cc wss cB cc wss w3a vz cv cG cfv cB wcel vz
      cA wral cG cA cc ccncf co wcel cG cA cB ccncf co wcel wi cA cc wss cc cc
      wss cB cc wss cncfres.1 cc ssid cncfres.2 3pm3.2i vz cv cG cfv cB wcel vz
      cA vz cv cA wcel vz cv cG cfv vx vz cv cC csb cB vz cv cA wcel vx vz cv
      cC csb cB wcel vz cv cG cfv vx vz cv cC csb wceq vx cv cA wcel cC cB wcel
      wi vz cv cA wcel vx vz cv cC csb cB wcel wi vx vz vz cv cA wcel vx vz cv
      cC csb cB wcel vx vz cv cA wcel vx ax-17 vx vw vw vx vz cv cC csb cB vx
      vw vz cv cC vz visset vw cv vz cv wcel vx ax-17 hbcsb1 vw cv cB wcel vx
      ax-17 hbel hbim vx cv vz cv wceq vx cv cA wcel vz cv cA wcel cC cB wcel
      vx vz cv cC csb cB wcel vx cv vz cv cA eleq1 vx cv vz cv wceq cC vx vz cv
      cC csb cB vx vz cv cC csbeq1a eleq1d imbi12d cncfres.5 chvar vx vy vw vz
      cv cC vx vz cv cC csb cA cB cG vw cv vz cv wcel vx ax-17 vx vw vz cv cC
      vz visset vw cv vz cv wcel vx ax-17 hbcsb1 vx vz cv cC csbeq1a cncfres.4
      fvopab4gf mpdan vx cv cA wcel cC cB wcel wi vz cv cA wcel vx vz cv cC csb
      cB wcel wi vx vz vz cv cA wcel vx vz cv cC csb cB wcel vx vz cv cA wcel
      vx ax-17 vx vw vw vx vz cv cC csb cB vx vw vz cv cC vz visset vw cv vz cv
      wcel vx ax-17 hbcsb1 vw cv cB wcel vx ax-17 hbel hbim vx cv vz cv wceq vx
      cv cA wcel vz cv cA wcel cC cB wcel vx vz cv cC csb cB wcel vx cv vz cv
      cA eleq1 vx cv vz cv wceq cC vx vz cv cC csb cB vx vz cv cC csbeq1a
      eleq1d imbi12d cncfres.5 chvar eqeltrd rgen vz cA cc cB cG cncffvrn mp2an
      ax-mp cA cc wss cB cc wss cA cB ccncf co cJ cK ccn co wceq cncfres.1
      cncfres.2 cA cB cabs cmin ccom cA cA cxp cres cabs cmin ccom cB cB cxp
      cres cJ cK cabs cmin ccom cA cA cxp cres eqid cabs cmin ccom cB cB cxp
      cres eqid cncfres.7 cncfres.8 cncfmet mp2an eleqtri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F x $. $d J x $. $d K x $.
    ishomeo2.1 $e |- X = U. J $.
    ishomeo2.2 $e |- Y = U. K $.
    $( The predicate "is a homeomorphism". $)
    ishomeo2 $p |- ( ( J e. Top /\ K e. Top ) -> ( F e. ( J Homeo K ) <->
                          ( F : X -1-1-onto-> Y /\ A. x e. J ( F " x ) e. K /\
                                        A. x e. K ( `' F " x ) e. J ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cX cY cF wf1o cF
      vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cX cY cF wf1o cF
      vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a
      cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel cF cJ cK chomeosm co
      wcel cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ
      wcel vx cK wral w3a wi cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co
      wcel w3a cF cJ cK chomeosm co wcel cX cY cF wf1o cF vx cv cima cK wcel vx
      cJ wral cF ccnv vx cv cima cJ wcel vx cK wral w3a vx cJ cK chomeosm co cF
      cJ cK cX cY ishomeo2.1 ishomeo2.2 ishomeo biimpd 3expia pm2.43d cJ ctop
      wcel cK ctop wcel wa cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF
      ccnv vx cv cima cJ wcel vx cK wral w3a cF cvv wcel cF cJ cK chomeosm co
      wcel cJ ctop wcel cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv
      vx cv cima cJ wcel vx cK wral w3a cF cvv wcel wi cK ctop wcel cX cY cF
      wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral w3a cJ ctop wcel cF cvv wcel cX cY cF wf1o cF vx cv cima cK wcel vx
      cJ wral cJ ctop wcel cF cvv wcel cF ccnv vx cv cima cJ wcel vx cK wral cX
      cY cF wf cX cvv wcel cF cvv wcel cX cY cF wf1o cJ ctop wcel cX cY cvv cF
      fex cX cY cF f1of cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg ishomeo2.1
      syl5eqel syl2an 3ad2antl1 expcom adantr cJ ctop wcel cK ctop wcel wa cF
      cvv wcel cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv
      cima cJ wcel vx cK wral w3a cF cJ cK chomeosm co wcel cJ ctop wcel cK
      ctop wcel cF cvv wcel cX cY cF wf1o cF vx cv cima cK wcel vx cJ wral cF
      ccnv vx cv cima cJ wcel vx cK wral w3a cF cJ cK chomeosm co wcel wi cJ
      ctop wcel cK ctop wcel cF cvv wcel w3a cF cJ cK chomeosm co wcel cX cY cF
      wf1o cF vx cv cima cK wcel vx cJ wral cF ccnv vx cv cima cJ wcel vx cK
      wral w3a vx cvv cF cJ cK cX cY ishomeo2.1 ishomeo2.2 ishomeo biimprd
      3expia com23 mpdd impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J v $. $d K v $. $d F v $.
    $( A homeomorphism is continuous. $)
    hmeocn $p |- ( ( J e. Top /\ K e. Top ) ->
                            ( F e. ( J Homeo K ) -> F e. ( J Cn K ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf1o cF vv cv cima cK
      wcel vv cJ wral cF ccnv vv cv cima cJ wcel vv cK wral w3a cJ cuni cK cuni
      cF wf cF ccnv vv cv cima cJ wcel vv cK wral wa cF cJ cK chomeosm co wcel
      cF cJ cK ccn co wcel cJ cuni cK cuni cF wf1o cF vv cv cima cK wcel vv cJ
      wral cF ccnv vv cv cima cJ wcel vv cK wral w3a cJ cuni cK cuni cF wf cF
      ccnv vv cv cima cJ wcel vv cK wral wa wi cJ ctop wcel cK ctop wcel wa cJ
      cuni cK cuni cF wf1o cF ccnv vv cv cima cJ wcel vv cK wral cJ cuni cK
      cuni cF wf cF ccnv vv cv cima cJ wcel vv cK wral wa cF vv cv cima cK wcel
      vv cJ wral cJ cuni cK cuni cF wf1o cJ cuni cK cuni cF wf cF ccnv vv cv
      cima cJ wcel vv cK wral cJ cuni cK cuni cF f1of anim1i 3adant2 a1i vv cF
      cJ cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid ishomeo2 vv cF cJ cK cJ
      cuni cK cuni cJ cuni eqid cK cuni eqid iscn 3imtr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The inverse of a homeomorphism is a homeomorphism. $)
    hmeocnv $p |- ( ( ( J e. Top /\ K e. Top ) /\ F e. ( J Homeo K ) )
                                            -> `' F e. ( K Homeo J ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel wa cF cJ cK
      chomeosm co wcel cF ccnv cK cJ chomeosm co wcel cJ ctop wcel cK ctop wcel
      wa cF cJ cK chomeosm co wcel pm3.27 cJ ctop wcel cK ctop wcel wa cF cJ cK
      chomeosm co wcel wa cJ cuni cK cuni cF wf1o cF cJ cK ccn co wcel cF ccnv
      cK cJ ccn co wcel w3a cK cuni cJ cuni cF ccnv wf1o cF ccnv cK cJ ccn co
      wcel cF ccnv ccnv cJ cK ccn co wcel w3a cF cJ cK chomeosm co wcel cF ccnv
      cK cJ chomeosm co wcel cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF
      wf1o cF cJ cK ccn co wcel cF ccnv cK cJ ccn co wcel w3a cK cuni cJ cuni
      cF ccnv wf1o cF ccnv cK cJ ccn co wcel cF ccnv ccnv cJ cK ccn co wcel w3a
      wi cF cJ cK chomeosm co wcel cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni
      cF wf1o cF cJ cK ccn co wcel cF ccnv cK cJ ccn co wcel w3a cK cuni cJ
      cuni cF ccnv wf1o cF ccnv cK cJ ccn co wcel cF ccnv ccnv cJ cK ccn co
      wcel w3a cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf1o cF cJ cK
      ccn co wcel cF ccnv cK cJ ccn co wcel w3a wa cK cuni cJ cuni cF ccnv wf1o
      cF ccnv cK cJ ccn co wcel cF ccnv ccnv cJ cK ccn co wcel cJ cuni cK cuni
      cF wf1o cF cJ cK ccn co wcel cF ccnv cK cJ ccn co wcel w3a cK cuni cJ
      cuni cF ccnv wf1o cJ ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf1o cF
      cJ cK ccn co wcel cK cuni cJ cuni cF ccnv wf1o cF ccnv cK cJ ccn co wcel
      cJ cuni cK cuni cF f1ocnv 3ad2ant1 adantl cJ cuni cK cuni cF wf1o cF cJ
      cK ccn co wcel cF ccnv cK cJ ccn co wcel w3a cF ccnv cK cJ ccn co wcel cJ
      ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf1o cF cJ cK ccn co wcel cF
      ccnv cK cJ ccn co wcel 3simp3 adantl cJ cuni cK cuni cF wf1o cF cJ cK ccn
      co wcel cF ccnv cK cJ ccn co wcel w3a cF ccnv ccnv cJ cK ccn co wcel cJ
      ctop wcel cK ctop wcel wa cJ cuni cK cuni cF wf1o cF cJ cK ccn co wcel cF
      ccnv ccnv cJ cK ccn co wcel cF ccnv cK cJ ccn co wcel cJ cuni cK cuni cF
      wf1o cF ccnv ccnv cJ cK ccn co wcel cF cJ cK ccn co wcel cJ cuni cK cuni
      cF wf1o cF ccnv ccnv cF cJ cK ccn co cJ cuni cK cuni cF wf1o cF wrel cF
      ccnv ccnv cF wceq cJ cuni cK cuni cF f1orel cF dfrel2 sylib eleq1d
      biimpar 3adant3 adantl 3jca ex adantr cJ ctop wcel cK ctop wcel cF cJ cK
      chomeosm co wcel cF cJ cK chomeosm co wcel cJ cuni cK cuni cF wf1o cF cJ
      cK ccn co wcel cF ccnv cK cJ ccn co wcel w3a wb cJ cK chomeosm co cF cJ
      cK cJ cuni cK cuni cJ cuni eqid cK cuni eqid hmeobc 3expa cJ ctop wcel cK
      ctop wcel wa cF ccnv cvv wcel cF ccnv cK cJ chomeosm co wcel cK cuni cJ
      cuni cF ccnv wf1o cF ccnv cK cJ ccn co wcel cF ccnv ccnv cJ cK ccn co
      wcel w3a wb cF cJ cK chomeosm co wcel cJ ctop wcel cK ctop wcel cF ccnv
      cvv wcel cF ccnv cK cJ chomeosm co wcel cK cuni cJ cuni cF ccnv wf1o cF
      ccnv cK cJ ccn co wcel cF ccnv ccnv cJ cK ccn co wcel w3a wb cK ctop wcel
      cJ ctop wcel cF ccnv cvv wcel cF ccnv cK cJ chomeosm co wcel cK cuni cJ
      cuni cF ccnv wf1o cF ccnv cK cJ ccn co wcel cF ccnv ccnv cJ cK ccn co
      wcel w3a wb cvv cF ccnv cK cJ cK cuni cJ cuni cK cuni eqid cJ cuni eqid
      hmeobc 3com12 3expa cF cJ cK chomeosm co cnvexg sylan2 3imtr4d mpd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d X x y $. $d J x y $. $d K x y $. $d A x y $. $d F x y $.
    hmeoopn.1 $e |- X = U. J $.
    $( Homeomorphisms preserve openness. $)
    hmeoopn $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( F e. ( J Homeo K ) /\
                               A C_ X ) ) -> ( A e. J <-> ( F " A ) e. K ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cA cX wss wa wa cA
      cJ wcel cF cA cima cK wcel cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm
      co wcel cA cJ wcel cF cA cima cK wcel wi cA cX wss cA cJ wcel cF vx cv
      cima cK wcel vx cJ wral cF cA cima cK wcel cJ ctop wcel cK ctop wcel wa
      cF cJ cK chomeosm co wcel wa cF vx cv cima cK wcel cF cA cima cK wcel vx
      cA cJ vx cv cA wceq cF vx cv cima cF cA cima cK vx cv cA cF imaeq2 eleq1d
      rcla4v cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cF vx cv
      cima cK wcel vx cJ wral vx cF cJ cK hmeocnb imp syl5com adantrr cJ ctop
      wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cA cX wss wa wa cF cA cima
      cK wcel cF ccnv cF cA cima cima cJ wcel cA cJ wcel cJ ctop wcel cK ctop
      wcel wa cF cJ cK chomeosm co wcel cF cA cima cK wcel cF ccnv cF cA cima
      cima cJ wcel wi cA cX wss cF cA cima cK wcel cF ccnv vy cv cima cJ wcel
      vy cK wral cF ccnv cF cA cima cima cJ wcel cJ ctop wcel cK ctop wcel wa
      cF cJ cK chomeosm co wcel wa cF ccnv vy cv cima cJ wcel cF ccnv cF cA
      cima cima cJ wcel vy cF cA cima cK vy cv cF cA cima wceq cF ccnv vy cv
      cima cF ccnv cF cA cima cima cJ vy cv cF cA cima cF ccnv imaeq2 eleq1d
      rcla4v cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cF ccnv vy
      cv cima cJ wcel vy cK wral vy cF cJ cK hmeocna imp syl5com adantrr cJ
      ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cA cX wss wa wa cF
      ccnv cF cA cima cima cA cJ cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm
      co wcel cA cX wss cF ccnv cF cA cima cima cA wceq cX cK cuni cF wf1 cA cX
      wss cF ccnv cF cA cima cima cA wceq cJ ctop wcel cK ctop wcel wa cF cJ cK
      chomeosm co wcel wa cX cK cuni cA cF f1imacnv cJ ctop wcel cK ctop wcel
      wa cF cJ cK chomeosm co wcel wa cX cK cuni cF wf1o cX cK cuni cF wf1 cJ
      ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cX cK cuni cF wf1o cF
      cJ cK cX cK cuni hmeoopn.1 cK cuni eqid hmeomap imp cX cK cuni cF f1of1
      syl sylan anasss eleq1d sylibd impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    hmeocld.1 $e |- X = U. J $.
    $( Homeomorphisms preserve closedness. $)
    hmeocld $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( F e. ( J Homeo K ) /\
         A C_ X ) ) -> ( A e. ( Clsd ` J ) <-> ( F " A ) e. ( Clsd ` K ) ) ) $=
      cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cA cX wss wa wa cX
      cA cdif cJ wcel cK cuni cF cA cima cdif cK wcel cA cJ ccld cfv wcel cF cA
      cima cK ccld cfv wcel cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cA cX wss wa wa cX cA cdif cJ wcel cF cX cA cdif cima cK wcel cK
      cuni cF cA cima cdif cK wcel cJ ctop wcel cK ctop wcel wa cF cJ cK
      chomeosm co wcel cX cA cdif cJ wcel cF cX cA cdif cima cK wcel wb cA cX
      wss cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cX cA cdif cX
      wss cX cA cdif cJ wcel cF cX cA cdif cima cK wcel wb cX cA difss cX cA
      cdif cF cJ cK cX hmeocld.1 hmeoopn mpanr2 adantrr cJ ctop wcel cK ctop
      wcel wa cF cJ cK chomeosm co wcel cA cX wss wa wa cF cX cA cdif cima cK
      cuni cF cA cima cdif cK cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cA cX wss wa wa cF cX cA cdif cima cF cX cima cF cA cima cdif cK
      cuni cF cA cima cdif cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cA cX wss wa wa cF ccnv wfun cF cX cA cdif cima cF cX cima cF cA
      cima cdif wceq cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cF
      ccnv wfun cA cX wss cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel wa cX cK cuni cF wf1o cF ccnv wfun cJ ctop wcel cK ctop wcel wa cF
      cJ cK chomeosm co wcel cX cK cuni cF wf1o cF cJ cK cX cK cuni hmeocld.1
      cK cuni eqid hmeomap imp cX cK cuni cF wf1o cX cK cuni cF wfo cF ccnv
      wfun cX cK cuni cF dff1o3 pm3.27bi syl adantrr cX cA cF imadif syl cJ
      ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cA cX wss wa wa cF cX
      cima cK cuni cF cA cima cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cF cX cima cK cuni wceq cA cX wss cJ ctop wcel cK ctop wcel wa cF cJ
      cK chomeosm co wcel wa cX cK cuni cF wf1o cX cK cuni cF wfo cF cX cima cK
      cuni wceq cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cX cK
      cuni cF wf1o cF cJ cK cX cK cuni hmeocld.1 cK cuni eqid hmeomap imp cX cK
      cuni cF f1ofo cX cK cuni cF foima 3syl adantrr difeq1d eqtrd eleq1d bitrd
      cJ ctop wcel cA cX wss cA cJ ccld cfv wcel cX cA cdif cJ wcel wb cK ctop
      wcel cF cJ cK chomeosm co wcel cA cJ cX hmeocld.1 iscld2 ad2ant2rl cK
      ctop wcel cF cA cima cK cuni wss cF cA cima cK ccld cfv wcel cK cuni cF
      cA cima cdif cK wcel wb cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm co
      wcel cA cX wss wa wa cF cA cima cK cK cuni cK cuni eqid iscld2 cJ ctop
      wcel cK ctop wcel cF cJ cK chomeosm co wcel cA cX wss wa simplr cJ ctop
      wcel cK ctop wcel wa cF cJ cK chomeosm co wcel cA cX wss cF cA cima cK
      cuni wss cX cK cuni cF wf1o cA cX wss cF cA cima cK cuni wss cJ ctop wcel
      cK ctop wcel wa cF cJ cK chomeosm co wcel wa cX cK cuni cF wf1o cF cA
      cima cK cuni wss cA cX wss cX cK cuni cF wf1o cF cA cima cF crn cK cuni
      cF cA cima cF crn wss cX cK cuni cF wf1o cF cA imassrn a1i cX cK cuni cF
      wf1o cX cK cuni cF wfo cF crn cK cuni wceq cX cK cuni cF f1ofo cX cK cuni
      cF forn syl sseqtrd adantr cJ ctop wcel cK ctop wcel wa cF cJ cK chomeosm
      co wcel cX cK cuni cF wf1o cF cJ cK cX cK cuni hmeocld.1 cK cuni eqid
      hmeomap imp sylan anasss sylanc 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Topological limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~~>t $.
  $( Extend class notation with the topological convergence relation. $)
  ctlm $a class ~~>t $.

  ${
    $d j r f x u m n $.
    $( Define the convergence relation on sequences in a topological space. A
    sequence ` f ` converges to a point ` x ` if for every open neighborhood
    ` U ` of ` x ` , for all large enough ` m ` we have ` f ( m ) e. U ` . $)
    df-tlm $a |- ~~>t = { <. j , r >. | ( j e. Top /\ r = { <. f , x >. |
            ( f : NN --> U. j /\ x e. U. j /\ A. u e. ( ( nei ` j ) ` { x } )
                      E. n e. NN A. m e. ( ZZ>= ` n ) ( f ` m ) e. u ) } ) } $.
  $}

  ${
    $d J j r f x u m n $. $d X j r f x u m n $. $d F f x u m n $.
    $d Y f x u m n $. $d A f x u m n $.
    tlmval.1 $e |- X = U. J $.

    $( The convergence relation on sequences in a topological space. $)
    tlmval $p |- ( J e. Top -> ( ~~>t ` J ) = { <. f , x >. |
                ( f : NN --> X /\ x e. X /\ A. u e. ( ( nei ` J ) ` { x } )
                      E. n e. NN A. m e. ( ZZ>= ` n ) ( f ` m ) e. u ) } ) $=
      cJ ctop wcel cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu cv wcel vm
      vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf vx
      copab cvv wcel cJ ctlm cfv cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv
      vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv
      wral w3a vf vx copab wceq cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv
      wral w3a vf vx copab cn cX cxp cpw cX cxp wss cn cX cxp cpw cX cxp cvv
      wcel cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz
      cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf vx copab cvv
      wcel cJ ctop wcel cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu cv wcel
      vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf
      vx copab cn cX cxp cpw cX cxp cvv ssexg cn cX vf cv wf vx cv cX wcel vm
      cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ
      cnei cfv cfv wral w3a vf vx copab vf cv cn cX cxp cpw wcel vx cv cX wcel
      wa vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv
      csn cJ cnei cfv cfv wral wa vf vx copab cn cX cxp cpw cX cxp cn cX vf cv
      wf vx cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn
      wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf cv cn cX cxp cpw wcel vx cv
      cX wcel wa vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      vx cv csn cJ cnei cfv cfv wral wa vf vx cn cX vf cv wf vx cv cX wcel vm
      cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ
      cnei cfv cfv wral vf cv cn cX cxp cpw wcel vx cv cX wcel wa vm cv vf cv
      cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv
      cfv wral wa cn cX vf cv wf vx cv cX wcel wa vf cv cn cX cxp cpw wcel vx
      cv cX wcel wa vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex
      vu vx cv csn cJ cnei cfv cfv wral cn cX vf cv wf vf cv cn cX cxp cpw wcel
      vx cv cX wcel cn cX vf cv wf vf cv cn cX cxp wss vf cv cn cX cxp cpw wcel
      cn cX vf cv fssxp vf cv cn cX cxp vf visset elpw sylibr anim1i anim1i
      3impa ssopab2i vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn
      wrex vu vx cv csn cJ cnei cfv cfv wral vf vx cn cX cxp cpw cX opabssxp
      sstri cn cX cxp cpw cvv wcel cX cvv wcel cn cX cxp cpw cX cxp cvv wcel cJ
      ctop wcel cn cX cxp cpw cX cvv cvv xpexg cJ ctop wcel cn cX cxp cvv wcel
      cn cX cxp cpw cvv wcel cn cvv wcel cX cvv wcel cn cX cxp cvv wcel cJ ctop
      wcel cn cX cvv cvv xpexg nnex cJ ctop wcel cJ cuni cvv cX cJ ctop uniexg
      tlmval.1 syl5eqel sylancr cn cX cxp cvv pwexg syl cJ ctop wcel cJ cuni
      cvv cX cJ ctop uniexg tlmval.1 syl5eqel sylanc sylancr vj vr cJ cn vj cv
      cuni vf cv wf vx cv vj cv cuni wcel vm cv vf cv cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu vx cv csn vj cv cnei cfv cfv wral w3a vf vx
      copab cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf vx copab
      ctop cvv ctlm vj cv cJ wceq cn vj cv cuni vf cv wf vx cv vj cv cuni wcel
      vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn
      vj cv cnei cfv cfv wral w3a cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv
      vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv
      wral w3a vf vx vj cv cJ wceq cn vj cv cuni vf cv wf cn cX vf cv wf vx cv
      vj cv cuni wcel vx cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu vx cv csn vj cv cnei cfv cfv wral vm cv vf cv cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv
      wral vj cv cJ wceq vj cv cuni cX wceq cn vj cv cuni vf cv wf cn cX vf cv
      wf wb vj cv cJ wceq vj cv cuni cJ cuni cX vj cv cJ unieq tlmval.1 syl6eqr
      vj cv cuni cX cn vf cv feq3 syl vj cv cJ wceq vj cv cuni cX vx cv vj cv
      cJ wceq vj cv cuni cJ cuni cX vj cv cJ unieq tlmval.1 syl6eqr eleq2d vj
      cv cJ wceq vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      vx cv csn vj cv cnei cfv cfv vx cv csn cJ cnei cfv cfv vj cv cJ wceq vx
      cv csn vj cv cnei cfv cJ cnei cfv vj cv cJ cnei fveq2 fveq1d raleq1d
      3anbi123d opabbidv vx vu vf vj vm vn vr df-tlm fvopab4g mpdan $.
      $( [2-Sep-2009] $)

    $( The binary relation " ` F ` converges to ` Y ` topologically". $)
    tlmbr $p |- ( ( J e. Top /\ Y e. A ) -> ( F ( ~~>t ` J ) Y
    <-> ( F : NN --> X /\ Y e. X /\ A. u e. ( ( nei ` J ) ` { Y } ) E. n e. NN
                                A. m e. ( ZZ>= ` n ) ( F ` m ) e. u ) ) ) $=
      cJ ctop wcel cF cY cJ ctlm cfv wbr cF cY cn cX vf cv wf vx cv cX wcel vm
      cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ
      cnei cfv cfv wral w3a vf vx copab wbr cY cA wcel cn cX cF wf cY cX wcel
      vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ
      cnei cfv cfv wral w3a cJ ctop wcel cJ ctlm cfv cn cX vf cv wf vx cv cX
      wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv
      csn cJ cnei cfv cfv wral w3a vf vx copab wceq cF cY cJ ctlm cfv wbr cF cY
      cn cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf vx copab wbr wb
      vx vu vf vm vn cJ cX tlmval.1 tlmval cF cY cJ ctlm cfv cn cX vf cv wf vx
      cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      vx cv csn cJ cnei cfv cfv wral w3a vf vx copab breq syl cn cX vf cv wf vx
      cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      vx cv csn cJ cnei cfv cfv wral w3a cn cX cF wf vx cv cX wcel vm cv cF cfv
      vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv
      wral w3a cn cX cF wf cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu cY csn cJ cnei cfv cfv wral w3a vf vx cF cY cvv cA cn
      cX vf cv wf vx cv cX wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a vf vx copab vf cv
      cF wceq cn cX vf cv wf cn cX cF wf vm cv vf cv cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv wral vm cv cF cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv
      wral vx cv cX wcel cn cX vf cv cF feq1 vf cv cF wceq vm cv vf cv cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex vm cv cF cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu vx cv csn cJ cnei cfv cfv vf cv cF wceq vm cv
      vf cv cfv vu cv wcel vm cv cF cfv vu cv wcel vn vm cn vn cv cuz cfv vf cv
      cF wceq vm cv vf cv cfv vm cv cF cfv vu cv vm cv vf cv cF fveq1 eleq1d
      rexralbidv ralbidv 3anbi13d vx cv cY wceq vx cv cX wcel cY cX wcel vm cv
      cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ cnei
      cfv cfv wral vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      cY csn cJ cnei cfv cfv wral cn cX cF wf vx cv cY cX eleq1 vx cv cY wceq
      vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv csn cJ
      cnei cfv cfv cY csn cJ cnei cfv cfv vx cv cY wceq vx cv csn cY csn cJ
      cnei cfv vx cv cY sneq fveq2d raleq1d 3anbi23d cn cX vf cv wf vx cv cX
      wcel vm cv vf cv cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu vx cv
      csn cJ cnei cfv cfv wral w3a vf vx copab eqid cn cX cF wf cY cX wcel cF
      cvv wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY
      csn cJ cnei cfv cfv wral cn cX cF wf cn cvv wcel cF cvv wcel nnex cn cX
      cvv cF fex mpan2 3ad2ant1 brabg2 sylan9bb $.
      $( [2-Sep-2009] $)

    $( The binary relation " ` F ` converges to ` Y ` topologically". $)
    tlmbrf $p |- ( ( J e. Top /\ Y e. A /\ F : NN --> X ) -> ( F ( ~~>t ` J ) Y
                    <-> ( Y e. X /\ A. u e. ( ( nei ` J ) ` { Y } ) E. n e. NN
                                A. m e. ( ZZ>= ` n ) ( F ` m ) e. u ) ) ) $=
      cJ ctop wcel cY cA wcel cn cX cF wf w3a cF cY cJ ctlm cfv wbr cn cX cF wf
      cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY
      csn cJ cnei cfv cfv wral w3a cY cX wcel vm cv cF cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral wa cJ ctop wcel cY
      cA wcel cF cY cJ ctlm cfv wbr cn cX cF wf cY cX wcel vm cv cF cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral w3a
      wb cn cX cF wf vu cA vm vn cF cJ cX cY tlmval.1 tlmbr 3adant3 cJ ctop
      wcel cY cA wcel cn cX cF wf w3a cn cX cF wf cY cX wcel vm cv cF cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral wa
      wa cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      cY csn cJ cnei cfv cfv wral wa cn cX cF wf cY cX wcel vm cv cF cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral w3a
      cJ ctop wcel cY cA wcel cn cX cF wf cn cX cF wf cY cX wcel vm cv cF cfv
      vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv
      wral wa wa cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn
      wrex vu cY csn cJ cnei cfv cfv wral wa cJ ctop wcel cY cA wcel cn cX cF
      wf w3a cn cX cF wf cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu cY csn cJ cnei cfv cfv wral wa wa biidd ompfl3 cn cX
      cF wf cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex
      vu cY csn cJ cnei cfv cfv wral 3anass syl5bb bitrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d F a b c d p q u v x y $. $d J a b c d p q u v x y $.
    $d X a b c d p q u v x y $.
    haustlmu.1 $e |- X = U. J $.
    $( Limits are unique in a Hausdorff space. $)
    haustlmu $p |- ( J e. Haus -> E* x F ( ~~>t ` J ) x ) $=
      cJ cha wcel cF vx cv cJ ctlm cfv wbr cF vy cv cJ ctlm cfv wbr wa vx cv vy
      cv wceq wi vy wal vx wal cF vx cv cJ ctlm cfv wbr vx wmo cJ cha wcel cF
      vx cv cJ ctlm cfv wbr cF vy cv cJ ctlm cfv wbr wa vx cv vy cv wceq wi vx
      vy cJ cha wcel cF vx cv cJ ctlm cfv wbr cF vy cv cJ ctlm cfv wbr wa cn cX
      cF wf vx cv cX wcel vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn
      wrex vu vx cv csn cJ cnei cfv cfv wral w3a cn cX cF wf vy cv cX wcel vd
      cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ
      cnei cfv cfv wral w3a wa vx cv vy cv wceq cJ cha wcel cJ ctop wcel cF vx
      cv cJ ctlm cfv wbr cF vy cv cJ ctlm cfv wbr wa cn cX cF wf vx cv cX wcel
      vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ
      cnei cfv cfv wral w3a cn cX cF wf vy cv cX wcel vd cv cF cfv vv cv wcel
      vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral w3a wa
      wb cJ haustop cJ ctop wcel cF vx cv cJ ctlm cfv wbr cn cX cF wf vx cv cX
      wcel vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv
      csn cJ cnei cfv cfv wral w3a cF vy cv cJ ctlm cfv wbr cn cX cF wf vy cv
      cX wcel vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv
      csn cJ cnei cfv cfv wral w3a cJ ctop wcel vx cv cvv wcel cF vx cv cJ ctlm
      cfv wbr cn cX cF wf vx cv cX wcel vb cv cF cfv vu cv wcel vb va cv cuz
      cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral w3a wb vx visset vu
      cvv vb va cF cJ cX vx cv haustlmu.1 tlmbr mpan2 cJ ctop wcel vy cv cvv
      wcel cF vy cv cJ ctlm cfv wbr cn cX cF wf vy cv cX wcel vd cv cF cfv vv
      cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv
      wral w3a wb vy visset vv cvv vd vc cF cJ cX vy cv haustlmu.1 tlmbr mpan2
      anbi12d syl cJ cha wcel vx cv cX wcel vb cv cF cfv vu cv wcel vb va cv
      cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral wa vy cv cX
      wcel vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv
      csn cJ cnei cfv cfv wral wa vx cv vy cv wceq cn cX cF wf vx cv cX wcel vb
      cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ
      cnei cfv cfv wral w3a cn cX cF wf vy cv cX wcel vd cv cF cfv vv cv wcel
      vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral w3a cJ
      cha wcel vx cv cX wcel vy cv cX wcel wa vb cv cF cfv vu cv wcel vb va cv
      cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv
      cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv
      wral wa wa vx cv vy cv wceq vx cv cX wcel vb cv cF cfv vu cv wcel vb va
      cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral wa vy cv cX
      wcel vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv
      csn cJ cnei cfv cfv wral wa wa cJ cha wcel vx cv cX wcel vy cv cX wcel wa
      vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ
      cnei cfv cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn
      wrex vv vy cv csn cJ cnei cfv cfv wral wa vx cv vy cv wceq cJ cha wcel vx
      cv cX wcel vy cv cX wcel wa wa vb cv cF cfv vu cv wcel vb va cv cuz cfv
      wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv cv wcel
      vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral wa vx
      cv vy cv cJ cha wcel vx cv cX wcel vy cv cX wcel vx cv vy cv wne vb cv cF
      cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv
      cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy
      cv csn cJ cnei cfv cfv wral wa wn wi cJ cha wcel vx cv cX wcel vy cv cX
      wcel vx cv vy cv wne vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn
      wrex vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv cv wcel vd vc cv
      cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral wa wn cJ cha
      wcel vx cv cX wcel vy cv cX wcel vx cv vy cv wne w3a wa vx cv vp cv wcel
      vy cv vq cv wcel vp cv vq cv cin c0 wceq w3a vq cJ wrex vp cJ wrex vb cv
      cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei
      cfv cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv
      vy cv csn cJ cnei cfv cfv wral wa wn vx cv vy cv vq vp cJ cX haustlmu.1
      hausnei cJ cha wcel vx cv cX wcel vy cv cX wcel vx cv vy cv wne w3a wa vx
      cv vp cv wcel vy cv vq cv wcel vp cv vq cv cin c0 wceq w3a vb cv cF cfv
      vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv
      wral vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv
      csn cJ cnei cfv cfv wral wa wn vp vq cJ cJ cJ cha wcel vx cv cX wcel vy
      cv cX wcel vx cv vy cv wne w3a wa vp cv cJ wcel vq cv cJ wcel wa vx cv vp
      cv wcel vy cv vq cv wcel vp cv vq cv cin c0 wceq w3a vb cv cF cfv vu cv
      wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral
      vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ
      cnei cfv cfv wral wa wn wi cJ cha wcel vx cv cX wcel vy cv cX wcel vx cv
      vy cv wne w3a wa vp cv cJ wcel vq cv cJ wcel wa wa vx cv vp cv wcel vy cv
      vq cv wcel vp cv vq cv cin c0 wceq vb cv cF cfv vu cv wcel vb va cv cuz
      cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv cv
      wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral
      wa wn cJ cha wcel vx cv cX wcel vy cv cX wcel vx cv vy cv wne w3a wa vp
      cv cJ wcel vq cv cJ wcel wa wa vx cv vp cv wcel vy cv vq cv wcel vp cv vq
      cv cin c0 wceq vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex
      vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz
      cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral wa wn wi cJ cha
      wcel vx cv cX wcel vy cv cX wcel vx cv vy cv wne w3a wa vp cv cJ wcel vq
      cv cJ wcel wa vx cv vp cv wcel vy cv vq cv wcel wa vp cv vq cv cin c0
      wceq vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv
      csn cJ cnei cfv cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc
      cn wrex vv vy cv csn cJ cnei cfv cfv wral wa wn wi cJ cha wcel vx cv cX
      wcel vy cv cX wcel vx cv vy cv wne w3a wa vp cv cJ wcel vx cv vp cv wcel
      wa vq cv cJ wcel vy cv vq cv wcel wa wa vp cv vq cv cin c0 wceq vb cv cF
      cfv vu cv wcel vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv
      cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy
      cv csn cJ cnei cfv cfv wral wa wn wi vp cv cJ wcel vq cv cJ wcel wa vx cv
      vp cv wcel vy cv vq cv wcel wa wa cJ cha wcel vx cv cX wcel vy cv cX wcel
      vx cv vy cv wne w3a wa vp cv cJ wcel vx cv vp cv wcel wa vq cv cJ wcel vy
      cv vq cv wcel wa wa vp cv vx cv csn cJ cnei cfv cfv wcel vq cv vy cv csn
      cJ cnei cfv cfv wcel wa vp cv vq cv cin c0 wceq vb cv cF cfv vu cv wcel
      vb va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral vd cv
      cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei
      cfv cfv wral wa wn wi cJ cha wcel vp cv cJ wcel vx cv vp cv wcel wa vq cv
      cJ wcel vy cv vq cv wcel wa wa vp cv vx cv csn cJ cnei cfv cfv wcel vq cv
      vy cv csn cJ cnei cfv cfv wcel wa wi vx cv cX wcel vy cv cX wcel vx cv vy
      cv wne w3a cJ cha wcel cJ ctop wcel vp cv cJ wcel vx cv vp cv wcel wa vq
      cv cJ wcel vy cv vq cv wcel wa wa vp cv vx cv csn cJ cnei cfv cfv wcel vq
      cv vy cv csn cJ cnei cfv cfv wcel wa wi cJ haustop cJ ctop wcel vp cv cJ
      wcel vx cv vp cv wcel wa vp cv vx cv csn cJ cnei cfv cfv wcel vq cv cJ
      wcel vy cv vq cv wcel wa vq cv vy cv csn cJ cnei cfv cfv wcel cJ ctop
      wcel vp cv cJ wcel vx cv vp cv wcel vp cv vx cv csn cJ cnei cfv cfv wcel
      vx cv cJ vp cv opnneip 3expib cJ ctop wcel vq cv cJ wcel vy cv vq cv wcel
      vq cv vy cv csn cJ cnei cfv cfv wcel vy cv cJ vq cv opnneip 3expib
      anim12d syl adantr vp cv vx cv csn cJ cnei cfv cfv wcel vq cv vy cv csn
      cJ cnei cfv cfv wcel wa vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va
      cn wrex vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv cv wcel vd vc
      cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral wa vp cv vq
      cv cin c0 vp cv vx cv csn cJ cnei cfv cfv wcel vq cv vy cv csn cJ cnei
      cfv cfv wcel wa vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn wrex
      vu vx cv csn cJ cnei cfv cfv wral vd cv cF cfv vv cv wcel vd vc cv cuz
      cfv wral vc cn wrex vv vy cv csn cJ cnei cfv cfv wral wa vp cv vq cv cin
      c0 wne vp cv vx cv csn cJ cnei cfv cfv wcel vb cv cF cfv vu cv wcel vb va
      cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral vq cv vy cv
      csn cJ cnei cfv cfv wcel vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc
      cn wrex vv vy cv csn cJ cnei cfv cfv wral vp cv vq cv cin c0 wne vb cv cF
      cfv vp cv wcel vb va cv cuz cfv wral va cn wrex vd cv cF cfv vq cv wcel
      vd vc cv cuz cfv wral vc cn wrex vp cv vq cv cin c0 wne vp cv vx cv csn
      cJ cnei cfv cfv wcel vb cv cF cfv vu cv wcel vb va cv cuz cfv wral va cn
      wrex vu vx cv csn cJ cnei cfv cfv wral wa vq cv vy cv csn cJ cnei cfv cfv
      wcel vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv
      csn cJ cnei cfv cfv wral wa vb cv cF cfv vp cv wcel vb va cv cuz cfv wral
      va cn wrex vd cv cF cfv vq cv wcel vd vc cv cuz cfv wral vc cn wrex wa vb
      cv cF cfv vp cv wcel vb va cv cuz cfv wral vd cv cF cfv vq cv wcel vd vc
      cv cuz cfv wral wa vc cn wrex va cn wrex vp cv vq cv cin c0 wne vb cv cF
      cfv vp cv wcel vb va cv cuz cfv wral vd cv cF cfv vq cv wcel vd vc cv cuz
      cfv wral va vc cn cn reeanv vb cv cF cfv vp cv wcel vb va cv cuz cfv wral
      vd cv cF cfv vq cv wcel vd vc cv cuz cfv wral wa vp cv vq cv cin c0 wne
      va vc cn cn va cv cn wcel vc cv cn wcel wa vb cv cF cfv vp cv wcel vb va
      cv cuz cfv wral vd cv cF cfv vq cv wcel vd vc cv cuz cfv wral wa va cv vc
      cv caddc co cF cfv vp cv wcel va cv vc cv caddc co cF cfv vq cv wcel wa
      vp cv vq cv cin c0 wne va cv cn wcel vc cv cn wcel wa vb cv cF cfv vp cv
      wcel vb va cv cuz cfv wral va cv vc cv caddc co cF cfv vp cv wcel vd cv
      cF cfv vq cv wcel vd vc cv cuz cfv wral va cv vc cv caddc co cF cfv vq cv
      wcel va cv cn wcel vc cv cn wcel wa va cv vc cv caddc co va cv cuz cfv
      wcel vb cv cF cfv vp cv wcel vb va cv cuz cfv wral va cv vc cv caddc co
      cF cfv vp cv wcel wi va cv va cv cuz cfv wcel vc cv cn0 wcel va cv vc cv
      caddc co va cv cuz cfv wcel va cv cn wcel vc cv cn wcel vc cv va cv va cv
      uzaddcl va cv cn wcel va cv cz wcel va cv va cv cuz cfv wcel va cv nnz va
      cv uzid syl vc cv nnnn0 syl2an vb cv cF cfv vp cv wcel va cv vc cv caddc
      co cF cfv vp cv wcel vb va cv vc cv caddc co va cv cuz cfv vb cv va cv vc
      cv caddc co wceq vb cv cF cfv va cv vc cv caddc co cF cfv vp cv vb cv va
      cv vc cv caddc co cF fveq2 eleq1d rcla4v syl va cv cn wcel vc cv cn wcel
      wa va cv vc cv caddc co vc cv cuz cfv wcel vd cv cF cfv vq cv wcel vd vc
      cv cuz cfv wral va cv vc cv caddc co cF cfv vq cv wcel wi va cv cn wcel
      vc cv cn wcel wa va cv vc cv caddc co vc cv va cv caddc co vc cv cuz cfv
      va cv cc wcel vc cv cc wcel va cv vc cv caddc co vc cv va cv caddc co
      wceq va cv cn wcel vc cv cn wcel va cv vc cv addcom va cv nncn vc cv nncn
      syl2an vc cv cn wcel va cv cn wcel vc cv va cv caddc co vc cv cuz cfv
      wcel vc cv vc cv cuz cfv wcel va cv cn0 wcel vc cv va cv caddc co vc cv
      cuz cfv wcel vc cv cn wcel va cv cn wcel va cv vc cv vc cv uzaddcl vc cv
      cn wcel vc cv cz wcel vc cv vc cv cuz cfv wcel vc cv nnz vc cv uzid syl
      va cv nnnn0 syl2an ancoms eqeltrd vd cv cF cfv vq cv wcel va cv vc cv
      caddc co cF cfv vq cv wcel vd va cv vc cv caddc co vc cv cuz cfv vd cv va
      cv vc cv caddc co wceq vd cv cF cfv va cv vc cv caddc co cF cfv vq cv vd
      cv va cv vc cv caddc co cF fveq2 eleq1d rcla4v syl anim12d va cv vc cv
      caddc co cF cfv vp cv vq cv inelcm syl6 r19.23aivv sylbir vb cv cF cfv vu
      cv wcel vb va cv cuz cfv wral va cn wrex vb cv cF cfv vp cv wcel vb va cv
      cuz cfv wral va cn wrex vu vp cv vx cv csn cJ cnei cfv cfv vu cv vp cv
      wceq vb cv cF cfv vu cv wcel vb cv cF cfv vp cv wcel va vb cn va cv cuz
      cfv vu cv vp cv vb cv cF cfv eleq2 rexralbidv rcla4va vd cv cF cfv vv cv
      wcel vd vc cv cuz cfv wral vc cn wrex vd cv cF cfv vq cv wcel vd vc cv
      cuz cfv wral vc cn wrex vv vq cv vy cv csn cJ cnei cfv cfv vv cv vq cv
      wceq vd cv cF cfv vv cv wcel vd cv cF cfv vq cv wcel vc vd cn vc cv cuz
      cfv vv cv vq cv vd cv cF cfv eleq2 rexralbidv rcla4va syl2an an4s ex
      necon2bd syl6 vp cv cJ wcel vq cv cJ wcel vx cv vp cv wcel vy cv vq cv
      wcel an4 syl5ib expdimp exp3a 3impd ex r19.23advv mpd 3exp2 imp32
      necon4ad expimpd vx cv cX wcel vb cv cF cfv vu cv wcel vb va cv cuz cfv
      wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral vy cv cX wcel vd cv cF
      cfv vv cv wcel vd vc cv cuz cfv wral vc cn wrex vv vy cv csn cJ cnei cfv
      cfv wral an4 syl5ib cn cX cF wf vx cv cX wcel vb cv cF cfv vu cv wcel vb
      va cv cuz cfv wral va cn wrex vu vx cv csn cJ cnei cfv cfv wral 3simpc cn
      cX cF wf vy cv cX wcel vd cv cF cfv vv cv wcel vd vc cv cuz cfv wral vc
      cn wrex vv vy cv csn cJ cnei cfv cfv wral 3simpc syl2ani sylbid 19.21aivv
      cF vx cv cJ ctlm cfv wbr cF vy cv cJ ctlm cfv wbr vx vy vx cv vy cv cF cJ
      ctlm cfv breq2 mo4 sylibr $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J m n u $. $d X m n u $. $d Y m n u $.
    tlmconst.1 $e |- X = U. J $.
    $( A constant sequence converges to the constant. $)
    tlmconst $p |- ( ( J e. Top /\ Y e. X ) ->
                                    ( NN X. { Y } ) ( ~~>t ` J ) Y ) $=
      cJ ctop wcel cY cX wcel wa cn cY csn cxp cY cJ ctlm cfv wbr cn cX cn cY
      csn cxp wf cY cX wcel vm cv cn cY csn cxp cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu cY csn cJ cnei cfv cfv wral w3a cJ ctop wcel cY cX
      wcel wa cn cX cn cY csn cxp wf cY cX wcel vm cv cn cY csn cxp cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral cY
      cX wcel cn cX cn cY csn cxp wf cJ ctop wcel cn cY csn cn cY csn cxp wf cY
      csn cX wss cn cX cn cY csn cxp wf cY cX wcel cn cY csn cX cn cY csn cxp
      fss cn cY cX fconstg cY cX snssi sylanc adantl cJ ctop wcel cY cX wcel
      pm3.27 cJ ctop wcel cY cX wcel wa vm cv cn cY csn cxp cfv vu cv wcel vm
      vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv c1 cn wcel vm cv
      cn cY csn cxp cfv vu cv wcel vm c1 cuz cfv wral vm cv cn cY csn cxp cfv
      vu cv wcel vm vn cv cuz cfv wral vn cn wrex cJ ctop wcel cY cX wcel wa vu
      cv cY csn cJ cnei cfv cfv wcel wa vm cv cn cY csn cxp cfv vu cv wcel vm
      vn cv cuz cfv wral vm cv cn cY csn cxp cfv vu cv wcel vm c1 cuz cfv wral
      vn c1 cn vn cv c1 wceq vm cv cn cY csn cxp cfv vu cv wcel vm vn cv cuz
      cfv c1 cuz cfv vn cv c1 cuz fveq2 raleq1d rcla4ev 1nn cJ ctop wcel cY cX
      wcel wa vu cv cY csn cJ cnei cfv cfv wcel wa vm cv cn cY csn cxp cfv vu
      cv wcel vm c1 cuz cfv cJ ctop wcel cY cX wcel wa vu cv cY csn cJ cnei cfv
      cfv wcel wa vm cv cn wcel vm cv cn cY csn cxp cfv vu cv wcel vm cv c1 cuz
      cfv wcel cJ ctop wcel cY cX wcel wa vu cv cY csn cJ cnei cfv cfv wcel wa
      vm cv cn wcel wa vm cv cn cY csn cxp cfv cY vu cv cJ ctop wcel cY cX wcel
      wa vm cv cn wcel vm cv cn cY csn cxp cfv cY wceq vu cv cY csn cJ cnei cfv
      cfv wcel cY cX wcel vm cv cn wcel vm cv cn cY csn cxp cfv cY wceq cJ ctop
      wcel cn cY vm cv cX fvconst2g adantll adantlr cJ ctop wcel cY cX wcel wa
      vu cv cY csn cJ cnei cfv cfv wcel wa cY vu cv wcel vm cv cn wcel cJ ctop
      wcel cY cX wcel wa vu cv cY csn cJ cnei cfv cfv wcel cY csn vu cv wss cY
      vu cv wcel cJ ctop wcel vu cv cY csn cJ cnei cfv cfv wcel cY csn vu cv
      wss cY cX wcel cY csn cJ vu cv ssnei adantlr cY cX wcel cY csn vu cv wss
      cY vu cv wcel cJ ctop wcel cY cX wcel cY vu cv wcel cY csn vu cv wss cY
      vu cv cX snssg biimpar adantll syldan adantr eqeltrd vm cv elnnuz
      sylan2br r19.21aiva sylancr r19.21aiva 3jca vu cX vm vn cn cY csn cxp cJ
      cX cY tlmconst.1 tlmbr mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M m n r s u $. $d J m n r s u $. $d X m n r s u $.
    $d F m n r s u $. $d Y m n r s u $. $d A m n r s u $.
    lmtlm.1 $e |- J = ( Open ` M ) $.
    lmtlm.2 $e |- X = dom dom M $.
    $( Metric space limits are topological limits under the standard
       topology. $)
    lmtlm $p |- ( ( M e. Met /\ Y e. A /\ F : NN --> X ) ->
                              ( F ( ~~>t ` J ) Y <-> F ( ~~>m ` M ) Y ) ) $=
      cM cme wcel cY cA wcel cn cX cF wf w3a cY cJ cuni wcel vm cv cF cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral wa
      cY cX wcel cc0 vr cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vr
      cv clt wbr wi vm cn wral vn cn wrex wi vr cr wral wa cF cY cJ ctlm cfv
      wbr cF cY cM clm cfv wbr cM cme wcel cY cA wcel cn cX cF wf w3a cY cJ
      cuni wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY
      csn cJ cnei cfv cfv wral wa cY cX wcel vm cv cF cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral wa cY cX wcel cc0
      vr cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi
      vm cn wral vn cn wrex wi vr cr wral wa cM cme wcel cY cA wcel cn cX cF wf
      w3a cY cJ cuni wcel cY cX wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu cY csn cJ cnei cfv cfv wral cM cme wcel cY cA wcel cn
      cX cF wf w3a cJ cuni cX cY cM cme wcel cY cA wcel cJ cuni cX wceq cn cX
      cF wf cM cJ cX lmtlm.2 lmtlm.1 uniopn2 3ad2ant1 eleq2d anbi1d cM cme wcel
      cY cA wcel cn cX cF wf w3a cY cX wcel vm cv cF cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral cc0 vr cv clt wbr
      vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn
      cn wrex wi vr cr wral cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel
      wa vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ
      cnei cfv cfv wral cc0 vr cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY
      cM co vr cv clt wbr wi vm cn wral vn cn wrex wi vr cr wral cM cme wcel cY
      cA wcel cn cX cF wf w3a cY cX wcel wa vm cv cF cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral cc0 vr cv clt wbr
      vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn
      cn wrex wi vr cr cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr
      cv cr wcel wa cc0 vr cv clt wbr vm cv cF cfv vu cv wcel vm vn cv cuz cfv
      wral vn cn wrex vu cY csn cJ cnei cfv cfv wral vn cv vm cv cle wbr vm cv
      cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex cM cme wcel cY cA
      wcel cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0 vr cv clt wbr vm cv
      cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv
      cfv wral vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn
      wral vn cn wrex wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa
      vr cv cr wcel cc0 vr cv clt wbr wa wa cY vr cv cM cbl cfv co cY csn cJ
      cnei cfv cfv wcel vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn
      wrex vu cY csn cJ cnei cfv cfv wral vn cv vm cv cle wbr vm cv cF cfv cY
      cM co vr cv clt wbr wi vm cn wral vn cn wrex cM cme wcel cY cA wcel cn cX
      cF wf w3a cY cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa cY vr cv cM
      cbl cfv co cY csn cJ cnei cfv cfv wcel cM cme wcel cY cA wcel cY cX wcel
      vr cv cr wcel cc0 vr cv clt wbr wa cY vr cv cM cbl cfv co cY csn cJ cnei
      cfv cfv wcel wi cn cX cF wf cM cme wcel cY cX wcel wa vr cv cr wcel cc0
      vr cv clt wbr wa cY vr cv cM cbl cfv co cY csn cJ cnei cfv cfv wcel cM cY
      vr cv cJ cX lmtlm.2 lmtlm.1 blnei ex 3ad2antl1 imp cM cme wcel cY cA wcel
      cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa wa vm cv
      cF cfv cY vr cv cM cbl cfv co wcel vm vn cv cuz cfv wral vn cn wrex vn cv
      vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn
      wrex cY vr cv cM cbl cfv co cY csn cJ cnei cfv cfv wcel vm cv cF cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral
      wa cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0
      vr cv clt wbr wa wa vm cv cF cfv cY vr cv cM cbl cfv co wcel vm vn cv cuz
      cfv wral vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn
      wral vn cn cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr cv cr
      wcel cc0 vr cv clt wbr wa wa vn cv cn wcel wa vm cv cF cfv cY vr cv cM
      cbl cfv co wcel vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr
      wi vm vn cv cuz cfv cn cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel
      wa vr cv cr wcel cc0 vr cv clt wbr wa wa vn cv cn wcel wa vm cv vn cv cuz
      cfv wcel vm cv cF cfv cY vr cv cM cbl cfv co wcel wi vm cv cn wcel vn cv
      vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr cM cme wcel cY cA wcel
      cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa wa vn cv
      cn wcel wa vm cv vn cv cuz cfv wcel vm cv cF cfv cY vr cv cM cbl cfv co
      wcel wi vm cv cn wcel vn cv vm cv cle wbr wa vm cv cF cfv cY vr cv cM cbl
      cfv co wcel wi vm cv cn wcel vn cv vm cv cle wbr wa vm cv cF cfv cY cM co
      vr cv clt wbr wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr
      cv cr wcel cc0 vr cv clt wbr wa wa vn cv cn wcel wa vm cv cn wcel vn cv
      vm cv cle wbr wa vm cv vn cv cuz cfv wcel vm cv cF cfv cY vr cv cM cbl
      cfv co wcel vn cv cn wcel vm cv cn wcel vn cv vm cv cle wbr wa vm cv vn
      cv cuz cfv wcel wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa
      vr cv cr wcel cc0 vr cv clt wbr wa wa vn cv cn wcel vm cv cn wcel vn cv
      vm cv cle wbr vm cv vn cv cuz cfv wcel vn cv cn wcel vm cv cn wcel wa vm
      cv vn cv cuz cfv wcel vn cv vm cv cle wbr vn cv cz wcel vm cv cz wcel vm
      cv vn cv cuz cfv wcel vn cv vm cv cle wbr wb vn cv cn wcel vm cv cn wcel
      vn cv vm cv eluz vn cv nnz vm cv nnz syl2an biimprd expimpd adantl imim1d
      cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0 vr
      cv clt wbr wa wa vn cv cn wcel wa vm cv cn wcel vn cv vm cv cle wbr wa vm
      cv cF cfv cY vr cv cM cbl cfv co wcel vm cv cF cfv cY cM co vr cv clt wbr
      cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0 vr
      cv clt wbr wa wa vn cv cn wcel wa vm cv cn wcel vn cv vm cv cle wbr wa vm
      cv cF cfv cY vr cv cM cbl cfv co wcel vm cv cF cfv cY cM co vr cv clt wbr
      wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vr cv cr wcel cc0
      vr cv clt wbr wa wa vm cv cn wcel vm cv cF cfv cY vr cv cM cbl cfv co
      wcel vm cv cF cfv cY cM co vr cv clt wbr wi vn cv cn wcel vn cv vm cv cle
      wbr cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vm cv cn wcel vr
      cv cr wcel cc0 vr cv clt wbr wa vm cv cF cfv cY vr cv cM cbl cfv co wcel
      vm cv cF cfv cY cM co vr cv clt wbr wi cM cme wcel cY cA wcel cn cX cF wf
      w3a cY cX wcel wa vm cv cn wcel wa vr cv cr wcel cc0 vr cv clt wbr wa vm
      cv cF cfv cY vr cv cM cbl cfv co wcel vm cv cF cfv cY cM co vr cv clt wbr
      wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel vm cv cn wcel vr cv
      cr wcel cc0 vr cv clt wbr wa vm cv cF cfv cY vr cv cM cbl cfv co wcel vm
      cv cF cfv cY cM co vr cv clt wbr wi wi cM cme wcel cY cX wcel vm cv cF
      cfv cX wcel vr cv cr wcel cc0 vr cv clt wbr wa vm cv cF cfv cY vr cv cM
      cbl cfv co wcel vm cv cF cfv cY cM co vr cv clt wbr wi wi cM cme wcel cY
      cA wcel cn cX cF wf w3a cY cX wcel vm cv cn wcel wa wa cM cme wcel cY cX
      wcel vm cv cF cfv cX wcel w3a vr cv cr wcel cc0 vr cv clt wbr wa vm cv cF
      cfv cY vr cv cM cbl cfv co wcel vm cv cF cfv cY cM co vr cv clt wbr wi cM
      cme wcel cY cX wcel vm cv cF cfv cX wcel w3a vr cv cr wcel cc0 vr cv clt
      wbr wa wa vm cv cF cfv cY vr cv cM cbl cfv co wcel vm cv cF cfv cY cM co
      vr cv clt wbr vm cv cF cfv cM cY vr cv cX lmtlm.2 elbl3 biimpd ex cM cme
      wcel cY cA wcel cn cX cF wf w3a cM cme wcel cY cX wcel vm cv cn wcel wa
      cM cme wcel cY cA wcel cn cX cF wf 3simp1 adantr cM cme wcel cY cA wcel
      cn cX cF wf w3a cY cX wcel vm cv cn wcel simprl cM cme wcel cY cA wcel cn
      cX cF wf w3a vm cv cn wcel vm cv cF cfv cX wcel cY cX wcel cn cX cF wf cM
      cme wcel vm cv cn wcel vm cv cF cfv cX wcel cY cA wcel cn cX vm cv cF
      ffvelrn 3ad2antl3 adantrl syl3anc anassrs imp an1rs ad2ant2r ex a2d syld
      exp4a r19.20dv2 r19.22dva vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral
      vn cn wrex vm cv cF cfv cY vr cv cM cbl cfv co wcel vm vn cv cuz cfv wral
      vn cn wrex vu cY vr cv cM cbl cfv co cY csn cJ cnei cfv cfv vu cv cY vr
      cv cM cbl cfv co wceq vm cv cF cfv vu cv wcel vm cv cF cfv cY vr cv cM
      cbl cfv co wcel vn vm cn vn cv cuz cfv vu cv cY vr cv cM cbl cfv co vm cv
      cF cfv eleq2 rexralbidv rcla4va syl5 mpand expr com23 r19.21adva cM cme
      wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa cc0 vr cv clt wbr vn cv vm
      cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex
      wi vr cr wral vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex vu
      cY csn cJ cnei cfv cfv cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel
      wa vu cv cY csn cJ cnei cfv cfv wcel cc0 vr cv clt wbr vn cv vm cv cle
      wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex wi vr cr
      wral vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex cM cme wcel
      cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cY csn cJ cnei cfv cfv
      wcel vu cv cX wss cc0 vs cv clt wbr cY vs cv cM cbl cfv co vu cv wss wa
      vs cr wrex wa cc0 vr cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co
      vr cv clt wbr wi vm cn wral vn cn wrex wi vr cr wral vm cv cF cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex wi cM cme wcel cY cA wcel cY cX
      wcel vu cv cY csn cJ cnei cfv cfv wcel vu cv cX wss cc0 vs cv clt wbr cY
      vs cv cM cbl cfv co vu cv wss wa vs cr wrex wa wb cn cX cF wf cM cY cJ vu
      cv cX vs lmtlm.2 lmtlm.1 neibl 3ad2antl1 cM cme wcel cY cA wcel cn cX cF
      wf w3a cY cX wcel wa vu cv cX wss cc0 vs cv clt wbr cY vs cv cM cbl cfv
      co vu cv wss wa vs cr wrex cc0 vr cv clt wbr vn cv vm cv cle wbr vm cv cF
      cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex wi vr cr wral vm cv
      cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex wi cM cme wcel cY cA
      wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa cc0 vs cv clt wbr cY
      vs cv cM cbl cfv co vu cv wss wa cc0 vr cv clt wbr vn cv vm cv cle wbr vm
      cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex wi vr cr wral
      vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex wi vs cr cM cme
      wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa vs cv cr
      wcel cc0 vr cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv
      clt wbr wi vm cn wral vn cn wrex wi vr cr wral cc0 vs cv clt wbr cY vs cv
      cM cbl cfv co vu cv wss wa vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral
      vn cn wrex cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX
      wss wa vs cv cr wcel cc0 vr cv clt wbr vn cv vm cv cle wbr vm cv cF cfv
      cY cM co vr cv clt wbr wi vm cn wral vn cn wrex wi vr cr wral cc0 vs cv
      clt wbr cY vs cv cM cbl cfv co vu cv wss wa vm cv cF cfv vu cv wcel vm vn
      cv cuz cfv wral vn cn wrex wi cM cme wcel cY cA wcel cn cX cF wf w3a cY
      cX wcel wa vu cv cX wss wa vs cv cr wcel cc0 vs cv clt wbr vn cv vm cv
      cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex wi
      wa cc0 vs cv clt wbr cY vs cv cM cbl cfv co vu cv wss wa vm cv cF cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex wi vs cv cr wcel cc0 vr cv clt
      wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral
      vn cn wrex wi vr cr wral wa cc0 vs cv clt wbr cY vs cv cM cbl cfv co vu
      cv wss wa vs cv cr wcel cc0 vs cv clt wbr vn cv vm cv cle wbr vm cv cF
      cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex wi wa cM cme wcel cY
      cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa vm cv cF cfv vu cv
      wcel vm vn cv cuz cfv wral vn cn wrex cc0 vs cv clt wbr cY vs cv cM cbl
      cfv co vu cv wss wa vs cv cr wcel cc0 vs cv clt wbr vn cv vm cv cle wbr
      vm cv cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex wi cM cme
      wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa vm cv cF
      cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex wi cc0 vs cv clt wbr cY
      vs cv cM cbl cfv co vu cv wss wa vs cv cr wcel wa cc0 vs cv clt wbr vn cv
      vm cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn
      wrex wi vn cv vm cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi vm cn
      wral vn cn wrex cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu
      cv cX wss wa vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex wi
      cc0 vs cv clt wbr cc0 vs cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY
      cM co vs cv clt wbr wi vm cn wral vn cn wrex wi vn cv vm cv cle wbr vm cv
      cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex wi cY vs cv cM cbl
      cfv co vu cv wss vs cv cr wcel cc0 vs cv clt wbr vn cv vm cv cle wbr vm
      cv cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex pm2.27 ad2antrr
      cY vs cv cM cbl cfv co vu cv wss cc0 vs cv clt wbr vs cv cr wcel vn cv vm
      cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex
      cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa vm
      cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn wrex wi wi cY vs cv cM
      cbl cfv co vu cv wss cc0 vs cv clt wbr vs cv cr wcel vn cv vm cv cle wbr
      vm cv cF cfv cY cM co vs cv clt wbr wi vm cn wral vn cn wrex cM cme wcel
      cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa vm cv cF cfv vu
      cv wcel vm vn cv cuz cfv wral vn cn wrex wi wi cY vs cv cM cbl cfv co vu
      cv wss vs cv cr wcel cc0 vs cv clt wbr vn cv vm cv cle wbr vm cv cF cfv
      cY cM co vs cv clt wbr wi vm cn wral vn cn wrex cM cme wcel cY cA wcel cn
      cX cF wf w3a cY cX wcel wa vu cv cX wss wa vm cv cF cfv vu cv wcel vm vn
      cv cuz cfv wral vn cn wrex wi wi cY vs cv cM cbl cfv co vu cv wss vs cv
      cr wcel cc0 vs cv clt wbr wa wa cM cme wcel cY cA wcel cn cX cF wf w3a cY
      cX wcel wa vu cv cX wss wa vn cv vm cv cle wbr vm cv cF cfv cY cM co vs
      cv clt wbr wi vm cn wral vn cn wrex vm cv cF cfv vu cv wcel vm vn cv cuz
      cfv wral vn cn wrex cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa
      vu cv cX wss wa cY vs cv cM cbl cfv co vu cv wss vs cv cr wcel cc0 vs cv
      clt wbr wa wa vn cv vm cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi
      vm cn wral vn cn wrex vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn
      wrex wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss
      wa cY vs cv cM cbl cfv co vu cv wss vs cv cr wcel cc0 vs cv clt wbr wa wa
      wa vn cv vm cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi vm cn wral
      vm cv cF cfv vu cv wcel vm vn cv cuz cfv wral vn cn cM cme wcel cY cA
      wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa cY vs cv cM cbl cfv co
      vu cv wss vs cv cr wcel cc0 vs cv clt wbr wa wa wa vn cv cn wcel wa vn cv
      vm cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi vm cv cF cfv vu cv
      wcel vm cn vn cv cuz cfv cM cme wcel cY cA wcel cn cX cF wf w3a cY cX
      wcel wa vu cv cX wss wa cY vs cv cM cbl cfv co vu cv wss vs cv cr wcel
      cc0 vs cv clt wbr wa wa wa vn cv cn wcel wa vm cv cn wcel vn cv vm cv cle
      wbr wa vm cv cF cfv cY cM co vs cv clt wbr wi vm cv vn cv cuz cfv wcel vm
      cv cF cfv vu cv wcel wi vm cv cn wcel vn cv vm cv cle wbr vm cv cF cfv cY
      cM co vs cv clt wbr wi wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX
      wcel wa vu cv cX wss wa cY vs cv cM cbl cfv co vu cv wss vs cv cr wcel
      cc0 vs cv clt wbr wa wa wa vn cv cn wcel wa vm cv cn wcel vn cv vm cv cle
      wbr wa vm cv cF cfv cY cM co vs cv clt wbr wi vm cv vn cv cuz cfv wcel vm
      cv cF cfv cY cM co vs cv clt wbr wi vm cv vn cv cuz cfv wcel vm cv cF cfv
      vu cv wcel wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv
      cX wss wa cY vs cv cM cbl cfv co vu cv wss vs cv cr wcel cc0 vs cv clt
      wbr wa wa wa vn cv cn wcel wa vm cv vn cv cuz cfv wcel vm cv cn wcel vn
      cv vm cv cle wbr wa vm cv cF cfv cY cM co vs cv clt wbr vn cv cn wcel vm
      cv vn cv cuz cfv wcel vm cv cn wcel vn cv vm cv cle wbr wa wi cM cme wcel
      cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa cY vs cv cM cbl
      cfv co vu cv wss vs cv cr wcel cc0 vs cv clt wbr wa wa wa vn cv cn wcel
      vm cv vn cv cuz cfv wcel vm cv cn wcel vn cv vm cv cle wbr vn cv cn wcel
      vn cv cuz cfv cn vm cv vn cv cn wcel vn cv cuz cfv c1 cuz cfv cn vn cv cn
      wcel vn cv c1 cuz cfv wcel vn cv cuz cfv c1 cuz cfv wss vn cv elnnuz c1
      vn cv uzss sylbi nnuz syl6ssr sseld vm cv vn cv cuz cfv wcel vn cv vm cv
      cle wbr wi vn cv cn wcel vn cv vm cv eluzle a1i jcad adantl imim1d cM cme
      wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa cY vs cv cM
      cbl cfv co vu cv wss vs cv cr wcel cc0 vs cv clt wbr wa wa wa vn cv cn
      wcel wa vm cv vn cv cuz cfv wcel vm cv cF cfv cY cM co vs cv clt wbr vm
      cv cF cfv vu cv wcel vn cv cn wcel vm cv vn cv cuz cfv wcel vm cv cn wcel
      cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vu cv cX wss wa cY
      vs cv cM cbl cfv co vu cv wss vs cv cr wcel cc0 vs cv clt wbr wa wa wa vm
      cv cF cfv cY cM co vs cv clt wbr vm cv cF cfv vu cv wcel wi vn cv cn wcel
      vn cv cuz cfv cn vm cv vn cv cn wcel vn cv cuz cfv c1 cuz cfv cn vn cv cn
      wcel vn cv c1 cuz cfv wcel vn cv cuz cfv c1 cuz cfv wss vn cv elnnuz c1
      vn cv uzss sylbi nnuz syl6ssr sseld cM cme wcel cY cA wcel cn cX cF wf
      w3a cY cX wcel wa cY vs cv cM cbl cfv co vu cv wss vs cv cr wcel cc0 vs
      cv clt wbr wa wa vm cv cn wcel vm cv cF cfv cY cM co vs cv clt wbr vm cv
      cF cfv vu cv wcel wi wi vu cv cX wss cM cme wcel cY cA wcel cn cX cF wf
      w3a cY cX wcel wa vs cv cr wcel cc0 vs cv clt wbr wa cY vs cv cM cbl cfv
      co vu cv wss vm cv cn wcel vm cv cF cfv cY cM co vs cv clt wbr vm cv cF
      cfv vu cv wcel wi wi cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa
      vs cv cr wcel cc0 vs cv clt wbr wa cY vs cv cM cbl cfv co vu cv wss vm cv
      cn wcel vm cv cF cfv cY cM co vs cv clt wbr vm cv cF cfv vu cv wcel wi wi
      cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vs cv cr wcel cc0 vs
      cv clt wbr wa wa cY vs cv cM cbl cfv co vu cv wss wa vm cv cn wcel vm cv
      cF cfv cY cM co vs cv clt wbr vm cv cF cfv vu cv wcel wi cM cme wcel cY
      cA wcel cn cX cF wf w3a cY cX wcel wa vs cv cr wcel cc0 vs cv clt wbr wa
      wa vm cv cn wcel cY vs cv cM cbl cfv co vu cv wss vm cv cF cfv cY cM co
      vs cv clt wbr vm cv cF cfv vu cv wcel wi cM cme wcel cY cA wcel cn cX cF
      wf w3a cY cX wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vm cv cn wcel
      wa cY vs cv cM cbl cfv co vu cv wss wa vm cv cF cfv cY cM co vs cv clt
      wbr vm cv cF cfv vu cv wcel cM cme wcel cY cA wcel cn cX cF wf w3a cY cX
      wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vm cv cn wcel wa vm cv cF
      cfv cY cM co vs cv clt wbr cY vs cv cM cbl cfv co vu cv wss vm cv cF cfv
      vu cv wcel cY vs cv cM cbl cfv co vu cv wss cM cme wcel cY cA wcel cn cX
      cF wf w3a cY cX wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vm cv cn
      wcel wa vm cv cF cfv cY cM co vs cv clt wbr wa vm cv cF cfv vu cv wcel cY
      vs cv cM cbl cfv co vu cv wss vm cv cF cfv cY vs cv cM cbl cfv co wcel vm
      cv cF cfv vu cv wcel cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa
      vs cv cr wcel cc0 vs cv clt wbr wa wa vm cv cn wcel wa vm cv cF cfv cY cM
      co vs cv clt wbr wa cY vs cv cM cbl cfv co vu cv vm cv cF cfv ssel2 cM
      cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vs cv cr wcel cc0 vs cv
      clt wbr wa wa vm cv cF cfv cY cM co vs cv clt wbr vm cv cn wcel vm cv cF
      cfv cY vs cv cM cbl cfv co wcel cM cme wcel cY cA wcel cn cX cF wf w3a cY
      cX wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa vm cv cF cfv cY cM co vs
      cv clt wbr wa vm cv cn wcel vm cv cF cfv cX wcel vm cv cF cfv cY vs cv cM
      cbl cfv co wcel cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vs
      cv cr wcel cc0 vs cv clt wbr wa wa vm cv cn wcel vm cv cF cfv cX wcel vm
      cv cF cfv cY cM co vs cv clt wbr cM cme wcel cY cA wcel cn cX cF wf w3a
      cY cX wcel wa vm cv cn wcel vm cv cF cfv cX wcel vs cv cr wcel cc0 vs cv
      clt wbr wa cM cme wcel cY cA wcel cn cX cF wf w3a vm cv cn wcel vm cv cF
      cfv cX wcel cY cX wcel cn cX cF wf cM cme wcel vm cv cn wcel vm cv cF cfv
      cX wcel cY cA wcel cn cX vm cv cF ffvelrn 3ad2antl3 adantlr adantlr
      adantlr cM cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vs cv cr
      wcel cc0 vs cv clt wbr wa wa vm cv cF cfv cX wcel vm cv cF cfv cY cM co
      vs cv clt wbr vm cv cF cfv cY vs cv cM cbl cfv co wcel cM cme wcel cY cA
      wcel cn cX cF wf w3a cY cX wcel wa vs cv cr wcel cc0 vs cv clt wbr wa wa
      vm cv cF cfv cX wcel wa vm cv cF cfv cY vs cv cM cbl cfv co wcel vm cv cF
      cfv cY cM co vs cv clt wbr cM cme wcel cY cA wcel cn cX cF wf w3a cY cX
      wcel wa vm cv cF cfv cX wcel vs cv cr wcel cc0 vs cv clt wbr wa vm cv cF
      cfv cY vs cv cM cbl cfv co wcel vm cv cF cfv cY cM co vs cv clt wbr wb cM
      cme wcel cY cA wcel cn cX cF wf w3a cY cX wcel wa vm cv cF cfv cX wcel vs
      cv cr wcel cc0 vs cv clt wbr wa vm cv cF cfv cY vs cv cM cbl cfv co wcel
      vm cv cF cfv cY cM co vs cv clt wbr wb cM cme wcel cY cA wcel cn cX cF wf
      w3a cY cX wcel wa vm cv cF cfv cX wcel vs cv cr wcel cc0 vs cv clt wbr wa
      wa vm cv cF cfv cY vs cv cM cbl cfv co wcel vm cv cF cfv cY cM co vs cv
      clt wbr wb cM cme wcel cY cA wcel cY cX wcel vm cv cF cfv cX wcel vs cv
      cr wcel cc0 vs cv clt wbr wa wa vm cv cF cfv cY vs cv cM cbl cfv co wcel
      vm cv cF cfv cY cM co vs cv clt wbr wb wi cn cX cF wf cM cme wcel cY cX
      wcel wa vm cv cF cfv cX wcel vs cv cr wcel cc0 vs cv clt wbr wa vm cv cF
      cfv cY vs cv cM cbl cfv co wcel vm cv cF cfv cY cM co vs cv clt wbr wb cM
      cme wcel cY cX wcel vm cv cF cfv cX wcel vs cv cr wcel cc0 vs cv clt wbr
      wa vm cv cF cfv cY vs cv cM cbl cfv co wcel vm cv cF cfv cY cM co vs cv
      clt wbr wb wi cM cme wcel cY cX wcel vm cv cF cfv cX wcel w3a vs cv cr
      wcel cc0 vs cv clt wbr wa vm cv cF cfv cY vs cv cM cbl cfv co wcel vm cv
      cF cfv cY cM co vs cv clt wbr wb vm cv cF cfv cM cY vs cv cX lmtlm.2
      elbl3 ex 3expa expimpd 3ad2antl1 imp anassrs an1rs biimpar an1rs syldan
      an1rs sylan2 ancoms an1rs ex an1rs ex anasss ancom2s adantlr sylan9r a2d
      syld vm cv cn wcel vn cv vm cv cle wbr vm cv cF cfv cY cM co vs cv clt
      wbr impexp syl5ibr r19.20dv2 r19.22dva expcom com23 ancom2s anassrs
      ancom1s syld expimpd com13 vs cv cr wcel cc0 vr cv clt wbr vn cv vm cv
      cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex wi
      vr cr wral cc0 vs cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vs
      cv clt wbr wi vm cn wral vn cn wrex wi cc0 vr cv clt wbr vn cv vm cv cle
      wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm cn wral vn cn wrex wi cc0
      vs cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vs cv clt wbr wi
      vm cn wral vn cn wrex wi vr vs cv cr vr vs weq cc0 vr cv clt wbr cc0 vs
      cv clt wbr vn cv vm cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vm
      cn wral vn cn wrex vn cv vm cv cle wbr vm cv cF cfv cY cM co vs cv clt
      wbr wi vm cn wral vn cn wrex vr cv vs cv cc0 clt breq2 vr vs weq vn cv vm
      cv cle wbr vm cv cF cfv cY cM co vr cv clt wbr wi vn cv vm cv cle wbr vm
      cv cF cfv cY cM co vs cv clt wbr wi vn vm cn cn vr vs weq vm cv cF cfv cY
      cM co vr cv clt wbr vm cv cF cfv cY cM co vs cv clt wbr vn cv vm cv cle
      wbr vr cv vs cv vm cv cF cfv cY cM co clt breq2 imbi2d rexralbidv imbi12d
      rcla4v imdistani syl5 exp3a com34 r19.23adv expimpd sylbid com23
      r19.21adv impbid pm5.32da bitrd cJ ctop wcel cY cA wcel cn cJ cuni cF wf
      cF cY cJ ctlm cfv wbr cY cJ cuni wcel vm cv cF cfv vu cv wcel vm vn cv
      cuz cfv wral vn cn wrex vu cY csn cJ cnei cfv cfv wral wa wb cM cme wcel
      cY cA wcel cn cX cF wf w3a vu cA vm vn cF cJ cJ cuni cY cJ cuni eqid
      tlmbrf cM cme wcel cY cA wcel cJ ctop wcel cn cX cF wf cM cJ lmtlm.1
      opntop 3ad2ant1 cM cme wcel cY cA wcel cn cX cF wf 3simp2 cM cme wcel cn
      cX cF wf cn cJ cuni cF wf cY cA wcel cM cme wcel cn cX cF wf cn cJ cuni
      cF wf cM cme wcel cX cJ cuni wceq cn cX cF wf cn cJ cuni cF wf wb cM cme
      wcel cJ cuni cX cM cJ cX lmtlm.2 lmtlm.1 uniopn2 eqcomd cX cJ cuni cn cF
      feq3 syl biimpa 3adant2 syl3anc vr cA cM cY vn vm cF c1 cX cn lmtlm.2 1z
      nnuz lmbrf 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Product topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d T x y z w $. $d R x y z w $. $d S x y z w $. $d U x y z w $.
    $d X x y z $. $d Y x y z $. $d F x y z w $. $d G x y z w $.
    $d H w $. $d Z x y z $. $d W x y z w $.
    txcnoprab.1 $e |- T = ( R tX S ) $.
    txcnoprab.2 $e |- X = U. U $.
    txcnoprab.3 $e |- Y = U. W $.
    txcnoprab.4 $e |- Z = ( U tX W ) $.
    txcnoprab.5 $e |- H = { <. <. x , y >. , z >. | ( ( x e. X /\ y e. Y ) /\
                                      z = <. ( x F y ) , ( x G y ) >. ) } $.
    $( A map into the product of two topological spaces is continuous if both
       of its projections are continuous. $)
    txcnoprab $p |- ( ( ( R e. Top /\ S e. Top ) /\ ( U e. Top /\ W e. Top ) /\
              ( F e. ( Z Cn R ) /\ G e. ( Z Cn S ) ) ) -> H e. ( Z Cn T ) ) $=
      cR ctop wcel cS ctop wcel wa cU ctop wcel cW ctop wcel wa cF cZ cR ccn co
      wcel cG cZ cS ccn co wcel wa cH cZ cT ccn co wcel cU ctop wcel cW ctop
      wcel wa cR ctop wcel cS ctop wcel wa cF cZ cR ccn co wcel cG cZ cS ccn co
      wcel wa cH cZ cT ccn co wcel cU ctop wcel cW ctop wcel wa cR ctop wcel cS
      ctop wcel wa cF cZ cR ccn co wcel cG cZ cS ccn co wcel wa wa cH cZ cT ccn
      co wcel cU ctop wcel cW ctop wcel cR ctop wcel cS ctop wcel wa cF cZ cR
      ccn co wcel cG cZ cS ccn co wcel wa wa cH cZ cT ccn co wcel wi cR ctop
      wcel cS ctop wcel wa cF cU ctop wcel cU c0 csn cif cW ctx co cR ccn co
      wcel cG cU ctop wcel cU c0 csn cif cW ctx co cS ccn co wcel wa wa vx cv
      cU ctop wcel cU c0 csn cif cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy
      cv cF co vx cv vy cv cG co cop wceq wa vx vy vz copab2 cU ctop wcel cU c0
      csn cif cW ctx co cT ccn co wcel wi cR ctop wcel cS ctop wcel wa cF cU
      ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co cR ccn co wcel
      cG cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co cS ccn co
      wcel wa wa vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW ctop wcel
      cW c0 csn cif cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop
      wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn
      cif ctx co cT ccn co wcel wi cU cW c0 csn c0 csn cU cU ctop wcel cU c0
      csn cif wceq cR ctop wcel cS ctop wcel wa cF cU cW ctx co cR ccn co wcel
      cG cU cW ctx co cS ccn co wcel wa wa vx cv cU cuni wcel vy cv cW cuni
      wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop wceq wa vx vy vz
      copab2 cU cW ctx co cT ccn co wcel wi cR ctop wcel cS ctop wcel wa cF cU
      ctop wcel cU c0 csn cif cW ctx co cR ccn co wcel cG cU ctop wcel cU c0
      csn cif cW ctx co cS ccn co wcel wa wa vx cv cU ctop wcel cU c0 csn cif
      cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co
      cop wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cW ctx co cT ccn
      co wcel wi cR ctop wcel cS ctop wcel wa cF cZ cR ccn co wcel cG cZ cS ccn
      co wcel wa wa cH cZ cT ccn co wcel wi cU cU ctop wcel cU c0 csn cif wceq
      cR ctop wcel cS ctop wcel wa cF cU cW ctx co cR ccn co wcel cG cU cW ctx
      co cS ccn co wcel wa wa cR ctop wcel cS ctop wcel wa cF cU ctop wcel cU
      c0 csn cif cW ctx co cR ccn co wcel cG cU ctop wcel cU c0 csn cif cW ctx
      co cS ccn co wcel wa wa vx cv cU cuni wcel vy cv cW cuni wcel wa vz cv vx
      cv vy cv cF co vx cv vy cv cG co cop wceq wa vx vy vz copab2 cU cW ctx co
      cT ccn co wcel vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW cuni
      wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop wceq wa vx vy vz
      copab2 cU ctop wcel cU c0 csn cif cW ctx co cT ccn co wcel cU cU ctop
      wcel cU c0 csn cif wceq cF cU cW ctx co cR ccn co wcel cG cU cW ctx co cS
      ccn co wcel wa cF cU ctop wcel cU c0 csn cif cW ctx co cR ccn co wcel cG
      cU ctop wcel cU c0 csn cif cW ctx co cS ccn co wcel wa cR ctop wcel cS
      ctop wcel wa cU cU ctop wcel cU c0 csn cif wceq cF cU cW ctx co cR ccn co
      wcel cF cU ctop wcel cU c0 csn cif cW ctx co cR ccn co wcel cG cU cW ctx
      co cS ccn co wcel cG cU ctop wcel cU c0 csn cif cW ctx co cS ccn co wcel
      cU cU ctop wcel cU c0 csn cif wceq cU cW ctx co cR ccn co cU ctop wcel cU
      c0 csn cif cW ctx co cR ccn co cF cU cU ctop wcel cU c0 csn cif wceq cU
      cW ctx co cU ctop wcel cU c0 csn cif cW ctx co cR ccn cU cU ctop wcel cU
      c0 csn cif cW ctx opreq1 opreq1d eleq2d cU cU ctop wcel cU c0 csn cif
      wceq cU cW ctx co cS ccn co cU ctop wcel cU c0 csn cif cW ctx co cS ccn
      co cG cU cU ctop wcel cU c0 csn cif wceq cU cW ctx co cU ctop wcel cU c0
      csn cif cW ctx co cS ccn cU cU ctop wcel cU c0 csn cif cW ctx opreq1
      opreq1d eleq2d anbi12d anbi2d cU cU ctop wcel cU c0 csn cif wceq vx cv cU
      cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co
      cop wceq wa vx vy vz copab2 vx cv cU ctop wcel cU c0 csn cif cuni wcel vy
      cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop wceq wa
      vx vy vz copab2 cU cW ctx co cT ccn co cU ctop wcel cU c0 csn cif cW ctx
      co cT ccn co cU cU ctop wcel cU c0 csn cif wceq vx cv cU cuni wcel vy cv
      cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop wceq wa vx
      cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW cuni wcel wa vz cv vx cv
      vy cv cF co vx cv vy cv cG co cop wceq wa vx vy vz cU cU ctop wcel cU c0
      csn cif wceq vx cv cU cuni wcel vy cv cW cuni wcel wa vx cv cU ctop wcel
      cU c0 csn cif cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx
      cv vy cv cG co cop wceq cU cU ctop wcel cU c0 csn cif wceq vx cv cU cuni
      wcel vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW cuni wcel cU cU
      ctop wcel cU c0 csn cif wceq cU cuni cU ctop wcel cU c0 csn cif cuni vx
      cv cU cU ctop wcel cU c0 csn cif unieq eleq2d anbi1d anbi1d oprabbidv cU
      cU ctop wcel cU c0 csn cif wceq cU cW ctx co cU ctop wcel cU c0 csn cif
      cW ctx co cT ccn cU cU ctop wcel cU c0 csn cif cW ctx opreq1 opreq1d
      eleq12d imbi12d cR ctop wcel cS ctop wcel wa cF cZ cR ccn co wcel cG cZ
      cS ccn co wcel wa wa cR ctop wcel cS ctop wcel wa cF cU cW ctx co cR ccn
      co wcel cG cU cW ctx co cS ccn co wcel wa wa cH cZ cT ccn co wcel vx cv
      cU cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG
      co cop wceq wa vx vy vz copab2 cU cW ctx co cT ccn co wcel cF cZ cR ccn
      co wcel cG cZ cS ccn co wcel wa cF cU cW ctx co cR ccn co wcel cG cU cW
      ctx co cS ccn co wcel wa cR ctop wcel cS ctop wcel wa cF cZ cR ccn co
      wcel cF cU cW ctx co cR ccn co wcel cG cZ cS ccn co wcel cG cU cW ctx co
      cS ccn co wcel cZ cR ccn co cU cW ctx co cR ccn co cF cZ cU cW ctx co cR
      ccn txcnoprab.4 opreq1i eleq2i cZ cS ccn co cU cW ctx co cS ccn co cG cZ
      cU cW ctx co cS ccn txcnoprab.4 opreq1i eleq2i anbi12i anbi2i cH vx cv cU
      cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co
      cop wceq wa vx vy vz copab2 cZ cT ccn co cU cW ctx co cT ccn co cH vx cv
      cX wcel vy cv cY wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop
      wceq wa vx vy vz copab2 vx cv cU cuni wcel vy cv cW cuni wcel wa vz cv vx
      cv vy cv cF co vx cv vy cv cG co cop wceq wa vx vy vz copab2 txcnoprab.5
      vx cv cX wcel vy cv cY wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co
      cop wceq wa vx cv cU cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF
      co vx cv vy cv cG co cop wceq wa vx vy vz vx cv cX wcel vy cv cY wcel wa
      vx cv cU cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy
      cv cG co cop wceq vx cv cX wcel vx cv cU cuni wcel vy cv cY wcel vy cv cW
      cuni wcel cX cU cuni vx cv txcnoprab.2 eleq2i cY cW cuni vy cv
      txcnoprab.3 eleq2i anbi12i anbi1i oprabbii eqtri cZ cU cW ctx co cT ccn
      txcnoprab.4 opreq1i eleq12i imbi12i syl5bb cW cW ctop wcel cW c0 csn cif
      wceq cR ctop wcel cS ctop wcel wa cF cU ctop wcel cU c0 csn cif cW ctx co
      cR ccn co wcel cG cU ctop wcel cU c0 csn cif cW ctx co cS ccn co wcel wa
      wa cR ctop wcel cS ctop wcel wa cF cU ctop wcel cU c0 csn cif cW ctop
      wcel cW c0 csn cif ctx co cR ccn co wcel cG cU ctop wcel cU c0 csn cif cW
      ctop wcel cW c0 csn cif ctx co cS ccn co wcel wa wa vx cv cU ctop wcel cU
      c0 csn cif cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv
      vy cv cG co cop wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cW ctx
      co cT ccn co wcel vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW
      ctop wcel cW c0 csn cif cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv
      cG co cop wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cW ctop wcel
      cW c0 csn cif ctx co cT ccn co wcel cW cW ctop wcel cW c0 csn cif wceq cF
      cU ctop wcel cU c0 csn cif cW ctx co cR ccn co wcel cG cU ctop wcel cU c0
      csn cif cW ctx co cS ccn co wcel wa cF cU ctop wcel cU c0 csn cif cW ctop
      wcel cW c0 csn cif ctx co cR ccn co wcel cG cU ctop wcel cU c0 csn cif cW
      ctop wcel cW c0 csn cif ctx co cS ccn co wcel wa cR ctop wcel cS ctop
      wcel wa cW cW ctop wcel cW c0 csn cif wceq cF cU ctop wcel cU c0 csn cif
      cW ctx co cR ccn co wcel cF cU ctop wcel cU c0 csn cif cW ctop wcel cW c0
      csn cif ctx co cR ccn co wcel cG cU ctop wcel cU c0 csn cif cW ctx co cS
      ccn co wcel cG cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx
      co cS ccn co wcel cW cW ctop wcel cW c0 csn cif wceq cU ctop wcel cU c0
      csn cif cW ctx co cR ccn co cU ctop wcel cU c0 csn cif cW ctop wcel cW c0
      csn cif ctx co cR ccn co cF cW cW ctop wcel cW c0 csn cif wceq cU ctop
      wcel cU c0 csn cif cW ctx co cU ctop wcel cU c0 csn cif cW ctop wcel cW
      c0 csn cif ctx co cR ccn cW cW ctop wcel cW c0 csn cif cU ctop wcel cU c0
      csn cif ctx opreq2 opreq1d eleq2d cW cW ctop wcel cW c0 csn cif wceq cU
      ctop wcel cU c0 csn cif cW ctx co cS ccn co cU ctop wcel cU c0 csn cif cW
      ctop wcel cW c0 csn cif ctx co cS ccn co cG cW cW ctop wcel cW c0 csn cif
      wceq cU ctop wcel cU c0 csn cif cW ctx co cU ctop wcel cU c0 csn cif cW
      ctop wcel cW c0 csn cif ctx co cS ccn cW cW ctop wcel cW c0 csn cif cU
      ctop wcel cU c0 csn cif ctx opreq2 opreq1d eleq2d anbi12d anbi2d cW cW
      ctop wcel cW c0 csn cif wceq vx cv cU ctop wcel cU c0 csn cif cuni wcel
      vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop wceq
      wa vx vy vz copab2 vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW
      ctop wcel cW c0 csn cif cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv
      cG co cop wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cW ctx co cT
      ccn co cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co cT
      ccn co cW cW ctop wcel cW c0 csn cif wceq vx cv cU ctop wcel cU c0 csn
      cif cuni wcel vy cv cW cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv
      cG co cop wceq wa vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW
      ctop wcel cW c0 csn cif cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv
      cG co cop wceq wa vx vy vz cW cW ctop wcel cW c0 csn cif wceq vx cv cU
      ctop wcel cU c0 csn cif cuni wcel vy cv cW cuni wcel wa vx cv cU ctop
      wcel cU c0 csn cif cuni wcel vy cv cW ctop wcel cW c0 csn cif cuni wcel
      wa vz cv vx cv vy cv cF co vx cv vy cv cG co cop wceq cW cW ctop wcel cW
      c0 csn cif wceq vy cv cW cuni wcel vy cv cW ctop wcel cW c0 csn cif cuni
      wcel vx cv cU ctop wcel cU c0 csn cif cuni wcel cW cW ctop wcel cW c0 csn
      cif wceq cW cuni cW ctop wcel cW c0 csn cif cuni vy cv cW cW ctop wcel cW
      c0 csn cif unieq eleq2d anbi2d anbi1d oprabbidv cW cW ctop wcel cW c0 csn
      cif wceq cU ctop wcel cU c0 csn cif cW ctx co cU ctop wcel cU c0 csn cif
      cW ctop wcel cW c0 csn cif ctx co cT ccn cW cW ctop wcel cW c0 csn cif cU
      ctop wcel cU c0 csn cif ctx opreq2 opreq1d eleq12d imbi12d cR ctop wcel
      cS ctop wcel cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co
      ctop wcel cF cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co
      cR ccn co wcel cG cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif
      ctx co cS ccn co wcel wa vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv
      cW ctop wcel cW c0 csn cif cuni wcel wa vz cv vx cv vy cv cF co vx cv vy
      cv cG co cop wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cW ctop
      wcel cW c0 csn cif ctx co cT ccn co wcel cU ctop wcel cU c0 csn cif ctop
      wcel cW ctop wcel cW c0 csn cif ctop wcel cU ctop wcel cU c0 csn cif cW
      ctop wcel cW c0 csn cif ctx co ctop wcel cU c0 csn ctop sn0top elimel cW
      c0 csn ctop sn0top elimel cU ctop wcel cU c0 csn cif cW ctop wcel cW c0
      csn cif cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co cU
      ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co eqid txtop
      mp2an vw vz cR cS cT cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn
      cif ctx co cF cG vx cv cU ctop wcel cU c0 csn cif cuni wcel vy cv cW ctop
      wcel cW c0 csn cif cuni wcel wa vz cv vx cv vy cv cF co vx cv vy cv cG co
      cop wceq wa vx vy vz copab2 cU ctop wcel cU c0 csn cif cuni cW ctop wcel
      cW c0 csn cif cuni cxp txcnoprab.1 cU ctop wcel cU c0 csn cif cW ctop
      wcel cW c0 csn cif ctx co cuni cU ctop wcel cU c0 csn cif cuni cW ctop
      wcel cW c0 csn cif cuni cxp cU ctop wcel cU c0 csn cif ctop wcel cW ctop
      wcel cW c0 csn cif ctop wcel cU ctop wcel cU c0 csn cif cW ctop wcel cW
      c0 csn cif ctx co cuni cU ctop wcel cU c0 csn cif cuni cW ctop wcel cW c0
      csn cif cuni cxp wceq cU c0 csn ctop sn0top elimel cW c0 csn ctop sn0top
      elimel cU ctop wcel cU c0 csn cif cW ctop wcel cW c0 csn cif cU ctop wcel
      cU c0 csn cif cW ctop wcel cW c0 csn cif ctx co cU ctop wcel cU c0 csn
      cif cuni cW ctop wcel cW c0 csn cif cuni cU ctop wcel cU c0 csn cif cW
      ctop wcel cW c0 csn cif ctx co eqid cU ctop wcel cU c0 csn cif cuni eqid
      cW ctop wcel cW c0 csn cif cuni eqid txuni mp2an eqcomi vx vy vz vw cU
      ctop wcel cU c0 csn cif cuni cW ctop wcel cW c0 csn cif cuni vx cv vy cv
      cF co vx cv vy cv cG co cop vw cv cF cfv vw cv cG cfv cop vx cv vy cv cop
      vw cv wceq vx cv vy cv cop cF cfv vx cv vy cv cop cG cfv cop vw cv cF cfv
      vw cv cG cfv cop vx cv vy cv cF co vx cv vy cv cG co cop vx cv vy cv cop
      vw cv wceq vx cv vy cv cop cF cfv vw cv cF cfv vx cv vy cv cop cG cfv vw
      cv cG cfv vx cv vy cv cop vw cv cF fveq2 vx cv vy cv cop vw cv cG fveq2
      opeq12d vx cv vy cv cF co vx cv vy cv cop cF cfv vx cv vy cv cG co vx cv
      vy cv cop cG cfv vx cv vy cv cF df-opr vx cv vy cv cG df-opr opeq12i
      syl5eq dfoprab4s txcnopab mp3anl3 dedth2h imp an1s 3impb $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d R q r s t u v w x y z $. $d S q r s t u v w x y z $.
    $d X q r s t u v w x y z $. $d Y q r s t u v w x y z $.
    $d A q r s t u v w x y z $. $d B q r s t u v w x y z $.
    txsubsp.1 $e |- X = U. R $.
    txsubsp.2 $e |- Y = U. S $.
    $( The subspace of a topological product space induced by a subset with
       a Cartesian product representation is a topological product of the
       subspaces induced by the subspaces of the terms of the products. $)
    txsubsp $p |- ( ( ( R e. Top /\ S e. Top ) /\ ( A C_ X /\ B C_ Y ) ) ->
                      ( subSp ` <. ( A X. B ) , ( R tX S ) >. ) =
                    ( ( subSp ` <. A , R >. ) tX ( subSp ` <. B , S >. ) ) ) $=
      cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vx cA cB cxp cR cS
      ctx co cop csubsp cfv cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co cR
      ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vx cv cA cB cxp cR cS
      ctx co cop csubsp cfv wcel vx cv cA cR cop csubsp cfv cB cS cop csubsp
      cfv ctx co wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vx
      cv vy cv cA cB cxp cin wceq vy cR cS ctx co wrex vx cv vw cv vr cv vs cv
      cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab
      ctg cfv wcel vx cv cA cB cxp cR cS ctx co cop csubsp cfv wcel vx cv cA cR
      cop csubsp cfv cB cS cop csubsp cfv ctx co wcel cR ctop wcel cS ctop wcel
      wa cA cX wss cB cY wss wa wa vx cv vy cv cA cB cxp cin wceq vx cv vw cv
      vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab ctg cfv wcel vy cR cS ctx co cR ctop wcel cS ctop wcel wa cA
      cX wss cB cY wss wa wa vy cv cR cS ctx co wcel vy cv cA cB cxp cin vw cv
      vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab ctg cfv wcel vx cv vy cv cA cB cxp cin wceq vx cv vw cv vr cv
      vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex
      vw cab ctg cfv wcel wi cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss
      wa wa vy cv cR cS ctx co wcel vt cv vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz cab wss vy cv vt cv cuni wceq wa vt wex vy cv cA cB cxp cin
      vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop
      csubsp cfv wrex vw cab ctg cfv wcel cR ctop wcel cS ctop wcel wa vy cv cR
      cS ctx co wcel vt cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab wss vy cv vt cv cuni wceq wa vt wex wb cA cX wss cB cY wss wa cR ctop
      wcel cS ctop wcel wa vy cv cR cS ctx co wcel vy cv vz cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vz cab ctg cfv wcel vt cv vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab wss vy cv vt cv cuni wceq wa vt wex
      cR ctop wcel cS ctop wcel wa cR cS ctx co vz cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vz cab ctg cfv vy cv vz vv vu cR cS txval eleq2d cR
      ctop wcel cS ctop wcel wa vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab ctb wcel vy cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab ctg cfv wcel vt cv vz cv vu cv vv cv cxp wceq vv cS wrex vu
      cR wrex vz cab wss vy cv vt cv cuni wceq wa vt wex wb vz vv vu cR cS
      txbas vt vy cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      eltg3 syl bitrd adantr cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss
      wa wa vt cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss
      vy cv vt cv cuni wceq wa vy cv cA cB cxp cin vw cv vr cv vs cv cxp wceq
      vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv
      wcel vt cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss vy cv vt cv cuni
      wceq vy cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp
      cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv wcel vy cv vt cv
      cuni wceq vy cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB cS cop
      csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv wcel vq cv vx
      cv cA cB cxp cin wceq vx vt cv wrex vq cab cuni vw cv vr cv vs cv cxp
      wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg
      cfv wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss wa vy cv vt cv
      cuni wceq vy cv cA cB cxp cin vq cv vx cv cA cB cxp cin wceq vx vt cv
      wrex vq cab cuni vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex
      vr cA cR cop csubsp cfv wrex vw cab ctg cfv vy cv vt cv cuni wceq vy cv
      cA cB cxp cin vt cv cuni cA cB cxp cin vq cv vx cv cA cB cxp cin wceq vx
      vt cv wrex vq cab cuni vy cv vt cv cuni cA cB cxp ineq1 vq vx vt cv cA cB
      cxp ntunte syl6eq eleq1d vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp
      cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv ctop wcel vq cv vx
      cv cA cB cxp cin wceq vx vt cv wrex vq cab vw cv vr cv vs cv cxp wceq vs
      cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv wss
      vq cv vx cv cA cB cxp cin wceq vx vt cv wrex vq cab cuni vw cv vr cv vs
      cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw
      cab ctg cfv wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa
      vt cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss wa vq
      cv vx cv cA cB cxp cin wceq vx vt cv wrex vq cab vw cv vr cv vs cv cxp
      wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg
      cfv uniopn cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vw cv
      vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab ctg cfv ctop wcel vt cv vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz cab wss cR ctop wcel cA cX wss cS ctop wcel cB cY wss vw cv
      vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab ctg cfv ctop wcel cR ctop wcel cA cX wss wa cS ctop wcel cB
      cY wss wa wa vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr
      cA cR cop csubsp cfv wrex vw cab ctb wcel vw cv vr cv vs cv cxp wceq vs
      cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv
      ctop wcel cA cR cop csubsp cfv ctop wcel cB cS cop csubsp cfv ctop wcel
      vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop
      csubsp cfv wrex vw cab ctb wcel cR ctop wcel cA cX wss wa cS ctop wcel cB
      cY wss wa vw vs vr cA cR cop csubsp cfv cB cS cop csubsp cfv txbas cR
      ctop wcel cA cR cuni wss cA cR cop csubsp cfv ctop wcel cA cX wss cA cR
      stoig3 cX cR cuni cA txsubsp.1 sseq2i sylan2b cS ctop wcel cB cS cuni wss
      cB cS cop csubsp cfv ctop wcel cB cY wss cB cS stoig3 cY cS cuni cB
      txsubsp.2 sseq2i sylan2b syl2an vw cv vr cv vs cv cxp wceq vs cB cS cop
      csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab tgcl syl an4s adantr
      cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss wa vq cv vx cv cA cB cxp
      cin wceq vx vt cv wrex vq vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp
      cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv cR ctop wcel cS ctop
      wcel wa cA cX wss cB cY wss wa wa vt cv vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab wss wa vq cv vx cv cA cB cxp cin wceq vq cv vw cv
      vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab ctg cfv wcel vx vt cv vq cv vx cv cA cB cxp cin wceq vq cv vw
      cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp
      cfv wrex vw cab ctg cfv wcel vx cv cA cB cxp cin vw cv vr cv vs cv cxp
      wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg
      cfv wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss wa vx cv vt cv
      wcel wa vq cv vx cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB cS cop
      csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv eleq1 cR ctop
      wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab wss wa vx cv vt cv wcel wa vw cv vr
      cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA
      cR cop csubsp cfv wrex vw cab ctg cfv vx cv cA cB cxp cin cR ctop wcel cS
      ctop wcel wa cA cX wss cB cY wss wa wa vw cv vr cv vs cv cxp wceq vs cB
      cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab vw cv vr cv vs
      cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw
      cab ctg cfv wss vt cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab wss vx cv vt cv wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss
      wa wa vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR
      cop csubsp cfv wrex vw cab ctb wcel vw cv vr cv vs cv cxp wceq vs cB cS
      cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab vw cv vr cv vs cv
      cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab
      ctg cfv wss cR ctop wcel cA cX wss cS ctop wcel cB cY wss vw cv vr cv vs
      cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw
      cab ctb wcel cA cR cop csubsp cfv ctop wcel cB cS cop csubsp cfv ctop
      wcel vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop
      csubsp cfv wrex vw cab ctb wcel cR ctop wcel cA cX wss wa cS ctop wcel cB
      cY wss wa vw vs vr cA cR cop csubsp cfv cB cS cop csubsp cfv txbas cR
      ctop wcel cA cR cuni wss cA cR cop csubsp cfv ctop wcel cA cX wss cA cR
      stoig3 cX cR cuni cA txsubsp.1 sseq2i sylan2b cS ctop wcel cB cS cuni wss
      cB cS cop csubsp cfv ctop wcel cB cY wss cB cS stoig3 cY cS cuni cB
      txsubsp.2 sseq2i sylan2b syl2an an4s vw cv vr cv vs cv cxp wceq vs cB cS
      cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab bastg syl
      ad2antrr cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss vx cv vt cv wcel
      vx cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv
      wrex vr cA cR cop csubsp cfv wrex vw cab wcel cR ctop wcel cS ctop wcel
      wa cA cX wss cB cY wss wa wa vx cv vz cv vu cv vv cv cxp wceq vv cS wrex
      vu cR wrex vz cab wcel vx cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs
      cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab wcel vt cv
      vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wss vx cv vt cv
      wcel wa cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vx cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv cA cB cxp cin vw cv vr cv
      vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex
      vw cab wcel vx cv vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vx cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vx cv cA cB cxp cin vw cv vr cv vs
      cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw
      cab wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vx cv vu
      cv vv cv cxp wceq vx cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB cS
      cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab wcel vu vv cR cS
      cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vu cv cR wcel vv
      cv cS wcel wa vu cv vv cv cxp cA cB cxp cin vw cv vr cv vs cv cxp wceq vs
      cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab wcel vx cv
      vu cv vv cv cxp wceq vx cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB
      cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab wcel wi cR
      ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vu cv cR wcel vv cv
      cS wcel wa vu cv vv cv cxp cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB
      cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab wcel cR ctop
      wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vu cv cR wcel vv cv cS
      wcel wa wa vu cv vv cv cxp cA cB cxp cin vr cv vs cv cxp wceq vs cB cS
      cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vu cv vv cv cxp cA cB
      cxp cin vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR
      cop csubsp cfv wrex vw cab wcel vu cv cA cin cA cR cop csubsp cfv wcel vv
      cv cB cin cB cS cop csubsp cfv wcel vu cv vv cv cxp cA cB cxp cin vu cv
      cA cin vv cv cB cin cxp wceq vu cv vv cv cxp cA cB cxp cin vr cv vs cv
      cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex cR
      ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vu cv cR wcel vv cv
      cS wcel wa wa vu cv vv cv cxp cA cB cxp cin vr cv vs cv cxp wceq vu cv vv
      cv cxp cA cB cxp cin vu cv cA cin vv cv cB cin cxp wceq vu cv vv cv cxp
      cA cB cxp cin vu cv cA cin vs cv cxp wceq vr vs vu cv cA cin vv cv cB cin
      cA cR cop csubsp cfv cB cS cop csubsp cfv vr cv vu cv cA cin wceq vr cv
      vs cv cxp vu cv cA cin vs cv cxp vu cv vv cv cxp cA cB cxp cin vr cv vu
      cv cA cin vs cv xpeq1 eqeq2d vs cv vv cv cB cin wceq vu cv cA cin vs cv
      cxp vu cv cA cin vv cv cB cin cxp vu cv vv cv cxp cA cB cxp cin vs cv vv
      cv cB cin vu cv cA cin xpeq2 eqeq2d rcla42ev cR ctop wcel cS ctop wcel wa
      cA cX wss cB cY wss wa wa vu cv cR wcel vv cv cS wcel wa wa vu cv cA cin
      cA cR cop csubsp cfv wcel vu cv cA cin vx cv cA cin wceq vx cR wrex vu cv
      cR wcel vu cv cA cin vx cv cA cin wceq vx cR wrex cR ctop wcel cS ctop
      wcel wa cA cX wss cB cY wss wa wa vv cv cS wcel vu cv cR wcel vu cv cA
      cin vu cv cA cin wceq vu cv cA cin vx cv cA cin wceq vx cR wrex vu cv cA
      cin eqid vu cv cA cin vx cv cA cin wceq vu cv cA cin vu cv cA cin wceq vx
      vu cv cR vx cv vu cv wceq vx cv cA cin vu cv cA cin vu cv cA cin vx cv vu
      cv cA ineq1 eqeq2d rcla4ev mpan2 ad2antrl cR ctop wcel vu cv cA cin cvv
      wcel cA cvv wcel vu cv cA cin cA cR cop csubsp cfv wcel vu cv cA cin vx
      cv cA cin wceq vx cR wrex wb cR ctop wcel cS ctop wcel wa cA cX wss cB cY
      wss wa wa vu cv cR wcel vv cv cS wcel wa wa vx vu cv cA cin cA cvv cR
      issubspt cR ctop wcel cS ctop wcel cA cX wss cB cY wss wa vu cv cR wcel
      vv cv cS wcel wa simplll vu cv cA cin cvv wcel cR ctop wcel cS ctop wcel
      wa cA cX wss cB cY wss wa wa vu cv cR wcel vv cv cS wcel wa wa vu cv cA
      vu visset inex1 a1i cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa
      wa cA cvv wcel vu cv cR wcel vv cv cS wcel wa cR ctop wcel cA cX wss cA
      cvv wcel cS ctop wcel cB cY wss cA cX wss cR ctop wcel cA cvv wcel cA cX
      wss cX cvv wcel cA cvv wcel cR ctop wcel cA cX cvv ssexg cR ctop wcel cR
      cuni cvv cX cR ctop uniexg txsubsp.1 syl5eqel sylan2 ancoms ad2ant2r
      adantr syl3anc mpbird cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa
      wa vu cv cR wcel vv cv cS wcel wa wa vv cv cB cin cB cS cop csubsp cfv
      wcel vv cv cB cin vx cv cB cin wceq vx cS wrex vv cv cS wcel vv cv cB cin
      vx cv cB cin wceq vx cS wrex cR ctop wcel cS ctop wcel wa cA cX wss cB cY
      wss wa wa vu cv cR wcel vv cv cS wcel vv cv cB cin vv cv cB cin wceq vv
      cv cB cin vx cv cB cin wceq vx cS wrex vv cv cB cin eqid vv cv cB cin vx
      cv cB cin wceq vv cv cB cin vv cv cB cin wceq vx vv cv cS vx cv vv cv
      wceq vx cv cB cin vv cv cB cin vv cv cB cin vx cv vv cv cB ineq1 eqeq2d
      rcla4ev mpan2 ad2antll cS ctop wcel vv cv cB cin cvv wcel cB cvv wcel vv
      cv cB cin cB cS cop csubsp cfv wcel vv cv cB cin vx cv cB cin wceq vx cS
      wrex wb cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vu cv cR
      wcel vv cv cS wcel wa wa vx vv cv cB cin cB cvv cS issubspt cR ctop wcel
      cS ctop wcel cA cX wss cB cY wss wa vu cv cR wcel vv cv cS wcel wa
      simpllr vv cv cS wcel vv cv cB cin cvv wcel cR ctop wcel cS ctop wcel wa
      cA cX wss cB cY wss wa wa vu cv cR wcel vv cv cB cS inex1g ad2antll cR
      ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa cB cvv wcel vu cv cR
      wcel vv cv cS wcel wa cS ctop wcel cB cY wss cB cvv wcel cR ctop wcel cA
      cX wss cB cY wss cS ctop wcel cB cvv wcel cB cY wss cY cvv wcel cB cvv
      wcel cS ctop wcel cB cY cvv ssexg cS ctop wcel cS cuni cvv cY cS ctop
      uniexg txsubsp.2 syl5eqel sylan2 ancoms ad2ant2l adantr syl3anc mpbird vu
      cv vv cv cxp cA cB cxp cin vu cv cA cin vv cv cB cin cxp wceq cR ctop
      wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vu cv cR wcel vv cv cS
      wcel wa wa vu cv vv cv cA cB inxp a1i syl3anc vw cv vr cv vs cv cxp wceq
      vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vu cv vv cv cxp
      cA cB cxp cin vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR
      cop csubsp cfv wrex vw vu cv vv cv cxp cA cB cxp cin vu cv vv cv cxp cA
      cB cxp vu cv vv cv vu visset vv visset xpex inex1 vw cv vu cv vv cv cxp
      cA cB cxp cin wceq vw cv vr cv vs cv cxp wceq vu cv vv cv cxp cA cB cxp
      cin vr cv vs cv cxp wceq vr vs cA cR cop csubsp cfv cB cS cop csubsp cfv
      vw cv vu cv vv cv cxp cA cB cxp cin vr cv vs cv cxp eqeq1 2rexbidv elab
      sylibr ex vx cv vu cv vv cv cxp wceq vx cv cA cB cxp cin vw cv vr cv vs
      cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw
      cab wcel vu cv vv cv cxp cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB
      cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab wcel vx cv vu
      cv vv cv cxp wceq vx cv cA cB cxp cin vu cv vv cv cxp cA cB cxp cin vw cv
      vr cv vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv
      wrex vw cab vx cv vu cv vv cv cxp cA cB cxp ineq1 eleq1d biimprcd syl6
      r19.23advv imp vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vx cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vz vx cv vx visset vz cv vx cv
      wceq vz cv vu cv vv cv cxp wceq vx cv vu cv vv cv cxp wceq vu vv cR cS vz
      cv vx cv vu cv vv cv cxp eqeq1 2rexbidv elab sylan2b vt cv vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab vx cv ssel2 sylan2 anassrs
      sseldd syl5cbir r19.23adva abssdv sylanc syl5cbir expimpd 19.23adv sylbid
      vy cv cA cB cxp cin vw cv vr cv vs cv cxp wceq vs cB cS cop csubsp cfv
      wrex vr cA cR cop csubsp cfv wrex vw cab ctg cfv vx cv eleq1a syl6
      r19.23adv cR cS ctx co ctop wcel vx cv cvv wcel cA cB cxp cvv wcel vx cv
      cA cB cxp cR cS ctx co cop csubsp cfv wcel vx cv vy cv cA cB cxp cin wceq
      vy cR cS ctx co wrex wb cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss
      wa wa vy vx cv cA cB cxp cvv cR cS ctx co issubspt cR ctop wcel cS ctop
      wcel wa cR cS ctx co ctop wcel cA cX wss cB cY wss wa cR cS cR cS ctx co
      cR cS ctx co eqid txtop adantr vx cv cvv wcel cR ctop wcel cS ctop wcel
      wa cA cX wss cB cY wss wa wa vx visset a1i cR ctop wcel cA cX wss cS ctop
      wcel cB cY wss cA cB cxp cvv wcel cA cvv wcel cB cvv wcel cA cB cxp cvv
      wcel cR ctop wcel cA cX wss wa cS ctop wcel cB cY wss wa cA cB cvv cvv
      xpexg cA cX wss cR ctop wcel cA cvv wcel cA cX wss cX cvv wcel cA cvv
      wcel cR ctop wcel cA cX cvv ssexg cR ctop wcel cR cuni cvv cX cR ctop
      uniexg txsubsp.1 syl5eqel sylan2 ancoms cB cY wss cS ctop wcel cB cvv
      wcel cB cY wss cY cvv wcel cB cvv wcel cS ctop wcel cB cY cvv ssexg cS
      ctop wcel cS cuni cvv cY cS ctop uniexg txsubsp.2 syl5eqel sylan2 ancoms
      syl2an an4s syl3anc cR ctop wcel cA cX wss cS ctop wcel cB cY wss vx cv
      cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co wcel vx cv vw cv vr cv
      vs cv cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex
      vw cab ctg cfv wcel wb cR ctop wcel cA cX wss wa cS ctop wcel cB cY wss
      wa wa cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co vw cv vr cv vs cv
      cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab
      ctg cfv vx cv cA cR cop csubsp cfv ctop wcel cB cS cop csubsp cfv ctop
      wcel cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co vw cv vr cv vs cv
      cxp wceq vs cB cS cop csubsp cfv wrex vr cA cR cop csubsp cfv wrex vw cab
      ctg cfv wceq cR ctop wcel cA cX wss wa cS ctop wcel cB cY wss wa vw vs vr
      cA cR cop csubsp cfv cB cS cop csubsp cfv txval cR ctop wcel cA cR cuni
      wss cA cR cop csubsp cfv ctop wcel cA cX wss cA cR stoig3 cX cR cuni cA
      txsubsp.1 sseq2i sylan2b cS ctop wcel cB cS cuni wss cB cS cop csubsp cfv
      ctop wcel cB cY wss cB cS stoig3 cY cS cuni cB txsubsp.2 sseq2i sylan2b
      syl2an eleq2d an4s 3imtr4d cR ctop wcel cS ctop wcel wa cA cX wss cB cY
      wss wa wa vx cv cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co wcel vt
      cv vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop
      csubsp cfv wrex vz cab wss vx cv vt cv cuni wceq wa vt wex vx cv cA cB
      cxp cR cS ctx co cop csubsp cfv wcel cR ctop wcel cA cX wss cS ctop wcel
      cB cY wss vx cv cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co wcel vt
      cv vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop
      csubsp cfv wrex vz cab wss vx cv vt cv cuni wceq wa vt wex wb cA cR cop
      csubsp cfv ctop wcel cB cS cop csubsp cfv ctop wcel vx cv cA cR cop
      csubsp cfv cB cS cop csubsp cfv ctx co wcel vt cv vz cv vu cv vv cv cxp
      wceq vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cab wss
      vx cv vt cv cuni wceq wa vt wex wb cR ctop wcel cA cX wss wa cS ctop wcel
      cB cY wss wa cA cR cop csubsp cfv ctop wcel cB cS cop csubsp cfv ctop
      wcel wa vx cv cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co wcel vx cv
      vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop
      csubsp cfv wrex vz cab ctg cfv wcel vt cv vz cv vu cv vv cv cxp wceq vv
      cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cab wss vx cv
      vt cv cuni wceq wa vt wex cA cR cop csubsp cfv ctop wcel cB cS cop csubsp
      cfv ctop wcel wa cA cR cop csubsp cfv cB cS cop csubsp cfv ctx co vz cv
      vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv
      wrex vz cab ctg cfv vx cv vz vv vu cA cR cop csubsp cfv cB cS cop csubsp
      cfv txval eleq2d cA cR cop csubsp cfv ctop wcel cB cS cop csubsp cfv ctop
      wcel wa vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR
      cop csubsp cfv wrex vz cab ctb wcel vx cv vz cv vu cv vv cv cxp wceq vv
      cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cab ctg cfv
      wcel vt cv vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA
      cR cop csubsp cfv wrex vz cab wss vx cv vt cv cuni wceq wa vt wex wb vz
      vv vu cA cR cop csubsp cfv cB cS cop csubsp cfv txbas vt vx cv vz cv vu
      cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv
      wrex vz cab eltg3 syl bitrd cR ctop wcel cA cR cuni wss cA cR cop csubsp
      cfv ctop wcel cA cX wss cA cR stoig3 cX cR cuni cA txsubsp.1 sseq2i
      sylan2b cS ctop wcel cB cS cuni wss cB cS cop csubsp cfv ctop wcel cB cY
      wss cB cS stoig3 cY cS cuni cB txsubsp.2 sseq2i sylan2b syl2an an4s cR
      ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz cv vu cv vv
      cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz
      cab wss vx cv vt cv cuni wceq wa vx cv cA cB cxp cR cS ctx co cop csubsp
      cfv wcel vt cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv
      vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop
      csubsp cfv wrex vz cab wss vx cv vt cv cuni wceq vx cv cA cB cxp cR cS
      ctx co cop csubsp cfv wcel vx cv vt cv cuni wceq vx cv cA cB cxp cR cS
      ctx co cop csubsp cfv wcel vt cv cuni cA cB cxp cR cS ctx co cop csubsp
      cfv wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv vz
      cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp
      cfv wrex vz cab wss wa vx cv vt cv cuni cA cB cxp cR cS ctx co cop csubsp
      cfv eleq1 cA cB cxp cR cS ctx co cop csubsp cfv ctop wcel vt cv cA cB cxp
      cR cS ctx co cop csubsp cfv wss vt cv cuni cA cB cxp cR cS ctx co cop
      csubsp cfv wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt
      cv vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop
      csubsp cfv wrex vz cab wss wa vt cv cA cB cxp cR cS ctx co cop csubsp cfv
      uniopn cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa cA cB cxp
      cR cS ctx co cop csubsp cfv ctop wcel vt cv vz cv vu cv vv cv cxp wceq vv
      cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cab wss cR cS
      ctx co ctop wcel cA cB cxp cR cS ctx co cuni wss cA cB cxp cR cS ctx co
      cop csubsp cfv ctop wcel cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss
      wa wa cA cB cxp cR cS ctx co stoig3 cR ctop wcel cS ctop wcel wa cR cS
      ctx co ctop wcel cA cX wss cB cY wss wa cR cS cR cS ctx co cR cS ctx co
      eqid txtop adantr cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa
      cA cB cxp cX cY cxp cR cS ctx co cuni cA cX wss cB cY wss wa cA cB cxp cX
      cY cxp wss cR ctop wcel cS ctop wcel wa cA cX cB cY ssxp adantl cR ctop
      wcel cS ctop wcel wa cR cS ctx co cuni cX cY cxp wceq cA cX wss cB cY wss
      wa cR cS cR cS ctx co cX cY cR cS ctx co eqid txsubsp.1 txsubsp.2 txuni
      adantr sseqtr4d sylanc adantr vt cv vz cv vu cv vv cv cxp wceq vv cB cS
      cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cab wss cR ctop wcel
      cS ctop wcel wa cA cX wss cB cY wss wa wa vt cv cA cB cxp cR cS ctx co
      cop csubsp cfv wss vt cv vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp
      cfv wrex vu cA cR cop csubsp cfv wrex vz cab wss vz cv vu cv vv cv cxp
      wceq vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cab cA
      cB cxp cR cS ctx co cop csubsp cfv wss vt cv cA cB cxp cR cS ctx co cop
      csubsp cfv wss cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vt
      cv vz cv vu cv vv cv cxp wceq vv cB cS cop csubsp cfv wrex vu cA cR cop
      csubsp cfv wrex vz cab cA cB cxp cR cS ctx co cop csubsp cfv sstr cR ctop
      wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vz cv vu cv vv cv cxp wceq
      vv cB cS cop csubsp cfv wrex vu cA cR cop csubsp cfv wrex vz cA cB cxp cR
      cS ctx co cop csubsp cfv cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss
      wa wa vz cv vu cv vv cv cxp wceq vz cv cA cB cxp cR cS ctx co cop csubsp
      cfv wcel vu vv cA cR cop csubsp cfv cB cS cop csubsp cfv cR ctop wcel cS
      ctop wcel wa cA cX wss cB cY wss wa wa vu cv cA cR cop csubsp cfv wcel vv
      cv cB cS cop csubsp cfv wcel wa vu cv vv cv cxp cA cB cxp cR cS ctx co
      cop csubsp cfv wcel vz cv vu cv vv cv cxp wceq vz cv cA cB cxp cR cS ctx
      co cop csubsp cfv wcel wi cR ctop wcel cS ctop wcel wa cA cX wss cB cY
      wss wa wa vu cv vr cv cA cin wceq vr cR wrex vv cv vs cv cB cin wceq vs
      cS wrex wa vu cv vv cv cxp vy cv cA cB cxp cin wceq vy cR cS ctx co wrex
      vu cv cA cR cop csubsp cfv wcel vv cv cB cS cop csubsp cfv wcel wa vu cv
      vv cv cxp cA cB cxp cR cS ctx co cop csubsp cfv wcel cR ctop wcel cS ctop
      wcel wa cA cX wss cB cY wss wa wa vu cv vr cv cA cin wceq vv cv vs cv cB
      cin wceq wa vs cS wrex vr cR wrex vu cv vv cv cxp vy cv cA cB cxp cin
      wceq vy cR cS ctx co wrex vu cv vr cv cA cin wceq vr cR wrex vv cv vs cv
      cB cin wceq vs cS wrex wa cR ctop wcel cS ctop wcel wa cA cX wss cB cY
      wss wa wa vu cv vr cv cA cin wceq vv cv vs cv cB cin wceq wa vu cv vv cv
      cxp vy cv cA cB cxp cin wceq vy cR cS ctx co wrex vr vs cR cS cR ctop
      wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vr cv cR wcel vs cv cS
      wcel wa vu cv vr cv cA cin wceq vv cv vs cv cB cin wceq wa vu cv vv cv
      cxp vy cv cA cB cxp cin wceq vy cR cS ctx co wrex wi cR ctop wcel cS ctop
      wcel wa cA cX wss cB cY wss wa wa vr cv cR wcel vs cv cS wcel wa wa vu cv
      vr cv cA cin wceq vv cv vs cv cB cin wceq wa vr cv vs cv cxp cR cS ctx co
      wcel vu cv vv cv cxp vr cv vs cv cxp cA cB cxp cin wceq wa vu cv vv cv
      cxp vy cv cA cB cxp cin wceq vy cR cS ctx co wrex cR ctop wcel cS ctop
      wcel wa cA cX wss cB cY wss wa wa vr cv cR wcel vs cv cS wcel wa wa vu cv
      vr cv cA cin wceq vv cv vs cv cB cin wceq wa vu cv vv cv cxp vr cv vs cv
      cxp cA cB cxp cin wceq vr cv vs cv cxp cR cS ctx co wcel vu cv vr cv cA
      cin wceq vv cv vs cv cB cin wceq wa vu cv vv cv cxp vr cv vs cv cxp cA cB
      cxp cin wceq wi cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vr
      cv cR wcel vs cv cS wcel wa wa vu cv vr cv cA cin wceq vv cv vs cv cB cin
      wceq wa vu cv vv cv cxp vr cv cA cin vs cv cB cin cxp vr cv vs cv cxp cA
      cB cxp cin vu cv vr cv cA cin wceq vv cv vs cv cB cin wceq vu cv vv cv
      cxp vr cv cA cin vv cv cxp vr cv cA cin vs cv cB cin cxp vu cv vr cv cA
      cin vv cv xpeq1 vv cv vs cv cB cin vr cv cA cin xpeq2 sylan9eq vr cv vs
      cv cA cB inxp syl6eqr a1i cR ctop wcel cS ctop wcel wa vr cv cR wcel vs
      cv cS wcel wa vr cv vs cv cxp cR cS ctx co wcel cA cX wss cB cY wss wa cR
      ctop wcel cS ctop wcel wa vr cv cR wcel vs cv cS wcel wa wa vr cv vs cv
      cxp vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv cR cS
      ctx co cR ctop wcel cS ctop wcel wa vr cv cR wcel vs cv cS wcel wa wa vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv vr cv vs cv cxp cR ctop
      wcel cS ctop wcel wa vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv wss
      vr cv cR wcel vs cv cS wcel wa cR ctop wcel cS ctop wcel wa vz cv vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctb wcel vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab ctg cfv wss vz vv vu cR cS txbas vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vz cab bastg syl adantr cR ctop wcel cS
      ctop wcel wa vr cv cR wcel vs cv cS wcel wa wa vr cv vs cv cxp vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vr cv vs cv cxp vz cv vu cv vv cv cxp
      wceq vv cS wrex vu cR wrex vz cab wcel vr cv cR wcel vs cv cS wcel vr cv
      vs cv cxp vr cv vs cv cxp wceq vr cv vs cv cxp vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex cR ctop wcel cS ctop wcel wa vr cv cR wcel vs cv cS wcel
      wa wa vr cv vs cv cxp vu cv vv cv cxp wceq vr cv vs cv cxp vr cv vs cv
      cxp wceq vr cv vs cv cxp vr cv vv cv cxp wceq vu vv vr cv vs cv cR cS vu
      cv vr cv wceq vu cv vv cv cxp vr cv vv cv cxp vr cv vs cv cxp vu cv vr cv
      vv cv xpeq1 eqeq2d vv cv vs cv wceq vr cv vv cv cxp vr cv vs cv cxp vr cv
      vs cv cxp vv cv vs cv vr cv xpeq2 eqeq2d rcla42ev cR ctop wcel cS ctop
      wcel wa vr cv cR wcel vs cv cS wcel simprl cR ctop wcel cS ctop wcel wa
      vr cv cR wcel vs cv cS wcel simprr cR ctop wcel cS ctop wcel wa vr cv cR
      wcel vs cv cS wcel wa wa vr cv vs cv cxp eqidd syl3anc vz cv vu cv vv cv
      cxp wceq vv cS wrex vu cR wrex vr cv vs cv cxp vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz vr cv vs cv cxp vr cv vs cv vr visset vs visset xpex
      vz cv vr cv vs cv cxp wceq vz cv vu cv vv cv cxp wceq vr cv vs cv cxp vu
      cv vv cv cxp wceq vu vv cR cS vz cv vr cv vs cv cxp vu cv vv cv cxp eqeq1
      2rexbidv elab sylibr sseldd cR ctop wcel cS ctop wcel wa cR cS ctx co vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv wceq vr cv
      cR wcel vs cv cS wcel wa vz vv vu cR cS txval adantr eleqtrrd adantlr
      jctild vu cv vv cv cxp vy cv cA cB cxp cin wceq vu cv vv cv cxp vr cv vs
      cv cxp cA cB cxp cin wceq vy vr cv vs cv cxp cR cS ctx co vy cv vr cv vs
      cv cxp wceq vy cv cA cB cxp cin vr cv vs cv cxp cA cB cxp cin vu cv vv cv
      cxp vy cv vr cv vs cv cxp cA cB cxp ineq1 eqeq2d rcla4ev syl6 ex
      r19.23advv vu cv vr cv cA cin wceq vv cv vs cv cB cin wceq vr vs cR cS
      reeanv syl5ibr cR ctop wcel cA cX wss cS ctop wcel cB cY wss vu cv cA cR
      cop csubsp cfv wcel vv cv cB cS cop csubsp cfv wcel wa vu cv vr cv cA cin
      wceq vr cR wrex vv cv vs cv cB cin wceq vs cS wrex wa wb cR ctop wcel cA
      cX wss wa vu cv cA cR cop csubsp cfv wcel vu cv vr cv cA cin wceq vr cR
      wrex cS ctop wcel cB cY wss wa vv cv cB cS cop csubsp cfv wcel vv cv vs
      cv cB cin wceq vs cS wrex cR ctop wcel vu cv cvv wcel cA cvv wcel vu cv
      cA cR cop csubsp cfv wcel vu cv vr cv cA cin wceq vr cR wrex wb cR ctop
      wcel cA cX wss wa vr vu cv cA cvv cR issubspt cR ctop wcel cA cX wss
      pm3.26 vu cv cvv wcel cR ctop wcel cA cX wss wa vu visset a1i cA cX wss
      cR ctop wcel cA cvv wcel cA cX wss cX cvv wcel cA cvv wcel cR ctop wcel
      cA cX cvv ssexg cR ctop wcel cR cuni cvv cX cR ctop uniexg txsubsp.1
      syl5eqel sylan2 ancoms syl3anc cS ctop wcel vv cv cvv wcel cB cvv wcel vv
      cv cB cS cop csubsp cfv wcel vv cv vs cv cB cin wceq vs cS wrex wb cS
      ctop wcel cB cY wss wa vs vv cv cB cvv cS issubspt cS ctop wcel cB cY wss
      pm3.26 vv cv cvv wcel cS ctop wcel cB cY wss wa vv visset a1i cB cY wss
      cS ctop wcel cB cvv wcel cB cY wss cY cvv wcel cB cvv wcel cS ctop wcel
      cB cY cvv ssexg cS ctop wcel cS cuni cvv cY cS ctop uniexg txsubsp.2
      syl5eqel sylan2 ancoms syl3anc bi2anan9 an4s cR cS ctx co ctop wcel vu cv
      vv cv cxp cvv wcel cA cB cxp cvv wcel vu cv vv cv cxp cA cB cxp cR cS ctx
      co cop csubsp cfv wcel vu cv vv cv cxp vy cv cA cB cxp cin wceq vy cR cS
      ctx co wrex wb cR ctop wcel cS ctop wcel wa cA cX wss cB cY wss wa wa vy
      vu cv vv cv cxp cA cB cxp cvv cR cS ctx co issubspt cR ctop wcel cS ctop
      wcel wa cR cS ctx co ctop wcel cA cX wss cB cY wss wa cR cS cR cS ctx co
      cR cS ctx co eqid txtop adantr vu cv vv cv cxp cvv wcel cR ctop wcel cS
      ctop wcel wa cA cX wss cB cY wss wa wa vu cv vv cv vu visset vv visset
      xpex a1i cR ctop wcel cA cX wss cS ctop wcel cB cY wss cA cB cxp cvv wcel
      cA cvv wcel cB cvv wcel cA cB cxp cvv wcel cR ctop wcel cA cX wss wa cS
      ctop wcel cB cY wss wa cA cB cvv cvv xpexg cA cX wss cR ctop wcel cA cvv
      wcel cA cX wss cX cvv wcel cA cvv wcel cR ctop wcel cA cX cvv ssexg cR
      ctop wcel cR cuni cvv cX cR ctop uniexg txsubsp.1 syl5eqel sylan2 ancoms
      cB cY wss cS ctop wcel cB cvv wcel cB cY wss cY cvv wcel cB cvv wcel cS
      ctop wcel cB cY cvv ssexg cS ctop wcel cS cuni cvv cY cS ctop uniexg
      txsubsp.2 syl5eqel sylan2 ancoms syl2an an4s syl3anc 3imtr4d vu cv vv cv
      cxp cA cB cxp cR cS ctx co cop csubsp cfv vz cv eleq1a syl6 r19.23advv
      abssdv sylan2 ancoms sylanc syl5cbir expimpd 19.23adv sylbid impbid eqrdv
      $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d R u v z $. $d S u v z $. $d T u v z $. $d A u v z $. $d B u v z $.
    txopn.1 $e |- T = ( R tX S ) $.
    $( The product of two open sets is open in the product topology. $)
    txopn $p |- ( ( ( R e. Top /\ S e. Top ) /\ ( A e. R /\ B e. S ) )
                                                      -> ( A X. B ) e. T ) $=
      cR ctop wcel cS ctop wcel wa cA cR wcel cB cS wcel wa wa cA cB cxp vz cv
      vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv cT cR ctop wcel
      cS ctop wcel wa cA cR wcel cB cS wcel wa wa vz cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv cS wrex vu cR
      wrex vz cab ctg cfv cA cB cxp cR ctop wcel cS ctop wcel wa vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cab ctg cfv wss cA cR wcel cB cS wcel wa cR ctop wcel
      cS ctop wcel wa vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      ctb wcel vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab vz cv vu
      cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv wss vz vv vu cR cS
      txbas vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab bastg syl
      adantr cA cR wcel cB cS wcel wa cA cB cxp vz cv vu cv vv cv cxp wceq vv
      cS wrex vu cR wrex vz cab wcel cR ctop wcel cS ctop wcel wa cA cR wcel cB
      cS wcel wa cA cB cxp vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz
      cab wcel cA cB cxp vu cv vv cv cxp wceq vv cS wrex vu cR wrex cA cR wcel
      cB cS wcel cA cB cxp cA cB cxp wceq cA cB cxp vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex cA cB cxp eqid cA cB cxp vu cv vv cv cxp wceq cA cB cxp
      cA cB cxp wceq cA cB cxp cA vv cv cxp wceq vu vv cA cB cR cS vu cv cA
      wceq vu cv vv cv cxp cA vv cv cxp cA cB cxp vu cv cA vv cv xpeq1 eqeq2d
      vv cv cB wceq cA vv cv cxp cA cB cxp cA cB cxp vv cv cB cA xpeq2 eqeq2d
      rcla42ev mp3an3 cA cR wcel cB cS wcel wa cA cB cxp cvv wcel cA cB cxp vz
      cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab wcel cA cB cxp vu cv
      vv cv cxp wceq vv cS wrex vu cR wrex wb cA cB cR cS xpexg vz cv vu cv vv
      cv cxp wceq vv cS wrex vu cR wrex cA cB cxp vu cv vv cv cxp wceq vv cS
      wrex vu cR wrex vz cA cB cxp cvv vz cv cA cB cxp wceq vz cv vu cv vv cv
      cxp wceq cA cB cxp vu cv vv cv cxp wceq vu vv cR cS vz cv cA cB cxp vu cv
      vv cv cxp eqeq1 2rexbidv elabg syl mpbird adantl sseldd cR ctop wcel cS
      ctop wcel wa cT vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab
      ctg cfv wceq cA cR wcel cB cS wcel wa cR ctop wcel cS ctop wcel wa cR cS
      ctx co vz cv vu cv vv cv cxp wceq vv cS wrex vu cR wrex vz cab ctg cfv cT
      vz vv vu cR cS txval txopn.1 syl5eq adantr eleqtrrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    txcld.1 $e |- T = ( R tX S ) $.
    $( The product of two closed sets is closed in the product topology. $)
    txcld $p |- ( ( ( R e. Top /\ S e. Top ) /\ ( A e. ( Clsd ` R )
                  /\ B e. ( Clsd ` S ) ) ) -> ( A X. B ) e. ( Clsd ` T ) ) $=
      cR ctop wcel cS ctop wcel wa cA cR ccld cfv wcel cB cS ccld cfv wcel wa
      cA cB cxp cT ccld cfv wcel cR ctop wcel cS ctop wcel wa cA cR cuni wss cR
      cuni cA cdif cR wcel wa cB cS cuni wss cS cuni cB cdif cS wcel wa wa cA
      cB cxp cT cuni wss cT cuni cA cB cxp cdif cT wcel wa cA cR ccld cfv wcel
      cB cS ccld cfv wcel wa cA cB cxp cT ccld cfv wcel cR ctop wcel cS ctop
      wcel wa cA cR cuni wss cR cuni cA cdif cR wcel wa cB cS cuni wss cS cuni
      cB cdif cS wcel wa wa cA cB cxp cT cuni wss cT cuni cA cB cxp cdif cT
      wcel cR ctop wcel cS ctop wcel wa cA cR cuni wss cR cuni cA cdif cR wcel
      wa cB cS cuni wss cS cuni cB cdif cS wcel wa wa cA cB cxp cT cuni wss cR
      ctop wcel cS ctop wcel wa cA cR cuni wss cR cuni cA cdif cR wcel wa cB cS
      cuni wss cS cuni cB cdif cS wcel wa wa wa cA cB cxp cR cuni cS cuni cxp
      cT cuni cA cR cuni wss cR cuni cA cdif cR wcel wa cB cS cuni wss cS cuni
      cB cdif cS wcel wa wa cA cB cxp cR cuni cS cuni cxp wss cR ctop wcel cS
      ctop wcel wa cA cR cuni wss cB cS cuni wss cA cB cxp cR cuni cS cuni cxp
      wss cR cuni cA cdif cR wcel cS cuni cB cdif cS wcel cA cR cuni cB cS cuni
      ssxp ad2ant2r adantl cR ctop wcel cS ctop wcel wa cT cuni cR cuni cS cuni
      cxp wceq cA cR cuni wss cR cuni cA cdif cR wcel wa cB cS cuni wss cS cuni
      cB cdif cS wcel wa wa cR cS cT cR cuni cS cuni txcld.1 cR cuni eqid cS
      cuni eqid txuni adantr sseqtr4d ex cR ctop wcel cS ctop wcel wa cA cR
      cuni wss cR cuni cA cdif cR wcel wa cB cS cuni wss cS cuni cB cdif cS
      wcel wa wa cT cuni cA cB cxp cdif cT wcel cR ctop wcel cS ctop wcel wa cA
      cR cuni wss cR cuni cA cdif cR wcel wa cS cuni cB cdif cS wcel cT cuni cA
      cB cxp cdif cT wcel cB cS cuni wss cR ctop wcel cS ctop wcel wa cR cuni
      cA cdif cR wcel cS cuni cB cdif cS wcel cT cuni cA cB cxp cdif cT wcel cA
      cR cuni wss cR ctop wcel cS ctop wcel wa cR cuni cA cdif cR wcel cS cuni
      cB cdif cS wcel wa wa cT cuni cA cB cxp cdif cR cuni cA cdif cS cuni cxp
      cR cuni cS cuni cB cdif cxp cun cR cuni cA cdif cS cuni cB cdif cxp cun
      cT cR ctop wcel cS ctop wcel wa cR cuni cA cdif cR wcel cS cuni cB cdif
      cS wcel wa wa cT cuni cA cB cxp cdif cR cuni cS cuni cxp cA cB cxp cdif
      cR cuni cA cdif cS cuni cxp cR cuni cS cuni cB cdif cxp cun cR cuni cA
      cdif cS cuni cB cdif cxp cun cR ctop wcel cS ctop wcel wa cR cuni cA cdif
      cR wcel cS cuni cB cdif cS wcel wa wa cT cuni cR cuni cS cuni cxp cA cB
      cxp cR ctop wcel cS ctop wcel wa cT cuni cR cuni cS cuni cxp wceq cR cuni
      cA cdif cR wcel cS cuni cB cdif cS wcel wa cR cS cT cR cuni cS cuni
      txcld.1 cR cuni eqid cS cuni eqid txuni adantr difeq1d cA cB cR cuni cS
      cuni difxp syl6eq cT ctop wcel cR cuni cA cdif cS cuni cxp cR cuni cS
      cuni cB cdif cxp cun cT wcel cR cuni cA cdif cS cuni cB cdif cxp cT wcel
      cR cuni cA cdif cS cuni cxp cR cuni cS cuni cB cdif cxp cun cR cuni cA
      cdif cS cuni cB cdif cxp cun cT wcel cR ctop wcel cS ctop wcel wa cR cuni
      cA cdif cR wcel cS cuni cB cdif cS wcel wa wa cR cuni cA cdif cS cuni cxp
      cR cuni cS cuni cB cdif cxp cun cR cuni cA cdif cS cuni cB cdif cxp cT
      unopn cR ctop wcel cS ctop wcel wa cT ctop wcel cR cuni cA cdif cR wcel
      cS cuni cB cdif cS wcel wa cR cS cT txcld.1 txtop adantr cT ctop wcel cR
      cuni cA cdif cS cuni cxp cT wcel cR cuni cS cuni cB cdif cxp cT wcel cR
      cuni cA cdif cS cuni cxp cR cuni cS cuni cB cdif cxp cun cT wcel cR ctop
      wcel cS ctop wcel wa cR cuni cA cdif cR wcel cS cuni cB cdif cS wcel wa
      wa cR cuni cA cdif cS cuni cxp cR cuni cS cuni cB cdif cxp cT unopn cR
      ctop wcel cS ctop wcel wa cT ctop wcel cR cuni cA cdif cR wcel cS cuni cB
      cdif cS wcel wa cR cS cT txcld.1 txtop adantr cR ctop wcel cS ctop wcel
      wa cR cuni cA cdif cR wcel cR cuni cA cdif cS cuni cxp cT wcel cS cuni cB
      cdif cS wcel cR ctop wcel cS ctop wcel wa cR cuni cA cdif cR wcel wa cS
      cuni cS wcel cR cuni cA cdif cS cuni cxp cT wcel cS ctop wcel cS cuni cS
      wcel cR ctop wcel cR cuni cA cdif cR wcel cS cS cuni cS cuni eqid topopn
      ad2antlr cR ctop wcel cS ctop wcel wa cR cuni cA cdif cR wcel cS cuni cS
      wcel cR cuni cA cdif cS cuni cxp cT wcel cR cuni cA cdif cS cuni cR cS cT
      txcld.1 txopn anassrs mpdan adantrr cR ctop wcel cS ctop wcel wa cS cuni
      cB cdif cS wcel cR cuni cS cuni cB cdif cxp cT wcel cR cuni cA cdif cR
      wcel cR ctop wcel cS ctop wcel wa cS cuni cB cdif cS wcel wa cR cuni cR
      wcel cR cuni cS cuni cB cdif cxp cT wcel cR ctop wcel cR cuni cR wcel cS
      ctop wcel cS cuni cB cdif cS wcel cR cR cuni cR cuni eqid topopn ad2antrr
      cR ctop wcel cS ctop wcel wa cS cuni cB cdif cS wcel cR cuni cR wcel cR
      cuni cS cuni cB cdif cxp cT wcel cR ctop wcel cS ctop wcel wa cR cuni cR
      wcel cS cuni cB cdif cS wcel cR cuni cS cuni cB cdif cxp cT wcel cR cuni
      cS cuni cB cdif cR cS cT txcld.1 txopn ancom2s anassrs mpdan adantrl
      syl3anc cR cuni cA cdif cS cuni cB cdif cR cS cT txcld.1 txopn syl3anc
      eqeltrd adantrll adantrrl ex jcad cR ctop wcel cA cR ccld cfv wcel cA cR
      cuni wss cR cuni cA cdif cR wcel wa cS ctop wcel cB cS ccld cfv wcel cB
      cS cuni wss cS cuni cB cdif cS wcel wa cA cR cR cuni cR cuni eqid iscld
      cB cS cS cuni cS cuni eqid iscld bi2anan9 cR ctop wcel cS ctop wcel wa cT
      ctop wcel cA cB cxp cT ccld cfv wcel cA cB cxp cT cuni wss cT cuni cA cB
      cxp cdif cT wcel wa wb cR cS cT txcld.1 txtop cA cB cxp cT cT cuni cT
      cuni eqid iscld syl 3imtr4d imp $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Boundedness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $c TotBnd $.
  $c Bnd $.
  $( Extend class notation with the class of totally bounded metric spaces. $)
  ctotbnd $a class TotBnd $.
  $( Extend class notation with the class of bounded metric spaces. $)
  cbnd $a class Bnd $.

  ${
    $d m d v b x $.
    $( Define the class of totally bounded metrics. A metric space is totally
       bounded iff it can be covered by a finite number of balls of any given
       radius. $)
    df-totbnd $a |- TotBnd = { m e. Met | A. d e. RR+ E. v e. Fin ( U. v =
      dom dom m /\ A. b e. v E. x e. dom dom m b = ( x ( ball ` m ) d ) ) } $.
  $}

  ${
    $d M m d v b x $. $d X m d v b x $.
    istotbnd.1 $e |- X = dom dom M $.
    $( The predicate "is a totally bounded metric space". $)
    istotbnd $p |- ( M e. TotBnd <-> ( M e. Met /\ A. d e. RR+ E. v e. Fin
        ( U. v = X /\ A. b e. v E. x e. X b = ( x ( ball ` M ) d ) ) ) ) $=
      vv cv cuni vm cv cdm cdm wceq vb cv vx cv vd cv vm cv cbl cfv co wceq vx
      vm cv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral vv cv cuni cX
      wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv
      cfn wrex vd crp wral vm cM cme ctotbnd vm cv cM wceq vv cv cuni vm cv cdm
      cdm wceq vb cv vx cv vd cv vm cv cbl cfv co wceq vx vm cv cdm cdm wrex vb
      vv cv wral wa vv cfn wrex vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd crp vm cv cM wceq vv
      cv cuni vm cv cdm cdm wceq vb cv vx cv vd cv vm cv cbl cfv co wceq vx vm
      cv cdm cdm wrex vb vv cv wral wa vv cv cuni cX wceq vb cv vx cv vd cv cM
      cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn vm cv cM wceq vv cv
      cuni vm cv cdm cdm wceq vv cv cuni cX wceq vb cv vx cv vd cv vm cv cbl
      cfv co wceq vx vm cv cdm cdm wrex vb vv cv wral vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vb vv cv wral vm cv cM wceq vm cv cdm cdm cX vv cv
      cuni vm cv cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm cv cdm cM
      cdm vm cv cM dmeq dmeqd istotbnd.1 syl6eqr eqeq2d vm cv cM wceq vb cv vx
      cv vd cv vm cv cbl cfv co wceq vx vm cv cdm cdm wrex vb cv vx cv vd cv cM
      cbl cfv co wceq vx cX wrex vb vv cv vm cv cM wceq vb cv vx cv vd cv vm cv
      cbl cfv co wceq vb cv vx cv vd cv cM cbl cfv co wceq vx vm cv cdm cdm cX
      vm cv cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm cv cdm cM cdm
      vm cv cM dmeq dmeqd istotbnd.1 syl6eqr vm cv cM wceq vx cv vd cv vm cv
      cbl cfv co vx cv vd cv cM cbl cfv co vb cv vm cv cM wceq vm cv cbl cfv cM
      cbl cfv vx cv vd cv vm cv cM cbl fveq2 opreqd eqeq2d rexeq12d ralbidv
      anbi12d rexbidv ralbidv vx vv vm vb vd df-totbnd elrab2 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M d v b x $. $d X d v b x $.
    istotbnd2.1 $e |- X = dom dom M $.
    $( The predicate "is a totally bounded metric space." $)
    istotbnd2 $p |- ( M e. Met -> ( M e. TotBnd <-> A. d e. RR+ E. v e. Fin
        ( U. v = X /\ A. b e. v E. x e. X b = ( x ( ball ` M ) d ) ) ) ) $=
      cM ctotbnd wcel cM cme wcel vv cv cuni cX wceq vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral vx vv cM
      cX vb vd istotbnd2.1 istotbnd baib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M d v b x $.
    $( The predicate "totally bounded" implies ` M ` is a metric space. $)
    totbndmet $p |- ( M e. TotBnd -> M e. Met ) $=
      cM ctotbnd wcel cM cme wcel vv cv cuni cM cdm cdm wceq vb cv vx cv vd cv
      cM cbl cfv co wceq vx cM cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp
      wral vx vv cM cM cdm cdm vb vd cM cdm cdm eqid istotbnd pm3.26bi $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d X a b c d r s t u v w x y z $. $d M a b c d r s t u v w x y z $.
    $d Y a b c d r s t u v w x y z $. $d N a b c d r s t u v w x y z $.
    sstotbnd.1 $e |- X = dom dom M $.
    sstotbnd.2 $e |- N = ( M |` ( Y X. Y ) ) $.
    $( Condition for a subset of a metric space to be totally bounded. $)
    sstotbnd $p |- ( ( M e. Met /\ Y C_ X ) -> ( N e. TotBnd <->
                        A. d e. RR+ E. v e. Fin ( Y C_ U. v /\
                          A. b e. v E. x e. X b = ( x ( ball ` M ) d ) ) ) ) $=
      cM cme wcel cY cX wss wa cN ctotbnd wcel cY vv cv cuni wss vb cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral
      cM cme wcel cY cX wss wa cN ctotbnd wcel vw cv cuni cN cdm cdm wceq vu cv
      vs cv vd cv cN cbl cfv co wceq vs cN cdm cdm wrex vu vw cv wral wa vw cfn
      wrex vd crp wral cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral cM cme wcel cY cX wss
      wa cN cme wcel cN ctotbnd wcel vw cv cuni cN cdm cdm wceq vu cv vs cv vd
      cv cN cbl cfv co wceq vs cN cdm cdm wrex vu vw cv wral wa vw cfn wrex vd
      crp wral wb cM cme wcel cY cX wss wa cM cY cY cxp cres cme cN cM cme wcel
      cM cY cY cxp cres cme wcel cY cX wss cM cY metres adantr sstotbnd.2
      syl5eqel vs vw cN cN cdm cdm vu vd cN cdm cdm eqid istotbnd2 syl cM cme
      wcel cY cX wss wa vw cv cuni cN cdm cdm wceq vu cv vs cv vd cv cN cbl cfv
      co wceq vs cN cdm cdm wrex vu vw cv wral wa vw cfn wrex cY vv cv cuni wss
      vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn
      wrex vd crp cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cuni cN cdm
      cdm wceq vu cv vs cv vd cv cN cbl cfv co wceq vs cN cdm cdm wrex vu vw cv
      wral wa cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex
      vb vv cv wral wa vv cfn wrex vw cfn cM cme wcel cY cX wss wa vd cv crp
      wcel wa vw cv cfn wcel wa vw cv cuni cN cdm cdm wceq vu cv vs cv vd cv cN
      cbl cfv co wceq vs cN cdm cdm wrex vu vw cv wral wa cY vv cv cuni wss vb
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex
      cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vw cv cuni
      cN cdm cdm wceq vu cv vs cv vd cv cN cbl cfv co wceq vs cN cdm cdm wrex
      vu vw cv wral wa wa vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv wrex vu vw cv wral vu cv vs cv vd cv cN cbl cfv co wceq vu
      vw cv wrex vs vz cv wral w3a vz cfn wrex cY vv cv cuni wss vb cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vw cv cfn
      wcel cN cdm cdm cvv wcel vu cv vs cv vd cv cN cbl cfv co wceq vs cN cdm
      cdm wrex vu vw cv wral vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl cfv
      co wceq vs vz cv wrex vu vw cv wral vu cv vs cv vd cv cN cbl cfv co wceq
      vu vw cv wrex vs vz cv wral w3a vz cfn wrex cM cme wcel cY cX wss wa vd
      cv crp wcel wa vw cv cfn wcel wa vw cv cuni cN cdm cdm wceq vu cv vs cv
      vd cv cN cbl cfv co wceq vs cN cdm cdm wrex vu vw cv wral wa wa vu cv vs
      cv vd cv cN cbl cfv co wceq vu vs vw cv cN cdm cdm cvv vz indexf cM cme
      wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel vw cv cuni cN cdm cdm
      wceq vu cv vs cv vd cv cN cbl cfv co wceq vs cN cdm cdm wrex vu vw cv
      wral wa simplr cM cme wcel cY cX wss wa vd cv crp wcel wa cN cdm cdm cvv
      wcel vw cv cfn wcel vw cv cuni cN cdm cdm wceq vu cv vs cv vd cv cN cbl
      cfv co wceq vs cN cdm cdm wrex vu vw cv wral wa cM cme wcel cN cdm cdm
      cvv wcel cY cX wss vd cv crp wcel cM cme wcel cN cvv wcel cN cdm cvv wcel
      cN cdm cdm cvv wcel cM cme wcel cM cY cY cxp cres cvv cN cM cY cY cxp cme
      resexg sstotbnd.2 syl5eqel cN cvv dmexg cN cdm cvv dmexg 3syl ad2antrr
      ad2antrr cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vw
      cv cuni cN cdm cdm wceq vu cv vs cv vd cv cN cbl cfv co wceq vs cN cdm
      cdm wrex vu vw cv wral simprr syl3anc cM cme wcel cY cX wss wa vd cv crp
      wcel wa vw cv cfn wcel wa vw cv cuni cN cdm cdm wceq vz cv cN cdm cdm wss
      vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral vu cv vs
      cv vd cv cN cbl cfv co wceq vu vw cv wrex vs vz cv wral w3a vz cfn wrex
      cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv
      cv wral wa vv cfn wrex wi vu cv vs cv vd cv cN cbl cfv co wceq vs cN cdm
      cdm wrex vu vw cv wral cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv
      cfn wcel wa vw cv cuni cN cdm cdm wceq wa vz cv cN cdm cdm wss vu cv vs
      cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral vu cv vs cv vd cv
      cN cbl cfv co wceq vu vw cv wrex vs vz cv wral w3a cY vv cv cuni wss vb
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex
      vz cfn cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vw cv
      cuni cN cdm cdm wceq vz cv cfn wcel vz cv cN cdm cdm wss vu cv vs cv vd
      cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral vu cv vs cv vd cv cN
      cbl cfv co wceq vu vw cv wrex vs vz cv wral w3a cY vv cv cuni wss vb cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex wi
      cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vw cv cuni
      cN cdm cdm wceq vz cv cfn wcel wa wa vz cv cN cdm cdm wss vu cv vs cv vd
      cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral vu cv vs cv vd cv cN
      cbl cfv co wceq vu vw cv wrex vs vz cv wral w3a cY vv cv cuni wss vb cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex va
      cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cfn wcel cY va cv
      vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cuni wss vb cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vb va cv vt cv vd cv cM cbl cfv co
      wceq vt vz cv wrex va cab wral cY vv cv cuni wss vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex cM cme wcel cY cX wss
      wa vd cv crp wcel wa vw cv cfn wcel wa vw cv cuni cN cdm cdm wceq vz cv
      cfn wcel wa wa vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl cfv co wceq
      vs vz cv wrex vu vw cv wral vu cv vs cv vd cv cN cbl cfv co wceq vu vw cv
      wrex vs vz cv wral w3a wa vw cv cuni cN cdm cdm wceq vz cv cfn wcel wa va
      cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cfn wcel cM cme
      wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vz cv cN cdm cdm
      wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral vu
      cv vs cv vd cv cN cbl cfv co wceq vu vw cv wrex vs vz cv wral w3a vz cv
      cfn wcel va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cfn
      wcel vw cv cuni cN cdm cdm wceq va vt vz cv vt cv vd cv cM cbl cfv co
      firnfi2 adantl ad2antlr cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv
      cfn wcel wa vw cv cuni cN cdm cdm wceq vz cv cfn wcel wa wa vz cv cN cdm
      cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral
      cY va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cuni wss vu
      cv vs cv vd cv cN cbl cfv co wceq vu vw cv wrex vs vz cv wral cM cme wcel
      cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vw cv cuni cN cdm cdm
      wceq vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv
      wrex vu vw cv wral wa cY va cv vt cv vd cv cM cbl cfv co wceq vt vz cv
      wrex va cab cuni wss vz cv cfn wcel cM cme wcel cY cX wss wa vd cv crp
      wcel wa vw cv cuni cN cdm cdm wceq vz cv cN cdm cdm wss vu cv vs cv vd cv
      cN cbl cfv co wceq vs vz cv wrex vu vw cv wral wa cY va cv vt cv vd cv cM
      cbl cfv co wceq vt vz cv wrex va cab cuni wss vw cv cfn wcel cM cme wcel
      cY cX wss wa vd cv crp wcel wa vw cv cuni cN cdm cdm wceq wa vz cv cN cdm
      cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral
      wa wa cY vw cv cuni va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va
      cab cuni cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cuni cN cdm cdm
      wceq wa cY vw cv cuni wceq vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl
      cfv co wceq vs vz cv wrex vu vw cv wral wa cM cme wcel cY cX wss wa vw cv
      cuni cN cdm cdm wceq cY vw cv cuni wceq vd cv crp wcel cM cme wcel cY cX
      wss wa vw cv cuni cN cdm cdm wceq wa vw cv cuni cY cM cme wcel cY cX wss
      wa vw cv cuni cN cdm cdm wceq vw cv cuni cY wceq cM cme wcel cY cX wss wa
      cN cdm cdm cY vw cv cuni cM cme wcel cY cX wss wa cY cM cY cY cxp cres
      cdm cdm cN cdm cdm cM cX cY sstotbnd.1 metssba2 cN cdm cM cY cY cxp cres
      cdm cN cM cY cY cxp cres sstotbnd.2 dmeqi dmeqi syl6reqr eqeq2d biimpa
      eqcomd adantlr adantr cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN
      cdm cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv
      wral wa vw cv cuni va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va
      cab cuni wss vw cv cuni cN cdm cdm wceq cM cme wcel cY cX wss wa vd cv
      crp wcel wa vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs
      vz cv wrex vu vw cv wral wa wa vw cv cuni vb cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv wrex vb cab cuni va cv vt cv vd cv cM cbl cfv co wceq vt vz
      cv wrex va cab cuni cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN
      cdm cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv
      wral wa wa vw cv vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb
      cab wss vw cv cuni vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb
      cab cuni wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv
      wral vw cv vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb cab wss
      cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss vu cv vs
      cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral vu cv vb cv vs cv
      vd cv cN cbl cfv co wceq vs vz cv wrex vb cab wcel vu vw cv wral vw cv vb
      cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb cab wss vu cv vs cv vd
      cv cN cbl cfv co wceq vs vz cv wrex vu cv vb cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv wrex vb cab wcel vu vw cv vu cv vb cv vs cv vd cv cN cbl
      cfv co wceq vs vz cv wrex vb cab wcel vu cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv wrex vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu
      cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb vu cv vu visset vb vu
      weq vb cv vs cv vd cv cN cbl cfv co wceq vu cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv vb cv vu cv vs cv vd cv cN cbl cfv co eqeq1 rexbidv elab
      biimpri r19.20si vu vw cv vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv
      wrex vb cab dfss3 sylibr ad2antll vw cv vb cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv wrex vb cab uniss syl cM cme wcel cY cX wss wa vd cv crp
      wcel wa vz cv cN cdm cdm wss vu cv vs cv vd cv cN cbl cfv co wceq vs vz
      cv wrex vu vw cv wral wa wa vx cv vy cv wss vy va cv vt cv vd cv cM cbl
      cfv co wceq vt vz cv wrex va cab wrex vx vb cv vs cv vd cv cN cbl cfv co
      wceq vs vz cv wrex vb cab wral vb cv vs cv vd cv cN cbl cfv co wceq vs vz
      cv wrex vb cab cuni va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va
      cab cuni wss cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm
      wss vx cv vy cv wss vy va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex
      va cab wrex vx vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb cab
      wral vu cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vu vw cv wral cM
      cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa vx cv vy
      cv wss vy va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wrex
      vx vb cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb cab cM cme wcel
      cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa vx cv vs cv vd cv
      cN cbl cfv co wceq vs vz cv wrex vx cv vy cv wss vy va cv vt cv vd cv cM
      cbl cfv co wceq vt vz cv wrex va cab wrex vx cv vb cv vs cv vd cv cN cbl
      cfv co wceq vs vz cv wrex vb cab wcel cM cme wcel cY cX wss wa vd cv crp
      wcel wa vz cv cN cdm cdm wss wa vx cv vs cv vd cv cN cbl cfv co wceq vx
      cv vy cv wss vy va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab
      wrex vs vz cv cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm
      wss wa vs vz wel wa vx cv vs cv vd cv cN cbl cfv co wceq vx cv vy cv wss
      vy va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wrex vs cv
      vd cv cM cbl cfv co va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va
      cab wcel vx cv vs cv vd cv cM cbl cfv co wss vx cv vy cv wss vy va cv vt
      cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wrex cM cme wcel cY cX
      wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa vs vz wel wa vx cv vs cv
      vd cv cN cbl cfv co wceq wa vx cv vy cv wss vx cv vs cv vd cv cM cbl cfv
      co wss vy vs cv vd cv cM cbl cfv co va cv vt cv vd cv cM cbl cfv co wceq
      vt vz cv wrex va cab vy cv vs cv vd cv cM cbl cfv co vx cv sseq2 rcla4ev
      vs vz wel vs cv vd cv cM cbl cfv co va cv vt cv vd cv cM cbl cfv co wceq
      vt vz cv wrex va cab wcel cM cme wcel cY cX wss wa vd cv crp wcel wa vz
      cv cN cdm cdm wss wa vx cv vs cv vd cv cN cbl cfv co wceq vs vz wel vs cv
      vd cv cM cbl cfv co vt cv vd cv cM cbl cfv co wceq vt vz cv wrex vs cv vd
      cv cM cbl cfv co va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va
      cab wcel vs vz wel vs cv vd cv cM cbl cfv co vs cv vd cv cM cbl cfv co
      wceq vs cv vd cv cM cbl cfv co vt cv vd cv cM cbl cfv co wceq vt vz cv
      wrex vs cv vd cv cM cbl cfv co eqid vs cv vd cv cM cbl cfv co vt cv vd cv
      cM cbl cfv co wceq vs cv vd cv cM cbl cfv co vs cv vd cv cM cbl cfv co
      wceq vt vs cv vz cv vt vs weq vt cv vd cv cM cbl cfv co vs cv vd cv cM
      cbl cfv co vs cv vd cv cM cbl cfv co vt cv vs cv vd cv cM cbl cfv opreq1
      eqeq2d rcla4ev mpan2 va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex
      vs cv vd cv cM cbl cfv co vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va
      vs cv vd cv cM cbl cfv co vs cv vd cv cM cbl cfv oprex va cv vs cv vd cv
      cM cbl cfv co wceq va cv vt cv vd cv cM cbl cfv co wceq vs cv vd cv cM
      cbl cfv co vt cv vd cv cM cbl cfv co wceq vt vz cv va cv vs cv vd cv cM
      cbl cfv co vt cv vd cv cM cbl cfv co eqeq1 rexbidv elab sylibr ad2antlr
      cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa vs vz
      wel wa vx cv vs cv vd cv cN cbl cfv co wceq wa vx cv vs cv vd cv cM cbl
      cfv co cY cin vs cv vd cv cM cbl cfv co cM cme wcel cY cX wss wa vd cv
      crp wcel wa vz cv cN cdm cdm wss wa vs vz wel wa vx cv vs cv vd cv cN cbl
      cfv co wceq wa vx cv vs cv vd cv cN cbl cfv co vs cv vd cv cM cbl cfv co
      cY cin cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa
      vs vz wel wa vx cv vs cv vd cv cN cbl cfv co wceq pm3.27 cM cme wcel cY
      cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa vs vz wel wa vs cv vd
      cv cN cbl cfv co vs cv vd cv cM cbl cfv co cY cin wceq vx cv vs cv vd cv
      cN cbl cfv co wceq cM cme wcel cY cX wss wa vd cv crp wcel wa vz cv cN
      cdm cdm wss wa vs vz wel vs cv cY wcel vs cv vd cv cN cbl cfv co vs cv vd
      cv cM cbl cfv co cY cin wceq cM cme wcel cY cX wss wa vz cv cN cdm cdm
      wss vs vz wel vs cv cY wcel vd cv crp wcel vz cv cY wss vs vz wel vs cv
      cY wcel cM cme wcel cY cX wss wa vz cv cN cdm cdm wss wa vz cv cY vs cv
      ssel2 cM cme wcel cY cX wss wa vz cv cN cdm cdm wss vz cv cY wss cM cme
      wcel cY cX wss wa cN cdm cdm cY vz cv cM cme wcel cY cX wss wa cY cM cY
      cY cxp cres cdm cdm cN cdm cdm cM cX cY sstotbnd.1 metssba2 cN cdm cM cY
      cY cxp cres cdm cN cM cY cY cxp cres sstotbnd.2 dmeqi dmeqi syl6reqr
      sseq2d biimpa sylan adantllr cM cme wcel cY cX wss wa vd cv crp wcel wa
      vs cv cY wcel vs cv vd cv cN cbl cfv co vs cv vd cv cM cbl cfv co cY cin
      wceq vz cv cN cdm cdm wss cM cme wcel cY cX wss wa vs cv cY wcel vd cv
      crp wcel vs cv vd cv cN cbl cfv co vs cv vd cv cM cbl cfv co cY cin wceq
      cM cme wcel cY cX wss wa vs cv cY wcel vd cv crp wcel vs cv vd cv cN cbl
      cfv co vs cv vd cv cM cbl cfv co cY cin wceq vd cv cY cM cN cX vs cv
      sstotbnd.1 sstotbnd.2 blssp anassrs an1rs adantlr syldan adantr eqtrd vs
      cv vd cv cM cbl cfv co cY cin vs cv vd cv cM cbl cfv co wss cM cme wcel
      cY cX wss wa vd cv crp wcel wa vz cv cN cdm cdm wss wa vs vz wel wa vx cv
      vs cv vd cv cN cbl cfv co wceq wa vs cv vd cv cM cbl cfv co cY inss1 a1i
      eqsstrd sylanc ex r19.23adva vb cv vs cv vd cv cN cbl cfv co wceq vs vz
      cv wrex vx cv vs cv vd cv cN cbl cfv co wceq vs vz cv wrex vb vx cv vx
      visset vb vx weq vb cv vs cv vd cv cN cbl cfv co wceq vx cv vs cv vd cv
      cN cbl cfv co wceq vs vz cv vb cv vx cv vs cv vd cv cN cbl cfv co eqeq1
      rexbidv elab syl5ib r19.21aiv adantrr vx vy vb cv vs cv vd cv cN cbl cfv
      co wceq vs vz cv wrex vb cab va cv vt cv vd cv cM cbl cfv co wceq vt vz
      cv wrex va cab uniss2 syl sstrd adantlr eqsstrd adantllr adantlrr
      3adantr3 cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cfn wcel wa vw
      cv cuni cN cdm cdm wceq vz cv cfn wcel wa wa vu cv vs cv vd cv cN cbl cfv
      co wceq vs vz cv wrex vu vw cv wral vz cv cN cdm cdm wss vb cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vb va cv vt cv vd cv cM cbl cfv co wceq
      vt vz cv wrex va cab wral vu cv vs cv vd cv cN cbl cfv co wceq vu vw cv
      wrex vs vz cv wral cM cme wcel cY cX wss wa vd cv crp wcel wa vw cv cfn
      wcel wa vz cv cN cdm cdm wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vb va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wral vw
      cv cuni cN cdm cdm wceq vz cv cfn wcel wa cM cme wcel cY cX wss wa vd cv
      crp wcel wa vz cv cN cdm cdm wss vb cv vx cv vd cv cM cbl cfv co wceq vx
      cX wrex vb va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wral
      vw cv cfn wcel cM cme wcel cY cX wss wa vz cv cN cdm cdm wss vb cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vb va cv vt cv vd cv cM cbl cfv co
      wceq vt vz cv wrex va cab wral vd cv crp wcel cM cme wcel cY cX wss wa vz
      cv cN cdm cdm wss wa cM cme wcel cY cX wss wa vz cv cY wss wa vz cv cX
      wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb va cv vt cv vd cv
      cM cbl cfv co wceq vt vz cv wrex va cab wral cM cme wcel cY cX wss wa vz
      cv cN cdm cdm wss vz cv cY wss cM cme wcel cY cX wss wa vz cv cN cdm cdm
      wss vz cv cY wss cM cme wcel cY cX wss wa cN cdm cdm cY vz cv cM cme wcel
      cY cX wss wa cY cM cY cY cxp cres cdm cdm cN cdm cdm cM cX cY sstotbnd.1
      metssba2 cN cdm cM cY cY cxp cres cdm cN cM cY cY cxp cres sstotbnd.2
      dmeqi dmeqi syl6reqr sseq2d biimpd imdistani cY cX wss vz cv cY wss vz cv
      cX wss cM cme wcel vz cv cY wss cY cX wss vz cv cX wss vz cv cY cX sstr2
      impcom adantll vz cv cX wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vb va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab vz cv
      cX wss vb cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex vb cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vb cv va cv vt cv vd cv cM cbl cfv co
      wceq vt vz cv wrex va cab wcel vz cv cX wss vb cv vt cv vd cv cM cbl cfv
      co wceq vt vz cv wrex vb cv vt cv vd cv cM cbl cfv co wceq vt cX wrex vb
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb cv vt cv vd cv cM cbl cfv
      co wceq vt vz cv cX ssrexv vb cv vt cv vd cv cM cbl cfv co wceq vb cv vx
      cv vd cv cM cbl cfv co wceq vt vx cX vt vx weq vt cv vd cv cM cbl cfv co
      vx cv vd cv cM cbl cfv co vb cv vt cv vx cv vd cv cM cbl cfv opreq1
      eqeq2d cbvrexv syl6ib va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex
      vb cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va vb cv vb visset va
      vb weq va cv vt cv vd cv cM cbl cfv co wceq vb cv vt cv vd cv cM cbl cfv
      co wceq vt vz cv va cv vb cv vt cv vd cv cM cbl cfv co eqeq1 rexbidv elab
      syl5ib r19.21aiv 3syl adantlr adantlr adantlr 3ad2antr1 cY vv cv cuni wss
      vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa cY va cv
      vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cuni wss vb cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vb va cv vt cv vd cv cM cbl cfv co
      wceq vt vz cv wrex va cab wral wa vv va cv vt cv vd cv cM cbl cfv co wceq
      vt vz cv wrex va cab cfn vv cv va cv vt cv vd cv cM cbl cfv co wceq vt vz
      cv wrex va cab wceq cY vv cv cuni wss cY va cv vt cv vd cv cM cbl cfv co
      wceq vt vz cv wrex va cab cuni wss vb cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex vb vv cv wral vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex
      vb va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wral vv cv
      va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab wceq vv cv cuni
      va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab cuni cY vv cv
      va cv vt cv vd cv cM cbl cfv co wceq vt vz cv wrex va cab unieq sseq2d vb
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv va cv vt cv vd cv
      cM cbl cfv co wceq vt vz cv wrex va cab raleq1 anbi12d rcla4ev sylan32c
      ex anassrs r19.23adva adantrr mpd ex r19.23adva r19.20dva sylbid cM cme
      wcel cY cX wss wa cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral vw cv cuni cN cdm cdm
      wceq vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv
      wral wa vw cfn wrex vc crp wral cN ctotbnd wcel cM cme wcel cY cX wss wa
      cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv
      cv wral wa vv cfn wrex vd crp wral vw cv cuni cN cdm cdm wceq vs cv vd cv
      vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex
      vc crp cM cme wcel cY cX wss wa vc cv crp wcel wa cY vv cv cuni wss vb cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd
      crp wral cY vv cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vb vv cv wral wa vv cfn wrex vw cv cuni cN cdm cdm wceq
      vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa
      vw cfn wrex vc cv crp wcel cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral cY vv cv cuni
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv
      wral wa vv cfn wrex wi cM cme wcel cY cX wss wa vc cv crp wcel vc cv c2
      cdiv co crp wcel cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral cY vv cv cuni wss vb
      cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv wral wa
      vv cfn wrex wi vc cv crp wcel c2 crp wcel vc cv c2 cdiv co crp wcel c2
      2re 2pos elrpii vc cv c2 rpdivcl mpan2 cY vv cv cuni wss vb cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex cY vv cv
      cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv
      cv wral wa vv cfn wrex vd vc cv c2 cdiv co crp vd cv vc cv c2 cdiv co
      wceq cY vv cv cuni wss vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb
      vv cv wral wa cY vv cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vb vv cv wral wa vv cfn vd cv vc cv c2 cdiv co wceq vb
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral vb cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv wral cY vv cv cuni
      wss vd cv vc cv c2 cdiv co wceq vb cv vx cv vd cv cM cbl cfv co wceq vx
      cX wrex vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv
      cv vd cv vc cv c2 cdiv co wceq vb cv vx cv vd cv cM cbl cfv co wceq vb cv
      vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX vd cv vc cv c2 cdiv co
      wceq vx cv vd cv cM cbl cfv co vx cv vc cv c2 cdiv co cM cbl cfv co vb cv
      vd cv vc cv c2 cdiv co vx cv cM cbl cfv opreq2 eqeq2d rexbidv ralbidv
      anbi2d rexbidv rcla4v syl adantl cM cme wcel cY cX wss wa vc cv crp wcel
      wa cY vv cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vv cv wral wa vw cv cuni cN cdm cdm wceq vs cv vd cv vc cv cN
      cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex vv cfn cM
      cme wcel cY cX wss wa vc cv crp wcel wa vv cv cfn wcel wa cY vv cv cuni
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv
      wral wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vb vu cv wral vy vt wel vy cY wrex vt vu cv wral w3a vu cfn
      wrex vw cv cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co wceq vd
      cN cdm cdm wrex vs vw cv wral wa vw cfn wrex cM cme wcel cY cX wss wa vc
      cv crp wcel wa vv cv cfn wcel wa cY vv cv cuni wss vb cv vx cv vc cv c2
      cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv wral wa va cv cY cin c0
      wne va vv cv crab cfn wcel cY va cv cY cin c0 wne va vv cv crab cuni wss
      vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY
      cin c0 wne va vv cv crab wral vy vt wel vy cY wrex vt va cv cY cin c0 wne
      va vv cv crab wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co
      cM cbl cfv co wceq vx cX wrex vb vu cv wral vy vt wel vy cY wrex vt vu cv
      wral w3a vu cfn wrex cM cme wcel cY cX wss wa vc cv crp wcel wa vv cv cfn
      wcel wa cY vv cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vb vv cv wral wa cY va cv cY cin c0 wne va vv cv crab cuni wss
      vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY
      cin c0 wne va vv cv crab wral vy vt wel vy cY wrex vt va cv cY cin c0 wne
      va vv cv crab wral w3a va cv cY cin c0 wne va vv cv crab cfn wcel cY vv
      cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb
      vv cv wral wa cY va cv cY cin c0 wne va vv cv crab cuni wss vb cv vx cv
      vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY cin c0 wne va
      vv cv crab wral vy vt wel vy cY wrex vt va cv cY cin c0 wne va vv cv crab
      wral w3a wi cM cme wcel cY cX wss wa vc cv crp wcel wa vv cv cfn wcel wa
      cY vv cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX
      wrex vb vv cv wral wa cY va cv cY cin c0 wne va vv cv crab cuni wss vb cv
      vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY cin c0
      wne va vv cv crab wral vy vt wel vy cY wrex vt va cv cY cin c0 wne va vv
      cv crab wral cY vv cv cuni wss cY va cv cY cin c0 wne va vv cv crab cuni
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv
      wral vy cv vv cv cuni wcel vy cY wral vy cv va cv cY cin c0 wne va vv cv
      crab cuni wcel vy cY wral cY vv cv cuni wss cY va cv cY cin c0 wne va vv
      cv crab cuni wss vy cv vv cv cuni wcel vy cv va cv cY cin c0 wne va vv cv
      crab cuni wcel vy cY vy cv cY wcel vy vx wel vx vv cv wrex vy vx wel vx
      va cv cY cin c0 wne va vv cv crab wrex vy cv vv cv cuni wcel vy cv va cv
      cY cin c0 wne va vv cv crab cuni wcel vy cv cY wcel vy vx wel vy vx wel
      vx vv cv va cv cY cin c0 wne va vv cv crab vy cv cY wcel vx vv wel vy vx
      wel wa vx cv va cv cY cin c0 wne va vv cv crab wcel vy vx wel vx vv wel
      vy vx wel wa vy cv cY wcel vx cv va cv cY cin c0 wne va vv cv crab wcel
      vx vv wel vy vx wel vy cv cY wcel vx cv va cv cY cin c0 wne va vv cv crab
      wcel vx vv wel vx cv cY cin c0 wne vx cv va cv cY cin c0 wne va vv cv
      crab wcel vy vx wel vy cv cY wcel wa vx cv va cv cY cin c0 wne va vv cv
      crab wcel vx vv wel vx cv cY cin c0 wne wa va cv cY cin c0 wne vx cv cY
      cin c0 wne va vx cv vv cv va vx weq va cv cY cin vx cv cY cin c0 va cv vx
      cv cY ineq1 neeq1d elrab biimpri vy cv vx cv cY inelcm sylan2 anassrs
      expcom vx vv wel vy vx wel wa vy vx wel wi vy cv cY wcel vx vv wel vy vx
      wel pm3.27 a1i jcad r19.22dv2 vx vy cv vv cv eluni2 vx vy cv va cv cY cin
      c0 wne va vv cv crab eluni2 3imtr4g r19.20i vy cY vv cv cuni dfss3 vy cY
      va cv cY cin c0 wne va vv cv crab cuni dfss3 3imtr4i adantr vb cv vx cv
      vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv wral vb cv vx cv
      vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY cin c0 wne va
      vv cv crab wral cY vv cv cuni wss va cv cY cin c0 wne va vv cv crab vv cv
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv
      wral vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv
      cY cin c0 wne va vv cv crab wral wi va cv cY cin c0 wne va vv cv ssrab2
      vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY
      cin c0 wne va vv cv crab vv cv ssralv ax-mp adantl vy vt wel vy cY wrex
      vt va cv cY cin c0 wne va vv cv crab wral cY vv cv cuni wss vb cv vx cv
      vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vy vt wel
      vy cY wrex vt va cv cY cin c0 wne va vv cv crab vt cv va cv cY cin c0 wne
      va vv cv crab wcel vt vv wel vt cv cY cin c0 wne wa vy vt wel vy cY wrex
      va cv cY cin c0 wne vt cv cY cin c0 wne va vt cv vv cv va vt weq va cv cY
      cin vt cv cY cin c0 va cv vt cv cY ineq1 neeq1d elrab vt cv cY cin c0 wne
      vy vt wel vy cY wrex vt vv wel vt cv cY cin c0 wne vy vt wel vy cY wrex
      vy cv vt cv cY cin wcel vy wex vy cv cY wcel vy vt wel wa vy wex vt cv cY
      cin c0 wne vy vt wel vy cY wrex vy cv vt cv cY cin wcel vy cv cY wcel vy
      vt wel wa vy vy cv vt cv cY cin wcel vy vt wel vy cv cY wcel wa vy cv cY
      wcel vy vt wel wa vy cv vt cv cY elin vy vt wel vy cv cY wcel ancom bitri
      exbii vy vt cv cY cin n0 vy vt wel vy cY df-rex 3bitr4i biimpi adantl
      sylbi rgen a1i 3jca a1i vv cv cfn wcel va cv cY cin c0 wne va vv cv crab
      cfn wcel cM cme wcel cY cX wss wa vc cv crp wcel wa vv cv cfn wcel va cv
      cY cin c0 wne va vv cv crab vv cv wss va cv cY cin c0 wne va vv cv crab
      cfn wcel va cv cY cin c0 wne va vv cv ssrab2 vv cv va cv cY cin c0 wne va
      vv cv crab ssfi mpan2 adantl jctild cY vu cv cuni wss vb cv vx cv vc cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral vy vt wel vy cY
      wrex vt vu cv wral w3a cY va cv cY cin c0 wne va vv cv crab cuni wss vb
      cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb va cv cY cin
      c0 wne va vv cv crab wral vy vt wel vy cY wrex vt va cv cY cin c0 wne va
      vv cv crab wral w3a vu va cv cY cin c0 wne va vv cv crab cfn vu cv va cv
      cY cin c0 wne va vv cv crab wceq cY vu cv cuni wss cY va cv cY cin c0 wne
      va vv cv crab cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb va cv cY cin c0 wne va vv cv crab wral vy vt wel vy cY wrex vt
      vu cv wral vy vt wel vy cY wrex vt va cv cY cin c0 wne va vv cv crab wral
      vu cv va cv cY cin c0 wne va vv cv crab wceq vu cv cuni va cv cY cin c0
      wne va vv cv crab cuni cY vu cv va cv cY cin c0 wne va vv cv crab unieq
      sseq2d vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu
      cv va cv cY cin c0 wne va vv cv crab raleq1 vy vt wel vy cY wrex vt vu cv
      va cv cY cin c0 wne va vv cv crab raleq1 3anbi123d rcla4ev syl6 cM cme
      wcel cY cX wss wa vc cv crp wcel wa cY vu cv cuni wss vb cv vx cv vc cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral vy vt wel vy cY
      wrex vt vu cv wral w3a vu cfn wrex vw cv cuni cN cdm cdm wceq vs cv vd cv
      vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex
      wi vv cv cfn wcel cM cme wcel cY cX wss wa vc cv crp wcel wa cY vu cv
      cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu
      cv wral vy vt wel vy cY wrex vt vu cv wral w3a vw cv cuni cN cdm cdm wceq
      vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa
      vw cfn wrex vu cfn cM cme wcel cY cX wss wa vc cv crp wcel wa vu cv cfn
      wcel wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vb vu cv wral vy vt wel vy cY wrex vt vu cv wral vw cv cuni cN
      cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs
      vw cv wral wa vw cfn wrex cM cme wcel cY cX wss wa vc cv crp wcel wa vu
      cv cfn wcel wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vb vu cv wral vy vt wel vy cY wrex vt vu cv wral vw cv
      cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm
      wrex vs vw cv wral wa vw cfn wrex wi cM cme wcel cY cX wss wa vc cv crp
      wcel wa vu cv cfn wcel wa vy vt wel vy cY wrex vt vu cv wral cY vu cv
      cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu
      cv wral wa vw cv cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co
      wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex cM cme wcel cY cX
      wss wa vc cv crp wcel wa vu cv cfn wcel vy vt wel vy cY wrex vt vu cv
      wral cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral wa vw cv cuni cN cdm cdm wceq vs cv vd cv vc cv cN
      cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex wi cM cme
      wcel cY cX wss wa vc cv crp wcel wa vu cv cfn wcel vy vt wel vy cY wrex
      vt vu cv wral wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt
      wel vt vu cv wrex vy vv cv wral w3a vv cfn wrex cY vu cv cuni wss vb cv
      vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa vw
      cv cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm
      cdm wrex vs vw cv wral wa vw cfn wrex wi cM cme wcel cY cX wss wa vu cv
      cfn wcel vy vt wel vy cY wrex vt vu cv wral wa vv cv cY wss vy vt wel vy
      vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a vv cfn
      wrex wi vc cv crp wcel cM cme wcel cY cX wss wa cY cvv wcel vu cv cfn
      wcel vy vt wel vy cY wrex vt vu cv wral wa vv cv cY wss vy vt wel vy vv
      cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a vv cfn
      wrex wi cY cX wss cM cme wcel cY cvv wcel cY cX wss cX cvv wcel cY cvv
      wcel cM cme wcel cY cX cvv ssexg cM cme wcel cM cdm cdm cvv cX cM cme
      wcel cM cdm cvv wcel cM cdm cdm cvv wcel cM cme dmexg cM cdm cvv dmexg
      syl sstotbnd.1 syl5eqel sylan2 ancoms cY cvv wcel vu cv cfn wcel vy vt
      wel vy cY wrex vt vu cv wral wa vv cv cY wss vy vt wel vy vv cv wrex vt
      vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a vv cfn wrex vu cv
      cfn wcel cY cvv wcel vy vt wel vy cY wrex vt vu cv wral vv cv cY wss vy
      vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral
      w3a vv cfn wrex vu cv cfn wcel cY cvv wcel vy vt wel vy cY wrex vt vu cv
      wral vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu
      cv wrex vy vv cv wral w3a vv cfn wrex vy vt wel vt vy vu cv cY cvv vv
      indexf 3expb an1s ex syl adantr cM cme wcel cY cX wss wa vc cv crp wcel
      wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wceq vx cX wrex vb vu cv wral wa vw cv cuni cN cdm cdm wceq vs
      cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw
      cfn wrex wi vv cfn cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel
      vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wceq vx cX wrex vb vu cv wral wa vw cv cuni cN cdm cdm wceq vs
      cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw
      cfn wrex wi wi cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa
      wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wceq vx cX wrex vb vu cv wral wa vw cv cuni cN cdm cdm wceq vs
      cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw
      cfn wrex wi cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa
      vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co
      cM cbl cfv co wceq vx cX wrex vb vu cv wral wa va cv vz cv vc cv cN cbl
      cfv co wceq vz vv cv wrex va cab cfn wcel va cv vz cv vc cv cN cbl cfv co
      wceq vz vv cv wrex va cab cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl
      cfv co wceq vd cN cdm cdm wrex vs va cv vz cv vc cv cN cbl cfv co wceq vz
      vv cv wrex va cab wral wa wa vw cv cuni cN cdm cdm wceq vs cv vd cv vc cv
      cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex cM cme
      wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt
      wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a
      wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral wa va cv vz cv vc cv cN cbl cfv co wceq vz vv cv
      wrex va cab cfn wcel va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex
      va cab cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co wceq vd cN
      cdm cdm wrex vs va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab
      wral wa vc cv crp wcel vv cv cfn wcel wa cY vu cv cuni wss vb cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa va cv vz cv
      vc cv cN cbl cfv co wceq vz vv cv wrex va cab cfn wcel wi cM cme wcel cY
      cX wss wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt
      vu cv wrex vy vv cv wral w3a vv cv cfn wcel cY vu cv cuni wss vb cv vx cv
      vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa va cv vz
      cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab cfn wcel wi vc cv crp
      wcel vv cv cfn wcel va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va
      cab cfn wcel cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vb vu cv wral wa va vz vv cv vz cv vc cv cN cbl cfv co
      firnfi2 a1d adantl ad2antlr cM cme wcel cY cX wss wa vc cv crp wcel vv cv
      cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt
      wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa va cv vz cv
      vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni cN cdm cdm wceq vs cv
      vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs va cv vz cv vc cv cN
      cbl cfv co wceq vz vv cv wrex va cab wral cM cme wcel cY cX wss wa vc cv
      crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu
      cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb
      cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa
      va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni cN cdm cdm
      wceq cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv
      cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy
      vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl
      cfv co wceq vx cX wrex vb vu cv wral wa wa va cv vz cv vc cv cN cbl cfv
      co wceq vz vv cv wrex va cab cuni cY cN cdm cdm cM cme wcel cY cX wss wa
      vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex
      vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv
      wral wa wa va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni
      cY cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY
      wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv
      cv wral w3a wa va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab
      cuni cY wss cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vb vu cv wral wa cM cme wcel cY cX wss wa vc cv crp wcel
      vv cv cfn wcel wa wa vy vt wel vy vv cv wrex vt vu cv wral vv cv cY wss
      va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni cY wss vy
      vt wel vt vu cv wrex vy vv cv wral cM cme wcel cY cX wss wa vc cv crp
      wcel vv cv cY wss va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va
      cab cuni cY wss vv cv cfn wcel cM cme wcel cY cX wss wa vc cv crp wcel wa
      vv cv cY wss wa vx cv cY wss vx va cv vz cv vc cv cN cbl cfv co wceq vz
      vv cv wrex va cab wral va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex
      va cab cuni cY wss cM cme wcel cY cX wss wa vc cv crp wcel wa vv cv cY
      wss wa vx cv cY wss vx va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex
      va cab cM cme wcel cY cX wss wa vc cv crp wcel wa vv cv cY wss wa vx cv
      vz cv vc cv cN cbl cfv co wceq vz vv cv wrex vx cv cY wss vx cv va cv vz
      cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wcel cM cme wcel cY cX
      wss wa vc cv crp wcel wa vv cv cY wss wa vx cv vz cv vc cv cN cbl cfv co
      wceq vx cv cY wss vz vv cv vx cv vz cv vc cv cN cbl cfv co wceq vx cv cY
      wss vz cv vc cv cN cbl cfv co cY wss cM cme wcel cY cX wss wa vc cv crp
      wcel wa vv cv cY wss wa vz vv wel wa vx cv vz cv vc cv cN cbl cfv co cY
      sseq1 cM cme wcel cY cX wss wa vc cv crp wcel wa vv cv cY wss vz vv wel
      vz cv vc cv cN cbl cfv co cY wss cM cme wcel cY cX wss wa vc cv crp wcel
      wa vz cv cY wcel vz cv vc cv cN cbl cfv co cY wss vv cv cY wss vz vv wel
      wa cM cme wcel cY cX wss wa vc cv crp wcel wa vz cv cY wcel vz cv vc cv
      cN cbl cfv co cY wss cM cme wcel cY cX wss wa vc cv crp wcel wa vz cv cN
      cdm cdm wcel vz cv vc cv cN cbl cfv co cN cdm cdm wss wi vz cv cY wcel vz
      cv vc cv cN cbl cfv co cY wss wi cN cme wcel vc cv cr wcel cc0 vc cv clt
      wbr wa vz cv cN cdm cdm wcel vz cv vc cv cN cbl cfv co cN cdm cdm wss wi
      cM cme wcel cY cX wss wa vc cv crp wcel cN cme wcel vc cv cr wcel cc0 vc
      cv clt wbr wa wa vz cv cN cdm cdm wcel vz cv vc cv cN cbl cfv co cN cdm
      cdm wss cN cme wcel vz cv cN cdm cdm wcel vc cv cr wcel cc0 vc cv clt wbr
      wa vz cv vc cv cN cbl cfv co cN cdm cdm wss cN vz cv vc cv cN cdm cdm cN
      cdm cdm eqid blssm an1rs ex cM cme wcel cY cX wss wa cM cY cY cxp cres
      cme cN cM cme wcel cM cY cY cxp cres cme wcel cY cX wss cM cY metres
      adantr sstotbnd.2 syl5eqel vc cv rpregt0 syl2an cM cme wcel cY cX wss wa
      vz cv cN cdm cdm wcel vz cv vc cv cN cbl cfv co cN cdm cdm wss wi vz cv
      cY wcel vz cv vc cv cN cbl cfv co cY wss wi wb vc cv crp wcel cM cme wcel
      cY cX wss wa vz cv cN cdm cdm wcel vz cv cY wcel vz cv vc cv cN cbl cfv
      co cN cdm cdm wss vz cv vc cv cN cbl cfv co cY wss cM cme wcel cY cX wss
      wa cN cdm cdm cY vz cv cM cme wcel cY cX wss wa cY cM cY cY cxp cres cdm
      cdm cN cdm cdm cM cX cY sstotbnd.1 metssba2 cN cdm cM cY cY cxp cres cdm
      cN cM cY cY cxp cres sstotbnd.2 dmeqi dmeqi syl6reqr eleq2d cM cme wcel
      cY cX wss wa cN cdm cdm cY vz cv vc cv cN cbl cfv co cM cme wcel cY cX
      wss wa cY cM cY cY cxp cres cdm cdm cN cdm cdm cM cX cY sstotbnd.1
      metssba2 cN cdm cM cY cY cxp cres cdm cN cM cY cY cxp cres sstotbnd.2
      dmeqi dmeqi syl6reqr sseq2d imbi12d adantr mpbid imp vv cv cY vz cv ssel2
      sylan2 anassrs syl5cbir r19.23adva va cv vz cv vc cv cN cbl cfv co wceq
      vz vv cv wrex vx cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va vx cv
      vx visset va vx weq va cv vz cv vc cv cN cbl cfv co wceq vx cv vz cv vc
      cv cN cbl cfv co wceq vz vv cv va cv vx cv vz cv vc cv cN cbl cfv co
      eqeq1 rexbidv elab syl5ib r19.21aiv vx va cv vz cv vc cv cN cbl cfv co
      wceq vz vv cv wrex va cab cY unissb sylibr adantlrr 3ad2antr1 adantr cM
      cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy
      vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral
      w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vb vu cv wral wa wa vw cY va cv vz cv vc cv cN cbl cfv co wceq
      vz vv cv wrex va cab cuni cM cme wcel cY cX wss wa vc cv crp wcel vv cv
      cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt
      wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa wa vw cv cY
      wcel vw cv va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni
      wcel cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv
      cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy
      vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl
      cfv co wceq vx cX wrex vb vu cv wral wa wa vw cv cY wcel wa vw vd wel vd
      va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex vw cv va
      cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni wcel cM cme
      wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt
      wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a
      wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral wa wa vw cv cY wcel wa vw vs wel vs vu cv wrex vw
      vd wel vd va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex
      cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX
      wrex vb vu cv wral wa vw cv cY wcel vw vs wel vs vu cv wrex cM cme wcel
      cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel
      vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa
      cY vu cv cuni wss vw cv cY wcel vw vs wel vs vu cv wrex vb cv vx cv vc cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral cY vu cv cuni wss
      vw cv cY wcel wa vw cv vu cv cuni wcel vw vs wel vs vu cv wrex cY vu cv
      cuni vw cv ssel2 vs vw cv vu cv eluni2 sylib adantlr adantll cM cme wcel
      cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel
      vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa
      cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX
      wrex vb vu cv wral wa wa vw cv cY wcel wa vw vs wel vw vd wel vd va cv vz
      cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex vs vu cv cM cme
      wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt
      wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a
      wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral wa wa vw cv cY wcel vs vu wel vw vs wel vw vd wel
      vd va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex wi cM
      cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy
      vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral
      w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vb vu cv wral wa wa vw cv cY wcel vs vu wel wa wa vw vs wel vw
      vd wel vd va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex
      cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss
      vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv
      wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vb vu cv wral wa wa vw cv cY wcel vs vu wel wa wa vw vs
      wel wa vr vs wel vr vv cv wrex vw vd wel vd va cv vz cv vc cv cN cbl cfv
      co wceq vz vv cv wrex va cab wrex cM cme wcel cY cX wss wa vc cv crp wcel
      vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral
      vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx
      cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa wa vw
      cv cY wcel vs vu wel wa wa vr vs wel vr vv cv wrex vw vs wel vv cv cY wss
      vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv
      wral w3a cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vb vu cv wral wa vw cv cY wcel vs vu wel wa vr vs wel vr
      vv cv wrex cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa
      vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a vs vu wel vr vs wel vr vv cv wrex cY vu cv cuni
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv
      wral wa vw cv cY wcel vy vt wel vy vv cv wrex vt vu cv wral vv cv cY wss
      vs vu wel vr vs wel vr vv cv wrex vy vt wel vt vu cv wrex vy vv cv wral
      vy vt wel vy vv cv wrex vr vs wel vr vv cv wrex vt vs cv vu cv vt vs weq
      vr vt wel vr vv cv wrex vr vs wel vr vv cv wrex vy vt wel vy vv cv wrex
      vt vs weq vr vt wel vr vs wel vr vv cv vt vs vr elequ2 rexbidv vy vt wel
      vr vt wel vy vr vv cv vy vr vt elequ1 cbvrexv syl5bb rcla4cva 3ad2antl2
      ad2ant2rl adantlll adantr cM cme wcel cY cX wss wa vc cv crp wcel vv cv
      cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt
      wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa wa vw cv cY
      wcel vs vu wel wa wa vw vs wel wa vr vs wel vw vd wel vd va cv vz cv vc
      cv cN cbl cfv co wceq vz vv cv wrex va cab wrex vr vv cv cM cme wcel cY
      cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy
      vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY
      vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vb vu cv wral wa wa vw cv cY wcel vs vu wel wa wa vw vs wel vr vv wel vr
      vs wel vw vd wel vd va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va
      cab wrex wi cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa
      vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co
      cM cbl cfv co wceq vx cX wrex vb vu cv wral wa wa vw cv cY wcel vs vu wel
      wa vw vs wel vr vv wel wa vr vs wel vw vd wel vd va cv vz cv vc cv cN cbl
      cfv co wceq vz vv cv wrex va cab wrex wi cM cme wcel cY cX wss wa vc cv
      crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu
      cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb
      cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa
      wa vw cv cY wcel vs vu wel wa vw vs wel vr vv wel wa wa wa vr vs wel vw
      vd wel vd va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex
      vr cv vc cv cN cbl cfv co va cv vz cv vc cv cN cbl cfv co wceq vz vv cv
      wrex va cab wcel vw cv vr cv vc cv cN cbl cfv co wcel vw vd wel vd va cv
      vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wrex cM cme wcel cY
      cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy
      vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY
      vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vb vu cv wral wa wa vw cv cY wcel vs vu wel wa vw vs wel vr vv wel wa wa
      wa vr vs wel wa vw vd wel vw cv vr cv vc cv cN cbl cfv co wcel vd vr cv
      vc cv cN cbl cfv co va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va
      cab vd cv vr cv vc cv cN cbl cfv co vw cv eleq2 rcla4ev vw cv cY wcel vs
      vu wel wa vw vs wel vr vv wel wa wa vr vs wel vr cv vc cv cN cbl cfv co
      va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wcel cM cme
      wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt
      wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a
      wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral wa wa vw vs wel vr vv wel wa vr cv vc cv cN cbl cfv
      co va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wcel vw cv
      cY wcel vs vu wel wa vr vs wel vr vv wel vr cv vc cv cN cbl cfv co va cv
      vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wcel vw vs wel vr vv
      wel vr cv vc cv cN cbl cfv co vz cv vc cv cN cbl cfv co wceq vz vv cv
      wrex vr cv vc cv cN cbl cfv co va cv vz cv vc cv cN cbl cfv co wceq vz vv
      cv wrex va cab wcel vr vv wel vr cv vc cv cN cbl cfv co vr cv vc cv cN
      cbl cfv co wceq vr cv vc cv cN cbl cfv co vz cv vc cv cN cbl cfv co wceq
      vz vv cv wrex vr cv vc cv cN cbl cfv co eqid vr cv vc cv cN cbl cfv co vz
      cv vc cv cN cbl cfv co wceq vr cv vc cv cN cbl cfv co vr cv vc cv cN cbl
      cfv co wceq vz vr cv vv cv vz vr weq vz cv vc cv cN cbl cfv co vr cv vc
      cv cN cbl cfv co vr cv vc cv cN cbl cfv co vz cv vr cv vc cv cN cbl cfv
      opreq1 eqeq2d rcla4ev mpan2 va cv vz cv vc cv cN cbl cfv co wceq vz vv cv
      wrex vr cv vc cv cN cbl cfv co vz cv vc cv cN cbl cfv co wceq vz vv cv
      wrex va vr cv vc cv cN cbl cfv co vr cv vc cv cN cbl cfv oprex va cv vr
      cv vc cv cN cbl cfv co wceq va cv vz cv vc cv cN cbl cfv co wceq vr cv vc
      cv cN cbl cfv co vz cv vc cv cN cbl cfv co wceq vz vv cv va cv vr cv vc
      cv cN cbl cfv co vz cv vc cv cN cbl cfv co eqeq1 rexbidv elab sylibr
      adantl ad2antlr adantll cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn
      wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel
      vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2
      cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa wa vw cv cY wcel
      vs vu wel wa vw vs wel vr vv wel wa wa wa vr vs wel wa vw cv vr cv vc cv
      cM cbl cfv co cY cin vr cv vc cv cN cbl cfv co vw cv vr cv vc cv cM cbl
      cfv co cY cin wcel vw cv vr cv vc cv cM cbl cfv co wcel vw cv cY wcel cM
      cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy
      vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral
      w3a wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vb vu cv wral wa wa vw cv cY wcel vs vu wel wa vw vs wel vr vv
      wel wa wa wa vr vs wel wa vw cv vr cv vc cv cM cbl cfv co cY elin cM cme
      wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt
      wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a
      wa cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vb vu cv wral wa wa vw cv cY wcel vs vu wel wa vw vs wel vr vv
      wel wa wa vr vs wel vw cv vr cv vc cv cM cbl cfv co wcel cM cme wcel cY
      cX wss wa vc cv crp wcel vv cv cfn wcel wa wa cY vu cv cuni wss vb cv vx
      cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa vw cv
      cY wcel vs vu wel wa vw vs wel vr vv wel wa wa vr vs wel wa vw cv vr cv
      vc cv cM cbl cfv co wcel vv cv cY wss vy vt wel vy vv cv wrex vt vu cv
      wral vy vt wel vt vu cv wrex vy vv cv wral w3a cM cme wcel cY cX wss wa
      vc cv crp wcel vv cv cfn wcel wa wa vb cv vx cv vc cv c2 cdiv co cM cbl
      cfv co wceq vx cX wrex vb vu cv wral vw cv cY wcel vs vu wel wa vw vs wel
      vr vv wel wa wa vr vs wel wa vw cv vr cv vc cv cM cbl cfv co wcel cY vu
      cv cuni wss cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa
      vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral
      wa vs vu wel vw vs wel wa vr vs wel vw cv vr cv vc cv cM cbl cfv co wcel
      vw cv cY wcel vs vu wel wa vw vs wel vr vv wel wa wa cM cme wcel cY cX
      wss wa vc cv crp wcel vv cv cfn wcel wa wa vb cv vx cv vc cv c2 cdiv co
      cM cbl cfv co wceq vx cX wrex vb vu cv wral vs vu wel vw vs wel wa vr vs
      wel wa vw cv vr cv vc cv cM cbl cfv co wcel cM cme wcel cY cX wss wa vc
      cv crp wcel vv cv cfn wcel wa wa vw cv vx cv vc cv c2 cdiv co cM cbl cfv
      co wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel wa vx cX wrex vw
      cv vr cv vc cv cM cbl cfv co wcel vb cv vx cv vc cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vb vu cv wral vs vu wel vw vs wel wa vr vs wel wa wa
      cM cme wcel cY cX wss wa vc cv crp wcel vw cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel wa vx cX
      wrex vw cv vr cv vc cv cM cbl cfv co wcel vv cv cfn wcel cM cme wcel cY
      cX wss wa vc cv crp wcel wa vw cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel wa vx cX wrex vw cv
      vr cv vc cv cM cbl cfv co wcel cM cme wcel cY cX wss wa vc cv crp wcel wa
      vw cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vr cv vx cv vc cv c2 cdiv
      co cM cbl cfv co wcel wa vw cv vr cv vc cv cM cbl cfv co wcel vx cX cM
      cme wcel cY cX wss wa vc cv crp wcel wa vx cv cX wcel wa vr cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wcel vw cv vx cv vc cv c2 cdiv co cM cbl cfv
      co wcel vw cv vr cv vc cv cM cbl cfv co wcel cM cme wcel vc cv crp wcel
      vx cv cX wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vw cv vx cv
      vc cv c2 cdiv co cM cbl cfv co wcel wa vw cv vr cv vc cv cM cbl cfv co
      wcel wi cY cX wss cM cme wcel vc cv crp wcel wa vx cv cX wcel wa vr cv vx
      cv vc cv c2 cdiv co cM cbl cfv co wcel vw cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wcel vw cv vr cv vc cv cM cbl cfv co wcel cM cme wcel vc cv
      crp wcel wa vx cv cX wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel
      vw cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vw cv vr cv vc cv cM cbl
      cfv co wcel wi cM cme wcel vc cv crp wcel wa vx cv cX wcel vr cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wcel wa wa vx cv vc cv c2 cdiv co cM cbl cfv
      co vr cv vc cv cM cbl cfv co vw cv cM cme wcel vx cv cX wcel vc cv crp
      wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vx cv vc cv c2 cdiv
      co cM cbl cfv co vr cv vc cv cM cbl cfv co wss vc cv cM cX vx cv vr cv
      sstotbnd.1 blhalf an4s sseld anassrs expimpd adantllr ancomsd r19.23adva
      imp adantlrr vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vb vu cv wral vs vu wel vw vs wel wa vr vs wel wa wa vs cv vx cv vc cv c2
      cdiv co cM cbl cfv co wceq vx cX wrex vw cv vx cv vc cv c2 cdiv co cM cbl
      cfv co wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel wa vx cX wrex
      vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral
      vs vu wel vw vs wel wa vs cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vr vs wel vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX
      wrex vb vu cv wral vs vu wel vs cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vw vs wel vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq
      vx cX wrex vs cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb
      vs cv vu cv vb vs weq vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vs
      cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX vb cv vs cv vx cv vc
      cv c2 cdiv co cM cbl cfv co eqeq1 rexbidv rcla4cva adantrr adantrr vs vu
      wel vw vs wel wa vr vs wel wa vs cv vx cv vc cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vw cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vr cv vx
      cv vc cv c2 cdiv co cM cbl cfv co wcel wa vx cX wrex wi vb cv vx cv vc cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral vw vs wel vr vs
      wel vs cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vw cv vx
      cv vc cv c2 cdiv co cM cbl cfv co wcel vr cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wcel wa vx cX wrex wi vs vu wel vw vs wel vr vs wel wa vs cv
      vx cv vc cv c2 cdiv co cM cbl cfv co wceq vw cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wcel vr cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel wa vx cX
      vs cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vw vs wel vr vs wel wa vw
      cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vr cv vx cv vc cv c2 cdiv co
      cM cbl cfv co wcel wa vs cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vw
      vs wel vw cv vx cv vc cv c2 cdiv co cM cbl cfv co wcel vr vs wel vr cv vx
      cv vc cv c2 cdiv co cM cbl cfv co wcel vs cv vx cv vc cv c2 cdiv co cM
      cbl cfv co vw cv eleq2 vs cv vx cv vc cv c2 cdiv co cM cbl cfv co vr cv
      eleq2 anbi12d biimpcd r19.22sdv adantll adantl mpd sylan2 anassrs vs vu
      wel vw vs wel vs vu wel vw vs wel wa vw cv cY wcel vr vv wel vs vu wel vw
      vs wel wa id ad2ant2lr sylanr1 adantlrl adantllr anassrs vw cv cY wcel vs
      vu wel wa vw vs wel vr vv wel wa wa vw cv cY wcel cM cme wcel cY cX wss
      wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv
      wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv
      cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu
      cv wral wa wa vr vs wel vw cv cY wcel vs vu wel vw vs wel vr vv wel wa
      simpll ad2antlr sylanbrc cM cme wcel cY cX wss wa vc cv crp wcel vv cv
      cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt
      wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni wss vb cv vx cv vc
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv wral wa wa vw cv cY
      wcel vs vu wel wa vw vs wel vr vv wel wa wa wa vr cv vc cv cN cbl cfv co
      vr cv vc cv cM cbl cfv co cY cin wceq vr vs wel cM cme wcel cY cX wss wa
      vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex
      vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa cY vu cv cuni
      wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb vu cv
      wral wa wa vw vs wel vr vv wel wa vr cv vc cv cN cbl cfv co vr cv vc cv
      cM cbl cfv co cY cin wceq vw cv cY wcel vs vu wel wa cM cme wcel cY cX
      wss wa vc cv crp wcel vv cv cfn wcel wa wa vv cv cY wss vy vt wel vy vv
      cv wrex vt vu cv wral vy vt wel vt vu cv wrex vy vv cv wral w3a wa vr vv
      wel vr cv vc cv cN cbl cfv co vr cv vc cv cM cbl cfv co cY cin wceq cY vu
      cv cuni wss vb cv vx cv vc cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vb
      vu cv wral wa vw vs wel cM cme wcel cY cX wss wa vc cv crp wcel vv cv cfn
      wcel wa wa vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel
      vt vu cv wrex vy vv cv wral w3a vr vv wel vr cv vc cv cN cbl cfv co vr cv
      vc cv cM cbl cfv co cY cin wceq cM cme wcel cY cX wss wa vc cv crp wcel
      vv cv cfn wcel wa wa vr cv cY wcel vr cv vc cv cN cbl cfv co vr cv vc cv
      cM cbl cfv co cY cin wceq vv cv cY wss vy vt wel vy vv cv wrex vt vu cv
      wral vy vt wel vt vu cv wrex vy vv cv wral w3a vr vv wel wa cM cme wcel
      cY cX wss wa vc cv crp wcel vr cv cY wcel vr cv vc cv cN cbl cfv co vr cv
      vc cv cM cbl cfv co cY cin wceq vv cv cfn wcel cM cme wcel cY cX wss wa
      vc cv crp wcel vr cv cY wcel vr cv vc cv cN cbl cfv co vr cv vc cv cM cbl
      cfv co cY cin wceq cM cme wcel cY cX wss wa vr cv cY wcel vc cv crp wcel
      vr cv vc cv cN cbl cfv co vr cv vc cv cM cbl cfv co cY cin wceq vc cv cY
      cM cN cX vr cv sstotbnd.1 sstotbnd.2 blssp ancom2s anassrs adantlrr vv cv
      cY wss vy vt wel vy vv cv wrex vt vu cv wral vr vv wel vr cv cY wcel vy
      vt wel vt vu cv wrex vy vv cv wral vv cv cY vr cv ssel2 3ad2antl1 sylan2
      anassrs ad2ant2rl adantrl adantr eleqtrrd sylanc ex anassrs anassrs
      r19.23adva mpd ex anassrs r19.23adva mpd vd vw cv va cv vz cv vc cv cN
      cbl cfv co wceq vz vv cv wrex va cab eluni2 sylibr ex ssrdv eqssd cM cme
      wcel cY cX wss wa vc cv crp wcel vv cv cfn wcel wa wa cN cdm cdm cY wceq
      vv cv cY wss vy vt wel vy vv cv wrex vt vu cv wral vy vt wel vt vu cv
      wrex vy vv cv wral w3a cY vu cv cuni wss vb cv vx cv vc cv c2 cdiv co cM
      cbl cfv co wceq vx cX wrex vb vu cv wral wa cM cme wcel cY cX wss wa cN
      cdm cdm cY wceq vc cv crp wcel vv cv cfn wcel wa cM cme wcel cY cX wss wa
      cY cM cY cY cxp cres cdm cdm cN cdm cdm cM cX cY sstotbnd.1 metssba2 cN
      cdm cM cY cY cxp cres cdm cN cM cY cY cxp cres sstotbnd.2 dmeqi dmeqi
      syl6reqr adantr ad2antrr eqtr4d ex cM cme wcel cY cX wss wa vc cv crp
      wcel vv cv cfn wcel wa wa vy vt wel vy vv cv wrex vt vu cv wral vv cv cY
      wss vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs va cv vz
      cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wral vy vt wel vt vu cv
      wrex vy vv cv wral cM cme wcel cY cX wss wa vv cv cY wss vs cv vd cv vc
      cv cN cbl cfv co wceq vd cN cdm cdm wrex vs va cv vz cv vc cv cN cbl cfv
      co wceq vz vv cv wrex va cab wral vc cv crp wcel vv cv cfn wcel wa cM cme
      wcel cY cX wss wa vv cv cY wss wa vs cv vd cv vc cv cN cbl cfv co wceq vd
      cN cdm cdm wrex vs va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va
      cab cM cme wcel cY cX wss wa vv cv cY wss wa vs cv vz cv vc cv cN cbl cfv
      co wceq vz vv cv wrex vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm
      wrex vs cv va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex va cab wcel
      cM cme wcel cY cX wss wa vv cv cY wss wa vs cv vd cv vc cv cN cbl cfv co
      wceq vd vv cv wrex vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm
      wrex vs cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex cM cme wcel cY cX
      wss wa vv cv cY wss wa vv cv cN cdm cdm wss vs cv vd cv vc cv cN cbl cfv
      co wceq vd vv cv wrex vs cv vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm
      wrex wi cM cme wcel cY cX wss wa vv cv cN cdm cdm wss vv cv cY wss cM cme
      wcel cY cX wss wa cN cdm cdm cY vv cv cM cme wcel cY cX wss wa cY cM cY
      cY cxp cres cdm cdm cN cdm cdm cM cX cY sstotbnd.1 metssba2 cN cdm cM cY
      cY cxp cres cdm cN cM cY cY cxp cres sstotbnd.2 dmeqi dmeqi syl6reqr
      sseq2d biimpar vs cv vd cv vc cv cN cbl cfv co wceq vd vv cv cN cdm cdm
      ssrexv syl vs cv vz cv vc cv cN cbl cfv co wceq vs cv vd cv vc cv cN cbl
      cfv co wceq vz vd vv cv vz vd weq vz cv vc cv cN cbl cfv co vd cv vc cv
      cN cbl cfv co vs cv vz cv vd cv vc cv cN cbl cfv opreq1 eqeq2d cbvrexv
      syl5ib va cv vz cv vc cv cN cbl cfv co wceq vz vv cv wrex vs cv vz cv vc
      cv cN cbl cfv co wceq vz vv cv wrex va vs cv vs visset va vs weq va cv vz
      cv vc cv cN cbl cfv co wceq vs cv vz cv vc cv cN cbl cfv co wceq vz vv cv
      va cv vs cv vz cv vc cv cN cbl cfv co eqeq1 rexbidv elab syl5ib r19.21aiv
      adantlr 3ad2antr1 jctird jcad vw cv cuni cN cdm cdm wceq vs cv vd cv vc
      cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral wa va cv vz cv vc
      cv cN cbl cfv co wceq vz vv cv wrex va cab cuni cN cdm cdm wceq vs cv vd
      cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs va cv vz cv vc cv cN
      cbl cfv co wceq vz vv cv wrex va cab wral wa vw va cv vz cv vc cv cN cbl
      cfv co wceq vz vv cv wrex va cab cfn vw cv va cv vz cv vc cv cN cbl cfv
      co wceq vz vv cv wrex va cab wceq vw cv cuni cN cdm cdm wceq va cv vz cv
      vc cv cN cbl cfv co wceq vz vv cv wrex va cab cuni cN cdm cdm wceq vs cv
      vd cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs vw cv wral vs cv vd
      cv vc cv cN cbl cfv co wceq vd cN cdm cdm wrex vs va cv vz cv vc cv cN
      cbl cfv co wceq vz vv cv wrex va cab wral vw cv va cv vz cv vc cv cN cbl
      cfv co wceq vz vv cv wrex va cab wceq vw cv cuni va cv vz cv vc cv cN cbl
      cfv co wceq vz vv cv wrex va cab cuni cN cdm cdm vw cv va cv vz cv vc cv
      cN cbl cfv co wceq vz vv cv wrex va cab unieq eqeq1d vs cv vd cv vc cv cN
      cbl cfv co wceq vd cN cdm cdm wrex vs vw cv va cv vz cv vc cv cN cbl cfv
      co wceq vz vv cv wrex va cab raleq1 anbi12d rcla4ev syl6 ex anassrs
      r19.23adva syld expdimp com23 exp3a 3impd r19.23adva adantr syld
      r19.23adva syld r19.21adva cM cme wcel cY cX wss wa cN cme wcel cN
      ctotbnd wcel vw cv cuni cN cdm cdm wceq vs cv vd cv vc cv cN cbl cfv co
      wceq vd cN cdm cdm wrex vs vw cv wral wa vw cfn wrex vc crp wral wb cM
      cme wcel cY cX wss wa cM cY cY cxp cres cme cN cM cme wcel cM cY cY cxp
      cres cme wcel cY cX wss cM cY metres adantr sstotbnd.2 syl5eqel vd vw cN
      cN cdm cdm vs vc cN cdm cdm eqid istotbnd2 syl sylibrd impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M n p q r s t u v w x y z $.
    $d X n p q r s t u v w x y z $.
    $d S n p q r s t u v w x y z $.
    totbndss.1 $e |- X = dom dom M $.
    $( A subset of a totally bounded metric space is totally bounded. $)
    totbndss $p |- ( ( M e. Met /\ M e. TotBnd /\ S C_ X ) ->
                                      ( M |` ( S X. S ) ) e. TotBnd ) $=
      cM cme wcel cM ctotbnd wcel cS cX wss cM cS cS cxp cres ctotbnd wcel cM
      cme wcel cS cX wss cM ctotbnd wcel cM cS cS cxp cres ctotbnd wcel cM cme
      wcel cS cX wss cM ctotbnd wcel cM cS cS cxp cres ctotbnd wcel wi cM cme
      wcel cS cX wss wa vv cv cuni cX wceq vz cv vx cv vq cv cM cbl cfv co wceq
      vx cX wrex vz vv cv wral wa vv cfn wrex vq crp wral vw cv cuni cM cS cS
      cxp cres cdm cdm wceq vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq
      vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral wa vw cfn wrex vr crp
      wral cM ctotbnd wcel cM cS cS cxp cres ctotbnd wcel cM cme wcel cS cX wss
      wa vv cv cuni cX wceq vz cv vx cv vq cv cM cbl cfv co wceq vx cX wrex vz
      vv cv wral wa vv cfn wrex vq crp wral vw cv cuni cM cS cS cxp cres cdm
      cdm wceq vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS
      cxp cres cdm cdm wrex vy vw cv wral wa vw cfn wrex vr crp cM cme wcel cS
      cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vq cv cM cbl
      cfv co wceq vx cX wrex vz vv cv wral wa vv cfn wrex vq crp wral vv cv
      cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vz vv cv wral wa vv cfn wrex vw cv cuni cM cS cS cxp cres cdm cdm wceq vy
      cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm
      cdm wrex vy vw cv wral wa vw cfn wrex vr cv crp wcel vv cv cuni cX wceq
      vz cv vx cv vq cv cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vv cfn
      wrex vq crp wral vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl
      cfv co wceq vx cX wrex vz vv cv wral wa vv cfn wrex wi cM cme wcel cS cX
      wss wa vr cv crp wcel vr cv c2 cdiv co crp wcel vv cv cuni cX wceq vz cv
      vx cv vq cv cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vv cfn wrex vq
      crp wral vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vz vv cv wral wa vv cfn wrex wi vr cv crp wcel c2 crp
      wcel vr cv c2 cdiv co crp wcel c2 2re 2pos elrpii vr cv c2 rpdivcl mpan2
      vv cv cuni cX wceq vz cv vx cv vq cv cM cbl cfv co wceq vx cX wrex vz vv
      cv wral wa vv cfn wrex vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM
      cbl cfv co wceq vx cX wrex vz vv cv wral wa vv cfn wrex vq vr cv c2 cdiv
      co crp vq cv vr cv c2 cdiv co wceq vv cv cuni cX wceq vz cv vx cv vq cv
      cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vv cv cuni cX wceq vz cv
      vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vv
      cfn vq cv vr cv c2 cdiv co wceq vz cv vx cv vq cv cM cbl cfv co wceq vx
      cX wrex vz vv cv wral vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vz vv cv wral vv cv cuni cX wceq vq cv vr cv c2 cdiv co wceq vz
      cv vx cv vq cv cM cbl cfv co wceq vx cX wrex vz cv vx cv vr cv c2 cdiv co
      cM cbl cfv co wceq vx cX wrex vz vv cv vq cv vr cv c2 cdiv co wceq vz cv
      vx cv vq cv cM cbl cfv co wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX vq cv vr cv c2 cdiv co wceq vx cv vq cv cM cbl cfv co vx cv vr
      cv c2 cdiv co cM cbl cfv co vz cv vq cv vr cv c2 cdiv co vx cv cM cbl cfv
      opreq2 eqeq2d rexbidv ralbidv anbi2d rexbidv rcla4v syl adantl cM cme
      wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vw cv cuni cM
      cS cS cxp cres cdm cdm wceq vy cv vu cv vr cv cM cS cS cxp cres cbl cfv
      co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral wa vw cfn wrex vv
      cfn cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cfn wcel wa vv cv
      cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vz vv cv wral wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr
      cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin
      c0 wne vp vv cv crab wral vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp vv cv crab
      wrex vy vw cv wral w3a vw cfn wrex vw cv cuni cM cS cS cxp cres cdm cdm
      wceq vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp
      cres cdm cdm wrex vy vw cv wral wa vw cfn wrex cM cme wcel cS cX wss wa
      vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vw cv cS cpw
      wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu
      cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv
      cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex
      wa vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv wral w3a vw cfn
      wrex vp cv cS cin c0 wne vp vv cv crab cfn wcel cS cpw cvv wcel vt cv cS
      cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa
      vy cS cpw wrex vt vp cv cS cin c0 wne vp vv cv crab wral vw cv cS cpw wss
      vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv cS
      cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa
      vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv wral w3a vw cfn wrex
      cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni
      cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv
      cv wral wa wa vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vt vy vp cv cS cin c0 wne vp vv cv crab cS cpw cvv
      vw indexf vv cv cfn wcel vp cv cS cin c0 wne vp vv cv crab cfn wcel cM
      cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vv cv cfn
      wcel vp cv cS cin c0 wne vp vv cv crab vv cv wss vp cv cS cin c0 wne vp
      vv cv crab cfn wcel vp cv cS cin c0 wne vp vv cv ssrab2 vv cv vp cv cS
      cin c0 wne vp vv cv crab ssfi mpan2 ad2antlr cM cme wcel cS cX wss wa vr
      cv crp wcel wa vv cv cuni cX wceq cS cpw cvv wcel vv cv cfn wcel vz cv vx
      cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral cM cme
      wcel cS cX wss wa cS cpw cvv wcel vr cv crp wcel vv cv cuni cX wceq cM
      cme wcel cS cX wss wa cS cvv wcel cS cpw cvv wcel cM cme wcel cX cvv wcel
      cS cX wss cS cvv wcel cM cme wcel cM cdm cdm cvv cX cM cme wcel cM cdm
      cvv wcel cM cdm cdm cvv wcel cM cme dmexg cM cdm cvv dmexg syl totbndss.1
      syl5eqel cS cX wss cX cvv wcel cS cvv wcel cS cX cvv ssexg ex mpan9 cS
      cvv pwexg syl ad2antrr ad2ant2r cM cme wcel cS cX wss wa vr cv crp wcel
      wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx
      cX wrex vz vv cv wral wa vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex vt vp cv cS cin c0 wne vp
      vv cv crab wral vv cv cfn wcel cM cme wcel cS cX wss wa vr cv crp wcel wa
      vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX
      wrex vz vv cv wral wa wa vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex vt vp cv cS cin c0 wne vp
      vv cv crab cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq
      vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral
      wa wa vt cv vv cv wcel vt cv cS cin c0 wne wa vt cv cS cin vy cv wss vy
      cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex vt
      cv vp cv cS cin c0 wne vp vv cv crab wcel cM cme wcel cS cX wss wa vr cv
      crp wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vz vv cv wral wa wa vt cv vv cv wcel vt cv cS cin c0 wne
      vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy cS cpw wrex cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv
      cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vz vv cv wral wa wa vt cv vv cv wcel wa vw cv vt cv cS cin wcel vw wex vt
      cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy cS cpw wrex vt cv cS cin c0 wne cM cme wcel cS cX wss wa vr cv
      crp wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vz vv cv wral wa wa vt cv vv cv wcel wa vw cv vt cv cS
      cin wcel vw wex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vy cS cpw wrex cM cme wcel cS cX wss wa vr cv crp
      wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vz vv cv wral wa vt cv vv cv wcel vw cv vt cv cS cin wcel
      vw wex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq
      vu cS wrex wa vy cS cpw wrex wi cM cme wcel cS cX wss wa vr cv crp wcel
      wa vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vw cv vt cv
      cS cin wcel vw wex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex wa vy cS cpw wrex wi vv cv cuni cX wceq vz cv vx
      cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vt cv
      vv cv wcel wa cM cme wcel cS cX wss wa vr cv crp wcel wa vt cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex wa vw cv vt cv cS cin wcel vt
      cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy cS cpw wrex vw cM cme wcel cS cX wss wa vr cv crp wcel wa vt
      cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex wa vw cv vt cv cS
      cin wcel vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy cS cpw wrex cM cme wcel cS cX wss wa vr cv crp wcel
      wa vw cv vt cv cS cin wcel vt cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vy cS cpw wrex cM cme wcel cS cX wss wa vr cv crp
      wcel wa vw cv vt cv cS cin wcel wa vt cv vx cv vr cv c2 cdiv co cM cbl
      cfv co wceq vx cX wrex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex cM cme wcel cS cX wss wa
      vr cv crp wcel wa vw cv vt cv cS cin wcel wa vt cv vx cv vr cv c2 cdiv co
      cM cbl cfv co wceq vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex wa vy cS cpw wrex vx cX cM cme wcel cS cX wss wa
      vr cv crp wcel wa vw cv vt cv cS cin wcel wa vx cv cX wcel wa vt cv vx cv
      vr cv c2 cdiv co cM cbl cfv co wceq vw cv vx cv vr cv c2 cdiv co cM cbl
      cfv co wcel vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy cS cpw wrex vw cv vt cv cS cin wcel vt cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vw cv vx cv vr cv c2 cdiv co cM cbl cfv
      co wcel wi cM cme wcel cS cX wss wa vr cv crp wcel wa vx cv cX wcel vt cv
      vx cv vr cv c2 cdiv co cM cbl cfv co wceq vw cv vt cv wcel vw cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wcel vw cv vt cv cS cin wcel vt cv vx cv vr
      cv c2 cdiv co cM cbl cfv co vw cv eleq2 vt cv cS cin vt cv vw cv vt cv cS
      inss1 sseli syl5cbi ad2antlr cM cme wcel cS cX wss wa vr cv crp wcel wa
      vw cv vt cv cS cin wcel wa vx cv cX wcel wa vw cv vx cv vr cv c2 cdiv co
      cM cbl cfv co wcel vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv
      cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex
      wa vy cS cpw wrex cM cme wcel cS cX wss wa vr cv crp wcel wa vw cv vt cv
      cS cin wcel wa vx cv cX wcel vw cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wcel vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv cS cin vy cv
      wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS cpw
      wrex wi wi cM cme wcel cS cX wss wa vr cv crp wcel vw cv vt cv cS cin
      wcel vx cv cX wcel vw cv vx cv vr cv c2 cdiv co cM cbl cfv co wcel vt cv
      vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv cS cin vy cv wss vy cv vu
      cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex wi wi wi
      cM cme wcel vr cv crp wcel cS cX wss vw cv vt cv cS cin wcel vx cv cX
      wcel vw cv vx cv vr cv c2 cdiv co cM cbl cfv co wcel vt cv vx cv vr cv c2
      cdiv co cM cbl cfv co wceq vt cv cS cin vy cv wss vy cv vu cv vr cv cM
      cbl cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex wi wi wi cM cme wcel
      vr cv crp wcel wa cS cX wss vw cv vt cv cS cin wcel wa wa vx cv cX wcel
      vw cv vx cv vr cv c2 cdiv co cM cbl cfv co wcel vt cv vx cv vr cv c2 cdiv
      co cM cbl cfv co wceq vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv
      co cS cin wceq vu cS wrex wa vy cS cpw wrex wi cM cme wcel vr cv crp wcel
      wa cS cX wss vw cv vt cv cS cin wcel wa vx cv cX wcel vw cv vx cv vr cv
      c2 cdiv co cM cbl cfv co wcel wa vt cv vx cv vr cv c2 cdiv co cM cbl cfv
      co wceq vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy cS cpw wrex wi wi cM cme wcel vr cv crp wcel wa vx
      cv cX wcel vw cv vx cv vr cv c2 cdiv co cM cbl cfv co wcel wa cS cX wss
      vw cv vt cv cS cin wcel wa vt cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq
      vu cS wrex wa vy cS cpw wrex wi cM cme wcel vr cv crp wcel wa vx cv cX
      wcel vw cv vx cv vr cv c2 cdiv co cM cbl cfv co wcel wa cS cX wss vw cv
      vt cv cS cin wcel wa vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt
      cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy cS cpw wrex wi wi cM cme wcel vx cv cX wcel vr cv crp wcel vw
      cv vx cv vr cv c2 cdiv co cM cbl cfv co wcel cS cX wss vw cv vt cv cS cin
      wcel wa vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv cS cin vy
      cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS
      cpw wrex wi wi cM cme wcel vx cv cX wcel wa vr cv crp wcel vw cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wcel wa wa vx cv vr cv c2 cdiv co cM cbl cfv
      co vw cv vr cv cM cbl cfv co wss cS cX wss vw cv vt cv cS cin wcel wa vt
      cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv cS cin vy cv wss vy cv
      vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex wi wi
      vr cv cM cX vx cv vw cv totbndss.1 blhalf cM cme wcel vx cv vr cv c2 cdiv
      co cM cbl cfv co vw cv vr cv cM cbl cfv co wss cS cX wss vw cv vt cv cS
      cin wcel wa vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv cS cin
      vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS
      cpw wrex wi wi wi vx cv cX wcel vr cv crp wcel vw cv vx cv vr cv c2 cdiv
      co cM cbl cfv co wcel wa cM cme wcel vx cv vr cv c2 cdiv co cM cbl cfv co
      vw cv vr cv cM cbl cfv co wss cS cX wss vw cv vt cv cS cin wcel wa vt cv
      vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv cS cin vy cv wss vy cv vu
      cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex vw cv vr
      cv cM cbl cfv co cS cin cS cpw wcel vt cv cS cin vw cv vr cv cM cbl cfv
      co cS cin wss vw cv vr cv cM cbl cfv co cS cin vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vy cS cpw wrex cM cme wcel vx cv vr cv
      c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl cfv co wss cS cX wss vw cv vt
      cv cS cin wcel wa w3a vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq wa
      vw cv vr cv cM cbl cfv co cS cin cS cpw wcel cM cme wcel vx cv vr cv c2
      cdiv co cM cbl cfv co vw cv vr cv cM cbl cfv co wss cS cX wss vw cv vt cv
      cS cin wcel wa w3a vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq wa vw
      cv vr cv cM cbl cfv co cS cin cS cpw wcel vw cv vr cv cM cbl cfv co cS
      cin cS wss vw cv vr cv cM cbl cfv co cS inss2 vw cv vr cv cM cbl cfv co
      cS cin cS vw cv vr cv cM cbl cfv co cS vw cv vr cv cM cbl cfv oprex inex1
      elpw mpbir a1i vx cv vr cv c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl
      cfv co wss cM cme wcel vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt
      cv cS cin vw cv vr cv cM cbl cfv co cS cin wss cS cX wss vw cv vt cv cS
      cin wcel wa vx cv vr cv c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl cfv
      co wss vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq wa vt cv vw cv vr
      cv cM cbl cfv co wss vt cv cS cin vw cv vr cv cM cbl cfv co cS cin wss vt
      cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv vw cv vr cv cM cbl cfv
      co wss vx cv vr cv c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl cfv co wss
      vt cv vx cv vr cv c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl cfv co
      sseq1 biimparc vt cv vw cv vr cv cM cbl cfv co cS ssrin syl 3ad2antl2 cM
      cme wcel vx cv vr cv c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl cfv co
      wss cS cX wss vw cv vt cv cS cin wcel wa w3a vw cv vr cv cM cbl cfv co cS
      cin vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex vt cv vx cv vr cv c2
      cdiv co cM cbl cfv co wceq cS cX wss vw cv vt cv cS cin wcel wa cM cme
      wcel vw cv vr cv cM cbl cfv co cS cin vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex vx cv vr cv c2 cdiv co cM cbl cfv co vw cv vr cv cM cbl
      cfv co wss vw cv vt cv cS cin wcel vw cv vr cv cM cbl cfv co cS cin vu cv
      vr cv cM cbl cfv co cS cin wceq vu cS wrex cS cX wss vw cv cS wcel vw cv
      vr cv cM cbl cfv co cS cin vw cv vr cv cM cbl cfv co cS cin wceq vw cv vr
      cv cM cbl cfv co cS cin vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex
      vw cv vt cv cS cin wcel vw cv vr cv cM cbl cfv co cS cin vu cv vr cv cM
      cbl cfv co cS cin wceq vw cv vr cv cM cbl cfv co cS cin vw cv vr cv cM
      cbl cfv co cS cin wceq vu vw cv cS vu cv vw cv wceq vu cv vr cv cM cbl
      cfv co cS cin vw cv vr cv cM cbl cfv co cS cin vw cv vr cv cM cbl cfv co
      cS cin vu cv vw cv wceq vu cv vr cv cM cbl cfv co vw cv vr cv cM cbl cfv
      co cS vu cv vw cv vr cv cM cbl cfv opreq1 ineq1d eqeq2d rcla4ev vt cv cS
      cin cS vw cv vt cv cS inss2 sseli vw cv vt cv cS cin wcel vw cv vr cv cM
      cbl cfv co cS cin eqidd sylanc adantl 3ad2ant3 adantr vt cv cS cin vy cv
      wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt cv cS
      cin vw cv vr cv cM cbl cfv co cS cin wss vw cv vr cv cM cbl cfv co cS cin
      vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv vr cv cM cbl
      cfv co cS cin cS cpw vy cv vw cv vr cv cM cbl cfv co cS cin wceq vt cv cS
      cin vy cv wss vt cv cS cin vw cv vr cv cM cbl cfv co cS cin wss vy cv vu
      cv vr cv cM cbl cfv co cS cin wceq vu cS wrex vw cv vr cv cM cbl cfv co
      cS cin vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex vy cv vw cv vr cv
      cM cbl cfv co cS cin vt cv cS cin sseq2 vy cv vw cv vr cv cM cbl cfv co
      cS cin wceq vy cv vu cv vr cv cM cbl cfv co cS cin wceq vw cv vr cv cM
      cbl cfv co cS cin vu cv vr cv cM cbl cfv co cS cin wceq vu cS vy cv vw cv
      vr cv cM cbl cfv co cS cin vu cv vr cv cM cbl cfv co cS cin eqeq1 rexbidv
      anbi12d rcla4ev sylan32c 3exp1 ad2antrr mpd an4s ex com23 imp exp3a an4s
      anassrs imp com23 mpdd r19.23adva imp an1rs ex 19.23adv vz cv vx cv vr cv
      c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral vt cv vv cv wcel
      vt cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vv cv cuni cX
      wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vt cv vx
      cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vt cv vv cv vz cv vt
      cv wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vt cv vx cv vr cv
      c2 cdiv co cM cbl cfv co wceq vx cX vz cv vt cv vx cv vr cv c2 cdiv co cM
      cbl cfv co eqeq1 rexbidv rcla4cva adantll sylan2 anassrs imp vw vt cv cS
      cin n0 sylan2b anasss vp cv cS cin c0 wne vt cv cS cin c0 wne vp vt cv vv
      cv vp cv vt cv wceq vp cv cS cin vt cv cS cin c0 vp cv vt cv cS ineq1
      neeq1d elrab sylan2b r19.21aiva adantlr syl3anc ex cM cme wcel cS cX wss
      wa vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vw cv cS cpw
      wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu
      cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv
      cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex
      wa vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv wral w3a vw cfn
      wrex vw cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vu cv vr cv cM cS cS
      cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral
      wa vw cfn wrex wi cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cfn
      wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co
      wceq vx cX wrex vz vv cv wral wa wa vw cv cS cpw wss vt cv cS cin vy cv
      wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv
      wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv cS cin vy cv wss vy
      cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0
      wne vp vv cv crab wrex vy vw cv wral w3a vw cv cuni cM cS cS cxp cres cdm
      cdm wceq vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS
      cxp cres cdm cdm wrex vy vw cv wral wa vw cfn cM cme wcel cS cX wss wa vr
      cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2
      cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cfn wcel
      wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv
      co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv
      cv crab wral vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv
      wral w3a vw cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vu cv vr cv cM
      cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv
      wral cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cfn wcel wa vv cv
      cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vz vv cv wral wa wa vw cv cfn wcel wa vw cv cS cpw wss vt cv cS cin vy cv
      wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv
      wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv cS cin vy cv wss vy
      cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0
      wne vp vv cv crab wrex vy vw cv wral w3a vw cv cuni cS wceq vw cv cuni cM
      cS cS cxp cres cdm cdm wceq cM cme wcel cS cX wss wa vr cv crp wcel wa vv
      cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vz vv cv wral wa wa vw cv cfn wcel wa vw cv cS cpw wss
      vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv cS
      cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa
      vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv wral w3a vw cv cuni cS
      wss cS vw cv cuni wss wa vw cv cuni cS wceq cM cme wcel cS cX wss wa vr
      cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2
      cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cfn wcel
      wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv
      co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv
      cv crab wral vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv
      wral w3a vw cv cuni cS wss cS vw cv cuni wss vw cv cS cpw wss vt cv cS
      cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa
      vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral vt cv cS cin vy
      cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv
      cS cin c0 wne vp vv cv crab wrex vy vw cv wral w3a vw cv cuni cS wss wi
      cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni
      cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv
      cv wral wa wa vw cv cfn wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss
      vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex
      vt vp cv cS cin c0 wne vp vv cv crab wral vw cv cuni cS wss vt cv cS cin
      vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp
      cv cS cin c0 wne vp vv cv crab wrex vy vw cv wral vw cv cS cpw wss vw cv
      cuni cS cpw cuni cS vw cv cS cpw uniss cS unipw syl6ss 3ad2ant1 a1i cM
      cme wcel cS cX wss wa vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX
      wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv
      wral wa wa vw cv cfn wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss vy
      cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt
      vp cv cS cin c0 wne vp vv cv crab wral vt cv cS cin vy cv wss vy cv vu cv
      vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp
      vv cv crab wrex vy vw cv wral w3a cS vw cv cuni wss cM cme wcel cS cX wss
      wa vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cfn
      wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp
      vv cv crab wral cS vw cv cuni wss vt cv cS cin vy cv wss vy cv vu cv vr
      cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp vv
      cv crab wrex vy vw cv wral cM cme wcel cS cX wss wa vr cv crp wcel wa vv
      cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vz vv cv wral wa wa vw cv cS cpw wss vt cv cS cin vy
      cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv
      wrex vt vp cv cS cin c0 wne vp vv cv crab wral wa cS vw cv cuni wss vw cv
      cfn wcel cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz
      cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa
      vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv
      crab wral wa cS vw cv cuni wss vv cv cfn wcel cM cme wcel cS cX wss wa vr
      cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vz vv cv wral wa wa vw cv cS cpw wss vt cv cS cin vy
      cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv
      wrex vt vp cv cS cin c0 wne vp vv cv crab wral wa wa vn cS vw cv cuni cM
      cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cS
      cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab
      wral wa wa vn cv cS wcel vn cv cX wcel vn cv vw cv cuni wcel cM cme wcel
      cS cX wss wa vr cv crp wcel wa vn cv cS wcel vn cv cX wcel wi vv cv cuni
      cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv
      cv wral wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM
      cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne
      vp vv cv crab wral wa cS cX wss vn cv cS wcel vn cv cX wcel wi cM cme
      wcel vr cv crp wcel cS cX vn cv ssel ad2antlr ad2antrr cM cme wcel cS cX
      wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co
      cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cS cpw wss vt cv
      cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex
      wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral wa wa vn cv cS
      wcel vn cv cX wcel vn cv vw cv cuni wcel wi cM cme wcel cS cX wss wa vr
      cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv
      co wceq vx cX wrex vz vv cv wral wa wa vw cv cS cpw wss vt cv cS cin vy
      cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv
      wrex vt vp cv cS cin c0 wne vp vv cv crab wral wa wa vn cv cS wcel wa vn
      cv cX wcel vn cv vs cv wcel vs cv vv cv wcel wa vs wex vn cv vw cv cuni
      wcel cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv
      vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa
      vn cv cX wcel vn cv vs cv wcel vs cv vv cv wcel wa vs wex wi vw cv cS cpw
      wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu
      cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral wa vn
      cv cS wcel vv cv cuni cX wceq vn cv cX wcel vn cv vs cv wcel vs cv vv cv
      wcel wa vs wex wi cM cme wcel cS cX wss wa vr cv crp wcel wa vz cv vx cv
      vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral vv cv cuni
      cX wceq vn cv cX wcel vn cv vv cv cuni wcel vn cv vs cv wcel vs cv vv cv
      wcel wa vs wex vv cv cuni cX wceq vn cv vv cv cuni wcel vn cv cX wcel vv
      cv cuni cX vn cv eleq2 biimprd vs vn cv vv cv eluni syl6ib ad2antrl
      ad2antrr cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz
      cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa
      wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv
      co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv
      cv crab wral wa wa vn cv cS wcel wa vn cv vs cv wcel vs cv vv cv wcel wa
      vn cv vw cv cuni wcel vs cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv
      cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex
      vz vv cv wral wa wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv
      vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS
      cin c0 wne vp vv cv crab wral wa wa vn cv cS wcel wa vn cv vs cv wcel vs
      cv vv cv wcel wa vs cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex wa vy vw cv wrex vn cv vw cv cuni wcel vw cv cS
      cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab
      wral wa vn cv cS wcel vn cv vs cv wcel vs cv vv cv wcel wa vs cv cS cin
      vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw
      cv wrex wi cM cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq
      vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral
      wa wa vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq
      vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral vn
      cv cS wcel vn cv vs cv wcel vs cv vv cv wcel wa vs cv cS cin vy cv wss vy
      cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex wi
      vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv
      crab wral vn cv cS wcel vn cv vs cv wcel vs cv vv cv wcel wa vs cv cS cin
      vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw
      cv wrex vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab
      wral vs cv vp cv cS cin c0 wne vp vv cv crab wcel vs cv cS cin vy cv wss
      vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex
      vn cv cS wcel vn cv vs cv wcel vs cv vv cv wcel wa wa vt cv cS cin vy cv
      wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv
      wrex vs cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq
      vu cS wrex wa vy vw cv wrex vt vs cv vp cv cS cin c0 wne vp vv cv crab vt
      cv vs cv wceq vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vs cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vy vw cv vt cv vs cv wceq vt cv cS cin
      vy cv wss vs cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex vt cv vs cv wceq vt cv cS cin vs cv cS cin vy cv vt cv vs
      cv cS ineq1 sseq1d anbi1d rexbidv rcla4cv vs cv vv cv wcel vn cv vs cv
      wcel vn cv cS wcel vs cv vp cv cS cin c0 wne vp vv cv crab wcel vs cv vv
      cv wcel vs cv cS cin c0 wne vs cv vp cv cS cin c0 wne vp vv cv crab wcel
      vn cv vs cv wcel vn cv cS wcel wa vs cv vp cv cS cin c0 wne vp vv cv crab
      wcel vs cv vv cv wcel vs cv cS cin c0 wne wa vp cv cS cin c0 wne vs cv cS
      cin c0 wne vp vs cv vv cv vp cv vs cv wceq vp cv cS cin vs cv cS cin c0
      vp cv vs cv cS ineq1 neeq1d elrab biimpri vn cv vs cv cS inelcm sylan2
      ancom13s syl5 expdimp adantll adantll vn cv cS wcel vn cv vs cv wcel vs
      cv vv cv wcel wa vs cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co
      cS cin wceq vu cS wrex wa vy vw cv wrex vn cv vw cv cuni wcel wi wi cM
      cme wcel cS cX wss wa vr cv crp wcel wa vv cv cuni cX wceq vz cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cS
      cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin
      wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab
      wral wa wa vn cv cS wcel vn cv vs cv wcel vs cv vv cv wcel wa vs cv cS
      cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa
      vy vw cv wrex vn cv vw cv cuni wcel wi vn cv cS wcel vn cv vs cv wcel vs
      cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS
      wrex wa vy vw cv wrex vn cv vw cv cuni wcel wi vs cv vv cv wcel vn cv vs
      cv wcel vn cv cS wcel vs cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv
      co cS cin wceq vu cS wrex wa vy vw cv wrex vn cv vw cv cuni wcel wi vn cv
      vs cv wcel vn cv cS wcel wa vs cv cS cin vy cv wss vy cv vu cv vr cv cM
      cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vn cv vy cv wcel vy vw
      cv wrex vn cv vw cv cuni wcel vn cv vs cv wcel vn cv cS wcel wa vs cv cS
      cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa
      vn cv vy cv wcel vy vw cv vn cv vs cv wcel vn cv cS wcel wa vs cv cS cin
      vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex vn cv vy
      cv wcel vn cv vs cv wcel vn cv cS wcel wa vs cv cS cin vy cv wss wa vn cv
      vy cv wcel vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex vs cv
      cS cin vy cv wss vn cv vs cv wcel vn cv cS wcel wa vn cv vy cv wcel vs cv
      cS cin vy cv wss vn cv vs cv cS cin wcel vn cv vy cv wcel vn cv vs cv
      wcel vn cv cS wcel wa vs cv cS cin vy cv vn cv ssel2 vn cv vs cv cS elin
      sylan2br ancoms a1d expimpd r19.22sdv vy vn cv vw cv eluni2 syl6ibr
      ancoms adantrr ex adantl mpdd 19.23adv syld ex mpdd ssrdv adantllr
      adantlr 3adantr3 ex jcad vw cv cuni cS eqss syl6ibr cM cme wcel cS cX wss
      wa vr cv crp wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vz cv vx cv vr
      cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv cv wral wa wa vw cv cfn
      wcel wa cS cM cS cS cxp cres cdm cdm vw cv cuni cM cme wcel cS cX wss wa
      vr cv crp wcel wa vv cv cfn wcel wa cS cM cS cS cxp cres cdm cdm wceq vv
      cv cuni cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX
      wrex vz vv cv wral wa vw cv cfn wcel cM cme wcel cS cX wss wa cS cM cS cS
      cxp cres cdm cdm wceq vr cv crp wcel vv cv cfn wcel cM cX cS totbndss.1
      metssba2 ad2antrr ad2antrr eqeq2d sylibd cM cme wcel cS cX wss wa vr cv
      crp wcel wa vv cv cfn wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss vy
      cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt
      vp cv cS cin c0 wne vp vv cv crab wral vt cv cS cin vy cv wss vy cv vu cv
      vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp
      vv cv crab wrex vy vw cv wral w3a vy cv vu cv vr cv cM cS cS cxp cres cbl
      cfv co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral wi vv cv cuni
      cX wceq vz cv vx cv vr cv c2 cdiv co cM cbl cfv co wceq vx cX wrex vz vv
      cv wral wa vw cv cfn wcel cM cme wcel cS cX wss wa vr cv crp wcel wa vw
      cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS
      cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0 wne vp vv cv crab
      wral vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq
      vu cS wrex wa vt vp cv cS cin c0 wne vp vv cv crab wrex vy vw cv wral w3a
      vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres
      cdm cdm wrex vy vw cv wral wi vv cv cfn wcel cM cme wcel cS cX wss wa vr
      cv crp wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv vr cv
      cM cbl cfv co cS cin wceq vu cS wrex wa vy vw cv wrex vt vp cv cS cin c0
      wne vp vv cv crab wral vt cv cS cin vy cv wss vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp vv cv crab
      wrex vy vw cv wral w3a vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co
      wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral cM cme wcel cS cX
      wss wa vr cv crp wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu
      cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne
      vp vv cv crab wrex vy vw cv wral vy cv vu cv vr cv cM cS cS cxp cres cbl
      cfv co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral vt cv cS cin
      vy cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy vw
      cv wrex vt vp cv cS cin c0 wne vp vv cv crab wral cM cme wcel cS cX wss
      wa vr cv crp wcel wa vw cv cS cpw wss vt cv cS cin vy cv wss vy cv vu cv
      vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0 wne vp
      vv cv crab wrex vy vw cv wral vy cv vu cv vr cv cM cS cS cxp cres cbl cfv
      co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral cM cme wcel cS cX
      wss wa vr cv crp wcel wa vw cv cS cpw wss wa vt cv cS cin vy cv wss vy cv
      vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vt vp cv cS cin c0
      wne vp vv cv crab wrex vy cv vu cv vr cv cM cS cS cxp cres cbl cfv co
      wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv cM cme wcel cS cX wss wa
      vr cv crp wcel wa vw cv cS cpw wss wa vy cv vw cv wcel wa vt cv cS cin vy
      cv wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cv vu
      cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm cdm
      wrex vt vp cv cS cin c0 wne vp vv cv crab cM cme wcel cS cX wss wa vr cv
      crp wcel wa vw cv cS cpw wss wa vy cv vw cv wcel wa vt cv cS cin vy cv
      wss vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex wa vy cv vu cv
      vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm cdm wrex
      wi vt cv vp cv cS cin c0 wne vp vv cv crab wcel cM cme wcel cS cX wss wa
      vr cv crp wcel wa vw cv cS cpw wss wa vy cv vw cv wcel wa vy cv vu cv vr
      cv cM cbl cfv co cS cin wceq vu cS wrex vy cv vu cv vr cv cM cS cS cxp
      cres cbl cfv co wceq vu cM cS cS cxp cres cdm cdm wrex vt cv cS cin vy cv
      wss cM cme wcel cS cX wss wa vr cv crp wcel wa vw cv cS cpw wss wa vy cv
      vw cv wcel wa vy cv vu cv vr cv cM cbl cfv co cS cin wceq vu cS wrex vy
      cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cS wrex vy cv vu cv
      vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm cdm wrex
      cM cme wcel cS cX wss wa vr cv crp wcel wa vw cv cS cpw wss wa vy cv vw
      cv wcel wa vy cv vu cv vr cv cM cbl cfv co cS cin wceq vy cv vu cv vr cv
      cM cS cS cxp cres cbl cfv co wceq vu cS cM cme wcel cS cX wss wa vr cv
      crp wcel wa vw cv cS cpw wss wa vy cv vw cv wcel wa vu cv cS wcel wa vy
      cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vy cv vu cv vr cv cM cbl
      cfv co cS cin wceq cM cme wcel cS cX wss wa vr cv crp wcel wa vw cv cS
      cpw wss wa vy cv vw cv wcel wa vu cv cS wcel wa vu cv vr cv cM cS cS cxp
      cres cbl cfv co vu cv vr cv cM cbl cfv co cS cin vy cv cM cme wcel cS cX
      wss wa vr cv crp wcel wa vw cv cS cpw wss wa vu cv cS wcel vu cv vr cv cM
      cS cS cxp cres cbl cfv co vu cv vr cv cM cbl cfv co cS cin wceq vy cv vw
      cv wcel cM cme wcel cS cX wss wa vr cv crp wcel wa vu cv cS wcel vu cv vr
      cv cM cS cS cxp cres cbl cfv co vu cv vr cv cM cbl cfv co cS cin wceq vw
      cv cS cpw wss cM cme wcel cS cX wss wa vr cv crp wcel vu cv cS wcel vu cv
      vr cv cM cS cS cxp cres cbl cfv co vu cv vr cv cM cbl cfv co cS cin wceq
      cM cme wcel cS cX wss wa vu cv cS wcel vr cv crp wcel vu cv vr cv cM cS
      cS cxp cres cbl cfv co vu cv vr cv cM cbl cfv co cS cin wceq vr cv cS cM
      cM cS cS cxp cres cX vu cv totbndss.1 cM cS cS cxp cres eqid blssp
      ancom2s anassrs adantlr adantlr eqeq2d biimprd r19.22dva cM cme wcel cS
      cX wss wa vr cv crp wcel wa vw cv cS cpw wss wa vy cv vw cv wcel wa vy cv
      vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cS cM cS cS cxp cres cdm
      cdm cM cme wcel cS cX wss wa vr cv crp wcel wa cS cM cS cS cxp cres cdm
      cdm wceq vw cv cS cpw wss vy cv vw cv wcel cM cme wcel cS cX wss wa cS cM
      cS cS cxp cres cdm cdm wceq vr cv crp wcel cM cX cS totbndss.1 metssba2
      adantr ad2antrr rexeq1d sylibd adantld adantr r19.23adva r19.20dva impr
      3adantr2 ex adantr ad2antrr jcad r19.22dva ex mpdd r19.23adva syld
      r19.21adva cM cme wcel cM ctotbnd wcel vv cv cuni cX wceq vz cv vx cv vq
      cv cM cbl cfv co wceq vx cX wrex vz vv cv wral wa vv cfn wrex vq crp wral
      wb cS cX wss vx vv cM cX vz vq totbndss.1 istotbnd2 adantr cM cme wcel cM
      cS cS cxp cres ctotbnd wcel vw cv cuni cM cS cS cxp cres cdm cdm wceq vy
      cv vu cv vr cv cM cS cS cxp cres cbl cfv co wceq vu cM cS cS cxp cres cdm
      cdm wrex vy vw cv wral wa vw cfn wrex vr crp wral wb cS cX wss cM cme
      wcel cM cS cS cxp cres cme wcel cM cS cS cxp cres ctotbnd wcel vw cv cuni
      cM cS cS cxp cres cdm cdm wceq vy cv vu cv vr cv cM cS cS cxp cres cbl
      cfv co wceq vu cM cS cS cxp cres cdm cdm wrex vy vw cv wral wa vw cfn
      wrex vr crp wral wb cM cS metres vu vw cM cS cS cxp cres cM cS cS cxp
      cres cdm cdm vy vr cM cS cS cxp cres cdm cdm eqid istotbnd2 syl adantr
      3imtr4d ex com23 3imp $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d m x r $.
    $( Define the class of bounded metrics. A metric space is bounded iff it
       can be covered by a single ball. $)
    df-bnd $a |- Bnd = { m e. Met | A. x e. dom dom m E. r e. RR+
                                          dom dom m = ( x ( ball ` m ) r ) } $.
  $}

  ${
    $d M m x r $. $d X m x r $.
    isbnd.1 $e |- X = dom dom M $.
    $( The predicate "is a bounded metric space". $)
    isbnd $p |- ( M e. Bnd <-> ( M e. Met /\ A. x e. X E. r e. RR+
                            X = ( x ( ball ` M ) r ) ) ) $=
      vm cv cdm cdm vx cv vr cv vm cv cbl cfv co wceq vr crp wrex vx vm cv cdm
      cdm wral cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX wral vm cM
      cme cbnd vm cv cM wceq vm cv cdm cdm vx cv vr cv vm cv cbl cfv co wceq vr
      crp wrex cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx vm cv cdm cdm
      cX vm cv cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm cv cdm cM
      cdm vm cv cM dmeq dmeqd isbnd.1 syl6eqr vm cv cM wceq vm cv cdm cdm vx cv
      vr cv vm cv cbl cfv co wceq cX vx cv vr cv cM cbl cfv co wceq vr crp vm
      cv cM wceq vm cv cdm cdm cX vx cv vr cv vm cv cbl cfv co vx cv vr cv cM
      cbl cfv co vm cv cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm cv
      cdm cM cdm vm cv cM dmeq dmeqd isbnd.1 syl6eqr vm cv cM wceq vm cv cbl
      cfv cM cbl cfv vx cv vr cv vm cv cM cbl fveq2 opreqd eqeq12d rexbidv
      raleq12d vx vm vr df-bnd elrab2 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M m x r $. $d X m x r $.
    isbnd2.1 $e |- X = dom dom M $.
    $( The predicate "is a bounded metric space". $)
    isbnd2 $p |- ( M e. Met -> ( M e. Bnd <->
                        A. x e. X E. r e. RR+ X = ( x ( ball ` M ) r ) ) ) $=
      cM cbnd wcel cM cme wcel cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx
      cX wral vx cM cX vr isbnd2.1 isbnd baib $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M x y r s $. $d X x y r s $.
    isbnd3.1 $e |- X = dom dom M $.
    $( The predicate "is a bounded metric space". Uses a single point instead
       of an arbitrary point in the space. $)
    isbnd3 $p |- ( ( M e. Bnd /\ X =/= (/) ) <-> ( M e. Met /\
                E. x e. X E. r e. RR+ X = ( x ( ball ` M ) r ) ) ) $=
      cM cbnd wcel cX c0 wne wa cM cme wcel cX vx cv vr cv cM cbl cfv co wceq
      vr crp wrex vx cX wral wa cX c0 wne wa cM cme wcel cX vx cv vr cv cM cbl
      cfv co wceq vr crp wrex vx cX wral cX c0 wne wa wa cM cme wcel cX vx cv
      vr cv cM cbl cfv co wceq vr crp wrex vx cX wrex wa cM cbnd wcel cM cme
      wcel cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX wral wa cX c0
      wne vx cM cX vr isbnd3.1 isbnd anbi1i cM cme wcel cX vx cv vr cv cM cbl
      cfv co wceq vr crp wrex vx cX wral cX c0 wne anass cM cme wcel cX vx cv
      vr cv cM cbl cfv co wceq vr crp wrex vx cX wral cX c0 wne wa cX vx cv vr
      cv cM cbl cfv co wceq vr crp wrex vx cX wrex cM cme wcel cX vx cv vr cv
      cM cbl cfv co wceq vr crp wrex vx cX wral cX c0 wne wa cX vx cv vr cv cM
      cbl cfv co wceq vr crp wrex vx cX wrex cX c0 wne cX vx cv vr cv cM cbl
      cfv co wceq vr crp wrex vx cX wral cX vx cv vr cv cM cbl cfv co wceq vr
      crp wrex vx cX wrex cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX
      r19.2z ancoms cM cme wcel cX vx cv vr cv cM cbl cfv co wceq vr crp wrex
      vx cX wrex cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX wral cX c0
      wne cM cme wcel cX vy cv vs cv cM cbl cfv co wceq vs crp wrex vy cX wrex
      cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX wral cX vx cv vr cv
      cM cbl cfv co wceq vr crp wrex vx cX wrex cM cme wcel cX vy cv vs cv cM
      cbl cfv co wceq cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX wral
      vy vs cX crp cM cme wcel vy cv cX wcel vs cv crp wcel wa cX vy cv vs cv
      cM cbl cfv co wceq cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX
      wral wi cM cme wcel vy cv cX wcel vs cv crp wcel wa wa cX vy cv vs cv cM
      cbl cfv co wceq cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cX cM
      cme wcel vy cv cX wcel vs cv crp wcel wa wa vx cv cX wcel wa cX vy cv vs
      cv cM cbl cfv co wceq cX vx cv vr cv cM cbl cfv co wceq vr crp wrex c2 vs
      cv cmul co crp wcel cX vx cv c2 vs cv cmul co cM cbl cfv co wceq cX vx cv
      vr cv cM cbl cfv co wceq vr crp wrex cM cme wcel vy cv cX wcel vs cv crp
      wcel wa wa vx cv cX wcel wa cX vy cv vs cv cM cbl cfv co wceq wa cX vx cv
      vr cv cM cbl cfv co wceq cX vx cv c2 vs cv cmul co cM cbl cfv co wceq vr
      c2 vs cv cmul co crp vr cv c2 vs cv cmul co wceq vx cv vr cv cM cbl cfv
      co vx cv c2 vs cv cmul co cM cbl cfv co cX vr cv c2 vs cv cmul co vx cv
      cM cbl cfv opreq2 eqeq2d rcla4ev cM cme wcel vy cv cX wcel vs cv crp wcel
      wa wa c2 vs cv cmul co crp wcel vx cv cX wcel cX vy cv vs cv cM cbl cfv
      co wceq vs cv crp wcel c2 vs cv cmul co crp wcel cM cme wcel vy cv cX
      wcel c2 crp wcel vs cv crp wcel c2 vs cv cmul co crp wcel c2 2re 2pos
      elrpii c2 vs cv rpmulcl mpan ad2antll ad2antrr cM cme wcel vy cv cX wcel
      vs cv crp wcel wa wa vx cv cX wcel wa cX vy cv vs cv cM cbl cfv co wceq
      wa cX vx cv c2 vs cv cmul co cM cbl cfv co cM cme wcel vy cv cX wcel vs
      cv crp wcel wa wa vx cv cX wcel wa cX vy cv vs cv cM cbl cfv co wceq cX
      vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wceq cX vx cv c2 vs cv
      cmul co cM cbl cfv co wss cM cme wcel vy cv cX wcel vs cv crp wcel wa wa
      vx cv cX wcel wa cX vy cv vs cv cM cbl cfv co wceq cX vy cv c2 vs cv cmul
      co c2 cdiv co cM cbl cfv co wceq cM cme wcel vy cv cX wcel vs cv crp wcel
      wa wa cX vy cv vs cv cM cbl cfv co wceq cX vy cv c2 vs cv cmul co c2 cdiv
      co cM cbl cfv co wceq wi vx cv cX wcel vs cv crp wcel cX vy cv vs cv cM
      cbl cfv co wceq cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wceq
      wi cM cme wcel vy cv cX wcel vs cv crp wcel cX vy cv vs cv cM cbl cfv co
      wceq cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wceq vs cv crp
      wcel vy cv vs cv cM cbl cfv co vy cv c2 vs cv cmul co c2 cdiv co cM cbl
      cfv co cX vs cv crp wcel vs cv c2 vs cv cmul co c2 cdiv co vy cv cM cbl
      cfv vs cv cc wcel c2 cc wcel c2 cc0 wne vs cv c2 vs cv cmul co c2 cdiv co
      wceq vs cv crp wcel vs cv cc wcel c2 cc wcel c2 cc0 wne w3a c2 vs cv cmul
      co c2 cdiv co vs cv vs cv c2 divcan3 eqcomd vs cv rpcn c2 cc wcel vs cv
      crp wcel 2cn a1i c2 cc0 wne vs cv crp wcel 2ne0 a1i syl3anc opreq2d
      eqeq2d biimpd ad2antll adantr imp cM cme wcel vy cv cX wcel vs cv crp
      wcel wa wa vx cv cX wcel wa cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl
      cfv co wceq wa cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co vx cv
      c2 vs cv cmul co cM cbl cfv co cM cme wcel vy cv cX wcel vs cv crp wcel
      wa wa vx cv cX wcel wa cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co
      wceq pm3.27 cM cme wcel vy cv cX wcel vs cv crp wcel wa wa vx cv cX wcel
      cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wceq vy cv c2 vs cv
      cmul co c2 cdiv co cM cbl cfv co vx cv c2 vs cv cmul co cM cbl cfv co wss
      cM cme wcel vy cv cX wcel vs cv crp wcel wa wa vx cv vy cv c2 vs cv cmul
      co c2 cdiv co cM cbl cfv co wcel vy cv c2 vs cv cmul co c2 cdiv co cM cbl
      cfv co vx cv c2 vs cv cmul co cM cbl cfv co wss vx cv cX wcel cX vy cv c2
      vs cv cmul co c2 cdiv co cM cbl cfv co wceq wa cM cme wcel vy cv cX wcel
      vs cv crp wcel wa wa vx cv vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv
      co wcel vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co vx cv c2 vs cv
      cmul co cM cbl cfv co wss cM cme wcel vy cv cX wcel vs cv crp wcel vx cv
      vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wcel vy cv c2 vs cv cmul
      co c2 cdiv co cM cbl cfv co vx cv c2 vs cv cmul co cM cbl cfv co wss wi
      cM cme wcel vy cv cX wcel wa c2 vs cv cmul co crp wcel vx cv vy cv c2 vs
      cv cmul co c2 cdiv co cM cbl cfv co wcel vy cv c2 vs cv cmul co c2 cdiv
      co cM cbl cfv co vx cv c2 vs cv cmul co cM cbl cfv co wss wi vs cv crp
      wcel cM cme wcel vy cv cX wcel wa c2 vs cv cmul co crp wcel vx cv vy cv
      c2 vs cv cmul co c2 cdiv co cM cbl cfv co wcel vy cv c2 vs cv cmul co c2
      cdiv co cM cbl cfv co vx cv c2 vs cv cmul co cM cbl cfv co wss c2 vs cv
      cmul co cM cX vy cv vx cv isbnd3.1 blhalf expr c2 crp wcel vs cv crp wcel
      c2 vs cv cmul co crp wcel c2 2re 2pos elrpii c2 vs cv rpmulcl mpan sylan2
      anasss imp cX vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wceq vx cv
      cX wcel vx cv vy cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co wcel cX vy
      cv c2 vs cv cmul co c2 cdiv co cM cbl cfv co vx cv eleq2 biimpac sylan2
      anassrs eqsstrd syldan cM cme wcel vy cv cX wcel vs cv crp wcel wa wa vx
      cv cX wcel wa vx cv c2 vs cv cmul co cM cbl cfv co cX wss cX vy cv vs cv
      cM cbl cfv co wceq cM cme wcel vs cv crp wcel vx cv cX wcel vx cv c2 vs
      cv cmul co cM cbl cfv co cX wss vy cv cX wcel cM cme wcel vx cv cX wcel
      vs cv crp wcel vx cv c2 vs cv cmul co cM cbl cfv co cX wss cM cme wcel vx
      cv cX wcel wa c2 vs cv cmul co cr wcel cc0 c2 vs cv cmul co clt wbr wa vx
      cv c2 vs cv cmul co cM cbl cfv co cX wss vs cv crp wcel cM vx cv c2 vs cv
      cmul co cX isbnd3.1 blssm vs cv crp wcel c2 vs cv cmul co crp wcel c2 vs
      cv cmul co cr wcel cc0 c2 vs cv cmul co clt wbr wa c2 crp wcel vs cv crp
      wcel c2 vs cv cmul co crp wcel c2 2re 2pos elrpii c2 vs cv rpmulcl mpan
      c2 vs cv cmul co elrp sylib sylan2 an1rs adantlrl adantr eqssd sylanc ex
      r19.21adva ex r19.23advv cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vx
      cX wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wrex cX vy cv
      vs cv cM cbl cfv co wceq vs crp wrex vy cX wrex cX vx cv vr cv cM cbl cfv
      co wceq vr crp wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vx vy
      cX vx cv vy cv wceq cX vx cv vr cv cM cbl cfv co wceq cX vy cv vr cv cM
      cbl cfv co wceq vr crp vx cv vy cv wceq vx cv vr cv cM cbl cfv co vy cv
      vr cv cM cbl cfv co cX vx cv vy cv vr cv cM cbl cfv opreq1 eqeq2d rexbidv
      cbvrexv cX vy cv vr cv cM cbl cfv co wceq vr crp wrex cX vy cv vs cv cM
      cbl cfv co wceq vs crp wrex vy cX cX vy cv vr cv cM cbl cfv co wceq cX vy
      cv vs cv cM cbl cfv co wceq vr vs crp vr cv vs cv wceq vy cv vr cv cM cbl
      cfv co vy cv vs cv cM cbl cfv co cX vr cv vs cv vy cv cM cbl cfv opreq2
      eqeq2d cbvrexv rexbii bitri syl5ib cX vx cv vr cv cM cbl cfv co wceq vr
      crp wrex vx cX wrex cX c0 wne wi cM cme wcel cX vx cv vr cv cM cbl cfv co
      wceq vr crp wrex vx cX rexn0 a1i jcad impbid2 pm5.32i 3bitri $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M x y r $. $d X x y r $. $d S x y r $.
    bndss.1 $e |- X = dom dom M $.
    $( A subset of a bounded metric space is bounded. $)
    bndss $p |- ( ( M e. Bnd /\ S C_ X ) -> ( M |` ( S X. S ) ) e. Bnd ) $=
      cM cme wcel cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wral wa
      cS cX wss wa cM cS cS cxp cres cme wcel cM cS cS cxp cres cdm cdm vx cv
      vr cv cM cS cS cxp cres cbl cfv co wceq vr crp wrex vx cM cS cS cxp cres
      cdm cdm wral wa cM cbnd wcel cS cX wss wa cM cS cS cxp cres cbnd wcel cM
      cme wcel cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wral wa cS
      cX wss wa cM cS cS cxp cres cme wcel cM cS cS cxp cres cdm cdm vx cv vr
      cv cM cS cS cxp cres cbl cfv co wceq vr crp wrex vx cM cS cS cxp cres cdm
      cdm wral cM cme wcel cM cS cS cxp cres cme wcel cX vy cv vr cv cM cbl cfv
      co wceq vr crp wrex vy cX wral cS cX wss cM cS metres ad2antrr cM cme
      wcel cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wral wa cS cX
      wss wa cM cS cS cxp cres cdm cdm vx cv vr cv cM cS cS cxp cres cbl cfv co
      wceq vr crp wrex vx cM cS cS cxp cres cdm cdm cM cme wcel cX vy cv vr cv
      cM cbl cfv co wceq vr crp wrex vy cX wral wa cS cX wss wa vx cv cM cS cS
      cxp cres cdm cdm wcel vx cv cS wcel cM cS cS cxp cres cdm cdm vx cv vr cv
      cM cS cS cxp cres cbl cfv co wceq vr crp wrex cM cme wcel cS cX wss vx cv
      cM cS cS cxp cres cdm cdm wcel vx cv cS wcel cX vy cv vr cv cM cbl cfv co
      wceq vr crp wrex vy cX wral cM cme wcel cS cX wss wa vx cv cS wcel vx cv
      cM cS cS cxp cres cdm cdm wcel cM cme wcel cS cX wss wa cS cM cS cS cxp
      cres cdm cdm vx cv cM cX cS bndss.1 metssba2 eleq2d biimpar adantllr cM
      cme wcel cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wral wa vx
      cv cS wcel cS cX wss cM cS cS cxp cres cdm cdm vx cv vr cv cM cS cS cxp
      cres cbl cfv co wceq vr crp wrex cM cme wcel cX vy cv vr cv cM cbl cfv co
      wceq vr crp wrex vy cX wral wa vx cv cS wcel wa cS cX wss cM cS cS cxp
      cres cdm cdm vx cv vr cv cM cS cS cxp cres cbl cfv co wceq vr crp wrex cM
      cme wcel vx cv cS wcel cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy
      cX wral cS cX wss cM cS cS cxp cres cdm cdm vx cv vr cv cM cS cS cxp cres
      cbl cfv co wceq vr crp wrex wi cM cme wcel vx cv cS wcel wa cX vy cv vr
      cv cM cbl cfv co wceq vr crp wrex vy cX wral wa cS cX wss cM cS cS cxp
      cres cdm cdm vx cv vr cv cM cS cS cxp cres cbl cfv co wceq vr crp wrex cM
      cme wcel vx cv cS wcel wa cS cX wss cX vy cv vr cv cM cbl cfv co wceq vr
      crp wrex vy cX wral cM cS cS cxp cres cdm cdm vx cv vr cv cM cS cS cxp
      cres cbl cfv co wceq vr crp wrex cM cme wcel vx cv cS wcel wa cS cX wss
      wa cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wral cX vx cv vr
      cv cM cbl cfv co wceq vr crp wrex cM cS cS cxp cres cdm cdm vx cv vr cv
      cM cS cS cxp cres cbl cfv co wceq vr crp wrex vx cv cS wcel cS cX wss cX
      vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX wral cX vx cv vr cv cM
      cbl cfv co wceq vr crp wrex cM cme wcel vx cv cX wcel cX vy cv vr cv cM
      cbl cfv co wceq vr crp wrex vy cX wral cX vx cv vr cv cM cbl cfv co wceq
      vr crp wrex vx cv cS wcel cS cX wss wa cX vy cv vr cv cM cbl cfv co wceq
      vr crp wrex cX vx cv vr cv cM cbl cfv co wceq vr crp wrex vy vx cv cX vy
      cv vx cv wceq cX vy cv vr cv cM cbl cfv co wceq cX vx cv vr cv cM cbl cfv
      co wceq vr crp vy cv vx cv wceq vy cv vr cv cM cbl cfv co vx cv vr cv cM
      cbl cfv co cX vy cv vx cv vr cv cM cbl cfv opreq1 eqeq2d rexbidv rcla4va
      cS cX wss vx cv cS wcel vx cv cX wcel cS cX vx cv ssel2 ancoms sylan
      adantlll cM cme wcel vx cv cS wcel wa cS cX wss wa cX vx cv vr cv cM cbl
      cfv co wceq vr crp wrex cM cS cS cxp cres cdm cdm vx cv vr cv cM cS cS
      cxp cres cbl cfv co wceq vr crp wrex cM cme wcel vx cv cS wcel wa cS cX
      wss wa cX vx cv vr cv cM cbl cfv co wceq cM cS cS cxp cres cdm cdm vx cv
      vr cv cM cS cS cxp cres cbl cfv co wceq vr crp cM cme wcel vx cv cS wcel
      wa cS cX wss wa vr cv crp wcel wa cX vx cv vr cv cM cbl cfv co wceq cM cS
      cS cxp cres cdm cdm vx cv vr cv cM cS cS cxp cres cbl cfv co wceq cM cme
      wcel vx cv cS wcel wa cS cX wss wa vr cv crp wcel wa cX vx cv vr cv cM
      cbl cfv co wceq wa vx cv vr cv cM cS cS cxp cres cbl cfv co vx cv vr cv
      cM cbl cfv co cS cin cS cM cS cS cxp cres cdm cdm cM cme wcel vx cv cS
      wcel wa cS cX wss wa vr cv crp wcel wa vx cv vr cv cM cS cS cxp cres cbl
      cfv co vx cv vr cv cM cbl cfv co cS cin wceq cX vx cv vr cv cM cbl cfv co
      wceq cM cme wcel vx cv cS wcel wa cS cX wss vr cv crp wcel vx cv vr cv cM
      cS cS cxp cres cbl cfv co vx cv vr cv cM cbl cfv co cS cin wceq cM cme
      wcel cS cX wss vx cv cS wcel vr cv crp wcel vx cv vr cv cM cS cS cxp cres
      cbl cfv co vx cv vr cv cM cbl cfv co cS cin wceq vr cv cS cM cM cS cS cxp
      cres cX vx cv bndss.1 cM cS cS cxp cres eqid blssp an4s anassrs adantr cM
      cme wcel vx cv cS wcel wa cS cX wss wa cX vx cv vr cv cM cbl cfv co wceq
      cS vx cv vr cv cM cbl cfv co cS cin wceq vr cv crp wcel cS cX wss cX vx
      cv vr cv cM cbl cfv co wceq cS vx cv vr cv cM cbl cfv co cS cin wceq cM
      cme wcel vx cv cS wcel wa cS cX wss cX vx cv vr cv cM cbl cfv co wceq cS
      cX cS cin vx cv vr cv cM cbl cfv co cS cin cS cX wss cS cS cX cin cX cS
      cin cS cX wss cS cS cX cin wceq cS cX dfss biimpi cS cX incom syl6eq cX
      vx cv vr cv cM cbl cfv co cS ineq1 sylan9eq adantll adantlr cM cme wcel
      vx cv cS wcel wa cS cX wss wa cS cM cS cS cxp cres cdm cdm wceq vr cv crp
      wcel cX vx cv vr cv cM cbl cfv co wceq cM cme wcel cS cX wss cS cM cS cS
      cxp cres cdm cdm wceq vx cv cS wcel cM cX cS bndss.1 metssba2 adantlr
      ad2antrr 3eqtr2rd ex r19.22dva imp syldan an1rs ex an1rs imp an1rs syldan
      r19.21aiva jca cM cbnd wcel cM cme wcel cX vy cv vr cv cM cbl cfv co wceq
      vr crp wrex vy cX wral wa cS cX wss vy cM cX vr bndss.1 isbnd anbi1i vx
      cM cS cS cxp cres cM cS cS cxp cres cdm cdm vr cM cS cS cxp cres cdm cdm
      eqid isbnd 3imtr4i $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M x r $. $d X x r $. $d Y x r $. $d R x r $.
    blbnd.1 $e |- X = dom dom M $.
    $( A ball is bounded. $)
    blbnd $p |- ( ( M e. Met /\ Y e. X /\ R e. RR+ ) ->
          ( M |` ( ( Y ( ball ` M ) R ) X. ( Y ( ball ` M ) R ) ) ) e. Bnd ) $=
      cM cme wcel cY cX wcel cR crp wcel w3a cM cY cR cM cbl cfv co cY cR cM
      cbl cfv co cxp cres cbnd wcel cM cY cR cM cbl cfv co cY cR cM cbl cfv co
      cxp cres cdm cdm c0 wne cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp
      cres cbnd wcel cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm
      cdm c0 wne wa cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cme
      wcel cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm vx cv vr
      cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq vr
      crp wrex vx cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm
      wrex cM cme wcel cY cX wcel cR crp wcel w3a vx cM cY cR cM cbl cfv co cY
      cR cM cbl cfv co cxp cres cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp
      cres cdm cdm vr cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm
      cdm eqid isbnd3 cM cme wcel cY cX wcel cM cY cR cM cbl cfv co cY cR cM
      cbl cfv co cxp cres cme wcel cR crp wcel cM cY cR cM cbl cfv co metres
      3ad2ant1 cY cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm
      wcel cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm cY vr cv
      cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq vr
      crp wrex cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm vx
      cv vr cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co
      wceq vr crp wrex vx cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres
      cdm cdm wrex cM cme wcel cY cX wcel cR crp wcel w3a cM cY cR cM cbl cfv
      co cY cR cM cbl cfv co cxp cres cdm cdm vx cv vr cv cM cY cR cM cbl cfv
      co cY cR cM cbl cfv co cxp cres cbl cfv co wceq vr crp wrex cM cY cR cM
      cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm cY vr cv cM cY cR cM cbl
      cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq vr crp wrex vx cY cM
      cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm vx cv cY wceq cM
      cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm vx cv vr cv cM
      cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq cM cY cR
      cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm cY vr cv cM cY cR cM
      cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq vr crp vx cv cY
      wceq vx cv vr cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl
      cfv co cY vr cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl
      cfv co cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm vx cv
      cY vr cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv
      opreq1 eqeq2d rexbidv rcla4ev cM cme wcel cY cX wcel cR crp wcel w3a cY
      cY cR cM cbl cfv co cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres
      cdm cdm cM cme wcel cY cX wcel cR crp wcel cY cY cR cM cbl cfv co wcel cM
      cme wcel cY cX wcel wa cR cr wcel cc0 cR clt wbr wa cY cY cR cM cbl cfv
      co wcel cR crp wcel cM cY cR cX blbnd.1 blcntr cR elrp sylan2b 3impa cM
      cme wcel cY cR cM cbl cfv co cX wss cY cR cM cbl cfv co cM cY cR cM cbl
      cfv co cY cR cM cbl cfv co cxp cres cdm cdm wceq cM cme wcel cY cX wcel
      cR crp wcel w3a cM cX cY cR cM cbl cfv co blbnd.1 metssba2 cM cme wcel cY
      cX wcel cR crp wcel 3simp1 cM cme wcel cY cX wcel cR crp wcel cY cR cM
      cbl cfv co cX wss cM cme wcel cY cX wcel wa cR cr wcel cc0 cR clt wbr wa
      cY cR cM cbl cfv co cX wss cR crp wcel cM cY cR cX blbnd.1 blssm cR elrp
      sylan2b 3impa sylanc eleqtrd cR crp wcel cM cY cR cM cbl cfv co cY cR cM
      cbl cfv co cxp cres cdm cdm cY cR cM cY cR cM cbl cfv co cY cR cM cbl cfv
      co cxp cres cbl cfv co wceq cM cY cR cM cbl cfv co cY cR cM cbl cfv co
      cxp cres cdm cdm cY vr cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp
      cres cbl cfv co wceq vr crp wrex cM cme wcel cY cX wcel cR crp wcel w3a
      cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm cY vr cv cM
      cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq cM cY cR
      cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm cY cR cM cY cR cM cbl
      cfv co cY cR cM cbl cfv co cxp cres cbl cfv co wceq vr cR crp vr cv cR
      wceq cY vr cv cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv
      co cY cR cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co
      cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm cdm vr cv cR cY
      cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv opreq2 eqeq2d
      rcla4ev cM cme wcel cY cX wcel cR crp wcel 3simp3 cM cme wcel cY cX wcel
      cR crp wcel w3a cY cR cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres
      cbl cfv co cY cR cM cbl cfv co cM cY cR cM cbl cfv co cY cR cM cbl cfv co
      cxp cres cdm cdm cM cme wcel cY cX wcel cR crp wcel w3a cY cR cM cY cR cM
      cbl cfv co cY cR cM cbl cfv co cxp cres cbl cfv co cY cR cM cbl cfv co cY
      cR cM cbl cfv co cin cY cR cM cbl cfv co cM cme wcel cY cR cM cbl cfv co
      cX wss cY cY cR cM cbl cfv co wcel cR crp wcel cY cR cM cY cR cM cbl cfv
      co cY cR cM cbl cfv co cxp cres cbl cfv co cY cR cM cbl cfv co cY cR cM
      cbl cfv co cin wceq cM cme wcel cY cX wcel cR crp wcel w3a cR cY cR cM
      cbl cfv co cM cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cX cY
      blbnd.1 cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres eqid blssp cM
      cme wcel cY cX wcel cR crp wcel 3simp1 cM cme wcel cY cX wcel cR crp wcel
      cY cR cM cbl cfv co cX wss cM cme wcel cY cX wcel wa cR cr wcel cc0 cR
      clt wbr wa cY cR cM cbl cfv co cX wss cR crp wcel cM cY cR cX blbnd.1
      blssm cR elrp sylan2b 3impa cM cme wcel cY cX wcel cR crp wcel cY cY cR
      cM cbl cfv co wcel cM cme wcel cY cX wcel wa cR cr wcel cc0 cR clt wbr wa
      cY cY cR cM cbl cfv co wcel cR crp wcel cM cY cR cX blbnd.1 blcntr cR
      elrp sylan2b 3impa cM cme wcel cY cX wcel cR crp wcel 3simp3 syl2anc cY
      cR cM cbl cfv co inidm syl6eq cM cme wcel cY cR cM cbl cfv co cX wss cY
      cR cM cbl cfv co cM cY cR cM cbl cfv co cY cR cM cbl cfv co cxp cres cdm
      cdm wceq cM cme wcel cY cX wcel cR crp wcel w3a cM cX cY cR cM cbl cfv co
      blbnd.1 metssba2 cM cme wcel cY cX wcel cR crp wcel 3simp1 cM cme wcel cY
      cX wcel cR crp wcel cY cR cM cbl cfv co cX wss cM cme wcel cY cX wcel wa
      cR cr wcel cc0 cR clt wbr wa cY cR cM cbl cfv co cX wss cR crp wcel cM cY
      cR cX blbnd.1 blssm cR elrp sylan2b 3impa sylanc eqtr2d sylanc sylanc
      sylanbrc pm3.26d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M a b c d m r s t u v x y z $. $d X a b c d m r s t u v x y z $.
    totbndbnd.1 $e |- X = dom dom M $.
    $( A totally bounded metric space is bounded. $)
    totbndbnd $p |- ( M e. TotBnd -> M e. Bnd ) $=
      cM cme wcel cM ctotbnd wcel cM cbnd wcel cM totbndmet cM cme wcel vv cv
      cuni cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv
      wral wa vv cfn wrex vd crp wral cX vy cv vr cv cM cbl cfv co wceq vr crp
      wrex vy cX wral cM ctotbnd wcel cM cbnd wcel cM cme wcel vv cv cuni cX
      wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv
      cfn wrex vd crp wral cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vy cX
      cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq vb cv vx cv c1 cM cbl cfv
      co wceq vx cX wrex vb vv cv wral wa vv cfn wrex cX vy cv vr cv cM cbl cfv
      co wceq vr crp wrex vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv co
      wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral cM cme wcel vy
      cv cX wcel wa vv cv cuni cX wceq vb cv vx cv c1 cM cbl cfv co wceq vx cX
      wrex vb vv cv wral wa cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vv
      cfn cM cme wcel vy cv cX wcel wa vv cv cfn wcel wa vv cv cuni cX wceq vb
      cv vx cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv wral wa cX vy cv vr cv
      cM cbl cfv co wceq vr crp wrex cM cme wcel vy cv cX wcel wa vv cv cfn
      wcel wa vv cv cuni cX wceq vb cv vx cv c1 cM cbl cfv co wceq vx cX wrex
      vb vv cv wral wa wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu
      cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx
      vu cv wral w3a vu cfn wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex
      vv cv cfn wcel cX cvv wcel vb cv vx cv c1 cM cbl cfv co wceq vx cX wrex
      vb vv cv wral vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv
      wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu
      cv wral w3a vu cfn wrex cM cme wcel vy cv cX wcel wa vv cv cfn wcel wa vv
      cv cuni cX wceq vb cv vx cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv
      wral wa wa vb cv vx cv c1 cM cbl cfv co wceq vb vx vv cv cX cvv vu indexf
      cM cme wcel vy cv cX wcel wa vv cv cfn wcel vv cv cuni cX wceq vb cv vx
      cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv wral wa simplr cM cme wcel
      vy cv cX wcel wa cX cvv wcel vv cv cfn wcel vv cv cuni cX wceq vb cv vx
      cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv wral wa cM cme wcel cX cvv
      wcel vy cv cX wcel cM cme wcel cM cdm cdm cvv cX cM cme wcel cM cdm cvv
      wcel cM cdm cdm cvv wcel cM cme dmexg cM cdm cvv dmexg syl totbndbnd.1
      syl5eqel adantr ad2antrr cM cme wcel vy cv cX wcel wa vv cv cfn wcel wa
      vv cv cuni cX wceq vb cv vx cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv
      wral simprr syl3anc cM cme wcel vy cv cX wcel wa vv cv cfn wcel wa vv cv
      cuni cX wceq vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex
      vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv
      wral w3a vu cfn wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vb cv
      vx cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv wral cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq
      vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv
      wrex vx vu cv wral w3a vu cfn wrex cX vy cv vr cv cM cbl cfv co wceq vr
      crp wrex vv cv cfn wcel cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq
      wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv
      wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a vu
      cfn wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex cM cme wcel vy cv
      cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv
      co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb
      vv cv wrex vx vu cv wral w3a cX vy cv vr cv cM cbl cfv co wceq vr crp
      wrex vu cfn cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cfn
      wcel wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb
      vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral
      w3a cX vy cv vr cv cM cbl cfv co wceq vr crp wrex cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl
      cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv vs cv wne vs cv vr
      cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex
      va crp crab wral vr va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv
      wrex va crp crab wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab cfn wcel va
      cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab c0 wne vr
      cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex va crp crab wral vr va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wrex cM cme wcel vy cv cX wcel wa
      vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv c1 cM
      cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co
      wceq vb vv cv wrex vx vu cv wral w3a wa vr vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab clt va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab cr wss cr clt wor va cv vy cv vc
      cv cM co c1 caddc co wceq vc vu cv wrex va crp crab clt wor va cv vy cv
      vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab crp cr va cv vy cv
      vc cv cM co c1 caddc co wceq vc vu cv wrex va crp ssrab2 rpssre sstri
      ltso va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      cr clt soss mp2 fimax vu cv cfn wcel va cv vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex va crp crab vu cv cdom wbr va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab cfn wcel cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl
      cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vu cv va cv vy cv vc cv cM
      co c1 caddc co wceq vc vu cv wrex va crp crab domfi cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cfn wcel vu cv cX wss vb cv vx cv c1
      cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv
      co wceq vb vv cv wrex vx vu cv wral w3a simplr cM cme wcel vy cv cX wcel
      wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv c1 cM
      cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co
      wceq vb vv cv wrex vx vu cv wral w3a wa va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex va crp crab vc cv vu cv wcel va cv vy cv vc cv cM
      co c1 caddc co wceq wa vc va copab crn vu cv cdom cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl
      cfv co wceq vb vv cv wrex vx vu cv wral w3a wa va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va cab va cv crp wcel va cv vy cv vc cv cM co
      c1 caddc co wceq vc vu cv wrex wa va cab vc cv vu cv wcel va cv vy cv vc
      cv cM co c1 caddc co wceq wa vc va copab crn va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab cM cme wcel vy cv cX wcel wa vv
      cv cuni cX wceq wa vu cv cfn wcel wa vb cv vx cv c1 cM cbl cfv co wceq vx
      vu cv wrex vb vv cv wral vu cv cX wss va cv vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex va cab va cv crp wcel va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex wa va cab wceq vb cv vx cv c1 cM cbl cfv co wceq vb
      vv cv wrex vx vu cv wral cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq
      wa vu cv cX wss va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va
      cab va cv crp wcel va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex
      wa va cab wceq vu cv cfn wcel cM cme wcel vy cv cX wcel wa vu cv cX wss
      va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va cab va cv crp
      wcel va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex wa va cab
      wceq vv cv cuni cX wceq cM cme wcel vy cv cX wcel wa vu cv cX wss wa va
      cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va cv crp wcel va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex wa va cM cme wcel vy cv
      cX wcel wa vu cv cX wss wa va cv vy cv vc cv cM co c1 caddc co wceq vc vu
      cv wrex va cv crp wcel cM cme wcel vy cv cX wcel wa vu cv cX wss wa va cv
      vy cv vc cv cM co c1 caddc co wceq va cv crp wcel vc vu cv cM cme wcel vy
      cv cX wcel wa vu cv cX wss vc cv vu cv wcel va cv vy cv vc cv cM co c1
      caddc co wceq va cv crp wcel wi cM cme wcel vy cv cX wcel wa vc cv cX
      wcel va cv vy cv vc cv cM co c1 caddc co wceq va cv crp wcel wi vu cv cX
      wss vc cv vu cv wcel wa va cv vy cv vc cv cM co c1 caddc co wceq va cv
      crp wcel vy cv vc cv cM co c1 caddc co crp wcel cM cme wcel vy cv cX wcel
      wa vc cv cX wcel wa va cv vy cv vc cv cM co c1 caddc co crp eleq1 cM cme
      wcel vy cv cX wcel vc cv cX wcel vy cv vc cv cM co c1 caddc co crp wcel
      vy cv vc cv cM co c1 caddc co crp wcel vy cv vc cv cM co c1 caddc co cr
      wcel cc0 vy cv vc cv cM co c1 caddc co clt wbr cM cme wcel vy cv cX wcel
      vc cv cX wcel w3a vy cv vc cv cM co c1 caddc co elrp vy cv vc cv cM co cr
      wcel c1 cr wcel vy cv vc cv cM co c1 caddc co cr wcel cM cme wcel vy cv
      cX wcel vc cv cX wcel w3a vy cv vc cv cM co c1 readdcl vy cv vc cv cM cX
      totbndbnd.1 metcl 1re sylancl cM cme wcel vy cv cX wcel vc cv cX wcel w3a
      cc0 cc0 caddc co vy cv vc cv cM co c1 caddc co cc0 clt cM cme wcel vy cv
      cX wcel vc cv cX wcel w3a cc0 vy cv vc cv cM co cle wbr cc0 c1 clt wbr wa
      cc0 cc0 caddc co vy cv vc cv cM co c1 caddc co clt wbr cM cme wcel vy cv
      cX wcel vc cv cX wcel w3a cc0 vy cv vc cv cM co cle wbr cc0 c1 clt wbr vy
      cv vc cv cM cX totbndbnd.1 metge0 lt01 jctir cc0 cr wcel cc0 cr wcel vy
      cv vc cv cM co cr wcel c1 cr wcel cc0 vy cv vc cv cM co cle wbr cc0 c1
      clt wbr wa cc0 cc0 caddc co vy cv vc cv cM co c1 caddc co clt wbr wi cM
      cme wcel vy cv cX wcel vc cv cX wcel w3a cc0 cc0 vy cv vc cv cM co c1
      leltadd cc0 cr wcel cM cme wcel vy cv cX wcel vc cv cX wcel w3a 0re a1i
      cc0 cr wcel cM cme wcel vy cv cX wcel vc cv cX wcel w3a 0re a1i vy cv vc
      cv cM cX totbndbnd.1 metcl c1 cr wcel cM cme wcel vy cv cX wcel vc cv cX
      wcel w3a 1re a1i syl2anc mpd cc0 0cn addid1i syl5eqbrr sylanbrc 3expa
      syl5cbir vu cv cX vc cv ssel2 sylan2 anassrs r19.23adva pm4.71rd abbidv
      adantlr adantlr 3ad2antr1 vc va vu cv vy cv vc cv cM co c1 caddc co
      rnopab2 va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp
      df-rab 3eqtr4g vu cv cvv wcel vc cv vu cv wcel va cv vy cv vc cv cM co c1
      caddc co wceq wa vc va copab vu cv wfn vc cv vu cv wcel va cv vy cv vc cv
      cM co c1 caddc co wceq wa vc va copab crn vu cv cdom wbr vu visset vc va
      vu cv vy cv vc cv cM co c1 caddc co vc cv vu cv wcel va cv vy cv vc cv cM
      co c1 caddc co wceq wa vc va copab vy cv vc cv cM co c1 caddc oprex vc cv
      vu cv wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab eqid
      fnopab2 vu cv cvv vc cv vu cv wcel va cv vy cv vc cv cM co c1 caddc co
      wceq wa vc va copab fnrndomg mp2 syl6eqbrr sylanc cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl
      cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vc cv vu cv wcel va cv vy
      cv vc cv cM co c1 caddc co wceq wa vc va copab crn c0 wne va cv vy cv vc
      cv cM co c1 caddc co wceq vc vu cv wrex va crp crab c0 wne cM cme wcel vy
      cv cX wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv
      vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vc cv vu cv wcel
      va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab crn c0 wne vb cv
      vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral cM cme wcel vy cv
      cX wcel wa vv cv cuni cX wceq wa vb cv vx cv c1 cM cbl cfv co wceq vx vu
      cv wrex vb vv cv wral vc cv vu cv wcel va cv vy cv vc cv cM co c1 caddc
      co wceq wa vc va copab crn c0 wne vu cv cfn wcel vy cv cX wcel vv cv cuni
      cX wceq vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vc
      cv vu cv wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab crn
      c0 wne cM cme wcel vy cv cX wcel vv cv cuni cX wceq wa vb cv vx cv c1 cM
      cbl cfv co wceq vx vu cv wrex vb vv cv wral wa vc cv vu cv wcel va cv vy
      cv vc cv cM co c1 caddc co wceq wa vc va copab crn c0 vc cv vu cv wcel va
      cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab crn c0 wceq vu cv c0
      wceq vy cv cX wcel vv cv cuni cX wceq wa vb cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb vv cv wral wa wn vu cv c0 wceq vc cv vu cv wcel va
      cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab cdm c0 wceq vc cv vu
      cv wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab crn c0
      wceq vc cv vu cv wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va
      copab cdm vu cv c0 vc va vu cv vy cv vc cv cM co c1 caddc co vc cv vu cv
      wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab vy cv vc cv
      cM co c1 caddc oprex vc cv vu cv wcel va cv vy cv vc cv cM co c1 caddc co
      wceq wa vc va copab eqid dmopab2 eqeq1i vc cv vu cv wcel va cv vy cv vc
      cv cM co c1 caddc co wceq wa vc va copab dm0rn0 bitr3i vu cv c0 wceq vx
      cv vx cv wceq vx vu cv wrex vy cv cX wcel vv cv cuni cX wceq wa vb cv vx
      cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral wa vu cv c0 wceq vx
      cv vx cv wceq vx vu cv wrex vx cv vx cv wceq vx c0 wrex vx cv vx cv wceq
      vx rex0 vx cv vx cv wceq vx vu cv c0 rexeq1 mtbiri vv cv c0 wne vb cv vx
      cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vx cv vx cv wceq vx
      vu cv wrex vy cv cX wcel vv cv cuni cX wceq wa vv cv c0 wne vb cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral wa vb cv vx cv c1 cM
      cbl cfv co wceq vx vu cv wrex vb vv cv wrex vx cv vx cv wceq vx vu cv
      wrex vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv r19.2z vb
      cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vx cv vx cv wceq vx vu cv
      wrex vb vv cv vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vx cv vx cv
      wceq vx vu cv wrex wi vb cv vv cv wcel vb cv vx cv c1 cM cbl cfv co wceq
      vx cv vx cv wceq vx vu cv vb cv vx cv c1 cM cbl cfv co wceq vx cv eqidd
      r19.22si a1i r19.23aiv syl vy cv cX wcel cX c0 wne vv cv cuni cX wceq vv
      cv c0 wne cX vy cv ne0i vv cv cuni cX wceq vv cv c0 cX c0 vv cv cuni cX
      wceq vv cv cuni c0 wceq cX c0 wceq vv cv c0 wceq vv cv cuni cX c0 eqeq1
      vv cv c0 wceq vv cv cuni c0 cuni c0 vv cv c0 unieq uni0 syl6eq syl5bi
      necon3d mpan9 sylan nsyl sylbir necon2ai adantlll adantlr 3ad2antr2 cM
      cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv
      cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb
      cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vc cv
      vu cv wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab crn va
      cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab c0 cM cme
      wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vu cv cX
      wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv
      vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa va cv vy
      cv vc cv cM co c1 caddc co wceq vc vu cv wrex va cab va cv crp wcel va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex wa va cab vc cv vu cv
      wcel va cv vy cv vc cv cM co c1 caddc co wceq wa vc va copab crn va cv vy
      cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab cM cme wcel vy
      cv cX wcel wa vv cv cuni cX wceq wa vu cv cfn wcel wa vb cv vx cv c1 cM
      cbl cfv co wceq vx vu cv wrex vb vv cv wral vu cv cX wss va cv vy cv vc
      cv cM co c1 caddc co wceq vc vu cv wrex va cab va cv crp wcel va cv vy cv
      vc cv cM co c1 caddc co wceq vc vu cv wrex wa va cab wceq vb cv vx cv c1
      cM cbl cfv co wceq vb vv cv wrex vx vu cv wral cM cme wcel vy cv cX wcel
      wa vv cv cuni cX wceq wa vu cv cX wss va cv vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex va cab va cv crp wcel va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex wa va cab wceq vu cv cfn wcel cM cme wcel vy cv cX
      wcel wa vu cv cX wss va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv
      wrex va cab va cv crp wcel va cv vy cv vc cv cM co c1 caddc co wceq vc vu
      cv wrex wa va cab wceq vv cv cuni cX wceq cM cme wcel vy cv cX wcel wa vu
      cv cX wss wa va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va cv
      crp wcel va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex wa va cM
      cme wcel vy cv cX wcel wa vu cv cX wss wa va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va cv crp wcel cM cme wcel vy cv cX wcel wa
      vu cv cX wss wa va cv vy cv vc cv cM co c1 caddc co wceq va cv crp wcel
      vc vu cv cM cme wcel vy cv cX wcel wa vu cv cX wss vc cv vu cv wcel va cv
      vy cv vc cv cM co c1 caddc co wceq va cv crp wcel wi cM cme wcel vy cv cX
      wcel wa vc cv cX wcel va cv vy cv vc cv cM co c1 caddc co wceq va cv crp
      wcel wi vu cv cX wss vc cv vu cv wcel wa va cv vy cv vc cv cM co c1 caddc
      co wceq va cv crp wcel vy cv vc cv cM co c1 caddc co crp wcel cM cme wcel
      vy cv cX wcel wa vc cv cX wcel wa va cv vy cv vc cv cM co c1 caddc co crp
      eleq1 cM cme wcel vy cv cX wcel vc cv cX wcel vy cv vc cv cM co c1 caddc
      co crp wcel vy cv vc cv cM co c1 caddc co crp wcel vy cv vc cv cM co c1
      caddc co cr wcel cc0 vy cv vc cv cM co c1 caddc co clt wbr cM cme wcel vy
      cv cX wcel vc cv cX wcel w3a vy cv vc cv cM co c1 caddc co elrp vy cv vc
      cv cM co cr wcel c1 cr wcel vy cv vc cv cM co c1 caddc co cr wcel cM cme
      wcel vy cv cX wcel vc cv cX wcel w3a vy cv vc cv cM co c1 readdcl vy cv
      vc cv cM cX totbndbnd.1 metcl 1re sylancl cM cme wcel vy cv cX wcel vc cv
      cX wcel w3a cc0 cc0 caddc co vy cv vc cv cM co c1 caddc co cc0 clt cM cme
      wcel vy cv cX wcel vc cv cX wcel w3a cc0 vy cv vc cv cM co cle wbr cc0 c1
      clt wbr wa cc0 cc0 caddc co vy cv vc cv cM co c1 caddc co clt wbr cM cme
      wcel vy cv cX wcel vc cv cX wcel w3a cc0 vy cv vc cv cM co cle wbr cc0 c1
      clt wbr vy cv vc cv cM cX totbndbnd.1 metge0 lt01 jctir cc0 cr wcel cc0
      cr wcel vy cv vc cv cM co cr wcel c1 cr wcel cc0 vy cv vc cv cM co cle
      wbr cc0 c1 clt wbr wa cc0 cc0 caddc co vy cv vc cv cM co c1 caddc co clt
      wbr wi cM cme wcel vy cv cX wcel vc cv cX wcel w3a cc0 cc0 vy cv vc cv cM
      co c1 leltadd cc0 cr wcel cM cme wcel vy cv cX wcel vc cv cX wcel w3a 0re
      a1i cc0 cr wcel cM cme wcel vy cv cX wcel vc cv cX wcel w3a 0re a1i vy cv
      vc cv cM cX totbndbnd.1 metcl c1 cr wcel cM cme wcel vy cv cX wcel vc cv
      cX wcel w3a 1re a1i syl2anc mpd cc0 0cn addid1i syl5eqbrr sylanbrc 3expa
      syl5cbir vu cv cX vc cv ssel2 sylan2 anassrs r19.23adva pm4.71rd abbidv
      adantlr adantlr 3ad2antr1 vc va vu cv vy cv vc cv cM co c1 caddc co
      rnopab2 va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp
      df-rab 3eqtr4g neeq1d mpbid sylanc cM cme wcel vy cv cX wcel wa vv cv
      cuni cX wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv c1 cM cbl cfv
      co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb
      vv cv wrex vx vu cv wral w3a wa vr cv vs cv wne vs cv vr cv clt wbr wi vs
      va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral
      vr crp wrex cX vy cv vr cv cM cbl cfv co wceq vr crp wrex vr cv vs cv wne
      vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu
      cv wrex va crp crab wral vr va cv vy cv vc cv cM co c1 caddc co wceq vc
      vu cv wrex va crp crab wrex cM cme wcel vy cv cX wcel wa vv cv cuni cX
      wceq wa vu cv cfn wcel wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq
      vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv
      wrex vx vu cv wral w3a wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral cX vy
      cv vr cv cM cbl cfv co wceq vr crp cM cme wcel vy cv cX wcel wa vv cv
      cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv
      wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu
      cv wral w3a vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va
      cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral cX
      vy cv vr cv cM cbl cfv co wceq wi vu cv cfn wcel cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv
      cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr
      cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex
      va crp crab wral cX vy cv vr cv cM cbl cfv co wceq cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv
      cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr
      cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex
      va crp crab wral wa vz cX vy cv vr cv cM cbl cfv co cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv
      cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr
      cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex
      va crp crab wral wa vz cv cX wcel vz cv vy cv vr cv cM cbl cfv co wcel cM
      cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl
      cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr cv vs
      cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq
      vc vu cv wrex va crp crab wral wa vz cv cX wcel vz cv vt cv wcel vt vv cv
      wrex vz cv vy cv vr cv cM cbl cfv co wcel cM cme wcel vy cv cX wcel wa vv
      cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu
      cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx
      vu cv wral w3a wa vz cv cX wcel vz cv vt cv wcel vt vv cv wrex wi vr cv
      crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM
      co c1 caddc co wceq vc vu cv wrex va crp crab wral vv cv cuni cX wceq vz
      cv cX wcel vz cv vt cv wcel vt vv cv wrex wi cM cme wcel vy cv cX wcel wa
      vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv
      wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a vv
      cv cuni cX wceq vz cv cX wcel vz cv vv cv cuni wcel vz cv vt cv wcel vt
      vv cv wrex vv cv cuni cX vz cv eleq2 vz cv vv cv cuni wcel vz cv vt cv
      wcel vt vv cv wrex vt vz cv vv cv eluni2 biimpi syl6bir ad2antlr ad2antrr
      cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx
      cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM
      cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr
      cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex va crp crab wral wa vz cv vt cv wcel vz cv vy cv vr
      cv cM cbl cfv co wcel vt vv cv cM cme wcel vy cv cX wcel wa vv cv cuni cX
      wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb
      vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral
      w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral wa vt
      cv vv cv wcel wa vt cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vz cv vt
      cv wcel vz cv vy cv vr cv cM cbl cfv co wcel wi cM cme wcel vy cv cX wcel
      wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq
      vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv
      wrex vx vu cv wral w3a wa vr cv crp wcel wa vt cv vv cv wcel vt cv vx cv
      c1 cM cbl cfv co wceq vx vu cv wrex vr cv vs cv wne vs cv vr cv clt wbr
      wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      wral cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb
      cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1
      cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vt cv vv cv wcel vt
      cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vr cv crp wcel vu cv cX wss
      vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv
      c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a vt cv vv cv wcel vt
      cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex cM cme wcel vy cv cX wcel wa
      vv cv cuni cX wceq wa vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb
      vv cv wral vu cv cX wss vt cv vv cv wcel vt cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu
      cv wral vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vt cv vx cv c1 cM
      cbl cfv co wceq vx vu cv wrex vb vt cv vv cv vb cv vt cv wceq vb cv vx cv
      c1 cM cbl cfv co wceq vt cv vx cv c1 cM cbl cfv co wceq vx vu cv vb cv vt
      cv vx cv c1 cM cbl cfv co eqeq1 rexbidv rcla4cva 3ad2antl2 adantll
      adantlr adantlr cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv
      cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb
      cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv
      crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv
      cM co c1 caddc co wceq vc vu cv wrex va crp crab wral wa vt cv vv cv wcel
      wa vt cv vx cv c1 cM cbl cfv co wceq vz cv vt cv wcel vz cv vy cv vr cv
      cM cbl cfv co wcel wi vx vu cv cM cme wcel vy cv cX wcel wa vv cv cuni cX
      wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb
      vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral
      w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral wa vt
      cv vv cv wcel vx cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv
      cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb
      cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv
      crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv
      cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vx cM cme wcel vy
      cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl
      cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq
      vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel vx cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv
      cv wrex vx vu cv wral w3a vx cM cme wcel vy cv cX wcel wa vv cv cuni cX
      wceq wa vx ax-17 vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv
      wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu
      cv wral vx vu cv cX wss vx ax-17 vb cv vx cv c1 cM cbl cfv co wceq vx vu
      cv wrex vx vb vv cv vb cv vv cv wcel vx ax-17 vb cv vx cv c1 cM cbl cfv
      co wceq vx vu cv hbre1 hbral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv
      wrex vx vu cv hbra1 hb3an hban vr cv crp wcel vx ax-17 hban vr cv vs cv
      wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc
      vu cv wrex va crp crab wral vx ax-17 hban vt cv vv cv wcel vx ax-17 hban
      vz cv vt cv wcel vz cv vy cv vr cv cM cbl cfv co wcel wi vx ax-17 cM cme
      wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1
      cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv
      co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv
      wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc
      vu cv wrex va crp crab wral wa vt cv vv cv wcel wa vx cv vu cv wcel vt cv
      vx cv c1 cM cbl cfv co wceq vz cv vt cv wcel vz cv vy cv vr cv cM cbl cfv
      co wcel cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss
      vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv
      c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel
      wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wral wa vt cv vv cv wcel wa vx cv
      vu cv wcel wa vz cv vx cv c1 cM cbl cfv co wcel vz cv vy cv vr cv cM cbl
      cfv co wcel vt cv vx cv c1 cM cbl cfv co wceq vz cv vt cv wcel wa cM cme
      wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1
      cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv
      co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv
      wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc
      vu cv wrex va crp crab wral wa vt cv vv cv wcel wa vx cv vu cv wcel wa vz
      cv cX wcel vx cv vz cv cM co c1 clt wbr wa vz cv cX wcel vy cv vz cv cM
      co vr cv clt wbr wa vz cv vx cv c1 cM cbl cfv co wcel vz cv vy cv vr cv
      cM cbl cfv co wcel cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu
      cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral
      vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr
      cv crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc
      cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral wa vt cv vv cv
      wcel wa vx cv vu cv wcel wa vz cv cX wcel vx cv vz cv cM co c1 clt wbr vy
      cv vz cv cM co vr cv clt wbr cM cme wcel vy cv cX wcel wa vv cv cuni cX
      wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb
      vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral
      w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral wa vx
      cv vu cv wcel vz cv cX wcel vx cv vz cv cM co c1 clt wbr vy cv vz cv cM
      co vr cv clt wbr wi wi vt cv vv cv wcel cM cme wcel vy cv cX wcel wa vv
      cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu
      cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx
      vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr
      wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      wral wa vx cv vu cv wcel wa vy cv vx cv cM co c1 caddc co vr cv cle wbr
      vz cv cX wcel vx cv vz cv cM co c1 clt wbr vy cv vz cv cM co vr cv clt
      wbr wi wi cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss
      vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv
      c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel
      wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wral vx cv vu cv wcel vy cv vx cv
      cM co c1 caddc co vr cv cle wbr cM cme wcel vy cv cX wcel wa vv cv cuni
      cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex
      vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv
      wral w3a wa vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va
      cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vx
      cv vu cv wcel wa vy cv vx cv cM co c1 caddc co vr cv cle wbr cM cme wcel
      vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl
      cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq
      vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel vr cv vs cv wne vs cv
      vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv
      wrex va crp crab wral vx cv vu cv wcel wa wa vy cv vx cv cM co c1 caddc
      co vr cv cle wbr cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vb cv
      vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vu cv cX wss vr
      cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv
      cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vx cv vu cv wcel wa
      wa vy cv vx cv cM co c1 caddc co vr cv cle wbr wi vb cv vx cv c1 cM cbl
      cfv co wceq vb vv cv wrex vx vu cv wral cM cme wcel vy cv cX wcel wa vu
      cv cX wss vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vx cv
      vu cv wcel wa wa vy cv vx cv cM co c1 caddc co vr cv cle wbr wi vv cv
      cuni cX wceq cM cme wcel vy cv cX wcel wa vu cv cX wss wa vr cv crp wcel
      vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wral vx cv vu cv wcel wa wa vy cv
      vx cv cM co c1 caddc co vr cv cle wbr cM cme wcel vy cv cX wcel wa vu cv
      cX wss wa vs cv vr cv cle wbr vs va cv vy cv vc cv cM co c1 caddc co wceq
      vc vu cv wrex va crp crab wral vx cv vu cv wcel wa vy cv vx cv cM co c1
      caddc co vr cv cle wbr vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr
      wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      wral vx cv vu cv wcel wa wa cM cme wcel vy cv cX wcel wa vu cv cX wss wa
      vx cv vu cv wcel vs cv vr cv cle wbr vs va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex va crp crab wral vy cv vx cv cM co c1 caddc co vr
      cv cle wbr cM cme wcel vy cv cX wcel wa vu cv cX wss wa vx cv vu cv wcel
      vs cv vr cv cle wbr vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv
      wrex va crp crab wral vy cv vx cv cM co c1 caddc co vr cv cle wbr vy cv
      vx cv cM co c1 caddc co va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv
      wrex va crp crab wcel vs cv vr cv cle wbr vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wral vy cv vx cv cM co c1 caddc
      co vr cv cle wbr cM cme wcel vy cv cX wcel wa vu cv cX wss wa vx cv vu cv
      wcel wa vs cv vr cv cle wbr vy cv vx cv cM co c1 caddc co vr cv cle wbr
      vs vy cv vx cv cM co c1 caddc co va cv vy cv vc cv cM co c1 caddc co wceq
      vc vu cv wrex va crp crab vs cv vy cv vx cv cM co c1 caddc co vr cv cle
      breq1 rcla4va vy cv vx cv cM co c1 caddc co va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wcel vy cv vx cv cM co c1 caddc
      co crp wcel vy cv vx cv cM co c1 caddc co vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex cM cme wcel vy cv cX wcel wa vu cv cX wss wa vx cv vu
      cv wcel wa va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex vy cv
      vx cv cM co c1 caddc co vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex
      va vy cv vx cv cM co c1 caddc co crp va cv vy cv vx cv cM co c1 caddc co
      wceq va cv vy cv vc cv cM co c1 caddc co wceq vy cv vx cv cM co c1 caddc
      co vy cv vc cv cM co c1 caddc co wceq vc vu cv va cv vy cv vx cv cM co c1
      caddc co vy cv vc cv cM co c1 caddc co eqeq1 rexbidv elrab cM cme wcel vy
      cv cX wcel wa vu cv cX wss vx cv vu cv wcel vy cv vx cv cM co c1 caddc co
      crp wcel cM cme wcel vy cv cX wcel wa vx cv cX wcel vy cv vx cv cM co c1
      caddc co crp wcel vu cv cX wss vx cv vu cv wcel wa cM cme wcel vy cv cX
      wcel vx cv cX wcel vy cv vx cv cM co c1 caddc co crp wcel vy cv vx cv cM
      co c1 caddc co crp wcel vy cv vx cv cM co c1 caddc co cr wcel cc0 vy cv
      vx cv cM co c1 caddc co clt wbr cM cme wcel vy cv cX wcel vx cv cX wcel
      w3a vy cv vx cv cM co c1 caddc co elrp cM cme wcel vy cv cX wcel vx cv cX
      wcel w3a vy cv vx cv cM co cr wcel vy cv vx cv cM co c1 caddc co cr wcel
      vy cv vx cv cM cX totbndbnd.1 metcl vy cv vx cv cM co peano2re syl cM cme
      wcel vy cv cX wcel vx cv cX wcel w3a cc0 cc0 caddc co vy cv vx cv cM co
      c1 caddc co cc0 clt cM cme wcel vy cv cX wcel vx cv cX wcel w3a cc0 vy cv
      vx cv cM co cle wbr cc0 c1 clt wbr wa cc0 cc0 caddc co vy cv vx cv cM co
      c1 caddc co clt wbr cM cme wcel vy cv cX wcel vx cv cX wcel w3a cc0 vy cv
      vx cv cM co cle wbr cc0 c1 clt wbr vy cv vx cv cM cX totbndbnd.1 metge0
      lt01 jctir cc0 cr wcel cc0 cr wcel vy cv vx cv cM co cr wcel c1 cr wcel
      cc0 vy cv vx cv cM co cle wbr cc0 c1 clt wbr wa cc0 cc0 caddc co vy cv vx
      cv cM co c1 caddc co clt wbr wi cM cme wcel vy cv cX wcel vx cv cX wcel
      w3a cc0 cc0 vy cv vx cv cM co c1 leltadd cc0 cr wcel cM cme wcel vy cv cX
      wcel vx cv cX wcel w3a 0re a1i cc0 cr wcel cM cme wcel vy cv cX wcel vx
      cv cX wcel w3a 0re a1i vy cv vx cv cM cX totbndbnd.1 metcl c1 cr wcel cM
      cme wcel vy cv cX wcel vx cv cX wcel w3a 1re a1i syl2anc mpd cc0 0cn
      addid1i syl5eqbrr sylanbrc 3expa vu cv cX vx cv ssel2 sylan2 anassrs vx
      cv vu cv wcel vy cv vx cv cM co c1 caddc co vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex cM cme wcel vy cv cX wcel wa vu cv cX wss wa vx cv vu
      cv wcel vy cv vx cv cM co c1 caddc co vy cv vx cv cM co c1 caddc co wceq
      vy cv vx cv cM co c1 caddc co vy cv vc cv cM co c1 caddc co wceq vc vu cv
      wrex vy cv vx cv cM co c1 caddc co eqid vy cv vx cv cM co c1 caddc co vy
      cv vc cv cM co c1 caddc co wceq vy cv vx cv cM co c1 caddc co vy cv vx cv
      cM co c1 caddc co wceq vc vx cv vu cv vc cv vx cv wceq vy cv vc cv cM co
      c1 caddc co vy cv vx cv cM co c1 caddc co vy cv vx cv cM co c1 caddc co
      vc cv vx cv wceq vy cv vc cv cM co vy cv vx cv cM co c1 caddc vc cv vx cv
      vy cv cM opreq2 opreq1d eqeq2d rcla4ev mpan2 adantl sylanbrc sylan anasss
      ancom2s vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy
      cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vx cv vu
      cv wcel vs cv vr cv cle wbr vs va cv vy cv vc cv cM co c1 caddc co wceq
      vc vu cv wrex va crp crab wral vx cv vu cv wcel wa vr cv crp wcel vr cv
      vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex va crp crab wral wa vs cv vr cv cle wbr vs va cv vy cv
      vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vx cv vu cv
      wcel vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv
      vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vs cv vr cv
      cle wbr vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp
      crab wral vr cv crp wcel vr cv vs cv wne vs cv vr cv clt wbr wi vs cv vr
      cv cle wbr vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va
      crp crab vr cv crp wcel vs cv crp wcel vr cv vs cv wne vs cv vr cv clt
      wbr wi vs cv vr cv cle wbr wi vs cv va cv vy cv vc cv cM co c1 caddc co
      wceq vc vu cv wrex va crp crab wcel vr cv crp wcel vs cv crp wcel wa vr
      cv vs cv wne vs cv vr cv clt wbr wi vr cv vs cv wceq wn vs cv vr cv cle
      wbr wi vs cv vr cv cle wbr vr cv crp wcel vs cv crp wcel wa vr cv vs cv
      wceq wn vr cv vs cv wne vs cv vr cv clt wbr vs cv vr cv cle wbr vr cv crp
      wcel vs cv crp wcel wa vr cv vs cv wceq vr cv vs cv vr cv crp wcel vs cv
      crp wcel wa vr cv vs cv wceq idd necon3bd vs cv crp wcel vr cv crp wcel
      vs cv vr cv clt wbr vs cv vr cv cle wbr wi vs cv cr wcel vr cv cr wcel vs
      cv vr cv clt wbr vs cv vr cv cle wbr wi vs cv crp wcel vr cv crp wcel vs
      cv vr cv ltle vs cv rpre vr cv rpre syl2an ancoms imim12d vr cv crp wcel
      vs cv crp wcel wa vr cv vs cv wceq vs cv vr cv cle wbr wi vr cv vs cv
      wceq wn vs cv vr cv cle wbr wi vs cv vr cv cle wbr wi vs cv crp wcel vr
      cv vs cv wceq vs cv vr cv cle wbr wi vr cv crp wcel vs cv crp wcel vs cv
      cr wcel vr cv vs cv wceq vs cv vr cv cle wbr wi vs cv rpre vs cv cr wcel
      vs cv vr cv wceq vs cv vr cv cle wbr vr cv vs cv wceq vs cv cr wcel vs cv
      vr cv wceq vs cv vr cv cle wbr vs cv vr cv eqle ex vr vs equcom syl5ib
      syl adantl vr cv vs cv wceq vs cv vr cv cle wbr pm2.61 syl syld vs cv va
      cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wcel vs
      cv crp wcel vs cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va cv
      vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex vs cv vy cv vc cv cM co
      c1 caddc co wceq vc vu cv wrex va vs cv crp va cv vs cv wceq va cv vy cv
      vc cv cM co c1 caddc co wceq vs cv vy cv vc cv cM co c1 caddc co wceq vc
      vu cv va cv vs cv vy cv vc cv cM co c1 caddc co eqeq1 rexbidv elrab
      pm3.26bi sylan2 r19.20dva imp anim1i anasss sylan2 ex adantlr 3ad2antr1
      imp anassrs anassrs cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu
      cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral
      vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr
      cv crp wcel wa vx cv vu cv wcel vy cv vx cv cM co c1 caddc co vr cv cle
      wbr vz cv cX wcel vx cv vz cv cM co c1 clt wbr vy cv vz cv cM co vr cv
      clt wbr wi wi wi vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc
      cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wral cM cme wcel vy
      cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl
      cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq
      vb vv cv wrex vx vu cv wral w3a wa vx cv vu cv wcel vr cv crp wcel vy cv
      vx cv cM co c1 caddc co vr cv cle wbr vz cv cX wcel vx cv vz cv cM co c1
      clt wbr vy cv vz cv cM co vr cv clt wbr wi wi wi cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vx cv cX wcel wa vr cv crp wcel vy cv vx cv
      cM co c1 caddc co vr cv cle wbr vz cv cX wcel vx cv vz cv cM co c1 clt
      wbr vy cv vz cv cM co vr cv clt wbr wi wi wi cM cme wcel vy cv cX wcel wa
      vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx
      vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex
      vx vu cv wral w3a wa vx cv vu cv wcel wa cM cme wcel vy cv cX wcel wa vx
      cv cX wcel vr cv crp wcel vy cv vx cv cM co c1 caddc co vr cv cle wbr vz
      cv cX wcel vx cv vz cv cM co c1 clt wbr vy cv vz cv cM co vr cv clt wbr
      wi wi wi vv cv cuni cX wceq cM cme wcel vy cv cX wcel wa vx cv cX wcel wa
      vr cv crp wcel wa vz cv cX wcel vy cv vx cv cM co c1 caddc co vr cv cle
      wbr vx cv vz cv cM co c1 clt wbr vy cv vz cv cM co vr cv clt wbr wi cM
      cme wcel vy cv cX wcel wa vx cv cX wcel wa vr cv crp wcel wa vz cv cX
      wcel vy cv vx cv cM co c1 caddc co vr cv cle wbr vx cv vz cv cM co c1 clt
      wbr vy cv vz cv cM co vr cv clt wbr wi wi cM cme wcel vy cv cX wcel wa vx
      cv cX wcel wa vr cv crp wcel wa vz cv cX wcel wa vx cv vz cv cM co c1 clt
      wbr vy cv vx cv cM co c1 caddc co vr cv cle wbr vy cv vz cv cM co vr cv
      clt wbr cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vr cv crp wcel wa
      vz cv cX wcel wa vx cv vz cv cM co c1 clt wbr vy cv vx cv cM co vx cv vz
      cv cM co caddc co vy cv vx cv cM co c1 caddc co clt wbr vy cv vx cv cM co
      c1 caddc co vr cv cle wbr vy cv vz cv cM co vr cv clt wbr wi cM cme wcel
      vy cv cX wcel wa vx cv cX wcel wa vz cv cX wcel vx cv vz cv cM co c1 clt
      wbr vy cv vx cv cM co vx cv vz cv cM co caddc co vy cv vx cv cM co c1
      caddc co clt wbr wi vr cv crp wcel cM cme wcel vy cv cX wcel wa vx cv cX
      wcel wa vz cv cX wcel wa vx cv vz cv cM co c1 clt wbr vy cv vx cv cM co
      vx cv vz cv cM co caddc co vy cv vx cv cM co c1 caddc co clt wbr vx cv vz
      cv cM co cr wcel c1 cr wcel vy cv vx cv cM co cr wcel vx cv vz cv cM co
      c1 clt wbr vy cv vx cv cM co vx cv vz cv cM co caddc co vy cv vx cv cM co
      c1 caddc co clt wbr wb cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vz
      cv cX wcel wa vx cv vz cv cM co c1 vy cv vx cv cM co ltadd2 cM cme wcel
      vx cv cX wcel vz cv cX wcel vx cv vz cv cM co cr wcel vy cv cX wcel cM
      cme wcel vx cv cX wcel vz cv cX wcel vx cv vz cv cM co cr wcel vx cv vz
      cv cM cX totbndbnd.1 metcl 3expa adantllr c1 cr wcel cM cme wcel vy cv cX
      wcel wa vx cv cX wcel wa vz cv cX wcel wa 1re a1i cM cme wcel vy cv cX
      wcel wa vx cv cX wcel wa vy cv vx cv cM co cr wcel vz cv cX wcel cM cme
      wcel vy cv cX wcel vx cv cX wcel vy cv vx cv cM co cr wcel vy cv vx cv cM
      cX totbndbnd.1 metcl 3expa adantr syl3anc biimpd adantlr cM cme wcel vy
      cv cX wcel wa vx cv cX wcel wa vr cv crp wcel wa vz cv cX wcel wa vy cv
      vx cv cM co vx cv vz cv cM co caddc co vy cv vx cv cM co c1 caddc co clt
      wbr vy cv vx cv cM co c1 caddc co vr cv cle wbr vy cv vz cv cM co vr cv
      clt wbr cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vr cv crp wcel wa
      vz cv cX wcel wa vy cv vx cv cM co vx cv vz cv cM co caddc co vy cv vx cv
      cM co c1 caddc co clt wbr vy cv vx cv cM co c1 caddc co vr cv cle wbr wa
      vy cv vx cv cM co vx cv vz cv cM co caddc co vr cv clt wbr vy cv vz cv cM
      co vr cv clt wbr vy cv vx cv cM co vx cv vz cv cM co caddc co cr wcel vy
      cv vx cv cM co c1 caddc co cr wcel vr cv cr wcel vy cv vx cv cM co vx cv
      vz cv cM co caddc co vy cv vx cv cM co c1 caddc co clt wbr vy cv vx cv cM
      co c1 caddc co vr cv cle wbr wa vy cv vx cv cM co vx cv vz cv cM co caddc
      co vr cv clt wbr wi cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vr cv
      crp wcel wa vz cv cX wcel wa vy cv vx cv cM co vx cv vz cv cM co caddc co
      vy cv vx cv cM co c1 caddc co vr cv ltletr vy cv vx cv cM co cr wcel vx
      cv vz cv cM co cr wcel vy cv vx cv cM co vx cv vz cv cM co caddc co cr
      wcel cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vr cv crp wcel wa vz
      cv cX wcel wa vy cv vx cv cM co vx cv vz cv cM co readdcl cM cme wcel vy
      cv cX wcel wa vx cv cX wcel wa vy cv vx cv cM co cr wcel vr cv crp wcel
      vz cv cX wcel cM cme wcel vy cv cX wcel vx cv cX wcel vy cv vx cv cM co
      cr wcel vy cv vx cv cM cX totbndbnd.1 metcl 3expa ad2antrr cM cme wcel vy
      cv cX wcel wa vx cv cX wcel wa vz cv cX wcel vx cv vz cv cM co cr wcel vr
      cv crp wcel cM cme wcel vx cv cX wcel vz cv cX wcel vx cv vz cv cM co cr
      wcel vy cv cX wcel cM cme wcel vx cv cX wcel vz cv cX wcel vx cv vz cv cM
      co cr wcel vx cv vz cv cM cX totbndbnd.1 metcl 3expa adantllr adantlr
      sylanc cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vz cv cX wcel vy cv
      vx cv cM co c1 caddc co cr wcel vr cv crp wcel vy cv vx cv cM co cr wcel
      c1 cr wcel vy cv vx cv cM co c1 caddc co cr wcel cM cme wcel vy cv cX
      wcel wa vx cv cX wcel wa vz cv cX wcel wa vy cv vx cv cM co c1 readdcl cM
      cme wcel vy cv cX wcel wa vx cv cX wcel wa vy cv vx cv cM co cr wcel vz
      cv cX wcel cM cme wcel vy cv cX wcel vx cv cX wcel vy cv vx cv cM co cr
      wcel vy cv vx cv cM cX totbndbnd.1 metcl 3expa adantr 1re sylancl adantlr
      vr cv crp wcel vr cv cr wcel cM cme wcel vy cv cX wcel wa vx cv cX wcel
      wa vz cv cX wcel vr cv rpre ad2antlr syl3anc cM cme wcel vy cv cX wcel wa
      vx cv cX wcel wa vr cv crp wcel wa vz cv cX wcel wa vy cv vz cv cM co vy
      cv vx cv cM co vx cv vz cv cM co caddc co cle wbr vy cv vx cv cM co vx cv
      vz cv cM co caddc co vr cv clt wbr vy cv vz cv cM co vr cv clt wbr cM cme
      wcel vy cv cX wcel wa vx cv cX wcel wa vz cv cX wcel vy cv vz cv cM co vy
      cv vx cv cM co vx cv vz cv cM co caddc co cle wbr vr cv crp wcel cM cme
      wcel vy cv cX wcel wa vz cv cX wcel vx cv cX wcel vy cv vz cv cM co vy cv
      vx cv cM co vx cv vz cv cM co caddc co cle wbr cM cme wcel vy cv cX wcel
      vz cv cX wcel vx cv cX wcel vy cv vz cv cM co vy cv vx cv cM co vx cv vz
      cv cM co caddc co cle wbr cM cme wcel vy cv cX wcel vz cv cX wcel vx cv
      cX wcel vy cv vz cv cM co vy cv vx cv cM co vx cv vz cv cM co caddc co
      cle wbr vy cv vz cv vx cv cM cX totbndbnd.1 mettri 3exp2 imp41 an1rs
      adantlr vy cv vz cv cM co cr wcel vy cv vx cv cM co vx cv vz cv cM co
      caddc co cr wcel vr cv cr wcel vy cv vz cv cM co vy cv vx cv cM co vx cv
      vz cv cM co caddc co cle wbr vy cv vx cv cM co vx cv vz cv cM co caddc co
      vr cv clt wbr wa vy cv vz cv cM co vr cv clt wbr wi cM cme wcel vy cv cX
      wcel wa vx cv cX wcel wa vr cv crp wcel wa vz cv cX wcel wa vy cv vz cv
      cM co vy cv vx cv cM co vx cv vz cv cM co caddc co vr cv lelttr cM cme
      wcel vy cv cX wcel wa vx cv cX wcel wa vz cv cX wcel vy cv vz cv cM co cr
      wcel vr cv crp wcel cM cme wcel vy cv cX wcel wa vz cv cX wcel vy cv vz
      cv cM co cr wcel vx cv cX wcel cM cme wcel vy cv cX wcel vz cv cX wcel vy
      cv vz cv cM co cr wcel vy cv vz cv cM cX totbndbnd.1 metcl 3expa adantlr
      adantlr vy cv vx cv cM co cr wcel vx cv vz cv cM co cr wcel vy cv vx cv
      cM co vx cv vz cv cM co caddc co cr wcel cM cme wcel vy cv cX wcel wa vx
      cv cX wcel wa vr cv crp wcel wa vz cv cX wcel wa vy cv vx cv cM co vx cv
      vz cv cM co readdcl cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vy cv
      vx cv cM co cr wcel vr cv crp wcel vz cv cX wcel cM cme wcel vy cv cX
      wcel vx cv cX wcel vy cv vx cv cM co cr wcel vy cv vx cv cM cX
      totbndbnd.1 metcl 3expa ad2antrr cM cme wcel vy cv cX wcel wa vx cv cX
      wcel wa vz cv cX wcel vx cv vz cv cM co cr wcel vr cv crp wcel cM cme
      wcel vx cv cX wcel vz cv cX wcel vx cv vz cv cM co cr wcel vy cv cX wcel
      cM cme wcel vx cv cX wcel vz cv cX wcel vx cv vz cv cM co cr wcel vx cv
      vz cv cM cX totbndbnd.1 metcl 3expa adantllr adantlr sylanc vr cv crp
      wcel vr cv cr wcel cM cme wcel vy cv cX wcel wa vx cv cX wcel wa vz cv cX
      wcel vr cv rpre ad2antlr syl3anc mpand syld exp3a syld com23 ex com23
      adantllr cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss
      vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv
      c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a vx cv vu cv wcel cM
      cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vx cv cX wcel wa vu cv cX
      wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv
      vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a vx cv vu cv
      wcel wa vx cv cX wcel cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa
      vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv
      wral vx cv vu cv wcel vx cv cX wcel vb cv vx cv c1 cM cbl cfv co wceq vb
      vv cv wrex vx vu cv wral vu cv cX vx cv ssel2 3ad2antl1 anim2i anassrs
      sylan an1rs adantlr mpd adantlr imdistand cM cme wcel vy cv cX wcel wa vv
      cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu
      cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx
      vu cv wral w3a wa vr cv crp wcel wa vr cv vs cv wne vs cv vr cv clt wbr
      wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      wral wa vx cv vu cv wcel vz cv vx cv c1 cM cbl cfv co wcel vz cv cX wcel
      vx cv vz cv cM co c1 clt wbr wa wb vt cv vv cv wcel cM cme wcel vy cv cX
      wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co
      wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv
      cv wrex vx vu cv wral w3a wa vr cv crp wcel wa vx cv vu cv wcel vz cv vx
      cv c1 cM cbl cfv co wcel vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb
      vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wral cM cme wcel vy cv cX wcel wa
      vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx
      vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex
      vx vu cv wral w3a wa vx cv vu cv wcel vz cv vx cv c1 cM cbl cfv co wcel
      vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb vr cv crp wcel cM cme
      wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss vb cv vx cv c1
      cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv
      co wceq vb vv cv wrex vx vu cv wral w3a vx cv vu cv wcel vz cv vx cv c1
      cM cbl cfv co wcel vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb cM
      cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vx cv cX wcel vz cv vx cv
      c1 cM cbl cfv co wcel vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb vu
      cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral
      vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a vx cv
      vu cv wcel wa cM cme wcel vy cv cX wcel wa vx cv cX wcel vz cv vx cv c1
      cM cbl cfv co wcel vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb vv cv
      cuni cX wceq cM cme wcel vx cv cX wcel vz cv vx cv c1 cM cbl cfv co wcel
      vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb vy cv cX wcel cM cme
      wcel vx cv cX wcel wa c1 cr wcel cc0 c1 clt wbr vz cv vx cv c1 cM cbl cfv
      co wcel vz cv cX wcel vx cv vz cv cM co c1 clt wbr wa wb 1re lt01 vz cv
      cM vx cv c1 cX totbndbnd.1 elbl mpanr12 adantlr adantlr vu cv cX wss vb
      cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vx cv vu cv
      wcel vx cv cX wcel vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu
      cv wral vu cv cX vx cv ssel2 3ad2antl1 sylan2 anassrs adantlr adantlr
      adantlr cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu cv cX wss
      vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral vb cv vx cv
      c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr cv crp wcel
      wa vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1
      caddc co wceq vc vu cv wrex va crp crab wral wa vz cv vy cv vr cv cM cbl
      cfv co wcel vz cv cX wcel vy cv vz cv cM co vr cv clt wbr wa wb vt cv vv
      cv wcel vx cv vu cv wcel cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq
      wa vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv
      wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa
      vr cv crp wcel wa vz cv vy cv vr cv cM cbl cfv co wcel vz cv cX wcel vy
      cv vz cv cM co vr cv clt wbr wa wb vr cv vs cv wne vs cv vr cv clt wbr wi
      vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      wral cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vr cv crp wcel vz
      cv vy cv vr cv cM cbl cfv co wcel vz cv cX wcel vy cv vz cv cM co vr cv
      clt wbr wa wb vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv
      wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu
      cv wral w3a cM cme wcel vy cv cX wcel wa vr cv crp wcel vz cv vy cv vr cv
      cM cbl cfv co wcel vz cv cX wcel vy cv vz cv cM co vr cv clt wbr wa wb vv
      cv cuni cX wceq cM cme wcel vy cv cX wcel wa vr cv cr wcel cc0 vr cv clt
      wbr wa vz cv vy cv vr cv cM cbl cfv co wcel vz cv cX wcel vy cv vz cv cM
      co vr cv clt wbr wa wb vr cv crp wcel vz cv cM vy cv vr cv cX totbndbnd.1
      elbl vr cv elrp sylan2b adantlr adantlr adantr ad2antrr 3imtr4d vt cv vx
      cv c1 cM cbl cfv co wceq vz cv vt cv wcel vz cv vx cv c1 cM cbl cfv co
      wcel vt cv vx cv c1 cM cbl cfv co vz cv eleq2 biimpa syl5 exp4b r19.23ad
      mpd r19.23adva syld cM cme wcel vy cv cX wcel wa vv cv cuni cX wceq wa vu
      cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex vb vv cv wral
      vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv wral w3a wa vr
      cv crp wcel wa vz cv vy cv vr cv cM cbl cfv co wcel vz cv cX wcel wi vr
      cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex va crp crab wral cM cme wcel vy cv cX wcel wa vv cv
      cuni cX wceq wa vr cv crp wcel vz cv vy cv vr cv cM cbl cfv co wcel vz cv
      cX wcel wi vu cv cX wss vb cv vx cv c1 cM cbl cfv co wceq vx vu cv wrex
      vb vv cv wral vb cv vx cv c1 cM cbl cfv co wceq vb vv cv wrex vx vu cv
      wral w3a cM cme wcel vy cv cX wcel wa vr cv crp wcel vz cv vy cv vr cv cM
      cbl cfv co wcel vz cv cX wcel wi vv cv cuni cX wceq cM cme wcel vy cv cX
      wcel wa vr cv crp wcel wa vy cv vr cv cM cbl cfv co cX vz cv cM cme wcel
      vy cv cX wcel wa vr cv cr wcel cc0 vr cv clt wbr wa vy cv vr cv cM cbl
      cfv co cX wss vr cv crp wcel cM vy cv vr cv cX totbndbnd.1 blssm vr cv
      elrp sylan2b sseld adantlr adantlr adantr impbid eqrdv ex adantllr
      r19.22dva va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp
      crab crp wss vr cv vs cv wne vs cv vr cv clt wbr wi vs va cv vy cv vc cv
      cM co c1 caddc co wceq vc vu cv wrex va crp crab wral vr va cv vy cv vc
      cv cM co c1 caddc co wceq vc vu cv wrex va crp crab wrex vr cv vs cv wne
      vs cv vr cv clt wbr wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu
      cv wrex va crp crab wral vr crp wrex wi va cv vy cv vc cv cM co c1 caddc
      co wceq vc vu cv wrex va crp ssrab2 vr cv vs cv wne vs cv vr cv clt wbr
      wi vs va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp crab
      wral vr va cv vy cv vc cv cM co c1 caddc co wceq vc vu cv wrex va crp
      crab crp ssrexv ax-mp syl5 mpd ex r19.23adva imp adantllr adantlrr mpdan
      ex r19.23adva c1 crp wcel vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd crp wral vv cv cuni cX
      wceq vb cv vx cv c1 cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn
      wrex wi 1rp vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vb vv cv wral wa vv cfn wrex vv cv cuni cX wceq vb cv vx cv c1 cM
      cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex vd c1 crp vd cv
      c1 wceq vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vb vv cv wral wa vv cv cuni cX wceq vb cv vx cv c1 cM cbl cfv co
      wceq vx cX wrex vb vv cv wral wa vv cfn vd cv c1 wceq vb cv vx cv vd cv
      cM cbl cfv co wceq vx cX wrex vb vv cv wral vb cv vx cv c1 cM cbl cfv co
      wceq vx cX wrex vb vv cv wral vv cv cuni cX wceq vd cv c1 wceq vb cv vx
      cv vd cv cM cbl cfv co wceq vx cX wrex vb cv vx cv c1 cM cbl cfv co wceq
      vx cX wrex vb vv cv vd cv c1 wceq vb cv vx cv vd cv cM cbl cfv co wceq vb
      cv vx cv c1 cM cbl cfv co wceq vx cX vd cv c1 wceq vx cv vd cv cM cbl cfv
      co vx cv c1 cM cbl cfv co vb cv vd cv c1 vx cv cM cbl cfv opreq2 eqeq2d
      rexbidv ralbidv anbi2d rexbidv rcla4v ax-mp syl5 r19.21adva vx vv cM cX
      vb vd totbndbnd.1 istotbnd2 vy cM cX vr totbndbnd.1 isbnd2 3imtr4d mpcom
      $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Isometries
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ismty $.
  $( Extend class notation with the class of metric space isometries. $)
  cismty $a class Ismty $.

  ${
    $d m n z f x y $.
    $( Define a function which takes two metric spaces and returns the set of
    isometries between the spaces. An isometry is a bijection which preserves
    distance. $)
    df-ismty $a |- Ismty = { <. <. m , n >. , z >. | ( ( m e. Met /\ n e. Met )
        /\ z = { f | ( f : dom dom m -1-1-onto-> dom dom n /\ A. x e. dom dom m
            A. y e. dom dom m ( x m y ) = ( ( f ` x ) n ( f ` y ) ) ) } ) } $.
  $}

  ${
    $d M m n z f x y $. $d N m n z f x y $.
    $d X m n z f x y $. $d Y m n z f x y $.
    ismtyval.1 $e |- X = dom dom M $.
    ismtyval.2 $e |- Y = dom dom N $.
    $( The set of isometries between two metric spaces. $)
    ismtyval $p |- ( ( M e. Met /\ N e. Met ) -> ( M Ismty N ) =
                      { f | ( f : X -1-1-onto-> Y /\ A. x e. X A. y e. X
                            ( x M y ) = ( ( f ` x ) N ( f ` y ) ) ) } ) $=
      cM cme wcel cN cme wcel cX cY vf cv wf1o vx cv vy cv cM co vx cv vf cv
      cfv vy cv vf cv cfv cN co wceq vy cX wral vx cX wral wa vf cab cvv wcel
      cM cN cismty co cX cY vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv
      vf cv cfv cN co wceq vy cX wral vx cX wral wa vf cab wceq cX cY vf cv
      wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv cN co wceq vy cX
      wral vx cX wral wa vf cab cX cY vf cv wf vf cab wss cX cY vf cv wf vf cab
      cvv wcel cX cY vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv
      cfv cN co wceq vy cX wral vx cX wral wa vf cab cvv wcel cM cme wcel cN
      cme wcel wa cX cY vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf
      cv cfv cN co wceq vy cX wral vx cX wral wa vf cab cX cY vf cv wf vf cab
      cvv ssexg cX cY vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv
      cfv cN co wceq vy cX wral vx cX wral wa cX cY vf cv wf vf cX cY vf cv
      wf1o cX cY vf cv wf vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv cN
      co wceq vy cX wral vx cX wral cX cY vf cv f1of adantr ss2abi cX cvv wcel
      cY cvv wcel cX cY vf cv wf vf cab cvv wcel cM cme wcel cN cme wcel cX cY
      cvv cvv vf mapex cM cme wcel cM cdm cdm cvv cX cM cme wcel cM cdm cvv
      wcel cM cdm cdm cvv wcel cM cme dmexg cM cdm cvv dmexg syl ismtyval.1
      syl5eqel cN cme wcel cN cdm cdm cvv cY cN cme wcel cN cdm cvv wcel cN cdm
      cdm cvv wcel cN cme dmexg cN cdm cvv dmexg syl ismtyval.2 syl5eqel syl2an
      sylancr vm vn vz cM cN cme cme vm cv cdm cdm vn cv cdm cdm vf cv wf1o vx
      cv vy cv vm cv co vx cv vf cv cfv vy cv vf cv cfv vn cv co wceq vy vm cv
      cdm cdm wral vx vm cv cdm cdm wral wa vf cab cX cY vf cv wf1o vx cv vy cv
      cM co vx cv vf cv cfv vy cv vf cv cfv cN co wceq vy cX wral vx cX wral wa
      vf cab cismty cX vn cv cdm cdm vf cv wf1o vx cv vy cv cM co vx cv vf cv
      cfv vy cv vf cv cfv vn cv co wceq vy cX wral vx cX wral wa vf cab cvv vm
      cv cM wceq vm cv cdm cdm vn cv cdm cdm vf cv wf1o vx cv vy cv vm cv co vx
      cv vf cv cfv vy cv vf cv cfv vn cv co wceq vy vm cv cdm cdm wral vx vm cv
      cdm cdm wral wa cX vn cv cdm cdm vf cv wf1o vx cv vy cv cM co vx cv vf cv
      cfv vy cv vf cv cfv vn cv co wceq vy cX wral vx cX wral wa vf vm cv cM
      wceq vm cv cdm cdm vn cv cdm cdm vf cv wf1o cX vn cv cdm cdm vf cv wf1o
      vx cv vy cv vm cv co vx cv vf cv cfv vy cv vf cv cfv vn cv co wceq vy vm
      cv cdm cdm wral vx vm cv cdm cdm wral vx cv vy cv cM co vx cv vf cv cfv
      vy cv vf cv cfv vn cv co wceq vy cX wral vx cX wral vm cv cM wceq vm cv
      cdm cdm cX wceq vm cv cdm cdm vn cv cdm cdm vf cv wf1o cX vn cv cdm cdm
      vf cv wf1o wb vm cv cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm
      cv cdm cM cdm vm cv cM dmeq dmeqd ismtyval.1 syl6eqr vm cv cdm cdm cX vn
      cv cdm cdm vf cv f1oeq2 syl vm cv cM wceq vx cv vy cv vm cv co vx cv vf
      cv cfv vy cv vf cv cfv vn cv co wceq vy vm cv cdm cdm wral vx cv vy cv cM
      co vx cv vf cv cfv vy cv vf cv cfv vn cv co wceq vy cX wral vx vm cv cdm
      cdm cX vm cv cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm cv cdm
      cM cdm vm cv cM dmeq dmeqd ismtyval.1 syl6eqr vm cv cM wceq vx cv vy cv
      vm cv co vx cv vf cv cfv vy cv vf cv cfv vn cv co wceq vx cv vy cv cM co
      vx cv vf cv cfv vy cv vf cv cfv vn cv co wceq vy vm cv cdm cdm cX vm cv
      cM wceq vm cv cdm cdm cM cdm cdm cX vm cv cM wceq vm cv cdm cM cdm vm cv
      cM dmeq dmeqd ismtyval.1 syl6eqr vm cv cM wceq vx cv vy cv vm cv co vx cv
      vy cv cM co vx cv vf cv cfv vy cv vf cv cfv vn cv co vx cv vy cv vm cv cM
      opreq eqeq1d raleq12d raleq12d anbi12d abbidv vn cv cN wceq cX vn cv cdm
      cdm vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv vn cv co
      wceq vy cX wral vx cX wral wa cX cY vf cv wf1o vx cv vy cv cM co vx cv vf
      cv cfv vy cv vf cv cfv cN co wceq vy cX wral vx cX wral wa vf vn cv cN
      wceq cX vn cv cdm cdm vf cv wf1o cX cY vf cv wf1o vx cv vy cv cM co vx cv
      vf cv cfv vy cv vf cv cfv vn cv co wceq vy cX wral vx cX wral vx cv vy cv
      cM co vx cv vf cv cfv vy cv vf cv cfv cN co wceq vy cX wral vx cX wral vn
      cv cN wceq vn cv cdm cdm cY wceq cX vn cv cdm cdm vf cv wf1o cX cY vf cv
      wf1o wb vn cv cN wceq vn cv cdm cdm cN cdm cdm cY vn cv cN wceq vn cv cdm
      cN cdm vn cv cN dmeq dmeqd ismtyval.2 syl6eqr vn cv cdm cdm cY cX vf cv
      f1oeq3 syl vn cv cN wceq vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv
      cfv vn cv co wceq vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv cN co
      wceq vx vy cX cX vn cv cN wceq vx cv vf cv cfv vy cv vf cv cfv vn cv co
      vx cv vf cv cfv vy cv vf cv cfv cN co vx cv vy cv cM co vx cv vf cv cfv
      vy cv vf cv cfv vn cv cN opreq eqeq2d 2ralbidv anbi12d abbidv vx vy vz vf
      vm vn df-ismty oprabval2g mpd3an3 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M f x y $. $d N f x y $. $d X f x y $. $d Y f x y $. $d F f x y $.
    isismty.1 $e |- X = dom dom M $.
    isismty.2 $e |- Y = dom dom N $.
    $( The condition "is an isometry". $)
    isismty $p |- ( ( M e. Met /\ N e. Met ) -> ( F e. ( M Ismty N ) <->
                          ( F : X -1-1-onto-> Y /\ A. x e. X A. y e. X
                              ( x M y ) = ( ( F ` x ) N ( F ` y ) ) ) ) ) $=
      cM cme wcel cN cme wcel wa cF cM cN cismty co wcel cF cX cY vf cv wf1o vx
      cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv cN co wceq vy cX wral vx
      cX wral wa vf cab wcel cX cY cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv
      cF cfv cN co wceq vy cX wral vx cX wral wa cM cme wcel cN cme wcel wa cM
      cN cismty co cX cY vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf
      cv cfv cN co wceq vy cX wral vx cX wral wa vf cab cF vx vy vf cM cN cX cY
      isismty.1 isismty.2 ismtyval eleq2d cM cme wcel cN cme wcel wa cX cY cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral vx
      cX wral wa cF cvv wcel wi cF cX cY vf cv wf1o vx cv vy cv cM co vx cv vf
      cv cfv vy cv vf cv cfv cN co wceq vy cX wral vx cX wral wa vf cab wcel cX
      cY cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX
      wral vx cX wral wa wb cM cme wcel cN cme wcel wa cX cY cF wf1o cF cvv
      wcel vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral vx
      cX wral cM cme wcel cX cY cF wf1o cF cvv wcel wi cN cme wcel cX cY cF
      wf1o cM cme wcel cF cvv wcel cX cY cF wf cX cvv wcel cF cvv wcel cX cY cF
      wf1o cM cme wcel cX cY cvv cF fex cX cY cF f1of cM cme wcel cM cdm cdm
      cvv cX cM cme wcel cM cdm cvv wcel cM cdm cdm cvv wcel cM cme dmexg cM
      cdm cvv dmexg syl isismty.1 syl5eqel syl2an expcom adantr adantrd cX cY
      vf cv wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv cN co wceq
      vy cX wral vx cX wral wa cX cY cF wf1o vx cv vy cv cM co vx cv cF cfv vy
      cv cF cfv cN co wceq vy cX wral vx cX wral wa vf cF cvv vf cv cF wceq cX
      cY vf cv wf1o cX cY cF wf1o vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv
      cfv cN co wceq vy cX wral vx cX wral vx cv vy cv cM co vx cv cF cfv vy cv
      cF cfv cN co wceq vy cX wral vx cX wral cX cY vf cv cF f1oeq1 vf cv cF
      wceq vx cv vy cv cM co vx cv vf cv cfv vy cv vf cv cfv cN co wceq vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vx vy cX cX vf cv cF
      wceq vx cv vf cv cfv vy cv vf cv cfv cN co vx cv cF cfv vy cv cF cfv cN
      co vx cv vy cv cM co vf cv cF wceq vx cv vf cv cfv vx cv cF cfv vy cv vf
      cv cfv vy cv cF cfv cN vx cv vf cv cF fveq1 vy cv vf cv cF fveq1 opreq12d
      eqeq2d 2ralbidv anbi12d elab3g syl bitrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M u v x y $. $d N u v x y $. $d F u v x y $.
    $( The inverse of an isometry is an isometry. $)
    ismtycnv $p |- ( ( M e. Met /\ N e. Met ) ->
                      ( F e. ( M Ismty N ) -> `' F e. ( N Ismty M ) ) ) $=
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa cN cdm cdm cM cdm cdm cF ccnv wf1o vu cv vv cv cN co vu cv cF
      ccnv cfv vv cv cF ccnv cfv cM co wceq vv cN cdm cdm wral vu cN cdm cdm
      wral wa cF cM cN cismty co wcel cF ccnv cN cM cismty co wcel cM cdm cdm
      cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq
      vy cM cdm cdm wral vx cM cdm cdm wral wa cN cdm cdm cM cdm cdm cF ccnv
      wf1o vu cv vv cv cN co vu cv cF ccnv cfv vv cv cF ccnv cfv cM co wceq vv
      cN cdm cdm wral vu cN cdm cdm wral wa wi cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa cN cdm cdm cM cdm cdm cF
      ccnv wf1o vu cv vv cv cN co vu cv cF ccnv cfv vv cv cF ccnv cfv cM co
      wceq vv cN cdm cdm wral vu cN cdm cdm wral cM cdm cdm cN cdm cdm cF wf1o
      cN cdm cdm cM cdm cdm cF ccnv wf1o vx cv vy cv cM co vx cv cF cfv vy cv
      cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cdm cdm cN cdm
      cdm cF f1ocnv adantr cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx
      cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral
      wa vu cv vv cv cN co vu cv cF ccnv cfv vv cv cF ccnv cfv cM co wceq vu vv
      cN cdm cdm cN cdm cdm cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx
      cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral
      wa vu cv cN cdm cdm wcel vv cv cN cdm cdm wcel wa vu cv vv cv cN co vu cv
      cF ccnv cfv vv cv cF ccnv cfv cM co wceq cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa vu cv cN cdm cdm wcel vv cv cN cdm cdm wcel wa wa vu
      cv cF ccnv cfv vv cv cF ccnv cfv cM co vu cv cF ccnv cfv cF cfv vv cv cF
      ccnv cfv cF cfv cN co vu cv vv cv cN co cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa vu cv cN cdm cdm wcel vv cv cN cdm cdm wcel wa wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa vu cv cF ccnv cfv cM cdm
      cdm wcel vv cv cF ccnv cfv cM cdm cdm wcel wa wa vu cv cF ccnv cfv vv cv
      cF ccnv cfv cM co vu cv cF ccnv cfv cF cfv vv cv cF ccnv cfv cF cfv cN co
      wceq cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv
      cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa vu cv cN cdm
      cdm wcel vv cv cN cdm cdm wcel wa vu cv cF ccnv cfv cM cdm cdm wcel vv cv
      cF ccnv cfv cM cdm cdm wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv cN cdm
      cdm wcel vv cv cN cdm cdm wcel wa vu cv cF ccnv cfv cM cdm cdm wcel vv cv
      cF ccnv cfv cM cdm cdm wcel wa wi vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cdm cdm cN cdm
      cdm cF wf1o vu cv cN cdm cdm wcel vu cv cF ccnv cfv cM cdm cdm wcel vv cv
      cN cdm cdm wcel vv cv cF ccnv cfv cM cdm cdm wcel cM cdm cdm cN cdm cdm
      cF wf1o vu cv cN cdm cdm wcel vu cv cF ccnv cfv cM cdm cdm wcel cM cdm
      cdm cN cdm cdm vu cv cF f1ocnvdm ex cM cdm cdm cN cdm cdm cF wf1o vv cv
      cN cdm cdm wcel vv cv cF ccnv cfv cM cdm cdm wcel cM cdm cdm cN cdm cdm
      vv cv cF f1ocnvdm ex anim12d adantr imdistani vx cv vy cv cM co vx cv cF
      cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral vu cv
      cF ccnv cfv cM cdm cdm wcel vv cv cF ccnv cfv cM cdm cdm wcel wa vu cv cF
      ccnv cfv vv cv cF ccnv cfv cM co vu cv cF ccnv cfv cF cfv vv cv cF ccnv
      cfv cF cfv cN co wceq cM cdm cdm cN cdm cdm cF wf1o vu cv cF ccnv cfv cM
      cdm cdm wcel vv cv cF ccnv cfv cM cdm cdm wcel wa vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral vu
      cv cF ccnv cfv vv cv cF ccnv cfv cM co vu cv cF ccnv cfv cF cfv vv cv cF
      ccnv cfv cF cfv cN co wceq vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vu cv cF ccnv cfv vv cv cF ccnv cfv cM co vu cv cF ccnv cfv cF
      cfv vv cv cF ccnv cfv cF cfv cN co wceq vu cv cF ccnv cfv vy cv cM co vu
      cv cF ccnv cfv cF cfv vy cv cF cfv cN co wceq vx vy vu cv cF ccnv cfv vv
      cv cF ccnv cfv cM cdm cdm cM cdm cdm vx cv vu cv cF ccnv cfv wceq vx cv
      vy cv cM co vu cv cF ccnv cfv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      vu cv cF ccnv cfv cF cfv vy cv cF cfv cN co vx cv vu cv cF ccnv cfv vy cv
      cM opreq1 vx cv vu cv cF ccnv cfv wceq vx cv cF cfv vu cv cF ccnv cfv cF
      cfv vy cv cF cfv cN vx cv vu cv cF ccnv cfv cF fveq2 opreq1d eqeq12d vy
      cv vv cv cF ccnv cfv wceq vu cv cF ccnv cfv vy cv cM co vu cv cF ccnv cfv
      vv cv cF ccnv cfv cM co vu cv cF ccnv cfv cF cfv vy cv cF cfv cN co vu cv
      cF ccnv cfv cF cfv vv cv cF ccnv cfv cF cfv cN co vy cv vv cv cF ccnv cfv
      vu cv cF ccnv cfv cM opreq2 vy cv vv cv cF ccnv cfv wceq vy cv cF cfv vv
      cv cF ccnv cfv cF cfv vu cv cF ccnv cfv cF cfv cN vy cv vv cv cF ccnv cfv
      cF fveq2 opreq2d eqeq12d rcla42v impcom adantll syl cM cdm cdm cN cdm cdm
      cF wf1o vu cv cN cdm cdm wcel vv cv cN cdm cdm wcel wa vu cv cF ccnv cfv
      cF cfv vv cv cF ccnv cfv cF cfv cN co vu cv vv cv cN co wceq vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral cM cdm cdm cN cdm cdm cF wf1o vu cv cN cdm cdm wcel vv cv cN cdm
      cdm wcel wa wa vu cv cF ccnv cfv cF cfv vu cv vv cv cF ccnv cfv cF cfv vv
      cv cN cM cdm cdm cN cdm cdm cF wf1o vu cv cN cdm cdm wcel vu cv cF ccnv
      cfv cF cfv vu cv wceq vv cv cN cdm cdm wcel cM cdm cdm cN cdm cdm vu cv
      cF f1ocnvfv2 adantrr cM cdm cdm cN cdm cdm cF wf1o vv cv cN cdm cdm wcel
      vv cv cF ccnv cfv cF cfv vv cv wceq vu cv cN cdm cdm wcel cM cdm cdm cN
      cdm cdm vv cv cF f1ocnvfv2 adantrl opreq12d adantlr eqtr2d ex r19.21aivv
      jca a1i vx vy cF cM cN cM cdm cdm cN cdm cdm cM cdm cdm eqid cN cdm cdm
      eqid isismty cN cme wcel cM cme wcel cF ccnv cN cM cismty co wcel cN cdm
      cdm cM cdm cdm cF ccnv wf1o vu cv vv cv cN co vu cv cF ccnv cfv vv cv cF
      ccnv cfv cM co wceq vv cN cdm cdm wral vu cN cdm cdm wral wa wb vu vv cF
      ccnv cN cM cN cdm cdm cM cdm cdm cN cdm cdm eqid cM cdm cdm eqid isismty
      ancoms 3imtr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M q r s t u v w x y z $. $d N q r s t u v w x y z $.
    $d J q r s t u v w x y z $. $d K q r s t u v w x y z $.
    $d F q r s t u v w x y z $.
    ismtyhmeo.1 $e |- J = ( Open ` M ) $.
    ismtyhmeo.2 $e |- K = ( Open ` N ) $.
    $( Lemma for ~ ismtyhmeo . $)
    ismtyhmeolem $p |- ( ( ( M e. Met /\ N e. Met ) /\
                ( F : dom dom M -1-1-onto-> dom dom N /\ A. x e. dom dom M
                    A. y e. dom dom M ( x M y ) = ( ( F ` x ) N ( F ` y ) ) ) )
                                              -> A. u e. J ( F " u ) e. K ) $=
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa cF vu cv cima cK wcel vu cJ cM cme wcel cN cme wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss vv
      cv vs cv wcel vs cv vu cv wss wa vs cM cbl cfv crn wrex vv vu cv wral wa
      cF vu cv cima cN cdm cdm wss vw cv vt cv wcel vt cv cF vu cv cima wss wa
      vt cN cbl cfv crn wrex vw cF vu cv cima wral wa vu cv cJ wcel cF vu cv
      cima cK wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa wa vu cv cM cdm cdm wss vv cv vs cv wcel vs cv vu cv
      wss wa vs cM cbl cfv crn wrex vv vu cv wral wa vw cv vt cv wcel vt cv cF
      vu cv cima wss wa vt cN cbl cfv crn wrex vw cF vu cv cima wral cF vu cv
      cima cN cdm cdm wss cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss vv cv vs cv wcel vs cv
      vu cv wss wa vs cM cbl cfv crn wrex vv vu cv wral wa vw cv vt cv wcel vt
      cv cF vu cv cima wss wa vt cN cbl cfv crn wrex vw cF vu cv cima wral cM
      cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co
      vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa vu cv cM cdm cdm wss vv cv vs cv wcel vs cv vu cv wss wa vs cM
      cbl cfv crn wrex vv vu cv wral wa wa vw cv vt cv wcel vt cv cF vu cv cima
      wss wa vt cN cbl cfv crn wrex vw cF vu cv cima cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv
      cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm
      wss vv cv vs cv wcel vs cv vu cv wss wa vs cM cbl cfv crn wrex vv vu cv
      wral wa wa vw cv cF vu cv cima wcel vz cv cF cfv vw cv wceq vz vu cv wrex
      vw cv vt cv wcel vt cv cF vu cv cima wss wa vt cN cbl cfv crn wrex cM cdm
      cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral wa vw cv cF vu cv cima wcel vz
      cv cF cfv vw cv wceq vz vu cv wrex wi cM cme wcel cN cme wcel wa vu cv cM
      cdm cdm wss vv cv vs cv wcel vs cv vu cv wss wa vs cM cbl cfv crn wrex vv
      vu cv wral wa cM cdm cdm cN cdm cdm cF wf1o vw cv cF vu cv cima wcel vz
      cv cF cfv vw cv wceq vz vu cv wrex wi vx cv vy cv cM co vx cv cF cfv vy
      cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cdm cdm cN
      cdm cdm cF wf1o cF wfun vw cv cF vu cv cima wcel vz cv cF cfv vw cv wceq
      vz vu cv wrex wi cM cdm cdm cN cdm cdm cF f1ofun cF wfun vw cv cF vu cv
      cima wcel vz cv cF cfv vw cv wceq vz vu cv wrex vz vw cv vu cv cF fvelima
      ex syl adantr ad2antlr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm
      cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss vv cv vs cv wcel
      vs cv vu cv wss wa vs cM cbl cfv crn wrex vv vu cv wral vz cv cF cfv vw
      cv wceq vz vu cv wrex vw cv vt cv wcel vt cv cF vu cv cima wss wa vt cN
      cbl cfv crn wrex wi cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vv cv vs cv wcel vs
      cv vu cv wss wa vs cM cbl cfv crn wrex vv vu cv wral wa vz cv cF cfv vw
      cv wceq vw cv vt cv wcel vt cv cF vu cv cima wss wa vt cN cbl cfv crn
      wrex vz vu cv cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vv cv vs cv wcel vs cv vu
      cv wss wa vs cM cbl cfv crn wrex vv vu cv wral vz cv vu cv wcel vz cv cF
      cfv vw cv wceq vw cv vt cv wcel vt cv cF vu cv cima wss wa vt cN cbl cfv
      crn wrex wi cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vz cv vs cv wcel vs cv vu
      cv wss wa vs cM cbl cfv crn wrex vz cv cF cfv vw cv wceq vw cv vt cv wcel
      vt cv cF vu cv cima wss wa vt cN cbl cfv crn wrex wi vv cv vs cv wcel vs
      cv vu cv wss wa vs cM cbl cfv crn wrex vv vu cv wral vz cv vu cv wcel wa
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa vu cv cM cdm cdm wss wa vz cv vs cv wcel vs cv vu cv wss wa vs
      cM cbl cfv crn wrex vz cv cF cfv vw cv wceq vw cv vt cv wcel vt cv cF vu
      cv cima wss wa vt cN cbl cfv crn wrex wi cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss
      wa vz cv vs cv wcel vs cv vu cv wss wa vz cv cF cfv vw cv wceq vw cv vt
      cv wcel vt cv cF vu cv cima wss wa vt cN cbl cfv crn wrex wi vs cM cbl
      cfv crn cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vu cv cM cdm cdm wss wa vs cv cM cbl cfv crn wcel wa
      vz cv vs cv wcel vs cv vu cv wss wa vz cv cF cfv vw cv wceq vw cv vt cv
      wcel vt cv cF vu cv cima wss wa vt cN cbl cfv crn wrex cF vs cv cima cN
      cbl cfv crn wcel vw cv cF vs cv cima wcel cF vs cv cima cF vu cv cima wss
      vw cv vt cv wcel vt cv cF vu cv cima wss wa vt cN cbl cfv crn wrex cM cme
      wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa
      wa vu cv cM cdm cdm wss wa vs cv cM cbl cfv crn wcel wa vz cv vs cv wcel
      vs cv vu cv wss wa wa vz cv cF cfv vw cv wceq wa cM cme wcel cN cme wcel
      wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm
      cdm wss wa vs cv cM cbl cfv crn wcel wa cF vs cv cima cN cbl cfv crn wcel
      vz cv vs cv wcel vs cv vu cv wss wa vz cv cF cfv vw cv wceq cM cme wcel
      cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF
      cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa
      vs cv cM cbl cfv crn wcel cF vs cv cima cN cbl cfv crn wcel vu cv cM cdm
      cdm wss cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vs cv cM cbl cfv crn wcel cF vs cv cima cN cbl cfv crn
      wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral wa wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa
      vq cr wrex vv cM cdm cdm wrex cc0 vr cv clt wbr cF vs cv cima vw cv vr cv
      cN cbl cfv co wceq wa vr cr wrex vw cN cdm cdm wrex vs cv cM cbl cfv crn
      wcel cF vs cv cima cN cbl cfv crn wcel cM cme wcel cN cme wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa cc0 vq cv clt wbr vs cv
      vv cv vq cv cM cbl cfv co wceq wa cc0 vr cv clt wbr cF vs cv cima vw cv
      vr cv cN cbl cfv co wceq wa vr cr wrex vw cN cdm cdm wrex vv vq cM cdm
      cdm cr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa cc0 vr cv clt wbr cF vs cv
      cima vw cv vr cv cN cbl cfv co wceq wa vr cr wrex vw cN cdm cdm wrex vv
      cv cF cfv cN cdm cdm wcel cc0 vr cv clt wbr cF vs cv cima vv cv cF cfv vr
      cv cN cbl cfv co wceq wa vr cr wrex cc0 vr cv clt wbr cF vs cv cima vw cv
      vr cv cN cbl cfv co wceq wa vr cr wrex vw cN cdm cdm wrex cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv
      cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM
      cbl cfv co wceq wa wa wa cc0 vr cv clt wbr cF vs cv cima vw cv vr cv cN
      cbl cfv co wceq wa vr cr wrex cc0 vr cv clt wbr cF vs cv cima vv cv cF
      cfv vr cv cN cbl cfv co wceq wa vr cr wrex vw vv cv cF cfv cN cdm cdm vw
      cv vv cv cF cfv wceq cc0 vr cv clt wbr cF vs cv cima vw cv vr cv cN cbl
      cfv co wceq wa cc0 vr cv clt wbr cF vs cv cima vv cv cF cfv vr cv cN cbl
      cfv co wceq wa vr cr vw cv vv cv cF cfv wceq cF vs cv cima vw cv vr cv cN
      cbl cfv co wceq cF vs cv cima vv cv cF cfv vr cv cN cbl cfv co wceq cc0
      vr cv clt wbr vw cv vv cv cF cfv wceq vw cv vr cv cN cbl cfv co vv cv cF
      cfv vr cv cN cbl cfv co cF vs cv cima vw cv vv cv cF cfv vr cv cN cbl cfv
      opreq1 eqeq2d anbi2d rexbidv rcla4ev cM cdm cdm cN cdm cdm cF wf1o vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa vv cv cM cdm cdm wcel vq cv cr wcel wa vv cv cF cfv cN
      cdm cdm wcel cM cme wcel cN cme wcel wa cc0 vq cv clt wbr vs cv vv cv vq
      cv cM cbl cfv co wceq wa cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm
      wcel vv cv cF cfv cN cdm cdm wcel vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral vq cv cr wcel cM cdm
      cdm cN cdm cdm cF wf vv cv cM cdm cdm wcel vv cv cF cfv cN cdm cdm wcel
      cM cdm cdm cN cdm cdm cF wf1o cM cdm cdm cN cdm cdm vv cv cF ffvelrn cM
      cdm cdm cN cdm cdm cF f1of sylan ad2ant2r ad2ant2lr vq cv cr wcel cc0 vq
      cv clt wbr cF vs cv cima vv cv cF cfv vq cv cN cbl cfv co wceq cc0 vr cv
      clt wbr cF vs cv cima vv cv cF cfv vr cv cN cbl cfv co wceq wa vr cr wrex
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv
      vv cv vq cv cM cbl cfv co wceq wa wa wa cM cme wcel cN cme wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq
      cv cr wcel cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa
      simprlr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq simprrl cM cme wcel cN cme wcel
      wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm
      cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv
      co wceq wa wa wa vz cF vs cv cima vv cv cF cfv vq cv cN cbl cfv co cM cme
      wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa
      wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv
      vq cv cM cbl cfv co wceq wa wa wa vw cv cF cfv vz cv wceq vw vv cv vq cv
      cM cbl cfv co wrex vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv
      clt wbr wa vz cv cF vs cv cima wcel vz cv vv cv cF cfv vq cv cN cbl cfv
      co wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vw cv cF cfv vz cv wceq
      vw vv cv vq cv cM cbl cfv co wrex vz cv cN cdm cdm wcel vv cv cF cfv vz
      cv cN co vq cv clt wbr wa cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM
      cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel
      wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vw cv
      cF cfv vz cv wceq vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv
      clt wbr wa vw vv cv vq cv cM cbl cfv co cM cme wcel cN cme wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq
      cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa
      wa wa vw cv vv cv vq cv cM cbl cfv co wcel vw cv cF cfv vz cv wceq vz cv
      cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv
      cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM
      cbl cfv co wceq wa wa wa vw cv vv cv vq cv cM cbl cfv co wcel vw cv cF
      cfv vz cv wceq wa wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv
      clt wbr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vw cv vv cv vq cv cM
      cbl cfv co wcel vw cv cF cfv vz cv wceq wa wa vw cv cM cdm cdm wcel vz cv
      cN cdm cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vw cv vv cv vq cv
      cM cbl cfv co wcel vw cv cM cdm cdm wcel vw cv cF cfv vz cv wceq cM cme
      wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa
      wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv
      vq cv cM cbl cfv co wceq wa wa wa vw cv vv cv vq cv cM cbl cfv co wcel vw
      cv cM cdm cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0
      vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vv cv vq cv
      cM cbl cfv co cM cdm cdm vw cv cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy
      cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr
      wcel wa cc0 vq cv clt wbr vv cv vq cv cM cbl cfv co cM cdm cdm wss vs cv
      vv cv vq cv cM cbl cfv co wceq cM cme wcel cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr wa vv cv vq cv cM cbl cfv co cM cdm cdm wss cN cme wcel cM cme
      wcel cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vq cv cr wcel wa
      cc0 vq cv clt wbr wa vv cv vq cv cM cbl cfv co cM cdm cdm wss vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt
      wbr vv cv vq cv cM cbl cfv co cM cdm cdm wss cM cme wcel cM cdm cdm cN
      cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr wa wa cM vv cv vq cv cM cdm cdm cM cdm cdm eqid blssm cM cme wcel cM
      cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq
      cv clt wbr wa simpll cM cme wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv
      cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr simprll cM cme wcel cM
      cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq
      cv clt wbr simprlr cM cme wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM
      cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr simprr syl2anc adantlrr
      adantllr adantrrr sseld imp adantrr cM cme wcel cN cme wcel wa cM cdm cdm
      cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq
      vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv
      cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa
      wa vw cv vv cv vq cv cM cbl cfv co wcel vw cv cF cfv vz cv wceq vw cv cM
      cdm cdm wcel vz cv cN cdm cdm wcel wi cM cme wcel cN cme wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq
      cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa
      wa wa vw cv vv cv vq cv cM cbl cfv co wcel wa vw cv cF cfv vz cv wceq vw
      cv cM cdm cdm wcel vz cv cN cdm cdm wcel cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vw cv cF cfv vz cv
      wceq vw cv cM cdm cdm wcel wa vz cv cN cdm cdm wcel wi vv cv cM cdm cdm
      wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co
      wceq wa wa vw cv vv cv vq cv cM cbl cfv co wcel cM cdm cdm cN cdm cdm cF
      wf1o vw cv cF cfv vz cv wceq vw cv cM cdm cdm wcel wa vz cv cN cdm cdm
      wcel wi cM cme wcel cN cme wcel wa vx cv vy cv cM co vx cv cF cfv vy cv
      cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cdm cdm cN cdm
      cdm cF wf1o vw cv cM cdm cdm wcel vw cv cF cfv vz cv wceq vz cv cN cdm
      cdm wcel cM cdm cdm cN cdm cdm cF wf1o vw cv cM cdm cdm wcel vw cv cF cfv
      vz cv wceq vz cv cN cdm cdm wcel vw cv cF cfv vz cv wceq vw cv cF cfv cN
      cdm cdm wcel vz cv cN cdm cdm wcel cM cdm cdm cN cdm cdm cF wf1o vw cv cM
      cdm cdm wcel wa vw cv cF cfv vz cv cN cdm cdm eleq1 cM cdm cdm cN cdm cdm
      cF wf vw cv cM cdm cdm wcel vw cv cF cfv cN cdm cdm wcel cM cdm cdm cN
      cdm cdm cF wf1o cM cdm cdm cN cdm cdm vw cv cF ffvelrn cM cdm cdm cN cdm
      cdm cF f1of sylan syl5cbi expimpd ancomsd ad2antrl ad2antrr expdimp
      anasss mpd cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vw cv vv cv vq cv cM
      cbl cfv co wcel vw cv cF cfv vz cv wceq vv cv cF cfv vz cv cN co vq cv
      clt wbr vw cv cF cfv vz cv wceq vv cv cF cfv vw cv cF cfv cN co vq cv clt
      wbr vv cv cF cfv vz cv cN co vq cv clt wbr cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq
      wa wa wa vw cv vv cv vq cv cM cbl cfv co wcel wa vw cv cF cfv vz cv wceq
      vv cv cF cfv vw cv cF cfv cN co vv cv cF cfv vz cv cN co vq cv clt vw cv
      cF cfv vz cv vv cv cF cfv cN opreq2 breq1d cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq
      wa wa wa vw cv vv cv vq cv cM cbl cfv co wcel wa vv cv vw cv cM co vv cv
      cF cfv vw cv cF cfv cN co vq cv clt cM cme wcel cN cme wcel wa cM cdm cdm
      cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq
      vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv
      cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa
      wa vw cv vv cv vq cv cM cbl cfv co wcel wa vv cv cM cdm cdm wcel vw cv cM
      cdm cdm wcel vv cv vw cv cM co vv cv cF cfv vw cv cF cfv cN co wceq vv cv
      cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM
      cbl cfv co wceq wa wa vv cv cM cdm cdm wcel cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vw cv vv cv vq cv cM
      cbl cfv co wcel vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr vs
      cv vv cv vq cv cM cbl cfv co wceq wa simpll ad2antlr cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy
      cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM
      cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl
      cfv co wceq wa wa wa vw cv vv cv vq cv cM cbl cfv co wcel vw cv cM cdm
      cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vv cv vq cv cM cbl cfv
      co cM cdm cdm vw cv cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0
      vq cv clt wbr vv cv vq cv cM cbl cfv co cM cdm cdm wss vs cv vv cv vq cv
      cM cbl cfv co wceq cM cme wcel cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr wa
      vv cv vq cv cM cbl cfv co cM cdm cdm wss cN cme wcel cM cme wcel cM cdm
      cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr wa vv cv vq cv cM cbl cfv co cM cdm cdm wss vx cv vy cv cM co vx
      cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral
      cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr vv cv
      vq cv cM cbl cfv co cM cdm cdm wss cM cme wcel cM cdm cdm cN cdm cdm cF
      wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr wa wa cM
      vv cv vq cv cM cdm cdm cM cdm cdm eqid blssm cM cme wcel cM cdm cdm cN
      cdm cdm cF wf1o vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr
      wa simpll cM cme wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm
      wcel vq cv cr wcel cc0 vq cv clt wbr simprll cM cme wcel cM cdm cdm cN
      cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr
      simprlr cM cme wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm
      wcel vq cv cr wcel wa cc0 vq cv clt wbr simprr syl2anc adantlrr adantllr
      adantrrr sseld imp cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vw cv cM cdm cdm wcel
      wa vv cv vw cv cM co vv cv cF cfv vw cv cF cfv cN co wceq wi vv cv cM cdm
      cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv
      co wceq wa wa vw cv vv cv vq cv cM cbl cfv co wcel vx cv vy cv cM co vx
      cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral
      vv cv cM cdm cdm wcel vw cv cM cdm cdm wcel wa vv cv vw cv cM co vv cv cF
      cfv vw cv cF cfv cN co wceq wi cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vv cv cM cdm cdm wcel vw cv cM cdm cdm wcel wa vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral vv cv vw cv cM co vv cv cF cfv vw cv cF cfv cN co wceq vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vv cv vw cv cM co vv cv
      cF cfv vw cv cF cfv cN co wceq vv cv vy cv cM co vv cv cF cfv vy cv cF
      cfv cN co wceq vx vy vv cv vw cv cM cdm cdm cM cdm cdm vx cv vv cv wceq
      vx cv vy cv cM co vv cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co vv cv
      cF cfv vy cv cF cfv cN co vx cv vv cv vy cv cM opreq1 vx cv vv cv wceq vx
      cv cF cfv vv cv cF cfv vy cv cF cfv cN vx cv vv cv cF fveq2 opreq1d
      eqeq12d vy cv vw cv wceq vv cv vy cv cM co vv cv vw cv cM co vv cv cF cfv
      vy cv cF cfv cN co vv cv cF cfv vw cv cF cfv cN co vy cv vw cv vv cv cM
      opreq2 vy cv vw cv wceq vy cv cF cfv vw cv cF cfv vv cv cF cfv cN vy cv
      vw cv cF fveq2 opreq2d eqeq12d rcla42v com12 ad2antll ad2antrr mp2and cM
      cme wcel cN cme wcel wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa vw cv vv cv vq cv cM
      cbl cfv co wcel vv cv vw cv cM co vq cv clt wbr cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa cM cme wcel vv cv cM cdm cdm wcel vq cv cr
      wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa vw
      cv vv cv vq cv cM cbl cfv co wcel vv cv vw cv cM co vq cv clt wbr cN cme
      wcel cM cme wcel vw cv vv cv vq cv cM cbl cfv co wcel vv cv cM cdm cdm
      wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co
      wceq wa wa vv cv vw cv cM co vq cv clt wbr cM cme wcel vw cv vv cv vq cv
      cM cbl cfv co wcel wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr vv cv vw cv cM co vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co
      wceq cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr
      wa vw cv vv cv vq cv cM cbl cfv co wcel vv cv vw cv cM co vq cv clt wbr
      cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr wa
      wa vw cv vv cv vq cv cM cbl cfv co wcel vw cv cM cdm cdm wcel vv cv vw cv
      cM co vq cv clt wbr cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel cc0
      vq cv clt wbr vw cv vv cv vq cv cM cbl cfv co wcel vw cv cM cdm cdm wcel
      vv cv vw cv cM co vq cv clt wbr wa wb cM cme wcel vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr wa wa vw cv cM vv cv vq cv cM cdm cdm
      cM cdm cdm eqid elbl cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel wa
      cc0 vq cv clt wbr wa pm3.26 cM cme wcel vv cv cM cdm cdm wcel vq cv cr
      wcel cc0 vq cv clt wbr simprll cM cme wcel vv cv cM cdm cdm wcel vq cv cr
      wcel cc0 vq cv clt wbr simprlr cM cme wcel vv cv cM cdm cdm wcel vq cv cr
      wcel wa cc0 vq cv clt wbr simprr syl2anc pm3.27bda an1rs adantrrr an1rs
      adantllr adantllr eqbrtrrd syl5cbi impr jca expr r19.23adva cM cme wcel
      cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF
      cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa
      vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq
      cv cM cbl cfv co wceq wa wa wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv
      cN co vq cv clt wbr wa vw cv cF cfv vz cv wceq vw vv cv vq cv cM cbl cfv
      co wrex vz cv cF ccnv cfv vv cv vq cv cM cbl cfv co wcel vz cv cF ccnv
      cfv cF cfv vz cv wceq vw cv cF cfv vz cv wceq vw vv cv vq cv cM cbl cfv
      co wrex cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vz cv cN cdm cdm wcel
      vv cv cF cfv vz cv cN co vq cv clt wbr wa wa vw cv cF cfv vz cv wceq vz
      cv cF ccnv cfv cF cfv vz cv wceq vw vz cv cF ccnv cfv vv cv vq cv cM cbl
      cfv co vw cv vz cv cF ccnv cfv wceq vw cv cF cfv vz cv cF ccnv cfv cF cfv
      vz cv vw cv vz cv cF ccnv cfv cF fveq2 eqeq1d rcla4ev cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy
      cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM
      cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl
      cfv co wceq wa wa wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv
      clt wbr wa wa vz cv cF ccnv cfv vv cv vq cv cM cbl cfv co wcel vz cv cF
      ccnv cfv cM cdm cdm wcel vv cv vz cv cF ccnv cfv cM co vq cv clt wbr wa
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv
      vv cv vq cv cM cbl cfv co wceq wa wa wa vz cv cN cdm cdm wcel vv cv cF
      cfv vz cv cN co vq cv clt wbr wa wa vz cv cF ccnv cfv cM cdm cdm wcel vv
      cv vz cv cF ccnv cfv cM co vq cv clt wbr cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vz cv cN cdm cdm wcel
      vz cv cF ccnv cfv cM cdm cdm wcel vv cv cM cdm cdm wcel vq cv cr wcel wa
      cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa vv cv cF cfv
      vz cv cN co vq cv clt wbr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral cM cdm cdm cN cdm cdm cF wf1o vz cv cN cdm cdm wcel vz cv cF
      ccnv cfv cM cdm cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      vz cv cF f1ocnvdm adantll adantlrr ad2ant2r cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq
      wa wa wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr vv
      cv vz cv cF ccnv cfv cM co vq cv clt wbr cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq
      wa wa wa vz cv cN cdm cdm wcel wa vv cv vz cv cF ccnv cfv cM co vq cv clt
      wbr vv cv cF cfv vz cv cN co vq cv clt wbr cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq
      wa wa wa vz cv cN cdm cdm wcel wa vv cv vz cv cF ccnv cfv cM co vv cv cF
      cfv vz cv cN co vq cv clt cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM
      cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel
      wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vz cv
      cN cdm cdm wcel wa vv cv vz cv cF ccnv cfv cM co vv cv cF cfv vz cv cF
      ccnv cfv cF cfv cN co vv cv cF cfv vz cv cN co cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv
      cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm
      wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co
      wceq wa wa wa vz cv cN cdm cdm wcel wa vv cv cM cdm cdm wcel vz cv cF
      ccnv cfv cM cdm cdm wcel vv cv vz cv cF ccnv cfv cM co vv cv cF cfv vz cv
      cF ccnv cfv cF cfv cN co wceq vv cv cM cdm cdm wcel vq cv cr wcel wa cc0
      vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa vv cv cM cdm cdm
      wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral wa wa vz cv cN cdm cdm wcel vv cv cM cdm cdm wcel vq cv cr wcel
      cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa simpll ad2antlr
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel vv cv
      cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM
      cbl cfv co wceq wa wa cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral cM cdm cdm cN cdm cdm cF wf1o vz cv cN cdm cdm wcel vz cv cF
      ccnv cfv cM cdm cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      vz cv cF f1ocnvdm adantll adantlrr adantlr cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel
      vz cv cF ccnv cfv cM cdm cdm wcel wa vv cv vz cv cF ccnv cfv cM co vv cv
      cF cfv vz cv cF ccnv cfv cF cfv cN co wceq wi vv cv cM cdm cdm wcel vq cv
      cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa
      vz cv cN cdm cdm wcel vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral vv cv cM cdm cdm wcel vz cv cF
      ccnv cfv cM cdm cdm wcel wa vv cv vz cv cF ccnv cfv cM co vv cv cF cfv vz
      cv cF ccnv cfv cF cfv cN co wceq wi cM cme wcel cN cme wcel wa cM cdm cdm
      cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm
      wcel wa vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm
      cdm wral vx cM cdm cdm wral vv cv vz cv cF ccnv cfv cM co vv cv cF cfv vz
      cv cF ccnv cfv cF cfv cN co wceq vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vv cv vz cv cF ccnv cfv cM co vv cv cF cfv vz cv cF ccnv
      cfv cF cfv cN co wceq vv cv vy cv cM co vv cv cF cfv vy cv cF cfv cN co
      wceq vx vy vv cv vz cv cF ccnv cfv cM cdm cdm cM cdm cdm vx cv vv cv wceq
      vx cv vy cv cM co vv cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co vv cv
      cF cfv vy cv cF cfv cN co vx cv vv cv vy cv cM opreq1 vx cv vv cv wceq vx
      cv cF cfv vv cv cF cfv vy cv cF cfv cN vx cv vv cv cF fveq2 opreq1d
      eqeq12d vy cv vz cv cF ccnv cfv wceq vv cv vy cv cM co vv cv vz cv cF
      ccnv cfv cM co vv cv cF cfv vy cv cF cfv cN co vv cv cF cfv vz cv cF ccnv
      cfv cF cfv cN co vy cv vz cv cF ccnv cfv vv cv cM opreq2 vy cv vz cv cF
      ccnv cfv wceq vy cv cF cfv vz cv cF ccnv cfv cF cfv vv cv cF cfv cN vy cv
      vz cv cF ccnv cfv cF fveq2 opreq2d eqeq12d rcla42v com12 ad2antll
      ad2antrr mp2and cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vz cv cN cdm cdm
      wcel wa vz cv cF ccnv cfv cF cfv vz cv vv cv cF cfv cN cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy
      cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vz cv cN
      cdm cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq vv cv cM cdm cdm wcel vq
      cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa
      wa cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vz cv cN cdm
      cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq vx cv vy cv cM co vx cv cF
      cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cdm
      cdm cN cdm cdm cF wf1o vz cv cN cdm cdm wcel vz cv cF ccnv cfv cF cfv vz
      cv wceq cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm vz cv cF
      f1ocnvfv2 adantll adantlrr adantlr opreq2d eqtrd breq1d biimpar anasss
      jca cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr vz
      cv cF ccnv cfv vv cv vq cv cM cbl cfv co wcel vz cv cF ccnv cfv cM cdm
      cdm wcel vv cv vz cv cF ccnv cfv cM co vq cv clt wbr wa wb cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv
      cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM
      cbl cfv co wceq wa wa wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co
      vq cv clt wbr wa wa vz cv cF ccnv cfv cM vv cv vq cv cM cdm cdm cM cdm
      cdm eqid elbl cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa wa cM cme wcel vv cv cM cdm cdm wcel vq cv cr wcel wa
      cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa vz cv cN cdm
      cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa cM cme wcel cN cme
      wcel cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv
      cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa simpll
      ad2antrr vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv
      vv cv vq cv cM cbl cfv co wceq wa wa vv cv cM cdm cdm wcel cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vz cv
      cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa vv cv cM cdm
      cdm wcel vq cv cr wcel cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co
      wceq wa simpll ad2antlr vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa vq cv cr wcel cM cme
      wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa
      wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa vv cv
      cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl
      cfv co wceq wa simplr ad2antlr vv cv cM cdm cdm wcel vq cv cr wcel wa cc0
      vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa cc0 vq cv clt
      wbr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral wa wa vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt
      wbr wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv
      cv vq cv cM cbl cfv co wceq simprl ad2antlr syl2anc mpbird cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vz cv
      cN cdm cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq
      wa wa vv cv cF cfv vz cv cN co vq cv clt wbr cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vz cv cN cdm cdm wcel vz cv cF ccnv cfv cF
      cfv vz cv wceq vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy
      cM cdm cdm wral vx cM cdm cdm wral cM cdm cdm cN cdm cdm cF wf1o vz cv cN
      cdm cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq cM cme wcel cN cme wcel
      wa cM cdm cdm cN cdm cdm vz cv cF f1ocnvfv2 adantll adantlrr ad2ant2r
      sylanc ex impbid cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv
      clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa wa vz cv cF vs cv cima
      wcel vz cv cF vv cv vq cv cM cbl cfv co cima wcel vw cv cF cfv vz cv wceq
      vw vv cv vq cv cM cbl cfv co wrex cM cme wcel cN cme wcel wa cM cdm cdm
      cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq
      vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv
      cr wcel wa cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa wa
      wa cF vs cv cima cF vv cv vq cv cM cbl cfv co cima vz cv cc0 vq cv clt
      wbr vs cv vv cv vq cv cM cbl cfv co wceq wa cF vs cv cima cF vv cv vq cv
      cM cbl cfv co cima wceq cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm
      cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr wcel wa
      vs cv vv cv vq cv cM cbl cfv co wceq cF vs cv cima cF vv cv vq cv cM cbl
      cfv co cima wceq cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co cF
      imaeq2 adantl ad2antll eleq2d cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy
      cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv cM cdm cdm wcel vq cv cr
      wcel wa cc0 vq cv clt wbr vz cv cF vv cv vq cv cM cbl cfv co cima wcel vw
      cv cF cfv vz cv wceq vw vv cv vq cv cM cbl cfv co wrex wb vs cv vv cv vq
      cv cM cbl cfv co wceq cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr wa vz cv cF
      vv cv vq cv cM cbl cfv co cima wcel vw cv cF cfv vz cv wceq vw vv cv vq
      cv cM cbl cfv co wrex wb vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cme wcel cM cdm cdm cN
      cdm cdm cF wf1o vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr
      wa vz cv cF vv cv vq cv cM cbl cfv co cima wcel vw cv cF cfv vz cv wceq
      vw vv cv vq cv cM cbl cfv co wrex wb cN cme wcel cF cM cdm cdm wfn vv cv
      vq cv cM cbl cfv co cM cdm cdm wss vz cv cF vv cv vq cv cM cbl cfv co
      cima wcel vw cv cF cfv vz cv wceq vw vv cv vq cv cM cbl cfv co wrex wb cM
      cme wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr
      wcel wa cc0 vq cv clt wbr wa wa vw cM cdm cdm vv cv vq cv cM cbl cfv co
      vz cv cF fvelimab cM cdm cdm cN cdm cdm cF wf1o cF cM cdm cdm wfn cM cme
      wcel vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr wa cM cdm
      cdm cN cdm cdm cF f1ofn ad2antlr cM cme wcel vv cv cM cdm cdm wcel vq cv
      cr wcel cc0 vq cv clt wbr vv cv vq cv cM cbl cfv co cM cdm cdm wss cM cme
      wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel
      wa cc0 vq cv clt wbr wa wa cM vv cv vq cv cM cdm cdm cM cdm cdm eqid
      blssm cM cme wcel cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vq
      cv cr wcel wa cc0 vq cv clt wbr wa simpll cM cme wcel cM cdm cdm cN cdm
      cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr
      simprll cM cme wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm
      wcel vq cv cr wcel cc0 vq cv clt wbr simprlr cM cme wcel cM cdm cdm cN
      cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt
      wbr simprr syl2anc sylanc adantllr adantlrr adantrrr bitrd cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vv cv
      cM cdm cdm wcel vq cv cr wcel wa cc0 vq cv clt wbr vz cv vv cv cF cfv vq
      cv cN cbl cfv co wcel vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq
      cv clt wbr wa wb vs cv vv cv vq cv cM cbl cfv co wceq cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vq cv cr wcel
      wa cc0 vq cv clt wbr wa vz cv vv cv cF cfv vq cv cN cbl cfv co wcel vz cv
      cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa wb vx cv vy cv
      cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm
      cdm wral cN cme wcel cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel
      vq cv cr wcel wa cc0 vq cv clt wbr wa vz cv vv cv cF cfv vq cv cN cbl cfv
      co wcel vz cv cN cdm cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa
      wb cM cme wcel cN cme wcel vv cv cF cfv cN cdm cdm wcel vq cv cr wcel cc0
      vq cv clt wbr vz cv vv cv cF cfv vq cv cN cbl cfv co wcel vz cv cN cdm
      cdm wcel vv cv cF cfv vz cv cN co vq cv clt wbr wa wb cN cme wcel cM cdm
      cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel wa cc0 vq
      cv clt wbr wa wa vz cv cN vv cv cF cfv vq cv cN cdm cdm cN cdm cdm eqid
      elbl cN cme wcel cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm wcel vq
      cv cr wcel wa cc0 vq cv clt wbr wa simpll cM cdm cdm cN cdm cdm cF wf1o
      vv cv cM cdm cdm wcel vq cv cr wcel wa vv cv cF cfv cN cdm cdm wcel cN
      cme wcel cc0 vq cv clt wbr cM cdm cdm cN cdm cdm cF wf1o vv cv cM cdm cdm
      wcel vv cv cF cfv cN cdm cdm wcel vq cv cr wcel cM cdm cdm cN cdm cdm cF
      wf vv cv cM cdm cdm wcel vv cv cF cfv cN cdm cdm wcel cM cdm cdm cN cdm
      cdm cF wf1o cM cdm cdm cN cdm cdm vv cv cF ffvelrn cM cdm cdm cN cdm cdm
      cF f1of sylan adantrr ad2ant2lr cN cme wcel cM cdm cdm cN cdm cdm cF wf1o
      wa vv cv cM cdm cdm wcel vq cv cr wcel cc0 vq cv clt wbr simprlr cN cme
      wcel cM cdm cdm cN cdm cdm cF wf1o wa vv cv cM cdm cdm wcel vq cv cr wcel
      wa cc0 vq cv clt wbr simprr syl2anc adantlll adantlrr adantrrr 3bitr4d
      eqrdv cc0 vr cv clt wbr cF vs cv cima vv cv cF cfv vr cv cN cbl cfv co
      wceq wa cc0 vq cv clt wbr cF vs cv cima vv cv cF cfv vq cv cN cbl cfv co
      wceq wa vr vq cv cr vr cv vq cv wceq cc0 vr cv clt wbr cc0 vq cv clt wbr
      cF vs cv cima vv cv cF cfv vr cv cN cbl cfv co wceq cF vs cv cima vv cv
      cF cfv vq cv cN cbl cfv co wceq vr cv vq cv cc0 clt breq2 vr cv vq cv
      wceq vv cv cF cfv vr cv cN cbl cfv co vv cv cF cfv vq cv cN cbl cfv co cF
      vs cv cima vr cv vq cv vv cv cF cfv cN cbl cfv opreq2 eqeq2d anbi12d
      rcla4ev sylan32c sylanc exp32 r19.23advv cM cme wcel vs cv cM cbl cfv crn
      wcel cc0 vq cv clt wbr vs cv vv cv vq cv cM cbl cfv co wceq wa vq cr wrex
      vv cM cdm cdm wrex wb cN cme wcel cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa vv vq vs cv cM cM cdm cdm cM cdm cdm eqid blrn3 ad2antrr
      cN cme wcel cF vs cv cima cN cbl cfv crn wcel cc0 vr cv clt wbr cF vs cv
      cima vw cv vr cv cN cbl cfv co wceq wa vr cr wrex vw cN cdm cdm wrex wb
      cM cme wcel cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa vw vr cF
      vs cv cima cN cN cdm cdm cN cdm cdm eqid blrn3 ad2antlr 3imtr4d imp
      adantlr ad2antrr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vs cv cM cbl cfv crn
      wcel wa vz cv vs cv wcel vs cv vu cv wss wa wa vz cv cF cfv vw cv wceq vw
      cv cF vs cv cima wcel vz cv cF cfv vw cv wceq vz cv cF cfv cF vs cv cima
      wcel vw cv cF vs cv cima wcel cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy
      cM cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vs cv cM
      cbl cfv crn wcel wa vz cv vs cv wcel vs cv vu cv wss wa wa vz cv cF cfv
      vw cv cF vs cv cima eleq1 cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM
      cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vs cv cM
      cbl cfv crn wcel wa vs cv vu cv wss vz cv vs cv wcel vz cv cF cfv cF vs
      cv cima wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vs cv cM cbl cfv crn wcel
      wa vs cv vu cv wss vz cv vs cv wcel vz cv cF cfv cF vs cv cima wcel cM
      cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co
      vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa wa vu cv cM cdm cdm wss wa vs cv vu cv wss vz cv vs cv wcel vz cv
      cF cfv cF vs cv cima wcel wi vs cv cM cbl cfv crn wcel cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy
      cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa wa vu cv cM
      cdm cdm wss vs cv vu cv wss vz cv vs cv wcel vz cv cF cfv cF vs cv cima
      wcel wi cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa wa vs cv cM cdm cdm wss vz cv vs cv wcel vz cv cF cfv cF
      vs cv cima wcel wi vu cv cM cdm cdm wss vs cv vu cv wss wa cM cdm cdm cN
      cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy
      cM cdm cdm wral vx cM cdm cdm wral wa vs cv cM cdm cdm wss vz cv vs cv
      wcel vz cv cF cfv cF vs cv cima wcel wi cM cme wcel cN cme wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vs cv cM cdm cdm wss vz cv vs cv wcel vz cv cF cfv
      cF vs cv cima wcel wi vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co
      wceq vy cM cdm cdm wral vx cM cdm cdm wral cF wfun vs cv cF cdm wss vz cv
      vs cv wcel vz cv cF cfv cF vs cv cima wcel wi cM cdm cdm cN cdm cdm cF
      wf1o vs cv cM cdm cdm wss wa vs cv vz cv cF funfvima2 cM cdm cdm cN cdm
      cdm cF wf1o cF wfun vs cv cM cdm cdm wss cM cdm cdm cN cdm cdm cF f1ofun
      adantr cM cdm cdm cN cdm cdm cF wf1o vs cv cF cdm wss vs cv cM cdm cdm
      wss cM cdm cdm cN cdm cdm cF wf1o cF cdm cM cdm cdm vs cv cM cdm cdm cN
      cdm cdm cF wf1o cM cdm cdm cN cdm cdm cF wf cF cdm cM cdm cdm wceq cM cdm
      cdm cN cdm cdm cF f1of cM cdm cdm cN cdm cdm cF fdm syl sseq2d biimpar
      sylanc adantlr adantll vs cv vu cv wss vu cv cM cdm cdm wss vs cv cM cdm
      cdm wss vs cv vu cv cM cdm cdm sstr ancoms sylan2 anassrs adantlr impr
      ancom2s syl5cbi imp vz cv vs cv wcel vs cv vu cv wss wa cF vs cv cima cF
      vu cv cima wss cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa wa vu cv cM cdm cdm wss wa vs cv cM cbl cfv crn
      wcel wa vz cv cF cfv vw cv wceq vs cv vu cv wss cF vs cv cima cF vu cv
      cima wss vz cv vs cv wcel vs cv vu cv cF imass2 adantl ad2antlr vw cv vt
      cv wcel vt cv cF vu cv cima wss wa vw cv cF vs cv cima wcel cF vs cv cima
      cF vu cv cima wss wa vt cF vs cv cima cN cbl cfv crn vt cv cF vs cv cima
      wceq vw cv vt cv wcel vw cv cF vs cv cima wcel vt cv cF vu cv cima wss cF
      vs cv cima cF vu cv cima wss vt cv cF vs cv cima vw cv eleq2 vt cv cF vs
      cv cima cF vu cv cima sseq1 anbi12d rcla4ev sylan32c exp31 r19.23adva imp
      vv cv vs cv wcel vs cv vu cv wss wa vs cM cbl cfv crn wrex vz cv vs cv
      wcel vs cv vu cv wss wa vs cM cbl cfv crn wrex vv vz cv vu cv vv cv vz cv
      wceq vv cv vs cv wcel vs cv vu cv wss wa vz cv vs cv wcel vs cv vu cv wss
      wa vs cM cbl cfv crn vv cv vz cv wceq vv cv vs cv wcel vz cv vs cv wcel
      vs cv vu cv wss vv vz vs elequ1 anbi1d rexbidv rcla4cva sylan2 anassrs
      r19.23adva anasss syld r19.21aiv ex cM cdm cdm cN cdm cdm cF wf1o cF vu
      cv cima cN cdm cdm wss cM cme wcel cN cme wcel wa vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM
      cdm cdm cN cdm cdm cF wf1o cM cdm cdm cN cdm cdm cF wfo cF crn cN cdm cdm
      wceq cF vu cv cima cN cdm cdm wss cM cdm cdm cN cdm cdm cF f1ofo cM cdm
      cdm cN cdm cdm cF forn cF crn cN cdm cdm wceq cF vu cv cima cF crn wss cF
      vu cv cima cN cdm cdm wss cF vu cv imassrn cF crn cN cdm cdm cF vu cv
      cima sseq2 mpbii 3syl ad2antrl jctild cM cme wcel vu cv cJ wcel vu cv cM
      cdm cdm wss vv cv vs cv wcel vs cv vu cv wss wa vs cM cbl cfv crn wrex vv
      vu cv wral wa wb cN cme wcel cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa vv vs vu cv cM cJ cM cdm cdm cM cdm cdm eqid ismtyhmeo.1 isopn
      ad2antrr cN cme wcel cF vu cv cima cK wcel cF vu cv cima cN cdm cdm wss
      vw cv vt cv wcel vt cv cF vu cv cima wss wa vt cN cbl cfv crn wrex vw cF
      vu cv cima wral wa wb cM cme wcel cM cdm cdm cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM
      cdm cdm wral wa vw vt cF vu cv cima cN cK cN cdm cdm cN cdm cdm eqid
      ismtyhmeo.2 isopn ad2antlr 3imtr4d r19.21aiv $.
      $( [2-Sep-2009] $)

    $( An isometry is a homeomorphism on the induced topology. $)
    ismtyhmeo $p |- ( ( M e. Met /\ N e. Met ) ->
                            ( F e. ( M Ismty N ) -> F e. ( J Homeo K ) ) ) $=
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa cJ cuni cK cuni cF wf1o cF vu cv cima cK wcel vu cJ wral cF ccnv
      vu cv cima cJ wcel vu cK wral w3a cF cM cN cismty co wcel cF cJ cK
      chomeosm co wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa cJ cuni cK cuni cF wf1o cF vu cv cima cK wcel vu cJ
      wral cF ccnv vu cv cima cJ wcel vu cK wral cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o cJ cuni cK cuni cF wf1o vx cv vy cv cM co vx
      cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o cJ cuni cK cuni
      cF wf1o cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o cJ cuni
      cN cdm cdm cF wf1o cJ cuni cK cuni cF wf1o cM cme wcel cN cme wcel wa cM
      cdm cdm cJ cuni wceq cM cdm cdm cN cdm cdm cF wf1o cJ cuni cN cdm cdm cF
      wf1o wb cM cme wcel cM cdm cdm cJ cuni wceq cN cme wcel cM cme wcel cJ
      cuni cM cdm cdm cM cJ cM cdm cdm cM cdm cdm eqid ismtyhmeo.1 uniopn2
      eqcomd adantr cM cdm cdm cJ cuni cN cdm cdm cF f1oeq2 syl cM cme wcel cN
      cme wcel wa cN cdm cdm cK cuni wceq cJ cuni cN cdm cdm cF wf1o cJ cuni cK
      cuni cF wf1o wb cN cme wcel cN cdm cdm cK cuni wceq cM cme wcel cN cme
      wcel cK cuni cN cdm cdm cN cK cN cdm cdm cN cdm cdm eqid ismtyhmeo.2
      uniopn2 eqcomd adantl cN cdm cdm cK cuni cJ cuni cF f1oeq3 syl bitrd
      biimpd adantrd cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral
      vx cM cdm cdm wral wa cF vu cv cima cK wcel vu cJ wral vx vy vu cF cJ cK
      cM cN ismtyhmeo.1 ismtyhmeo.2 ismtyhmeolem ex cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv
      cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa cF ccnv vu cv cima cJ
      wcel vu cK wral cN cme wcel cM cme wcel cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa cF ccnv vu cv cima cJ wcel vu cK wral cN cme wcel cM
      cme wcel wa cN cdm cdm cM cdm cdm cF ccnv wf1o vs cv vt cv cN co vs cv cF
      ccnv cfv vt cv cF ccnv cfv cM co wceq vt cN cdm cdm wral vs cN cdm cdm
      wral wa cF ccnv vu cv cima cJ wcel vu cK wral cM cdm cdm cN cdm cdm cF
      wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm
      wral vx cM cdm cdm wral wa vs vt vu cF ccnv cK cJ cN cM ismtyhmeo.2
      ismtyhmeo.1 ismtyhmeolem cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co
      vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa cN cdm cdm cM cdm cdm cF ccnv wf1o vs cv vt cv cN co vs cv cF
      ccnv cfv vt cv cF ccnv cfv cM co wceq vt cN cdm cdm wral vs cN cdm cdm
      wral cM cdm cdm cN cdm cdm cF wf1o cN cdm cdm cM cdm cdm cF ccnv wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral cM cdm cdm cN cdm cdm cF f1ocnv adantr cM cdm cdm cN cdm
      cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM
      cdm cdm wral vx cM cdm cdm wral wa vs cv vt cv cN co vs cv cF ccnv cfv vt
      cv cF ccnv cfv cM co wceq vs vt cN cdm cdm cN cdm cdm cM cdm cdm cN cdm
      cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM
      cdm cdm wral vx cM cdm cdm wral wa vs cv cN cdm cdm wcel vt cv cN cdm cdm
      wcel wa vs cv vt cv cN co vs cv cF ccnv cfv vt cv cF ccnv cfv cM co wceq
      cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv
      cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa vs cv cN cdm cdm wcel
      vt cv cN cdm cdm wcel wa wa vs cv cF ccnv cfv vt cv cF ccnv cfv cM co vs
      cv cF ccnv cfv cF cfv vt cv cF ccnv cfv cF cfv cN co vs cv vt cv cN co cM
      cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cM cdm cdm wral vx cM cdm cdm wral wa vs cv cN cdm cdm wcel vt
      cv cN cdm cdm wcel wa wa cM cdm cdm cN cdm cdm cF wf1o vx cv vy cv cM co
      vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm
      wral wa vs cv cF ccnv cfv cM cdm cdm wcel vt cv cF ccnv cfv cM cdm cdm
      wcel wa wa vs cv cF ccnv cfv vt cv cF ccnv cfv cM co vs cv cF ccnv cfv cF
      cfv vt cv cF ccnv cfv cF cfv cN co wceq cM cdm cdm cN cdm cdm cF wf1o vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral wa vs cv cN cdm cdm wcel vt cv cN cdm cdm wcel wa vs cv
      cF ccnv cfv cM cdm cdm wcel vt cv cF ccnv cfv cM cdm cdm wcel wa cM cdm
      cdm cN cdm cdm cF wf1o vs cv cN cdm cdm wcel vt cv cN cdm cdm wcel wa vs
      cv cF ccnv cfv cM cdm cdm wcel vt cv cF ccnv cfv cM cdm cdm wcel wa wi vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx
      cM cdm cdm wral cM cdm cdm cN cdm cdm cF wf1o vs cv cN cdm cdm wcel vs cv
      cF ccnv cfv cM cdm cdm wcel vt cv cN cdm cdm wcel vt cv cF ccnv cfv cM
      cdm cdm wcel cM cdm cdm cN cdm cdm cF wf1o vs cv cN cdm cdm wcel vs cv cF
      ccnv cfv cM cdm cdm wcel cM cdm cdm cN cdm cdm vs cv cF f1ocnvdm ex cM
      cdm cdm cN cdm cdm cF wf1o vt cv cN cdm cdm wcel vt cv cF ccnv cfv cM cdm
      cdm wcel cM cdm cdm cN cdm cdm vt cv cF f1ocnvdm ex anim12d adantr
      imdistani vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cM
      cdm cdm wral vx cM cdm cdm wral vs cv cF ccnv cfv cM cdm cdm wcel vt cv
      cF ccnv cfv cM cdm cdm wcel wa vs cv cF ccnv cfv vt cv cF ccnv cfv cM co
      vs cv cF ccnv cfv cF cfv vt cv cF ccnv cfv cF cfv cN co wceq cM cdm cdm
      cN cdm cdm cF wf1o vs cv cF ccnv cfv cM cdm cdm wcel vt cv cF ccnv cfv cM
      cdm cdm wcel wa vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy
      cM cdm cdm wral vx cM cdm cdm wral vs cv cF ccnv cfv vt cv cF ccnv cfv cM
      co vs cv cF ccnv cfv cF cfv vt cv cF ccnv cfv cF cfv cN co wceq vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vs cv cF ccnv cfv vt cv cF
      ccnv cfv cM co vs cv cF ccnv cfv cF cfv vt cv cF ccnv cfv cF cfv cN co
      wceq vs cv cF ccnv cfv vy cv cM co vs cv cF ccnv cfv cF cfv vy cv cF cfv
      cN co wceq vx vy vs cv cF ccnv cfv vt cv cF ccnv cfv cM cdm cdm cM cdm
      cdm vx cv vs cv cF ccnv cfv wceq vx cv vy cv cM co vs cv cF ccnv cfv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co vs cv cF ccnv cfv cF cfv vy cv
      cF cfv cN co vx cv vs cv cF ccnv cfv vy cv cM opreq1 vx cv vs cv cF ccnv
      cfv wceq vx cv cF cfv vs cv cF ccnv cfv cF cfv vy cv cF cfv cN vx cv vs
      cv cF ccnv cfv cF fveq2 opreq1d eqeq12d vy cv vt cv cF ccnv cfv wceq vs
      cv cF ccnv cfv vy cv cM co vs cv cF ccnv cfv vt cv cF ccnv cfv cM co vs
      cv cF ccnv cfv cF cfv vy cv cF cfv cN co vs cv cF ccnv cfv cF cfv vt cv
      cF ccnv cfv cF cfv cN co vy cv vt cv cF ccnv cfv vs cv cF ccnv cfv cM
      opreq2 vy cv vt cv cF ccnv cfv wceq vy cv cF cfv vt cv cF ccnv cfv cF cfv
      vs cv cF ccnv cfv cF cfv cN vy cv vt cv cF ccnv cfv cF fveq2 opreq2d
      eqeq12d rcla42v impcom adantll syl cM cdm cdm cN cdm cdm cF wf1o vs cv cN
      cdm cdm wcel vt cv cN cdm cdm wcel wa vs cv cF ccnv cfv cF cfv vt cv cF
      ccnv cfv cF cfv cN co vs cv vt cv cN co wceq vx cv vy cv cM co vx cv cF
      cfv vy cv cF cfv cN co wceq vy cM cdm cdm wral vx cM cdm cdm wral cM cdm
      cdm cN cdm cdm cF wf1o vs cv cN cdm cdm wcel vt cv cN cdm cdm wcel wa wa
      vs cv cF ccnv cfv cF cfv vs cv vt cv cF ccnv cfv cF cfv vt cv cN cM cdm
      cdm cN cdm cdm cF wf1o vs cv cN cdm cdm wcel vs cv cF ccnv cfv cF cfv vs
      cv wceq vt cv cN cdm cdm wcel cM cdm cdm cN cdm cdm vs cv cF f1ocnvfv2
      adantrr cM cdm cdm cN cdm cdm cF wf1o vt cv cN cdm cdm wcel vt cv cF ccnv
      cfv cF cfv vt cv wceq vs cv cN cdm cdm wcel cM cdm cdm cN cdm cdm vt cv
      cF f1ocnvfv2 adantrl opreq12d adantlr eqtr2d ex r19.21aivv jca sylan2
      ancom1s ex 3jcad vx vy cF cM cN cM cdm cdm cN cdm cdm cM cdm cdm eqid cN
      cdm cdm eqid isismty cJ ctop wcel cK ctop wcel cF cJ cK chomeosm co wcel
      cJ cuni cK cuni cF wf1o cF vu cv cima cK wcel vu cJ wral cF ccnv vu cv
      cima cJ wcel vu cK wral w3a wb cM cme wcel cN cme wcel vu cF cJ cK cJ
      cuni cK cuni cJ cuni eqid cK cuni eqid ishomeo2 cM cJ ismtyhmeo.1 opntop
      cN cK ismtyhmeo.2 opntop syl2an 3imtr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M r u v x y z $. $d N r u v x y z $. $d F r u v x y z $.
    $( Lemma for ~ ismtybnd . $)
    ismtybndlem $p |- ( ( M e. Met /\ N e. Met /\ F e. ( M Ismty N ) )
                                              -> ( M e. Bnd -> N e. Bnd ) ) $=
      cM cme wcel cN cme wcel cF cM cN cismty co wcel w3a cM cdm cdm vx cv vr
      cv cM cbl cfv co wceq vr crp wrex vx cM cdm cdm wral cN cdm cdm vy cv vr
      cv cN cbl cfv co wceq vr crp wrex vy cN cdm cdm wral cM cbnd wcel cN cbnd
      wcel cM cme wcel cN cme wcel cF cM cN cismty co wcel cM cdm cdm vx cv vr
      cv cM cbl cfv co wceq vr crp wrex vx cM cdm cdm wral cN cdm cdm vy cv vr
      cv cN cbl cfv co wceq vr crp wrex vy cN cdm cdm wral wi cM cme wcel cN
      cme wcel wa cF cM cN cismty co wcel cM cdm cdm cN cdm cdm cF wf1o vu cv
      vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM
      cdm cdm wral wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx
      cM cdm cdm wral cN cdm cdm vy cv vr cv cN cbl cfv co wceq vr crp wrex vy
      cN cdm cdm wral wi vu vv cF cM cN cM cdm cdm cN cdm cdm cM cdm cdm eqid
      cN cdm cdm eqid isismty cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq
      vr crp wrex vx cM cdm cdm wral cN cdm cdm vy cv vr cv cN cbl cfv co wceq
      vr crp wrex vy cN cdm cdm wral cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv
      cM cdm cdm wral vu cM cdm cdm wral wa wa cM cdm cdm vx cv vr cv cM cbl
      cfv co wceq vr crp wrex vx cM cdm cdm wral wa cN cdm cdm vy cv vr cv cN
      cbl cfv co wceq vr crp wrex vy cN cdm cdm cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN
      co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa cM cdm cdm vx cv vr
      cv cM cbl cfv co wceq vr crp wrex vx cM cdm cdm wral wa vy cv cN cdm cdm
      wcel wa vy cv cF ccnv cfv cM cdm cdm wcel cN cdm cdm vy cv vr cv cN cbl
      cfv co wceq vr crp wrex cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vy cv cF ccnv cfv
      cM cdm cdm wcel cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx
      cM cdm cdm wral cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF
      cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa vy
      cv cN cdm cdm wcel vy cv cF ccnv cfv cM cdm cdm wcel cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vy cv cN cdm cdm wcel vy cv cF ccnv
      cfv cM cdm cdm wcel vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co
      wceq vv cM cdm cdm wral vu cM cdm cdm wral cM cdm cdm cN cdm cdm vy cv cF
      f1ocnvdm adantlr adantll adantlr cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv
      cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel cM cdm cdm
      vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cM cdm cdm wral vy cv cF
      ccnv cfv cM cdm cdm wcel cN cdm cdm vy cv vr cv cN cbl cfv co wceq vr crp
      wrex wi cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv
      cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM
      cdm cdm wral wa wa vy cv cN cdm cdm wcel wa cM cdm cdm vx cv vr cv cM cbl
      cfv co wceq vr crp wrex vx cM cdm cdm wral vy cv cF ccnv cfv cM cdm cdm
      wcel cN cdm cdm vy cv vr cv cN cbl cfv co wceq vr crp wrex cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv
      vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv
      cN cdm cdm wcel wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq
      vr crp wrex cN cdm cdm vy cv vr cv cN cbl cfv co wceq vr crp wrex cM cdm
      cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cM cdm cdm wral vy cv
      cF ccnv cfv cM cdm cdm wcel wa cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv
      cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel wa cM cdm
      cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq cN cdm cdm vy cv vr cv cN
      cbl cfv co wceq vr crp cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel cM
      cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq cN cdm cdm vy cv vr cv
      cN cbl cfv co wceq wi cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm
      wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa
      cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq cN cdm cdm vy cv vr
      cv cN cbl cfv co wceq cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm
      wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa
      cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa cN cdm cdm vy cv
      vr cv cN cbl cfv co cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm
      wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa
      cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cN cdm cdm vy
      cv vr cv cN cbl cfv co cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa
      wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv cN cdm
      cdm wcel vz cv vy cv vr cv cN cbl cfv co wcel cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm
      wcel vr cv crp wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv
      co wceq wa vz cv cN cdm cdm wcel wa vz cv vy cv vr cv cN cbl cfv co wcel
      vy cv vz cv cN co vr cv clt wbr cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv
      cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp
      wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv
      cN cdm cdm wcel wa vy cv vz cv cN co vy cv cF ccnv cfv vz cv cF ccnv cfv
      cM co vr cv clt cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral
      vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa cM
      cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv cN cdm cdm
      wcel wa vy cv cF ccnv cfv vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF
      cfv vz cv cF ccnv cfv cF cfv cN co vy cv vz cv cN co cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv
      cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN
      cdm cdm wcel vr cv crp wcel wa wa vz cv cN cdm cdm wcel vy cv cF ccnv cfv
      vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF cfv vz cv cF ccnv cfv cF cfv
      cN co wceq cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq cM cme
      wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv
      cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa
      wa vy cv cN cdm cdm wcel vz cv cN cdm cdm wcel vy cv cF ccnv cfv vz cv cF
      ccnv cfv cM co vy cv cF ccnv cfv cF cfv vz cv cF ccnv cfv cF cfv cN co
      wceq vr cv crp wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm
      wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vz cv cN cdm cdm wcel
      vy cv cF ccnv cfv vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF cfv vz cv
      cF ccnv cfv cF cfv cN co wceq cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv
      cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm
      cdm wral wa vy cv cN cdm cdm wcel vz cv cN cdm cdm wcel wa vy cv cF ccnv
      cfv vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF cfv vz cv cF ccnv cfv cF
      cfv cN co wceq cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral
      vu cM cdm cdm wral wa vy cv cN cdm cdm wcel vz cv cN cdm cdm wcel wa wa
      cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa vy cv cF ccnv cfv cM
      cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel wa wa vy cv cF ccnv cfv vz
      cv cF ccnv cfv cM co vy cv cF ccnv cfv cF cfv vz cv cF ccnv cfv cF cfv cN
      co wceq cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv
      cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa vy cv cN
      cdm cdm wcel vz cv cN cdm cdm wcel wa vy cv cF ccnv cfv cM cdm cdm wcel
      vz cv cF ccnv cfv cM cdm cdm wcel wa cM cdm cdm cN cdm cdm cF wf1o vy cv
      cN cdm cdm wcel vz cv cN cdm cdm wcel wa vy cv cF ccnv cfv cM cdm cdm
      wcel vz cv cF ccnv cfv cM cdm cdm wcel wa wi vu cv vv cv cM co vu cv cF
      cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral cM cdm
      cdm cN cdm cdm cF wf1o vy cv cN cdm cdm wcel vy cv cF ccnv cfv cM cdm cdm
      wcel vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel cM cdm cdm
      cN cdm cdm cF wf1o vy cv cN cdm cdm wcel vy cv cF ccnv cfv cM cdm cdm
      wcel cM cdm cdm cN cdm cdm vy cv cF f1ocnvdm ex cM cdm cdm cN cdm cdm cF
      wf1o vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel cM cdm cdm
      cN cdm cdm vz cv cF f1ocnvdm ex anim12d adantr imdistani vu cv vv cv cM
      co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm
      wral vy cv cF ccnv cfv cM cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel
      wa vy cv cF ccnv cfv vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF cfv vz
      cv cF ccnv cfv cF cfv cN co wceq cM cdm cdm cN cdm cdm cF wf1o vy cv cF
      ccnv cfv cM cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel wa vu cv vv cv
      cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm
      cdm wral vy cv cF ccnv cfv vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF
      cfv vz cv cF ccnv cfv cF cfv cN co wceq vu cv vv cv cM co vu cv cF cfv vv
      cv cF cfv cN co wceq vy cv cF ccnv cfv vz cv cF ccnv cfv cM co vy cv cF
      ccnv cfv cF cfv vz cv cF ccnv cfv cF cfv cN co wceq vy cv cF ccnv cfv vv
      cv cM co vy cv cF ccnv cfv cF cfv vv cv cF cfv cN co wceq vu vv vy cv cF
      ccnv cfv vz cv cF ccnv cfv cM cdm cdm cM cdm cdm vu cv vy cv cF ccnv cfv
      wceq vu cv vv cv cM co vy cv cF ccnv cfv vv cv cM co vu cv cF cfv vv cv
      cF cfv cN co vy cv cF ccnv cfv cF cfv vv cv cF cfv cN co vu cv vy cv cF
      ccnv cfv vv cv cM opreq1 vu cv vy cv cF ccnv cfv wceq vu cv cF cfv vy cv
      cF ccnv cfv cF cfv vv cv cF cfv cN vu cv vy cv cF ccnv cfv cF fveq2
      opreq1d eqeq12d vv cv vz cv cF ccnv cfv wceq vy cv cF ccnv cfv vv cv cM
      co vy cv cF ccnv cfv vz cv cF ccnv cfv cM co vy cv cF ccnv cfv cF cfv vv
      cv cF cfv cN co vy cv cF ccnv cfv cF cfv vz cv cF ccnv cfv cF cfv cN co
      vv cv vz cv cF ccnv cfv vy cv cF ccnv cfv cM opreq2 vv cv vz cv cF ccnv
      cfv wceq vv cv cF cfv vz cv cF ccnv cfv cF cfv vy cv cF ccnv cfv cF cfv
      cN vv cv vz cv cF ccnv cfv cF fveq2 opreq2d eqeq12d rcla42v impcom
      adantll syl adantll anassrs adantlrr adantlr cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm
      wcel vr cv crp wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv
      co wceq wa vz cv cN cdm cdm wcel wa vy cv cF ccnv cfv cF cfv vy cv vz cv
      cF ccnv cfv cF cfv vz cv cN cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM
      cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp
      wcel wa wa vy cv cF ccnv cfv cF cfv vy cv wceq cM cdm cdm vy cv cF ccnv
      cfv vr cv cM cbl cfv co wceq vz cv cN cdm cdm wcel cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa vy cv cN cdm cdm wcel vr cv crp wcel wa vy
      cv cF ccnv cfv cF cfv vy cv wceq cM cme wcel cN cme wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vy cv cN cdm cdm wcel vy cv cF ccnv cfv cF cfv vy cv wceq
      vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral
      vu cM cdm cdm wral vr cv crp wcel cM cdm cdm cN cdm cdm vy cv cF
      f1ocnvfv2 ad2ant2r adantll ad2antrr cM cme wcel cN cme wcel wa cM cdm cdm
      cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq
      vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv
      crp wcel wa wa vz cv cN cdm cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq
      cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq cM cdm cdm cN cdm
      cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM
      cdm cdm wral vu cM cdm cdm wral wa vy cv cN cdm cdm wcel vr cv crp wcel
      wa vz cv cN cdm cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq cM cme wcel
      cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vy cv cN cdm cdm wcel vr cv
      crp wcel wa vz cv cN cdm cdm wcel vz cv cF ccnv cfv cF cfv vz cv wceq vu
      cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu
      cM cdm cdm wral cM cdm cdm cN cdm cdm cF wf1o vz cv cN cdm cdm wcel vz cv
      cF ccnv cfv cF cfv vz cv wceq vy cv cN cdm cdm wcel vr cv crp wcel wa cM
      cdm cdm cN cdm cdm vz cv cF f1ocnvfv2 adantlr adantllr adantlll adantlr
      opreq12d eqtr2d cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral
      vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa cM
      cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv cN cdm cdm
      wcel wa vz cv cF ccnv cfv vy cv cF ccnv cfv vr cv cM cbl cfv co wcel vy
      cv cF ccnv cfv vz cv cF ccnv cfv cM co vr cv clt wbr cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv
      cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN
      cdm cdm wcel vr cv crp wcel wa wa vz cv cN cdm cdm wcel cM cdm cdm vy cv
      cF ccnv cfv vr cv cM cbl cfv co wceq vz cv cF ccnv cfv vy cv cF ccnv cfv
      vr cv cM cbl cfv co wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa
      wa vz cv cN cdm cdm wcel wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv
      co wceq vz cv cF ccnv cfv vy cv cF ccnv cfv vr cv cM cbl cfv co wcel cM
      cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq vz cv cF ccnv cfv cM
      cdm cdm wcel vz cv cF ccnv cfv vy cv cF ccnv cfv vr cv cM cbl cfv co wcel
      cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM
      co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm
      wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa vz cv cN cdm cdm
      wcel wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co vz cv cF ccnv
      cfv eleq2 cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv
      vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM
      cdm cdm wral wa wa vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm
      wcel vy cv cN cdm cdm wcel vr cv crp wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm
      wral vu cM cdm cdm wral wa vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm
      cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vz cv
      cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel vu cv vv cv cM co vu cv
      cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral cM
      cdm cdm cN cdm cdm vz cv cF f1ocnvdm adantlr adantll adantlr syl5cbi imp
      an1rs cM cme wcel vy cv cF ccnv cfv cM cdm cdm wcel vz cv cF ccnv cfv cM
      cdm cdm wcel w3a vr cv cr wcel cc0 vr cv clt wbr wa vz cv cF ccnv cfv vy
      cv cF ccnv cfv vr cv cM cbl cfv co wcel vy cv cF ccnv cfv vz cv cF ccnv
      cfv cM co vr cv clt wbr wb cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM
      cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp
      wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv
      cN cdm cdm wcel wa vz cv cF ccnv cfv cM vy cv cF ccnv cfv vr cv cM cdm
      cdm cM cdm cdm eqid elbl2 cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM
      cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp
      wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv
      cN cdm cdm wcel wa cM cme wcel vy cv cF ccnv cfv cM cdm cdm wcel vz cv cF
      ccnv cfv cM cdm cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm
      cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm
      cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa
      wa cM cme wcel cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq vz
      cv cN cdm cdm wcel cM cme wcel cN cme wcel cM cdm cdm cN cdm cdm cF wf1o
      vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral
      vu cM cdm cdm wral wa vy cv cN cdm cdm wcel vr cv crp wcel wa simplll
      ad2antrr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv
      vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM
      cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa vy cv cF
      ccnv cfv cM cdm cdm wcel cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co
      wceq vz cv cN cdm cdm wcel cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM
      co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm
      wral wa vy cv cN cdm cdm wcel vr cv crp wcel wa vy cv cF ccnv cfv cM cdm
      cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vy cv
      cN cdm cdm wcel vy cv cF ccnv cfv cM cdm cdm wcel vu cv vv cv cM co vu cv
      cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral vr
      cv crp wcel cM cdm cdm cN cdm cdm vy cv cF f1ocnvdm ad2ant2r adantll
      ad2antrr cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv
      vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM
      cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa vz cv cN
      cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel cM cdm cdm vy cv cF ccnv
      cfv vr cv cM cbl cfv co wceq cM cme wcel cN cme wcel wa cM cdm cdm cN cdm
      cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM
      cdm cdm wral vu cM cdm cdm wral wa wa vz cv cN cdm cdm wcel vz cv cF ccnv
      cfv cM cdm cdm wcel vy cv cN cdm cdm wcel vr cv crp wcel wa cM cdm cdm cN
      cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv
      cM cdm cdm wral vu cM cdm cdm wral wa vz cv cN cdm cdm wcel vz cv cF ccnv
      cfv cM cdm cdm wcel cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF
      wf1o vz cv cN cdm cdm wcel vz cv cF ccnv cfv cM cdm cdm wcel vu cv vv cv
      cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm
      cdm wral cM cdm cdm cN cdm cdm vz cv cF f1ocnvdm adantlr adantll adantlr
      adantlr 3jca cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu
      cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu
      cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa vr cv cr
      wcel cc0 vr cv clt wbr wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv
      co wceq vz cv cN cdm cdm wcel vr cv crp wcel vr cv cr wcel cc0 vr cv clt
      wbr wa cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv
      cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM
      cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv rpregt0 ad2antll ad2antrr
      sylanc mpbid eqbrtrd cN cme wcel vy cv cN cdm cdm wcel vz cv cN cdm cdm
      wcel w3a vr cv cr wcel cc0 vr cv clt wbr wa vz cv vy cv vr cv cN cbl cfv
      co wcel vy cv vz cv cN co vr cv clt wbr wb cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN
      co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel
      vr cv crp wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co
      wceq wa vz cv cN cdm cdm wcel wa vz cv cN vy cv vr cv cN cdm cdm cN cdm
      cdm eqid elbl2 cM cme wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o
      vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral
      vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa cM
      cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq wa vz cv cN cdm cdm
      wcel wa cN cme wcel vy cv cN cdm cdm wcel vz cv cN cdm cdm wcel cM cme
      wcel cN cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv
      cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa
      wa vy cv cN cdm cdm wcel vr cv crp wcel wa wa cN cme wcel cM cdm cdm vy
      cv cF ccnv cfv vr cv cM cbl cfv co wceq vz cv cN cdm cdm wcel cM cme wcel
      cN cme wcel cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv
      vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa vy cv cN
      cdm cdm wcel vr cv crp wcel wa simpllr ad2antrr cM cme wcel cN cme wcel
      wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF
      cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm
      cdm wcel vr cv crp wcel wa wa vy cv cN cdm cdm wcel cM cdm cdm vy cv cF
      ccnv cfv vr cv cM cbl cfv co wceq vz cv cN cdm cdm wcel cM cme wcel cN
      cme wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv
      vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv
      cN cdm cdm wcel vr cv crp wcel simprl ad2antrr cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm
      wcel vr cv crp wcel wa wa cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv
      co wceq wa vz cv cN cdm cdm wcel pm3.27 3jca cM cme wcel cN cme wcel wa
      cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm
      wcel vr cv crp wcel wa wa vr cv cr wcel cc0 vr cv clt wbr wa cM cdm cdm
      vy cv cF ccnv cfv vr cv cM cbl cfv co wceq vz cv cN cdm cdm wcel vr cv
      crp wcel vr cv cr wcel cc0 vr cv clt wbr wa cM cme wcel cN cme wcel wa cM
      cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv cv cF cfv cN
      co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN cdm cdm wcel
      vr cv rpregt0 ad2antll ad2antrr sylanc mpbird ex ssrdv cM cme wcel cN cme
      wcel wa cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu cv cF cfv vv
      cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral wa wa vy cv cN
      cdm cdm wcel vr cv crp wcel wa wa vy cv vr cv cN cbl cfv co cN cdm cdm
      wss cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq cM cme wcel cN
      cme wcel wa vy cv cN cdm cdm wcel vr cv crp wcel wa vy cv vr cv cN cbl
      cfv co cN cdm cdm wss cM cdm cdm cN cdm cdm cF wf1o vu cv vv cv cM co vu
      cv cF cfv vv cv cF cfv cN co wceq vv cM cdm cdm wral vu cM cdm cdm wral
      wa cN cme wcel vy cv cN cdm cdm wcel vr cv crp wcel wa vy cv vr cv cN cbl
      cfv co cN cdm cdm wss cM cme wcel cN cme wcel vy cv cN cdm cdm wcel vr cv
      crp wcel vy cv vr cv cN cbl cfv co cN cdm cdm wss cN cme wcel vy cv cN
      cdm cdm wcel wa vr cv cr wcel cc0 vr cv clt wbr wa vy cv vr cv cN cbl cfv
      co cN cdm cdm wss vr cv crp wcel cN vy cv vr cv cN cdm cdm cN cdm cdm
      eqid blssm vr cv elrp sylan2b anasss adantll adantlr adantr eqssd ex
      anassrs r19.22dva cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex
      cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co wceq vr crp wrex vx vy
      cv cF ccnv cfv cM cdm cdm vx cv vy cv cF ccnv cfv wceq cM cdm cdm vx cv
      vr cv cM cbl cfv co wceq cM cdm cdm vy cv cF ccnv cfv vr cv cM cbl cfv co
      wceq vr crp vx cv vy cv cF ccnv cfv wceq vx cv vr cv cM cbl cfv co vy cv
      cF ccnv cfv vr cv cM cbl cfv co cM cdm cdm vx cv vy cv cF ccnv cfv vr cv
      cM cbl cfv opreq1 eqeq2d rexbidv rcla4cva syl5 expdimp an1rs mpd
      r19.21aiva exp31 sylbid 3impia cM cme wcel cN cme wcel cM cbnd wcel cM
      cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cM cdm cdm wral wb
      cF cM cN cismty co wcel vx cM cM cdm cdm vr cM cdm cdm eqid isbnd2
      3ad2ant1 cN cme wcel cM cme wcel cN cbnd wcel cN cdm cdm vy cv vr cv cN
      cbl cfv co wceq vr crp wrex vy cN cdm cdm wral wb cF cM cN cismty co wcel
      vy cN cN cdm cdm vr cN cdm cdm eqid isbnd2 3ad2ant2 3imtr4d $.
      $( [2-Sep-2009] $)

    $( Isometries preserve boundedness. $)
    ismtybnd $p |- ( ( M e. Met /\ N e. Met /\ F e. ( M Ismty N ) )
                                              -> ( M e. Bnd <-> N e. Bnd ) ) $=
      cM cme wcel cN cme wcel cF cM cN cismty co wcel w3a cM cbnd wcel cN cbnd
      wcel cF cM cN ismtybndlem cM cme wcel cN cme wcel cF cM cN cismty co wcel
      cN cbnd wcel cM cbnd wcel wi cM cme wcel cN cme wcel wa cF cM cN cismty
      co wcel cF ccnv cN cM cismty co wcel cN cbnd wcel cM cbnd wcel wi cF cM
      cN ismtycnv cN cme wcel cM cme wcel cF ccnv cN cM cismty co wcel cN cbnd
      wcel cM cbnd wcel wi wi cN cme wcel cM cme wcel cF ccnv cN cM cismty co
      wcel cN cbnd wcel cM cbnd wcel wi cF ccnv cN cM ismtybndlem 3expia ancoms
      syld 3impia impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d X u v x y $. $d M u v x y $. $d N u v x y $. $d A u v x y $.
    $d B u v x y $. $d S u v x y $. $d T u v x y $. $d F u v x y $.
    ismtyres.1 $e |- X = dom dom M $.
    ismtyres.2 $e |- B = ( F " A ) $.
    ismtyres.3 $e |- S = ( M |` ( A X. A ) ) $.
    ismtyres.4 $e |- T = ( N |` ( B X. B ) ) $.
    $( A restriction of an isometry is an isometry. The condition ` A C_ X `
       is not necessary but makes the proof easier. $)
    ismtyres $p |- ( ( ( M e. Met /\ N e. Met ) /\ ( F e. ( M Ismty N )
                              /\ A C_ X ) ) -> ( F |` A ) e. ( S Ismty T ) ) $=
      cM cme wcel cN cme wcel wa cA cX wss cF cM cN cismty co wcel cF cA cres
      cS cT cismty co wcel cM cme wcel cN cme wcel wa cA cX wss cF cM cN cismty
      co wcel cF cA cres cS cT cismty co wcel cM cme wcel cN cme wcel wa cA cX
      wss wa cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv
      cN co wceq vy cX wral vx cX wral wa cS cdm cdm cT cdm cdm cF cA cres wf1o
      vu cv vv cv cS co vu cv cF cA cres cfv vv cv cF cA cres cfv cT co wceq vv
      cS cdm cdm wral vu cS cdm cdm wral wa cF cM cN cismty co wcel cF cA cres
      cS cT cismty co wcel cM cme wcel cN cme wcel wa cA cX wss wa cX cN cdm
      cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX
      wral vx cX wral wa cS cdm cdm cT cdm cdm cF cA cres wf1o vu cv vv cv cS
      co vu cv cF cA cres cfv vv cv cF cA cres cfv cT co wceq vv cS cdm cdm
      wral vu cS cdm cdm wral cM cme wcel cN cme wcel wa cA cX wss wa cX cN cdm
      cdm cF wf1o cS cdm cdm cT cdm cdm cF cA cres wf1o vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral cM cme wcel cN cme
      wcel wa cA cX wss wa cX cN cdm cdm cF wf1 cS cdm cdm cT cdm cdm cF cA
      cres wf1o cX cN cdm cdm cF wf1o cM cme wcel cN cme wcel wa cA cX wss wa
      cX cN cdm cdm cF wf1 cS cdm cdm cT cdm cdm cF cA cres wf1o cM cme wcel cN
      cme wcel wa cA cX wss wa cX cN cdm cdm cF wf1 wa cA cF cA cima cF cA cres
      wf1o cS cdm cdm cT cdm cdm cF cA cres wf1o cA cX wss cX cN cdm cdm cF wf1
      cA cF cA cima cF cA cres wf1o cM cme wcel cN cme wcel wa cX cN cdm cdm cF
      wf1 cA cX wss cA cF cA cima cF cA cres wf1o cX cN cdm cdm cA cF f1ores
      ancoms adantll cM cme wcel cN cme wcel wa cA cX wss wa cX cN cdm cdm cF
      wf1 wa cA cF cA cima cF cA cres wf1o cS cdm cdm cF cA cima cF cA cres
      wf1o cS cdm cdm cT cdm cdm cF cA cres wf1o cM cme wcel cN cme wcel wa cA
      cX wss wa cA cF cA cima cF cA cres wf1o cS cdm cdm cF cA cima cF cA cres
      wf1o wb cX cN cdm cdm cF wf1 cM cme wcel cA cX wss cA cF cA cima cF cA
      cres wf1o cS cdm cdm cF cA cima cF cA cres wf1o wb cN cme wcel cM cme
      wcel cA cX wss wa cA cS cdm cdm wceq cA cF cA cima cF cA cres wf1o cS cdm
      cdm cF cA cima cF cA cres wf1o wb cM cS cX cA ismtyres.3 ismtyres.1
      basmetres cA cS cdm cdm cF cA cima cF cA cres f1oeq2 syl adantlr adantr
      cN cme wcel cA cX wss cX cN cdm cdm cF wf1 cS cdm cdm cF cA cima cF cA
      cres wf1o cS cdm cdm cT cdm cdm cF cA cres wf1o wb cM cme wcel cN cme
      wcel cA cX wss wa cX cN cdm cdm cF wf1 wa cF cA cima cT cdm cdm wceq cS
      cdm cdm cF cA cima cF cA cres wf1o cS cdm cdm cT cdm cdm cF cA cres wf1o
      wb cN cme wcel cA cX wss wa cX cN cdm cdm cF wf1 wa cF cA cima cN cF cA
      cima cF cA cima cxp cres cdm cdm cT cdm cdm cN cme wcel cA cX wss cX cN
      cdm cdm cF wf1 cF cA cima cN cF cA cima cF cA cima cxp cres cdm cdm wceq
      cN cme wcel cF cA cima cN cdm cdm wss cF cA cima cN cF cA cima cF cA cima
      cxp cres cdm cdm wceq cA cX wss cX cN cdm cdm cF wf1 wa cN cN cdm cdm cF
      cA cima cN cdm cdm eqid metssba2 cA cX wss cX cN cdm cdm cF wf cF cA cima
      cN cdm cdm wss cX cN cdm cdm cF wf1 cX cN cdm cdm cF wf cF cA cima cN cdm
      cdm wss cA cX wss cX cN cdm cdm cF wf cF cA cima cF crn cN cdm cdm cF cA
      cima cF crn wss cX cN cdm cdm cF wf cF cA imassrn a1i cX cN cdm cdm cF
      frn sstrd adantl cX cN cdm cdm cF f1f sylan2 sylan2 anassrs cT cdm cN cF
      cA cima cF cA cima cxp cres cdm cT cN cF cA cima cF cA cima cxp cres cT
      cN cB cB cxp cres cN cF cA cima cF cA cima cxp cres ismtyres.4 cB cB cxp
      cF cA cima cF cA cima cxp wceq cN cB cB cxp cres cN cF cA cima cF cA cima
      cxp cres wceq cB cB cxp cF cA cima cB cxp cF cA cima cF cA cima cxp cB cF
      cA cima cB ismtyres.2 xpeq1i cB cF cA cima cF cA cima ismtyres.2 xpeq2i
      eqtri cB cB cxp cF cA cima cF cA cima cxp cN reseq2 ax-mp eqtri dmeqi
      dmeqi syl6eqr cF cA cima cT cdm cdm cS cdm cdm cF cA cres f1oeq3 syl
      adantlll bitrd mpbid ex cX cN cdm cdm cF f1of1 syl5 adantrd cM cme wcel
      cN cme wcel wa cA cX wss wa cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv
      cF cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral wa vu cv vv cv cS co
      vu cv cF cA cres cfv vv cv cF cA cres cfv cT co wceq vv cS cdm cdm wral
      vu cS cdm cdm wral cM cme wcel cN cme wcel wa cA cX wss wa cX cN cdm cdm
      cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral
      vx cX wral wa wa vu cv vv cv cS co vu cv cF cA cres cfv vv cv cF cA cres
      cfv cT co wceq vu vv cS cdm cdm cS cdm cdm cM cme wcel cN cme wcel wa cA
      cX wss wa cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vy cX wral vx cX wral wa wa vu cv cS cdm cdm wcel vv cv cS
      cdm cdm wcel wa vu cv cA wcel vv cv cA wcel wa vu cv vv cv cS co vu cv cF
      cA cres cfv vv cv cF cA cres cfv cT co wceq cM cme wcel cN cme wcel wa cA
      cX wss wa vu cv cA wcel vv cv cA wcel wa vu cv cS cdm cdm wcel vv cv cS
      cdm cdm wcel wa wb cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cX wral vx cX wral wa cM cme wcel cA cX wss vu
      cv cA wcel vv cv cA wcel wa vu cv cS cdm cdm wcel vv cv cS cdm cdm wcel
      wa wb cN cme wcel cM cme wcel cA cX wss wa vu cv cA wcel vu cv cS cdm cdm
      wcel vv cv cA wcel vv cv cS cdm cdm wcel cM cme wcel cA cX wss wa cA cS
      cdm cdm vu cv cM cS cX cA ismtyres.3 ismtyres.1 basmetres eleq2d cM cme
      wcel cA cX wss wa cA cS cdm cdm vv cv cM cS cX cA ismtyres.3 ismtyres.1
      basmetres eleq2d anbi12d adantlr adantr cM cme wcel cN cme wcel wa cA cX
      wss wa cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF cfv
      cN co wceq vy cX wral vx cX wral wa wa vu cv cA wcel vv cv cA wcel wa vu
      cv vv cv cS co vu cv cF cA cres cfv vv cv cF cA cres cfv cT co wceq cM
      cme wcel cN cme wcel wa cA cX wss wa cX cN cdm cdm cF wf1o vx cv vy cv cM
      co vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral wa wa vu cv
      cA wcel vv cv cA wcel wa wa vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co vu cv vv cv cS co vu cv cF cA cres cfv vv cv cF cA cres cfv cT co
      cA cX wss cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv vy cv cF
      cfv cN co wceq vy cX wral vx cX wral wa vu cv cA wcel vv cv cA wcel wa vu
      cv vv cv cM co vu cv cF cfv vv cv cF cfv cN co wceq cM cme wcel cN cme
      wcel wa cA cX wss vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq
      vy cX wral vx cX wral vu cv cA wcel vv cv cA wcel wa vu cv vv cv cM co vu
      cv cF cfv vv cv cF cfv cN co wceq cX cN cdm cdm cF wf1o cA cX wss vu cv
      cA wcel vv cv cA wcel wa vx cv vy cv cM co vx cv cF cfv vy cv cF cfv cN
      co wceq vy cX wral vx cX wral vu cv vv cv cM co vu cv cF cfv vv cv cF cfv
      cN co wceq cA cX wss vu cv cA wcel vv cv cA wcel wa wa vx cv vy cv cM co
      vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral vu cv vv cv cM
      co vu cv cF cfv vv cv cF cfv cN co wceq cA cX wss vu cv cA wcel vv cv cA
      wcel wa wa vu cv cX wcel vv cv cX wcel wa vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cX wral vx cX wral vu cv vv cv cM co vu cv cF
      cfv vv cv cF cfv cN co wceq wi cA cX wss vu cv cA wcel vv cv cA wcel wa
      vu cv cX wcel vv cv cX wcel wa cA cX wss vu cv cA wcel vu cv cX wcel vv
      cv cA wcel vv cv cX wcel cA cX vu cv ssel cA cX vv cv ssel anim12d imp vx
      cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vu cv vv cv cM co vu
      cv cF cfv vv cv cF cfv cN co wceq vu cv vy cv cM co vu cv cF cfv vy cv cF
      cfv cN co wceq vx vy vu cv vv cv cX cX vx cv vu cv wceq vx cv vy cv cM co
      vu cv vy cv cM co vx cv cF cfv vy cv cF cfv cN co vu cv cF cfv vy cv cF
      cfv cN co vx cv vu cv vy cv cM opreq1 vx cv vu cv wceq vx cv cF cfv vu cv
      cF cfv vy cv cF cfv cN vx cv vu cv cF fveq2 opreq1d eqeq12d vy cv vv cv
      wceq vu cv vy cv cM co vu cv vv cv cM co vu cv cF cfv vy cv cF cfv cN co
      vu cv cF cfv vv cv cF cfv cN co vy cv vv cv vu cv cM opreq2 vy cv vv cv
      wceq vy cv cF cfv vv cv cF cfv vu cv cF cfv cN vy cv vv cv cF fveq2
      opreq2d eqeq12d rcla42v syl imp an1rs adantlrl adantlll vu cv cA wcel vv
      cv cA wcel wa vu cv vv cv cS co vu cv vv cv cM co wceq cM cme wcel cN cme
      wcel wa cA cX wss wa cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF cfv
      vy cv cF cfv cN co wceq vy cX wral vx cX wral wa wa vu cv cA wcel vv cv
      cA wcel wa vu cv vv cv cM cA cA cxp cres co vu cv vv cv cM co vu cv vv cv
      cS co vu cv vv cv cA cA cM oprvres cS cM cA cA cxp cres vu cv vv cv
      ismtyres.3 opreqi syl5eq adantl cA cX wss cX cN cdm cdm cF wf1o vx cv vy
      cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral wa vu
      cv cA wcel vv cv cA wcel wa vu cv cF cA cres cfv vv cv cF cA cres cfv cT
      co vu cv cF cfv vv cv cF cfv cN co wceq cM cme wcel cN cme wcel wa cA cX
      wss cX cN cdm cdm cF wf1o vu cv cA wcel vv cv cA wcel wa vu cv cF cA cres
      cfv vv cv cF cA cres cfv cT co vu cv cF cfv vv cv cF cfv cN co wceq vx cv
      vy cv cM co vx cv cF cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral cA
      cX wss cX cN cdm cdm cF wf1o wa vu cv cA wcel vv cv cA wcel wa wa vu cv
      cF cA cres cfv vv cv cF cA cres cfv cT co vu cv cF cfv vv cv cF cfv cT co
      vu cv cF cfv vv cv cF cfv cN co cA cX wss cX cN cdm cdm cF wf1o wa vu cv
      cA wcel vv cv cA wcel wa wa vu cv cF cA cres cfv vu cv cF cfv vv cv cF cA
      cres cfv vv cv cF cfv cT vu cv cA wcel vu cv cF cA cres cfv vu cv cF cfv
      wceq cA cX wss cX cN cdm cdm cF wf1o wa vv cv cA wcel vu cv cA cF fvres
      ad2antrl vv cv cA wcel vv cv cF cA cres cfv vv cv cF cfv wceq cA cX wss
      cX cN cdm cdm cF wf1o wa vu cv cA wcel vv cv cA cF fvres ad2antll
      opreq12d cA cX wss cX cN cdm cdm cF wf1o wa vu cv cA wcel vv cv cA wcel
      wa wa vu cv cF cfv vv cv cF cfv cN cB cB cxp cres co vu cv cF cfv vv cv
      cF cfv cN co vu cv cF cfv vv cv cF cfv cT co vu cv cF cfv cB wcel vv cv
      cF cfv cB wcel vu cv cF cfv vv cv cF cfv cN cB cB cxp cres co vu cv cF
      cfv vv cv cF cfv cN co wceq cA cX wss cX cN cdm cdm cF wf1o wa vu cv cA
      wcel vv cv cA wcel wa wa vu cv cF cfv vv cv cF cfv cB cB cN oprvres cA cX
      wss cX cN cdm cdm cF wf1o wa vu cv cA wcel vu cv cF cfv cB wcel vv cv cA
      wcel cA cX wss cX cN cdm cdm cF wf1o wa vu cv cA wcel wa vu cv cF cfv cF
      cA cima cB cA cX wss cX cN cdm cdm cF wf1o wa vu cv cA wcel vu cv cF cfv
      cF cA cima wcel cF wfun cA cF cdm wss vu cv cA wcel vu cv cF cfv cF cA
      cima wcel wi cA cX wss cX cN cdm cdm cF wf1o wa cA vu cv cF funfvima2 cX
      cN cdm cdm cF wf1o cF wfun cA cX wss cX cN cdm cdm cF f1ofun adantl cX cN
      cdm cdm cF wf1o cA cF cdm wss cA cX wss cX cN cdm cdm cF wf1o cF cdm cX
      cA cX cN cdm cdm cF wf1o cX cN cdm cdm cF wf cF cdm cX wceq cX cN cdm cdm
      cF f1of cX cN cdm cdm cF fdm syl sseq2d biimparc sylanc imp ismtyres.2
      syl6eleqr adantrr cA cX wss cX cN cdm cdm cF wf1o wa vv cv cA wcel vv cv
      cF cfv cB wcel vu cv cA wcel cA cX wss cX cN cdm cdm cF wf1o wa vv cv cA
      wcel wa vv cv cF cfv cF cA cima cB cA cX wss cX cN cdm cdm cF wf1o wa vv
      cv cA wcel vv cv cF cfv cF cA cima wcel cF wfun cA cF cdm wss vv cv cA
      wcel vv cv cF cfv cF cA cima wcel wi cA cX wss cX cN cdm cdm cF wf1o wa
      cA vv cv cF funfvima2 cX cN cdm cdm cF wf1o cF wfun cA cX wss cX cN cdm
      cdm cF f1ofun adantl cX cN cdm cdm cF wf1o cA cF cdm wss cA cX wss cX cN
      cdm cdm cF wf1o cF cdm cX cA cX cN cdm cdm cF wf1o cX cN cdm cdm cF wf cF
      cdm cX wceq cX cN cdm cdm cF f1of cX cN cdm cdm cF fdm syl sseq2d
      biimparc sylanc imp ismtyres.2 syl6eleqr adantrl sylanc cT cN cB cB cxp
      cres vu cv cF cfv vv cv cF cfv ismtyres.4 opreqi syl5eq eqtrd adantlrr
      adantlll 3eqtr4d ex sylbird r19.21aivv ex jcad cM cme wcel cN cme wcel wa
      cF cM cN cismty co wcel cX cN cdm cdm cF wf1o vx cv vy cv cM co vx cv cF
      cfv vy cv cF cfv cN co wceq vy cX wral vx cX wral wa wb cA cX wss vx vy
      cF cM cN cX cN cdm cdm ismtyres.1 cN cdm cdm eqid isismty adantr cM cme
      wcel cN cme wcel wa cF cA cres cS cT cismty co wcel cS cdm cdm cT cdm cdm
      cF cA cres wf1o vu cv vv cv cS co vu cv cF cA cres cfv vv cv cF cA cres
      cfv cT co wceq vv cS cdm cdm wral vu cS cdm cdm wral wa wb cA cX wss cS
      cme wcel cT cme wcel cF cA cres cS cT cismty co wcel cS cdm cdm cT cdm
      cdm cF cA cres wf1o vu cv vv cv cS co vu cv cF cA cres cfv vv cv cF cA
      cres cfv cT co wceq vv cS cdm cdm wral vu cS cdm cdm wral wa wb cM cme
      wcel cN cme wcel vu vv cF cA cres cS cT cS cdm cdm cT cdm cdm cS cdm cdm
      eqid cT cdm cdm eqid isismty cM cme wcel cM cA cA cxp cres cme cS cM cA
      metres ismtyres.3 syl5eqel cN cme wcel cN cB cB cxp cres cme cT cN cB
      metres ismtyres.4 syl5eqel syl2an adantr 3imtr4d impr ancom2s $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Heine-Borel Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d M b c d f l n r s t u v w x y z $. $d J b c d f l n s t v x y z $.
    $d C d l n r s t u v w x y z $. $d X b c d f l n r s t u v w x y z $.
    $d U t w x y z $. $d N l d n s $. $d B d l n $. $d A d l n s $.
    $d Z s t w x y z $. $d Y r t u w x y z $. $d F l d m r t x y z $.
    $d j k x $. $d m n s $. $d T x y $.

    heibor.1 $e |- J = ( Open ` M ) $.
    heibor.2 $e |- X = dom dom M $.

    $( Lemma for ~ heibor . A compact metric space is totally bounded. $)
    heiborlem1 $p |- ( ( M e. Met /\ J e. Comp ) -> M e. TotBnd ) $=
      cM cme wcel cJ ccomp wcel cM ctotbnd wcel cM cme wcel cJ ccomp wcel vv cv
      cuni cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv
      wral wa vv cfn wrex vd crp wral cM ctotbnd wcel cM cme wcel cJ ccomp wcel
      vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv
      cv wral wa vv cfn wrex vd crp cM cme wcel vd cv crp wcel wa cJ cuni vy cv
      cuni wceq cJ cuni vv cv cuni wceq vv vy cv cpw cfn cin wrex wi vy cJ cpw
      wral vv cv cuni cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex
      vb vv cv wral wa vv cfn wrex cJ ccomp wcel cM cme wcel vd cv crp wcel wa
      cJ cuni vy cv cuni wceq cJ cuni vv cv cuni wceq vv vy cv cpw cfn cin wrex
      wi vy cJ cpw wral cJ cuni vv cv cuni wceq vv vc cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vc cab cpw cfn cin wrex vv cv cuni cX wceq vb cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex cM cme
      wcel vd cv crp wcel wa cJ cuni vy cv cuni wceq cJ cuni vv cv cuni wceq vv
      vy cv cpw cfn cin wrex wi vy cJ cpw wral cJ cuni vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab cuni wceq cJ cuni vv cv cuni wceq vv vc cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw cfn cin wrex cM cme
      wcel vd cv crp wcel wa cJ cuni cX vc cv vx cv vd cv cM cbl cfv co wceq vx
      cX wrex vc cab cuni cM cme wcel cJ cuni cX wceq vd cv crp wcel cM cJ cX
      heibor.2 heibor.1 uniopn2 adantr cM cme wcel vd cv crp wcel wa vy cX vc
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cuni cM cme wcel vd
      cv crp wcel wa vy cv cX wcel vy cv vz cv wcel vz cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex wa vz wex vy cv vc cv vx cv vd cv cM cbl cfv co
      wceq vx cX wrex vc cab cuni wcel cM cme wcel vd cv crp wcel wa vy cv cX
      wcel vy cv vz cv wcel vz cv vx cv vd cv cM cbl cfv co wceq vx cX wrex wa
      vz wex cM cme wcel vd cv crp wcel wa vy cv cX wcel vy cv vy cv vd cv cM
      cbl cfv co wcel vy cv vd cv cM cbl cfv co vx cv vd cv cM cbl cfv co wceq
      vx cX wrex wa vy cv vz cv wcel vz cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex wa vz wex cM cme wcel vd cv crp wcel wa vy cv cX wcel vy cv vy cv vd
      cv cM cbl cfv co wcel vy cv vd cv cM cbl cfv co vx cv vd cv cM cbl cfv co
      wceq vx cX wrex wa cM cme wcel vd cv crp wcel wa vy cv cX wcel wa vy cv
      vy cv vd cv cM cbl cfv co wcel vy cv vd cv cM cbl cfv co vx cv vd cv cM
      cbl cfv co wceq vx cX wrex cM cme wcel vy cv cX wcel vd cv crp wcel vy cv
      vy cv vd cv cM cbl cfv co wcel cM cme wcel vy cv cX wcel wa vd cv cr wcel
      cc0 vd cv clt wbr wa vy cv vy cv vd cv cM cbl cfv co wcel vd cv crp wcel
      cM vy cv vd cv cX heibor.2 blcntr vd cv rpregt0 sylan2 an1rs vy cv cX
      wcel vy cv vd cv cM cbl cfv co vx cv vd cv cM cbl cfv co wceq vx cX wrex
      cM cme wcel vd cv crp wcel wa vy cv cX wcel vy cv vd cv cM cbl cfv co vy
      cv vd cv cM cbl cfv co wceq vy cv vd cv cM cbl cfv co vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vy cv vd cv cM cbl cfv co eqid vy cv vd cv cM cbl
      cfv co vx cv vd cv cM cbl cfv co wceq vy cv vd cv cM cbl cfv co vy cv vd
      cv cM cbl cfv co wceq vx vy cv cX vx cv vy cv wceq vx cv vd cv cM cbl cfv
      co vy cv vd cv cM cbl cfv co vy cv vd cv cM cbl cfv co vx cv vy cv vd cv
      cM cbl cfv opreq1 eqeq2d rcla4ev mpan2 adantl jca ex vy cv vz cv wcel vz
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex wa vy cv vy cv vd cv cM cbl
      cfv co wcel vy cv vd cv cM cbl cfv co vx cv vd cv cM cbl cfv co wceq vx
      cX wrex wa vz vy cv vd cv cM cbl cfv co vy cv vd cv cM cbl cfv oprex vz
      cv vy cv vd cv cM cbl cfv co wceq vy cv vz cv wcel vy cv vy cv vd cv cM
      cbl cfv co wcel vz cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vy cv vd
      cv cM cbl cfv co vx cv vd cv cM cbl cfv co wceq vx cX wrex vz cv vy cv vd
      cv cM cbl cfv co vy cv eleq2 vz cv vy cv vd cv cM cbl cfv co wceq vz cv
      vx cv vd cv cM cbl cfv co wceq vy cv vd cv cM cbl cfv co vx cv vd cv cM
      cbl cfv co wceq vx cX vz cv vy cv vd cv cM cbl cfv co vx cv vd cv cM cbl
      cfv co eqeq1 rexbidv anbi12d cla4ev syl6 cM cme wcel vd cv crp wcel wa vy
      cv vz cv wcel vz cv vx cv vd cv cM cbl cfv co wceq vx cX wrex wa vy cv cX
      wcel vz cM cme wcel vd cv crp wcel wa vy cv vz cv wcel vz cv vx cv vd cv
      cM cbl cfv co wceq vx cX wrex vy cv cX wcel cM cme wcel vd cv crp wcel wa
      vy cv vz cv wcel wa vz cv vx cv vd cv cM cbl cfv co wceq vy cv cX wcel vx
      cX cM cme wcel vd cv crp wcel wa vx cv cX wcel vy cv vz cv wcel vz cv vx
      cv vd cv cM cbl cfv co wceq vy cv cX wcel wi cM cme wcel vd cv crp wcel
      wa vx cv cX wcel wa vy cv vz cv wcel vz cv vx cv vd cv cM cbl cfv co wceq
      vy cv cX wcel wi cM cme wcel vd cv crp wcel wa vx cv cX wcel wa vz cv vx
      cv vd cv cM cbl cfv co wceq vy cv vz cv wcel vy cv cX wcel cM cme wcel vd
      cv crp wcel wa vx cv cX wcel wa vz cv vx cv vd cv cM cbl cfv co wceq vy
      cv vz cv wcel vy cv cX wcel wi cM cme wcel vd cv crp wcel wa vx cv cX
      wcel wa vz cv vx cv vd cv cM cbl cfv co wceq wa vz cv cX vy cv cM cme
      wcel vd cv crp wcel wa vx cv cX wcel wa vx cv vd cv cM cbl cfv co cX wss
      vz cv vx cv vd cv cM cbl cfv co wceq vz cv cX wss cM cme wcel vx cv cX
      wcel vd cv crp wcel vx cv vd cv cM cbl cfv co cX wss cM cme wcel vx cv cX
      wcel wa vd cv cr wcel cc0 vd cv clt wbr wa vx cv vd cv cM cbl cfv co cX
      wss vd cv crp wcel cM vx cv vd cv cX heibor.2 blssm vd cv rpregt0 sylan2
      an1rs vz cv vx cv vd cv cM cbl cfv co wceq vz cv cX wss vx cv vd cv cM
      cbl cfv co cX wss vz cv vx cv vd cv cM cbl cfv co cX sseq1 biimprd mpan9
      sseld ex com23 imp an1rs r19.23adva expimpd 19.23adv impbid vy cv vc cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cuni wcel vy cv vz cv
      wcel vz cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab wcel wa
      vz wex vy cv vz cv wcel vz cv vx cv vd cv cM cbl cfv co wceq vx cX wrex
      wa vz wex vz vy cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab
      eluni vy cv vz cv wcel vz cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vc cab wcel wa vy cv vz cv wcel vz cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex wa vz vz cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc
      cab wcel vz cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vy cv vz cv wcel
      vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vz cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc vz cv vz visset vc cv vz cv wceq vc cv vx cv vd
      cv cM cbl cfv co wceq vz cv vx cv vd cv cM cbl cfv co wceq vx cX vc cv vz
      cv vx cv vd cv cM cbl cfv co eqeq1 rexbidv elab anbi2i exbii bitri
      syl6bbr eqrdv eqtrd cM cme wcel vd cv crp wcel wa vc cv vx cv vd cv cM
      cbl cfv co wceq vx cX wrex vc cab cJ wss vc cv vx cv vd cv cM cbl cfv co
      wceq vx cX wrex vc cab cJ cpw wcel cJ cuni vy cv cuni wceq cJ cuni vv cv
      cuni wceq vv vy cv cpw cfn cin wrex wi vy cJ cpw wral cJ cuni vc cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vc cab cuni wceq cJ cuni vv cv cuni
      wceq vv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw cfn
      cin wrex wi wi cM cme wcel vd cv crp wcel wa vc cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vc cJ cM cme wcel vd cv crp wcel wa vc cv vx cv vd cv
      cM cbl cfv co wceq vc cv cJ wcel vx cX vc cv vx cv vd cv cM cbl cfv co
      wceq vc cv cJ wcel vx cv vd cv cM cbl cfv co cJ wcel cM cme wcel vd cv
      crp wcel wa vx cv cX wcel wa vc cv vx cv vd cv cM cbl cfv co cJ eleq1 cM
      cme wcel vx cv cX wcel vd cv crp wcel vx cv vd cv cM cbl cfv co cJ wcel
      cM cme wcel vx cv cX wcel wa vd cv cr wcel cc0 vd cv clt wbr wa vx cv vd
      cv cM cbl cfv co cJ wcel vd cv crp wcel cM vx cv vd cv cJ cX heibor.2
      heibor.1 blopn vd cv rpregt0 sylan2 an1rs syl5cbir r19.23adva abssdv vc
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cJ wss vc cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vc cab cvv wcel vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab cJ cpw wcel vc cv vx cv vd cv cM cbl cfv co
      wceq vx cX wrex vc cab cJ cJ cM copn cfv cvv heibor.1 cM copn fvex
      eqeltri ssex vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cvv
      wcel vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cJ cpw wcel
      vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cJ wss vc cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vc cab cJ cvv elpwg biimprcd mpd cJ
      cuni vy cv cuni wceq cJ cuni vv cv cuni wceq vv vy cv cpw cfn cin wrex wi
      cJ cuni vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cuni wceq
      cJ cuni vv cv cuni wceq vv vc cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vc cab cpw cfn cin wrex wi vy vc cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex vc cab cJ cpw vy cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vc cab wceq cJ cuni vy cv cuni wceq cJ cuni vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab cuni wceq cJ cuni vv cv cuni wceq vv vy cv
      cpw cfn cin wrex cJ cuni vv cv cuni wceq vv vc cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vc cab cpw cfn cin wrex vy cv vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab wceq vy cv cuni vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab cuni cJ cuni vy cv vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab unieq eqeq2d vy cv vc cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vc cab wceq cJ cuni vv cv cuni wceq vv vy cv cpw
      cfn cin vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw cfn
      cin vy cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab wceq vy
      cv cpw vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw cfn vy
      cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab pweq ineq1d
      rexeq1d imbi12d rcla4v 3syl mpid cM cme wcel vd cv crp wcel wa vv cv vc
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel cJ cuni vv
      cv cuni wceq wa vv cfn wrex vv cv cuni cX wceq vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vb vv cv wral wa vv cfn wrex cJ cuni vv cv cuni
      wceq vv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw cfn
      cin wrex cM cme wcel vd cv crp wcel wa vv cv vc cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vc cab cpw wcel cJ cuni vv cv cuni wceq wa vv cv cuni
      cX wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa
      vv cfn cM cme wcel vd cv crp wcel wa cJ cuni vv cv cuni wceq vv cv vc cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel vv cv cuni cX
      wceq vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral wa cM
      cme wcel vd cv crp wcel wa cJ cuni vv cv cuni wceq vv cv cuni cX wceq vv
      cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel vb cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv wral cM cme wcel vd cv
      crp wcel wa cJ cuni vv cv cuni wceq vv cv cuni cX wceq cM cme wcel vd cv
      crp wcel wa cJ cuni vv cv cuni wceq wa cX vv cv cuni cM cme wcel vd cv
      crp wcel wa cJ cuni vv cv cuni wceq cX vv cv cuni wceq cM cme wcel vd cv
      crp wcel wa cJ cuni cX wceq cJ cuni vv cv cuni wceq cX vv cv cuni wceq wi
      cM cme wcel cJ cuni cX wceq vd cv crp wcel cM cJ cX heibor.2 heibor.1
      uniopn2 adantr cJ cuni cX wceq cJ cuni vv cv cuni wceq cX vv cv cuni wceq
      cJ cuni cX vv cv cuni eqeq1 biimpd syl imp eqcomd ex vv cv vc cv vx cv vd
      cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vb vv cv wral wi cM cme wcel vd cv crp wcel wa vv
      cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel vb cv
      vx cv vd cv cM cbl cfv co wceq vx cX wrex vb vv cv vb cv vv cv wcel vv cv
      vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel vb cv vx
      cv vd cv cM cbl cfv co wceq vx cX wrex vb cv vv cv wcel vv cv vc cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel wa vb cv vc cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vc cab wcel vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX wrex vb cv vv cv vc cv vx cv vd cv cM cbl cfv co wceq
      vx cX wrex vc cab bepart vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex
      vb cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc vb cv vb visset vc cv
      vb cv wceq vc cv vx cv vd cv cM cbl cfv co wceq vb cv vx cv vd cv cM cbl
      cfv co wceq vx cX vc cv vb cv vx cv vd cv cM cbl cfv co eqeq1 rexbidv
      elab sylib ancoms r19.21aiva a1i anim12d ancomsd r19.22sdv cJ cuni vv cv
      cuni wceq vv cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab
      cpw wcel cJ cuni vv cv cuni wceq wa vv vc cv vx cv vd cv cM cbl cfv co
      wceq vx cX wrex vc cab cpw cfn cin cfn vv cv vc cv vx cv vd cv cM cbl cfv
      co wceq vx cX wrex vc cab cpw cfn cin wcel cJ cuni vv cv cuni wceq wa vv
      cv cfn wcel vv cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab
      cpw wcel wa cJ cuni vv cv cuni wceq wa vv cv cfn wcel vv cv vc cv vx cv
      vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel cJ cuni vv cv cuni
      wceq wa wa vv cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab
      cpw cfn cin wcel vv cv cfn wcel vv cv vc cv vx cv vd cv cM cbl cfv co
      wceq vx cX wrex vc cab cpw wcel wa cJ cuni vv cv cuni wceq vv cv vc cv vx
      cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw cfn cin wcel vv cv vc
      cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel vv cv cfn
      wcel wa vv cv cfn wcel vv cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vc cab cpw wcel wa vv cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vc cab cpw cfn elin vv cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX
      wrex vc cab cpw wcel vv cv cfn wcel ancom bitri anbi1i vv cv cfn wcel vv
      cv vc cv vx cv vd cv cM cbl cfv co wceq vx cX wrex vc cab cpw wcel cJ
      cuni vv cv cuni wceq anass bitri rexbii2 syl5ib syld cJ ccomp wcel cJ
      ctop wcel cJ cuni vy cv cuni wceq cJ cuni vv cv cuni wceq vv vy cv cpw
      cfn cin wrex wi vy cJ cpw wral vy vv cJ iscomp pm3.27bi syl5 r19.21adva
      vx vv cM cX vb vd heibor.2 istotbnd2 sylibrd imp $.
      $( [2-Sep-2009] $)

    ${
      $d B s $.
      heibor.3 $e |- M e. Met $.
      heibor.4 $e |- C e. ( Cau ` M ) $.
      heibor.5 $e |- J e. Comp $.
      heibor.6 $e |- F = { <. n , s >. | ( n e. NN /\ s =
                          ( ( cls ` J ) ` ( C " ( ZZ>= ` n ) ) ) ) } $.
      heibor.7 $e |- U = { <. l , d >. | ( l e. NN /\ d =
                          ( X \ ( F ` l ) ) ) } $.

      $( Lemma for ~ heibor . Define a sequence ` F ` of closures of upper
         sequences of a Cauchy sequence ` C ` . $)
      heiborlem2 $p |- ( N e. NN -> ( F ` N ) = ( ( cls ` J ) `
                                                ( C " ( ZZ>= ` N ) ) ) ) $=
        vn vs cN cC vn cv cuz cfv cima cJ ccl cfv cfv cC cN cuz cfv cima cJ ccl
        cfv cfv cn cF vn cv cN wceq cC vn cv cuz cfv cima cC cN cuz cfv cima cJ
        ccl cfv vn cv cN wceq vn cv cuz cfv cN cuz cfv cC vn cv cN cuz fveq2
        imaeq2d fveq2d heibor.6 cC cN cuz cfv cima cJ ccl cfv fvex fvopab4 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Define a sequence ` U ` complementary to
         ` F ` . $)
      heiborlem3 $p |- ( N e. NN -> ( U ` N ) = ( X \ ( F ` N ) ) ) $=
        vl vd cN cX vl cv cF cfv cdif cX cN cF cfv cdif cn cU vl cv cN wceq vl
        cv cF cfv cN cF cfv cX vl cv cN cF fveq2 difeq2d heibor.7 cX cvv wcel
        cX cN cF cfv cdif cvv wcel cX cM cdm cdm cvv heibor.2 cM cdm cM cM cme
        heibor.3 elisseti dmex dmex eqeltri cX cN cF cfv cvv difexg ax-mp
        fvopab4 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . ` F ` is a sequence. $)
      heiborlem4 $p |- F Fn NN $=
        vn vs cn cC vn cv cuz cfv cima cJ ccl cfv cfv cF cC vn cv cuz cfv cima
        cJ ccl cfv fvex heibor.6 fnopab2 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . ` U ` is a sequence. $)
      heiborlem5 $p |- U Fn NN $=
        vl vd cn cX vl cv cF cfv cdif cU cX cvv wcel cX vl cv cF cfv cdif cvv
        wcel cX cM cdm cdm cvv heibor.2 cM cdm cM cM cme heibor.3 elisseti dmex
        dmex eqeltri cX vl cv cF cfv cvv difexg ax-mp heibor.7 fnopab2 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Elements of ` U ` are open sets. $)
      heiborlem6 $p |- ( N e. NN -> ( U ` N ) e. J ) $=
        cN cn wcel cN cU cfv cJ wcel cC cN cuz cfv cima cJ ccl cfv cfv cJ ccld
        cfv wcel cJ ctop wcel cC cN cuz cfv cima cX wss cC cN cuz cfv cima cJ
        ccl cfv cfv cJ ccld cfv wcel cN cn wcel cC cN cuz cfv cima cJ cX cM cme
        wcel cX cJ cuni wceq heibor.3 cM cme wcel cJ cuni cX cM cJ cX heibor.2
        heibor.1 uniopn2 eqcomd ax-mp clscld cM cme wcel cJ ctop wcel heibor.3
        cM cJ heibor.1 opntop ax-mp cC cN cuz cfv cima cX wss cN cn wcel cC cN
        cuz cfv cima cC crn cX cC cN cuz cfv imassrn cC crn cc cX cxp crn cX cC
        cc cX cxp wss cC crn cc cX cxp crn wss cM cme wcel cC cM cca cfv wcel
        cC cc cX cxp wss heibor.3 heibor.4 cM cC cX heibor.2 caufss mp2an cC cc
        cX cxp rnss ax-mp cc c0 wne cc cX cxp crn cX wceq cc0 cc wcel cc c0 wne
        0cn cc cc0 ne0i ax-mp cc cX rnxp ax-mp sseqtri sstri a1i sylancr cN cn
        wcel cN cU cfv cJ wcel cX cN cF cfv cdif cJ wcel cN cF cfv cJ ccld cfv
        wcel cC cN cuz cfv cima cJ ccl cfv cfv cJ ccld cfv wcel cN cn wcel cN
        cU cfv cX cN cF cfv cdif cJ cC cU vn cF cJ cM cN cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem3 eleq1d
        cJ ctop wcel cN cF cfv cX wss cN cF cfv cJ ccld cfv wcel cX cN cF cfv
        cdif cJ wcel wb cN cn wcel cN cF cfv cJ cX cM cme wcel cX cJ cuni wceq
        heibor.3 cM cme wcel cJ cuni cX cM cJ cX heibor.2 heibor.1 uniopn2
        eqcomd ax-mp iscld2 cM cme wcel cJ ctop wcel heibor.3 cM cJ heibor.1
        opntop ax-mp cN cn wcel cN cF cfv cX wss cC cN cuz cfv cima cJ ccl cfv
        cfv cX wss cJ ctop wcel cC cN cuz cfv cima cX wss cC cN cuz cfv cima cJ
        ccl cfv cfv cX wss cM cme wcel cJ ctop wcel heibor.3 cM cJ heibor.1
        opntop ax-mp cC cN cuz cfv cima cC crn cX cC cN cuz cfv imassrn cC crn
        cc cX cxp crn cX cC cc cX cxp wss cC crn cc cX cxp crn wss cM cme wcel
        cC cM cca cfv wcel cC cc cX cxp wss heibor.3 heibor.4 cM cC cX heibor.2
        caufss mp2an cC cc cX cxp rnss ax-mp cc c0 wne cc cX cxp crn cX wceq
        cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp cc cX rnxp ax-mp sseqtri
        sstri cC cN cuz cfv cima cJ cX cM cme wcel cX cJ cuni wceq heibor.3 cM
        cme wcel cJ cuni cX cM cJ cX heibor.2 heibor.1 uniopn2 eqcomd ax-mp
        clsss3 mp2an cN cn wcel cN cF cfv cC cN cuz cfv cima cJ ccl cfv cfv cX
        cC cU vn cF cJ cM cN cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4
        heibor.5 heibor.6 heibor.7 heiborlem2 sseq1d mpbiri sylancr cN cn wcel
        cN cF cfv cC cN cuz cfv cima cJ ccl cfv cfv cJ ccld cfv cC cU vn cF cJ
        cM cN cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem2 eleq1d 3bitr2d mpbird $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Elements of ` U ` are open sets. $)
      heiborlem7 $p |- ( U " NN ) e. ~P J $=
        cU cn cima cJ cpw wcel cU cn cima cJ wss cU cn cima vx cv cU cfv vy cv
        wceq vx cn wrex vy cab cJ cU wfun cn cU cdm wss cU cn cima vx cv cU cfv
        vy cv wceq vx cn wrex vy cab wceq cU cn wfn cU wfun cC cU vn cF cJ cM
        cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem5 cn cU fnfun ax-mp cU cdm cn vl vd cn cX vl cv cF
        cfv cdif cU cX cvv wcel cX vl cv cF cfv cdif cvv wcel cX cM cdm cdm cvv
        heibor.2 cM cdm cM cM cme heibor.3 elisseti dmex dmex eqeltri cX vl cv
        cF cfv cvv difexg ax-mp heibor.7 dmopab2 eqimss2i vx vy cn cU dfimafn
        mp2an vx cv cU cfv vy cv wceq vx cn wrex vy cJ vx cv cU cfv vy cv wceq
        vy cv cJ wcel vx cn vx cv cU cfv vy cv wceq vx cv cU cfv cJ wcel vy cv
        cJ wcel vx cv cn wcel vx cv cU cfv vy cv cJ eleq1 cC cU vn cF cJ cM vx
        cv cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem6 syl5cbi r19.23aiv abssi eqsstri cU cn cima cJ cU
        wfun cU cn cima cvv wcel cU cn wfn cU wfun cC cU vn cF cJ cM cX vs vd
        vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem5 cn cU fnfun ax-mp cU cn nnex funimaex ax-mp elpw mpbir $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Relate the union of a subsequence of ` U ` to
         the intersection of a subsequence of ` F ` . $)
      heiborlem8 $p |- ( T C_ NN -> U. ( U " T ) = ( X \ |^| ( F " T ) ) ) $=
        cT cn wss vx cT cX vx cv cF cfv cdif ciun cX vx cT vx cv cF cfv ciin
        cdif cU cT cima cuni cX cF cT cima cint cdif vx cT cX vx cv cF cfv
        iundif2 cT cn wss cU cT cima cuni vy cv cX vx cv cF cfv cdif wceq vx cT
        wrex vy cab cuni vx cT cX vx cv cF cfv cdif ciun cT cn wss cU cT cima
        vy cv cX vx cv cF cfv cdif wceq vx cT wrex vy cab cT cn wss cU cT cima
        vx cv cU cfv vy cv wceq vx cT wrex vy cab vy cv cX vx cv cF cfv cdif
        wceq vx cT wrex vy cab cU wfun cT cU cdm wss cU cT cima vx cv cU cfv vy
        cv wceq vx cT wrex vy cab wceq cT cn wss vx vy cT cU dfimafn cU cn wfn
        cU wfun cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3
        heibor.4 heibor.5 heibor.6 heibor.7 heiborlem5 cn cU fnfun ax-mp cT cU
        cdm wss cT cn wss cU cdm cn cT cU cn wfn cU cdm cn wceq cC cU vn cF cJ
        cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem5 cn cU fndm ax-mp sseq2i biimpri sylancr cT cn wss
        vx cv cU cfv vy cv wceq vx cT wrex vy cv cX vx cv cF cfv cdif wceq vx
        cT wrex vy cT cn wss vx cv cU cfv vy cv wceq vy cv cX vx cv cF cfv cdif
        wceq vx cT cT cn wss vx cv cT wcel wa vx cv cn wcel vx cv cU cfv cX vx
        cv cF cfv cdif wceq vx cv cU cfv vy cv wceq vy cv cX vx cv cF cfv cdif
        wceq wb cT cn vx cv ssel2 cC cU vn cF cJ cM vx cv cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem3 vx cv
        cU cfv cX vx cv cF cfv cdif wceq vx cv cU cfv vy cv wceq cX vx cv cF
        cfv cdif vy cv wceq vy cv cX vx cv cF cfv cdif wceq vx cv cU cfv cX vx
        cv cF cfv cdif vy cv eqeq1 cX vx cv cF cfv cdif vy cv eqcom syl6bb 3syl
        rexbidva abbidv eqtrd unieqd vx vy cT cX vx cv cF cfv cdif cX cvv wcel
        cX vx cv cF cfv cdif cvv wcel cX cM cdm cdm cvv heibor.2 cM cdm cM cM
        cme heibor.3 elisseti dmex dmex eqeltri cX vx cv cF cfv cvv difexg
        ax-mp dfiun2 syl6eqr cT cn wss cF cT cima cint vx cT vx cv cF cfv ciin
        cX cT cn wss cF cT cima cint vy cv vx cv cF cfv wceq vx cT wrex vy cab
        cint vx cT vx cv cF cfv ciin cT cn wss cF cT cima vy cv vx cv cF cfv
        wceq vx cT wrex vy cab cF wfun cT cF cdm wss cF cT cima vy cv vx cv cF
        cfv wceq vx cT wrex vy cab wceq cT cn wss cF wfun cT cF cdm wss wa cF
        cT cima vx cv cF cfv vy cv wceq vx cT wrex vy cab vy cv vx cv cF cfv
        wceq vx cT wrex vy cab vx vy cT cF dfimafn vx cv cF cfv vy cv wceq vx
        cT wrex vy cv vx cv cF cfv wceq vx cT wrex vy vx cv cF cfv vy cv wceq
        vy cv vx cv cF cfv wceq vx cT vx cv cF cfv vy cv eqcom rexbii abbii
        syl6eq cF cn wfn cF wfun cC cU vn cF cJ cM cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem4 cn cF
        fnfun ax-mp cT cF cdm wss cT cn wss cF cdm cn cT cF cn wfn cF cdm cn
        wceq cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4
        heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fndm ax-mp sseq2i biimpri
        sylancr inteqd vx vy cT vx cv cF cfv vx cv cF fvex dfiin2 syl6eqr
        difeq2d 3eqtr4a $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Use compactness to show that if the elements of
         ` F ` have empty intersection, then the elements of ` U ` cover
         ` X ` , so we can take a finite subcover. $)
      heiborlem9 $p |- ( |^| ( F " NN ) = (/) ->
                      E. z e. ( ~P ( U " NN ) i^i Fin ) U. J = U. z ) $=
        cU cn cima cJ cpw wcel cJ cuni cU cn cima cuni wceq cJ cuni vz cv cuni
        wceq vz cU cn cima cpw cfn cin wrex cF cn cima cint c0 wceq cJ cuni vy
        cv cuni wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wi cJ
        cuni cU cn cima cuni wceq cJ cuni vz cv cuni wceq vz cU cn cima cpw cfn
        cin wrex wi vy cU cn cima cJ cpw vy cv cU cn cima wceq cJ cuni vy cv
        cuni wceq cJ cuni cU cn cima cuni wceq cJ cuni vz cv cuni wceq vz vy cv
        cpw cfn cin wrex cJ cuni vz cv cuni wceq vz cU cn cima cpw cfn cin wrex
        vy cv cU cn cima wceq vy cv cuni cU cn cima cuni cJ cuni vy cv cU cn
        cima unieq eqeq2d vy cv cU cn cima wceq cJ cuni vz cv cuni wceq vz vy
        cv cpw cfn cin cU cn cima cpw cfn cin vy cv cU cn cima wceq vy cv cpw
        cU cn cima cpw cfn vy cv cU cn cima pweq ineq1d rexeq1d imbi12d cJ ctop
        wcel cJ cuni vy cv cuni wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn
        cin wrex wi vy cJ cpw wral cJ ccomp wcel cJ ctop wcel cJ cuni vy cv
        cuni wceq cJ cuni vz cv cuni wceq vz vy cv cpw cfn cin wrex wi vy cJ
        cpw wral wa heibor.5 vy vz cJ iscomp mpbi pm3.27i vtoclri cU cn cima cJ
        cpw wcel cF cn cima cint c0 wceq cC cU vn cF cJ cM cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem7 a1i cF
        cn cima cint c0 wceq cU cn cima cuni cX cJ cuni cF cn cima cint c0 wceq
        cU cn cima cuni cX c0 cdif cX cF cn cima cint c0 wceq cX cF cn cima
        cint cdif cX c0 cdif cU cn cima cuni cF cn cima cint c0 cX difeq2 cn cn
        wss cU cn cima cuni cX cF cn cima cint cdif wceq cn ssid cC cn cU vn cF
        cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem8 ax-mp syl5eq cX dif0 syl6eq cM cme wcel cJ cuni cX
        wceq heibor.3 cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp syl6reqr sylc $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Rewrite the finite subcover property in terms of
         a finite subsequence. $)
      heiborlem10 $p |- ( Z e. ( ~P ( U " NN ) i^i Fin ) ->
                      E. t e. ( ~P NN i^i Fin ) Z = ( U " t ) ) $=
        cZ cU cn cima cpw cfn cin wcel cZ cU cn cima cpw wcel cZ cfn wcel wa cZ
        cU vt cv cima wceq vt cn cpw cfn cin wrex cZ cU cn cima cpw cfn elin cZ
        cU cn cima wss cZ cfn wcel cZ cU vt cv cima wceq vt cn cpw cfn cin wrex
        cZ cU cn cima cpw wcel cZ cU cn cima wss cZ cfn wcel wa vt cv cn wss vx
        cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU cfv vy cv wceq
        vy cZ wrex vx vt cv wral w3a vt cfn wrex cZ cU vt cv cima wceq vt cn
        cpw cfn cin wrex cZ cfn wcel cn cvv wcel vx cv cU cfv vy cv wceq vx cn
        wrex vy cZ wral vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy
        cZ wral vx cv cU cfv vy cv wceq vy cZ wrex vx vt cv wral w3a vt cfn
        wrex cZ cU cn cima wss cZ cfn wcel wa vx cv cU cfv vy cv wceq vy vx cZ
        cn cvv vt indexf cZ cU cn cima wss cZ cfn wcel pm3.27 cn cvv wcel cZ cU
        cn cima wss cZ cfn wcel wa nnex a1i cZ cU cn cima wss vx cv cU cfv vy
        cv wceq vx cn wrex vy cZ wral cZ cfn wcel cZ cU cn cima wss vx cv cU
        cfv vy cv wceq vx cn wrex vy cZ cU wfun vy cv cU cn cima wcel vx cv cU
        cfv vy cv wceq vx cn wrex cZ cU cn cima wss vy cv cZ wcel wa vx vy cv
        cn cU fvelima cU cn wfn cU wfun cC cU vn cF cJ cM cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem5 cn cU
        fnfun ax-mp cZ cU cn cima vy cv ssel2 sylancr r19.21aiva adantr syl3anc
        vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU
        cfv vy cv wceq vy cZ wrex vx vt cv wral w3a cZ cU vt cv cima wceq vt
        cfn cn cpw cfn cin vt cv cfn wcel vt cv cn wss vx cv cU cfv vy cv wceq
        vx vt cv wrex vy cZ wral vx cv cU cfv vy cv wceq vy cZ wrex vx vt cv
        wral w3a wa vt cv cn cpw cfn cin wcel cZ cU vt cv cima wceq vt cv cn
        cpw cfn cin wcel vt cv cn cpw wcel vt cv cfn wcel vt cv cfn wcel vt cv
        cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU cfv vy
        cv wceq vy cZ wrex vx vt cv wral w3a wa vt cv cn cpw cfn elin vt cv cn
        wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU cfv vy cv
        wceq vy cZ wrex vx vt cv wral w3a vt cv cn cpw wcel vt cv cfn wcel vt
        cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vt cv cn cpw
        wcel vx cv cU cfv vy cv wceq vy cZ wrex vx vt cv wral vt cv cn cpw wcel
        vt cv cn wss vt cv cn vt visset elpw biimpri 3ad2ant1 adantl vt cv cfn
        wcel vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx
        cv cU cfv vy cv wceq vy cZ wrex vx vt cv wral w3a pm3.26 sylanbrc vt cv
        cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU cfv vy
        cv wceq vy cZ wrex vx vt cv wral w3a cZ cU vt cv cima wceq vt cv cfn
        wcel vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx
        cv cU cfv vy cv wceq vy cZ wrex vx vt cv wral w3a vz cZ cU vt cv cima
        vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU
        cfv vy cv wceq vy cZ wrex vx vt cv wral w3a vz cv cZ wcel vz cv cU vt
        cv cima wcel vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ
        wral vz cv cZ wcel vz cv cU vt cv cima wcel wi vx cv cU cfv vy cv wceq
        vy cZ wrex vx vt cv wral vt cv cn wss vx cv cU cfv vy cv wceq vx vt cv
        wrex vy cZ wral wa vz cv cZ wcel vx cv cU cfv vz cv wceq vx vt cv wrex
        vz cv cU vt cv cima wcel vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ
        wral vz cv cZ wcel vx cv cU cfv vz cv wceq vx vt cv wrex wi vt cv cn
        wss vx cv cU cfv vy cv wceq vx vt cv wrex vx cv cU cfv vz cv wceq vx vt
        cv wrex vy vz cv cZ vy cv vz cv wceq vx cv cU cfv vy cv wceq vx cv cU
        cfv vz cv wceq vx vt cv vy cv vz cv vx cv cU cfv eqeq2 rexbidv rcla4cv
        adantl vt cv cn wss vz cv cU vt cv cima wcel vx cv cU cfv vz cv wceq vx
        vt cv wrex wb vx cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral cU cn
        wfn vt cv cn wss vz cv cU vt cv cima wcel vx cv cU cfv vz cv wceq vx vt
        cv wrex wb cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3
        heibor.4 heibor.5 heibor.6 heibor.7 heiborlem5 vx cn vt cv vz cv cU
        fvelimab mpan adantr sylibrd 3adant3 vx cv cU cfv vy cv wceq vy cZ wrex
        vx vt cv wral vt cv cn wss vz cv cU vt cv cima wcel vz cv cZ wcel wi vx
        cv cU cfv vy cv wceq vx vt cv wrex vy cZ wral vx cv cU cfv vy cv wceq
        vy cZ wrex vx vt cv wral vw cv cU cfv vz cv wceq vw vt cv wrex vz cv cZ
        wcel vz cv cU vt cv cima wcel vx cv cU cfv vy cv wceq vy cZ wrex vx vt
        cv wral vw cv cU cfv vz cv wceq vz cv cZ wcel vw vt cv vw cv vt cv wcel
        vx cv cU cfv vy cv wceq vy cZ wrex vx vt cv wral vw cv cU cfv vy cv
        wceq vy cZ wrex vw cv cU cfv vz cv wceq vz cv cZ wcel wi vx cv cU cfv
        vy cv wceq vy cZ wrex vw cv cU cfv vy cv wceq vy cZ wrex vx vw cv vt cv
        vx cv vw cv wceq vx cv cU cfv vy cv wceq vw cv cU cfv vy cv wceq vy cZ
        vx cv vw cv wceq vx cv cU cfv vw cv cU cfv vy cv vx cv vw cv cU fveq2
        eqeq1d rexbidv rcla4v vw cv cU cfv vy cv wceq vw cv cU cfv vz cv wceq
        vz cv cZ wcel wi vy cZ vy cv cZ wcel vw cv cU cfv vy cv wceq vw cv cU
        cfv vz cv wceq vz cv cZ wcel vy cv cZ wcel vy cv vz cv wceq vz cv cZ
        wcel vw cv cU cfv vy cv wceq vw cv cU cfv vz cv wceq wa vy cv vz cv
        wceq vy cv cZ wcel vz cv cZ wcel vy cv vz cv cZ eleq1 biimpcd vw cv cU
        cfv vy cv vz cv eqtr2 syl5 exp3a r19.23aiv syl6com r19.23adv cU wfun vz
        cv cU vt cv cima wcel vw cv cU cfv vz cv wceq vw vt cv wrex cU cn wfn
        cU wfun cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3
        heibor.4 heibor.5 heibor.6 heibor.7 heiborlem5 cn cU fnfun ax-mp vw vz
        cv vt cv cU fvelima mpan syl5 3ad2ant3 impbid eqrdv adantl jca r19.22i2
        syl cZ cU cn cima elpwi sylan sylbi $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Combining the previous two lemmas, if the
         elements of ` F ` have empty intersection, then so does a finite
         subsequence. $)
      heiborlem11 $p |- ( |^| ( F " NN ) = (/) ->
                      E. t e. ( ~P NN i^i Fin ) |^| ( F " t ) = (/) ) $=
        cF cn cima cint c0 wceq cJ cuni vz cv cuni wceq vz cU cn cima cpw cfn
        cin wrex cF vt cv cima cint c0 wceq vt cn cpw cfn cin wrex vz cC cU vn
        cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5
        heibor.6 heibor.7 heiborlem9 cF cn cima cint c0 wceq cX cU vt cv cima
        cuni wceq vt cn cpw cfn cin wrex cF vt cv cima cint c0 wceq vt cn cpw
        cfn cin wrex cJ cuni vz cv cuni wceq vz cU cn cima cpw cfn cin wrex cF
        cn cima cint c0 wceq cX cU vt cv cima cuni wceq cF vt cv cima cint c0
        wceq vt cn cpw cfn cin cF cn cima cint c0 wceq vt cv cn wss cX cU vt cv
        cima cuni wceq cF vt cv cima cint c0 wceq wi vt cv cn cpw cfn cin wcel
        vt cv cn wss cX cU vt cv cima cuni wceq cF vt cv cima cint c0 wceq wi
        cF cn cima cint c0 wceq vt cv cn wss cX cU vt cv cima cuni wceq vt cv
        c0 wne cF vt cv cima cint c0 wceq cX cU vt cv cima cuni wceq vt cv c0
        wceq wn vt cv c0 wne cX cU vt cv cima cuni wceq vt cv c0 wceq cX c0
        wceq cX c0 wne cX c0 wceq wn cM cme wcel cC cM cca cfv wcel cX c0 wne
        heibor.3 heibor.4 cM cC cX heibor.2 caun0 mp2an cX c0 df-ne mpbi cX cU
        vt cv cima cuni wceq cX c0 wceq cU vt cv cima cuni c0 wceq vt cv c0
        wceq cX cU vt cv cima cuni c0 eqeq1 vt cv c0 wceq cU vt cv cima cuni cU
        c0 cima cuni c0 vt cv c0 wceq cU vt cv cima cU c0 cima vt cv c0 cU
        imaeq2 unieqd cU c0 cima cuni c0 cuni c0 cU c0 cima c0 cU ima0 unieqi
        uni0 eqtri syl6eq syl5bir mtoi vt cv c0 df-ne sylibr vt cv cn wss cU vt
        cv cima cuni cX cF vt cv cima cint cdif wceq cX cU vt cv cima cuni wceq
        vt cv c0 wne cF vt cv cima cint c0 wceq wi wi cC vt cv cU vn cF cJ cM
        cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem8 cU vt cv cima cuni cX cF vt cv cima cint cdif wceq
        cX cU vt cv cima cuni wceq vt cv c0 wne vt cv cn wss cF vt cv cima cint
        c0 wceq cU vt cv cima cuni cX cF vt cv cima cint cdif wceq cX cU vt cv
        cima cuni wceq cX cX cF vt cv cima cint cdif wceq vt cv c0 wne vt cv cn
        wss cF vt cv cima cint c0 wceq wi wi cU vt cv cima cuni cX cF vt cv
        cima cint cdif cX eqeq2 cX cX cF vt cv cima cint cdif wceq vt cv c0 wne
        vt cv cn wss cF vt cv cima cint c0 wceq cX cX cF vt cv cima cint cdif
        wceq cX cF vt cv cima cint cin c0 wceq vt cv c0 wne vt cv cn wss wa cF
        vt cv cima cint c0 wceq wi cX cF vt cv cima cint disj3 vt cv c0 wne vt
        cv cn wss wa cX cF vt cv cima cint cin c0 wceq cF vt cv cima cint c0
        wceq vt cv c0 wne vt cv cn wss wa cX cF vt cv cima cint cin cF vt cv
        cima cint c0 vt cv c0 wne vt cv cn wss wa cF vt cv cima cint cX cin cF
        vt cv cima cint cX cF vt cv cima cint cin vt cv c0 wne vt cv cn wss wa
        cF vt cv cima cint cX wss cF vt cv cima cint cX cin cF vt cv cima cint
        wceq cF vt cv cima cJ ccld cfv wss cF vt cv cima c0 wne cF vt cv cima
        cint cX wss vt cv c0 wne vt cv cn wss wa cF vt cv cima cJ ccld cfv wss
        cF vt cv cima c0 wne wa cF vt cv cima cint cJ ccld cfv cuni cX cF vt cv
        cima cJ ccld cfv intssuni2 cJ ccld cfv cuni cX wss cX cJ ccld cfv wcel
        cJ ccld cfv cuni cX wceq cJ ccld cfv cuni cX wss vx cv cX wss vx cJ
        ccld cfv vx cJ ccld cfv cX unissb cJ ctop wcel vx cv cJ ccld cfv wcel
        vx cv cX wss cM cme wcel cJ ctop wcel heibor.3 cM cJ heibor.1 opntop
        ax-mp vx cv cJ cX cJ cuni cX cM cme wcel cJ cuni cX wceq heibor.3 cM cJ
        cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi cldss mpan mprgbir cJ ctop
        wcel cX cJ ccld cfv wcel cM cme wcel cJ ctop wcel heibor.3 cM cJ
        heibor.1 opntop ax-mp cJ cX cJ cuni cX cM cme wcel cJ cuni cX wceq
        heibor.3 cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi topcld ax-mp
        cJ ccld cfv cX unissel mp2an syl6ss vt cv cn wss cF vt cv cima cJ ccld
        cfv wss vt cv c0 wne vt cv cn wss vy cF vt cv cima cJ ccld cfv vt cv cn
        wss vy cv cF vt cv cima wcel vx cv cF cfv vy cv wceq vx vt cv wrex vy
        cv cJ ccld cfv wcel cF cn wfn vt cv cn wss vy cv cF vt cv cima wcel vx
        cv cF cfv vy cv wceq vx vt cv wrex wb cC cU vn cF cJ cM cX vs vd vl
        heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem4 vx cn vt cv vy cv cF fvelimab mpan vt cv cn wss vx cv cF cfv
        vy cv wceq vy cv cJ ccld cfv wcel vx vt cv vt cv cn wss vx cv vt cv
        wcel wa vx cv cn wcel vx cv cF cfv cJ ccld cfv wcel vx cv cF cfv vy cv
        wceq vy cv cJ ccld cfv wcel wi vt cv cn vx cv ssel2 vx cv cn wcel vx cv
        cF cfv cC vx cv cuz cfv cima cJ ccl cfv cfv cJ ccld cfv cC cU vn cF cJ
        cM vx cv cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5
        heibor.6 heibor.7 heiborlem2 cJ ctop wcel cC vx cv cuz cfv cima cX wss
        cC vx cv cuz cfv cima cJ ccl cfv cfv cJ ccld cfv wcel vx cv cn wcel cC
        vx cv cuz cfv cima cJ cX cJ cuni cX cM cme wcel cJ cuni cX wceq
        heibor.3 cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi clscld cM cme
        wcel cJ ctop wcel heibor.3 cM cJ heibor.1 opntop ax-mp cC vx cv cuz cfv
        cima cX wss vx cv cn wcel cC vx cv cuz cfv cima cC crn cX cC vx cv cuz
        cfv imassrn cC crn cc cX cxp crn cX cC cc cX cxp wss cC crn cc cX cxp
        crn wss cM cme wcel cC cM cca cfv wcel cC cc cX cxp wss heibor.3
        heibor.4 cM cC cX heibor.2 caufss mp2an cC cc cX cxp rnss ax-mp cc c0
        wne cc cX cxp crn cX wceq cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp
        cc cX rnxp ax-mp sseqtri sstri a1i sylancr eqeltrd vx cv cF cfv vy cv
        wceq vx cv cF cfv cJ ccld cfv wcel vy cv cJ ccld cfv wcel vx cv cF cfv
        vy cv cJ ccld cfv eleq1 biimpcd 3syl r19.23adva sylbid ssrdv adantl vt
        cv c0 wne vt cv cn wss cF vt cv cima c0 wne vt cv c0 wne vx cv vt cv
        wcel vx wex vt cv cn wss cF vt cv cima c0 wne wi vx vt cv n0 vx cv vt
        cv wcel vt cv cn wss cF vt cv cima c0 wne wi vx vt cv cn wss vx cv vt
        cv wcel vx cv cF cfv cF vt cv cima wcel cF vt cv cima c0 wne cF wfun vt
        cv cn wss vx cv vt cv wcel vx cv cF cfv cF vt cv cima wcel wi cF cn wfn
        cF wfun cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3
        heibor.4 heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fnfun ax-mp cF
        wfun vt cv cF cdm wss vx cv vt cv wcel vx cv cF cfv cF vt cv cima wcel
        wi vt cv cn wss vt cv vx cv cF funfvima2 cF cdm cn vt cv cF cn wfn cF
        cdm cn wceq cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3
        heibor.4 heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fndm ax-mp sseq2i
        sylan2br mpan cF vt cv cima vx cv cF cfv ne0i syl6com 19.23aiv sylbi
        imp sylanc cF vt cv cima cint cX df-ss sylib cX cF vt cv cima cint
        incom syl5eq eqeq1d biimpcd sylbir exp3a syl6bi com4r mpd mpdi adantl
        vt cv cn cpw cfn cin wcel vt cv cn cpw wcel vt cv cfn wcel wa vt cv cn
        wss vt cv cn cpw cfn elin vt cv cn cpw wcel vt cv cn wss vt cv cfn wcel
        vt cv cn elpwi adantr sylbi sylan2 r19.22dva cJ cuni vz cv cuni wceq cX
        cU vt cv cima cuni wceq vt cn cpw cfn cin wrex vz cU cn cima cpw cfn
        cin cJ cuni vz cv cuni wceq vz cv cU vt cv cima wceq vt cn cpw cfn cin
        wrex cX cU vt cv cima cuni wceq vt cn cpw cfn cin wrex vz cv cU cn cima
        cpw cfn cin wcel cJ cuni vz cv cuni wceq vz cv cU vt cv cima wceq cX cU
        vt cv cima cuni wceq vt cn cpw cfn cin vz cv cU vt cv cima wceq cJ cuni
        vz cv cuni wceq cX cU vt cv cima cuni wceq vz cv cU vt cv cima wceq cJ
        cuni cX vz cv cuni cU vt cv cima cuni cJ cuni cX wceq vz cv cU vt cv
        cima wceq cM cme wcel cJ cuni cX wceq heibor.3 cM cJ cX heibor.2
        heibor.1 uniopn2 ax-mp a1i vz cv cU vt cv cima unieq eqeq12d biimpcd
        r19.22sdv vt cC cU vn cF cJ cM cX vz cv vs vd vl heibor.1 heibor.2
        heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem10 syl5com
        r19.23aiv syl5 mpd $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . ` F ` forms a chain under containment. $)
      heiborlem12 $p |- ( ( A e. NN /\ B e. NN ) -> ( A < B ->
                                                ( F ` B ) C_ ( F ` A ) ) ) $=
        cA cn wcel cB cn wcel wa cA cB clt wbr cB cF cfv cA cF cfv wss cA cn
        wcel cB cn wcel wa cA cB clt wbr wa cC cB cuz cfv cima cJ ccl cfv cfv
        cC cA cuz cfv cima cJ ccl cfv cfv cB cF cfv cA cF cfv cJ ctop wcel cC
        cA cuz cfv cima cX wss cC cB cuz cfv cima cC cA cuz cfv cima wss cC cB
        cuz cfv cima cJ ccl cfv cfv cC cA cuz cfv cima cJ ccl cfv cfv wss cA cn
        wcel cB cn wcel wa cA cB clt wbr wa cC cA cuz cfv cima cC cB cuz cfv
        cima cJ cX cJ cuni cX cM cme wcel cJ cuni cX wceq heibor.3 cM cJ cX
        heibor.2 heibor.1 uniopn2 ax-mp eqcomi clsss cJ ctop wcel cA cn wcel cB
        cn wcel wa cA cB clt wbr wa cM cme wcel cJ ctop wcel heibor.3 cM cJ
        heibor.1 opntop ax-mp a1i cC cA cuz cfv cima cX wss cA cn wcel cB cn
        wcel wa cA cB clt wbr wa cC cA cuz cfv cima cC crn cX cC cA cuz cfv
        imassrn cC crn cc cX cxp crn cX cC cc cX cxp wss cC crn cc cX cxp crn
        wss cM cme wcel cC cM cca cfv wcel cC cc cX cxp wss heibor.3 heibor.4
        cM cC cX heibor.2 caufss mp2an cC cc cX cxp rnss ax-mp cc c0 wne cc cX
        cxp crn cX wceq cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp cc cX rnxp
        ax-mp sseqtri sstri a1i cA cn wcel cB cn wcel wa cA cB clt wbr wa cB cA
        cuz cfv wcel cB cuz cfv cA cuz cfv wss cC cB cuz cfv cima cC cA cuz cfv
        cima wss cA cn wcel cB cn wcel wa cA cB clt wbr wa cA cz wcel cB cz
        wcel wa cA cB clt wbr wa cA cz wcel cB cz wcel wa cA cB cle wbr wa cB
        cA cuz cfv wcel cA cn wcel cB cn wcel wa cA cz wcel cB cz wcel wa cA cB
        clt wbr cA cn wcel cA cz wcel cB cn wcel cB cz wcel cA nnz cB nnz
        anim12i anim1i cA cz wcel cB cz wcel wa cA cB clt wbr cA cB cle wbr cA
        cr wcel cB cr wcel cA cB clt wbr cA cB cle wbr wi cA cz wcel cB cz wcel
        cA cB ltle cA zre cB zre syl2an imdistani cA cz wcel cB cz wcel wa cB
        cA cuz cfv wcel cA cB cle wbr cA cB eluz biimpar 3syl cA cB uzss cB cuz
        cfv cA cuz cfv cC imass2 3syl syl3anc cB cn wcel cB cF cfv cC cB cuz
        cfv cima cJ ccl cfv cfv wceq cA cn wcel cA cB clt wbr cC cU vn cF cJ cM
        cB cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem2 ad2antlr cA cn wcel cA cF cfv cC cA cuz cfv cima cJ
        ccl cfv cfv wceq cB cn wcel cA cB clt wbr cC cU vn cF cJ cM cA cX vs vd
        vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem2 ad2antrr 3sstr4d ex $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . If a finite subsequence of ` F ` has empty
         intersection, the maximal element of that subsequence must be
         empty. $)
      heiborlem13 $p |- ( E. t e. ( ~P NN i^i Fin ) |^| ( F " t ) = (/) ->
                                    E. m e. NN ( F ` m ) = (/) ) $=
        cF vt cv cima cint c0 wceq vt cn cpw cfn cin wrex vt cv cn wss cF vt cv
        cima cint c0 wceq vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral
        vm vt cv wrex w3a vt wex vm cv cF cfv c0 wceq vm cn wrex cF vt cv cima
        cint c0 wceq vt cn cpw cfn cin wrex vt cv cn cpw cfn cin wcel cF vt cv
        cima cint c0 wceq wa vt wex vt cv cn wss cF vt cv cima cint c0 wceq vm
        cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm vt cv wrex w3a vt
        wex cF vt cv cima cint c0 wceq vt cn cpw cfn cin df-rex vt cv cn cpw
        cfn cin wcel cF vt cv cima cint c0 wceq wa vt cv cn wss cF vt cv cima
        cint c0 wceq vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm vt
        cv wrex w3a vt vt cv cn wss vt cv cfn wcel wa cF vt cv cima cint c0
        wceq vt cv cn wss cF vt cv cima cint c0 wceq vm cv vx cv wne vx cv vm
        cv clt wbr wi vx vt cv wral vm vt cv wrex w3a vt cv cn cpw cfn cin wcel
        vt cv cn wss vt cv cfn wcel wa cF vt cv cima cint c0 wceq wa vt cv cn
        wss cF vt cv cima cint c0 wceq vm cv vx cv wne vx cv vm cv clt wbr wi
        vx vt cv wral vm vt cv wrex vt cv cn wss vt cv cfn wcel cF vt cv cima
        cint c0 wceq simpll vt cv cn wss vt cv cfn wcel wa cF vt cv cima cint
        c0 wceq pm3.27 vt cv clt wor vt cv cfn wcel vt cv c0 wne vm cv vx cv
        wne vx cv vm cv clt wbr wi vx vt cv wral vm vt cv wrex vt cv cn wss vt
        cv cfn wcel wa cF vt cv cima cint c0 wceq wa vm vx vt cv clt fimaxg vt
        cv cn wss vt cv clt wor vt cv cfn wcel cF vt cv cima cint c0 wceq vt cv
        cn wss vt cv cr wss vt cv clt wor vt cv cn wss cn cr wss vt cv cr wss
        nnssre vt cv cn cr sstr mpan2 vt cv cr wss cr clt wor vt cv clt wor
        ltso vt cv cr clt soss mpi syl ad2antrr vt cv cn wss vt cv cfn wcel cF
        vt cv cima cint c0 wceq simplr cF vt cv cima cint c0 wceq vt cv c0 wne
        vt cv cn wss vt cv cfn wcel wa cF vt cv cima cint c0 wceq vt cv c0 wceq
        wn vt cv c0 wne cF vt cv cima cint c0 wceq vt cv c0 wceq cvv c0 wceq c0
        cvv wcel cvv c0 wceq wn 0ex cvv c0 n0i ax-mp vt cv c0 wceq cF vt cv
        cima cint c0 wceq cvv c0 wceq vt cv c0 wceq cF vt cv cima cint cvv c0
        vt cv c0 wceq cF vt cv cima cint c0 cint cvv vt cv c0 wceq cF vt cv
        cima c0 vt cv c0 wceq cF vt cv cima cF c0 cima c0 vt cv c0 cF imaeq2 cF
        ima0 syl6eq inteqd int0 syl6eq eqeq1d biimpcd mtoi vt cv c0 df-ne
        sylibr adantl syl3anc 3jca vt cv cn cpw cfn cin wcel vt cv cn cpw wcel
        vt cv cfn wcel wa vt cv cn wss vt cv cfn wcel wa vt cv cn cpw cfn elin
        vt cv cn cpw wcel vt cv cn wss vt cv cfn wcel vt cv cn elpwi anim1i
        sylbi sylan 19.22i sylbi vt cv cn wss cF vt cv cima cint c0 wceq vm cv
        vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm vt cv wrex w3a vm cv
        cF cfv c0 wceq vm cn wrex vt vt cv cn wss cF vt cv cima cint c0 wceq vm
        cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm vt cv wrex vm cv
        cF cfv c0 wceq vm cn wrex vt cv cn wss cF vt cv cima cint c0 wceq wa vm
        cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm cv cF cfv c0 wceq
        vm vt cv cn vt cv cn wss cF vt cv cima cint c0 wceq wa vm cv vt cv wcel
        vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral wa vm cv cn wcel
        vm cv cF cfv c0 wceq vt cv cn wss cF vt cv cima cint c0 wceq wa vm cv
        vt cv wcel vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral wa vm
        cv cn wcel vt cv cn wss vm cv vt cv wcel vm cv cn wcel cF vt cv cima
        cint c0 wceq vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vt cv
        cn vm cv ssel2 ad2ant2r ex vt cv cn wss cF vt cv cima cint c0 wceq wa
        vm cv vt cv wcel vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral
        wa vm cv cF cfv cF vt cv cima cint wceq vm cv cF cfv c0 wceq vt cv cn
        wss cF vt cv cima cint c0 wceq wa vm cv vt cv wcel vm cv vx cv wne vx
        cv vm cv clt wbr wi vx vt cv wral wa vm cv cF cfv cF vt cv cima cint
        wceq vt cv cn wss cF vt cv cima cint c0 wceq wa vm cv vt cv wcel vm cv
        vx cv wne vx cv vm cv clt wbr wi vx vt cv wral wa wa vm cv cF cfv cF vt
        cv cima cint vt cv cn wss cF vt cv cima cint c0 wceq wa vm cv vt cv
        wcel vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral wa wa vm cv
        cF cfv vy cv wss vy cF vt cv cima wral vm cv cF cfv cF vt cv cima cint
        wss vt cv cn wss cF vt cv cima cint c0 wceq wa vm cv vt cv wcel vm cv
        vx cv wne vx cv vm cv clt wbr wi vx vt cv wral wa wa vm cv cF cfv vy cv
        wss vy cF vt cv cima vt cv cn wss vm cv vt cv wcel vm cv vx cv wne vx
        cv vm cv clt wbr wi vx vt cv wral wa vy cv cF vt cv cima wcel vm cv cF
        cfv vy cv wss cF vt cv cima cint c0 wceq vt cv cn wss vm cv vt cv wcel
        vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral wa wa vz cv cF cfv
        vy cv wceq vz vt cv wrex vm cv cF cfv vy cv wss vy cv cF vt cv cima
        wcel vt cv cn wss vm cv vt cv wcel vm cv vx cv wne vx cv vm cv clt wbr
        wi vx vt cv wral wa wa vz cv cF cfv vy cv wceq vz vt cv wrex vm cv cF
        cfv vy cv wss vt cv cn wss vm cv vt cv wcel vm cv vx cv wne vx cv vm cv
        clt wbr wi vx vt cv wral wa wa vz cv cF cfv vy cv wceq vm cv cF cfv vy
        cv wss vz vt cv vz cv cF cfv vy cv wceq vm cv cF cfv vz cv cF cfv wss
        vm cv cF cfv vy cv wss vt cv cn wss vm cv vt cv wcel vm cv vx cv wne vx
        cv vm cv clt wbr wi vx vt cv wral wa wa vz cv vt cv wcel wa vz cv cF
        cfv vy cv vm cv cF cfv sseq2 vt cv cn wss vm cv vt cv wcel vm cv vx cv
        wne vx cv vm cv clt wbr wi vx vt cv wral wa wa vz cv vt cv wcel vm cv
        cF cfv vz cv cF cfv wss vt cv cn wss vm cv vt cv wcel vm cv vx cv wne
        vx cv vm cv clt wbr wi vx vt cv wral vz cv vt cv wcel vm cv cF cfv vz
        cv cF cfv wss wi vt cv cn wss vm cv cn wcel wa vm cv vx cv wne vx cv vm
        cv clt wbr wi vx vt cv wral vz cv vt cv wcel vm cv cF cfv vz cv cF cfv
        wss wi vt cv cn wss vm cv vt cv wcel wa vt cv cn wss vm cv cn wcel wa
        vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vz cv vt cv wcel
        vm cv cF cfv vz cv cF cfv wss wi vt cv cn wss vm cv cn wcel wa vz cv vt
        cv wcel vm cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm cv cF
        cfv vz cv cF cfv wss vt cv cn wss vm cv cn wcel wa vz cv vt cv wcel vm
        cv vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm cv vz cv wne vz cv
        vm cv clt wbr wi vm cv cF cfv vz cv cF cfv wss vz cv vt cv wcel vm cv
        vx cv wne vx cv vm cv clt wbr wi vx vt cv wral vm cv vz cv wne vz cv vm
        cv clt wbr wi wi wi vt cv cn wss vm cv cn wcel wa vm cv vx cv wne vx cv
        vm cv clt wbr wi vm cv vz cv wne vz cv vm cv clt wbr wi vx vz cv vt cv
        vx cv vz cv wceq vm cv vx cv wne vm cv vz cv wne vx cv vm cv clt wbr vz
        cv vm cv clt wbr vx cv vz cv vm cv neeq2 vx cv vz cv vm cv clt breq1
        imbi12d rcla4v a1i vt cv cn wss vm cv cn wcel vz cv vt cv wcel vm cv vz
        cv wne vz cv vm cv clt wbr wi vm cv cF cfv vz cv cF cfv wss wi wi vt cv
        cn wss vz cv vt cv wcel vm cv cn wcel vm cv vz cv wne vz cv vm cv clt
        wbr wi vm cv cF cfv vz cv cF cfv wss wi vt cv cn wss vz cv vt cv wcel
        vz cv cn wcel vm cv cn wcel vm cv vz cv wne vz cv vm cv clt wbr wi vm
        cv cF cfv vz cv cF cfv wss wi wi vt cv cn vz cv ssel vz cv cn wcel vm
        cv cn wcel vm cv vz cv wne vz cv vm cv clt wbr wi vm cv cF cfv vz cv cF
        cfv wss wi vm cv vz cv wne vz cv vm cv clt wbr wi vz cv vm cv clt wbr
        vm cv cF cfv vz cv cF cfv wss wi vm cv cF cfv vz cv cF cfv wss vz cv cn
        wcel vm cv cn wcel wa vm cv vz cv wne vz cv vm cv clt wbr wi vz cv vm
        cv clt wbr vm cv cF cfv vz cv cF cfv wss wi vm cv vz cv wne vm cv cF
        cfv vz cv cF cfv wss wi vm cv cF cfv vz cv cF cfv wss vm cv vz cv wne
        vz cv vm cv clt wbr vm cv cF cfv vz cv cF cfv wss imim1 vm cv vz cv wne
        vm cv cF cfv vz cv cF cfv wss wi vm cv vz cv wceq wn vm cv cF cfv vz cv
        cF cfv wss wi vm cv cF cfv vz cv cF cfv wss vm cv vz cv wne vm cv vz cv
        wceq wn vm cv cF cfv vz cv cF cfv wss vm cv vz cv df-ne imbi1i vm cv vz
        cv wceq vm cv cF cfv vz cv cF cfv wss wi vm cv vz cv wceq wn vm cv cF
        cfv vz cv cF cfv wss wi vm cv cF cfv vz cv cF cfv wss wi vm cv vz cv
        wceq vm cv cF cfv vz cv cF cfv wss vz cv cF cfv vz cv cF cfv wss vz cv
        cF cfv ssid vm cv vz cv wceq vm cv cF cfv vz cv cF cfv vz cv cF cfv vm
        cv vz cv cF fveq2 sseq1d mpbiri vm cv vz cv wceq vm cv cF cfv vz cv cF
        cfv wss pm2.61 ax-mp sylbi syl6 vz cv vm cv cC cU vn cF cJ cM cX vs vd
        vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem12 syl5com ex syl6 com23 imp syldd com23 imp vt cv cn wss vm
        cv vt cv wcel vm cv cn wcel vt cv cn vm cv ssel imdistani sylan anasss
        imp syl5cbi r19.23adva imp cF wfun vy cv cF vt cv cima wcel vz cv cF
        cfv vy cv wceq vz vt cv wrex cF cn wfn cF wfun cC cU vn cF cJ cM cX vs
        vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem4 cn cF fnfun ax-mp vz vy cv vt cv cF fvelima mpan sylan2
        adantllr r19.21aiva vy vm cv cF cfv cF vt cv cima ssint sylibr vt cv cn
        wss cF vt cv cima cint c0 wceq wa vm cv vt cv wcel vm cv vx cv wne vx
        cv vm cv clt wbr wi vx vt cv wral wa wa vm cv cF cfv cF vt cv cima wcel
        cF vt cv cima cint vm cv cF cfv wss vt cv cn wss vm cv vt cv wcel vm cv
        cF cfv cF vt cv cima wcel cF vt cv cima cint c0 wceq vm cv vx cv wne vx
        cv vm cv clt wbr wi vx vt cv wral vt cv cn wss vm cv vt cv wcel vm cv
        cF cfv cF vt cv cima wcel cF wfun vt cv cn wss vm cv vt cv wcel vm cv
        cF cfv cF vt cv cima wcel wi cF cn wfn cF wfun cC cU vn cF cJ cM cX vs
        vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem4 cn cF fnfun ax-mp cF wfun vt cv cF cdm wss vm cv vt cv wcel
        vm cv cF cfv cF vt cv cima wcel wi vt cv cn wss vt cv vm cv cF
        funfvima2 cF cdm cn vt cv cF cn wfn cF cdm cn wceq cC cU vn cF cJ cM cX
        vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem4 cn cF fndm ax-mp sseq2i sylan2br mpan imp ad2ant2r vm cv cF
        cfv cF vt cv cima intss1 syl eqssd ex cF vt cv cima cint c0 wceq vm cv
        cF cfv cF vt cv cima cint wceq vm cv cF cfv c0 wceq wi vt cv cn wss cF
        vt cv cima cint c0 wceq vm cv cF cfv cF vt cv cima cint wceq vm cv cF
        cfv c0 wceq cF vt cv cima cint c0 vm cv cF cfv eqeq2 biimpd adantl syld
        jcad r19.22dv2 3impia 19.23aiv syl $.
        $( [2-Sep-2009] $)

      heibor.8 $e |- C : NN --> X $.

      $( Lemma for ~ heibor . Use modus tollens to show that the intersection
         of elements of ` F ` cannot be empty. $)
      heiborlem14 $p |- |^| ( F " NN ) =/= (/) $=
        cF cn cima cint c0 wne cF cn cima cint c0 wceq wn cF cn cima cint c0
        wceq vm cv cF cfv c0 wceq vm cn wrex vm cv cF cfv c0 wceq vm cn vm cv
        cn wcel vm cv cC cfv vm cv cF cfv wcel vm cv cF cfv c0 wceq wn vm cv cn
        wcel vm cv cC cfv cC vm cv cuz cfv cima cJ ccl cfv cfv vm cv cF cfv vm
        cv cn wcel cC vm cv cuz cfv cima cC vm cv cuz cfv cima cJ ccl cfv cfv
        vm cv cC cfv cC vm cv cuz cfv cima cC vm cv cuz cfv cima cJ ccl cfv cfv
        wss vm cv cn wcel cJ ctop wcel cC vm cv cuz cfv cima cX wss cC vm cv
        cuz cfv cima cC vm cv cuz cfv cima cJ ccl cfv cfv wss cM cme wcel cJ
        ctop wcel heibor.3 cM cJ heibor.1 opntop ax-mp cC vm cv cuz cfv cima cC
        crn cX cC vm cv cuz cfv imassrn cC crn cc cX cxp crn cX cC cc cX cxp
        wss cC crn cc cX cxp crn wss cM cme wcel cC cM cca cfv wcel cC cc cX
        cxp wss heibor.3 heibor.4 cM cC cX heibor.2 caufss mp2an cC cc cX cxp
        rnss ax-mp cc c0 wne cc cX cxp crn cX wceq cc0 cc wcel cc c0 wne 0cn cc
        cc0 ne0i ax-mp cc cX rnxp ax-mp sseqtri sstri cC vm cv cuz cfv cima cJ
        cX cM cme wcel cX cJ cuni wceq heibor.3 cM cme wcel cJ cuni cX cM cJ cX
        heibor.2 heibor.1 uniopn2 eqcomd ax-mp sscls mp2an a1i cC wfun vm cv cC
        cdm wcel wa vm cv vm cv cuz cfv wcel vm cv cC cfv cC vm cv cuz cfv cima
        wcel vm cv cn wcel vm cv cuz cfv vm cv cC funfvima vm cv cn wcel vm cv
        cC cdm wcel cC wfun vm cv cC cdm wcel vm cv cn wcel cC cdm cn vm cv cn
        cX cC heibor.8 fdmi eleq2i biimpri cn cX cC wf cC wfun heibor.8 cn cX
        cC ffun ax-mp jctil vm cv cn wcel vm cv cz wcel vm cv vm cv cuz cfv
        wcel vm cv nnz vm cv uzid syl sylc sseldd cC cU vn cF cJ cM vm cv cX vs
        vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem2 eleqtrrd vm cv cF cfv vm cv cC cfv n0i syl nrex cF cn cima
        cint c0 wceq cF vt cv cima cint c0 wceq vt cn cpw cfn cin wrex vm cv cF
        cfv c0 wceq vm cn wrex vt cC cU vn cF cJ cM cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem11 vt cC
        cU vm vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4
        heibor.5 heibor.6 heibor.7 heiborlem13 syl mto cF cn cima cint c0 df-ne
        mpbir $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . If the intersection of ` F ` contains an element,
         then that element is an accumulation point of ` C ` . $)
      heiborlem15 $p |- ( Y e. |^| ( F " NN ) -> A. r e. RR+ A. x e. NN
                    E. y e. ( ZZ>= ` x ) ( C ` y ) e. ( Y ( ball ` M ) r ) ) $=
        cY cF cn cima cint wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy vx
        cv cuz cfv wrex vr vx crp cn vr cv crp wcel vx cv cn wcel wa cY cF cn
        cima cint wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz
        cfv wrex vr cv crp wcel vx cv cn wcel cY cF cn cima cint wcel vy cv cC
        cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cv cn wcel cY
        cF cn cima cint wcel wa vr cv crp wcel vy cv cC cfv cY vr cv cM cbl cfv
        co wcel vy vx cv cuz cfv wrex vx cv cn wcel cY cF cn cima cint wcel wa
        vx cv cn wcel cY cC vx cv cuz cfv cima wcel cY cC vx cv cuz cfv cima cJ
        clp cfv cfv wcel wo wa vr cv crp wcel vy cv cC cfv cY vr cv cM cbl cfv
        co wcel vy vx cv cuz cfv wrex wi vx cv cn wcel cY cF cn cima cint wcel
        cY cC vx cv cuz cfv cima wcel cY cC vx cv cuz cfv cima cJ clp cfv cfv
        wcel wo vx cv cn wcel cY cF cn cima cint wcel cY vx cv cF cfv wcel cY
        cC vx cv cuz cfv cima wcel cY cC vx cv cuz cfv cima cJ clp cfv cfv wcel
        wo cY cF cn cima cint wcel vx cv cF cfv cF cn cima wcel cY vx cv cF cfv
        wcel vx cv cn wcel cY cF cn cima vx cv cF cfv elinti cF wfun cn cF cdm
        wss vx cv cn wcel vx cv cF cfv cF cn cima wcel wi cF cn wfn cF wfun cC
        cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5
        heibor.6 heibor.7 heiborlem4 cn cF fnfun ax-mp cF cdm cn cF cn wfn cF
        cdm cn wceq cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3
        heibor.4 heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fndm ax-mp
        eqimss2i cn vx cv cF funfvima2 mp2an syl5com vx cv cn wcel cY vx cv cF
        cfv wcel cY cC vx cv cuz cfv cima cC vx cv cuz cfv cima cJ clp cfv cfv
        cun wcel cY cC vx cv cuz cfv cima wcel cY cC vx cv cuz cfv cima cJ clp
        cfv cfv wcel wo vx cv cn wcel vx cv cF cfv cC vx cv cuz cfv cima cC vx
        cv cuz cfv cima cJ clp cfv cfv cun cY vx cv cn wcel vx cv cF cfv cC vx
        cv cuz cfv cima cJ ccl cfv cfv cC vx cv cuz cfv cima cC vx cv cuz cfv
        cima cJ clp cfv cfv cun cC cU vn cF cJ cM vx cv cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem2 cJ
        ctop wcel cC vx cv cuz cfv cima cX wss cC vx cv cuz cfv cima cJ ccl cfv
        cfv cC vx cv cuz cfv cima cC vx cv cuz cfv cima cJ clp cfv cfv cun wceq
        vx cv cn wcel cC vx cv cuz cfv cima cJ cX cJ cuni cX cM cme wcel cJ
        cuni cX wceq heibor.3 cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi
        clslp cM cme wcel cJ ctop wcel heibor.3 cM cJ heibor.1 opntop ax-mp cC
        vx cv cuz cfv cima cX wss vx cv cn wcel cC vx cv cuz cfv cima cC crn cX
        cC vx cv cuz cfv imassrn cn cX cC wf cC crn cX wss heibor.8 cn cX cC
        frn ax-mp sstri a1i sylancr eqtrd eleq2d cY cC vx cv cuz cfv cima cC vx
        cv cuz cfv cima cJ clp cfv cfv elun syl6bb sylibd imdistani vx cv cn
        wcel cY cC vx cv cuz cfv cima wcel cY cC vx cv cuz cfv cima cJ clp cfv
        cfv wcel wo vr cv crp wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy
        vx cv cuz cfv wrex wi vx cv cn wcel cY cC vx cv cuz cfv cima wcel vr cv
        crp wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex
        wi cY cC vx cv cuz cfv cima cJ clp cfv cfv wcel vx cv cn wcel vy cv cC
        cfv cY wceq vy vx cv cuz cfv wrex vr cv crp wcel vy cv cC cfv cY vr cv
        cM cbl cfv co wcel vy vx cv cuz cfv wrex wi cY cC vx cv cuz cfv cima
        wcel vx cv cn wcel vr cv crp wcel vy cv cC cfv cY wceq vy vx cv cuz cfv
        wrex vy cv cC cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex vx
        cv cn wcel vr cv crp wcel vy cv cC cfv cY wceq vy vx cv cuz cfv wrex vy
        cv cC cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex wi vx cv cn
        wcel vr cv crp wcel wa vy cv cC cfv cY wceq vy cv cC cfv cY vr cv cM
        cbl cfv co wcel vy vx cv cuz cfv vx cv cn wcel vr cv crp wcel vy cv vx
        cv cuz cfv wcel vy cv cC cfv cY wceq vy cv cC cfv cY vr cv cM cbl cfv
        co wcel wi wi vx cv cn wcel vy cv vx cv cuz cfv wcel vr cv crp wcel vy
        cv cC cfv cY wceq vy cv cC cfv cY vr cv cM cbl cfv co wcel wi vx cv cn
        wcel vy cv vx cv cuz cfv wcel vy cv cC cfv cX wcel vr cv crp wcel vy cv
        cC cfv cY wceq vy cv cC cfv cY vr cv cM cbl cfv co wcel wi wi vx cv cn
        wcel vy cv vx cv cuz cfv wcel vy cv cn wcel vy cv cC cfv cX wcel vx cv
        cn wcel vx cv cuz cfv cn vy cv vx cv c1 cuz cfv wcel vx cv cuz cfv c1
        cuz cfv wss vx cv cn wcel vx cv cuz cfv cn wss c1 vx cv uzss vx cv
        elnnuz cn c1 cuz cfv vx cv cuz cfv nnuz sseq2i 3imtr4i sseld cn cX vy
        cv cC heibor.8 ffvelrni syl6 vy cv cC cfv cY wceq vy cv cC cfv cX wcel
        vr cv crp wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy cv cC cfv cY
        wceq vy cv cC cfv cX wcel cY cX wcel vr cv crp wcel vy cv cC cfv cY vr
        cv cM cbl cfv co wcel wi vy cv cC cfv cY cX eleq1 cY cX wcel vr cv crp
        wcel cY cY vr cv cM cbl cfv co wcel vy cv cC cfv cY wceq vy cv cC cfv
        cY vr cv cM cbl cfv co wcel cY cX wcel vr cv crp wcel cY cY vr cv cM
        cbl cfv co wcel cM cme wcel cY cX wcel wa vr cv cr wcel cc0 vr cv clt
        wbr wa cY cY vr cv cM cbl cfv co wcel cY cX wcel vr cv crp wcel cM cY
        vr cv cX heibor.2 blcntr cY cX wcel cM cme wcel heibor.3 jctl vr cv
        rpregt0 syl2an ex vy cv cC cfv cY wceq vy cv cC cfv cY vr cv cM cbl cfv
        co wcel cY cY vr cv cM cbl cfv co wcel vy cv cC cfv cY cY vr cv cM cbl
        cfv co eleq1 biimprd syl9r sylbid com3l syl6 com23 imp r19.22dv ex
        com23 cC wfun cY cC vx cv cuz cfv cima wcel vy cv cC cfv cY wceq vy vx
        cv cuz cfv wrex cn cX cC wf cC wfun heibor.8 cn cX cC ffun ax-mp vy cY
        vx cv cuz cfv cC fvelima mpan syl5 cY cC vx cv cuz cfv cima cJ clp cfv
        cfv wcel vr cv crp wcel vz cv cY vr cv cM cbl cfv co wcel vz cC vx cv
        cuz cfv cima wrex vx cv cn wcel vy cv cC cfv cY vr cv cM cbl cfv co
        wcel vy vx cv cuz cfv wrex cM cme wcel cC vx cv cuz cfv cima cX wss cY
        cC vx cv cuz cfv cima cJ clp cfv cfv wcel vr cv crp wcel vz cv cY vr cv
        cM cbl cfv co wcel vz cC vx cv cuz cfv cima wrex wi heibor.3 cC vx cv
        cuz cfv cima cC crn cX cC vx cv cuz cfv imassrn cn cX cC wf cC crn cX
        wss heibor.8 cn cX cC frn ax-mp sstri cM cme wcel cC vx cv cuz cfv cima
        cX wss cY cC vx cv cuz cfv cima cJ clp cfv cfv wcel w3a vr cv crp wcel
        vz cv cY vr cv cM cbl cfv co wcel vz cC vx cv cuz cfv cima wrex cM cme
        wcel cC vx cv cuz cfv cima cX wss cY cC vx cv cuz cfv cima cJ clp cfv
        cfv wcel w3a vr cv cr wcel cc0 vr cv clt wbr wa vz cv cY vr cv cM cbl
        cfv co wcel vz cC vx cv cuz cfv cima wrex vr cv crp wcel vz cM cY vr cv
        cC vx cv cuz cfv cima cJ cX heibor.2 heibor.1 lpbl vr cv rpregt0 sylan2
        ex mp3an12 vx cv cn wcel vz cv cY vr cv cM cbl cfv co wcel vy cv cC cfv
        cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex vz cC vx cv cuz cfv
        cima vz cv cY vr cv cM cbl cfv co wcel vy cv cC cfv vz cv wceq vy vx cv
        cuz cfv wrex vy cv cC cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv
        wrex vx cv cn wcel vz cv cC vx cv cuz cfv cima wcel wa vz cv cY vr cv
        cM cbl cfv co wcel vy cv cC cfv vz cv wceq vy cv cC cfv cY vr cv cM cbl
        cfv co wcel vy vx cv cuz cfv vz cv cY vr cv cM cbl cfv co vy cv cC cfv
        eleq1a r19.22sdv vz cv cC vx cv cuz cfv cima wcel vy cv cC cfv vz cv
        wceq vy vx cv cuz cfv wrex vx cv cn wcel cC wfun vz cv cC vx cv cuz cfv
        cima wcel vy cv cC cfv vz cv wceq vy vx cv cuz cfv wrex cn cX cC wf cC
        wfun heibor.8 cn cX cC ffun ax-mp vy vz cv vx cv cuz cfv cC fvelima
        mpan adantl syl5com r19.23adva syl9r jaod imp syl impcom anassrs expcom
        r19.21aivv $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Using the fact that ` C ` is Cauchy, the
         accumulation point must be the limit of ` C ` . $)
      heiborlem16 $p |- ( Y e. |^| ( F " NN ) -> C ( ~~>m ` M ) Y ) $=
        cY cF cn cima cint wcel cC cY cM clm cfv wbr cc0 vt cv clt wbr vu cv vz
        cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cn wrex
        wi vt cr wral cY cX wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy vx
        cv cuz cfv wrex vx cn wral vr crp wral cc0 vt cv clt wbr vu cv vz cv
        cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cn wrex wi
        vt cr wral cY cF cn cima cint wcel cY cX wcel vy cv cC cfv cY vr cv cM
        cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr crp wral wa cc0 vt
        cv clt wbr vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi
        vz cn wral vu cn wrex wi vt cr cY cX wcel vy cv cC cfv cY vr cv cM cbl
        cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr crp wral wa vt cv cr
        wcel cc0 vt cv clt wbr vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv
        clt wbr wi vz cn wral vu cn wrex cY cX wcel vy cv cC cfv cY vr cv cM
        cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr crp wral wa vt cv
        crp wcel vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz
        cn wral vu cn wrex vt cv cr wcel cc0 vt cv clt wbr wa cY cX wcel vy cv
        cC cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr
        crp wral vt cv crp wcel vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv
        clt wbr wi vz cn wral vu cn wrex wi cY cX wcel vt cv crp wcel vy cv cC
        cfv cY vr cv cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr crp
        wral vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn
        wral vu cn wrex cY cX wcel vt cv crp wcel vy cv cC cfv cY vr cv cM cbl
        cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr crp wral vy cv cC cfv
        cY vt cv c2 cdiv co cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral
        vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn wral
        vu cn wrex vt cv crp wcel vy cv cC cfv cY vr cv cM cbl cfv co wcel vy
        vx cv cuz cfv wrex vx cn wral vr crp wral vy cv cC cfv cY vt cv c2 cdiv
        co cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral wi wi cY cX wcel
        vt cv crp wcel vt cv c2 cdiv co crp wcel vy cv cC cfv cY vr cv cM cbl
        cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr crp wral vy cv cC cfv
        cY vt cv c2 cdiv co cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral
        wi vt cv crp wcel c2 crp wcel vt cv c2 cdiv co crp wcel c2 2re 2pos
        elrpii vt cv c2 rpdivcl mpan2 vy cv cC cfv cY vr cv cM cbl cfv co wcel
        vy vx cv cuz cfv wrex vx cn wral vy cv cC cfv cY vt cv c2 cdiv co cM
        cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vr vt cv c2 cdiv co
        crp vr cv vt cv c2 cdiv co wceq vy cv cC cfv cY vr cv cM cbl cfv co
        wcel vy vx cv cuz cfv wrex vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv
        co wcel vy vx cv cuz cfv wrex vx cn vr cv vt cv c2 cdiv co wceq vy cv
        cC cfv cY vr cv cM cbl cfv co wcel vy cv cC cfv cY vt cv c2 cdiv co cM
        cbl cfv co wcel vy vx cv cuz cfv vr cv vt cv c2 cdiv co wceq cY vr cv
        cM cbl cfv co cY vt cv c2 cdiv co cM cbl cfv co vy cv cC cfv vr cv vt
        cv c2 cdiv co cY cM cbl cfv opreq2 eleq2d rexbidv ralbidv rcla4v syl
        a1i cY cX wcel vt cv crp wcel vw cv vz cv cle wbr vw cv vv cv cle wbr
        wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv
        cM co vt cv c2 cdiv co clt wbr w3a wi vv cn wral vz cn wral vw cn wrex
        vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vy vx cv cuz cfv
        wrex vx cn wral vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr
        wi vz cn wral vu cn wrex wi vt cv crp wcel vw cv vz cv cle wbr vw cv vv
        cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv
        cv cC cfv cM co vr cv clt wbr w3a wi vv cn wral vz cn wral vw cn wrex
        vr crp wral vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX
        wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv
        co clt wbr w3a wi vv cn wral vz cn wral vw cn wrex vw cv vz cv cle wbr
        vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv
        cC cfv vv cv cC cfv cM co vr cv clt wbr w3a wi vv cn wral vz cn wral vw
        cn wrex vr crp wral vr cv crp wcel vw cv vz cv cle wbr vw cv vv cv cle
        wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC
        cfv cM co vr cv clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi vr
        wal vr cv crp wcel vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC
        cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv
        clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi vr wal vr cv cr wcel
        cc0 vr cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC
        cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv
        clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi wi vr wal cc0 vr cv
        clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel
        vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a
        wi vv cn wral vz cn wral vw cn wrex wi vr cr wral vr cv cr wcel cc0 vr
        cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX
        wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr
        w3a wi vv cn wral vz cn wral vw cn wrex wi wi vr wal cC cc cX cxp wss
        cc0 vr cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC
        cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv
        clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi vr cr wral cC cM cca
        cfv wcel cC cc cX cxp wss cc0 vr cv clt wbr vw cv vz cv cle wbr vw cv
        vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv
        vv cv cC cfv cM co vr cv clt wbr w3a wi vv cn wral vz cn wral vw cn
        wrex wi vr cr wral wa heibor.4 cM cme wcel cC cM cca cfv wcel cC cc cX
        cxp wss cc0 vr cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz
        cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co
        vr cv clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi vr cr wral wa
        wb heibor.3 vr cM vw vz vv cC c1 cX cn heibor.2 1z nnuz iscau2 ax-mp
        mpbi pm3.27i cc0 vr cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr
        wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv
        cM co vr cv clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi vr cr
        df-ral mpbi vr cv crp wcel vw cv vz cv cle wbr vw cv vv cv cle wbr wa
        vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM
        co vr cv clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi vr cv cr
        wcel cc0 vr cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv
        cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr
        cv clt wbr w3a wi vv cn wral vz cn wral vw cn wrex wi wi vr vr cv crp
        wcel vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv
        cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a wi
        vv cn wral vz cn wral vw cn wrex wi vr cv cr wcel cc0 vr cv clt wbr wa
        vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv
        cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a wi vv
        cn wral vz cn wral vw cn wrex wi vr cv cr wcel cc0 vr cv clt wbr vw cv
        vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv
        cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a wi vv cn wral
        vz cn wral vw cn wrex wi wi vr cv crp wcel vr cv cr wcel cc0 vr cv clt
        wbr wa vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel
        vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a
        wi vv cn wral vz cn wral vw cn wrex vr cv elrp imbi1i vr cv cr wcel cc0
        vr cv clt wbr vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv
        cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt
        wbr w3a wi vv cn wral vz cn wral vw cn wrex impexp bitri albii mpbir vw
        cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC
        cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a wi vv cn
        wral vz cn wral vw cn wrex vr crp df-ral mpbir vt cv crp wcel vt cv c2
        cdiv co crp wcel vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC
        cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vr cv
        clt wbr w3a wi vv cn wral vz cn wral vw cn wrex vr crp wral vw cv vz cv
        cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX
        wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv
        cn wral vz cn wral vw cn wrex wi vt cv crp wcel c2 crp wcel vt cv c2
        cdiv co crp wcel c2 2re 2pos elrpii vt cv c2 rpdivcl mpan2 vw cv vz cv
        cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX
        wcel vz cv cC cfv vv cv cC cfv cM co vr cv clt wbr w3a wi vv cn wral vz
        cn wral vw cn wrex vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC
        cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv
        c2 cdiv co clt wbr w3a wi vv cn wral vz cn wral vw cn wrex vr vt cv c2
        cdiv co crp vr cv vt cv c2 cdiv co wceq vw cv vz cv cle wbr vw cv vv cv
        cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv
        cC cfv cM co vr cv clt wbr w3a wi vv cn wral vz cn wral vw cv vz cv cle
        wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz
        cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv cn wral
        vz cn wral vw cn vr cv vt cv c2 cdiv co wceq vw cv vz cv cle wbr vw cv
        vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv
        vv cv cC cfv cM co vr cv clt wbr w3a wi vw cv vz cv cle wbr vw cv vv cv
        cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv
        cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vz vv cn cn vr cv vt cv c2
        cdiv co wceq vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv
        cv cC cfv cM co vr cv clt wbr w3a vz cv cC cfv cX wcel vv cv cC cfv cX
        wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a vw cv
        vz cv cle wbr vw cv vv cv cle wbr wa vr cv vt cv c2 cdiv co wceq vz cv
        cC cfv vv cv cC cfv cM co vr cv clt wbr vz cv cC cfv vv cv cC cfv cM co
        vt cv c2 cdiv co clt wbr vz cv cC cfv cX wcel vv cv cC cfv cX wcel vr
        cv vt cv c2 cdiv co vz cv cC cfv vv cv cC cfv cM co clt breq2 3anbi3d
        imbi2d 2ralbidv rexbidv rcla4v syl mpi cY cX wcel vt cv crp wcel vw cv
        vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv
        cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi
        vv cn wral vz cn wral vw cn wrex vy cv cC cfv cY vt cv c2 cdiv co cM
        cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vu cv vz cv cle wbr vz
        cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cn wrex wi wi cY cX
        wcel vt cv crp wcel wa vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv
        cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt
        cv c2 cdiv co clt wbr w3a wi vv cn wral vz cn wral vy cv cC cfv cY vt
        cv c2 cdiv co cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn wral vu cv
        vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cn
        wrex wi vw cn cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv cC
        cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vy vx cv cuz cfv wrex vx cn
        wral vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv
        cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt
        wbr w3a wi vv cn wral vz cn wral vu cv vz cv cle wbr vz cv cC cfv cY cM
        co vt cv clt wbr wi vz cn wral vu cn wrex cY cX wcel vt cv crp wcel wa
        vw cv cn wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vy
        vx cv cuz cfv wrex vx cn wral vy cv cC cfv cY vt cv c2 cdiv co cM cbl
        cfv co wcel vy vw cv cuz cfv wrex vw cv vz cv cle wbr vw cv vv cv cle
        wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC
        cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv cn wral vz cn wral vu cv
        vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cn
        wrex wi vw cv cn wcel vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co
        wcel vy vx cv cuz cfv wrex vx cn wral vy cv cC cfv cY vt cv c2 cdiv co
        cM cbl cfv co wcel vy vw cv cuz cfv wrex wi cY cX wcel vt cv crp wcel
        wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vy vx cv cuz cfv
        wrex vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vy vw cv cuz
        cfv wrex vx vw cv cn vx cv vw cv wceq vy cv cC cfv cY vt cv c2 cdiv co
        cM cbl cfv co wcel vy vx cv cuz cfv vw cv cuz cfv vx cv vw cv cuz fveq2
        rexeq1d rcla4v adantl cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy
        cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vw cv vz cv cle wbr vw
        cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC
        cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv cn wral vz cn
        wral vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn
        wral vu cn wrex wi vy vw cv cuz cfv cY cX wcel vt cv crp wcel wa vw cv
        cn wcel wa vy cv vw cv cuz cfv wcel wa vy cv cC cfv cY vt cv c2 cdiv co
        cM cbl cfv co wcel vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC
        cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv
        c2 cdiv co clt wbr w3a wi vv cn wral vz cn wral vy cv vz cv cle wbr vz
        cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cv vz cv cle wbr vz
        cv cC cfv cY cM co vt cv clt wbr wi vz cn wral vu cn wrex cY cX wcel vt
        cv crp wcel wa vw cv cn wcel wa vy cv vw cv cuz cfv wcel wa vy cv cC
        cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vw cv vz cv cle wbr vw cv vv
        cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv
        cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv cn wral vz cn wral
        vy cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz cn wral
        wi cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv vw cv cuz cfv
        wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel wa vw cv vz
        cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX
        wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv
        cn wral vy cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz
        cn cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv vw cv cuz cfv
        wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel wa vz cv cn
        wcel wa vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel
        vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co
        clt wbr w3a wi vv cn wral vw cv vz cv cle wbr vw cv vy cv cle wbr wa vz
        cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM co
        vt cv c2 cdiv co clt wbr w3a wi vy cv vz cv cle wbr vz cv cC cfv cY cM
        co vt cv clt wbr wi cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv
        vw cv cuz cfv wcel wa vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv
        cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt
        cv c2 cdiv co clt wbr w3a wi vv cn wral vw cv vz cv cle wbr vw cv vy cv
        cle wbr wa vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv
        cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi wi vy cv cC cfv cY vt cv
        c2 cdiv co cM cbl cfv co wcel vz cv cn wcel vw cv cn wcel vy cv vw cv
        cuz cfv wcel vw cv vz cv cle wbr vw cv vv cv cle wbr wa vz cv cC cfv cX
        wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv
        co clt wbr w3a wi vv cn wral vw cv vz cv cle wbr vw cv vy cv cle wbr wa
        vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM
        co vt cv c2 cdiv co clt wbr w3a wi wi cY cX wcel vt cv crp wcel wa vw
        cv cn wcel vy cv vw cv cuz cfv wcel wa vy cv cn wcel vw cv vz cv cle
        wbr vw cv vv cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz
        cv cC cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv cn wral
        vw cv vz cv cle wbr vw cv vy cv cle wbr wa vz cv cC cfv cX wcel vy cv
        cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr
        w3a wi wi vw cv c1 cuz cfv wcel vy cv vw cv cuz cfv wcel wa vy cv c1
        cuz cfv wcel vw cv cn wcel vy cv vw cv cuz cfv wcel wa vy cv cn wcel vw
        cv c1 cuz cfv wcel vy cv vw cv cuz cfv wcel vy cv c1 cuz cfv wcel vw cv
        c1 cuz cfv wcel vw cv cuz cfv c1 cuz cfv vy cv c1 vw cv uzss sseld imp
        vw cv cn wcel vw cv c1 cuz cfv wcel vy cv vw cv cuz cfv wcel vw cv
        elnnuz anbi1i vy cv elnnuz 3imtr4i vw cv vz cv cle wbr vw cv vv cv cle
        wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC cfv vv cv cC
        cfv cM co vt cv c2 cdiv co clt wbr w3a wi vw cv vz cv cle wbr vw cv vy
        cv cle wbr wa vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy
        cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a wi vv vy cv cn vv cv vy cv
        wceq vw cv vz cv cle wbr vw cv vv cv cle wbr wa vw cv vz cv cle wbr vw
        cv vy cv cle wbr wa vz cv cC cfv cX wcel vv cv cC cfv cX wcel vz cv cC
        cfv vv cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a vz cv cC cfv cX
        wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv
        co clt wbr w3a vv cv vy cv wceq vw cv vv cv cle wbr vw cv vy cv cle wbr
        vw cv vz cv cle wbr vv cv vy cv vw cv cle breq2 anbi2d vv cv vy cv wceq
        vv cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vv cv cC cfv cM
        co vt cv c2 cdiv co clt wbr vz cv cC cfv vy cv cC cfv cM co vt cv c2
        cdiv co clt wbr vz cv cC cfv cX wcel vv cv vy cv wceq vv cv cC cfv vy
        cv cC cfv cX vv cv vy cv cC fveq2 eleq1d vv cv vy cv wceq vz cv cC cfv
        vv cv cC cfv cM co vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt
        vv cv vy cv wceq vv cv cC cfv vy cv cC cfv vz cv cC cfv cM vv cv vy cv
        cC fveq2 opreq2d breq1d 3anbi23d imbi12d rcla4v syl adantll ad2antrr cY
        cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv vw cv cuz cfv wcel wa
        vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel wa vz cv cn wcel wa
        vy cv vz cv cle wbr vw cv vz cv cle wbr vw cv vy cv cle wbr wa vz cv cC
        cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM co vt cv
        c2 cdiv co clt wbr w3a vz cv cC cfv cY cM co vt cv clt wbr cY cX wcel
        vt cv crp wcel wa vw cv cn wcel wa vy cv vw cv cuz cfv wcel wa vz cv cn
        wcel vy cv vz cv cle wbr vw cv vz cv cle wbr vw cv vy cv cle wbr wa wi
        vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vw cv cn wcel vy cv
        vw cv cuz cfv wcel vz cv cn wcel vy cv vz cv cle wbr vw cv vz cv cle
        wbr vw cv vy cv cle wbr wa wi cY cX wcel vt cv crp wcel wa vw cv cn
        wcel vy cv vw cv cuz cfv wcel wa vz cv cn wcel wa vy cv vz cv cle wbr
        vw cv vz cv cle wbr vw cv vy cv cle wbr vw cv cn wcel vy cv vw cv cuz
        cfv wcel wa vz cv cn wcel wa vw cv vy cv cle wbr vy cv vz cv cle wbr vw
        cv vz cv cle wbr wi vy cv vw cv cuz cfv wcel vw cv vy cv cle wbr vw cv
        cn wcel vz cv cn wcel vw cv vy cv eluzle ad2antlr vw cv cn wcel vy cv
        vw cv cuz cfv wcel vz cv cn wcel vw cv vy cv cle wbr vy cv vz cv cle
        wbr vw cv vz cv cle wbr wi wi vw cv cr wcel vy cv cr wcel vz cv cr wcel
        vw cv vy cv cle wbr vy cv vz cv cle wbr vw cv vz cv cle wbr wi wi vw cv
        cn wcel vy cv vw cv cuz cfv wcel vz cv cn wcel vw cv cr wcel vy cv cr
        wcel vz cv cr wcel w3a vw cv vy cv cle wbr vy cv vz cv cle wbr vw cv vz
        cv cle wbr vw cv vy cv vz cv letr exp3a vw cv nnre vy cv vw cv cuz cfv
        wcel vy cv cz wcel vy cv cr wcel vw cv vy cv eluzelz vy cv zre syl vz
        cv nnre syl3an 3expa mpd vy cv vw cv cuz cfv wcel vw cv vy cv cle wbr
        vw cv cn wcel vz cv cn wcel vw cv vy cv eluzle ad2antlr jctird adantlll
        adantlr cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv vw cv cuz
        cfv wcel wa vy cv cC cfv cX wcel cY vy cv cC cfv cM co vt cv c2 cdiv co
        clt wbr wa wa vz cv cn wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel
        vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr w3a vz cv cC
        cfv cY cM co vt cv clt wbr wi cY cX wcel vt cv crp wcel wa vw cv cn
        wcel wa vy cv vw cv cuz cfv wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM
        cbl cfv co wcel wa cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv
        cC cfv cX wcel cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr wa vz cv
        cn wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC
        cfv cM co vt cv c2 cdiv co clt wbr w3a vz cv cC cfv cY cM co vt cv clt
        wbr wi vy cv vw cv cuz cfv wcel cY cX wcel vt cv crp wcel wa vy cv cC
        cfv cX wcel cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr wa vz cv cn
        wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC
        cfv cM co vt cv c2 cdiv co clt wbr w3a vz cv cC cfv cY cM co vt cv clt
        wbr wi vw cv cn wcel cY cX wcel vt cv crp wcel wa vy cv cC cfv cX wcel
        cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr wa wa vz cv cC cfv cX
        wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv
        co clt wbr w3a vz cv cC cfv cY cM co vt cv clt wbr wi vz cv cn wcel cY
        cX wcel vt cv crp wcel wa cY vy cv cC cfv cM co vt cv c2 cdiv co clt
        wbr vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv
        cM co vt cv c2 cdiv co clt wbr w3a vz cv cC cfv cY cM co vt cv clt wbr
        wi vy cv cC cfv cX wcel cY cX wcel vt cv crp wcel wa cY vy cv cC cfv cM
        co vt cv c2 cdiv co clt wbr wa vz cv cC cfv cX wcel vy cv cC cfv cX
        wcel vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv cC
        cfv cY cM co vt cv clt wbr cY cX wcel vt cv crp wcel wa cY vy cv cC cfv
        cM co vt cv c2 cdiv co clt wbr wa vz cv cC cfv cX wcel vy cv cC cfv cX
        wcel vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv cC
        cfv cY cM co vt cv clt wbr wi cY vy cv cC cfv cM co vt cv c2 cdiv co
        clt wbr vt cv crp wcel cY cX wcel vz cv cC cfv cX wcel vy cv cC cfv cX
        wcel wa vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv
        cC cfv cY cM co vt cv clt wbr wi wi cY vy cv cC cfv cM co vt cv c2 cdiv
        co clt wbr vt cv crp wcel wa cY cX wcel vz cv cC cfv cX wcel vy cv cC
        cfv cX wcel wa vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr
        vz cv cC cfv cY cM co vt cv clt wbr wi cY vy cv cC cfv cM co vt cv c2
        cdiv co clt wbr vt cv crp wcel wa cY cX wcel vz cv cC cfv cX wcel vy cv
        cC cfv cX wcel wa wa wa vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv
        cM co cY vy cv cC cfv cM co caddc co cle wbr vz cv cC cfv vy cv cC cfv
        cM co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM co vt cv clt wbr wi
        cY cX wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel wa wa vz cv cC cfv
        cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co
        cle wbr cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vt cv crp wcel
        wa cY cX wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv cY
        cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co
        cle wbr vz cv cC cfv cX wcel cY cX wcel vy cv cC cfv cX wcel vz cv cC
        cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co
        caddc co cle wbr vz cv cC cfv cX wcel cY cX wcel vy cv cC cfv cX wcel
        vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv
        cM co caddc co cle wbr cM cme wcel vz cv cC cfv cX wcel cY cX wcel vy
        cv cC cfv cX wcel w3a vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv
        cM co cY vy cv cC cfv cM co caddc co cle wbr heibor.3 vz cv cC cfv cY
        vy cv cC cfv cM cX heibor.2 mettri3 mpan 3expa ancom1s anasss adantl cY
        vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vt cv crp wcel wa vz cv cC
        cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv
        cC cfv cM co cr wcel w3a vz cv cC cfv cY cM co vz cv cC cfv vy cv cC
        cfv cM co cY vy cv cC cfv cM co caddc co cle wbr vz cv cC cfv vy cv cC
        cfv cM co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM co vt cv clt wbr
        wi wi cY cX wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel wa wa vz cv
        cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy
        cv cC cfv cM co cr wcel w3a vt cv crp wcel cY vy cv cC cfv cM co vt cv
        c2 cdiv co clt wbr vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM
        co cY vy cv cC cfv cM co caddc co cle wbr vz cv cC cfv vy cv cC cfv cM
        co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM co vt cv clt wbr wi wi
        vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel
        cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa cY vy cv cC cfv cM
        co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM co vz cv cC cfv vy cv cC
        cfv cM co cY vy cv cC cfv cM co caddc co cle wbr vz cv cC cfv vy cv cC
        cfv cM co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM co vt cv clt wbr
        wi wi vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa vz cv cC cfv
        cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co
        cle wbr cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv cC cfv vy
        cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM co vt cv
        clt wbr wi vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM
        co cr wcel cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa vz cv cC
        cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co
        caddc co cle wbr cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv
        cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv cC cfv cY cM
        co vt cv clt wbr vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC
        cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa
        vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv
        cM co caddc co cle wbr wa cY vy cv cC cfv cM co vt cv c2 cdiv co clt
        wbr vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr wa vz cv
        cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co vt cv c2 cdiv
        co vt cv c2 cdiv co caddc co clt wbr vz cv cC cfv cY cM co vt cv clt
        wbr vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa vz cv cC cfv
        cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co
        cle wbr wa vz cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr cY
        vy cv cC cfv cM co vt cv c2 cdiv co clt wbr vz cv cC cfv vy cv cC cfv
        cM co cY vy cv cC cfv cM co caddc co vt cv c2 cdiv co vt cv c2 cdiv co
        caddc co clt wbr vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC
        cfv cM co cr wcel vt cv c2 cdiv co cr wcel vt cv c2 cdiv co cr wcel vz
        cv cC cfv vy cv cC cfv cM co vt cv c2 cdiv co clt wbr cY vy cv cC cfv
        cM co vt cv c2 cdiv co clt wbr wa vz cv cC cfv vy cv cC cfv cM co cY vy
        cv cC cfv cM co caddc co vt cv c2 cdiv co vt cv c2 cdiv co caddc co clt
        wbr wi vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa vz cv cC cfv
        cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co
        cle wbr wa vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co vt cv
        c2 cdiv co vt cv c2 cdiv co lt2add vz cv cC cfv cY cM co cr wcel vz cv
        cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel w3a vz
        cv cC cfv vy cv cC cfv cM co cr wcel vt cv crp wcel vz cv cC cfv cY cM
        co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co cle
        wbr vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel cY vy cv cC cfv cM co cr wcel 3simp2 ad2antrr vz cv cC cfv cY cM
        co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM
        co cr wcel w3a cY vy cv cC cfv cM co cr wcel vt cv crp wcel vz cv cC
        cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co
        caddc co cle wbr vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC
        cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel 3simp3 ad2antrr vt cv
        crp wcel vt cv c2 cdiv co cr wcel vz cv cC cfv cY cM co cr wcel vz cv
        cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel w3a vz
        cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM
        co caddc co cle wbr vt cv crp wcel vt cv c2 cdiv co crp wcel vt cv c2
        cdiv co cr wcel vt cv crp wcel c2 crp wcel vt cv c2 cdiv co crp wcel c2
        2re 2pos elrpii vt cv c2 rpdivcl mpan2 vt cv c2 cdiv co rpre syl
        ad2antlr vt cv crp wcel vt cv c2 cdiv co cr wcel vz cv cC cfv cY cM co
        cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co
        cr wcel w3a vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy
        cv cC cfv cM co caddc co cle wbr vt cv crp wcel vt cv c2 cdiv co crp
        wcel vt cv c2 cdiv co cr wcel vt cv crp wcel c2 crp wcel vt cv c2 cdiv
        co crp wcel c2 2re 2pos elrpii vt cv c2 rpdivcl mpan2 vt cv c2 cdiv co
        rpre syl ad2antlr syl2anc ancomsd vz cv cC cfv cY cM co cr wcel vz cv
        cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel w3a vt
        cv crp wcel wa vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY
        vy cv cC cfv cM co caddc co cle wbr vz cv cC cfv vy cv cC cfv cM co cY
        vy cv cC cfv cM co caddc co vt cv c2 cdiv co vt cv c2 cdiv co caddc co
        clt wbr vz cv cC cfv cY cM co vt cv clt wbr vz cv cC cfv cY cM co cr
        wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr
        wcel w3a vt cv crp wcel wa vz cv cC cfv cY cM co vz cv cC cfv vy cv cC
        cfv cM co cY vy cv cC cfv cM co caddc co cle wbr vz cv cC cfv vy cv cC
        cfv cM co cY vy cv cC cfv cM co caddc co vt cv c2 cdiv co vt cv c2 cdiv
        co caddc co clt wbr wa vz cv cC cfv cY cM co vt cv c2 cdiv co vt cv c2
        cdiv co caddc co clt wbr vz cv cC cfv cY cM co vt cv clt wbr vz cv cC
        cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM
        co caddc co cr wcel vt cv c2 cdiv co vt cv c2 cdiv co caddc co cr wcel
        vz cv cC cfv cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv
        cM co caddc co cle wbr vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv
        cM co caddc co vt cv c2 cdiv co vt cv c2 cdiv co caddc co clt wbr wa vz
        cv cC cfv cY cM co vt cv c2 cdiv co vt cv c2 cdiv co caddc co clt wbr
        wi vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel cY vy cv cC cfv cM co cr wcel w3a vt cv crp wcel wa vz cv cC cfv
        cY cM co vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co caddc co
        vt cv c2 cdiv co vt cv c2 cdiv co caddc co lelttr vz cv cC cfv cY cM co
        cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co
        cr wcel w3a vz cv cC cfv cY cM co cr wcel vt cv crp wcel vz cv cC cfv
        cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC
        cfv cM co cr wcel 3simp1 adantr vz cv cC cfv vy cv cC cfv cM co cr wcel
        cY vy cv cC cfv cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cY vy cv
        cC cfv cM co caddc co cr wcel vz cv cC cfv cY cM co cr wcel vz cv cC
        cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel w3a vt cv
        crp wcel wa vz cv cC cfv vy cv cC cfv cM co cY vy cv cC cfv cM co
        readdcl vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co
        cr wcel cY vy cv cC cfv cM co cr wcel w3a vz cv cC cfv vy cv cC cfv cM
        co cr wcel vt cv crp wcel vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy
        cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel 3simp2 adantr vz
        cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY
        vy cv cC cfv cM co cr wcel w3a cY vy cv cC cfv cM co cr wcel vt cv crp
        wcel vz cv cC cfv cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel cY vy cv cC cfv cM co cr wcel 3simp3 adantr sylanc vt cv crp wcel
        vt cv c2 cdiv co vt cv c2 cdiv co caddc co cr wcel vz cv cC cfv cY cM
        co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM
        co cr wcel w3a vt cv crp wcel vt cv c2 cdiv co crp wcel vt cv c2 cdiv
        co cr wcel vt cv c2 cdiv co vt cv c2 cdiv co caddc co cr wcel vt cv crp
        wcel c2 crp wcel vt cv c2 cdiv co crp wcel c2 2re 2pos elrpii vt cv c2
        rpdivcl mpan2 vt cv c2 cdiv co rpre vt cv c2 cdiv co cr wcel vt cv c2
        cdiv co vt cv c2 cdiv co caddc co cr wcel vt cv c2 cdiv co vt cv c2
        cdiv co readdcl anidms 3syl adantl syl3anc vt cv crp wcel vz cv cC cfv
        cY cM co vt cv c2 cdiv co vt cv c2 cdiv co caddc co clt wbr vz cv cC
        cfv cY cM co vt cv clt wbr wb vz cv cC cfv cY cM co cr wcel vz cv cC
        cfv vy cv cC cfv cM co cr wcel cY vy cv cC cfv cM co cr wcel w3a vt cv
        crp wcel vt cv c2 cdiv co vt cv c2 cdiv co caddc co vt cv vz cv cC cfv
        cY cM co clt vt cv crp wcel vt cv cr wcel vt cv cc wcel vt cv c2 cdiv
        co vt cv c2 cdiv co caddc co vt cv wceq vt cv rpre vt cv recn vt cv
        2halves 3syl breq2d adantl sylibd expdimp syld exp4b com23 imp ancom31s
        cY cX wcel vz cv cC cfv cX wcel vy cv cC cfv cX wcel wa wa vz cv cC cfv
        cY cM co cr wcel vz cv cC cfv vy cv cC cfv cM co cr wcel cY vy cv cC
        cfv cM co cr wcel cY cX wcel vz cv cC cfv cX wcel vz cv cC cfv cY cM co
        cr wcel vy cv cC cfv cX wcel vz cv cC cfv cX wcel cY cX wcel vz cv cC
        cfv cY cM co cr wcel cM cme wcel vz cv cC cfv cX wcel cY cX wcel vz cv
        cC cfv cY cM co cr wcel heibor.3 vz cv cC cfv cY cM cX heibor.2 metcl
        mp3an1 ancoms adantrr vz cv cC cfv cX wcel vy cv cC cfv cX wcel wa vz
        cv cC cfv vy cv cC cfv cM co cr wcel cY cX wcel cM cme wcel vz cv cC
        cfv cX wcel vy cv cC cfv cX wcel vz cv cC cfv vy cv cC cfv cM co cr
        wcel heibor.3 vz cv cC cfv vy cv cC cfv cM cX heibor.2 metcl mp3an1
        adantl cY cX wcel vy cv cC cfv cX wcel cY vy cv cC cfv cM co cr wcel vz
        cv cC cfv cX wcel cM cme wcel cY cX wcel vy cv cC cfv cX wcel cY vy cv
        cC cfv cM co cr wcel heibor.3 cY vy cv cC cfv cM cX heibor.2 metcl
        mp3an1 adantrl 3jca sylan2 mpd expr ancom31s exp3a 3impd adantrl adantr
        adantllr adantllr cY cX wcel vt cv crp wcel wa vw cv cn wcel wa vy cv
        vw cv cuz cfv wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co
        wcel vy cv cC cfv cX wcel cY vy cv cC cfv cM co vt cv c2 cdiv co clt
        wbr wa cY cX wcel vt cv crp wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM
        cbl cfv co wcel vy cv cC cfv cX wcel cY vy cv cC cfv cM co vt cv c2
        cdiv co clt wbr wa wi vw cv cn wcel vy cv vw cv cuz cfv wcel cY cX wcel
        vt cv crp wcel wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel
        vy cv cC cfv cX wcel cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr wa
        cM cme wcel cY cX wcel wa vt cv c2 cdiv co cr wcel cc0 vt cv c2 cdiv co
        clt wbr wa vy cv cC cfv cY vt cv c2 cdiv co cM cbl cfv co wcel vy cv cC
        cfv cX wcel cY vy cv cC cfv cM co vt cv c2 cdiv co clt wbr wa wb cY cX
        wcel vt cv crp wcel vy cv cC cfv cM cY vt cv c2 cdiv co cX heibor.2
        elbl cY cX wcel cM cme wcel heibor.3 jctl vt cv crp wcel vt cv c2 cdiv
        co crp wcel vt cv c2 cdiv co cr wcel cc0 vt cv c2 cdiv co clt wbr wa vt
        cv crp wcel c2 crp wcel vt cv c2 cdiv co crp wcel c2 2re 2pos elrpii vt
        cv c2 rpdivcl mpan2 vt cv c2 cdiv co elrp sylib syl2an biimpd ad2antrr
        imdistani sylan imim12d syld r19.20dva ex vw cv cn wcel vy cv vw cv cuz
        cfv wcel vy cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz
        cn wral vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr wi vz
        cn wral vu cn wrex wi cY cX wcel vt cv crp wcel wa vw cv cn wcel vy cv
        vw cv cuz cfv wcel wa vy cv cn wcel vy cv vz cv cle wbr vz cv cC cfv cY
        cM co vt cv clt wbr wi vz cn wral vu cv vz cv cle wbr vz cv cC cfv cY
        cM co vt cv clt wbr wi vz cn wral vu cn wrex wi vw cv c1 cuz cfv wcel
        vy cv vw cv cuz cfv wcel wa vy cv c1 cuz cfv wcel vw cv cn wcel vy cv
        vw cv cuz cfv wcel wa vy cv cn wcel vw cv c1 cuz cfv wcel vy cv vw cv
        cuz cfv wcel vy cv c1 cuz cfv wcel vw cv c1 cuz cfv wcel vw cv cuz cfv
        c1 cuz cfv vy cv c1 vw cv uzss sseld imp vw cv cn wcel vw cv c1 cuz cfv
        wcel vy cv vw cv cuz cfv wcel vw cv elnnuz anbi1i vy cv elnnuz 3imtr4i
        vy cv cn wcel vy cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr
        wi vz cn wral vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr
        wi vz cn wral vu cn wrex vu cv vz cv cle wbr vz cv cC cfv cY cM co vt
        cv clt wbr wi vz cn wral vy cv vz cv cle wbr vz cv cC cfv cY cM co vt
        cv clt wbr wi vz cn wral vu vy cv cn vu cv vy cv wceq vu cv vz cv cle
        wbr vz cv cC cfv cY cM co vt cv clt wbr wi vy cv vz cv cle wbr vz cv cC
        cfv cY cM co vt cv clt wbr wi vz cn vu cv vy cv wceq vu cv vz cv cle
        wbr vy cv vz cv cle wbr vz cv cC cfv cY cM co vt cv clt wbr vu cv vy cv
        vz cv cle breq1 imbi1d ralbidv rcla4ev ex syl adantll syl6d r19.23adva
        syld com23 r19.23adva ex mpdi syldd com23 imp vt cv elrp syl5ibr exp3a
        r19.21aiv cF cn cima cint cX cY cF cn cima cint c1 cF cfv cX c1 cF cfv
        cF cn cima wcel cF cn cima cint c1 cF cfv wss cF wfun c1 cF cdm wcel c1
        cF cfv cF cn cima wcel cF cn wfn cF wfun cC cU vn cF cJ cM cX vs vd vl
        heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem4 cn cF fnfun ax-mp c1 cn cF cdm 1nn cF cn wfn cF cdm cn wceq
        cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4
        heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fndm ax-mp eleqtrri cF wfun
        c1 cF cdm wcel wa c1 cn wcel c1 cF cfv cF cn cima wcel 1nn cn c1 cF
        funfvima mpi mp2an c1 cF cfv cF cn cima intss1 ax-mp c1 cF cfv cC c1
        cuz cfv cima cJ ccl cfv cfv cX c1 cn wcel c1 cF cfv cC c1 cuz cfv cima
        cJ ccl cfv cfv wceq 1nn cC cU vn cF cJ cM c1 cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem2 ax-mp
        cJ ctop wcel cC c1 cuz cfv cima cX wss cC c1 cuz cfv cima cJ ccl cfv
        cfv cX wss cM cme wcel cJ ctop wcel heibor.3 cM cJ heibor.1 opntop
        ax-mp cC c1 cuz cfv cima cC crn cX cC c1 cuz cfv imassrn cC crn cc cX
        cxp crn cX cC cc cX cxp wss cC crn cc cX cxp crn wss cM cme wcel cC cM
        cca cfv wcel cC cc cX cxp wss heibor.3 heibor.4 cM cC cX heibor.2
        caufss mp2an cC cc cX cxp rnss ax-mp cc c0 wne cc cX cxp crn cX wceq
        cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp cc cX rnxp ax-mp sseqtri
        sstri cC c1 cuz cfv cima cJ cX cJ cuni cX cM cme wcel cJ cuni cX wceq
        heibor.3 cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi clsss3 mp2an
        eqsstri sstri sseli vx vy cC cU vn cF cJ cM cX cY vs vr vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heibor.8
        heiborlem15 sylanc cM cme wcel cY cX wcel cn cX cC wf cC cY cM clm cfv
        wbr cc0 vt cv clt wbr vu cv vz cv cle wbr vz cv cC cfv cY cM co vt cv
        clt wbr wi vz cn wral vu cn wrex wi vt cr wral wb cY cF cn cima cint
        wcel vt cM cY vu vz cC c1 cX cn heibor.2 1z nnuz lmbrf2 cM cme wcel cY
        cF cn cima cint wcel heibor.3 a1i cF cn cima cint cX cY cF cn cima cint
        c1 cF cfv cX c1 cF cfv cF cn cima wcel cF cn cima cint c1 cF cfv wss cF
        wfun c1 cF cdm wcel c1 cF cfv cF cn cima wcel cF cn wfn cF wfun cC cU
        vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5
        heibor.6 heibor.7 heiborlem4 cn cF fnfun ax-mp c1 cn cF cdm 1nn cF cn
        wfn cF cdm cn wceq cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2
        heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fndm
        ax-mp eleqtrri cF wfun c1 cF cdm wcel wa c1 cn wcel c1 cF cfv cF cn
        cima wcel 1nn cn c1 cF funfvima mpi mp2an c1 cF cfv cF cn cima intss1
        ax-mp c1 cF cfv cC c1 cuz cfv cima cJ ccl cfv cfv cX c1 cn wcel c1 cF
        cfv cC c1 cuz cfv cima cJ ccl cfv cfv wceq 1nn cC cU vn cF cJ cM c1 cX
        vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7
        heiborlem2 ax-mp cJ ctop wcel cC c1 cuz cfv cima cX wss cC c1 cuz cfv
        cima cJ ccl cfv cfv cX wss cM cme wcel cJ ctop wcel heibor.3 cM cJ
        heibor.1 opntop ax-mp cC c1 cuz cfv cima cC crn cX cC c1 cuz cfv
        imassrn cC crn cc cX cxp crn cX cC cc cX cxp wss cC crn cc cX cxp crn
        wss cM cme wcel cC cM cca cfv wcel cC cc cX cxp wss heibor.3 heibor.4
        cM cC cX heibor.2 caufss mp2an cC cc cX cxp rnss ax-mp cc c0 wne cc cX
        cxp crn cX wceq cc0 cc wcel cc c0 wne 0cn cc cc0 ne0i ax-mp cc cX rnxp
        ax-mp sseqtri sstri cC c1 cuz cfv cima cJ cX cJ cuni cX cM cme wcel cJ
        cuni cX wceq heibor.3 cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi
        clsss3 mp2an eqsstri sstri sseli cn cX cC wf cY cF cn cima cint wcel
        heibor.8 a1i syl3anc mpbird $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Combine previous lemmas to show that the Cauchy
         sequence ` C ` converges. $)
      heiborlem17 $p |- E. x e. X C ( ~~>m ` M ) x $=
        vx cv cF cn cima cint wcel vx wex cC vx cv cM clm cfv wbr vx cX wrex cF
        cn cima cint c0 wne vx cv cF cn cima cint wcel vx wex cC cU vn cF cJ cM
        cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heibor.8 heiborlem14 vx cF cn cima cint n0 mpbi vx cv cF cn
        cima cint wcel vx wex vx cv cF cn cima cint wcel vx cX wrex cC vx cv cM
        clm cfv wbr vx cX wrex vx cv cF cn cima cint wcel vx wex vx cv cX wcel
        vx cv cF cn cima cint wcel wa vx wex vx cv cF cn cima cint wcel vx cX
        wrex vx cv cF cn cima cint wcel vx cv cX wcel vx cv cF cn cima cint
        wcel wa vx vx cv cF cn cima cint wcel vx cv cX wcel cF cn cima cint cX
        vx cv cF cn cima cint c1 cF cfv cX c1 cF cfv cF cn cima wcel cF cn cima
        cint c1 cF cfv wss c1 cn wcel c1 cF cfv cF cn cima wcel 1nn cF wfun c1
        cF cdm wcel c1 cn wcel c1 cF cfv cF cn cima wcel wi cF cn wfn cF wfun
        cC cU vn cF cJ cM cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4
        heibor.5 heibor.6 heibor.7 heiborlem4 cn cF fnfun ax-mp c1 cn cF cdm
        1nn cF cn wfn cF cdm cn wceq cC cU vn cF cJ cM cX vs vd vl heibor.1
        heibor.2 heibor.3 heibor.4 heibor.5 heibor.6 heibor.7 heiborlem4 cn cF
        fndm ax-mp eleqtrri cn c1 cF funfvima mp2an ax-mp c1 cF cfv cF cn cima
        intss1 ax-mp c1 cF cfv cC c1 cuz cfv cima cJ ccl cfv cfv cX c1 cn wcel
        c1 cF cfv cC c1 cuz cfv cima cJ ccl cfv cfv wceq 1nn cC cU vn cF cJ cM
        c1 cX vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5 heibor.6
        heibor.7 heiborlem2 ax-mp cJ ctop wcel cC c1 cuz cfv cima cX wss cC c1
        cuz cfv cima cJ ccl cfv cfv cX wss cM cme wcel cJ ctop wcel heibor.3 cM
        cJ heibor.1 opntop ax-mp cC c1 cuz cfv cima cC crn cX cC c1 cuz cfv
        imassrn cn cX cC wf cC crn cX wss heibor.8 cn cX cC frn ax-mp sstri cC
        c1 cuz cfv cima cJ cX cJ cuni cX cM cme wcel cJ cuni cX wceq heibor.3
        cM cJ cX heibor.2 heibor.1 uniopn2 ax-mp eqcomi clsss3 mp2an eqsstri
        sstri sseli ancri 19.22i vx cv cF cn cima cint wcel vx cX df-rex sylibr
        vx cv cF cn cima cint wcel cC vx cv cM clm cfv wbr vx cX cC cU vn cF cJ
        cM cX vx cv vs vd vl heibor.1 heibor.2 heibor.3 heibor.4 heibor.5
        heibor.6 heibor.7 heibor.8 heiborlem16 r19.22si syl ax-mp $.
        $( [2-Sep-2009] $)
    $}

    $( Lemma for ~ heibor . Apply the deduction theorem. $)
    heiborlem18 $p |- ( ( ( M e. Met /\ J e. Comp ) /\ ( C e. ( Cau ` M ) /\
                  C : NN --> X ) ) -> E. x e. X C ( ~~>m ` M ) x ) $=
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC vx
      cv cM clm cfv wbr vx cM cdm cdm wrex cC vx cv cM clm cfv wbr vx cX wrex
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC vx
      cv cM clm cfv wbr vx cM cdm cdm wrex cC vx cv cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif clm cfv wbr vx cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm wrex cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif vx cv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif clm cfv wbr vx cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm wrex cM cC c0 csn c0 csn cxp cc0 csn cxp cn c0
      csn cxp cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cC vx cv cM clm cfv wbr cC
      vx cv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif clm cfv wbr vx cM cdm cdm cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif cdm cdm cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cM cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      dmeq dmeqd cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM clm cfv cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif clm cfv wceq cC vx cv cM clm cfv wbr cC vx cv cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif clm cfv wbr wb cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif clm
      fveq2 cC vx cv cM clm cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif clm cfv breq syl
      rexeq12d cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif wceq cC vx cv cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      clm cfv wbr cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif vx cv cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif clm cfv
      wbr vx cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif vx cv cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif clm cfv breq1 rexbidv vx cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif vn cv
      cn wcel vs cv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm vn cv vl cv cn wcel vd
      cv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC
      cn c0 csn cxp cif vl cv cuz cfv cima cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn
      cfv ccl cfv cfv wceq wa vl vd copab cfv cdif wceq wa vn vs copab vl vl cv
      cn wcel vd cv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif vl cv cuz cfv cima cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif copn cfv ccl cfv cfv wceq wa vl vd copab cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      copn cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cdm cdm vd vs vn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv eqid cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm eqid cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif wf wa wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme
      wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn
      cfv ccomp wcel wa cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa wa cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cC cn c0 csn cxp cif wf wa wa c0 csn c0 csn cxp cc0 csn cxp cme
      wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel wa cn c0 csn cxp
      c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn
      cxp cdm cdm cn c0 csn cxp wf wa wa cM cC c0 csn c0 csn cxp cc0 csn cxp cn
      c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn cfv ccomp wcel wa cn c0 csn cxp cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa
      wa cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cme wcel cJ ccomp wcel wa cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn
      cfv ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa cC cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf wa cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cme wcel cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cme wcel cJ ccomp wcel cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      copn cfv ccomp wcel cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme eleq1 cM cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif wceq cJ cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv
      ccomp cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM copn cfv cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv cJ cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn fveq2
      heibor.1 syl5eq eleq1d anbi12d cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cC
      cM cca cfv wcel cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cX cC wf
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf cM cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif wceq cM cca cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv cC cM cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cca fveq2 eleq2d cM cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif wceq cX cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm wceq cn cX cC wf cn cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wb cM cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif wceq cM cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cX cM cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif wceq cM cdm cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm
      cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif dmeq dmeqd heibor.2 syl5eq cX cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif cdm cdm cn cC feq3 syl anbi12d anbi12d cC cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif wceq cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cC wf wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif wf wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn cfv ccomp wcel wa cC cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wceq cC cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf cn cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf cC cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cC cn c0 csn cxp cif feq1 anbi12d anbi2d c0 csn c0 csn cxp cc0
      csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp
      cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel wa cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv
      ccomp wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn
      c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa cn c0 csn cxp
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cn c0 csn cxp wf wa c0 csn c0 csn cxp cc0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv
      ccomp wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel c0 csn c0 csn
      cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme eleq1 c0 csn c0 csn cxp
      cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn
      cxp copn cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp c0 csn c0 csn
      cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn fveq2 eleq1d anbi12d
      c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cn c0
      csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0 csn cxp cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm
      cdm cn c0 csn cxp wf cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn
      cxp wf c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      c0 csn c0 csn cxp cc0 csn cxp cca cfv cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca
      cfv cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cca fveq2 eleq2d c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cdm cdm cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm wceq cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn
      cxp wf cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wb c0
      csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn
      c0 csn cxp cc0 csn cxp cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm c0 csn c0
      csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif dmeq dmeqd c0 csn c0 csn
      cxp cc0 csn cxp cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn cn c0
      csn cxp feq3 syl anbi12d anbi12d cn c0 csn cxp cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wceq cn c0
      csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cn c0 csn cxp wf wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif wf wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn cfv ccomp wcel wa cn c0 csn cxp cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wceq cn c0 csn
      cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm
      cdm cn c0 csn cxp wf cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif wf cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca
      cfv eleq1 cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif feq1 anbi12d anbi2d c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn
      c0 csn cxp cc0 csn cxp copn cfv ccomp wcel wa cn c0 csn cxp c0 csn c0 csn
      cxp cc0 csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn
      c0 csn cxp wf wa c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp
      cc0 csn cxp copn cfv ccomp wcel vx vy vz c0 csn c0 csn cxp cc0 csn cxp c0
      csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn cxp cc0 csn cxp wf cc0
      csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp cc0 csn cxp wf c0 csn
      c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr wss 0re
      cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn
      cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn cxp
      cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv c0 csn wcel vy cv c0
      csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv
      vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq
      wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv cop c0 csn
      c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn
      opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv
      cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0
      csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc
      co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr
      cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn
      wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0 caddc co cle vx
      cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv vy cv cc0 cc
      0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0 csn wcel vz cv c0
      csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vy cv c0
      csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv c0 csn wcel vz
      cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ctop cfn cin wcel c0 csn c0 csn cxp cc0 csn cxp
      copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop cfn cin
      wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop wcel c0 csn c0 csn cxp
      cc0 csn cxp copn cfv cfn wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop
      cfn elin c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn
      cxp copn cfv ctop wcel vx vy vz c0 csn c0 csn cxp cc0 csn cxp c0 csn p0ex
      c0 csn c0 csn cxp cc0 csn c0 csn c0 csn cxp cc0 csn cxp wf cc0 csn cr wss
      c0 csn c0 csn cxp cr c0 csn c0 csn cxp cc0 csn cxp wf c0 csn c0 csn cxp
      cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr
      snssi ax-mp c0 csn c0 csn cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn cxp
      fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv c0 csn wcel vy cv c0 csn
      wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy
      cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv
      c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp
      cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop
      c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv
      cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv cop c0 csn c0
      csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn
      opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv
      cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0
      csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc
      co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr
      cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn
      wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0 caddc co cle vx
      cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv vy cv cc0 cc
      0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0 csn wcel vz cv c0
      csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vy cv c0
      csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv c0 csn wcel vz
      cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn c0 csn
      cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0 csn cxp
      cc0 csn cxp copn cfv eqid opntop ax-mp c0 csn cpw cfn wcel c0 csn c0 csn
      cxp cc0 csn cxp copn cfv c0 csn cpw wss c0 csn c0 csn cxp cc0 csn cxp
      copn cfv cfn wcel c0 csn cfn wcel c0 csn cpw cfn wcel c0 snfi c0 csn pwfi
      mpbi c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp
      copn cfv c0 csn cpw wss vx vy vz c0 csn c0 csn cxp cc0 csn cxp c0 csn
      p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn cxp cc0 csn cxp wf cc0 csn
      cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp cc0 csn cxp wf c0 csn c0
      csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0
      cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn cxp
      fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv c0 csn wcel vy cv c0 csn
      wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy
      cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv
      c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp
      cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop
      c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv
      cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv cop c0 csn c0
      csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn
      opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv
      cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0
      csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc
      co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr
      cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn
      wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0 caddc co cle vx
      cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv vy cv cc0 cc
      0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0 csn wcel vz cv c0
      csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vy cv c0
      csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv c0 csn wcel vz
      cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn c0 csn
      cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn cxp
      cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz c0
      csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opnfss ax-mp c0 csn cpw c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ssfi mp2an mpbir2an c0 csn c0 csn cxp cc0 csn
      cxp copn cfv fintopcomp ax-mp pm3.2i cn c0 csn cxp c0 csn c0 csn cxp cc0
      csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn
      cxp wf cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk
      cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx crp c0 csn
      c0 csn cxp cc0 csn cxp cme wcel cn c0 csn cn c0 csn cxp wf cn c0 csn cxp
      c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral wb vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti cn c0
      0ex fconst vx c0 csn c0 csn cxp cc0 csn cxp vj vk cn c0 csn cxp c0 csn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i iscau5
      mp2an c1 cn wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj
      cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx cv
      crp wcel vj cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral c1 vk cv
      cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr wi vk cn wral vj c1 cn vj cv c1 wceq vj cv
      vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0
      csn cxp cc0 csn cxp co vx cv clt wbr wi c1 vk cv cle wbr c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr wi vk cn vj cv c1 wceq vj cv vk cv cle wbr c1 vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr vj cv c1 vk cv cle breq1 vj cv c1 wceq
      vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn
      cxp co c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt vj cv c1 wceq vj cv cn c0 csn cxp cfv c1 cn c0 csn
      cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp vj cv c1 cn
      c0 csn cxp fveq2 opreq1d breq1d imbi12d ralbidv rcla4ev 1nn vx cv crp
      wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn vx cv crp wcel vk cv cn
      wcel wa c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr c1 vk cv cle wbr cc0 vx cv clt wbr vk cv cn
      wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt wbr vx cv crp wcel vk cv cn wcel c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr cc0 vx cv clt wbr vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co cc0 vx cv clt vk cv cn wcel c1
      cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp cc0 csn
      cxp cfv cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq c1 cn c0 csn cxp cfv
      c0 csn wcel vk cv cn c0 csn cxp cfv c0 csn wcel c1 cn c0 csn cxp cfv vk
      cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp wcel vk cv cn wcel c1 cn c0
      csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn opelxpi c1 cn wcel c1
      cn c0 csn cxp cfv c0 csn wcel 1nn c1 cn wcel c1 cn c0 csn cxp cfv c0 c0
      csn cn c0 c1 0ex fvconst2 c0 0ex snid syl6eqel ax-mp vk cv cn wcel vk cv
      cn c0 csn cxp cfv c0 c0 csn cn c0 vk cv 0ex fvconst2 c0 0ex snid syl6eqel
      sylancr c0 csn c0 csn cxp cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop cc0 cc 0cn elisseti fvconst2 syl c1 cn c0 csn cxp cfv vk cv cn c0
      csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq breq1d biimparc
      vx cv rpgt0 sylan a1d r19.21aiva sylancr mprgbir cn c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf cn c0 0ex
      fconst c0 csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn wceq cn c0 csn c0 csn
      cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf wb c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtri c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn cn cn c0 csn cxp feq3 ax-mp mpbir
      pm3.2i pm3.2i elimhyp2v cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn
      c0 csn cxp cif wf wa simpll ax-mp cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif wf wa wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cca cfv wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa wa cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv
      ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf wa wa c0 csn c0
      csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp
      wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa wa cM cC c0 csn c0
      csn cxp cc0 csn cxp cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cn c0 csn cxp cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cdm cdm cn c0 csn cxp wf wa wa cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      cme wcel cJ ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cC wf wa cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      cM cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cJ ccomp wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel cM cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cme eleq1 cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cJ cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      copn cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv cJ cM cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn fveq2 heibor.1 syl5eq eleq1d anbi12d cM cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq cC cM cca cfv wcel cC cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cca cfv wcel cn cX cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cca cfv cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv cC cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca fveq2
      eleq2d cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cX cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm wceq cn cX cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf wb cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cdm cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cX cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cdm
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cdm cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif dmeq
      dmeqd heibor.2 syl5eq cX cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn cC feq3
      syl anbi12d anbi12d cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cC cn c0 csn cxp cif wceq cC cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cC cn c0 csn cxp cif wf wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme
      wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif wceq cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif wf cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cdm cdm cC cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif feq1 anbi12d
      anbi2d c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn
      cfv ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp wcel wa cn c0 csn cxp c0 csn c0 csn cxp
      cc0 csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0
      csn cxp wf wa cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa c0 csn c0
      csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp
      cc0 csn cxp cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel c0 csn c0
      csn cxp cc0 csn cxp copn cfv ccomp wcel cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cme eleq1 c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif wceq c0 csn c0 csn cxp cc0 csn cxp copn cfv cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif copn cfv ccomp c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn fveq2 eleq1d anbi12d c0 csn c0 csn cxp cc0 csn cxp cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif wceq cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp
      cca cfv wcel cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf c0 csn c0 csn cxp cc0 csn
      cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cca
      cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv cn c0 csn cxp c0 csn c0 csn cxp
      cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca fveq2 eleq2d c0 csn c0 csn
      cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm wceq cn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cn c0 csn cxp wf wb c0 csn c0 csn cxp cc0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif dmeq dmeqd c0 csn c0 csn cxp cc0 csn cxp cdm cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cn cn c0 csn cxp feq3 syl anbi12d anbi12d cn c0
      csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cC cn c0 csn cxp cif wceq cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn
      c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf wa cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cn
      c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cC cn c0 csn cxp cif wceq cn c0 csn cxp cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf cn c0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif feq1 anbi12d anbi2d c0 csn c0
      csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp
      wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa c0 csn c0 csn cxp
      cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel vx
      vy vz c0 csn c0 csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn
      c0 csn c0 csn cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0
      csn c0 csn cxp cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti
      fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn
      cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy
      cv c0 wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv wceq wb vx cv c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0
      wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv
      wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn
      c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx
      cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0
      csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx
      cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel
      vy cv c0 csn wcel vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy
      cv c0 wceq vx cv vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn
      syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti
      fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d
      impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0 csn wcel vy cv c0 csn wcel
      vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr
      cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr cc0 0re leidi cc0 0re leidi
      cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co caddc co cc0 cc0 caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel
      c0 csn c0 csn cc0 vx cv vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx
      cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn
      c0 csn cxp cc0 csn cxp co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 caddc vx cv c0 csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv
      c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn
      c0 csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy
      cv c0 csn wcel vz cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz
      cv vy cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d
      mpbiri ismeti c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop cfn cin wcel c0
      csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn
      cxp copn cfv ctop cfn cin wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv
      ctop wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv cfn wcel c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ctop cfn elin c0 csn c0 csn cxp cc0 csn cxp cme
      wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop wcel vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn
      c0 csn cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opntop ax-mp c0 csn cpw cfn wcel c0 csn
      c0 csn cxp cc0 csn cxp copn cfv c0 csn cpw wss c0 csn c0 csn cxp cc0 csn
      cxp copn cfv cfn wcel c0 csn cfn wcel c0 csn cpw cfn wcel c0 snfi c0 csn
      pwfi mpbi c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0
      csn cxp copn cfv c0 csn cpw wss vx vy vz c0 csn c0 csn cxp cc0 csn cxp c0
      csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn cxp cc0 csn cxp wf cc0
      csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp cc0 csn cxp wf c0 csn
      c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr wss 0re
      cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn
      cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn cxp
      cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv c0 csn wcel vy cv c0
      csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv
      vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq
      wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv cop c0 csn
      c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn
      opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv
      cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0
      csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc
      co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr
      cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn
      wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0 caddc co cle vx
      cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv vy cv cc0 cc
      0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0 csn wcel vz cv c0
      csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vy cv c0
      csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv c0 csn wcel vz
      cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn c0 csn
      cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn cxp
      cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz c0
      csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opnfss ax-mp c0 csn cpw c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ssfi mp2an mpbir2an c0 csn c0 csn cxp cc0 csn
      cxp copn cfv fintopcomp ax-mp pm3.2i cn c0 csn cxp c0 csn c0 csn cxp cc0
      csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn
      cxp wf cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk
      cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx crp c0 csn
      c0 csn cxp cc0 csn cxp cme wcel cn c0 csn cn c0 csn cxp wf cn c0 csn cxp
      c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral wb vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti cn c0
      0ex fconst vx c0 csn c0 csn cxp cc0 csn cxp vj vk cn c0 csn cxp c0 csn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i iscau5
      mp2an c1 cn wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj
      cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx cv
      crp wcel vj cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral c1 vk cv
      cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr wi vk cn wral vj c1 cn vj cv c1 wceq vj cv
      vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0
      csn cxp cc0 csn cxp co vx cv clt wbr wi c1 vk cv cle wbr c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr wi vk cn vj cv c1 wceq vj cv vk cv cle wbr c1 vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr vj cv c1 vk cv cle breq1 vj cv c1 wceq
      vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn
      cxp co c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt vj cv c1 wceq vj cv cn c0 csn cxp cfv c1 cn c0 csn
      cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp vj cv c1 cn
      c0 csn cxp fveq2 opreq1d breq1d imbi12d ralbidv rcla4ev 1nn vx cv crp
      wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn vx cv crp wcel vk cv cn
      wcel wa c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr c1 vk cv cle wbr cc0 vx cv clt wbr vk cv cn
      wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt wbr vx cv crp wcel vk cv cn wcel c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr cc0 vx cv clt wbr vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co cc0 vx cv clt vk cv cn wcel c1
      cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp cc0 csn
      cxp cfv cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq c1 cn c0 csn cxp cfv
      c0 csn wcel vk cv cn c0 csn cxp cfv c0 csn wcel c1 cn c0 csn cxp cfv vk
      cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp wcel vk cv cn wcel c1 cn c0
      csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn opelxpi c1 cn wcel c1
      cn c0 csn cxp cfv c0 csn wcel 1nn c1 cn wcel c1 cn c0 csn cxp cfv c0 c0
      csn cn c0 c1 0ex fvconst2 c0 0ex snid syl6eqel ax-mp vk cv cn wcel vk cv
      cn c0 csn cxp cfv c0 c0 csn cn c0 vk cv 0ex fvconst2 c0 0ex snid syl6eqel
      sylancr c0 csn c0 csn cxp cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop cc0 cc 0cn elisseti fvconst2 syl c1 cn c0 csn cxp cfv vk cv cn c0
      csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq breq1d biimparc
      vx cv rpgt0 sylan a1d r19.21aiva sylancr mprgbir cn c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf cn c0 0ex
      fconst c0 csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn wceq cn c0 csn c0 csn
      cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf wb c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtri c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn cn cn c0 csn cxp feq3 ax-mp mpbir
      pm3.2i pm3.2i elimhyp2v cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm
      cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC
      cn c0 csn cxp cif wf simprl ax-mp cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif wf wa wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn
      cfv ccomp wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn cfv ccomp wcel wa cC cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv
      wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa wa cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp
      wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf wa wa c0 csn c0 csn
      cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp
      wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa wa cM cC c0 csn c0
      csn cxp cc0 csn cxp cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cn c0 csn cxp cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cdm cdm cn c0 csn cxp wf wa wa cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      cme wcel cJ ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cC wf wa cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      cM cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cJ ccomp wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel cM cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cme eleq1 cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cJ cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      copn cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv cJ cM cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn fveq2 heibor.1 syl5eq eleq1d anbi12d cM cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq cC cM cca cfv wcel cC cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cca cfv wcel cn cX cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cca cfv cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv cC cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca fveq2
      eleq2d cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cX cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm wceq cn cX cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf wb cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cdm cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cX cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cdm
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cdm cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif dmeq
      dmeqd heibor.2 syl5eq cX cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn cC feq3
      syl anbi12d anbi12d cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cC cn c0 csn cxp cif wceq cC cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cC cn c0 csn cxp cif wf wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme
      wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif wceq cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif wf cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cdm cdm cC cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif feq1 anbi12d
      anbi2d c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn
      cfv ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp wcel wa cn c0 csn cxp c0 csn c0 csn cxp
      cc0 csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0
      csn cxp wf wa cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa c0 csn c0
      csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp
      cc0 csn cxp cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel c0 csn c0
      csn cxp cc0 csn cxp copn cfv ccomp wcel cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cme eleq1 c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif wceq c0 csn c0 csn cxp cc0 csn cxp copn cfv cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif copn cfv ccomp c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn fveq2 eleq1d anbi12d c0 csn c0 csn cxp cc0 csn cxp cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif wceq cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp
      cca cfv wcel cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf c0 csn c0 csn cxp cc0 csn
      cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cca
      cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv cn c0 csn cxp c0 csn c0 csn cxp
      cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca fveq2 eleq2d c0 csn c0 csn
      cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm wceq cn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cn c0 csn cxp wf wb c0 csn c0 csn cxp cc0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif dmeq dmeqd c0 csn c0 csn cxp cc0 csn cxp cdm cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cn cn c0 csn cxp feq3 syl anbi12d anbi12d cn c0
      csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cC cn c0 csn cxp cif wceq cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn
      c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf wa cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cn
      c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cC cn c0 csn cxp cif wceq cn c0 csn cxp cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf cn c0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif feq1 anbi12d anbi2d c0 csn c0
      csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp
      wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa c0 csn c0 csn cxp
      cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel vx
      vy vz c0 csn c0 csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn
      c0 csn c0 csn cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0
      csn c0 csn cxp cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti
      fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn
      cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy
      cv c0 wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv wceq wb vx cv c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0
      wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv
      wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn
      c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx
      cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0
      csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx
      cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel
      vy cv c0 csn wcel vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy
      cv c0 wceq vx cv vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn
      syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti
      fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d
      impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0 csn wcel vy cv c0 csn wcel
      vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr
      cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr cc0 0re leidi cc0 0re leidi
      cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co caddc co cc0 cc0 caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel
      c0 csn c0 csn cc0 vx cv vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx
      cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn
      c0 csn cxp cc0 csn cxp co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 caddc vx cv c0 csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv
      c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn
      c0 csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy
      cv c0 csn wcel vz cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz
      cv vy cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d
      mpbiri ismeti c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop cfn cin wcel c0
      csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn
      cxp copn cfv ctop cfn cin wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv
      ctop wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv cfn wcel c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ctop cfn elin c0 csn c0 csn cxp cc0 csn cxp cme
      wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop wcel vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn
      c0 csn cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opntop ax-mp c0 csn cpw cfn wcel c0 csn
      c0 csn cxp cc0 csn cxp copn cfv c0 csn cpw wss c0 csn c0 csn cxp cc0 csn
      cxp copn cfv cfn wcel c0 csn cfn wcel c0 csn cpw cfn wcel c0 snfi c0 csn
      pwfi mpbi c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0
      csn cxp copn cfv c0 csn cpw wss vx vy vz c0 csn c0 csn cxp cc0 csn cxp c0
      csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn cxp cc0 csn cxp wf cc0
      csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp cc0 csn cxp wf c0 csn
      c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr wss 0re
      cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn
      cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn cxp
      cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv c0 csn wcel vy cv c0
      csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv
      vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq
      wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv cop c0 csn
      c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn
      opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv
      cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0
      csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc
      co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr
      cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn
      wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0 caddc co cle vx
      cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv vy cv cc0 cc
      0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0 csn wcel vz cv c0
      csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vy cv c0
      csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv c0 csn wcel vz
      cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn c0 csn
      cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn cxp
      cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz c0
      csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opnfss ax-mp c0 csn cpw c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ssfi mp2an mpbir2an c0 csn c0 csn cxp cc0 csn
      cxp copn cfv fintopcomp ax-mp pm3.2i cn c0 csn cxp c0 csn c0 csn cxp cc0
      csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn
      cxp wf cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk
      cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx crp c0 csn
      c0 csn cxp cc0 csn cxp cme wcel cn c0 csn cn c0 csn cxp wf cn c0 csn cxp
      c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral wb vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti cn c0
      0ex fconst vx c0 csn c0 csn cxp cc0 csn cxp vj vk cn c0 csn cxp c0 csn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i iscau5
      mp2an c1 cn wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj
      cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx cv
      crp wcel vj cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral c1 vk cv
      cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr wi vk cn wral vj c1 cn vj cv c1 wceq vj cv
      vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0
      csn cxp cc0 csn cxp co vx cv clt wbr wi c1 vk cv cle wbr c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr wi vk cn vj cv c1 wceq vj cv vk cv cle wbr c1 vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr vj cv c1 vk cv cle breq1 vj cv c1 wceq
      vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn
      cxp co c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt vj cv c1 wceq vj cv cn c0 csn cxp cfv c1 cn c0 csn
      cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp vj cv c1 cn
      c0 csn cxp fveq2 opreq1d breq1d imbi12d ralbidv rcla4ev 1nn vx cv crp
      wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn vx cv crp wcel vk cv cn
      wcel wa c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr c1 vk cv cle wbr cc0 vx cv clt wbr vk cv cn
      wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt wbr vx cv crp wcel vk cv cn wcel c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr cc0 vx cv clt wbr vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co cc0 vx cv clt vk cv cn wcel c1
      cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp cc0 csn
      cxp cfv cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq c1 cn c0 csn cxp cfv
      c0 csn wcel vk cv cn c0 csn cxp cfv c0 csn wcel c1 cn c0 csn cxp cfv vk
      cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp wcel vk cv cn wcel c1 cn c0
      csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn opelxpi c1 cn wcel c1
      cn c0 csn cxp cfv c0 csn wcel 1nn c1 cn wcel c1 cn c0 csn cxp cfv c0 c0
      csn cn c0 c1 0ex fvconst2 c0 0ex snid syl6eqel ax-mp vk cv cn wcel vk cv
      cn c0 csn cxp cfv c0 c0 csn cn c0 vk cv 0ex fvconst2 c0 0ex snid syl6eqel
      sylancr c0 csn c0 csn cxp cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop cc0 cc 0cn elisseti fvconst2 syl c1 cn c0 csn cxp cfv vk cv cn c0
      csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq breq1d biimparc
      vx cv rpgt0 sylan a1d r19.21aiva sylancr mprgbir cn c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf cn c0 0ex
      fconst c0 csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn wceq cn c0 csn c0 csn
      cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf wb c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtri c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn cn cn c0 csn cxp feq3 ax-mp mpbir
      pm3.2i pm3.2i elimhyp2v cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn
      c0 csn cxp cif wf wa simplr ax-mp vl cv cn wcel vd cv cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      vl cv cuz cfv cima cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccl cfv cfv
      wceq wa vl vd copab eqid vn cv cn wcel vs cv cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cdm cdm vn cv vl cv cn wcel vd cv cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif vl cv cuz cfv cima cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccl cfv cfv wceq wa vl vd copab cfv cdif
      wceq wa vn vs copab eqid cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm
      cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC
      cn c0 csn cxp cif wf wa wa cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0
      csn cxp cif wf cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn cfv ccomp wcel wa cC cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv
      wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa wa cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp
      wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf wa wa c0 csn c0 csn
      cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp
      wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa wa cM cC c0 csn c0
      csn cxp cc0 csn cxp cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cn c0 csn cxp cM
      cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn
      c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cdm cdm cn c0 csn cxp wf wa wa cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      cme wcel cJ ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cC wf wa cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      cM cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cJ ccomp wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel cM cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cme eleq1 cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cJ cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp cM cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM
      copn cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv cJ cM cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn fveq2 heibor.1 syl5eq eleq1d anbi12d cM cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq cC cM cca cfv wcel cC cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cca cfv wcel cn cX cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cca cfv cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cca cfv cC cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca fveq2
      eleq2d cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cX cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm wceq cn cX cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca
      cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm
      cC wf wb cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cdm cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cX cM cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq cM cdm
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cdm cM cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif dmeq
      dmeqd heibor.2 syl5eq cX cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn cC feq3
      syl anbi12d anbi12d cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cC cn c0 csn cxp cif wceq cC cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cC wf wa cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn
      cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cC cn c0 csn cxp cif wf wa cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme
      wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cC cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif wceq cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cC wf cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif wf cC cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0
      csn c0 csn cxp cc0 csn cxp cif cdm cdm cC cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif feq1 anbi12d
      anbi2d c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq
      c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn
      cfv ccomp wcel wa cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif copn cfv ccomp wcel wa cn c0 csn cxp c0 csn c0 csn cxp
      cc0 csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0
      csn cxp wf wa cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa c0 csn c0
      csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX
      cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp
      cc0 csn cxp cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn
      cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel c0 csn c0
      csn cxp cc0 csn cxp copn cfv ccomp wcel cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cme eleq1 c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif wceq c0 csn c0 csn cxp cc0 csn cxp copn cfv cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif copn cfv ccomp c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif copn fveq2 eleq1d anbi12d c0 csn c0 csn cxp cc0 csn cxp cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif wceq cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp
      cca cfv wcel cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf c0 csn c0 csn cxp cc0 csn
      cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cca
      cfv cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv cn c0 csn cxp c0 csn c0 csn cxp
      cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca fveq2 eleq2d c0 csn c0 csn
      cxp cc0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm wceq cn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp
      cif cdm cdm cn c0 csn cxp wf wb c0 csn c0 csn cxp cc0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif wceq c0 csn c0 csn cxp cc0 csn cxp cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm c0 csn c0 csn cxp cc0 csn cxp cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif dmeq dmeqd c0 csn c0 csn cxp cc0 csn cxp cdm cdm cM cme wcel cJ
      ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp
      cc0 csn cxp cif cdm cdm cn cn c0 csn cxp feq3 syl anbi12d anbi12d cn c0
      csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa
      cC cn c0 csn cxp cif wceq cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC
      cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf wa
      cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn
      c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf wa cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cme wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC
      wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cn
      c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa
      wa cC cn c0 csn cxp cif wceq cn c0 csn cxp cM cme wcel cJ ccomp wcel wa
      cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif
      cca cfv wcel cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf
      wa wa cC cn c0 csn cxp cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cca cfv wcel
      cn cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cdm cdm cn c0 csn cxp wf cn cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cdm cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif wf cn c0 csn cxp cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp
      cif cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM
      c0 csn c0 csn cxp cc0 csn cxp cif cca cfv eleq1 cn cM cme wcel cJ ccomp
      wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn
      cxp cif cdm cdm cn c0 csn cxp cM cme wcel cJ ccomp wcel wa cC cM cca cfv
      wcel cn cX cC wf wa wa cC cn c0 csn cxp cif feq1 anbi12d anbi2d c0 csn c0
      csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp
      wcel wa cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel cn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf wa c0 csn c0 csn cxp
      cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel vx
      vy vz c0 csn c0 csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn
      c0 csn c0 csn cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0
      csn c0 csn cxp cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti
      fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn
      cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy
      cv c0 wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv wceq wb vx cv c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0
      wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv
      wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn
      c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx
      cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0
      csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx
      cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel
      vy cv c0 csn wcel vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy
      cv c0 wceq vx cv vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn
      syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti
      fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d
      impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0 csn wcel vy cv c0 csn wcel
      vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr
      cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr cc0 0re leidi cc0 0re leidi
      cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co caddc co cc0 cc0 caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel
      c0 csn c0 csn cc0 vx cv vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx
      cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn
      c0 csn cxp cc0 csn cxp co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 caddc vx cv c0 csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv
      c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn
      c0 csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy
      cv c0 csn wcel vz cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz
      cv vy cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d
      mpbiri ismeti c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop cfn cin wcel c0
      csn c0 csn cxp cc0 csn cxp copn cfv ccomp wcel c0 csn c0 csn cxp cc0 csn
      cxp copn cfv ctop cfn cin wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv
      ctop wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv cfn wcel c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ctop cfn elin c0 csn c0 csn cxp cc0 csn cxp cme
      wcel c0 csn c0 csn cxp cc0 csn cxp copn cfv ctop wcel vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn
      c0 csn cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opntop ax-mp c0 csn cpw cfn wcel c0 csn
      c0 csn cxp cc0 csn cxp copn cfv c0 csn cpw wss c0 csn c0 csn cxp cc0 csn
      cxp copn cfv cfn wcel c0 csn cfn wcel c0 csn cpw cfn wcel c0 snfi c0 csn
      pwfi mpbi c0 csn c0 csn cxp cc0 csn cxp cme wcel c0 csn c0 csn cxp cc0
      csn cxp copn cfv c0 csn cpw wss vx vy vz c0 csn c0 csn cxp cc0 csn cxp c0
      csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn cxp cc0 csn cxp wf cc0
      csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp cc0 csn cxp wf c0 csn
      c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr wcel cc0 csn cr wss 0re
      cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr c0 csn c0 csn cxp cc0 csn
      cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn cxp
      cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv c0 csn wcel vy cv c0
      csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq wa vx cv
      vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq vy cv c0 wceq
      wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv cop c0 csn
      c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv vy cv c0 csn c0 csn
      opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn cxp cc0 vx cv vy cv
      cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0 csn c0 csn cxp cc0
      csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn syl2anb vx cv c0
      csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr cc0 cc0 cc0 caddc
      co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0 caddc co cle wbr
      cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i mp2an vx cv c0 csn
      wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co vz cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0 caddc co cle vx
      cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv vy cv cc0 cc
      0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0 csn wcel vz cv
      c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0 csn wcel vz cv c0
      csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vy cv c0
      csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv c0 csn wcel vz
      cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv c0 csn wcel vz
      cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti c0 csn c0 csn
      cxp cc0 csn cxp c0 csn c0 csn cxp cc0 csn cxp copn cfv c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn cxp
      cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz c0
      csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i c0 csn c0
      csn cxp cc0 csn cxp copn cfv eqid opnfss ax-mp c0 csn cpw c0 csn c0 csn
      cxp cc0 csn cxp copn cfv ssfi mp2an mpbir2an c0 csn c0 csn cxp cc0 csn
      cxp copn cfv fintopcomp ax-mp pm3.2i cn c0 csn cxp c0 csn c0 csn cxp cc0
      csn cxp cca cfv wcel cn c0 csn c0 csn cxp cc0 csn cxp cdm cdm cn c0 csn
      cxp wf cn c0 csn cxp c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk
      cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx crp c0 csn
      c0 csn cxp cc0 csn cxp cme wcel cn c0 csn cn c0 csn cxp wf cn c0 csn cxp
      c0 csn c0 csn cxp cc0 csn cxp cca cfv wcel vj cv vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr wi vk cn wral vj cn wrex vx crp wral wb vx vy vz c0 csn c0
      csn cxp cc0 csn cxp c0 csn p0ex c0 csn c0 csn cxp cc0 csn c0 csn c0 csn
      cxp cc0 csn cxp wf cc0 csn cr wss c0 csn c0 csn cxp cr c0 csn c0 csn cxp
      cc0 csn cxp wf c0 csn c0 csn cxp cc0 cc0 cc 0cn elisseti fconst cc0 cr
      wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp c0 csn c0 csn cxp cc0 csn cr
      c0 csn c0 csn cxp cc0 csn cxp fss mp2an vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb vx cv
      c0 csn wcel vy cv c0 csn wcel vx cv c0 wceq vy cv c0 wceq wa vx cv vy cv
      c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx cv c0 wceq
      vy cv c0 wceq wa vx cv vy cv wceq vx cv vy cv c0 csn c0 csn cxp cc0 csn
      cxp co cc0 wceq vx cv vy cv c0 eqtr3 a1d vx cv c0 wceq vy cv c0 wceq wa
      vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq vx
      cv c0 wceq vy cv c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp cc0 csn cxp
      cfv cc0 vx cv vy cv c0 csn c0 csn cxp cc0 csn cxp co vx cv c0 wceq vy cv
      c0 wceq wa vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv vy cv cop c0 csn
      c0 csn cxp cc0 csn cxp cfv cc0 wceq vx cv c0 csn wcel vy cv c0 csn wcel
      vx cv vy cv cop c0 csn c0 csn cxp wcel vx cv c0 wceq vy cv c0 wceq vx cv
      vy cv c0 csn c0 csn opelxpi vx c0 elsn vy c0 elsn syl2anbr c0 csn c0 csn
      cxp cc0 vx cv vy cv cop cc0 cc 0cn elisseti fvconst2 syl vx cv vy cv c0
      csn c0 csn cxp cc0 csn cxp df-opr syl5eq a1d impbid vx c0 elsn vy c0 elsn
      syl2anb vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv
      vy cv c0 csn c0 csn cxp cc0 csn cxp co vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cle wbr
      cc0 cc0 cc0 caddc co cle wbr cc0 cc0 cle wbr cc0 cc0 cle wbr cc0 cc0 cc0
      caddc co cle wbr cc0 0re leidi cc0 0re leidi cc0 cc0 0re 0re addge0i
      mp2an vx cv c0 csn wcel vy cv c0 csn wcel vz cv c0 csn wcel w3a vx cv vy
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 vz cv vx cv c0 csn c0 csn cxp cc0
      csn cxp co vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co caddc co cc0 cc0
      caddc co cle vx cv c0 csn wcel vy cv c0 csn wcel vx cv vy cv c0 csn c0
      csn cxp cc0 csn cxp co cc0 wceq vz cv c0 csn wcel c0 csn c0 csn cc0 vx cv
      vy cv cc0 cc 0cn elisseti oprvconst2 3adant3 vx cv c0 csn wcel vy cv c0
      csn wcel vz cv c0 csn wcel w3a vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp
      co cc0 vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 caddc vx cv c0
      csn wcel vz cv c0 csn wcel vz cv vx cv c0 csn c0 csn cxp cc0 csn cxp co
      cc0 wceq vy cv c0 csn wcel vz cv c0 csn wcel vx cv c0 csn wcel vz cv vx
      cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vx
      cv cc0 cc 0cn elisseti oprvconst2 ancoms 3adant2 vy cv c0 csn wcel vz cv
      c0 csn wcel vz cv vy cv c0 csn c0 csn cxp cc0 csn cxp co cc0 wceq vx cv
      c0 csn wcel vz cv c0 csn wcel vy cv c0 csn wcel vz cv vy cv c0 csn c0 csn
      cxp cc0 csn cxp co cc0 wceq c0 csn c0 csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d breq12d mpbiri ismeti cn c0
      0ex fconst vx c0 csn c0 csn cxp cc0 csn cxp vj vk cn c0 csn cxp c0 csn c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtr2i iscau5
      mp2an c1 cn wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj
      cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx cv
      crp wcel vj cv vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn wral c1 vk cv
      cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr wi vk cn wral vj c1 cn vj cv c1 wceq vj cv
      vk cv cle wbr vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0
      csn cxp cc0 csn cxp co vx cv clt wbr wi c1 vk cv cle wbr c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr wi vk cn vj cv c1 wceq vj cv vk cv cle wbr c1 vk cv cle wbr vj cv cn
      c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co
      vx cv clt wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vx cv clt wbr vj cv c1 vk cv cle breq1 vj cv c1 wceq
      vj cv cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn
      cxp co c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt vj cv c1 wceq vj cv cn c0 csn cxp cfv c1 cn c0 csn
      cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp vj cv c1 cn
      c0 csn cxp fveq2 opreq1d breq1d imbi12d ralbidv rcla4ev 1nn vx cv crp
      wcel c1 vk cv cle wbr c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn
      c0 csn cxp cc0 csn cxp co vx cv clt wbr wi vk cn vx cv crp wcel vk cv cn
      wcel wa c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp
      cc0 csn cxp co vx cv clt wbr c1 vk cv cle wbr cc0 vx cv clt wbr vk cv cn
      wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0
      csn cxp co vx cv clt wbr vx cv crp wcel vk cv cn wcel c1 cn c0 csn cxp
      cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp co vx cv clt
      wbr cc0 vx cv clt wbr vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn
      cxp cfv c0 csn c0 csn cxp cc0 csn cxp co cc0 vx cv clt vk cv cn wcel c1
      cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp cc0 csn
      cxp cfv cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn
      cxp cc0 csn cxp co vk cv cn wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp wcel c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop c0 csn c0 csn cxp cc0 csn cxp cfv cc0 wceq c1 cn c0 csn cxp cfv
      c0 csn wcel vk cv cn c0 csn cxp cfv c0 csn wcel c1 cn c0 csn cxp cfv vk
      cv cn c0 csn cxp cfv cop c0 csn c0 csn cxp wcel vk cv cn wcel c1 cn c0
      csn cxp cfv vk cv cn c0 csn cxp cfv c0 csn c0 csn opelxpi c1 cn wcel c1
      cn c0 csn cxp cfv c0 csn wcel 1nn c1 cn wcel c1 cn c0 csn cxp cfv c0 c0
      csn cn c0 c1 0ex fvconst2 c0 0ex snid syl6eqel ax-mp vk cv cn wcel vk cv
      cn c0 csn cxp cfv c0 c0 csn cn c0 vk cv 0ex fvconst2 c0 0ex snid syl6eqel
      sylancr c0 csn c0 csn cxp cc0 c1 cn c0 csn cxp cfv vk cv cn c0 csn cxp
      cfv cop cc0 cc 0cn elisseti fvconst2 syl c1 cn c0 csn cxp cfv vk cv cn c0
      csn cxp cfv c0 csn c0 csn cxp cc0 csn cxp df-opr syl5eq breq1d biimparc
      vx cv rpgt0 sylan a1d r19.21aiva sylancr mprgbir cn c0 csn c0 csn cxp cc0
      csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf cn c0 0ex
      fconst c0 csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn wceq cn c0 csn c0 csn
      cxp cc0 csn cxp cdm cdm cn c0 csn cxp wf cn c0 csn cn c0 csn cxp wf wb c0
      csn c0 csn cxp cc0 csn cxp cdm cdm c0 csn c0 csn cxp cdm c0 csn c0 csn c0
      csn cxp cc0 csn cxp cdm c0 csn c0 csn cxp cc0 csn c0 wne c0 csn c0 csn
      cxp cc0 csn cxp cdm c0 csn c0 csn cxp wceq cc0 cc0 cc 0cn elisseti snnz
      c0 csn c0 csn cxp cc0 csn dmxp ax-mp dmeqi c0 csn dmxpid eqtri c0 csn c0
      csn cxp cc0 csn cxp cdm cdm c0 csn cn cn c0 csn cxp feq3 ax-mp mpbir
      pm3.2i pm3.2i elimhyp2v cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel
      cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cme wcel cM cme
      wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0
      csn cxp cc0 csn cxp cif copn cfv ccomp wcel wa cM cme wcel cJ ccomp wcel
      wa cC cM cca cfv wcel cn cX cC wf wa wa cC cn c0 csn cxp cif cM cme wcel
      cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn
      cxp cc0 csn cxp cif cca cfv wcel cn cM cme wcel cJ ccomp wcel wa cC cM
      cca cfv wcel cn cX cC wf wa wa cM c0 csn c0 csn cxp cc0 csn cxp cif cdm
      cdm cM cme wcel cJ ccomp wcel wa cC cM cca cfv wcel cn cX cC wf wa wa cC
      cn c0 csn cxp cif wf simprr ax-mp heiborlem17 dedth2v cX cM cdm cdm wceq
      cC vx cv cM clm cfv wbr vx cX wrex cC vx cv cM clm cfv wbr vx cM cdm cdm
      wrex wb heibor.2 cC vx cv cM clm cfv wbr vx cX cM cdm cdm rexeq1 ax-mp
      sylibr $.
      $( [2-Sep-2009] $)

    $( Lemma for ~ heibor . Since every Cauchy sequence converges, ` M ` is a
       complete metric. $)
    heiborlem19 $p |- ( ( M e. Met /\ J e. Comp ) -> M e. CMet ) $=
      cM cme wcel cJ ccomp wcel cn cX vf cv wf vf cv vx cv cM clm cfv wbr vx cX
      wrex wi vf cM cca cfv wral cM cms wcel cM cme wcel cJ ccomp wcel wa cn cX
      vf cv wf vf cv vx cv cM clm cfv wbr vx cX wrex wi vf cM cca cfv cM cme
      wcel cJ ccomp wcel wa vf cv cM cca cfv wcel cn cX vf cv wf vf cv vx cv cM
      clm cfv wbr vx cX wrex vx vf cv cJ cM cX heibor.1 heibor.2 heiborlem18
      exp32 r19.21aiv cM cms wcel cM cme wcel cn cX vf cv wf vf cv vx cv cM clm
      cfv wbr vx cX wrex wi vf cM cca cfv wral wa vx cM vf cX heibor.2 iscms2
      biimpri syldan $.
      $( [2-Sep-2009] $)

    $d U p s u v $. $d S d s t u v w x y z $. $d Y a h j l m n p s v $.
    $d A r v w x $. $d D a h n r t u w x y z $. $d X a g h j k m p $.
    $d N a h r v x y $. $d H a f g h j k l m n p r s t u v x y $.
    $d B a f g h j k m p t u w y z $. $d M a g h j k m p $. $d J u w $.
    $d G f g j k l m p t u w y z $. $d R a d h j l m n p r s t u v w x y $.

    ${
      heibor.9 $e |- M e. CMet $.
      heibor.10 $e |- M e. TotBnd $.
      heibor.11 $e |- U C_ J $.
      heibor.12 $e |- X = U. U $.
      heibor.13 $e |- D = { s e. ~P X | -. E. v e.
                                          ( ~P U i^i Fin ) s C_ U. v } $.

      $( Lemma for ~ heibor . Condition for being an element of ` D ` , the set
         of subsets of ` X ` with no finite subcover. $)
      heiborlem20 $p |- ( S e. D <-> ( S C_ X /\
                            -. E. w e. ( ~P U i^i Fin ) S C_ U. w ) ) $=
        cS cD wcel cS cX cpw wcel cS vv cv cuni wss vv cU cpw cfn cin wrex wn
        wa cS cX wss cS vw cv cuni wss vw cU cpw cfn cin wrex wn wa vs cv vv cv
        cuni wss vv cU cpw cfn cin wrex wn cS vv cv cuni wss vv cU cpw cfn cin
        wrex wn vs cS cX cpw cD vs cv cS wceq vs cv vv cv cuni wss vv cU cpw
        cfn cin wrex cS vv cv cuni wss vv cU cpw cfn cin wrex vs cv cS wceq vs
        cv vv cv cuni wss cS vv cv cuni wss vv cU cpw cfn cin vs cv cS vv cv
        cuni sseq1 rexbidv notbid heibor.13 elrab2 cS cX cpw wcel cS cX wss cS
        vv cv cuni wss vv cU cpw cfn cin wrex wn cS vw cv cuni wss vw cU cpw
        cfn cin wrex wn cS cX cX cM cdm cdm cvv heibor.2 cM cdm cM cM cms
        heibor.9 elisseti dmex dmex eqeltri elpw2 cS vv cv cuni wss vv cU cpw
        cfn cin wrex cS vw cv cuni wss vw cU cpw cfn cin wrex cS vv cv cuni wss
        cS vw cv cuni wss vv vw cU cpw cfn cin vv cv vw cv wceq vv cv cuni vw
        cv cuni cS vv cv vw cv unieq sseq2d cbvrexv notbii anbi12i bitri $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . A set with no finite subcover cannot be empty. $)
      heiborlem21 $p |- ( S e. D -> S =/= (/) ) $=
        cS cD wcel cS cX wss cS vw cv cuni wss vw cU cpw cfn cin wrex wn wa cS
        c0 wne vw vv cD cS cU cJ cM cX vs heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heiborlem20 cS vw cv cuni wss vw cU cpw
        cfn cin wrex wn cS c0 wne cS cX wss cS vw cv cuni wss vw cU cpw cfn cin
        wrex cS c0 c0 cU cpw cfn cin wcel cS c0 cuni wss cS vw cv cuni wss vw
        cU cpw cfn cin wrex cS c0 wceq cS vw cv cuni wss cS c0 cuni wss vw c0
        cU cpw cfn cin vw cv c0 wceq vw cv cuni c0 cuni cS vw cv c0 unieq
        sseq2d rcla4ev c0 cU cpw cfn cin wcel c0 cU cpw wcel c0 cfn wcel c0 cU
        cpw cfn elin cU 0elpw emfin mpbir2an cS c0 wceq cS c0 cuni wss c0 c0
        cuni wss c0 cuni 0ss cS c0 c0 cuni sseq1 mpbiri sylancr necon3bi adantl
        sylbi $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . If a set has no finite subcover, then any set
         containing it has no finite subcover. $)
      heiborlem22 $p |- ( ( A e. D /\ A C_ S /\ S C_ X ) -> S e. D ) $=
        cS cD wcel cS cX wss cS vw cv cuni wss vw cU cpw cfn cin wrex wn cA cD
        wcel cA cS wss cS cX wss w3a vw vv cD cS cU cJ cM cX vs heibor.1
        heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heiborlem20
        cA cD wcel cA cS wss cS cX wss 3simp3 cA cD wcel cA cS wss cS vw cv
        cuni wss vw cU cpw cfn cin wrex wn cS cX wss cA cS wss cA cD wcel cS vw
        cv cuni wss vw cU cpw cfn cin wrex wn cA cS wss cS vw cv cuni wss vw cU
        cpw cfn cin wrex cA vw cv cuni wss vw cU cpw cfn cin wrex cA cD wcel cA
        cS wss cS vw cv cuni wss cA vw cv cuni wss vw cU cpw cfn cin cA cS vw
        cv cuni sstr2 r19.22sdv cA cD wcel cA cX wss cA vw cv cuni wss vw cU
        cpw cfn cin wrex wn vw vv cD cA cU cJ cM cX vs heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heiborlem20 pm3.27bi
        nsyli impcom 3adant3 sylanbrc $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . If a set has no finite subcover, then there
         exists a ball of any given radius whose intersection with the set also
         has no finite subcover. This lemma relies on the totally bounded
         condition to show that ` S ` can be covered by finitely many balls. $)
      heiborlem23 $p |- ( ( S e. D /\ R e. RR+ ) ->
                      E. x e. X ( ( x ( ball ` M ) R ) i^i S ) e. D ) $=
        cS cX wss cS vz cv cuni wss vz cU cpw cfn cin wrex wn wa cR crp wcel vx
        cv cR cM cbl cfv co cS cin cD wcel vx cX wrex cS cD wcel cS cX wss cS
        vz cv cuni wss vz cU cpw cfn cin wrex wn cR crp wcel vx cv cR cM cbl
        cfv co cS cin cD wcel vx cX wrex cS cX wss cS vz cv cuni wss vz cU cpw
        cfn cin wrex wn cR crp wcel wa vx cv cR cM cbl cfv co cS cin cD wcel vx
        cX wrex cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv
        vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm
        wrex vy vu cv wral wa vu cfn wrex vd crp wral cS vz cv cuni wss vz cU
        cpw cfn cin wrex wn cR crp wcel wa vx cv cR cM cbl cfv co cS cin cD
        wcel vx cX wrex wi cS cX wss cM cS cS cxp cres ctotbnd wcel vu cv cuni
        cM cS cS cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS cS cxp cres cbl
        cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn
        wrex vd crp wral cM cme wcel cM ctotbnd wcel cS cX wss cM cS cS cxp
        cres ctotbnd wcel cM heibor.9 cmsmeti heibor.10 cS cM cX heibor.2
        totbndss mp3an12 cM cS cS cxp cres cme wcel cM cS cS cxp cres ctotbnd
        wcel vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS
        cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv
        wral wa vu cfn wrex vd crp wral wb cM cme wcel cM cS cS cxp cres cme
        wcel cM heibor.9 cmsmeti cM cS metres ax-mp vt vu cM cS cS cxp cres cM
        cS cS cxp cres cdm cdm vy vd cM cS cS cxp cres cdm cdm eqid istotbnd2
        ax-mp sylib cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv
        vt cv vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm
        cdm wrex vy vu cv wral wa vu cfn wrex vd crp wral wa cS vz cv cuni wss
        vz cU cpw cfn cin wrex wn cR crp wcel wa vx cv cR cM cbl cfv co cS cin
        vw cv cuni wss vw cU cpw cfn cin wrex wn vx cX wrex vx cv cR cM cbl cfv
        co cS cin cD wcel vx cX wrex cS cX wss vu cv cuni cM cS cS cxp cres cdm
        cdm wceq vy cv vt cv vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS
        cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn wrex vd crp wral wa cS
        vz cv cuni wss vz cU cpw cfn cin wrex wn cR crp wcel wa vx cv cR cM cbl
        cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX wral wn vx cv
        cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex wn vx cX
        wrex cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv vd
        cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex
        vy vu cv wral wa vu cfn wrex vd crp wral wa cR crp wcel cS vz cv cuni
        wss vz cU cpw cfn cin wrex wn vx cv cR cM cbl cfv co cS cin vw cv cuni
        wss vw cU cpw cfn cin wrex vx cX wral wn cS cX wss vu cv cuni cM cS cS
        cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS cS cxp cres cbl cfv co
        wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn wrex vd
        crp wral wa cR crp wcel cS vz cv cuni wss vz cU cpw cfn cin wrex wn vx
        cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX
        wral wn cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv
        vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm
        wrex vy vu cv wral wa vu cfn wrex vd crp wral wa cR crp wcel wa vx cv
        cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX
        wral cS vz cv cuni wss vz cU cpw cfn cin wrex cS cX wss vu cv cuni cM
        cS cS cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS cS cxp cres cbl cfv
        co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn wrex
        vd crp wral cR crp wcel vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw
        cU cpw cfn cin wrex vx cX wral cS vz cv cuni wss vz cU cpw cfn cin wrex
        wi cS cX wss cR crp wcel vu cv cuni cM cS cS cxp cres cdm cdm wceq vy
        cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm
        cdm wrex vy vu cv wral wa vu cfn wrex wa vx cv cR cM cbl cfv co cS cin
        vw cv cuni wss vw cU cpw cfn cin wrex vx cX wral cS vz cv cuni wss vz
        cU cpw cfn cin wrex wi vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv
        vt cv vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm
        cdm wrex vy vu cv wral wa vu cfn wrex vd crp wral cR crp wcel wa cS cX
        wss cR crp wcel vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv
        cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex
        vy vu cv wral wa vu cfn wrex vx cv cR cM cbl cfv co cS cin vw cv cuni
        wss vw cU cpw cfn cin wrex vx cX wral cS vz cv cuni wss vz cU cpw cfn
        cin wrex wi cS cX wss cR crp wcel wa vu cv cuni cM cS cS cxp cres cdm
        cdm wceq vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS
        cxp cres cdm cdm wrex vy vu cv wral wa vx cv cR cM cbl cfv co cS cin vw
        cv cuni wss vw cU cpw cfn cin wrex vx cX wral cS vz cv cuni wss vz cU
        cpw cfn cin wrex wi vu cfn cS cX wss cR crp wcel wa vu cv cfn wcel wa
        vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv cR cM cS cS cxp
        cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral vx
        cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX
        wral cS vz cv cuni wss vz cU cpw cfn cin wrex wi cS cX wss cR crp wcel
        wa vu cv cfn wcel wa vu cv cuni cM cS cS cxp cres cdm cdm wceq wa vy cv
        vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm
        wrex vy vu cv wral vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU
        cpw cfn cin wrex vx cX wral cS vz cv cuni wss vz cU cpw cfn cin wrex cS
        cX wss cR crp wcel wa vu cv cfn wcel wa vu cv cuni cM cS cS cxp cres
        cdm cdm wceq wa vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM
        cS cS cxp cres cdm cdm wrex vy vu cv wral vx cv cR cM cbl cfv co cS cin
        vw cv cuni wss vw cU cpw cfn cin wrex vx cX wral wa vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex vy vu cv wral cS vz cv cuni wss vz cU cpw
        cfn cin wrex cS cX wss cR crp wcel wa vy cv vt cv cR cM cS cS cxp cres
        cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral vx cv
        cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX
        wral wa vy cv vw cv cuni wss vw cU cpw cfn cin wrex vy vu cv wral wi vu
        cv cfn wcel vu cv cuni cM cS cS cxp cres cdm cdm wceq cS cX wss cR crp
        wcel wa vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin
        wrex vx cX wral vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM
        cS cS cxp cres cdm cdm wrex vy vu cv wral vy cv vw cv cuni wss vw cU
        cpw cfn cin wrex vy vu cv wral cS cX wss cR crp wcel wa vx cv cR cM cbl
        cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX wral vy cv vt
        cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm
        wrex vy vu cv wral vy cv vw cv cuni wss vw cU cpw cfn cin wrex vy vu cv
        wral cS cX wss cR crp wcel wa vx cv cR cM cbl cfv co cS cin vw cv cuni
        wss vw cU cpw cfn cin wrex vx cX wral wa vy cv vt cv cR cM cS cS cxp
        cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex vy vu cv cS cX wss cR crp wcel wa vx cv cR
        cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx cX wral
        wa vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex vt cM cS cS cxp cres cdm cdm cS cX wss cR
        crp wcel wa vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn
        cin wrex vx cX wral wa vt cv cM cS cS cxp cres cdm cdm wcel vt cv cS
        wcel vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex wi cS cX wss vt cv cM cS cS cxp cres cdm cdm
        wcel vt cv cS wcel wi cR crp wcel vx cv cR cM cbl cfv co cS cin vw cv
        cuni wss vw cU cpw cfn cin wrex vx cX wral cS cX wss vt cv cS wcel vt
        cv cM cS cS cxp cres cdm cdm wcel cS cX wss cS cM cS cS cxp cres cdm
        cdm vt cv cM cme wcel cS cX wss cS cM cS cS cxp cres cdm cdm wceq cM
        heibor.9 cmsmeti cM cX cS heibor.2 metssba2 mpan eleq2d biimprd
        ad2antrr cS cX wss cR crp wcel wa vx cv cR cM cbl cfv co cS cin vw cv
        cuni wss vw cU cpw cfn cin wrex vx cX wral wa vt cv cS wcel vt cv cX
        wcel vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex wi cS cX wss vt cv cS wcel vt cv cX wcel wi
        cR crp wcel vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn
        cin wrex vx cX wral cS cX vt cv ssel ad2antrr cS cX wss cR crp wcel wa
        vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vx
        cX wral wa vt cv cX wcel vt cv cS wcel vy cv vt cv cR cM cS cS cxp cres
        cbl cfv co wceq vy cv vw cv cuni wss vw cU cpw cfn cin wrex wi cS cX
        wss cR crp wcel wa vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU
        cpw cfn cin wrex vx cX wral vt cv cX wcel vt cv cS wcel vy cv vt cv cR
        cM cS cS cxp cres cbl cfv co wceq vy cv vw cv cuni wss vw cU cpw cfn
        cin wrex wi wi cS cX wss cR crp wcel wa vt cv cR cM cbl cfv co cS cin
        vw cv cuni wss vw cU cpw cfn cin wrex vt cv cS wcel vy cv vt cv cR cM
        cS cS cxp cres cbl cfv co wceq vy cv vw cv cuni wss vw cU cpw cfn cin
        wrex wi wi vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn
        cin wrex vx cX wral vt cv cX wcel wa cS cX wss cR crp wcel wa vy cv vt
        cv cR cM cS cS cxp cres cbl cfv co wceq vt cv cS wcel vt cv cR cM cbl
        cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex cS cX wss cR crp wcel wa vy cv vt cv cR cM
        cS cS cxp cres cbl cfv co wceq vt cv cS wcel vt cv cR cM cbl cfv co cS
        cin vw cv cuni wss vw cU cpw cfn cin wrex vy cv vw cv cuni wss vw cU
        cpw cfn cin wrex wi cS cX wss cR crp wcel wa vy cv vt cv cR cM cS cS
        cxp cres cbl cfv co wceq vt cv cS wcel w3a vt cv cR cM cbl cfv co cS
        cin vw cv cuni wss vy cv vw cv cuni wss vw cU cpw cfn cin cS cX wss cR
        crp wcel wa vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cv cS
        wcel w3a vy cv vw cv cuni wss vt cv cR cM cbl cfv co cS cin vw cv cuni
        wss cS cX wss cR crp wcel wa vy cv vt cv cR cM cS cS cxp cres cbl cfv
        co wceq vt cv cS wcel w3a vy cv vt cv cR cM cbl cfv co cS cin vw cv
        cuni cS cX wss cR crp wcel wa vy cv vt cv cR cM cS cS cxp cres cbl cfv
        co wceq vt cv cS wcel vy cv vt cv cR cM cbl cfv co cS cin wceq cS cX
        wss cR crp wcel wa vt cv cS wcel vy cv vt cv cR cM cS cS cxp cres cbl
        cfv co wceq vy cv vt cv cR cM cbl cfv co cS cin wceq cS cX wss cR crp
        wcel wa vt cv cS wcel vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq
        vy cv vt cv cR cM cbl cfv co cS cin wceq wi cS cX wss cR crp wcel wa vt
        cv cS wcel wa vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vy cv vt
        cv cR cM cbl cfv co cS cin wceq cS cX wss cR crp wcel wa vt cv cS wcel
        wa vt cv cR cM cS cS cxp cres cbl cfv co vt cv cR cM cbl cfv co cS cin
        vy cv cS cX wss cR crp wcel vt cv cS wcel vt cv cR cM cS cS cxp cres
        cbl cfv co vt cv cR cM cbl cfv co cS cin wceq cS cX wss vt cv cS wcel
        cR crp wcel vt cv cR cM cS cS cxp cres cbl cfv co vt cv cR cM cbl cfv
        co cS cin wceq cM cme wcel cS cX wss vt cv cS wcel cR crp wcel wa vt cv
        cR cM cS cS cxp cres cbl cfv co vt cv cR cM cbl cfv co cS cin wceq cM
        heibor.9 cmsmeti cR cS cM cM cS cS cxp cres cX vt cv heibor.2 cM cS cS
        cxp cres eqid blssp mpanl1 ancom2s anassrs eqeq2d biimpd ex com23 3imp
        sseq1d biimprd r19.22sdv 3exp com24 vx cv cR cM cbl cfv co cS cin vw cv
        cuni wss vw cU cpw cfn cin wrex vt cv cR cM cbl cfv co cS cin vw cv
        cuni wss vw cU cpw cfn cin wrex vx vt cv cX vx cv vt cv wceq vx cv cR
        cM cbl cfv co cS cin vw cv cuni wss vt cv cR cM cbl cfv co cS cin vw cv
        cuni wss vw cU cpw cfn cin vx cv vt cv wceq vx cv cR cM cbl cfv co cS
        cin vt cv cR cM cbl cfv co cS cin vw cv cuni vx cv vt cv wceq vx cv cR
        cM cbl cfv co vt cv cR cM cbl cfv co cS vx cv vt cv cR cM cbl cfv
        opreq1 ineq1d sseq1d rexbidv rcla4cva syl5 expdimp com23 mpdd syld
        r19.23adv r19.20sdv expimpd ancomsd ad2antrr cS cX wss vu cv cfn wcel
        vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vw cv cuni wss vw cU
        cpw cfn cin wrex vy vu cv wral cS vz cv cuni wss vz cU cpw cfn cin wrex
        wi cR crp wcel cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq vu
        cv cfn wcel vy cv vw cv cuni wss vw cU cpw cfn cin wrex vy vu cv wral
        cS vz cv cuni wss vz cU cpw cfn cin wrex wi cS cX wss vu cv cuni cM cS
        cS cxp cres cdm cdm wceq wa vu cv cfn wcel vy cv vw cv cuni wss vw cU
        cpw cfn cin wrex vy vu cv wral cS vz cv cuni wss vz cU cpw cfn cin wrex
        cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq wa vs cv cU cpw cfn
        cin wss vy cv vw cv cuni wss vw vs cv wrex vy vu cv wral vy cv vw cv
        cuni wss vy vu cv wrex vw vs cv wral w3a vs cfn wrex cS vz cv cuni wss
        vz cU cpw cfn cin wrex vu cv cfn wcel vy cv vw cv cuni wss vw cU cpw
        cfn cin wrex vy vu cv wral wa cS cX wss vu cv cuni cM cS cS cxp cres
        cdm cdm wceq wa cS cX wss vu cv cuni cS wceq wa vs cv cU cpw cfn cin
        wss vy cv vw cv cuni wss vw vs cv wrex vy vu cv wral vy cv vw cv cuni
        wss vy vu cv wrex vw vs cv wral w3a vs cfn wrex cS vz cv cuni wss vz cU
        cpw cfn cin wrex wi cS cX wss vu cv cuni cM cS cS cxp cres cdm cdm wceq
        vu cv cuni cS wceq cS cX wss vu cv cuni cS wceq vu cv cuni cM cS cS cxp
        cres cdm cdm wceq cS cX wss cS cM cS cS cxp cres cdm cdm vu cv cuni cM
        cme wcel cS cX wss cS cM cS cS cxp cres cdm cdm wceq cM heibor.9
        cmsmeti cM cX cS heibor.2 metssba2 mpan eqeq2d biimprd imdistani cS cX
        wss vu cv cuni cS wceq wa vs cv cU cpw cfn cin wss vy cv vw cv cuni wss
        vw vs cv wrex vy vu cv wral vy cv vw cv cuni wss vy vu cv wrex vw vs cv
        wral w3a cS vz cv cuni wss vz cU cpw cfn cin wrex vs cfn cS cX wss vu
        cv cuni cS wceq wa vs cv cfn wcel wa vs cv cU cpw cfn cin wss vy cv vw
        cv cuni wss vw vs cv wrex vy vu cv wral vy cv vw cv cuni wss vy vu cv
        wrex vw vs cv wral w3a cS vz cv cuni wss vz cU cpw cfn cin wrex vs cv
        cuni cU cpw cfn cin wcel cS vs cv cuni cuni wss cS vz cv cuni wss vz cU
        cpw cfn cin wrex cS cX wss vu cv cuni cS wceq wa vs cv cfn wcel wa vs
        cv cU cpw cfn cin wss vy cv vw cv cuni wss vw vs cv wrex vy vu cv wral
        vy cv vw cv cuni wss vy vu cv wrex vw vs cv wral w3a wa cS vz cv cuni
        wss cS vs cv cuni cuni wss vz vs cv cuni cU cpw cfn cin vz cv vs cv
        cuni wceq vz cv cuni vs cv cuni cuni cS vz cv vs cv cuni unieq sseq2d
        rcla4ev cS cX wss vu cv cuni cS wceq wa vs cv cfn wcel wa vy cv vw cv
        cuni wss vw vs cv wrex vy vu cv wral vs cv cU cpw cfn cin wss vs cv
        cuni cU cpw cfn cin wcel vy cv vw cv cuni wss vy vu cv wrex vw vs cv
        wral vs cv cfn wcel vs cv cU cpw cfn cin wss vs cv cuni cU cpw cfn cin
        wcel cS cX wss vu cv cuni cS wceq wa vs cv cfn wcel vs cv cU cpw wss vs
        cv cfn wss wa vs cv cuni cU cpw cfn cin wcel vs cv cU cpw cfn cin wss
        vs cv cuni cU cpw cfn cin wcel vs cv cuni cU cpw wcel vs cv cuni cfn
        wcel vs cv cfn wcel vs cv cU cpw wss vs cv cfn wss wa wa vs cv cuni cU
        cpw cfn elin vs cv cU cpw wss vs cv cuni cU cpw wcel vs cv cfn wcel vs
        cv cfn wss vs cv cU cpw wss vs cv cuni cU wss vs cv cuni cU cpw wcel vs
        cv cU cpw wss vs cv cuni cU cpw cuni cU vs cv cU cpw uniss cU unipw
        syl6ss vs cv cuni cU vs cv vs visset uniex elpw sylibr ad2antrl vs cv
        cfn wcel vs cv cfn wss vs cv cuni cfn wcel vs cv cU cpw wss vs cv cfn
        wcel vx cv cfn wcel vx vs cv wral vs cv cuni cfn wcel vs cv cfn wss vx
        vs cv unifi vx vs cv cfn dfss3 sylan2b adantrl sylanbrc vs cv cU cpw
        cfn ssin sylan2br adantll 3ad2antr1 cS cX wss vu cv cuni cS wceq wa vs
        cv cfn wcel wa vs cv cU cpw cfn cin wss vy cv vw cv cuni wss vw vs cv
        wrex vy vu cv wral cS vs cv cuni cuni wss vy cv vw cv cuni wss vy vu cv
        wrex vw vs cv wral cS cX wss vu cv cuni cS wceq wa vy cv vw cv cuni wss
        vw vs cv wrex vy vu cv wral cS vs cv cuni cuni wss vs cv cfn wcel vu cv
        cuni cS wceq vy cv vw cv cuni wss vw vs cv wrex vy vu cv wral cS vs cv
        cuni cuni wss cS cX wss vy cv vw cv cuni wss vw vs cv wrex vy vu cv
        wral vu cv cuni cS wceq cS vs cv cuni cuni wss vu cv cuni cS wceq vu cv
        cuni vs cv cuni cuni wss cS vs cv cuni cuni wss vy cv vw cv cuni wss vw
        vs cv wrex vy vu cv wral vu cv cuni cS vs cv cuni cuni sseq1 vy cv vw
        cv cuni wss vw vs cv wrex vy vu cv wral vy cv vs cv cuni cuni wss vy vu
        cv wral vu cv cuni vs cv cuni cuni wss vy cv vw cv cuni wss vw vs cv
        wrex vy cv vs cv cuni cuni wss vy vu cv vy cv vw cv cuni wss vy cv vs
        cv cuni cuni wss vw vs cv vw cv vs cv wcel vw cv vs cv cuni wss vw cv
        cuni vs cv cuni cuni wss vy cv vw cv cuni wss vy cv vs cv cuni cuni wss
        wi vw cv vs cv elssuni vw cv vs cv cuni uniss vy cv vw cv cuni wss vw
        cv cuni vs cv cuni cuni wss vy cv vs cv cuni cuni wss vy cv vw cv cuni
        vs cv cuni cuni sstr expcom 3syl r19.23aiv r19.20si vy vu cv vs cv cuni
        cuni unissb sylibr syl5cbi impcom adantll adantlr 3ad2antr2 sylanc ex
        r19.23adva syl vu cv cfn wcel cU cpw cfn cin cvv wcel vy cv vw cv cuni
        wss vw cU cpw cfn cin wrex vy vu cv wral vs cv cU cpw cfn cin wss vy cv
        vw cv cuni wss vw vs cv wrex vy vu cv wral vy cv vw cv cuni wss vy vu
        cv wrex vw vs cv wral w3a vs cfn wrex cU cpw cfn cU cU cJ cJ cM copn
        cfv cvv heibor.1 cM copn fvex eqeltri heibor.11 ssexi pwex inex1 vy cv
        vw cv cuni wss vy vw vu cv cU cpw cfn cin cvv vs indexf mp3an2 syl5
        expdimp an1rs adantllr syld exp3a expimpd r19.23adva impr cR crp wcel
        vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS cS
        cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv
        wral wa vu cfn wrex vd crp wral cR crp wcel vu cv cuni cM cS cS cxp
        cres cdm cdm wceq vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt
        cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn wrex wa cR crp
        wcel vu cv cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS
        cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv
        wral wa vu cfn wrex vd crp wral vu cv cuni cM cS cS cxp cres cdm cdm
        wceq vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp
        cres cdm cdm wrex vy vu cv wral wa vu cfn wrex vu cv cuni cM cS cS cxp
        cres cdm cdm wceq vy cv vt cv vd cv cM cS cS cxp cres cbl cfv co wceq
        vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn wrex vu cv
        cuni cM cS cS cxp cres cdm cdm wceq vy cv vt cv cR cM cS cS cxp cres
        cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu
        cfn wrex vd cR crp vd cv cR wceq vu cv cuni cM cS cS cxp cres cdm cdm
        wceq vy cv vt cv vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS
        cxp cres cdm cdm wrex vy vu cv wral wa vu cv cuni cM cS cS cxp cres cdm
        cdm wceq vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS
        cxp cres cdm cdm wrex vy vu cv wral wa vu cfn vd cv cR wceq vy cv vt cv
        vd cv cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm
        wrex vy vu cv wral vy cv vt cv cR cM cS cS cxp cres cbl cfv co wceq vt
        cM cS cS cxp cres cdm cdm wrex vy vu cv wral vu cv cuni cM cS cS cxp
        cres cdm cdm wceq vd cv cR wceq vy cv vt cv vd cv cM cS cS cxp cres cbl
        cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy cv vt cv cR cM cS cS
        cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv vd
        cv cR wceq vy cv vt cv vd cv cM cS cS cxp cres cbl cfv co wceq vy cv vt
        cv cR cM cS cS cxp cres cbl cfv co wceq vt cM cS cS cxp cres cdm cdm vd
        cv cR wceq vt cv vd cv cM cS cS cxp cres cbl cfv co vt cv cR cM cS cS
        cxp cres cbl cfv co vy cv vd cv cR vt cv cM cS cS cxp cres cbl cfv
        opreq2 eqeq2d rexbidv ralbidv anbi2d rexbidv rcla4v imdistani ancoms
        sylan2 anassrs con3d expimpd ancomsd vx cv cR cM cbl cfv co cS cin vw
        cv cuni wss vw cU cpw cfn cin wrex vx cX rexnal syl6ibr cS cX wss vx cv
        cR cM cbl cfv co cS cin cD wcel vx cX wrex vx cv cR cM cbl cfv co cS
        cin vw cv cuni wss vw cU cpw cfn cin wrex wn vx cX wrex wb vu cv cuni
        cM cS cS cxp cres cdm cdm wceq vy cv vt cv vd cv cM cS cS cxp cres cbl
        cfv co wceq vt cM cS cS cxp cres cdm cdm wrex vy vu cv wral wa vu cfn
        wrex vd crp wral cS cX wss vx cv cR cM cbl cfv co cS cin cD wcel vx cv
        cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex wn vx cX
        cS cX wss vx cv cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn
        cin wrex wn vx cv cR cM cbl cfv co cS cin cX wss vx cv cR cM cbl cfv co
        cS cin vw cv cuni wss vw cU cpw cfn cin wrex wn wa vx cv cR cM cbl cfv
        co cS cin cD wcel cS cX wss vx cv cR cM cbl cfv co cS cin cX wss vx cv
        cR cM cbl cfv co cS cin vw cv cuni wss vw cU cpw cfn cin wrex wn vx cv
        cR cM cbl cfv co cS cin cS wss cS cX wss vx cv cR cM cbl cfv co cS cin
        cX wss vx cv cR cM cbl cfv co cS inss2 vx cv cR cM cbl cfv co cS cin cS
        cX sstr mpan biantrurd vw vv cD vx cv cR cM cbl cfv co cS cin cU cJ cM
        cX vs heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heiborlem20 syl6rbbr rexbidv adantr sylibrd mpdan imp anassrs
        vz vv cD cS cU cJ cM cX vs heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heiborlem20 sylanb $.
        $( [2-Sep-2009] $)

      heibor.14 $e |- B = { <. x , r >. | ( ( x e. X /\ r e. RR+ )
                                        /\ ( x ( ball ` M ) r ) e. D ) } $.

      $( Lemma for ~ heibor . The set ` B ` consists of ordered pairs of
         centers and radii of balls which have no finite subcover. $)
      heiborlem24 $p |- ( A e. B <-> ( A e. ( X X. RR+ ) /\
                                          ( ( ball ` M ) ` A ) e. D ) ) $=
        cA cB wcel cA vx cv cX wcel vr cv crp wcel wa vx cv vr cv cM cbl cfv co
        cD wcel wa vx vr copab wcel cA vx cv vr cv cop wceq vx cv cX wcel vr cv
        crp wcel wa vx cv vr cv cM cbl cfv co cD wcel wa wa vr wex vx wex cA cX
        crp cxp wcel cA cM cbl cfv cfv cD wcel wa cB vx cv cX wcel vr cv crp
        wcel wa vx cv vr cv cM cbl cfv co cD wcel wa vx vr copab cA heibor.14
        eleq2i vx cv cX wcel vr cv crp wcel wa vx cv vr cv cM cbl cfv co cD
        wcel wa vx vr cA elopab cA vx cv vr cv cop wceq vx cv cX wcel vr cv crp
        wcel wa vx cv vr cv cM cbl cfv co cD wcel wa wa vr wex vx wex cA vx cv
        vr cv cop wceq vx cv cX wcel vr cv crp wcel wa wa cA cM cbl cfv cfv cD
        wcel wa vr wex vx wex cA vx cv vr cv cop wceq vx cv cX wcel vr cv crp
        wcel wa wa vr wex vx wex cA cM cbl cfv cfv cD wcel wa cA cX crp cxp
        wcel cA cM cbl cfv cfv cD wcel wa cA vx cv vr cv cop wceq vx cv cX wcel
        vr cv crp wcel wa vx cv vr cv cM cbl cfv co cD wcel wa wa cA vx cv vr
        cv cop wceq vx cv cX wcel vr cv crp wcel wa wa cA cM cbl cfv cfv cD
        wcel wa vx vr cA vx cv vr cv cop wceq vx cv cX wcel vr cv crp wcel wa
        vx cv vr cv cM cbl cfv co cD wcel wa wa cA vx cv vr cv cop wceq vx cv
        cX wcel vr cv crp wcel wa wa vx cv vr cv cM cbl cfv co cD wcel wa cA vx
        cv vr cv cop wceq vx cv cX wcel vr cv crp wcel wa wa cA cM cbl cfv cfv
        cD wcel wa cA vx cv vr cv cop wceq vx cv cX wcel vr cv crp wcel wa vx
        cv vr cv cM cbl cfv co cD wcel anass cA vx cv vr cv cop wceq vx cv cX
        wcel vr cv crp wcel wa wa vx cv vr cv cM cbl cfv co cD wcel cA cM cbl
        cfv cfv cD wcel cA vx cv vr cv cop wceq vx cv vr cv cM cbl cfv co cD
        wcel cA cM cbl cfv cfv cD wcel wb vx cv cX wcel vr cv crp wcel wa cA vx
        cv vr cv cop wceq vx cv vr cv cM cbl cfv co cA cM cbl cfv cfv cD cA vx
        cv vr cv cop wceq cA cM cbl cfv cfv vx cv vr cv cop cM cbl cfv cfv vx
        cv vr cv cM cbl cfv co cA vx cv vr cv cop cM cbl cfv fveq2 vx cv vr cv
        cM cbl cfv df-opr syl6reqr eleq1d adantr pm5.32i bitr3i 2exbii cA vx cv
        vr cv cop wceq vx cv cX wcel vr cv crp wcel wa wa cA cM cbl cfv cfv cD
        wcel vx vr 19.41vv cA vx cv vr cv cop wceq vx cv cX wcel vr cv crp wcel
        wa wa vr wex vx wex cA cX crp cxp wcel cA cM cbl cfv cfv cD wcel cA cX
        crp cxp wcel cA vx cv vr cv cop wceq vx cv cX wcel vr cv crp wcel wa wa
        vr wex vx wex vx vr cA cX crp elxp bicomi anbi1i 3bitri 3bitri $.
        $( [2-Sep-2009] $)

      heibor.15 $e |- G = { <. <. n , a >. , h >. | ( ( n e. NN /\ a e. B ) /\
            h = { <. x , r >. | ( ( x e. X /\ r = ( 1 / ( 2 ^ n ) ) ) /\
                  ( ( x ( ball ` M ) r ) e. D /\ ( ( x ( ball ` M ) r ) i^i
                  ( ( ball ` M ) ` a ) ) =/= (/) ) ) } ) } $.

      $( Lemma for ~ heibor . The value of the function ` G ` , which takes
         a ball and a natural number and gives the set of all balls of the form
         given in ~ heiborlem22 . This is part of the setup for the use of the
        Axiom of Dependent Choice ~ acdc2 in ~ heiborlem41 . $)
      heiborlem25 $p |- ( ( N e. NN /\ Y e. B ) -> ( N G Y ) =
                  { <. x , r >. | ( ( x e. X /\ r = ( 1 / ( 2 ^ N ) ) ) /\
                  ( ( x ( ball ` M ) r ) e. D /\ ( ( x ( ball ` M ) r ) i^i
                  ( ( ball ` M ) ` Y ) ) =/= (/) ) ) } ) $=
        vn va vh cN cY cn cB vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co
        wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va
        cv cM cbl cfv cfv cin c0 wne wa wa vx vr copab vx cv cX wcel vr cv c1
        c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv
        vr cv cM cbl cfv co cY cM cbl cfv cfv cin c0 wne wa wa vx vr copab cG
        vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0
        wne wa wa vx vr copab vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq
        wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cM
        cbl cfv cfv cin c0 wne wa wa vx vr copab vx cv cX wcel vr cv c1 c2 cN
        cexp co cdiv co wceq wa vx vr copab vx vr cX c1 c2 cN cexp co cdiv co
        cX cM cdm cdm cvv heibor.2 cM cdm cM cM cms heibor.9 elisseti dmex dmex
        eqeltri opabex2 vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx
        cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cM cbl cfv
        cfv cin c0 wne wa wa vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq
        wa vx vr vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr
        cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cM cbl cfv cfv
        cin c0 wne wa pm3.26 ssopab2i ssexi vn cv cN wceq vx cv cX wcel vr cv
        c1 c2 vn cv cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel
        vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0 wne wa wa vx cv
        cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv
        co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0 wne wa
        wa vx vr vn cv cN wceq vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co
        wceq wa vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr
        cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv
        cin c0 wne wa vn cv cN wceq vr cv c1 c2 vn cv cexp co cdiv co wceq vr
        cv c1 c2 cN cexp co cdiv co wceq vx cv cX wcel vn cv cN wceq c1 c2 vn
        cv cexp co cdiv co c1 c2 cN cexp co cdiv co vr cv vn cv cN wceq c2 vn
        cv cexp co c2 cN cexp co c1 cdiv vn cv cN c2 cexp opreq2 opreq2d eqeq2d
        anbi2d anbi1d opabbidv va cv cY wceq vx cv cX wcel vr cv c1 c2 cN cexp
        co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co va cv cM cbl cfv cfv cin c0 wne wa wa vx cv cX wcel vr cv c1 c2
        cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr
        cv cM cbl cfv co cY cM cbl cfv cfv cin c0 wne wa wa vx vr va cv cY wceq
        vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM
        cbl cfv cfv cin c0 wne wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv
        cM cbl cfv co cY cM cbl cfv cfv cin c0 wne wa vx cv cX wcel vr cv c1 c2
        cN cexp co cdiv co wceq wa va cv cY wceq vx cv vr cv cM cbl cfv co va
        cv cM cbl cfv cfv cin c0 wne vx cv vr cv cM cbl cfv co cY cM cbl cfv
        cfv cin c0 wne vx cv vr cv cM cbl cfv co cD wcel va cv cY wceq vx cv vr
        cv cM cbl cfv co va cv cM cbl cfv cfv cin vx cv vr cv cM cbl cfv co cY
        cM cbl cfv cfv cin c0 va cv cY wceq va cv cM cbl cfv cfv cY cM cbl cfv
        cfv vx cv vr cv cM cbl cfv co va cv cY cM cbl cfv fveq2 ineq2d neeq1d
        anbi2d anbi2d opabbidv heibor.15 oprabval2 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The value of the function ` G ` . $)
      heiborlem26 $p |- ( ( ( N e. NN /\ Y e. X /\ R e. RR+ ) /\
                  ( Y ( ball ` M ) R ) e. D ) -> ( N G <. Y , R >. ) =
                  { <. x , r >. | ( ( x e. X /\ r = ( 1 / ( 2 ^ N ) ) ) /\
                  ( ( x ( ball ` M ) r ) e. D /\ ( ( x ( ball ` M ) r ) i^i
                  ( Y ( ball ` M ) R ) ) =/= (/) ) ) } ) $=
        cN cn wcel cY cR cop cB wcel cN cY cR cop cG co vx cv cX wcel vr cv c1
        c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv
        vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx vr copab
        wceq cN cn wcel cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD wcel
        wa vn va vh cN cY cR cop cn cB vx cv cX wcel vr cv c1 c2 vn cv cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co va cv cM cbl cfv cfv cin c0 wne wa wa vx vr copab vx cv cX wcel
        vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD
        wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx
        vr copab cG vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv
        vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv
        cfv cin c0 wne wa wa vx vr copab vx cv cX wcel vr cv c1 c2 cN cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx vr copab vx cv cX wcel
        vr cv c1 c2 cN cexp co cdiv co wceq wa vx vr copab vx vr cX c1 c2 cN
        cexp co cdiv co cX cM cdm cdm cvv heibor.2 cM cdm cM cM cms heibor.9
        elisseti dmex dmex eqeltri opabex2 vx cv cX wcel vr cv c1 c2 cN cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx cv cX wcel vr cv c1 c2
        cN cexp co cdiv co wceq wa vx vr vx cv cX wcel vr cv c1 c2 cN cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co cY cR cM cbl cfv co cin c0 wne wa pm3.26 ssopab2i ssexi vn cv cN
        wceq vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa vx cv vr
        cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv
        cin c0 wne wa wa vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa
        vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM
        cbl cfv cfv cin c0 wne wa wa vx vr vn cv cN wceq vx cv cX wcel vr cv c1
        c2 vn cv cexp co cdiv co wceq wa vx cv cX wcel vr cv c1 c2 cN cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co va cv cM cbl cfv cfv cin c0 wne wa vn cv cN wceq vr cv c1 c2 vn
        cv cexp co cdiv co wceq vr cv c1 c2 cN cexp co cdiv co wceq vx cv cX
        wcel vn cv cN wceq c1 c2 vn cv cexp co cdiv co c1 c2 cN cexp co cdiv co
        vr cv vn cv cN wceq c2 vn cv cexp co c2 cN cexp co c1 cdiv vn cv cN c2
        cexp opreq2 opreq2d eqeq2d anbi2d anbi1d opabbidv va cv cY cR cop wceq
        vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0
        wne wa wa vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr
        cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co
        cin c0 wne wa wa vx vr va cv cY cR cop wceq vx cv vr cv cM cbl cfv co
        cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0 wne wa vx
        cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl
        cfv co cin c0 wne wa vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq
        wa va cv cY cR cop wceq vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv
        cin c0 wne vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne vx
        cv vr cv cM cbl cfv co cD wcel va cv cY cR cop wceq vx cv vr cv cM cbl
        cfv co va cv cM cbl cfv cfv cin vx cv vr cv cM cbl cfv co cY cR cM cbl
        cfv co cin c0 va cv cY cR cop wceq va cv cM cbl cfv cfv cY cR cM cbl
        cfv co vx cv vr cv cM cbl cfv co va cv cY cR cop wceq va cv cM cbl cfv
        cfv cY cR cop cM cbl cfv cfv cY cR cM cbl cfv co va cv cY cR cop cM cbl
        cfv fveq2 cY cR cM cbl cfv df-opr syl6eqr ineq2d neeq1d anbi2d anbi2d
        opabbidv heibor.15 oprabval2 cN cn wcel cY cX wcel cR crp wcel w3a cN
        cn wcel cY cR cM cbl cfv co cD wcel cN cn wcel cY cX wcel cR crp wcel
        3simp1 adantr cY cX wcel cR crp wcel cY cR cM cbl cfv co cD wcel cY cR
        cop cB wcel cN cn wcel cY cR cop cX crp cxp wcel cY cR cop cM cbl cfv
        cfv cD wcel cY cR cop cB wcel cY cX wcel cR crp wcel wa cY cR cM cbl
        cfv co cD wcel cY cR cop cB wcel cY cR cop cX crp cxp wcel cY cR cop cM
        cbl cfv cfv cD wcel wa vx vv cY cR cop cB cD cU cJ cM cX vs vr heibor.1
        heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14
        heiborlem24 biimpri cY cR cX crp opelxpi cY cR cM cbl cfv co cD wcel cY
        cR cop cM cbl cfv cfv cD wcel cY cR cM cbl cfv co cY cR cop cM cbl cfv
        cfv cD cY cR cM cbl cfv df-opr eleq1i biimpi syl2an 3adantl1 sylanc $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The value of ` G ` is a subset of ` B ` . $)
      heiborlem27 $p |- ( ( ( N e. NN /\ Y e. X /\ R e. RR+ ) /\
                  ( Y ( ball ` M ) R ) e. D ) -> ( N G <. Y , R >. ) C_ B ) $=
        cN cn wcel cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD wcel wa cN
        cY cR cop cG co vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx
        cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl
        cfv co cin c0 wne wa wa vx vr copab cB vx vv cB cD cR cU vh vn cG cJ cM
        cN cX cY vs vr va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11
        heibor.12 heibor.13 heibor.14 heibor.15 heiborlem26 cN cn wcel cY cX
        wcel cR crp wcel w3a vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq
        wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM
        cbl cfv co cin c0 wne wa wa vx vr copab cB wss cY cR cM cbl cfv co cD
        wcel cN cn wcel cY cX wcel vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co
        wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY
        cR cM cbl cfv co cin c0 wne wa wa vx vr copab cB wss cR crp wcel cN cn
        wcel vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv
        cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin
        c0 wne wa wa vx vr copab vx cv cX wcel vr cv crp wcel wa vx cv vr cv cM
        cbl cfv co cD wcel wa vx vr copab cB cN cn wcel vx cv cX wcel vr cv c1
        c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv
        vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx cv cX wcel
        vr cv crp wcel wa vx cv vr cv cM cbl cfv co cD wcel wa wi vr wal vx wal
        vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne
        wa wa vx vr copab vx cv cX wcel vr cv crp wcel wa vx cv vr cv cM cbl
        cfv co cD wcel wa vx vr copab wss cN cn wcel vx cv cX wcel vr cv c1 c2
        cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr
        cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx cv cX wcel vr
        cv crp wcel wa vx cv vr cv cM cbl cfv co cD wcel wa wi vx vr cN cn wcel
        vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne
        wa wa vx cv cX wcel vr cv crp wcel wa vx cv vr cv cM cbl cfv co cD wcel
        wa cN cn wcel vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx
        cv vr cv cM cbl cfv co cD wcel vx cv cX wcel vr cv crp wcel wa vx cv vr
        cv cM cbl cfv co cD wcel wa vx cv vr cv cM cbl cfv co cY cR cM cbl cfv
        co cin c0 wne cN cn wcel vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co
        wceq wa vx cv vr cv cM cbl cfv co cD wcel wa vx cv cX wcel vr cv crp
        wcel wa vx cv vr cv cM cbl cfv co cD wcel wa cN cn wcel vx cv cX wcel
        vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv cX wcel vr cv crp wcel wa
        vx cv vr cv cM cbl cfv co cD wcel cN cn wcel vr cv c1 c2 cN cexp co
        cdiv co wceq vr cv crp wcel vx cv cX wcel cN cn wcel c2 cN cexp co crp
        wcel c1 c2 cN cexp co cdiv co crp wcel vr cv c1 c2 cN cexp co cdiv co
        wceq vr cv crp wcel wi c2 crp wcel cN cn0 wcel c2 cN cexp co crp wcel
        cN cn wcel c2 cN rpexpcl c2 2re 2pos elrpii cN nnnn0 sylancr c2 cN cexp
        co rpreccl c1 c2 cN cexp co cdiv co crp vr cv eleq1a 3syl anim2d anim1d
        imp adantrrr ex 19.21aivv vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co
        wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY
        cR cM cbl cfv co cin c0 wne wa wa vx cv cX wcel vr cv crp wcel wa vx cv
        vr cv cM cbl cfv co cD wcel wa vx vr ssopab2 sylibr heibor.14 syl6ssr
        3ad2ant1 adantr eqsstrd $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The value of ` G ` is nonempty, due to the
         existence proven in ~ heiborlem23 . $)
      heiborlem28 $p |- ( ( ( N e. NN /\ Y e. X /\ R e. RR+ ) /\
                ( Y ( ball ` M ) R ) e. D ) -> ( N G <. Y , R >. ) =/= (/) ) $=
        cN cn wcel cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD wcel wa vy
        cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD
        wcel vy cX wrex cN cY cR cop cG co c0 wne cY cR cM cbl cfv co cD wcel
        c1 c2 cN cexp co cdiv co crp wcel vy cv c1 c2 cN cexp co cdiv co cM cbl
        cfv co cY cR cM cbl cfv co cin cD wcel vy cX wrex cN cn wcel cY cX wcel
        cR crp wcel w3a cY cR cM cbl cfv co cD wcel wa vy vv cD c1 c2 cN cexp
        co cdiv co cY cR cM cbl cfv co cU cJ cM cX vs heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heiborlem23 cN cn wcel
        cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD wcel pm3.27 cN cn
        wcel cY cX wcel cR crp wcel w3a c1 c2 cN cexp co cdiv co crp wcel cY cR
        cM cbl cfv co cD wcel cN cn wcel cY cX wcel c1 c2 cN cexp co cdiv co
        crp wcel cR crp wcel cN cn wcel cN cn0 wcel c2 cN cexp co crp wcel c1
        c2 cN cexp co cdiv co crp wcel cN nnnn0 c2 crp wcel cN cn0 wcel c2 cN
        cexp co crp wcel c2 2re 2pos elrpii c2 cN rpexpcl mpan c2 cN cexp co
        rpreccl 3syl 3ad2ant1 adantr sylanc cN cn wcel cY cX wcel cR crp wcel
        w3a cY cR cM cbl cfv co cD wcel wa vy cv c1 c2 cN cexp co cdiv co cM
        cbl cfv co cY cR cM cbl cfv co cin cD wcel cN cY cR cop cG co c0 wne vy
        cX cN cn wcel cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD wcel wa
        vy cv cX wcel wa vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM
        cbl cfv co cin cD wcel vy cv c1 c2 cN cexp co cdiv co cop cN cY cR cop
        cG co wcel cN cY cR cop cG co c0 wne cN cn wcel cY cX wcel cR crp wcel
        w3a cY cR cM cbl cfv co cD wcel wa vy cv cX wcel vy cv c1 c2 cN cexp co
        cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy cv c1 c2 cN
        cexp co cdiv co cop cN cY cR cop cG co wcel cN cn wcel cY cX wcel cR
        crp wcel w3a cY cR cM cbl cfv co cD wcel wa vy cv cX wcel vy cv c1 c2
        cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel wa cN
        cY cR cop cG co vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx
        cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl
        cfv co cin c0 wne wa wa vx vr copab wceq vy cv c1 c2 cN cexp co cdiv co
        cop cN cY cR cop cG co wcel vx vv cB cD cR cU vh vn cG cJ cM cN cX cY
        vs vr va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heibor.15 heiborlem26 cN cn wcel cY cX wcel cR crp
        wcel w3a cY cR cM cbl cfv co cD wcel wa vy cv cX wcel vy cv c1 c2 cN
        cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel wa vy cv
        c1 c2 cN cexp co cdiv co cop vx cv cX wcel vr cv c1 c2 cN cexp co cdiv
        co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co
        cY cR cM cbl cfv co cin c0 wne wa wa vx vr copab wcel cN cY cR cop cG
        co vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM
        cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0
        wne wa wa vx vr copab wceq vy cv c1 c2 cN cexp co cdiv co cop cN cY cR
        cop cG co wcel wi cN cn wcel cY cX wcel cR crp wcel w3a cY cR cM cbl
        cfv co cD wcel wa vy cv cX wcel vy cv c1 c2 cN cexp co cdiv co cM cbl
        cfv co cY cR cM cbl cfv co cin cD wcel wa vy cv cX wcel vy cv c1 c2 cN
        cexp co cdiv co cM cbl cfv co cD wcel vy cv c1 c2 cN cexp co cdiv co cM
        cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wa vy cv c1 c2 cN cexp co
        cdiv co cop vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv
        vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv
        co cin c0 wne wa wa vx vr copab wcel cN cn wcel cY cX wcel cR crp wcel
        w3a cY cR cM cbl cfv co cD wcel wa vy cv cX wcel vy cv c1 c2 cN cexp co
        cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy cv c1 c2 cN
        cexp co cdiv co cM cbl cfv co cD wcel vy cv c1 c2 cN cexp co cdiv co cM
        cbl cfv co cY cR cM cbl cfv co cin c0 wne wa cN cn wcel cY cX wcel cR
        crp wcel w3a cY cR cM cbl cfv co cD wcel wa vy cv cX wcel vy cv c1 c2
        cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy cv
        c1 c2 cN cexp co cdiv co cM cbl cfv co cD wcel vy cv c1 c2 cN cexp co
        cdiv co cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wi cN cn wcel
        cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD wcel wa vy cv cX wcel
        wa vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin
        cD wcel vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cD wcel vy cv c1
        c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin c0 wne cN
        cn wcel cY cX wcel cR crp wcel w3a vy cv cX wcel vy cv c1 c2 cN cexp co
        cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy cv c1 c2 cN
        cexp co cdiv co cM cbl cfv co cD wcel wi cY cR cM cbl cfv co cD wcel cN
        cn wcel cY cX wcel vy cv cX wcel vy cv c1 c2 cN cexp co cdiv co cM cbl
        cfv co cY cR cM cbl cfv co cin cD wcel vy cv c1 c2 cN cexp co cdiv co
        cM cbl cfv co cD wcel wi cR crp wcel cN cn wcel vy cv cX wcel wa vy cv
        c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel
        vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cD wcel vy cv c1 c2 cN
        cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy cv c1
        c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin vy cv c1 c2
        cN cexp co cdiv co cM cbl cfv co wss vy cv c1 c2 cN cexp co cdiv co cM
        cbl cfv co cX wss vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cD wcel
        cN cn wcel vy cv cX wcel wa vy cv c1 c2 cN cexp co cdiv co cM cbl cfv
        co cY cR cM cbl cfv co cin cD wcel wa vv vy cv c1 c2 cN cexp co cdiv co
        cM cbl cfv co cY cR cM cbl cfv co cin cD vy cv c1 c2 cN cexp co cdiv co
        cM cbl cfv co cU cJ cM cX vs heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heiborlem22 cN cn wcel vy cv cX wcel wa
        vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD
        wcel pm3.27 vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl
        cfv co cin vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co wss cN cn wcel
        vy cv cX wcel wa vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM
        cbl cfv co cin cD wcel wa vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co
        cY cR cM cbl cfv co inss1 a1i cN cn wcel vy cv cX wcel wa vy cv c1 c2
        cN cexp co cdiv co cM cbl cfv co cX wss vy cv c1 c2 cN cexp co cdiv co
        cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy cv cX wcel cN cn wcel
        vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cX wss cM cme wcel vy cv
        cX wcel wa c1 c2 cN cexp co cdiv co cr wcel cc0 c1 c2 cN cexp co cdiv
        co clt wbr wa vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cX wss vy cv
        cX wcel cN cn wcel cM vy cv c1 c2 cN cexp co cdiv co cX heibor.2 blssm
        vy cv cX wcel cM cme wcel cM heibor.9 cmsmeti jctl cN cn wcel c2 cN
        cexp co crp wcel c1 c2 cN cexp co cdiv co crp wcel c1 c2 cN cexp co
        cdiv co cr wcel cc0 c1 c2 cN cexp co cdiv co clt wbr wa c2 crp wcel cN
        cn0 wcel c2 cN cexp co crp wcel cN cn wcel c2 cN rpexpcl c2 2re 2pos
        elrpii cN nnnn0 sylancr c2 cN cexp co rpreccl c1 c2 cN cexp co cdiv co
        rpregt0 3syl syl2an ancoms adantr syl3anc ex 3ad2antl1 adantlr vy cv c1
        c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin cD wcel vy
        cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin c0
        wne wi cN cn wcel cY cX wcel cR crp wcel w3a cY cR cM cbl cfv co cD
        wcel wa vy cv cX wcel wa vv cD vy cv c1 c2 cN cexp co cdiv co cM cbl
        cfv co cY cR cM cbl cfv co cin cU cJ cM cX vs heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heiborlem21 a1i jcad
        ex imdistand vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv
        vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv
        co cin c0 wne wa wa vy cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq
        wa vy cv vr cv cM cbl cfv co cD wcel vy cv vr cv cM cbl cfv co cY cR cM
        cbl cfv co cin c0 wne wa wa vy cv cX wcel vy cv c1 c2 cN cexp co cdiv
        co cM cbl cfv co cD wcel vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co
        cY cR cM cbl cfv co cin c0 wne wa wa vx vr vy cv c1 c2 cN cexp co cdiv
        co vy visset c1 c2 cN cexp co cdiv oprex vx cv vy cv wceq vx cv cX wcel
        vr cv c1 c2 cN cexp co cdiv co wceq wa vy cv cX wcel vr cv c1 c2 cN
        cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv
        cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa vy cv vr cv cM cbl cfv
        co cD wcel vy cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa
        vx cv vy cv wceq vx cv cX wcel vy cv cX wcel vr cv c1 c2 cN cexp co
        cdiv co wceq vx cv vy cv cX eleq1 anbi1d vx cv vy cv wceq vx cv vr cv
        cM cbl cfv co cD wcel vy cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM
        cbl cfv co cY cR cM cbl cfv co cin c0 wne vy cv vr cv cM cbl cfv co cY
        cR cM cbl cfv co cin c0 wne vx cv vy cv wceq vx cv vr cv cM cbl cfv co
        vy cv vr cv cM cbl cfv co cD vx cv vy cv vr cv cM cbl cfv opreq1 eleq1d
        vx cv vy cv wceq vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin vy
        cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 vx cv vy cv wceq vx
        cv vr cv cM cbl cfv co vy cv vr cv cM cbl cfv co cY cR cM cbl cfv co vx
        cv vy cv vr cv cM cbl cfv opreq1 ineq1d neeq1d anbi12d anbi12d vr cv c1
        c2 cN cexp co cdiv co wceq vy cv cX wcel vr cv c1 c2 cN cexp co cdiv co
        wceq wa vy cv cX wcel vy cv vr cv cM cbl cfv co cD wcel vy cv vr cv cM
        cbl cfv co cY cR cM cbl cfv co cin c0 wne wa vy cv c1 c2 cN cexp co
        cdiv co cM cbl cfv co cD wcel vy cv c1 c2 cN cexp co cdiv co cM cbl cfv
        co cY cR cM cbl cfv co cin c0 wne wa vr cv c1 c2 cN cexp co cdiv co
        wceq vy cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vy cv cX wcel
        vy cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq pm3.26 vr cv c1 c2 cN
        cexp co cdiv co wceq vy cv cX wcel pm3.21 impbid2 vr cv c1 c2 cN cexp
        co cdiv co wceq vy cv vr cv cM cbl cfv co cD wcel vy cv c1 c2 cN cexp
        co cdiv co cM cbl cfv co cD wcel vy cv vr cv cM cbl cfv co cY cR cM cbl
        cfv co cin c0 wne vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM
        cbl cfv co cin c0 wne vr cv c1 c2 cN cexp co cdiv co wceq vy cv vr cv
        cM cbl cfv co vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cD vr cv c1
        c2 cN cexp co cdiv co vy cv cM cbl cfv opreq2 eleq1d vr cv c1 c2 cN
        cexp co cdiv co wceq vy cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin
        vy cv c1 c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co cin c0
        vr cv c1 c2 cN cexp co cdiv co wceq vy cv vr cv cM cbl cfv co vy cv c1
        c2 cN cexp co cdiv co cM cbl cfv co cY cR cM cbl cfv co vr cv c1 c2 cN
        cexp co cdiv co vy cv cM cbl cfv opreq2 ineq1d neeq1d anbi12d anbi12d
        opelopab syl6ibr cN cY cR cop cG co vx cv cX wcel vr cv c1 c2 cN cexp
        co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co cY cR cM cbl cfv co cin c0 wne wa wa vx vr copab wceq vy cv c1
        c2 cN cexp co cdiv co cop cN cY cR cop cG co wcel vy cv c1 c2 cN cexp
        co cdiv co cop vx cv cX wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx
        cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl
        cfv co cin c0 wne wa wa vx vr copab wcel cN cY cR cop cG co vx cv cX
        wcel vr cv c1 c2 cN cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co
        cD wcel vx cv vr cv cM cbl cfv co cY cR cM cbl cfv co cin c0 wne wa wa
        vx vr copab vy cv c1 c2 cN cexp co cdiv co cop eleq2 biimprcd syl6 mpid
        expdimp cN cY cR cop cG co vy cv c1 c2 cN cexp co cdiv co cop ne0i syl6
        r19.23adva mpd $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Property of ` G ` required for the application of
         ~ acdc2 . $)
      heiborlem29 $p |- G : ( NN X. B ) --> ( ~P B \ { (/) } ) $=
        cn cB cxp cB cpw c0 csn cdif cG wf cG cn cB cxp wfn cG crn cB cpw c0
        csn cdif wss cn cB cxp cB cpw c0 csn cdif cG df-f vn va vh cn cB vx cv
        cX wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0
        wne wa wa vx vr copab cG vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv
        co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co
        va cv cM cbl cfv cfv cin c0 wne wa wa vx vr copab vx cv cX wcel vr cv
        c1 c2 vn cv cexp co cdiv co wceq wa vx vr copab vx vr cX c1 c2 vn cv
        cexp co cdiv co cX cM cdm cdm cvv heibor.2 cM cdm cM cM cms heibor.9
        elisseti dmex dmex eqeltri opabex2 vx cv cX wcel vr cv c1 c2 vn cv cexp
        co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co va cv cM cbl cfv cfv cin c0 wne wa wa vx cv cX wcel vr cv c1 c2
        vn cv cexp co cdiv co wceq wa vx vr vx cv cX wcel vr cv c1 c2 vn cv
        cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv
        cM cbl cfv co va cv cM cbl cfv cfv cin c0 wne wa pm3.26 ssopab2i ssexi
        heibor.15 fnoprab2 vy cG crn cB cpw c0 csn cdif vy cv cG crn wcel vu cv
        vz cv cG co vy cv wceq vz cB wrex vu cn wrex vy cv cB cpw c0 csn cdif
        wcel cG cn cB cxp wfn vy cv cG crn wcel vu cv vz cv cG co vy cv wceq vz
        cB wrex vu cn wrex wb vn va vh cn cB vx cv cX wcel vr cv c1 c2 vn cv
        cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv
        cM cbl cfv co va cv cM cbl cfv cfv cin c0 wne wa wa vx vr copab cG vx
        cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv cfv cin c0
        wne wa wa vx vr copab vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co
        wceq wa vx vr copab vx vr cX c1 c2 vn cv cexp co cdiv co cX cM cdm cdm
        cvv heibor.2 cM cdm cM cM cms heibor.9 elisseti dmex dmex eqeltri
        opabex2 vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa vx cv
        vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM cbl cfv
        cfv cin c0 wne wa wa vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co
        wceq wa vx vr vx cv cX wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa
        vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co va cv cM
        cbl cfv cfv cin c0 wne wa pm3.26 ssopab2i ssexi heibor.15 fnoprab2 vu
        vz cn cB vy cv cG oprvelrn ax-mp vu cv vz cv cG co vy cv wceq vy cv cB
        cpw c0 csn cdif wcel vu vz cn cB vu cv cn wcel vz cv vw cv vt cv cop
        wceq vw cv vt cv cM cbl cfv co cD wcel wa vt crp wrex vw cX wrex vu cv
        vz cv cG co vy cv wceq vy cv cB cpw c0 csn cdif wcel wi vz cv cB wcel
        vu cv cn wcel vz cv vw cv vt cv cop wceq vw cv vt cv cM cbl cfv co cD
        wcel wa vt crp wrex vw cX wrex vu cv vz cv cG co vy cv wceq vy cv cB
        cpw c0 csn cdif wcel wi vu cv cn wcel vz cv vw cv vt cv cop wceq vw cv
        vt cv cM cbl cfv co cD wcel wa vu cv vz cv cG co vy cv wceq vy cv cB
        cpw c0 csn cdif wcel wi vw vt cX crp vu cv cn wcel vw cv cX wcel vt cv
        crp wcel vz cv vw cv vt cv cop wceq vw cv vt cv cM cbl cfv co cD wcel
        wa vu cv vz cv cG co vy cv wceq vy cv cB cpw c0 csn cdif wcel wi wi vu
        cv cn wcel vw cv cX wcel vt cv crp wcel w3a vw cv vt cv cM cbl cfv co
        cD wcel vz cv vw cv vt cv cop wceq vu cv vz cv cG co vy cv wceq vy cv
        cB cpw c0 csn cdif wcel wi vu cv cn wcel vw cv cX wcel vt cv crp wcel
        w3a vw cv vt cv cM cbl cfv co cD wcel vz cv vw cv vt cv cop wceq vu cv
        vz cv cG co vy cv wceq vy cv cB cpw c0 csn cdif wcel wi vu cv cn wcel
        vw cv cX wcel vt cv crp wcel w3a vw cv vt cv cM cbl cfv co cD wcel wa
        vz cv vw cv vt cv cop wceq vu cv vz cv cG co cB cpw c0 csn cdif wcel vu
        cv vz cv cG co vy cv wceq vy cv cB cpw c0 csn cdif wcel wi vz cv vw cv
        vt cv cop wceq vu cv vz cv cG co cB cpw c0 csn cdif wcel vu cv vw cv vt
        cv cop cG co cB cpw c0 csn cdif wcel vu cv cn wcel vw cv cX wcel vt cv
        crp wcel w3a vw cv vt cv cM cbl cfv co cD wcel wa vz cv vw cv vt cv cop
        wceq vu cv vz cv cG co vu cv vw cv vt cv cop cG co cB cpw c0 csn cdif
        vz cv vw cv vt cv cop vu cv cG opreq2 eleq1d vu cv vw cv vt cv cop cG
        co cB cpw c0 csn cdif wcel vu cv vw cv vt cv cop cG co cB cpw wcel vu
        cv vw cv vt cv cop cG co c0 wne vu cv cn wcel vw cv cX wcel vt cv crp
        wcel w3a vw cv vt cv cM cbl cfv co cD wcel wa vu cv vw cv vt cv cop cG
        co cB cpw c0 eldifsn vu cv cn wcel vw cv cX wcel vt cv crp wcel w3a vw
        cv vt cv cM cbl cfv co cD wcel wa vu cv vw cv vt cv cop cG co cB wss vu
        cv vw cv vt cv cop cG co cB cpw wcel vx vv cB cD vt cv cU vh vn cG cJ
        cM vu cv cX vw cv vs vr va heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heibor.14 heibor.15 heiborlem27 vu cv vw
        cv vt cv cop cG co cB vu cv vw cv vt cv cop cG oprex elpw sylibr vx vv
        cB cD vt cv cU vh vn cG cJ cM vu cv cX vw cv vs vr va heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heibor.15
        heiborlem28 sylanbrc syl5cbir vu cv vz cv cG co vy cv wceq vu cv vz cv
        cG co cB cpw c0 csn cdif wcel vy cv cB cpw c0 csn cdif wcel vu cv vz cv
        cG co vy cv cB cpw c0 csn cdif eleq1 biimpcd syl6 expimpd ancomsd
        3expib r19.23advv imp vz cv cB wcel vz cv cX crp cxp wcel vz cv cM cbl
        cfv cfv cD wcel wa vz cv vw cv vt cv cop wceq vw cv vt cv cM cbl cfv co
        cD wcel wa vt crp wrex vw cX wrex vx vv vz cv cB cD cU cJ cM cX vs vr
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heiborlem24 vz cv vw cv vt cv cop wceq vt crp wrex vw cX wrex
        vz cv cM cbl cfv cfv cD wcel vz cv vw cv vt cv cop wceq vw cv vt cv cM
        cbl cfv co cD wcel wa vt crp wrex vw cX wrex vz cv cX crp cxp wcel vz
        cv vw cv vt cv cop wceq vw cv vt cv cM cbl cfv co cD wcel wa vt crp
        wrex vw cX wrex vz cv vw cv vt cv cop wceq vt crp wrex vw cX wrex vz cv
        cM cbl cfv cfv cD wcel wa vz cv vw cv vt cv cop wceq vw cv vt cv cM cbl
        cfv co cD wcel wa vt crp wrex vw cX wrex vz cv vw cv vt cv cop wceq vz
        cv cM cbl cfv cfv cD wcel wa vt crp wrex vw cX wrex vz cv vw cv vt cv
        cop wceq vt crp wrex vz cv cM cbl cfv cfv cD wcel wa vw cX wrex vz cv
        vw cv vt cv cop wceq vt crp wrex vw cX wrex vz cv cM cbl cfv cfv cD
        wcel wa vz cv vw cv vt cv cop wceq vw cv vt cv cM cbl cfv co cD wcel wa
        vz cv vw cv vt cv cop wceq vz cv cM cbl cfv cfv cD wcel wa vw vt cX crp
        vz cv vw cv vt cv cop wceq vw cv vt cv cM cbl cfv co cD wcel vz cv cM
        cbl cfv cfv cD wcel vz cv vw cv vt cv cop wceq vz cv cM cbl cfv cfv cD
        wcel vw cv vt cv cop cM cbl cfv cfv cD wcel vw cv vt cv cM cbl cfv co
        cD wcel vz cv vw cv vt cv cop wceq vz cv cM cbl cfv cfv vw cv vt cv cop
        cM cbl cfv cfv cD vz cv vw cv vt cv cop cM cbl cfv fveq2 eleq1d vw cv
        vt cv cM cbl cfv co vw cv vt cv cop cM cbl cfv cfv cD vw cv vt cv cM
        cbl cfv df-opr eleq1i syl6rbbr pm5.32i 2rexbii vz cv vw cv vt cv cop
        wceq vz cv cM cbl cfv cfv cD wcel wa vt crp wrex vz cv vw cv vt cv cop
        wceq vt crp wrex vz cv cM cbl cfv cfv cD wcel wa vw cX vz cv vw cv vt
        cv cop wceq vz cv cM cbl cfv cfv cD wcel vt crp r19.41v rexbii vz cv vw
        cv vt cv cop wceq vt crp wrex vz cv cM cbl cfv cfv cD wcel vw cX
        r19.41v 3bitri biimpri vw vt vz cv cX crp elxp2 sylanb sylbi sylan2
        r19.23aivv sylbi ssriv mpbir2an $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The first in a series of lemmas giving properties
         of the function ` H ` which will be constructed by ~ acdc2 . ` H ` is
         a sequence of balls with radii in a decreasing geometric
         progression. $)
      heiborlem30 $p |- ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
              ( ( g + 1 ) G ( H ` g ) ) ) -> A. k e. ( ZZ>= ` 2 )
                          ( ( 1st ` ( H ` k ) ) e. X /\
                    ( 2nd ` ( H ` k ) ) = ( 1 / ( 2 ^ k ) ) ) ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd
        cfv c1 c2 vk cv cexp co cdiv co wceq wa vk c2 cuz cfv cn cB cH wf vg cv
        c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        wa vk cv c2 cuz cfv wcel wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv c1st cfv vk
        cv cH cfv c2nd cfv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vk cv cH
        cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin
        c0 wne wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv
        cH cfv cG co wcel vg cn wral vk cv c2 cuz cfv wcel vk cv cH cfv c1st
        cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa
        vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co cD wcel vk cv
        cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH
        cfv cM cbl cfv cfv cin c0 wne wa wa cn cB cH wf vk cv c1 cmin co c1
        caddc co cH cfv vk cv c1 cmin co c1 caddc co vk cv c1 cmin co cH cfv cG
        co wcel vk cv c2 cuz cfv wcel wa vk cv cH cfv c1st cfv cX wcel vk cv cH
        cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv c1st cfv
        vk cv cH cfv c2nd cfv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vk cv
        cH cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv
        cin c0 wne wa wa vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral vk cv c2 cuz cfv wcel wa cn cB cH wf vk cv cH
        cfv vk cv vk cv c1 cmin co cH cfv cG co wcel vk cv c2 cuz cfv wcel wa
        vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co
        cdiv co wceq wa vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv
        co cD wcel vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk
        cv c1 cmin co cH cfv cM cbl cfv cfv cin c0 wne wa wa vk cv c1 cmin co
        c1 caddc co cH cfv vk cv c1 cmin co c1 caddc co vk cv c1 cmin co cH cfv
        cG co wcel vk cv c2 cuz cfv wcel wa cn cB cH wf vk cv c2 cuz cfv wcel
        vk cv cH cfv vk cv vk cv c1 cmin co cH cfv cG co wcel vk cv cH cfv c1st
        cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa
        vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co cD wcel vk cv
        cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH
        cfv cM cbl cfv cfv cin c0 wne wa wa cn cB cH wf vk cv c2 cuz cfv wcel
        vk cv cH cfv vk cv vk cv c1 cmin co cH cfv cG co wcel vk cv cH cfv c1st
        cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa
        vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co cD wcel vk cv
        cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH
        cfv cM cbl cfv cfv cin c0 wne wa wa vk cv cn wcel vk cv c1 cmin co cH
        cfv cB wcel wa vk cv cH cfv vk cv vk cv c1 cmin co cH cfv cG co wcel vk
        cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co
        cdiv co wceq wa vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv
        co cD wcel vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk
        cv c1 cmin co cH cfv cM cbl cfv cfv cin c0 wne wa wa cn cB cH wf vk cv
        c2 cuz cfv wcel wa vk cv vk cv c1 cmin co cH cfv cG co vx cv cX wcel vr
        cv c1 c2 vk cv cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD
        wcel vx cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv
        cin c0 wne wa wa vx vr copab wceq vk cv cH cfv vk cv vk cv c1 cmin co
        cH cfv cG co wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv
        c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv c1st cfv vk cv cH cfv
        c2nd cfv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vk cv cH cfv c2nd
        cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin c0 wne wa
        wa vk cv cn wcel vk cv c1 cmin co cH cfv cB wcel wa vk cv vk cv c1 cmin
        co cH cfv cG co vx cv cX wcel vr cv c1 c2 vk cv cexp co cdiv co wceq wa
        vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co vk cv c1
        cmin co cH cfv cM cbl cfv cfv cin c0 wne wa wa vx vr copab wceq vk cv
        cH cfv vk cv vk cv c1 cmin co cH cfv cG co wcel wa vk cv cH cfv vx cv
        cX wcel vr cv c1 c2 vk cv cexp co cdiv co wceq wa vx cv vr cv cM cbl
        cfv co cD wcel vx cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl
        cfv cfv cin c0 wne wa wa vx vr copab wcel vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv
        c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co cD wcel vk cv cH cfv c1st
        cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl
        cfv cfv cin c0 wne wa wa vk cv vk cv c1 cmin co cH cfv cG co vx cv cX
        wcel vr cv c1 c2 vk cv cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv
        co cD wcel vx cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv
        cfv cin c0 wne wa wa vx vr copab wceq vk cv cH cfv vk cv vk cv c1 cmin
        co cH cfv cG co wcel vk cv cH cfv vx cv cX wcel vr cv c1 c2 vk cv cexp
        co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin c0 wne wa wa vx vr
        copab wcel vk cv vk cv c1 cmin co cH cfv cG co vx cv cX wcel vr cv c1
        c2 vk cv cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx
        cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin c0
        wne wa wa vx vr copab vk cv cH cfv eleq2 biimpa vx cv cX wcel vr cv c1
        c2 vk cv cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx
        cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin c0
        wne wa wa vk cv cH cfv c1st cfv cX wcel vr cv c1 c2 vk cv cexp co cdiv
        co wceq wa vk cv cH cfv c1st cfv vr cv cM cbl cfv co cD wcel vk cv cH
        cfv c1st cfv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv
        cin c0 wne wa wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1
        c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv c1st cfv vk cv cH cfv
        c2nd cfv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vk cv cH cfv c2nd
        cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin c0 wne wa
        wa vx vr vk cv cH cfv vx cv vk cv cH cfv c1st cfv wceq vx cv cX wcel vr
        cv c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv c1st cfv cX wcel vr
        cv c1 c2 vk cv cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD
        wcel vx cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv
        cin c0 wne wa vk cv cH cfv c1st cfv vr cv cM cbl cfv co cD wcel vk cv
        cH cfv c1st cfv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv
        cfv cin c0 wne wa vx cv vk cv cH cfv c1st cfv wceq vx cv cX wcel vk cv
        cH cfv c1st cfv cX wcel vr cv c1 c2 vk cv cexp co cdiv co wceq vx cv vk
        cv cH cfv c1st cfv cX eleq1 anbi1d vx cv vk cv cH cfv c1st cfv wceq vx
        cv vr cv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vr cv cM cbl cfv
        co cD wcel vx cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv
        cfv cin c0 wne vk cv cH cfv c1st cfv vr cv cM cbl cfv co vk cv c1 cmin
        co cH cfv cM cbl cfv cfv cin c0 wne vx cv vk cv cH cfv c1st cfv wceq vx
        cv vr cv cM cbl cfv co vk cv cH cfv c1st cfv vr cv cM cbl cfv co cD vx
        cv vk cv cH cfv c1st cfv vr cv cM cbl cfv opreq1 eleq1d vx cv vk cv cH
        cfv c1st cfv wceq vx cv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv cM
        cbl cfv cfv cin vk cv cH cfv c1st cfv vr cv cM cbl cfv co vk cv c1 cmin
        co cH cfv cM cbl cfv cfv cin c0 vx cv vk cv cH cfv c1st cfv wceq vx cv
        vr cv cM cbl cfv co vk cv cH cfv c1st cfv vr cv cM cbl cfv co vk cv c1
        cmin co cH cfv cM cbl cfv cfv vx cv vk cv cH cfv c1st cfv vr cv cM cbl
        cfv opreq1 ineq1d neeq1d anbi12d anbi12d vr cv vk cv cH cfv c2nd cfv
        wceq vk cv cH cfv c1st cfv cX wcel vr cv c1 c2 vk cv cexp co cdiv co
        wceq wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv
        cexp co cdiv co wceq wa vk cv cH cfv c1st cfv vr cv cM cbl cfv co cD
        wcel vk cv cH cfv c1st cfv vr cv cM cbl cfv co vk cv c1 cmin co cH cfv
        cM cbl cfv cfv cin c0 wne wa vk cv cH cfv c1st cfv vk cv cH cfv c2nd
        cfv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv
        cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin c0 wne wa vr
        cv vk cv cH cfv c2nd cfv wceq vr cv c1 c2 vk cv cexp co cdiv co wceq vk
        cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq vk cv cH cfv c1st
        cfv cX wcel vr cv vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co
        eqeq1 anbi2d vr cv vk cv cH cfv c2nd cfv wceq vk cv cH cfv c1st cfv vr
        cv cM cbl cfv co cD wcel vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM
        cbl cfv co cD wcel vk cv cH cfv c1st cfv vr cv cM cbl cfv co vk cv c1
        cmin co cH cfv cM cbl cfv cfv cin c0 wne vk cv cH cfv c1st cfv vk cv cH
        cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin
        c0 wne vr cv vk cv cH cfv c2nd cfv wceq vk cv cH cfv c1st cfv vr cv cM
        cbl cfv co vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv co cD
        vr cv vk cv cH cfv c2nd cfv vk cv cH cfv c1st cfv cM cbl cfv opreq2
        eleq1d vr cv vk cv cH cfv c2nd cfv wceq vk cv cH cfv c1st cfv vr cv cM
        cbl cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv cin vk cv cH cfv c1st
        cfv vk cv cH cfv c2nd cfv cM cbl cfv co vk cv c1 cmin co cH cfv cM cbl
        cfv cfv cin c0 vr cv vk cv cH cfv c2nd cfv wceq vk cv cH cfv c1st cfv
        vr cv cM cbl cfv co vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl
        cfv co vk cv c1 cmin co cH cfv cM cbl cfv cfv vr cv vk cv cH cfv c2nd
        cfv vk cv cH cfv c1st cfv cM cbl cfv opreq2 ineq1d neeq1d anbi12d
        anbi12d elopabi syl vx vv cB cD cU vh vn cG cJ cM vk cv cX vk cv c1
        cmin co cH cfv vs vr va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11
        heibor.12 heibor.13 heibor.14 heibor.15 heiborlem25 sylan cn cB cH wf
        vk cv c2 cuz cfv wcel wa vk cv cn wcel vk cv c1 cmin co cH cfv cB wcel
        vk cv c2 cuz cfv wcel vk cv cn wcel cn cB cH wf vk cv c2 cuz cfv wcel
        vk cv c1 cuz cfv wcel vk cv cn wcel c2 cuz cfv c1 cuz cfv vk cv c2 c1
        cuz cfv wcel c2 cuz cfv c1 cuz cfv wss c2 c1 cuz cfv wcel c1 c2 cle wbr
        c1 c2 1re 2re 1lt2 ltleii c1 cz wcel c2 cz wcel c2 c1 cuz cfv wcel c1
        c2 cle wbr wb 1z 2z c1 c2 eluz mp2an mpbir c1 c2 uzss ax-mp sseli vk cv
        elnnuz sylibr adantl cn cB cH wf vk cv c1 cmin co cn wcel vk cv c1 cmin
        co cH cfv cB wcel vk cv c2 cuz cfv wcel cn cB vk cv c1 cmin co cH
        ffvelrn vk cv c1 c1 caddc co cuz cfv wcel vk cv c1 cmin co c1 cuz cfv
        wcel vk cv c2 cuz cfv wcel vk cv c1 cmin co cn wcel c1 c1 vk cv 1z 1z
        eluzsubi c2 cuz cfv c1 c1 caddc co cuz cfv vk cv c2 c1 c1 caddc co cuz
        df-2 fveq2i eleq2i vk cv c1 cmin co elnnuz 3imtr4i sylan2 jca sylan
        anasss ancom2s vk cv c2 cuz cfv wcel vk cv c1 cmin co c1 caddc co cH
        cfv vk cv c1 cmin co c1 caddc co vk cv c1 cmin co cH cfv cG co wcel vk
        cv cH cfv vk cv vk cv c1 cmin co cH cfv cG co wcel vk cv c2 cuz cfv
        wcel vk cv c1 cmin co c1 caddc co cH cfv vk cv c1 cmin co c1 caddc co
        vk cv c1 cmin co cH cfv cG co wcel vk cv cH cfv vk cv vk cv c1 cmin co
        cH cfv cG co wcel vk cv c2 cuz cfv wcel vk cv c1 cmin co c1 caddc co cH
        cfv vk cv cH cfv vk cv c1 cmin co c1 caddc co vk cv c1 cmin co cH cfv
        cG co vk cv vk cv c1 cmin co cH cfv cG co vk cv c2 cuz cfv wcel vk cv
        c1 cmin co c1 caddc co vk cv cH vk cv c2 cuz cfv wcel vk cv cz wcel vk
        cv cc wcel vk cv c1 cmin co c1 caddc co vk cv wceq c2 vk cv eluzelz vk
        cv zcn vk cv cc wcel c1 cc wcel vk cv c1 cmin co c1 caddc co vk cv wceq
        ax1cn vk cv c1 npcan mpan2 3syl fveq2d vk cv c2 cuz cfv wcel vk cv c1
        cmin co c1 caddc co vk cv vk cv c1 cmin co cH cfv cG vk cv c2 cuz cfv
        wcel vk cv cz wcel vk cv cc wcel vk cv c1 cmin co c1 caddc co vk cv
        wceq c2 vk cv eluzelz vk cv zcn vk cv cc wcel c1 cc wcel vk cv c1 cmin
        co c1 caddc co vk cv wceq ax1cn vk cv c1 npcan mpan2 3syl opreq1d
        eleq12d biimpd imdistanri sylan2 vk cv c2 cuz cfv wcel vg cv c1 caddc
        co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral vk cv c1
        cmin co c1 caddc co cH cfv vk cv c1 cmin co c1 caddc co vk cv c1 cmin
        co cH cfv cG co wcel vk cv c2 cuz cfv wcel vk cv c1 cmin co cn wcel vg
        cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn
        wral vk cv c1 cmin co c1 caddc co cH cfv vk cv c1 cmin co c1 caddc co
        vk cv c1 cmin co cH cfv cG co wcel wi vk cv c1 c1 caddc co cuz cfv wcel
        vk cv c1 cmin co c1 cuz cfv wcel vk cv c2 cuz cfv wcel vk cv c1 cmin co
        cn wcel c1 c1 vk cv 1z 1z eluzsubi c2 cuz cfv c1 c1 caddc co cuz cfv vk
        cv c2 c1 c1 caddc co cuz df-2 fveq2i eleq2i vk cv c1 cmin co elnnuz
        3imtr4i vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co
        wcel vk cv c1 cmin co c1 caddc co cH cfv vk cv c1 cmin co c1 caddc co
        vk cv c1 cmin co cH cfv cG co wcel vg vk cv c1 cmin co cn vg cv vk cv
        c1 cmin co wceq vg cv c1 caddc co cH cfv vk cv c1 cmin co c1 caddc co
        cH cfv vg cv c1 caddc co vg cv cH cfv cG co vk cv c1 cmin co c1 caddc
        co vk cv c1 cmin co cH cfv cG co vg cv vk cv c1 cmin co wceq vg cv c1
        caddc co vk cv c1 cmin co c1 caddc co cH vg cv vk cv c1 cmin co c1
        caddc opreq1 fveq2d vg cv vk cv c1 cmin co wceq vg cv c1 caddc co vk cv
        c1 cmin co c1 caddc co vg cv cH cfv vk cv c1 cmin co cH cfv cG vg cv vk
        cv c1 cmin co c1 caddc opreq1 vg cv vk cv c1 cmin co cH fveq2 opreq12d
        eleq12d rcla4v syl imdistanri sylan2 anassrs pm3.26d r19.21aiva $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Consecutive balls in the sequence ` H ` have
         nonzero intersection. $)
      heiborlem31 $p |- ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) ) -> A. k e. ( ZZ>= ` 2 )
                        ( ( ( ball ` M ) ` ( H ` ( k + 1 ) ) ) i^i
                                ( ( ball ` M ) ` ( H ` k ) ) ) =/= (/) ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH
        cfv cM cbl cfv cfv cin c0 wne vg cn wral vk cv c1 caddc co cH cfv cM
        cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0 wne vk c2 cuz cfv wral
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv
        cM cbl cfv cfv cin c0 wne vg cn wral cn cB cH wf vg cv c1 caddc co cH
        cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cv c1 caddc co cH cfv
        cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin c0 wne vg cn vg cv c1
        caddc co cn wcel vg cv cH cfv cB wcel vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cv c1 caddc co cH cfv cM cbl cfv
        cfv vg cv cH cfv cM cbl cfv cfv cin c0 wne wi cn cB cH wf vg cv cn wcel
        wa vg cv c1 caddc co cn wcel vg cv cH cfv cB wcel wa vg cv c1 caddc co
        vg cv cH cfv cG co vx cv cX wcel vr cv c1 c2 vg cv c1 caddc co cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co vg cv cH cfv cM cbl cfv cfv cin c0 wne wa wa vx vr copab wceq vg
        cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cv
        c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin c0
        wne wi vx vv cB cD cU vh vn cG cJ cM vg cv c1 caddc co cX vg cv cH cfv
        vs vr va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heibor.15 heiborlem25 vg cv c1 caddc co vg cv cH
        cfv cG co vx cv cX wcel vr cv c1 c2 vg cv c1 caddc co cexp co cdiv co
        wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co vg
        cv cH cfv cM cbl cfv cfv cin c0 wne wa wa vx vr copab wceq vg cv c1
        caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cv c1
        caddc co cH cfv vx cv cX wcel vr cv c1 c2 vg cv c1 caddc co cexp co
        cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl
        cfv co vg cv cH cfv cM cbl cfv cfv cin c0 wne wa wa vx vr copab wcel vg
        cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin c0
        wne vg cv c1 caddc co vg cv cH cfv cG co vx cv cX wcel vr cv c1 c2 vg
        cv c1 caddc co cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD
        wcel vx cv vr cv cM cbl cfv co vg cv cH cfv cM cbl cfv cfv cin c0 wne
        wa wa vx vr copab vg cv c1 caddc co cH cfv eleq2 vg cv c1 caddc co cH
        cfv vx cv cX wcel vr cv c1 c2 vg cv c1 caddc co cexp co cdiv co wceq wa
        vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co vg cv cH
        cfv cM cbl cfv cfv cin c0 wne wa wa vx vr copab wcel vg cv c1 caddc co
        cH cfv vx cv vr cv cop wceq vx cv cX wcel vr cv c1 c2 vg cv c1 caddc co
        cexp co cdiv co wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv
        cM cbl cfv co vg cv cH cfv cM cbl cfv cfv cin c0 wne wa wa wa vr wex vx
        wex vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv
        cin c0 wne vx cv cX wcel vr cv c1 c2 vg cv c1 caddc co cexp co cdiv co
        wceq wa vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv co vg
        cv cH cfv cM cbl cfv cfv cin c0 wne wa wa vx vr vg cv c1 caddc co cH
        cfv elopab vg cv c1 caddc co cH cfv vx cv vr cv cop wceq vx cv cX wcel
        vr cv c1 c2 vg cv c1 caddc co cexp co cdiv co wceq wa vx cv vr cv cM
        cbl cfv co cD wcel vx cv vr cv cM cbl cfv co vg cv cH cfv cM cbl cfv
        cfv cin c0 wne wa wa wa vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv
        cH cfv cM cbl cfv cfv cin c0 wne vx vr vg cv c1 caddc co cH cfv vx cv
        vr cv cop wceq vx cv vr cv cM cbl cfv co cD wcel vx cv vr cv cM cbl cfv
        co vg cv cH cfv cM cbl cfv cfv cin c0 wne wa vg cv c1 caddc co cH cfv
        cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin c0 wne vx cv cX wcel vr
        cv c1 c2 vg cv c1 caddc co cexp co cdiv co wceq wa vg cv c1 caddc co cH
        cfv vx cv vr cv cop wceq vx cv vr cv cM cbl cfv co vg cv cH cfv cM cbl
        cfv cfv cin c0 wne vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv
        cM cbl cfv cfv cin c0 wne vx cv vr cv cM cbl cfv co cD wcel vg cv c1
        caddc co cH cfv vx cv vr cv cop wceq vx cv vr cv cM cbl cfv co vg cv cH
        cfv cM cbl cfv cfv cin c0 wne vg cv c1 caddc co cH cfv cM cbl cfv cfv
        vg cv cH cfv cM cbl cfv cfv cin c0 wne vg cv c1 caddc co cH cfv vx cv
        vr cv cop wceq vx cv vr cv cM cbl cfv co vg cv cH cfv cM cbl cfv cfv
        cin vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv
        cin c0 vg cv c1 caddc co cH cfv vx cv vr cv cop wceq vx cv vr cv cM cbl
        cfv co vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv
        cfv vg cv c1 caddc co cH cfv vx cv vr cv cop wceq vg cv c1 caddc co cH
        cfv cM cbl cfv cfv vx cv vr cv cop cM cbl cfv cfv vx cv vr cv cM cbl
        cfv co vg cv c1 caddc co cH cfv vx cv vr cv cop cM cbl cfv fveq2 vx cv
        vr cv cM cbl cfv df-opr syl6reqr ineq1d neeq1d biimpa adantrl adantrl
        19.23aivv sylbi syl6bi syl vg cv cn wcel vg cv c1 caddc co cn wcel cn
        cB cH wf vg cv peano2nn adantl cn cB vg cv cH ffvelrn sylanc r19.20dva
        imp vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv
        cin c0 wne vg cn wral vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH
        cfv cM cbl cfv cfv cin c0 wne vg c2 cuz cfv wral vk cv c1 caddc co cH
        cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0 wne vk c2 cuz cfv
        wral c2 cuz cfv cn wss vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH
        cfv cM cbl cfv cfv cin c0 wne vg cn wral vg cv c1 caddc co cH cfv cM
        cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin c0 wne vg c2 cuz cfv wral
        wi c2 cuz cfv c1 cuz cfv cn c2 c1 cuz cfv wcel c2 cuz cfv c1 cuz cfv
        wss c2 c1 cuz cfv wcel c1 c2 cle wbr c1 c2 1re 2re 1lt2 ltleii c1 cz
        wcel c2 cz wcel c2 c1 cuz cfv wcel c1 c2 cle wbr wb 1z 2z c1 c2 eluz
        mp2an mpbir c1 c2 uzss ax-mp nnuz sseqtr4i vg cv c1 caddc co cH cfv cM
        cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin c0 wne vg c2 cuz cfv cn
        ssralv ax-mp vg cv c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM
        cbl cfv cfv cin c0 wne vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH
        cfv cM cbl cfv cfv cin c0 wne vg vk c2 cuz cfv vg cv vk cv wceq vg cv
        c1 caddc co cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv cin vk cv
        c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0 vg
        cv vk cv wceq vg cv c1 caddc co cH cfv cM cbl cfv cfv vk cv c1 caddc co
        cH cfv cM cbl cfv cfv vg cv cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl
        cfv cfv vg cv vk cv wceq vg cv c1 caddc co cH cfv vk cv c1 caddc co cH
        cfv cM cbl cfv vg cv vk cv wceq vg cv c1 caddc co vk cv c1 caddc co cH
        vg cv vk cv c1 caddc opreq1 fveq2d fveq2d vg cv vk cv wceq vg cv cH cfv
        vk cv cH cfv cM cbl cfv vg cv vk cv cH fveq2 fveq2d ineq12d neeq1d
        cbvralv sylib syl $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Bound on the distance between centers of
         consecutive balls in ` H ` . $)
      heiborlem32 $p |- ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) ) -> A. k e. ( ZZ>= ` 2 )
                    ( ( 1st ` ( H ` k ) ) M ( 1st ` ( H ` ( k + 1 ) ) ) )
                                      < ( 1 / ( 2 ^ ( k - 1 ) ) ) ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd
        cfv c1 c2 vk cv cexp co cdiv co wceq wa vk c2 cuz cfv wral vk cv c1
        caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0 wne
        vk c2 cuz cfv wral wa vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr vk c2 cuz
        cfv wral cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv
        cH cfv cG co wcel vg cn wral wa vk cv cH cfv c1st cfv cX wcel vk cv cH
        cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk c2 cuz cfv wral vk
        cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0
        wne vk c2 cuz cfv wral vx vv cB cD cU vg vh vk vn cG cH cJ cM cX vs vr
        va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heibor.15 heiborlem30 vx vv cB cD cU vg vh vk vn cG cH cJ cM
        cX vs vr va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heibor.15 heiborlem31 jca cn cB cH wf vg cv c1
        caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa
        vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co
        cdiv co wceq wa vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM
        cbl cfv cfv cin c0 wne wa vk c2 cuz cfv wral vk cv cH cfv c1st cfv vk
        cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co
        cdiv co clt wbr vk c2 cuz cfv wral vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk c2 cuz cfv wral
        vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin
        c0 wne vk c2 cuz cfv wral wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa vk cv cH cfv c1st cfv
        cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv
        c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0
        wne wa vk c2 cuz cfv wral vk cv cH cfv c1st cfv vk cv c1 caddc co cH
        cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr vk c2
        cuz cfv wral cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg
        cv cH cfv cG co wcel vg cn wral wa vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv c1 caddc co
        cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0 wne wa vk cv
        cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1
        cmin co cexp co cdiv co clt wbr vk c2 cuz cfv cn cB cH wf vg cv c1
        caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa
        vk cv c2 cuz cfv wcel wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv c1 caddc co cH cfv
        cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin c0 wne vk cv cH cfv c1st
        cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp
        co cdiv co clt wbr cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc
        co vg cv cH cfv cG co wcel vg cn wral wa vk cv c2 cuz cfv wcel wa vk cv
        cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv
        co wceq wa wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH
        cfv cM cbl cfv cfv cin wcel vy wex vk cv cH cfv c1st cfv vk cv c1 caddc
        co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr
        vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin
        c0 wne cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral wa vk cv c2 cuz cfv wcel wa vk cv cH cfv c1st
        cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa
        wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl
        cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st
        cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr vy cn cB cH wf
        vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg
        cn wral wa vk cv c2 cuz cfv wcel wa vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vy cv vk cv c1
        caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk
        cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv
        c1 cmin co cexp co cdiv co clt wbr wi cn cB cH wf vg cv c1 caddc co cH
        cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa vk cv c2
        cuz cfv wcel wa vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1
        caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq
        wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp
        co cdiv co wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv
        cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co
        cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi
        wi vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp
        co cdiv co wceq wa vj c2 cuz cfv wral vk cv c1 caddc co c2 cuz cfv wcel
        vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd
        cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq wa cn cB cH wf vg cv
        c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        wa vk cv c2 cuz cfv wcel vj cv cH cfv c1st cfv cX wcel vj cv cH cfv
        c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vk cv c1 caddc co cH cfv
        c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc
        co cexp co cdiv co wceq wa vj vk cv c1 caddc co c2 cuz cfv vj cv vk cv
        c1 caddc co wceq vj cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv
        c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq
        vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv
        co wceq vj cv vk cv c1 caddc co wceq vj cv cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cX vj cv vk cv c1 caddc co wceq vj cv cH cfv
        vk cv c1 caddc co cH cfv c1st vj cv vk cv c1 caddc co cH fveq2 fveq2d
        eleq1d vj cv vk cv c1 caddc co wceq vj cv cH cfv c2nd cfv vk cv c1
        caddc co cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co c1 c2 vk cv c1
        caddc co cexp co cdiv co vj cv vk cv c1 caddc co wceq vj cv cH cfv vk
        cv c1 caddc co cH cfv c2nd vj cv vk cv c1 caddc co cH fveq2 fveq2d vj
        cv vk cv c1 caddc co wceq c2 vj cv cexp co c2 vk cv c1 caddc co cexp co
        c1 cdiv vj cv vk cv c1 caddc co c2 cexp opreq2 opreq2d eqeq12d anbi12d
        rcla4cva vx vv cB cD cU vg vh vj vn cG cH cJ cM cX vs vr va heibor.1
        heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14
        heibor.15 heiborlem30 c2 vk cv peano2uz syl2an cn cB cH wf vk cv c2 cuz
        cfv wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH
        cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq wa vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co
        wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM
        cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi wi wi
        vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg
        cn wral cn cB cH wf vk cv cn wcel vk cv c1 caddc co cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co
        cdiv co wceq wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1
        c2 vk cv cexp co cdiv co wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl
        cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk
        cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co
        cdiv co clt wbr wi wi wi vk cv c2 cuz cfv wcel cn cB cH wf vk cv cn
        wcel wa vk cv cH cfv cB wcel vk cv c1 caddc co cH cfv cB wcel vk cv c1
        caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv c1
        c2 vk cv c1 caddc co cexp co cdiv co wceq wa vk cv cH cfv c1st cfv cX
        wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vy cv vk
        cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin
        wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1
        c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi wi wi cn cB vk cv cH
        ffvelrn cn cB cH wf vk cv c1 caddc co cn wcel vk cv c1 caddc co cH cfv
        cB wcel vk cv cn wcel cn cB vk cv c1 caddc co cH ffvelrn vk cv peano2nn
        sylan2 vk cv cn wcel vk cv cH cfv cB wcel vk cv c1 caddc co cH cfv cB
        wcel wa vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH
        cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq wa vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co
        wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM
        cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi wi wi
        wi cn cB cH wf vk cv cn wcel vk cv cH cfv vk cv cH cfv c1st cfv vk cv
        cH cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv crp wcel wa wa vk cv c1 caddc co cH cfv vk cv c1 caddc co cH
        cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc
        co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel
        wa wa vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH
        cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq wa vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co
        wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM
        cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi wi wi
        vk cv cH cfv cB wcel vk cv c1 caddc co cH cfv cB wcel vk cv cn wcel vk
        cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv cH
        cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv crp wcel wa wa vk cv c1
        caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH
        cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv
        c1 caddc co cH cfv c2nd cfv crp wcel wa wa wa vk cv c1 caddc co cH cfv
        c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc
        co cexp co cdiv co wceq wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vy cv vk cv c1 caddc co cH
        cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co
        cexp co cdiv co clt wbr wi wi wi vk cv cn wcel vk cv cH cfv vk cv cH
        cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX
        wcel vk cv cH cfv c2nd cfv crp wcel wa wa vk cv c1 caddc co cH cfv vk
        cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop
        wceq vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv
        c2nd cfv crp wcel wa wa wa wa vk cv c1 caddc co cH cfv c2nd cfv c1 c2
        vk cv c1 caddc co cexp co cdiv co wceq vk cv cH cfv c1st cfv cX wcel vk
        cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vy cv vk cv c1
        caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk
        cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv
        c1 cmin co cexp co cdiv co clt wbr wi wi vk cv c1 caddc co cH cfv c1st
        cfv cX wcel vk cv cn wcel vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH
        cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd
        cfv crp wcel wa wa vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc co
        cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel wa
        wa wa wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk
        cv cexp co cdiv co wceq wa vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk
        cv c1 caddc co cexp co cdiv co wceq vy cv vk cv c1 caddc co cH cfv cM
        cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv c1st cfv
        vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co
        cdiv co clt wbr wi vk cv cn wcel vk cv cH cfv vk cv cH cfv c1st cfv vk
        cv cH cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX wcel vk cv cH cfv
        c2nd cfv crp wcel wa wa vk cv c1 caddc co cH cfv vk cv c1 caddc co cH
        cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc
        co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel
        wa wa wa wa vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq vk
        cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co
        wceq vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl
        cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st
        cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi wi vk cv cH
        cfv c1st cfv cX wcel vk cv cn wcel vk cv cH cfv vk cv cH cfv c1st cfv
        vk cv cH cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX wcel vk cv cH
        cfv c2nd cfv crp wcel wa wa vk cv c1 caddc co cH cfv vk cv c1 caddc co
        cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1
        caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv crp
        wcel wa wa wa wa vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc
        co cexp co cdiv co wceq vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv
        co wceq vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM
        cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi vk cv
        cn wcel vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop
        wceq vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv crp wcel wa wa
        vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1
        caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel wa wa wa wa vk cv c1
        caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq
        vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq vy cv vk cv c1
        caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk
        cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv
        c1 cmin co cexp co cdiv co clt wbr wi vk cv cH cfv vk cv cH cfv c1st
        cfv vk cv cH cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX wcel vk cv
        cH cfv c2nd cfv crp wcel wa wa vk cv c1 caddc co cH cfv vk cv c1 caddc
        co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1
        caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv crp
        wcel wa wa wa vk cv cn wcel vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk
        cv c1 caddc co cexp co cdiv co wceq vk cv cH cfv c2nd cfv c1 c2 vk cv
        cexp co cdiv co wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv
        vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co
        clt wbr wi wi vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv
        cop wceq vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk
        cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv crp wcel wa vk cv c1 caddc co cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel wa vk cv cn wcel vk cv
        c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co
        wceq vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vy cv vk
        cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin
        wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1
        c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi wi wi vk cv cH cfv vk cv
        cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv
        vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop
        wceq wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv crp wcel wa
        vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd
        cfv crp wcel wa wa vk cv cn wcel vk cv c1 caddc co cH cfv c2nd cfv c1
        c2 vk cv c1 caddc co cexp co cdiv co wceq vk cv cH cfv c2nd cfv c1 c2
        vk cv cexp co cdiv co wceq wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv
        cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co
        clt wbr wi wi vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv
        cop wceq vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk
        cv c1 caddc co cH cfv c2nd cfv cop wceq wa vk cv c1 caddc co cH cfv
        c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq vk cv cH cfv c2nd
        cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH cfv c1st cfv cX wcel
        vk cv cH cfv c2nd cfv crp wcel wa vk cv c1 caddc co cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel wa wa vk cv cn wcel wa
        vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv
        cfv cin wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM
        co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi vk cv cH cfv vk cv
        cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv
        vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop
        wceq wa vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp
        co cdiv co wceq vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq
        wa vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv crp wcel wa vk
        cv c1 caddc co cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd
        cfv crp wcel wa wa vk cv cn wcel wa vy cv vk cv c1 caddc co cH cfv cM
        cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH cfv c1st cfv
        vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co
        cdiv co clt wbr wi wi vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv
        c2nd cfv cop wceq vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq wa vk cv c1 caddc
        co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq vk cv
        cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa wa vy cv vk cv c1
        caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vy
        cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co
        cdiv co cM cbl cfv co wcel vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp
        co cdiv co cM cbl cfv co wcel wa vk cv cH cfv c1st cfv cX wcel vk cv cH
        cfv c2nd cfv crp wcel wa vk cv c1 caddc co cH cfv c1st cfv cX wcel vk
        cv c1 caddc co cH cfv c2nd cfv crp wcel wa wa vk cv cn wcel wa vk cv cH
        cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1
        cmin co cexp co cdiv co clt wbr vk cv cH cfv vk cv cH cfv c1st cfv vk
        cv cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv vk cv c1 caddc co
        cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq wa vk cv c1
        caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq
        vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa wa vy cv vk
        cv c1 caddc co cH cfv cM cbl cfv cfv wcel vy cv vk cv cH cfv cM cbl cfv
        cfv wcel wa vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1
        caddc co cexp co cdiv co cM cbl cfv co wcel vy cv vk cv cH cfv c1st cfv
        c1 c2 vk cv cexp co cdiv co cM cbl cfv co wcel wa vy cv vk cv c1 caddc
        co cH cfv cM cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin wcel vk cv cH
        cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv c1 caddc
        co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c2nd cfv cop wceq wa vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1
        caddc co cexp co cdiv co wceq vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co
        cdiv co wceq wa wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv wcel
        vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co
        cdiv co cM cbl cfv co wcel vy cv vk cv cH cfv cM cbl cfv cfv wcel vy cv
        vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cM cbl cfv co wcel vk
        cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc
        co cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk
        cv c1 caddc co cexp co cdiv co wceq vy cv vk cv c1 caddc co cH cfv cM
        cbl cfv cfv wcel vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1
        caddc co cexp co cdiv co cM cbl cfv co wcel wi vk cv cH cfv vk cv cH
        cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv cH cfv c2nd cfv c1 c2
        vk cv cexp co cdiv co wceq vk cv c1 caddc co cH cfv vk cv c1 caddc co
        cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1
        caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq
        wa vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv wcel vy cv vk cv c1
        caddc co cH cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co cdiv co cM cbl
        cfv co wcel vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv
        vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv
        c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq wa vk cv c1 caddc
        co cH cfv cM cbl cfv cfv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv
        c1 caddc co cexp co cdiv co cM cbl cfv co vy cv vk cv c1 caddc co cH
        cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv
        cop wceq vk cv c1 caddc co cH cfv c2nd cfv c1 c2 vk cv c1 caddc co cexp
        co cdiv co wceq vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv c1 caddc
        co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cM cbl cfv co vk
        cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co cdiv co
        cM cbl cfv co vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st
        cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv
        cM cbl cfv cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH
        cfv c2nd cfv cop cM cbl cfv cfv vk cv c1 caddc co cH cfv c1st cfv vk cv
        c1 caddc co cH cfv c2nd cfv cM cbl cfv co vk cv c1 caddc co cH cfv vk
        cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH cfv c2nd cfv cop cM
        cbl cfv fveq2 vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co cH
        cfv c2nd cfv cM cbl cfv df-opr syl6eqr vk cv c1 caddc co cH cfv c2nd
        cfv c1 c2 vk cv c1 caddc co cexp co cdiv co vk cv c1 caddc co cH cfv
        c1st cfv cM cbl cfv opreq2 sylan9eq eleq2d biimpd ad2ant2lr vk cv cH
        cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv cH cfv
        c2nd cfv c1 c2 vk cv cexp co cdiv co wceq vy cv vk cv cH cfv cM cbl cfv
        cfv wcel vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cM cbl
        cfv co wcel wi vk cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st
        cfv vk cv c1 caddc co cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv
        c2nd cfv c1 c2 vk cv c1 caddc co cexp co cdiv co wceq vk cv cH cfv vk
        cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk cv cH cfv c2nd cfv
        c1 c2 vk cv cexp co cdiv co wceq wa vy cv vk cv cH cfv cM cbl cfv cfv
        wcel vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cM cbl cfv
        co wcel vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop
        wceq vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq wa vk cv cH
        cfv cM cbl cfv cfv vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cM
        cbl cfv co vy cv vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd
        cfv cop wceq vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co wceq vk
        cv cH cfv cM cbl cfv cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM
        cbl cfv co vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cM cbl cfv
        co vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop wceq vk
        cv cH cfv cM cbl cfv cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv
        cop cM cbl cfv cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl
        cfv co vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cop cM
        cbl cfv fveq2 vk cv cH cfv c1st cfv vk cv cH cfv c2nd cfv cM cbl cfv
        df-opr syl6eqr vk cv cH cfv c2nd cfv c1 c2 vk cv cexp co cdiv co vk cv
        cH cfv c1st cfv cM cbl cfv opreq2 sylan9eq eleq2d biimpd ad2ant2rl
        anim12d vy cv vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv cH cfv cM
        cbl cfv cfv elin syl5ib vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co
        cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c2nd cfv crp wcel wa
        vk cv cn wcel vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1
        caddc co cexp co cdiv co cM cbl cfv co wcel vy cv vk cv cH cfv c1st cfv
        c1 c2 vk cv cexp co cdiv co cM cbl cfv co wcel wa vk cv cH cfv c1st cfv
        vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co
        cdiv co clt wbr wi vk cv cH cfv c2nd cfv crp wcel vk cv cH cfv c1st cfv
        cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel vk cv cn wcel vy cv
        vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co cdiv
        co cM cbl cfv co wcel vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp co
        cdiv co cM cbl cfv co wcel wa vk cv cH cfv c1st cfv vk cv c1 caddc co
        cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wi
        vk cv c1 caddc co cH cfv c2nd cfv crp wcel vk cv cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy
        cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv c1
        caddc co cexp co cdiv co clt wbr wa vy cv cX wcel vk cv cH cfv c1st cfv
        vy cv cM co c1 c2 vk cv cexp co cdiv co clt wbr wa vk cv cH cfv c1st
        cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp
        co cdiv co clt wbr vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv
        c1 caddc co cexp co cdiv co cM cbl cfv co wcel vy cv vk cv cH cfv c1st
        cfv c1 c2 vk cv cexp co cdiv co cM cbl cfv co wcel vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel
        wa vy cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk
        cv c1 caddc co cexp co cdiv co clt wbr vk cv cH cfv c1st cfv vy cv cM
        co c1 c2 vk cv cexp co cdiv co clt wbr wa wa vk cv cH cfv c1st cfv vk
        cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co cexp co
        cdiv co clt wbr vy cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv
        cM co c1 c2 vk cv c1 caddc co cexp co cdiv co clt wbr wa vy cv cX wcel
        vk cv cH cfv c1st cfv vy cv cM co c1 c2 vk cv cexp co cdiv co clt wbr
        wa wa vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv
        cX wcel wa vk cv cn wcel wa vy cv cX wcel vk cv c1 caddc co cH cfv c1st
        cfv vy cv cM co c1 c2 vk cv c1 caddc co cexp co cdiv co clt wbr vk cv
        cH cfv c1st cfv vy cv cM co c1 c2 vk cv cexp co cdiv co clt wbr wa vk
        cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv
        c1 cmin co cexp co cdiv co clt wbr vk cv cH cfv c1st cfv cX wcel vk cv
        c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel
        wa vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv c1 caddc
        co cexp co cdiv co clt wbr vk cv cH cfv c1st cfv vy cv cM co c1 c2 vk
        cv cexp co cdiv co clt wbr wa vk cv cH cfv c1st cfv vy cv cM co vk cv
        c1 caddc co cH cfv c1st cfv vy cv cM co caddc co c1 c2 vk cv cexp co
        cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt wbr vk cv
        cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1
        cmin co cexp co cdiv co clt wbr vk cv cH cfv c1st cfv cX wcel vk cv c1
        caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa
        vk cv cH cfv c1st cfv vy cv cM co c1 c2 vk cv cexp co cdiv co clt wbr
        vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv c1 caddc co
        cexp co cdiv co clt wbr vk cv cH cfv c1st cfv vy cv cM co vk cv c1
        caddc co cH cfv c1st cfv vy cv cM co caddc co c1 c2 vk cv cexp co cdiv
        co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt wbr vk cv cH
        cfv c1st cfv vy cv cM co cr wcel vk cv c1 caddc co cH cfv c1st cfv vy
        cv cM co cr wcel c1 c2 vk cv cexp co cdiv co cr wcel c1 c2 vk cv c1
        caddc co cexp co cdiv co cr wcel vk cv cH cfv c1st cfv vy cv cM co c1
        c2 vk cv cexp co cdiv co clt wbr vk cv c1 caddc co cH cfv c1st cfv vy
        cv cM co c1 c2 vk cv c1 caddc co cexp co cdiv co clt wbr wa vk cv cH
        cfv c1st cfv vy cv cM co vk cv c1 caddc co cH cfv c1st cfv vy cv cM co
        caddc co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co
        cdiv co caddc co clt wbr wi vk cv cH cfv c1st cfv cX wcel vk cv c1
        caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa
        vk cv cH cfv c1st cfv vy cv cM co vk cv c1 caddc co cH cfv c1st cfv vy
        cv cM co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co
        cdiv co lt2add vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv
        c1st cfv cX wcel wa vy cv cX wcel vk cv cH cfv c1st cfv vy cv cM co cr
        wcel vk cv cn wcel vk cv cH cfv c1st cfv cX wcel vy cv cX wcel vk cv cH
        cfv c1st cfv vy cv cM co cr wcel vk cv c1 caddc co cH cfv c1st cfv cX
        wcel cM cme wcel vk cv cH cfv c1st cfv cX wcel vy cv cX wcel vk cv cH
        cfv c1st cfv vy cv cM co cr wcel cM heibor.9 cmsmeti vk cv cH cfv c1st
        cfv vy cv cM cX heibor.2 metcl mp3an1 adantlr adantlr vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vy cv cX wcel
        vk cv c1 caddc co cH cfv c1st cfv vy cv cM co cr wcel vk cv cn wcel vk
        cv c1 caddc co cH cfv c1st cfv cX wcel vy cv cX wcel vk cv c1 caddc co
        cH cfv c1st cfv vy cv cM co cr wcel vk cv cH cfv c1st cfv cX wcel cM
        cme wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel vy cv cX wcel vk cv
        c1 caddc co cH cfv c1st cfv vy cv cM co cr wcel cM heibor.9 cmsmeti vk
        cv c1 caddc co cH cfv c1st cfv vy cv cM cX heibor.2 metcl mp3an1
        adantll adantlr vk cv cn wcel c1 c2 vk cv cexp co cdiv co cr wcel vk cv
        cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vy
        cv cX wcel vk cv cn wcel c1 c2 vk cv cexp co cdiv co crp wcel c1 c2 vk
        cv cexp co cdiv co cr wcel vk cv cn wcel vk cv cn0 wcel c2 vk cv cexp
        co crp wcel c1 c2 vk cv cexp co cdiv co crp wcel vk cv nnnn0 c2 crp
        wcel vk cv cn0 wcel c2 vk cv cexp co crp wcel c2 2re 2pos elrpii c2 vk
        cv rpexpcl mpan c2 vk cv cexp co rpreccl 3syl c1 c2 vk cv cexp co cdiv
        co rpre syl ad2antlr vk cv cn wcel c1 c2 vk cv c1 caddc co cexp co cdiv
        co cr wcel vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st
        cfv cX wcel wa vy cv cX wcel vk cv cn wcel c1 c2 vk cv c1 caddc co cexp
        co cdiv co crp wcel c1 c2 vk cv c1 caddc co cexp co cdiv co cr wcel vk
        cv cn wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co crp
        wcel c1 c2 vk cv c1 caddc co cexp co cdiv co crp wcel vk cv cn wcel vk
        cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv
        c1 caddc co nnnn0 syl c2 crp wcel vk cv c1 caddc co cn0 wcel c2 vk cv
        c1 caddc co cexp co crp wcel c2 2re 2pos elrpii c2 vk cv c1 caddc co
        rpexpcl mpan c2 vk cv c1 caddc co cexp co rpreccl 3syl c1 c2 vk cv c1
        caddc co cexp co cdiv co rpre syl ad2antlr syl2anc ancomsd vk cv cH cfv
        c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cn
        wcel wa vy cv cX wcel wa vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv
        c1st cfv cM co vk cv cH cfv c1st cfv vy cv cM co vk cv c1 caddc co cH
        cfv c1st cfv vy cv cM co caddc co cle wbr vk cv cH cfv c1st cfv vy cv
        cM co vk cv c1 caddc co cH cfv c1st cfv vy cv cM co caddc co c1 c2 vk
        cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt
        wbr vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2
        vk cv c1 cmin co cexp co cdiv co clt wbr cM cme wcel vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel vy cv cX wcel w3a
        vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co vk cv cH
        cfv c1st cfv vy cv cM co vk cv c1 caddc co cH cfv c1st cfv vy cv cM co
        caddc co cle wbr vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv
        c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa vk cv cH cfv c1st
        cfv vk cv c1 caddc co cH cfv c1st cfv vy cv cM cX heibor.2 mettri3 cM
        heibor.9 cmsmeti vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv
        c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel vy cv cX wcel vk
        cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel vk
        cv cn wcel vy cv cX wcel simplll vk cv cH cfv c1st cfv cX wcel vk cv c1
        caddc co cH cfv c1st cfv cX wcel vk cv cn wcel vy cv cX wcel simpllr vk
        cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa
        vk cv cn wcel wa vy cv cX wcel pm3.27 3jca sylancr vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel
        wa vy cv cX wcel wa vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st
        cfv cM co vk cv cH cfv c1st cfv vy cv cM co vk cv c1 caddc co cH cfv
        c1st cfv vy cv cM co caddc co cle wbr vk cv cH cfv c1st cfv vy cv cM co
        vk cv c1 caddc co cH cfv c1st cfv vy cv cM co caddc co c1 c2 vk cv cexp
        co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt wbr wa
        vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk
        cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt
        wbr vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2
        vk cv c1 cmin co cexp co cdiv co clt wbr vk cv cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cM co cr wcel vk cv cH cfv c1st cfv vy cv cM
        co vk cv c1 caddc co cH cfv c1st cfv vy cv cM co caddc co cr wcel c1 c2
        vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co
        cr wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co
        vk cv cH cfv c1st cfv vy cv cM co vk cv c1 caddc co cH cfv c1st cfv vy
        cv cM co caddc co cle wbr vk cv cH cfv c1st cfv vy cv cM co vk cv c1
        caddc co cH cfv c1st cfv vy cv cM co caddc co c1 c2 vk cv cexp co cdiv
        co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt wbr wa vk cv cH
        cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv cexp
        co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt wbr wi
        vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel
        wa vk cv cn wcel wa vy cv cX wcel wa vk cv cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cM co vk cv cH cfv c1st cfv vy cv cM co vk cv
        c1 caddc co cH cfv c1st cfv vy cv cM co caddc co c1 c2 vk cv cexp co
        cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co lelttr vk cv
        cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk
        cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co cr wcel vk
        cv cn wcel vy cv cX wcel cM cme wcel vk cv cH cfv c1st cfv cX wcel vk
        cv c1 caddc co cH cfv c1st cfv cX wcel vk cv cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cM co cr wcel cM heibor.9 cmsmeti vk cv cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM cX heibor.2 metcl mp3an1
        ad2antrr vk cv cH cfv c1st cfv vy cv cM co cr wcel vk cv c1 caddc co cH
        cfv c1st cfv vy cv cM co cr wcel vk cv cH cfv c1st cfv vy cv cM co vk
        cv c1 caddc co cH cfv c1st cfv vy cv cM co caddc co cr wcel vk cv cH
        cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv
        cn wcel wa vy cv cX wcel wa vk cv cH cfv c1st cfv vy cv cM co vk cv c1
        caddc co cH cfv c1st cfv vy cv cM co readdcl vk cv cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vy cv cX wcel vk cv
        cH cfv c1st cfv vy cv cM co cr wcel vk cv cn wcel vk cv cH cfv c1st cfv
        cX wcel vy cv cX wcel vk cv cH cfv c1st cfv vy cv cM co cr wcel vk cv
        c1 caddc co cH cfv c1st cfv cX wcel cM cme wcel vk cv cH cfv c1st cfv
        cX wcel vy cv cX wcel vk cv cH cfv c1st cfv vy cv cM co cr wcel cM
        heibor.9 cmsmeti vk cv cH cfv c1st cfv vy cv cM cX heibor.2 metcl
        mp3an1 adantlr adantlr vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co
        cH cfv c1st cfv cX wcel wa vy cv cX wcel vk cv c1 caddc co cH cfv c1st
        cfv vy cv cM co cr wcel vk cv cn wcel vk cv c1 caddc co cH cfv c1st cfv
        cX wcel vy cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv cM co cr
        wcel vk cv cH cfv c1st cfv cX wcel cM cme wcel vk cv c1 caddc co cH cfv
        c1st cfv cX wcel vy cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv
        cM co cr wcel cM heibor.9 cmsmeti vk cv c1 caddc co cH cfv c1st cfv vy
        cv cM cX heibor.2 metcl mp3an1 adantll adantlr sylanc c1 c2 vk cv cexp
        co cdiv co cr wcel c1 c2 vk cv c1 caddc co cexp co cdiv co cr wcel c1
        c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc
        co cr wcel vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st
        cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa c1 c2 vk cv cexp co
        cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co readdcl vk cv cn wcel
        c1 c2 vk cv cexp co cdiv co cr wcel vk cv cH cfv c1st cfv cX wcel vk cv
        c1 caddc co cH cfv c1st cfv cX wcel wa vy cv cX wcel vk cv cn wcel c1
        c2 vk cv cexp co cdiv co crp wcel c1 c2 vk cv cexp co cdiv co cr wcel
        vk cv cn wcel vk cv cn0 wcel c2 vk cv cexp co crp wcel c1 c2 vk cv cexp
        co cdiv co crp wcel vk cv nnnn0 c2 crp wcel vk cv cn0 wcel c2 vk cv
        cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl mpan c2 vk cv cexp
        co rpreccl 3syl c1 c2 vk cv cexp co cdiv co rpre syl ad2antlr vk cv cn
        wcel c1 c2 vk cv c1 caddc co cexp co cdiv co cr wcel vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vy cv cX wcel
        vk cv cn wcel c1 c2 vk cv c1 caddc co cexp co cdiv co crp wcel c1 c2 vk
        cv c1 caddc co cexp co cdiv co cr wcel vk cv cn wcel vk cv c1 caddc co
        cn0 wcel c2 vk cv c1 caddc co cexp co crp wcel c1 c2 vk cv c1 caddc co
        cexp co cdiv co crp wcel vk cv cn wcel vk cv c1 caddc co cn wcel vk cv
        c1 caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co nnnn0 syl c2 crp
        wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co crp wcel
        c2 2re 2pos elrpii c2 vk cv c1 caddc co rpexpcl mpan c2 vk cv c1 caddc
        co cexp co rpreccl 3syl c1 c2 vk cv c1 caddc co cexp co cdiv co rpre
        syl ad2antlr sylanc syl3anc vk cv cH cfv c1st cfv cX wcel vk cv c1
        caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa
        vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk
        cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co clt
        wbr c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co
        caddc co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr vk cv cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 cmin co
        cexp co cdiv co clt wbr vk cv cn wcel c1 c2 vk cv cexp co cdiv co c1 c2
        vk cv c1 caddc co cexp co cdiv co caddc co c1 c2 vk cv c1 cmin co cexp
        co cdiv co clt wbr vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH
        cfv c1st cfv cX wcel wa vy cv cX wcel vk cv cn wcel c1 c2 vk cv cexp co
        cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co c1 c2 vk cv c1
        cmin co cexp co cdiv co clt wbr c2 vk cv c1 caddc co cexp co c1 c2 vk
        cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co
        cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk cv c1 cmin co cexp co
        cdiv co cmul co clt wbr vk cv cn wcel c3 c4 c2 vk cv c1 caddc co cexp
        co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co
        caddc co cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk cv c1 cmin co
        cexp co cdiv co cmul co clt c3 c4 clt wbr vk cv cn wcel c3 c3 c1 caddc
        co c4 clt c3 3re ltp1i df-4 breqtrri a1i vk cv cn wcel c2 vk cv c1
        caddc co cexp co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co
        cexp co cdiv co caddc co cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk
        cv cexp co cdiv co cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk cv c1
        caddc co cexp co cdiv co cmul co caddc co c2 c1 caddc co c3 c2 vk cv c1
        caddc co cexp co cc wcel c1 c2 vk cv cexp co cdiv co cc wcel c1 c2 vk
        cv c1 caddc co cexp co cdiv co cc wcel c2 vk cv c1 caddc co cexp co c1
        c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc
        co cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk cv cexp co cdiv co
        cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk cv c1 caddc co cexp co
        cdiv co cmul co caddc co wceq vk cv cn wcel c2 vk cv c1 caddc co cexp
        co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co
        adddi vk cv cn wcel c2 vk cv c1 caddc co cexp co c2 cr wcel vk cv c1
        caddc co cn0 wcel c2 vk cv c1 caddc co cexp co cr wcel vk cv cn wcel c2
        vk cv c1 caddc co reexpcl 2re vk cv cn wcel vk cv c1 caddc co cn wcel
        vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co nnnn0 syl
        sylancr recnd vk cv cn wcel c1 c2 vk cv cexp co cdiv co vk cv cn wcel
        c1 c2 vk cv cexp co cdiv co crp wcel c1 c2 vk cv cexp co cdiv co cr
        wcel vk cv cn wcel vk cv cn0 wcel c2 vk cv cexp co crp wcel c1 c2 vk cv
        cexp co cdiv co crp wcel vk cv nnnn0 c2 crp wcel vk cv cn0 wcel c2 vk
        cv cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl mpan c2 vk cv
        cexp co rpreccl 3syl c1 c2 vk cv cexp co cdiv co rpre syl recnd vk cv
        cn wcel c1 c2 vk cv c1 caddc co cexp co cdiv co vk cv cn wcel c1 c2 vk
        cv c1 caddc co cexp co cdiv co crp wcel c1 c2 vk cv c1 caddc co cexp co
        cdiv co cr wcel vk cv cn wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1
        caddc co cexp co crp wcel c1 c2 vk cv c1 caddc co cexp co cdiv co crp
        wcel vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel
        vk cv peano2nn vk cv c1 caddc co nnnn0 syl c2 crp wcel vk cv c1 caddc
        co cn0 wcel c2 vk cv c1 caddc co cexp co crp wcel c2 2re 2pos elrpii c2
        vk cv c1 caddc co rpexpcl mpan c2 vk cv c1 caddc co cexp co rpreccl
        3syl c1 c2 vk cv c1 caddc co cexp co cdiv co rpre syl recnd syl3anc vk
        cv cn wcel c2 vk cv c1 caddc co cexp co c1 c2 vk cv cexp co cdiv co
        cmul co c2 c2 vk cv c1 caddc co cexp co c1 c2 vk cv c1 caddc co cexp co
        cdiv co cmul co c1 caddc vk cv cn wcel c2 vk cv c1 caddc co vk cv cmin
        co cexp co c2 vk cv c1 caddc co cexp co c2 vk cv cexp co cdiv co c2 c2
        vk cv c1 caddc co cexp co c1 c2 vk cv cexp co cdiv co cmul co c2 cc
        wcel c2 cc0 wne wa vk cv c1 caddc co cn0 wcel vk cv cn0 wcel w3a vk cv
        vk cv c1 caddc co cle wbr c2 vk cv c1 caddc co vk cv cmin co cexp co c2
        vk cv c1 caddc co cexp co c2 vk cv cexp co cdiv co wceq vk cv cn wcel
        c2 vk cv c1 caddc co vk cv expsub vk cv cn wcel c2 cc wcel c2 cc0 wne
        wa vk cv c1 caddc co cn0 wcel vk cv cn0 wcel c2 cc wcel c2 cc0 wne wa
        vk cv cn wcel c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i a1i vk cv cn wcel
        vk cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk
        cv c1 caddc co nnnn0 syl vk cv nnnn0 3jca vk cv cn wcel vk cv cr wcel
        vk cv vk cv c1 caddc co cle wbr vk cv nnre vk cv lep1 syl sylanc vk cv
        cn wcel c2 vk cv c1 caddc co vk cv cmin co cexp co c2 c1 cexp co c2 vk
        cv cn wcel vk cv c1 caddc co vk cv cmin co c1 c2 cexp vk cv cc wcel c1
        cc wcel vk cv c1 caddc co vk cv cmin co c1 wceq vk cv cn wcel vk cv c1
        pncan2 vk cv nncn ax1cn sylancl opreq2d c2 cc wcel c2 c1 cexp co c2
        wceq 2cn c2 exp1 ax-mp syl6eq c2 vk cv c1 caddc co cexp co cc wcel c2
        vk cv cexp co cc wcel c2 vk cv cexp co cc0 wne c2 vk cv c1 caddc co
        cexp co c2 vk cv cexp co cdiv co c2 vk cv c1 caddc co cexp co c1 c2 vk
        cv cexp co cdiv co cmul co wceq vk cv cn wcel c2 vk cv c1 caddc co cexp
        co c2 vk cv cexp co divrec vk cv cn wcel c2 vk cv c1 caddc co cexp co
        c2 cr wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co cr
        wcel vk cv cn wcel c2 vk cv c1 caddc co reexpcl 2re vk cv cn wcel vk cv
        c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1
        caddc co nnnn0 syl sylancr recnd vk cv cn wcel vk cv cn0 wcel c2 vk cv
        cexp co crp wcel c2 vk cv cexp co cc wcel vk cv nnnn0 c2 crp wcel vk cv
        cn0 wcel c2 vk cv cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl
        mpan c2 vk cv cexp co rpcn 3syl vk cv cn wcel vk cv cn0 wcel c2 vk cv
        cexp co crp wcel c2 vk cv cexp co cc0 wne vk cv nnnn0 c2 crp wcel vk cv
        cn0 wcel c2 vk cv cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl
        mpan c2 vk cv cexp co rpne0 3syl syl3anc 3eqtr3rd vk cv cn wcel c2 vk
        cv c1 caddc co cexp co c2 vk cv c1 caddc co cexp co cdiv co c2 vk cv c1
        caddc co cexp co c1 c2 vk cv c1 caddc co cexp co cdiv co cmul co c1 c2
        vk cv c1 caddc co cexp co cc wcel c2 vk cv c1 caddc co cexp co cc wcel
        c2 vk cv c1 caddc co cexp co cc0 wne c2 vk cv c1 caddc co cexp co c2 vk
        cv c1 caddc co cexp co cdiv co c2 vk cv c1 caddc co cexp co c1 c2 vk cv
        c1 caddc co cexp co cdiv co cmul co wceq vk cv cn wcel c2 vk cv c1
        caddc co cexp co c2 vk cv c1 caddc co cexp co divrec vk cv cn wcel c2
        vk cv c1 caddc co cexp co c2 cr wcel vk cv c1 caddc co cn0 wcel c2 vk
        cv c1 caddc co cexp co cr wcel vk cv cn wcel c2 vk cv c1 caddc co
        reexpcl 2re vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co
        cn0 wcel vk cv peano2nn vk cv c1 caddc co nnnn0 syl sylancr recnd vk cv
        cn wcel c2 vk cv c1 caddc co cexp co c2 cr wcel vk cv c1 caddc co cn0
        wcel c2 vk cv c1 caddc co cexp co cr wcel vk cv cn wcel c2 vk cv c1
        caddc co reexpcl 2re vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1
        caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co nnnn0 syl sylancr
        recnd vk cv cn wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co
        cexp co crp wcel c2 vk cv c1 caddc co cexp co cc0 wne vk cv cn wcel vk
        cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv
        c1 caddc co nnnn0 syl c2 crp wcel vk cv c1 caddc co cn0 wcel c2 vk cv
        c1 caddc co cexp co crp wcel c2 2re 2pos elrpii c2 vk cv c1 caddc co
        rpexpcl mpan c2 vk cv c1 caddc co cexp co rpne0 3syl syl3anc c2 vk cv
        c1 caddc co cexp co cc wcel c2 vk cv c1 caddc co cexp co cc0 wne c2 vk
        cv c1 caddc co cexp co c2 vk cv c1 caddc co cexp co cdiv co c1 wceq vk
        cv cn wcel c2 vk cv c1 caddc co cexp co divid vk cv cn wcel c2 vk cv c1
        caddc co cexp co c2 cr wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1
        caddc co cexp co cr wcel vk cv cn wcel c2 vk cv c1 caddc co reexpcl 2re
        vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk
        cv peano2nn vk cv c1 caddc co nnnn0 syl sylancr recnd vk cv cn wcel vk
        cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co crp wcel c2 vk cv
        c1 caddc co cexp co cc0 wne vk cv cn wcel vk cv c1 caddc co cn wcel vk
        cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co nnnn0 syl c2
        crp wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co crp
        wcel c2 2re 2pos elrpii c2 vk cv c1 caddc co rpexpcl mpan c2 vk cv c1
        caddc co cexp co rpne0 3syl sylanc eqtr3d opreq12d c2 c1 caddc co c3
        wceq vk cv cn wcel c3 c2 c1 caddc co df-3 eqcomi a1i 3eqtrd vk cv cn
        wcel c2 vk cv c1 caddc co vk cv c1 cmin co cmin co cexp co c2 vk cv c1
        caddc co cexp co c2 vk cv c1 cmin co cexp co cdiv co c4 c2 vk cv c1
        caddc co cexp co c1 c2 vk cv c1 cmin co cexp co cdiv co cmul co c2 cc
        wcel c2 cc0 wne wa vk cv c1 caddc co cn0 wcel vk cv c1 cmin co cn0 wcel
        w3a vk cv c1 cmin co vk cv c1 caddc co cle wbr c2 vk cv c1 caddc co vk
        cv c1 cmin co cmin co cexp co c2 vk cv c1 caddc co cexp co c2 vk cv c1
        cmin co cexp co cdiv co wceq vk cv cn wcel c2 vk cv c1 caddc co vk cv
        c1 cmin co expsub vk cv cn wcel c2 cc wcel c2 cc0 wne wa vk cv c1 caddc
        co cn0 wcel vk cv c1 cmin co cn0 wcel c2 cc wcel c2 cc0 wne wa vk cv cn
        wcel c2 cc wcel c2 cc0 wne 2cn 2ne0 pm3.2i a1i vk cv cn wcel vk cv c1
        caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1
        caddc co nnnn0 syl vk cv nnm1nn0 3jca vk cv cn wcel cc0 vk cv c1 caddc
        co vk cv c1 cmin co cmin co cle wbr vk cv c1 cmin co vk cv c1 caddc co
        cle wbr vk cv cn wcel c2 vk cv c1 caddc co vk cv c1 cmin co cmin co cc0
        cle vk cv cn wcel vk cv c1 caddc co vk cv c1 cmin co cmin co c1 c1
        caddc co c2 vk cv cc wcel c1 cc wcel c1 cc wcel vk cv c1 caddc co vk cv
        c1 cmin co cmin co c1 c1 caddc co wceq vk cv cn wcel vk cv c1 c1 pnncan
        vk cv nncn c1 cc wcel vk cv cn wcel ax1cn a1i c1 cc wcel vk cv cn wcel
        ax1cn a1i syl3anc df-2 syl6eqr cc0 c2 0re 2re 2pos ltleii syl5breqr vk
        cv c1 caddc co cr wcel vk cv c1 cmin co cr wcel cc0 vk cv c1 caddc co
        vk cv c1 cmin co cmin co cle wbr vk cv c1 cmin co vk cv c1 caddc co cle
        wbr wb vk cv cn wcel vk cv c1 caddc co vk cv c1 cmin co subge0 vk cv cn
        wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cr wcel vk cv peano2nn
        vk cv c1 caddc co nnre syl vk cv cr wcel c1 cr wcel vk cv c1 cmin co cr
        wcel vk cv cn wcel vk cv c1 resubcl vk cv nnre 1re sylancl sylanc mpbid
        sylanc vk cv cn wcel c2 vk cv c1 caddc co vk cv c1 cmin co cmin co cexp
        co c2 c2 cexp co c4 vk cv cn wcel vk cv c1 caddc co vk cv c1 cmin co
        cmin co c2 c2 cexp vk cv cn wcel vk cv c1 caddc co vk cv c1 cmin co
        cmin co c1 c1 caddc co c2 vk cv cc wcel c1 cc wcel c1 cc wcel vk cv c1
        caddc co vk cv c1 cmin co cmin co c1 c1 caddc co wceq vk cv cn wcel vk
        cv c1 c1 pnncan vk cv nncn c1 cc wcel vk cv cn wcel ax1cn a1i c1 cc
        wcel vk cv cn wcel ax1cn a1i syl3anc df-2 syl6eqr opreq2d sq2 syl6eq c2
        vk cv c1 caddc co cexp co cc wcel c2 vk cv c1 cmin co cexp co cc wcel
        c2 vk cv c1 cmin co cexp co cc0 wne c2 vk cv c1 caddc co cexp co c2 vk
        cv c1 cmin co cexp co cdiv co c2 vk cv c1 caddc co cexp co c1 c2 vk cv
        c1 cmin co cexp co cdiv co cmul co wceq vk cv cn wcel c2 vk cv c1 caddc
        co cexp co c2 vk cv c1 cmin co cexp co divrec vk cv cn wcel c2 vk cv c1
        caddc co cexp co c2 cr wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1
        caddc co cexp co cr wcel vk cv cn wcel c2 vk cv c1 caddc co reexpcl 2re
        vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk
        cv peano2nn vk cv c1 caddc co nnnn0 syl sylancr recnd vk cv cn wcel vk
        cv c1 cmin co cn0 wcel c2 vk cv c1 cmin co cexp co crp wcel c2 vk cv c1
        cmin co cexp co cc wcel vk cv nnm1nn0 c2 crp wcel vk cv c1 cmin co cn0
        wcel c2 vk cv c1 cmin co cexp co crp wcel c2 2re 2pos elrpii c2 vk cv
        c1 cmin co rpexpcl mpan c2 vk cv c1 cmin co cexp co rpcn 3syl vk cv cn
        wcel vk cv c1 cmin co cn0 wcel c2 vk cv c1 cmin co cexp co crp wcel c2
        vk cv c1 cmin co cexp co cc0 wne vk cv nnm1nn0 c2 crp wcel vk cv c1
        cmin co cn0 wcel c2 vk cv c1 cmin co cexp co crp wcel c2 2re 2pos
        elrpii c2 vk cv c1 cmin co rpexpcl mpan c2 vk cv c1 cmin co cexp co
        rpne0 3syl syl3anc 3eqtr3rd 3brtr4d c1 c2 vk cv cexp co cdiv co c1 c2
        vk cv c1 caddc co cexp co cdiv co caddc co cr wcel c1 c2 vk cv c1 cmin
        co cexp co cdiv co cr wcel c2 vk cv c1 caddc co cexp co cr wcel w3a cc0
        c2 vk cv c1 caddc co cexp co clt wbr c1 c2 vk cv cexp co cdiv co c1 c2
        vk cv c1 caddc co cexp co cdiv co caddc co c1 c2 vk cv c1 cmin co cexp
        co cdiv co clt wbr c2 vk cv c1 caddc co cexp co c1 c2 vk cv cexp co
        cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co cmul co c2 vk
        cv c1 caddc co cexp co c1 c2 vk cv c1 cmin co cexp co cdiv co cmul co
        clt wbr wb vk cv cn wcel c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1
        caddc co cexp co cdiv co caddc co cr wcel c1 c2 vk cv c1 cmin co cexp
        co cdiv co cr wcel c2 vk cv c1 caddc co cexp co cr wcel cc0 c2 vk cv c1
        caddc co cexp co clt wbr c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1
        caddc co cexp co cdiv co caddc co c1 c2 vk cv c1 cmin co cexp co cdiv
        co clt wbr c2 vk cv c1 caddc co cexp co c1 c2 vk cv cexp co cdiv co c1
        c2 vk cv c1 caddc co cexp co cdiv co caddc co cmul co c2 vk cv c1 caddc
        co cexp co c1 c2 vk cv c1 cmin co cexp co cdiv co cmul co clt wbr wb c1
        c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc
        co cr wcel c1 c2 vk cv c1 cmin co cexp co cdiv co cr wcel c2 vk cv c1
        caddc co cexp co cr wcel cc0 c2 vk cv c1 caddc co cexp co clt wbr c1 c2
        vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co
        c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr c2 vk cv c1 caddc co
        cexp co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co
        cdiv co caddc co cmul co c2 vk cv c1 caddc co cexp co c1 c2 vk cv c1
        cmin co cexp co cdiv co cmul co clt wbr wb c1 c2 vk cv cexp co cdiv co
        c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co cr wcel c1 c2 vk cv c1
        cmin co cexp co cdiv co cr wcel c2 vk cv c1 caddc co cexp co cr wcel
        cc0 c2 vk cv c1 caddc co cexp co clt wbr wa c1 c2 vk cv cexp co cdiv co
        c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co c1 c2 vk cv c1 cmin co
        cexp co cdiv co clt wbr c2 vk cv c1 caddc co cexp co c1 c2 vk cv cexp
        co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co cmul co c2
        vk cv c1 caddc co cexp co c1 c2 vk cv c1 cmin co cexp co cdiv co cmul
        co clt wbr wb c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp
        co cdiv co caddc co c1 c2 vk cv c1 cmin co cexp co cdiv co c2 vk cv c1
        caddc co cexp co ltmul2 3exp exp4a 3imp1 vk cv cn wcel c1 c2 vk cv cexp
        co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc co cr wcel c1
        c2 vk cv c1 cmin co cexp co cdiv co cr wcel c2 vk cv c1 caddc co cexp
        co cr wcel c1 c2 vk cv cexp co cdiv co cr wcel c1 c2 vk cv c1 caddc co
        cexp co cdiv co cr wcel c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1
        caddc co cexp co cdiv co caddc co cr wcel vk cv cn wcel c1 c2 vk cv
        cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co readdcl vk cv
        cn wcel c1 c2 vk cv cexp co cdiv co crp wcel c1 c2 vk cv cexp co cdiv
        co cr wcel vk cv cn wcel vk cv cn0 wcel c2 vk cv cexp co crp wcel c1 c2
        vk cv cexp co cdiv co crp wcel vk cv nnnn0 c2 crp wcel vk cv cn0 wcel
        c2 vk cv cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl mpan c2
        vk cv cexp co rpreccl 3syl c1 c2 vk cv cexp co cdiv co rpre syl vk cv
        cn wcel c1 c2 vk cv c1 caddc co cexp co cdiv co crp wcel c1 c2 vk cv c1
        caddc co cexp co cdiv co cr wcel vk cv cn wcel vk cv c1 caddc co cn0
        wcel c2 vk cv c1 caddc co cexp co crp wcel c1 c2 vk cv c1 caddc co cexp
        co cdiv co crp wcel vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1
        caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co nnnn0 syl c2 crp
        wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co crp wcel
        c2 2re 2pos elrpii c2 vk cv c1 caddc co rpexpcl mpan c2 vk cv c1 caddc
        co cexp co rpreccl 3syl c1 c2 vk cv c1 caddc co cexp co cdiv co rpre
        syl sylanc vk cv cn wcel c1 c2 vk cv c1 cmin co cexp co cdiv co crp
        wcel c1 c2 vk cv c1 cmin co cexp co cdiv co cr wcel vk cv cn wcel vk cv
        c1 cmin co cn0 wcel c2 vk cv c1 cmin co cexp co crp wcel c1 c2 vk cv c1
        cmin co cexp co cdiv co crp wcel vk cv nnm1nn0 c2 crp wcel vk cv c1
        cmin co cn0 wcel c2 vk cv c1 cmin co cexp co crp wcel c2 2re 2pos
        elrpii c2 vk cv c1 cmin co rpexpcl mpan c2 vk cv c1 cmin co cexp co
        rpreccl 3syl c1 c2 vk cv c1 cmin co cexp co cdiv co rpre syl c2 cr wcel
        vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co cr wcel vk cv
        cn wcel c2 vk cv c1 caddc co reexpcl 2re vk cv cn wcel vk cv c1 caddc
        co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co
        nnnn0 syl sylancr 3jca c2 cr wcel vk cv c1 caddc co cn0 wcel cc0 c2 clt
        wbr cc0 c2 vk cv c1 caddc co cexp co clt wbr vk cv cn wcel c2 vk cv c1
        caddc co expgt0 c2 cr wcel vk cv cn wcel 2re a1i vk cv cn wcel vk cv c1
        caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1
        caddc co nnnn0 syl cc0 c2 clt wbr vk cv cn wcel 2pos a1i syl3anc sylanc
        mpbird ad2antlr vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv
        cM co cr wcel c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp
        co cdiv co caddc co cr wcel c1 c2 vk cv c1 cmin co cexp co cdiv co cr
        wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1
        c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co caddc
        co clt wbr c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co
        cdiv co caddc co c1 c2 vk cv c1 cmin co cexp co cdiv co clt wbr wa vk
        cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv
        c1 cmin co cexp co cdiv co clt wbr wi vk cv cH cfv c1st cfv cX wcel vk
        cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX
        wcel wa vk cv cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co
        c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co
        caddc co c1 c2 vk cv c1 cmin co cexp co cdiv co lttr vk cv cH cfv c1st
        cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vk cv cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c1st cfv cM co cr wcel vk cv cn wcel
        vy cv cX wcel cM cme wcel vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc
        co cH cfv c1st cfv cX wcel vk cv cH cfv c1st cfv vk cv c1 caddc co cH
        cfv c1st cfv cM co cr wcel cM heibor.9 cmsmeti vk cv cH cfv c1st cfv vk
        cv c1 caddc co cH cfv c1st cfv cM cX heibor.2 metcl mp3an1 ad2antrr c1
        c2 vk cv cexp co cdiv co cr wcel c1 c2 vk cv c1 caddc co cexp co cdiv
        co cr wcel c1 c2 vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co
        cdiv co caddc co cr wcel vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc
        co cH cfv c1st cfv cX wcel wa vk cv cn wcel wa vy cv cX wcel wa c1 c2
        vk cv cexp co cdiv co c1 c2 vk cv c1 caddc co cexp co cdiv co readdcl
        vk cv cn wcel c1 c2 vk cv cexp co cdiv co cr wcel vk cv cH cfv c1st cfv
        cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel wa vy cv cX wcel vk
        cv cn wcel c1 c2 vk cv cexp co cdiv co crp wcel c1 c2 vk cv cexp co
        cdiv co cr wcel vk cv cn wcel vk cv cn0 wcel c2 vk cv cexp co crp wcel
        c1 c2 vk cv cexp co cdiv co crp wcel vk cv nnnn0 c2 crp wcel vk cv cn0
        wcel c2 vk cv cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl mpan
        c2 vk cv cexp co rpreccl 3syl c1 c2 vk cv cexp co cdiv co rpre syl
        ad2antlr vk cv cn wcel c1 c2 vk cv c1 caddc co cexp co cdiv co cr wcel
        vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel
        wa vy cv cX wcel vk cv cn wcel c1 c2 vk cv c1 caddc co cexp co cdiv co
        crp wcel c1 c2 vk cv c1 caddc co cexp co cdiv co cr wcel vk cv cn wcel
        vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co cexp co crp wcel c1 c2
        vk cv c1 caddc co cexp co cdiv co crp wcel vk cv cn wcel vk cv c1 caddc
        co cn wcel vk cv c1 caddc co cn0 wcel vk cv peano2nn vk cv c1 caddc co
        nnnn0 syl c2 crp wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co
        cexp co crp wcel c2 2re 2pos elrpii c2 vk cv c1 caddc co rpexpcl mpan
        c2 vk cv c1 caddc co cexp co rpreccl 3syl c1 c2 vk cv c1 caddc co cexp
        co cdiv co rpre syl ad2antlr sylanc vk cv cn wcel c1 c2 vk cv c1 cmin
        co cexp co cdiv co cr wcel vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc
        co cH cfv c1st cfv cX wcel wa vy cv cX wcel vk cv cn wcel c1 c2 vk cv
        c1 cmin co cexp co cdiv co crp wcel c1 c2 vk cv c1 cmin co cexp co cdiv
        co cr wcel vk cv cn wcel vk cv c1 cmin co cn0 wcel c2 vk cv c1 cmin co
        cexp co crp wcel c1 c2 vk cv c1 cmin co cexp co cdiv co crp wcel vk cv
        nnm1nn0 c2 crp wcel vk cv c1 cmin co cn0 wcel c2 vk cv c1 cmin co cexp
        co crp wcel c2 2re 2pos elrpii c2 vk cv c1 cmin co rpexpcl mpan c2 vk
        cv c1 cmin co cexp co rpreccl 3syl c1 c2 vk cv c1 cmin co cexp co cdiv
        co rpre syl ad2antlr syl3anc mpan2d syld mpand syld expimpd vy cv cX
        wcel vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv c1 caddc
        co cexp co cdiv co clt wbr vk cv cH cfv c1st cfv vy cv cM co c1 c2 vk
        cv cexp co cdiv co clt wbr anandi syl5ibr vk cv c1 caddc co cH cfv c1st
        cfv cX wcel vk cv cn wcel vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2
        vk cv c1 caddc co cexp co cdiv co cM cbl cfv co wcel vy cv cX wcel vk
        cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv c1 caddc co cexp
        co cdiv co clt wbr wa wi vk cv cH cfv c1st cfv cX wcel vk cv c1 caddc
        co cH cfv c1st cfv cX wcel vk cv cn wcel wa vy cv vk cv c1 caddc co cH
        cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co cdiv co cM cbl cfv co wcel
        vy cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv
        c1 caddc co cexp co cdiv co clt wbr wa vk cv c1 caddc co cH cfv c1st
        cfv cX wcel c1 c2 vk cv c1 caddc co cexp co cdiv co cr wcel cc0 c1 c2
        vk cv c1 caddc co cexp co cdiv co clt wbr wa vy cv vk cv c1 caddc co cH
        cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co cdiv co cM cbl cfv co wcel
        vy cv cX wcel vk cv c1 caddc co cH cfv c1st cfv vy cv cM co c1 c2 vk cv
        c1 caddc co cexp co cdiv co clt wbr wa wb vk cv cn wcel cM cme wcel vk
        cv c1 caddc co cH cfv c1st cfv cX wcel c1 c2 vk cv c1 caddc co cexp co
        cdiv co cr wcel cc0 c1 c2 vk cv c1 caddc co cexp co cdiv co clt wbr wa
        vy cv vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk cv c1 caddc co cexp co
        cdiv co cM cbl cfv co wcel vy cv cX wcel vk cv c1 caddc co cH cfv c1st
        cfv vy cv cM co c1 c2 vk cv c1 caddc co cexp co cdiv co clt wbr wa wb
        cM heibor.9 cmsmeti vy cv cM vk cv c1 caddc co cH cfv c1st cfv c1 c2 vk
        cv c1 caddc co cexp co cdiv co cX heibor.2 elbl mpanl1 vk cv cn wcel c1
        c2 vk cv c1 caddc co cexp co cdiv co crp wcel c1 c2 vk cv c1 caddc co
        cexp co cdiv co cr wcel cc0 c1 c2 vk cv c1 caddc co cexp co cdiv co clt
        wbr wa vk cv cn wcel vk cv c1 caddc co cn0 wcel c2 vk cv c1 caddc co
        cexp co crp wcel c1 c2 vk cv c1 caddc co cexp co cdiv co crp wcel vk cv
        cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co cn0 wcel vk cv
        peano2nn vk cv c1 caddc co nnnn0 syl c2 crp wcel vk cv c1 caddc co cn0
        wcel c2 vk cv c1 caddc co cexp co crp wcel c2 2re 2pos elrpii c2 vk cv
        c1 caddc co rpexpcl mpan c2 vk cv c1 caddc co cexp co rpreccl 3syl c1
        c2 vk cv c1 caddc co cexp co cdiv co rpregt0 syl sylan2 biimpd adantll
        vk cv cH cfv c1st cfv cX wcel vk cv cn wcel vy cv vk cv cH cfv c1st cfv
        c1 c2 vk cv cexp co cdiv co cM cbl cfv co wcel vy cv cX wcel vk cv cH
        cfv c1st cfv vy cv cM co c1 c2 vk cv cexp co cdiv co clt wbr wa wi vk
        cv c1 caddc co cH cfv c1st cfv cX wcel vk cv cH cfv c1st cfv cX wcel vk
        cv cn wcel wa vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co
        cM cbl cfv co wcel vy cv cX wcel vk cv cH cfv c1st cfv vy cv cM co c1
        c2 vk cv cexp co cdiv co clt wbr wa vk cv cH cfv c1st cfv cX wcel c1 c2
        vk cv cexp co cdiv co cr wcel cc0 c1 c2 vk cv cexp co cdiv co clt wbr
        wa vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cM cbl cfv
        co wcel vy cv cX wcel vk cv cH cfv c1st cfv vy cv cM co c1 c2 vk cv
        cexp co cdiv co clt wbr wa wb vk cv cn wcel cM cme wcel vk cv cH cfv
        c1st cfv cX wcel c1 c2 vk cv cexp co cdiv co cr wcel cc0 c1 c2 vk cv
        cexp co cdiv co clt wbr wa vy cv vk cv cH cfv c1st cfv c1 c2 vk cv cexp
        co cdiv co cM cbl cfv co wcel vy cv cX wcel vk cv cH cfv c1st cfv vy cv
        cM co c1 c2 vk cv cexp co cdiv co clt wbr wa wb cM heibor.9 cmsmeti vy
        cv cM vk cv cH cfv c1st cfv c1 c2 vk cv cexp co cdiv co cX heibor.2
        elbl mpanl1 vk cv cn wcel c1 c2 vk cv cexp co cdiv co crp wcel c1 c2 vk
        cv cexp co cdiv co cr wcel cc0 c1 c2 vk cv cexp co cdiv co clt wbr wa
        vk cv cn wcel vk cv cn0 wcel c2 vk cv cexp co crp wcel c1 c2 vk cv cexp
        co cdiv co crp wcel vk cv nnnn0 c2 crp wcel vk cv cn0 wcel c2 vk cv
        cexp co crp wcel c2 2re 2pos elrpii c2 vk cv rpexpcl mpan c2 vk cv cexp
        co rpreccl 3syl c1 c2 vk cv cexp co cdiv co rpregt0 syl sylan2 biimpd
        adantlr syl2and adantlrr adantllr syl9 ex com23 expdimp an4s impcom
        exp3a com23 adantld com23 adantld ex vk cv cH cfv cB wcel vk cv cH cfv
        cX crp cxp wcel vk cv cH cfv vk cv cH cfv c1st cfv vk cv cH cfv c2nd
        cfv cop wceq vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv crp
        wcel wa wa vk cv cH cfv cB wcel vk cv cH cfv cX crp cxp wcel vk cv cH
        cfv cM cbl cfv cfv cD wcel vx vv vk cv cH cfv cB cD cU cJ cM cX vs vr
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heiborlem24 pm3.26bi vk cv cH cfv cX crp elxp6 sylib vk cv c1
        caddc co cH cfv cB wcel vk cv c1 caddc co cH cfv cX crp cxp wcel vk cv
        c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co
        cH cfv c2nd cfv cop wceq vk cv c1 caddc co cH cfv c1st cfv cX wcel vk
        cv c1 caddc co cH cfv c2nd cfv crp wcel wa wa vk cv c1 caddc co cH cfv
        cB wcel vk cv c1 caddc co cH cfv cX crp cxp wcel vk cv c1 caddc co cH
        cfv cM cbl cfv cfv cD wcel vx vv vk cv c1 caddc co cH cfv cB cD cU cJ
        cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heiborlem24 pm3.26bi vk cv c1 caddc co cH cfv cX
        crp elxp6 sylib syl2ani adantl mp2and vk cv c2 cuz cfv wcel vk cv c1
        cuz cfv wcel vk cv cn wcel c2 cuz cfv c1 cuz cfv vk cv c2 c1 cuz cfv
        wcel c2 cuz cfv c1 cuz cfv wss c2 c1 cuz cfv wcel c1 c2 cle wbr c1 c2
        1re 2re 1lt2 ltleii c1 cz wcel c2 cz wcel c2 c1 cuz cfv wcel c1 c2 cle
        wbr wb 1z 2z c1 c2 eluz mp2an mpbir c1 c2 uzss ax-mp sseli vk cv elnnuz
        sylibr sylan2 adantlr mpd imp 19.23adv vy vk cv c1 caddc co cH cfv cM
        cbl cfv cfv vk cv cH cfv cM cbl cfv cfv cin n0 syl5ib expimpd r19.20dva
        imp vk cv cH cfv c1st cfv cX wcel vk cv cH cfv c2nd cfv c1 c2 vk cv
        cexp co cdiv co wceq wa vk cv c1 caddc co cH cfv cM cbl cfv cfv vk cv
        cH cfv cM cbl cfv cfv cin c0 wne vk c2 cuz cfv r19.26 sylan2br mpdan $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The centers of the balls in ` H ` form a Cauchy
         sequence. $)
      heiborlem33 $p |- ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                ( ( g + 1 ) G ( H ` g ) ) ) -> ( 1st o. H ) e. ( Cau ` M ) ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa c1st cH ccom cM cca cfv wcel c1st cH ccom c2 cuz
        cfv cres cM cca cfv wcel cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral wa vt cv cn wcel vu cv vt
        cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab cM cca cfv wcel c1st
        cH ccom c2 cuz cfv cres cM cca cfv wcel cM cme wcel cn cX vt cv cn wcel
        vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab wf wa c1 cr
        wcel c1 c2 cdiv co crp wcel c1 c2 cdiv co c1 clt wbr w3a vk cv vt cv cn
        wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab cfv vk
        cv c1 caddc co vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv
        wceq wa vt vu copab cfv cM co c1 c1 c2 cdiv co vk cv cexp co cmul co
        cle wbr vk cn wral vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st
        cfv wceq wa vt vu copab cM cca cfv wcel cn cB cH wf vg cv c1 caddc co
        cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa c1 c1 c2
        cdiv co vk vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq
        wa vt vu copab cM cX heibor.2 geomcau cn cB cH wf vg cv c1 caddc co cH
        cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cn cX vt cv
        cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab wf
        cM cme wcel cn cB cH wf cn cX vt cv cn wcel vu cv vt cv c1 caddc co cH
        cfv c1st cfv wceq wa vt vu copab wf vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral cn cB cH wf vt cv c1 caddc
        co cH cfv c1st cfv cX wcel vt cn wral cn cX vt cv cn wcel vu cv vt cv
        c1 caddc co cH cfv c1st cfv wceq wa vt vu copab wf cn cB cH wf vt cv c1
        caddc co cH cfv c1st cfv cX wcel vt cn cn cB cH wf vt cv c1 caddc co cn
        wcel vt cv c1 caddc co cH cfv c1st cfv cX wcel vt cv cn wcel cn cB cH
        wf vt cv c1 caddc co cn wcel wa vt cv c1 caddc co cH cfv cB wcel vt cv
        c1 caddc co cH cfv c1st cfv cX wcel cn cB vt cv c1 caddc co cH ffvelrn
        vt cv c1 caddc co cH cfv cB wcel vt cv c1 caddc co cH cfv cX crp cxp
        wcel vt cv c1 caddc co cH cfv cM cbl cfv cfv cD wcel wa vt cv c1 caddc
        co cH cfv c1st cfv cX wcel vx vv vt cv c1 caddc co cH cfv cB cD cU cJ
        cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heiborlem24 vt cv c1 caddc co cH cfv cX crp cxp
        wcel vt cv c1 caddc co cH cfv c1st cfv cX wcel vt cv c1 caddc co cH cfv
        cM cbl cfv cfv cD wcel vt cv c1 caddc co cH cfv cX crp xp1st adantr
        sylbi syl vt cv peano2nn sylan2 r19.21aiva vt vu cn cX vt cv c1 caddc
        co cH cfv c1st cfv vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st
        cfv wceq wa vt vu copab vt cv cn wcel vu cv vt cv c1 caddc co cH cfv
        c1st cfv wceq wa vt vu copab eqid fopab2 sylib adantr cM heibor.9
        cmsmeti jctil c1 cr wcel c1 c2 cdiv co crp wcel c1 c2 cdiv co c1 clt
        wbr w3a cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral wa c1 cr wcel c1 c2 cdiv co crp wcel c1 c2
        cdiv co c1 clt wbr 1re c2 crp wcel c1 c2 cdiv co crp wcel c2 2re 2pos
        elrpii c2 rpreccl ax-mp halflt1 3pm3.2i a1i cn cB cH wf vg cv c1 caddc
        co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa vk cv
        vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu
        copab cfv vk cv c1 caddc co vt cv cn wcel vu cv vt cv c1 caddc co cH
        cfv c1st cfv wceq wa vt vu copab cfv cM co c1 c1 c2 cdiv co vk cv cexp
        co cmul co cle wbr vk cn cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral wa vk cv cn wcel wa vk cv
        c1 caddc co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st
        cfv cM co c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co vk cv vt
        cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab
        cfv vk cv c1 caddc co vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st
        cfv wceq wa vt vu copab cfv cM co c1 c1 c2 cdiv co vk cv cexp co cmul
        co cle cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral wa vk cv cn wcel wa vk cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM co c1 c2 vk
        cv c1 caddc co c1 cmin co cexp co cdiv co clt wbr vk cv c1 caddc co cH
        cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM co c1 c2
        vk cv c1 caddc co c1 cmin co cexp co cdiv co cle wbr vj cv cH cfv c1st
        cfv vj cv c1 caddc co cH cfv c1st cfv cM co c1 c2 vj cv c1 cmin co cexp
        co cdiv co clt wbr vj c2 cuz cfv wral vk cv c1 caddc co c2 cuz cfv wcel
        vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv
        c1st cfv cM co c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co clt
        wbr cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv
        cG co wcel vg cn wral wa vk cv cn wcel vj cv cH cfv c1st cfv vj cv c1
        caddc co cH cfv c1st cfv cM co c1 c2 vj cv c1 cmin co cexp co cdiv co
        clt wbr vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co
        cH cfv c1st cfv cM co c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv
        co clt wbr vj vk cv c1 caddc co c2 cuz cfv vj cv vk cv c1 caddc co wceq
        vj cv cH cfv c1st cfv vj cv c1 caddc co cH cfv c1st cfv cM co vk cv c1
        caddc co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv
        cM co c1 c2 vj cv c1 cmin co cexp co cdiv co c1 c2 vk cv c1 caddc co c1
        cmin co cexp co cdiv co clt vj cv vk cv c1 caddc co wceq vj cv cH cfv
        c1st cfv vk cv c1 caddc co cH cfv c1st cfv vj cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM vj cv vk cv
        c1 caddc co wceq vj cv cH cfv vk cv c1 caddc co cH cfv c1st vj cv vk cv
        c1 caddc co cH fveq2 fveq2d vj cv vk cv c1 caddc co wceq vj cv c1 caddc
        co cH cfv vk cv c1 caddc co c1 caddc co cH cfv c1st vj cv vk cv c1
        caddc co wceq vj cv c1 caddc co vk cv c1 caddc co c1 caddc co cH vj cv
        vk cv c1 caddc co c1 caddc opreq1 fveq2d fveq2d opreq12d vj cv vk cv c1
        caddc co wceq c2 vj cv c1 cmin co cexp co c2 vk cv c1 caddc co c1 cmin
        co cexp co c1 cdiv vj cv vk cv c1 caddc co wceq vj cv c1 cmin co vk cv
        c1 caddc co c1 cmin co c2 cexp vj cv vk cv c1 caddc co c1 cmin opreq1
        opreq2d opreq2d breq12d rcla4cva vx vv cB cD cU vg vh vj vn cG cH cJ cM
        cX vs vr va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heibor.15 heiborlem32 vk cv cn wcel vk cv c1 caddc
        co c1 c1 caddc co cuz cfv c2 cuz cfv vk cv cn wcel vk cv c1 cuz cfv
        wcel vk cv c1 caddc co c1 c1 caddc co cuz cfv wcel vk cv elnnuz c1 vk
        cv eluzp1p1 sylbi c2 c1 c1 caddc co cuz df-2 fveq2i syl6eleqr syl2an cn
        cB cH wf vk cv cn wcel vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc
        co c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 caddc co c1 cmin co
        cexp co cdiv co clt wbr vk cv c1 caddc co cH cfv c1st cfv vk cv c1
        caddc co c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 caddc co c1
        cmin co cexp co cdiv co cle wbr wi vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral vk cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM co cr wcel c1
        c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co cr wcel vk cv c1 caddc
        co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM co
        c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co clt wbr vk cv c1
        caddc co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv
        cM co c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co cle wbr wi cn
        cB cH wf vk cv cn wcel wa vk cv c1 caddc co cH cfv c1st cfv vk cv c1
        caddc co c1 caddc co cH cfv c1st cfv cM co c1 c2 vk cv c1 caddc co c1
        cmin co cexp co cdiv co ltle cM cme wcel vk cv c1 caddc co cH cfv c1st
        cfv cX wcel vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cX wcel vk cv
        c1 caddc co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st
        cfv cM co cr wcel cn cB cH wf vk cv cn wcel wa vk cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM cX heibor.2
        metcl cM cme wcel cn cB cH wf vk cv cn wcel wa cM heibor.9 cmsmeti a1i
        cn cB cH wf vk cv c1 caddc co cn wcel vk cv c1 caddc co cH cfv c1st cfv
        cX wcel vk cv cn wcel cn cB cH wf vk cv c1 caddc co cn wcel wa vk cv c1
        caddc co cH cfv cB wcel vk cv c1 caddc co cH cfv c1st cfv cX wcel cn cB
        vk cv c1 caddc co cH ffvelrn vk cv c1 caddc co cH cfv cB wcel vk cv c1
        caddc co cH cfv cX crp cxp wcel vk cv c1 caddc co cH cfv cM cbl cfv cfv
        cD wcel wa vk cv c1 caddc co cH cfv c1st cfv cX wcel vx vv vk cv c1
        caddc co cH cfv cB cD cU cJ cM cX vs vr heibor.1 heibor.2 heibor.9
        heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heiborlem24 vk cv c1
        caddc co cH cfv cX crp cxp wcel vk cv c1 caddc co cH cfv c1st cfv cX
        wcel vk cv c1 caddc co cH cfv cM cbl cfv cfv cD wcel vk cv c1 caddc co
        cH cfv cX crp xp1st adantr sylbi syl vk cv peano2nn sylan2 cn cB cH wf
        vk cv c1 caddc co c1 caddc co cn wcel vk cv c1 caddc co c1 caddc co cH
        cfv c1st cfv cX wcel vk cv cn wcel cn cB cH wf vk cv c1 caddc co c1
        caddc co cn wcel wa vk cv c1 caddc co c1 caddc co cH cfv cB wcel vk cv
        c1 caddc co c1 caddc co cH cfv c1st cfv cX wcel cn cB vk cv c1 caddc co
        c1 caddc co cH ffvelrn vk cv c1 caddc co c1 caddc co cH cfv cB wcel vk
        cv c1 caddc co c1 caddc co cH cfv cX crp cxp wcel vk cv c1 caddc co c1
        caddc co cH cfv cM cbl cfv cfv cD wcel wa vk cv c1 caddc co c1 caddc co
        cH cfv c1st cfv cX wcel vx vv vk cv c1 caddc co c1 caddc co cH cfv cB
        cD cU cJ cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10 heibor.11
        heibor.12 heibor.13 heibor.14 heiborlem24 vk cv c1 caddc co c1 caddc co
        cH cfv cX crp cxp wcel vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cX
        wcel vk cv c1 caddc co c1 caddc co cH cfv cM cbl cfv cfv cD wcel vk cv
        c1 caddc co c1 caddc co cH cfv cX crp xp1st adantr sylbi syl vk cv cn
        wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co c1 caddc co cn wcel vk
        cv peano2nn vk cv c1 caddc co peano2nn syl sylan2 syl3anc vk cv cn wcel
        c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co cr wcel cn cB cH wf
        vk cv cn wcel c2 vk cv c1 caddc co c1 cmin co cexp co crp wcel c1 c2 vk
        cv c1 caddc co c1 cmin co cexp co cdiv co crp wcel c1 c2 vk cv c1 caddc
        co c1 cmin co cexp co cdiv co cr wcel c2 crp wcel vk cv c1 caddc co c1
        cmin co cn0 wcel c2 vk cv c1 caddc co c1 cmin co cexp co crp wcel vk cv
        cn wcel c2 vk cv c1 caddc co c1 cmin co rpexpcl c2 2re 2pos elrpii vk
        cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co c1 cmin co cn0
        wcel vk cv peano2nn vk cv c1 caddc co nnm1nn0 syl sylancr c2 vk cv c1
        caddc co c1 cmin co cexp co rpreccl c1 c2 vk cv c1 caddc co c1 cmin co
        cexp co cdiv co rpre 3syl adantl sylanc adantlr mpd vk cv cn wcel vk cv
        vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu
        copab cfv vk cv c1 caddc co vt cv cn wcel vu cv vt cv c1 caddc co cH
        cfv c1st cfv wceq wa vt vu copab cfv cM co vk cv c1 caddc co cH cfv
        c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cM co wceq cn cB
        cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co
        wcel vg cn wral wa vk cv cn wcel vk cv vt cv cn wcel vu cv vt cv c1
        caddc co cH cfv c1st cfv wceq wa vt vu copab cfv vk cv c1 caddc co cH
        cfv c1st cfv vk cv c1 caddc co vt cv cn wcel vu cv vt cv c1 caddc co cH
        cfv c1st cfv wceq wa vt vu copab cfv vk cv c1 caddc co c1 caddc co cH
        cfv c1st cfv cM vt vu vk cv vt cv c1 caddc co cH cfv c1st cfv vk cv c1
        caddc co cH cfv c1st cfv cn vt cv cn wcel vu cv vt cv c1 caddc co cH
        cfv c1st cfv wceq wa vt vu copab vt cv vk cv wceq vt cv c1 caddc co cH
        cfv vk cv c1 caddc co cH cfv c1st vt cv vk cv wceq vt cv c1 caddc co vk
        cv c1 caddc co cH vt cv vk cv c1 caddc opreq1 fveq2d fveq2d vt cv cn
        wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab eqid
        vk cv c1 caddc co cH cfv c1st fvex fvopab4 vk cv cn wcel vk cv c1 caddc
        co cn wcel vk cv c1 caddc co vt cv cn wcel vu cv vt cv c1 caddc co cH
        cfv c1st cfv wceq wa vt vu copab cfv vk cv c1 caddc co c1 caddc co cH
        cfv c1st cfv wceq vk cv peano2nn vt vu vk cv c1 caddc co vt cv c1 caddc
        co cH cfv c1st cfv vk cv c1 caddc co c1 caddc co cH cfv c1st cfv cn vt
        cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab
        vt cv vk cv c1 caddc co wceq vt cv c1 caddc co cH cfv vk cv c1 caddc co
        c1 caddc co cH cfv c1st vt cv vk cv c1 caddc co wceq vt cv c1 caddc co
        vk cv c1 caddc co c1 caddc co cH vt cv vk cv c1 caddc co c1 caddc
        opreq1 fveq2d fveq2d vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st
        cfv wceq wa vt vu copab eqid vk cv c1 caddc co c1 caddc co cH cfv c1st
        fvex fvopab4 syl opreq12d adantl vk cv cn wcel c1 c1 c2 cdiv co vk cv
        cexp co cmul co c1 c2 vk cv c1 caddc co c1 cmin co cexp co cdiv co wceq
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa vk cv cn wcel c1 c1 c2 cdiv co vk cv cexp co cmul
        co c1 c2 cdiv co vk cv cexp co c1 c2 vk cv cexp co cdiv co c1 c2 vk cv
        c1 caddc co c1 cmin co cexp co cdiv co vk cv cn wcel c1 c2 cdiv co vk
        cv cexp co cc wcel c1 c1 c2 cdiv co vk cv cexp co cmul co c1 c2 cdiv co
        vk cv cexp co wceq c1 c2 cdiv co cc wcel vk cv cn0 wcel c1 c2 cdiv co
        vk cv cexp co cc wcel vk cv cn wcel c1 c2 cdiv co vk cv expcl c2 2cn
        2ne0 reccli vk cv nnnn0 sylancr c1 c2 cdiv co vk cv cexp co mulid2 syl
        c2 cc wcel c2 cc0 wne vk cv cn0 wcel c1 c2 cdiv co vk cv cexp co c1 c2
        vk cv cexp co cdiv co wceq vk cv cn wcel c2 vk cv exprec c2 cc wcel vk
        cv cn wcel 2cn a1i c2 cc0 wne vk cv cn wcel 2ne0 a1i vk cv nnnn0
        syl3anc vk cv cn wcel c2 vk cv cexp co c2 vk cv c1 caddc co c1 cmin co
        cexp co c1 cdiv vk cv cn wcel vk cv vk cv c1 caddc co c1 cmin co c2
        cexp vk cv cn wcel vk cv c1 caddc co c1 cmin co vk cv vk cv cc wcel c1
        cc wcel vk cv c1 caddc co c1 cmin co vk cv wceq vk cv cn wcel vk cv c1
        pncan vk cv nncn ax1cn sylancl eqcomd opreq2d opreq2d 3eqtrd adantl
        3brtr4d r19.21aiva syl3anc cn cB cH wf vt cv cn wcel vu cv vt cv c1
        caddc co cH cfv c1st cfv wceq wa vt vu copab cM cca cfv wcel c1st cH
        ccom c2 cuz cfv cres cM cca cfv wcel wb vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral cM cme wcel cn cX vt cv
        cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab wf
        c2 cuz cfv cX c1st cH ccom c2 cuz cfv cres wf wa vk cv vt cv cn wcel vu
        cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab cfv vk cv c1
        caddc co c1st cH ccom c2 cuz cfv cres cfv wceq vk cn wral vt cv cn wcel
        vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab cM cca cfv
        wcel c1st cH ccom c2 cuz cfv cres cM cca cfv wcel wb cn cB cH wf vk vt
        cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab
        c1st cH ccom c2 cuz cfv cres c1 cM c1 c2 cuz cfv cX cn 1nn 1nn nnuz c2
        c1 c1 caddc co cuz df-2 fveq2i heibor.2 caushft cM cme wcel cn cB cH wf
        cM heibor.9 cmsmeti a1i cn cB cH wf cn cX vt cv cn wcel vu cv vt cv c1
        caddc co cH cfv c1st cfv wceq wa vt vu copab wf c2 cuz cfv cX c1st cH
        ccom c2 cuz cfv cres wf cn cB cH wf vt cv c1 caddc co cH cfv c1st cfv
        cX wcel vt cn wral cn cX vt cv cn wcel vu cv vt cv c1 caddc co cH cfv
        c1st cfv wceq wa vt vu copab wf cn cB cH wf vt cv c1 caddc co cH cfv
        c1st cfv cX wcel vt cn cn cB cH wf vt cv c1 caddc co cn wcel vt cv c1
        caddc co cH cfv c1st cfv cX wcel vt cv cn wcel cn cB cH wf vt cv c1
        caddc co cn wcel wa vt cv c1 caddc co cH cfv cB wcel vt cv c1 caddc co
        cH cfv c1st cfv cX wcel cn cB vt cv c1 caddc co cH ffvelrn vt cv c1
        caddc co cH cfv cB wcel vt cv c1 caddc co cH cfv cX crp cxp wcel vt cv
        c1 caddc co cH cfv cM cbl cfv cfv cD wcel wa vt cv c1 caddc co cH cfv
        c1st cfv cX wcel vx vv vt cv c1 caddc co cH cfv cB cD cU cJ cM cX vs vr
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heiborlem24 vt cv c1 caddc co cH cfv cX crp cxp wcel vt cv c1
        caddc co cH cfv c1st cfv cX wcel vt cv c1 caddc co cH cfv cM cbl cfv
        cfv cD wcel vt cv c1 caddc co cH cfv cX crp xp1st adantr sylbi syl vt
        cv peano2nn sylan2 r19.21aiva vt vu cn cX vt cv c1 caddc co cH cfv c1st
        cfv vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu
        copab vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt
        vu copab eqid fopab2 sylib c2 cuz cfv cX c1st cH ccom c2 cuz cfv cres
        wf c1st cH ccom c2 cuz cfv cres c2 cuz cfv wfn c1st cH ccom c2 cuz cfv
        cres crn cX wss cn cB cH wf c2 cuz cfv cX c1st cH ccom c2 cuz cfv cres
        df-f c1st cH ccom cn wfn c2 cuz cfv cn wss c1st cH ccom c2 cuz cfv cres
        c2 cuz cfv wfn cn cB cH wf cn c2 cuz cfv c1st cH ccom fnssres c1st cvv
        wfn cH cn wfn cH crn cvv wss c1st cH ccom cn wfn cn cB cH wf cvv cn
        c1st cH fnco c1st cvv wfn cn cB cH wf cvv cvv c1st wfo c1st cvv wfn
        fo1st cvv cvv c1st fofn ax-mp a1i cn cB cH ffn cH crn cvv wss cn cB cH
        wf cH crn ssv a1i syl3anc c2 cuz cfv c1 cuz cfv cn c2 c1 cuz cfv wcel
        c2 cuz cfv c1 cuz cfv wss c2 cn wcel c2 c1 cuz cfv wcel 2nn c2 elnnuz
        mpbi c1 c2 uzss ax-mp nnuz sseqtr4i sylancl cn cB cH wf c1st cH ccom c2
        cuz cfv cima cX c1st cH ccom c2 cuz cfv cres crn cn cB cH wf c1st cH
        ccom c2 cuz cfv cima c1st cH ccom crn cX c1st cH ccom c2 cuz cfv cima
        c1st cH ccom crn wss cn cB cH wf c1st cH ccom c2 cuz cfv imassrn a1i
        c1st cH ccom cn wfn vk cv c1st cH ccom cfv cX wcel vk cn wral c1st cH
        ccom crn cX wss cn cB cH wf vk cn cX c1st cH ccom fnfvrnss c1st cvv wfn
        cH cn wfn cH crn cvv wss c1st cH ccom cn wfn cn cB cH wf cvv cn c1st cH
        fnco c1st cvv wfn cn cB cH wf cvv cvv c1st wfo c1st cvv wfn fo1st cvv
        cvv c1st fofn ax-mp a1i cn cB cH ffn cH crn cvv wss cn cB cH wf cH crn
        ssv a1i syl3anc cn cB cH wf vk cv c1st cH ccom cfv cX wcel vk cn cn cB
        cH wf vk cv cn wcel wa vk cv c1st cH ccom cfv vk cv cH cfv c1st cfv cX
        c1st wfun cH wfun vk cv cH cdm wcel vk cv c1st cH ccom cfv vk cv cH cfv
        c1st cfv wceq cn cB cH wf vk cv cn wcel wa vk cv c1st cH fvco c1st wfun
        cn cB cH wf vk cv cn wcel wa cvv cvv c1st wfo c1st wfun fo1st cvv cvv
        c1st fofun ax-mp a1i cn cB cH wf cH wfun vk cv cn wcel cn cB cH ffun
        adantr cn cB cH wf vk cv cH cdm wcel vk cv cn wcel cn cB cH wf cH cdm
        cn vk cv cn cB cH fdm eleq2d biimpar syl3anc cn cB cH wf vk cv cn wcel
        wa vk cv cH cfv cB wcel vk cv cH cfv c1st cfv cX wcel cn cB vk cv cH
        ffvelrn vk cv cH cfv cB wcel vk cv cH cfv cX crp cxp wcel vk cv cH cfv
        cM cbl cfv cfv cD wcel wa vk cv cH cfv c1st cfv cX wcel vx vv vk cv cH
        cfv cB cD cU cJ cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heibor.14 heiborlem24 vk cv cH cfv cX crp
        cxp wcel vk cv cH cfv c1st cfv cX wcel vk cv cH cfv cM cbl cfv cfv cD
        wcel vk cv cH cfv cX crp xp1st adantr sylbi syl eqeltrd r19.21aiva
        sylanc sstrd c1st cH ccom c2 cuz cfv df-ima syl5ssr sylanbrc jca cn cB
        cH wf vk cv vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv wceq
        wa vt vu copab cfv vk cv c1 caddc co c1st cH ccom c2 cuz cfv cres cfv
        wceq vk cn cn cB cH wf vk cv cn wcel wa vk cv c1 caddc co c1st cH ccom
        cfv vk cv c1 caddc co cH cfv c1st cfv vk cv c1 caddc co c1st cH ccom c2
        cuz cfv cres cfv vk cv vt cv cn wcel vu cv vt cv c1 caddc co cH cfv
        c1st cfv wceq wa vt vu copab cfv c1st wfun cH wfun vk cv c1 caddc co cH
        cdm wcel vk cv c1 caddc co c1st cH ccom cfv vk cv c1 caddc co cH cfv
        c1st cfv wceq cn cB cH wf vk cv cn wcel wa vk cv c1 caddc co c1st cH
        fvco c1st wfun cn cB cH wf vk cv cn wcel wa cvv cvv c1st wfo c1st wfun
        fo1st cvv cvv c1st fofun ax-mp a1i cn cB cH wf cH wfun vk cv cn wcel cn
        cB cH ffun adantr cn cB cH wf vk cv c1 caddc co cn wcel vk cv c1 caddc
        co cH cdm wcel vk cv cn wcel cn cB cH wf vk cv c1 caddc co cH cdm wcel
        vk cv c1 caddc co cn wcel cn cB cH wf cH cdm cn vk cv c1 caddc co cn cB
        cH fdm eleq2d biimpar vk cv peano2nn sylan2 syl3anc vk cv cn wcel vk cv
        c1 caddc co c1st cH ccom c2 cuz cfv cres cfv vk cv c1 caddc co c1st cH
        ccom cfv wceq cn cB cH wf vk cv cn wcel vk cv c1 caddc co c2 cuz cfv
        wcel vk cv c1 caddc co c1st cH ccom c2 cuz cfv cres cfv vk cv c1 caddc
        co c1st cH ccom cfv wceq vk cv cn wcel vk cv c1 caddc co c1 c1 caddc co
        cuz cfv c2 cuz cfv vk cv cn wcel vk cv c1 cuz cfv wcel vk cv c1 caddc
        co c1 c1 caddc co cuz cfv wcel vk cv elnnuz c1 vk cv eluzp1p1 sylbi c2
        c1 c1 caddc co cuz df-2 fveq2i syl6eleqr vk cv c1 caddc co c2 cuz cfv
        c1st cH ccom fvres syl adantl vk cv cn wcel vk cv vt cv cn wcel vu cv
        vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab cfv vk cv c1
        caddc co cH cfv c1st cfv wceq cn cB cH wf vt vu vk cv vt cv c1 caddc co
        cH cfv c1st cfv vk cv c1 caddc co cH cfv c1st cfv cn vt cv cn wcel vu
        cv vt cv c1 caddc co cH cfv c1st cfv wceq wa vt vu copab vt cv vk cv
        wceq vt cv c1 caddc co cH cfv vk cv c1 caddc co cH cfv c1st vt cv vk cv
        wceq vt cv c1 caddc co vk cv c1 caddc co cH vt cv vk cv c1 caddc opreq1
        fveq2d fveq2d vt cv cn wcel vu cv vt cv c1 caddc co cH cfv c1st cfv
        wceq wa vt vu copab eqid vk cv c1 caddc co cH cfv c1st fvex fvopab4
        adantl 3eqtr4rd r19.21aiva syl3anc adantr mpbid cn cB cH wf c1st cH
        ccom cM cca cfv wcel c1st cH ccom c2 cuz cfv cres cM cca cfv wcel wb vg
        cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn
        wral cM cme wcel c1st cH ccom cc cX cxp wss c1st cH ccom cM cca cfv
        wcel c1st cH ccom c2 cuz cfv cres cM cca cfv wcel wb cn cB cH wf c1st
        cH ccom cM c2 cX c2 cuz cfv heibor.2 2z c2 cuz cfv eqid caures cM
        heibor.9 cmsmeti cn cB cH wf c1st cH ccom cn cX cxp cc cX cxp cn cB cH
        wf cn cX c1st cH ccom wf c1st cH ccom cn cX cxp wss cn cX c1st cH ccom
        wf c1st cH ccom cn wfn c1st cH ccom crn cX wss cn cB cH wf cn cX c1st
        cH ccom df-f c1st cvv wfn cH cn wfn cH crn cvv wss c1st cH ccom cn wfn
        cn cB cH wf cvv cn c1st cH fnco c1st cvv wfn cn cB cH wf cvv cvv c1st
        wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp a1i cn cB cH ffn cH crn
        cvv wss cn cB cH wf cH crn ssv a1i syl3anc c1st cH ccom cn wfn vk cv
        c1st cH ccom cfv cX wcel vk cn wral c1st cH ccom crn cX wss cn cB cH wf
        vk cn cX c1st cH ccom fnfvrnss c1st cvv wfn cH cn wfn cH crn cvv wss
        c1st cH ccom cn wfn cn cB cH wf cvv cn c1st cH fnco c1st cvv wfn cn cB
        cH wf cvv cvv c1st wfo c1st cvv wfn fo1st cvv cvv c1st fofn ax-mp a1i
        cn cB cH ffn cH crn cvv wss cn cB cH wf cH crn ssv a1i syl3anc cn cB cH
        wf vk cv c1st cH ccom cfv cX wcel vk cn cn cB cH wf vk cv cn wcel wa vk
        cv c1st cH ccom cfv vk cv cH cfv c1st cfv cX c1st wfun cH wfun vk cv cH
        cdm wcel vk cv c1st cH ccom cfv vk cv cH cfv c1st cfv wceq cn cB cH wf
        vk cv cn wcel wa vk cv c1st cH fvco c1st wfun cn cB cH wf vk cv cn wcel
        wa cvv cvv c1st wfo c1st wfun fo1st cvv cvv c1st fofun ax-mp a1i cn cB
        cH wf cH wfun vk cv cn wcel cn cB cH ffun adantr cn cB cH wf vk cv cH
        cdm wcel vk cv cn wcel cn cB cH wf cH cdm cn vk cv cn cB cH fdm eleq2d
        biimpar syl3anc cn cB cH wf vk cv cn wcel wa vk cv cH cfv cB wcel vk cv
        cH cfv c1st cfv cX wcel cn cB vk cv cH ffvelrn vk cv cH cfv cB wcel vk
        cv cH cfv cX crp cxp wcel vk cv cH cfv cM cbl cfv cfv cD wcel wa vk cv
        cH cfv c1st cfv cX wcel vx vv vk cv cH cfv cB cD cU cJ cM cX vs vr
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heiborlem24 vk cv cH cfv cX crp cxp wcel vk cv cH cfv c1st
        cfv cX wcel vk cv cH cfv cM cbl cfv cfv cD wcel vk cv cH cfv cX crp
        xp1st adantr sylbi syl eqeltrd r19.21aiva sylanc sylanbrc cn cX c1st cH
        ccom fssxp syl cn cX cxp cc cX cxp wss cn cB cH wf cn cc wss cX cX wss
        cn cX cxp cc cX cxp wss nnsscn cX ssid cn cc cX cX ssxp mp2an a1i sstrd
        sylancr adantr mpbird $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . If ` Y ` is the limit of the Cauchy sequence from
         ~ heiborlem33 , then bound the distance between ` Y ` and the center
         of a ball in ` H ` . $)
      heiborlem34 $p |- ( ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) /\ ( 1st o. H ) ( ~~>m ` M ) Y )
                      /\ ( Y e. X /\ R e. RR+ ) ) -> E. j e. NN A. m e. NN
                        ( j <_ m -> ( ( 1st ` ( H ` m ) ) M Y ) < R ) ) $=
        cn cB cH wf c1st cH ccom cY cM clm cfv wbr cY cX wcel cR crp wcel wa vj
        cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR clt wbr wi vm cn
        wral vj cn wrex vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv
        cG co wcel vg cn wral cn cB cH wf c1st cH ccom cY cM clm cfv wbr wa cY
        cX wcel cR crp wcel wa wa vj cv vm cv cle wbr vm cv c1st cH ccom cfv cY
        cM co cR clt wbr wi vm cn wral vj cn wrex vj cv vm cv cle wbr vm cv cH
        cfv c1st cfv cY cM co cR clt wbr wi vm cn wral vj cn wrex c1st cH ccom
        cY cM clm cfv wbr cY cX wcel cR crp wcel wa vj cv vm cv cle wbr vm cv
        c1st cH ccom cfv cY cM co cR clt wbr wi vm cn wral vj cn wrex cn cB cH
        wf cY cX wcel c1st cH ccom cY cM clm cfv wbr cR crp wcel vj cv vm cv
        cle wbr vm cv c1st cH ccom cfv cY cM co cR clt wbr wi vm cn wral vj cn
        wrex cM cme wcel cY cX wcel c1st cH ccom cY cM clm cfv wbr cR crp wcel
        wa vj cv vm cv cle wbr vm cv c1st cH ccom cfv cY cM co cR clt wbr wi vm
        cn wral vj cn wrex cM heibor.9 cmsmeti vm cv c1st cH ccom cfv cX cM cY
        cR vj vm c1st cH ccom cX heibor.2 vm cv cn wcel vm cv c1st cH ccom cfv
        eqidd lmcvgnns mpanl1 an1s adantll cn cB cH wf vj cv vm cv cle wbr vm
        cv c1st cH ccom cfv cY cM co cR clt wbr wi vm cn wral vj cn wrex vj cv
        vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR clt wbr wi vm cn wral
        vj cn wrex wb c1st cH ccom cY cM clm cfv wbr cY cX wcel cR crp wcel wa
        cn cB cH wf vj cv vm cv cle wbr vm cv c1st cH ccom cfv cY cM co cR clt
        wbr wi vm cn wral vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR
        clt wbr wi vm cn wral vj cn cn cB cH wf vj cv vm cv cle wbr vm cv c1st
        cH ccom cfv cY cM co cR clt wbr wi vj cv vm cv cle wbr vm cv cH cfv
        c1st cfv cY cM co cR clt wbr wi vm cn cn cB cH wf vm cv cn wcel wa vm
        cv c1st cH ccom cfv cY cM co cR clt wbr vm cv cH cfv c1st cfv cY cM co
        cR clt wbr vj cv vm cv cle wbr cn cB cH wf vm cv cn wcel wa vm cv c1st
        cH ccom cfv cY cM co vm cv cH cfv c1st cfv cY cM co cR clt cn cB cH wf
        vm cv cn wcel wa vm cv c1st cH ccom cfv vm cv cH cfv c1st cfv cY cM
        c1st wfun cH wfun vm cv cH cdm wcel vm cv c1st cH ccom cfv vm cv cH cfv
        c1st cfv wceq cn cB cH wf vm cv cn wcel wa vm cv c1st cH fvco c1st wfun
        cn cB cH wf vm cv cn wcel wa cvv cvv c1st wfo c1st wfun fo1st cvv cvv
        c1st fofun ax-mp a1i cn cB cH wf cH wfun vm cv cn wcel cn cB cH ffun
        adantr cn cB cH wf vm cv cn wcel wa vm cv cn cH cdm cn cB cH wf vm cv
        cn wcel pm3.27 cn cB cH wf cH cdm cn wceq vm cv cn wcel cn cB cH fdm
        adantr eleqtrrd syl3anc opreq1d breq1d imbi2d ralbidva rexbidv ad2antrr
        mpbid 3adantl2 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Bound the distance between a point in a ball in
         ` H ` and the ball's center. $)
      heiborlem35 $p |- ( ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) /\ ( 1st o. H ) ( ~~>m ` M ) Y )
                      /\ ( Y e. X /\ R e. RR+ ) ) -> E. l e. NN A. m e. NN
                        ( l <_ m -> A. y e. ( ( ball ` M ) ` ( H ` m ) )
                                ( ( 1st ` ( H ` m ) ) M y ) < R ) ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cR crp wcel vl cv
        vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH
        cfv cM cbl cfv cfv wral wi vm cn wral vl cn wrex cY cX wcel cn cB cH wf
        vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg
        cn wral cR crp wcel vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM
        co cR clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm cn wral vl cn
        wrex c1st cH ccom cY cM clm cfv wbr cn cB cH wf vg cv c1 caddc co cH
        cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cR crp wcel
        wa vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy
        vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn
        wral vl cn wrex vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co
        cR clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm cn wral vl cn wrex
        vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co
        cdiv co wceq wa vj c2 cuz cfv wral cR crp wcel vl cv vm cv cle wbr vm
        cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm
        cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn wral vl cn wrex cn cB cH
        wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel
        vg cn wral wa vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2
        vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR crp wcel wa vl cv
        vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn wral vl
        c2 cuz cfv wrex vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co
        cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co
        wral wi vm cn wral vl cn wrex vj cv cH cfv c1st cfv cX wcel vj cv cH
        cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR
        crp wcel wa c1 c2 vl cv cexp co cdiv co cR clt wbr vl c2 cuz cfv wrex
        vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm
        cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn
        wral vl c2 cuz cfv wrex cR crp wcel c1 c2 vl cv cexp co cdiv co cR clt
        wbr vl c2 cuz cfv wrex vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd
        cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR crp wcel
        c1 c2 vm cv cexp co cdiv co cR clt wbr vm cn wrex c1 c2 vl cv cexp co
        cdiv co cR clt wbr vl c2 cuz cfv wrex cR crp wcel c2 cr wcel c1 c2 clt
        wbr c1 c2 vm cv cexp co cdiv co cR clt wbr vm cn wrex 2re 1lt2 cR c2 vm
        expnlbnd mp3an23 cR crp wcel c1 c2 vm cv cexp co cdiv co cR clt wbr c1
        c2 vl cv cexp co cdiv co cR clt wbr vl c2 cuz cfv wrex vm cn cR crp
        wcel vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co cR clt wbr c1 c2 vl
        cv cexp co cdiv co cR clt wbr vl c2 cuz cfv wrex vm cv c1 caddc co c2
        cuz cfv wcel c1 c2 vm cv c1 caddc co cexp co cdiv co cR clt wbr c1 c2
        vl cv cexp co cdiv co cR clt wbr vl c2 cuz cfv wrex cR crp wcel vm cv
        cn wcel wa c1 c2 vm cv cexp co cdiv co cR clt wbr wa c1 c2 vl cv cexp
        co cdiv co cR clt wbr c1 c2 vm cv c1 caddc co cexp co cdiv co cR clt
        wbr vl vm cv c1 caddc co c2 cuz cfv vl cv vm cv c1 caddc co wceq c1 c2
        vl cv cexp co cdiv co c1 c2 vm cv c1 caddc co cexp co cdiv co cR clt vl
        cv vm cv c1 caddc co wceq c2 vl cv cexp co c2 vm cv c1 caddc co cexp co
        c1 cdiv vl cv vm cv c1 caddc co c2 cexp opreq2 opreq2d breq1d rcla4ev
        vm cv cn wcel vm cv c1 caddc co c2 cuz cfv wcel cR crp wcel c1 c2 vm cv
        cexp co cdiv co cR clt wbr vm cv c1 cuz cfv wcel vm cv c1 caddc co c1
        c1 caddc co cuz cfv wcel vm cv cn wcel vm cv c1 caddc co c2 cuz cfv
        wcel c1 vm cv eluzp1p1 vm cv elnnuz c2 cuz cfv c1 c1 caddc co cuz cfv
        vm cv c1 caddc co c2 c1 c1 caddc co cuz df-2 fveq2i eleq2i 3imtr4i
        ad2antlr cR crp wcel vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co cR
        clt wbr c1 c2 vm cv c1 caddc co cexp co cdiv co cR clt wbr cR crp wcel
        vm cv cn wcel wa c1 c2 vm cv c1 caddc co cexp co cdiv co c1 c2 vm cv
        cexp co cdiv co clt wbr c1 c2 vm cv cexp co cdiv co cR clt wbr c1 c2 vm
        cv c1 caddc co cexp co cdiv co cR clt wbr vm cv cn wcel c1 c2 vm cv c1
        caddc co cexp co cdiv co c1 c2 vm cv cexp co cdiv co clt wbr cR crp
        wcel vm cv cn wcel c2 vm cv cexp co c2 vm cv c1 caddc co cexp co clt
        wbr c1 c2 vm cv c1 caddc co cexp co cdiv co c1 c2 vm cv cexp co cdiv co
        clt wbr c2 cr wcel vm cv cn0 wcel vm cv c1 caddc co cn0 wcel w3a c1 c2
        clt wbr vm cv vm cv c1 caddc co clt wbr wa c2 vm cv cexp co c2 vm cv c1
        caddc co cexp co clt wbr vm cv cn wcel c2 vm cv vm cv c1 caddc co
        expordi vm cv cn wcel c2 cr wcel vm cv cn0 wcel vm cv c1 caddc co cn0
        wcel c2 cr wcel vm cv cn wcel 2re a1i vm cv nnnn0 vm cv cn wcel vm cv
        c1 caddc co cn wcel vm cv c1 caddc co cn0 wcel vm cv peano2nn vm cv c1
        caddc co nnnn0 syl 3jca vm cv cn wcel vm cv vm cv c1 caddc co clt wbr
        c1 c2 clt wbr vm cv cn wcel vm cv cc0 caddc co vm cv vm cv c1 caddc co
        clt vm cv cn wcel vm cv cc wcel vm cv cc0 caddc co vm cv wceq vm cv
        nncn vm cv ax0id syl vm cv cn wcel cc0 c1 clt wbr vm cv cc0 caddc co vm
        cv c1 caddc co clt wbr lt01 cc0 cr wcel c1 cr wcel vm cv cr wcel cc0 c1
        clt wbr vm cv cc0 caddc co vm cv c1 caddc co clt wbr wb vm cv cn wcel
        cc0 c1 vm cv ltadd2 cc0 cr wcel vm cv cn wcel 0re a1i c1 cr wcel vm cv
        cn wcel 1re a1i vm cv nnre syl3anc mpbii eqbrtrrd 1lt2 jctil sylanc c2
        vm cv cexp co cr wcel cc0 c2 vm cv cexp co clt wbr c2 vm cv c1 caddc co
        cexp co cr wcel cc0 c2 vm cv c1 caddc co cexp co clt wbr c2 vm cv cexp
        co c2 vm cv c1 caddc co cexp co clt wbr c1 c2 vm cv c1 caddc co cexp co
        cdiv co c1 c2 vm cv cexp co cdiv co clt wbr wb vm cv cn wcel c2 vm cv
        cexp co c2 vm cv c1 caddc co cexp co ltrec c2 cr wcel vm cv cn0 wcel c2
        vm cv cexp co cr wcel vm cv cn wcel c2 vm cv reexpcl 2re vm cv nnnn0
        sylancr c2 cr wcel vm cv cn0 wcel cc0 c2 clt wbr cc0 c2 vm cv cexp co
        clt wbr vm cv cn wcel c2 vm cv expgt0 c2 cr wcel vm cv cn wcel 2re a1i
        vm cv nnnn0 cc0 c2 clt wbr vm cv cn wcel 2pos a1i syl3anc c2 cr wcel vm
        cv c1 caddc co cn0 wcel c2 vm cv c1 caddc co cexp co cr wcel vm cv cn
        wcel c2 vm cv c1 caddc co reexpcl 2re vm cv cn wcel vm cv c1 caddc co
        cn wcel vm cv c1 caddc co cn0 wcel vm cv peano2nn vm cv c1 caddc co
        nnnn0 syl sylancr c2 cr wcel vm cv c1 caddc co cn0 wcel cc0 c2 clt wbr
        cc0 c2 vm cv c1 caddc co cexp co clt wbr vm cv cn wcel c2 vm cv c1
        caddc co expgt0 c2 cr wcel vm cv cn wcel 2re a1i vm cv cn wcel vm cv c1
        caddc co cn wcel vm cv c1 caddc co cn0 wcel vm cv peano2nn vm cv c1
        caddc co nnnn0 syl cc0 c2 clt wbr vm cv cn wcel 2pos a1i syl3anc
        syl2anc mpbid adantl c1 c2 vm cv c1 caddc co cexp co cdiv co cr wcel c1
        c2 vm cv cexp co cdiv co cr wcel cR cr wcel c1 c2 vm cv c1 caddc co
        cexp co cdiv co c1 c2 vm cv cexp co cdiv co clt wbr c1 c2 vm cv cexp co
        cdiv co cR clt wbr wa c1 c2 vm cv c1 caddc co cexp co cdiv co cR clt
        wbr wi cR crp wcel vm cv cn wcel wa c1 c2 vm cv c1 caddc co cexp co
        cdiv co c1 c2 vm cv cexp co cdiv co cR lttr cR crp wcel vm cv cn wcel
        wa c2 vm cv c1 caddc co cexp co crp wcel c1 c2 vm cv c1 caddc co cexp
        co cdiv co crp wcel c1 c2 vm cv c1 caddc co cexp co cdiv co cr wcel c2
        crp wcel vm cv c1 caddc co cn0 wcel c2 vm cv c1 caddc co cexp co crp
        wcel cR crp wcel vm cv cn wcel wa c2 vm cv c1 caddc co rpexpcl c2 2re
        2pos elrpii vm cv cn wcel vm cv c1 caddc co cn0 wcel cR crp wcel vm cv
        cn wcel vm cv c1 caddc co cn wcel vm cv c1 caddc co cn0 wcel vm cv
        peano2nn vm cv c1 caddc co nnnn0 syl adantl sylancr c2 vm cv c1 caddc
        co cexp co rpreccl c1 c2 vm cv c1 caddc co cexp co cdiv co rpre 3syl cR
        crp wcel vm cv cn wcel wa c2 vm cv cexp co crp wcel c1 c2 vm cv cexp co
        cdiv co crp wcel c1 c2 vm cv cexp co cdiv co cr wcel c2 crp wcel vm cv
        cn0 wcel c2 vm cv cexp co crp wcel cR crp wcel vm cv cn wcel wa c2 vm
        cv rpexpcl c2 2re 2pos elrpii vm cv cn wcel vm cv cn0 wcel cR crp wcel
        vm cv nnnn0 adantl sylancr c2 vm cv cexp co rpreccl c1 c2 vm cv cexp co
        cdiv co rpre 3syl cR crp wcel cR cr wcel vm cv cn wcel cR rpre adantr
        syl3anc mpand imp sylanc ex r19.23adva mpd adantl vj cv cH cfv c1st cfv
        cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2
        cuz cfv wral cR crp wcel wa c1 c2 vl cv cexp co cdiv co cR clt wbr vl
        cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv
        cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn wral
        vl c2 cuz cfv vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2
        vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR crp wcel wa vl cv
        c2 cuz cfv wcel wa c1 c2 vl cv cexp co cdiv co cR clt wbr vl cv vm cv
        cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn wral vj cv
        cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv
        co wceq wa vj c2 cuz cfv wral cR crp wcel wa vl cv c2 cuz cfv wcel wa
        c1 c2 vl cv cexp co cdiv co cR clt wbr wa vl cv vm cv cle wbr vm cv cH
        cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cM cbl cfv co wral wi vm cn vj cv cH cfv c1st cfv cX wcel
        vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv
        wral cR crp wcel wa vl cv c2 cuz cfv wcel wa c1 c2 vl cv cexp co cdiv
        co cR clt wbr wa vm cv cn wcel wa vl cv vm cv cle wbr vm cv c2 cuz cfv
        wcel c1 c2 vm cv cexp co cdiv co cR clt wbr wa vm cv cH cfv c1st cfv vy
        cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM
        cbl cfv co wral vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1
        c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR crp wcel wa vl
        cv c2 cuz cfv wcel wa c1 c2 vl cv cexp co cdiv co cR clt wbr vm cv cn
        wcel vl cv vm cv cle wbr vm cv c2 cuz cfv wcel c1 c2 vm cv cexp co cdiv
        co cR clt wbr wa wi cR crp wcel vl cv c2 cuz cfv wcel c1 c2 vl cv cexp
        co cdiv co cR clt wbr vm cv cn wcel wa vl cv vm cv cle wbr vm cv c2 cuz
        cfv wcel c1 c2 vm cv cexp co cdiv co cR clt wbr wa wi vj cv cH cfv c1st
        cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa
        vj c2 cuz cfv wral cR crp wcel vl cv c2 cuz cfv wcel wa c1 c2 vl cv
        cexp co cdiv co cR clt wbr vm cv cn wcel wa wa vl cv vm cv cle wbr vm
        cv c2 cuz cfv wcel c1 c2 vm cv cexp co cdiv co cR clt wbr vl cv c2 cuz
        cfv wcel vm cv cn wcel vl cv vm cv cle wbr vm cv c2 cuz cfv wcel wi cR
        crp wcel c1 c2 vl cv cexp co cdiv co cR clt wbr vl cv c2 cuz cfv wcel
        vm cv cn wcel wa vl cv vm cv cle wbr vm cv vl cv cmin co cn0 wcel vm cv
        c2 cuz cfv wcel vl cv cz wcel vm cv cz wcel vl cv vm cv cle wbr vm cv
        vl cv cmin co cn0 wcel wi vl cv c2 cuz cfv wcel vm cv cn wcel vl cv cz
        wcel vm cv cz wcel vl cv vm cv cle wbr vm cv vl cv cmin co cn0 wcel vl
        cv vm cv znn0sub2 3expia c2 vl cv eluzelz vm cv nnz syl2an vl cv c2 cuz
        cfv wcel vm cv cn wcel wa vm cv vl cv cmin co cn0 wcel vm cv c2 cuz cfv
        wcel vl cv c2 cuz cfv wcel vm cv vl cv cmin co cn0 wcel vm cv cn wcel
        vm cv c2 cuz cfv wcel vl cv c2 cuz cfv wcel vl cv vm cv vl cv cmin co
        caddc co c2 cuz cfv wcel wa vm cv cn wcel vm cv c2 cuz cfv wcel vl cv
        c2 cuz cfv wcel vm cv vl cv cmin co cn0 wcel wa vl cv c2 cuz cfv wcel
        vm cv cn wcel vl cv vm cv vl cv cmin co caddc co c2 cuz cfv wcel vm cv
        c2 cuz cfv wcel vl cv c2 cuz cfv wcel vm cv cn wcel wa vl cv vm cv vl
        cv cmin co caddc co c2 cuz cfv wcel vm cv c2 cuz cfv wcel vl cv c2 cuz
        cfv wcel vm cv cn wcel wa vl cv vm cv vl cv cmin co caddc co vm cv c2
        cuz cfv vl cv cc wcel vm cv cc wcel vl cv vm cv vl cv cmin co caddc co
        vm cv wceq vl cv c2 cuz cfv wcel vm cv cn wcel vl cv vm cv pncan3 vl cv
        c2 cuz cfv wcel vl cv cz wcel vl cv cc wcel c2 vl cv eluzelz vl cv zcn
        syl vm cv nncn syl2an eleq1d biimpa an1rs vl cv c2 cuz cfv wcel vm cv
        vl cv cmin co cn0 wcel vl cv vm cv vl cv cmin co caddc co c2 cuz cfv
        wcel vl cv c2 cuz cfv wcel vm cv vl cv cmin co cn0 wcel vl cv vm cv vl
        cv cmin co caddc co c2 cuz cfv wcel vm cv vl cv cmin co c2 vl cv
        uzaddcl ex imdistani sylan an1rs ex syld ad2ant2l cR crp wcel vl cv c2
        cuz cfv wcel wa vm cv cn wcel c1 c2 vl cv cexp co cdiv co cR clt wbr vl
        cv vm cv cle wbr c1 c2 vm cv cexp co cdiv co cR clt wbr wi cR crp wcel
        vl cv c2 cuz cfv wcel wa vm cv cn wcel c1 c2 vl cv cexp co cdiv co cR
        clt wbr vl cv vm cv cle wbr c1 c2 vm cv cexp co cdiv co cR clt wbr wi
        cR crp wcel vl cv c2 cuz cfv wcel wa vm cv cn wcel wa vl cv vm cv cle
        wbr c1 c2 vl cv cexp co cdiv co cR clt wbr c1 c2 vm cv cexp co cdiv co
        cR clt wbr cR crp wcel vl cv c2 cuz cfv wcel wa vm cv cn wcel wa vl cv
        vm cv cle wbr c1 c2 vl cv cexp co cdiv co cR clt wbr c1 c2 vm cv cexp
        co cdiv co cR clt wbr wi cR crp wcel vl cv c2 cuz cfv wcel wa vm cv cn
        wcel wa vl cv vm cv cle wbr wa c1 c2 vm cv cexp co cdiv co c1 c2 vl cv
        cexp co cdiv co cle wbr c1 c2 vl cv cexp co cdiv co cR clt wbr c1 c2 vm
        cv cexp co cdiv co cR clt wbr vl cv c2 cuz cfv wcel vm cv cn wcel vl cv
        vm cv cle wbr c1 c2 vm cv cexp co cdiv co c1 c2 vl cv cexp co cdiv co
        cle wbr cR crp wcel vl cv c2 cuz cfv wcel vm cv cn wcel wa vl cv vm cv
        cle wbr wa c2 vl cv cexp co c2 vm cv cexp co cle wbr c1 c2 vm cv cexp
        co cdiv co c1 c2 vl cv cexp co cdiv co cle wbr c2 cr wcel vl cv cn0
        wcel vm cv cn0 wcel w3a c1 c2 cle wbr vl cv vm cv cle wbr wa c2 vl cv
        cexp co c2 vm cv cexp co cle wbr vl cv c2 cuz cfv wcel vm cv cn wcel wa
        vl cv vm cv cle wbr wa c2 vl cv vm cv expwordi vl cv c2 cuz cfv wcel vm
        cv cn wcel wa vl cv vm cv cle wbr wa c2 cr wcel vl cv cn0 wcel vm cv
        cn0 wcel c2 cr wcel vl cv c2 cuz cfv wcel vm cv cn wcel wa vl cv vm cv
        cle wbr wa 2re a1i vl cv c2 cuz cfv wcel vl cv cn0 wcel vm cv cn wcel
        vl cv vm cv cle wbr vl cv c2 cuz cfv wcel vl cv cc0 cuz cfv wcel vl cv
        cn0 wcel c2 cuz cfv cc0 cuz cfv vl cv c2 cc0 cuz cfv wcel c2 cuz cfv
        cc0 cuz cfv wss c2 cc0 cuz cfv wcel c2 cz wcel cc0 c2 cle wbr cc0 c2 0z
        eluz1i 2z cc0 c2 0re 2re 2pos ltleii mpbir2an cc0 c2 uzss ax-mp sseli
        vl cv elnn0uz sylibr ad2antrr vm cv cn wcel vm cv cn0 wcel vl cv c2 cuz
        cfv wcel vl cv vm cv cle wbr vm cv nnnn0 ad2antlr 3jca vl cv c2 cuz cfv
        wcel vm cv cn wcel wa vl cv vm cv cle wbr wa vl cv vm cv cle wbr c1 c2
        cle wbr vl cv c2 cuz cfv wcel vm cv cn wcel wa vl cv vm cv cle wbr
        pm3.27 c1 c2 1re 2re 1lt2 ltleii jctil sylanc c2 vl cv cexp co cr wcel
        cc0 c2 vl cv cexp co clt wbr c2 vm cv cexp co cr wcel cc0 c2 vm cv cexp
        co clt wbr c2 vl cv cexp co c2 vm cv cexp co cle wbr c1 c2 vm cv cexp
        co cdiv co c1 c2 vl cv cexp co cdiv co cle wbr wb vl cv c2 cuz cfv wcel
        vm cv cn wcel wa vl cv vm cv cle wbr wa c2 vl cv cexp co c2 vm cv cexp
        co lerec vl cv c2 cuz cfv wcel c2 vl cv cexp co cr wcel vm cv cn wcel
        vl cv vm cv cle wbr c2 cr wcel vl cv cn0 wcel c2 vl cv cexp co cr wcel
        vl cv c2 cuz cfv wcel c2 vl cv reexpcl 2re vl cv c2 cuz cfv wcel vl cv
        cc0 cuz cfv wcel vl cv cn0 wcel c2 cuz cfv cc0 cuz cfv vl cv c2 cc0 cuz
        cfv wcel c2 cuz cfv cc0 cuz cfv wss c2 cc0 cuz cfv wcel c2 cz wcel cc0
        c2 cle wbr cc0 c2 0z eluz1i 2z cc0 c2 0re 2re 2pos ltleii mpbir2an cc0
        c2 uzss ax-mp sseli vl cv elnn0uz sylibr sylancr ad2antrr vl cv c2 cuz
        cfv wcel cc0 c2 vl cv cexp co clt wbr vm cv cn wcel vl cv vm cv cle wbr
        c2 cr wcel vl cv cn0 wcel cc0 c2 clt wbr cc0 c2 vl cv cexp co clt wbr
        vl cv c2 cuz cfv wcel c2 vl cv expgt0 c2 cr wcel vl cv c2 cuz cfv wcel
        2re a1i vl cv c2 cuz cfv wcel vl cv cc0 cuz cfv wcel vl cv cn0 wcel c2
        cuz cfv cc0 cuz cfv vl cv c2 cc0 cuz cfv wcel c2 cuz cfv cc0 cuz cfv
        wss c2 cc0 cuz cfv wcel c2 cz wcel cc0 c2 cle wbr cc0 c2 0z eluz1i 2z
        cc0 c2 0re 2re 2pos ltleii mpbir2an cc0 c2 uzss ax-mp sseli vl cv
        elnn0uz sylibr cc0 c2 clt wbr vl cv c2 cuz cfv wcel 2pos a1i syl3anc
        ad2antrr vm cv cn wcel c2 vm cv cexp co cr wcel vl cv c2 cuz cfv wcel
        vl cv vm cv cle wbr c2 cr wcel vm cv cn0 wcel c2 vm cv cexp co cr wcel
        vm cv cn wcel c2 vm cv reexpcl 2re vm cv nnnn0 sylancr ad2antlr vm cv
        cn wcel cc0 c2 vm cv cexp co clt wbr vl cv c2 cuz cfv wcel vl cv vm cv
        cle wbr c2 cr wcel vm cv cn0 wcel cc0 c2 clt wbr cc0 c2 vm cv cexp co
        clt wbr vm cv cn wcel c2 vm cv expgt0 c2 cr wcel vm cv cn wcel 2re a1i
        vm cv nnnn0 cc0 c2 clt wbr vm cv cn wcel 2pos a1i syl3anc ad2antlr
        syl2anc mpbid adantlll c1 c2 vm cv cexp co cdiv co cr wcel c1 c2 vl cv
        cexp co cdiv co cr wcel cR cr wcel c1 c2 vm cv cexp co cdiv co c1 c2 vl
        cv cexp co cdiv co cle wbr c1 c2 vl cv cexp co cdiv co cR clt wbr wa c1
        c2 vm cv cexp co cdiv co cR clt wbr wi cR crp wcel vl cv c2 cuz cfv
        wcel wa vm cv cn wcel wa vl cv vm cv cle wbr wa c1 c2 vm cv cexp co
        cdiv co c1 c2 vl cv cexp co cdiv co cR lelttr vm cv cn wcel c1 c2 vm cv
        cexp co cdiv co cr wcel cR crp wcel vl cv c2 cuz cfv wcel wa vl cv vm
        cv cle wbr vm cv cn wcel c2 vm cv cexp co crp wcel c1 c2 vm cv cexp co
        cdiv co crp wcel c1 c2 vm cv cexp co cdiv co cr wcel c2 crp wcel vm cv
        cn0 wcel c2 vm cv cexp co crp wcel vm cv cn wcel c2 vm cv rpexpcl c2
        2re 2pos elrpii vm cv nnnn0 sylancr c2 vm cv cexp co rpreccl c1 c2 vm
        cv cexp co cdiv co rpre 3syl ad2antlr cR crp wcel vl cv c2 cuz cfv wcel
        wa c1 c2 vl cv cexp co cdiv co cr wcel vm cv cn wcel vl cv vm cv cle
        wbr vl cv c2 cuz cfv wcel c1 c2 vl cv cexp co cdiv co cr wcel cR crp
        wcel vl cv c2 cuz cfv wcel c2 vl cv cexp co crp wcel c1 c2 vl cv cexp
        co cdiv co crp wcel c1 c2 vl cv cexp co cdiv co cr wcel c2 crp wcel vl
        cv cn0 wcel c2 vl cv cexp co crp wcel vl cv c2 cuz cfv wcel c2 vl cv
        rpexpcl c2 2re 2pos elrpii vl cv c2 cuz cfv wcel vl cv cc0 cuz cfv wcel
        vl cv cn0 wcel c2 cuz cfv cc0 cuz cfv vl cv c2 cc0 cuz cfv wcel c2 cuz
        cfv cc0 cuz cfv wss c2 cc0 cuz cfv wcel c2 cz wcel cc0 c2 cle wbr cc0
        c2 0z eluz1i 2z cc0 c2 0re 2re 2pos ltleii mpbir2an cc0 c2 uzss ax-mp
        sseli vl cv elnn0uz sylibr sylancr c2 vl cv cexp co rpreccl c1 c2 vl cv
        cexp co cdiv co rpre 3syl adantl ad2antrr cR crp wcel vl cv c2 cuz cfv
        wcel wa vm cv cn wcel wa cR cr wcel vl cv vm cv cle wbr cR crp wcel cR
        cr wcel vl cv c2 cuz cfv wcel vm cv cn wcel cR rpre ad2antrr adantr
        syl3anc mpand ex com23 impr ancom2s jcad adantlll anassrs vj cv cH cfv
        c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq
        wa vj c2 cuz cfv wral cR crp wcel wa vl cv c2 cuz cfv wcel wa vm cv cn
        wcel vl cv vm cv cle wbr vm cv c2 cuz cfv wcel c1 c2 vm cv cexp co cdiv
        co cR clt wbr wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv
        cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi wi c1 c2 vl
        cv cexp co cdiv co cR clt wbr vj cv cH cfv c1st cfv cX wcel vj cv cH
        cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR
        crp wcel wa vm cv cn wcel vl cv vm cv cle wbr vm cv c2 cuz cfv wcel c1
        c2 vm cv cexp co cdiv co cR clt wbr wa vm cv cH cfv c1st cfv vy cv cM
        co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv
        co wral wi wi vl cv c2 cuz cfv wcel vj cv cH cfv c1st cfv cX wcel vj cv
        cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral
        cR crp wcel wa vm cv cn wcel wa vm cv c2 cuz cfv wcel c1 c2 vm cv cexp
        co cdiv co cR clt wbr wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr
        vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vl
        cv vm cv cle wbr vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1
        c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR crp wcel wa vm
        cv cn wcel wa vm cv c2 cuz cfv wcel c1 c2 vm cv cexp co cdiv co cR clt
        wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st
        cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral vj cv cH cfv c1st cfv cX
        wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2
        cuz cfv wral cR crp wcel vm cv cn wcel vm cv c2 cuz cfv wcel c1 c2 vm
        cv cexp co cdiv co cR clt wbr vm cv cH cfv c1st cfv vy cv cM co cR clt
        wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral
        wi wi vm cv c2 cuz cfv wcel vj cv cH cfv c1st cfv cX wcel vj cv cH cfv
        c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral cR crp
        wcel vm cv cn wcel wa wa c1 c2 vm cv cexp co cdiv co cR clt wbr vm cv
        cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv
        cH cfv c2nd cfv cM cbl cfv co wral wi vm cv c2 cuz cfv wcel vj cv cH
        cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co
        wceq wa vj c2 cuz cfv wral cR crp wcel vm cv cn wcel wa c1 c2 vm cv
        cexp co cdiv co cR clt wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr
        vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm
        cv c2 cuz cfv wcel vj cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv
        c1 c2 vj cv cexp co cdiv co wceq wa vj c2 cuz cfv wral vm cv cH cfv
        c1st cfv cX wcel vm cv cH cfv c2nd cfv c1 c2 vm cv cexp co cdiv co wceq
        wa cR crp wcel vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co cR clt wbr
        vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv
        vm cv cH cfv c2nd cfv cM cbl cfv co wral wi wi vj cv cH cfv c1st cfv cX
        wcel vj cv cH cfv c2nd cfv c1 c2 vj cv cexp co cdiv co wceq wa vm cv cH
        cfv c1st cfv cX wcel vm cv cH cfv c2nd cfv c1 c2 vm cv cexp co cdiv co
        wceq wa vj vm cv c2 cuz cfv vj cv vm cv wceq vj cv cH cfv c1st cfv cX
        wcel vm cv cH cfv c1st cfv cX wcel vj cv cH cfv c2nd cfv c1 c2 vj cv
        cexp co cdiv co wceq vm cv cH cfv c2nd cfv c1 c2 vm cv cexp co cdiv co
        wceq vj cv vm cv wceq vj cv cH cfv c1st cfv vm cv cH cfv c1st cfv cX vj
        cv vm cv wceq vj cv cH cfv vm cv cH cfv c1st vj cv vm cv cH fveq2
        fveq2d eleq1d vj cv vm cv wceq vj cv cH cfv c2nd cfv vm cv cH cfv c2nd
        cfv c1 c2 vj cv cexp co cdiv co c1 c2 vm cv cexp co cdiv co vj cv vm cv
        wceq vj cv cH cfv vm cv cH cfv c2nd vj cv vm cv cH fveq2 fveq2d vj cv
        vm cv wceq c2 vj cv cexp co c2 vm cv cexp co c1 cdiv vj cv vm cv c2
        cexp opreq2 opreq2d eqeq12d anbi12d rcla4v vm cv cH cfv c1st cfv cX
        wcel vm cv cH cfv c2nd cfv c1 c2 vm cv cexp co cdiv co wceq wa cR crp
        wcel vm cv cn wcel wa c1 c2 vm cv cexp co cdiv co cR clt wbr vm cv cH
        cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cM cbl cfv co wral wi vm cv cH cfv c1st cfv cX wcel vm cv
        cH cfv c2nd cfv c1 c2 vm cv cexp co cdiv co wceq wa cR crp wcel vm cv
        cn wcel c1 c2 vm cv cexp co cdiv co cR clt wbr vm cv cH cfv c1st cfv vy
        cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM
        cbl cfv co wral wi vm cv cH cfv c1st cfv cX wcel vm cv cH cfv c2nd cfv
        c1 c2 vm cv cexp co cdiv co wceq wa cR crp wcel wa vm cv cn wcel c1 c2
        vm cv cexp co cdiv co cR clt wbr vm cv cH cfv c1st cfv vy cv cM co cR
        clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co
        wral vm cv cH cfv c1st cfv cX wcel cR crp wcel vm cv cH cfv c2nd cfv c1
        c2 vm cv cexp co cdiv co wceq vm cv cn wcel c1 c2 vm cv cexp co cdiv co
        cR clt wbr wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cv cH cfv
        c1st cfv cX wcel cR crp wcel wa vm cv cH cfv c2nd cfv c1 c2 vm cv cexp
        co cdiv co wceq wa c1 c2 vm cv cexp co cdiv co crp wcel c1 c2 vm cv
        cexp co cdiv co cR clt wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr
        vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral vm cv
        cn wcel vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vm cv cH cfv c2nd
        cfv c1 c2 vm cv cexp co cdiv co wceq wa c1 c2 vm cv cexp co cdiv co crp
        wcel c1 c2 vm cv cexp co cdiv co cR clt wbr wa vm cv cH cfv c2nd cfv
        crp wcel vm cv cH cfv c2nd cfv cR clt wbr wa vm cv cH cfv c1st cfv vy
        cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM
        cbl cfv co wral vm cv cH cfv c2nd cfv c1 c2 vm cv cexp co cdiv co wceq
        vm cv cH cfv c2nd cfv crp wcel vm cv cH cfv c2nd cfv cR clt wbr wa c1
        c2 vm cv cexp co cdiv co crp wcel c1 c2 vm cv cexp co cdiv co cR clt
        wbr wa wb vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vm cv cH cfv
        c2nd cfv c1 c2 vm cv cexp co cdiv co wceq vm cv cH cfv c2nd cfv crp
        wcel c1 c2 vm cv cexp co cdiv co crp wcel vm cv cH cfv c2nd cfv cR clt
        wbr c1 c2 vm cv cexp co cdiv co cR clt wbr vm cv cH cfv c2nd cfv c1 c2
        vm cv cexp co cdiv co crp eleq1 vm cv cH cfv c2nd cfv c1 c2 vm cv cexp
        co cdiv co cR clt breq1 anbi12d adantl vm cv cH cfv c1st cfv cX wcel cR
        crp wcel wa vm cv cH cfv c2nd cfv crp wcel vm cv cH cfv c2nd cfv cR clt
        wbr wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cv cH cfv c2nd
        cfv c1 c2 vm cv cexp co cdiv co wceq vm cv cH cfv c1st cfv cX wcel cR
        crp wcel wa vm cv cH cfv c2nd cfv crp wcel vm cv cH cfv c2nd cfv cR clt
        wbr wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral vm cv cH cfv c1st cfv
        cX wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel vm cv cH cfv c2nd
        cfv cR clt wbr wa wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm
        cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co vm cv cH cfv
        c1st cfv cX wcel cR crp wcel wa vy cv vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cM cbl cfv co wcel vm cv cH cfv c2nd cfv crp wcel vm cv cH
        cfv c2nd cfv cR clt wbr wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr
        vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vy cv vm cv cH cfv c1st
        cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel wa vm cv cH cfv c2nd cfv
        crp wcel vm cv cH cfv c2nd cfv cR clt wbr vm cv cH cfv c1st cfv vy cv
        cM co cR clt wbr vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vy cv vm
        cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel wa vm cv cH
        cfv c2nd cfv crp wcel wa vm cv cH cfv c1st cfv vy cv cM co vm cv cH cfv
        c2nd cfv clt wbr vm cv cH cfv c2nd cfv cR clt wbr vm cv cH cfv c1st cfv
        vy cv cM co cR clt wbr vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vy
        cv vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel wa vm
        cv cH cfv c2nd cfv crp wcel wa vy cv cX wcel vm cv cH cfv c1st cfv vy
        cv cM co vm cv cH cfv c2nd cfv clt wbr vm cv cH cfv c1st cfv cX wcel cR
        crp wcel wa vm cv cH cfv c2nd cfv crp wcel vy cv vm cv cH cfv c1st cfv
        vm cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX wcel vm cv cH cfv
        c1st cfv vy cv cM co vm cv cH cfv c2nd cfv clt wbr wa vm cv cH cfv c1st
        cfv cX wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel wa vy cv vm
        cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX
        wcel vm cv cH cfv c1st cfv vy cv cM co vm cv cH cfv c2nd cfv clt wbr wa
        cM cme wcel vm cv cH cfv c1st cfv cX wcel vm cv cH cfv c2nd cfv cr wcel
        cc0 vm cv cH cfv c2nd cfv clt wbr vy cv vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cM cbl cfv co wcel vy cv cX wcel vm cv cH cfv c1st cfv vy
        cv cM co vm cv cH cfv c2nd cfv clt wbr wa wb vm cv cH cfv c1st cfv cX
        wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel wa vy cv cM vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cX heibor.2 elbl cM cme wcel vm cv
        cH cfv c1st cfv cX wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel
        wa cM heibor.9 cmsmeti a1i vm cv cH cfv c1st cfv cX wcel cR crp wcel vm
        cv cH cfv c2nd cfv crp wcel simpll vm cv cH cfv c2nd cfv crp wcel vm cv
        cH cfv c2nd cfv cr wcel vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vm
        cv cH cfv c2nd cfv rpre adantl vm cv cH cfv c2nd cfv crp wcel cc0 vm cv
        cH cfv c2nd cfv clt wbr vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vm
        cv cH cfv c2nd cfv rpgt0 adantl syl2anc biimpa an1rs pm3.27d vm cv cH
        cfv c1st cfv vy cv cM co cr wcel vm cv cH cfv c2nd cfv cr wcel cR cr
        wcel vm cv cH cfv c1st cfv vy cv cM co vm cv cH cfv c2nd cfv clt wbr vm
        cv cH cfv c2nd cfv cR clt wbr wa vm cv cH cfv c1st cfv vy cv cM co cR
        clt wbr wi vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vy cv vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel wa vm cv cH cfv
        c2nd cfv crp wcel wa vm cv cH cfv c1st cfv vy cv cM co vm cv cH cfv
        c2nd cfv cR lttr cM cme wcel vm cv cH cfv c1st cfv cX wcel vy cv cX
        wcel vm cv cH cfv c1st cfv vy cv cM co cr wcel vm cv cH cfv c1st cfv cX
        wcel cR crp wcel wa vy cv vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv
        cM cbl cfv co wcel wa vm cv cH cfv c2nd cfv crp wcel wa vm cv cH cfv
        c1st cfv vy cv cM cX heibor.2 metcl cM cme wcel vm cv cH cfv c1st cfv
        cX wcel cR crp wcel wa vy cv vm cv cH cfv c1st cfv vm cv cH cfv c2nd
        cfv cM cbl cfv co wcel wa vm cv cH cfv c2nd cfv crp wcel wa cM heibor.9
        cmsmeti a1i vm cv cH cfv c1st cfv cX wcel cR crp wcel vy cv vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel vm cv cH cfv c2nd
        cfv crp wcel simplll vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vy cv
        vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel wa vm cv
        cH cfv c2nd cfv crp wcel wa vy cv cX wcel vm cv cH cfv c1st cfv vy cv
        cM co vm cv cH cfv c2nd cfv clt wbr vm cv cH cfv c1st cfv cX wcel cR
        crp wcel wa vm cv cH cfv c2nd cfv crp wcel vy cv vm cv cH cfv c1st cfv
        vm cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX wcel vm cv cH cfv
        c1st cfv vy cv cM co vm cv cH cfv c2nd cfv clt wbr wa vm cv cH cfv c1st
        cfv cX wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel wa vy cv vm
        cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX
        wcel vm cv cH cfv c1st cfv vy cv cM co vm cv cH cfv c2nd cfv clt wbr wa
        cM cme wcel vm cv cH cfv c1st cfv cX wcel vm cv cH cfv c2nd cfv cr wcel
        cc0 vm cv cH cfv c2nd cfv clt wbr vy cv vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cM cbl cfv co wcel vy cv cX wcel vm cv cH cfv c1st cfv vy
        cv cM co vm cv cH cfv c2nd cfv clt wbr wa wb vm cv cH cfv c1st cfv cX
        wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel wa vy cv cM vm cv cH
        cfv c1st cfv vm cv cH cfv c2nd cfv cX heibor.2 elbl cM cme wcel vm cv
        cH cfv c1st cfv cX wcel cR crp wcel wa vm cv cH cfv c2nd cfv crp wcel
        wa cM heibor.9 cmsmeti a1i vm cv cH cfv c1st cfv cX wcel cR crp wcel vm
        cv cH cfv c2nd cfv crp wcel simpll vm cv cH cfv c2nd cfv crp wcel vm cv
        cH cfv c2nd cfv cr wcel vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vm
        cv cH cfv c2nd cfv rpre adantl vm cv cH cfv c2nd cfv crp wcel cc0 vm cv
        cH cfv c2nd cfv clt wbr vm cv cH cfv c1st cfv cX wcel cR crp wcel wa vm
        cv cH cfv c2nd cfv rpgt0 adantl syl2anc biimpa an1rs pm3.26d syl3anc vm
        cv cH cfv c2nd cfv crp wcel vm cv cH cfv c2nd cfv cr wcel vm cv cH cfv
        c1st cfv cX wcel cR crp wcel wa vy cv vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cM cbl cfv co wcel wa vm cv cH cfv c2nd cfv rpre adantl vm
        cv cH cfv c1st cfv cX wcel cR crp wcel wa cR cr wcel vy cv vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wcel vm cv cH cfv c2nd cfv
        crp wcel cR crp wcel cR cr wcel vm cv cH cfv c1st cfv cX wcel cR rpre
        adantl ad2antrr syl3anc mpand impr an1rs r19.21aiva ex adantr sylbird
        vm cv cn wcel vm cv cn0 wcel c2 vm cv cexp co crp wcel c1 c2 vm cv cexp
        co cdiv co crp wcel vm cv nnnn0 c2 crp wcel vm cv cn0 wcel c2 vm cv
        cexp co crp wcel c2 2re 2pos elrpii c2 vm cv rpexpcl mpan c2 vm cv cexp
        co rpreccl 3syl sylani an1rs expdimp anasss ex syl6 imp3a com12 anassrs
        imp3a a1d adantlr adantlr mpdd r19.21aiva ex r19.22dva mpd c2 cuz cfv
        cn wss vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr
        vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm
        cn wral vl c2 cuz cfv wrex vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy
        cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cM
        cbl cfv co wral wi vm cn wral vl cn wrex wi c2 cuz cfv c1 cuz cfv cn c2
        c1 cuz cfv wcel c2 cuz cfv c1 cuz cfv wss c2 c1 cuz cfv wcel c2 cz wcel
        c1 c2 cle wbr c1 c2 1z eluz1i 2z c1 c2 1re 2re 1lt2 ltleii mpbir2an c1
        c2 uzss ax-mp nnuz sseqtr4i vl cv vm cv cle wbr vm cv cH cfv c1st cfv
        vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv
        cM cbl cfv co wral wi vm cn wral vl c2 cuz cfv cn ssrexv ax-mp syl vx
        vv cB cD cU vg vh vj vn cG cH cJ cM cX vs vr va heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heibor.15
        heiborlem30 sylan cn cB cH wf vl cv vm cv cle wbr vm cv cH cfv c1st cfv
        vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv
        cM cbl cfv co wral wi vm cn wral vl cn wrex vl cv vm cv cle wbr vm cv
        cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv cM cbl cfv cfv
        wral wi vm cn wral vl cn wrex wb vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral cR crp wcel cn cB cH wf vl
        cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv
        cH cfv c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vm cn wral
        vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm
        cv cH cfv cM cbl cfv cfv wral wi vm cn wral vl cn cn cB cH wf vl cv vm
        cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co wral wi vl cv vm cv cle
        wbr vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv cM cbl
        cfv cfv wral wi vm cn cn cB cH wf vm cv cn wcel wa vm cv cH cfv c1st
        cfv vy cv cM co cR clt wbr vy vm cv cH cfv c1st cfv vm cv cH cfv c2nd
        cfv cM cbl cfv co wral vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy
        vm cv cH cfv cM cbl cfv cfv wral vl cv vm cv cle wbr cn cB cH wf vm cv
        cn wcel wa vm cv cH cfv c1st cfv vy cv cM co cR clt wbr vy vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co vm cv cH cfv cM cbl cfv
        cfv cn cB cH wf vm cv cn wcel wa vm cv cH cfv c1st cfv vm cv cH cfv
        c2nd cfv cop cM cbl cfv cfv vm cv cH cfv cM cbl cfv cfv vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv co cn cB cH wf vm cv cn wcel
        wa vm cv cH cfv c1st cfv vm cv cH cfv c2nd cfv cop vm cv cH cfv cM cbl
        cfv cn cB cH wf vm cv cn wcel wa vm cv cH cfv vm cv cH cfv c1st cfv vm
        cv cH cfv c2nd cfv cop cn cB cH wf vm cv cn wcel wa vm cv cH cfv vm cv
        cH cfv c1st cfv vm cv cH cfv c2nd cfv cop wceq vm cv cH cfv c1st cfv cX
        wcel vm cv cH cfv c2nd cfv crp wcel wa cn cB cH wf vm cv cn wcel wa vm
        cv cH cfv cX crp cxp wcel vm cv cH cfv vm cv cH cfv c1st cfv vm cv cH
        cfv c2nd cfv cop wceq vm cv cH cfv c1st cfv cX wcel vm cv cH cfv c2nd
        cfv crp wcel wa wa cn cB cH wf vm cv cn wcel wa vm cv cH cfv cB wcel vm
        cv cH cfv cX crp cxp wcel cn cB vm cv cH ffvelrn vm cv cH cfv cB wcel
        vm cv cH cfv cX crp cxp wcel vm cv cH cfv cM cbl cfv cfv cD wcel vx vv
        vm cv cH cfv cB cD cU cJ cM cX vs vr heibor.1 heibor.2 heibor.9
        heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heiborlem24 pm3.26bi
        syl vm cv cH cfv cX crp elxp6 sylib pm3.26d eqcomd fveq2d vm cv cH cfv
        c1st cfv vm cv cH cfv c2nd cfv cM cbl cfv df-opr syl5eq raleq1d imbi2d
        ralbidva rexbidv ad2antrr mpbid 3adantl3 adantrl $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Combine the two bounds in ~ heiborlem34 and
         ~ heiborlem35 to get a ball in ` H ` lying completely within a ball of
         arbitrary radius about ` Y ` . $)
      heiborlem36 $p |- ( ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) /\ ( 1st o. H ) ( ~~>m ` M ) Y )
                      /\ ( Y e. X /\ R e. RR+ ) ) -> E. p e. NN
                  ( ( ball ` M ) ` ( H ` p ) ) C_ ( Y ( ball ` M ) R ) ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel cR crp
        wcel wa wa vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2
        cdiv co clt wbr wi vm cn wral vj cn wrex vl cv vm cv cle wbr vm cv cH
        cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl
        cfv cfv wral wi vm cn wral vl cn wrex wa vp cv cH cfv cM cbl cfv cfv cY
        cR cM cbl cfv co wss vp cn wrex cn cB cH wf vg cv c1 caddc co cH cfv vg
        cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral c1st cH ccom cY cM
        clm cfv wbr w3a cY cX wcel cR c2 cdiv co crp wcel vj cv vm cv cle wbr
        vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vm cn wral vj
        cn wrex vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm cn wral vl cn
        wrex wa cR crp wcel cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc
        co vg cv cH cfv cG co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr
        w3a cY cX wcel cR c2 cdiv co crp wcel wa wa vj cv vm cv cle wbr vm cv
        cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vm cn wral vj cn wrex
        vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt
        wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm cn wral vl cn wrex vx vv
        cB cD cR c2 cdiv co cU vg vh vj vm vn cG cH cJ cM cX cY vs vr va
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heibor.15 heiborlem34 vx vy vv cB cD cR c2 cdiv co cU vg vh
        vm vn cG cH cJ cM cX cY vs vr va vl heibor.1 heibor.2 heibor.9
        heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heibor.15 heiborlem35
        jca cR crp wcel c2 crp wcel cR c2 cdiv co crp wcel c2 2re 2pos elrpii
        cR c2 rpdivcl mpan2 sylanr2 cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral cY cX wcel cR crp wcel
        wa vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt
        wbr wi vm cn wral vj cn wrex vl cv vm cv cle wbr vm cv cH cfv c1st cfv
        vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral
        wi vm cn wral vl cn wrex wa vp cv cH cfv cM cbl cfv cfv cY cR cM cbl
        cfv co wss vp cn wrex wi c1st cH ccom cY cM clm cfv wbr cn cB cH wf vg
        cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn
        wral wa cY cX wcel cR crp wcel wa wa vj cv vm cv cle wbr vm cv cH cfv
        c1st cfv cY cM co cR c2 cdiv co clt wbr wi vm cn wral vl cv vm cv cle
        wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH
        cfv cM cbl cfv cfv wral wi vm cn wral wa vl cn wrex vj cn wrex vp cv cH
        cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vp cn wrex vj cv vm cv cle
        wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vm cn wral
        vj cn wrex vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm cn wral vl cn
        wrex wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vj cv vm cv
        cle wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vm cn
        wral vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv
        co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm cn wral wa vp cv
        cH cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vp cn wrex vj vl cn cn cn
        cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co
        wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vj cv cn wcel vl cv cn
        wcel wa vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv
        co clt wbr wi vm cn wral vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy
        cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi
        vm cn wral wa vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vp cn
        wrex wi cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vj cv cn wcel
        vl cv cn wcel wa wa vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co
        cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy
        cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi
        wa vm cn wral vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vp cn
        wrex vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co
        clt wbr wi vm cn wral vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv
        cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi vm
        cn wral wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv
        cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vj cv vp
        cv cle wbr vl cv vp cv cle wbr wa vp cn wrex vj cv vm cv cle wbr vm cv
        cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr
        vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv
        cM cbl cfv cfv wral wi wa vm cn wral vp cv cH cfv cM cbl cfv cfv cY cR
        cM cbl cfv co wss vp cn wrex wi vj cv cn wcel vl cv cn wcel wa cn cB cH
        wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel
        vg cn wral wa cY cX wcel cR crp wcel wa wa vj cv vp cv cle wbr vl cv vp
        cv cle wbr wa vp cn wrex vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY
        cM co cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st
        cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv
        wral wi wa vm cn wral vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv co
        wss vp cn wrex wi cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc
        co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa
        vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt
        wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv
        co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi wa vm cn wral vj cv
        vp cv cle wbr vl cv vp cv cle wbr wa vp cn wrex vp cv cH cfv cM cbl cfv
        cfv cY cR cM cbl cfv co wss vp cn wrex cn cB cH wf vg cv c1 caddc co cH
        cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel
        cR crp wcel wa wa vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR
        c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv
        cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi wa
        vm cn wral vj cv vp cv cle wbr vl cv vp cv cle wbr wa vp cn wrex vp cv
        cH cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vp cn wrex wi cn cB cH wf
        vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg
        cn wral wa cY cX wcel cR crp wcel wa wa vj cv vm cv cle wbr vm cv cH
        cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm
        cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM
        cbl cfv cfv wral wi wa vm cn wral wa vj cv vp cv cle wbr vl cv vp cv
        cle wbr wa vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vp cn cn
        cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co
        wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vj cv vm cv cle wbr vm
        cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vm cv cle
        wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH
        cfv cM cbl cfv cfv wral wi wa vm cn wral vp cv cn wcel vj cv vp cv cle
        wbr vl cv vp cv cle wbr wa vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv
        co wss wi cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv
        cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn
        wcel vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co
        clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi wa vm cn wral vj
        cv vp cv cle wbr vl cv vp cv cle wbr wa vp cv cH cfv cM cbl cfv cfv cY
        cR cM cbl cfv co wss wi cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel
        wa wa vp cv cn wcel vj cv vp cv cle wbr vp cv cH cfv c1st cfv cY cM co
        cR c2 cdiv co clt wbr wi vl cv vp cv cle wbr vp cv cH cfv c1st cfv vy
        cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv cM cbl cfv cfv wral wi
        wa wa vj cv vp cv cle wbr vl cv vp cv cle wbr wa vp cv cH cfv cM cbl
        cfv cfv cY cR cM cbl cfv co wss wi vp cv cn wcel vj cv vm cv cle wbr vm
        cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vm cv cle
        wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH
        cfv cM cbl cfv cfv wral wi wa vm cn wral wa cn cB cH wf vg cv c1 caddc
        co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX
        wcel cR crp wcel wa wa vp cv cn wcel vj cv vp cv cle wbr vp cv cH cfv
        c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vp cv cle wbr vp cv cH
        cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv cM cbl
        cfv cfv wral wi wa vj cv vp cv cle wbr vl cv vp cv cle wbr wa vp cv cH
        cfv cM cbl cfv cfv cY cR cM cbl cfv co wss wi vj cv vp cv cle wbr vp cv
        cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vp cv cle wbr
        vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv
        cM cbl cfv cfv wral wi wa vj cv vp cv cle wbr vl cv vp cv cle wbr wa vp
        cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st cfv
        vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv cM cbl cfv cfv wral
        wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv
        cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa
        vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv co wss vj cv vp cv cle wbr
        vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr vl cv vp cv cle
        wbr vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH
        cfv cM cbl cfv cfv wral prth cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp
        wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv
        co clt wbr vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy
        vp cv cH cfv cM cbl cfv cfv wral wa vp cv cH cfv cM cbl cfv cfv cY cR
        cM cbl cfv co wss cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc
        co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa
        vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr
        vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv
        cM cbl cfv cfv wral wa wa vy cv cY cR cM cbl cfv co wcel vy vp cv cH
        cfv cM cbl cfv cfv wral vp cv cH cfv cM cbl cfv cfv cY cR cM cbl cfv co
        wss cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv
        cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa
        vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st
        cfv vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv cM cbl cfv cfv
        wral vy cv cY cR cM cbl cfv co wcel vy vp cv cH cfv cM cbl cfv cfv wral
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vp
        cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa vp cv cH cfv c1st
        cfv vy cv cM co cR c2 cdiv co clt wbr vy cv cY cR cM cbl cfv co wcel vy
        vp cv cH cfv cM cbl cfv cfv cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp
        wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv
        co clt wbr wa vy cv vp cv cH cfv cM cbl cfv cfv wcel wa vp cv cH cfv
        c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy cv cY cR cM cbl cfv co
        wcel cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel
        wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa vy cv vp cv
        cH cfv cM cbl cfv cfv wcel wa vp cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr wa vy cv cY cR cM cbl cfv co wcel vy cv cX wcel cY vy
        cv cM co cR clt wbr wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel
        wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt
        wbr wa vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy cv vp
        cv cH cfv cM cbl cfv cfv wcel vy cv cX wcel cY vy cv cM co cR clt wbr
        wa cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv
        cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa
        vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa vp cv cH cfv
        c1st cfv vy cv cM co cR c2 cdiv co clt wbr wa vy cv vp cv cH cfv cM cbl
        cfv cfv wcel vy cv cX wcel vy cv cX wcel cY vy cv cM co cR clt wbr wa
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vp
        cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa vp cv cH cfv c1st
        cfv vy cv cM co cR c2 cdiv co clt wbr wa vy cv vp cv cH cfv cM cbl cfv
        cfv wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co vp cv cH cfv
        c2nd cfv clt wbr cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co
        vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp
        cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa
        vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr wa vy cv vp cv
        cH cfv cM cbl cfv cfv wcel vy cv vp cv cH cfv c1st cfv vp cv cH cfv
        c2nd cfv cM cbl cfv co wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv
        cM co vp cv cH cfv c2nd cfv clt wbr wa cn cB cH wf vg cv c1 caddc co cH
        cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel
        cR crp wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2
        cdiv co clt wbr wa vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt
        wbr wa vp cv cH cfv cM cbl cfv cfv vp cv cH cfv c1st cfv vp cv cH cfv
        c2nd cfv cM cbl cfv co vy cv cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp
        wcel wa wa vp cv cn wcel wa vp cv cH cfv cM cbl cfv cfv vp cv cH cfv
        c1st cfv vp cv cH cfv c2nd cfv cM cbl cfv co wceq vp cv cH cfv c1st cfv
        cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr cn cB cH wf cY cX wcel cR crp wcel wa vp cv cn wcel vp
        cv cH cfv cM cbl cfv cfv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cM
        cbl cfv co wceq vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv
        cG co wcel vg cn wral cn cB cH wf vp cv cn wcel vp cv cH cfv cM cbl cfv
        cfv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cM cbl cfv co wceq cY
        cX wcel cR crp wcel wa cn cB cH wf vp cv cn wcel wa vp cv cH cfv cB
        wcel vp cv cH cfv cM cbl cfv cfv vp cv cH cfv c1st cfv vp cv cH cfv
        c2nd cfv cM cbl cfv co wceq cn cB vp cv cH ffvelrn vp cv cH cfv cB wcel
        vp cv cH cfv cM cbl cfv cfv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv
        cop cM cbl cfv cfv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cM cbl
        cfv co vp cv cH cfv cB wcel vp cv cH cfv vp cv cH cfv c1st cfv vp cv cH
        cfv c2nd cfv cop cM cbl cfv vp cv cH cfv cB wcel vp cv cH cfv cX crp
        cxp wcel vp cv cH cfv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cop
        wceq vp cv cH cfv cB wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv cM
        cbl cfv cfv cD wcel vx vv vp cv cH cfv cB cD cU cJ cM cX vs vr heibor.1
        heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14
        heiborlem24 pm3.26bi vp cv cH cfv cX crp cxp wcel vp cv cH cfv vp cv cH
        cfv c1st cfv vp cv cH cfv c2nd cfv cop wceq vp cv cH cfv c1st cfv cX
        wcel vp cv cH cfv c2nd cfv crp wcel wa vp cv cH cfv cX crp elxp6
        pm3.26bi syl fveq2d vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cM cbl
        cfv df-opr syl6eqr syl adantlr adantllr ad2antrr eleq2d cn cB cH wf vg
        cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn
        wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vy cv vp cv cH
        cfv c1st cfv vp cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX wcel vp
        cv cH cfv c1st cfv vy cv cM co vp cv cH cfv c2nd cfv clt wbr wa wb vp
        cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st cfv
        vy cv cM co cR c2 cdiv co clt wbr cn cB cH wf vg cv c1 caddc co cH cfv
        vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa vp cv cn wcel
        vy cv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cM cbl cfv co wcel vy
        cv cX wcel vp cv cH cfv c1st cfv vy cv cM co vp cv cH cfv c2nd cfv clt
        wbr wa wb cY cX wcel cR crp wcel wa cn cB cH wf vp cv cn wcel vy cv vp
        cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX
        wcel vp cv cH cfv c1st cfv vy cv cM co vp cv cH cfv c2nd cfv clt wbr wa
        wb vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel
        vg cn wral cn cB cH wf vp cv cn wcel wa vp cv cH cfv cB wcel vp cv cH
        cfv cX crp cxp wcel vy cv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv
        cM cbl cfv co wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co vp
        cv cH cfv c2nd cfv clt wbr wa wb cn cB vp cv cH ffvelrn vp cv cH cfv cB
        wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv cM cbl cfv cfv cD wcel
        vx vv vp cv cH cfv cB cD cU cJ cM cX vs vr heibor.1 heibor.2 heibor.9
        heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heiborlem24 pm3.26bi
        vp cv cH cfv cX crp cxp wcel vp cv cH cfv c1st cfv cX wcel vp cv cH cfv
        c2nd cfv crp wcel wa vy cv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv
        cM cbl cfv co wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co vp
        cv cH cfv c2nd cfv clt wbr wa wb vp cv cH cfv cX crp cxp wcel vp cv cH
        cfv vp cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cop wceq vp cv cH cfv
        c1st cfv cX wcel vp cv cH cfv c2nd cfv crp wcel wa vp cv cH cfv cX crp
        elxp6 pm3.27bi cM cme wcel vp cv cH cfv c1st cfv cX wcel vp cv cH cfv
        c2nd cfv cr wcel cc0 vp cv cH cfv c2nd cfv clt wbr vy cv vp cv cH cfv
        c1st cfv vp cv cH cfv c2nd cfv cM cbl cfv co wcel vy cv cX wcel vp cv
        cH cfv c1st cfv vy cv cM co vp cv cH cfv c2nd cfv clt wbr wa wb vp cv
        cH cfv c1st cfv cX wcel vp cv cH cfv c2nd cfv crp wcel wa vy cv cM vp
        cv cH cfv c1st cfv vp cv cH cfv c2nd cfv cX heibor.2 elbl cM cme wcel
        vp cv cH cfv c1st cfv cX wcel vp cv cH cfv c2nd cfv crp wcel wa cM
        heibor.9 cmsmeti a1i vp cv cH cfv c1st cfv cX wcel vp cv cH cfv c2nd
        cfv crp wcel pm3.26 vp cv cH cfv c2nd cfv crp wcel vp cv cH cfv c2nd
        cfv cr wcel vp cv cH cfv c1st cfv cX wcel vp cv cH cfv c2nd cfv rpre
        adantl vp cv cH cfv c2nd cfv crp wcel cc0 vp cv cH cfv c2nd cfv clt wbr
        vp cv cH cfv c1st cfv cX wcel vp cv cH cfv c2nd cfv rpgt0 adantl
        syl2anc syl 3syl adantlr adantlr ad2antrr bitrd pm3.26bda cn cB cH wf
        vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg
        cn wral wa cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vp cv cH cfv
        c1st cfv cY cM co cR c2 cdiv co clt wbr wa vp cv cH cfv c1st cfv vy cv
        cM co cR c2 cdiv co clt wbr wa vy cv cX wcel wa vy cv cX wcel cY vy cv
        cM co cR clt wbr cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co
        vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp
        cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa
        vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr wa vy cv cX
        wcel pm3.27 cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg
        cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel wa wa vp cv
        cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wa vp
        cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr wa vy cv cX wcel
        cY vy cv cM co cR clt wbr cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1
        caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp wcel
        wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt
        wbr vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy cv cX
        wcel cY vy cv cM co cR clt wbr wi cn cB cH wf vg cv c1 caddc co cH cfv
        vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR
        crp wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2
        cdiv co clt wbr vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr
        wa vy cv cX wcel cY vy cv cM co cR clt wbr wi cn cB cH wf cY cX wcel cR
        crp wcel wa vp cv cn wcel vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co
        clt wbr vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr wa vy
        cv cX wcel cY vy cv cM co cR clt wbr wi wi vg cv c1 caddc co cH cfv vg
        cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral cn cB cH wf cY cX
        wcel cR crp wcel wa wa vp cv cn wcel wa vy cv cX wcel vp cv cH cfv c1st
        cfv cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st cfv vy cv cM co cR
        c2 cdiv co clt wbr wa cY vy cv cM co cR clt wbr cn cB cH wf cY cX wcel
        cR crp wcel wa wa vp cv cn wcel wa vy cv cX wcel vp cv cH cfv c1st cfv
        cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr wa cY vy cv cM co cR clt wbr wi cn cB cH wf cY cX wcel
        cR crp wcel wa wa vp cv cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st
        cfv cY cM co cR c2 cdiv co clt wbr vp cv cH cfv c1st cfv vy cv cM co cR
        c2 cdiv co clt wbr wa vp cv cH cfv c1st cfv cY cM co vp cv cH cfv c1st
        cfv vy cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr
        cY vy cv cM co cR clt wbr vp cv cH cfv c1st cfv cY cM co cr wcel vp cv
        cH cfv c1st cfv vy cv cM co cr wcel cR c2 cdiv co cr wcel cR c2 cdiv co
        cr wcel vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr vp cv cH
        cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr wa vp cv cH cfv c1st cfv
        cY cM co vp cv cH cfv c1st cfv vy cv cM co caddc co cR c2 cdiv co cR c2
        cdiv co caddc co clt wbr wi cn cB cH wf cY cX wcel cR crp wcel wa wa vp
        cv cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st cfv cY cM co vp cv cH
        cfv c1st cfv vy cv cM co cR c2 cdiv co cR c2 cdiv co lt2add cn cB cH wf
        cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY
        cM co cr wcel vy cv cX wcel cn cB cH wf cY cX wcel vp cv cn wcel vp cv
        cH cfv c1st cfv cY cM co cr wcel cR crp wcel cM cme wcel vp cv cH cfv
        c1st cfv cX wcel cY cX wcel vp cv cH cfv c1st cfv cY cM co cr wcel cn
        cB cH wf cY cX wcel wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM cX
        heibor.2 metcl cM cme wcel cn cB cH wf cY cX wcel wa vp cv cn wcel wa
        cM heibor.9 cmsmeti a1i cn cB cH wf vp cv cn wcel vp cv cH cfv c1st cfv
        cX wcel cY cX wcel cn cB cH wf vp cv cn wcel wa vp cv cH cfv cB wcel vp
        cv cH cfv cX crp cxp wcel vp cv cH cfv c1st cfv cX wcel cn cB vp cv cH
        ffvelrn vp cv cH cfv cB wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv
        cM cbl cfv cfv cD wcel vx vv vp cv cH cfv cB cD cU cJ cM cX vs vr
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heiborlem24 pm3.26bi vp cv cH cfv cX crp xp1st 3syl adantlr
        cn cB cH wf cY cX wcel vp cv cn wcel simplr syl3anc adantlrr adantr cn
        cB cH wf vp cv cn wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co
        cr wcel cY cX wcel cR crp wcel wa cM cme wcel vp cv cH cfv c1st cfv cX
        wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co cr wcel cn cB cH
        wf vp cv cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st cfv vy cv cM cX
        heibor.2 metcl cM cme wcel cn cB cH wf vp cv cn wcel wa vy cv cX wcel
        wa cM heibor.9 cmsmeti a1i cn cB cH wf vp cv cn wcel wa vp cv cH cfv
        c1st cfv cX wcel vy cv cX wcel cn cB cH wf vp cv cn wcel wa vp cv cH
        cfv cB wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv c1st cfv cX wcel
        cn cB vp cv cH ffvelrn vp cv cH cfv cB wcel vp cv cH cfv cX crp cxp
        wcel vp cv cH cfv cM cbl cfv cfv cD wcel vx vv vp cv cH cfv cB cD cU cJ
        cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heiborlem24 pm3.26bi vp cv cH cfv cX crp xp1st 3syl
        adantr cn cB cH wf vp cv cn wcel wa vy cv cX wcel pm3.27 syl3anc
        adantllr cn cB cH wf cY cX wcel cR crp wcel wa wa cR c2 cdiv co cr wcel
        vp cv cn wcel vy cv cX wcel cR crp wcel cR c2 cdiv co cr wcel cn cB cH
        wf cY cX wcel cR crp wcel cR c2 cdiv co crp wcel cR c2 cdiv co cr wcel
        cR crp wcel c2 crp wcel cR c2 cdiv co crp wcel c2 2re 2pos elrpii cR c2
        rpdivcl mpan2 cR c2 cdiv co rpre syl ad2antll ad2antrr cn cB cH wf cY
        cX wcel cR crp wcel wa wa cR c2 cdiv co cr wcel vp cv cn wcel vy cv cX
        wcel cR crp wcel cR c2 cdiv co cr wcel cn cB cH wf cY cX wcel cR crp
        wcel cR c2 cdiv co crp wcel cR c2 cdiv co cr wcel cR crp wcel c2 crp
        wcel cR c2 cdiv co crp wcel c2 2re 2pos elrpii cR c2 rpdivcl mpan2 cR
        c2 cdiv co rpre syl ad2antll ad2antrr syl2anc cn cB cH wf cY cX wcel cR
        crp wcel wa wa vp cv cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st cfv
        cY cM co vp cv cH cfv c1st cfv vy cv cM co caddc co cR c2 cdiv co cR c2
        cdiv co caddc co clt wbr cY vy cv cM co cR clt wbr cn cB cH wf cY cX
        wcel cR crp wcel wa wa vp cv cn wcel wa vy cv cX wcel wa vp cv cH cfv
        c1st cfv cY cM co vp cv cH cfv c1st cfv vy cv cM co caddc co cR c2 cdiv
        co cR c2 cdiv co caddc co clt wbr wa cY vy cv cM co cR c2 cdiv co cR c2
        cdiv co caddc co cR clt cn cB cH wf cY cX wcel cR crp wcel wa wa vp cv
        cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st cfv cY cM co vp cv cH cfv
        c1st cfv vy cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt
        wbr cY vy cv cM co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cn cB
        cH wf cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vy cv cX wcel wa cY
        vy cv cM co vp cv cH cfv c1st cfv cY cM co vp cv cH cfv c1st cfv vy cv
        cM co caddc co cle wbr vp cv cH cfv c1st cfv cY cM co vp cv cH cfv c1st
        cfv vy cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr
        cY vy cv cM co cR c2 cdiv co cR c2 cdiv co caddc co clt wbr cM cme wcel
        cY cX wcel vy cv cX wcel vp cv cH cfv c1st cfv cX wcel cY vy cv cM co
        vp cv cH cfv c1st cfv cY cM co vp cv cH cfv c1st cfv vy cv cM co caddc
        co cle wbr cn cB cH wf cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vy
        cv cX wcel wa cY vy cv vp cv cH cfv c1st cfv cM cX heibor.2 mettri4 cM
        cme wcel cn cB cH wf cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vy
        cv cX wcel wa cM heibor.9 cmsmeti a1i cn cB cH wf cY cX wcel cR crp
        wcel wa wa cY cX wcel vp cv cn wcel vy cv cX wcel cn cB cH wf cY cX
        wcel cR crp wcel simprl ad2antrr cn cB cH wf cY cX wcel cR crp wcel wa
        wa vp cv cn wcel wa vy cv cX wcel pm3.27 cn cB cH wf vp cv cn wcel vy
        cv cX wcel vp cv cH cfv c1st cfv cX wcel cY cX wcel cR crp wcel wa cn
        cB cH wf vp cv cn wcel wa vp cv cH cfv c1st cfv cX wcel vy cv cX wcel
        cn cB cH wf vp cv cn wcel wa vp cv cH cfv cB wcel vp cv cH cfv cX crp
        cxp wcel vp cv cH cfv c1st cfv cX wcel cn cB vp cv cH ffvelrn vp cv cH
        cfv cB wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv cM cbl cfv cfv cD
        wcel vx vv vp cv cH cfv cB cD cU cJ cM cX vs vr heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heiborlem24
        pm3.26bi vp cv cH cfv cX crp xp1st 3syl adantr adantllr syl2anc cY vy
        cv cM co cr wcel vp cv cH cfv c1st cfv cY cM co vp cv cH cfv c1st cfv
        vy cv cM co caddc co cr wcel cR c2 cdiv co cR c2 cdiv co caddc co cr
        wcel cY vy cv cM co vp cv cH cfv c1st cfv cY cM co vp cv cH cfv c1st
        cfv vy cv cM co caddc co cle wbr vp cv cH cfv c1st cfv cY cM co vp cv
        cH cfv c1st cfv vy cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc
        co clt wbr wa cY vy cv cM co cR c2 cdiv co cR c2 cdiv co caddc co clt
        wbr wi cn cB cH wf cY cX wcel cR crp wcel wa wa vp cv cn wcel wa vy cv
        cX wcel wa cY vy cv cM co vp cv cH cfv c1st cfv cY cM co vp cv cH cfv
        c1st cfv vy cv cM co caddc co cR c2 cdiv co cR c2 cdiv co caddc co
        lelttr cn cB cH wf cY cX wcel cR crp wcel wa wa vy cv cX wcel cY vy cv
        cM co cr wcel vp cv cn wcel cY cX wcel cR crp wcel wa vy cv cX wcel cY
        vy cv cM co cr wcel cn cB cH wf cY cX wcel vy cv cX wcel cY vy cv cM co
        cr wcel cR crp wcel cM cme wcel cY cX wcel vy cv cX wcel cY vy cv cM co
        cr wcel cM heibor.9 cmsmeti cY vy cv cM cX heibor.2 metcl mp3an1
        adantlr adantll adantlr vp cv cH cfv c1st cfv cY cM co cr wcel vp cv cH
        cfv c1st cfv vy cv cM co cr wcel vp cv cH cfv c1st cfv cY cM co vp cv
        cH cfv c1st cfv vy cv cM co caddc co cr wcel cn cB cH wf cY cX wcel cR
        crp wcel wa wa vp cv cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st cfv
        cY cM co vp cv cH cfv c1st cfv vy cv cM co readdcl cn cB cH wf cY cX
        wcel cR crp wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co
        cr wcel vy cv cX wcel cn cB cH wf cY cX wcel vp cv cn wcel vp cv cH cfv
        c1st cfv cY cM co cr wcel cR crp wcel cM cme wcel vp cv cH cfv c1st cfv
        cX wcel cY cX wcel vp cv cH cfv c1st cfv cY cM co cr wcel cn cB cH wf
        cY cX wcel wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM cX heibor.2
        metcl cM cme wcel cn cB cH wf cY cX wcel wa vp cv cn wcel wa cM
        heibor.9 cmsmeti a1i cn cB cH wf vp cv cn wcel vp cv cH cfv c1st cfv cX
        wcel cY cX wcel cn cB cH wf vp cv cn wcel wa vp cv cH cfv cB wcel vp cv
        cH cfv cX crp cxp wcel vp cv cH cfv c1st cfv cX wcel cn cB vp cv cH
        ffvelrn vp cv cH cfv cB wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv
        cM cbl cfv cfv cD wcel vx vv vp cv cH cfv cB cD cU cJ cM cX vs vr
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heibor.14 heiborlem24 pm3.26bi vp cv cH cfv cX crp xp1st 3syl adantlr
        cn cB cH wf cY cX wcel vp cv cn wcel simplr syl3anc adantlrr adantr cn
        cB cH wf vp cv cn wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co
        cr wcel cY cX wcel cR crp wcel wa cM cme wcel vp cv cH cfv c1st cfv cX
        wcel vy cv cX wcel vp cv cH cfv c1st cfv vy cv cM co cr wcel cn cB cH
        wf vp cv cn wcel wa vy cv cX wcel wa vp cv cH cfv c1st cfv vy cv cM cX
        heibor.2 metcl cM cme wcel cn cB cH wf vp cv cn wcel wa vy cv cX wcel
        wa cM heibor.9 cmsmeti a1i cn cB cH wf vp cv cn wcel wa vp cv cH cfv
        c1st cfv cX wcel vy cv cX wcel cn cB cH wf vp cv cn wcel wa vp cv cH
        cfv cB wcel vp cv cH cfv cX crp cxp wcel vp cv cH cfv c1st cfv cX wcel
        cn cB vp cv cH ffvelrn vp cv cH cfv cB wcel vp cv cH cfv cX crp cxp
        wcel vp cv cH cfv cM cbl cfv cfv cD wcel vx vv vp cv cH cfv cB cD cU cJ
        cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heiborlem24 pm3.26bi vp cv cH cfv cX crp xp1st 3syl
        adantr cn cB cH wf vp cv cn wcel wa vy cv cX wcel pm3.27 syl3anc
        adantllr sylanc cn cB cH wf cY cX wcel cR crp wcel wa wa cR c2 cdiv co
        cR c2 cdiv co caddc co cr wcel vp cv cn wcel vy cv cX wcel cR crp wcel
        cR c2 cdiv co cR c2 cdiv co caddc co cr wcel cn cB cH wf cY cX wcel cR
        crp wcel cR c2 cdiv co crp wcel cR c2 cdiv co cr wcel cR c2 cdiv co cR
        c2 cdiv co caddc co cr wcel cR crp wcel c2 crp wcel cR c2 cdiv co crp
        wcel c2 2re 2pos elrpii cR c2 rpdivcl mpan2 cR c2 cdiv co rpre cR c2
        cdiv co cr wcel cR c2 cdiv co cR c2 cdiv co caddc co cr wcel cR c2 cdiv
        co cR c2 cdiv co readdcl anidms 3syl ad2antll ad2antrr syl3anc mpand
        imp cn cB cH wf cY cX wcel cR crp wcel wa wa vp cv cn wcel wa cR c2
        cdiv co cR c2 cdiv co caddc co cR wceq vy cv cX wcel vp cv cH cfv c1st
        cfv cY cM co vp cv cH cfv c1st cfv vy cv cM co caddc co cR c2 cdiv co
        cR c2 cdiv co caddc co clt wbr cY cX wcel cR crp wcel wa cR c2 cdiv co
        cR c2 cdiv co caddc co cR wceq cn cB cH wf vp cv cn wcel cR crp wcel cR
        c2 cdiv co cR c2 cdiv co caddc co cR wceq cY cX wcel cR crp wcel cR cc
        wcel cR c2 cdiv co cR c2 cdiv co caddc co cR wceq cR rpcn cR 2halves
        syl adantl ad2antlr ad2antrr breqtrd ex syld ex com23 adantllr imp
        anassrs imp jca syldan an1rs cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX wcel cR crp
        wcel wa wa vp cv cn wcel wa vp cv cH cfv c1st cfv cY cM co cR c2 cdiv
        co clt wbr wa vy cv cY cR cM cbl cfv co wcel vy cv cX wcel cY vy cv cM
        co cR clt wbr wa wb vy cv vp cv cH cfv cM cbl cfv cfv wcel vp cv cH cfv
        c1st cfv vy cv cM co cR c2 cdiv co clt wbr cn cB cH wf vg cv c1 caddc
        co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral wa cY cX
        wcel cR crp wcel wa wa vy cv cY cR cM cbl cfv co wcel vy cv cX wcel cY
        vy cv cM co cR clt wbr wa wb vp cv cn wcel vp cv cH cfv c1st cfv cY cM
        co cR c2 cdiv co clt wbr cY cX wcel cR crp wcel wa vy cv cY cR cM cbl
        cfv co wcel vy cv cX wcel cY vy cv cM co cR clt wbr wa wb cn cB cH wf
        vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg
        cn wral wa cM cme wcel cY cX wcel cR cr wcel cc0 cR clt wbr vy cv cY cR
        cM cbl cfv co wcel vy cv cX wcel cY vy cv cM co cR clt wbr wa wb cY cX
        wcel cR crp wcel wa vy cv cM cY cR cX heibor.2 elbl cM cme wcel cY cX
        wcel cR crp wcel wa cM heibor.9 cmsmeti a1i cY cX wcel cR crp wcel
        pm3.26 cR crp wcel cR cr wcel cY cX wcel cR rpre adantl cR crp wcel cc0
        cR clt wbr cY cX wcel cR rpgt0 adantl syl2anc adantl ad2antrr ad2antrr
        mpbird ex r19.20dva impr vy vp cv cH cfv cM cbl cfv cfv cY cR cM cbl
        cfv co dfss3 sylibr ex sylan9r anasss vp cv cn wcel vj cv vm cv cle wbr
        vm cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vm cv cle
        wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH
        cfv cM cbl cfv cfv wral wi wa vm cn wral vj cv vp cv cle wbr vp cv cH
        cfv c1st cfv cY cM co cR c2 cdiv co clt wbr wi vl cv vp cv cle wbr vp
        cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vp cv cH cfv cM
        cbl cfv cfv wral wi wa vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM
        co cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv
        vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral
        wi wa vj cv vp cv cle wbr vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co
        clt wbr wi vl cv vp cv cle wbr vp cv cH cfv c1st cfv vy cv cM co cR c2
        cdiv co clt wbr vy vp cv cH cfv cM cbl cfv cfv wral wi wa vm vp cv cn
        vm cv vp cv wceq vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co cR
        c2 cdiv co clt wbr wi vj cv vp cv cle wbr vp cv cH cfv c1st cfv cY cM
        co cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv
        vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral
        wi vl cv vp cv cle wbr vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co
        clt wbr vy vp cv cH cfv cM cbl cfv cfv wral wi vm cv vp cv wceq vj cv
        vm cv cle wbr vj cv vp cv cle wbr vm cv cH cfv c1st cfv cY cM co cR c2
        cdiv co clt wbr vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt wbr vm
        cv vp cv vj cv cle breq2 vm cv vp cv wceq vm cv cH cfv c1st cfv cY cM
        co vp cv cH cfv c1st cfv cY cM co cR c2 cdiv co clt vm cv vp cv wceq vm
        cv cH cfv c1st cfv vp cv cH cfv c1st cfv cY cM vm cv vp cv wceq vm cv
        cH cfv vp cv cH cfv c1st vm cv vp cv cH fveq2 fveq2d opreq1d breq1d
        imbi12d vm cv vp cv wceq vl cv vm cv cle wbr vl cv vp cv cle wbr vm cv
        cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM
        cbl cfv cfv wral vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt
        wbr vy vp cv cH cfv cM cbl cfv cfv wral vm cv vp cv vl cv cle breq2 vm
        cv vp cv wceq vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr
        vp cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv
        cM cbl cfv cfv vp cv cH cfv cM cbl cfv cfv vm cv vp cv wceq vm cv cH
        cfv vp cv cH cfv cM cbl cfv vm cv vp cv cH fveq2 fveq2d vm cv vp cv
        wceq vm cv cH cfv c1st cfv vy cv cM co vp cv cH cfv c1st cfv vy cv cM
        co cR c2 cdiv co clt vm cv vp cv wceq vm cv cH cfv c1st cfv vp cv cH
        cfv c1st cfv vy cv cM vm cv vp cv wceq vm cv cH cfv vp cv cH cfv c1st
        vm cv vp cv cH fveq2 fveq2d opreq1d breq1d raleq12d imbi12d anbi12d
        rcla4v imdistani sylan2 ancom2s anassrs r19.22dva ex com23 imp vp vj cv
        vl cv nn2ge sylan2 vj cv vm cv cle wbr vm cv cH cfv c1st cfv cY cM co
        cR c2 cdiv co clt wbr wi vl cv vm cv cle wbr vm cv cH cfv c1st cfv vy
        cv cM co cR c2 cdiv co clt wbr vy vm cv cH cfv cM cbl cfv cfv wral wi
        vm cn r19.26 syl5ibr ex r19.23advv vj cv vm cv cle wbr vm cv cH cfv
        c1st cfv cY cM co cR c2 cdiv co clt wbr wi vm cn wral vl cv vm cv cle
        wbr vm cv cH cfv c1st cfv vy cv cM co cR c2 cdiv co clt wbr vy vm cv cH
        cfv cM cbl cfv cfv wral wi vm cn wral vj vl cn cn reeanv syl5ibr
        3adantl3 mpd $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Since ` U ` is an open cover of ` X ` , there is
        an element of ` U ` containing a ball around ` Y ` , and thus
         containing a ball in ` H ` . $)
      heiborlem37 $p |- ( ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) /\ ( 1st o. H ) ( ~~>m ` M ) Y )
                      /\ Y e. X ) -> E. p e. NN E. u e. U
                                ( ( ball ` M ) ` ( H ` p ) ) C_ u ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa cY
        vu cv wcel vu cU wrex vp cv cH cfv cM cbl cfv cfv vu cv wss vu cU wrex
        vp cn wrex cY cX wcel cY vu cv wcel vu cU wrex cn cB cH wf vg cv c1
        caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel cY vu cv wcel vu cU wrex
        cY cX wcel cY cU cuni wcel cY vu cv wcel vu cU wrex cX cU cuni cY
        heibor.12 eleq2i vu cY cU eluni2 bitri biimpi adantl cn cB cH wf vg cv
        c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa cY vu cv wcel vu cU
        wrex vp cv cH cfv cM cbl cfv cfv vu cv wss vp cn wrex vu cU wrex vp cv
        cH cfv cM cbl cfv cfv vu cv wss vu cU wrex vp cn wrex cn cB cH wf vg cv
        c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa cY vu cv wcel vp cv cH
        cfv cM cbl cfv cfv vu cv wss vp cn wrex vu cU cn cB cH wf vg cv c1
        caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa vu cv cJ wcel cY vu cv
        wcel vp cv cH cfv cM cbl cfv cfv vu cv wss vp cn wrex wi vu cv cU wcel
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa vu
        cv cJ wcel cY vu cv wcel vp cv cH cfv cM cbl cfv cfv vu cv wss vp cn
        wrex cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH
        cfv cG co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel
        wa vy cv crp wcel cY vy cv cM cbl cfv co vu cv wss wa vy wex vp cv cH
        cfv cM cbl cfv cfv vu cv wss vp cn wrex vu cv cJ wcel cY vu cv wcel wa
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa vy
        cv crp wcel cY vy cv cM cbl cfv co vu cv wss wa vp cv cH cfv cM cbl cfv
        cfv vu cv wss vp cn wrex vy cn cB cH wf vg cv c1 caddc co cH cfv vg cv
        c1 caddc co vg cv cH cfv cG co wcel vg cn wral c1st cH ccom cY cM clm
        cfv wbr w3a cY cX wcel wa vy cv crp wcel cY vy cv cM cbl cfv co vu cv
        wss vp cv cH cfv cM cbl cfv cfv vu cv wss vp cn wrex cn cB cH wf vg cv
        c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral
        c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel vy cv crp wcel cY vy cv
        cM cbl cfv co vu cv wss vp cv cH cfv cM cbl cfv cfv vu cv wss vp cn
        wrex wi cY vy cv cM cbl cfv co vu cv wss vp cv cH cfv cM cbl cfv cfv cY
        vy cv cM cbl cfv co wss vp cn wrex vp cv cH cfv cM cbl cfv cfv vu cv
        wss vp cn wrex cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co
        vg cv cH cfv cG co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a
        cY cX wcel vy cv crp wcel wa wa cY vy cv cM cbl cfv co vu cv wss vp cv
        cH cfv cM cbl cfv cfv cY vy cv cM cbl cfv co wss vp cv cH cfv cM cbl
        cfv cfv vu cv wss vp cn vp cv cH cfv cM cbl cfv cfv cY vy cv cM cbl cfv
        co wss cY vy cv cM cbl cfv co vu cv wss vp cv cH cfv cM cbl cfv cfv vu
        cv wss vp cv cH cfv cM cbl cfv cfv cY vy cv cM cbl cfv co vu cv sstr2
        com12 r19.22sdv vx vv cB cD vy cv cU vg vh vn cG cH cJ cM cX cY vs vr
        vp va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heibor.15 heiborlem36 syl5com anassrs expimpd
        19.23adv vu cv cJ wcel cY vu cv wcel wa cc0 vy cv clt wbr cY vy cv cM
        cbl cfv co vu cv wss wa vy cr wrex vy cv crp wcel cY vy cv cM cbl cfv
        co vu cv wss wa vy wex cM cme wcel vu cv cJ wcel cY vu cv wcel cc0 vy
        cv clt wbr cY vy cv cM cbl cfv co vu cv wss wa vy cr wrex cM heibor.9
        cmsmeti vy vu cv cM cY cJ heibor.1 opni2 mp3an1 cc0 vy cv clt wbr cY vy
        cv cM cbl cfv co vu cv wss wa vy cr wrex vy cv cr wcel cc0 vy cv clt
        wbr cY vy cv cM cbl cfv co vu cv wss wa wa vy wex vy cv crp wcel cY vy
        cv cM cbl cfv co vu cv wss wa vy wex cc0 vy cv clt wbr cY vy cv cM cbl
        cfv co vu cv wss wa vy cr df-rex vy cv cr wcel cc0 vy cv clt wbr cY vy
        cv cM cbl cfv co vu cv wss wa wa vy cv crp wcel cY vy cv cM cbl cfv co
        vu cv wss wa vy vy cv cr wcel cc0 vy cv clt wbr cY vy cv cM cbl cfv co
        vu cv wss vy cv crp wcel cY vy cv cM cbl cfv co vu cv wss wa vy cv cr
        wcel cc0 vy cv clt wbr wa vy cv crp wcel cY vy cv cM cbl cfv co vu cv
        wss vy cv crp wcel vy cv cr wcel cc0 vy cv clt wbr wa vy cv elrp
        biimpri anim1i anasss 19.22i sylbi syl syl5 expdimp cU cJ vu cv
        heibor.11 sseli sylan2 r19.22dva vp cv cH cfv cM cbl cfv cfv vu cv wss
        vu vp cU cn rexcom syl6ib mpd $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The ball which is contained in an element of
         ` U ` has a finite subcover, namely the single element containing
         it. $)
      heiborlem38 $p |- ( ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) /\ ( 1st o. H ) ( ~~>m ` M ) Y )
            /\ Y e. X ) -> E. p e. NN -. ( ( ball ` M ) ` ( H ` p ) ) e. D ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa vp
        cv cH cfv cM cbl cfv cfv vu cv wss vu cU wrex vp cn wrex vp cv cH cfv
        cM cbl cfv cfv cD wcel wn vp cn wrex vx vv vu cB cD cU vg vh vn cG cH
        cJ cM cX cY vs vr vp va heibor.1 heibor.2 heibor.9 heibor.10 heibor.11
        heibor.12 heibor.13 heibor.14 heibor.15 heiborlem37 vp cv cH cfv cM cbl
        cfv cfv vu cv wss vu cU wrex vp cv cH cfv cM cbl cfv cfv cD wcel wn vp
        cn vp cv cH cfv cM cbl cfv cfv vu cv wss vp cv cH cfv cM cbl cfv cfv cD
        wcel wn vu cU vu cv cU wcel vp cv cH cfv cM cbl cfv cfv vu cv wss wa vp
        cv cH cfv cM cbl cfv cfv vy cv cuni wss vy cU cpw cfn cin wrex vp cv cH
        cfv cM cbl cfv cfv cX wss vp cv cH cfv cM cbl cfv cfv vy cv cuni wss vy
        cU cpw cfn cin wrex wn wa wn vp cv cH cfv cM cbl cfv cfv cD wcel wn vu
        cv csn cU cpw cfn cin wcel vp cv cH cfv cM cbl cfv cfv vu cv csn cuni
        wss vp cv cH cfv cM cbl cfv cfv vy cv cuni wss vy cU cpw cfn cin wrex
        vu cv cU wcel vp cv cH cfv cM cbl cfv cfv vu cv wss vp cv cH cfv cM cbl
        cfv cfv vy cv cuni wss vp cv cH cfv cM cbl cfv cfv vu cv csn cuni wss
        vy vu cv csn cU cpw cfn cin vy cv vu cv csn wceq vy cv cuni vu cv csn
        cuni vp cv cH cfv cM cbl cfv cfv vy cv vu cv csn unieq sseq2d rcla4ev
        vu cv cU wcel vu cv csn cU cpw wcel vu cv csn cfn wcel wa vu cv csn cU
        cpw cfn cin wcel vu cv cU wcel vu cv csn cU cpw wcel vu cv csn cfn wcel
        vu cv cU wcel vu cv csn cU wss vu cv csn cU cpw wcel vu cv cU snssi vu
        cv csn cU vu cv snex elpw sylibr vu cv snfi jctir vu cv csn cU cpw cfn
        elin sylibr vp cv cH cfv cM cbl cfv cfv vu cv csn cuni wss vp cv cH cfv
        cM cbl cfv cfv vu cv wss vu cv csn cuni vu cv vp cv cH cfv cM cbl cfv
        cfv vu cv vu visset unisn sseq2i biimpri syl2an vp cv cH cfv cM cbl cfv
        cfv vy cv cuni wss vy cU cpw cfn cin wrex vp cv cH cfv cM cbl cfv cfv
        vy cv cuni wss vy cU cpw cfn cin wrex wn vp cv cH cfv cM cbl cfv cfv cX
        wss vp cv cH cfv cM cbl cfv cfv vy cv cuni wss vy cU cpw cfn cin wrex
        notnot1 intnand vp cv cH cfv cM cbl cfv cfv cD wcel wn vp cv cH cfv cM
        cbl cfv cfv cX wss vp cv cH cfv cM cbl cfv cfv vy cv cuni wss vy cU cpw
        cfn cin wrex wn wa wn vp cv cH cfv cM cbl cfv cfv cD wcel vp cv cH cfv
        cM cbl cfv cfv cX wss vp cv cH cfv cM cbl cfv cfv vy cv cuni wss vy cU
        cpw cfn cin wrex wn wa vy vv cD vp cv cH cfv cM cbl cfv cfv cU cJ cM cX
        vs heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heiborlem20 notbii biimpri 3syl r19.23aiva r19.22si syl $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . The conclusion of ~ heiborlem38 contradicts the
         construction of ` H ` , whose elements do not have finite
         subcovers. $)
      heiborlem39 $p |- ( ( ( H : NN --> B /\ A. g e. NN ( H ` ( g + 1 ) ) e.
                  ( ( g + 1 ) G ( H ` g ) ) /\ ( 1st o. H ) ( ~~>m ` M ) Y )
                                              /\ Y e. X ) -> -. B = B ) $=
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa vp
        cv cH cfv cB wcel vp cv cH cfv cB wcel wn wa vp cn wrex cB cB wceq wn
        vp cv cH cfv cB wcel vp cn wral vp cv cH cfv cB wcel wn vp cn wrex vp
        cv cH cfv cB wcel vp cv cH cfv cB wcel wn wa vp cn wrex cn cB cH wf vg
        cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn
        wral c1st cH ccom cY cM clm cfv wbr w3a cY cX wcel wa vp cv cH cfv cB
        wcel vp cv cH cfv cB wcel wn vp cn r19.29 cn cB cH wf vg cv c1 caddc co
        cH cfv vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral c1st cH
        ccom cY cM clm cfv wbr w3a vp cv cH cfv cB wcel vp cn wral cY cX wcel
        cn cB cH wf vg cv c1 caddc co cH cfv vg cv c1 caddc co vg cv cH cfv cG
        co wcel vg cn wral vp cv cH cfv cB wcel vp cn wral c1st cH ccom cY cM
        clm cfv wbr cn cB cH wf vp cv cH cfv cB wcel vp cn cn cB vp cv cH
        ffvelrn r19.21aiva 3ad2ant1 adantr cn cB cH wf vg cv c1 caddc co cH cfv
        vg cv c1 caddc co vg cv cH cfv cG co wcel vg cn wral c1st cH ccom cY cM
        clm cfv wbr w3a cY cX wcel wa vp cv cH cfv cM cbl cfv cfv cD wcel wn vp
        cn wrex vp cv cH cfv cB wcel wn vp cn wrex vx vv cB cD cU vg vh vn cG
        cH cJ cM cX cY vs vr vp va heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heibor.14 heibor.15 heiborlem38 vp cv cH
        cfv cM cbl cfv cfv cD wcel wn vp cv cH cfv cB wcel wn vp cn vp cv cH
        cfv cB wcel vp cv cH cfv cM cbl cfv cfv cD wcel vp cv cH cfv cB wcel vp
        cv cH cfv cX crp cxp wcel vp cv cH cfv cM cbl cfv cfv cD wcel vx vv vp
        cv cH cfv cB cD cU cJ cM cX vs vr heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heibor.14 heiborlem24 pm3.27bi con3i
        r19.22si syl sylanc vp cv cH cfv cB wcel vp cv cH cfv cB wcel wn wa cB
        cB wceq wn vp cn vp cv cH cfv cB wcel vp cv cH cfv cB wcel wn wa cB cB
        wceq wn wi vp cv cn wcel vp cv cH cfv cB cB nelneq2 a1i r19.23aiv syl
        $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . If ` B ` were non-empty, then we could apply the
         Axiom of Dependent Choice ~ acdc2 to arrive at a contradiction
         ~ heiborlem39 . $)
      heiborlem40 $p |- B = (/) $=
        cB c0 wceq cB c0 wne cB c0 wceq wn cB c0 wne cn cB vf cv wf vj cv c1
        caddc co vf cv cfv vj cv c1 caddc co vj cv vf cv cfv cG co wcel vj cn
        wral wa vf wex cn cB vf cv wf vj cv c1 caddc co vf cv cfv vj cv c1
        caddc co vj cv vf cv cfv cG co wcel vj cn wral wa vf wex cB cB wceq cB
        eqid cn cB vf cv wf vj cv c1 caddc co vf cv cfv vj cv c1 caddc co vj cv
        vf cv cfv cG co wcel vj cn wral wa cB cB wceq wn vf cn cB vf cv wf vj
        cv c1 caddc co vf cv cfv vj cv c1 caddc co vj cv vf cv cfv cG co wcel
        vj cn wral wa c1st vf cv ccom vy cv cM clm cfv wbr vy cX wrex cB cB
        wceq wn cn cB vf cv wf vj cv c1 caddc co vf cv cfv vj cv c1 caddc co vj
        cv vf cv cfv cG co wcel vj cn wral wa c1st vf cv ccom cM cca cfv wcel
        c1st vf cv ccom vy cv cM clm cfv wbr vy cX wrex vx vv cB cD cU vj vh vn
        cG vf cv cJ cM cX vs vr va heibor.1 heibor.2 heibor.9 heibor.10
        heibor.11 heibor.12 heibor.13 heibor.14 heibor.15 heiborlem33 vg cv vy
        cv cM clm cfv wbr vy cX wrex c1st vf cv ccom vy cv cM clm cfv wbr vy cX
        wrex vg c1st vf cv ccom cM cca cfv vg cv c1st vf cv ccom wceq vg cv vy
        cv cM clm cfv wbr c1st vf cv ccom vy cv cM clm cfv wbr vy cX vg cv c1st
        vf cv ccom vy cv cM clm cfv breq1 rexbidv cM cme wcel vg cv vy cv cM
        clm cfv wbr vy cX wrex vg cM cca cfv wral cM cms wcel cM cme wcel vg cv
        vy cv cM clm cfv wbr vy cX wrex vg cM cca cfv wral wa heibor.9 vy cM vg
        cX heibor.2 iscms mpbi pm3.27i vtoclri syl cn cB vf cv wf vj cv c1
        caddc co vf cv cfv vj cv c1 caddc co vj cv vf cv cfv cG co wcel vj cn
        wral wa c1st vf cv ccom vy cv cM clm cfv wbr cB cB wceq wn vy cX cn cB
        vf cv wf vj cv c1 caddc co vf cv cfv vj cv c1 caddc co vj cv vf cv cfv
        cG co wcel vj cn wral wa c1st vf cv ccom vy cv cM clm cfv wbr vy cv cX
        wcel cB cB wceq wn cn cB vf cv wf vj cv c1 caddc co vf cv cfv vj cv c1
        caddc co vj cv vf cv cfv cG co wcel vj cn wral c1st vf cv ccom vy cv cM
        clm cfv wbr vy cv cX wcel cB cB wceq wn wi cn cB vf cv wf vj cv c1
        caddc co vf cv cfv vj cv c1 caddc co vj cv vf cv cfv cG co wcel vj cn
        wral c1st vf cv ccom vy cv cM clm cfv wbr w3a vy cv cX wcel cB cB wceq
        wn vx vv cB cD cU vj vh vn cG vf cv cJ cM cX vy cv vs vr va heibor.1
        heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14
        heibor.15 heiborlem39 ex 3expia com23 r19.23adv mpd 19.23aiv mt2 cB c0
        wne cn cB cxp cB cpw c0 csn cdif cG wf cn cB vf cv wf vj cv c1 caddc co
        vf cv cfv vj cv c1 caddc co vj cv vf cv cfv cG co wcel vj cn wral wa vf
        wex vx vv cB cD cU vh vn cG cJ cM cX vs vr va heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heibor.15
        heiborlem29 cB vf vj cG cB cX crp cxp cX crp cX cM cdm cdm cvv heibor.2
        cM cdm cM cM cms heibor.9 elisseti dmex dmex eqeltri crp cr reex rpssre
        ssexi xpex vy cB cX crp cxp vy cv cB wcel vy cv cX crp cxp wcel vy cv
        cM cbl cfv cfv cD wcel vx vv vy cv cB cD cU cJ cM cX vs vr heibor.1
        heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14
        heiborlem24 pm3.26bi ssriv ssexi acdc2 mpan2 mto cB c0 df-ne mtbi
        notnotri $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ heibor . Apply the previous result to the entire metric
         space ` M ` , which is equal to a ball since it is totally bounded
         hence bounded by ~ totbndbnd . $)
      heiborlem41 $p |- E. w e. ( ~P U i^i Fin ) X = U. w $=
        cX vw cv cuni wss vw cU cpw cfn cin wrex cX vw cv cuni wceq vw cU cpw
        cfn cin wrex cX vw cv cuni wss vw cU cpw cfn cin wrex cB c0 wceq wn cB
        c0 wceq vx vv cB cD cU vh vn cG cJ cM cX vs vr va heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heibor.14 heibor.15
        heiborlem40 notnoti cX vw cv cuni wss vw cU cpw cfn cin wrex wn cX cD
        wcel cB c0 wceq wn cX cX wss cX vw cv cuni wss vw cU cpw cfn cin wrex
        wn cX cD wcel cX ssid cX cD wcel cX cX wss cX vw cv cuni wss vw cU cpw
        cfn cin wrex wn wa vw vv cD cX cU cJ cM cX vs heibor.1 heibor.2
        heibor.9 heibor.10 heibor.11 heibor.12 heibor.13 heiborlem20 biimpri
        mpan cX cD wcel cX c0 wne cB c0 wceq wn vv cD cX cU cJ cM cX vs
        heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12 heibor.13
        heiborlem21 cX cD wcel cX c0 wne wa cX vy cv vu cv cM cbl cfv co wceq
        vu crp wrex vy cX wral cB c0 wceq wn cM cbnd wcel cX vy cv vu cv cM cbl
        cfv co wceq vu crp wrex vy cX wral cM ctotbnd wcel cM cbnd wcel
        heibor.10 cM cX heibor.2 totbndbnd ax-mp cM cme wcel cM cbnd wcel cX vy
        cv vu cv cM cbl cfv co wceq vu crp wrex vy cX wral wb cM heibor.9
        cmsmeti vy cM cX vu heibor.2 isbnd2 ax-mp mpbi cX cD wcel cX c0 wne cX
        vy cv vu cv cM cbl cfv co wceq vu crp wrex vy cX wral cB c0 wceq wn cX
        cD wcel cX vy cv vu cv cM cbl cfv co wceq vu crp wrex vy cX wrex cB c0
        wceq wn cX c0 wne cX vy cv vu cv cM cbl cfv co wceq vu crp wrex vy cX
        wral wa cX cD wcel cX vy cv vu cv cM cbl cfv co wceq cB c0 wceq wn vy
        vu cX crp cX cD wcel cX vy cv vu cv cM cbl cfv co wceq vy cv cX wcel vu
        cv crp wcel wa cB c0 wceq wn cX cD wcel cX vy cv vu cv cM cbl cfv co
        wceq vy cv vu cv cM cbl cfv co cD wcel vy cv cX wcel vu cv crp wcel wa
        cB c0 wceq wn wi cX vy cv vu cv cM cbl cfv co wceq cX cD wcel vy cv vu
        cv cM cbl cfv co cD wcel cX vy cv vu cv cM cbl cfv co cD eleq1 biimpcd
        vy cv vu cv cM cbl cfv co cD wcel vy cv vu cv cop cX crp cxp wcel cB c0
        wceq wn vy cv cX wcel vu cv crp wcel wa vy cv vu cv cM cbl cfv co cD
        wcel vy cv vu cv cop cM cbl cfv cfv cD wcel vy cv vu cv cop cX crp cxp
        wcel cB c0 wceq wn wi vy cv vu cv cM cbl cfv co vy cv vu cv cop cM cbl
        cfv cfv cD vy cv vu cv cM cbl cfv df-opr eleq1i vy cv vu cv cop cX crp
        cxp wcel vy cv vu cv cop cM cbl cfv cfv cD wcel cB c0 wceq wn vy cv vu
        cv cop cX crp cxp wcel vy cv vu cv cop cM cbl cfv cfv cD wcel wa vy cv
        vu cv cop cB wcel cB c0 wceq wn vx vv vy cv vu cv cop cB cD cU cJ cM cX
        vs vr heibor.1 heibor.2 heibor.9 heibor.10 heibor.11 heibor.12
        heibor.13 heibor.14 heiborlem24 cB vy cv vu cv cop n0i sylbir expcom
        sylbi vy cv vu cv cX crp vu visset opelxp syl5ibr syl6 com23 r19.23advv
        cX vy cv vu cv cM cbl cfv co wceq vu crp wrex vy cX r19.2z syl5 expdimp
        mpi mpdan syl mt3 cX vw cv cuni wss cX vw cv cuni wceq vw cU cpw cfn
        cin vw cv cU cpw cfn cin wcel vw cv cU wss vw cv cuni cX wss cX vw cv
        cuni wss cX vw cv cuni wceq wi vw cv cU cpw cfn cin wcel vw cv cU cpw
        wcel vw cv cU wss vw cv cU cpw cfn cin wcel vw cv cU cpw wcel vw cv cfn
        wcel vw cv cU cpw cfn elin pm3.26bi vw cv cU vw visset elpw sylib vw cv
        cU wss vw cv cuni cU cuni cX vw cv cU uniss heibor.12 syl6ssr cX vw cv
        cuni wss vw cv cuni cX wss cX vw cv cuni wceq cX vw cv cuni wceq cX vw
        cv cuni wss vw cv cuni cX wss wa cX vw cv cuni eqss biimpri expcom 3syl
        r19.22i ax-mp $.
        $( [2-Sep-2009] $)
    $}

    $( Lemma for ~ heibor . Use the deduction theorem. Since every open cover
       has a finite subcover, ` J ` is compact. $)
    heiborlem42 $p |- ( ( M e. CMet /\ M e. TotBnd ) -> J e. Comp ) $=
      cJ ccomp wcel cJ ctop wcel cJ cuni vu cv cuni wceq cJ cuni vw cv cuni
      wceq vw vu cv cpw cfn cin wrex wi vu cJ cpw wral cM cms wcel cM ctotbnd
      wcel wa vu vw cJ iscomp cM cms wcel cJ ctop wcel cM ctotbnd wcel cM cms
      wcel cM cme wcel cJ ctop wcel cM cmsmet cM cJ heibor.1 opntop syl adantr
      cM cms wcel cM ctotbnd wcel wa cJ cuni vu cv cuni wceq cJ cuni vw cv cuni
      wceq vw vu cv cpw cfn cin wrex wi vu cJ cpw cM cms wcel cM ctotbnd wcel
      wa vu cv cJ cpw wcel wa cM cdm cdm vu cv cuni wceq cM cdm cdm vw cv cuni
      wceq vw vu cv cpw cfn cin wrex cJ cuni vu cv cuni wceq cJ cuni vw cv cuni
      wceq vw vu cv cpw cfn cin wrex cM cms wcel cM ctotbnd wcel wa vu cv cJ
      wss cM cdm cdm vu cv cuni wceq cM cdm cdm vw cv cuni wceq vw vu cv cpw
      cfn cin wrex wi vu cv cJ cpw wcel cM cms wcel cM ctotbnd wcel wa vu cv cJ
      wss cM cdm cdm vu cv cuni wceq cM cdm cdm vw cv cuni wceq vw vu cv cpw
      cfn cin wrex cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq cM cdm cdm vw cv cuni wceq vw vu cv cpw cfn cin wrex
      vu cv cJ wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM cdm cdm vw cv cuni wceq vw vu cv cpw cfn cin
      wrex cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif cdm cdm vw cv cuni wceq vw vu cv cpw cfn cin
      wrex cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif cdm cdm vw cv cuni wceq vw cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cpw cfn cin wrex cM vu cv c0 c0 csn cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq cM cdm cdm vw cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vw
      cv cuni wceq vw vu cv cpw cfn cin cM cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq cM cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cdm cdm vw cv cuni cM cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      wceq cM cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif cdm cM cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif dmeq
      dmeqd eqeq1d rexbidv vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif wceq cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif cdm cdm vw cv cuni wceq vw vu cv cpw cfn cin cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      vu cv c0 csn cif cpw cfn cin vu cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif wceq vu
      cv cpw cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa vu cv c0 csn cif cpw cfn vu cv cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif pweq ineq1d rexeq1d vx vw vv vx cv cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm
      wcel vr cv crp wcel wa vx cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cbl cfv co vs
      cv vv cv cuni wss vv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cdm cdm cpw crab wcel wa vx vr copab vs cv vv
      cv cuni wss vv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm cpw crab cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif vh
      vn vn cv cn wcel va cv vx cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm wcel vr cv crp
      wcel wa vx cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cbl cfv co vs cv vv cv cuni
      wss vv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm cpw crab wcel wa vx vr copab wcel wa vh cv vx cv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif cdm cdm wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa vx
      cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cbl cfv co vs cv vv cv cuni wss vv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cpw crab wcel vx cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cbl cfv co va cv
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cbl cfv cfv cin c0 wne wa wa vx vr copab wceq
      wa vn va vh copab2 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif cdm cdm vs vr va cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv eqid cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm eqid cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif ctotbnd wcel cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa wa
      c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv wss c0 cdm cdm c0 csn
      cuni wceq wa wa cM vu cv c0 c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa wa cM cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq cM cms wcel cM ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq cM cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM ctotbnd wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel cM cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      eleq1 cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq vu cv cM copn cfv wss vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni wceq cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif wceq cM copn cfv cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv vu cv cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2 sseq2d cM cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq cM cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq cM cdm cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d vu cv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cuni wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif copn cfv sseq1 vu cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif wceq vu
      cv cuni cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif unieq eqeq2d anbi12d anbi2d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 cms wcel c0 ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn c0 copn
      cfv wss c0 cdm cdm c0 csn cuni wceq wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa c0 cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq c0 cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel c0
      ctotbnd wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel c0 cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms eleq1 c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 csn c0 copn cfv wss c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv wss c0 cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni wceq c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 copn cfv cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif copn cfv c0 csn c0 cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2
      sseq2d c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cdm cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d c0
      csn cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq c0 csn cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv sseq1 c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif wceq c0 csn cuni cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif unieq
      eqeq2d anbi12d anbi2d c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv
      wss c0 cdm cdm c0 csn cuni wceq wa c0 cms wcel c0 ctotbnd wcel vz c0 vg
      c0 c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i 0met cn c0 vg cv
      wf vg cv vz cv c0 clm cfv wbr vz c0 wrex vg cv c0 cca cfv wcel cn c0 vg
      cv wf cn c0 wceq vg cv vz cv c0 clm cfv wbr vz c0 wrex cn c0 vg cv wf vg
      cv c0 wceq cn c0 wceq cn vg cv f00 pm3.27bi cn c0 wceq vg cv vz cv c0 clm
      cfv wbr vz c0 wrex c1 cn wcel cn c0 wceq wn 1nn cn c1 n0i ax-mp pm2.21i
      syl adantl iscms2i c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv
      c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp c0 cme
      wcel c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp wral wb 0met vz vw c0
      c0 vy vd c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i istotbnd2
      ax-mp vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy vw cv wral wa vw cfn wrex vd cv crp wcel c0 cfn wcel c0 cuni c0 wceq
      vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral wa vw cv cuni
      c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa
      vw cfn wrex emfin c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy c0 wral uni0 vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy ral0 pm3.2i vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy vw cv wral wa c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy c0 wral wa vw c0 cfn vw cv c0 wceq vw cv cuni c0 wceq
      c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv
      wral vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral vw cv c0
      wceq vw cv cuni c0 cuni c0 vw cv c0 unieq eqeq1d vy cv vz cv vd cv c0 cbl
      cfv co wceq vz c0 wrex vy vw cv c0 raleq1 anbi12d rcla4ev mp2an a1i
      mprgbir pm3.2i c0 csn c0 copn cfv wss c0 cdm cdm c0 csn cuni wceq c0 c0
      copn cfv wcel c0 csn c0 copn cfv wss c0 cme wcel c0 c0 copn cfv wcel 0met
      c0 c0 copn cfv c0 copn cfv eqid opn0 ax-mp c0 c0 copn cfv snssi ax-mp c0
      cdm c0 c0 cdm cdm c0 csn cuni dm0 c0 cdm c0 dm0 dmeqi c0 0ex unisn
      3eqtr4i pm3.2i pm3.2i elimhyp2v pm3.26i pm3.26i cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn
      cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa wa
      c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv wss c0 cdm cdm c0 csn
      cuni wceq wa wa cM vu cv c0 c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa wa cM cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq cM cms wcel cM ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq cM cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM ctotbnd wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel cM cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      eleq1 cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq vu cv cM copn cfv wss vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni wceq cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif wceq cM copn cfv cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv vu cv cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2 sseq2d cM cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq cM cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq cM cdm cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d vu cv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cuni wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif copn cfv sseq1 vu cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif wceq vu
      cv cuni cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif unieq eqeq2d anbi12d anbi2d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 cms wcel c0 ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn c0 copn
      cfv wss c0 cdm cdm c0 csn cuni wceq wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa c0 cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq c0 cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel c0
      ctotbnd wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel c0 cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms eleq1 c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 csn c0 copn cfv wss c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv wss c0 cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni wceq c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 copn cfv cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif copn cfv c0 csn c0 cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2
      sseq2d c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cdm cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d c0
      csn cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq c0 csn cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv sseq1 c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif wceq c0 csn cuni cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif unieq
      eqeq2d anbi12d anbi2d c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv
      wss c0 cdm cdm c0 csn cuni wceq wa c0 cms wcel c0 ctotbnd wcel vz c0 vg
      c0 c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i 0met cn c0 vg cv
      wf vg cv vz cv c0 clm cfv wbr vz c0 wrex vg cv c0 cca cfv wcel cn c0 vg
      cv wf cn c0 wceq vg cv vz cv c0 clm cfv wbr vz c0 wrex cn c0 vg cv wf vg
      cv c0 wceq cn c0 wceq cn vg cv f00 pm3.27bi cn c0 wceq vg cv vz cv c0 clm
      cfv wbr vz c0 wrex c1 cn wcel cn c0 wceq wn 1nn cn c1 n0i ax-mp pm2.21i
      syl adantl iscms2i c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv
      c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp c0 cme
      wcel c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp wral wb 0met vz vw c0
      c0 vy vd c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i istotbnd2
      ax-mp vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy vw cv wral wa vw cfn wrex vd cv crp wcel c0 cfn wcel c0 cuni c0 wceq
      vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral wa vw cv cuni
      c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa
      vw cfn wrex emfin c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy c0 wral uni0 vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy ral0 pm3.2i vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy vw cv wral wa c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy c0 wral wa vw c0 cfn vw cv c0 wceq vw cv cuni c0 wceq
      c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv
      wral vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral vw cv c0
      wceq vw cv cuni c0 cuni c0 vw cv c0 unieq eqeq1d vy cv vz cv vd cv c0 cbl
      cfv co wceq vz c0 wrex vy vw cv c0 raleq1 anbi12d rcla4ev mp2an a1i
      mprgbir pm3.2i c0 csn c0 copn cfv wss c0 cdm cdm c0 csn cuni wceq c0 c0
      copn cfv wcel c0 csn c0 copn cfv wss c0 cme wcel c0 c0 copn cfv wcel 0met
      c0 c0 copn cfv c0 copn cfv eqid opn0 ax-mp c0 c0 copn cfv snssi ax-mp c0
      cdm c0 c0 cdm cdm c0 csn cuni dm0 c0 cdm c0 dm0 dmeqi c0 0ex unisn
      3eqtr4i pm3.2i pm3.2i elimhyp2v pm3.26i pm3.27i cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa wa
      c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv wss c0 cdm cdm c0 csn
      cuni wceq wa wa cM vu cv c0 c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa wa cM cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq cM cms wcel cM ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq cM cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM ctotbnd wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel cM cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      eleq1 cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq vu cv cM copn cfv wss vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni wceq cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif wceq cM copn cfv cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv vu cv cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2 sseq2d cM cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq cM cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq cM cdm cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d vu cv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cuni wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif copn cfv sseq1 vu cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif wceq vu
      cv cuni cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif unieq eqeq2d anbi12d anbi2d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 cms wcel c0 ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn c0 copn
      cfv wss c0 cdm cdm c0 csn cuni wceq wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa c0 cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq c0 cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel c0
      ctotbnd wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel c0 cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms eleq1 c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 csn c0 copn cfv wss c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv wss c0 cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni wceq c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 copn cfv cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif copn cfv c0 csn c0 cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2
      sseq2d c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cdm cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d c0
      csn cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq c0 csn cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv sseq1 c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif wceq c0 csn cuni cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif unieq
      eqeq2d anbi12d anbi2d c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv
      wss c0 cdm cdm c0 csn cuni wceq wa c0 cms wcel c0 ctotbnd wcel vz c0 vg
      c0 c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i 0met cn c0 vg cv
      wf vg cv vz cv c0 clm cfv wbr vz c0 wrex vg cv c0 cca cfv wcel cn c0 vg
      cv wf cn c0 wceq vg cv vz cv c0 clm cfv wbr vz c0 wrex cn c0 vg cv wf vg
      cv c0 wceq cn c0 wceq cn vg cv f00 pm3.27bi cn c0 wceq vg cv vz cv c0 clm
      cfv wbr vz c0 wrex c1 cn wcel cn c0 wceq wn 1nn cn c1 n0i ax-mp pm2.21i
      syl adantl iscms2i c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv
      c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp c0 cme
      wcel c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp wral wb 0met vz vw c0
      c0 vy vd c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i istotbnd2
      ax-mp vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy vw cv wral wa vw cfn wrex vd cv crp wcel c0 cfn wcel c0 cuni c0 wceq
      vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral wa vw cv cuni
      c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa
      vw cfn wrex emfin c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy c0 wral uni0 vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy ral0 pm3.2i vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy vw cv wral wa c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy c0 wral wa vw c0 cfn vw cv c0 wceq vw cv cuni c0 wceq
      c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv
      wral vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral vw cv c0
      wceq vw cv cuni c0 cuni c0 vw cv c0 unieq eqeq1d vy cv vz cv vd cv c0 cbl
      cfv co wceq vz c0 wrex vy vw cv c0 raleq1 anbi12d rcla4ev mp2an a1i
      mprgbir pm3.2i c0 csn c0 copn cfv wss c0 cdm cdm c0 csn cuni wceq c0 c0
      copn cfv wcel c0 csn c0 copn cfv wss c0 cme wcel c0 c0 copn cfv wcel 0met
      c0 c0 copn cfv c0 copn cfv eqid opn0 ax-mp c0 c0 copn cfv snssi ax-mp c0
      cdm c0 c0 cdm cdm c0 csn cuni dm0 c0 cdm c0 dm0 dmeqi c0 0ex unisn
      3eqtr4i pm3.2i pm3.2i elimhyp2v pm3.27i pm3.26i cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel
      wa cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa wa
      c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv wss c0 cdm cdm c0 csn
      cuni wceq wa wa cM vu cv c0 c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa wa cM cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq cM cms wcel cM ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq cM cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel cM ctotbnd wcel
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif ctotbnd wcel cM cM cms wcel cM ctotbnd wcel wa
      vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      eleq1 cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d cM cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif wceq vu cv cM copn cfv wss vu cv cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv
      wss cM cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni wceq cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif wceq cM copn cfv cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv vu cv cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2 sseq2d cM cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq cM cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm vu cv
      cuni cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq cM cdm cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cM cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d vu cv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm vu cv cuni wceq wa cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms
      wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu
      cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa vu cv cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm vu cv cuni wceq cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif cuni wceq vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif copn cfv sseq1 vu cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif wceq vu
      cv cuni cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm vu cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa vu cv c0 csn cif unieq eqeq2d anbi12d anbi2d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 cms wcel c0 ctotbnd wcel wa cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn c0 copn
      cfv wss c0 cdm cdm c0 csn cuni wceq wa c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa c0 cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif wceq c0 cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cms wcel c0
      ctotbnd wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel c0 cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cms eleq1 c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd eleq1 anbi12d c0 cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif wceq c0 csn c0 copn cfv wss c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif copn cfv wss c0 cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni wceq c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn
      cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 copn cfv cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif copn cfv c0 csn c0 cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn fveq2
      sseq2d c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cdm cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif
      cdm cdm c0 csn cuni c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif wceq c0 cdm cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm c0 cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm
      cdm vu cv cuni wceq wa wa cM c0 cif dmeq dmeqd eqeq1d anbi12d anbi12d c0
      csn cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn
      cfv wss cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni wceq wa cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      cM c0 cif cms wcel cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss
      cM cdm cdm vu cv cuni wceq wa wa cM c0 cif ctotbnd wcel wa c0 csn cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif wceq c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif copn cfv wss cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cuni wceq cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cuni wceq c0 csn cM cms wcel cM ctotbnd
      wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0
      csn cif cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif copn cfv sseq1 c0 csn cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu
      cv c0 csn cif wceq c0 csn cuni cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cuni cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm c0 csn cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif unieq
      eqeq2d anbi12d anbi2d c0 cms wcel c0 ctotbnd wcel wa c0 csn c0 copn cfv
      wss c0 cdm cdm c0 csn cuni wceq wa c0 cms wcel c0 ctotbnd wcel vz c0 vg
      c0 c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i 0met cn c0 vg cv
      wf vg cv vz cv c0 clm cfv wbr vz c0 wrex vg cv c0 cca cfv wcel cn c0 vg
      cv wf cn c0 wceq vg cv vz cv c0 clm cfv wbr vz c0 wrex cn c0 vg cv wf vg
      cv c0 wceq cn c0 wceq cn vg cv f00 pm3.27bi cn c0 wceq vg cv vz cv c0 clm
      cfv wbr vz c0 wrex c1 cn wcel cn c0 wceq wn 1nn cn c1 n0i ax-mp pm2.21i
      syl adantl iscms2i c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv
      c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp c0 cme
      wcel c0 ctotbnd wcel vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy vw cv wral wa vw cfn wrex vd crp wral wb 0met vz vw c0
      c0 vy vd c0 cdm cdm c0 cdm c0 c0 cdm c0 dm0 dmeqi dm0 eqtr2i istotbnd2
      ax-mp vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy vw cv wral wa vw cfn wrex vd cv crp wcel c0 cfn wcel c0 cuni c0 wceq
      vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral wa vw cv cuni
      c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv wral wa
      vw cfn wrex emfin c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy c0 wral uni0 vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex
      vy ral0 pm3.2i vw cv cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz
      c0 wrex vy vw cv wral wa c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co
      wceq vz c0 wrex vy c0 wral wa vw c0 cfn vw cv c0 wceq vw cv cuni c0 wceq
      c0 cuni c0 wceq vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy vw cv
      wral vy cv vz cv vd cv c0 cbl cfv co wceq vz c0 wrex vy c0 wral vw cv c0
      wceq vw cv cuni c0 cuni c0 vw cv c0 unieq eqeq1d vy cv vz cv vd cv c0 cbl
      cfv co wceq vz c0 wrex vy vw cv c0 raleq1 anbi12d rcla4ev mp2an a1i
      mprgbir pm3.2i c0 csn c0 copn cfv wss c0 cdm cdm c0 csn cuni wceq c0 c0
      copn cfv wcel c0 csn c0 copn cfv wss c0 cme wcel c0 c0 copn cfv wcel 0met
      c0 c0 copn cfv c0 copn cfv eqid opn0 ax-mp c0 c0 copn cfv snssi ax-mp c0
      cdm c0 c0 cdm cdm c0 csn cuni dm0 c0 cdm c0 dm0 dmeqi c0 0ex unisn
      3eqtr4i pm3.2i pm3.2i elimhyp2v pm3.27i pm3.27i vs cv vv cv cuni wss vv
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm cpw crab eqid vx cv cM cms wcel cM ctotbnd wcel wa vu cv
      cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm wcel
      vr cv crp wcel wa vx cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv cM
      copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cbl cfv co vs cv
      vv cv cuni wss vv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs cM
      cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni
      wceq wa wa cM c0 cif cdm cdm cpw crab wcel wa vx vr copab eqid vn cv cn
      wcel va cv vx cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM
      cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm wcel vr cv crp wcel wa vx
      cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm
      vu cv cuni wceq wa wa cM c0 cif cbl cfv co vs cv vv cv cuni wss vv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa vu cv c0 csn cif cpw cfn cin wrex wn vs cM cms wcel cM ctotbnd wcel
      wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm
      cdm cpw crab wcel wa vx vr copab wcel wa vh cv vx cv cM cms wcel cM
      ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM
      c0 cif cdm cdm wcel vr cv c1 c2 vn cv cexp co cdiv co wceq wa vx cv vr cv
      cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv
      cuni wceq wa wa cM c0 cif cbl cfv co vs cv vv cv cuni wss vv cM cms wcel
      cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa
      vu cv c0 csn cif cpw cfn cin wrex wn vs cM cms wcel cM ctotbnd wcel wa vu
      cv cM copn cfv wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cdm cdm cpw
      crab wcel vx cv vr cv cM cms wcel cM ctotbnd wcel wa vu cv cM copn cfv
      wss cM cdm cdm vu cv cuni wceq wa wa cM c0 cif cbl cfv co va cv cM cms
      wcel cM ctotbnd wcel wa vu cv cM copn cfv wss cM cdm cdm vu cv cuni wceq
      wa wa cM c0 cif cbl cfv cfv cin c0 wne wa wa vx vr copab wceq wa vn va vh
      copab2 eqid heiborlem41 dedth2v vu cv cJ wss vu cv cM copn cfv wss cJ cM
      copn cfv vu cv heibor.1 sseq2i biimpi sylanr1 expr vu cv cJ elpwi sylan2
      cM cms wcel cJ cuni vu cv cuni wceq cM cdm cdm vu cv cuni wceq wb cM
      ctotbnd wcel vu cv cJ cpw wcel cM cms wcel cJ cuni cM cdm cdm vu cv cuni
      cM cms wcel cM cme wcel cJ cuni cM cdm cdm wceq cM cmsmet cM cJ cM cdm
      cdm cM cdm cdm eqid heibor.1 uniopn2 syl eqeq1d ad2antrr cM cms wcel cJ
      cuni vw cv cuni wceq vw vu cv cpw cfn cin wrex cM cdm cdm vw cv cuni wceq
      vw vu cv cpw cfn cin wrex wb cM ctotbnd wcel vu cv cJ cpw wcel cM cms
      wcel cJ cuni vw cv cuni wceq cM cdm cdm vw cv cuni wceq vw vu cv cpw cfn
      cin cM cms wcel cJ cuni cM cdm cdm vw cv cuni cM cms wcel cM cme wcel cJ
      cuni cM cdm cdm wceq cM cmsmet cM cJ cM cdm cdm cM cdm cdm eqid heibor.1
      uniopn2 syl eqeq1d rexbidv ad2antrr 3imtr4d r19.21aiva sylanbrc $.
      $( [2-Sep-2009] $)

    $( Generalized Heine-Borel Theorem. A metric space is compact iff it is
       complete and totally bounded. $)
    heibor $p |- ( M e. Met -> ( J e. Comp <->
                                        ( M e. CMet /\ M e. TotBnd ) ) ) $=
      cM cme wcel cJ ccomp wcel cM cms wcel cM ctotbnd wcel wa cM cme wcel cJ
      ccomp wcel cM cms wcel cM ctotbnd wcel wa cM cme wcel cJ ccomp wcel wa cM
      cms wcel cM ctotbnd wcel cJ cM cX heibor.1 heibor.2 heiborlem19 cJ cM cX
      heibor.1 heibor.2 heiborlem1 jca ex cJ cM cX heibor.1 heibor.2
      heiborlem42 impbid1 $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Banach Fixed Point Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F a b c k w x y z $. $d X a b c k w x y z $. $d Z x y z $.
    $d N a b c u v x y z $. $d Y a b c x y z $. $d W x y z $. $d f j k w x z $.
    $d G k u v x y z $. $d M k u v w x y z $. $d K u v k w x y z $.
    $d D k u v $.

    bfp.1 $e |- X = dom dom M $.

    ${
      bfplem.2 $e |- M e. CMet $.
      bfplem.3 $e |- F : X --> X $.
      bfplem.4 $e |- Y e. X $.
      bfplem.5 $e |- G = ( { <. <. a , b >. , c >. | ( ( a e. X /\ b e. X )
                                /\ c = ( F ` a ) ) } seq1 ( NN X. { Y } ) ) $.

      $( Lemma for ~ bfp . We construct a sequence ` G ` by repeatedly applying
         ` F ` to a starting value ` Y ` . $)
      bfplem1 $p |- G : NN --> X $=
        cn cX cG wf cn cX va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv
        wceq wa va vb vc copab2 cn cY csn cxp cseq1 co wf cn cX cn cY csn cxp
        wf cX cX cxp cX va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq
        wa va vb vc copab2 wf cn cX va cv cX wcel vb cv cX wcel wa vc cv va cv
        cF cfv wceq wa va vb vc copab2 cn cY csn cxp cseq1 co wf cn cY csn cn
        cY csn cxp wf cY csn cX wss cn cX cn cY csn cxp wf cn cY cY cX bfplem.4
        elisseti fconst cY cX wcel cY csn cX wss bfplem.4 cY cX snssi ax-mp cn
        cY csn cX cn cY csn cxp fss mp2an va vb vc cX cX va cv cF cfv cX va cv
        cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc copab2 va
        cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc copab2
        eqid va cv cX wcel va cv cF cfv cX wcel vb cv cX wcel cX cX va cv cF
        bfplem.3 ffvelrni adantr foprab cX va cv cX wcel vb cv cX wcel wa vc cv
        va cv cF cfv wceq wa va vb vc copab2 cn cY csn cxp va vb vc cX cX va cv
        cF cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb
        vc copab2 cX cM cdm cdm cvv bfp.1 cM cdm cM cM cms bfplem.2 elisseti
        dmex dmex eqeltri cX cM cdm cdm cvv bfp.1 cM cdm cM cM cms bfplem.2
        elisseti dmex dmex eqeltri va cv cX wcel vb cv cX wcel wa vc cv va cv
        cF cfv wceq wa va vb vc copab2 eqid oprabex2 cn cY csn nnex cY snex
        xpex seq1f mp2an cG va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv
        wceq wa va vb vc copab2 cn cY csn cxp cseq1 co wceq cn cX cG wf cn cX
        va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc
        copab2 cn cY csn cxp cseq1 co wf wb bfplem.5 cn cX cG va cv cX wcel vb
        cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc copab2 cn cY csn cxp
        cseq1 co feq1 ax-mp mpbir $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . The first element in the sequence is ` Y ` . $)
      bfplem2 $p |- ( G ` 1 ) = Y $=
        c1 cG cfv c1 va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa
        va vb vc copab2 cn cY csn cxp cseq1 co cfv c1 cn cY csn cxp cfv cY c1
        cG va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc
        copab2 cn cY csn cxp cseq1 co bfplem.5 fveq1i va cv cX wcel vb cv cX
        wcel wa vc cv va cv cF cfv wceq wa va vb vc copab2 cn cY csn cxp va vb
        vc cX cX va cv cF cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv
        wceq wa va vb vc copab2 cX cM cdm cdm cvv bfp.1 cM cdm cM cM cms
        bfplem.2 elisseti dmex dmex eqeltri cX cM cdm cdm cvv bfp.1 cM cdm cM
        cM cms bfplem.2 elisseti dmex dmex eqeltri va cv cX wcel vb cv cX wcel
        wa vc cv va cv cF cfv wceq wa va vb vc copab2 eqid oprabex2 cn cY csn
        nnex cY snex xpex seq11 c1 cn wcel c1 cn cY csn cxp cfv cY wceq 1nn cn
        cY c1 cY cX bfplem.4 elisseti fvconst2 ax-mp 3eqtri $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . The next element in the sequence is obtained by
         applying ` F ` to the previous element. $)
      bfplem3 $p |- ( N e. NN -> ( G ` ( N + 1 ) ) = ( F ` ( G ` N ) ) ) $=
        cN cn wcel cN c1 caddc co cG cfv cN cG cfv cN c1 caddc co cn cY csn cxp
        cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc
        copab2 co cN cG cfv cF cfv cN cn wcel cN c1 caddc co va cv cX wcel vb
        cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc copab2 cn cY csn cxp
        cseq1 co cfv cN va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq
        wa va vb vc copab2 cn cY csn cxp cseq1 co cfv cN c1 caddc co cn cY csn
        cxp cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb
        vc copab2 co cN c1 caddc co cG cfv cN cG cfv cN c1 caddc co cn cY csn
        cxp cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb
        vc copab2 co cN va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq
        wa va vb vc copab2 cn cY csn cxp va vb vc cX cX va cv cF cfv va cv cX
        wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb vc copab2 cX cM
        cdm cdm cvv bfp.1 cM cdm cM cM cms bfplem.2 elisseti dmex dmex eqeltri
        cX cM cdm cdm cvv bfp.1 cM cdm cM cM cms bfplem.2 elisseti dmex dmex
        eqeltri va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb
        vc copab2 eqid oprabex2 cn cY csn nnex cY snex xpex seq1p1 cN c1 caddc
        co cG cfv cN c1 caddc co va cv cX wcel vb cv cX wcel wa vc cv va cv cF
        cfv wceq wa va vb vc copab2 cn cY csn cxp cseq1 co cfv wceq cN cn wcel
        cN c1 caddc co cG va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv
        wceq wa va vb vc copab2 cn cY csn cxp cseq1 co bfplem.5 fveq1i a1i cN
        cn wcel cN cG cfv cN va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv
        wceq wa va vb vc copab2 cn cY csn cxp cseq1 co cfv cN c1 caddc co cn cY
        csn cxp cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa
        va vb vc copab2 cN cG cfv cN va cv cX wcel vb cv cX wcel wa vc cv va cv
        cF cfv wceq wa va vb vc copab2 cn cY csn cxp cseq1 co cfv wceq cN cn
        wcel cN cG va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va
        vb vc copab2 cn cY csn cxp cseq1 co bfplem.5 fveq1i a1i opreq1d 3eqtr4d
        cN cG cfv cX wcel cN c1 caddc co cn cY csn cxp cfv cX wcel cN cG cfv cN
        c1 caddc co cn cY csn cxp cfv va cv cX wcel vb cv cX wcel wa vc cv va
        cv cF cfv wceq wa va vb vc copab2 co cN cG cfv cF cfv wceq cN cn wcel
        vx vy vz cN cG cfv cN c1 caddc co cn cY csn cxp cfv cX cX vx cv cF cfv
        cN cG cfv cF cfv va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq
        wa va vb vc copab2 cN cG cfv cF cfv cN cG cfv cF fvex vx cv cN cG cfv
        cF fveq2 vy cv cN c1 caddc co cn cY csn cxp cfv wceq cN cG cfv cF cfv
        eqidd va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq wa va vb
        vc copab2 vx cv cX wcel vy cv cX wcel wa vc cv vx cv cF cfv wceq wa vx
        vy vc copab2 vx cv cX wcel vy cv cX wcel wa vz cv vx cv cF cfv wceq wa
        vx vy vz copab2 va cv cX wcel vb cv cX wcel wa vc cv va cv cF cfv wceq
        wa vx cv cX wcel vy cv cX wcel wa vc cv vx cv cF cfv wceq wa va vb vc
        vx vy va cv vx cv wceq vb cv vy cv wceq wa va cv cX wcel vb cv cX wcel
        wa vx cv cX wcel vy cv cX wcel wa vc cv va cv cF cfv wceq vc cv vx cv
        cF cfv wceq va cv vx cv wceq va cv cX wcel vx cv cX wcel vb cv vy cv
        wceq vb cv cX wcel vy cv cX wcel va cv vx cv cX eleq1 vb cv vy cv cX
        eleq1 bi2anan9 vb cv vy cv wceq va cv vx cv wceq vc cv vc cv va cv cF
        cfv vx cv cF cfv vb cv vy cv wceq vc cv eqidd va cv vx cv cF fveq2
        eqeqan12rd anbi12d cbvoprab12v vx cv cX wcel vy cv cX wcel wa vc cv vx
        cv cF cfv wceq wa vx cv cX wcel vy cv cX wcel wa vz cv vx cv cF cfv
        wceq wa vx vy vc vz vc cv vz cv wceq vc cv vx cv cF cfv wceq vz cv vx
        cv cF cfv wceq vx cv cX wcel vy cv cX wcel wa vc cv vz cv vx cv cF cfv
        eqeq1 anbi2d cbvoprab3v eqtri oprabval2 cn cX cN cG cF cG cM cX cY va
        vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni cN cn
        wcel cN c1 caddc co cn cY csn cxp cfv cY cX cN cn wcel cN c1 caddc co
        cn wcel cN c1 caddc co cn cY csn cxp cfv cY wceq cN peano2nn cn cY cN
        c1 caddc co cY cX bfplem.4 elisseti fvconst2 syl bfplem.4 syl6eqel
        sylanc eqtrd $.
        $( [2-Sep-2009] $)

      bfplem.6 $e |- D = ( Y M ( F ` Y ) ) $.

      $( Lemma for ~ bfp . Define the initial distance ` D ` . $)
      bfplem4 $p |- ( D e. RR /\ 0 <_ D ) $=
        cD cr wcel cc0 cD cle wbr cD cY cY cF cfv cM co cr bfplem.6 cM cme wcel
        cY cX wcel cY cF cfv cX wcel cY cY cF cfv cM co cr wcel cM bfplem.2
        cmsmeti bfplem.4 cX cX cF wf cY cX wcel cY cF cfv cX wcel bfplem.3
        bfplem.4 cX cX cY cF ffvelrn mp2an cY cY cF cfv cM cX bfp.1 metcl mp3an
        eqeltri cc0 cY cY cF cfv cM co cD cle cM cme wcel cY cX wcel cY cF cfv
        cX wcel cc0 cY cY cF cfv cM co cle wbr cM bfplem.2 cmsmeti bfplem.4 cX
        cX cF wf cY cX wcel cY cF cfv cX wcel bfplem.3 bfplem.4 cX cX cY cF
        ffvelrn mp2an cY cY cF cfv cM cX bfp.1 metge0 mp3an bfplem.6 breqtrri
        pm3.2i $.
        $( [2-Sep-2009] $)

      bfplem.7 $e |- K e. RR+ $.
      bfplem.8 $e |- K < 1 $.
      bfplem.9 $e |- A. x e. X A. y e. X
                            ( ( F ` x ) M ( F ` y ) ) <_ ( K x. ( x M y ) ) $.

      $( Lemma for ~ bfp . Recursively bound the distance between consecutive
         elements of the sequence ` G ` based on the contraction property. $)
      bfplem5 $p |- ( N e. NN
             -> ( ( G ` ( N + 1 ) ) M ( G ` ( ( N + 1 ) + 1 ) )
                          ) <_ ( K x. ( ( G ` N ) M ( G ` ( N + 1 ) ) ) ) ) $=
        cN cn wcel cN c1 caddc co cG cfv cN c1 caddc co c1 caddc co cG cfv cM
        co cN cG cfv cF cfv cN c1 caddc co cG cfv cF cfv cM co cK cN cG cfv cN
        c1 caddc co cG cfv cM co cmul co cle cN cn wcel cN c1 caddc co cG cfv
        cN cG cfv cF cfv cN c1 caddc co c1 caddc co cG cfv cN c1 caddc co cG
        cfv cF cfv cM cF cG cM cN cX cY va vb vc bfp.1 bfplem.2 bfplem.3
        bfplem.4 bfplem.5 bfplem3 cN cn wcel cN c1 caddc co cn wcel cN c1 caddc
        co c1 caddc co cG cfv cN c1 caddc co cG cfv cF cfv wceq cN peano2nn cF
        cG cM cN c1 caddc co cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem3 syl opreq12d cN cG cfv cX wcel cN c1 caddc co cG cfv
        cX wcel cN cG cfv cF cfv cN c1 caddc co cG cfv cF cfv cM co cK cN cG
        cfv cN c1 caddc co cG cfv cM co cmul co cle wbr cN cn wcel cN cG cfv cX
        wcel cN c1 caddc co cG cfv cX wcel wa vx cv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral cN cG cfv cF
        cfv cN c1 caddc co cG cfv cF cfv cM co cK cN cG cfv cN c1 caddc co cG
        cfv cM co cmul co cle wbr bfplem.9 vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr cN cG cfv cF cfv cN c1 caddc co cG
        cfv cF cfv cM co cK cN cG cfv cN c1 caddc co cG cfv cM co cmul co cle
        wbr cN cG cfv cF cfv vy cv cF cfv cM co cK cN cG cfv vy cv cM co cmul
        co cle wbr vx vy cN cG cfv cN c1 caddc co cG cfv cX cX vx cv cN cG cfv
        wceq vx cv cF cfv vy cv cF cfv cM co cN cG cfv cF cfv vy cv cF cfv cM
        co cK vx cv vy cv cM co cmul co cK cN cG cfv vy cv cM co cmul co cle vx
        cv cN cG cfv wceq vx cv cF cfv cN cG cfv cF cfv vy cv cF cfv cM vx cv
        cN cG cfv cF fveq2 opreq1d vx cv cN cG cfv wceq vx cv vy cv cM co cN cG
        cfv vy cv cM co cK cmul vx cv cN cG cfv vy cv cM opreq1 opreq2d breq12d
        vy cv cN c1 caddc co cG cfv wceq cN cG cfv cF cfv vy cv cF cfv cM co cN
        cG cfv cF cfv cN c1 caddc co cG cfv cF cfv cM co cK cN cG cfv vy cv cM
        co cmul co cK cN cG cfv cN c1 caddc co cG cfv cM co cmul co cle vy cv
        cN c1 caddc co cG cfv wceq vy cv cF cfv cN c1 caddc co cG cfv cF cfv cN
        cG cfv cF cfv cM vy cv cN c1 caddc co cG cfv cF fveq2 opreq2d vy cv cN
        c1 caddc co cG cfv wceq cN cG cfv vy cv cM co cN cG cfv cN c1 caddc co
        cG cfv cM co cK cmul vy cv cN c1 caddc co cG cfv cN cG cfv cM opreq2
        opreq2d breq12d rcla42v mpi cn cX cN cG cF cG cM cX cY va vb vc bfp.1
        bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni cN cn wcel cN c1
        caddc co cn wcel cN c1 caddc co cG cfv cX wcel cN peano2nn cn cX cN c1
        caddc co cG cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem1 ffvelrni syl sylanc eqbrtrd $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . Bound the distance between consecutive elements of
         the sequence ` G ` by applying ~ bfplem5 inductively. $)
      bfplem6 $p |- ( N e. NN -> ( ( G ` N ) M ( G ` ( N + 1 ) ) )
                                      <_ ( D x. ( K ^ ( N - 1 ) ) ) ) $=
        vu cv cG cfv vu cv c1 caddc co cG cfv cM co cD cK vu cv c1 cmin co cexp
        co cmul co cle wbr c1 cG cfv c1 c1 caddc co cG cfv cM co cD cK c1 c1
        cmin co cexp co cmul co cle wbr vv cv cG cfv vv cv c1 caddc co cG cfv
        cM co cD cK vv cv c1 cmin co cexp co cmul co cle wbr vv cv c1 caddc co
        cG cfv vv cv c1 caddc co c1 caddc co cG cfv cM co cD cK vv cv c1 caddc
        co c1 cmin co cexp co cmul co cle wbr cN cG cfv cN c1 caddc co cG cfv
        cM co cD cK cN c1 cmin co cexp co cmul co cle wbr vu vv cN vu cv c1
        wceq vu cv cG cfv vu cv c1 caddc co cG cfv cM co c1 cG cfv c1 c1 caddc
        co cG cfv cM co cD cK vu cv c1 cmin co cexp co cmul co cD cK c1 c1 cmin
        co cexp co cmul co cle vu cv c1 wceq vu cv cG cfv c1 cG cfv vu cv c1
        caddc co cG cfv c1 c1 caddc co cG cfv cM vu cv c1 cG fveq2 vu cv c1
        wceq vu cv c1 caddc co c1 c1 caddc co cG vu cv c1 c1 caddc opreq1
        fveq2d opreq12d vu cv c1 wceq cK vu cv c1 cmin co cexp co cK c1 c1 cmin
        co cexp co cD cmul vu cv c1 wceq vu cv c1 cmin co c1 c1 cmin co cK cexp
        vu cv c1 c1 cmin opreq1 opreq2d opreq2d breq12d vu cv vv cv wceq vu cv
        cG cfv vu cv c1 caddc co cG cfv cM co vv cv cG cfv vv cv c1 caddc co cG
        cfv cM co cD cK vu cv c1 cmin co cexp co cmul co cD cK vv cv c1 cmin co
        cexp co cmul co cle vu cv vv cv wceq vu cv cG cfv vv cv cG cfv vu cv c1
        caddc co cG cfv vv cv c1 caddc co cG cfv cM vu cv vv cv cG fveq2 vu cv
        vv cv wceq vu cv c1 caddc co vv cv c1 caddc co cG vu cv vv cv c1 caddc
        opreq1 fveq2d opreq12d vu cv vv cv wceq cK vu cv c1 cmin co cexp co cK
        vv cv c1 cmin co cexp co cD cmul vu cv vv cv wceq vu cv c1 cmin co vv
        cv c1 cmin co cK cexp vu cv vv cv c1 cmin opreq1 opreq2d opreq2d
        breq12d vu cv vv cv c1 caddc co wceq vu cv cG cfv vu cv c1 caddc co cG
        cfv cM co vv cv c1 caddc co cG cfv vv cv c1 caddc co c1 caddc co cG cfv
        cM co cD cK vu cv c1 cmin co cexp co cmul co cD cK vv cv c1 caddc co c1
        cmin co cexp co cmul co cle vu cv vv cv c1 caddc co wceq vu cv cG cfv
        vv cv c1 caddc co cG cfv vu cv c1 caddc co cG cfv vv cv c1 caddc co c1
        caddc co cG cfv cM vu cv vv cv c1 caddc co cG fveq2 vu cv vv cv c1
        caddc co wceq vu cv c1 caddc co vv cv c1 caddc co c1 caddc co cG vu cv
        vv cv c1 caddc co c1 caddc opreq1 fveq2d opreq12d vu cv vv cv c1 caddc
        co wceq cK vu cv c1 cmin co cexp co cK vv cv c1 caddc co c1 cmin co
        cexp co cD cmul vu cv vv cv c1 caddc co wceq vu cv c1 cmin co vv cv c1
        caddc co c1 cmin co cK cexp vu cv vv cv c1 caddc co c1 cmin opreq1
        opreq2d opreq2d breq12d vu cv cN wceq vu cv cG cfv vu cv c1 caddc co cG
        cfv cM co cN cG cfv cN c1 caddc co cG cfv cM co cD cK vu cv c1 cmin co
        cexp co cmul co cD cK cN c1 cmin co cexp co cmul co cle vu cv cN wceq
        vu cv cG cfv cN cG cfv vu cv c1 caddc co cG cfv cN c1 caddc co cG cfv
        cM vu cv cN cG fveq2 vu cv cN wceq vu cv c1 caddc co cN c1 caddc co cG
        vu cv cN c1 caddc opreq1 fveq2d opreq12d vu cv cN wceq cK vu cv c1 cmin
        co cexp co cK cN c1 cmin co cexp co cD cmul vu cv cN wceq vu cv c1 cmin
        co cN c1 cmin co cK cexp vu cv cN c1 cmin opreq1 opreq2d opreq2d
        breq12d c1 cG cfv c1 c1 caddc co cG cfv cM co cD cD cK c1 c1 cmin co
        cexp co cmul co cle c1 cG cfv c1 c1 caddc co cG cfv cM co cY cY cF cfv
        cM co cD c1 cG cfv cY c1 c1 caddc co cG cfv cY cF cfv cM cF cG cM cX cY
        va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem2 c1 c1 caddc
        co cG cfv c1 cG cfv cF cfv cY cF cfv c1 cn wcel c1 c1 caddc co cG cfv
        c1 cG cfv cF cfv wceq 1nn cF cG cM c1 cX cY va vb vc bfp.1 bfplem.2
        bfplem.3 bfplem.4 bfplem.5 bfplem3 ax-mp c1 cG cfv cY cF cF cG cM cX cY
        va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem2 fveq2i eqtri
        opreq12i bfplem.6 eqtr4i cD cr wcel cD cD cK c1 c1 cmin co cexp co cmul
        co wceq cD cD cK c1 c1 cmin co cexp co cmul co cle wbr cD cr wcel cc0
        cD cle wbr cD cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem.6 bfplem4 pm3.26i cD cK c1 c1 cmin co cexp co cmul co
        cD c1 cmul co cD cK c1 c1 cmin co cexp co c1 cD cmul cK c1 c1 cmin co
        cexp co cK cc0 cexp co c1 c1 c1 cmin co cc0 cK cexp c1 ax1cn subidi
        opreq2i cK cc wcel cK cc0 cexp co c1 wceq cK crp wcel cK cc wcel
        bfplem.7 cK rpcn ax-mp cK exp0 ax-mp eqtri opreq2i cD cD cD cr wcel cc0
        cD cle wbr cD cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem.6 bfplem4 pm3.26i recni mulid1i eqtr2i cD cD cK c1 c1
        cmin co cexp co cmul co eqle mp2an eqbrtri vv cv cn wcel vv cv cG cfv
        vv cv c1 caddc co cG cfv cM co cD cK vv cv c1 cmin co cexp co cmul co
        cle wbr cK vv cv cG cfv vv cv c1 caddc co cG cfv cM co cmul co cD cK vv
        cv c1 caddc co c1 cmin co cexp co cmul co cle wbr vv cv c1 caddc co cG
        cfv vv cv c1 caddc co c1 caddc co cG cfv cM co cD cK vv cv c1 caddc co
        c1 cmin co cexp co cmul co cle wbr vv cv cn wcel vv cv cG cfv vv cv c1
        caddc co cG cfv cM co cD cK vv cv c1 cmin co cexp co cmul co cle wbr cK
        vv cv cG cfv vv cv c1 caddc co cG cfv cM co cmul co cK cD cK vv cv c1
        cmin co cexp co cmul co cmul co cle wbr cK vv cv cG cfv vv cv c1 caddc
        co cG cfv cM co cmul co cD cK vv cv c1 caddc co c1 cmin co cexp co cmul
        co cle wbr vv cv cG cfv vv cv c1 caddc co cG cfv cM co cr wcel cD cK vv
        cv c1 cmin co cexp co cmul co cr wcel cK cr wcel cc0 cK cle wbr wa vv
        cv cG cfv vv cv c1 caddc co cG cfv cM co cD cK vv cv c1 cmin co cexp co
        cmul co cle wbr cK vv cv cG cfv vv cv c1 caddc co cG cfv cM co cmul co
        cK cD cK vv cv c1 cmin co cexp co cmul co cmul co cle wbr wi vv cv cn
        wcel vv cv cG cfv vv cv c1 caddc co cG cfv cM co cD cK vv cv c1 cmin co
        cexp co cmul co cK lemul2aALT cM cme wcel vv cv cG cfv cX wcel vv cv c1
        caddc co cG cfv cX wcel vv cv cG cfv vv cv c1 caddc co cG cfv cM co cr
        wcel vv cv cn wcel vv cv cG cfv vv cv c1 caddc co cG cfv cM cX bfp.1
        metcl cM cme wcel vv cv cn wcel cM bfplem.2 cmsmeti a1i cn cX vv cv cG
        cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5
        bfplem1 ffvelrni vv cv cn wcel vv cv c1 caddc co cn wcel vv cv c1 caddc
        co cG cfv cX wcel vv cv peano2nn cn cX vv cv c1 caddc co cG cF cG cM cX
        cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni
        syl syl3anc cD cr wcel cK vv cv c1 cmin co cexp co cr wcel cD cK vv cv
        c1 cmin co cexp co cmul co cr wcel vv cv cn wcel cD cK vv cv c1 cmin co
        cexp co remulcl cD cr wcel cc0 cD cle wbr cD cF cG cM cX cY va vb vc
        bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem.6 bfplem4 pm3.26i cK
        cr wcel vv cv c1 cmin co cn0 wcel cK vv cv c1 cmin co cexp co cr wcel
        vv cv cn wcel cK vv cv c1 cmin co reexpcl cK crp wcel cK cr wcel
        bfplem.7 cK rpre ax-mp vv cv nnm1nn0 sylancr sylancr cK cr wcel cc0 cK
        cle wbr wa vv cv cn wcel cK crp wcel cK cr wcel cc0 cK cle wbr wa
        bfplem.7 cK crp wcel cK cr wcel cc0 cK cle wbr cK rpre cK rpge0 jca
        ax-mp a1i syl3anc vv cv cn wcel cD cK vv cv c1 caddc co c1 cmin co cexp
        co cmul co cK cD cK vv cv c1 cmin co cexp co cmul co cmul co cK vv cv
        cG cfv vv cv c1 caddc co cG cfv cM co cmul co cle vv cv cn wcel cD cK
        vv cv c1 caddc co c1 cmin co cexp co cmul co cD cK cK vv cv c1 cmin co
        cexp co cmul co cmul co cK cD cK vv cv c1 cmin co cexp co cmul co cmul
        co vv cv cn wcel cK vv cv c1 caddc co c1 cmin co cexp co cK cK vv cv c1
        cmin co cexp co cmul co cD cmul vv cv cn wcel cK vv cv c1 caddc co c1
        cmin co cexp co cK vv cv c1 cmin co c1 caddc co cexp co cK vv cv c1
        cmin co cexp co cK cmul co cK cK vv cv c1 cmin co cexp co cmul co vv cv
        cn wcel vv cv c1 caddc co c1 cmin co vv cv c1 cmin co c1 caddc co cK
        cexp vv cv cc wcel c1 cc wcel c1 cc wcel vv cv c1 caddc co c1 cmin co
        vv cv c1 cmin co c1 caddc co wceq vv cv cn wcel vv cv c1 c1 addsub vv
        cv nncn c1 cc wcel vv cv cn wcel ax1cn a1i c1 cc wcel vv cv cn wcel
        ax1cn a1i syl3anc opreq2d cK cc wcel vv cv c1 cmin co cn0 wcel cK vv cv
        c1 cmin co c1 caddc co cexp co cK vv cv c1 cmin co cexp co cK cmul co
        wceq vv cv cn wcel cK vv cv c1 cmin co expp1 cK crp wcel cK cc wcel
        bfplem.7 cK rpcn ax-mp vv cv nnm1nn0 sylancr cK vv cv c1 cmin co cexp
        co cc wcel cK cc wcel cK vv cv c1 cmin co cexp co cK cmul co cK cK vv
        cv c1 cmin co cexp co cmul co wceq vv cv cn wcel cK vv cv c1 cmin co
        cexp co cK mulcom vv cv cn wcel cK vv cv c1 cmin co cexp co cK cr wcel
        vv cv c1 cmin co cn0 wcel cK vv cv c1 cmin co cexp co cr wcel vv cv cn
        wcel cK vv cv c1 cmin co reexpcl cK crp wcel cK cr wcel bfplem.7 cK
        rpre ax-mp vv cv nnm1nn0 sylancr recnd cK crp wcel cK cc wcel bfplem.7
        cK rpcn ax-mp sylancl 3eqtrd opreq2d cD cc wcel cK cc wcel cK vv cv c1
        cmin co cexp co cc wcel cD cK cK vv cv c1 cmin co cexp co cmul co cmul
        co cK cD cK vv cv c1 cmin co cexp co cmul co cmul co wceq vv cv cn wcel
        cD cK cK vv cv c1 cmin co cexp co mul12 cD cc wcel vv cv cn wcel cD cD
        cr wcel cc0 cD cle wbr cD cF cG cM cX cY va vb vc bfp.1 bfplem.2
        bfplem.3 bfplem.4 bfplem.5 bfplem.6 bfplem4 pm3.26i recni a1i cK cc
        wcel vv cv cn wcel cK crp wcel cK cc wcel bfplem.7 cK rpcn ax-mp a1i vv
        cv cn wcel cK vv cv c1 cmin co cexp co cK cr wcel vv cv c1 cmin co cn0
        wcel cK vv cv c1 cmin co cexp co cr wcel vv cv cn wcel cK vv cv c1 cmin
        co reexpcl cK crp wcel cK cr wcel bfplem.7 cK rpre ax-mp vv cv nnm1nn0
        sylancr recnd syl3anc eqtrd breq2d sylibrd vv cv cn wcel vv cv c1 caddc
        co cG cfv vv cv c1 caddc co c1 caddc co cG cfv cM co cK vv cv cG cfv vv
        cv c1 caddc co cG cfv cM co cmul co cle wbr cK vv cv cG cfv vv cv c1
        caddc co cG cfv cM co cmul co cD cK vv cv c1 caddc co c1 cmin co cexp
        co cmul co cle wbr vv cv c1 caddc co cG cfv vv cv c1 caddc co c1 caddc
        co cG cfv cM co cD cK vv cv c1 caddc co c1 cmin co cexp co cmul co cle
        wbr vx vy cD cF cG cK cM vv cv cX cY va vb vc bfp.1 bfplem.2 bfplem.3
        bfplem.4 bfplem.5 bfplem.6 bfplem.7 bfplem.8 bfplem.9 bfplem5 vv cv c1
        caddc co cG cfv vv cv c1 caddc co c1 caddc co cG cfv cM co cr wcel cK
        vv cv cG cfv vv cv c1 caddc co cG cfv cM co cmul co cr wcel cD cK vv cv
        c1 caddc co c1 cmin co cexp co cmul co cr wcel vv cv c1 caddc co cG cfv
        vv cv c1 caddc co c1 caddc co cG cfv cM co cK vv cv cG cfv vv cv c1
        caddc co cG cfv cM co cmul co cle wbr cK vv cv cG cfv vv cv c1 caddc co
        cG cfv cM co cmul co cD cK vv cv c1 caddc co c1 cmin co cexp co cmul co
        cle wbr wa vv cv c1 caddc co cG cfv vv cv c1 caddc co c1 caddc co cG
        cfv cM co cD cK vv cv c1 caddc co c1 cmin co cexp co cmul co cle wbr wi
        vv cv cn wcel vv cv c1 caddc co cG cfv vv cv c1 caddc co c1 caddc co cG
        cfv cM co cK vv cv cG cfv vv cv c1 caddc co cG cfv cM co cmul co cD cK
        vv cv c1 caddc co c1 cmin co cexp co cmul co letr vv cv cn wcel vv cv
        c1 caddc co cn wcel vv cv c1 caddc co cG cfv vv cv c1 caddc co c1 caddc
        co cG cfv cM co cr wcel vv cv peano2nn cM cme wcel vv cv c1 caddc co cG
        cfv cX wcel vv cv c1 caddc co c1 caddc co cG cfv cX wcel vv cv c1 caddc
        co cG cfv vv cv c1 caddc co c1 caddc co cG cfv cM co cr wcel vv cv c1
        caddc co cn wcel vv cv c1 caddc co cG cfv vv cv c1 caddc co c1 caddc co
        cG cfv cM cX bfp.1 metcl cM cme wcel vv cv c1 caddc co cn wcel cM
        bfplem.2 cmsmeti a1i cn cX vv cv c1 caddc co cG cF cG cM cX cY va vb vc
        bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni vv cv c1
        caddc co cn wcel vv cv c1 caddc co c1 caddc co cn wcel vv cv c1 caddc
        co c1 caddc co cG cfv cX wcel vv cv c1 caddc co peano2nn cn cX vv cv c1
        caddc co c1 caddc co cG cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3
        bfplem.4 bfplem.5 bfplem1 ffvelrni syl syl3anc syl cK cr wcel vv cv cG
        cfv vv cv c1 caddc co cG cfv cM co cr wcel cK vv cv cG cfv vv cv c1
        caddc co cG cfv cM co cmul co cr wcel vv cv cn wcel cK vv cv cG cfv vv
        cv c1 caddc co cG cfv cM co remulcl cK crp wcel cK cr wcel bfplem.7 cK
        rpre ax-mp cM cme wcel vv cv cG cfv cX wcel vv cv c1 caddc co cG cfv cX
        wcel vv cv cG cfv vv cv c1 caddc co cG cfv cM co cr wcel vv cv cn wcel
        vv cv cG cfv vv cv c1 caddc co cG cfv cM cX bfp.1 metcl cM cme wcel vv
        cv cn wcel cM bfplem.2 cmsmeti a1i cn cX vv cv cG cF cG cM cX cY va vb
        vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni vv cv cn
        wcel vv cv c1 caddc co cn wcel vv cv c1 caddc co cG cfv cX wcel vv cv
        peano2nn cn cX vv cv c1 caddc co cG cF cG cM cX cY va vb vc bfp.1
        bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni syl syl3anc
        sylancr cD cr wcel cK vv cv c1 caddc co c1 cmin co cexp co cr wcel cD
        cK vv cv c1 caddc co c1 cmin co cexp co cmul co cr wcel vv cv cn wcel
        cD cK vv cv c1 caddc co c1 cmin co cexp co remulcl cD cr wcel cc0 cD
        cle wbr cD cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem.6 bfplem4 pm3.26i cK cr wcel vv cv c1 caddc co c1 cmin
        co cn0 wcel cK vv cv c1 caddc co c1 cmin co cexp co cr wcel vv cv cn
        wcel cK vv cv c1 caddc co c1 cmin co reexpcl cK crp wcel cK cr wcel
        bfplem.7 cK rpre ax-mp vv cv cn wcel vv cv c1 caddc co cn wcel vv cv c1
        caddc co c1 cmin co cn0 wcel vv cv peano2nn vv cv c1 caddc co nnm1nn0
        syl sylancr sylancr syl3anc mpand syld nnind $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . Use ~ geomcau to show that ` G ` is a Cauchy
         sequence, which then converges as ` M ` is complete. $)
      bfplem7 $p |- E. z e. X G ( ~~>m ` M ) z $=
        cM cms wcel cG cM cca cfv wcel cG vz cv cM clm cfv wbr vz cX wrex
        bfplem.2 cM cme wcel cn cX cG wf wa cD cK cdiv co cr wcel cK crp wcel
        cK c1 clt wbr w3a vk cv cG cfv vk cv c1 caddc co cG cfv cM co cD cK
        cdiv co cK vk cv cexp co cmul co cle wbr vk cn wral cG cM cca cfv wcel
        cM cme wcel cn cX cG wf cM bfplem.2 cmsmeti cF cG cM cX cY va vb vc
        bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 pm3.2i cD cK cdiv co
        cr wcel cK crp wcel cK c1 clt wbr cD cK cD cr wcel cc0 cD cle wbr cD cF
        cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem.6
        bfplem4 pm3.26i cK crp wcel cK cr wcel bfplem.7 cK rpre ax-mp cK crp
        wcel cK cc0 wne bfplem.7 cK rpne0 ax-mp redivcli bfplem.7 bfplem.8
        3pm3.2i vk cv cG cfv vk cv c1 caddc co cG cfv cM co cD cK cdiv co cK vk
        cv cexp co cmul co cle wbr vk cn vk cv cn wcel vk cv cG cfv vk cv c1
        caddc co cG cfv cM co cD cK vk cv c1 cmin co cexp co cmul co cD cK cdiv
        co cK vk cv cexp co cmul co cle vx vy cD cF cG cK cM vk cv cX cY va vb
        vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem.6 bfplem.7 bfplem.8
        bfplem.9 bfplem6 vk cv cn wcel cD cK cdiv co cK vk cv cexp co cmul co
        cK vk cv cexp co cK cdiv co cD cmul co cD cK vk cv cexp co cK cdiv co
        cmul co cD cK vk cv c1 cmin co cexp co cmul co cD cc wcel cK cc wcel cK
        cc0 wne wa cK vk cv cexp co cc wcel cD cK cdiv co cK vk cv cexp co cmul
        co cK vk cv cexp co cK cdiv co cD cmul co wceq vk cv cn wcel cD cK cK
        vk cv cexp co div13 cD cc wcel vk cv cn wcel cD cD cr wcel cc0 cD cle
        wbr cD cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem.6 bfplem4 pm3.26i recni a1i cK cc wcel cK cc0 wne wa vk
        cv cn wcel cK cc wcel cK cc0 wne cK cK crp wcel cK cr wcel bfplem.7 cK
        rpre ax-mp recni cK crp wcel cK cc0 wne bfplem.7 cK rpne0 ax-mp pm3.2i
        a1i cK cc wcel vk cv cn0 wcel cK vk cv cexp co cc wcel vk cv cn wcel cK
        vk cv expcl cK cK crp wcel cK cr wcel bfplem.7 cK rpre ax-mp recni vk
        cv nnnn0 sylancr syl3anc cK vk cv cexp co cK cdiv co cc wcel cD cc wcel
        cK vk cv cexp co cK cdiv co cD cmul co cD cK vk cv cexp co cK cdiv co
        cmul co wceq vk cv cn wcel cK vk cv cexp co cK cdiv co cD mulcom vk cv
        cn wcel cK vk cv cexp co cK cdiv co crp wcel cK vk cv cexp co cK cdiv
        co cc wcel cK vk cv cexp co crp wcel cK crp wcel cK vk cv cexp co cK
        cdiv co crp wcel vk cv cn wcel cK vk cv cexp co cK rpdivcl cK crp wcel
        vk cv cn0 wcel cK vk cv cexp co crp wcel vk cv cn wcel cK vk cv rpexpcl
        bfplem.7 vk cv nnnn0 sylancr bfplem.7 sylancl cK vk cv cexp co cK cdiv
        co rpcn syl cD cD cr wcel cc0 cD cle wbr cD cF cG cM cX cY va vb vc
        bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem.6 bfplem4 pm3.26i
        recni sylancl vk cv cn wcel cK vk cv cexp co cK cdiv co cK vk cv c1
        cmin co cexp co cD cmul vk cv cn wcel cK vk cv cexp co cK cdiv co cK vk
        cv c1 cmin co cexp co wceq cK vk cv cexp co cK vk cv c1 cmin co cexp co
        cK cmul co wceq cK cc wcel vk cv cn wcel cK vk cv cexp co cK vk cv c1
        cmin co cexp co cK cmul co wceq cK cK crp wcel cK cr wcel bfplem.7 cK
        rpre ax-mp recni cK vk cv expm1t mpan cK vk cv cexp co cc wcel cK vk cv
        c1 cmin co cexp co cc wcel cK cc wcel cK cc0 wne wa cK vk cv cexp co cK
        cdiv co cK vk cv c1 cmin co cexp co wceq cK vk cv cexp co cK vk cv c1
        cmin co cexp co cK cmul co wceq wb vk cv cn wcel cK vk cv cexp co cK vk
        cv c1 cmin co cexp co cK divmul3 cK cc wcel vk cv cn0 wcel cK vk cv
        cexp co cc wcel vk cv cn wcel cK vk cv expcl cK cK crp wcel cK cr wcel
        bfplem.7 cK rpre ax-mp recni vk cv nnnn0 sylancr cK cc wcel vk cv c1
        cmin co cn0 wcel cK vk cv c1 cmin co cexp co cc wcel vk cv cn wcel cK
        vk cv c1 cmin co expcl cK cK crp wcel cK cr wcel bfplem.7 cK rpre ax-mp
        recni vk cv nnm1nn0 sylancr cK cc wcel cK cc0 wne wa vk cv cn wcel cK
        cc wcel cK cc0 wne cK cK crp wcel cK cr wcel bfplem.7 cK rpre ax-mp
        recni cK crp wcel cK cc0 wne bfplem.7 cK rpne0 ax-mp pm3.2i a1i syl3anc
        mpbird opreq2d 3eqtrd breqtrrd rgen cD cK cdiv co cK vk cG cM cX bfp.1
        geomcau mp3an vz cM cG cX bfp.1 cmscvg mp2an $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . The limit of ` G ` is a fixed point of ` F ` . $)
      bfplem8 $p |- ( ( Z e. X /\ G ( ~~>m ` M ) Z ) -> ( F ` Z ) = Z ) $=
        cZ cX wcel cG cZ cM clm cfv wbr cZ cF cfv cZ wceq vz cv cX wcel cG vz
        cv cM clm cfv wbr wa vz cv cF cfv vz cv wceq wi cZ cX wcel cG cZ cM clm
        cfv wbr wa cZ cF cfv cZ wceq wi vz cZ cX vz cv cZ wceq vz cv cX wcel cG
        vz cv cM clm cfv wbr wa cZ cX wcel cG cZ cM clm cfv wbr wa vz cv cF cfv
        vz cv wceq cZ cF cfv cZ wceq vz cv cZ wceq vz cv cX wcel cZ cX wcel cG
        vz cv cM clm cfv wbr cG cZ cM clm cfv wbr vz cv cZ cX eleq1 vz cv cZ cG
        cM clm cfv breq2 anbi12d vz cv cZ wceq vz cv cF cfv cZ cF cfv vz cv cZ
        vz cv cZ cF fveq2 vz cv cZ wceq id eqeq12d imbi12d cM cme wcel cG vz cv
        cF cfv cM clm cfv wbr cG vz cv cM clm cfv wbr vz cv cF cfv vz cv wceq
        vz cv cX wcel cG vz cv cM clm cfv wbr wa vz cv cF cfv vz cv cM cG vz cv
        cF fvex vz visset lmuni cM cme wcel vz cv cX wcel cG vz cv cM clm cfv
        wbr wa cM bfplem.2 cmsmeti a1i vz cv cX wcel cG vz cv cM clm cfv wbr wa
        cG vz cv cF cfv cM clm cfv wbr vx cv cn wcel vy cv vx cv cG cfv vz cv
        cF cfv cM co wceq wa vx vy copab cc0 cli wbr vz cv cX wcel cG vz cv cM
        clm cfv wbr wa vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq
        wa vx vy copab c1 cneg cshi co cc0 cli wbr vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab cc0 cli wbr vx cv cn wcel vy
        cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx vy copab cc0 cli wbr
        c1 cz wcel vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul
        co wceq wa vx vy copab cfv cr wcel vk cv vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv cr wcel
        wa cc0 vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq
        wa vx vy copab c1 cneg cshi co cfv cle wbr vk cv vx cv cn wcel vy cv vx
        cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv vk
        cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx
        vy copab cfv cle wbr wa wa vk c1 cuz cfv wral vx cv cn wcel vy cv vx cv
        cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cc0 cli
        wbr vz cv cX wcel cG vz cv cM clm cfv wbr wa cc0 vk vx cv cn wcel vy cv
        cK vx cv cG cfv vz cv cM co cmul co wceq wa vx vy copab vx cv cn wcel
        vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi
        co c1 vx vy cn cK vx cv cG cfv vz cv cM co cmul co nnex opabex2 vx cv
        cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1
        cneg cshi oprex cc0 cc 0cn elisseti climsqueeze2 vz cv cX wcel cG vz cv
        cM clm cfv wbr wa vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul
        co wceq wa vx vy copab cK cc0 cmul co cc0 cli cK cc wcel vx cv cn wcel
        vy cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cc0 cli wbr c1 cz
        wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy
        copab cfv cc wcel vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co
        cmul co wceq wa vx vy copab cfv cK vk cv vx cv cn wcel vy cv vx cv cG
        cfv vz cv cM co wceq wa vx vy copab cfv cmul co wceq wa vk c1 cuz cfv
        wral vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx
        vy copab cK cc0 cmul co cli wbr vz cv cX wcel cG vz cv cM clm cfv wbr
        wa cc0 cK vk vx cv cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy
        copab vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa
        vx vy copab c1 vx vy cn vx cv cG cfv vz cv cM co nnex opabex2 vx vy cn
        cK vx cv cG cfv vz cv cM co cmul co nnex opabex2 cc0 cc 0cn elisseti
        climmulc2 cK cc wcel vz cv cX wcel cG vz cv cM clm cfv wbr wa cK crp
        wcel cK cc wcel bfplem.7 cK rpcn ax-mp a1i vz cv cX wcel cG vz cv cM
        clm cfv wbr vx cv cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy
        copab cc0 cli wbr cM cme wcel cn cX cG wf vz cv cX wcel cG vz cv cM clm
        cfv wbr vx cv cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy
        copab cc0 cli wbr wb cM bfplem.2 cmsmeti cF cG cM cX cY va vb vc bfp.1
        bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 vx vy cG vx cv cn wcel vy
        cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cM cX vz cv bfp.1 vx cv
        cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy copab eqid lmclim2
        mp3an12 biimpa c1 cz wcel vz cv cX wcel cG vz cv cM clm cfv wbr wa 1z
        a1i vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv vx cv cn wcel vy cv
        vx cv cG cfv vz cv cM co wceq wa vx vy copab cfv cc wcel vk cv vx cv cn
        wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx vy copab cfv
        cK vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy
        copab cfv cmul co wceq wa vk c1 cuz cfv vz cv cX wcel cG vz cv cM clm
        cfv wbr wa vk cv cn wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv
        cM co wceq wa vx vy copab cfv cc wcel vk cv vx cv cn wcel vy cv cK vx
        cv cG cfv vz cv cM co cmul co wceq wa vx vy copab cfv cK vk cv vx cv cn
        wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cfv cmul co
        wceq wa vk cv c1 cuz cfv wcel vz cv cX wcel cG vz cv cM clm cfv wbr wa
        vk cv cn wcel wa vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cM co
        wceq wa vx vy copab cfv cc wcel vk cv vx cv cn wcel vy cv cK vx cv cG
        cfv vz cv cM co cmul co wceq wa vx vy copab cfv cK vk cv vx cv cn wcel
        vy cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cfv cmul co wceq vz
        cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn wcel wa vk cv vx cv cn
        wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cfv vk cv cG
        cfv vz cv cM co cc vk cv cn wcel vk cv vx cv cn wcel vy cv vx cv cG cfv
        vz cv cM co wceq wa vx vy copab cfv vk cv cG cfv vz cv cM co wceq vz cv
        cX wcel cG vz cv cM clm cfv wbr wa vx vy vk cv vx cv cG cfv vz cv cM co
        vk cv cG cfv vz cv cM co cn vx cv cn wcel vy cv vx cv cG cfv vz cv cM
        co wceq wa vx vy copab vx cv vk cv wceq vx cv cG cfv vk cv cG cfv vz cv
        cM vx cv vk cv cG fveq2 opreq1d vx cv cn wcel vy cv vx cv cG cfv vz cv
        cM co wceq wa vx vy copab eqid vk cv cG cfv vz cv cM oprex fvopab4
        adantl vz cv cX wcel vk cv cn wcel vk cv cG cfv vz cv cM co cc wcel cG
        vz cv cM clm cfv wbr vk cv cn wcel vz cv cX wcel vk cv cG cfv vz cv cM
        co cc wcel vk cv cn wcel vz cv cX wcel wa vk cv cG cfv vz cv cM co vk
        cv cG cfv cX wcel vz cv cX wcel vk cv cG cfv vz cv cM co cr wcel vk cv
        cn wcel cM cme wcel vk cv cG cfv cX wcel vz cv cX wcel vk cv cG cfv vz
        cv cM co cr wcel cM bfplem.2 cmsmeti vk cv cG cfv vz cv cM cX bfp.1
        metcl mp3an1 cn cX vk cv cG cF cG cM cX cY va vb vc bfp.1 bfplem.2
        bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni sylan recnd ancoms adantlr
        eqeltrd vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn wcel wa vk cv
        vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx vy
        copab cfv cK vk cv cG cfv vz cv cM co cmul co cK vk cv vx cv cn wcel vy
        cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cfv cmul co vk cv cn
        wcel vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq
        wa vx vy copab cfv cK vk cv cG cfv vz cv cM co cmul co wceq vz cv cX
        wcel cG vz cv cM clm cfv wbr wa vx vy vk cv cK vx cv cG cfv vz cv cM co
        cmul co cK vk cv cG cfv vz cv cM co cmul co cn vx cv cn wcel vy cv cK
        vx cv cG cfv vz cv cM co cmul co wceq wa vx vy copab vx cv vk cv wceq
        vx cv cG cfv vz cv cM co vk cv cG cfv vz cv cM co cK cmul vx cv vk cv
        wceq vx cv cG cfv vk cv cG cfv vz cv cM vx cv vk cv cG fveq2 opreq1d
        opreq2d vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa
        vx vy copab eqid cK vk cv cG cfv vz cv cM co cmul oprex fvopab4 adantl
        vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn wcel wa vk cv vx cv
        cn wcel vy cv vx cv cG cfv vz cv cM co wceq wa vx vy copab cfv vk cv cG
        cfv vz cv cM co cK cmul vk cv cn wcel vk cv vx cv cn wcel vy cv vx cv
        cG cfv vz cv cM co wceq wa vx vy copab cfv vk cv cG cfv vz cv cM co
        wceq vz cv cX wcel cG vz cv cM clm cfv wbr wa vx vy vk cv vx cv cG cfv
        vz cv cM co vk cv cG cfv vz cv cM co cn vx cv cn wcel vy cv vx cv cG
        cfv vz cv cM co wceq wa vx vy copab vx cv vk cv wceq vx cv cG cfv vk cv
        cG cfv vz cv cM vx cv vk cv cG fveq2 opreq1d vx cv cn wcel vy cv vx cv
        cG cfv vz cv cM co wceq wa vx vy copab eqid vk cv cG cfv vz cv cM oprex
        fvopab4 adantl opreq2d eqtr4d jca vk cv elnnuz sylan2br r19.21aiva
        syl2anc cK cK crp wcel cK cc wcel bfplem.7 cK rpcn ax-mp mul01i
        syl6breq c1 cz wcel vz cv cX wcel cG vz cv cM clm cfv wbr wa 1z a1i vz
        cv cX wcel cG vz cv cM clm cfv wbr wa vk cv vx cv cn wcel vy cv cK vx
        cv cG cfv vz cv cM co cmul co wceq wa vx vy copab cfv cr wcel vk cv vx
        cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1
        cneg cshi co cfv cr wcel wa cc0 vk cv vx cv cn wcel vy cv vx cv cG cfv
        vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv cle wbr vk
        cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy
        copab c1 cneg cshi co cfv vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz
        cv cM co cmul co wceq wa vx vy copab cfv cle wbr wa wa vk c1 cuz cfv vz
        cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn wcel vk cv vx cv cn wcel
        vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx vy copab cfv cr
        wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa
        vx vy copab c1 cneg cshi co cfv cr wcel wa cc0 vk cv vx cv cn wcel vy
        cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co
        cfv cle wbr vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co
        wceq wa vx vy copab c1 cneg cshi co cfv vk cv vx cv cn wcel vy cv cK vx
        cv cG cfv vz cv cM co cmul co wceq wa vx vy copab cfv cle wbr wa wa vk
        cv c1 cuz cfv wcel vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn
        wcel wa vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co
        wceq wa vx vy copab cfv cr wcel vk cv vx cv cn wcel vy cv vx cv cG cfv
        vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv cr wcel cc0
        vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy
        copab c1 cneg cshi co cfv cle wbr vk cv vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv vk cv vx
        cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa vx vy
        copab cfv cle wbr wa vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn
        wcel wa vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co
        wceq wa vx vy copab cfv cK vk cv cG cfv vz cv cM co cmul co cr vk cv cn
        wcel vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq
        wa vx vy copab cfv cK vk cv cG cfv vz cv cM co cmul co wceq vz cv cX
        wcel cG vz cv cM clm cfv wbr wa vx vy vk cv cK vx cv cG cfv vz cv cM co
        cmul co cK vk cv cG cfv vz cv cM co cmul co cn vx cv cn wcel vy cv cK
        vx cv cG cfv vz cv cM co cmul co wceq wa vx vy copab vx cv vk cv wceq
        vx cv cG cfv vz cv cM co vk cv cG cfv vz cv cM co cK cmul vx cv vk cv
        wceq vx cv cG cfv vk cv cG cfv vz cv cM vx cv vk cv cG fveq2 opreq1d
        opreq2d vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa
        vx vy copab eqid cK vk cv cG cfv vz cv cM co cmul oprex fvopab4 adantl
        cK cr wcel vk cv cG cfv vz cv cM co cr wcel cK vk cv cG cfv vz cv cM co
        cmul co cr wcel vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn wcel
        wa cK vk cv cG cfv vz cv cM co remulcl cK crp wcel cK cr wcel bfplem.7
        cK rpre ax-mp vz cv cX wcel vk cv cn wcel vk cv cG cfv vz cv cM co cr
        wcel cG vz cv cM clm cfv wbr vk cv cn wcel vz cv cX wcel vk cv cG cfv
        vz cv cM co cr wcel vk cv cG cfv cX wcel vz cv cX wcel vk cv cG cfv vz
        cv cM co cr wcel vk cv cn wcel cM cme wcel vk cv cG cfv cX wcel vz cv
        cX wcel vk cv cG cfv vz cv cM co cr wcel cM bfplem.2 cmsmeti vk cv cG
        cfv vz cv cM cX bfp.1 metcl mp3an1 cn cX vk cv cG cF cG cM cX cY va vb
        vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni sylan
        ancoms adantlr sylancr eqeltrd vz cv cX wcel cG vz cv cM clm cfv wbr wa
        vk cv cn wcel wa vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM
        co wceq wa vx vy copab c1 cneg cshi co cfv vk cv c1 caddc co cG cfv vz
        cv cF cfv cM co cr vk cv cn wcel vk cv vx cv cn wcel vy cv vx cv cG cfv
        vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv vk cv c1
        caddc co cG cfv vz cv cF cfv cM co wceq vz cv cX wcel cG vz cv cM clm
        cfv wbr wa vk cv cn wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv
        cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv c1 vk cv caddc co
        vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab
        cfv vk cv c1 caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM
        co wceq wa vx vy copab cfv vk cv c1 caddc co cG cfv vz cv cF cfv cM co
        c1 cc wcel vk cv cc wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv
        cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv c1 vk cv caddc co
        vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab
        cfv wceq vk cv cn wcel c1 vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv
        cF cfv cM co wceq wa vx vy copab vx vy cn vx cv cG cfv vz cv cF cfv cM
        co nnex opabex2 shftval4 ax1cn vk cv nncn sylancr vk cv cn wcel c1 vk
        cv caddc co vk cv c1 caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF
        cfv cM co wceq wa vx vy copab c1 cc wcel vk cv cc wcel c1 vk cv caddc
        co vk cv c1 caddc co wceq vk cv cn wcel c1 vk cv addcom ax1cn vk cv
        nncn sylancr fveq2d vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1
        caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx
        vy copab cfv vk cv c1 caddc co cG cfv vz cv cF cfv cM co wceq vk cv
        peano2nn vx vy vk cv c1 caddc co vx cv cG cfv vz cv cF cfv cM co vk cv
        c1 caddc co cG cfv vz cv cF cfv cM co cn vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab vx cv vk cv c1 caddc co wceq
        vx cv cG cfv vk cv c1 caddc co cG cfv vz cv cF cfv cM vx cv vk cv c1
        caddc co cG fveq2 opreq1d vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv
        cM co wceq wa vx vy copab eqid vk cv c1 caddc co cG cfv vz cv cF cfv cM
        oprex fvopab4 syl 3eqtrd adantl vz cv cX wcel vk cv cn wcel vk cv c1
        caddc co cG cfv vz cv cF cfv cM co cr wcel cG vz cv cM clm cfv wbr vk
        cv cn wcel vz cv cX wcel vk cv c1 caddc co cG cfv vz cv cF cfv cM co cr
        wcel vk cv c1 caddc co cG cfv cX wcel vz cv cF cfv cX wcel vk cv c1
        caddc co cG cfv vz cv cF cfv cM co cr wcel vk cv cn wcel vz cv cX wcel
        cM cme wcel vk cv c1 caddc co cG cfv cX wcel vz cv cF cfv cX wcel vk cv
        c1 caddc co cG cfv vz cv cF cfv cM co cr wcel cM bfplem.2 cmsmeti vk cv
        c1 caddc co cG cfv vz cv cF cfv cM cX bfp.1 metcl mp3an1 vk cv cn wcel
        vk cv c1 caddc co cn wcel vk cv c1 caddc co cG cfv cX wcel vk cv
        peano2nn cn cX vk cv c1 caddc co cG cF cG cM cX cY va vb vc bfp.1
        bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 ffvelrni syl cX cX vz cv cF
        bfplem.3 ffvelrni syl2an ancoms adantlr eqeltrd vz cv cX wcel cG vz cv
        cM clm cfv wbr wa vk cv cn wcel wa cc0 vk cv vx cv cn wcel vy cv vx cv
        cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv cle
        wbr vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa
        vx vy copab c1 cneg cshi co cfv vk cv vx cv cn wcel vy cv cK vx cv cG
        cfv vz cv cM co cmul co wceq wa vx vy copab cfv cle wbr vz cv cX wcel
        cG vz cv cM clm cfv wbr wa vk cv cn wcel wa cc0 vk cv c1 caddc co cG
        cfv vz cv cF cfv cM co vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF
        cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv cle vz cv cX wcel vk
        cv cn wcel cc0 vk cv c1 caddc co cG cfv vz cv cF cfv cM co cle wbr cG
        vz cv cM clm cfv wbr vk cv cn wcel vz cv cX wcel cc0 vk cv c1 caddc co
        cG cfv vz cv cF cfv cM co cle wbr vk cv c1 caddc co cG cfv cX wcel vz
        cv cF cfv cX wcel cc0 vk cv c1 caddc co cG cfv vz cv cF cfv cM co cle
        wbr vk cv cn wcel vz cv cX wcel cM cme wcel vk cv c1 caddc co cG cfv cX
        wcel vz cv cF cfv cX wcel cc0 vk cv c1 caddc co cG cfv vz cv cF cfv cM
        co cle wbr cM bfplem.2 cmsmeti vk cv c1 caddc co cG cfv vz cv cF cfv cM
        cX bfp.1 metge0 mp3an1 vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1
        caddc co cG cfv cX wcel vk cv peano2nn cn cX vk cv c1 caddc co cG cF cG
        cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1
        ffvelrni syl cX cX vz cv cF bfplem.3 ffvelrni syl2an ancoms adantlr vk
        cv cn wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co
        wceq wa vx vy copab c1 cneg cshi co cfv vk cv c1 caddc co cG cfv vz cv
        cF cfv cM co wceq vz cv cX wcel cG vz cv cM clm cfv wbr wa vk cv cn
        wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa
        vx vy copab c1 cneg cshi co cfv c1 vk cv caddc co vx cv cn wcel vy cv
        vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab cfv vk cv c1 caddc
        co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy
        copab cfv vk cv c1 caddc co cG cfv vz cv cF cfv cM co c1 cc wcel vk cv
        cc wcel vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq
        wa vx vy copab c1 cneg cshi co cfv c1 vk cv caddc co vx cv cn wcel vy
        cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab cfv wceq vk cv
        cn wcel c1 vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co
        wceq wa vx vy copab vx vy cn vx cv cG cfv vz cv cF cfv cM co nnex
        opabex2 shftval4 ax1cn vk cv nncn sylancr vk cv cn wcel c1 vk cv caddc
        co vk cv c1 caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM
        co wceq wa vx vy copab c1 cc wcel vk cv cc wcel c1 vk cv caddc co vk cv
        c1 caddc co wceq vk cv cn wcel c1 vk cv addcom ax1cn vk cv nncn sylancr
        fveq2d vk cv cn wcel vk cv c1 caddc co cn wcel vk cv c1 caddc co vx cv
        cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab cfv
        vk cv c1 caddc co cG cfv vz cv cF cfv cM co wceq vk cv peano2nn vx vy
        vk cv c1 caddc co vx cv cG cfv vz cv cF cfv cM co vk cv c1 caddc co cG
        cfv vz cv cF cfv cM co cn vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv
        cM co wceq wa vx vy copab vx cv vk cv c1 caddc co wceq vx cv cG cfv vk
        cv c1 caddc co cG cfv vz cv cF cfv cM vx cv vk cv c1 caddc co cG fveq2
        opreq1d vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx
        vy copab eqid vk cv c1 caddc co cG cfv vz cv cF cfv cM oprex fvopab4
        syl 3eqtrd adantl breqtrrd vz cv cX wcel cG vz cv cM clm cfv wbr wa vk
        cv cn wcel wa vk cv vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co
        wceq wa vx vy copab c1 cneg cshi co cfv vk cv c1 caddc co cG cfv vz cv
        cF cfv cM co vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul
        co wceq wa vx vy copab cfv cle vk cv cn wcel vk cv vx cv cn wcel vy cv
        vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv
        vk cv c1 caddc co cG cfv vz cv cF cfv cM co wceq vz cv cX wcel cG vz cv
        cM clm cfv wbr wa vk cv cn wcel vk cv vx cv cn wcel vy cv vx cv cG cfv
        vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv c1 vk cv
        caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx
        vy copab cfv vk cv c1 caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv
        cF cfv cM co wceq wa vx vy copab cfv vk cv c1 caddc co cG cfv vz cv cF
        cfv cM co c1 cc wcel vk cv cc wcel vk cv vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cfv c1 vk cv
        caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx
        vy copab cfv wceq vk cv cn wcel c1 vk cv vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab vx vy cn vx cv cG cfv vz cv
        cF cfv cM co nnex opabex2 shftval4 ax1cn vk cv nncn sylancr vk cv cn
        wcel c1 vk cv caddc co vk cv c1 caddc co vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cc wcel vk cv cc wcel c1
        vk cv caddc co vk cv c1 caddc co wceq vk cv cn wcel c1 vk cv addcom
        ax1cn vk cv nncn sylancr fveq2d vk cv cn wcel vk cv c1 caddc co cn wcel
        vk cv c1 caddc co vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co
        wceq wa vx vy copab cfv vk cv c1 caddc co cG cfv vz cv cF cfv cM co
        wceq vk cv peano2nn vx vy vk cv c1 caddc co vx cv cG cfv vz cv cF cfv
        cM co vk cv c1 caddc co cG cfv vz cv cF cfv cM co cn vx cv cn wcel vy
        cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab vx cv vk cv c1
        caddc co wceq vx cv cG cfv vk cv c1 caddc co cG cfv vz cv cF cfv cM vx
        cv vk cv c1 caddc co cG fveq2 opreq1d vx cv cn wcel vy cv vx cv cG cfv
        vz cv cF cfv cM co wceq wa vx vy copab eqid vk cv c1 caddc co cG cfv vz
        cv cF cfv cM oprex fvopab4 syl 3eqtrd adantl vz cv cX wcel cG vz cv cM
        clm cfv wbr wa vk cv cn wcel wa vk cv cG cfv cF cfv vz cv cF cfv cM co
        cK vk cv cG cfv vz cv cM co cmul co vk cv c1 caddc co cG cfv vz cv cF
        cfv cM co vk cv vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co
        wceq wa vx vy copab cfv cle vz cv cX wcel vk cv cn wcel vk cv cG cfv cF
        cfv vz cv cF cfv cM co cK vk cv cG cfv vz cv cM co cmul co cle wbr cG
        vz cv cM clm cfv wbr vk cv cn wcel vz cv cX wcel vk cv cG cfv cF cfv vz
        cv cF cfv cM co cK vk cv cG cfv vz cv cM co cmul co cle wbr vk cv cG
        cfv cX wcel vz cv cX wcel vk cv cG cfv cF cfv vz cv cF cfv cM co cK vk
        cv cG cfv vz cv cM co cmul co cle wbr vk cv cn wcel vk cv cG cfv cX
        wcel vz cv cX wcel wa vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM
        co cmul co cle wbr vy cX wral vx cX wral vk cv cG cfv cF cfv vz cv cF
        cfv cM co cK vk cv cG cfv vz cv cM co cmul co cle wbr bfplem.9 vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vk cv cG
        cfv cF cfv vz cv cF cfv cM co cK vk cv cG cfv vz cv cM co cmul co cle
        wbr vk cv cG cfv cF cfv vy cv cF cfv cM co cK vk cv cG cfv vy cv cM co
        cmul co cle wbr vx vy vk cv cG cfv vz cv cX cX vx cv vk cv cG cfv wceq
        vx cv cF cfv vy cv cF cfv cM co vk cv cG cfv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cK vk cv cG cfv vy cv cM co cmul co cle vx
        cv vk cv cG cfv wceq vx cv cF cfv vk cv cG cfv cF cfv vy cv cF cfv cM
        vx cv vk cv cG cfv cF fveq2 opreq1d vx cv vk cv cG cfv wceq vx cv vy cv
        cM co vk cv cG cfv vy cv cM co cK cmul vx cv vk cv cG cfv vy cv cM
        opreq1 opreq2d breq12d vy cv vz cv wceq vk cv cG cfv cF cfv vy cv cF
        cfv cM co vk cv cG cfv cF cfv vz cv cF cfv cM co cK vk cv cG cfv vy cv
        cM co cmul co cK vk cv cG cfv vz cv cM co cmul co cle vy cv vz cv wceq
        vy cv cF cfv vz cv cF cfv vk cv cG cfv cF cfv cM vy cv vz cv cF fveq2
        opreq2d vy cv vz cv wceq vk cv cG cfv vy cv cM co vk cv cG cfv vz cv cM
        co cK cmul vy cv vz cv vk cv cG cfv cM opreq2 opreq2d breq12d rcla42v
        mpi cn cX vk cv cG cF cG cM cX cY va vb vc bfp.1 bfplem.2 bfplem.3
        bfplem.4 bfplem.5 bfplem1 ffvelrni sylan ancoms adantlr vz cv cX wcel
        cG vz cv cM clm cfv wbr wa vk cv cn wcel wa vk cv c1 caddc co cG cfv vk
        cv cG cfv cF cfv vz cv cF cfv cM vk cv cn wcel vk cv c1 caddc co cG cfv
        vk cv cG cfv cF cfv wceq vz cv cX wcel cG vz cv cM clm cfv wbr wa cF cG
        cM vk cv cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5
        bfplem3 adantl opreq1d vk cv cn wcel vk cv vx cv cn wcel vy cv cK vx cv
        cG cfv vz cv cM co cmul co wceq wa vx vy copab cfv cK vk cv cG cfv vz
        cv cM co cmul co wceq vz cv cX wcel cG vz cv cM clm cfv wbr wa vx vy vk
        cv cK vx cv cG cfv vz cv cM co cmul co cK vk cv cG cfv vz cv cM co cmul
        co cn vx cv cn wcel vy cv cK vx cv cG cfv vz cv cM co cmul co wceq wa
        vx vy copab vx cv vk cv wceq vx cv cG cfv vz cv cM co vk cv cG cfv vz
        cv cM co cK cmul vx cv vk cv wceq vx cv cG cfv vk cv cG cfv vz cv cM vx
        cv vk cv cG fveq2 opreq1d opreq2d vx cv cn wcel vy cv cK vx cv cG cfv
        vz cv cM co cmul co wceq wa vx vy copab eqid cK vk cv cG cfv vz cv cM
        co cmul oprex fvopab4 adantl 3brtr4d eqbrtrd jca jca31 vk cv elnnuz
        sylan2br r19.21aiva syl3anc cc0 cc wcel vx cv cn wcel vy cv vx cv cG
        cfv vz cv cF cfv cM co wceq wa vx vy copab c1 cneg cshi co cc0 cli wbr
        vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab
        cc0 cli wbr wb 0cn cc0 vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM
        co wceq wa vx vy copab c1 cneg vx vy cn vx cv cG cfv vz cv cF cfv cM co
        nnex opabex2 c1 cz wcel c1 cneg cz wcel 1z c1 znegcl ax-mp climshfti
        ax-mp sylib vz cv cX wcel cG vz cv cF cfv cM clm cfv wbr vx cv cn wcel
        vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab cc0 cli wbr
        wb cG vz cv cM clm cfv wbr cM cme wcel cn cX cG wf vz cv cF cfv cX wcel
        cG vz cv cF cfv cM clm cfv wbr vx cv cn wcel vy cv vx cv cG cfv vz cv
        cF cfv cM co wceq wa vx vy copab cc0 cli wbr wb vz cv cX wcel vx vy cG
        vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv cM co wceq wa vx vy copab
        cM cX vz cv cF cfv bfp.1 vx cv cn wcel vy cv vx cv cG cfv vz cv cF cfv
        cM co wceq wa vx vy copab eqid lmclim2 cM cme wcel vz cv cX wcel cM
        bfplem.2 cmsmeti a1i cn cX cG wf vz cv cX wcel cF cG cM cX cY va vb vc
        bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem1 a1i cX cX vz cv cF
        bfplem.3 ffvelrni syl3anc adantr mpbird vz cv cX wcel cG vz cv cM clm
        cfv wbr pm3.27 syl3anc vtoclg anabsi5 $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . The fixed point is unique. $)
      bfplem9 $p |- ( ( ( Z e. X /\ W e. X ) /\
                        ( ( F ` Z ) = Z /\ ( F ` W ) = W ) ) -> Z = W ) $=
        cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv cW wceq wa wa cZ
        cW cM co cc0 wceq cZ cW wceq cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq
        cW cF cfv cW wceq wa wa cc0 cZ cW cM co cZ cX wcel cW cX wcel wa cZ cF
        cfv cZ wceq cW cF cfv cW wceq wa wa cc0 cZ cW cM co wceq cc0 cZ cW cM
        co cle wbr cc0 cZ cW cM co clt wbr wn wa cZ cX wcel cW cX wcel wa cZ cF
        cfv cZ wceq cW cF cfv cW wceq wa wa cc0 cZ cW cM co cle wbr cc0 cZ cW
        cM co clt wbr wn cZ cX wcel cW cX wcel wa cc0 cZ cW cM co cle wbr cZ cF
        cfv cZ wceq cW cF cfv cW wceq wa cM cme wcel cZ cX wcel cW cX wcel cc0
        cZ cW cM co cle wbr cM bfplem.2 cmsmeti cZ cW cM cX bfp.1 metge0 mp3an1
        adantr cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv cW wceq wa
        wa cc0 cZ cW cM co clt wbr cZ cW cM co cZ cW cM co clt wbr cZ cX wcel
        cW cX wcel wa cZ cW cM co cZ cW cM co clt wbr wn cZ cF cfv cZ wceq cW
        cF cfv cW wceq wa cZ cX wcel cW cX wcel wa cZ cW cM co cr wcel cZ cW cM
        co cZ cW cM co clt wbr wn cM cme wcel cZ cX wcel cW cX wcel cZ cW cM co
        cr wcel cM bfplem.2 cmsmeti cZ cW cM cX bfp.1 metcl mp3an1 cZ cW cM co
        ltnr syl adantr cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv cW
        wceq wa wa cc0 cZ cW cM co clt wbr wa cZ cW cM co cK cZ cW cM co cmul
        co cZ cW cM co cZ cX wcel cW cX wcel wa cZ cW cM co cr wcel cZ cF cfv
        cZ wceq cW cF cfv cW wceq wa cc0 cZ cW cM co clt wbr cM cme wcel cZ cX
        wcel cW cX wcel cZ cW cM co cr wcel cM bfplem.2 cmsmeti cZ cW cM cX
        bfp.1 metcl mp3an1 ad2antrr cK cr wcel cZ cW cM co cr wcel cK cZ cW cM
        co cmul co cr wcel cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv
        cW wceq wa wa cc0 cZ cW cM co clt wbr wa cK cZ cW cM co remulcl cK crp
        wcel cK cr wcel bfplem.7 cK rpre ax-mp cZ cX wcel cW cX wcel wa cZ cW
        cM co cr wcel cZ cF cfv cZ wceq cW cF cfv cW wceq wa cc0 cZ cW cM co
        clt wbr cM cme wcel cZ cX wcel cW cX wcel cZ cW cM co cr wcel cM
        bfplem.2 cmsmeti cZ cW cM cX bfp.1 metcl mp3an1 ad2antrr sylancr cZ cX
        wcel cW cX wcel wa cZ cW cM co cr wcel cZ cF cfv cZ wceq cW cF cfv cW
        wceq wa cc0 cZ cW cM co clt wbr cM cme wcel cZ cX wcel cW cX wcel cZ cW
        cM co cr wcel cM bfplem.2 cmsmeti cZ cW cM cX bfp.1 metcl mp3an1
        ad2antrr cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv cW wceq
        wa wa cZ cW cM co cK cZ cW cM co cmul co cle wbr cc0 cZ cW cM co clt
        wbr cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv cW wceq wa wa
        cZ cF cfv cW cF cfv cM co cZ cW cM co cK cZ cW cM co cmul co cle cZ cF
        cfv cZ wceq cW cF cfv cW wceq wa cZ cF cfv cW cF cfv cM co cZ cW cM co
        wceq cZ cX wcel cW cX wcel wa cZ cF cfv cZ cW cF cfv cW cM opreq12
        adantl cZ cX wcel cW cX wcel wa cZ cF cfv cW cF cfv cM co cK cZ cW cM
        co cmul co cle wbr cZ cF cfv cZ wceq cW cF cfv cW wceq wa cZ cX wcel cW
        cX wcel wa vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
        cle wbr vy cX wral vx cX wral cZ cF cfv cW cF cfv cM co cK cZ cW cM co
        cmul co cle wbr bfplem.9 vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv
        cM co cmul co cle wbr cZ cF cfv cW cF cfv cM co cK cZ cW cM co cmul co
        cle wbr cZ cF cfv vy cv cF cfv cM co cK cZ vy cv cM co cmul co cle wbr
        vx vy cZ cW cX cX vx cv cZ wceq vx cv cF cfv vy cv cF cfv cM co cZ cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cK cZ vy cv cM co
        cmul co cle vx cv cZ wceq vx cv cF cfv cZ cF cfv vy cv cF cfv cM vx cv
        cZ cF fveq2 opreq1d vx cv cZ wceq vx cv vy cv cM co cZ vy cv cM co cK
        cmul vx cv cZ vy cv cM opreq1 opreq2d breq12d vy cv cW wceq cZ cF cfv
        vy cv cF cfv cM co cZ cF cfv cW cF cfv cM co cK cZ vy cv cM co cmul co
        cK cZ cW cM co cmul co cle vy cv cW wceq vy cv cF cfv cW cF cfv cZ cF
        cfv cM vy cv cW cF fveq2 opreq2d vy cv cW wceq cZ vy cv cM co cZ cW cM
        co cK cmul vy cv cW cZ cM opreq2 opreq2d breq12d rcla42v mpi adantr
        eqbrtrrd adantr cZ cX wcel cW cX wcel wa cZ cF cfv cZ wceq cW cF cfv cW
        wceq wa wa cc0 cZ cW cM co clt wbr wa cK cZ cW cM co cmul co c1 cZ cW
        cM co cmul co cZ cW cM co clt cZ cX wcel cW cX wcel wa cc0 cZ cW cM co
        clt wbr cK cZ cW cM co cmul co c1 cZ cW cM co cmul co clt wbr cZ cF cfv
        cZ wceq cW cF cfv cW wceq wa cZ cW cM co cr wcel cc0 cZ cW cM co clt
        wbr cK cZ cW cM co cmul co c1 cZ cW cM co cmul co clt wbr cZ cX wcel cW
        cX wcel wa cK cr wcel c1 cr wcel cZ cW cM co cr wcel cc0 cZ cW cM co
        clt wbr wa cK cZ cW cM co cmul co c1 cZ cW cM co cmul co clt wbr cK crp
        wcel cK cr wcel bfplem.7 cK rpre ax-mp 1re cK cr wcel c1 cr wcel cZ cW
        cM co cr wcel cc0 cZ cW cM co clt wbr wa w3a cK c1 clt wbr cK cZ cW cM
        co cmul co c1 cZ cW cM co cmul co clt wbr bfplem.8 cK c1 cZ cW cM co
        ltmul1 mpbii mp3an12 cM cme wcel cZ cX wcel cW cX wcel cZ cW cM co cr
        wcel cM bfplem.2 cmsmeti cZ cW cM cX bfp.1 metcl mp3an1 sylan adantlr
        cZ cX wcel cW cX wcel wa c1 cZ cW cM co cmul co cZ cW cM co wceq cZ cF
        cfv cZ wceq cW cF cfv cW wceq wa cc0 cZ cW cM co clt wbr cZ cX wcel cW
        cX wcel wa cZ cW cM co cr wcel cZ cW cM co cc wcel c1 cZ cW cM co cmul
        co cZ cW cM co wceq cM cme wcel cZ cX wcel cW cX wcel cZ cW cM co cr
        wcel cM bfplem.2 cmsmeti cZ cW cM cX bfp.1 metcl mp3an1 cZ cW cM co
        recn cZ cW cM co mulid2 3syl ad2antrr breqtrd lelttrd mtand jca cZ cX
        wcel cW cX wcel wa cc0 cZ cW cM co wceq cc0 cZ cW cM co cle wbr cc0 cZ
        cW cM co clt wbr wn wa wb cZ cF cfv cZ wceq cW cF cfv cW wceq wa cc0 cr
        wcel cZ cW cM co cr wcel cc0 cZ cW cM co wceq cc0 cZ cW cM co cle wbr
        cc0 cZ cW cM co clt wbr wn wa wb cZ cX wcel cW cX wcel wa cc0 cZ cW cM
        co eqlelt 0re cM cme wcel cZ cX wcel cW cX wcel cZ cW cM co cr wcel cM
        bfplem.2 cmsmeti cZ cW cM cX bfp.1 metcl mp3an1 sylancr adantr mpbird
        eqcomd cZ cX wcel cW cX wcel wa cZ cW cM co cc0 wceq cZ cW wceq wb cZ
        cF cfv cZ wceq cW cF cfv cW wceq wa cM cme wcel cZ cX wcel cW cX wcel
        cZ cW cM co cc0 wceq cZ cW wceq wb cM bfplem.2 cmsmeti cZ cW cM cX
        bfp.1 meteq0 mp3an1 adantr mpbid $.
        $( [2-Sep-2009] $)

      $( Lemma for ~ bfp . ` F ` has exactly one fixed point. $)
      bfplem10 $p |- E! z e. X ( F ` z ) = z $=
        vz cv cF cfv vz cv wceq vz cX wreu vz cv cF cfv vz cv wceq vz cX wrex
        vz cv cF cfv vz cv wceq vw cv cF cfv vw cv wceq wa vz cv vw cv wceq wi
        vw cX wral vz cX wral vz cv cF cfv vz cv wceq vw cv cF cfv vw cv wceq
        vz vw cX vz cv vw cv wceq vz cv cF cfv vw cv cF cfv vz cv vw cv vz cv
        vw cv cF fveq2 vz cv vw cv wceq id eqeq12d reu4 cG vz cv cM clm cfv wbr
        vz cX wrex vz cv cF cfv vz cv wceq vz cX wrex vx vy vz cD cF cG cK cM
        cX cY va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4 bfplem.5 bfplem.6
        bfplem.7 bfplem.8 bfplem.9 bfplem7 cG vz cv cM clm cfv wbr vz cv cF cfv
        vz cv wceq vz cX vz cv cX wcel cG vz cv cM clm cfv wbr vz cv cF cfv vz
        cv wceq vx vy cD cF cG cK cM cX cY vz cv va vb vc bfp.1 bfplem.2
        bfplem.3 bfplem.4 bfplem.5 bfplem.6 bfplem.7 bfplem.8 bfplem.9 bfplem8
        ex r19.22i ax-mp vz cv cF cfv vz cv wceq vw cv cF cfv vw cv wceq wa vz
        cv vw cv wceq wi vz vw cX vz cv cX wcel vw cv cX wcel wa vz cv cF cfv
        vz cv wceq vw cv cF cfv vw cv wceq wa vz cv vw cv wceq vx vy cD cF cG
        cK cM vw cv cX cY vz cv va vb vc bfp.1 bfplem.2 bfplem.3 bfplem.4
        bfplem.5 bfplem.6 bfplem.7 bfplem.8 bfplem.9 bfplem9 ex rgen2a mpbir2an
        $.
        $( [2-Sep-2009] $)
    $}

    ${
      $d M a b c $. $d K a b c $. $d F u v $. $d X u v $. $d Y u v $.
      bfplem.2a $e |- M e. CMet $.
      bfplem.4a $e |- Y e. X $.
      bfplem.7a $e |- K e. RR+ $.
      bfplem.8a $e |- K < 1 $.
      $( Lemma for ~ bfp . Apply the deduction theorem. $)
      bfplem11 $p |- ( ( F : X --> X /\ A. x e. X A. y e. X
                            ( ( F ` x ) M  ( F ` y ) ) <_ ( K x. ( x M y ) ) )
                                        -> E! z e. X ( F ` z ) = z ) $=
        cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul
        co cle wbr vy cX wral vx cX wral wa vz cv cF cfv vz cv wceq vz cX wreu
        vz cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv vz cv
        wceq vz cX wreu cF cX cY csn cxp cF cX cX cF wf vx cv cF cfv vy cv cF
        cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa
        cF cX cY csn cxp cif wceq vz cv cF cfv vz cv wceq vz cv cX cX cF wf vx
        cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif cfv vz cv wceq vz cX cF cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wceq vz cv cF cfv vz
        cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv vz cv
        vz cv cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM
        co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif fveq1
        eqeq1d reubidv vu vv vz cY cY cX cX cF wf vx cv cF cfv vy cv cF cfv cM
        co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX
        cY csn cxp cif cfv cM co cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif va cv cX wcel vb cv cX wcel wa vc cv va cv cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif cfv wceq wa va vb vc copab2 cn cY
        csn cxp cseq1 co cK cM cX cY va vb vc bfp.1 bfplem.2a cX cX cX cX cF wf
        vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy
        cX wral vx cX wral wa cF cX cY csn cxp cif wf vu cv cX cX cF wf vx cv
        cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul
        co cle wbr vv cX wral vu cX wral cX cX cF wf vx cv cF cfv vy cv cF cfv
        cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cX
        cX cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wf vu cv
        cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul
        co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX
        cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
        cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv cM co cK vu
        cv vv cv cM co cmul co cle wbr vv cX wral vu cX wral wa cX cX cX cY csn
        cxp wf vu cv cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co cK vu cv
        vv cv cM co cmul co cle wbr vv cX wral vu cX wral wa cF cX cY csn cxp
        cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wceq cX
        cX cF wf cX cX cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif
        wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr
        vy cX wral vx cX wral vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY
        csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx
        cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX wral vu cX
        wral cX cX cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif
        feq1 cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM
        co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wceq
        vu cv cF cfv vv cv cF cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv
        cX wral vu cX wral vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv
        vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp
        cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX wral vu cX
        wral vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM
        co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX
        cY csn cxp cif wceq vu cv cF cfv vv cv cF cfv cM co cK vu cv vv cv cM
        co cmul co cle wbr vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv
        vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp
        cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr vu vv cX cX cF cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wceq vu cv cF cfv vv
        cv cF cfv cM co vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx
        cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv
        vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp
        cif cfv cM co cK vu cv vv cv cM co cmul co cle cF cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif wceq vu cv cF cfv vu cv cX cX cF wf
        vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy
        cX wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cF cfv vv cv cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv cM vu cv cF cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif fveq1 vv cv cF cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif fveq1 opreq12d breq1d
        2ralbidv vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
        cle wbr vu cv cF cfv vv cv cF cfv cM co cK vu cv vv cv cM co cmul co
        cle wbr vu cv cF cfv vy cv cF cfv cM co cK vu cv vy cv cM co cmul co
        cle wbr vx vy vu vv cX cX vx cv vu cv wceq vx cv cF cfv vy cv cF cfv cM
        co vu cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cK vu
        cv vy cv cM co cmul co cle vx cv vu cv wceq vx cv cF cfv vu cv cF cfv
        vy cv cF cfv cM vx cv vu cv cF fveq2 opreq1d vx cv vu cv wceq vx cv vy
        cv cM co vu cv vy cv cM co cK cmul vx cv vu cv vy cv cM opreq1 opreq2d
        breq12d vy cv vv cv wceq vu cv cF cfv vy cv cF cfv cM co vu cv cF cfv
        vv cv cF cfv cM co cK vu cv vy cv cM co cmul co cK vu cv vv cv cM co
        cmul co cle vy cv vv cv wceq vy cv cF cfv vv cv cF cfv vu cv cF cfv cM
        vy cv vv cv cF fveq2 opreq2d vy cv vv cv wceq vu cv vy cv cM co vu cv
        vv cv cM co cK cmul vy cv vv cv vu cv cM opreq2 opreq2d breq12d
        cbvral2v syl5bb anbi12d cX cY csn cxp cX cX cF wf vx cv cF cfv vy cv cF
        cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa
        cF cX cY csn cxp cif wceq cX cX cX cY csn cxp wf cX cX cX cX cF wf vx
        cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif wf vu cv cX cY csn cxp cfv vv
        cv cX cY csn cxp cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX
        wral vu cX wral vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx
        cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv
        vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp
        cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX wral vu cX
        wral cX cX cX cY csn cxp cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif feq1 cX cY csn cxp cX cX cF wf vx cv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY
        csn cxp cif wceq vu cv cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co
        cK vu cv vv cv cM co cmul co cle wbr vu cv cX cX cF wf vx cv cF cfv vy
        cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX
        wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv
        cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral
        wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr
        vu vv cX cX cX cY csn cxp cX cX cF wf vx cv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY
        csn cxp cif wceq vu cv cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co
        vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv
        cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul
        co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv cM co cK
        vu cv vv cv cM co cmul co cle cX cY csn cxp cX cX cF wf vx cv cF cfv vy
        cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX
        wral wa cF cX cY csn cxp cif wceq vu cv cX cY csn cxp cfv vu cv cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cY csn
        cxp cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif
        cfv cM vu cv cX cY csn cxp cX cX cF wf vx cv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY
        csn cxp cif fveq1 vv cv cX cY csn cxp cX cX cF wf vx cv cF cfv vy cv cF
        cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa
        cF cX cY csn cxp cif fveq1 opreq12d breq1d 2ralbidv anbi12d cX cX cX cY
        csn cxp wf vu cv cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co cK vu
        cv vv cv cM co cmul co cle wbr vv cX wral vu cX wral cX cY csn cX cY
        csn cxp wf cY csn cX wss cX cX cX cY csn cxp wf cX cY cY cX bfplem.4a
        elisseti fconst cY cX wcel cY csn cX wss bfplem.4a cY cX snssi ax-mp cX
        cY csn cX cX cY csn cxp fss mp2an vu cv cX cY csn cxp cfv vv cv cX cY
        csn cxp cfv cM co cK vu cv vv cv cM co cmul co cle wbr vu vv cX vu cv
        cX wcel vv cv cX wcel wa vu cv cX cY csn cxp cfv vv cv cX cY csn cxp
        cfv cM co cc0 cK vu cv vv cv cM co cmul co cle vu cv cX wcel vv cv cX
        wcel wa vu cv cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co cY cY cM
        co cc0 vu cv cX wcel vv cv cX wcel vu cv cX cY csn cxp cfv cY vv cv cX
        cY csn cxp cfv cY cM cX cY vu cv cY cX bfplem.4a elisseti fvconst2 cX
        cY vv cv cY cX bfplem.4a elisseti fvconst2 opreqan12d cM cme wcel cY cX
        wcel cY cY cM co cc0 wceq cM bfplem.2a cmsmeti bfplem.4a cY cM cX bfp.1
        met0 mp2an syl6eq cK cr wcel cc0 cK cle wbr vu cv vv cv cM co cr wcel
        cc0 vu cv vv cv cM co cle wbr cc0 cK vu cv vv cv cM co cmul co cle wbr
        vu cv cX wcel vv cv cX wcel wa cK vu cv vv cv cM co mulge0 cK cr wcel
        vu cv cX wcel vv cv cX wcel wa cK crp wcel cK cr wcel bfplem.7a cK rpre
        ax-mp a1i cc0 cK cle wbr vu cv cX wcel vv cv cX wcel wa cK crp wcel cc0
        cK cle wbr bfplem.7a cK rpge0 ax-mp a1i cM cme wcel vu cv cX wcel vv cv
        cX wcel vu cv vv cv cM co cr wcel cM bfplem.2a cmsmeti vu cv vv cv cM
        cX bfp.1 metcl mp3an1 cM cme wcel vu cv cX wcel vv cv cX wcel cc0 vu cv
        vv cv cM co cle wbr cM bfplem.2a cmsmeti vu cv vv cv cM cX bfp.1 metge0
        mp3an1 syl2anc eqbrtrd rgen2a pm3.2i elimhyp pm3.26i bfplem.4a va cv cX
        wcel vb cv cX wcel wa vc cv va cv cX cX cF wf vx cv cF cfv vy cv cF cfv
        cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF
        cX cY csn cxp cif cfv wceq wa va vb vc copab2 cn cY csn cxp cseq1 co
        eqid cY cY cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv
        cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv
        cM co eqid bfplem.7a bfplem.8a cX cX cX cX cF wf vx cv cF cfv vy cv cF
        cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa
        cF cX cY csn cxp cif wf vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM
        co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX
        cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX wral vu cX
        wral cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cX cX cX cX cF wf vx cv cF cfv
        vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx
        cX wral wa cF cX cY csn cxp cif wf vu cv cX cX cF wf vx cv cF cfv vy cv
        cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral
        wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv
        cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF
        cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX
        wral vu cX wral wa cX cX cX cY csn cxp wf vu cv cX cY csn cxp cfv vv cv
        cX cY csn cxp cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX wral
        vu cX wral wa cF cX cY csn cxp cF cX cX cF wf vx cv cF cfv vy cv cF cfv
        cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF
        cX cY csn cxp cif wceq cX cX cF wf cX cX cX cX cF wf vx cv cF cfv vy cv
        cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral
        wa cF cX cY csn cxp cif wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cle wbr vy cX wral vx cX wral vu cv cX cX cF wf vx cv
        cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul
        co cle wbr vv cX wral vu cX wral cX cX cF cX cX cF wf vx cv cF cfv vy
        cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX
        wral wa cF cX cY csn cxp cif feq1 cF cX cX cF wf vx cv cF cfv vy cv cF
        cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa
        cF cX cY csn cxp cif wceq vu cv cF cfv vv cv cF cfv cM co cK vu cv vv
        cv cM co cmul co cle wbr vv cX wral vu cX wral vu cv cX cX cF wf vx cv
        cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul
        co cle wbr vv cX wral vu cX wral vx cv cF cfv vy cv cF cfv cM co cK vx
        cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral cF cX cX cF wf vx
        cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif wceq vu cv cF cfv vv cv cF cfv
        cM co cK vu cv vv cv cM co cmul co cle wbr vu cv cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv
        vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx
        cX wral wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul co
        cle wbr vu vv cX cX cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif wceq vu cv cF cfv vv cv cF cfv cM co vu cv cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv
        vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx
        cX wral wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul co
        cle cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wceq vu
        cv cF cfv vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif
        cfv vv cv cF cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv cM vu cv cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif fveq1 vv cv cF cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif fveq1 opreq12d breq1d 2ralbidv vx cv cF cfv vy cv cF cfv cM co
        cK vx cv vy cv cM co cmul co cle wbr vu cv cF cfv vv cv cF cfv cM co cK
        vu cv vv cv cM co cmul co cle wbr vu cv cF cfv vy cv cF cfv cM co cK vu
        cv vy cv cM co cmul co cle wbr vx vy vu vv cX cX vx cv vu cv wceq vx cv
        cF cfv vy cv cF cfv cM co vu cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cK vu cv vy cv cM co cmul co cle vx cv vu cv wceq vx
        cv cF cfv vu cv cF cfv vy cv cF cfv cM vx cv vu cv cF fveq2 opreq1d vx
        cv vu cv wceq vx cv vy cv cM co vu cv vy cv cM co cK cmul vx cv vu cv
        vy cv cM opreq1 opreq2d breq12d vy cv vv cv wceq vu cv cF cfv vy cv cF
        cfv cM co vu cv cF cfv vv cv cF cfv cM co cK vu cv vy cv cM co cmul co
        cK vu cv vv cv cM co cmul co cle vy cv vv cv wceq vy cv cF cfv vv cv cF
        cfv vu cv cF cfv cM vy cv vv cv cF fveq2 opreq2d vy cv vv cv wceq vu cv
        vy cv cM co vu cv vv cv cM co cK cmul vy cv vv cv vu cv cM opreq2
        opreq2d breq12d cbvral2v syl5bb anbi12d cX cY csn cxp cX cX cF wf vx cv
        cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX
        wral vx cX wral wa cF cX cY csn cxp cif wceq cX cX cX cY csn cxp wf cX
        cX cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
        cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wf vu cv
        cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co cK vu cv vv cv cM co
        cmul co cle wbr vv cX wral vu cX wral vu cv cX cX cF wf vx cv cF cfv vy
        cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX
        wral wa cF cX cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv
        cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral
        wa cF cX cY csn cxp cif cfv cM co cK vu cv vv cv cM co cmul co cle wbr
        vv cX wral vu cX wral cX cX cX cY csn cxp cX cX cF wf vx cv cF cfv vy
        cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX
        wral wa cF cX cY csn cxp cif feq1 cX cY csn cxp cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif wceq vu cv cX cY csn cxp cfv vv cv
        cX cY csn cxp cfv cM co cK vu cv vv cv cM co cmul co cle wbr vu cv cX
        cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
        cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv vv cv cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif cfv cM co cK vu cv vv
        cv cM co cmul co cle wbr vu vv cX cX cX cY csn cxp cX cX cF wf vx cv cF
        cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
        vx cX wral wa cF cX cY csn cxp cif wceq vu cv cX cY csn cxp cfv vv cv
        cX cY csn cxp cfv cM co vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM
        co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX
        cY csn cxp cif cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK
        vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn
        cxp cif cfv cM co cK vu cv vv cv cM co cmul co cle cX cY csn cxp cX cX
        cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
        wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif wceq vu cv cX cY csn
        cxp cfv vu cv cX cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
        cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF cX cY csn cxp cif
        cfv vv cv cX cY csn cxp cfv vv cv cX cX cF wf vx cv cF cfv vy cv cF cfv
        cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral wa cF
        cX cY csn cxp cif cfv cM vu cv cX cY csn cxp cX cX cF wf vx cv cF cfv
        vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx
        cX wral wa cF cX cY csn cxp cif fveq1 vv cv cX cY csn cxp cX cX cF wf
        vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy
        cX wral vx cX wral wa cF cX cY csn cxp cif fveq1 opreq12d breq1d
        2ralbidv anbi12d cX cX cX cY csn cxp wf vu cv cX cY csn cxp cfv vv cv
        cX cY csn cxp cfv cM co cK vu cv vv cv cM co cmul co cle wbr vv cX wral
        vu cX wral cX cY csn cX cY csn cxp wf cY csn cX wss cX cX cX cY csn cxp
        wf cX cY cY cX bfplem.4a elisseti fconst cY cX wcel cY csn cX wss
        bfplem.4a cY cX snssi ax-mp cX cY csn cX cX cY csn cxp fss mp2an vu cv
        cX cY csn cxp cfv vv cv cX cY csn cxp cfv cM co cK vu cv vv cv cM co
        cmul co cle wbr vu vv cX vu cv cX wcel vv cv cX wcel wa vu cv cX cY csn
        cxp cfv vv cv cX cY csn cxp cfv cM co cc0 cK vu cv vv cv cM co cmul co
        cle vu cv cX wcel vv cv cX wcel wa vu cv cX cY csn cxp cfv vv cv cX cY
        csn cxp cfv cM co cY cY cM co cc0 vu cv cX wcel vv cv cX wcel vu cv cX
        cY csn cxp cfv cY vv cv cX cY csn cxp cfv cY cM cX cY vu cv cY cX
        bfplem.4a elisseti fvconst2 cX cY vv cv cY cX bfplem.4a elisseti
        fvconst2 opreqan12d cM cme wcel cY cX wcel cY cY cM co cc0 wceq cM
        bfplem.2a cmsmeti bfplem.4a cY cM cX bfp.1 met0 mp2an syl6eq cK cr wcel
        cc0 cK cle wbr vu cv vv cv cM co cr wcel cc0 vu cv vv cv cM co cle wbr
        cc0 cK vu cv vv cv cM co cmul co cle wbr vu cv cX wcel vv cv cX wcel wa
        cK vu cv vv cv cM co mulge0 cK cr wcel vu cv cX wcel vv cv cX wcel wa
        cK crp wcel cK cr wcel bfplem.7a cK rpre ax-mp a1i cc0 cK cle wbr vu cv
        cX wcel vv cv cX wcel wa cK crp wcel cc0 cK cle wbr bfplem.7a cK rpge0
        ax-mp a1i cM cme wcel vu cv cX wcel vv cv cX wcel vu cv vv cv cM co cr
        wcel cM bfplem.2a cmsmeti vu cv vv cv cM cX bfp.1 metcl mp3an1 cM cme
        wcel vu cv cX wcel vv cv cX wcel cc0 vu cv vv cv cM co cle wbr cM
        bfplem.2a cmsmeti vu cv vv cv cM cX bfp.1 metge0 mp3an1 syl2anc eqbrtrd
        rgen2a pm3.2i elimhyp pm3.27i bfplem10 dedth $.
        $( [2-Sep-2009] $)
    $}

    $( Banach fixed point theorem, also known as contraction mapping theorem.
       A contraction on a complete metric space has a unique fixed point. $)
    bfp $p |- ( ( ( M e. CMet /\ X =/= (/) ) /\ ( K e. RR+ /\ K < 1 ) /\
                        ( F : X --> X /\ A. x e. X A. y e. X
                          ( ( F ` x ) M  ( F ` y ) ) <_ ( K x. ( x M y ) ) ) )
                                        -> E! z e. X ( F ` z ) = z ) $=
      cM cms wcel cX c0 wne wa cK crp wcel cK c1 clt wbr wa cX cX cF wf vx cv
      cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
      vx cX wral wa vz cv cF cfv vz cv wceq vz cX wreu cM cms wcel cX c0 wne wa
      cK crp wcel cK c1 clt wbr wa wa cM cdm cdm cM cdm cdm cF wf vx cv cF cfv
      vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cM cdm cdm
      wral vx cM cdm cdm wral wa vz cv cF cfv vz cv wceq vz cM cdm cdm wreu cX
      cX cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
      wbr vy cX wral vx cX wral wa vz cv cF cfv vz cv wceq vz cX wreu cM cms
      wcel cX c0 wne cK crp wcel cK c1 clt wbr wa cM cdm cdm cM cdm cdm cF wf
      vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy
      cM cdm cdm wral vx cM cdm cdm wral wa vz cv cF cfv vz cv wceq vz cM cdm
      cdm wreu wi cM cms wcel vw cv cM cdm cdm wcel vw wex cK crp wcel cK c1
      clt wbr wa cM cdm cdm cM cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM co cK
      vx cv vy cv cM co cmul co cle wbr vy cM cdm cdm wral vx cM cdm cdm wral
      wa vz cv cF cfv vz cv wceq vz cM cdm cdm wreu wi wi cX c0 wne cM cms wcel
      vw cv cM cdm cdm wcel cK crp wcel cK c1 clt wbr wa cM cdm cdm cM cdm cdm
      cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle
      wbr vy cM cdm cdm wral vx cM cdm cdm wral wa vz cv cF cfv vz cv wceq vz
      cM cdm cdm wreu wi wi vw cM cms wcel vw cv cM cdm cdm wcel cK crp wcel cK
      c1 clt wbr wa cM cdm cdm cM cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM co
      cK vx cv vy cv cM co cmul co cle wbr vy cM cdm cdm wral vx cM cdm cdm
      wral wa vz cv cF cfv vz cv wceq vz cM cdm cdm wreu wi cM cms wcel vw cv
      cM cdm cdm wcel wa cK crp wcel cK c1 clt wbr wa cM cdm cdm cM cdm cdm cF
      wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr
      vy cM cdm cdm wral vx cM cdm cdm wral wa vz cv cF cfv vz cv wceq vz cM
      cdm cdm wreu wi cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv
      vw cv cop csn cc0 csn cxp cif cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      co cK vx cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif co cmul co cle wbr vy cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral vx cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm wral wa vz cv cF cfv vz cv wceq vz cM cms wcel vw cv cM cdm cdm wcel
      wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wreu wi cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM cms wcel vw cv cM cdm cdm wcel
      wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK crp wcel cK c1 clt wbr wa
      cK c1 c2 cdiv co cif vx cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif co cmul co cle wbr vy cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral
      vx cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif cdm cdm wral wa vz cv cF cfv vz cv wceq vz cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wreu wi cM
      cK vw cv vw cv cop csn cc0 csn cxp c1 c2 cdiv co cM cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq cM cdm cdm cM
      cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul
      co cle wbr vy cM cdm cdm wral vx cM cdm cdm wral wa cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm cF wf vx cv cF cfv vy cv cF cfv cM cms wcel vw cv cM cdm cdm wcel wa
      cM vw cv vw cv cop csn cc0 csn cxp cif co cK vx cv vy cv cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co
      cle wbr vy cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn
      cc0 csn cxp cif cdm cdm wral vx cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral wa vz cv cF cfv vz cv
      wceq vz cM cdm cdm wreu vz cv cF cfv vz cv wceq vz cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wreu cM cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      wceq cM cdm cdm cM cdm cdm cF wf cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cF wf vx cv cF cfv
      vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cM cdm cdm
      wral vx cM cdm cdm wral vx cv cF cfv vy cv cF cfv cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK vx cv vy cv
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif co cmul co cle wbr vy cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv
      vw cv cop csn cc0 csn cxp cif cdm cdm wral vx cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral cM cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq
      cM cdm cdm cM cdm cdm cF wf cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv
      vw cv cop csn cc0 csn cxp cif cdm cdm cM cdm cdm cF wf cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm cF wf cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn
      cc0 csn cxp cif wceq cM cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wceq cM cdm cdm cM cdm cdm cF
      wf cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif cdm cdm cM cdm cdm cF wf wb cM cM cms wcel vw cv cM cdm cdm wcel
      wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq cM cdm cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cM cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif dmeq
      dmeqd cM cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm cM cdm cdm cF feq2 syl cM cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq cM cdm cdm
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif cdm cdm wceq cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm cM cdm cdm cF wf cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cF wf
      wb cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif wceq cM cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif cdm cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw
      cv vw cv cop csn cc0 csn cxp cif dmeq dmeqd cM cdm cdm cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm cF feq3 syl bitrd cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw
      cv cop csn cc0 csn cxp cif wceq vx cv cF cfv vy cv cF cfv cM co cK vx cv
      vy cv cM co cmul co cle wbr vy cM cdm cdm wral vx cv cF cfv vy cv cF cfv
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif co cK vx cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif co cmul co cle wbr vy cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral vx cM cdm
      cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif cdm cdm cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif wceq cM cdm cM cms wcel vw cv cM cdm cdm wcel wa
      cM vw cv vw cv cop csn cc0 csn cxp cif cdm cM cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif dmeq dmeqd cM cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq
      vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vx
      cv cF cfv vy cv cF cfv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw
      cv cop csn cc0 csn cxp cif co cK vx cv vy cv cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co cle wbr vy cM
      cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif cdm cdm cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw
      cv cop csn cc0 csn cxp cif wceq cM cdm cM cms wcel vw cv cM cdm cdm wcel
      wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cM cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif dmeq dmeqd cM cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq
      vx cv cF cfv vy cv cF cfv cM co vx cv cF cfv vy cv cF cfv cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK vx cv
      vy cv cM co cmul co cK vx cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa
      cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co cle vx cv cF cfv vy cv
      cF cfv cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif opreq cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif wceq vx cv vy cv cM co vx cv vy cv cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK cmul
      vx cv vy cv cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif opreq opreq2d breq12d raleq12d raleq12d anbi12d cM cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      wceq cM cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm wceq vz cv cF cfv vz cv wceq vz cM cdm cdm
      wreu vz cv cF cfv vz cv wceq vz cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wreu wb cM cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq cM cdm cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      cdm cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif dmeq dmeqd vz cv cF cfv vz cv wceq vz cM cdm cdm cM cms wcel
      vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm
      reueq1 syl imbi12d cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif
      wceq cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM cms wcel
      vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK vx
      cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif co cmul co cle wbr vy cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral vx cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wral wa cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif cdm cdm cF wf vx cv cF cfv vy cv cF cfv cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK crp wcel cK
      c1 clt wbr wa cK c1 c2 cdiv co cif vx cv vy cv cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co cle wbr vy
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif cdm cdm wral vx cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif cdm cdm wral wa vz cv cF cfv vz cv wceq vz cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm wreu cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif wceq vx cv
      cF cfv vy cv cF cfv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif co cK vx cv vy cv cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co cle wbr vy cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      cdm cdm wral vx cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm wral vx cv cF cfv vy cv cF cfv cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cK crp
      wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif vx cv vy cv cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co cle
      wbr vy cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif cdm cdm wral vx cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv
      vw cv cop csn cc0 csn cxp cif cdm cdm wral cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cF wf
      cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif wceq vx cv cF cfv vy
      cv cF cfv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif co cK vx cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa cM vw
      cv vw cv cop csn cc0 csn cxp cif co cmul co cle wbr vx cv cF cfv vy cv cF
      cfv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif co cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif vx cv vy cv
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif co cmul co cle wbr vx vy cM cms wcel vw cv cM cdm cdm wcel wa cM vw
      cv vw cv cop csn cc0 csn cxp cif cdm cdm cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm cK cK crp wcel cK
      c1 clt wbr wa cK c1 c2 cdiv co cif wceq cK vx cv vy cv cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co cK
      crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif vx cv vy cv cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif co cmul co
      vx cv cF cfv vy cv cF cfv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv
      vw cv cop csn cc0 csn cxp cif co cle cK cK crp wcel cK c1 clt wbr wa cK
      c1 c2 cdiv co cif vx cv vy cv cM cms wcel vw cv cM cdm cdm wcel wa cM vw
      cv vw cv cop csn cc0 csn cxp cif co cmul opreq1 breq2d 2ralbidv anbi2d
      imbi1d vx vy vz cF cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif cM
      cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif cdm cdm vw cv cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cdm cdm eqid cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cms wcel vw cv cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wcel cM
      cms wcel vw cv cM cdm cdm wcel wa cM cms wcel vw cv cM cdm cdm wcel wa cM
      vw cv vw cv cop csn cc0 csn cxp cif cms wcel vw cv cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wcel wa vw
      cv vw cv cop csn cc0 csn cxp cms wcel vw cv vw cv vw cv cop csn cc0 csn
      cxp cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cM cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq cM cms
      wcel cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif cms wcel vw cv cM cdm cdm wcel vw cv cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wcel cM cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cms
      eleq1 cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif wceq cM cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv
      vw cv cop csn cc0 csn cxp cif cdm cdm vw cv cM cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq cM cdm cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif dmeq dmeqd eleq2d anbi12d vw cv vw cv cop csn cc0 csn cxp cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq
      vw cv vw cv cop csn cc0 csn cxp cms wcel cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cms wcel vw cv vw cv vw cv
      cop csn cc0 csn cxp cdm cdm wcel vw cv cM cms wcel vw cv cM cdm cdm wcel
      wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wcel vw cv vw cv cop
      csn cc0 csn cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop
      csn cc0 csn cxp cif cms eleq1 vw cv vw cv cop csn cc0 csn cxp cM cms wcel
      vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq vw
      cv vw cv cop csn cc0 csn cxp cdm cdm cM cms wcel vw cv cM cdm cdm wcel wa
      cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm vw cv vw cv vw cv cop csn
      cc0 csn cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn
      cc0 csn cxp cif wceq vw cv vw cv cop csn cc0 csn cxp cdm cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm vw cv vw
      cv cop csn cc0 csn cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw
      cv cop csn cc0 csn cxp cif dmeq dmeqd eleq2d anbi12d vw cv vw cv cop csn
      cc0 csn cxp cms wcel vw cv vw cv vw cv cop csn cc0 csn cxp cdm cdm wcel
      vz vw cv vw cv cop csn cc0 csn cxp vf vw cv csn vw cv vw cv cop csn cc0
      csn cxp cdm cdm vw cv vw cv cop csn cdm vw cv csn vw cv vw cv cop csn cc0
      csn cxp cdm vw cv vw cv cop csn cc0 csn c0 wne vw cv vw cv cop csn cc0
      csn cxp cdm vw cv vw cv cop csn wceq cc0 cc0 cc 0cn elisseti snnz vw cv
      vw cv cop csn cc0 csn dmxp ax-mp dmeqi vw cv vw cv dmsnop eqtr2i vw cv
      csn vw cv csn cxp cc0 csn cxp vw cv vw cv cop csn cc0 csn cxp cme vw cv
      csn vw cv csn cxp vw cv vw cv cop csn cc0 csn vw cv vw cv vw visset vw
      visset xpsn xpeq1i vx vy vz vw cv csn vw cv csn cxp cc0 csn cxp vw cv csn
      vw cv snex vw cv csn vw cv csn cxp cc0 csn vw cv csn vw cv csn cxp cc0
      csn cxp wf cc0 csn cr wss vw cv csn vw cv csn cxp cr vw cv csn vw cv csn
      cxp cc0 csn cxp wf vw cv csn vw cv csn cxp cc0 cc0 cc 0cn elisseti fconst
      cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp vw cv csn vw cv csn cxp
      cc0 csn cr vw cv csn vw cv csn cxp cc0 csn cxp fss mp2an vx cv vw cv csn
      wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy
      cv wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv
      csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb wi vw cv
      csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti oprvconst2 vx cv vw cv
      csn wcel vy cv vw cv csn wcel vx cv vw cv vy cv vx cv vw cv elsni vy cv
      vw cv csn wcel vy cv vw cv vy cv vw cv elsni eqcomd sylan9eq vx cv vw cv
      csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn vw cv csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq pm5.35 mp2an vx cv vw cv csn wcel vy
      cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 caddc co vx cv vy
      cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv vx cv vw cv csn vw cv csn
      cxp cc0 csn cxp co vz cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co
      caddc co cle cc0 cc0 cc0 caddc co cle wbr vx cv vw cv csn wcel vy cv vw
      cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 cc0 caddc co cle cc0 0re
      leidi cc0 0cn addid1i breqtrri a1i vx cv vw cv csn wcel vy cv vw cv csn
      wcel vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vz cv vw
      cv csn wcel vw cv csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti
      oprvconst2 3adant3 vx cv vw cv csn wcel vy cv vw cv csn wcel vz cv vw cv
      csn wcel w3a vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 vz cv
      vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 caddc vx cv vw cv csn
      wcel vz cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp
      co cc0 wceq vy cv vw cv csn wcel vz cv vw cv csn wcel vx cv vw cv csn
      wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vw cv
      csn vw cv csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2 ancoms
      3adant2 vy cv vw cv csn wcel vz cv vw cv csn wcel vz cv vy cv vw cv csn
      vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vw cv csn wcel vz cv vw cv
      csn wcel vy cv vw cv csn wcel vz cv vy cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 wceq vw cv csn vw cv csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d 3brtr4d ismeti eqeltrri vw cv vw cv
      csn wcel vf cv vw cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vf cv vz
      cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vz vw cv csn wrex vf cv vw
      cv vw cv cop csn cc0 csn cxp cca cfv wcel cn vw cv csn vf cv wf wa vf cv
      vz cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vf cv vw cv vw cv vw cv
      cop csn cc0 csn cxp clm cfv wbr vz vw cv vw cv csn vz cv vw cv vf cv vw
      cv vw cv cop csn cc0 csn cxp clm cfv breq2 rcla4ev vw cv vw visset snid
      vf cv vw cv vw cv cop csn cc0 csn cxp cca cfv wcel cn vw cv csn vf cv wf
      wa vf cv cn vw cv csn cxp vw cv vw cv vw cv cop csn cc0 csn cxp clm cfv
      cn vw cv csn vf cv wf vf cv cn vw cv csn cxp wceq vf cv vw cv vw cv cop
      csn cc0 csn cxp cca cfv wcel cn vw cv csn vf cv wf vf cv cn vw cv csn cxp
      wceq cn vw cv vf cv vw visset fconst2 biimpi adantl cn vw cv csn cxp vw
      cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vj cv vk cv cle wbr vw cv
      vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj
      cn wrex vx crp vw cv vw cv cop csn cc0 csn cxp cme wcel vw cv vw cv csn
      wcel cn vw cv csn cn vw cv csn cxp wf cn vw cv csn cxp vw cv vw cv vw cv
      cop csn cc0 csn cxp clm cfv wbr vj cv vk cv cle wbr vw cv vw cv vw cv vw
      cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx crp
      wral wb vw cv csn vw cv csn cxp cc0 csn cxp vw cv vw cv cop csn cc0 csn
      cxp cme vw cv csn vw cv csn cxp vw cv vw cv cop csn cc0 csn vw cv vw cv
      vw visset vw visset xpsn xpeq1i vx vy vz vw cv csn vw cv csn cxp cc0 csn
      cxp vw cv csn vw cv snex vw cv csn vw cv csn cxp cc0 csn vw cv csn vw cv
      csn cxp cc0 csn cxp wf cc0 csn cr wss vw cv csn vw cv csn cxp cr vw cv
      csn vw cv csn cxp cc0 csn cxp wf vw cv csn vw cv csn cxp cc0 cc0 cc 0cn
      elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp vw cv
      csn vw cv csn cxp cc0 csn cr vw cv csn vw cv csn cxp cc0 csn cxp fss
      mp2an vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn
      vw cv csn cxp cc0 csn cxp co cc0 wceq wi vx cv vw cv csn wcel vy cv vw cv
      csn wcel wa vx cv vy cv wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel
      wa vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv wceq wb wi vw cv csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti
      oprvconst2 vx cv vw cv csn wcel vy cv vw cv csn wcel vx cv vw cv vy cv vx
      cv vw cv elsni vy cv vw cv csn wcel vy cv vw cv vy cv vw cv elsni eqcomd
      sylan9eq vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv
      csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq pm5.35 mp2an
      vx cv vw cv csn wcel vy cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0
      cc0 cc0 caddc co vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv
      vx cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv vy cv vw cv csn vw cv
      csn cxp cc0 csn cxp co caddc co cle cc0 cc0 cc0 caddc co cle wbr vx cv vw
      cv csn wcel vy cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 cc0
      caddc co cle cc0 0re leidi cc0 0cn addid1i breqtrri a1i vx cv vw cv csn
      wcel vy cv vw cv csn wcel vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp
      co cc0 wceq vz cv vw cv csn wcel vw cv csn vw cv csn cc0 vx cv vy cv cc0
      cc 0cn elisseti oprvconst2 3adant3 vx cv vw cv csn wcel vy cv vw cv csn
      wcel vz cv vw cv csn wcel w3a vz cv vx cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 vz cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 caddc
      vx cv vw cv csn wcel vz cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn
      cxp cc0 csn cxp co cc0 wceq vy cv vw cv csn wcel vz cv vw cv csn wcel vx
      cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0
      wceq vw cv csn vw cv csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2
      ancoms 3adant2 vy cv vw cv csn wcel vz cv vw cv csn wcel vz cv vy cv vw
      cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vw cv csn wcel vz cv
      vw cv csn wcel vy cv vw cv csn wcel vz cv vy cv vw cv csn vw cv csn cxp
      cc0 csn cxp co cc0 wceq vw cv csn vw cv csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d 3brtr4d ismeti eqeltrri vw cv
      vw visset snid cn vw cv vw visset fconst vx vw cv vw cv vw cv cop csn cc0
      csn cxp vw cv vj vk cn vw cv csn cxp vw cv csn vw cv vw cv cop csn cc0
      csn cxp cdm cdm vw cv vw cv cop csn cdm vw cv csn vw cv vw cv cop csn cc0
      csn cxp cdm vw cv vw cv cop csn cc0 csn c0 wne vw cv vw cv cop csn cc0
      csn cxp cdm vw cv vw cv cop csn wceq cc0 cc0 cc 0cn elisseti snnz vw cv
      vw cv cop csn cc0 csn dmxp ax-mp dmeqi vw cv vw cv dmsnop eqtr2i vk cv cn
      wcel vk cv cn vw cv csn cxp cfv vw cv cn vw cv vk cv vw visset fvconst2
      eqcomd lmbrnns mp3an c1 cn wcel c1 vk cv cle wbr vw cv vw cv vw cv vw cv
      cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr vw
      cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral
      vj cn wrex vx cv crp wcel vj cv vk cv cle wbr vw cv vw cv vw cv vw cv cop
      csn cc0 csn cxp co vx cv clt wbr wi vk cn wral c1 vk cv cle wbr vw cv vw
      cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj c1
      cn vj cv c1 wceq vj cv vk cv cle wbr vw cv vw cv vw cv vw cv cop csn cc0
      csn cxp co vx cv clt wbr wi c1 vk cv cle wbr vw cv vw cv vw cv vw cv cop
      csn cc0 csn cxp co vx cv clt wbr wi vk cn vj cv c1 wceq vj cv vk cv cle
      wbr c1 vk cv cle wbr vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv
      clt wbr vj cv c1 vk cv cle breq1 imbi1d ralbidv rcla4ev 1nn vx cv crp
      wcel c1 vk cv cle wbr vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx
      cv clt wbr wi vk cn vx cv crp wcel c1 vk cv cle wbr vw cv vw cv vw cv vw
      cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cv cn wcel vx cv crp wcel
      vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr c1 vk cv cle
      wbr vx cv crp wcel cc0 vx cv vw cv vw cv vw cv vw cv cop csn cc0 csn cxp
      co clt vx cv rpgt0 vw cv vw cv cop csn cc0 csn cxp cme wcel vw cv vw cv
      csn wcel vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co cc0 wceq vw cv
      csn vw cv csn cxp cc0 csn cxp vw cv vw cv cop csn cc0 csn cxp cme vw cv
      csn vw cv csn cxp vw cv vw cv cop csn cc0 csn vw cv vw cv vw visset vw
      visset xpsn xpeq1i vx vy vz vw cv csn vw cv csn cxp cc0 csn cxp vw cv csn
      vw cv snex vw cv csn vw cv csn cxp cc0 csn vw cv csn vw cv csn cxp cc0
      csn cxp wf cc0 csn cr wss vw cv csn vw cv csn cxp cr vw cv csn vw cv csn
      cxp cc0 csn cxp wf vw cv csn vw cv csn cxp cc0 cc0 cc 0cn elisseti fconst
      cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp vw cv csn vw cv csn cxp
      cc0 csn cr vw cv csn vw cv csn cxp cc0 csn cxp fss mp2an vx cv vw cv csn
      wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy
      cv wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv
      csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb wi vw cv
      csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti oprvconst2 vx cv vw cv
      csn wcel vy cv vw cv csn wcel vx cv vw cv vy cv vx cv vw cv elsni vy cv
      vw cv csn wcel vy cv vw cv vy cv vw cv elsni eqcomd sylan9eq vx cv vw cv
      csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn vw cv csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq pm5.35 mp2an vx cv vw cv csn wcel vy
      cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 caddc co vx cv vy
      cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv vx cv vw cv csn vw cv csn
      cxp cc0 csn cxp co vz cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co
      caddc co cle cc0 cc0 cc0 caddc co cle wbr vx cv vw cv csn wcel vy cv vw
      cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 cc0 caddc co cle cc0 0re
      leidi cc0 0cn addid1i breqtrri a1i vx cv vw cv csn wcel vy cv vw cv csn
      wcel vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vz cv vw
      cv csn wcel vw cv csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti
      oprvconst2 3adant3 vx cv vw cv csn wcel vy cv vw cv csn wcel vz cv vw cv
      csn wcel w3a vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 vz cv
      vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 caddc vx cv vw cv csn
      wcel vz cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp
      co cc0 wceq vy cv vw cv csn wcel vz cv vw cv csn wcel vx cv vw cv csn
      wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vw cv
      csn vw cv csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2 ancoms
      3adant2 vy cv vw cv csn wcel vz cv vw cv csn wcel vz cv vy cv vw cv csn
      vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vw cv csn wcel vz cv vw cv
      csn wcel vy cv vw cv csn wcel vz cv vy cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 wceq vw cv csn vw cv csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d 3brtr4d ismeti eqeltrri vw cv vw
      visset snid vw cv vw cv vw cv cop csn cc0 csn cxp vw cv csn vw cv vw cv
      cop csn cc0 csn cxp cdm cdm vw cv vw cv cop csn cdm vw cv csn vw cv vw cv
      cop csn cc0 csn cxp cdm vw cv vw cv cop csn cc0 csn c0 wne vw cv vw cv
      cop csn cc0 csn cxp cdm vw cv vw cv cop csn wceq cc0 cc0 cc 0cn elisseti
      snnz vw cv vw cv cop csn cc0 csn dmxp ax-mp dmeqi vw cv vw cv dmsnop
      eqtr2i met0 mp2an syl5eqbr a1d adantr r19.21aiva sylancr mprgbir syl6eqbr
      sylancr iscms2i vw cv vw cv vw cv cop csn cdm vw cv vw cv cop csn cc0 csn
      cxp cdm cdm vw cv vw cv csn vw cv vw cv cop csn cdm vw cv vw visset snid
      vw cv vw cv dmsnop eleqtrri vw cv vw cv cop csn cc0 csn cxp cdm vw cv vw
      cv cop csn cc0 csn c0 wne vw cv vw cv cop csn cc0 csn cxp cdm vw cv vw cv
      cop csn wceq cc0 cc0 cc 0cn elisseti snnz vw cv vw cv cop csn cc0 csn
      dmxp ax-mp dmeqi eleqtrri pm3.2i elimhyp pm3.26i cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cms wcel vw cv cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm wcel cM cms wcel vw cv cM cdm cdm wcel wa cM cms wcel vw cv cM cdm
      cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cms wcel vw cv cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm
      cdm wcel wa vw cv vw cv cop csn cc0 csn cxp cms wcel vw cv vw cv vw cv
      cop csn cc0 csn cxp cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cM
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif wceq cM cms wcel cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif cms wcel vw cv cM cdm cdm wcel vw cv cM cms wcel
      vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm
      wcel cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif cms eleq1 cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw
      cv cop csn cc0 csn cxp cif wceq cM cdm cdm cM cms wcel vw cv cM cdm cdm
      wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm vw cv cM cM cms
      wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif wceq
      cM cdm cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif cdm cM cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv
      cop csn cc0 csn cxp cif dmeq dmeqd eleq2d anbi12d vw cv vw cv cop csn cc0
      csn cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0
      csn cxp cif wceq vw cv vw cv cop csn cc0 csn cxp cms wcel cM cms wcel vw
      cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cms wcel vw
      cv vw cv vw cv cop csn cc0 csn cxp cdm cdm wcel vw cv cM cms wcel vw cv
      cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm wcel vw
      cv vw cv cop csn cc0 csn cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw
      cv vw cv cop csn cc0 csn cxp cif cms eleq1 vw cv vw cv cop csn cc0 csn
      cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn
      cxp cif wceq vw cv vw cv cop csn cc0 csn cxp cdm cdm cM cms wcel vw cv cM
      cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp cif cdm cdm vw cv vw
      cv vw cv cop csn cc0 csn cxp cM cms wcel vw cv cM cdm cdm wcel wa cM vw
      cv vw cv cop csn cc0 csn cxp cif wceq vw cv vw cv cop csn cc0 csn cxp cdm
      cM cms wcel vw cv cM cdm cdm wcel wa cM vw cv vw cv cop csn cc0 csn cxp
      cif cdm vw cv vw cv cop csn cc0 csn cxp cM cms wcel vw cv cM cdm cdm wcel
      wa cM vw cv vw cv cop csn cc0 csn cxp cif dmeq dmeqd eleq2d anbi12d vw cv
      vw cv cop csn cc0 csn cxp cms wcel vw cv vw cv vw cv cop csn cc0 csn cxp
      cdm cdm wcel vz vw cv vw cv cop csn cc0 csn cxp vf vw cv csn vw cv vw cv
      cop csn cc0 csn cxp cdm cdm vw cv vw cv cop csn cdm vw cv csn vw cv vw cv
      cop csn cc0 csn cxp cdm vw cv vw cv cop csn cc0 csn c0 wne vw cv vw cv
      cop csn cc0 csn cxp cdm vw cv vw cv cop csn wceq cc0 cc0 cc 0cn elisseti
      snnz vw cv vw cv cop csn cc0 csn dmxp ax-mp dmeqi vw cv vw cv dmsnop
      eqtr2i vw cv csn vw cv csn cxp cc0 csn cxp vw cv vw cv cop csn cc0 csn
      cxp cme vw cv csn vw cv csn cxp vw cv vw cv cop csn cc0 csn vw cv vw cv
      vw visset vw visset xpsn xpeq1i vx vy vz vw cv csn vw cv csn cxp cc0 csn
      cxp vw cv csn vw cv snex vw cv csn vw cv csn cxp cc0 csn vw cv csn vw cv
      csn cxp cc0 csn cxp wf cc0 csn cr wss vw cv csn vw cv csn cxp cr vw cv
      csn vw cv csn cxp cc0 csn cxp wf vw cv csn vw cv csn cxp cc0 cc0 cc 0cn
      elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp vw cv
      csn vw cv csn cxp cc0 csn cr vw cv csn vw cv csn cxp cc0 csn cxp fss
      mp2an vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn
      vw cv csn cxp cc0 csn cxp co cc0 wceq wi vx cv vw cv csn wcel vy cv vw cv
      csn wcel wa vx cv vy cv wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel
      wa vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv wceq wb wi vw cv csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti
      oprvconst2 vx cv vw cv csn wcel vy cv vw cv csn wcel vx cv vw cv vy cv vx
      cv vw cv elsni vy cv vw cv csn wcel vy cv vw cv vy cv vw cv elsni eqcomd
      sylan9eq vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv
      csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq pm5.35 mp2an
      vx cv vw cv csn wcel vy cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0
      cc0 cc0 caddc co vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv
      vx cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv vy cv vw cv csn vw cv
      csn cxp cc0 csn cxp co caddc co cle cc0 cc0 cc0 caddc co cle wbr vx cv vw
      cv csn wcel vy cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 cc0
      caddc co cle cc0 0re leidi cc0 0cn addid1i breqtrri a1i vx cv vw cv csn
      wcel vy cv vw cv csn wcel vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp
      co cc0 wceq vz cv vw cv csn wcel vw cv csn vw cv csn cc0 vx cv vy cv cc0
      cc 0cn elisseti oprvconst2 3adant3 vx cv vw cv csn wcel vy cv vw cv csn
      wcel vz cv vw cv csn wcel w3a vz cv vx cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 vz cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 caddc
      vx cv vw cv csn wcel vz cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn
      cxp cc0 csn cxp co cc0 wceq vy cv vw cv csn wcel vz cv vw cv csn wcel vx
      cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0
      wceq vw cv csn vw cv csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2
      ancoms 3adant2 vy cv vw cv csn wcel vz cv vw cv csn wcel vz cv vy cv vw
      cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vw cv csn wcel vz cv
      vw cv csn wcel vy cv vw cv csn wcel vz cv vy cv vw cv csn vw cv csn cxp
      cc0 csn cxp co cc0 wceq vw cv csn vw cv csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d 3brtr4d ismeti eqeltrri vw cv
      vw cv csn wcel vf cv vw cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vf
      cv vz cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vz vw cv csn wrex vf
      cv vw cv vw cv cop csn cc0 csn cxp cca cfv wcel cn vw cv csn vf cv wf wa
      vf cv vz cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vf cv vw cv vw cv
      vw cv cop csn cc0 csn cxp clm cfv wbr vz vw cv vw cv csn vz cv vw cv vf
      cv vw cv vw cv cop csn cc0 csn cxp clm cfv breq2 rcla4ev vw cv vw visset
      snid vf cv vw cv vw cv cop csn cc0 csn cxp cca cfv wcel cn vw cv csn vf
      cv wf wa vf cv cn vw cv csn cxp vw cv vw cv vw cv cop csn cc0 csn cxp clm
      cfv cn vw cv csn vf cv wf vf cv cn vw cv csn cxp wceq vf cv vw cv vw cv
      cop csn cc0 csn cxp cca cfv wcel cn vw cv csn vf cv wf vf cv cn vw cv csn
      cxp wceq cn vw cv vf cv vw visset fconst2 biimpi adantl cn vw cv csn cxp
      vw cv vw cv vw cv cop csn cc0 csn cxp clm cfv wbr vj cv vk cv cle wbr vw
      cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral
      vj cn wrex vx crp vw cv vw cv cop csn cc0 csn cxp cme wcel vw cv vw cv
      csn wcel cn vw cv csn cn vw cv csn cxp wf cn vw cv csn cxp vw cv vw cv vw
      cv cop csn cc0 csn cxp clm cfv wbr vj cv vk cv cle wbr vw cv vw cv vw cv
      vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cn wrex vx
      crp wral wb vw cv csn vw cv csn cxp cc0 csn cxp vw cv vw cv cop csn cc0
      csn cxp cme vw cv csn vw cv csn cxp vw cv vw cv cop csn cc0 csn vw cv vw
      cv vw visset vw visset xpsn xpeq1i vx vy vz vw cv csn vw cv csn cxp cc0
      csn cxp vw cv csn vw cv snex vw cv csn vw cv csn cxp cc0 csn vw cv csn vw
      cv csn cxp cc0 csn cxp wf cc0 csn cr wss vw cv csn vw cv csn cxp cr vw cv
      csn vw cv csn cxp cc0 csn cxp wf vw cv csn vw cv csn cxp cc0 cc0 cc 0cn
      elisseti fconst cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp vw cv
      csn vw cv csn cxp cc0 csn cr vw cv csn vw cv csn cxp cc0 csn cxp fss
      mp2an vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn
      vw cv csn cxp cc0 csn cxp co cc0 wceq wi vx cv vw cv csn wcel vy cv vw cv
      csn wcel wa vx cv vy cv wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel
      wa vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy
      cv wceq wb wi vw cv csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti
      oprvconst2 vx cv vw cv csn wcel vy cv vw cv csn wcel vx cv vw cv vy cv vx
      cv vw cv elsni vy cv vw cv csn wcel vy cv vw cv vy cv vw cv elsni eqcomd
      sylan9eq vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv
      csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq pm5.35 mp2an
      vx cv vw cv csn wcel vy cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0
      cc0 cc0 caddc co vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv
      vx cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv vy cv vw cv csn vw cv
      csn cxp cc0 csn cxp co caddc co cle cc0 cc0 cc0 caddc co cle wbr vx cv vw
      cv csn wcel vy cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 cc0
      caddc co cle cc0 0re leidi cc0 0cn addid1i breqtrri a1i vx cv vw cv csn
      wcel vy cv vw cv csn wcel vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp
      co cc0 wceq vz cv vw cv csn wcel vw cv csn vw cv csn cc0 vx cv vy cv cc0
      cc 0cn elisseti oprvconst2 3adant3 vx cv vw cv csn wcel vy cv vw cv csn
      wcel vz cv vw cv csn wcel w3a vz cv vx cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 vz cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 caddc
      vx cv vw cv csn wcel vz cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn
      cxp cc0 csn cxp co cc0 wceq vy cv vw cv csn wcel vz cv vw cv csn wcel vx
      cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0
      wceq vw cv csn vw cv csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2
      ancoms 3adant2 vy cv vw cv csn wcel vz cv vw cv csn wcel vz cv vy cv vw
      cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vw cv csn wcel vz cv
      vw cv csn wcel vy cv vw cv csn wcel vz cv vy cv vw cv csn vw cv csn cxp
      cc0 csn cxp co cc0 wceq vw cv csn vw cv csn cc0 vz cv vy cv cc0 cc 0cn
      elisseti oprvconst2 ancoms 3adant1 opreq12d 3brtr4d ismeti eqeltrri vw cv
      vw visset snid cn vw cv vw visset fconst vx vw cv vw cv vw cv cop csn cc0
      csn cxp vw cv vj vk cn vw cv csn cxp vw cv csn vw cv vw cv cop csn cc0
      csn cxp cdm cdm vw cv vw cv cop csn cdm vw cv csn vw cv vw cv cop csn cc0
      csn cxp cdm vw cv vw cv cop csn cc0 csn c0 wne vw cv vw cv cop csn cc0
      csn cxp cdm vw cv vw cv cop csn wceq cc0 cc0 cc 0cn elisseti snnz vw cv
      vw cv cop csn cc0 csn dmxp ax-mp dmeqi vw cv vw cv dmsnop eqtr2i vk cv cn
      wcel vk cv cn vw cv csn cxp cfv vw cv cn vw cv vk cv vw visset fvconst2
      eqcomd lmbrnns mp3an c1 cn wcel c1 vk cv cle wbr vw cv vw cv vw cv vw cv
      cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj cv vk cv cle wbr vw
      cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral
      vj cn wrex vx cv crp wcel vj cv vk cv cle wbr vw cv vw cv vw cv vw cv cop
      csn cc0 csn cxp co vx cv clt wbr wi vk cn wral c1 vk cv cle wbr vw cv vw
      cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cn wral vj c1
      cn vj cv c1 wceq vj cv vk cv cle wbr vw cv vw cv vw cv vw cv cop csn cc0
      csn cxp co vx cv clt wbr wi c1 vk cv cle wbr vw cv vw cv vw cv vw cv cop
      csn cc0 csn cxp co vx cv clt wbr wi vk cn vj cv c1 wceq vj cv vk cv cle
      wbr c1 vk cv cle wbr vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv
      clt wbr vj cv c1 vk cv cle breq1 imbi1d ralbidv rcla4ev 1nn vx cv crp
      wcel c1 vk cv cle wbr vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx
      cv clt wbr wi vk cn vx cv crp wcel c1 vk cv cle wbr vw cv vw cv vw cv vw
      cv cop csn cc0 csn cxp co vx cv clt wbr wi vk cv cn wcel vx cv crp wcel
      vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co vx cv clt wbr c1 vk cv cle
      wbr vx cv crp wcel cc0 vx cv vw cv vw cv vw cv vw cv cop csn cc0 csn cxp
      co clt vx cv rpgt0 vw cv vw cv cop csn cc0 csn cxp cme wcel vw cv vw cv
      csn wcel vw cv vw cv vw cv vw cv cop csn cc0 csn cxp co cc0 wceq vw cv
      csn vw cv csn cxp cc0 csn cxp vw cv vw cv cop csn cc0 csn cxp cme vw cv
      csn vw cv csn cxp vw cv vw cv cop csn cc0 csn vw cv vw cv vw visset vw
      visset xpsn xpeq1i vx vy vz vw cv csn vw cv csn cxp cc0 csn cxp vw cv csn
      vw cv snex vw cv csn vw cv csn cxp cc0 csn vw cv csn vw cv csn cxp cc0
      csn cxp wf cc0 csn cr wss vw cv csn vw cv csn cxp cr vw cv csn vw cv csn
      cxp cc0 csn cxp wf vw cv csn vw cv csn cxp cc0 cc0 cc 0cn elisseti fconst
      cc0 cr wcel cc0 csn cr wss 0re cc0 cr snssi ax-mp vw cv csn vw cv csn cxp
      cc0 csn cr vw cv csn vw cv csn cxp cc0 csn cxp fss mp2an vx cv vw cv csn
      wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy
      cv wceq wi vx cv vw cv csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv
      csn vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vy cv wceq wb wi vw cv
      csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti oprvconst2 vx cv vw cv
      csn wcel vy cv vw cv csn wcel vx cv vw cv vy cv vx cv vw cv elsni vy cv
      vw cv csn wcel vy cv vw cv vy cv vw cv elsni eqcomd sylan9eq vx cv vw cv
      csn wcel vy cv vw cv csn wcel wa vx cv vy cv vw cv csn vw cv csn cxp cc0
      csn cxp co cc0 wceq vx cv vy cv wceq pm5.35 mp2an vx cv vw cv csn wcel vy
      cv vw cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 caddc co vx cv vy
      cv vw cv csn vw cv csn cxp cc0 csn cxp co vz cv vx cv vw cv csn vw cv csn
      cxp cc0 csn cxp co vz cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co
      caddc co cle cc0 cc0 cc0 caddc co cle wbr vx cv vw cv csn wcel vy cv vw
      cv csn wcel vz cv vw cv csn wcel w3a cc0 cc0 cc0 cc0 caddc co cle cc0 0re
      leidi cc0 0cn addid1i breqtrri a1i vx cv vw cv csn wcel vy cv vw cv csn
      wcel vx cv vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vz cv vw
      cv csn wcel vw cv csn vw cv csn cc0 vx cv vy cv cc0 cc 0cn elisseti
      oprvconst2 3adant3 vx cv vw cv csn wcel vy cv vw cv csn wcel vz cv vw cv
      csn wcel w3a vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 vz cv
      vy cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 caddc vx cv vw cv csn
      wcel vz cv vw cv csn wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp
      co cc0 wceq vy cv vw cv csn wcel vz cv vw cv csn wcel vx cv vw cv csn
      wcel vz cv vx cv vw cv csn vw cv csn cxp cc0 csn cxp co cc0 wceq vw cv
      csn vw cv csn cc0 vz cv vx cv cc0 cc 0cn elisseti oprvconst2 ancoms
      3adant2 vy cv vw cv csn wcel vz cv vw cv csn wcel vz cv vy cv vw cv csn
      vw cv csn cxp cc0 csn cxp co cc0 wceq vx cv vw cv csn wcel vz cv vw cv
      csn wcel vy cv vw cv csn wcel vz cv vy cv vw cv csn vw cv csn cxp cc0 csn
      cxp co cc0 wceq vw cv csn vw cv csn cc0 vz cv vy cv cc0 cc 0cn elisseti
      oprvconst2 ancoms 3adant1 opreq12d 3brtr4d ismeti eqeltrri vw cv vw
      visset snid vw cv vw cv vw cv cop csn cc0 csn cxp vw cv csn vw cv vw cv
      cop csn cc0 csn cxp cdm cdm vw cv vw cv cop csn cdm vw cv csn vw cv vw cv
      cop csn cc0 csn cxp cdm vw cv vw cv cop csn cc0 csn c0 wne vw cv vw cv
      cop csn cc0 csn cxp cdm vw cv vw cv cop csn wceq cc0 cc0 cc 0cn elisseti
      snnz vw cv vw cv cop csn cc0 csn dmxp ax-mp dmeqi vw cv vw cv dmsnop
      eqtr2i met0 mp2an syl5eqbr a1d adantr r19.21aiva sylancr mprgbir syl6eqbr
      sylancr iscms2i vw cv vw cv vw cv cop csn cdm vw cv vw cv cop csn cc0 csn
      cxp cdm cdm vw cv vw cv csn vw cv vw cv cop csn cdm vw cv vw visset snid
      vw cv vw cv dmsnop eleqtrri vw cv vw cv cop csn cc0 csn cxp cdm vw cv vw
      cv cop csn cc0 csn c0 wne vw cv vw cv cop csn cc0 csn cxp cdm vw cv vw cv
      cop csn wceq cc0 cc0 cc 0cn elisseti snnz vw cv vw cv cop csn cc0 csn
      dmxp ax-mp dmeqi eleqtrri pm3.2i elimhyp pm3.27i cK crp wcel cK c1 clt
      wbr wa cK c1 c2 cdiv co cif crp wcel cK crp wcel cK c1 clt wbr wa cK c1
      c2 cdiv co cif c1 clt wbr cK crp wcel cK c1 clt wbr wa cK crp wcel cK c1
      clt wbr wa cK c1 c2 cdiv co cif crp wcel cK crp wcel cK c1 clt wbr wa cK
      c1 c2 cdiv co cif c1 clt wbr wa c1 c2 cdiv co crp wcel c1 c2 cdiv co c1
      clt wbr wa cK c1 c2 cdiv co cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv
      co cif wceq cK crp wcel cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif
      crp wcel cK c1 clt wbr cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif
      c1 clt wbr cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif crp eleq1
      cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif c1 clt breq1 anbi12d
      c1 c2 cdiv co cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif wceq c1
      c2 cdiv co crp wcel cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif crp
      wcel c1 c2 cdiv co c1 clt wbr cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv
      co cif c1 clt wbr c1 c2 cdiv co cK crp wcel cK c1 clt wbr wa cK c1 c2
      cdiv co cif crp eleq1 c1 c2 cdiv co cK crp wcel cK c1 clt wbr wa cK c1 c2
      cdiv co cif c1 clt breq1 anbi12d c1 c2 cdiv co crp wcel c1 c2 cdiv co c1
      clt wbr c2 crp wcel c1 c2 cdiv co crp wcel c2 2re 2pos elrpii c2 rpreccl
      ax-mp halflt1 pm3.2i elimhyp pm3.26i cK crp wcel cK c1 clt wbr wa cK c1
      c2 cdiv co cif crp wcel cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif
      c1 clt wbr cK crp wcel cK c1 clt wbr wa cK crp wcel cK c1 clt wbr wa cK
      c1 c2 cdiv co cif crp wcel cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co
      cif c1 clt wbr wa c1 c2 cdiv co crp wcel c1 c2 cdiv co c1 clt wbr wa cK
      c1 c2 cdiv co cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif wceq
      cK crp wcel cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif crp wcel cK
      c1 clt wbr cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif c1 clt wbr
      cK cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif crp eleq1 cK cK crp
      wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif c1 clt breq1 anbi12d c1 c2
      cdiv co cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif wceq c1 c2 cdiv
      co crp wcel cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif crp wcel c1
      c2 cdiv co c1 clt wbr cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co cif
      c1 clt wbr c1 c2 cdiv co cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co
      cif crp eleq1 c1 c2 cdiv co cK crp wcel cK c1 clt wbr wa cK c1 c2 cdiv co
      cif c1 clt breq1 anbi12d c1 c2 cdiv co crp wcel c1 c2 cdiv co c1 clt wbr
      c2 crp wcel c1 c2 cdiv co crp wcel c2 2re 2pos elrpii c2 rpreccl ax-mp
      halflt1 pm3.2i elimhyp pm3.27i bfplem11 dedth2h exp31 19.23adv cX c0 wne
      cM cdm cdm c0 wne vw cv cM cdm cdm wcel vw wex cX cM cdm cdm c0 bfp.1
      neeq1i vw cM cdm cdm n0 bitri syl5ib imp31 cX cX cF wf cM cdm cdm cM cdm
      cdm cF wf vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
      cle wbr vy cX wral vx cX wral vx cv cF cfv vy cv cF cfv cM co cK vx cv vy
      cv cM co cmul co cle wbr vy cM cdm cdm wral vx cM cdm cdm wral cX cX cF
      wf cM cdm cdm cX cF wf cM cdm cdm cM cdm cdm cF wf cX cM cdm cdm wceq cX
      cX cF wf cM cdm cdm cX cF wf wb bfp.1 cX cM cdm cdm cX cF feq2 ax-mp cX
      cM cdm cdm wceq cM cdm cdm cX cF wf cM cdm cdm cM cdm cdm cF wf wb bfp.1
      cX cM cdm cdm cM cdm cdm cF feq3 ax-mp bitri vx cv cF cfv vy cv cF cfv cM
      co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX wral vx cv cF
      cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx
      cM cdm cdm wral vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul
      co cle wbr vy cM cdm cdm wral vx cM cdm cdm wral cX cM cdm cdm wceq vx cv
      cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
      vx cX wral vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
      cle wbr vy cX wral vx cM cdm cdm wral wb bfp.1 vx cv cF cfv vy cv cF cfv
      cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral vx cX cM cdm cdm
      raleq1 ax-mp vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co
      cle wbr vy cX wral vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co
      cmul co cle wbr vy cM cdm cdm wral vx cM cdm cdm cX cM cdm cdm wceq vx cv
      cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy cX wral
      vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv cM co cmul co cle wbr vy
      cM cdm cdm wral wb bfp.1 vx cv cF cfv vy cv cF cfv cM co cK vx cv vy cv
      cM co cmul co cle wbr vy cX cM cdm cdm raleq1 ax-mp ralbii bitri anbi12i
      cX cM cdm cdm wceq vz cv cF cfv vz cv wceq vz cX wreu vz cv cF cfv vz cv
      wceq vz cM cdm cdm wreu wb bfp.1 vz cv cF cfv vz cv wceq vz cX cM cdm cdm
      reueq1 ax-mp 3imtr4g 3impia $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Euclidean space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The real numbers are a complete metric space. $)
    recms $p |- ( ( abs o. - ) |` ( RR X. RR ) ) e. CMet $=
      cabs cmin ccom cr cr cxp cres cms wcel cr cabs cmin ccom copn cfv ccld
      cfv wcel cr cabs cmin ccom copn cfv ccld cfv wcel cc cr cdif cabs cmin
      ccom copn cfv wcel cc cr cdif cabs cmin ccom copn cfv wcel cc cr cdif cc
      wss cc0 vy cv clt wbr vx cv vy cv cabs cmin ccom cbl cfv co cc cr cdif
      wss wa vy cr wrex vx cc cr cdif wral cabs cmin ccom cme wcel cc cr cdif
      cabs cmin ccom copn cfv wcel cc cr cdif cc wss cc0 vy cv clt wbr vx cv vy
      cv cabs cmin ccom cbl cfv co cc cr cdif wss wa vy cr wrex vx cc cr cdif
      wral wa wb cabs cmin ccom cabs cmin ccom eqid cnmet vx vy cc cr cdif cabs
      cmin ccom cabs cmin ccom copn cfv cc cabs cmin ccom cabs cmin ccom eqid
      cnmetba cabs cmin ccom copn cfv eqid isopn4 ax-mp cc cr difss cc0 vy cv
      clt wbr vx cv vy cv cabs cmin ccom cbl cfv co cc cr cdif wss wa vy cr
      wrex vx cc cr cdif vx cv cim cfv cabs cfv cr wcel cc0 vx cv cim cfv cabs
      cfv clt wbr vx cv vx cv cim cfv cabs cfv cabs cmin ccom cbl cfv co cc cr
      cdif wss cc0 vy cv clt wbr vx cv vy cv cabs cmin ccom cbl cfv co cc cr
      cdif wss wa vy cr wrex vx cv cc cr cdif wcel vx cv cc cr cdif wcel vx cv
      cc wcel vx cv cim cfv cr wcel vx cv cim cfv cabs cfv cr wcel vx cv cc cr
      eldifi vx cv imcl vx cv cim cfv cr wcel vx cv cim cfv cc wcel vx cv cim
      cfv cabs cfv cr wcel vx cv cim cfv recn vx cv cim cfv abscl syl 3syl vx
      cv cc cr cdif wcel cc0 vx cv cim cfv cabs cfv clt wbr cc0 vx cv cim cfv
      cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne wa vx cv cc cr cdif wcel
      cc0 vx cv cim cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne vx cv
      cc cr cdif wcel vx cv cim cfv cc wcel cc0 vx cv cim cfv cabs cfv cle wbr
      vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv
      cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv recn 3syl vx cv cim
      cfv absge0 syl vx cv cc cr cdif wcel vx cv cim cfv cabs cfv cc0 wne vx cv
      cim cfv cc0 wne vx cv cc cr cdif wcel vx cv cr wcel wn vx cv cim cfv cc0
      wne vx cv cc cr eldifn vx cv cc cr cdif wcel vx cv cr wcel vx cv cim cfv
      cc0 vx cv cc cr cdif wcel vx cv cc wcel vx cv cr wcel vx cv cim cfv cc0
      wceq wb vx cv cc cr eldifi vx cv reim0b syl necon3bbid mpbid vx cv cc cr
      cdif wcel vx cv cim cfv cabs cfv cc0 vx cv cim cfv cc0 vx cv cc cr cdif
      wcel vx cv cim cfv cc wcel vx cv cim cfv cabs cfv cc0 wceq vx cv cim cfv
      cc0 wceq wb vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx
      cv cim cfv cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv recn 3syl
      vx cv cim cfv abs00 syl necon3bid mpbird jca cc0 cr wcel vx cv cim cfv
      cabs cfv cr wcel cc0 vx cv cim cfv cabs cfv clt wbr cc0 vx cv cim cfv
      cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne wa wb vx cv cc cr cdif
      wcel cc0 vx cv cim cfv cabs cfv ltlen 0re vx cv cc cr cdif wcel vx cv cc
      wcel vx cv cim cfv cr wcel vx cv cim cfv cabs cfv cr wcel vx cv cc cr
      eldifi vx cv imcl vx cv cim cfv cr wcel vx cv cim cfv cc wcel vx cv cim
      cfv cabs cfv cr wcel vx cv cim cfv recn vx cv cim cfv abscl syl 3syl
      sylancr mpbird vx cv cc cr cdif wcel vy vx cv vx cv cim cfv cabs cfv cabs
      cmin ccom cbl cfv co cc cr cdif vx cv cc cr cdif wcel vy cv vx cv vx cv
      cim cfv cabs cfv cabs cmin ccom cbl cfv co wcel vy cv cc wcel vy cv cr
      wcel wn wa vy cv cc cr cdif wcel vx cv cc cr cdif wcel vy cv vx cv vx cv
      cim cfv cabs cfv cabs cmin ccom cbl cfv co wcel vy cv cc wcel vy cv cr
      wcel wn vx cv cc cr cdif wcel vx cv vx cv cim cfv cabs cfv cabs cmin ccom
      cbl cfv co cc vy cv cabs cmin ccom cme wcel vx cv cc wcel vx cv cim cfv
      cabs cfv cr wcel cc0 vx cv cim cfv cabs cfv clt wbr vx cv vx cv cim cfv
      cabs cfv cabs cmin ccom cbl cfv co cc wss vx cv cc cr cdif wcel cabs cmin
      ccom vx cv vx cv cim cfv cabs cfv cc cabs cmin ccom cabs cmin ccom eqid
      cnmetba blssm cabs cmin ccom cme wcel vx cv cc cr cdif wcel cabs cmin
      ccom cabs cmin ccom eqid cnmet a1i vx cv cc cr eldifi vx cv cc cr cdif
      wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv cabs cfv cr wcel
      vx cv cc cr eldifi vx cv imcl vx cv cim cfv cr wcel vx cv cim cfv cc wcel
      vx cv cim cfv cabs cfv cr wcel vx cv cim cfv recn vx cv cim cfv abscl syl
      3syl vx cv cc cr cdif wcel cc0 vx cv cim cfv cabs cfv clt wbr cc0 vx cv
      cim cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne wa vx cv cc cr
      cdif wcel cc0 vx cv cim cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0
      wne vx cv cc cr cdif wcel vx cv cim cfv cc wcel cc0 vx cv cim cfv cabs
      cfv cle wbr vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx
      cv cim cfv cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv recn 3syl
      vx cv cim cfv absge0 syl vx cv cc cr cdif wcel vx cv cim cfv cabs cfv cc0
      wne vx cv cim cfv cc0 wne vx cv cc cr cdif wcel vx cv cr wcel wn vx cv
      cim cfv cc0 wne vx cv cc cr eldifn vx cv cc cr cdif wcel vx cv cr wcel vx
      cv cim cfv cc0 vx cv cc cr cdif wcel vx cv cc wcel vx cv cr wcel vx cv
      cim cfv cc0 wceq wb vx cv cc cr eldifi vx cv reim0b syl necon3bbid mpbid
      vx cv cc cr cdif wcel vx cv cim cfv cabs cfv cc0 vx cv cim cfv cc0 vx cv
      cc cr cdif wcel vx cv cim cfv cc wcel vx cv cim cfv cabs cfv cc0 wceq vx
      cv cim cfv cc0 wceq wb vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv
      cr wcel vx cv cim cfv cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv
      recn 3syl vx cv cim cfv abs00 syl necon3bid mpbird jca cc0 cr wcel vx cv
      cim cfv cabs cfv cr wcel cc0 vx cv cim cfv cabs cfv clt wbr cc0 vx cv cim
      cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne wa wb vx cv cc cr
      cdif wcel cc0 vx cv cim cfv cabs cfv ltlen 0re vx cv cc cr cdif wcel vx
      cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv cabs cfv cr wcel vx cv cc
      cr eldifi vx cv imcl vx cv cim cfv cr wcel vx cv cim cfv cc wcel vx cv
      cim cfv cabs cfv cr wcel vx cv cim cfv recn vx cv cim cfv abscl syl 3syl
      sylancr mpbird syl2anc sseld vx cv cc cr cdif wcel vy cv vx cv vx cv cim
      cfv cabs cfv cabs cmin ccom cbl cfv co wcel vy cv cc wcel vx cv vy cv
      cabs cmin ccom co vx cv cim cfv cabs cfv clt wbr wa vy cv cr wcel wn cabs
      cmin ccom cme wcel vx cv cc wcel vx cv cim cfv cabs cfv cr wcel cc0 vx cv
      cim cfv cabs cfv clt wbr vy cv vx cv vx cv cim cfv cabs cfv cabs cmin
      ccom cbl cfv co wcel vy cv cc wcel vx cv vy cv cabs cmin ccom co vx cv
      cim cfv cabs cfv clt wbr wa wb vx cv cc cr cdif wcel vy cv cabs cmin ccom
      vx cv vx cv cim cfv cabs cfv cc cabs cmin ccom cabs cmin ccom eqid
      cnmetba elbl cabs cmin ccom cme wcel vx cv cc cr cdif wcel cabs cmin ccom
      cabs cmin ccom eqid cnmet a1i vx cv cc cr eldifi vx cv cc cr cdif wcel vx
      cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv cabs cfv cr wcel vx cv cc
      cr eldifi vx cv imcl vx cv cim cfv cr wcel vx cv cim cfv cc wcel vx cv
      cim cfv cabs cfv cr wcel vx cv cim cfv recn vx cv cim cfv abscl syl 3syl
      vx cv cc cr cdif wcel cc0 vx cv cim cfv cabs cfv clt wbr cc0 vx cv cim
      cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne wa vx cv cc cr cdif
      wcel cc0 vx cv cim cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne vx
      cv cc cr cdif wcel vx cv cim cfv cc wcel cc0 vx cv cim cfv cabs cfv cle
      wbr vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv cim
      cfv cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv recn 3syl vx cv
      cim cfv absge0 syl vx cv cc cr cdif wcel vx cv cim cfv cabs cfv cc0 wne
      vx cv cim cfv cc0 wne vx cv cc cr cdif wcel vx cv cr wcel wn vx cv cim
      cfv cc0 wne vx cv cc cr eldifn vx cv cc cr cdif wcel vx cv cr wcel vx cv
      cim cfv cc0 vx cv cc cr cdif wcel vx cv cc wcel vx cv cr wcel vx cv cim
      cfv cc0 wceq wb vx cv cc cr eldifi vx cv reim0b syl necon3bbid mpbid vx
      cv cc cr cdif wcel vx cv cim cfv cabs cfv cc0 vx cv cim cfv cc0 vx cv cc
      cr cdif wcel vx cv cim cfv cc wcel vx cv cim cfv cabs cfv cc0 wceq vx cv
      cim cfv cc0 wceq wb vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr
      wcel vx cv cim cfv cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv
      recn 3syl vx cv cim cfv abs00 syl necon3bid mpbird jca cc0 cr wcel vx cv
      cim cfv cabs cfv cr wcel cc0 vx cv cim cfv cabs cfv clt wbr cc0 vx cv cim
      cfv cabs cfv cle wbr vx cv cim cfv cabs cfv cc0 wne wa wb vx cv cc cr
      cdif wcel cc0 vx cv cim cfv cabs cfv ltlen 0re vx cv cc cr cdif wcel vx
      cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv cabs cfv cr wcel vx cv cc
      cr eldifi vx cv imcl vx cv cim cfv cr wcel vx cv cim cfv cc wcel vx cv
      cim cfv cabs cfv cr wcel vx cv cim cfv recn vx cv cim cfv abscl syl 3syl
      sylancr mpbird syl2anc vx cv cc cr cdif wcel vx cv vy cv cabs cmin ccom
      co vx cv cim cfv cabs cfv clt wbr vy cv cr wcel wn vy cv cc wcel vx cv cc
      cr cdif wcel vy cv cr wcel vx cv vy cv cabs cmin ccom co vx cv cim cfv
      cabs cfv clt wbr vx cv cc cr cdif wcel vy cv cr wcel vx cv vy cv cabs
      cmin ccom co vx cv cim cfv cabs cfv clt wbr wn vx cv cc cr cdif wcel vy
      cv cr wcel wa vx cv cim cfv cabs cfv vx cv vy cv cmin co cabs cfv cle wbr
      vx cv vy cv cabs cmin ccom co vx cv cim cfv cabs cfv clt wbr wn vx cv cc
      cr cdif wcel vy cv cr wcel wa vx cv cim cfv cabs cfv vx cv vy cv cmin co
      cabs cfv cle wbr vx cv cim cfv cabs cfv c2 cexp co vx cv vy cv cmin co
      cabs cfv c2 cexp co cle wbr vx cv cc cr cdif wcel vy cv cr wcel wa vx cv
      cim cfv c2 cexp co vx cv vy cv cmin co cre cfv c2 cexp co vx cv cim cfv
      c2 cexp co caddc co vx cv cim cfv cabs cfv c2 cexp co vx cv vy cv cmin co
      cabs cfv c2 cexp co cle vx cv cc cr cdif wcel vy cv cr wcel wa cc0 vx cv
      vy cv cmin co cre cfv c2 cexp co cle wbr vx cv cim cfv c2 cexp co vx cv
      vy cv cmin co cre cfv c2 cexp co vx cv cim cfv c2 cexp co caddc co cle
      wbr vx cv cc cr cdif wcel vy cv cr wcel wa vx cv vy cv cmin co cc wcel vx
      cv vy cv cmin co cre cfv cr wcel cc0 vx cv vy cv cmin co cre cfv c2 cexp
      co cle wbr vx cv cc wcel vy cv cc wcel vx cv vy cv cmin co cc wcel vx cv
      cc cr cdif wcel vy cv cr wcel vx cv vy cv subcl vx cv cc cr eldifi vy cv
      recn syl2an vx cv vy cv cmin co recl vx cv vy cv cmin co cre cfv sqge0
      3syl vx cv cim cfv c2 cexp co cr wcel vx cv vy cv cmin co cre cfv c2 cexp
      co cr wcel cc0 vx cv vy cv cmin co cre cfv c2 cexp co cle wbr vx cv cim
      cfv c2 cexp co vx cv vy cv cmin co cre cfv c2 cexp co vx cv cim cfv c2
      cexp co caddc co cle wbr wb vx cv cc cr cdif wcel vy cv cr wcel wa vx cv
      cim cfv c2 cexp co vx cv vy cv cmin co cre cfv c2 cexp co addge02 vx cv
      cc cr cdif wcel vy cv cr wcel wa vx cv cim cfv cr wcel vx cv cim cfv c2
      cexp co cr wcel vx cv cc cr cdif wcel vx cv cim cfv cr wcel vy cv cr wcel
      vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv cc cr
      eldifi vx cv imcl syl adantr vx cv cim cfv resqcl syl vx cv cc cr cdif
      wcel vy cv cr wcel wa vx cv vy cv cmin co cc wcel vx cv vy cv cmin co cre
      cfv cr wcel vx cv vy cv cmin co cre cfv c2 cexp co cr wcel vx cv cc wcel
      vy cv cc wcel vx cv vy cv cmin co cc wcel vx cv cc cr cdif wcel vy cv cr
      wcel vx cv vy cv subcl vx cv cc cr eldifi vy cv recn syl2an vx cv vy cv
      cmin co recl vx cv vy cv cmin co cre cfv resqcl 3syl sylanc mpbid vx cv
      cc cr cdif wcel vy cv cr wcel wa vx cv cim cfv cr wcel vx cv cim cfv cabs
      cfv c2 cexp co vx cv cim cfv c2 cexp co wceq vx cv cc cr cdif wcel vx cv
      cim cfv cr wcel vy cv cr wcel vx cv cc cr cdif wcel vx cv cc wcel vx cv
      cim cfv cr wcel vx cv cc cr eldifi vx cv imcl syl adantr vx cv cim cfv
      absresq syl vx cv cc cr cdif wcel vy cv cr wcel wa vx cv vy cv cmin co
      cabs cfv c2 cexp co vx cv vy cv cmin co cre cfv c2 cexp co vx cv vy cv
      cmin co cim cfv c2 cexp co caddc co vx cv vy cv cmin co cre cfv c2 cexp
      co vx cv cim cfv c2 cexp co caddc co vx cv cc cr cdif wcel vy cv cr wcel
      wa vx cv vy cv cmin co cc wcel vx cv vy cv cmin co cabs cfv c2 cexp co vx
      cv vy cv cmin co cre cfv c2 cexp co vx cv vy cv cmin co cim cfv c2 cexp
      co caddc co wceq vx cv cc wcel vy cv cc wcel vx cv vy cv cmin co cc wcel
      vx cv cc cr cdif wcel vy cv cr wcel vx cv vy cv subcl vx cv cc cr eldifi
      vy cv recn syl2an vx cv vy cv cmin co absvalsq2 syl vx cv cc cr cdif wcel
      vy cv cr wcel wa vx cv vy cv cmin co cim cfv c2 cexp co vx cv cim cfv c2
      cexp co vx cv vy cv cmin co cre cfv c2 cexp co caddc vx cv cc cr cdif
      wcel vy cv cr wcel wa vx cv vy cv cmin co cim cfv vx cv cim cfv c2 cexp
      vx cv cc cr cdif wcel vy cv cr wcel wa vx cv vy cv cmin co cim cfv vx cv
      cim cfv vy cv cim cfv cmin co vx cv cim cfv cc0 cmin co vx cv cim cfv vx
      cv cc wcel vy cv cc wcel vx cv vy cv cmin co cim cfv vx cv cim cfv vy cv
      cim cfv cmin co wceq vx cv cc cr cdif wcel vy cv cr wcel vx cv vy cv
      imsub vx cv cc cr eldifi vy cv recn syl2an vx cv cc cr cdif wcel vy cv cr
      wcel wa vy cv cim cfv cc0 vx cv cim cfv cmin vy cv cr wcel vy cv cim cfv
      cc0 wceq vx cv cc cr cdif wcel vy cv reim0 adantl opreq2d vx cv cc cr
      cdif wcel vy cv cr wcel wa vx cv cim cfv cc wcel vx cv cim cfv cc0 cmin
      co vx cv cim cfv wceq vx cv cc cr cdif wcel vx cv cim cfv cc wcel vy cv
      cr wcel vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv
      cim cfv cc wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv recn 3syl
      adantr vx cv cim cfv subid1 syl 3eqtrd opreq1d opreq2d eqtrd 3brtr4d vx
      cv cim cfv cabs cfv cr wcel cc0 vx cv cim cfv cabs cfv cle wbr vx cv vy
      cv cmin co cabs cfv cr wcel cc0 vx cv vy cv cmin co cabs cfv cle wbr vx
      cv cim cfv cabs cfv vx cv vy cv cmin co cabs cfv cle wbr vx cv cim cfv
      cabs cfv c2 cexp co vx cv vy cv cmin co cabs cfv c2 cexp co cle wbr wb vx
      cv cc cr cdif wcel vy cv cr wcel wa vx cv cim cfv cabs cfv vx cv vy cv
      cmin co cabs cfv le2sq vx cv cc cr cdif wcel vx cv cim cfv cabs cfv cr
      wcel vy cv cr wcel vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr
      wcel vx cv cim cfv cabs cfv cr wcel vx cv cc cr eldifi vx cv imcl vx cv
      cim cfv cr wcel vx cv cim cfv cc wcel vx cv cim cfv cabs cfv cr wcel vx
      cv cim cfv recn vx cv cim cfv abscl syl 3syl adantr vx cv cc cr cdif wcel
      cc0 vx cv cim cfv cabs cfv cle wbr vy cv cr wcel vx cv cc cr cdif wcel vx
      cv cim cfv cc wcel cc0 vx cv cim cfv cabs cfv cle wbr vx cv cc cr cdif
      wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv cc wcel vx cv cc
      cr eldifi vx cv imcl vx cv cim cfv recn 3syl vx cv cim cfv absge0 syl
      adantr vx cv cc cr cdif wcel vy cv cr wcel wa vx cv vy cv cmin co cc wcel
      vx cv vy cv cmin co cabs cfv cr wcel vx cv cc wcel vy cv cc wcel vx cv vy
      cv cmin co cc wcel vx cv cc cr cdif wcel vy cv cr wcel vx cv vy cv subcl
      vx cv cc cr eldifi vy cv recn syl2an vx cv vy cv cmin co abscl syl vx cv
      cc cr cdif wcel vy cv cr wcel wa vx cv vy cv cmin co cc wcel cc0 vx cv vy
      cv cmin co cabs cfv cle wbr vx cv cc wcel vy cv cc wcel vx cv vy cv cmin
      co cc wcel vx cv cc cr cdif wcel vy cv cr wcel vx cv vy cv subcl vx cv cc
      cr eldifi vy cv recn syl2an vx cv vy cv cmin co absge0 syl syl2anc mpbird
      vx cv cc cr cdif wcel vy cv cr wcel wa vx cv cim cfv cabs cfv vx cv vy cv
      cabs cmin ccom co cle wbr vx cv cim cfv cabs cfv vx cv vy cv cmin co cabs
      cfv cle wbr vx cv vy cv cabs cmin ccom co vx cv cim cfv cabs cfv clt wbr
      wn vx cv cc cr cdif wcel vy cv cr wcel wa vx cv vy cv cabs cmin ccom co
      vx cv vy cv cmin co cabs cfv vx cv cim cfv cabs cfv cle vx cv cc wcel vy
      cv cc wcel vx cv vy cv cabs cmin ccom co vx cv vy cv cmin co cabs cfv
      wceq vx cv cc cr cdif wcel vy cv cr wcel vx cv vy cv cabs cmin ccom cabs
      cmin ccom eqid cnmetdval vx cv cc cr eldifi vy cv recn syl2an breq2d vx
      cv cim cfv cabs cfv cr wcel vx cv vy cv cabs cmin ccom co cr wcel vx cv
      cim cfv cabs cfv vx cv vy cv cabs cmin ccom co cle wbr vx cv vy cv cabs
      cmin ccom co vx cv cim cfv cabs cfv clt wbr wn wb vx cv cc cr cdif wcel
      vy cv cr wcel wa vx cv cim cfv cabs cfv vx cv vy cv cabs cmin ccom co
      lenlt vx cv cc cr cdif wcel vx cv cim cfv cabs cfv cr wcel vy cv cr wcel
      vx cv cc cr cdif wcel vx cv cc wcel vx cv cim cfv cr wcel vx cv cim cfv
      cabs cfv cr wcel vx cv cc cr eldifi vx cv imcl vx cv cim cfv cr wcel vx
      cv cim cfv cc wcel vx cv cim cfv cabs cfv cr wcel vx cv cim cfv recn vx
      cv cim cfv abscl syl 3syl adantr cabs cmin ccom cme wcel vx cv cc wcel vy
      cv cc wcel vx cv vy cv cabs cmin ccom co cr wcel vx cv cc cr cdif wcel vy
      cv cr wcel wa vx cv vy cv cabs cmin ccom cc cabs cmin ccom cabs cmin ccom
      eqid cnmetba metcl cabs cmin ccom cme wcel vx cv cc cr cdif wcel vy cv cr
      wcel wa cabs cmin ccom cabs cmin ccom eqid cnmet a1i vx cv cc cr cdif
      wcel vx cv cc wcel vy cv cr wcel vx cv cc cr eldifi adantr vy cv cr wcel
      vy cv cc wcel vx cv cc cr cdif wcel vy cv recn adantl syl3anc sylanc
      bitr3d mpbid ex con2d adantld sylbid jcad vy cv cc cr eldif syl6ibr ssrdv
      cc0 vy cv clt wbr vx cv vy cv cabs cmin ccom cbl cfv co cc cr cdif wss wa
      cc0 vx cv cim cfv cabs cfv clt wbr vx cv vx cv cim cfv cabs cfv cabs cmin
      ccom cbl cfv co cc cr cdif wss wa vy vx cv cim cfv cabs cfv cr vy cv vx
      cv cim cfv cabs cfv wceq cc0 vy cv clt wbr cc0 vx cv cim cfv cabs cfv clt
      wbr vx cv vy cv cabs cmin ccom cbl cfv co cc cr cdif wss vx cv vx cv cim
      cfv cabs cfv cabs cmin ccom cbl cfv co cc cr cdif wss vy cv vx cv cim cfv
      cabs cfv cc0 clt breq2 vy cv vx cv cim cfv cabs cfv wceq vx cv vy cv cabs
      cmin ccom cbl cfv co vx cv vx cv cim cfv cabs cfv cabs cmin ccom cbl cfv
      co cc cr cdif vy cv vx cv cim cfv cabs cfv vx cv cabs cmin ccom cbl cfv
      opreq2 sseq1d anbi12d rcla4ev sylan32c rgen mpbir2an cabs cmin ccom copn
      cfv ctop wcel cr cc wss cr cabs cmin ccom copn cfv ccld cfv wcel cc cr
      cdif cabs cmin ccom copn cfv wcel wb cabs cmin ccom cme wcel cabs cmin
      ccom copn cfv ctop wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs
      cmin ccom cabs cmin ccom copn cfv cabs cmin ccom copn cfv eqid opntop
      ax-mp axresscn cr cabs cmin ccom copn cfv cc cabs cmin ccom cme wcel cc
      cabs cmin ccom copn cfv cuni wceq cabs cmin ccom cabs cmin ccom eqid
      cnmet cabs cmin ccom cme wcel cabs cmin ccom copn cfv cuni cc cabs cmin
      ccom cabs cmin ccom copn cfv cc cabs cmin ccom cabs cmin ccom eqid
      cnmetba cabs cmin ccom copn cfv eqid uniopn2 eqcomd ax-mp iscld2 mp2an
      mpbir cabs cmin ccom cms wcel cr cc wss cabs cmin ccom cr cr cxp cres cms
      wcel cr cabs cmin ccom copn cfv ccld cfv wcel wb cabs cmin ccom cabs cmin
      ccom eqid cncms axresscn cabs cmin ccom cabs cmin ccom copn cfv cc cr
      cabs cmin ccom cabs cmin ccom eqid cnmetba cabs cmin ccom copn cfv eqid
      cmsss mp2an mpbir $.
      $( [2-Sep-2009] $)
  $}

  $c Rn $.
  $( Extend class notation with the n-dimensional Euclidean space. $)
  crrn $a class Rn $.

  ${
    $d n r x y d k $.
    $( Define n-dimensional Euclidean space as a metric space with the standard
       Euclidean norm given by the quadratic mean. $)
    df-rrn $a |- Rn = { <. n , r >. | ( n e. NN /\ r = { <. <. x , y >. , d >.
       | ( ( x e. ( RR ^m ( 1 ... n ) ) /\ y e. ( RR ^m ( 1 ... n ) ) ) /\
                      d = ( sqr ` sum_ k e. ( 1 ... n )
                                ( ( ( x ` k ) - ( y ` k ) ) ^ 2 ) ) ) } ) } $.
  $}

  ${
    $d N n r x y d k $.
    $( The n-dimensional Euclidean space. $)
    rrnval $p |- ( N e. NN -> ( Rn ` N ) = { <. <. x , y >. , d >. |
            ( ( x e. ( RR ^m ( 1 ... N ) ) /\ y e. ( RR ^m ( 1 ... N ) ) ) /\
                      d = ( sqr ` sum_ k e. ( 1 ... N )
                                ( ( ( x ` k ) - ( y ` k ) ) ^ 2 ) ) ) } ) $=
      vn vr cN vx cv cr c1 vn cv cfz co cm co wcel vy cv cr c1 vn cv cfz co cm
      co wcel wa vd cv c1 vn cv cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co
      c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2 vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx
      vy vd copab2 cn crrn vn cv cN wceq vx cv cr c1 vn cv cfz co cm co wcel vy
      cv cr c1 vn cv cfz co cm co wcel wa vd cv c1 vn cv cfz co vk cv vx cv cfv
      vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co
      vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq
      wa vx vy vd vn cv cN wceq vx cv cr c1 vn cv cfz co cm co wcel vy cv cr c1
      vn cv cfz co cm co wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel wa vd cv c1 vn cv cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv wceq vd cv c1 cN cfz co vk cv vx
      cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq vn cv cN
      wceq vx cv cr c1 vn cv cfz co cm co wcel vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 vn cv cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel vn
      cv cN wceq cr c1 vn cv cfz co cm co cr c1 cN cfz co cm co vx cv vn cv cN
      wceq c1 vn cv cfz co c1 cN cfz co cr cm vn cv cN c1 cfz opreq2 opreq2d
      eleq2d vn cv cN wceq cr c1 vn cv cfz co cm co cr c1 cN cfz co cm co vy cv
      vn cv cN wceq c1 vn cv cfz co c1 cN cfz co cr cm vn cv cN c1 cfz opreq2
      opreq2d eleq2d anbi12d vn cv cN wceq c1 vn cv cfz co vk cv vx cv cfv vk
      cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv vx cv
      cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv vd cv vn cv cN
      wceq c1 vn cv cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co
      vk csu c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk
      csu csqr vn cv cN wceq c1 vn cv cfz co c1 cN cfz co vk cv vx cv cfv vk cv
      vy cv cfv cmin co c2 cexp co vk vn cv cN c1 cfz opreq2 sumeq1d fveq2d
      eqeq2d anbi12d oprabbidv vx vy vk vn vr vd df-rrn vx vy vd cr c1 cN cfz
      co cm co cr c1 cN cfz co cm co c1 cN cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk
      cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2
      cr c1 cN cfz co cm oprex cr c1 cN cfz co cm oprex vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx
      vy vd copab2 eqid oprabex2 fvopab4 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N x y d k $. $d X x y d k $. $d Y x y d k $.
    $( The value of the Euclidean metric. $)
    rrnmval $p |- ( ( N e. NN /\ X e. ( RR ^m ( 1 ... N ) )
                  /\ Y e. ( RR ^m ( 1 ... N ) ) ) -> ( X ( Rn ` N ) Y ) =
        ( sqr ` sum_ k e. ( 1 ... N ) ( ( ( X ` k ) - ( Y ` k ) ) ^ 2 ) ) ) $=
      cN cn wcel cX cr c1 cN cfz co cm co wcel cY cr c1 cN cfz co cm co wcel cX
      cY cN crrn cfv co c1 cN cfz co vk cv cX cfv vk cv cY cfv cmin co c2 cexp
      co vk csu csqr cfv wceq cN cn wcel cX cr c1 cN cfz co cm co wcel cY cr c1
      cN cfz co cm co wcel wa cX cY cN crrn cfv co cX cY vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx
      vy vd copab2 co c1 cN cfz co vk cv cX cfv vk cv cY cfv cmin co c2 cexp co
      vk csu csqr cfv cN cn wcel cN crrn cfv vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk
      cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2
      cX cY vx vy vk cN vd rrnval opreqd vx vy vd cX cY cr c1 cN cfz co cm co
      cr c1 cN cfz co cm co c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv cX cfv vk cv cY cfv cmin
      co c2 cexp co vk csu csqr cfv vx cv cr c1 cN cfz co cm co wcel vy cv cr
      c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2 c1 cN cfz
      co vk cv cX cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv c1 cN
      cfz co vk cv cX cfv vk cv cY cfv cmin co c2 cexp co vk csu csqr fvex vx
      cv cX wceq c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co vk csu c1 cN cfz co vk cv cX cfv vk cv vy cv cfv cmin co c2 cexp co vk
      csu csqr vx cv cX wceq c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co vk cv cX cfv vk cv vy cv cfv cmin co c2 cexp co vk vx cv cX
      wceq vk cv vx cv cfv vk cv vy cv cfv cmin co vk cv cX cfv vk cv vy cv cfv
      cmin co c2 cexp vx cv cX wceq vk cv vx cv cfv vk cv cX cfv vk cv vy cv
      cfv cmin vk cv vx cv cX fveq1 opreq1d opreq1d sumeq2sdv fveq2d vy cv cY
      wceq c1 cN cfz co vk cv cX cfv vk cv vy cv cfv cmin co c2 cexp co vk csu
      c1 cN cfz co vk cv cX cfv vk cv cY cfv cmin co c2 cexp co vk csu csqr vy
      cv cY wceq c1 cN cfz co vk cv cX cfv vk cv vy cv cfv cmin co c2 cexp co
      vk cv cX cfv vk cv cY cfv cmin co c2 cexp co vk vy cv cY wceq vk cv cX
      cfv vk cv vy cv cfv cmin co vk cv cX cfv vk cv cY cfv cmin co c2 cexp vy
      cv cY wceq vk cv vy cv cfv vk cv cY cfv vk cv cX cfv cmin vk cv vy cv cY
      fveq1 opreq2d opreq1d sumeq2sdv fveq2d vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk
      cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2
      eqid oprabval2 sylan9eq 3impb $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N x y d k $.
    $( The underlying set of Euclidean space. $)
    rrndm $p |- ( N e. NN -> dom dom ( Rn ` N ) = ( RR ^m ( 1 ... N ) ) ) $=
      cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co cr c1 cN cfz co cm
      co cxp cdm cr c1 cN cfz co cm co cN cn wcel cN crrn cfv cdm cr c1 cN cfz
      co cm co cr c1 cN cfz co cm co cxp cN cn wcel cN crrn cfv cdm vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz
      co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv
      wceq wa vx vy vd copab2 cdm cr c1 cN cfz co cm co cr c1 cN cfz co cm co
      cxp cN cn wcel cN crrn cfv vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2 vx vy vk
      cN vd rrnval dmeqd vx vy vd cr c1 cN cfz co cm co cr c1 cN cfz co cm co
      c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu
      csqr cfv vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2
      cexp co vk csu csqr cfv wceq wa vx vy vd copab2 c1 cN cfz co vk cv vx cv
      cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr fvex vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co
      vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq
      wa vx vy vd copab2 eqid dmoprab2 syl6eq dmeqd cN cn wcel cr c1 cN cfz co
      cm co c0 wne cr c1 cN cfz co cm co cr c1 cN cfz co cm co cxp cdm cr c1 cN
      cfz co cm co wceq cr c1 cN cfz co cm co c0 wne cN cn wcel cr c1 cN cfz co
      cm co c0 wne cr c1 cN cfz co cm co c0 wceq wn cr c1 cN cfz co cm co c0
      wceq cr c0 wceq cc0 cr wcel cr c0 wceq wn 0re cr cc0 n0i ax-mp cr c1 cN
      cfz co cm co c0 wceq cr c0 wceq c1 cN cfz co c0 wne cr c1 cN cfz co reex
      c1 cN cfz oprex map0 pm3.26bi mto cr c1 cN cfz co cm co c0 df-ne mpbir
      a1i cr c1 cN cfz co cm co cr c1 cN cfz co cm co dmxp syl eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N x y d k z m n $.
    $( Euclidean space is a metric space. $)
    rrnmet $p |- ( N e. NN -> ( Rn ` N ) e. Met ) $=
      cN crrn cfv cme wcel cN crrn cfv cdm cdm cN crrn cfv cdm cdm cxp cr cN
      crrn cfv wf vx cv vy cv cN crrn cfv co cc0 wceq vx cv vy cv wceq wb vx cv
      vy cv cN crrn cfv co vz cv vx cv cN crrn cfv co vz cv vy cv cN crrn cfv
      co caddc co cle wbr vz cN crrn cfv cdm cdm wral wa vy cN crrn cfv cdm cdm
      wral vx cN crrn cfv cdm cdm wral cN cn wcel cN crrn cfv cvv wcel cN crrn
      cfv cme wcel cN crrn cfv cdm cdm cN crrn cfv cdm cdm cxp cr cN crrn cfv
      wf vx cv vy cv cN crrn cfv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cN
      crrn cfv co vz cv vx cv cN crrn cfv co vz cv vy cv cN crrn cfv co caddc
      co cle wbr vz cN crrn cfv cdm cdm wral wa vy cN crrn cfv cdm cdm wral vx
      cN crrn cfv cdm cdm wral wa wb cN crrn fvex vx vy vz cvv cN crrn cfv cN
      crrn cfv cdm cdm cN crrn cfv cdm cdm eqid ismet ax-mp cN cn wcel cN crrn
      cfv cdm cdm cN crrn cfv cdm cdm cxp cr cN crrn cfv wf cr c1 cN cfz co cm
      co cr c1 cN cfz co cm co cxp cr cN crrn cfv wf cN cn wcel cr c1 cN cfz co
      cm co cr c1 cN cfz co cm co cxp cr cN crrn cfv wf cr c1 cN cfz co cm co
      cr c1 cN cfz co cm co cxp cr vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy vd copab2 wf cN cn
      wcel c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk
      csu csqr cfv cr wcel vy cr c1 cN cfz co cm co wral vx cr c1 cN cfz co cm
      co wral cr c1 cN cfz co cm co cr c1 cN cfz co cm co cxp cr vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co
      vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq
      wa vx vy vd copab2 wf cN cn wcel c1 cN cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv cr wcel vx vy cr c1 cN cfz co cm
      co cr c1 cN cfz co cm co cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel c1 cN cfz co vk cv vx cv cfv vk cv vy cv
      cfv cmin co c2 cexp co vk csu csqr cfv cr wcel c1 cN cfz co vk cv vx cv
      cfv vk cv vy cv cfv cmin co c2 cexp co vk csu cr wcel cc0 c1 cN cfz co vk
      cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu cle wbr c1 cN cfz
      co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv cr
      wcel cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm
      co wcel w3a c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co vk csu sqrcl cN c1 cuz cfv wcel vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv vx cv cfv
      vk cv vy cv cfv cmin co c2 cexp co vk csu cr wcel cN cn wcel vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv vx cv cfv
      vk cv vy cv cfv cmin co c2 cexp co vk c1 cN fsumrecl cN cn wcel vx cv cr
      c1 cN cfz co cm co wcel cN c1 cuz cfv wcel vy cv cr c1 cN cfz co cm co
      wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi 3ad2ant1 cN cn wcel
      vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk
      cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr wcel vk c1 cN cfz co
      cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv cmin
      co cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr wcel vk
      cv vx cv cfv cr wcel vk cv vy cv cfv cr wcel vk cv vx cv cfv vk cv vy cv
      cfv cmin co cr wcel cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr
      c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk
      cv vy cv cfv resubcl vx cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1
      cN cfz co wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel
      c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel
      vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vx cv ffvelrn cr
      c1 cN cfz co vx cv reex c1 cN cfz oprex elmap sylanb 3ad2antl2 vy cv cr
      c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vy cv
      cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv wf vk
      cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel vy cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv vx cv cfv vk cv vy cv cfv
      cmin co resqcl syl r19.21aiva sylanc cN c1 cuz cfv wcel vk cv vx cv cfv
      vk cv vy cv cfv cmin co c2 cexp co cr wcel cc0 vk cv vx cv cfv vk cv vy
      cv cfv cmin co c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz
      co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu cle wbr cN
      cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      w3a vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk c1 cN fsumcmp0
      cN cn wcel vx cv cr c1 cN cfz co cm co wcel cN c1 cuz cfv wcel vy cv cr
      c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi
      3ad2ant1 cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz
      co cm co wcel w3a vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr
      wcel cc0 vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cle wbr wa vk
      c1 cN cfz co cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy
      cv cfv cmin co c2 cexp co cr wcel cc0 vk cv vx cv cfv vk cv vy cv cfv
      cmin co c2 cexp co cle wbr cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv
      cfv vk cv vy cv cfv cmin co cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co cr wcel vk cv vx cv cfv cr wcel vk cv vy cv cfv cr wcel vk
      cv vx cv cfv vk cv vy cv cfv cmin co cr wcel cN cn wcel vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel wa vk cv vx cv cfv vk cv vy cv cfv resubcl vx cv cr c1 cN cfz co cm
      co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vy cv
      cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co
      wcel vk cv vx cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vk cv vx cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex
      elmap sylanb 3ad2antl2 vy cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv
      c1 cN cfz co wcel vk cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vy cv cfv cr
      wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vy cv ffvelrn
      cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap sylanb 3ad2antl3 sylanc
      vk cv vx cv cfv vk cv vy cv cfv cmin co resqcl syl cN cn wcel vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz
      co wcel wa vk cv vx cv cfv vk cv vy cv cfv cmin co cr wcel cc0 vk cv vx
      cv cfv vk cv vy cv cfv cmin co c2 cexp co cle wbr vk cv vx cv cfv cr wcel
      vk cv vy cv cfv cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin co cr wcel
      cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv
      resubcl vx cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vx cv cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vx cv ffvelrn cr c1 cN cfz
      co vx cv reex c1 cN cfz oprex elmap sylanb 3ad2antl2 vy cv cr c1 cN cfz
      co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel
      vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv wf vk cv c1 cN cfz
      co wcel vk cv vy cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN cfz oprex
      elmap sylanb 3ad2antl3 sylanc vk cv vx cv cfv vk cv vy cv cfv cmin co
      sqge0 syl jca r19.21aiva sylanc sylanc 3expib r19.21aivv vx vy vd cr c1
      cN cfz co cm co cr c1 cN cfz co cm co c1 cN cfz co vk cv vx cv cfv vk cv
      vy cv cfv cmin co c2 cexp co vk csu csqr cfv cr vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1 cN cfz co vk cv vx
      cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq wa vx vy
      vd copab2 vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel wa vd cv c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2
      cexp co vk csu csqr cfv wceq wa vx vy vd copab2 eqid foprab2 sylib cN cn
      wcel cr c1 cN cfz co cm co cr c1 cN cfz co cm co cxp cr cN crrn cfv vx cv
      cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vd cv c1
      cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr
      cfv wceq wa vx vy vd copab2 vx vy vk cN vd rrnval feq1d mpbird cN cn wcel
      cN crrn cfv cdm cdm cN crrn cfv cdm cdm cxp cr c1 cN cfz co cm co cr c1
      cN cfz co cm co cxp wceq cN crrn cfv cdm cdm cN crrn cfv cdm cdm cxp cr
      cN crrn cfv wf cr c1 cN cfz co cm co cr c1 cN cfz co cm co cxp cr cN crrn
      cfv wf wb cN cn wcel cN crrn cfv cdm cdm cN crrn cfv cdm cdm cxp cr c1 cN
      cfz co cm co cN crrn cfv cdm cdm cxp cr c1 cN cfz co cm co cr c1 cN cfz
      co cm co cxp cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co wceq cN
      crrn cfv cdm cdm cN crrn cfv cdm cdm cxp cr c1 cN cfz co cm co cN crrn
      cfv cdm cdm cxp wceq cN rrndm cN crrn cfv cdm cdm cr c1 cN cfz co cm co
      cN crrn cfv cdm cdm xpeq1 syl cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz
      co cm co wceq cr c1 cN cfz co cm co cN crrn cfv cdm cdm cxp cr c1 cN cfz
      co cm co cr c1 cN cfz co cm co cxp wceq cN rrndm cN crrn cfv cdm cdm cr
      c1 cN cfz co cm co cr c1 cN cfz co cm co xpeq2 syl eqtrd cN crrn cfv cdm
      cdm cN crrn cfv cdm cdm cxp cr c1 cN cfz co cm co cr c1 cN cfz co cm co
      cxp cr cN crrn cfv feq2 syl mpbird cN cn wcel vx cv vy cv cN crrn cfv co
      cc0 wceq vx cv vy cv wceq wb vx cv vy cv cN crrn cfv co vz cv vx cv cN
      crrn cfv co vz cv vy cv cN crrn cfv co caddc co cle wbr vz cN crrn cfv
      cdm cdm wral wa vx vy cN crrn cfv cdm cdm cN crrn cfv cdm cdm cN cn wcel
      vx cv cN crrn cfv cdm cdm wcel vy cv cN crrn cfv cdm cdm wcel wa vx cv cr
      c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vx cv vy cv
      cN crrn cfv co cc0 wceq vx cv vy cv wceq wb vx cv vy cv cN crrn cfv co vz
      cv vx cv cN crrn cfv co vz cv vy cv cN crrn cfv co caddc co cle wbr vz cN
      crrn cfv cdm cdm wral wa cN cn wcel vx cv cN crrn cfv cdm cdm wcel vx cv
      cr c1 cN cfz co cm co wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN
      cfz co cm co wcel cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vx
      cv cN rrndm eleq2d cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co
      vy cv cN rrndm eleq2d anbi12d cN cn wcel vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel vx cv vy cv cN crrn cfv co cc0 wceq vx
      cv vy cv wceq wb vx cv vy cv cN crrn cfv co vz cv vx cv cN crrn cfv co vz
      cv vy cv cN crrn cfv co caddc co cle wbr vz cN crrn cfv cdm cdm wral wa
      cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel w3a vx cv vy cv cN crrn cfv co cc0 wceq vx cv vy cv wceq wb vx cv vy
      cv cN crrn cfv co vz cv vx cv cN crrn cfv co vz cv vy cv cN crrn cfv co
      caddc co cle wbr vz cN crrn cfv cdm cdm wral cN cn wcel vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vx cv vy cv cN
      crrn cfv co cc0 wceq c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co
      c2 cexp co vk csu csqr cfv cc0 wceq c1 cN cfz co vk cv vx cv cfv vk cv vy
      cv cfv cmin co c2 cexp co vk csu cc0 wceq vx cv vy cv wceq cN cn wcel vx
      cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vx cv
      vy cv cN crrn cfv co c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co
      c2 cexp co vk csu csqr cfv cc0 vk cN vx cv vy cv rrnmval eqeq1d c1 cN cfz
      co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu cr wcel cc0
      c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu
      cle wbr c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co
      vk csu csqr cfv cc0 wceq c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv
      cmin co c2 cexp co vk csu cc0 wceq wb cN cn wcel vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel w3a c1 cN cfz co vk cv vx cv cfv
      vk cv vy cv cfv cmin co c2 cexp co vk csu sqr00 cN c1 cuz cfv wcel vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr wcel vk c1 cN cfz co wral
      c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu cr
      wcel cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm
      co wcel w3a vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk c1 cN
      fsumrecl cN cn wcel vx cv cr c1 cN cfz co cm co wcel cN c1 cuz cfv wcel
      vy cv cr c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz
      biimpi 3ad2ant1 cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel w3a vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co cr wcel vk c1 cN cfz co cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv
      cfv vk cv vy cv cfv cmin co cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co cr wcel vk cv vx cv cfv cr wcel vk cv vy cv cfv cr wcel vk
      cv vx cv cfv vk cv vy cv cfv cmin co cr wcel cN cn wcel vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel wa vk cv vx cv cfv vk cv vy cv cfv resubcl vx cv cr c1 cN cfz co cm
      co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vy cv
      cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co
      wcel vk cv vx cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vk cv vx cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex
      elmap sylanb 3ad2antl2 vy cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv
      c1 cN cfz co wcel vk cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vy cv cfv cr
      wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vy cv ffvelrn
      cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap sylanb 3ad2antl3 sylanc
      vk cv vx cv cfv vk cv vy cv cfv cmin co resqcl syl r19.21aiva sylanc cN
      c1 cuz cfv wcel vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr
      wcel cc0 vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cle wbr wa vk
      c1 cN cfz co wral cc0 c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co vk csu cle wbr cN cn wcel vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel w3a vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co vk c1 cN fsumcmp0 cN cn wcel vx cv cr c1 cN cfz co cm co
      wcel cN c1 cuz cfv wcel vy cv cr c1 cN cfz co cm co wcel cN cn wcel cN c1
      cuz cfv wcel cN elnnuz biimpi 3ad2ant1 cN cn wcel vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv vx cv cfv vk cv vy
      cv cfv cmin co c2 cexp co cr wcel cc0 vk cv vx cv cfv vk cv vy cv cfv
      cmin co c2 cexp co cle wbr wa vk c1 cN cfz co cN cn wcel vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel wa vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr wcel cc0 vk
      cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cle wbr cN cn wcel vx cv
      cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1
      cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv cmin co cr wcel vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr wcel vk cv vx cv cfv cr
      wcel vk cv vy cv cfv cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin co cr
      wcel cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv
      resubcl vx cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vx cv cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vx cv ffvelrn cr c1 cN cfz
      co vx cv reex c1 cN cfz oprex elmap sylanb 3ad2antl2 vy cv cr c1 cN cfz
      co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel
      vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv wf vk cv c1 cN cfz
      co wcel vk cv vy cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN cfz oprex
      elmap sylanb 3ad2antl3 sylanc vk cv vx cv cfv vk cv vy cv cfv cmin co
      resqcl syl cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz
      co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv
      cfv cmin co cr wcel cc0 vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co cle wbr vk cv vx cv cfv cr wcel vk cv vy cv cfv cr wcel vk cv vx cv
      cfv vk cv vy cv cfv cmin co cr wcel cN cn wcel vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa
      vk cv vx cv cfv vk cv vy cv cfv resubcl vx cv cr c1 cN cfz co cm co wcel
      cN cn wcel vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv
      vx cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv
      vx cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap sylanb
      3ad2antl2 vy cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel vy cv cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz
      co vy cv reex c1 cN cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv vx cv
      cfv vk cv vy cv cfv cmin co sqge0 syl jca r19.21aiva sylanc sylanc cN cn
      wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      w3a c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk
      csu cc0 wceq vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cc0 wceq
      vk c1 cN cfz co wral vk cv vx cv cfv vk cv vy cv cfv wceq vk c1 cN cfz co
      wral vx cv vy cv wceq cN c1 cuz cfv wcel vk cv vx cv cfv vk cv vy cv cfv
      cmin co c2 cexp co cr wcel cc0 vk cv vx cv cfv vk cv vy cv cfv cmin co c2
      cexp co cle wbr wa vk c1 cN cfz co wral c1 cN cfz co vk cv vx cv cfv vk
      cv vy cv cfv cmin co c2 cexp co vk csu cc0 wceq vk cv vx cv cfv vk cv vy
      cv cfv cmin co c2 cexp co cc0 wceq vk c1 cN cfz co wral wb cN cn wcel vx
      cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk c1 cN fsum00 cN cn wcel
      vx cv cr c1 cN cfz co cm co wcel cN c1 cuz cfv wcel vy cv cr c1 cN cfz co
      cm co wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi 3ad2ant1 cN cn
      wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      w3a vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr wcel cc0 vk cv
      vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cle wbr wa vk c1 cN cfz co
      cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv cmin
      co c2 cexp co cr wcel cc0 vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co cle wbr cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz
      co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv
      cfv cmin co cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co cr
      wcel vk cv vx cv cfv cr wcel vk cv vy cv cfv cr wcel vk cv vx cv cfv vk
      cv vy cv cfv cmin co cr wcel cN cn wcel vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx
      cv cfv vk cv vy cv cfv resubcl vx cv cr c1 cN cfz co cm co wcel cN cn
      wcel vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN cfz
      co cm co wcel c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vx
      cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vx
      cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap sylanb
      3ad2antl2 vy cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel vy cv cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz
      co vy cv reex c1 cN cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv vx cv
      cfv vk cv vy cv cfv cmin co resqcl syl cN cn wcel vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel
      wa vk cv vx cv cfv vk cv vy cv cfv cmin co cr wcel cc0 vk cv vx cv cfv vk
      cv vy cv cfv cmin co c2 cexp co cle wbr vk cv vx cv cfv cr wcel vk cv vy
      cv cfv cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin co cr wcel cN cn wcel
      vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk
      cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv resubcl vx cv cr
      c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vx cv
      cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf vk
      cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vk cv vx cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN
      cfz oprex elmap sylanb 3ad2antl2 vy cv cr c1 cN cfz co cm co wcel cN cn
      wcel vk cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel vx cv cr c1 cN cfz
      co cm co wcel c1 cN cfz co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vy
      cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vy
      cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap sylanb
      3ad2antl3 sylanc vk cv vx cv cfv vk cv vy cv cfv cmin co sqge0 syl jca
      r19.21aiva sylanc cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel w3a vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co cc0 wceq vk cv vx cv cfv vk cv vy cv cfv wceq vk c1 cN cfz co cN cn
      wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv cmin co c2
      cexp co cc0 wceq vk cv vx cv cfv vk cv vy cv cfv cmin co cc0 wceq vk cv
      vx cv cfv vk cv vy cv cfv wceq cN cn wcel vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk
      cv vx cv cfv vk cv vy cv cfv cmin co cr wcel vk cv vx cv cfv vk cv vy cv
      cfv cmin co cc wcel vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co
      cc0 wceq vk cv vx cv cfv vk cv vy cv cfv cmin co cc0 wceq wb vk cv vx cv
      cfv cr wcel vk cv vy cv cfv cr wcel vk cv vx cv cfv vk cv vy cv cfv cmin
      co cr wcel cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz
      co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vy cv
      cfv resubcl vx cv cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vx cv
      cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vx cv ffvelrn cr c1 cN
      cfz co vx cv reex c1 cN cfz oprex elmap sylanb 3ad2antl2 vy cv cr c1 cN
      cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vy cv cfv cr
      wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv wf vk cv c1
      cN cfz co wcel vk cv vy cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel
      c1 cN cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN cfz
      oprex elmap sylanb 3ad2antl3 sylanc vk cv vx cv cfv vk cv vy cv cfv cmin
      co recn vk cv vx cv cfv vk cv vy cv cfv cmin co sqeq0 3syl vk cv vx cv
      cfv cc wcel vk cv vy cv cfv cc wcel vk cv vx cv cfv vk cv vy cv cfv cmin
      co cc0 wceq vk cv vx cv cfv vk cv vy cv cfv wceq wb cN cn wcel vx cv cr
      c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN
      cfz co wcel wa vk cv vx cv cfv vk cv vy cv cfv subeq0 cN cn wcel vx cv cr
      c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a vk cv c1 cN
      cfz co wcel wa vk cv vx cv cfv vx cv cr c1 cN cfz co cm co wcel cN cn
      wcel vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel vy cv cr c1 cN cfz
      co cm co wcel c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vx
      cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv vx
      cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap sylanb
      3ad2antl2 recnd cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv vy cv cfv vy cv
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv vy cv
      cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv wf vk
      cv c1 cN cfz co wcel vk cv vy cv cfv cr wcel vy cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vk cv vy cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 recnd sylanc bitrd ralbidva vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel vk cv vx cv cfv vk
      cv vy cv cfv wceq vk c1 cN cfz co wral vx cv vy cv wceq wb cN cn wcel vx
      cv c1 cN cfz co wfn vy cv c1 cN cfz co wfn vk cv vx cv cfv vk cv vy cv
      cfv wceq vk c1 cN cfz co wral vx cv vy cv wceq wb vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel vx cv c1 cN cfz co wfn vy cv
      c1 cN cfz co wfn wa vk cv vx cv cfv vk cv vy cv cfv wceq vk c1 cN cfz co
      wral c1 cN cfz co c1 cN cfz co wceq vk cv vx cv cfv vk cv vy cv cfv wceq
      vk c1 cN cfz co wral wa vx cv vy cv wceq vx cv c1 cN cfz co wfn vy cv c1
      cN cfz co wfn wa c1 cN cfz co c1 cN cfz co wceq vk cv vx cv cfv vk cv vy
      cv cfv wceq vk c1 cN cfz co wral vx cv c1 cN cfz co wfn vy cv c1 cN cfz
      co wfn wa c1 cN cfz co eqidd biantrurd vk c1 cN cfz co c1 cN cfz co vx cv
      vy cv eqfnfv bitr4d vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx
      cv wf vx cv c1 cN cfz co wfn cr c1 cN cfz co vx cv reex c1 cN cfz oprex
      elmap c1 cN cfz co cr vx cv ffn sylbi vy cv cr c1 cN cfz co cm co wcel c1
      cN cfz co cr vy cv wf vy cv c1 cN cfz co wfn cr c1 cN cfz co vy cv reex
      c1 cN cfz oprex elmap c1 cN cfz co cr vy cv ffn sylbi syl2an 3adant1
      3bitrd 3bitrd cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel w3a vx cv vy cv cN crrn cfv co vz cv vx cv cN crrn cfv
      co vz cv vy cv cN crrn cfv co caddc co cle wbr vz cN crrn cfv cdm cdm cN
      cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      w3a vz cv cN crrn cfv cdm cdm wcel vz cv cr c1 cN cfz co cm co wcel vx cv
      vy cv cN crrn cfv co vz cv vx cv cN crrn cfv co vz cv vy cv cN crrn cfv
      co caddc co cle wbr cN cn wcel vx cv cr c1 cN cfz co cm co wcel vz cv cN
      crrn cfv cdm cdm wcel vz cv cr c1 cN cfz co cm co wcel wi vy cv cr c1 cN
      cfz co cm co wcel cN cn wcel vz cv cN crrn cfv cdm cdm wcel vz cv cr c1
      cN cfz co cm co wcel cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co
      vz cv cN rrndm eleq2d biimpd 3ad2ant1 cN cn wcel vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel vz cv cr c1 cN cfz co cm co wcel
      vx cv vy cv cN crrn cfv co vz cv vx cv cN crrn cfv co vz cv vy cv cN crrn
      cfv co caddc co cle wbr wi cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel vz cv cr c1 cN cfz co cm co wcel vx cv vy
      cv cN crrn cfv co vz cv vx cv cN crrn cfv co vz cv vy cv cN crrn cfv co
      caddc co cle wbr cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel vz cv cr c1 cN cfz co cm co wcel w3a wa c1 cN cfz co
      vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv c1 cN
      cfz co vk cv vz cv cfv vk cv vx cv cfv cmin co c2 cexp co vk csu csqr cfv
      c1 cN cfz co vk cv vz cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu
      csqr cfv caddc co vx cv vy cv cN crrn cfv co vz cv vx cv cN crrn cfv co
      vz cv vy cv cN crrn cfv co caddc co cle cN cn wcel c1 cN cfz co cr vx cv
      wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a c1 cN cfz co vk
      cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv c1 cN cfz
      co vk cv vz cv cfv vk cv vx cv cfv cmin co c2 cexp co vk csu csqr cfv c1
      cN cfz co vk cv vz cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr
      cfv caddc co cle wbr vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz
      co cm co wcel vz cv cr c1 cN cfz co cm co wcel w3a cN cn wcel c1 cN cfz
      co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a wa
      c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz
      cv cfv cmin co wceq wa vm vn copab cfv vk cv vm cv c1 cN cfz co wcel vn
      cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv caddc
      co c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv vm cv c1 cN cfz co wcel
      vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv
      vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv c2 cexp
      co vk csu csqr cfv caddc co c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv
      cmin co c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv vz cv cfv vk cv vx
      cv cfv cmin co c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv vz cv cfv vk
      cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv caddc co cle cN cn wcel
      c1 cN cfz co cr vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv
      cfv cmin co wceq wa vm vn copab wf c1 cN cfz co cr vm cv c1 cN cfz co
      wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab wf
      c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz
      cv cfv cmin co wceq wa vm vn copab cfv vk cv vm cv c1 cN cfz co wcel vn
      cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv caddc
      co c2 cexp co vk csu csqr cfv c1 cN cfz co vk cv vm cv c1 cN cfz co wcel
      vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv c2
      cexp co vk csu csqr cfv c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv
      vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv c2 cexp
      co vk csu csqr cfv caddc co cle wbr cN cn wcel c1 cN cfz co cr vx cv wf
      c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a wa vk cN vm cv c1
      cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm
      vn copab vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv
      cmin co wceq wa vm vn copab trirn cN cn wcel c1 cN cfz co cr vx cv wf c1
      cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a pm3.26 c1 cN cfz co cr
      vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a c1 cN cfz
      co cr vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin
      co wceq wa vm vn copab wf cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz
      co cr vy cv wf c1 cN cfz co cr vz cv wf w3a vm cv vx cv cfv vm cv vz cv
      cfv cmin co cr wcel vm c1 cN cfz co wral c1 cN cfz co cr vm cv c1 cN cfz
      co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab
      wf c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz
      cv wf w3a vm cv vx cv cfv vm cv vz cv cfv cmin co cr wcel vm c1 cN cfz co
      vm cv vx cv cfv cr wcel vm cv vz cv cfv cr wcel vm cv vx cv cfv vm cv vz
      cv cfv cmin co cr wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf
      c1 cN cfz co cr vz cv wf w3a vm cv c1 cN cfz co wcel wa vm cv vx cv cfv
      vm cv vz cv cfv resubcl c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf
      vm cv c1 cN cfz co wcel vm cv vx cv cfv cr wcel c1 cN cfz co cr vz cv wf
      c1 cN cfz co cr vm cv vx cv ffvelrn 3ad2antl1 c1 cN cfz co cr vz cv wf c1
      cN cfz co cr vx cv wf vm cv c1 cN cfz co wcel vm cv vz cv cfv cr wcel c1
      cN cfz co cr vy cv wf c1 cN cfz co cr vm cv vz cv ffvelrn 3ad2antl3
      sylanc r19.21aiva vm vn c1 cN cfz co cr vm cv vx cv cfv vm cv vz cv cfv
      cmin co vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv
      cmin co wceq wa vm vn copab vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv
      vm cv vz cv cfv cmin co wceq wa vm vn copab eqid fopab2 sylib adantl c1
      cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf
      w3a c1 cN cfz co cr vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv
      vy cv cfv cmin co wceq wa vm vn copab wf cN cn wcel c1 cN cfz co cr vx cv
      wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a vm cv vz cv cfv
      vm cv vy cv cfv cmin co cr wcel vm c1 cN cfz co wral c1 cN cfz co cr vm
      cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq
      wa vm vn copab wf c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN
      cfz co cr vz cv wf w3a vm cv vz cv cfv vm cv vy cv cfv cmin co cr wcel vm
      c1 cN cfz co vm cv vz cv cfv cr wcel vm cv vy cv cfv cr wcel vm cv vz cv
      cfv vm cv vy cv cfv cmin co cr wcel c1 cN cfz co cr vx cv wf c1 cN cfz co
      cr vy cv wf c1 cN cfz co cr vz cv wf w3a vm cv c1 cN cfz co wcel wa vm cv
      vz cv cfv vm cv vy cv cfv resubcl c1 cN cfz co cr vz cv wf c1 cN cfz co
      cr vx cv wf vm cv c1 cN cfz co wcel vm cv vz cv cfv cr wcel c1 cN cfz co
      cr vy cv wf c1 cN cfz co cr vm cv vz cv ffvelrn 3ad2antl3 c1 cN cfz co cr
      vy cv wf c1 cN cfz co cr vx cv wf vm cv c1 cN cfz co wcel vm cv vy cv cfv
      cr wcel c1 cN cfz co cr vz cv wf c1 cN cfz co cr vm cv vy cv ffvelrn
      3ad2antl2 sylanc r19.21aiva vm vn c1 cN cfz co cr vm cv vz cv cfv vm cv
      vy cv cfv cmin co vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy
      cv cfv cmin co wceq wa vm vn copab vm cv c1 cN cfz co wcel vn cv vm cv vz
      cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab eqid fopab2 sylib
      adantl syl3anc cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv
      wf c1 cN cfz co cr vz cv wf w3a wa c1 cN cfz co vk cv vx cv cfv vk cv vy
      cv cfv cmin co c2 cexp co vk csu c1 cN cfz co vk cv vm cv c1 cN cfz co
      wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab
      cfv vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv
      cmin co wceq wa vm vn copab cfv caddc co c2 cexp co vk csu csqr cN cn
      wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz
      cv wf w3a wa c1 cN cfz co vk cv vx cv cfv vk cv vy cv cfv cmin co c2 cexp
      co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv
      cmin co wceq wa vm vn copab cfv vk cv vm cv c1 cN cfz co wcel vn cv vm cv
      vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv caddc co c2
      cexp co vk cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf
      c1 cN cfz co cr vz cv wf w3a wa vk cv c1 cN cfz co wcel wa vk cv vx cv
      cfv vk cv vy cv cfv cmin co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx
      cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv vk cv vm cv c1 cN
      cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn
      copab cfv caddc co c2 cexp cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz
      co cr vy cv wf c1 cN cfz co cr vz cv wf w3a wa vk cv c1 cN cfz co wcel wa
      vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin
      co wceq wa vm vn copab cfv vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz
      cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv caddc co vk cv vx
      cv cfv vk cv vz cv cfv cmin co vk cv vz cv cfv vk cv vy cv cfv cmin co
      caddc co vk cv vx cv cfv vk cv vy cv cfv cmin co vk cv c1 cN cfz co wcel
      vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin
      co wceq wa vm vn copab cfv vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz
      cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv caddc co vk cv vx
      cv cfv vk cv vz cv cfv cmin co vk cv vz cv cfv vk cv vy cv cfv cmin co
      caddc co wceq cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv
      wf c1 cN cfz co cr vz cv wf w3a wa vk cv c1 cN cfz co wcel vk cv vm cv c1
      cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm
      vn copab cfv vk cv vx cv cfv vk cv vz cv cfv cmin co vk cv vm cv c1 cN
      cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn
      copab cfv vk cv vz cv cfv vk cv vy cv cfv cmin co caddc vm vn vk cv vm cv
      vx cv cfv vm cv vz cv cfv cmin co vk cv vx cv cfv vk cv vz cv cfv cmin co
      c1 cN cfz co vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv
      cfv cmin co wceq wa vm vn copab vm cv vk cv wceq vm cv vx cv cfv vk cv vx
      cv cfv vm cv vz cv cfv vk cv vz cv cfv cmin vm cv vk cv vx cv fveq2 vm cv
      vk cv vz cv fveq2 opreq12d vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv
      vm cv vz cv cfv cmin co wceq wa vm vn copab eqid vk cv vx cv cfv vk cv vz
      cv cfv cmin oprex fvopab4 vm vn vk cv vm cv vz cv cfv vm cv vy cv cfv
      cmin co vk cv vz cv cfv vk cv vy cv cfv cmin co c1 cN cfz co vm cv c1 cN
      cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn
      copab vm cv vk cv wceq vm cv vz cv cfv vk cv vz cv cfv vm cv vy cv cfv vk
      cv vy cv cfv cmin vm cv vk cv vz cv fveq2 vm cv vk cv vy cv fveq2
      opreq12d vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv
      cmin co wceq wa vm vn copab eqid vk cv vz cv cfv vk cv vy cv cfv cmin
      oprex fvopab4 opreq12d adantl c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy
      cv wf c1 cN cfz co cr vz cv wf w3a vk cv c1 cN cfz co wcel vk cv vx cv
      cfv vk cv vz cv cfv cmin co vk cv vz cv cfv vk cv vy cv cfv cmin co caddc
      co vk cv vx cv cfv vk cv vy cv cfv cmin co wceq cN cn wcel vk cv vx cv
      cfv cc wcel vk cv vz cv cfv cc wcel vk cv vy cv cfv cc wcel vk cv vx cv
      cfv vk cv vz cv cfv cmin co vk cv vz cv cfv vk cv vy cv cfv cmin co caddc
      co vk cv vx cv cfv vk cv vy cv cfv cmin co wceq c1 cN cfz co cr vx cv wf
      c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a vk cv c1 cN cfz co
      wcel wa vk cv vx cv cfv vk cv vz cv cfv vk cv vy cv cfv npncan c1 cN cfz
      co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a vk
      cv c1 cN cfz co wcel wa vk cv vx cv cfv c1 cN cfz co cr vx cv wf c1 cN
      cfz co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel c1 cN
      cfz co cr vz cv wf c1 cN cfz co cr vk cv vx cv ffvelrn 3ad2antl1 recnd c1
      cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf
      w3a vk cv c1 cN cfz co wcel wa vk cv vz cv cfv c1 cN cfz co cr vz cv wf
      c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vz cv cfv cr wcel
      c1 cN cfz co cr vy cv wf c1 cN cfz co cr vk cv vz cv ffvelrn 3ad2antl3
      recnd c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr
      vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vy cv cfv c1 cN cfz co cr
      vy cv wf c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vy cv cfv
      cr wcel c1 cN cfz co cr vz cv wf c1 cN cfz co cr vk cv vy cv ffvelrn
      3ad2antl2 recnd syl3anc adantll eqtr2d opreq1d sumeq2dv fveq2d cN cn wcel
      c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv
      wf w3a wa c1 cN cfz co vk cv vz cv cfv vk cv vx cv cfv cmin co c2 cexp co
      vk csu csqr cfv c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx
      cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv c2 cexp co vk csu
      csqr cfv c1 cN cfz co vk cv vz cv cfv vk cv vy cv cfv cmin co c2 cexp co
      vk csu csqr cfv c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz
      cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab cfv c2 cexp co vk csu
      csqr cfv caddc cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv
      wf c1 cN cfz co cr vz cv wf w3a wa c1 cN cfz co vk cv vz cv cfv vk cv vx
      cv cfv cmin co c2 cexp co vk csu c1 cN cfz co vk cv vm cv c1 cN cfz co
      wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab
      cfv c2 cexp co vk csu csqr cN cn wcel c1 cN cfz co cr vx cv wf c1 cN cfz
      co cr vy cv wf c1 cN cfz co cr vz cv wf w3a wa c1 cN cfz co vk cv vz cv
      cfv vk cv vx cv cfv cmin co c2 cexp co vk cv vm cv c1 cN cfz co wcel vn
      cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv c2
      cexp co vk c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co
      cr vz cv wf w3a vk cv c1 cN cfz co wcel vk cv vz cv cfv vk cv vx cv cfv
      cmin co c2 cexp co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm
      cv vz cv cfv cmin co wceq wa vm vn copab cfv c2 cexp co wceq cN cn wcel
      c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv
      wf w3a vk cv c1 cN cfz co wcel wa vk cv vz cv cfv vk cv vx cv cfv cmin co
      cneg c2 cexp co vk cv vx cv cfv vk cv vz cv cfv cmin co c2 cexp co vk cv
      vz cv cfv vk cv vx cv cfv cmin co c2 cexp co vk cv vm cv c1 cN cfz co
      wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab
      cfv c2 cexp co c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN
      cfz co cr vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vz cv cfv vk cv
      vx cv cfv cmin co cneg vk cv vx cv cfv vk cv vz cv cfv cmin co c2 cexp vk
      cv vz cv cfv cc wcel vk cv vx cv cfv cc wcel vk cv vz cv cfv vk cv vx cv
      cfv cmin co cneg vk cv vx cv cfv vk cv vz cv cfv cmin co wceq c1 cN cfz
      co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a vk
      cv c1 cN cfz co wcel wa vk cv vz cv cfv vk cv vx cv cfv negsubdi2 c1 cN
      cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a
      vk cv c1 cN cfz co wcel wa vk cv vz cv cfv c1 cN cfz co cr vz cv wf c1 cN
      cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv vz cv cfv cr wcel c1 cN
      cfz co cr vy cv wf c1 cN cfz co cr vk cv vz cv ffvelrn 3ad2antl3 recnd c1
      cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf
      w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv c1 cN cfz co cr vx cv wf
      c1 cN cfz co cr vy cv wf vk cv c1 cN cfz co wcel vk cv vx cv cfv cr wcel
      c1 cN cfz co cr vz cv wf c1 cN cfz co cr vk cv vx cv ffvelrn 3ad2antl1
      recnd sylanc opreq1d c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1
      cN cfz co cr vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vz cv cfv vk
      cv vx cv cfv cmin co cc wcel vk cv vz cv cfv vk cv vx cv cfv cmin co cneg
      c2 cexp co vk cv vz cv cfv vk cv vx cv cfv cmin co c2 cexp co wceq vk cv
      vz cv cfv cc wcel vk cv vx cv cfv cc wcel vk cv vz cv cfv vk cv vx cv cfv
      cmin co cc wcel c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN
      cfz co cr vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vz cv cfv vk cv
      vx cv cfv subcl c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN
      cfz co cr vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vz cv cfv c1 cN
      cfz co cr vz cv wf c1 cN cfz co cr vx cv wf vk cv c1 cN cfz co wcel vk cv
      vz cv cfv cr wcel c1 cN cfz co cr vy cv wf c1 cN cfz co cr vk cv vz cv
      ffvelrn 3ad2antl3 recnd c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf
      c1 cN cfz co cr vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv
      c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf vk cv c1 cN cfz co wcel
      vk cv vx cv cfv cr wcel c1 cN cfz co cr vz cv wf c1 cN cfz co cr vk cv vx
      cv ffvelrn 3ad2antl1 recnd sylanc vk cv vz cv cfv vk cv vx cv cfv cmin co
      sqneg syl c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co
      cr vz cv wf w3a vk cv c1 cN cfz co wcel wa vk cv vx cv cfv vk cv vz cv
      cfv cmin co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz
      cv cfv cmin co wceq wa vm vn copab cfv c2 cexp vk cv c1 cN cfz co wcel vk
      cv vx cv cfv vk cv vz cv cfv cmin co vk cv vm cv c1 cN cfz co wcel vn cv
      vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv wceq c1
      cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf
      w3a vk cv c1 cN cfz co wcel vk cv vm cv c1 cN cfz co wcel vn cv vm cv vx
      cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab cfv vk cv vx cv cfv vk
      cv vz cv cfv cmin co vm vn vk cv vm cv vx cv cfv vm cv vz cv cfv cmin co
      vk cv vx cv cfv vk cv vz cv cfv cmin co c1 cN cfz co vm cv c1 cN cfz co
      wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa vm vn copab vm
      cv vk cv wceq vm cv vx cv cfv vk cv vx cv cfv vm cv vz cv cfv vk cv vz cv
      cfv cmin vm cv vk cv vx cv fveq2 vm cv vk cv vz cv fveq2 opreq12d vm cv
      c1 cN cfz co wcel vn cv vm cv vx cv cfv vm cv vz cv cfv cmin co wceq wa
      vm vn copab eqid vk cv vx cv cfv vk cv vz cv cfv cmin oprex fvopab4
      eqcomd adantl opreq1d 3eqtr3d adantll sumeq2dv fveq2d cN cn wcel c1 cN
      cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a
      wa c1 cN cfz co vk cv vz cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu
      c1 cN cfz co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy
      cv cfv cmin co wceq wa vm vn copab cfv c2 cexp co vk csu csqr cN cn wcel
      c1 cN cfz co cr vx cv wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv
      wf w3a wa c1 cN cfz co vk cv vz cv cfv vk cv vy cv cfv cmin co c2 cexp co
      vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin
      co wceq wa vm vn copab cfv c2 cexp co vk cN cn wcel c1 cN cfz co cr vx cv
      wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a wa vk cv c1 cN
      cfz co wcel wa vk cv vz cv cfv vk cv vy cv cfv cmin co vk cv vm cv c1 cN
      cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn
      copab cfv c2 cexp vk cv c1 cN cfz co wcel vk cv vz cv cfv vk cv vy cv cfv
      cmin co vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy cv
      cfv cmin co wceq wa vm vn copab cfv wceq cN cn wcel c1 cN cfz co cr vx cv
      wf c1 cN cfz co cr vy cv wf c1 cN cfz co cr vz cv wf w3a wa vk cv c1 cN
      cfz co wcel vk cv vm cv c1 cN cfz co wcel vn cv vm cv vz cv cfv vm cv vy
      cv cfv cmin co wceq wa vm vn copab cfv vk cv vz cv cfv vk cv vy cv cfv
      cmin co vm vn vk cv vm cv vz cv cfv vm cv vy cv cfv cmin co vk cv vz cv
      cfv vk cv vy cv cfv cmin co c1 cN cfz co vm cv c1 cN cfz co wcel vn cv vm
      cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab vm cv vk cv wceq
      vm cv vz cv cfv vk cv vz cv cfv vm cv vy cv cfv vk cv vy cv cfv cmin vm
      cv vk cv vz cv fveq2 vm cv vk cv vy cv fveq2 opreq12d vm cv c1 cN cfz co
      wcel vn cv vm cv vz cv cfv vm cv vy cv cfv cmin co wceq wa vm vn copab
      eqid vk cv vz cv cfv vk cv vy cv cfv cmin oprex fvopab4 eqcomd adantl
      opreq1d sumeq2dv fveq2d opreq12d 3brtr4d vx cv cr c1 cN cfz co cm co wcel
      c1 cN cfz co cr vx cv wf vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vy cv wf vz cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vz cv wf cr c1
      cN cfz co vx cv reex c1 cN cfz oprex elmap cr c1 cN cfz co vy cv reex c1
      cN cfz oprex elmap cr c1 cN cfz co vz cv reex c1 cN cfz oprex elmap
      3anbi123i sylan2b cN cn wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel vx cv vy cv cN crrn cfv co c1 cN cfz co vk cv vx cv
      cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq vz cv cr c1
      cN cfz co cm co wcel vk cN vx cv vy cv rrnmval 3adant3r3 cN cn wcel vx cv
      cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel vz cv cr c1
      cN cfz co cm co wcel w3a wa vz cv vx cv cN crrn cfv co c1 cN cfz co vk cv
      vz cv cfv vk cv vx cv cfv cmin co c2 cexp co vk csu csqr cfv vz cv vy cv
      cN crrn cfv co c1 cN cfz co vk cv vz cv cfv vk cv vy cv cfv cmin co c2
      cexp co vk csu csqr cfv caddc cN cn wcel vx cv cr c1 cN cfz co cm co wcel
      vz cv cr c1 cN cfz co cm co wcel vz cv vx cv cN crrn cfv co c1 cN cfz co
      vk cv vz cv cfv vk cv vx cv cfv cmin co c2 cexp co vk csu csqr cfv wceq
      vy cv cr c1 cN cfz co cm co wcel cN cn wcel vz cv cr c1 cN cfz co cm co
      wcel vx cv cr c1 cN cfz co cm co wcel vz cv vx cv cN crrn cfv co c1 cN
      cfz co vk cv vz cv cfv vk cv vx cv cfv cmin co c2 cexp co vk csu csqr cfv
      wceq cN cn wcel vz cv cr c1 cN cfz co cm co wcel vx cv cr c1 cN cfz co cm
      co wcel vz cv vx cv cN crrn cfv co c1 cN cfz co vk cv vz cv cfv vk cv vx
      cv cfv cmin co c2 cexp co vk csu csqr cfv wceq vk cN vz cv vx cv rrnmval
      3expb ancom2s 3adantr2 cN cn wcel vy cv cr c1 cN cfz co cm co wcel vz cv
      cr c1 cN cfz co cm co wcel vz cv vy cv cN crrn cfv co c1 cN cfz co vk cv
      vz cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq vx cv
      cr c1 cN cfz co cm co wcel cN cn wcel vz cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel vz cv vy cv cN crrn cfv co c1 cN cfz co vk
      cv vz cv cfv vk cv vy cv cfv cmin co c2 cexp co vk csu csqr cfv wceq cN
      cn wcel vz cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      vz cv vy cv cN crrn cfv co c1 cN cfz co vk cv vz cv cfv vk cv vy cv cfv
      cmin co c2 cexp co vk csu csqr cfv wceq vk cN vz cv vy cv rrnmval 3expb
      ancom2s 3adantr1 opreq12d 3brtr4d 3exp2 3imp syld r19.21aiv jca 3expib
      sylbid r19.21aivv sylanbrc $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d M k n $. $d X k n $. $d N k n $. $d A k $.
    $d F k n $. $d G k n $. $d R k n $.
    rrndstprj.1 $e |- M = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    rrndstprj.2 $e |- X = ( RR ^m ( 1 ... N ) ) $.
    $( The distance between two points in Euclidean space is greater than the
       distance between the projections onto one coordinate. $)
    rrndstprj $p |- ( ( ( N e. NN /\ A e. ( 1 ... N ) ) /\ ( F e. X
         /\ G e. X ) ) -> ( ( F ` A ) M ( G ` A ) ) <_ ( F ( Rn ` N ) G ) ) $=
      cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa cA cF cfv
      cA cG cfv cmin co cabs cfv c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk csu csqr cfv cA cF cfv cA cG cfv cM co cF cG cN crrn cfv co
      cle cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa cA cF
      cfv cA cG cfv cmin co cabs cfv c1 cN cfz co vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co vk csu csqr cfv cle wbr cA cF cfv cA cG cfv cmin co
      cabs cfv c2 cexp co c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co vk csu csqr cfv c2 cexp co cle wbr cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel cG cX wcel wa wa cA cF cfv cA cG cfv cmin co c2 cexp
      co c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cA cF
      cfv cA cG cfv cmin co cabs cfv c2 cexp co c1 cN cfz co vk cv cF cfv vk cv
      cG cfv cmin co c2 cexp co vk csu csqr cfv c2 cexp co cle cN c1 cuz cfv
      wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF
      cfv vk cv cG cfv cmin co c2 cexp co cle wbr wa vk c1 cN cfz co wral cA c1
      cN cfz co wcel cA cF cfv cA cG cfv cmin co c2 cexp co c1 cN cfz co vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr cN cn wcel cA c1 cN
      cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co cA cF cfv cA cG cfv cmin co c2 cexp co vk cA c1 cN vk cv cA
      wceq vk cv cF cfv vk cv cG cfv cmin co cA cF cfv cA cG cfv cmin co c2
      cexp vk cv cA wceq vk cv cF cfv cA cF cfv vk cv cG cfv cA cG cfv cmin vk
      cv cA cF fveq2 vk cv cA cG fveq2 opreq12d opreq1d fsumlt1 cN cn wcel cA
      c1 cN cfz co wcel wa cN c1 cuz cfv wcel cF cX wcel cG cX wcel wa cn cA c1
      cN elfzuz2 adantr cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX
      wcel wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr wa vk c1 cN cfz co cN cn
      wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz
      co wcel wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF
      cfv vk cv cG cfv cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cr wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk
      cv cG cfv cmin co cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel
      cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv
      resubcl cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel vk cv c1 cN cfz co
      wcel vk cv cF cfv cr wcel cG cX wcel c1 cN cfz co cr cF wf vk cv c1 cN
      cfz co wcel vk cv cF cfv cr wcel cF cX wcel c1 cN cfz co cr vk cv cF
      ffvelrn cF cX wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf cX
      cr c1 cN cfz co cm co cF rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN
      cfz oprex elmap bitri sylanb adantlr adantll cF cX wcel cG cX wcel wa vk
      cv c1 cN cfz co wcel vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co wcel
      wa cG cX wcel vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX wcel c1
      cN cfz co cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cX
      wcel c1 cN cfz co cr vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i
      cr c1 cN cfz co cG reex c1 cN cfz oprex elmap bitri sylanb adantll
      adantll sylanc vk cv cF cfv vk cv cG cfv cmin co resqcl syl cN cn wcel cA
      c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel
      wa vk cv cF cfv vk cv cG cfv cmin co cr wcel cc0 vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co cle wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel
      vk cv cF cfv vk cv cG cfv cmin co cr wcel cN cn wcel cA c1 cN cfz co wcel
      wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk
      cv cG cfv resubcl cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv
      cF cfv cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel vk cv c1 cN
      cfz co wcel vk cv cF cfv cr wcel cG cX wcel c1 cN cfz co cr cF wf vk cv
      c1 cN cfz co wcel vk cv cF cfv cr wcel cF cX wcel c1 cN cfz co cr vk cv
      cF ffvelrn cF cX wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf
      cX cr c1 cN cfz co cm co cF rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1
      cN cfz oprex elmap bitri sylanb adantlr adantll cF cX wcel cG cX wcel wa
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co
      wcel wa cG cX wcel vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX
      wcel c1 cN cfz co cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel
      cG cX wcel c1 cN cfz co cr vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2
      eleq2i cr c1 cN cfz co cG reex c1 cN cfz oprex elmap bitri sylanb adantll
      adantll sylanc vk cv cF cfv vk cv cG cfv cmin co sqge0 syl jca r19.21aiva
      cN cn wcel cA c1 cN cfz co wcel cF cX wcel cG cX wcel wa simplr syl3anc
      cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa cA cF cfv
      cA cG cfv cmin co cr wcel cA cF cfv cA cG cfv cmin co cabs cfv c2 cexp co
      cA cF cfv cA cG cfv cmin co c2 cexp co wceq cA cF cfv cr wcel cA cG cfv
      cr wcel cA cF cfv cA cG cfv cmin co cr wcel cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel cG cX wcel wa wa cA cF cfv cA cG cfv resubcl cA c1 cN
      cfz co wcel cF cX wcel cA cF cfv cr wcel cN cn wcel cG cX wcel cA c1 cN
      cfz co wcel c1 cN cfz co cr cF wf cA cF cfv cr wcel cF cX wcel c1 cN cfz
      co cr cF wf cA c1 cN cfz co wcel cA cF cfv cr wcel c1 cN cfz co cr cA cF
      ffvelrn ancoms cF cX wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2 eleq2i cr c1 cN cfz co cF
      reex c1 cN cfz oprex elmap bitri sylan2b ad2ant2lr cA c1 cN cfz co wcel
      cG cX wcel cA cG cfv cr wcel cN cn wcel cF cX wcel cA c1 cN cfz co wcel
      c1 cN cfz co cr cG wf cA cG cfv cr wcel cG cX wcel c1 cN cfz co cr cG wf
      cA c1 cN cfz co wcel cA cG cfv cr wcel c1 cN cfz co cr cA cG ffvelrn
      ancoms cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf cX
      cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap bitri sylan2b ad2ant2l sylanc cA cF cfv cA cG cfv cmin co
      absresq syl c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk
      csu cr wcel cc0 c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      vk csu cle wbr c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      vk csu csqr cfv c2 cexp co c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk csu wceq cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG
      cX wcel wa wa c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      vk csu sqsqr cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co cr wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co vk csu cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF
      cX wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk
      c1 cN fsumrecl cN cn wcel cA c1 cN cfz co wcel wa cN c1 cuz cfv wcel cF
      cX wcel cG cX wcel wa cn cA c1 cN elfzuz2 adantr cN cn wcel cA c1 cN cfz
      co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co cr wcel vk c1 cN cfz co cN cn wcel cA c1 cN cfz co wcel wa cF
      cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa
      vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel
      cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA
      c1 cN cfz co wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr
      wcel cG cX wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF
      rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri
      sylanb adantlr adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel
      vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv
      c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr
      vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG
      reex c1 cN cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF
      cfv vk cv cG cfv cmin co resqcl syl r19.21aiva sylanc cN c1 cuz cfv wcel
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr cN cn
      wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co vk c1 cN fsumcmp0 cN cn wcel cA c1 cN cfz co
      wcel wa cN c1 cuz cfv wcel cF cX wcel cG cX wcel wa cn cA c1 cN elfzuz2
      adantr cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk
      cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv
      cG cfv cmin co c2 cexp co cle wbr wa vk c1 cN cfz co cN cn wcel cA c1 cN
      cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk
      cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv
      cG cfv cmin co c2 cexp co cle wbr cN cn wcel cA c1 cN cfz co wcel wa cF
      cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa
      vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel
      cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA
      c1 cN cfz co wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr
      wcel cG cX wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF
      rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri
      sylanb adantlr adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel
      vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv
      c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr
      vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG
      reex c1 cN cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF
      cfv vk cv cG cfv cmin co resqcl syl cN cn wcel cA c1 cN cfz co wcel wa cF
      cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle
      wbr vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv
      cmin co cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel
      wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX
      wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn
      wcel cA c1 cN cfz co wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cX wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk
      cv cF cfv cr wcel cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel
      cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm
      co cF rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      bitri sylanb adantlr adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr
      cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz
      co cr vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz
      co cG reex c1 cN cfz oprex elmap bitri sylanb adantll adantll sylanc vk
      cv cF cfv vk cv cG cfv cmin co sqge0 syl jca r19.21aiva sylanc sylanc
      3brtr4d cA cF cfv cA cG cfv cmin co cabs cfv cr wcel cc0 cA cF cfv cA cG
      cfv cmin co cabs cfv cle wbr c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co vk csu csqr cfv cr wcel cc0 c1 cN cfz co vk cv cF cfv vk cv
      cG cfv cmin co c2 cexp co vk csu csqr cfv cle wbr cA cF cfv cA cG cfv
      cmin co cabs cfv c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co vk csu csqr cfv cle wbr cA cF cfv cA cG cfv cmin co cabs cfv c2 cexp
      co c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr
      cfv c2 cexp co cle wbr wb cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel
      cG cX wcel wa wa cA cF cfv cA cG cfv cmin co cabs cfv c1 cN cfz co vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv le2sq cN cn wcel
      cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa cA cF cfv cA cG cfv
      cmin co cr wcel cA cF cfv cA cG cfv cmin co cc wcel cA cF cfv cA cG cfv
      cmin co cabs cfv cr wcel cA cF cfv cr wcel cA cG cfv cr wcel cA cF cfv cA
      cG cfv cmin co cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG
      cX wcel wa wa cA cF cfv cA cG cfv resubcl cA c1 cN cfz co wcel cF cX wcel
      cA cF cfv cr wcel cN cn wcel cG cX wcel cA c1 cN cfz co wcel c1 cN cfz co
      cr cF wf cA cF cfv cr wcel cF cX wcel c1 cN cfz co cr cF wf cA c1 cN cfz
      co wcel cA cF cfv cr wcel c1 cN cfz co cr cA cF ffvelrn ancoms cF cX wcel
      cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm
      co cF rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      bitri sylan2b ad2ant2lr cA c1 cN cfz co wcel cG cX wcel cA cG cfv cr wcel
      cN cn wcel cF cX wcel cA c1 cN cfz co wcel c1 cN cfz co cr cG wf cA cG
      cfv cr wcel cG cX wcel c1 cN cfz co cr cG wf cA c1 cN cfz co wcel cA cG
      cfv cr wcel c1 cN cfz co cr cA cG ffvelrn ancoms cG cX wcel cG cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr cG wf cX cr c1 cN cfz co cm co cG
      rrndstprj.2 eleq2i cr c1 cN cfz co cG reex c1 cN cfz oprex elmap bitri
      sylan2b ad2ant2l sylanc cA cF cfv cA cG cfv cmin co recn cA cF cfv cA cG
      cfv cmin co abscl 3syl cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG
      cX wcel wa wa cA cF cfv cA cG cfv cmin co cr wcel cA cF cfv cA cG cfv
      cmin co cc wcel cc0 cA cF cfv cA cG cfv cmin co cabs cfv cle wbr cA cF
      cfv cr wcel cA cG cfv cr wcel cA cF cfv cA cG cfv cmin co cr wcel cN cn
      wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa cA cF cfv cA cG
      cfv resubcl cA c1 cN cfz co wcel cF cX wcel cA cF cfv cr wcel cN cn wcel
      cG cX wcel cA c1 cN cfz co wcel c1 cN cfz co cr cF wf cA cF cfv cr wcel
      cF cX wcel c1 cN cfz co cr cF wf cA c1 cN cfz co wcel cA cF cfv cr wcel
      c1 cN cfz co cr cA cF ffvelrn ancoms cF cX wcel cF cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2 eleq2i
      cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri sylan2b ad2ant2lr cA
      c1 cN cfz co wcel cG cX wcel cA cG cfv cr wcel cN cn wcel cF cX wcel cA
      c1 cN cfz co wcel c1 cN cfz co cr cG wf cA cG cfv cr wcel cG cX wcel c1
      cN cfz co cr cG wf cA c1 cN cfz co wcel cA cG cfv cr wcel c1 cN cfz co cr
      cA cG ffvelrn ancoms cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz
      co cG reex c1 cN cfz oprex elmap bitri sylan2b ad2ant2l sylanc cA cF cfv
      cA cG cfv cmin co recn cA cF cfv cA cG cfv cmin co absge0 3syl c1 cN cfz
      co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cr wcel cc0 c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu sqrcl cN c1
      cuz cfv wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk c1
      cN cfz co wral c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      vk csu cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel
      wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk c1 cN fsumrecl cN
      cn wcel cA c1 cN cfz co wcel wa cN c1 cuz cfv wcel cF cX wcel cG cX wcel
      wa cn cA c1 cN elfzuz2 adantr cN cn wcel cA c1 cN cfz co wcel wa cF cX
      wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel vk c1 cN cfz co cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX
      wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co
      cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN
      cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN
      cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel cG cX wcel wa
      vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cX
      wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel
      cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2
      eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri sylanb adantlr
      adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cG cfv cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf vk cv c1 cN
      cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr vk cv cG
      ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf cX
      cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF cfv vk cv cG
      cfv cmin co resqcl syl r19.21aiva sylanc cN c1 cuz cfv wcel vk cv cF cfv
      vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr cN cn wcel cA c1 cN
      cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co vk c1 cN fsumcmp0 cN cn wcel cA c1 cN cfz co wcel wa cN c1
      cuz cfv wcel cF cX wcel cG cX wcel wa cn cA c1 cN elfzuz2 adantr cN cn
      wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co cle wbr wa vk c1 cN cfz co cN cn wcel cA c1 cN cfz co wcel
      wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co cle wbr cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX
      wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co
      cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN
      cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN
      cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel cG cX wcel wa
      vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cX
      wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel
      cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2
      eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri sylanb adantlr
      adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cG cfv cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf vk cv c1 cN
      cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr vk cv cG
      ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf cX
      cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF cfv vk cv cG
      cfv cmin co resqcl syl cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG
      cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr vk cv
      cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv
      c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel cG cX
      wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA c1 cN
      cfz co wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG
      cX wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr
      wcel cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF
      rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri
      sylanb adantlr adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel
      vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv
      c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr
      vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG
      reex c1 cN cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF
      cfv vk cv cG cfv cmin co sqge0 syl jca r19.21aiva sylanc sylanc c1 cN cfz
      co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cr wcel cc0 c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr cc0 c1
      cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv
      cle wbr cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa c1
      cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu sqrge0 cN
      c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk
      c1 cN cfz co wral c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co vk csu cr wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX
      wcel wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk c1 cN fsumrecl
      cN cn wcel cA c1 cN cfz co wcel wa cN c1 cuz cfv wcel cF cX wcel cG cX
      wcel wa cn cA c1 cN elfzuz2 adantr cN cn wcel cA c1 cN cfz co wcel wa cF
      cX wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel vk c1 cN cfz co cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX
      wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co
      cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN
      cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN
      cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel cG cX wcel wa
      vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cX
      wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel
      cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2
      eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri sylanb adantlr
      adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cG cfv cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf vk cv c1 cN
      cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr vk cv cG
      ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf cX
      cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF cfv vk cv cG
      cfv cmin co resqcl syl r19.21aiva sylanc cN c1 cuz cfv wcel vk cv cF cfv
      vk cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr cN cn wcel cA c1 cN
      cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co vk c1 cN fsumcmp0 cN cn wcel cA c1 cN cfz co wcel wa cN c1
      cuz cfv wcel cF cX wcel cG cX wcel wa cn cA c1 cN elfzuz2 adantr cN cn
      wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co cle wbr wa vk c1 cN cfz co cN cn wcel cA c1 cN cfz co wcel
      wa cF cX wcel cG cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co cle wbr cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX
      wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co
      cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk cv cF cfv
      cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN
      cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv c1 cN
      cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel cG cX wcel wa
      vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA c1 cN cfz co
      wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cX
      wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel
      cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2
      eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri sylanb adantlr
      adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel vk cv cG cfv cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf vk cv c1 cN
      cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr vk cv cG
      ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf cX
      cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF cfv vk cv cG
      cfv cmin co resqcl syl cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG
      cX wcel wa wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr vk cv
      cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr
      wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa vk cv
      c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cX wcel cG cX
      wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cN cn wcel cA c1 cN
      cfz co wcel wa cF cX wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG
      cX wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr
      wcel cF cX wcel c1 cN cfz co cr vk cv cF ffvelrn cF cX wcel cF cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr cF wf cX cr c1 cN cfz co cm co cF
      rrndstprj.2 eleq2i cr c1 cN cfz co cF reex c1 cN cfz oprex elmap bitri
      sylanb adantlr adantll cF cX wcel cG cX wcel wa vk cv c1 cN cfz co wcel
      vk cv cG cfv cr wcel cN cn wcel cA c1 cN cfz co wcel wa cG cX wcel vk cv
      c1 cN cfz co wcel vk cv cG cfv cr wcel cF cX wcel c1 cN cfz co cr cG wf
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cX wcel c1 cN cfz co cr
      vk cv cG ffvelrn cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG
      reex c1 cN cfz oprex elmap bitri sylanb adantll adantll sylanc vk cv cF
      cfv vk cv cG cfv cmin co sqge0 syl jca r19.21aiva sylanc sylanc syl2anc
      mpbird cA cF cfv cr wcel cA cG cfv cr wcel cA cF cfv cA cG cfv cM co cA
      cF cfv cA cG cfv cmin co cabs cfv wceq cN cn wcel cA c1 cN cfz co wcel wa
      cF cX wcel cG cX wcel wa wa cA cF cfv cA cG cfv cM rrndstprj.1 remetdval
      cA c1 cN cfz co wcel cF cX wcel cA cF cfv cr wcel cN cn wcel cG cX wcel
      cA c1 cN cfz co wcel c1 cN cfz co cr cF wf cA cF cfv cr wcel cF cX wcel
      c1 cN cfz co cr cF wf cA c1 cN cfz co wcel cA cF cfv cr wcel c1 cN cfz co
      cr cA cF ffvelrn ancoms cF cX wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr cF wf cX cr c1 cN cfz co cm co cF rrndstprj.2 eleq2i cr c1 cN
      cfz co cF reex c1 cN cfz oprex elmap bitri sylan2b ad2ant2lr cA c1 cN cfz
      co wcel cG cX wcel cA cG cfv cr wcel cN cn wcel cF cX wcel cA c1 cN cfz
      co wcel c1 cN cfz co cr cG wf cA cG cfv cr wcel cG cX wcel c1 cN cfz co
      cr cG wf cA c1 cN cfz co wcel cA cG cfv cr wcel c1 cN cfz co cr cA cG
      ffvelrn ancoms cG cX wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cG wf cX cr c1 cN cfz co cm co cG rrndstprj.2 eleq2i cr c1 cN cfz co cG
      reex c1 cN cfz oprex elmap bitri sylan2b ad2ant2l sylanc cN cn wcel cF cr
      c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel cF cG cN crrn cfv
      co c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr
      cfv wceq cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG cX wcel wa wa
      vk cN cF cG rrnmval cN cn wcel cA c1 cN cfz co wcel cF cX wcel cG cX wcel
      wa simpll cF cX wcel cF cr c1 cN cfz co cm co wcel cN cn wcel cA c1 cN
      cfz co wcel wa cG cX wcel cF cX wcel cF cr c1 cN cfz co cm co wcel cX cr
      c1 cN cfz co cm co cF rrndstprj.2 eleq2i biimpi ad2antrl cG cX wcel cG cr
      c1 cN cfz co cm co wcel cN cn wcel cA c1 cN cfz co wcel wa cF cX wcel cG
      cX wcel cG cr c1 cN cfz co cm co wcel cX cr c1 cN cfz co cm co cG
      rrndstprj.2 eleq2i biimpi ad2antll syl3anc 3brtr4d $.
      $( [2-Sep-2009] $)

    $( Bound on the distance between two points in Euclidean space given bounds
       on the distances in each coordinate. This theorem and ~ rrndstprj can be
       used to show that the supremum norm and Euclidean norm are
       equivalent. $)
    rrndstprj2 $p |- ( ( ( N e. NN /\ F e. X /\ G e. X ) /\ ( R e. RR+ /\
                    A. n e. ( 1 ... N ) ( ( F ` n ) M ( G ` n ) ) < R ) ) ->
                                ( F ( Rn ` N ) G ) < ( R x. ( sqr ` N ) ) ) $=
      cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel
      w3a cR crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr vn c1 cN cfz
      co wral wa cF cG cN crrn cfv co cR cN csqr cfv cmul co clt wbr cN cn wcel
      cF cX wcel cG cX wcel w3a cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr
      c1 cN cfz co cm co wcel w3a cR crp wcel vn cv cF cfv vn cv cG cfv cM co
      cR clt wbr vn c1 cN cfz co wral wa wa cF cG cN crrn cfv co c1 cN cfz co
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv cR cN csqr
      cfv cmul co clt cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz
      co cm co wcel w3a cF cG cN crrn cfv co c1 cN cfz co vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co vk csu csqr cfv wceq cR crp wcel vn cv cF cfv vn
      cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral wa vk cN cF cG rrnmval
      adantr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a cR crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr vn c1 cN
      cfz co wral wa wa c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co vk csu csqr cfv cR cN csqr cfv cmul co clt wbr c1 cN cfz co vk cv cF
      cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv c2 cexp co cR cN csqr
      cfv cmul co c2 cexp co clt wbr cN cn wcel cF cr c1 cN cfz co cm co wcel
      cG cr c1 cN cfz co cm co wcel w3a cR crp wcel vn cv cF cfv vn cv cG cfv
      cM co cR clt wbr vn c1 cN cfz co wral wa wa c1 cN cfz co vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co vk csu cN cR c2 cexp co cmul co c1 cN cfz co
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv c2 cexp co
      cR cN csqr cfv cmul co c2 cexp co clt cN cn wcel cF cr c1 cN cfz co cm co
      wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel vn cv cF cfv vn cv cG
      cfv cM co cR clt wbr vn c1 cN cfz co wral wa wa c1 cN cfz co vk cv cF cfv
      vk cv cG cfv cmin co c2 cexp co vk csu c1 cN cfz co cR c2 cexp co vk csu
      cN cR c2 cexp co cmul co clt cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co cr wcel cR c2 cexp co cr wcel vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co cR c2 cexp co clt wbr w3a vk c1 cN cfz co wral c1
      cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu c1 cN cfz
      co cR c2 cexp co vk csu clt wbr cN cn wcel cF cr c1 cN cfz co cm co wcel
      cG cr c1 cN cfz co cm co wcel w3a cR crp wcel vn cv cF cfv vn cv cG cfv
      cM co cR clt wbr vn c1 cN cfz co wral wa wa vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co cR c2 cexp co vk c1 cN fsumlt cN cn wcel cF cr c1 cN
      cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cN c1 cuz cfv wcel cR
      crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral
      wa cN cn wcel cF cr c1 cN cfz co cm co wcel cN c1 cuz cfv wcel cG cr c1
      cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi
      3ad2ant1 adantr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz
      co cm co wcel w3a cR crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr
      vn c1 cN cfz co wral wa wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      cr wcel cR c2 cexp co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co cR c2 cexp co clt wbr w3a vk c1 cN cfz co cN cn wcel cF cr c1 cN cfz
      co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel vn cv cF cfv
      vn cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral wa wa vk cv c1 cN cfz
      co wcel wa vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel cR c2
      cexp co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cR c2 cexp
      co clt wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cr wcel cR crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr vn
      c1 cN cfz co wral wa cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl
      cF cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      resqcl syl adantlr cR crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr
      vn c1 cN cfz co wral wa cR c2 cexp co cr wcel cN cn wcel cF cr c1 cN cfz
      co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel
      cR crp wcel cR c2 cexp co cr wcel vn cv cF cfv vn cv cG cfv cM co cR clt
      wbr vn c1 cN cfz co wral cR crp wcel cR cr wcel cR c2 cexp co cr wcel cR
      rpre cR resqcl syl adantr ad2antlr cN cn wcel cF cr c1 cN cfz co cm co
      wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel vn cv cF cfv vn cv cG
      cfv cM co cR clt wbr vn c1 cN cfz co wral wa wa vk cv c1 cN cfz co wcel
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cR c2 cexp co clt wbr cN cn
      wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR
      crp wcel vn cv cF cfv vn cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral
      vk cv c1 cN cfz co wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cR
      c2 cexp co clt wbr wi cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1
      cN cfz co cm co wcel w3a cR crp wcel wa vn cv cF cfv vn cv cG cfv cM co
      cR clt wbr vn c1 cN cfz co wral vk cv c1 cN cfz co wcel vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co cR c2 cexp co clt wbr cN cn wcel cF cr c1 cN
      cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel wa vk cv
      c1 cN cfz co wcel vk cv cF cfv vk cv cG cfv cM co cR clt wbr wa vk cv cF
      cfv vk cv cG cfv cmin co c2 cexp co cR c2 cexp co clt wbr vn cv cF cfv vn
      cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral vk cv c1 cN cfz co wcel
      wa cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel
      w3a cR crp wcel wa vk cv c1 cN cfz co wcel vk cv cF cfv vk cv cG cfv cM
      co cR clt wbr wa wa vk cv cF cfv vk cv cG cfv cM co c2 cexp co vk cv cF
      cfv vk cv cG cfv cmin co c2 cexp co cR c2 cexp co clt cN cn wcel cF cr c1
      cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel vk cv cF cfv vk cv cG cfv cM co c2 cexp co vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co wceq cR crp wcel vk cv cF cfv vk cv cG cfv cM co cR
      clt wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cM co c2
      cexp co vk cv cF cfv vk cv cG cfv cmin co cabs cfv c2 cexp co vk cv cF
      cfv vk cv cG cfv cmin co c2 cexp co cN cn wcel cF cr c1 cN cfz co cm co
      wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv
      cF cfv vk cv cG cfv cM co vk cv cF cfv vk cv cG cfv cmin co cabs cfv c2
      cexp vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv
      cM co vk cv cF cfv vk cv cG cfv cmin co cabs cfv wceq cN cn wcel cF cr c1
      cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel wa vk cv cF cfv vk cv cG cfv cM rrndstprj.1 remetdval cF cr c1 cN
      cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel
      cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co
      wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap sylanb
      3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co cm
      co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc opreq1d cN cn wcel cF cr c1 cN
      cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel wa vk cv cF cfv vk cv cG cfv cmin co cr wcel vk cv cF cfv vk cv cG
      cfv cmin co cabs cfv c2 cexp co vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co wceq vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG
      cfv cmin co cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv resubcl cF cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co
      wcel vk cv cF cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm
      co wcel c1 cN cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN
      cfz oprex elmap sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel
      vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel
      cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN
      cfz co cG reex c1 cN cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv
      vk cv cG cfv cmin co absresq syl eqtrd ad2ant2r cN cn wcel cF cr c1 cN
      cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel wa vk cv
      c1 cN cfz co wcel vk cv cF cfv vk cv cG cfv cM co cR clt wbr vk cv cF cfv
      vk cv cG cfv cM co c2 cexp co cR c2 cexp co clt wbr cN cn wcel cF cr c1
      cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel wa vk
      cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cM co cR clt wbr vk cv
      cF cfv vk cv cG cfv cM co c2 cexp co cR c2 cexp co clt wbr vk cv cF cfv
      vk cv cG cfv cM co cr wcel cc0 vk cv cF cfv vk cv cG cfv cM co cle wbr cR
      cr wcel cc0 cR cle wbr vk cv cF cfv vk cv cG cfv cM co cR clt wbr vk cv
      cF cfv vk cv cG cfv cM co c2 cexp co cR c2 cexp co clt wbr wb cN cn wcel
      cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp
      wcel wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cM co cR
      lt2sq cM cme wcel vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv
      vk cv cG cfv cM co cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr
      c1 cN cfz co cm co wcel w3a cR crp wcel wa vk cv c1 cN cfz co wcel wa vk
      cv cF cfv vk cv cG cfv cM cr cM rrndstprj.1 remetba metcl cM cme wcel cN
      cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a
      cR crp wcel wa vk cv c1 cN cfz co wcel wa cM rrndstprj.1 remet a1i cN cn
      wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk
      cv c1 cN cfz co wcel vk cv cF cfv cr wcel cR crp wcel cF cr c1 cN cfz co
      cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cr
      c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk
      cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv cF
      ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap sylanb 3ad2antl2
      adantlr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cR crp wcel cG cr
      c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cG cfv
      cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf vk cv c1 cN
      cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN cfz oprex elmap
      sylanb 3ad2antl3 adantlr syl3anc cM cme wcel vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel cc0 vk cv cF cfv vk cv cG cfv cM co cle wbr cN cn wcel cF
      cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel
      wa vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cM cr cM
      rrndstprj.1 remetba metge0 cM cme wcel cN cn wcel cF cr c1 cN cfz co cm
      co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel wa vk cv c1 cN cfz
      co wcel wa cM rrndstprj.1 remet a1i cN cn wcel cF cr c1 cN cfz co cm co
      wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cR crp wcel cF cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF
      reex c1 cN cfz oprex elmap sylanb 3ad2antl2 adantlr cN cn wcel cF cr c1
      cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz co
      wcel vk cv cG cfv cr wcel cR crp wcel cG cr c1 cN cfz co cm co wcel cN cn
      wcel vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm
      co wcel c1 cN cfz co cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr
      wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1
      cN cfz co cG reex c1 cN cfz oprex elmap sylanb 3ad2antl3 adantlr syl3anc
      cR crp wcel cR cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1
      cN cfz co cm co wcel w3a vk cv c1 cN cfz co wcel cR rpre ad2antlr cR crp
      wcel cc0 cR cle wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel cR rpge0 ad2antlr syl2anc
      biimpa anasss eqbrtrrd vk cv c1 cN cfz co wcel vn cv cF cfv vn cv cG cfv
      cM co cR clt wbr vn c1 cN cfz co wral vk cv c1 cN cfz co wcel vk cv cF
      cfv vk cv cG cfv cM co cR clt wbr wa vk cv c1 cN cfz co wcel vn cv cF cfv
      vn cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral vk cv cF cfv vk cv cG
      cfv cM co cR clt wbr vn cv cF cfv vn cv cG cfv cM co cR clt wbr vk cv cF
      cfv vk cv cG cfv cM co cR clt wbr vn vk cv c1 cN cfz co vn cv vk cv wceq
      vn cv cF cfv vn cv cG cfv cM co vk cv cF cfv vk cv cG cfv cM co cR clt vn
      cv vk cv wceq vn cv cF cfv vk cv cF cfv vn cv cG cfv vk cv cG cfv cM vn
      cv vk cv cF fveq2 vn cv vk cv cG fveq2 opreq12d breq1d rcla4v imdistani
      ancoms sylan2 expr anasss imp 3jca r19.21aiva sylanc cN cn wcel cF cr c1
      cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel c1 cN
      cfz co cR c2 cexp co vk csu cN cR c2 cexp co cmul co wceq vn cv cF cfv vn
      cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral cN cn wcel cF cr c1 cN
      cfz co cm co wcel cR crp wcel c1 cN cfz co cR c2 cexp co vk csu cN cR c2
      cexp co cmul co wceq cG cr c1 cN cfz co cm co wcel cN cn wcel cR crp wcel
      wa c1 cN cfz co cR c2 cexp co vk csu cN c1 cmin co c1 caddc co cR c2 cexp
      co cmul co cN cR c2 cexp co cmul co cN c1 cuz cfv wcel cR c2 cexp co cc
      wcel c1 cN cfz co cR c2 cexp co vk csu cN c1 cmin co c1 caddc co cR c2
      cexp co cmul co wceq cN cn wcel cR crp wcel cR c2 cexp co vk c1 cN
      fsumconst cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi cR crp wcel cR
      cc wcel cR c2 cexp co cc wcel cR rpcn cR sqcl syl syl2an cN cn wcel cR
      crp wcel wa cN c1 cmin co c1 caddc co cN cR c2 cexp co cmul cN cn wcel cN
      c1 cmin co c1 caddc co cN wceq cR crp wcel cN cc wcel c1 cc wcel cN c1
      cmin co c1 caddc co cN wceq cN cn wcel cN c1 npcan cN nncn ax1cn sylancl
      adantr opreq1d eqtrd 3ad2antl1 adantrr breqtrd cN cn wcel cF cr c1 cN cfz
      co cm co wcel cG cr c1 cN cfz co cm co wcel w3a c1 cN cfz co vk cv cF cfv
      vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv c2 cexp co c1 cN cfz co
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu wceq cR crp wcel vn
      cv cF cfv vn cv cG cfv cM co cR clt wbr vn c1 cN cfz co wral wa c1 cN cfz
      co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cr wcel cc0 c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv c2
      cexp co c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu
      wceq cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu
      sqsqr cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk csu cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr
      c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      vk c1 cN fsumrecl cN cn wcel cF cr c1 cN cfz co cm co wcel cN c1 cuz cfv
      wcel cG cr c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv wcel cN
      elnnuz biimpi 3ad2ant1 cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1
      cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel vk c1 cN cfz co cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl
      cF cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      resqcl syl r19.21aiva sylanc cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co vk csu cle wbr cN cn wcel cF cr c1 cN cfz co cm co
      wcel cG cr c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk c1 cN fsumcmp0 cN cn wcel cF cr c1 cN cfz co cm co wcel cN
      c1 cuz cfv wcel cG cr c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv
      wcel cN elnnuz biimpi 3ad2ant1 cN cn wcel cF cr c1 cN cfz co cm co wcel
      cG cr c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr
      wa vk c1 cN cfz co cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cle wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz
      co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv
      cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk
      cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co
      cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      resqcl syl cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co
      cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr
      wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      sqge0 syl jca r19.21aiva sylanc sylanc adantr cN cn wcel cF cr c1 cN cfz
      co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel cR cN csqr
      cfv cmul co c2 cexp co cN cR c2 cexp co cmul co wceq vn cv cF cfv vn cv
      cG cfv cM co cR clt wbr vn c1 cN cfz co wral cN cn wcel cF cr c1 cN cfz
      co cm co wcel cR crp wcel cR cN csqr cfv cmul co c2 cexp co cN cR c2 cexp
      co cmul co wceq cG cr c1 cN cfz co cm co wcel cN cn wcel cR crp wcel wa
      cN csqr cfv cR cmul co c2 cexp co cN csqr cfv c2 cexp co cR c2 cexp co
      cmul co cR cN csqr cfv cmul co c2 cexp co cN cR c2 cexp co cmul co cN
      csqr cfv cc wcel cR cc wcel cN csqr cfv cR cmul co c2 cexp co cN csqr cfv
      c2 cexp co cR c2 cexp co cmul co wceq cN cn wcel cR crp wcel cN csqr cfv
      cR sqmul cN cn wcel cN csqr cfv cN cr wcel cc0 cN cle wbr cN csqr cfv cr
      wcel cN cn wcel cN sqrcl cN nnre cN cn wcel cN cn0 wcel cc0 cN cle wbr cN
      nnnn0 cN nn0ge0 syl sylanc recnd cR rpcn syl2an cN cn wcel cR crp wcel wa
      cN csqr cfv cR cmul co cR cN csqr cfv cmul co c2 cexp cN csqr cfv cc wcel
      cR cc wcel cN csqr cfv cR cmul co cR cN csqr cfv cmul co wceq cN cn wcel
      cR crp wcel cN csqr cfv cR mulcom cN cn wcel cN csqr cfv cN cr wcel cc0
      cN cle wbr cN csqr cfv cr wcel cN cn wcel cN sqrcl cN nnre cN cn wcel cN
      cn0 wcel cc0 cN cle wbr cN nnnn0 cN nn0ge0 syl sylanc recnd cR rpcn
      syl2an opreq1d cN cn wcel cR crp wcel wa cN csqr cfv c2 cexp co cN cR c2
      cexp co cmul cN cn wcel cN csqr cfv c2 cexp co cN wceq cR crp wcel cN cr
      wcel cc0 cN cle wbr cN csqr cfv c2 cexp co cN wceq cN cn wcel cN sqsqr cN
      nnre cN cn wcel cN cn0 wcel cc0 cN cle wbr cN nnnn0 cN nn0ge0 syl sylanc
      adantr opreq1d 3eqtr3d 3ad2antl1 adantrr 3brtr4d cN cn wcel cF cr c1 cN
      cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel c1 cN cfz
      co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv cR cN
      csqr cfv cmul co clt wbr c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk csu csqr cfv c2 cexp co cR cN csqr cfv cmul co c2 cexp co
      clt wbr wb vn cv cF cfv vn cv cG cfv cM co cR clt wbr vn c1 cN cfz co
      wral c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu
      csqr cfv cr wcel cc0 c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co vk csu csqr cfv cle wbr cR cN csqr cfv cmul co cr wcel cc0 cR cN
      csqr cfv cmul co cle wbr c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk csu csqr cfv cR cN csqr cfv cmul co clt wbr c1 cN cfz co vk
      cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv c2 cexp co cR
      cN csqr cfv cmul co c2 cexp co clt wbr wb cN cn wcel cF cr c1 cN cfz co
      cm co wcel cG cr c1 cN cfz co cm co wcel w3a cR crp wcel wa c1 cN cfz co
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv cR cN csqr
      cfv cmul co lt2sq cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co vk csu csqr cfv cr wcel cR crp wcel c1 cN cfz co vk cv cF cfv vk
      cv cG cfv cmin co c2 cexp co vk csu cr wcel cc0 c1 cN cfz co vk cv cF cfv
      vk cv cG cfv cmin co c2 cexp co vk csu cle wbr c1 cN cfz co vk cv cF cfv
      vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv cr wcel cN cn wcel cF cr
      c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a c1 cN cfz co vk
      cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu sqrcl cN c1 cuz cfv wcel
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk c1 cN cfz co wral
      c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cr wcel
      cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel
      w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk c1 cN fsumrecl cN cn
      wcel cF cr c1 cN cfz co cm co wcel cN c1 cuz cfv wcel cG cr c1 cN cfz co
      cm co wcel cN cn wcel cN c1 cuz cfv wcel cN elnnuz biimpi 3ad2ant1 cN cn
      wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk
      cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk c1 cN cfz co cN cn
      wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk
      cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co cr wcel vk cv
      cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk cv cF cfv cr wcel vk cv
      cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN cn wcel cF cr
      c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1 cN cfz
      co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cr c1 cN cfz co cm co
      wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv cF
      ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap sylanb 3ad2antl2 cG
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cG
      cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf vk cv c1
      cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN cfz oprex elmap
      sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co resqcl syl
      r19.21aiva sylanc cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr
      wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin
      co c2 cexp co vk csu cle wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG
      cr c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co vk c1 cN fsumcmp0 cN cn wcel cF cr c1 cN cfz co cm co wcel cN c1 cuz
      cfv wcel cG cr c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv wcel cN
      elnnuz biimpi 3ad2ant1 cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1
      cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr wa vk c1 cN
      cfz co cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr
      cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel
      w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co cr wcel
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk cv cF cfv cr wcel
      vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN cn wcel
      cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1
      cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cr c1 cN cfz co cm
      co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cr c1
      cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv
      cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv cF
      ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap sylanb 3ad2antl2 cG
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cG
      cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf vk cv c1
      cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN cfz oprex elmap
      sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co resqcl syl cN
      cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a
      vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co cr wcel cc0
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr vk cv cF cfv cr wcel
      vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr wcel cN cn wcel
      cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co wcel w3a vk cv c1
      cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF cr c1 cN cfz co cm
      co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF cfv cr wcel cG cr c1
      cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1 cN cfz co wcel vk cv
      cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr vk cv cF
      ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap sylanb 3ad2antl2 cG
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cG
      cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co cr cG wf vk cv c1
      cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN cfz oprex elmap
      sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co sqge0 syl jca
      r19.21aiva sylanc sylanc adantr cN cn wcel cF cr c1 cN cfz co cm co wcel
      cG cr c1 cN cfz co cm co wcel w3a cc0 c1 cN cfz co vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co vk csu csqr cfv cle wbr cR crp wcel c1 cN cfz co
      vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cr wcel cc0 c1 cN cfz
      co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu cle wbr cc0 c1 cN
      cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu csqr cfv cle
      wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co c2 cexp co vk csu
      sqrge0 cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel vk c1 cN cfz co wral c1 cN cfz co vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk csu cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr
      c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp co
      vk c1 cN fsumrecl cN cn wcel cF cr c1 cN cfz co cm co wcel cN c1 cuz cfv
      wcel cG cr c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv wcel cN
      elnnuz biimpi 3ad2ant1 cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1
      cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr
      wcel vk c1 cN cfz co cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel
      vk cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin
      co cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl
      cF cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      resqcl syl r19.21aiva sylanc cN c1 cuz cfv wcel vk cv cF cfv vk cv cG cfv
      cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp
      co cle wbr wa vk c1 cN cfz co wral cc0 c1 cN cfz co vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co vk csu cle wbr cN cn wcel cF cr c1 cN cfz co cm co
      wcel cG cr c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co
      c2 cexp co vk c1 cN fsumcmp0 cN cn wcel cF cr c1 cN cfz co cm co wcel cN
      c1 cuz cfv wcel cG cr c1 cN cfz co cm co wcel cN cn wcel cN c1 cuz cfv
      wcel cN elnnuz biimpi 3ad2ant1 cN cn wcel cF cr c1 cN cfz co cm co wcel
      cG cr c1 cN cfz co cm co wcel w3a vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr
      wa vk c1 cN cfz co cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN
      cfz co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG
      cfv cmin co c2 cexp co cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2
      cexp co cle wbr cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz
      co cm co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv
      cmin co cr wcel vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cr wcel vk
      cv cF cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co
      cr wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      resqcl syl cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm
      co wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv cmin co
      cr wcel cc0 vk cv cF cfv vk cv cG cfv cmin co c2 cexp co cle wbr vk cv cF
      cfv cr wcel vk cv cG cfv cr wcel vk cv cF cfv vk cv cG cfv cmin co cr
      wcel cN cn wcel cF cr c1 cN cfz co cm co wcel cG cr c1 cN cfz co cm co
      wcel w3a vk cv c1 cN cfz co wcel wa vk cv cF cfv vk cv cG cfv resubcl cF
      cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz co wcel vk cv cF
      cfv cr wcel cG cr c1 cN cfz co cm co wcel c1 cN cfz co cr cF wf vk cv c1
      cN cfz co wcel vk cv cF cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vk cv cF ffvelrn cr c1 cN cfz co cF reex c1 cN cfz oprex elmap
      sylanb 3ad2antl2 cG cr c1 cN cfz co cm co wcel cN cn wcel vk cv c1 cN cfz
      co wcel vk cv cG cfv cr wcel cF cr c1 cN cfz co cm co wcel c1 cN cfz co
      cr cG wf vk cv c1 cN cfz co wcel vk cv cG cfv cr wcel cG cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vk cv cG ffvelrn cr c1 cN cfz co cG reex c1 cN
      cfz oprex elmap sylanb 3ad2antl3 sylanc vk cv cF cfv vk cv cG cfv cmin co
      sqge0 syl jca r19.21aiva sylanc sylanc adantr cN cn wcel cF cr c1 cN cfz
      co cm co wcel cR crp wcel cR cN csqr cfv cmul co cr wcel cG cr c1 cN cfz
      co cm co wcel cR crp wcel cN cn wcel cR cN csqr cfv cmul co cr wcel cR cr
      wcel cN csqr cfv cr wcel cR cN csqr cfv cmul co cr wcel cR crp wcel cN cn
      wcel cR cN csqr cfv remulcl cR rpre cN cr wcel cc0 cN cle wbr cN csqr cfv
      cr wcel cN cn wcel cN sqrcl cN nnre cN cn wcel cN cn0 wcel cc0 cN cle wbr
      cN nnnn0 cN nn0ge0 syl sylanc syl2an ancoms 3ad2antl1 cN cn wcel cF cr c1
      cN cfz co cm co wcel cR crp wcel cc0 cR cN csqr cfv cmul co cle wbr cG cr
      c1 cN cfz co cm co wcel cR crp wcel cN cn wcel cc0 cR cN csqr cfv cmul co
      cle wbr cR cr wcel cc0 cR cle wbr wa cN csqr cfv cr wcel cc0 cN csqr cfv
      cle wbr wa cc0 cR cN csqr cfv cmul co cle wbr cR crp wcel cN cn wcel cR
      cN csqr cfv mulge0 cR crp wcel cR cr wcel cc0 cR cle wbr cR rpre cR rpge0
      jca cN cn wcel cN csqr cfv cr wcel cc0 cN csqr cfv cle wbr cN cr wcel cc0
      cN cle wbr cN csqr cfv cr wcel cN cn wcel cN sqrcl cN nnre cN cn wcel cN
      cn0 wcel cc0 cN cle wbr cN nnnn0 cN nn0ge0 syl sylanc cN cr wcel cc0 cN
      cle wbr cc0 cN csqr cfv cle wbr cN cn wcel cN sqrge0 cN nnre cN cn wcel
      cN cn0 wcel cc0 cN cle wbr cN nnnn0 cN nn0ge0 syl sylanc jca syl2an
      ancoms 3ad2antl1 syl2anc adantrr mpbird eqbrtrd cN cn wcel cN cn wcel cF
      cX wcel cF cr c1 cN cfz co cm co wcel cG cX wcel cG cr c1 cN cfz co cm co
      wcel cN cn wcel biid cX cr c1 cN cfz co cm co cF rrndstprj.2 eleq2i cX cr
      c1 cN cfz co cm co cG rrndstprj.2 eleq2i 3anbi123i sylanb $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d N f g j k m n r s x y z $.
    $( Euclidean space is complete. $)
    rrncms $p |- ( N e. NN -> ( Rn ` N ) e. CMet ) $=
      cN crrn cfv cms wcel cN crrn cfv cme wcel cn cN crrn cfv cdm cdm vf cv wf
      vf cv vx cv cN crrn cfv clm cfv wbr vx cN crrn cfv cdm cdm wrex wi vf cN
      crrn cfv cca cfv wral cN cn wcel vx cN crrn cfv vf cN crrn cfv cdm cdm cN
      crrn cfv cdm cdm eqid iscms2 cN rrnmet cN cn wcel cn cN crrn cfv cdm cdm
      vf cv wf vf cv vx cv cN crrn cfv clm cfv wbr vx cN crrn cfv cdm cdm wrex
      wi vf cN crrn cfv cca cfv cN cn wcel vf cv cN crrn cfv cca cfv wcel wa cn
      cN crrn cfv cdm cdm vf cv wf vf cv vx cv cN crrn cfv clm cfv wbr vx cN
      crrn cfv cdm cdm wrex cN cn wcel vf cv cN crrn cfv cca cfv wcel wa cn cN
      crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel vf cv vx cv
      cN crrn cfv clm cfv wbr wa vx wex vf cv vx cv cN crrn cfv clm cfv wbr vx
      cN crrn cfv cdm cdm wrex cN cn wcel vf cv cN crrn cfv cca cfv wcel wa cn
      cN crrn cfv cdm cdm vf cv wf wa c1 cN cfz co cr vx cv wf vm cv cn wcel vz
      cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres clm cfv wbr vn c1 cN cfz co wral wa vx wex vx cv
      cN crrn cfv cdm cdm wcel vf cv vx cv cN crrn cfv clm cfv wbr wa vx wex cN
      cn wcel vf cv cN crrn cfv cca cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf
      wa vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vy
      cv cabs cmin ccom cr cr cxp cres clm cfv wbr vy cr wrex vn c1 cN cfz co
      wral c1 cN cfz co cr vx cv wf vm cv cn wcel vz cv vn cv vm cv vf cv cfv
      cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr cr cxp cres clm
      cfv wbr vn c1 cN cfz co wral wa vx wex cN cn wcel vf cv cN crrn cfv cca
      cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf wa vm cv cn wcel vz cv vn cv
      vm cv vf cv cfv cfv wceq wa vm vz copab vy cv cabs cmin ccom cr cr cxp
      cres clm cfv wbr vy cr wrex vn c1 cN cfz co cN cn wcel vf cv cN crrn cfv
      cca cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf wa vn cv c1 cN cfz co
      wcel wa vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab
      cabs cmin ccom cr cr cxp cres cca cfv wcel vm cv cn wcel vz cv vn cv vm
      cv vf cv cfv cfv wceq wa vm vz copab vy cv cabs cmin ccom cr cr cxp cres
      clm cfv wbr vy cr wrex cN cn wcel vf cv cN crrn cfv cca cfv wcel wa cn cN
      crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel vm cv cn wcel vz cv vn
      cv vm cv vf cv cfv cfv wceq wa vm vz copab cabs cmin ccom cr cr cxp cres
      cca cfv wcel cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz
      co wcel wa vf cv cN crrn cfv cca cfv wcel vm cv cn wcel vz cv vn cv vm cv
      vf cv cfv cfv wceq wa vm vz copab cabs cmin ccom cr cr cxp cres cca cfv
      wcel cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel
      wa wa vf cv cN crrn cfv cca cfv wcel vm cv cn wcel vz cv vn cv vm cv vf
      cv cfv cfv wceq wa vm vz copab cabs cmin ccom cr cr cxp cres cca cfv wcel
      cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa
      vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co vr cv
      clt wbr wi vk cn wral vj cn wrex vr crp wral vj cv vk cv cle wbr vj cv vm
      cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv vk cv
      vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv
      cabs cmin ccom cr cr cxp cres co vr cv clt wbr wi vk cn wral vj cn wrex
      vr crp wral vf cv cN crrn cfv cca cfv wcel vm cv cn wcel vz cv vn cv vm
      cv vf cv cfv cfv wceq wa vm vz copab cabs cmin ccom cr cr cxp cres cca
      cfv wcel cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co
      wcel wa wa vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv cfv cN crrn
      cfv co vr cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle wbr vj cv
      vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv vk
      cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv
      cabs cmin ccom cr cr cxp cres co vr cv clt wbr wi vk cn wral vj cn wrex
      vr crp cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel
      wa wa vr cv crp wcel wa vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf cv
      cfv cN crrn cfv co vr cv clt wbr wi vk cn wral vj cv vk cv cle wbr vj cv
      vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv vk
      cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv
      cabs cmin ccom cr cr cxp cres co vr cv clt wbr wi vk cn wral vj cn cN cn
      wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv
      crp wcel wa vj cv cn wcel wa vj cv vk cv cle wbr vj cv vf cv cfv vk cv vf
      cv cfv cN crrn cfv co vr cv clt wbr wi vj cv vk cv cle wbr vj cv vm cv cn
      wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv vk cv vm cv
      cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv cabs cmin
      ccom cr cr cxp cres co vr cv clt wbr wi vk cn cN cn wcel cn cN crrn cfv
      cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv crp wcel wa vj cv cn
      wcel wa vk cv cn wcel wa vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co
      vr cv clt wbr vj cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa
      vm vz copab cfv vk cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq
      wa vm vz copab cfv cabs cmin ccom cr cr cxp cres co vr cv clt wbr vj cv
      vk cv cle wbr cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz
      co wcel wa wa vr cv crp wcel wa vj cv cn wcel wa vk cv cn wcel wa vj cv
      vf cv cfv vk cv vf cv cfv cN crrn cfv co vr cv clt wbr vn cv vj cv vf cv
      cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co vr cv
      clt wbr vj cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz
      copab cfv vk cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm
      vz copab cfv cabs cmin ccom cr cr cxp cres co vr cv clt wbr cN cn wcel cn
      cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv crp wcel
      wa vj cv cn wcel vk cv cn wcel vj cv vf cv cfv vk cv vf cv cfv cN crrn
      cfv co vr cv clt wbr vn cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv
      cabs cmin ccom cr cr cxp cres co vr cv clt wbr wi cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv crp wcel wa vj
      cv cn wcel vk cv cn wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk
      cv vf cv cfv cN crrn cfv cdm cdm wcel wa vj cv vf cv cfv vk cv vf cv cfv
      cN crrn cfv co vr cv clt wbr vn cv vj cv vf cv cfv cfv vn cv vk cv vf cv
      cfv cfv cabs cmin ccom cr cr cxp cres co vr cv clt wbr wi cN cn wcel cn
      cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vj cv cn wcel
      vk cv cn wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv
      cN crrn cfv cdm cdm wcel wa vr cv crp wcel cn cN crrn cfv cdm cdm vf cv
      wf vn cv c1 cN cfz co wcel wa vj cv cn wcel vk cv cn wcel wa vj cv vf cv
      cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa
      cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vj cv cn wcel vk cv cn wcel wa
      vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm
      cdm wcel wa vn cv c1 cN cfz co wcel cn cN crrn cfv cdm cdm vf cv wf vj cv
      cn wcel vk cv cn wcel wa wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk
      cv vf cv cfv cN crrn cfv cdm cdm wcel cn cN crrn cfv cdm cdm vf cv wf vj
      cv cn wcel vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv cn wcel cn cN
      crrn cfv cdm cdm vj cv vf cv ffvelrn adantrr cn cN crrn cfv cdm cdm vf cv
      wf vk cv cn wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel vj cv cn wcel
      cn cN crrn cfv cdm cdm vk cv vf cv ffvelrn adantrl jca adantlr adantll
      adantlr cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co
      wcel wa wa vr cv crp wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk
      cv vf cv cfv cN crrn cfv cdm cdm wcel wa wa vn cv vj cv vf cv cfv cfv vn
      cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co vj cv vf cv cfv
      vk cv vf cv cfv cN crrn cfv co cle wbr vj cv vf cv cfv vk cv vf cv cfv cN
      crrn cfv co vr cv clt wbr vn cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv
      cfv cabs cmin ccom cr cr cxp cres co vr cv clt wbr cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vj cv vf cv cfv cN
      crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa vn cv
      vj cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp
      cres co vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co cle wbr vr cv crp
      wcel cN cn wcel vn cv c1 cN cfz co wcel vj cv vf cv cfv cN crrn cfv cdm
      cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa vn cv vj cv vf cv
      cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co vj cv
      vf cv cfv vk cv vf cv cfv cN crrn cfv co cle wbr cn cN crrn cfv cdm cdm
      vf cv wf cN cn wcel vn cv c1 cN cfz co wcel wa vj cv vf cv cfv cN crrn
      cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa wa cN cn
      wcel vn cv c1 cN cfz co wcel wa vj cv vf cv cfv cr c1 cN cfz co cm co
      wcel vk cv vf cv cfv cr c1 cN cfz co cm co wcel wa wa vn cv vj cv vf cv
      cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co vj cv
      vf cv cfv vk cv vf cv cfv cN crrn cfv co cle wbr cN cn wcel vn cv c1 cN
      cfz co wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv
      cN crrn cfv cdm cdm wcel wa vj cv vf cv cfv cr c1 cN cfz co cm co wcel vk
      cv vf cv cfv cr c1 cN cfz co cm co wcel wa cN cn wcel vn cv c1 cN cfz co
      wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn
      cfv cdm cdm wcel wa vj cv vf cv cfv cr c1 cN cfz co cm co wcel vk cv vf
      cv cfv cr c1 cN cfz co cm co wcel wa cN cn wcel vn cv c1 cN cfz co wcel
      wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vj cv vf cv cfv cr c1 cN cfz
      co cm co wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv cr
      c1 cN cfz co cm co wcel cN cn wcel vn cv c1 cN cfz co wcel wa cN crrn cfv
      cdm cdm cr c1 cN cfz co cm co vj cv vf cv cfv cN cn wcel cN crrn cfv cdm
      cdm cr c1 cN cfz co cm co wceq vn cv c1 cN cfz co wcel cN rrndm adantr
      eleq2d cN cn wcel vn cv c1 cN cfz co wcel wa cN crrn cfv cdm cdm cr c1 cN
      cfz co cm co vk cv vf cv cfv cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz
      co cm co wceq vn cv c1 cN cfz co wcel cN rrndm adantr eleq2d anbi12d
      biimpd imdistani vn cv vj cv vf cv cfv vk cv vf cv cfv cabs cmin ccom cr
      cr cxp cres cN cr c1 cN cfz co cm co cabs cmin ccom cr cr cxp cres eqid
      cr c1 cN cfz co cm co eqid rrndstprj syl adantlrl adantlr vn cv vj cv vf
      cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co cr
      wcel vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co cr wcel vr cv cr wcel
      vn cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr
      cxp cres co vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co cle wbr vj cv
      vf cv cfv vk cv vf cv cfv cN crrn cfv co vr cv clt wbr wa vn cv vj cv vf
      cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co vr
      cv clt wbr wi cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz
      co wcel wa wa vr cv crp wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel
      vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa wa vn cv vj cv vf cv cfv cfv
      vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co vj cv vf cv
      cfv vk cv vf cv cfv cN crrn cfv co vr cv lelttr cN cn wcel cn cN crrn cfv
      cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vj cv vf cv cfv cN crrn
      cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa vn cv vj cv
      vf cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co
      cr wcel vr cv crp wcel cN cn wcel vn cv c1 cN cfz co wcel vj cv vf cv cfv
      cN crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa vn
      cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp
      cres co cr wcel cn cN crrn cfv cdm cdm vf cv wf vn cv vj cv vf cv cfv cfv
      cr wcel vn cv vk cv vf cv cfv cfv cr wcel vn cv vj cv vf cv cfv cfv vn cv
      vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres co cr wcel cN cn wcel
      vn cv c1 cN cfz co wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv
      vf cv cfv cN crrn cfv cdm cdm wcel wa wa cabs cmin ccom cr cr cxp cres
      cme wcel vn cv vj cv vf cv cfv cfv cr wcel vn cv vk cv vf cv cfv cfv cr
      wcel vn cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom
      cr cr cxp cres co cr wcel cabs cmin ccom cr cr cxp cres cabs cmin ccom cr
      cr cxp cres eqid remet vn cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv
      cfv cabs cmin ccom cr cr cxp cres cr cabs cmin ccom cr cr cxp cres cabs
      cmin ccom cr cr cxp cres eqid remetba metcl mp3an1 cN cn wcel vn cv c1 cN
      cfz co wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vn cv vj cv vf cv
      cfv cfv cr wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel cN cn wcel vn cv
      c1 cN cfz co wcel wa vj cv vf cv cfv cN crrn cfv cdm cdm wcel vn cv vj cv
      vf cv cfv cfv cr wcel cN cn wcel vj cv vf cv cfv cN crrn cfv cdm cdm wcel
      c1 cN cfz co cr vj cv vf cv cfv wf vn cv c1 cN cfz co wcel vn cv vj cv vf
      cv cfv cfv cr wcel cN cn wcel vj cv vf cv cfv cN crrn cfv cdm cdm wcel c1
      cN cfz co cr vj cv vf cv cfv wf cN cn wcel vj cv vf cv cfv cN crrn cfv
      cdm cdm wcel vj cv vf cv cfv cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vj cv vf cv cfv wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co
      vj cv vf cv cfv cN rrndm eleq2d cr c1 cN cfz co vj cv vf cv cfv reex c1
      cN cfz oprex elmap syl6bb biimpd c1 cN cfz co cr vj cv vf cv cfv wf vn cv
      c1 cN cfz co wcel vn cv vj cv vf cv cfv cfv cr wcel c1 cN cfz co cr vn cv
      vj cv vf cv cfv ffvelrn expcom sylan9 imp adantrr cN cn wcel vn cv c1 cN
      cfz co wcel wa vk cv vf cv cfv cN crrn cfv cdm cdm wcel vn cv vk cv vf cv
      cfv cfv cr wcel vj cv vf cv cfv cN crrn cfv cdm cdm wcel cN cn wcel vn cv
      c1 cN cfz co wcel wa vk cv vf cv cfv cN crrn cfv cdm cdm wcel vn cv vk cv
      vf cv cfv cfv cr wcel cN cn wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel
      c1 cN cfz co cr vk cv vf cv cfv wf vn cv c1 cN cfz co wcel vn cv vk cv vf
      cv cfv cfv cr wcel cN cn wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel c1
      cN cfz co cr vk cv vf cv cfv wf cN cn wcel vk cv vf cv cfv cN crrn cfv
      cdm cdm wcel vk cv vf cv cfv cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vk cv vf cv cfv wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co
      vk cv vf cv cfv cN rrndm eleq2d cr c1 cN cfz co vk cv vf cv cfv reex c1
      cN cfz oprex elmap syl6bb biimpd c1 cN cfz co cr vk cv vf cv cfv wf vn cv
      c1 cN cfz co wcel vn cv vk cv vf cv cfv cfv cr wcel c1 cN cfz co cr vn cv
      vk cv vf cv cfv ffvelrn expcom sylan9 imp adantrl sylanc adantlrl adantlr
      cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa
      vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm
      cdm wcel wa vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co cr wcel vr cv
      crp wcel cN cn wcel vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv
      cfv cN crrn cfv cdm cdm wcel wa vj cv vf cv cfv vk cv vf cv cfv cN crrn
      cfv co cr wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa
      cN crrn cfv cme wcel vj cv vf cv cfv cN crrn cfv cdm cdm wcel vk cv vf cv
      cfv cN crrn cfv cdm cdm wcel wa vj cv vf cv cfv vk cv vf cv cfv cN crrn
      cfv co cr wcel cN cn wcel cN crrn cfv cme wcel vj cv vf cv cfv cN crrn
      cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel vj cv vf cv cfv
      vk cv vf cv cfv cN crrn cfv co cr wcel vj cv vf cv cfv vk cv vf cv cfv cN
      crrn cfv cN crrn cfv cdm cdm cN crrn cfv cdm cdm eqid metcl 3expb cN
      rrnmet sylan adantlr adantlr vr cv crp wcel vr cv cr wcel cN cn wcel cn
      cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vj cv vf cv
      cfv cN crrn cfv cdm cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel wa
      vr cv rpre ad2antlr syl3anc mpand syldan anassrs cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv crp wcel wa vj
      cv cn wcel wa vk cv cn wcel wa vj cv vm cv cn wcel vz cv vn cv vm cv vf
      cv cfv cfv wceq wa vm vz copab cfv vk cv vm cv cn wcel vz cv vn cv vm cv
      vf cv cfv cfv wceq wa vm vz copab cfv cabs cmin ccom cr cr cxp cres co vn
      cv vj cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp
      cres co vr cv clt cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN
      cfz co wcel wa wa vr cv crp wcel wa vj cv cn wcel wa vk cv cn wcel wa vj
      cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cfv
      vn cv vj cv vf cv cfv cfv vk cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv
      cfv wceq wa vm vz copab cfv vn cv vk cv vf cv cfv cfv cabs cmin ccom cr
      cr cxp cres vj cv cn wcel vj cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv
      cfv wceq wa vm vz copab cfv vn cv vj cv vf cv cfv cfv wceq cN cn wcel cn
      cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv crp wcel
      wa vk cv cn wcel vm vz vj cv vn cv vm cv vf cv cfv cfv vn cv vj cv vf cv
      cfv cfv cn vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz
      copab vm cv vj cv wceq vn cv vm cv vf cv cfv vj cv vf cv cfv vm cv vj cv
      vf cv fveq2 fveq1d vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa
      vm vz copab eqid vn cv vj cv vf cv cfv fvex fvopab4 ad2antlr vk cv cn
      wcel vk cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz
      copab cfv vn cv vk cv vf cv cfv cfv wceq cN cn wcel cn cN crrn cfv cdm
      cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cv crp wcel wa vj cv cn
      wcel wa vm vz vk cv vn cv vm cv vf cv cfv cfv vn cv vk cv vf cv cfv cfv
      cn vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vm
      cv vk cv wceq vn cv vm cv vf cv cfv vk cv vf cv cfv vm cv vk cv vf cv
      fveq2 fveq1d vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz
      copab eqid vn cv vk cv vf cv cfv fvex fvopab4 adantl opreq12d breq1d
      sylibrd imim2d r19.20dva r19.22dva r19.20dva cN crrn cfv cme wcel cn cN
      crrn cfv cdm cdm vf cv wf vf cv cN crrn cfv cca cfv wcel vj cv vk cv cle
      wbr vj cv vf cv cfv vk cv vf cv cfv cN crrn cfv co vr cv clt wbr wi vk cn
      wral vj cn wrex vr crp wral wb cN cn wcel cn cN crrn cfv cdm cdm vf cv wf
      vn cv c1 cN cfz co wcel wa wa vr cN crrn cfv vj vk vf cv cN crrn cfv cdm
      cdm cN crrn cfv cdm cdm eqid iscau5 cN cn wcel cN crrn cfv cme wcel cn cN
      crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa cN rrnmet adantr cN
      cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel simprl
      sylanc cabs cmin ccom cr cr cxp cres cme wcel cn cr vm cv cn wcel vz cv
      vn cv vm cv vf cv cfv cfv wceq wa vm vz copab wf vm cv cn wcel vz cv vn
      cv vm cv vf cv cfv cfv wceq wa vm vz copab cabs cmin ccom cr cr cxp cres
      cca cfv wcel vj cv vk cv cle wbr vj cv vm cv cn wcel vz cv vn cv vm cv vf
      cv cfv cfv wceq wa vm vz copab cfv vk cv vm cv cn wcel vz cv vn cv vm cv
      vf cv cfv cfv wceq wa vm vz copab cfv cabs cmin ccom cr cr cxp cres co vr
      cv clt wbr wi vk cn wral vj cn wrex vr crp wral wb cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf vn cv c1 cN cfz co wcel wa wa vr cabs cmin ccom cr
      cr cxp cres vj vk vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa
      vm vz copab cr cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp
      cres eqid remetba iscau5 cabs cmin ccom cr cr cxp cres cabs cmin ccom cr
      cr cxp cres eqid remet cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vn cv
      c1 cN cfz co wcel wa wa vn cv vm cv vf cv cfv cfv cr wcel vm cn wral cn
      cr vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab wf
      cN cn wcel vn cv c1 cN cfz co wcel cn cN crrn cfv cdm cdm vf cv wf vn cv
      vm cv vf cv cfv cfv cr wcel vm cn wral cN cn wcel vn cv c1 cN cfz co wcel
      cn cN crrn cfv cdm cdm vf cv wf vn cv vm cv vf cv cfv cfv cr wcel vm cn
      wral cN cn wcel vn cv c1 cN cfz co wcel wa cn cN crrn cfv cdm cdm vf cv
      wf wa vn cv vm cv vf cv cfv cfv cr wcel vm cn cN cn wcel vn cv c1 cN cfz
      co wcel wa cn cN crrn cfv cdm cdm vf cv wf vm cv cn wcel vn cv vm cv vf
      cv cfv cfv cr wcel cN cn wcel vn cv c1 cN cfz co wcel wa vm cv vf cv cfv
      cN crrn cfv cdm cdm wcel vn cv vm cv vf cv cfv cfv cr wcel cn cN crrn cfv
      cdm cdm vf cv wf vm cv cn wcel wa cN cn wcel vm cv vf cv cfv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vm cv vf cv cfv cfv cr wcel c1
      cN cfz co cr vm cv vf cv cfv wf vn cv c1 cN cfz co wcel vn cv vm cv vf cv
      cfv cfv cr wcel cN cn wcel vm cv vf cv cfv cN crrn cfv cdm cdm wcel wa c1
      cN cfz co cr vn cv vm cv vf cv cfv ffvelrn cN cn wcel c1 cN cfz co cr vm
      cv vf cv cfv wf vm cv vf cv cfv cN crrn cfv cdm cdm wcel cN cn wcel vm cv
      vf cv cfv cN crrn cfv cdm cdm wcel vm cv vf cv cfv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vm cv vf cv cfv wf cN cn wcel cN crrn cfv cdm cdm cr
      c1 cN cfz co cm co vm cv vf cv cfv cN rrndm eleq2d cr c1 cN cfz co vm cv
      vf cv cfv reex c1 cN cfz oprex elmap syl6rbb biimpar sylan an1rs cn cN
      crrn cfv cdm cdm vm cv vf cv ffvelrn sylan2 anassrs r19.21aiva anasss
      ancom2s vm vz cn cr vn cv vm cv vf cv cfv cfv vm cv cn wcel vz cv vn cv
      vm cv vf cv cfv cfv wceq wa vm vz copab vm cv cn wcel vz cv vn cv vm cv
      vf cv cfv cfv wceq wa vm vz copab eqid fopab2 sylib sylancr 3imtr4d imp
      an1rs anassrs vg cv vy cv cabs cmin ccom cr cr cxp cres clm cfv wbr vy
      cabs cmin ccom cr cr cxp cres cdm cdm wrex vm cv cn wcel vz cv vn cv vm
      cv vf cv cfv cfv wceq wa vm vz copab vy cv cabs cmin ccom cr cr cxp cres
      clm cfv wbr vy cr wrex vg vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv
      wceq wa vm vz copab cabs cmin ccom cr cr cxp cres cca cfv vg cv vm cv cn
      wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab wceq vg cv vy cv
      cabs cmin ccom cr cr cxp cres clm cfv wbr vm cv cn wcel vz cv vn cv vm cv
      vf cv cfv cfv wceq wa vm vz copab vy cv cabs cmin ccom cr cr cxp cres clm
      cfv wbr vy cabs cmin ccom cr cr cxp cres cdm cdm cr cabs cmin ccom cr cr
      cxp cres cdm cdm cr wceq vg cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv
      cfv wceq wa vm vz copab wceq cr cabs cmin ccom cr cr cxp cres cdm cdm
      cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid remetba
      eqcomi a1i vg cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm
      vz copab vy cv cabs cmin ccom cr cr cxp cres clm cfv breq1 rexeq12d cabs
      cmin ccom cr cr cxp cres cme wcel vg cv vy cv cabs cmin ccom cr cr cxp
      cres clm cfv wbr vy cabs cmin ccom cr cr cxp cres cdm cdm wrex vg cabs
      cmin ccom cr cr cxp cres cca cfv wral cabs cmin ccom cr cr cxp cres cms
      wcel cabs cmin ccom cr cr cxp cres cme wcel vg cv vy cv cabs cmin ccom cr
      cr cxp cres clm cfv wbr vy cabs cmin ccom cr cr cxp cres cdm cdm wrex vg
      cabs cmin ccom cr cr cxp cres cca cfv wral wa recms vy cabs cmin ccom cr
      cr cxp cres vg cabs cmin ccom cr cr cxp cres cdm cdm cabs cmin ccom cr cr
      cxp cres cdm cdm eqid iscms mpbi pm3.27i vtoclri syl r19.21aiva vm cv cn
      wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vy cv cabs cmin
      ccom cr cr cxp cres clm cfv wbr vm cv cn wcel vz cv vn cv vm cv vf cv cfv
      cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr cr cxp cres clm
      cfv wbr vn vy c1 cN cfz co cr vx c1 cN cfz oprex vy cv vn cv vx cv cfv vm
      cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab cabs cmin
      ccom cr cr cxp cres clm cfv breq2 ac6s syl cN cn wcel vf cv cN crrn cfv
      cca cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf wa c1 cN cfz co cr vx cv
      wf vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vn
      cv vx cv cfv cabs cmin ccom cr cr cxp cres clm cfv wbr vn c1 cN cfz co
      wral wa vx cv cN crrn cfv cdm cdm wcel vf cv vx cv cN crrn cfv clm cfv
      wbr wa vx cN cn wcel vf cv cN crrn cfv cca cfv wcel wa cn cN crrn cfv cdm
      cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel vm cv cn wcel vz cv vn cv
      vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr
      cr cxp cres clm cfv wbr vn c1 cN cfz co wral vx cv cN crrn cfv cdm cdm
      wcel vf cv vx cv cN crrn cfv clm cfv wbr wa c1 cN cfz co cr vx cv wf cN
      cn wcel vf cv cN crrn cfv cca cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf
      wa vx cv cN crrn cfv cdm cdm wcel vm cv cn wcel vz cv vn cv vm cv vf cv
      cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr cr cxp cres
      clm cfv wbr vn c1 cN cfz co wral vf cv vx cv cN crrn cfv clm cfv wbr cN
      cn wcel cn cN crrn cfv cdm cdm vf cv wf vx cv cN crrn cfv cdm cdm wcel vm
      cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx
      cv cfv cabs cmin ccom cr cr cxp cres clm cfv wbr vn c1 cN cfz co wral vf
      cv vx cv cN crrn cfv clm cfv wbr wi wi vf cv cN crrn cfv cca cfv wcel cN
      cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel
      vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vn cv
      vx cv cfv cabs cmin ccom cr cr cxp cres clm cfv wbr vn c1 cN cfz co wral
      vf cv vx cv cN crrn cfv clm cfv wbr wi cN cn wcel cn cN crrn cfv cdm cdm
      vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vm cv cn wcel vz cv vn cv
      vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr
      cr cxp cres clm cfv wbr vn c1 cN cfz co wral vj cv vk cv cle wbr vk cv vf
      cv cfv vx cv cN crrn cfv co vr cv clt wbr wi vk cn wral vj cn wrex vr crp
      wral vf cv vx cv cN crrn cfv clm cfv wbr cN cn wcel cn cN crrn cfv cdm
      cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vm cv cn wcel vz cv vn
      cv vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom
      cr cr cxp cres clm cfv wbr vn c1 cN cfz co wral vj cv vk cv cle wbr vk cv
      vf cv cfv vx cv cN crrn cfv co vr cv clt wbr wi vk cn wral vj cn wrex vr
      crp cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm
      cdm wcel wa vr cv crp wcel wa vm cv cn wcel vz cv vn cv vm cv vf cv cfv
      cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr cr cxp cres clm
      cfv wbr vn c1 cN cfz co wral vj cv vk cv cle wbr vn cv vk cv vf cv cfv
      cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv
      cdiv co clt wbr wi vk cn wral vj cn wrex vn c1 cN cfz co wral vj cv vk cv
      cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN cfz co wral wi vk
      cn wral vj cn wrex vj cv vk cv cle wbr vk cv vf cv cfv vx cv cN crrn cfv
      co vr cv clt wbr wi vk cn wral vj cn wrex cN cn wcel cn cN crrn cfv cdm
      cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vr cv crp wcel wa vm cv
      cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx cv
      cfv cabs cmin ccom cr cr cxp cres clm cfv wbr vj cv vk cv cle wbr vn cv
      vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr
      cv cN csqr cfv cdiv co clt wbr wi vk cn wral vj cn wrex vn c1 cN cfz co
      cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm
      wcel wa vr cv crp wcel wa vn cv c1 cN cfz co wcel wa vm cv cn wcel vz cv
      vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin
      ccom cr cr cxp cres clm cfv wbr vj cv vk cv cle wbr vn cv vk cv vf cv cfv
      cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vs cv clt wbr wi vk
      cn wral vj cn wrex vs crp wral vj cv vk cv cle wbr vn cv vk cv vf cv cfv
      cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv
      cdiv co clt wbr wi vk cn wral vj cn wrex cabs cmin ccom cr cr cxp cres
      cme wcel vn cv vx cv cfv cr wcel cn cr vm cv cn wcel vz cv vn cv vm cv vf
      cv cfv cfv wceq wa vm vz copab wf vm cv cn wcel vz cv vn cv vm cv vf cv
      cfv cfv wceq wa vm vz copab vn cv vx cv cfv cabs cmin ccom cr cr cxp cres
      clm cfv wbr vj cv vk cv cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv
      cabs cmin ccom cr cr cxp cres co vs cv clt wbr wi vk cn wral vj cn wrex
      vs crp wral wb cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN
      crrn cfv cdm cdm wcel wa vr cv crp wcel wa vn cv c1 cN cfz co wcel wa vs
      vn cv vk cv vf cv cfv cfv cabs cmin ccom cr cr cxp cres vn cv vx cv cfv
      vj vk vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab
      cr cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres eqid
      remetba vk cv cn wcel vk cv vm cv cn wcel vz cv vn cv vm cv vf cv cfv cfv
      wceq wa vm vz copab cfv vn cv vk cv vf cv cfv cfv vm vz vk cv vn cv vm cv
      vf cv cfv cfv vn cv vk cv vf cv cfv cfv cn vm cv cn wcel vz cv vn cv vm
      cv vf cv cfv cfv wceq wa vm vz copab vm cv vk cv wceq vn cv vm cv vf cv
      cfv vk cv vf cv cfv vm cv vk cv vf cv fveq2 fveq1d vm cv cn wcel vz cv vn
      cv vm cv vf cv cfv cfv wceq wa vm vz copab eqid vn cv vk cv vf cv cfv
      fvex fvopab4 eqcomd lmbrnns cabs cmin ccom cr cr cxp cres cme wcel cN cn
      wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa
      vr cv crp wcel wa vn cv c1 cN cfz co wcel wa cabs cmin ccom cr cr cxp
      cres cabs cmin ccom cr cr cxp cres eqid remet a1i cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz
      co wcel vn cv vx cv cfv cr wcel vr cv crp wcel cN cn wcel vx cv cN crrn
      cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cn cN
      crrn cfv cdm cdm vf cv wf c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co
      wcel vn cv vx cv cfv cr wcel cN cn wcel vx cv cN crrn cfv cdm cdm wcel wa
      c1 cN cfz co cr vn cv vx cv ffvelrn cN cn wcel vx cv cN crrn cfv cdm cdm
      wcel wa vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cN cn
      wcel vx cv cN crrn cfv cdm cdm wcel vx cv cr c1 cN cfz co cm co wcel cN
      cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vx cv cN rrndm eleq2d
      biimpa cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap sylib sylan
      adantllr adantlr cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN
      crrn cfv cdm cdm wcel wa vr cv crp wcel wa vn cv c1 cN cfz co wcel wa vn
      cv vm cv vf cv cfv cfv cr wcel vm cn wral cn cr vm cv cn wcel vz cv vn cv
      vm cv vf cv cfv cfv wceq wa vm vz copab wf cN cn wcel cn cN crrn cfv cdm
      cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel
      vn cv vm cv vf cv cfv cfv cr wcel vm cn wral vr cv crp wcel cN cn wcel cn
      cN crrn cfv cdm cdm vf cv wf wa vn cv c1 cN cfz co wcel vn cv vm cv vf cv
      cfv cfv cr wcel vm cn wral vx cv cN crrn cfv cdm cdm wcel cN cn wcel cn
      cN crrn cfv cdm cdm vf cv wf wa vn cv c1 cN cfz co wcel wa vn cv vm cv vf
      cv cfv cfv cr wcel vm cn cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vm
      cv cn wcel vn cv c1 cN cfz co wcel vn cv vm cv vf cv cfv cfv cr wcel c1
      cN cfz co cr vm cv vf cv cfv wf vn cv c1 cN cfz co wcel vn cv vm cv vf cv
      cfv cfv cr wcel cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vm cv cn
      wcel wa c1 cN cfz co cr vn cv vm cv vf cv cfv ffvelrn cN cn wcel cn cN
      crrn cfv cdm cdm vf cv wf vm cv cn wcel c1 cN cfz co cr vm cv vf cv cfv
      wf cN cn wcel vm cv vf cv cfv cN crrn cfv cdm cdm wcel c1 cN cfz co cr vm
      cv vf cv cfv wf cn cN crrn cfv cdm cdm vf cv wf vm cv cn wcel wa cN cn
      wcel c1 cN cfz co cr vm cv vf cv cfv wf vm cv vf cv cfv cN crrn cfv cdm
      cdm wcel cN cn wcel vm cv vf cv cfv cN crrn cfv cdm cdm wcel vm cv vf cv
      cfv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vm cv vf cv cfv wf cN cn
      wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vm cv vf cv cfv cN rrndm
      eleq2d cr c1 cN cfz co vm cv vf cv cfv reex c1 cN cfz oprex elmap syl6rbb
      biimpar cn cN crrn cfv cdm cdm vm cv vf cv ffvelrn sylan2 anassrs sylan
      an1rs r19.21aiva adantlr adantlr vm vz cn cr vn cv vm cv vf cv cfv cfv vm
      cv cn wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab vm cv cn
      wcel vz cv vn cv vm cv vf cv cfv cfv wceq wa vm vz copab eqid fopab2
      sylib syl3anc cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn
      cfv cdm cdm wcel wa vr cv crp wcel wa vj cv vk cv cle wbr vn cv vk cv vf
      cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vs cv clt wbr
      wi vk cn wral vj cn wrex vs crp wral vj cv vk cv cle wbr vn cv vk cv vf
      cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr
      cfv cdiv co clt wbr wi vk cn wral vj cn wrex wi vn cv c1 cN cfz co wcel
      cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vr cv crp wcel vj cv vk cv
      cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vs cv clt wbr wi vk cn wral vj cn wrex vs crp wral vj cv vk
      cv cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vr cv cN csqr cfv cdiv co clt wbr wi vk cn wral vj cn wrex wi
      vx cv cN crrn cfv cdm cdm wcel cN cn wcel vr cv crp wcel vj cv vk cv cle
      wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp
      cres co vs cv clt wbr wi vk cn wral vj cn wrex vs crp wral vj cv vk cv
      cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vr cv cN csqr cfv cdiv co clt wbr wi vk cn wral vj cn wrex wi
      cn cN crrn cfv cdm cdm vf cv wf cN cn wcel vr cv crp wcel wa vr cv cN
      csqr cfv cdiv co crp wcel vj cv vk cv cle wbr vn cv vk cv vf cv cfv cfv
      vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vs cv clt wbr wi vk cn
      wral vj cn wrex vs crp wral vj cv vk cv cle wbr vn cv vk cv vf cv cfv cfv
      vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv
      co clt wbr wi vk cn wral vj cn wrex wi vr cv crp wcel cN cn wcel vr cv cN
      csqr cfv cdiv co crp wcel vr cv crp wcel cN csqr cfv crp wcel vr cv cN
      csqr cfv cdiv co crp wcel cN cn wcel vr cv cN csqr cfv rpdivcl cN cn wcel
      cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 ancoms vj
      cv vk cv cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom
      cr cr cxp cres co vs cv clt wbr wi vk cn wral vj cn wrex vj cv vk cv cle
      wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp
      cres co vr cv cN csqr cfv cdiv co clt wbr wi vk cn wral vj cn wrex vs vr
      cv cN csqr cfv cdiv co crp vs cv vr cv cN csqr cfv cdiv co wceq vj cv vk
      cv cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vs cv clt wbr wi vj cv vk cv cle wbr vn cv vk cv vf cv cfv
      cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv
      cdiv co clt wbr wi vj vk cn cn vs cv vr cv cN csqr cfv cdiv co wceq vn cv
      vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vs
      cv clt wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vr cv cN csqr cfv cdiv co clt wbr vj cv vk cv cle wbr vs cv
      vr cv cN csqr cfv cdiv co vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres co clt breq2 imbi2d rexralbidv rcla4v syl
      adantlr adantlr adantr sylbid r19.20dva c1 cN cfz co cfn wcel c1 cN cfz
      co c0 wne cn cr wss vj cv vk cv cle wbr vn cv vk cv vf cv cfv cfv vn cv
      vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt
      wbr wi vk cn wral vj cn wrex vn c1 cN cfz co wral vj cv vk cv cle wbr vn
      cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co
      vr cv cN csqr cfv cdiv co clt wbr vn c1 cN cfz co wral wi vk cn wral vj
      cn wrex wi cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn
      cfv cdm cdm wcel wa vr cv crp wcel wa vn cv vk cv vf cv cfv cfv vn cv vx
      cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr
      vn vj vk c1 cN cfz co cn filbcmb cN cn wcel cn cN crrn cfv cdm cdm vf cv
      wf wa c1 cN cfz co cfn wcel vx cv cN crrn cfv cdm cdm wcel vr cv crp wcel
      cN cn wcel c1 cN cfz co cfn wcel cn cN crrn cfv cdm cdm vf cv wf cN cn
      wcel cN c1 cuz cfv wcel c1 cN cfz co cfn wcel cN elnnuz c1 cN fzfi sylbi
      adantr ad2antrr cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa c1 cN cfz
      co c0 wne vx cv cN crrn cfv cdm cdm wcel vr cv crp wcel cN cn wcel c1 cN
      cfz co c0 wne cn cN crrn cfv cdm cdm vf cv wf cN cn wcel cN c1 cuz cfv
      wcel c1 c1 cN cfz co wcel c1 cN cfz co c0 wne cN cn wcel cN c1 cuz cfv
      wcel cN elnnuz biimpi c1 cN eluzfz1 c1 cN cfz co c1 ne0i 3syl adantr
      ad2antrr cn cr wss cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN
      crrn cfv cdm cdm wcel wa vr cv crp wcel wa nnssre a1i syl3anc cN cn wcel
      cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vr
      cv crp wcel wa vj cv vk cv cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv
      cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn
      c1 cN cfz co wral wi vk cn wral vj cv vk cv cle wbr vk cv vf cv cfv vx cv
      cN crrn cfv co vr cv clt wbr wi vk cn wral vj cn cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vr cv crp wcel
      wa vj cv vk cv cle wbr vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN
      cfz co wral wi vj cv vk cv cle wbr vk cv vf cv cfv vx cv cN crrn cfv co
      vr cv clt wbr wi vk cn cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx
      cv cN crrn cfv cdm cdm wcel wa vr cv crp wcel wa vk cv cn wcel wa vn cv
      vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr
      cv cN csqr cfv cdiv co clt wbr vn c1 cN cfz co wral vk cv vf cv cfv vx cv
      cN crrn cfv co vr cv clt wbr vj cv vk cv cle wbr cN cn wcel cn cN crrn
      cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vr cv crp wcel
      wa vk cv cn wcel wa cN cn wcel cn cN crrn cfv cdm cdm vf cv wf wa vx cv
      cN crrn cfv cdm cdm wcel wa vr cv crp wcel wa vk cv vf cv cfv cN crrn cfv
      cdm cdm wcel wa vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom
      cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN cfz co wral
      vk cv vf cv cfv vx cv cN crrn cfv co vr cv clt wbr wi cN cn wcel cn cN
      crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vr cv crp
      wcel wa vk cv cn wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel cN cn wcel
      cn cN crrn cfv cdm cdm vf cv wf wa vk cv cn wcel vk cv vf cv cfv cN crrn
      cfv cdm cdm wcel wi vx cv cN crrn cfv cdm cdm wcel vr cv crp wcel cn cN
      crrn cfv cdm cdm vf cv wf vk cv cn wcel vk cv vf cv cfv cN crrn cfv cdm
      cdm wcel wi cN cn wcel cn cN crrn cfv cdm cdm vf cv wf vk cv cn wcel vk
      cv vf cv cfv cN crrn cfv cdm cdm wcel cn cN crrn cfv cdm cdm vk cv vf cv
      ffvelrn ex adantl ad2antrr imdistani cN cn wcel cn cN crrn cfv cdm cdm vf
      cv wf wa vx cv cN crrn cfv cdm cdm wcel wa vr cv crp wcel vk cv vf cv cfv
      cN crrn cfv cdm cdm wcel vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN
      cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co vr cv clt wbr wi cN cn
      wcel vx cv cN crrn cfv cdm cdm wcel vr cv crp wcel vk cv vf cv cfv cN
      crrn cfv cdm cdm wcel wa vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN
      cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co vr cv clt wbr wi cn cN
      crrn cfv cdm cdm vf cv wf cN cn wcel vr cv crp wcel vx cv cN crrn cfv cdm
      cdm wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel vn cv vk cv vf cv cfv
      cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv
      cdiv co clt wbr vn c1 cN cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co
      vr cv clt wbr wi cN cn wcel vx cv cN crrn cfv cdm cdm wcel vk cv vf cv
      cfv cN crrn cfv cdm cdm wcel wa vr cv crp wcel vn cv vk cv vf cv cfv cfv
      vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv
      co clt wbr vn c1 cN cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co vr
      cv clt wbr wi cN cn wcel vk cv vf cv cfv cr c1 cN cfz co cm co wcel vx cv
      cr c1 cN cfz co cm co wcel wa wa vr cv crp wcel vn cv vk cv vf cv cfv cfv
      vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv
      co clt wbr vn c1 cN cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co vr
      cv clt wbr wi cN cn wcel vx cv cN crrn cfv cdm cdm wcel vk cv vf cv cfv
      cN crrn cfv cdm cdm wcel wa wa cN cn wcel vk cv vf cv cfv cr c1 cN cfz co
      cm co wcel vx cv cr c1 cN cfz co cm co wcel wa wa vr cv crp wcel vn cv vk
      cv vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv
      cN csqr cfv cdiv co clt wbr vn c1 cN cfz co wral vk cv vf cv cfv vx cv cN
      crrn cfv co vr cv clt wbr cN cn wcel vk cv vf cv cfv cr c1 cN cfz co cm
      co wcel vx cv cr c1 cN cfz co cm co wcel vr cv crp wcel vn cv vk cv vf cv
      cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr
      cfv cdiv co clt wbr vn c1 cN cfz co wral wa vk cv vf cv cfv vx cv cN crrn
      cfv co vr cv clt wbr wi cN cn wcel vk cv vf cv cfv cr c1 cN cfz co cm co
      wcel vx cv cr c1 cN cfz co cm co wcel w3a vr cv crp wcel vn cv vk cv vf
      cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr
      cfv cdiv co clt wbr vn c1 cN cfz co wral wa vk cv vf cv cfv vx cv cN crrn
      cfv co vr cv clt wbr cN cn wcel vk cv vf cv cfv cr c1 cN cfz co cm co
      wcel vx cv cr c1 cN cfz co cm co wcel w3a vr cv crp wcel vn cv vk cv vf
      cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr
      cfv cdiv co clt wbr vn c1 cN cfz co wral wa wa vk cv vf cv cfv vx cv cN
      crrn cfv co vr cv cN csqr cfv cdiv co cN csqr cfv cmul co vr cv clt cN cn
      wcel vk cv vf cv cfv cr c1 cN cfz co cm co wcel vx cv cr c1 cN cfz co cm
      co wcel w3a vr cv crp wcel vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN
      cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co vr cv cN csqr cfv cdiv
      co cN csqr cfv cmul co clt wbr cN cn wcel vk cv vf cv cfv cr c1 cN cfz co
      cm co wcel vx cv cr c1 cN cfz co cm co wcel w3a vr cv crp wcel vr cv cN
      csqr cfv cdiv co crp wcel vn cv vk cv vf cv cfv cfv vn cv vx cv cfv cabs
      cmin ccom cr cr cxp cres co vr cv cN csqr cfv cdiv co clt wbr vn c1 cN
      cfz co wral vk cv vf cv cfv vx cv cN crrn cfv co vr cv cN csqr cfv cdiv
      co cN csqr cfv cmul co clt wbr wi cN cn wcel vk cv vf cv cfv cr c1 cN cfz
      co cm co wcel vr cv crp wcel vr cv cN csqr cfv cdiv co crp wcel wi vx cv
      cr c1 cN cfz co cm co wcel vr cv crp wcel cN cn wcel vr cv cN csqr cfv
      cdiv co crp wcel vr cv crp wcel cN csqr cfv crp wcel vr cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vr cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 expcom 3ad2ant1
      cN cn wcel vk cv vf cv cfv cr c1 cN cfz co cm co wcel vx cv cr c1 cN cfz
      co cm co wcel w3a vr cv cN csqr cfv cdiv co crp wcel vn cv vk cv vf cv
      cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN csqr
      cfv cdiv co clt wbr vn c1 cN cfz co wral vk cv vf cv cfv vx cv cN crrn
      cfv co vr cv cN csqr cfv cdiv co cN csqr cfv cmul co clt wbr vr cv cN
      csqr cfv cdiv co vn vk cv vf cv cfv vx cv cabs cmin ccom cr cr cxp cres
      cN cr c1 cN cfz co cm co cabs cmin ccom cr cr cxp cres eqid cr c1 cN cfz
      co cm co eqid rrndstprj2 exp32 syld imp32 cN cn wcel vk cv vf cv cfv cr
      c1 cN cfz co cm co wcel vx cv cr c1 cN cfz co cm co wcel w3a vr cv crp
      wcel vr cv cN csqr cfv cdiv co cN csqr cfv cmul co vr cv wceq vn cv vk cv
      vf cv cfv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vr cv cN
      csqr cfv cdiv co clt wbr vn c1 cN cfz co wral cN cn wcel vk cv vf cv cfv
      cr c1 cN cfz co cm co wcel vr cv crp wcel vr cv cN csqr cfv cdiv co cN
      csqr cfv cmul co vr cv wceq vx cv cr c1 cN cfz co cm co wcel vr cv cc
      wcel cN csqr cfv cc wcel cN csqr cfv cc0 wne vr cv cN csqr cfv cdiv co cN
      csqr cfv cmul co vr cv wceq cN cn wcel vr cv crp wcel wa vr cv cN csqr
      cfv divcan1 vr cv crp wcel vr cv cc wcel cN cn wcel vr cv rpcn adantl cN
      cn wcel cN csqr cfv cc wcel vr cv crp wcel cN cn wcel cN cr wcel cc0 cN
      cle wbr wa cN csqr cfv cr wcel cN csqr cfv cc wcel cN cn wcel cN cr wcel
      cc0 cN cle wbr cN nnre cN cn wcel cN cn0 wcel cc0 cN cle wbr cN nnnn0 cN
      nn0ge0 syl jca cN sqrcl cN csqr cfv recn 3syl adantr cN cn wcel cN csqr
      cfv cc0 wne vr cv crp wcel cN cn wcel cN crp wcel cN csqr cfv crp wcel cN
      csqr cfv cc0 wne cN nnrp cN rpsqrcl cN csqr cfv rpne0 3syl adantr syl3anc
      3ad2antl1 adantrr breqtrd ex 3expb expdimp cN cn wcel vk cv vf cv cfv cN
      crrn cfv cdm cdm wcel vx cv cN crrn cfv cdm cdm wcel cN cn wcel vk cv vf
      cv cfv cr c1 cN cfz co cm co wcel vx cv cr c1 cN cfz co cm co wcel wa wa
      cN cn wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel vx cv cN crrn cfv cdm
      cdm wcel wa vk cv vf cv cfv cr c1 cN cfz co cm co wcel vx cv cr c1 cN cfz
      co cm co wcel wa cN cn wcel vk cv vf cv cfv cN crrn cfv cdm cdm wcel vx
      cv cN crrn cfv cdm cdm wcel wa vk cv vf cv cfv cr c1 cN cfz co cm co wcel
      vx cv cr c1 cN cfz co cm co wcel wa cN cn wcel vk cv vf cv cfv cN crrn
      cfv cdm cdm wcel vk cv vf cv cfv cr c1 cN cfz co cm co wcel vx cv cN crrn
      cfv cdm cdm wcel vx cv cr c1 cN cfz co cm co wcel cN cn wcel cN crrn cfv
      cdm cdm cr c1 cN cfz co cm co vk cv vf cv cfv cN rrndm eleq2d cN cn wcel
      cN crrn cfv cdm cdm cr c1 cN cfz co cm co vx cv cN rrndm eleq2d anbi12d
      biimpd imdistani ancom2s sylan an1rs an4s adantllr anassrs syl imim2d
      r19.20dva r19.22sdv 3syld r19.21adva cN cn wcel vx cv cN crrn cfv cdm cdm
      wcel cn cN crrn cfv cdm cdm vf cv wf vf cv vx cv cN crrn cfv clm cfv wbr
      vj cv vk cv cle wbr vk cv vf cv cfv vx cv cN crrn cfv co vr cv clt wbr wi
      vk cn wral vj cn wrex vr crp wral wb cN cn wcel vx cv cN crrn cfv cdm cdm
      wcel cn cN crrn cfv cdm cdm vf cv wf vf cv vx cv cN crrn cfv clm cfv wbr
      vj cv vk cv cle wbr vk cv vf cv cfv vx cv cN crrn cfv co vr cv clt wbr wi
      vk cn wral vj cn wrex vr crp wral wb cN crrn cfv cme wcel vx cv cN crrn
      cfv cdm cdm wcel cn cN crrn cfv cdm cdm vf cv wf vf cv vx cv cN crrn cfv
      clm cfv wbr vj cv vk cv cle wbr vk cv vf cv cfv vx cv cN crrn cfv co vr
      cv clt wbr wi vk cn wral vj cn wrex vr crp wral wb cN cn wcel vr vk cv vf
      cv cfv cN crrn cfv vx cv vj vk vf cv cN crrn cfv cdm cdm cN crrn cfv cdm
      cdm eqid vk cv cn wcel vk cv vf cv cfv eqidd lmbrnns cN rrnmet syl3an1
      3expa an1rs sylibrd ex adantlr imdistand cN cn wcel vf cv cN crrn cfv cca
      cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm
      wcel c1 cN cfz co cr vx cv wf cN cn wcel vf cv cN crrn cfv cca cfv wcel
      wa cn cN crrn cfv cdm cdm vf cv wf wa vx cv cN crrn cfv cdm cdm wcel vx
      cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cN cn wcel vf cv
      cN crrn cfv cca cfv wcel wa cn cN crrn cfv cdm cdm vf cv wf wa cN crrn
      cfv cdm cdm cr c1 cN cfz co cm co vx cv cN cn wcel cN crrn cfv cdm cdm cr
      c1 cN cfz co cm co wceq vf cv cN crrn cfv cca cfv wcel cn cN crrn cfv cdm
      cdm vf cv wf cN rrndm ad2antrr eleq2d cr c1 cN cfz co vx cv reex c1 cN
      cfz oprex elmap syl6bb biimprd syland 19.22dv mpd vf cv vx cv cN crrn cfv
      clm cfv wbr vx cN crrn cfv cdm cdm df-rex sylibr ex r19.21aiva sylanbrc
      $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d X a b d f m n r u v w x y z $. $d M a b d f m n r u v w x y z $.
    $d Y a b d f m n r u v w x y z $. $d N a b d f m n r u v w x y z $.
    rrntotbnd.1 $e |- X = ( RR ^m ( 1 ... N ) ) $.
    rrntotbnd.2 $e |- M = ( ( Rn ` N ) |` ( Y X. Y ) ) $.

    $( Lemma for ~ rrntotbnd . $)
    rrntotbndlem1 $p |- ( ( ( ( N e. NN /\ x e. X ) /\ ( d e. RR+ /\ r e. RR+ )
          ) /\ ( y e. dom dom ( Rn ` N ) /\ ( x ( Rn ` N ) y ) < r ) ) ->
          ( { <. m , u >. | ( m e. ( 1 ... N ) /\ u = ( ( x ` m ) +
              ( ( d / ( sqr ` N ) ) x. ( { <. n , v >. | ( n e. ( 1 ... N ) /\
            v = ( |_ ` ( ( ( ( y ` n ) - ( x ` n ) ) / ( d / ( sqr ` N ) ) ) +
                  ( 1 / 2 ) ) ) ) } ` m ) ) ) ) } ( ball ` ( Rn ` N ) ) d ) e.
        { a | E. f ( f : ( 1 ... N ) --> ( -u ( ( |_ ` ( r / ( d / ( sqr ` N )
              ) ) ) + 1 ) ... ( ( |_ ` ( r / ( d / ( sqr ` N ) ) ) ) + 1 ) ) /\
                  a = ( { <. m , u >. | ( m e. ( 1 ... N ) /\ u = ( ( x ` m ) +
                                  ( ( d / ( sqr ` N ) ) x. ( f ` m ) ) ) ) }
                                            ( ball ` ( Rn ` N ) ) d ) ) } ) $=
      cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa c1
      cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      vf cv wf vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cbl cfv co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab
      vd cv cN crrn cfv cbl cfv co wceq wa vf wex vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa vf wex va cab wcel c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vn cv c1 cN cfz co wcel vv cv vn cv vy
      cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab wf vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wceq c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co vf cv wf vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex cN cn wcel vx cv
      cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa c1 cN cfz co vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv
      c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab wf vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz co wcel vu cv vm
      cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv
      cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc
      co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf vn cv c1
      cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab vn vv c1 cN cfz co vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv c1 cN cfz oprex
      opabex2 vf cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab wceq c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cfz co vf cv wf c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vn cv c1 cN cfz co wcel vv cv vn cv vy
      cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab wf vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa
      vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd
      cv cN crrn cfv cbl cfv co wceq c1 cN cfz co vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cfz co vf cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab feq1 vf cv vn cv c1 cN cfz
      co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab wceq
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd
      cv cN crrn cfv cbl cfv co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv
      vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm
      vu copab vd cv cN crrn cfv cbl cfv co vf cv vn cv c1 cN cfz co wcel vv cv
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab wceq vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co
      wceq wa vm vu copab vd cv cN crrn cfv cbl cfv vf cv vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab wceq vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vf cv cfv cmul co caddc co wceq wa vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq
      wa vm vu vf cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab wceq vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vf cv cfv cmul co caddc co wceq vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq vm cv c1
      cN cfz co wcel vf cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv wceq wa vn vv copab wceq vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vf cv cfv cmul co caddc co vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co vu cv vf cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      wceq vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co vm cv vx cv cfv caddc vf cv vn cv c1
      cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab wceq vm cv vf cv cfv vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy
      cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv vd cv cN csqr cfv cdiv
      co cmul vm cv vf cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv wceq wa vn vv copab fveq1 opreq2d opreq2d eqeq2d anbi2d
      opabbidv opreq1d eqeq2d anbi12d cla4ev cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv
      cN crrn cfv co vr cv clt wbr wa wa vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co wcel vn c1 cN cfz co
      wral c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq
      wa vn vv copab wf cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr
      cv clt wbr wa wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co wcel vn c1 cN cfz co vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cn wcel vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv cz wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cabs cfv vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cle wbr vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa
      wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt
      wbr wa wa vn cv c1 cN cfz co wcel wa vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cn wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv cabs cfv vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cle wbr w3a vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co wcel vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cle wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cle wbr wa vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cn wcel vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv cz wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cabs cfv vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cle wbr vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv cle wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cle wbr wa vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv cz wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cn wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv cabs cfv vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cle wbr vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cle wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cle wbr wa wb vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cr wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cr
      wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv cabs cfv vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cle wbr vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cle
      wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cle wbr wa wb vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cz wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cn
      wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co absle vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv zre vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co nnre syl2an
      ancoms biimp3a vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg cz wcel vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cz wcel vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz
      co wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv cle wbr vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cle wbr wa wb
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cn wcel vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cz wcel vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cabs cfv
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cle wbr w3a
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co elfz vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cn wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cabs cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cle wbr 3simp2 vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cn wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg cz wcel vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv cabs cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cle wbr vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co nnnegz 3ad2ant1 vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cn wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cz wcel vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv cabs cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cle wbr vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co nnz 3ad2ant1 syl3anc mpbird cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cn wcel vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel cN cn wcel vd cv crp
      wcel vr cv crp wcel wa vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cn wcel vx cv cX wcel vd cv crp wcel vr cv crp wcel wa cN cn
      wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cn wcel
      cN cn wcel vr cv crp wcel vd cv crp wcel vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cn wcel cN cn wcel vr cv crp wcel wa vd cv
      crp wcel wa vr cv vd cv cN csqr cfv cdiv co cdiv co crp wcel vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv cn0 wcel vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cn wcel vr cv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel vr cv vd cv cN csqr cfv cdiv co cdiv co crp wcel cN cn
      wcel vr cv crp wcel wa vd cv crp wcel wa vr cv vd cv cN csqr cfv cdiv co
      rpdivcl cN cn wcel vr cv crp wcel vd cv crp wcel simplr cN cn wcel vd cv
      crp wcel vd cv cN csqr cfv cdiv co crp wcel vr cv crp wcel vd cv crp wcel
      cN cn wcel vd cv cN csqr cfv cdiv co crp wcel vd cv crp wcel cN csqr cfv
      crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv
      rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl
      syl sylan2 ancoms adantlr sylanc vr cv vd cv cN csqr cfv cdiv co cdiv co
      cr wcel cc0 vr cv vd cv cN csqr cfv cdiv co cdiv co cle wbr vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv cn0 wcel vr cv vd cv cN csqr cfv cdiv
      co cdiv co crp wcel vr cv vd cv cN csqr cfv cdiv co cdiv co flge0nn0 vr
      cv vd cv cN csqr cfv cdiv co cdiv co rpre vr cv vd cv cN csqr cfv cdiv co
      cdiv co rpge0 sylanc vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      nn0p1nn 3syl ancom31s ancoms adantlr ad2antrr cN cn wcel vx cv cX wcel wa
      vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vn cv
      c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr
      cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co
      wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cr wcel vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cz wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cr wcel c1 c2 cdiv co cr wcel vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel
      cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co readdcl
      vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co
      cr wcel vd cv cN csqr cfv cdiv co cc0 wne vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co redivcl cN cn wcel vx cv cX wcel wa vy cv cN
      crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv
      cfv cmin co cr wcel vd cv crp wcel vr cv crp wcel wa vn cv vy cv cfv cr
      wcel vn cv vx cv cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr
      wcel cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv
      c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv resubcl cN cn wcel
      vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr
      wcel vx cv cX wcel c1 cN cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv
      vy cv cfv cr wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz
      co cr vn cv vy cv ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN
      cfz co cr vy cv wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1
      cN cfz co cm co wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm
      cdm cr c1 cN cfz co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv
      reex c1 cN cfz oprex elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv
      cX wcel wa vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn
      cfv cdm cdm wcel vx cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr
      wcel cN cn wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx
      cv cfv cr wcel vx cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX
      wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1
      cN cfz co cm co vx cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN
      cfz oprex elmap bitri sylanb adantll adantlr sylanc adantllr cN cn wcel
      vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv
      cdiv co cr wcel vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN
      cn wcel vd cv crp wcel vd cv cN csqr cfv cdiv co cr wcel vx cv cX wcel vr
      cv crp wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cr wcel
      vd cv crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN
      csqr cfv cdiv co cr wcel vd cv crp wcel cN csqr cfv crp wcel vd cv cN
      csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel
      cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN
      csqr cfv cdiv co rpre syl ancoms ad2ant2r ad2antrr cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cc0
      wne vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd
      cv crp wcel vd cv cN csqr cfv cdiv co cc0 wne vx cv cX wcel vr cv crp
      wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cc0 wne vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv
      cdiv co rpne0 syl ancoms ad2ant2r ad2antrr syl3anc c2 2re 2ne0 rereccli
      sylancl vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co flcl syl adantlrr cN cn wcel vx cv cX wcel
      wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx
      cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv cabs cfv vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cfl cfv c1 caddc co vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co
      wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv cc wcel vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv cabs cfv cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv
      crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co
      vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv cc wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel
      wa wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cr wcel vx cv vy cv cN crrn cfv co vr cv clt wbr vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel c1
      c2 cdiv co cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co readdcl vn cv vy cv
      cfv vn cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd
      cv cN csqr cfv cdiv co cc0 wne vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co cr wcel cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1
      cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co redivcl cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm
      wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr
      wcel vd cv crp wcel vr cv crp wcel wa vn cv vy cv cfv cr wcel vn cv vx cv
      cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN cn wcel vx
      cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel
      wa vn cv vy cv cfv vn cv vx cv cfv resubcl cN cn wcel vy cv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx cv cX
      wcel c1 cN cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv cfv cr
      wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz co cr vn cv
      vy cv ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN cfz co cr
      vy cv wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN cfz co
      cm co wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm cdm cr c1
      cN cfz co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv reex c1 cN
      cfz oprex elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv cX wcel wa
      vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm
      wcel vx cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN cn
      wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr
      wcel vx cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx
      cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co
      cm co vx cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex
      elmap bitri sylanb adantll adantlr sylanc adantllr cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cr
      wcel vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd
      cv crp wcel vd cv cN csqr cfv cdiv co cr wcel vx cv cX wcel vr cv crp
      wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cr wcel vd cv
      crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cr wcel vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv
      cdiv co rpre syl ancoms ad2ant2r ad2antrr cN cn wcel vx cv cX wcel wa vd
      cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cc0 wne vy cv
      cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp
      wcel vd cv cN csqr cfv cdiv co cc0 wne vx cv cX wcel vr cv crp wcel vd cv
      crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv crp wcel cN
      cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co
      cc0 wne vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp
      wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr
      cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co
      rpne0 syl ancoms ad2ant2r ad2antrr syl3anc c2 2re 2ne0 rereccli sylancl
      adantlrr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co flcl vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      zcn 3syl vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv abscl syl cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co
      wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cabs cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cabs cfv cfl cfv c1 caddc co cz wcel vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv
      cfl cfv c1 caddc co cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr
      cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      cabs cfv cr wcel vx cv vy cv cN crrn cfv co vr cv clt wbr cN cn wcel vx
      cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm
      cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cc wcel vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cr wcel cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co vn cv vy cv cfv vn cv
      vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr
      cfv cdiv co cc0 wne vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr
      cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co
      wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      redivcl cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel vn cv
      c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv
      crp wcel vr cv crp wcel wa vn cv vy cv cfv cr wcel vn cv vx cv cfv cr
      wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN cn wcel vx cv cX
      wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv resubcl cN cn wcel vy cv cN crrn cfv cdm cdm
      wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx cv cX wcel c1 cN
      cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel cN cn
      wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz co cr vn cv vy cv
      ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN cfz co cr vy cv
      wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz
      co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv reex c1 cN cfz oprex
      elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv cX wcel wa vn cv c1
      cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm wcel vx
      cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN cn wcel c1
      cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vx
      cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx cv cr c1
      cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx
      cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap
      bitri sylanb adantll adantlr sylanc adantllr cN cn wcel vx cv cX wcel wa
      vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cr wcel vy
      cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp
      wcel vd cv cN csqr cfv cdiv co cr wcel vx cv cX wcel vr cv crp wcel vd cv
      crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN
      cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co
      cr wcel vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp
      wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr
      cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre
      syl ancoms ad2ant2r ad2antrr cN cn wcel vx cv cX wcel wa vd cv crp wcel
      vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cc0 wne vy cv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vd cv cN
      csqr cfv cdiv co cc0 wne vx cv cX wcel vr cv crp wcel vd cv crp wcel cN
      cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv crp wcel cN cn wcel wa vd
      cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn
      wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp
      wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpne0 syl
      ancoms ad2ant2r ad2antrr syl3anc recnd vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co abscl syl adantlrr vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cr
      wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cabs cfv cfl cfv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cabs cfv flcl peano2zdi vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cfl cfv c1
      caddc co zre 3syl cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr
      cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv cr wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv
      crp wcel wa wa vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel vy
      cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa
      vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vr cv crp wcel wa vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel vx cv cX wcel cN cn
      wcel vd cv crp wcel vr cv crp wcel wa wa vr cv vd cv cN csqr cfv cdiv co
      cdiv co cr wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cz wcel
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel cN cn wcel vd cv
      crp wcel vr cv crp wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cr wcel
      vr cv crp wcel cN cn wcel vd cv crp wcel wa vr cv vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vr cv crp wcel cN cn wcel vd cv crp wcel wa wa vr cv
      vd cv cN csqr cfv cdiv co cdiv co crp wcel vr cv vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vr cv crp wcel vd cv cN csqr cfv cdiv co crp wcel vr
      cv vd cv cN csqr cfv cdiv co cdiv co crp wcel cN cn wcel vd cv crp wcel
      wa vr cv vd cv cN csqr cfv cdiv co rpdivcl vd cv crp wcel cN cn wcel vd
      cv cN csqr cfv cdiv co crp wcel vd cv crp wcel cN csqr cfv crp wcel vd cv
      cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn
      wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2
      ancoms sylan2 vr cv vd cv cN csqr cfv cdiv co cdiv co rpre syl ancoms
      anasss vr cv vd cv cN csqr cfv cdiv co cdiv co flcl vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv zre 3syl adantlr ad2antrr vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv peano2re syl cN cn wcel vx cv cX wcel wa vd
      cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy
      cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy
      cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv cabs cfv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cfl cfv c1 caddc co
      cle wbr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa
      vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel vx cv vy
      cv cN crrn cfv co vr cv clt wbr vn cv vy cv cfv vn cv vx cv cfv cmin co
      cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv co cc0
      wne vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel
      wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl cN cn
      wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co
      wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv crp wcel vr cv
      crp wcel wa vn cv vy cv cfv cr wcel vn cv vx cv cfv cr wcel vn cv vy cv
      cfv vn cv vx cv cfv cmin co cr wcel cN cn wcel vx cv cX wcel wa vy cv cN
      crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv
      vx cv cfv resubcl cN cn wcel vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN
      cfz co wcel vn cv vy cv cfv cr wcel vx cv cX wcel c1 cN cfz co cr vy cv
      wf vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel wa c1 cN cfz co cr vn cv vy cv ffvelrn cN cn wcel
      vy cv cN crrn cfv cdm cdm wcel c1 cN cfz co cr vy cv wf cN cn wcel vy cv
      cN crrn cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vy cv wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vy cv cN
      rrndm eleq2d cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap syl6bb
      biimpa sylan adantllr cN cn wcel vx cv cX wcel wa vn cv c1 cN cfz co wcel
      vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv cX wcel vn
      cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN cn wcel c1 cN cfz co cr
      vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vx cv cX wcel c1
      cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx cv cr c1 cN cfz co cm
      co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx cv
      rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap bitri
      sylanb adantll adantlr sylanc adantllr cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cr wcel vy cv cN
      crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel
      vd cv cN csqr cfv cdiv co cr wcel vx cv cX wcel vr cv crp wcel vd cv crp
      wcel cN cn wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN cn
      wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr
      wcel vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp
      wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr
      cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre
      syl ancoms ad2ant2r ad2antrr cN cn wcel vx cv cX wcel wa vd cv crp wcel
      vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cc0 wne vy cv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vd cv cN
      csqr cfv cdiv co cc0 wne vx cv cX wcel vr cv crp wcel vd cv crp wcel cN
      cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv crp wcel cN cn wcel wa vd
      cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn
      wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp
      wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpne0 syl
      ancoms ad2ant2r ad2antrr syl3anc adantlrr vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co absrdbnd syl cN cn wcel vx cv
      cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co
      wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cabs cfv cfl cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      cle wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cabs cfv cfl cfv c1 caddc co vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cle wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co cabs cfv cr wcel vr cv vd cv cN csqr cfv
      cdiv co cdiv co cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cabs cfv vr cv vd cv cN csqr cfv cdiv co cdiv co
      cle wbr vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cabs cfv cfl cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      cle wbr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa
      vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr
      wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cabs cfv vr cv vd cv cN csqr cfv cdiv
      co cdiv co flwordi cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs
      cfv cr wcel vx cv vy cv cN crrn cfv co vr cv clt wbr cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co cc wcel vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cr wcel cN cn wcel
      vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv
      cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co vn cv vy cv cfv vn cv vx cv
      cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv
      cdiv co cc0 wne vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv
      crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel
      wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      redivcl cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel vn cv
      c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv
      crp wcel vr cv crp wcel wa vn cv vy cv cfv cr wcel vn cv vx cv cfv cr
      wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN cn wcel vx cv cX
      wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv resubcl cN cn wcel vy cv cN crrn cfv cdm cdm
      wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx cv cX wcel c1 cN
      cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel cN cn
      wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz co cr vn cv vy cv
      ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN cfz co cr vy cv
      wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz
      co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv reex c1 cN cfz oprex
      elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv cX wcel wa vn cv c1
      cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm wcel vx
      cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN cn wcel c1
      cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vx
      cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx cv cr c1
      cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx
      cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap
      bitri sylanb adantll adantlr sylanc adantllr cN cn wcel vx cv cX wcel wa
      vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cr wcel vy
      cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp
      wcel vd cv cN csqr cfv cdiv co cr wcel vx cv cX wcel vr cv crp wcel vd cv
      crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN
      cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co
      cr wcel vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp
      wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr
      cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre
      syl ancoms ad2ant2r ad2antrr cN cn wcel vx cv cX wcel wa vd cv crp wcel
      vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cc0 wne vy cv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vd cv cN
      csqr cfv cdiv co cc0 wne vx cv cX wcel vr cv crp wcel vd cv crp wcel cN
      cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv crp wcel cN cn wcel wa vd
      cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn
      wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp
      wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpne0 syl
      ancoms ad2ant2r ad2antrr syl3anc recnd vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co abscl syl adantlrr cN cn wcel
      vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vr cv vd cv cN csqr
      cfv cdiv co cdiv co cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel cN cn wcel vd cv crp
      wcel vr cv crp wcel wa vr cv vd cv cN csqr cfv cdiv co cdiv co cr wcel vx
      cv cX wcel cN cn wcel vd cv crp wcel vr cv crp wcel vr cv vd cv cN csqr
      cfv cdiv co cdiv co cr wcel vr cv crp wcel cN cn wcel vd cv crp wcel wa
      vr cv vd cv cN csqr cfv cdiv co cdiv co cr wcel vr cv crp wcel cN cn wcel
      vd cv crp wcel wa wa vr cv vd cv cN csqr cfv cdiv co cdiv co crp wcel vr
      cv vd cv cN csqr cfv cdiv co cdiv co cr wcel vr cv crp wcel vd cv cN csqr
      cfv cdiv co crp wcel vr cv vd cv cN csqr cfv cdiv co cdiv co crp wcel cN
      cn wcel vd cv crp wcel wa vr cv vd cv cN csqr cfv cdiv co rpdivcl vd cv
      crp wcel cN cn wcel vd cv cN csqr cfv cdiv co crp wcel vd cv crp wcel cN
      csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN
      csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN
      rpsqrcl syl sylan2 ancoms sylan2 vr cv vd cv cN csqr cfv cdiv co cdiv co
      rpre syl ancoms anasss adantlr ad2antrr cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv
      cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv vn
      cv vy cv cfv vn cv vx cv cfv cmin co cabs cfv vd cv cN csqr cfv cdiv co
      cdiv co vr cv vd cv cN csqr cfv cdiv co cdiv co cle cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co
      wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cabs cfv vn cv vy cv cfv vn cv vx cv cfv cmin co cabs cfv vd cv
      cN csqr cfv cdiv co cabs cfv cdiv co vn cv vy cv cfv vn cv vx cv cfv cmin
      co cabs cfv vd cv cN csqr cfv cdiv co cdiv co vn cv vy cv cfv vn cv vx cv
      cfv cmin co cc wcel vd cv cN csqr cfv cdiv co cc wcel vd cv cN csqr cfv
      cdiv co cc0 wne vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co cabs cfv vn cv vy cv cfv vn cv vx cv cfv cmin co cabs cfv
      vd cv cN csqr cfv cdiv co cabs cfv cdiv co wceq cN cn wcel vx cv cX wcel
      wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx
      cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co absdiv cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn
      cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co cN cn
      wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn
      cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv
      cmin co cr wcel vx cv vy cv cN crrn cfv co vr cv clt wbr cN cn wcel vx cv
      cX wcel wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv
      vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv crp wcel vr cv crp wcel
      wa vn cv vy cv cfv cr wcel vn cv vx cv cfv cr wcel vn cv vy cv cfv vn cv
      vx cv cfv cmin co cr wcel cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv
      cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv
      cfv resubcl cN cn wcel vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co
      wcel vn cv vy cv cfv cr wcel vx cv cX wcel c1 cN cfz co cr vy cv wf vn cv
      c1 cN cfz co wcel vn cv vy cv cfv cr wcel cN cn wcel vy cv cN crrn cfv
      cdm cdm wcel wa c1 cN cfz co cr vn cv vy cv ffvelrn cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel c1 cN cfz co cr vy cv wf cN cn wcel vy cv cN crrn
      cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv
      wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vy cv cN rrndm
      eleq2d cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap syl6bb biimpa
      sylan adantllr cN cn wcel vx cv cX wcel wa vn cv c1 cN cfz co wcel vn cv
      vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv cX wcel vn cv c1
      cN cfz co wcel vn cv vx cv cfv cr wcel cN cn wcel c1 cN cfz co cr vx cv
      wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vx cv cX wcel c1 cN
      cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx cv rrntotbnd.1
      eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap bitri sylanb
      adantll adantlr sylanc adantllr adantlrr recnd cN cn wcel vx cv cX wcel
      wa vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cc wcel
      vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr
      wa vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vd cv cN csqr cfv
      cdiv co cc wcel vx cv cX wcel vr cv crp wcel cN cn wcel vd cv crp wcel wa
      vd cv cN csqr cfv cdiv co vd cv crp wcel cN cn wcel vd cv cN csqr cfv
      cdiv co cr wcel vd cv crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co
      crp wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN csqr cfv crp
      wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv
      rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl
      syl sylan2 vd cv cN csqr cfv cdiv co rpre syl ancoms recnd ad2ant2r
      ad2antrr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa
      vd cv cN csqr cfv cdiv co cc0 wne vy cv cN crrn cfv cdm cdm wcel vx cv vy
      cv cN crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel cN cn wcel vd
      cv crp wcel vd cv cN csqr cfv cdiv co cc0 wne vx cv cX wcel vr cv crp
      wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cc0 wne vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv
      cdiv co rpne0 syl ancoms ad2ant2r ad2antrr syl3anc cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co
      wcel wa vd cv cN csqr cfv cdiv co cabs cfv vd cv cN csqr cfv cdiv co vn
      cv vy cv cfv vn cv vx cv cfv cmin co cabs cfv cdiv cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co
      cabs cfv vd cv cN csqr cfv cdiv co wceq vy cv cN crrn cfv cdm cdm wcel vx
      cv vy cv cN crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel cN cn
      wcel vd cv crp wcel vd cv cN csqr cfv cdiv co cabs cfv vd cv cN csqr cfv
      cdiv co wceq vx cv cX wcel vr cv crp wcel vd cv cN csqr cfv cdiv co cr
      wcel cc0 vd cv cN csqr cfv cdiv co cle wbr vd cv cN csqr cfv cdiv co cabs
      cfv vd cv cN csqr cfv cdiv co wceq cN cn wcel vd cv crp wcel wa vd cv cN
      csqr cfv cdiv co absid vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv
      co cr wcel vd cv crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN csqr cfv crp
      wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv
      rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl
      syl sylan2 vd cv cN csqr cfv cdiv co rpre syl ancoms cN cn wcel vd cv crp
      wcel wa vd cv cN csqr cfv cdiv co crp wcel cc0 vd cv cN csqr cfv cdiv co
      cle wbr vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co crp wcel vd
      cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn
      wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp
      wcel cN nnrp cN rpsqrcl syl sylan2 ancoms vd cv cN csqr cfv cdiv co rpge0
      syl sylanc ad2ant2r ad2antrr opreq2d eqtrd cN cn wcel vx cv cX wcel wa vd
      cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy
      cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy
      cv cfv vn cv vx cv cfv cmin co cabs cfv vr cv cle wbr vn cv vy cv cfv vn
      cv vx cv cfv cmin co cabs cfv vd cv cN csqr cfv cdiv co cdiv co vr cv vd
      cv cN csqr cfv cdiv co cdiv co cle wbr cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv
      cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv
      cfv vn cv vx cv cfv cmin co cabs cfv vx cv vy cv cN crrn cfv co vr cv cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn
      cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co cc wcel vn cv vy cv cfv vn cv vx
      cv cfv cmin co cabs cfv cr wcel cN cn wcel vx cv cX wcel wa vd cv crp
      wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz
      co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin
      co cr wcel vd cv crp wcel vr cv crp wcel wa vn cv vy cv cfv cr wcel vn cv
      vx cv cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN cn
      wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz
      co wcel wa vn cv vy cv cfv vn cv vx cv cfv resubcl cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx
      cv cX wcel c1 cN cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv
      cfv cr wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz co cr
      vn cv vy cv ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN cfz
      co cr vy cv wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm cdm
      cr c1 cN cfz co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv reex c1
      cN cfz oprex elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv cX wcel
      wa vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm
      cdm wcel vx cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN
      cn wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv
      cr wcel vx cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel
      vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz
      co cm co vx cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz
      oprex elmap bitri sylanb adantll adantlr sylanc adantllr adantlrr vn cv
      vy cv cfv vn cv vx cv cfv cmin co recn vn cv vy cv cfv vn cv vx cv cfv
      cmin co abscl 3syl cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr
      cv clt wbr wa wa vx cv vy cv cN crrn cfv co cr wcel vn cv c1 cN cfz co
      wcel cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel vx cv vy
      cv cN crrn cfv co cr wcel vd cv crp wcel vr cv crp wcel wa vx cv vy cv cN
      crrn cfv co vr cv clt wbr cN crrn cfv cme wcel vx cv cN crrn cfv cdm cdm
      wcel vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co cr wcel cN
      cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vx cv vy cv cN
      crrn cfv cN crrn cfv cdm cdm cN crrn cfv cdm cdm eqid metcl cN cn wcel cN
      crrn cfv cme wcel vx cv cX wcel vy cv cN crrn cfv cdm cdm wcel cN rrnmet
      ad2antrr cN cn wcel vx cv cX wcel wa vx cv cN crrn cfv cdm cdm wcel vy cv
      cN crrn cfv cdm cdm wcel cN cn wcel vx cv cX wcel vx cv cN crrn cfv cdm
      cdm wcel cN cn wcel cX cN crrn cfv cdm cdm vx cv cN cn wcel cN crrn cfv
      cdm cdm cr c1 cN cfz co cm co cX cN rrndm rrntotbnd.1 syl6reqr eleq2d
      biimpa adantr cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel
      pm3.27 syl3anc ad2ant2r adantr cN cn wcel vx cv cX wcel wa vd cv crp wcel
      vr cv crp wcel wa wa vr cv cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv
      vy cv cN crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel vr cv crp
      wcel vr cv cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv rpre
      ad2antll ad2antrr cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co cabs cfv vx cv vy cv cN crrn cfv
      co cle wbr vd cv crp wcel vr cv crp wcel wa cN cn wcel vx cv cX wcel wa
      vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn
      cv vx cv cfv cmin co cabs cfv vx cv vy cv cN crrn cfv co cle wbr vx cv vy
      cv cN crrn cfv co vr cv clt wbr cN cn wcel vx cv cX wcel wa vy cv cN crrn
      cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx
      cv cfv cabs cmin ccom cr cr cxp cres co vn cv vy cv cfv vn cv vx cv cfv
      cmin co cabs cfv vx cv vy cv cN crrn cfv co cle vn cv vy cv cfv cr wcel
      vn cv vx cv cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cabs cmin ccom cr
      cr cxp cres co vn cv vy cv cfv vn cv vx cv cfv cmin co cabs cfv wceq cN
      cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN
      cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp
      cres cabs cmin ccom cr cr cxp cres eqid remetdval cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx
      cv cX wcel c1 cN cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv
      cfv cr wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz co cr
      vn cv vy cv ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN cfz
      co cr vy cv wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm cdm
      cr c1 cN cfz co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv reex c1
      cN cfz oprex elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv cX wcel
      wa vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm
      cdm wcel vx cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN
      cn wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv
      cr wcel vx cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel
      vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz
      co cm co vx cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz
      oprex elmap bitri sylanb adantll adantlr sylanc cN cn wcel vx cv cX wcel
      wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy
      cv cfv vn cv vx cv cfv cabs cmin ccom cr cr cxp cres co vn cv vx cv cfv
      vn cv vy cv cfv cabs cmin ccom cr cr cxp cres co vx cv vy cv cN crrn cfv
      co cle cabs cmin ccom cr cr cxp cres cme wcel vn cv vy cv cfv cr wcel vn
      cv vx cv cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cabs cmin ccom cr cr
      cxp cres co vn cv vx cv cfv vn cv vy cv cfv cabs cmin ccom cr cr cxp cres
      co wceq cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn
      cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cabs cmin ccom cr
      cr cxp cres cr cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp
      cres eqid remetba metsym cabs cmin ccom cr cr cxp cres cme wcel cN cn
      wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz
      co wcel wa cabs cmin ccom cr cr cxp cres cabs cmin ccom cr cr cxp cres
      eqid remet a1i cN cn wcel vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz
      co wcel vn cv vy cv cfv cr wcel vx cv cX wcel c1 cN cfz co cr vy cv wf vn
      cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel cN cn wcel vy cv cN crrn cfv
      cdm cdm wcel wa c1 cN cfz co cr vn cv vy cv ffvelrn cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel c1 cN cfz co cr vy cv wf cN cn wcel vy cv cN crrn
      cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv
      wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vy cv cN rrndm
      eleq2d cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap syl6bb biimpa
      sylan adantllr cN cn wcel vx cv cX wcel wa vn cv c1 cN cfz co wcel vn cv
      vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv cX wcel vn cv c1
      cN cfz co wcel vn cv vx cv cfv cr wcel cN cn wcel c1 cN cfz co cr vx cv
      wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vx cv cX wcel c1 cN
      cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx cv rrntotbnd.1
      eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap bitri sylanb
      adantll adantlr syl3anc cN cn wcel vx cv cX wcel wa vy cv cX wcel wa vn
      cv c1 cN cfz co wcel vn cv vx cv cfv vn cv vy cv cfv cabs cmin ccom cr cr
      cxp cres co vx cv vy cv cN crrn cfv co cle wbr cN cn wcel vx cv cX wcel
      wa vy cv cN crrn cfv cdm cdm wcel wa cN cn wcel vx cv cX wcel wa vy cv cX
      wcel wa vn cv c1 cN cfz co wcel vn cv vx cv cfv vn cv vy cv cfv cabs cmin
      ccom cr cr cxp cres co vx cv vy cv cN crrn cfv co cle wbr cN cn wcel vx
      cv cX wcel vy cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv vn cv vy
      cv cfv cabs cmin ccom cr cr cxp cres co vx cv vy cv cN crrn cfv co cle
      wbr wi cN cn wcel vx cv cX wcel vy cv cX wcel wa wa vn cv c1 cN cfz co
      wcel vn cv vx cv cfv vn cv vy cv cfv cabs cmin ccom cr cr cxp cres co vx
      cv vy cv cN crrn cfv co cle wbr cN cn wcel vn cv c1 cN cfz co wcel vx cv
      cX wcel vy cv cX wcel wa vn cv vx cv cfv vn cv vy cv cfv cabs cmin ccom
      cr cr cxp cres co vx cv vy cv cN crrn cfv co cle wbr vn cv vx cv vy cv
      cabs cmin ccom cr cr cxp cres cN cX cabs cmin ccom cr cr cxp cres eqid
      rrntotbnd.1 rrndstprj an1rs ex anassrs imp cN cn wcel vx cv cX wcel wa vy
      cv cN crrn cfv cdm cdm wcel vy cv cX wcel cN cn wcel vy cv cN crrn cfv
      cdm cdm wcel vy cv cX wcel wi vx cv cX wcel cN cn wcel vy cv cX wcel vy
      cv cN crrn cfv cdm cdm wcel cN cn wcel cX cN crrn cfv cdm cdm vy cv cN cn
      wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co cX cN rrndm rrntotbnd.1
      syl6reqr eleq2d biimprd adantr imdistani sylan eqbrtrd eqbrtrrd adantlrr
      adantllr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa
      vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr
      wa wa vx cv vy cv cN crrn cfv co vr cv cle wbr vn cv c1 cN cfz co wcel cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr vx cv vy
      cv cN crrn cfv co vr cv cle wbr vx cv vy cv cN crrn cfv co cr wcel vr cv
      cr wcel vx cv vy cv cN crrn cfv co vr cv clt wbr vx cv vy cv cN crrn cfv
      co vr cv cle wbr wi cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vx cv vy cv cN crrn cfv co
      vr cv ltle cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel vx
      cv vy cv cN crrn cfv co cr wcel vd cv crp wcel vr cv crp wcel wa cN crrn
      cfv cme wcel vx cv cN crrn cfv cdm cdm wcel vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co cr wcel cN cn wcel vx cv cX wcel wa vy cv
      cN crrn cfv cdm cdm wcel wa vx cv vy cv cN crrn cfv cN crrn cfv cdm cdm
      cN crrn cfv cdm cdm eqid metcl cN cn wcel cN crrn cfv cme wcel vx cv cX
      wcel vy cv cN crrn cfv cdm cdm wcel cN rrnmet ad2antrr cN cn wcel vx cv
      cX wcel wa vx cv cN crrn cfv cdm cdm wcel vy cv cN crrn cfv cdm cdm wcel
      cN cn wcel vx cv cX wcel vx cv cN crrn cfv cdm cdm wcel cN cn wcel cX cN
      crrn cfv cdm cdm vx cv cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm
      co cX cN rrndm rrntotbnd.1 syl6reqr eleq2d biimpa adantr cN cn wcel vx cv
      cX wcel wa vy cv cN crrn cfv cdm cdm wcel pm3.27 syl3anc adantlr vd cv
      crp wcel vr cv crp wcel wa vr cv cr wcel cN cn wcel vx cv cX wcel wa vy
      cv cN crrn cfv cdm cdm wcel vr cv crp wcel vr cv cr wcel vd cv crp wcel
      vr cv rpre adantl ad2antlr sylanc impr adantr letrd vn cv vy cv cfv vn cv
      vx cv cfv cmin co cabs cfv cr wcel vr cv cr wcel vd cv cN csqr cfv cdiv
      co cr wcel cc0 vd cv cN csqr cfv cdiv co clt wbr wa vn cv vy cv cfv vn cv
      vx cv cfv cmin co cabs cfv vr cv cle wbr vn cv vy cv cfv vn cv vx cv cfv
      cmin co cabs cfv vd cv cN csqr cfv cdiv co cdiv co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cle wbr wb cN cn wcel vx cv cX wcel wa vd cv crp wcel
      vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn
      cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn
      cv vx cv cfv cmin co cabs cfv vr cv vd cv cN csqr cfv cdiv co lediv1 cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn
      cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co cc wcel vn cv vy cv cfv vn cv vx
      cv cfv cmin co cabs cfv cr wcel cN cn wcel vx cv cX wcel wa vd cv crp
      wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz
      co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr cN cn wcel vx cv cX wcel wa vy cv cN crrn cfv
      cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin
      co cr wcel vd cv crp wcel vr cv crp wcel wa vn cv vy cv cfv cr wcel vn cv
      vx cv cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN cn
      wcel vx cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz
      co wcel wa vn cv vy cv cfv vn cv vx cv cfv resubcl cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx
      cv cX wcel c1 cN cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv
      cfv cr wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel wa c1 cN cfz co cr
      vn cv vy cv ffvelrn cN cn wcel vy cv cN crrn cfv cdm cdm wcel c1 cN cfz
      co cr vy cv wf cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vy cv wf cN cn wcel cN crrn cfv cdm cdm
      cr c1 cN cfz co cm co vy cv cN rrndm eleq2d cr c1 cN cfz co vy cv reex c1
      cN cfz oprex elmap syl6bb biimpa sylan adantllr cN cn wcel vx cv cX wcel
      wa vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cN crrn cfv cdm
      cdm wcel vx cv cX wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel cN
      cn wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx cv cfv
      cr wcel vx cv cX wcel c1 cN cfz co cr vn cv vx cv ffvelrn vx cv cX wcel
      vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz
      co cm co vx cv rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz
      oprex elmap bitri sylanb adantll adantlr sylanc adantllr adantlrr vn cv
      vy cv cfv vn cv vx cv cfv cmin co recn vn cv vy cv cfv vn cv vx cv cfv
      cmin co abscl 3syl cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vr cv cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel vr cv crp wcel vr cv
      cr wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv rpre ad2antll
      ad2antrr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa
      vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr
      wa wa vn cv c1 cN cfz co wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv
      cN csqr cfv cdiv co cr wcel cc0 vd cv cN csqr cfv cdiv co clt wbr wa cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vd cv cN
      csqr cfv cdiv co crp wcel vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr wa vn cv c1 cN cfz co wcel cN cn wcel vd cv crp
      wcel vd cv cN csqr cfv cdiv co crp wcel vx cv cX wcel vr cv crp wcel vd
      cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co crp wcel vd cv crp wcel
      cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv
      cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp
      cN rpsqrcl syl sylan2 ancoms ad2ant2r ad2antrr vd cv cN csqr cfv cdiv co
      elrp sylib syl3anc mpbid eqbrtrd syl3anc vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cfl cfv cr wcel vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel c1 cr wcel vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv
      cfl cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cle wbr vn cv vy
      cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv
      cfl cfv c1 caddc co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cle wbr wb cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp
      wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr
      cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cfl cfv vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 leadd1 cN cn wcel vx cv cX wcel
      wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx
      cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      cabs cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cabs cfv cfl cfv cz wcel vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cfl cfv cr wcel cN
      cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN
      crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv cr wcel vx cv vy
      cv cN crrn cfv co vr cv clt wbr cN cn wcel vx cv cX wcel wa vd cv crp
      wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN
      cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co cc wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cabs cfv cr wcel cN cn wcel vx cv cX wcel wa vd
      cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel wa vn cv
      c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel
      vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv co cc0 wne vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr
      wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy
      cv cN crrn cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl cN cn wcel vx
      cv cX wcel wa vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz co wcel vn
      cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv crp wcel vr cv crp
      wcel wa vn cv vy cv cfv cr wcel vn cv vx cv cfv cr wcel vn cv vy cv cfv
      vn cv vx cv cfv cmin co cr wcel cN cn wcel vx cv cX wcel wa vy cv cN crrn
      cfv cdm cdm wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx
      cv cfv resubcl cN cn wcel vy cv cN crrn cfv cdm cdm wcel vn cv c1 cN cfz
      co wcel vn cv vy cv cfv cr wcel vx cv cX wcel c1 cN cfz co cr vy cv wf vn
      cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel cN cn wcel vy cv cN crrn cfv
      cdm cdm wcel wa c1 cN cfz co cr vn cv vy cv ffvelrn cN cn wcel vy cv cN
      crrn cfv cdm cdm wcel c1 cN cfz co cr vy cv wf cN cn wcel vy cv cN crrn
      cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vy cv
      wf cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vy cv cN rrndm
      eleq2d cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap syl6bb biimpa
      sylan adantllr cN cn wcel vx cv cX wcel wa vn cv c1 cN cfz co wcel vn cv
      vx cv cfv cr wcel vy cv cN crrn cfv cdm cdm wcel vx cv cX wcel vn cv c1
      cN cfz co wcel vn cv vx cv cfv cr wcel cN cn wcel c1 cN cfz co cr vx cv
      wf vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vx cv cX wcel c1 cN
      cfz co cr vn cv vx cv ffvelrn vx cv cX wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx cv rrntotbnd.1
      eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap bitri sylanb
      adantll adantlr sylanc adantllr cN cn wcel vx cv cX wcel wa vd cv crp
      wcel vr cv crp wcel wa wa vd cv cN csqr cfv cdiv co cr wcel vy cv cN crrn
      cfv cdm cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vd cv
      cN csqr cfv cdiv co cr wcel vx cv cX wcel vr cv crp wcel vd cv crp wcel
      cN cn wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN cn wcel wa
      vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel vd
      cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn
      wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp
      wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre syl
      ancoms ad2ant2r ad2antrr cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv
      crp wcel wa wa vd cv cN csqr cfv cdiv co cc0 wne vy cv cN crrn cfv cdm
      cdm wcel vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vd cv cN csqr
      cfv cdiv co cc0 wne vx cv cX wcel vr cv crp wcel vd cv crp wcel cN cn
      wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv crp wcel cN cn wcel wa vd cv
      cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv crp
      wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel
      vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN
      nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpne0 syl ancoms
      ad2ant2r ad2antrr syl3anc recnd vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co abscl syl adantlrr vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cabs cfv flcl vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      cabs cfv cfl cfv zre 3syl cN cn wcel vx cv cX wcel wa vd cv crp wcel vr
      cv crp wcel wa wa vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel
      vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr
      wa vn cv c1 cN cfz co wcel cN cn wcel vd cv crp wcel vr cv crp wcel wa vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel vx cv cX wcel cN cn
      wcel vd cv crp wcel vr cv crp wcel wa wa vr cv vd cv cN csqr cfv cdiv co
      cdiv co cr wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cz wcel
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv cr wcel cN cn wcel vd cv
      crp wcel vr cv crp wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cr wcel
      vr cv crp wcel cN cn wcel vd cv crp wcel wa vr cv vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vr cv crp wcel cN cn wcel vd cv crp wcel wa wa vr cv
      vd cv cN csqr cfv cdiv co cdiv co crp wcel vr cv vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vr cv crp wcel vd cv cN csqr cfv cdiv co crp wcel vr
      cv vd cv cN csqr cfv cdiv co cdiv co crp wcel cN cn wcel vd cv crp wcel
      wa vr cv vd cv cN csqr cfv cdiv co rpdivcl vd cv crp wcel cN cn wcel vd
      cv cN csqr cfv cdiv co crp wcel vd cv crp wcel cN csqr cfv crp wcel vd cv
      cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn
      wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2
      ancoms sylan2 vr cv vd cv cN csqr cfv cdiv co cdiv co rpre syl ancoms
      anasss vr cv vd cv cN csqr cfv cdiv co cdiv co flcl vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv zre 3syl adantlr ad2antrr c1 cr wcel cN cn
      wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn
      cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vn cv c1
      cN cfz co wcel wa 1re a1i syl3anc mpbid letrd syl3anc r19.21aiva vn vv c1
      cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab vn cv c1 cN cfz co wcel vv cv vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv wceq wa vn vv copab eqid fopab2 sylib cN cn
      wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn
      cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wa vm cv c1
      cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn
      cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co eqidd sylanc c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm
      vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex c1 cN cfz co vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv
      c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa vf wex va vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz co wcel vu cv vm
      cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv
      cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc
      co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv oprex va cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv
      c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wceq c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab
      vd cv cN crrn cfv cbl cfv co wceq wa c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa
      vf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cbl cfv co wceq va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm
      vu copab vd cv cN crrn cfv cbl cfv co wceq vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq c1
      cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co eqeq1 anbi2d exbidv elab sylibr
      $.
      $( [2-Sep-2009] $)

    $( Lemma for ~ rrntotbnd . $)
    rrntotbndlem2 $p |- ( ( ( N e. NN /\ d e. RR+ ) /\
            ( x e. ( RR ^m ( 1 ... N ) ) /\ y e. ( RR ^m ( 1 ... N ) ) ) ) ->
                    ( { <. m , u >. | ( m e. ( 1 ... N ) /\ u = ( ( x ` m ) +
          ( ( d / ( sqr ` N ) ) x. ( { <. n , v >. | ( n e. ( 1 ... N ) /\ v =
                ( |_ ` ( ( ( ( y ` n ) - ( x ` n ) ) / ( d / ( sqr ` N ) ) ) +
                        ( 1 / 2 ) ) ) ) } ` m ) ) ) ) } ( Rn ` N ) y ) < d ) $=
      cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel wa wa vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv
      vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm
      vu copab vy cv cN crrn cfv co vd cv cN csqr cfv cdiv co cN csqr cfv cmul
      co vd cv clt cN cn wcel vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd
      cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm
      vu copab cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel w3a
      vd cv cN csqr cfv cdiv co crp wcel va cv vm cv c1 cN cfz co wcel vu cv vm
      cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv
      cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc
      co wceq wa vm vu copab cfv va cv vy cv cfv cabs cmin ccom cr cr cxp cres
      co vd cv cN csqr cfv cdiv co clt wbr va c1 cN cfz co wral vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab vy cv cN crrn cfv co vd cv cN
      csqr cfv cdiv co cN csqr cfv cmul co clt wbr cN cn wcel vd cv crp wcel wa
      vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa
      cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel wa wa cN cn wcel vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co
      wceq wa vm vu copab cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm
      co wcel cN cn wcel vd cv crp wcel vx cv cr c1 cN cfz co cm co wcel vy cv
      cr c1 cN cfz co cm co wcel wa simpll cN cn wcel vd cv crp wcel wa vx cv
      cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa c1 cN
      cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab wf vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn
      vv copab cfv cmul co caddc co wceq wa vm vu copab cr c1 cN cfz co cm co
      wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv
      cr c1 cN cfz co cm co wcel wa wa vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv cmul co caddc co cr wcel vm c1 cN cfz co wral c1
      cN cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab wf
      cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1
      cN cfz co cm co wcel wa wa vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa
      vn vv copab cfv cmul co caddc co cr wcel vm c1 cN cfz co vm cv vx cv cfv
      cr wcel vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co cr wcel vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co
      cr wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel wa wa vm cv c1 cN cfz co wcel wa vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co readdcl cN cn
      wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vm cv c1 cN cfz
      co wcel vm cv vx cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel vx cv cr
      c1 cN cfz co cm co wcel vm cv c1 cN cfz co wcel vm cv vx cv cfv cr wcel
      cN cn wcel vd cv crp wcel wa c1 cN cfz co cr vx cv wf vm cv c1 cN cfz co
      wcel vm cv vx cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz
      co cr vm cv vx cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex
      elmap sylanb adantll adantlrr vd cv cN csqr cfv cdiv co cr wcel vm cv vn
      cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cr wcel vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co cr
      wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv
      cr c1 cN cfz co cm co wcel wa wa vm cv c1 cN cfz co wcel wa vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv remulcl cN cn wcel vd cv crp wcel wa vd
      cv cN csqr cfv cdiv co cr wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr
      c1 cN cfz co cm co wcel wa vm cv c1 cN cfz co wcel vd cv crp wcel cN cn
      wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN cn wcel wa vd cv
      cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp
      wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel
      vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN
      nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre syl ancoms
      ad2antrr c1 cN cfz co cr vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab wf vm cv c1 cN cfz co wcel vm cv vn
      cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cr wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel wa wa c1 cN cfz co cr vm cv vn
      cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab ffvelrn cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel wa wa vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv cr wcel vn c1 cN cfz co wral c1 cN cfz co cr vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab wf cN cn wcel
      vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co
      cm co wcel wa wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr wcel vn c1 cN cfz
      co cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr
      c1 cN cfz co cm co wcel wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cr wcel c1 c2 cdiv co cr wcel vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cr wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel wa wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co readdcl vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vd cv
      cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv co cc0 wne vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel cN
      cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel wa wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vn cv c1 cN cfz co wcel vn
      cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN cn wcel vd cv crp wcel wa
      vn cv vy cv cfv cr wcel vn cv vx cv cfv cr wcel vn cv vy cv cfv vn cv vx
      cv cfv cmin co cr wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel wa vn cv c1 cN cfz co wcel wa vn cv vy cv cfv vn cv vx
      cv cfv resubcl vy cv cr c1 cN cfz co cm co wcel vn cv c1 cN cfz co wcel
      vn cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vy cv cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vn cv vy cv ffvelrn cr c1 cN cfz co vy
      cv reex c1 cN cfz oprex elmap sylanb adantll vx cv cr c1 cN cfz co cm co
      wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel vy cv cr c1 cN cfz
      co cm co wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz co wcel vn cv vx
      cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vn cv vx
      cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap sylanb
      adantlr sylanc adantll cN cn wcel vd cv crp wcel wa vd cv cN csqr cfv
      cdiv co cr wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm
      co wcel wa vn cv c1 cN cfz co wcel vd cv crp wcel cN cn wcel vd cv cN
      csqr cfv cdiv co cr wcel vd cv crp wcel cN cn wcel wa vd cv cN csqr cfv
      cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN csqr
      cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr
      cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN
      rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre syl ancoms ad2antrr cN
      cn wcel vd cv crp wcel wa vd cv cN csqr cfv cdiv co cc0 wne vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vn cv c1 cN cfz
      co wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cc0 wne vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv
      cdiv co rpne0 syl ancoms ad2antrr syl3anc c2 2re 2ne0 rereccli sylancl vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co flcl vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv zre 3syl
      r19.21aiva vn vv c1 cN cfz co cr vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vn cv c1
      cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq
      wa vn vv copab eqid fopab2 sylib sylan sylanc sylanc r19.21aiva vm vu c1
      cN cfz co cr vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab eqid
      fopab2 sylib cr c1 cN cfz co vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa
      vm vu copab reex c1 cN cfz oprex elmap sylibr cN cn wcel vd cv crp wcel
      wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      simprr 3jca cN cn wcel vd cv crp wcel wa vd cv cN csqr cfv cdiv co crp
      wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa
      vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co crp wcel vd cv crp
      wcel cN csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel
      vd cv cN csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN
      nnrp cN rpsqrcl syl sylan2 ancoms adantr cN cn wcel vd cv crp wcel wa vx
      cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa va
      cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab cfv va cv vy
      cv cfv cabs cmin ccom cr cr cxp cres co vd cv cN csqr cfv cdiv co clt wbr
      va c1 cN cfz co cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel wa wa va cv c1 cN cfz co wcel wa va
      cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab cfv va cv vy
      cv cfv cabs cmin ccom cr cr cxp cres co va cv vx cv cfv vd cv cN csqr cfv
      cdiv co va cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co va cv vy cv cfv cabs cmin
      ccom cr cr cxp cres co vd cv cN csqr cfv cdiv co clt va cv c1 cN cfz co
      wcel va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab cfv
      va cv vy cv cfv cabs cmin ccom cr cr cxp cres co va cv vx cv cfv vd cv cN
      csqr cfv cdiv co va cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co va cv vy cv cfv
      cabs cmin ccom cr cr cxp cres co wceq cN cn wcel vd cv crp wcel wa vx cv
      cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa va cv
      c1 cN cfz co wcel va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd
      cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm
      vu copab cfv va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp cres vm vu
      va cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vn cv c1 cN cfz
      co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv
      cmul co caddc co c1 cN cfz co vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa
      vm vu copab vm cv va cv wceq vm cv vx cv cfv va cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co vd cv cN csqr cfv cdiv
      co va cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv cmul co caddc vm cv va cv vx cv fveq2 vm cv va cv
      wceq vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv va cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab cfv vd cv cN csqr cfv cdiv co
      cmul vm cv va cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab fveq2 opreq2d opreq12d vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab eqid va cv vx cv cfv vd cv cN
      csqr cfv cdiv co va cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc oprex fvopab4
      opreq1d adantl cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel wa wa va cv c1 cN cfz co wcel wa va
      cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vn cv c1 cN cfz co wcel vv
      cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc
      co va cv vy cv cfv cabs cmin ccom cr cr cxp cres co va cv vx cv cfv vd cv
      cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co caddc co va cv
      vy cv cfv cabs cmin ccom cr cr cxp cres co vd cv cN csqr cfv cdiv co clt
      va cv c1 cN cfz co wcel va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv
      vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn
      vv copab cfv cmul co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp
      cres co va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cmul co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp cres
      co wceq cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel wa wa va cv c1 cN cfz co wcel va cv vx cv
      cfv vd cv cN csqr cfv cdiv co va cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co va cv
      vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul
      co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp cres va cv c1 cN cfz
      co wcel vd cv cN csqr cfv cdiv co va cv vn cv c1 cN cfz co wcel vv cv vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co vd cv cN csqr
      cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co va cv vx cv cfv
      caddc va cv c1 cN cfz co wcel va cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv vd cv cN csqr cfv cdiv co cmul vn vv va cv vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv c1 cN cfz co vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab vn cv va cv
      wceq vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co va cv vy cv cfv va cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl vn cv va cv
      wceq vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc vn cv va cv wceq vn cv vy cv cfv vn cv vx cv
      cfv cmin co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv vn cv va cv wceq vn cv vy cv cfv va cv vy cv cfv vn cv vx cv
      cfv va cv vx cv cfv cmin vn cv va cv vy cv fveq2 vn cv va cv vx cv fveq2
      opreq12d opreq1d opreq1d fveq2d vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab eqid va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      fvex fvopab4 opreq2d opreq2d opreq1d adantl cN cn wcel vd cv crp wcel wa
      vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa va
      cv c1 cN cfz co wcel va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cmul co caddc co va cv vy cv cfv cabs cmin ccom
      cr cr cxp cres co vd cv cN csqr cfv cdiv co clt wbr vd cv cN csqr cfv
      cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa va cv
      vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul
      co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp cres co vd cv cN
      csqr cfv cdiv co clt wbr cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz
      co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa va cv c1 cN cfz co wcel
      wa vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa wa va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv cmul co caddc co va cv vy cv cfv cabs cmin ccom cr cr
      cxp cres co va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv cmul co caddc co va cv vy cv cfv cmin co cabs cfv vd cv
      cN csqr cfv cdiv co clt va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cmul co caddc co cr wcel va cv vy cv cfv cr wcel
      va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cmul co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp cres co va cv
      vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul
      co caddc co va cv vy cv cfv cmin co cabs cfv wceq vd cv cN csqr cfv cdiv
      co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv
      vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul
      co caddc co va cv vy cv cfv cabs cmin ccom cr cr cxp cres cabs cmin ccom
      cr cr cxp cres eqid remetdval va cv vx cv cfv cr wcel vd cv cN csqr cfv
      cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co cr wcel va cv vx cv cfv vd
      cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co caddc co
      cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv
      vy cv cfv cr wcel wa wa va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cmul co readdcl vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel simprl vd cv cN csqr
      cfv cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr wcel vd cv cN csqr
      cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv remulcl
      vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel va
      cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co
      rpre adantr vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va
      cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv cz wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr wcel va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr
      wcel c1 c2 cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel vd cv cN csqr
      cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa
      wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co readdcl va cv vy cv cfv va cv vx cv cfv cmin co cr wcel
      vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv co cc0 wne va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr
      wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv
      co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv va cv vx cv cfv cmin co cr wcel va cv vy cv cfv va cv vx cv cfv
      resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd
      cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co crp wcel vd
      cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr wcel va cv vy cv cfv cr
      wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr syl3anc c2 2re 2ne0
      rereccli sylancl va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co flcl va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv zre 3syl sylanc sylanc vd cv cN csqr cfv cdiv co crp wcel va cv
      vx cv cfv cr wcel va cv vy cv cfv cr wcel simprr sylanc vd cv cN csqr cfv
      cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa vd
      cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs
      cfv cmul co vd cv cN csqr cfv cdiv co c1 cmul co va cv vx cv cfv vd cv cN
      csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co caddc co va cv
      vy cv cfv cmin co cabs cfv vd cv cN csqr cfv cdiv co clt vd cv cN csqr
      cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa
      wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv c1 clt wbr vd cv cN
      csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv cmul
      co vd cv cN csqr cfv cdiv co c1 cmul co clt wbr vd cv cN csqr cfv cdiv co
      crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cmin co cabs cfv c1 c2 cdiv co c1 vd cv cN csqr
      cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa
      wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cmin co cc wcel va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co cmin co cabs cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cc
      wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cc wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cc wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co subcl vd cv cN csqr cfv cdiv co
      crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv vd cv cN csqr cfv cdiv co crp wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel
      va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv cz wcel va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cr wcel c1 c2 cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel
      vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co readdcl va cv vy cv cfv va cv vx cv cfv
      cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv
      co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv cr wcel
      va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv vy cv cfv va cv vx
      cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp wcel vd cv cN
      csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr syl3anc c2 2re
      2ne0 rereccli sylancl va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co flcl va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv zre 3syl recnd vd cv cN csqr cfv cdiv co crp wcel va cv
      vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co va cv vy cv cfv va cv vx
      cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr
      cfv cdiv co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx
      cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va
      cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel
      vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv vy cv
      cfv va cv vx cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv
      cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr
      syl3anc recnd sylanc va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co abscl
      syl c1 c2 cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv cr wcel wa wa c2 2re 2ne0 rereccli a1i c1 cr
      wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa wa 1re a1i vd cv cN csqr cfv cdiv co crp wcel va cv vx
      cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cmin co cabs cfv c1 c2 cdiv co cle wbr va cv vy cv
      cfv va cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd
      cv cN csqr cfv cdiv co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel
      va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co
      cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv
      vx cv cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv
      vy cv cfv va cv vx cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co
      crp wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv
      vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr
      cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr
      syl3anc va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co rddif syl c1 c2 cdiv co c1 clt wbr vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa halflt1 a1i
      lelttrd va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv cr wcel c1 cr
      wcel vd cv cN csqr cfv cdiv co cr wcel w3a cc0 vd cv cN csqr cfv cdiv co
      clt wbr va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv c1 clt wbr vd
      cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs
      cfv cmul co vd cv cN csqr cfv cdiv co c1 cmul co clt wbr wb vd cv cN csqr
      cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa
      wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv cr wcel c1 cr wcel vd
      cv cN csqr cfv cdiv co cr wcel cc0 vd cv cN csqr cfv cdiv co clt wbr va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cmin co cabs cfv c1 clt wbr vd cv cN csqr cfv
      cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv cmul co vd cv
      cN csqr cfv cdiv co c1 cmul co clt wbr wb va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      cmin co cabs cfv cr wcel c1 cr wcel vd cv cN csqr cfv cdiv co cr wcel cc0
      vd cv cN csqr cfv cdiv co clt wbr va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co
      cabs cfv c1 clt wbr vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cmin co cabs cfv cmul co vd cv cN csqr cfv cdiv co c1 cmul co clt
      wbr wb va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv cr wcel c1 cr
      wcel vd cv cN csqr cfv cdiv co cr wcel cc0 vd cv cN csqr cfv cdiv co clt
      wbr wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv c1 clt wbr vd
      cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs
      cfv cmul co vd cv cN csqr cfv cdiv co c1 cmul co clt wbr wb va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cmin co cabs cfv c1 vd cv cN csqr cfv cdiv co ltmul2
      3exp exp4a 3imp1 vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin
      co cabs cfv cr wcel c1 cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cc wcel va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cmin co cabs cfv cr wcel va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv cc wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co cc wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cc wcel
      vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co subcl vd cv cN csqr
      cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa
      wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv vd cv cN csqr cfv cdiv co crp wcel va
      cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cr wcel c1 c2 cdiv co cr wcel va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va
      cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co readdcl va cv vy cv cfv va cv
      vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr
      cfv cdiv co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx
      cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va
      cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel
      vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv vy cv
      cfv va cv vx cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv
      cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr
      syl3anc c2 2re 2ne0 rereccli sylancl va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co flcl va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv zre 3syl recnd vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co va cv vy cv
      cfv va cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd
      cv cN csqr cfv cdiv co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel
      va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co
      cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv
      vx cv cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv
      vy cv cfv va cv vx cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co
      crp wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv
      vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr
      cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr
      syl3anc recnd sylanc va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co abscl
      syl c1 cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel
      va cv vy cv cfv cr wcel wa wa 1re a1i vd cv cN csqr cfv cdiv co crp wcel
      vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv
      cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr 3jca vd cv cN csqr cfv
      cdiv co crp wcel cc0 vd cv cN csqr cfv cdiv co clt wbr va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpgt0 adantr
      sylanc mpbid vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel
      va cv vy cv cfv cr wcel wa wa va cv vx cv cfv vd cv cN csqr cfv cdiv co
      va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv cmul co caddc co va cv vy cv cfv cmin co
      cabs cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin
      co cmul co cabs cfv vd cv cN csqr cfv cdiv co cabs cfv va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cmin co cabs cfv cmul co vd cv cN csqr cfv cdiv co va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cmin co cabs cfv cmul co vd cv cN csqr cfv
      cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va
      cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cmul co caddc co va cv vy cv cfv cmin co vd cv cN csqr cfv cdiv co va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cmin co cmul co cabs vd cv cN csqr cfv cdiv co
      crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vx
      cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co
      caddc co va cv vy cv cfv cmin co vd cv cN csqr cfv cdiv co va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv cmul co va cv vx cv cfv caddc co va cv vy cv cfv cmin
      co vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co va
      cv vy cv cfv va cv vx cv cfv cmin co cmin co vd cv cN csqr cfv cdiv co va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cmin co cmul co vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vx cv
      cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co
      caddc co vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul
      co va cv vx cv cfv caddc co va cv vy cv cfv cmin va cv vx cv cfv cc wcel
      vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co cc
      wcel va cv vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv cmul co caddc co vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cmul co va cv vx cv cfv caddc co wceq vd cv cN csqr cfv cdiv
      co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv
      vx cv cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul
      co addcom va cv vx cv cfv cr wcel va cv vx cv cfv cc wcel vd cv cN csqr
      cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv recn
      ad2antrl vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv
      vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cmul co vd cv cN csqr cfv cdiv co cr wcel va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv cr wcel vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv cmul co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv remulcl vd cv cN csqr cfv cdiv co crp wcel vd cv
      cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr
      wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co
      crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cr wcel c1 c2 cdiv co cr wcel va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co readdcl va cv vy
      cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel
      vd cv cN csqr cfv cdiv co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl va cv vx cv
      cfv cr wcel va cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv
      cmin co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr
      wcel va cv vy cv cfv va cv vx cv cfv resubcl ancoms adantl vd cv cN csqr
      cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd
      cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv
      vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co
      rpne0 adantr syl3anc c2 2re 2ne0 rereccli sylancl va cv vy cv cfv va cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co flcl va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv zre 3syl sylanc recnd sylanc
      opreq1d vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co
      cc wcel va cv vy cv cfv cc wcel va cv vx cv cfv cc wcel vd cv cN csqr cfv
      cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co va cv vy cv cfv va cv vx
      cv cfv cmin co cmin co vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv cmul co va cv vx cv cfv caddc co va cv vy cv cfv cmin co wceq vd
      cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv
      cr wcel wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cmul co va cv vy cv cfv va cv vx cv cfv subsub3 vd cv cN csqr cfv cdiv co
      crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa vd cv cN
      csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co vd cv cN csqr
      cfv cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr wcel vd cv cN csqr
      cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv remulcl
      vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel va
      cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co
      rpre adantr vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va
      cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv cz wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr wcel va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr
      wcel c1 c2 cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel vd cv cN csqr
      cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa
      wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co readdcl va cv vy cv cfv va cv vx cv cfv cmin co cr wcel
      vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv co cc0 wne va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cr
      wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv
      co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv va cv vx cv cfv cmin co cr wcel va cv vy cv cfv va cv vx cv cfv
      resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd
      cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co crp wcel vd
      cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr wcel va cv vy cv cfv cr
      wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr syl3anc c2 2re 2ne0
      rereccli sylancl va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co flcl va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv zre 3syl sylanc recnd va cv vy cv cfv cr wcel va cv vy cv cfv cc
      wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv recn ad2antll va cv vx cv cfv cr wcel va cv vx cv cfv cc wcel vd
      cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv
      recn ad2antrl syl3anc vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv
      cr wcel va cv vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cmul co va cv vy cv cfv va cv vx cv cfv cmin co
      cmin co vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co
      vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cmul co cmin co vd cv cN csqr cfv cdiv co va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cmin co cmul co vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmul co vd cv cN
      csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cmul co cmin vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co cmul co va cv vy cv cfv va cv vx cv cfv
      cmin co va cv vy cv cfv va cv vx cv cfv cmin co cc wcel vd cv cN csqr cfv
      cdiv co cc wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv cN csqr cfv cdiv
      co va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co cmul co va cv vy cv cfv va cv vx cv cfv cmin co wceq vd cv cN csqr cfv
      cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co divcan2 vd
      cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv
      cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co
      cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv
      vx cv cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv
      vy cv cfv va cv vx cv cfv resubcl ancoms adantl recnd vd cv cN csqr cfv
      cdiv co crp wcel vd cv cN csqr cfv cdiv co cc wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpcn adantr vd
      cv cN csqr cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv
      vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co
      rpne0 adantr syl3anc eqcomd opreq2d vd cv cN csqr cfv cdiv co cc wcel va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv cc wcel va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co cc wcel vd cv cN csqr cfv cdiv co va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co cmin co cmul co vd cv cN csqr cfv cdiv co va
      cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv cmul co vd cv cN csqr cfv cdiv co va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmul co
      cmin co wceq vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel
      va cv vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv
      va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co subdi vd cv cN csqr cfv cdiv co crp wcel vd cv cN
      csqr cfv cdiv co cc wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa vd cv cN csqr cfv cdiv co rpcn adantr vd cv cN csqr cfv cdiv co crp
      wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv
      cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cz wcel va cv vy cv cfv va cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr wcel
      va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      cr wcel c1 c2 cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co readdcl va cv vy cv cfv va cv vx cv cfv cmin co cr
      wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv co cc0 wne
      va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv
      vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv
      co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv va cv vx cv cfv cmin co cr wcel va cv vy cv cfv va cv vx cv cfv
      resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd
      cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co crp wcel vd
      cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr wcel va cv vy cv cfv cr
      wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr syl3anc c2 2re 2ne0
      rereccli sylancl va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co flcl va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv zre 3syl recnd vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv
      cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co va cv vy cv cfv va cv vx cv cfv
      cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv
      co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv cr wcel
      va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv vy cv cfv va cv vx
      cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp wcel vd cv cN
      csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr syl3anc recnd
      syl3anc eqtr4d 3eqtr2d fveq2d vd cv cN csqr cfv cdiv co cc wcel va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cmin co cc wcel vd cv cN csqr cfv cdiv co va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co cmin co cmul co cabs cfv vd cv cN csqr cfv cdiv
      co cabs cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cabs cfv cmul co
      wceq vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cmin co absmul vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cc wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd
      cv cN csqr cfv cdiv co rpcn adantr va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cc
      wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cc wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin co cc wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co subcl vd cv cN csqr cfv cdiv co
      crp wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy
      cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv vd cv cN csqr cfv cdiv co crp wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel
      va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv cz wcel va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      cr wcel va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co cr wcel c1 c2 cdiv co cr wcel va cv vy cv cfv va cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cr wcel
      vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co readdcl va cv vy cv cfv va cv vx cv cfv
      cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv
      co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va cv vy cv
      cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel vd cv cN
      csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv cfv cr wcel
      va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv vy cv cfv va cv vx
      cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp wcel vd cv cN
      csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel
      wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr syl3anc c2 2re
      2ne0 rereccli sylancl va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co flcl va cv vy cv cfv va
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv zre 3syl recnd vd cv cN csqr cfv cdiv co crp wcel va cv
      vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co va cv vy cv cfv va cv vx
      cv cfv cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr
      cfv cdiv co cc0 wne va cv vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co cr wcel vd cv cN csqr cfv cdiv co crp wcel va cv vx
      cv cfv cr wcel va cv vy cv cfv cr wcel wa wa va cv vy cv cfv va cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co redivcl va cv vx cv cfv cr wcel va
      cv vy cv cfv cr wcel wa va cv vy cv cfv va cv vx cv cfv cmin co cr wcel
      vd cv cN csqr cfv cdiv co crp wcel va cv vy cv cfv cr wcel va cv vx cv
      cfv cr wcel va cv vy cv cfv va cv vx cv cfv cmin co cr wcel va cv vy cv
      cfv va cv vx cv cfv resubcl ancoms adantl vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr wcel va cv vy
      cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd cv cN csqr cfv
      cdiv co crp wcel vd cv cN csqr cfv cdiv co cc0 wne va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpne0 adantr
      syl3anc recnd sylanc sylanc vd cv cN csqr cfv cdiv co crp wcel va cv vx
      cv cfv cr wcel va cv vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co
      cabs cfv vd cv cN csqr cfv cdiv co va cv vy cv cfv va cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv va cv
      vy cv cfv va cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co cmin
      co cabs cfv cmul vd cv cN csqr cfv cdiv co cr wcel cc0 vd cv cN csqr cfv
      cdiv co cle wbr vd cv cN csqr cfv cdiv co cabs cfv vd cv cN csqr cfv cdiv
      co wceq vd cv cN csqr cfv cdiv co crp wcel va cv vx cv cfv cr wcel va cv
      vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv co absid vd cv cN csqr cfv
      cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel va cv vx cv cfv cr
      wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co rpre adantr vd
      cv cN csqr cfv cdiv co crp wcel cc0 vd cv cN csqr cfv cdiv co cle wbr va
      cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv co
      rpge0 adantr sylanc opreq1d 3eqtrd vd cv cN csqr cfv cdiv co crp wcel va
      cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa wa vd cv cN csqr cfv cdiv
      co c1 cmul co vd cv cN csqr cfv cdiv co vd cv cN csqr cfv cdiv co crp
      wcel vd cv cN csqr cfv cdiv co c1 cmul co vd cv cN csqr cfv cdiv co wceq
      va cv vx cv cfv cr wcel va cv vy cv cfv cr wcel wa vd cv cN csqr cfv cdiv
      co crp wcel vd cv cN csqr cfv cdiv co cc wcel vd cv cN csqr cfv cdiv co
      c1 cmul co vd cv cN csqr cfv cdiv co wceq vd cv cN csqr cfv cdiv co rpcn
      vd cv cN csqr cfv cdiv co mulid1 syl adantr eqcomd 3brtr4d eqbrtrd vd cv
      crp wcel cN cn wcel vd cv cN csqr cfv cdiv co crp wcel vd cv crp wcel cN
      csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN
      csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN
      rpsqrcl syl sylan2 ancoms vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel wa va cv c1 cN cfz co wcel wa va cv vx cv cfv cr wcel
      va cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel va cv c1 cN cfz
      co wcel va cv vx cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vx cv wf va cv c1 cN cfz co wcel va cv vx cv cfv cr wcel vx cv
      cr c1 cN cfz co cm co wcel c1 cN cfz co cr va cv vx cv ffvelrn cr c1 cN
      cfz co vx cv reex c1 cN cfz oprex elmap sylanb adantlr vy cv cr c1 cN cfz
      co cm co wcel va cv c1 cN cfz co wcel va cv vy cv cfv cr wcel vx cv cr c1
      cN cfz co cm co wcel c1 cN cfz co cr vy cv wf va cv c1 cN cfz co wcel va
      cv vy cv cfv cr wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr va
      cv vy cv ffvelrn cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap sylanb
      adantll jca syl2an anassrs eqbrtrd eqbrtrd r19.21aiva vd cv cN csqr cfv
      cdiv co va vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vy
      cv cabs cmin ccom cr cr cxp cres cN cr c1 cN cfz co cm co cabs cmin ccom
      cr cr cxp cres eqid cr c1 cN cfz co cm co eqid rrndstprj2 sylan32c cN cn
      wcel vd cv crp wcel wa vd cv cN csqr cfv cdiv co cN csqr cfv cmul co vd
      cv wceq vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      wa vd cv cc wcel cN csqr cfv cc wcel cN csqr cfv cc0 wne vd cv cN csqr
      cfv cdiv co cN csqr cfv cmul co vd cv wceq cN cn wcel vd cv crp wcel wa
      vd cv cN csqr cfv divcan1 vd cv crp wcel vd cv cc wcel cN cn wcel vd cv
      rpcn adantl cN cn wcel cN csqr cfv cc wcel vd cv crp wcel cN cn wcel cN
      crp wcel cN csqr cfv crp wcel cN csqr cfv cc wcel cN nnrp cN rpsqrcl cN
      csqr cfv rpcn 3syl adantr cN cn wcel cN csqr cfv cc0 wne vd cv crp wcel
      cN cn wcel cN crp wcel cN csqr cfv crp wcel cN csqr cfv cc0 wne cN nnrp
      cN rpsqrcl cN csqr cfv rpne0 3syl adantr syl3anc adantr breqtrd $.
      $( [2-Sep-2009] $)

    $( A set in Euclidean space is totally bounded iff its is bounded. $)
    rrntotbnd $p |- ( ( N e. NN /\ Y C_ X )
              -> ( M e. TotBnd <-> M e. Bnd ) ) $=
      cN cn wcel cY cX wss wa cM ctotbnd wcel cM cbnd wcel cM cM cdm cdm cM cdm
      cdm eqid totbndbnd cN cn wcel cY cX wss wa cM cdm cdm vx cv vr cv cM cbl
      cfv co wceq vr crp wrex vx cM cdm cdm wral cY vv cv cuni wss vb cv vy cv
      vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv
      wral wa vv cfn wrex vd crp wral cM cbnd wcel cM ctotbnd wcel cN cn wcel
      cY cX wss wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cM
      cdm cdm wral cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cY
      wral cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy
      cN crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral cN cn
      wcel cY cX wss wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex
      vx cM cdm cdm cY cN cn wcel cY cX wss wa cM cdm cdm cN crrn cfv cY cY cxp
      cres cdm cdm cY cN cn wcel cY cX wss wa cM cdm cN crrn cfv cY cY cxp cres
      cdm cN cn wcel cY cX wss wa cM cN crrn cfv cY cY cxp cres cM cN crrn cfv
      cY cY cxp cres wceq cN cn wcel cY cX wss wa rrntotbnd.2 a1i dmeqd dmeqd
      cN crrn cfv cme wcel cY cN crrn cfv cdm cdm wss cY cN crrn cfv cY cY cxp
      cres cdm cdm wceq cN cn wcel cY cX wss wa cN crrn cfv cN crrn cfv cdm cdm
      cY cN crrn cfv cdm cdm eqid metssba2 cN cn wcel cN crrn cfv cme wcel cY
      cX wss cN rrnmet adantr cN cn wcel cY cN crrn cfv cdm cdm wss cY cX wss
      cN cn wcel cN crrn cfv cdm cdm cX cY cN cn wcel cN crrn cfv cdm cdm cr c1
      cN cfz co cm co cX cN rrndm rrntotbnd.1 syl6eqr sseq2d biimpar sylanc
      eqtr4d raleq1d cN cn wcel cY cX wss wa cY c0 wceq cM cdm cdm vx cv vr cv
      cM cbl cfv co wceq vr crp wrex vx cY wral cY vv cv cuni wss vb cv vy cv
      vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv
      wral wa vv cfn wrex vd crp wral wi cN cn wcel cY cX wss wa cY c0 wceq wa
      cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN
      crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral cM cdm cdm
      vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cY wral cN cn wcel cY cX
      wss wa cY c0 wceq wa cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl
      cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd
      crp cN cn wcel cY cX wss wa cY c0 wceq wa cY vv cv cuni wss vb cv vy cv
      vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv
      wral wa vv cfn wrex vd cv crp wcel c0 cfn wcel cY c0 cuni wss vb cv vy cv
      vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb c0 wral
      wa cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN
      crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex cN cn wcel cY cX wss
      wa cY c0 wceq wa cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv
      co wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa cY c0 cuni wss vb cv
      vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb c0
      wral wa vv c0 cfn vv cv c0 wceq cY vv cv cuni wss cY c0 cuni wss vb cv vy
      cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv
      wral vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm
      wrex vb c0 wral vv cv c0 wceq vv cv cuni c0 cuni cY vv cv c0 unieq sseq2d
      vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex
      vb vv cv c0 raleq1 anbi12d rcla4ev emfin cN cn wcel cY cX wss wa cY c0
      wceq wa cY c0 cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy
      cN crrn cfv cdm cdm wrex vb c0 wral cY c0 wceq cY c0 cuni wss cN cn wcel
      cY cX wss wa cY c0 wceq cY c0 c0 cuni cY c0 wceq id c0 c0 cuni wss cY c0
      wceq c0 cuni 0ss a1i eqsstrd adantl vb cv vy cv vd cv cN crrn cfv cbl cfv
      co wceq vy cN crrn cfv cdm cdm wrex vb ral0 jctir sylancr adantr
      r19.21aiva a1d cN cn wcel cY cX wss wa cY c0 wne cM cdm cdm vx cv vr cv
      cM cbl cfv co wceq vr crp wrex vx cY wral cY vv cv cuni wss vb cv vy cv
      vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv
      wral wa vv cfn wrex vd crp wral wi cY c0 wceq wn cN cn wcel cY cX wss wa
      cY c0 wne cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cY
      wral cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy
      cN crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral cN cn
      wcel cY cX wss wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex
      vx cY wrex cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co
      wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral
      cY c0 wne cM cdm cdm vx cv vr cv cM cbl cfv co wceq vr crp wrex vx cY
      wral wa cN cn wcel cY cX wss wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq
      cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN
      crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral vx vr cY
      crp cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa cM cdm cdm vx
      cv vr cv cM cbl cfv co wceq cY vv cv cuni wss vb cv vy cv vd cv cN crrn
      cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn
      wrex vd crp wral wi cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel
      wa wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq cY vv cv cuni wss vb cv
      vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv
      cv wral wa vv cfn wrex vd crp cN cn wcel cY cX wss wa vx cv cY wcel vr cv
      crp wcel wa wa vd cv crp wcel wa cM cdm cdm vx cv vr cv cM cbl cfv co
      wceq c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab
      vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cfn wcel cY c1 cN cfz
      co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va
      cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa vf wex va cab cuni wss vb cv vy cv vd cv cN crrn cfv
      cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb c1 cN cfz co vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wceq wa vf wex va cab wral wa wa cY vv cv cuni wss vb cv vy cv vd cv cN
      crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa vv
      cfn wrex cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vd cv
      crp wcel wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq cY c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa vf wex va cab cuni wss vb cv vy cv vd cv cN crrn cfv cbl
      cfv co wceq vy cN crrn cfv cdm cdm wrex vb c1 cN cfz co vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa
      vf wex va cab wral wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq
      wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cfn
      wcel cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vd cv crp
      wcel wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq cY c1 cN cfz co vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wceq wa vf wex va cab cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv
      co wceq vy cN crrn cfv cdm cdm wrex vb c1 cN cfz co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf
      wex va cab wral cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa
      wa vd cv crp wcel wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq cY vx cv
      vr cv cN crrn cfv cbl cfv co wss cY c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex
      va cab cuni wss cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa
      wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq cY vx cv vr cv cN crrn cfv
      cbl cfv co wss wi vd cv crp wcel cN cn wcel cY cX wss wa vx cv cY wcel vr
      cv crp wcel wa wa cM cdm cdm vx cv vr cv cM cbl cfv co wceq cY vx cv vr
      cv cM cbl cfv co wceq cY vx cv vr cv cN crrn cfv cbl cfv co wss cN cn
      wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa cY cM cdm cdm vx cv
      vr cv cM cbl cfv co cN cn wcel cY cX wss wa cY cM cdm cdm wceq vx cv cY
      wcel vr cv crp wcel wa cN cn wcel cY cX wss wa cY cN crrn cfv cY cY cxp
      cres cdm cdm cM cdm cdm cN crrn cfv cme wcel cY cN crrn cfv cdm cdm wss
      cY cN crrn cfv cY cY cxp cres cdm cdm wceq cN cn wcel cY cX wss wa cN
      crrn cfv cN crrn cfv cdm cdm cY cN crrn cfv cdm cdm eqid metssba2 cN cn
      wcel cN crrn cfv cme wcel cY cX wss cN rrnmet adantr cN cn wcel cY cN
      crrn cfv cdm cdm wss cY cX wss cN cn wcel cN crrn cfv cdm cdm cX cY cN cn
      wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co cX cN rrndm rrntotbnd.1
      syl6eqr sseq2d biimpar sylanc cN cn wcel cY cX wss wa cM cdm cN crrn cfv
      cY cY cxp cres cdm cN cn wcel cY cX wss wa cM cN crrn cfv cY cY cxp cres
      cM cN crrn cfv cY cY cxp cres wceq cN cn wcel cY cX wss wa rrntotbnd.2
      a1i dmeqd dmeqd eqtr4d adantr eqeq1d cY vx cv vr cv cM cbl cfv co wceq cY
      vx cv vr cv cN crrn cfv cbl cfv co wss vx cv vr cv cM cbl cfv co vx cv vr
      cv cN crrn cfv cbl cfv co wss cN cn wcel cY cX wss wa vx cv cY wcel vr cv
      crp wcel wa wa cY vx cv vr cv cM cbl cfv co vx cv vr cv cN crrn cfv cbl
      cfv co sseq1 cN crrn cfv cme wcel cY cN crrn cfv cdm cdm wss wa vx cv cY
      wcel vr cv crp wcel wa vx cv vr cv cM cbl cfv co vx cv vr cv cN crrn cfv
      cbl cfv co wss cN cn wcel cY cX wss wa cN crrn cfv cme wcel cY cN crrn
      cfv cdm cdm wss wa vx cv cY wcel vr cv crp wcel wa wa vx cv vr cv cM cbl
      cfv co vx cv vr cv cN crrn cfv cbl cfv co cY cin vx cv vr cv cN crrn cfv
      cbl cfv co vr cv cY cN crrn cfv cM cN crrn cfv cdm cdm vx cv cN crrn cfv
      cdm cdm eqid rrntotbnd.2 blssp vx cv vr cv cN crrn cfv cbl cfv co cY cin
      vx cv vr cv cN crrn cfv cbl cfv co wss cN crrn cfv cme wcel cY cN crrn
      cfv cdm cdm wss wa vx cv cY wcel vr cv crp wcel wa wa vx cv vr cv cN crrn
      cfv cbl cfv co cY inss1 a1i eqsstrd cN cn wcel cY cX wss wa cN crrn cfv
      cme wcel cY cN crrn cfv cdm cdm wss cN cn wcel cN crrn cfv cme wcel cY cX
      wss cN rrnmet adantr cN cn wcel cY cN crrn cfv cdm cdm wss cY cX wss cN
      cn wcel cN crrn cfv cdm cdm cX cY cN cn wcel cN crrn cfv cdm cdm cr c1 cN
      cfz co cm co cX cN rrndm rrntotbnd.1 syl6eqr sseq2d biimpar jca sylan
      syl5cbir sylbird adantr cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp
      wcel wa wa vd cv crp wcel wa vx cv vr cv cN crrn cfv cbl cfv co c1 cN cfz
      co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va
      cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa vf wex va cab cuni wss cY vx cv vr cv cN crrn cfv cbl
      cfv co wss cY c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm
      vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cuni wss wi
      cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vd cv crp wcel
      wa vy vx cv vr cv cN crrn cfv cbl cfv co c1 cN cfz co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf
      wex va cab cuni cN cn wcel vx cv cX wcel vr cv crp wcel wa wa vd cv crp
      wcel vy cv vx cv vr cv cN crrn cfv cbl cfv co wcel vy cv c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa vf wex va cab cuni wcel wi cN cn wcel cY cX wss wa vx cv
      cY wcel vr cv crp wcel wa wa cN cn wcel vd cv crp wcel vx cv cX wcel vr
      cv crp wcel wa vy cv vx cv vr cv cN crrn cfv cbl cfv co wcel vy cv c1 cN
      cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv
      wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cbl cfv co wceq wa vf wex va cab cuni wcel wi cN cn wcel vx cv
      cX wcel vd cv crp wcel vr cv crp wcel vy cv vx cv vr cv cN crrn cfv cbl
      cfv co wcel vy cv c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cuni wcel
      wi cN cn wcel vx cv cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv
      vx cv vr cv cN crrn cfv cbl cfv co wcel vy cv cN crrn cfv cdm cdm wcel vx
      cv vy cv cN crrn cfv co vr cv clt wbr wa vy cv c1 cN cfz co vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wceq wa vf wex va cab cuni wcel cN cn wcel vx cv cX wcel wa vr cv crp
      wcel vy cv vx cv vr cv cN crrn cfv cbl cfv co wcel vy cv cN crrn cfv cdm
      cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wb vd cv crp wcel cN
      crrn cfv cme wcel vx cv cN crrn cfv cdm cdm wcel wa vr cv cr wcel cc0 vr
      cv clt wbr wa vy cv vx cv vr cv cN crrn cfv cbl cfv co wcel vy cv cN crrn
      cfv cdm cdm wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa wb cN cn
      wcel vx cv cX wcel wa vr cv crp wcel vy cv cN crrn cfv vx cv vr cv cN
      crrn cfv cdm cdm cN crrn cfv cdm cdm eqid elbl cN cn wcel vx cv cX wcel
      wa cN crrn cfv cme wcel vx cv cN crrn cfv cdm cdm wcel cN cn wcel cN crrn
      cfv cme wcel vx cv cX wcel cN rrnmet adantr cN cn wcel vx cv cX wcel vx
      cv cN crrn cfv cdm cdm wcel cN cn wcel cX cN crrn cfv cdm cdm vx cv cN cn
      wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co cX cN rrndm rrntotbnd.1
      syl6reqr eleq2d biimpa jca vr cv rpregt0 syl2an adantrl cN cn wcel vx cv
      cX wcel wa vd cv crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm
      wcel vx cv vy cv cN crrn cfv co vr cv clt wbr wa vy cv c1 cN cfz co vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wceq wa vf wex va cab cuni wcel cN cn wcel vx cv cX wcel wa vd cv crp
      wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv cN
      crrn cfv co vr cv clt wbr wa wa vy cv vz cv wcel vz c1 cN cfz co vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wceq wa vf wex va cab wrex vy cv c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex
      va cab cuni wcel vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab vd cv cN crrn cfv cbl cfv co c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex
      va cab wcel vy cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab vd cv cN crrn cfv cbl cfv co wcel vy cv vz cv wcel vz c1 cN cfz co
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa vf wex va cab wrex cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vx cv vy cv
      cN crrn cfv co vr cv clt wbr wa wa vy cv vz cv wcel vy cv vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wcel vz vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cbl cfv co c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab vz cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa
      vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co vy cv eleq2 rcla4ev vx vy vv vu vf vm vn cM cN cX cY vr va vd
      rrntotbnd.1 rrntotbnd.2 rrntotbndlem1 cN cn wcel vx cv cX wcel wa vd cv
      crp wcel vr cv crp wcel wa wa vy cv cN crrn cfv cdm cdm wcel vy cv vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn
      vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wcel vx cv vy cv cN crrn cfv co vr cv clt wbr cN cn wcel vx cv cX
      wcel wa vd cv crp wcel vy cv cN crrn cfv cdm cdm wcel vy cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv
      c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wcel vr cv crp wcel cN cn wcel vx cv cX wcel wa vd cv crp wcel wa vy
      cv cN crrn cfv cdm cdm wcel wa cN cn wcel vx cv cX wcel wa vd cv crp wcel
      wa vy cv cr c1 cN cfz co cm co wcel wa vy cv vm cv c1 cN cfz co wcel vu
      cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wcel cN cn wcel
      vx cv cX wcel wa vd cv crp wcel wa vy cv cN crrn cfv cdm cdm wcel vy cv
      cr c1 cN cfz co cm co wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy
      cv cr c1 cN cfz co cm co wcel wi vx cv cX wcel vd cv crp wcel cN cn wcel
      vy cv cN crrn cfv cdm cdm wcel vy cv cr c1 cN cfz co cm co wcel cN cn
      wcel cN crrn cfv cdm cdm cr c1 cN cfz co cm co vy cv cN rrndm eleq2d
      biimpd ad2antrr imdistani cN cn wcel vx cv cr c1 cN cfz co cm co wcel wa
      vd cv crp wcel vy cv cr c1 cN cfz co cm co wcel vy cv vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wcel cN cn wcel vx cv cX wcel wa cN cn wcel vx cv cr c1 cN cfz co cm co
      wcel wa vd cv crp wcel wa vy cv cr c1 cN cfz co cm co wcel vy cv vm cv c1
      cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn
      cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wcel cN cn wcel vd cv crp wcel vx cv cr c1 cN cfz co cm co wcel vy cv
      cr c1 cN cfz co cm co wcel vy cv vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq
      wa vm vu copab vd cv cN crrn cfv cbl cfv co wcel wi cN cn wcel vd cv crp
      wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel
      vy cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cbl cfv co wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz
      co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vy cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv
      c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv
      co wcel vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vy cv cN
      crrn cfv co vd cv clt wbr vx vy vv vu vm vn cM cN cX cY vd rrntotbnd.1
      rrntotbnd.2 rrntotbndlem2 cN crrn cfv cme wcel vm cv c1 cN cfz co wcel vu
      cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co
      wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab cN crrn cfv cdm cdm wcel vy cv cN crrn cfv
      cdm cdm wcel w3a vd cv cr wcel cc0 vd cv clt wbr wa vy cv vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wcel vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vy cv cN
      crrn cfv co vd cv clt wbr wb cN cn wcel vd cv crp wcel wa vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vy cv cN crrn
      cfv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv
      co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv
      wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cdm cdm cN crrn cfv cdm cdm eqid elbl2 cN cn wcel vd cv crp wcel
      wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa
      wa cN crrn cfv cme wcel vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd
      cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv
      cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv
      co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm
      vu copab cN crrn cfv cdm cdm wcel vy cv cN crrn cfv cdm cdm wcel cN cn
      wcel cN crrn cfv cme wcel vd cv crp wcel vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel wa cN rrnmet ad2antrr cN cn wcel vd cv
      crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co
      wcel wa wa vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab cN
      crrn cfv cdm cdm wcel c1 cN cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co
      wceq wa vm vu copab wf cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co cr wcel vm c1
      cN cfz co wral c1 cN cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv
      vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa
      vm vu copab wf cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel wa wa vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cmul co caddc co cr wcel vm c1 cN cfz co
      vm cv vx cv cfv cr wcel vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz
      co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv
      cmul co cr wcel vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1
      cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co caddc co cr wcel cN cn wcel vd cv crp wcel wa vx cv cr
      c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vm cv c1
      cN cfz co wcel wa vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv
      c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab cfv cmul co readdcl cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz
      co cm co wcel vm cv c1 cN cfz co wcel vm cv vx cv cfv cr wcel vy cv cr c1
      cN cfz co cm co wcel vx cv cr c1 cN cfz co cm co wcel vm cv c1 cN cfz co
      wcel vm cv vx cv cfv cr wcel cN cn wcel vd cv crp wcel wa c1 cN cfz co cr
      vx cv wf vm cv c1 cN cfz co wcel vm cv vx cv cfv cr wcel vx cv cr c1 cN
      cfz co cm co wcel c1 cN cfz co cr vm cv vx cv ffvelrn cr c1 cN cfz co vx
      cv reex c1 cN cfz oprex elmap sylanb adantll adantlrr vd cv cN csqr cfv
      cdiv co cr wcel vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv
      vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc
      co cfl cfv wceq wa vn vv copab cfv cr wcel vd cv cN csqr cfv cdiv co vm
      cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa
      vn vv copab cfv cmul co cr wcel cN cn wcel vd cv crp wcel wa vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vm cv c1 cN
      cfz co wcel wa vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv
      cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv remulcl cN cn
      wcel vd cv crp wcel wa vd cv cN csqr cfv cdiv co cr wcel vx cv cr c1 cN
      cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vm cv c1 cN cfz co
      wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cr wcel vd cv
      crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cr wcel vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv
      cdiv co rpre syl ancoms ad2antrr c1 cN cfz co cr vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab wf vm cv c1 cN
      cfz co wcel vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab cfv cr wcel cN cn wcel vd cv crp wcel wa vx
      cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa c1
      cN cfz co cr vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx
      cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co
      cfl cfv wceq wa vn vv copab ffvelrn cN cn wcel vd cv crp wcel wa vx cv cr
      c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vn cv vy
      cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2
      cdiv co caddc co cfl cfv cr wcel vn c1 cN cfz co wral c1 cN cfz co cr vn
      cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv
      cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab wf cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy
      cv cr c1 cN cfz co cm co wcel wa wa vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cr
      wcel vn c1 cN cfz co cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vn cv c1 cN cfz co wcel
      wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv
      co c1 c2 cdiv co caddc co cr wcel vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv cz wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cfl cfv cr wcel vn cv vy cv cfv vn cv vx cv cfv
      cmin co vd cv cN csqr cfv cdiv co cdiv co cr wcel c1 c2 cdiv co cr wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co
      c1 c2 cdiv co caddc co cr wcel cN cn wcel vd cv crp wcel wa vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vn cv c1 cN
      cfz co wcel wa vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv
      cdiv co cdiv co c1 c2 cdiv co readdcl vn cv vy cv cfv vn cv vx cv cfv
      cmin co cr wcel vd cv cN csqr cfv cdiv co cr wcel vd cv cN csqr cfv cdiv
      co cc0 wne vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv
      co cdiv co cr wcel cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel wa wa vn cv c1 cN cfz co wcel wa
      vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co redivcl
      vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vn
      cv c1 cN cfz co wcel vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel cN
      cn wcel vd cv crp wcel wa vn cv vy cv cfv cr wcel vn cv vx cv cfv cr wcel
      vn cv vy cv cfv vn cv vx cv cfv cmin co cr wcel vx cv cr c1 cN cfz co cm
      co wcel vy cv cr c1 cN cfz co cm co wcel wa vn cv c1 cN cfz co wcel wa vn
      cv vy cv cfv vn cv vx cv cfv resubcl vy cv cr c1 cN cfz co cm co wcel vn
      cv c1 cN cfz co wcel vn cv vy cv cfv cr wcel vx cv cr c1 cN cfz co cm co
      wcel c1 cN cfz co cr vy cv wf vn cv c1 cN cfz co wcel vn cv vy cv cfv cr
      wcel vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vn cv vy cv ffvelrn
      cr c1 cN cfz co vy cv reex c1 cN cfz oprex elmap sylanb adantll vx cv cr
      c1 cN cfz co cm co wcel vn cv c1 cN cfz co wcel vn cv vx cv cfv cr wcel
      vy cv cr c1 cN cfz co cm co wcel c1 cN cfz co cr vx cv wf vn cv c1 cN cfz
      co wcel vn cv vx cv cfv cr wcel vx cv cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vn cv vx cv ffvelrn cr c1 cN cfz co vx cv reex c1 cN cfz oprex
      elmap sylanb adantlr sylanc adantll cN cn wcel vd cv crp wcel wa vd cv cN
      csqr cfv cdiv co cr wcel vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel wa vn cv c1 cN cfz co wcel vd cv crp wcel cN cn wcel vd
      cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN cn wcel wa vd cv cN csqr
      cfv cdiv co crp wcel vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN
      csqr cfv crp wcel vd cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN
      csqr cfv rpdivcl cN cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN
      rpsqrcl syl sylan2 vd cv cN csqr cfv cdiv co rpre syl ancoms ad2antrr cN
      cn wcel vd cv crp wcel wa vd cv cN csqr cfv cdiv co cc0 wne vx cv cr c1
      cN cfz co cm co wcel vy cv cr c1 cN cfz co cm co wcel wa vn cv c1 cN cfz
      co wcel vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co cc0 wne vd cv
      crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel vd cv cN csqr
      cfv cdiv co cc0 wne vd cv crp wcel cN csqr cfv crp wcel vd cv cN csqr cfv
      cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN cn wcel cN crp
      wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd cv cN csqr cfv
      cdiv co rpne0 syl ancoms ad2antrr syl3anc c2 2re 2ne0 rereccli sylancl vn
      cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1
      c2 cdiv co caddc co flcl vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv zre 3syl
      r19.21aiva vn vv c1 cN cfz co cr vn cv vy cv cfv vn cv vx cv cfv cmin co
      vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv vn cv c1
      cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN
      csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv
      copab vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin
      co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq
      wa vn vv copab eqid fopab2 sylib sylan sylanc sylanc r19.21aiva vm vu c1
      cN cfz co cr vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv
      vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab eqid
      fopab2 sylib cN cn wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co
      wcel vy cv cr c1 cN cfz co cm co wcel wa wa vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel
      vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co
      cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab cfv cmul co
      caddc co wceq wa vm vu copab cN crrn cfv cdm cdm wcel vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vn cv c1 cN
      cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd cv cN csqr
      cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn vv copab
      cfv cmul co caddc co wceq wa vm vu copab cr c1 cN cfz co cm co wcel c1 cN
      cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv
      cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl
      cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu copab wf cN cn
      wcel vd cv crp wcel wa vx cv cr c1 cN cfz co cm co wcel vy cv cr c1 cN
      cfz co cm co wcel wa wa cN crrn cfv cdm cdm cr c1 cN cfz co cm co vm cv
      c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn cv vx cv cfv cmin co vd
      cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co caddc co cfl cfv wceq wa vn
      vv copab cfv cmul co caddc co wceq wa vm vu copab cN cn wcel cN crrn cfv
      cdm cdm cr c1 cN cfz co cm co wceq vd cv crp wcel vx cv cr c1 cN cfz co
      cm co wcel vy cv cr c1 cN cfz co cm co wcel wa cN rrndm ad2antrr eleq2d
      cr c1 cN cfz co vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vn cv c1 cN cfz co wcel vv cv vn cv vy cv cfv vn
      cv vx cv cfv cmin co vd cv cN csqr cfv cdiv co cdiv co c1 c2 cdiv co
      caddc co cfl cfv wceq wa vn vv copab cfv cmul co caddc co wceq wa vm vu
      copab reex c1 cN cfz oprex elmap syl6bb mpbird cN cn wcel vy cv cr c1 cN
      cfz co cm co wcel vy cv cN crrn cfv cdm cdm wcel vd cv crp wcel vx cv cr
      c1 cN cfz co cm co wcel cN cn wcel vy cv cN crrn cfv cdm cdm wcel vy cv
      cr c1 cN cfz co cm co wcel cN cn wcel cN crrn cfv cdm cdm cr c1 cN cfz co
      cm co vy cv cN rrndm eleq2d biimpar ad2ant2rl 3jca vd cv crp wcel vd cv
      cr wcel cc0 vd cv clt wbr wa cN cn wcel vx cv cr c1 cN cfz co cm co wcel
      vy cv cr c1 cN cfz co cm co wcel wa vd cv rpregt0 ad2antlr sylanc mpbird
      expr an1rs imp vx cv cX wcel vx cv cr c1 cN cfz co cm co wcel cN cn wcel
      vx cv cX wcel vx cv cr c1 cN cfz co cm co wcel cX cr c1 cN cfz co cm co
      vx cv rrntotbnd.1 eleq2i biimpi anim2i sylanl1 syl adantlrr adantrr
      sylanc vz vy cv c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm
      vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab eluni2 sylibr
      ex sylbid an4s an1rs cN cn wcel cY cX wss vx cv cY wcel vr cv crp wcel wa
      cN cn wcel vx cv cX wcel vr cv crp wcel wa wa cY cX wss vx cv cY wcel vr
      cv crp wcel wa wa vx cv cX wcel vr cv crp wcel wa cN cn wcel cY cX wss vx
      cv cY wcel vr cv crp wcel vx cv cX wcel vr cv crp wcel wa cY cX wss vx cv
      cY wcel wa vx cv cX wcel vr cv crp wcel cY cX vx cv ssel2 anim1i anasss
      anim2i anassrs sylan ssrdv cY vx cv vr cv cN crrn cfv cbl cfv co wss vx
      cv vr cv cN crrn cfv cbl cfv co c1 cN cfz co vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu
      cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex
      va cab cuni wss cY c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cuni wss
      cY vx cv vr cv cN crrn cfv cbl cfv co c1 cN cfz co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf
      wex va cab cuni sstr expcom syl syld cN cn wcel cY cX wss wa vx cv cY
      wcel vr cv crp wcel wa wa vd cv crp wcel wa vb cv vy cv vd cv cN crrn cfv
      cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb c1 cN cfz co vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wceq wa vf wex va cab cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp
      wcel wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cfz co vf cv wf vb cv vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc
      co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex vb cv
      vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb cv
      c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd
      cv cN crrn cfv cbl cfv co wceq wa vf wex va cab wcel cN cn wcel cY cX wss
      wa vx cv cY wcel vr cv crp wcel wa wa vd cv crp wcel wa c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vb cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn
      cfv cdm cdm wrex vf cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel
      wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cfz co vf cv wf vb cv vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq
      wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vb cv vy cv vd cv cN
      crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab cN crrn cfv cdm cdm wcel vb cv vm cv c1
      cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf
      cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wceq vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm
      wrex cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vd cv crp
      wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co vf cv wf vb cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab
      vd cv cN crrn cfv cbl cfv co wceq wa wa vb cv vy cv vd cv cN crrn cfv cbl
      cfv co wceq vb cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd
      cv cN crrn cfv cbl cfv co wceq vy vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab cN crrn cfv cdm cdm vy cv vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq
      wa vm vu copab wceq vy cv vd cv cN crrn cfv cbl cfv co vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co vb cv vy cv
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv opreq1 eqeq2d rcla4ev cN cn wcel cY cX wss wa vx cv cY wcel vr cv
      crp wcel wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc
      co wceq wa vm vu copab cN crrn cfv cdm cdm wcel vb cv vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq cN cn
      wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vd cv crp wcel wa c1
      cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      vf cv wf wa vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr
      cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab cN crrn
      cfv cdm cdm wcel c1 cN cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab wf cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa
      vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co vf cv wf wa vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co cr wcel vm c1 cN cfz co wral c1 cN cfz
      co cr vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab wf cN cn
      wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vd cv crp wcel wa c1
      cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      vf cv wf wa vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co cr wcel vm c1 cN cfz co cN cn wcel cY cX wss wa vx cv cY
      wcel vr cv crp wcel wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN cfz co
      wcel vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co cr wcel vm cv vx cv cfv cr wcel vd cv cN csqr cfv cdiv co vm cv
      vf cv cfv cmul co cr wcel vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv
      vf cv cfv cmul co caddc co cr wcel cN cn wcel cY cX wss wa vx cv cY wcel
      vr cv crp wcel wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN cfz co wcel wa
      wa vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      readdcl cN cn wcel cY cX wss wa vx cv cY wcel vr cv crp wcel wa wa vm cv
      c1 cN cfz co wcel vm cv vx cv cfv cr wcel vd cv crp wcel c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf cN cn
      wcel cY cX wss wa vx cv cY wcel vm cv c1 cN cfz co wcel vm cv vx cv cfv
      cr wcel vr cv crp wcel c1 cN cfz co cr vx cv wf vm cv c1 cN cfz co wcel
      vm cv vx cv cfv cr wcel cN cn wcel cY cX wss wa vx cv cY wcel wa c1 cN
      cfz co cr vm cv vx cv ffvelrn cN cn wcel cY cX wss vx cv cY wcel c1 cN
      cfz co cr vx cv wf cN cn wcel vx cv cX wcel c1 cN cfz co cr vx cv wf cY
      cX wss vx cv cY wcel wa vx cv cX wcel c1 cN cfz co cr vx cv wf cN cn wcel
      vx cv cX wcel c1 cN cfz co cr vx cv wf vx cv cX wcel vx cv cr c1 cN cfz
      co cm co wcel c1 cN cfz co cr vx cv wf cX cr c1 cN cfz co cm co vx cv
      rrntotbnd.1 eleq2i cr c1 cN cfz co vx cv reex c1 cN cfz oprex elmap bitri
      biimpi adantl cY cX vx cv ssel2 sylan2 anassrs sylan adantlrr ad2ant2rl
      vd cv cN csqr cfv cdiv co cr wcel vm cv vf cv cfv cr wcel vd cv cN csqr
      cfv cdiv co vm cv vf cv cfv cmul co cr wcel cN cn wcel cY cX wss wa vx cv
      cY wcel vr cv crp wcel wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vm cv c1 cN cfz
      co wcel wa vd cv cN csqr cfv cdiv co vm cv vf cv cfv remulcl cN cn wcel
      cY cX wss wa vd cv crp wcel vd cv cN csqr cfv cdiv co cr wcel vx cv cY
      wcel vr cv crp wcel wa cN cn wcel vd cv crp wcel vd cv cN csqr cfv cdiv
      co cr wcel cY cX wss vd cv crp wcel cN cn wcel vd cv cN csqr cfv cdiv co
      cr wcel vd cv crp wcel cN cn wcel wa vd cv cN csqr cfv cdiv co crp wcel
      vd cv cN csqr cfv cdiv co cr wcel vd cv crp wcel cN csqr cfv crp wcel vd
      cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN
      cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2 vd
      cv cN csqr cfv cdiv co rpre syl ancoms adantlr adantlr c1 cN cfz co cr vf
      cv wf vm cv c1 cN cfz co wcel vm cv vf cv cfv cr wcel c1 cN cfz co vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf c1 cN cfz co
      cr vm cv vf cv ffvelrn c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cfz co vf cv wf vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co cr wss c1 cN cfz co cr vf cv wf vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co cz cr vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg cuz cfv cz vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co fzssuz vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg uzssz sstri zssre sstri c1 cN cfz co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co cr vf cv fss mpan2 sylan syl2an
      sylanc anassrs r19.21aiva vm vu c1 cN cfz co cr vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm
      vu copab eqid fopab2 sylib cN cn wcel cY cX wss wa vx cv cY wcel vr cv
      crp wcel wa wa vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab cN
      crrn cfv cdm cdm wcel c1 cN cfz co cr vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq
      wa vm vu copab wf wb vd cv crp wcel c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf cN cn wcel vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab cN crrn cfv cdm cdm wcel c1 cN cfz co cr
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab wf wb cY cX wss vx
      cv cY wcel vr cv crp wcel wa cN cn wcel vm cv c1 cN cfz co wcel vu cv vm
      cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co
      wceq wa vm vu copab cN crrn cfv cdm cdm wcel vm cv c1 cN cfz co wcel vu
      cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab cr c1 cN cfz co cm co wcel c1 cN cfz co cr
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab wf cN cn wcel cN
      crrn cfv cdm cdm cr c1 cN cfz co cm co vm cv c1 cN cfz co wcel vu cv vm
      cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co
      wceq wa vm vu copab cN rrndm eleq2d cr c1 cN cfz co vm cv c1 cN cfz co
      wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul
      co caddc co wceq wa vm vu copab reex c1 cN cfz oprex elmap syl6bb
      ad2antrr ad2antrr mpbird adantrr cN cn wcel cY cX wss wa vx cv cY wcel vr
      cv crp wcel wa wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf vb cv vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq simprr
      sylanc ex 19.23adv c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx
      cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa
      vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vb cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa vf wex va vb cv vb visset va cv vb cv wceq c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cfz co vf cv wf vb cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv
      cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm
      vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf va cv vb cv wceq va cv
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq vb cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab
      vd cv cN crrn cfv cbl cfv co wceq c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vb cv vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co eqeq1
      anbi2d exbidv elab syl5ib r19.21aiv jctird cN cn wcel cY cX wss wa vr cv
      crp wcel vd cv crp wcel c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv
      vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq
      wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cfn
      wcel vx cv cY wcel cN cn wcel vr cv crp wcel vd cv crp wcel c1 cN cfz co
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa vf wex va cab cfn wcel cY cX wss cN cn wcel vr cv crp
      wcel wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cfz co cxp cpw cfn wcel c1 cN cfz co vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vf cab cfn wcel c1 cN
      cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv
      wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv
      cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN
      crrn cfv cbl cfv co wceq wa vf wex va cab cfn wcel cN cn wcel vr cv crp
      wcel wa vd cv crp wcel wa c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cfz co cxp cfn wcel c1 cN cfz co vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cfz co cxp cpw cfn wcel c1 cN cfz co cfn
      wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co cfn wcel
      c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      cxp cfn wcel cN cn wcel vr cv crp wcel wa vd cv crp wcel wa c1 cN cfz co
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co fixp cN cn wcel
      c1 cN cfz co cfn wcel vr cv crp wcel vd cv crp wcel cN cn wcel cN c1 cuz
      cfv wcel c1 cN cfz co cfn wcel cN elnnuz c1 cN fzfi sylbi ad2antrr cN cn
      wcel vr cv crp wcel wa vd cv crp wcel wa vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cn wcel vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg cuz cfv wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cfz co cfn wcel cN cn wcel vr cv crp wcel wa vd cv crp wcel wa
      vr cv vd cv cN csqr cfv cdiv co cdiv co crp wcel vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv cn0 wcel vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cn wcel vr cv crp wcel vd cv cN csqr cfv cdiv co crp
      wcel vr cv vd cv cN csqr cfv cdiv co cdiv co crp wcel cN cn wcel vr cv
      crp wcel wa vd cv crp wcel wa vr cv vd cv cN csqr cfv cdiv co rpdivcl cN
      cn wcel vr cv crp wcel vd cv crp wcel simplr cN cn wcel vd cv crp wcel vd
      cv cN csqr cfv cdiv co crp wcel vr cv crp wcel vd cv crp wcel cN cn wcel
      vd cv cN csqr cfv cdiv co crp wcel vd cv crp wcel cN csqr cfv crp wcel vd
      cv cN csqr cfv cdiv co crp wcel cN cn wcel vd cv cN csqr cfv rpdivcl cN
      cn wcel cN crp wcel cN csqr cfv crp wcel cN nnrp cN rpsqrcl syl sylan2
      ancoms adantlr sylanc vr cv vd cv cN csqr cfv cdiv co cdiv co cr wcel cc0
      vr cv vd cv cN csqr cfv cdiv co cdiv co cle wbr vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv cn0 wcel vr cv vd cv cN csqr cfv cdiv co cdiv co
      crp wcel vr cv vd cv cN csqr cfv cdiv co cdiv co flge0nn0 vr cv vd cv cN
      csqr cfv cdiv co cdiv co rpre vr cv vd cv cN csqr cfv cdiv co cdiv co
      rpge0 sylanc vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv nn0p1nn 3syl
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cn wcel c1
      cuz cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg
      cuz cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co vr cv
      vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cn wcel c1 vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg cuz cfv wcel c1
      cuz cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg
      cuz cfv wss vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cn wcel c1 cneg cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg cuz cfv c1 vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cn wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co c1 cneg cuz cfv wcel c1 cneg cneg vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg cuz cfv wcel vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cn wcel vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co c1 cuz cfv wcel vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co c1 cneg cuz cfv wcel vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co elnnuz c1 cuz cfv c1 cneg
      cuz cfv vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co c1 c1
      cneg cuz cfv wcel c1 cuz cfv c1 cneg cuz cfv wss c1 cneg cz wcel c1 cz
      wcel c1 c1 cneg cuz cfv wcel c1 cz wcel c1 cneg cz wcel 1z c1 znegcl
      ax-mp 1z c1 cneg cz wcel c1 cz wcel wa c1 c1 cneg cuz cfv wcel c1 cneg c1
      cle wbr c1 cneg cc0 cle wbr cc0 c1 cle wbr c1 cneg c1 cle wbr cc0 c1 cle
      wbr c1 cneg cc0 cle wbr cc0 c1 0re 1re lt01 ltleii c1 cr wcel cc0 c1 cle
      wbr c1 cneg cc0 cle wbr wb 1re c1 le0neg2 ax-mp mpbi cc0 c1 0re 1re lt01
      ltleii c1 cneg cc0 c1 c1 1re renegcli 0re 1re letri mp2an c1 cneg c1 eluz
      mpbiri mp2an c1 cneg c1 uzss ax-mp sseli sylbi c1 cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co uzneg syl c1 ax1cn negnegi
      syl5eqelr vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg c1 uzss syl vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cn wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co c1
      cuz cfv wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      elnnuz biimpi sseldd vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      fzfi 3syl sylanc c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cfz co cxp pwfi sylib c1 cN cfz co vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cfz co cxp cpw cfn wcel vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co c1 cN cfz co cm co cfn c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf vf cab c1
      cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co
      cxp cpw cfn wcel vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz
      co c1 cN cfz co cm co c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cfz co cxp cpw wss vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl
      cfv c1 caddc co cfz co c1 cN cfz co cm co cfn wcel c1 cN cfz co cvv wcel
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co c1 cN cfz co cm
      co c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz
      co cxp cpw wss c1 cN cfz oprex vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv
      c1 caddc co cfz co c1 cN cfz co cvv mapsspw ax-mp c1 cN cfz co vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co cxp cpw vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co c1 cN cfz co cm co ssfi
      mpan2 vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co c1 cN cfz
      co vf vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz oprex c1 cN
      cfz oprex mapval syl5eqelr c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cfz co vf cv wf va vf vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc
      co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co firnfi4 3syl adantllr
      adantlrl jctild cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv
      co wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa cY c1 cN cfz co vr
      cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm
      cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm
      cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl
      cfv co wceq wa vf wex va cab cuni wss vb cv vy cv vd cv cN crrn cfv cbl
      cfv co wceq vy cN crrn cfv cdm cdm wrex vb c1 cN cfz co vr cv vd cv cN
      csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz
      co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv
      cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa
      vf wex va cab wral wa vv c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co
      cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv
      vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc
      co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab
      cfn vv cv c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1
      caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co
      cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv
      cN csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab
      vd cv cN crrn cfv cbl cfv co wceq wa vf wex va cab wceq cY vv cv cuni wss
      cY c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz
      co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd
      cv cN crrn cfv cbl cfv co wceq wa vf wex va cab cuni wss vb cv vy cv vd
      cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral
      vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN crrn cfv cdm cdm wrex
      vb c1 cN cfz co vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc
      co cneg vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz
      co vf cv wf va cv vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN
      csqr cfv cdiv co vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd
      cv cN crrn cfv cbl cfv co wceq wa vf wex va cab wral vv cv c1 cN cfz co
      vr cv vd cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd
      cv cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv
      vm cv c1 cN cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co
      vm cv vf cv cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv
      cbl cfv co wceq wa vf wex va cab wceq vv cv cuni c1 cN cfz co vr cv vd cv
      cN csqr cfv cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr
      cfv cdiv co cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN
      cfz co wcel vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv
      cfv cmul co caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co
      wceq wa vf wex va cab cuni cY vv cv c1 cN cfz co vr cv vd cv cN csqr cfv
      cdiv co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co
      cdiv co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel
      vu cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex
      va cab unieq sseq2d vb cv vy cv vd cv cN crrn cfv cbl cfv co wceq vy cN
      crrn cfv cdm cdm wrex vb vv cv c1 cN cfz co vr cv vd cv cN csqr cfv cdiv
      co cdiv co cfl cfv c1 caddc co cneg vr cv vd cv cN csqr cfv cdiv co cdiv
      co cfl cfv c1 caddc co cfz co vf cv wf va cv vm cv c1 cN cfz co wcel vu
      cv vm cv vx cv cfv vd cv cN csqr cfv cdiv co vm cv vf cv cfv cmul co
      caddc co wceq wa vm vu copab vd cv cN crrn cfv cbl cfv co wceq wa vf wex
      va cab raleq1 anbi12d rcla4ev syl6 r19.21adva ex r19.23advv cM cdm cdm vx
      cv vr cv cM cbl cfv co wceq vr crp wrex vx cY r19.2z syl5 expdimp cY c0
      df-ne sylan2br pm2.61dan sylbid cN cn wcel cY cX wss wa cN crrn cfv cme
      wcel cM cme wcel cM cbnd wcel cM cdm cdm vx cv vr cv cM cbl cfv co wceq
      vr crp wrex vx cM cdm cdm wral wb cN cn wcel cN crrn cfv cme wcel cY cX
      wss cN rrnmet adantr cN crrn cfv cme wcel cN crrn cfv cY cY cxp cres cme
      cM cN crrn cfv cY metres rrntotbnd.2 syl5eqel vx cM cM cdm cdm vr cM cdm
      cdm eqid isbnd2 3syl cN crrn cfv cme wcel cY cN crrn cfv cdm cdm wss cM
      ctotbnd wcel cY vv cv cuni wss vb cv vy cv vd cv cN crrn cfv cbl cfv co
      wceq vy cN crrn cfv cdm cdm wrex vb vv cv wral wa vv cfn wrex vd crp wral
      wb cN cn wcel cY cX wss wa vy vv cN crrn cfv cM cN crrn cfv cdm cdm cY vb
      vd cN crrn cfv cdm cdm eqid rrntotbnd.2 sstotbnd cN cn wcel cN crrn cfv
      cme wcel cY cX wss cN rrnmet adantr cN cn wcel cY cN crrn cfv cdm cdm wss
      cY cX wss cN cn wcel cN crrn cfv cdm cdm cX cY cN cn wcel cN crrn cfv cdm
      cdm cr c1 cN cfz co cm co cX cN rrndm rrntotbnd.1 syl6eqr sseq2d biimpar
      sylanc 3imtr4d impbid2 $.
      $( [2-Sep-2009] $)
  $}

  ${
    rrnheibor.1 $e |- X = ( RR ^m ( 1 ... N ) ) $.
    rrnheibor.2 $e |- M = ( ( Rn ` N ) |` ( Y X. Y ) ) $.
    rrnheibor.3 $e |- T = ( Open ` M ) $.
    rrnheibor.4 $e |- U = ( Open ` ( Rn ` N ) ) $.
    $( Heine-Borel theorem for Euclidean space. A subset of Euclidean space
       is compact iff it is closed and bounded. $)
    rrnheibor $p |- ( ( N e. NN /\ Y C_ X ) ->
                      ( T e. Comp <-> ( Y e. ( Clsd ` U ) /\ M e. Bnd ) ) ) $=
      cN cn wcel cY cX wss wa cT ccomp wcel cM cms wcel cM ctotbnd wcel wa cY
      cU ccld cfv wcel cM cbnd wcel wa cN cn wcel cY cX wss wa cM cme wcel cT
      ccomp wcel cM cms wcel cM ctotbnd wcel wa wb cN cn wcel cM cme wcel cY cX
      wss cN cn wcel cN crrn cfv cme wcel cM cme wcel cN rrnmet cN crrn cfv cme
      wcel cN crrn cfv cY cY cxp cres cme cM cN crrn cfv cY metres rrnheibor.2
      syl5eqel syl adantr cT cM cM cdm cdm rrnheibor.3 cM cdm cdm eqid heibor
      syl cN cn wcel cY cX wss wa cM cms wcel cY cU ccld cfv wcel cM ctotbnd
      wcel cM cbnd wcel cN cn wcel cY cX wss wa cN crrn cfv cY cY cxp cres cms
      wcel cY cU ccld cfv wcel cM cms wcel cN crrn cfv cms wcel cY cN crrn cfv
      cdm cdm wss cN crrn cfv cY cY cxp cres cms wcel cY cU ccld cfv wcel wb cN
      cn wcel cY cX wss wa cN crrn cfv cU cN crrn cfv cdm cdm cY cN crrn cfv
      cdm cdm eqid rrnheibor.4 cmsss cN cn wcel cN crrn cfv cms wcel cY cX wss
      cN rrncms adantr cN cn wcel cY cX wss cY cN crrn cfv cdm cdm wss cN cn
      wcel cX cN crrn cfv cdm cdm cY cN cn wcel cN crrn cfv cdm cdm cr c1 cN
      cfz co cm co cX cN rrndm rrnheibor.1 syl6reqr sseq2d biimpa sylanc cM cN
      crrn cfv cY cY cxp cres cms rrnheibor.2 eleq1i syl5bb cM cN cX cY
      rrnheibor.1 rrnheibor.2 rrntotbnd anbi12d bitrd $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Intervals (continued)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d R k u v x y $. $d F k u v $.
    ismrer1.1 $e |- R = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    ismrer1.2 $e |- F = { <. x , y >. | ( x e. RR /\
                                              y = ( { 1 } X. { x } ) ) } $.
    $( An isometry between ` RR ` and ` RR ^ 1 ` . $)
    ismrer1 $p |- F e. ( R Ismty ( Rn ` 1 ) ) $=
      cF cR c1 crrn cfv cismty co wcel cr cr c1 csn cm co cF wf1o vu cv vv cv
      cR co vu cv cF cfv vv cv cF cfv c1 crrn cfv co wceq vv cr wral vu cr wral
      cR cme wcel c1 crrn cfv cme wcel cF cR c1 crrn cfv cismty co wcel cr cr
      c1 csn cm co cF wf1o vu cv vv cv cR co vu cv cF cfv vv cv cF cfv c1 crrn
      cfv co wceq vv cr wral vu cr wral wa wb cR ismrer1.1 remet c1 cn wcel c1
      crrn cfv cme wcel 1nn c1 rrnmet ax-mp vu vv cF cR c1 crrn cfv cr cr c1
      csn cm co cR ismrer1.1 remetba c1 crrn cfv cdm cdm cr c1 c1 cfz co cm co
      cr c1 csn cm co c1 cn wcel c1 crrn cfv cdm cdm cr c1 c1 cfz co cm co wceq
      1nn c1 rrndm ax-mp c1 c1 cfz co c1 csn cr cm c1 cz wcel c1 c1 cfz co c1
      csn wceq 1z c1 fzsn ax-mp opreq2i eqtr2i isismty mp2an cr cr c1 csn cm co
      cF wf1o cF cr wfn cF crn cr c1 csn cm co wceq vu cv cF cfv vv cv cF cfv
      wceq vu cv vv cv wceq wi vv cr wral vu cr wral w3a cF cr wfn cF crn cr c1
      csn cm co wceq vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq wi vv cr
      wral vu cr wral vx vy cr c1 csn vx cv csn cxp cF c1 csn vx cv csn c1 snex
      vx cv snex xpex ismrer1.2 fnopab2 vy cv c1 csn vx cv csn cxp wceq vx cr
      wrex vy cab vy cv c1 vx cv cop csn wceq vx cr wrex vy cab cF crn cr c1
      csn cm co vy cv c1 csn vx cv csn cxp wceq vx cr wrex vy cv c1 vx cv cop
      csn wceq vx cr wrex vy vy cv c1 csn vx cv csn cxp wceq vy cv c1 vx cv cop
      csn wceq vx cr c1 csn vx cv csn cxp c1 vx cv cop csn vy cv c1 vx cv c1 cc
      ax1cn elisseti vx visset xpsn eqeq2i rexbii abbii cF crn vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab crn vy cv c1 csn vx cv csn
      cxp wceq vx cr wrex vy cab cF vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab ismrer1.2 rneqi vx vy cr c1 csn vx cv csn cxp rnopab2
      eqtri vx cr c1 vy reex c1 cc ax1cn elisseti mapsn 3eqtr4i vu cv cF cfv vv
      cv cF cfv wceq vu cv vv cv wceq wi vu vv cr vu cv cr wcel vv cv cr wcel
      wa vu cv cF cfv vv cv cF cfv wceq c1 csn vu cv csn cxp c1 csn vv cv csn
      cxp wceq vu cv vv cv wceq vu cv cr wcel vv cv cr wcel vu cv cF cfv c1 csn
      vu cv csn cxp vv cv cF cfv c1 csn vv cv csn cxp vx vy vu cv c1 csn vx cv
      csn cxp c1 csn vu cv csn cxp cr cF vx cv vu cv wceq vx cv csn vu cv csn
      wceq c1 csn vx cv csn cxp c1 csn vu cv csn cxp wceq vx cv vu cv sneq vx
      cv csn vu cv csn c1 csn xpeq2 syl ismrer1.2 c1 csn vu cv csn c1 snex vu
      cv snex xpex fvopab4 vx vy vv cv c1 csn vx cv csn cxp c1 csn vv cv csn
      cxp cr cF vx cv vv cv wceq vx cv csn vv cv csn wceq c1 csn vx cv csn cxp
      c1 csn vv cv csn cxp wceq vx cv vv cv sneq vx cv csn vv cv csn c1 csn
      xpeq2 syl ismrer1.2 c1 csn vv cv csn c1 snex vv cv snex xpex fvopab4
      eqeqan12d c1 csn vu cv csn cxp c1 csn vv cv csn cxp wceq c1 csn c1 csn
      wceq vu cv csn vv cv csn wceq wa vu cv vv cv wceq c1 csn c0 wne vu cv csn
      c0 wne c1 csn vu cv csn cxp c1 csn vv cv csn cxp wceq c1 csn c1 csn wceq
      vu cv csn vv cv csn wceq wa wb c1 c1 cc ax1cn elisseti snnz vu cv vu
      visset snnz c1 csn vu cv csn c1 csn vv cv csn xp11 mp2an vu cv csn vv cv
      csn wceq vu cv vv cv wceq c1 csn c1 csn wceq vu cv vv cv vu visset sneqr
      adantl sylbi syl6bi rgen2a 3pm3.2i vu vv cr cr c1 csn cm co cF dff1o6
      mpbir vu cv vv cv cR co vu cv cF cfv vv cv cF cfv c1 crrn cfv co wceq vu
      vv cr vu cv cr wcel vv cv cr wcel wa vu cv vv cv cmin co cabs cfv c1 c1
      cfz co vk cv vu cv cF cfv cfv vk cv vv cv cF cfv cfv cmin co c2 cexp co
      vk csu csqr cfv vu cv vv cv cR co vu cv cF cfv vv cv cF cfv c1 crrn cfv
      co vu cv cr wcel vv cv cr wcel wa c1 c1 cfz co vk cv vu cv cF cfv cfv vk
      cv vv cv cF cfv cfv cmin co c2 cexp co vk csu csqr cfv c1 vu cv cF cfv
      cfv c1 vv cv cF cfv cfv cmin co c2 cexp co csqr cfv vu cv vv cv cmin co
      c2 cexp co csqr cfv vu cv vv cv cmin co cabs cfv c1 c1 cfz co vk cv vu cv
      cF cfv cfv vk cv vv cv cF cfv cfv cmin co c2 cexp co vk csu csqr cfv c1
      vu cv cF cfv cfv c1 vv cv cF cfv cfv cmin co c2 cexp co csqr cfv wceq vu
      cv cr wcel vv cv cr wcel wa c1 c1 cfz co vk cv vu cv cF cfv cfv vk cv vv
      cv cF cfv cfv cmin co c2 cexp co vk csu c1 vu cv cF cfv cfv c1 vv cv cF
      cfv cfv cmin co c2 cexp co csqr c1 vu cv cF cfv cfv c1 vv cv cF cfv cfv
      cmin co c2 cexp co cvv wcel c1 cz wcel c1 c1 cfz co vk cv vu cv cF cfv
      cfv vk cv vv cv cF cfv cfv cmin co c2 cexp co vk csu c1 vu cv cF cfv cfv
      c1 vv cv cF cfv cfv cmin co c2 cexp co wceq c1 vu cv cF cfv cfv c1 vv cv
      cF cfv cfv cmin co c2 cexp oprex 1z vk cv vu cv cF cfv cfv vk cv vv cv cF
      cfv cfv cmin co c2 cexp co c1 vu cv cF cfv cfv c1 vv cv cF cfv cfv cmin
      co c2 cexp co cvv vk c1 vk cv c1 wceq vk cv vu cv cF cfv cfv vk cv vv cv
      cF cfv cfv cmin co c1 vu cv cF cfv cfv c1 vv cv cF cfv cfv cmin co c2
      cexp vk cv c1 wceq vk cv vu cv cF cfv cfv c1 vu cv cF cfv cfv vk cv vv cv
      cF cfv cfv c1 vv cv cF cfv cfv cmin vk cv c1 vu cv cF cfv fveq2 vk cv c1
      vv cv cF cfv fveq2 opreq12d opreq1d fsum1i mp2an fveq2i a1i vu cv cr wcel
      vv cv cr wcel wa c1 vu cv cF cfv cfv c1 vv cv cF cfv cfv cmin co c2 cexp
      co vu cv vv cv cmin co c2 cexp co csqr vu cv cr wcel vv cv cr wcel wa c1
      vu cv cF cfv cfv c1 vv cv cF cfv cfv cmin co vu cv vv cv cmin co c2 cexp
      vu cv cr wcel vv cv cr wcel c1 vu cv cF cfv cfv vu cv c1 vv cv cF cfv cfv
      vv cv cmin vu cv cr wcel c1 vu cv cF cfv cfv c1 c1 csn vu cv csn cxp cfv
      vu cv vu cv cr wcel c1 vu cv cF cfv c1 csn vu cv csn cxp vx vy vu cv c1
      csn vx cv csn cxp c1 csn vu cv csn cxp cr cF vx cv vu cv wceq vx cv csn
      vu cv csn wceq c1 csn vx cv csn cxp c1 csn vu cv csn cxp wceq vx cv vu cv
      sneq vx cv csn vu cv csn c1 csn xpeq2 syl ismrer1.2 c1 csn vu cv csn c1
      snex vu cv snex xpex fvopab4 fveq1d c1 c1 csn wcel c1 c1 csn vu cv csn
      cxp cfv vu cv wceq c1 c1 cc ax1cn elisseti snid c1 csn vu cv c1 vu visset
      fvconst2 ax-mp syl6eq vv cv cr wcel c1 vv cv cF cfv cfv c1 c1 csn vv cv
      csn cxp cfv vv cv vv cv cr wcel c1 vv cv cF cfv c1 csn vv cv csn cxp vx
      vy vv cv c1 csn vx cv csn cxp c1 csn vv cv csn cxp cr cF vx cv vv cv wceq
      vx cv csn vv cv csn wceq c1 csn vx cv csn cxp c1 csn vv cv csn cxp wceq
      vx cv vv cv sneq vx cv csn vv cv csn c1 csn xpeq2 syl ismrer1.2 c1 csn vv
      cv csn c1 snex vv cv snex xpex fvopab4 fveq1d c1 c1 csn wcel c1 c1 csn vv
      cv csn cxp cfv vv cv wceq c1 c1 cc ax1cn elisseti snid c1 csn vv cv c1 vv
      visset fvconst2 ax-mp syl6eq opreqan12d opreq1d fveq2d vu cv cr wcel vv
      cv cr wcel wa vu cv vv cv cmin co cr wcel vu cv vv cv cmin co c2 cexp co
      csqr cfv vu cv vv cv cmin co cabs cfv wceq vu cv vv cv resubcl vu cv vv
      cv cmin co cr wcel vu cv vv cv cmin co c2 cexp co csqr cfv vu cv vv cv
      cmin co cabs cfv c2 cexp co csqr cfv vu cv vv cv cmin co cabs cfv vu cv
      vv cv cmin co cr wcel vu cv vv cv cmin co c2 cexp co vu cv vv cv cmin co
      cabs cfv c2 cexp co csqr vu cv vv cv cmin co cr wcel vu cv vv cv cmin co
      cabs cfv c2 cexp co vu cv vv cv cmin co c2 cexp co vu cv vv cv cmin co
      absresq eqcomd fveq2d vu cv vv cv cmin co cabs cfv cr wcel cc0 vu cv vv
      cv cmin co cabs cfv cle wbr vu cv vv cv cmin co cabs cfv c2 cexp co csqr
      cfv vu cv vv cv cmin co cabs cfv wceq vu cv vv cv cmin co cr wcel vu cv
      vv cv cmin co cabs cfv sqrsq vu cv vv cv cmin co cr wcel vu cv vv cv cmin
      co cc wcel vu cv vv cv cmin co cabs cfv cr wcel vu cv vv cv cmin co recn
      vu cv vv cv cmin co abscl syl vu cv vv cv cmin co cr wcel vu cv vv cv
      cmin co cc wcel cc0 vu cv vv cv cmin co cabs cfv cle wbr vu cv vv cv cmin
      co recn vu cv vv cv cmin co absge0 syl sylanc eqtrd syl 3eqtrrd vu cv vv
      cv cR ismrer1.1 remetdval c1 cn wcel vu cv cF cfv cr c1 c1 cfz co cm co
      wcel vv cv cF cfv cr c1 c1 cfz co cm co wcel vu cv cF cfv vv cv cF cfv c1
      crrn cfv co c1 c1 cfz co vk cv vu cv cF cfv cfv vk cv vv cv cF cfv cfv
      cmin co c2 cexp co vk csu csqr cfv wceq vu cv cr wcel vv cv cr wcel wa vk
      c1 vu cv cF cfv vv cv cF cfv rrnmval c1 cn wcel vu cv cr wcel vv cv cr
      wcel wa 1nn a1i vu cv cr wcel vu cv cF cfv cr c1 c1 cfz co cm co wcel vv
      cv cr wcel vu cv cr wcel vu cv cF cfv cr c1 csn cm co cr c1 c1 cfz co cm
      co cr cr c1 csn cm co vu cv cF cr cr c1 csn cm co cF wf1o cr cr c1 csn cm
      co cF wf cr cr c1 csn cm co cF wf1o cF cr wfn cF crn cr c1 csn cm co wceq
      vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq wi vv cr wral vu cr wral
      w3a cF cr wfn cF crn cr c1 csn cm co wceq vu cv cF cfv vv cv cF cfv wceq
      vu cv vv cv wceq wi vv cr wral vu cr wral vx vy cr c1 csn vx cv csn cxp
      cF c1 csn vx cv csn c1 snex vx cv snex xpex ismrer1.2 fnopab2 vy cv c1
      csn vx cv csn cxp wceq vx cr wrex vy cab vy cv c1 vx cv cop csn wceq vx
      cr wrex vy cab cF crn cr c1 csn cm co vy cv c1 csn vx cv csn cxp wceq vx
      cr wrex vy cv c1 vx cv cop csn wceq vx cr wrex vy vy cv c1 csn vx cv csn
      cxp wceq vy cv c1 vx cv cop csn wceq vx cr c1 csn vx cv csn cxp c1 vx cv
      cop csn vy cv c1 vx cv c1 cc ax1cn elisseti vx visset xpsn eqeq2i rexbii
      abbii cF crn vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab
      crn vy cv c1 csn vx cv csn cxp wceq vx cr wrex vy cab cF vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab ismrer1.2 rneqi vx vy cr c1
      csn vx cv csn cxp rnopab2 eqtri vx cr c1 vy reex c1 cc ax1cn elisseti
      mapsn 3eqtr4i vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq wi vu vv cr
      vu cv cr wcel vv cv cr wcel wa vu cv cF cfv vv cv cF cfv wceq c1 csn vu
      cv csn cxp c1 csn vv cv csn cxp wceq vu cv vv cv wceq vu cv cr wcel vv cv
      cr wcel vu cv cF cfv c1 csn vu cv csn cxp vv cv cF cfv c1 csn vv cv csn
      cxp vx vy vu cv c1 csn vx cv csn cxp c1 csn vu cv csn cxp cr cF vx cv vu
      cv wceq vx cv csn vu cv csn wceq c1 csn vx cv csn cxp c1 csn vu cv csn
      cxp wceq vx cv vu cv sneq vx cv csn vu cv csn c1 csn xpeq2 syl ismrer1.2
      c1 csn vu cv csn c1 snex vu cv snex xpex fvopab4 vx vy vv cv c1 csn vx cv
      csn cxp c1 csn vv cv csn cxp cr cF vx cv vv cv wceq vx cv csn vv cv csn
      wceq c1 csn vx cv csn cxp c1 csn vv cv csn cxp wceq vx cv vv cv sneq vx
      cv csn vv cv csn c1 csn xpeq2 syl ismrer1.2 c1 csn vv cv csn c1 snex vv
      cv snex xpex fvopab4 eqeqan12d c1 csn vu cv csn cxp c1 csn vv cv csn cxp
      wceq c1 csn c1 csn wceq vu cv csn vv cv csn wceq wa vu cv vv cv wceq c1
      csn c0 wne vu cv csn c0 wne c1 csn vu cv csn cxp c1 csn vv cv csn cxp
      wceq c1 csn c1 csn wceq vu cv csn vv cv csn wceq wa wb c1 c1 cc ax1cn
      elisseti snnz vu cv vu visset snnz c1 csn vu cv csn c1 csn vv cv csn xp11
      mp2an vu cv csn vv cv csn wceq vu cv vv cv wceq c1 csn c1 csn wceq vu cv
      vv cv vu visset sneqr adantl sylbi syl6bi rgen2a 3pm3.2i vu vv cr cr c1
      csn cm co cF dff1o6 mpbir cr cr c1 csn cm co cF f1of ax-mp ffvelrni c1 c1
      cfz co c1 csn cr cm c1 cz wcel c1 c1 cfz co c1 csn wceq 1z c1 fzsn ax-mp
      opreq2i syl6eleqr adantr vv cv cr wcel vv cv cF cfv cr c1 c1 cfz co cm co
      wcel vu cv cr wcel vv cv cr wcel vv cv cF cfv cr c1 csn cm co cr c1 c1
      cfz co cm co cr cr c1 csn cm co vv cv cF cr cr c1 csn cm co cF wf1o cr cr
      c1 csn cm co cF wf cr cr c1 csn cm co cF wf1o cF cr wfn cF crn cr c1 csn
      cm co wceq vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq wi vv cr wral
      vu cr wral w3a cF cr wfn cF crn cr c1 csn cm co wceq vu cv cF cfv vv cv
      cF cfv wceq vu cv vv cv wceq wi vv cr wral vu cr wral vx vy cr c1 csn vx
      cv csn cxp cF c1 csn vx cv csn c1 snex vx cv snex xpex ismrer1.2 fnopab2
      vy cv c1 csn vx cv csn cxp wceq vx cr wrex vy cab vy cv c1 vx cv cop csn
      wceq vx cr wrex vy cab cF crn cr c1 csn cm co vy cv c1 csn vx cv csn cxp
      wceq vx cr wrex vy cv c1 vx cv cop csn wceq vx cr wrex vy vy cv c1 csn vx
      cv csn cxp wceq vy cv c1 vx cv cop csn wceq vx cr c1 csn vx cv csn cxp c1
      vx cv cop csn vy cv c1 vx cv c1 cc ax1cn elisseti vx visset xpsn eqeq2i
      rexbii abbii cF crn vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx
      vy copab crn vy cv c1 csn vx cv csn cxp wceq vx cr wrex vy cab cF vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab ismrer1.2 rneqi vx
      vy cr c1 csn vx cv csn cxp rnopab2 eqtri vx cr c1 vy reex c1 cc ax1cn
      elisseti mapsn 3eqtr4i vu cv cF cfv vv cv cF cfv wceq vu cv vv cv wceq wi
      vu vv cr vu cv cr wcel vv cv cr wcel wa vu cv cF cfv vv cv cF cfv wceq c1
      csn vu cv csn cxp c1 csn vv cv csn cxp wceq vu cv vv cv wceq vu cv cr
      wcel vv cv cr wcel vu cv cF cfv c1 csn vu cv csn cxp vv cv cF cfv c1 csn
      vv cv csn cxp vx vy vu cv c1 csn vx cv csn cxp c1 csn vu cv csn cxp cr cF
      vx cv vu cv wceq vx cv csn vu cv csn wceq c1 csn vx cv csn cxp c1 csn vu
      cv csn cxp wceq vx cv vu cv sneq vx cv csn vu cv csn c1 csn xpeq2 syl
      ismrer1.2 c1 csn vu cv csn c1 snex vu cv snex xpex fvopab4 vx vy vv cv c1
      csn vx cv csn cxp c1 csn vv cv csn cxp cr cF vx cv vv cv wceq vx cv csn
      vv cv csn wceq c1 csn vx cv csn cxp c1 csn vv cv csn cxp wceq vx cv vv cv
      sneq vx cv csn vv cv csn c1 csn xpeq2 syl ismrer1.2 c1 csn vv cv csn c1
      snex vv cv snex xpex fvopab4 eqeqan12d c1 csn vu cv csn cxp c1 csn vv cv
      csn cxp wceq c1 csn c1 csn wceq vu cv csn vv cv csn wceq wa vu cv vv cv
      wceq c1 csn c0 wne vu cv csn c0 wne c1 csn vu cv csn cxp c1 csn vv cv csn
      cxp wceq c1 csn c1 csn wceq vu cv csn vv cv csn wceq wa wb c1 c1 cc ax1cn
      elisseti snnz vu cv vu visset snnz c1 csn vu cv csn c1 csn vv cv csn xp11
      mp2an vu cv csn vv cv csn wceq vu cv vv cv wceq c1 csn c1 csn wceq vu cv
      vv cv vu visset sneqr adantl sylbi syl6bi rgen2a 3pm3.2i vu vv cr cr c1
      csn cm co cF dff1o6 mpbir cr cr c1 csn cm co cF f1of ax-mp ffvelrni c1 c1
      cfz co c1 csn cr cm c1 cz wcel c1 c1 cfz co c1 csn wceq 1z c1 fzsn ax-mp
      opreq2i syl6eleqr adantl syl3anc 3eqtr4d rgen2a mpbir2an $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d R x y f $. $d T f $. $d Y f $.
    reheibor.1 $e |- R = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    reheibor.2 $e |- M = ( R |` ( Y X. Y ) ) $.
    reheibor.3 $e |- T = ( Open ` M ) $.
    reheibor.4 $e |- U = ( Open ` R ) $.
    $( Heine-Borel theorem for real numbers. A subset of ` RR ` is compact
       iff it is closed and bounded. $)
    reheibor $p |- ( Y C_ RR -> ( T e. Comp <->
                                  ( Y e. ( Clsd ` U ) /\ M e. Bnd ) ) ) $=
      cY cr wss c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx
      vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cxp cres copn cfv ccomp wcel vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima c1 crrn cfv copn cfv ccld cfv wcel
      c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab
      cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cima cxp cres cbnd wcel wa cT ccomp wcel cY cU ccld cfv wcel cM cbnd wcel
      wa c1 cn wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cr c1 c1 cfz co cm co wss c1 crrn cfv vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1
      csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv ccomp
      wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      c1 crrn cfv copn cfv ccld cfv wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima cxp cres cbnd wcel wa wb cY cr wss
      c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab
      cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cima cxp cres copn cfv c1 crrn cfv copn cfv c1 crrn cfv vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres c1 cr c1 c1 cfz
      co cm co vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cima cr c1 c1 cfz co cm co eqid c1 crrn cfv vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cima cxp cres eqid c1 crrn cfv vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv
      eqid c1 crrn cfv copn cfv eqid rrnheibor 1nn vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cima cr c1 c1 cfz co cm co wss cY cr
      wss vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab crn cr c1 c1
      cfz co cm co vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab
      cY imassrn cr cr c1 c1 cfz co cm co vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab wf vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab crn cr c1 c1 cfz co cm co wss vx vy cr cr c1 c1 cfz co cm
      co c1 csn vx cv csn cxp vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab
      eqid vx cv cr wcel c1 csn vx cv csn cxp cr c1 csn cm co cr c1 c1 cfz co
      cm co vx cv cr wcel c1 csn cr c1 csn vx cv csn cxp wf c1 csn vx cv csn
      cxp cr c1 csn cm co wcel c1 csn vx cv csn c1 csn vx cv csn cxp wf vx cv
      csn cr wss c1 csn cr c1 csn vx cv csn cxp wf vx cv cr wcel c1 csn vx cv
      csn cr c1 csn vx cv csn cxp fss c1 csn vx cv cr fconstg vx cv cr snssi
      sylanc cr c1 csn c1 csn vx cv csn cxp reex c1 snex elmap sylibr c1 c1 cfz
      co c1 csn cr cm c1 cz wcel c1 c1 cfz co c1 csn wceq 1z c1 fzsn ax-mp
      opreq2i syl6eleqr fopab cr cr c1 c1 cfz co cm co vx cv cr wcel vy cv c1
      csn vx cv csn cxp wceq wa vx vy copab frn ax-mp sstri a1i sylancr cT ctop
      wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cxp cres copn cfv ctop wcel wa vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cres cT c1 crrn cfv vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv
      chomeosm co wcel cT ccomp wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv ccomp wcel wb cY cr
      wss cT ctop wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres copn cfv ctop wcel wa vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cres cT c1 crrn cfv vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv
      chomeosm co wcel cT c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres copn cfv chomeo wbr cT ccomp wcel c1 crrn
      cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres copn cfv ccomp wcel wb cT ctop wcel c1 crrn cfv vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1
      csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv ctop wcel
      wa vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cres
      cT c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cxp cres copn cfv chomeosm co wcel cT c1 crrn cfv vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv
      chomeo wbr cT ctop wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima cxp cres copn cfv ctop wcel wa cT c1 crrn cfv
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres copn cfv chomeo wbr vf cv cT c1 crrn cfv vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv chomeosm co wcel
      vf wex vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cres cT c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx
      vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cxp cres copn cfv chomeosm co wcel vf cT c1 crrn cfv vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn
      cfv hmph vf cv cT c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres copn cfv chomeosm co wcel vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cres cT c1 crrn cfv vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres
      copn cfv chomeosm co wcel vf vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cres vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cvv wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab cY cres cvv wcel vx vy cr c1 csn vx cv csn cxp reex opabex2
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cvv
      resexg ax-mp vf cv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cres cT c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres copn cfv chomeosm co eleq1 cla4ev syl5bir
      imp cT ctop wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres copn cfv ctop wcel cT c1 crrn cfv vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn
      cfv chomeo wbr cT ccomp wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cY cima cxp cres copn cfv ccomp wcel wb cT c1
      crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      cxp cres copn cfv comptoppr 3expa syldan cT ctop wcel c1 crrn cfv vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn
      cfv ctop wcel cM cme wcel cT ctop wcel cM cR cY cY cxp cres cme
      reheibor.2 cR cme wcel cR cY cY cxp cres cme wcel cR reheibor.1 remet cR
      cY metres ax-mp eqeltri cM cT reheibor.3 opntop ax-mp c1 crrn cfv vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres cme
      wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cxp cres copn cfv ctop wcel c1 crrn cfv cme wcel c1 crrn
      cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres cme wcel c1 cn wcel c1 crrn cfv cme wcel 1nn c1 rrnmet ax-mp c1 crrn
      cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      metres ax-mp c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx
      vy copab cY cima cxp cres c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cY cima cxp cres copn cfv c1 crrn cfv vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv
      eqid opntop ax-mp pm3.2i cY cr wss vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cY cres cM c1 crrn cfv vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima cxp cres cismty co wcel vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cres cT c1 crrn
      cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres copn cfv chomeosm co wcel cR cme wcel c1 crrn cfv cme wcel vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cR c1 crrn cfv cismty
      co wcel cY cr wss vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cres cM c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres cismty co wcel cY cr wss cY vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cM c1 crrn cfv vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cR c1 crrn
      cfv cr cR reheibor.1 remetba vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima eqid reheibor.2 c1 crrn cfv vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres eqid ismtyres
      cR cme wcel cY cr wss cR reheibor.1 remet a1i c1 crrn cfv cme wcel cY cr
      wss c1 cn wcel c1 crrn cfv cme wcel 1nn c1 rrnmet ax-mp a1i vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cR c1 crrn cfv cismty co
      wcel cY cr wss vx vy cR vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab reheibor.1 vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab eqid ismrer1 a1i cY cr wss id syl2anc cM cme wcel c1 crrn cfv
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres cme wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cres cM c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres cismty co wcel vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cres cT c1 crrn cfv vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv
      chomeosm co wcel wi cM cR cY cY cxp cres cme reheibor.2 cR cme wcel cR cY
      cY cxp cres cme wcel cR reheibor.1 remet cR cY metres ax-mp eqeltri c1
      crrn cfv cme wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cxp cres cme wcel c1 cn wcel c1 crrn cfv cme wcel
      1nn c1 rrnmet ax-mp c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cima metres ax-mp vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cres cT c1 crrn cfv vx cv cr wcel vy cv c1
      csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cima cxp cres copn cfv cM c1 crrn
      cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres reheibor.3 c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab cY cima cxp cres copn cfv eqid ismtyhmeo mp2an syl sylancr cY
      cr wss cY cU ccld cfv wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima c1 crrn cfv copn cfv ccld cfv wcel cM cbnd wcel c1
      crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima
      cxp cres cbnd wcel cU ctop wcel c1 crrn cfv copn cfv ctop wcel vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cU c1 crrn cfv copn
      cfv chomeosm co wcel cY cr wss cY cU ccld cfv wcel vx cv cr wcel vy cv c1
      csn vx cv csn cxp wceq wa vx vy copab cY cima c1 crrn cfv copn cfv ccld
      cfv wcel wb cY cr wss cY vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab cU c1 crrn cfv copn cfv cr cU cuni cr cR cme wcel cU cuni cr
      wceq cR reheibor.1 remet cR cU cr cR reheibor.1 remetba reheibor.4
      uniopn2 ax-mp eqcomi hmeocld cU ctop wcel cY cr wss cR cme wcel cU ctop
      wcel cR reheibor.1 remet cR cU reheibor.4 opntop ax-mp a1i c1 crrn cfv
      copn cfv ctop wcel cY cr wss c1 crrn cfv cme wcel c1 crrn cfv copn cfv
      ctop wcel c1 cn wcel c1 crrn cfv cme wcel 1nn c1 rrnmet ax-mp c1 crrn cfv
      c1 crrn cfv copn cfv c1 crrn cfv copn cfv eqid opntop ax-mp a1i vx cv cr
      wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cU c1 crrn cfv copn
      cfv chomeosm co wcel cY cr wss vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cR c1 crrn cfv cismty co wcel vx cv cr wcel vy cv c1
      csn vx cv csn cxp wceq wa vx vy copab cU c1 crrn cfv copn cfv chomeosm co
      wcel vx vy cR vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab reheibor.1 vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab eqid ismrer1 cR cme wcel c1 crrn cfv cme wcel vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cR c1 crrn cfv cismty co wcel vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cU c1 crrn cfv
      copn cfv chomeosm co wcel wi cR reheibor.1 remet c1 cn wcel c1 crrn cfv
      cme wcel 1nn c1 rrnmet ax-mp vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cU c1 crrn cfv copn cfv cR c1 crrn cfv reheibor.4 c1
      crrn cfv copn cfv eqid ismtyhmeo mp2an ax-mp a1i cY cr wss id syl2anc cM
      cme wcel c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx
      vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy
      copab cY cima cxp cres cme wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cY cres cM c1 crrn cfv vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cima cxp cres cismty co wcel cM cbnd wcel
      c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab
      cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY
      cima cxp cres cbnd wcel wb cY cr wss vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cY cres cM c1 crrn cfv vx cv cr wcel vy cv c1 csn
      vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx
      cv csn cxp wceq wa vx vy copab cY cima cxp cres ismtybnd cM cme wcel cY
      cr wss cM cR cY cY cxp cres cme reheibor.2 cR cme wcel cR cY cY cxp cres
      cme wcel cR reheibor.1 remet cR cY metres ax-mp eqeltri a1i c1 crrn cfv
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp
      cres cme wcel cY cr wss c1 crrn cfv cme wcel c1 crrn cfv vx cv cr wcel vy
      cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv
      c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres cme wcel c1 cn
      wcel c1 crrn cfv cme wcel 1nn c1 rrnmet ax-mp c1 crrn cfv vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima metres ax-mp a1i
      cR cme wcel c1 crrn cfv cme wcel vx cv cr wcel vy cv c1 csn vx cv csn cxp
      wceq wa vx vy copab cR c1 crrn cfv cismty co wcel cY cr wss vx cv cr wcel
      vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cres cM c1 crrn cfv vx
      cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima cxp cres
      cismty co wcel cY cr wss cY vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq
      wa vx vy copab cY cima cM c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cY cima cxp cres vx cv cr wcel vy cv c1 csn vx cv
      csn cxp wceq wa vx vy copab cR c1 crrn cfv cr cR reheibor.1 remetba vx cv
      cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab cY cima eqid
      reheibor.2 c1 crrn cfv vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa
      vx vy copab cY cima vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx
      vy copab cY cima cxp cres eqid ismtyres cR cme wcel cY cr wss cR
      reheibor.1 remet a1i c1 crrn cfv cme wcel cY cr wss c1 cn wcel c1 crrn
      cfv cme wcel 1nn c1 rrnmet ax-mp a1i vx cv cr wcel vy cv c1 csn vx cv csn
      cxp wceq wa vx vy copab cR c1 crrn cfv cismty co wcel cY cr wss vx vy cR
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab reheibor.1
      vx cv cr wcel vy cv c1 csn vx cv csn cxp wceq wa vx vy copab eqid ismrer1
      a1i cY cr wss id syl2anc syl3anc anbi12d 3bitr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d A x y z $. $d B x y z $. $d J x y z $. $d M x y z $.
    iccbnd.1 $e |- J = ( A [,] B ) $.
    iccbnd.2 $e |- M = ( ( abs o. - ) |` ( J X. J ) ) $.
    $( A closed interval in ` RR ` is bounded. $)
    iccbnd $p |- ( ( A e. RR /\ B e. RR ) -> M e. Bnd ) $=
      cA cr wcel cB cr wcel wa cM cdm cdm vx cv vy cv cM cbl cfv co wceq vy crp
      wrex vx cM cdm cdm wral cM cbnd wcel cA cr wcel cB cr wcel wa cM cdm cdm
      vx cv vy cv cM cbl cfv co wceq vy crp wrex vx cM cdm cdm cA cr wcel cB cr
      wcel wa vx cv cM cdm cdm wcel vx cv cA cB cicc co wcel cM cdm cdm vx cv
      vy cv cM cbl cfv co wceq vy crp wrex cA cr wcel cB cr wcel wa cA cB cicc
      co cM cdm cdm vx cv cA cr wcel cB cr wcel wa cA cB cicc co cabs cmin ccom
      cA cB cicc co cA cB cicc co cxp cres cdm cdm cM cdm cdm cabs cmin ccom
      cme wcel cA cB cicc co cc wss cA cB cicc co cabs cmin ccom cA cB cicc co
      cA cB cicc co cxp cres cdm cdm wceq cA cr wcel cB cr wcel wa cabs cmin
      ccom cc cA cB cicc co cabs cmin ccom cabs cmin ccom eqid cnmetba metssba2
      cabs cmin ccom cabs cmin ccom eqid cnmet cA cr wcel cB cr wcel wa cA cB
      cicc co cr cc cA cB iccssre cr cc wss cA cr wcel cB cr wcel wa axresscn
      a1i sstrd sylancr cM cdm cabs cmin ccom cA cB cicc co cA cB cicc co cxp
      cres cdm cM cabs cmin ccom cA cB cicc co cA cB cicc co cxp cres cM cabs
      cmin ccom cJ cJ cxp cres cabs cmin ccom cA cB cicc co cA cB cicc co cxp
      cres iccbnd.2 cJ cJ cxp cA cB cicc co cA cB cicc co cxp wceq cabs cmin
      ccom cJ cJ cxp cres cabs cmin ccom cA cB cicc co cA cB cicc co cxp cres
      wceq cJ cJ cxp cA cB cicc co cJ cxp cA cB cicc co cA cB cicc co cxp cJ cA
      cB cicc co cJ iccbnd.1 xpeq1i cJ cA cB cicc co cA cB cicc co iccbnd.1
      xpeq2i eqtri cJ cJ cxp cA cB cicc co cA cB cicc co cxp cabs cmin ccom
      reseq2 ax-mp eqtri dmeqi dmeqi syl6eqr eleq2d cA cr wcel cB cr wcel wa vx
      cv cA cB cicc co wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      cM cdm cdm vx cv vy cv cM cbl cfv co wceq vy crp wrex cA cB vx cv elicc2
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a cM cdm cdm vx cv vy cv cM cbl cfv co wceq vy crp wrex cB cA cmin co
      cabs cfv c1 caddc co crp wcel cM cdm cdm vx cv cB cA cmin co cabs cfv c1
      caddc co cM cbl cfv co wceq cM cdm cdm vx cv vy cv cM cbl cfv co wceq vy
      crp wrex cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a wa cM cdm cdm vx cv vy cv cM cbl cfv co wceq cM cdm cdm vx cv
      cB cA cmin co cabs cfv c1 caddc co cM cbl cfv co wceq vy cB cA cmin co
      cabs cfv c1 caddc co crp vy cv cB cA cmin co cabs cfv c1 caddc co wceq vx
      cv vy cv cM cbl cfv co vx cv cB cA cmin co cabs cfv c1 caddc co cM cbl
      cfv co cM cdm cdm vy cv cB cA cmin co cabs cfv c1 caddc co vx cv cM cbl
      cfv opreq2 eqeq2d rcla4ev cA cr wcel cB cr wcel wa cB cA cmin co cabs cfv
      c1 caddc co crp wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      cB cA cmin co cabs cfv c1 caddc co crp wcel cB cA cmin co cabs cfv c1
      caddc co cr wcel cc0 cB cA cmin co cabs cfv c1 caddc co clt wbr cA cr
      wcel cB cr wcel wa cB cA cmin co cabs cfv c1 caddc co elrp cB cA cmin co
      cabs cfv cr wcel c1 cr wcel cB cA cmin co cabs cfv c1 caddc co cr wcel cA
      cr wcel cB cr wcel wa cB cA cmin co cabs cfv c1 readdcl cA cr wcel cB cr
      wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel cB cA cmin co cabs
      cfv cr wcel cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl
      ancoms cB cA cmin co recn cB cA cmin co abscl 3syl 1re sylancl cB cA cmin
      co cabs cfv cr wcel c1 cr wcel cc0 cB cA cmin co cabs cfv cle wbr cc0 c1
      clt wbr cc0 cB cA cmin co cabs cfv c1 caddc co clt wbr cA cr wcel cB cr
      wcel wa cB cA cmin co cabs cfv c1 addgegt0 cA cr wcel cB cr wcel wa cB cA
      cmin co cr wcel cB cA cmin co cc wcel cB cA cmin co cabs cfv cr wcel cB
      cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms cB cA cmin
      co recn cB cA cmin co abscl 3syl c1 cr wcel cA cr wcel cB cr wcel wa 1re
      a1i cA cr wcel cB cr wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel
      cc0 cB cA cmin co cabs cfv cle wbr cB cr wcel cA cr wcel cB cA cmin co cr
      wcel cB cA resubcl ancoms cB cA cmin co recn cB cA cmin co absge0 3syl
      cc0 c1 clt wbr cA cr wcel cB cr wcel wa lt01 a1i syl2anc sylanbrc adantr
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a wa cM cdm cdm vx cv cB cA cmin co cabs cfv c1 caddc co cabs cmin ccom
      cbl cfv co cJ cin vx cv cB cA cmin co cabs cfv c1 caddc co cM cbl cfv co
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a wa vx cv cB cA cmin co cabs cfv c1 caddc co cabs cmin ccom cbl cfv co
      cA cB cicc co cin cA cB cicc co vx cv cB cA cmin co cabs cfv c1 caddc co
      cabs cmin ccom cbl cfv co cJ cin cM cdm cdm cA cr wcel cB cr wcel wa vx
      cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa cA cB cicc co vx cv
      cB cA cmin co cabs cfv c1 caddc co cabs cmin ccom cbl cfv co wss vx cv cB
      cA cmin co cabs cfv c1 caddc co cabs cmin ccom cbl cfv co cA cB cicc co
      cin cA cB cicc co wceq cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a wa vz cA cB cicc co vx cv cB cA cmin co cabs
      cfv c1 caddc co cabs cmin ccom cbl cfv co cA cr wcel cB cr wcel wa vx cv
      cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cA cB cicc co wcel
      vz cv vx cv cB cA cmin co cabs cfv c1 caddc co cabs cmin ccom cbl cfv co
      wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle
      wbr w3a wa vz cv cA cB cicc co wcel wa vz cv vx cv cB cA cmin co cabs cfv
      c1 caddc co cabs cmin ccom cbl cfv co wcel vz cv cc wcel vx cv vz cv cabs
      cmin ccom co cB cA cmin co cabs cfv c1 caddc co clt wbr wa cA cr wcel cB
      cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv
      cA cB cicc co wcel wa vz cv cc wcel vx cv vz cv cabs cmin ccom co cB cA
      cmin co cabs cfv c1 caddc co clt wbr cA cr wcel cB cr wcel wa vz cv cA cB
      cicc co wcel vz cv cc wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle
      wbr w3a cA cr wcel cB cr wcel wa vz cv cA cB cicc co wcel vz cv cc wcel
      cA cr wcel cB cr wcel wa cA cB cicc co cc vz cv cA cr wcel cB cr wcel wa
      cA cB cicc co cr cc cA cB iccssre cr cc wss cA cr wcel cB cr wcel wa
      axresscn a1i sstrd sseld imp adantlr cA cr wcel cB cr wcel wa vx cv cr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cA cB cicc co wcel vx
      cv vz cv cabs cmin ccom co cB cA cmin co cabs cfv c1 caddc co clt wbr cA
      cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      wa vz cv cA cB cicc co wcel vz cv cr wcel cA vz cv cle wbr vz cv cB cle
      wbr w3a vx cv vz cv cabs cmin ccom co cB cA cmin co cabs cfv c1 caddc co
      clt wbr cA cr wcel cB cr wcel wa vz cv cA cB cicc co wcel vz cv cr wcel
      cA vz cv cle wbr vz cv cB cle wbr w3a wb vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr w3a cA cB vz cv elicc2 adantr cA cr wcel cB cr wcel wa
      vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA
      vz cv cle wbr vz cv cB cle wbr w3a vx cv vz cv cabs cmin ccom co cB cA
      cmin co cabs cfv c1 caddc co clt wbr cA cr wcel cB cr wcel wa vx cv cr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle
      wbr vz cv cB cle wbr w3a wa vx cv vz cv cabs cmin ccom co vx cv vz cv
      cmin co cabs cfv cB cA cmin co cabs cfv c1 caddc co clt vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv
      cB cle wbr w3a vx cv vz cv cabs cmin ccom co vx cv vz cv cmin co cabs cfv
      wceq cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vz cv cr
      wcel cA vz cv cle wbr vz cv cB cle wbr w3a vx cv vz cv cabs cmin ccom co
      vx cv vz cv cmin co cabs cfv wceq vx cv cB cle wbr vx cv cr wcel cA vz cv
      cle wbr vz cv cr wcel vx cv vz cv cabs cmin ccom co vx cv vz cv cmin co
      cabs cfv wceq vz cv cB cle wbr vx cv cc wcel vz cv cc wcel vx cv vz cv
      cabs cmin ccom co vx cv vz cv cmin co cabs cfv wceq vx cv cr wcel vz cv
      cr wcel vx cv vz cv cabs cmin ccom cabs cmin ccom eqid cnmetdval vx cv
      recn vz cv recn syl2an 3ad2antr1 3ad2antl1 adantll cA cr wcel cB cr wcel
      wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel
      cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv cmin co cabs cfv cB
      cA cmin co cabs cfv cB cA cmin co cabs cfv c1 caddc co vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv
      cB cle wbr w3a vx cv vz cv cmin co cabs cfv cr wcel cA cr wcel cB cr wcel
      wa vx cv cr wcel cA vx cv cle wbr vz cv cr wcel cA vz cv cle wbr vz cv cB
      cle wbr w3a vx cv vz cv cmin co cabs cfv cr wcel vx cv cB cle wbr vx cv
      cr wcel cA vz cv cle wbr vz cv cr wcel vx cv vz cv cmin co cabs cfv cr
      wcel vz cv cB cle wbr vx cv cr wcel vz cv cr wcel wa vx cv vz cv cmin co
      cr wcel vx cv vz cv cmin co cc wcel vx cv vz cv cmin co cabs cfv cr wcel
      vx cv vz cv resubcl vx cv vz cv cmin co recn vx cv vz cv cmin co abscl
      3syl 3ad2antr1 3ad2antl1 adantll cA cr wcel cB cr wcel wa cB cA cmin co
      cabs cfv cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vz
      cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a cA cr wcel cB cr wcel wa
      cB cA cmin co cr wcel cB cA cmin co cc wcel cB cA cmin co cabs cfv cr
      wcel cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms cB
      cA cmin co recn cB cA cmin co abscl 3syl ad2antrr cA cr wcel cB cr wcel
      wa cB cA cmin co cabs cfv c1 caddc co cr wcel vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a cB cA cmin co cabs cfv cr wcel c1 cr wcel cB cA cmin co cabs cfv c1
      caddc co cr wcel cA cr wcel cB cr wcel wa cB cA cmin co cabs cfv c1
      readdcl cA cr wcel cB cr wcel wa cB cA cmin co cr wcel cB cA cmin co cc
      wcel cB cA cmin co cabs cfv cr wcel cB cr wcel cA cr wcel cB cA cmin co
      cr wcel cB cA resubcl ancoms cB cA cmin co recn cB cA cmin co abscl 3syl
      1re sylancl ad2antrr cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle
      wbr w3a wa vx cv vz cv cmin co cabs cfv cB cA cmin co cB cA cmin co cabs
      cfv vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA
      vz cv cle wbr vz cv cB cle wbr w3a vx cv vz cv cmin co cabs cfv cr wcel
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vz cv cr wcel cA
      vz cv cle wbr vz cv cB cle wbr w3a vx cv vz cv cmin co cabs cfv cr wcel
      vx cv cB cle wbr vx cv cr wcel cA vz cv cle wbr vz cv cr wcel vx cv vz cv
      cmin co cabs cfv cr wcel vz cv cB cle wbr vx cv cr wcel vz cv cr wcel wa
      vx cv vz cv cmin co cr wcel vx cv vz cv cmin co cc wcel vx cv vz cv cmin
      co cabs cfv cr wcel vx cv vz cv resubcl vx cv vz cv cmin co recn vx cv vz
      cv cmin co abscl 3syl 3ad2antr1 3ad2antl1 adantll cA cr wcel cB cr wcel
      wa cB cA cmin co cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a cB cr wcel cA cr
      wcel cB cA cmin co cr wcel cB cA resubcl ancoms ad2antrr cA cr wcel cB cr
      wcel wa cB cA cmin co cabs cfv cr wcel vx cv cr wcel cA vx cv cle wbr vx
      cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a cA
      cr wcel cB cr wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel cB cA
      cmin co cabs cfv cr wcel cB cr wcel cA cr wcel cB cA cmin co cr wcel cB
      cA resubcl ancoms cB cA cmin co recn cB cA cmin co abscl 3syl ad2antrr cA
      cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv
      cmin co cabs cfv cB cA cmin co cle wbr cB cA cmin co cneg vx cv vz cv
      cmin co cle wbr vx cv vz cv cmin co cB cA cmin co cle wbr wa cA cr wcel
      cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz
      cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa cB cA cmin co cneg vx
      cv vz cv cmin co cle wbr vx cv vz cv cmin co cB cA cmin co cle wbr cA cr
      wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa
      vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa cA cB cneg caddc
      co vx cv vz cv cneg caddc co cB cA cmin co cneg vx cv vz cv cmin co cle
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa cA vx cv
      cle wbr cB cneg vz cv cneg cle wbr cA cB cneg caddc co vx cv vz cv cneg
      caddc co cle wbr vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA
      vx cv cle wbr cA cr wcel cB cr wcel wa vz cv cr wcel cA vz cv cle wbr vz
      cv cB cle wbr w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp2
      ad2antlr cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vz
      cv cB cle wbr cB cneg vz cv cneg cle wbr vz cv cr wcel cA vz cv cle wbr
      vz cv cB cle wbr w3a vz cv cB cle wbr cA cr wcel cB cr wcel wa vx cv cr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle
      wbr vz cv cB cle wbr 3simp3 adantl vz cv cr wcel cB cr wcel vz cv cB cle
      wbr cB cneg vz cv cneg cle wbr wb cA cr wcel cB cr wcel wa vx cv cr wcel
      cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr
      vz cv cB cle wbr w3a wa vz cv cB leneg vz cv cr wcel cA vz cv cle wbr vz
      cv cB cle wbr w3a vz cv cr wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz
      cv cB cle wbr 3simp1 adantl cA cr wcel cB cr wcel vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle
      wbr w3a simpllr sylanc mpbid cA cr wcel cB cneg cr wcel vx cv cr wcel vz
      cv cneg cr wcel cA vx cv cle wbr cB cneg vz cv cneg cle wbr wa cA cB cneg
      caddc co vx cv vz cv cneg caddc co cle wbr wi cA cr wcel cB cr wcel wa vx
      cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz
      cv cle wbr vz cv cB cle wbr w3a wa cA cB cneg vx cv vz cv cneg le2add cA
      cr wcel cB cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vz
      cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a simplll cA cr wcel cB cr
      wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr
      wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa cB cr wcel cB cneg cr wcel
      cA cr wcel cB cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a simpllr cB renegcl
      syl vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cr wcel cA
      cr wcel cB cr wcel wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a
      vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp1 ad2antlr cA cr
      wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa
      vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vz cv cr wcel vz
      cv cneg cr wcel vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a vz cv
      cr wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr 3simp1
      adantl vz cv renegcl syl syl2anc mp2and cA cr wcel cB cr wcel wa vx cv cr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle
      wbr vz cv cB cle wbr w3a wa cA cB cneg caddc co cB cneg cA caddc co cB cA
      cmin co cneg cA cc wcel cB cneg cc wcel cA cB cneg caddc co cB cneg cA
      caddc co wceq cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx
      cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a
      wa cA cB cneg addcom cA cr wcel cB cr wcel wa cA cc wcel vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv
      cB cle wbr w3a cA cr wcel cA cc wcel cB cr wcel cA recn adantr ad2antrr
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa cB cc wcel
      cB cneg cc wcel cA cr wcel cB cr wcel wa cB cc wcel vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB
      cle wbr w3a cB cr wcel cB cc wcel cA cr wcel cB recn adantl ad2antrr cB
      negcl syl sylanc cB cc wcel cA cc wcel cB cA cmin co cneg cB cneg cA
      caddc co wceq cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx
      cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a
      wa cB cA negsubdi cA cr wcel cB cr wcel wa cB cc wcel vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB
      cle wbr w3a cB cr wcel cB cc wcel cA cr wcel cB recn adantl ad2antrr cA
      cr wcel cB cr wcel wa cA cc wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a cA cr
      wcel cA cc wcel cB cr wcel cA recn adantr ad2antrr sylanc eqtr4d vx cv cc
      wcel vz cv cc wcel vx cv vz cv cneg caddc co vx cv vz cv cmin co wceq cA
      cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a
      wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv
      negsub vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cc wcel
      cA cr wcel cB cr wcel wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cc wcel vx cv cB cle wbr vx cv
      recn 3ad2ant1 ad2antlr vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a vz cv cc wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cc wcel vz
      cv cB cle wbr vz cv recn 3ad2ant1 adantl sylanc 3brtr3d cA cr wcel cB cr
      wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr
      wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv cneg caddc co
      cB cA cneg caddc co vx cv vz cv cmin co cB cA cmin co cle cA cr wcel cB
      cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv
      cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv cB cle wbr vz cv
      cneg cA cneg cle wbr vx cv vz cv cneg caddc co cB cA cneg caddc co cle
      wbr vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cB cle wbr
      cA cr wcel cB cr wcel wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp3 ad2antlr cA cr
      wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa
      vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa cA vz cv cle wbr
      vz cv cneg cA cneg cle wbr vz cv cr wcel cA vz cv cle wbr vz cv cB cle
      wbr w3a cA vz cv cle wbr cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB
      cle wbr 3simp2 adantl cA cr wcel vz cv cr wcel cA vz cv cle wbr vz cv
      cneg cA cneg cle wbr wb cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB
      cle wbr w3a cA vz cv leneg cA cr wcel cB cr wcel vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a simpll vz cv cr wcel cA vz cv cle wbr vz cv
      cB cle wbr 3simp1 syl2an mpbid vx cv cr wcel vz cv cneg cr wcel cB cr
      wcel cA cneg cr wcel vx cv cB cle wbr vz cv cneg cA cneg cle wbr wa vx cv
      vz cv cneg caddc co cB cA cneg caddc co cle wbr wi cA cr wcel cB cr wcel
      wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel
      cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv cneg cB cA cneg
      le2add vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cr wcel
      cA cr wcel cB cr wcel wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr 3simp1 ad2antlr cA cr
      wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa
      vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa vz cv cr wcel vz
      cv cneg cr wcel vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a vz cv
      cr wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr 3simp1
      adantl vz cv renegcl syl cA cr wcel cB cr wcel vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a simpllr cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv
      cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a wa
      cA cr wcel cA cneg cr wcel cA cr wcel cB cr wcel vx cv cr wcel cA vx cv
      cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle
      wbr w3a simplll cA renegcl syl syl2anc mp2and vx cv cc wcel vz cv cc wcel
      vx cv vz cv cneg caddc co vx cv vz cv cmin co wceq cA cr wcel cB cr wcel
      wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel
      cA vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv negsub vx cv cr wcel
      cA vx cv cle wbr vx cv cB cle wbr w3a vx cv cc wcel cA cr wcel cB cr wcel
      wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a vx cv cr wcel cA
      vx cv cle wbr vx cv cc wcel vx cv cB cle wbr vx cv recn 3ad2ant1 ad2antlr
      vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a vz cv cc wcel cA cr
      wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa
      vz cv cr wcel cA vz cv cle wbr vz cv cc wcel vz cv cB cle wbr vz cv recn
      3ad2ant1 adantl sylanc cB cc wcel cA cc wcel cB cA cneg caddc co cB cA
      cmin co wceq cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx
      cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a
      wa cB cA negsub cA cr wcel cB cr wcel wa cB cc wcel vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB
      cle wbr w3a cB cr wcel cB cc wcel cA cr wcel cB recn adantl ad2antrr cA
      cr wcel cB cr wcel wa cA cc wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a cA cr
      wcel cA cc wcel cB cr wcel cA recn adantr ad2antrr sylanc 3brtr3d jca vx
      cv vz cv cmin co cr wcel cB cA cmin co cr wcel vx cv vz cv cmin co cabs
      cfv cB cA cmin co cle wbr cB cA cmin co cneg vx cv vz cv cmin co cle wbr
      vx cv vz cv cmin co cB cA cmin co cle wbr wa wb cA cr wcel cB cr wcel wa
      vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA
      vz cv cle wbr vz cv cB cle wbr w3a wa vx cv vz cv cmin co cB cA cmin co
      absle vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vz cv cr wcel
      cA vz cv cle wbr vz cv cB cle wbr w3a vx cv vz cv cmin co cr wcel cA cr
      wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vz cv cr wcel cA vz cv
      cle wbr vz cv cB cle wbr w3a vx cv vz cv cmin co cr wcel vx cv cB cle wbr
      vx cv cr wcel cA vz cv cle wbr vz cv cr wcel vx cv vz cv cmin co cr wcel
      vz cv cB cle wbr vx cv vz cv resubcl 3ad2antr1 3ad2antl1 adantll cA cr
      wcel cB cr wcel wa cB cA cmin co cr wcel vx cv cr wcel cA vx cv cle wbr
      vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a
      cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms ad2antrr
      sylanc mpbird cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx
      cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a
      wa cB cA cmin co cr wcel cB cA cmin co cB cA cmin co cabs cfv cle wbr cA
      cr wcel cB cr wcel wa cB cA cmin co cr wcel vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr
      w3a cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms
      ad2antrr cB cA cmin co leabs syl letrd cA cr wcel cB cr wcel wa vx cv cr
      wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vz cv cr wcel cA vz cv cle
      wbr vz cv cB cle wbr w3a wa cB cA cmin co cabs cfv cr wcel cB cA cmin co
      cabs cfv cB cA cmin co cabs cfv c1 caddc co clt wbr cA cr wcel cB cr wcel
      wa cB cA cmin co cabs cfv cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cB
      cle wbr w3a vz cv cr wcel cA vz cv cle wbr vz cv cB cle wbr w3a cA cr
      wcel cB cr wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel cB cA cmin
      co cabs cfv cr wcel cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA
      resubcl ancoms cB cA cmin co recn cB cA cmin co abscl 3syl ad2antrr cB cA
      cmin co cabs cfv ltp1 syl lelttrd eqbrtrd ex sylbid imp jca cabs cmin
      ccom cme wcel vx cv cc wcel cB cA cmin co cabs cfv c1 caddc co cr wcel
      cc0 cB cA cmin co cabs cfv c1 caddc co clt wbr vz cv vx cv cB cA cmin co
      cabs cfv c1 caddc co cabs cmin ccom cbl cfv co wcel vz cv cc wcel vx cv
      vz cv cabs cmin ccom co cB cA cmin co cabs cfv c1 caddc co clt wbr wa wb
      cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a wa vz cv cA cB cicc co wcel wa vz cv cabs cmin ccom vx cv cB cA cmin
      co cabs cfv c1 caddc co cc cabs cmin ccom cabs cmin ccom eqid cnmetba
      elbl cabs cmin ccom cme wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA vx
      cv cle wbr vx cv cB cle wbr w3a wa vz cv cA cB cicc co wcel wa cabs cmin
      ccom cabs cmin ccom eqid cnmet a1i vx cv cr wcel cA vx cv cle wbr vx cv
      cB cle wbr w3a vx cv cc wcel cA cr wcel cB cr wcel wa vz cv cA cB cicc co
      wcel vx cv cr wcel cA vx cv cle wbr vx cv cc wcel vx cv cB cle wbr vx cv
      recn 3ad2ant1 ad2antlr cA cr wcel cB cr wcel wa cB cA cmin co cabs cfv c1
      caddc co cr wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a vz
      cv cA cB cicc co wcel cB cA cmin co cabs cfv cr wcel c1 cr wcel cB cA
      cmin co cabs cfv c1 caddc co cr wcel cA cr wcel cB cr wcel wa cB cA cmin
      co cabs cfv c1 readdcl cA cr wcel cB cr wcel wa cB cA cmin co cr wcel cB
      cA cmin co cc wcel cB cA cmin co cabs cfv cr wcel cB cr wcel cA cr wcel
      cB cA cmin co cr wcel cB cA resubcl ancoms cB cA cmin co recn cB cA cmin
      co abscl 3syl 1re sylancl ad2antrr cA cr wcel cB cr wcel wa cc0 cB cA
      cmin co cabs cfv c1 caddc co clt wbr vx cv cr wcel cA vx cv cle wbr vx cv
      cB cle wbr w3a vz cv cA cB cicc co wcel cB cA cmin co cabs cfv cr wcel c1
      cr wcel cc0 cB cA cmin co cabs cfv cle wbr cc0 c1 clt wbr cc0 cB cA cmin
      co cabs cfv c1 caddc co clt wbr cA cr wcel cB cr wcel wa cB cA cmin co
      cabs cfv c1 addgegt0 cA cr wcel cB cr wcel wa cB cA cmin co cr wcel cB cA
      cmin co cc wcel cB cA cmin co cabs cfv cr wcel cB cr wcel cA cr wcel cB
      cA cmin co cr wcel cB cA resubcl ancoms cB cA cmin co recn cB cA cmin co
      abscl 3syl c1 cr wcel cA cr wcel cB cr wcel wa 1re a1i cA cr wcel cB cr
      wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel cc0 cB cA cmin co
      cabs cfv cle wbr cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA
      resubcl ancoms cB cA cmin co recn cB cA cmin co absge0 3syl cc0 c1 clt
      wbr cA cr wcel cB cr wcel wa lt01 a1i syl2anc ad2antrr syl2anc mpbird ex
      ssrdv cA cB cicc co vx cv cB cA cmin co cabs cfv c1 caddc co cabs cmin
      ccom cbl cfv co sseqin2 sylib vx cv cB cA cmin co cabs cfv c1 caddc co
      cabs cmin ccom cbl cfv co cJ cin vx cv cB cA cmin co cabs cfv c1 caddc co
      cabs cmin ccom cbl cfv co cA cB cicc co cin wceq cA cr wcel cB cr wcel wa
      vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa cJ cA cB cicc co
      vx cv cB cA cmin co cabs cfv c1 caddc co cabs cmin ccom cbl cfv co
      iccbnd.1 ineq2i a1i cA cr wcel cB cr wcel wa cM cdm cdm cA cB cicc co
      wceq vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cr wcel cB cr
      wcel wa cA cB cicc co cabs cmin ccom cA cB cicc co cA cB cicc co cxp cres
      cdm cdm cM cdm cdm cabs cmin ccom cme wcel cA cB cicc co cc wss cA cB
      cicc co cabs cmin ccom cA cB cicc co cA cB cicc co cxp cres cdm cdm wceq
      cA cr wcel cB cr wcel wa cabs cmin ccom cc cA cB cicc co cabs cmin ccom
      cabs cmin ccom eqid cnmetba metssba2 cabs cmin ccom cabs cmin ccom eqid
      cnmet cA cr wcel cB cr wcel wa cA cB cicc co cr cc cA cB iccssre cr cc
      wss cA cr wcel cB cr wcel wa axresscn a1i sstrd sylancr cM cdm cabs cmin
      ccom cA cB cicc co cA cB cicc co cxp cres cdm cM cabs cmin ccom cA cB
      cicc co cA cB cicc co cxp cres cM cabs cmin ccom cJ cJ cxp cres cabs cmin
      ccom cA cB cicc co cA cB cicc co cxp cres iccbnd.2 cJ cJ cxp cA cB cicc
      co cA cB cicc co cxp wceq cabs cmin ccom cJ cJ cxp cres cabs cmin ccom cA
      cB cicc co cA cB cicc co cxp cres wceq cJ cJ cxp cA cB cicc co cJ cxp cA
      cB cicc co cA cB cicc co cxp cJ cA cB cicc co cJ iccbnd.1 xpeq1i cJ cA cB
      cicc co cA cB cicc co iccbnd.1 xpeq2i eqtri cJ cJ cxp cA cB cicc co cA cB
      cicc co cxp cabs cmin ccom reseq2 ax-mp eqtri dmeqi dmeqi syl6reqr adantr
      3eqtr4rd cabs cmin ccom cme wcel cJ cc wss vx cv cJ wcel cB cA cmin co
      cabs cfv c1 caddc co crp wcel vx cv cB cA cmin co cabs cfv c1 caddc co cM
      cbl cfv co vx cv cB cA cmin co cabs cfv c1 caddc co cabs cmin ccom cbl
      cfv co cJ cin wceq cA cr wcel cB cr wcel wa vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a wa cB cA cmin co cabs cfv c1 caddc co cJ cabs
      cmin ccom cM cc vx cv cabs cmin ccom cabs cmin ccom eqid cnmetba iccbnd.2
      blssp cabs cmin ccom cme wcel cA cr wcel cB cr wcel wa vx cv cr wcel cA
      vx cv cle wbr vx cv cB cle wbr w3a wa cabs cmin ccom cabs cmin ccom eqid
      cnmet a1i cA cr wcel cB cr wcel wa cJ cc wss vx cv cr wcel cA vx cv cle
      wbr vx cv cB cle wbr w3a cA cr wcel cB cr wcel wa cA cB cicc co cc cJ cA
      cr wcel cB cr wcel wa cA cB cicc co cr cc cA cB iccssre cr cc wss cA cr
      wcel cB cr wcel wa axresscn a1i sstrd iccbnd.1 syl5ss adantr cA cr wcel
      cB cr wcel wa vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a wa vx
      cv cA cB cicc co cJ cA cr wcel cB cr wcel wa vx cv cA cB cicc co wcel vx
      cv cr wcel cA vx cv cle wbr vx cv cB cle wbr w3a cA cB vx cv elicc2
      biimpar iccbnd.1 syl6eleqr cA cr wcel cB cr wcel wa cB cA cmin co cabs
      cfv c1 caddc co crp wcel vx cv cr wcel cA vx cv cle wbr vx cv cB cle wbr
      w3a cB cA cmin co cabs cfv c1 caddc co crp wcel cB cA cmin co cabs cfv c1
      caddc co cr wcel cc0 cB cA cmin co cabs cfv c1 caddc co clt wbr cA cr
      wcel cB cr wcel wa cB cA cmin co cabs cfv c1 caddc co elrp cB cA cmin co
      cabs cfv cr wcel c1 cr wcel cB cA cmin co cabs cfv c1 caddc co cr wcel cA
      cr wcel cB cr wcel wa cB cA cmin co cabs cfv c1 readdcl cA cr wcel cB cr
      wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel cB cA cmin co cabs
      cfv cr wcel cB cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl
      ancoms cB cA cmin co recn cB cA cmin co abscl 3syl 1re sylancl cB cA cmin
      co cabs cfv cr wcel c1 cr wcel cc0 cB cA cmin co cabs cfv cle wbr cc0 c1
      clt wbr cc0 cB cA cmin co cabs cfv c1 caddc co clt wbr cA cr wcel cB cr
      wcel wa cB cA cmin co cabs cfv c1 addgegt0 cA cr wcel cB cr wcel wa cB cA
      cmin co cr wcel cB cA cmin co cc wcel cB cA cmin co cabs cfv cr wcel cB
      cr wcel cA cr wcel cB cA cmin co cr wcel cB cA resubcl ancoms cB cA cmin
      co recn cB cA cmin co abscl 3syl c1 cr wcel cA cr wcel cB cr wcel wa 1re
      a1i cA cr wcel cB cr wcel wa cB cA cmin co cr wcel cB cA cmin co cc wcel
      cc0 cB cA cmin co cabs cfv cle wbr cB cr wcel cA cr wcel cB cA cmin co cr
      wcel cB cA resubcl ancoms cB cA cmin co recn cB cA cmin co absge0 3syl
      cc0 c1 clt wbr cA cr wcel cB cr wcel wa lt01 a1i syl2anc sylanbrc adantr
      syl2anc eqtr4d sylanc ex sylbid sylbird r19.21aiv cM cme wcel cM cbnd
      wcel cM cdm cdm vx cv vy cv cM cbl cfv co wceq vy crp wrex vx cM cdm cdm
      wral wb cM cabs cmin ccom cJ cJ cxp cres cme iccbnd.2 cabs cmin ccom cme
      wcel cabs cmin ccom cJ cJ cxp cres cme wcel cabs cmin ccom cabs cmin ccom
      eqid cnmet cabs cmin ccom cJ metres ax-mp eqeltri vx cM cM cdm cdm vy cM
      cdm cdm eqid isbnd2 ax-mp sylibr $.
      $( [2-Sep-2009] $)
  $}

  ${
    icccmp.1 $e |- J = ( A [,] B ) $.
    icccmp.2 $e |- M = ( ( abs o. - ) |` ( J X. J ) ) $.
    icccmp.3 $e |- T = ( Open ` M ) $.
    $( A closed interval in ` RR ` is compact. $)
    icccmp $p |- ( ( A e. RR /\ B e. RR ) -> T e. Comp ) $=
      cA cr wcel cB cr wcel wa cT cabs cmin ccom cr cr cxp cres cA cB cicc co
      cA cB cicc co cxp cres copn cfv ccomp cA cr wcel cB cr wcel wa cM copn
      cfv cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres
      copn cfv cT cA cr wcel cB cr wcel wa cM cabs cmin ccom cr cr cxp cres cA
      cB cicc co cA cB cicc co cxp cres copn cA cr wcel cB cr wcel wa cabs cmin
      ccom cA cB cicc co cA cB cicc co cxp cres cabs cmin ccom cr cr cxp cres
      cA cB cicc co cA cB cicc co cxp cres cM cA cr wcel cB cr wcel wa cA cB
      cicc co cA cB cicc co cxp cr cr cxp wss cabs cmin ccom cA cB cicc co cA
      cB cicc co cxp cres cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB
      cicc co cxp cres wceq cA cB cicc co cr wss cA cB cicc co cr wss cA cB
      cicc co cA cB cicc co cxp cr cr cxp wss cA cr wcel cB cr wcel wa cA cB
      cicc co cr cA cB cicc co cr ssxp cA cB iccssre cA cB iccssre sylanc cA cB
      cicc co cA cB cicc co cxp cr cr cxp wss cabs cmin ccom cr cr cxp cres cA
      cB cicc co cA cB cicc co cxp cres cabs cmin ccom cA cB cicc co cA cB cicc
      co cxp cres cabs cmin ccom cA cB cicc co cA cB cicc co cxp cr cr cxp
      resabs1 eqcomd syl cM cabs cmin ccom cJ cJ cxp cres cabs cmin ccom cA cB
      cicc co cA cB cicc co cxp cres icccmp.2 cJ cJ cxp cA cB cicc co cA cB
      cicc co cxp wceq cabs cmin ccom cJ cJ cxp cres cabs cmin ccom cA cB cicc
      co cA cB cicc co cxp cres wceq cJ cJ cxp cA cB cicc co cJ cxp cA cB cicc
      co cA cB cicc co cxp cJ cA cB cicc co cJ icccmp.1 xpeq1i cJ cA cB cicc co
      cA cB cicc co icccmp.1 xpeq2i eqtri cJ cJ cxp cA cB cicc co cA cB cicc co
      cxp cabs cmin ccom reseq2 ax-mp eqtri syl5eq fveq2d icccmp.3 syl5eq cA cr
      wcel cB cr wcel wa cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc
      co cxp cres copn cfv ccomp wcel cA cB cicc co cabs cmin ccom cr cr cxp
      cres copn cfv ccld cfv wcel cabs cmin ccom cr cr cxp cres cA cB cicc co
      cA cB cicc co cxp cres cbnd wcel wa cA cr wcel cB cr wcel wa cA cB cicc
      co cabs cmin ccom cr cr cxp cres copn cfv ccld cfv wcel cabs cmin ccom cr
      cr cxp cres cA cB cicc co cA cB cicc co cxp cres cbnd wcel cA cr wcel cB
      cr wcel wa cA cB cicc co cioo crn ctg cfv ccld cfv cabs cmin ccom cr cr
      cxp cres copn cfv ccld cfv cA cB clint3 cioo crn ctg cfv cabs cmin ccom
      cr cr cxp cres copn cfv ccld cabs cmin ccom cr cr cxp cres cabs cmin ccom
      cr cr cxp cres copn cfv cabs cmin ccom cr cr cxp cres eqid cabs cmin ccom
      cr cr cxp cres copn cfv eqid tgioo fveq2i syl6eleq cA cr wcel cB cr wcel
      wa cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres
      cabs cmin ccom cA cB cicc co cA cB cicc co cxp cres cbnd cA cr wcel cB cr
      wcel wa cA cB cicc co cA cB cicc co cxp cr cr cxp wss cabs cmin ccom cr
      cr cxp cres cA cB cicc co cA cB cicc co cxp cres cabs cmin ccom cA cB
      cicc co cA cB cicc co cxp cres wceq cA cB cicc co cr wss cA cB cicc co cr
      wss cA cB cicc co cA cB cicc co cxp cr cr cxp wss cA cr wcel cB cr wcel
      wa cA cB cicc co cr cA cB cicc co cr ssxp cA cB iccssre cA cB iccssre
      sylanc cabs cmin ccom cA cB cicc co cA cB cicc co cxp cr cr cxp resabs1
      syl cA cB cA cB cicc co cabs cmin ccom cA cB cicc co cA cB cicc co cxp
      cres cA cB cicc co eqid cabs cmin ccom cA cB cicc co cA cB cicc co cxp
      cres eqid iccbnd eqeltrd jca cA cr wcel cB cr wcel wa cA cB cicc co cr
      wss cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres
      copn cfv ccomp wcel cA cB cicc co cabs cmin ccom cr cr cxp cres copn cfv
      ccld cfv wcel cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co
      cxp cres cbnd wcel wa wb cA cB iccssre cabs cmin ccom cr cr cxp cres cabs
      cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp cres copn cfv
      cabs cmin ccom cr cr cxp cres copn cfv cabs cmin ccom cr cr cxp cres cA
      cB cicc co cA cB cicc co cxp cres cA cB cicc co cabs cmin ccom cr cr cxp
      cres eqid cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp
      cres eqid cabs cmin ccom cr cr cxp cres cA cB cicc co cA cB cicc co cxp
      cres copn cfv eqid cabs cmin ccom cr cr cxp cres copn cfv eqid reheibor
      syl mpbird eqeltrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $( The unit interval is compact. $)
    iicmp $p |- II e. Comp $=
      cc0 cr wcel c1 cr wcel cii ccomp wcel 0re 1re cc0 c1 cii cc0 c1 cicc co
      cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cc0 c1 cicc co eqid
      cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres eqid df-ii icccmp
      mp2an $.
      $( [2-Sep-2009] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Path homotopy
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c PHtpy $.
  $c =~ph $.
  $( Extend class notation with the class of path homotopies between
     two continuous functions. $)
  cphtpy $a class PHtpy $.
  $( Extend class notation with the path homotopy relation. $)
  cphtpc $a class =~ph $.

  ${
    $d x y f g z h s $.
    $( Define the function which takes a topological space ` X ` and two
       continuous functions ` F : II --> X ` and ` G : II --> X ` and returns
       the class of path homotopies from ` F ` to ` G ` . $)
    df-phtpy $a |- PHtpy = { <. x , y >. | ( x e. Top /\ y =
      { <. <. f , g >. , z >. | ( ( ( f e. ( II Cn x ) /\ g e. ( II Cn x ) ) /\
                ( ( f ` 0 ) = ( g ` 0 ) /\ ( f ` 1 ) = ( g ` 1 ) ) ) /\ z =
                      { h e. ( ( II tX II ) Cn x ) | A. s e. ( 0 [,] 1 )
                    ( ( ( s h 0 ) = ( f ` s ) /\ ( s h 1 ) = ( g ` s ) ) /\
              ( ( 0 h s ) = ( f ` 0 ) /\ ( 1 h s ) = ( f ` 1 ) ) ) } ) } ) } $.
  $}

  ${
    $d J x y f g z h s $.
    $( Value of the path homotopy function on a topology. $)
    phtpyfval $p |- ( J e. Top -> ( PHtpy ` J ) =
      { <. <. f , g >. , z >. | ( ( ( f e. ( II Cn J ) /\ g e. ( II Cn J ) ) /\
                ( ( f ` 0 ) = ( g ` 0 ) /\ ( f ` 1 ) = ( g ` 1 ) ) ) /\ z =
                      { h e. ( ( II tX II ) Cn J ) | A. s e. ( 0 [,] 1 )
                    ( ( ( s h 0 ) = ( f ` s ) /\ ( s h 1 ) = ( g ` s ) ) /\
                ( ( 0 h s ) = ( f ` 0 ) /\ ( 1 h s ) = ( f ` 1 ) ) ) } ) } ) $=
      vx vy cJ vf cv cii vx cv ccn co wcel vg cv cii vx cv ccn co wcel wa cc0
      vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv
      vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv
      wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv
      cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co vx cv ccn co crab
      wceq wa vf vg vz copab2 vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel
      wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa
      vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg
      cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1
      vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab wceq wa vf vg vz copab2 ctop cphtpy vx cv cJ wceq vf cv cii vx cv
      ccn co wcel vg cv cii vx cv ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv
      wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs cv
      vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv
      co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1
      cicc co wral vh cii cii ctx co vx cv ccn co crab wceq wa vf cv cii cJ ccn
      co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1
      vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs cv vf cv
      cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0
      vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz vx cv cJ wceq
      vf cv cii vx cv ccn co wcel vg cv cii vx cv ccn co wcel wa cc0 vf cv cfv
      cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv cii cJ ccn
      co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1
      vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs cv vf cv
      cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0
      vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co vx cv ccn co crab wceq vz cv vs cv cc0 vh cv co
      vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv
      vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs
      cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq vx cv cJ wceq
      vf cv cii vx cv ccn co wcel vg cv cii vx cv ccn co wcel wa vf cv cii cJ
      ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq
      c1 vf cv cfv c1 vg cv cfv wceq wa vx cv cJ wceq vf cv cii vx cv ccn co
      wcel vf cv cii cJ ccn co wcel vg cv cii vx cv ccn co wcel vg cv cii cJ
      ccn co wcel vx cv cJ wceq cii vx cv ccn co cii cJ ccn co vf cv vx cv cJ
      cii ccn opreq2 eleq2d vx cv cJ wceq cii vx cv ccn co cii cJ ccn co vg cv
      vx cv cJ cii ccn opreq2 eleq2d anbi12d anbi1d vx cv cJ wceq vs cv cc0 vh
      cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0
      vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa
      wa vs cc0 c1 cicc co wral vh cii cii ctx co vx cv ccn co crab vs cv cc0
      vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa
      cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq
      wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab vz cv vx cv
      cJ wceq cii cii ctx co vx cv ccn co cii cii ctx co cJ ccn co wceq vs cv
      cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq
      wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co vx cv ccn co crab vs
      cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv
      wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv
      cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab
      wceq vx cv cJ cii cii ctx co ccn opreq2 vs cv cc0 vh cv co vs cv vf cv
      cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0
      vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co vx cv ccn co cii cii ctx co cJ ccn co rabeq syl
      eqeq2d anbi12d oprabbidv vx vy vz vf vg vh vs df-phtpy cc0 vf cv cfv cc0
      vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz cv vs cv cc0 vh cv co
      vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv
      vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs
      cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz cii
      cJ ccn co cii cJ ccn co vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel
      wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa
      vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg
      cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1
      vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab wceq wa vf vg vz copab2 cii cJ ccn oprex cii cJ ccn oprex cc0 vf cv
      cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz cv vs cv cc0
      vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa
      cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq
      wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vz
      wmo vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa vz cv vs cv cc0
      vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa
      cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq
      wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq cc0 vf
      cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz vz vs cv
      cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq
      wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab moeq
      moani a1i vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv
      cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv
      cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq
      wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq
      wa vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0
      vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz cv vs cv cc0 vh cv co
      vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv
      vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs
      cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa wa vf vg vz
      vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg
      cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz cv vs cv cc0 vh cv co vs
      cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh
      cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0
      c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq anass oprabbii
      oprabex fvopab4 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J f g z h s $. $d F f g z h s $. $d G f g z h s $.
    $( The class of path homotopies between two continuous functions. $)
    phtpyval $p |- ( ( ( J e. Top /\ F e. ( II Cn J ) /\ G e. ( II Cn J ) ) /\
                    ( ( F ` 0 ) = ( G ` 0 ) /\ ( F ` 1 ) = ( G ` 1 ) ) ) ->
              ( F ( PHtpy ` J ) G ) = { h e. ( ( II tX II ) Cn J ) |
      A. s e. ( 0 [,] 1 ) ( ( ( s h 0 ) = ( F ` s ) /\ ( s h 1 ) = ( G ` s ) )
                /\ ( ( 0 h s ) = ( F ` 0 ) /\ ( 1 h s ) = ( F ` 1 ) ) ) } ) $=
      cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv co cF
      cG vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0
      vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv
      co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs
      cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa
      vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz
      copab2 co vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG
      cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF
      cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab cJ
      ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cF cG cJ cphtpy
      cfv co cF cG vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf
      cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs
      cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv
      wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv
      cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab
      wceq wa vf vg vz copab2 co wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1
      cG cfv wceq wa cJ ctop wcel cF cii cJ ccn co wcel cF cG cJ cphtpy cfv co
      cF cG vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv
      cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0
      vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa
      cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq
      wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vf
      vg vz copab2 co wceq cG cii cJ ccn co wcel cJ ctop wcel cJ cphtpy cfv vf
      cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv
      cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs
      cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh
      cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0
      c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz copab2
      cF cG vz vf vg vh cJ vs phtpyfval opreqd 3ad2ant1 adantr cJ ctop wcel cF
      cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq
      c1 cF cfv c1 cG cfv wceq wa cF cG vf cv cii cJ ccn co wcel vg cv cii cJ
      ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv
      wceq wa wa vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv
      co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv
      vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co
      cJ ccn co crab wceq wa vf vg vz copab2 co vs cv cc0 vh cv co vs cv cF cfv
      wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv
      wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii
      cii ctx co cJ ccn co crab wceq cJ ctop wcel cF cii cJ ccn co wcel cG cii
      cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa
      vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq
      wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab vs cv cc0 vh
      cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv
      vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1
      cicc co wral vh cii cii ctx co cJ ccn co crab wceq cF cG vf cv cii cJ ccn
      co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1
      vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs cv vf cv
      cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0
      vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz copab2 co vs cv
      cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0
      vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs
      cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq vs cv cc0 vh cv
      co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh
      cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1
      cicc co wral vh cii cii ctx co cJ ccn co crab eqid cF cii cJ ccn co wcel
      cG cii cJ ccn co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq
      wa vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv
      wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab vs cv
      cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0
      vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs
      cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa cF cG vf cv
      cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv
      cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs
      cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh
      cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0
      c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz copab2
      co vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv
      wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq
      wi cJ ctop wcel cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv
      cfv wceq wa vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv
      co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv
      vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co
      cJ ccn co crab wceq wa cc0 cF cfv cc0 vg cv cfv wceq c1 cF cfv c1 vg cv
      cfv wceq wa vz cv vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co
      vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv
      co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn
      co crab wceq wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vz
      cv vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv
      wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq
      wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vs cv cc0 vh cv
      co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh
      cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1
      cicc co wral vh cii cii ctx co cJ ccn co crab vs cv cc0 vh cv co vs cv cF
      cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF
      cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh
      cii cii ctx co cJ ccn co crab wceq wa vf vg vz cF cG vs cv cc0 vh cv co
      vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv
      co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co cJ ccn co crab cii cJ ccn co cii cJ ccn co vf
      cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv
      cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vz cv vs cv cc0 vh cv co vs
      cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh
      cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0
      c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq wa vf vg vz copab2
      vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq
      wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co cii cii ctx co cJ
      ccn oprex rabex vf cv cF wceq cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv
      cfv c1 vg cv cfv wceq wa cc0 cF cfv cc0 vg cv cfv wceq c1 cF cfv c1 vg cv
      cfv wceq wa vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv
      co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv
      vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co
      cJ ccn co crab wceq vz cv vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1
      vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs
      cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co
      cJ ccn co crab wceq vf cv cF wceq cc0 vf cv cfv cc0 vg cv cfv wceq cc0 cF
      cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq c1 cF cfv c1 vg cv
      cfv wceq vf cv cF wceq cc0 vf cv cfv cc0 cF cfv cc0 vg cv cfv cc0 vf cv
      cF fveq1 eqeq1d vf cv cF wceq c1 vf cv cfv c1 cF cfv c1 vg cv cfv c1 vf
      cv cF fveq1 eqeq1d anbi12d vf cv cF wceq vs cv cc0 vh cv co vs cv vf cv
      cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0
      vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co cJ ccn co crab vs cv cc0 vh cv co vs cv cF cfv
      wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF
      cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh
      cii cii ctx co cJ ccn co crab vz cv vf cv cF wceq vs cv cc0 vh cv co vs
      cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh
      cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq wa wa vs cc0
      c1 cicc co wral vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs
      cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co
      c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      vf cv cF wceq vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co
      vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh
      cv co c1 vf cv cfv wceq wa wa vs cv cc0 vh cv co vs cv cF cfv wceq vs cv
      c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1
      vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co vf cv cF wceq vs cv
      cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq
      wa vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv vg cv cfv
      wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv
      cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF
      cfv wceq wa vf cv cF wceq vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv
      cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq vf
      cv cF wceq vs cv vf cv cfv vs cv cF cfv vs cv cc0 vh cv co vs cv vf cv cF
      fveq1 eqeq2d anbi1d vf cv cF wceq cc0 vs cv vh cv co cc0 vf cv cfv wceq
      cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 vf cv cfv wceq c1
      vs cv vh cv co c1 cF cfv wceq vf cv cF wceq cc0 vf cv cfv cc0 cF cfv cc0
      vs cv vh cv co cc0 vf cv cF fveq1 eqeq2d vf cv cF wceq c1 vf cv cfv c1 cF
      cfv c1 vs cv vh cv co c1 vf cv cF fveq1 eqeq2d anbi12d anbi12d ralbidv
      rabbisdv eqeq2d anbi12d vg cv cG wceq cc0 cF cfv cc0 vg cv cfv wceq c1 cF
      cfv c1 vg cv cfv wceq wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa vz cv vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs
      cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co
      c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab wceq vz cv vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs
      cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1
      cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab
      wceq vg cv cG wceq cc0 cF cfv cc0 vg cv cfv wceq cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 vg cv cfv wceq c1 cF cfv c1 cG cfv wceq vg cv cG wceq
      cc0 vg cv cfv cc0 cG cfv cc0 cF cfv cc0 vg cv cG fveq1 eqeq2d vg cv cG
      wceq c1 vg cv cfv c1 cG cfv c1 cF cfv c1 vg cv cG fveq1 eqeq2d anbi12d vg
      cv cG wceq vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv
      vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1
      cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab
      vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq
      wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab vz cv vg cv cG
      wceq vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv vg cv
      cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF
      cfv wceq wa wa vs cc0 c1 cicc co wral vs cv cc0 vh cv co vs cv cF cfv
      wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv
      wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii
      cii ctx co cJ ccn co vg cv cG wceq vs cv cc0 vh cv co vs cv cF cfv wceq
      vs cv c1 vh cv co vs cv vg cv cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv
      wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cv cc0 vh cv co vs cv cF
      cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF
      cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co vg cv
      cG wceq vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv vg
      cv cfv wceq wa vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs
      cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1
      cF cfv wceq wa vg cv cG wceq vs cv c1 vh cv co vs cv vg cv cfv wceq vs cv
      c1 vh cv co vs cv cG cfv wceq vs cv cc0 vh cv co vs cv cF cfv wceq vg cv
      cG wceq vs cv vg cv cfv vs cv cG cfv vs cv c1 vh cv co vs cv vg cv cG
      fveq1 eqeq2d anbi2d anbi1d ralbidv rabbisdv eqeq2d anbi12d vz cv vs cv
      cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0
      vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs
      cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq vz cv vs cv cc0
      vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs
      cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0
      c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq vs cv cc0 vh cv co
      vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv
      co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co cJ ccn co crab vs cv cc0 vh cv co vs cv cF cfv
      wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv
      wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii
      cii ctx co cJ ccn co crab wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG
      cfv wceq wa vz cv vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co
      vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co
      c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv
      wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab eqeq1
      anbi2d cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa
      vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg
      cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1
      vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab wceq wa vz wmo vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa
      vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg
      cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1
      vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab wceq cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq
      wa vz vz vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv
      vg cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co
      c1 vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn
      co crab moeq moani a1i vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel
      wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa
      vz cv vs cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg
      cv cfv wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1
      vf cv cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co
      crab wceq wa vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf
      cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz cv vs cv
      cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv wceq
      wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv cfv
      wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab wceq
      wa wa vf vg vz vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0
      vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vz cv vs
      cv cc0 vh cv co vs cv vf cv cfv wceq vs cv c1 vh cv co vs cv vg cv cfv
      wceq wa cc0 vs cv vh cv co cc0 vf cv cfv wceq c1 vs cv vh cv co c1 vf cv
      cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab
      wceq anass oprabbii oprabvali 3adant1 mpan2i imp eqtrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J h s $. $d F h s $. $d G h s $. $d H h s $.
    $( Membership in the class of path homotopies between two continuous
       functions. $)
    isphtpy $p |- ( ( ( J e. Top /\ F e. ( II Cn J ) /\ G e. ( II Cn J ) ) /\
                    ( ( F ` 0 ) = ( G ` 0 ) /\ ( F ` 1 ) = ( G ` 1 ) ) ) ->
            ( H e. ( F ( PHtpy ` J ) G ) <-> ( H e. ( ( II tX II ) Cn J ) /\
      A. s e. ( 0 [,] 1 ) ( ( ( s H 0 ) = ( F ` s ) /\ ( s H 1 ) = ( G ` s ) )
              /\ ( ( 0 H s ) = ( F ` 0 ) /\ ( 1 H s ) = ( F ` 1 ) ) ) ) ) ) $=
      cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cH cF cG cJ cphtpy cfv co
      wcel cH vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG
      cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF
      cfv wceq wa wa vs cc0 c1 cicc co wral vh cii cii ctx co cJ ccn co crab
      wcel cH cii cii ctx co cJ ccn co wcel vs cv cc0 cH co vs cv cF cfv wceq
      vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs
      cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral wa cJ ctop wcel cF
      cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq
      c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv co vs cv cc0 vh cv co
      vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa cc0 vs cv vh cv
      co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa wa vs cc0 c1 cicc
      co wral vh cii cii ctx co cJ ccn co crab cH vh cF cG cJ vs phtpyval
      eleq2d vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh cv co vs cv cG
      cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF
      cfv wceq wa wa vs cc0 c1 cicc co wral vs cv cc0 cH co vs cv cF cfv wceq
      vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs
      cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vh cH cii cii ctx co
      cJ ccn co vh cv cH wceq vs cv cc0 vh cv co vs cv cF cfv wceq vs cv c1 vh
      cv co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0 cF cfv wceq c1 vs cv vh
      cv co c1 cF cfv wceq wa wa vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH
      co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1
      cF cfv wceq wa wa vs cc0 c1 cicc co vh cv cH wceq vs cv cc0 vh cv co vs
      cv cF cfv wceq vs cv c1 vh cv co vs cv cG cfv wceq wa vs cv cc0 cH co vs
      cv cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv vh cv co cc0
      cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq wa cc0 vs cv cH co cc0 cF
      cfv wceq c1 vs cv cH co c1 cF cfv wceq wa vh cv cH wceq vs cv cc0 vh cv
      co vs cv cF cfv wceq vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 vh cv co
      vs cv cG cfv wceq vs cv c1 cH co vs cv cG cfv wceq vh cv cH wceq vs cv
      cc0 vh cv co vs cv cc0 cH co vs cv cF cfv vs cv cc0 vh cv cH opreq eqeq1d
      vh cv cH wceq vs cv c1 vh cv co vs cv c1 cH co vs cv cG cfv vs cv c1 vh
      cv cH opreq eqeq1d anbi12d vh cv cH wceq cc0 vs cv vh cv co cc0 cF cfv
      wceq cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv vh cv co c1 cF cfv wceq c1
      vs cv cH co c1 cF cfv wceq vh cv cH wceq cc0 vs cv vh cv co cc0 vs cv cH
      co cc0 cF cfv cc0 vs cv vh cv cH opreq eqeq1d vh cv cH wceq c1 vs cv vh
      cv co c1 vs cv cH co c1 cF cfv c1 vs cv vh cv cH opreq eqeq1d anbi12d
      anbi12d ralbidv elrab syl6bb $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J s x y z $. $d F s x y z $. $d H s $.
    phtpyid.1 $e |- H = { <. <. x , y >. , z >. | ( ( x e. ( 0 [,] 1 )
                                /\ y e. ( 0 [,] 1 ) ) /\ z = ( F ` x ) ) } $.
    $( A homotopy from a path to itself. $)
    phtpyid $p |- ( ( J e. Top /\ F e. ( II Cn J ) ) ->
                                          H e. ( F ( PHtpy ` J ) F ) ) $=
      cJ ctop wcel cF cii cJ ccn co wcel wa cH cF cF cJ cphtpy cfv co wcel cH
      cii cii ctx co cJ ccn co wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv c1
      cH co vs cv cF cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co
      c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral wa cJ ctop wcel cF cii cJ ccn
      co wcel wa cH cii cii ctx co cJ ccn co wcel vs cv cc0 cH co vs cv cF cfv
      wceq vs cv c1 cH co vs cv cF cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq
      c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral cJ ctop wcel
      cF cii cJ ccn co wcel wa cH cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp
      cres ccom cii cii ctx co cJ ccn co cJ ctop wcel cF cii cJ ccn co wcel wa
      vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv
      wceq wa vx vy vz copab2 cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres
      ccom cH cJ ctop wcel cF cii cJ ccn co wcel wa vx cv cc0 c1 cicc co wcel
      vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2
      cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres ccom wceq cc0 c1 cicc co
      cc0 c1 cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp wceq vs cv vx cv cc0
      c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa
      vx vy vz copab2 cfv vs cv cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres
      ccom cfv wceq vs cc0 c1 cicc co cc0 c1 cicc co cxp wral wa cJ ctop wcel
      cF cii cJ ccn co wcel wa cc0 c1 cicc co cc0 c1 cicc co cxp cc0 c1 cicc co
      cc0 c1 cicc co cxp wceq vs cv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc
      co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs cv cF c1st
      cc0 c1 cicc co cc0 c1 cicc co cxp cres ccom cfv wceq vs cc0 c1 cicc co
      cc0 c1 cicc co cxp wral cJ ctop wcel cF cii cJ ccn co wcel wa cc0 c1 cicc
      co cc0 c1 cicc co cxp eqidd cJ ctop wcel cF cii cJ ccn co wcel wa vs cv
      vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv
      wceq wa vx vy vz copab2 cfv vs cv cF c1st cc0 c1 cicc co cc0 c1 cicc co
      cxp cres ccom cfv wceq vs cc0 c1 cicc co cc0 c1 cicc co cxp cJ ctop wcel
      cF cii cJ ccn co wcel wa vs cv cc0 c1 cicc co cc0 c1 cicc co cxp wcel wa
      vs cv c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cfv cF cfv vs cv c1st
      cfv cF cfv vs cv cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres ccom cfv
      vs cv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv
      cF cfv wceq wa vx vy vz copab2 cfv vs cv cc0 c1 cicc co cc0 c1 cicc co
      cxp wcel vs cv c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cfv cF cfv vs
      cv c1st cfv cF cfv wceq cJ ctop wcel cF cii cJ ccn co wcel wa vs cv cc0
      c1 cicc co cc0 c1 cicc co cxp wcel vs cv c1st cc0 c1 cicc co cc0 c1 cicc
      co cxp cres cfv vs cv c1st cfv cF vs cv cc0 c1 cicc co cc0 c1 cicc co cxp
      c1st fvres fveq2d adantl cF wfun c1st cc0 c1 cicc co cc0 c1 cicc co cxp
      cres wfun vs cv c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cdm wcel vs
      cv cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres ccom cfv vs cv c1st cc0
      c1 cicc co cc0 c1 cicc co cxp cres cfv cF cfv wceq cJ ctop wcel cF cii cJ
      ccn co wcel wa vs cv cc0 c1 cicc co cc0 c1 cicc co cxp wcel wa vs cv cF
      c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres fvco cJ ctop wcel cF cii cJ
      ccn co wcel wa cF wfun vs cv cc0 c1 cicc co cc0 c1 cicc co cxp wcel cJ
      ctop wcel cF cii cJ ccn co wcel wa cc0 c1 cicc co cJ cuni cF wf cF wfun
      cii ctop wcel cJ ctop wcel cF cii cJ ccn co wcel cc0 c1 cicc co cJ cuni
      cF wf iitop cF cii cJ cc0 c1 cicc co cJ cuni cii cuni cc0 c1 cicc co
      iiuni eqcomi cJ cuni eqid cnf mp3an1 cc0 c1 cicc co cJ cuni cF ffun syl
      adantr c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres wfun cJ ctop wcel cF
      cii cJ ccn co wcel wa vs cv cc0 c1 cicc co cc0 c1 cicc co cxp wcel wa cc0
      c1 cicc co cc0 c1 cicc co cxp cc0 c1 cicc co c1st cc0 c1 cicc co cc0 c1
      cicc co cxp cres wf c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres wfun cc0
      c1 cicc co cc0 c1 cicc co f1stres cc0 c1 cicc co cc0 c1 cicc co cxp cc0
      c1 cicc co c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres ffun ax-mp a1i vs
      cv cc0 c1 cicc co cc0 c1 cicc co cxp wcel vs cv c1st cc0 c1 cicc co cc0
      c1 cicc co cxp cres cdm wcel cJ ctop wcel cF cii cJ ccn co wcel wa vs cv
      c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cdm wcel vs cv cc0 c1 cicc co
      cc0 c1 cicc co cxp wcel c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cdm
      cc0 c1 cicc co cc0 c1 cicc co cxp vs cv cc0 c1 cicc co cc0 c1 cicc co cxp
      cc0 c1 cicc co c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cc0 c1 cicc co
      cc0 c1 cicc co f1stres fdmi eleq2i biimpri adantl syl3anc vs cv cc0 c1
      cicc co cc0 c1 cicc co cxp wcel vs cv vx cv cc0 c1 cicc co wcel vy cv cc0
      c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs cv
      c1st cfv cF cfv wceq cJ ctop wcel cF cii cJ ccn co wcel wa vs cv cc0 c1
      cicc co cc0 c1 cicc co cxp wcel vs cv vs cv c1st cfv vs cv c2nd cfv cop
      wceq vs cv c1st cfv cc0 c1 cicc co wcel vs cv c2nd cfv cc0 c1 cicc co
      wcel wa wa vs cv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa
      vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs cv c1st cfv cF cfv wceq
      vs cv cc0 c1 cicc co cc0 c1 cicc co elxp6 vs cv vs cv c1st cfv vs cv c2nd
      cfv cop wceq vs cv c1st cfv cc0 c1 cicc co wcel vs cv c2nd cfv cc0 c1
      cicc co wcel wa wa vs cv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co
      wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs cv c1st cfv vs
      cv c2nd cfv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv
      vx cv cF cfv wceq wa vx vy vz copab2 co vs cv c1st cfv cF cfv vs cv vs cv
      c1st cfv vs cv c2nd cfv cop wceq vs cv c1st cfv cc0 c1 cicc co wcel vs cv
      c2nd cfv cc0 c1 cicc co wcel wa wa vs cv vx cv cc0 c1 cicc co wcel vy cv
      cc0 c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs
      cv c1st cfv vs cv c2nd cfv cop vx cv cc0 c1 cicc co wcel vy cv cc0 c1
      cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs cv c1st
      cfv vs cv c2nd cfv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa
      vz cv vx cv cF cfv wceq wa vx vy vz copab2 co vs cv vs cv c1st cfv vs cv
      c2nd cfv cop wceq vs cv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co
      wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cfv vs cv c1st cfv vs
      cv c2nd cfv cop vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz
      cv vx cv cF cfv wceq wa vx vy vz copab2 cfv wceq vs cv c1st cfv cc0 c1
      cicc co wcel vs cv c2nd cfv cc0 c1 cicc co wcel wa vs cv vs cv c1st cfv
      vs cv c2nd cfv cop vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa
      vz cv vx cv cF cfv wceq wa vx vy vz copab2 fveq2 adantr vs cv c1st cfv vs
      cv c2nd cfv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv
      vx cv cF cfv wceq wa vx vy vz copab2 df-opr syl6eqr vs cv c1st cfv cc0 c1
      cicc co wcel vs cv c2nd cfv cc0 c1 cicc co wcel wa vs cv c1st cfv vs cv
      c2nd cfv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx
      cv cF cfv wceq wa vx vy vz copab2 co vs cv c1st cfv cF cfv wceq vs cv vs
      cv c1st cfv vs cv c2nd cfv cop wceq vx vy vz vs cv c1st cfv vs cv c2nd
      cfv cc0 c1 cicc co cc0 c1 cicc co vx cv cF cfv vs cv c1st cfv cF cfv vx
      cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv
      wceq wa vx vy vz copab2 vs cv c1st cfv cF cfv vs cv c1st cfv cF fvex vx
      cv vs cv c1st cfv cF fveq2 vy cv vs cv c2nd cfv wceq vs cv c1st cfv cF
      cfv eqidd vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx
      cv cF cfv wceq wa vx vy vz copab2 eqid oprabval2 adantl eqtrd sylbi
      adantl 3eqtr4rd r19.21aiva jca vx cv cc0 c1 cicc co wcel vy cv cc0 c1
      cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cc0 c1 cicc co
      cc0 c1 cicc co cxp wfn cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres
      ccom cc0 c1 cicc co cc0 c1 cicc co cxp wfn vx cv cc0 c1 cicc co wcel vy
      cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cF
      c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres ccom wceq cc0 c1 cicc co cc0
      c1 cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp wceq vs cv vx cv cc0 c1
      cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa vx
      vy vz copab2 cfv vs cv cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres
      ccom cfv wceq vs cc0 c1 cicc co cc0 c1 cicc co cxp wral wa wb cJ ctop
      wcel cF cii cJ ccn co wcel wa vs cc0 c1 cicc co cc0 c1 cicc co cxp cc0 c1
      cicc co cc0 c1 cicc co cxp vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co
      wcel wa vz cv vx cv cF cfv wceq wa vx vy vz copab2 cF c1st cc0 c1 cicc co
      cc0 c1 cicc co cxp cres ccom eqfnfv vx vy vz cc0 c1 cicc co cc0 c1 cicc
      co vx cv cF cfv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz
      cv vx cv cF cfv wceq wa vx vy vz copab2 vx cv cF fvex vx cv cc0 c1 cicc
      co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv cF cfv wceq wa vx vy vz
      copab2 eqid fnoprab2 cF cc0 c1 cicc co wfn c1st cc0 c1 cicc co cc0 c1
      cicc co cxp cres cc0 c1 cicc co cc0 c1 cicc co cxp wfn c1st cc0 c1 cicc
      co cc0 c1 cicc co cxp cres crn cc0 c1 cicc co wss cF c1st cc0 c1 cicc co
      cc0 c1 cicc co cxp cres ccom cc0 c1 cicc co cc0 c1 cicc co cxp wfn cJ
      ctop wcel cF cii cJ ccn co wcel wa cc0 c1 cicc co cc0 c1 cicc co cc0 c1
      cicc co cxp cF c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres fnco cJ ctop
      wcel cF cii cJ ccn co wcel wa cc0 c1 cicc co cJ cuni cF wf cF cc0 c1 cicc
      co wfn cii ctop wcel cJ ctop wcel cF cii cJ ccn co wcel cc0 c1 cicc co cJ
      cuni cF wf iitop cF cii cJ cc0 c1 cicc co cJ cuni cii cuni cc0 c1 cicc co
      iiuni eqcomi cJ cuni eqid cnf mp3an1 cc0 c1 cicc co cJ cuni cF ffn syl
      c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cc0 c1 cicc co cc0 c1 cicc co
      cxp wfn cJ ctop wcel cF cii cJ ccn co wcel wa cc0 c1 cicc co cc0 c1 cicc
      co cxp cc0 c1 cicc co c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres wf c1st
      cc0 c1 cicc co cc0 c1 cicc co cxp cres cc0 c1 cicc co cc0 c1 cicc co cxp
      wfn cc0 c1 cicc co cc0 c1 cicc co f1stres cc0 c1 cicc co cc0 c1 cicc co
      cxp cc0 c1 cicc co c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres ffn ax-mp
      a1i c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres crn cc0 c1 cicc co wss cJ
      ctop wcel cF cii cJ ccn co wcel wa cc0 c1 cicc co cc0 c1 cicc co cxp cc0
      c1 cicc co c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres wf c1st cc0 c1
      cicc co cc0 c1 cicc co cxp cres crn cc0 c1 cicc co wss cc0 c1 cicc co cc0
      c1 cicc co f1stres cc0 c1 cicc co cc0 c1 cicc co cxp cc0 c1 cicc co c1st
      cc0 c1 cicc co cc0 c1 cicc co cxp cres frn ax-mp a1i syl3anc sylancr
      mpbird phtpyid.1 syl5eq cii cii ctx co ctop wcel cii ctop wcel cJ ctop
      wcel w3a c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cii cii ctx co cii
      ccn co wcel cF cii cJ ccn co wcel wa cF c1st cc0 c1 cicc co cc0 c1 cicc
      co cxp cres ccom cii cii ctx co cJ ccn co wcel cJ ctop wcel cF cii cJ ccn
      co wcel wa c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cF cii cii ctx co
      cii cJ cnco cJ ctop wcel cF cii cJ ccn co wcel wa cii cii ctx co ctop
      wcel cii ctop wcel cJ ctop wcel cii cii ctx co ctop wcel cJ ctop wcel cF
      cii cJ ccn co wcel wa cii ctop wcel cii ctop wcel cii cii ctx co ctop
      wcel iitop iitop cii cii cii cii ctx co cii cii ctx co eqid txtop mp2an
      a1i cii ctop wcel cJ ctop wcel cF cii cJ ccn co wcel wa iitop a1i cJ ctop
      wcel cF cii cJ ccn co wcel pm3.26 3jca cJ ctop wcel cF cii cJ ccn co wcel
      wa cF cii cJ ccn co wcel c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cii
      cii ctx co cii ccn co wcel cJ ctop wcel cF cii cJ ccn co wcel pm3.27 cii
      ctop wcel cii ctop wcel c1st cc0 c1 cicc co cc0 c1 cicc co cxp cres cii
      cii ctx co cii ccn co wcel iitop iitop cii cii cii cii ctx co cc0 c1 cicc
      co cc0 c1 cicc co cc0 c1 cicc co cc0 c1 cicc co cxp cii cii ctx co eqid
      cii cuni cc0 c1 cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi
      cc0 c1 cicc co cc0 c1 cicc co cxp eqid tx1cn mp2an jctil sylanc eqeltrd
      cJ ctop wcel cF cii cJ ccn co wcel wa vs cv cc0 cH co vs cv cF cfv wceq
      vs cv c1 cH co vs cv cF cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs
      cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co vs cv cc0 c1 cicc co wcel
      vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cF cfv wceq wa cc0
      vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa cJ ctop
      wcel cF cii cJ ccn co wcel wa vs cv cc0 c1 cicc co wcel vs cv cc0 cH co
      vs cv cF cfv wceq vs cv c1 cH co vs cv cF cfv wceq cc0 vs cv cH co cc0 cF
      cfv wceq c1 vs cv cH co c1 cF cfv wceq wa vs cv cc0 c1 cicc co wcel cc0
      cc0 c1 cicc co wcel vs cv cc0 cH co vs cv cF cfv wceq cc0 cr wcel c1 cr
      wcel cc0 c1 cle wbr cc0 cc0 c1 cicc co wcel 0re 1re cc0 c1 0re 1re lt01
      ltleii cc0 c1 lbicc2 mp3an vx vy vz vs cv cc0 cc0 c1 cicc co cc0 c1 cicc
      co vx cv cF cfv vs cv cF cfv cH vs cv cF cfv vs cv cF fvex vx cv vs cv cF
      fveq2 vy cv cc0 wceq vs cv cF cfv eqidd phtpyid.1 oprabval2 mpan2 vs cv
      cc0 c1 cicc co wcel c1 cc0 c1 cicc co wcel vs cv c1 cH co vs cv cF cfv
      wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr c1 cc0 c1 cicc co wcel 0re 1re
      cc0 c1 0re 1re lt01 ltleii cc0 c1 ubicc2 mp3an vx vy vz vs cv c1 cc0 c1
      cicc co cc0 c1 cicc co vx cv cF cfv vs cv cF cfv cH vs cv cF cfv vs cv cF
      fvex vx cv vs cv cF fveq2 vy cv c1 wceq vs cv cF cfv eqidd phtpyid.1
      oprabval2 mpan2 vs cv cc0 c1 cicc co wcel cc0 vs cv cH co cc0 cF cfv wceq
      c1 vs cv cH co c1 cF cfv wceq cc0 cc0 c1 cicc co wcel vs cv cc0 c1 cicc
      co wcel cc0 vs cv cH co cc0 cF cfv wceq cc0 cr wcel c1 cr wcel cc0 c1 cle
      wbr cc0 cc0 c1 cicc co wcel 0re 1re cc0 c1 0re 1re lt01 ltleii cc0 c1
      lbicc2 mp3an vx vy vz cc0 vs cv cc0 c1 cicc co cc0 c1 cicc co vx cv cF
      cfv cc0 cF cfv cH cc0 cF cfv cc0 cF fvex vx cv cc0 cF fveq2 vy cv vs cv
      wceq cc0 cF cfv eqidd phtpyid.1 oprabval2 mpan c1 cc0 c1 cicc co wcel vs
      cv cc0 c1 cicc co wcel c1 vs cv cH co c1 cF cfv wceq cc0 cr wcel c1 cr
      wcel cc0 c1 cle wbr c1 cc0 c1 cicc co wcel 0re 1re cc0 c1 0re 1re lt01
      ltleii cc0 c1 ubicc2 mp3an vx vy vz c1 vs cv cc0 c1 cicc co cc0 c1 cicc
      co vx cv cF cfv c1 cF cfv cH c1 cF cfv c1 cF fvex vx cv c1 cF fveq2 vy cv
      vs cv wceq c1 cF cfv eqidd phtpyid.1 oprabval2 mpan jca jca31 adantl
      r19.21aiva jca cJ ctop wcel cF cii cJ ccn co wcel cF cii cJ ccn co wcel
      w3a cc0 cF cfv cc0 cF cfv wceq c1 cF cfv c1 cF cfv wceq cH cF cF cJ
      cphtpy cfv co wcel cH cii cii ctx co cJ ccn co wcel vs cv cc0 cH co vs cv
      cF cfv wceq vs cv c1 cH co vs cv cF cfv wceq wa cc0 vs cv cH co cc0 cF
      cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral wa wb
      cJ ctop wcel cF cii cJ ccn co wcel wa cJ ctop wcel cF cii cJ ccn co wcel
      wa cJ ctop wcel cF cii cJ ccn co wcel cF cii cJ ccn co wcel cJ ctop wcel
      cF cii cJ ccn co wcel pm3.26 cJ ctop wcel cF cii cJ ccn co wcel pm3.27 cJ
      ctop wcel cF cii cJ ccn co wcel pm3.27 3jca cJ ctop wcel cF cii cJ ccn co
      wcel wa cc0 cF cfv eqidd cJ ctop wcel cF cii cJ ccn co wcel wa c1 cF cfv
      eqidd cF cF cH cJ vs isphtpy sylan32c mpbird $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J s t w x y z $. $d F s t w x y z $. $d H s t w x y z $.
    $d G s t w x y z $. $d K s t w $.
    phtpycom.1 $e |- K = { <. <. x , y >. , z >. | ( ( x e. ( 0 [,] 1 )
                          /\ y e. ( 0 [,] 1 ) ) /\ z = ( x H ( 1 - y ) ) ) } $.
    $( Given a homotopy from ` F ` to ` G ` , produce a homotopy from
       ` G ` to ` F ` . $)
    phtpycom $p |- ( ( ( J e. Top /\ F e. ( II Cn J ) /\ G e. ( II Cn J ) ) /\
                    ( ( F ` 0 ) = ( G ` 0 ) /\ ( F ` 1 ) = ( G ` 1 ) ) ) ->
              ( H e. ( F ( PHtpy ` J ) G ) -> K e. ( G ( PHtpy ` J ) F ) ) ) $=
      cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cH cii cii ctx co cJ ccn
      co wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv
      wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel vt cv cc0
      cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 vt cv cK
      co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa vt cc0 c1 cicc co
      wral wa cH cF cG cJ cphtpy cfv co wcel cK cG cF cJ cphtpy cfv co wcel cJ
      ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv cc0
      cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cH cii cii ctx co cJ ccn co
      wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq
      wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs
      cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel vt cv cc0 cK co
      vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 vt cv cK co cc0
      cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa vt cc0 c1 cicc co wral wa
      cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cH cii cii ctx co cJ ccn
      co wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv
      wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa cK cii cii ctx co cJ ccn co wcel vt cv
      cc0 cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 vt cv
      cK co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa vt cc0 c1 cicc
      co wral cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cH
      cii cii ctx co cJ ccn co wcel cK cii cii ctx co cJ ccn co wcel cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vs cv cc0 cH co vs cv cF cfv
      wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq
      c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral cJ ctop wcel
      cF cii cJ ccn co wcel cH cii cii ctx co cJ ccn co wcel cK cii cii ctx co
      cJ ccn co wcel cG cii cJ ccn co wcel cJ ctop wcel cH cii cii ctx co cJ
      ccn co wcel wa cK cH vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel
      wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab
      cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab cfv cop wceq wa vx vy vw copab2 ccom cii cii ctx co cJ ccn co cJ
      ctop wcel cH cii cii ctx co cJ ccn co wcel wa cc0 c1 cicc co cc0 c1 cicc
      co cxp cJ cuni cH wf cH cc0 c1 cicc co cc0 c1 cicc co cxp wfn cK cH vx cv
      cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs cv cc0 c1
      cicc co wcel vt cv vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc
      co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv cop wceq wa vx vy
      vw copab2 ccom wceq cii cii ctx co ctop wcel cJ ctop wcel cH cii cii ctx
      co cJ ccn co wcel cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cH wf cii
      ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop iitop cii cii cii
      cii ctx co cii cii ctx co eqid txtop mp2an cH cii cii ctx co cJ cc0 c1
      cicc co cc0 c1 cicc co cxp cJ cuni cii cii ctx co cuni cc0 c1 cicc co cc0
      c1 cicc co cxp cii ctop wcel cii ctop wcel cii cii ctx co cuni cc0 c1
      cicc co cc0 c1 cicc co cxp wceq iitop iitop cii cii cii cii ctx co cc0 c1
      cicc co cc0 c1 cicc co cii cii ctx co eqid cii cuni cc0 c1 cicc co iiuni
      eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi txuni mp2an eqcomi cJ cuni
      eqid cnf mp3an1 cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cH ffn vx vy vw
      vz cc0 c1 cicc co cc0 c1 cicc co vx cv c1 vy cv cmin co cop cc0 c1 cicc
      co cc0 c1 cicc co cxp vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel
      wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab
      cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab cfv cop wceq wa vx vy vw copab2 cK cH vx cv cc0 c1 cicc co wcel c1
      vy cv cmin co cc0 c1 cicc co wcel vx cv c1 vy cv cmin co cop cc0 c1 cicc
      co cc0 c1 cicc co cxp wcel vy cv cc0 c1 cicc co wcel vx cv c1 vy cv cmin
      co cc0 c1 cicc co cc0 c1 cicc co opelxpi vy cv iirev sylan2 vx cv cc0 c1
      cicc co wcel vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs cv cc0 c1 cicc
      co wcel vt cv vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc co
      wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv cop wceq wa vx cv cc0
      c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vw cv vx cv c1 vy cv cmin co
      cop wceq wa vx vy vw vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel
      wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab
      cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab cfv cop wceq vw cv vx cv c1 vy cv cmin co cop wceq vx cv cc0 c1
      cicc co wcel vy cv cc0 c1 cicc co wcel wa vx cv vs cv cc0 c1 cicc co wcel
      vt cv vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc co wcel vt cv
      c1 vs cv cmin co wceq wa vs vt copab cfv cop vx cv c1 vy cv cmin co cop
      vw cv vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vx cv vs cv
      cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab cfv vx cv vy cv vs cv
      cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv c1 vy
      cv cmin co vx cv cc0 c1 cicc co wcel vx cv vs cv cc0 c1 cicc co wcel vt
      cv vs cv wceq wa vs vt copab cfv vx cv wceq vy cv cc0 c1 cicc co wcel vs
      vt vx cv vs cv vx cv cc0 c1 cicc co vs cv cc0 c1 cicc co wcel vt cv vs cv
      wceq wa vs vt copab vs cv vx cv wceq id vs cv cc0 c1 cicc co wcel vt cv
      vs cv wceq wa vs vt copab eqid vx visset fvopab4 adantr vy cv cc0 c1 cicc
      co wcel vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs
      vt copab cfv c1 vy cv cmin co wceq vx cv cc0 c1 cicc co wcel vs vt vy cv
      c1 vs cv cmin co c1 vy cv cmin co cc0 c1 cicc co vs cv cc0 c1 cicc co
      wcel vt cv c1 vs cv cmin co wceq wa vs vt copab vs cv vy cv c1 cmin
      opreq2 vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab eqid c1 vy cv cmin oprex fvopab4 adantl opeq12d eqeq2d pm5.32i
      oprabbii cK vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv
      vx cv c1 vy cv cmin co cH co wceq wa vx vy vz copab2 vx cv cc0 c1 cicc co
      wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv c1 vy cv cmin co cop cH cfv
      wceq wa vx vy vz copab2 phtpycom.1 vx cv cc0 c1 cicc co wcel vy cv cc0 c1
      cicc co wcel wa vz cv vx cv c1 vy cv cmin co cH co wceq wa vx cv cc0 c1
      cicc co wcel vy cv cc0 c1 cicc co wcel wa vz cv vx cv c1 vy cv cmin co
      cop cH cfv wceq wa vx vy vz vz cv vx cv c1 vy cv cmin co cH co wceq vz cv
      vx cv c1 vy cv cmin co cop cH cfv wceq vx cv cc0 c1 cicc co wcel vy cv
      cc0 c1 cicc co wcel wa vx cv c1 vy cv cmin co cH co vx cv c1 vy cv cmin
      co cop cH cfv vz cv vx cv c1 vy cv cmin co cH df-opr eqeq2i anbi2i
      oprabbii eqtri oprabco 3syl cii cii ctx co ctop wcel cii cii ctx co ctop
      wcel cJ ctop wcel w3a vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel
      wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab
      cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab cfv cop wceq wa vx vy vw copab2 cii cii ctx co cii cii ctx co ccn
      co wcel cH cii cii ctx co cJ ccn co wcel wa cH vx cv cc0 c1 cicc co wcel
      vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv
      vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs
      cv cmin co wceq wa vs vt copab cfv cop wceq wa vx vy vw copab2 ccom cii
      cii ctx co cJ ccn co wcel cJ ctop wcel cH cii cii ctx co cJ ccn co wcel
      wa vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs
      cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab cfv vy cv vs cv
      cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv cop
      wceq wa vx vy vw copab2 cH cii cii ctx co cii cii ctx co cJ cnco cJ ctop
      wcel cH cii cii ctx co cJ ccn co wcel wa cii cii ctx co ctop wcel cii cii
      ctx co ctop wcel cJ ctop wcel cii cii ctx co ctop wcel cJ ctop wcel cH
      cii cii ctx co cJ ccn co wcel wa cii ctop wcel cii ctop wcel cii cii ctx
      co ctop wcel iitop iitop cii cii cii cii ctx co cii cii ctx co eqid txtop
      mp2an a1i cii cii ctx co ctop wcel cJ ctop wcel cH cii cii ctx co cJ ccn
      co wcel wa cii ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop
      iitop cii cii cii cii ctx co cii cii ctx co eqid txtop mp2an a1i cJ ctop
      wcel cH cii cii ctx co cJ ccn co wcel pm3.26 3jca cJ ctop wcel cH cii cii
      ctx co cJ ccn co wcel wa cH cii cii ctx co cJ ccn co wcel vx cv cc0 c1
      cicc co wcel vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs cv cc0 c1 cicc
      co wcel vt cv vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc co
      wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv cop wceq wa vx vy vw
      copab2 cii cii ctx co cii cii ctx co ccn co wcel cJ ctop wcel cH cii cii
      ctx co cJ ccn co wcel pm3.27 cii ctop wcel cii ctop wcel wa cii ctop wcel
      cii ctop wcel wa vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt
      copab cii cii ccn co wcel vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin
      co wceq wa vs vt copab cii cii ccn co wcel wa vx cv cc0 c1 cicc co wcel
      vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv
      vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs
      cv cmin co wceq wa vs vt copab cfv cop wceq wa vx vy vw copab2 cii cii
      ctx co cii cii ctx co ccn co wcel cii ctop wcel cii ctop wcel iitop iitop
      pm3.2i cii ctop wcel cii ctop wcel iitop iitop pm3.2i vs cv cc0 c1 cicc
      co wcel vt cv vs cv wceq wa vs vt copab cii cii ccn co wcel vs cv cc0 c1
      cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cii cii ccn co
      wcel vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab cid cc0 c1
      cicc co cres cii cii ccn co cid cc0 c1 cicc co cres vt cv vs cv wceq vs
      vt copab cc0 c1 cicc co cres vs cv cc0 c1 cicc co wcel vt cv vs cv wceq
      wa vs vt copab cid vt cv vs cv wceq vs vt copab wceq cid cc0 c1 cicc co
      cres vt cv vs cv wceq vs vt copab cc0 c1 cicc co cres wceq cid vs cv vt
      cv wceq vs vt copab vt cv vs cv wceq vs vt copab vs vt df-id vs cv vt cv
      wceq vt cv vs cv wceq vs vt vs vt equcom opabbii eqtri cid vt cv vs cv
      wceq vs vt copab cc0 c1 cicc co reseq1 ax-mp vt cv vs cv wceq vs vt cc0
      c1 cicc co resopab eqtr2i cii ctop wcel cid cc0 c1 cicc co cres cii cii
      ccn co wcel iitop cii cc0 c1 cicc co cii cuni cc0 c1 cicc co iiuni eqcomi
      idcn ax-mp eqeltri vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq
      wa vs vt copab cc0 c1 cicc co cc0 c1 cicc co ccncf co cii cii ccn co cc0
      c1 cicc co cc wss cc cc wss cc0 c1 cicc co cc wss w3a vw cv vs cv cc0 c1
      cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv cc0 c1 cicc
      co wcel vw cc0 c1 cicc co wral wa vs cv cc0 c1 cicc co wcel vt cv c1 vs
      cv cmin co wceq wa vs vt copab cc0 c1 cicc co cc ccncf co wcel vs cv cc0
      c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cc0 c1 cicc co
      cc0 c1 cicc co ccncf co wcel cc0 c1 cicc co cc wss cc cc wss cc0 c1 cicc
      co cc wss w3a vw cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq
      wa vs vt copab cfv cc0 c1 cicc co wcel vw cc0 c1 cicc co wral cc0 c1 cicc
      co cc wss cc cc wss cc0 c1 cicc co cc wss cc0 c1 cicc co cr cc cc0 cr
      wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an
      axresscn sstri cc ssid cc0 c1 cicc co cr cc cc0 cr wcel c1 cr wcel cc0 c1
      cicc co cr wss 0re 1re cc0 c1 iccssre mp2an axresscn sstri 3pm3.2i vw cv
      vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv
      cc0 c1 cicc co wcel vw cc0 c1 cicc co vw cv cc0 c1 cicc co wcel vw cv vs
      cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv c1
      vw cv cmin co cc0 c1 cicc co vs vt vw cv c1 vs cv cmin co c1 vw cv cmin
      co cc0 c1 cicc co vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq
      wa vs vt copab vs cv vw cv c1 cmin opreq2 vs cv cc0 c1 cicc co wcel vt cv
      c1 vs cv cmin co wceq wa vs vt copab eqid c1 vw cv cmin oprex fvopab4 vw
      cv iirev eqeltrd rgen pm3.2i vs cv cc wcel vt cv c1 vs cv cmin co wceq wa
      vs vt copab cc0 c1 cicc co cres vs cv cc0 c1 cicc co wcel vt cv c1 vs cv
      cmin co wceq wa vs vt copab cc0 c1 cicc co cc ccncf co cc0 c1 cicc co cc
      wss vs cv cc wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cc0 c1 cicc
      co cres vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab wceq cc0 c1 cicc co cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr
      wss 0re 1re cc0 c1 iccssre mp2an axresscn sstri vt cv c1 vs cv cmin co
      wceq vs vt cc0 c1 cicc co cc resopab2 ax-mp vs cv cc wcel vt cv c1 vs cv
      cmin co wceq wa vs vt copab cc cc ccncf co wcel vs cv cc wcel vt cv c1 vs
      cv cmin co wceq wa vs vt copab cc0 c1 cicc co cres cc0 c1 cicc co cc
      ccncf co wcel c1 cc wcel vs cv cc wcel vt cv c1 vs cv cmin co wceq wa vs
      vt copab cc cc ccncf co wcel ax1cn vs vt c1 vs cv cc wcel vt cv c1 vs cv
      cmin co wceq wa vs vt copab vs cv cc wcel vt cv c1 vs cv cmin co wceq wa
      vs vt copab eqid sub2cncf ax-mp cc cc wss cc cc wss cc0 c1 cicc co cc wss
      vs cv cc wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cc cc ccncf co
      wcel vs cv cc wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cc0 c1 cicc
      co cres cc0 c1 cicc co cc ccncf co wcel wi cc ssid cc ssid cc0 c1 cicc co
      cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre
      mp2an axresscn sstri cc cc cc0 c1 cicc co vs cv cc wcel vt cv c1 vs cv
      cmin co wceq wa vs vt copab rescncf mp3an ax-mp eqeltrri vw cc0 c1 cicc
      co cc cc0 c1 cicc co vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co
      wceq wa vs vt copab cncffvrn mp2 cc0 c1 cicc co cc wss cc0 c1 cicc co cc
      wss cc0 c1 cicc co cc0 c1 cicc co ccncf co cii cii ccn co wceq cc0 c1
      cicc co cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1
      iccssre mp2an axresscn sstri cc0 c1 cicc co cr cc cc0 cr wcel c1 cr wcel
      cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an axresscn sstri cc0 c1
      cicc co cc0 c1 cicc co cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp
      cres cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cii cii cabs
      cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres eqid cabs cmin ccom cc0
      c1 cicc co cc0 c1 cicc co cxp cres eqid df-ii df-ii cncfmet mp2an eleqtri
      pm3.2i vx vy vw cii cii cii cii ctx co vs cv cc0 c1 cicc co wcel vt cv vs
      cv wceq wa vs vt copab vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co
      wceq wa vs vt copab vx cv cc0 c1 cicc co wcel vy cv cc0 c1 cicc co wcel
      wa vw cv vx cv vs cv cc0 c1 cicc co wcel vt cv vs cv wceq wa vs vt copab
      cfv vy cv vs cv cc0 c1 cicc co wcel vt cv c1 vs cv cmin co wceq wa vs vt
      copab cfv cop wceq wa vx vy vw copab2 cii cii cii cii ctx co cc0 c1 cicc
      co cc0 c1 cicc co cii cii ctx co eqid cii cii ctx co eqid cii cuni cc0 c1
      cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi vx cv cc0 c1
      cicc co wcel vy cv cc0 c1 cicc co wcel wa vw cv vx cv vs cv cc0 c1 cicc
      co wcel vt cv vs cv wceq wa vs vt copab cfv vy cv vs cv cc0 c1 cicc co
      wcel vt cv c1 vs cv cmin co wceq wa vs vt copab cfv cop wceq wa vx vy vw
      copab2 eqid 2txcn mp3an jctil sylanc eqeltrd 3ad2antl1 ad2ant2r cc0 cF
      cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vs cv cc0 cH co vs cv cF
      cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv
      wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral vt cv cc0
      cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 vt cv cK
      co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa vt cc0 c1 cicc co
      wral cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cH cii
      cii ctx co cJ ccn co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv
      wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral wa vt cv cc0 cK co vt cv cG cfv wceq vt cv c1
      cK co vt cv cF cfv wceq wa cc0 vt cv cK co cc0 cG cfv wceq c1 vt cv cK co
      c1 cG cfv wceq wa wa vt cc0 c1 cicc co cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs
      cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF
      cfv wceq wa wa vs cc0 c1 cicc co wral vt cv cc0 c1 cicc co wcel vt cv cc0
      cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 vt cv cK
      co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa cc0 cF cfv cc0 cG
      cfv wceq c1 cF cfv c1 cG cfv wceq wa vt cv cc0 c1 cicc co wcel vs cv cc0
      cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH
      co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co
      wral vt cv cc0 cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq
      wa cc0 vt cv cK co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa
      cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vt cv cc0 c1 cicc
      co wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv
      wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa vt cv cc0 cK co vt cv cG cfv wceq vt cv
      c1 cK co vt cv cF cfv wceq wa cc0 vt cv cK co cc0 cG cfv wceq c1 vt cv cK
      co c1 cG cfv wceq wa vt cv cc0 c1 cicc co wcel vs cv cc0 cH co vs cv cF
      cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv
      wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral wa vt cv
      cc0 cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 cF
      cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vt cv cc0 c1 cicc co wcel
      vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0
      vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1
      cicc co wral wa vt cv cc0 c1 cicc co wcel vt cv cc0 cH co vt cv cF cfv
      wceq vt cv c1 cH co vt cv cG cfv wceq wa cc0 vt cv cH co cc0 cF cfv wceq
      c1 vt cv cH co c1 cF cfv wceq wa wa wa vt cv cc0 cK co vt cv cG cfv wceq
      vt cv c1 cK co vt cv cF cfv wceq wa vt cv cc0 c1 cicc co wcel vs cv cc0
      cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH
      co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co
      wral vt cv cc0 cH co vt cv cF cfv wceq vt cv c1 cH co vt cv cG cfv wceq
      wa cc0 vt cv cH co cc0 cF cfv wceq c1 vt cv cH co c1 cF cfv wceq wa wa vs
      cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs
      cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa vt cv cc0 cH
      co vt cv cF cfv wceq vt cv c1 cH co vt cv cG cfv wceq wa cc0 vt cv cH co
      cc0 cF cfv wceq c1 vt cv cH co c1 cF cfv wceq wa wa vs vt cv cc0 c1 cicc
      co vs cv vt cv wceq vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co vs
      cv cG cfv wceq wa vt cv cc0 cH co vt cv cF cfv wceq vt cv c1 cH co vt cv
      cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv
      wceq wa cc0 vt cv cH co cc0 cF cfv wceq c1 vt cv cH co c1 cF cfv wceq wa
      vs cv vt cv wceq vs cv cc0 cH co vs cv cF cfv wceq vt cv cc0 cH co vt cv
      cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq vt cv c1 cH co vt cv cG cfv
      wceq vs cv vt cv wceq vs cv cc0 cH co vt cv cc0 cH co vs cv cF cfv vt cv
      cF cfv vs cv vt cv cc0 cH opreq1 vs cv vt cv cF fveq2 eqeq12d vs cv vt cv
      wceq vs cv c1 cH co vt cv c1 cH co vs cv cG cfv vt cv cG cfv vs cv vt cv
      c1 cH opreq1 vs cv vt cv cG fveq2 eqeq12d anbi12d vs cv vt cv wceq cc0 vs
      cv cH co cc0 cF cfv wceq cc0 vt cv cH co cc0 cF cfv wceq c1 vs cv cH co
      c1 cF cfv wceq c1 vt cv cH co c1 cF cfv wceq vs cv vt cv wceq cc0 vs cv
      cH co cc0 vt cv cH co cc0 cF cfv vs cv vt cv cc0 cH opreq2 eqeq1d vs cv
      vt cv wceq c1 vs cv cH co c1 vt cv cH co c1 cF cfv vs cv vt cv c1 cH
      opreq2 eqeq1d anbi12d anbi12d rcla4v imdistani vt cv cc0 c1 cicc co wcel
      vt cv cc0 cH co vt cv cF cfv wceq vt cv c1 cH co vt cv cG cfv wceq wa vt
      cv cc0 cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0 vt
      cv cH co cc0 cF cfv wceq c1 vt cv cH co c1 cF cfv wceq wa vt cv cc0 c1
      cicc co wcel vt cv c1 cH co vt cv cG cfv wceq vt cv cc0 cH co vt cv cF
      cfv wceq vt cv cc0 cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv
      wceq wa vt cv cc0 c1 cicc co wcel vt cv cc0 cK co vt cv cG cfv wceq vt cv
      c1 cK co vt cv cF cfv wceq wa vt cv c1 cH co vt cv cG cfv wceq vt cv cc0
      cH co vt cv cF cfv wceq wa vt cv cc0 c1 cicc co wcel vt cv cc0 cK co vt
      cv cG cfv wceq vt cv c1 cH co vt cv cG cfv wceq vt cv c1 cK co vt cv cF
      cfv wceq vt cv cc0 cH co vt cv cF cfv wceq vt cv cc0 c1 cicc co wcel vt
      cv cc0 cK co vt cv c1 cH co vt cv cG cfv vt cv cc0 c1 cicc co wcel vt cv
      cc0 cK co vt cv c1 cc0 cmin co cH co vt cv c1 cH co vt cv cc0 c1 cicc co
      wcel cc0 cc0 c1 cicc co wcel vt cv cc0 cK co vt cv c1 cc0 cmin co cH co
      wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr cc0 cc0 c1 cicc co wcel 0re
      1re cc0 c1 0re 1re lt01 ltleii cc0 c1 lbicc2 mp3an vx vy vz vt cv cc0 cc0
      c1 cicc co cc0 c1 cicc co vx cv c1 vy cv cmin co cH co vt cv c1 cc0 cmin
      co cH co cK vt cv c1 vy cv cmin co cH co vt cv c1 cc0 cmin co cH oprex vx
      cv vt cv c1 vy cv cmin co cH opreq1 vy cv cc0 wceq c1 vy cv cmin co c1
      cc0 cmin co vt cv cH vy cv cc0 c1 cmin opreq2 opreq2d phtpycom.1
      oprabval2 mpan2 c1 cc0 cmin co c1 vt cv cH c1 ax1cn subid1i opreq2i
      syl6eq eqeq1d vt cv cc0 c1 cicc co wcel vt cv c1 cK co vt cv cc0 cH co vt
      cv cF cfv vt cv cc0 c1 cicc co wcel vt cv c1 cK co vt cv c1 c1 cmin co cH
      co vt cv cc0 cH co vt cv cc0 c1 cicc co wcel c1 cc0 c1 cicc co wcel vt cv
      c1 cK co vt cv c1 c1 cmin co cH co wceq cc0 cr wcel c1 cr wcel cc0 c1 cle
      wbr c1 cc0 c1 cicc co wcel 0re 1re cc0 c1 0re 1re lt01 ltleii cc0 c1
      ubicc2 mp3an vx vy vz vt cv c1 cc0 c1 cicc co cc0 c1 cicc co vx cv c1 vy
      cv cmin co cH co vt cv c1 c1 cmin co cH co cK vt cv c1 vy cv cmin co cH
      co vt cv c1 c1 cmin co cH oprex vx cv vt cv c1 vy cv cmin co cH opreq1 vy
      cv c1 wceq c1 vy cv cmin co c1 c1 cmin co vt cv cH vy cv c1 c1 cmin
      opreq2 opreq2d phtpycom.1 oprabval2 mpan2 c1 c1 cmin co cc0 vt cv cH c1
      ax1cn subidi opreq2i syl6eq eqeq1d anbi12d biimpar ancom2s adantrr syl
      adantl cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vt cv cc0
      c1 cicc co wcel c1 vt cv cmin co cc0 cH co c1 vt cv cmin co cF cfv wceq
      c1 vt cv cmin co c1 cH co c1 vt cv cmin co cG cfv wceq wa cc0 c1 vt cv
      cmin co cH co cc0 cF cfv wceq c1 c1 vt cv cmin co cH co c1 cF cfv wceq wa
      wa wa cc0 vt cv cK co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa vt
      cv cc0 c1 cicc co wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co
      vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF
      cfv wceq wa wa vs cc0 c1 cicc co wral wa cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa vt cv cc0 c1 cicc co wcel c1 vt cv cmin co cc0 cH
      co c1 vt cv cmin co cF cfv wceq c1 vt cv cmin co c1 cH co c1 vt cv cmin
      co cG cfv wceq wa cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq wa wa cc0 vt cv cK co cc0 cG cfv wceq c1 vt
      cv cK co c1 cG cfv wceq wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa vt cv cc0 c1 cicc co wcel wa cc0 c1 vt cv cmin co cH co cc0 cF
      cfv wceq c1 c1 vt cv cmin co cH co c1 cF cfv wceq wa cc0 vt cv cK co cc0
      cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa c1 vt cv cmin co cc0 cH co
      c1 vt cv cmin co cF cfv wceq c1 vt cv cmin co c1 cH co c1 vt cv cmin co
      cG cfv wceq wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vt
      cv cc0 c1 cicc co wcel wa cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq c1
      c1 vt cv cmin co cH co c1 cF cfv wceq wa wa cc0 vt cv cK co cc0 cG cfv
      wceq c1 vt cv cK co c1 cG cfv wceq cc0 cF cfv cc0 cG cfv wceq vt cv cc0
      c1 cicc co wcel cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq wa cc0 vt cv cK co cc0 cG cfv wceq c1 cF cfv
      c1 cG cfv wceq cc0 cF cfv cc0 cG cfv wceq vt cv cc0 c1 cicc co wcel wa
      cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq cc0 vt cv cK co cc0 cG cfv
      wceq c1 c1 vt cv cmin co cH co c1 cF cfv wceq cc0 cF cfv cc0 cG cfv wceq
      vt cv cc0 c1 cicc co wcel wa cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq
      wa cc0 vt cv cK co cc0 c1 vt cv cmin co cH co cc0 cG cfv vt cv cc0 c1
      cicc co wcel cc0 vt cv cK co cc0 c1 vt cv cmin co cH co wceq cc0 cF cfv
      cc0 cG cfv wceq cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq cc0 cc0 c1
      cicc co wcel vt cv cc0 c1 cicc co wcel cc0 vt cv cK co cc0 c1 vt cv cmin
      co cH co wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr cc0 cc0 c1 cicc co
      wcel 0re 1re cc0 c1 0re 1re lt01 ltleii cc0 c1 lbicc2 mp3an vx vy vz cc0
      vt cv cc0 c1 cicc co cc0 c1 cicc co vx cv c1 vy cv cmin co cH co cc0 c1
      vt cv cmin co cH co cK cc0 c1 vy cv cmin co cH co cc0 c1 vt cv cmin co cH
      oprex vx cv cc0 c1 vy cv cmin co cH opreq1 vy cv vt cv wceq c1 vy cv cmin
      co c1 vt cv cmin co cc0 cH vy cv vt cv c1 cmin opreq2 opreq2d phtpycom.1
      oprabval2 mpan ad2antlr cc0 cF cfv cc0 cG cfv wceq cc0 c1 vt cv cmin co
      cH co cc0 cF cfv wceq cc0 c1 vt cv cmin co cH co cc0 cG cfv wceq vt cv
      cc0 c1 cicc co wcel cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq cc0 cF cfv
      cc0 cG cfv wceq cc0 c1 vt cv cmin co cH co cc0 cG cfv wceq cc0 c1 vt cv
      cmin co cH co cc0 cF cfv cc0 cG cfv eqtr ancoms adantlr eqtrd adantrr
      adantllr c1 cF cfv c1 cG cfv wceq vt cv cc0 c1 cicc co wcel cc0 c1 vt cv
      cmin co cH co cc0 cF cfv wceq c1 c1 vt cv cmin co cH co c1 cF cfv wceq wa
      c1 vt cv cK co c1 cG cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG
      cfv wceq vt cv cc0 c1 cicc co wcel wa c1 c1 vt cv cmin co cH co c1 cF cfv
      wceq c1 vt cv cK co c1 cG cfv wceq cc0 c1 vt cv cmin co cH co cc0 cF cfv
      wceq c1 cF cfv c1 cG cfv wceq vt cv cc0 c1 cicc co wcel wa c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq wa c1 vt cv cK co c1 c1 vt cv cmin co cH co
      c1 cG cfv vt cv cc0 c1 cicc co wcel c1 vt cv cK co c1 c1 vt cv cmin co cH
      co wceq c1 cF cfv c1 cG cfv wceq c1 c1 vt cv cmin co cH co c1 cF cfv wceq
      c1 cc0 c1 cicc co wcel vt cv cc0 c1 cicc co wcel c1 vt cv cK co c1 c1 vt
      cv cmin co cH co wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr c1 cc0 c1
      cicc co wcel 0re 1re cc0 c1 0re 1re lt01 ltleii cc0 c1 ubicc2 mp3an vx vy
      vz c1 vt cv cc0 c1 cicc co cc0 c1 cicc co vx cv c1 vy cv cmin co cH co c1
      c1 vt cv cmin co cH co cK c1 c1 vy cv cmin co cH co c1 c1 vt cv cmin co
      cH oprex vx cv c1 c1 vy cv cmin co cH opreq1 vy cv vt cv wceq c1 vy cv
      cmin co c1 vt cv cmin co c1 cH vy cv vt cv c1 cmin opreq2 opreq2d
      phtpycom.1 oprabval2 mpan ad2antlr c1 cF cfv c1 cG cfv wceq c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq c1 c1 vt cv cmin co cH co c1 cG cfv wceq vt
      cv cc0 c1 cicc co wcel c1 c1 vt cv cmin co cH co c1 cF cfv wceq c1 cF cfv
      c1 cG cfv wceq c1 c1 vt cv cmin co cH co c1 cG cfv wceq c1 c1 vt cv cmin
      co cH co c1 cF cfv c1 cG cfv eqtr ancoms adantlr eqtrd adantrl adantlll
      jca adantrl anasss vt cv cc0 c1 cicc co wcel vs cv cc0 cH co vs cv cF cfv
      wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq
      c1 vs cv cH co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral c1 vt cv cmin
      co cc0 cH co c1 vt cv cmin co cF cfv wceq c1 vt cv cmin co c1 cH co c1 vt
      cv cmin co cG cfv wceq wa cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq c1
      c1 vt cv cmin co cH co c1 cF cfv wceq wa wa vt cv cc0 c1 cicc co wcel c1
      vt cv cmin co cc0 c1 cicc co wcel vs cv cc0 cH co vs cv cF cfv wceq vs cv
      c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF cfv wceq c1 vs cv cH
      co c1 cF cfv wceq wa wa vs cc0 c1 cicc co wral c1 vt cv cmin co cc0 cH co
      c1 vt cv cmin co cF cfv wceq c1 vt cv cmin co c1 cH co c1 vt cv cmin co
      cG cfv wceq wa cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq wa wa wi vt cv iirev vs cv cc0 cH co vs cv
      cF cfv wceq vs cv c1 cH co vs cv cG cfv wceq wa cc0 vs cv cH co cc0 cF
      cfv wceq c1 vs cv cH co c1 cF cfv wceq wa wa c1 vt cv cmin co cc0 cH co
      c1 vt cv cmin co cF cfv wceq c1 vt cv cmin co c1 cH co c1 vt cv cmin co
      cG cfv wceq wa cc0 c1 vt cv cmin co cH co cc0 cF cfv wceq c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq wa wa vs c1 vt cv cmin co cc0 c1 cicc co vs
      cv c1 vt cv cmin co wceq vs cv cc0 cH co vs cv cF cfv wceq vs cv c1 cH co
      vs cv cG cfv wceq wa c1 vt cv cmin co cc0 cH co c1 vt cv cmin co cF cfv
      wceq c1 vt cv cmin co c1 cH co c1 vt cv cmin co cG cfv wceq wa cc0 vs cv
      cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq wa cc0 c1 vt cv cmin
      co cH co cc0 cF cfv wceq c1 c1 vt cv cmin co cH co c1 cF cfv wceq wa vs
      cv c1 vt cv cmin co wceq vs cv cc0 cH co vs cv cF cfv wceq c1 vt cv cmin
      co cc0 cH co c1 vt cv cmin co cF cfv wceq vs cv c1 cH co vs cv cG cfv
      wceq c1 vt cv cmin co c1 cH co c1 vt cv cmin co cG cfv wceq vs cv c1 vt
      cv cmin co wceq vs cv cc0 cH co c1 vt cv cmin co cc0 cH co vs cv cF cfv
      c1 vt cv cmin co cF cfv vs cv c1 vt cv cmin co cc0 cH opreq1 vs cv c1 vt
      cv cmin co cF fveq2 eqeq12d vs cv c1 vt cv cmin co wceq vs cv c1 cH co c1
      vt cv cmin co c1 cH co vs cv cG cfv c1 vt cv cmin co cG cfv vs cv c1 vt
      cv cmin co c1 cH opreq1 vs cv c1 vt cv cmin co cG fveq2 eqeq12d anbi12d
      vs cv c1 vt cv cmin co wceq cc0 vs cv cH co cc0 cF cfv wceq cc0 c1 vt cv
      cmin co cH co cc0 cF cfv wceq c1 vs cv cH co c1 cF cfv wceq c1 c1 vt cv
      cmin co cH co c1 cF cfv wceq vs cv c1 vt cv cmin co wceq cc0 vs cv cH co
      cc0 c1 vt cv cmin co cH co cc0 cF cfv vs cv c1 vt cv cmin co cc0 cH
      opreq2 eqeq1d vs cv c1 vt cv cmin co wceq c1 vs cv cH co c1 c1 vt cv cmin
      co cH co c1 cF cfv vs cv c1 vt cv cmin co c1 cH opreq2 eqeq1d anbi12d
      anbi12d rcla4v syl imdistani sylan2 jca ancom2s anassrs r19.21aiva
      ad2ant2l jca ex cF cG cH cJ vs isphtpy cJ ctop wcel cG cii cJ ccn co wcel
      cF cii cJ ccn co wcel w3a cc0 cG cfv cc0 cF cfv wceq c1 cG cfv c1 cF cfv
      wceq wa cK cG cF cJ cphtpy cfv co wcel cK cii cii ctx co cJ ccn co wcel
      vt cv cc0 cK co vt cv cG cfv wceq vt cv c1 cK co vt cv cF cfv wceq wa cc0
      vt cv cK co cc0 cG cfv wceq c1 vt cv cK co c1 cG cfv wceq wa wa vt cc0 c1
      cicc co wral wa wb cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cG cF cK
      cJ vt isphtpy cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel
      w3a cJ ctop wcel cG cii cJ ccn co wcel cF cii cJ ccn co wcel cJ ctop wcel
      cF cii cJ ccn co wcel cG cii cJ ccn co wcel 3simp1 cJ ctop wcel cF cii cJ
      ccn co wcel cG cii cJ ccn co wcel 3simp3 cJ ctop wcel cF cii cJ ccn co
      wcel cG cii cJ ccn co wcel 3simp2 3jca cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cF cfv wceq c1 cG cfv c1 cF cfv wceq
      wa cc0 cF cfv cc0 cG cfv wceq cc0 cG cfv cc0 cF cfv wceq c1 cF cfv c1 cG
      cfv wceq c1 cG cfv c1 cF cfv wceq cc0 cF cfv cc0 cG cfv eqcom c1 cF cfv
      c1 cG cfv eqcom anbi12i biimpi syl2an 3imtr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J r s t u v w x y z $. $d F r s t u v w x y z $.
    $d G r s t u v w x y z $. $d H r s t u v w x y z $. $d M r s t u v w $.
    $d K r s t u v w x y z $. $d L r s t u v w x y z $.
    $d X r s t u v w x y z $. $d Y r s t u v w x y z $.
    phtpyco.1 $e |- M = { <. <. x , y >. , z >. | ( ( x e. ( 0 [,] 1 ) /\
                      y e. ( 0 [,] 1 ) ) /\ z = if ( y <_ ( 1 / 2 ) ,
                      ( x K ( 2 x. y ) ) , ( x L ( ( 2 x. y ) - 1 ) ) ) ) } $.

    $( Lemma for ~ phtpyco . $)
    phtpycolem1 $p |- ( ( X e. ( 0 [,] 1 ) /\ Y e. ( 0 [,] ( 1 / 2 ) ) )
                                    -> ( X M Y ) = ( X K ( 2 x. Y ) ) ) $=
      cX cc0 c1 cicc co wcel cY cc0 c1 c2 cdiv co cicc co wcel wa cX cY cM co
      cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin
      co cL co cif cX c2 cY cmul co cK co cX cc0 c1 cicc co wcel cY cc0 c1 cicc
      co wcel cX cY cM co cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2
      cY cmul co c1 cmin co cL co cif wceq cY cc0 c1 c2 cdiv co cicc co wcel vx
      vy vz cX cY cc0 c1 cicc co cc0 c1 cicc co vy cv c1 c2 cdiv co cle wbr vx
      cv c2 vy cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL co cif cY
      c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co
      cL co cif cM vy cv c1 c2 cdiv co cle wbr cX c2 vy cv cmul co cK co cX c2
      vy cv cmul co c1 cmin co cL co cif cY c1 c2 cdiv co cle wbr cX c2 cY cmul
      co cK co cX c2 cY cmul co c1 cmin co cL co cX c2 cY cmul co cK oprex cX
      c2 cY cmul co c1 cmin co cL oprex ifex vx cv cX wceq vy cv c1 c2 cdiv co
      cle wbr vx cv c2 vy cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL
      co cif vy cv c1 c2 cdiv co cle wbr cX c2 vy cv cmul co cK co vx cv c2 vy
      cv cmul co c1 cmin co cL co cif vy cv c1 c2 cdiv co cle wbr cX c2 vy cv
      cmul co cK co cX c2 vy cv cmul co c1 cmin co cL co cif vx cv cX wceq vy
      cv c1 c2 cdiv co cle wbr vx cv c2 vy cv cmul co cK co cX c2 vy cv cmul co
      cK co vx cv c2 vy cv cmul co c1 cmin co cL co vx cv cX c2 vy cv cmul co
      cK opreq1 ifeq1d vx cv cX wceq vy cv c1 c2 cdiv co cle wbr vx cv c2 vy cv
      cmul co c1 cmin co cL co cX c2 vy cv cmul co c1 cmin co cL co cX c2 vy cv
      cmul co cK co vx cv cX c2 vy cv cmul co c1 cmin co cL opreq1 ifeq2d eqtrd
      vy cv cY wceq vy cv c1 c2 cdiv co cle wbr cY c1 c2 cdiv co cle wbr cX c2
      vy cv cmul co cK co cX c2 vy cv cmul co c1 cmin co cL co cX c2 cY cmul co
      cK co cX c2 cY cmul co c1 cmin co cL co vy cv cY c1 c2 cdiv co cle breq1
      vy cv cY wceq c2 vy cv cmul co c2 cY cmul co cX cK vy cv cY c2 cmul
      opreq2 opreq2d vy cv cY wceq c2 vy cv cmul co c1 cmin co c2 cY cmul co c1
      cmin co cX cL vy cv cY wceq c2 vy cv cmul co c2 cY cmul co c1 cmin vy cv
      cY c2 cmul opreq2 opreq1d opreq2d ifbieq12d phtpyco.1 oprabval2 cc0 c1 c2
      cdiv co cicc co cc0 c1 cicc co cY cc0 cr wcel c1 cr wcel wa cc0 cr wcel
      c1 c2 cdiv co cr wcel wa cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr wa cc0
      c1 c2 cdiv co cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re
      pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel 0re c2 2re 2ne0 rereccli pm3.2i
      cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr cc0 0re leidi c1 c2 cdiv co c1
      c2 2re 2ne0 rereccli 1re halflt1 ltleii pm3.2i cc0 c1 cc0 c1 c2 cdiv co
      iccss mp3an sseli sylan2 cY cc0 c1 c2 cdiv co cicc co wcel cY c1 c2 cdiv
      co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co cL co cif
      cX c2 cY cmul co cK co wceq cX cc0 c1 cicc co wcel cY cc0 c1 c2 cdiv co
      cicc co wcel cY c1 c2 cdiv co cle wbr cY c1 c2 cdiv co cle wbr cX c2 cY
      cmul co cK co cX c2 cY cmul co c1 cmin co cL co cif cX c2 cY cmul co cK
      co wceq cY cc0 c1 c2 cdiv co cicc co wcel cY cr wcel cc0 cY cle wbr cY c1
      c2 cdiv co cle wbr cY cc0 c1 c2 cdiv co cicc co wcel cY cr wcel cc0 cY
      cle wbr cY c1 c2 cdiv co cle wbr w3a cc0 cr wcel c1 c2 cdiv co cr wcel cY
      cc0 c1 c2 cdiv co cicc co wcel cY cr wcel cc0 cY cle wbr cY c1 c2 cdiv co
      cle wbr w3a wb 0re c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co cY elicc2 mp2an
      biimpi 3simp3d cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY
      cmul co c1 cmin co cL co iftrue syl adantl eqtrd $.
      $( [2-Sep-2009] $)

    $( Lemma for ~ phtpyco . $)
    phtpycolem2 $p |- ( ( A. w e. ( 0 [,] 1 ) ( w K 1 ) = ( w L 0 ) /\
                        X e. ( 0 [,] 1 ) /\ Y e. ( ( 1 / 2 ) [,] 1 ) ) ->
                                ( X M Y ) = ( X L ( ( 2 x. Y ) - 1 ) ) ) $=
      vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cX cc0 c1 cicc
      co wcel cY c1 c2 cdiv co c1 cicc co wcel w3a cX cY cM co cY c1 c2 cdiv co
      cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co cL co cif cX
      c2 cY cmul co c1 cmin co cL co cX cc0 c1 cicc co wcel cY c1 c2 cdiv co c1
      cicc co wcel cX cY cM co cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co
      cX c2 cY cmul co c1 cmin co cL co cif wceq vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral cX cc0 c1 cicc co wcel cY cc0 c1 cicc co wcel
      cX cY cM co cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul
      co c1 cmin co cL co cif wceq cY c1 c2 cdiv co c1 cicc co wcel vx vy vz cX
      cY cc0 c1 cicc co cc0 c1 cicc co vy cv c1 c2 cdiv co cle wbr vx cv c2 vy
      cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL co cif cY c1 c2
      cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co cL co
      cif cM vy cv c1 c2 cdiv co cle wbr cX c2 vy cv cmul co cK co cX c2 vy cv
      cmul co c1 cmin co cL co cif cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK
      co cX c2 cY cmul co c1 cmin co cL co cX c2 cY cmul co cK oprex cX c2 cY
      cmul co c1 cmin co cL oprex ifex vx cv cX wceq vy cv c1 c2 cdiv co cle
      wbr vx cv c2 vy cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL co
      cif vy cv c1 c2 cdiv co cle wbr cX c2 vy cv cmul co cK co vx cv c2 vy cv
      cmul co c1 cmin co cL co cif vy cv c1 c2 cdiv co cle wbr cX c2 vy cv cmul
      co cK co cX c2 vy cv cmul co c1 cmin co cL co cif vx cv cX wceq vy cv c1
      c2 cdiv co cle wbr vx cv c2 vy cv cmul co cK co cX c2 vy cv cmul co cK co
      vx cv c2 vy cv cmul co c1 cmin co cL co vx cv cX c2 vy cv cmul co cK
      opreq1 ifeq1d vx cv cX wceq vy cv c1 c2 cdiv co cle wbr vx cv c2 vy cv
      cmul co c1 cmin co cL co cX c2 vy cv cmul co c1 cmin co cL co cX c2 vy cv
      cmul co cK co vx cv cX c2 vy cv cmul co c1 cmin co cL opreq1 ifeq2d eqtrd
      vy cv cY wceq vy cv c1 c2 cdiv co cle wbr cY c1 c2 cdiv co cle wbr cX c2
      vy cv cmul co cK co cX c2 vy cv cmul co c1 cmin co cL co cX c2 cY cmul co
      cK co cX c2 cY cmul co c1 cmin co cL co vy cv cY c1 c2 cdiv co cle breq1
      vy cv cY wceq c2 vy cv cmul co c2 cY cmul co cX cK vy cv cY c2 cmul
      opreq2 opreq2d vy cv cY wceq c2 vy cv cmul co c1 cmin co c2 cY cmul co c1
      cmin co cX cL vy cv cY wceq c2 vy cv cmul co c2 cY cmul co c1 cmin vy cv
      cY c2 cmul opreq2 opreq1d opreq2d ifbieq12d phtpyco.1 oprabval2 c1 c2
      cdiv co c1 cicc co cc0 c1 cicc co cY cc0 cr wcel c1 cr wcel wa c1 c2 cdiv
      co cr wcel c1 cr wcel wa cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr wa c1 c2
      cdiv co c1 cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re
      pm3.2i c1 c2 cdiv co cr wcel c1 cr wcel c2 2re 2ne0 rereccli 1re pm3.2i
      cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0
      rereccli halfgt0 ltleii c1 1re leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss
      mp3an sseli sylan2 3adant1 vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1
      cicc co wral cX cc0 c1 cicc co wcel cY c1 c2 cdiv co c1 cicc co wcel cY
      c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co
      cL co cif cX c2 cY cmul co c1 cmin co cL co wceq cX c1 cK co cX cc0 cL co
      wceq cY c1 c2 cdiv co cle wbr wn cY c1 c2 cdiv co wceq wo cY c1 c2 cdiv
      co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co cL co cif
      cX c2 cY cmul co c1 cmin co cL co wceq vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral cX cc0 c1 cicc co wcel wa cY c1 c2 cdiv co c1
      cicc co wcel cX c1 cK co cX cc0 cL co wceq cY c1 c2 cdiv co cle wbr wn cY
      c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co
      cL co cif cX c2 cY cmul co c1 cmin co cL co wceq cY c1 c2 cdiv co wceq cY
      c1 c2 cdiv co cle wbr wn cY c1 c2 cdiv co cle wbr cX c2 cY cmul co cK co
      cX c2 cY cmul co c1 cmin co cL co cif cX c2 cY cmul co c1 cmin co cL co
      wceq cX c1 cK co cX cc0 cL co wceq cY c1 c2 cdiv co cle wbr cX c2 cY cmul
      co cK co cX c2 cY cmul co c1 cmin co cL co iffalse adantl cX c1 cK co cX
      cc0 cL co wceq cY c1 c2 cdiv co wceq wa cY c1 c2 cdiv co cle wbr cX c2 cY
      cmul co cK co cX c2 cY cmul co c1 cmin co cL co cif cX c2 cY cmul co cK
      co cX c2 cY cmul co c1 cmin co cL co cY c1 c2 cdiv co wceq cY c1 c2 cdiv
      co cle wbr cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co cL co cif
      cX c2 cY cmul co cK co wceq cX c1 cK co cX cc0 cL co wceq cY c1 c2 cdiv
      co wceq cY c1 c2 cdiv co cle wbr cY c1 c2 cdiv co cle wbr cX c2 cY cmul
      co cK co cX c2 cY cmul co c1 cmin co cL co cif cX c2 cY cmul co cK co
      wceq cY c1 c2 cdiv co wceq cY c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 c2
      cdiv co cle wbr c1 c2 cdiv co c2 2re 2ne0 rereccli leidi cY c1 c2 cdiv co
      c1 c2 cdiv co cle breq1 mpbiri cY c1 c2 cdiv co cle wbr cX c2 cY cmul co
      cK co cX c2 cY cmul co c1 cmin co cL co iftrue syl adantl cY c1 c2 cdiv
      co wceq cX c2 cY cmul co cK co cX c2 cY cmul co c1 cmin co cL co wceq cX
      c1 cK co cX cc0 cL co wceq cY c1 c2 cdiv co wceq cX c2 cY cmul co cK co
      cX c1 cK co cX c2 cY cmul co c1 cmin co cL co cX cc0 cL co cY c1 c2 cdiv
      co wceq c2 cY cmul co c1 cX cK cY c1 c2 cdiv co wceq c2 cY cmul co c2 c1
      c2 cdiv co cmul co c1 cY c1 c2 cdiv co c2 cmul opreq2 c2 2cn 2ne0 recidi
      syl6eq opreq2d cY c1 c2 cdiv co wceq c2 cY cmul co c1 cmin co cc0 cX cL
      cY c1 c2 cdiv co wceq c2 cY cmul co c1 cmin co c2 c1 c2 cdiv co cmul co
      c1 cmin co cc0 cY c1 c2 cdiv co wceq c2 cY cmul co c2 c1 c2 cdiv co cmul
      co c1 cmin cY c1 c2 cdiv co c2 cmul opreq2 opreq1d c2 c1 c2 cdiv co cmul
      co c1 cmin co c1 c1 cmin co cc0 c2 c1 c2 cdiv co cmul co c1 c1 cmin c2
      2cn 2ne0 recidi opreq1i c1 ax1cn subidi eqtri syl6eq opreq2d eqeq12d
      biimparc eqtrd jaodan vw cv c1 cK co vw cv cc0 cL co wceq cX c1 cK co cX
      cc0 cL co wceq vw cX cc0 c1 cicc co vw cv cX wceq vw cv c1 cK co cX c1 cK
      co vw cv cc0 cL co cX cc0 cL co vw cv cX c1 cK opreq1 vw cv cX cc0 cL
      opreq1 eqeq12d rcla4cva cY c1 c2 cdiv co c1 cicc co wcel cY cr wcel c1 c2
      cdiv co cY cle wbr cY c1 cle wbr w3a cY c1 c2 cdiv co cle wbr wn cY c1 c2
      cdiv co wceq wo c1 c2 cdiv co cr wcel c1 cr wcel cY c1 c2 cdiv co c1 cicc
      co wcel cY cr wcel c1 c2 cdiv co cY cle wbr cY c1 cle wbr w3a wb c2 2re
      2ne0 rereccli 1re c1 c2 cdiv co c1 cY elicc2 mp2an cY cr wcel c1 c2 cdiv
      co cY cle wbr cY c1 c2 cdiv co cle wbr wn cY c1 c2 cdiv co wceq wo cY c1
      cle wbr cY cr wcel c1 c2 cdiv co cY cle wbr wa c1 c2 cdiv co cY clt wbr
      c1 c2 cdiv co cY wceq wo cY c1 c2 cdiv co cle wbr wn cY c1 c2 cdiv co
      wceq wo cY cr wcel c1 c2 cdiv co cY cle wbr c1 c2 cdiv co cY clt wbr c1
      c2 cdiv co cY wceq wo c1 c2 cdiv co cr wcel cY cr wcel c1 c2 cdiv co cY
      cle wbr c1 c2 cdiv co cY clt wbr c1 c2 cdiv co cY wceq wo wb c2 2re 2ne0
      rereccli c1 c2 cdiv co cY leloe mpan biimpa cY cr wcel c1 c2 cdiv co cY
      cle wbr wa c1 c2 cdiv co cY clt wbr cY c1 c2 cdiv co cle wbr wn c1 c2
      cdiv co cY wceq cY c1 c2 cdiv co wceq cY cr wcel c1 c2 cdiv co cY clt wbr
      cY c1 c2 cdiv co cle wbr wn wb c1 c2 cdiv co cY cle wbr c1 c2 cdiv co cr
      wcel cY cr wcel c1 c2 cdiv co cY clt wbr cY c1 c2 cdiv co cle wbr wn wb
      c2 2re 2ne0 rereccli c1 c2 cdiv co cY ltnle mpan adantr c1 c2 cdiv co cY
      wceq cY c1 c2 cdiv co wceq wb cY cr wcel c1 c2 cdiv co cY cle wbr wa c1
      c2 cdiv co cY eqcom a1i orbi12d mpbid 3adant3 sylbi syl2an 3impa eqtrd $.
      $( [2-Sep-2009] $)

    $( Lemma for ~ phtpyco . $)
    phtpycolem3 $p |- ( ( J e. Top /\ K e. ( ( II tX II ) Cn J ) ) ->
            ( M |` ( ( 0 [,] 1 ) X. ( 0 [,] ( 1 / 2 ) ) ) ) e. ( ( subSp `
      <. ( ( 0 [,] 1 ) X. ( 0 [,] ( 1 / 2 ) ) ) , ( II tX II ) >. ) Cn J ) ) $=
      cJ ctop wcel cK cii cii ctx co cJ ccn co wcel wa cM cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co cxp cres cK vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2
      cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv
      wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv
      c2 vu cv cmul co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2 ccom
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co cop csubsp
      cfv cJ ccn co cJ ctop wcel cK cii cii ctx co cJ ccn co wcel wa cc0 c1
      cicc co cc0 c1 cicc co cxp cJ cuni cK wf cK cc0 c1 cicc co cc0 c1 cicc co
      cxp wfn cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cK vr cv cc0
      c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vt cv vr cv vu cv
      cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0
      c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv
      cop wceq wa vr vs vt copab2 ccom wceq cii cii ctx co ctop wcel cJ ctop
      wcel cK cii cii ctx co cJ ccn co wcel cc0 c1 cicc co cc0 c1 cicc co cxp
      cJ cuni cK wf cii ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop
      iitop cii cii cii cii ctx co cii cii ctx co eqid txtop mp2an cK cii cii
      ctx co cJ cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cii cii ctx co cuni
      cc0 c1 cicc co cc0 c1 cicc co cxp cii ctop wcel cii ctop wcel cii cii ctx
      co cuni cc0 c1 cicc co cc0 c1 cicc co cxp wceq iitop iitop cii cii cii
      cii ctx co cc0 c1 cicc co cc0 c1 cicc co cii cii ctx co eqid cii cuni cc0
      c1 cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi txuni mp2an
      eqcomi cJ cuni eqid cnf mp3an1 cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni
      cK ffn vr vs vt vu cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co vr cv c2 vs
      cv cmul co cop cc0 c1 cicc co cc0 c1 cicc co cxp vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1
      cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2
      cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cop
      wceq wa vr vs vt copab2 cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres cK vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa
      vr cv cc0 c1 cicc co wcel c2 vs cv cmul co cc0 c1 cicc co wcel wa vr cv
      c2 vs cv cmul co cop cc0 c1 cicc co cc0 c1 cicc co cxp wcel vs cv cc0 c1
      c2 cdiv co cicc co wcel c2 vs cv cmul co cc0 c1 cicc co wcel vr cv cc0 c1
      cicc co wcel vs cv iihalf1 anim2i vr cv c2 vs cv cmul co cc0 c1 cicc co
      cc0 c1 cicc co c2 vs cv cmul oprex opelxp sylibr vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1
      cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2
      cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cop
      wceq wa vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa
      vt cv vr cv c2 vs cv cmul co cop wceq wa vr vs vt vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1
      cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2
      cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cop
      wceq vt cv vr cv c2 vs cv cmul co cop wceq vr cv cc0 c1 cicc co wcel vs
      cv cc0 c1 c2 cdiv co cicc co wcel wa vr cv vu cv cc0 c1 cicc co wcel vv
      cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2 cdiv co cicc co
      wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cop vr cv c2 vs cv
      cmul co cop vt cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc
      co wcel wa vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv
      copab cfv vr cv vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv
      cmul co wceq wa vu vv copab cfv c2 vs cv cmul co vr cv cc0 c1 cicc co
      wcel vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cfv
      vr cv wceq vs cv cc0 c1 c2 cdiv co cicc co wcel vu vv vr cv vu cv vr cv
      cc0 c1 cicc co vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab
      vu cv vr cv wceq id vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv
      copab eqid vr visset fvopab4 adantr vs cv cc0 c1 c2 cdiv co cicc co wcel
      vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa
      vu vv copab cfv c2 vs cv cmul co wceq vr cv cc0 c1 cicc co wcel vu vv vs
      cv c2 vu cv cmul co c2 vs cv cmul co cc0 c1 c2 cdiv co cicc co vu cv cc0
      c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab vu
      cv vs cv c2 cmul opreq2 vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu
      cv cmul co wceq wa vu vv copab eqid c2 vs cv cmul oprex fvopab4 adantl
      opeq12d eqeq2d pm5.32i oprabbii cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co
      wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2
      wceq cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co cxp wceq vv cv cM cc0 c1 cicc co cc0 c1 c2 cdiv co
      cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv
      co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs
      vu copab2 cfv wceq vv cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp wral
      cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co cxp wfn vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2
      cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa
      vr vs vu copab2 cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp wfn cM cc0
      c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres vr cv cc0 c1 cicc co wcel
      vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop
      cK cfv wceq wa vr vs vu copab2 wceq cc0 c1 cicc co cc0 c1 c2 cdiv co cicc
      co cxp cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp wceq vv cv cM cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co
      cop cK cfv wceq wa vr vs vu copab2 cfv wceq vv cc0 c1 cicc co cc0 c1 c2
      cdiv co cicc co cxp wral wa wb cM cc0 c1 cicc co cc0 c1 cicc co cxp wfn
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cc0 c1 cicc co cc0 c1 cicc
      co cxp wss cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co cxp wfn vx vy vz cc0 c1 cicc co cc0 c1
      cicc co vy cv c1 c2 cdiv co cle wbr vx cv c2 vy cv cmul co cK co vx cv c2
      vy cv cmul co c1 cmin co cL co cif cM vy cv c1 c2 cdiv co cle wbr vx cv
      c2 vy cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL co vx cv c2
      vy cv cmul co cK oprex vx cv c2 vy cv cmul co c1 cmin co cL oprex ifex
      phtpyco.1 fnoprab2 cc0 c1 cicc co cc0 c1 cicc co wss cc0 c1 c2 cdiv co
      cicc co cc0 c1 cicc co wss cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp
      cc0 c1 cicc co cc0 c1 cicc co cxp wss cc0 c1 cicc co ssid cc0 cr wcel c1
      cr wcel wa cc0 cr wcel c1 c2 cdiv co cr wcel wa cc0 cc0 cle wbr c1 c2
      cdiv co c1 cle wbr wa cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co wss cc0 cr
      wcel c1 cr wcel 0re 1re pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel 0re c2
      2re 2ne0 rereccli pm3.2i cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr cc0 0re
      leidi c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1 ltleii pm3.2i cc0
      c1 cc0 c1 c2 cdiv co iccss mp3an cc0 c1 cicc co cc0 c1 cicc co cc0 c1 c2
      cdiv co cicc co cc0 c1 cicc co ssxp mp2an cc0 c1 cicc co cc0 c1 cicc co
      cxp cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cM fnssres mp2an vr vs
      vu cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co vr cv c2 vs cv cmul co cop cK
      cfv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu
      cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 vr cv c2 vs
      cv cmul co cop cK fvex vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co
      cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu
      copab2 eqid fnoprab2 vv cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cc0
      c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cM cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cres vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co
      cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu
      copab2 eqfnfv mp2an cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp eqid vv
      cv cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cfv vv cv vr cv
      cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv
      c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 cfv wceq vv cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co cxp vv cv cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp wcel vv cv vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv
      c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co
      wcel wa wa vv cv cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cfv
      vv cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa
      vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 cfv wceq
      vv cv cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co elxp6 vv cv vv cv c1st cfv
      vv cv c2nd cfv cop wceq vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv
      cc0 c1 c2 cdiv co cicc co wcel wa wa vv cv cM cc0 c1 cicc co cc0 c1 c2
      cdiv co cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1
      c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq
      wa vr vs vu copab2 cfv wceq vv cv c1st cfv vv cv c2nd cfv cop cM cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd
      cfv cop vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa
      vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 cfv wceq
      vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc
      co wcel wa vv cv c1st cfv vv cv c2nd cfv cop cM cc0 c1 cicc co cc0 c1 c2
      cdiv co cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd cfv cop vr cv cc0
      c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs
      cv cmul co cop cK cfv wceq wa vr vs vu copab2 cfv wceq vv cv vv cv c1st
      cfv vv cv c2nd cfv cop wceq vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd
      cfv cc0 c1 c2 cdiv co cicc co wcel wa vv cv c1st cfv vv cv c2nd cfv cM
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres co vv cv c1st cfv vv cv
      c2nd cfv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel
      wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 co vv
      cv c1st cfv vv cv c2nd cfv cop cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres cfv vv cv c1st cfv vv cv c2nd cfv cop vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co
      cop cK cfv wceq wa vr vs vu copab2 cfv vv cv c1st cfv cc0 c1 cicc co wcel
      vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co wcel wa vv cv c1st cfv vv cv
      c2nd cfv cM co vv cv c1st cfv c2 vv cv c2nd cfv cmul co cK co vv cv c1st
      cfv vv cv c2nd cfv cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres
      co vv cv c1st cfv vv cv c2nd cfv vr cv cc0 c1 cicc co wcel vs cv cc0 c1
      c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq
      wa vr vs vu copab2 co vx vy vz cK cL cM vv cv c1st cfv vv cv c2nd cfv
      phtpyco.1 phtpycolem1 vv cv c1st cfv vv cv c2nd cfv cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co cM oprvres vv cv c1st cfv cc0 c1 cicc co wcel vv cv
      c2nd cfv cc0 c1 c2 cdiv co cicc co wcel wa vv cv c1st cfv vv cv c2nd cfv
      vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv
      vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 co vv cv c1st
      cfv c2 vv cv c2nd cfv cmul co cop cK cfv vv cv c1st cfv c2 vv cv c2nd cfv
      cmul co cK co vr vs vu vv cv c1st cfv vv cv c2nd cfv cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co vr cv c2 vs cv cmul co cop cK cfv vv cv c1st cfv c2
      vv cv c2nd cfv cmul co cop cK cfv vr cv cc0 c1 cicc co wcel vs cv cc0 c1
      c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq
      wa vr vs vu copab2 vv cv c1st cfv c2 vs cv cmul co cop cK cfv vv cv c1st
      cfv c2 vv cv c2nd cfv cmul co cop cK fvex vr cv vv cv c1st cfv wceq vr cv
      c2 vs cv cmul co cop vv cv c1st cfv c2 vs cv cmul co cop cK vr cv vv cv
      c1st cfv c2 vs cv cmul co opeq1 fveq2d vs cv vv cv c2nd cfv wceq vv cv
      c1st cfv c2 vs cv cmul co cop vv cv c1st cfv c2 vv cv c2nd cfv cmul co
      cop cK vs cv vv cv c2nd cfv wceq c2 vs cv cmul co c2 vv cv c2nd cfv cmul
      co vv cv c1st cfv vs cv vv cv c2nd cfv c2 cmul opreq2 opeq2d fveq2d vr cv
      cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv
      c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 eqid oprabval2 vv cv
      c1st cfv c2 vv cv c2nd cfv cmul co cK df-opr syl6eqr 3eqtr4d vv cv c1st
      cfv vv cv c2nd cfv cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres
      df-opr vv cv c1st cfv vv cv c2nd cfv vr cv cc0 c1 cicc co wcel vs cv cc0
      c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv
      wceq wa vr vs vu copab2 df-opr 3eqtr3g adantl vv cv vv cv c1st cfv vv cv
      c2nd cfv cop wceq vv cv cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres cfv vv cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co
      wcel wa vu cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2
      cfv wceq vv cv c1st cfv vv cv c2nd cfv cop cM cc0 c1 cicc co cc0 c1 c2
      cdiv co cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd cfv cop vr cv cc0
      c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs
      cv cmul co cop cK cfv wceq wa vr vs vu copab2 cfv wceq wb vv cv c1st cfv
      cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co wcel wa vv
      cv vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv cM cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd cfv cop cM cc0
      c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc
      co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv cmul
      co cop cK cfv wceq wa vr vs vu copab2 cfv vv cv c1st cfv vv cv c2nd cfv
      cop vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu
      cv vr cv c2 vs cv cmul co cop cK cfv wceq wa vr vs vu copab2 cfv vv cv vv
      cv c1st cfv vv cv c2nd cfv cop cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres fveq2 vv cv vv cv c1st cfv vv cv c2nd cfv cop vr cv cc0 c1
      cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa vu cv vr cv c2 vs cv
      cmul co cop cK cfv wceq wa vr vs vu copab2 fveq2 eqeq12d adantr mpbird
      sylbi rgen mpbir2an oprabco 3syl cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co
      cxp cii cii ctx co cop csubsp cfv ctop wcel cii cii ctx co ctop wcel cJ
      ctop wcel w3a vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co
      wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv
      copab cfv vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul
      co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2 cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co cxp cii cii ctx co cop csubsp cfv cii cii ctx co
      ccn co wcel cK cii cii ctx co cJ ccn co wcel cK vr cv cc0 c1 cicc co wcel
      vs cv cc0 c1 c2 cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co
      wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2 cdiv co
      cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cop wceq wa
      vr vs vt copab2 ccom cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii
      ctx co cop csubsp cfv cJ ccn co wcel cJ ctop wcel cK cii cii ctx co cJ
      ccn co wcel wa cJ ctop wcel cK cii cii ctx co cJ ccn co wcel wa cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co cop csubsp cfv ctop
      wcel cii cii ctx co ctop wcel cJ ctop wcel cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cii cii ctx co cop csubsp cfv ctop wcel cJ ctop wcel cK
      cii cii ctx co cJ ccn co wcel wa cii cii ctx co ctop wcel cc0 c1 cicc co
      cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co cuni wss cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co cxp cii cii ctx co cop csubsp cfv ctop wcel cii
      ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop iitop cii cii cii
      cii ctx co cii cii ctx co eqid txtop mp2an cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp cii cii ctx co cuni cc0
      c1 cicc co cc0 c1 cicc co wss cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co
      wss cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cc0 c1 cicc co cc0 c1
      cicc co cxp wss cc0 c1 cicc co ssid cc0 cr wcel c1 cr wcel wa cc0 cr wcel
      c1 c2 cdiv co cr wcel wa cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr wa cc0
      c1 c2 cdiv co cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re
      pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel 0re c2 2re 2ne0 rereccli pm3.2i
      cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr cc0 0re leidi c1 c2 cdiv co c1
      c2 2re 2ne0 rereccli 1re halflt1 ltleii pm3.2i cc0 c1 cc0 c1 c2 cdiv co
      iccss mp3an cc0 c1 cicc co cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cc0
      c1 cicc co ssxp mp2an cii ctop wcel cii ctop wcel cii cii ctx co cuni cc0
      c1 cicc co cc0 c1 cicc co cxp wceq iitop iitop cii cii cii cii ctx co cc0
      c1 cicc co cc0 c1 cicc co cii cii ctx co eqid cii cuni cc0 c1 cicc co
      iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi txuni mp2an sseqtr4i
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co stoig3 mp2an
      a1i cii cii ctx co ctop wcel cJ ctop wcel cK cii cii ctx co cJ ccn co
      wcel wa cii ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop iitop
      cii cii cii cii ctx co cii cii ctx co eqid txtop mp2an a1i cJ ctop wcel
      cK cii cii ctx co cJ ccn co wcel pm3.26 3jca cii ctop wcel cabs cmin ccom
      cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv
      ctop wcel wa cii ctop wcel cii ctop wcel wa vu cv cc0 c1 cicc co wcel vv
      cv vu cv wceq wa vu vv copab cii cii ccn co wcel vu cv cc0 c1 c2 cdiv co
      cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cabs cmin ccom
      cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv cii
      ccn co wcel wa vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co
      wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv
      copab cfv vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul
      co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2 cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co cxp cii cii ctx co cop csubsp cfv cii cii ctx co
      ccn co wcel cJ ctop wcel cK cii cii ctx co cJ ccn co wcel wa vr vs vt cii
      cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres copn cfv cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co
      cop csubsp cfv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab
      vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv
      copab vr cv cc0 c1 cicc co wcel vs cv cc0 c1 c2 cdiv co cicc co wcel wa
      vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cfv
      vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa
      vu vv copab cfv cop wceq wa vr vs vt copab2 cii cii cii cii ctx co cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co cc0 c1 c2 cdiv co cicc
      co cxp cii cii ctx co cop csubsp cfv cc0 c1 cicc co cii cop csubsp cfv
      cc0 c1 c2 cdiv co cicc co cii cop csubsp cfv ctx co cii cabs cmin ccom
      cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv ctx
      co cii ctop wcel cii ctop wcel wa cc0 c1 cicc co cc0 c1 cicc co wss cc0
      c1 c2 cdiv co cicc co cc0 c1 cicc co wss wa cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cii cii ctx co cop csubsp cfv cc0 c1 cicc co cii cop
      csubsp cfv cc0 c1 c2 cdiv co cicc co cii cop csubsp cfv ctx co wceq cii
      ctop wcel cii ctop wcel iitop iitop pm3.2i cc0 c1 cicc co cc0 c1 cicc co
      wss cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co wss cc0 c1 cicc co ssid cc0
      cr wcel c1 cr wcel wa cc0 cr wcel c1 c2 cdiv co cr wcel wa cc0 cc0 cle
      wbr c1 c2 cdiv co c1 cle wbr wa cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co
      wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i cc0 cr wcel c1 c2 cdiv co cr
      wcel 0re c2 2re 2ne0 rereccli pm3.2i cc0 cc0 cle wbr c1 c2 cdiv co c1 cle
      wbr cc0 0re leidi c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1
      ltleii pm3.2i cc0 c1 cc0 c1 c2 cdiv co iccss mp3an pm3.2i cc0 c1 cicc co
      cc0 c1 c2 cdiv co cicc co cii cii cc0 c1 cicc co cc0 c1 cicc co cii cuni
      cc0 c1 cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi txsubsp
      mp2an cc0 c1 cicc co cii cop csubsp cfv cii cc0 c1 c2 cdiv co cicc co cii
      cop csubsp cfv cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co
      cicc co cxp cres copn cfv ctx cii ctop wcel cc0 c1 cicc co cii cop csubsp
      cfv cii wceq iitop cii cc0 c1 cicc co cii cuni cc0 c1 cicc co iiuni
      eqcomi subspid ax-mp cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp
      cres cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn
      cfv cc0 c1 c2 cdiv co cicc co cii cop csubsp cfv cabs cmin ccom cc0 c1 c2
      cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv cabs cmin
      ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cme wcel cc0 c1 c2 cdiv co
      cicc co cc0 c1 cicc co wss cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co
      cxp cres cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres
      copn cfv cc0 c1 c2 cdiv co cicc co cii cop csubsp cfv wceq cabs cmin ccom
      cme wcel cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cme wcel
      cabs cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cc0 c1 cicc co
      metres ax-mp cc0 cr wcel c1 cr wcel wa cc0 cr wcel c1 c2 cdiv co cr wcel
      wa cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr wa cc0 c1 c2 cdiv co cicc co
      cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i cc0 cr wcel c1
      c2 cdiv co cr wcel 0re c2 2re 2ne0 rereccli pm3.2i cc0 cc0 cle wbr c1 c2
      cdiv co c1 cle wbr cc0 0re leidi c1 c2 cdiv co c1 c2 2re 2ne0 rereccli
      1re halflt1 ltleii pm3.2i cc0 c1 cc0 c1 c2 cdiv co iccss mp3an cii cabs
      cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cc0 c1 cicc co cc0 c1 c2
      cdiv co cicc co cabs cmin ccom cme wcel cc0 c1 cicc co cc wss cc0 c1 cicc
      co cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cdm cdm wceq
      cabs cmin ccom cabs cmin ccom eqid cnmet cc0 c1 cicc co cr cc cc0 cr wcel
      c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an axresscn
      sstri cabs cmin ccom cc cc0 c1 cicc co cabs cmin ccom cabs cmin ccom eqid
      cnmetba metssba2 mp2an df-ii metsstop mp2an cabs cmin ccom cc0 c1 cicc co
      cc0 c1 cicc co cxp cres cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co
      cicc co cxp cres copn cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co
      cxp cc0 c1 cicc co cc0 c1 cicc co cxp wss cabs cmin ccom cc0 c1 cicc co
      cc0 c1 cicc co cxp cres cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co
      cicc co cxp cres wceq cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co wss cc0 c1
      c2 cdiv co cicc co cc0 c1 cicc co wss cc0 c1 c2 cdiv co cicc co cc0 c1 c2
      cdiv co cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp wss cc0 cr wcel c1
      cr wcel wa cc0 cr wcel c1 c2 cdiv co cr wcel wa cc0 cc0 cle wbr c1 c2
      cdiv co c1 cle wbr wa cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co wss cc0 cr
      wcel c1 cr wcel 0re 1re pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel 0re c2
      2re 2ne0 rereccli pm3.2i cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr cc0 0re
      leidi c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1 ltleii pm3.2i cc0
      c1 cc0 c1 c2 cdiv co iccss mp3an cc0 cr wcel c1 cr wcel wa cc0 cr wcel c1
      c2 cdiv co cr wcel wa cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr wa cc0 c1
      c2 cdiv co cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re
      pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel 0re c2 2re 2ne0 rereccli pm3.2i
      cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr cc0 0re leidi c1 c2 cdiv co c1
      c2 2re 2ne0 rereccli 1re halflt1 ltleii pm3.2i cc0 c1 cc0 c1 c2 cdiv co
      iccss mp3an cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co cc0 c1 c2 cdiv co
      cicc co cc0 c1 cicc co ssxp mp2an cabs cmin ccom cc0 c1 c2 cdiv co cicc
      co cc0 c1 c2 cdiv co cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp
      resabs1 ax-mp fveq2i eqtr3i opreq12i eqtri cii cii ctx co eqid cii cuni
      cc0 c1 cicc co iiuni eqcomi cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0
      c1 c2 cdiv co cicc co cxp cres copn cfv cuni cc0 c1 c2 cdiv co cicc co
      cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres cme wcel cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co
      cicc co cxp cres copn cfv cuni cc0 c1 c2 cdiv co cicc co wceq cabs cmin
      ccom cme wcel cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co
      cicc co cxp cres cme wcel cabs cmin ccom cabs cmin ccom eqid cnmet cabs
      cmin ccom cc0 c1 c2 cdiv co cicc co metres ax-mp cabs cmin ccom cc0 c1 c2
      cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres cabs cmin ccom cc0 c1
      c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv cc0 c1 c2
      cdiv co cicc co cabs cmin ccom cme wcel cc0 c1 c2 cdiv co cicc co cc wss
      cc0 c1 c2 cdiv co cicc co cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1
      c2 cdiv co cicc co cxp cres cdm cdm wceq cabs cmin ccom cabs cmin ccom
      eqid cnmet cc0 c1 c2 cdiv co cicc co cr cc cc0 cr wcel c1 c2 cdiv co cr
      wcel cc0 c1 c2 cdiv co cicc co cr wss 0re c2 2re 2ne0 rereccli cc0 c1 c2
      cdiv co iccssre mp2an axresscn sstri cabs cmin ccom cc cc0 c1 c2 cdiv co
      cicc co cabs cmin ccom cabs cmin ccom eqid cnmetba metssba2 mp2an cabs
      cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres
      copn cfv eqid uniopn2 ax-mp eqcomi vr cv cc0 c1 cicc co wcel vs cv cc0 c1
      c2 cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu
      cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv
      cv c2 vu cv cmul co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2
      eqid 2txcn cii ctop wcel cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1
      c2 cdiv co cicc co cxp cres copn cfv ctop wcel wa cJ ctop wcel cK cii cii
      ctx co cJ ccn co wcel wa cii ctop wcel cabs cmin ccom cc0 c1 c2 cdiv co
      cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv ctop wcel iitop cabs
      cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres
      cme wcel cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres copn cfv ctop wcel cabs cmin ccom cme wcel cabs cmin ccom cc0
      c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres cme wcel cabs
      cmin ccom cabs cmin ccom eqid cnmet cabs cmin ccom cc0 c1 c2 cdiv co cicc
      co metres ax-mp cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv
      co cicc co cxp cres cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2
      cdiv co cicc co cxp cres copn cfv cabs cmin ccom cc0 c1 c2 cdiv co cicc
      co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv eqid opntop ax-mp pm3.2i
      a1i cii ctop wcel cii ctop wcel wa cJ ctop wcel cK cii cii ctx co cJ ccn
      co wcel wa cii ctop wcel cii ctop wcel iitop iitop pm3.2i a1i vu cv cc0
      c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cii cii ccn co wcel vu cv
      cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab
      cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres copn cfv cii ccn co wcel wa cJ ctop wcel cK cii cii ctx co cJ ccn co
      wcel wa vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cii cii
      ccn co wcel vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co
      wceq wa vu vv copab cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2
      cdiv co cicc co cxp cres copn cfv cii ccn co wcel vu cv cc0 c1 cicc co
      wcel vv cv vu cv wceq wa vu vv copab cid cc0 c1 cicc co cres cii cii ccn
      co cid cc0 c1 cicc co cres vv cv vu cv wceq vu vv copab cc0 c1 cicc co
      cres vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cid vv cv
      vu cv wceq vu vv copab wceq cid cc0 c1 cicc co cres vv cv vu cv wceq vu
      vv copab cc0 c1 cicc co cres wceq cid vu cv vv cv wceq vu vv copab vv cv
      vu cv wceq vu vv copab vu vv df-id vu cv vv cv wceq vv cv vu cv wceq vu
      vv vu vv equcom opabbii eqtri cid vv cv vu cv wceq vu vv copab cc0 c1
      cicc co reseq1 ax-mp vv cv vu cv wceq vu vv cc0 c1 cicc co resopab eqtr2i
      cii ctop wcel cid cc0 c1 cicc co cres cii cii ccn co wcel iitop cii cc0
      c1 cicc co cii cuni cc0 c1 cicc co iiuni eqcomi idcn ax-mp eqeltri vu cv
      cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab
      cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co ccncf co cabs cmin ccom cc0 c1
      c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv cii ccn co
      vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv
      copab cc0 c1 c2 cdiv co cicc co cc ccncf co wcel vu cv cc0 c1 c2 cdiv co
      cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cc0 c1 c2 cdiv co
      cicc co cc0 c1 cicc co ccncf co wcel vu cv cc wcel vv cv c2 vu cv cmul co
      wceq wa vu vv copab cc0 c1 c2 cdiv co cicc co cres vu cv cc0 c1 c2 cdiv
      co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cc0 c1 c2 cdiv
      co cicc co cc ccncf co cc0 c1 c2 cdiv co cicc co cc wss vu cv cc wcel vv
      cv c2 vu cv cmul co wceq wa vu vv copab cc0 c1 c2 cdiv co cicc co cres vu
      cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv
      copab wceq cc0 c1 c2 cdiv co cicc co cr cc cc0 cr wcel c1 c2 cdiv co cr
      wcel cc0 c1 c2 cdiv co cicc co cr wss 0re c2 2re 2ne0 rereccli cc0 c1 c2
      cdiv co iccssre mp2an axresscn sstri vv cv c2 vu cv cmul co wceq vu vv
      cc0 c1 c2 cdiv co cicc co cc resopab2 ax-mp vu cv cc wcel vv cv c2 vu cv
      cmul co wceq wa vu vv copab cc cc ccncf co wcel vu cv cc wcel vv cv c2 vu
      cv cmul co wceq wa vu vv copab cc0 c1 c2 cdiv co cicc co cres cc0 c1 c2
      cdiv co cicc co cc ccncf co wcel c2 cc wcel vu cv cc wcel vv cv c2 vu cv
      cmul co wceq wa vu vv copab cc cc ccncf co wcel 2cn vu vv c2 vu cv cc
      wcel vv cv c2 vu cv cmul co wceq wa vu vv copab vu cv cc wcel vv cv c2 vu
      cv cmul co wceq wa vu vv copab eqid mulc1cncf ax-mp cc cc wss cc cc wss
      cc0 c1 c2 cdiv co cicc co cc wss vu cv cc wcel vv cv c2 vu cv cmul co
      wceq wa vu vv copab cc cc ccncf co wcel vu cv cc wcel vv cv c2 vu cv cmul
      co wceq wa vu vv copab cc0 c1 c2 cdiv co cicc co cres cc0 c1 c2 cdiv co
      cicc co cc ccncf co wcel wi cc ssid cc ssid cc0 c1 c2 cdiv co cicc co cr
      cc cc0 cr wcel c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cicc co cr wss 0re
      c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co iccssre mp2an axresscn sstri cc cc
      cc0 c1 c2 cdiv co cicc co vu cv cc wcel vv cv c2 vu cv cmul co wceq wa vu
      vv copab rescncf mp3an ax-mp eqeltrri cc0 c1 c2 cdiv co cicc co cc wss cc
      cc wss cc0 c1 cicc co cc wss w3a vw cv vu cv cc0 c1 c2 cdiv co cicc co
      wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cc0 c1 cicc co wcel
      vw cc0 c1 c2 cdiv co cicc co wral vu cv cc0 c1 c2 cdiv co cicc co wcel vv
      cv c2 vu cv cmul co wceq wa vu vv copab cc0 c1 c2 cdiv co cicc co cc
      ccncf co wcel vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co
      wceq wa vu vv copab cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co ccncf co
      wcel wi cc0 c1 c2 cdiv co cicc co cc wss cc cc wss cc0 c1 cicc co cc wss
      cc0 c1 c2 cdiv co cicc co cr cc cc0 cr wcel c1 c2 cdiv co cr wcel cc0 c1
      c2 cdiv co cicc co cr wss 0re c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co
      iccssre mp2an axresscn sstri cc ssid cc0 c1 cicc co cr cc cc0 cr wcel c1
      cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an axresscn sstri
      3pm3.2i vw cv vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul co
      wceq wa vu vv copab cfv cc0 c1 cicc co wcel vw cc0 c1 c2 cdiv co cicc co
      vw cv cc0 c1 c2 cdiv co cicc co wcel vw cv vu cv cc0 c1 c2 cdiv co cicc
      co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv c2 vw cv cmul co
      cc0 c1 cicc co vu vv vw cv c2 vu cv cmul co c2 vw cv cmul co cc0 c1 c2
      cdiv co cicc co vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv cmul
      co wceq wa vu vv copab vu cv vw cv c2 cmul opreq2 vu cv cc0 c1 c2 cdiv co
      cicc co wcel vv cv c2 vu cv cmul co wceq wa vu vv copab eqid c2 vw cv
      cmul oprex fvopab4 vw cv iihalf1 eqeltrd rgen vw cc0 c1 c2 cdiv co cicc
      co cc cc0 c1 cicc co vu cv cc0 c1 c2 cdiv co cicc co wcel vv cv c2 vu cv
      cmul co wceq wa vu vv copab cncffvrn mp2an ax-mp cc0 c1 c2 cdiv co cicc
      co cc wss cc0 c1 cicc co cc wss cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co
      ccncf co cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc
      co cxp cres copn cfv cii ccn co wceq cc0 c1 c2 cdiv co cicc co cr cc cc0
      cr wcel c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cicc co cr wss 0re c2 2re
      2ne0 rereccli cc0 c1 c2 cdiv co iccssre mp2an axresscn sstri cc0 c1 cicc
      co cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1
      iccssre mp2an axresscn sstri cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co
      cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cabs cmin ccom
      cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres copn cfv cii
      cabs cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp
      cres eqid cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres eqid cabs
      cmin ccom cc0 c1 c2 cdiv co cicc co cc0 c1 c2 cdiv co cicc co cxp cres
      copn cfv eqid df-ii cncfmet mp2an eleqtri pm3.2i a1i syl3anc cJ ctop wcel
      cK cii cii ctx co cJ ccn co wcel pm3.27 vr cv cc0 c1 cicc co wcel vs cv
      cc0 c1 c2 cdiv co cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel
      vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv cc0 c1 c2 cdiv co cicc co
      wcel vv cv c2 vu cv cmul co wceq wa vu vv copab cfv cop wceq wa vr vs vt
      copab2 cK cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co cop
      csubsp cfv cii cii ctx co cJ cnco sylan32c eqeltrd $.
      $( [2-Sep-2009] $)

    $( Lemma for ~ phtpyco . $)
    phtpycolem4 $p |- ( ( J e. Top /\ L e. ( ( II tX II ) Cn J ) /\
                    A. w e. ( 0 [,] 1 ) ( w K 1 ) = ( w L 0 ) ) ->
                ( M |` ( ( 0 [,] 1 ) X. ( ( 1 / 2 ) [,] 1 ) ) ) e. ( ( subSp `
      <. ( ( 0 [,] 1 ) X. ( ( 1 / 2 ) [,] 1 ) ) , ( II tX II ) >. ) Cn J ) ) $=
      cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL
      co wceq vw cc0 c1 cicc co wral w3a cM cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cres cL vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc
      co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu
      vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv
      cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2
      ccom cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop
      csubsp cfv cJ ccn co cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv
      c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cM cc0 c1 cicc co c1
      c2 cdiv co c1 cicc co cxp cres cL vr cv cc0 c1 cicc co wcel vs cv c1 c2
      cdiv co c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu
      cv wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv
      cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs
      vt copab2 ccom wceq cL cc0 c1 cicc co cc0 c1 cicc co cxp wfn vw cv c1 cK
      co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cM cc0 c1 cicc co c1 c2
      cdiv co c1 cicc co cxp cres cL vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv
      co c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv
      wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv
      c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs vt
      copab2 ccom wceq cJ ctop wcel cL cii cii ctx co cJ ccn co wcel wa vw cv
      c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cL cc0 c1 cicc co
      cc0 c1 cicc co cxp wfn cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp
      cres vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu
      cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu copab2
      cL vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vt cv
      vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv
      vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co
      wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2 ccom cM cc0 c1 cicc
      co c1 c2 cdiv co c1 cicc co cxp cres vr cv cc0 c1 cicc co wcel vs cv c1
      c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop
      cL cfv wceq wa vr vs vu copab2 wceq cc0 c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp wceq vv cv cM cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc co
      wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co
      c1 cmin co cop cL cfv wceq wa vr vs vu copab2 cfv wceq vv cc0 c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp wral vw cv c1 cK co vw cv cc0 cL co wceq vw
      cc0 c1 cicc co wral cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp wfn vr cv cc0 c1 cicc co wcel
      vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1
      cmin co cop cL cfv wceq wa vr vs vu copab2 cc0 c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp wfn cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres vr
      cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv
      c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu copab2 wceq cc0
      c1 cicc co c1 c2 cdiv co c1 cicc co cxp cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp wceq vv cv cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp
      cres cfv vv cv vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co
      wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs
      vu copab2 cfv wceq vv cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp wral wa
      wb cM cc0 c1 cicc co cc0 c1 cicc co cxp wfn cc0 c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp wss cM cc0 c1 cicc co c1
      c2 cdiv co c1 cicc co cxp cres cc0 c1 cicc co c1 c2 cdiv co c1 cicc co
      cxp wfn vx vy vz cc0 c1 cicc co cc0 c1 cicc co vy cv c1 c2 cdiv co cle
      wbr vx cv c2 vy cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL co
      cif cM vy cv c1 c2 cdiv co cle wbr vx cv c2 vy cv cmul co cK co vx cv c2
      vy cv cmul co c1 cmin co cL co vx cv c2 vy cv cmul co cK oprex vx cv c2
      vy cv cmul co c1 cmin co cL oprex ifex phtpyco.1 fnoprab2 cc0 c1 cicc co
      cc0 c1 cicc co wss c1 c2 cdiv co c1 cicc co cc0 c1 cicc co wss cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp
      wss cc0 c1 cicc co ssid cc0 cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel
      c1 cr wcel wa cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1
      cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2
      cdiv co cr wcel c1 cr wcel c2 2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv
      co cle wbr c1 c1 cle wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli
      halfgt0 ltleii c1 1re leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss mp3an
      cc0 c1 cicc co cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cc0 c1 cicc co
      ssxp mp2an cc0 c1 cicc co cc0 c1 cicc co cxp cc0 c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp cM fnssres mp2an vr vs vu cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co vr cv c2 vs cv cmul co c1 cmin co cop cL cfv vr cv cc0 c1 cicc co
      wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co
      c1 cmin co cop cL cfv wceq wa vr vs vu copab2 vr cv c2 vs cv cmul co c1
      cmin co cop cL fvex vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc
      co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr
      vs vu copab2 eqid fnoprab2 vv cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cM cc0 c1 cicc co c1 c2 cdiv
      co c1 cicc co cxp cres vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1
      cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq
      wa vr vs vu copab2 eqfnfv mp2an vw cv c1 cK co vw cv cc0 cL co wceq vw
      cc0 c1 cicc co wral cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp eqidd vw
      cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral vv cv cM cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc co
      wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co
      c1 cmin co cop cL cfv wceq wa vr vs vu copab2 cfv wceq vv cc0 c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp vw cv c1 cK co vw cv cc0 cL co wceq vw cc0
      c1 cicc co wral vv cv vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv c1st
      cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel wa
      wa vv cv cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv cv vr
      cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv
      c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu copab2 cfv wceq
      vv cv cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp wcel vw cv c1 cK co vw
      cv cc0 cL co wceq vw cc0 c1 cicc co wral vv cv vv cv c1st cfv vv cv c2nd
      cfv cop wceq vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv
      co c1 cicc co wcel wa wa wa vv cv cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cres cfv vv cv vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1
      cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq
      wa vr vs vu copab2 cfv wceq vv cv c1st cfv vv cv c2nd cfv cop cM cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd
      cfv cop vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa
      vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu
      copab2 cfv wceq vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co
      wral vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1
      cicc co wcel wa vv cv c1st cfv vv cv c2nd cfv cop cM cc0 c1 cicc co c1 c2
      cdiv co c1 cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd cfv cop vr cv
      cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2
      vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu copab2 cfv wceq vv
      cv vv cv c1st cfv vv cv c2nd cfv cop wceq vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd
      cfv c1 c2 cdiv co c1 cicc co wcel wa wa vv cv c1st cfv vv cv c2nd cfv cM
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres co vv cv c1st cfv vv cv
      c2nd cfv vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa
      vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu
      copab2 co vv cv c1st cfv vv cv c2nd cfv cop cM cc0 c1 cicc co c1 c2 cdiv
      co c1 cicc co cxp cres cfv vv cv c1st cfv vv cv c2nd cfv cop vr cv cc0 c1
      cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv
      cmul co c1 cmin co cop cL cfv wceq wa vr vs vu copab2 cfv vw cv c1 cK co
      vw cv cc0 cL co wceq vw cc0 c1 cicc co wral vv cv c1st cfv cc0 c1 cicc co
      wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel wa wa vv cv c1st cfv vv
      cv c2nd cfv cM co vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL
      co vv cv c1st cfv vv cv c2nd cfv cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cres co vv cv c1st cfv vv cv c2nd cfv vr cv cc0 c1 cicc co wcel vs
      cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin
      co cop cL cfv wceq wa vr vs vu copab2 co vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd
      cfv c1 c2 cdiv co c1 cicc co wcel vv cv c1st cfv vv cv c2nd cfv cM co vv
      cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL co wceq vx vy vz vw
      cK cL cM vv cv c1st cfv vv cv c2nd cfv phtpyco.1 phtpycolem2 3expb vv cv
      c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel
      wa vv cv c1st cfv vv cv c2nd cfv cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cres co vv cv c1st cfv vv cv c2nd cfv cM co wceq vw cv c1 cK co vw
      cv cc0 cL co wceq vw cc0 c1 cicc co wral vv cv c1st cfv vv cv c2nd cfv
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cM oprvres adantl vv cv c1st cfv
      cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel wa vv cv
      c1st cfv vv cv c2nd cfv vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1
      cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq
      wa vr vs vu copab2 co vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co
      cL co wceq vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral vv
      cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co
      wcel wa vv cv c1st cfv vv cv c2nd cfv vr cv cc0 c1 cicc co wcel vs cv c1
      c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop
      cL cfv wceq wa vr vs vu copab2 co vv cv c1st cfv c2 vv cv c2nd cfv cmul
      co c1 cmin co cop cL cfv vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin
      co cL co vr vs vu vv cv c1st cfv vv cv c2nd cfv cc0 c1 cicc co c1 c2 cdiv
      co c1 cicc co vr cv c2 vs cv cmul co c1 cmin co cop cL cfv vv cv c1st cfv
      c2 vv cv c2nd cfv cmul co c1 cmin co cop cL cfv vr cv cc0 c1 cicc co wcel
      vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1
      cmin co cop cL cfv wceq wa vr vs vu copab2 vv cv c1st cfv c2 vs cv cmul
      co c1 cmin co cop cL cfv vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin
      co cop cL fvex vr cv vv cv c1st cfv wceq vr cv c2 vs cv cmul co c1 cmin
      co cop vv cv c1st cfv c2 vs cv cmul co c1 cmin co cop cL vr cv vv cv c1st
      cfv c2 vs cv cmul co c1 cmin co opeq1 fveq2d vs cv vv cv c2nd cfv wceq vv
      cv c1st cfv c2 vs cv cmul co c1 cmin co cop vv cv c1st cfv c2 vv cv c2nd
      cfv cmul co c1 cmin co cop cL vs cv vv cv c2nd cfv wceq c2 vs cv cmul co
      c1 cmin co c2 vv cv c2nd cfv cmul co c1 cmin co vv cv c1st cfv vs cv vv
      cv c2nd cfv wceq c2 vs cv cmul co c2 vv cv c2nd cfv cmul co c1 cmin vs cv
      vv cv c2nd cfv c2 cmul opreq2 opreq1d opeq2d fveq2d vr cv cc0 c1 cicc co
      wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co
      c1 cmin co cop cL cfv wceq wa vr vs vu copab2 eqid oprabval2 vv cv c1st
      cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL df-opr syl6eqr adantl 3eqtr4d
      vv cv c1st cfv vv cv c2nd cfv cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co
      cxp cres df-opr vv cv c1st cfv vv cv c2nd cfv vr cv cc0 c1 cicc co wcel
      vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1
      cmin co cop cL cfv wceq wa vr vs vu copab2 df-opr 3eqtr3g adantrl vv cv
      vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv cM cc0 c1 cicc co c1 c2 cdiv
      co c1 cicc co cxp cres cfv vv cv vr cv cc0 c1 cicc co wcel vs cv c1 c2
      cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL
      cfv wceq wa vr vs vu copab2 cfv wceq vv cv c1st cfv vv cv c2nd cfv cop cM
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv cv c1st cfv vv cv
      c2nd cfv cop vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co
      wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs
      vu copab2 cfv wceq wb vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc
      co wral vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co
      c1 cicc co wcel wa vv cv vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv cM
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv cv c1st cfv vv cv
      c2nd cfv cop cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cfv vv
      cv vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vu cv
      vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu copab2 cfv
      vv cv c1st cfv vv cv c2nd cfv cop vr cv cc0 c1 cicc co wcel vs cv c1 c2
      cdiv co c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL
      cfv wceq wa vr vs vu copab2 cfv vv cv vv cv c1st cfv vv cv c2nd cfv cop
      cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres fveq2 vv cv vv cv
      c1st cfv vv cv c2nd cfv cop vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co
      c1 cicc co wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv
      wceq wa vr vs vu copab2 fveq2 eqeq12d ad2antrl mpbird vv cv cc0 c1 cicc
      co c1 c2 cdiv co c1 cicc co elxp6 sylan2b r19.21aiva sylanbrc vr vs vt vu
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co vr cv c2 vs cv cmul co c1 cmin co
      cop cc0 c1 cicc co cc0 c1 cicc co cxp vr cv cc0 c1 cicc co wcel vs cv c1
      c2 cdiv co c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv
      vu cv wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel
      vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr
      vs vt copab2 vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co
      wcel wa vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs
      vu copab2 cL vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co
      wcel wa vr cv cc0 c1 cicc co wcel c2 vs cv cmul co c1 cmin co cc0 c1 cicc
      co wcel wa vr cv c2 vs cv cmul co c1 cmin co cop cc0 c1 cicc co cc0 c1
      cicc co cxp wcel vs cv c1 c2 cdiv co c1 cicc co wcel c2 vs cv cmul co c1
      cmin co cc0 c1 cicc co wcel vr cv cc0 c1 cicc co wcel vs cv iihalf2
      anim2i vr cv c2 vs cv cmul co c1 cmin co cc0 c1 cicc co cc0 c1 cicc co c2
      vs cv cmul co c1 cmin oprex opelxp sylibr vr cv cc0 c1 cicc co wcel vs cv
      c1 c2 cdiv co c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv
      cv vu cv wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co
      wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq
      wa vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vt cv
      vr cv c2 vs cv cmul co c1 cmin co cop wceq wa vr vs vt vr cv cc0 c1 cicc
      co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1
      cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv
      co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab
      cfv cop wceq vt cv vr cv c2 vs cv cmul co c1 cmin co cop wceq vr cv cc0
      c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vr cv vu cv cc0 c1
      cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv
      co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab
      cfv cop vr cv c2 vs cv cmul co c1 cmin co cop vt cv vr cv cc0 c1 cicc co
      wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vr cv vu cv cc0 c1 cicc co
      wcel vv cv vu cv wceq wa vu vv copab cfv vr cv vs cv vu cv c1 c2 cdiv co
      c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv
      c2 vs cv cmul co c1 cmin co vr cv cc0 c1 cicc co wcel vr cv vu cv cc0 c1
      cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vr cv wceq vs cv c1 c2
      cdiv co c1 cicc co wcel vu vv vr cv vu cv vr cv cc0 c1 cicc co vu cv cc0
      c1 cicc co wcel vv cv vu cv wceq wa vu vv copab vu cv vr cv wceq id vu cv
      cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab eqid vr visset
      fvopab4 adantr vs cv c1 c2 cdiv co c1 cicc co wcel vs cv vu cv c1 c2 cdiv
      co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab
      cfv c2 vs cv cmul co c1 cmin co wceq vr cv cc0 c1 cicc co wcel vu vv vs
      cv c2 vu cv cmul co c1 cmin co c2 vs cv cmul co c1 cmin co c1 c2 cdiv co
      c1 cicc co vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1
      cmin co wceq wa vu vv copab vu cv vs cv wceq c2 vu cv cmul co c2 vs cv
      cmul co c1 cmin vu cv vs cv c2 cmul opreq2 opreq1d vu cv c1 c2 cdiv co c1
      cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab eqid
      c2 vs cv cmul co c1 cmin oprex fvopab4 adantl opeq12d eqeq2d pm5.32i
      oprabbii vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa
      vu cv vr cv c2 vs cv cmul co c1 cmin co cop cL cfv wceq wa vr vs vu
      copab2 eqid oprabco sylan9eqr cii cii ctx co ctop wcel cJ ctop wcel cL
      cii cii ctx co cJ ccn co wcel cL cc0 c1 cicc co cc0 c1 cicc co cxp wfn
      cii ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop iitop cii cii
      cii cii ctx co cii cii ctx co eqid txtop mp2an cii cii ctx co ctop wcel
      cJ ctop wcel cL cii cii ctx co cJ ccn co wcel w3a cc0 c1 cicc co cc0 c1
      cicc co cxp cJ cuni cL wf cL cc0 c1 cicc co cc0 c1 cicc co cxp wfn cL cii
      cii ctx co cJ cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cii cii ctx co
      cuni cc0 c1 cicc co cc0 c1 cicc co cxp cii ctop wcel cii ctop wcel cii
      cii ctx co cuni cc0 c1 cicc co cc0 c1 cicc co cxp wceq iitop iitop cii
      cii cii cii ctx co cc0 c1 cicc co cc0 c1 cicc co cii cii ctx co eqid cii
      cuni cc0 c1 cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi
      txuni mp2an eqcomi cJ cuni eqid cnf cc0 c1 cicc co cc0 c1 cicc co cxp cJ
      cuni cL ffn syl mp3an1 sylan 3impa cc0 c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cii cii ctx co cop csubsp cfv ctop wcel cii cii ctx co ctop wcel
      cJ ctop wcel w3a vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co
      wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv
      copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul
      co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2 cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv cii
      cii ctx co ccn co wcel cL cii cii ctx co cJ ccn co wcel cL vr cv cc0 c1
      cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa vt cv vr cv vu cv cc0
      c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cfv vs cv vu cv c1 c2
      cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv
      copab cfv cop wceq wa vr vs vt copab2 ccom cc0 c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp cii cii ctx co cop csubsp cfv cJ ccn co wcel cJ ctop wcel
      cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL co wceq vw
      cc0 c1 cicc co wral w3a cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw
      cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral w3a cc0 c1 cicc
      co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv ctop wcel
      cii cii ctx co ctop wcel cJ ctop wcel cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cii cii ctx co cop csubsp cfv ctop wcel cJ ctop wcel cL cii
      cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1
      cicc co wral w3a cii cii ctx co ctop wcel cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cii cii ctx co cuni wss cc0 c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cii cii ctx co cop csubsp cfv ctop wcel cii ctop wcel cii ctop
      wcel cii cii ctx co ctop wcel iitop iitop cii cii cii cii ctx co cii cii
      ctx co eqid txtop mp2an cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cc0
      c1 cicc co cc0 c1 cicc co cxp cii cii ctx co cuni cc0 c1 cicc co cc0 c1
      cicc co wss c1 c2 cdiv co c1 cicc co cc0 c1 cicc co wss cc0 c1 cicc co c1
      c2 cdiv co c1 cicc co cxp cc0 c1 cicc co cc0 c1 cicc co cxp wss cc0 c1
      cicc co ssid cc0 cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel c1 cr wcel
      wa cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1 cicc co
      cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2 cdiv co cr
      wcel c1 cr wcel c2 2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv co cle wbr
      c1 c1 cle wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli halfgt0 ltleii
      c1 1re leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss mp3an cc0 c1 cicc co
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cc0 c1 cicc co ssxp mp2an cii
      ctop wcel cii ctop wcel cii cii ctx co cuni cc0 c1 cicc co cc0 c1 cicc co
      cxp wceq iitop iitop cii cii cii cii ctx co cc0 c1 cicc co cc0 c1 cicc co
      cii cii ctx co eqid cii cuni cc0 c1 cicc co iiuni eqcomi cii cuni cc0 c1
      cicc co iiuni eqcomi txuni mp2an sseqtr4i cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cii cii ctx co stoig3 mp2an a1i cii cii ctx co ctop wcel cJ
      ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral w3a cii ctop wcel cii ctop wcel cii cii ctx
      co ctop wcel iitop iitop cii cii cii cii ctx co cii cii ctx co eqid txtop
      mp2an a1i cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw
      cv cc0 cL co wceq vw cc0 c1 cicc co wral 3simp1 3jca cii ctop wcel cabs
      cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn
      cfv ctop wcel wa cii ctop wcel cii ctop wcel wa vu cv cc0 c1 cicc co wcel
      vv cv vu cv wceq wa vu vv copab cii cii ccn co wcel vu cv c1 c2 cdiv co
      c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab
      cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres
      copn cfv cii ccn co wcel wa vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co
      c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq
      wa vu vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu
      cv cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv
      cii cii ctx co ccn co wcel cJ ctop wcel cL cii cii ctx co cJ ccn co wcel
      vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral w3a vr vs vt
      cii cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp
      cres copn cfv cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co
      cop csubsp cfv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab
      vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co
      wceq wa vu vv copab vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc
      co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu
      vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv
      cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2
      cii cii cii cii ctx co cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv cc0 c1
      cicc co cii cop csubsp cfv c1 c2 cdiv co c1 cicc co cii cop csubsp cfv
      ctx co cii cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc
      co cxp cres copn cfv ctx co cii ctop wcel cii ctop wcel wa cc0 c1 cicc co
      cc0 c1 cicc co wss c1 c2 cdiv co c1 cicc co cc0 c1 cicc co wss wa cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv cc0 c1
      cicc co cii cop csubsp cfv c1 c2 cdiv co c1 cicc co cii cop csubsp cfv
      ctx co wceq cii ctop wcel cii ctop wcel iitop iitop pm3.2i cc0 c1 cicc co
      cc0 c1 cicc co wss c1 c2 cdiv co c1 cicc co cc0 c1 cicc co wss cc0 c1
      cicc co ssid cc0 cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel c1 cr wcel
      wa cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1 cicc co
      cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2 cdiv co cr
      wcel c1 cr wcel c2 2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv co cle wbr
      c1 c1 cle wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli halfgt0 ltleii
      c1 1re leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss mp3an pm3.2i cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cii cii cc0 c1 cicc co cc0 c1 cicc co
      cii cuni cc0 c1 cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi
      txsubsp mp2an cc0 c1 cicc co cii cop csubsp cfv cii c1 c2 cdiv co c1 cicc
      co cii cop csubsp cfv cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv
      co c1 cicc co cxp cres copn cfv ctx cii ctop wcel cc0 c1 cicc co cii cop
      csubsp cfv cii wceq iitop cii cc0 c1 cicc co cii cuni cc0 c1 cicc co
      iiuni eqcomi subspid ax-mp cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co
      cxp cres c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn
      cfv c1 c2 cdiv co c1 cicc co cii cop csubsp cfv cabs cmin ccom c1 c2 cdiv
      co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv cabs cmin ccom
      cc0 c1 cicc co cc0 c1 cicc co cxp cres cme wcel c1 c2 cdiv co c1 cicc co
      cc0 c1 cicc co wss cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres
      c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv c1 c2
      cdiv co c1 cicc co cii cop csubsp cfv wceq cabs cmin ccom cme wcel cabs
      cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres cme wcel cabs cmin ccom
      cabs cmin ccom eqid cnmet cabs cmin ccom cc0 c1 cicc co metres ax-mp cc0
      cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel c1 cr wcel wa cc0 c1 c2 cdiv
      co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1 cicc co cc0 c1 cicc co wss
      cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2 cdiv co cr wcel c1 cr wcel c2
      2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr cc0
      c1 c2 cdiv co 0re c2 2re 2ne0 rereccli halfgt0 ltleii c1 1re leidi pm3.2i
      cc0 c1 c1 c2 cdiv co c1 iccss mp3an cii cabs cmin ccom cc0 c1 cicc co cc0
      c1 cicc co cxp cres cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cabs cmin
      ccom cme wcel cc0 c1 cicc co cc wss cc0 c1 cicc co cabs cmin ccom cc0 c1
      cicc co cc0 c1 cicc co cxp cres cdm cdm wceq cabs cmin ccom cabs cmin
      ccom eqid cnmet cc0 c1 cicc co cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc
      co cr wss 0re 1re cc0 c1 iccssre mp2an axresscn sstri cabs cmin ccom cc
      cc0 c1 cicc co cabs cmin ccom cabs cmin ccom eqid cnmetba metssba2 mp2an
      df-ii metsstop mp2an cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp
      cres c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cabs cmin
      ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn c1
      c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cc0 c1 cicc co cc0 c1
      cicc co cxp wss cabs cmin ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres c1
      c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cabs cmin ccom c1
      c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres wceq c1 c2 cdiv
      co c1 cicc co cc0 c1 cicc co wss c1 c2 cdiv co c1 cicc co cc0 c1 cicc co
      wss c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cc0 c1 cicc co
      cc0 c1 cicc co cxp wss cc0 cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel c1
      cr wcel wa cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1
      cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2
      cdiv co cr wcel c1 cr wcel c2 2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv
      co cle wbr c1 c1 cle wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli
      halfgt0 ltleii c1 1re leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss mp3an
      cc0 cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel c1 cr wcel wa cc0 c1 c2
      cdiv co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1 cicc co cc0 c1 cicc co
      wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2 cdiv co cr wcel c1 cr
      wcel c2 2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv co cle wbr c1 c1 cle
      wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli halfgt0 ltleii c1 1re
      leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss mp3an c1 c2 cdiv co c1 cicc co
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cc0 c1 cicc co ssxp mp2an cabs
      cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cc0 c1
      cicc co cc0 c1 cicc co cxp resabs1 ax-mp fveq2i eqtr3i opreq12i eqtri cii
      cii ctx co eqid cii cuni cc0 c1 cicc co iiuni eqcomi cabs cmin ccom c1 c2
      cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv cuni c1 c2
      cdiv co c1 cicc co cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp cres cme wcel cabs cmin ccom c1 c2 cdiv co c1 cicc co c1
      c2 cdiv co c1 cicc co cxp cres copn cfv cuni c1 c2 cdiv co c1 cicc co
      wceq cabs cmin ccom cme wcel cabs cmin ccom c1 c2 cdiv co c1 cicc co c1
      c2 cdiv co c1 cicc co cxp cres cme wcel cabs cmin ccom cabs cmin ccom
      eqid cnmet cabs cmin ccom c1 c2 cdiv co c1 cicc co metres ax-mp cabs cmin
      ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cabs cmin
      ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv
      c1 c2 cdiv co c1 cicc co cabs cmin ccom cme wcel c1 c2 cdiv co c1 cicc co
      cc wss c1 c2 cdiv co c1 cicc co cabs cmin ccom c1 c2 cdiv co c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp cres cdm cdm wceq cabs cmin ccom cabs cmin
      ccom eqid cnmet c1 c2 cdiv co c1 cicc co cr cc c1 c2 cdiv co cr wcel c1
      cr wcel c1 c2 cdiv co c1 cicc co cr wss c2 2re 2ne0 rereccli 1re c1 c2
      cdiv co c1 iccssre mp2an axresscn sstri cabs cmin ccom cc c1 c2 cdiv co
      c1 cicc co cabs cmin ccom cabs cmin ccom eqid cnmetba metssba2 mp2an cabs
      cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn
      cfv eqid uniopn2 ax-mp eqcomi vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv
      co c1 cicc co wcel wa vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv
      wceq wa vu vv copab cfv vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv
      c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv cop wceq wa vr vs vt
      copab2 eqid 2txcn cii ctop wcel cabs cmin ccom c1 c2 cdiv co c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp cres copn cfv ctop wcel wa cJ ctop wcel cL
      cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0
      c1 cicc co wral w3a cii ctop wcel cabs cmin ccom c1 c2 cdiv co c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp cres copn cfv ctop wcel iitop cabs cmin ccom
      c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cme wcel cabs
      cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn
      cfv ctop wcel cabs cmin ccom cme wcel cabs cmin ccom c1 c2 cdiv co c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cres cme wcel cabs cmin ccom cabs
      cmin ccom eqid cnmet cabs cmin ccom c1 c2 cdiv co c1 cicc co metres ax-mp
      cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres
      cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres
      copn cfv cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co
      cxp cres copn cfv eqid opntop ax-mp pm3.2i a1i cii ctop wcel cii ctop
      wcel wa cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw
      cv cc0 cL co wceq vw cc0 c1 cicc co wral w3a cii ctop wcel cii ctop wcel
      iitop iitop pm3.2i a1i vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu
      vv copab cii cii ccn co wcel vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2
      vu cv cmul co c1 cmin co wceq wa vu vv copab cabs cmin ccom c1 c2 cdiv co
      c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv cii ccn co wcel wa
      cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL
      co wceq vw cc0 c1 cicc co wral w3a vu cv cc0 c1 cicc co wcel vv cv vu cv
      wceq wa vu vv copab cii cii ccn co wcel vu cv c1 c2 cdiv co c1 cicc co
      wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cabs cmin ccom
      c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv cii
      ccn co wcel vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cid
      cc0 c1 cicc co cres cii cii ccn co cid cc0 c1 cicc co cres vv cv vu cv
      wceq vu vv copab cc0 c1 cicc co cres vu cv cc0 c1 cicc co wcel vv cv vu
      cv wceq wa vu vv copab cid vv cv vu cv wceq vu vv copab wceq cid cc0 c1
      cicc co cres vv cv vu cv wceq vu vv copab cc0 c1 cicc co cres wceq cid vu
      cv vv cv wceq vu vv copab vv cv vu cv wceq vu vv copab vu vv df-id vu cv
      vv cv wceq vv cv vu cv wceq vu vv vu vv equcom opabbii eqtri cid vv cv vu
      cv wceq vu vv copab cc0 c1 cicc co reseq1 ax-mp vv cv vu cv wceq vu vv
      cc0 c1 cicc co resopab eqtr2i cii ctop wcel cid cc0 c1 cicc co cres cii
      cii ccn co wcel iitop cii cc0 c1 cicc co cii cuni cc0 c1 cicc co iiuni
      eqcomi idcn ax-mp eqeltri vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu
      cv cmul co c1 cmin co wceq wa vu vv copab c1 c2 cdiv co c1 cicc co cc0 c1
      cicc co ccncf co cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cres copn cfv cii ccn co vu cv c1 c2 cdiv co c1 cicc co wcel
      vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab c1 c2 cdiv co c1
      cicc co cc ccncf co wcel vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu
      cv cmul co c1 cmin co wceq wa vu vv copab c1 c2 cdiv co c1 cicc co cc0 c1
      cicc co ccncf co wcel vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co
      wceq wa vu vv copab c1 c2 cdiv co c1 cicc co cres vu cv c1 c2 cdiv co c1
      cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab c1 c2
      cdiv co c1 cicc co cc ccncf co c1 c2 cdiv co c1 cicc co cc wss vu cv cc
      wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab c1 c2 cdiv co
      c1 cicc co cres vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul
      co c1 cmin co wceq wa vu vv copab wceq c1 c2 cdiv co c1 cicc co cr cc c1
      c2 cdiv co cr wcel c1 cr wcel c1 c2 cdiv co c1 cicc co cr wss c2 2re 2ne0
      rereccli 1re c1 c2 cdiv co c1 iccssre mp2an axresscn sstri vv cv c2 vu cv
      cmul co c1 cmin co wceq vu vv c1 c2 cdiv co c1 cicc co cc resopab2 ax-mp
      vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cc cc
      ccncf co wcel vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu
      vv copab c1 c2 cdiv co c1 cicc co cres c1 c2 cdiv co c1 cicc co cc ccncf
      co wcel vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vx cv cc
      wcel vy cv c2 vx cv cmul co wceq wa vx vy copab ccom vu cv cc wcel vv cv
      c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cc cc ccncf co vw cv cc
      wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx
      cv cmul co wceq wa vx vy copab ccom vu cv cc wcel vv cv c2 vu cv cmul co
      c1 cmin co wceq wa vu vv copab wceq cc cc wceq vt cv vw cv cc wcel vz cv
      vw cv c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co
      wceq wa vx vy copab ccom cfv vt cv vu cv cc wcel vv cv c2 vu cv cmul co
      c1 cmin co wceq wa vu vv copab cfv wceq vt cc wral vw cv cc wcel vz cv vw
      cv c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co
      wceq wa vx vy copab ccom cc wfn vu cv cc wcel vv cv c2 vu cv cmul co c1
      cmin co wceq wa vu vv copab cc wfn vw cv cc wcel vz cv vw cv c1 cmin co
      wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy
      copab ccom vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv
      copab wceq cc cc wceq vt cv vw cv cc wcel vz cv vw cv c1 cmin co wceq wa
      vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab ccom
      cfv vt cv vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv
      copab cfv wceq vt cc wral wa wb vw cv cc wcel vz cv vw cv c1 cmin co wceq
      wa vw vz copab cc wfn vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy
      copab cc wfn vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab crn
      cc wss vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vx cv cc
      wcel vy cv c2 vx cv cmul co wceq wa vx vy copab ccom cc wfn vw vz cc vw
      cv c1 cmin co vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vw
      cv c1 cmin oprex vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab
      eqid fnopab2 vx vy cc c2 vx cv cmul co vx cv cc wcel vy cv c2 vx cv cmul
      co wceq wa vx vy copab c2 vx cv cmul oprex vx cv cc wcel vy cv c2 vx cv
      cmul co wceq wa vx vy copab eqid fnopab2 cc cc vx cv cc wcel vy cv c2 vx
      cv cmul co wceq wa vx vy copab wf vx cv cc wcel vy cv c2 vx cv cmul co
      wceq wa vx vy copab crn cc wss vx vy cc cc c2 vx cv cmul co vx cv cc wcel
      vy cv c2 vx cv cmul co wceq wa vx vy copab vx cv cc wcel vy cv c2 vx cv
      cmul co wceq wa vx vy copab eqid c2 cc wcel vx cv cc wcel c2 vx cv cmul
      co cc wcel 2cn c2 vx cv mulcl mpan fopab cc cc vx cv cc wcel vy cv c2 vx
      cv cmul co wceq wa vx vy copab frn ax-mp cc cc vw cv cc wcel vz cv vw cv
      c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co wceq
      wa vx vy copab fnco mp3an vu vv cc c2 vu cv cmul co c1 cmin co vu cv cc
      wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab c2 vu cv cmul
      co c1 cmin oprex vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa
      vu vv copab eqid fnopab2 vt cc cc vw cv cc wcel vz cv vw cv c1 cmin co
      wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy
      copab ccom vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv
      copab eqfnfv mp2an cc eqid vt cv vw cv cc wcel vz cv vw cv c1 cmin co
      wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy
      copab ccom cfv vt cv vu cv cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq
      wa vu vv copab cfv wceq vt cc vt cv cc wcel vt cv vw cv cc wcel vz cv vw
      cv c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co
      wceq wa vx vy copab ccom cfv c2 vt cv cmul co c1 cmin co vt cv vu cv cc
      wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv vt cv cc
      wcel vt cv vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vx cv
      cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab ccom cfv vt cv vx cv
      cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab cfv vw cv cc wcel vz
      cv vw cv c1 cmin co wceq wa vw vz copab cfv c2 vt cv cmul co vw cv cc
      wcel vz cv vw cv c1 cmin co wceq wa vw vz copab cfv c2 vt cv cmul co c1
      cmin co vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab wfun vx
      cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab wfun vt cv vx cv cc
      wcel vy cv c2 vx cv cmul co wceq wa vx vy copab cdm wcel vt cv vw cv cc
      wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx
      cv cmul co wceq wa vx vy copab ccom cfv vt cv vx cv cc wcel vy cv c2 vx
      cv cmul co wceq wa vx vy copab cfv vw cv cc wcel vz cv vw cv c1 cmin co
      wceq wa vw vz copab cfv wceq vt cv cc wcel vt cv vw cv cc wcel vz cv vw
      cv c1 cmin co wceq wa vw vz copab vx cv cc wcel vy cv c2 vx cv cmul co
      wceq wa vx vy copab fvco vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw
      vz copab wfun vt cv cc wcel vw cv cc wcel vz cv vw cv c1 cmin co wceq wa
      vw vz copab cc wfn vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz
      copab wfun vw vz cc vw cv c1 cmin co vw cv cc wcel vz cv vw cv c1 cmin co
      wceq wa vw vz copab vw cv c1 cmin oprex vw cv cc wcel vz cv vw cv c1 cmin
      co wceq wa vw vz copab eqid fnopab2 cc vw cv cc wcel vz cv vw cv c1 cmin
      co wceq wa vw vz copab fnfun ax-mp a1i vx cv cc wcel vy cv c2 vx cv cmul
      co wceq wa vx vy copab wfun vt cv cc wcel vx cv cc wcel vy cv c2 vx cv
      cmul co wceq wa vx vy copab cc wfn vx cv cc wcel vy cv c2 vx cv cmul co
      wceq wa vx vy copab wfun vx vy cc c2 vx cv cmul co vx cv cc wcel vy cv c2
      vx cv cmul co wceq wa vx vy copab c2 vx cv cmul oprex vx cv cc wcel vy cv
      c2 vx cv cmul co wceq wa vx vy copab eqid fnopab2 cc vx cv cc wcel vy cv
      c2 vx cv cmul co wceq wa vx vy copab fnfun ax-mp a1i vt cv vx cv cc wcel
      vy cv c2 vx cv cmul co wceq wa vx vy copab cdm wcel vt cv cc wcel vx cv
      cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab cdm cc vt cv vx vy cc
      c2 vx cv cmul co vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab
      c2 vx cv cmul oprex vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy
      copab eqid dmopab2 eleq2i biimpri syl3anc vt cv cc wcel vt cv vx cv cc
      wcel vy cv c2 vx cv cmul co wceq wa vx vy copab cfv c2 vt cv cmul co vw
      cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vx vy vt cv c2 vx
      cv cmul co c2 vt cv cmul co cc vx cv cc wcel vy cv c2 vx cv cmul co wceq
      wa vx vy copab vx cv vt cv c2 cmul opreq2 vx cv cc wcel vy cv c2 vx cv
      cmul co wceq wa vx vy copab eqid c2 vt cv cmul oprex fvopab4 fveq2d vt cv
      cc wcel c2 vt cv cmul co cc wcel c2 vt cv cmul co vw cv cc wcel vz cv vw
      cv c1 cmin co wceq wa vw vz copab cfv c2 vt cv cmul co c1 cmin co wceq c2
      cc wcel vt cv cc wcel c2 vt cv cmul co cc wcel 2cn c2 vt cv mulcl mpan vw
      vz c2 vt cv cmul co vw cv c1 cmin co c2 vt cv cmul co c1 cmin co cc vw cv
      cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vw cv c2 vt cv cmul co
      c1 cmin opreq1 vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab
      eqid c2 vt cv cmul co c1 cmin oprex fvopab4 syl 3eqtrd vu vv vt cv c2 vu
      cv cmul co c1 cmin co c2 vt cv cmul co c1 cmin co cc vu cv cc wcel vv cv
      c2 vu cv cmul co c1 cmin co wceq wa vu vv copab vu cv vt cv wceq c2 vu cv
      cmul co c2 vt cv cmul co c1 cmin vu cv vt cv c2 cmul opreq2 opreq1d vu cv
      cc wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab eqid c2 vt
      cv cmul co c1 cmin oprex fvopab4 eqtr4d rgen mpbir2an cc cc wss cc cc wss
      cc cc wss w3a vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab cc
      cc ccncf co wcel vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab
      cc cc ccncf co wcel wa vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz
      copab vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab ccom cc cc
      ccncf co wcel cc cc wss cc cc wss cc cc wss cc ssid cc ssid cc ssid
      3pm3.2i vx cv cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab cc cc
      ccncf co wcel vw cv cc wcel vz cv vw cv c1 cmin co wceq wa vw vz copab cc
      cc ccncf co wcel c2 cc wcel vx cv cc wcel vy cv c2 vx cv cmul co wceq wa
      vx vy copab cc cc ccncf co wcel 2cn vx vy c2 vx cv cc wcel vy cv c2 vx cv
      cmul co wceq wa vx vy copab vx cv cc wcel vy cv c2 vx cv cmul co wceq wa
      vx vy copab eqid mulc1cncf ax-mp c1 cc wcel vw cv cc wcel vz cv vw cv c1
      cmin co wceq wa vw vz copab cc cc ccncf co wcel ax1cn vw vz c1 vw cv cc
      wcel vz cv vw cv c1 cmin co wceq wa vw vz copab vw cv cc wcel vz cv vw cv
      c1 cmin co wceq wa vw vz copab eqid sub1cncf ax-mp pm3.2i cc cc cc vx cv
      cc wcel vy cv c2 vx cv cmul co wceq wa vx vy copab vw cv cc wcel vz cv vw
      cv c1 cmin co wceq wa vw vz copab cncfco mp2an eqeltrri cc cc wss cc cc
      wss c1 c2 cdiv co c1 cicc co cc wss vu cv cc wcel vv cv c2 vu cv cmul co
      c1 cmin co wceq wa vu vv copab cc cc ccncf co wcel vu cv cc wcel vv cv c2
      vu cv cmul co c1 cmin co wceq wa vu vv copab c1 c2 cdiv co c1 cicc co
      cres c1 c2 cdiv co c1 cicc co cc ccncf co wcel wi cc ssid cc ssid c1 c2
      cdiv co c1 cicc co cr cc c1 c2 cdiv co cr wcel c1 cr wcel c1 c2 cdiv co
      c1 cicc co cr wss c2 2re 2ne0 rereccli 1re c1 c2 cdiv co c1 iccssre mp2an
      axresscn sstri cc cc c1 c2 cdiv co c1 cicc co vu cv cc wcel vv cv c2 vu
      cv cmul co c1 cmin co wceq wa vu vv copab rescncf mp3an ax-mp eqeltrri c1
      c2 cdiv co c1 cicc co cc wss cc cc wss cc0 c1 cicc co cc wss w3a vw cv vu
      cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq
      wa vu vv copab cfv cc0 c1 cicc co wcel vw c1 c2 cdiv co c1 cicc co wral
      vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co
      wceq wa vu vv copab c1 c2 cdiv co c1 cicc co cc ccncf co wcel vu cv c1 c2
      cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv
      copab c1 c2 cdiv co c1 cicc co cc0 c1 cicc co ccncf co wcel wi c1 c2 cdiv
      co c1 cicc co cc wss cc cc wss cc0 c1 cicc co cc wss c1 c2 cdiv co c1
      cicc co cr cc c1 c2 cdiv co cr wcel c1 cr wcel c1 c2 cdiv co c1 cicc co
      cr wss c2 2re 2ne0 rereccli 1re c1 c2 cdiv co c1 iccssre mp2an axresscn
      sstri cc ssid cc0 c1 cicc co cr cc cc0 cr wcel c1 cr wcel cc0 c1 cicc co
      cr wss 0re 1re cc0 c1 iccssre mp2an axresscn sstri 3pm3.2i vw cv vu cv c1
      c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu
      vv copab cfv cc0 c1 cicc co wcel vw c1 c2 cdiv co c1 cicc co vw cv c1 c2
      cdiv co c1 cicc co wcel vw cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv
      c2 vu cv cmul co c1 cmin co wceq wa vu vv copab cfv c2 vw cv cmul co c1
      cmin co cc0 c1 cicc co vu vv vw cv c2 vu cv cmul co c1 cmin co c2 vw cv
      cmul co c1 cmin co c1 c2 cdiv co c1 cicc co vu cv c1 c2 cdiv co c1 cicc
      co wcel vv cv c2 vu cv cmul co c1 cmin co wceq wa vu vv copab vu cv vw cv
      wceq c2 vu cv cmul co c2 vw cv cmul co c1 cmin vu cv vw cv c2 cmul opreq2
      opreq1d vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1
      cmin co wceq wa vu vv copab eqid c2 vw cv cmul co c1 cmin oprex fvopab4
      vw cv iihalf2 eqeltrd rgen vw c1 c2 cdiv co c1 cicc co cc cc0 c1 cicc co
      vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin co
      wceq wa vu vv copab cncffvrn mp2an ax-mp c1 c2 cdiv co c1 cicc co cc wss
      cc0 c1 cicc co cc wss c1 c2 cdiv co c1 cicc co cc0 c1 cicc co ccncf co
      cabs cmin ccom c1 c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres
      copn cfv cii ccn co wceq c1 c2 cdiv co c1 cicc co cr cc c1 c2 cdiv co cr
      wcel c1 cr wcel c1 c2 cdiv co c1 cicc co cr wss c2 2re 2ne0 rereccli 1re
      c1 c2 cdiv co c1 iccssre mp2an axresscn sstri cc0 c1 cicc co cr cc cc0 cr
      wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an
      axresscn sstri c1 c2 cdiv co c1 cicc co cc0 c1 cicc co cabs cmin ccom c1
      c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cabs cmin ccom
      cc0 c1 cicc co cc0 c1 cicc co cxp cres cabs cmin ccom c1 c2 cdiv co c1
      cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv cii cabs cmin ccom c1
      c2 cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres eqid cabs cmin
      ccom cc0 c1 cicc co cc0 c1 cicc co cxp cres eqid cabs cmin ccom c1 c2
      cdiv co c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres copn cfv eqid df-ii
      cncfmet mp2an eleqtri pm3.2i a1i syl3anc cJ ctop wcel cL cii cii ctx co
      cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral
      3simp2 vr cv cc0 c1 cicc co wcel vs cv c1 c2 cdiv co c1 cicc co wcel wa
      vt cv vr cv vu cv cc0 c1 cicc co wcel vv cv vu cv wceq wa vu vv copab cfv
      vs cv vu cv c1 c2 cdiv co c1 cicc co wcel vv cv c2 vu cv cmul co c1 cmin
      co wceq wa vu vv copab cfv cop wceq wa vr vs vt copab2 cL cc0 c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv cii cii ctx co
      cJ cnco sylan32c eqeltrd $.
      $( [2-Sep-2009] $)

    $( Lemma for ~ phtpyco . $)
    phtpycolem5 $p |- ( ( ( J e. Top /\ A. w e. ( 0 [,] 1 ) ( w K 1 ) = ( w L 0
       ) ) /\ ( K e. ( ( II tX II ) Cn J ) /\ L e. ( ( II tX II ) Cn J ) ) )
                                      -> M e. ( ( II tX II ) Cn J ) ) $=
      cii cii ctx co ctop wcel cJ ctop wcel wa cc0 c1 cicc co cc0 c1 c2 cdiv co
      cicc co cxp cii cii ctx co ccld cfv wcel cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cii cii ctx co ccld cfv wcel cc0 c1 cicc co cc0 c1 c2 cdiv co
      cicc co cxp cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cun cc0 c1 cicc
      co cc0 c1 cicc co cxp wceq w3a cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni
      cM wf cM cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cc0 c1 cicc co
      cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co cop csubsp cfv cJ ccn co
      wcel cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres cc0 c1 cicc co
      c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv cJ ccn co wcel
      w3a cM cii cii ctx co cJ ccn co wcel cJ ctop wcel vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel
      cL cii cii ctx co cJ ccn co wcel wa wa cc0 c1 cicc co cc0 c1 c2 cdiv co
      cicc co cxp cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cM cii cii ctx co
      cJ cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cii cii ctx co cuni cc0 c1
      cicc co cc0 c1 cicc co cxp cii ctop wcel cii ctop wcel cii cii ctx co
      cuni cc0 c1 cicc co cc0 c1 cicc co cxp wceq iitop iitop cii cii cii cii
      ctx co cc0 c1 cicc co cc0 c1 cicc co cii cii ctx co eqid cii cuni cc0 c1
      cicc co iiuni eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi txuni mp2an
      eqcomi cJ cuni eqid paste cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii
      cii ctx co cJ ccn co wcel wa wa cJ ctop wcel cii cii ctx co ctop wcel cJ
      ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cK
      cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa simpll
      cii ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop iitop cii cii
      cii cii ctx co cii cii ctx co eqid txtop mp2an jctil cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co cxp cii cii ctx co ccld cfv wcel cc0 c1 cicc co c1
      c2 cdiv co c1 cicc co cxp cii cii ctx co ccld cfv wcel cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co cxp cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cun
      cc0 c1 cicc co cc0 c1 cicc co cxp wceq w3a cJ ctop wcel vw cv c1 cK co vw
      cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co
      wcel cL cii cii ctx co cJ ccn co wcel wa wa cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cii cii ctx co ccld cfv wcel cc0 c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp cii cii ctx co ccld cfv wcel cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cun cc0 c1
      cicc co cc0 c1 cicc co cxp wceq cii ctop wcel cii ctop wcel wa cc0 c1
      cicc co cii ccld cfv wcel cc0 c1 c2 cdiv co cicc co cii ccld cfv wcel wa
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii ctx co ccld cfv wcel
      cii ctop wcel cii ctop wcel iitop iitop pm3.2i cc0 c1 cicc co cii ccld
      cfv wcel cc0 c1 c2 cdiv co cicc co cii ccld cfv wcel cii ctop wcel cc0 c1
      cicc co cii ccld cfv wcel iitop cii cc0 c1 cicc co cii cuni cc0 c1 cicc
      co iiuni eqcomi topcld ax-mp cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co
      cioo crn ctg cfv cop csubsp cfv ccld cfv cii ccld cfv cioo crn ctg cfv
      ctop wcel cc0 c1 cicc co cr wss wa cc0 c1 c2 cdiv co cicc co cioo crn ctg
      cfv ccld cfv wcel cc0 c1 c2 cdiv co cicc co cc0 c1 cicc co wss wa cc0 c1
      c2 cdiv co cicc co cc0 c1 cicc co cioo crn ctg cfv cop csubsp cfv ccld
      cfv wcel cioo crn ctg cfv ctop wcel cc0 c1 cicc co cr wss retop cc0 cr
      wcel c1 cr wcel cc0 c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an pm3.2i
      cc0 c1 c2 cdiv co cicc co cioo crn ctg cfv ccld cfv wcel cc0 c1 c2 cdiv
      co cicc co cc0 c1 cicc co wss cc0 cr wcel c1 c2 cdiv co cr wcel cc0 c1 c2
      cdiv co cicc co cioo crn ctg cfv ccld cfv wcel 0re c2 2re 2ne0 rereccli
      cc0 c1 c2 cdiv co clint3 mp2an cc0 cr wcel c1 cr wcel wa cc0 cr wcel c1
      c2 cdiv co cr wcel wa cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr wa cc0 c1
      c2 cdiv co cicc co cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re
      pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel 0re c2 2re 2ne0 rereccli pm3.2i
      cc0 cc0 cle wbr c1 c2 cdiv co c1 cle wbr cc0 0re leidi c1 c2 cdiv co c1
      c2 2re 2ne0 rereccli 1re halflt1 ltleii pm3.2i cc0 c1 cc0 c1 c2 cdiv co
      iccss mp3an pm3.2i cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cioo crn ctg
      cfv cr cioo crn ctg cfv cuni cr uniretop eqcomi subspcld mp2an cii cc0 c1
      cicc co cioo crn ctg cfv cop csubsp cfv ccld dfii2 fveq2i eleqtrri pm3.2i
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cii cii cii cii ctx co cii cii
      ctx co eqid txcld mp2an cii ctop wcel cii ctop wcel wa cc0 c1 cicc co cii
      ccld cfv wcel c1 c2 cdiv co c1 cicc co cii ccld cfv wcel wa cc0 c1 cicc
      co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co ccld cfv wcel cii ctop
      wcel cii ctop wcel iitop iitop pm3.2i cc0 c1 cicc co cii ccld cfv wcel c1
      c2 cdiv co c1 cicc co cii ccld cfv wcel cii ctop wcel cc0 c1 cicc co cii
      ccld cfv wcel iitop cii cc0 c1 cicc co cii cuni cc0 c1 cicc co iiuni
      eqcomi topcld ax-mp c1 c2 cdiv co c1 cicc co cc0 c1 cicc co cioo crn ctg
      cfv cop csubsp cfv ccld cfv cii ccld cfv cioo crn ctg cfv ctop wcel cc0
      c1 cicc co cr wss wa c1 c2 cdiv co c1 cicc co cioo crn ctg cfv ccld cfv
      wcel c1 c2 cdiv co c1 cicc co cc0 c1 cicc co wss wa c1 c2 cdiv co c1 cicc
      co cc0 c1 cicc co cioo crn ctg cfv cop csubsp cfv ccld cfv wcel cioo crn
      ctg cfv ctop wcel cc0 c1 cicc co cr wss retop cc0 cr wcel c1 cr wcel cc0
      c1 cicc co cr wss 0re 1re cc0 c1 iccssre mp2an pm3.2i c1 c2 cdiv co c1
      cicc co cioo crn ctg cfv ccld cfv wcel c1 c2 cdiv co c1 cicc co cc0 c1
      cicc co wss c1 c2 cdiv co cr wcel c1 cr wcel c1 c2 cdiv co c1 cicc co
      cioo crn ctg cfv ccld cfv wcel c2 2re 2ne0 rereccli 1re c1 c2 cdiv co c1
      clint3 mp2an cc0 cr wcel c1 cr wcel wa c1 c2 cdiv co cr wcel c1 cr wcel
      wa cc0 c1 c2 cdiv co cle wbr c1 c1 cle wbr wa c1 c2 cdiv co c1 cicc co
      cc0 c1 cicc co wss cc0 cr wcel c1 cr wcel 0re 1re pm3.2i c1 c2 cdiv co cr
      wcel c1 cr wcel c2 2re 2ne0 rereccli 1re pm3.2i cc0 c1 c2 cdiv co cle wbr
      c1 c1 cle wbr cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli halfgt0 ltleii
      c1 1re leidi pm3.2i cc0 c1 c1 c2 cdiv co c1 iccss mp3an pm3.2i cc0 c1
      cicc co c1 c2 cdiv co c1 cicc co cioo crn ctg cfv cr cioo crn ctg cfv
      cuni cr uniretop eqcomi subspcld mp2an cii cc0 c1 cicc co cioo crn ctg
      cfv cop csubsp cfv ccld dfii2 fveq2i eleqtrri pm3.2i cc0 c1 cicc co c1 c2
      cdiv co c1 cicc co cii cii cii cii ctx co cii cii ctx co eqid txcld mp2an
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co c1 c2 cdiv co c1 cicc co cun cxp
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cc0 c1 cicc co c1 c2 cdiv co
      c1 cicc co cxp cun cc0 c1 cicc co cc0 c1 cicc co cxp cc0 c1 cicc co cc0
      c1 c2 cdiv co cicc co c1 c2 cdiv co c1 cicc co xpundi cc0 c1 c2 cdiv co
      cicc co c1 c2 cdiv co c1 cicc co cun cc0 c1 cicc co cc0 c1 cicc co cc0 c1
      cicc co cc0 c1 c2 cdiv co cicc co c1 c2 cdiv co c1 cicc co cun cc0 cr
      wcel c1 cr wcel c1 c2 cdiv co cc0 c1 cicc co wcel cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co c1 c2 cdiv co c1 cicc co cun wceq 0re 1re c1 c2 cdiv
      co cc0 c1 cicc co wcel c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1
      c2 cdiv co c1 cle wbr w3a c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr
      c1 c2 cdiv co c1 cle wbr c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co 0re c2
      2re 2ne0 rereccli halfgt0 ltleii c1 c2 cdiv co c1 c2 2re 2ne0 rereccli
      1re halflt1 ltleii 3pm3.2i cc0 cr wcel c1 cr wcel c1 c2 cdiv co cc0 c1
      cicc co wcel c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv
      co c1 cle wbr w3a wb 0re 1re cc0 c1 c1 c2 cdiv co elicc2 mp2an mpbir cc0
      c1 c1 c2 cdiv co iccsplit mp3an eqcomi xpeq2i eqtr3i 3pm3.2i a1i cJ ctop
      wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii
      cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa cc0 c1
      cicc co cc0 c1 cicc co cxp cJ cuni cM wf cM cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co cxp cres cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cii cii
      ctx co cop csubsp cfv cJ ccn co wcel cM cc0 c1 cicc co c1 c2 cdiv co c1
      cicc co cxp cres cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx
      co cop csubsp cfv cJ ccn co wcel cJ ctop wcel vw cv c1 cK co vw cv cc0 cL
      co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii
      cii ctx co cJ ccn co wcel wa wa cM cc0 c1 cicc co cc0 c1 cicc co cxp wfn
      vv cv cM cfv cJ cuni wcel vv cc0 c1 cicc co cc0 c1 cicc co cxp wral wa
      cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cM wf cJ ctop wcel vw cv c1 cK
      co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ
      ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv cM cfv cJ cuni
      wcel vv cc0 c1 cicc co cc0 c1 cicc co cxp wral cM cc0 c1 cicc co cc0 c1
      cicc co cxp wfn cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0
      c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ
      ccn co wcel wa wa vv cv cM cfv cJ cuni wcel vv cc0 c1 cicc co cc0 c1 cicc
      co cxp cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co
      wral wa cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel
      wa wa vv cv vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv c1st cfv cc0 c1
      cicc co wcel vv cv c2nd cfv cc0 c1 cicc co wcel wa wa vv cv cM cfv cJ
      cuni wcel vv cv cc0 c1 cicc co cc0 c1 cicc co cxp wcel cJ ctop wcel vw cv
      c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co
      cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv c1st cfv cc0
      c1 cicc co wcel vv cv c2nd cfv cc0 c1 cicc co wcel wa vv cv vv cv c1st
      cfv vv cv c2nd cfv cop wceq vv cv cM cfv cJ cuni wcel cJ ctop wcel vw cv
      c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co
      cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv c1st cfv cc0
      c1 cicc co wcel vv cv c2nd cfv cc0 c1 cicc co wcel wa vv cv vv cv c1st
      cfv vv cv c2nd cfv cop wceq vv cv cM cfv cJ cuni wcel vv cv vv cv c1st
      cfv vv cv c2nd cfv cop wceq vv cv cM cfv cJ cuni wcel vv cv c1st cfv vv
      cv c2nd cfv cM co cJ cuni wcel cJ ctop wcel vw cv c1 cK co vw cv cc0 cL
      co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii
      cii ctx co cJ ccn co wcel wa wa vv cv c1st cfv cc0 c1 cicc co wcel vv cv
      c2nd cfv cc0 c1 cicc co wcel wa wa vv cv vv cv c1st cfv vv cv c2nd cfv
      cop wceq vv cv cM cfv vv cv c1st cfv vv cv c2nd cfv cM co cJ cuni vv cv
      vv cv c1st cfv vv cv c2nd cfv cop wceq vv cv cM cfv vv cv c1st cfv vv cv
      c2nd cfv cop cM cfv vv cv c1st cfv vv cv c2nd cfv cM co vv cv vv cv c1st
      cfv vv cv c2nd cfv cop cM fveq2 vv cv c1st cfv vv cv c2nd cfv cM df-opr
      syl6eqr eleq1d cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1
      cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn
      co wcel wa wa vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1
      cicc co wcel vv cv c1st cfv vv cv c2nd cfv cM co cJ cuni wcel cJ ctop
      wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii
      cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv
      c1st cfv cc0 c1 cicc co wcel wa vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co
      wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel wo vv cv c1st cfv vv cv
      c2nd cfv cM co cJ cuni wcel vv cv c2nd cfv cc0 c1 cicc co wcel cJ ctop
      wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii
      cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv
      c1st cfv cc0 c1 cicc co wcel wa vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co
      wcel vv cv c1st cfv vv cv c2nd cfv cM co cJ cuni wcel vv cv c2nd cfv c1
      c2 cdiv co c1 cicc co wcel cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii
      cii ctx co cJ ccn co wcel wa wa vv cv c1st cfv cc0 c1 cicc co wcel wa vv
      cv c2nd cfv cc0 c1 c2 cdiv co cicc co wcel wa vv cv c1st cfv vv cv c2nd
      cfv cM co vv cv c1st cfv c2 vv cv c2nd cfv cmul co cK co cJ cuni vv cv
      c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co
      wcel vv cv c1st cfv vv cv c2nd cfv cM co vv cv c1st cfv c2 vv cv c2nd cfv
      cmul co cK co wceq cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw
      cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co
      cJ ccn co wcel wa wa vx vy vz cK cL cM vv cv c1st cfv vv cv c2nd cfv
      phtpyco.1 phtpycolem1 adantll cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral wa cK cii cii ctx co cJ ccn co wcel cL cii
      cii ctx co cJ ccn co wcel wa wa vv cv c1st cfv cc0 c1 cicc co wcel vv cv
      c2nd cfv cc0 c1 c2 cdiv co cicc co wcel vv cv c1st cfv c2 vv cv c2nd cfv
      cmul co cK co cJ cuni wcel cJ ctop wcel cK cii cii ctx co cJ ccn co wcel
      cL cii cii ctx co cJ ccn co wcel wa vv cv c1st cfv cc0 c1 cicc co wcel vv
      cv c2nd cfv cc0 c1 c2 cdiv co cicc co wcel wa vv cv c1st cfv c2 vv cv
      c2nd cfv cmul co cK co cJ cuni wcel vw cv c1 cK co vw cv cc0 cL co wceq
      vw cc0 c1 cicc co wral cJ ctop wcel cK cii cii ctx co cJ ccn co wcel vv
      cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co
      wcel wa vv cv c1st cfv c2 vv cv c2nd cfv cmul co cK co cJ cuni wcel cL
      cii cii ctx co cJ ccn co wcel cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni
      cK wf vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv cc0 c1 c2 cdiv co
      cicc co wcel wa vv cv c1st cfv c2 vv cv c2nd cfv cmul co cK co cJ cuni
      wcel cJ ctop wcel cK cii cii ctx co cJ ccn co wcel wa cc0 c1 cicc co cc0
      c1 cicc co cxp cJ cuni cK wf vv cv c1st cfv cc0 c1 cicc co wcel c2 vv cv
      c2nd cfv cmul co cc0 c1 cicc co wcel vv cv c1st cfv c2 vv cv c2nd cfv
      cmul co cK co cJ cuni wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co wcel
      cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cK wf vv cv c1st cfv c2 vv cv
      c2nd cfv cmul co cop cc0 c1 cicc co cc0 c1 cicc co cxp wcel vv cv c1st
      cfv c2 vv cv c2nd cfv cmul co cK co cJ cuni wcel vv cv c1st cfv cc0 c1
      cicc co wcel c2 vv cv c2nd cfv cmul co cc0 c1 cicc co wcel wa cc0 c1 cicc
      co cc0 c1 cicc co cxp cJ cuni cK wf vv cv c1st cfv c2 vv cv c2nd cfv cmul
      co cop cc0 c1 cicc co cc0 c1 cicc co cxp wcel wa vv cv c1st cfv c2 vv cv
      c2nd cfv cmul co cop cK cfv cJ cuni vv cv c1st cfv c2 vv cv c2nd cfv cmul
      co cK co cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni vv cv c1st cfv c2 vv
      cv c2nd cfv cmul co cop cK ffvelrn vv cv c1st cfv c2 vv cv c2nd cfv cmul
      co cK df-opr syl5eqel vv cv c1st cfv c2 vv cv c2nd cfv cmul co cc0 c1
      cicc co cc0 c1 cicc co c2 vv cv c2nd cfv cmul oprex opelxp sylan2br vv cv
      c2nd cfv iihalf1 sylanr2 cii cii ctx co ctop wcel cJ ctop wcel cK cii cii
      ctx co cJ ccn co wcel cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cK wf cii
      ctop wcel cii ctop wcel cii cii ctx co ctop wcel iitop iitop cii cii cii
      cii ctx co cii cii ctx co eqid txtop mp2an cK cii cii ctx co cJ cc0 c1
      cicc co cc0 c1 cicc co cxp cJ cuni cii cii ctx co cuni cc0 c1 cicc co cc0
      c1 cicc co cxp cii ctop wcel cii ctop wcel cii cii ctx co cuni cc0 c1
      cicc co cc0 c1 cicc co cxp wceq iitop iitop cii cii cii cii ctx co cc0 c1
      cicc co cc0 c1 cicc co cii cii ctx co eqid cii cuni cc0 c1 cicc co iiuni
      eqcomi cii cuni cc0 c1 cicc co iiuni eqcomi txuni mp2an eqcomi cJ cuni
      eqid cnf mp3an1 sylan adantlrr adantllr anassrs eqeltrd cJ ctop wcel vw
      cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii cii ctx
      co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv c1st cfv
      cc0 c1 cicc co wcel wa vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel wa vv
      cv c1st cfv vv cv c2nd cfv cM co vv cv c1st cfv c2 vv cv c2nd cfv cmul co
      c1 cmin co cL co cJ cuni cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq
      vw cc0 c1 cicc co wral wa vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd
      cfv c1 c2 cdiv co c1 cicc co wcel vv cv c1st cfv vv cv c2nd cfv cM co vv
      cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL co wceq cK cii cii
      ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa vw cv c1 cK co
      vw cv cc0 cL co wceq vw cc0 c1 cicc co wral vv cv c1st cfv cc0 c1 cicc co
      wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel vv cv c1st cfv vv cv
      c2nd cfv cM co vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL co
      wceq cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co
      wral vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1
      cicc co wcel vv cv c1st cfv vv cv c2nd cfv cM co vv cv c1st cfv c2 vv cv
      c2nd cfv cmul co c1 cmin co cL co wceq vx vy vz vw cK cL cM vv cv c1st
      cfv vv cv c2nd cfv phtpyco.1 phtpycolem2 3expa adantlll adantllr cJ ctop
      wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cK cii
      cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa wa vv cv
      c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel
      vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL co cJ cuni wcel cJ
      ctop wcel cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co
      wcel wa vv cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co
      c1 cicc co wcel wa vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL
      co cJ cuni wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co
      wral cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vv cv c1st cfv cc0 c1
      cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co wcel wa vv cv c1st
      cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL co cJ cuni wcel cK cii cii
      ctx co cJ ccn co wcel cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cL wf vv
      cv c1st cfv cc0 c1 cicc co wcel vv cv c2nd cfv c1 c2 cdiv co c1 cicc co
      wcel wa vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL co cJ cuni
      wcel cJ ctop wcel cL cii cii ctx co cJ ccn co wcel wa cc0 c1 cicc co cc0
      c1 cicc co cxp cJ cuni cL wf vv cv c1st cfv cc0 c1 cicc co wcel c2 vv cv
      c2nd cfv cmul co c1 cmin co cc0 c1 cicc co wcel vv cv c1st cfv c2 vv cv
      c2nd cfv cmul co c1 cmin co cL co cJ cuni wcel vv cv c2nd cfv c1 c2 cdiv
      co c1 cicc co wcel cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cL wf vv cv
      c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cop cc0 c1 cicc co cc0 c1
      cicc co cxp wcel vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cL
      co cJ cuni wcel vv cv c1st cfv cc0 c1 cicc co wcel c2 vv cv c2nd cfv cmul
      co c1 cmin co cc0 c1 cicc co wcel wa cc0 c1 cicc co cc0 c1 cicc co cxp cJ
      cuni cL wf vv cv c1st cfv c2 vv cv c2nd cfv cmul co c1 cmin co cop cc0 c1
      cicc co cc0 c1 cicc co cxp wcel wa vv cv c1st cfv c2 vv cv c2nd cfv cmul
      co c1 cmin co cop cL cfv cJ cuni vv cv c1st cfv c2 vv cv c2nd cfv cmul co
      c1 cmin co cL co cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni vv cv c1st cfv
      c2 vv cv c2nd cfv cmul co c1 cmin co cop cL ffvelrn vv cv c1st cfv c2 vv
      cv c2nd cfv cmul co c1 cmin co cL df-opr syl5eqel vv cv c1st cfv c2 vv cv
      c2nd cfv cmul co c1 cmin co cc0 c1 cicc co cc0 c1 cicc co c2 vv cv c2nd
      cfv cmul co c1 cmin oprex opelxp sylan2br vv cv c2nd cfv iihalf2 sylanr2
      cii cii ctx co ctop wcel cJ ctop wcel cL cii cii ctx co cJ ccn co wcel
      cc0 c1 cicc co cc0 c1 cicc co cxp cJ cuni cL wf cii ctop wcel cii ctop
      wcel cii cii ctx co ctop wcel iitop iitop cii cii cii cii ctx co cii cii
      ctx co eqid txtop mp2an cL cii cii ctx co cJ cc0 c1 cicc co cc0 c1 cicc
      co cxp cJ cuni cii cii ctx co cuni cc0 c1 cicc co cc0 c1 cicc co cxp cii
      ctop wcel cii ctop wcel cii cii ctx co cuni cc0 c1 cicc co cc0 c1 cicc co
      cxp wceq iitop iitop cii cii cii cii ctx co cc0 c1 cicc co cc0 c1 cicc co
      cii cii ctx co eqid cii cuni cc0 c1 cicc co iiuni eqcomi cii cuni cc0 c1
      cicc co iiuni eqcomi txuni mp2an eqcomi cJ cuni eqid cnf mp3an1 sylan
      adantlrl adantllr anassrs eqeltrd jaodan vv cv c2nd cfv cc0 c1 cicc co
      wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co c1 c2 cdiv co c1 cicc co
      cun wcel vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co wcel vv cv c2nd cfv c1
      c2 cdiv co c1 cicc co wcel wo cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co c1
      c2 cdiv co c1 cicc co cun vv cv c2nd cfv cc0 cr wcel c1 cr wcel c1 c2
      cdiv co cc0 c1 cicc co wcel cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co c1
      c2 cdiv co c1 cicc co cun wceq 0re 1re c1 c2 cdiv co cc0 c1 cicc co wcel
      c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 cle wbr
      w3a c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 cle
      wbr c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli
      halfgt0 ltleii c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1 ltleii
      3pm3.2i cc0 cr wcel c1 cr wcel c1 c2 cdiv co cc0 c1 cicc co wcel c1 c2
      cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 cle wbr w3a wb
      0re 1re cc0 c1 c1 c2 cdiv co elicc2 mp2an mpbir cc0 c1 c1 c2 cdiv co
      iccsplit mp3an eleq2i vv cv c2nd cfv cc0 c1 c2 cdiv co cicc co c1 c2 cdiv
      co c1 cicc co elun bitri sylan2b anasss syl5cbir impr ancom2s vv cv cc0
      c1 cicc co cc0 c1 cicc co elxp6 sylan2b r19.21aiva vx vy vz cc0 c1 cicc
      co cc0 c1 cicc co vy cv c1 c2 cdiv co cle wbr vx cv c2 vy cv cmul co cK
      co vx cv c2 vy cv cmul co c1 cmin co cL co cif cM vy cv c1 c2 cdiv co cle
      wbr vx cv c2 vy cv cmul co cK co vx cv c2 vy cv cmul co c1 cmin co cL co
      vx cv c2 vy cv cmul co cK oprex vx cv c2 vy cv cmul co c1 cmin co cL
      oprex ifex phtpyco.1 fnoprab2 jctil vv cc0 c1 cicc co cc0 c1 cicc co cxp
      cJ cuni cM ffnfv sylibr cJ ctop wcel cK cii cii ctx co cJ ccn co wcel cM
      cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co cxp cres cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co cxp cii cii ctx co cop csubsp cfv cJ ccn co wcel vw cv
      c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cL cii cii ctx co cJ
      ccn co wcel vx vy vz cJ cK cL cM phtpyco.1 phtpycolem3 ad2ant2r cJ ctop
      wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral wa cL cii
      cii ctx co cJ ccn co wcel cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp
      cres cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop
      csubsp cfv cJ ccn co wcel cK cii cii ctx co cJ ccn co wcel cJ ctop wcel
      cL cii cii ctx co cJ ccn co wcel vw cv c1 cK co vw cv cc0 cL co wceq vw
      cc0 c1 cicc co wral cM cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cres
      cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp cii cii ctx co cop csubsp cfv
      cJ ccn co wcel cJ ctop wcel cL cii cii ctx co cJ ccn co wcel vw cv c1 cK
      co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cM cc0 c1 cicc co c1 c2
      cdiv co c1 cicc co cxp cres cc0 c1 cicc co c1 c2 cdiv co c1 cicc co cxp
      cii cii ctx co cop csubsp cfv cJ ccn co wcel vx vy vz vw cJ cK cL cM
      phtpyco.1 phtpycolem4 3expa an1rs adantrl 3jca syl3anc $.
      $( [2-Sep-2009] $)

    $( Concatenate two path homotopies. $)
    phtpyco $p |- ( ( J e. Top /\ ( F e. ( II Cn J ) /\ G e. ( II Cn J ) /\
     H e. ( II Cn J ) ) /\ ( ( ( F ` 0 ) = ( G ` 0 ) /\ ( F ` 1 ) = ( G ` 1 ) )
              /\ ( ( G ` 0 ) = ( H ` 0 ) /\ ( G ` 1 ) = ( H ` 1 ) ) ) ) ->
              ( ( K e. ( F ( PHtpy ` J ) G ) /\ L e. ( G ( PHtpy ` J ) H ) ) ->
                                          M e. ( F ( PHtpy ` J ) H ) ) ) $=
      cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co
      wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG
      cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa w3a cK cii cii ctx co
      cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG
      cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq
      wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv
      cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv
      cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc
      co wral wa wa cM cii cii ctx co cJ ccn co wcel vt cv cc0 cM co vt cv cF
      cfv wceq vt cv c1 cM co vt cv cH cfv wceq wa cc0 vt cv cM co cc0 cF cfv
      wceq c1 vt cv cM co c1 cF cfv wceq wa wa vt cc0 c1 cicc co wral wa cK cF
      cG cJ cphtpy cfv co wcel cL cG cH cJ cphtpy cfv co wcel wa cM cF cH cJ
      cphtpy cfv co wcel cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG
      cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa w3a
      cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv
      c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK
      co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ
      ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa cM cii cii ctx co cJ ccn co wcel vt cv
      cc0 cM co vt cv cF cfv wceq vt cv c1 cM co vt cv cH cfv wceq wa cc0 vt cv
      cM co cc0 cF cfv wceq c1 vt cv cM co c1 cF cfv wceq wa wa vt cc0 c1 cicc
      co wral wa cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH
      cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa w3a cK
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn
      co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa wa cM cii cii ctx co cJ ccn co wcel vt cv
      cc0 cM co vt cv cF cfv wceq vt cv c1 cM co vt cv cH cfv wceq wa cc0 vt cv
      cM co cc0 cF cfv wceq c1 vt cv cM co c1 cF cfv wceq wa wa vt cc0 c1 cicc
      co wral cJ ctop wcel vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc
      co wral wa cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co
      wcel wa cM cii cii ctx co cJ ccn co wcel cJ ctop wcel cF cii cJ ccn co
      wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG
      cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv
      c1 cH cfv wceq wa wa w3a cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co
      vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0
      cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa
      cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv
      c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL
      co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vx vy vz vw cJ cK
      cL cM phtpyco.1 phtpycolem5 cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ
      ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq
      wa wa w3a cJ ctop wcel cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co
      vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0
      cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa
      cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv
      c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL
      co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral cJ ctop wcel cF cii cJ ccn co wcel
      cG cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa 3simp1 vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co
      vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv wceq
      vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs
      cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral cK cii cii ctx co cJ ccn co wcel cL
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vw cv c1 cK
      co vw cv cc0 cL co wceq vw cc0 c1 cicc co vw cv cc0 c1 cicc co wcel vr cv
      cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv
      cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc
      co wral vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1
      cK co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co
      c1 cF cfv wceq wa wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw
      cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG
      cfv wceq wa wa wa vw cv c1 cK co vw cv cc0 cL co wceq vw cv cc0 c1 cicc
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK
      co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1
      cF cfv wceq wa wa vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv
      cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv
      wceq wa wa vs cc0 c1 cicc co wral vw cv cc0 cL co vw cv cG cfv wceq vw cv
      c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL
      co c1 cG cfv wceq wa wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co
      vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co vw cv cG
      cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq
      wa wa vr vw cv cc0 c1 cicc co vr cv vw cv wceq vr cv cc0 cK co vr cv cF
      cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa vw cv cc0 cK co vw cv cF cfv
      wceq vw cv c1 cK co vw cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq
      c1 vr cv cK co c1 cF cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv
      cK co c1 cF cfv wceq wa vr cv vw cv wceq vr cv cc0 cK co vr cv cF cfv
      wceq vw cv cc0 cK co vw cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      vw cv c1 cK co vw cv cG cfv wceq vr cv vw cv wceq vr cv cc0 cK co vw cv
      cc0 cK co vr cv cF cfv vw cv cF cfv vr cv vw cv cc0 cK opreq1 vr cv vw cv
      cF fveq2 eqeq12d vr cv vw cv wceq vr cv c1 cK co vw cv c1 cK co vr cv cG
      cfv vw cv cG cfv vr cv vw cv c1 cK opreq1 vr cv vw cv cG fveq2 eqeq12d
      anbi12d vr cv vw cv wceq cc0 vr cv cK co cc0 cF cfv wceq cc0 vw cv cK co
      cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq c1 vw cv cK co c1 cF cfv
      wceq vr cv vw cv wceq cc0 vr cv cK co cc0 vw cv cK co cc0 cF cfv vr cv vw
      cv cc0 cK opreq2 eqeq1d vr cv vw cv wceq c1 vr cv cK co c1 vw cv cK co c1
      cF cfv vr cv vw cv c1 cK opreq2 eqeq1d anbi12d anbi12d rcla4v vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vw cv cc0 cL co vw
      cv cG cfv wceq vw cv c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG
      cfv wceq c1 vw cv cL co c1 cG cfv wceq wa wa vs vw cv cc0 c1 cicc co vs
      cv vw cv wceq vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH
      cfv wceq wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa vs cv vw
      cv wceq vs cv cc0 cL co vs cv cG cfv wceq vw cv cc0 cL co vw cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq vw cv c1 cL co vw cv cH cfv wceq vs
      cv vw cv wceq vs cv cc0 cL co vw cv cc0 cL co vs cv cG cfv vw cv cG cfv
      vs cv vw cv cc0 cL opreq1 vs cv vw cv cG fveq2 eqeq12d vs cv vw cv wceq
      vs cv c1 cL co vw cv c1 cL co vs cv cH cfv vw cv cH cfv vs cv vw cv c1 cL
      opreq1 vs cv vw cv cH fveq2 eqeq12d anbi12d vs cv vw cv wceq cc0 vs cv cL
      co cc0 cG cfv wceq cc0 vw cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq c1 vw cv cL co c1 cG cfv wceq vs cv vw cv wceq cc0 vs cv cL co
      cc0 vw cv cL co cc0 cG cfv vs cv vw cv cc0 cL opreq2 eqeq1d vs cv vw cv
      wceq c1 vs cv cL co c1 vw cv cL co c1 cG cfv vs cv vw cv c1 cL opreq2
      eqeq1d anbi12d anbi12d rcla4v anim12d vw cv cc0 cK co vw cv cF cfv wceq
      vw cv c1 cK co vw cv cG cfv wceq wa vw cv cc0 cL co vw cv cG cfv wceq vw
      cv c1 cL co vw cv cH cfv wceq wa vw cv c1 cK co vw cv cc0 cL co wceq cc0
      vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq wa cc0 vw cv cL
      co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa vw cv c1 cK co vw cv
      cG cfv wceq vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cK co vw cv cc0 cL
      co wceq vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cL co vw cv cH cfv
      wceq vw cv c1 cK co vw cv cc0 cL co vw cv cG cfv eqtr3 ad2ant2lr ad2ant2r
      syl6com r19.21aiv ad2ant2l anim12i cK cii cii ctx co cJ ccn co wcel vr cv
      cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv
      cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc
      co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa cK cii
      cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co wcel wa cJ ctop
      wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel
      w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0
      cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa w3a cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co cJ ccn co
      wcel cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq
      vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr
      cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral cL cii cii ctx co cJ
      ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa simpll cK cii cii ctx co cJ ccn co wcel vr
      cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr
      cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1
      cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG
      cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv
      wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral simprl
      jca adantl sylanc cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa
      cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cJ ctop wcel cK
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn
      co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa vt cv cc0 cM co vt cv cF cfv wceq vt cv
      c1 cM co vt cv cH cfv wceq wa cc0 vt cv cM co cc0 cF cfv wceq c1 vt cv cM
      co c1 cF cfv wceq wa wa vt cc0 c1 cicc co wral cF cii cJ ccn co wcel cG
      cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq
      c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH
      cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF
      cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv
      wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii
      cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL
      co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1
      cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 cM co vt cv
      cF cfv wceq vt cv c1 cM co vt cv cH cfv wceq wa cc0 vt cv cM co cc0 cF
      cfv wceq c1 vt cv cM co c1 cF cfv wceq wa wa vt cc0 c1 cicc co cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK
      co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co
      cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co
      wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vt cv
      cc0 c1 cicc co wcel wa vt cv cc0 cM co vt cv cF cfv wceq vt cv c1 cM co
      vt cv cH cfv wceq cc0 vt cv cM co cc0 cF cfv wceq c1 vt cv cM co c1 cF
      cfv wceq wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG
      cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ
      ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa wa vt cv cc0 c1 cicc co wcel wa vt cv cc0 cM co vt cv c2 cc0
      cmul co cK co vt cv cF cfv vt cv cc0 c1 cicc co wcel vt cv cc0 cM co vt
      cv c2 cc0 cmul co cK co wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG
      cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn
      co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 cicc co wcel cc0 cc0 c1
      c2 cdiv co cicc co wcel vt cv cc0 cM co vt cv c2 cc0 cmul co cK co wceq
      cc0 cc0 c1 c2 cdiv co cicc co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 c1 c2
      cdiv co cle wbr w3a cc0 cr wcel cc0 cc0 cle wbr cc0 c1 c2 cdiv co cle wbr
      0re cc0 0re leidi cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli halfgt0
      ltleii 3pm3.2i cc0 cr wcel c1 c2 cdiv co cr wcel cc0 cc0 c1 c2 cdiv co
      cicc co wcel cc0 cr wcel cc0 cc0 cle wbr cc0 c1 c2 cdiv co cle wbr w3a wb
      0re c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co cc0 elicc2 mp2an mpbir vx vy
      vz cK cL cM vt cv cc0 phtpyco.1 phtpycolem1 mpan2 adantl cc0 cF cfv cc0
      cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG
      cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co
      vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0
      cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa
      cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv
      c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL
      co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 cicc
      co wcel wa vt cv cc0 cK co vt cv cF cfv vt cv c2 cc0 cmul co cK co cK cii
      cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co
      wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq
      wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs
      cc0 c1 cicc co wral wa wa vt cv cc0 c1 cicc co wcel vt cv cc0 cK co vt cv
      cF cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG
      cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ
      ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa vt cv cc0 c1 cicc co wcel vt cv cc0 cK co vt
      cv cF cfv wceq cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG
      cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv
      wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vr cv
      cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv
      cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc
      co wral vt cv cc0 c1 cicc co wcel vt cv cc0 cK co vt cv cF cfv wceq cK
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral vt cv cc0 c1 cicc co wcel wa
      vt cv cc0 cK co vt cv cF cfv wceq vt cv c1 cK co vt cv cG cfv wceq wa cc0
      vt cv cK co cc0 cF cfv wceq c1 vt cv cK co c1 cF cfv wceq wa wa vt cv cc0
      cK co vt cv cF cfv wceq vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co
      vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vt cv cc0 cK co vt cv cF cfv wceq vt cv c1 cK co vt cv cG
      cfv wceq wa cc0 vt cv cK co cc0 cF cfv wceq c1 vt cv cK co c1 cF cfv wceq
      wa wa vr vt cv cc0 c1 cicc co vr cv vt cv wceq vr cv cc0 cK co vr cv cF
      cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa vt cv cc0 cK co vt cv cF cfv
      wceq vt cv c1 cK co vt cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq
      c1 vr cv cK co c1 cF cfv wceq wa cc0 vt cv cK co cc0 cF cfv wceq c1 vt cv
      cK co c1 cF cfv wceq wa vr cv vt cv wceq vr cv cc0 cK co vr cv cF cfv
      wceq vt cv cc0 cK co vt cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      vt cv c1 cK co vt cv cG cfv wceq vr cv vt cv wceq vr cv cc0 cK co vt cv
      cc0 cK co vr cv cF cfv vt cv cF cfv vr cv vt cv cc0 cK opreq1 vr cv vt cv
      cF fveq2 eqeq12d vr cv vt cv wceq vr cv c1 cK co vt cv c1 cK co vr cv cG
      cfv vt cv cG cfv vr cv vt cv c1 cK opreq1 vr cv vt cv cG fveq2 eqeq12d
      anbi12d vr cv vt cv wceq cc0 vr cv cK co cc0 cF cfv wceq cc0 vt cv cK co
      cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq c1 vt cv cK co c1 cF cfv
      wceq vr cv vt cv wceq cc0 vr cv cK co cc0 vt cv cK co cc0 cF cfv vr cv vt
      cv cc0 cK opreq2 eqeq1d vr cv vt cv wceq c1 vr cv cK co c1 vt cv cK co c1
      cF cfv vr cv vt cv c1 cK opreq2 eqeq1d anbi12d anbi12d rcla4cva vt cv cc0
      cK co vt cv cF cfv wceq vt cv c1 cK co vt cv cG cfv wceq cc0 vt cv cK co
      cc0 cF cfv wceq c1 vt cv cK co c1 cF cfv wceq wa simpll syl adantll
      adantlr adantll c2 cc0 cmul co cc0 vt cv cK c2 2cn mul01i opreq2i syl5eq
      eqtrd cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv
      cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa wa vt cv cc0 c1 cicc co wcel wa vt cv c1 cM co vt cv c2 c1
      cmul co c1 cmin co cL co vt cv cH cfv vw cv c1 cK co vw cv cc0 cL co wceq
      vw cc0 c1 cicc co wral vt cv cc0 c1 cicc co wcel vt cv c1 cM co vt cv c2
      c1 cmul co c1 cmin co cL co wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1
      cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa
      cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv
      c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK
      co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ
      ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa wa vw cv c1 cK co vw cv cc0 cL co wceq vw
      cc0 c1 cicc co wral vt cv cc0 c1 cicc co wcel c1 c1 c2 cdiv co c1 cicc co
      wcel vt cv c1 cM co vt cv c2 c1 cmul co c1 cmin co cL co wceq c1 c1 c2
      cdiv co c1 cicc co wcel c1 cr wcel c1 c2 cdiv co c1 cle wbr c1 c1 cle wbr
      w3a c1 cr wcel c1 c2 cdiv co c1 cle wbr c1 c1 cle wbr 1re c1 c2 cdiv co
      c1 c2 2re 2ne0 rereccli 1re halflt1 ltleii c1 1re leidi 3pm3.2i c1 c2
      cdiv co cr wcel c1 cr wcel c1 c1 c2 cdiv co c1 cicc co wcel c1 cr wcel c1
      c2 cdiv co c1 cle wbr c1 c1 cle wbr w3a wb c2 2re 2ne0 rereccli 1re c1 c2
      cdiv co c1 c1 elicc2 mp2an mpbir vx vy vz vw cK cL cM vt cv c1 phtpyco.1
      phtpycolem2 mp3an3 cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv
      cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq
      wa wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr
      cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs
      cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq wa wa vs cc0 c1 cicc co wral vw cv c1 cK co vw cv cc0 cL co wceq
      vw cc0 c1 cicc co wral cK cii cii ctx co cJ ccn co wcel cL cii cii ctx co
      cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG
      cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq
      wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vw cv c1 cK co vw cv cc0
      cL co wceq vw cc0 c1 cicc co vw cv cc0 c1 cicc co wcel vr cv cc0 cK co vr
      cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral vs cv
      cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv
      cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc
      co wral wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co vw cv cG cfv
      wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq wa
      wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw cv cH cfv wceq wa
      cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa wa wa vw
      cv c1 cK co vw cv cc0 cL co wceq vw cv cc0 c1 cicc co wcel vr cv cc0 cK
      co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co
      cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co
      wral vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co vw cv cG cfv wceq
      wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq wa wa vs
      cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs
      cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1
      cicc co wral vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw cv cH
      cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq
      wa wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vw
      cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co vw cv cG cfv wceq wa cc0 vw
      cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq wa wa vr vw cv cc0
      c1 cicc co vr cv vw cv wceq vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co
      vw cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq
      wa vr cv vw cv wceq vr cv cc0 cK co vr cv cF cfv wceq vw cv cc0 cK co vw
      cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq vw cv c1 cK co vw cv cG
      cfv wceq vr cv vw cv wceq vr cv cc0 cK co vw cv cc0 cK co vr cv cF cfv vw
      cv cF cfv vr cv vw cv cc0 cK opreq1 vr cv vw cv cF fveq2 eqeq12d vr cv vw
      cv wceq vr cv c1 cK co vw cv c1 cK co vr cv cG cfv vw cv cG cfv vr cv vw
      cv c1 cK opreq1 vr cv vw cv cG fveq2 eqeq12d anbi12d vr cv vw cv wceq cc0
      vr cv cK co cc0 cF cfv wceq cc0 vw cv cK co cc0 cF cfv wceq c1 vr cv cK
      co c1 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq vr cv vw cv wceq cc0 vr
      cv cK co cc0 vw cv cK co cc0 cF cfv vr cv vw cv cc0 cK opreq2 eqeq1d vr
      cv vw cv wceq c1 vr cv cK co c1 vw cv cK co c1 cF cfv vr cv vw cv c1 cK
      opreq2 eqeq1d anbi12d anbi12d rcla4v vs cv cc0 cL co vs cv cG cfv wceq vs
      cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv
      cL co c1 cG cfv wceq wa wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL
      co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1
      cG cfv wceq wa wa vs vw cv cc0 c1 cicc co vs cv vw cv wceq vs cv cc0 cL
      co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa vw cv cc0 cL co
      vw cv cG cfv wceq vw cv c1 cL co vw cv cH cfv wceq wa cc0 vs cv cL co cc0
      cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa cc0 vw cv cL co cc0 cG cfv
      wceq c1 vw cv cL co c1 cG cfv wceq wa vs cv vw cv wceq vs cv cc0 cL co vs
      cv cG cfv wceq vw cv cc0 cL co vw cv cG cfv wceq vs cv c1 cL co vs cv cH
      cfv wceq vw cv c1 cL co vw cv cH cfv wceq vs cv vw cv wceq vs cv cc0 cL
      co vw cv cc0 cL co vs cv cG cfv vw cv cG cfv vs cv vw cv cc0 cL opreq1 vs
      cv vw cv cG fveq2 eqeq12d vs cv vw cv wceq vs cv c1 cL co vw cv c1 cL co
      vs cv cH cfv vw cv cH cfv vs cv vw cv c1 cL opreq1 vs cv vw cv cH fveq2
      eqeq12d anbi12d vs cv vw cv wceq cc0 vs cv cL co cc0 cG cfv wceq cc0 vw
      cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq c1 vw cv cL co c1
      cG cfv wceq vs cv vw cv wceq cc0 vs cv cL co cc0 vw cv cL co cc0 cG cfv
      vs cv vw cv cc0 cL opreq2 eqeq1d vs cv vw cv wceq c1 vs cv cL co c1 vw cv
      cL co c1 cG cfv vs cv vw cv c1 cL opreq2 eqeq1d anbi12d anbi12d rcla4v
      anim12d vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co vw cv cG cfv
      wceq wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw cv cH cfv
      wceq wa vw cv c1 cK co vw cv cc0 cL co wceq cc0 vw cv cK co cc0 cF cfv
      wceq c1 vw cv cK co c1 cF cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1
      vw cv cL co c1 cG cfv wceq wa vw cv c1 cK co vw cv cG cfv wceq vw cv cc0
      cL co vw cv cG cfv wceq vw cv c1 cK co vw cv cc0 cL co wceq vw cv cc0 cK
      co vw cv cF cfv wceq vw cv c1 cL co vw cv cH cfv wceq vw cv c1 cK co vw
      cv cc0 cL co vw cv cG cfv eqtr3 ad2ant2lr ad2ant2r syl6com r19.21aiv
      ad2ant2l adantl sylan cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq
      wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii
      ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr
      cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel
      vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0
      vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1
      cicc co wral wa wa wa vt cv cc0 c1 cicc co wcel wa vt cv c1 cL co vt cv
      cH cfv vt cv c2 c1 cmul co c1 cmin co cL co cK cii cii ctx co cJ ccn co
      wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr
      cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co
      vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0
      cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa
      wa vt cv cc0 c1 cicc co wcel vt cv c1 cL co vt cv cH cfv wceq cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL
      co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co
      cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa vt cv cc0 c1 cicc co wcel vt cv c1 cL co vt cv cH cfv wceq cK cii
      cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral wa vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vt cv cc0 c1
      cicc co wcel vt cv c1 cL co vt cv cH cfv wceq cL cii cii ctx co cJ ccn co
      wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq
      wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs
      cc0 c1 cicc co wral vt cv cc0 c1 cicc co wcel wa vt cv cc0 cL co vt cv cG
      cfv wceq vt cv c1 cL co vt cv cH cfv wceq wa cc0 vt cv cL co cc0 cG cfv
      wceq c1 vt cv cL co c1 cG cfv wceq wa wa vt cv c1 cL co vt cv cH cfv wceq
      vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0
      vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vt cv cc0
      cL co vt cv cG cfv wceq vt cv c1 cL co vt cv cH cfv wceq wa cc0 vt cv cL
      co cc0 cG cfv wceq c1 vt cv cL co c1 cG cfv wceq wa wa vs vt cv cc0 c1
      cicc co vs cv vt cv wceq vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co
      vs cv cH cfv wceq wa vt cv cc0 cL co vt cv cG cfv wceq vt cv c1 cL co vt
      cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq wa cc0 vt cv cL co cc0 cG cfv wceq c1 vt cv cL co c1 cG cfv wceq
      wa vs cv vt cv wceq vs cv cc0 cL co vs cv cG cfv wceq vt cv cc0 cL co vt
      cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq vt cv c1 cL co vt cv cH
      cfv wceq vs cv vt cv wceq vs cv cc0 cL co vt cv cc0 cL co vs cv cG cfv vt
      cv cG cfv vs cv vt cv cc0 cL opreq1 vs cv vt cv cG fveq2 eqeq12d vs cv vt
      cv wceq vs cv c1 cL co vt cv c1 cL co vs cv cH cfv vt cv cH cfv vs cv vt
      cv c1 cL opreq1 vs cv vt cv cH fveq2 eqeq12d anbi12d vs cv vt cv wceq cc0
      vs cv cL co cc0 cG cfv wceq cc0 vt cv cL co cc0 cG cfv wceq c1 vs cv cL
      co c1 cG cfv wceq c1 vt cv cL co c1 cG cfv wceq vs cv vt cv wceq cc0 vs
      cv cL co cc0 vt cv cL co cc0 cG cfv vs cv vt cv cc0 cL opreq2 eqeq1d vs
      cv vt cv wceq c1 vs cv cL co c1 vt cv cL co c1 cG cfv vs cv vt cv c1 cL
      opreq2 eqeq1d anbi12d anbi12d rcla4cva vt cv cc0 cL co vt cv cG cfv wceq
      vt cv c1 cL co vt cv cH cfv wceq cc0 vt cv cL co cc0 cG cfv wceq c1 vt cv
      cL co c1 cG cfv wceq wa simplr syl adantll adantll adantll c2 c1 cmul co
      c1 cmin co c1 vt cv cL c2 c1 cmul co c1 cmin co c2 c1 cmin co c1 c2 c1
      cmul co c2 c1 cmin c2 2cn mulid1i opreq1i c2 c1 c1 2cn ax1cn ax1cn 1p1e2
      subaddrii eqtri opreq2i syl5eq eqtrd cc0 cF cfv cc0 cG cfv wceq c1 cF cfv
      c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa
      wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr
      cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv
      cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ
      ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 cicc co wcel wa cc0 vt cv
      cM co cc0 cF cfv wceq c1 vt cv cM co c1 cF cfv wceq cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv
      cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 c2 cdiv
      co cicc co wcel vt cv c1 c2 cdiv co c1 cicc co wcel wo cc0 vt cv cM co
      cc0 cF cfv wceq vt cv cc0 c1 cicc co wcel cc0 cF cfv cc0 cG cfv wceq c1
      cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv
      wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv
      wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq
      c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii
      ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs
      cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 c2 cdiv co
      cicc co wcel cc0 vt cv cM co cc0 cF cfv wceq vt cv c1 c2 cdiv co c1 cicc
      co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv
      cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa wa vt cv cc0 c1 c2 cdiv co cicc co wcel wa cc0 vt cv cM co cc0
      c2 vt cv cmul co cK co cc0 cF cfv vt cv cc0 c1 c2 cdiv co cicc co wcel
      cc0 vt cv cM co cc0 c2 vt cv cmul co cK co wceq cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv
      cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa cc0 cc0 c1 cicc co
      wcel vt cv cc0 c1 c2 cdiv co cicc co wcel cc0 vt cv cM co cc0 c2 vt cv
      cmul co cK co wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr cc0 cc0 c1 cicc
      co wcel 0re 1re cc0 c1 0re 1re lt01 ltleii cc0 c1 lbicc2 mp3an vx vy vz
      cK cL cM cc0 vt cv phtpyco.1 phtpycolem1 mpan adantl cK cii cii ctx co cJ
      ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa vt cv cc0 c1 c2 cdiv co cicc co wcel cc0 c2 vt cv cmul co cK
      co cc0 cF cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa
      cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx
      co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv
      cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv
      wceq wa wa vr cc0 c1 cicc co wral wa vt cv cc0 c1 c2 cdiv co cicc co wcel
      cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq cL cii cii ctx co cJ ccn co
      wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq
      wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs
      cc0 c1 cicc co wral wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co
      vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vr cc0 c1 cicc co wral vt cv cc0 c1 c2 cdiv co cicc co
      wcel cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral c2 vt cv cmul co cc0 c1 cicc co wcel cc0 c2 vt
      cv cmul co cK co cc0 cF cfv wceq vt cv cc0 c1 c2 cdiv co cicc co wcel vr
      cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr
      cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1
      cicc co wral c2 vt cv cmul co cc0 c1 cicc co wcel wa c2 vt cv cmul co cc0
      cK co c2 vt cv cmul co cF cfv wceq c2 vt cv cmul co c1 cK co c2 vt cv
      cmul co cG cfv wceq wa cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 c2
      vt cv cmul co cK co c1 cF cfv wceq wa wa cc0 c2 vt cv cmul co cK co cc0
      cF cfv wceq vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa c2 vt cv cmul co cc0 cK co c2 vt cv cmul co cF cfv wceq c2 vt cv cmul
      co c1 cK co c2 vt cv cmul co cG cfv wceq wa cc0 c2 vt cv cmul co cK co
      cc0 cF cfv wceq c1 c2 vt cv cmul co cK co c1 cF cfv wceq wa wa vr c2 vt
      cv cmul co cc0 c1 cicc co vr cv c2 vt cv cmul co wceq vr cv cc0 cK co vr
      cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa c2 vt cv cmul co cc0
      cK co c2 vt cv cmul co cF cfv wceq c2 vt cv cmul co c1 cK co c2 vt cv
      cmul co cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 c2 vt cv
      cmul co cK co c1 cF cfv wceq wa vr cv c2 vt cv cmul co wceq vr cv cc0 cK
      co vr cv cF cfv wceq c2 vt cv cmul co cc0 cK co c2 vt cv cmul co cF cfv
      wceq vr cv c1 cK co vr cv cG cfv wceq c2 vt cv cmul co c1 cK co c2 vt cv
      cmul co cG cfv wceq vr cv c2 vt cv cmul co wceq vr cv cc0 cK co c2 vt cv
      cmul co cc0 cK co vr cv cF cfv c2 vt cv cmul co cF cfv vr cv c2 vt cv
      cmul co cc0 cK opreq1 vr cv c2 vt cv cmul co cF fveq2 eqeq12d vr cv c2 vt
      cv cmul co wceq vr cv c1 cK co c2 vt cv cmul co c1 cK co vr cv cG cfv c2
      vt cv cmul co cG cfv vr cv c2 vt cv cmul co c1 cK opreq1 vr cv c2 vt cv
      cmul co cG fveq2 eqeq12d anbi12d vr cv c2 vt cv cmul co wceq cc0 vr cv cK
      co cc0 cF cfv wceq cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 vr cv cK
      co c1 cF cfv wceq c1 c2 vt cv cmul co cK co c1 cF cfv wceq vr cv c2 vt cv
      cmul co wceq cc0 vr cv cK co cc0 c2 vt cv cmul co cK co cc0 cF cfv vr cv
      c2 vt cv cmul co cc0 cK opreq2 eqeq1d vr cv c2 vt cv cmul co wceq c1 vr
      cv cK co c1 c2 vt cv cmul co cK co c1 cF cfv vr cv c2 vt cv cmul co c1 cK
      opreq2 eqeq1d anbi12d anbi12d rcla4cva c2 vt cv cmul co cc0 cK co c2 vt
      cv cmul co cF cfv wceq c2 vt cv cmul co c1 cK co c2 vt cv cmul co cG cfv
      wceq wa cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 c2 vt cv cmul co cK
      co c1 cF cfv wceq simprl syl vt cv iihalf1 sylan2 adantll adantlr adantll
      eqtrd cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv
      cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa wa vt cv c1 c2 cdiv co c1 cicc co wcel wa cc0 c2 vt cv cmul co
      c1 cmin co cL co cc0 cG cfv cc0 vt cv cM co cc0 cF cfv cK cii cii ctx co
      cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG
      cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq
      wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv
      cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv
      cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc
      co wral wa wa vt cv c1 c2 cdiv co c1 cicc co wcel cc0 c2 vt cv cmul co c1
      cmin co cL co cc0 cG cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG
      cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vt cv c1 c2 cdiv co c1
      cicc co wcel cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv wceq cK cii
      cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral wa vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vt cv c1 c2
      cdiv co c1 cicc co wcel cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv
      wceq cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq
      vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs
      cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral c2 vt cv cmul co c1
      cmin co cc0 c1 cicc co wcel cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG
      cfv wceq vt cv c1 c2 cdiv co c1 cicc co wcel vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral c2 vt cv cmul
      co c1 cmin co cc0 c1 cicc co wcel wa c2 vt cv cmul co c1 cmin co cc0 cL
      co c2 vt cv cmul co c1 cmin co cG cfv wceq c2 vt cv cmul co c1 cmin co c1
      cL co c2 vt cv cmul co c1 cmin co cH cfv wceq wa cc0 c2 vt cv cmul co c1
      cmin co cL co cc0 cG cfv wceq c1 c2 vt cv cmul co c1 cmin co cL co c1 cG
      cfv wceq wa wa cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv wceq vs
      cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs
      cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa c2 vt cv
      cmul co c1 cmin co cc0 cL co c2 vt cv cmul co c1 cmin co cG cfv wceq c2
      vt cv cmul co c1 cmin co c1 cL co c2 vt cv cmul co c1 cmin co cH cfv wceq
      wa cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv wceq c1 c2 vt cv cmul
      co c1 cmin co cL co c1 cG cfv wceq wa wa vs c2 vt cv cmul co c1 cmin co
      cc0 c1 cicc co vs cv c2 vt cv cmul co c1 cmin co wceq vs cv cc0 cL co vs
      cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa c2 vt cv cmul co c1
      cmin co cc0 cL co c2 vt cv cmul co c1 cmin co cG cfv wceq c2 vt cv cmul
      co c1 cmin co c1 cL co c2 vt cv cmul co c1 cmin co cH cfv wceq wa cc0 vs
      cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa cc0 c2 vt cv
      cmul co c1 cmin co cL co cc0 cG cfv wceq c1 c2 vt cv cmul co c1 cmin co
      cL co c1 cG cfv wceq wa vs cv c2 vt cv cmul co c1 cmin co wceq vs cv cc0
      cL co vs cv cG cfv wceq c2 vt cv cmul co c1 cmin co cc0 cL co c2 vt cv
      cmul co c1 cmin co cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq c2 vt cv
      cmul co c1 cmin co c1 cL co c2 vt cv cmul co c1 cmin co cH cfv wceq vs cv
      c2 vt cv cmul co c1 cmin co wceq vs cv cc0 cL co c2 vt cv cmul co c1 cmin
      co cc0 cL co vs cv cG cfv c2 vt cv cmul co c1 cmin co cG cfv vs cv c2 vt
      cv cmul co c1 cmin co cc0 cL opreq1 vs cv c2 vt cv cmul co c1 cmin co cG
      fveq2 eqeq12d vs cv c2 vt cv cmul co c1 cmin co wceq vs cv c1 cL co c2 vt
      cv cmul co c1 cmin co c1 cL co vs cv cH cfv c2 vt cv cmul co c1 cmin co
      cH cfv vs cv c2 vt cv cmul co c1 cmin co c1 cL opreq1 vs cv c2 vt cv cmul
      co c1 cmin co cH fveq2 eqeq12d anbi12d vs cv c2 vt cv cmul co c1 cmin co
      wceq cc0 vs cv cL co cc0 cG cfv wceq cc0 c2 vt cv cmul co c1 cmin co cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq c1 c2 vt cv cmul co c1
      cmin co cL co c1 cG cfv wceq vs cv c2 vt cv cmul co c1 cmin co wceq cc0
      vs cv cL co cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv vs cv c2 vt
      cv cmul co c1 cmin co cc0 cL opreq2 eqeq1d vs cv c2 vt cv cmul co c1 cmin
      co wceq c1 vs cv cL co c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv vs
      cv c2 vt cv cmul co c1 cmin co c1 cL opreq2 eqeq1d anbi12d anbi12d
      rcla4cva c2 vt cv cmul co c1 cmin co cc0 cL co c2 vt cv cmul co c1 cmin
      co cG cfv wceq c2 vt cv cmul co c1 cmin co c1 cL co c2 vt cv cmul co c1
      cmin co cH cfv wceq wa cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv
      wceq c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv wceq simprl syl vt cv
      iihalf2 sylan2 adantll adantll adantll vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral vt cv c1 c2 cdiv co c1 cicc co wcel cc0 vt cv
      cM co cc0 c2 vt cv cmul co c1 cmin co cL co wceq cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv
      cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral cc0 cc0 c1 cicc co wcel vt cv c1 c2
      cdiv co c1 cicc co wcel cc0 vt cv cM co cc0 c2 vt cv cmul co c1 cmin co
      cL co wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr cc0 cc0 c1 cicc co wcel
      0re 1re cc0 c1 0re 1re lt01 ltleii cc0 c1 lbicc2 mp3an vx vy vz vw cK cL
      cM cc0 vt cv phtpyco.1 phtpycolem2 mp3an2 cK cii cii ctx co cJ ccn co
      wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr
      cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co
      vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0
      cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa
      wa vw cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vw cv c1 cK co
      vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cK cii cii ctx co cJ ccn co
      wcel cL cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq
      vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr
      cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs
      cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG
      cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vw
      cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co vw cv cc0 c1 cicc co
      wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr
      cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs
      cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq wa wa vs cc0 c1 cicc co wral wa vw cv cc0 cK co vw cv cF cfv
      wceq vw cv c1 cK co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq
      c1 vw cv cK co c1 cF cfv wceq wa wa vw cv cc0 cL co vw cv cG cfv wceq vw
      cv c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv
      cL co c1 cG cfv wceq wa wa wa vw cv c1 cK co vw cv cc0 cL co wceq vw cv
      cc0 c1 cicc co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr
      cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vr cc0 c1 cicc co wral vw cv cc0 cK co vw cv cF cfv wceq
      vw cv c1 cK co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw
      cv cK co c1 cF cfv wceq wa wa vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vw cv cc0 cL co vw cv cG cfv
      wceq vw cv c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq
      c1 vw cv cL co c1 cG cfv wceq wa wa vr cv cc0 cK co vr cv cF cfv wceq vr
      cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv
      cK co c1 cF cfv wceq wa wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK
      co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1
      cF cfv wceq wa wa vr vw cv cc0 c1 cicc co vr cv vw cv wceq vr cv cc0 cK
      co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa vw cv cc0 cK co
      vw cv cF cfv wceq vw cv c1 cK co vw cv cG cfv wceq wa cc0 vr cv cK co cc0
      cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa cc0 vw cv cK co cc0 cF cfv
      wceq c1 vw cv cK co c1 cF cfv wceq wa vr cv vw cv wceq vr cv cc0 cK co vr
      cv cF cfv wceq vw cv cc0 cK co vw cv cF cfv wceq vr cv c1 cK co vr cv cG
      cfv wceq vw cv c1 cK co vw cv cG cfv wceq vr cv vw cv wceq vr cv cc0 cK
      co vw cv cc0 cK co vr cv cF cfv vw cv cF cfv vr cv vw cv cc0 cK opreq1 vr
      cv vw cv cF fveq2 eqeq12d vr cv vw cv wceq vr cv c1 cK co vw cv c1 cK co
      vr cv cG cfv vw cv cG cfv vr cv vw cv c1 cK opreq1 vr cv vw cv cG fveq2
      eqeq12d anbi12d vr cv vw cv wceq cc0 vr cv cK co cc0 cF cfv wceq cc0 vw
      cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq c1 vw cv cK co c1
      cF cfv wceq vr cv vw cv wceq cc0 vr cv cK co cc0 vw cv cK co cc0 cF cfv
      vr cv vw cv cc0 cK opreq2 eqeq1d vr cv vw cv wceq c1 vr cv cK co c1 vw cv
      cK co c1 cF cfv vr cv vw cv c1 cK opreq2 eqeq1d anbi12d anbi12d rcla4v vs
      cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs
      cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vw cv cc0 cL
      co vw cv cG cfv wceq vw cv c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co
      cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa wa vs vw cv cc0 c1 cicc
      co vs cv vw cv wceq vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs
      cv cH cfv wceq wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw cv
      cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv
      wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa
      vs cv vw cv wceq vs cv cc0 cL co vs cv cG cfv wceq vw cv cc0 cL co vw cv
      cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq vw cv c1 cL co vw cv cH cfv
      wceq vs cv vw cv wceq vs cv cc0 cL co vw cv cc0 cL co vs cv cG cfv vw cv
      cG cfv vs cv vw cv cc0 cL opreq1 vs cv vw cv cG fveq2 eqeq12d vs cv vw cv
      wceq vs cv c1 cL co vw cv c1 cL co vs cv cH cfv vw cv cH cfv vs cv vw cv
      c1 cL opreq1 vs cv vw cv cH fveq2 eqeq12d anbi12d vs cv vw cv wceq cc0 vs
      cv cL co cc0 cG cfv wceq cc0 vw cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq vs cv vw cv wceq cc0 vs cv
      cL co cc0 vw cv cL co cc0 cG cfv vs cv vw cv cc0 cL opreq2 eqeq1d vs cv
      vw cv wceq c1 vs cv cL co c1 vw cv cL co c1 cG cfv vs cv vw cv c1 cL
      opreq2 eqeq1d anbi12d anbi12d rcla4v anim12d vw cv cc0 cK co vw cv cF cfv
      wceq vw cv c1 cK co vw cv cG cfv wceq wa vw cv cc0 cL co vw cv cG cfv
      wceq vw cv c1 cL co vw cv cH cfv wceq wa vw cv c1 cK co vw cv cc0 cL co
      wceq cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq wa cc0
      vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa vw cv c1 cK
      co vw cv cG cfv wceq vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cK co vw
      cv cc0 cL co wceq vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cL co vw cv
      cH cfv wceq vw cv c1 cK co vw cv cc0 cL co vw cv cG cfv eqtr3 ad2ant2lr
      ad2ant2r syl6com r19.21aiv ad2ant2l adantl sylan cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa cc0 cF cfv cc0 cG cfv wceq cK cii cii ctx co cJ ccn co
      wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr
      cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co
      vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0
      cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa
      wa vt cv c1 c2 cdiv co c1 cicc co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa
      simpll ad2antrr 3eqtr4d jaodan vt cv cc0 c1 cicc co wcel vt cv cc0 c1 c2
      cdiv co cicc co c1 c2 cdiv co c1 cicc co cun wcel vt cv cc0 c1 c2 cdiv co
      cicc co wcel vt cv c1 c2 cdiv co c1 cicc co wcel wo cc0 c1 cicc co cc0 c1
      c2 cdiv co cicc co c1 c2 cdiv co c1 cicc co cun vt cv cc0 cr wcel c1 cr
      wcel c1 c2 cdiv co cc0 c1 cicc co wcel cc0 c1 cicc co cc0 c1 c2 cdiv co
      cicc co c1 c2 cdiv co c1 cicc co cun wceq 0re 1re c1 c2 cdiv co cc0 c1
      cicc co wcel c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv
      co c1 cle wbr w3a c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2
      cdiv co c1 cle wbr c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co 0re c2 2re 2ne0
      rereccli halfgt0 ltleii c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1
      ltleii 3pm3.2i cc0 cr wcel c1 cr wcel c1 c2 cdiv co cc0 c1 cicc co wcel
      c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 cle wbr
      w3a wb 0re 1re cc0 c1 c1 c2 cdiv co elicc2 mp2an mpbir cc0 c1 c1 c2 cdiv
      co iccsplit mp3an eleq2i vt cv cc0 c1 c2 cdiv co cicc co c1 c2 cdiv co c1
      cicc co elun bitri sylan2b cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii
      cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co
      wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq
      wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs
      cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 c2 cdiv co cicc co wcel vt cv
      c1 c2 cdiv co c1 cicc co wcel wo c1 vt cv cM co c1 cF cfv wceq vt cv cc0
      c1 cicc co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa
      cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx
      co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv
      cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv
      wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs
      cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs
      cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1
      cicc co wral wa wa wa vt cv cc0 c1 c2 cdiv co cicc co wcel c1 vt cv cM co
      c1 cF cfv wceq vt cv c1 c2 cdiv co c1 cicc co wcel cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv
      cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vt cv cc0 c1 c2 cdiv
      co cicc co wcel wa c1 vt cv cM co c1 c2 vt cv cmul co cK co c1 cF cfv vt
      cv cc0 c1 c2 cdiv co cicc co wcel c1 vt cv cM co c1 c2 vt cv cmul co cK
      co wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv
      cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa wa c1 cc0 c1 cicc co wcel vt cv cc0 c1 c2 cdiv co cicc co wcel
      c1 vt cv cM co c1 c2 vt cv cmul co cK co wceq cc0 cr wcel c1 cr wcel cc0
      c1 cle wbr c1 cc0 c1 cicc co wcel 0re 1re cc0 c1 0re 1re lt01 ltleii cc0
      c1 ubicc2 mp3an vx vy vz cK cL cM c1 vt cv phtpyco.1 phtpycolem1 mpan
      adantl cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq
      vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr
      cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cii cii ctx co
      cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH
      cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq
      wa wa vs cc0 c1 cicc co wral wa wa vt cv cc0 c1 c2 cdiv co cicc co wcel
      c1 c2 vt cv cmul co cK co c1 cF cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq
      wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq
      vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr
      cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa vt cv cc0 c1 c2
      cdiv co cicc co wcel c1 c2 vt cv cmul co cK co c1 cF cfv wceq cL cii cii
      ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs
      cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq wa wa vs cc0 c1 cicc co wral wa vr cv cc0 cK co vr cv cF cfv
      wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq
      c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral vt cv cc0 c1
      c2 cdiv co cicc co wcel c1 c2 vt cv cmul co cK co c1 cF cfv wceq cK cii
      cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral c2 vt cv cmul co cc0 c1 cicc co
      wcel c1 c2 vt cv cmul co cK co c1 cF cfv wceq vt cv cc0 c1 c2 cdiv co
      cicc co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG
      cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq
      wa wa vr cc0 c1 cicc co wral c2 vt cv cmul co cc0 c1 cicc co wcel wa c2
      vt cv cmul co cc0 cK co c2 vt cv cmul co cF cfv wceq c2 vt cv cmul co c1
      cK co c2 vt cv cmul co cG cfv wceq wa cc0 c2 vt cv cmul co cK co cc0 cF
      cfv wceq c1 c2 vt cv cmul co cK co c1 cF cfv wceq wa wa c1 c2 vt cv cmul
      co cK co c1 cF cfv wceq vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co
      vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa c2 vt cv cmul co cc0 cK co c2 vt cv cmul co cF cfv wceq c2
      vt cv cmul co c1 cK co c2 vt cv cmul co cG cfv wceq wa cc0 c2 vt cv cmul
      co cK co cc0 cF cfv wceq c1 c2 vt cv cmul co cK co c1 cF cfv wceq wa wa
      vr c2 vt cv cmul co cc0 c1 cicc co vr cv c2 vt cv cmul co wceq vr cv cc0
      cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa c2 vt cv cmul
      co cc0 cK co c2 vt cv cmul co cF cfv wceq c2 vt cv cmul co c1 cK co c2 vt
      cv cmul co cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 c2 vt cv
      cmul co cK co c1 cF cfv wceq wa vr cv c2 vt cv cmul co wceq vr cv cc0 cK
      co vr cv cF cfv wceq c2 vt cv cmul co cc0 cK co c2 vt cv cmul co cF cfv
      wceq vr cv c1 cK co vr cv cG cfv wceq c2 vt cv cmul co c1 cK co c2 vt cv
      cmul co cG cfv wceq vr cv c2 vt cv cmul co wceq vr cv cc0 cK co c2 vt cv
      cmul co cc0 cK co vr cv cF cfv c2 vt cv cmul co cF cfv vr cv c2 vt cv
      cmul co cc0 cK opreq1 vr cv c2 vt cv cmul co cF fveq2 eqeq12d vr cv c2 vt
      cv cmul co wceq vr cv c1 cK co c2 vt cv cmul co c1 cK co vr cv cG cfv c2
      vt cv cmul co cG cfv vr cv c2 vt cv cmul co c1 cK opreq1 vr cv c2 vt cv
      cmul co cG fveq2 eqeq12d anbi12d vr cv c2 vt cv cmul co wceq cc0 vr cv cK
      co cc0 cF cfv wceq cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 vr cv cK
      co c1 cF cfv wceq c1 c2 vt cv cmul co cK co c1 cF cfv wceq vr cv c2 vt cv
      cmul co wceq cc0 vr cv cK co cc0 c2 vt cv cmul co cK co cc0 cF cfv vr cv
      c2 vt cv cmul co cc0 cK opreq2 eqeq1d vr cv c2 vt cv cmul co wceq c1 vr
      cv cK co c1 c2 vt cv cmul co cK co c1 cF cfv vr cv c2 vt cv cmul co c1 cK
      opreq2 eqeq1d anbi12d anbi12d rcla4cva c2 vt cv cmul co cc0 cK co c2 vt
      cv cmul co cF cfv wceq c2 vt cv cmul co c1 cK co c2 vt cv cmul co cG cfv
      wceq wa cc0 c2 vt cv cmul co cK co cc0 cF cfv wceq c1 c2 vt cv cmul co cK
      co c1 cF cfv wceq simprr syl vt cv iihalf1 sylan2 adantll adantlr adantll
      eqtrd cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv
      cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cK cii cii ctx co cJ ccn
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa wa vt cv c1 c2 cdiv co c1 cicc co wcel wa c1 c2 vt cv cmul co
      c1 cmin co cL co c1 cG cfv c1 vt cv cM co c1 cF cfv cK cii cii ctx co cJ
      ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co
      wral wa wa vt cv c1 c2 cdiv co c1 cicc co wcel c1 c2 vt cv cmul co c1
      cmin co cL co c1 cG cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG
      cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vt cv c1 c2 cdiv co c1
      cicc co wcel c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv wceq cK cii
      cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK
      co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1
      cF cfv wceq wa wa vr cc0 c1 cicc co wral wa vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vt cv c1 c2
      cdiv co c1 cicc co wcel c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv
      wceq cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq
      vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs
      cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral c2 vt cv cmul co c1
      cmin co cc0 c1 cicc co wcel c1 c2 vt cv cmul co c1 cmin co cL co c1 cG
      cfv wceq vt cv c1 c2 cdiv co c1 cicc co wcel vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral c2 vt cv cmul
      co c1 cmin co cc0 c1 cicc co wcel wa c2 vt cv cmul co c1 cmin co cc0 cL
      co c2 vt cv cmul co c1 cmin co cG cfv wceq c2 vt cv cmul co c1 cmin co c1
      cL co c2 vt cv cmul co c1 cmin co cH cfv wceq wa cc0 c2 vt cv cmul co c1
      cmin co cL co cc0 cG cfv wceq c1 c2 vt cv cmul co c1 cmin co cL co c1 cG
      cfv wceq wa wa c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv wceq vs cv
      cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv
      cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa c2 vt cv cmul
      co c1 cmin co cc0 cL co c2 vt cv cmul co c1 cmin co cG cfv wceq c2 vt cv
      cmul co c1 cmin co c1 cL co c2 vt cv cmul co c1 cmin co cH cfv wceq wa
      cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv wceq c1 c2 vt cv cmul co
      c1 cmin co cL co c1 cG cfv wceq wa wa vs c2 vt cv cmul co c1 cmin co cc0
      c1 cicc co vs cv c2 vt cv cmul co c1 cmin co wceq vs cv cc0 cL co vs cv
      cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa c2 vt cv cmul co c1 cmin
      co cc0 cL co c2 vt cv cmul co c1 cmin co cG cfv wceq c2 vt cv cmul co c1
      cmin co c1 cL co c2 vt cv cmul co c1 cmin co cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa cc0 c2 vt cv cmul co
      c1 cmin co cL co cc0 cG cfv wceq c1 c2 vt cv cmul co c1 cmin co cL co c1
      cG cfv wceq wa vs cv c2 vt cv cmul co c1 cmin co wceq vs cv cc0 cL co vs
      cv cG cfv wceq c2 vt cv cmul co c1 cmin co cc0 cL co c2 vt cv cmul co c1
      cmin co cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq c2 vt cv cmul co c1
      cmin co c1 cL co c2 vt cv cmul co c1 cmin co cH cfv wceq vs cv c2 vt cv
      cmul co c1 cmin co wceq vs cv cc0 cL co c2 vt cv cmul co c1 cmin co cc0
      cL co vs cv cG cfv c2 vt cv cmul co c1 cmin co cG cfv vs cv c2 vt cv cmul
      co c1 cmin co cc0 cL opreq1 vs cv c2 vt cv cmul co c1 cmin co cG fveq2
      eqeq12d vs cv c2 vt cv cmul co c1 cmin co wceq vs cv c1 cL co c2 vt cv
      cmul co c1 cmin co c1 cL co vs cv cH cfv c2 vt cv cmul co c1 cmin co cH
      cfv vs cv c2 vt cv cmul co c1 cmin co c1 cL opreq1 vs cv c2 vt cv cmul co
      c1 cmin co cH fveq2 eqeq12d anbi12d vs cv c2 vt cv cmul co c1 cmin co
      wceq cc0 vs cv cL co cc0 cG cfv wceq cc0 c2 vt cv cmul co c1 cmin co cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq c1 c2 vt cv cmul co c1
      cmin co cL co c1 cG cfv wceq vs cv c2 vt cv cmul co c1 cmin co wceq cc0
      vs cv cL co cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv vs cv c2 vt
      cv cmul co c1 cmin co cc0 cL opreq2 eqeq1d vs cv c2 vt cv cmul co c1 cmin
      co wceq c1 vs cv cL co c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv vs
      cv c2 vt cv cmul co c1 cmin co c1 cL opreq2 eqeq1d anbi12d anbi12d
      rcla4cva c2 vt cv cmul co c1 cmin co cc0 cL co c2 vt cv cmul co c1 cmin
      co cG cfv wceq c2 vt cv cmul co c1 cmin co c1 cL co c2 vt cv cmul co c1
      cmin co cH cfv wceq wa cc0 c2 vt cv cmul co c1 cmin co cL co cc0 cG cfv
      wceq c1 c2 vt cv cmul co c1 cmin co cL co c1 cG cfv wceq simprr syl vt cv
      iihalf2 sylan2 adantll adantll adantll vw cv c1 cK co vw cv cc0 cL co
      wceq vw cc0 c1 cicc co wral vt cv c1 c2 cdiv co c1 cicc co wcel c1 vt cv
      cM co c1 c2 vt cv cmul co c1 cmin co cL co wceq cc0 cF cfv cc0 cG cfv
      wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa wa cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv
      cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF
      cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL
      cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1
      cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co
      c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa wa vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral c1 cc0 c1 cicc co wcel vt cv c1 c2
      cdiv co c1 cicc co wcel c1 vt cv cM co c1 c2 vt cv cmul co c1 cmin co cL
      co wceq cc0 cr wcel c1 cr wcel cc0 c1 cle wbr c1 cc0 c1 cicc co wcel 0re
      1re cc0 c1 0re 1re lt01 ltleii cc0 c1 ubicc2 mp3an vx vy vz vw cK cL cM
      c1 vt cv phtpyco.1 phtpycolem2 mp3an2 cK cii cii ctx co cJ ccn co wcel vr
      cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr
      cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1
      cicc co wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG
      cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv
      wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa vw
      cv c1 cK co vw cv cc0 cL co wceq vw cc0 c1 cicc co wral cc0 cF cfv cc0 cG
      cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv
      c1 cH cfv wceq wa wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr
      cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv wceq
      vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs
      cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral vw cv c1 cK co vw cv
      cc0 cL co wceq vw cc0 c1 cicc co wral cK cii cii ctx co cJ ccn co wcel cL
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa vw cv c1 cK
      co vw cv cc0 cL co wceq vw cc0 c1 cicc co vw cv cc0 c1 cicc co wcel vr cv
      cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv
      cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc
      co wral vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      wa vs cc0 c1 cicc co wral wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1
      cK co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co
      c1 cF cfv wceq wa wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw
      cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG
      cfv wceq wa wa wa vw cv c1 cK co vw cv cc0 cL co wceq vw cv cc0 c1 cicc
      co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv
      wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa
      wa vr cc0 c1 cicc co wral vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK
      co vw cv cG cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1
      cF cfv wceq wa wa vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv
      cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv
      wceq wa wa vs cc0 c1 cicc co wral vw cv cc0 cL co vw cv cG cfv wceq vw cv
      c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL
      co c1 cG cfv wceq wa wa vr cv cc0 cK co vr cv cF cfv wceq vr cv c1 cK co
      vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co c1 cF
      cfv wceq wa wa vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cK co vw cv cG
      cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq
      wa wa vr vw cv cc0 c1 cicc co vr cv vw cv wceq vr cv cc0 cK co vr cv cF
      cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa vw cv cc0 cK co vw cv cF cfv
      wceq vw cv c1 cK co vw cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq
      c1 vr cv cK co c1 cF cfv wceq wa cc0 vw cv cK co cc0 cF cfv wceq c1 vw cv
      cK co c1 cF cfv wceq wa vr cv vw cv wceq vr cv cc0 cK co vr cv cF cfv
      wceq vw cv cc0 cK co vw cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq
      vw cv c1 cK co vw cv cG cfv wceq vr cv vw cv wceq vr cv cc0 cK co vw cv
      cc0 cK co vr cv cF cfv vw cv cF cfv vr cv vw cv cc0 cK opreq1 vr cv vw cv
      cF fveq2 eqeq12d vr cv vw cv wceq vr cv c1 cK co vw cv c1 cK co vr cv cG
      cfv vw cv cG cfv vr cv vw cv c1 cK opreq1 vr cv vw cv cG fveq2 eqeq12d
      anbi12d vr cv vw cv wceq cc0 vr cv cK co cc0 cF cfv wceq cc0 vw cv cK co
      cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq c1 vw cv cK co c1 cF cfv
      wceq vr cv vw cv wceq cc0 vr cv cK co cc0 vw cv cK co cc0 cF cfv vr cv vw
      cv cc0 cK opreq2 eqeq1d vr cv vw cv wceq c1 vr cv cK co c1 vw cv cK co c1
      cF cfv vr cv vw cv c1 cK opreq2 eqeq1d anbi12d anbi12d rcla4v vs cv cc0
      cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL
      co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vw cv cc0 cL co vw
      cv cG cfv wceq vw cv c1 cL co vw cv cH cfv wceq wa cc0 vw cv cL co cc0 cG
      cfv wceq c1 vw cv cL co c1 cG cfv wceq wa wa vs vw cv cc0 c1 cicc co vs
      cv vw cv wceq vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH
      cfv wceq wa vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cL co vw cv cH cfv
      wceq wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa
      cc0 vw cv cL co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa vs cv vw
      cv wceq vs cv cc0 cL co vs cv cG cfv wceq vw cv cc0 cL co vw cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq vw cv c1 cL co vw cv cH cfv wceq vs
      cv vw cv wceq vs cv cc0 cL co vw cv cc0 cL co vs cv cG cfv vw cv cG cfv
      vs cv vw cv cc0 cL opreq1 vs cv vw cv cG fveq2 eqeq12d vs cv vw cv wceq
      vs cv c1 cL co vw cv c1 cL co vs cv cH cfv vw cv cH cfv vs cv vw cv c1 cL
      opreq1 vs cv vw cv cH fveq2 eqeq12d anbi12d vs cv vw cv wceq cc0 vs cv cL
      co cc0 cG cfv wceq cc0 vw cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG
      cfv wceq c1 vw cv cL co c1 cG cfv wceq vs cv vw cv wceq cc0 vs cv cL co
      cc0 vw cv cL co cc0 cG cfv vs cv vw cv cc0 cL opreq2 eqeq1d vs cv vw cv
      wceq c1 vs cv cL co c1 vw cv cL co c1 cG cfv vs cv vw cv c1 cL opreq2
      eqeq1d anbi12d anbi12d rcla4v anim12d vw cv cc0 cK co vw cv cF cfv wceq
      vw cv c1 cK co vw cv cG cfv wceq wa vw cv cc0 cL co vw cv cG cfv wceq vw
      cv c1 cL co vw cv cH cfv wceq wa vw cv c1 cK co vw cv cc0 cL co wceq cc0
      vw cv cK co cc0 cF cfv wceq c1 vw cv cK co c1 cF cfv wceq wa cc0 vw cv cL
      co cc0 cG cfv wceq c1 vw cv cL co c1 cG cfv wceq wa vw cv c1 cK co vw cv
      cG cfv wceq vw cv cc0 cL co vw cv cG cfv wceq vw cv c1 cK co vw cv cc0 cL
      co wceq vw cv cc0 cK co vw cv cF cfv wceq vw cv c1 cL co vw cv cH cfv
      wceq vw cv c1 cK co vw cv cc0 cL co vw cv cG cfv eqtr3 ad2ant2lr ad2ant2r
      syl6com r19.21aiv ad2ant2l adantl sylan cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq
      wa wa c1 cF cfv c1 cG cfv wceq cK cii cii ctx co cJ ccn co wcel vr cv cc0
      cK co vr cv cF cfv wceq vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK
      co cc0 cF cfv wceq c1 vr cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co
      wral wa cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv cG cfv
      wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG cfv wceq
      c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa wa vt cv c1
      c2 cdiv co c1 cicc co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa simplr
      ad2antrr 3eqtr4d jaodan vt cv cc0 c1 cicc co wcel vt cv cc0 c1 c2 cdiv co
      cicc co c1 c2 cdiv co c1 cicc co cun wcel vt cv cc0 c1 c2 cdiv co cicc co
      wcel vt cv c1 c2 cdiv co c1 cicc co wcel wo cc0 c1 cicc co cc0 c1 c2 cdiv
      co cicc co c1 c2 cdiv co c1 cicc co cun vt cv cc0 cr wcel c1 cr wcel c1
      c2 cdiv co cc0 c1 cicc co wcel cc0 c1 cicc co cc0 c1 c2 cdiv co cicc co
      c1 c2 cdiv co c1 cicc co cun wceq 0re 1re c1 c2 cdiv co cc0 c1 cicc co
      wcel c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 cle
      wbr w3a c1 c2 cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1
      cle wbr c2 2re 2ne0 rereccli cc0 c1 c2 cdiv co 0re c2 2re 2ne0 rereccli
      halfgt0 ltleii c1 c2 cdiv co c1 c2 2re 2ne0 rereccli 1re halflt1 ltleii
      3pm3.2i cc0 cr wcel c1 cr wcel c1 c2 cdiv co cc0 c1 cicc co wcel c1 c2
      cdiv co cr wcel cc0 c1 c2 cdiv co cle wbr c1 c2 cdiv co c1 cle wbr w3a wb
      0re 1re cc0 c1 c1 c2 cdiv co elicc2 mp2an mpbir cc0 c1 c1 c2 cdiv co
      iccsplit mp3an eleq2i vt cv cc0 c1 c2 cdiv co cicc co c1 c2 cdiv co c1
      cicc co elun bitri sylan2b jca jca31 r19.21aiva 3ad2antl3 jca ex cJ ctop
      wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel
      w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0
      cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa w3a cK cF cG cJ cphtpy cfv co
      wcel cK cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq
      vr cv c1 cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr
      cv cK co c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa cL cG cH cJ
      cphtpy cfv co wcel cL cii cii ctx co cJ ccn co wcel vs cv cc0 cL co vs cv
      cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq wa cc0 vs cv cL co cc0 cG
      cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs cc0 c1 cicc co wral wa cJ
      ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv cc0
      cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cK cF cG cJ cphtpy cfv co wcel cK
      cii cii ctx co cJ ccn co wcel vr cv cc0 cK co vr cv cF cfv wceq vr cv c1
      cK co vr cv cG cfv wceq wa cc0 vr cv cK co cc0 cF cfv wceq c1 vr cv cK co
      c1 cF cfv wceq wa wa vr cc0 c1 cicc co wral wa wb cJ ctop wcel cF cii cJ
      ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa wa w3a cF cG cK cJ vr isphtpy cJ ctop wcel cF
      cii cJ ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cJ
      ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cc0 cF cfv cc0
      cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG
      cfv c1 cH cfv wceq wa wa cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn
      co wcel cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel w3a cH
      cii cJ ccn co wcel cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel w3a id 3adant3r3 3adant3 cF cii cJ ccn co wcel cG cii cJ ccn co wcel
      cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cc0 cF
      cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cJ ctop wcel cF cii cJ
      ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa simprl 3adant1 sylanc cJ ctop wcel cG cii cJ ccn
      co wcel cH cii cJ ccn co wcel w3a cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1
      cH cfv wceq wa cL cG cH cJ cphtpy cfv co wcel cL cii cii ctx co cJ ccn co
      wcel vs cv cc0 cL co vs cv cG cfv wceq vs cv c1 cL co vs cv cH cfv wceq
      wa cc0 vs cv cL co cc0 cG cfv wceq c1 vs cv cL co c1 cG cfv wceq wa wa vs
      cc0 c1 cicc co wral wa wb cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ
      ccn co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF
      cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq
      wa wa w3a cG cH cL cJ vs isphtpy cJ ctop wcel cF cii cJ ccn co wcel cG
      cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cJ ctop wcel cG cii cJ ccn
      co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1
      cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa
      cJ ctop wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel cJ ctop wcel cG
      cii cJ ccn co wcel cH cii cJ ccn co wcel w3a cF cii cJ ccn co wcel cJ
      ctop wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel w3a id 3adant3r1
      3adant3 cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH cii cJ ccn co wcel
      w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0
      cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn
      co wcel cH cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1
      cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa
      simprr 3adant1 sylanc anbi12d cJ ctop wcel cF cii cJ ccn co wcel cH cii
      cJ ccn co wcel w3a cc0 cF cfv cc0 cH cfv wceq c1 cF cfv c1 cH cfv wceq wa
      cM cF cH cJ cphtpy cfv co wcel cM cii cii ctx co cJ ccn co wcel vt cv cc0
      cM co vt cv cF cfv wceq vt cv c1 cM co vt cv cH cfv wceq wa cc0 vt cv cM
      co cc0 cF cfv wceq c1 vt cv cM co c1 cF cfv wceq wa wa vt cc0 c1 cicc co
      wral wa wb cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH
      cii cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa w3a cF
      cH cM cJ vt isphtpy cJ ctop wcel cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel cH cii cJ ccn co wcel w3a cJ ctop wcel cF cii cJ ccn co wcel cH cii
      cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa
      cc0 cG cfv cc0 cH cfv wceq c1 cG cfv c1 cH cfv wceq wa wa cJ ctop wcel cF
      cii cJ ccn co wcel cH cii cJ ccn co wcel cJ ctop wcel cF cii cJ ccn co
      wcel cH cii cJ ccn co wcel w3a cG cii cJ ccn co wcel cJ ctop wcel cF cii
      cJ ccn co wcel cH cii cJ ccn co wcel w3a id 3adant3r2 3adant3 cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa cc0 cG cfv cc0 cH cfv wceq c1
      cG cfv c1 cH cfv wceq wa wa cJ ctop wcel cc0 cF cfv cc0 cH cfv wceq c1 cF
      cfv c1 cH cfv wceq wa cF cii cJ ccn co wcel cG cii cJ ccn co wcel cH cii
      cJ ccn co wcel w3a cc0 cF cfv cc0 cG cfv wceq cc0 cG cfv cc0 cH cfv wceq
      c1 cF cfv c1 cG cfv wceq c1 cG cfv c1 cH cfv wceq cc0 cF cfv cc0 cH cfv
      wceq c1 cF cfv c1 cH cfv wceq wa cc0 cF cfv cc0 cG cfv wceq cc0 cG cfv
      cc0 cH cfv wceq wa cc0 cF cfv cc0 cH cfv wceq c1 cF cfv c1 cG cfv wceq c1
      cG cfv c1 cH cfv wceq wa c1 cF cfv c1 cH cfv wceq cc0 cF cfv cc0 cG cfv
      cc0 cH cfv eqtr c1 cF cfv c1 cG cfv c1 cH cfv eqtr anim12i an4s 3ad2ant3
      sylanc 3imtr4d $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d x y f g $.
    $( Define the function which takes a topology and returns the path
       homotopy relation on that topology. $)
    df-phtpc $a |- =~ph = { <. x , y >. | ( x e. Top /\ y = { <. f , g >. |
        ( ( ( f e. ( II Cn x ) /\ g e. ( II Cn x ) ) /\ ( ( f ` 0 ) = ( g ` 0 )
       /\ ( f ` 1 ) = ( g ` 1 ) ) ) /\ ( f ( PHtpy ` x ) g ) =/= (/) ) } ) } $.
  $}

  ${
    $d J x y f g $.
    $( The value of the path homotopy relation. $)
    phtpcval $p |- ( J e. Top -> ( =~ph ` J ) = { <. f , g >. |
        ( ( ( f e. ( II Cn J ) /\ g e. ( II Cn J ) ) /\ ( ( f ` 0 ) = ( g ` 0 )
        /\ ( f ` 1 ) = ( g ` 1 ) ) ) /\ ( f ( PHtpy ` J ) g ) =/= (/) ) } ) $=
      vx vy cJ vf cv cii vx cv ccn co wcel vg cv cii vx cv ccn co wcel wa cc0
      vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv
      vg cv vx cv cphtpy cfv co c0 wne wa vf vg copab vf cv cii cJ ccn co wcel
      vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv
      c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf vg
      copab ctop cphtpc vx cv cJ wceq vf cv cii vx cv ccn co wcel vg cv cii vx
      cv ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv
      cfv wceq wa wa vf cv vg cv vx cv cphtpy cfv co c0 wne wa vf cv cii cJ ccn
      co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1
      vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa
      vf vg vx cv cJ wceq vf cv cii vx cv ccn co wcel vg cv cii vx cv ccn co
      wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq
      wa wa vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv
      cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv vx cv
      cphtpy cfv co c0 wne vf cv vg cv cJ cphtpy cfv co c0 wne vx cv cJ wceq vf
      cv cii vx cv ccn co wcel vg cv cii vx cv ccn co wcel wa vf cv cii cJ ccn
      co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1
      vf cv cfv c1 vg cv cfv wceq wa vx cv cJ wceq vf cv cii vx cv ccn co wcel
      vf cv cii cJ ccn co wcel vg cv cii vx cv ccn co wcel vg cv cii cJ ccn co
      wcel vx cv cJ wceq cii vx cv ccn co cii cJ ccn co vf cv vx cv cJ cii ccn
      opreq2 eleq2d vx cv cJ wceq cii vx cv ccn co cii cJ ccn co vg cv vx cv cJ
      cii ccn opreq2 eleq2d anbi12d anbi1d vx cv cJ wceq vf cv vg cv vx cv
      cphtpy cfv co vf cv vg cv cJ cphtpy cfv co c0 vx cv cJ wceq vx cv cphtpy
      cfv cJ cphtpy cfv vf cv vg cv vx cv cJ cphtpy fveq2 opreqd neeq1d anbi12d
      opabbidv vx vy vf vg df-phtpc vf cv cii cJ ccn co wcel vg cv cii cJ ccn
      co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv
      wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf vg copab vf cv cii
      cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv
      wceq c1 vf cv cfv c1 vg cv cfv wceq wa vf cv vg cv cJ cphtpy cfv co c0
      wne wa wa vf vg copab cvv vf cv cii cJ ccn co wcel vg cv cii cJ ccn co
      wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq
      wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf cv cii cJ ccn co wcel vg
      cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1
      vg cv cfv wceq wa vf cv vg cv cJ cphtpy cfv co c0 wne wa wa vf vg vf cv
      cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv
      cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vf cv vg cv cJ cphtpy cfv co
      c0 wne anass opabbii vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa
      cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vf cv
      vg cv cJ cphtpy cfv co c0 wne wa wa vf vg copab cii cJ ccn co cii cJ ccn
      co cxp cii cJ ccn co cii cJ ccn co cii cJ ccn oprex cii cJ ccn oprex xpex
      cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa vf cv
      vg cv cJ cphtpy cfv co c0 wne wa vf vg cii cJ ccn co cii cJ ccn co
      opabssxp ssexi eqeltri fvopab4 $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J f g $. $d F f g $. $d G f g $. $d A f g $. $d B f g $.
    $( The relation "is path homotopic to". $)
    isphtpc $p |- ( ( J e. Top /\ F e. A /\ G e. B ) -> ( F ( =~ph ` J ) G <->
        ( ( ( F e. ( II Cn J ) /\ G e. ( II Cn J ) ) /\ ( ( F ` 0 ) = ( G ` 0 )
         /\ ( F ` 1 ) = ( G ` 1 ) ) ) /\ ( F ( PHtpy ` J ) G ) =/= (/) ) ) ) $=
      cJ ctop wcel cF cA wcel cG cB wcel w3a cF cG cJ cphtpc cfv wbr cF cG vf
      cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv
      cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv
      co c0 wne wa vf vg copab wbr cF cii cJ ccn co wcel cG cii cJ ccn co wcel
      wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ
      cphtpy cfv co c0 wne wa cJ ctop wcel cF cA wcel cF cG cJ cphtpc cfv wbr
      cF cG vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv
      cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ
      cphtpy cfv co c0 wne wa vf vg copab wbr wb cG cB wcel cJ ctop wcel cJ
      cphtpc cfv vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv
      cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv
      cJ cphtpy cfv co c0 wne wa vf vg copab wceq cF cG cJ cphtpc cfv wbr cF cG
      vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg
      cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy
      cfv co c0 wne wa vf vg copab wbr wb vf vg cJ phtpcval cF cG cJ cphtpc cfv
      vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg
      cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy
      cfv co c0 wne wa vf vg copab breq syl 3ad2ant1 cF cA wcel cG cB wcel cF
      cG vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0
      vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy
      cfv co c0 wne wa vf vg copab wbr cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG
      cJ cphtpy cfv co c0 wne wa wb cJ ctop wcel vf cv cii cJ ccn co wcel vg cv
      cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg
      cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa cF cii cJ ccn co
      wcel vg cv cii cJ ccn co wcel wa cc0 cF cfv cc0 vg cv cfv wceq c1 cF cfv
      c1 vg cv cfv wceq wa wa cF vg cv cJ cphtpy cfv co c0 wne wa cF cii cJ ccn
      co wcel cG cii cJ ccn co wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1
      cG cfv wceq wa wa cF cG cJ cphtpy cfv co c0 wne wa vf vg cF cG cA cB vf
      cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv
      cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv
      co c0 wne wa vf vg copab vf cv cF wceq vf cv cii cJ ccn co wcel vg cv cii
      cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv
      cfv wceq wa wa cF cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 cF
      cfv cc0 vg cv cfv wceq c1 cF cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ
      cphtpy cfv co c0 wne cF vg cv cJ cphtpy cfv co c0 wne vf cv cF wceq vf cv
      cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cF cii cJ ccn co wcel vg
      cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1
      vg cv cfv wceq wa cc0 cF cfv cc0 vg cv cfv wceq c1 cF cfv c1 vg cv cfv
      wceq wa vf cv cF wceq vf cv cii cJ ccn co wcel cF cii cJ ccn co wcel vg
      cv cii cJ ccn co wcel vf cv cF cii cJ ccn co eleq1 anbi1d vf cv cF wceq
      cc0 vf cv cfv cc0 vg cv cfv wceq cc0 cF cfv cc0 vg cv cfv wceq c1 vf cv
      cfv c1 vg cv cfv wceq c1 cF cfv c1 vg cv cfv wceq vf cv cF wceq cc0 vf cv
      cfv cc0 cF cfv cc0 vg cv cfv cc0 vf cv cF fveq1 eqeq1d vf cv cF wceq c1
      vf cv cfv c1 cF cfv c1 vg cv cfv c1 vf cv cF fveq1 eqeq1d anbi12d anbi12d
      vf cv cF wceq vf cv vg cv cJ cphtpy cfv co cF vg cv cJ cphtpy cfv co c0
      vf cv cF vg cv cJ cphtpy cfv opreq1 neeq1d anbi12d vg cv cG wceq cF cii
      cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 cF cfv cc0 vg cv cfv wceq
      c1 cF cfv c1 vg cv cfv wceq wa wa cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF vg
      cv cJ cphtpy cfv co c0 wne cF cG cJ cphtpy cfv co c0 wne vg cv cG wceq cF
      cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cF cii cJ ccn co wcel cG
      cii cJ ccn co wcel wa cc0 cF cfv cc0 vg cv cfv wceq c1 cF cfv c1 vg cv
      cfv wceq wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa vg cv
      cG wceq vg cv cii cJ ccn co wcel cG cii cJ ccn co wcel cF cii cJ ccn co
      wcel vg cv cG cii cJ ccn co eleq1 anbi2d vg cv cG wceq cc0 cF cfv cc0 vg
      cv cfv wceq cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 vg cv cfv wceq c1 cF
      cfv c1 cG cfv wceq vg cv cG wceq cc0 vg cv cfv cc0 cG cfv cc0 cF cfv cc0
      vg cv cG fveq1 eqeq2d vg cv cG wceq c1 vg cv cfv c1 cG cfv c1 cF cfv c1
      vg cv cG fveq1 eqeq2d anbi12d anbi12d vg cv cG wceq cF vg cv cJ cphtpy
      cfv co cF cG cJ cphtpy cfv co c0 vg cv cG cF cJ cphtpy cfv opreq2 neeq1d
      anbi12d vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0 vf cv
      cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv
      cJ cphtpy cfv co c0 wne wa vf vg copab eqid brabg 3adant1 bitrd $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J f g $.
    $( The relation "is path homotopic to". $)
    isphtpc2 $p |- ( ( J e. Top /\ G e. A ) -> ( F ( =~ph ` J ) G <->
        ( ( ( F e. ( II Cn J ) /\ G e. ( II Cn J ) ) /\ ( ( F ` 0 ) = ( G ` 0 )
         /\ ( F ` 1 ) = ( G ` 1 ) ) ) /\ ( F ( PHtpy ` J ) G ) =/= (/) ) ) ) $=
      cJ ctop wcel cG cA wcel wa cF cG cJ cphtpc cfv wbr cF cii cJ ccn co wcel
      cG cii cJ ccn co wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa wa cF cG cJ cphtpy cfv co c0 wne wa cJ ctop wcel cG cA wcel wa cF
      cG cJ cphtpc cfv wbr cF cvv wcel cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG
      cJ cphtpy cfv co c0 wne wa cJ ctop wcel cG cA wcel wa cJ cphtpc cfv wrel
      cF cG cJ cphtpc cfv wbr cF cvv wcel wi cJ ctop wcel cG cA wcel wa cJ
      cphtpc cfv wrel vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel wa cc0
      vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa vf cv
      vg cv cJ cphtpy cfv co c0 wne wa vf vg copab wrel vf cv cii cJ ccn co
      wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf
      cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf
      vg relopab cJ ctop wcel cG cA wcel wa cJ cphtpc cfv vf cv cii cJ ccn co
      wcel vg cv cii cJ ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf
      cv cfv c1 vg cv cfv wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf
      vg copab wceq cJ cphtpc cfv wrel vf cv cii cJ ccn co wcel vg cv cii cJ
      ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv
      wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf vg copab wrel wb cJ
      ctop wcel cJ cphtpc cfv vf cv cii cJ ccn co wcel vg cv cii cJ ccn co wcel
      wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv wceq wa wa
      vf cv vg cv cJ cphtpy cfv co c0 wne wa vf vg copab wceq cG cA wcel vf vg
      cJ phtpcval adantr cJ cphtpc cfv vf cv cii cJ ccn co wcel vg cv cii cJ
      ccn co wcel wa cc0 vf cv cfv cc0 vg cv cfv wceq c1 vf cv cfv c1 vg cv cfv
      wceq wa wa vf cv vg cv cJ cphtpy cfv co c0 wne wa vf vg copab releq syl
      mpbiri cJ cphtpc cfv wrel cF cG cJ cphtpc cfv wbr cF cvv wcel cF cG cJ
      cphtpc cfv brrelex ex syl cJ ctop wcel cG cA wcel wa cF cvv wcel cF cG cJ
      cphtpc cfv wbr cF cii cJ ccn co wcel cG cii cJ ccn co wcel wa cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv co c0
      wne wa cJ ctop wcel cG cA wcel wa cF cvv wcel cF cG cJ cphtpc cfv wbr cF
      cii cJ ccn co wcel cG cii cJ ccn co wcel wa cc0 cF cfv cc0 cG cfv wceq c1
      cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv co c0 wne wa wi cJ ctop
      wcel cF cvv wcel cG cA wcel cF cG cJ cphtpc cfv wbr cF cii cJ ccn co wcel
      cG cii cJ ccn co wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv
      wceq wa wa cF cG cJ cphtpy cfv co c0 wne wa wi cJ ctop wcel cF cvv wcel
      cG cA wcel cF cG cJ cphtpc cfv wbr cF cii cJ ccn co wcel cG cii cJ ccn co
      wcel wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG
      cJ cphtpy cfv co c0 wne wa wi cJ ctop wcel cF cvv wcel cG cA wcel w3a cF
      cG cJ cphtpc cfv wbr cF cii cJ ccn co wcel cG cii cJ ccn co wcel wa cc0
      cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv
      co c0 wne wa cvv cA cF cG cJ isphtpc biimpd 3expa an1rs ex com23 mpdd cJ
      ctop wcel cG cA wcel wa cF cii cJ ccn co wcel cG cii cJ ccn co wcel wa
      cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy
      cfv co c0 wne wa cF cii cJ ccn co wcel cF cG cJ cphtpc cfv wbr cF cii cJ
      ccn co wcel cG cii cJ ccn co wcel cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1
      cG cfv wceq wa cF cG cJ cphtpy cfv co c0 wne simplll cJ ctop wcel cG cA
      wcel wa cF cii cJ ccn co wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel
      wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ
      cphtpy cfv co c0 wne wa cF cG cJ cphtpc cfv wbr cJ ctop wcel cG cA wcel
      wa cF cii cJ ccn co wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel wa
      cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy
      cfv co c0 wne wa cF cG cJ cphtpc cfv wbr wi cJ ctop wcel cF cii cJ ccn co
      wcel cG cA wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel wa cc0 cF cfv
      cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv co c0
      wne wa cF cG cJ cphtpc cfv wbr wi cJ ctop wcel cF cii cJ ccn co wcel cG
      cA wcel cF cii cJ ccn co wcel cG cii cJ ccn co wcel wa cc0 cF cfv cc0 cG
      cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ cphtpy cfv co c0 wne wa
      cF cG cJ cphtpc cfv wbr wi cJ ctop wcel cF cii cJ ccn co wcel cG cA wcel
      w3a cF cG cJ cphtpc cfv wbr cF cii cJ ccn co wcel cG cii cJ ccn co wcel
      wa cc0 cF cfv cc0 cG cfv wceq c1 cF cfv c1 cG cfv wceq wa wa cF cG cJ
      cphtpy cfv co c0 wne wa cii cJ ccn co cA cF cG cJ isphtpc biimprd 3expa
      an1rs ex com23 mpdi impbid $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J r s t x y $.
    $( The domain of the path homotopy relation. $)
    phtpcdm $p |- ( J e. Top -> dom ( =~ph ` J ) = ( II Cn J ) ) $=
      cJ ctop wcel vx cJ cphtpc cfv cdm cii cJ ccn co cJ ctop wcel vx cv cJ
      cphtpc cfv cdm wcel vx cv cii cJ ccn co wcel cJ ctop wcel vx cv vy cv cJ
      cphtpc cfv wbr vy wex vx cv cii cJ ccn co wcel vx cv cJ cphtpc cfv cdm
      wcel cJ ctop wcel vx cv vy cv cJ cphtpc cfv wbr vx cv cii cJ ccn co wcel
      vy cJ ctop wcel vx cv vy cv cJ cphtpc cfv wbr vx cv cii cJ ccn co wcel vy
      cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1
      vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne wa vx cv cii cJ
      ccn co wcel cJ ctop wcel vx cv cvv wcel vy cv cvv wcel vx cv vy cv cJ
      cphtpc cfv wbr vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0
      vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv
      vy cv cJ cphtpy cfv co c0 wne wa wb vx visset vy visset cvv cvv vx cv vy
      cv cJ isphtpc mp3an23 vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel
      cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa vx cv
      vy cv cJ cphtpy cfv co c0 wne simplll syl6bi 19.23adv vy vx cv cJ cphtpc
      cfv vx visset eldm syl5ib cJ ctop wcel vx cv cii cJ ccn co wcel vx cv vy
      cv cJ cphtpc cfv wbr vy wex vx cv cJ cphtpc cfv cdm wcel cJ ctop wcel vx
      cv cii cJ ccn co wcel vx cv vx cv cJ cphtpc cfv wbr vx cv vy cv cJ cphtpc
      cfv wbr vy wex cJ ctop wcel vx cv cii cJ ccn co wcel vx cv vx cv cJ
      cphtpc cfv wbr cJ ctop wcel vx cv cii cJ ccn co wcel wa vx cv vx cv cJ
      cphtpc cfv wbr vx cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel wa cc0
      vx cv cfv cc0 vx cv cfv wceq c1 vx cv cfv c1 vx cv cfv wceq wa wa vx cv
      vx cv cJ cphtpy cfv co c0 wne wa cJ ctop wcel vx cv cii cJ ccn co wcel wa
      vx cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vx
      cv cfv wceq c1 vx cv cfv c1 vx cv cfv wceq wa wa vx cv vx cv cJ cphtpy
      cfv co c0 wne vx cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel vx cv cii
      cJ ccn co wcel wa cc0 vx cv cfv cc0 vx cv cfv wceq c1 vx cv cfv c1 vx cv
      cfv wceq wa wa cJ ctop wcel vx cv cii cJ ccn co wcel vx cv cii cJ ccn co
      wcel vx cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vx cv cfv wceq c1 vx
      cv cfv c1 vx cv cfv wceq wa vx cv cii cJ ccn co wcel vx cv cii cJ ccn co
      wcel vx cv cii cJ ccn co wcel wa vx cv cii cJ ccn co wcel vx cv cii cJ
      ccn co wcel pm3.2 pm2.43i cc0 vx cv cfv cc0 vx cv cfv wceq c1 vx cv cfv
      c1 vx cv cfv wceq cc0 vx cv cfv eqid c1 vx cv cfv eqid pm3.2i jctir
      adantl cJ ctop wcel vx cv cii cJ ccn co wcel wa vr cv cc0 c1 cicc co wcel
      vs cv cc0 c1 cicc co wcel wa vt cv vr cv vx cv cfv wceq wa vr vs vt
      copab2 vx cv vx cv cJ cphtpy cfv co wcel vx cv vx cv cJ cphtpy cfv co c0
      wne vr vs vt vx cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 cicc co wcel wa
      vt cv vr cv vx cv cfv wceq wa vr vs vt copab2 cJ vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 cicc co wcel wa vt cv vr cv vx cv cfv wceq wa vr vs vt
      copab2 eqid phtpyid vx cv vx cv cJ cphtpy cfv co vr cv cc0 c1 cicc co
      wcel vs cv cc0 c1 cicc co wcel wa vt cv vr cv vx cv cfv wceq wa vr vs vt
      copab2 ne0i syl jca cii cJ ccn co vx cv vx cv cJ isphtpc2 mpbird ex vx cv
      vy cv cJ cphtpc cfv wbr vx cv vx cv cJ cphtpc cfv wbr vy vx cv vx visset
      vy cv vx cv vx cv cJ cphtpc cfv breq2 cla4ev syl6 vy vx cv cJ cphtpc cfv
      vx visset eldm syl6ibr impbid eqrdv $.
      $( [2-Sep-2009] $)
  $}

  ${
    $d J r s t v w x y z $.
    $( Path homotopy is an equivalence relation. Proposition 1.2 of Hatcher. $)
    phtpcer $p |- ( J e. Top -> Er ( =~ph ` J ) ) $=
      cJ ctop wcel vx cv vy cv cJ cphtpc cfv wbr vy cv vx cv cJ cphtpc cfv wbr
      wi vx cv vy cv cJ cphtpc cfv wbr vy cv vz cv cJ cphtpc cfv wbr wa vx cv
      vz cv cJ cphtpc cfv wbr wi wa vz wal vy wal vx wal cJ cphtpc cfv wer cJ
      ctop wcel vx cv vy cv cJ cphtpc cfv wbr vy cv vx cv cJ cphtpc cfv wbr wi
      vx cv vy cv cJ cphtpc cfv wbr vy cv vz cv cJ cphtpc cfv wbr wa vx cv vz
      cv cJ cphtpc cfv wbr wi wa vz wal vy wal vx cJ ctop wcel vx cv vy cv cJ
      cphtpc cfv wbr vy cv vx cv cJ cphtpc cfv wbr wi vx cv vy cv cJ cphtpc cfv
      wbr vy cv vz cv cJ cphtpc cfv wbr wa vx cv vz cv cJ cphtpc cfv wbr wi wa
      vy vz cJ ctop wcel vx cv vy cv cJ cphtpc cfv wbr vy cv vx cv cJ cphtpc
      cfv wbr wi vx cv vy cv cJ cphtpc cfv wbr vy cv vz cv cJ cphtpc cfv wbr wa
      vx cv vz cv cJ cphtpc cfv wbr wi cJ ctop wcel vx cv cii cJ ccn co wcel vy
      cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1
      vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne wa vy cv cii cJ
      ccn co wcel vx cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vx cv cfv wceq
      c1 vy cv cfv c1 vx cv cfv wceq wa wa vy cv vx cv cJ cphtpy cfv co c0 wne
      wa vx cv vy cv cJ cphtpc cfv wbr vy cv vx cv cJ cphtpc cfv wbr cJ ctop
      wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv
      cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ
      cphtpy cfv co c0 wne wa vy cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel
      wa cc0 vy cv cfv cc0 vx cv cfv wceq c1 vy cv cfv c1 vx cv cfv wceq wa wa
      vy cv vx cv cJ cphtpy cfv co c0 wne wa cJ ctop wcel vx cv cii cJ ccn co
      wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx
      cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne wa wa
      vy cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vx
      cv cfv wceq c1 vy cv cfv c1 vx cv cfv wceq wa wa vy cv vx cv cJ cphtpy
      cfv co c0 wne vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx
      cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii
      cJ ccn co wcel vx cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vx cv cfv
      wceq c1 vy cv cfv c1 vx cv cfv wceq wa wa cJ ctop wcel vx cv vy cv cJ
      cphtpy cfv co c0 wne vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa
      vy cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy
      cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vx cv cfv
      wceq c1 vy cv cfv c1 vx cv cfv wceq wa vx cv cii cJ ccn co wcel vy cv cii
      cJ ccn co wcel pm3.22 cc0 vx cv cfv cc0 vy cv cfv wceq cc0 vy cv cfv cc0
      vx cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq c1 vy cv cfv c1 vx cv cfv
      wceq cc0 vx cv cfv cc0 vy cv cfv wceq cc0 vy cv cfv cc0 vx cv cfv wceq
      cc0 vx cv cfv cc0 vy cv cfv eqcom biimpi c1 vx cv cfv c1 vy cv cfv wceq
      c1 vy cv cfv c1 vx cv cfv wceq c1 vx cv cfv c1 vy cv cfv eqcom biimpi
      anim12i anim12i ad2antrl cJ ctop wcel vx cv cii cJ ccn co wcel vy cv cii
      cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv
      cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne vy cv vx cv cJ cphtpy
      cfv co c0 wne cJ ctop wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn co
      wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq
      wa wa wa vw cv vx cv vy cv cJ cphtpy cfv co wcel vw wex vy cv vx cv cJ
      cphtpy cfv co c0 wne vx cv vy cv cJ cphtpy cfv co c0 wne cJ ctop wcel vx
      cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa wa vw cv vx cv vy cv cJ
      cphtpy cfv co wcel vy cv vx cv cJ cphtpy cfv co c0 wne vw cJ ctop wcel vx
      cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa vw cv vx cv vy cv cJ cphtpy
      cfv co wcel vy cv vx cv cJ cphtpy cfv co c0 wne wi cJ ctop wcel vx cv cii
      cJ ccn co wcel vy cv cii cJ ccn co wcel cc0 vx cv cfv cc0 vy cv cfv wceq
      c1 vx cv cfv c1 vy cv cfv wceq wa vw cv vx cv vy cv cJ cphtpy cfv co wcel
      vy cv vx cv cJ cphtpy cfv co c0 wne wi wi cJ ctop wcel vx cv cii cJ ccn
      co wcel vy cv cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv cfv wceq c1
      vx cv cfv c1 vy cv cfv wceq wa vw cv vx cv vy cv cJ cphtpy cfv co wcel vy
      cv vx cv cJ cphtpy cfv co c0 wne wi cJ ctop wcel vx cv cii cJ ccn co wcel
      vy cv cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv
      cfv c1 vy cv cfv wceq wa wa vw cv vx cv vy cv cJ cphtpy cfv co wcel vr cv
      cc0 c1 cicc co wcel vs cv cc0 c1 cicc co wcel wa vt cv vr cv c1 vs cv
      cmin co vw cv co wceq wa vr vs vt copab2 vy cv vx cv cJ cphtpy cfv co
      wcel vy cv vx cv cJ cphtpy cfv co c0 wne vr vs vt vx cv vy cv vw cv cJ vr
      cv cc0 c1 cicc co wcel vs cv cc0 c1 cicc co wcel wa vt cv vr cv c1 vs cv
      cmin co vw cv co wceq wa vr vs vt copab2 vr cv cc0 c1 cicc co wcel vs cv
      cc0 c1 cicc co wcel wa vt cv vr cv c1 vs cv cmin co vw cv co wceq wa vr
      vs vt copab2 eqid phtpycom vy cv vx cv cJ cphtpy cfv co vr cv cc0 c1 cicc
      co wcel vs cv cc0 c1 cicc co wcel wa vt cv vr cv c1 vs cv cmin co vw cv
      co wceq wa vr vs vt copab2 ne0i syl6 ex 3expb impr 19.23adv vw vx cv vy
      cv cJ cphtpy cfv co n0 syl5ib impr jca ex cJ ctop wcel vx cv cvv wcel vy
      cv cvv wcel vx cv vy cv cJ cphtpc cfv wbr vx cv cii cJ ccn co wcel vy cv
      cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy
      cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne wa wb vx visset vy
      visset cvv cvv vx cv vy cv cJ isphtpc mp3an23 cJ ctop wcel vy cv cvv wcel
      vx cv cvv wcel vy cv vx cv cJ cphtpc cfv wbr vy cv cii cJ ccn co wcel vx
      cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vx cv cfv wceq c1 vy cv cfv c1
      vx cv cfv wceq wa wa vy cv vx cv cJ cphtpy cfv co c0 wne wa wb vy visset
      vx visset cvv cvv vy cv vx cv cJ isphtpc mp3an23 3imtr4d cJ ctop wcel vx
      cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv
      co c0 wne wa vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy
      cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa vy cv vz
      cv cJ cphtpy cfv co c0 wne wa wa vx cv cii cJ ccn co wcel vz cv cii cJ
      ccn co wcel wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vz cv cfv
      wceq wa wa vx cv vz cv cJ cphtpy cfv co c0 wne wa vx cv vy cv cJ cphtpc
      cfv wbr vy cv vz cv cJ cphtpc cfv wbr wa vx cv vz cv cJ cphtpc cfv wbr cJ
      ctop wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv
      cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv
      cJ cphtpy cfv co c0 wne wa vy cv cii cJ ccn co wcel vz cv cii cJ ccn co
      wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq
      wa wa vy cv vz cv cJ cphtpy cfv co c0 wne wa wa vx cv cii cJ ccn co wcel
      vz cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv
      c1 vz cv cfv wceq wa wa vx cv vz cv cJ cphtpy cfv co c0 wne wa cJ ctop
      wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv
      cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ
      cphtpy cfv co c0 wne wa vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel
      wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa
      vy cv vz cv cJ cphtpy cfv co c0 wne wa wa wa vx cv cii cJ ccn co wcel vz
      cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1
      vz cv cfv wceq wa wa vx cv vz cv cJ cphtpy cfv co c0 wne vx cv cii cJ ccn
      co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1
      vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne wa
      vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz
      cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa vy cv vz cv cJ cphtpy
      cfv co c0 wne wa wa vx cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa
      cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vz cv cfv wceq wa wa cJ
      ctop wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv
      cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii cJ
      ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq
      c1 vy cv cfv c1 vz cv cfv wceq wa wa vx cv cii cJ ccn co wcel vz cv cii
      cJ ccn co wcel wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vz cv
      cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne vy cv vz cv cJ cphtpy
      cfv co c0 wne vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vy cv
      cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv
      wceq c1 vy cv cfv c1 vz cv cfv wceq wa vx cv cii cJ ccn co wcel vz cv cii
      cJ ccn co wcel wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vz cv
      cfv wceq wa wa vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vy cv
      cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa wa vx cv cii cJ ccn co
      wcel vz cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx
      cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv
      c1 vz cv cfv wceq wa wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1
      vz cv cfv wceq wa vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vy
      cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa wa vx cv cii cJ ccn co
      wcel vz cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn
      co wcel vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa simpll vx cv
      cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vy cv cii cJ ccn co wcel
      vz cv cii cJ ccn co wcel simprr jca cc0 vx cv cfv cc0 vy cv cfv wceq cc0
      vy cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq c1 vy cv cfv
      c1 vz cv cfv wceq cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vz cv
      cfv wceq wa cc0 vx cv cfv cc0 vy cv cfv wceq cc0 vy cv cfv cc0 vz cv cfv
      wceq wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq
      c1 vy cv cfv c1 vz cv cfv wceq wa c1 vx cv cfv c1 vz cv cfv wceq cc0 vx
      cv cfv cc0 vy cv cfv cc0 vz cv cfv eqtr c1 vx cv cfv c1 vy cv cfv c1 vz
      cv cfv eqtr anim12i an4s anim12i an4s ad2ant2r adantl vx cv cii cJ ccn co
      wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx
      cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne wa vy
      cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv
      cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa vy cv vz cv cJ cphtpy cfv
      co c0 wne wa wa cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0 wne vx cv
      cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii cJ ccn co wcel vz
      cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1
      vz cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv co c0 wne vy cv vz cv cJ
      cphtpy cfv co c0 wne cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0 wne wi
      vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy
      cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii cJ ccn co wcel
      vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv
      c1 vz cv cfv wceq wa wa wa vx cv vy cv cJ cphtpy cfv co c0 wne vy cv vz
      cv cJ cphtpy cfv co c0 wne cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0
      wne wi vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv
      cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii cJ ccn
      co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1
      vy cv cfv c1 vz cv cfv wceq wa wa wa vv cv vx cv vy cv cJ cphtpy cfv co
      wcel vv wex vy cv vz cv cJ cphtpy cfv co c0 wne cJ ctop wcel vx cv vz cv
      cJ cphtpy cfv co c0 wne wi wi vx cv vy cv cJ cphtpy cfv co c0 wne vx cv
      cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii cJ ccn co wcel vz
      cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1
      vz cv cfv wceq wa wa wa vv cv vx cv vy cv cJ cphtpy cfv co wcel vy cv vz
      cv cJ cphtpy cfv co c0 wne cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0
      wne wi wi vv vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx
      cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii
      cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv
      wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa wa vy cv vz cv cJ cphtpy cfv co
      c0 wne vv cv vx cv vy cv cJ cphtpy cfv co wcel cJ ctop wcel vx cv vz cv
      cJ cphtpy cfv co c0 wne wi vx cv cii cJ ccn co wcel vy cv cii cJ ccn co
      wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq
      wa wa vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv
      cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa wa vw cv vy cv vz
      cv cJ cphtpy cfv co wcel vw wex vv cv vx cv vy cv cJ cphtpy cfv co wcel
      cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0 wne wi wi vy cv vz cv cJ
      cphtpy cfv co c0 wne vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa
      cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vy
      cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv
      cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa wa vw cv vy cv vz cv cJ
      cphtpy cfv co wcel vv cv vx cv vy cv cJ cphtpy cfv co wcel cJ ctop wcel
      vx cv vz cv cJ cphtpy cfv co c0 wne wi wi vw vx cv cii cJ ccn co wcel vy
      cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1
      vy cv cfv wceq wa wa vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa
      cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa wa
      vv cv vx cv vy cv cJ cphtpy cfv co wcel vw cv vy cv vz cv cJ cphtpy cfv
      co wcel cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0 wne wi vx cv cii cJ
      ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq
      c1 vx cv cfv c1 vy cv cfv wceq wa wa vy cv cii cJ ccn co wcel vz cv cii
      cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv
      cfv wceq wa wa wa vv cv vx cv vy cv cJ cphtpy cfv co wcel vw cv vy cv vz
      cv cJ cphtpy cfv co wcel cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0 wne
      wi vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vy cv cii cJ ccn
      co wcel vz cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv cfv wceq c1
      vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv
      cfv c1 vz cv cfv wceq wa vv cv vx cv vy cv cJ cphtpy cfv co wcel vw cv vy
      cv vz cv cJ cphtpy cfv co wcel wa cJ ctop wcel vx cv vz cv cJ cphtpy cfv
      co c0 wne wi wi vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel vz cv
      cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv cfv wceq c1 vx cv cfv c1
      vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv
      cfv wceq wa wa vv cv vx cv vy cv cJ cphtpy cfv co wcel vw cv vy cv vz cv
      cJ cphtpy cfv co wcel wa cJ ctop wcel vx cv vz cv cJ cphtpy cfv co c0 wne
      wi wi vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vy cv cii cJ
      ccn co wcel vz cv cii cJ ccn co wcel wa wa vx cv cii cJ ccn co wcel vy cv
      cii cJ ccn co wcel vz cv cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv
      wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa wa cJ ctop wcel vv cv vx cv vy
      cv cJ cphtpy cfv co wcel vw cv vy cv vz cv cJ cphtpy cfv co wcel wa vx cv
      vz cv cJ cphtpy cfv co c0 wne cJ ctop wcel vx cv cii cJ ccn co wcel vy cv
      cii cJ ccn co wcel vz cv cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv
      wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa wa vv cv vx cv vy cv cJ cphtpy
      cfv co wcel vw cv vy cv vz cv cJ cphtpy cfv co wcel wa vx cv vz cv cJ
      cphtpy cfv co c0 wne wi cJ ctop wcel vx cv cii cJ ccn co wcel vy cv cii
      cJ ccn co wcel vz cv cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv cfv
      wceq c1 vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv wceq
      c1 vy cv cfv c1 vz cv cfv wceq wa wa wa wa vv cv vx cv vy cv cJ cphtpy
      cfv co wcel vw cv vy cv vz cv cJ cphtpy cfv co wcel wa vr cv cc0 c1 cicc
      co wcel vs cv cc0 c1 cicc co wcel wa vt cv vs cv c1 c2 cdiv co cle wbr vr
      cv c2 vs cv cmul co vv cv co vr cv c2 vs cv cmul co c1 cmin co vw cv co
      cif wceq wa vr vs vt copab2 vx cv vz cv cJ cphtpy cfv co wcel vx cv vz cv
      cJ cphtpy cfv co c0 wne cJ ctop wcel vx cv cii cJ ccn co wcel vy cv cii
      cJ ccn co wcel vz cv cii cJ ccn co wcel w3a cc0 vx cv cfv cc0 vy cv cfv
      wceq c1 vx cv cfv c1 vy cv cfv wceq wa cc0 vy cv cfv cc0 vz cv cfv wceq
      c1 vy cv cfv c1 vz cv cfv wceq wa wa vv cv vx cv vy cv cJ cphtpy cfv co
      wcel vw cv vy cv vz cv cJ cphtpy cfv co wcel wa vr cv cc0 c1 cicc co wcel
      vs cv cc0 c1 cicc co wcel wa vt cv vs cv c1 c2 cdiv co cle wbr vr cv c2
      vs cv cmul co vv cv co vr cv c2 vs cv cmul co c1 cmin co vw cv co cif
      wceq wa vr vs vt copab2 vx cv vz cv cJ cphtpy cfv co wcel wi vr vs vt vx
      cv vy cv vz cv cJ vv cv vw cv vr cv cc0 c1 cicc co wcel vs cv cc0 c1 cicc
      co wcel wa vt cv vs cv c1 c2 cdiv co cle wbr vr cv c2 vs cv cmul co vv cv
      co vr cv c2 vs cv cmul co c1 cmin co vw cv co cif wceq wa vr vs vt copab2
      vr cv cc0 c1 cicc co wcel vs cv cc0 c1 cicc co wcel wa vt cv vs cv c1 c2
      cdiv co cle wbr vr cv c2 vs cv cmul co vv cv co vr cv c2 vs cv cmul co c1
      cmin co vw cv co cif wceq wa vr vs vt copab2 eqid phtpyco 3expb vx cv vz
      cv cJ cphtpy cfv co vr cv cc0 c1 cicc co wcel vs cv cc0 c1 cicc co wcel
      wa vt cv vs cv c1 c2 cdiv co cle wbr vr cv c2 vs cv cmul co vv cv co vr
      cv c2 vs cv cmul co c1 cmin co vw cv co cif wceq wa vr vs vt copab2 ne0i
      syl6 expcom com23 vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa vz
      cv cii cJ ccn co wcel vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel
      vz cv cii cJ ccn co wcel w3a vy cv cii cJ ccn co wcel vx cv cii cJ ccn co
      wcel vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel w3a vx cv cii cJ
      ccn co wcel vy cv cii cJ ccn co wcel wa vz cv cii cJ ccn co wcel wa vx cv
      cii cJ ccn co wcel vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel
      df-3an biimpri adantrl sylan an4s exp3a com23 19.23adv vw vy cv vz cv cJ
      cphtpy cfv co n0 syl5ib com23 19.23adv vv vx cv vy cv cJ cphtpy cfv co n0
      syl5ib imp32 an4s impcom jca ex cJ ctop wcel vx cv vy cv cJ cphtpc cfv
      wbr vx cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv
      cc0 vy cv cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ
      cphtpy cfv co c0 wne wa vy cv vz cv cJ cphtpc cfv wbr vy cv cii cJ ccn co
      wcel vz cv cii cJ ccn co wcel wa cc0 vy cv cfv cc0 vz cv cfv wceq c1 vy
      cv cfv c1 vz cv cfv wceq wa wa vy cv vz cv cJ cphtpy cfv co c0 wne wa cJ
      ctop wcel vx cv cvv wcel vy cv cvv wcel vx cv vy cv cJ cphtpc cfv wbr vx
      cv cii cJ ccn co wcel vy cv cii cJ ccn co wcel wa cc0 vx cv cfv cc0 vy cv
      cfv wceq c1 vx cv cfv c1 vy cv cfv wceq wa wa vx cv vy cv cJ cphtpy cfv
      co c0 wne wa wb vx visset vy visset cvv cvv vx cv vy cv cJ isphtpc
      mp3an23 cJ ctop wcel vy cv cvv wcel vz cv cvv wcel vy cv vz cv cJ cphtpc
      cfv wbr vy cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel wa cc0 vy cv
      cfv cc0 vz cv cfv wceq c1 vy cv cfv c1 vz cv cfv wceq wa wa vy cv vz cv
      cJ cphtpy cfv co c0 wne wa wb vy visset vz visset cvv cvv vy cv vz cv cJ
      isphtpc mp3an23 anbi12d cJ ctop wcel vx cv cvv wcel vz cv cvv wcel vx cv
      vz cv cJ cphtpc cfv wbr vx cv cii cJ ccn co wcel vz cv cii cJ ccn co wcel
      wa cc0 vx cv cfv cc0 vz cv cfv wceq c1 vx cv cfv c1 vz cv cfv wceq wa wa
      vx cv vz cv cJ cphtpy cfv co c0 wne wa wb vx visset vz visset cvv cvv vx
      cv vz cv cJ isphtpc mp3an23 3imtr4d jca 19.21aivv 19.21aiv vx vy vz cJ
      cphtpc cfv dfer2 sylibr $.
      $( [2-Sep-2009] $)
  $}

$( (End of Jeff Madsen's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Mathbox for Rodolfo Medina
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                  Partitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    prtlem60.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    prtlem60.2 $e |- ( ps -> ( th -> ta ) ) $.
    $( Lemma for ~ prter3 . $)
    prtlem60 $p |- ( ph -> ( ps -> ( ch -> ta ) ) )
        $=
      wph wps wch wth wta prtlem60.1 wps wth wta wi wi wph prtlem60.2 a1i syldd
      $.
      $( [22-Oct-2010] $) $( [9-Oct-2010] $)
  $}

  ${
    impbidd.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    impbidd.2 $e |- ( ph -> ( ps -> ( th -> ch ) ) ) $.
    $( Lemma for ~ prter3 . $)
    impbidd  $p |- ( ph -> ( ps -> ( ch <-> th ) ) )
        $=
      wph wps wch wth wb wph wps wa wch wth wph wps wch wth wi impbidd.1 imp
      wph wps wth wch wi impbidd.2 imp impbid ex $.
      $( [22-Oct-2010] $) $( [12-Oct-2010] $)
  $}

  ${
    bicomdd.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Commute two sides of a biconditional in a deduction. $)
    bicomdd $p |- ( ph -> ( ps -> ( th <-> ch ) ) )
        $=
      wph wps wth wch wb wph wps wa wch wth wph wps wch wth wb bicomdd.1 imp
      bicomd ex $.
      $( [22-Oct-2010] $) $( [19-Oct-2010] $)
  $}

  ${
    prtlem1.1 $e |- ( ps -> ( ch -> ph ) ) $.
    $( Add a disjunct in the antecedent. $)
    prtlem1 $p |- ( ( ph \/ ps ) -> ( ch -> ph ) )
        $=
      wph wch wph wi wps wph wch ax-1 prtlem1.1 jaoi $.
      $( [22-Oct-2010] $) $( [24-Sep-2010] $)
  $}

  ${
    jca2.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jca2.2 $e |- ( ps -> th ) $.
    $( Inference conjoining the consequents of two implications. $)
    jca2 $p |- ( ph -> ( ps -> ( ch /\ th ) ) )
        $=
      wph wps wch wth jca2.1 wps wth wi wph jca2.2 a1i jcad $.
      $( [22-Oct-2010] $) $( [12-Oct-2010] $)
  $}

  ${
    jca2r.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jca2r.2 $e |- ( ps -> th ) $.
    $( Inference conjoining the consequents of two implications. $)
    jca2r $p |- ( ph -> ( ps -> ( th /\ ch ) ) )
        $=
      wph wps wth wch wps wth wi wph jca2r.2 a1i jca2r.1 jcad $.
      $( [22-Oct-2010] $) $( [17-Oct-2010] $)
  $}

  ${
    jca3.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jca3.2 $e |- ( th -> ta  ) $.
    $( Inference conjoining the consequents of two implications. $)
    jca3 $p |- ( ph -> ( ps -> ( th -> ( ch /\ ta ) ) ) )
        $=
      wph wps wth wch wta wa wi wph wps wa wth wch wta wph wps wa wch wth wph
      wps wch jca3.1 imp a1d jca3.2 jca2 ex $.
      $( [22-Oct-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    prtlem50.1 $e |- ( ph -> ( ps -> ch ) ) $.
    prtlem50.2 $e |- ( th -> ta ) $.
    $( Lemma for ~ prter3 . $)
    prtlem50 $p |- ( ph -> ( ( ps /\ th ) -> ( ch /\ ta ) ) )
        $=
      wph wps wch wth wta prtlem50.1 wth wta wi wph prtlem50.2 a1i anim12d $.
      $( [22-Oct-2010] $) $( [12-Oct-2010] $)
  $}

  $( Rearrangement of 4 conjuncts. $)
  an43 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
               ( ( ph /\ th ) /\ ( ps /\ ch ) ) )
        $=
    wph wps wa wch wth wa wa wph wps wa wth wch wa wa wph wth wa wps wch wa wa
    wch wth wa wth wch wa wph wps wa wch wth ancom anbi2i wph wps wth wch an4
    bitri $.
    $( [22-Oct-2010] $) $( [24-Sep-2010] $)

  $( A rearrangement of conjuncts. $)
  an3 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ( ph /\ th ) )
        $=
    wph wps wa wch wth wa wa wph wth wa wps wch wa wph wps wch wth an43
    pm3.26bi $.
    $( [22-Oct-2010] $) $( [25-Sep-2010] $)

  ${
    $v et $.
    prtlem70.et $f wff et $.
    $( Lemma for ~ prter3 : a rearrangement of conjuncts. $)
    prtlem70 $p |- ( ( ( ( ps /\ et ) /\ ( ( ph /\ th ) /\ ( ch /\ ta ) ) )
                        /\ ph ) <->  ( ( ph /\ ( ps /\ ( ch /\ ( th /\ ta ) ) )
    ) /\ et ) )
        $=
      wps prtlem70.et wa wph wth wa wch wta wa wa wa wph wa wph wps wth wa wa
      wch wta wa wa prtlem70.et wa wph wps wth wa wch wta wa wa wa prtlem70.et
      wa wph wps wch wth wta wa wa wa wa prtlem70.et wa wph wps wa wph wth wa
      wa wch wta wa wa prtlem70.et wa wph wps wa wph wth wa wch wta wa wa wa
      prtlem70.et wa wph wps wth wa wa wch wta wa wa prtlem70.et wa wps
      prtlem70.et wa wph wth wa wch wta wa wa wa wph wa wph wps wa wph wth wa
      wa wch wta wa wa wph wps wa wph wth wa wch wta wa wa wa prtlem70.et wph
      wps wa wph wth wa wch wta wa anass anbi1i wph wps wth wa wa wch wta wa wa
      wph wps wa wph wth wa wa wch wta wa wa prtlem70.et wph wps wth wa wa wph
      wps wa wph wth wa wa wch wta wa wph wps wth anandi anbi1i anbi1i wps
      prtlem70.et wa wph wth wa wch wta wa wa wa wph wa prtlem70.et wph wps wa
      wa wph wth wa wch wta wa wa wa prtlem70.et wph wps wa wph wth wa wch wta
      wa wa wa wa wph wps wa wph wth wa wch wta wa wa wa prtlem70.et wa wps
      prtlem70.et wa wph wth wa wch wta wa wa wa wph wa wph wps prtlem70.et wa
      wa wph wth wa wch wta wa wa wa wph wps wa prtlem70.et wa wph wth wa wch
      wta wa wa wa prtlem70.et wph wps wa wa wph wth wa wch wta wa wa wa wps
      prtlem70.et wa wph wth wa wch wta wa wa wa wph wa wph wps prtlem70.et wa
      wph wth wa wch wta wa wa wa wa wph wps prtlem70.et wa wa wph wth wa wch
      wta wa wa wa wps prtlem70.et wa wph wth wa wch wta wa wa wa wph ancom wph
      wps prtlem70.et wa wph wth wa wch wta wa wa anass bitr4i wph wps wa
      prtlem70.et wa wph wps prtlem70.et wa wa wph wth wa wch wta wa wa wph wps
      prtlem70.et anass anbi1i wph wps wa prtlem70.et wa prtlem70.et wph wps wa
      wa wph wth wa wch wta wa wa wph wps wa prtlem70.et ancom anbi1i 3bitr2i
      prtlem70.et wph wps wa wph wth wa wch wta wa wa anass prtlem70.et wph wps
      wa wph wth wa wch wta wa wa wa ancom 3bitri 3bitr4ri wph wps wth wa wa
      wch wta wa wa wph wps wth wa wch wta wa wa wa prtlem70.et wph wps wth wa
      wch wta wa anass anbi1i wph wps wth wa wch wta wa wa wa wph wps wch wth
      wta wa wa wa wa prtlem70.et wps wth wa wch wta wa wa wps wch wth wta wa
      wa wa wph wps wth wa wch wta wa wa wps wch wa wth wta wa wa wps wch wth
      wta wa wa wa wps wth wch wta an4 wps wch wth wta wa anass bitri anbi2i
      anbi1i 3bitri $.
      $( [22-Oct-2010] $) $( [20-Oct-2010] $)
  $}

  ${
    ibdr.1 $e |- ( ph -> ( ch -> ( ps <-> ch ) ) ) $.
    $( Reverse of ibd. $)
    ibdr $p |- ( ph -> ( ch -> ps ) )
        $=
      wph wch wps wph wch wps wch ibdr.1 bicomdd ibd $.
      $( [22-Oct-2010] $) $( [30-Sep-2010] $)
  $}

  $( Variant of ~ pm5.31 . $)
  pm5.31r $p |- ( ( ch /\ ( ph -> ps ) ) -> ( ph -> ( ch /\ ps ) ) )
        $=
    wch wph wps wi wph wch wps wa wi wch wps wch wps wa wph wch wps pm3.2
    imim2d imp $.
    $( [22-Oct-2010] $) $( [15-Oct-2010] $)

  $( Cancel a conjunct from the scope of an existential quantifier. $)
  exan2 $p |- ( E. x ( ph /\ ps ) -> E. x ph )
        $=
    wph wps wa vx wex wph vx wex wps vx wex wph wps vx 19.40 pm3.26d $.
    $( [22-Oct-2010] $) $( [25-Sep-2010] $)

  $( Cancel a conjunct from the scope of an existential quantifier. $)
  exan3 $p |- ( E. x ( ph /\ ps ) -> E. x ps )
        $=
    wph wps wa vx wex wph vx wex wps vx wex wph wps vx 19.40 pm3.27d $.
    $( [22-Oct-2010] $) $( [25-Sep-2010] $)

  $( Double the quantifiers of theorem r19.29. $)
  2r19.29 $p |- ( ( A. x e. A A. y e. B ph /\ E. x e. A E. y e. B ps )
                        -> E. x e. A E. y e. B ( ph /\ ps ) )
        $=
    wph vy cB wral vx cA wral wps vy cB wrex vx cA wrex wa wph vy cB wral wps
    vy cB wrex wa vx cA wrex wph wps wa vy cB wrex vx cA wrex wph vy cB wral
    wps vy cB wrex vx cA r19.29 wph vy cB wral wps vy cB wrex wa wph wps wa vy
    cB wrex vx cA wph wps vy cB r19.29 r19.22si syl $.
    $( [22-Oct-2010] $) $( [25-Sep-2010] $)

  $( Lemma for ~ prter3 . $)
  prtlem100 $p |- ( E. x e. A ( B e. x /\ ph ) <->
                        E. x e. ( A \ { (/) } ) ( B e. x /\ ph ) )
        $=
    cB vx cv wcel wph wa cB vx cv wcel wph wa vx cA cA c0 csn cdif vx cv cA
    wcel vx cv c0 wne wa cB vx cv wcel wph wa wa vx cv cA wcel vx cv c0 wne cB
    vx cv wcel wph wa wa wa vx cv cA c0 csn cdif wcel cB vx cv wcel wph wa wa
    vx cv cA wcel cB vx cv wcel wph wa wa vx cv cA wcel vx cv c0 wne cB vx cv
    wcel wph wa anass vx cv cA c0 csn cdif wcel vx cv cA wcel vx cv c0 wne wa
    cB vx cv wcel wph wa vx cv cA c0 eldifsn anbi1i cB vx cv wcel wph wa vx cv
    c0 wne cB vx cv wcel wph wa wa vx cv cA wcel cB vx cv wcel wph wa vx cv c0
    wne cB vx cv wcel wa wph wa vx cv c0 wne cB vx cv wcel wph wa wa cB vx cv
    wcel vx cv c0 wne cB vx cv wcel wa wph cB vx cv wcel vx cv c0 wne vx cv cB
    ne0i pm4.71ri anbi1i vx cv c0 wne cB vx cv wcel wph anass bitri anbi2i
    3bitr4ri rexbii2 $.
    $( [22-Oct-2010] $) $( [19-Oct-2010] $)

  ${
    $d u v x r $.  $d u v x s $.  $d u v x A $.
    $( Lemma for ~ prter1 , ~ prter2 , ~ prter3 and ~ prtex . $)
    prtlem5 $p |- ( [ s / v ] [ r / u ] E. x e. A ( u e. x /\ v e. x )
                        <-> E. x e. A ( r e. x /\ s e. x ) )
        $=
      vu cv vx cv wcel vv cv vx cv wcel wa vx cA wrex vu vr cv wsbc vv vs cv
      wsbc vx cv cA wcel vr cv vx cv wcel vs cv vx cv wcel wa wa vx wex vr cv
      vx cv wcel vs cv vx cv wcel wa vx cA wrex vu cv vx cv wcel vv cv vx cv
      wcel wa vx cA wrex vu vr cv wsbc vv vs cv wsbc vx cv cA wcel vv vs cv
      wsbc vr cv vx cv wcel vv cv vx cv wcel wa vv vs cv wsbc wa vx wex vx cv
      cA wcel vv vs cv wsbc vr cv vx cv wcel vv vs cv wsbc vv cv vx cv wcel vv
      vs cv wsbc wa wa vx wex vx cv cA wcel vr cv vx cv wcel vs cv vx cv wcel
      wa wa vx wex vu cv vx cv wcel vv cv vx cv wcel wa vx cA wrex vu vr cv
      wsbc vv vs cv wsbc vx cv cA wcel vu vr cv wsbc vu cv vx cv wcel vv cv vx
      cv wcel wa vu vr cv wsbc wa vv vs cv wsbc vx wex vx cv cA wcel vr cv vx
      cv wcel vv cv vx cv wcel wa wa vv vs cv wsbc vx wex vx cv cA wcel vv vs
      cv wsbc vr cv vx cv wcel vv cv vx cv wcel wa vv vs cv wsbc wa vx wex vu
      cv vx cv wcel vv cv vx cv wcel wa vx cA wrex vu vr cv wsbc vv vs cv wsbc
      vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vu vr cv wsbc vx
      wex vv vs cv wsbc vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa
      vu vr cv wsbc vv vs cv wsbc vx wex vx cv cA wcel vu vr cv wsbc vu cv vx
      cv wcel vv cv vx cv wcel wa vu vr cv wsbc wa vv vs cv wsbc vx wex vu cv
      vx cv wcel vv cv vx cv wcel wa vx cA wrex vu vr cv wsbc vv vs cv wsbc vx
      cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vx wex vu vr cv wsbc
      vv vs cv wsbc vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vu vr
      cv wsbc vx wex vv vs cv wsbc vu cv vx cv wcel vv cv vx cv wcel wa vx cA
      wrex vu vr cv wsbc vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa
      vx wex vu vr cv wsbc vv vs vu cv vx cv wcel vv cv vx cv wcel wa vx cA
      wrex vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vx wex vu vr
      vu cv vx cv wcel vv cv vx cv wcel wa vx cA df-rex sbbii sbbii vx cv cA
      wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vx wex vu vr cv wsbc vx cv
      cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vu vr cv wsbc vx wex vv
      vs vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vx vu vr sbex
      sbbii bitri vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa wa vu vr
      cv wsbc vx vv vs sbex vx cv cA wcel vu cv vx cv wcel vv cv vx cv wcel wa
      wa vu vr cv wsbc vv vs cv wsbc vx cv cA wcel vu vr cv wsbc vu cv vx cv
      wcel vv cv vx cv wcel wa vu vr cv wsbc wa vv vs cv wsbc vx vx cv cA wcel
      vu cv vx cv wcel vv cv vx cv wcel wa wa vu vr cv wsbc vx cv cA wcel vu vr
      cv wsbc vu cv vx cv wcel vv cv vx cv wcel wa vu vr cv wsbc wa vv vs vx cv
      cA wcel vu cv vx cv wcel vv cv vx cv wcel wa vu vr sban sbbii exbii
      3bitri vx cv cA wcel vu vr cv wsbc vu cv vx cv wcel vv cv vx cv wcel wa
      vu vr cv wsbc wa vv vs cv wsbc vx cv cA wcel vr cv vx cv wcel vv cv vx cv
      wcel wa wa vv vs cv wsbc vx vx cv cA wcel vu vr cv wsbc vu cv vx cv wcel
      vv cv vx cv wcel wa vu vr cv wsbc wa vx cv cA wcel vr cv vx cv wcel vv cv
      vx cv wcel wa wa vv vs vx cv cA wcel vu vr cv wsbc vx cv cA wcel vu cv vx
      cv wcel vv cv vx cv wcel wa vu vr cv wsbc vr cv vx cv wcel vv cv vx cv
      wcel wa vx cv cA wcel vu vr vx cv cA wcel vu ax-17 sbf vu cv vx cv wcel
      vv cv vx cv wcel wa vu vr cv wsbc vu cv vx cv wcel vu vr cv wsbc vv cv vx
      cv wcel vu vr cv wsbc wa vr cv vx cv wcel vv cv vx cv wcel wa vu cv vx cv
      wcel vv cv vx cv wcel vu vr sban vu cv vx cv wcel vu vr cv wsbc vr cv vx
      cv wcel vv cv vx cv wcel vu vr cv wsbc vv cv vx cv wcel vr vu vx elsb3 vv
      cv vx cv wcel vu vr vv cv vx cv wcel vu ax-17 sbf anbi12i bitri anbi12i
      sbbii exbii vx cv cA wcel vr cv vx cv wcel vv cv vx cv wcel wa wa vv vs
      cv wsbc vx cv cA wcel vv vs cv wsbc vr cv vx cv wcel vv cv vx cv wcel wa
      vv vs cv wsbc wa vx vx cv cA wcel vr cv vx cv wcel vv cv vx cv wcel wa vv
      vs sban exbii 3bitri vx cv cA wcel vv vs cv wsbc vr cv vx cv wcel vv cv
      vx cv wcel wa vv vs cv wsbc wa vx cv cA wcel vv vs cv wsbc vr cv vx cv
      wcel vv vs cv wsbc vv cv vx cv wcel vv vs cv wsbc wa wa vx vr cv vx cv
      wcel vv cv vx cv wcel wa vv vs cv wsbc vr cv vx cv wcel vv vs cv wsbc vv
      cv vx cv wcel vv vs cv wsbc wa vx cv cA wcel vv vs cv wsbc vr cv vx cv
      wcel vv cv vx cv wcel vv vs sban anbi2i exbii vx cv cA wcel vv vs cv wsbc
      vr cv vx cv wcel vv vs cv wsbc vv cv vx cv wcel vv vs cv wsbc wa wa vx
      wex vx cv cA wcel vv vs cv wsbc vr cv vx cv wcel vs cv vx cv wcel wa wa
      vx wex vx cv cA wcel vr cv vx cv wcel vs cv vx cv wcel wa wa vx wex vx cv
      cA wcel vv vs cv wsbc vr cv vx cv wcel vv vs cv wsbc vv cv vx cv wcel vv
      vs cv wsbc wa wa vx cv cA wcel vv vs cv wsbc vr cv vx cv wcel vs cv vx cv
      wcel wa wa vx vr cv vx cv wcel vv vs cv wsbc vv cv vx cv wcel vv vs cv
      wsbc wa vr cv vx cv wcel vs cv vx cv wcel wa vx cv cA wcel vv vs cv wsbc
      vr cv vx cv wcel vv vs cv wsbc vr cv vx cv wcel vv cv vx cv wcel vv vs cv
      wsbc vs cv vx cv wcel vr cv vx cv wcel vv vs vr cv vx cv wcel vv ax-17
      sbf vs vv vx elsb3 anbi12i anbi2i exbii vx cv cA wcel vv vs cv wsbc vr cv
      vx cv wcel vs cv vx cv wcel wa wa vx cv cA wcel vr cv vx cv wcel vs cv vx
      cv wcel wa wa vx vx cv cA wcel vv vs cv wsbc vx cv cA wcel vr cv vx cv
      wcel vs cv vx cv wcel wa vx cv cA wcel vv vs vx cv cA wcel vv ax-17 sbf
      anbi1i exbii bitri 3bitri vr cv vx cv wcel vs cv vx cv wcel wa vx cA
      df-rex bitr4i $.
      $( [22-Oct-2010] $) $( [25-Sep-2010] $)
  $}

  $( Lemma for ~ prter2 . $)
  prtlem90 $p |- ( -. A e. B -> ( C e. B -> C =/= A ) )
        $=
    cA cB wcel wn cC cB wcel cA cC wne cC cA wne cA cB wcel wn cC cB wcel cA cC
    wceq wn cA cC wne cA cB wcel wn cC cB wcel cA cC wceq wn cA cB wcel wn cC
    cB wcel wa cA cB wcel cC cB wcel wb cA cC wceq cA cB wcel wn cC cB wcel wa
    cA cB wcel cC cB wcel wn wa cC cB wcel cA cB wcel wn wa wo cA cB wcel cC cB
    wcel wb wn cA cB wcel wn cC cB wcel wa cA cB wcel cC cB wcel wn wa cA cB
    wcel wn cC cB wcel wa wo cA cB wcel cC cB wcel wn wa cC cB wcel cA cB wcel
    wn wa wo cA cB wcel wn cC cB wcel wa cA cB wcel cC cB wcel wn wa olc cA cB
    wcel wn cC cB wcel wa cC cB wcel cA cB wcel wn wa cA cB wcel cC cB wcel wn
    wa cA cB wcel wn cC cB wcel ancom orbi2i sylib cA cB wcel cC cB wcel xor
    sylibr cA cC cB eleq1 nsyl ex cA cC df-ne syl6ibr cA cC necom syl6ib $.
    $( [22-Oct-2010] $) $( [17-Oct-2010] $)

  $( Lemma for ~ prter2 . $)
  prtlem80 $p |- ( A e. B -> -. A e. ( C \ { A } ) )
        $=
    cA cB wcel cA cC wcel cA cA csn wcel wn wa wn cA cC cA csn cdif wcel wn cA
    cB wcel cA cC wcel cA cA csn wcel wi cA cC wcel cA cA csn wcel wn wa wn cA
    cB wcel cA cA csn wcel cA cC wcel cA cB snidg a1d cA cC wcel cA cA csn wcel
    iman sylib cA cC cA csn cdif wcel cA cC wcel cA cA csn wcel wn wa cA cC cA
    csn eldif notbii sylibr $.
    $( [22-Oct-2010] $) $( [17-Oct-2010] $)

  ${
    $d x A $.  $d x u $.
    $( Negated membership of the empty set in another class. $)
    n0el $p |- ( -. (/) e. A <-> A. x e. A E. u u e. x )
        $=
      vu cv vx cv wcel wn vu wal wn vx cA wral vx cv cA wcel vu cv vx cv wcel
      wn vu wal wn wi vx wal vu cv vx cv wcel vu wex vx cA wral c0 cA wcel wn
      vu cv vx cv wcel wn vu wal wn vx cA df-ral vu cv vx cv wcel vu wex vu cv
      vx cv wcel wn vu wal wn vx cA vu cv vx cv wcel vu df-ex ralbii vx cv cA
      wcel vu cv vx cv wcel wn vu wal wa wn vx wal vx cv cA wcel vu cv vx cv
      wcel wn vu wal wa vx wex wn vx cv cA wcel vu cv vx cv wcel wn vu wal wn
      wi vx wal c0 cA wcel wn vx cv cA wcel vu cv vx cv wcel wn vu wal wa vx
      alnex vx cv cA wcel vu cv vx cv wcel wn vu wal wn wi vx cv cA wcel vu cv
      vx cv wcel wn vu wal wa wn vx vx cv cA wcel vu cv vx cv wcel wn vu wal
      imnan albii c0 cA wcel vx cv cA wcel vu cv vx cv wcel wn vu wal wa vx wex
      c0 cA wcel vu cv vx cv wcel wn vu wal vx cA wrex vx cv cA wcel vu cv vx
      cv wcel wn vu wal wa vx wex vx vu cA 0el vu cv vx cv wcel wn vu wal vx cA
      df-rex bitri notbii 3bitr4ri 3bitr4ri $.
      $( [22-Oct-2010] $) $( [25-Sep-2010] $)
  $}

  ${
    $d x A $.
    ceqsex3.1 $e |- ( ps -> A. x ps ) $.
    ceqsex3.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Version of ~ ceqsex with an antecedent instead of a hypothesis. $)
    ceqsex3 $p |- ( A e. _V -> ( E. x ( x = A /\ ph ) <-> ps ) )
        $=
      cA cvv wcel vx cv cA wceq wph wa vx wex wps vx cv cA wceq wph wa wps vx
      ceqsex3.1 vx cv cA wceq wph wps ceqsex3.2 biimpa 19.23ai wps cA cvv wcel
      vx cv cA wceq wph wa vx wex wps vx cv cA wceq vx wex vx cv cA wceq wph wa
      vx wex cA cvv wcel wps vx cv cA wceq wph wi vx wal vx cv cA wceq vx wex
      vx cv cA wceq wph wa vx wex wi wps vx cv cA wceq wph wi vx ceqsex3.1 vx
      cv cA wceq wph wps ceqsex3.2 biimprcd 19.21ai vx cv cA wceq wph vx exintr
      syl vx cA isset syl5ib com12 impbid2 $.
      $( [22-Oct-2010] $) $( [19-Oct-2010] $)
  $}

  ${
    $d x A $.  $d x ps $.
    ceqsex3v.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Version of ~ ceqsexv with an antecedent instead of a hypothesis. $)
    ceqsex3v $p |- ( A e. _V -> ( E. x ( x = A /\ ph ) <-> ps ) )
        $=
      wph wps vx cA cvv ceqsex3v.1 ceqsexgv $.
      $( [22-Oct-2010] $) $( [19-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqrelrdv.1 $e |- Rel A $.
    eqrelrdv.2 $e |- Rel B $.
    eqrelrdv.3 $e |- ( ph -> ( <. x , y >. e. A <-> <. x , y >. e. B ) ) $.
    $( Deduce equality of relations from equivalence of membership. $)
    eqrelrdv $p |- ( ph -> A = B )
        $=
      wph vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wb vy wal vx wal cA
      cB wceq wph vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wb vx vy
      eqrelrdv.3 19.21aivv cA wrel cB wrel cA cB wceq vx cv vy cv cop cA wcel
      vx cv vy cv cop cB wcel wb vy wal vx wal wb eqrelrdv.1 eqrelrdv.2 vx vy
      cA cB eqrel mp2an sylibr $.
      $( [22-Oct-2010] $) $( [10-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqbrrdv.1 $e |- Rel A $.
    eqbrrdv.2 $e |- Rel B $.
    eqbrrdv.3 $e |- ( ph -> ( x A y <-> x B y ) ) $.
    $( Deduction from extensionality principle for relations. $)
    eqbrrdv  $p |- ( ph -> A = B )
        $=
      wph vx vy cA cB eqbrrdv.1 eqbrrdv.2 wph vx cv vy cv cA wbr vx cv vy cv cB
      wbr vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel eqbrrdv.3 vx cv vy cv
      cA df-br vx cv vy cv cB df-br 3bitr3g eqrelrdv $.
      $( [22-Oct-2010] $) $( [10-Oct-2010] $)
  $}

  ${
    $d x y z $.  $d x y w $.
    $( Closed form of ~ brabsb . $)
    brabsb2 $p |- ( R = { <. x , y >. | ph }
                        -> ( z R w <-> [ w / y ] [ z / x ] ph ) )
        $=
      cR wph vx vy copab wceq vz cv vw cv cR wbr vz cv vw cv cop wph vx vy
      copab wcel wph vx vz cv wsbc vy vw cv wsbc cR wph vx vy copab wceq vz cv
      vw cv cR wbr vz cv vw cv wph vx vy copab wbr vz cv vw cv cop wph vx vy
      copab wcel vz cv vw cv cR wph vx vy copab breq vz cv vw cv wph vx vy
      copab df-br syl6bb wph vx vy vz vw opelopabsb syl6bb $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqrelrdv2.1 $e |- ( ( ( Rel A /\ Rel B ) /\ ph )
                                -> ( <. x , y >. e. A
                                        <-> <. x , y >. e. B ) ) $.
    $( Other version of ~ eqrelrdv . $)
    eqrelrdv2 $p |- ( ( ( Rel A /\ Rel B ) /\ ph ) -> A = B )
        $=
      cA wrel cB wrel wa wph wa cA cB wceq vx cv vy cv cop cA wcel vx cv vy cv
      cop cB wcel wb vy wal vx wal cA wrel cB wrel wa wph wa vx cv vy cv cop cA
      wcel vx cv vy cv cop cB wcel wb vx vy eqrelrdv2.1 19.21aivv cA wrel cB
      wrel wa cA cB wceq vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel wb vy
      wal vx wal wb wph vx vy cA cB eqrel adantr mpbird $.
      $( [22-Oct-2010] $) $( [30-Sep-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqbrrdv2.1 $e |- ( ( ( Rel A /\ Rel B ) /\ ph )
                        -> ( x A y <-> x B y ) ) $.
    $( Other version of ~ eqbrrdv . $)
    eqbrrdv2 $p |- ( ( ( Rel A /\ Rel B ) /\ ph ) -> A = B )
        $=
      wph vx vy cA cB cA wrel cB wrel wa wph wa vx cv vy cv cA wbr vx cv vy cv
      cB wbr vx cv vy cv cop cA wcel vx cv vy cv cop cB wcel eqbrrdv2.1 vx cv
      vy cv cA df-br vx cv vy cv cB df-br 3bitr3g eqrelrdv2 $.
      $( [22-Oct-2010] $) $( [30-Sep-2010] $)
  $}

  ${
    $d x y z R $.  $d x y A $.  $d x y B $.
    ersym2.1 $e |- A e. _V $.
    ersym2.2 $e |- B e. _V $.
    $( Version of ~ ersym with an antecedent instead of a hypothesis. $)
    ersym2 $p |- ( Er R -> ( A R B -> B R A ) )
        $=
      cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi wi cR wer cA cB cR wbr cB
      cA cR wbr wi wi vx vy cA cB ersym2.1 ersym2.2 vx cv cA wceq vy cv cB wceq
      wa vx cv vy cv cR wbr vy cv vx cv cR wbr wi cA cB cR wbr cB cA cR wbr wi
      cR wer vx cv cA wceq vy cv cB wceq wa vx cv vy cv cR wbr cA cB cR wbr vy
      cv vx cv cR wbr cB cA cR wbr vx cv cA vy cv cB cR breq12 vy cv cB wceq vx
      cv cA wceq vy cv vx cv cR wbr cB cA cR wbr wb vy cv cB vx cv cA cR breq12
      ancoms imbi12d imbi2d cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx
      cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi cR wer vx cv
      vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr
      wa vx cv vz cv cR wbr wi wa vy vz cR wer vx cv vy cv cR wbr vy cv vx cv
      cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi
      wa vz wal vy wal vx cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv
      vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal
      vx wal vx vy vz cR dfer2 biimpi 19.21bi 19.21bbi pm3.26d vtocl2 $.
      $( [22-Oct-2010] $) $( [11-Oct-2010] $)
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    ertr2.1 $e |- A e. _V $.
    ertr2.2 $e |- B e. _V $.
    ertr2.3 $e |- C e. _V $.
    $( Version of ~ ertr with an antecedent instead of a hypothesis. $)
    ertr2 $p |- ( Er R -> ( ( A R B /\ B R C ) -> A R C ) )
        $=
      cR wer vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wi
      cR wer cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi wi vx vy vz cA cB cC
      ertr2.1 ertr2.2 ertr2.3 vx cv cA wceq cR wer vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wi cR wer cA vy cv cR wbr vy cv vz cv
      cR wbr wa cA vz cv cR wbr wi wi vy cv cB wceq cR wer cA cB cR wbr cB vz
      cv cR wbr wa cA vz cv cR wbr wi wi vz cv cC wceq cR wer cA cB cR wbr cB
      cC cR wbr wa cA cC cR wbr wi wi vx cv cA wceq vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi cA vy cv cR wbr vy cv vz cv cR wbr wa
      cA vz cv cR wbr wi cR wer vx cv cA wceq vx cv vy cv cR wbr vy cv vz cv cR
      wbr wa cA vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr cA vz cv
      cR wbr vx cv cA wceq vx cv vy cv cR wbr cA vy cv cR wbr vy cv vz cv cR
      wbr vx cv cA vy cv cR breq1 anbi1d vx cv cA vz cv cR breq1 imbi12d imbi2d
      vy cv cB wceq cA vy cv cR wbr vy cv vz cv cR wbr wa cA vz cv cR wbr wi cA
      cB cR wbr cB vz cv cR wbr wa cA vz cv cR wbr wi cR wer vy cv cB wceq cA
      vy cv cR wbr vy cv vz cv cR wbr wa cA cB cR wbr cB vz cv cR wbr wa cA vz
      cv cR wbr vy cv cB wceq cA vy cv cR wbr cA cB cR wbr vy cv vz cv cR wbr
      cB vz cv cR wbr vy cv cB cA cR breq2 vy cv cB vz cv cR breq1 anbi12d
      imbi1d imbi2d vz cv cC wceq cA cB cR wbr cB vz cv cR wbr wa cA vz cv cR
      wbr wi cA cB cR wbr cB cC cR wbr wa cA cC cR wbr wi cR wer vz cv cC wceq
      cA cB cR wbr cB vz cv cR wbr wa cA cB cR wbr cB cC cR wbr wa cA vz cv cR
      wbr cA cC cR wbr vz cv cC wceq cB vz cv cR wbr cB cC cR wbr cA cB cR wbr
      vz cv cC cB cR breq2 anbi2d vz cv cC cA cR breq2 imbi12d imbi2d syl3an9b
      cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv
      vz cv cR wbr wa vx cv vz cv cR wbr wi cR wer vx cv vy cv cR wbr vy cv vx
      cv cR wbr wi vx cv vy cv cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr
      wi wa vy vz cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv
      cR wbr vy cv vz cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx cR
      wer vx cv vy cv cR wbr vy cv vx cv cR wbr wi vx cv vy cv cR wbr vy cv vz
      cv cR wbr wa vx cv vz cv cR wbr wi wa vz wal vy wal vx wal vx vy vz cR
      dfer2 biimpi 19.21bi 19.21bbi pm3.27d vtocl3 $.
      $( [22-Oct-2010] $) $( [10-Oct-2010] $)
  $}

  ${
    ersymb2.1 $e |- A e. _V $.
    ersymb2.2 $e |- B e. _V $.
    $( Version of ~ ersymb with an antecedent instead of a hypothesis. $)
    ersymb2 $p |- ( Er R -> ( A R B <-> B R A ) )
        $=
      cR wer cA cB cR wbr cB cA cR wbr cA cB cR ersymb2.1 ersymb2.2 ersym2 cB
      cA cR ersymb2.2 ersymb2.1 ersym2 impbid $.
      $( [22-Oct-2010] $) $( [11-Oct-2010] $)
  $}

  ${
    $d x y $.  $d y R $.  $d x A $.  $d x R $.
    $( Closed form of ~ erref . $)
    erreft $p |- ( Er R -> ( A e. ( dom R u. ran R ) -> A R A ) )
        $=
      cR wer vx cv vx cv cR wbr vx cR cdm cR crn cun wral cA cR cdm cR crn cun
      wcel cA cA cR wbr wi cR wer vx cv vx cv cR wbr vx cR cdm cR crn cun cR
      wer vx cv cR cdm wcel vx cv cR crn wcel wo vx cv vx cv cR wbr vx cv cR
      cdm cR crn cun wcel cR wer vx cv cR cdm wcel vx cv vx cv cR wbr vx cv cR
      crn wcel cR wer vx cv vy cv cR wbr vy wex vx cv vx cv cR wbr vx cv cR cdm
      wcel cR wer vx cv vy cv cR wbr vx cv vx cv cR wbr vy cR wer vx cv vy cv
      cR wbr vx cv vy cv cR wbr wa vx cv vx cv cR wbr vx cv vy cv cR wbr cR wer
      vx cv vy cv cR wbr vy cv vx cv cR wbr vx cv vx cv cR wbr vx cv vy cv cR
      wbr vx cv vy cv vx cv cR vx visset vy visset vx visset ertr2 vx cv vy cv
      cR vx visset vy visset ersym2 sylan2d vx cv vy cv cR wbr anidm syl5ibr
      19.23adv vy vx cv cR vx visset eldm syl5ib cR wer vy cv vx cv cR wbr vy
      wex vx cv vx cv cR wbr vx cv cR crn wcel cR wer vy cv vx cv cR wbr vx cv
      vx cv cR wbr vy cR wer vy cv vx cv cR wbr vy cv vx cv cR wbr wa vx cv vx
      cv cR wbr vy cv vx cv cR wbr cR wer vx cv vy cv cR wbr vy cv vx cv cR wbr
      vx cv vx cv cR wbr vy cv vx cv cR wbr vx cv vy cv vx cv cR vx visset vy
      visset vx visset ertr2 vy cv vx cv cR vy visset vx visset ersym2 syland
      vy cv vx cv cR wbr anidm syl5ibr 19.23adv vy vx cv cR vx visset elrn
      syl5ib jaod vx cv cR cdm cR crn elun syl5ib r19.21aiv vx cv vx cv cR wbr
      cA cA cR wbr vx cA cR cdm cR crn cun vx cv cA wceq vx cv vx cv cR wbr cA
      vx cv cR wbr cA cA cR wbr vx cv cA vx cv cR breq1 vx cv cA cA cR breq2
      bitrd rcla4cv syl $.
      $( [22-Oct-2010] $) $( [11-Oct-2010] $)
  $}

  ${
    $d x y R $.
    $( Closed form of ~ erdmrn . $)
    erdmrn2 $p |- ( Er R -> dom R = ran R )
        $=
      cR wer vx cR cdm cR crn cR wer vx cv vy cv cR wbr vy wex vy cv vx cv cR
      wbr vy wex vx cv cR cdm wcel vx cv cR crn wcel cR wer vx cv vy cv cR wbr
      vy cv vx cv cR wbr vy vx cv vy cv cR vx visset vy visset ersymb2 exbidv
      vy vx cv cR vx visset eldm vy vx cv cR vx visset elrn 3bitr4g eqrdv $.
      $( [22-Oct-2010] $) $( [11-Oct-2010] $)
  $}

  $( Simplified version of ~ erreft . $)
  erreft2 $p |- ( Er R -> ( A e. dom R -> A R A ) )
        $=
    cR wer cA cR cdm wcel cA cR cdm cR crn cun wcel cA cA cR wbr cR wer cR cdm
    cR crn cun cR cdm cA cR wer cR cdm cR cdm cun cR cdm cR crn cun cR cdm cR
    wer cR cdm cR crn cR cdm cR erdmrn2 uneq2d cR cdm unidm syl5reqr eleq2d cA
    cR erreft sylbird $.
    $( [22-Oct-2010] $) $( [11-Oct-2010] $)

  $( An equivalence relation is a set if its domain is a set. $)
  erex $p |- ( ( Rel R /\ Er R ) -> ( dom R e. A -> R e. _V ) )
        $=
    cR wrel cR wer wa cR cdm cA wcel cR wrel cR cdm cR crn cxp cvv wcel wa cR
    cvv wcel cR wrel cR cdm cA wcel cR cdm cR crn cxp cvv wcel wi cR cdm cA
    wcel cR wrel cR cdm cR crn cxp cvv wcel wa wi cR wer cR cdm cA wcel cR cdm
    cR crn cxp cvv wcel cR wrel pm5.31r cR wer cR cdm cA wcel cR cdm cA wcel cR
    crn cA wcel wa cR cdm cR crn cxp cvv wcel cR wer cR cdm cA wcel cR crn cA
    wcel wi cR cdm cA wcel cR cdm cA wcel cR crn cA wcel wa wb cR wer cR cdm cA
    wcel cR crn cA wcel cR wer cR cdm cR crn cA cR erdmrn2 eleq1d biimpd cR cdm
    cA wcel cR crn cA wcel pm4.71 sylib cR cdm cR crn cA cA xpexg syl6bi sylan2
    cR cR cdm cR crn cxp wss cR cdm cR crn cxp cvv wcel cR cvv wcel cR wrel cR
    cR cdm cR crn cxp cvv ssexg cR relssdmrn sylan syl6 $.
    $( [22-Oct-2010] $) $( [15-Oct-2010] $)

  $( An equivalence relation is a set if and only if its domain is a set. $)
  erex2 $p |- ( ( Rel R /\ Er R ) -> ( R e. _V <-> dom R e. _V ) )
        $=
    cR wrel cR wer wa cR cvv wcel cR cdm cvv wcel cR cvv dmexg cvv cR erex
    impbid2 $.
    $( [22-Oct-2010] $) $( [15-Oct-2010] $)

  ${
    $d x A $.  $d x B $.
    $( Lemma for ~ prter3 . $)
    prtlem9 $p |- ( A e. B -> E. x e. B [ x ] R = [ A ] R )
        $=
      cA cB wcel vx cv cA wceq vx cB wrex vx cv cR cec cA cR cec wceq vx cB
      wrex vx cA cB risset vx cv cA wceq vx cv cR cec cA cR cec wceq vx cB vx
      cv cA cR eceq2 r19.22si sylbi $.
      $( [22-Oct-2010] $) $( [25-Sep-2010] $)
  $}

  ${
    $d v z $.  $d v w $.  $d v R $.
    $( Lemma for ~ prter3 . $)
    prtlem10 $p |- ( Er R -> ( z e. dom R ->
                                ( z R w <->
                                        E. v e. dom R ( z e. [ v ] R /\
                                                        w e. [ v ] R ) ) ) )
        $=
      cR wer vz cv cR cdm wcel vz cv vw cv cR wbr vz cv vv cv cR cec wcel vw cv
      vv cv cR cec wcel wa vv cR cdm wrex cR wer vz cv cR cdm wcel vz cv vw cv
      cR wbr vz cv vz cv cR cec wcel vw cv vz cv cR cec wcel wa vz cv vv cv cR
      cec wcel vw cv vv cv cR cec wcel wa vv cR cdm wrex cR wer vz cv cR cdm
      wcel vz cv vz cv cR cec wcel vz cv vw cv cR wbr vw cv vz cv cR cec wcel
      cR wer vz cv cR cdm wcel vz cv vz cv cR wbr vz cv vz cv cR cec wcel vz cv
      cR erreft2 vz cv vz cv cR vz visset vz visset elec syl6ibr vw cv vz cv cR
      cec wcel vz cv vw cv cR wbr vw cv vz cv cR vw visset vz visset elec
      biimpri jca3 vz cv cR cdm wcel vz cv vz cv cR cec wcel vw cv vz cv cR cec
      wcel wa vz cv vv cv cR cec wcel vw cv vv cv cR cec wcel wa wi vv cR cdm
      wrex vz cv vz cv cR cec wcel vw cv vz cv cR cec wcel wa vz cv vv cv cR
      cec wcel vw cv vv cv cR cec wcel wa vv cR cdm wrex wi vz cv cR cdm wcel
      vv cv cR cec vz cv cR cec wceq vv cR cdm wrex vz cv vz cv cR cec wcel vw
      cv vz cv cR cec wcel wa vz cv vv cv cR cec wcel vw cv vv cv cR cec wcel
      wa wi vv cR cdm wrex vv vz cv cR cdm cR prtlem9 vv cv cR cec vz cv cR cec
      wceq vz cv vz cv cR cec wcel vw cv vz cv cR cec wcel wa vz cv vv cv cR
      cec wcel vw cv vv cv cR cec wcel wa wi vv cR cdm vv cv cR cec vz cv cR
      cec wceq vz cv vv cv cR cec wcel vw cv vv cv cR cec wcel wa vz cv vz cv
      cR cec wcel vw cv vz cv cR cec wcel wa vv cv cR cec vz cv cR cec wceq vz
      cv vv cv cR cec wcel vz cv vz cv cR cec wcel vw cv vv cv cR cec wcel vw
      cv vz cv cR cec wcel vv cv cR cec vz cv cR cec vz cv eleq2 vv cv cR cec
      vz cv cR cec vw cv eleq2 anbi12d biimprd r19.22si syl vz cv vz cv cR cec
      wcel vw cv vz cv cR cec wcel wa vz cv vv cv cR cec wcel vw cv vv cv cR
      cec wcel wa vv cR cdm r19.37av syl prtlem60 cR wer vz cv vv cv cR cec
      wcel vw cv vv cv cR cec wcel wa vv cR cdm wrex vz cv vw cv cR wbr vv cR
      cdm wrex vz cv cR cdm wcel vz cv vw cv cR wbr cR wer vz cv vv cv cR cec
      wcel vw cv vv cv cR cec wcel wa vz cv vw cv cR wbr vv cR cdm cR wer vz cv
      vv cv cR cec wcel vw cv vv cv cR cec wcel wa vz cv vv cv cR wbr vv cv vw
      cv cR wbr wa vz cv vw cv cR wbr cR wer vz cv vv cv cR cec wcel vz cv vv
      cv cR wbr vw cv vv cv cR cec wcel vv cv vw cv cR wbr cR wer vv cv vz cv
      cR wbr vz cv vv cv cR wbr vz cv vv cv cR cec wcel vv cv vz cv cR vv
      visset vz visset ersym2 vz cv vv cv cR vz visset vv visset elec syl5ib vw
      cv vv cv cR cec wcel vv cv vw cv cR wbr vw cv vv cv cR vw visset vv
      visset elec biimpi prtlem50 vz cv vv cv vw cv cR vz visset vv visset vw
      visset ertr2 syld r19.22sdv vz cv cR cdm wcel vz cv vw cv cR wbr vz cv vw
      cv cR wbr vv cR cdm wrex vz cv cR cdm wcel cR cdm c0 wne vz cv vw cv cR
      wbr vz cv vw cv cR wbr vv cR cdm wrex wb cR cdm vz cv ne0i vz cv vw cv cR
      wbr vv cR cdm r19.9rzv syl biimprd syl9 impbidd $.
      $( [22-Oct-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y R $.
    $( Members of a quotient set do not overlap. $)
    erdisj3 $p |- ( Er R -> ( ( B e. ( A /. R ) /\ C e. ( A /. R ) )
                                -> ( B = C \/ ( B i^i C ) = (/) ) ) )
        $=
      cR wer cB cA cR cqs wcel cC cA cR cqs wcel cB cC wceq cB cC cin c0 wceq
      wo cR wer cB cA cR cqs wcel vy cv cR cec cC wceq vy wex cB cC wceq cB cC
      cin c0 wceq wo cC cA cR cqs wcel cR wer vx cv cR cec cB wceq vx wex vy cv
      cR cec cC wceq vy wex cB cC wceq cB cC cin c0 wceq wo wi cB cA cR cqs
      wcel cR wer vx cv cR cec cB wceq vx wex vy cv cR cec cC wceq vy wex cB cC
      wceq cB cC cin c0 wceq wo wi cR wer vx cv cR cec cB wceq vx wex wa vy cv
      cR cec cC wceq cB cC wceq cB cC cin c0 wceq wo vy cR wer vx cv cR cec cB
      wceq vx wex vy cv cR cec cC wceq cB cC wceq cB cC cin c0 wceq wo wi cR
      wer vx cv cR cec cB wceq vy cv cR cec cC wceq cB cC wceq cB cC cin c0
      wceq wo wi vx cR wer vx cv cR cec cB wceq vy cv cR cec cC wceq cB cC wceq
      cB cC cin c0 wceq wo vx cv cR cec cB wceq vy cv cR cec cC wceq wa vx cv
      cR cec vy cv cR cec wceq vx cv cR cec vy cv cR cec cin c0 wceq wo cB cC
      wceq cB cC cin c0 wceq wo cR wer vx cv cR cec cB wceq vx cv cR cec vy cv
      cR cec wceq vx cv cR cec vy cv cR cec cin c0 wceq wo cB vy cv cR cec wceq
      cB vy cv cR cec cin c0 wceq wo vy cv cR cec cC wceq cB cC wceq cB cC cin
      c0 wceq wo vx cv cR cec cB wceq vx cv cR cec vy cv cR cec wceq cB vy cv
      cR cec wceq vx cv cR cec vy cv cR cec cin c0 wceq cB vy cv cR cec cin c0
      wceq vx cv cR cec cB vy cv cR cec eqeq1 vx cv cR cec cB wceq vx cv cR cec
      vy cv cR cec cin cB vy cv cR cec cin c0 vx cv cR cec cB vy cv cR cec
      ineq1 eqeq1d orbi12d vy cv cR cec cC wceq cB vy cv cR cec wceq cB cC wceq
      cB vy cv cR cec cin c0 wceq cB cC cin c0 wceq vy cv cR cec cC cB eqeq2 vy
      cv cR cec cC wceq cB vy cv cR cec cin cB cC cin c0 vy cv cR cec cC cB
      ineq2 eqeq1d orbi12d sylan9bb vx cv vy cv cR vx visset vy visset erdisj2
      syl5cbi exp3a 19.23adv imp 19.23adv ex cB cA cR cqs wcel cB vx cv cR cec
      wceq vx wex vx cv cR cec cB wceq vx wex cB cA cR cqs wcel vx cv cA wcel
      cB vx cv cR cec wceq wa vx wex cB vx cv cR cec wceq vx wex cB cA cR cqs
      wcel cB vx cv cR cec wceq vx cA wrex vx cv cA wcel cB vx cv cR cec wceq
      wa vx wex vx cA cB cR elqsi cB vx cv cR cec wceq vx cA df-rex sylib vx cv
      cA wcel cB vx cv cR cec wceq vx exan3 syl cB vx cv cR cec wceq vx cv cR
      cec cB wceq vx cB vx cv cR cec eqcom exbii sylib syl5 cC cA cR cqs wcel
      cC vy cv cR cec wceq vy wex vy cv cR cec cC wceq vy wex cC cA cR cqs wcel
      vy cv cA wcel cC vy cv cR cec wceq wa vy wex cC vy cv cR cec wceq vy wex
      cC cA cR cqs wcel cC vy cv cR cec wceq vy cA wrex vy cv cA wcel cC vy cv
      cR cec wceq wa vy wex vy cA cC cR elqsi cC vy cv cR cec wceq vy cA df-rex
      sylib vy cv cA wcel cC vy cv cR cec wceq vy exan3 syl cC vy cv cR cec
      wceq vy cv cR cec cC wceq vy cC vy cv cR cec eqcom exbii sylib syl7 imp3a
      $.
      $( [22-Oct-2010] $) $( [12-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( Closed form of ~ elqs . $)
    elqs2 $p |- ( B e. C -> ( B e. ( A /. R ) <-> E. x e. A B = [ x ] R ) )
        $=
      vy cv vx cv cR cec wceq vx cA wrex cB vx cv cR cec wceq vx cA wrex vy cB
      cA cR cqs cC vy cv cB wceq vy cv vx cv cR cec wceq cB vx cv cR cec wceq
      vx cA vy cv cB vx cv cR cec eqeq1 rexbidv vx vy cA cR df-qs elab2g $.
      $( [22-Oct-2010] $) $( [12-Oct-2010] $)
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x R $.
    $( Lemma for ~ prter2 . $)
    prtlem11 $p |- ( B e. D ->
                        ( C e. A -> ( B = [ C ] R -> B e. ( A /. R ) ) ) )
        $=
      cB cD wcel cC cA wcel cB cC cR cec wceq cB cA cR cqs wcel cB cD wcel cB
      cA cR cqs wcel cB vx cv cR cec wceq vx cA wrex cC cA wcel cB cC cR cec
      wceq wa vx cA cB cD cR elqs2 vx cv cC wceq vx cA wrex cB cC cR cec wceq
      cB vx cv cR cec wceq vx cA wrex cC cA wcel vx cv cC wceq vx cA wrex cB cC
      cR cec wceq wa vx cv cC wceq cB cC cR cec wceq wa vx cA wrex cB vx cv cR
      cec wceq vx cA wrex vx cv cC wceq cB cC cR cec wceq vx cA r19.41v vx cv
      cC wceq cB cC cR cec wceq wa cB vx cv cR cec wceq vx cA vx cv cR cec cC
      cR cec wceq cB cC cR cec wceq cB vx cv cR cec wceq vx cv cC wceq vx cv cR
      cec cC cR cec wceq cB cC cR cec wceq wa vx cv cR cec cB vx cv cR cec cB
      cC cR cec eqtr3 eqcomd vx cv cC cR eceq2 sylan r19.22si sylbir vx cC cA
      risset sylanb syl5bir exp3a $.
      $( [22-Oct-2010] $) $( [12-Oct-2010] $)
  $}

  ${
    $d x R $.  $d x A $.
    $( Closed form of ~ 0nelqs . $)
    0nelqs2 $p |- ( dom R = A -> -. (/) e. ( A /. R ) )
        $=
      cR cdm cA wceq c0 vx cv cR cec wceq vx cA wrex c0 cA cR cqs wcel cR cdm
      cA wceq c0 vx cv cR cec wceq wn vx cA wral c0 vx cv cR cec wceq vx cA
      wrex wn cR cdm cA wceq c0 vx cv cR cec wceq wn vx cA cR cdm cA wceq c0 vx
      cv cR cec wceq wn vx cv cA wcel cR cdm cA wceq vx cv cR cdm wcel vx cv cA
      wcel c0 vx cv cR cec wceq wn cR cdm cA vx cv eleq2 vx cv cR cdm wcel vx
      cv cR cec c0 wne c0 vx cv cR cec wne c0 vx cv cR cec wceq wn vx cv cR vx
      visset ecdmn0 vx cv cR cec c0 necom c0 vx cv cR cec df-ne 3bitri syl5bbr
      biimprd r19.21aiv c0 vx cv cR cec wceq vx cA ralnex sylib vx cA c0 cR
      elqsi nsyl $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y $.
    $( Lemma for ~ prtex and ~ prter3 . $)
    prtlem12 $p |- ( R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) }
                        -> Rel R )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cR
      wrel vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wrel vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy relopab cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab releq mpbiri $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y u z $.  $d x y u w $.  $d x y u A $.  $d u v z $.  $d u v w $.
    $d u v A $.
    $( Lemma for ~ prter1 , ~ prter2 , ~ prter3 and ~ prtex . $)
    prtlem13 $p |- ( R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) }
                        -> ( z R w <-> E. v e. A ( z e. v /\ w e. v ) ) )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv
      vw cv cR wbr vz cv vu cv wcel vw cv vu cv wcel wa vu cA wrex vz cv vv cv
      wcel vw cv vv cv wcel wa vv cA wrex cR vx cv vu cv wcel vy cv vu cv wcel
      wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vz cv wsbc vy vw cv wsbc vz cv vu cv wcel vw
      cv vu cv wcel wa vu cA wrex vx cv vu cv wcel vy cv vu cv wcel wa vu cA
      wrex vx vy vz vw cR brabsb2 vu vy vx cA vw vz prtlem5 syl6bb vz cv vu cv
      wcel vw cv vu cv wcel wa vz cv vv cv wcel vw cv vv cv wcel wa vu vv cA vu
      cv vv cv wceq vz cv vu cv wcel vz cv vv cv wcel vw cv vu cv wcel vw cv vv
      cv wcel vu vv vz elequ2 vu vv vw elequ2 anbi12d cbvrexv syl6bb $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y u w z A $.  $d u v w z A $.  $d w z R $.
    $( Lemma for ~ prtex , ~ prter2 and ~ prter3 . $)
    prtlem16 $p |- ( R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) }
                        -> dom R = U. A )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cR
      cdm cA cuni cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq vz cv cR cdm wcel vz cv cA cuni wcel cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq vz cv cR cdm wcel vz cv vv cv
      wcel vv cv cA wcel wa vv wex vz cv cA cuni wcel cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq vz cv cR cdm wcel vv cv cA wcel
      vz cv vv cv wcel wa vv wex vz cv vv cv wcel vv cv cA wcel wa vv wex cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv cR
      cdm wcel vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vw wex wa vv
      wex vv cv cA wcel vz cv vv cv wcel wa vv wex cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq vz cv cR cdm wcel vv cv cA wcel vz
      cv vv cv wcel wa vw cv vv cv wcel wa vw wex vv wex vv cv cA wcel vz cv vv
      cv wcel wa vw cv vv cv wcel vw wex wa vv wex cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq vz cv cR cdm wcel vv cv cA wcel vz
      cv vv cv wcel wa vw cv vv cv wcel wa vv wex vw wex vv cv cA wcel vz cv vv
      cv wcel wa vw cv vv cv wcel wa vw wex vv wex cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq vz cv cR cdm wcel vz cv vv cv wcel
      vw cv vv cv wcel wa vv cA wrex vw wex vv cv cA wcel vz cv vv cv wcel wa
      vw cv vv cv wcel wa vv wex vw wex cR vx cv vu cv wcel vy cv vu cv wcel wa
      vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vw wex vz cv vv cv wcel vw
      cv vv cv wcel wa vv cA wrex vw wex vz cv cR cdm wcel cR vx cv vu cv wcel
      vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vz cv
      vv cv wcel vw cv vv cv wcel wa vv cA wrex vw vx vy vz vw vv vu cA cR
      prtlem13 exbidv vw vz cv cR vz visset eldm syl5bb vz cv vv cv wcel vw cv
      vv cv wcel wa vv cA wrex vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv
      wcel wa vv wex vw vz cv vv cv wcel vw cv vv cv wcel wa vv cA wrex vv cv
      cA wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vv cv cA wcel vz
      cv vv cv wcel wa vw cv vv cv wcel wa vv wex vz cv vv cv wcel vw cv vv cv
      wcel wa vv cA df-rex vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel
      wa vv cv cA wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vv vv cv cA wcel
      vz cv vv cv wcel vw cv vv cv wcel anass exbii bitr4i exbii syl6bb vv cv
      cA wcel vz cv vv cv wcel wa vw cv vv cv wcel wa vw vv excom syl6bb vv cv
      cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vv vw exdistr syl6bb vv cv
      cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vw wex vv exan2 syl6bi vv cv
      cA wcel vz cv vv cv wcel vv exancom syl6ib vv vz cv cA eluni syl6ibr cR
      vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv cR
      cdm wcel vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vw wex wa vv
      wex vz cv cA cuni wcel cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex
      vx vy copab wceq vz cv cR cdm wcel vv cv cA wcel vz cv vv cv wcel wa vw
      cv vv cv wcel wa vw wex vv wex vv cv cA wcel vz cv vv cv wcel wa vw cv vv
      cv wcel vw wex wa vv wex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA
      wrex vx vy copab wceq vz cv cR cdm wcel vv cv cA wcel vz cv vv cv wcel wa
      vw cv vv cv wcel wa vv wex vw wex vv cv cA wcel vz cv vv cv wcel wa vw cv
      vv cv wcel wa vw wex vv wex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA
      wrex vx vy copab wceq vz cv cR cdm wcel vz cv vv cv wcel vw cv vv cv wcel
      wa vv cA wrex vw wex vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel
      wa vv wex vw wex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq vz cv vw cv cR wbr vw wex vz cv vv cv wcel vw cv vv cv wcel wa
      vv cA wrex vw wex vz cv cR cdm wcel cR vx cv vu cv wcel vy cv vu cv wcel
      wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vz cv vv cv wcel vw cv
      vv cv wcel wa vv cA wrex vw vx vy vz vw vv vu cA cR prtlem13 exbidv vw vz
      cv cR vz visset eldm syl5bb vz cv vv cv wcel vw cv vv cv wcel wa vv cA
      wrex vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel wa vv wex vw vz
      cv vv cv wcel vw cv vv cv wcel wa vv cA wrex vv cv cA wcel vz cv vv cv
      wcel vw cv vv cv wcel wa wa vv wex vv cv cA wcel vz cv vv cv wcel wa vw
      cv vv cv wcel wa vv wex vz cv vv cv wcel vw cv vv cv wcel wa vv cA df-rex
      vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel wa vv cv cA wcel vz cv
      vv cv wcel vw cv vv cv wcel wa wa vv vv cv cA wcel vz cv vv cv wcel vw cv
      vv cv wcel anass exbii bitr4i exbii syl6bb vv cv cA wcel vz cv vv cv wcel
      wa vw cv vv cv wcel wa vw vv excom syl6bb vv cv cA wcel vz cv vv cv wcel
      wa vw cv vv cv wcel vv vw exdistr syl6bb vz cv cA cuni wcel vv cv cA wcel
      vz cv vv cv wcel wa vv wex vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv
      wcel vw wex wa vv wex vz cv cA cuni wcel vz cv vv cv wcel vv cv cA wcel
      wa vv wex vv cv cA wcel vz cv vv cv wcel wa vv wex vv vz cv cA eluni vv
      cv cA wcel vz cv vv cv wcel vv exancom bitr4i vv cv cA wcel vz cv vv cv
      wcel wa vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vw wex wa vv
      vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vw wex vz cv vv cv
      wcel vw cv vv cv wcel vw wex vv cv cA wcel vz cv vv cv wcel vw cv vz cv
      wceq vw cv vv cv wcel wa vw wex vw cv vv cv wcel vw wex vw vz cv vv cv
      df-clel vw cv vz cv wceq vw cv vv cv wcel vw exan3 sylbi adantl ancli
      19.22i sylbi syl5bir impbid eqrdv $.
      $( [22-Oct-2010] $) $( [14-Oct-2010] $)
  $}

  ${
    $d x y u A $.
    $( Lemma for ~ prter2 and also a property of partitions . $)
    prtlem400 $p |- ( R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) }
                        -> -. (/) e. ( U. A /. R ) )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cR
      cdm cA cuni wceq c0 cA cuni cR cqs wcel wn vx vy vu cA cR prtlem16 cA
      cuni cR 0nelqs2 syl $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  $( Introduce the partition predicate. $)
  $c Prt $.

  $( Extend the definition of a wff to include the partition predicate. $)
  wprt $a wff Prt A $.

  ${
    $d x y A $.
    $( Define the partition predicate. $)
    df-prt $a |- ( Prt A <-> A. x e. A A. y e. A ( x = y \/
                                                ( x i^i y ) = (/) ) ) $.
  $}

  ${
    $d x y A $.  $d x y R $.
    $( The quotient set of an equivalence relation is a partition. $)
    erprt $p |- ( Er R -> Prt ( A /. R ) )
        $=
      cR wer vx cv vy cv wceq vx cv vy cv cin c0 wceq wo vy cA cR cqs wral vx
      cA cR cqs wral cA cR cqs wprt cR wer vx cv vy cv wceq vx cv vy cv cin c0
      wceq wo vx vy cA cR cqs cA cR cqs cA vx cv vy cv cR erdisj3 r19.21aivv vx
      vy cA cR cqs df-prt sylibr $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d w x $.  $d w y $.
    $( Lemma for ~ prter1 , ~ prter2 and ~ prtex . $)
    prtlem14 $p |- ( Prt A -> ( ( x e. A /\ y e. A )
                                -> ( ( w e. x /\ w e. y ) -> x = y ) ) )
        $=
      cA wprt vx cv cA wcel vy cv cA wcel wa vx cv vy cv wceq vx cv vy cv cin
      c0 wceq wo vw cv vx cv wcel vw cv vy cv wcel wa vx cv vy cv wceq wi cA
      wprt vx cv vy cv wceq vx cv vy cv cin c0 wceq wo vy cA wral vx cA wral vx
      cv cA wcel vy cv cA wcel wa vx cv vy cv wceq vx cv vy cv cin c0 wceq wo
      wi vx vy cA df-prt vx cv vy cv wceq vx cv vy cv cin c0 wceq wo vx vy cA
      cA ra42 sylbi vx cv vy cv wceq vx cv vy cv cin c0 wceq vw cv vx cv wcel
      vw cv vy cv wcel wa vx cv vy cv cin c0 wceq vw cv vx cv vy cv cin wcel vx
      cv vy cv wceq vw cv vx cv wcel vw cv vy cv wcel wa vx cv vy cv cin c0
      wceq vw cv vx cv vy cv cin wcel vx cv vy cv wceq vx cv vy cv cin c0 wceq
      vw cv vx cv vy cv cin wcel wn vw wal vw cv vx cv vy cv cin wcel wn vw vx
      cv vy cv cin eq0 vw cv vx cv vy cv cin wcel wn vw ax-4 sylbi pm2.21d vw
      cv vx cv vy cv elin syl5ibr prtlem1 syl6 $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d z x $.  $d z y $.  $d y w $.
    $( Lemma for ~ prter2 . $)
    prtlem17 $p |- ( Prt A -> ( ( x e. A /\ z e. x )
                                        -> ( E. y e. A ( z e. y /\ w e. y )
                                                -> w e. x ) ) )
        $=
      cA wprt vx cv cA wcel vz cv vx cv wcel wa vz cv vy cv wcel vw cv vy cv
      wcel wa vy cA wrex vw cv vx cv wcel wi cA wprt vx cv cA wcel vz cv vx cv
      wcel wa wa vy cv cA wcel vz cv vy cv wcel vw cv vy cv wcel wa wa vy wex
      vw cv vx cv wcel vz cv vy cv wcel vw cv vy cv wcel wa vy cA wrex cA wprt
      vx cv cA wcel vz cv vx cv wcel wa wa vy cv cA wcel vz cv vy cv wcel vw cv
      vy cv wcel wa wa vw cv vx cv wcel vy cA wprt vx cv cA wcel vz cv vx cv
      wcel wa vy cv cA wcel vz cv vy cv wcel vw cv vy cv wcel wa vw cv vx cv
      wcel cA wprt vx cv cA wcel vz cv vx cv wcel wa vy cv cA wcel vz cv vy cv
      wcel vw cv vy cv wcel vw cv vx cv wcel cA wprt vx cv cA wcel vz cv vx cv
      wcel wa vy cv cA wcel vz cv vy cv wcel vw cv vy cv wcel vw cv vx cv wcel
      wi wi cA wprt vx cv cA wcel vy cv cA wcel wa vz cv vx cv wcel wa vz cv vy
      cv wcel vw cv vy cv wcel vw cv vx cv wcel wi wi vx cv cA wcel vz cv vx cv
      wcel wa vy cv cA wcel wa cA wprt vx cv cA wcel vy cv cA wcel wa vz cv vx
      cv wcel vz cv vy cv wcel vw cv vy cv wcel vw cv vx cv wcel wi wi cA wprt
      vx cv cA wcel vy cv cA wcel wa vz cv vx cv wcel vz cv vy cv wcel vw cv vy
      cv wcel vw cv vx cv wcel wi cA wprt vx cv cA wcel vy cv cA wcel wa vz cv
      vx cv wcel vz cv vy cv wcel wa vx cv vy cv wceq vw cv vy cv wcel vw cv vx
      cv wcel wi vx vy vz cA prtlem14 vx cv vy cv wceq vw cv vx cv wcel vw cv
      vy cv wcel vx vy vw elequ2 biimprd syl8 exp4a imp3a vx cv cA wcel vy cv
      cA wcel vz cv vx cv wcel an23 syl5ibr exp3a imp5a imp4b 19.23adv vz cv vy
      cv wcel vw cv vy cv wcel wa vy cA df-rex syl5ib ex $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y u z $.  $d x y u w $.  $d x y u A $.  $d u v z $.  $d u v w $.
    $d u p z $.  $d u p w $.  $d u v p A $.  $d v R $.
    $( Lemma for ~ prter2 . $)
    prtlem18 $p |- ( ( Prt A /\
                        R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } )
                        -> ( ( v e. A /\ z e. v ) -> ( w e. v <-> z R w ) ) )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cA
      wprt vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vz cv vw cv cR
      wbr wb wi cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cA wprt vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vz cv vw
      cv cR wbr wb cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq cA wprt vv cv cA wcel vz cv vv cv wcel wa wa wa vw cv vv cv
      wcel vz cv vw cv cR wbr cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA
      wrex vx vy copab wceq cA wprt vv cv cA wcel vz cv vv cv wcel wa vw cv vv
      cv wcel vz cv vw cv cR wbr wi cR vx cv vu cv wcel vy cv vu cv wcel wa vu
      cA wrex vx vy copab wceq vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv
      wcel vz cv vw cv cR wbr wi wi cA wprt cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq vv cv cA wcel vz cv vv cv wcel wa vw
      cv vv cv wcel vz cv vw cv cR wbr cR vx cv vu cv wcel vy cv vu cv wcel wa
      vu cA wrex vx vy copab wceq vv cv cA wcel vz cv vv cv wcel vw cv vv cv
      wcel wa wa vz cv vw cv cR wbr vv cv cA wcel vz cv vv cv wcel wa vw cv vv
      cv wcel wa cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq vv cv cA wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vz cv vw cv cR
      wbr wi vv cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq vv cv cA wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vz cv
      vw cv cR wbr wi vv cv cA wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vz
      cv vw cv cR wbr wi vv wal cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA
      wrex vx vy copab wceq vz cv vw cv cR wbr vv cv cA wcel vz cv vv cv wcel
      vw cv vv cv wcel wa wa vv wex cR vx cv vu cv wcel vy cv vu cv wcel wa vu
      cA wrex vx vy copab wceq vz cv vw cv cR wbr vz cv vv cv wcel vw cv vv cv
      wcel wa vv cA wrex vv cv cA wcel vz cv vv cv wcel vw cv vv cv wcel wa wa
      vv wex vx vy vz vw vv vu cA cR prtlem13 vz cv vv cv wcel vw cv vv cv wcel
      wa vv cA df-rex syl6bb biimprd vv cv cA wcel vz cv vv cv wcel vw cv vv cv
      wcel wa wa vz cv vw cv cR wbr vv 19.23v sylibr 19.21bi vv cv cA wcel vz
      cv vv cv wcel vw cv vv cv wcel anass syl5ib exp3a a1d imp32 cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR
      wbr vz cv vp cv wcel vw cv vp cv wcel wa vp cA wrex cA wprt vv cv cA wcel
      vz cv vv cv wcel wa wa vw cv vv cv wcel cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vz cv vp cv wcel
      vw cv vp cv wcel wa vp cA wrex vx vy vz vw vp vu cA cR prtlem13 biimpd cA
      wprt vv cv cA wcel vz cv vv cv wcel wa vz cv vp cv wcel vw cv vp cv wcel
      wa vp cA wrex vw cv vv cv wcel wi vv vp vz vw cA prtlem17 imp sylan9
      impbid expr ancoms $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y u w z A $.  $d u v w z A $.  $d v w R $.
    $( Lemma for ~ prter2 . $)
    prtlem19 $p |- ( ( Prt A /\
                        R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } )
                        -> ( ( v e. A /\ z e. v ) -> v = [ z ] R ) )
        $=
      cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq wa vv cv cA wcel vz cv vv cv wcel wa vv cv vz cv cR cec wceq cA wprt
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vv
      cv cA wcel vz cv vv cv wcel wa wa vz cv cR cec vv cv cA wprt cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vv cv cA wcel
      vz cv vv cv wcel wa wa vw vz cv cR cec vv cv cA wprt cR vx cv vu cv wcel
      vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vv cv cA wcel vz cv vv
      cv wcel wa wa vz cv vw cv cR wbr vw cv vv cv wcel vw cv vz cv cR cec wcel
      cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq wa vv cv cA wcel vz cv vv cv wcel wa vz cv vw cv cR wbr vw cv vv cv
      wcel wb cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq wa vv cv cA wcel vz cv vv cv wcel wa vw cv vv cv wcel vz cv vw
      cv cR wbr vx vy vz vw vv vu cA cR prtlem18 bicomdd imp vw cv vz cv cR vw
      visset vz visset elec syl5bb eqrdv eqcomd ex $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y A $.  $d x z A $.  $d x y u $.  $d x y v $.
    $d x z u $.  $d x z v $.  $d w x $.  $d w y $.
    $( Lemma for ~ prter1 and ~ prtex . $)
    prtlem15 $p |- ( Prt A -> ( E. x e. A E. y e. A ( ( u e. x /\ w e. x )
                        /\ ( w e. y /\ v e. y ) )
                        -> E. z e. A ( u e. z /\ v e. z ) ) )
        $=
      cA wprt vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv
      wcel wa wa vy cA wrex vx cA wrex vu cv vx cv wcel vv cv vx cv wcel wa vx
      cA wrex vu cv vz cv wcel vv cv vz cv wcel wa vz cA wrex cA wprt vu cv vx
      cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv wcel wa wa vy cA
      wrex vu cv vx cv wcel vv cv vx cv wcel wa vx cA cA wprt vx cv cA wcel wa
      vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv wcel wa
      wa vu cv vx cv wcel vv cv vx cv wcel wa vy cA cA wprt vx cv cA wcel vy cv
      cA wcel vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv
      wcel wa wa vu cv vx cv wcel vv cv vx cv wcel wa wi cA wprt vx cv cA wcel
      vy cv cA wcel wa vw cv vx cv wcel vw cv vy cv wcel wa vu cv vx cv wcel vw
      cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv wcel wa wa wa vu cv vx cv
      wcel vv cv vx cv wcel wa vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv
      wcel vv cv vy cv wcel wa wa cA wprt vx cv cA wcel vy cv cA wcel wa vw cv
      vx cv wcel vw cv vy cv wcel wa vu cv vx cv wcel vw cv vx cv wcel wa vw cv
      vy cv wcel vv cv vy cv wcel wa wa vu cv vx cv wcel vv cv vx cv wcel wa cA
      wprt vx cv cA wcel vy cv cA wcel wa vw cv vx cv wcel vw cv vy cv wcel wa
      vx cv vy cv wceq vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv
      cv vy cv wcel wa wa vu cv vx cv wcel vv cv vx cv wcel wa wi vx vy vw cA
      prtlem14 vx cv vy cv wceq vu cv vx cv wcel vv cv vx cv wcel wa vu cv vx
      cv wcel vv cv vy cv wcel wa vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy
      cv wcel vv cv vy cv wcel wa wa vx cv vy cv wceq vv cv vx cv wcel vv cv vy
      cv wcel vu cv vx cv wcel vx vy vv elequ2 anbi2d vu cv vx cv wcel vw cv vx
      cv wcel vw cv vy cv wcel vv cv vy cv wcel an3 syl5bir syl8 imp4a vw cv vx
      cv wcel vw cv vy cv wcel wa vu cv vx cv wcel vv cv vy cv wcel wa vw cv vx
      cv wcel vw cv vy cv wcel wa wa wa vu cv vx cv wcel vv cv vy cv wcel wa vw
      cv vx cv wcel vw cv vy cv wcel wa wa vw cv vx cv wcel vw cv vy cv wcel wa
      vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv wcel wa
      wa wa vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel vv cv vy cv
      wcel wa wa vu cv vx cv wcel vv cv vy cv wcel wa vw cv vx cv wcel vw cv vy
      cv wcel wa anabs7 vu cv vx cv wcel vw cv vx cv wcel wa vw cv vy cv wcel
      vv cv vy cv wcel wa wa vu cv vx cv wcel vv cv vy cv wcel wa vw cv vx cv
      wcel vw cv vy cv wcel wa wa vw cv vx cv wcel vw cv vy cv wcel wa vu cv vx
      cv wcel vw cv vx cv wcel vw cv vy cv wcel vv cv vy cv wcel an43 anbi2i vu
      cv vx cv wcel vw cv vx cv wcel vw cv vy cv wcel vv cv vy cv wcel an43
      3bitr4ri syl7ib expdimp r19.23adv r19.22dva vu cv vx cv wcel vv cv vx cv
      wcel wa vu cv vz cv wcel vv cv vz cv wcel wa vx vz cA vx cv vz cv wceq vu
      cv vx cv wcel vu cv vz cv wcel vv cv vx cv wcel vv cv vz cv wcel vx vz vu
      elequ2 vx vz vv elequ2 anbi12d cbvrexv syl6ib $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y u z $.  $d x y u w $.  $d x y u p A $.  $d u v r A $.
    $d u v w q A $.  $d u v z p q A $.  $d z w p R $.  $d u r z $.  $d u r p $.
    $( Every partition generates an equivalence relation. $)
    prter1 $p |- ( ( Prt A /\
                        R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } )
                        -> Er R )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cA
      wprt cR wer cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq cA wprt wa vz cv vw cv cR wbr vw cv vz cv cR wbr wi vz cv vw
      cv cR wbr vw cv vp cv cR wbr wa vz cv vp cv cR wbr wi wa vp wal vw wal vz
      wal cR wer cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cA wprt wa vz cv vw cv cR wbr vw cv vz cv cR wbr wi vz cv vw cv cR
      wbr vw cv vp cv cR wbr wa vz cv vp cv cR wbr wi wa vp wal vw wal vz cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cA wprt wa
      vz cv vw cv cR wbr vw cv vz cv cR wbr wi vz cv vw cv cR wbr vw cv vp cv
      cR wbr wa vz cv vp cv cR wbr wi wa vw vp cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq cA wprt wa vz cv vw cv cR wbr vw cv
      vz cv cR wbr wi vz cv vw cv cR wbr vw cv vp cv cR wbr wa vz cv vp cv cR
      wbr wi cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq vz cv vw cv cR wbr vw cv vz cv cR wbr wi cA wprt cR vx cv vu cv wcel
      vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vw cv
      vz cv cR wbr cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq vz cv vw cv cR wbr vw cv vv cv wcel vz cv vv cv wcel wa vv cA
      wrex vw cv vz cv cR wbr cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA
      wrex vx vy copab wceq vz cv vw cv cR wbr vz cv vv cv wcel vw cv vv cv
      wcel wa vv cA wrex vw cv vv cv wcel vz cv vv cv wcel wa vv cA wrex vx vy
      vz vw vv vu cA cR prtlem13 vz cv vv cv wcel vw cv vv cv wcel wa vw cv vv
      cv wcel vz cv vv cv wcel wa vv cA vz cv vv cv wcel vw cv vv cv wcel ancom
      rexbii syl6bb vx vy vw vz vv vu cA cR prtlem13 bitr4d biimpd adantr cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cA wprt wa
      vz cv vw cv cR wbr vw cv vp cv cR wbr wa vz cv vr cv wcel vp cv vr cv
      wcel wa vr cA wrex vz cv vp cv cR wbr cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vw cv vp cv cR wbr
      wa vz cv vv cv wcel vw cv vv cv wcel wa vw cv vq cv wcel vp cv vq cv wcel
      wa wa vq cA wrex vv cA wrex cA wprt vz cv vr cv wcel vp cv vr cv wcel wa
      vr cA wrex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq vz cv vw cv cR wbr vw cv vp cv cR wbr wa vz cv vv cv wcel vw cv vv
      cv wcel wa vw cv vq cv wcel vp cv vq cv wcel wa wa vq cA wrex vv cA wrex
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv
      vw cv cR wbr vw cv vp cv cR wbr wa vz cv vv cv wcel vw cv vv cv wcel wa
      vv cA wrex vw cv vq cv wcel vp cv vq cv wcel wa vq cA wrex wa vz cv vv cv
      wcel vw cv vv cv wcel wa vw cv vq cv wcel vp cv vq cv wcel wa wa vq cA
      wrex vv cA wrex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq vz cv vw cv cR wbr vz cv vv cv wcel vw cv vv cv wcel wa vv cA
      wrex vw cv vp cv cR wbr vw cv vq cv wcel vp cv vq cv wcel wa vq cA wrex
      vx vy vz vw vv vu cA cR prtlem13 vx vy vw vp vq vu cA cR prtlem13 anbi12d
      vz cv vv cv wcel vw cv vv cv wcel wa vw cv vq cv wcel vp cv vq cv wcel wa
      vv vq cA cA reeanv syl6bbr biimpd vv vq vr vw vp vz cA prtlem15 sylan9 cR
      vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vp
      cv cR wbr vz cv vr cv wcel vp cv vr cv wcel wa vr cA wrex wb cA wprt vx
      vy vz vp vr vu cA cR prtlem13 adantr sylibrd jca 19.21aivv 19.21aiv vz vw
      vp cR dfer2 sylibr ancoms $.
      $( [22-Oct-2010] $) $( [13-Oct-2010] $)
  $}

  ${
    $d x y u A $.
    $( Lemma for ~ prtex . $)
    prtlem300 $p |- ( ( Prt A /\
                        R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } )
                        -> ( R e. _V <-> U. A e. _V ) )
        $=
      cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq wa cR cvv wcel cR cdm cvv wcel cA cuni cvv wcel cR wrel cR wer cR
      cvv wcel cR cdm cvv wcel wb cA wprt cR vx cv vu cv wcel vy cv vu cv wcel
      wa vu cA wrex vx vy copab wceq wa cR erex2 cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq cR wrel cA wprt vx vy vu cA cR
      prtlem12 adantl vx vy vu cA cR prter1 sylanc cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq cR cdm cvv wcel cA cuni cvv wcel
      wb cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cR cdm cA cuni cvv vx vy vu cA cR prtlem16 eleq1d adantl bitrd $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y u A $.
    $( The equivalence relation generated by a partition is a set if and only
       if the partition itself is a set.  $)
    prtex $p |- ( ( Prt A /\
                        R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } )
                        -> ( R e. _V <-> A e. _V ) )
        $=
      cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq wa cR cvv wcel cA cuni cvv wcel cA cvv wcel vx vy vu cA cR prtlem300
      cA uniexb syl6bbr $.
      $( [22-Oct-2010] $) $( [15-Oct-2010] $)
  $}

  ${
    $d x y u v z p A $.  $d v z p R $.
    $( The quotient set of the equivalence relation generated by a partition
       equals the partition itself. $)
    prter2 $p |- ( ( Prt A /\
                        R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } )
                        -> ( U. A /. R ) = ( A \ { (/) } ) )
        $=
      cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq wa vp cA cuni cR cqs cA c0 csn cdif cA wprt cR vx cv vu cv wcel vy
      cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vp cv cA cuni cR cqs wcel
      vp cv cA c0 csn cdif wcel cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa
      vu cA wrex vx vy copab wceq wa vp cv cA cuni cR cqs wcel vp cv cA wcel vp
      cv c0 wne wa vp cv cA c0 csn cdif wcel cA wprt cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq wa vp cv cA cuni cR cqs wcel vp
      cv cA wcel vp cv c0 wne cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa
      vu cA wrex vx vy copab wceq wa vp cv cA cuni cR cqs wcel vv cv vp cv wceq
      vv cA wrex vp cv cA wcel cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa
      vu cA wrex vx vy copab wceq wa vp cv cA cuni cR cqs wcel vv cv vp cv wceq
      vz vv cv wrex vv cA wrex vv cv vp cv wceq vv cA wrex cA wprt cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vp cv cA cuni
      cR cqs wcel vv cv vz cv cR cec wceq vp cv vz cv cR cec wceq wa vz vv cv
      wrex vv cA wrex vv cv vp cv wceq vz vv cv wrex vv cA wrex cA wprt cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vp cv vz
      cv cR cec wceq vz vv cv wrex vv cA wrex vv cv vz cv cR cec wceq vp cv vz
      cv cR cec wceq wa vz vv cv wrex vv cA wrex vp cv cA cuni cR cqs wcel cA
      wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq
      wa vv cv vz cv cR cec wceq vz vv cv wral vv cA wral vp cv vz cv cR cec
      wceq vz vv cv wrex vv cA wrex vv cv vz cv cR cec wceq vp cv vz cv cR cec
      wceq wa vz vv cv wrex vv cA wrex wi cA wprt cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq wa vv cv vz cv cR cec wceq vv vz
      cA vv cv vx vy vz vv vu cA cR prtlem19 r19.21aivv vv cv vz cv cR cec wceq
      vz vv cv wral vv cA wral vp cv vz cv cR cec wceq vz vv cv wrex vv cA wrex
      vv cv vz cv cR cec wceq vp cv vz cv cR cec wceq wa vz vv cv wrex vv cA
      wrex vv cv vz cv cR cec wceq vp cv vz cv cR cec wceq vv vz cA vv cv
      2r19.29 ex syl vz cv vv cv wcel vp cv vz cv cR cec wceq wa vz wex vv cA
      wrex vz cv vv cv wcel vv cA wrex vp cv vz cv cR cec wceq wa vz wex vp cv
      vz cv cR cec wceq vz vv cv wrex vv cA wrex vp cv cA cuni cR cqs wcel vz
      cv vv cv wcel vp cv vz cv cR cec wceq wa vz wex vv cA wrex vz cv vv cv
      wcel vp cv vz cv cR cec wceq wa vv cA wrex vz wex vz cv vv cv wcel vv cA
      wrex vp cv vz cv cR cec wceq wa vz wex vz cv vv cv wcel vp cv vz cv cR
      cec wceq wa vv vz cA rexcom4 vz cv vv cv wcel vp cv vz cv cR cec wceq wa
      vv cA wrex vz cv vv cv wcel vv cA wrex vp cv vz cv cR cec wceq wa vz vz
      cv vv cv wcel vp cv vz cv cR cec wceq vv cA r19.41v exbii bitri vp cv vz
      cv cR cec wceq vz vv cv wrex vz cv vv cv wcel vp cv vz cv cR cec wceq wa
      vz wex vv cA vp cv vz cv cR cec wceq vz vv cv df-rex rexbii vp cv cA cuni
      cR cqs wcel vp cv vz cv cR cec wceq vz cA cuni wrex vz cv cA cuni wcel vp
      cv vz cv cR cec wceq wa vz wex vz cv vv cv wcel vv cA wrex vp cv vz cv cR
      cec wceq wa vz wex vz cA cuni vp cv cR vp visset elqs vp cv vz cv cR cec
      wceq vz cA cuni df-rex vz cv cA cuni wcel vp cv vz cv cR cec wceq wa vz
      cv vv cv wcel vv cA wrex vp cv vz cv cR cec wceq wa vz vz cv cA cuni wcel
      vz cv vv cv wcel vv cA wrex vp cv vz cv cR cec wceq vv vz cv cA eluni2
      anbi1i exbii 3bitri 3bitr4ri syl5ib vv cv vz cv cR cec wceq vp cv vz cv
      cR cec wceq wa vz vv cv wrex vv cv vp cv wceq vz vv cv wrex vv cA vv cv
      vz cv cR cec wceq vp cv vz cv cR cec wceq wa vv cv vp cv wceq vz vv cv vv
      cv vp cv vz cv cR cec eqtr3 r19.22si r19.22si syl6 vv cv vp cv wceq vz vv
      cv wrex vv cv vp cv wceq vv cA vv cv vp cv wceq vz vv cv wrex vz cv vv cv
      wcel vz wex vv cv vp cv wceq vv cv vp cv wceq vz vv cv wrex vz cv vv cv
      wcel vv cv vp cv wceq wa vz wex vz cv vv cv wcel vz wex vv cv vp cv wceq
      wa vv cv vp cv wceq vz vv cv df-rex vz cv vv cv wcel vv cv vp cv wceq vz
      19.41v bitri pm3.27bi r19.22si syl6 vv vp cv cA risset syl6ibr cR vx cv
      vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vp cv cA cuni
      cR cqs wcel vp cv c0 wne wi cA wprt cR vx cv vu cv wcel vy cv vu cv wcel
      wa vu cA wrex vx vy copab wceq c0 cA cuni cR cqs wcel wn vp cv cA cuni cR
      cqs wcel vp cv c0 wne wi vx vy vu cA cR prtlem400 c0 cA cuni cR cqs vp cv
      prtlem90 syl adantl jcad vp cv cA c0 eldifsn syl6ibr cA wprt cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vz cv vp cv
      wcel vz wex vp cv cA wcel wa vp cv cA cuni cR cqs wcel vp cv cA c0 csn
      cdif wcel cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx
      vy copab wceq wa vz cv vp cv wcel vp cv cA wcel wa vz wex vp cv cA cuni
      cR cqs wcel vz wex vz cv vp cv wcel vz wex vp cv cA wcel wa vp cv cA cuni
      cR cqs wcel cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx
      vy copab wceq wa vz cv vp cv wcel vp cv cA wcel wa vp cv cA cuni cR cqs
      wcel vz cA wprt cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq wa vz cv vp cv wcel vp cv cA wcel wa vz cv cA cuni wcel vp cv
      vz cv cR cec wceq wa vp cv cA cuni cR cqs wcel cA wprt cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vz cv vp cv wcel
      vp cv cA wcel wa vp cv vz cv cR cec wceq vz cv cA cuni wcel cA wprt cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq wa vp cv cA
      wcel vz cv vp cv wcel vp cv vz cv cR cec wceq vx vy vz vp vu cA cR
      prtlem19 ancomsd vz cv vp cv cA elunii jca2r vz cv cA cuni wcel vp cv vz
      cv cR cec wceq vp cv cA cuni cR cqs wcel vp cv cvv wcel vz cv cA cuni
      wcel vp cv vz cv cR cec wceq vp cv cA cuni cR cqs wcel wi wi vp visset cA
      cuni vp cv vz cv cvv cR prtlem11 ax-mp imp syl6 19.22dv vz cv vp cv wcel
      vp cv cA wcel vz 19.41v vp cv cA cuni cR cqs wcel vz 19.9v 3imtr3g vp cv
      cA c0 csn cdif wcel vz cv vp cv wcel vz wex vp cv cA wcel vz cv vp cv
      wcel vz wex vp cA c0 csn cdif c0 cA c0 csn cdif wcel wn vz cv vp cv wcel
      vz wex vp cA c0 csn cdif wral c0 cvv wcel c0 cA c0 csn cdif wcel wn 0ex
      c0 cvv cA prtlem80 ax-mp vp vz cA c0 csn cdif n0el mpbi rspec vp cv cA c0
      csn eldifi jca syl5 impbid eqrdv $.
      $( [22-Oct-2010] $) $( [17-Oct-2010] $)
  $}

  ${
    $d x y u z $.  $d x y u w $.  $d x y u A $.  $d u v z A $.  $d u v w A $.
    $d u v S $.  $d z w R $.  $d z w t S $.  $d t v $.  $d t A $.
    $( For every partition there exists a unique equivalence relation whose
       quotient set equals the partition. $)
    prter3 $p |- ( ( R = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } /\
                        ( Rel S /\
                                ( Er S /\
                                        ( S e. _V /\
                                                ( dom R = dom S /\
                                                        ( U. A /. S ) =
                                                        ( A \ { (/) } )
                        ) ) ) ) ) -> R = S )
        $=
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS
      wrel cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif
      wceq wa wa wa wa wa cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx
      vy copab wceq cS wrel cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex
      vx vy copab wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA
      c0 csn cdif wceq wa wa wa wa wa wa cR cS wceq cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq cS wrel cR vx cv vu cv wcel vy
      cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel cR cdm cS
      cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa wa wa cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wrel cS wer cS
      cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa
      wa wa wa cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cS wrel cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0
      csn cdif wceq wa wa wa wa wa cS wrel cR vx cv vu cv wcel vy cv vu cv wcel
      wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA
      cuni cS cqs cA c0 csn cdif wceq wa wa wa wa wa cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq cS wrel cS wer cS cvv wcel cR
      cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa wa cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wrel cR
      vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer
      cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa
      wa an12 anbi2i cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq cS wrel cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs
      cA c0 csn cdif wceq wa wa wa wa anabs5 bitri cR wrel cS wrel cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv
      wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa wa
      cR cS wceq cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cR wrel cS wrel cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex
      vx vy copab wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA
      c0 csn cdif wceq wa wa wa wa cR cS wceq cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel cR cdm cS cdm wceq
      cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz vw cR cS cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel
      cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz cv
      vw cv cR wbr vz cv vw cv cS wbr wb cR wrel cS wrel wa cR vx cv vu cv wcel
      vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel cR cdm
      cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz cv vw cv cR
      wbr vz cv vw cv cS wbr cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex
      vx vy copab wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA
      c0 csn cdif wceq wa wa wa wa vz cv vw cv cR wbr vz cv vw cv cS wbr cR vx
      cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS
      cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa
      wa vz cv cR cdm wcel vz cv vw cv cR wbr vz cv vw cv cS wbr wb vz cv vw cv
      cR wbr cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif
      wceq wa wa wa wa vz cv cR cdm wcel vz cv cS cdm wcel vz cv vw cv cR wbr
      vz cv vw cv cS wbr wb cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0
      csn cdif wceq wa wa vz cv cR cdm wcel vz cv cS cdm wcel wb cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cR cdm cS cdm
      wceq vz cv cR cdm wcel vz cv cS cdm wcel wb cS cvv wcel cA cuni cS cqs cA
      c0 csn cdif wceq cR cdm cS cdm vz cv eleq2 ad2antrl ad2antll cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv
      wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz
      cv cS cdm wcel vz cv vw cv cS wbr vz cv vw cv cR wbr cR vx cv vu cv wcel
      vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel cR cdm
      cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz cv cS cdm
      wcel vz cv vw cv cS wbr vz cv vw cv cR wbr wb cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel cR cdm cS
      cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz cv cS cdm wcel
      wa cS wer vz cv cS cdm wcel wa cR vx cv vu cv wcel vy cv vu cv wcel wa vu
      cA wrex vx vy copab wceq cR cdm cS cdm wceq wa cS cvv wcel cA cuni cS cqs
      cA c0 csn cdif wceq wa wa wa cR vx cv vu cv wcel vy cv vu cv wcel wa vu
      cA wrex vx vy copab wceq wa vz cv vw cv cS wbr vz cv vw cv cR wbr wb cR
      vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer
      cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq vz cv
      cS cdm wcel prtlem70 cS wer vz cv cS cdm wcel wa cR vx cv vu cv wcel vy
      cv vu cv wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm wceq wa cS cvv
      wcel cA cuni cS cqs cA c0 csn cdif wceq wa wa wa vz cv vw cv cS wbr vz cv
      vv cv wcel vw cv vv cv wcel wa vv cA wrex cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr cS wer vz cv cS
      cdm wcel wa vz cv vw cv cS wbr vz cv vt cv cS cec wcel vw cv vt cv cS cec
      wcel wa vt cS cdm wrex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex
      vx vy copab wceq cR cdm cS cdm wceq wa cS cvv wcel cA cuni cS cqs cA c0
      csn cdif wceq wa wa vz cv vv cv wcel vw cv vv cv wcel wa vv cA wrex cS
      wer vz cv cS cdm wcel vz cv vw cv cS wbr vz cv vt cv cS cec wcel vw cv vt
      cv cS cec wcel wa vt cS cdm wrex wb vz vw vt cS prtlem10 imp cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm
      wceq wa vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cS cdm wrex
      vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex cS cvv
      wcel cA cuni cS cqs cA c0 csn cdif wceq wa vz cv vv cv wcel vw cv vv cv
      wcel wa vv cA wrex cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx
      vy copab wceq cR cdm cS cdm wceq vz cv vt cv cS cec wcel vw cv vt cv cS
      cec wcel wa vt cS cdm wrex vz cv vt cv cS cec wcel vw cv vt cv cS cec
      wcel wa vt cA cuni wrex wb cR cdm cS cdm wceq cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq cS cdm cA cuni wceq vz cv vt cv
      cS cec wcel vw cv vt cv cS cec wcel wa vt cS cdm wrex vz cv vt cv cS cec
      wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex wb cR cdm cS cdm wceq cR
      cdm cA cuni wceq cS cdm cA cuni wceq cR vx cv vu cv wcel vy cv vu cv wcel
      wa vu cA wrex vx vy copab wceq cR cdm cS cdm cA cuni eqeq1 vx vy vu cA cR
      prtlem16 syl5bi vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cS
      cdm cA cuni rexeq1 syl6com imp cS cvv wcel cA cuni cS cqs cA c0 csn cdif
      wceq wa vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni
      wrex vz cv vv cv wcel vw cv vv cv wcel wa vv cA c0 csn cdif wrex vz cv vv
      cv wcel vw cv vv cv wcel wa vv cA wrex cS cvv wcel vz cv vt cv cS cec
      wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex vz cv vv cv wcel vw cv vv
      cv wcel wa vv cA cuni cS cqs wrex cA cuni cS cqs cA c0 csn cdif wceq vz
      cv vv cv wcel vw cv vv cv wcel wa vv cA c0 csn cdif wrex cS cvv wcel vz
      cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex vv cv cA
      cuni cS cqs wcel vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vz cv vv
      cv wcel vw cv vv cv wcel wa vv cA cuni cS cqs wrex cS cvv wcel vz cv vt
      cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex vt cv cA cuni
      wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa wa
      vt wex vv wex vv cv cA cuni cS cqs wcel vz cv vv cv wcel vw cv vv cv wcel
      wa wa vv wex cS cvv wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv
      vv cv wcel wa wa vt cA cuni wrex vv wex vz cv vt cv cS cec wcel vw cv vt
      cv cS cec wcel wa vt cA cuni wrex vt cv cA cuni wcel vv cv vt cv cS cec
      wceq vz cv vv cv wcel vw cv vv cv wcel wa wa wa vt wex vv wex cS cvv wcel
      vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vt
      cA cuni wrex vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA
      cuni wrex vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa
      vt cA cuni wrex vv wex cS cvv wcel vv cv vt cv cS cec wceq vz cv vv cv
      wcel vw cv vv cv wcel wa wa vv wex vz cv vt cv cS cec wcel vw cv vt cv cS
      cec wcel wa vt cA cuni cS cvv wcel vt cv cS cec cvv wcel vv cv vt cv cS
      cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vz cv vt cv cS
      cec wcel vw cv vt cv cS cec wcel wa wb vt cv cvv cS ecexg vz cv vv cv
      wcel vw cv vv cv wcel wa vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel
      wa vv vt cv cS cec vv cv vt cv cS cec wceq vz cv vv cv wcel vz cv vt cv
      cS cec wcel vw cv vv cv wcel vw cv vt cv cS cec wcel vv cv vt cv cS cec
      vz cv eleq2 vv cv vt cv cS cec vw cv eleq2 anbi12d ceqsex3v syl rexbidv
      vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa vt vv cA
      cuni rexcom4 syl5bbr vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv
      wcel wa wa vt cA cuni wrex vt cv cA cuni wcel vv cv vt cv cS cec wceq vz
      cv vv cv wcel vw cv vv cv wcel wa wa wa vt wex vv vv cv vt cv cS cec wceq
      vz cv vv cv wcel vw cv vv cv wcel wa wa vt cA cuni df-rex exbii syl5rbbr
      vt cv cA cuni wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv
      wcel wa wa wa vt wex vv cv cA cuni cS cqs wcel vz cv vv cv wcel vw cv vv
      cv wcel wa wa vv vv cv cA cuni cS cqs wcel vz cv vv cv wcel vw cv vv cv
      wcel wa wa vt cv cA cuni wcel vv cv vt cv cS cec wceq wa vt wex vz cv vv
      cv wcel vw cv vv cv wcel wa wa vt cv cA cuni wcel vv cv vt cv cS cec wceq
      wa vz cv vv cv wcel vw cv vv cv wcel wa wa vt wex vt cv cA cuni wcel vv
      cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa wa vt wex vv
      cv cA cuni cS cqs wcel vt cv cA cuni wcel vv cv vt cv cS cec wceq wa vt
      wex vz cv vv cv wcel vw cv vv cv wcel wa vv cv cA cuni cS cqs wcel vv cv
      vt cv cS cec wceq vt cA cuni wrex vt cv cA cuni wcel vv cv vt cv cS cec
      wceq wa vt wex vt cA cuni vv cv cS vv visset elqs vv cv vt cv cS cec wceq
      vt cA cuni df-rex bitri anbi1i vt cv cA cuni wcel vv cv vt cv cS cec wceq
      wa vz cv vv cv wcel vw cv vv cv wcel wa vt 19.41v vt cv cA cuni wcel vv
      cv vt cv cS cec wceq wa vz cv vv cv wcel vw cv vv cv wcel wa wa vt cv cA
      cuni wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa
      wa vt vt cv cA cuni wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv
      vv cv wcel wa anass exbii 3bitr2ri exbii syl6bb vz cv vv cv wcel vw cv vv
      cv wcel wa vv cA cuni cS cqs df-rex syl6bbr vz cv vv cv wcel vw cv vv cv
      wcel wa vv cA cuni cS cqs cA c0 csn cdif rexeq1 sylan9bb vw cv vv cv wcel
      vv cA vz cv prtlem100 syl6bbr sylan9bb sylan9bb cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr vz cv vv cv
      wcel vw cv vv cv wcel wa vv cA wrex vx vy vz vw vv vu cA cR prtlem13
      bicomd sylan9bb sylbir ex bicomdd sylbid vz cv vw cv cR vz visset breldm
      syl5 ibd cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif
      wceq wa wa wa wa vz cv vw cv cR wbr vz cv vw cv cS wbr cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel
      cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz cv
      cS cdm wcel vz cv vw cv cR wbr vz cv vw cv cS wbr wb vz cv vw cv cS wbr
      cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS
      wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa
      wa wa wa vz cv cS cdm wcel vz cv vw cv cS wbr vz cv vw cv cR wbr cR vx cv
      vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv
      wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz
      cv cS cdm wcel vz cv vw cv cS wbr vz cv vw cv cR wbr wb cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS wer cS cvv wcel
      cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif wceq wa wa wa wa vz cv
      cS cdm wcel wa cS wer vz cv cS cdm wcel wa cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm wceq wa cS cvv wcel
      cA cuni cS cqs cA c0 csn cdif wceq wa wa wa cR vx cv vu cv wcel vy cv vu
      cv wcel wa vu cA wrex vx vy copab wceq wa vz cv vw cv cS wbr vz cv vw cv
      cR wbr wb cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab
      wceq cS wer cS cvv wcel cR cdm cS cdm wceq cA cuni cS cqs cA c0 csn cdif
      wceq vz cv cS cdm wcel prtlem70 cS wer vz cv cS cdm wcel wa cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm
      wceq wa cS cvv wcel cA cuni cS cqs cA c0 csn cdif wceq wa wa wa vz cv vw
      cv cS wbr vz cv vv cv wcel vw cv vv cv wcel wa vv cA wrex cR vx cv vu cv
      wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR wbr
      cS wer vz cv cS cdm wcel wa vz cv vw cv cS wbr vz cv vt cv cS cec wcel vw
      cv vt cv cS cec wcel wa vt cS cdm wrex cR vx cv vu cv wcel vy cv vu cv
      wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm wceq wa cS cvv wcel cA
      cuni cS cqs cA c0 csn cdif wceq wa wa vz cv vv cv wcel vw cv vv cv wcel
      wa vv cA wrex cS wer vz cv cS cdm wcel vz cv vw cv cS wbr vz cv vt cv cS
      cec wcel vw cv vt cv cS cec wcel wa vt cS cdm wrex wb vz vw vt cS
      prtlem10 imp cR vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy
      copab wceq cR cdm cS cdm wceq wa vz cv vt cv cS cec wcel vw cv vt cv cS
      cec wcel wa vt cS cdm wrex vz cv vt cv cS cec wcel vw cv vt cv cS cec
      wcel wa vt cA cuni wrex cS cvv wcel cA cuni cS cqs cA c0 csn cdif wceq wa
      vz cv vv cv wcel vw cv vv cv wcel wa vv cA wrex cR vx cv vu cv wcel vy cv
      vu cv wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm wceq vz cv vt cv
      cS cec wcel vw cv vt cv cS cec wcel wa vt cS cdm wrex vz cv vt cv cS cec
      wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex wb cR cdm cS cdm wceq cR
      vx cv vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cS cdm
      cA cuni wceq vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cS cdm
      wrex vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex
      wb cR cdm cS cdm wceq cR cdm cA cuni wceq cS cdm cA cuni wceq cR vx cv vu
      cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq cR cdm cS cdm cA
      cuni eqeq1 vx vy vu cA cR prtlem16 syl5bi vz cv vt cv cS cec wcel vw cv
      vt cv cS cec wcel wa vt cS cdm cA cuni rexeq1 syl6com imp cS cvv wcel cA
      cuni cS cqs cA c0 csn cdif wceq wa vz cv vt cv cS cec wcel vw cv vt cv cS
      cec wcel wa vt cA cuni wrex vz cv vv cv wcel vw cv vv cv wcel wa vv cA c0
      csn cdif wrex vz cv vv cv wcel vw cv vv cv wcel wa vv cA wrex cS cvv wcel
      vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex vz cv
      vv cv wcel vw cv vv cv wcel wa vv cA cuni cS cqs wrex cA cuni cS cqs cA
      c0 csn cdif wceq vz cv vv cv wcel vw cv vv cv wcel wa vv cA c0 csn cdif
      wrex cS cvv wcel vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA
      cuni wrex vv cv cA cuni cS cqs wcel vz cv vv cv wcel vw cv vv cv wcel wa
      wa vv wex vz cv vv cv wcel vw cv vv cv wcel wa vv cA cuni cS cqs wrex cS
      cvv wcel vz cv vt cv cS cec wcel vw cv vt cv cS cec wcel wa vt cA cuni
      wrex vt cv cA cuni wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv
      cv wcel wa wa wa vt wex vv wex vv cv cA cuni cS cqs wcel vz cv vv cv wcel
      vw cv vv cv wcel wa wa vv wex cS cvv wcel vv cv vt cv cS cec wceq vz cv
      vv cv wcel vw cv vv cv wcel wa wa vt cA cuni wrex vv wex vz cv vt cv cS
      cec wcel vw cv vt cv cS cec wcel wa vt cA cuni wrex vt cv cA cuni wcel vv
      cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa wa vt wex vv
      wex cS cvv wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel
      wa wa vv wex vt cA cuni wrex vz cv vt cv cS cec wcel vw cv vt cv cS cec
      wcel wa vt cA cuni wrex vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv
      cv wcel wa wa vt cA cuni wrex vv wex cS cvv wcel vv cv vt cv cS cec wceq
      vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vz cv vt cv cS cec wcel vw
      cv vt cv cS cec wcel wa vt cA cuni cS cvv wcel vt cv cS cec cvv wcel vv
      cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa vv wex vz cv
      vt cv cS cec wcel vw cv vt cv cS cec wcel wa wb vt cv cvv cS ecexg vz cv
      vv cv wcel vw cv vv cv wcel wa vz cv vt cv cS cec wcel vw cv vt cv cS cec
      wcel wa vv vt cv cS cec vv cv vt cv cS cec wceq vz cv vv cv wcel vz cv vt
      cv cS cec wcel vw cv vv cv wcel vw cv vt cv cS cec wcel vv cv vt cv cS
      cec vz cv eleq2 vv cv vt cv cS cec vw cv eleq2 anbi12d ceqsex3v syl
      rexbidv vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa
      vt vv cA cuni rexcom4 syl5bbr vv cv vt cv cS cec wceq vz cv vv cv wcel vw
      cv vv cv wcel wa wa vt cA cuni wrex vt cv cA cuni wcel vv cv vt cv cS cec
      wceq vz cv vv cv wcel vw cv vv cv wcel wa wa wa vt wex vv vv cv vt cv cS
      cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa vt cA cuni df-rex exbii
      syl5rbbr vt cv cA cuni wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw
      cv vv cv wcel wa wa wa vt wex vv cv cA cuni cS cqs wcel vz cv vv cv wcel
      vw cv vv cv wcel wa wa vv vv cv cA cuni cS cqs wcel vz cv vv cv wcel vw
      cv vv cv wcel wa wa vt cv cA cuni wcel vv cv vt cv cS cec wceq wa vt wex
      vz cv vv cv wcel vw cv vv cv wcel wa wa vt cv cA cuni wcel vv cv vt cv cS
      cec wceq wa vz cv vv cv wcel vw cv vv cv wcel wa wa vt wex vt cv cA cuni
      wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv cv wcel wa wa wa
      vt wex vv cv cA cuni cS cqs wcel vt cv cA cuni wcel vv cv vt cv cS cec
      wceq wa vt wex vz cv vv cv wcel vw cv vv cv wcel wa vv cv cA cuni cS cqs
      wcel vv cv vt cv cS cec wceq vt cA cuni wrex vt cv cA cuni wcel vv cv vt
      cv cS cec wceq wa vt wex vt cA cuni vv cv cS vv visset elqs vv cv vt cv
      cS cec wceq vt cA cuni df-rex bitri anbi1i vt cv cA cuni wcel vv cv vt cv
      cS cec wceq wa vz cv vv cv wcel vw cv vv cv wcel wa vt 19.41v vt cv cA
      cuni wcel vv cv vt cv cS cec wceq wa vz cv vv cv wcel vw cv vv cv wcel wa
      wa vt cv cA cuni wcel vv cv vt cv cS cec wceq vz cv vv cv wcel vw cv vv
      cv wcel wa wa wa vt vt cv cA cuni wcel vv cv vt cv cS cec wceq vz cv vv
      cv wcel vw cv vv cv wcel wa anass exbii 3bitr2ri exbii syl6bb vz cv vv cv
      wcel vw cv vv cv wcel wa vv cA cuni cS cqs df-rex syl6bbr vz cv vv cv
      wcel vw cv vv cv wcel wa vv cA cuni cS cqs cA c0 csn cdif rexeq1 sylan9bb
      vw cv vv cv wcel vv cA vz cv prtlem100 syl6bbr sylan9bb sylan9bb cR vx cv
      vu cv wcel vy cv vu cv wcel wa vu cA wrex vx vy copab wceq vz cv vw cv cR
      wbr vz cv vv cv wcel vw cv vv cv wcel wa vv cA wrex vx vy vz vw vv vu cA
      cR prtlem13 bicomd sylan9bb sylbir ex bicomdd vz cv vw cv cS vz visset
      breldm syl5 ibdr impbid adantl eqbrrdv2 anasss vx vy vu cA cR prtlem12
      sylan sylbir $.
      $( [22-Oct-2010] $) $( [19-Oct-2010] $)
  $}

$( (End of Rodolfo Medina's mathbox.) $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Norm Megill
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Axioms for quantum logic system Q3
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( Axiom 1 of experimental implication/negation system for ->3.
     lattice '(a3(a3(b3a)))=1' $)
  $( Axiom 7b of experimental implication/negation system for ->3.
     This is other dir. of 7a.  Is it redundant?
     lattice '((a^b)3b)=1'
     lattice '(a3(avb))=1' $)
  $( Axiom for quantum logic system Q3.

     Note: This will be broken out as a separate database, but for now
     I am reusing the structure already in set.mm.  All proofs should
     refer only to axioms in this section, and nothing outside of this
     section should make use of it since it will go away eventually.

     The purpose of this project is to try to simplify the axioms of
     Kalmbach's quantum logic using implication and negation as
     primitives.  Kalmbach proved that this is the only quantum
     logic possible that has modus ponens as its sole inference rule.
     (Four other logics are possible with slightly different definitions of
     implication, but they all require inference rules other than
     modus ponens.)

     For the original system, see axioms QA1-QA16 and rule QR1 at
     ~ http://us.metamath.org/qlegif/kalmbach.txt . I conjecture that the
     axioms here can be proved from that system and vice-versa, and the
     purpose of this project is to verify that.  Eventually I'd like to find
     further simplifications to the axioms where possible, eliminate
     redundant axioms, and prove the independence of the remaining ones.

     (This axiom system doesn't make set.mm inconsistent, because
     each axiom here can be proved as a theorem of classical logic
     from ~ ax-1 through ~ ax-3 .  In addition, the definitions ~ def-qora ,
     ~ def-qorb , ~ def-qana , and ~ def-qanb are theorems of classical logic.
     Thus all theorems derived from the quantum logic system Q3 are also
     theorems of the classical propositional calculus.  But the converse is
     false; for example ~ ax-1 cannot be derived as a theorem inside system
     Q3.) $)
  ax-q1 $a |- ( ph -> ( ps -> ( ps -> ph ) ) ) $.

  $( Axiom 1 of experimental implication/negation system for ->3.
     lattice '(a3(a3(b3a)))=1' $)
  $( Axiom 7b of experimental implication/negation system for ->3.
     This is other dir. of 7a.  Is it redundant?
     lattice '((a^b)3b)=1'
     lattice '(a3(avb))=1' $)
  $( Axiom for quantum logic system Q3. $)
  ax-q2 $a |- ( -. ph -> ( ph -> ( ph -> ps ) ) ) $.

  $( Axiom 15 of experimental implication/negation system for ->3.
     lattice '((a3b)3(aOb))=1'
     lattice '((a3b)3(a3(a3b)))=1' $)
  $( Axiom for quantum logic system Q3. $)
  ax-q3 $a |- ( ( ph -> ps ) -> ( ph -> ( ph -> ps ) ) ) $.

  $( Axiom 9b of experimental implication/negation system for ->3.
     Redundant?
     lattice '(--a3a)=1' $)
  $( Axiom for quantum logic system Q3. $)
  ax-q4 $a |- ( -. -. ph -> ph ) $.

  $( Axiom 16g of experimental implication/negation system for ->3.
     lattice '(-a^-b)3(a3b)=1'
     lattice '-(avb)3(a3b)=1'
     lattice '-(-a3b)3(a3b)=1'
  $)
  $( Axiom for quantum logic system Q3. $)
  ax-q5 $a |- ( -. ( -. ph -> ps ) -> ( ph -> ps ) ) $.

  $( Axiom 16c of experimental implication/negation system for ->3.
    Note:  x ->3 y   = =
    ( ( -. x /\ y ) \/ ( -. x /\ -. y ) ) \/ ( x /\ ( -. x \/ y ) )
     (a3b)=((-avb)^((av(-a^-b))v(-a^b)))
         ((av(-a^-b))v(-a^b)) (a3(b3a)) 32
     lattice '((av(-a^-b))v(-a^b))=(a3(b3a))'
     lattice '((b2a)v(-a^b))=(a3(b3a))'
     lattice '(((-a3b)3a)v-(b3(b3a)))=(a3(b3a))'
     lattice '((b^-a)3(a3(b3a)))=1'
     lattice '(-(b3(b3a))3(a3(b3a)))=1' old
     lattice '(-(-bva)3(a3b))=1'  new
     lattice '(-(b3a)3(a3b))=1' fails MO2
   $)
  $( Axiom for quantum logic system Q3. $)
  ax-q6 $a |- ( -. ( ph -> ( ph -> ps ) ) -> ( ps -> ph ) ) $.

  $( Axiom 16b of experimental implication/negation system for ->3.
     lattice 'a^(-avb)<a3b'
     lattice 'a^(-avb)=-((--a3b)3-a)'
     lattice '(-((--a3b)3-a)3(a3b))=1'
     lattice '(-(a3-(a3(a3b)))3(a3b))=1'
     $)
  $( Axiom for quantum logic system Q3. $)
  ax-q7 $a |- ( -. ( ph -> -. ( ph -> ( ph -> ps ) ) ) -> ( ph -> ps ) ) $.

  $( Axiom 3 of experimental implication/negation system for ->3.
     lattice '((a3b)O(-b3-a))' $)
  $( Axiom for quantum logic system Q3. $)
  ax-q8 $a |- ( ( -. ph -> -. ps )
              -> ( ( -. ph -> -. ps ) -> ( ps -> ph ) ) ) $.

  $( Axiom 16e of experimental implication/negation system for ->3.
     lattice '(a3(b3a))<(((-a3b)3a)v-(b3(b3a)))'
     Use -x3y<xvy
     lattice '(a3(b3a))<(-((-a3b)3a)3-(b3(b3a)))'   ok
     lattice '(a3(b3a))<(--(b3(b3a))3((-a3b)3a))'   ok
     lattice '(a3b)3((b3(b3a))3((-a3b)3a))=1'
     $)
  $( Axiom for quantum logic system Q3. $)
  ax-q9 $a |- ( ( ph -> ps )
      -> ( ( ps -> ( ps -> ph ) ) -> ( ( -. ph -> ps ) -> ph ) ) ) $.

  $( Axiom 2d of experimental implication/negation system for ->3.
     ( ( ph ->2 ps ) <-> ( ( -. ps -> ph ) -> ps )
     lattice '((a2b)O(a3b))=1'  $)
  $( Axiom for quantum logic system Q3. $)
  ax-q10 $a |- ( ( ( -. ph -> ps ) -> ph )
          -> ( ( ( -. ph -> ps ) -> ph )
          -> ( ps -> ph ) ) ) $.

  $( Axiom 15c of experimental implication/negation system for ->3.
     lattice '((a3b)O((avb)3b))=1'
     lattice '((a3b)O(a3(a^b)))=1' fails MO2
     lattice '((a3b)O((-a3(-a3b))3b))=1'
     lattice '((a3b)3((a3b)3((-a3(-a3b))3b)))=1'
     This is needed for qi3le and also replaces ax-q8aOLD that was
     used for qorabsb . $)
  $( Axiom for quantum logic system Q3. $)
  ax-q11 $a |- ( ( -. ph -> ps ) -> ( ( -. ph -> ps )
               -> ( ( ph -> ( ph -> ps ) ) -> ps ) ) ) $.

  $( Axiom 2c of experimental implication/negation system for ->3.
     ( ( ph ->2 ps ) <-> ( ( -. ps -> ph ) -> ps )
     lattice '((a3b)O((b3c)O(a2c)))=1'
     lattice '((a3b)3((a3b)3((b3c)3((b3c)3(a2c)))))=1'
     See lattice.test 13-Aug-2009 $)
  $( Axiom for quantum logic system Q3. $)
  ax-q12 $a |- ( ( ph -> ps ) -> ( ( ph -> ps )
          -> ( ( ps -> ch ) -> ( ( ps -> ch )
          -> ( ( -. ch -> ph ) -> ch ) ) ) ) ) $.

  $( Axiom 4c
     lattice '((a3b)O((c3(c3a))2(c3(c3b))))=1'
     See lattice.test 13-Aug-2009 $)
  $( Axiom for quantum logic system Q3. $)
  ax-q13 $a |- ( ( ph -> ps ) -> ( ( ph -> ps )
        -> ( ( -. ( ch -> ( ch -> ps ) ) -> ( ch -> ( ch -> ph ) ) )
        -> ( ch -> ( ch -> ps ) ) ) ) ) $.

  ${
    qmp.1 $e |- ph $.
    qmp.2 $e |- ( ph -> ps ) $.
    $( Modus-ponens rule for quantum logic system Q3. $)
    ax-qmp $a |- ps $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Preliminary lemmas to justify definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    qsyl.1 $e |- ( ph -> ps ) $.
    qsyl.2 $e |- ( ps -> ch ) $.
    $( Transitive law for implication. $)
    qsyl $p |- ( ph -> ch ) $=
      wch wn wph wi wch wi wph wch wi wps wch wi wch wn wph wi wch wi qsyl.2
      wps wch wi wps wch wi wch wn wph wi wch wi wi qsyl.2 wph wps wi wps wch
      wi wps wch wi wch wn wph wi wch wi wi wi qsyl.1 wph wps wi wph wps wi wps
      wch wi wps wch wi wch wn wph wi wch wi wi wi wi qsyl.1 wph wps wch ax-q12
      ax-qmp ax-qmp ax-qmp ax-qmp wch wn wph wi wch wi wch wn wph wi wch wi wph
      wch wi wi wps wch wi wch wn wph wi wch wi qsyl.2 wps wch wi wps wch wi
      wch wn wph wi wch wi wi qsyl.2 wph wps wi wps wch wi wps wch wi wch wn
      wph wi wch wi wi wi qsyl.1 wph wps wi wph wps wi wps wch wi wps wch wi
      wch wn wph wi wch wi wi wi wi qsyl.1 wph wps wch ax-q12 ax-qmp ax-qmp
      ax-qmp ax-qmp wch wph ax-q10 ax-qmp ax-qmp $.
      $( [2-Aug-2009] $) $( [28-Jul-2009] $)
  $}

  $( Double negation. $)
  qnotnot2 $p |- ( -. -. ph -> ph ) $=
    wph ax-q4 $.
    $( [27-Aug-2009] $) $( [7-Aug-2009] $)

  $( Double negation. $)
  qnotnot1 $p |- ( ph -> -. -. ph ) $=
    wph wn wn wn wph wn wi wph wph wn wn wi wph wn ax-q4 wph wn wn wn wph wn wi
    wph wn wn wn wph wn wi wph wph wn wn wi wi wph wn ax-q4 wph wn wn wph ax-q8
    ax-qmp ax-qmp $.
    $( [27-Aug-2009] $) $( [7-Aug-2009] $)

  $( Identity law for implication. $)
  qid $p |- ( ph -> ph ) $=
    wph wph wn wn wph wph qnotnot1 wph qnotnot2 qsyl $.
    $( [2-Aug-2009] $) $( [28-Jul-2009] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define disjunction.  The justification is provided by ~ qid . $)
  def-qora $a |- ( ( ph \/ ps ) -> ( -. ph -> ( -. ph -> ps ) ) ) $.

  $( Define disjunction. $)
  def-qorb $a |- ( ( -. ph -> ( -. ph -> ps ) ) -> ( ph \/ ps ) ) $.

  $( Define conjunction. $)
  def-qana $a |- ( ( ph /\ ps ) -> -. ( -. ph \/ -. ps ) ) $.

  $( Define conjunction. $)
  def-qanb $a |- ( -. ( -. ph \/ -. ps ) -> ( ph /\ ps ) ) $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Basic theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    q2th.1 $e |- ph $.
    q2th.2 $e |- ps $.
    $( Add theorem antecedent to a theorem. $)
    q2th $p |- ( ps -> ph ) $=
      wps wps wph wi q2th.2 wph wps wps wph wi wi q2th.1 wph wps ax-q1 ax-qmp
      ax-qmp $.
      $( [27-Aug-2009] $) $( [8-Aug-2009] $)
  $}

  ${
    qa1i.1 $e |- ph $.
    $( Add an antecedent to a theorem. $)
    qa1i $p |- ( ps -> ph ) $=
      wps wps wps wi wph wps wps wi wps wps wps wi wi wps qid wps wps ax-q3
      ax-qmp wph wps wps wi qa1i.1 wps qid q2th qsyl $.
      $( [27-Aug-2009] $) $( [8-Aug-2009] $)
  $}

  ${
    qmpc.1 $e |- ph $.
    qmpc.2 $e |- ( -. ph \/ ps ) $.
    $( Classical modus ponens. $)
    qmpc $p |- ps $=
      wph wn wn wps wph wph wn wn qmpc.1 wph qnotnot1 ax-qmp wph wn wn wph wn
      wn wps wi wph wph wn wn qmpc.1 wph qnotnot1 ax-qmp wph wn wps wo wph wn
      wn wph wn wn wps wi wi qmpc.2 wph wn wps def-qora ax-qmp ax-qmp ax-qmp $.
      $( [1-Aug-2009] $) $( [28-Jul-2009] $)
  $}

  $( An older axiom of quantum logic system Q3, proved from the others,
     so it is redundant. $)
  qax8a $p |- ( ( ph -> ph ) -> ( ps -> ( ph -> ph ) ) ) $=
    wps wph wph wi wi wph wph wi wph wph wi wps wph qid qa1i qa1i $.
    $( [1-Aug-2009] $) $( [30-Jul-2009] $)

  $( An older axiom of quantum logic system Q3, proved from the others,
     so it is redundant. $)
  qax8b $p |- ( ( ps -> ( ps -> ( ph -> ph ) ) ) -> ( ph -> ph ) ) $=
    wph wph wi wps wps wph wph wi wi wi wph qid qa1i $.
    $( [1-Aug-2009] $) $( [30-Jul-2009] $)

  ${
    qcon4i.1 $e |- ( -. ph -> -. ps ) $.
    $( Contraposition inference. $)
    qcon4i $p |- ( ps -> ph ) $=
      wph wn wps wn wi wps wph wi qcon4i.1 wph wn wps wn wi wph wn wps wn wi
      wps wph wi wi qcon4i.1 wph wps ax-q8 ax-qmp ax-qmp $.
      $( [6-Aug-2009] $) $( [4-Aug-2009] $)
  $}

  ${
    qcon3i.1 $e |- ( ph -> ps ) $.
    $( Contraposition inference. $)
    qcon3i $p |- ( -. ps -> -. ph ) $=
      wph wn wps wn wph wn wn wph wps wn wn wph qnotnot2 wph wps wps wn wn
      qcon3i.1 wps qnotnot1 qsyl qsyl qcon4i $.
      $( [6-Aug-2009] $) $( [4-Aug-2009] $)
  $}

  ${
    qcon1i.1 $e |- ( -. ph -> ps ) $.
    $( Contraposition inference. $)
    qcon1i $p |- ( -. ps -> ph ) $=
      wps wn wph wn wn wph wph wn wps qcon1i.1 qcon3i wph qnotnot2 qsyl $.
      $( [27-Aug-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    qcon2i.1 $e |- ( ph -> -. ps ) $.
    $( Contraposition inference. $)
    qcon2i $p |- ( ps -> -. ph ) $=
      wph wn wps wph wn wn wph wps wn wph qnotnot2 qcon2i.1 qsyl qcon4i $.
      $( [27-Aug-2009] $) $( [5-Aug-2009] $)
  $}

  $( Add disjunct to consequent. $)
  qorl $p |- ( ph -> ( ps \/ ph ) ) $=
    wph wps wn wps wn wph wi wi wps wph wo wph wps wn ax-q1 wps wph def-qorb
    qsyl $.
    $( [27-Aug-2009] $) $( [5-Aug-2009] $)

  ${
    q2imim2i.1 $e |- ( ph -> ps ) $.
    $( Introduce an imbedded consequent into both sides of an implication. $)
    q2imim2i $p |- ( ( ch -> ( ch -> ph ) ) -> ( ch -> ( ch -> ps ) ) ) $=
      wch wch wps wi wi wn wch wch wph wi wi wi wch wch wps wi wi wi wch wch
      wph wi wi wch wch wps wi wi wi wph wps wi wch wch wps wi wi wn wch wch
      wph wi wi wi wch wch wps wi wi wi q2imim2i.1 wph wps wi wph wps wi wch
      wch wps wi wi wn wch wch wph wi wi wi wch wch wps wi wi wi wi q2imim2i.1
      wph wps wch ax-q13 ax-qmp ax-qmp wch wch wps wi wi wn wch wch wph wi wi
      wi wch wch wps wi wi wi wch wch wps wi wi wn wch wch wph wi wi wi wch wch
      wps wi wi wi wch wch wph wi wi wch wch wps wi wi wi wi wph wps wi wch wch
      wps wi wi wn wch wch wph wi wi wi wch wch wps wi wi wi q2imim2i.1 wph wps
      wi wph wps wi wch wch wps wi wi wn wch wch wph wi wi wi wch wch wps wi wi
      wi wi q2imim2i.1 wph wps wch ax-q13 ax-qmp ax-qmp wch wch wps wi wi wch
      wch wph wi wi ax-q10 ax-qmp ax-qmp $.
      $( [9-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    qor2lim.1 $e |- ( -. ph -> ch ) $.
    qor2lim.2 $e |- ( ps -> ch ) $.
    $( Disjoin antecedents (implication version of ~ qor2l ). $)
    qor2lim $p |- ( ( ph -> ( ph -> ps ) ) -> ch ) $=
      wph wph wps wi wi wph wph wch wi wi wch wps wch wph qor2lim.2 q2imim2i
      wph wn wch wi wph wph wch wi wi wch wi qor2lim.1 wph wn wch wi wph wn wch
      wi wph wph wch wi wi wch wi wi qor2lim.1 wph wch ax-q11 ax-qmp ax-qmp
      qsyl $.
      $( [9-Sep-2009] $) $( [3-Sep-2009] $)
  $}

  ${
    qor2l.1 $e |- ( ph -> ch ) $.
    qor2l.2 $e |- ( ps -> ch ) $.
    $( Disjoin antecedents. $)
    qor2l $p |- ( ( ph \/ ps ) -> ch ) $=
      wph wps wo wph wn wph wn wch wi wi wch wph wps wo wph wn wph wn wps wi wi
      wph wn wph wn wch wi wi wph wps def-qora wps wch wph wn qor2l.2 q2imim2i
      qsyl wph wn wn wch wi wph wn wph wn wch wi wi wch wi wph wn wn wph wch
      wph ax-q4 qor2l.1 qsyl wph wn wn wch wi wph wn wn wch wi wph wn wph wn
      wch wi wi wch wi wi wph wn wn wph wch wph ax-q4 qor2l.1 qsyl wph wn wch
      ax-q11 ax-qmp ax-qmp qsyl $.
      $( [9-Sep-2009] $) $( [3-Sep-2009] $)
  $}

  ${
    qan2r.1 $e |- ( ph -> ps ) $.
    qan24.2 $e |- ( ph -> ch ) $.
    $( Conjoin consequents. $)
    qan2r $p |- ( ph -> ( ps /\ ch ) ) $=
      wph wps wn wch wn wo wn wps wch wa wps wn wch wn wo wph wps wn wch wn wph
      wn wph wps qan2r.1 qcon3i wph wch qan24.2 qcon3i qor2l qcon2i wps wch
      def-qanb qsyl $.
      $( [9-Sep-2009] $) $( [16-Aug-2009] $)
  $}

  $( Disjunction is commutative. $)
  qorcoma $p |- ( ( ph \/ ps ) -> ( ps \/ ph ) ) $=
    wph wps wps wph wo wph wps qorl wps wps wn wps wn wph wi wi wps wph wo wps
    wps wn wn wps wn wps wn wph wi wi wps qnotnot1 wps wn wph ax-q2 qsyl wps
    wph def-qorb qsyl qor2l $.
    $( [9-Sep-2009] $) $( [12-Aug-2009] $)

  $( Conjunction is commutative.

     Note:  see description of quantum logic system Q3 under ~ ax-q1  . $)
  qancoma $p |- ( ( ph /\ ps ) -> ( ps /\ ph ) ) $=
    wph wps wa wph wn wps wn wo wn wps wph wa wph wps def-qana wph wn wps wn wo
    wn wps wn wph wn wo wn wps wph wa wps wn wph wn wo wph wn wps wn wo wps wn
    wph wn qorcoma qcon3i wps wph def-qanb qsyl qsyl $.
    $( [1-Aug-2009] $) $( [29-Jul-2009] $)

  $( Add disjunct to consequent. $)
  qorr $p |- ( ph -> ( ph \/ ps ) ) $=
    wph wps wph wo wph wps wo wph wps qorl wps wph qorcoma qsyl $.
    $( [1-Aug-2009] $) $( [5-Aug-2009] $)

  $( Remove conjunct from antecent. $)
  qanr $p |- ( ( ph /\ ps ) -> ph ) $=
    wph wps wa wph wn wps wn wo wn wph wph wps def-qana wph wph wn wps wn wo wn
    wph wn wph wn wps wn wo wph wn wps wn wo wn wn wph wn wps wn qorr wph wn
    wps wn wo qnotnot1 qsyl qcon4i qsyl $.
    $( [1-Sep-2009] $) $( [5-Aug-2009] $)

  $( Remove conjunct from antecent. $)
  qanl $p |- ( ( ph /\ ps ) -> ps ) $=
    wph wps wa wps wph wa wps wph wps qancoma wps wph qanr qsyl $.
    $( [1-Sep-2009] $) $( [5-Aug-2009] $)

  $( Associative law. $)
  qorassa $p |-  ( ( ( ph \/ ps ) \/ ch ) -> ( ph \/ ( ps \/ ch ) ) ) $=
    wph wps wo wch wph wps wch wo wo wph wps wo wph wn wph wn wps wch wo wi wi
    wph wps wch wo wo wph wps wo wph wn wph wn wps wi wi wph wn wph wn wps wch
    wo wi wi wph wps def-qora wps wps wch wo wph wn wps wch wps wo wps wch wo
    wps wch qorl wch wps qorcoma qsyl q2imim2i qsyl wph wps wch wo def-qorb qsyl
    wch wph wch wo wph wps wch wo wo wch wph qorl wph wch wo wph wn wph wn wps
    wch wo wi wi wph wps wch wo wo wph wch wo wph wn wph wn wch wi wi wph wn
    wph wn wps wch wo wi wi wph wch def-qora wch wps wch wo wph wn wch wps qorl
    q2imim2i qsyl wph wps wch wo def-qorb qsyl qsyl qor2l $.
    $( [1-Sep-2009] $) $( [12-Aug-2009] $)

  ${
    qorim2i.1 $e |- ( ph -> ps ) $.
    $( Introduce a left disjunct to both sides of an implication. $)
    qorim2i $p |- ( ( ch \/ ph ) -> ( ch \/ ps ) ) $=
      wch wph wo wch wn wch wn wph wi wi wch wps wo wch wph def-qora wch wn wch
      wn wph wi wi wch wn wch wn wps wi wi wch wps wo wph wps wch wn qorim2i.1
      q2imim2i wch wps def-qorb qsyl qsyl $.
      $( [3-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    qorim1i.1 $e |- ( ph -> ps ) $.
    $( Introduce a right disjunct to both sides of an implication. $)
    qorim1i $p |- ( ( ph \/ ch ) -> ( ps \/ ch ) ) $=
      wph wch wo wch wps wo wps wch wo wph wch wo wch wph wo wch wps wo wph wch
      qorcoma wph wps wch qorim1i.1 qorim2i qsyl wch wps qorcoma qsyl $.
      $( [3-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  $( Disjunction in terms of implication. $)
  qor2a $p |- ( ( -. ph \/ ps ) -> ( ph -> ( ph -> ps ) ) ) $=
    wph wn wps wph wph wps wi wi wph wps ax-q2 wps wph ax-q1 qor2l $.
    $( [9-Sep-2009] $) $( [3-Sep-2009] $)

  $( Disjunction in terms of implication. $)
  qor2b $p |- ( ( ph -> ( ph -> ps ) ) -> ( -. ph \/ ps ) ) $=
    wph wps wph wn wps wo wph wn wps qorr wps wph wn qorl qor2lim $.
    $( [9-Sep-2009] $) $( [3-Sep-2009] $)

  $( Expand definition of AND. $)
  qdfan2a $p |- ( ( ph /\ ps ) -> -. ( ph -> ( ph -> -. ps ) ) ) $=
    wph wph wps wn wi wi wph wps wa wph wph wps wn wi wi wph wn wps wn wo wph
    wps wa wn wph wps wn qor2b wph wps wa wph wn wps wn wo wph wps def-qana
    qcon2i qsyl qcon2i $.
    $( [9-Sep-2009] $) $( [5-Aug-2009] $)

  $( Expand definition of AND. $)
  qdfan2b $p |- ( -. ( ph -> ( ph -> -. ps ) ) -> ( ph /\ ps ) ) $=
    wph wps wa wph wph wps wn wi wi wph wps wa wn wph wn wps wn wo wph wph wps
    wn wi wi wph wn wps wn wo wph wps wa wph wps def-qanb qcon1i wph wps wn
    qor2a qsyl qcon1i $.
    $( [9-Sep-2009] $) $( [5-Aug-2009] $)

  ${
    qanim1i.1 $e |- ( ph -> ps ) $.
    $( Introduce a right conjunct to both sides of an implication. $)
    qanim1i $p |- ( ( ph /\ ch ) -> ( ps /\ ch ) ) $=
      wph wch wa wps wn wch wn wo wn wps wch wa wph wch wa wph wn wch wn wo wn
      wps wn wch wn wo wn wph wch def-qana wps wn wch wn wo wph wn wch wn wo wps
      wn wph wn wch wn wph wps qanim1i.1 qcon3i qorim1i qcon3i qsyl wps wch
      def-qanb qsyl $.
      $( [9-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    qanim2i.1 $e |- ( ph -> ps ) $.
    $( Introduce a left conjunct to both sides of an implication. $)
    qanim2i $p |- ( ( ch /\ ph ) -> ( ch /\ ps ) ) $=
      wch wph wa wch wn wph wn wo wn wch wps wa wch wph def-qana wch wn wph wn
      wo wn wch wn wps wn wo wn wch wps wa wch wn wps wn wo wch wn wph wn wo
      wps wn wph wn wch wn wph wps qanim2i.1 qcon3i qorim2i qcon3i wch wps
      def-qanb qsyl qsyl $.
      $( [9-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  $( Conjunction implies "quantum conjunction". $)
  qanqan $p |- ( ( ph /\ ps ) -> -. ( ph -> -. ps ) ) $=
    wph wps wa wph wph wps wn wi wi wn wph wps wn wi wn wph wps qdfan2a wph wps
    wn wi wph wph wps wn wi wi wph wps wn ax-q3 qcon3i qsyl $.
    $( [9-Sep-2009] $) $( [5-Aug-2009] $)

  ${
    qanim12i.1 $e |- ( ph -> ps ) $.
    qanim12i.2 $e |- ( ch -> th ) $.
    $( Join both sides with conjunct. $)
    qanim12i $p |- ( ( ph /\ ch ) -> ( ps /\ th ) ) $=
      wph wch wa wps wch wa wps wth wa wph wps wch qanim12i.1 qanim1i wch wth
      wps qanim12i.2 qanim2i qsyl $.
      $( [10-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  ${
    qorim12i.1 $e |- ( ph -> ps ) $.
    qorim12i.2 $e |- ( ch -> th ) $.
    $( Join both sides with disjunction. $)
    qorim12i $p |- ( ( ph \/ ch ) -> ( ps \/ th ) ) $=
      wph wch wo wph wth wo wps wth wo wch wth wph qorim12i.2 qorim2i wph wps
      wth qorim12i.1 qorim1i qsyl $.
      $( [10-Sep-2009] $) $( [5-Aug-2009] $)
  $}

  $( Disjunction in terms of conjunction. $)
  qorana $p |- ( ( ph \/ ps ) -> -. ( -. ph /\ -. ps ) ) $=
    wph wps wo wph wn wn wps wn wn wo wph wn wps wn wa wn wph wph wn wn wps wps
    wn wn wph qnotnot1 wps qnotnot1 qorim12i wph wn wps wn wa wph wn wn wps wn
    wn wo wph wn wps wn def-qana qcon2i qsyl $.
    $( [10-Sep-2009] $) $( [5-Aug-2009] $)

  $( Disjunction in terms of conjunction. $)
  qoranb $p |- ( -. ( -. ph /\ -. ps ) -> ( ph \/ ps ) ) $=
    wph wn wps wn wa wn wph wn wn wps wn wn wo wph wps wo wph wn wn wps wn wn
    wo wph wn wps wn wa wph wn wps wn def-qanb qcon1i wph wn wn wph wps wn wn
    wps wph qnotnot2 wps qnotnot2 qorim12i qsyl $.
    $( [10-Sep-2009] $) $( [5-Aug-2009] $)

  $( Negated disjunction in terms of conjunction (DeMorgan's law). $)
  qiorana $p |- ( -. ( ph \/ ps ) -> ( -. ph /\ -. ps ) ) $=
    wph wps wo wn wph wn wps wn wa wn wn wph wn wps wn wa wph wn wps wn wa wn
    wph wps wo wph wps qoranb qcon3i wph wn wps wn wa qnotnot2 qsyl $.
    $( [11-Sep-2009] $) $( [5-Aug-2009] $)

  $( Negated disjunction in terms of conjunction (DeMorgan's law). $)
  qioranb $p |- ( ( -. ph /\ -. ps ) -> -. ( ph \/ ps ) ) $=
    wph wn wps wn wa wph wn wps wn wa wn wn wph wps wo wn wph wn wps wn wa
    qnotnot1 wph wps wo wph wn wps wn wa wn wph wps qorana qcon3i qsyl $.
    $( [11-Sep-2009] $) $( [5-Aug-2009] $)

  $( Negated conjunction in terms of disjunction (DeMorgan's law). $)
  qianora $p |- ( -. ( ph /\ ps ) -> ( -. ph \/ -. ps ) ) $=
    wph wn wps wn wo wph wps wa wph wps def-qanb qcon1i $.
    $( [11-Sep-2009] $) $( [5-Aug-2009] $)

  $( Negated conjunction in terms of disjunction (DeMorgan's law).

     Note:  see description of quantum logic system Q3 under ~ ax-q1 . $)
  qianorb $p |- ( ( -. ph \/ -. ps ) -> -. ( ph /\ ps ) ) $=
    wph wps wa wph wn wps wn wo wph wps def-qana qcon2i $.
    $( [11-Sep-2009] $) $( [5-Aug-2009] $)

  $( Conjunction in terms of disjunction. $)
  qanor1a $p |- ( ( ph /\ -. ps ) -> -. ( -. ph \/ ps ) ) $=
    wph wps wn wa wph wn wps wn wn wo wn wph wn wps wo wn wph wps wn def-qana
    wph wn wps wo wph wn wps wn wn wo wps wps wn wn wph wn wps qnotnot1 qorim2i
    qcon3i qsyl $.
    $( [12-Sep-2009] $) $( [5-Aug-2009] $)

  $( Conjunction in terms of disjunction. $)
  qanor1b $p |- ( -. ( -. ph \/ ps ) -> ( ph /\ -. ps ) ) $=
    wph wn wps wo wn wph wn wps wn wn wo wn wph wps wn wa wph wn wps wn wn wo
    wph wn wps wo wps wn wn wps wph wn wps qnotnot2 qorim2i qcon3i wph wps wn
    def-qanb qsyl $.
    $( [12-Sep-2009] $) $( [5-Aug-2009] $)

  $( Relation between conjunction and disjunction. $)
  qanor2a $p |- ( ( -. ph /\ ps ) -> -. ( ph \/ -. ps ) ) $=
    wph wn wps wa wph wn wn wps wn wo wn wph wps wn wo wn wph wn wps def-qana
    wph wps wn wo wph wn wn wps wn wo wph wph wn wn wps wn wph qnotnot1 qorim1i
    qcon3i qsyl $.
    $( [12-Sep-2009] $) $( [5-Aug-2009] $)

  $( Relation between conjunction and disjunction. $)
  qanor2b $p |- ( -. ( ph \/ -. ps ) -> ( -. ph /\ ps ) ) $=
    wph wps wn wo wn wph wn wn wps wn wo wn wph wn wps wa wph wn wn wps wn wo
    wph wps wn wo wph wn wn wph wps wn wph qnotnot2 qorim1i qcon3i wph wn wps
    def-qanb qsyl $.
    $( [12-Sep-2009] $) $( [5-Aug-2009] $)

  $( Absorption law.

     Note:  see description of quantum logic system Q3 under ~ ax-q1 . $)
  qanabsa $p |- ( ( ph \/ ( ph /\ ps ) ) -> ph ) $=
    wph wph wps wa wo wph wps wa wph wo wph wph wph wps wa qorcoma wph wps wa
    wph wo wph wps wa wn wph wps wa wn wph wi wi wph wph wps wa wph def-qora wph
    wps wa wn wn wph wi wph wps wa wn wph wps wa wn wph wi wi wph wi wph wps wa
    wn wn wph wps wa wph wph wps wa ax-q4 wph wps qanr qsyl wph wps wa wn wn
    wph wi wph wps wa wn wn wph wi wph wps wa wn wph wps wa wn wph wi wi wph wi
    wi wph wps wa wn wn wph wps wa wph wph wps wa ax-q4 wph wps qanr qsyl wph
    wps wa wn wph ax-q11 ax-qmp ax-qmp qsyl qsyl $.
    $( [13-Sep-2009] $) $( [3-Sep-2009] $)

  $( Law of excluded middle. $)
  qexclmid $p |- ( ph \/ -. ph ) $=
    wph wn wph wn wph wn wi wi wph wph wn wo wph wn wph wn wi wph wn wph wn wph
    wn wi wi wph wn qid wph wn wph wn ax-q3 ax-qmp wph wph wn def-qorb ax-qmp $.
    $( [14-Sep-2009] $) $( [1-Aug-2009] $)

  $( One direction of Kalmbach's axiom 8. $)
  qa8a $p |- ( ( -. ph /\ ph ) -> ( ( -. ph /\ ph ) /\ ps ) ) $=
    wph wn wph wa wph wn wph wa wn wps wn wo wn wph wn wph wa wps wa wph wn wph
    wa wph wn wn wph wn wo wn wph wn wph wa wn wps wn wo wn wph wn wph def-qana
    wph wn wph wa wn wps wn wo wph wn wn wph wn wo wph wn wph wa wn wps wn wo
    wps wn wph wn wph wa wn wo wph wn wn wph wn wo wph wn wph wa wn wps wn
    qorcoma wps wn wph wn wph wa wn wo wph wph wn wo wph wn wn wph wn wo wph
    wph wn wo wps wn wph wn wph wa wn wo wph qexclmid qa1i wph wph wn wn wph wn
    wph qnotnot1 qorim1i qsyl qsyl qcon3i qsyl wph wn wph wa wps def-qanb qsyl
    $.
    $( [14-Sep-2009] $) $( [5-Aug-2009] $)

  $( The other direction of Kalmbach's axiom 8.

     Note:  see description of quantum logic system Q3 under ~ ax-q1 . $)
  qa8b $p |- ( ( ( -. ph /\ ph ) /\ ps ) -> ( -. ph /\ ph ) ) $=
    wph wn wph wa wps wa wph wn wn wph wn wo wn wph wn wph wa wph wn wph wa wps
    wa wph wn wph wa wn wps wn wo wn wph wn wn wph wn wo wn wph wn wph wa wps
    def-qana wph wn wn wph wn wo wph wn wph wa wn wps wn wo wph wn wn wph wn wo
    wps wn wph wn wph wa wn wo wph wn wph wa wn wps wn wo wph wn wn wph wn wo
    wps wn wph wn wn wph wn wo wo wps wn wph wn wph wa wn wo wph wn wn wph wn
    wo wps wn wn wps wn wn wph wn wn wph wn wo wi wi wps wn wph wn wn wph wn wo
    wo wps wn wn wps wn wn wph wn wn wph wn wo wi wi wph wn wn wph wn wo wps wn
    wn wph wn wn wph wn wo wi wps wn wn wph wn wn wph wn wo wps wn wn wph wn
    wph wn wn wo wph wn wn wph wn wo wph wn qexclmid wph wn wph wn wn qorcoma
    ax-qmp qa1i qa1i qa1i wps wn wph wn wn wph wn wo def-qorb qsyl wph wn wn wph
    wn wo wph wn wph wa wn wps wn wph wn wph qianorb qorim2i qsyl wps wn wph wn
    wph wa wn qorcoma qsyl qcon3i qsyl wph wn wph def-qanb qsyl $.
    $( [14-Sep-2009] $) $( [5-Aug-2009] $)

  $( Absorption law. $)
  qorabsa $p |- ( ( ph /\ ( ph \/ ps ) ) -> ph ) $=
    wph wph wph wps wo wa wph wn wph wn wph wps wo wn wo wph wph wps wo wa wn
    wph wn wph wps wo wn wph wn wo wph wn wph wps wo wn wo wph wn wph wps wo wn
    wn wph wps wo wn wn wph wn wi wi wph wps wo wn wph wn wo wph wn wph wps wo
    wn wn ax-q1 wph wps wo wn wph wn def-qorb qsyl wph wps wo wn wph wn qorcoma
    qsyl wph wph wps wo qianorb qsyl qcon4i $.
    $( [16-Sep-2009] $) $( [5-Aug-2009] $)

  $( Absorption law. $)
  qorabsb $p |- ( ph -> ( ph /\ ( ph \/ ps ) ) ) $=
    wph wph wn wph wn wps wn wa wo wn wph wph wps wo wa wph wn wph wn wps wn wa
    wo wph wph wn wps wn qanabsa qcon2i wph wn wph wn wps wn wa wo wn wph wph
    wn wps wn wa wn wa wph wph wps wo wa wph wph wn wps wn wa qanor1b wph wn
    wps wn wa wn wph wps wo wph wph wps qoranb qanim2i qsyl qsyl $.
    $( [16-Sep-2009] $) $( [8-Aug-2009] $)

  $( Theorem justifying a definition of false (by showing that the expression
     for it is independent of the wff variable). $)
  q0equiv0a $p |- ( ( -. ph /\ ph ) -> ( -. ps /\ ps ) ) $=
    wps wn wps wa wph wn wph wa wph wn wph wa wn wps wn wps wa wn wph wn wn wph
    wn wo wph wn wph wa wn wph wn wph wn wn wo wph wn wn wph wn wo wph wn
    qexclmid wph wn wph wn wn qorcoma ax-qmp wph wn wph qianorb ax-qmp qa1i
    qcon4i $.
    $( [16-Sep-2009] $) $( [5-Aug-2009] $)

  $( True is equivalent to true. $)
  q1equiv1a $p |- ( ( ph \/ -. ph ) -> ( ps \/ -. ps ) ) $=
    wph wph wn wo wph wph wn wo wps wps wn wo wi wph qexclmid wps wps wn wo wph
    wph wn wo wph wph wn wo wps wps wn wo wi wi wps qexclmid wps wps wn wo wph
    wph wn wo ax-q1 ax-qmp ax-qmp $.
    $( [17-Sep-2009] $) $( [5-Aug-2009] $)

  $( Idempotent law. $)
  qanidma $p |- ( ( ph /\ ph ) -> ph ) $=
    wph wph wa wph wph wph wn wn wph wn wa wo wa wph wph wph wph wn wn wph wn
    wa wo wph wph wph wn wn wph wn wa wo wph wph wph wn wn wph wn wa wo wn wph
    wn wph wn wn wph wn wa wn wa wph wn wph wph wn wn wph wn wa qiorana wph wn
    wph wn wn wph wn wa wn wa wph wn wph wn wph wo wa wph wn wph wn wn wph wn
    wa wn wph wn wph wo wph wn wph wn wph qoranb qanim2i wph wn wph qorabsa
    qsyl qsyl qcon4i qanim2i wph wph wn wn wph wn wa qorabsa qsyl $.
    $( [18-Sep-2009] $) $( [5-Aug-2009] $)

  $( Idempotent law. $)
  qanidmb $p |- ( ph -> ( ph /\ ph ) ) $=
    wph wph wph wph wn wn wph wn wa wo wa wph wph wa wph wph wn wn wph wn wa
    qorabsb wph wph wn wn wph wn wa wo wph wph wph wph wph wn wn wph wn wa wo
    wph wn wph wn wph wn wn wph wn wa wn wa wph wph wn wn wph wn wa wo wn wph
    wn wph wn wph wn wph wo wa wph wn wph wn wn wph wn wa wn wa wph wn wph
    qorabsb wph wn wph wo wph wn wn wph wn wa wn wph wn wph wn wph qorana
    qanim2i qsyl wph wph wn wn wph wn wa qioranb qsyl qcon4i qanim2i qsyl $.
    $( [18-Sep-2009] $) $( [5-Aug-2009] $)

  $( Idempotent law. $)
  qoridma $p |- ( ( ph \/ ph ) -> ph ) $=
    wph wph wo wph wn wph wn wa wn wph wph wph qorana wph wph wn wph wn wa wph
    wn qanidmb qcon1i qsyl $.
    $( [18-Sep-2009] $) $( [5-Aug-2009] $)

  $( Idempotent law. $)
  qoridmb $p |- ( ph -> ( ph \/ ph ) ) $=
    wph wph wn wph wn wa wn wph wph wo wph wn wph wn wa wph wph wn qanidma
    qcon2i wph wph qoranb qsyl $.
    $( [18-Sep-2009] $) $( [5-Aug-2009] $)

  $( Absorption law. $)
  qanabsb $p |- ( ph -> ( ph \/ ( ph /\ ps ) ) ) $=
    wph wph wn wph wn wps wn wo wa wn wph wph wps wa wo wph wn wph wn wps wn wo
    wa wph wph wn wps wn qorabsa qcon2i wph wn wph wn wps wn wo wa wn wph wn
    wph wps wa wn wa wn wph wph wps wa wo wph wn wph wps wa wn wa wph wn wph wn
    wps wn wo wa wph wps wa wn wph wn wps wn wo wph wn wph wps qianora qanim2i
    qcon3i wph wph wps wa qoranb qsyl qsyl $.
    $( [23-Sep-2009] $) $( [5-Aug-2009] $)

  $( Associative law. $)
  qorassb $p |-  ( ( ph \/ ( ps \/ ch ) ) -> ( ( ph \/ ps ) \/ ch ) ) $=
    wph wps wch wo wo wps wch wo wph wo wph wps wo wch wo wph wps wch wo
    qorcoma wps wch wo wph wo wps wch wph wo wo wph wps wo wch wo wps wch wph
    qorassa wps wch wph wo wo wch wph wps wo wo wph wps wo wch wo wps wch wph
    wo wo wch wph wo wps wo wch wph wps wo wo wps wch wph wo qorcoma wch wph
    wps qorassa qsyl wch wph wps wo qorcoma qsyl qsyl qsyl $.
    $( [23-Sep-2009] $) $( [5-Aug-2009] $)

  $( Associative law. $)
  qanassa $p |-  ( ( ( ph /\ ps ) /\ ch ) -> ( ph /\ ( ps /\ ch ) ) ) $=
    wph wps wa wch wa wph wps wa wn wch wn wo wn wph wps wch wa wa wph wps wa
    wch def-qana wph wps wa wn wch wn wo wn wph wn wps wch wa wn wo wn wph wps
    wch wa wa wph wn wps wch wa wn wo wph wps wa wn wch wn wo wph wn wps wch wa
    wn wo wph wn wps wn wch wn wo wo wph wps wa wn wch wn wo wps wch wa wn wps
    wn wch wn wo wph wn wps wch qianora qorim2i wph wn wps wn wch wn wo wo wph
    wn wps wn wo wch wn wo wph wps wa wn wch wn wo wph wn wps wn wch wn qorassb
    wph wn wps wn wo wph wps wa wn wch wn wph wps qianorb qorim1i qsyl qsyl
    qcon3i wph wps wch wa def-qanb qsyl qsyl $.
    $( [23-Sep-2009] $) $( [5-Aug-2009] $)

  $( Associative law. $)
  qanassb $p |-  ( ( ph /\ ( ps /\ ch ) ) -> ( ( ph /\ ps ) /\ ch ) ) $=
    wph wps wch wa wa wps wch wa wph wa wph wps wa wch wa wph wps wch wa
    qancoma wps wch wa wph wa wps wch wph wa wa wph wps wa wch wa wps wch wph
    qanassa wps wch wph wa wa wch wph wps wa wa wph wps wa wch wa wps wch wph
    wa wa wch wph wa wps wa wch wph wps wa wa wps wch wph wa qancoma wch wph
    wps qanassa qsyl wch wph wps wa qancoma qsyl qsyl qsyl $.
    $( [23-Sep-2009] $) $( [5-Aug-2009] $)

  $( Swap disjuncts. $)
  qor12a $p |- ( ( ph \/ ( ps \/ ch ) ) -> ( ps \/ ( ph \/ ch ) ) ) $=
    wph wps wch wo wo wps wph wo wch wo wps wph wch wo wo wph wps wch wo wo wph
    wps wo wch wo wps wph wo wch wo wph wps wch qorassb wph wps wo wps wph wo
    wch wph wps qorcoma qorim1i qsyl wps wph wch qorassa qsyl $.
    $( [8-Oct-2009] $) $( [5-Aug-2009] $)

  $( Swap conjuncts. $)
  qan12a $p |- ( ( ph /\ ( ps /\ ch ) ) -> ( ps /\ ( ph /\ ch ) ) ) $=
    wph wps wch wa wa wps wph wa wch wa wps wph wch wa wa wph wps wch wa wa wph
    wps wa wch wa wps wph wa wch wa wph wps wch qanassb wph wps wa wps wph wa
    wch wph wps qancoma qanim1i qsyl wps wph wch qanassa qsyl $.
    $( [8-Oct-2009] $) $( [5-Aug-2009] $)

  $( Swap disjuncts. $)
  qor23a $p |- ( ( ( ph \/ ps ) \/ ch ) -> ( ( ph \/ ch ) \/ ps ) ) $=
    wph wps wo wch wo wph wps wch wo wo wph wch wo wps wo wph wps wch qorassa
    wph wps wch wo wo wph wch wps wo wo wph wch wo wps wo wps wch wo wch wps wo
    wph wps wch qorcoma qorim2i wph wch wps qorassb qsyl qsyl $.
    $( [11-Oct-2009] $) $( [5-Aug-2009] $)

  $( Swap conjuncts. $)
  qan23a $p |- ( ( ( ph /\ ps ) /\ ch ) -> ( ( ph /\ ch ) /\ ps ) ) $=
    wph wps wa wch wa wph wps wch wa wa wph wch wa wps wa wph wps wch qanassa
    wph wps wch wa wa wph wch wps wa wa wph wch wa wps wa wps wch wa wch wps wa
    wph wps wch qancoma qanim2i wph wch wps qanassb qsyl qsyl $.
    $( [11-Oct-2009] $) $( [5-Aug-2009] $)

  $( Swap disjuncts. $)
  qor4a $p |- ( ( ( ph \/ ps ) \/ ( ch \/ th ) )
           -> ( ( ph \/ ch ) \/ ( ps \/ th ) ) ) $=
    wph wps wo wch wth wo wo wph wps wch wth wo wo wo wph wch wo wps wth wo wo
    wph wps wch wth wo qorassa wph wps wch wth wo wo wo wph wch wps wth wo wo
    wo wph wch wo wps wth wo wo wps wch wth wo wo wch wps wth wo wo wph wps wch
    wth qor12a qorim2i wph wch wps wth wo qorassb qsyl qsyl $.
    $( [13-Oct-2009] $) $( [5-Aug-2009] $)

  $( Swap conjuncts. $)
  qan4a $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) )
            -> ( ( ph /\ ch ) /\ ( ps /\ th ) ) ) $=
    wph wps wa wch wth wa wa wph wps wch wth wa wa wa wph wch wa wps wth wa wa
    wph wps wch wth wa qanassa wph wps wch wth wa wa wa wph wch wps wth wa wa
    wa wph wch wa wps wth wa wa wps wch wth wa wa wch wps wth wa wa wph wps wch
    wth qan12a qanim2i wph wch wps wth wa qanassb qsyl qsyl $.
    $( [13-Oct-2009] $) $( [5-Aug-2009] $)

  $( Discard a conjunct in the antecedent.

     Note:  see description of quantum logic system Q3 under ~ ax-q1 . $)
  qleorana $p |- ( ( ph /\ ps ) -> ph ) $=
    wph wps qanr $.
    $( [13-Oct-2009] $) $( [5-Aug-2009] $)

$( (End of Norm Megill's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Steve Rodriguez
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
 Graph theory add-on for set.mm
 (see http://planetx.cc.vt.edu/AsteroidMeta/steverod)

 Steve Rodriguez

 I hereby place this in the public domain, and release all rights to it.

 This continues from the set.mm proofs preceding the Dedekind-cut real
 construction.  It is best placed or included before the "End of set.mm"
 comment there.

 I very likely won't work on this much anymore.
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Hypergraphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c HypGrph $. $( class of hypergraphs $)

  $( Extend class notation with the class of all hypergraphs. $)
  chgra $a class HypGrph $.

  $(
  [Diestel] Diestel, Reinhard, "Graph Theory, Electronic Edition,"
  Springer-Verlag, Heidelberg, 2005 [QA166.D51413]
  URL: http://www.math.uni-hamburg.de/home/diestel/books/graph.theory/
  $)

  $(
  [McKMegPav] B. McKay, N. Megill, and M. Pavicic,
  "Algorithms for Greechie Diagrams," Int. J. Theor. Phys. 39,
  2393-2417 (2000), http://xxx.lanl.gov/abs/quant-ph/0009039 .
  $)

  ${
    $d a b $.
    $( Define the class of all hypergraphs.  For a textbook
       definition of a hypergraph and more information,
       see ~ ishgrag . $)
    df-hgra $a |- HypGrph = { <. a , b >. | ( ( a i^i b ) = (/)
           /\ b C_ ( ~P a \ { (/) } ) ) } $.
  $}

  ${
    $d b A $.  $d b B $.
    $( Two ways of saying "the blocks in a hypergraph
       are each non-empty subsets of the set of atoms
       in the hypergraph." $)
    blkssatm $p |- ( B C_ ( ~P A \ { (/) } ) <->
                    A. b e. B ( b C_ A /\ b =/= (/) ) ) $=
      cB cA cpw c0 csn cdif wss vb cv cA cpw c0 csn cdif wcel vb cB wral vb cv
      cA wss vb cv c0 wne wa vb cB wral vb cB cA cpw c0 csn cdif dfss3 vb cv cA
      cpw c0 csn cdif wcel vb cv cA wss vb cv c0 wne wa vb cB vb cv cA cpw c0
      csn cdif wcel vb cv cA cpw wcel vb cv c0 wne wa vb cv cA wss vb cv c0 wne
      wa vb cv cA cpw c0 eldifsn vb cv cA cpw wcel vb cv cA wss vb cv c0 wne vb
      cv cA vb visset elpw anbi1i bitri ralbii bitri $.
      $( [20-Feb-2007] $) $( [16-Dec-2006] $)
  $}

  ${
    $d x y $.
    $( The class of all hypergraphs is a relation. $)
    hgrarel $p |- Rel HypGrph $=
      chgra wrel vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss wa vx
      vy copab wrel vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss wa
      vx vy relopab chgra vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif
      wss wa vx vy copab vx vy df-hgra releqi mpbir $.
      $( [20-Feb-2007] $) $( [15-Dec-2006] $)
  $}

  ${
    $d x y A $.  $d x B $.  $d y B $.  $d b A $.  $d b B $.
    $( x and y are dummy. $)
    ishgrag.1 $e |- H = <. A , B >. $.
    $( Express the predicate "` H ` is a hypergraph."
       Definition of hypergraph in [Diestel] p. 28, which states
       "A hypergraph is a pair (_V_, _E_) of disjoint sets, where
       the elements of _E_ are non-empty subsets (of any cardinality)
       of _V_."

       Because _V_ and _E_ are both used as symbols
       (for the universal class ~ df-v and the epsilon relation
       ~ df-eprel , respectively) in Metamath, we instead use ` A `
       to represent _V_, the set of _vertices_ or _atoms_ of
       the hypergraph, and ` B ` to represent _E_, the set of _edges_
       or _blocks_ that each connect one or more atoms
       in ` A ` .  (See Definition 2.1 in [McKMegPav] p. 2384 for an
       analogous use of _atom_ and _block_ in Greechie diagrams.) $)
    ishgrag $p |- ( ( A e. C /\ B e. D ) ->
                   ( H e. HypGrph <->
                     ( ( A i^i B ) = (/) /\
                       A. b e. B ( b C_ A /\ b =/= (/) ) ) ) ) $=
      cA cC wcel cB cD wcel wa cH chgra wcel cA cB cin c0 wceq cB cA cpw c0 csn
      cdif wss wa cA cB cin c0 wceq vb cv cA wss vb cv c0 wne wa vb cB wral wa
      cA cC wcel cB cD wcel wa cA cB cop chgra wcel cA cB cin c0 wceq cB cA cpw
      c0 csn cdif wss wa cH chgra wcel cA cC wcel cB cD wcel wa cA cB cop vx cv
      vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss wa vx vy copab wcel cA
      cB cin c0 wceq cB cA cpw c0 csn cdif wss wa cA cB cop chgra wcel vx cv vy
      cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss wa cA vy cv cin c0 wceq vy
      cv cA cpw c0 csn cdif wss wa cA cB cin c0 wceq cB cA cpw c0 csn cdif wss
      wa vx vy cA cB cC cD vx cv cA wceq vx cv vy cv cin c0 wceq cA vy cv cin
      c0 wceq vy cv vx cv cpw c0 csn cdif wss vy cv cA cpw c0 csn cdif wss vx
      cv cA wceq vx cv vy cv cin cA vy cv cin c0 vx cv cA vy cv ineq1 eqeq1d vx
      cv cA wceq vx cv cpw c0 csn cdif cA cpw c0 csn cdif vy cv vx cv cA wceq
      vx cv cpw cA cpw c0 csn vx cv cA pweq difeq1d sseq2d anbi12d vy cv cB
      wceq cA vy cv cin c0 wceq cA cB cin c0 wceq vy cv cA cpw c0 csn cdif wss
      cB cA cpw c0 csn cdif wss vy cv cB wceq cA vy cv cin cA cB cin c0 vy cv
      cB cA ineq2 eqeq1d vy cv cB cA cpw c0 csn cdif sseq1 anbi12d opelopabg
      chgra vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss wa vx vy
      copab cA cB cop vx vy df-hgra eleq2i syl5bb cH cA cB cop chgra ishgrag.1
      eleq1i syl5bb cB cA cpw c0 csn cdif wss vb cv cA wss vb cv c0 wne wa vb
      cB wral cA cB cin c0 wceq cA cB vb blkssatm anbi2i syl6bb $.
      $( [20-Feb-2007] $) $( [16-Dec-2006] $)
  $}

  ${
    $d x y A $.  $d x B $.  $d y B $.  $d x H $.  $d y H $.
    $( x and y are dummy. $)
    hgralem.1 $e |- A = ( 1st ` H ) $.
    hgralem.2 $e |- B = ( 2nd ` H ) $.
    $( Lemma for various hypergraph theorems. $)
    hgralem $p |- ( H e. HypGrph ->
                    ( ( A i^i B ) = (/) /\
                      B C_ ( ~P A \ { (/) } ) ) ) $=
      cH chgra wcel cH vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss
      wa vx vy copab wcel cA cB cin c0 wceq cB cA cpw c0 csn cdif wss wa chgra
      vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss wa vx vy copab cH
      vx vy df-hgra eleq2i vx cv vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif
      wss wa cA vy cv cin c0 wceq vy cv cA cpw c0 csn cdif wss wa cA cB cin c0
      wceq cB cA cpw c0 csn cdif wss wa vx vy cH vx cv cH c1st cfv wceq vx cv
      vy cv cin c0 wceq cA vy cv cin c0 wceq vy cv vx cv cpw c0 csn cdif wss vy
      cv cA cpw c0 csn cdif wss vx cv cH c1st cfv wceq vx cv vy cv cin cA vy cv
      cin c0 vx cv cH c1st cfv wceq vx cv cA wceq vx cv vy cv cin cA vy cv cin
      wceq cA cH c1st cfv vx cv hgralem.1 eqeq2i vx cv cA vy cv ineq1 sylbir
      eqeq1d vx cv cH c1st cfv wceq vx cv cA wceq vy cv vx cv cpw c0 csn cdif
      wss vy cv cA cpw c0 csn cdif wss wb cA cH c1st cfv vx cv hgralem.1 eqeq2i
      vx cv cA wceq vx cv cpw c0 csn cdif cA cpw c0 csn cdif vy cv vx cv cA
      wceq vx cv cpw cA cpw c0 csn vx cv cA pweq difeq1d sseq2d sylbir anbi12d
      vy cv cH c2nd cfv wceq cA vy cv cin c0 wceq cA cB cin c0 wceq vy cv cA
      cpw c0 csn cdif wss cB cA cpw c0 csn cdif wss vy cv cH c2nd cfv wceq cA
      vy cv cin cA cB cin c0 vy cv cH c2nd cfv wceq vy cv cB wceq cA vy cv cin
      cA cB cin wceq cB cH c2nd cfv vy cv hgralem.2 eqeq2i vy cv cB cA ineq2
      sylbir eqeq1d vy cv cH c2nd cfv wceq vy cv cB wceq vy cv cA cpw c0 csn
      cdif wss cB cA cpw c0 csn cdif wss wb cB cH c2nd cfv vy cv hgralem.2
      eqeq2i vy cv cB cA cpw c0 csn cdif sseq1 sylbir anbi12d elopabi sylbi $.
      $( [20-Feb-2007] $) $( [15-Dec-2006] $)
  $}

  ${
    hgradj.1 $e |- A = ( 1st ` H ) $.
    hgradj.2 $e |- B = ( 2nd ` H ) $.
    $( The sets of atoms and blocks in a hypergraph are disjoint. $)
    hgradj $p |- ( H e. HypGrph -> ( A i^i B ) = (/) ) $=
      cH chgra wcel cA cB cin c0 wceq cB cA cpw c0 csn cdif wss cA cB cH
      hgradj.1 hgradj.2 hgralem pm3.26d $.
      $( [20-Feb-2007] $) $( [17-Dec-2006] $)
  $}

  ${
    hgrablkconn.1 $e |- A = ( 1st ` H ) $.
    hgrablkconn.2 $e |- B = ( 2nd ` H ) $.
    $( The blocks in a hypergraph each connect to one or more atoms. $)
    hgrablkconn $p |- ( H e. HypGrph -> B C_ ( ~P A \ { (/) } ) ) $=
      cH chgra wcel cA cB cin c0 wceq cB cA cpw c0 csn cdif wss cA cB cH
      hgrablkconn.1 hgrablkconn.2 hgralem pm3.27d $.
      $( [20-Feb-2007] $) $( [17-Dec-2006] $)
  $}

  ${
    $d H b $.  $d B b $.
    hgrablkne0.1 $e |- B = ( 2nd ` H ) $.
    $( The empty set cannot be a block in a hypergraph. $)
    hgrablkne0 $p |- ( H e. HypGrph -> A. b e. B b =/= (/) ) $=
      cH chgra wcel vb cv c0 wne vb cB cH chgra wcel vb cv cH c1st cfv wss vb
      cv c0 wne wa vb cB wral vb cv cB wcel vb cv cH c1st cfv wss vb cv c0 wne
      wa wi vb cv cB wcel vb cv c0 wne wi cH chgra wcel cB cH c1st cfv cpw c0
      csn cdif wss vb cv cH c1st cfv wss vb cv c0 wne wa vb cB wral cH c1st cfv
      cB cH cH c1st cfv eqid hgrablkne0.1 hgrablkconn cH c1st cfv cB vb
      blkssatm sylib vb cv cH c1st cfv wss vb cv c0 wne wa vb cB ra4 vb cv cH
      c1st cfv wss vb cv c0 wne wa vb cv c0 wne vb cv cB wcel vb cv cH c1st cfv
      wss vb cv c0 wne pm3.27 imim2i 3syl r19.21aiv $.
      $( [20-Feb-2007] $) $( [17-Dec-2006] $)

    $( The number of atoms incident to each block of a hypergraph
       is greater than zero. $)
    hgrablkcard $p |- ( H e. HypGrph ->
                        A. b e. B (/) e. ( card ` b ) ) $=
      cH chgra wcel c0 vb cv ccrd cfv wcel vb cB cH chgra wcel vb cv cB wcel vb
      cv c0 wne wi vb cv cB wcel c0 vb cv ccrd cfv wcel wi cH chgra wcel vb cv
      c0 wne vb cB wral vb cv cB wcel vb cv c0 wne wi cB cH vb hgrablkne0.1
      hgrablkne0 vb cv c0 wne vb cB ra4 syl vb cv cB wcel c0 vb cv ccrd cfv
      wcel vb cv c0 wne vb cv cB wcel c0 vb cv ccrd cfv wcel c0 vb cv csdm wbr
      vb cv c0 wne vb cv cB wcel c0 ccrd cfv vb cv ccrd cfv wcel c0 vb cv csdm
      wbr c0 vb cv ccrd cfv wcel c0 cvv wcel vb cv cB wcel c0 ccrd cfv vb cv
      ccrd cfv wcel c0 vb cv csdm wbr wb 0ex c0 vb cv cvv cB cardsdom mpan c0
      ccrd cfv c0 vb cv ccrd cfv card0 eleq1i syl5bbr vb cv cB 0sdomg bitrd
      pm5.74i sylibr r19.21aiv $.
      $( [20-Feb-2007] $) $( [17-Dec-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of hypergraphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A b $. $( b is dummy. $)
    $( An ordered pair with an empty second element is a hypergraph
       (with no blocks/edges). $)
    emhgrat $p |- ( A e. B -> <. A , (/) >. e. HypGrph ) $=
      cA cB wcel cA c0 cop chgra wcel cA c0 cin c0 wceq vb cv cA wss vb cv c0
      wne wa vb c0 wral wa cA c0 cin c0 wceq vb cv cA wss vb cv c0 wne wa vb c0
      wral cA in0 vb cv cA wss vb cv c0 wne wa vb ral0 pm3.2i cA cB wcel c0 cvv
      wcel cA c0 cop chgra wcel cA c0 cin c0 wceq vb cv cA wss vb cv c0 wne wa
      vb c0 wral wa wb 0ex cA c0 cB cvv cA c0 cop vb cA c0 cop eqid ishgrag
      mpan2 mpbiri $.
      $( [20-Feb-2007] $) $( [16-Dec-2006] $)
  $}

  $( The null hypergraph ` <. (/) , (/) >.` . $)
  0hgra $p |- <. (/) , (/) >. e. HypGrph $=
    c0 cvv wcel c0 c0 cop chgra wcel 0ex c0 cvv emhgrat ax-mp $.
    $( [20-Feb-2007] $) $( [16-Dec-2006] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Pseudographs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c PsGrph $. $( class of pseudographs
                 (graphs with one- or two-vertex edges) $)

  $( Extend class notation with the class of all pseudographs. $)
  cpgra $a class PsGrph $.

  ${
    $d a b $.
    $( Define the class of all pseudographs (hypergraphs with _edges_
       that connect only one or two _vertices_ each).
       Based on definition in [Diestel] p. 28, which uses the
       name "multigraph".  (MathWorld's Eric Weisstein recommends against
       using the term _multigraph_ because of differing meanings in
       the literature; see ~ http://mathworld.wolfram.com/Multigraph.html .) $)
    df-pgra $a |- PsGrph = { <. a , b >. | ( ( a i^i b ) = (/)
           /\ b C_ ( a u. ( a ^m 2o ) ) ) } $.
  $}

  ${
    $d a b P $.  $d L a $.  $d L b $.
    $( a and b are dummy, but correspond to P and L in the final result. $)
    ispgrag.1 $e |- G = <. P , L >. $.
    $( Express the predicate "` G ` is a pseudograph."

       Because _V_ and _E_ are both used as symbols
       (for the universal class ~ df-v and the epsilon relation
       ~ df-eprel , respectively) in Metamath, we instead use ` P `
       to represent _V_, the set of _vertices_ or _points_ of
       the hypergraph, and ` L ` to represent _E_, the set of
       _edges_ or _lines_ that each connect one or two vertices
       in ` P ` . $)
    ispgrag $p |- ( ( P e. A /\ L e. B ) ->
                    ( G e. PsGrph <->
                      ( ( P i^i L ) = (/) /\
                        L C_ ( P u. ( P ^m 2o ) ) ) ) ) $=
      cP cA wcel cL cB wcel wa cP cL cop va cv vb cv cin c0 wceq vb cv va cv va
      cv c2o cm co cun wss wa va vb copab wcel cP cL cin c0 wceq cL cP cP c2o
      cm co cun wss wa cG cpgra wcel va cv vb cv cin c0 wceq vb cv va cv va cv
      c2o cm co cun wss wa cP vb cv cin c0 wceq vb cv cP cP c2o cm co cun wss
      wa cP cL cin c0 wceq cL cP cP c2o cm co cun wss wa va vb cP cL cA cB va
      cv cP wceq va cv vb cv cin c0 wceq cP vb cv cin c0 wceq vb cv va cv va cv
      c2o cm co cun wss vb cv cP cP c2o cm co cun wss va cv cP wceq va cv vb cv
      cin cP vb cv cin c0 va cv cP vb cv ineq1 eqeq1d va cv cP wceq va cv va cv
      c2o cm co cun cP cP c2o cm co cun vb cv va cv cP wceq va cv cP va cv c2o
      cm co cP c2o cm co va cv cP wceq id va cv cP c2o cm opreq1 uneq12d sseq2d
      anbi12d vb cv cL wceq cP vb cv cin c0 wceq cP cL cin c0 wceq vb cv cP cP
      c2o cm co cun wss cL cP cP c2o cm co cun wss vb cv cL wceq cP vb cv cin
      cP cL cin c0 vb cv cL cP ineq2 eqeq1d vb cv cL cP cP c2o cm co cun sseq1
      anbi12d opelopabg cG cP cL cop cpgra va cv vb cv cin c0 wceq vb cv va cv
      va cv c2o cm co cun wss wa va vb copab ispgrag.1 va vb df-pgra eleq12i
      syl5bb $.
      $( [20-Feb-2007] $) $( [17-Dec-2006] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of pseudographs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$( empty $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Simple graphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SmpGrph $. $( class of simple graphs
                 (pseudographs with two-vertex edges) $)

  $( Extend class notation with the class of all simple graphs. $)
  csgra $a class SmpGrph $.

  ${
    $d a b $.
    $( Define the class of all simple graphs (pseudographs whose edges
       connect exactly two vertices each).
       Definition in [Diestel] p. 2, which simply calls them
       "graphs". $)
    df-sgra $a |- SmpGrph = { <. a , b >. | ( ( a i^i b ) = (/)
           /\ b C_ ( a ^m 2o ) ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of pseudographs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$( empty $)


$( (End of Steve Rodriguez's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                  Mathbox for Alan Sare
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Meta-implication and meta-conjunction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ->.. $. $( rightwards thick arrow for meta-implication
      [10-Nov-2010] $)

  $c . $. $( right and left meta-parenthesis
      [10-Nov-2010] $)

  ${
    $( Syntax for meta-implication. $)
    wimeta $a wff [ ph ->.. ps ] $.
      $( [10-Nov-2010] $)
  $}

  ${
    $( Definition of meta-implication. $)
    df-wimeta $a |- ( [ ph ->.. ps ] <-> ( ph -> ps ) ) $.
      $( [10-Nov-2010] $)
  $}

  ${
    dfwimetai.1 $e |- [ ph ->.. ps ] $.
    $( Inference form of ~df-wimeta . $)
    dfwimetai $p |- ( ph -> ps ) $=
      wph wps wimeta wph wps wi dfwimetai.1 wph wps df-wimeta mpbi $.
      $( [12-Nov-2010] $)
  $}

  ${
    dfwimetair.1 $e |- ( ph -> ps ) $.
    $( Inference form of ~df-wimeta with the meta-implication
      as the assertion. $)
    dfwimetair $p |- [ ph ->.. ps ] $=
      wph wps wimeta wph wps wi dfwimetair.1 wph wps df-wimeta mpbir $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Syntax for meta-conjunction. $)
    wameta $a wff . ph , ps . $.
      $( [10-Nov-2010] $)
  $}

  ${
    $( Definition of meta-conjunction. $)
    df-wameta $a |- ( . ph , ps . <-> ( ph /\ ps ) ) $.
      $( [10-Nov-2010] $)
  $}

  ${
    $( Definition of the nested meta-conjunction of three wffs. $)
    dfwa3nmt $p |- ( . . ph , ps . , ch . <-> ( ( ph /\ ps ) /\ ch ) ) $=
      wph wps wameta wch wameta wph wps wameta wch wa wph wps wa wch wa wph wps
      wameta wch df-wameta wph wps wameta wph wps wa wch wph wps df-wameta
      anbi1i bitri $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Definition of the left-nested meta-conjunction of three wffs. $)
    dfwa3nlmt $p |- ( . ph , . ps , ch . . <-> ( ph /\ ( ps /\ ch ) ) ) $=
      wph wps wch wameta wameta wph wps wch wameta wa wph wps wch wa wa wph wps
      wch wameta df-wameta wps wch wameta wps wch wa wph wps wch df-wameta
      anbi2i bitri $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Definition of the nested meta-conjunction of four wffs. $)
    dfwa4nmt $p |- ( . . . ph , ps . , ch . , th .
            <-> ( ( ( ph /\ ps ) /\ ch ) /\ th ) ) $=
      wph wps wameta wch wameta wth wameta wph wps wameta wch wameta wth wa wph
      wps wa wch wa wth wa wph wps wameta wch wameta wth df-wameta wph wps
      wameta wch wameta wph wps wa wch wa wth wph wps wch dfwa3nmt anbi1i bitri
      $.
      $( [26-Nov-2010] $)
  $}

  ${
    $( Definition of the nested meta-conjunction of five wffs. $)
    dfwa5nmt $p |- ( . . . . ph , ps . , ch . , th . , ta . <->
      ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta ) ) $=
      wph wps wameta wch wameta wth wameta wta wameta wph wps wameta wch wameta
      wth wameta wta wa wph wps wa wch wa wth wa wta wa wph wps wameta wch
      wameta wth wameta wta df-wameta wph wps wameta wch wameta wth wameta wph
      wps wa wch wa wth wa wta wph wps wch wth dfwa4nmt anbi1i bitri $.
      $( [26-Nov-2010] $)
  $}

  ${
    dfwiwametai.1 $e |- [ . ph , ps . ->.. ch ] $.
    $( Definition of the meta-form of an implication having an
    antecedent of two wffs conjoined. $)
    dfwiwametai $p |- ( ( ph /\  ps ) -> ch ) $=
      wph wps wa wph wps wameta wch wph wps df-wameta wph wps wameta wch
      dfwiwametai.1 dfwimetai sylbir $.
      $( [26-Nov-2010] $)
  $}

  ${
    sylbimt.1 $e |- ( ph <-> ps ) $.
    sylbimt.2 $e |- ( ps -> ch ) $.
    $( ~sylbi with a meta-implication assertion. $)
    sylbimt $p |- [ ph ->.. ch ] $=
      wph wch wph wps wch sylbimt.1 sylbimt.2 sylbi dfwimetair $.
      $( [12-Nov-2010] $)
  $}

  ${
    sylibrmt.1 $e |- ( ph -> ps ) $.
    sylibrmt.2 $e |- ( ch <-> ps ) $.
    $( ~sylibr with a meta-implication assertion. $)
    sylibrmt $p |- [ ph ->.. ch ] $=
      wph wch wph wps wch sylibrmt.1 sylibrmt.2 sylibr dfwimetair $.
      $( [12-Nov-2010] $)
  $}

  ${
    syl2anbmt.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    syl2anbmt.2 $e |- ( th <-> ph ) $.
    syl2anbmt.3 $e |- ( ta <-> ps ) $.
    $( ~syl2anb with an assertion using meta-connectives.  $)
    syl2anbmt $p |- [ . th , ta . ->.. ch ] $=
      wth wta wameta wth wta wa wch wth wta df-wameta wph wps wch wth wta
      syl2anbmt.1 syl2anbmt.2 syl2anbmt.3 syl2anb sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    adantlmt.1 $e |- ( ph -> ps ) $.
    $( ~adantl with a meta-implication assertion. $)
    adantlmt $p |- [ . ch , ph . ->.. ps ] $=
      wch wph wameta wch wph wa wps wch wph df-wameta wph wps wch adantlmt.1
      adantl sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    adantrmt.1 $e |- ( ph -> ps ) $.
    $( ~adantr with a meta-implication assertion. $)
    adantrmt $p |- [ . ph , ch . ->.. ps ] $=
      wph wch wameta wph wch wa wps wph wch df-wameta wph wps wch adantrmt.1
      adantr sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    adantlbirmt.1 $e |- ( ph <-> ps ) $.
    $( Meta-connective form of a theorem similar to ~adantl having a
      bi-conditional hypothesis.  $)
    adantlbirmt $p |- [ . ch , ps . ->.. ph ] $=
      wps wph wch wph wps adantlbirmt.1 biimpri adantlmt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~pm3.26 . $)
    pm3.26mt $p |- [ . ph , ps . ->.. ph ] $=
      wph wps wameta wph wps wa wph wph wps df-wameta wph wps pm3.26 sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~pm3.27 . $)
    pm3.27mt $p |- [ . ph , ps . ->.. ps ] $=
      wph wps wameta wph wps wa wps wph wps df-wameta wph wps pm3.27 sylbimt $.
      $( [26-Nov-2010] $)
  $}

  ${
    pm3.27dmt.1 $e |- [ ph ->.. . ps , ch . ] $.
    $( ~pm3.27d with a hypothesis using meta-connectives. $)
      pm3.27dmt $p |- ( ph -> ch ) $=
        wph wps wch wph wps wch wameta wps wch wa wph wps wch wameta
        pm3.27dmt.1 dfwimetai wps wch df-wameta sylib pm3.27d $.
        $( [12-Nov-2010] $)
  $}

  ${
    pm3.27dexmt.1 $e |- [ . ph , ps . ->.. . ch , th . ] $.
    $( A theorem combining ~pm3.27d and ~ex with a hypothesis
      using meta-implication. $)
    pm3.27dexmt $p |- [ ph ->.. ( ps -> th ) ] $=
      wph wps wth wi wph wps wth wph wps wa wch wth wph wps wameta wch wth
      wameta wph wps wa wch wth wa wph wps wameta wch wth wameta pm3.27dexmt.1
      dfwimetai wph wps df-wameta wch wth df-wameta 3imtr3i pm3.27d ex
      dfwimetair $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Definition of the meta-form of an implication with a consequent
      which is the conjunction of two wffs. $)
    dfwiwamt $p |- ( [ ph ->.. . ps , ch . ] <-> ( ph -> ( ps /\ ch ) ) ) $=
      wph wps wch wameta wimeta wph wps wch wameta wi wph wps wch wa wi wph wps
      wch wameta df-wimeta wps wch wameta wps wch wa wph wps wch df-wameta
      imbi2i bitri $.
      $( [21-Nov-2010] $)
  $}

  ${
     $( Definition of the meta-form of an implication with a consequent
       which is the conjunction of two wffs.  The right wff of that
       conjunction is an implication.  The consquent of that implication
       is the conjunction of two wffs. $)
     dfwiwawiwamt $p |- ( [ ph ->.. . ps , [ ch ->.. . th , ta . ] . ]
            <-> ( ph -> ( ps /\ ( ch -> ( th /\ ta ) ) ) ) ) $=
       wph wps wch wth wta wameta wimeta wameta wimeta wph wps wch wth wta
       wameta wimeta wameta wi wph wps wch wth wta wa wi wa wi wph wps wch wth
       wta wameta wimeta wameta df-wimeta wps wch wth wta wameta wimeta wameta
       wps wch wth wta wa wi wa wph wps wch wth wta wameta wimeta wameta wps
       wch wth wta wameta wimeta wa wps wch wth wta wa wi wa wps wch wth wta
       wameta wimeta df-wameta wch wth wta wameta wimeta wch wth wta wa wi wps
       wch wth wta dfwiwamt anbi2i bitri imbi2i bitri $.
       $( [21-Nov-2010] $)
  $}

  ${
     pm3.27dnmt.1 $e |- [ ph ->.. . ps , [ ch ->.. . th , ta . ] . ] $.
     $( Inference having a hypothesis which is a meta-implication having
       a consequent which is a conjunction whose right conjunct is a
       meta-implication whose consequent is a conjunction.  The assertion
       of the inference is the meta-implication of the hypothesis with
       the right conjunct of its consequent altered
       in accordance with  ~pm3.27dmt . $)
     pm3.27dnmt $p |- [ ph ->.. . ps , ( ch -> ta ) . ]  $=
       wph wps wch wta wi wameta wimeta wph wps wch wta wi wa wi wph wps wch
       wth wta wa wi wa wi wph wps wch wta wi wa wi wph wps wch wth wta wameta
       wimeta wameta wimeta wph wps wch wth wta wa wi wa wi pm3.27dnmt.1 wph
       wps wch wth wta dfwiwawiwamt mpbi wps wch wth wta wa wi wa wps wch wta
       wi wa wph wch wth wta wa wi wch wta wi wps wth wta wa wta wch wta wta wi
       wth wta wa wta wi wta id wth wta wta pm3.42 ax-mp imim2i anim2i imim2i
       ax-mp wph wps wch wta wi dfwiwamt mpbir $.
       $( [21-Nov-2010] $)
  $}

  ${
     axmpanmt.1 $e |- ph $.
     axmpanmt.2 $e |- [ ph ->.. . ps , ch . ] $.
     $( The meta-form of ~ax-mp with the consequent of the major
       premise being a conjunction and the right conjunction
       the assertion. $)
     axmpanmt $p |- ch  $=
       wph wch axmpanmt.1 wph wps wch wph wps wch wameta wimeta wph wps wch wa
       wi axmpanmt.2 wph wps wch dfwiwamt mpbi pm3.27d ax-mp $.
       $( [28-Nov-2010] $)
  $}

  ${
    ra.1 $e |- [ ph ->.. ps ] $.
    ra.2 $e |- ( ch -> ph ) $.
    $( Replace the antecedent of a meta-implication and
      conjoin it to the left side of the consequent. $)
    ra $p |- [ ch ->.. . ph , ps . ] $=
      wch wph wps wameta wimeta wch wph wps wa wi wch wph wps ra.2 wch wph wps
      ra.2 wph wps ra.1 dfwimetai syl jca wch wph wps dfwiwamt mpbir $.
      $( [28-Nov-2010] $)
  $}

  ${
    ra2.1 $e |- [ ph ->.. . ps , ch . ] $.
    ra2.2 $e |- ( th -> ph ) $.
    $( Replace the antecedent of a meta-implication and
      substitute it for the left conjunct of the consequent. $)
    ra2 $p |- [ th ->.. . ph , ch . ] $=
      wph wch wth wph wch wph wps wch ra2.1 pm3.27dmt dfwimetair ra2.2 ra $.
      $( [28-Nov-2010] $)
  $}

  ${
    ra219.21ai.1 $e |- [ A. x ph ->.. . ps , ch . ] $.
    ra219.21ai.2 $e |- ( th -> A. x th ) $.
    ra219.21ai.3 $e |- ( th -> ph ) $.
    $( Replace the antecedent of a meta-implication and
      substitute it for the left conjunct of the consequent.
      The antecedent of the hypothesis meta-implication is
      universally quantified. $)
    ra219.21ai $p |- [ th ->.. . A. x ph , ch . ] $=
      wph vx wal wps wch wth ra219.21ai.1 wth wph vx ra219.21ai.2 ra219.21ai.3
      19.21ai ra2 $.
      $( [28-Nov-2010] $)
  $}

  ${
    19.21ai2mt.1 $e |- ( ph -> A. x ph ) $.
    19.21ai2mt.2 $e |- [ ph ->.. ps ] $.
    $( Meta-connected form of a theorem similar to ~19.21ai . $)
    19.21ai2mt $p |- [ ph ->.. . ps , A. x ps . ] $=
      wph wps wps vx wal wa wps wps vx wal wameta wph wps wps vx wal wph wps
      19.21ai2mt.2 dfwimetai wph wps vx 19.21ai2mt.1 wph wps 19.21ai2mt.2
      dfwimetai 19.21ai jca wps wps vx wal df-wameta sylibrmt $.
      $( [12-Nov-2010] $)
  $}

  ${
    19.21aai2mt.1 $e |- ( ph -> A. x A. y ph ) $.
    19.21aai2mt.2 $e |- [ ph ->.. ps ] $.
    $( Meta-connected form of a theorem similar to ~19.21ai for two
      quantifying variables. $)
    19.21aai2mt $p |- [ ph ->.. . ps , A. x A. y ps . ] $=
      wph wps wps vy wal vx wal wameta wimeta wph wps wps vy wal vx wal wa wi
      wph wps wps vy wal vx wal wph wps 19.21aai2mt.2 dfwimetai wph wps vy wal
      vx wph wph vy wal vx wal wph vx wal vy wal wph vx wal 19.21aai2mt.1 wph
      vx vy ax67to7 wph vx wal vy ax-4 3syl wph wps vy wph wph vy wal vx wal
      wph vy wal 19.21aai2mt.1 wph vy wal vx ax-4 syl wph wps 19.21aai2mt.2
      dfwimetai 19.21ai 19.21ai jca wph wps wps vy wal vx wal dfwiwamt mpbir $.
      $( [21-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~simplr . $)
    simplrmt $p |- [ . . ph , ps . , ch . ->.. ps ] $=
      wph wps wameta wch wameta wph wps wa wch wa wps wph wps wch dfwa3nmt wph
      wps wch simplr sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~simprr . $)
    simprrmt $p |- [ . ph , . ps , ch . . ->.. ch ] $=
      wph wps wch wameta wameta wph wps wch wa wa wch wph wps wch dfwa3nlmt wph
      wps wch simprr sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~simpll . $)
    simpllmt $p |- [ . . ph , ps . , ch . ->.. ph ] $=
      wph wps wameta wch wameta wph wps wa wch wa wph wph wps wch dfwa3nmt wph
      wps wch simpll sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~simprl . $)
    simprlmt $p |- [ . ph , . ps , ch . . ->.. ps ] $=
      wph wps wch wameta wameta wph wps wch wa wa wps wph wps wch dfwa3nlmt wph
      wps wch simprl sylbimt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~simprlr . $)
    simprlrmt $p |- [ . ph , . . ps , ch . , th . . ->.. ch ] $=
      wph wps wch wa wth wa wch wph wps wch wameta wth wameta wph wps wch wth
      simprlr wph biid wps wch wth dfwa3nmt syl2anbmt $.
      $( [26-Nov-2010] $)
  $}

  ${
    $( Meta-connective form of ~simprll . $)
    simprllmt $p |- [ . ph , . . ps , ch . , th . . ->.. ps ] $=
      wph wps wch wa wth wa wps wph wps wch wameta wth wameta wph wps wch wth
      simprll wph biid wps wch wth dfwa3nmt syl2anbmt $.
      $( [12-Dec-2010] $)
  $}

  ${
    $( Meta-connective form theorem similar to ~simprr . $)
    simprr2mt $p |- [ . . ph , ps . , . . ch , th . , ta . . ->.. ta ] $=
      wph wps wa wch wth wa wta wa wta wph wps wameta wch wth wameta wta wameta
      wph wps wa wch wth wa wta simprr wph wps df-wameta wch wth wta dfwa3nmt
      syl2anbmt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $v et $.
    simprlllr.wet $f wff et $.
    $( A conjunction whose right conjunct is a five-wff nested conjunction
    imples the right conjunct of the innermost conjunction of the nested
    conjunction. $)
    simprlllr $p |- ( ( ph /\ ( ( ( ( ps /\ ch ) /\ th ) /\ ta ) /\ et ) )
      -> ch ) $=
      wps wch wa wth wa wta wa simprlllr.wet wa wch wph wps wch wa wth wa wta
      wa wch simprlllr.wet wps wch wth wta simpllr adantr adantl $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    simprlllrmt.wet $f wff et $.
    $( Meta-connective form of ~simprlllr . $)
    simprlllrmt $p |- [ . ph , . . . . ps , ch . , th . , ta . , et . .
             ->.. ch ] $=
      wph wps wch wa wth wa wta wa simprlllrmt.wet wa wch wph wps wch wameta
      wth wameta wta wameta simprlllrmt.wet wameta wph wps wch wth wta
      simprlllrmt.wet simprlllr wph biid wps wch wth wta simprlllrmt.wet
      dfwa5nmt syl2anbmt $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    simpllllr.wet $f wff et $.
    $( A conjunction whose right conjunct is a five-wff nested conjunction
    imples the left conjunct of the innermost conjunction of the nested
    conjunction. $)
    simpllllr $p |- ( ( ph /\ ( ( ( ( ps /\ ch ) /\ th ) /\ ta ) /\ et ) )
      -> ps ) $=
      wps wch wa wth wa wta wa simpllllr.wet wa wps wph wps wch wa wth wa wta
      wa wps simpllllr.wet wps wch wth wta simplll adantr adantl $.
      $( [9-Dec-2010] $)
  $}

  ${
    $v et $.
    simpllllrmt.wet $f wff et $.
    $( Meta-connective form of ~simpllllr . $)
    simpllllrmt $p |- [ . ph , . . . . ps , ch . , th . ,
                           ta . , et . . ->.. ps ] $=
      wph wps wch wa wth wa wta wa simpllllrmt.wet wa wps wph wps wch wameta
      wth wameta wta wameta simpllllrmt.wet wameta wph wps wch wth wta
      simpllllrmt.wet simpllllr wph biid wps wch wth wta simpllllrmt.wet
      dfwa5nmt syl2anbmt $.
      $( [9-Dec-2010] $)
  $}

  ${
    $v et $.
    $v ze $.
    $v si $.
    ac5h.wet $f wff et $.
    ac5h.wze $f wff ze $.
    ac5h.wsi $f wff si $.
    ac5h.1 $e |- [ ph ->.. ps ] $.
    ac5h.2 $e |-  ( ch -> ( th -> ( ta -> ( et -> ( ze -> si ) ) ) ) ) $.
    ac5h.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac5h.4 $e |- [ . ph , ps . ->.. th ] $.
    ac5h.5 $e |- [ . ph , ps . ->.. ta ] $.
    ac5h.6 $e |- [ . ph , ps . ->.. et ] $.
    ac5h.7 $e |- [ . ph , ps . ->.. ze ] $.
    $( Meta-conjoin to the consequent of a meta-implication a wff which is the
       end wff of a five-antecedent nested implication. $)
    ac5h $p |- [ ph ->.. . ps , si . ] $=
      wph wps ac5h.wsi wa wps ac5h.wsi wameta wph wps ac5h.wsi wph wps ac5h.1
      dfwimetai wph ac5h.wsi wph wps ac5h.wsi wph wph wps wa ac5h.wsi wph wps
      wa ac5h.wze ac5h.wsi wph wps wa wph wps wa ac5h.wze ac5h.wsi wi wph wps
      wa ac5h.wet ac5h.wze ac5h.wsi wi wph wps wa wph wps wa ac5h.wet ac5h.wze
      ac5h.wsi wi wi wph wps wa wta ac5h.wet ac5h.wze ac5h.wsi wi wi wph wps wa
      wph wps wa wta ac5h.wet ac5h.wze ac5h.wsi wi wi wi wph wps wa wth wta
      ac5h.wet ac5h.wze ac5h.wsi wi wi wi wph wps wa wph wps wa wch wth wta
      ac5h.wet ac5h.wze ac5h.wsi wi wi wi wi wph wps wch ac5h.3 dfwiwametai
      ac5h.2 syl wph wps wth ac5h.4 dfwiwametai syl5 pm2.43i wph wps wta ac5h.5
      dfwiwametai syl5 pm2.43i wph wps ac5h.wet ac5h.6 dfwiwametai syl5 pm2.43i
      wph wps ac5h.wze ac5h.7 dfwiwametai syl5 pm2.43i wph wps ac5h.1 dfwimetai
      sylan2 anidms jca wps ac5h.wsi df-wameta sylibrmt $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    $v ze $.
    ac4h.wet $f wff et $.
    ac4h.wze $f wff ze $.
    ac4h.1 $e |- [ ph ->.. ps ] $.
    ac4h.2 $e |-  ( ch -> ( th -> ( ta -> ( et -> ze ) ) ) ) $.
    ac4h.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac4h.4 $e |- [ . ph , ps . ->.. th ] $.
    ac4h.5 $e |- [ . ph , ps . ->.. ta ] $.
    ac4h.6 $e |- [ . ph , ps . ->.. et ] $.
    $( Meta-conjoin to the consequent of a meta-implication a wff which is the
       end wff of a four-antecedent nested implication. $)
    ac4h $p |- [ ph ->.. . ps , ze . ] $=
      wph wps wch wch wth wta ac4h.wet ac4h.wze ac4h.1 wch wth wta ac4h.wet
      ac4h.wze wi wi wi wi wch ac4h.2 a1i ac4h.3 ac4h.3 ac4h.4 ac4h.5 ac4h.6
      ac5h $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    ac3h.wet $f wff et $.
    ac3h.1 $e |- [ ph ->.. ps ] $.
    ac3h.2 $e |-  ( ch -> ( th -> ( ta -> et ) ) ) $.
    ac3h.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac3h.4 $e |- [ . ph , ps . ->.. th ] $.
    ac3h.5 $e |- [ . ph , ps . ->.. ta ] $.

    $( Meta-conjoin to the consequent of a meta-implication a wff which is the
       end wff of a three-antecedent nested implication. $)
    ac3h $p |- [ ph ->.. . ps , et . ] $=
      wph wps wch wch wth wta ac3h.wet ac3h.1 wch wth wta ac3h.wet wi wi wi wch
      ac3h.2 a1i ac3h.3 ac3h.3 ac3h.4 ac3h.5 ac4h $.
      $( [26-Nov-2010] $)
  $}

  ${
    ac2h.1 $e |- [ ph ->.. ps ] $.
    ac2h.2 $e |-  ( ch -> ( th -> ta ) ) $.
    ac2h.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac2h.4 $e |- [ . ph , ps . ->.. th ] $.
    $( Meta-conjoin to the consequent of a meta-implication a wff which is the
       end wff of a two-antecedent nested implication. $)
    ac2h $p |- [ ph ->.. . ps , ta . ] $=
      wph wps wch wch wth wta ac2h.1 wch wth wta wi wi wch ac2h.2 a1i ac2h.3
      ac2h.3 ac2h.4 ac3h $.
      $( [26-Nov-2010] $)
  $}

  ${
    ac2han.1 $e |- [ ph ->.. ps ] $.
    ac2han.2 $e |- ( ( ch /\ th ) -> ta ) $.
    ac2han.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac2han.4 $e |- [ . ph , ps . ->.. th ] $.
    $( Meta-conjoin to the consequent of a meta-implication a wff which is the
       consequent of an implication having an antecedent of two conjoined
       wffs. $)
    ac2han $p |- [ ph ->.. . ps , ta . ] $=
      wph wps wch wth wta ac2han.1 wch wth wa wta wi wch wth wta wi wi ac2han.2
      wch wth wta impexp mpbi ac2han.3 ac2han.4 ac2h $.
      $( [26-Nov-2010] $)
  $}

  ${
    ac2hmt.1 $e |- [ ph ->.. ps ] $.
    ac2hmt.2 $e |- [ . ch , th . ->.. ta ] $.
    ac2hmt.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac2hmt.4 $e |- [ . ph , ps . ->.. th ] $.
    $( Conjoin a consequent to the consequent of an implication using a
       meta-implication having an antecedent of two conjoined wffs. $)
    ac2hmt $p |- [ ph ->.. . ps , ta . ] $=
      wph wps wch wth wta ac2hmt.1 wch wth wa wch wth wameta wta wch wth
      df-wameta wch wth wameta wta ac2hmt.2 dfwimetai sylbir ac2hmt.3 ac2hmt.4
      ac2han $.
      $( [12-Nov-2010] $)
  $}

  ${
    ac2hbir.1 $e |- [ ph ->.. ps ] $.
    ac2hbir.2 $e |- ( ch -> ( th <-> ta ) ) $.
    ac2hbir.3 $e |- [ . ph , ps . ->.. ch ] $.
    ac2hbir.4 $e |- [ . ph , ps . ->.. ta ] $.
    $( Conjoin a consequent to the consequent of an implication using an
       implication whose consequent is a bi-conditional.  The conjoined
       consequent is the left side of the bi-conditional. $)
    ac2hbir $p |- [ ph ->.. . ps , th . ] $=
      wph wps wch wta wth ac2hbir.1 wch wth wta ac2hbir.2 biimprd ac2hbir.3
      ac2hbir.4 ac2h $.
      $( [12-Dec-2010] $)
  $}

  ${
    ac1h.1 $e |- [ ph ->.. ps ] $.
    ac1h.2 $e |-  ( ch -> th ) $.
    ac1h.3 $e |- [ . ph , ps . ->.. ch ] $.
    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is the consequent of an implication. $)
    ac1h $p |- [ ph ->.. . ps , th . ] $=
      wph wps wch wch wth ac1h.1 wch wth wi wch ac1h.2 a1i ac1h.3 ac1h.3 ac2h
      $.
      $( [26-Nov-2010] $)
  $}

  ${
    ac1hbir.1 $e |- [ ph ->.. ps ] $.
    ac1hbir.2 $e |-  ( th <-> ch ) $.
    ac1hbir.3 $e |- [ . ph , ps . ->.. ch ] $.
    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is on the left side of a biconditional. $)
    ac1hbir $p |- [ ph ->.. . ps , th . ] $=
      wph wps wch wth ac1hbir.1 wth wch ac1hbir.2 biimpri ac1hbir.3 ac1h $.
      $( [26-Nov-2010] $)
  $}

  ${
    ac0h.1 $e |- [ ph ->.. ps ] $.
    ac0h.2 $e |- ch $.
    $( Meta-conjoin to the consequent of a meta-implication
      a theorem. $)
    ac0h $p |- [ ph ->.. . ps , ch . ] $=
      wph wps wch wch ac0h.1 wch id wph wps wameta wph wps wa wch wph wps
      df-wameta wch wph wps wa ac0h.2 a1i sylbimt ac1h $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    $v ze $.
    $v si $.
    $v rh $.
    $v la $.
    acn5h.wet $f wff et $.
    acn5h.wze $f wff ze $.
    acn5h.wsi $f wff si $.
    acn5h.wpi $f wff rh $.
    acn5h.wla $f wff la $.
    acn5h.1 $e |- [ ph ->.. . ps , [ ch ->.. th ] . ] $.
    acn5h.2 $e |-  ( ta -> ( et -> ( ze -> ( si -> ( rh -> la ) ) ) ) ) $.
    acn5h.3 $e |- [ . . . ph , ps . , ch . , th . ->.. ta ] $.
    acn5h.4 $e |- [ . . . ph , ps . , ch . , th . ->.. et ] $.
    acn5h.5 $e |- [ . . . ph , ps . , ch . , th . ->.. ze ] $.
    acn5h.6 $e |- [ . . . ph , ps . , ch . , th . ->.. si ] $.
    acn5h.7 $e |- [ . . . ph , ps . , ch . , th . ->.. rh ] $.

    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is the end wff of a five-antecedent nested
      implication.  The meta-implication conjoined with
      another wff is the consequent of another meta-implication. $)
    acn5h $p |- [ ph ->.. . ps , [ ch ->.. . th , la . ] . ] $=
      wph wps wch wth acn5h.wla wameta wimeta wameta wimeta wph wps wch wth
      acn5h.wla wa wi wa wi wph wps wch wth acn5h.wla wa wi wph wps wch wth
      wimeta wph wps wch wth wimeta wameta wps wch wth wimeta wa wph wps wch
      wth wimeta wameta acn5h.1 dfwimetai wps wch wth wimeta df-wameta sylib
      pm3.26d wph wch wth acn5h.wla wph wch wth wimeta wch wth wi wph wps wch
      wth wimeta wph wps wch wth wimeta wameta wps wch wth wimeta wa wph wps
      wch wth wimeta wameta acn5h.1 dfwimetai wps wch wth wimeta df-wameta
      sylib pm3.27d wch wth df-wimeta sylib wph wch wth acn5h.wla wph wch wth
      wimeta wch wth wi wph wps wch wth wimeta wph wps wch wth wimeta wameta
      wps wch wth wimeta wa wph wps wch wth wimeta wameta acn5h.1 dfwimetai wps
      wch wth wimeta df-wameta sylib pm3.27d wch wth df-wimeta sylib wph wch
      wth acn5h.wla wi wi wph wps wch wth acn5h.wla wi wi wph wph wps wch wth
      acn5h.wla wph wps wa wch wa wth wa acn5h.wla wph wps wa wch wa wth wa
      acn5h.wpi acn5h.wla wph wps wa wch wa wth wa wph wps wa wch wa wth wa
      acn5h.wpi acn5h.wla wi wph wps wa wch wa wth wa acn5h.wsi acn5h.wpi
      acn5h.wla wi wph wps wa wch wa wth wa wph wps wa wch wa wth wa acn5h.wsi
      acn5h.wpi acn5h.wla wi wi wph wps wa wch wa wth wa acn5h.wze acn5h.wsi
      acn5h.wpi acn5h.wla wi wi wph wps wa wch wa wth wa wph wps wa wch wa wth
      wa acn5h.wze acn5h.wsi acn5h.wpi acn5h.wla wi wi wi wph wps wa wch wa wth
      wa acn5h.wet acn5h.wze acn5h.wsi acn5h.wpi acn5h.wla wi wi wi wph wps wa
      wch wa wth wa wph wps wa wch wa wth wa wta acn5h.wet acn5h.wze acn5h.wsi
      acn5h.wpi acn5h.wla wi wi wi wi wph wps wa wch wa wth wa wph wps wameta
      wch wameta wth wameta wta wph wps wch wth dfwa4nmt wph wps wameta wch
      wameta wth wameta wta acn5h.3 dfwimetai sylbir acn5h.2 syl wph wps wa wch
      wa wth wa wph wps wameta wch wameta wth wameta acn5h.wet wph wps wch wth
      dfwa4nmt wph wps wameta wch wameta wth wameta acn5h.wet acn5h.4 dfwimetai
      sylbir syl5 pm2.43i wph wps wa wch wa wth wa wph wps wameta wch wameta
      wth wameta acn5h.wze wph wps wch wth dfwa4nmt wph wps wameta wch wameta
      wth wameta acn5h.wze acn5h.5 dfwimetai sylbir syl5 pm2.43i wph wps wa wch
      wa wth wa wph wps wameta wch wameta wth wameta acn5h.wsi wph wps wch wth
      dfwa4nmt wph wps wameta wch wameta wth wameta acn5h.wsi acn5h.6 dfwimetai
      sylbir syl5 pm2.43i wph wps wa wch wa wth wa wph wps wameta wch wameta
      wth wameta acn5h.wpi wph wps wch wth dfwa4nmt wph wps wameta wch wameta
      wth wameta acn5h.wpi acn5h.7 dfwimetai sylbir syl5 pm2.43i exp41 wph wps
      wch wth wimeta wph wps wch wth wimeta wameta wps wch wth wimeta wa wph
      wps wch wth wimeta wameta acn5h.1 dfwimetai wps wch wth wimeta df-wameta
      sylib pm3.26d syl5 pm2.43i mpdd jcad jca wph wps wch wth acn5h.wla
      dfwiwawiwamt mpbir $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    $v ze $.
    $v si $.
    $v rh $.
    acn4h.wet $f wff et $.
    acn4h.wze $f wff ze $.
    acn4h.wsi $f wff si $.
    acn4h.wpi $f wff rh $.
    acn4h.1 $e |- [ ph ->.. . ps , [ ch ->.. th ] . ] $.
    acn4h.2 $e |-  ( ta -> ( et -> ( ze -> ( si -> rh ) ) ) ) $.
    acn4h.3 $e |- [ . . . ph , ps . , ch . , th . ->.. ta ] $.
    acn4h.4 $e |- [ . . . ph , ps . , ch . , th . ->.. et ] $.
    acn4h.5 $e |- [ . . . ph , ps . , ch . , th . ->.. ze ] $.
    acn4h.6 $e |- [ . . . ph , ps . , ch . , th . ->.. si ] $.

    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is the end wff of a four-antecedent nested
      implication.  The meta-implication conjoined with
      another wff is the consequent of another meta-implication. $)
    acn4h $p |- [ ph ->.. . ps , [ ch ->.. . th , rh . ] . ] $=
      wph wps wch wth wta wta acn4h.wet acn4h.wze acn4h.wsi acn4h.wpi acn4h.1
      wta acn4h.wet acn4h.wze acn4h.wsi acn4h.wpi wi wi wi wi wta acn4h.2 a1i
      acn4h.3 acn4h.3 acn4h.4 acn4h.5 acn4h.6 acn5h $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    $v ze $.
    $v si $.
    acn3h.wet $f wff et $.
    acn3h.wze $f wff ze $.
    acn3h.wsi $f wff si $.
    acn3h.1 $e |- [ ph ->.. . ps , [ ch ->.. th ] . ] $.
    acn3h.2 $e |-  ( ta -> ( et -> ( ze -> si ) ) ) $.
    acn3h.3 $e |- [ . . . ph , ps . , ch . , th . ->.. ta ] $.
    acn3h.4 $e |- [ . . . ph , ps . , ch . , th . ->.. et ] $.
    acn3h.5 $e |- [ . . . ph , ps . , ch . , th . ->.. ze ] $.

    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is the end wff of a three-antecedent nested
      implication.  The meta-implication conjoined with
      another wff is the consequent of another meta-implication. $)
    acn3h $p |- [ ph ->.. . ps , [ ch ->.. . th , si . ] . ] $=
      wph wps wch wth wta wta acn3h.wet acn3h.wze acn3h.wsi acn3h.1 wta
      acn3h.wet acn3h.wze acn3h.wsi wi wi wi wta acn3h.2 a1i acn3h.3 acn3h.3
      acn3h.4 acn3h.5 acn4h $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    $v ze $.
    acn2h.wet $f wff et $.
    acn2h.wze $f wff ze $.
    acn2h.1 $e |- [ ph ->.. . ps , [ ch ->.. th ] . ] $.
    acn2h.2 $e |-  ( ta -> ( et -> ze ) ) $.
    acn2h.3 $e |- [ . . . ph , ps . , ch . , th . ->.. ta ] $.
    acn2h.4 $e |- [ . . . ph , ps . , ch . , th . ->.. et ] $.

    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is the end wff of a two-antecedent nested
      implication.  The meta-implication conjoined with
      another wff is the consequent of another meta-implication. $)
    acn2h $p |- [ ph ->.. . ps , [ ch ->.. . th , ze . ] . ] $=
      wph wps wch wth wta wta acn2h.wet acn2h.wze acn2h.1 wta acn2h.wet
      acn2h.wze wi wi wta acn2h.2 a1i acn2h.3 acn2h.3 acn2h.4 acn3h $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    acn1h.wet $f wff et $.
    acn1h.1 $e |- [ ph ->.. . ps , [ ch ->.. th ] . ] $.
    acn1h.2 $e |-  ( ta -> et ) $.
    acn1h.3 $e |- [ . . . ph , ps . , ch . , th . ->.. ta ] $.

    $( Meta-conjoin to the consequent of a meta-implication
      a wff which is the antecedent of an implication.  The
      meta-implication conjoined with another wff is the
      consequent of another meta-implication. $)
    acn1h $p |- [ ph ->.. . ps , [ ch ->.. . th , et . ] . ] $=
      wph wps wch wth wta wta acn1h.wet acn1h.1 wta acn1h.wet wi wta acn1h.2
      a1i acn1h.3 acn1h.3 acn2h $.
      $( [26-Nov-2010] $)
  $}

  ${
    acn0h.1 $e |- [ ph ->.. . ps , [ ch ->.. th ] . ] $.
    acn0h.2 $e |- ta $.
    $( Meta-conjoin to the consequent of a meta-implication
      a theorem.  The meta-implication conjoined with another
      wff is the consequent of another meta-implication. $)
    acn0h $p |- [ ph ->.. . ps , [ ch ->.. . th , ta . ] . ] $=
      wph wps wch wth wta wta acn0h.1 wta id wph wps wameta wch wameta wth
      wameta wta wta wph wps wameta wch wameta wth wameta acn0h.2 a1i
      dfwimetair acn1h $.
      $( [26-Nov-2010] $)
  $}

  ${
    $v et $.
    anc2h.wet $f wff et $.
    anc2h.1 $e |- [ ph ->.. ps ] $.
    anc2h.2 $e |-  ( ch -> ( th -> ( ta -> et ) ) ) $.
    anc2h.3 $e |- [ . ph , ps . ->.. ch ] $.
    anc2h.4 $e |- [ . ph , ps . ->.. th ] $.
    $( Meta-conjoin to the consequent of a meta-implication
      a meta-implication which is the meta-form of the
      implication at the end of a three-antecedent nested
      implication. $)
    anc2h $p |- [ ph ->.. . ps , [ ta ->.. et ] . ] $=
      wph wps wch wth wta anc2h.wet wimeta anc2h.1 wch wth wta anc2h.wet wi wta
      anc2h.wet wimeta anc2h.2 wta anc2h.wet df-wimeta syl6ibr anc2h.3 anc2h.4
      ac2h $.
      $( [26-Nov-2010] $)
  $}

  ${
    anc1h.1 $e |- [ ph ->.. ps ] $.
    anc1h.2 $e |-  ( ch -> ( th -> ta ) ) $.
    anc1h.3 $e |- [ . ph , ps . ->.. ch ] $.

    $( Meta-conjoin to the consequent of a meta-implication
      a meta-implication which is the meta-form of the
      implication at the end of a two-antecedent nested
      implication. $)
    anc1h $p |- [ ph ->.. . ps , [ th ->.. ta ] . ] $=
      wph wps wch wth wta wimeta anc1h.1 wch wth wta wi wth wta wimeta anc1h.2
      wth wta df-wimeta sylibr anc1h.3 ac1h $.
      $( [26-Nov-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Theorems proved using meta-conjunction and meta-implication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $. $d x B $. $d x C $.
    $( Alternate proof of ~sstr , transitivity of subclasses, Theorem 6 of
      [Suppes] p. 23, using theorems and deductions containing
      the meta-implication and meta-conjunction connectives. $)
    sstrALT2 $p |- ( ( A C_ B /\ B C_ C ) -> A C_ C ) $=
      cA cB wss cB cC wss wa vx cv cA wcel vx cv cC wcel wi vx cv cA wcel vx cv
      cC wcel wi vx wal wameta cA cC wss cA cB wss cB cC wss wa vx cv cA wcel
      vx cv cC wcel wi vx cv cA wcel vx cv cC wcel wi vx wal wameta cA cB wss
      cB cC wss wa vx cv cA wcel vx cv cC wcel wi vx wal cA cC wss cA cB wss cB
      cC wss wa vx cv cA wcel vx cv cC wcel wi vx cA cB wss cB cC wss wa vx
      ax-17 cA cB wss cB cC wss wa vx cv cA wcel cA cB wss cB cC wss wameta vx
      cv cB wcel wameta vx cv cC wcel cA cB wss cB cC wss wa vx cv cA wcel
      wameta cA cB wss cB cC wss wameta vx cv cB wcel wameta cB cC wss vx cv cB
      wcel vx cv cC wcel cA cB wss cB cC wss wa vx cv cA wcel wameta cA cB wss
      cB cC wss wameta cA cB wss vx cv cA wcel vx cv cB wcel cA cB wss cB cC
      wss wa vx cv cA wcel wameta cA cB wss cA cB wss cB cC wss wa cB cC wss cA
      cB wss cB cC wss wa cA cB wss vx cv cA wcel cA cB wss cB cC wss pm3.26
      adantrmt cA cB wss cB cC wss pm3.27 cA cB wss cB cC wss wa vx cv cA wcel
      cA cB wss simpllmt ac1h cA cB vx cv ssel2 cA cB wss cB cC wss wa vx cv cA
      wcel wameta cA cB wss cB cC wss simprlmt cA cB wss cB cC wss wa vx cv cA
      wcel cA cB wss cB cC wss wameta simplrmt ac2han cB cC vx cv ssel2 cA cB
      wss cB cC wss wa vx cv cA wcel wameta cA cB wss cB cC wss vx cv cB wcel
      simprlrmt cA cB wss cB cC wss wa vx cv cA wcel wameta cA cB wss cB cC wss
      wameta vx cv cB wcel simprrmt ac2han pm3.27dexmt 19.21ai2mt cA cC wss vx
      cv cA wcel vx cv cC wcel wi vx wal cA cB wss cB cC wss wa vx cA cC dfss2
      adantlbirmt cA cB wss cB cC wss wa vx cv cA wcel vx cv cC wcel wi vx cv
      cA wcel vx cv cC wcel wi vx wal wameta pm3.26mt cA cB wss cB cC wss wa vx
      cv cA wcel vx cv cC wcel wi vx cv cA wcel vx cv cC wcel wi vx wal
      simprrmt ac2hmt pm3.27dmt $.
      $( [12-Nov-2010] $)
  $}

  ${
    $d z A $. $d y A $. $d z y $.
    $( Proof of ~suctr using the meta-implication
      and meta-conjunction connectives. $)
    suctrALT2 $p |- ( Tr A -> Tr suc A ) $=
      cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa vz cv cA csuc wcel wi vz cv
      vy cv wcel vy cv cA csuc wcel wa vz cv cA csuc wcel wi vy wal vz wal
      wameta cA csuc wtr cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa vz cv cA
      csuc wcel wi vz cv vy cv wcel vy cv cA csuc wcel wa vz cv cA csuc wcel wi
      vy wal vz wal wameta vz cv vy cv wcel vy cv cA csuc wcel wa vz cv cA csuc
      wcel wi vy wal vz wal cA csuc wtr cA wtr vz cv vy cv wcel vy cv cA csuc
      wcel wa vz cv cA csuc wcel wi vz vy cA wtr cA wtr vy wal cA wtr vy wal vz
      wal cA wtr vy ax-17 cA wtr vy wal vz ax-17 syl cA wtr vz cv vy cv wcel vy
      cv cA csuc wcel wa vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo
      wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA csuc wcel wi wameta
      vy cv cA wceq vz cv cA csuc wcel wi wameta vz cv cA csuc wcel cA wtr vz
      cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA
      wcel vy cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv
      cA csuc wcel wi wameta vy cv cA wceq vz cv cA csuc wcel wi wameta vy cv
      cA wcel vz cv cA csuc wcel wi vy cv cA wceq vz cv cA csuc wcel wi vy cv
      cA wcel vy cv cA wceq wo vz cv cA csuc wcel cA wtr vz cv vy cv wcel vy cv
      cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo
      wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA csuc wcel wi wameta
      vy cv cA wceq vz cv cA wcel cA cA csuc wss wameta vz cv cA csuc wcel cA
      wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy
      cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel
      vz cv cA csuc wcel wi wameta vy cv cA wceq vz cv cA wcel cA cA csuc wss
      wameta cA cA csuc wss vz cv cA wcel vz cv cA csuc wcel cA wtr vz cv vy cv
      wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel vy cv
      cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA csuc
      wcel wi wameta vy cv cA wceq vz cv cA wcel cA cA csuc wss cA wtr vz cv vy
      cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel vy
      cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA csuc
      wcel wi wameta vz cv vy cv wcel vy cv cA wceq vz cv cA wcel cA wtr vz cv
      vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel
      vy cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA
      wcel cA cA csuc wss wameta vz cv cA csuc wcel cA wtr vz cv vy cv wcel vy
      cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq
      wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA wcel cA cA csuc
      wss wameta cA cA csuc wss vz cv cA wcel vz cv cA csuc wcel cA wtr vz cv
      vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel
      vy cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA
      wcel cA cA csuc wss cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta
      vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel
      wameta cA wtr vz cv vy cv wcel vy cv cA wcel vz cv cA wcel cA wtr vz cv
      vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel
      vy cv cA wceq wo wameta vz cv vy cv wcel vy cv cA csuc wcel wa vz cv vy
      cv wcel cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA
      csuc wcel vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo vz cv vy cv
      wcel vy cv cA csuc wcel wa vy cv cA csuc wcel cA wtr vz cv vy cv wcel vy
      cv cA csuc wcel pm3.27 adantlmt vy cv cA elsuci cA wtr vz cv vy cv wcel
      vy cv cA csuc wcel wa wameta vy cv cA csuc wcel pm3.27mt ac1h vz cv vy cv
      wcel vy cv cA csuc wcel pm3.26 cA wtr vz cv vy cv wcel vy cv cA csuc wcel
      wa vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo wameta simplrmt ac1h
      cA wtr vz cv vy cv wcel vy cv cA wcel vz cv cA wcel cA vz cv vy cv trel
      exp3a cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa vy cv cA csuc wcel vy
      cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel wameta simpllmt cA
      wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy
      cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel simprrmt anc2h cA
      sssucid acn0h cA cA csuc vz cv ssel cA wtr vz cv vy cv wcel vy cv cA csuc
      wcel wa wameta vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo wameta
      vz cv vy cv wcel wameta wameta vy cv cA wcel wameta vz cv cA wcel cA cA
      csuc wss simprrmt cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy
      cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel
      wameta wameta vy cv cA wcel wameta vz cv cA wcel cA cA csuc wss simprlmt
      acn2h pm3.27dnmt vy cv cA wceq vz cv vy cv wcel vz cv cA wcel vy cv cA vz
      cv eleq2 biimpcd cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy
      cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel vy
      cv cA wcel vz cv cA csuc wcel wi simprlrmt anc1h cA sssucid acn0h cA cA
      csuc vz cv ssel cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy
      cv cA csuc wcel vy cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel
      wameta vy cv cA wcel vz cv cA csuc wcel wi wameta wameta vy cv cA wceq
      wameta vz cv cA wcel cA cA csuc wss simprrmt cA wtr vz cv vy cv wcel vy
      cv cA csuc wcel wa wameta vy cv cA csuc wcel vy cv cA wcel vy cv cA wceq
      wo wameta vz cv vy cv wcel wameta vy cv cA wcel vz cv cA csuc wcel wi
      wameta wameta vy cv cA wceq wameta vz cv cA wcel cA cA csuc wss simprlmt
      acn2h pm3.27dnmt vy cv cA wcel vz cv cA csuc wcel vy cv cA wceq jao cA
      wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy
      cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel
      vz cv cA csuc wcel wi vy cv cA wceq vz cv cA csuc wcel wi simprlrmt cA
      wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel vy
      cv cA wcel vy cv cA wceq wo wameta vz cv vy cv wcel wameta vy cv cA wcel
      vz cv cA csuc wcel wi wameta vy cv cA wceq vz cv cA csuc wcel wi simprrmt
      cA wtr vz cv vy cv wcel vy cv cA csuc wcel wa wameta vy cv cA csuc wcel
      vy cv cA wcel vy cv cA wceq wo vz cv vy cv wcel vy cv cA wcel vz cv cA
      csuc wcel wi vy cv cA wceq vz cv cA csuc wcel wi simprlllrmt ac3h
      pm3.27dexmt 19.21aai2mt vz vy cA csuc dftr2 cA wtr vz cv vy cv wcel vy cv
      cA csuc wcel wa vz cv cA csuc wcel wi vz cv vy cv wcel vy cv cA csuc wcel
      wa vz cv cA csuc wcel wi vy wal vz wal simprrmt ac1hbir pm3.27dmt $.
      $( [26-Nov-2010] $)
  $}

  ${
    $d z A $. $d y A $. $d z y $.
    $( The power class of a transitive class is transitive. $)
    pwtr $p |- ( Tr A -> Tr ~P A ) $=
      cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa vz cv cA cpw wcel wi vz cv
      vy cv wcel vy cv cA cpw wcel wa vz cv cA cpw wcel wi vy wal vz wal wameta
      cA cpw wtr cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa vz cv cA cpw wcel
      wi vz cv vy cv wcel vy cv cA cpw wcel wa vz cv cA cpw wcel wi vy wal vz
      wal wameta cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa vz cv cA cpw wcel
      wi vy wal vz wal cA cpw wtr cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa
      vz cv cA cpw wcel wi vz vy cA wtr cA wtr vy wal cA wtr vy wal vz wal cA
      wtr vy ax-17 cA wtr vy wal vz ax-17 syl cA wtr vz cv vy cv wcel vy cv cA
      cpw wcel wa vz cv vy cv wcel vy cv cA cpw wcel wameta vy cv cA wss wameta
      vz cv cA wcel wameta vz cv cA wss wameta vz cv cvv wcel wameta vz cv cA
      cpw wcel cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv
      wcel vy cv cA cpw wcel wameta vy cv cA wss wameta vz cv cA wcel wameta vz
      cv cA wss wameta vz cv cvv wcel wameta vz cv cvv wcel vz cv cA cpw wcel
      vz cv cA wss cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy
      cv wcel vy cv cA cpw wcel wameta vy cv cA wss wameta vz cv cA wcel wameta
      vz cv cA wss wameta vz cv cvv wcel cA wtr vz cv vy cv wcel vy cv cA cpw
      wcel wa wameta vz cv vy cv wcel vy cv cA cpw wcel wameta vy cv cA wss
      wameta vz cv cA wcel wameta cA wtr vz cv cA wcel vz cv cA wss cA wtr vz
      cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv wcel vy cv cA cpw
      wcel wameta vy cv cA wss wameta vy cv cA wss vz cv vy cv wcel vz cv cA
      wcel cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv wcel
      vy cv cA cpw wcel wameta vy cv cA cpw wcel vy cv cA wss cA wtr vz cv vy
      cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv wcel vz cv vy cv wcel vy
      cv cA cpw wcel wa vy cv cA cpw wcel vz cv vy cv wcel vy cv cA cpw wcel wa
      vz cv vy cv wcel cA wtr vz cv vy cv wcel vy cv cA cpw wcel pm3.26
      adantlmt vz cv vy cv wcel vy cv cA cpw wcel pm3.27 cA wtr vz cv vy cv
      wcel vy cv cA cpw wcel wa vz cv vy cv wcel simplrmt ac1h vy cv cA elpwi
      cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv wcel vy
      cv cA cpw wcel simprrmt ac1h vy cv cA vz cv ssel cA wtr vz cv vy cv wcel
      vy cv cA cpw wcel wa wameta vz cv vy cv wcel vy cv cA cpw wcel wameta vy
      cv cA wss simprrmt cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa wameta vz
      cv vy cv wcel vy cv cA cpw wcel vy cv cA wss simprllmt ac2h cA vz cv trss
      cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa vz cv vy cv wcel vy cv cA
      cpw wcel wameta vy cv cA wss wameta vz cv cA wcel wameta simpllmt cA wtr
      vz cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv wcel vy cv cA
      cpw wcel wameta vy cv cA wss wameta vz cv cA wcel simprrmt ac2h vz visset
      ac0h vz cv cA cvv elpwg cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa
      wameta vz cv vy cv wcel vy cv cA cpw wcel wameta vy cv cA wss wameta vz
      cv cA wcel wameta vz cv cA wss wameta vz cv cvv wcel simprrmt cA wtr vz
      cv vy cv wcel vy cv cA cpw wcel wa wameta vz cv vy cv wcel vy cv cA cpw
      wcel wameta vy cv cA wss wameta vz cv cA wcel wameta vz cv cA wss vz cv
      cvv wcel simprlrmt ac2hbir pm3.27dexmt 19.21aai2mt cA cpw wtr vz cv vy cv
      wcel vy cv cA cpw wcel wa vz cv cA cpw wcel wi vy wal vz wal cA wtr vz vy
      cA cpw dftr2 adantlbirmt cA wtr vz cv vy cv wcel vy cv cA cpw wcel wa vz
      cv cA cpw wcel wi vz cv vy cv wcel vy cv cA cpw wcel wa vz cv cA cpw wcel
      wi vy wal vz wal wameta pm3.26mt cA wtr vz cv vy cv wcel vy cv cA cpw
      wcel wa vz cv cA cpw wcel wi vz cv vy cv wcel vy cv cA cpw wcel wa vz cv
      cA cpw wcel wi vy wal vz wal simprrmt ac2hmt pm3.27dmt $.
      $( [12-Dec-2010] $)
  $}

  ${
    $d z A $. $d y A $. $d z y $.
    pwtrr.1 $e |- A e. _V $.
    $( A set is transitive if its power set is transitive. $)
    pwtrr $p |- ( Tr ~P A -> Tr A ) $=
      cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vz cv vy cv
      wcel vy cv cA wcel wa vz cv cA wcel wi vy wal vz wal wameta cA wtr cA cpw
      wtr vz cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vz cv vy cv wcel
      vy cv cA wcel wa vz cv cA wcel wi vy wal vz wal wameta cA cpw wtr vz cv
      vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vy wal vz wal cA wtr cA cpw
      wtr vz cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vz vy cA cpw wtr
      cA cpw wtr vy wal cA cpw wtr vy wal vz wal cA cpw wtr vy ax-17 cA cpw wtr
      vy wal vz ax-17 syl cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa vz cv vy
      cv wcel vy cv cA wcel wameta cA cA cpw wcel wameta vy cv cA cpw wcel
      wameta vy cv cA wss wameta vz cv cA wcel cA cpw wtr vz cv vy cv wcel vy
      cv cA wcel wa wameta vz cv vy cv wcel vy cv cA wcel wameta cA cA cpw wcel
      wameta vy cv cA cpw wcel wameta vy cv cA wss wameta vy cv cA wss vz cv vy
      cv wcel vz cv cA wcel cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa wameta
      vz cv vy cv wcel vy cv cA wcel wameta cA cA cpw wcel wameta vy cv cA cpw
      wcel wameta vy cv cA cpw wcel vy cv cA wss cA cpw wtr vz cv vy cv wcel vy
      cv cA wcel wa wameta vz cv vy cv wcel vy cv cA wcel wameta cA cA cpw wcel
      wameta cA cpw wtr vy cv cA wcel cA cA cpw wcel vy cv cA cpw wcel cA cpw
      wtr vz cv vy cv wcel vy cv cA wcel wa wameta vz cv vy cv wcel vy cv cA
      wcel wameta cA cA cpw wcel cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa
      wameta vz cv vy cv wcel vz cv vy cv wcel vy cv cA wcel wa vy cv cA wcel
      vz cv vy cv wcel vy cv cA wcel wa vz cv vy cv wcel cA cpw wtr vz cv vy cv
      wcel vy cv cA wcel pm3.26 adantlmt vz cv vy cv wcel vy cv cA wcel pm3.27
      cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa vz cv vy cv wcel simplrmt
      ac1h cA pwtrr.1 pwid ac0h cA cpw wtr vy cv cA wcel cA cA cpw wcel vy cv
      cA cpw wcel cA cpw vy cv cA trel exp3a cA cpw wtr vz cv vy cv wcel vy cv
      cA wcel wa vz cv vy cv wcel vy cv cA wcel wameta cA cA cpw wcel wameta
      simpllmt cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa wameta vz cv vy cv
      wcel vy cv cA wcel cA cA cpw wcel simprlrmt cA cpw wtr vz cv vy cv wcel
      vy cv cA wcel wa wameta vz cv vy cv wcel vy cv cA wcel wameta cA cA cpw
      wcel simprrmt ac3h vy cv cA elpwi cA cpw wtr vz cv vy cv wcel vy cv cA
      wcel wa wameta vz cv vy cv wcel vy cv cA wcel wameta cA cA cpw wcel
      wameta vy cv cA cpw wcel simprrmt ac1h vy cv cA vz cv ssel cA cpw wtr vz
      cv vy cv wcel vy cv cA wcel wa wameta vz cv vy cv wcel vy cv cA wcel
      wameta cA cA cpw wcel wameta vy cv cA cpw wcel wameta vy cv cA wss
      simprrmt cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa wameta vz cv vy cv
      wcel vy cv cA wcel cA cA cpw wcel vy cv cA cpw wcel vy cv cA wss
      simpllllrmt ac2h pm3.27dexmt 19.21aai2mt cA wtr vz cv vy cv wcel vy cv cA
      wcel wa vz cv cA wcel wi vy wal vz wal cA cpw wtr vz vy cA dftr2
      adantlbirmt cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi
      vz cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vy wal vz wal wameta
      pm3.26mt cA cpw wtr vz cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vz
      cv vy cv wcel vy cv cA wcel wa vz cv cA wcel wi vy wal vz wal simprrmt
      ac2hmt pm3.27dmt $.
      $( [8-Dec-2010] $)
  $}

  ${
    $d z y $.
    $( Proof of ~tr0 using the meta-implication
      and meta-conjunction connectives. $)
    tr0ALT $p |- Tr (/) $=
      vy cv c0 wcel wn vy wal vz cv vy cv wcel vy cv c0 wcel wa wn vy wal vz
      wal c0 wtr vy cv c0 wcel wn vy vy cv noel ax-gen vz cv vy cv wcel vy cv
      c0 wcel wa wn vy wal vz cv vy cv wcel vy cv c0 wcel wa vz cv c0 wcel wi
      vy wal vz wal c0 wtr vy cv c0 wcel wn vy wal vz vz cv vy cv wcel vy cv c0
      wcel wa vz cv c0 wcel wi vy wal vz wal c0 wtr vz cv vy cv wcel vy cv c0
      wcel wa wn vy wal vz wal vz cv vy cv wcel vy cv c0 wcel wa vz cv c0 wcel
      wi vy wal vz wal c0 wtr c0 wtr vz cv vy cv wcel vy cv c0 wcel wa vz cv c0
      wcel wi vy wal vz wal vz vy c0 dftr2 biimpri dfwimetair vz cv vy cv wcel
      vy cv c0 wcel wa wn vy wal vz cv vy cv wcel vy cv c0 wcel wa vz cv c0
      wcel wi vy wal vz vz cv vy cv wcel vy cv c0 wcel wa wn vz cv vy cv wcel
      vy cv c0 wcel wa vz cv c0 wcel wi vy vz cv vy cv wcel vy cv c0 wcel wa vz
      cv c0 wcel pm2.21 19.20i 19.20i ra vy cv c0 wcel wn vy wal vz ax-17 vy cv
      c0 wcel wn vz cv vy cv wcel vy cv c0 wcel wa wn vy vz cv vy cv wcel vy cv
      c0 wcel wa vy cv c0 wcel vz cv vy cv wcel vy cv c0 wcel pm3.27 con3i
      19.20i ra219.21ai axmpanmt $.
      $( [28-Nov-2010] $)
  $}

  ${
    sylALT.1 $e |- ( ph -> ps ) $.
    sylALT.2 $e |- ( ps -> ch ) $.
    $( Proof of ~syl using the meta-implication
      and meta-conjunction connectives. $)
    sylALT $p |- ( ph -> ch ) $=
      wph wps wch wph wps wps wch wph wps sylALT.1 dfwimetair sylALT.2 wph wps
      pm3.27mt ac1h pm3.27dmt $.
      $( [30-Nov-2010] $)
  $}

  ${
    impALT.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Proof of ~imp using the meta-implication
      and meta-conjunction connectives. $)
    impALT $p |- ( ( ph /\ ps ) -> ch ) $=
      wph wps wa wph wps wameta wch wph wps wa wph wps wameta wph wps wch wph
      wps wa wph wph wps wa wps wph wps wa wph wph wps pm3.26 dfwimetair wph
      wps pm3.27 wph wps wa wph pm3.26mt ac1h impALT.1 wph wps wa wph wps
      simprlmt wph wps wa wph wps simprrmt ac2h pm3.27dmt $.
      $( [30-Nov-2010] $)
  $}

  ${
    exALT.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Proof of ~ex using the meta-implication
      and meta-conjunction connectives. $)
    exALT $p |- ( ph -> ( ps -> ch ) )  $=
      wph wps wch wi wph wps wph wps wameta wph wps wa wameta wch wph wps
      wameta wph wps wameta wph wps wa wameta wph wps wa wch wph wps wameta wph
      wps wameta wph wps wph wps wa wph wps wameta wph wps wameta wph wps
      wameta id dfwimetair wph wps pm3.2 wph wps wameta wph wps simprlmt wph
      wps wameta wph wps simprrmt ac2h exALT.1 wph wps wameta wph wps wameta
      wph wps wa simprrmt ac1h pm3.27dexmt dfwimetai $.
      $( [30-Nov-2010] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Miscellaneous theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    snelpwi.1 $e |- A e. _V $.
    snelpwi.2 $e |- A e. B $.
    $( Inference form of ~ snelpw . $)
    snelpwi $p |- { A } e. ~P B $=
      cA cB wcel cA csn cB cpw wcel snelpwi.2 cA cB snelpwi.1 snelpw mpbi $.
      $( [31-Dec-2008] $) $( [30-Dec-2008] $)
  $}

  ${
    $d x A $. $d x B $. $d x C $.
    eluniii.1 $e |- A e. B $.
    eluniii.2 $e |- B e. C $.
    $( Inference form of ~ elunii . $)
    eluniii $p |- A e. U. C $=
      cA cB wcel cB cC wcel wa cA cC cuni wcel cA cB wcel cB cC wcel eluniii.1
      eluniii.2 pm3.2i cA cB cC elunii ax-mp $.
      $( [31-Dec-2008] $) $( [30-Dec-2008] $)
  $}

  ${
    ssunipwALTlem1.1 $e |- x e. A $.
    $( An element of a class is an element of the union of that class's power
       class $)
    ssunipwALTlem1 $p |- x e. U. ~P A $=
      vx cv vx cv csn cA cpw vx cv vx visset snid vx cv cA vx visset
      ssunipwALTlem1.1 snelpwi eluniii $.
      $( [31-Dec-2008] $) $( [30-Dec-2008] $)
  $}

  ${
    $d x A $.
    $( Every set is a subset of the union of its power set.  ` x ` and ` A `
       must be distinct because this is a requirement of ~ ssriv . $)
    ssunipwALT $p |- A C_ U. ~P A $=
      vx cA cA cpw cuni vx cv cA wcel vx cv cA cpw cuni wcel vx cv vx cv cA
      wcel cA vx cv csn cif cpw cuni wcel cA vx cv csn cA vx cv cA wcel cA vx
      cv csn cif wceq cA cpw vx cv cA wcel cA vx cv csn cif cpw wceq cA cpw
      cuni vx cv cA wcel cA vx cv csn cif cpw cuni wceq vx cv cA cpw cuni wcel
      vx cv vx cv cA wcel cA vx cv csn cif cpw cuni wcel wb cA vx cv cA wcel cA
      vx cv csn cif pweq cA cpw vx cv cA wcel cA vx cv csn cif cpw unieq cA cpw
      cuni vx cv cA wcel cA vx cv csn cif cpw cuni vx cv eleq2 3syl vx vx cv cA
      wcel cA vx cv csn cif vx cv cA wcel vx cv vx cv cA wcel cA vx cv csn cif
      wcel vx cv vx cv csn wcel cA vx cv csn cA vx cv cA wcel cA vx cv csn cif
      vx cv eleq2 vx cv csn vx cv cA wcel cA vx cv csn cif vx cv eleq2 vx cv vx
      visset snid elimhyp ssunipwALTlem1 dedth ssriv $.
      $( [31-Dec-2008] $) $( [30-Dec-2008] $)
  $}

  ${
    elsucii.1 $e |- A e. suc B $.
    $( Inference form of elsuci. $)
    elsucii $p |- ( A e. B \/ A = B ) $=
      cA cB csuc wcel cA cB wcel cA cB wceq wo elsucii.1 cA cB elsuci ax-mp $.
      $( [19-Apr-2009] $) $( [24-Dec-2008] $)
  $}

  ${
    jaoii.1 $e |- ( ph -> ps ) $.
    jaoii.2 $e |- ( ch -> ps ) $.
    jaoii.3 $e |- ( ph \/ ch ) $.
    $( Inference form of jaoi.. $)
    jaoii $p |- ps $=
      wph wch wo wps jaoii.3 wph wps wch jaoii.1 jaoii.2 jaoi ax-mp $.
      $( [19-Apr-2009] $) $( [24-Dec-2008] $)
  $}

  ${
    treli.1 $e |- Tr A $.
    treli.2 $e |- B e. C $.
    treli.3 $e |- C e. A $.
    $( Inference form of trel. $)
    treli $p |- B e. A $=
      cB cC wcel cC cA wcel wa cB cA wcel cB cC wcel cC cA wcel treli.2 treli.3
      pm3.2i cA wtr cB cC wcel cC cA wcel wa cB cA wcel wi treli.1 cA cB cC
      trel ax-mp ax-mp $.
      $( [19-Apr-2009] $) $( [24-Dec-2008] $)
  $}

  ${
    dt.1 $e |- ph $.
    dt.2 $e |- ps $.
    $( Pseudo Deduction Theorem. $)
    dt $p |- ( ph -> ps ) $=
      wps wph dt.2 a1i $.
      $( [19-Apr-2009] $) $( [24-Dec-2008] $)
  $}

  ${
    $d y A $. $d x A $. $d x y $.
    dftr2i.1 $e |- A. x A. y ( ( x e. y /\ y e. A ) -> x e. A ) $.
    $( Inference form of dftr2. $)
    dftr2i $p |- Tr A  $=
      cA wtr vx cv vy cv wcel vy cv cA wcel wa vx cv cA wcel wi vy wal vx wal
      dftr2i.1 vx vy cA dftr2 mpbir $.
      $( [19-Apr-2009] $) $( [24-Dec-2008] $)
  $}

  ${
    $d z A $. $d y A $. $d z y $.
    suctr.1 $e |- Tr A $.
    suctr.2 $e |- ( z e. y /\ y e. suc A ) $.
    suctr.3 $e |- y e. A $.
    suctr.4 $e |- y = A $.
    $( The successor of a transitive class is transitive.  Below is the
       original proof in the actual sequence constructed.  Compare the direct
       proof, ~ suctr .
       <PRE>
        Permitted Assumptions    Hyp       Ref      Expression

    1                            2,3       ~ dt       ( Tr A -> Tr suc A )
    2   suctr.1                            suctr.1  Tr A
    3   suctr.1                  4         ~ dftr2i   Tr suc A
    4   suctr.1                  5         ~ gen2     A. z A. y ( ( z e. y /\
                                                   y e. suc A ) -> z e. suc A )
    5   suctr.1                  6,7       ~ dt      ( ( z e. y /\ y e. suc A )
                                                    -> z e. suc A )
    6   suctr.1,suctr.2                    suctr.2  ( z e. y /\ y e. suc A )
    7   suctr.1,suctr.2          10,16,9   ~ jaoii    z e. suc A
    8   suctr.1,suctr.2          6         ~ pm3.27i  y e. suc A
    9   suctr.1,suctr.2          8         ~ elsucii  ( y e. A \/ y = A )
    10  suctr.1,suctr.2          11,12     ~ dt       ( y e. A -> z e. suc A )
    11  suctr.1,suctr.2,suctr.3            suctr.3  y e. A
    12  suctr.1,suctr.2,suctr.3  15,14     ~ sselii   z e. suc A
    13  suctr.1,suctr.2,suctr.3  6         ~ pm3.26i  z e. y
    14  suctr.1,suctr.2,suctr.3  2,13,11   ~ treli    z e. A
    15  suctr.1,suctr.2,suctr.3            ~ sssucid  A C_ suc A
    16  suctr.1,suctr.2          17,18     ~ dt       ( y = A -> z e. suc A )
    17  suctr.1,suctr.2,suctr.4            suctr.4  y = A
    18  suctr.1,suctr.2,suctr.4  21,20     ~ sselii   z e. suc A
    19  suctr.1,suctr.2,suctr.4  6         ~ pm3.26i  z e. y
    20  suctr.1,suctr.2,suctr.4  19,17     ~ eleqtri  z e. A
    21  suctr.1,suctr.2,suctr.4            ~ sssucid  A C_ suc A
       </PRE> $)
    suctrALT $p |- ( Tr A -> Tr suc A ) $=
      cA wtr cA csuc wtr suctr.1 vz vy cA csuc vz cv vy cv wcel vy cv cA csuc
      wcel wa vz cv cA csuc wcel wi vz vy vz cv vy cv wcel vy cv cA csuc wcel
      wa vz cv cA csuc wcel suctr.2 vy cv cA wcel vz cv cA csuc wcel vy cv cA
      wceq vy cv cA wcel vz cv cA csuc wcel suctr.3 cA cA csuc vz cv cA sssucid
      cA vz cv vy cv suctr.1 vz cv vy cv wcel vy cv cA csuc wcel suctr.2
      pm3.26i suctr.3 treli sselii dt vy cv cA wceq vz cv cA csuc wcel suctr.4
      cA cA csuc vz cv cA sssucid vz cv vy cv cA vz cv vy cv wcel vy cv cA csuc
      wcel suctr.2 pm3.26i suctr.4 eleqtri sselii dt vy cv cA vz cv vy cv wcel
      vy cv cA csuc wcel suctr.2 pm3.27i elsucii jaoii dt gen2 dftr2i dt $.
      $( [19-Apr-2009] $) $( [24-Dec-2008] $)
  $}

  ${
    sbf3.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution has no effect on a bound variable. $)
    sbf3 $p |- ( [ y / x ] A. y ph <-> A. y ph ) $=
      wph vy wal vx vy wph vy wal wph vx wal vy wal wph vy wal vx wal wph wph
      vx wal wi vy wal wph vy wal wph vx wal vy wal wi wph wph vx wal wi vy
      sbf3.1 ax-gen wph wph vx wal vy 19.20 ax-mp wph vy vx ax-7 syl sbf $.
      $( [15-Feb-2010] $)
  $}

  ${
    sbf5.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution has no effect on a bound variable. $)
    sbf5 $p |- ( [ y / x ] E. y ph <-> E. y ph ) $=
      wph vy wex vx vy wph vx vy sbf5.1 hbex sbf $.
      $( [15-Feb-2010] $)
  $}

  ${
    $( Substitution has no effect on a bound variable. $)
    sbf4 $p |- ( [ y / x ] E. x ph <-> E. x ph ) $=
      wph vx wex vx vy wph vx hbe1 sbf $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x y $.
    subdefbi1.1 $e |- ( E. x ( x = y /\ ph ) <-> ps ) $.
    $( Apply the definition of substitution to a biconditional. $)
    subdefbi1 $p |- ( [ y / x ] ph <-> ps ) $=
      wph vx vy cv wsbc vx cv vy cv wceq wph wa vx wex wps wph vx vy sb5
      subdefbi1.1 bitri $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x z $. $d x y $.
    $( Lemma for ~ elsb3ALT . $)
    elsb3ALTlem $p |- ( E. x ( x = y /\ x e. z ) <-> y e. z ) $=
      vx cv vz cv wcel vy cv vz cv wcel vx vy vy cv vz cv wcel vx ax-17 vx vy
      vz elequ1 equsex $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x z $. $d x y $.
    $(  Lemma for ~ elsb4ALT . $)
    elsb4ALTlem $p |- ( E. x ( x = y /\ z e. x ) <-> z e. y ) $=
      vz cv vx cv wcel vz cv vy cv wcel vx vy vz cv vy cv wcel vx ax-17 vx vy
      vz elequ2 equsex $.
      $( [15-Feb-2010] $)
  $}

  ${
    $( If two sets are equal they are not ordinary. $)
    elequ3 $p |- ( x = y -> ( x e. x <-> y e. y ) ) $=
      vx cv vy cv wceq vx cv vx cv wcel vy cv vx cv wcel wb vy cv vx cv wcel vy
      cv vy cv wcel wb wa vx cv vx cv wcel vy cv vy cv wcel wb vx cv vy cv wceq
      vx cv vx cv wcel vy cv vx cv wcel wb vy cv vx cv wcel vy cv vy cv wcel wb
      vx vy vx elequ1 vx vy vy elequ2 jca vx cv vx cv wcel vy cv vx cv wcel vy
      cv vy cv wcel bitr syl $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x y $.
    $( Lemma for ~ elsb2 . $)
    elsb2lem $p |- ( E. x ( x = y /\ x e. x ) <-> y e. y ) $=
      vx cv vx cv wcel vy cv vy cv wcel vx vy vy cv vy cv wcel vx ax-17 vx vy
      elequ3 equsex $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x z $.  $d x y $.
    $( Substituion applied to an atomic membership wff.  ~ elsb3ALT is
       ~ elsb3 with the additional distinct variable requirement that ` x `
       and ` y ` are distinct, but with a shorter proof. $)
    elsb3ALT $p |- ( [ y / x ] x e. z <-> y e. z ) $=
      vx cv vz cv wcel vy cv vz cv wcel vx vy vx vy vz elsb3ALTlem subdefbi1 $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x z $.  $d x y $.
    $( Substitution applied to an atomic membership wff.  ~ elsb4ALT is
       ~ elsb4 with the additional distinct variable requirement that ` x `
       and ` y ` are distinct, but with a shorter proof. $)
    elsb4ALT $p |- ( [ y / x ] z e. x <-> z e. y ) $=
      vz cv vx cv wcel vz cv vy cv wcel vx vy vx vy vz elsb4ALTlem subdefbi1 $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x y $.
    $( Substitution applied to the atomic membership wff that a set contains
       itself.  This wff is false by the axiom of regularity. $)
    elsb2 $p |- ( [ y / x ] x e. x <-> y e. y ) $=
      vx cv vx cv wcel vy cv vy cv wcel vx vy vx vy elsb2lem subdefbi1 $.
      $( [15-Feb-2010] $)
  $}

  ${
    $d x z $. $d x w $.
    $( Substitution applied to an atomic membership wff in which ` x ` doesn't
       occur. $)
    elsb1 $p |- ( [ y / x ] z e. w <-> z e. w ) $=
      vz cv vw cv wcel vx vy vz cv vw cv wcel vx ax-17 sbf $.
      $( [15-Feb-2010] $)
  $}

$( (End of Alan Sare's mathbox.) $)
